var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __spreadProps = (a, b2) => __defProps(a, __getOwnPropDescs(b2));
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import * as React from "react";
import React__default, { useState, useMemo as useMemo$1, useRef, useEffect, createContext, useLayoutEffect as useLayoutEffect$1, useContext, forwardRef, useImperativeHandle, useCallback, Component } from "react";
var __read$2 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useToggle(defaultValue, reverseValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$2(useState(defaultValue), 2), state = _a2[0], setState2 = _a2[1];
  var actions2 = useMemo$1(function() {
    var reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    var toggle = function toggle2() {
      return setState2(function(s) {
        return s === defaultValue ? reverseValueOrigin : defaultValue;
      });
    };
    var set2 = function set3(value) {
      return setState2(value);
    };
    var setLeft = function setLeft2() {
      return setState2(defaultValue);
    };
    var setRight = function setRight2() {
      return setState2(reverseValueOrigin);
    };
    return {
      toggle,
      set: set2,
      setLeft,
      setRight
    };
  }, []);
  return [state, actions2];
}
var __read$1 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$1(useToggle(defaultValue), 2), state = _a2[0], _b2 = _a2[1], toggle = _b2.toggle, _set = _b2.set;
  var actions2 = useMemo$1(function() {
    var setTrue = function setTrue2() {
      return _set(true);
    };
    var setFalse = function setFalse2() {
      return _set(false);
    };
    return {
      toggle,
      set: function set2(v4) {
        return _set(!!v4);
      },
      setTrue,
      setFalse
    };
  }, []);
  return [state, actions2];
}
function useLatest(value) {
  var ref2 = useRef(value);
  ref2.current = value;
  return ref2;
}
var isBrowser$1 = !!(typeof window !== "undefined" && window.document && window.document.createElement);
var isBrowser$2 = isBrowser$1;
function getTargetElement(target, defaultElement) {
  if (!isBrowser$2) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  var targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if ("current" in target) {
    targetElement = target.current;
  } else {
    targetElement = target;
  }
  return targetElement;
}
var useUnmount = function useUnmount2(fn) {
  var fnRef = useLatest(fn);
  useEffect(function() {
    return function() {
      fnRef.current();
    };
  }, []);
};
var useUnmount$1 = useUnmount;
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (var i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
var createEffectWithTarget = function createEffectWithTarget2(useEffectType) {
  var useEffectWithTarget2 = function useEffectWithTarget3(effect, deps, target) {
    var hasInitRef = useRef(false);
    var lastElementRef = useRef([]);
    var lastDepsRef = useRef([]);
    var unLoadRef = useRef();
    useEffectType(function() {
      var _a2;
      var targets = Array.isArray(target) ? target : [target];
      var els = targets.map(function(item) {
        return getTargetElement(item);
      });
      if (!hasInitRef.current) {
        hasInitRef.current = true;
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
        return;
      }
      if (els.length !== lastElementRef.current.length || !depsAreSame(els, lastElementRef.current) || !depsAreSame(deps, lastDepsRef.current)) {
        (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
      }
    });
    useUnmount$1(function() {
      var _a2;
      (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
      hasInitRef.current = false;
    });
  };
  return useEffectWithTarget2;
};
var createEffectWithTarget$1 = createEffectWithTarget;
var useEffectWithTarget = createEffectWithTarget$1(useEffect);
var useEffectWithTarget$1 = useEffectWithTarget;
function useMemoizedFn(fn) {
  var fnRef = useRef(fn);
  fnRef.current = useMemo$1(function() {
    return fn;
  }, [fn]);
  var memoizedFn = useRef();
  if (!memoizedFn.current) {
    memoizedFn.current = function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return fnRef.current.apply(this, args);
    };
  }
  return memoizedFn.current;
}
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function useCreation(factory, deps) {
  var current2 = useRef({
    deps,
    obj: void 0,
    initialized: false
  }).current;
  if (current2.initialized === false || !depsAreSame(current2.deps, deps)) {
    current2.deps = deps;
    current2.obj = factory();
    current2.initialized = true;
  }
  return current2.obj;
}
function isObject$9(value) {
  var type4 = typeof value;
  return value != null && (type4 == "object" || type4 == "function");
}
var isObject_1 = isObject$9;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$8 = freeGlobal || freeSelf || Function("return this")();
var _root = root$8;
var root$7 = _root;
var Symbol$5 = root$7.Symbol;
var _Symbol = Symbol$5;
var Symbol$4 = _Symbol;
var objectProto$b = Object.prototype;
var hasOwnProperty$c = objectProto$b.hasOwnProperty;
var nativeObjectToString$1 = objectProto$b.toString;
var symToStringTag$1 = Symbol$4 ? Symbol$4.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$c.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e2) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto$a = Object.prototype;
var nativeObjectToString = objectProto$a.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$3 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$3 ? Symbol$3.toStringTag : void 0;
function baseGetTag$4(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$4;
function isObjectLike$4(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$4;
var createUpdateEffect = function createUpdateEffect2(hook) {
  return function(effect, deps) {
    var isMounted = useRef(false);
    hook(function() {
      return function() {
        isMounted.current = false;
      };
    }, []);
    hook(function() {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};
var useUpdateEffect = createUpdateEffect(useEffect);
function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}
var _listCacheClear = listCacheClear$1;
function eq$2(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_1 = eq$2;
var eq$1 = eq_1;
function assocIndexOf$4(array4, key) {
  var length = array4.length;
  while (length--) {
    if (eq$1(array4[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var _assocIndexOf = assocIndexOf$4;
var assocIndexOf$3 = _assocIndexOf;
var arrayProto$1 = Array.prototype;
var splice = arrayProto$1.splice;
function listCacheDelete$1(key) {
  var data2 = this.__data__, index2 = assocIndexOf$3(data2, key);
  if (index2 < 0) {
    return false;
  }
  var lastIndex = data2.length - 1;
  if (index2 == lastIndex) {
    data2.pop();
  } else {
    splice.call(data2, index2, 1);
  }
  --this.size;
  return true;
}
var _listCacheDelete = listCacheDelete$1;
var assocIndexOf$2 = _assocIndexOf;
function listCacheGet$2(key) {
  var data2 = this.__data__, index2 = assocIndexOf$2(data2, key);
  return index2 < 0 ? void 0 : data2[index2][1];
}
var _listCacheGet = listCacheGet$2;
var assocIndexOf$1 = _assocIndexOf;
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}
var _listCacheHas = listCacheHas$1;
var assocIndexOf = _assocIndexOf;
function listCacheSet$2(key, value) {
  var data2 = this.__data__, index2 = assocIndexOf(data2, key);
  if (index2 < 0) {
    ++this.size;
    data2.push([key, value]);
  } else {
    data2[index2][1] = value;
  }
  return this;
}
var _listCacheSet = listCacheSet$2;
var listCacheClear = _listCacheClear, listCacheDelete = _listCacheDelete, listCacheGet$1 = _listCacheGet, listCacheHas = _listCacheHas, listCacheSet$1 = _listCacheSet;
function ListCache$4(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
ListCache$4.prototype.clear = listCacheClear;
ListCache$4.prototype["delete"] = listCacheDelete;
ListCache$4.prototype.get = listCacheGet$1;
ListCache$4.prototype.has = listCacheHas;
ListCache$4.prototype.set = listCacheSet$1;
var _ListCache = ListCache$4;
var ListCache$3 = _ListCache;
function stackClear$1() {
  this.__data__ = new ListCache$3();
  this.size = 0;
}
var _stackClear = stackClear$1;
function stackDelete$1(key) {
  var data2 = this.__data__, result = data2["delete"](key);
  this.size = data2.size;
  return result;
}
var _stackDelete = stackDelete$1;
function stackGet$1(key) {
  return this.__data__.get(key);
}
var _stackGet = stackGet$1;
function stackHas$1(key) {
  return this.__data__.has(key);
}
var _stackHas = stackHas$1;
var baseGetTag$3 = _baseGetTag, isObject$8 = isObject_1;
var asyncTag = "[object AsyncFunction]", funcTag$1 = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction$5(value) {
  if (!isObject$8(value)) {
    return false;
  }
  var tag = baseGetTag$3(value);
  return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_1 = isFunction$5;
var root$6 = _root;
var coreJsData$1 = root$6["__core-js_shared__"];
var _coreJsData = coreJsData$1;
var coreJsData = _coreJsData;
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked$1(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var _isMasked = isMasked$1;
var funcProto$1 = Function.prototype;
var funcToString$1 = funcProto$1.toString;
function toSource$2(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e2) {
    }
    try {
      return func + "";
    } catch (e2) {
    }
  }
  return "";
}
var _toSource = toSource$2;
var isFunction$4 = isFunction_1, isMasked = _isMasked, isObject$7 = isObject_1, toSource$1 = _toSource;
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto$9 = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty$b = objectProto$9.hasOwnProperty;
var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$b).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative$1(value) {
  if (!isObject$7(value) || isMasked(value)) {
    return false;
  }
  var pattern4 = isFunction$4(value) ? reIsNative : reIsHostCtor;
  return pattern4.test(toSource$1(value));
}
var _baseIsNative = baseIsNative$1;
function getValue$4(object4, key) {
  return object4 == null ? void 0 : object4[key];
}
var _getValue = getValue$4;
var baseIsNative = _baseIsNative, getValue$3 = _getValue;
function getNative$6(object4, key) {
  var value = getValue$3(object4, key);
  return baseIsNative(value) ? value : void 0;
}
var _getNative = getNative$6;
var getNative$5 = _getNative, root$5 = _root;
var Map$4 = getNative$5(root$5, "Map");
var _Map = Map$4;
var getNative$4 = _getNative;
var nativeCreate$4 = getNative$4(Object, "create");
var _nativeCreate = nativeCreate$4;
var nativeCreate$3 = _nativeCreate;
function hashClear$1() {
  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
  this.size = 0;
}
var _hashClear = hashClear$1;
function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var _hashDelete = hashDelete$1;
var nativeCreate$2 = _nativeCreate;
var HASH_UNDEFINED$2 = "__lodash_hash_undefined__";
var objectProto$8 = Object.prototype;
var hasOwnProperty$a = objectProto$8.hasOwnProperty;
function hashGet$1(key) {
  var data2 = this.__data__;
  if (nativeCreate$2) {
    var result = data2[key];
    return result === HASH_UNDEFINED$2 ? void 0 : result;
  }
  return hasOwnProperty$a.call(data2, key) ? data2[key] : void 0;
}
var _hashGet = hashGet$1;
var nativeCreate$1 = _nativeCreate;
var objectProto$7 = Object.prototype;
var hasOwnProperty$9 = objectProto$7.hasOwnProperty;
function hashHas$1(key) {
  var data2 = this.__data__;
  return nativeCreate$1 ? data2[key] !== void 0 : hasOwnProperty$9.call(data2, key);
}
var _hashHas = hashHas$1;
var nativeCreate = _nativeCreate;
var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
function hashSet$1(key, value) {
  var data2 = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data2[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED$1 : value;
  return this;
}
var _hashSet = hashSet$1;
var hashClear = _hashClear, hashDelete = _hashDelete, hashGet = _hashGet, hashHas = _hashHas, hashSet = _hashSet;
function Hash$1(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
Hash$1.prototype.clear = hashClear;
Hash$1.prototype["delete"] = hashDelete;
Hash$1.prototype.get = hashGet;
Hash$1.prototype.has = hashHas;
Hash$1.prototype.set = hashSet;
var _Hash = Hash$1;
var Hash = _Hash, ListCache$2 = _ListCache, Map$3 = _Map;
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$3 || ListCache$2)(),
    "string": new Hash()
  };
}
var _mapCacheClear = mapCacheClear$1;
function isKeyable$1(value) {
  var type4 = typeof value;
  return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
}
var _isKeyable = isKeyable$1;
var isKeyable = _isKeyable;
function getMapData$4(map2, key) {
  var data2 = map2.__data__;
  return isKeyable(key) ? data2[typeof key == "string" ? "string" : "hash"] : data2.map;
}
var _getMapData = getMapData$4;
var getMapData$3 = _getMapData;
function mapCacheDelete$1(key) {
  var result = getMapData$3(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var _mapCacheDelete = mapCacheDelete$1;
var getMapData$2 = _getMapData;
function mapCacheGet$1(key) {
  return getMapData$2(this, key).get(key);
}
var _mapCacheGet = mapCacheGet$1;
var getMapData$1 = _getMapData;
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}
var _mapCacheHas = mapCacheHas$1;
var getMapData = _getMapData;
function mapCacheSet$1(key, value) {
  var data2 = getMapData(this, key), size = data2.size;
  data2.set(key, value);
  this.size += data2.size == size ? 0 : 1;
  return this;
}
var _mapCacheSet = mapCacheSet$1;
var mapCacheClear = _mapCacheClear, mapCacheDelete = _mapCacheDelete, mapCacheGet = _mapCacheGet, mapCacheHas = _mapCacheHas, mapCacheSet = _mapCacheSet;
function MapCache$2(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
MapCache$2.prototype.clear = mapCacheClear;
MapCache$2.prototype["delete"] = mapCacheDelete;
MapCache$2.prototype.get = mapCacheGet;
MapCache$2.prototype.has = mapCacheHas;
MapCache$2.prototype.set = mapCacheSet;
var _MapCache = MapCache$2;
var ListCache$1 = _ListCache, Map$2 = _Map, MapCache$1 = _MapCache;
var LARGE_ARRAY_SIZE = 200;
function stackSet$1(key, value) {
  var data2 = this.__data__;
  if (data2 instanceof ListCache$1) {
    var pairs = data2.__data__;
    if (!Map$2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
      pairs.push([key, value]);
      this.size = ++data2.size;
      return this;
    }
    data2 = this.__data__ = new MapCache$1(pairs);
  }
  data2.set(key, value);
  this.size = data2.size;
  return this;
}
var _stackSet = stackSet$1;
var ListCache = _ListCache, stackClear = _stackClear, stackDelete = _stackDelete, stackGet = _stackGet, stackHas = _stackHas, stackSet = _stackSet;
function Stack$1(entries) {
  var data2 = this.__data__ = new ListCache(entries);
  this.size = data2.size;
}
Stack$1.prototype.clear = stackClear;
Stack$1.prototype["delete"] = stackDelete;
Stack$1.prototype.get = stackGet;
Stack$1.prototype.has = stackHas;
Stack$1.prototype.set = stackSet;
var _Stack = Stack$1;
var HASH_UNDEFINED = "__lodash_hash_undefined__";
function setCacheAdd$1(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}
var _setCacheAdd = setCacheAdd$1;
function setCacheHas$1(value) {
  return this.__data__.has(value);
}
var _setCacheHas = setCacheHas$1;
var MapCache = _MapCache, setCacheAdd = _setCacheAdd, setCacheHas = _setCacheHas;
function SetCache$1(values) {
  var index2 = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache();
  while (++index2 < length) {
    this.add(values[index2]);
  }
}
SetCache$1.prototype.add = SetCache$1.prototype.push = setCacheAdd;
SetCache$1.prototype.has = setCacheHas;
var _SetCache = SetCache$1;
function arraySome$1(array4, predicate) {
  var index2 = -1, length = array4 == null ? 0 : array4.length;
  while (++index2 < length) {
    if (predicate(array4[index2], index2, array4)) {
      return true;
    }
  }
  return false;
}
var _arraySome = arraySome$1;
function cacheHas$1(cache, key) {
  return cache.has(key);
}
var _cacheHas = cacheHas$1;
var SetCache = _SetCache, arraySome = _arraySome, cacheHas = _cacheHas;
var COMPARE_PARTIAL_FLAG$3 = 1, COMPARE_UNORDERED_FLAG$1 = 2;
function equalArrays$2(array4, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3, arrLength = array4.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array4);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array4;
  }
  var index2 = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG$1 ? new SetCache() : void 0;
  stack.set(array4, other);
  stack.set(other, array4);
  while (++index2 < arrLength) {
    var arrValue = array4[index2], othValue = other[index2];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome(other, function(othValue2, othIndex) {
        if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array4);
  stack["delete"](other);
  return result;
}
var _equalArrays = equalArrays$2;
var root$4 = _root;
var Uint8Array$2 = root$4.Uint8Array;
var _Uint8Array = Uint8Array$2;
function mapToArray$1(map2) {
  var index2 = -1, result = Array(map2.size);
  map2.forEach(function(value, key) {
    result[++index2] = [key, value];
  });
  return result;
}
var _mapToArray = mapToArray$1;
function setToArray$1(set2) {
  var index2 = -1, result = Array(set2.size);
  set2.forEach(function(value) {
    result[++index2] = value;
  });
  return result;
}
var _setToArray = setToArray$1;
var Symbol$2 = _Symbol, Uint8Array$1 = _Uint8Array, eq = eq_1, equalArrays$1 = _equalArrays, mapToArray = _mapToArray, setToArray = _setToArray;
var COMPARE_PARTIAL_FLAG$2 = 1, COMPARE_UNORDERED_FLAG = 2;
var boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", errorTag$1 = "[object Error]", mapTag$2 = "[object Map]", numberTag$1 = "[object Number]", regexpTag$1 = "[object RegExp]", setTag$2 = "[object Set]", stringTag$1 = "[object String]", symbolTag = "[object Symbol]";
var arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$2 = "[object DataView]";
var symbolProto = Symbol$2 ? Symbol$2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
function equalByTag$1(object4, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag$2:
      if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
        return false;
      }
      object4 = object4.buffer;
      other = other.buffer;
    case arrayBufferTag$1:
      if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array$1(object4), new Uint8Array$1(other))) {
        return false;
      }
      return true;
    case boolTag$1:
    case dateTag$1:
    case numberTag$1:
      return eq(+object4, +other);
    case errorTag$1:
      return object4.name == other.name && object4.message == other.message;
    case regexpTag$1:
    case stringTag$1:
      return object4 == other + "";
    case mapTag$2:
      var convert = mapToArray;
    case setTag$2:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2;
      convert || (convert = setToArray);
      if (object4.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object4);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;
      stack.set(object4, other);
      var result = equalArrays$1(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object4);
      return result;
    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object4) == symbolValueOf.call(other);
      }
  }
  return false;
}
var _equalByTag = equalByTag$1;
function arrayPush$1(array4, values) {
  var index2 = -1, length = values.length, offset3 = array4.length;
  while (++index2 < length) {
    array4[offset3 + index2] = values[index2];
  }
  return array4;
}
var _arrayPush = arrayPush$1;
var isArray$6 = Array.isArray;
var isArray_1 = isArray$6;
var arrayPush = _arrayPush, isArray$5 = isArray_1;
function baseGetAllKeys$1(object4, keysFunc, symbolsFunc) {
  var result = keysFunc(object4);
  return isArray$5(object4) ? result : arrayPush(result, symbolsFunc(object4));
}
var _baseGetAllKeys = baseGetAllKeys$1;
function arrayFilter$1(array4, predicate) {
  var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
  while (++index2 < length) {
    var value = array4[index2];
    if (predicate(value, index2, array4)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var _arrayFilter = arrayFilter$1;
function stubArray$1() {
  return [];
}
var stubArray_1 = stubArray$1;
var arrayFilter = _arrayFilter, stubArray = stubArray_1;
var objectProto$6 = Object.prototype;
var propertyIsEnumerable$1 = objectProto$6.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols$1 = !nativeGetSymbols ? stubArray : function(object4) {
  if (object4 == null) {
    return [];
  }
  object4 = Object(object4);
  return arrayFilter(nativeGetSymbols(object4), function(symbol) {
    return propertyIsEnumerable$1.call(object4, symbol);
  });
};
var _getSymbols = getSymbols$1;
function baseTimes$1(n2, iteratee) {
  var index2 = -1, result = Array(n2);
  while (++index2 < n2) {
    result[index2] = iteratee(index2);
  }
  return result;
}
var _baseTimes = baseTimes$1;
var baseGetTag$2 = _baseGetTag, isObjectLike$3 = isObjectLike_1;
var argsTag$2 = "[object Arguments]";
function baseIsArguments$1(value) {
  return isObjectLike$3(value) && baseGetTag$2(value) == argsTag$2;
}
var _baseIsArguments = baseIsArguments$1;
var baseIsArguments = _baseIsArguments, isObjectLike$2 = isObjectLike_1;
var objectProto$5 = Object.prototype;
var hasOwnProperty$8 = objectProto$5.hasOwnProperty;
var propertyIsEnumerable = objectProto$5.propertyIsEnumerable;
var isArguments$1 = baseIsArguments(function() {
  return arguments;
}()) ? baseIsArguments : function(value) {
  return isObjectLike$2(value) && hasOwnProperty$8.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
};
var isArguments_1 = isArguments$1;
var isBuffer$2 = { exports: {} };
function stubFalse() {
  return false;
}
var stubFalse_1 = stubFalse;
(function(module, exports) {
  var root2 = _root, stubFalse2 = stubFalse_1;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var Buffer2 = moduleExports ? root2.Buffer : void 0;
  var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
  var isBuffer2 = nativeIsBuffer || stubFalse2;
  module.exports = isBuffer2;
})(isBuffer$2, isBuffer$2.exports);
var MAX_SAFE_INTEGER$2 = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex$1(value, length) {
  var type4 = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$2 : length;
  return !!length && (type4 == "number" || type4 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var _isIndex = isIndex$1;
var MAX_SAFE_INTEGER$1 = 9007199254740991;
function isLength$2(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
}
var isLength_1 = isLength$2;
var baseGetTag$1 = _baseGetTag, isLength$1 = isLength_1, isObjectLike$1 = isObjectLike_1;
var argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", mapTag$1 = "[object Map]", numberTag = "[object Number]", objectTag$2 = "[object Object]", regexpTag = "[object RegExp]", setTag$1 = "[object Set]", stringTag = "[object String]", weakMapTag$1 = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]", dataViewTag$1 = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag$1] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag$1] = typedArrayTags[numberTag] = typedArrayTags[objectTag$2] = typedArrayTags[regexpTag] = typedArrayTags[setTag$1] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag$1] = false;
function baseIsTypedArray$1(value) {
  return isObjectLike$1(value) && isLength$1(value.length) && !!typedArrayTags[baseGetTag$1(value)];
}
var _baseIsTypedArray = baseIsTypedArray$1;
function baseUnary$1(func) {
  return function(value) {
    return func(value);
  };
}
var _baseUnary = baseUnary$1;
var _nodeUtil = { exports: {} };
(function(module, exports) {
  var freeGlobal2 = _freeGlobal;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var freeProcess = moduleExports && freeGlobal2.process;
  var nodeUtil2 = function() {
    try {
      var types2 = freeModule && freeModule.require && freeModule.require("util").types;
      if (types2) {
        return types2;
      }
      return freeProcess && freeProcess.binding && freeProcess.binding("util");
    } catch (e2) {
    }
  }();
  module.exports = nodeUtil2;
})(_nodeUtil, _nodeUtil.exports);
var baseIsTypedArray = _baseIsTypedArray, baseUnary = _baseUnary, nodeUtil = _nodeUtil.exports;
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
var isTypedArray$3 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
var isTypedArray_1 = isTypedArray$3;
var baseTimes = _baseTimes, isArguments = isArguments_1, isArray$4 = isArray_1, isBuffer$1 = isBuffer$2.exports, isIndex = _isIndex, isTypedArray$2 = isTypedArray_1;
var objectProto$4 = Object.prototype;
var hasOwnProperty$7 = objectProto$4.hasOwnProperty;
function arrayLikeKeys$1(value, inherited) {
  var isArr = isArray$4(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$2(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$7.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var _arrayLikeKeys = arrayLikeKeys$1;
var objectProto$3 = Object.prototype;
function isPrototype$1(value) {
  var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto$3;
  return value === proto2;
}
var _isPrototype = isPrototype$1;
function overArg$1(func, transform2) {
  return function(arg) {
    return func(transform2(arg));
  };
}
var _overArg = overArg$1;
var overArg = _overArg;
var nativeKeys$1 = overArg(Object.keys, Object);
var _nativeKeys = nativeKeys$1;
var isPrototype = _isPrototype, nativeKeys = _nativeKeys;
var objectProto$2 = Object.prototype;
var hasOwnProperty$6 = objectProto$2.hasOwnProperty;
function baseKeys$1(object4) {
  if (!isPrototype(object4)) {
    return nativeKeys(object4);
  }
  var result = [];
  for (var key in Object(object4)) {
    if (hasOwnProperty$6.call(object4, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var _baseKeys = baseKeys$1;
var isFunction$3 = isFunction_1, isLength = isLength_1;
function isArrayLike$2(value) {
  return value != null && isLength(value.length) && !isFunction$3(value);
}
var isArrayLike_1 = isArrayLike$2;
var arrayLikeKeys = _arrayLikeKeys, baseKeys = _baseKeys, isArrayLike$1 = isArrayLike_1;
function keys$2(object4) {
  return isArrayLike$1(object4) ? arrayLikeKeys(object4) : baseKeys(object4);
}
var keys_1 = keys$2;
var baseGetAllKeys = _baseGetAllKeys, getSymbols = _getSymbols, keys$1 = keys_1;
function getAllKeys$1(object4) {
  return baseGetAllKeys(object4, keys$1, getSymbols);
}
var _getAllKeys = getAllKeys$1;
var getAllKeys = _getAllKeys;
var COMPARE_PARTIAL_FLAG$1 = 1;
var objectProto$1 = Object.prototype;
var hasOwnProperty$5 = objectProto$1.hasOwnProperty;
function equalObjects$1(object4, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1, objProps = getAllKeys(object4), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index2 = objLength;
  while (index2--) {
    var key = objProps[index2];
    if (!(isPartial ? key in other : hasOwnProperty$5.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object4);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object4;
  }
  var result = true;
  stack.set(object4, other);
  stack.set(other, object4);
  var skipCtor = isPartial;
  while (++index2 < objLength) {
    key = objProps[index2];
    var objValue = object4[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object4.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object4);
  stack["delete"](other);
  return result;
}
var _equalObjects = equalObjects$1;
var getNative$3 = _getNative, root$3 = _root;
var DataView$4 = getNative$3(root$3, "DataView");
var _DataView = DataView$4;
var getNative$2 = _getNative, root$2 = _root;
var Promise$2 = getNative$2(root$2, "Promise");
var _Promise = Promise$2;
var getNative$1 = _getNative, root$1 = _root;
var Set$2 = getNative$1(root$1, "Set");
var _Set = Set$2;
var getNative = _getNative, root = _root;
var WeakMap$4 = getNative(root, "WeakMap");
var _WeakMap = WeakMap$4;
var DataView$3 = _DataView, Map$1 = _Map, Promise$1 = _Promise, Set$1 = _Set, WeakMap$3 = _WeakMap, baseGetTag = _baseGetTag, toSource = _toSource;
var mapTag = "[object Map]", objectTag$1 = "[object Object]", promiseTag = "[object Promise]", setTag = "[object Set]", weakMapTag = "[object WeakMap]";
var dataViewTag = "[object DataView]";
var dataViewCtorString = toSource(DataView$3), mapCtorString = toSource(Map$1), promiseCtorString = toSource(Promise$1), setCtorString = toSource(Set$1), weakMapCtorString = toSource(WeakMap$3);
var getTag$1 = baseGetTag;
if (DataView$3 && getTag$1(new DataView$3(new ArrayBuffer(1))) != dataViewTag || Map$1 && getTag$1(new Map$1()) != mapTag || Promise$1 && getTag$1(Promise$1.resolve()) != promiseTag || Set$1 && getTag$1(new Set$1()) != setTag || WeakMap$3 && getTag$1(new WeakMap$3()) != weakMapTag) {
  getTag$1 = function(value) {
    var result = baseGetTag(value), Ctor = result == objectTag$1 ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag;
        case mapCtorString:
          return mapTag;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag;
        case weakMapCtorString:
          return weakMapTag;
      }
    }
    return result;
  };
}
var _getTag = getTag$1;
var Stack = _Stack, equalArrays = _equalArrays, equalByTag = _equalByTag, equalObjects = _equalObjects, getTag = _getTag, isArray$3 = isArray_1, isBuffer = isBuffer$2.exports, isTypedArray$1 = isTypedArray_1;
var COMPARE_PARTIAL_FLAG = 1;
var argsTag = "[object Arguments]", arrayTag = "[object Array]", objectTag = "[object Object]";
var objectProto = Object.prototype;
var hasOwnProperty$4 = objectProto.hasOwnProperty;
function baseIsEqualDeep$1(object4, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$3(object4), othIsArr = isArray$3(other), objTag = objIsArr ? arrayTag : getTag(object4), othTag = othIsArr ? arrayTag : getTag(other);
  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;
  var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer(object4)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack());
    return objIsArr || isTypedArray$1(object4) ? equalArrays(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag(object4, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty$4.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty$4.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack());
  return equalObjects(object4, other, bitmask, customizer, equalFunc, stack);
}
var _baseIsEqualDeep = baseIsEqualDeep$1;
var baseIsEqualDeep = _baseIsEqualDeep, isObjectLike = isObjectLike_1;
function baseIsEqual$1(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual$1, stack);
}
var _baseIsEqual = baseIsEqual$1;
var baseIsEqual = _baseIsEqual;
function isEqual(value, other) {
  return baseIsEqual(value, other);
}
var isEqual_1 = isEqual;
function useEventListener(eventName, handler, options) {
  if (options === void 0) {
    options = {};
  }
  var handlerRef = useLatest(handler);
  useEffectWithTarget$1(function() {
    var targetElement = getTargetElement(options.target, window);
    if (!(targetElement === null || targetElement === void 0 ? void 0 : targetElement.addEventListener)) {
      return;
    }
    var eventListener = function eventListener2(event) {
      return handlerRef.current(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return function() {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
var __read = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function isFunction$2(obj) {
  return typeof obj === "function";
}
function createUseStorageState(getStorage) {
  function useStorageState(key, options) {
    var storage2;
    try {
      storage2 = getStorage();
    } catch (err) {
      console.error(err);
    }
    var serializer = function serializer2(value) {
      if (options === null || options === void 0 ? void 0 : options.serializer) {
        return options === null || options === void 0 ? void 0 : options.serializer(value);
      }
      return JSON.stringify(value);
    };
    var deserializer = function deserializer2(value) {
      if (options === null || options === void 0 ? void 0 : options.deserializer) {
        return options === null || options === void 0 ? void 0 : options.deserializer(value);
      }
      return JSON.parse(value);
    };
    function getStoredValue() {
      try {
        var raw = storage2 === null || storage2 === void 0 ? void 0 : storage2.getItem(key);
        if (raw) {
          return deserializer(raw);
        }
      } catch (e2) {
        console.error(e2);
      }
      if (isFunction$2(options === null || options === void 0 ? void 0 : options.defaultValue)) {
        return options === null || options === void 0 ? void 0 : options.defaultValue();
      }
      return options === null || options === void 0 ? void 0 : options.defaultValue;
    }
    var _a2 = __read(useState(function() {
      return getStoredValue();
    }), 2), state = _a2[0], setState2 = _a2[1];
    useUpdateEffect(function() {
      setState2(getStoredValue());
    }, [key]);
    var updateState2 = function updateState3(value) {
      if (typeof value === "undefined") {
        setState2(void 0);
        storage2 === null || storage2 === void 0 ? void 0 : storage2.removeItem(key);
      } else if (isFunction$2(value)) {
        var currentState = value(state);
        try {
          setState2(currentState);
          storage2 === null || storage2 === void 0 ? void 0 : storage2.setItem(key, serializer(currentState));
        } catch (e2) {
          console.error(e2);
        }
      } else {
        try {
          setState2(value);
          storage2 === null || storage2 === void 0 ? void 0 : storage2.setItem(key, serializer(value));
        } catch (e2) {
          console.error(e2);
        }
      }
    };
    return [state, useMemoizedFn(updateState2)];
  }
  return useStorageState;
}
var useLocalStorageState = createUseStorageState(function() {
  return isBrowser$2 ? localStorage : void 0;
});
var useLocalStorageState$1 = useLocalStorageState;
var MapShim = function() {
  if (typeof Map !== "undefined") {
    return Map;
  }
  function getIndex(arr, key) {
    var result = -1;
    arr.some(function(entry, index2) {
      if (entry[0] === key) {
        result = index2;
        return true;
      }
      return false;
    });
    return result;
  }
  return function() {
    function class_1() {
      this.__entries__ = [];
    }
    Object.defineProperty(class_1.prototype, "size", {
      get: function() {
        return this.__entries__.length;
      },
      enumerable: true,
      configurable: true
    });
    class_1.prototype.get = function(key) {
      var index2 = getIndex(this.__entries__, key);
      var entry = this.__entries__[index2];
      return entry && entry[1];
    };
    class_1.prototype.set = function(key, value) {
      var index2 = getIndex(this.__entries__, key);
      if (~index2) {
        this.__entries__[index2][1] = value;
      } else {
        this.__entries__.push([key, value]);
      }
    };
    class_1.prototype.delete = function(key) {
      var entries = this.__entries__;
      var index2 = getIndex(entries, key);
      if (~index2) {
        entries.splice(index2, 1);
      }
    };
    class_1.prototype.has = function(key) {
      return !!~getIndex(this.__entries__, key);
    };
    class_1.prototype.clear = function() {
      this.__entries__.splice(0);
    };
    class_1.prototype.forEach = function(callback, ctx) {
      if (ctx === void 0) {
        ctx = null;
      }
      for (var _i = 0, _a2 = this.__entries__; _i < _a2.length; _i++) {
        var entry = _a2[_i];
        callback.call(ctx, entry[1], entry[0]);
      }
    };
    return class_1;
  }();
}();
var isBrowser = typeof window !== "undefined" && typeof document !== "undefined" && window.document === document;
var global$1 = function() {
  if (typeof global !== "undefined" && global.Math === Math) {
    return global;
  }
  if (typeof self !== "undefined" && self.Math === Math) {
    return self;
  }
  if (typeof window !== "undefined" && window.Math === Math) {
    return window;
  }
  return Function("return this")();
}();
var requestAnimationFrame$1$1 = function() {
  if (typeof requestAnimationFrame === "function") {
    return requestAnimationFrame.bind(global$1);
  }
  return function(callback) {
    return setTimeout(function() {
      return callback(Date.now());
    }, 1e3 / 60);
  };
}();
var trailingTimeout = 2;
function throttle$1(callback, delay) {
  var leadingCall = false, trailingCall = false, lastCallTime = 0;
  function resolvePending() {
    if (leadingCall) {
      leadingCall = false;
      callback();
    }
    if (trailingCall) {
      proxy();
    }
  }
  function timeoutCallback() {
    requestAnimationFrame$1$1(resolvePending);
  }
  function proxy() {
    var timeStamp = Date.now();
    if (leadingCall) {
      if (timeStamp - lastCallTime < trailingTimeout) {
        return;
      }
      trailingCall = true;
    } else {
      leadingCall = true;
      trailingCall = false;
      setTimeout(timeoutCallback, delay);
    }
    lastCallTime = timeStamp;
  }
  return proxy;
}
var REFRESH_DELAY = 20;
var transitionKeys = ["top", "right", "bottom", "left", "width", "height", "size", "weight"];
var mutationObserverSupported = typeof MutationObserver !== "undefined";
var ResizeObserverController = function() {
  function ResizeObserverController2() {
    this.connected_ = false;
    this.mutationEventsAdded_ = false;
    this.mutationsObserver_ = null;
    this.observers_ = [];
    this.onTransitionEnd_ = this.onTransitionEnd_.bind(this);
    this.refresh = throttle$1(this.refresh.bind(this), REFRESH_DELAY);
  }
  ResizeObserverController2.prototype.addObserver = function(observer) {
    if (!~this.observers_.indexOf(observer)) {
      this.observers_.push(observer);
    }
    if (!this.connected_) {
      this.connect_();
    }
  };
  ResizeObserverController2.prototype.removeObserver = function(observer) {
    var observers2 = this.observers_;
    var index2 = observers2.indexOf(observer);
    if (~index2) {
      observers2.splice(index2, 1);
    }
    if (!observers2.length && this.connected_) {
      this.disconnect_();
    }
  };
  ResizeObserverController2.prototype.refresh = function() {
    var changesDetected = this.updateObservers_();
    if (changesDetected) {
      this.refresh();
    }
  };
  ResizeObserverController2.prototype.updateObservers_ = function() {
    var activeObservers = this.observers_.filter(function(observer) {
      return observer.gatherActive(), observer.hasActive();
    });
    activeObservers.forEach(function(observer) {
      return observer.broadcastActive();
    });
    return activeObservers.length > 0;
  };
  ResizeObserverController2.prototype.connect_ = function() {
    if (!isBrowser || this.connected_) {
      return;
    }
    document.addEventListener("transitionend", this.onTransitionEnd_);
    window.addEventListener("resize", this.refresh);
    if (mutationObserverSupported) {
      this.mutationsObserver_ = new MutationObserver(this.refresh);
      this.mutationsObserver_.observe(document, {
        attributes: true,
        childList: true,
        characterData: true,
        subtree: true
      });
    } else {
      document.addEventListener("DOMSubtreeModified", this.refresh);
      this.mutationEventsAdded_ = true;
    }
    this.connected_ = true;
  };
  ResizeObserverController2.prototype.disconnect_ = function() {
    if (!isBrowser || !this.connected_) {
      return;
    }
    document.removeEventListener("transitionend", this.onTransitionEnd_);
    window.removeEventListener("resize", this.refresh);
    if (this.mutationsObserver_) {
      this.mutationsObserver_.disconnect();
    }
    if (this.mutationEventsAdded_) {
      document.removeEventListener("DOMSubtreeModified", this.refresh);
    }
    this.mutationsObserver_ = null;
    this.mutationEventsAdded_ = false;
    this.connected_ = false;
  };
  ResizeObserverController2.prototype.onTransitionEnd_ = function(_a2) {
    var _b2 = _a2.propertyName, propertyName = _b2 === void 0 ? "" : _b2;
    var isReflowProperty = transitionKeys.some(function(key) {
      return !!~propertyName.indexOf(key);
    });
    if (isReflowProperty) {
      this.refresh();
    }
  };
  ResizeObserverController2.getInstance = function() {
    if (!this.instance_) {
      this.instance_ = new ResizeObserverController2();
    }
    return this.instance_;
  };
  ResizeObserverController2.instance_ = null;
  return ResizeObserverController2;
}();
var defineConfigurable = function(target, props) {
  for (var _i = 0, _a2 = Object.keys(props); _i < _a2.length; _i++) {
    var key = _a2[_i];
    Object.defineProperty(target, key, {
      value: props[key],
      enumerable: false,
      writable: false,
      configurable: true
    });
  }
  return target;
};
var getWindowOf = function(target) {
  var ownerGlobal = target && target.ownerDocument && target.ownerDocument.defaultView;
  return ownerGlobal || global$1;
};
var emptyRect = createRectInit(0, 0, 0, 0);
function toFloat(value) {
  return parseFloat(value) || 0;
}
function getBordersSize(styles2) {
  var positions = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    positions[_i - 1] = arguments[_i];
  }
  return positions.reduce(function(size, position2) {
    var value = styles2["border-" + position2 + "-width"];
    return size + toFloat(value);
  }, 0);
}
function getPaddings(styles2) {
  var positions = ["top", "right", "bottom", "left"];
  var paddings = {};
  for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
    var position2 = positions_1[_i];
    var value = styles2["padding-" + position2];
    paddings[position2] = toFloat(value);
  }
  return paddings;
}
function getSVGContentRect(target) {
  var bbox = target.getBBox();
  return createRectInit(0, 0, bbox.width, bbox.height);
}
function getHTMLElementContentRect(target) {
  var clientWidth = target.clientWidth, clientHeight = target.clientHeight;
  if (!clientWidth && !clientHeight) {
    return emptyRect;
  }
  var styles2 = getWindowOf(target).getComputedStyle(target);
  var paddings = getPaddings(styles2);
  var horizPad = paddings.left + paddings.right;
  var vertPad = paddings.top + paddings.bottom;
  var width = toFloat(styles2.width), height = toFloat(styles2.height);
  if (styles2.boxSizing === "border-box") {
    if (Math.round(width + horizPad) !== clientWidth) {
      width -= getBordersSize(styles2, "left", "right") + horizPad;
    }
    if (Math.round(height + vertPad) !== clientHeight) {
      height -= getBordersSize(styles2, "top", "bottom") + vertPad;
    }
  }
  if (!isDocumentElement(target)) {
    var vertScrollbar = Math.round(width + horizPad) - clientWidth;
    var horizScrollbar = Math.round(height + vertPad) - clientHeight;
    if (Math.abs(vertScrollbar) !== 1) {
      width -= vertScrollbar;
    }
    if (Math.abs(horizScrollbar) !== 1) {
      height -= horizScrollbar;
    }
  }
  return createRectInit(paddings.left, paddings.top, width, height);
}
var isSVGGraphicsElement = function() {
  if (typeof SVGGraphicsElement !== "undefined") {
    return function(target) {
      return target instanceof getWindowOf(target).SVGGraphicsElement;
    };
  }
  return function(target) {
    return target instanceof getWindowOf(target).SVGElement && typeof target.getBBox === "function";
  };
}();
function isDocumentElement(target) {
  return target === getWindowOf(target).document.documentElement;
}
function getContentRect(target) {
  if (!isBrowser) {
    return emptyRect;
  }
  if (isSVGGraphicsElement(target)) {
    return getSVGContentRect(target);
  }
  return getHTMLElementContentRect(target);
}
function createReadOnlyRect(_a2) {
  var x2 = _a2.x, y2 = _a2.y, width = _a2.width, height = _a2.height;
  var Constr = typeof DOMRectReadOnly !== "undefined" ? DOMRectReadOnly : Object;
  var rect = Object.create(Constr.prototype);
  defineConfigurable(rect, {
    x: x2,
    y: y2,
    width,
    height,
    top: y2,
    right: x2 + width,
    bottom: height + y2,
    left: x2
  });
  return rect;
}
function createRectInit(x2, y2, width, height) {
  return { x: x2, y: y2, width, height };
}
var ResizeObservation = function() {
  function ResizeObservation2(target) {
    this.broadcastWidth = 0;
    this.broadcastHeight = 0;
    this.contentRect_ = createRectInit(0, 0, 0, 0);
    this.target = target;
  }
  ResizeObservation2.prototype.isActive = function() {
    var rect = getContentRect(this.target);
    this.contentRect_ = rect;
    return rect.width !== this.broadcastWidth || rect.height !== this.broadcastHeight;
  };
  ResizeObservation2.prototype.broadcastRect = function() {
    var rect = this.contentRect_;
    this.broadcastWidth = rect.width;
    this.broadcastHeight = rect.height;
    return rect;
  };
  return ResizeObservation2;
}();
var ResizeObserverEntry = function() {
  function ResizeObserverEntry2(target, rectInit) {
    var contentRect = createReadOnlyRect(rectInit);
    defineConfigurable(this, { target, contentRect });
  }
  return ResizeObserverEntry2;
}();
var ResizeObserverSPI = function() {
  function ResizeObserverSPI2(callback, controller, callbackCtx) {
    this.activeObservations_ = [];
    this.observations_ = new MapShim();
    if (typeof callback !== "function") {
      throw new TypeError("The callback provided as parameter 1 is not a function.");
    }
    this.callback_ = callback;
    this.controller_ = controller;
    this.callbackCtx_ = callbackCtx;
  }
  ResizeObserverSPI2.prototype.observe = function(target) {
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    if (typeof Element === "undefined" || !(Element instanceof Object)) {
      return;
    }
    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }
    var observations = this.observations_;
    if (observations.has(target)) {
      return;
    }
    observations.set(target, new ResizeObservation(target));
    this.controller_.addObserver(this);
    this.controller_.refresh();
  };
  ResizeObserverSPI2.prototype.unobserve = function(target) {
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    if (typeof Element === "undefined" || !(Element instanceof Object)) {
      return;
    }
    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }
    var observations = this.observations_;
    if (!observations.has(target)) {
      return;
    }
    observations.delete(target);
    if (!observations.size) {
      this.controller_.removeObserver(this);
    }
  };
  ResizeObserverSPI2.prototype.disconnect = function() {
    this.clearActive();
    this.observations_.clear();
    this.controller_.removeObserver(this);
  };
  ResizeObserverSPI2.prototype.gatherActive = function() {
    var _this = this;
    this.clearActive();
    this.observations_.forEach(function(observation) {
      if (observation.isActive()) {
        _this.activeObservations_.push(observation);
      }
    });
  };
  ResizeObserverSPI2.prototype.broadcastActive = function() {
    if (!this.hasActive()) {
      return;
    }
    var ctx = this.callbackCtx_;
    var entries = this.activeObservations_.map(function(observation) {
      return new ResizeObserverEntry(observation.target, observation.broadcastRect());
    });
    this.callback_.call(ctx, entries, ctx);
    this.clearActive();
  };
  ResizeObserverSPI2.prototype.clearActive = function() {
    this.activeObservations_.splice(0);
  };
  ResizeObserverSPI2.prototype.hasActive = function() {
    return this.activeObservations_.length > 0;
  };
  return ResizeObserverSPI2;
}();
var observers = typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : new MapShim();
var ResizeObserver$1 = function() {
  function ResizeObserver2(callback) {
    if (!(this instanceof ResizeObserver2)) {
      throw new TypeError("Cannot call a class as a function.");
    }
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    var controller = ResizeObserverController.getInstance();
    var observer = new ResizeObserverSPI(callback, controller, this);
    observers.set(this, observer);
  }
  return ResizeObserver2;
}();
[
  "observe",
  "unobserve",
  "disconnect"
].forEach(function(method4) {
  ResizeObserver$1.prototype[method4] = function() {
    var _a2;
    return (_a2 = observers.get(this))[method4].apply(_a2, arguments);
  };
});
var index$9 = function() {
  if (typeof global$1.ResizeObserver !== "undefined") {
    return global$1.ResizeObserver;
  }
  return ResizeObserver$1;
}();
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d2, b2) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b3) {
    d3.__proto__ = b3;
  } || function(d3, b3) {
    for (var p2 in b3)
      if (Object.prototype.hasOwnProperty.call(b3, p2))
        d3[p2] = b3[p2];
  };
  return extendStatics(d2, b2);
};
function __extends(d2, b2) {
  if (typeof b2 !== "function" && b2 !== null)
    throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
  extendStatics(d2, b2);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
}
var Browser = function() {
  function Browser2() {
    this.firefox = false;
    this.ie = false;
    this.edge = false;
    this.newEdge = false;
    this.weChat = false;
  }
  return Browser2;
}();
var Env = function() {
  function Env2() {
    this.browser = new Browser();
    this.node = false;
    this.wxa = false;
    this.worker = false;
    this.svgSupported = false;
    this.touchEventsSupported = false;
    this.pointerEventsSupported = false;
    this.domSupported = false;
    this.transformSupported = false;
    this.transform3dSupported = false;
    this.hasGlobalWindow = typeof window !== "undefined";
  }
  return Env2;
}();
var env = new Env();
if (typeof wx === "object" && typeof wx.getSystemInfoSync === "function") {
  env.wxa = true;
  env.touchEventsSupported = true;
} else if (typeof document === "undefined" && typeof self !== "undefined") {
  env.worker = true;
} else if (typeof navigator === "undefined") {
  env.node = true;
  env.svgSupported = true;
} else {
  detect(navigator.userAgent, env);
}
function detect(ua2, env2) {
  var browser = env2.browser;
  var firefox = ua2.match(/Firefox\/([\d.]+)/);
  var ie2 = ua2.match(/MSIE\s([\d.]+)/) || ua2.match(/Trident\/.+?rv:(([\d.]+))/);
  var edge = ua2.match(/Edge?\/([\d.]+)/);
  var weChat = /micromessenger/i.test(ua2);
  if (firefox) {
    browser.firefox = true;
    browser.version = firefox[1];
  }
  if (ie2) {
    browser.ie = true;
    browser.version = ie2[1];
  }
  if (edge) {
    browser.edge = true;
    browser.version = edge[1];
    browser.newEdge = +edge[1].split(".")[0] > 18;
  }
  if (weChat) {
    browser.weChat = true;
  }
  env2.svgSupported = typeof SVGRect !== "undefined";
  env2.touchEventsSupported = "ontouchstart" in window && !browser.ie && !browser.edge;
  env2.pointerEventsSupported = "onpointerdown" in window && (browser.edge || browser.ie && +browser.version >= 11);
  env2.domSupported = typeof document !== "undefined";
  var style2 = document.documentElement.style;
  env2.transform3dSupported = (browser.ie && "transition" in style2 || browser.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in style2) && !("OTransition" in style2);
  env2.transformSupported = env2.transform3dSupported || browser.ie && +browser.version >= 9;
}
var env$1 = env;
var DEFAULT_FONT_SIZE = 12;
var DEFAULT_FONT_FAMILY = "sans-serif";
var DEFAULT_FONT = DEFAULT_FONT_SIZE + "px " + DEFAULT_FONT_FAMILY;
var OFFSET = 20;
var SCALE = 100;
var defaultWidthMapStr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
function getTextWidthMap(mapStr) {
  var map2 = {};
  if (typeof JSON === "undefined") {
    return map2;
  }
  for (var i = 0; i < mapStr.length; i++) {
    var char = String.fromCharCode(i + 32);
    var size = (mapStr.charCodeAt(i) - OFFSET) / SCALE;
    map2[char] = size;
  }
  return map2;
}
var DEFAULT_TEXT_WIDTH_MAP = getTextWidthMap(defaultWidthMapStr);
var platformApi = {
  createCanvas: function() {
    return typeof document !== "undefined" && document.createElement("canvas");
  },
  measureText: function() {
    var _ctx;
    var _cachedFont;
    return function(text, font) {
      if (!_ctx) {
        var canvas = platformApi.createCanvas();
        _ctx = canvas && canvas.getContext("2d");
      }
      if (_ctx) {
        if (_cachedFont !== font) {
          _cachedFont = _ctx.font = font || DEFAULT_FONT;
        }
        return _ctx.measureText(text);
      } else {
        text = text || "";
        font = font || DEFAULT_FONT;
        var res2 = /^([0-9]*?)px$/.exec(font);
        var fontSize = +(res2 && res2[1]) || DEFAULT_FONT_SIZE;
        var width = 0;
        if (font.indexOf("mono") >= 0) {
          width = fontSize * text.length;
        } else {
          for (var i = 0; i < text.length; i++) {
            var preCalcWidth = DEFAULT_TEXT_WIDTH_MAP[text[i]];
            width += preCalcWidth == null ? fontSize : preCalcWidth * fontSize;
          }
        }
        return { width };
      }
    };
  }(),
  loadImage: function(src, onload, onerror) {
    var image = new Image();
    image.onload = onload;
    image.onerror = onerror;
    image.src = src;
    return image;
  }
};
var BUILTIN_OBJECT = reduce([
  "Function",
  "RegExp",
  "Date",
  "Error",
  "CanvasGradient",
  "CanvasPattern",
  "Image",
  "Canvas"
], function(obj, val) {
  obj["[object " + val + "]"] = true;
  return obj;
}, {});
var TYPED_ARRAY = reduce([
  "Int8",
  "Uint8",
  "Uint8Clamped",
  "Int16",
  "Uint16",
  "Int32",
  "Uint32",
  "Float32",
  "Float64"
], function(obj, val) {
  obj["[object " + val + "Array]"] = true;
  return obj;
}, {});
var objToString = Object.prototype.toString;
var arrayProto = Array.prototype;
var nativeForEach = arrayProto.forEach;
var nativeFilter = arrayProto.filter;
var nativeSlice = arrayProto.slice;
var nativeMap = arrayProto.map;
var ctorFunction = function() {
}.constructor;
var protoFunction = ctorFunction ? ctorFunction.prototype : null;
var protoKey = "__proto__";
var idStart = 2311;
function guid() {
  return idStart++;
}
function logError() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  if (typeof console !== "undefined") {
    console.error.apply(console, args);
  }
}
function clone$4(source) {
  if (source == null || typeof source !== "object") {
    return source;
  }
  var result = source;
  var typeStr = objToString.call(source);
  if (typeStr === "[object Array]") {
    if (!isPrimitive(source)) {
      result = [];
      for (var i = 0, len2 = source.length; i < len2; i++) {
        result[i] = clone$4(source[i]);
      }
    }
  } else if (TYPED_ARRAY[typeStr]) {
    if (!isPrimitive(source)) {
      var Ctor = source.constructor;
      if (Ctor.from) {
        result = Ctor.from(source);
      } else {
        result = new Ctor(source.length);
        for (var i = 0, len2 = source.length; i < len2; i++) {
          result[i] = source[i];
        }
      }
    }
  } else if (!BUILTIN_OBJECT[typeStr] && !isPrimitive(source) && !isDom(source)) {
    result = {};
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        result[key] = clone$4(source[key]);
      }
    }
  }
  return result;
}
function merge$1(target, source, overwrite) {
  if (!isObject$6(source) || !isObject$6(target)) {
    return overwrite ? clone$4(source) : target;
  }
  for (var key in source) {
    if (source.hasOwnProperty(key) && key !== protoKey) {
      var targetProp = target[key];
      var sourceProp = source[key];
      if (isObject$6(sourceProp) && isObject$6(targetProp) && !isArray$2(sourceProp) && !isArray$2(targetProp) && !isDom(sourceProp) && !isDom(targetProp) && !isBuiltInObject(sourceProp) && !isBuiltInObject(targetProp) && !isPrimitive(sourceProp) && !isPrimitive(targetProp)) {
        merge$1(targetProp, sourceProp, overwrite);
      } else if (overwrite || !(key in target)) {
        target[key] = clone$4(source[key]);
      }
    }
  }
  return target;
}
function mergeAll(targetAndSources, overwrite) {
  var result = targetAndSources[0];
  for (var i = 1, len2 = targetAndSources.length; i < len2; i++) {
    result = merge$1(result, targetAndSources[i], overwrite);
  }
  return result;
}
function extend(target, source) {
  if (Object.assign) {
    Object.assign(target, source);
  } else {
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        target[key] = source[key];
      }
    }
  }
  return target;
}
function defaults(target, source, overlay) {
  var keysArr = keys(source);
  for (var i = 0; i < keysArr.length; i++) {
    var key = keysArr[i];
    if (overlay ? source[key] != null : target[key] == null) {
      target[key] = source[key];
    }
  }
  return target;
}
platformApi.createCanvas;
function indexOf(array4, value) {
  if (array4) {
    if (array4.indexOf) {
      return array4.indexOf(value);
    }
    for (var i = 0, len2 = array4.length; i < len2; i++) {
      if (array4[i] === value) {
        return i;
      }
    }
  }
  return -1;
}
function inherits(clazz, baseClazz) {
  var clazzPrototype = clazz.prototype;
  function F2() {
  }
  F2.prototype = baseClazz.prototype;
  clazz.prototype = new F2();
  for (var prop in clazzPrototype) {
    if (clazzPrototype.hasOwnProperty(prop)) {
      clazz.prototype[prop] = clazzPrototype[prop];
    }
  }
  clazz.prototype.constructor = clazz;
  clazz.superClass = baseClazz;
}
function mixin(target, source, override) {
  target = "prototype" in target ? target.prototype : target;
  source = "prototype" in source ? source.prototype : source;
  if (Object.getOwnPropertyNames) {
    var keyList = Object.getOwnPropertyNames(source);
    for (var i = 0; i < keyList.length; i++) {
      var key = keyList[i];
      if (key !== "constructor") {
        if (override ? source[key] != null : target[key] == null) {
          target[key] = source[key];
        }
      }
    }
  } else {
    defaults(target, source, override);
  }
}
function isArrayLike(data2) {
  if (!data2) {
    return false;
  }
  if (typeof data2 === "string") {
    return false;
  }
  return typeof data2.length === "number";
}
function each$g(arr, cb2, context) {
  if (!(arr && cb2)) {
    return;
  }
  if (arr.forEach && arr.forEach === nativeForEach) {
    arr.forEach(cb2, context);
  } else if (arr.length === +arr.length) {
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      cb2.call(context, arr[i], i, arr);
    }
  } else {
    for (var key in arr) {
      if (arr.hasOwnProperty(key)) {
        cb2.call(context, arr[key], key, arr);
      }
    }
  }
}
function map$1(arr, cb2, context) {
  if (!arr) {
    return [];
  }
  if (!cb2) {
    return slice(arr);
  }
  if (arr.map && arr.map === nativeMap) {
    return arr.map(cb2, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      result.push(cb2.call(context, arr[i], i, arr));
    }
    return result;
  }
}
function reduce(arr, cb2, memo, context) {
  if (!(arr && cb2)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    memo = cb2.call(context, memo, arr[i], i, arr);
  }
  return memo;
}
function filter(arr, cb2, context) {
  if (!arr) {
    return [];
  }
  if (!cb2) {
    return slice(arr);
  }
  if (arr.filter && arr.filter === nativeFilter) {
    return arr.filter(cb2, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      if (cb2.call(context, arr[i], i, arr)) {
        result.push(arr[i]);
      }
    }
    return result;
  }
}
function find(arr, cb2, context) {
  if (!(arr && cb2)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    if (cb2.call(context, arr[i], i, arr)) {
      return arr[i];
    }
  }
}
function keys(obj) {
  if (!obj) {
    return [];
  }
  if (Object.keys) {
    return Object.keys(obj);
  }
  var keyList = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      keyList.push(key);
    }
  }
  return keyList;
}
function bindPolyfill(func, context) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return function() {
    return func.apply(context, args.concat(nativeSlice.call(arguments)));
  };
}
var bind$1 = protoFunction && isFunction$1(protoFunction.bind) ? protoFunction.call.bind(protoFunction.bind) : bindPolyfill;
function curry$3(func) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return function() {
    return func.apply(this, args.concat(nativeSlice.call(arguments)));
  };
}
function isArray$2(value) {
  if (Array.isArray) {
    return Array.isArray(value);
  }
  return objToString.call(value) === "[object Array]";
}
function isFunction$1(value) {
  return typeof value === "function";
}
function isString$1(value) {
  return typeof value === "string";
}
function isStringSafe(value) {
  return objToString.call(value) === "[object String]";
}
function isNumber(value) {
  return typeof value === "number";
}
function isObject$6(value) {
  var type4 = typeof value;
  return type4 === "function" || !!value && type4 === "object";
}
function isBuiltInObject(value) {
  return !!BUILTIN_OBJECT[objToString.call(value)];
}
function isTypedArray(value) {
  return !!TYPED_ARRAY[objToString.call(value)];
}
function isDom(value) {
  return typeof value === "object" && typeof value.nodeType === "number" && typeof value.ownerDocument === "object";
}
function isGradientObject(value) {
  return value.colorStops != null;
}
function isImagePatternObject(value) {
  return value.image != null;
}
function isRegExp(value) {
  return objToString.call(value) === "[object RegExp]";
}
function eqNaN(value) {
  return value !== value;
}
function retrieve() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  for (var i = 0, len2 = args.length; i < len2; i++) {
    if (args[i] != null) {
      return args[i];
    }
  }
}
function retrieve2(value0, value1) {
  return value0 != null ? value0 : value1;
}
function retrieve3(value0, value1, value2) {
  return value0 != null ? value0 : value1 != null ? value1 : value2;
}
function slice(arr) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return nativeSlice.apply(arr, args);
}
function normalizeCssArray$1(val) {
  if (typeof val === "number") {
    return [val, val, val, val];
  }
  var len2 = val.length;
  if (len2 === 2) {
    return [val[0], val[1], val[0], val[1]];
  } else if (len2 === 3) {
    return [val[0], val[1], val[2], val[1]];
  }
  return val;
}
function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}
function trim$1(str) {
  if (str == null) {
    return null;
  } else if (typeof str.trim === "function") {
    return str.trim();
  } else {
    return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
}
var primitiveKey = "__ec_primitive__";
function setAsPrimitive(obj) {
  obj[primitiveKey] = true;
}
function isPrimitive(obj) {
  return obj[primitiveKey];
}
var HashMap = function() {
  function HashMap2(obj) {
    this.data = {};
    var isArr = isArray$2(obj);
    this.data = {};
    var thisMap = this;
    obj instanceof HashMap2 ? obj.each(visit) : obj && each$g(obj, visit);
    function visit(value, key) {
      isArr ? thisMap.set(value, key) : thisMap.set(key, value);
    }
  }
  HashMap2.prototype.get = function(key) {
    return this.data.hasOwnProperty(key) ? this.data[key] : null;
  };
  HashMap2.prototype.set = function(key, value) {
    return this.data[key] = value;
  };
  HashMap2.prototype.each = function(cb2, context) {
    for (var key in this.data) {
      if (this.data.hasOwnProperty(key)) {
        cb2.call(context, this.data[key], key);
      }
    }
  };
  HashMap2.prototype.keys = function() {
    return keys(this.data);
  };
  HashMap2.prototype.removeKey = function(key) {
    delete this.data[key];
  };
  return HashMap2;
}();
function createHashMap(obj) {
  return new HashMap(obj);
}
function concatArray(a, b2) {
  var newArray = new a.constructor(a.length + b2.length);
  for (var i = 0; i < a.length; i++) {
    newArray[i] = a[i];
  }
  var offset3 = a.length;
  for (var i = 0; i < b2.length; i++) {
    newArray[i + offset3] = b2[i];
  }
  return newArray;
}
function createObject(proto2, properties) {
  var obj;
  if (Object.create) {
    obj = Object.create(proto2);
  } else {
    var StyleCtor = function() {
    };
    StyleCtor.prototype = proto2;
    obj = new StyleCtor();
  }
  if (properties) {
    extend(obj, properties);
  }
  return obj;
}
function disableUserSelect(dom) {
  var domStyle = dom.style;
  domStyle.webkitUserSelect = "none";
  domStyle.userSelect = "none";
  domStyle.webkitTapHighlightColor = "rgba(0,0,0,0)";
  domStyle["-webkit-touch-callout"] = "none";
}
function hasOwn$1(own, prop) {
  return own.hasOwnProperty(prop);
}
function noop$1() {
}
var RADIAN_TO_DEGREE = 180 / Math.PI;
function create$3(x2, y2) {
  if (x2 == null) {
    x2 = 0;
  }
  if (y2 == null) {
    y2 = 0;
  }
  return [x2, y2];
}
function copy$1(out2, v4) {
  out2[0] = v4[0];
  out2[1] = v4[1];
  return out2;
}
function clone$3(v4) {
  return [v4[0], v4[1]];
}
function set$2(out2, a, b2) {
  out2[0] = a;
  out2[1] = b2;
  return out2;
}
function add(out2, v12, v22) {
  out2[0] = v12[0] + v22[0];
  out2[1] = v12[1] + v22[1];
  return out2;
}
function scaleAndAdd$1(out2, v12, v22, a) {
  out2[0] = v12[0] + v22[0] * a;
  out2[1] = v12[1] + v22[1] * a;
  return out2;
}
function sub(out2, v12, v22) {
  out2[0] = v12[0] - v22[0];
  out2[1] = v12[1] - v22[1];
  return out2;
}
function len(v4) {
  return Math.sqrt(lenSquare(v4));
}
function lenSquare(v4) {
  return v4[0] * v4[0] + v4[1] * v4[1];
}
function scale$2(out2, v4, s) {
  out2[0] = v4[0] * s;
  out2[1] = v4[1] * s;
  return out2;
}
function normalize$4(out2, v4) {
  var d2 = len(v4);
  if (d2 === 0) {
    out2[0] = 0;
    out2[1] = 0;
  } else {
    out2[0] = v4[0] / d2;
    out2[1] = v4[1] / d2;
  }
  return out2;
}
function distance(v12, v22) {
  return Math.sqrt((v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]));
}
var dist$1 = distance;
function distanceSquare(v12, v22) {
  return (v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]);
}
var distSquare = distanceSquare;
function lerp$1(out2, v12, v22, t2) {
  out2[0] = v12[0] + t2 * (v22[0] - v12[0]);
  out2[1] = v12[1] + t2 * (v22[1] - v12[1]);
  return out2;
}
function applyTransform$1(out2, v4, m2) {
  var x2 = v4[0];
  var y2 = v4[1];
  out2[0] = m2[0] * x2 + m2[2] * y2 + m2[4];
  out2[1] = m2[1] * x2 + m2[3] * y2 + m2[5];
  return out2;
}
function min$1(out2, v12, v22) {
  out2[0] = Math.min(v12[0], v22[0]);
  out2[1] = Math.min(v12[1], v22[1]);
  return out2;
}
function max$1(out2, v12, v22) {
  out2[0] = Math.max(v12[0], v22[0]);
  out2[1] = Math.max(v12[1], v22[1]);
  return out2;
}
var Param = function() {
  function Param2(target, e2) {
    this.target = target;
    this.topTarget = e2 && e2.topTarget;
  }
  return Param2;
}();
var Draggable = function() {
  function Draggable2(handler) {
    this.handler = handler;
    handler.on("mousedown", this._dragStart, this);
    handler.on("mousemove", this._drag, this);
    handler.on("mouseup", this._dragEnd, this);
  }
  Draggable2.prototype._dragStart = function(e2) {
    var draggingTarget = e2.target;
    while (draggingTarget && !draggingTarget.draggable) {
      draggingTarget = draggingTarget.parent || draggingTarget.__hostTarget;
    }
    if (draggingTarget) {
      this._draggingTarget = draggingTarget;
      draggingTarget.dragging = true;
      this._x = e2.offsetX;
      this._y = e2.offsetY;
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragstart", e2.event);
    }
  };
  Draggable2.prototype._drag = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      var x2 = e2.offsetX;
      var y2 = e2.offsetY;
      var dx = x2 - this._x;
      var dy = y2 - this._y;
      this._x = x2;
      this._y = y2;
      draggingTarget.drift(dx, dy, e2);
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "drag", e2.event);
      var dropTarget = this.handler.findHover(x2, y2, draggingTarget).target;
      var lastDropTarget = this._dropTarget;
      this._dropTarget = dropTarget;
      if (draggingTarget !== dropTarget) {
        if (lastDropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(lastDropTarget, e2), "dragleave", e2.event);
        }
        if (dropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(dropTarget, e2), "dragenter", e2.event);
        }
      }
    }
  };
  Draggable2.prototype._dragEnd = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      draggingTarget.dragging = false;
    }
    this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragend", e2.event);
    if (this._dropTarget) {
      this.handler.dispatchToElement(new Param(this._dropTarget, e2), "drop", e2.event);
    }
    this._draggingTarget = null;
    this._dropTarget = null;
  };
  return Draggable2;
}();
var Draggable$1 = Draggable;
var Eventful = function() {
  function Eventful2(eventProcessors) {
    if (eventProcessors) {
      this._$eventProcessor = eventProcessors;
    }
  }
  Eventful2.prototype.on = function(event, query, handler, context) {
    if (!this._$handlers) {
      this._$handlers = {};
    }
    var _h = this._$handlers;
    if (typeof query === "function") {
      context = handler;
      handler = query;
      query = null;
    }
    if (!handler || !event) {
      return this;
    }
    var eventProcessor = this._$eventProcessor;
    if (query != null && eventProcessor && eventProcessor.normalizeQuery) {
      query = eventProcessor.normalizeQuery(query);
    }
    if (!_h[event]) {
      _h[event] = [];
    }
    for (var i = 0; i < _h[event].length; i++) {
      if (_h[event][i].h === handler) {
        return this;
      }
    }
    var wrap = {
      h: handler,
      query,
      ctx: context || this,
      callAtLast: handler.zrEventfulCallAtLast
    };
    var lastIndex = _h[event].length - 1;
    var lastWrap = _h[event][lastIndex];
    lastWrap && lastWrap.callAtLast ? _h[event].splice(lastIndex, 0, wrap) : _h[event].push(wrap);
    return this;
  };
  Eventful2.prototype.isSilent = function(eventName) {
    var _h = this._$handlers;
    return !_h || !_h[eventName] || !_h[eventName].length;
  };
  Eventful2.prototype.off = function(eventType, handler) {
    var _h = this._$handlers;
    if (!_h) {
      return this;
    }
    if (!eventType) {
      this._$handlers = {};
      return this;
    }
    if (handler) {
      if (_h[eventType]) {
        var newList = [];
        for (var i = 0, l2 = _h[eventType].length; i < l2; i++) {
          if (_h[eventType][i].h !== handler) {
            newList.push(_h[eventType][i]);
          }
        }
        _h[eventType] = newList;
      }
      if (_h[eventType] && _h[eventType].length === 0) {
        delete _h[eventType];
      }
    } else {
      delete _h[eventType];
    }
    return this;
  };
  Eventful2.prototype.trigger = function(eventType) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[eventType];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(eventType, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(hItem.ctx);
            break;
          case 1:
            hItem.h.call(hItem.ctx, args[0]);
            break;
          case 2:
            hItem.h.call(hItem.ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(hItem.ctx, args);
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(eventType);
    return this;
  };
  Eventful2.prototype.triggerWithContext = function(type4) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[type4];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var ctx = args[argLen - 1];
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(type4, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(ctx);
            break;
          case 1:
            hItem.h.call(ctx, args[0]);
            break;
          case 2:
            hItem.h.call(ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(ctx, args.slice(1, argLen - 1));
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(type4);
    return this;
  };
  return Eventful2;
}();
var Eventful$1 = Eventful;
var LN2 = Math.log(2);
function determinant(rows, rank, rowStart, rowMask, colMask, detCache) {
  var cacheKey = rowMask + "-" + colMask;
  var fullRank = rows.length;
  if (detCache.hasOwnProperty(cacheKey)) {
    return detCache[cacheKey];
  }
  if (rank === 1) {
    var colStart = Math.round(Math.log((1 << fullRank) - 1 & ~colMask) / LN2);
    return rows[rowStart][colStart];
  }
  var subRowMask = rowMask | 1 << rowStart;
  var subRowStart = rowStart + 1;
  while (rowMask & 1 << subRowStart) {
    subRowStart++;
  }
  var sum2 = 0;
  for (var j = 0, colLocalIdx = 0; j < fullRank; j++) {
    var colTag = 1 << j;
    if (!(colTag & colMask)) {
      sum2 += (colLocalIdx % 2 ? -1 : 1) * rows[rowStart][j] * determinant(rows, rank - 1, subRowStart, subRowMask, colMask | colTag, detCache);
      colLocalIdx++;
    }
  }
  detCache[cacheKey] = sum2;
  return sum2;
}
function buildTransformer(src, dest) {
  var mA = [
    [src[0], src[1], 1, 0, 0, 0, -dest[0] * src[0], -dest[0] * src[1]],
    [0, 0, 0, src[0], src[1], 1, -dest[1] * src[0], -dest[1] * src[1]],
    [src[2], src[3], 1, 0, 0, 0, -dest[2] * src[2], -dest[2] * src[3]],
    [0, 0, 0, src[2], src[3], 1, -dest[3] * src[2], -dest[3] * src[3]],
    [src[4], src[5], 1, 0, 0, 0, -dest[4] * src[4], -dest[4] * src[5]],
    [0, 0, 0, src[4], src[5], 1, -dest[5] * src[4], -dest[5] * src[5]],
    [src[6], src[7], 1, 0, 0, 0, -dest[6] * src[6], -dest[6] * src[7]],
    [0, 0, 0, src[6], src[7], 1, -dest[7] * src[6], -dest[7] * src[7]]
  ];
  var detCache = {};
  var det = determinant(mA, 8, 0, 0, 0, detCache);
  if (det === 0) {
    return;
  }
  var vh2 = [];
  for (var i = 0; i < 8; i++) {
    for (var j = 0; j < 8; j++) {
      vh2[j] == null && (vh2[j] = 0);
      vh2[j] += ((i + j) % 2 ? -1 : 1) * determinant(mA, 7, i === 0 ? 1 : 0, 1 << i, 1 << j, detCache) / det * dest[i];
    }
  }
  return function(out2, srcPointX, srcPointY) {
    var pk2 = srcPointX * vh2[6] + srcPointY * vh2[7] + 1;
    out2[0] = (srcPointX * vh2[0] + srcPointY * vh2[1] + vh2[2]) / pk2;
    out2[1] = (srcPointX * vh2[3] + srcPointY * vh2[4] + vh2[5]) / pk2;
  };
}
var EVENT_SAVED_PROP = "___zrEVENTSAVED";
var _calcOut$1 = [];
function transformLocalCoord(out2, elFrom, elTarget, inX, inY) {
  return transformCoordWithViewport(_calcOut$1, elFrom, inX, inY, true) && transformCoordWithViewport(out2, elTarget, _calcOut$1[0], _calcOut$1[1]);
}
function transformCoordWithViewport(out2, el, inX, inY, inverse) {
  if (el.getBoundingClientRect && env$1.domSupported && !isCanvasEl(el)) {
    var saved = el[EVENT_SAVED_PROP] || (el[EVENT_SAVED_PROP] = {});
    var markers = prepareCoordMarkers(el, saved);
    var transformer = preparePointerTransformer(markers, saved, inverse);
    if (transformer) {
      transformer(out2, inX, inY);
      return true;
    }
  }
  return false;
}
function prepareCoordMarkers(el, saved) {
  var markers = saved.markers;
  if (markers) {
    return markers;
  }
  markers = saved.markers = [];
  var propLR = ["left", "right"];
  var propTB = ["top", "bottom"];
  for (var i = 0; i < 4; i++) {
    var marker = document.createElement("div");
    var stl = marker.style;
    var idxLR = i % 2;
    var idxTB = (i >> 1) % 2;
    stl.cssText = [
      "position: absolute",
      "visibility: hidden",
      "padding: 0",
      "margin: 0",
      "border-width: 0",
      "user-select: none",
      "width:0",
      "height:0",
      propLR[idxLR] + ":0",
      propTB[idxTB] + ":0",
      propLR[1 - idxLR] + ":auto",
      propTB[1 - idxTB] + ":auto",
      ""
    ].join("!important;");
    el.appendChild(marker);
    markers.push(marker);
  }
  return markers;
}
function preparePointerTransformer(markers, saved, inverse) {
  var transformerName = inverse ? "invTrans" : "trans";
  var transformer = saved[transformerName];
  var oldSrcCoords = saved.srcCoords;
  var srcCoords = [];
  var destCoords = [];
  var oldCoordTheSame = true;
  for (var i = 0; i < 4; i++) {
    var rect = markers[i].getBoundingClientRect();
    var ii2 = 2 * i;
    var x2 = rect.left;
    var y2 = rect.top;
    srcCoords.push(x2, y2);
    oldCoordTheSame = oldCoordTheSame && oldSrcCoords && x2 === oldSrcCoords[ii2] && y2 === oldSrcCoords[ii2 + 1];
    destCoords.push(markers[i].offsetLeft, markers[i].offsetTop);
  }
  return oldCoordTheSame && transformer ? transformer : (saved.srcCoords = srcCoords, saved[transformerName] = inverse ? buildTransformer(destCoords, srcCoords) : buildTransformer(srcCoords, destCoords));
}
function isCanvasEl(el) {
  return el.nodeName.toUpperCase() === "CANVAS";
}
var MOUSE_EVENT_REG = /^(?:mouse|pointer|contextmenu|drag|drop)|click/;
var _calcOut = [];
var firefoxNotSupportOffsetXY = env$1.browser.firefox && +env$1.browser.version.split(".")[0] < 39;
function clientToLocal(el, e2, out2, calculate) {
  out2 = out2 || {};
  if (calculate) {
    calculateZrXY(el, e2, out2);
  } else if (firefoxNotSupportOffsetXY && e2.layerX != null && e2.layerX !== e2.offsetX) {
    out2.zrX = e2.layerX;
    out2.zrY = e2.layerY;
  } else if (e2.offsetX != null) {
    out2.zrX = e2.offsetX;
    out2.zrY = e2.offsetY;
  } else {
    calculateZrXY(el, e2, out2);
  }
  return out2;
}
function calculateZrXY(el, e2, out2) {
  if (env$1.domSupported && el.getBoundingClientRect) {
    var ex = e2.clientX;
    var ey = e2.clientY;
    if (isCanvasEl(el)) {
      var box2 = el.getBoundingClientRect();
      out2.zrX = ex - box2.left;
      out2.zrY = ey - box2.top;
      return;
    } else {
      if (transformCoordWithViewport(_calcOut, el, ex, ey)) {
        out2.zrX = _calcOut[0];
        out2.zrY = _calcOut[1];
        return;
      }
    }
  }
  out2.zrX = out2.zrY = 0;
}
function getNativeEvent(e2) {
  return e2 || window.event;
}
function normalizeEvent(el, e2, calculate) {
  e2 = getNativeEvent(e2);
  if (e2.zrX != null) {
    return e2;
  }
  var eventType = e2.type;
  var isTouch = eventType && eventType.indexOf("touch") >= 0;
  if (!isTouch) {
    clientToLocal(el, e2, e2, calculate);
    var wheelDelta = getWheelDeltaMayPolyfill(e2);
    e2.zrDelta = wheelDelta ? wheelDelta / 120 : -(e2.detail || 0) / 3;
  } else {
    var touch = eventType !== "touchend" ? e2.targetTouches[0] : e2.changedTouches[0];
    touch && clientToLocal(el, touch, e2, calculate);
  }
  var button = e2.button;
  if (e2.which == null && button !== void 0 && MOUSE_EVENT_REG.test(e2.type)) {
    e2.which = button & 1 ? 1 : button & 2 ? 3 : button & 4 ? 2 : 0;
  }
  return e2;
}
function getWheelDeltaMayPolyfill(e2) {
  var rawWheelDelta = e2.wheelDelta;
  if (rawWheelDelta) {
    return rawWheelDelta;
  }
  var deltaX = e2.deltaX;
  var deltaY = e2.deltaY;
  if (deltaX == null || deltaY == null) {
    return rawWheelDelta;
  }
  var delta = deltaY !== 0 ? Math.abs(deltaY) : Math.abs(deltaX);
  var sign = deltaY > 0 ? -1 : deltaY < 0 ? 1 : deltaX > 0 ? -1 : 1;
  return 3 * delta * sign;
}
function addEventListener$1(el, name2, handler, opt) {
  el.addEventListener(name2, handler, opt);
}
function removeEventListener$1(el, name2, handler, opt) {
  el.removeEventListener(name2, handler, opt);
}
var stop = function(e2) {
  e2.preventDefault();
  e2.stopPropagation();
  e2.cancelBubble = true;
};
function isMiddleOrRightButtonOnMouseUpDown(e2) {
  return e2.which === 2 || e2.which === 3;
}
var GestureMgr = function() {
  function GestureMgr2() {
    this._track = [];
  }
  GestureMgr2.prototype.recognize = function(event, target, root2) {
    this._doTrack(event, target, root2);
    return this._recognize(event);
  };
  GestureMgr2.prototype.clear = function() {
    this._track.length = 0;
    return this;
  };
  GestureMgr2.prototype._doTrack = function(event, target, root2) {
    var touches = event.touches;
    if (!touches) {
      return;
    }
    var trackItem = {
      points: [],
      touches: [],
      target,
      event
    };
    for (var i = 0, len2 = touches.length; i < len2; i++) {
      var touch = touches[i];
      var pos = clientToLocal(root2, touch, {});
      trackItem.points.push([pos.zrX, pos.zrY]);
      trackItem.touches.push(touch);
    }
    this._track.push(trackItem);
  };
  GestureMgr2.prototype._recognize = function(event) {
    for (var eventName in recognizers) {
      if (recognizers.hasOwnProperty(eventName)) {
        var gestureInfo = recognizers[eventName](this._track, event);
        if (gestureInfo) {
          return gestureInfo;
        }
      }
    }
  };
  return GestureMgr2;
}();
function dist(pointPair) {
  var dx = pointPair[1][0] - pointPair[0][0];
  var dy = pointPair[1][1] - pointPair[0][1];
  return Math.sqrt(dx * dx + dy * dy);
}
function center$1(pointPair) {
  return [
    (pointPair[0][0] + pointPair[1][0]) / 2,
    (pointPair[0][1] + pointPair[1][1]) / 2
  ];
}
var recognizers = {
  pinch: function(tracks, event) {
    var trackLen = tracks.length;
    if (!trackLen) {
      return;
    }
    var pinchEnd = (tracks[trackLen - 1] || {}).points;
    var pinchPre = (tracks[trackLen - 2] || {}).points || pinchEnd;
    if (pinchPre && pinchPre.length > 1 && pinchEnd && pinchEnd.length > 1) {
      var pinchScale = dist(pinchEnd) / dist(pinchPre);
      !isFinite(pinchScale) && (pinchScale = 1);
      event.pinchScale = pinchScale;
      var pinchCenter = center$1(pinchEnd);
      event.pinchX = pinchCenter[0];
      event.pinchY = pinchCenter[1];
      return {
        type: "pinch",
        target: tracks[0].target,
        event
      };
    }
  }
};
var SILENT = "silent";
function makeEventPacket(eveType, targetInfo, event) {
  return {
    type: eveType,
    event,
    target: targetInfo.target,
    topTarget: targetInfo.topTarget,
    cancelBubble: false,
    offsetX: event.zrX,
    offsetY: event.zrY,
    gestureEvent: event.gestureEvent,
    pinchX: event.pinchX,
    pinchY: event.pinchY,
    pinchScale: event.pinchScale,
    wheelDelta: event.zrDelta,
    zrByTouch: event.zrByTouch,
    which: event.which,
    stop: stopEvent
  };
}
function stopEvent() {
  stop(this.event);
}
var EmptyProxy = function(_super) {
  __extends(EmptyProxy2, _super);
  function EmptyProxy2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.handler = null;
    return _this;
  }
  EmptyProxy2.prototype.dispose = function() {
  };
  EmptyProxy2.prototype.setCursor = function() {
  };
  return EmptyProxy2;
}(Eventful$1);
var HoveredResult = function() {
  function HoveredResult2(x2, y2) {
    this.x = x2;
    this.y = y2;
  }
  return HoveredResult2;
}();
var handlerNames = [
  "click",
  "dblclick",
  "mousewheel",
  "mouseout",
  "mouseup",
  "mousedown",
  "mousemove",
  "contextmenu"
];
var Handler = function(_super) {
  __extends(Handler2, _super);
  function Handler2(storage2, painter, proxy, painterRoot) {
    var _this = _super.call(this) || this;
    _this._hovered = new HoveredResult(0, 0);
    _this.storage = storage2;
    _this.painter = painter;
    _this.painterRoot = painterRoot;
    proxy = proxy || new EmptyProxy();
    _this.proxy = null;
    _this.setHandlerProxy(proxy);
    _this._draggingMgr = new Draggable$1(_this);
    return _this;
  }
  Handler2.prototype.setHandlerProxy = function(proxy) {
    if (this.proxy) {
      this.proxy.dispose();
    }
    if (proxy) {
      each$g(handlerNames, function(name2) {
        proxy.on && proxy.on(name2, this[name2], this);
      }, this);
      proxy.handler = this;
    }
    this.proxy = proxy;
  };
  Handler2.prototype.mousemove = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var lastHovered = this._hovered;
    var lastHoveredTarget = lastHovered.target;
    if (lastHoveredTarget && !lastHoveredTarget.__zr) {
      lastHovered = this.findHover(lastHovered.x, lastHovered.y);
      lastHoveredTarget = lastHovered.target;
    }
    var hovered = this._hovered = isOutside ? new HoveredResult(x2, y2) : this.findHover(x2, y2);
    var hoveredTarget = hovered.target;
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(hoveredTarget ? hoveredTarget.cursor : "default");
    if (lastHoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(lastHovered, "mouseout", event);
    }
    this.dispatchToElement(hovered, "mousemove", event);
    if (hoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(hovered, "mouseover", event);
    }
  };
  Handler2.prototype.mouseout = function(event) {
    var eventControl = event.zrEventControl;
    if (eventControl !== "only_globalout") {
      this.dispatchToElement(this._hovered, "mouseout", event);
    }
    if (eventControl !== "no_globalout") {
      this.trigger("globalout", { type: "globalout", event });
    }
  };
  Handler2.prototype.resize = function() {
    this._hovered = new HoveredResult(0, 0);
  };
  Handler2.prototype.dispatch = function(eventName, eventArgs) {
    var handler = this[eventName];
    handler && handler.call(this, eventArgs);
  };
  Handler2.prototype.dispose = function() {
    this.proxy.dispose();
    this.storage = null;
    this.proxy = null;
    this.painter = null;
  };
  Handler2.prototype.setCursorStyle = function(cursorStyle) {
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(cursorStyle);
  };
  Handler2.prototype.dispatchToElement = function(targetInfo, eventName, event) {
    targetInfo = targetInfo || {};
    var el = targetInfo.target;
    if (el && el.silent) {
      return;
    }
    var eventKey = "on" + eventName;
    var eventPacket = makeEventPacket(eventName, targetInfo, event);
    while (el) {
      el[eventKey] && (eventPacket.cancelBubble = !!el[eventKey].call(el, eventPacket));
      el.trigger(eventName, eventPacket);
      el = el.__hostTarget ? el.__hostTarget : el.parent;
      if (eventPacket.cancelBubble) {
        break;
      }
    }
    if (!eventPacket.cancelBubble) {
      this.trigger(eventName, eventPacket);
      if (this.painter && this.painter.eachOtherLayer) {
        this.painter.eachOtherLayer(function(layer) {
          if (typeof layer[eventKey] === "function") {
            layer[eventKey].call(layer, eventPacket);
          }
          if (layer.trigger) {
            layer.trigger(eventName, eventPacket);
          }
        });
      }
    }
  };
  Handler2.prototype.findHover = function(x2, y2, exclude) {
    var list = this.storage.getDisplayList();
    var out2 = new HoveredResult(x2, y2);
    for (var i = list.length - 1; i >= 0; i--) {
      var hoverCheckResult = void 0;
      if (list[i] !== exclude && !list[i].ignore && (hoverCheckResult = isHover(list[i], x2, y2))) {
        !out2.topTarget && (out2.topTarget = list[i]);
        if (hoverCheckResult !== SILENT) {
          out2.target = list[i];
          break;
        }
      }
    }
    return out2;
  };
  Handler2.prototype.processGesture = function(event, stage) {
    if (!this._gestureMgr) {
      this._gestureMgr = new GestureMgr();
    }
    var gestureMgr = this._gestureMgr;
    stage === "start" && gestureMgr.clear();
    var gestureInfo = gestureMgr.recognize(event, this.findHover(event.zrX, event.zrY, null).target, this.proxy.dom);
    stage === "end" && gestureMgr.clear();
    if (gestureInfo) {
      var type4 = gestureInfo.type;
      event.gestureEvent = type4;
      var res2 = new HoveredResult();
      res2.target = gestureInfo.target;
      this.dispatchToElement(res2, type4, gestureInfo.event);
    }
  };
  return Handler2;
}(Eventful$1);
each$g(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(name2) {
  Handler.prototype[name2] = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var hovered;
    var hoveredTarget;
    if (name2 !== "mouseup" || !isOutside) {
      hovered = this.findHover(x2, y2);
      hoveredTarget = hovered.target;
    }
    if (name2 === "mousedown") {
      this._downEl = hoveredTarget;
      this._downPoint = [event.zrX, event.zrY];
      this._upEl = hoveredTarget;
    } else if (name2 === "mouseup") {
      this._upEl = hoveredTarget;
    } else if (name2 === "click") {
      if (this._downEl !== this._upEl || !this._downPoint || dist$1(this._downPoint, [event.zrX, event.zrY]) > 4) {
        return;
      }
      this._downPoint = null;
    }
    this.dispatchToElement(hovered, name2, event);
  };
});
function isHover(displayable, x2, y2) {
  if (displayable[displayable.rectHover ? "rectContain" : "contain"](x2, y2)) {
    var el = displayable;
    var isSilent = void 0;
    var ignoreClip = false;
    while (el) {
      if (el.ignoreClip) {
        ignoreClip = true;
      }
      if (!ignoreClip) {
        var clipPath = el.getClipPath();
        if (clipPath && !clipPath.contain(x2, y2)) {
          return false;
        }
        if (el.silent) {
          isSilent = true;
        }
      }
      var hostEl = el.__hostTarget;
      el = hostEl ? hostEl : el.parent;
    }
    return isSilent ? SILENT : true;
  }
  return false;
}
function isOutsideBoundary(handlerInstance, x2, y2) {
  var painter = handlerInstance.painter;
  return x2 < 0 || x2 > painter.getWidth() || y2 < 0 || y2 > painter.getHeight();
}
var Handler$1 = Handler;
var DEFAULT_MIN_MERGE = 32;
var DEFAULT_MIN_GALLOPING = 7;
function minRunLength(n2) {
  var r2 = 0;
  while (n2 >= DEFAULT_MIN_MERGE) {
    r2 |= n2 & 1;
    n2 >>= 1;
  }
  return n2 + r2;
}
function makeAscendingRun(array4, lo, hi2, compare2) {
  var runHi = lo + 1;
  if (runHi === hi2) {
    return 1;
  }
  if (compare2(array4[runHi++], array4[lo]) < 0) {
    while (runHi < hi2 && compare2(array4[runHi], array4[runHi - 1]) < 0) {
      runHi++;
    }
    reverseRun(array4, lo, runHi);
  } else {
    while (runHi < hi2 && compare2(array4[runHi], array4[runHi - 1]) >= 0) {
      runHi++;
    }
  }
  return runHi - lo;
}
function reverseRun(array4, lo, hi2) {
  hi2--;
  while (lo < hi2) {
    var t2 = array4[lo];
    array4[lo++] = array4[hi2];
    array4[hi2--] = t2;
  }
}
function binaryInsertionSort(array4, lo, hi2, start2, compare2) {
  if (start2 === lo) {
    start2++;
  }
  for (; start2 < hi2; start2++) {
    var pivot = array4[start2];
    var left = lo;
    var right = start2;
    var mid;
    while (left < right) {
      mid = left + right >>> 1;
      if (compare2(pivot, array4[mid]) < 0) {
        right = mid;
      } else {
        left = mid + 1;
      }
    }
    var n2 = start2 - left;
    switch (n2) {
      case 3:
        array4[left + 3] = array4[left + 2];
      case 2:
        array4[left + 2] = array4[left + 1];
      case 1:
        array4[left + 1] = array4[left];
        break;
      default:
        while (n2 > 0) {
          array4[left + n2] = array4[left + n2 - 1];
          n2--;
        }
    }
    array4[left] = pivot;
  }
}
function gallopLeft(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset3 = 1;
  if (compare2(value, array4[start2 + hint]) > 0) {
    maxOffset = length - hint;
    while (offset3 < maxOffset && compare2(value, array4[start2 + hint + offset3]) > 0) {
      lastOffset = offset3;
      offset3 = (offset3 << 1) + 1;
      if (offset3 <= 0) {
        offset3 = maxOffset;
      }
    }
    if (offset3 > maxOffset) {
      offset3 = maxOffset;
    }
    lastOffset += hint;
    offset3 += hint;
  } else {
    maxOffset = hint + 1;
    while (offset3 < maxOffset && compare2(value, array4[start2 + hint - offset3]) <= 0) {
      lastOffset = offset3;
      offset3 = (offset3 << 1) + 1;
      if (offset3 <= 0) {
        offset3 = maxOffset;
      }
    }
    if (offset3 > maxOffset) {
      offset3 = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset3;
    offset3 = hint - tmp;
  }
  lastOffset++;
  while (lastOffset < offset3) {
    var m2 = lastOffset + (offset3 - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) > 0) {
      lastOffset = m2 + 1;
    } else {
      offset3 = m2;
    }
  }
  return offset3;
}
function gallopRight(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset3 = 1;
  if (compare2(value, array4[start2 + hint]) < 0) {
    maxOffset = hint + 1;
    while (offset3 < maxOffset && compare2(value, array4[start2 + hint - offset3]) < 0) {
      lastOffset = offset3;
      offset3 = (offset3 << 1) + 1;
      if (offset3 <= 0) {
        offset3 = maxOffset;
      }
    }
    if (offset3 > maxOffset) {
      offset3 = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset3;
    offset3 = hint - tmp;
  } else {
    maxOffset = length - hint;
    while (offset3 < maxOffset && compare2(value, array4[start2 + hint + offset3]) >= 0) {
      lastOffset = offset3;
      offset3 = (offset3 << 1) + 1;
      if (offset3 <= 0) {
        offset3 = maxOffset;
      }
    }
    if (offset3 > maxOffset) {
      offset3 = maxOffset;
    }
    lastOffset += hint;
    offset3 += hint;
  }
  lastOffset++;
  while (lastOffset < offset3) {
    var m2 = lastOffset + (offset3 - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) < 0) {
      offset3 = m2;
    } else {
      lastOffset = m2 + 1;
    }
  }
  return offset3;
}
function TimSort(array4, compare2) {
  var minGallop = DEFAULT_MIN_GALLOPING;
  var runStart;
  var runLength;
  var stackSize = 0;
  var tmp = [];
  runStart = [];
  runLength = [];
  function pushRun(_runStart, _runLength) {
    runStart[stackSize] = _runStart;
    runLength[stackSize] = _runLength;
    stackSize += 1;
  }
  function mergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 >= 1 && runLength[n2 - 1] <= runLength[n2] + runLength[n2 + 1] || n2 >= 2 && runLength[n2 - 2] <= runLength[n2] + runLength[n2 - 1]) {
        if (runLength[n2 - 1] < runLength[n2 + 1]) {
          n2--;
        }
      } else if (runLength[n2] > runLength[n2 + 1]) {
        break;
      }
      mergeAt(n2);
    }
  }
  function forceMergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 > 0 && runLength[n2 - 1] < runLength[n2 + 1]) {
        n2--;
      }
      mergeAt(n2);
    }
  }
  function mergeAt(i) {
    var start1 = runStart[i];
    var length1 = runLength[i];
    var start2 = runStart[i + 1];
    var length2 = runLength[i + 1];
    runLength[i] = length1 + length2;
    if (i === stackSize - 3) {
      runStart[i + 1] = runStart[i + 2];
      runLength[i + 1] = runLength[i + 2];
    }
    stackSize--;
    var k2 = gallopRight(array4[start2], array4, start1, length1, 0, compare2);
    start1 += k2;
    length1 -= k2;
    if (length1 === 0) {
      return;
    }
    length2 = gallopLeft(array4[start1 + length1 - 1], array4, start2, length2, length2 - 1, compare2);
    if (length2 === 0) {
      return;
    }
    if (length1 <= length2) {
      mergeLow(start1, length1, start2, length2);
    } else {
      mergeHigh(start1, length1, start2, length2);
    }
  }
  function mergeLow(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length1; i++) {
      tmp[i] = array4[start1 + i];
    }
    var cursor1 = 0;
    var cursor2 = start2;
    var dest = start1;
    array4[dest++] = array4[cursor2++];
    if (--length2 === 0) {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
      return;
    }
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
      return;
    }
    var _minGallop = minGallop;
    var count1;
    var count2;
    var exit;
    while (1) {
      count1 = 0;
      count2 = 0;
      exit = false;
      do {
        if (compare2(array4[cursor2], tmp[cursor1]) < 0) {
          array4[dest++] = array4[cursor2++];
          count2++;
          count1 = 0;
          if (--length2 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest++] = tmp[cursor1++];
          count1++;
          count2 = 0;
          if (--length1 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = gallopRight(array4[cursor2], tmp, cursor1, length1, 0, compare2);
        if (count1 !== 0) {
          for (i = 0; i < count1; i++) {
            array4[dest + i] = tmp[cursor1 + i];
          }
          dest += count1;
          cursor1 += count1;
          length1 -= count1;
          if (length1 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest++] = array4[cursor2++];
        if (--length2 === 0) {
          exit = true;
          break;
        }
        count2 = gallopLeft(tmp[cursor1], array4, cursor2, length2, 0, compare2);
        if (count2 !== 0) {
          for (i = 0; i < count2; i++) {
            array4[dest + i] = array4[cursor2 + i];
          }
          dest += count2;
          cursor2 += count2;
          length2 -= count2;
          if (length2 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest++] = tmp[cursor1++];
        if (--length1 === 1) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    minGallop < 1 && (minGallop = 1);
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
    } else if (length1 === 0) {
      throw new Error();
    } else {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
    }
  }
  function mergeHigh(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length2; i++) {
      tmp[i] = array4[start2 + i];
    }
    var cursor1 = start1 + length1 - 1;
    var cursor2 = length2 - 1;
    var dest = start2 + length2 - 1;
    var customCursor = 0;
    var customDest = 0;
    array4[dest--] = array4[cursor1--];
    if (--length1 === 0) {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
      return;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
      return;
    }
    var _minGallop = minGallop;
    while (true) {
      var count1 = 0;
      var count2 = 0;
      var exit = false;
      do {
        if (compare2(tmp[cursor2], array4[cursor1]) < 0) {
          array4[dest--] = array4[cursor1--];
          count1++;
          count2 = 0;
          if (--length1 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest--] = tmp[cursor2--];
          count2++;
          count1 = 0;
          if (--length2 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = length1 - gallopRight(tmp[cursor2], array4, start1, length1, length1 - 1, compare2);
        if (count1 !== 0) {
          dest -= count1;
          cursor1 -= count1;
          length1 -= count1;
          customDest = dest + 1;
          customCursor = cursor1 + 1;
          for (i = count1 - 1; i >= 0; i--) {
            array4[customDest + i] = array4[customCursor + i];
          }
          if (length1 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest--] = tmp[cursor2--];
        if (--length2 === 1) {
          exit = true;
          break;
        }
        count2 = length2 - gallopLeft(array4[cursor1], tmp, 0, length2, length2 - 1, compare2);
        if (count2 !== 0) {
          dest -= count2;
          cursor2 -= count2;
          length2 -= count2;
          customDest = dest + 1;
          customCursor = cursor2 + 1;
          for (i = 0; i < count2; i++) {
            array4[customDest + i] = tmp[customCursor + i];
          }
          if (length2 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest--] = array4[cursor1--];
        if (--length1 === 0) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    if (minGallop < 1) {
      minGallop = 1;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
    } else if (length2 === 0) {
      throw new Error();
    } else {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
    }
  }
  return {
    mergeRuns,
    forceMergeRuns,
    pushRun
  };
}
function sort$2(array4, compare2, lo, hi2) {
  if (!lo) {
    lo = 0;
  }
  if (!hi2) {
    hi2 = array4.length;
  }
  var remaining = hi2 - lo;
  if (remaining < 2) {
    return;
  }
  var runLength = 0;
  if (remaining < DEFAULT_MIN_MERGE) {
    runLength = makeAscendingRun(array4, lo, hi2, compare2);
    binaryInsertionSort(array4, lo, hi2, lo + runLength, compare2);
    return;
  }
  var ts = TimSort(array4, compare2);
  var minRun = minRunLength(remaining);
  do {
    runLength = makeAscendingRun(array4, lo, hi2, compare2);
    if (runLength < minRun) {
      var force = remaining;
      if (force > minRun) {
        force = minRun;
      }
      binaryInsertionSort(array4, lo, lo + force, lo + runLength, compare2);
      runLength = force;
    }
    ts.pushRun(lo, runLength);
    ts.mergeRuns();
    remaining -= runLength;
    lo += runLength;
  } while (remaining !== 0);
  ts.forceMergeRuns();
}
var REDRAW_BIT = 1;
var STYLE_CHANGED_BIT = 2;
var SHAPE_CHANGED_BIT = 4;
var invalidZErrorLogged = false;
function logInvalidZError() {
  if (invalidZErrorLogged) {
    return;
  }
  invalidZErrorLogged = true;
  console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors");
}
function shapeCompareFunc(a, b2) {
  if (a.zlevel === b2.zlevel) {
    if (a.z === b2.z) {
      return a.z2 - b2.z2;
    }
    return a.z - b2.z;
  }
  return a.zlevel - b2.zlevel;
}
var Storage = function() {
  function Storage2() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    this.displayableSortFunc = shapeCompareFunc;
  }
  Storage2.prototype.traverse = function(cb2, context) {
    for (var i = 0; i < this._roots.length; i++) {
      this._roots[i].traverse(cb2, context);
    }
  };
  Storage2.prototype.getDisplayList = function(update, includeIgnore) {
    includeIgnore = includeIgnore || false;
    var displayList = this._displayList;
    if (update || !displayList.length) {
      this.updateDisplayList(includeIgnore);
    }
    return displayList;
  };
  Storage2.prototype.updateDisplayList = function(includeIgnore) {
    this._displayListLen = 0;
    var roots2 = this._roots;
    var displayList = this._displayList;
    for (var i = 0, len2 = roots2.length; i < len2; i++) {
      this._updateAndAddDisplayable(roots2[i], null, includeIgnore);
    }
    displayList.length = this._displayListLen;
    sort$2(displayList, shapeCompareFunc);
  };
  Storage2.prototype._updateAndAddDisplayable = function(el, clipPaths, includeIgnore) {
    if (el.ignore && !includeIgnore) {
      return;
    }
    el.beforeUpdate();
    el.update();
    el.afterUpdate();
    var userSetClipPath = el.getClipPath();
    if (el.ignoreClip) {
      clipPaths = null;
    } else if (userSetClipPath) {
      if (clipPaths) {
        clipPaths = clipPaths.slice();
      } else {
        clipPaths = [];
      }
      var currentClipPath = userSetClipPath;
      var parentClipPath = el;
      while (currentClipPath) {
        currentClipPath.parent = parentClipPath;
        currentClipPath.updateTransform();
        clipPaths.push(currentClipPath);
        parentClipPath = currentClipPath;
        currentClipPath = currentClipPath.getClipPath();
      }
    }
    if (el.childrenRef) {
      var children = el.childrenRef();
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (el.__dirty) {
          child.__dirty |= REDRAW_BIT;
        }
        this._updateAndAddDisplayable(child, clipPaths, includeIgnore);
      }
      el.__dirty = 0;
    } else {
      var disp = el;
      if (clipPaths && clipPaths.length) {
        disp.__clipPaths = clipPaths;
      } else if (disp.__clipPaths && disp.__clipPaths.length > 0) {
        disp.__clipPaths = [];
      }
      if (isNaN(disp.z)) {
        logInvalidZError();
        disp.z = 0;
      }
      if (isNaN(disp.z2)) {
        logInvalidZError();
        disp.z2 = 0;
      }
      if (isNaN(disp.zlevel)) {
        logInvalidZError();
        disp.zlevel = 0;
      }
      this._displayList[this._displayListLen++] = disp;
    }
    var decalEl = el.getDecalElement && el.getDecalElement();
    if (decalEl) {
      this._updateAndAddDisplayable(decalEl, clipPaths, includeIgnore);
    }
    var textGuide = el.getTextGuideLine();
    if (textGuide) {
      this._updateAndAddDisplayable(textGuide, clipPaths, includeIgnore);
    }
    var textEl = el.getTextContent();
    if (textEl) {
      this._updateAndAddDisplayable(textEl, clipPaths, includeIgnore);
    }
  };
  Storage2.prototype.addRoot = function(el) {
    if (el.__zr && el.__zr.storage === this) {
      return;
    }
    this._roots.push(el);
  };
  Storage2.prototype.delRoot = function(el) {
    if (el instanceof Array) {
      for (var i = 0, l2 = el.length; i < l2; i++) {
        this.delRoot(el[i]);
      }
      return;
    }
    var idx = indexOf(this._roots, el);
    if (idx >= 0) {
      this._roots.splice(idx, 1);
    }
  };
  Storage2.prototype.delAllRoots = function() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    return;
  };
  Storage2.prototype.getRoots = function() {
    return this._roots;
  };
  Storage2.prototype.dispose = function() {
    this._displayList = null;
    this._roots = null;
  };
  return Storage2;
}();
var Storage$1 = Storage;
var requestAnimationFrame$1;
requestAnimationFrame$1 = env$1.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(func) {
  return setTimeout(func, 16);
};
var requestAnimationFrame$2 = requestAnimationFrame$1;
var easingFuncs = {
  linear: function(k2) {
    return k2;
  },
  quadraticIn: function(k2) {
    return k2 * k2;
  },
  quadraticOut: function(k2) {
    return k2 * (2 - k2);
  },
  quadraticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2;
    }
    return -0.5 * (--k2 * (k2 - 2) - 1);
  },
  cubicIn: function(k2) {
    return k2 * k2 * k2;
  },
  cubicOut: function(k2) {
    return --k2 * k2 * k2 + 1;
  },
  cubicInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 + 2);
  },
  quarticIn: function(k2) {
    return k2 * k2 * k2 * k2;
  },
  quarticOut: function(k2) {
    return 1 - --k2 * k2 * k2 * k2;
  },
  quarticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2;
    }
    return -0.5 * ((k2 -= 2) * k2 * k2 * k2 - 2);
  },
  quinticIn: function(k2) {
    return k2 * k2 * k2 * k2 * k2;
  },
  quinticOut: function(k2) {
    return --k2 * k2 * k2 * k2 * k2 + 1;
  },
  quinticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 * k2 * k2 + 2);
  },
  sinusoidalIn: function(k2) {
    return 1 - Math.cos(k2 * Math.PI / 2);
  },
  sinusoidalOut: function(k2) {
    return Math.sin(k2 * Math.PI / 2);
  },
  sinusoidalInOut: function(k2) {
    return 0.5 * (1 - Math.cos(Math.PI * k2));
  },
  exponentialIn: function(k2) {
    return k2 === 0 ? 0 : Math.pow(1024, k2 - 1);
  },
  exponentialOut: function(k2) {
    return k2 === 1 ? 1 : 1 - Math.pow(2, -10 * k2);
  },
  exponentialInOut: function(k2) {
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if ((k2 *= 2) < 1) {
      return 0.5 * Math.pow(1024, k2 - 1);
    }
    return 0.5 * (-Math.pow(2, -10 * (k2 - 1)) + 2);
  },
  circularIn: function(k2) {
    return 1 - Math.sqrt(1 - k2 * k2);
  },
  circularOut: function(k2) {
    return Math.sqrt(1 - --k2 * k2);
  },
  circularInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return -0.5 * (Math.sqrt(1 - k2 * k2) - 1);
    }
    return 0.5 * (Math.sqrt(1 - (k2 -= 2) * k2) + 1);
  },
  elasticIn: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return -(a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
  },
  elasticOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return a * Math.pow(2, -10 * k2) * Math.sin((k2 - s) * (2 * Math.PI) / p2) + 1;
  },
  elasticInOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    if ((k2 *= 2) < 1) {
      return -0.5 * (a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
    }
    return a * Math.pow(2, -10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2) * 0.5 + 1;
  },
  backIn: function(k2) {
    var s = 1.70158;
    return k2 * k2 * ((s + 1) * k2 - s);
  },
  backOut: function(k2) {
    var s = 1.70158;
    return --k2 * k2 * ((s + 1) * k2 + s) + 1;
  },
  backInOut: function(k2) {
    var s = 1.70158 * 1.525;
    if ((k2 *= 2) < 1) {
      return 0.5 * (k2 * k2 * ((s + 1) * k2 - s));
    }
    return 0.5 * ((k2 -= 2) * k2 * ((s + 1) * k2 + s) + 2);
  },
  bounceIn: function(k2) {
    return 1 - easingFuncs.bounceOut(1 - k2);
  },
  bounceOut: function(k2) {
    if (k2 < 1 / 2.75) {
      return 7.5625 * k2 * k2;
    } else if (k2 < 2 / 2.75) {
      return 7.5625 * (k2 -= 1.5 / 2.75) * k2 + 0.75;
    } else if (k2 < 2.5 / 2.75) {
      return 7.5625 * (k2 -= 2.25 / 2.75) * k2 + 0.9375;
    } else {
      return 7.5625 * (k2 -= 2.625 / 2.75) * k2 + 0.984375;
    }
  },
  bounceInOut: function(k2) {
    if (k2 < 0.5) {
      return easingFuncs.bounceIn(k2 * 2) * 0.5;
    }
    return easingFuncs.bounceOut(k2 * 2 - 1) * 0.5 + 0.5;
  }
};
var easingFuncs$1 = easingFuncs;
var mathPow$2 = Math.pow;
var mathSqrt$3 = Math.sqrt;
var EPSILON$4 = 1e-8;
var EPSILON_NUMERIC = 1e-4;
var THREE_SQRT = mathSqrt$3(3);
var ONE_THIRD = 1 / 3;
var _v0 = create$3();
var _v1 = create$3();
var _v2 = create$3();
function isAroundZero$1(val) {
  return val > -EPSILON$4 && val < EPSILON$4;
}
function isNotAroundZero$1(val) {
  return val > EPSILON$4 || val < -EPSILON$4;
}
function cubicAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return onet * onet * (onet * p0 + 3 * t2 * p1) + t2 * t2 * (t2 * p3 + 3 * onet * p2);
}
function cubicDerivativeAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return 3 * (((p1 - p0) * onet + 2 * (p2 - p1) * t2) * onet + (p3 - p2) * t2 * t2);
}
function cubicRootAt(p0, p1, p2, p3, val, roots2) {
  var a = p3 + 3 * (p1 - p2) - p0;
  var b2 = 3 * (p2 - p1 * 2 + p0);
  var c2 = 3 * (p1 - p0);
  var d2 = p0 - val;
  var A2 = b2 * b2 - 3 * a * c2;
  var B2 = b2 * c2 - 9 * a * d2;
  var C = c2 * c2 - 3 * b2 * d2;
  var n2 = 0;
  if (isAroundZero$1(A2) && isAroundZero$1(B2)) {
    if (isAroundZero$1(b2)) {
      roots2[0] = 0;
    } else {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = B2 * B2 - 4 * A2 * C;
    if (isAroundZero$1(disc)) {
      var K = B2 / A2;
      var t1 = -b2 / a + K;
      var t2 = -K / 2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var Y1 = A2 * b2 + 1.5 * a * (-B2 + discSqrt);
      var Y2 = A2 * b2 + 1.5 * a * (-B2 - discSqrt);
      if (Y1 < 0) {
        Y1 = -mathPow$2(-Y1, ONE_THIRD);
      } else {
        Y1 = mathPow$2(Y1, ONE_THIRD);
      }
      if (Y2 < 0) {
        Y2 = -mathPow$2(-Y2, ONE_THIRD);
      } else {
        Y2 = mathPow$2(Y2, ONE_THIRD);
      }
      var t1 = (-b2 - (Y1 + Y2)) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else {
      var T2 = (2 * A2 * b2 - 3 * a * B2) / (2 * mathSqrt$3(A2 * A2 * A2));
      var theta = Math.acos(T2) / 3;
      var ASqrt = mathSqrt$3(A2);
      var tmp = Math.cos(theta);
      var t1 = (-b2 - 2 * ASqrt * tmp) / (3 * a);
      var t2 = (-b2 + ASqrt * (tmp + THREE_SQRT * Math.sin(theta))) / (3 * a);
      var t3 = (-b2 + ASqrt * (tmp - THREE_SQRT * Math.sin(theta))) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
      if (t3 >= 0 && t3 <= 1) {
        roots2[n2++] = t3;
      }
    }
  }
  return n2;
}
function cubicExtrema(p0, p1, p2, p3, extrema2) {
  var b2 = 6 * p2 - 12 * p1 + 6 * p0;
  var a = 9 * p1 + 3 * p3 - 3 * p0 - 9 * p2;
  var c2 = 3 * p1 - 3 * p0;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      extrema2[0] = -b2 / (2 * a);
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        extrema2[n2++] = t2;
      }
    }
  }
  return n2;
}
function cubicSubdivide(p0, p1, p2, p3, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p23 = (p3 - p2) * t2 + p2;
  var p012 = (p12 - p01) * t2 + p01;
  var p123 = (p23 - p12) * t2 + p12;
  var p0123 = (p123 - p012) * t2 + p012;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p0123;
  out2[4] = p0123;
  out2[5] = p123;
  out2[6] = p23;
  out2[7] = p3;
}
function cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  var prev;
  var next;
  var d1;
  var d22;
  _v0[0] = x4;
  _v0[1] = y4;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = cubicAt(x0, x1, x2, x3, _t);
    _v1[1] = cubicAt(y0, y1, y2, y3, _t);
    d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    prev = t2 - interval;
    next = t2 + interval;
    _v1[0] = cubicAt(x0, x1, x2, x3, prev);
    _v1[1] = cubicAt(y0, y1, y2, y3, prev);
    d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = cubicAt(x0, x1, x2, x3, next);
      _v2[1] = cubicAt(y0, y1, y2, y3, next);
      d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = cubicAt(x0, x1, x2, x3, t2);
    out2[1] = cubicAt(y0, y1, y2, y3, t2);
  }
  return mathSqrt$3(d2);
}
function cubicLength(x0, y0, x1, y1, x2, y2, x3, y3, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x4 = cubicAt(x0, x1, x2, x3, t2);
    var y4 = cubicAt(y0, y1, y2, y3, t2);
    var dx = x4 - px;
    var dy = y4 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x4;
    py = y4;
  }
  return d2;
}
function quadraticAt$1(p0, p1, p2, t2) {
  var onet = 1 - t2;
  return onet * (onet * p0 + 2 * t2 * p1) + t2 * t2 * p2;
}
function quadraticDerivativeAt(p0, p1, p2, t2) {
  return 2 * ((1 - t2) * (p1 - p0) + t2 * (p2 - p1));
}
function quadraticRootAt(p0, p1, p2, val, roots2) {
  var a = p0 - 2 * p1 + p2;
  var b2 = 2 * (p1 - p0);
  var c2 = p0 - val;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      var t1 = -b2 / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    }
  }
  return n2;
}
function quadraticExtremum(p0, p1, p2) {
  var divider = p0 + p2 - 2 * p1;
  if (divider === 0) {
    return 0.5;
  } else {
    return (p0 - p1) / divider;
  }
}
function quadraticSubdivide(p0, p1, p2, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p012 = (p12 - p01) * t2 + p01;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p012;
  out2[4] = p12;
  out2[5] = p2;
}
function quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  _v0[0] = x3;
  _v0[1] = y3;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = quadraticAt$1(x0, x1, x2, _t);
    _v1[1] = quadraticAt$1(y0, y1, y2, _t);
    var d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    var prev = t2 - interval;
    var next = t2 + interval;
    _v1[0] = quadraticAt$1(x0, x1, x2, prev);
    _v1[1] = quadraticAt$1(y0, y1, y2, prev);
    var d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = quadraticAt$1(x0, x1, x2, next);
      _v2[1] = quadraticAt$1(y0, y1, y2, next);
      var d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = quadraticAt$1(x0, x1, x2, t2);
    out2[1] = quadraticAt$1(y0, y1, y2, t2);
  }
  return mathSqrt$3(d2);
}
function quadraticLength(x0, y0, x1, y1, x2, y2, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x3 = quadraticAt$1(x0, x1, x2, t2);
    var y3 = quadraticAt$1(y0, y1, y2, t2);
    var dx = x3 - px;
    var dy = y3 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x3;
    py = y3;
  }
  return d2;
}
var regexp$1 = /cubic-bezier\(([0-9,\.e ]+)\)/;
function createCubicEasingFunc(cubicEasingStr) {
  var cubic = cubicEasingStr && regexp$1.exec(cubicEasingStr);
  if (cubic) {
    var points2 = cubic[1].split(",");
    var a_1 = +trim$1(points2[0]);
    var b_1 = +trim$1(points2[1]);
    var c_1 = +trim$1(points2[2]);
    var d_1 = +trim$1(points2[3]);
    if (isNaN(a_1 + b_1 + c_1 + d_1)) {
      return;
    }
    var roots_1 = [];
    return function(p2) {
      return p2 <= 0 ? 0 : p2 >= 1 ? 1 : cubicRootAt(0, a_1, c_1, 1, p2, roots_1) && cubicAt(0, b_1, d_1, 1, roots_1[0]);
    };
  }
}
var Clip = function() {
  function Clip2(opts) {
    this._inited = false;
    this._startTime = 0;
    this._pausedTime = 0;
    this._paused = false;
    this._life = opts.life || 1e3;
    this._delay = opts.delay || 0;
    this.loop = opts.loop || false;
    this.onframe = opts.onframe || noop$1;
    this.ondestroy = opts.ondestroy || noop$1;
    this.onrestart = opts.onrestart || noop$1;
    opts.easing && this.setEasing(opts.easing);
  }
  Clip2.prototype.step = function(globalTime, deltaTime) {
    if (!this._inited) {
      this._startTime = globalTime + this._delay;
      this._inited = true;
    }
    if (this._paused) {
      this._pausedTime += deltaTime;
      return;
    }
    var life = this._life;
    var elapsedTime = globalTime - this._startTime - this._pausedTime;
    var percent = elapsedTime / life;
    if (percent < 0) {
      percent = 0;
    }
    percent = Math.min(percent, 1);
    var easingFunc = this.easingFunc;
    var schedule = easingFunc ? easingFunc(percent) : percent;
    this.onframe(schedule);
    if (percent === 1) {
      if (this.loop) {
        var remainder = elapsedTime % life;
        this._startTime = globalTime - remainder;
        this._pausedTime = 0;
        this.onrestart();
      } else {
        return true;
      }
    }
    return false;
  };
  Clip2.prototype.pause = function() {
    this._paused = true;
  };
  Clip2.prototype.resume = function() {
    this._paused = false;
  };
  Clip2.prototype.setEasing = function(easing) {
    this.easing = easing;
    this.easingFunc = isFunction$1(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
  };
  return Clip2;
}();
var Clip$1 = Clip;
var Entry = function() {
  function Entry2(val) {
    this.value = val;
  }
  return Entry2;
}();
var LinkedList = function() {
  function LinkedList2() {
    this._len = 0;
  }
  LinkedList2.prototype.insert = function(val) {
    var entry = new Entry(val);
    this.insertEntry(entry);
    return entry;
  };
  LinkedList2.prototype.insertEntry = function(entry) {
    if (!this.head) {
      this.head = this.tail = entry;
    } else {
      this.tail.next = entry;
      entry.prev = this.tail;
      entry.next = null;
      this.tail = entry;
    }
    this._len++;
  };
  LinkedList2.prototype.remove = function(entry) {
    var prev = entry.prev;
    var next = entry.next;
    if (prev) {
      prev.next = next;
    } else {
      this.head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this.tail = prev;
    }
    entry.next = entry.prev = null;
    this._len--;
  };
  LinkedList2.prototype.len = function() {
    return this._len;
  };
  LinkedList2.prototype.clear = function() {
    this.head = this.tail = null;
    this._len = 0;
  };
  return LinkedList2;
}();
var LRU = function() {
  function LRU2(maxSize) {
    this._list = new LinkedList();
    this._maxSize = 10;
    this._map = {};
    this._maxSize = maxSize;
  }
  LRU2.prototype.put = function(key, value) {
    var list = this._list;
    var map2 = this._map;
    var removed = null;
    if (map2[key] == null) {
      var len2 = list.len();
      var entry = this._lastRemovedEntry;
      if (len2 >= this._maxSize && len2 > 0) {
        var leastUsedEntry = list.head;
        list.remove(leastUsedEntry);
        delete map2[leastUsedEntry.key];
        removed = leastUsedEntry.value;
        this._lastRemovedEntry = leastUsedEntry;
      }
      if (entry) {
        entry.value = value;
      } else {
        entry = new Entry(value);
      }
      entry.key = key;
      list.insertEntry(entry);
      map2[key] = entry;
    }
    return removed;
  };
  LRU2.prototype.get = function(key) {
    var entry = this._map[key];
    var list = this._list;
    if (entry != null) {
      if (entry !== list.tail) {
        list.remove(entry);
        list.insertEntry(entry);
      }
      return entry.value;
    }
  };
  LRU2.prototype.clear = function() {
    this._list.clear();
    this._map = {};
  };
  LRU2.prototype.len = function() {
    return this._list.len();
  };
  return LRU2;
}();
var LRU$1 = LRU;
var kCSSColorTable = {
  "transparent": [0, 0, 0, 0],
  "aliceblue": [240, 248, 255, 1],
  "antiquewhite": [250, 235, 215, 1],
  "aqua": [0, 255, 255, 1],
  "aquamarine": [127, 255, 212, 1],
  "azure": [240, 255, 255, 1],
  "beige": [245, 245, 220, 1],
  "bisque": [255, 228, 196, 1],
  "black": [0, 0, 0, 1],
  "blanchedalmond": [255, 235, 205, 1],
  "blue": [0, 0, 255, 1],
  "blueviolet": [138, 43, 226, 1],
  "brown": [165, 42, 42, 1],
  "burlywood": [222, 184, 135, 1],
  "cadetblue": [95, 158, 160, 1],
  "chartreuse": [127, 255, 0, 1],
  "chocolate": [210, 105, 30, 1],
  "coral": [255, 127, 80, 1],
  "cornflowerblue": [100, 149, 237, 1],
  "cornsilk": [255, 248, 220, 1],
  "crimson": [220, 20, 60, 1],
  "cyan": [0, 255, 255, 1],
  "darkblue": [0, 0, 139, 1],
  "darkcyan": [0, 139, 139, 1],
  "darkgoldenrod": [184, 134, 11, 1],
  "darkgray": [169, 169, 169, 1],
  "darkgreen": [0, 100, 0, 1],
  "darkgrey": [169, 169, 169, 1],
  "darkkhaki": [189, 183, 107, 1],
  "darkmagenta": [139, 0, 139, 1],
  "darkolivegreen": [85, 107, 47, 1],
  "darkorange": [255, 140, 0, 1],
  "darkorchid": [153, 50, 204, 1],
  "darkred": [139, 0, 0, 1],
  "darksalmon": [233, 150, 122, 1],
  "darkseagreen": [143, 188, 143, 1],
  "darkslateblue": [72, 61, 139, 1],
  "darkslategray": [47, 79, 79, 1],
  "darkslategrey": [47, 79, 79, 1],
  "darkturquoise": [0, 206, 209, 1],
  "darkviolet": [148, 0, 211, 1],
  "deeppink": [255, 20, 147, 1],
  "deepskyblue": [0, 191, 255, 1],
  "dimgray": [105, 105, 105, 1],
  "dimgrey": [105, 105, 105, 1],
  "dodgerblue": [30, 144, 255, 1],
  "firebrick": [178, 34, 34, 1],
  "floralwhite": [255, 250, 240, 1],
  "forestgreen": [34, 139, 34, 1],
  "fuchsia": [255, 0, 255, 1],
  "gainsboro": [220, 220, 220, 1],
  "ghostwhite": [248, 248, 255, 1],
  "gold": [255, 215, 0, 1],
  "goldenrod": [218, 165, 32, 1],
  "gray": [128, 128, 128, 1],
  "green": [0, 128, 0, 1],
  "greenyellow": [173, 255, 47, 1],
  "grey": [128, 128, 128, 1],
  "honeydew": [240, 255, 240, 1],
  "hotpink": [255, 105, 180, 1],
  "indianred": [205, 92, 92, 1],
  "indigo": [75, 0, 130, 1],
  "ivory": [255, 255, 240, 1],
  "khaki": [240, 230, 140, 1],
  "lavender": [230, 230, 250, 1],
  "lavenderblush": [255, 240, 245, 1],
  "lawngreen": [124, 252, 0, 1],
  "lemonchiffon": [255, 250, 205, 1],
  "lightblue": [173, 216, 230, 1],
  "lightcoral": [240, 128, 128, 1],
  "lightcyan": [224, 255, 255, 1],
  "lightgoldenrodyellow": [250, 250, 210, 1],
  "lightgray": [211, 211, 211, 1],
  "lightgreen": [144, 238, 144, 1],
  "lightgrey": [211, 211, 211, 1],
  "lightpink": [255, 182, 193, 1],
  "lightsalmon": [255, 160, 122, 1],
  "lightseagreen": [32, 178, 170, 1],
  "lightskyblue": [135, 206, 250, 1],
  "lightslategray": [119, 136, 153, 1],
  "lightslategrey": [119, 136, 153, 1],
  "lightsteelblue": [176, 196, 222, 1],
  "lightyellow": [255, 255, 224, 1],
  "lime": [0, 255, 0, 1],
  "limegreen": [50, 205, 50, 1],
  "linen": [250, 240, 230, 1],
  "magenta": [255, 0, 255, 1],
  "maroon": [128, 0, 0, 1],
  "mediumaquamarine": [102, 205, 170, 1],
  "mediumblue": [0, 0, 205, 1],
  "mediumorchid": [186, 85, 211, 1],
  "mediumpurple": [147, 112, 219, 1],
  "mediumseagreen": [60, 179, 113, 1],
  "mediumslateblue": [123, 104, 238, 1],
  "mediumspringgreen": [0, 250, 154, 1],
  "mediumturquoise": [72, 209, 204, 1],
  "mediumvioletred": [199, 21, 133, 1],
  "midnightblue": [25, 25, 112, 1],
  "mintcream": [245, 255, 250, 1],
  "mistyrose": [255, 228, 225, 1],
  "moccasin": [255, 228, 181, 1],
  "navajowhite": [255, 222, 173, 1],
  "navy": [0, 0, 128, 1],
  "oldlace": [253, 245, 230, 1],
  "olive": [128, 128, 0, 1],
  "olivedrab": [107, 142, 35, 1],
  "orange": [255, 165, 0, 1],
  "orangered": [255, 69, 0, 1],
  "orchid": [218, 112, 214, 1],
  "palegoldenrod": [238, 232, 170, 1],
  "palegreen": [152, 251, 152, 1],
  "paleturquoise": [175, 238, 238, 1],
  "palevioletred": [219, 112, 147, 1],
  "papayawhip": [255, 239, 213, 1],
  "peachpuff": [255, 218, 185, 1],
  "peru": [205, 133, 63, 1],
  "pink": [255, 192, 203, 1],
  "plum": [221, 160, 221, 1],
  "powderblue": [176, 224, 230, 1],
  "purple": [128, 0, 128, 1],
  "red": [255, 0, 0, 1],
  "rosybrown": [188, 143, 143, 1],
  "royalblue": [65, 105, 225, 1],
  "saddlebrown": [139, 69, 19, 1],
  "salmon": [250, 128, 114, 1],
  "sandybrown": [244, 164, 96, 1],
  "seagreen": [46, 139, 87, 1],
  "seashell": [255, 245, 238, 1],
  "sienna": [160, 82, 45, 1],
  "silver": [192, 192, 192, 1],
  "skyblue": [135, 206, 235, 1],
  "slateblue": [106, 90, 205, 1],
  "slategray": [112, 128, 144, 1],
  "slategrey": [112, 128, 144, 1],
  "snow": [255, 250, 250, 1],
  "springgreen": [0, 255, 127, 1],
  "steelblue": [70, 130, 180, 1],
  "tan": [210, 180, 140, 1],
  "teal": [0, 128, 128, 1],
  "thistle": [216, 191, 216, 1],
  "tomato": [255, 99, 71, 1],
  "turquoise": [64, 224, 208, 1],
  "violet": [238, 130, 238, 1],
  "wheat": [245, 222, 179, 1],
  "white": [255, 255, 255, 1],
  "whitesmoke": [245, 245, 245, 1],
  "yellow": [255, 255, 0, 1],
  "yellowgreen": [154, 205, 50, 1]
};
function clampCssByte(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 255 ? 255 : i;
}
function clampCssAngle(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 360 ? 360 : i;
}
function clampCssFloat(f2) {
  return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
}
function parseCssInt(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssByte(parseFloat(str) / 100 * 255);
  }
  return clampCssByte(parseInt(str, 10));
}
function parseCssFloat(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssFloat(parseFloat(str) / 100);
  }
  return clampCssFloat(parseFloat(str));
}
function cssHueToRgb(m1, m2, h) {
  if (h < 0) {
    h += 1;
  } else if (h > 1) {
    h -= 1;
  }
  if (h * 6 < 1) {
    return m1 + (m2 - m1) * h * 6;
  }
  if (h * 2 < 1) {
    return m2;
  }
  if (h * 3 < 2) {
    return m1 + (m2 - m1) * (2 / 3 - h) * 6;
  }
  return m1;
}
function lerpNumber(a, b2, p2) {
  return a + (b2 - a) * p2;
}
function setRgba(out2, r2, g2, b2, a) {
  out2[0] = r2;
  out2[1] = g2;
  out2[2] = b2;
  out2[3] = a;
  return out2;
}
function copyRgba(out2, a) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  return out2;
}
var colorCache = new LRU$1(20);
var lastRemovedArr = null;
function putToCache(colorStr, rgbaArr) {
  if (lastRemovedArr) {
    copyRgba(lastRemovedArr, rgbaArr);
  }
  lastRemovedArr = colorCache.put(colorStr, lastRemovedArr || rgbaArr.slice());
}
function parse$1(colorStr, rgbaArr) {
  if (!colorStr) {
    return;
  }
  rgbaArr = rgbaArr || [];
  var cached2 = colorCache.get(colorStr);
  if (cached2) {
    return copyRgba(rgbaArr, cached2);
  }
  colorStr = colorStr + "";
  var str = colorStr.replace(/ /g, "").toLowerCase();
  if (str in kCSSColorTable) {
    copyRgba(rgbaArr, kCSSColorTable[str]);
    putToCache(colorStr, rgbaArr);
    return rgbaArr;
  }
  var strLen = str.length;
  if (str.charAt(0) === "#") {
    if (strLen === 4 || strLen === 5) {
      var iv = parseInt(str.slice(1, 4), 16);
      if (!(iv >= 0 && iv <= 4095)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 3840) >> 4 | (iv & 3840) >> 8, iv & 240 | (iv & 240) >> 4, iv & 15 | (iv & 15) << 4, strLen === 5 ? parseInt(str.slice(4), 16) / 15 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    } else if (strLen === 7 || strLen === 9) {
      var iv = parseInt(str.slice(1, 7), 16);
      if (!(iv >= 0 && iv <= 16777215)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 16711680) >> 16, (iv & 65280) >> 8, iv & 255, strLen === 9 ? parseInt(str.slice(7), 16) / 255 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    }
    return;
  }
  var op = str.indexOf("(");
  var ep = str.indexOf(")");
  if (op !== -1 && ep + 1 === strLen) {
    var fname = str.substr(0, op);
    var params = str.substr(op + 1, ep - (op + 1)).split(",");
    var alpha = 1;
    switch (fname) {
      case "rgba":
        if (params.length !== 4) {
          return params.length === 3 ? setRgba(rgbaArr, +params[0], +params[1], +params[2], 1) : setRgba(rgbaArr, 0, 0, 0, 1);
        }
        alpha = parseCssFloat(params.pop());
      case "rgb":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        setRgba(rgbaArr, parseCssInt(params[0]), parseCssInt(params[1]), parseCssInt(params[2]), alpha);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsla":
        if (params.length !== 4) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        params[3] = parseCssFloat(params[3]);
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsl":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      default:
        return;
    }
  }
  setRgba(rgbaArr, 0, 0, 0, 1);
  return;
}
function hsla2rgba(hsla, rgba) {
  var h = (parseFloat(hsla[0]) % 360 + 360) % 360 / 360;
  var s = parseCssFloat(hsla[1]);
  var l2 = parseCssFloat(hsla[2]);
  var m2 = l2 <= 0.5 ? l2 * (s + 1) : l2 + s - l2 * s;
  var m1 = l2 * 2 - m2;
  rgba = rgba || [];
  setRgba(rgba, clampCssByte(cssHueToRgb(m1, m2, h + 1 / 3) * 255), clampCssByte(cssHueToRgb(m1, m2, h) * 255), clampCssByte(cssHueToRgb(m1, m2, h - 1 / 3) * 255), 1);
  if (hsla.length === 4) {
    rgba[3] = hsla[3];
  }
  return rgba;
}
function rgba2hsla(rgba) {
  if (!rgba) {
    return;
  }
  var R2 = rgba[0] / 255;
  var G2 = rgba[1] / 255;
  var B2 = rgba[2] / 255;
  var vMin = Math.min(R2, G2, B2);
  var vMax = Math.max(R2, G2, B2);
  var delta = vMax - vMin;
  var L = (vMax + vMin) / 2;
  var H2;
  var S2;
  if (delta === 0) {
    H2 = 0;
    S2 = 0;
  } else {
    if (L < 0.5) {
      S2 = delta / (vMax + vMin);
    } else {
      S2 = delta / (2 - vMax - vMin);
    }
    var deltaR = ((vMax - R2) / 6 + delta / 2) / delta;
    var deltaG = ((vMax - G2) / 6 + delta / 2) / delta;
    var deltaB = ((vMax - B2) / 6 + delta / 2) / delta;
    if (R2 === vMax) {
      H2 = deltaB - deltaG;
    } else if (G2 === vMax) {
      H2 = 1 / 3 + deltaR - deltaB;
    } else if (B2 === vMax) {
      H2 = 2 / 3 + deltaG - deltaR;
    }
    if (H2 < 0) {
      H2 += 1;
    }
    if (H2 > 1) {
      H2 -= 1;
    }
  }
  var hsla = [H2 * 360, S2, L];
  if (rgba[3] != null) {
    hsla.push(rgba[3]);
  }
  return hsla;
}
function lift(color, level) {
  var colorArr = parse$1(color);
  if (colorArr) {
    for (var i = 0; i < 3; i++) {
      if (level < 0) {
        colorArr[i] = colorArr[i] * (1 - level) | 0;
      } else {
        colorArr[i] = (255 - colorArr[i]) * level + colorArr[i] | 0;
      }
      if (colorArr[i] > 255) {
        colorArr[i] = 255;
      } else if (colorArr[i] < 0) {
        colorArr[i] = 0;
      }
    }
    return stringify(colorArr, colorArr.length === 4 ? "rgba" : "rgb");
  }
}
function fastLerp(normalizedValue, colors2, out2) {
  if (!(colors2 && colors2.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  out2 = out2 || [];
  var value = normalizedValue * (colors2.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = colors2[leftIndex];
  var rightColor = colors2[rightIndex];
  var dv = value - leftIndex;
  out2[0] = clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv));
  out2[1] = clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv));
  out2[2] = clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv));
  out2[3] = clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv));
  return out2;
}
function lerp(normalizedValue, colors2, fullOutput) {
  if (!(colors2 && colors2.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  var value = normalizedValue * (colors2.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = parse$1(colors2[leftIndex]);
  var rightColor = parse$1(colors2[rightIndex]);
  var dv = value - leftIndex;
  var color = stringify([
    clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv)),
    clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv)),
    clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv)),
    clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv))
  ], "rgba");
  return fullOutput ? {
    color,
    leftIndex,
    rightIndex,
    value
  } : color;
}
function modifyHSL(color, h, s, l2) {
  var colorArr = parse$1(color);
  if (color) {
    colorArr = rgba2hsla(colorArr);
    h != null && (colorArr[0] = clampCssAngle(h));
    s != null && (colorArr[1] = parseCssFloat(s));
    l2 != null && (colorArr[2] = parseCssFloat(l2));
    return stringify(hsla2rgba(colorArr), "rgba");
  }
}
function modifyAlpha(color, alpha) {
  var colorArr = parse$1(color);
  if (colorArr && alpha != null) {
    colorArr[3] = clampCssFloat(alpha);
    return stringify(colorArr, "rgba");
  }
}
function stringify(arrColor, type4) {
  if (!arrColor || !arrColor.length) {
    return;
  }
  var colorStr = arrColor[0] + "," + arrColor[1] + "," + arrColor[2];
  if (type4 === "rgba" || type4 === "hsva" || type4 === "hsla") {
    colorStr += "," + arrColor[3];
  }
  return type4 + "(" + colorStr + ")";
}
function lum(color, backgroundLum) {
  var arr = parse$1(color);
  return arr ? (0.299 * arr[0] + 0.587 * arr[1] + 0.114 * arr[2]) * arr[3] / 255 + (1 - arr[3]) * backgroundLum : 0;
}
var mathRound$1 = Math.round;
function normalizeColor(color) {
  var opacity;
  if (!color || color === "transparent") {
    color = "none";
  } else if (typeof color === "string" && color.indexOf("rgba") > -1) {
    var arr = parse$1(color);
    if (arr) {
      color = "rgb(" + arr[0] + "," + arr[1] + "," + arr[2] + ")";
      opacity = arr[3];
    }
  }
  return {
    color,
    opacity: opacity == null ? 1 : opacity
  };
}
var EPSILON$3 = 1e-4;
function isAroundZero(transform2) {
  return transform2 < EPSILON$3 && transform2 > -EPSILON$3;
}
function round3(transform2) {
  return mathRound$1(transform2 * 1e3) / 1e3;
}
function round4(transform2) {
  return mathRound$1(transform2 * 1e4) / 1e4;
}
function getMatrixStr(m2) {
  return "matrix(" + round3(m2[0]) + "," + round3(m2[1]) + "," + round3(m2[2]) + "," + round3(m2[3]) + "," + round4(m2[4]) + "," + round4(m2[5]) + ")";
}
var TEXT_ALIGN_TO_ANCHOR = {
  left: "start",
  right: "end",
  center: "middle",
  middle: "middle"
};
function adjustTextY$1(y2, lineHeight, textBaseline) {
  if (textBaseline === "top") {
    y2 += lineHeight / 2;
  } else if (textBaseline === "bottom") {
    y2 -= lineHeight / 2;
  }
  return y2;
}
function hasShadow(style2) {
  return style2 && (style2.shadowBlur || style2.shadowOffsetX || style2.shadowOffsetY);
}
function getShadowKey(displayable) {
  var style2 = displayable.style;
  var globalScale = displayable.getGlobalScale();
  return [
    style2.shadowColor,
    (style2.shadowBlur || 0).toFixed(2),
    (style2.shadowOffsetX || 0).toFixed(2),
    (style2.shadowOffsetY || 0).toFixed(2),
    globalScale[0],
    globalScale[1]
  ].join(",");
}
function isImagePattern(val) {
  return val && !!val.image;
}
function isSVGPattern(val) {
  return val && !!val.svgElement;
}
function isPattern(val) {
  return isImagePattern(val) || isSVGPattern(val);
}
function isLinearGradient(val) {
  return val.type === "linear";
}
function isRadialGradient(val) {
  return val.type === "radial";
}
function isGradient(val) {
  return val && (val.type === "linear" || val.type === "radial");
}
function getIdURL(id2) {
  return "url(#" + id2 + ")";
}
function getPathPrecision(el) {
  var scale2 = el.getGlobalScale();
  var size = Math.max(scale2[0], scale2[1]);
  return Math.max(Math.ceil(Math.log(size) / Math.log(10)), 1);
}
function getSRTTransformString(transform2) {
  var x2 = transform2.x || 0;
  var y2 = transform2.y || 0;
  var rotation = (transform2.rotation || 0) * RADIAN_TO_DEGREE;
  var scaleX = retrieve2(transform2.scaleX, 1);
  var scaleY = retrieve2(transform2.scaleY, 1);
  var skewX = transform2.skewX || 0;
  var skewY = transform2.skewY || 0;
  var res2 = [];
  if (x2 || y2) {
    res2.push("translate(" + x2 + "px," + y2 + "px)");
  }
  if (rotation) {
    res2.push("rotate(" + rotation + ")");
  }
  if (scaleX !== 1 || scaleY !== 1) {
    res2.push("scale(" + scaleX + "," + scaleY + ")");
  }
  if (skewX || skewY) {
    res2.push("skew(" + mathRound$1(skewX * RADIAN_TO_DEGREE) + "deg, " + mathRound$1(skewY * RADIAN_TO_DEGREE) + "deg)");
  }
  return res2.join(" ");
}
var encodeBase64 = function() {
  if (env$1.hasGlobalWindow && isFunction$1(window.btoa)) {
    return function(str) {
      return window.btoa(unescape(str));
    };
  }
  if (typeof Buffer !== "undefined") {
    return function(str) {
      return Buffer.from(str).toString("base64");
    };
  }
  return function(str) {
    return null;
  };
}();
var arraySlice = Array.prototype.slice;
function interpolateNumber$1(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
function interpolate1DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = interpolateNumber$1(p0[i], p1[i], percent);
  }
  return out2;
}
function interpolate2DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = interpolateNumber$1(p0[i][j], p1[i][j], percent);
    }
  }
  return out2;
}
function add1DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = p0[i] + p1[i] * sign;
  }
  return out2;
}
function add2DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = p0[i][j] + p1[i][j] * sign;
    }
  }
  return out2;
}
function fillColorStops(val0, val1) {
  var len0 = val0.length;
  var len1 = val1.length;
  var shorterArr = len0 > len1 ? val1 : val0;
  var shorterLen = Math.min(len0, len1);
  var last = shorterArr[shorterLen - 1] || { color: [0, 0, 0, 0], offset: 0 };
  for (var i = shorterLen; i < Math.max(len0, len1); i++) {
    shorterArr.push({
      offset: last.offset,
      color: last.color.slice()
    });
  }
}
function fillArray(val0, val1, arrDim) {
  var arr0 = val0;
  var arr1 = val1;
  if (!arr0.push || !arr1.push) {
    return;
  }
  var arr0Len = arr0.length;
  var arr1Len = arr1.length;
  if (arr0Len !== arr1Len) {
    var isPreviousLarger = arr0Len > arr1Len;
    if (isPreviousLarger) {
      arr0.length = arr1Len;
    } else {
      for (var i = arr0Len; i < arr1Len; i++) {
        arr0.push(arrDim === 1 ? arr1[i] : arraySlice.call(arr1[i]));
      }
    }
  }
  var len2 = arr0[0] && arr0[0].length;
  for (var i = 0; i < arr0.length; i++) {
    if (arrDim === 1) {
      if (isNaN(arr0[i])) {
        arr0[i] = arr1[i];
      }
    } else {
      for (var j = 0; j < len2; j++) {
        if (isNaN(arr0[i][j])) {
          arr0[i][j] = arr1[i][j];
        }
      }
    }
  }
}
function cloneValue(value) {
  if (isArrayLike(value)) {
    var len2 = value.length;
    if (isArrayLike(value[0])) {
      var ret = [];
      for (var i = 0; i < len2; i++) {
        ret.push(arraySlice.call(value[i]));
      }
      return ret;
    }
    return arraySlice.call(value);
  }
  return value;
}
function rgba2String(rgba) {
  rgba[0] = Math.floor(rgba[0]) || 0;
  rgba[1] = Math.floor(rgba[1]) || 0;
  rgba[2] = Math.floor(rgba[2]) || 0;
  rgba[3] = rgba[3] == null ? 1 : rgba[3];
  return "rgba(" + rgba.join(",") + ")";
}
function guessArrayDim(value) {
  return isArrayLike(value && value[0]) ? 2 : 1;
}
var VALUE_TYPE_NUMBER = 0;
var VALUE_TYPE_1D_ARRAY = 1;
var VALUE_TYPE_2D_ARRAY = 2;
var VALUE_TYPE_COLOR = 3;
var VALUE_TYPE_LINEAR_GRADIENT = 4;
var VALUE_TYPE_RADIAL_GRADIENT = 5;
var VALUE_TYPE_UNKOWN = 6;
function isGradientValueType(valType) {
  return valType === VALUE_TYPE_LINEAR_GRADIENT || valType === VALUE_TYPE_RADIAL_GRADIENT;
}
function isArrayValueType(valType) {
  return valType === VALUE_TYPE_1D_ARRAY || valType === VALUE_TYPE_2D_ARRAY;
}
var tmpRgba = [0, 0, 0, 0];
var Track = function() {
  function Track2(propName) {
    this.keyframes = [];
    this.discrete = false;
    this._invalid = false;
    this._needsSort = false;
    this._lastFr = 0;
    this._lastFrP = 0;
    this.propName = propName;
  }
  Track2.prototype.isFinished = function() {
    return this._finished;
  };
  Track2.prototype.setFinished = function() {
    this._finished = true;
    if (this._additiveTrack) {
      this._additiveTrack.setFinished();
    }
  };
  Track2.prototype.needsAnimate = function() {
    return this.keyframes.length >= 1;
  };
  Track2.prototype.getAdditiveTrack = function() {
    return this._additiveTrack;
  };
  Track2.prototype.addKeyframe = function(time, rawValue, easing) {
    this._needsSort = true;
    var keyframes = this.keyframes;
    var len2 = keyframes.length;
    var discrete = false;
    var valType = VALUE_TYPE_UNKOWN;
    var value = rawValue;
    if (isArrayLike(rawValue)) {
      var arrayDim = guessArrayDim(rawValue);
      valType = arrayDim;
      if (arrayDim === 1 && !isNumber(rawValue[0]) || arrayDim === 2 && !isNumber(rawValue[0][0])) {
        discrete = true;
      }
    } else {
      if (isNumber(rawValue) && !eqNaN(rawValue)) {
        valType = VALUE_TYPE_NUMBER;
      } else if (isString$1(rawValue)) {
        if (!isNaN(+rawValue)) {
          valType = VALUE_TYPE_NUMBER;
        } else {
          var colorArray = parse$1(rawValue);
          if (colorArray) {
            value = colorArray;
            valType = VALUE_TYPE_COLOR;
          }
        }
      } else if (isGradientObject(rawValue)) {
        var parsedGradient = extend({}, value);
        parsedGradient.colorStops = map$1(rawValue.colorStops, function(colorStop) {
          return {
            offset: colorStop.offset,
            color: parse$1(colorStop.color)
          };
        });
        if (isLinearGradient(rawValue)) {
          valType = VALUE_TYPE_LINEAR_GRADIENT;
        } else if (isRadialGradient(rawValue)) {
          valType = VALUE_TYPE_RADIAL_GRADIENT;
        }
        value = parsedGradient;
      }
    }
    if (len2 === 0) {
      this.valType = valType;
    } else if (valType !== this.valType || valType === VALUE_TYPE_UNKOWN) {
      discrete = true;
    }
    this.discrete = this.discrete || discrete;
    var kf2 = {
      time,
      value,
      rawValue,
      percent: 0
    };
    if (easing) {
      kf2.easing = easing;
      kf2.easingFunc = isFunction$1(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
    }
    keyframes.push(kf2);
    return kf2;
  };
  Track2.prototype.prepare = function(maxTime, additiveTrack) {
    var kfs = this.keyframes;
    if (this._needsSort) {
      kfs.sort(function(a, b2) {
        return a.time - b2.time;
      });
    }
    var valType = this.valType;
    var kfsLen = kfs.length;
    var lastKf = kfs[kfsLen - 1];
    var isDiscrete = this.discrete;
    var isArr = isArrayValueType(valType);
    var isGradient2 = isGradientValueType(valType);
    for (var i = 0; i < kfsLen; i++) {
      var kf2 = kfs[i];
      var value = kf2.value;
      var lastValue = lastKf.value;
      kf2.percent = kf2.time / maxTime;
      if (!isDiscrete) {
        if (isArr && i !== kfsLen - 1) {
          fillArray(value, lastValue, valType);
        } else if (isGradient2) {
          fillColorStops(value.colorStops, lastValue.colorStops);
        }
      }
    }
    if (!isDiscrete && valType !== VALUE_TYPE_RADIAL_GRADIENT && additiveTrack && this.needsAnimate() && additiveTrack.needsAnimate() && valType === additiveTrack.valType && !additiveTrack._finished) {
      this._additiveTrack = additiveTrack;
      var startValue = kfs[0].value;
      for (var i = 0; i < kfsLen; i++) {
        if (valType === VALUE_TYPE_NUMBER) {
          kfs[i].additiveValue = kfs[i].value - startValue;
        } else if (valType === VALUE_TYPE_COLOR) {
          kfs[i].additiveValue = add1DArray([], kfs[i].value, startValue, -1);
        } else if (isArrayValueType(valType)) {
          kfs[i].additiveValue = valType === VALUE_TYPE_1D_ARRAY ? add1DArray([], kfs[i].value, startValue, -1) : add2DArray([], kfs[i].value, startValue, -1);
        }
      }
    }
  };
  Track2.prototype.step = function(target, percent) {
    if (this._finished) {
      return;
    }
    if (this._additiveTrack && this._additiveTrack._finished) {
      this._additiveTrack = null;
    }
    var isAdditive = this._additiveTrack != null;
    var valueKey = isAdditive ? "additiveValue" : "value";
    var valType = this.valType;
    var keyframes = this.keyframes;
    var kfsNum = keyframes.length;
    var propName = this.propName;
    var isValueColor = valType === VALUE_TYPE_COLOR;
    var frameIdx;
    var lastFrame = this._lastFr;
    var mathMin2 = Math.min;
    var frame;
    var nextFrame;
    if (kfsNum === 1) {
      frame = nextFrame = keyframes[0];
    } else {
      if (percent < 0) {
        frameIdx = 0;
      } else if (percent < this._lastFrP) {
        var start2 = mathMin2(lastFrame + 1, kfsNum - 1);
        for (frameIdx = start2; frameIdx >= 0; frameIdx--) {
          if (keyframes[frameIdx].percent <= percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx, kfsNum - 2);
      } else {
        for (frameIdx = lastFrame; frameIdx < kfsNum; frameIdx++) {
          if (keyframes[frameIdx].percent > percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx - 1, kfsNum - 2);
      }
      nextFrame = keyframes[frameIdx + 1];
      frame = keyframes[frameIdx];
    }
    if (!(frame && nextFrame)) {
      return;
    }
    this._lastFr = frameIdx;
    this._lastFrP = percent;
    var interval = nextFrame.percent - frame.percent;
    var w2 = interval === 0 ? 1 : mathMin2((percent - frame.percent) / interval, 1);
    if (nextFrame.easingFunc) {
      w2 = nextFrame.easingFunc(w2);
    }
    var targetArr = isAdditive ? this._additiveValue : isValueColor ? tmpRgba : target[propName];
    if ((isArrayValueType(valType) || isValueColor) && !targetArr) {
      targetArr = this._additiveValue = [];
    }
    if (this.discrete) {
      target[propName] = w2 < 1 ? frame.rawValue : nextFrame.rawValue;
    } else if (isArrayValueType(valType)) {
      valType === VALUE_TYPE_1D_ARRAY ? interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2) : interpolate2DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
    } else if (isGradientValueType(valType)) {
      var val = frame[valueKey];
      var nextVal_1 = nextFrame[valueKey];
      var isLinearGradient_1 = valType === VALUE_TYPE_LINEAR_GRADIENT;
      target[propName] = {
        type: isLinearGradient_1 ? "linear" : "radial",
        x: interpolateNumber$1(val.x, nextVal_1.x, w2),
        y: interpolateNumber$1(val.y, nextVal_1.y, w2),
        colorStops: map$1(val.colorStops, function(colorStop, idx) {
          var nextColorStop = nextVal_1.colorStops[idx];
          return {
            offset: interpolateNumber$1(colorStop.offset, nextColorStop.offset, w2),
            color: rgba2String(interpolate1DArray([], colorStop.color, nextColorStop.color, w2))
          };
        }),
        global: nextVal_1.global
      };
      if (isLinearGradient_1) {
        target[propName].x2 = interpolateNumber$1(val.x2, nextVal_1.x2, w2);
        target[propName].y2 = interpolateNumber$1(val.y2, nextVal_1.y2, w2);
      } else {
        target[propName].r = interpolateNumber$1(val.r, nextVal_1.r, w2);
      }
    } else if (isValueColor) {
      interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
      if (!isAdditive) {
        target[propName] = rgba2String(targetArr);
      }
    } else {
      var value = interpolateNumber$1(frame[valueKey], nextFrame[valueKey], w2);
      if (isAdditive) {
        this._additiveValue = value;
      } else {
        target[propName] = value;
      }
    }
    if (isAdditive) {
      this._addToTarget(target);
    }
  };
  Track2.prototype._addToTarget = function(target) {
    var valType = this.valType;
    var propName = this.propName;
    var additiveValue = this._additiveValue;
    if (valType === VALUE_TYPE_NUMBER) {
      target[propName] = target[propName] + additiveValue;
    } else if (valType === VALUE_TYPE_COLOR) {
      parse$1(target[propName], tmpRgba);
      add1DArray(tmpRgba, tmpRgba, additiveValue, 1);
      target[propName] = rgba2String(tmpRgba);
    } else if (valType === VALUE_TYPE_1D_ARRAY) {
      add1DArray(target[propName], target[propName], additiveValue, 1);
    } else if (valType === VALUE_TYPE_2D_ARRAY) {
      add2DArray(target[propName], target[propName], additiveValue, 1);
    }
  };
  return Track2;
}();
var Animator = function() {
  function Animator2(target, loop, allowDiscreteAnimation, additiveTo) {
    this._tracks = {};
    this._trackKeys = [];
    this._maxTime = 0;
    this._started = 0;
    this._clip = null;
    this._target = target;
    this._loop = loop;
    if (loop && additiveTo) {
      logError("Can' use additive animation on looped animation.");
      return;
    }
    this._additiveAnimators = additiveTo;
    this._allowDiscrete = allowDiscreteAnimation;
  }
  Animator2.prototype.getMaxTime = function() {
    return this._maxTime;
  };
  Animator2.prototype.getDelay = function() {
    return this._delay;
  };
  Animator2.prototype.getLoop = function() {
    return this._loop;
  };
  Animator2.prototype.getTarget = function() {
    return this._target;
  };
  Animator2.prototype.changeTarget = function(target) {
    this._target = target;
  };
  Animator2.prototype.when = function(time, props, easing) {
    return this.whenWithKeys(time, props, keys(props), easing);
  };
  Animator2.prototype.whenWithKeys = function(time, props, propNames, easing) {
    var tracks = this._tracks;
    for (var i = 0; i < propNames.length; i++) {
      var propName = propNames[i];
      var track = tracks[propName];
      if (!track) {
        track = tracks[propName] = new Track(propName);
        var initialValue = void 0;
        var additiveTrack = this._getAdditiveTrack(propName);
        if (additiveTrack) {
          var addtiveTrackKfs = additiveTrack.keyframes;
          var lastFinalKf = addtiveTrackKfs[addtiveTrackKfs.length - 1];
          initialValue = lastFinalKf && lastFinalKf.value;
          if (additiveTrack.valType === VALUE_TYPE_COLOR && initialValue) {
            initialValue = rgba2String(initialValue);
          }
        } else {
          initialValue = this._target[propName];
        }
        if (initialValue == null) {
          continue;
        }
        if (time > 0) {
          track.addKeyframe(0, cloneValue(initialValue), easing);
        }
        this._trackKeys.push(propName);
      }
      track.addKeyframe(time, cloneValue(props[propName]), easing);
    }
    this._maxTime = Math.max(this._maxTime, time);
    return this;
  };
  Animator2.prototype.pause = function() {
    this._clip.pause();
    this._paused = true;
  };
  Animator2.prototype.resume = function() {
    this._clip.resume();
    this._paused = false;
  };
  Animator2.prototype.isPaused = function() {
    return !!this._paused;
  };
  Animator2.prototype.duration = function(duration) {
    this._maxTime = duration;
    this._force = true;
    return this;
  };
  Animator2.prototype._doneCallback = function() {
    this._setTracksFinished();
    this._clip = null;
    var doneList = this._doneCbs;
    if (doneList) {
      var len2 = doneList.length;
      for (var i = 0; i < len2; i++) {
        doneList[i].call(this);
      }
    }
  };
  Animator2.prototype._abortedCallback = function() {
    this._setTracksFinished();
    var animation = this.animation;
    var abortedList = this._abortedCbs;
    if (animation) {
      animation.removeClip(this._clip);
    }
    this._clip = null;
    if (abortedList) {
      for (var i = 0; i < abortedList.length; i++) {
        abortedList[i].call(this);
      }
    }
  };
  Animator2.prototype._setTracksFinished = function() {
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < tracksKeys.length; i++) {
      tracks[tracksKeys[i]].setFinished();
    }
  };
  Animator2.prototype._getAdditiveTrack = function(trackName) {
    var additiveTrack;
    var additiveAnimators = this._additiveAnimators;
    if (additiveAnimators) {
      for (var i = 0; i < additiveAnimators.length; i++) {
        var track = additiveAnimators[i].getTrack(trackName);
        if (track) {
          additiveTrack = track;
        }
      }
    }
    return additiveTrack;
  };
  Animator2.prototype.start = function(easing) {
    if (this._started > 0) {
      return;
    }
    this._started = 1;
    var self2 = this;
    var tracks = [];
    var maxTime = this._maxTime || 0;
    for (var i = 0; i < this._trackKeys.length; i++) {
      var propName = this._trackKeys[i];
      var track = this._tracks[propName];
      var additiveTrack = this._getAdditiveTrack(propName);
      var kfs = track.keyframes;
      var kfsNum = kfs.length;
      track.prepare(maxTime, additiveTrack);
      if (track.needsAnimate()) {
        if (!this._allowDiscrete && track.discrete) {
          var lastKf = kfs[kfsNum - 1];
          if (lastKf) {
            self2._target[track.propName] = lastKf.rawValue;
          }
          track.setFinished();
        } else {
          tracks.push(track);
        }
      }
    }
    if (tracks.length || this._force) {
      var clip2 = new Clip$1({
        life: maxTime,
        loop: this._loop,
        delay: this._delay || 0,
        onframe: function(percent) {
          self2._started = 2;
          var additiveAnimators = self2._additiveAnimators;
          if (additiveAnimators) {
            var stillHasAdditiveAnimator = false;
            for (var i2 = 0; i2 < additiveAnimators.length; i2++) {
              if (additiveAnimators[i2]._clip) {
                stillHasAdditiveAnimator = true;
                break;
              }
            }
            if (!stillHasAdditiveAnimator) {
              self2._additiveAnimators = null;
            }
          }
          for (var i2 = 0; i2 < tracks.length; i2++) {
            tracks[i2].step(self2._target, percent);
          }
          var onframeList = self2._onframeCbs;
          if (onframeList) {
            for (var i2 = 0; i2 < onframeList.length; i2++) {
              onframeList[i2](self2._target, percent);
            }
          }
        },
        ondestroy: function() {
          self2._doneCallback();
        }
      });
      this._clip = clip2;
      if (this.animation) {
        this.animation.addClip(clip2);
      }
      if (easing) {
        clip2.setEasing(easing);
      }
    } else {
      this._doneCallback();
    }
    return this;
  };
  Animator2.prototype.stop = function(forwardToLast) {
    if (!this._clip) {
      return;
    }
    var clip2 = this._clip;
    if (forwardToLast) {
      clip2.onframe(1);
    }
    this._abortedCallback();
  };
  Animator2.prototype.delay = function(time) {
    this._delay = time;
    return this;
  };
  Animator2.prototype.during = function(cb2) {
    if (cb2) {
      if (!this._onframeCbs) {
        this._onframeCbs = [];
      }
      this._onframeCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.done = function(cb2) {
    if (cb2) {
      if (!this._doneCbs) {
        this._doneCbs = [];
      }
      this._doneCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.aborted = function(cb2) {
    if (cb2) {
      if (!this._abortedCbs) {
        this._abortedCbs = [];
      }
      this._abortedCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.getClip = function() {
    return this._clip;
  };
  Animator2.prototype.getTrack = function(propName) {
    return this._tracks[propName];
  };
  Animator2.prototype.getTracks = function() {
    var _this = this;
    return map$1(this._trackKeys, function(key) {
      return _this._tracks[key];
    });
  };
  Animator2.prototype.stopTracks = function(propNames, forwardToLast) {
    if (!propNames.length || !this._clip) {
      return true;
    }
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < propNames.length; i++) {
      var track = tracks[propNames[i]];
      if (track && !track.isFinished()) {
        if (forwardToLast) {
          track.step(this._target, 1);
        } else if (this._started === 1) {
          track.step(this._target, 0);
        }
        track.setFinished();
      }
    }
    var allAborted = true;
    for (var i = 0; i < tracksKeys.length; i++) {
      if (!tracks[tracksKeys[i]].isFinished()) {
        allAborted = false;
        break;
      }
    }
    if (allAborted) {
      this._abortedCallback();
    }
    return allAborted;
  };
  Animator2.prototype.saveTo = function(target, trackKeys, firstOrLast) {
    if (!target) {
      return;
    }
    trackKeys = trackKeys || this._trackKeys;
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track || track.isFinished()) {
        continue;
      }
      var kfs = track.keyframes;
      var kf2 = kfs[firstOrLast ? 0 : kfs.length - 1];
      if (kf2) {
        target[propName] = cloneValue(kf2.rawValue);
      }
    }
  };
  Animator2.prototype.__changeFinalValue = function(finalProps, trackKeys) {
    trackKeys = trackKeys || keys(finalProps);
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track) {
        continue;
      }
      var kfs = track.keyframes;
      if (kfs.length > 1) {
        var lastKf = kfs.pop();
        track.addKeyframe(lastKf.time, finalProps[propName]);
        track.prepare(this._maxTime, track.getAdditiveTrack());
      }
    }
  };
  return Animator2;
}();
function getTime() {
  return new Date().getTime();
}
var Animation = function(_super) {
  __extends(Animation2, _super);
  function Animation2(opts) {
    var _this = _super.call(this) || this;
    _this._running = false;
    _this._time = 0;
    _this._pausedTime = 0;
    _this._pauseStart = 0;
    _this._paused = false;
    opts = opts || {};
    _this.stage = opts.stage || {};
    return _this;
  }
  Animation2.prototype.addClip = function(clip2) {
    if (clip2.animation) {
      this.removeClip(clip2);
    }
    if (!this._head) {
      this._head = this._tail = clip2;
    } else {
      this._tail.next = clip2;
      clip2.prev = this._tail;
      clip2.next = null;
      this._tail = clip2;
    }
    clip2.animation = this;
  };
  Animation2.prototype.addAnimator = function(animator) {
    animator.animation = this;
    var clip2 = animator.getClip();
    if (clip2) {
      this.addClip(clip2);
    }
  };
  Animation2.prototype.removeClip = function(clip2) {
    if (!clip2.animation) {
      return;
    }
    var prev = clip2.prev;
    var next = clip2.next;
    if (prev) {
      prev.next = next;
    } else {
      this._head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this._tail = prev;
    }
    clip2.next = clip2.prev = clip2.animation = null;
  };
  Animation2.prototype.removeAnimator = function(animator) {
    var clip2 = animator.getClip();
    if (clip2) {
      this.removeClip(clip2);
    }
    animator.animation = null;
  };
  Animation2.prototype.update = function(notTriggerFrameAndStageUpdate) {
    var time = getTime() - this._pausedTime;
    var delta = time - this._time;
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      var finished = clip2.step(time, delta);
      if (finished) {
        clip2.ondestroy();
        this.removeClip(clip2);
        clip2 = nextClip;
      } else {
        clip2 = nextClip;
      }
    }
    this._time = time;
    if (!notTriggerFrameAndStageUpdate) {
      this.trigger("frame", delta);
      this.stage.update && this.stage.update();
    }
  };
  Animation2.prototype._startLoop = function() {
    var self2 = this;
    this._running = true;
    function step() {
      if (self2._running) {
        requestAnimationFrame$2(step);
        !self2._paused && self2.update();
      }
    }
    requestAnimationFrame$2(step);
  };
  Animation2.prototype.start = function() {
    if (this._running) {
      return;
    }
    this._time = getTime();
    this._pausedTime = 0;
    this._startLoop();
  };
  Animation2.prototype.stop = function() {
    this._running = false;
  };
  Animation2.prototype.pause = function() {
    if (!this._paused) {
      this._pauseStart = getTime();
      this._paused = true;
    }
  };
  Animation2.prototype.resume = function() {
    if (this._paused) {
      this._pausedTime += getTime() - this._pauseStart;
      this._paused = false;
    }
  };
  Animation2.prototype.clear = function() {
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      clip2.prev = clip2.next = clip2.animation = null;
      clip2 = nextClip;
    }
    this._head = this._tail = null;
  };
  Animation2.prototype.isFinished = function() {
    return this._head == null;
  };
  Animation2.prototype.animate = function(target, options) {
    options = options || {};
    this.start();
    var animator = new Animator(target, options.loop);
    this.addAnimator(animator);
    return animator;
  };
  return Animation2;
}(Eventful$1);
var Animation$1 = Animation;
var TOUCH_CLICK_DELAY = 300;
var globalEventSupported = env$1.domSupported;
var localNativeListenerNames = function() {
  var mouseHandlerNames = [
    "click",
    "dblclick",
    "mousewheel",
    "wheel",
    "mouseout",
    "mouseup",
    "mousedown",
    "mousemove",
    "contextmenu"
  ];
  var touchHandlerNames = [
    "touchstart",
    "touchend",
    "touchmove"
  ];
  var pointerEventNameMap = {
    pointerdown: 1,
    pointerup: 1,
    pointermove: 1,
    pointerout: 1
  };
  var pointerHandlerNames = map$1(mouseHandlerNames, function(name2) {
    var nm = name2.replace("mouse", "pointer");
    return pointerEventNameMap.hasOwnProperty(nm) ? nm : name2;
  });
  return {
    mouse: mouseHandlerNames,
    touch: touchHandlerNames,
    pointer: pointerHandlerNames
  };
}();
var globalNativeListenerNames = {
  mouse: ["mousemove", "mouseup"],
  pointer: ["pointermove", "pointerup"]
};
var wheelEventSupported = false;
function isPointerFromTouch(event) {
  var pointerType = event.pointerType;
  return pointerType === "pen" || pointerType === "touch";
}
function setTouchTimer(scope) {
  scope.touching = true;
  if (scope.touchTimer != null) {
    clearTimeout(scope.touchTimer);
    scope.touchTimer = null;
  }
  scope.touchTimer = setTimeout(function() {
    scope.touching = false;
    scope.touchTimer = null;
  }, 700);
}
function markTouch(event) {
  event && (event.zrByTouch = true);
}
function normalizeGlobalEvent(instance, event) {
  return normalizeEvent(instance.dom, new FakeGlobalEvent(instance, event), true);
}
function isLocalEl(instance, el) {
  var elTmp = el;
  var isLocal = false;
  while (elTmp && elTmp.nodeType !== 9 && !(isLocal = elTmp.domBelongToZr || elTmp !== el && elTmp === instance.painterRoot)) {
    elTmp = elTmp.parentNode;
  }
  return isLocal;
}
var FakeGlobalEvent = function() {
  function FakeGlobalEvent2(instance, event) {
    this.stopPropagation = noop$1;
    this.stopImmediatePropagation = noop$1;
    this.preventDefault = noop$1;
    this.type = event.type;
    this.target = this.currentTarget = instance.dom;
    this.pointerType = event.pointerType;
    this.clientX = event.clientX;
    this.clientY = event.clientY;
  }
  return FakeGlobalEvent2;
}();
var localDOMHandlers = {
  mousedown: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__mayPointerCapture = [event.zrX, event.zrY];
    this.trigger("mousedown", event);
  },
  mousemove: function(event) {
    event = normalizeEvent(this.dom, event);
    var downPoint = this.__mayPointerCapture;
    if (downPoint && (event.zrX !== downPoint[0] || event.zrY !== downPoint[1])) {
      this.__togglePointerCapture(true);
    }
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
  },
  mouseout: function(event) {
    event = normalizeEvent(this.dom, event);
    var element = event.toElement || event.relatedTarget;
    if (!isLocalEl(this, element)) {
      if (this.__pointerCapturing) {
        event.zrEventControl = "no_globalout";
      }
      this.trigger("mouseout", event);
    }
  },
  wheel: function(event) {
    wheelEventSupported = true;
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  mousewheel: function(event) {
    if (wheelEventSupported) {
      return;
    }
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  touchstart: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.__lastTouchMoment = new Date();
    this.handler.processGesture(event, "start");
    localDOMHandlers.mousemove.call(this, event);
    localDOMHandlers.mousedown.call(this, event);
  },
  touchmove: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "change");
    localDOMHandlers.mousemove.call(this, event);
  },
  touchend: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "end");
    localDOMHandlers.mouseup.call(this, event);
    if (+new Date() - +this.__lastTouchMoment < TOUCH_CLICK_DELAY) {
      localDOMHandlers.click.call(this, event);
    }
  },
  pointerdown: function(event) {
    localDOMHandlers.mousedown.call(this, event);
  },
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    localDOMHandlers.mouseup.call(this, event);
  },
  pointerout: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mouseout.call(this, event);
    }
  }
};
each$g(["click", "dblclick", "contextmenu"], function(name2) {
  localDOMHandlers[name2] = function(event) {
    event = normalizeEvent(this.dom, event);
    this.trigger(name2, event);
  };
});
var globalDOMHandlers = {
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      globalDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    globalDOMHandlers.mouseup.call(this, event);
  },
  mousemove: function(event) {
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    var pointerCaptureReleasing = this.__pointerCapturing;
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
    if (pointerCaptureReleasing) {
      event.zrEventControl = "only_globalout";
      this.trigger("mouseout", event);
    }
  }
};
function mountLocalDOMEventListeners(instance, scope) {
  var domHandlers = scope.domHandlers;
  if (env$1.pointerEventsSupported) {
    each$g(localNativeListenerNames.pointer, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        domHandlers[nativeEventName].call(instance, event);
      });
    });
  } else {
    if (env$1.touchEventsSupported) {
      each$g(localNativeListenerNames.touch, function(nativeEventName) {
        mountSingleDOMEventListener(scope, nativeEventName, function(event) {
          domHandlers[nativeEventName].call(instance, event);
          setTouchTimer(scope);
        });
      });
    }
    each$g(localNativeListenerNames.mouse, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        event = getNativeEvent(event);
        if (!scope.touching) {
          domHandlers[nativeEventName].call(instance, event);
        }
      });
    });
  }
}
function mountGlobalDOMEventListeners(instance, scope) {
  if (env$1.pointerEventsSupported) {
    each$g(globalNativeListenerNames.pointer, mount);
  } else if (!env$1.touchEventsSupported) {
    each$g(globalNativeListenerNames.mouse, mount);
  }
  function mount(nativeEventName) {
    function nativeEventListener(event) {
      event = getNativeEvent(event);
      if (!isLocalEl(instance, event.target)) {
        event = normalizeGlobalEvent(instance, event);
        scope.domHandlers[nativeEventName].call(instance, event);
      }
    }
    mountSingleDOMEventListener(scope, nativeEventName, nativeEventListener, { capture: true });
  }
}
function mountSingleDOMEventListener(scope, nativeEventName, listener, opt) {
  scope.mounted[nativeEventName] = listener;
  scope.listenerOpts[nativeEventName] = opt;
  addEventListener$1(scope.domTarget, nativeEventName, listener, opt);
}
function unmountDOMEventListeners(scope) {
  var mounted = scope.mounted;
  for (var nativeEventName in mounted) {
    if (mounted.hasOwnProperty(nativeEventName)) {
      removeEventListener$1(scope.domTarget, nativeEventName, mounted[nativeEventName], scope.listenerOpts[nativeEventName]);
    }
  }
  scope.mounted = {};
}
var DOMHandlerScope = function() {
  function DOMHandlerScope2(domTarget, domHandlers) {
    this.mounted = {};
    this.listenerOpts = {};
    this.touching = false;
    this.domTarget = domTarget;
    this.domHandlers = domHandlers;
  }
  return DOMHandlerScope2;
}();
var HandlerDomProxy = function(_super) {
  __extends(HandlerDomProxy2, _super);
  function HandlerDomProxy2(dom, painterRoot) {
    var _this = _super.call(this) || this;
    _this.__pointerCapturing = false;
    _this.dom = dom;
    _this.painterRoot = painterRoot;
    _this._localHandlerScope = new DOMHandlerScope(dom, localDOMHandlers);
    if (globalEventSupported) {
      _this._globalHandlerScope = new DOMHandlerScope(document, globalDOMHandlers);
    }
    mountLocalDOMEventListeners(_this, _this._localHandlerScope);
    return _this;
  }
  HandlerDomProxy2.prototype.dispose = function() {
    unmountDOMEventListeners(this._localHandlerScope);
    if (globalEventSupported) {
      unmountDOMEventListeners(this._globalHandlerScope);
    }
  };
  HandlerDomProxy2.prototype.setCursor = function(cursorStyle) {
    this.dom.style && (this.dom.style.cursor = cursorStyle || "default");
  };
  HandlerDomProxy2.prototype.__togglePointerCapture = function(isPointerCapturing) {
    this.__mayPointerCapture = null;
    if (globalEventSupported && +this.__pointerCapturing ^ +isPointerCapturing) {
      this.__pointerCapturing = isPointerCapturing;
      var globalHandlerScope = this._globalHandlerScope;
      isPointerCapturing ? mountGlobalDOMEventListeners(this, globalHandlerScope) : unmountDOMEventListeners(globalHandlerScope);
    }
  };
  return HandlerDomProxy2;
}(Eventful$1);
var HandlerProxy = HandlerDomProxy;
var dpr = 1;
if (env$1.hasGlobalWindow) {
  dpr = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1);
}
var devicePixelRatio = dpr;
var DARK_MODE_THRESHOLD = 0.4;
var DARK_LABEL_COLOR = "#333";
var LIGHT_LABEL_COLOR = "#ccc";
var LIGHTER_LABEL_COLOR = "#eee";
function create$2() {
  return [1, 0, 0, 1, 0, 0];
}
function identity(out2) {
  out2[0] = 1;
  out2[1] = 0;
  out2[2] = 0;
  out2[3] = 1;
  out2[4] = 0;
  out2[5] = 0;
  return out2;
}
function copy(out2, m2) {
  out2[0] = m2[0];
  out2[1] = m2[1];
  out2[2] = m2[2];
  out2[3] = m2[3];
  out2[4] = m2[4];
  out2[5] = m2[5];
  return out2;
}
function mul(out2, m1, m2) {
  var out0 = m1[0] * m2[0] + m1[2] * m2[1];
  var out1 = m1[1] * m2[0] + m1[3] * m2[1];
  var out22 = m1[0] * m2[2] + m1[2] * m2[3];
  var out3 = m1[1] * m2[2] + m1[3] * m2[3];
  var out4 = m1[0] * m2[4] + m1[2] * m2[5] + m1[4];
  var out5 = m1[1] * m2[4] + m1[3] * m2[5] + m1[5];
  out2[0] = out0;
  out2[1] = out1;
  out2[2] = out22;
  out2[3] = out3;
  out2[4] = out4;
  out2[5] = out5;
  return out2;
}
function translate(out2, a, v4) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  out2[4] = a[4] + v4[0];
  out2[5] = a[5] + v4[1];
  return out2;
}
function rotate(out2, a, rad) {
  var aa2 = a[0];
  var ac2 = a[2];
  var atx = a[4];
  var ab2 = a[1];
  var ad2 = a[3];
  var aty = a[5];
  var st = Math.sin(rad);
  var ct = Math.cos(rad);
  out2[0] = aa2 * ct + ab2 * st;
  out2[1] = -aa2 * st + ab2 * ct;
  out2[2] = ac2 * ct + ad2 * st;
  out2[3] = -ac2 * st + ct * ad2;
  out2[4] = ct * atx + st * aty;
  out2[5] = ct * aty - st * atx;
  return out2;
}
function scale$1(out2, a, v4) {
  var vx = v4[0];
  var vy = v4[1];
  out2[0] = a[0] * vx;
  out2[1] = a[1] * vy;
  out2[2] = a[2] * vx;
  out2[3] = a[3] * vy;
  out2[4] = a[4] * vx;
  out2[5] = a[5] * vy;
  return out2;
}
function invert(out2, a) {
  var aa2 = a[0];
  var ac2 = a[2];
  var atx = a[4];
  var ab2 = a[1];
  var ad2 = a[3];
  var aty = a[5];
  var det = aa2 * ad2 - ab2 * ac2;
  if (!det) {
    return null;
  }
  det = 1 / det;
  out2[0] = ad2 * det;
  out2[1] = -ab2 * det;
  out2[2] = -ac2 * det;
  out2[3] = aa2 * det;
  out2[4] = (ac2 * aty - ad2 * atx) * det;
  out2[5] = (ab2 * atx - aa2 * aty) * det;
  return out2;
}
function clone$2(a) {
  var b2 = create$2();
  copy(b2, a);
  return b2;
}
var mIdentity = identity;
var EPSILON$2 = 5e-5;
function isNotAroundZero(val) {
  return val > EPSILON$2 || val < -EPSILON$2;
}
var scaleTmp = [];
var tmpTransform = [];
var originTransform = create$2();
var abs = Math.abs;
var Transformable = function() {
  function Transformable2() {
  }
  Transformable2.prototype.getLocalTransform = function(m2) {
    return Transformable2.getLocalTransform(this, m2);
  };
  Transformable2.prototype.setPosition = function(arr) {
    this.x = arr[0];
    this.y = arr[1];
  };
  Transformable2.prototype.setScale = function(arr) {
    this.scaleX = arr[0];
    this.scaleY = arr[1];
  };
  Transformable2.prototype.setSkew = function(arr) {
    this.skewX = arr[0];
    this.skewY = arr[1];
  };
  Transformable2.prototype.setOrigin = function(arr) {
    this.originX = arr[0];
    this.originY = arr[1];
  };
  Transformable2.prototype.needLocalTransform = function() {
    return isNotAroundZero(this.rotation) || isNotAroundZero(this.x) || isNotAroundZero(this.y) || isNotAroundZero(this.scaleX - 1) || isNotAroundZero(this.scaleY - 1) || isNotAroundZero(this.skewX) || isNotAroundZero(this.skewY);
  };
  Transformable2.prototype.updateTransform = function() {
    var parentTransform = this.parent && this.parent.transform;
    var needLocalTransform = this.needLocalTransform();
    var m2 = this.transform;
    if (!(needLocalTransform || parentTransform)) {
      m2 && mIdentity(m2);
      return;
    }
    m2 = m2 || create$2();
    if (needLocalTransform) {
      this.getLocalTransform(m2);
    } else {
      mIdentity(m2);
    }
    if (parentTransform) {
      if (needLocalTransform) {
        mul(m2, parentTransform, m2);
      } else {
        copy(m2, parentTransform);
      }
    }
    this.transform = m2;
    this._resolveGlobalScaleRatio(m2);
  };
  Transformable2.prototype._resolveGlobalScaleRatio = function(m2) {
    var globalScaleRatio = this.globalScaleRatio;
    if (globalScaleRatio != null && globalScaleRatio !== 1) {
      this.getGlobalScale(scaleTmp);
      var relX = scaleTmp[0] < 0 ? -1 : 1;
      var relY = scaleTmp[1] < 0 ? -1 : 1;
      var sx = ((scaleTmp[0] - relX) * globalScaleRatio + relX) / scaleTmp[0] || 0;
      var sy = ((scaleTmp[1] - relY) * globalScaleRatio + relY) / scaleTmp[1] || 0;
      m2[0] *= sx;
      m2[1] *= sx;
      m2[2] *= sy;
      m2[3] *= sy;
    }
    this.invTransform = this.invTransform || create$2();
    invert(this.invTransform, m2);
  };
  Transformable2.prototype.getComputedTransform = function() {
    var transformNode = this;
    var ancestors = [];
    while (transformNode) {
      ancestors.push(transformNode);
      transformNode = transformNode.parent;
    }
    while (transformNode = ancestors.pop()) {
      transformNode.updateTransform();
    }
    return this.transform;
  };
  Transformable2.prototype.setLocalTransform = function(m2) {
    if (!m2) {
      return;
    }
    var sx = m2[0] * m2[0] + m2[1] * m2[1];
    var sy = m2[2] * m2[2] + m2[3] * m2[3];
    var rotation = Math.atan2(m2[1], m2[0]);
    var shearX = Math.PI / 2 + rotation - Math.atan2(m2[3], m2[2]);
    sy = Math.sqrt(sy) * Math.cos(shearX);
    sx = Math.sqrt(sx);
    this.skewX = shearX;
    this.skewY = 0;
    this.rotation = -rotation;
    this.x = +m2[4];
    this.y = +m2[5];
    this.scaleX = sx;
    this.scaleY = sy;
    this.originX = 0;
    this.originY = 0;
  };
  Transformable2.prototype.decomposeTransform = function() {
    if (!this.transform) {
      return;
    }
    var parent = this.parent;
    var m2 = this.transform;
    if (parent && parent.transform) {
      mul(tmpTransform, parent.invTransform, m2);
      m2 = tmpTransform;
    }
    var ox = this.originX;
    var oy = this.originY;
    if (ox || oy) {
      originTransform[4] = ox;
      originTransform[5] = oy;
      mul(tmpTransform, m2, originTransform);
      tmpTransform[4] -= ox;
      tmpTransform[5] -= oy;
      m2 = tmpTransform;
    }
    this.setLocalTransform(m2);
  };
  Transformable2.prototype.getGlobalScale = function(out2) {
    var m2 = this.transform;
    out2 = out2 || [];
    if (!m2) {
      out2[0] = 1;
      out2[1] = 1;
      return out2;
    }
    out2[0] = Math.sqrt(m2[0] * m2[0] + m2[1] * m2[1]);
    out2[1] = Math.sqrt(m2[2] * m2[2] + m2[3] * m2[3]);
    if (m2[0] < 0) {
      out2[0] = -out2[0];
    }
    if (m2[3] < 0) {
      out2[1] = -out2[1];
    }
    return out2;
  };
  Transformable2.prototype.transformCoordToLocal = function(x2, y2) {
    var v22 = [x2, y2];
    var invTransform = this.invTransform;
    if (invTransform) {
      applyTransform$1(v22, v22, invTransform);
    }
    return v22;
  };
  Transformable2.prototype.transformCoordToGlobal = function(x2, y2) {
    var v22 = [x2, y2];
    var transform2 = this.transform;
    if (transform2) {
      applyTransform$1(v22, v22, transform2);
    }
    return v22;
  };
  Transformable2.prototype.getLineScale = function() {
    var m2 = this.transform;
    return m2 && abs(m2[0] - 1) > 1e-10 && abs(m2[3] - 1) > 1e-10 ? Math.sqrt(abs(m2[0] * m2[3] - m2[2] * m2[1])) : 1;
  };
  Transformable2.prototype.copyTransform = function(source) {
    copyTransform(this, source);
  };
  Transformable2.getLocalTransform = function(target, m2) {
    m2 = m2 || [];
    var ox = target.originX || 0;
    var oy = target.originY || 0;
    var sx = target.scaleX;
    var sy = target.scaleY;
    var ax = target.anchorX;
    var ay = target.anchorY;
    var rotation = target.rotation || 0;
    var x2 = target.x;
    var y2 = target.y;
    var skewX = target.skewX ? Math.tan(target.skewX) : 0;
    var skewY = target.skewY ? Math.tan(-target.skewY) : 0;
    if (ox || oy || ax || ay) {
      var dx = ox + ax;
      var dy = oy + ay;
      m2[4] = -dx * sx - skewX * dy * sy;
      m2[5] = -dy * sy - skewY * dx * sx;
    } else {
      m2[4] = m2[5] = 0;
    }
    m2[0] = sx;
    m2[3] = sy;
    m2[1] = skewY * sx;
    m2[2] = skewX * sy;
    rotation && rotate(m2, m2, rotation);
    m2[4] += ox + x2;
    m2[5] += oy + y2;
    return m2;
  };
  Transformable2.initDefaultProps = function() {
    var proto2 = Transformable2.prototype;
    proto2.scaleX = proto2.scaleY = proto2.globalScaleRatio = 1;
    proto2.x = proto2.y = proto2.originX = proto2.originY = proto2.skewX = proto2.skewY = proto2.rotation = proto2.anchorX = proto2.anchorY = 0;
  }();
  return Transformable2;
}();
var TRANSFORMABLE_PROPS = [
  "x",
  "y",
  "originX",
  "originY",
  "anchorX",
  "anchorY",
  "rotation",
  "scaleX",
  "scaleY",
  "skewX",
  "skewY"
];
function copyTransform(target, source) {
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var propName = TRANSFORMABLE_PROPS[i];
    target[propName] = source[propName];
  }
}
var Transformable$1 = Transformable;
var Point = function() {
  function Point2(x2, y2) {
    this.x = x2 || 0;
    this.y = y2 || 0;
  }
  Point2.prototype.copy = function(other) {
    this.x = other.x;
    this.y = other.y;
    return this;
  };
  Point2.prototype.clone = function() {
    return new Point2(this.x, this.y);
  };
  Point2.prototype.set = function(x2, y2) {
    this.x = x2;
    this.y = y2;
    return this;
  };
  Point2.prototype.equal = function(other) {
    return other.x === this.x && other.y === this.y;
  };
  Point2.prototype.add = function(other) {
    this.x += other.x;
    this.y += other.y;
    return this;
  };
  Point2.prototype.scale = function(scalar) {
    this.x *= scalar;
    this.y *= scalar;
  };
  Point2.prototype.scaleAndAdd = function(other, scalar) {
    this.x += other.x * scalar;
    this.y += other.y * scalar;
  };
  Point2.prototype.sub = function(other) {
    this.x -= other.x;
    this.y -= other.y;
    return this;
  };
  Point2.prototype.dot = function(other) {
    return this.x * other.x + this.y * other.y;
  };
  Point2.prototype.len = function() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  };
  Point2.prototype.lenSquare = function() {
    return this.x * this.x + this.y * this.y;
  };
  Point2.prototype.normalize = function() {
    var len2 = this.len();
    this.x /= len2;
    this.y /= len2;
    return this;
  };
  Point2.prototype.distance = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return Math.sqrt(dx * dx + dy * dy);
  };
  Point2.prototype.distanceSquare = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return dx * dx + dy * dy;
  };
  Point2.prototype.negate = function() {
    this.x = -this.x;
    this.y = -this.y;
    return this;
  };
  Point2.prototype.transform = function(m2) {
    if (!m2) {
      return;
    }
    var x2 = this.x;
    var y2 = this.y;
    this.x = m2[0] * x2 + m2[2] * y2 + m2[4];
    this.y = m2[1] * x2 + m2[3] * y2 + m2[5];
    return this;
  };
  Point2.prototype.toArray = function(out2) {
    out2[0] = this.x;
    out2[1] = this.y;
    return out2;
  };
  Point2.prototype.fromArray = function(input) {
    this.x = input[0];
    this.y = input[1];
  };
  Point2.set = function(p2, x2, y2) {
    p2.x = x2;
    p2.y = y2;
  };
  Point2.copy = function(p2, p22) {
    p2.x = p22.x;
    p2.y = p22.y;
  };
  Point2.len = function(p2) {
    return Math.sqrt(p2.x * p2.x + p2.y * p2.y);
  };
  Point2.lenSquare = function(p2) {
    return p2.x * p2.x + p2.y * p2.y;
  };
  Point2.dot = function(p0, p1) {
    return p0.x * p1.x + p0.y * p1.y;
  };
  Point2.add = function(out2, p0, p1) {
    out2.x = p0.x + p1.x;
    out2.y = p0.y + p1.y;
  };
  Point2.sub = function(out2, p0, p1) {
    out2.x = p0.x - p1.x;
    out2.y = p0.y - p1.y;
  };
  Point2.scale = function(out2, p0, scalar) {
    out2.x = p0.x * scalar;
    out2.y = p0.y * scalar;
  };
  Point2.scaleAndAdd = function(out2, p0, p1, scalar) {
    out2.x = p0.x + p1.x * scalar;
    out2.y = p0.y + p1.y * scalar;
  };
  Point2.lerp = function(out2, p0, p1, t2) {
    var onet = 1 - t2;
    out2.x = onet * p0.x + t2 * p1.x;
    out2.y = onet * p0.y + t2 * p1.y;
  };
  return Point2;
}();
var Point$1 = Point;
var mathMin$a = Math.min;
var mathMax$a = Math.max;
var lt = new Point$1();
var rb$1 = new Point$1();
var lb$1 = new Point$1();
var rt = new Point$1();
var minTv$1 = new Point$1();
var maxTv$1 = new Point$1();
var BoundingRect = function() {
  function BoundingRect2(x2, y2, width, height) {
    if (width < 0) {
      x2 = x2 + width;
      width = -width;
    }
    if (height < 0) {
      y2 = y2 + height;
      height = -height;
    }
    this.x = x2;
    this.y = y2;
    this.width = width;
    this.height = height;
  }
  BoundingRect2.prototype.union = function(other) {
    var x2 = mathMin$a(other.x, this.x);
    var y2 = mathMin$a(other.y, this.y);
    if (isFinite(this.x) && isFinite(this.width)) {
      this.width = mathMax$a(other.x + other.width, this.x + this.width) - x2;
    } else {
      this.width = other.width;
    }
    if (isFinite(this.y) && isFinite(this.height)) {
      this.height = mathMax$a(other.y + other.height, this.y + this.height) - y2;
    } else {
      this.height = other.height;
    }
    this.x = x2;
    this.y = y2;
  };
  BoundingRect2.prototype.applyTransform = function(m2) {
    BoundingRect2.applyTransform(this, this, m2);
  };
  BoundingRect2.prototype.calculateTransform = function(b2) {
    var a = this;
    var sx = b2.width / a.width;
    var sy = b2.height / a.height;
    var m2 = create$2();
    translate(m2, m2, [-a.x, -a.y]);
    scale$1(m2, m2, [sx, sy]);
    translate(m2, m2, [b2.x, b2.y]);
    return m2;
  };
  BoundingRect2.prototype.intersect = function(b2, mtv) {
    if (!b2) {
      return false;
    }
    if (!(b2 instanceof BoundingRect2)) {
      b2 = BoundingRect2.create(b2);
    }
    var a = this;
    var ax0 = a.x;
    var ax1 = a.x + a.width;
    var ay0 = a.y;
    var ay1 = a.y + a.height;
    var bx0 = b2.x;
    var bx1 = b2.x + b2.width;
    var by0 = b2.y;
    var by1 = b2.y + b2.height;
    var overlap = !(ax1 < bx0 || bx1 < ax0 || ay1 < by0 || by1 < ay0);
    if (mtv) {
      var dMin = Infinity;
      var dMax = 0;
      var d0 = Math.abs(ax1 - bx0);
      var d1 = Math.abs(bx1 - ax0);
      var d2 = Math.abs(ay1 - by0);
      var d3 = Math.abs(by1 - ay0);
      var dx = Math.min(d0, d1);
      var dy = Math.min(d2, d3);
      if (ax1 < bx0 || bx1 < ax0) {
        if (dx > dMax) {
          dMax = dx;
          if (d0 < d1) {
            Point$1.set(maxTv$1, -d0, 0);
          } else {
            Point$1.set(maxTv$1, d1, 0);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d0 < d1) {
            Point$1.set(minTv$1, d0, 0);
          } else {
            Point$1.set(minTv$1, -d1, 0);
          }
        }
      }
      if (ay1 < by0 || by1 < ay0) {
        if (dy > dMax) {
          dMax = dy;
          if (d2 < d3) {
            Point$1.set(maxTv$1, 0, -d2);
          } else {
            Point$1.set(maxTv$1, 0, d3);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d2 < d3) {
            Point$1.set(minTv$1, 0, d2);
          } else {
            Point$1.set(minTv$1, 0, -d3);
          }
        }
      }
    }
    if (mtv) {
      Point$1.copy(mtv, overlap ? minTv$1 : maxTv$1);
    }
    return overlap;
  };
  BoundingRect2.prototype.contain = function(x2, y2) {
    var rect = this;
    return x2 >= rect.x && x2 <= rect.x + rect.width && y2 >= rect.y && y2 <= rect.y + rect.height;
  };
  BoundingRect2.prototype.clone = function() {
    return new BoundingRect2(this.x, this.y, this.width, this.height);
  };
  BoundingRect2.prototype.copy = function(other) {
    BoundingRect2.copy(this, other);
  };
  BoundingRect2.prototype.plain = function() {
    return {
      x: this.x,
      y: this.y,
      width: this.width,
      height: this.height
    };
  };
  BoundingRect2.prototype.isFinite = function() {
    return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
  };
  BoundingRect2.prototype.isZero = function() {
    return this.width === 0 || this.height === 0;
  };
  BoundingRect2.create = function(rect) {
    return new BoundingRect2(rect.x, rect.y, rect.width, rect.height);
  };
  BoundingRect2.copy = function(target, source) {
    target.x = source.x;
    target.y = source.y;
    target.width = source.width;
    target.height = source.height;
  };
  BoundingRect2.applyTransform = function(target, source, m2) {
    if (!m2) {
      if (target !== source) {
        BoundingRect2.copy(target, source);
      }
      return;
    }
    if (m2[1] < 1e-5 && m2[1] > -1e-5 && m2[2] < 1e-5 && m2[2] > -1e-5) {
      var sx = m2[0];
      var sy = m2[3];
      var tx = m2[4];
      var ty = m2[5];
      target.x = source.x * sx + tx;
      target.y = source.y * sy + ty;
      target.width = source.width * sx;
      target.height = source.height * sy;
      if (target.width < 0) {
        target.x += target.width;
        target.width = -target.width;
      }
      if (target.height < 0) {
        target.y += target.height;
        target.height = -target.height;
      }
      return;
    }
    lt.x = lb$1.x = source.x;
    lt.y = rt.y = source.y;
    rb$1.x = rt.x = source.x + source.width;
    rb$1.y = lb$1.y = source.y + source.height;
    lt.transform(m2);
    rt.transform(m2);
    rb$1.transform(m2);
    lb$1.transform(m2);
    target.x = mathMin$a(lt.x, rb$1.x, lb$1.x, rt.x);
    target.y = mathMin$a(lt.y, rb$1.y, lb$1.y, rt.y);
    var maxX = mathMax$a(lt.x, rb$1.x, lb$1.x, rt.x);
    var maxY = mathMax$a(lt.y, rb$1.y, lb$1.y, rt.y);
    target.width = maxX - target.x;
    target.height = maxY - target.y;
  };
  return BoundingRect2;
}();
var BoundingRect$1 = BoundingRect;
var textWidthCache = {};
function getWidth(text, font) {
  font = font || DEFAULT_FONT;
  var cacheOfFont = textWidthCache[font];
  if (!cacheOfFont) {
    cacheOfFont = textWidthCache[font] = new LRU$1(500);
  }
  var width = cacheOfFont.get(text);
  if (width == null) {
    width = platformApi.measureText(text, font).width;
    cacheOfFont.put(text, width);
  }
  return width;
}
function innerGetBoundingRect(text, font, textAlign, textBaseline) {
  var width = getWidth(text, font);
  var height = getLineHeight(font);
  var x2 = adjustTextX(0, width, textAlign);
  var y2 = adjustTextY(0, height, textBaseline);
  var rect = new BoundingRect$1(x2, y2, width, height);
  return rect;
}
function getBoundingRect(text, font, textAlign, textBaseline) {
  var textLines = ((text || "") + "").split("\n");
  var len2 = textLines.length;
  if (len2 === 1) {
    return innerGetBoundingRect(textLines[0], font, textAlign, textBaseline);
  } else {
    var uniondRect = new BoundingRect$1(0, 0, 0, 0);
    for (var i = 0; i < textLines.length; i++) {
      var rect = innerGetBoundingRect(textLines[i], font, textAlign, textBaseline);
      i === 0 ? uniondRect.copy(rect) : uniondRect.union(rect);
    }
    return uniondRect;
  }
}
function adjustTextX(x2, width, textAlign) {
  if (textAlign === "right") {
    x2 -= width;
  } else if (textAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function adjustTextY(y2, height, verticalAlign) {
  if (verticalAlign === "middle") {
    y2 -= height / 2;
  } else if (verticalAlign === "bottom") {
    y2 -= height;
  }
  return y2;
}
function getLineHeight(font) {
  return getWidth("\u56FD", font);
}
function parsePercent$1(value, maxValue) {
  if (typeof value === "string") {
    if (value.lastIndexOf("%") >= 0) {
      return parseFloat(value) / 100 * maxValue;
    }
    return parseFloat(value);
  }
  return value;
}
function calculateTextPosition(out2, opts, rect) {
  var textPosition = opts.position || "inside";
  var distance2 = opts.distance != null ? opts.distance : 5;
  var height = rect.height;
  var width = rect.width;
  var halfHeight = height / 2;
  var x2 = rect.x;
  var y2 = rect.y;
  var textAlign = "left";
  var textVerticalAlign = "top";
  if (textPosition instanceof Array) {
    x2 += parsePercent$1(textPosition[0], rect.width);
    y2 += parsePercent$1(textPosition[1], rect.height);
    textAlign = null;
    textVerticalAlign = null;
  } else {
    switch (textPosition) {
      case "left":
        x2 -= distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "right":
        x2 += distance2 + width;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "top":
        x2 += width / 2;
        y2 -= distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "bottom":
        x2 += width / 2;
        y2 += height + distance2;
        textAlign = "center";
        break;
      case "inside":
        x2 += width / 2;
        y2 += halfHeight;
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "insideLeft":
        x2 += distance2;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "insideRight":
        x2 += width - distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideTop":
        x2 += width / 2;
        y2 += distance2;
        textAlign = "center";
        break;
      case "insideBottom":
        x2 += width / 2;
        y2 += height - distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideTopLeft":
        x2 += distance2;
        y2 += distance2;
        break;
      case "insideTopRight":
        x2 += width - distance2;
        y2 += distance2;
        textAlign = "right";
        break;
      case "insideBottomLeft":
        x2 += distance2;
        y2 += height - distance2;
        textVerticalAlign = "bottom";
        break;
      case "insideBottomRight":
        x2 += width - distance2;
        y2 += height - distance2;
        textAlign = "right";
        textVerticalAlign = "bottom";
        break;
    }
  }
  out2 = out2 || {};
  out2.x = x2;
  out2.y = y2;
  out2.align = textAlign;
  out2.verticalAlign = textVerticalAlign;
  return out2;
}
var PRESERVED_NORMAL_STATE = "__zr_normal__";
var PRIMARY_STATES_KEYS$1 = TRANSFORMABLE_PROPS.concat(["ignore"]);
var DEFAULT_ANIMATABLE_MAP = reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = true;
  return obj;
}, { ignore: false });
var tmpTextPosCalcRes = {};
var tmpBoundingRect = new BoundingRect$1(0, 0, 0, 0);
var Element$1 = function() {
  function Element2(props) {
    this.id = guid();
    this.animators = [];
    this.currentStates = [];
    this.states = {};
    this._init(props);
  }
  Element2.prototype._init = function(props) {
    this.attr(props);
  };
  Element2.prototype.drift = function(dx, dy, e2) {
    switch (this.draggable) {
      case "horizontal":
        dy = 0;
        break;
      case "vertical":
        dx = 0;
        break;
    }
    var m2 = this.transform;
    if (!m2) {
      m2 = this.transform = [1, 0, 0, 1, 0, 0];
    }
    m2[4] += dx;
    m2[5] += dy;
    this.decomposeTransform();
    this.markRedraw();
  };
  Element2.prototype.beforeUpdate = function() {
  };
  Element2.prototype.afterUpdate = function() {
  };
  Element2.prototype.update = function() {
    this.updateTransform();
    if (this.__dirty) {
      this.updateInnerText();
    }
  };
  Element2.prototype.updateInnerText = function(forceUpdate) {
    var textEl = this._textContent;
    if (textEl && (!textEl.ignore || forceUpdate)) {
      if (!this.textConfig) {
        this.textConfig = {};
      }
      var textConfig = this.textConfig;
      var isLocal = textConfig.local;
      var innerTransformable = textEl.innerTransformable;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var textStyleChanged = false;
      innerTransformable.parent = isLocal ? this : null;
      var innerOrigin = false;
      innerTransformable.copyTransform(textEl);
      if (textConfig.position != null) {
        var layoutRect = tmpBoundingRect;
        if (textConfig.layoutRect) {
          layoutRect.copy(textConfig.layoutRect);
        } else {
          layoutRect.copy(this.getBoundingRect());
        }
        if (!isLocal) {
          layoutRect.applyTransform(this.transform);
        }
        if (this.calculateTextPosition) {
          this.calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        } else {
          calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        }
        innerTransformable.x = tmpTextPosCalcRes.x;
        innerTransformable.y = tmpTextPosCalcRes.y;
        textAlign = tmpTextPosCalcRes.align;
        textVerticalAlign = tmpTextPosCalcRes.verticalAlign;
        var textOrigin = textConfig.origin;
        if (textOrigin && textConfig.rotation != null) {
          var relOriginX = void 0;
          var relOriginY = void 0;
          if (textOrigin === "center") {
            relOriginX = layoutRect.width * 0.5;
            relOriginY = layoutRect.height * 0.5;
          } else {
            relOriginX = parsePercent$1(textOrigin[0], layoutRect.width);
            relOriginY = parsePercent$1(textOrigin[1], layoutRect.height);
          }
          innerOrigin = true;
          innerTransformable.originX = -innerTransformable.x + relOriginX + (isLocal ? 0 : layoutRect.x);
          innerTransformable.originY = -innerTransformable.y + relOriginY + (isLocal ? 0 : layoutRect.y);
        }
      }
      if (textConfig.rotation != null) {
        innerTransformable.rotation = textConfig.rotation;
      }
      var textOffset = textConfig.offset;
      if (textOffset) {
        innerTransformable.x += textOffset[0];
        innerTransformable.y += textOffset[1];
        if (!innerOrigin) {
          innerTransformable.originX = -textOffset[0];
          innerTransformable.originY = -textOffset[1];
        }
      }
      var isInside = textConfig.inside == null ? typeof textConfig.position === "string" && textConfig.position.indexOf("inside") >= 0 : textConfig.inside;
      var innerTextDefaultStyle = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {});
      var textFill = void 0;
      var textStroke = void 0;
      var autoStroke = void 0;
      if (isInside && this.canBeInsideText()) {
        textFill = textConfig.insideFill;
        textStroke = textConfig.insideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getInsideTextFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getInsideTextStroke(textFill);
          autoStroke = true;
        }
      } else {
        textFill = textConfig.outsideFill;
        textStroke = textConfig.outsideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getOutsideFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getOutsideStroke(textFill);
          autoStroke = true;
        }
      }
      textFill = textFill || "#000";
      if (textFill !== innerTextDefaultStyle.fill || textStroke !== innerTextDefaultStyle.stroke || autoStroke !== innerTextDefaultStyle.autoStroke || textAlign !== innerTextDefaultStyle.align || textVerticalAlign !== innerTextDefaultStyle.verticalAlign) {
        textStyleChanged = true;
        innerTextDefaultStyle.fill = textFill;
        innerTextDefaultStyle.stroke = textStroke;
        innerTextDefaultStyle.autoStroke = autoStroke;
        innerTextDefaultStyle.align = textAlign;
        innerTextDefaultStyle.verticalAlign = textVerticalAlign;
        textEl.setDefaultTextStyle(innerTextDefaultStyle);
      }
      textEl.__dirty |= REDRAW_BIT;
      if (textStyleChanged) {
        textEl.dirtyStyle(true);
      }
    }
  };
  Element2.prototype.canBeInsideText = function() {
    return true;
  };
  Element2.prototype.getInsideTextFill = function() {
    return "#fff";
  };
  Element2.prototype.getInsideTextStroke = function(textFill) {
    return "#000";
  };
  Element2.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? LIGHT_LABEL_COLOR : DARK_LABEL_COLOR;
  };
  Element2.prototype.getOutsideStroke = function(textFill) {
    var backgroundColor2 = this.__zr && this.__zr.getBackgroundColor();
    var colorArr = typeof backgroundColor2 === "string" && parse$1(backgroundColor2);
    if (!colorArr) {
      colorArr = [255, 255, 255, 1];
    }
    var alpha = colorArr[3];
    var isDark = this.__zr.isDarkMode();
    for (var i = 0; i < 3; i++) {
      colorArr[i] = colorArr[i] * alpha + (isDark ? 0 : 255) * (1 - alpha);
    }
    colorArr[3] = 1;
    return stringify(colorArr, "rgba");
  };
  Element2.prototype.traverse = function(cb2, context) {
  };
  Element2.prototype.attrKV = function(key, value) {
    if (key === "textConfig") {
      this.setTextConfig(value);
    } else if (key === "textContent") {
      this.setTextContent(value);
    } else if (key === "clipPath") {
      this.setClipPath(value);
    } else if (key === "extra") {
      this.extra = this.extra || {};
      extend(this.extra, value);
    } else {
      this[key] = value;
    }
  };
  Element2.prototype.hide = function() {
    this.ignore = true;
    this.markRedraw();
  };
  Element2.prototype.show = function() {
    this.ignore = false;
    this.markRedraw();
  };
  Element2.prototype.attr = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.attrKV(keyOrObj, value);
    } else if (isObject$6(keyOrObj)) {
      var obj = keyOrObj;
      var keysArr = keys(obj);
      for (var i = 0; i < keysArr.length; i++) {
        var key = keysArr[i];
        this.attrKV(key, keyOrObj[key]);
      }
    }
    this.markRedraw();
    return this;
  };
  Element2.prototype.saveCurrentToNormalState = function(toState) {
    this._innerSaveToNormal(toState);
    var normalState = this._normalState;
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      var fromStateTransition = animator.__fromStateTransition;
      if (animator.getLoop() || fromStateTransition && fromStateTransition !== PRESERVED_NORMAL_STATE) {
        continue;
      }
      var targetName = animator.targetName;
      var target = targetName ? normalState[targetName] : normalState;
      animator.saveTo(target);
    }
  };
  Element2.prototype._innerSaveToNormal = function(toState) {
    var normalState = this._normalState;
    if (!normalState) {
      normalState = this._normalState = {};
    }
    if (toState.textConfig && !normalState.textConfig) {
      normalState.textConfig = this.textConfig;
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS$1);
  };
  Element2.prototype._savePrimaryToNormal = function(toState, normalState, primaryKeys) {
    for (var i = 0; i < primaryKeys.length; i++) {
      var key = primaryKeys[i];
      if (toState[key] != null && !(key in normalState)) {
        normalState[key] = this[key];
      }
    }
  };
  Element2.prototype.hasState = function() {
    return this.currentStates.length > 0;
  };
  Element2.prototype.getState = function(name2) {
    return this.states[name2];
  };
  Element2.prototype.ensureState = function(name2) {
    var states = this.states;
    if (!states[name2]) {
      states[name2] = {};
    }
    return states[name2];
  };
  Element2.prototype.clearStates = function(noAnimation) {
    this.useState(PRESERVED_NORMAL_STATE, false, noAnimation);
  };
  Element2.prototype.useState = function(stateName, keepCurrentStates, noAnimation, forceUseHoverLayer) {
    var toNormalState = stateName === PRESERVED_NORMAL_STATE;
    var hasStates = this.hasState();
    if (!hasStates && toNormalState) {
      return;
    }
    var currentStates = this.currentStates;
    var animationCfg = this.stateTransition;
    if (indexOf(currentStates, stateName) >= 0 && (keepCurrentStates || currentStates.length === 1)) {
      return;
    }
    var state;
    if (this.stateProxy && !toNormalState) {
      state = this.stateProxy(stateName);
    }
    if (!state) {
      state = this.states && this.states[stateName];
    }
    if (!state && !toNormalState) {
      logError("State " + stateName + " not exists.");
      return;
    }
    if (!toNormalState) {
      this.saveCurrentToNormalState(state);
    }
    var useHoverLayer = !!(state && state.hoverLayer || forceUseHoverLayer);
    if (useHoverLayer) {
      this._toggleHoverLayerFlag(true);
    }
    this._applyStateObj(stateName, state, this._normalState, keepCurrentStates, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (textGuide) {
      textGuide.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (toNormalState) {
      this.currentStates = [];
      this._normalState = {};
    } else {
      if (!keepCurrentStates) {
        this.currentStates = [stateName];
      } else {
        this.currentStates.push(stateName);
      }
    }
    this._updateAnimationTargets();
    this.markRedraw();
    if (!useHoverLayer && this.__inHover) {
      this._toggleHoverLayerFlag(false);
      this.__dirty &= ~REDRAW_BIT;
    }
    return state;
  };
  Element2.prototype.useStates = function(states, noAnimation, forceUseHoverLayer) {
    if (!states.length) {
      this.clearStates();
    } else {
      var stateObjects = [];
      var currentStates = this.currentStates;
      var len2 = states.length;
      var notChange = len2 === currentStates.length;
      if (notChange) {
        for (var i = 0; i < len2; i++) {
          if (states[i] !== currentStates[i]) {
            notChange = false;
            break;
          }
        }
      }
      if (notChange) {
        return;
      }
      for (var i = 0; i < len2; i++) {
        var stateName = states[i];
        var stateObj = void 0;
        if (this.stateProxy) {
          stateObj = this.stateProxy(stateName, states);
        }
        if (!stateObj) {
          stateObj = this.states[stateName];
        }
        if (stateObj) {
          stateObjects.push(stateObj);
        }
      }
      var lastStateObj = stateObjects[len2 - 1];
      var useHoverLayer = !!(lastStateObj && lastStateObj.hoverLayer || forceUseHoverLayer);
      if (useHoverLayer) {
        this._toggleHoverLayerFlag(true);
      }
      var mergedState = this._mergeStates(stateObjects);
      var animationCfg = this.stateTransition;
      this.saveCurrentToNormalState(mergedState);
      this._applyStateObj(states.join(","), mergedState, this._normalState, false, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
      var textContent = this._textContent;
      var textGuide = this._textGuide;
      if (textContent) {
        textContent.useStates(states, noAnimation, useHoverLayer);
      }
      if (textGuide) {
        textGuide.useStates(states, noAnimation, useHoverLayer);
      }
      this._updateAnimationTargets();
      this.currentStates = states.slice();
      this.markRedraw();
      if (!useHoverLayer && this.__inHover) {
        this._toggleHoverLayerFlag(false);
        this.__dirty &= ~REDRAW_BIT;
      }
    }
  };
  Element2.prototype._updateAnimationTargets = function() {
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      if (animator.targetName) {
        animator.changeTarget(this[animator.targetName]);
      }
    }
  };
  Element2.prototype.removeState = function(state) {
    var idx = indexOf(this.currentStates, state);
    if (idx >= 0) {
      var currentStates = this.currentStates.slice();
      currentStates.splice(idx, 1);
      this.useStates(currentStates);
    }
  };
  Element2.prototype.replaceState = function(oldState, newState, forceAdd) {
    var currentStates = this.currentStates.slice();
    var idx = indexOf(currentStates, oldState);
    var newStateExists = indexOf(currentStates, newState) >= 0;
    if (idx >= 0) {
      if (!newStateExists) {
        currentStates[idx] = newState;
      } else {
        currentStates.splice(idx, 1);
      }
    } else if (forceAdd && !newStateExists) {
      currentStates.push(newState);
    }
    this.useStates(currentStates);
  };
  Element2.prototype.toggleState = function(state, enable) {
    if (enable) {
      this.useState(state, true);
    } else {
      this.removeState(state);
    }
  };
  Element2.prototype._mergeStates = function(states) {
    var mergedState = {};
    var mergedTextConfig;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      extend(mergedState, state);
      if (state.textConfig) {
        mergedTextConfig = mergedTextConfig || {};
        extend(mergedTextConfig, state.textConfig);
      }
    }
    if (mergedTextConfig) {
      mergedState.textConfig = mergedTextConfig;
    }
    return mergedState;
  };
  Element2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    var needsRestoreToNormal = !(state && keepCurrentStates);
    if (state && state.textConfig) {
      this.textConfig = extend({}, keepCurrentStates ? this.textConfig : normalState.textConfig);
      extend(this.textConfig, state.textConfig);
    } else if (needsRestoreToNormal) {
      if (normalState.textConfig) {
        this.textConfig = normalState.textConfig;
      }
    }
    var transitionTarget = {};
    var hasTransition = false;
    for (var i = 0; i < PRIMARY_STATES_KEYS$1.length; i++) {
      var key = PRIMARY_STATES_KEYS$1[i];
      var propNeedsTransition = transition && DEFAULT_ANIMATABLE_MAP[key];
      if (state && state[key] != null) {
        if (propNeedsTransition) {
          hasTransition = true;
          transitionTarget[key] = state[key];
        } else {
          this[key] = state[key];
        }
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          if (propNeedsTransition) {
            hasTransition = true;
            transitionTarget[key] = normalState[key];
          } else {
            this[key] = normalState[key];
          }
        }
      }
    }
    if (!transition) {
      for (var i = 0; i < this.animators.length; i++) {
        var animator = this.animators[i];
        var targetName = animator.targetName;
        if (!animator.getLoop()) {
          animator.__changeFinalValue(targetName ? (state || normalState)[targetName] : state || normalState);
        }
      }
    }
    if (hasTransition) {
      this._transitionState(stateName, transitionTarget, animationCfg);
    }
  };
  Element2.prototype._attachComponent = function(componentEl) {
    if (componentEl.__zr && !componentEl.__hostTarget) {
      return;
    }
    if (componentEl === this) {
      return;
    }
    var zr = this.__zr;
    if (zr) {
      componentEl.addSelfToZr(zr);
    }
    componentEl.__zr = zr;
    componentEl.__hostTarget = this;
  };
  Element2.prototype._detachComponent = function(componentEl) {
    if (componentEl.__zr) {
      componentEl.removeSelfFromZr(componentEl.__zr);
    }
    componentEl.__zr = null;
    componentEl.__hostTarget = null;
  };
  Element2.prototype.getClipPath = function() {
    return this._clipPath;
  };
  Element2.prototype.setClipPath = function(clipPath) {
    if (this._clipPath && this._clipPath !== clipPath) {
      this.removeClipPath();
    }
    this._attachComponent(clipPath);
    this._clipPath = clipPath;
    this.markRedraw();
  };
  Element2.prototype.removeClipPath = function() {
    var clipPath = this._clipPath;
    if (clipPath) {
      this._detachComponent(clipPath);
      this._clipPath = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextContent = function() {
    return this._textContent;
  };
  Element2.prototype.setTextContent = function(textEl) {
    var previousTextContent = this._textContent;
    if (previousTextContent === textEl) {
      return;
    }
    if (previousTextContent && previousTextContent !== textEl) {
      this.removeTextContent();
    }
    textEl.innerTransformable = new Transformable$1();
    this._attachComponent(textEl);
    this._textContent = textEl;
    this.markRedraw();
  };
  Element2.prototype.setTextConfig = function(cfg) {
    if (!this.textConfig) {
      this.textConfig = {};
    }
    extend(this.textConfig, cfg);
    this.markRedraw();
  };
  Element2.prototype.removeTextConfig = function() {
    this.textConfig = null;
    this.markRedraw();
  };
  Element2.prototype.removeTextContent = function() {
    var textEl = this._textContent;
    if (textEl) {
      textEl.innerTransformable = null;
      this._detachComponent(textEl);
      this._textContent = null;
      this._innerTextDefaultStyle = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextGuideLine = function() {
    return this._textGuide;
  };
  Element2.prototype.setTextGuideLine = function(guideLine) {
    if (this._textGuide && this._textGuide !== guideLine) {
      this.removeTextGuideLine();
    }
    this._attachComponent(guideLine);
    this._textGuide = guideLine;
    this.markRedraw();
  };
  Element2.prototype.removeTextGuideLine = function() {
    var textGuide = this._textGuide;
    if (textGuide) {
      this._detachComponent(textGuide);
      this._textGuide = null;
      this.markRedraw();
    }
  };
  Element2.prototype.markRedraw = function() {
    this.__dirty |= REDRAW_BIT;
    var zr = this.__zr;
    if (zr) {
      if (this.__inHover) {
        zr.refreshHover();
      } else {
        zr.refresh();
      }
    }
    if (this.__hostTarget) {
      this.__hostTarget.markRedraw();
    }
  };
  Element2.prototype.dirty = function() {
    this.markRedraw();
  };
  Element2.prototype._toggleHoverLayerFlag = function(inHover) {
    this.__inHover = inHover;
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.__inHover = inHover;
    }
    if (textGuide) {
      textGuide.__inHover = inHover;
    }
  };
  Element2.prototype.addSelfToZr = function(zr) {
    if (this.__zr === zr) {
      return;
    }
    this.__zr = zr;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.addAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.addSelfToZr(zr);
    }
    if (this._textContent) {
      this._textContent.addSelfToZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.addSelfToZr(zr);
    }
  };
  Element2.prototype.removeSelfFromZr = function(zr) {
    if (!this.__zr) {
      return;
    }
    this.__zr = null;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.removeAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.removeSelfFromZr(zr);
    }
    if (this._textContent) {
      this._textContent.removeSelfFromZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.removeSelfFromZr(zr);
    }
  };
  Element2.prototype.animate = function(key, loop, allowDiscreteAnimation) {
    var target = key ? this[key] : this;
    var animator = new Animator(target, loop, allowDiscreteAnimation);
    key && (animator.targetName = key);
    this.addAnimator(animator, key);
    return animator;
  };
  Element2.prototype.addAnimator = function(animator, key) {
    var zr = this.__zr;
    var el = this;
    animator.during(function() {
      el.updateDuringAnimation(key);
    }).done(function() {
      var animators = el.animators;
      var idx = indexOf(animators, animator);
      if (idx >= 0) {
        animators.splice(idx, 1);
      }
    });
    this.animators.push(animator);
    if (zr) {
      zr.animation.addAnimator(animator);
    }
    zr && zr.wakeUp();
  };
  Element2.prototype.updateDuringAnimation = function(key) {
    this.markRedraw();
  };
  Element2.prototype.stopAnimation = function(scope, forwardToLast) {
    var animators = this.animators;
    var len2 = animators.length;
    var leftAnimators = [];
    for (var i = 0; i < len2; i++) {
      var animator = animators[i];
      if (!scope || scope === animator.scope) {
        animator.stop(forwardToLast);
      } else {
        leftAnimators.push(animator);
      }
    }
    this.animators = leftAnimators;
    return this;
  };
  Element2.prototype.animateTo = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps);
  };
  Element2.prototype.animateFrom = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps, true);
  };
  Element2.prototype._transitionState = function(stateName, target, cfg, animationProps) {
    var animators = animateTo(this, target, cfg, animationProps);
    for (var i = 0; i < animators.length; i++) {
      animators[i].__fromStateTransition = stateName;
    }
  };
  Element2.prototype.getBoundingRect = function() {
    return null;
  };
  Element2.prototype.getPaintRect = function() {
    return null;
  };
  Element2.initDefaultProps = function() {
    var elProto = Element2.prototype;
    elProto.type = "element";
    elProto.name = "";
    elProto.ignore = elProto.silent = elProto.isGroup = elProto.draggable = elProto.dragging = elProto.ignoreClip = elProto.__inHover = false;
    elProto.__dirty = REDRAW_BIT;
    function createLegacyProperty(key, privateKey, xKey, yKey) {
      Object.defineProperty(elProto, key, {
        get: function() {
          if (!this[privateKey]) {
            var pos = this[privateKey] = [];
            enhanceArray(this, pos);
          }
          return this[privateKey];
        },
        set: function(pos) {
          this[xKey] = pos[0];
          this[yKey] = pos[1];
          this[privateKey] = pos;
          enhanceArray(this, pos);
        }
      });
      function enhanceArray(self2, pos) {
        Object.defineProperty(pos, 0, {
          get: function() {
            return self2[xKey];
          },
          set: function(val) {
            self2[xKey] = val;
          }
        });
        Object.defineProperty(pos, 1, {
          get: function() {
            return self2[yKey];
          },
          set: function(val) {
            self2[yKey] = val;
          }
        });
      }
    }
    if (Object.defineProperty) {
      createLegacyProperty("position", "_legacyPos", "x", "y");
      createLegacyProperty("scale", "_legacyScale", "scaleX", "scaleY");
      createLegacyProperty("origin", "_legacyOrigin", "originX", "originY");
    }
  }();
  return Element2;
}();
mixin(Element$1, Eventful$1);
mixin(Element$1, Transformable$1);
function animateTo(animatable, target, cfg, animationProps, reverse2) {
  cfg = cfg || {};
  var animators = [];
  animateToShallow(animatable, "", animatable, target, cfg, animationProps, animators, reverse2);
  var finishCount = animators.length;
  var doneHappened = false;
  var cfgDone = cfg.done;
  var cfgAborted = cfg.aborted;
  var doneCb = function() {
    doneHappened = true;
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  var abortedCb = function() {
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  if (!finishCount) {
    cfgDone && cfgDone();
  }
  if (animators.length > 0 && cfg.during) {
    animators[0].during(function(target2, percent) {
      cfg.during(percent);
    });
  }
  for (var i = 0; i < animators.length; i++) {
    var animator = animators[i];
    if (doneCb) {
      animator.done(doneCb);
    }
    if (abortedCb) {
      animator.aborted(abortedCb);
    }
    if (cfg.force) {
      animator.duration(cfg.duration);
    }
    animator.start(cfg.easing);
  }
  return animators;
}
function copyArrShallow(source, target, len2) {
  for (var i = 0; i < len2; i++) {
    source[i] = target[i];
  }
}
function is2DArray(value) {
  return isArrayLike(value[0]);
}
function copyValue(target, source, key) {
  if (isArrayLike(source[key])) {
    if (!isArrayLike(target[key])) {
      target[key] = [];
    }
    if (isTypedArray(source[key])) {
      var len2 = source[key].length;
      if (target[key].length !== len2) {
        target[key] = new source[key].constructor(len2);
        copyArrShallow(target[key], source[key], len2);
      }
    } else {
      var sourceArr = source[key];
      var targetArr = target[key];
      var len0 = sourceArr.length;
      if (is2DArray(sourceArr)) {
        var len1 = sourceArr[0].length;
        for (var i = 0; i < len0; i++) {
          if (!targetArr[i]) {
            targetArr[i] = Array.prototype.slice.call(sourceArr[i]);
          } else {
            copyArrShallow(targetArr[i], sourceArr[i], len1);
          }
        }
      } else {
        copyArrShallow(targetArr, sourceArr, len0);
      }
      targetArr.length = sourceArr.length;
    }
  } else {
    target[key] = source[key];
  }
}
function isValueSame(val1, val2) {
  return val1 === val2 || isArrayLike(val1) && isArrayLike(val2) && is1DArraySame(val1, val2);
}
function is1DArraySame(arr0, arr1) {
  var len2 = arr0.length;
  if (len2 !== arr1.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    if (arr0[i] !== arr1[i]) {
      return false;
    }
  }
  return true;
}
function animateToShallow(animatable, topKey, animateObj, target, cfg, animationProps, animators, reverse2) {
  var targetKeys = keys(target);
  var duration = cfg.duration;
  var delay = cfg.delay;
  var additive = cfg.additive;
  var setToFinal = cfg.setToFinal;
  var animateAll = !isObject$6(animationProps);
  var existsAnimators = animatable.animators;
  var animationKeys = [];
  for (var k2 = 0; k2 < targetKeys.length; k2++) {
    var innerKey = targetKeys[k2];
    var targetVal = target[innerKey];
    if (targetVal != null && animateObj[innerKey] != null && (animateAll || animationProps[innerKey])) {
      if (isObject$6(targetVal) && !isArrayLike(targetVal) && !isGradientObject(targetVal)) {
        if (topKey) {
          if (!reverse2) {
            animateObj[innerKey] = targetVal;
            animatable.updateDuringAnimation(topKey);
          }
          continue;
        }
        animateToShallow(animatable, innerKey, animateObj[innerKey], targetVal, cfg, animationProps && animationProps[innerKey], animators, reverse2);
      } else {
        animationKeys.push(innerKey);
      }
    } else if (!reverse2) {
      animateObj[innerKey] = targetVal;
      animatable.updateDuringAnimation(topKey);
      animationKeys.push(innerKey);
    }
  }
  var keyLen = animationKeys.length;
  if (!additive && keyLen) {
    for (var i = 0; i < existsAnimators.length; i++) {
      var animator = existsAnimators[i];
      if (animator.targetName === topKey) {
        var allAborted = animator.stopTracks(animationKeys);
        if (allAborted) {
          var idx = indexOf(existsAnimators, animator);
          existsAnimators.splice(idx, 1);
        }
      }
    }
  }
  if (!cfg.force) {
    animationKeys = filter(animationKeys, function(key) {
      return !isValueSame(target[key], animateObj[key]);
    });
    keyLen = animationKeys.length;
  }
  if (keyLen > 0 || cfg.force && !animators.length) {
    var revertedSource = void 0;
    var reversedTarget = void 0;
    var sourceClone = void 0;
    if (reverse2) {
      reversedTarget = {};
      if (setToFinal) {
        revertedSource = {};
      }
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        reversedTarget[innerKey] = animateObj[innerKey];
        if (setToFinal) {
          revertedSource[innerKey] = target[innerKey];
        } else {
          animateObj[innerKey] = target[innerKey];
        }
      }
    } else if (setToFinal) {
      sourceClone = {};
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        sourceClone[innerKey] = cloneValue(animateObj[innerKey]);
        copyValue(animateObj, target, innerKey);
      }
    }
    var animator = new Animator(animateObj, false, false, additive ? filter(existsAnimators, function(animator2) {
      return animator2.targetName === topKey;
    }) : null);
    animator.targetName = topKey;
    if (cfg.scope) {
      animator.scope = cfg.scope;
    }
    if (setToFinal && revertedSource) {
      animator.whenWithKeys(0, revertedSource, animationKeys);
    }
    if (sourceClone) {
      animator.whenWithKeys(0, sourceClone, animationKeys);
    }
    animator.whenWithKeys(duration == null ? 500 : duration, reverse2 ? reversedTarget : target, animationKeys).delay(delay || 0);
    animatable.addAnimator(animator, topKey);
    animators.push(animator);
  }
}
var Element$2 = Element$1;
var Group$5 = function(_super) {
  __extends(Group2, _super);
  function Group2(opts) {
    var _this = _super.call(this) || this;
    _this.isGroup = true;
    _this._children = [];
    _this.attr(opts);
    return _this;
  }
  Group2.prototype.childrenRef = function() {
    return this._children;
  };
  Group2.prototype.children = function() {
    return this._children.slice();
  };
  Group2.prototype.childAt = function(idx) {
    return this._children[idx];
  };
  Group2.prototype.childOfName = function(name2) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].name === name2) {
        return children[i];
      }
    }
  };
  Group2.prototype.childCount = function() {
    return this._children.length;
  };
  Group2.prototype.add = function(child) {
    if (child) {
      if (child !== this && child.parent !== this) {
        this._children.push(child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.addBefore = function(child, nextSibling2) {
    if (child && child !== this && child.parent !== this && nextSibling2 && nextSibling2.parent === this) {
      var children = this._children;
      var idx = children.indexOf(nextSibling2);
      if (idx >= 0) {
        children.splice(idx, 0, child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.replace = function(oldChild, newChild) {
    var idx = indexOf(this._children, oldChild);
    if (idx >= 0) {
      this.replaceAt(newChild, idx);
    }
    return this;
  };
  Group2.prototype.replaceAt = function(child, index2) {
    var children = this._children;
    var old = children[index2];
    if (child && child !== this && child.parent !== this && child !== old) {
      children[index2] = child;
      old.parent = null;
      var zr = this.__zr;
      if (zr) {
        old.removeSelfFromZr(zr);
      }
      this._doAdd(child);
    }
    return this;
  };
  Group2.prototype._doAdd = function(child) {
    if (child.parent) {
      child.parent.remove(child);
    }
    child.parent = this;
    var zr = this.__zr;
    if (zr && zr !== child.__zr) {
      child.addSelfToZr(zr);
    }
    zr && zr.refresh();
  };
  Group2.prototype.remove = function(child) {
    var zr = this.__zr;
    var children = this._children;
    var idx = indexOf(children, child);
    if (idx < 0) {
      return this;
    }
    children.splice(idx, 1);
    child.parent = null;
    if (zr) {
      child.removeSelfFromZr(zr);
    }
    zr && zr.refresh();
    return this;
  };
  Group2.prototype.removeAll = function() {
    var children = this._children;
    var zr = this.__zr;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (zr) {
        child.removeSelfFromZr(zr);
      }
      child.parent = null;
    }
    children.length = 0;
    return this;
  };
  Group2.prototype.eachChild = function(cb2, context) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      cb2.call(context, child, i);
    }
    return this;
  };
  Group2.prototype.traverse = function(cb2, context) {
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      var stopped = cb2.call(context, child);
      if (child.isGroup && !stopped) {
        child.traverse(cb2, context);
      }
    }
    return this;
  };
  Group2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.addSelfToZr(zr);
    }
  };
  Group2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.removeSelfFromZr(zr);
    }
  };
  Group2.prototype.getBoundingRect = function(includeChildren) {
    var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
    var children = includeChildren || this._children;
    var tmpMat = [];
    var rect = null;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.ignore || child.invisible) {
        continue;
      }
      var childRect = child.getBoundingRect();
      var transform2 = child.getLocalTransform(tmpMat);
      if (transform2) {
        BoundingRect$1.applyTransform(tmpRect2, childRect, transform2);
        rect = rect || tmpRect2.clone();
        rect.union(tmpRect2);
      } else {
        rect = rect || childRect.clone();
        rect.union(childRect);
      }
    }
    return rect || tmpRect2;
  };
  return Group2;
}(Element$2);
Group$5.prototype.type = "group";
var Group$6 = Group$5;
/*!
* ZRender, a high performance 2d drawing library.
*
* Copyright (c) 2013, Baidu Inc.
* All rights reserved.
*
* LICENSE
* https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
*/
var painterCtors = {};
var instances$1 = {};
function delInstance(id2) {
  delete instances$1[id2];
}
function isDarkMode(backgroundColor2) {
  if (!backgroundColor2) {
    return false;
  }
  if (typeof backgroundColor2 === "string") {
    return lum(backgroundColor2, 1) < DARK_MODE_THRESHOLD;
  } else if (backgroundColor2.colorStops) {
    var colorStops = backgroundColor2.colorStops;
    var totalLum = 0;
    var len2 = colorStops.length;
    for (var i = 0; i < len2; i++) {
      totalLum += lum(colorStops[i].color, 1);
    }
    totalLum /= len2;
    return totalLum < DARK_MODE_THRESHOLD;
  }
  return false;
}
var ZRender = function() {
  function ZRender2(id2, dom, opts) {
    var _this = this;
    this._sleepAfterStill = 10;
    this._stillFrameAccum = 0;
    this._needsRefresh = true;
    this._needsRefreshHover = true;
    this._darkMode = false;
    opts = opts || {};
    this.dom = dom;
    this.id = id2;
    var storage2 = new Storage$1();
    var rendererType = opts.renderer || "canvas";
    if (!painterCtors[rendererType]) {
      rendererType = keys(painterCtors)[0];
    }
    opts.useDirtyRect = opts.useDirtyRect == null ? false : opts.useDirtyRect;
    var painter = new painterCtors[rendererType](dom, storage2, opts, id2);
    var ssrMode = opts.ssr || painter.ssrOnly;
    this.storage = storage2;
    this.painter = painter;
    var handerProxy = !env$1.node && !env$1.worker && !ssrMode ? new HandlerProxy(painter.getViewportRoot(), painter.root) : null;
    this.handler = new Handler$1(storage2, painter, handerProxy, painter.root);
    this.animation = new Animation$1({
      stage: {
        update: ssrMode ? null : function() {
          return _this._flush(true);
        }
      }
    });
    if (!ssrMode) {
      this.animation.start();
    }
  }
  ZRender2.prototype.add = function(el) {
    if (!el) {
      return;
    }
    this.storage.addRoot(el);
    el.addSelfToZr(this);
    this.refresh();
  };
  ZRender2.prototype.remove = function(el) {
    if (!el) {
      return;
    }
    this.storage.delRoot(el);
    el.removeSelfFromZr(this);
    this.refresh();
  };
  ZRender2.prototype.configLayer = function(zLevel, config2) {
    if (this.painter.configLayer) {
      this.painter.configLayer(zLevel, config2);
    }
    this.refresh();
  };
  ZRender2.prototype.setBackgroundColor = function(backgroundColor2) {
    if (this.painter.setBackgroundColor) {
      this.painter.setBackgroundColor(backgroundColor2);
    }
    this.refresh();
    this._backgroundColor = backgroundColor2;
    this._darkMode = isDarkMode(backgroundColor2);
  };
  ZRender2.prototype.getBackgroundColor = function() {
    return this._backgroundColor;
  };
  ZRender2.prototype.setDarkMode = function(darkMode) {
    this._darkMode = darkMode;
  };
  ZRender2.prototype.isDarkMode = function() {
    return this._darkMode;
  };
  ZRender2.prototype.refreshImmediately = function(fromInside) {
    if (!fromInside) {
      this.animation.update(true);
    }
    this._needsRefresh = false;
    this.painter.refresh();
    this._needsRefresh = false;
  };
  ZRender2.prototype.refresh = function() {
    this._needsRefresh = true;
    this.animation.start();
  };
  ZRender2.prototype.flush = function() {
    this._flush(false);
  };
  ZRender2.prototype._flush = function(fromInside) {
    var triggerRendered;
    var start2 = getTime();
    if (this._needsRefresh) {
      triggerRendered = true;
      this.refreshImmediately(fromInside);
    }
    if (this._needsRefreshHover) {
      triggerRendered = true;
      this.refreshHoverImmediately();
    }
    var end2 = getTime();
    if (triggerRendered) {
      this._stillFrameAccum = 0;
      this.trigger("rendered", {
        elapsedTime: end2 - start2
      });
    } else if (this._sleepAfterStill > 0) {
      this._stillFrameAccum++;
      if (this._stillFrameAccum > this._sleepAfterStill) {
        this.animation.stop();
      }
    }
  };
  ZRender2.prototype.setSleepAfterStill = function(stillFramesCount) {
    this._sleepAfterStill = stillFramesCount;
  };
  ZRender2.prototype.wakeUp = function() {
    this.animation.start();
    this._stillFrameAccum = 0;
  };
  ZRender2.prototype.refreshHover = function() {
    this._needsRefreshHover = true;
  };
  ZRender2.prototype.refreshHoverImmediately = function() {
    this._needsRefreshHover = false;
    if (this.painter.refreshHover && this.painter.getType() === "canvas") {
      this.painter.refreshHover();
    }
  };
  ZRender2.prototype.resize = function(opts) {
    opts = opts || {};
    this.painter.resize(opts.width, opts.height);
    this.handler.resize();
  };
  ZRender2.prototype.clearAnimation = function() {
    this.animation.clear();
  };
  ZRender2.prototype.getWidth = function() {
    return this.painter.getWidth();
  };
  ZRender2.prototype.getHeight = function() {
    return this.painter.getHeight();
  };
  ZRender2.prototype.setCursorStyle = function(cursorStyle) {
    this.handler.setCursorStyle(cursorStyle);
  };
  ZRender2.prototype.findHover = function(x2, y2) {
    return this.handler.findHover(x2, y2);
  };
  ZRender2.prototype.on = function(eventName, eventHandler, context) {
    this.handler.on(eventName, eventHandler, context);
    return this;
  };
  ZRender2.prototype.off = function(eventName, eventHandler) {
    this.handler.off(eventName, eventHandler);
  };
  ZRender2.prototype.trigger = function(eventName, event) {
    this.handler.trigger(eventName, event);
  };
  ZRender2.prototype.clear = function() {
    var roots2 = this.storage.getRoots();
    for (var i = 0; i < roots2.length; i++) {
      if (roots2[i] instanceof Group$6) {
        roots2[i].removeSelfFromZr(this);
      }
    }
    this.storage.delAllRoots();
    this.painter.clear();
  };
  ZRender2.prototype.dispose = function() {
    this.animation.stop();
    this.clear();
    this.storage.dispose();
    this.painter.dispose();
    this.handler.dispose();
    this.animation = this.storage = this.painter = this.handler = null;
    delInstance(this.id);
  };
  return ZRender2;
}();
function init$3(dom, opts) {
  var zr = new ZRender(guid(), dom, opts);
  instances$1[zr.id] = zr;
  return zr;
}
function registerPainter(name2, Ctor) {
  painterCtors[name2] = Ctor;
}
var RADIAN_EPSILON = 1e-4;
var ROUND_SUPPORTED_PRECISION_MAX = 20;
function _trim(str) {
  return str.replace(/^\s+|\s+$/g, "");
}
function linearMap$2(val, domain, range3, clamp2) {
  var d0 = domain[0];
  var d1 = domain[1];
  var r0 = range3[0];
  var r1 = range3[1];
  var subDomain = d1 - d0;
  var subRange = r1 - r0;
  if (subDomain === 0) {
    return subRange === 0 ? r0 : (r0 + r1) / 2;
  }
  if (clamp2) {
    if (subDomain > 0) {
      if (val <= d0) {
        return r0;
      } else if (val >= d1) {
        return r1;
      }
    } else {
      if (val >= d0) {
        return r0;
      } else if (val <= d1) {
        return r1;
      }
    }
  } else {
    if (val === d0) {
      return r0;
    }
    if (val === d1) {
      return r1;
    }
  }
  return (val - d0) / subDomain * subRange + r0;
}
function parsePercent(percent, all) {
  switch (percent) {
    case "center":
    case "middle":
      percent = "50%";
      break;
    case "left":
    case "top":
      percent = "0%";
      break;
    case "right":
    case "bottom":
      percent = "100%";
      break;
  }
  if (isString$1(percent)) {
    if (_trim(percent).match(/%$/)) {
      return parseFloat(percent) / 100 * all;
    }
    return parseFloat(percent);
  }
  return percent == null ? NaN : +percent;
}
function round$3(x2, precision, returnStr) {
  if (precision == null) {
    precision = 10;
  }
  precision = Math.min(Math.max(0, precision), ROUND_SUPPORTED_PRECISION_MAX);
  x2 = (+x2).toFixed(precision);
  return returnStr ? x2 : +x2;
}
function asc$2(arr) {
  arr.sort(function(a, b2) {
    return a - b2;
  });
  return arr;
}
function getPrecision(val) {
  val = +val;
  if (isNaN(val)) {
    return 0;
  }
  if (val > 1e-14) {
    var e2 = 1;
    for (var i = 0; i < 15; i++, e2 *= 10) {
      if (Math.round(val * e2) / e2 === val) {
        return i;
      }
    }
  }
  return getPrecisionSafe(val);
}
function getPrecisionSafe(val) {
  var str = val.toString().toLowerCase();
  var eIndex = str.indexOf("e");
  var exp = eIndex > 0 ? +str.slice(eIndex + 1) : 0;
  var significandPartLen = eIndex > 0 ? eIndex : str.length;
  var dotIndex = str.indexOf(".");
  var decimalPartLen = dotIndex < 0 ? 0 : significandPartLen - 1 - dotIndex;
  return Math.max(0, decimalPartLen - exp);
}
function getPixelPrecision(dataExtent, pixelExtent) {
  var log = Math.log;
  var LN10 = Math.LN10;
  var dataQuantity = Math.floor(log(dataExtent[1] - dataExtent[0]) / LN10);
  var sizeQuantity = Math.round(log(Math.abs(pixelExtent[1] - pixelExtent[0])) / LN10);
  var precision = Math.min(Math.max(-dataQuantity + sizeQuantity, 0), 20);
  return !isFinite(precision) ? 20 : precision;
}
function getPercentWithPrecision(valueList, idx, precision) {
  if (!valueList[idx]) {
    return 0;
  }
  var sum2 = reduce(valueList, function(acc, val) {
    return acc + (isNaN(val) ? 0 : val);
  }, 0);
  if (sum2 === 0) {
    return 0;
  }
  var digits = Math.pow(10, precision);
  var votesPerQuota = map$1(valueList, function(val) {
    return (isNaN(val) ? 0 : val) / sum2 * digits * 100;
  });
  var targetSeats = digits * 100;
  var seats = map$1(votesPerQuota, function(votes) {
    return Math.floor(votes);
  });
  var currentSum = reduce(seats, function(acc, val) {
    return acc + val;
  }, 0);
  var remainder = map$1(votesPerQuota, function(votes, idx2) {
    return votes - seats[idx2];
  });
  while (currentSum < targetSeats) {
    var max3 = Number.NEGATIVE_INFINITY;
    var maxId = null;
    for (var i = 0, len2 = remainder.length; i < len2; ++i) {
      if (remainder[i] > max3) {
        max3 = remainder[i];
        maxId = i;
      }
    }
    ++seats[maxId];
    remainder[maxId] = 0;
    ++currentSum;
  }
  return seats[idx] / digits;
}
function addSafe(val0, val1) {
  var maxPrecision = Math.max(getPrecision(val0), getPrecision(val1));
  var sum2 = val0 + val1;
  return maxPrecision > ROUND_SUPPORTED_PRECISION_MAX ? sum2 : round$3(sum2, maxPrecision);
}
var MAX_SAFE_INTEGER = 9007199254740991;
function remRadian(radian) {
  var pi2 = Math.PI * 2;
  return (radian % pi2 + pi2) % pi2;
}
function isRadianAroundZero(val) {
  return val > -RADIAN_EPSILON && val < RADIAN_EPSILON;
}
var TIME_REG = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
function parseDate(value) {
  if (value instanceof Date) {
    return value;
  } else if (isString$1(value)) {
    var match = TIME_REG.exec(value);
    if (!match) {
      return new Date(NaN);
    }
    if (!match[8]) {
      return new Date(+match[1], +(match[2] || 1) - 1, +match[3] || 1, +match[4] || 0, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0);
    } else {
      var hour = +match[4] || 0;
      if (match[8].toUpperCase() !== "Z") {
        hour -= +match[8].slice(0, 3);
      }
      return new Date(Date.UTC(+match[1], +(match[2] || 1) - 1, +match[3] || 1, hour, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0));
    }
  } else if (value == null) {
    return new Date(NaN);
  }
  return new Date(Math.round(value));
}
function quantity(val) {
  return Math.pow(10, quantityExponent(val));
}
function quantityExponent(val) {
  if (val === 0) {
    return 0;
  }
  var exp = Math.floor(Math.log(val) / Math.LN10);
  if (val / Math.pow(10, exp) >= 10) {
    exp++;
  }
  return exp;
}
function nice(val, round2) {
  var exponent = quantityExponent(val);
  var exp10 = Math.pow(10, exponent);
  var f2 = val / exp10;
  var nf2;
  if (round2) {
    if (f2 < 1.5) {
      nf2 = 1;
    } else if (f2 < 2.5) {
      nf2 = 2;
    } else if (f2 < 4) {
      nf2 = 3;
    } else if (f2 < 7) {
      nf2 = 5;
    } else {
      nf2 = 10;
    }
  } else {
    if (f2 < 1) {
      nf2 = 1;
    } else if (f2 < 2) {
      nf2 = 2;
    } else if (f2 < 3) {
      nf2 = 3;
    } else if (f2 < 5) {
      nf2 = 5;
    } else {
      nf2 = 10;
    }
  }
  val = nf2 * exp10;
  return exponent >= -20 ? +val.toFixed(exponent < 0 ? -exponent : 0) : val;
}
function quantile(ascArr, p2) {
  var H2 = (ascArr.length - 1) * p2 + 1;
  var h = Math.floor(H2);
  var v4 = +ascArr[h - 1];
  var e2 = H2 - h;
  return e2 ? v4 + e2 * (ascArr[h] - v4) : v4;
}
function reformIntervals(list) {
  list.sort(function(a, b2) {
    return littleThan2(a, b2, 0) ? -1 : 1;
  });
  var curr = -Infinity;
  var currClose = 1;
  for (var i = 0; i < list.length; ) {
    var interval = list[i].interval;
    var close_1 = list[i].close;
    for (var lg2 = 0; lg2 < 2; lg2++) {
      if (interval[lg2] <= curr) {
        interval[lg2] = curr;
        close_1[lg2] = !lg2 ? 1 - currClose : 1;
      }
      curr = interval[lg2];
      currClose = close_1[lg2];
    }
    if (interval[0] === interval[1] && close_1[0] * close_1[1] !== 1) {
      list.splice(i, 1);
    } else {
      i++;
    }
  }
  return list;
  function littleThan2(a, b2, lg3) {
    return a.interval[lg3] < b2.interval[lg3] || a.interval[lg3] === b2.interval[lg3] && (a.close[lg3] - b2.close[lg3] === (!lg3 ? 1 : -1) || !lg3 && littleThan2(a, b2, 1));
  }
}
function numericToNumber(val) {
  var valFloat = parseFloat(val);
  return valFloat == val && (valFloat !== 0 || !isString$1(val) || val.indexOf("x") <= 0) ? valFloat : NaN;
}
function isNumeric$1(val) {
  return !isNaN(numericToNumber(val));
}
function getRandomIdBase() {
  return Math.round(Math.random() * 9);
}
function getGreatestCommonDividor(a, b2) {
  if (b2 === 0) {
    return a;
  }
  return getGreatestCommonDividor(b2, a % b2);
}
function getLeastCommonMultiple(a, b2) {
  if (a == null) {
    return b2;
  }
  if (b2 == null) {
    return a;
  }
  return a * b2 / getGreatestCommonDividor(a, b2);
}
function throwError$2(msg) {
  throw new Error(msg);
}
function interpolateNumber(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
var DUMMY_COMPONENT_NAME_PREFIX = "series\0";
var INTERNAL_COMPONENT_ID_PREFIX = "\0_ec_\0";
function normalizeToArray(value) {
  return value instanceof Array ? value : value == null ? [] : [value];
}
function defaultEmphasis(opt, key, subOpts) {
  if (opt) {
    opt[key] = opt[key] || {};
    opt.emphasis = opt.emphasis || {};
    opt.emphasis[key] = opt.emphasis[key] || {};
    for (var i = 0, len2 = subOpts.length; i < len2; i++) {
      var subOptName = subOpts[i];
      if (!opt.emphasis[key].hasOwnProperty(subOptName) && opt[key].hasOwnProperty(subOptName)) {
        opt.emphasis[key][subOptName] = opt[key][subOptName];
      }
    }
  }
}
var TEXT_STYLE_OPTIONS = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
function getDataItemValue(dataItem) {
  return isObject$6(dataItem) && !isArray$2(dataItem) && !(dataItem instanceof Date) ? dataItem.value : dataItem;
}
function isDataItemOption(dataItem) {
  return isObject$6(dataItem) && !(dataItem instanceof Array);
}
function mappingToExists(existings, newCmptOptions, mode) {
  var isNormalMergeMode = mode === "normalMerge";
  var isReplaceMergeMode = mode === "replaceMerge";
  var isReplaceAllMode = mode === "replaceAll";
  existings = existings || [];
  newCmptOptions = (newCmptOptions || []).slice();
  var existingIdIdxMap = createHashMap();
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!isObject$6(cmptOption)) {
      newCmptOptions[index2] = null;
      return;
    }
  });
  var result = prepareResult(existings, existingIdIdxMap, mode);
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingById(result, existings, existingIdIdxMap, newCmptOptions);
  }
  if (isNormalMergeMode) {
    mappingByName(result, newCmptOptions);
  }
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingByIndex(result, newCmptOptions, isReplaceMergeMode);
  } else if (isReplaceAllMode) {
    mappingInReplaceAllMode(result, newCmptOptions);
  }
  makeIdAndName(result);
  return result;
}
function prepareResult(existings, existingIdIdxMap, mode) {
  var result = [];
  if (mode === "replaceAll") {
    return result;
  }
  for (var index2 = 0; index2 < existings.length; index2++) {
    var existing = existings[index2];
    if (existing && existing.id != null) {
      existingIdIdxMap.set(existing.id, index2);
    }
    result.push({
      existing: mode === "replaceMerge" || isComponentIdInternal(existing) ? null : existing,
      newOption: null,
      keyInfo: null,
      brandNew: null
    });
  }
  return result;
}
function mappingById(result, existings, existingIdIdxMap, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.id == null) {
      return;
    }
    var optionId = makeComparableKey(cmptOption.id);
    var existingIdx = existingIdIdxMap.get(optionId);
    if (existingIdx != null) {
      var resultItem = result[existingIdx];
      assert(!resultItem.newOption, 'Duplicated option on id "' + optionId + '".');
      resultItem.newOption = cmptOption;
      resultItem.existing = existings[existingIdx];
      newCmptOptions[index2] = null;
    }
  });
}
function mappingByName(result, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.name == null) {
      return;
    }
    for (var i = 0; i < result.length; i++) {
      var existing = result[i].existing;
      if (!result[i].newOption && existing && (existing.id == null || cmptOption.id == null) && !isComponentIdInternal(cmptOption) && !isComponentIdInternal(existing) && keyExistAndEqual("name", existing, cmptOption)) {
        result[i].newOption = cmptOption;
        newCmptOptions[index2] = null;
        return;
      }
    }
  });
}
function mappingByIndex(result, newCmptOptions, brandNew) {
  each$g(newCmptOptions, function(cmptOption) {
    if (!cmptOption) {
      return;
    }
    var resultItem;
    var nextIdx = 0;
    while ((resultItem = result[nextIdx]) && (resultItem.newOption || isComponentIdInternal(resultItem.existing) || resultItem.existing && cmptOption.id != null && !keyExistAndEqual("id", cmptOption, resultItem.existing))) {
      nextIdx++;
    }
    if (resultItem) {
      resultItem.newOption = cmptOption;
      resultItem.brandNew = brandNew;
    } else {
      result.push({
        newOption: cmptOption,
        brandNew,
        existing: null,
        keyInfo: null
      });
    }
    nextIdx++;
  });
}
function mappingInReplaceAllMode(result, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption) {
    result.push({
      newOption: cmptOption,
      brandNew: true,
      existing: null,
      keyInfo: null
    });
  });
}
function makeIdAndName(mapResult) {
  var idMap = createHashMap();
  each$g(mapResult, function(item) {
    var existing = item.existing;
    existing && idMap.set(existing.id, item);
  });
  each$g(mapResult, function(item) {
    var opt = item.newOption;
    assert(!opt || opt.id == null || !idMap.get(opt.id) || idMap.get(opt.id) === item, "id duplicates: " + (opt && opt.id));
    opt && opt.id != null && idMap.set(opt.id, item);
    !item.keyInfo && (item.keyInfo = {});
  });
  each$g(mapResult, function(item, index2) {
    var existing = item.existing;
    var opt = item.newOption;
    var keyInfo = item.keyInfo;
    if (!isObject$6(opt)) {
      return;
    }
    keyInfo.name = opt.name != null ? makeComparableKey(opt.name) : existing ? existing.name : DUMMY_COMPONENT_NAME_PREFIX + index2;
    if (existing) {
      keyInfo.id = makeComparableKey(existing.id);
    } else if (opt.id != null) {
      keyInfo.id = makeComparableKey(opt.id);
    } else {
      var idNum = 0;
      do {
        keyInfo.id = "\0" + keyInfo.name + "\0" + idNum++;
      } while (idMap.get(keyInfo.id));
    }
    idMap.set(keyInfo.id, item);
  });
}
function keyExistAndEqual(attr, obj1, obj2) {
  var key1 = convertOptionIdName(obj1[attr], null);
  var key2 = convertOptionIdName(obj2[attr], null);
  return key1 != null && key2 != null && key1 === key2;
}
function makeComparableKey(val) {
  return convertOptionIdName(val, "");
}
function convertOptionIdName(idOrName, defaultValue) {
  if (idOrName == null) {
    return defaultValue;
  }
  return isString$1(idOrName) ? idOrName : isNumber(idOrName) || isStringSafe(idOrName) ? idOrName + "" : defaultValue;
}
function isNameSpecified(componentModel) {
  var name2 = componentModel.name;
  return !!(name2 && name2.indexOf(DUMMY_COMPONENT_NAME_PREFIX));
}
function isComponentIdInternal(cmptOption) {
  return cmptOption && cmptOption.id != null && makeComparableKey(cmptOption.id).indexOf(INTERNAL_COMPONENT_ID_PREFIX) === 0;
}
function makeInternalComponentId(idSuffix) {
  return INTERNAL_COMPONENT_ID_PREFIX + idSuffix;
}
function setComponentTypeToKeyInfo(mappingResult, mainType, componentModelCtor) {
  each$g(mappingResult, function(item) {
    var newOption = item.newOption;
    if (isObject$6(newOption)) {
      item.keyInfo.mainType = mainType;
      item.keyInfo.subType = determineSubType(mainType, newOption, item.existing, componentModelCtor);
    }
  });
}
function determineSubType(mainType, newCmptOption, existComponent, componentModelCtor) {
  var subType = newCmptOption.type ? newCmptOption.type : existComponent ? existComponent.subType : componentModelCtor.determineSubType(mainType, newCmptOption);
  return subType;
}
function compressBatches(batchA, batchB) {
  var mapA = {};
  var mapB = {};
  makeMap(batchA || [], mapA);
  makeMap(batchB || [], mapB, mapA);
  return [mapToArray2(mapA), mapToArray2(mapB)];
  function makeMap(sourceBatch, map2, otherMap) {
    for (var i = 0, len2 = sourceBatch.length; i < len2; i++) {
      var seriesId = convertOptionIdName(sourceBatch[i].seriesId, null);
      if (seriesId == null) {
        return;
      }
      var dataIndices = normalizeToArray(sourceBatch[i].dataIndex);
      var otherDataIndices = otherMap && otherMap[seriesId];
      for (var j = 0, lenj = dataIndices.length; j < lenj; j++) {
        var dataIndex = dataIndices[j];
        if (otherDataIndices && otherDataIndices[dataIndex]) {
          otherDataIndices[dataIndex] = null;
        } else {
          (map2[seriesId] || (map2[seriesId] = {}))[dataIndex] = 1;
        }
      }
    }
  }
  function mapToArray2(map2, isData) {
    var result = [];
    for (var i in map2) {
      if (map2.hasOwnProperty(i) && map2[i] != null) {
        if (isData) {
          result.push(+i);
        } else {
          var dataIndices = mapToArray2(map2[i], true);
          dataIndices.length && result.push({
            seriesId: i,
            dataIndex: dataIndices
          });
        }
      }
    }
    return result;
  }
}
function queryDataIndex(data2, payload) {
  if (payload.dataIndexInside != null) {
    return payload.dataIndexInside;
  } else if (payload.dataIndex != null) {
    return isArray$2(payload.dataIndex) ? map$1(payload.dataIndex, function(value) {
      return data2.indexOfRawIndex(value);
    }) : data2.indexOfRawIndex(payload.dataIndex);
  } else if (payload.name != null) {
    return isArray$2(payload.name) ? map$1(payload.name, function(value) {
      return data2.indexOfName(value);
    }) : data2.indexOfName(payload.name);
  }
}
function makeInner() {
  var key = "__ec_inner_" + innerUniqueIndex++;
  return function(hostObj) {
    return hostObj[key] || (hostObj[key] = {});
  };
}
var innerUniqueIndex = getRandomIdBase();
function parseFinder$1(ecModel, finderInput, opt) {
  var _a2 = preParseFinder(finderInput, opt), mainTypeSpecified = _a2.mainTypeSpecified, queryOptionMap = _a2.queryOptionMap, others = _a2.others;
  var result = others;
  var defaultMainType = opt ? opt.defaultMainType : null;
  if (!mainTypeSpecified && defaultMainType) {
    queryOptionMap.set(defaultMainType, {});
  }
  queryOptionMap.each(function(queryOption, mainType) {
    var queryResult = queryReferringComponents(ecModel, mainType, queryOption, {
      useDefault: defaultMainType === mainType,
      enableAll: opt && opt.enableAll != null ? opt.enableAll : true,
      enableNone: opt && opt.enableNone != null ? opt.enableNone : true
    });
    result[mainType + "Models"] = queryResult.models;
    result[mainType + "Model"] = queryResult.models[0];
  });
  return result;
}
function preParseFinder(finderInput, opt) {
  var finder;
  if (isString$1(finderInput)) {
    var obj = {};
    obj[finderInput + "Index"] = 0;
    finder = obj;
  } else {
    finder = finderInput;
  }
  var queryOptionMap = createHashMap();
  var others = {};
  var mainTypeSpecified = false;
  each$g(finder, function(value, key) {
    if (key === "dataIndex" || key === "dataIndexInside") {
      others[key] = value;
      return;
    }
    var parsedKey = key.match(/^(\w+)(Index|Id|Name)$/) || [];
    var mainType = parsedKey[1];
    var queryType = (parsedKey[2] || "").toLowerCase();
    if (!mainType || !queryType || opt && opt.includeMainTypes && indexOf(opt.includeMainTypes, mainType) < 0) {
      return;
    }
    mainTypeSpecified = mainTypeSpecified || !!mainType;
    var queryOption = queryOptionMap.get(mainType) || queryOptionMap.set(mainType, {});
    queryOption[queryType] = value;
  });
  return {
    mainTypeSpecified,
    queryOptionMap,
    others
  };
}
var SINGLE_REFERRING = {
  useDefault: true,
  enableAll: false,
  enableNone: false
};
var MULTIPLE_REFERRING = {
  useDefault: false,
  enableAll: true,
  enableNone: true
};
function queryReferringComponents(ecModel, mainType, userOption, opt) {
  opt = opt || SINGLE_REFERRING;
  var indexOption = userOption.index;
  var idOption = userOption.id;
  var nameOption = userOption.name;
  var result = {
    models: null,
    specified: indexOption != null || idOption != null || nameOption != null
  };
  if (!result.specified) {
    var firstCmpt = void 0;
    result.models = opt.useDefault && (firstCmpt = ecModel.getComponent(mainType)) ? [firstCmpt] : [];
    return result;
  }
  if (indexOption === "none" || indexOption === false) {
    assert(opt.enableNone, '`"none"` or `false` is not a valid value on index option.');
    result.models = [];
    return result;
  }
  if (indexOption === "all") {
    assert(opt.enableAll, '`"all"` is not a valid value on index option.');
    indexOption = idOption = nameOption = null;
  }
  result.models = ecModel.queryComponents({
    mainType,
    index: indexOption,
    id: idOption,
    name: nameOption
  });
  return result;
}
function setAttribute(dom, key, value) {
  dom.setAttribute ? dom.setAttribute(key, value) : dom[key] = value;
}
function getAttribute(dom, key) {
  return dom.getAttribute ? dom.getAttribute(key) : dom[key];
}
function getTooltipRenderMode(renderModeOption) {
  if (renderModeOption === "auto") {
    return env$1.domSupported ? "html" : "richText";
  } else {
    return renderModeOption || "html";
  }
}
function groupData(array4, getKey2) {
  var buckets = createHashMap();
  var keys2 = [];
  each$g(array4, function(item) {
    var key = getKey2(item);
    (buckets.get(key) || (keys2.push(key), buckets.set(key, []))).push(item);
  });
  return {
    keys: keys2,
    buckets
  };
}
function interpolateRawValues(data2, precision, sourceValue, targetValue, percent) {
  var isAutoPrecision = precision == null || precision === "auto";
  if (targetValue == null) {
    return targetValue;
  }
  if (isNumber(targetValue)) {
    var value = interpolateNumber(sourceValue || 0, targetValue, percent);
    return round$3(value, isAutoPrecision ? Math.max(getPrecision(sourceValue || 0), getPrecision(targetValue)) : precision);
  } else if (isString$1(targetValue)) {
    return percent < 1 ? sourceValue : targetValue;
  } else {
    var interpolated = [];
    var leftArr = sourceValue;
    var rightArr = targetValue;
    var length_1 = Math.max(leftArr ? leftArr.length : 0, rightArr.length);
    for (var i = 0; i < length_1; ++i) {
      var info = data2.getDimensionInfo(i);
      if (info && info.type === "ordinal") {
        interpolated[i] = (percent < 1 && leftArr ? leftArr : rightArr)[i];
      } else {
        var leftVal = leftArr && leftArr[i] ? leftArr[i] : 0;
        var rightVal = rightArr[i];
        var value = interpolateNumber(leftVal, rightVal, percent);
        interpolated[i] = round$3(value, isAutoPrecision ? Math.max(getPrecision(leftVal), getPrecision(rightVal)) : precision);
      }
    }
    return interpolated;
  }
}
var TYPE_DELIMITER = ".";
var IS_CONTAINER = "___EC__COMPONENT__CONTAINER___";
var IS_EXTENDED_CLASS = "___EC__EXTENDED_CLASS___";
function parseClassType(componentType) {
  var ret = {
    main: "",
    sub: ""
  };
  if (componentType) {
    var typeArr = componentType.split(TYPE_DELIMITER);
    ret.main = typeArr[0] || "";
    ret.sub = typeArr[1] || "";
  }
  return ret;
}
function checkClassType(componentType) {
  assert(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(componentType), 'componentType "' + componentType + '" illegal');
}
function isExtendedClass(clz) {
  return !!(clz && clz[IS_EXTENDED_CLASS]);
}
function enableClassExtend(rootClz, mandatoryMethods) {
  rootClz.$constructor = rootClz;
  rootClz.extend = function(proto2) {
    var superClass = this;
    var ExtendedClass;
    if (isESClass(superClass)) {
      ExtendedClass = function(_super) {
        __extends(class_1, _super);
        function class_1() {
          return _super.apply(this, arguments) || this;
        }
        return class_1;
      }(superClass);
    } else {
      ExtendedClass = function() {
        (proto2.$constructor || superClass).apply(this, arguments);
      };
      inherits(ExtendedClass, this);
    }
    extend(ExtendedClass.prototype, proto2);
    ExtendedClass[IS_EXTENDED_CLASS] = true;
    ExtendedClass.extend = this.extend;
    ExtendedClass.superCall = superCall;
    ExtendedClass.superApply = superApply;
    ExtendedClass.superClass = superClass;
    return ExtendedClass;
  };
}
function isESClass(fn) {
  return isFunction$1(fn) && /^class\s/.test(Function.prototype.toString.call(fn));
}
function mountExtend(SubClz, SupperClz) {
  SubClz.extend = SupperClz.extend;
}
var classBase = Math.round(Math.random() * 10);
function enableClassCheck(target) {
  var classAttr = ["__\0is_clz", classBase++].join("_");
  target.prototype[classAttr] = true;
  target.isInstance = function(obj) {
    return !!(obj && obj[classAttr]);
  };
}
function superCall(context, methodName) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return this.superClass.prototype[methodName].apply(context, args);
}
function superApply(context, methodName, args) {
  return this.superClass.prototype[methodName].apply(context, args);
}
function enableClassManagement(target) {
  var storage2 = {};
  target.registerClass = function(clz) {
    var componentFullType = clz.type || clz.prototype.type;
    if (componentFullType) {
      checkClassType(componentFullType);
      clz.prototype.type = componentFullType;
      var componentTypeInfo = parseClassType(componentFullType);
      if (!componentTypeInfo.sub) {
        storage2[componentTypeInfo.main] = clz;
      } else if (componentTypeInfo.sub !== IS_CONTAINER) {
        var container2 = makeContainer(componentTypeInfo);
        container2[componentTypeInfo.sub] = clz;
      }
    }
    return clz;
  };
  target.getClass = function(mainType, subType, throwWhenNotFound) {
    var clz = storage2[mainType];
    if (clz && clz[IS_CONTAINER]) {
      clz = subType ? clz[subType] : null;
    }
    if (throwWhenNotFound && !clz) {
      throw new Error(!subType ? mainType + ".type should be specified." : "Component " + mainType + "." + (subType || "") + " is used but not imported.");
    }
    return clz;
  };
  target.getClassesByMainType = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var result = [];
    var obj = storage2[componentTypeInfo.main];
    if (obj && obj[IS_CONTAINER]) {
      each$g(obj, function(o, type4) {
        type4 !== IS_CONTAINER && result.push(o);
      });
    } else {
      result.push(obj);
    }
    return result;
  };
  target.hasClass = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    return !!storage2[componentTypeInfo.main];
  };
  target.getAllClassMainTypes = function() {
    var types2 = [];
    each$g(storage2, function(obj, type4) {
      types2.push(type4);
    });
    return types2;
  };
  target.hasSubTypes = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var obj = storage2[componentTypeInfo.main];
    return obj && obj[IS_CONTAINER];
  };
  function makeContainer(componentTypeInfo) {
    var container2 = storage2[componentTypeInfo.main];
    if (!container2 || !container2[IS_CONTAINER]) {
      container2 = storage2[componentTypeInfo.main] = {};
      container2[IS_CONTAINER] = true;
    }
    return container2;
  }
}
function makeStyleMapper(properties, ignoreParent) {
  for (var i = 0; i < properties.length; i++) {
    if (!properties[i][1]) {
      properties[i][1] = properties[i][0];
    }
  }
  ignoreParent = ignoreParent || false;
  return function(model, excludes, includes) {
    var style2 = {};
    for (var i2 = 0; i2 < properties.length; i2++) {
      var propName = properties[i2][1];
      if (excludes && indexOf(excludes, propName) >= 0 || includes && indexOf(includes, propName) < 0) {
        continue;
      }
      var val = model.getShallow(propName, ignoreParent);
      if (val != null) {
        style2[properties[i2][0]] = val;
      }
    }
    return style2;
  };
}
var AREA_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["opacity"],
  ["shadowColor"]
];
var getAreaStyle = makeStyleMapper(AREA_STYLE_KEY_MAP);
var AreaStyleMixin = function() {
  function AreaStyleMixin2() {
  }
  AreaStyleMixin2.prototype.getAreaStyle = function(excludes, includes) {
    return getAreaStyle(this, excludes, includes);
  };
  return AreaStyleMixin2;
}();
var globalImageCache = new LRU$1(50);
function findExistImage(newImageOrSrc) {
  if (typeof newImageOrSrc === "string") {
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    return cachedImgObj && cachedImgObj.image;
  } else {
    return newImageOrSrc;
  }
}
function createOrUpdateImage(newImageOrSrc, image, hostEl, onload, cbPayload) {
  if (!newImageOrSrc) {
    return image;
  } else if (typeof newImageOrSrc === "string") {
    if (image && image.__zrImageSrc === newImageOrSrc || !hostEl) {
      return image;
    }
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    var pendingWrap = { hostEl, cb: onload, cbPayload };
    if (cachedImgObj) {
      image = cachedImgObj.image;
      !isImageReady(image) && cachedImgObj.pending.push(pendingWrap);
    } else {
      var image_1 = platformApi.loadImage(newImageOrSrc, imageOnLoad, imageOnLoad);
      image_1.__zrImageSrc = newImageOrSrc;
      globalImageCache.put(newImageOrSrc, image_1.__cachedImgObj = {
        image: image_1,
        pending: [pendingWrap]
      });
    }
    return image;
  } else {
    return newImageOrSrc;
  }
}
function imageOnLoad() {
  var cachedImgObj = this.__cachedImgObj;
  this.onload = this.onerror = this.__cachedImgObj = null;
  for (var i = 0; i < cachedImgObj.pending.length; i++) {
    var pendingWrap = cachedImgObj.pending[i];
    var cb2 = pendingWrap.cb;
    cb2 && cb2(this, pendingWrap.cbPayload);
    pendingWrap.hostEl.dirty();
  }
  cachedImgObj.pending.length = 0;
}
function isImageReady(image) {
  return image && image.width && image.height;
}
var STYLE_REG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
function truncateText(text, containerWidth, font, ellipsis, options) {
  if (!containerWidth) {
    return "";
  }
  var textLines = (text + "").split("\n");
  options = prepareTruncateOptions(containerWidth, font, ellipsis, options);
  for (var i = 0, len2 = textLines.length; i < len2; i++) {
    textLines[i] = truncateSingleLine(textLines[i], options);
  }
  return textLines.join("\n");
}
function prepareTruncateOptions(containerWidth, font, ellipsis, options) {
  options = options || {};
  var preparedOpts = extend({}, options);
  preparedOpts.font = font;
  ellipsis = retrieve2(ellipsis, "...");
  preparedOpts.maxIterations = retrieve2(options.maxIterations, 2);
  var minChar = preparedOpts.minChar = retrieve2(options.minChar, 0);
  preparedOpts.cnCharWidth = getWidth("\u56FD", font);
  var ascCharWidth = preparedOpts.ascCharWidth = getWidth("a", font);
  preparedOpts.placeholder = retrieve2(options.placeholder, "");
  var contentWidth = containerWidth = Math.max(0, containerWidth - 1);
  for (var i = 0; i < minChar && contentWidth >= ascCharWidth; i++) {
    contentWidth -= ascCharWidth;
  }
  var ellipsisWidth = getWidth(ellipsis, font);
  if (ellipsisWidth > contentWidth) {
    ellipsis = "";
    ellipsisWidth = 0;
  }
  contentWidth = containerWidth - ellipsisWidth;
  preparedOpts.ellipsis = ellipsis;
  preparedOpts.ellipsisWidth = ellipsisWidth;
  preparedOpts.contentWidth = contentWidth;
  preparedOpts.containerWidth = containerWidth;
  return preparedOpts;
}
function truncateSingleLine(textLine, options) {
  var containerWidth = options.containerWidth;
  var font = options.font;
  var contentWidth = options.contentWidth;
  if (!containerWidth) {
    return "";
  }
  var lineWidth = getWidth(textLine, font);
  if (lineWidth <= containerWidth) {
    return textLine;
  }
  for (var j = 0; ; j++) {
    if (lineWidth <= contentWidth || j >= options.maxIterations) {
      textLine += options.ellipsis;
      break;
    }
    var subLength = j === 0 ? estimateLength(textLine, contentWidth, options.ascCharWidth, options.cnCharWidth) : lineWidth > 0 ? Math.floor(textLine.length * contentWidth / lineWidth) : 0;
    textLine = textLine.substr(0, subLength);
    lineWidth = getWidth(textLine, font);
  }
  if (textLine === "") {
    textLine = options.placeholder;
  }
  return textLine;
}
function estimateLength(text, contentWidth, ascCharWidth, cnCharWidth) {
  var width = 0;
  var i = 0;
  for (var len2 = text.length; i < len2 && width < contentWidth; i++) {
    var charCode = text.charCodeAt(i);
    width += 0 <= charCode && charCode <= 127 ? ascCharWidth : cnCharWidth;
  }
  return i;
}
function parsePlainText(text, style2) {
  text != null && (text += "");
  var overflow = style2.overflow;
  var padding = style2.padding;
  var font = style2.font;
  var truncate = overflow === "truncate";
  var calculatedLineHeight = getLineHeight(font);
  var lineHeight = retrieve2(style2.lineHeight, calculatedLineHeight);
  var bgColorDrawn = !!style2.backgroundColor;
  var truncateLineOverflow = style2.lineOverflow === "truncate";
  var width = style2.width;
  var lines;
  if (width != null && (overflow === "break" || overflow === "breakAll")) {
    lines = text ? wrapText(text, style2.font, width, overflow === "breakAll", 0).lines : [];
  } else {
    lines = text ? text.split("\n") : [];
  }
  var contentHeight = lines.length * lineHeight;
  var height = retrieve2(style2.height, contentHeight);
  if (contentHeight > height && truncateLineOverflow) {
    var lineCount = Math.floor(height / lineHeight);
    lines = lines.slice(0, lineCount);
  }
  if (text && truncate && width != null) {
    var options = prepareTruncateOptions(width, font, style2.ellipsis, {
      minChar: style2.truncateMinChar,
      placeholder: style2.placeholder
    });
    for (var i = 0; i < lines.length; i++) {
      lines[i] = truncateSingleLine(lines[i], options);
    }
  }
  var outerHeight = height;
  var contentWidth = 0;
  for (var i = 0; i < lines.length; i++) {
    contentWidth = Math.max(getWidth(lines[i], font), contentWidth);
  }
  if (width == null) {
    width = contentWidth;
  }
  var outerWidth = contentWidth;
  if (padding) {
    outerHeight += padding[0] + padding[2];
    outerWidth += padding[1] + padding[3];
    width += padding[1] + padding[3];
  }
  if (bgColorDrawn) {
    outerWidth = width;
  }
  return {
    lines,
    height,
    outerWidth,
    outerHeight,
    lineHeight,
    calculatedLineHeight,
    contentWidth,
    contentHeight,
    width
  };
}
var RichTextToken = function() {
  function RichTextToken2() {
  }
  return RichTextToken2;
}();
var RichTextLine = function() {
  function RichTextLine2(tokens) {
    this.tokens = [];
    if (tokens) {
      this.tokens = tokens;
    }
  }
  return RichTextLine2;
}();
var RichTextContentBlock = function() {
  function RichTextContentBlock2() {
    this.width = 0;
    this.height = 0;
    this.contentWidth = 0;
    this.contentHeight = 0;
    this.outerWidth = 0;
    this.outerHeight = 0;
    this.lines = [];
  }
  return RichTextContentBlock2;
}();
function parseRichText(text, style2) {
  var contentBlock = new RichTextContentBlock();
  text != null && (text += "");
  if (!text) {
    return contentBlock;
  }
  var topWidth = style2.width;
  var topHeight = style2.height;
  var overflow = style2.overflow;
  var wrapInfo = (overflow === "break" || overflow === "breakAll") && topWidth != null ? { width: topWidth, accumWidth: 0, breakAll: overflow === "breakAll" } : null;
  var lastIndex = STYLE_REG.lastIndex = 0;
  var result;
  while ((result = STYLE_REG.exec(text)) != null) {
    var matchedIndex = result.index;
    if (matchedIndex > lastIndex) {
      pushTokens(contentBlock, text.substring(lastIndex, matchedIndex), style2, wrapInfo);
    }
    pushTokens(contentBlock, result[2], style2, wrapInfo, result[1]);
    lastIndex = STYLE_REG.lastIndex;
  }
  if (lastIndex < text.length) {
    pushTokens(contentBlock, text.substring(lastIndex, text.length), style2, wrapInfo);
  }
  var pendingList = [];
  var calculatedHeight = 0;
  var calculatedWidth = 0;
  var stlPadding = style2.padding;
  var truncate = overflow === "truncate";
  var truncateLine = style2.lineOverflow === "truncate";
  function finishLine(line2, lineWidth2, lineHeight2) {
    line2.width = lineWidth2;
    line2.lineHeight = lineHeight2;
    calculatedHeight += lineHeight2;
    calculatedWidth = Math.max(calculatedWidth, lineWidth2);
  }
  outer:
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var lineHeight = 0;
      var lineWidth = 0;
      for (var j = 0; j < line.tokens.length; j++) {
        var token = line.tokens[j];
        var tokenStyle = token.styleName && style2.rich[token.styleName] || {};
        var textPadding = token.textPadding = tokenStyle.padding;
        var paddingH = textPadding ? textPadding[1] + textPadding[3] : 0;
        var font = token.font = tokenStyle.font || style2.font;
        token.contentHeight = getLineHeight(font);
        var tokenHeight = retrieve2(tokenStyle.height, token.contentHeight);
        token.innerHeight = tokenHeight;
        textPadding && (tokenHeight += textPadding[0] + textPadding[2]);
        token.height = tokenHeight;
        token.lineHeight = retrieve3(tokenStyle.lineHeight, style2.lineHeight, tokenHeight);
        token.align = tokenStyle && tokenStyle.align || style2.align;
        token.verticalAlign = tokenStyle && tokenStyle.verticalAlign || "middle";
        if (truncateLine && topHeight != null && calculatedHeight + token.lineHeight > topHeight) {
          if (j > 0) {
            line.tokens = line.tokens.slice(0, j);
            finishLine(line, lineWidth, lineHeight);
            contentBlock.lines = contentBlock.lines.slice(0, i + 1);
          } else {
            contentBlock.lines = contentBlock.lines.slice(0, i);
          }
          break outer;
        }
        var styleTokenWidth = tokenStyle.width;
        var tokenWidthNotSpecified = styleTokenWidth == null || styleTokenWidth === "auto";
        if (typeof styleTokenWidth === "string" && styleTokenWidth.charAt(styleTokenWidth.length - 1) === "%") {
          token.percentWidth = styleTokenWidth;
          pendingList.push(token);
          token.contentWidth = getWidth(token.text, font);
        } else {
          if (tokenWidthNotSpecified) {
            var textBackgroundColor = tokenStyle.backgroundColor;
            var bgImg = textBackgroundColor && textBackgroundColor.image;
            if (bgImg) {
              bgImg = findExistImage(bgImg);
              if (isImageReady(bgImg)) {
                token.width = Math.max(token.width, bgImg.width * tokenHeight / bgImg.height);
              }
            }
          }
          var remainTruncWidth = truncate && topWidth != null ? topWidth - lineWidth : null;
          if (remainTruncWidth != null && remainTruncWidth < token.width) {
            if (!tokenWidthNotSpecified || remainTruncWidth < paddingH) {
              token.text = "";
              token.width = token.contentWidth = 0;
            } else {
              token.text = truncateText(token.text, remainTruncWidth - paddingH, font, style2.ellipsis, { minChar: style2.truncateMinChar });
              token.width = token.contentWidth = getWidth(token.text, font);
            }
          } else {
            token.contentWidth = getWidth(token.text, font);
          }
        }
        token.width += paddingH;
        lineWidth += token.width;
        tokenStyle && (lineHeight = Math.max(lineHeight, token.lineHeight));
      }
      finishLine(line, lineWidth, lineHeight);
    }
  contentBlock.outerWidth = contentBlock.width = retrieve2(topWidth, calculatedWidth);
  contentBlock.outerHeight = contentBlock.height = retrieve2(topHeight, calculatedHeight);
  contentBlock.contentHeight = calculatedHeight;
  contentBlock.contentWidth = calculatedWidth;
  if (stlPadding) {
    contentBlock.outerWidth += stlPadding[1] + stlPadding[3];
    contentBlock.outerHeight += stlPadding[0] + stlPadding[2];
  }
  for (var i = 0; i < pendingList.length; i++) {
    var token = pendingList[i];
    var percentWidth = token.percentWidth;
    token.width = parseInt(percentWidth, 10) / 100 * contentBlock.width;
  }
  return contentBlock;
}
function pushTokens(block, str, style2, wrapInfo, styleName) {
  var isEmptyStr = str === "";
  var tokenStyle = styleName && style2.rich[styleName] || {};
  var lines = block.lines;
  var font = tokenStyle.font || style2.font;
  var newLine = false;
  var strLines;
  var linesWidths;
  if (wrapInfo) {
    var tokenPadding = tokenStyle.padding;
    var tokenPaddingH = tokenPadding ? tokenPadding[1] + tokenPadding[3] : 0;
    if (tokenStyle.width != null && tokenStyle.width !== "auto") {
      var outerWidth_1 = parsePercent$1(tokenStyle.width, wrapInfo.width) + tokenPaddingH;
      if (lines.length > 0) {
        if (outerWidth_1 + wrapInfo.accumWidth > wrapInfo.width) {
          strLines = str.split("\n");
          newLine = true;
        }
      }
      wrapInfo.accumWidth = outerWidth_1;
    } else {
      var res2 = wrapText(str, font, wrapInfo.width, wrapInfo.breakAll, wrapInfo.accumWidth);
      wrapInfo.accumWidth = res2.accumWidth + tokenPaddingH;
      linesWidths = res2.linesWidths;
      strLines = res2.lines;
    }
  } else {
    strLines = str.split("\n");
  }
  for (var i = 0; i < strLines.length; i++) {
    var text = strLines[i];
    var token = new RichTextToken();
    token.styleName = styleName;
    token.text = text;
    token.isLineHolder = !text && !isEmptyStr;
    if (typeof tokenStyle.width === "number") {
      token.width = tokenStyle.width;
    } else {
      token.width = linesWidths ? linesWidths[i] : getWidth(text, font);
    }
    if (!i && !newLine) {
      var tokens = (lines[lines.length - 1] || (lines[0] = new RichTextLine())).tokens;
      var tokensLen = tokens.length;
      tokensLen === 1 && tokens[0].isLineHolder ? tokens[0] = token : (text || !tokensLen || isEmptyStr) && tokens.push(token);
    } else {
      lines.push(new RichTextLine([token]));
    }
  }
}
function isLatin(ch2) {
  var code2 = ch2.charCodeAt(0);
  return code2 >= 33 && code2 <= 383;
}
var breakCharMap = reduce(",&?/;] ".split(""), function(obj, ch2) {
  obj[ch2] = true;
  return obj;
}, {});
function isWordBreakChar(ch2) {
  if (isLatin(ch2)) {
    if (breakCharMap[ch2]) {
      return true;
    }
    return false;
  }
  return true;
}
function wrapText(text, font, lineWidth, isBreakAll, lastAccumWidth) {
  var lines = [];
  var linesWidths = [];
  var line = "";
  var currentWord = "";
  var currentWordWidth = 0;
  var accumWidth = 0;
  for (var i = 0; i < text.length; i++) {
    var ch2 = text.charAt(i);
    if (ch2 === "\n") {
      if (currentWord) {
        line += currentWord;
        accumWidth += currentWordWidth;
      }
      lines.push(line);
      linesWidths.push(accumWidth);
      line = "";
      currentWord = "";
      currentWordWidth = 0;
      accumWidth = 0;
      continue;
    }
    var chWidth = getWidth(ch2, font);
    var inWord = isBreakAll ? false : !isWordBreakChar(ch2);
    if (!lines.length ? lastAccumWidth + accumWidth + chWidth > lineWidth : accumWidth + chWidth > lineWidth) {
      if (!accumWidth) {
        if (inWord) {
          lines.push(currentWord);
          linesWidths.push(currentWordWidth);
          currentWord = ch2;
          currentWordWidth = chWidth;
        } else {
          lines.push(ch2);
          linesWidths.push(chWidth);
        }
      } else if (line || currentWord) {
        if (inWord) {
          if (!line) {
            line = currentWord;
            currentWord = "";
            currentWordWidth = 0;
            accumWidth = currentWordWidth;
          }
          lines.push(line);
          linesWidths.push(accumWidth - currentWordWidth);
          currentWord += ch2;
          currentWordWidth += chWidth;
          line = "";
          accumWidth = currentWordWidth;
        } else {
          if (currentWord) {
            line += currentWord;
            currentWord = "";
            currentWordWidth = 0;
          }
          lines.push(line);
          linesWidths.push(accumWidth);
          line = ch2;
          accumWidth = chWidth;
        }
      }
      continue;
    }
    accumWidth += chWidth;
    if (inWord) {
      currentWord += ch2;
      currentWordWidth += chWidth;
    } else {
      if (currentWord) {
        line += currentWord;
        currentWord = "";
        currentWordWidth = 0;
      }
      line += ch2;
    }
  }
  if (!lines.length && !line) {
    line = text;
    currentWord = "";
    currentWordWidth = 0;
  }
  if (currentWord) {
    line += currentWord;
  }
  if (line) {
    lines.push(line);
    linesWidths.push(accumWidth);
  }
  if (lines.length === 1) {
    accumWidth += lastAccumWidth;
  }
  return {
    accumWidth,
    lines,
    linesWidths
  };
}
var STYLE_MAGIC_KEY = "__zr_style_" + Math.round(Math.random() * 10);
var DEFAULT_COMMON_STYLE = {
  shadowBlur: 0,
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowColor: "#000",
  opacity: 1,
  blend: "source-over"
};
var DEFAULT_COMMON_ANIMATION_PROPS = {
  style: {
    shadowBlur: true,
    shadowOffsetX: true,
    shadowOffsetY: true,
    shadowColor: true,
    opacity: true
  }
};
DEFAULT_COMMON_STYLE[STYLE_MAGIC_KEY] = true;
var PRIMARY_STATES_KEYS = ["z", "z2", "invisible"];
var PRIMARY_STATES_KEYS_IN_HOVER_LAYER = ["invisible"];
var Displayable = function(_super) {
  __extends(Displayable2, _super);
  function Displayable2(props) {
    return _super.call(this, props) || this;
  }
  Displayable2.prototype._init = function(props) {
    var keysArr = keys(props);
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      if (key === "style") {
        this.useStyle(props[key]);
      } else {
        _super.prototype.attrKV.call(this, key, props[key]);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Displayable2.prototype.beforeBrush = function() {
  };
  Displayable2.prototype.afterBrush = function() {
  };
  Displayable2.prototype.innerBeforeBrush = function() {
  };
  Displayable2.prototype.innerAfterBrush = function() {
  };
  Displayable2.prototype.shouldBePainted = function(viewWidth, viewHeight, considerClipPath, considerAncestors) {
    var m2 = this.transform;
    if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && isDisplayableCulled(this, viewWidth, viewHeight) || m2 && !m2[0] && !m2[3]) {
      return false;
    }
    if (considerClipPath && this.__clipPaths) {
      for (var i = 0; i < this.__clipPaths.length; ++i) {
        if (this.__clipPaths[i].isZeroArea()) {
          return false;
        }
      }
    }
    if (considerAncestors && this.parent) {
      var parent_1 = this.parent;
      while (parent_1) {
        if (parent_1.ignore) {
          return false;
        }
        parent_1 = parent_1.parent;
      }
    }
    return true;
  };
  Displayable2.prototype.contain = function(x2, y2) {
    return this.rectContain(x2, y2);
  };
  Displayable2.prototype.traverse = function(cb2, context) {
    cb2.call(context, this);
  };
  Displayable2.prototype.rectContain = function(x2, y2) {
    var coord = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    return rect.contain(coord[0], coord[1]);
  };
  Displayable2.prototype.getPaintRect = function() {
    var rect = this._paintRect;
    if (!this._paintRect || this.__dirty) {
      var transform2 = this.transform;
      var elRect = this.getBoundingRect();
      var style2 = this.style;
      var shadowSize = style2.shadowBlur || 0;
      var shadowOffsetX = style2.shadowOffsetX || 0;
      var shadowOffsetY = style2.shadowOffsetY || 0;
      rect = this._paintRect || (this._paintRect = new BoundingRect$1(0, 0, 0, 0));
      if (transform2) {
        BoundingRect$1.applyTransform(rect, elRect, transform2);
      } else {
        rect.copy(elRect);
      }
      if (shadowSize || shadowOffsetX || shadowOffsetY) {
        rect.width += shadowSize * 2 + Math.abs(shadowOffsetX);
        rect.height += shadowSize * 2 + Math.abs(shadowOffsetY);
        rect.x = Math.min(rect.x, rect.x + shadowOffsetX - shadowSize);
        rect.y = Math.min(rect.y, rect.y + shadowOffsetY - shadowSize);
      }
      var tolerance = this.dirtyRectTolerance;
      if (!rect.isZero()) {
        rect.x = Math.floor(rect.x - tolerance);
        rect.y = Math.floor(rect.y - tolerance);
        rect.width = Math.ceil(rect.width + 1 + tolerance * 2);
        rect.height = Math.ceil(rect.height + 1 + tolerance * 2);
      }
    }
    return rect;
  };
  Displayable2.prototype.setPrevPaintRect = function(paintRect) {
    if (paintRect) {
      this._prevPaintRect = this._prevPaintRect || new BoundingRect$1(0, 0, 0, 0);
      this._prevPaintRect.copy(paintRect);
    } else {
      this._prevPaintRect = null;
    }
  };
  Displayable2.prototype.getPrevPaintRect = function() {
    return this._prevPaintRect;
  };
  Displayable2.prototype.animateStyle = function(loop) {
    return this.animate("style", loop);
  };
  Displayable2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else {
      this.markRedraw();
    }
  };
  Displayable2.prototype.attrKV = function(key, value) {
    if (key !== "style") {
      _super.prototype.attrKV.call(this, key, value);
    } else {
      if (!this.style) {
        this.useStyle(value);
      } else {
        this.setStyle(value);
      }
    }
  };
  Displayable2.prototype.setStyle = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.style[keyOrObj] = value;
    } else {
      extend(this.style, keyOrObj);
    }
    this.dirtyStyle();
    return this;
  };
  Displayable2.prototype.dirtyStyle = function(notRedraw) {
    if (!notRedraw) {
      this.markRedraw();
    }
    this.__dirty |= STYLE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
  };
  Displayable2.prototype.dirty = function() {
    this.dirtyStyle();
  };
  Displayable2.prototype.styleChanged = function() {
    return !!(this.__dirty & STYLE_CHANGED_BIT);
  };
  Displayable2.prototype.styleUpdated = function() {
    this.__dirty &= ~STYLE_CHANGED_BIT;
  };
  Displayable2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_COMMON_STYLE, obj);
  };
  Displayable2.prototype.useStyle = function(obj) {
    if (!obj[STYLE_MAGIC_KEY]) {
      obj = this.createStyle(obj);
    }
    if (this.__inHover) {
      this.__hoverStyle = obj;
    } else {
      this.style = obj;
    }
    this.dirtyStyle();
  };
  Displayable2.prototype.isStyleObject = function(obj) {
    return obj[STYLE_MAGIC_KEY];
  };
  Displayable2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.style && !normalState.style) {
      normalState.style = this._mergeStyle(this.createStyle(), this.style);
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS);
  };
  Displayable2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetStyle;
    if (state && state.style) {
      if (transition) {
        if (keepCurrentStates) {
          targetStyle = state.style;
        } else {
          targetStyle = this._mergeStyle(this.createStyle(), normalState.style);
          this._mergeStyle(targetStyle, state.style);
        }
      } else {
        targetStyle = this._mergeStyle(this.createStyle(), keepCurrentStates ? this.style : normalState.style);
        this._mergeStyle(targetStyle, state.style);
      }
    } else if (needsRestoreToNormal) {
      targetStyle = normalState.style;
    }
    if (targetStyle) {
      if (transition) {
        var sourceStyle = this.style;
        this.style = this.createStyle(needsRestoreToNormal ? {} : sourceStyle);
        if (needsRestoreToNormal) {
          var changedKeys = keys(sourceStyle);
          for (var i = 0; i < changedKeys.length; i++) {
            var key = changedKeys[i];
            if (key in targetStyle) {
              targetStyle[key] = targetStyle[key];
              this.style[key] = sourceStyle[key];
            }
          }
        }
        var targetKeys = keys(targetStyle);
        for (var i = 0; i < targetKeys.length; i++) {
          var key = targetKeys[i];
          this.style[key] = this.style[key];
        }
        this._transitionState(stateName, {
          style: targetStyle
        }, animationCfg, this.getAnimationStyleProps());
      } else {
        this.useStyle(targetStyle);
      }
    }
    var statesKeys = this.__inHover ? PRIMARY_STATES_KEYS_IN_HOVER_LAYER : PRIMARY_STATES_KEYS;
    for (var i = 0; i < statesKeys.length; i++) {
      var key = statesKeys[i];
      if (state && state[key] != null) {
        this[key] = state[key];
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          this[key] = normalState[key];
        }
      }
    }
  };
  Displayable2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedStyle;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.style) {
        mergedStyle = mergedStyle || {};
        this._mergeStyle(mergedStyle, state.style);
      }
    }
    if (mergedStyle) {
      mergedState.style = mergedStyle;
    }
    return mergedState;
  };
  Displayable2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    extend(targetStyle, sourceStyle);
    return targetStyle;
  };
  Displayable2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_COMMON_ANIMATION_PROPS;
  };
  Displayable2.initDefaultProps = function() {
    var dispProto = Displayable2.prototype;
    dispProto.type = "displayable";
    dispProto.invisible = false;
    dispProto.z = 0;
    dispProto.z2 = 0;
    dispProto.zlevel = 0;
    dispProto.culling = false;
    dispProto.cursor = "pointer";
    dispProto.rectHover = false;
    dispProto.incremental = false;
    dispProto._rect = null;
    dispProto.dirtyRectTolerance = 0;
    dispProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT;
  }();
  return Displayable2;
}(Element$2);
var tmpRect = new BoundingRect$1(0, 0, 0, 0);
var viewRect = new BoundingRect$1(0, 0, 0, 0);
function isDisplayableCulled(el, width, height) {
  tmpRect.copy(el.getBoundingRect());
  if (el.transform) {
    tmpRect.applyTransform(el.transform);
  }
  viewRect.width = width;
  viewRect.height = height;
  return !tmpRect.intersect(viewRect);
}
var Displayable$1 = Displayable;
var mathMin$9 = Math.min;
var mathMax$9 = Math.max;
var mathSin$4 = Math.sin;
var mathCos$4 = Math.cos;
var PI2$9 = Math.PI * 2;
var start = create$3();
var end = create$3();
var extremity = create$3();
function fromPoints(points2, min3, max3) {
  if (points2.length === 0) {
    return;
  }
  var p2 = points2[0];
  var left = p2[0];
  var right = p2[0];
  var top = p2[1];
  var bottom = p2[1];
  for (var i = 1; i < points2.length; i++) {
    p2 = points2[i];
    left = mathMin$9(left, p2[0]);
    right = mathMax$9(right, p2[0]);
    top = mathMin$9(top, p2[1]);
    bottom = mathMax$9(bottom, p2[1]);
  }
  min3[0] = left;
  min3[1] = top;
  max3[0] = right;
  max3[1] = bottom;
}
function fromLine(x0, y0, x1, y1, min3, max3) {
  min3[0] = mathMin$9(x0, x1);
  min3[1] = mathMin$9(y0, y1);
  max3[0] = mathMax$9(x0, x1);
  max3[1] = mathMax$9(y0, y1);
}
var xDim = [];
var yDim = [];
function fromCubic(x0, y0, x1, y1, x2, y2, x3, y3, min3, max3) {
  var cubicExtrema$1 = cubicExtrema;
  var cubicAt$1 = cubicAt;
  var n2 = cubicExtrema$1(x0, x1, x2, x3, xDim);
  min3[0] = Infinity;
  min3[1] = Infinity;
  max3[0] = -Infinity;
  max3[1] = -Infinity;
  for (var i = 0; i < n2; i++) {
    var x4 = cubicAt$1(x0, x1, x2, x3, xDim[i]);
    min3[0] = mathMin$9(x4, min3[0]);
    max3[0] = mathMax$9(x4, max3[0]);
  }
  n2 = cubicExtrema$1(y0, y1, y2, y3, yDim);
  for (var i = 0; i < n2; i++) {
    var y4 = cubicAt$1(y0, y1, y2, y3, yDim[i]);
    min3[1] = mathMin$9(y4, min3[1]);
    max3[1] = mathMax$9(y4, max3[1]);
  }
  min3[0] = mathMin$9(x0, min3[0]);
  max3[0] = mathMax$9(x0, max3[0]);
  min3[0] = mathMin$9(x3, min3[0]);
  max3[0] = mathMax$9(x3, max3[0]);
  min3[1] = mathMin$9(y0, min3[1]);
  max3[1] = mathMax$9(y0, max3[1]);
  min3[1] = mathMin$9(y3, min3[1]);
  max3[1] = mathMax$9(y3, max3[1]);
}
function fromQuadratic(x0, y0, x1, y1, x2, y2, min3, max3) {
  var quadraticExtremum$1 = quadraticExtremum;
  var quadraticAt2 = quadraticAt$1;
  var tx = mathMax$9(mathMin$9(quadraticExtremum$1(x0, x1, x2), 1), 0);
  var ty = mathMax$9(mathMin$9(quadraticExtremum$1(y0, y1, y2), 1), 0);
  var x3 = quadraticAt2(x0, x1, x2, tx);
  var y3 = quadraticAt2(y0, y1, y2, ty);
  min3[0] = mathMin$9(x0, x2, x3);
  min3[1] = mathMin$9(y0, y2, y3);
  max3[0] = mathMax$9(x0, x2, x3);
  max3[1] = mathMax$9(y0, y2, y3);
}
function fromArc(x2, y2, rx, ry, startAngle, endAngle, anticlockwise, min3, max3) {
  var vec2Min = min$1;
  var vec2Max = max$1;
  var diff = Math.abs(startAngle - endAngle);
  if (diff % PI2$9 < 1e-4 && diff > 1e-4) {
    min3[0] = x2 - rx;
    min3[1] = y2 - ry;
    max3[0] = x2 + rx;
    max3[1] = y2 + ry;
    return;
  }
  start[0] = mathCos$4(startAngle) * rx + x2;
  start[1] = mathSin$4(startAngle) * ry + y2;
  end[0] = mathCos$4(endAngle) * rx + x2;
  end[1] = mathSin$4(endAngle) * ry + y2;
  vec2Min(min3, start, end);
  vec2Max(max3, start, end);
  startAngle = startAngle % PI2$9;
  if (startAngle < 0) {
    startAngle = startAngle + PI2$9;
  }
  endAngle = endAngle % PI2$9;
  if (endAngle < 0) {
    endAngle = endAngle + PI2$9;
  }
  if (startAngle > endAngle && !anticlockwise) {
    endAngle += PI2$9;
  } else if (startAngle < endAngle && anticlockwise) {
    startAngle += PI2$9;
  }
  if (anticlockwise) {
    var tmp = endAngle;
    endAngle = startAngle;
    startAngle = tmp;
  }
  for (var angle = 0; angle < endAngle; angle += Math.PI / 2) {
    if (angle > startAngle) {
      extremity[0] = mathCos$4(angle) * rx + x2;
      extremity[1] = mathSin$4(angle) * ry + y2;
      vec2Min(min3, extremity, min3);
      vec2Max(max3, extremity, max3);
    }
  }
}
var CMD$4 = {
  M: 1,
  L: 2,
  C: 3,
  Q: 4,
  A: 5,
  Z: 6,
  R: 7
};
var tmpOutX = [];
var tmpOutY = [];
var min = [];
var max = [];
var min2 = [];
var max2 = [];
var mathMin$8 = Math.min;
var mathMax$8 = Math.max;
var mathCos$3 = Math.cos;
var mathSin$3 = Math.sin;
var mathAbs$2 = Math.abs;
var PI$8 = Math.PI;
var PI2$8 = PI$8 * 2;
var hasTypedArray = typeof Float32Array !== "undefined";
var tmpAngles = [];
function modPI2(radian) {
  var n2 = Math.round(radian / PI$8 * 1e8) / 1e8;
  return n2 % 2 * PI$8;
}
function normalizeArcAngles(angles, anticlockwise) {
  var newStartAngle = modPI2(angles[0]);
  if (newStartAngle < 0) {
    newStartAngle += PI2$8;
  }
  var delta = newStartAngle - angles[0];
  var newEndAngle = angles[1];
  newEndAngle += delta;
  if (!anticlockwise && newEndAngle - newStartAngle >= PI2$8) {
    newEndAngle = newStartAngle + PI2$8;
  } else if (anticlockwise && newStartAngle - newEndAngle >= PI2$8) {
    newEndAngle = newStartAngle - PI2$8;
  } else if (!anticlockwise && newStartAngle > newEndAngle) {
    newEndAngle = newStartAngle + (PI2$8 - modPI2(newStartAngle - newEndAngle));
  } else if (anticlockwise && newStartAngle < newEndAngle) {
    newEndAngle = newStartAngle - (PI2$8 - modPI2(newEndAngle - newStartAngle));
  }
  angles[0] = newStartAngle;
  angles[1] = newEndAngle;
}
var PathProxy = function() {
  function PathProxy2(notSaveData) {
    this.dpr = 1;
    this._xi = 0;
    this._yi = 0;
    this._x0 = 0;
    this._y0 = 0;
    this._len = 0;
    if (notSaveData) {
      this._saveData = false;
    }
    if (this._saveData) {
      this.data = [];
    }
  }
  PathProxy2.prototype.increaseVersion = function() {
    this._version++;
  };
  PathProxy2.prototype.getVersion = function() {
    return this._version;
  };
  PathProxy2.prototype.setScale = function(sx, sy, segmentIgnoreThreshold) {
    segmentIgnoreThreshold = segmentIgnoreThreshold || 0;
    if (segmentIgnoreThreshold > 0) {
      this._ux = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sx) || 0;
      this._uy = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sy) || 0;
    }
  };
  PathProxy2.prototype.setDPR = function(dpr2) {
    this.dpr = dpr2;
  };
  PathProxy2.prototype.setContext = function(ctx) {
    this._ctx = ctx;
  };
  PathProxy2.prototype.getContext = function() {
    return this._ctx;
  };
  PathProxy2.prototype.beginPath = function() {
    this._ctx && this._ctx.beginPath();
    this.reset();
    return this;
  };
  PathProxy2.prototype.reset = function() {
    if (this._saveData) {
      this._len = 0;
    }
    if (this._pathSegLen) {
      this._pathSegLen = null;
      this._pathLen = 0;
    }
    this._version++;
  };
  PathProxy2.prototype.moveTo = function(x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.M, x2, y2);
    this._ctx && this._ctx.moveTo(x2, y2);
    this._x0 = x2;
    this._y0 = y2;
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.lineTo = function(x2, y2) {
    var dx = mathAbs$2(x2 - this._xi);
    var dy = mathAbs$2(y2 - this._yi);
    var exceedUnit = dx > this._ux || dy > this._uy;
    this.addData(CMD$4.L, x2, y2);
    if (this._ctx && exceedUnit) {
      this._ctx.lineTo(x2, y2);
    }
    if (exceedUnit) {
      this._xi = x2;
      this._yi = y2;
      this._pendingPtDist = 0;
    } else {
      var d2 = dx * dx + dy * dy;
      if (d2 > this._pendingPtDist) {
        this._pendingPtX = x2;
        this._pendingPtY = y2;
        this._pendingPtDist = d2;
      }
    }
    return this;
  };
  PathProxy2.prototype.bezierCurveTo = function(x1, y1, x2, y2, x3, y3) {
    this._drawPendingPt();
    this.addData(CMD$4.C, x1, y1, x2, y2, x3, y3);
    if (this._ctx) {
      this._ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
    }
    this._xi = x3;
    this._yi = y3;
    return this;
  };
  PathProxy2.prototype.quadraticCurveTo = function(x1, y1, x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.Q, x1, y1, x2, y2);
    if (this._ctx) {
      this._ctx.quadraticCurveTo(x1, y1, x2, y2);
    }
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this._drawPendingPt();
    tmpAngles[0] = startAngle;
    tmpAngles[1] = endAngle;
    normalizeArcAngles(tmpAngles, anticlockwise);
    startAngle = tmpAngles[0];
    endAngle = tmpAngles[1];
    var delta = endAngle - startAngle;
    this.addData(CMD$4.A, cx, cy, r2, r2, startAngle, delta, 0, anticlockwise ? 0 : 1);
    this._ctx && this._ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
    this._xi = mathCos$3(endAngle) * r2 + cx;
    this._yi = mathSin$3(endAngle) * r2 + cy;
    return this;
  };
  PathProxy2.prototype.arcTo = function(x1, y1, x2, y2, radius) {
    this._drawPendingPt();
    if (this._ctx) {
      this._ctx.arcTo(x1, y1, x2, y2, radius);
    }
    return this;
  };
  PathProxy2.prototype.rect = function(x2, y2, w2, h) {
    this._drawPendingPt();
    this._ctx && this._ctx.rect(x2, y2, w2, h);
    this.addData(CMD$4.R, x2, y2, w2, h);
    return this;
  };
  PathProxy2.prototype.closePath = function() {
    this._drawPendingPt();
    this.addData(CMD$4.Z);
    var ctx = this._ctx;
    var x0 = this._x0;
    var y0 = this._y0;
    if (ctx) {
      ctx.closePath();
    }
    this._xi = x0;
    this._yi = y0;
    return this;
  };
  PathProxy2.prototype.fill = function(ctx) {
    ctx && ctx.fill();
    this.toStatic();
  };
  PathProxy2.prototype.stroke = function(ctx) {
    ctx && ctx.stroke();
    this.toStatic();
  };
  PathProxy2.prototype.len = function() {
    return this._len;
  };
  PathProxy2.prototype.setData = function(data2) {
    var len2 = data2.length;
    if (!(this.data && this.data.length === len2) && hasTypedArray) {
      this.data = new Float32Array(len2);
    }
    for (var i = 0; i < len2; i++) {
      this.data[i] = data2[i];
    }
    this._len = len2;
  };
  PathProxy2.prototype.appendPath = function(path) {
    if (!(path instanceof Array)) {
      path = [path];
    }
    var len2 = path.length;
    var appendSize = 0;
    var offset3 = this._len;
    for (var i = 0; i < len2; i++) {
      appendSize += path[i].len();
    }
    if (hasTypedArray && this.data instanceof Float32Array) {
      this.data = new Float32Array(offset3 + appendSize);
    }
    for (var i = 0; i < len2; i++) {
      var appendPathData = path[i].data;
      for (var k2 = 0; k2 < appendPathData.length; k2++) {
        this.data[offset3++] = appendPathData[k2];
      }
    }
    this._len = offset3;
  };
  PathProxy2.prototype.addData = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    if (!this._saveData) {
      return;
    }
    var data2 = this.data;
    if (this._len + arguments.length > data2.length) {
      this._expandData();
      data2 = this.data;
    }
    for (var i = 0; i < arguments.length; i++) {
      data2[this._len++] = arguments[i];
    }
  };
  PathProxy2.prototype._drawPendingPt = function() {
    if (this._pendingPtDist > 0) {
      this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY);
      this._pendingPtDist = 0;
    }
  };
  PathProxy2.prototype._expandData = function() {
    if (!(this.data instanceof Array)) {
      var newData = [];
      for (var i = 0; i < this._len; i++) {
        newData[i] = this.data[i];
      }
      this.data = newData;
    }
  };
  PathProxy2.prototype.toStatic = function() {
    if (!this._saveData) {
      return;
    }
    this._drawPendingPt();
    var data2 = this.data;
    if (data2 instanceof Array) {
      data2.length = this._len;
      if (hasTypedArray && this._len > 11) {
        this.data = new Float32Array(data2);
      }
    }
  };
  PathProxy2.prototype.getBoundingRect = function() {
    min[0] = min[1] = min2[0] = min2[1] = Number.MAX_VALUE;
    max[0] = max[1] = max2[0] = max2[1] = -Number.MAX_VALUE;
    var data2 = this.data;
    var xi2 = 0;
    var yi2 = 0;
    var x0 = 0;
    var y0 = 0;
    var i;
    for (i = 0; i < this._len; ) {
      var cmd = data2[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi2 = data2[i];
        yi2 = data2[i + 1];
        x0 = xi2;
        y0 = yi2;
      }
      switch (cmd) {
        case CMD$4.M:
          xi2 = x0 = data2[i++];
          yi2 = y0 = data2[i++];
          min2[0] = x0;
          min2[1] = y0;
          max2[0] = x0;
          max2[1] = y0;
          break;
        case CMD$4.L:
          fromLine(xi2, yi2, data2[i], data2[i + 1], min2, max2);
          xi2 = data2[i++];
          yi2 = data2[i++];
          break;
        case CMD$4.C:
          fromCubic(xi2, yi2, data2[i++], data2[i++], data2[i++], data2[i++], data2[i], data2[i + 1], min2, max2);
          xi2 = data2[i++];
          yi2 = data2[i++];
          break;
        case CMD$4.Q:
          fromQuadratic(xi2, yi2, data2[i++], data2[i++], data2[i], data2[i + 1], min2, max2);
          xi2 = data2[i++];
          yi2 = data2[i++];
          break;
        case CMD$4.A:
          var cx = data2[i++];
          var cy = data2[i++];
          var rx = data2[i++];
          var ry = data2[i++];
          var startAngle = data2[i++];
          var endAngle = data2[i++] + startAngle;
          i += 1;
          var anticlockwise = !data2[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          fromArc(cx, cy, rx, ry, startAngle, endAngle, anticlockwise, min2, max2);
          xi2 = mathCos$3(endAngle) * rx + cx;
          yi2 = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R:
          x0 = xi2 = data2[i++];
          y0 = yi2 = data2[i++];
          var width = data2[i++];
          var height = data2[i++];
          fromLine(x0, y0, x0 + width, y0 + height, min2, max2);
          break;
        case CMD$4.Z:
          xi2 = x0;
          yi2 = y0;
          break;
      }
      min$1(min, min, min2);
      max$1(max, max, max2);
    }
    if (i === 0) {
      min[0] = min[1] = max[0] = max[1] = 0;
    }
    return new BoundingRect$1(min[0], min[1], max[0] - min[0], max[1] - min[1]);
  };
  PathProxy2.prototype._calculateLength = function() {
    var data2 = this.data;
    var len2 = this._len;
    var ux = this._ux;
    var uy = this._uy;
    var xi2 = 0;
    var yi2 = 0;
    var x0 = 0;
    var y0 = 0;
    if (!this._pathSegLen) {
      this._pathSegLen = [];
    }
    var pathSegLen = this._pathSegLen;
    var pathTotalLen = 0;
    var segCount = 0;
    for (var i = 0; i < len2; ) {
      var cmd = data2[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi2 = data2[i];
        yi2 = data2[i + 1];
        x0 = xi2;
        y0 = yi2;
      }
      var l2 = -1;
      switch (cmd) {
        case CMD$4.M:
          xi2 = x0 = data2[i++];
          yi2 = y0 = data2[i++];
          break;
        case CMD$4.L: {
          var x2 = data2[i++];
          var y2 = data2[i++];
          var dx = x2 - xi2;
          var dy = y2 - yi2;
          if (mathAbs$2(dx) > ux || mathAbs$2(dy) > uy || i === len2 - 1) {
            l2 = Math.sqrt(dx * dx + dy * dy);
            xi2 = x2;
            yi2 = y2;
          }
          break;
        }
        case CMD$4.C: {
          var x1 = data2[i++];
          var y1 = data2[i++];
          var x2 = data2[i++];
          var y2 = data2[i++];
          var x3 = data2[i++];
          var y3 = data2[i++];
          l2 = cubicLength(xi2, yi2, x1, y1, x2, y2, x3, y3, 10);
          xi2 = x3;
          yi2 = y3;
          break;
        }
        case CMD$4.Q: {
          var x1 = data2[i++];
          var y1 = data2[i++];
          var x2 = data2[i++];
          var y2 = data2[i++];
          l2 = quadraticLength(xi2, yi2, x1, y1, x2, y2, 10);
          xi2 = x2;
          yi2 = y2;
          break;
        }
        case CMD$4.A:
          var cx = data2[i++];
          var cy = data2[i++];
          var rx = data2[i++];
          var ry = data2[i++];
          var startAngle = data2[i++];
          var delta = data2[i++];
          var endAngle = delta + startAngle;
          i += 1;
          !data2[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          l2 = mathMax$8(rx, ry) * mathMin$8(PI2$8, Math.abs(delta));
          xi2 = mathCos$3(endAngle) * rx + cx;
          yi2 = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R: {
          x0 = xi2 = data2[i++];
          y0 = yi2 = data2[i++];
          var width = data2[i++];
          var height = data2[i++];
          l2 = width * 2 + height * 2;
          break;
        }
        case CMD$4.Z: {
          var dx = x0 - xi2;
          var dy = y0 - yi2;
          l2 = Math.sqrt(dx * dx + dy * dy);
          xi2 = x0;
          yi2 = y0;
          break;
        }
      }
      if (l2 >= 0) {
        pathSegLen[segCount++] = l2;
        pathTotalLen += l2;
      }
    }
    this._pathLen = pathTotalLen;
    return pathTotalLen;
  };
  PathProxy2.prototype.rebuildPath = function(ctx, percent) {
    var d2 = this.data;
    var ux = this._ux;
    var uy = this._uy;
    var len2 = this._len;
    var x0;
    var y0;
    var xi2;
    var yi2;
    var x2;
    var y2;
    var drawPart = percent < 1;
    var pathSegLen;
    var pathTotalLen;
    var accumLength = 0;
    var segCount = 0;
    var displayedLength;
    var pendingPtDist = 0;
    var pendingPtX;
    var pendingPtY;
    if (drawPart) {
      if (!this._pathSegLen) {
        this._calculateLength();
      }
      pathSegLen = this._pathSegLen;
      pathTotalLen = this._pathLen;
      displayedLength = percent * pathTotalLen;
      if (!displayedLength) {
        return;
      }
    }
    lo:
      for (var i = 0; i < len2; ) {
        var cmd = d2[i++];
        var isFirst = i === 1;
        if (isFirst) {
          xi2 = d2[i];
          yi2 = d2[i + 1];
          x0 = xi2;
          y0 = yi2;
        }
        if (cmd !== CMD$4.L && pendingPtDist > 0) {
          ctx.lineTo(pendingPtX, pendingPtY);
          pendingPtDist = 0;
        }
        switch (cmd) {
          case CMD$4.M:
            x0 = xi2 = d2[i++];
            y0 = yi2 = d2[i++];
            ctx.moveTo(xi2, yi2);
            break;
          case CMD$4.L: {
            x2 = d2[i++];
            y2 = d2[i++];
            var dx = mathAbs$2(x2 - xi2);
            var dy = mathAbs$2(y2 - yi2);
            if (dx > ux || dy > uy) {
              if (drawPart) {
                var l2 = pathSegLen[segCount++];
                if (accumLength + l2 > displayedLength) {
                  var t2 = (displayedLength - accumLength) / l2;
                  ctx.lineTo(xi2 * (1 - t2) + x2 * t2, yi2 * (1 - t2) + y2 * t2);
                  break lo;
                }
                accumLength += l2;
              }
              ctx.lineTo(x2, y2);
              xi2 = x2;
              yi2 = y2;
              pendingPtDist = 0;
            } else {
              var d22 = dx * dx + dy * dy;
              if (d22 > pendingPtDist) {
                pendingPtX = x2;
                pendingPtY = y2;
                pendingPtDist = d22;
              }
            }
            break;
          }
          case CMD$4.C: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            var x3 = d2[i++];
            var y3 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                cubicSubdivide(xi2, x1, x22, x3, t2, tmpOutX);
                cubicSubdivide(yi2, y1, y22, y3, t2, tmpOutY);
                ctx.bezierCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2], tmpOutX[3], tmpOutY[3]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.bezierCurveTo(x1, y1, x22, y22, x3, y3);
            xi2 = x3;
            yi2 = y3;
            break;
          }
          case CMD$4.Q: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                quadraticSubdivide(xi2, x1, x22, t2, tmpOutX);
                quadraticSubdivide(yi2, y1, y22, t2, tmpOutY);
                ctx.quadraticCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.quadraticCurveTo(x1, y1, x22, y22);
            xi2 = x22;
            yi2 = y22;
            break;
          }
          case CMD$4.A:
            var cx = d2[i++];
            var cy = d2[i++];
            var rx = d2[i++];
            var ry = d2[i++];
            var startAngle = d2[i++];
            var delta = d2[i++];
            var psi = d2[i++];
            var anticlockwise = !d2[i++];
            var r2 = rx > ry ? rx : ry;
            var isEllipse = mathAbs$2(rx - ry) > 1e-3;
            var endAngle = startAngle + delta;
            var breakBuild = false;
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                endAngle = startAngle + delta * (displayedLength - accumLength) / l2;
                breakBuild = true;
              }
              accumLength += l2;
            }
            if (isEllipse && ctx.ellipse) {
              ctx.ellipse(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise);
            } else {
              ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
            }
            if (breakBuild) {
              break lo;
            }
            if (isFirst) {
              x0 = mathCos$3(startAngle) * rx + cx;
              y0 = mathSin$3(startAngle) * ry + cy;
            }
            xi2 = mathCos$3(endAngle) * rx + cx;
            yi2 = mathSin$3(endAngle) * ry + cy;
            break;
          case CMD$4.R:
            x0 = xi2 = d2[i];
            y0 = yi2 = d2[i + 1];
            x2 = d2[i++];
            y2 = d2[i++];
            var width = d2[i++];
            var height = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var d_1 = displayedLength - accumLength;
                ctx.moveTo(x2, y2);
                ctx.lineTo(x2 + mathMin$8(d_1, width), y2);
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + width, y2 + mathMin$8(d_1, height));
                }
                d_1 -= height;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + mathMax$8(width - d_1, 0), y2 + height);
                }
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2, y2 + mathMax$8(height - d_1, 0));
                }
                break lo;
              }
              accumLength += l2;
            }
            ctx.rect(x2, y2, width, height);
            break;
          case CMD$4.Z:
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                ctx.lineTo(xi2 * (1 - t2) + x0 * t2, yi2 * (1 - t2) + y0 * t2);
                break lo;
              }
              accumLength += l2;
            }
            ctx.closePath();
            xi2 = x0;
            yi2 = y0;
        }
      }
  };
  PathProxy2.prototype.clone = function() {
    var newProxy = new PathProxy2();
    var data2 = this.data;
    newProxy.data = data2.slice ? data2.slice() : Array.prototype.slice.call(data2);
    newProxy._len = this._len;
    return newProxy;
  };
  PathProxy2.CMD = CMD$4;
  PathProxy2.initDefaultProps = function() {
    var proto2 = PathProxy2.prototype;
    proto2._saveData = true;
    proto2._ux = 0;
    proto2._uy = 0;
    proto2._pendingPtDist = 0;
    proto2._version = 0;
  }();
  return PathProxy2;
}();
var PathProxy$1 = PathProxy;
function containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  var _a2 = 0;
  var _b2 = x0;
  if (y2 > y0 + _l && y2 > y1 + _l || y2 < y0 - _l && y2 < y1 - _l || x2 > x0 + _l && x2 > x1 + _l || x2 < x0 - _l && x2 < x1 - _l) {
    return false;
  }
  if (x0 !== x1) {
    _a2 = (y0 - y1) / (x0 - x1);
    _b2 = (x0 * y1 - x1 * y0) / (x0 - x1);
  } else {
    return Math.abs(x2 - x0) <= _l / 2;
  }
  var tmp = _a2 * x2 - y2 + _b2;
  var _s = tmp * tmp / (_a2 * _a2 + 1);
  return _s <= _l / 2 * _l / 2;
}
function containStroke$3(x0, y0, x1, y1, x2, y2, x3, y3, lineWidth, x4, y4) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y4 > y0 + _l && y4 > y1 + _l && y4 > y2 + _l && y4 > y3 + _l || y4 < y0 - _l && y4 < y1 - _l && y4 < y2 - _l && y4 < y3 - _l || x4 > x0 + _l && x4 > x1 + _l && x4 > x2 + _l && x4 > x3 + _l || x4 < x0 - _l && x4 < x1 - _l && x4 < x2 - _l && x4 < x3 - _l) {
    return false;
  }
  var d2 = cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, null);
  return d2 <= _l / 2;
}
function containStroke$2(x0, y0, x1, y1, x2, y2, lineWidth, x3, y3) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y3 > y0 + _l && y3 > y1 + _l && y3 > y2 + _l || y3 < y0 - _l && y3 < y1 - _l && y3 < y2 - _l || x3 > x0 + _l && x3 > x1 + _l && x3 > x2 + _l || x3 < x0 - _l && x3 < x1 - _l && x3 < x2 - _l) {
    return false;
  }
  var d2 = quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, null);
  return d2 <= _l / 2;
}
var PI2$7 = Math.PI * 2;
function normalizeRadian(angle) {
  angle %= PI2$7;
  if (angle < 0) {
    angle += PI2$7;
  }
  return angle;
}
var PI2$6 = Math.PI * 2;
function containStroke$1(cx, cy, r2, startAngle, endAngle, anticlockwise, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  if (d2 - _l > r2 || d2 + _l < r2) {
    return false;
  }
  if (Math.abs(startAngle - endAngle) % PI2$6 < 1e-4) {
    return true;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$6;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$6;
  }
  return angle >= startAngle && angle <= endAngle || angle + PI2$6 >= startAngle && angle + PI2$6 <= endAngle;
}
function windingLine(x0, y0, x1, y1, x2, y2) {
  if (y2 > y0 && y2 > y1 || y2 < y0 && y2 < y1) {
    return 0;
  }
  if (y1 === y0) {
    return 0;
  }
  var t2 = (y2 - y0) / (y1 - y0);
  var dir3 = y1 < y0 ? 1 : -1;
  if (t2 === 1 || t2 === 0) {
    dir3 = y1 < y0 ? 0.5 : -0.5;
  }
  var x_ = t2 * (x1 - x0) + x0;
  return x_ === x2 ? Infinity : x_ > x2 ? dir3 : 0;
}
var CMD$3 = PathProxy$1.CMD;
var PI2$5 = Math.PI * 2;
var EPSILON$1 = 1e-4;
function isAroundEqual$1(a, b2) {
  return Math.abs(a - b2) < EPSILON$1;
}
var roots = [-1, -1, -1];
var extrema = [-1, -1];
function swapExtrema() {
  var tmp = extrema[0];
  extrema[0] = extrema[1];
  extrema[1] = tmp;
}
function windingCubic(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4) {
  if (y4 > y0 && y4 > y1 && y4 > y2 && y4 > y3 || y4 < y0 && y4 < y1 && y4 < y2 && y4 < y3) {
    return 0;
  }
  var nRoots = cubicRootAt(y0, y1, y2, y3, y4, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var w2 = 0;
    var nExtrema = -1;
    var y0_ = void 0;
    var y1_ = void 0;
    for (var i = 0; i < nRoots; i++) {
      var t2 = roots[i];
      var unit = t2 === 0 || t2 === 1 ? 0.5 : 1;
      var x_ = cubicAt(x0, x1, x2, x3, t2);
      if (x_ < x4) {
        continue;
      }
      if (nExtrema < 0) {
        nExtrema = cubicExtrema(y0, y1, y2, y3, extrema);
        if (extrema[1] < extrema[0] && nExtrema > 1) {
          swapExtrema();
        }
        y0_ = cubicAt(y0, y1, y2, y3, extrema[0]);
        if (nExtrema > 1) {
          y1_ = cubicAt(y0, y1, y2, y3, extrema[1]);
        }
      }
      if (nExtrema === 2) {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else if (t2 < extrema[1]) {
          w2 += y1_ < y0_ ? unit : -unit;
        } else {
          w2 += y3 < y1_ ? unit : -unit;
        }
      } else {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else {
          w2 += y3 < y0_ ? unit : -unit;
        }
      }
    }
    return w2;
  }
}
function windingQuadratic(x0, y0, x1, y1, x2, y2, x3, y3) {
  if (y3 > y0 && y3 > y1 && y3 > y2 || y3 < y0 && y3 < y1 && y3 < y2) {
    return 0;
  }
  var nRoots = quadraticRootAt(y0, y1, y2, y3, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var t2 = quadraticExtremum(y0, y1, y2);
    if (t2 >= 0 && t2 <= 1) {
      var w2 = 0;
      var y_ = quadraticAt$1(y0, y1, y2, t2);
      for (var i = 0; i < nRoots; i++) {
        var unit = roots[i] === 0 || roots[i] === 1 ? 0.5 : 1;
        var x_ = quadraticAt$1(x0, x1, x2, roots[i]);
        if (x_ < x3) {
          continue;
        }
        if (roots[i] < t2) {
          w2 += y_ < y0 ? unit : -unit;
        } else {
          w2 += y2 < y_ ? unit : -unit;
        }
      }
      return w2;
    } else {
      var unit = roots[0] === 0 || roots[0] === 1 ? 0.5 : 1;
      var x_ = quadraticAt$1(x0, x1, x2, roots[0]);
      if (x_ < x3) {
        return 0;
      }
      return y2 < y0 ? unit : -unit;
    }
  }
}
function windingArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2) {
  y2 -= cy;
  if (y2 > r2 || y2 < -r2) {
    return 0;
  }
  var tmp = Math.sqrt(r2 * r2 - y2 * y2);
  roots[0] = -tmp;
  roots[1] = tmp;
  var dTheta = Math.abs(startAngle - endAngle);
  if (dTheta < 1e-4) {
    return 0;
  }
  if (dTheta >= PI2$5 - 1e-4) {
    startAngle = 0;
    endAngle = PI2$5;
    var dir3 = anticlockwise ? 1 : -1;
    if (x2 >= roots[0] + cx && x2 <= roots[1] + cx) {
      return dir3;
    } else {
      return 0;
    }
  }
  if (startAngle > endAngle) {
    var tmp_1 = startAngle;
    startAngle = endAngle;
    endAngle = tmp_1;
  }
  if (startAngle < 0) {
    startAngle += PI2$5;
    endAngle += PI2$5;
  }
  var w2 = 0;
  for (var i = 0; i < 2; i++) {
    var x_ = roots[i];
    if (x_ + cx > x2) {
      var angle = Math.atan2(y2, x_);
      var dir3 = anticlockwise ? 1 : -1;
      if (angle < 0) {
        angle = PI2$5 + angle;
      }
      if (angle >= startAngle && angle <= endAngle || angle + PI2$5 >= startAngle && angle + PI2$5 <= endAngle) {
        if (angle > Math.PI / 2 && angle < Math.PI * 1.5) {
          dir3 = -dir3;
        }
        w2 += dir3;
      }
    }
  }
  return w2;
}
function containPath(path, lineWidth, isStroke, x2, y2) {
  var data2 = path.data;
  var len2 = path.len();
  var w2 = 0;
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  for (var i = 0; i < len2; ) {
    var cmd = data2[i++];
    var isFirst = i === 1;
    if (cmd === CMD$3.M && i > 1) {
      if (!isStroke) {
        w2 += windingLine(xi2, yi2, x0, y0, x2, y2);
      }
    }
    if (isFirst) {
      xi2 = data2[i];
      yi2 = data2[i + 1];
      x0 = xi2;
      y0 = yi2;
    }
    switch (cmd) {
      case CMD$3.M:
        x0 = data2[i++];
        y0 = data2[i++];
        xi2 = x0;
        yi2 = y0;
        break;
      case CMD$3.L:
        if (isStroke) {
          if (containStroke$4(xi2, yi2, data2[i], data2[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi2, yi2, data2[i], data2[i + 1], x2, y2) || 0;
        }
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$3.C:
        if (isStroke) {
          if (containStroke$3(xi2, yi2, data2[i++], data2[i++], data2[i++], data2[i++], data2[i], data2[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingCubic(xi2, yi2, data2[i++], data2[i++], data2[i++], data2[i++], data2[i], data2[i + 1], x2, y2) || 0;
        }
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$3.Q:
        if (isStroke) {
          if (containStroke$2(xi2, yi2, data2[i++], data2[i++], data2[i], data2[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingQuadratic(xi2, yi2, data2[i++], data2[i++], data2[i], data2[i + 1], x2, y2) || 0;
        }
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$3.A:
        var cx = data2[i++];
        var cy = data2[i++];
        var rx = data2[i++];
        var ry = data2[i++];
        var theta = data2[i++];
        var dTheta = data2[i++];
        i += 1;
        var anticlockwise = !!(1 - data2[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (!isFirst) {
          w2 += windingLine(xi2, yi2, x1, y1, x2, y2);
        } else {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        if (isStroke) {
          if (containStroke$1(cx, cy, ry, theta, theta + dTheta, anticlockwise, lineWidth, _x, y2)) {
            return true;
          }
        } else {
          w2 += windingArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2);
        }
        xi2 = Math.cos(theta + dTheta) * rx + cx;
        yi2 = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$3.R:
        x0 = xi2 = data2[i++];
        y0 = yi2 = data2[i++];
        var width = data2[i++];
        var height = data2[i++];
        x1 = x0 + width;
        y1 = y0 + height;
        if (isStroke) {
          if (containStroke$4(x0, y0, x1, y0, lineWidth, x2, y2) || containStroke$4(x1, y0, x1, y1, lineWidth, x2, y2) || containStroke$4(x1, y1, x0, y1, lineWidth, x2, y2) || containStroke$4(x0, y1, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(x1, y0, x1, y1, x2, y2);
          w2 += windingLine(x0, y1, x0, y0, x2, y2);
        }
        break;
      case CMD$3.Z:
        if (isStroke) {
          if (containStroke$4(xi2, yi2, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi2, yi2, x0, y0, x2, y2);
        }
        xi2 = x0;
        yi2 = y0;
        break;
    }
  }
  if (!isStroke && !isAroundEqual$1(yi2, y0)) {
    w2 += windingLine(xi2, yi2, x0, y0, x2, y2) || 0;
  }
  return w2 !== 0;
}
function contain$2(pathProxy, x2, y2) {
  return containPath(pathProxy, 0, false, x2, y2);
}
function containStroke(pathProxy, lineWidth, x2, y2) {
  return containPath(pathProxy, lineWidth, true, x2, y2);
}
var DEFAULT_PATH_STYLE = defaults({
  fill: "#000",
  stroke: null,
  strokePercent: 1,
  fillOpacity: 1,
  strokeOpacity: 1,
  lineDashOffset: 0,
  lineWidth: 1,
  lineCap: "butt",
  miterLimit: 10,
  strokeNoScale: false,
  strokeFirst: false
}, DEFAULT_COMMON_STYLE);
var DEFAULT_PATH_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    strokePercent: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineDashOffset: true,
    lineWidth: true,
    miterLimit: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var pathCopyParams = TRANSFORMABLE_PROPS.concat([
  "invisible",
  "culling",
  "z",
  "z2",
  "zlevel",
  "parent"
]);
var Path = function(_super) {
  __extends(Path2, _super);
  function Path2(opts) {
    return _super.call(this, opts) || this;
  }
  Path2.prototype.update = function() {
    var _this = this;
    _super.prototype.update.call(this);
    var style2 = this.style;
    if (style2.decal) {
      var decalEl = this._decalEl = this._decalEl || new Path2();
      if (decalEl.buildPath === Path2.prototype.buildPath) {
        decalEl.buildPath = function(ctx) {
          _this.buildPath(ctx, _this.shape);
        };
      }
      decalEl.silent = true;
      var decalElStyle = decalEl.style;
      for (var key in style2) {
        if (decalElStyle[key] !== style2[key]) {
          decalElStyle[key] = style2[key];
        }
      }
      decalElStyle.fill = style2.fill ? style2.decal : null;
      decalElStyle.decal = null;
      decalElStyle.shadowColor = null;
      style2.strokeFirst && (decalElStyle.stroke = null);
      for (var i = 0; i < pathCopyParams.length; ++i) {
        decalEl[pathCopyParams[i]] = this[pathCopyParams[i]];
      }
      decalEl.__dirty |= REDRAW_BIT;
    } else if (this._decalEl) {
      this._decalEl = null;
    }
  };
  Path2.prototype.getDecalElement = function() {
    return this._decalEl;
  };
  Path2.prototype._init = function(props) {
    var keysArr = keys(props);
    this.shape = this.getDefaultShape();
    var defaultStyle = this.getDefaultStyle();
    if (defaultStyle) {
      this.useStyle(defaultStyle);
    }
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      var value = props[key];
      if (key === "style") {
        if (!this.style) {
          this.useStyle(value);
        } else {
          extend(this.style, value);
        }
      } else if (key === "shape") {
        extend(this.shape, value);
      } else {
        _super.prototype.attrKV.call(this, key, value);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Path2.prototype.getDefaultStyle = function() {
    return null;
  };
  Path2.prototype.getDefaultShape = function() {
    return {};
  };
  Path2.prototype.canBeInsideText = function() {
    return this.hasFill();
  };
  Path2.prototype.getInsideTextFill = function() {
    var pathFill = this.style.fill;
    if (pathFill !== "none") {
      if (isString$1(pathFill)) {
        var fillLum = lum(pathFill, 0);
        if (fillLum > 0.5) {
          return DARK_LABEL_COLOR;
        } else if (fillLum > 0.2) {
          return LIGHTER_LABEL_COLOR;
        }
        return LIGHT_LABEL_COLOR;
      } else if (pathFill) {
        return LIGHT_LABEL_COLOR;
      }
    }
    return DARK_LABEL_COLOR;
  };
  Path2.prototype.getInsideTextStroke = function(textFill) {
    var pathFill = this.style.fill;
    if (isString$1(pathFill)) {
      var zr = this.__zr;
      var isDarkMode2 = !!(zr && zr.isDarkMode());
      var isDarkLabel = lum(textFill, 0) < DARK_MODE_THRESHOLD;
      if (isDarkMode2 === isDarkLabel) {
        return pathFill;
      }
    }
  };
  Path2.prototype.buildPath = function(ctx, shapeCfg, inBatch) {
  };
  Path2.prototype.pathUpdated = function() {
    this.__dirty &= ~SHAPE_CHANGED_BIT;
  };
  Path2.prototype.getUpdatedPathProxy = function(inBatch) {
    !this.path && this.createPathProxy();
    this.path.beginPath();
    this.buildPath(this.path, this.shape, inBatch);
    return this.path;
  };
  Path2.prototype.createPathProxy = function() {
    this.path = new PathProxy$1(false);
  };
  Path2.prototype.hasStroke = function() {
    var style2 = this.style;
    var stroke = style2.stroke;
    return !(stroke == null || stroke === "none" || !(style2.lineWidth > 0));
  };
  Path2.prototype.hasFill = function() {
    var style2 = this.style;
    var fill = style2.fill;
    return fill != null && fill !== "none";
  };
  Path2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    var style2 = this.style;
    var needsUpdateRect = !rect;
    if (needsUpdateRect) {
      var firstInvoke = false;
      if (!this.path) {
        firstInvoke = true;
        this.createPathProxy();
      }
      var path = this.path;
      if (firstInvoke || this.__dirty & SHAPE_CHANGED_BIT) {
        path.beginPath();
        this.buildPath(path, this.shape, false);
        this.pathUpdated();
      }
      rect = path.getBoundingRect();
    }
    this._rect = rect;
    if (this.hasStroke() && this.path && this.path.len() > 0) {
      var rectStroke = this._rectStroke || (this._rectStroke = rect.clone());
      if (this.__dirty || needsUpdateRect) {
        rectStroke.copy(rect);
        var lineScale = style2.strokeNoScale ? this.getLineScale() : 1;
        var w2 = style2.lineWidth;
        if (!this.hasFill()) {
          var strokeContainThreshold = this.strokeContainThreshold;
          w2 = Math.max(w2, strokeContainThreshold == null ? 4 : strokeContainThreshold);
        }
        if (lineScale > 1e-10) {
          rectStroke.width += w2 / lineScale;
          rectStroke.height += w2 / lineScale;
          rectStroke.x -= w2 / lineScale / 2;
          rectStroke.y -= w2 / lineScale / 2;
        }
      }
      return rectStroke;
    }
    return rect;
  };
  Path2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    var style2 = this.style;
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var pathProxy = this.path;
      if (this.hasStroke()) {
        var lineWidth = style2.lineWidth;
        var lineScale = style2.strokeNoScale ? this.getLineScale() : 1;
        if (lineScale > 1e-10) {
          if (!this.hasFill()) {
            lineWidth = Math.max(lineWidth, this.strokeContainThreshold);
          }
          if (containStroke(pathProxy, lineWidth / lineScale, x2, y2)) {
            return true;
          }
        }
      }
      if (this.hasFill()) {
        return contain$2(pathProxy, x2, y2);
      }
    }
    return false;
  };
  Path2.prototype.dirtyShape = function() {
    this.__dirty |= SHAPE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
    if (this._decalEl) {
      this._decalEl.dirtyShape();
    }
    this.markRedraw();
  };
  Path2.prototype.dirty = function() {
    this.dirtyStyle();
    this.dirtyShape();
  };
  Path2.prototype.animateShape = function(loop) {
    return this.animate("shape", loop);
  };
  Path2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else if (targetKey === "shape") {
      this.dirtyShape();
    } else {
      this.markRedraw();
    }
  };
  Path2.prototype.attrKV = function(key, value) {
    if (key === "shape") {
      this.setShape(value);
    } else {
      _super.prototype.attrKV.call(this, key, value);
    }
  };
  Path2.prototype.setShape = function(keyOrObj, value) {
    var shape = this.shape;
    if (!shape) {
      shape = this.shape = {};
    }
    if (typeof keyOrObj === "string") {
      shape[keyOrObj] = value;
    } else {
      extend(shape, keyOrObj);
    }
    this.dirtyShape();
    return this;
  };
  Path2.prototype.shapeChanged = function() {
    return !!(this.__dirty & SHAPE_CHANGED_BIT);
  };
  Path2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_PATH_STYLE, obj);
  };
  Path2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.shape && !normalState.shape) {
      normalState.shape = extend({}, this.shape);
    }
  };
  Path2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetShape;
    if (state && state.shape) {
      if (transition) {
        if (keepCurrentStates) {
          targetShape = state.shape;
        } else {
          targetShape = extend({}, normalState.shape);
          extend(targetShape, state.shape);
        }
      } else {
        targetShape = extend({}, keepCurrentStates ? this.shape : normalState.shape);
        extend(targetShape, state.shape);
      }
    } else if (needsRestoreToNormal) {
      targetShape = normalState.shape;
    }
    if (targetShape) {
      if (transition) {
        this.shape = extend({}, this.shape);
        var targetShapePrimaryProps = {};
        var shapeKeys = keys(targetShape);
        for (var i = 0; i < shapeKeys.length; i++) {
          var key = shapeKeys[i];
          if (typeof targetShape[key] === "object") {
            this.shape[key] = targetShape[key];
          } else {
            targetShapePrimaryProps[key] = targetShape[key];
          }
        }
        this._transitionState(stateName, {
          shape: targetShapePrimaryProps
        }, animationCfg);
      } else {
        this.shape = targetShape;
        this.dirtyShape();
      }
    }
  };
  Path2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedShape;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.shape) {
        mergedShape = mergedShape || {};
        this._mergeStyle(mergedShape, state.shape);
      }
    }
    if (mergedShape) {
      mergedState.shape = mergedShape;
    }
    return mergedState;
  };
  Path2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_PATH_ANIMATION_PROPS;
  };
  Path2.prototype.isZeroArea = function() {
    return false;
  };
  Path2.extend = function(defaultProps) {
    var Sub = function(_super2) {
      __extends(Sub2, _super2);
      function Sub2(opts) {
        var _this = _super2.call(this, opts) || this;
        defaultProps.init && defaultProps.init.call(_this, opts);
        return _this;
      }
      Sub2.prototype.getDefaultStyle = function() {
        return clone$4(defaultProps.style);
      };
      Sub2.prototype.getDefaultShape = function() {
        return clone$4(defaultProps.shape);
      };
      return Sub2;
    }(Path2);
    for (var key in defaultProps) {
      if (typeof defaultProps[key] === "function") {
        Sub.prototype[key] = defaultProps[key];
      }
    }
    return Sub;
  };
  Path2.initDefaultProps = function() {
    var pathProto = Path2.prototype;
    pathProto.type = "path";
    pathProto.strokeContainThreshold = 5;
    pathProto.segmentIgnoreThreshold = 0;
    pathProto.subPixelOptimize = false;
    pathProto.autoBatch = false;
    pathProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT | SHAPE_CHANGED_BIT;
  }();
  return Path2;
}(Displayable$1);
var Path$1 = Path;
var DEFAULT_TSPAN_STYLE = defaults({
  strokeFirst: true,
  font: DEFAULT_FONT,
  x: 0,
  y: 0,
  textAlign: "left",
  textBaseline: "top",
  miterLimit: 2
}, DEFAULT_PATH_STYLE);
var TSpan = function(_super) {
  __extends(TSpan2, _super);
  function TSpan2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TSpan2.prototype.hasStroke = function() {
    var style2 = this.style;
    var stroke = style2.stroke;
    return stroke != null && stroke !== "none" && style2.lineWidth > 0;
  };
  TSpan2.prototype.hasFill = function() {
    var style2 = this.style;
    var fill = style2.fill;
    return fill != null && fill !== "none";
  };
  TSpan2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_TSPAN_STYLE, obj);
  };
  TSpan2.prototype.setBoundingRect = function(rect) {
    this._rect = rect;
  };
  TSpan2.prototype.getBoundingRect = function() {
    var style2 = this.style;
    if (!this._rect) {
      var text = style2.text;
      text != null ? text += "" : text = "";
      var rect = getBoundingRect(text, style2.font, style2.textAlign, style2.textBaseline);
      rect.x += style2.x || 0;
      rect.y += style2.y || 0;
      if (this.hasStroke()) {
        var w2 = style2.lineWidth;
        rect.x -= w2 / 2;
        rect.y -= w2 / 2;
        rect.width += w2;
        rect.height += w2;
      }
      this._rect = rect;
    }
    return this._rect;
  };
  TSpan2.initDefaultProps = function() {
    var tspanProto = TSpan2.prototype;
    tspanProto.dirtyRectTolerance = 10;
  }();
  return TSpan2;
}(Displayable$1);
TSpan.prototype.type = "tspan";
var TSpan$1 = TSpan;
var DEFAULT_IMAGE_STYLE = defaults({
  x: 0,
  y: 0
}, DEFAULT_COMMON_STYLE);
var DEFAULT_IMAGE_ANIMATION_PROPS = {
  style: defaults({
    x: true,
    y: true,
    width: true,
    height: true,
    sx: true,
    sy: true,
    sWidth: true,
    sHeight: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
function isImageLike$1(source) {
  return !!(source && typeof source !== "string" && source.width && source.height);
}
var ZRImage = function(_super) {
  __extends(ZRImage2, _super);
  function ZRImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ZRImage2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_IMAGE_STYLE, obj);
  };
  ZRImage2.prototype._getSize = function(dim) {
    var style2 = this.style;
    var size = style2[dim];
    if (size != null) {
      return size;
    }
    var imageSource = isImageLike$1(style2.image) ? style2.image : this.__image;
    if (!imageSource) {
      return 0;
    }
    var otherDim = dim === "width" ? "height" : "width";
    var otherDimSize = style2[otherDim];
    if (otherDimSize == null) {
      return imageSource[dim];
    } else {
      return imageSource[dim] / imageSource[otherDim] * otherDimSize;
    }
  };
  ZRImage2.prototype.getWidth = function() {
    return this._getSize("width");
  };
  ZRImage2.prototype.getHeight = function() {
    return this._getSize("height");
  };
  ZRImage2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_IMAGE_ANIMATION_PROPS;
  };
  ZRImage2.prototype.getBoundingRect = function() {
    var style2 = this.style;
    if (!this._rect) {
      this._rect = new BoundingRect$1(style2.x || 0, style2.y || 0, this.getWidth(), this.getHeight());
    }
    return this._rect;
  };
  return ZRImage2;
}(Displayable$1);
ZRImage.prototype.type = "image";
var ZRImage$1 = ZRImage;
function buildPath$2(ctx, shape) {
  var x2 = shape.x;
  var y2 = shape.y;
  var width = shape.width;
  var height = shape.height;
  var r2 = shape.r;
  var r1;
  var r22;
  var r3;
  var r4;
  if (width < 0) {
    x2 = x2 + width;
    width = -width;
  }
  if (height < 0) {
    y2 = y2 + height;
    height = -height;
  }
  if (typeof r2 === "number") {
    r1 = r22 = r3 = r4 = r2;
  } else if (r2 instanceof Array) {
    if (r2.length === 1) {
      r1 = r22 = r3 = r4 = r2[0];
    } else if (r2.length === 2) {
      r1 = r3 = r2[0];
      r22 = r4 = r2[1];
    } else if (r2.length === 3) {
      r1 = r2[0];
      r22 = r4 = r2[1];
      r3 = r2[2];
    } else {
      r1 = r2[0];
      r22 = r2[1];
      r3 = r2[2];
      r4 = r2[3];
    }
  } else {
    r1 = r22 = r3 = r4 = 0;
  }
  var total;
  if (r1 + r22 > width) {
    total = r1 + r22;
    r1 *= width / total;
    r22 *= width / total;
  }
  if (r3 + r4 > width) {
    total = r3 + r4;
    r3 *= width / total;
    r4 *= width / total;
  }
  if (r22 + r3 > height) {
    total = r22 + r3;
    r22 *= height / total;
    r3 *= height / total;
  }
  if (r1 + r4 > height) {
    total = r1 + r4;
    r1 *= height / total;
    r4 *= height / total;
  }
  ctx.moveTo(x2 + r1, y2);
  ctx.lineTo(x2 + width - r22, y2);
  r22 !== 0 && ctx.arc(x2 + width - r22, y2 + r22, r22, -Math.PI / 2, 0);
  ctx.lineTo(x2 + width, y2 + height - r3);
  r3 !== 0 && ctx.arc(x2 + width - r3, y2 + height - r3, r3, 0, Math.PI / 2);
  ctx.lineTo(x2 + r4, y2 + height);
  r4 !== 0 && ctx.arc(x2 + r4, y2 + height - r4, r4, Math.PI / 2, Math.PI);
  ctx.lineTo(x2, y2 + r1);
  r1 !== 0 && ctx.arc(x2 + r1, y2 + r1, r1, Math.PI, Math.PI * 1.5);
}
var round$2 = Math.round;
function subPixelOptimizeLine$1(outputShape, inputShape, style2) {
  if (!inputShape) {
    return;
  }
  var x1 = inputShape.x1;
  var x2 = inputShape.x2;
  var y1 = inputShape.y1;
  var y2 = inputShape.y2;
  outputShape.x1 = x1;
  outputShape.x2 = x2;
  outputShape.y1 = y1;
  outputShape.y2 = y2;
  var lineWidth = style2 && style2.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  if (round$2(x1 * 2) === round$2(x2 * 2)) {
    outputShape.x1 = outputShape.x2 = subPixelOptimize$1(x1, lineWidth, true);
  }
  if (round$2(y1 * 2) === round$2(y2 * 2)) {
    outputShape.y1 = outputShape.y2 = subPixelOptimize$1(y1, lineWidth, true);
  }
  return outputShape;
}
function subPixelOptimizeRect$1(outputShape, inputShape, style2) {
  if (!inputShape) {
    return;
  }
  var originX = inputShape.x;
  var originY = inputShape.y;
  var originWidth = inputShape.width;
  var originHeight = inputShape.height;
  outputShape.x = originX;
  outputShape.y = originY;
  outputShape.width = originWidth;
  outputShape.height = originHeight;
  var lineWidth = style2 && style2.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  outputShape.x = subPixelOptimize$1(originX, lineWidth, true);
  outputShape.y = subPixelOptimize$1(originY, lineWidth, true);
  outputShape.width = Math.max(subPixelOptimize$1(originX + originWidth, lineWidth, false) - outputShape.x, originWidth === 0 ? 0 : 1);
  outputShape.height = Math.max(subPixelOptimize$1(originY + originHeight, lineWidth, false) - outputShape.y, originHeight === 0 ? 0 : 1);
  return outputShape;
}
function subPixelOptimize$1(position2, lineWidth, positiveOrNegative) {
  if (!lineWidth) {
    return position2;
  }
  var doubledPosition = round$2(position2 * 2);
  return (doubledPosition + round$2(lineWidth)) % 2 === 0 ? doubledPosition / 2 : (doubledPosition + (positiveOrNegative ? 1 : -1)) / 2;
}
var RectShape = function() {
  function RectShape2() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
  }
  return RectShape2;
}();
var subPixelOptimizeOutputShape$1 = {};
var Rect$2 = function(_super) {
  __extends(Rect2, _super);
  function Rect2(opts) {
    return _super.call(this, opts) || this;
  }
  Rect2.prototype.getDefaultShape = function() {
    return new RectShape();
  };
  Rect2.prototype.buildPath = function(ctx, shape) {
    var x2;
    var y2;
    var width;
    var height;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeRect$1(subPixelOptimizeOutputShape$1, shape, this.style);
      x2 = optimizedShape.x;
      y2 = optimizedShape.y;
      width = optimizedShape.width;
      height = optimizedShape.height;
      optimizedShape.r = shape.r;
      shape = optimizedShape;
    } else {
      x2 = shape.x;
      y2 = shape.y;
      width = shape.width;
      height = shape.height;
    }
    if (!shape.r) {
      ctx.rect(x2, y2, width, height);
    } else {
      buildPath$2(ctx, shape);
    }
  };
  Rect2.prototype.isZeroArea = function() {
    return !this.shape.width || !this.shape.height;
  };
  return Rect2;
}(Path$1);
Rect$2.prototype.type = "rect";
var Rect$3 = Rect$2;
var DEFAULT_RICH_TEXT_COLOR = {
  fill: "#000"
};
var DEFAULT_STROKE_LINE_WIDTH = 2;
var DEFAULT_TEXT_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineWidth: true,
    fontSize: true,
    lineHeight: true,
    width: true,
    height: true,
    textShadowColor: true,
    textShadowBlur: true,
    textShadowOffsetX: true,
    textShadowOffsetY: true,
    backgroundColor: true,
    padding: true,
    borderColor: true,
    borderWidth: true,
    borderRadius: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var ZRText = function(_super) {
  __extends(ZRText2, _super);
  function ZRText2(opts) {
    var _this = _super.call(this) || this;
    _this.type = "text";
    _this._children = [];
    _this._defaultStyle = DEFAULT_RICH_TEXT_COLOR;
    _this.attr(opts);
    return _this;
  }
  ZRText2.prototype.childrenRef = function() {
    return this._children;
  };
  ZRText2.prototype.update = function() {
    _super.prototype.update.call(this);
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.zlevel = this.zlevel;
      child.z = this.z;
      child.z2 = this.z2;
      child.culling = this.culling;
      child.cursor = this.cursor;
      child.invisible = this.invisible;
    }
  };
  ZRText2.prototype.updateTransform = function() {
    var innerTransformable = this.innerTransformable;
    if (innerTransformable) {
      innerTransformable.updateTransform();
      if (innerTransformable.transform) {
        this.transform = innerTransformable.transform;
      }
    } else {
      _super.prototype.updateTransform.call(this);
    }
  };
  ZRText2.prototype.getLocalTransform = function(m2) {
    var innerTransformable = this.innerTransformable;
    return innerTransformable ? innerTransformable.getLocalTransform(m2) : _super.prototype.getLocalTransform.call(this, m2);
  };
  ZRText2.prototype.getComputedTransform = function() {
    if (this.__hostTarget) {
      this.__hostTarget.getComputedTransform();
      this.__hostTarget.updateInnerText(true);
    }
    return _super.prototype.getComputedTransform.call(this);
  };
  ZRText2.prototype._updateSubTexts = function() {
    this._childCursor = 0;
    normalizeTextStyle(this.style);
    this.style.rich ? this._updateRichTexts() : this._updatePlainTexts();
    this._children.length = this._childCursor;
    this.styleUpdated();
  };
  ZRText2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = zr;
    }
  };
  ZRText2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = null;
    }
  };
  ZRText2.prototype.getBoundingRect = function() {
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    if (!this._rect) {
      var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
      var children = this._children;
      var tmpMat = [];
      var rect = null;
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var childRect = child.getBoundingRect();
        var transform2 = child.getLocalTransform(tmpMat);
        if (transform2) {
          tmpRect2.copy(childRect);
          tmpRect2.applyTransform(transform2);
          rect = rect || tmpRect2.clone();
          rect.union(tmpRect2);
        } else {
          rect = rect || childRect.clone();
          rect.union(childRect);
        }
      }
      this._rect = rect || tmpRect2;
    }
    return this._rect;
  };
  ZRText2.prototype.setDefaultTextStyle = function(defaultTextStyle) {
    this._defaultStyle = defaultTextStyle || DEFAULT_RICH_TEXT_COLOR;
  };
  ZRText2.prototype.setTextContent = function(textContent) {
  };
  ZRText2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    if (!sourceStyle) {
      return targetStyle;
    }
    var sourceRich = sourceStyle.rich;
    var targetRich = targetStyle.rich || sourceRich && {};
    extend(targetStyle, sourceStyle);
    if (sourceRich && targetRich) {
      this._mergeRich(targetRich, sourceRich);
      targetStyle.rich = targetRich;
    } else if (targetRich) {
      targetStyle.rich = targetRich;
    }
    return targetStyle;
  };
  ZRText2.prototype._mergeRich = function(targetRich, sourceRich) {
    var richNames = keys(sourceRich);
    for (var i = 0; i < richNames.length; i++) {
      var richName = richNames[i];
      targetRich[richName] = targetRich[richName] || {};
      extend(targetRich[richName], sourceRich[richName]);
    }
  };
  ZRText2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_TEXT_ANIMATION_PROPS;
  };
  ZRText2.prototype._getOrCreateChild = function(Ctor) {
    var child = this._children[this._childCursor];
    if (!child || !(child instanceof Ctor)) {
      child = new Ctor();
    }
    this._children[this._childCursor++] = child;
    child.__zr = this.__zr;
    child.parent = this;
    return child;
  };
  ZRText2.prototype._updatePlainTexts = function() {
    var style2 = this.style;
    var textFont = style2.font || DEFAULT_FONT;
    var textPadding = style2.padding;
    var text = getStyleText(style2);
    var contentBlock = parsePlainText(text, style2);
    var needDrawBg = needDrawBackground(style2);
    var bgColorDrawn = !!style2.backgroundColor;
    var outerHeight = contentBlock.outerHeight;
    var outerWidth = contentBlock.outerWidth;
    var contentWidth = contentBlock.contentWidth;
    var textLines = contentBlock.lines;
    var lineHeight = contentBlock.lineHeight;
    var defaultStyle = this._defaultStyle;
    var baseX = style2.x || 0;
    var baseY = style2.y || 0;
    var textAlign = style2.align || defaultStyle.align || "left";
    var verticalAlign = style2.verticalAlign || defaultStyle.verticalAlign || "top";
    var textX = baseX;
    var textY = adjustTextY(baseY, contentBlock.contentHeight, verticalAlign);
    if (needDrawBg || textPadding) {
      var boxX = adjustTextX(baseX, outerWidth, textAlign);
      var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
      needDrawBg && this._renderBackground(style2, style2, boxX, boxY, outerWidth, outerHeight);
    }
    textY += lineHeight / 2;
    if (textPadding) {
      textX = getTextXForPadding(baseX, textAlign, textPadding);
      if (verticalAlign === "top") {
        textY += textPadding[0];
      } else if (verticalAlign === "bottom") {
        textY -= textPadding[2];
      }
    }
    var defaultLineWidth = 0;
    var useDefaultFill = false;
    var textFill = getFill("fill" in style2 ? style2.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in style2 ? style2.stroke : !bgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = style2.textShadowBlur > 0;
    var fixedBoundingRect = style2.width != null && (style2.overflow === "truncate" || style2.overflow === "break" || style2.overflow === "breakAll");
    var calculatedLineHeight = contentBlock.calculatedLineHeight;
    for (var i = 0; i < textLines.length; i++) {
      var el = this._getOrCreateChild(TSpan$1);
      var subElStyle = el.createStyle();
      el.useStyle(subElStyle);
      subElStyle.text = textLines[i];
      subElStyle.x = textX;
      subElStyle.y = textY;
      if (textAlign) {
        subElStyle.textAlign = textAlign;
      }
      subElStyle.textBaseline = "middle";
      subElStyle.opacity = style2.opacity;
      subElStyle.strokeFirst = true;
      if (hasShadow2) {
        subElStyle.shadowBlur = style2.textShadowBlur || 0;
        subElStyle.shadowColor = style2.textShadowColor || "transparent";
        subElStyle.shadowOffsetX = style2.textShadowOffsetX || 0;
        subElStyle.shadowOffsetY = style2.textShadowOffsetY || 0;
      }
      subElStyle.stroke = textStroke;
      subElStyle.fill = textFill;
      if (textStroke) {
        subElStyle.lineWidth = style2.lineWidth || defaultLineWidth;
        subElStyle.lineDash = style2.lineDash;
        subElStyle.lineDashOffset = style2.lineDashOffset || 0;
      }
      subElStyle.font = textFont;
      setSeparateFont(subElStyle, style2);
      textY += lineHeight;
      if (fixedBoundingRect) {
        el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, style2.width, subElStyle.textAlign), adjustTextY(subElStyle.y, calculatedLineHeight, subElStyle.textBaseline), contentWidth, calculatedLineHeight));
      }
    }
  };
  ZRText2.prototype._updateRichTexts = function() {
    var style2 = this.style;
    var text = getStyleText(style2);
    var contentBlock = parseRichText(text, style2);
    var contentWidth = contentBlock.width;
    var outerWidth = contentBlock.outerWidth;
    var outerHeight = contentBlock.outerHeight;
    var textPadding = style2.padding;
    var baseX = style2.x || 0;
    var baseY = style2.y || 0;
    var defaultStyle = this._defaultStyle;
    var textAlign = style2.align || defaultStyle.align;
    var verticalAlign = style2.verticalAlign || defaultStyle.verticalAlign;
    var boxX = adjustTextX(baseX, outerWidth, textAlign);
    var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
    var xLeft = boxX;
    var lineTop = boxY;
    if (textPadding) {
      xLeft += textPadding[3];
      lineTop += textPadding[0];
    }
    var xRight = xLeft + contentWidth;
    if (needDrawBackground(style2)) {
      this._renderBackground(style2, style2, boxX, boxY, outerWidth, outerHeight);
    }
    var bgColorDrawn = !!style2.backgroundColor;
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var tokens = line.tokens;
      var tokenCount = tokens.length;
      var lineHeight = line.lineHeight;
      var remainedWidth = line.width;
      var leftIndex = 0;
      var lineXLeft = xLeft;
      var lineXRight = xRight;
      var rightIndex = tokenCount - 1;
      var token = void 0;
      while (leftIndex < tokenCount && (token = tokens[leftIndex], !token.align || token.align === "left")) {
        this._placeToken(token, style2, lineHeight, lineTop, lineXLeft, "left", bgColorDrawn);
        remainedWidth -= token.width;
        lineXLeft += token.width;
        leftIndex++;
      }
      while (rightIndex >= 0 && (token = tokens[rightIndex], token.align === "right")) {
        this._placeToken(token, style2, lineHeight, lineTop, lineXRight, "right", bgColorDrawn);
        remainedWidth -= token.width;
        lineXRight -= token.width;
        rightIndex--;
      }
      lineXLeft += (contentWidth - (lineXLeft - xLeft) - (xRight - lineXRight) - remainedWidth) / 2;
      while (leftIndex <= rightIndex) {
        token = tokens[leftIndex];
        this._placeToken(token, style2, lineHeight, lineTop, lineXLeft + token.width / 2, "center", bgColorDrawn);
        lineXLeft += token.width;
        leftIndex++;
      }
      lineTop += lineHeight;
    }
  };
  ZRText2.prototype._placeToken = function(token, style2, lineHeight, lineTop, x2, textAlign, parentBgColorDrawn) {
    var tokenStyle = style2.rich[token.styleName] || {};
    tokenStyle.text = token.text;
    var verticalAlign = token.verticalAlign;
    var y2 = lineTop + lineHeight / 2;
    if (verticalAlign === "top") {
      y2 = lineTop + token.height / 2;
    } else if (verticalAlign === "bottom") {
      y2 = lineTop + lineHeight - token.height / 2;
    }
    var needDrawBg = !token.isLineHolder && needDrawBackground(tokenStyle);
    needDrawBg && this._renderBackground(tokenStyle, style2, textAlign === "right" ? x2 - token.width : textAlign === "center" ? x2 - token.width / 2 : x2, y2 - token.height / 2, token.width, token.height);
    var bgColorDrawn = !!tokenStyle.backgroundColor;
    var textPadding = token.textPadding;
    if (textPadding) {
      x2 = getTextXForPadding(x2, textAlign, textPadding);
      y2 -= token.height / 2 - textPadding[0] - token.innerHeight / 2;
    }
    var el = this._getOrCreateChild(TSpan$1);
    var subElStyle = el.createStyle();
    el.useStyle(subElStyle);
    var defaultStyle = this._defaultStyle;
    var useDefaultFill = false;
    var defaultLineWidth = 0;
    var textFill = getFill("fill" in tokenStyle ? tokenStyle.fill : "fill" in style2 ? style2.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in tokenStyle ? tokenStyle.stroke : "stroke" in style2 ? style2.stroke : !bgColorDrawn && !parentBgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = tokenStyle.textShadowBlur > 0 || style2.textShadowBlur > 0;
    subElStyle.text = token.text;
    subElStyle.x = x2;
    subElStyle.y = y2;
    if (hasShadow2) {
      subElStyle.shadowBlur = tokenStyle.textShadowBlur || style2.textShadowBlur || 0;
      subElStyle.shadowColor = tokenStyle.textShadowColor || style2.textShadowColor || "transparent";
      subElStyle.shadowOffsetX = tokenStyle.textShadowOffsetX || style2.textShadowOffsetX || 0;
      subElStyle.shadowOffsetY = tokenStyle.textShadowOffsetY || style2.textShadowOffsetY || 0;
    }
    subElStyle.textAlign = textAlign;
    subElStyle.textBaseline = "middle";
    subElStyle.font = token.font || DEFAULT_FONT;
    subElStyle.opacity = retrieve3(tokenStyle.opacity, style2.opacity, 1);
    setSeparateFont(subElStyle, tokenStyle);
    if (textStroke) {
      subElStyle.lineWidth = retrieve3(tokenStyle.lineWidth, style2.lineWidth, defaultLineWidth);
      subElStyle.lineDash = retrieve2(tokenStyle.lineDash, style2.lineDash);
      subElStyle.lineDashOffset = style2.lineDashOffset || 0;
      subElStyle.stroke = textStroke;
    }
    if (textFill) {
      subElStyle.fill = textFill;
    }
    var textWidth = token.contentWidth;
    var textHeight = token.contentHeight;
    el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, textWidth, subElStyle.textAlign), adjustTextY(subElStyle.y, textHeight, subElStyle.textBaseline), textWidth, textHeight));
  };
  ZRText2.prototype._renderBackground = function(style2, topStyle, x2, y2, width, height) {
    var textBackgroundColor = style2.backgroundColor;
    var textBorderWidth = style2.borderWidth;
    var textBorderColor = style2.borderColor;
    var isImageBg = textBackgroundColor && textBackgroundColor.image;
    var isPlainOrGradientBg = textBackgroundColor && !isImageBg;
    var textBorderRadius = style2.borderRadius;
    var self2 = this;
    var rectEl;
    var imgEl;
    if (isPlainOrGradientBg || style2.lineHeight || textBorderWidth && textBorderColor) {
      rectEl = this._getOrCreateChild(Rect$3);
      rectEl.useStyle(rectEl.createStyle());
      rectEl.style.fill = null;
      var rectShape = rectEl.shape;
      rectShape.x = x2;
      rectShape.y = y2;
      rectShape.width = width;
      rectShape.height = height;
      rectShape.r = textBorderRadius;
      rectEl.dirtyShape();
    }
    if (isPlainOrGradientBg) {
      var rectStyle = rectEl.style;
      rectStyle.fill = textBackgroundColor || null;
      rectStyle.fillOpacity = retrieve2(style2.fillOpacity, 1);
    } else if (isImageBg) {
      imgEl = this._getOrCreateChild(ZRImage$1);
      imgEl.onload = function() {
        self2.dirtyStyle();
      };
      var imgStyle = imgEl.style;
      imgStyle.image = textBackgroundColor.image;
      imgStyle.x = x2;
      imgStyle.y = y2;
      imgStyle.width = width;
      imgStyle.height = height;
    }
    if (textBorderWidth && textBorderColor) {
      var rectStyle = rectEl.style;
      rectStyle.lineWidth = textBorderWidth;
      rectStyle.stroke = textBorderColor;
      rectStyle.strokeOpacity = retrieve2(style2.strokeOpacity, 1);
      rectStyle.lineDash = style2.borderDash;
      rectStyle.lineDashOffset = style2.borderDashOffset || 0;
      rectEl.strokeContainThreshold = 0;
      if (rectEl.hasFill() && rectEl.hasStroke()) {
        rectStyle.strokeFirst = true;
        rectStyle.lineWidth *= 2;
      }
    }
    var commonStyle = (rectEl || imgEl).style;
    commonStyle.shadowBlur = style2.shadowBlur || 0;
    commonStyle.shadowColor = style2.shadowColor || "transparent";
    commonStyle.shadowOffsetX = style2.shadowOffsetX || 0;
    commonStyle.shadowOffsetY = style2.shadowOffsetY || 0;
    commonStyle.opacity = retrieve3(style2.opacity, topStyle.opacity, 1);
  };
  ZRText2.makeFont = function(style2) {
    var font = "";
    if (hasSeparateFont(style2)) {
      font = [
        style2.fontStyle,
        style2.fontWeight,
        parseFontSize(style2.fontSize),
        style2.fontFamily || "sans-serif"
      ].join(" ");
    }
    return font && trim$1(font) || style2.textFont || style2.font;
  };
  return ZRText2;
}(Displayable$1);
var VALID_TEXT_ALIGN = { left: true, right: 1, center: 1 };
var VALID_TEXT_VERTICAL_ALIGN = { top: 1, bottom: 1, middle: 1 };
var FONT_PARTS = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
function parseFontSize(fontSize) {
  if (typeof fontSize === "string" && (fontSize.indexOf("px") !== -1 || fontSize.indexOf("rem") !== -1 || fontSize.indexOf("em") !== -1)) {
    return fontSize;
  } else if (!isNaN(+fontSize)) {
    return fontSize + "px";
  } else {
    return DEFAULT_FONT_SIZE + "px";
  }
}
function setSeparateFont(targetStyle, sourceStyle) {
  for (var i = 0; i < FONT_PARTS.length; i++) {
    var fontProp = FONT_PARTS[i];
    var val = sourceStyle[fontProp];
    if (val != null) {
      targetStyle[fontProp] = val;
    }
  }
}
function hasSeparateFont(style2) {
  return style2.fontSize != null || style2.fontFamily || style2.fontWeight;
}
function normalizeTextStyle(style2) {
  normalizeStyle(style2);
  each$g(style2.rich, normalizeStyle);
  return style2;
}
function normalizeStyle(style2) {
  if (style2) {
    style2.font = ZRText.makeFont(style2);
    var textAlign = style2.align;
    textAlign === "middle" && (textAlign = "center");
    style2.align = textAlign == null || VALID_TEXT_ALIGN[textAlign] ? textAlign : "left";
    var verticalAlign = style2.verticalAlign;
    verticalAlign === "center" && (verticalAlign = "middle");
    style2.verticalAlign = verticalAlign == null || VALID_TEXT_VERTICAL_ALIGN[verticalAlign] ? verticalAlign : "top";
    var textPadding = style2.padding;
    if (textPadding) {
      style2.padding = normalizeCssArray$1(style2.padding);
    }
  }
}
function getStroke(stroke, lineWidth) {
  return stroke == null || lineWidth <= 0 || stroke === "transparent" || stroke === "none" ? null : stroke.image || stroke.colorStops ? "#000" : stroke;
}
function getFill(fill) {
  return fill == null || fill === "none" ? null : fill.image || fill.colorStops ? "#000" : fill;
}
function getTextXForPadding(x2, textAlign, textPadding) {
  return textAlign === "right" ? x2 - textPadding[1] : textAlign === "center" ? x2 + textPadding[3] / 2 - textPadding[1] / 2 : x2 + textPadding[3];
}
function getStyleText(style2) {
  var text = style2.text;
  text != null && (text += "");
  return text;
}
function needDrawBackground(style2) {
  return !!(style2.backgroundColor || style2.lineHeight || style2.borderWidth && style2.borderColor);
}
var ZRText$1 = ZRText;
var getECData = makeInner();
var setCommonECData = function(seriesIndex, dataType, dataIdx, el) {
  if (el) {
    var ecData = getECData(el);
    ecData.dataIndex = dataIdx;
    ecData.dataType = dataType;
    ecData.seriesIndex = seriesIndex;
    if (el.type === "group") {
      el.traverse(function(child) {
        var childECData = getECData(child);
        childECData.seriesIndex = seriesIndex;
        childECData.dataIndex = dataIdx;
        childECData.dataType = dataType;
      });
    }
  }
};
var _highlightNextDigit = 1;
var _highlightKeyMap = {};
var getSavedStates = makeInner();
var getComponentStates = makeInner();
var HOVER_STATE_NORMAL = 0;
var HOVER_STATE_BLUR = 1;
var HOVER_STATE_EMPHASIS = 2;
var SPECIAL_STATES = ["emphasis", "blur", "select"];
var DISPLAY_STATES = ["normal", "emphasis", "blur", "select"];
var Z2_EMPHASIS_LIFT = 10;
var Z2_SELECT_LIFT = 9;
var HIGHLIGHT_ACTION_TYPE = "highlight";
var DOWNPLAY_ACTION_TYPE = "downplay";
var SELECT_ACTION_TYPE = "select";
var UNSELECT_ACTION_TYPE = "unselect";
var TOGGLE_SELECT_ACTION_TYPE = "toggleSelect";
function hasFillOrStroke(fillOrStroke) {
  return fillOrStroke != null && fillOrStroke !== "none";
}
var liftedColorCache = new LRU$1(100);
function liftColor(color) {
  if (isString$1(color)) {
    var liftedColor = liftedColorCache.get(color);
    if (!liftedColor) {
      liftedColor = lift(color, -0.1);
      liftedColorCache.put(color, liftedColor);
    }
    return liftedColor;
  } else if (isGradientObject(color)) {
    var ret = extend({}, color);
    ret.colorStops = map$1(color.colorStops, function(stop2) {
      return {
        offset: stop2.offset,
        color: lift(stop2.color, -0.1)
      };
    });
    return ret;
  }
  return color;
}
function doChangeHoverState(el, stateName, hoverStateEnum) {
  if (el.onHoverStateChange && (el.hoverState || 0) !== hoverStateEnum) {
    el.onHoverStateChange(stateName);
  }
  el.hoverState = hoverStateEnum;
}
function singleEnterEmphasis(el) {
  doChangeHoverState(el, "emphasis", HOVER_STATE_EMPHASIS);
}
function singleLeaveEmphasis(el) {
  if (el.hoverState === HOVER_STATE_EMPHASIS) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterBlur(el) {
  doChangeHoverState(el, "blur", HOVER_STATE_BLUR);
}
function singleLeaveBlur(el) {
  if (el.hoverState === HOVER_STATE_BLUR) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterSelect(el) {
  el.selected = true;
}
function singleLeaveSelect(el) {
  el.selected = false;
}
function updateElementState(el, updater, commonParam) {
  updater(el, commonParam);
}
function traverseUpdateState(el, updater, commonParam) {
  updateElementState(el, updater, commonParam);
  el.isGroup && el.traverse(function(child) {
    updateElementState(child, updater, commonParam);
  });
}
function setStatesFlag(el, stateName) {
  switch (stateName) {
    case "emphasis":
      el.hoverState = HOVER_STATE_EMPHASIS;
      break;
    case "normal":
      el.hoverState = HOVER_STATE_NORMAL;
      break;
    case "blur":
      el.hoverState = HOVER_STATE_BLUR;
      break;
    case "select":
      el.selected = true;
  }
}
function getFromStateStyle(el, props, toStateName, defaultValue) {
  var style2 = el.style;
  var fromState = {};
  for (var i = 0; i < props.length; i++) {
    var propName = props[i];
    var val = style2[propName];
    fromState[propName] = val == null ? defaultValue && defaultValue[propName] : val;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.__fromStateTransition && animator.__fromStateTransition.indexOf(toStateName) < 0 && animator.targetName === "style") {
      animator.saveTo(fromState, props);
    }
  }
  return fromState;
}
function createEmphasisDefaultState(el, stateName, targetStates, state) {
  var hasSelect = targetStates && indexOf(targetStates, "select") >= 0;
  var cloned = false;
  if (el instanceof Path$1) {
    var store = getSavedStates(el);
    var fromFill = hasSelect ? store.selectFill || store.normalFill : store.normalFill;
    var fromStroke = hasSelect ? store.selectStroke || store.normalStroke : store.normalStroke;
    if (hasFillOrStroke(fromFill) || hasFillOrStroke(fromStroke)) {
      state = state || {};
      var emphasisStyle = state.style || {};
      if (emphasisStyle.fill === "inherit") {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = fromFill;
      } else if (!hasFillOrStroke(emphasisStyle.fill) && hasFillOrStroke(fromFill)) {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = liftColor(fromFill);
      } else if (!hasFillOrStroke(emphasisStyle.stroke) && hasFillOrStroke(fromStroke)) {
        if (!cloned) {
          state = extend({}, state);
          emphasisStyle = extend({}, emphasisStyle);
        }
        emphasisStyle.stroke = liftColor(fromStroke);
      }
      state.style = emphasisStyle;
    }
  }
  if (state) {
    if (state.z2 == null) {
      if (!cloned) {
        state = extend({}, state);
      }
      var z2EmphasisLift = el.z2EmphasisLift;
      state.z2 = el.z2 + (z2EmphasisLift != null ? z2EmphasisLift : Z2_EMPHASIS_LIFT);
    }
  }
  return state;
}
function createSelectDefaultState(el, stateName, state) {
  if (state) {
    if (state.z2 == null) {
      state = extend({}, state);
      var z2SelectLift = el.z2SelectLift;
      state.z2 = el.z2 + (z2SelectLift != null ? z2SelectLift : Z2_SELECT_LIFT);
    }
  }
  return state;
}
function createBlurDefaultState(el, stateName, state) {
  var hasBlur = indexOf(el.currentStates, stateName) >= 0;
  var currentOpacity = el.style.opacity;
  var fromState = !hasBlur ? getFromStateStyle(el, ["opacity"], stateName, {
    opacity: 1
  }) : null;
  state = state || {};
  var blurStyle = state.style || {};
  if (blurStyle.opacity == null) {
    state = extend({}, state);
    blurStyle = extend({
      opacity: hasBlur ? currentOpacity : fromState.opacity * 0.1
    }, blurStyle);
    state.style = blurStyle;
  }
  return state;
}
function elementStateProxy(stateName, targetStates) {
  var state = this.states[stateName];
  if (this.style) {
    if (stateName === "emphasis") {
      return createEmphasisDefaultState(this, stateName, targetStates, state);
    } else if (stateName === "blur") {
      return createBlurDefaultState(this, stateName, state);
    } else if (stateName === "select") {
      return createSelectDefaultState(this, stateName, state);
    }
  }
  return state;
}
function setDefaultStateProxy(el) {
  el.stateProxy = elementStateProxy;
  var textContent = el.getTextContent();
  var textGuide = el.getTextGuideLine();
  if (textContent) {
    textContent.stateProxy = elementStateProxy;
  }
  if (textGuide) {
    textGuide.stateProxy = elementStateProxy;
  }
}
function enterEmphasisWhenMouseOver(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasisWhenMouseOut(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterEmphasis(el, highlightDigit) {
  el.__highByOuter |= 1 << (highlightDigit || 0);
  traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasis(el, highlightDigit) {
  !(el.__highByOuter &= ~(1 << (highlightDigit || 0))) && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterBlur(el) {
  traverseUpdateState(el, singleEnterBlur);
}
function leaveBlur(el) {
  traverseUpdateState(el, singleLeaveBlur);
}
function enterSelect(el) {
  traverseUpdateState(el, singleEnterSelect);
}
function leaveSelect(el) {
  traverseUpdateState(el, singleLeaveSelect);
}
function shouldSilent(el, e2) {
  return el.__highDownSilentOnTouch && e2.zrByTouch;
}
function allLeaveBlur(api) {
  var model = api.getModel();
  model.eachComponent(function(componentType, componentModel) {
    var componentStates = getComponentStates(componentModel);
    if (componentStates.isBlured) {
      var view = componentType === "series" ? api.getViewOfSeriesModel(componentModel) : api.getViewOfComponentModel(componentModel);
      view.group.traverse(function(child) {
        singleLeaveBlur(child);
      });
    }
    componentStates.isBlured = false;
  });
}
function blurSeries(targetSeriesIndex, focus, blurScope, api) {
  var ecModel = api.getModel();
  blurScope = blurScope || "coordinateSystem";
  function leaveBlurOfIndices(data2, dataIndices) {
    for (var i = 0; i < dataIndices.length; i++) {
      var itemEl = data2.getItemGraphicEl(dataIndices[i]);
      itemEl && leaveBlur(itemEl);
    }
  }
  if (targetSeriesIndex == null) {
    return;
  }
  if (!focus || focus === "none") {
    return;
  }
  var targetSeriesModel = ecModel.getSeriesByIndex(targetSeriesIndex);
  var targetCoordSys = targetSeriesModel.coordinateSystem;
  if (targetCoordSys && targetCoordSys.master) {
    targetCoordSys = targetCoordSys.master;
  }
  var blurredSeries = [];
  ecModel.eachSeries(function(seriesModel) {
    var sameSeries = targetSeriesModel === seriesModel;
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.master) {
      coordSys = coordSys.master;
    }
    var sameCoordSys = coordSys && targetCoordSys ? coordSys === targetCoordSys : sameSeries;
    if (!(blurScope === "series" && !sameSeries || blurScope === "coordinateSystem" && !sameCoordSys || focus === "series" && sameSeries)) {
      var view = api.getViewOfSeriesModel(seriesModel);
      view.group.traverse(function(child) {
        singleEnterBlur(child);
      });
      if (isArrayLike(focus)) {
        leaveBlurOfIndices(seriesModel.getData(), focus);
      } else if (isObject$6(focus)) {
        var dataTypes = keys(focus);
        for (var d2 = 0; d2 < dataTypes.length; d2++) {
          leaveBlurOfIndices(seriesModel.getData(dataTypes[d2]), focus[dataTypes[d2]]);
        }
      }
      blurredSeries.push(seriesModel);
      getComponentStates(seriesModel).isBlured = true;
    }
  });
  ecModel.eachComponent(function(componentType, componentModel) {
    if (componentType === "series") {
      return;
    }
    var view = api.getViewOfComponentModel(componentModel);
    if (view && view.blurSeries) {
      view.blurSeries(blurredSeries, ecModel);
    }
  });
}
function blurComponent(componentMainType, componentIndex, api) {
  if (componentMainType == null || componentIndex == null) {
    return;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return;
  }
  getComponentStates(componentModel).isBlured = true;
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.focusBlurEnabled) {
    return;
  }
  view.group.traverse(function(child) {
    singleEnterBlur(child);
  });
}
function blurSeriesFromHighlightPayload(seriesModel, payload, api) {
  var seriesIndex = seriesModel.seriesIndex;
  var data2 = seriesModel.getData(payload.dataType);
  if (!data2) {
    return;
  }
  var dataIndex = queryDataIndex(data2, payload);
  dataIndex = (isArray$2(dataIndex) ? dataIndex[0] : dataIndex) || 0;
  var el = data2.getItemGraphicEl(dataIndex);
  if (!el) {
    var count2 = data2.count();
    var current2 = 0;
    while (!el && current2 < count2) {
      el = data2.getItemGraphicEl(current2++);
    }
  }
  if (el) {
    var ecData = getECData(el);
    blurSeries(seriesIndex, ecData.focus, ecData.blurScope, api);
  } else {
    var focus_1 = seriesModel.get(["emphasis", "focus"]);
    var blurScope = seriesModel.get(["emphasis", "blurScope"]);
    if (focus_1 != null) {
      blurSeries(seriesIndex, focus_1, blurScope, api);
    }
  }
}
function findComponentHighDownDispatchers(componentMainType, componentIndex, name2, api) {
  var ret = {
    focusSelf: false,
    dispatchers: null
  };
  if (componentMainType == null || componentMainType === "series" || componentIndex == null || name2 == null) {
    return ret;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return ret;
  }
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.findHighDownDispatchers) {
    return ret;
  }
  var dispatchers = view.findHighDownDispatchers(name2);
  var focusSelf;
  for (var i = 0; i < dispatchers.length; i++) {
    if (getECData(dispatchers[i]).focus === "self") {
      focusSelf = true;
      break;
    }
  }
  return {
    focusSelf,
    dispatchers
  };
}
function handleGlobalMouseOverForHighDown(dispatcher, e2, api) {
  var ecData = getECData(dispatcher);
  var _a2 = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api), dispatchers = _a2.dispatchers, focusSelf = _a2.focusSelf;
  if (dispatchers) {
    if (focusSelf) {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    each$g(dispatchers, function(dispatcher2) {
      return enterEmphasisWhenMouseOver(dispatcher2, e2);
    });
  } else {
    blurSeries(ecData.seriesIndex, ecData.focus, ecData.blurScope, api);
    if (ecData.focus === "self") {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    enterEmphasisWhenMouseOver(dispatcher, e2);
  }
}
function handleGlobalMouseOutForHighDown(dispatcher, e2, api) {
  allLeaveBlur(api);
  var ecData = getECData(dispatcher);
  var dispatchers = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api).dispatchers;
  if (dispatchers) {
    each$g(dispatchers, function(dispatcher2) {
      return leaveEmphasisWhenMouseOut(dispatcher2, e2);
    });
  } else {
    leaveEmphasisWhenMouseOut(dispatcher, e2);
  }
}
function toggleSelectionFromPayload(seriesModel, payload, api) {
  if (!isSelectChangePayload(payload)) {
    return;
  }
  var dataType = payload.dataType;
  var data2 = seriesModel.getData(dataType);
  var dataIndex = queryDataIndex(data2, payload);
  if (!isArray$2(dataIndex)) {
    dataIndex = [dataIndex];
  }
  seriesModel[payload.type === TOGGLE_SELECT_ACTION_TYPE ? "toggleSelect" : payload.type === SELECT_ACTION_TYPE ? "select" : "unselect"](dataIndex, dataType);
}
function updateSeriesElementSelection(seriesModel) {
  var allData = seriesModel.getAllData();
  each$g(allData, function(_a2) {
    var data2 = _a2.data, type4 = _a2.type;
    data2.eachItemGraphicEl(function(el, idx) {
      seriesModel.isSelected(idx, type4) ? enterSelect(el) : leaveSelect(el);
    });
  });
}
function getAllSelectedIndices(ecModel) {
  var ret = [];
  ecModel.eachSeries(function(seriesModel) {
    var allData = seriesModel.getAllData();
    each$g(allData, function(_a2) {
      _a2.data;
      var type4 = _a2.type;
      var dataIndices = seriesModel.getSelectedDataIndices();
      if (dataIndices.length > 0) {
        var item = {
          dataIndex: dataIndices,
          seriesIndex: seriesModel.seriesIndex
        };
        if (type4 != null) {
          item.dataType = type4;
        }
        ret.push(item);
      }
    });
  });
  return ret;
}
function enableHoverEmphasis(el, focus, blurScope) {
  setAsHighDownDispatcher(el, true);
  traverseUpdateState(el, setDefaultStateProxy);
  enableHoverFocus(el, focus, blurScope);
}
function disableHoverEmphasis(el) {
  setAsHighDownDispatcher(el, false);
}
function toggleHoverEmphasis(el, focus, blurScope, isDisabled) {
  isDisabled ? disableHoverEmphasis(el) : enableHoverEmphasis(el, focus, blurScope);
}
function enableHoverFocus(el, focus, blurScope) {
  var ecData = getECData(el);
  if (focus != null) {
    ecData.focus = focus;
    ecData.blurScope = blurScope;
  } else if (ecData.focus) {
    ecData.focus = null;
  }
}
var OTHER_STATES = ["emphasis", "blur", "select"];
var defaultStyleGetterMap = {
  itemStyle: "getItemStyle",
  lineStyle: "getLineStyle",
  areaStyle: "getAreaStyle"
};
function setStatesStylesFromModel(el, itemModel, styleType, getter) {
  styleType = styleType || "itemStyle";
  for (var i = 0; i < OTHER_STATES.length; i++) {
    var stateName = OTHER_STATES[i];
    var model = itemModel.getModel([stateName, styleType]);
    var state = el.ensureState(stateName);
    state.style = getter ? getter(model) : model[defaultStyleGetterMap[styleType]]();
  }
}
function setAsHighDownDispatcher(el, asDispatcher) {
  var disable = asDispatcher === false;
  var extendedEl = el;
  if (el.highDownSilentOnTouch) {
    extendedEl.__highDownSilentOnTouch = el.highDownSilentOnTouch;
  }
  if (!disable || extendedEl.__highDownDispatcher) {
    extendedEl.__highByOuter = extendedEl.__highByOuter || 0;
    extendedEl.__highDownDispatcher = !disable;
  }
}
function isHighDownDispatcher(el) {
  return !!(el && el.__highDownDispatcher);
}
function enableComponentHighDownFeatures(el, componentModel, componentHighDownName) {
  var ecData = getECData(el);
  ecData.componentMainType = componentModel.mainType;
  ecData.componentIndex = componentModel.componentIndex;
  ecData.componentHighDownName = componentHighDownName;
}
function getHighlightDigit(highlightKey) {
  var highlightDigit = _highlightKeyMap[highlightKey];
  if (highlightDigit == null && _highlightNextDigit <= 32) {
    highlightDigit = _highlightKeyMap[highlightKey] = _highlightNextDigit++;
  }
  return highlightDigit;
}
function isSelectChangePayload(payload) {
  var payloadType = payload.type;
  return payloadType === SELECT_ACTION_TYPE || payloadType === UNSELECT_ACTION_TYPE || payloadType === TOGGLE_SELECT_ACTION_TYPE;
}
function isHighDownPayload(payload) {
  var payloadType = payload.type;
  return payloadType === HIGHLIGHT_ACTION_TYPE || payloadType === DOWNPLAY_ACTION_TYPE;
}
function savePathStates(el) {
  var store = getSavedStates(el);
  store.normalFill = el.style.fill;
  store.normalStroke = el.style.stroke;
  var selectState = el.states.select || {};
  store.selectFill = selectState.style && selectState.style.fill || null;
  store.selectStroke = selectState.style && selectState.style.stroke || null;
}
var CMD$2 = PathProxy$1.CMD;
var points$2 = [[], [], []];
var mathSqrt$2 = Math.sqrt;
var mathAtan2 = Math.atan2;
function transformPath(path, m2) {
  if (!m2) {
    return;
  }
  var data2 = path.data;
  var len2 = path.len();
  var cmd;
  var nPoint;
  var i;
  var j;
  var k2;
  var p2;
  var M2 = CMD$2.M;
  var C = CMD$2.C;
  var L = CMD$2.L;
  var R2 = CMD$2.R;
  var A2 = CMD$2.A;
  var Q = CMD$2.Q;
  for (i = 0, j = 0; i < len2; ) {
    cmd = data2[i++];
    j = i;
    nPoint = 0;
    switch (cmd) {
      case M2:
        nPoint = 1;
        break;
      case L:
        nPoint = 1;
        break;
      case C:
        nPoint = 3;
        break;
      case Q:
        nPoint = 2;
        break;
      case A2:
        var x2 = m2[4];
        var y2 = m2[5];
        var sx = mathSqrt$2(m2[0] * m2[0] + m2[1] * m2[1]);
        var sy = mathSqrt$2(m2[2] * m2[2] + m2[3] * m2[3]);
        var angle = mathAtan2(-m2[1] / sy, m2[0] / sx);
        data2[i] *= sx;
        data2[i++] += x2;
        data2[i] *= sy;
        data2[i++] += y2;
        data2[i++] *= sx;
        data2[i++] *= sy;
        data2[i++] += angle;
        data2[i++] += angle;
        i += 2;
        j = i;
        break;
      case R2:
        p2[0] = data2[i++];
        p2[1] = data2[i++];
        applyTransform$1(p2, p2, m2);
        data2[j++] = p2[0];
        data2[j++] = p2[1];
        p2[0] += data2[i++];
        p2[1] += data2[i++];
        applyTransform$1(p2, p2, m2);
        data2[j++] = p2[0];
        data2[j++] = p2[1];
    }
    for (k2 = 0; k2 < nPoint; k2++) {
      var p_1 = points$2[k2];
      p_1[0] = data2[i++];
      p_1[1] = data2[i++];
      applyTransform$1(p_1, p_1, m2);
      data2[j++] = p_1[0];
      data2[j++] = p_1[1];
    }
  }
  path.increaseVersion();
}
var mathSqrt$1 = Math.sqrt;
var mathSin$2 = Math.sin;
var mathCos$2 = Math.cos;
var PI$7 = Math.PI;
function vMag(v4) {
  return Math.sqrt(v4[0] * v4[0] + v4[1] * v4[1]);
}
function vRatio(u, v4) {
  return (u[0] * v4[0] + u[1] * v4[1]) / (vMag(u) * vMag(v4));
}
function vAngle(u, v4) {
  return (u[0] * v4[1] < u[1] * v4[0] ? -1 : 1) * Math.acos(vRatio(u, v4));
}
function processArc(x1, y1, x2, y2, fa2, fs, rx, ry, psiDeg, cmd, path) {
  var psi = psiDeg * (PI$7 / 180);
  var xp = mathCos$2(psi) * (x1 - x2) / 2 + mathSin$2(psi) * (y1 - y2) / 2;
  var yp = -1 * mathSin$2(psi) * (x1 - x2) / 2 + mathCos$2(psi) * (y1 - y2) / 2;
  var lambda = xp * xp / (rx * rx) + yp * yp / (ry * ry);
  if (lambda > 1) {
    rx *= mathSqrt$1(lambda);
    ry *= mathSqrt$1(lambda);
  }
  var f2 = (fa2 === fs ? -1 : 1) * mathSqrt$1((rx * rx * (ry * ry) - rx * rx * (yp * yp) - ry * ry * (xp * xp)) / (rx * rx * (yp * yp) + ry * ry * (xp * xp))) || 0;
  var cxp = f2 * rx * yp / ry;
  var cyp = f2 * -ry * xp / rx;
  var cx = (x1 + x2) / 2 + mathCos$2(psi) * cxp - mathSin$2(psi) * cyp;
  var cy = (y1 + y2) / 2 + mathSin$2(psi) * cxp + mathCos$2(psi) * cyp;
  var theta = vAngle([1, 0], [(xp - cxp) / rx, (yp - cyp) / ry]);
  var u = [(xp - cxp) / rx, (yp - cyp) / ry];
  var v4 = [(-1 * xp - cxp) / rx, (-1 * yp - cyp) / ry];
  var dTheta = vAngle(u, v4);
  if (vRatio(u, v4) <= -1) {
    dTheta = PI$7;
  }
  if (vRatio(u, v4) >= 1) {
    dTheta = 0;
  }
  if (dTheta < 0) {
    var n2 = Math.round(dTheta / PI$7 * 1e6) / 1e6;
    dTheta = PI$7 * 2 + n2 % 2 * PI$7;
  }
  path.addData(cmd, cx, cy, rx, ry, theta, dTheta, psi, fs);
}
var commandReg = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig;
var numberReg$1 = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function createPathProxyFromString(data2) {
  var path = new PathProxy$1();
  if (!data2) {
    return path;
  }
  var cpx = 0;
  var cpy = 0;
  var subpathX = cpx;
  var subpathY = cpy;
  var prevCmd;
  var CMD2 = PathProxy$1.CMD;
  var cmdList = data2.match(commandReg);
  if (!cmdList) {
    return path;
  }
  for (var l2 = 0; l2 < cmdList.length; l2++) {
    var cmdText = cmdList[l2];
    var cmdStr = cmdText.charAt(0);
    var cmd = void 0;
    var p2 = cmdText.match(numberReg$1) || [];
    var pLen = p2.length;
    for (var i = 0; i < pLen; i++) {
      p2[i] = parseFloat(p2[i]);
    }
    var off = 0;
    while (off < pLen) {
      var ctlPtx = void 0;
      var ctlPty = void 0;
      var rx = void 0;
      var ry = void 0;
      var psi = void 0;
      var fa2 = void 0;
      var fs = void 0;
      var x1 = cpx;
      var y1 = cpy;
      var len2 = void 0;
      var pathData = void 0;
      switch (cmdStr) {
        case "l":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "L":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "m":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "l";
          break;
        case "M":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "L";
          break;
        case "h":
          cpx += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "H":
          cpx = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "v":
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "V":
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "C":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++], p2[off++], p2[off++], p2[off++], p2[off++], p2[off++]);
          cpx = p2[off - 2];
          cpy = p2[off - 1];
          break;
        case "c":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy);
          cpx += p2[off - 2];
          cpy += p2[off - 1];
          break;
        case "S":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "s":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = cpx + p2[off++];
          y1 = cpy + p2[off++];
          cpx += p2[off++];
          cpy += p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "Q":
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "q":
          x1 = p2[off++] + cpx;
          y1 = p2[off++] + cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "T":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "t":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "A":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa2 = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa2, fs, rx, ry, psi, cmd, path);
          break;
        case "a":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa2 = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa2, fs, rx, ry, psi, cmd, path);
          break;
      }
    }
    if (cmdStr === "z" || cmdStr === "Z") {
      cmd = CMD2.Z;
      path.addData(cmd);
      cpx = subpathX;
      cpy = subpathY;
    }
    prevCmd = cmd;
  }
  path.toStatic();
  return path;
}
var SVGPath = function(_super) {
  __extends(SVGPath2, _super);
  function SVGPath2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SVGPath2.prototype.applyTransform = function(m2) {
  };
  return SVGPath2;
}(Path$1);
function isPathProxy(path) {
  return path.setData != null;
}
function createPathOptions(str, opts) {
  var pathProxy = createPathProxyFromString(str);
  var innerOpts = extend({}, opts);
  innerOpts.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.setData(pathProxy.data);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    } else {
      var ctx = path;
      pathProxy.rebuildPath(ctx, 1);
    }
  };
  innerOpts.applyTransform = function(m2) {
    transformPath(pathProxy, m2);
    this.dirtyShape();
  };
  return innerOpts;
}
function createFromString(str, opts) {
  return new SVGPath(createPathOptions(str, opts));
}
function extendFromString(str, defaultOpts) {
  var innerOpts = createPathOptions(str, defaultOpts);
  var Sub = function(_super) {
    __extends(Sub2, _super);
    function Sub2(opts) {
      var _this = _super.call(this, opts) || this;
      _this.applyTransform = innerOpts.applyTransform;
      _this.buildPath = innerOpts.buildPath;
      return _this;
    }
    return Sub2;
  }(SVGPath);
  return Sub;
}
function mergePath$1(pathEls, opts) {
  var pathList = [];
  var len2 = pathEls.length;
  for (var i = 0; i < len2; i++) {
    var pathEl = pathEls[i];
    pathList.push(pathEl.getUpdatedPathProxy(true));
  }
  var pathBundle = new Path$1(opts);
  pathBundle.createPathProxy();
  pathBundle.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.appendPath(pathList);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    }
  };
  return pathBundle;
}
function clonePath(sourcePath, opts) {
  opts = opts || {};
  var path = new Path$1();
  if (sourcePath.shape) {
    path.setShape(sourcePath.shape);
  }
  path.setStyle(sourcePath.style);
  if (opts.bakeTransform) {
    transformPath(path.path, sourcePath.getComputedTransform());
  } else {
    if (opts.toLocal) {
      path.setLocalTransform(sourcePath.getComputedTransform());
    } else {
      path.copyTransform(sourcePath);
    }
  }
  path.buildPath = sourcePath.buildPath;
  path.applyTransform = path.applyTransform;
  path.z = sourcePath.z;
  path.z2 = sourcePath.z2;
  path.zlevel = sourcePath.zlevel;
  return path;
}
var CircleShape = function() {
  function CircleShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
  }
  return CircleShape2;
}();
var Circle = function(_super) {
  __extends(Circle2, _super);
  function Circle2(opts) {
    return _super.call(this, opts) || this;
  }
  Circle2.prototype.getDefaultShape = function() {
    return new CircleShape();
  };
  Circle2.prototype.buildPath = function(ctx, shape) {
    ctx.moveTo(shape.cx + shape.r, shape.cy);
    ctx.arc(shape.cx, shape.cy, shape.r, 0, Math.PI * 2);
  };
  return Circle2;
}(Path$1);
Circle.prototype.type = "circle";
var Circle$1 = Circle;
var EllipseShape = function() {
  function EllipseShape2() {
    this.cx = 0;
    this.cy = 0;
    this.rx = 0;
    this.ry = 0;
  }
  return EllipseShape2;
}();
var Ellipse = function(_super) {
  __extends(Ellipse2, _super);
  function Ellipse2(opts) {
    return _super.call(this, opts) || this;
  }
  Ellipse2.prototype.getDefaultShape = function() {
    return new EllipseShape();
  };
  Ellipse2.prototype.buildPath = function(ctx, shape) {
    var k2 = 0.5522848;
    var x2 = shape.cx;
    var y2 = shape.cy;
    var a = shape.rx;
    var b2 = shape.ry;
    var ox = a * k2;
    var oy = b2 * k2;
    ctx.moveTo(x2 - a, y2);
    ctx.bezierCurveTo(x2 - a, y2 - oy, x2 - ox, y2 - b2, x2, y2 - b2);
    ctx.bezierCurveTo(x2 + ox, y2 - b2, x2 + a, y2 - oy, x2 + a, y2);
    ctx.bezierCurveTo(x2 + a, y2 + oy, x2 + ox, y2 + b2, x2, y2 + b2);
    ctx.bezierCurveTo(x2 - ox, y2 + b2, x2 - a, y2 + oy, x2 - a, y2);
    ctx.closePath();
  };
  return Ellipse2;
}(Path$1);
Ellipse.prototype.type = "ellipse";
var Ellipse$1 = Ellipse;
var PI$6 = Math.PI;
var PI2$4 = PI$6 * 2;
var mathSin$1 = Math.sin;
var mathCos$1 = Math.cos;
var mathACos = Math.acos;
var mathATan2 = Math.atan2;
var mathAbs$1 = Math.abs;
var mathSqrt = Math.sqrt;
var mathMax$7 = Math.max;
var mathMin$7 = Math.min;
var e$1 = 1e-4;
function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
  var dx10 = x1 - x0;
  var dy10 = y1 - y0;
  var dx32 = x3 - x2;
  var dy32 = y3 - y2;
  var t2 = dy32 * dx10 - dx32 * dy10;
  if (t2 * t2 < e$1) {
    return;
  }
  t2 = (dx32 * (y0 - y2) - dy32 * (x0 - x2)) / t2;
  return [x0 + t2 * dx10, y0 + t2 * dy10];
}
function computeCornerTangents(x0, y0, x1, y1, radius, cr, clockwise) {
  var x01 = x0 - x1;
  var y01 = y0 - y1;
  var lo = (clockwise ? cr : -cr) / mathSqrt(x01 * x01 + y01 * y01);
  var ox = lo * y01;
  var oy = -lo * x01;
  var x11 = x0 + ox;
  var y11 = y0 + oy;
  var x10 = x1 + ox;
  var y10 = y1 + oy;
  var x00 = (x11 + x10) / 2;
  var y00 = (y11 + y10) / 2;
  var dx = x10 - x11;
  var dy = y10 - y11;
  var d2 = dx * dx + dy * dy;
  var r2 = radius - cr;
  var s = x11 * y10 - x10 * y11;
  var d3 = (dy < 0 ? -1 : 1) * mathSqrt(mathMax$7(0, r2 * r2 * d2 - s * s));
  var cx0 = (s * dy - dx * d3) / d2;
  var cy0 = (-s * dx - dy * d3) / d2;
  var cx1 = (s * dy + dx * d3) / d2;
  var cy1 = (-s * dx + dy * d3) / d2;
  var dx0 = cx0 - x00;
  var dy0 = cy0 - y00;
  var dx1 = cx1 - x00;
  var dy1 = cy1 - y00;
  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
    cx0 = cx1;
    cy0 = cy1;
  }
  return {
    cx: cx0,
    cy: cy0,
    x0: -ox,
    y0: -oy,
    x1: cx0 * (radius / r2 - 1),
    y1: cy0 * (radius / r2 - 1)
  };
}
function normalizeCornerRadius(cr) {
  var arr;
  if (isArray$2(cr)) {
    var len2 = cr.length;
    if (!len2) {
      return cr;
    }
    if (len2 === 1) {
      arr = [cr[0], cr[0], 0, 0];
    } else if (len2 === 2) {
      arr = [cr[0], cr[0], cr[1], cr[1]];
    } else if (len2 === 3) {
      arr = cr.concat(cr[2]);
    } else {
      arr = cr;
    }
  } else {
    arr = [cr, cr, cr, cr];
  }
  return arr;
}
function buildPath$1(ctx, shape) {
  var _a2;
  var radius = mathMax$7(shape.r, 0);
  var innerRadius = mathMax$7(shape.r0 || 0, 0);
  var hasRadius = radius > 0;
  var hasInnerRadius = innerRadius > 0;
  if (!hasRadius && !hasInnerRadius) {
    return;
  }
  if (!hasRadius) {
    radius = innerRadius;
    innerRadius = 0;
  }
  if (innerRadius > radius) {
    var tmp = radius;
    radius = innerRadius;
    innerRadius = tmp;
  }
  var startAngle = shape.startAngle, endAngle = shape.endAngle;
  if (isNaN(startAngle) || isNaN(endAngle)) {
    return;
  }
  var cx = shape.cx, cy = shape.cy;
  var clockwise = !!shape.clockwise;
  var arc = mathAbs$1(endAngle - startAngle);
  var mod = arc > PI2$4 && arc % PI2$4;
  mod > e$1 && (arc = mod);
  if (!(radius > e$1)) {
    ctx.moveTo(cx, cy);
  } else if (arc > PI2$4 - e$1) {
    ctx.moveTo(cx + radius * mathCos$1(startAngle), cy + radius * mathSin$1(startAngle));
    ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    if (innerRadius > e$1) {
      ctx.moveTo(cx + innerRadius * mathCos$1(endAngle), cy + innerRadius * mathSin$1(endAngle));
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  } else {
    var icrStart = void 0;
    var icrEnd = void 0;
    var ocrStart = void 0;
    var ocrEnd = void 0;
    var ocrs = void 0;
    var ocre = void 0;
    var icrs = void 0;
    var icre = void 0;
    var ocrMax = void 0;
    var icrMax = void 0;
    var limitedOcrMax = void 0;
    var limitedIcrMax = void 0;
    var xre = void 0;
    var yre = void 0;
    var xirs = void 0;
    var yirs = void 0;
    var xrs = radius * mathCos$1(startAngle);
    var yrs = radius * mathSin$1(startAngle);
    var xire = innerRadius * mathCos$1(endAngle);
    var yire = innerRadius * mathSin$1(endAngle);
    var hasArc = arc > e$1;
    if (hasArc) {
      var cornerRadius = shape.cornerRadius;
      if (cornerRadius) {
        _a2 = normalizeCornerRadius(cornerRadius), icrStart = _a2[0], icrEnd = _a2[1], ocrStart = _a2[2], ocrEnd = _a2[3];
      }
      var halfRd = mathAbs$1(radius - innerRadius) / 2;
      ocrs = mathMin$7(halfRd, ocrStart);
      ocre = mathMin$7(halfRd, ocrEnd);
      icrs = mathMin$7(halfRd, icrStart);
      icre = mathMin$7(halfRd, icrEnd);
      limitedOcrMax = ocrMax = mathMax$7(ocrs, ocre);
      limitedIcrMax = icrMax = mathMax$7(icrs, icre);
      if (ocrMax > e$1 || icrMax > e$1) {
        xre = radius * mathCos$1(endAngle);
        yre = radius * mathSin$1(endAngle);
        xirs = innerRadius * mathCos$1(startAngle);
        yirs = innerRadius * mathSin$1(startAngle);
        if (arc < PI$6) {
          var it_1 = intersect(xrs, yrs, xirs, yirs, xre, yre, xire, yire);
          if (it_1) {
            var x0 = xrs - it_1[0];
            var y0 = yrs - it_1[1];
            var x1 = xre - it_1[0];
            var y1 = yre - it_1[1];
            var a = 1 / mathSin$1(mathACos((x0 * x1 + y0 * y1) / (mathSqrt(x0 * x0 + y0 * y0) * mathSqrt(x1 * x1 + y1 * y1))) / 2);
            var b2 = mathSqrt(it_1[0] * it_1[0] + it_1[1] * it_1[1]);
            limitedOcrMax = mathMin$7(ocrMax, (radius - b2) / (a + 1));
            limitedIcrMax = mathMin$7(icrMax, (innerRadius - b2) / (a - 1));
          }
        }
      }
    }
    if (!hasArc) {
      ctx.moveTo(cx + xrs, cy + yrs);
    } else if (limitedOcrMax > e$1) {
      var crStart = mathMin$7(ocrStart, limitedOcrMax);
      var crEnd = mathMin$7(ocrEnd, limitedOcrMax);
      var ct0 = computeCornerTangents(xirs, yirs, xrs, yrs, radius, crStart, clockwise);
      var ct1 = computeCornerTangents(xre, yre, xire, yire, radius, crEnd, clockwise);
      ctx.moveTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedOcrMax < ocrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedOcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crStart > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crStart, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, radius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), !clockwise);
        crEnd > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crEnd, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.moveTo(cx + xrs, cy + yrs);
      ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    }
    if (!(innerRadius > e$1) || !hasArc) {
      ctx.lineTo(cx + xire, cy + yire);
    } else if (limitedIcrMax > e$1) {
      var crStart = mathMin$7(icrStart, limitedIcrMax);
      var crEnd = mathMin$7(icrEnd, limitedIcrMax);
      var ct0 = computeCornerTangents(xire, yire, xre, yre, innerRadius, -crEnd, clockwise);
      var ct1 = computeCornerTangents(xrs, yrs, xirs, yirs, innerRadius, -crStart, clockwise);
      ctx.lineTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedIcrMax < icrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedIcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crEnd > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crEnd, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, innerRadius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), clockwise);
        crStart > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crStart, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.lineTo(cx + xire, cy + yire);
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  }
  ctx.closePath();
}
var SectorShape = function() {
  function SectorShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
    this.cornerRadius = 0;
  }
  return SectorShape2;
}();
var Sector = function(_super) {
  __extends(Sector2, _super);
  function Sector2(opts) {
    return _super.call(this, opts) || this;
  }
  Sector2.prototype.getDefaultShape = function() {
    return new SectorShape();
  };
  Sector2.prototype.buildPath = function(ctx, shape) {
    buildPath$1(ctx, shape);
  };
  Sector2.prototype.isZeroArea = function() {
    return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
  };
  return Sector2;
}(Path$1);
Sector.prototype.type = "sector";
var Sector$1 = Sector;
var RingShape = function() {
  function RingShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.r0 = 0;
  }
  return RingShape2;
}();
var Ring = function(_super) {
  __extends(Ring2, _super);
  function Ring2(opts) {
    return _super.call(this, opts) || this;
  }
  Ring2.prototype.getDefaultShape = function() {
    return new RingShape();
  };
  Ring2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var PI22 = Math.PI * 2;
    ctx.moveTo(x2 + shape.r, y2);
    ctx.arc(x2, y2, shape.r, 0, PI22, false);
    ctx.moveTo(x2 + shape.r0, y2);
    ctx.arc(x2, y2, shape.r0, 0, PI22, true);
  };
  return Ring2;
}(Path$1);
Ring.prototype.type = "ring";
var Ring$1 = Ring;
function smoothBezier(points2, smooth, isLoop, constraint) {
  var cps = [];
  var v4 = [];
  var v12 = [];
  var v22 = [];
  var prevPoint;
  var nextPoint;
  var min3;
  var max3;
  if (constraint) {
    min3 = [Infinity, Infinity];
    max3 = [-Infinity, -Infinity];
    for (var i = 0, len2 = points2.length; i < len2; i++) {
      min$1(min3, min3, points2[i]);
      max$1(max3, max3, points2[i]);
    }
    min$1(min3, min3, constraint[0]);
    max$1(max3, max3, constraint[1]);
  }
  for (var i = 0, len2 = points2.length; i < len2; i++) {
    var point = points2[i];
    if (isLoop) {
      prevPoint = points2[i ? i - 1 : len2 - 1];
      nextPoint = points2[(i + 1) % len2];
    } else {
      if (i === 0 || i === len2 - 1) {
        cps.push(clone$3(points2[i]));
        continue;
      } else {
        prevPoint = points2[i - 1];
        nextPoint = points2[i + 1];
      }
    }
    sub(v4, nextPoint, prevPoint);
    scale$2(v4, v4, smooth);
    var d0 = distance(point, prevPoint);
    var d1 = distance(point, nextPoint);
    var sum2 = d0 + d1;
    if (sum2 !== 0) {
      d0 /= sum2;
      d1 /= sum2;
    }
    scale$2(v12, v4, -d0);
    scale$2(v22, v4, d1);
    var cp0 = add([], point, v12);
    var cp1 = add([], point, v22);
    if (constraint) {
      max$1(cp0, cp0, min3);
      min$1(cp0, cp0, max3);
      max$1(cp1, cp1, min3);
      min$1(cp1, cp1, max3);
    }
    cps.push(cp0);
    cps.push(cp1);
  }
  if (isLoop) {
    cps.push(cps.shift());
  }
  return cps;
}
function buildPath(ctx, shape, closePath) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (points2 && points2.length >= 2) {
    if (smooth) {
      var controlPoints = smoothBezier(points2, smooth, closePath, shape.smoothConstraint);
      ctx.moveTo(points2[0][0], points2[0][1]);
      var len2 = points2.length;
      for (var i = 0; i < (closePath ? len2 : len2 - 1); i++) {
        var cp1 = controlPoints[i * 2];
        var cp2 = controlPoints[i * 2 + 1];
        var p2 = points2[(i + 1) % len2];
        ctx.bezierCurveTo(cp1[0], cp1[1], cp2[0], cp2[1], p2[0], p2[1]);
      }
    } else {
      ctx.moveTo(points2[0][0], points2[0][1]);
      for (var i = 1, l2 = points2.length; i < l2; i++) {
        ctx.lineTo(points2[i][0], points2[i][1]);
      }
    }
    closePath && ctx.closePath();
  }
}
var PolygonShape = function() {
  function PolygonShape2() {
    this.points = null;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolygonShape2;
}();
var Polygon = function(_super) {
  __extends(Polygon2, _super);
  function Polygon2(opts) {
    return _super.call(this, opts) || this;
  }
  Polygon2.prototype.getDefaultShape = function() {
    return new PolygonShape();
  };
  Polygon2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, true);
  };
  return Polygon2;
}(Path$1);
Polygon.prototype.type = "polygon";
var Polygon$1 = Polygon;
var PolylineShape = function() {
  function PolylineShape2() {
    this.points = null;
    this.percent = 1;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolylineShape2;
}();
var Polyline$2 = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(opts) {
    return _super.call(this, opts) || this;
  }
  Polyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Polyline2.prototype.getDefaultShape = function() {
    return new PolylineShape();
  };
  Polyline2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, false);
  };
  return Polyline2;
}(Path$1);
Polyline$2.prototype.type = "polyline";
var Polyline$3 = Polyline$2;
var subPixelOptimizeOutputShape = {};
var LineShape = function() {
  function LineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return LineShape2;
}();
var Line$2 = function(_super) {
  __extends(Line2, _super);
  function Line2(opts) {
    return _super.call(this, opts) || this;
  }
  Line2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Line2.prototype.getDefaultShape = function() {
    return new LineShape();
  };
  Line2.prototype.buildPath = function(ctx, shape) {
    var x1;
    var y1;
    var x2;
    var y2;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeLine$1(subPixelOptimizeOutputShape, shape, this.style);
      x1 = optimizedShape.x1;
      y1 = optimizedShape.y1;
      x2 = optimizedShape.x2;
      y2 = optimizedShape.y2;
    } else {
      x1 = shape.x1;
      y1 = shape.y1;
      x2 = shape.x2;
      y2 = shape.y2;
    }
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (percent < 1) {
      x2 = x1 * (1 - percent) + x2 * percent;
      y2 = y1 * (1 - percent) + y2 * percent;
    }
    ctx.lineTo(x2, y2);
  };
  Line2.prototype.pointAt = function(p2) {
    var shape = this.shape;
    return [
      shape.x1 * (1 - p2) + shape.x2 * p2,
      shape.y1 * (1 - p2) + shape.y2 * p2
    ];
  };
  return Line2;
}(Path$1);
Line$2.prototype.type = "line";
var Line$3 = Line$2;
var out = [];
var BezierCurveShape = function() {
  function BezierCurveShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.percent = 1;
  }
  return BezierCurveShape2;
}();
function someVectorAt(shape, t2, isTangent) {
  var cpx2 = shape.cpx2;
  var cpy2 = shape.cpy2;
  if (cpx2 != null || cpy2 != null) {
    return [
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.x1, shape.cpx1, shape.cpx2, shape.x2, t2),
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.y1, shape.cpy1, shape.cpy2, shape.y2, t2)
    ];
  } else {
    return [
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.x1, shape.cpx1, shape.x2, t2),
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.y1, shape.cpy1, shape.y2, t2)
    ];
  }
}
var BezierCurve = function(_super) {
  __extends(BezierCurve2, _super);
  function BezierCurve2(opts) {
    return _super.call(this, opts) || this;
  }
  BezierCurve2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  BezierCurve2.prototype.getDefaultShape = function() {
    return new BezierCurveShape();
  };
  BezierCurve2.prototype.buildPath = function(ctx, shape) {
    var x1 = shape.x1;
    var y1 = shape.y1;
    var x2 = shape.x2;
    var y2 = shape.y2;
    var cpx1 = shape.cpx1;
    var cpy1 = shape.cpy1;
    var cpx2 = shape.cpx2;
    var cpy2 = shape.cpy2;
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (cpx2 == null || cpy2 == null) {
      if (percent < 1) {
        quadraticSubdivide(x1, cpx1, x2, percent, out);
        cpx1 = out[1];
        x2 = out[2];
        quadraticSubdivide(y1, cpy1, y2, percent, out);
        cpy1 = out[1];
        y2 = out[2];
      }
      ctx.quadraticCurveTo(cpx1, cpy1, x2, y2);
    } else {
      if (percent < 1) {
        cubicSubdivide(x1, cpx1, cpx2, x2, percent, out);
        cpx1 = out[1];
        cpx2 = out[2];
        x2 = out[3];
        cubicSubdivide(y1, cpy1, cpy2, y2, percent, out);
        cpy1 = out[1];
        cpy2 = out[2];
        y2 = out[3];
      }
      ctx.bezierCurveTo(cpx1, cpy1, cpx2, cpy2, x2, y2);
    }
  };
  BezierCurve2.prototype.pointAt = function(t2) {
    return someVectorAt(this.shape, t2, false);
  };
  BezierCurve2.prototype.tangentAt = function(t2) {
    var p2 = someVectorAt(this.shape, t2, true);
    return normalize$4(p2, p2);
  };
  return BezierCurve2;
}(Path$1);
BezierCurve.prototype.type = "bezier-curve";
var BezierCurve$1 = BezierCurve;
var ArcShape = function() {
  function ArcShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return ArcShape2;
}();
var Arc = function(_super) {
  __extends(Arc2, _super);
  function Arc2(opts) {
    return _super.call(this, opts) || this;
  }
  Arc2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Arc2.prototype.getDefaultShape = function() {
    return new ArcShape();
  };
  Arc2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var r2 = Math.max(shape.r, 0);
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var unitX = Math.cos(startAngle);
    var unitY = Math.sin(startAngle);
    ctx.moveTo(unitX * r2 + x2, unitY * r2 + y2);
    ctx.arc(x2, y2, r2, startAngle, endAngle, !clockwise);
  };
  return Arc2;
}(Path$1);
Arc.prototype.type = "arc";
var Arc$1 = Arc;
var CompoundPath = function(_super) {
  __extends(CompoundPath2, _super);
  function CompoundPath2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "compound";
    return _this;
  }
  CompoundPath2.prototype._updatePathDirty = function() {
    var paths = this.shape.paths;
    var dirtyPath = this.shapeChanged();
    for (var i = 0; i < paths.length; i++) {
      dirtyPath = dirtyPath || paths[i].shapeChanged();
    }
    if (dirtyPath) {
      this.dirtyShape();
    }
  };
  CompoundPath2.prototype.beforeBrush = function() {
    this._updatePathDirty();
    var paths = this.shape.paths || [];
    var scale2 = this.getGlobalScale();
    for (var i = 0; i < paths.length; i++) {
      if (!paths[i].path) {
        paths[i].createPathProxy();
      }
      paths[i].path.setScale(scale2[0], scale2[1], paths[i].segmentIgnoreThreshold);
    }
  };
  CompoundPath2.prototype.buildPath = function(ctx, shape) {
    var paths = shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].buildPath(ctx, paths[i].shape, true);
    }
  };
  CompoundPath2.prototype.afterBrush = function() {
    var paths = this.shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].pathUpdated();
    }
  };
  CompoundPath2.prototype.getBoundingRect = function() {
    this._updatePathDirty.call(this);
    return Path$1.prototype.getBoundingRect.call(this);
  };
  return CompoundPath2;
}(Path$1);
var CompoundPath$1 = CompoundPath;
var Gradient = function() {
  function Gradient2(colorStops) {
    this.colorStops = colorStops || [];
  }
  Gradient2.prototype.addColorStop = function(offset3, color) {
    this.colorStops.push({
      offset: offset3,
      color
    });
  };
  return Gradient2;
}();
var Gradient$1 = Gradient;
var LinearGradient = function(_super) {
  __extends(LinearGradient2, _super);
  function LinearGradient2(x2, y2, x22, y22, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0 : x2;
    _this.y = y2 == null ? 0 : y2;
    _this.x2 = x22 == null ? 1 : x22;
    _this.y2 = y22 == null ? 0 : y22;
    _this.type = "linear";
    _this.global = globalCoord || false;
    return _this;
  }
  return LinearGradient2;
}(Gradient$1);
var LinearGradient$1 = LinearGradient;
var RadialGradient = function(_super) {
  __extends(RadialGradient2, _super);
  function RadialGradient2(x2, y2, r2, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0.5 : x2;
    _this.y = y2 == null ? 0.5 : y2;
    _this.r = r2 == null ? 0.5 : r2;
    _this.type = "radial";
    _this.global = globalCoord || false;
    return _this;
  }
  return RadialGradient2;
}(Gradient$1);
var RadialGradient$1 = RadialGradient;
var extent = [0, 0];
var extent2 = [0, 0];
var minTv = new Point$1();
var maxTv = new Point$1();
var OrientedBoundingRect = function() {
  function OrientedBoundingRect2(rect, transform2) {
    this._corners = [];
    this._axes = [];
    this._origin = [0, 0];
    for (var i = 0; i < 4; i++) {
      this._corners[i] = new Point$1();
    }
    for (var i = 0; i < 2; i++) {
      this._axes[i] = new Point$1();
    }
    if (rect) {
      this.fromBoundingRect(rect, transform2);
    }
  }
  OrientedBoundingRect2.prototype.fromBoundingRect = function(rect, transform2) {
    var corners = this._corners;
    var axes = this._axes;
    var x2 = rect.x;
    var y2 = rect.y;
    var x22 = x2 + rect.width;
    var y22 = y2 + rect.height;
    corners[0].set(x2, y2);
    corners[1].set(x22, y2);
    corners[2].set(x22, y22);
    corners[3].set(x2, y22);
    if (transform2) {
      for (var i = 0; i < 4; i++) {
        corners[i].transform(transform2);
      }
    }
    Point$1.sub(axes[0], corners[1], corners[0]);
    Point$1.sub(axes[1], corners[3], corners[0]);
    axes[0].normalize();
    axes[1].normalize();
    for (var i = 0; i < 2; i++) {
      this._origin[i] = axes[i].dot(corners[0]);
    }
  };
  OrientedBoundingRect2.prototype.intersect = function(other, mtv) {
    var overlapped = true;
    var noMtv = !mtv;
    minTv.set(Infinity, Infinity);
    maxTv.set(0, 0);
    if (!this._intersectCheckOneSide(this, other, minTv, maxTv, noMtv, 1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!this._intersectCheckOneSide(other, this, minTv, maxTv, noMtv, -1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!noMtv) {
      Point$1.copy(mtv, overlapped ? minTv : maxTv);
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._intersectCheckOneSide = function(self2, other, minTv2, maxTv2, noMtv, inverse) {
    var overlapped = true;
    for (var i = 0; i < 2; i++) {
      var axis = this._axes[i];
      this._getProjMinMaxOnAxis(i, self2._corners, extent);
      this._getProjMinMaxOnAxis(i, other._corners, extent2);
      if (extent[1] < extent2[0] || extent[0] > extent2[1]) {
        overlapped = false;
        if (noMtv) {
          return overlapped;
        }
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) > maxTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(maxTv2, axis, -dist0 * inverse);
          } else {
            Point$1.scale(maxTv2, axis, dist1 * inverse);
          }
        }
      } else if (minTv2) {
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) < minTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(minTv2, axis, dist0 * inverse);
          } else {
            Point$1.scale(minTv2, axis, -dist1 * inverse);
          }
        }
      }
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._getProjMinMaxOnAxis = function(dim, corners, out2) {
    var axis = this._axes[dim];
    var origin = this._origin;
    var proj = corners[0].dot(axis) + origin[dim];
    var min3 = proj;
    var max3 = proj;
    for (var i = 1; i < corners.length; i++) {
      var proj_1 = corners[i].dot(axis) + origin[dim];
      min3 = Math.min(proj_1, min3);
      max3 = Math.max(proj_1, max3);
    }
    out2[0] = min3;
    out2[1] = max3;
  };
  return OrientedBoundingRect2;
}();
var OrientedBoundingRect$1 = OrientedBoundingRect;
var m$3 = [];
var IncrementalDisplayable = function(_super) {
  __extends(IncrementalDisplayable2, _super);
  function IncrementalDisplayable2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.notClear = true;
    _this.incremental = true;
    _this._displayables = [];
    _this._temporaryDisplayables = [];
    _this._cursor = 0;
    return _this;
  }
  IncrementalDisplayable2.prototype.traverse = function(cb2, context) {
    cb2.call(context, this);
  };
  IncrementalDisplayable2.prototype.useStyle = function() {
    this.style = {};
  };
  IncrementalDisplayable2.prototype.getCursor = function() {
    return this._cursor;
  };
  IncrementalDisplayable2.prototype.innerAfterBrush = function() {
    this._cursor = this._displayables.length;
  };
  IncrementalDisplayable2.prototype.clearDisplaybles = function() {
    this._displayables = [];
    this._temporaryDisplayables = [];
    this._cursor = 0;
    this.markRedraw();
    this.notClear = false;
  };
  IncrementalDisplayable2.prototype.clearTemporalDisplayables = function() {
    this._temporaryDisplayables = [];
  };
  IncrementalDisplayable2.prototype.addDisplayable = function(displayable, notPersistent) {
    if (notPersistent) {
      this._temporaryDisplayables.push(displayable);
    } else {
      this._displayables.push(displayable);
    }
    this.markRedraw();
  };
  IncrementalDisplayable2.prototype.addDisplayables = function(displayables, notPersistent) {
    notPersistent = notPersistent || false;
    for (var i = 0; i < displayables.length; i++) {
      this.addDisplayable(displayables[i], notPersistent);
    }
  };
  IncrementalDisplayable2.prototype.getDisplayables = function() {
    return this._displayables;
  };
  IncrementalDisplayable2.prototype.getTemporalDisplayables = function() {
    return this._temporaryDisplayables;
  };
  IncrementalDisplayable2.prototype.eachPendingDisplayable = function(cb2) {
    for (var i = this._cursor; i < this._displayables.length; i++) {
      cb2 && cb2(this._displayables[i]);
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      cb2 && cb2(this._temporaryDisplayables[i]);
    }
  };
  IncrementalDisplayable2.prototype.update = function() {
    this.updateTransform();
    for (var i = this._cursor; i < this._displayables.length; i++) {
      var displayable = this._displayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      var displayable = this._temporaryDisplayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
  };
  IncrementalDisplayable2.prototype.getBoundingRect = function() {
    if (!this._rect) {
      var rect = new BoundingRect$1(Infinity, Infinity, -Infinity, -Infinity);
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        var childRect = displayable.getBoundingRect().clone();
        if (displayable.needLocalTransform()) {
          childRect.applyTransform(displayable.getLocalTransform(m$3));
        }
        rect.union(childRect);
      }
      this._rect = rect;
    }
    return this._rect;
  };
  IncrementalDisplayable2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    if (rect.contain(localPos[0], localPos[1])) {
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        if (displayable.contain(x2, y2)) {
          return true;
        }
      }
    }
    return false;
  };
  return IncrementalDisplayable2;
}(Displayable$1);
var IncrementalDisplayable$1 = IncrementalDisplayable;
var transitionStore = makeInner();
function getAnimationConfig(animationType, animatableModel, dataIndex, extraOpts, extraDelayParams) {
  var animationPayload;
  if (animatableModel && animatableModel.ecModel) {
    var updatePayload = animatableModel.ecModel.getUpdatePayload();
    animationPayload = updatePayload && updatePayload.animation;
  }
  var animationEnabled = animatableModel && animatableModel.isAnimationEnabled();
  var isUpdate = animationType === "update";
  if (animationEnabled) {
    var duration = void 0;
    var easing = void 0;
    var delay = void 0;
    if (extraOpts) {
      duration = retrieve2(extraOpts.duration, 200);
      easing = retrieve2(extraOpts.easing, "cubicOut");
      delay = 0;
    } else {
      duration = animatableModel.getShallow(isUpdate ? "animationDurationUpdate" : "animationDuration");
      easing = animatableModel.getShallow(isUpdate ? "animationEasingUpdate" : "animationEasing");
      delay = animatableModel.getShallow(isUpdate ? "animationDelayUpdate" : "animationDelay");
    }
    if (animationPayload) {
      animationPayload.duration != null && (duration = animationPayload.duration);
      animationPayload.easing != null && (easing = animationPayload.easing);
      animationPayload.delay != null && (delay = animationPayload.delay);
    }
    if (isFunction$1(delay)) {
      delay = delay(dataIndex, extraDelayParams);
    }
    if (isFunction$1(duration)) {
      duration = duration(dataIndex);
    }
    var config2 = {
      duration: duration || 0,
      delay,
      easing
    };
    return config2;
  } else {
    return null;
  }
}
function animateOrSetProps(animationType, el, props, animatableModel, dataIndex, cb2, during) {
  var isFrom = false;
  var removeOpt;
  if (isFunction$1(dataIndex)) {
    during = cb2;
    cb2 = dataIndex;
    dataIndex = null;
  } else if (isObject$6(dataIndex)) {
    cb2 = dataIndex.cb;
    during = dataIndex.during;
    isFrom = dataIndex.isFrom;
    removeOpt = dataIndex.removeOpt;
    dataIndex = dataIndex.dataIndex;
  }
  var isRemove = animationType === "leave";
  if (!isRemove) {
    el.stopAnimation("leave");
  }
  var animationConfig = getAnimationConfig(animationType, animatableModel, dataIndex, isRemove ? removeOpt || {} : null, animatableModel && animatableModel.getAnimationDelayParams ? animatableModel.getAnimationDelayParams(el, dataIndex) : null);
  if (animationConfig && animationConfig.duration > 0) {
    var duration = animationConfig.duration;
    var animationDelay = animationConfig.delay;
    var animationEasing = animationConfig.easing;
    var animateConfig = {
      duration,
      delay: animationDelay || 0,
      easing: animationEasing,
      done: cb2,
      force: !!cb2 || !!during,
      setToFinal: !isRemove,
      scope: animationType,
      during
    };
    isFrom ? el.animateFrom(props, animateConfig) : el.animateTo(props, animateConfig);
  } else {
    el.stopAnimation();
    !isFrom && el.attr(props);
    during && during(1);
    cb2 && cb2();
  }
}
function updateProps$1(el, props, animatableModel, dataIndex, cb2, during) {
  animateOrSetProps("update", el, props, animatableModel, dataIndex, cb2, during);
}
function initProps(el, props, animatableModel, dataIndex, cb2, during) {
  animateOrSetProps("enter", el, props, animatableModel, dataIndex, cb2, during);
}
function isElementRemoved(el) {
  if (!el.__zr) {
    return true;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.scope === "leave") {
      return true;
    }
  }
  return false;
}
function removeElement(el, props, animatableModel, dataIndex, cb2, during) {
  if (isElementRemoved(el)) {
    return;
  }
  animateOrSetProps("leave", el, props, animatableModel, dataIndex, cb2, during);
}
function fadeOutDisplayable(el, animatableModel, dataIndex, done) {
  el.removeTextContent();
  el.removeTextGuideLine();
  removeElement(el, {
    style: {
      opacity: 0
    }
  }, animatableModel, dataIndex, done);
}
function removeElementWithFadeOut(el, animatableModel, dataIndex) {
  function doRemove() {
    el.parent && el.parent.remove(el);
  }
  if (!el.isGroup) {
    fadeOutDisplayable(el, animatableModel, dataIndex, doRemove);
  } else {
    el.traverse(function(disp) {
      if (!disp.isGroup) {
        fadeOutDisplayable(disp, animatableModel, dataIndex, doRemove);
      }
    });
  }
}
function saveOldStyle(el) {
  transitionStore(el).oldStyle = el.style;
}
function getOldStyle(el) {
  return transitionStore(el).oldStyle;
}
var mathMax$6 = Math.max;
var mathMin$6 = Math.min;
var _customShapeMap = {};
function extendShape(opts) {
  return Path$1.extend(opts);
}
var extendPathFromString = extendFromString;
function extendPath(pathData, opts) {
  return extendPathFromString(pathData, opts);
}
function registerShape(name2, ShapeClass) {
  _customShapeMap[name2] = ShapeClass;
}
function getShapeClass(name2) {
  if (_customShapeMap.hasOwnProperty(name2)) {
    return _customShapeMap[name2];
  }
}
function makePath(pathData, opts, rect, layout2) {
  var path = createFromString(pathData, opts);
  if (rect) {
    if (layout2 === "center") {
      rect = centerGraphic(rect, path.getBoundingRect());
    }
    resizePath(path, rect);
  }
  return path;
}
function makeImage(imageUrl, rect, layout2) {
  var zrImg = new ZRImage$1({
    style: {
      image: imageUrl,
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    onload: function(img) {
      if (layout2 === "center") {
        var boundingRect = {
          width: img.width,
          height: img.height
        };
        zrImg.setStyle(centerGraphic(rect, boundingRect));
      }
    }
  });
  return zrImg;
}
function centerGraphic(rect, boundingRect) {
  var aspect = boundingRect.width / boundingRect.height;
  var width = rect.height * aspect;
  var height;
  if (width <= rect.width) {
    height = rect.height;
  } else {
    width = rect.width;
    height = width / aspect;
  }
  var cx = rect.x + rect.width / 2;
  var cy = rect.y + rect.height / 2;
  return {
    x: cx - width / 2,
    y: cy - height / 2,
    width,
    height
  };
}
var mergePath = mergePath$1;
function resizePath(path, rect) {
  if (!path.applyTransform) {
    return;
  }
  var pathRect = path.getBoundingRect();
  var m2 = pathRect.calculateTransform(rect);
  path.applyTransform(m2);
}
function subPixelOptimizeLine(param) {
  subPixelOptimizeLine$1(param.shape, param.shape, param.style);
  return param;
}
function subPixelOptimizeRect(param) {
  subPixelOptimizeRect$1(param.shape, param.shape, param.style);
  return param;
}
var subPixelOptimize = subPixelOptimize$1;
function getTransform$1(target, ancestor) {
  var mat = identity([]);
  while (target && target !== ancestor) {
    mul(mat, target.getLocalTransform(), mat);
    target = target.parent;
  }
  return mat;
}
function applyTransform(target, transform2, invert$1) {
  if (transform2 && !isArrayLike(transform2)) {
    transform2 = Transformable$1.getLocalTransform(transform2);
  }
  if (invert$1) {
    transform2 = invert([], transform2);
  }
  return applyTransform$1([], target, transform2);
}
function transformDirection(direction, transform2, invert2) {
  var hBase = transform2[4] === 0 || transform2[5] === 0 || transform2[0] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[0]);
  var vBase = transform2[4] === 0 || transform2[5] === 0 || transform2[2] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[2]);
  var vertex = [direction === "left" ? -hBase : direction === "right" ? hBase : 0, direction === "top" ? -vBase : direction === "bottom" ? vBase : 0];
  vertex = applyTransform(vertex, transform2, invert2);
  return Math.abs(vertex[0]) > Math.abs(vertex[1]) ? vertex[0] > 0 ? "right" : "left" : vertex[1] > 0 ? "bottom" : "top";
}
function isNotGroup(el) {
  return !el.isGroup;
}
function isPath$1(el) {
  return el.shape != null;
}
function groupTransition(g1, g2, animatableModel) {
  if (!g1 || !g2) {
    return;
  }
  function getElMap(g3) {
    var elMap = {};
    g3.traverse(function(el) {
      if (isNotGroup(el) && el.anid) {
        elMap[el.anid] = el;
      }
    });
    return elMap;
  }
  function getAnimatableProps(el) {
    var obj = {
      x: el.x,
      y: el.y,
      rotation: el.rotation
    };
    if (isPath$1(el)) {
      obj.shape = extend({}, el.shape);
    }
    return obj;
  }
  var elMap1 = getElMap(g1);
  g2.traverse(function(el) {
    if (isNotGroup(el) && el.anid) {
      var oldEl = elMap1[el.anid];
      if (oldEl) {
        var newProp = getAnimatableProps(el);
        el.attr(getAnimatableProps(oldEl));
        updateProps$1(el, newProp, animatableModel, getECData(el).dataIndex);
      }
    }
  });
}
function clipPointsByRect(points2, rect) {
  return map$1(points2, function(point) {
    var x2 = point[0];
    x2 = mathMax$6(x2, rect.x);
    x2 = mathMin$6(x2, rect.x + rect.width);
    var y2 = point[1];
    y2 = mathMax$6(y2, rect.y);
    y2 = mathMin$6(y2, rect.y + rect.height);
    return [x2, y2];
  });
}
function clipRectByRect(targetRect, rect) {
  var x2 = mathMax$6(targetRect.x, rect.x);
  var x22 = mathMin$6(targetRect.x + targetRect.width, rect.x + rect.width);
  var y2 = mathMax$6(targetRect.y, rect.y);
  var y22 = mathMin$6(targetRect.y + targetRect.height, rect.y + rect.height);
  if (x22 >= x2 && y22 >= y2) {
    return {
      x: x2,
      y: y2,
      width: x22 - x2,
      height: y22 - y2
    };
  }
}
function createIcon(iconStr, opt, rect) {
  var innerOpts = extend({
    rectHover: true
  }, opt);
  var style2 = innerOpts.style = {
    strokeNoScale: true
  };
  rect = rect || {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  };
  if (iconStr) {
    return iconStr.indexOf("image://") === 0 ? (style2.image = iconStr.slice(8), defaults(style2, rect), new ZRImage$1(innerOpts)) : makePath(iconStr.replace("path://", ""), innerOpts, rect, "center");
  }
}
function linePolygonIntersect(a1x, a1y, a2x, a2y, points2) {
  for (var i = 0, p2 = points2[points2.length - 1]; i < points2.length; i++) {
    var p3 = points2[i];
    if (lineLineIntersect$1(a1x, a1y, a2x, a2y, p3[0], p3[1], p2[0], p2[1])) {
      return true;
    }
    p2 = p3;
  }
}
function lineLineIntersect$1(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d$1(nx, ny, mx, my);
  if (nearZero(nmCrossProduct)) {
    return false;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var q2 = crossProduct2d$1(b1a1x, b1a1y, mx, my) / nmCrossProduct;
  if (q2 < 0 || q2 > 1) {
    return false;
  }
  var p2 = crossProduct2d$1(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return false;
  }
  return true;
}
function crossProduct2d$1(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function nearZero(val) {
  return val <= 1e-6 && val >= -1e-6;
}
function setTooltipConfig(opt) {
  var itemTooltipOption = opt.itemTooltipOption;
  var componentModel = opt.componentModel;
  var itemName = opt.itemName;
  var itemTooltipOptionObj = isString$1(itemTooltipOption) ? {
    formatter: itemTooltipOption
  } : itemTooltipOption;
  var mainType = componentModel.mainType;
  var componentIndex = componentModel.componentIndex;
  var formatterParams = {
    componentType: mainType,
    name: itemName,
    $vars: ["name"]
  };
  formatterParams[mainType + "Index"] = componentIndex;
  var formatterParamsExtra = opt.formatterParamsExtra;
  if (formatterParamsExtra) {
    each$g(keys(formatterParamsExtra), function(key) {
      if (!hasOwn$1(formatterParams, key)) {
        formatterParams[key] = formatterParamsExtra[key];
        formatterParams.$vars.push(key);
      }
    });
  }
  var ecData = getECData(opt.el);
  ecData.componentMainType = mainType;
  ecData.componentIndex = componentIndex;
  ecData.tooltipConfig = {
    name: itemName,
    option: defaults({
      content: itemName,
      formatterParams
    }, itemTooltipOptionObj)
  };
}
function traverseElement(el, cb2) {
  var stopped;
  if (el.isGroup) {
    stopped = cb2(el);
  }
  if (!stopped) {
    el.traverse(cb2);
  }
}
function traverseElements(els, cb2) {
  if (els) {
    if (isArray$2(els)) {
      for (var i = 0; i < els.length; i++) {
        traverseElement(els[i], cb2);
      }
    } else {
      traverseElement(els, cb2);
    }
  }
}
registerShape("circle", Circle$1);
registerShape("ellipse", Ellipse$1);
registerShape("sector", Sector$1);
registerShape("ring", Ring$1);
registerShape("polygon", Polygon$1);
registerShape("polyline", Polyline$3);
registerShape("rect", Rect$3);
registerShape("line", Line$3);
registerShape("bezierCurve", BezierCurve$1);
registerShape("arc", Arc$1);
var graphic = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  updateProps: updateProps$1,
  initProps,
  removeElement,
  removeElementWithFadeOut,
  isElementRemoved,
  extendShape,
  extendPath,
  registerShape,
  getShapeClass,
  makePath,
  makeImage,
  mergePath,
  resizePath,
  subPixelOptimizeLine,
  subPixelOptimizeRect,
  subPixelOptimize,
  getTransform: getTransform$1,
  applyTransform,
  transformDirection,
  groupTransition,
  clipPointsByRect,
  clipRectByRect,
  createIcon,
  linePolygonIntersect,
  lineLineIntersect: lineLineIntersect$1,
  setTooltipConfig,
  traverseElements,
  Group: Group$6,
  Image: ZRImage$1,
  Text: ZRText$1,
  Circle: Circle$1,
  Ellipse: Ellipse$1,
  Sector: Sector$1,
  Ring: Ring$1,
  Polygon: Polygon$1,
  Polyline: Polyline$3,
  Rect: Rect$3,
  Line: Line$3,
  BezierCurve: BezierCurve$1,
  Arc: Arc$1,
  IncrementalDisplayable: IncrementalDisplayable$1,
  CompoundPath: CompoundPath$1,
  LinearGradient: LinearGradient$1,
  RadialGradient: RadialGradient$1,
  BoundingRect: BoundingRect$1,
  OrientedBoundingRect: OrientedBoundingRect$1,
  Point: Point$1,
  Path: Path$1
}, Symbol.toStringTag, { value: "Module" }));
var EMPTY_OBJ = {};
function setLabelText(label, labelTexts) {
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var text = labelTexts[stateName];
    var state = label.ensureState(stateName);
    state.style = state.style || {};
    state.style.text = text;
  }
  var oldStates = label.currentStates.slice();
  label.clearStates(true);
  label.setStyle({
    text: labelTexts.normal
  });
  label.useStates(oldStates, true);
}
function getLabelText(opt, stateModels, interpolatedValue) {
  var labelFetcher = opt.labelFetcher;
  var labelDataIndex = opt.labelDataIndex;
  var labelDimIndex = opt.labelDimIndex;
  var normalModel = stateModels.normal;
  var baseText;
  if (labelFetcher) {
    baseText = labelFetcher.getFormattedLabel(labelDataIndex, "normal", null, labelDimIndex, normalModel && normalModel.get("formatter"), interpolatedValue != null ? {
      interpolatedValue
    } : null);
  }
  if (baseText == null) {
    baseText = isFunction$1(opt.defaultText) ? opt.defaultText(labelDataIndex, opt, interpolatedValue) : opt.defaultText;
  }
  var statesText = {
    normal: baseText
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var stateModel = stateModels[stateName];
    statesText[stateName] = retrieve2(labelFetcher ? labelFetcher.getFormattedLabel(labelDataIndex, stateName, null, labelDimIndex, stateModel && stateModel.get("formatter")) : null, baseText);
  }
  return statesText;
}
function setLabelStyle(targetEl, labelStatesModels, opt, stateSpecified) {
  opt = opt || EMPTY_OBJ;
  var isSetOnText = targetEl instanceof ZRText$1;
  var needsCreateText = false;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateModel = labelStatesModels[DISPLAY_STATES[i]];
    if (stateModel && stateModel.getShallow("show")) {
      needsCreateText = true;
      break;
    }
  }
  var textContent = isSetOnText ? targetEl : targetEl.getTextContent();
  if (needsCreateText) {
    if (!isSetOnText) {
      if (!textContent) {
        textContent = new ZRText$1();
        targetEl.setTextContent(textContent);
      }
      if (targetEl.stateProxy) {
        textContent.stateProxy = targetEl.stateProxy;
      }
    }
    var labelStatesTexts = getLabelText(opt, labelStatesModels);
    var normalModel = labelStatesModels.normal;
    var showNormal = !!normalModel.getShallow("show");
    var normalStyle = createTextStyle(normalModel, stateSpecified && stateSpecified.normal, opt, false, !isSetOnText);
    normalStyle.text = labelStatesTexts.normal;
    if (!isSetOnText) {
      targetEl.setTextConfig(createTextConfig(normalModel, opt, false));
    }
    for (var i = 0; i < SPECIAL_STATES.length; i++) {
      var stateName = SPECIAL_STATES[i];
      var stateModel = labelStatesModels[stateName];
      if (stateModel) {
        var stateObj = textContent.ensureState(stateName);
        var stateShow = !!retrieve2(stateModel.getShallow("show"), showNormal);
        if (stateShow !== showNormal) {
          stateObj.ignore = !stateShow;
        }
        stateObj.style = createTextStyle(stateModel, stateSpecified && stateSpecified[stateName], opt, true, !isSetOnText);
        stateObj.style.text = labelStatesTexts[stateName];
        if (!isSetOnText) {
          var targetElEmphasisState = targetEl.ensureState(stateName);
          targetElEmphasisState.textConfig = createTextConfig(stateModel, opt, true);
        }
      }
    }
    textContent.silent = !!normalModel.getShallow("silent");
    if (textContent.style.x != null) {
      normalStyle.x = textContent.style.x;
    }
    if (textContent.style.y != null) {
      normalStyle.y = textContent.style.y;
    }
    textContent.ignore = !showNormal;
    textContent.useStyle(normalStyle);
    textContent.dirty();
    if (opt.enableTextSetter) {
      labelInner(textContent).setLabelText = function(interpolatedValue) {
        var labelStatesTexts2 = getLabelText(opt, labelStatesModels, interpolatedValue);
        setLabelText(textContent, labelStatesTexts2);
      };
    }
  } else if (textContent) {
    textContent.ignore = true;
  }
  targetEl.dirty();
}
function getLabelStatesModels(itemModel, labelName) {
  labelName = labelName || "label";
  var statesModels = {
    normal: itemModel.getModel(labelName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelName]);
  }
  return statesModels;
}
function createTextStyle(textStyleModel, specifiedTextStyle, opt, isNotNormal, isAttached) {
  var textStyle = {};
  setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached);
  specifiedTextStyle && extend(textStyle, specifiedTextStyle);
  return textStyle;
}
function createTextConfig(textStyleModel, opt, isNotNormal) {
  opt = opt || {};
  var textConfig = {};
  var labelPosition;
  var labelRotate = textStyleModel.getShallow("rotate");
  var labelDistance = retrieve2(textStyleModel.getShallow("distance"), isNotNormal ? null : 5);
  var labelOffset = textStyleModel.getShallow("offset");
  labelPosition = textStyleModel.getShallow("position") || (isNotNormal ? null : "inside");
  labelPosition === "outside" && (labelPosition = opt.defaultOutsidePosition || "top");
  if (labelPosition != null) {
    textConfig.position = labelPosition;
  }
  if (labelOffset != null) {
    textConfig.offset = labelOffset;
  }
  if (labelRotate != null) {
    labelRotate *= Math.PI / 180;
    textConfig.rotation = labelRotate;
  }
  if (labelDistance != null) {
    textConfig.distance = labelDistance;
  }
  textConfig.outsideFill = textStyleModel.get("color") === "inherit" ? opt.inheritColor || null : "auto";
  return textConfig;
}
function setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached) {
  opt = opt || EMPTY_OBJ;
  var ecModel = textStyleModel.ecModel;
  var globalTextStyle = ecModel && ecModel.option.textStyle;
  var richItemNames = getRichItemNames(textStyleModel);
  var richResult;
  if (richItemNames) {
    richResult = {};
    for (var name_1 in richItemNames) {
      if (richItemNames.hasOwnProperty(name_1)) {
        var richTextStyle = textStyleModel.getModel(["rich", name_1]);
        setTokenTextStyle(richResult[name_1] = {}, richTextStyle, globalTextStyle, opt, isNotNormal, isAttached, false, true);
      }
    }
  }
  if (richResult) {
    textStyle.rich = richResult;
  }
  var overflow = textStyleModel.get("overflow");
  if (overflow) {
    textStyle.overflow = overflow;
  }
  var margin = textStyleModel.get("minMargin");
  if (margin != null) {
    textStyle.margin = margin;
  }
  setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, true, false);
}
function getRichItemNames(textStyleModel) {
  var richItemNameMap;
  while (textStyleModel && textStyleModel !== textStyleModel.ecModel) {
    var rich = (textStyleModel.option || EMPTY_OBJ).rich;
    if (rich) {
      richItemNameMap = richItemNameMap || {};
      var richKeys = keys(rich);
      for (var i = 0; i < richKeys.length; i++) {
        var richKey = richKeys[i];
        richItemNameMap[richKey] = 1;
      }
    }
    textStyleModel = textStyleModel.parentModel;
  }
  return richItemNameMap;
}
var TEXT_PROPS_WITH_GLOBAL = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"];
var TEXT_PROPS_SELF = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"];
var TEXT_PROPS_BOX = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
function setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, isBlock, inRich) {
  globalTextStyle = !isNotNormal && globalTextStyle || EMPTY_OBJ;
  var inheritColor = opt && opt.inheritColor;
  var fillColor = textStyleModel.getShallow("color");
  var strokeColor = textStyleModel.getShallow("textBorderColor");
  var opacity = retrieve2(textStyleModel.getShallow("opacity"), globalTextStyle.opacity);
  if (fillColor === "inherit" || fillColor === "auto") {
    if (inheritColor) {
      fillColor = inheritColor;
    } else {
      fillColor = null;
    }
  }
  if (strokeColor === "inherit" || strokeColor === "auto") {
    if (inheritColor) {
      strokeColor = inheritColor;
    } else {
      strokeColor = null;
    }
  }
  if (!isAttached) {
    fillColor = fillColor || globalTextStyle.color;
    strokeColor = strokeColor || globalTextStyle.textBorderColor;
  }
  if (fillColor != null) {
    textStyle.fill = fillColor;
  }
  if (strokeColor != null) {
    textStyle.stroke = strokeColor;
  }
  var textBorderWidth = retrieve2(textStyleModel.getShallow("textBorderWidth"), globalTextStyle.textBorderWidth);
  if (textBorderWidth != null) {
    textStyle.lineWidth = textBorderWidth;
  }
  var textBorderType = retrieve2(textStyleModel.getShallow("textBorderType"), globalTextStyle.textBorderType);
  if (textBorderType != null) {
    textStyle.lineDash = textBorderType;
  }
  var textBorderDashOffset = retrieve2(textStyleModel.getShallow("textBorderDashOffset"), globalTextStyle.textBorderDashOffset);
  if (textBorderDashOffset != null) {
    textStyle.lineDashOffset = textBorderDashOffset;
  }
  if (!isNotNormal && opacity == null && !inRich) {
    opacity = opt && opt.defaultOpacity;
  }
  if (opacity != null) {
    textStyle.opacity = opacity;
  }
  if (!isNotNormal && !isAttached) {
    if (textStyle.fill == null && opt.inheritColor) {
      textStyle.fill = opt.inheritColor;
    }
  }
  for (var i = 0; i < TEXT_PROPS_WITH_GLOBAL.length; i++) {
    var key = TEXT_PROPS_WITH_GLOBAL[i];
    var val = retrieve2(textStyleModel.getShallow(key), globalTextStyle[key]);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  for (var i = 0; i < TEXT_PROPS_SELF.length; i++) {
    var key = TEXT_PROPS_SELF[i];
    var val = textStyleModel.getShallow(key);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  if (textStyle.verticalAlign == null) {
    var baseline = textStyleModel.getShallow("baseline");
    if (baseline != null) {
      textStyle.verticalAlign = baseline;
    }
  }
  if (!isBlock || !opt.disableBox) {
    for (var i = 0; i < TEXT_PROPS_BOX.length; i++) {
      var key = TEXT_PROPS_BOX[i];
      var val = textStyleModel.getShallow(key);
      if (val != null) {
        textStyle[key] = val;
      }
    }
    var borderType = textStyleModel.getShallow("borderType");
    if (borderType != null) {
      textStyle.borderDash = borderType;
    }
    if ((textStyle.backgroundColor === "auto" || textStyle.backgroundColor === "inherit") && inheritColor) {
      textStyle.backgroundColor = inheritColor;
    }
    if ((textStyle.borderColor === "auto" || textStyle.borderColor === "inherit") && inheritColor) {
      textStyle.borderColor = inheritColor;
    }
  }
}
function getFont(opt, ecModel) {
  var gTextStyleModel = ecModel && ecModel.getModel("textStyle");
  return trim$1([
    opt.fontStyle || gTextStyleModel && gTextStyleModel.getShallow("fontStyle") || "",
    opt.fontWeight || gTextStyleModel && gTextStyleModel.getShallow("fontWeight") || "",
    (opt.fontSize || gTextStyleModel && gTextStyleModel.getShallow("fontSize") || 12) + "px",
    opt.fontFamily || gTextStyleModel && gTextStyleModel.getShallow("fontFamily") || "sans-serif"
  ].join(" "));
}
var labelInner = makeInner();
function setLabelValueAnimation(label, labelStatesModels, value, getDefaultText) {
  if (!label) {
    return;
  }
  var obj = labelInner(label);
  obj.prevValue = obj.value;
  obj.value = value;
  var normalLabelModel = labelStatesModels.normal;
  obj.valueAnimation = normalLabelModel.get("valueAnimation");
  if (obj.valueAnimation) {
    obj.precision = normalLabelModel.get("precision");
    obj.defaultInterpolatedText = getDefaultText;
    obj.statesModels = labelStatesModels;
  }
}
function animateLabelValue(textEl, dataIndex, data2, animatableModel, labelFetcher) {
  var labelInnerStore = labelInner(textEl);
  if (!labelInnerStore.valueAnimation || labelInnerStore.prevValue === labelInnerStore.value) {
    return;
  }
  var defaultInterpolatedText = labelInnerStore.defaultInterpolatedText;
  var currValue = retrieve2(labelInnerStore.interpolatedValue, labelInnerStore.prevValue);
  var targetValue = labelInnerStore.value;
  function during(percent) {
    var interpolated = interpolateRawValues(data2, labelInnerStore.precision, currValue, targetValue, percent);
    labelInnerStore.interpolatedValue = percent === 1 ? null : interpolated;
    var labelText = getLabelText({
      labelDataIndex: dataIndex,
      labelFetcher,
      defaultText: defaultInterpolatedText ? defaultInterpolatedText(interpolated) : interpolated + ""
    }, labelInnerStore.statesModels, interpolated);
    setLabelText(textEl, labelText);
  }
  textEl.percent = 0;
  (labelInnerStore.prevValue == null ? initProps : updateProps$1)(textEl, {
    percent: 1
  }, animatableModel, dataIndex, null, during);
}
var PATH_COLOR = ["textStyle", "color"];
var textStyleParams = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"];
var tmpText = new ZRText$1();
var TextStyleMixin = function() {
  function TextStyleMixin2() {
  }
  TextStyleMixin2.prototype.getTextColor = function(isEmphasis) {
    var ecModel = this.ecModel;
    return this.getShallow("color") || (!isEmphasis && ecModel ? ecModel.get(PATH_COLOR) : null);
  };
  TextStyleMixin2.prototype.getFont = function() {
    return getFont({
      fontStyle: this.getShallow("fontStyle"),
      fontWeight: this.getShallow("fontWeight"),
      fontSize: this.getShallow("fontSize"),
      fontFamily: this.getShallow("fontFamily")
    }, this.ecModel);
  };
  TextStyleMixin2.prototype.getTextRect = function(text) {
    var style2 = {
      text,
      verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline")
    };
    for (var i = 0; i < textStyleParams.length; i++) {
      style2[textStyleParams[i]] = this.getShallow(textStyleParams[i]);
    }
    tmpText.useStyle(style2);
    tmpText.update();
    return tmpText.getBoundingRect();
  };
  return TextStyleMixin2;
}();
var TextStyleMixin$1 = TextStyleMixin;
var LINE_STYLE_KEY_MAP = [
  ["lineWidth", "width"],
  ["stroke", "color"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "type"],
  ["lineDashOffset", "dashOffset"],
  ["lineCap", "cap"],
  ["lineJoin", "join"],
  ["miterLimit"]
];
var getLineStyle = makeStyleMapper(LINE_STYLE_KEY_MAP);
var LineStyleMixin = function() {
  function LineStyleMixin2() {
  }
  LineStyleMixin2.prototype.getLineStyle = function(excludes) {
    return getLineStyle(this, excludes);
  };
  return LineStyleMixin2;
}();
var ITEM_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["stroke", "borderColor"],
  ["lineWidth", "borderWidth"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "borderType"],
  ["lineDashOffset", "borderDashOffset"],
  ["lineCap", "borderCap"],
  ["lineJoin", "borderJoin"],
  ["miterLimit", "borderMiterLimit"]
];
var getItemStyle = makeStyleMapper(ITEM_STYLE_KEY_MAP);
var ItemStyleMixin = function() {
  function ItemStyleMixin2() {
  }
  ItemStyleMixin2.prototype.getItemStyle = function(excludes, includes) {
    return getItemStyle(this, excludes, includes);
  };
  return ItemStyleMixin2;
}();
var Model = function() {
  function Model2(option, parentModel, ecModel) {
    this.parentModel = parentModel;
    this.ecModel = ecModel;
    this.option = option;
  }
  Model2.prototype.init = function(option, parentModel, ecModel) {
    var rest = [];
    for (var _i = 3; _i < arguments.length; _i++) {
      rest[_i - 3] = arguments[_i];
    }
  };
  Model2.prototype.mergeOption = function(option, ecModel) {
    merge$1(this.option, option, true);
  };
  Model2.prototype.get = function(path, ignoreParent) {
    if (path == null) {
      return this.option;
    }
    return this._doGet(this.parsePath(path), !ignoreParent && this.parentModel);
  };
  Model2.prototype.getShallow = function(key, ignoreParent) {
    var option = this.option;
    var val = option == null ? option : option[key];
    if (val == null && !ignoreParent) {
      var parentModel = this.parentModel;
      if (parentModel) {
        val = parentModel.getShallow(key);
      }
    }
    return val;
  };
  Model2.prototype.getModel = function(path, parentModel) {
    var hasPath = path != null;
    var pathFinal = hasPath ? this.parsePath(path) : null;
    var obj = hasPath ? this._doGet(pathFinal) : this.option;
    parentModel = parentModel || this.parentModel && this.parentModel.getModel(this.resolveParentPath(pathFinal));
    return new Model2(obj, parentModel, this.ecModel);
  };
  Model2.prototype.isEmpty = function() {
    return this.option == null;
  };
  Model2.prototype.restoreData = function() {
  };
  Model2.prototype.clone = function() {
    var Ctor = this.constructor;
    return new Ctor(clone$4(this.option));
  };
  Model2.prototype.parsePath = function(path) {
    if (typeof path === "string") {
      return path.split(".");
    }
    return path;
  };
  Model2.prototype.resolveParentPath = function(path) {
    return path;
  };
  Model2.prototype.isAnimationEnabled = function() {
    if (!env$1.node && this.option) {
      if (this.option.animation != null) {
        return !!this.option.animation;
      } else if (this.parentModel) {
        return this.parentModel.isAnimationEnabled();
      }
    }
  };
  Model2.prototype._doGet = function(pathArr, parentModel) {
    var obj = this.option;
    if (!pathArr) {
      return obj;
    }
    for (var i = 0; i < pathArr.length; i++) {
      if (!pathArr[i]) {
        continue;
      }
      obj = obj && typeof obj === "object" ? obj[pathArr[i]] : null;
      if (obj == null) {
        break;
      }
    }
    if (obj == null && parentModel) {
      obj = parentModel._doGet(this.resolveParentPath(pathArr), parentModel.parentModel);
    }
    return obj;
  };
  return Model2;
}();
enableClassExtend(Model);
enableClassCheck(Model);
mixin(Model, LineStyleMixin);
mixin(Model, ItemStyleMixin);
mixin(Model, AreaStyleMixin);
mixin(Model, TextStyleMixin$1);
var Model$1 = Model;
var base = Math.round(Math.random() * 10);
function getUID(type4) {
  return [type4 || "", base++].join("_");
}
function enableSubTypeDefaulter(target) {
  var subTypeDefaulters = {};
  target.registerSubTypeDefaulter = function(componentType, defaulter) {
    var componentTypeInfo = parseClassType(componentType);
    subTypeDefaulters[componentTypeInfo.main] = defaulter;
  };
  target.determineSubType = function(componentType, option) {
    var type4 = option.type;
    if (!type4) {
      var componentTypeMain = parseClassType(componentType).main;
      if (target.hasSubTypes(componentType) && subTypeDefaulters[componentTypeMain]) {
        type4 = subTypeDefaulters[componentTypeMain](option);
      }
    }
    return type4;
  };
}
function enableTopologicalTravel(entity, dependencyGetter) {
  entity.topologicalTravel = function(targetNameList, fullNameList, callback, context) {
    if (!targetNameList.length) {
      return;
    }
    var result = makeDepndencyGraph(fullNameList);
    var graph = result.graph;
    var noEntryList = result.noEntryList;
    var targetNameSet = {};
    each$g(targetNameList, function(name2) {
      targetNameSet[name2] = true;
    });
    while (noEntryList.length) {
      var currComponentType = noEntryList.pop();
      var currVertex = graph[currComponentType];
      var isInTargetNameSet = !!targetNameSet[currComponentType];
      if (isInTargetNameSet) {
        callback.call(context, currComponentType, currVertex.originalDeps.slice());
        delete targetNameSet[currComponentType];
      }
      each$g(currVertex.successor, isInTargetNameSet ? removeEdgeAndAdd : removeEdge);
    }
    each$g(targetNameSet, function() {
      var errMsg = "";
      throw new Error(errMsg);
    });
    function removeEdge(succComponentType) {
      graph[succComponentType].entryCount--;
      if (graph[succComponentType].entryCount === 0) {
        noEntryList.push(succComponentType);
      }
    }
    function removeEdgeAndAdd(succComponentType) {
      targetNameSet[succComponentType] = true;
      removeEdge(succComponentType);
    }
  };
  function makeDepndencyGraph(fullNameList) {
    var graph = {};
    var noEntryList = [];
    each$g(fullNameList, function(name2) {
      var thisItem = createDependencyGraphItem(graph, name2);
      var originalDeps = thisItem.originalDeps = dependencyGetter(name2);
      var availableDeps = getAvailableDependencies(originalDeps, fullNameList);
      thisItem.entryCount = availableDeps.length;
      if (thisItem.entryCount === 0) {
        noEntryList.push(name2);
      }
      each$g(availableDeps, function(dependentName) {
        if (indexOf(thisItem.predecessor, dependentName) < 0) {
          thisItem.predecessor.push(dependentName);
        }
        var thatItem = createDependencyGraphItem(graph, dependentName);
        if (indexOf(thatItem.successor, dependentName) < 0) {
          thatItem.successor.push(name2);
        }
      });
    });
    return {
      graph,
      noEntryList
    };
  }
  function createDependencyGraphItem(graph, name2) {
    if (!graph[name2]) {
      graph[name2] = {
        predecessor: [],
        successor: []
      };
    }
    return graph[name2];
  }
  function getAvailableDependencies(originalDeps, fullNameList) {
    var availableDeps = [];
    each$g(originalDeps, function(dep) {
      indexOf(fullNameList, dep) >= 0 && availableDeps.push(dep);
    });
    return availableDeps;
  }
}
function inheritDefaultOption(superOption, subOption) {
  return merge$1(merge$1({}, superOption, true), subOption, true);
}
var langEN = {
  time: {
    month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
    dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
  },
  legend: {
    selector: {
      all: "All",
      inverse: "Inv"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "Box Select",
        polygon: "Lasso Select",
        lineX: "Horizontally Select",
        lineY: "Vertically Select",
        keep: "Keep Selections",
        clear: "Clear Selections"
      }
    },
    dataView: {
      title: "Data View",
      lang: ["Data View", "Close", "Refresh"]
    },
    dataZoom: {
      title: {
        zoom: "Zoom",
        back: "Zoom Reset"
      }
    },
    magicType: {
      title: {
        line: "Switch to Line Chart",
        bar: "Switch to Bar Chart",
        stack: "Stack",
        tiled: "Tile"
      }
    },
    restore: {
      title: "Restore"
    },
    saveAsImage: {
      title: "Save as Image",
      lang: ["Right Click to Save Image"]
    }
  },
  series: {
    typeNames: {
      pie: "Pie chart",
      bar: "Bar chart",
      line: "Line chart",
      scatter: "Scatter plot",
      effectScatter: "Ripple scatter plot",
      radar: "Radar chart",
      tree: "Tree",
      treemap: "Treemap",
      boxplot: "Boxplot",
      candlestick: "Candlestick",
      k: "K line chart",
      heatmap: "Heat map",
      map: "Map",
      parallel: "Parallel coordinate map",
      lines: "Line graph",
      graph: "Relationship graph",
      sankey: "Sankey diagram",
      funnel: "Funnel chart",
      gauge: "Gauge",
      pictorialBar: "Pictorial bar",
      themeRiver: "Theme River Map",
      sunburst: "Sunburst"
    }
  },
  aria: {
    general: {
      withTitle: 'This is a chart about "{title}"',
      withoutTitle: "This is a chart"
    },
    series: {
      single: {
        prefix: "",
        withName: " with type {seriesType} named {seriesName}.",
        withoutName: " with type {seriesType}."
      },
      multiple: {
        prefix: ". It consists of {seriesCount} series count.",
        withName: " The {seriesId} series is a {seriesType} representing {seriesName}.",
        withoutName: " The {seriesId} series is a {seriesType}.",
        separator: {
          middle: "",
          end: ""
        }
      }
    },
    data: {
      allData: "The data is as follows: ",
      partialData: "The first {displayCnt} items are: ",
      withName: "the data for {name} is {value}",
      withoutName: "{value}",
      separator: {
        middle: ", ",
        end: ". "
      }
    }
  }
};
var langZH = {
  time: {
    month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"],
    monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"],
    dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"]
  },
  legend: {
    selector: {
      all: "\u5168\u9009",
      inverse: "\u53CD\u9009"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "\u77E9\u5F62\u9009\u62E9",
        polygon: "\u5708\u9009",
        lineX: "\u6A2A\u5411\u9009\u62E9",
        lineY: "\u7EB5\u5411\u9009\u62E9",
        keep: "\u4FDD\u6301\u9009\u62E9",
        clear: "\u6E05\u9664\u9009\u62E9"
      }
    },
    dataView: {
      title: "\u6570\u636E\u89C6\u56FE",
      lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"]
    },
    dataZoom: {
      title: {
        zoom: "\u533A\u57DF\u7F29\u653E",
        back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F"
      }
    },
    magicType: {
      title: {
        line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE",
        bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE",
        stack: "\u5207\u6362\u4E3A\u5806\u53E0",
        tiled: "\u5207\u6362\u4E3A\u5E73\u94FA"
      }
    },
    restore: {
      title: "\u8FD8\u539F"
    },
    saveAsImage: {
      title: "\u4FDD\u5B58\u4E3A\u56FE\u7247",
      lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"]
    }
  },
  series: {
    typeNames: {
      pie: "\u997C\u56FE",
      bar: "\u67F1\u72B6\u56FE",
      line: "\u6298\u7EBF\u56FE",
      scatter: "\u6563\u70B9\u56FE",
      effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE",
      radar: "\u96F7\u8FBE\u56FE",
      tree: "\u6811\u56FE",
      treemap: "\u77E9\u5F62\u6811\u56FE",
      boxplot: "\u7BB1\u578B\u56FE",
      candlestick: "K\u7EBF\u56FE",
      k: "K\u7EBF\u56FE",
      heatmap: "\u70ED\u529B\u56FE",
      map: "\u5730\u56FE",
      parallel: "\u5E73\u884C\u5750\u6807\u56FE",
      lines: "\u7EBF\u56FE",
      graph: "\u5173\u7CFB\u56FE",
      sankey: "\u6851\u57FA\u56FE",
      funnel: "\u6F0F\u6597\u56FE",
      gauge: "\u4EEA\u8868\u76D8\u56FE",
      pictorialBar: "\u8C61\u5F62\u67F1\u56FE",
      themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE",
      sunburst: "\u65ED\u65E5\u56FE"
    }
  },
  aria: {
    general: {
      withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002",
      withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C"
    },
    series: {
      single: {
        prefix: "",
        withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002",
        withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002"
      },
      multiple: {
        prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002",
        withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C",
        withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C",
        separator: {
          middle: "\uFF1B",
          end: "\u3002"
        }
      }
    },
    data: {
      allData: "\u5176\u6570\u636E\u662F\u2014\u2014",
      partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014",
      withName: "{name}\u7684\u6570\u636E\u662F{value}",
      withoutName: "{value}",
      separator: {
        middle: "\uFF0C",
        end: ""
      }
    }
  }
};
var LOCALE_ZH = "ZH";
var LOCALE_EN = "EN";
var DEFAULT_LOCALE = LOCALE_EN;
var localeStorage = {};
var localeModels = {};
var SYSTEM_LANG = !env$1.domSupported ? DEFAULT_LOCALE : function() {
  var langStr = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
  return langStr.indexOf(LOCALE_ZH) > -1 ? LOCALE_ZH : DEFAULT_LOCALE;
}();
function registerLocale(locale2, localeObj) {
  locale2 = locale2.toUpperCase();
  localeModels[locale2] = new Model$1(localeObj);
  localeStorage[locale2] = localeObj;
}
function createLocaleObject(locale2) {
  if (isString$1(locale2)) {
    var localeObj = localeStorage[locale2.toUpperCase()] || {};
    if (locale2 === LOCALE_ZH || locale2 === LOCALE_EN) {
      return clone$4(localeObj);
    } else {
      return merge$1(clone$4(localeObj), clone$4(localeStorage[DEFAULT_LOCALE]), false);
    }
  } else {
    return merge$1(clone$4(locale2), clone$4(localeStorage[DEFAULT_LOCALE]), false);
  }
}
function getLocaleModel(lang) {
  return localeModels[lang];
}
function getDefaultLocaleModel() {
  return localeModels[DEFAULT_LOCALE];
}
registerLocale(LOCALE_EN, langEN);
registerLocale(LOCALE_ZH, langZH);
var ONE_SECOND = 1e3;
var ONE_MINUTE = ONE_SECOND * 60;
var ONE_HOUR = ONE_MINUTE * 60;
var ONE_DAY = ONE_HOUR * 24;
var ONE_YEAR = ONE_DAY * 365;
var defaultLeveledFormatter = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
};
var fullDayFormatter = "{yyyy}-{MM}-{dd}";
var fullLeveledFormatter = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: fullDayFormatter,
  hour: fullDayFormatter + " " + defaultLeveledFormatter.hour,
  minute: fullDayFormatter + " " + defaultLeveledFormatter.minute,
  second: fullDayFormatter + " " + defaultLeveledFormatter.second,
  millisecond: defaultLeveledFormatter.none
};
var primaryTimeUnits = ["year", "month", "day", "hour", "minute", "second", "millisecond"];
var timeUnits = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function pad(str, len2) {
  str += "";
  return "0000".substr(0, len2 - str.length) + str;
}
function getPrimaryTimeUnit(timeUnit) {
  switch (timeUnit) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return timeUnit;
  }
}
function isPrimaryTimeUnit(timeUnit) {
  return timeUnit === getPrimaryTimeUnit(timeUnit);
}
function getDefaultFormatPrecisionOfInterval(timeUnit) {
  switch (timeUnit) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function format$1(time, template, isUTC, lang) {
  var date4 = parseDate(time);
  var y2 = date4[fullYearGetterName(isUTC)]();
  var M2 = date4[monthGetterName(isUTC)]() + 1;
  var q2 = Math.floor((M2 - 1) / 4) + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var e2 = date4["get" + (isUTC ? "UTC" : "") + "Day"]();
  var H2 = date4[hoursGetterName(isUTC)]();
  var h = (H2 - 1) % 12 + 1;
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S2 = date4[millisecondsGetterName(isUTC)]();
  var localeModel = lang instanceof Model$1 ? lang : getLocaleModel(lang || SYSTEM_LANG) || getDefaultLocaleModel();
  var timeModel = localeModel.getModel("time");
  var month = timeModel.get("month");
  var monthAbbr = timeModel.get("monthAbbr");
  var dayOfWeek = timeModel.get("dayOfWeek");
  var dayOfWeekAbbr = timeModel.get("dayOfWeekAbbr");
  return (template || "").replace(/{yyyy}/g, y2 + "").replace(/{yy}/g, y2 % 100 + "").replace(/{Q}/g, q2 + "").replace(/{MMMM}/g, month[M2 - 1]).replace(/{MMM}/g, monthAbbr[M2 - 1]).replace(/{MM}/g, pad(M2, 2)).replace(/{M}/g, M2 + "").replace(/{dd}/g, pad(d2, 2)).replace(/{d}/g, d2 + "").replace(/{eeee}/g, dayOfWeek[e2]).replace(/{ee}/g, dayOfWeekAbbr[e2]).replace(/{e}/g, e2 + "").replace(/{HH}/g, pad(H2, 2)).replace(/{H}/g, H2 + "").replace(/{hh}/g, pad(h + "", 2)).replace(/{h}/g, h + "").replace(/{mm}/g, pad(m2, 2)).replace(/{m}/g, m2 + "").replace(/{ss}/g, pad(s, 2)).replace(/{s}/g, s + "").replace(/{SSS}/g, pad(S2, 3)).replace(/{S}/g, S2 + "");
}
function leveledFormat(tick, idx, formatter, lang, isUTC) {
  var template = null;
  if (isString$1(formatter)) {
    template = formatter;
  } else if (isFunction$1(formatter)) {
    template = formatter(tick.value, idx, {
      level: tick.level
    });
  } else {
    var defaults$1 = extend({}, defaultLeveledFormatter);
    if (tick.level > 0) {
      for (var i = 0; i < primaryTimeUnits.length; ++i) {
        defaults$1[primaryTimeUnits[i]] = "{primary|" + defaults$1[primaryTimeUnits[i]] + "}";
      }
    }
    var mergedFormatter = formatter ? formatter.inherit === false ? formatter : defaults(formatter, defaults$1) : defaults$1;
    var unit = getUnitFromValue(tick.value, isUTC);
    if (mergedFormatter[unit]) {
      template = mergedFormatter[unit];
    } else if (mergedFormatter.inherit) {
      var targetId = timeUnits.indexOf(unit);
      for (var i = targetId - 1; i >= 0; --i) {
        if (mergedFormatter[unit]) {
          template = mergedFormatter[unit];
          break;
        }
      }
      template = template || defaults$1.none;
    }
    if (isArray$2(template)) {
      var levelId = tick.level == null ? 0 : tick.level >= 0 ? tick.level : template.length + tick.level;
      levelId = Math.min(levelId, template.length - 1);
      template = template[levelId];
    }
  }
  return format$1(new Date(tick.value), template, isUTC, lang);
}
function getUnitFromValue(value, isUTC) {
  var date4 = parseDate(value);
  var M2 = date4[monthGetterName(isUTC)]() + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var h = date4[hoursGetterName(isUTC)]();
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S2 = date4[millisecondsGetterName(isUTC)]();
  var isSecond = S2 === 0;
  var isMinute = isSecond && s === 0;
  var isHour = isMinute && m2 === 0;
  var isDay = isHour && h === 0;
  var isMonth = isDay && d2 === 1;
  var isYear = isMonth && M2 === 1;
  if (isYear) {
    return "year";
  } else if (isMonth) {
    return "month";
  } else if (isDay) {
    return "day";
  } else if (isHour) {
    return "hour";
  } else if (isMinute) {
    return "minute";
  } else if (isSecond) {
    return "second";
  } else {
    return "millisecond";
  }
}
function getUnitValue(value, unit, isUTC) {
  var date4 = isNumber(value) ? parseDate(value) : value;
  unit = unit || getUnitFromValue(value, isUTC);
  switch (unit) {
    case "year":
      return date4[fullYearGetterName(isUTC)]();
    case "half-year":
      return date4[monthGetterName(isUTC)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((date4[monthGetterName(isUTC)]() + 1) / 4);
    case "month":
      return date4[monthGetterName(isUTC)]();
    case "day":
      return date4[dateGetterName(isUTC)]();
    case "half-day":
      return date4[hoursGetterName(isUTC)]() / 24;
    case "hour":
      return date4[hoursGetterName(isUTC)]();
    case "minute":
      return date4[minutesGetterName(isUTC)]();
    case "second":
      return date4[secondsGetterName(isUTC)]();
    case "millisecond":
      return date4[millisecondsGetterName(isUTC)]();
  }
}
function fullYearGetterName(isUTC) {
  return isUTC ? "getUTCFullYear" : "getFullYear";
}
function monthGetterName(isUTC) {
  return isUTC ? "getUTCMonth" : "getMonth";
}
function dateGetterName(isUTC) {
  return isUTC ? "getUTCDate" : "getDate";
}
function hoursGetterName(isUTC) {
  return isUTC ? "getUTCHours" : "getHours";
}
function minutesGetterName(isUTC) {
  return isUTC ? "getUTCMinutes" : "getMinutes";
}
function secondsGetterName(isUTC) {
  return isUTC ? "getUTCSeconds" : "getSeconds";
}
function millisecondsGetterName(isUTC) {
  return isUTC ? "getUTCMilliseconds" : "getMilliseconds";
}
function fullYearSetterName(isUTC) {
  return isUTC ? "setUTCFullYear" : "setFullYear";
}
function monthSetterName(isUTC) {
  return isUTC ? "setUTCMonth" : "setMonth";
}
function dateSetterName(isUTC) {
  return isUTC ? "setUTCDate" : "setDate";
}
function hoursSetterName(isUTC) {
  return isUTC ? "setUTCHours" : "setHours";
}
function minutesSetterName(isUTC) {
  return isUTC ? "setUTCMinutes" : "setMinutes";
}
function secondsSetterName(isUTC) {
  return isUTC ? "setUTCSeconds" : "setSeconds";
}
function millisecondsSetterName(isUTC) {
  return isUTC ? "setUTCMilliseconds" : "setMilliseconds";
}
function addCommas(x2) {
  if (!isNumeric$1(x2)) {
    return isString$1(x2) ? x2 : "-";
  }
  var parts = (x2 + "").split(".");
  return parts[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (parts.length > 1 ? "." + parts[1] : "");
}
function toCamelCase(str, upperCaseFirst) {
  str = (str || "").toLowerCase().replace(/-(.)/g, function(match, group1) {
    return group1.toUpperCase();
  });
  if (upperCaseFirst && str) {
    str = str.charAt(0).toUpperCase() + str.slice(1);
  }
  return str;
}
var normalizeCssArray = normalizeCssArray$1;
var replaceReg = /([&<>"'])/g;
var replaceMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
};
function encodeHTML(source) {
  return source == null ? "" : (source + "").replace(replaceReg, function(str, c2) {
    return replaceMap[c2];
  });
}
function makeValueReadable(value, valueType, useUTC) {
  var USER_READABLE_DEFUALT_TIME_PATTERN = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
  function stringToUserReadable(str) {
    return str && trim$1(str) ? str : "-";
  }
  function isNumberUserReadable(num) {
    return !!(num != null && !isNaN(num) && isFinite(num));
  }
  var isTypeTime = valueType === "time";
  var isValueDate = value instanceof Date;
  if (isTypeTime || isValueDate) {
    var date4 = isTypeTime ? parseDate(value) : value;
    if (!isNaN(+date4)) {
      return format$1(date4, USER_READABLE_DEFUALT_TIME_PATTERN, useUTC);
    } else if (isValueDate) {
      return "-";
    }
  }
  if (valueType === "ordinal") {
    return isStringSafe(value) ? stringToUserReadable(value) : isNumber(value) ? isNumberUserReadable(value) ? value + "" : "-" : "-";
  }
  var numericResult = numericToNumber(value);
  return isNumberUserReadable(numericResult) ? addCommas(numericResult) : isStringSafe(value) ? stringToUserReadable(value) : typeof value === "boolean" ? value + "" : "-";
}
var TPL_VAR_ALIAS = ["a", "b", "c", "d", "e", "f", "g"];
var wrapVar = function(varName, seriesIdx) {
  return "{" + varName + (seriesIdx == null ? "" : seriesIdx) + "}";
};
function formatTpl(tpl, paramsList, encode) {
  if (!isArray$2(paramsList)) {
    paramsList = [paramsList];
  }
  var seriesLen = paramsList.length;
  if (!seriesLen) {
    return "";
  }
  var $vars = paramsList[0].$vars || [];
  for (var i = 0; i < $vars.length; i++) {
    var alias = TPL_VAR_ALIAS[i];
    tpl = tpl.replace(wrapVar(alias), wrapVar(alias, 0));
  }
  for (var seriesIdx = 0; seriesIdx < seriesLen; seriesIdx++) {
    for (var k2 = 0; k2 < $vars.length; k2++) {
      var val = paramsList[seriesIdx][$vars[k2]];
      tpl = tpl.replace(wrapVar(TPL_VAR_ALIAS[k2], seriesIdx), encode ? encodeHTML(val) : val);
    }
  }
  return tpl;
}
function formatTplSimple(tpl, param, encode) {
  each$g(param, function(value, key) {
    tpl = tpl.replace("{" + key + "}", encode ? encodeHTML(value) : value);
  });
  return tpl;
}
function getTooltipMarker(inOpt, extraCssText) {
  var opt = isString$1(inOpt) ? {
    color: inOpt,
    extraCssText
  } : inOpt || {};
  var color = opt.color;
  var type4 = opt.type;
  extraCssText = opt.extraCssText;
  var renderMode = opt.renderMode || "html";
  if (!color) {
    return "";
  }
  if (renderMode === "html") {
    return type4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>';
  } else {
    var markerId = opt.markerId || "markerX";
    return {
      renderMode,
      content: "{" + markerId + "|}  ",
      style: type4 === "subItem" ? {
        width: 4,
        height: 4,
        borderRadius: 2,
        backgroundColor: color
      } : {
        width: 10,
        height: 10,
        borderRadius: 5,
        backgroundColor: color
      }
    };
  }
}
function convertToColorString(color, defaultColor) {
  defaultColor = defaultColor || "transparent";
  return isString$1(color) ? color : isObject$6(color) ? color.colorStops && (color.colorStops[0] || {}).color || defaultColor : defaultColor;
}
function windowOpen(link, target) {
  if (target === "_blank" || target === "blank") {
    var blank = window.open();
    blank.opener = null;
    blank.location.href = link;
  } else {
    window.open(link, target);
  }
}
var each$f = each$g;
var LOCATION_PARAMS = ["left", "right", "top", "bottom", "width", "height"];
var HV_NAMES = [["width", "left", "right"], ["height", "top", "bottom"]];
function boxLayout(orient, group, gap, maxWidth, maxHeight) {
  var x2 = 0;
  var y2 = 0;
  if (maxWidth == null) {
    maxWidth = Infinity;
  }
  if (maxHeight == null) {
    maxHeight = Infinity;
  }
  var currentLineMaxSize = 0;
  group.eachChild(function(child, idx) {
    var rect = child.getBoundingRect();
    var nextChild = group.childAt(idx + 1);
    var nextChildRect = nextChild && nextChild.getBoundingRect();
    var nextX;
    var nextY;
    if (orient === "horizontal") {
      var moveX = rect.width + (nextChildRect ? -nextChildRect.x + rect.x : 0);
      nextX = x2 + moveX;
      if (nextX > maxWidth || child.newline) {
        x2 = 0;
        nextX = moveX;
        y2 += currentLineMaxSize + gap;
        currentLineMaxSize = rect.height;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.height);
      }
    } else {
      var moveY = rect.height + (nextChildRect ? -nextChildRect.y + rect.y : 0);
      nextY = y2 + moveY;
      if (nextY > maxHeight || child.newline) {
        x2 += currentLineMaxSize + gap;
        y2 = 0;
        nextY = moveY;
        currentLineMaxSize = rect.width;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.width);
      }
    }
    if (child.newline) {
      return;
    }
    child.x = x2;
    child.y = y2;
    child.markRedraw();
    orient === "horizontal" ? x2 = nextX + gap : y2 = nextY + gap;
  });
}
var box = boxLayout;
curry$3(boxLayout, "vertical");
curry$3(boxLayout, "horizontal");
function getAvailableSize(positionInfo, containerRect, margin) {
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var x2 = parsePercent(positionInfo.left, containerWidth);
  var y2 = parsePercent(positionInfo.top, containerHeight);
  var x22 = parsePercent(positionInfo.right, containerWidth);
  var y22 = parsePercent(positionInfo.bottom, containerHeight);
  (isNaN(x2) || isNaN(parseFloat(positionInfo.left))) && (x2 = 0);
  (isNaN(x22) || isNaN(parseFloat(positionInfo.right))) && (x22 = containerWidth);
  (isNaN(y2) || isNaN(parseFloat(positionInfo.top))) && (y2 = 0);
  (isNaN(y22) || isNaN(parseFloat(positionInfo.bottom))) && (y22 = containerHeight);
  margin = normalizeCssArray(margin || 0);
  return {
    width: Math.max(x22 - x2 - margin[1] - margin[3], 0),
    height: Math.max(y22 - y2 - margin[0] - margin[2], 0)
  };
}
function getLayoutRect(positionInfo, containerRect, margin) {
  margin = normalizeCssArray(margin || 0);
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var left = parsePercent(positionInfo.left, containerWidth);
  var top = parsePercent(positionInfo.top, containerHeight);
  var right = parsePercent(positionInfo.right, containerWidth);
  var bottom = parsePercent(positionInfo.bottom, containerHeight);
  var width = parsePercent(positionInfo.width, containerWidth);
  var height = parsePercent(positionInfo.height, containerHeight);
  var verticalMargin = margin[2] + margin[0];
  var horizontalMargin = margin[1] + margin[3];
  var aspect = positionInfo.aspect;
  if (isNaN(width)) {
    width = containerWidth - right - horizontalMargin - left;
  }
  if (isNaN(height)) {
    height = containerHeight - bottom - verticalMargin - top;
  }
  if (aspect != null) {
    if (isNaN(width) && isNaN(height)) {
      if (aspect > containerWidth / containerHeight) {
        width = containerWidth * 0.8;
      } else {
        height = containerHeight * 0.8;
      }
    }
    if (isNaN(width)) {
      width = aspect * height;
    }
    if (isNaN(height)) {
      height = width / aspect;
    }
  }
  if (isNaN(left)) {
    left = containerWidth - right - width - horizontalMargin;
  }
  if (isNaN(top)) {
    top = containerHeight - bottom - height - verticalMargin;
  }
  switch (positionInfo.left || positionInfo.right) {
    case "center":
      left = containerWidth / 2 - width / 2 - margin[3];
      break;
    case "right":
      left = containerWidth - width - horizontalMargin;
      break;
  }
  switch (positionInfo.top || positionInfo.bottom) {
    case "middle":
    case "center":
      top = containerHeight / 2 - height / 2 - margin[0];
      break;
    case "bottom":
      top = containerHeight - height - verticalMargin;
      break;
  }
  left = left || 0;
  top = top || 0;
  if (isNaN(width)) {
    width = containerWidth - horizontalMargin - left - (right || 0);
  }
  if (isNaN(height)) {
    height = containerHeight - verticalMargin - top - (bottom || 0);
  }
  var rect = new BoundingRect$1(left + margin[3], top + margin[0], width, height);
  rect.margin = margin;
  return rect;
}
function positionElement(el, positionInfo, containerRect, margin, opt, out2) {
  var h = !opt || !opt.hv || opt.hv[0];
  var v4 = !opt || !opt.hv || opt.hv[1];
  var boundingMode = opt && opt.boundingMode || "all";
  out2 = out2 || el;
  out2.x = el.x;
  out2.y = el.y;
  if (!h && !v4) {
    return false;
  }
  var rect;
  if (boundingMode === "raw") {
    rect = el.type === "group" ? new BoundingRect$1(0, 0, +positionInfo.width || 0, +positionInfo.height || 0) : el.getBoundingRect();
  } else {
    rect = el.getBoundingRect();
    if (el.needLocalTransform()) {
      var transform2 = el.getLocalTransform();
      rect = rect.clone();
      rect.applyTransform(transform2);
    }
  }
  var layoutRect = getLayoutRect(defaults({
    width: rect.width,
    height: rect.height
  }, positionInfo), containerRect, margin);
  var dx = h ? layoutRect.x - rect.x : 0;
  var dy = v4 ? layoutRect.y - rect.y : 0;
  if (boundingMode === "raw") {
    out2.x = dx;
    out2.y = dy;
  } else {
    out2.x += dx;
    out2.y += dy;
  }
  if (out2 === el) {
    el.markRedraw();
  }
  return true;
}
function sizeCalculable(option, hvIdx) {
  return option[HV_NAMES[hvIdx][0]] != null || option[HV_NAMES[hvIdx][1]] != null && option[HV_NAMES[hvIdx][2]] != null;
}
function fetchLayoutMode(ins) {
  var layoutMode = ins.layoutMode || ins.constructor.layoutMode;
  return isObject$6(layoutMode) ? layoutMode : layoutMode ? {
    type: layoutMode
  } : null;
}
function mergeLayoutParam(targetOption, newOption, opt) {
  var ignoreSize = opt && opt.ignoreSize;
  !isArray$2(ignoreSize) && (ignoreSize = [ignoreSize, ignoreSize]);
  var hResult = merge3(HV_NAMES[0], 0);
  var vResult = merge3(HV_NAMES[1], 1);
  copy2(HV_NAMES[0], targetOption, hResult);
  copy2(HV_NAMES[1], targetOption, vResult);
  function merge3(names2, hvIdx) {
    var newParams = {};
    var newValueCount = 0;
    var merged = {};
    var mergedValueCount = 0;
    var enoughParamNumber = 2;
    each$f(names2, function(name2) {
      merged[name2] = targetOption[name2];
    });
    each$f(names2, function(name2) {
      hasProp(newOption, name2) && (newParams[name2] = merged[name2] = newOption[name2]);
      hasValue(newParams, name2) && newValueCount++;
      hasValue(merged, name2) && mergedValueCount++;
    });
    if (ignoreSize[hvIdx]) {
      if (hasValue(newOption, names2[1])) {
        merged[names2[2]] = null;
      } else if (hasValue(newOption, names2[2])) {
        merged[names2[1]] = null;
      }
      return merged;
    }
    if (mergedValueCount === enoughParamNumber || !newValueCount) {
      return merged;
    } else if (newValueCount >= enoughParamNumber) {
      return newParams;
    } else {
      for (var i = 0; i < names2.length; i++) {
        var name_1 = names2[i];
        if (!hasProp(newParams, name_1) && hasProp(targetOption, name_1)) {
          newParams[name_1] = targetOption[name_1];
          break;
        }
      }
      return newParams;
    }
  }
  function hasProp(obj, name2) {
    return obj.hasOwnProperty(name2);
  }
  function hasValue(obj, name2) {
    return obj[name2] != null && obj[name2] !== "auto";
  }
  function copy2(names2, target, source) {
    each$f(names2, function(name2) {
      target[name2] = source[name2];
    });
  }
}
function getLayoutParams(source) {
  return copyLayoutParams({}, source);
}
function copyLayoutParams(target, source) {
  source && target && each$f(LOCATION_PARAMS, function(name2) {
    source.hasOwnProperty(name2) && (target[name2] = source[name2]);
  });
  return target;
}
var inner$l = makeInner();
var ComponentModel = function(_super) {
  __extends(ComponentModel2, _super);
  function ComponentModel2(option, parentModel, ecModel) {
    var _this = _super.call(this, option, parentModel, ecModel) || this;
    _this.uid = getUID("ec_cpt_model");
    return _this;
  }
  ComponentModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  ComponentModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeModel = ecModel.getTheme();
    merge$1(option, themeModel.get(this.mainType));
    merge$1(option, this.getDefaultOption());
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  ComponentModel2.prototype.mergeOption = function(option, ecModel) {
    merge$1(this.option, option, true);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, option, layoutMode);
    }
  };
  ComponentModel2.prototype.optionUpdated = function(newCptOption, isInit) {
  };
  ComponentModel2.prototype.getDefaultOption = function() {
    var ctor = this.constructor;
    if (!isExtendedClass(ctor)) {
      return ctor.defaultOption;
    }
    var fields = inner$l(this);
    if (!fields.defaultOption) {
      var optList = [];
      var clz = ctor;
      while (clz) {
        var opt = clz.prototype.defaultOption;
        opt && optList.push(opt);
        clz = clz.superClass;
      }
      var defaultOption2 = {};
      for (var i = optList.length - 1; i >= 0; i--) {
        defaultOption2 = merge$1(defaultOption2, optList[i], true);
      }
      fields.defaultOption = defaultOption2;
    }
    return fields.defaultOption;
  };
  ComponentModel2.prototype.getReferringComponents = function(mainType, opt) {
    var indexKey = mainType + "Index";
    var idKey = mainType + "Id";
    return queryReferringComponents(this.ecModel, mainType, {
      index: this.get(indexKey, true),
      id: this.get(idKey, true)
    }, opt);
  };
  ComponentModel2.prototype.getBoxLayoutParams = function() {
    var boxLayoutModel = this;
    return {
      left: boxLayoutModel.get("left"),
      top: boxLayoutModel.get("top"),
      right: boxLayoutModel.get("right"),
      bottom: boxLayoutModel.get("bottom"),
      width: boxLayoutModel.get("width"),
      height: boxLayoutModel.get("height")
    };
  };
  ComponentModel2.prototype.getZLevelKey = function() {
    return "";
  };
  ComponentModel2.prototype.setZLevel = function(zlevel) {
    this.option.zlevel = zlevel;
  };
  ComponentModel2.protoInitialize = function() {
    var proto2 = ComponentModel2.prototype;
    proto2.type = "component";
    proto2.id = "";
    proto2.name = "";
    proto2.mainType = "";
    proto2.subType = "";
    proto2.componentIndex = 0;
  }();
  return ComponentModel2;
}(Model$1);
mountExtend(ComponentModel, Model$1);
enableClassManagement(ComponentModel);
enableSubTypeDefaulter(ComponentModel);
enableTopologicalTravel(ComponentModel, getDependencies);
function getDependencies(componentType) {
  var deps = [];
  each$g(ComponentModel.getClassesByMainType(componentType), function(clz) {
    deps = deps.concat(clz.dependencies || clz.prototype.dependencies || []);
  });
  deps = map$1(deps, function(type4) {
    return parseClassType(type4).main;
  });
  if (componentType !== "dataset" && indexOf(deps, "dataset") <= 0) {
    deps.unshift("dataset");
  }
  return deps;
}
var ComponentModel$1 = ComponentModel;
var platform = "";
if (typeof navigator !== "undefined") {
  platform = navigator.platform || "";
}
var decalColor = "rgba(0, 0, 0, 0.2)";
var globalDefault = {
  darkMode: "auto",
  colorBy: "series",
  color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"],
  gradientColor: ["#f6efa6", "#d88273", "#bf444c"],
  aria: {
    decal: {
      decals: [{
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [2, 5],
        symbolSize: 1,
        rotation: Math.PI / 6
      }, {
        color: decalColor,
        symbol: "circle",
        dashArrayX: [[8, 8], [0, 8, 8, 0]],
        dashArrayY: [6, 0],
        symbolSize: 0.8
      }, {
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [4, 3],
        rotation: -Math.PI / 4
      }, {
        color: decalColor,
        dashArrayX: [[6, 6], [0, 6, 6, 0]],
        dashArrayY: [6, 0]
      }, {
        color: decalColor,
        dashArrayX: [[1, 0], [1, 6]],
        dashArrayY: [1, 0, 6, 0],
        rotation: Math.PI / 4
      }, {
        color: decalColor,
        symbol: "triangle",
        dashArrayX: [[9, 9], [0, 9, 9, 0]],
        dashArrayY: [7, 2],
        symbolSize: 0.75
      }]
    }
  },
  textStyle: {
    fontFamily: platform.match(/^Win/) ? "Microsoft YaHei" : "sans-serif",
    fontSize: 12,
    fontStyle: "normal",
    fontWeight: "normal"
  },
  blendMode: null,
  stateAnimation: {
    duration: 300,
    easing: "cubicOut"
  },
  animation: "auto",
  animationDuration: 1e3,
  animationDurationUpdate: 500,
  animationEasing: "cubicInOut",
  animationEasingUpdate: "cubicInOut",
  animationThreshold: 2e3,
  progressiveThreshold: 3e3,
  progressive: 400,
  hoverLayerThreshold: 3e3,
  useUTC: false
};
var VISUAL_DIMENSIONS = createHashMap(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]);
var SOURCE_FORMAT_ORIGINAL = "original";
var SOURCE_FORMAT_ARRAY_ROWS = "arrayRows";
var SOURCE_FORMAT_OBJECT_ROWS = "objectRows";
var SOURCE_FORMAT_KEYED_COLUMNS = "keyedColumns";
var SOURCE_FORMAT_TYPED_ARRAY = "typedArray";
var SOURCE_FORMAT_UNKNOWN = "unknown";
var SERIES_LAYOUT_BY_COLUMN = "column";
var SERIES_LAYOUT_BY_ROW = "row";
var BE_ORDINAL = {
  Must: 1,
  Might: 2,
  Not: 3
};
var innerGlobalModel = makeInner();
function resetSourceDefaulter(ecModel) {
  innerGlobalModel(ecModel).datasetMap = createHashMap();
}
function makeSeriesEncodeForAxisCoordSys(coordDimensions, seriesModel, source) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel || !coordDimensions) {
    return encode;
  }
  var encodeItemName = [];
  var encodeSeriesName = [];
  var ecModel = seriesModel.ecModel;
  var datasetMap = innerGlobalModel(ecModel).datasetMap;
  var key = datasetModel.uid + "_" + source.seriesLayoutBy;
  var baseCategoryDimIndex;
  var categoryWayValueDimStart;
  coordDimensions = coordDimensions.slice();
  each$g(coordDimensions, function(coordDimInfoLoose, coordDimIdx) {
    var coordDimInfo = isObject$6(coordDimInfoLoose) ? coordDimInfoLoose : coordDimensions[coordDimIdx] = {
      name: coordDimInfoLoose
    };
    if (coordDimInfo.type === "ordinal" && baseCategoryDimIndex == null) {
      baseCategoryDimIndex = coordDimIdx;
      categoryWayValueDimStart = getDataDimCountOnCoordDim(coordDimInfo);
    }
    encode[coordDimInfo.name] = [];
  });
  var datasetRecord = datasetMap.get(key) || datasetMap.set(key, {
    categoryWayDim: categoryWayValueDimStart,
    valueWayDim: 0
  });
  each$g(coordDimensions, function(coordDimInfo, coordDimIdx) {
    var coordDimName = coordDimInfo.name;
    var count2 = getDataDimCountOnCoordDim(coordDimInfo);
    if (baseCategoryDimIndex == null) {
      var start2 = datasetRecord.valueWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.valueWayDim += count2;
    } else if (baseCategoryDimIndex === coordDimIdx) {
      pushDim(encode[coordDimName], 0, count2);
      pushDim(encodeItemName, 0, count2);
    } else {
      var start2 = datasetRecord.categoryWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.categoryWayDim += count2;
    }
  });
  function pushDim(dimIdxArr, idxFrom, idxCount) {
    for (var i = 0; i < idxCount; i++) {
      dimIdxArr.push(idxFrom + i);
    }
  }
  function getDataDimCountOnCoordDim(coordDimInfo) {
    var dimsDef = coordDimInfo.dimsDef;
    return dimsDef ? dimsDef.length : 1;
  }
  encodeItemName.length && (encode.itemName = encodeItemName);
  encodeSeriesName.length && (encode.seriesName = encodeSeriesName);
  return encode;
}
function makeSeriesEncodeForNameBased(seriesModel, source, dimCount) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel) {
    return encode;
  }
  var sourceFormat = source.sourceFormat;
  var dimensionsDefine = source.dimensionsDefine;
  var potentialNameDimIndex;
  if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    each$g(dimensionsDefine, function(dim, idx) {
      if ((isObject$6(dim) ? dim.name : dim) === "name") {
        potentialNameDimIndex = idx;
      }
    });
  }
  var idxResult = function() {
    var idxRes0 = {};
    var idxRes1 = {};
    var guessRecords = [];
    for (var i = 0, len2 = Math.min(5, dimCount); i < len2; i++) {
      var guessResult = doGuessOrdinal(source.data, sourceFormat, source.seriesLayoutBy, dimensionsDefine, source.startIndex, i);
      guessRecords.push(guessResult);
      var isPureNumber = guessResult === BE_ORDINAL.Not;
      if (isPureNumber && idxRes0.v == null && i !== potentialNameDimIndex) {
        idxRes0.v = i;
      }
      if (idxRes0.n == null || idxRes0.n === idxRes0.v || !isPureNumber && guessRecords[idxRes0.n] === BE_ORDINAL.Not) {
        idxRes0.n = i;
      }
      if (fulfilled(idxRes0) && guessRecords[idxRes0.n] !== BE_ORDINAL.Not) {
        return idxRes0;
      }
      if (!isPureNumber) {
        if (guessResult === BE_ORDINAL.Might && idxRes1.v == null && i !== potentialNameDimIndex) {
          idxRes1.v = i;
        }
        if (idxRes1.n == null || idxRes1.n === idxRes1.v) {
          idxRes1.n = i;
        }
      }
    }
    function fulfilled(idxResult2) {
      return idxResult2.v != null && idxResult2.n != null;
    }
    return fulfilled(idxRes0) ? idxRes0 : fulfilled(idxRes1) ? idxRes1 : null;
  }();
  if (idxResult) {
    encode.value = [idxResult.v];
    var nameDimIndex = potentialNameDimIndex != null ? potentialNameDimIndex : idxResult.n;
    encode.itemName = [nameDimIndex];
    encode.seriesName = [nameDimIndex];
  }
  return encode;
}
function querySeriesUpstreamDatasetModel(seriesModel) {
  var thisData = seriesModel.get("data", true);
  if (!thisData) {
    return queryReferringComponents(seriesModel.ecModel, "dataset", {
      index: seriesModel.get("datasetIndex", true),
      id: seriesModel.get("datasetId", true)
    }, SINGLE_REFERRING).models[0];
  }
}
function queryDatasetUpstreamDatasetModels(datasetModel) {
  if (!datasetModel.get("transform", true) && !datasetModel.get("fromTransformResult", true)) {
    return [];
  }
  return queryReferringComponents(datasetModel.ecModel, "dataset", {
    index: datasetModel.get("fromDatasetIndex", true),
    id: datasetModel.get("fromDatasetId", true)
  }, SINGLE_REFERRING).models;
}
function guessOrdinal(source, dimIndex) {
  return doGuessOrdinal(source.data, source.sourceFormat, source.seriesLayoutBy, source.dimensionsDefine, source.startIndex, dimIndex);
}
function doGuessOrdinal(data2, sourceFormat, seriesLayoutBy, dimensionsDefine, startIndex, dimIndex) {
  var result;
  var maxLoop = 5;
  if (isTypedArray(data2)) {
    return BE_ORDINAL.Not;
  }
  var dimName;
  var dimType;
  if (dimensionsDefine) {
    var dimDefItem = dimensionsDefine[dimIndex];
    if (isObject$6(dimDefItem)) {
      dimName = dimDefItem.name;
      dimType = dimDefItem.type;
    } else if (isString$1(dimDefItem)) {
      dimName = dimDefItem;
    }
  }
  if (dimType != null) {
    return dimType === "ordinal" ? BE_ORDINAL.Must : BE_ORDINAL.Not;
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data2;
    if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
      var sample = dataArrayRows[dimIndex];
      for (var i = 0; i < (sample || []).length && i < maxLoop; i++) {
        if ((result = detectValue(sample[startIndex + i])) != null) {
          return result;
        }
      }
    } else {
      for (var i = 0; i < dataArrayRows.length && i < maxLoop; i++) {
        var row = dataArrayRows[startIndex + i];
        if (row && (result = detectValue(row[dimIndex])) != null) {
          return result;
        }
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var dataObjectRows = data2;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < dataObjectRows.length && i < maxLoop; i++) {
      var item = dataObjectRows[i];
      if (item && (result = detectValue(item[dimName])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    var dataKeyedColumns = data2;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    var sample = dataKeyedColumns[dimName];
    if (!sample || isTypedArray(sample)) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < sample.length && i < maxLoop; i++) {
      if ((result = detectValue(sample[i])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var dataOriginal = data2;
    for (var i = 0; i < dataOriginal.length && i < maxLoop; i++) {
      var item = dataOriginal[i];
      var val = getDataItemValue(item);
      if (!isArray$2(val)) {
        return BE_ORDINAL.Not;
      }
      if ((result = detectValue(val[dimIndex])) != null) {
        return result;
      }
    }
  }
  function detectValue(val2) {
    var beStr = isString$1(val2);
    if (val2 != null && isFinite(val2) && val2 !== "") {
      return beStr ? BE_ORDINAL.Might : BE_ORDINAL.Not;
    } else if (beStr && val2 !== "-") {
      return BE_ORDINAL.Must;
    }
  }
  return BE_ORDINAL.Not;
}
var internalOptionCreatorMap = createHashMap();
function registerInternalOptionCreator(mainType, creator) {
  assert(internalOptionCreatorMap.get(mainType) == null && creator);
  internalOptionCreatorMap.set(mainType, creator);
}
function concatInternalOptions(ecModel, mainType, newCmptOptionList) {
  var internalOptionCreator = internalOptionCreatorMap.get(mainType);
  if (!internalOptionCreator) {
    return newCmptOptionList;
  }
  var internalOptions = internalOptionCreator(ecModel);
  if (!internalOptions) {
    return newCmptOptionList;
  }
  return newCmptOptionList.concat(internalOptions);
}
var innerColor = makeInner();
var innerDecal = makeInner();
var PaletteMixin = function() {
  function PaletteMixin2() {
  }
  PaletteMixin2.prototype.getColorFromPalette = function(name2, scope, requestNum) {
    var defaultPalette = normalizeToArray(this.get("color", true));
    var layeredPalette = this.get("colorLayer", true);
    return getFromPalette(this, innerColor, defaultPalette, layeredPalette, name2, scope, requestNum);
  };
  PaletteMixin2.prototype.clearColorPalette = function() {
    clearPalette(this, innerColor);
  };
  return PaletteMixin2;
}();
function getDecalFromPalette(ecModel, name2, scope, requestNum) {
  var defaultDecals = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  return getFromPalette(ecModel, innerDecal, defaultDecals, null, name2, scope, requestNum);
}
function getNearestPalette(palettes, requestColorNum) {
  var paletteNum = palettes.length;
  for (var i = 0; i < paletteNum; i++) {
    if (palettes[i].length > requestColorNum) {
      return palettes[i];
    }
  }
  return palettes[paletteNum - 1];
}
function getFromPalette(that, inner2, defaultPalette, layeredPalette, name2, scope, requestNum) {
  scope = scope || that;
  var scopeFields = inner2(scope);
  var paletteIdx = scopeFields.paletteIdx || 0;
  var paletteNameMap = scopeFields.paletteNameMap = scopeFields.paletteNameMap || {};
  if (paletteNameMap.hasOwnProperty(name2)) {
    return paletteNameMap[name2];
  }
  var palette = requestNum == null || !layeredPalette ? defaultPalette : getNearestPalette(layeredPalette, requestNum);
  palette = palette || defaultPalette;
  if (!palette || !palette.length) {
    return;
  }
  var pickedPaletteItem = palette[paletteIdx];
  if (name2) {
    paletteNameMap[name2] = pickedPaletteItem;
  }
  scopeFields.paletteIdx = (paletteIdx + 1) % palette.length;
  return pickedPaletteItem;
}
function clearPalette(that, inner2) {
  inner2(that).paletteIdx = 0;
  inner2(that).paletteNameMap = {};
}
var reCreateSeriesIndices;
var assertSeriesInitialized;
var initBase;
var OPTION_INNER_KEY = "\0_ec_inner";
var OPTION_INNER_VALUE = 1;
var GlobalModel = function(_super) {
  __extends(GlobalModel2, _super);
  function GlobalModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GlobalModel2.prototype.init = function(option, parentModel, ecModel, theme2, locale2, optionManager) {
    theme2 = theme2 || {};
    this.option = null;
    this._theme = new Model$1(theme2);
    this._locale = new Model$1(locale2);
    this._optionManager = optionManager;
  };
  GlobalModel2.prototype.setOption = function(option, opts, optionPreprocessorFuncs2) {
    var innerOpt = normalizeSetOptionInput(opts);
    this._optionManager.setOption(option, optionPreprocessorFuncs2, innerOpt);
    this._resetOption(null, innerOpt);
  };
  GlobalModel2.prototype.resetOption = function(type4, opt) {
    return this._resetOption(type4, normalizeSetOptionInput(opt));
  };
  GlobalModel2.prototype._resetOption = function(type4, opt) {
    var optionChanged = false;
    var optionManager = this._optionManager;
    if (!type4 || type4 === "recreate") {
      var baseOption = optionManager.mountOption(type4 === "recreate");
      if (!this.option || type4 === "recreate") {
        initBase(this, baseOption);
      } else {
        this.restoreData();
        this._mergeOption(baseOption, opt);
      }
      optionChanged = true;
    }
    if (type4 === "timeline" || type4 === "media") {
      this.restoreData();
    }
    if (!type4 || type4 === "recreate" || type4 === "timeline") {
      var timelineOption = optionManager.getTimelineOption(this);
      if (timelineOption) {
        optionChanged = true;
        this._mergeOption(timelineOption, opt);
      }
    }
    if (!type4 || type4 === "recreate" || type4 === "media") {
      var mediaOptions = optionManager.getMediaOption(this);
      if (mediaOptions.length) {
        each$g(mediaOptions, function(mediaOption) {
          optionChanged = true;
          this._mergeOption(mediaOption, opt);
        }, this);
      }
    }
    return optionChanged;
  };
  GlobalModel2.prototype.mergeOption = function(option) {
    this._mergeOption(option, null);
  };
  GlobalModel2.prototype._mergeOption = function(newOption, opt) {
    var option = this.option;
    var componentsMap = this._componentsMap;
    var componentsCount = this._componentsCount;
    var newCmptTypes = [];
    var newCmptTypeMap = createHashMap();
    var replaceMergeMainTypeMap = opt && opt.replaceMergeMainTypeMap;
    resetSourceDefaulter(this);
    each$g(newOption, function(componentOption, mainType) {
      if (componentOption == null) {
        return;
      }
      if (!ComponentModel$1.hasClass(mainType)) {
        option[mainType] = option[mainType] == null ? clone$4(componentOption) : merge$1(option[mainType], componentOption, true);
      } else if (mainType) {
        newCmptTypes.push(mainType);
        newCmptTypeMap.set(mainType, true);
      }
    });
    if (replaceMergeMainTypeMap) {
      replaceMergeMainTypeMap.each(function(val, mainTypeInReplaceMerge) {
        if (ComponentModel$1.hasClass(mainTypeInReplaceMerge) && !newCmptTypeMap.get(mainTypeInReplaceMerge)) {
          newCmptTypes.push(mainTypeInReplaceMerge);
          newCmptTypeMap.set(mainTypeInReplaceMerge, true);
        }
      });
    }
    ComponentModel$1.topologicalTravel(newCmptTypes, ComponentModel$1.getAllClassMainTypes(), visitComponent, this);
    function visitComponent(mainType) {
      var newCmptOptionList = concatInternalOptions(this, mainType, normalizeToArray(newOption[mainType]));
      var oldCmptList = componentsMap.get(mainType);
      var mergeMode = !oldCmptList ? "replaceAll" : replaceMergeMainTypeMap && replaceMergeMainTypeMap.get(mainType) ? "replaceMerge" : "normalMerge";
      var mappingResult = mappingToExists(oldCmptList, newCmptOptionList, mergeMode);
      setComponentTypeToKeyInfo(mappingResult, mainType, ComponentModel$1);
      option[mainType] = null;
      componentsMap.set(mainType, null);
      componentsCount.set(mainType, 0);
      var optionsByMainType = [];
      var cmptsByMainType = [];
      var cmptsCountByMainType = 0;
      var tooltipExists;
      each$g(mappingResult, function(resultItem, index2) {
        var componentModel = resultItem.existing;
        var newCmptOption = resultItem.newOption;
        if (!newCmptOption) {
          if (componentModel) {
            componentModel.mergeOption({}, this);
            componentModel.optionUpdated({}, false);
          }
        } else {
          var isSeriesType = mainType === "series";
          var ComponentModelClass = ComponentModel$1.getClass(mainType, resultItem.keyInfo.subType, !isSeriesType);
          if (!ComponentModelClass) {
            return;
          }
          if (mainType === "tooltip") {
            if (tooltipExists) {
              return;
            }
            tooltipExists = true;
          }
          if (componentModel && componentModel.constructor === ComponentModelClass) {
            componentModel.name = resultItem.keyInfo.name;
            componentModel.mergeOption(newCmptOption, this);
            componentModel.optionUpdated(newCmptOption, false);
          } else {
            var extraOpt = extend({
              componentIndex: index2
            }, resultItem.keyInfo);
            componentModel = new ComponentModelClass(newCmptOption, this, this, extraOpt);
            extend(componentModel, extraOpt);
            if (resultItem.brandNew) {
              componentModel.__requireNewView = true;
            }
            componentModel.init(newCmptOption, this, this);
            componentModel.optionUpdated(null, true);
          }
        }
        if (componentModel) {
          optionsByMainType.push(componentModel.option);
          cmptsByMainType.push(componentModel);
          cmptsCountByMainType++;
        } else {
          optionsByMainType.push(void 0);
          cmptsByMainType.push(void 0);
        }
      }, this);
      option[mainType] = optionsByMainType;
      componentsMap.set(mainType, cmptsByMainType);
      componentsCount.set(mainType, cmptsCountByMainType);
      if (mainType === "series") {
        reCreateSeriesIndices(this);
      }
    }
    if (!this._seriesIndices) {
      reCreateSeriesIndices(this);
    }
  };
  GlobalModel2.prototype.getOption = function() {
    var option = clone$4(this.option);
    each$g(option, function(optInMainType, mainType) {
      if (ComponentModel$1.hasClass(mainType)) {
        var opts = normalizeToArray(optInMainType);
        var realLen = opts.length;
        var metNonInner = false;
        for (var i = realLen - 1; i >= 0; i--) {
          if (opts[i] && !isComponentIdInternal(opts[i])) {
            metNonInner = true;
          } else {
            opts[i] = null;
            !metNonInner && realLen--;
          }
        }
        opts.length = realLen;
        option[mainType] = opts;
      }
    });
    delete option[OPTION_INNER_KEY];
    return option;
  };
  GlobalModel2.prototype.getTheme = function() {
    return this._theme;
  };
  GlobalModel2.prototype.getLocaleModel = function() {
    return this._locale;
  };
  GlobalModel2.prototype.setUpdatePayload = function(payload) {
    this._payload = payload;
  };
  GlobalModel2.prototype.getUpdatePayload = function() {
    return this._payload;
  };
  GlobalModel2.prototype.getComponent = function(mainType, idx) {
    var list = this._componentsMap.get(mainType);
    if (list) {
      var cmpt = list[idx || 0];
      if (cmpt) {
        return cmpt;
      } else if (idx == null) {
        for (var i = 0; i < list.length; i++) {
          if (list[i]) {
            return list[i];
          }
        }
      }
    }
  };
  GlobalModel2.prototype.queryComponents = function(condition) {
    var mainType = condition.mainType;
    if (!mainType) {
      return [];
    }
    var index2 = condition.index;
    var id2 = condition.id;
    var name2 = condition.name;
    var cmpts = this._componentsMap.get(mainType);
    if (!cmpts || !cmpts.length) {
      return [];
    }
    var result;
    if (index2 != null) {
      result = [];
      each$g(normalizeToArray(index2), function(idx) {
        cmpts[idx] && result.push(cmpts[idx]);
      });
    } else if (id2 != null) {
      result = queryByIdOrName("id", id2, cmpts);
    } else if (name2 != null) {
      result = queryByIdOrName("name", name2, cmpts);
    } else {
      result = filter(cmpts, function(cmpt) {
        return !!cmpt;
      });
    }
    return filterBySubType(result, condition);
  };
  GlobalModel2.prototype.findComponents = function(condition) {
    var query = condition.query;
    var mainType = condition.mainType;
    var queryCond = getQueryCond(query);
    var result = queryCond ? this.queryComponents(queryCond) : filter(this._componentsMap.get(mainType), function(cmpt) {
      return !!cmpt;
    });
    return doFilter(filterBySubType(result, condition));
    function getQueryCond(q2) {
      var indexAttr = mainType + "Index";
      var idAttr = mainType + "Id";
      var nameAttr = mainType + "Name";
      return q2 && (q2[indexAttr] != null || q2[idAttr] != null || q2[nameAttr] != null) ? {
        mainType,
        index: q2[indexAttr],
        id: q2[idAttr],
        name: q2[nameAttr]
      } : null;
    }
    function doFilter(res2) {
      return condition.filter ? filter(res2, condition.filter) : res2;
    }
  };
  GlobalModel2.prototype.eachComponent = function(mainType, cb2, context) {
    var componentsMap = this._componentsMap;
    if (isFunction$1(mainType)) {
      var ctxForAll_1 = cb2;
      var cbForAll_1 = mainType;
      componentsMap.each(function(cmpts2, componentType) {
        for (var i2 = 0; cmpts2 && i2 < cmpts2.length; i2++) {
          var cmpt2 = cmpts2[i2];
          cmpt2 && cbForAll_1.call(ctxForAll_1, componentType, cmpt2, cmpt2.componentIndex);
        }
      });
    } else {
      var cmpts = isString$1(mainType) ? componentsMap.get(mainType) : isObject$6(mainType) ? this.findComponents(mainType) : null;
      for (var i = 0; cmpts && i < cmpts.length; i++) {
        var cmpt = cmpts[i];
        cmpt && cb2.call(context, cmpt, cmpt.componentIndex);
      }
    }
  };
  GlobalModel2.prototype.getSeriesByName = function(name2) {
    var nameStr = convertOptionIdName(name2, null);
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && nameStr != null && oneSeries.name === nameStr;
    });
  };
  GlobalModel2.prototype.getSeriesByIndex = function(seriesIndex) {
    return this._componentsMap.get("series")[seriesIndex];
  };
  GlobalModel2.prototype.getSeriesByType = function(subType) {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && oneSeries.subType === subType;
    });
  };
  GlobalModel2.prototype.getSeries = function() {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries;
    });
  };
  GlobalModel2.prototype.getSeriesCount = function() {
    return this._componentsCount.get("series");
  };
  GlobalModel2.prototype.eachSeries = function(cb2, context) {
    assertSeriesInitialized(this);
    each$g(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      cb2.call(context, series, rawSeriesIndex);
    }, this);
  };
  GlobalModel2.prototype.eachRawSeries = function(cb2, context) {
    each$g(this._componentsMap.get("series"), function(series) {
      series && cb2.call(context, series, series.componentIndex);
    });
  };
  GlobalModel2.prototype.eachSeriesByType = function(subType, cb2, context) {
    assertSeriesInitialized(this);
    each$g(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      if (series.subType === subType) {
        cb2.call(context, series, rawSeriesIndex);
      }
    }, this);
  };
  GlobalModel2.prototype.eachRawSeriesByType = function(subType, cb2, context) {
    return each$g(this.getSeriesByType(subType), cb2, context);
  };
  GlobalModel2.prototype.isSeriesFiltered = function(seriesModel) {
    assertSeriesInitialized(this);
    return this._seriesIndicesMap.get(seriesModel.componentIndex) == null;
  };
  GlobalModel2.prototype.getCurrentSeriesIndices = function() {
    return (this._seriesIndices || []).slice();
  };
  GlobalModel2.prototype.filterSeries = function(cb2, context) {
    assertSeriesInitialized(this);
    var newSeriesIndices = [];
    each$g(this._seriesIndices, function(seriesRawIdx) {
      var series = this._componentsMap.get("series")[seriesRawIdx];
      cb2.call(context, series, seriesRawIdx) && newSeriesIndices.push(seriesRawIdx);
    }, this);
    this._seriesIndices = newSeriesIndices;
    this._seriesIndicesMap = createHashMap(newSeriesIndices);
  };
  GlobalModel2.prototype.restoreData = function(payload) {
    reCreateSeriesIndices(this);
    var componentsMap = this._componentsMap;
    var componentTypes = [];
    componentsMap.each(function(components, componentType) {
      if (ComponentModel$1.hasClass(componentType)) {
        componentTypes.push(componentType);
      }
    });
    ComponentModel$1.topologicalTravel(componentTypes, ComponentModel$1.getAllClassMainTypes(), function(componentType) {
      each$g(componentsMap.get(componentType), function(component) {
        if (component && (componentType !== "series" || !isNotTargetSeries(component, payload))) {
          component.restoreData();
        }
      });
    });
  };
  GlobalModel2.internalField = function() {
    reCreateSeriesIndices = function(ecModel) {
      var seriesIndices = ecModel._seriesIndices = [];
      each$g(ecModel._componentsMap.get("series"), function(series) {
        series && seriesIndices.push(series.componentIndex);
      });
      ecModel._seriesIndicesMap = createHashMap(seriesIndices);
    };
    assertSeriesInitialized = function(ecModel) {
    };
    initBase = function(ecModel, baseOption) {
      ecModel.option = {};
      ecModel.option[OPTION_INNER_KEY] = OPTION_INNER_VALUE;
      ecModel._componentsMap = createHashMap({
        series: []
      });
      ecModel._componentsCount = createHashMap();
      var airaOption = baseOption.aria;
      if (isObject$6(airaOption) && airaOption.enabled == null) {
        airaOption.enabled = true;
      }
      mergeTheme(baseOption, ecModel._theme.option);
      merge$1(baseOption, globalDefault, false);
      ecModel._mergeOption(baseOption, null);
    };
  }();
  return GlobalModel2;
}(Model$1);
function isNotTargetSeries(seriesModel, payload) {
  if (payload) {
    var index2 = payload.seriesIndex;
    var id2 = payload.seriesId;
    var name_1 = payload.seriesName;
    return index2 != null && seriesModel.componentIndex !== index2 || id2 != null && seriesModel.id !== id2 || name_1 != null && seriesModel.name !== name_1;
  }
}
function mergeTheme(option, theme2) {
  var notMergeColorLayer = option.color && !option.colorLayer;
  each$g(theme2, function(themeItem, name2) {
    if (name2 === "colorLayer" && notMergeColorLayer) {
      return;
    }
    if (!ComponentModel$1.hasClass(name2)) {
      if (typeof themeItem === "object") {
        option[name2] = !option[name2] ? clone$4(themeItem) : merge$1(option[name2], themeItem, false);
      } else {
        if (option[name2] == null) {
          option[name2] = themeItem;
        }
      }
    }
  });
}
function queryByIdOrName(attr, idOrName, cmpts) {
  if (isArray$2(idOrName)) {
    var keyMap_1 = createHashMap();
    each$g(idOrName, function(idOrNameItem) {
      if (idOrNameItem != null) {
        var idName = convertOptionIdName(idOrNameItem, null);
        idName != null && keyMap_1.set(idOrNameItem, true);
      }
    });
    return filter(cmpts, function(cmpt) {
      return cmpt && keyMap_1.get(cmpt[attr]);
    });
  } else {
    var idName_1 = convertOptionIdName(idOrName, null);
    return filter(cmpts, function(cmpt) {
      return cmpt && idName_1 != null && cmpt[attr] === idName_1;
    });
  }
}
function filterBySubType(components, condition) {
  return condition.hasOwnProperty("subType") ? filter(components, function(cmpt) {
    return cmpt && cmpt.subType === condition.subType;
  }) : components;
}
function normalizeSetOptionInput(opts) {
  var replaceMergeMainTypeMap = createHashMap();
  opts && each$g(normalizeToArray(opts.replaceMerge), function(mainType) {
    replaceMergeMainTypeMap.set(mainType, true);
  });
  return {
    replaceMergeMainTypeMap
  };
}
mixin(GlobalModel, PaletteMixin);
var GlobalModel$1 = GlobalModel;
var availableMethods = [
  "getDom",
  "getZr",
  "getWidth",
  "getHeight",
  "getDevicePixelRatio",
  "dispatchAction",
  "isSSR",
  "isDisposed",
  "on",
  "off",
  "getDataURL",
  "getConnectedDataURL",
  "getOption",
  "getId",
  "updateLabelLayout"
];
var ExtensionAPI = function() {
  function ExtensionAPI2(ecInstance) {
    each$g(availableMethods, function(methodName) {
      this[methodName] = bind$1(ecInstance[methodName], ecInstance);
    }, this);
  }
  return ExtensionAPI2;
}();
var ExtensionAPI$1 = ExtensionAPI;
var coordinateSystemCreators = {};
var CoordinateSystemManager = function() {
  function CoordinateSystemManager2() {
    this._coordinateSystems = [];
  }
  CoordinateSystemManager2.prototype.create = function(ecModel, api) {
    var coordinateSystems = [];
    each$g(coordinateSystemCreators, function(creater, type4) {
      var list = creater.create(ecModel, api);
      coordinateSystems = coordinateSystems.concat(list || []);
    });
    this._coordinateSystems = coordinateSystems;
  };
  CoordinateSystemManager2.prototype.update = function(ecModel, api) {
    each$g(this._coordinateSystems, function(coordSys) {
      coordSys.update && coordSys.update(ecModel, api);
    });
  };
  CoordinateSystemManager2.prototype.getCoordinateSystems = function() {
    return this._coordinateSystems.slice();
  };
  CoordinateSystemManager2.register = function(type4, creator) {
    coordinateSystemCreators[type4] = creator;
  };
  CoordinateSystemManager2.get = function(type4) {
    return coordinateSystemCreators[type4];
  };
  return CoordinateSystemManager2;
}();
var CoordinateSystem = CoordinateSystemManager;
var QUERY_REG = /^(min|max)?(.+)$/;
var OptionManager = function() {
  function OptionManager2(api) {
    this._timelineOptions = [];
    this._mediaList = [];
    this._currentMediaIndices = [];
    this._api = api;
  }
  OptionManager2.prototype.setOption = function(rawOption, optionPreprocessorFuncs2, opt) {
    if (rawOption) {
      each$g(normalizeToArray(rawOption.series), function(series) {
        series && series.data && isTypedArray(series.data) && setAsPrimitive(series.data);
      });
      each$g(normalizeToArray(rawOption.dataset), function(dataset) {
        dataset && dataset.source && isTypedArray(dataset.source) && setAsPrimitive(dataset.source);
      });
    }
    rawOption = clone$4(rawOption);
    var optionBackup = this._optionBackup;
    var newParsedOption = parseRawOption(rawOption, optionPreprocessorFuncs2, !optionBackup);
    this._newBaseOption = newParsedOption.baseOption;
    if (optionBackup) {
      if (newParsedOption.timelineOptions.length) {
        optionBackup.timelineOptions = newParsedOption.timelineOptions;
      }
      if (newParsedOption.mediaList.length) {
        optionBackup.mediaList = newParsedOption.mediaList;
      }
      if (newParsedOption.mediaDefault) {
        optionBackup.mediaDefault = newParsedOption.mediaDefault;
      }
    } else {
      this._optionBackup = newParsedOption;
    }
  };
  OptionManager2.prototype.mountOption = function(isRecreate) {
    var optionBackup = this._optionBackup;
    this._timelineOptions = optionBackup.timelineOptions;
    this._mediaList = optionBackup.mediaList;
    this._mediaDefault = optionBackup.mediaDefault;
    this._currentMediaIndices = [];
    return clone$4(isRecreate ? optionBackup.baseOption : this._newBaseOption);
  };
  OptionManager2.prototype.getTimelineOption = function(ecModel) {
    var option;
    var timelineOptions = this._timelineOptions;
    if (timelineOptions.length) {
      var timelineModel = ecModel.getComponent("timeline");
      if (timelineModel) {
        option = clone$4(timelineOptions[timelineModel.getCurrentIndex()]);
      }
    }
    return option;
  };
  OptionManager2.prototype.getMediaOption = function(ecModel) {
    var ecWidth = this._api.getWidth();
    var ecHeight = this._api.getHeight();
    var mediaList = this._mediaList;
    var mediaDefault = this._mediaDefault;
    var indices = [];
    var result = [];
    if (!mediaList.length && !mediaDefault) {
      return result;
    }
    for (var i = 0, len2 = mediaList.length; i < len2; i++) {
      if (applyMediaQuery(mediaList[i].query, ecWidth, ecHeight)) {
        indices.push(i);
      }
    }
    if (!indices.length && mediaDefault) {
      indices = [-1];
    }
    if (indices.length && !indicesEquals(indices, this._currentMediaIndices)) {
      result = map$1(indices, function(index2) {
        return clone$4(index2 === -1 ? mediaDefault.option : mediaList[index2].option);
      });
    }
    this._currentMediaIndices = indices;
    return result;
  };
  return OptionManager2;
}();
function parseRawOption(rawOption, optionPreprocessorFuncs2, isNew) {
  var mediaList = [];
  var mediaDefault;
  var baseOption;
  var declaredBaseOption = rawOption.baseOption;
  var timelineOnRoot = rawOption.timeline;
  var timelineOptionsOnRoot = rawOption.options;
  var mediaOnRoot = rawOption.media;
  var hasMedia = !!rawOption.media;
  var hasTimeline = !!(timelineOptionsOnRoot || timelineOnRoot || declaredBaseOption && declaredBaseOption.timeline);
  if (declaredBaseOption) {
    baseOption = declaredBaseOption;
    if (!baseOption.timeline) {
      baseOption.timeline = timelineOnRoot;
    }
  } else {
    if (hasTimeline || hasMedia) {
      rawOption.options = rawOption.media = null;
    }
    baseOption = rawOption;
  }
  if (hasMedia) {
    if (isArray$2(mediaOnRoot)) {
      each$g(mediaOnRoot, function(singleMedia) {
        if (singleMedia && singleMedia.option) {
          if (singleMedia.query) {
            mediaList.push(singleMedia);
          } else if (!mediaDefault) {
            mediaDefault = singleMedia;
          }
        }
      });
    }
  }
  doPreprocess(baseOption);
  each$g(timelineOptionsOnRoot, function(option) {
    return doPreprocess(option);
  });
  each$g(mediaList, function(media) {
    return doPreprocess(media.option);
  });
  function doPreprocess(option) {
    each$g(optionPreprocessorFuncs2, function(preProcess) {
      preProcess(option, isNew);
    });
  }
  return {
    baseOption,
    timelineOptions: timelineOptionsOnRoot || [],
    mediaDefault,
    mediaList
  };
}
function applyMediaQuery(query, ecWidth, ecHeight) {
  var realMap = {
    width: ecWidth,
    height: ecHeight,
    aspectratio: ecWidth / ecHeight
  };
  var applicatable = true;
  each$g(query, function(value, attr) {
    var matched = attr.match(QUERY_REG);
    if (!matched || !matched[1] || !matched[2]) {
      return;
    }
    var operator = matched[1];
    var realAttr = matched[2].toLowerCase();
    if (!compare(realMap[realAttr], value, operator)) {
      applicatable = false;
    }
  });
  return applicatable;
}
function compare(real, expect, operator) {
  if (operator === "min") {
    return real >= expect;
  } else if (operator === "max") {
    return real <= expect;
  } else {
    return real === expect;
  }
}
function indicesEquals(indices1, indices2) {
  return indices1.join(",") === indices2.join(",");
}
var OptionManager$1 = OptionManager;
var each$e = each$g;
var isObject$5 = isObject$6;
var POSSIBLE_STYLES = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
function compatEC2ItemStyle(opt) {
  var itemStyleOpt = opt && opt.itemStyle;
  if (!itemStyleOpt) {
    return;
  }
  for (var i = 0, len2 = POSSIBLE_STYLES.length; i < len2; i++) {
    var styleName = POSSIBLE_STYLES[i];
    var normalItemStyleOpt = itemStyleOpt.normal;
    var emphasisItemStyleOpt = itemStyleOpt.emphasis;
    if (normalItemStyleOpt && normalItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].normal) {
        opt[styleName].normal = normalItemStyleOpt[styleName];
      } else {
        merge$1(opt[styleName].normal, normalItemStyleOpt[styleName]);
      }
      normalItemStyleOpt[styleName] = null;
    }
    if (emphasisItemStyleOpt && emphasisItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].emphasis) {
        opt[styleName].emphasis = emphasisItemStyleOpt[styleName];
      } else {
        merge$1(opt[styleName].emphasis, emphasisItemStyleOpt[styleName]);
      }
      emphasisItemStyleOpt[styleName] = null;
    }
  }
}
function convertNormalEmphasis(opt, optType, useExtend) {
  if (opt && opt[optType] && (opt[optType].normal || opt[optType].emphasis)) {
    var normalOpt = opt[optType].normal;
    var emphasisOpt = opt[optType].emphasis;
    if (normalOpt) {
      if (useExtend) {
        opt[optType].normal = opt[optType].emphasis = null;
        defaults(opt[optType], normalOpt);
      } else {
        opt[optType] = normalOpt;
      }
    }
    if (emphasisOpt) {
      opt.emphasis = opt.emphasis || {};
      opt.emphasis[optType] = emphasisOpt;
      if (emphasisOpt.focus) {
        opt.emphasis.focus = emphasisOpt.focus;
      }
      if (emphasisOpt.blurScope) {
        opt.emphasis.blurScope = emphasisOpt.blurScope;
      }
    }
  }
}
function removeEC3NormalStatus(opt) {
  convertNormalEmphasis(opt, "itemStyle");
  convertNormalEmphasis(opt, "lineStyle");
  convertNormalEmphasis(opt, "areaStyle");
  convertNormalEmphasis(opt, "label");
  convertNormalEmphasis(opt, "labelLine");
  convertNormalEmphasis(opt, "upperLabel");
  convertNormalEmphasis(opt, "edgeLabel");
}
function compatTextStyle(opt, propName) {
  var labelOptSingle = isObject$5(opt) && opt[propName];
  var textStyle = isObject$5(labelOptSingle) && labelOptSingle.textStyle;
  if (textStyle) {
    for (var i = 0, len2 = TEXT_STYLE_OPTIONS.length; i < len2; i++) {
      var textPropName = TEXT_STYLE_OPTIONS[i];
      if (textStyle.hasOwnProperty(textPropName)) {
        labelOptSingle[textPropName] = textStyle[textPropName];
      }
    }
  }
}
function compatEC3CommonStyles(opt) {
  if (opt) {
    removeEC3NormalStatus(opt);
    compatTextStyle(opt, "label");
    opt.emphasis && compatTextStyle(opt.emphasis, "label");
  }
}
function processSeries(seriesOpt) {
  if (!isObject$5(seriesOpt)) {
    return;
  }
  compatEC2ItemStyle(seriesOpt);
  removeEC3NormalStatus(seriesOpt);
  compatTextStyle(seriesOpt, "label");
  compatTextStyle(seriesOpt, "upperLabel");
  compatTextStyle(seriesOpt, "edgeLabel");
  if (seriesOpt.emphasis) {
    compatTextStyle(seriesOpt.emphasis, "label");
    compatTextStyle(seriesOpt.emphasis, "upperLabel");
    compatTextStyle(seriesOpt.emphasis, "edgeLabel");
  }
  var markPoint = seriesOpt.markPoint;
  if (markPoint) {
    compatEC2ItemStyle(markPoint);
    compatEC3CommonStyles(markPoint);
  }
  var markLine = seriesOpt.markLine;
  if (markLine) {
    compatEC2ItemStyle(markLine);
    compatEC3CommonStyles(markLine);
  }
  var markArea = seriesOpt.markArea;
  if (markArea) {
    compatEC3CommonStyles(markArea);
  }
  var data2 = seriesOpt.data;
  if (seriesOpt.type === "graph") {
    data2 = data2 || seriesOpt.nodes;
    var edgeData = seriesOpt.links || seriesOpt.edges;
    if (edgeData && !isTypedArray(edgeData)) {
      for (var i = 0; i < edgeData.length; i++) {
        compatEC3CommonStyles(edgeData[i]);
      }
    }
    each$g(seriesOpt.categories, function(opt) {
      removeEC3NormalStatus(opt);
    });
  }
  if (data2 && !isTypedArray(data2)) {
    for (var i = 0; i < data2.length; i++) {
      compatEC3CommonStyles(data2[i]);
    }
  }
  markPoint = seriesOpt.markPoint;
  if (markPoint && markPoint.data) {
    var mpData = markPoint.data;
    for (var i = 0; i < mpData.length; i++) {
      compatEC3CommonStyles(mpData[i]);
    }
  }
  markLine = seriesOpt.markLine;
  if (markLine && markLine.data) {
    var mlData = markLine.data;
    for (var i = 0; i < mlData.length; i++) {
      if (isArray$2(mlData[i])) {
        compatEC3CommonStyles(mlData[i][0]);
        compatEC3CommonStyles(mlData[i][1]);
      } else {
        compatEC3CommonStyles(mlData[i]);
      }
    }
  }
  if (seriesOpt.type === "gauge") {
    compatTextStyle(seriesOpt, "axisLabel");
    compatTextStyle(seriesOpt, "title");
    compatTextStyle(seriesOpt, "detail");
  } else if (seriesOpt.type === "treemap") {
    convertNormalEmphasis(seriesOpt.breadcrumb, "itemStyle");
    each$g(seriesOpt.levels, function(opt) {
      removeEC3NormalStatus(opt);
    });
  } else if (seriesOpt.type === "tree") {
    removeEC3NormalStatus(seriesOpt.leaves);
  }
}
function toArr(o) {
  return isArray$2(o) ? o : o ? [o] : [];
}
function toObj(o) {
  return (isArray$2(o) ? o[0] : o) || {};
}
function globalCompatStyle(option, isTheme) {
  each$e(toArr(option.series), function(seriesOpt) {
    isObject$5(seriesOpt) && processSeries(seriesOpt);
  });
  var axes = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
  isTheme && axes.push("valueAxis", "categoryAxis", "logAxis", "timeAxis");
  each$e(axes, function(axisName) {
    each$e(toArr(option[axisName]), function(axisOpt) {
      if (axisOpt) {
        compatTextStyle(axisOpt, "axisLabel");
        compatTextStyle(axisOpt.axisPointer, "label");
      }
    });
  });
  each$e(toArr(option.parallel), function(parallelOpt) {
    var parallelAxisDefault = parallelOpt && parallelOpt.parallelAxisDefault;
    compatTextStyle(parallelAxisDefault, "axisLabel");
    compatTextStyle(parallelAxisDefault && parallelAxisDefault.axisPointer, "label");
  });
  each$e(toArr(option.calendar), function(calendarOpt) {
    convertNormalEmphasis(calendarOpt, "itemStyle");
    compatTextStyle(calendarOpt, "dayLabel");
    compatTextStyle(calendarOpt, "monthLabel");
    compatTextStyle(calendarOpt, "yearLabel");
  });
  each$e(toArr(option.radar), function(radarOpt) {
    compatTextStyle(radarOpt, "name");
    if (radarOpt.name && radarOpt.axisName == null) {
      radarOpt.axisName = radarOpt.name;
      delete radarOpt.name;
    }
    if (radarOpt.nameGap != null && radarOpt.axisNameGap == null) {
      radarOpt.axisNameGap = radarOpt.nameGap;
      delete radarOpt.nameGap;
    }
  });
  each$e(toArr(option.geo), function(geoOpt) {
    if (isObject$5(geoOpt)) {
      compatEC3CommonStyles(geoOpt);
      each$e(toArr(geoOpt.regions), function(regionObj) {
        compatEC3CommonStyles(regionObj);
      });
    }
  });
  each$e(toArr(option.timeline), function(timelineOpt) {
    compatEC3CommonStyles(timelineOpt);
    convertNormalEmphasis(timelineOpt, "label");
    convertNormalEmphasis(timelineOpt, "itemStyle");
    convertNormalEmphasis(timelineOpt, "controlStyle", true);
    var data2 = timelineOpt.data;
    isArray$2(data2) && each$g(data2, function(item) {
      if (isObject$6(item)) {
        convertNormalEmphasis(item, "label");
        convertNormalEmphasis(item, "itemStyle");
      }
    });
  });
  each$e(toArr(option.toolbox), function(toolboxOpt) {
    convertNormalEmphasis(toolboxOpt, "iconStyle");
    each$e(toolboxOpt.feature, function(featureOpt) {
      convertNormalEmphasis(featureOpt, "iconStyle");
    });
  });
  compatTextStyle(toObj(option.axisPointer), "label");
  compatTextStyle(toObj(option.tooltip).axisPointer, "label");
}
function get$1(opt, path) {
  var pathArr = path.split(",");
  var obj = opt;
  for (var i = 0; i < pathArr.length; i++) {
    obj = obj && obj[pathArr[i]];
    if (obj == null) {
      break;
    }
  }
  return obj;
}
function set$1(opt, path, val, overwrite) {
  var pathArr = path.split(",");
  var obj = opt;
  var key;
  var i = 0;
  for (; i < pathArr.length - 1; i++) {
    key = pathArr[i];
    if (obj[key] == null) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  if (overwrite || obj[pathArr[i]] == null) {
    obj[pathArr[i]] = val;
  }
}
function compatLayoutProperties(option) {
  option && each$g(LAYOUT_PROPERTIES, function(prop) {
    if (prop[0] in option && !(prop[1] in option)) {
      option[prop[1]] = option[prop[0]];
    }
  });
}
var LAYOUT_PROPERTIES = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]];
var COMPATITABLE_COMPONENTS = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"];
var BAR_ITEM_STYLE_MAP = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
function compatBarItemStyle(option) {
  var itemStyle = option && option.itemStyle;
  if (itemStyle) {
    for (var i = 0; i < BAR_ITEM_STYLE_MAP.length; i++) {
      var oldName = BAR_ITEM_STYLE_MAP[i][1];
      var newName = BAR_ITEM_STYLE_MAP[i][0];
      if (itemStyle[oldName] != null) {
        itemStyle[newName] = itemStyle[oldName];
      }
    }
  }
}
function compatPieLabel(option) {
  if (!option) {
    return;
  }
  if (option.alignTo === "edge" && option.margin != null && option.edgeDistance == null) {
    option.edgeDistance = option.margin;
  }
}
function compatSunburstState(option) {
  if (!option) {
    return;
  }
  if (option.downplay && !option.blur) {
    option.blur = option.downplay;
  }
}
function compatGraphFocus(option) {
  if (!option) {
    return;
  }
  if (option.focusNodeAdjacency != null) {
    option.emphasis = option.emphasis || {};
    if (option.emphasis.focus == null) {
      option.emphasis.focus = "adjacency";
    }
  }
}
function traverseTree(data2, cb2) {
  if (data2) {
    for (var i = 0; i < data2.length; i++) {
      cb2(data2[i]);
      data2[i] && traverseTree(data2[i].children, cb2);
    }
  }
}
function globalBackwardCompat(option, isTheme) {
  globalCompatStyle(option, isTheme);
  option.series = normalizeToArray(option.series);
  each$g(option.series, function(seriesOpt) {
    if (!isObject$6(seriesOpt)) {
      return;
    }
    var seriesType2 = seriesOpt.type;
    if (seriesType2 === "line") {
      if (seriesOpt.clipOverflow != null) {
        seriesOpt.clip = seriesOpt.clipOverflow;
      }
    } else if (seriesType2 === "pie" || seriesType2 === "gauge") {
      if (seriesOpt.clockWise != null) {
        seriesOpt.clockwise = seriesOpt.clockWise;
      }
      compatPieLabel(seriesOpt.label);
      var data2 = seriesOpt.data;
      if (data2 && !isTypedArray(data2)) {
        for (var i = 0; i < data2.length; i++) {
          compatPieLabel(data2[i]);
        }
      }
      if (seriesOpt.hoverOffset != null) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (seriesOpt.emphasis.scaleSize = null) {
          seriesOpt.emphasis.scaleSize = seriesOpt.hoverOffset;
        }
      }
    } else if (seriesType2 === "gauge") {
      var pointerColor = get$1(seriesOpt, "pointer.color");
      pointerColor != null && set$1(seriesOpt, "itemStyle.color", pointerColor);
    } else if (seriesType2 === "bar") {
      compatBarItemStyle(seriesOpt);
      compatBarItemStyle(seriesOpt.backgroundStyle);
      compatBarItemStyle(seriesOpt.emphasis);
      var data2 = seriesOpt.data;
      if (data2 && !isTypedArray(data2)) {
        for (var i = 0; i < data2.length; i++) {
          if (typeof data2[i] === "object") {
            compatBarItemStyle(data2[i]);
            compatBarItemStyle(data2[i] && data2[i].emphasis);
          }
        }
      }
    } else if (seriesType2 === "sunburst") {
      var highlightPolicy = seriesOpt.highlightPolicy;
      if (highlightPolicy) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (!seriesOpt.emphasis.focus) {
          seriesOpt.emphasis.focus = highlightPolicy;
        }
      }
      compatSunburstState(seriesOpt);
      traverseTree(seriesOpt.data, compatSunburstState);
    } else if (seriesType2 === "graph" || seriesType2 === "sankey") {
      compatGraphFocus(seriesOpt);
    } else if (seriesType2 === "map") {
      if (seriesOpt.mapType && !seriesOpt.map) {
        seriesOpt.map = seriesOpt.mapType;
      }
      if (seriesOpt.mapLocation) {
        defaults(seriesOpt, seriesOpt.mapLocation);
      }
    }
    if (seriesOpt.hoverAnimation != null) {
      seriesOpt.emphasis = seriesOpt.emphasis || {};
      if (seriesOpt.emphasis && seriesOpt.emphasis.scale == null) {
        seriesOpt.emphasis.scale = seriesOpt.hoverAnimation;
      }
    }
    compatLayoutProperties(seriesOpt);
  });
  if (option.dataRange) {
    option.visualMap = option.dataRange;
  }
  each$g(COMPATITABLE_COMPONENTS, function(componentName) {
    var options = option[componentName];
    if (options) {
      if (!isArray$2(options)) {
        options = [options];
      }
      each$g(options, function(option2) {
        compatLayoutProperties(option2);
      });
    }
  });
}
function dataStack(ecModel) {
  var stackInfoMap = createHashMap();
  ecModel.eachSeries(function(seriesModel) {
    var stack = seriesModel.get("stack");
    if (stack) {
      var stackInfoList = stackInfoMap.get(stack) || stackInfoMap.set(stack, []);
      var data2 = seriesModel.getData();
      var stackInfo = {
        stackResultDimension: data2.getCalculationInfo("stackResultDimension"),
        stackedOverDimension: data2.getCalculationInfo("stackedOverDimension"),
        stackedDimension: data2.getCalculationInfo("stackedDimension"),
        stackedByDimension: data2.getCalculationInfo("stackedByDimension"),
        isStackedByIndex: data2.getCalculationInfo("isStackedByIndex"),
        data: data2,
        seriesModel
      };
      if (!stackInfo.stackedDimension || !(stackInfo.isStackedByIndex || stackInfo.stackedByDimension)) {
        return;
      }
      stackInfoList.length && data2.setCalculationInfo("stackedOnSeries", stackInfoList[stackInfoList.length - 1].seriesModel);
      stackInfoList.push(stackInfo);
    }
  });
  stackInfoMap.each(calculateStack);
}
function calculateStack(stackInfoList) {
  each$g(stackInfoList, function(targetStackInfo, idxInStack) {
    var resultVal = [];
    var resultNaN = [NaN, NaN];
    var dims = [targetStackInfo.stackResultDimension, targetStackInfo.stackedOverDimension];
    var targetData = targetStackInfo.data;
    var isStackedByIndex = targetStackInfo.isStackedByIndex;
    targetData.modify(dims, function(v0, v12, dataIndex) {
      var sum2 = targetData.get(targetStackInfo.stackedDimension, dataIndex);
      if (isNaN(sum2)) {
        return resultNaN;
      }
      var byValue;
      var stackedDataRawIndex;
      if (isStackedByIndex) {
        stackedDataRawIndex = targetData.getRawIndex(dataIndex);
      } else {
        byValue = targetData.get(targetStackInfo.stackedByDimension, dataIndex);
      }
      var stackedOver = NaN;
      for (var j = idxInStack - 1; j >= 0; j--) {
        var stackInfo = stackInfoList[j];
        if (!isStackedByIndex) {
          stackedDataRawIndex = stackInfo.data.rawIndexOf(stackInfo.stackedByDimension, byValue);
        }
        if (stackedDataRawIndex >= 0) {
          var val = stackInfo.data.getByRawIndex(stackInfo.stackResultDimension, stackedDataRawIndex);
          if (sum2 >= 0 && val > 0 || sum2 <= 0 && val < 0) {
            sum2 = addSafe(sum2, val);
            stackedOver = val;
            break;
          }
        }
      }
      resultVal[0] = sum2;
      resultVal[1] = stackedOver;
      return resultVal;
    });
  });
}
var SourceImpl = function() {
  function SourceImpl2(fields) {
    this.data = fields.data || (fields.sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS ? {} : []);
    this.sourceFormat = fields.sourceFormat || SOURCE_FORMAT_UNKNOWN;
    this.seriesLayoutBy = fields.seriesLayoutBy || SERIES_LAYOUT_BY_COLUMN;
    this.startIndex = fields.startIndex || 0;
    this.dimensionsDetectedCount = fields.dimensionsDetectedCount;
    this.metaRawOption = fields.metaRawOption;
    var dimensionsDefine = this.dimensionsDefine = fields.dimensionsDefine;
    if (dimensionsDefine) {
      for (var i = 0; i < dimensionsDefine.length; i++) {
        var dim = dimensionsDefine[i];
        if (dim.type == null) {
          if (guessOrdinal(this, i) === BE_ORDINAL.Must) {
            dim.type = "ordinal";
          }
        }
      }
    }
  }
  return SourceImpl2;
}();
function isSourceInstance(val) {
  return val instanceof SourceImpl;
}
function createSource(sourceData, thisMetaRawOption, sourceFormat) {
  sourceFormat = sourceFormat || detectSourceFormat(sourceData);
  var seriesLayoutBy = thisMetaRawOption.seriesLayoutBy;
  var determined = determineSourceDimensions(sourceData, sourceFormat, seriesLayoutBy, thisMetaRawOption.sourceHeader, thisMetaRawOption.dimensions);
  var source = new SourceImpl({
    data: sourceData,
    sourceFormat,
    seriesLayoutBy,
    dimensionsDefine: determined.dimensionsDefine,
    startIndex: determined.startIndex,
    dimensionsDetectedCount: determined.dimensionsDetectedCount,
    metaRawOption: clone$4(thisMetaRawOption)
  });
  return source;
}
function createSourceFromSeriesDataOption(data2) {
  return new SourceImpl({
    data: data2,
    sourceFormat: isTypedArray(data2) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL
  });
}
function cloneSourceShallow(source) {
  return new SourceImpl({
    data: source.data,
    sourceFormat: source.sourceFormat,
    seriesLayoutBy: source.seriesLayoutBy,
    dimensionsDefine: clone$4(source.dimensionsDefine),
    startIndex: source.startIndex,
    dimensionsDetectedCount: source.dimensionsDetectedCount
  });
}
function detectSourceFormat(data2) {
  var sourceFormat = SOURCE_FORMAT_UNKNOWN;
  if (isTypedArray(data2)) {
    sourceFormat = SOURCE_FORMAT_TYPED_ARRAY;
  } else if (isArray$2(data2)) {
    if (data2.length === 0) {
      sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
    }
    for (var i = 0, len2 = data2.length; i < len2; i++) {
      var item = data2[i];
      if (item == null) {
        continue;
      } else if (isArray$2(item)) {
        sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
        break;
      } else if (isObject$6(item)) {
        sourceFormat = SOURCE_FORMAT_OBJECT_ROWS;
        break;
      }
    }
  } else if (isObject$6(data2)) {
    for (var key in data2) {
      if (hasOwn$1(data2, key) && isArrayLike(data2[key])) {
        sourceFormat = SOURCE_FORMAT_KEYED_COLUMNS;
        break;
      }
    }
  }
  return sourceFormat;
}
function determineSourceDimensions(data2, sourceFormat, seriesLayoutBy, sourceHeader, dimensionsDefine) {
  var dimensionsDetectedCount;
  var startIndex;
  if (!data2) {
    return {
      dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
      startIndex,
      dimensionsDetectedCount
    };
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data2;
    if (sourceHeader === "auto" || sourceHeader == null) {
      arrayRowsTravelFirst(function(val) {
        if (val != null && val !== "-") {
          if (isString$1(val)) {
            startIndex == null && (startIndex = 1);
          } else {
            startIndex = 0;
          }
        }
      }, seriesLayoutBy, dataArrayRows, 10);
    } else {
      startIndex = isNumber(sourceHeader) ? sourceHeader : sourceHeader ? 1 : 0;
    }
    if (!dimensionsDefine && startIndex === 1) {
      dimensionsDefine = [];
      arrayRowsTravelFirst(function(val, index2) {
        dimensionsDefine[index2] = val != null ? val + "" : "";
      }, seriesLayoutBy, dataArrayRows, Infinity);
    }
    dimensionsDetectedCount = dimensionsDefine ? dimensionsDefine.length : seriesLayoutBy === SERIES_LAYOUT_BY_ROW ? dataArrayRows.length : dataArrayRows[0] ? dataArrayRows[0].length : null;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    if (!dimensionsDefine) {
      dimensionsDefine = objectRowsCollectDimensions(data2);
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    if (!dimensionsDefine) {
      dimensionsDefine = [];
      each$g(data2, function(colArr, key) {
        dimensionsDefine.push(key);
      });
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var value0 = getDataItemValue(data2[0]);
    dimensionsDetectedCount = isArray$2(value0) && value0.length || 1;
  } else
    ;
  return {
    startIndex,
    dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
    dimensionsDetectedCount
  };
}
function objectRowsCollectDimensions(data2) {
  var firstIndex = 0;
  var obj;
  while (firstIndex < data2.length && !(obj = data2[firstIndex++])) {
  }
  if (obj) {
    var dimensions_1 = [];
    each$g(obj, function(value, key) {
      dimensions_1.push(key);
    });
    return dimensions_1;
  }
}
function normalizeDimensionsOption(dimensionsDefine) {
  if (!dimensionsDefine) {
    return;
  }
  var nameMap = createHashMap();
  return map$1(dimensionsDefine, function(rawItem, index2) {
    rawItem = isObject$6(rawItem) ? rawItem : {
      name: rawItem
    };
    var item = {
      name: rawItem.name,
      displayName: rawItem.displayName,
      type: rawItem.type
    };
    if (item.name == null) {
      return item;
    }
    item.name += "";
    if (item.displayName == null) {
      item.displayName = item.name;
    }
    var exist = nameMap.get(item.name);
    if (!exist) {
      nameMap.set(item.name, {
        count: 1
      });
    } else {
      item.name += "-" + exist.count++;
    }
    return item;
  });
}
function arrayRowsTravelFirst(cb2, seriesLayoutBy, data2, maxLoop) {
  if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
    for (var i = 0; i < data2.length && i < maxLoop; i++) {
      cb2(data2[i] ? data2[i][0] : null, i);
    }
  } else {
    var value0 = data2[0] || [];
    for (var i = 0; i < value0.length && i < maxLoop; i++) {
      cb2(value0[i], i);
    }
  }
}
function shouldRetrieveDataByName(source) {
  var sourceFormat = source.sourceFormat;
  return sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS;
}
var _a, _b, _c;
var providerMethods;
var mountMethods;
var DefaultDataProvider = function() {
  function DefaultDataProvider2(sourceParam, dimSize) {
    var source = !isSourceInstance(sourceParam) ? createSourceFromSeriesDataOption(sourceParam) : sourceParam;
    this._source = source;
    var data2 = this._data = source.data;
    if (source.sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
      this._offset = 0;
      this._dimSize = dimSize;
      this._data = data2;
    }
    mountMethods(this, data2, source);
  }
  DefaultDataProvider2.prototype.getSource = function() {
    return this._source;
  };
  DefaultDataProvider2.prototype.count = function() {
    return 0;
  };
  DefaultDataProvider2.prototype.getItem = function(idx, out2) {
    return;
  };
  DefaultDataProvider2.prototype.appendData = function(newData) {
  };
  DefaultDataProvider2.prototype.clean = function() {
  };
  DefaultDataProvider2.protoInitialize = function() {
    var proto2 = DefaultDataProvider2.prototype;
    proto2.pure = false;
    proto2.persistent = true;
  }();
  DefaultDataProvider2.internalField = function() {
    var _a2;
    mountMethods = function(provider, data2, source) {
      var sourceFormat = source.sourceFormat;
      var seriesLayoutBy = source.seriesLayoutBy;
      var startIndex = source.startIndex;
      var dimsDef = source.dimensionsDefine;
      var methods = providerMethods[getMethodMapKey(sourceFormat, seriesLayoutBy)];
      extend(provider, methods);
      if (sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
        provider.getItem = getItemForTypedArray;
        provider.count = countForTypedArray;
        provider.fillStorage = fillStorageForTypedArray;
      } else {
        var rawItemGetter = getRawSourceItemGetter(sourceFormat, seriesLayoutBy);
        provider.getItem = bind$1(rawItemGetter, null, data2, startIndex, dimsDef);
        var rawCounter = getRawSourceDataCounter(sourceFormat, seriesLayoutBy);
        provider.count = bind$1(rawCounter, null, data2, startIndex, dimsDef);
      }
    };
    var getItemForTypedArray = function(idx, out2) {
      idx = idx - this._offset;
      out2 = out2 || [];
      var data2 = this._data;
      var dimSize = this._dimSize;
      var offset3 = dimSize * idx;
      for (var i = 0; i < dimSize; i++) {
        out2[i] = data2[offset3 + i];
      }
      return out2;
    };
    var fillStorageForTypedArray = function(start2, end2, storage2, extent3) {
      var data2 = this._data;
      var dimSize = this._dimSize;
      for (var dim = 0; dim < dimSize; dim++) {
        var dimExtent = extent3[dim];
        var min3 = dimExtent[0] == null ? Infinity : dimExtent[0];
        var max3 = dimExtent[1] == null ? -Infinity : dimExtent[1];
        var count2 = end2 - start2;
        var arr = storage2[dim];
        for (var i = 0; i < count2; i++) {
          var val = data2[i * dimSize + dim];
          arr[start2 + i] = val;
          val < min3 && (min3 = val);
          val > max3 && (max3 = val);
        }
        dimExtent[0] = min3;
        dimExtent[1] = max3;
      }
    };
    var countForTypedArray = function() {
      return this._data ? this._data.length / this._dimSize : 0;
    };
    providerMethods = (_a2 = {}, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = {
      pure: true,
      appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      }
    }, _a2[SOURCE_FORMAT_OBJECT_ROWS] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_KEYED_COLUMNS] = {
      pure: true,
      appendData: function(newData) {
        var data2 = this._data;
        each$g(newData, function(newCol, key) {
          var oldCol = data2[key] || (data2[key] = []);
          for (var i = 0; i < (newCol || []).length; i++) {
            oldCol.push(newCol[i]);
          }
        });
      }
    }, _a2[SOURCE_FORMAT_ORIGINAL] = {
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_TYPED_ARRAY] = {
      persistent: false,
      pure: true,
      appendData: function(newData) {
        this._data = newData;
      },
      clean: function() {
        this._offset += this.count();
        this._data = null;
      }
    }, _a2);
    function appendDataSimply(newData) {
      for (var i = 0; i < newData.length; i++) {
        this._data.push(newData[i]);
      }
    }
  }();
  return DefaultDataProvider2;
}();
var getItemSimply = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx];
};
var rawSourceItemGetterMap = (_a = {}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx + startIndex];
}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef, idx, out2) {
  idx += startIndex;
  var item = out2 || [];
  var data2 = rawData;
  for (var i = 0; i < data2.length; i++) {
    var row = data2[i];
    item[i] = row ? row[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_OBJECT_ROWS] = getItemSimply, _a[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef, idx, out2) {
  var item = out2 || [];
  for (var i = 0; i < dimsDef.length; i++) {
    var dimName = dimsDef[i].name;
    var col = rawData[dimName];
    item[i] = col ? col[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_ORIGINAL] = getItemSimply, _a);
function getRawSourceItemGetter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceItemGetterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var countSimply = function(rawData, startIndex, dimsDef) {
  return rawData.length;
};
var rawSourceDataCounterMap = (_b = {}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef) {
  return Math.max(0, rawData.length - startIndex);
}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef) {
  var row = rawData[0];
  return row ? Math.max(0, row.length - startIndex) : 0;
}, _b[SOURCE_FORMAT_OBJECT_ROWS] = countSimply, _b[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef) {
  var dimName = dimsDef[0].name;
  var col = rawData[dimName];
  return col ? col.length : 0;
}, _b[SOURCE_FORMAT_ORIGINAL] = countSimply, _b);
function getRawSourceDataCounter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceDataCounterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var getRawValueSimply = function(dataItem, dimIndex, property) {
  return dataItem[dimIndex];
};
var rawSourceValueGetterMap = (_c = {}, _c[SOURCE_FORMAT_ARRAY_ROWS] = getRawValueSimply, _c[SOURCE_FORMAT_OBJECT_ROWS] = function(dataItem, dimIndex, property) {
  return dataItem[property];
}, _c[SOURCE_FORMAT_KEYED_COLUMNS] = getRawValueSimply, _c[SOURCE_FORMAT_ORIGINAL] = function(dataItem, dimIndex, property) {
  var value = getDataItemValue(dataItem);
  return !(value instanceof Array) ? value : value[dimIndex];
}, _c[SOURCE_FORMAT_TYPED_ARRAY] = getRawValueSimply, _c);
function getRawSourceValueGetter(sourceFormat) {
  var method4 = rawSourceValueGetterMap[sourceFormat];
  return method4;
}
function getMethodMapKey(sourceFormat, seriesLayoutBy) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS ? sourceFormat + "_" + seriesLayoutBy : sourceFormat;
}
function retrieveRawValue(data2, dataIndex, dim) {
  if (!data2) {
    return;
  }
  var dataItem = data2.getRawDataItem(dataIndex);
  if (dataItem == null) {
    return;
  }
  var store = data2.getStore();
  var sourceFormat = store.getSource().sourceFormat;
  if (dim != null) {
    var dimIndex = data2.getDimensionIndex(dim);
    var property = store.getDimensionProperty(dimIndex);
    return getRawSourceValueGetter(sourceFormat)(dataItem, dimIndex, property);
  } else {
    var result = dataItem;
    if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
      result = getDataItemValue(dataItem);
    }
    return result;
  }
}
var DIMENSION_LABEL_REG = /\{@(.+?)\}/g;
var DataFormatMixin = function() {
  function DataFormatMixin2() {
  }
  DataFormatMixin2.prototype.getDataParams = function(dataIndex, dataType) {
    var data2 = this.getData(dataType);
    var rawValue = this.getRawValue(dataIndex, dataType);
    var rawDataIndex = data2.getRawIndex(dataIndex);
    var name2 = data2.getName(dataIndex);
    var itemOpt = data2.getRawDataItem(dataIndex);
    var style2 = data2.getItemVisual(dataIndex, "style");
    var color = style2 && style2[data2.getItemVisual(dataIndex, "drawType") || "fill"];
    var borderColor = style2 && style2.stroke;
    var mainType = this.mainType;
    var isSeries2 = mainType === "series";
    var userOutput = data2.userOutput && data2.userOutput.get();
    return {
      componentType: mainType,
      componentSubType: this.subType,
      componentIndex: this.componentIndex,
      seriesType: isSeries2 ? this.subType : null,
      seriesIndex: this.seriesIndex,
      seriesId: isSeries2 ? this.id : null,
      seriesName: isSeries2 ? this.name : null,
      name: name2,
      dataIndex: rawDataIndex,
      data: itemOpt,
      dataType,
      value: rawValue,
      color,
      borderColor,
      dimensionNames: userOutput ? userOutput.fullDimensions : null,
      encode: userOutput ? userOutput.encode : null,
      $vars: ["seriesName", "name", "value"]
    };
  };
  DataFormatMixin2.prototype.getFormattedLabel = function(dataIndex, status, dataType, labelDimIndex, formatter, extendParams) {
    status = status || "normal";
    var data2 = this.getData(dataType);
    var params = this.getDataParams(dataIndex, dataType);
    if (extendParams) {
      params.value = extendParams.interpolatedValue;
    }
    if (labelDimIndex != null && isArray$2(params.value)) {
      params.value = params.value[labelDimIndex];
    }
    if (!formatter) {
      var itemModel = data2.getItemModel(dataIndex);
      formatter = itemModel.get(status === "normal" ? ["label", "formatter"] : [status, "label", "formatter"]);
    }
    if (isFunction$1(formatter)) {
      params.status = status;
      params.dimensionIndex = labelDimIndex;
      return formatter(params);
    } else if (isString$1(formatter)) {
      var str = formatTpl(formatter, params);
      return str.replace(DIMENSION_LABEL_REG, function(origin, dimStr) {
        var len2 = dimStr.length;
        var dimLoose = dimStr;
        if (dimLoose.charAt(0) === "[" && dimLoose.charAt(len2 - 1) === "]") {
          dimLoose = +dimLoose.slice(1, len2 - 1);
        }
        var val = retrieveRawValue(data2, dataIndex, dimLoose);
        if (extendParams && isArray$2(extendParams.interpolatedValue)) {
          var dimIndex = data2.getDimensionIndex(dimLoose);
          if (dimIndex >= 0) {
            val = extendParams.interpolatedValue[dimIndex];
          }
        }
        return val != null ? val + "" : "";
      });
    }
  };
  DataFormatMixin2.prototype.getRawValue = function(idx, dataType) {
    return retrieveRawValue(this.getData(dataType), idx);
  };
  DataFormatMixin2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return;
  };
  return DataFormatMixin2;
}();
function normalizeTooltipFormatResult(result) {
  var markupText;
  var markupFragment;
  if (isObject$6(result)) {
    if (result.type) {
      markupFragment = result;
    }
  } else {
    markupText = result;
  }
  return {
    text: markupText,
    frag: markupFragment
  };
}
function createTask(define) {
  return new Task(define);
}
var Task = function() {
  function Task2(define) {
    define = define || {};
    this._reset = define.reset;
    this._plan = define.plan;
    this._count = define.count;
    this._onDirty = define.onDirty;
    this._dirty = true;
  }
  Task2.prototype.perform = function(performArgs) {
    var upTask = this._upstream;
    var skip = performArgs && performArgs.skip;
    if (this._dirty && upTask) {
      var context = this.context;
      context.data = context.outputData = upTask.context.outputData;
    }
    if (this.__pipeline) {
      this.__pipeline.currentTask = this;
    }
    var planResult;
    if (this._plan && !skip) {
      planResult = this._plan(this.context);
    }
    var lastModBy = normalizeModBy(this._modBy);
    var lastModDataCount = this._modDataCount || 0;
    var modBy = normalizeModBy(performArgs && performArgs.modBy);
    var modDataCount = performArgs && performArgs.modDataCount || 0;
    if (lastModBy !== modBy || lastModDataCount !== modDataCount) {
      planResult = "reset";
    }
    function normalizeModBy(val) {
      !(val >= 1) && (val = 1);
      return val;
    }
    var forceFirstProgress;
    if (this._dirty || planResult === "reset") {
      this._dirty = false;
      forceFirstProgress = this._doReset(skip);
    }
    this._modBy = modBy;
    this._modDataCount = modDataCount;
    var step = performArgs && performArgs.step;
    if (upTask) {
      this._dueEnd = upTask._outputDueEnd;
    } else {
      this._dueEnd = this._count ? this._count(this.context) : Infinity;
    }
    if (this._progress) {
      var start2 = this._dueIndex;
      var end2 = Math.min(step != null ? this._dueIndex + step : Infinity, this._dueEnd);
      if (!skip && (forceFirstProgress || start2 < end2)) {
        var progress = this._progress;
        if (isArray$2(progress)) {
          for (var i = 0; i < progress.length; i++) {
            this._doProgress(progress[i], start2, end2, modBy, modDataCount);
          }
        } else {
          this._doProgress(progress, start2, end2, modBy, modDataCount);
        }
      }
      this._dueIndex = end2;
      var outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : end2;
      this._outputDueEnd = outputDueEnd;
    } else {
      this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
    }
    return this.unfinished();
  };
  Task2.prototype.dirty = function() {
    this._dirty = true;
    this._onDirty && this._onDirty(this.context);
  };
  Task2.prototype._doProgress = function(progress, start2, end2, modBy, modDataCount) {
    iterator.reset(start2, end2, modBy, modDataCount);
    this._callingProgress = progress;
    this._callingProgress({
      start: start2,
      end: end2,
      count: end2 - start2,
      next: iterator.next
    }, this.context);
  };
  Task2.prototype._doReset = function(skip) {
    this._dueIndex = this._outputDueEnd = this._dueEnd = 0;
    this._settedOutputEnd = null;
    var progress;
    var forceFirstProgress;
    if (!skip && this._reset) {
      progress = this._reset(this.context);
      if (progress && progress.progress) {
        forceFirstProgress = progress.forceFirstProgress;
        progress = progress.progress;
      }
      if (isArray$2(progress) && !progress.length) {
        progress = null;
      }
    }
    this._progress = progress;
    this._modBy = this._modDataCount = null;
    var downstream = this._downstream;
    downstream && downstream.dirty();
    return forceFirstProgress;
  };
  Task2.prototype.unfinished = function() {
    return this._progress && this._dueIndex < this._dueEnd;
  };
  Task2.prototype.pipe = function(downTask) {
    if (this._downstream !== downTask || this._dirty) {
      this._downstream = downTask;
      downTask._upstream = this;
      downTask.dirty();
    }
  };
  Task2.prototype.dispose = function() {
    if (this._disposed) {
      return;
    }
    this._upstream && (this._upstream._downstream = null);
    this._downstream && (this._downstream._upstream = null);
    this._dirty = false;
    this._disposed = true;
  };
  Task2.prototype.getUpstream = function() {
    return this._upstream;
  };
  Task2.prototype.getDownstream = function() {
    return this._downstream;
  };
  Task2.prototype.setOutputEnd = function(end2) {
    this._outputDueEnd = this._settedOutputEnd = end2;
  };
  return Task2;
}();
var iterator = function() {
  var end2;
  var current2;
  var modBy;
  var modDataCount;
  var winCount;
  var it = {
    reset: function(s, e2, sStep, sCount) {
      current2 = s;
      end2 = e2;
      modBy = sStep;
      modDataCount = sCount;
      winCount = Math.ceil(modDataCount / modBy);
      it.next = modBy > 1 && modDataCount > 0 ? modNext : sequentialNext;
    }
  };
  return it;
  function sequentialNext() {
    return current2 < end2 ? current2++ : null;
  }
  function modNext() {
    var dataIndex = current2 % winCount * modBy + Math.ceil(current2 / winCount);
    var result = current2 >= end2 ? null : dataIndex < modDataCount ? dataIndex : current2;
    current2++;
    return result;
  }
}();
function parseDataValue(value, opt) {
  var dimType = opt && opt.type;
  if (dimType === "ordinal") {
    return value;
  }
  if (dimType === "time" && !isNumber(value) && value != null && value !== "-") {
    value = +parseDate(value);
  }
  return value == null || value === "" ? NaN : +value;
}
var valueParserMap = createHashMap({
  "number": function(val) {
    return parseFloat(val);
  },
  "time": function(val) {
    return +parseDate(val);
  },
  "trim": function(val) {
    return isString$1(val) ? trim$1(val) : val;
  }
});
function getRawValueParser(type4) {
  return valueParserMap.get(type4);
}
var ORDER_COMPARISON_OP_MAP = {
  lt: function(lval, rval) {
    return lval < rval;
  },
  lte: function(lval, rval) {
    return lval <= rval;
  },
  gt: function(lval, rval) {
    return lval > rval;
  },
  gte: function(lval, rval) {
    return lval >= rval;
  }
};
var FilterOrderComparator = function() {
  function FilterOrderComparator2(op, rval) {
    if (!isNumber(rval)) {
      var errMsg = "";
      throwError$2(errMsg);
    }
    this._opFn = ORDER_COMPARISON_OP_MAP[op];
    this._rvalFloat = numericToNumber(rval);
  }
  FilterOrderComparator2.prototype.evaluate = function(lval) {
    return isNumber(lval) ? this._opFn(lval, this._rvalFloat) : this._opFn(numericToNumber(lval), this._rvalFloat);
  };
  return FilterOrderComparator2;
}();
var SortOrderComparator = function() {
  function SortOrderComparator2(order, incomparable) {
    var isDesc = order === "desc";
    this._resultLT = isDesc ? 1 : -1;
    if (incomparable == null) {
      incomparable = isDesc ? "min" : "max";
    }
    this._incomparable = incomparable === "min" ? -Infinity : Infinity;
  }
  SortOrderComparator2.prototype.evaluate = function(lval, rval) {
    var lvalFloat = isNumber(lval) ? lval : numericToNumber(lval);
    var rvalFloat = isNumber(rval) ? rval : numericToNumber(rval);
    var lvalNotNumeric = isNaN(lvalFloat);
    var rvalNotNumeric = isNaN(rvalFloat);
    if (lvalNotNumeric) {
      lvalFloat = this._incomparable;
    }
    if (rvalNotNumeric) {
      rvalFloat = this._incomparable;
    }
    if (lvalNotNumeric && rvalNotNumeric) {
      var lvalIsStr = isString$1(lval);
      var rvalIsStr = isString$1(rval);
      if (lvalIsStr) {
        lvalFloat = rvalIsStr ? lval : 0;
      }
      if (rvalIsStr) {
        rvalFloat = lvalIsStr ? rval : 0;
      }
    }
    return lvalFloat < rvalFloat ? this._resultLT : lvalFloat > rvalFloat ? -this._resultLT : 0;
  };
  return SortOrderComparator2;
}();
var FilterEqualityComparator = function() {
  function FilterEqualityComparator2(isEq, rval) {
    this._rval = rval;
    this._isEQ = isEq;
    this._rvalTypeof = typeof rval;
    this._rvalFloat = numericToNumber(rval);
  }
  FilterEqualityComparator2.prototype.evaluate = function(lval) {
    var eqResult = lval === this._rval;
    if (!eqResult) {
      var lvalTypeof = typeof lval;
      if (lvalTypeof !== this._rvalTypeof && (lvalTypeof === "number" || this._rvalTypeof === "number")) {
        eqResult = numericToNumber(lval) === this._rvalFloat;
      }
    }
    return this._isEQ ? eqResult : !eqResult;
  };
  return FilterEqualityComparator2;
}();
function createFilterComparator(op, rval) {
  return op === "eq" || op === "ne" ? new FilterEqualityComparator(op === "eq", rval) : hasOwn$1(ORDER_COMPARISON_OP_MAP, op) ? new FilterOrderComparator(op, rval) : null;
}
var ExternalSource = function() {
  function ExternalSource2() {
  }
  ExternalSource2.prototype.getRawData = function() {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.getRawDataItem = function(dataIndex) {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.cloneRawData = function() {
    return;
  };
  ExternalSource2.prototype.getDimensionInfo = function(dim) {
    return;
  };
  ExternalSource2.prototype.cloneAllDimensionInfo = function() {
    return;
  };
  ExternalSource2.prototype.count = function() {
    return;
  };
  ExternalSource2.prototype.retrieveValue = function(dataIndex, dimIndex) {
    return;
  };
  ExternalSource2.prototype.retrieveValueFromItem = function(dataItem, dimIndex) {
    return;
  };
  ExternalSource2.prototype.convertValue = function(rawVal, dimInfo) {
    return parseDataValue(rawVal, dimInfo);
  };
  return ExternalSource2;
}();
function createExternalSource(internalSource, externalTransform) {
  var extSource = new ExternalSource();
  var data2 = internalSource.data;
  var sourceFormat = extSource.sourceFormat = internalSource.sourceFormat;
  var sourceHeaderCount = internalSource.startIndex;
  var errMsg = "";
  if (internalSource.seriesLayoutBy !== SERIES_LAYOUT_BY_COLUMN) {
    throwError$2(errMsg);
  }
  var dimensions = [];
  var dimsByName = {};
  var dimsDef = internalSource.dimensionsDefine;
  if (dimsDef) {
    each$g(dimsDef, function(dimDef, idx) {
      var name2 = dimDef.name;
      var dimDefExt = {
        index: idx,
        name: name2,
        displayName: dimDef.displayName
      };
      dimensions.push(dimDefExt);
      if (name2 != null) {
        var errMsg_1 = "";
        if (hasOwn$1(dimsByName, name2)) {
          throwError$2(errMsg_1);
        }
        dimsByName[name2] = dimDefExt;
      }
    });
  } else {
    for (var i = 0; i < internalSource.dimensionsDetectedCount || 0; i++) {
      dimensions.push({
        index: i
      });
    }
  }
  var rawItemGetter = getRawSourceItemGetter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  if (externalTransform.__isBuiltIn) {
    extSource.getRawDataItem = function(dataIndex) {
      return rawItemGetter(data2, sourceHeaderCount, dimensions, dataIndex);
    };
    extSource.getRawData = bind$1(getRawData, null, internalSource);
  }
  extSource.cloneRawData = bind$1(cloneRawData, null, internalSource);
  var rawCounter = getRawSourceDataCounter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  extSource.count = bind$1(rawCounter, null, data2, sourceHeaderCount, dimensions);
  var rawValueGetter = getRawSourceValueGetter(sourceFormat);
  extSource.retrieveValue = function(dataIndex, dimIndex) {
    var rawItem = rawItemGetter(data2, sourceHeaderCount, dimensions, dataIndex);
    return retrieveValueFromItem(rawItem, dimIndex);
  };
  var retrieveValueFromItem = extSource.retrieveValueFromItem = function(dataItem, dimIndex) {
    if (dataItem == null) {
      return;
    }
    var dimDef = dimensions[dimIndex];
    if (dimDef) {
      return rawValueGetter(dataItem, dimIndex, dimDef.name);
    }
  };
  extSource.getDimensionInfo = bind$1(getDimensionInfo, null, dimensions, dimsByName);
  extSource.cloneAllDimensionInfo = bind$1(cloneAllDimensionInfo, null, dimensions);
  return extSource;
}
function getRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError$2(errMsg);
  }
  return upstream.data;
}
function cloneRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  var data2 = upstream.data;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError$2(errMsg);
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var result = [];
    for (var i = 0, len2 = data2.length; i < len2; i++) {
      result.push(data2[i].slice());
    }
    return result;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var result = [];
    for (var i = 0, len2 = data2.length; i < len2; i++) {
      result.push(extend({}, data2[i]));
    }
    return result;
  }
}
function getDimensionInfo(dimensions, dimsByName, dim) {
  if (dim == null) {
    return;
  }
  if (isNumber(dim) || !isNaN(dim) && !hasOwn$1(dimsByName, dim)) {
    return dimensions[dim];
  } else if (hasOwn$1(dimsByName, dim)) {
    return dimsByName[dim];
  }
}
function cloneAllDimensionInfo(dimensions) {
  return clone$4(dimensions);
}
var externalTransformMap = createHashMap();
function registerExternalTransform(externalTransform) {
  externalTransform = clone$4(externalTransform);
  var type4 = externalTransform.type;
  var errMsg = "";
  if (!type4) {
    throwError$2(errMsg);
  }
  var typeParsed = type4.split(":");
  if (typeParsed.length !== 2) {
    throwError$2(errMsg);
  }
  var isBuiltIn = false;
  if (typeParsed[0] === "echarts") {
    type4 = typeParsed[1];
    isBuiltIn = true;
  }
  externalTransform.__isBuiltIn = isBuiltIn;
  externalTransformMap.set(type4, externalTransform);
}
function applyDataTransform(rawTransOption, sourceList, infoForPrint) {
  var pipedTransOption = normalizeToArray(rawTransOption);
  var pipeLen = pipedTransOption.length;
  var errMsg = "";
  if (!pipeLen) {
    throwError$2(errMsg);
  }
  for (var i = 0, len2 = pipeLen; i < len2; i++) {
    var transOption = pipedTransOption[i];
    sourceList = applySingleDataTransform(transOption, sourceList);
    if (i !== len2 - 1) {
      sourceList.length = Math.max(sourceList.length, 1);
    }
  }
  return sourceList;
}
function applySingleDataTransform(transOption, upSourceList, infoForPrint, pipeIndex) {
  var errMsg = "";
  if (!upSourceList.length) {
    throwError$2(errMsg);
  }
  if (!isObject$6(transOption)) {
    throwError$2(errMsg);
  }
  var transType = transOption.type;
  var externalTransform = externalTransformMap.get(transType);
  if (!externalTransform) {
    throwError$2(errMsg);
  }
  var extUpSourceList = map$1(upSourceList, function(upSource) {
    return createExternalSource(upSource, externalTransform);
  });
  var resultList = normalizeToArray(externalTransform.transform({
    upstream: extUpSourceList[0],
    upstreamList: extUpSourceList,
    config: clone$4(transOption.config)
  }));
  return map$1(resultList, function(result, resultIndex) {
    var errMsg2 = "";
    if (!isObject$6(result)) {
      throwError$2(errMsg2);
    }
    if (!result.data) {
      throwError$2(errMsg2);
    }
    var sourceFormat = detectSourceFormat(result.data);
    if (!isSupportedSourceFormat(sourceFormat)) {
      throwError$2(errMsg2);
    }
    var resultMetaRawOption;
    var firstUpSource = upSourceList[0];
    if (firstUpSource && resultIndex === 0 && !result.dimensions) {
      var startIndex = firstUpSource.startIndex;
      if (startIndex) {
        result.data = firstUpSource.data.slice(0, startIndex).concat(result.data);
      }
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: startIndex,
        dimensions: firstUpSource.metaRawOption.dimensions
      };
    } else {
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: 0,
        dimensions: result.dimensions
      };
    }
    return createSource(result.data, resultMetaRawOption, null);
  });
}
function isSupportedSourceFormat(sourceFormat) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS || sourceFormat === SOURCE_FORMAT_OBJECT_ROWS;
}
var UNDEFINED$1 = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED$1 ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED$1 ? Array : Uint16Array;
var CtorInt32Array$1 = typeof Int32Array === UNDEFINED$1 ? Array : Int32Array;
var CtorFloat64Array = typeof Float64Array === UNDEFINED$1 ? Array : Float64Array;
var dataCtors = {
  "float": CtorFloat64Array,
  "int": CtorInt32Array$1,
  "ordinal": Array,
  "number": Array,
  "time": CtorFloat64Array
};
var defaultDimValueGetters;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function getInitialExtent() {
  return [Infinity, -Infinity];
}
function cloneChunk(originalChunk) {
  var Ctor = originalChunk.constructor;
  return Ctor === Array ? originalChunk.slice() : new Ctor(originalChunk);
}
function prepareStore(store, dimIdx, dimType, end2, append) {
  var DataCtor = dataCtors[dimType || "float"];
  if (append) {
    var oldStore = store[dimIdx];
    var oldLen = oldStore && oldStore.length;
    if (!(oldLen === end2)) {
      var newStore = new DataCtor(end2);
      for (var j = 0; j < oldLen; j++) {
        newStore[j] = oldStore[j];
      }
      store[dimIdx] = newStore;
    }
  } else {
    store[dimIdx] = new DataCtor(end2);
  }
}
var DataStore = function() {
  function DataStore2() {
    this._chunks = [];
    this._rawExtent = [];
    this._extent = [];
    this._count = 0;
    this._rawCount = 0;
    this._calcDimNameToIdx = createHashMap();
  }
  DataStore2.prototype.initData = function(provider, inputDimensions, dimValueGetter) {
    this._provider = provider;
    this._chunks = [];
    this._indices = null;
    this.getRawIndex = this._getRawIdxIdentity;
    var source = provider.getSource();
    var defaultGetter = this.defaultDimValueGetter = defaultDimValueGetters[source.sourceFormat];
    this._dimValueGetter = dimValueGetter || defaultGetter;
    this._rawExtent = [];
    shouldRetrieveDataByName(source);
    this._dimensions = map$1(inputDimensions, function(dim) {
      return {
        type: dim.type,
        property: dim.property
      };
    });
    this._initDataFromProvider(0, provider.count());
  };
  DataStore2.prototype.getProvider = function() {
    return this._provider;
  };
  DataStore2.prototype.getSource = function() {
    return this._provider.getSource();
  };
  DataStore2.prototype.ensureCalculationDimension = function(dimName, type4) {
    var calcDimNameToIdx = this._calcDimNameToIdx;
    var dimensions = this._dimensions;
    var calcDimIdx = calcDimNameToIdx.get(dimName);
    if (calcDimIdx != null) {
      if (dimensions[calcDimIdx].type === type4) {
        return calcDimIdx;
      }
    } else {
      calcDimIdx = dimensions.length;
    }
    dimensions[calcDimIdx] = {
      type: type4
    };
    calcDimNameToIdx.set(dimName, calcDimIdx);
    this._chunks[calcDimIdx] = new dataCtors[type4 || "float"](this._rawCount);
    this._rawExtent[calcDimIdx] = getInitialExtent();
    return calcDimIdx;
  };
  DataStore2.prototype.collectOrdinalMeta = function(dimIdx, ordinalMeta) {
    var chunk = this._chunks[dimIdx];
    var dim = this._dimensions[dimIdx];
    var rawExtents = this._rawExtent;
    var offset3 = dim.ordinalOffset || 0;
    var len2 = chunk.length;
    if (offset3 === 0) {
      rawExtents[dimIdx] = getInitialExtent();
    }
    var dimRawExtent = rawExtents[dimIdx];
    for (var i = offset3; i < len2; i++) {
      var val = chunk[i] = ordinalMeta.parseAndCollect(chunk[i]);
      dimRawExtent[0] = Math.min(val, dimRawExtent[0]);
      dimRawExtent[1] = Math.max(val, dimRawExtent[1]);
    }
    dim.ordinalMeta = ordinalMeta;
    dim.ordinalOffset = len2;
    dim.type = "ordinal";
  };
  DataStore2.prototype.getOrdinalMeta = function(dimIdx) {
    var dimInfo = this._dimensions[dimIdx];
    var ordinalMeta = dimInfo.ordinalMeta;
    return ordinalMeta;
  };
  DataStore2.prototype.getDimensionProperty = function(dimIndex) {
    var item = this._dimensions[dimIndex];
    return item && item.property;
  };
  DataStore2.prototype.appendData = function(data2) {
    var provider = this._provider;
    var start2 = this.count();
    provider.appendData(data2);
    var end2 = provider.count();
    if (!provider.persistent) {
      end2 += start2;
    }
    if (start2 < end2) {
      this._initDataFromProvider(start2, end2, true);
    }
    return [start2, end2];
  };
  DataStore2.prototype.appendValues = function(values, minFillLen) {
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var start2 = this.count();
    var end2 = start2 + Math.max(values.length, minFillLen || 0);
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      prepareStore(chunks, i, dim.type, end2, true);
    }
    var emptyDataItem = [];
    for (var idx = start2; idx < end2; idx++) {
      var sourceIdx = idx - start2;
      for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
        var dim = dimensions[dimIdx];
        var val = defaultDimValueGetters.arrayRows.call(this, values[sourceIdx] || emptyDataItem, dim.property, sourceIdx, dimIdx);
        chunks[dimIdx][idx] = val;
        var dimRawExtent = rawExtent[dimIdx];
        val < dimRawExtent[0] && (dimRawExtent[0] = val);
        val > dimRawExtent[1] && (dimRawExtent[1] = val);
      }
    }
    this._rawCount = this._count = end2;
    return {
      start: start2,
      end: end2
    };
  };
  DataStore2.prototype._initDataFromProvider = function(start2, end2, append) {
    var provider = this._provider;
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var dimNames = map$1(dimensions, function(dim2) {
      return dim2.property;
    });
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      if (!rawExtent[i]) {
        rawExtent[i] = getInitialExtent();
      }
      prepareStore(chunks, i, dim.type, end2, append);
    }
    if (provider.fillStorage) {
      provider.fillStorage(start2, end2, chunks, rawExtent);
    } else {
      var dataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        dataItem = provider.getItem(idx, dataItem);
        for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
          var dimStorage = chunks[dimIdx];
          var val = this._dimValueGetter(dataItem, dimNames[dimIdx], idx, dimIdx);
          dimStorage[idx] = val;
          var dimRawExtent = rawExtent[dimIdx];
          val < dimRawExtent[0] && (dimRawExtent[0] = val);
          val > dimRawExtent[1] && (dimRawExtent[1] = val);
        }
      }
    }
    if (!provider.persistent && provider.clean) {
      provider.clean();
    }
    this._rawCount = this._count = end2;
    this._extent = [];
  };
  DataStore2.prototype.count = function() {
    return this._count;
  };
  DataStore2.prototype.get = function(dim, idx) {
    if (!(idx >= 0 && idx < this._count)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[this.getRawIndex(idx)] : NaN;
  };
  DataStore2.prototype.getValues = function(dimensions, idx) {
    var values = [];
    var dimArr = [];
    if (idx == null) {
      idx = dimensions;
      dimensions = [];
      for (var i = 0; i < this._dimensions.length; i++) {
        dimArr.push(i);
      }
    } else {
      dimArr = dimensions;
    }
    for (var i = 0, len2 = dimArr.length; i < len2; i++) {
      values.push(this.get(dimArr[i], idx));
    }
    return values;
  };
  DataStore2.prototype.getByRawIndex = function(dim, rawIdx) {
    if (!(rawIdx >= 0 && rawIdx < this._rawCount)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[rawIdx] : NaN;
  };
  DataStore2.prototype.getSum = function(dim) {
    var dimData = this._chunks[dim];
    var sum2 = 0;
    if (dimData) {
      for (var i = 0, len2 = this.count(); i < len2; i++) {
        var value = this.get(dim, i);
        if (!isNaN(value)) {
          sum2 += value;
        }
      }
    }
    return sum2;
  };
  DataStore2.prototype.getMedian = function(dim) {
    var dimDataArray = [];
    this.each([dim], function(val) {
      if (!isNaN(val)) {
        dimDataArray.push(val);
      }
    });
    var sortedDimDataArray = dimDataArray.sort(function(a, b2) {
      return a - b2;
    });
    var len2 = this.count();
    return len2 === 0 ? 0 : len2 % 2 === 1 ? sortedDimDataArray[(len2 - 1) / 2] : (sortedDimDataArray[len2 / 2] + sortedDimDataArray[len2 / 2 - 1]) / 2;
  };
  DataStore2.prototype.indexOfRawIndex = function(rawIndex) {
    if (rawIndex >= this._rawCount || rawIndex < 0) {
      return -1;
    }
    if (!this._indices) {
      return rawIndex;
    }
    var indices = this._indices;
    var rawDataIndex = indices[rawIndex];
    if (rawDataIndex != null && rawDataIndex < this._count && rawDataIndex === rawIndex) {
      return rawIndex;
    }
    var left = 0;
    var right = this._count - 1;
    while (left <= right) {
      var mid = (left + right) / 2 | 0;
      if (indices[mid] < rawIndex) {
        left = mid + 1;
      } else if (indices[mid] > rawIndex) {
        right = mid - 1;
      } else {
        return mid;
      }
    }
    return -1;
  };
  DataStore2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    var chunks = this._chunks;
    var dimData = chunks[dim];
    var nearestIndices = [];
    if (!dimData) {
      return nearestIndices;
    }
    if (maxDistance == null) {
      maxDistance = Infinity;
    }
    var minDist = Infinity;
    var minDiff = -1;
    var nearestIndicesLen = 0;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var dataIndex = this.getRawIndex(i);
      var diff = value - dimData[dataIndex];
      var dist2 = Math.abs(diff);
      if (dist2 <= maxDistance) {
        if (dist2 < minDist || dist2 === minDist && diff >= 0 && minDiff < 0) {
          minDist = dist2;
          minDiff = diff;
          nearestIndicesLen = 0;
        }
        if (diff === minDiff) {
          nearestIndices[nearestIndicesLen++] = i;
        }
      }
    }
    nearestIndices.length = nearestIndicesLen;
    return nearestIndices;
  };
  DataStore2.prototype.getIndices = function() {
    var newIndices;
    var indices = this._indices;
    if (indices) {
      var Ctor = indices.constructor;
      var thisCount = this._count;
      if (Ctor === Array) {
        newIndices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          newIndices[i] = indices[i];
        }
      } else {
        newIndices = new Ctor(indices.buffer, 0, thisCount);
      }
    } else {
      var Ctor = getIndicesCtor(this._rawCount);
      newIndices = new Ctor(this.count());
      for (var i = 0; i < newIndices.length; i++) {
        newIndices[i] = i;
      }
    }
    return newIndices;
  };
  DataStore2.prototype.filter = function(dims, cb2) {
    if (!this._count) {
      return this;
    }
    var newStore = this.clone();
    var count2 = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(count2);
    var value = [];
    var dimSize = dims.length;
    var offset3 = 0;
    var dim0 = dims[0];
    var chunks = newStore._chunks;
    for (var i = 0; i < count2; i++) {
      var keep = void 0;
      var rawIdx = newStore.getRawIndex(i);
      if (dimSize === 0) {
        keep = cb2(i);
      } else if (dimSize === 1) {
        var val = chunks[dim0][rawIdx];
        keep = cb2(val, i);
      } else {
        var k2 = 0;
        for (; k2 < dimSize; k2++) {
          value[k2] = chunks[dims[k2]][rawIdx];
        }
        value[k2] = i;
        keep = cb2.apply(null, value);
      }
      if (keep) {
        newIndices[offset3++] = rawIdx;
      }
    }
    if (offset3 < count2) {
      newStore._indices = newIndices;
    }
    newStore._count = offset3;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.selectRange = function(range3) {
    var newStore = this.clone();
    var len2 = newStore._count;
    if (!len2) {
      return this;
    }
    var dims = keys(range3);
    var dimSize = dims.length;
    if (!dimSize) {
      return this;
    }
    var originalCount = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(originalCount);
    var offset3 = 0;
    var dim0 = dims[0];
    var min3 = range3[dim0][0];
    var max3 = range3[dim0][1];
    var storeArr = newStore._chunks;
    var quickFinished = false;
    if (!newStore._indices) {
      var idx = 0;
      if (dimSize === 1) {
        var dimStorage = storeArr[dims[0]];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset3++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      } else if (dimSize === 2) {
        var dimStorage = storeArr[dims[0]];
        var dimStorage2 = storeArr[dims[1]];
        var min22 = range3[dims[1]][0];
        var max22 = range3[dims[1]][1];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          var val2 = dimStorage2[i];
          if ((val >= min3 && val <= max3 || isNaN(val)) && (val2 >= min22 && val2 <= max22 || isNaN(val2))) {
            newIndices[offset3++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      }
    }
    if (!quickFinished) {
      if (dimSize === 1) {
        for (var i = 0; i < originalCount; i++) {
          var rawIndex = newStore.getRawIndex(i);
          var val = storeArr[dims[0]][rawIndex];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset3++] = rawIndex;
          }
        }
      } else {
        for (var i = 0; i < originalCount; i++) {
          var keep = true;
          var rawIndex = newStore.getRawIndex(i);
          for (var k2 = 0; k2 < dimSize; k2++) {
            var dimk = dims[k2];
            var val = storeArr[dimk][rawIndex];
            if (val < range3[dimk][0] || val > range3[dimk][1]) {
              keep = false;
            }
          }
          if (keep) {
            newIndices[offset3++] = newStore.getRawIndex(i);
          }
        }
      }
    }
    if (offset3 < originalCount) {
      newStore._indices = newIndices;
    }
    newStore._count = offset3;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.map = function(dims, cb2) {
    var target = this.clone(dims);
    this._updateDims(target, dims, cb2);
    return target;
  };
  DataStore2.prototype.modify = function(dims, cb2) {
    this._updateDims(this, dims, cb2);
  };
  DataStore2.prototype._updateDims = function(target, dims, cb2) {
    var targetChunks = target._chunks;
    var tmpRetValue = [];
    var dimSize = dims.length;
    var dataCount = target.count();
    var values = [];
    var rawExtent = target._rawExtent;
    for (var i = 0; i < dims.length; i++) {
      rawExtent[dims[i]] = getInitialExtent();
    }
    for (var dataIndex = 0; dataIndex < dataCount; dataIndex++) {
      var rawIndex = target.getRawIndex(dataIndex);
      for (var k2 = 0; k2 < dimSize; k2++) {
        values[k2] = targetChunks[dims[k2]][rawIndex];
      }
      values[dimSize] = dataIndex;
      var retValue = cb2 && cb2.apply(null, values);
      if (retValue != null) {
        if (typeof retValue !== "object") {
          tmpRetValue[0] = retValue;
          retValue = tmpRetValue;
        }
        for (var i = 0; i < retValue.length; i++) {
          var dim = dims[i];
          var val = retValue[i];
          var rawExtentOnDim = rawExtent[dim];
          var dimStore = targetChunks[dim];
          if (dimStore) {
            dimStore[rawIndex] = val;
          }
          if (val < rawExtentOnDim[0]) {
            rawExtentOnDim[0] = val;
          }
          if (val > rawExtentOnDim[1]) {
            rawExtentOnDim[1] = val;
          }
        }
      }
    }
  };
  DataStore2.prototype.lttbDownSample = function(valueDimension, rate) {
    var target = this.clone([valueDimension], true);
    var targetStorage = target._chunks;
    var dimStore = targetStorage[valueDimension];
    var len2 = this.count();
    var sampledIndex = 0;
    var frameSize = Math.floor(1 / rate);
    var currentRawIndex = this.getRawIndex(0);
    var maxArea;
    var area;
    var nextRawIndex;
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.min((Math.ceil(len2 / frameSize) + 2) * 2, len2));
    newIndices[sampledIndex++] = currentRawIndex;
    for (var i = 1; i < len2 - 1; i += frameSize) {
      var nextFrameStart = Math.min(i + frameSize, len2 - 1);
      var nextFrameEnd = Math.min(i + frameSize * 2, len2);
      var avgX = (nextFrameEnd + nextFrameStart) / 2;
      var avgY = 0;
      for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          continue;
        }
        avgY += y2;
      }
      avgY /= nextFrameEnd - nextFrameStart;
      var frameStart = i;
      var frameEnd = Math.min(i + frameSize, len2);
      var pointAX = i - 1;
      var pointAY = dimStore[currentRawIndex];
      maxArea = -1;
      nextRawIndex = frameStart;
      var firstNaNIndex = -1;
      var countNaN = 0;
      for (var idx = frameStart; idx < frameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          countNaN++;
          if (firstNaNIndex < 0) {
            firstNaNIndex = rawIndex;
          }
          continue;
        }
        area = Math.abs((pointAX - avgX) * (y2 - pointAY) - (pointAX - idx) * (avgY - pointAY));
        if (area > maxArea) {
          maxArea = area;
          nextRawIndex = rawIndex;
        }
      }
      if (countNaN > 0 && countNaN < frameEnd - frameStart) {
        newIndices[sampledIndex++] = Math.min(firstNaNIndex, nextRawIndex);
        nextRawIndex = Math.max(firstNaNIndex, nextRawIndex);
      }
      newIndices[sampledIndex++] = nextRawIndex;
      currentRawIndex = nextRawIndex;
    }
    newIndices[sampledIndex++] = this.getRawIndex(len2 - 1);
    target._count = sampledIndex;
    target._indices = newIndices;
    target.getRawIndex = this._getRawIdx;
    return target;
  };
  DataStore2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var target = this.clone([dimension], true);
    var targetStorage = target._chunks;
    var frameValues = [];
    var frameSize = Math.floor(1 / rate);
    var dimStore = targetStorage[dimension];
    var len2 = this.count();
    var rawExtentOnDim = target._rawExtent[dimension] = getInitialExtent();
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.ceil(len2 / frameSize));
    var offset3 = 0;
    for (var i = 0; i < len2; i += frameSize) {
      if (frameSize > len2 - i) {
        frameSize = len2 - i;
        frameValues.length = frameSize;
      }
      for (var k2 = 0; k2 < frameSize; k2++) {
        var dataIdx = this.getRawIndex(i + k2);
        frameValues[k2] = dimStore[dataIdx];
      }
      var value = sampleValue(frameValues);
      var sampleFrameIdx = this.getRawIndex(Math.min(i + sampleIndex(frameValues, value) || 0, len2 - 1));
      dimStore[sampleFrameIdx] = value;
      if (value < rawExtentOnDim[0]) {
        rawExtentOnDim[0] = value;
      }
      if (value > rawExtentOnDim[1]) {
        rawExtentOnDim[1] = value;
      }
      newIndices[offset3++] = sampleFrameIdx;
    }
    target._count = offset3;
    target._indices = newIndices;
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype.each = function(dims, cb2) {
    if (!this._count) {
      return;
    }
    var dimSize = dims.length;
    var chunks = this._chunks;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var rawIdx = this.getRawIndex(i);
      switch (dimSize) {
        case 0:
          cb2(i);
          break;
        case 1:
          cb2(chunks[dims[0]][rawIdx], i);
          break;
        case 2:
          cb2(chunks[dims[0]][rawIdx], chunks[dims[1]][rawIdx], i);
          break;
        default:
          var k2 = 0;
          var value = [];
          for (; k2 < dimSize; k2++) {
            value[k2] = chunks[dims[k2]][rawIdx];
          }
          value[k2] = i;
          cb2.apply(null, value);
      }
    }
  };
  DataStore2.prototype.getDataExtent = function(dim) {
    var dimData = this._chunks[dim];
    var initialExtent = getInitialExtent();
    if (!dimData) {
      return initialExtent;
    }
    var currEnd = this.count();
    var useRaw = !this._indices;
    var dimExtent;
    if (useRaw) {
      return this._rawExtent[dim].slice();
    }
    dimExtent = this._extent[dim];
    if (dimExtent) {
      return dimExtent.slice();
    }
    dimExtent = initialExtent;
    var min3 = dimExtent[0];
    var max3 = dimExtent[1];
    for (var i = 0; i < currEnd; i++) {
      var rawIdx = this.getRawIndex(i);
      var value = dimData[rawIdx];
      value < min3 && (min3 = value);
      value > max3 && (max3 = value);
    }
    dimExtent = [min3, max3];
    this._extent[dim] = dimExtent;
    return dimExtent;
  };
  DataStore2.prototype.getRawDataItem = function(idx) {
    var rawIdx = this.getRawIndex(idx);
    if (!this._provider.persistent) {
      var val = [];
      var chunks = this._chunks;
      for (var i = 0; i < chunks.length; i++) {
        val.push(chunks[i][rawIdx]);
      }
      return val;
    } else {
      return this._provider.getItem(rawIdx);
    }
  };
  DataStore2.prototype.clone = function(clonedDims, ignoreIndices) {
    var target = new DataStore2();
    var chunks = this._chunks;
    var clonedDimsMap = clonedDims && reduce(clonedDims, function(obj, dimIdx) {
      obj[dimIdx] = true;
      return obj;
    }, {});
    if (clonedDimsMap) {
      for (var i = 0; i < chunks.length; i++) {
        target._chunks[i] = !clonedDimsMap[i] ? chunks[i] : cloneChunk(chunks[i]);
      }
    } else {
      target._chunks = chunks;
    }
    this._copyCommonProps(target);
    if (!ignoreIndices) {
      target._indices = this._cloneIndices();
    }
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype._copyCommonProps = function(target) {
    target._count = this._count;
    target._rawCount = this._rawCount;
    target._provider = this._provider;
    target._dimensions = this._dimensions;
    target._extent = clone$4(this._extent);
    target._rawExtent = clone$4(this._rawExtent);
  };
  DataStore2.prototype._cloneIndices = function() {
    if (this._indices) {
      var Ctor = this._indices.constructor;
      var indices = void 0;
      if (Ctor === Array) {
        var thisCount = this._indices.length;
        indices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          indices[i] = this._indices[i];
        }
      } else {
        indices = new Ctor(this._indices);
      }
      return indices;
    }
    return null;
  };
  DataStore2.prototype._getRawIdxIdentity = function(idx) {
    return idx;
  };
  DataStore2.prototype._getRawIdx = function(idx) {
    if (idx < this._count && idx >= 0) {
      return this._indices[idx];
    }
    return -1;
  };
  DataStore2.prototype._updateGetRawIdx = function() {
    this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
  };
  DataStore2.internalField = function() {
    function getDimValueSimply(dataItem, property, dataIndex, dimIndex) {
      return parseDataValue(dataItem[dimIndex], this._dimensions[dimIndex]);
    }
    defaultDimValueGetters = {
      arrayRows: getDimValueSimply,
      objectRows: function(dataItem, property, dataIndex, dimIndex) {
        return parseDataValue(dataItem[property], this._dimensions[dimIndex]);
      },
      keyedColumns: getDimValueSimply,
      original: function(dataItem, property, dataIndex, dimIndex) {
        var value = dataItem && (dataItem.value == null ? dataItem : dataItem.value);
        return parseDataValue(value instanceof Array ? value[dimIndex] : value, this._dimensions[dimIndex]);
      },
      typedArray: function(dataItem, property, dataIndex, dimIndex) {
        return dataItem[dimIndex];
      }
    };
  }();
  return DataStore2;
}();
var SourceManager = function() {
  function SourceManager2(sourceHost) {
    this._sourceList = [];
    this._storeList = [];
    this._upstreamSignList = [];
    this._versionSignBase = 0;
    this._dirty = true;
    this._sourceHost = sourceHost;
  }
  SourceManager2.prototype.dirty = function() {
    this._setLocalSource([], []);
    this._storeList = [];
    this._dirty = true;
  };
  SourceManager2.prototype._setLocalSource = function(sourceList, upstreamSignList) {
    this._sourceList = sourceList;
    this._upstreamSignList = upstreamSignList;
    this._versionSignBase++;
    if (this._versionSignBase > 9e10) {
      this._versionSignBase = 0;
    }
  };
  SourceManager2.prototype._getVersionSign = function() {
    return this._sourceHost.uid + "_" + this._versionSignBase;
  };
  SourceManager2.prototype.prepareSource = function() {
    if (this._isDirty()) {
      this._createSource();
      this._dirty = false;
    }
  };
  SourceManager2.prototype._createSource = function() {
    this._setLocalSource([], []);
    var sourceHost = this._sourceHost;
    var upSourceMgrList = this._getUpstreamSourceManagers();
    var hasUpstream = !!upSourceMgrList.length;
    var resultSourceList;
    var upstreamSignList;
    if (isSeries(sourceHost)) {
      var seriesModel = sourceHost;
      var data2 = void 0;
      var sourceFormat = void 0;
      var upSource = void 0;
      if (hasUpstream) {
        var upSourceMgr = upSourceMgrList[0];
        upSourceMgr.prepareSource();
        upSource = upSourceMgr.getSource();
        data2 = upSource.data;
        sourceFormat = upSource.sourceFormat;
        upstreamSignList = [upSourceMgr._getVersionSign()];
      } else {
        data2 = seriesModel.get("data", true);
        sourceFormat = isTypedArray(data2) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL;
        upstreamSignList = [];
      }
      var newMetaRawOption = this._getSourceMetaRawOption() || {};
      var upMetaRawOption = upSource && upSource.metaRawOption || {};
      var seriesLayoutBy = retrieve2(newMetaRawOption.seriesLayoutBy, upMetaRawOption.seriesLayoutBy) || null;
      var sourceHeader = retrieve2(newMetaRawOption.sourceHeader, upMetaRawOption.sourceHeader);
      var dimensions = retrieve2(newMetaRawOption.dimensions, upMetaRawOption.dimensions);
      var needsCreateSource = seriesLayoutBy !== upMetaRawOption.seriesLayoutBy || !!sourceHeader !== !!upMetaRawOption.sourceHeader || dimensions;
      resultSourceList = needsCreateSource ? [createSource(data2, {
        seriesLayoutBy,
        sourceHeader,
        dimensions
      }, sourceFormat)] : [];
    } else {
      var datasetModel = sourceHost;
      if (hasUpstream) {
        var result = this._applyTransform(upSourceMgrList);
        resultSourceList = result.sourceList;
        upstreamSignList = result.upstreamSignList;
      } else {
        var sourceData = datasetModel.get("source", true);
        resultSourceList = [createSource(sourceData, this._getSourceMetaRawOption(), null)];
        upstreamSignList = [];
      }
    }
    this._setLocalSource(resultSourceList, upstreamSignList);
  };
  SourceManager2.prototype._applyTransform = function(upMgrList) {
    var datasetModel = this._sourceHost;
    var transformOption = datasetModel.get("transform", true);
    var fromTransformResult = datasetModel.get("fromTransformResult", true);
    if (fromTransformResult != null) {
      var errMsg = "";
      if (upMgrList.length !== 1) {
        doThrow(errMsg);
      }
    }
    var sourceList;
    var upSourceList = [];
    var upstreamSignList = [];
    each$g(upMgrList, function(upMgr) {
      upMgr.prepareSource();
      var upSource = upMgr.getSource(fromTransformResult || 0);
      var errMsg2 = "";
      if (fromTransformResult != null && !upSource) {
        doThrow(errMsg2);
      }
      upSourceList.push(upSource);
      upstreamSignList.push(upMgr._getVersionSign());
    });
    if (transformOption) {
      sourceList = applyDataTransform(transformOption, upSourceList, {
        datasetIndex: datasetModel.componentIndex
      });
    } else if (fromTransformResult != null) {
      sourceList = [cloneSourceShallow(upSourceList[0])];
    }
    return {
      sourceList,
      upstreamSignList
    };
  };
  SourceManager2.prototype._isDirty = function() {
    if (this._dirty) {
      return true;
    }
    var upSourceMgrList = this._getUpstreamSourceManagers();
    for (var i = 0; i < upSourceMgrList.length; i++) {
      var upSrcMgr = upSourceMgrList[i];
      if (upSrcMgr._isDirty() || this._upstreamSignList[i] !== upSrcMgr._getVersionSign()) {
        return true;
      }
    }
  };
  SourceManager2.prototype.getSource = function(sourceIndex) {
    sourceIndex = sourceIndex || 0;
    var source = this._sourceList[sourceIndex];
    if (!source) {
      var upSourceMgrList = this._getUpstreamSourceManagers();
      return upSourceMgrList[0] && upSourceMgrList[0].getSource(sourceIndex);
    }
    return source;
  };
  SourceManager2.prototype.getSharedDataStore = function(seriesDimRequest) {
    var schema = seriesDimRequest.makeStoreSchema();
    return this._innerGetDataStore(schema.dimensions, seriesDimRequest.source, schema.hash);
  };
  SourceManager2.prototype._innerGetDataStore = function(storeDims, seriesSource, sourceReadKey) {
    var sourceIndex = 0;
    var storeList = this._storeList;
    var cachedStoreMap = storeList[sourceIndex];
    if (!cachedStoreMap) {
      cachedStoreMap = storeList[sourceIndex] = {};
    }
    var cachedStore = cachedStoreMap[sourceReadKey];
    if (!cachedStore) {
      var upSourceMgr = this._getUpstreamSourceManagers()[0];
      if (isSeries(this._sourceHost) && upSourceMgr) {
        cachedStore = upSourceMgr._innerGetDataStore(storeDims, seriesSource, sourceReadKey);
      } else {
        cachedStore = new DataStore();
        cachedStore.initData(new DefaultDataProvider(seriesSource, storeDims.length), storeDims);
      }
      cachedStoreMap[sourceReadKey] = cachedStore;
    }
    return cachedStore;
  };
  SourceManager2.prototype._getUpstreamSourceManagers = function() {
    var sourceHost = this._sourceHost;
    if (isSeries(sourceHost)) {
      var datasetModel = querySeriesUpstreamDatasetModel(sourceHost);
      return !datasetModel ? [] : [datasetModel.getSourceManager()];
    } else {
      return map$1(queryDatasetUpstreamDatasetModels(sourceHost), function(datasetModel2) {
        return datasetModel2.getSourceManager();
      });
    }
  };
  SourceManager2.prototype._getSourceMetaRawOption = function() {
    var sourceHost = this._sourceHost;
    var seriesLayoutBy;
    var sourceHeader;
    var dimensions;
    if (isSeries(sourceHost)) {
      seriesLayoutBy = sourceHost.get("seriesLayoutBy", true);
      sourceHeader = sourceHost.get("sourceHeader", true);
      dimensions = sourceHost.get("dimensions", true);
    } else if (!this._getUpstreamSourceManagers().length) {
      var model = sourceHost;
      seriesLayoutBy = model.get("seriesLayoutBy", true);
      sourceHeader = model.get("sourceHeader", true);
      dimensions = model.get("dimensions", true);
    }
    return {
      seriesLayoutBy,
      sourceHeader,
      dimensions
    };
  };
  return SourceManager2;
}();
function disableTransformOptionMerge(datasetModel) {
  var transformOption = datasetModel.option.transform;
  transformOption && setAsPrimitive(datasetModel.option.transform);
}
function isSeries(sourceHost) {
  return sourceHost.mainType === "series";
}
function doThrow(errMsg) {
  throw new Error(errMsg);
}
var TOOLTIP_LINE_HEIGHT_CSS = "line-height:1";
function getTooltipTextStyle(textStyle, renderMode) {
  var nameFontColor = textStyle.color || "#6e7079";
  var nameFontSize = textStyle.fontSize || 12;
  var nameFontWeight = textStyle.fontWeight || "400";
  var valueFontColor = textStyle.color || "#464646";
  var valueFontSize = textStyle.fontSize || 14;
  var valueFontWeight = textStyle.fontWeight || "900";
  if (renderMode === "html") {
    return {
      nameStyle: "font-size:" + encodeHTML(nameFontSize + "") + "px;color:" + encodeHTML(nameFontColor) + ";font-weight:" + encodeHTML(nameFontWeight + ""),
      valueStyle: "font-size:" + encodeHTML(valueFontSize + "") + "px;color:" + encodeHTML(valueFontColor) + ";font-weight:" + encodeHTML(valueFontWeight + "")
    };
  } else {
    return {
      nameStyle: {
        fontSize: nameFontSize,
        fill: nameFontColor,
        fontWeight: nameFontWeight
      },
      valueStyle: {
        fontSize: valueFontSize,
        fill: valueFontColor,
        fontWeight: valueFontWeight
      }
    };
  }
}
var HTML_GAPS = [0, 10, 20, 30];
var RICH_TEXT_GAPS = ["", "\n", "\n\n", "\n\n\n"];
function createTooltipMarkup(type4, option) {
  option.type = type4;
  return option;
}
function isSectionFragment(frag) {
  return frag.type === "section";
}
function getBuilder(frag) {
  return isSectionFragment(frag) ? buildSection : buildNameValue;
}
function getBlockGapLevel(frag) {
  if (isSectionFragment(frag)) {
    var gapLevel_1 = 0;
    var subBlockLen = frag.blocks.length;
    var hasInnerGap_1 = subBlockLen > 1 || subBlockLen > 0 && !frag.noHeader;
    each$g(frag.blocks, function(subBlock) {
      var subGapLevel = getBlockGapLevel(subBlock);
      if (subGapLevel >= gapLevel_1) {
        gapLevel_1 = subGapLevel + +(hasInnerGap_1 && (!subGapLevel || isSectionFragment(subBlock) && !subBlock.noHeader));
      }
    });
    return gapLevel_1;
  }
  return 0;
}
function buildSection(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var noHeader = fragment.noHeader;
  var gaps = getGap(getBlockGapLevel(fragment));
  var subMarkupTextList = [];
  var subBlocks = fragment.blocks || [];
  assert(!subBlocks || isArray$2(subBlocks));
  subBlocks = subBlocks || [];
  var orderMode = ctx.orderMode;
  if (fragment.sortBlocks && orderMode) {
    subBlocks = subBlocks.slice();
    var orderMap = {
      valueAsc: "asc",
      valueDesc: "desc"
    };
    if (hasOwn$1(orderMap, orderMode)) {
      var comparator_1 = new SortOrderComparator(orderMap[orderMode], null);
      subBlocks.sort(function(a, b2) {
        return comparator_1.evaluate(a.sortParam, b2.sortParam);
      });
    } else if (orderMode === "seriesDesc") {
      subBlocks.reverse();
    }
  }
  each$g(subBlocks, function(subBlock, idx) {
    var valueFormatter = fragment.valueFormatter;
    var subMarkupText2 = getBuilder(subBlock)(valueFormatter ? extend(extend({}, ctx), {
      valueFormatter
    }) : ctx, subBlock, idx > 0 ? gaps.html : 0, toolTipTextStyle);
    subMarkupText2 != null && subMarkupTextList.push(subMarkupText2);
  });
  var subMarkupText = ctx.renderMode === "richText" ? subMarkupTextList.join(gaps.richText) : wrapBlockHTML(subMarkupTextList.join(""), noHeader ? topMarginForOuterGap : gaps.html);
  if (noHeader) {
    return subMarkupText;
  }
  var displayableHeader = makeValueReadable(fragment.header, "ordinal", ctx.useUTC);
  var nameStyle = getTooltipTextStyle(toolTipTextStyle, ctx.renderMode).nameStyle;
  if (ctx.renderMode === "richText") {
    return wrapInlineNameRichText(ctx, displayableHeader, nameStyle) + gaps.richText + subMarkupText;
  } else {
    return wrapBlockHTML('<div style="' + nameStyle + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodeHTML(displayableHeader) + "</div>" + subMarkupText, topMarginForOuterGap);
  }
}
function buildNameValue(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var renderMode = ctx.renderMode;
  var noName = fragment.noName;
  var noValue = fragment.noValue;
  var noMarker = !fragment.markerType;
  var name2 = fragment.name;
  var useUTC = ctx.useUTC;
  var valueFormatter = fragment.valueFormatter || ctx.valueFormatter || function(value) {
    value = isArray$2(value) ? value : [value];
    return map$1(value, function(val, idx) {
      return makeValueReadable(val, isArray$2(valueTypeOption) ? valueTypeOption[idx] : valueTypeOption, useUTC);
    });
  };
  if (noName && noValue) {
    return;
  }
  var markerStr = noMarker ? "" : ctx.markupStyleCreator.makeTooltipMarker(fragment.markerType, fragment.markerColor || "#333", renderMode);
  var readableName = noName ? "" : makeValueReadable(name2, "ordinal", useUTC);
  var valueTypeOption = fragment.valueType;
  var readableValueList = noValue ? [] : valueFormatter(fragment.value);
  var valueAlignRight = !noMarker || !noName;
  var valueCloseToMarker = !noMarker && noName;
  var _a2 = getTooltipTextStyle(toolTipTextStyle, renderMode), nameStyle = _a2.nameStyle, valueStyle = _a2.valueStyle;
  return renderMode === "richText" ? (noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameRichText(ctx, readableName, nameStyle)) + (noValue ? "" : wrapInlineValueRichText(ctx, readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)) : wrapBlockHTML((noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameHTML(readableName, !noMarker, nameStyle)) + (noValue ? "" : wrapInlineValueHTML(readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)), topMarginForOuterGap);
}
function buildTooltipMarkup(fragment, markupStyleCreator, renderMode, orderMode, useUTC, toolTipTextStyle) {
  if (!fragment) {
    return;
  }
  var builder = getBuilder(fragment);
  var ctx = {
    useUTC,
    renderMode,
    orderMode,
    markupStyleCreator,
    valueFormatter: fragment.valueFormatter
  };
  return builder(ctx, fragment, 0, toolTipTextStyle);
}
function getGap(gapLevel) {
  return {
    html: HTML_GAPS[gapLevel],
    richText: RICH_TEXT_GAPS[gapLevel]
  };
}
function wrapBlockHTML(encodedContent, topGap) {
  var clearfix = '<div style="clear:both"></div>';
  var marginCSS = "margin: " + topGap + "px 0 0";
  return '<div style="' + marginCSS + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodedContent + clearfix + "</div>";
}
function wrapInlineNameHTML(name2, leftHasMarker, style2) {
  var marginCss = leftHasMarker ? "margin-left:2px" : "";
  return '<span style="' + style2 + ";" + marginCss + '">' + encodeHTML(name2) + "</span>";
}
function wrapInlineValueHTML(valueList, alignRight, valueCloseToMarker, style2) {
  var paddingStr = valueCloseToMarker ? "10px" : "20px";
  var alignCSS = alignRight ? "float:right;margin-left:" + paddingStr : "";
  valueList = isArray$2(valueList) ? valueList : [valueList];
  return '<span style="' + alignCSS + ";" + style2 + '">' + map$1(valueList, function(value) {
    return encodeHTML(value);
  }).join("&nbsp;&nbsp;") + "</span>";
}
function wrapInlineNameRichText(ctx, name2, style2) {
  return ctx.markupStyleCreator.wrapRichTextStyle(name2, style2);
}
function wrapInlineValueRichText(ctx, values, alignRight, valueCloseToMarker, style2) {
  var styles2 = [style2];
  var paddingLeft = valueCloseToMarker ? 10 : 20;
  alignRight && styles2.push({
    padding: [0, 0, 0, paddingLeft],
    align: "right"
  });
  return ctx.markupStyleCreator.wrapRichTextStyle(isArray$2(values) ? values.join("  ") : values, styles2);
}
function retrieveVisualColorForTooltipMarker(series, dataIndex) {
  var style2 = series.getData().getItemVisual(dataIndex, "style");
  var color = style2[series.visualDrawType];
  return convertToColorString(color);
}
function getPaddingFromTooltipModel(model, renderMode) {
  var padding = model.get("padding");
  return padding != null ? padding : renderMode === "richText" ? [8, 10] : 10;
}
var TooltipMarkupStyleCreator = function() {
  function TooltipMarkupStyleCreator2() {
    this.richTextStyles = {};
    this._nextStyleNameId = getRandomIdBase();
  }
  TooltipMarkupStyleCreator2.prototype._generateStyleName = function() {
    return "__EC_aUTo_" + this._nextStyleNameId++;
  };
  TooltipMarkupStyleCreator2.prototype.makeTooltipMarker = function(markerType, colorStr, renderMode) {
    var markerId = renderMode === "richText" ? this._generateStyleName() : null;
    var marker = getTooltipMarker({
      color: colorStr,
      type: markerType,
      renderMode,
      markerId
    });
    if (isString$1(marker)) {
      return marker;
    } else {
      this.richTextStyles[markerId] = marker.style;
      return marker.content;
    }
  };
  TooltipMarkupStyleCreator2.prototype.wrapRichTextStyle = function(text, styles2) {
    var finalStl = {};
    if (isArray$2(styles2)) {
      each$g(styles2, function(stl) {
        return extend(finalStl, stl);
      });
    } else {
      extend(finalStl, styles2);
    }
    var styleName = this._generateStyleName();
    this.richTextStyles[styleName] = finalStl;
    return "{" + styleName + "|" + text + "}";
  };
  return TooltipMarkupStyleCreator2;
}();
function defaultSeriesFormatTooltip(opt) {
  var series = opt.series;
  var dataIndex = opt.dataIndex;
  var multipleSeries = opt.multipleSeries;
  var data2 = series.getData();
  var tooltipDims = data2.mapDimensionsAll("defaultedTooltip");
  var tooltipDimLen = tooltipDims.length;
  var value = series.getRawValue(dataIndex);
  var isValueArr = isArray$2(value);
  var markerColor = retrieveVisualColorForTooltipMarker(series, dataIndex);
  var inlineValue;
  var inlineValueType;
  var subBlocks;
  var sortParam;
  if (tooltipDimLen > 1 || isValueArr && !tooltipDimLen) {
    var formatArrResult = formatTooltipArrayValue(value, series, dataIndex, tooltipDims, markerColor);
    inlineValue = formatArrResult.inlineValues;
    inlineValueType = formatArrResult.inlineValueTypes;
    subBlocks = formatArrResult.blocks;
    sortParam = formatArrResult.inlineValues[0];
  } else if (tooltipDimLen) {
    var dimInfo = data2.getDimensionInfo(tooltipDims[0]);
    sortParam = inlineValue = retrieveRawValue(data2, dataIndex, tooltipDims[0]);
    inlineValueType = dimInfo.type;
  } else {
    sortParam = inlineValue = isValueArr ? value[0] : value;
  }
  var seriesNameSpecified = isNameSpecified(series);
  var seriesName = seriesNameSpecified && series.name || "";
  var itemName = data2.getName(dataIndex);
  var inlineName = multipleSeries ? seriesName : itemName;
  return createTooltipMarkup("section", {
    header: seriesName,
    noHeader: multipleSeries || !seriesNameSpecified,
    sortParam,
    blocks: [createTooltipMarkup("nameValue", {
      markerType: "item",
      markerColor,
      name: inlineName,
      noName: !trim$1(inlineName),
      value: inlineValue,
      valueType: inlineValueType
    })].concat(subBlocks || [])
  });
}
function formatTooltipArrayValue(value, series, dataIndex, tooltipDims, colorStr) {
  var data2 = series.getData();
  var isValueMultipleLine = reduce(value, function(isValueMultipleLine2, val, idx) {
    var dimItem = data2.getDimensionInfo(idx);
    return isValueMultipleLine2 = isValueMultipleLine2 || dimItem && dimItem.tooltip !== false && dimItem.displayName != null;
  }, false);
  var inlineValues = [];
  var inlineValueTypes = [];
  var blocks = [];
  tooltipDims.length ? each$g(tooltipDims, function(dim) {
    setEachItem(retrieveRawValue(data2, dataIndex, dim), dim);
  }) : each$g(value, setEachItem);
  function setEachItem(val, dim) {
    var dimInfo = data2.getDimensionInfo(dim);
    if (!dimInfo || dimInfo.otherDims.tooltip === false) {
      return;
    }
    if (isValueMultipleLine) {
      blocks.push(createTooltipMarkup("nameValue", {
        markerType: "subItem",
        markerColor: colorStr,
        name: dimInfo.displayName,
        value: val,
        valueType: dimInfo.type
      }));
    } else {
      inlineValues.push(val);
      inlineValueTypes.push(dimInfo.type);
    }
  }
  return {
    inlineValues,
    inlineValueTypes,
    blocks
  };
}
var inner$k = makeInner();
function getSelectionKey(data2, dataIndex) {
  return data2.getName(dataIndex) || data2.getId(dataIndex);
}
var SERIES_UNIVERSAL_TRANSITION_PROP = "__universalTransitionEnabled";
var SeriesModel = function(_super) {
  __extends(SeriesModel2, _super);
  function SeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._selectedDataIndicesMap = {};
    return _this;
  }
  SeriesModel2.prototype.init = function(option, parentModel, ecModel) {
    this.seriesIndex = this.componentIndex;
    this.dataTask = createTask({
      count: dataTaskCount,
      reset: dataTaskReset
    });
    this.dataTask.context = {
      model: this
    };
    this.mergeDefaultAndTheme(option, ecModel);
    var sourceManager = inner$k(this).sourceManager = new SourceManager(this);
    sourceManager.prepareSource();
    var data2 = this.getInitialData(option, ecModel);
    wrapData(data2, this);
    this.dataTask.context.data = data2;
    inner$k(this).dataBeforeProcessed = data2;
    autoSeriesName(this);
    this._initSelectedMapFromData(data2);
  };
  SeriesModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeSubType = this.subType;
    if (ComponentModel$1.hasClass(themeSubType)) {
      themeSubType += "Series";
    }
    merge$1(option, ecModel.getTheme().get(this.subType));
    merge$1(option, this.getDefaultOption());
    defaultEmphasis(option, "label", ["show"]);
    this.fillDataTextStyle(option.data);
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  SeriesModel2.prototype.mergeOption = function(newSeriesOption, ecModel) {
    newSeriesOption = merge$1(this.option, newSeriesOption, true);
    this.fillDataTextStyle(newSeriesOption.data);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, newSeriesOption, layoutMode);
    }
    var sourceManager = inner$k(this).sourceManager;
    sourceManager.dirty();
    sourceManager.prepareSource();
    var data2 = this.getInitialData(newSeriesOption, ecModel);
    wrapData(data2, this);
    this.dataTask.dirty();
    this.dataTask.context.data = data2;
    inner$k(this).dataBeforeProcessed = data2;
    autoSeriesName(this);
    this._initSelectedMapFromData(data2);
  };
  SeriesModel2.prototype.fillDataTextStyle = function(data2) {
    if (data2 && !isTypedArray(data2)) {
      var props = ["show"];
      for (var i = 0; i < data2.length; i++) {
        if (data2[i] && data2[i].label) {
          defaultEmphasis(data2[i], "label", props);
        }
      }
    }
  };
  SeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return;
  };
  SeriesModel2.prototype.appendData = function(params) {
    var data2 = this.getRawData();
    data2.appendData(params.data);
  };
  SeriesModel2.prototype.getData = function(dataType) {
    var task = getCurrentTask(this);
    if (task) {
      var data2 = task.context.data;
      return dataType == null ? data2 : data2.getLinkedData(dataType);
    } else {
      return inner$k(this).data;
    }
  };
  SeriesModel2.prototype.getAllData = function() {
    var mainData = this.getData();
    return mainData && mainData.getLinkedDataAll ? mainData.getLinkedDataAll() : [{
      data: mainData
    }];
  };
  SeriesModel2.prototype.setData = function(data2) {
    var task = getCurrentTask(this);
    if (task) {
      var context = task.context;
      context.outputData = data2;
      if (task !== this.dataTask) {
        context.data = data2;
      }
    }
    inner$k(this).data = data2;
  };
  SeriesModel2.prototype.getEncode = function() {
    var encode = this.get("encode", true);
    if (encode) {
      return createHashMap(encode);
    }
  };
  SeriesModel2.prototype.getSourceManager = function() {
    return inner$k(this).sourceManager;
  };
  SeriesModel2.prototype.getSource = function() {
    return this.getSourceManager().getSource();
  };
  SeriesModel2.prototype.getRawData = function() {
    return inner$k(this).dataBeforeProcessed;
  };
  SeriesModel2.prototype.getColorBy = function() {
    var colorBy = this.get("colorBy");
    return colorBy || "series";
  };
  SeriesModel2.prototype.isColorBySeries = function() {
    return this.getColorBy() === "series";
  };
  SeriesModel2.prototype.getBaseAxis = function() {
    var coordSys = this.coordinateSystem;
    return coordSys && coordSys.getBaseAxis && coordSys.getBaseAxis();
  };
  SeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
  };
  SeriesModel2.prototype.isAnimationEnabled = function() {
    var ecModel = this.ecModel;
    if (env$1.node && !(ecModel && ecModel.ssr)) {
      return false;
    }
    var animationEnabled = this.getShallow("animation");
    if (animationEnabled) {
      if (this.getData().count() > this.getShallow("animationThreshold")) {
        animationEnabled = false;
      }
    }
    return !!animationEnabled;
  };
  SeriesModel2.prototype.restoreData = function() {
    this.dataTask.dirty();
  };
  SeriesModel2.prototype.getColorFromPalette = function(name2, scope, requestColorNum) {
    var ecModel = this.ecModel;
    var color = PaletteMixin.prototype.getColorFromPalette.call(this, name2, scope, requestColorNum);
    if (!color) {
      color = ecModel.getColorFromPalette(name2, scope, requestColorNum);
    }
    return color;
  };
  SeriesModel2.prototype.coordDimToDataDim = function(coordDim) {
    return this.getRawData().mapDimensionsAll(coordDim);
  };
  SeriesModel2.prototype.getProgressive = function() {
    return this.get("progressive");
  };
  SeriesModel2.prototype.getProgressiveThreshold = function() {
    return this.get("progressiveThreshold");
  };
  SeriesModel2.prototype.select = function(innerDataIndices, dataType) {
    this._innerSelect(this.getData(dataType), innerDataIndices);
  };
  SeriesModel2.prototype.unselect = function(innerDataIndices, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return;
    }
    var selectedMode = this.option.selectedMode;
    var data2 = this.getData(dataType);
    if (selectedMode === "series" || selectedMap === "all") {
      this.option.selectedMap = {};
      this._selectedDataIndicesMap = {};
      return;
    }
    for (var i = 0; i < innerDataIndices.length; i++) {
      var dataIndex = innerDataIndices[i];
      var nameOrId = getSelectionKey(data2, dataIndex);
      selectedMap[nameOrId] = false;
      this._selectedDataIndicesMap[nameOrId] = -1;
    }
  };
  SeriesModel2.prototype.toggleSelect = function(innerDataIndices, dataType) {
    var tmpArr2 = [];
    for (var i = 0; i < innerDataIndices.length; i++) {
      tmpArr2[0] = innerDataIndices[i];
      this.isSelected(innerDataIndices[i], dataType) ? this.unselect(tmpArr2, dataType) : this.select(tmpArr2, dataType);
    }
  };
  SeriesModel2.prototype.getSelectedDataIndices = function() {
    if (this.option.selectedMap === "all") {
      return [].slice.call(this.getData().getIndices());
    }
    var selectedDataIndicesMap = this._selectedDataIndicesMap;
    var nameOrIds = keys(selectedDataIndicesMap);
    var dataIndices = [];
    for (var i = 0; i < nameOrIds.length; i++) {
      var dataIndex = selectedDataIndicesMap[nameOrIds[i]];
      if (dataIndex >= 0) {
        dataIndices.push(dataIndex);
      }
    }
    return dataIndices;
  };
  SeriesModel2.prototype.isSelected = function(dataIndex, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return false;
    }
    var data2 = this.getData(dataType);
    return (selectedMap === "all" || selectedMap[getSelectionKey(data2, dataIndex)]) && !data2.getItemModel(dataIndex).get(["select", "disabled"]);
  };
  SeriesModel2.prototype.isUniversalTransitionEnabled = function() {
    if (this[SERIES_UNIVERSAL_TRANSITION_PROP]) {
      return true;
    }
    var universalTransitionOpt = this.option.universalTransition;
    if (!universalTransitionOpt) {
      return false;
    }
    if (universalTransitionOpt === true) {
      return true;
    }
    return universalTransitionOpt && universalTransitionOpt.enabled;
  };
  SeriesModel2.prototype._innerSelect = function(data2, innerDataIndices) {
    var _a2, _b2;
    var option = this.option;
    var selectedMode = option.selectedMode;
    var len2 = innerDataIndices.length;
    if (!selectedMode || !len2) {
      return;
    }
    if (selectedMode === "series") {
      option.selectedMap = "all";
    } else if (selectedMode === "multiple") {
      if (!isObject$6(option.selectedMap)) {
        option.selectedMap = {};
      }
      var selectedMap = option.selectedMap;
      for (var i = 0; i < len2; i++) {
        var dataIndex = innerDataIndices[i];
        var nameOrId = getSelectionKey(data2, dataIndex);
        selectedMap[nameOrId] = true;
        this._selectedDataIndicesMap[nameOrId] = data2.getRawIndex(dataIndex);
      }
    } else if (selectedMode === "single" || selectedMode === true) {
      var lastDataIndex = innerDataIndices[len2 - 1];
      var nameOrId = getSelectionKey(data2, lastDataIndex);
      option.selectedMap = (_a2 = {}, _a2[nameOrId] = true, _a2);
      this._selectedDataIndicesMap = (_b2 = {}, _b2[nameOrId] = data2.getRawIndex(lastDataIndex), _b2);
    }
  };
  SeriesModel2.prototype._initSelectedMapFromData = function(data2) {
    if (this.option.selectedMap) {
      return;
    }
    var dataIndices = [];
    if (data2.hasItemOption) {
      data2.each(function(idx) {
        var rawItem = data2.getRawDataItem(idx);
        if (rawItem && rawItem.selected) {
          dataIndices.push(idx);
        }
      });
    }
    if (dataIndices.length > 0) {
      this._innerSelect(data2, dataIndices);
    }
  };
  SeriesModel2.registerClass = function(clz) {
    return ComponentModel$1.registerClass(clz);
  };
  SeriesModel2.protoInitialize = function() {
    var proto2 = SeriesModel2.prototype;
    proto2.type = "series.__base__";
    proto2.seriesIndex = 0;
    proto2.ignoreStyleOnData = false;
    proto2.hasSymbolVisual = false;
    proto2.defaultSymbol = "circle";
    proto2.visualStyleAccessPath = "itemStyle";
    proto2.visualDrawType = "fill";
  }();
  return SeriesModel2;
}(ComponentModel$1);
mixin(SeriesModel, DataFormatMixin);
mixin(SeriesModel, PaletteMixin);
mountExtend(SeriesModel, ComponentModel$1);
function autoSeriesName(seriesModel) {
  var name2 = seriesModel.name;
  if (!isNameSpecified(seriesModel)) {
    seriesModel.name = getSeriesAutoName(seriesModel) || name2;
  }
}
function getSeriesAutoName(seriesModel) {
  var data2 = seriesModel.getRawData();
  var dataDims = data2.mapDimensionsAll("seriesName");
  var nameArr = [];
  each$g(dataDims, function(dataDim) {
    var dimInfo = data2.getDimensionInfo(dataDim);
    dimInfo.displayName && nameArr.push(dimInfo.displayName);
  });
  return nameArr.join(" ");
}
function dataTaskCount(context) {
  return context.model.getRawData().count();
}
function dataTaskReset(context) {
  var seriesModel = context.model;
  seriesModel.setData(seriesModel.getRawData().cloneShallow());
  return dataTaskProgress;
}
function dataTaskProgress(param, context) {
  if (context.outputData && param.end > context.outputData.count()) {
    context.model.getRawData().cloneShallow(context.outputData);
  }
}
function wrapData(data2, seriesModel) {
  each$g(concatArray(data2.CHANGABLE_METHODS, data2.DOWNSAMPLE_METHODS), function(methodName) {
    data2.wrapMethod(methodName, curry$3(onDataChange, seriesModel));
  });
}
function onDataChange(seriesModel, newList) {
  var task = getCurrentTask(seriesModel);
  if (task) {
    task.setOutputEnd((newList || this).count());
  }
  return newList;
}
function getCurrentTask(seriesModel) {
  var scheduler2 = (seriesModel.ecModel || {}).scheduler;
  var pipeline = scheduler2 && scheduler2.getPipeline(seriesModel.uid);
  if (pipeline) {
    var task = pipeline.currentTask;
    if (task) {
      var agentStubMap = task.agentStubMap;
      if (agentStubMap) {
        task = agentStubMap.get(seriesModel.uid);
      }
    }
    return task;
  }
}
var SeriesModel$1 = SeriesModel;
var ComponentView = function() {
  function ComponentView2() {
    this.group = new Group$6();
    this.uid = getUID("viewComponent");
  }
  ComponentView2.prototype.init = function(ecModel, api) {
  };
  ComponentView2.prototype.render = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.dispose = function(ecModel, api) {
  };
  ComponentView2.prototype.updateView = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateLayout = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateVisual = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.blurSeries = function(seriesModels, ecModel) {
  };
  ComponentView2.prototype.eachRendered = function(cb2) {
    var group = this.group;
    if (group) {
      group.traverse(cb2);
    }
  };
  return ComponentView2;
}();
enableClassExtend(ComponentView);
enableClassManagement(ComponentView);
var ComponentView$1 = ComponentView;
function createRenderPlanner() {
  var inner2 = makeInner();
  return function(seriesModel) {
    var fields = inner2(seriesModel);
    var pipelineContext = seriesModel.pipelineContext;
    var originalLarge = !!fields.large;
    var originalProgressive = !!fields.progressiveRender;
    var large = fields.large = !!(pipelineContext && pipelineContext.large);
    var progressive = fields.progressiveRender = !!(pipelineContext && pipelineContext.progressiveRender);
    return !!(originalLarge !== large || originalProgressive !== progressive) && "reset";
  };
}
var inner$j = makeInner();
var renderPlanner = createRenderPlanner();
var ChartView = function() {
  function ChartView2() {
    this.group = new Group$6();
    this.uid = getUID("viewChart");
    this.renderTask = createTask({
      plan: renderTaskPlan,
      reset: renderTaskReset
    });
    this.renderTask.context = {
      view: this
    };
  }
  ChartView2.prototype.init = function(ecModel, api) {
  };
  ChartView2.prototype.render = function(seriesModel, ecModel, api, payload) {
  };
  ChartView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data2 = seriesModel.getData(payload && payload.dataType);
    if (!data2) {
      return;
    }
    toggleHighlight(data2, payload, "emphasis");
  };
  ChartView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data2 = seriesModel.getData(payload && payload.dataType);
    if (!data2) {
      return;
    }
    toggleHighlight(data2, payload, "normal");
  };
  ChartView2.prototype.remove = function(ecModel, api) {
    this.group.removeAll();
  };
  ChartView2.prototype.dispose = function(ecModel, api) {
  };
  ChartView2.prototype.updateView = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateLayout = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateVisual = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.eachRendered = function(cb2) {
    traverseElements(this.group, cb2);
  };
  ChartView2.markUpdateMethod = function(payload, methodName) {
    inner$j(payload).updateMethod = methodName;
  };
  ChartView2.protoInitialize = function() {
    var proto2 = ChartView2.prototype;
    proto2.type = "chart";
  }();
  return ChartView2;
}();
function elSetState(el, state, highlightDigit) {
  if (el && isHighDownDispatcher(el)) {
    (state === "emphasis" ? enterEmphasis : leaveEmphasis)(el, highlightDigit);
  }
}
function toggleHighlight(data2, payload, state) {
  var dataIndex = queryDataIndex(data2, payload);
  var highlightDigit = payload && payload.highlightKey != null ? getHighlightDigit(payload.highlightKey) : null;
  if (dataIndex != null) {
    each$g(normalizeToArray(dataIndex), function(dataIdx) {
      elSetState(data2.getItemGraphicEl(dataIdx), state, highlightDigit);
    });
  } else {
    data2.eachItemGraphicEl(function(el) {
      elSetState(el, state, highlightDigit);
    });
  }
}
enableClassExtend(ChartView);
enableClassManagement(ChartView);
function renderTaskPlan(context) {
  return renderPlanner(context.model);
}
function renderTaskReset(context) {
  var seriesModel = context.model;
  var ecModel = context.ecModel;
  var api = context.api;
  var payload = context.payload;
  var progressiveRender = seriesModel.pipelineContext.progressiveRender;
  var view = context.view;
  var updateMethod = payload && inner$j(payload).updateMethod;
  var methodName = progressiveRender ? "incrementalPrepareRender" : updateMethod && view[updateMethod] ? updateMethod : "render";
  if (methodName !== "render") {
    view[methodName](seriesModel, ecModel, api, payload);
  }
  return progressMethodMap[methodName];
}
var progressMethodMap = {
  incrementalPrepareRender: {
    progress: function(params, context) {
      context.view.incrementalRender(params, context.model, context.ecModel, context.api, context.payload);
    }
  },
  render: {
    forceFirstProgress: true,
    progress: function(params, context) {
      context.view.render(context.model, context.ecModel, context.api, context.payload);
    }
  }
};
var ChartView$1 = ChartView;
var ORIGIN_METHOD = "\0__throttleOriginMethod";
var RATE = "\0__throttleRate";
var THROTTLE_TYPE = "\0__throttleType";
function throttle(fn, delay, debounce) {
  var currCall;
  var lastCall = 0;
  var lastExec = 0;
  var timer = null;
  var diff;
  var scope;
  var args;
  var debounceNextCall;
  delay = delay || 0;
  function exec() {
    lastExec = new Date().getTime();
    timer = null;
    fn.apply(scope, args || []);
  }
  var cb2 = function() {
    var cbArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      cbArgs[_i] = arguments[_i];
    }
    currCall = new Date().getTime();
    scope = this;
    args = cbArgs;
    var thisDelay = debounceNextCall || delay;
    var thisDebounce = debounceNextCall || debounce;
    debounceNextCall = null;
    diff = currCall - (thisDebounce ? lastCall : lastExec) - thisDelay;
    clearTimeout(timer);
    if (thisDebounce) {
      timer = setTimeout(exec, thisDelay);
    } else {
      if (diff >= 0) {
        exec();
      } else {
        timer = setTimeout(exec, -diff);
      }
    }
    lastCall = currCall;
  };
  cb2.clear = function() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  };
  cb2.debounceNextCall = function(debounceDelay) {
    debounceNextCall = debounceDelay;
  };
  return cb2;
}
function createOrUpdate(obj, fnAttr, rate, throttleType) {
  var fn = obj[fnAttr];
  if (!fn) {
    return;
  }
  var originFn = fn[ORIGIN_METHOD] || fn;
  var lastThrottleType = fn[THROTTLE_TYPE];
  var lastRate = fn[RATE];
  if (lastRate !== rate || lastThrottleType !== throttleType) {
    if (rate == null || !throttleType) {
      return obj[fnAttr] = originFn;
    }
    fn = obj[fnAttr] = throttle(originFn, rate, throttleType === "debounce");
    fn[ORIGIN_METHOD] = originFn;
    fn[THROTTLE_TYPE] = throttleType;
    fn[RATE] = rate;
  }
  return fn;
}
function clear$1(obj, fnAttr) {
  var fn = obj[fnAttr];
  if (fn && fn[ORIGIN_METHOD]) {
    fn.clear && fn.clear();
    obj[fnAttr] = fn[ORIGIN_METHOD];
  }
}
var inner$i = makeInner();
var defaultStyleMappers = {
  itemStyle: makeStyleMapper(ITEM_STYLE_KEY_MAP, true),
  lineStyle: makeStyleMapper(LINE_STYLE_KEY_MAP, true)
};
var defaultColorKey = {
  lineStyle: "stroke",
  itemStyle: "fill"
};
function getStyleMapper(seriesModel, stylePath) {
  var styleMapper = seriesModel.visualStyleMapper || defaultStyleMappers[stylePath];
  if (!styleMapper) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return defaultStyleMappers.itemStyle;
  }
  return styleMapper;
}
function getDefaultColorKey(seriesModel, stylePath) {
  var colorKey = seriesModel.visualDrawType || defaultColorKey[stylePath];
  if (!colorKey) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return "fill";
  }
  return colorKey;
}
var seriesStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data2 = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var styleModel = seriesModel.getModel(stylePath);
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var globalStyle = getStyle2(styleModel);
    var decalOption = styleModel.getShallow("decal");
    if (decalOption) {
      data2.setVisual("decal", decalOption);
      decalOption.dirty = true;
    }
    var colorKey = getDefaultColorKey(seriesModel, stylePath);
    var color = globalStyle[colorKey];
    var colorCallback = isFunction$1(color) ? color : null;
    var hasAutoColor = globalStyle.fill === "auto" || globalStyle.stroke === "auto";
    if (!globalStyle[colorKey] || colorCallback || hasAutoColor) {
      var colorPalette2 = seriesModel.getColorFromPalette(seriesModel.name, null, ecModel.getSeriesCount());
      if (!globalStyle[colorKey]) {
        globalStyle[colorKey] = colorPalette2;
        data2.setVisual("colorFromPalette", true);
      }
      globalStyle.fill = globalStyle.fill === "auto" || isFunction$1(globalStyle.fill) ? colorPalette2 : globalStyle.fill;
      globalStyle.stroke = globalStyle.stroke === "auto" || isFunction$1(globalStyle.stroke) ? colorPalette2 : globalStyle.stroke;
    }
    data2.setVisual("style", globalStyle);
    data2.setVisual("drawType", colorKey);
    if (!ecModel.isSeriesFiltered(seriesModel) && colorCallback) {
      data2.setVisual("colorFromPalette", false);
      return {
        dataEach: function(data3, idx) {
          var dataParams = seriesModel.getDataParams(idx);
          var itemStyle = extend({}, globalStyle);
          itemStyle[colorKey] = colorCallback(dataParams);
          data3.setItemVisual(idx, "style", itemStyle);
        }
      };
    }
  }
};
var sharedModel = new Model$1();
var dataStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (seriesModel.ignoreStyleOnData || ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data2 = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var colorKey = data2.getVisual("drawType");
    return {
      dataEach: data2.hasItemOption ? function(data3, idx) {
        var rawItem = data3.getRawDataItem(idx);
        if (rawItem && rawItem[stylePath]) {
          sharedModel.option = rawItem[stylePath];
          var style2 = getStyle2(sharedModel);
          var existsStyle = data3.ensureUniqueItemVisual(idx, "style");
          extend(existsStyle, style2);
          if (sharedModel.option.decal) {
            data3.setItemVisual(idx, "decal", sharedModel.option.decal);
            sharedModel.option.decal.dirty = true;
          }
          if (colorKey in style2) {
            data3.setItemVisual(idx, "colorFromPalette", false);
          }
        }
      } : null
    };
  }
};
var dataColorPaletteTask = {
  performRawSeries: true,
  overallReset: function(ecModel) {
    var paletteScopeGroupByType = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var colorBy = seriesModel.getColorBy();
      if (seriesModel.isColorBySeries()) {
        return;
      }
      var key = seriesModel.type + "-" + colorBy;
      var colorScope = paletteScopeGroupByType.get(key);
      if (!colorScope) {
        colorScope = {};
        paletteScopeGroupByType.set(key, colorScope);
      }
      inner$i(seriesModel).scope = colorScope;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.isColorBySeries() || ecModel.isSeriesFiltered(seriesModel)) {
        return;
      }
      var dataAll = seriesModel.getRawData();
      var idxMap = {};
      var data2 = seriesModel.getData();
      var colorScope = inner$i(seriesModel).scope;
      var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
      var colorKey = getDefaultColorKey(seriesModel, stylePath);
      data2.each(function(idx) {
        var rawIdx = data2.getRawIndex(idx);
        idxMap[rawIdx] = idx;
      });
      dataAll.each(function(rawIdx) {
        var idx = idxMap[rawIdx];
        var fromPalette = data2.getItemVisual(idx, "colorFromPalette");
        if (fromPalette) {
          var itemStyle = data2.ensureUniqueItemVisual(idx, "style");
          var name_1 = dataAll.getName(rawIdx) || rawIdx + "";
          var dataCount = dataAll.count();
          itemStyle[colorKey] = seriesModel.getColorFromPalette(name_1, colorScope, dataCount);
        }
      });
    });
  }
};
var PI$5 = Math.PI;
function defaultLoading(api, opts) {
  opts = opts || {};
  defaults(opts, {
    text: "loading",
    textColor: "#000",
    fontSize: 12,
    fontWeight: "normal",
    fontStyle: "normal",
    fontFamily: "sans-serif",
    maskColor: "rgba(255, 255, 255, 0.8)",
    showSpinner: true,
    color: "#5470c6",
    spinnerRadius: 10,
    lineWidth: 5,
    zlevel: 0
  });
  var group = new Group$6();
  var mask = new Rect$3({
    style: {
      fill: opts.maskColor
    },
    zlevel: opts.zlevel,
    z: 1e4
  });
  group.add(mask);
  var textContent = new ZRText$1({
    style: {
      text: opts.text,
      fill: opts.textColor,
      fontSize: opts.fontSize,
      fontWeight: opts.fontWeight,
      fontStyle: opts.fontStyle,
      fontFamily: opts.fontFamily
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  var labelRect = new Rect$3({
    style: {
      fill: "none"
    },
    textContent,
    textConfig: {
      position: "right",
      distance: 10
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  group.add(labelRect);
  var arc;
  if (opts.showSpinner) {
    arc = new Arc$1({
      shape: {
        startAngle: -PI$5 / 2,
        endAngle: -PI$5 / 2 + 0.1,
        r: opts.spinnerRadius
      },
      style: {
        stroke: opts.color,
        lineCap: "round",
        lineWidth: opts.lineWidth
      },
      zlevel: opts.zlevel,
      z: 10001
    });
    arc.animateShape(true).when(1e3, {
      endAngle: PI$5 * 3 / 2
    }).start("circularInOut");
    arc.animateShape(true).when(1e3, {
      startAngle: PI$5 * 3 / 2
    }).delay(300).start("circularInOut");
    group.add(arc);
  }
  group.resize = function() {
    var textWidth = textContent.getBoundingRect().width;
    var r2 = opts.showSpinner ? opts.spinnerRadius : 0;
    var cx = (api.getWidth() - r2 * 2 - (opts.showSpinner && textWidth ? 10 : 0) - textWidth) / 2 - (opts.showSpinner && textWidth ? 0 : 5 + textWidth / 2) + (opts.showSpinner ? 0 : textWidth / 2) + (textWidth ? 0 : r2);
    var cy = api.getHeight() / 2;
    opts.showSpinner && arc.setShape({
      cx,
      cy
    });
    labelRect.setShape({
      x: cx - r2,
      y: cy - r2,
      width: r2 * 2,
      height: r2 * 2
    });
    mask.setShape({
      x: 0,
      y: 0,
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  group.resize();
  return group;
}
var Scheduler = function() {
  function Scheduler2(ecInstance, api, dataProcessorHandlers, visualHandlers) {
    this._stageTaskMap = createHashMap();
    this.ecInstance = ecInstance;
    this.api = api;
    dataProcessorHandlers = this._dataProcessorHandlers = dataProcessorHandlers.slice();
    visualHandlers = this._visualHandlers = visualHandlers.slice();
    this._allHandlers = dataProcessorHandlers.concat(visualHandlers);
  }
  Scheduler2.prototype.restoreData = function(ecModel, payload) {
    ecModel.restoreData(payload);
    this._stageTaskMap.each(function(taskRecord) {
      var overallTask = taskRecord.overallTask;
      overallTask && overallTask.dirty();
    });
  };
  Scheduler2.prototype.getPerformArgs = function(task, isBlock) {
    if (!task.__pipeline) {
      return;
    }
    var pipeline = this._pipelineMap.get(task.__pipeline.id);
    var pCtx = pipeline.context;
    var incremental = !isBlock && pipeline.progressiveEnabled && (!pCtx || pCtx.progressiveRender) && task.__idxInPipeline > pipeline.blockIndex;
    var step = incremental ? pipeline.step : null;
    var modDataCount = pCtx && pCtx.modDataCount;
    var modBy = modDataCount != null ? Math.ceil(modDataCount / step) : null;
    return {
      step,
      modBy,
      modDataCount
    };
  };
  Scheduler2.prototype.getPipeline = function(pipelineId) {
    return this._pipelineMap.get(pipelineId);
  };
  Scheduler2.prototype.updateStreamModes = function(seriesModel, view) {
    var pipeline = this._pipelineMap.get(seriesModel.uid);
    var data2 = seriesModel.getData();
    var dataLen = data2.count();
    var progressiveRender = pipeline.progressiveEnabled && view.incrementalPrepareRender && dataLen >= pipeline.threshold;
    var large = seriesModel.get("large") && dataLen >= seriesModel.get("largeThreshold");
    var modDataCount = seriesModel.get("progressiveChunkMode") === "mod" ? dataLen : null;
    seriesModel.pipelineContext = pipeline.context = {
      progressiveRender,
      modDataCount,
      large
    };
  };
  Scheduler2.prototype.restorePipelines = function(ecModel) {
    var scheduler2 = this;
    var pipelineMap = scheduler2._pipelineMap = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var progressive = seriesModel.getProgressive();
      var pipelineId = seriesModel.uid;
      pipelineMap.set(pipelineId, {
        id: pipelineId,
        head: null,
        tail: null,
        threshold: seriesModel.getProgressiveThreshold(),
        progressiveEnabled: progressive && !(seriesModel.preventIncremental && seriesModel.preventIncremental()),
        blockIndex: -1,
        step: Math.round(progressive || 700),
        count: 0
      });
      scheduler2._pipe(seriesModel, seriesModel.dataTask);
    });
  };
  Scheduler2.prototype.prepareStageTasks = function() {
    var stageTaskMap = this._stageTaskMap;
    var ecModel = this.api.getModel();
    var api = this.api;
    each$g(this._allHandlers, function(handler) {
      var record = stageTaskMap.get(handler.uid) || stageTaskMap.set(handler.uid, {});
      var errMsg = "";
      assert(!(handler.reset && handler.overallReset), errMsg);
      handler.reset && this._createSeriesStageTask(handler, record, ecModel, api);
      handler.overallReset && this._createOverallStageTask(handler, record, ecModel, api);
    }, this);
  };
  Scheduler2.prototype.prepareView = function(view, model, ecModel, api) {
    var renderTask = view.renderTask;
    var context = renderTask.context;
    context.model = model;
    context.ecModel = ecModel;
    context.api = api;
    renderTask.__block = !view.incrementalPrepareRender;
    this._pipe(model, renderTask);
  };
  Scheduler2.prototype.performDataProcessorTasks = function(ecModel, payload) {
    this._performStageTasks(this._dataProcessorHandlers, ecModel, payload, {
      block: true
    });
  };
  Scheduler2.prototype.performVisualTasks = function(ecModel, payload, opt) {
    this._performStageTasks(this._visualHandlers, ecModel, payload, opt);
  };
  Scheduler2.prototype._performStageTasks = function(stageHandlers, ecModel, payload, opt) {
    opt = opt || {};
    var unfinished = false;
    var scheduler2 = this;
    each$g(stageHandlers, function(stageHandler, idx) {
      if (opt.visualType && opt.visualType !== stageHandler.visualType) {
        return;
      }
      var stageHandlerRecord = scheduler2._stageTaskMap.get(stageHandler.uid);
      var seriesTaskMap = stageHandlerRecord.seriesTaskMap;
      var overallTask = stageHandlerRecord.overallTask;
      if (overallTask) {
        var overallNeedDirty_1;
        var agentStubMap = overallTask.agentStubMap;
        agentStubMap.each(function(stub) {
          if (needSetDirty(opt, stub)) {
            stub.dirty();
            overallNeedDirty_1 = true;
          }
        });
        overallNeedDirty_1 && overallTask.dirty();
        scheduler2.updatePayload(overallTask, payload);
        var performArgs_1 = scheduler2.getPerformArgs(overallTask, opt.block);
        agentStubMap.each(function(stub) {
          stub.perform(performArgs_1);
        });
        if (overallTask.perform(performArgs_1)) {
          unfinished = true;
        }
      } else if (seriesTaskMap) {
        seriesTaskMap.each(function(task, pipelineId) {
          if (needSetDirty(opt, task)) {
            task.dirty();
          }
          var performArgs = scheduler2.getPerformArgs(task, opt.block);
          performArgs.skip = !stageHandler.performRawSeries && ecModel.isSeriesFiltered(task.context.model);
          scheduler2.updatePayload(task, payload);
          if (task.perform(performArgs)) {
            unfinished = true;
          }
        });
      }
    });
    function needSetDirty(opt2, task) {
      return opt2.setDirty && (!opt2.dirtyMap || opt2.dirtyMap.get(task.__pipeline.id));
    }
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.performSeriesTasks = function(ecModel) {
    var unfinished;
    ecModel.eachSeries(function(seriesModel) {
      unfinished = seriesModel.dataTask.perform() || unfinished;
    });
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.plan = function() {
    this._pipelineMap.each(function(pipeline) {
      var task = pipeline.tail;
      do {
        if (task.__block) {
          pipeline.blockIndex = task.__idxInPipeline;
          break;
        }
        task = task.getUpstream();
      } while (task);
    });
  };
  Scheduler2.prototype.updatePayload = function(task, payload) {
    payload !== "remain" && (task.context.payload = payload);
  };
  Scheduler2.prototype._createSeriesStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler2 = this;
    var oldSeriesTaskMap = stageHandlerRecord.seriesTaskMap;
    var newSeriesTaskMap = stageHandlerRecord.seriesTaskMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    if (stageHandler.createOnAllSeries) {
      ecModel.eachRawSeries(create2);
    } else if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, create2);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(create2);
    }
    function create2(seriesModel) {
      var pipelineId = seriesModel.uid;
      var task = newSeriesTaskMap.set(pipelineId, oldSeriesTaskMap && oldSeriesTaskMap.get(pipelineId) || createTask({
        plan: seriesTaskPlan,
        reset: seriesTaskReset,
        count: seriesTaskCount
      }));
      task.context = {
        model: seriesModel,
        ecModel,
        api,
        useClearVisual: stageHandler.isVisual && !stageHandler.isLayout,
        plan: stageHandler.plan,
        reset: stageHandler.reset,
        scheduler: scheduler2
      };
      scheduler2._pipe(seriesModel, task);
    }
  };
  Scheduler2.prototype._createOverallStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler2 = this;
    var overallTask = stageHandlerRecord.overallTask = stageHandlerRecord.overallTask || createTask({
      reset: overallTaskReset
    });
    overallTask.context = {
      ecModel,
      api,
      overallReset: stageHandler.overallReset,
      scheduler: scheduler2
    };
    var oldAgentStubMap = overallTask.agentStubMap;
    var newAgentStubMap = overallTask.agentStubMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    var overallProgress = true;
    var shouldOverallTaskDirty = false;
    var errMsg = "";
    assert(!stageHandler.createOnAllSeries, errMsg);
    if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, createStub);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(createStub);
    } else {
      overallProgress = false;
      each$g(ecModel.getSeries(), createStub);
    }
    function createStub(seriesModel) {
      var pipelineId = seriesModel.uid;
      var stub = newAgentStubMap.set(pipelineId, oldAgentStubMap && oldAgentStubMap.get(pipelineId) || (shouldOverallTaskDirty = true, createTask({
        reset: stubReset,
        onDirty: stubOnDirty
      })));
      stub.context = {
        model: seriesModel,
        overallProgress
      };
      stub.agent = overallTask;
      stub.__block = overallProgress;
      scheduler2._pipe(seriesModel, stub);
    }
    if (shouldOverallTaskDirty) {
      overallTask.dirty();
    }
  };
  Scheduler2.prototype._pipe = function(seriesModel, task) {
    var pipelineId = seriesModel.uid;
    var pipeline = this._pipelineMap.get(pipelineId);
    !pipeline.head && (pipeline.head = task);
    pipeline.tail && pipeline.tail.pipe(task);
    pipeline.tail = task;
    task.__idxInPipeline = pipeline.count++;
    task.__pipeline = pipeline;
  };
  Scheduler2.wrapStageHandler = function(stageHandler, visualType) {
    if (isFunction$1(stageHandler)) {
      stageHandler = {
        overallReset: stageHandler,
        seriesType: detectSeriseType(stageHandler)
      };
    }
    stageHandler.uid = getUID("stageHandler");
    visualType && (stageHandler.visualType = visualType);
    return stageHandler;
  };
  return Scheduler2;
}();
function overallTaskReset(context) {
  context.overallReset(context.ecModel, context.api, context.payload);
}
function stubReset(context) {
  return context.overallProgress && stubProgress;
}
function stubProgress() {
  this.agent.dirty();
  this.getDownstream().dirty();
}
function stubOnDirty() {
  this.agent && this.agent.dirty();
}
function seriesTaskPlan(context) {
  return context.plan ? context.plan(context.model, context.ecModel, context.api, context.payload) : null;
}
function seriesTaskReset(context) {
  if (context.useClearVisual) {
    context.data.clearAllVisual();
  }
  var resetDefines = context.resetDefines = normalizeToArray(context.reset(context.model, context.ecModel, context.api, context.payload));
  return resetDefines.length > 1 ? map$1(resetDefines, function(v4, idx) {
    return makeSeriesTaskProgress(idx);
  }) : singleSeriesTaskProgress;
}
var singleSeriesTaskProgress = makeSeriesTaskProgress(0);
function makeSeriesTaskProgress(resetDefineIdx) {
  return function(params, context) {
    var data2 = context.data;
    var resetDefine = context.resetDefines[resetDefineIdx];
    if (resetDefine && resetDefine.dataEach) {
      for (var i = params.start; i < params.end; i++) {
        resetDefine.dataEach(data2, i);
      }
    } else if (resetDefine && resetDefine.progress) {
      resetDefine.progress(params, data2);
    }
  };
}
function seriesTaskCount(context) {
  return context.data.count();
}
function detectSeriseType(legacyFunc) {
  seriesType = null;
  try {
    legacyFunc(ecModelMock, apiMock);
  } catch (e2) {
  }
  return seriesType;
}
var ecModelMock = {};
var apiMock = {};
var seriesType;
mockMethods(ecModelMock, GlobalModel$1);
mockMethods(apiMock, ExtensionAPI$1);
ecModelMock.eachSeriesByType = ecModelMock.eachRawSeriesByType = function(type4) {
  seriesType = type4;
};
ecModelMock.eachComponent = function(cond) {
  if (cond.mainType === "series" && cond.subType) {
    seriesType = cond.subType;
  }
};
function mockMethods(target, Clz) {
  for (var name_1 in Clz.prototype) {
    target[name_1] = noop$1;
  }
}
var Scheduler$1 = Scheduler;
var colorAll = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"];
var lightTheme = {
  color: colorAll,
  colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], colorAll]
};
var contrastColor = "#B9B8CE";
var backgroundColor = "#100C2A";
var axisCommon = function() {
  return {
    axisLine: {
      lineStyle: {
        color: contrastColor
      }
    },
    splitLine: {
      lineStyle: {
        color: "#484753"
      }
    },
    splitArea: {
      areaStyle: {
        color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"]
      }
    },
    minorSplitLine: {
      lineStyle: {
        color: "#20203B"
      }
    }
  };
};
var colorPalette = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"];
var theme = {
  darkMode: true,
  color: colorPalette,
  backgroundColor,
  axisPointer: {
    lineStyle: {
      color: "#817f91"
    },
    crossStyle: {
      color: "#817f91"
    },
    label: {
      color: "#fff"
    }
  },
  legend: {
    textStyle: {
      color: contrastColor
    }
  },
  textStyle: {
    color: contrastColor
  },
  title: {
    textStyle: {
      color: "#EEF1FA"
    },
    subtextStyle: {
      color: "#B9B8CE"
    }
  },
  toolbox: {
    iconStyle: {
      borderColor: contrastColor
    }
  },
  dataZoom: {
    borderColor: "#71708A",
    textStyle: {
      color: contrastColor
    },
    brushStyle: {
      color: "rgba(135,163,206,0.3)"
    },
    handleStyle: {
      color: "#353450",
      borderColor: "#C5CBE3"
    },
    moveHandleStyle: {
      color: "#B0B6C3",
      opacity: 0.3
    },
    fillerColor: "rgba(135,163,206,0.2)",
    emphasis: {
      handleStyle: {
        borderColor: "#91B7F2",
        color: "#4D587D"
      },
      moveHandleStyle: {
        color: "#636D9A",
        opacity: 0.7
      }
    },
    dataBackground: {
      lineStyle: {
        color: "#71708A",
        width: 1
      },
      areaStyle: {
        color: "#71708A"
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#87A3CE"
      },
      areaStyle: {
        color: "#87A3CE"
      }
    }
  },
  visualMap: {
    textStyle: {
      color: contrastColor
    }
  },
  timeline: {
    lineStyle: {
      color: contrastColor
    },
    label: {
      color: contrastColor
    },
    controlStyle: {
      color: contrastColor,
      borderColor: contrastColor
    }
  },
  calendar: {
    itemStyle: {
      color: backgroundColor
    },
    dayLabel: {
      color: contrastColor
    },
    monthLabel: {
      color: contrastColor
    },
    yearLabel: {
      color: contrastColor
    }
  },
  timeAxis: axisCommon(),
  logAxis: axisCommon(),
  valueAxis: axisCommon(),
  categoryAxis: axisCommon(),
  line: {
    symbol: "circle"
  },
  graph: {
    color: colorPalette
  },
  gauge: {
    title: {
      color: contrastColor
    },
    axisLine: {
      lineStyle: {
        color: [[1, "rgba(207,212,219,0.2)"]]
      }
    },
    axisLabel: {
      color: contrastColor
    },
    detail: {
      color: "#EEF1FA"
    }
  },
  candlestick: {
    itemStyle: {
      color: "#f64e56",
      color0: "#54ea92",
      borderColor: "#f64e56",
      borderColor0: "#54ea92"
    }
  }
};
theme.categoryAxis.splitLine.show = false;
var darkTheme = theme;
var ECEventProcessor = function() {
  function ECEventProcessor2() {
  }
  ECEventProcessor2.prototype.normalizeQuery = function(query) {
    var cptQuery = {};
    var dataQuery = {};
    var otherQuery = {};
    if (isString$1(query)) {
      var condCptType = parseClassType(query);
      cptQuery.mainType = condCptType.main || null;
      cptQuery.subType = condCptType.sub || null;
    } else {
      var suffixes_1 = ["Index", "Name", "Id"];
      var dataKeys_1 = {
        name: 1,
        dataIndex: 1,
        dataType: 1
      };
      each$g(query, function(val, key) {
        var reserved = false;
        for (var i = 0; i < suffixes_1.length; i++) {
          var propSuffix = suffixes_1[i];
          var suffixPos = key.lastIndexOf(propSuffix);
          if (suffixPos > 0 && suffixPos === key.length - propSuffix.length) {
            var mainType = key.slice(0, suffixPos);
            if (mainType !== "data") {
              cptQuery.mainType = mainType;
              cptQuery[propSuffix.toLowerCase()] = val;
              reserved = true;
            }
          }
        }
        if (dataKeys_1.hasOwnProperty(key)) {
          dataQuery[key] = val;
          reserved = true;
        }
        if (!reserved) {
          otherQuery[key] = val;
        }
      });
    }
    return {
      cptQuery,
      dataQuery,
      otherQuery
    };
  };
  ECEventProcessor2.prototype.filter = function(eventType, query) {
    var eventInfo = this.eventInfo;
    if (!eventInfo) {
      return true;
    }
    var targetEl = eventInfo.targetEl;
    var packedEvent = eventInfo.packedEvent;
    var model = eventInfo.model;
    var view = eventInfo.view;
    if (!model || !view) {
      return true;
    }
    var cptQuery = query.cptQuery;
    var dataQuery = query.dataQuery;
    return check(cptQuery, model, "mainType") && check(cptQuery, model, "subType") && check(cptQuery, model, "index", "componentIndex") && check(cptQuery, model, "name") && check(cptQuery, model, "id") && check(dataQuery, packedEvent, "name") && check(dataQuery, packedEvent, "dataIndex") && check(dataQuery, packedEvent, "dataType") && (!view.filterForExposedEvent || view.filterForExposedEvent(eventType, query.otherQuery, targetEl, packedEvent));
    function check(query2, host, prop, propOnHost) {
      return query2[prop] == null || host[propOnHost || prop] === query2[prop];
    }
  };
  ECEventProcessor2.prototype.afterTrigger = function() {
    this.eventInfo = null;
  };
  return ECEventProcessor2;
}();
var SYMBOL_PROPS_WITH_CB = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"];
var SYMBOL_PROPS = SYMBOL_PROPS_WITH_CB.concat(["symbolKeepAspect"]);
var seriesSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data2 = seriesModel.getData();
    if (seriesModel.legendIcon) {
      data2.setVisual("legendIcon", seriesModel.legendIcon);
    }
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    var symbolOptions = {};
    var symbolOptionsCb = {};
    var hasCallback = false;
    for (var i = 0; i < SYMBOL_PROPS_WITH_CB.length; i++) {
      var symbolPropName = SYMBOL_PROPS_WITH_CB[i];
      var val = seriesModel.get(symbolPropName);
      if (isFunction$1(val)) {
        hasCallback = true;
        symbolOptionsCb[symbolPropName] = val;
      } else {
        symbolOptions[symbolPropName] = val;
      }
    }
    symbolOptions.symbol = symbolOptions.symbol || seriesModel.defaultSymbol;
    data2.setVisual(extend({
      legendIcon: seriesModel.legendIcon || symbolOptions.symbol,
      symbolKeepAspect: seriesModel.get("symbolKeepAspect")
    }, symbolOptions));
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var symbolPropsCb = keys(symbolOptionsCb);
    function dataEach(data3, idx) {
      var rawValue = seriesModel.getRawValue(idx);
      var params = seriesModel.getDataParams(idx);
      for (var i2 = 0; i2 < symbolPropsCb.length; i2++) {
        var symbolPropName2 = symbolPropsCb[i2];
        data3.setItemVisual(idx, symbolPropName2, symbolOptionsCb[symbolPropName2](rawValue, params));
      }
    }
    return {
      dataEach: hasCallback ? dataEach : null
    };
  }
};
var dataSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data2 = seriesModel.getData();
    function dataEach(data3, idx) {
      var itemModel = data3.getItemModel(idx);
      for (var i = 0; i < SYMBOL_PROPS.length; i++) {
        var symbolPropName = SYMBOL_PROPS[i];
        var val = itemModel.getShallow(symbolPropName, true);
        if (val != null) {
          data3.setItemVisual(idx, symbolPropName, val);
        }
      }
    }
    return {
      dataEach: data2.hasItemOption ? dataEach : null
    };
  }
};
function getItemVisualFromData(data2, dataIndex, key) {
  switch (key) {
    case "color":
      var style2 = data2.getItemVisual(dataIndex, "style");
      return style2[data2.getVisual("drawType")];
    case "opacity":
      return data2.getItemVisual(dataIndex, "style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data2.getItemVisual(dataIndex, key);
  }
}
function getVisualFromData(data2, key) {
  switch (key) {
    case "color":
      var style2 = data2.getVisual("style");
      return style2[data2.getVisual("drawType")];
    case "opacity":
      return data2.getVisual("style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data2.getVisual(key);
  }
}
function setItemVisualFromData(data2, dataIndex, key, value) {
  switch (key) {
    case "color":
      var style2 = data2.ensureUniqueItemVisual(dataIndex, "style");
      style2[data2.getVisual("drawType")] = value;
      data2.setItemVisual(dataIndex, "colorFromPalette", false);
      break;
    case "opacity":
      data2.ensureUniqueItemVisual(dataIndex, "style").opacity = value;
      break;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      data2.setItemVisual(dataIndex, key, value);
      break;
  }
}
function createLegacyDataSelectAction(seriesType2, ecRegisterAction) {
  function getSeriesIndices(ecModel, payload) {
    var seriesIndices = [];
    ecModel.eachComponent({
      mainType: "series",
      subType: seriesType2,
      query: payload
    }, function(seriesModel) {
      seriesIndices.push(seriesModel.seriesIndex);
    });
    return seriesIndices;
  }
  each$g([[seriesType2 + "ToggleSelect", "toggleSelect"], [seriesType2 + "Select", "select"], [seriesType2 + "UnSelect", "unselect"]], function(eventsMap) {
    ecRegisterAction(eventsMap[0], function(payload, ecModel, api) {
      payload = extend({}, payload);
      api.dispatchAction(extend(payload, {
        type: eventsMap[1],
        seriesIndex: getSeriesIndices(ecModel, payload)
      }));
    });
  });
}
function handleSeriesLegacySelectEvents(type4, eventPostfix, ecIns, ecModel, payload) {
  var legacyEventName = type4 + eventPostfix;
  if (!ecIns.isSilent(legacyEventName)) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "pie"
    }, function(seriesModel) {
      var seriesIndex = seriesModel.seriesIndex;
      var selectedMap = seriesModel.option.selectedMap;
      var selected = payload.selected;
      for (var i = 0; i < selected.length; i++) {
        if (selected[i].seriesIndex === seriesIndex) {
          var data2 = seriesModel.getData();
          var dataIndex = queryDataIndex(data2, payload.fromActionPayload);
          ecIns.trigger(legacyEventName, {
            type: legacyEventName,
            seriesId: seriesModel.id,
            name: isArray$2(dataIndex) ? data2.getName(dataIndex[0]) : data2.getName(dataIndex),
            selected: isString$1(selectedMap) ? selectedMap : extend({}, selectedMap)
          });
        }
      }
    });
  }
}
function handleLegacySelectEvents(messageCenter, ecIns, api) {
  messageCenter.on("selectchanged", function(params) {
    var ecModel = api.getModel();
    if (params.isFromClick) {
      handleSeriesLegacySelectEvents("map", "selectchanged", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selectchanged", ecIns, ecModel, params);
    } else if (params.fromAction === "select") {
      handleSeriesLegacySelectEvents("map", "selected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selected", ecIns, ecModel, params);
    } else if (params.fromAction === "unselect") {
      handleSeriesLegacySelectEvents("map", "unselected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "unselected", ecIns, ecModel, params);
    }
  });
}
function findEventDispatcher(target, det, returnFirstMatch) {
  var found;
  while (target) {
    if (det(target)) {
      found = target;
      if (returnFirstMatch) {
        break;
      }
    }
    target = target.__hostTarget || target.parent;
  }
  return found;
}
var wmUniqueIndex = Math.round(Math.random() * 9);
var supportDefineProperty = typeof Object.defineProperty === "function";
var WeakMap$1 = function() {
  function WeakMap2() {
    this._id = "__ec_inner_" + wmUniqueIndex++;
  }
  WeakMap2.prototype.get = function(key) {
    return this._guard(key)[this._id];
  };
  WeakMap2.prototype.set = function(key, value) {
    var target = this._guard(key);
    if (supportDefineProperty) {
      Object.defineProperty(target, this._id, {
        value,
        enumerable: false,
        configurable: true
      });
    } else {
      target[this._id] = value;
    }
    return this;
  };
  WeakMap2.prototype["delete"] = function(key) {
    if (this.has(key)) {
      delete this._guard(key)[this._id];
      return true;
    }
    return false;
  };
  WeakMap2.prototype.has = function(key) {
    return !!this._guard(key)[this._id];
  };
  WeakMap2.prototype._guard = function(key) {
    if (key !== Object(key)) {
      throw TypeError("Value of WeakMap is not a non-null object.");
    }
    return key;
  };
  return WeakMap2;
}();
var WeakMap$2 = WeakMap$1;
var Triangle = Path$1.extend({
  type: "triangle",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy + height);
    path.lineTo(cx - width, cy + height);
    path.closePath();
  }
});
var Diamond = Path$1.extend({
  type: "diamond",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy);
    path.lineTo(cx, cy + height);
    path.lineTo(cx - width, cy);
    path.closePath();
  }
});
var Pin = Path$1.extend({
  type: "pin",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var x2 = shape.x;
    var y2 = shape.y;
    var w2 = shape.width / 5 * 3;
    var h = Math.max(w2, shape.height);
    var r2 = w2 / 2;
    var dy = r2 * r2 / (h - r2);
    var cy = y2 - h + r2 + dy;
    var angle = Math.asin(dy / r2);
    var dx = Math.cos(angle) * r2;
    var tanX = Math.sin(angle);
    var tanY = Math.cos(angle);
    var cpLen = r2 * 0.6;
    var cpLen2 = r2 * 0.7;
    path.moveTo(x2 - dx, cy + dy);
    path.arc(x2, cy, r2, Math.PI - angle, Math.PI * 2 + angle);
    path.bezierCurveTo(x2 + dx - tanX * cpLen, cy + dy + tanY * cpLen, x2, y2 - cpLen2, x2, y2);
    path.bezierCurveTo(x2, y2 - cpLen2, x2 - dx + tanX * cpLen, cy + dy + tanY * cpLen, x2 - dx, cy + dy);
    path.closePath();
  }
});
var Arrow = Path$1.extend({
  type: "arrow",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(ctx, shape) {
    var height = shape.height;
    var width = shape.width;
    var x2 = shape.x;
    var y2 = shape.y;
    var dx = width / 3 * 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(x2 + dx, y2 + height);
    ctx.lineTo(x2, y2 + height / 4 * 3);
    ctx.lineTo(x2 - dx, y2 + height);
    ctx.lineTo(x2, y2);
    ctx.closePath();
  }
});
var symbolCtors = {
  line: Line$3,
  rect: Rect$3,
  roundRect: Rect$3,
  square: Rect$3,
  circle: Circle$1,
  diamond: Diamond,
  pin: Pin,
  arrow: Arrow,
  triangle: Triangle
};
var symbolShapeMakers = {
  line: function(x2, y2, w2, h, shape) {
    shape.x1 = x2;
    shape.y1 = y2 + h / 2;
    shape.x2 = x2 + w2;
    shape.y2 = y2 + h / 2;
  },
  rect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
  },
  roundRect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
    shape.r = Math.min(w2, h) / 4;
  },
  square: function(x2, y2, w2, h, shape) {
    var size = Math.min(w2, h);
    shape.x = x2;
    shape.y = y2;
    shape.width = size;
    shape.height = size;
  },
  circle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.r = Math.min(w2, h) / 2;
  },
  diamond: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  pin: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  arrow: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  triangle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  }
};
var symbolBuildProxies = {};
each$g(symbolCtors, function(Ctor, name2) {
  symbolBuildProxies[name2] = new Ctor();
});
var SymbolClz$1 = Path$1.extend({
  type: "symbol",
  shape: {
    symbolType: "",
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  calculateTextPosition: function(out2, config2, rect) {
    var res2 = calculateTextPosition(out2, config2, rect);
    var shape = this.shape;
    if (shape && shape.symbolType === "pin" && config2.position === "inside") {
      res2.y = rect.y + rect.height * 0.4;
    }
    return res2;
  },
  buildPath: function(ctx, shape, inBundle) {
    var symbolType = shape.symbolType;
    if (symbolType !== "none") {
      var proxySymbol = symbolBuildProxies[symbolType];
      if (!proxySymbol) {
        symbolType = "rect";
        proxySymbol = symbolBuildProxies[symbolType];
      }
      symbolShapeMakers[symbolType](shape.x, shape.y, shape.width, shape.height, proxySymbol.shape);
      proxySymbol.buildPath(ctx, proxySymbol.shape, inBundle);
    }
  }
});
function symbolPathSetColor(color, innerColor2) {
  if (this.type !== "image") {
    var symbolStyle = this.style;
    if (this.__isEmptyBrush) {
      symbolStyle.stroke = color;
      symbolStyle.fill = innerColor2 || "#fff";
      symbolStyle.lineWidth = 2;
    } else if (this.shape.symbolType === "line") {
      symbolStyle.stroke = color;
    } else {
      symbolStyle.fill = color;
    }
    this.markRedraw();
  }
}
function createSymbol$1(symbolType, x2, y2, w2, h, color, keepAspect) {
  var isEmpty2 = symbolType.indexOf("empty") === 0;
  if (isEmpty2) {
    symbolType = symbolType.substr(5, 1).toLowerCase() + symbolType.substr(6);
  }
  var symbolPath;
  if (symbolType.indexOf("image://") === 0) {
    symbolPath = makeImage(symbolType.slice(8), new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else if (symbolType.indexOf("path://") === 0) {
    symbolPath = makePath(symbolType.slice(7), {}, new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else {
    symbolPath = new SymbolClz$1({
      shape: {
        symbolType,
        x: x2,
        y: y2,
        width: w2,
        height: h
      }
    });
  }
  symbolPath.__isEmptyBrush = isEmpty2;
  symbolPath.setColor = symbolPathSetColor;
  if (color) {
    symbolPath.setColor(color);
  }
  return symbolPath;
}
function normalizeSymbolSize(symbolSize) {
  if (!isArray$2(symbolSize)) {
    symbolSize = [+symbolSize, +symbolSize];
  }
  return [symbolSize[0] || 0, symbolSize[1] || 0];
}
function normalizeSymbolOffset(symbolOffset, symbolSize) {
  if (symbolOffset == null) {
    return;
  }
  if (!isArray$2(symbolOffset)) {
    symbolOffset = [symbolOffset, symbolOffset];
  }
  return [parsePercent(symbolOffset[0], symbolSize[0]) || 0, parsePercent(retrieve2(symbolOffset[1], symbolOffset[0]), symbolSize[1]) || 0];
}
function createLinearGradient(ctx, obj, rect) {
  var x2 = obj.x == null ? 0 : obj.x;
  var x22 = obj.x2 == null ? 1 : obj.x2;
  var y2 = obj.y == null ? 0 : obj.y;
  var y22 = obj.y2 == null ? 0 : obj.y2;
  if (!obj.global) {
    x2 = x2 * rect.width + rect.x;
    x22 = x22 * rect.width + rect.x;
    y2 = y2 * rect.height + rect.y;
    y22 = y22 * rect.height + rect.y;
  }
  x2 = isNaN(x2) ? 0 : x2;
  x22 = isNaN(x22) ? 1 : x22;
  y2 = isNaN(y2) ? 0 : y2;
  y22 = isNaN(y22) ? 0 : y22;
  var canvasGradient = ctx.createLinearGradient(x2, y2, x22, y22);
  return canvasGradient;
}
function createRadialGradient(ctx, obj, rect) {
  var width = rect.width;
  var height = rect.height;
  var min3 = Math.min(width, height);
  var x2 = obj.x == null ? 0.5 : obj.x;
  var y2 = obj.y == null ? 0.5 : obj.y;
  var r2 = obj.r == null ? 0.5 : obj.r;
  if (!obj.global) {
    x2 = x2 * width + rect.x;
    y2 = y2 * height + rect.y;
    r2 = r2 * min3;
  }
  var canvasGradient = ctx.createRadialGradient(x2, y2, 0, x2, y2, r2);
  return canvasGradient;
}
function getCanvasGradient(ctx, obj, rect) {
  var canvasGradient = obj.type === "radial" ? createRadialGradient(ctx, obj, rect) : createLinearGradient(ctx, obj, rect);
  var colorStops = obj.colorStops;
  for (var i = 0; i < colorStops.length; i++) {
    canvasGradient.addColorStop(colorStops[i].offset, colorStops[i].color);
  }
  return canvasGradient;
}
function isClipPathChanged(clipPaths, prevClipPaths) {
  if (clipPaths === prevClipPaths || !clipPaths && !prevClipPaths) {
    return false;
  }
  if (!clipPaths || !prevClipPaths || clipPaths.length !== prevClipPaths.length) {
    return true;
  }
  for (var i = 0; i < clipPaths.length; i++) {
    if (clipPaths[i] !== prevClipPaths[i]) {
      return true;
    }
  }
  return false;
}
function parseInt10(val) {
  return parseInt(val, 10);
}
function getSize$1(root2, whIdx, opts) {
  var wh2 = ["width", "height"][whIdx];
  var cwh = ["clientWidth", "clientHeight"][whIdx];
  var plt = ["paddingLeft", "paddingTop"][whIdx];
  var prb = ["paddingRight", "paddingBottom"][whIdx];
  if (opts[wh2] != null && opts[wh2] !== "auto") {
    return parseFloat(opts[wh2]);
  }
  var stl = document.defaultView.getComputedStyle(root2);
  return (root2[cwh] || parseInt10(stl[wh2]) || parseInt10(root2.style[wh2])) - (parseInt10(stl[plt]) || 0) - (parseInt10(stl[prb]) || 0) | 0;
}
function normalizeLineDash(lineType, lineWidth) {
  if (!lineType || lineType === "solid" || !(lineWidth > 0)) {
    return null;
  }
  return lineType === "dashed" ? [4 * lineWidth, 2 * lineWidth] : lineType === "dotted" ? [lineWidth] : isNumber(lineType) ? [lineType] : isArray$2(lineType) ? lineType : null;
}
function getLineDash(el) {
  var style2 = el.style;
  var lineDash = style2.lineDash && style2.lineWidth > 0 && normalizeLineDash(style2.lineDash, style2.lineWidth);
  var lineDashOffset = style2.lineDashOffset;
  if (lineDash) {
    var lineScale_1 = style2.strokeNoScale && el.getLineScale ? el.getLineScale() : 1;
    if (lineScale_1 && lineScale_1 !== 1) {
      lineDash = map$1(lineDash, function(rawVal) {
        return rawVal / lineScale_1;
      });
      lineDashOffset /= lineScale_1;
    }
  }
  return [lineDash, lineDashOffset];
}
var pathProxyForDraw = new PathProxy$1(true);
function styleHasStroke(style2) {
  var stroke = style2.stroke;
  return !(stroke == null || stroke === "none" || !(style2.lineWidth > 0));
}
function isValidStrokeFillStyle(strokeOrFill) {
  return typeof strokeOrFill === "string" && strokeOrFill !== "none";
}
function styleHasFill(style2) {
  var fill = style2.fill;
  return fill != null && fill !== "none";
}
function doFillPath(ctx, style2) {
  if (style2.fillOpacity != null && style2.fillOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style2.fillOpacity * style2.opacity;
    ctx.fill();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.fill();
  }
}
function doStrokePath(ctx, style2) {
  if (style2.strokeOpacity != null && style2.strokeOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style2.strokeOpacity * style2.opacity;
    ctx.stroke();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.stroke();
  }
}
function createCanvasPattern(ctx, pattern4, el) {
  var image = createOrUpdateImage(pattern4.image, pattern4.__image, el);
  if (isImageReady(image)) {
    var canvasPattern = ctx.createPattern(image, pattern4.repeat || "repeat");
    if (typeof DOMMatrix === "function" && canvasPattern && canvasPattern.setTransform) {
      var matrix = new DOMMatrix();
      matrix.translateSelf(pattern4.x || 0, pattern4.y || 0);
      matrix.rotateSelf(0, 0, (pattern4.rotation || 0) * RADIAN_TO_DEGREE);
      matrix.scaleSelf(pattern4.scaleX || 1, pattern4.scaleY || 1);
      canvasPattern.setTransform(matrix);
    }
    return canvasPattern;
  }
}
function brushPath(ctx, el, style2, inBatch) {
  var _a2;
  var hasStroke = styleHasStroke(style2);
  var hasFill = styleHasFill(style2);
  var strokePercent = style2.strokePercent;
  var strokePart = strokePercent < 1;
  var firstDraw = !el.path;
  if ((!el.silent || strokePart) && firstDraw) {
    el.createPathProxy();
  }
  var path = el.path || pathProxyForDraw;
  var dirtyFlag = el.__dirty;
  if (!inBatch) {
    var fill = style2.fill;
    var stroke = style2.stroke;
    var hasFillGradient = hasFill && !!fill.colorStops;
    var hasStrokeGradient = hasStroke && !!stroke.colorStops;
    var hasFillPattern = hasFill && !!fill.image;
    var hasStrokePattern = hasStroke && !!stroke.image;
    var fillGradient = void 0;
    var strokeGradient = void 0;
    var fillPattern = void 0;
    var strokePattern = void 0;
    var rect = void 0;
    if (hasFillGradient || hasStrokeGradient) {
      rect = el.getBoundingRect();
    }
    if (hasFillGradient) {
      fillGradient = dirtyFlag ? getCanvasGradient(ctx, fill, rect) : el.__canvasFillGradient;
      el.__canvasFillGradient = fillGradient;
    }
    if (hasStrokeGradient) {
      strokeGradient = dirtyFlag ? getCanvasGradient(ctx, stroke, rect) : el.__canvasStrokeGradient;
      el.__canvasStrokeGradient = strokeGradient;
    }
    if (hasFillPattern) {
      fillPattern = dirtyFlag || !el.__canvasFillPattern ? createCanvasPattern(ctx, fill, el) : el.__canvasFillPattern;
      el.__canvasFillPattern = fillPattern;
    }
    if (hasStrokePattern) {
      strokePattern = dirtyFlag || !el.__canvasStrokePattern ? createCanvasPattern(ctx, stroke, el) : el.__canvasStrokePattern;
      el.__canvasStrokePattern = fillPattern;
    }
    if (hasFillGradient) {
      ctx.fillStyle = fillGradient;
    } else if (hasFillPattern) {
      if (fillPattern) {
        ctx.fillStyle = fillPattern;
      } else {
        hasFill = false;
      }
    }
    if (hasStrokeGradient) {
      ctx.strokeStyle = strokeGradient;
    } else if (hasStrokePattern) {
      if (strokePattern) {
        ctx.strokeStyle = strokePattern;
      } else {
        hasStroke = false;
      }
    }
  }
  var scale2 = el.getGlobalScale();
  path.setScale(scale2[0], scale2[1], el.segmentIgnoreThreshold);
  var lineDash;
  var lineDashOffset;
  if (ctx.setLineDash && style2.lineDash) {
    _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
  }
  var needsRebuild = true;
  if (firstDraw || dirtyFlag & SHAPE_CHANGED_BIT) {
    path.setDPR(ctx.dpr);
    if (strokePart) {
      path.setContext(null);
    } else {
      path.setContext(ctx);
      needsRebuild = false;
    }
    path.reset();
    el.buildPath(path, el.shape, inBatch);
    path.toStatic();
    el.pathUpdated();
  }
  if (needsRebuild) {
    path.rebuildPath(ctx, strokePart ? strokePercent : 1);
  }
  if (lineDash) {
    ctx.setLineDash(lineDash);
    ctx.lineDashOffset = lineDashOffset;
  }
  if (!inBatch) {
    if (style2.strokeFirst) {
      if (hasStroke) {
        doStrokePath(ctx, style2);
      }
      if (hasFill) {
        doFillPath(ctx, style2);
      }
    } else {
      if (hasFill) {
        doFillPath(ctx, style2);
      }
      if (hasStroke) {
        doStrokePath(ctx, style2);
      }
    }
  }
  if (lineDash) {
    ctx.setLineDash([]);
  }
}
function brushImage(ctx, el, style2) {
  var image = el.__image = createOrUpdateImage(style2.image, el.__image, el, el.onload);
  if (!image || !isImageReady(image)) {
    return;
  }
  var x2 = style2.x || 0;
  var y2 = style2.y || 0;
  var width = el.getWidth();
  var height = el.getHeight();
  var aspect = image.width / image.height;
  if (width == null && height != null) {
    width = height * aspect;
  } else if (height == null && width != null) {
    height = width / aspect;
  } else if (width == null && height == null) {
    width = image.width;
    height = image.height;
  }
  if (style2.sWidth && style2.sHeight) {
    var sx = style2.sx || 0;
    var sy = style2.sy || 0;
    ctx.drawImage(image, sx, sy, style2.sWidth, style2.sHeight, x2, y2, width, height);
  } else if (style2.sx && style2.sy) {
    var sx = style2.sx;
    var sy = style2.sy;
    var sWidth = width - sx;
    var sHeight = height - sy;
    ctx.drawImage(image, sx, sy, sWidth, sHeight, x2, y2, width, height);
  } else {
    ctx.drawImage(image, x2, y2, width, height);
  }
}
function brushText(ctx, el, style2) {
  var _a2;
  var text = style2.text;
  text != null && (text += "");
  if (text) {
    ctx.font = style2.font || DEFAULT_FONT;
    ctx.textAlign = style2.textAlign;
    ctx.textBaseline = style2.textBaseline;
    var lineDash = void 0;
    var lineDashOffset = void 0;
    if (ctx.setLineDash && style2.lineDash) {
      _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
    }
    if (lineDash) {
      ctx.setLineDash(lineDash);
      ctx.lineDashOffset = lineDashOffset;
    }
    if (style2.strokeFirst) {
      if (styleHasStroke(style2)) {
        ctx.strokeText(text, style2.x, style2.y);
      }
      if (styleHasFill(style2)) {
        ctx.fillText(text, style2.x, style2.y);
      }
    } else {
      if (styleHasFill(style2)) {
        ctx.fillText(text, style2.x, style2.y);
      }
      if (styleHasStroke(style2)) {
        ctx.strokeText(text, style2.x, style2.y);
      }
    }
    if (lineDash) {
      ctx.setLineDash([]);
    }
  }
}
var SHADOW_NUMBER_PROPS = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"];
var STROKE_PROPS = [
  ["lineCap", "butt"],
  ["lineJoin", "miter"],
  ["miterLimit", 10]
];
function bindCommonProps(ctx, style2, prevStyle, forceSetAll, scope) {
  var styleChanged = false;
  if (!forceSetAll) {
    prevStyle = prevStyle || {};
    if (style2 === prevStyle) {
      return false;
    }
  }
  if (forceSetAll || style2.opacity !== prevStyle.opacity) {
    flushPathDrawn(ctx, scope);
    styleChanged = true;
    var opacity = Math.max(Math.min(style2.opacity, 1), 0);
    ctx.globalAlpha = isNaN(opacity) ? DEFAULT_COMMON_STYLE.opacity : opacity;
  }
  if (forceSetAll || style2.blend !== prevStyle.blend) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalCompositeOperation = style2.blend || DEFAULT_COMMON_STYLE.blend;
  }
  for (var i = 0; i < SHADOW_NUMBER_PROPS.length; i++) {
    var propName = SHADOW_NUMBER_PROPS[i];
    if (forceSetAll || style2[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = ctx.dpr * (style2[propName] || 0);
    }
  }
  if (forceSetAll || style2.shadowColor !== prevStyle.shadowColor) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.shadowColor = style2.shadowColor || DEFAULT_COMMON_STYLE.shadowColor;
  }
  return styleChanged;
}
function bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetAll, scope) {
  var style2 = getStyle(el, scope.inHover);
  var prevStyle = forceSetAll ? null : prevEl && getStyle(prevEl, scope.inHover) || {};
  if (style2 === prevStyle) {
    return false;
  }
  var styleChanged = bindCommonProps(ctx, style2, prevStyle, forceSetAll, scope);
  if (forceSetAll || style2.fill !== prevStyle.fill) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style2.fill) && (ctx.fillStyle = style2.fill);
  }
  if (forceSetAll || style2.stroke !== prevStyle.stroke) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style2.stroke) && (ctx.strokeStyle = style2.stroke);
  }
  if (forceSetAll || style2.opacity !== prevStyle.opacity) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalAlpha = style2.opacity == null ? 1 : style2.opacity;
  }
  if (el.hasStroke()) {
    var lineWidth = style2.lineWidth;
    var newLineWidth = lineWidth / (style2.strokeNoScale && el.getLineScale ? el.getLineScale() : 1);
    if (ctx.lineWidth !== newLineWidth) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx.lineWidth = newLineWidth;
    }
  }
  for (var i = 0; i < STROKE_PROPS.length; i++) {
    var prop = STROKE_PROPS[i];
    var propName = prop[0];
    if (forceSetAll || style2[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = style2[propName] || prop[1];
    }
  }
  return styleChanged;
}
function bindImageStyle(ctx, el, prevEl, forceSetAll, scope) {
  return bindCommonProps(ctx, getStyle(el, scope.inHover), prevEl && getStyle(prevEl, scope.inHover), forceSetAll, scope);
}
function setContextTransform(ctx, el) {
  var m2 = el.transform;
  var dpr2 = ctx.dpr || 1;
  if (m2) {
    ctx.setTransform(dpr2 * m2[0], dpr2 * m2[1], dpr2 * m2[2], dpr2 * m2[3], dpr2 * m2[4], dpr2 * m2[5]);
  } else {
    ctx.setTransform(dpr2, 0, 0, dpr2, 0, 0);
  }
}
function updateClipStatus(clipPaths, ctx, scope) {
  var allClipped = false;
  for (var i = 0; i < clipPaths.length; i++) {
    var clipPath = clipPaths[i];
    allClipped = allClipped || clipPath.isZeroArea();
    setContextTransform(ctx, clipPath);
    ctx.beginPath();
    clipPath.buildPath(ctx, clipPath.shape);
    ctx.clip();
  }
  scope.allClipped = allClipped;
}
function isTransformChanged(m0, m1) {
  if (m0 && m1) {
    return m0[0] !== m1[0] || m0[1] !== m1[1] || m0[2] !== m1[2] || m0[3] !== m1[3] || m0[4] !== m1[4] || m0[5] !== m1[5];
  } else if (!m0 && !m1) {
    return false;
  }
  return true;
}
var DRAW_TYPE_PATH = 1;
var DRAW_TYPE_IMAGE = 2;
var DRAW_TYPE_TEXT = 3;
var DRAW_TYPE_INCREMENTAL = 4;
function canPathBatch(style2) {
  var hasFill = styleHasFill(style2);
  var hasStroke = styleHasStroke(style2);
  return !(style2.lineDash || !(+hasFill ^ +hasStroke) || hasFill && typeof style2.fill !== "string" || hasStroke && typeof style2.stroke !== "string" || style2.strokePercent < 1 || style2.strokeOpacity < 1 || style2.fillOpacity < 1);
}
function flushPathDrawn(ctx, scope) {
  scope.batchFill && ctx.fill();
  scope.batchStroke && ctx.stroke();
  scope.batchFill = "";
  scope.batchStroke = "";
}
function getStyle(el, inHover) {
  return inHover ? el.__hoverStyle || el.style : el.style;
}
function brushSingle(ctx, el) {
  brush$1(ctx, el, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
}
function brush$1(ctx, el, scope, isLast) {
  var m2 = el.transform;
  if (!el.shouldBePainted(scope.viewWidth, scope.viewHeight, false, false)) {
    el.__dirty &= ~REDRAW_BIT;
    el.__isRendered = false;
    return;
  }
  var clipPaths = el.__clipPaths;
  var prevElClipPaths = scope.prevElClipPaths;
  var forceSetTransform = false;
  var forceSetStyle = false;
  if (!prevElClipPaths || isClipPathChanged(clipPaths, prevElClipPaths)) {
    if (prevElClipPaths && prevElClipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.restore();
      forceSetStyle = forceSetTransform = true;
      scope.prevElClipPaths = null;
      scope.allClipped = false;
      scope.prevEl = null;
    }
    if (clipPaths && clipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.save();
      updateClipStatus(clipPaths, ctx, scope);
      forceSetTransform = true;
    }
    scope.prevElClipPaths = clipPaths;
  }
  if (scope.allClipped) {
    el.__isRendered = false;
    return;
  }
  el.beforeBrush && el.beforeBrush();
  el.innerBeforeBrush();
  var prevEl = scope.prevEl;
  if (!prevEl) {
    forceSetStyle = forceSetTransform = true;
  }
  var canBatchPath = el instanceof Path$1 && el.autoBatch && canPathBatch(el.style);
  if (forceSetTransform || isTransformChanged(m2, prevEl.transform)) {
    flushPathDrawn(ctx, scope);
    setContextTransform(ctx, el);
  } else if (!canBatchPath) {
    flushPathDrawn(ctx, scope);
  }
  var style2 = getStyle(el, scope.inHover);
  if (el instanceof Path$1) {
    if (scope.lastDrawType !== DRAW_TYPE_PATH) {
      forceSetStyle = true;
      scope.lastDrawType = DRAW_TYPE_PATH;
    }
    bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
    if (!canBatchPath || !scope.batchFill && !scope.batchStroke) {
      ctx.beginPath();
    }
    brushPath(ctx, el, style2, canBatchPath);
    if (canBatchPath) {
      scope.batchFill = style2.fill || "";
      scope.batchStroke = style2.stroke || "";
    }
  } else {
    if (el instanceof TSpan$1) {
      if (scope.lastDrawType !== DRAW_TYPE_TEXT) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_TEXT;
      }
      bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushText(ctx, el, style2);
    } else if (el instanceof ZRImage$1) {
      if (scope.lastDrawType !== DRAW_TYPE_IMAGE) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_IMAGE;
      }
      bindImageStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushImage(ctx, el, style2);
    } else if (el.getTemporalDisplayables) {
      if (scope.lastDrawType !== DRAW_TYPE_INCREMENTAL) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_INCREMENTAL;
      }
      brushIncremental(ctx, el, scope);
    }
  }
  if (canBatchPath && isLast) {
    flushPathDrawn(ctx, scope);
  }
  el.innerAfterBrush();
  el.afterBrush && el.afterBrush();
  scope.prevEl = el;
  el.__dirty = 0;
  el.__isRendered = true;
}
function brushIncremental(ctx, el, scope) {
  var displayables = el.getDisplayables();
  var temporalDisplayables = el.getTemporalDisplayables();
  ctx.save();
  var innerScope = {
    prevElClipPaths: null,
    prevEl: null,
    allClipped: false,
    viewWidth: scope.viewWidth,
    viewHeight: scope.viewHeight,
    inHover: scope.inHover
  };
  var i;
  var len2;
  for (i = el.getCursor(), len2 = displayables.length; i < len2; i++) {
    var displayable = displayables[i];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i === len2 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  for (var i_1 = 0, len_1 = temporalDisplayables.length; i_1 < len_1; i_1++) {
    var displayable = temporalDisplayables[i_1];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i_1 === len_1 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  el.clearTemporalDisplayables();
  el.notClear = true;
  ctx.restore();
}
var decalMap = new WeakMap$2();
var decalCache = new LRU$1(100);
var decalKeys = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
function createOrUpdatePatternFromDecal(decalObject, api) {
  if (decalObject === "none") {
    return null;
  }
  var dpr2 = api.getDevicePixelRatio();
  var zr = api.getZr();
  var isSVG = zr.painter.type === "svg";
  if (decalObject.dirty) {
    decalMap["delete"](decalObject);
  }
  var oldPattern = decalMap.get(decalObject);
  if (oldPattern) {
    return oldPattern;
  }
  var decalOpt = defaults(decalObject, {
    symbol: "rect",
    symbolSize: 1,
    symbolKeepAspect: true,
    color: "rgba(0, 0, 0, 0.2)",
    backgroundColor: null,
    dashArrayX: 5,
    dashArrayY: 5,
    rotation: 0,
    maxTileWidth: 512,
    maxTileHeight: 512
  });
  if (decalOpt.backgroundColor === "none") {
    decalOpt.backgroundColor = null;
  }
  var pattern4 = {
    repeat: "repeat"
  };
  setPatternnSource(pattern4);
  pattern4.rotation = decalOpt.rotation;
  pattern4.scaleX = pattern4.scaleY = isSVG ? 1 : 1 / dpr2;
  decalMap.set(decalObject, pattern4);
  decalObject.dirty = false;
  return pattern4;
  function setPatternnSource(pattern5) {
    var keys2 = [dpr2];
    var isValidKey = true;
    for (var i = 0; i < decalKeys.length; ++i) {
      var value = decalOpt[decalKeys[i]];
      if (value != null && !isArray$2(value) && !isString$1(value) && !isNumber(value) && typeof value !== "boolean") {
        isValidKey = false;
        break;
      }
      keys2.push(value);
    }
    var cacheKey;
    if (isValidKey) {
      cacheKey = keys2.join(",") + (isSVG ? "-svg" : "");
      var cache = decalCache.get(cacheKey);
      if (cache) {
        isSVG ? pattern5.svgElement = cache : pattern5.image = cache;
      }
    }
    var dashArrayX = normalizeDashArrayX(decalOpt.dashArrayX);
    var dashArrayY = normalizeDashArrayY(decalOpt.dashArrayY);
    var symbolArray = normalizeSymbolArray(decalOpt.symbol);
    var lineBlockLengthsX = getLineBlockLengthX(dashArrayX);
    var lineBlockLengthY = getLineBlockLengthY(dashArrayY);
    var canvas = !isSVG && platformApi.createCanvas();
    var svgRoot = isSVG && {
      tag: "g",
      attrs: {},
      key: "dcl",
      children: []
    };
    var pSize = getPatternSize();
    var ctx;
    if (canvas) {
      canvas.width = pSize.width * dpr2;
      canvas.height = pSize.height * dpr2;
      ctx = canvas.getContext("2d");
    }
    brushDecal();
    if (isValidKey) {
      decalCache.put(cacheKey, canvas || svgRoot);
    }
    pattern5.image = canvas;
    pattern5.svgElement = svgRoot;
    pattern5.svgWidth = pSize.width;
    pattern5.svgHeight = pSize.height;
    function getPatternSize() {
      var width = 1;
      for (var i2 = 0, xlen = lineBlockLengthsX.length; i2 < xlen; ++i2) {
        width = getLeastCommonMultiple(width, lineBlockLengthsX[i2]);
      }
      var symbolRepeats = 1;
      for (var i2 = 0, xlen = symbolArray.length; i2 < xlen; ++i2) {
        symbolRepeats = getLeastCommonMultiple(symbolRepeats, symbolArray[i2].length);
      }
      width *= symbolRepeats;
      var height = lineBlockLengthY * lineBlockLengthsX.length * symbolArray.length;
      return {
        width: Math.max(1, Math.min(width, decalOpt.maxTileWidth)),
        height: Math.max(1, Math.min(height, decalOpt.maxTileHeight))
      };
    }
    function brushDecal() {
      if (ctx) {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        if (decalOpt.backgroundColor) {
          ctx.fillStyle = decalOpt.backgroundColor;
          ctx.fillRect(0, 0, canvas.width, canvas.height);
        }
      }
      var ySum = 0;
      for (var i2 = 0; i2 < dashArrayY.length; ++i2) {
        ySum += dashArrayY[i2];
      }
      if (ySum <= 0) {
        return;
      }
      var y2 = -lineBlockLengthY;
      var yId = 0;
      var yIdTotal = 0;
      var xId0 = 0;
      while (y2 < pSize.height) {
        if (yId % 2 === 0) {
          var symbolYId = yIdTotal / 2 % symbolArray.length;
          var x2 = 0;
          var xId1 = 0;
          var xId1Total = 0;
          while (x2 < pSize.width * 2) {
            var xSum = 0;
            for (var i2 = 0; i2 < dashArrayX[xId0].length; ++i2) {
              xSum += dashArrayX[xId0][i2];
            }
            if (xSum <= 0) {
              break;
            }
            if (xId1 % 2 === 0) {
              var size = (1 - decalOpt.symbolSize) * 0.5;
              var left = x2 + dashArrayX[xId0][xId1] * size;
              var top_1 = y2 + dashArrayY[yId] * size;
              var width = dashArrayX[xId0][xId1] * decalOpt.symbolSize;
              var height = dashArrayY[yId] * decalOpt.symbolSize;
              var symbolXId = xId1Total / 2 % symbolArray[symbolYId].length;
              brushSymbol(left, top_1, width, height, symbolArray[symbolYId][symbolXId]);
            }
            x2 += dashArrayX[xId0][xId1];
            ++xId1Total;
            ++xId1;
            if (xId1 === dashArrayX[xId0].length) {
              xId1 = 0;
            }
          }
          ++xId0;
          if (xId0 === dashArrayX.length) {
            xId0 = 0;
          }
        }
        y2 += dashArrayY[yId];
        ++yIdTotal;
        ++yId;
        if (yId === dashArrayY.length) {
          yId = 0;
        }
      }
      function brushSymbol(x3, y3, width2, height2, symbolType) {
        var scale2 = isSVG ? 1 : dpr2;
        var symbol = createSymbol$1(symbolType, x3 * scale2, y3 * scale2, width2 * scale2, height2 * scale2, decalOpt.color, decalOpt.symbolKeepAspect);
        if (isSVG) {
          var symbolVNode = zr.painter.renderOneToVNode(symbol);
          if (symbolVNode) {
            svgRoot.children.push(symbolVNode);
          }
        } else {
          brushSingle(ctx, symbol);
        }
      }
    }
  }
}
function normalizeSymbolArray(symbol) {
  if (!symbol || symbol.length === 0) {
    return [["rect"]];
  }
  if (isString$1(symbol)) {
    return [[symbol]];
  }
  var isAllString = true;
  for (var i = 0; i < symbol.length; ++i) {
    if (!isString$1(symbol[i])) {
      isAllString = false;
      break;
    }
  }
  if (isAllString) {
    return normalizeSymbolArray([symbol]);
  }
  var result = [];
  for (var i = 0; i < symbol.length; ++i) {
    if (isString$1(symbol[i])) {
      result.push([symbol[i]]);
    } else {
      result.push(symbol[i]);
    }
  }
  return result;
}
function normalizeDashArrayX(dash) {
  if (!dash || dash.length === 0) {
    return [[0, 0]];
  }
  if (isNumber(dash)) {
    var dashValue = Math.ceil(dash);
    return [[dashValue, dashValue]];
  }
  var isAllNumber = true;
  for (var i = 0; i < dash.length; ++i) {
    if (!isNumber(dash[i])) {
      isAllNumber = false;
      break;
    }
  }
  if (isAllNumber) {
    return normalizeDashArrayX([dash]);
  }
  var result = [];
  for (var i = 0; i < dash.length; ++i) {
    if (isNumber(dash[i])) {
      var dashValue = Math.ceil(dash[i]);
      result.push([dashValue, dashValue]);
    } else {
      var dashValue = map$1(dash[i], function(n2) {
        return Math.ceil(n2);
      });
      if (dashValue.length % 2 === 1) {
        result.push(dashValue.concat(dashValue));
      } else {
        result.push(dashValue);
      }
    }
  }
  return result;
}
function normalizeDashArrayY(dash) {
  if (!dash || typeof dash === "object" && dash.length === 0) {
    return [0, 0];
  }
  if (isNumber(dash)) {
    var dashValue_1 = Math.ceil(dash);
    return [dashValue_1, dashValue_1];
  }
  var dashValue = map$1(dash, function(n2) {
    return Math.ceil(n2);
  });
  return dash.length % 2 ? dashValue.concat(dashValue) : dashValue;
}
function getLineBlockLengthX(dash) {
  return map$1(dash, function(line) {
    return getLineBlockLengthY(line);
  });
}
function getLineBlockLengthY(dash) {
  var blockLength = 0;
  for (var i = 0; i < dash.length; ++i) {
    blockLength += dash[i];
  }
  if (dash.length % 2 === 1) {
    return blockLength * 2;
  }
  return blockLength;
}
function decalVisual(ecModel, api) {
  ecModel.eachRawSeries(function(seriesModel) {
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data2 = seriesModel.getData();
    if (data2.hasItemVisual()) {
      data2.each(function(idx) {
        var decal2 = data2.getItemVisual(idx, "decal");
        if (decal2) {
          var itemStyle = data2.ensureUniqueItemVisual(idx, "style");
          itemStyle.decal = createOrUpdatePatternFromDecal(decal2, api);
        }
      });
    }
    var decal = data2.getVisual("decal");
    if (decal) {
      var style2 = data2.getVisual("style");
      style2.decal = createOrUpdatePatternFromDecal(decal, api);
    }
  });
}
var lifecycle = new Eventful$1();
var lifecycle$1 = lifecycle;
var implsStore = {};
function registerImpl(name2, impl) {
  implsStore[name2] = impl;
}
function getImpl(name2) {
  return implsStore[name2];
}
var hasWindow = typeof window !== "undefined";
var TEST_FRAME_REMAIN_TIME = 1;
var PRIORITY_PROCESSOR_SERIES_FILTER = 800;
var PRIORITY_PROCESSOR_DATASTACK = 900;
var PRIORITY_PROCESSOR_FILTER = 1e3;
var PRIORITY_PROCESSOR_DEFAULT = 2e3;
var PRIORITY_PROCESSOR_STATISTIC = 5e3;
var PRIORITY_VISUAL_LAYOUT = 1e3;
var PRIORITY_VISUAL_PROGRESSIVE_LAYOUT = 1100;
var PRIORITY_VISUAL_GLOBAL = 2e3;
var PRIORITY_VISUAL_CHART = 3e3;
var PRIORITY_VISUAL_COMPONENT = 4e3;
var PRIORITY_VISUAL_CHART_DATA_CUSTOM = 4500;
var PRIORITY_VISUAL_POST_CHART_LAYOUT = 4600;
var PRIORITY_VISUAL_BRUSH = 5e3;
var PRIORITY_VISUAL_ARIA = 6e3;
var PRIORITY_VISUAL_DECAL = 7e3;
var PRIORITY = {
  PROCESSOR: {
    FILTER: PRIORITY_PROCESSOR_FILTER,
    SERIES_FILTER: PRIORITY_PROCESSOR_SERIES_FILTER,
    STATISTIC: PRIORITY_PROCESSOR_STATISTIC
  },
  VISUAL: {
    LAYOUT: PRIORITY_VISUAL_LAYOUT,
    PROGRESSIVE_LAYOUT: PRIORITY_VISUAL_PROGRESSIVE_LAYOUT,
    GLOBAL: PRIORITY_VISUAL_GLOBAL,
    CHART: PRIORITY_VISUAL_CHART,
    POST_CHART_LAYOUT: PRIORITY_VISUAL_POST_CHART_LAYOUT,
    COMPONENT: PRIORITY_VISUAL_COMPONENT,
    BRUSH: PRIORITY_VISUAL_BRUSH,
    CHART_ITEM: PRIORITY_VISUAL_CHART_DATA_CUSTOM,
    ARIA: PRIORITY_VISUAL_ARIA,
    DECAL: PRIORITY_VISUAL_DECAL
  }
};
var IN_MAIN_PROCESS_KEY = "__flagInMainProcess";
var PENDING_UPDATE = "__pendingUpdate";
var STATUS_NEEDS_UPDATE_KEY = "__needsUpdateStatus";
var ACTION_REG = /^[a-zA-Z0-9_]+$/;
var CONNECT_STATUS_KEY = "__connectUpdateStatus";
var CONNECT_STATUS_PENDING = 0;
var CONNECT_STATUS_UPDATING = 1;
var CONNECT_STATUS_UPDATED = 2;
function createRegisterEventWithLowercaseECharts(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    if (this.isDisposed()) {
      disposedWarning(this.id);
      return;
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function createRegisterEventWithLowercaseMessageCenter(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function toLowercaseNameAndCallEventful(host, method4, args) {
  args[0] = args[0] && args[0].toLowerCase();
  return Eventful$1.prototype[method4].apply(host, args);
}
var MessageCenter = function(_super) {
  __extends(MessageCenter2, _super);
  function MessageCenter2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return MessageCenter2;
}(Eventful$1);
var messageCenterProto = MessageCenter.prototype;
messageCenterProto.on = createRegisterEventWithLowercaseMessageCenter("on");
messageCenterProto.off = createRegisterEventWithLowercaseMessageCenter("off");
var prepare;
var prepareView;
var updateDirectly;
var updateMethods;
var doConvertPixel;
var updateStreamModes;
var doDispatchAction;
var flushPendingActions;
var triggerUpdatedEvent;
var bindRenderedEvent;
var bindMouseEvent;
var render;
var renderComponents;
var renderSeries;
var createExtensionAPI;
var enableConnect;
var markStatusToUpdate;
var applyChangedStates;
var ECharts = function(_super) {
  __extends(ECharts2, _super);
  function ECharts2(dom, theme2, opts) {
    var _this = _super.call(this, new ECEventProcessor()) || this;
    _this._chartsViews = [];
    _this._chartsMap = {};
    _this._componentsViews = [];
    _this._componentsMap = {};
    _this._pendingActions = [];
    opts = opts || {};
    if (isString$1(theme2)) {
      theme2 = themeStorage[theme2];
    }
    _this._dom = dom;
    var defaultRenderer = "canvas";
    var defaultUseDirtyRect = false;
    var zr = _this._zr = init$3(dom, {
      renderer: opts.renderer || defaultRenderer,
      devicePixelRatio: opts.devicePixelRatio,
      width: opts.width,
      height: opts.height,
      ssr: opts.ssr,
      useDirtyRect: opts.useDirtyRect == null ? defaultUseDirtyRect : opts.useDirtyRect
    });
    _this._ssr = opts.ssr;
    _this._throttledZrFlush = throttle(bind$1(zr.flush, zr), 17);
    theme2 = clone$4(theme2);
    theme2 && globalBackwardCompat(theme2, true);
    _this._theme = theme2;
    _this._locale = createLocaleObject(opts.locale || SYSTEM_LANG);
    _this._coordSysMgr = new CoordinateSystem();
    var api = _this._api = createExtensionAPI(_this);
    function prioritySortFunc(a, b2) {
      return a.__prio - b2.__prio;
    }
    sort$2(visualFuncs, prioritySortFunc);
    sort$2(dataProcessorFuncs, prioritySortFunc);
    _this._scheduler = new Scheduler$1(_this, api, dataProcessorFuncs, visualFuncs);
    _this._messageCenter = new MessageCenter();
    _this._initEvents();
    _this.resize = bind$1(_this.resize, _this);
    zr.animation.on("frame", _this._onframe, _this);
    bindRenderedEvent(zr, _this);
    bindMouseEvent(zr, _this);
    setAsPrimitive(_this);
    return _this;
  }
  ECharts2.prototype._onframe = function() {
    if (this._disposed) {
      return;
    }
    applyChangedStates(this);
    var scheduler2 = this._scheduler;
    if (this[PENDING_UPDATE]) {
      var silent = this[PENDING_UPDATE].silent;
      this[IN_MAIN_PROCESS_KEY] = true;
      try {
        prepare(this);
        updateMethods.update.call(this, null, this[PENDING_UPDATE].updateParams);
      } catch (e2) {
        this[IN_MAIN_PROCESS_KEY] = false;
        this[PENDING_UPDATE] = null;
        throw e2;
      }
      this._zr.flush();
      this[IN_MAIN_PROCESS_KEY] = false;
      this[PENDING_UPDATE] = null;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    } else if (scheduler2.unfinished) {
      var remainTime = TEST_FRAME_REMAIN_TIME;
      var ecModel = this._model;
      var api = this._api;
      scheduler2.unfinished = false;
      do {
        var startTime = +new Date();
        scheduler2.performSeriesTasks(ecModel);
        scheduler2.performDataProcessorTasks(ecModel);
        updateStreamModes(this, ecModel);
        scheduler2.performVisualTasks(ecModel);
        renderSeries(this, this._model, api, "remain", {});
        remainTime -= +new Date() - startTime;
      } while (remainTime > 0 && scheduler2.unfinished);
      if (!scheduler2.unfinished) {
        this._zr.flush();
      }
    }
  };
  ECharts2.prototype.getDom = function() {
    return this._dom;
  };
  ECharts2.prototype.getId = function() {
    return this.id;
  };
  ECharts2.prototype.getZr = function() {
    return this._zr;
  };
  ECharts2.prototype.isSSR = function() {
    return this._ssr;
  };
  ECharts2.prototype.setOption = function(option, notMerge, lazyUpdate) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var silent;
    var replaceMerge;
    var transitionOpt;
    if (isObject$6(notMerge)) {
      lazyUpdate = notMerge.lazyUpdate;
      silent = notMerge.silent;
      replaceMerge = notMerge.replaceMerge;
      transitionOpt = notMerge.transition;
      notMerge = notMerge.notMerge;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    if (!this._model || notMerge) {
      var optionManager = new OptionManager$1(this._api);
      var theme2 = this._theme;
      var ecModel = this._model = new GlobalModel$1();
      ecModel.scheduler = this._scheduler;
      ecModel.ssr = this._ssr;
      ecModel.init(null, null, null, theme2, this._locale, optionManager);
    }
    this._model.setOption(option, {
      replaceMerge
    }, optionPreprocessorFuncs);
    var updateParams = {
      seriesTransition: transitionOpt,
      optionChanged: true
    };
    if (lazyUpdate) {
      this[PENDING_UPDATE] = {
        silent,
        updateParams
      };
      this[IN_MAIN_PROCESS_KEY] = false;
      this.getZr().wakeUp();
    } else {
      try {
        prepare(this);
        updateMethods.update.call(this, null, updateParams);
      } catch (e2) {
        this[PENDING_UPDATE] = null;
        this[IN_MAIN_PROCESS_KEY] = false;
        throw e2;
      }
      if (!this._ssr) {
        this._zr.flush();
      }
      this[PENDING_UPDATE] = null;
      this[IN_MAIN_PROCESS_KEY] = false;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    }
  };
  ECharts2.prototype.setTheme = function() {
  };
  ECharts2.prototype.getModel = function() {
    return this._model;
  };
  ECharts2.prototype.getOption = function() {
    return this._model && this._model.getOption();
  };
  ECharts2.prototype.getWidth = function() {
    return this._zr.getWidth();
  };
  ECharts2.prototype.getHeight = function() {
    return this._zr.getHeight();
  };
  ECharts2.prototype.getDevicePixelRatio = function() {
    return this._zr.painter.dpr || hasWindow && window.devicePixelRatio || 1;
  };
  ECharts2.prototype.getRenderedCanvas = function(opts) {
    return this.renderToCanvas(opts);
  };
  ECharts2.prototype.renderToCanvas = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.getRenderedCanvas({
      backgroundColor: opts.backgroundColor || this._model.get("backgroundColor"),
      pixelRatio: opts.pixelRatio || this.getDevicePixelRatio()
    });
  };
  ECharts2.prototype.renderToSVGString = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.renderToString({
      useViewBox: opts.useViewBox
    });
  };
  ECharts2.prototype.getSvgDataURL = function() {
    if (!env$1.svgSupported) {
      return;
    }
    var zr = this._zr;
    var list = zr.storage.getDisplayList();
    each$g(list, function(el) {
      el.stopAnimation(null, true);
    });
    return zr.painter.toDataURL();
  };
  ECharts2.prototype.getDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    opts = opts || {};
    var excludeComponents = opts.excludeComponents;
    var ecModel = this._model;
    var excludesComponentViews = [];
    var self2 = this;
    each$g(excludeComponents, function(componentType) {
      ecModel.eachComponent({
        mainType: componentType
      }, function(component) {
        var view = self2._componentsMap[component.__viewId];
        if (!view.group.ignore) {
          excludesComponentViews.push(view);
          view.group.ignore = true;
        }
      });
    });
    var url2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(opts).toDataURL("image/" + (opts && opts.type || "png"));
    each$g(excludesComponentViews, function(view) {
      view.group.ignore = false;
    });
    return url2;
  };
  ECharts2.prototype.getConnectedDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var isSvg = opts.type === "svg";
    var groupId = this.group;
    var mathMin2 = Math.min;
    var mathMax2 = Math.max;
    var MAX_NUMBER = Infinity;
    if (connectedGroups[groupId]) {
      var left_1 = MAX_NUMBER;
      var top_1 = MAX_NUMBER;
      var right_1 = -MAX_NUMBER;
      var bottom_1 = -MAX_NUMBER;
      var canvasList_1 = [];
      var dpr_1 = opts && opts.pixelRatio || this.getDevicePixelRatio();
      each$g(instances, function(chart, id2) {
        if (chart.group === groupId) {
          var canvas = isSvg ? chart.getZr().painter.getSvgDom().innerHTML : chart.renderToCanvas(clone$4(opts));
          var boundingRect = chart.getDom().getBoundingClientRect();
          left_1 = mathMin2(boundingRect.left, left_1);
          top_1 = mathMin2(boundingRect.top, top_1);
          right_1 = mathMax2(boundingRect.right, right_1);
          bottom_1 = mathMax2(boundingRect.bottom, bottom_1);
          canvasList_1.push({
            dom: canvas,
            left: boundingRect.left,
            top: boundingRect.top
          });
        }
      });
      left_1 *= dpr_1;
      top_1 *= dpr_1;
      right_1 *= dpr_1;
      bottom_1 *= dpr_1;
      var width = right_1 - left_1;
      var height = bottom_1 - top_1;
      var targetCanvas = platformApi.createCanvas();
      var zr_1 = init$3(targetCanvas, {
        renderer: isSvg ? "svg" : "canvas"
      });
      zr_1.resize({
        width,
        height
      });
      if (isSvg) {
        var content_1 = "";
        each$g(canvasList_1, function(item) {
          var x2 = item.left - left_1;
          var y2 = item.top - top_1;
          content_1 += '<g transform="translate(' + x2 + "," + y2 + ')">' + item.dom + "</g>";
        });
        zr_1.painter.getSvgRoot().innerHTML = content_1;
        if (opts.connectedBackgroundColor) {
          zr_1.painter.setBackgroundColor(opts.connectedBackgroundColor);
        }
        zr_1.refreshImmediately();
        return zr_1.painter.toDataURL();
      } else {
        if (opts.connectedBackgroundColor) {
          zr_1.add(new Rect$3({
            shape: {
              x: 0,
              y: 0,
              width,
              height
            },
            style: {
              fill: opts.connectedBackgroundColor
            }
          }));
        }
        each$g(canvasList_1, function(item) {
          var img = new ZRImage$1({
            style: {
              x: item.left * dpr_1 - left_1,
              y: item.top * dpr_1 - top_1,
              image: item.dom
            }
          });
          zr_1.add(img);
        });
        zr_1.refreshImmediately();
        return targetCanvas.toDataURL("image/" + (opts && opts.type || "png"));
      }
    } else {
      return this.getDataURL(opts);
    }
  };
  ECharts2.prototype.convertToPixel = function(finder, value) {
    return doConvertPixel(this, "convertToPixel", finder, value);
  };
  ECharts2.prototype.convertFromPixel = function(finder, value) {
    return doConvertPixel(this, "convertFromPixel", finder, value);
  };
  ECharts2.prototype.containPixel = function(finder, value) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var ecModel = this._model;
    var result;
    var findResult = parseFinder$1(ecModel, finder);
    each$g(findResult, function(models, key) {
      key.indexOf("Models") >= 0 && each$g(models, function(model) {
        var coordSys = model.coordinateSystem;
        if (coordSys && coordSys.containPoint) {
          result = result || !!coordSys.containPoint(value);
        } else if (key === "seriesModels") {
          var view = this._chartsMap[model.__viewId];
          if (view && view.containPoint) {
            result = result || view.containPoint(value, model);
          }
        } else
          ;
      }, this);
    }, this);
    return !!result;
  };
  ECharts2.prototype.getVisual = function(finder, visualType) {
    var ecModel = this._model;
    var parsedFinder = parseFinder$1(ecModel, finder, {
      defaultMainType: "series"
    });
    var seriesModel = parsedFinder.seriesModel;
    var data2 = seriesModel.getData();
    var dataIndexInside = parsedFinder.hasOwnProperty("dataIndexInside") ? parsedFinder.dataIndexInside : parsedFinder.hasOwnProperty("dataIndex") ? data2.indexOfRawIndex(parsedFinder.dataIndex) : null;
    return dataIndexInside != null ? getItemVisualFromData(data2, dataIndexInside, visualType) : getVisualFromData(data2, visualType);
  };
  ECharts2.prototype.getViewOfComponentModel = function(componentModel) {
    return this._componentsMap[componentModel.__viewId];
  };
  ECharts2.prototype.getViewOfSeriesModel = function(seriesModel) {
    return this._chartsMap[seriesModel.__viewId];
  };
  ECharts2.prototype._initEvents = function() {
    var _this = this;
    each$g(MOUSE_EVENT_NAMES, function(eveName) {
      var handler = function(e2) {
        var ecModel = _this.getModel();
        var el = e2.target;
        var params;
        var isGlobalOut = eveName === "globalout";
        if (isGlobalOut) {
          params = {};
        } else {
          el && findEventDispatcher(el, function(parent) {
            var ecData = getECData(parent);
            if (ecData && ecData.dataIndex != null) {
              var dataModel = ecData.dataModel || ecModel.getSeriesByIndex(ecData.seriesIndex);
              params = dataModel && dataModel.getDataParams(ecData.dataIndex, ecData.dataType) || {};
              return true;
            } else if (ecData.eventData) {
              params = extend({}, ecData.eventData);
              return true;
            }
          }, true);
        }
        if (params) {
          var componentType = params.componentType;
          var componentIndex = params.componentIndex;
          if (componentType === "markLine" || componentType === "markPoint" || componentType === "markArea") {
            componentType = "series";
            componentIndex = params.seriesIndex;
          }
          var model = componentType && componentIndex != null && ecModel.getComponent(componentType, componentIndex);
          var view = model && _this[model.mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId];
          params.event = e2;
          params.type = eveName;
          _this._$eventProcessor.eventInfo = {
            targetEl: el,
            packedEvent: params,
            model,
            view
          };
          _this.trigger(eveName, params);
        }
      };
      handler.zrEventfulCallAtLast = true;
      _this._zr.on(eveName, handler, _this);
    });
    each$g(eventActionMap, function(actionType, eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    each$g(["selectchanged"], function(eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    handleLegacySelectEvents(this._messageCenter, this, this._api);
  };
  ECharts2.prototype.isDisposed = function() {
    return this._disposed;
  };
  ECharts2.prototype.clear = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this.setOption({
      series: []
    }, true);
  };
  ECharts2.prototype.dispose = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._disposed = true;
    var dom = this.getDom();
    if (dom) {
      setAttribute(this.getDom(), DOM_ATTRIBUTE_KEY, "");
    }
    var chart = this;
    var api = chart._api;
    var ecModel = chart._model;
    each$g(chart._componentsViews, function(component) {
      component.dispose(ecModel, api);
    });
    each$g(chart._chartsViews, function(chart2) {
      chart2.dispose(ecModel, api);
    });
    chart._zr.dispose();
    chart._dom = chart._model = chart._chartsMap = chart._componentsMap = chart._chartsViews = chart._componentsViews = chart._scheduler = chart._api = chart._zr = chart._throttledZrFlush = chart._theme = chart._coordSysMgr = chart._messageCenter = null;
    delete instances[chart.id];
  };
  ECharts2.prototype.resize = function(opts) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._zr.resize(opts);
    var ecModel = this._model;
    this._loadingFX && this._loadingFX.resize();
    if (!ecModel) {
      return;
    }
    var needPrepare = ecModel.resetOption("media");
    var silent = opts && opts.silent;
    if (this[PENDING_UPDATE]) {
      if (silent == null) {
        silent = this[PENDING_UPDATE].silent;
      }
      needPrepare = true;
      this[PENDING_UPDATE] = null;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    try {
      needPrepare && prepare(this);
      updateMethods.update.call(this, {
        type: "resize",
        animation: extend({
          duration: 0
        }, opts && opts.animation)
      });
    } catch (e2) {
      this[IN_MAIN_PROCESS_KEY] = false;
      throw e2;
    }
    this[IN_MAIN_PROCESS_KEY] = false;
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.showLoading = function(name2, cfg) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (isObject$6(name2)) {
      cfg = name2;
      name2 = "";
    }
    name2 = name2 || "default";
    this.hideLoading();
    if (!loadingEffects[name2]) {
      return;
    }
    var el = loadingEffects[name2](this._api, cfg);
    var zr = this._zr;
    this._loadingFX = el;
    zr.add(el);
  };
  ECharts2.prototype.hideLoading = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._loadingFX && this._zr.remove(this._loadingFX);
    this._loadingFX = null;
  };
  ECharts2.prototype.makeActionFromEvent = function(eventObj) {
    var payload = extend({}, eventObj);
    payload.type = eventActionMap[eventObj.type];
    return payload;
  };
  ECharts2.prototype.dispatchAction = function(payload, opt) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (!isObject$6(opt)) {
      opt = {
        silent: !!opt
      };
    }
    if (!actions[payload.type]) {
      return;
    }
    if (!this._model) {
      return;
    }
    if (this[IN_MAIN_PROCESS_KEY]) {
      this._pendingActions.push(payload);
      return;
    }
    var silent = opt.silent;
    doDispatchAction.call(this, payload, silent);
    var flush = opt.flush;
    if (flush) {
      this._zr.flush();
    } else if (flush !== false && env$1.browser.weChat) {
      this._throttledZrFlush();
    }
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.updateLabelLayout = function() {
    lifecycle$1.trigger("series:layoutlabels", this._model, this._api, {
      updatedSeries: []
    });
  };
  ECharts2.prototype.appendData = function(params) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var seriesIndex = params.seriesIndex;
    var ecModel = this.getModel();
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    seriesModel.appendData(params);
    this._scheduler.unfinished = true;
    this.getZr().wakeUp();
  };
  ECharts2.internalField = function() {
    prepare = function(ecIns) {
      var scheduler2 = ecIns._scheduler;
      scheduler2.restorePipelines(ecIns._model);
      scheduler2.prepareStageTasks();
      prepareView(ecIns, true);
      prepareView(ecIns, false);
      scheduler2.plan();
    };
    prepareView = function(ecIns, isComponent) {
      var ecModel = ecIns._model;
      var scheduler2 = ecIns._scheduler;
      var viewList = isComponent ? ecIns._componentsViews : ecIns._chartsViews;
      var viewMap = isComponent ? ecIns._componentsMap : ecIns._chartsMap;
      var zr = ecIns._zr;
      var api = ecIns._api;
      for (var i = 0; i < viewList.length; i++) {
        viewList[i].__alive = false;
      }
      isComponent ? ecModel.eachComponent(function(componentType, model) {
        componentType !== "series" && doPrepare(model);
      }) : ecModel.eachSeries(doPrepare);
      function doPrepare(model) {
        var requireNewView = model.__requireNewView;
        model.__requireNewView = false;
        var viewId = "_ec_" + model.id + "_" + model.type;
        var view2 = !requireNewView && viewMap[viewId];
        if (!view2) {
          var classType = parseClassType(model.type);
          var Clazz = isComponent ? ComponentView$1.getClass(classType.main, classType.sub) : ChartView$1.getClass(classType.sub);
          view2 = new Clazz();
          view2.init(ecModel, api);
          viewMap[viewId] = view2;
          viewList.push(view2);
          zr.add(view2.group);
        }
        model.__viewId = view2.__id = viewId;
        view2.__alive = true;
        view2.__model = model;
        view2.group.__ecComponentInfo = {
          mainType: model.mainType,
          index: model.componentIndex
        };
        !isComponent && scheduler2.prepareView(view2, model, ecModel, api);
      }
      for (var i = 0; i < viewList.length; ) {
        var view = viewList[i];
        if (!view.__alive) {
          !isComponent && view.renderTask.dispose();
          zr.remove(view.group);
          view.dispose(ecModel, api);
          viewList.splice(i, 1);
          if (viewMap[view.__id] === view) {
            delete viewMap[view.__id];
          }
          view.__id = view.group.__ecComponentInfo = null;
        } else {
          i++;
        }
      }
    };
    updateDirectly = function(ecIns, method4, payload, mainType, subType) {
      var ecModel = ecIns._model;
      ecModel.setUpdatePayload(payload);
      if (!mainType) {
        each$g([].concat(ecIns._componentsViews).concat(ecIns._chartsViews), callView);
        return;
      }
      var query = {};
      query[mainType + "Id"] = payload[mainType + "Id"];
      query[mainType + "Index"] = payload[mainType + "Index"];
      query[mainType + "Name"] = payload[mainType + "Name"];
      var condition = {
        mainType,
        query
      };
      subType && (condition.subType = subType);
      var excludeSeriesId = payload.excludeSeriesId;
      var excludeSeriesIdMap;
      if (excludeSeriesId != null) {
        excludeSeriesIdMap = createHashMap();
        each$g(normalizeToArray(excludeSeriesId), function(id2) {
          var modelId = convertOptionIdName(id2, null);
          if (modelId != null) {
            excludeSeriesIdMap.set(modelId, true);
          }
        });
      }
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        if (isHighDownPayload(payload)) {
          if (model instanceof SeriesModel$1) {
            if (payload.type === HIGHLIGHT_ACTION_TYPE && !payload.notBlur && !model.get(["emphasis", "disabled"])) {
              blurSeriesFromHighlightPayload(model, payload, ecIns._api);
            }
          } else {
            var _a2 = findComponentHighDownDispatchers(model.mainType, model.componentIndex, payload.name, ecIns._api), focusSelf = _a2.focusSelf, dispatchers = _a2.dispatchers;
            if (payload.type === HIGHLIGHT_ACTION_TYPE && focusSelf && !payload.notBlur) {
              blurComponent(model.mainType, model.componentIndex, ecIns._api);
            }
            if (dispatchers) {
              each$g(dispatchers, function(dispatcher) {
                payload.type === HIGHLIGHT_ACTION_TYPE ? enterEmphasis(dispatcher) : leaveEmphasis(dispatcher);
              });
            }
          }
        } else if (isSelectChangePayload(payload)) {
          if (model instanceof SeriesModel$1) {
            toggleSelectionFromPayload(model, payload, ecIns._api);
            updateSeriesElementSelection(model);
            markStatusToUpdate(ecIns);
          }
        }
      }, ecIns);
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        callView(ecIns[mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId]);
      }, ecIns);
      function callView(view) {
        view && view.__alive && view[method4] && view[method4](view.__model, ecModel, ecIns._api, payload);
      }
    };
    updateMethods = {
      prepareAndUpdate: function(payload) {
        prepare(this);
        updateMethods.update.call(this, payload, {
          optionChanged: payload.newOption != null
        });
      },
      update: function(payload, updateParams) {
        var ecModel = this._model;
        var api = this._api;
        var zr = this._zr;
        var coordSysMgr = this._coordSysMgr;
        var scheduler2 = this._scheduler;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        scheduler2.restoreData(ecModel, payload);
        scheduler2.performSeriesTasks(ecModel);
        coordSysMgr.create(ecModel, api);
        scheduler2.performDataProcessorTasks(ecModel, payload);
        updateStreamModes(this, ecModel);
        coordSysMgr.update(ecModel, api);
        clearColorPalette(ecModel);
        scheduler2.performVisualTasks(ecModel, payload);
        render(this, ecModel, api, payload, updateParams);
        var backgroundColor2 = ecModel.get("backgroundColor") || "transparent";
        var darkMode = ecModel.get("darkMode");
        zr.setBackgroundColor(backgroundColor2);
        if (darkMode != null && darkMode !== "auto") {
          zr.setDarkMode(darkMode);
        }
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateTransform: function(payload) {
        var _this = this;
        var ecModel = this._model;
        var api = this._api;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        var componentDirtyList = [];
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType === "series") {
            return;
          }
          var componentView = _this.getViewOfComponentModel(componentModel);
          if (componentView && componentView.__alive) {
            if (componentView.updateTransform) {
              var result = componentView.updateTransform(componentModel, ecModel, api, payload);
              result && result.update && componentDirtyList.push(componentView);
            } else {
              componentDirtyList.push(componentView);
            }
          }
        });
        var seriesDirtyMap = createHashMap();
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          if (chartView.updateTransform) {
            var result = chartView.updateTransform(seriesModel, ecModel, api, payload);
            result && result.update && seriesDirtyMap.set(seriesModel.uid, 1);
          } else {
            seriesDirtyMap.set(seriesModel.uid, 1);
          }
        });
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true,
          dirtyMap: seriesDirtyMap
        });
        renderSeries(this, ecModel, api, payload, {}, seriesDirtyMap);
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateView: function(payload) {
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ChartView$1.markUpdateMethod(payload, "updateView");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true
        });
        render(this, ecModel, this._api, payload, {});
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateVisual: function(payload) {
        var _this = this;
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ecModel.eachSeries(function(seriesModel) {
          seriesModel.getData().clearAllVisual();
        });
        ChartView$1.markUpdateMethod(payload, "updateVisual");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          visualType: "visual",
          setDirty: true
        });
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType !== "series") {
            var componentView = _this.getViewOfComponentModel(componentModel);
            componentView && componentView.__alive && componentView.updateVisual(componentModel, ecModel, _this._api, payload);
          }
        });
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          chartView.updateVisual(seriesModel, ecModel, _this._api, payload);
        });
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateLayout: function(payload) {
        updateMethods.update.call(this, payload);
      }
    };
    doConvertPixel = function(ecIns, methodName, finder, value) {
      if (ecIns._disposed) {
        disposedWarning(ecIns.id);
        return;
      }
      var ecModel = ecIns._model;
      var coordSysList = ecIns._coordSysMgr.getCoordinateSystems();
      var result;
      var parsedFinder = parseFinder$1(ecModel, finder);
      for (var i = 0; i < coordSysList.length; i++) {
        var coordSys = coordSysList[i];
        if (coordSys[methodName] && (result = coordSys[methodName](ecModel, parsedFinder, value)) != null) {
          return result;
        }
      }
    };
    updateStreamModes = function(ecIns, ecModel) {
      var chartsMap = ecIns._chartsMap;
      var scheduler2 = ecIns._scheduler;
      ecModel.eachSeries(function(seriesModel) {
        scheduler2.updateStreamModes(seriesModel, chartsMap[seriesModel.__viewId]);
      });
    };
    doDispatchAction = function(payload, silent) {
      var _this = this;
      var ecModel = this.getModel();
      var payloadType = payload.type;
      var escapeConnect = payload.escapeConnect;
      var actionWrap = actions[payloadType];
      var actionInfo2 = actionWrap.actionInfo;
      var cptTypeTmp = (actionInfo2.update || "update").split(":");
      var updateMethod = cptTypeTmp.pop();
      var cptType = cptTypeTmp[0] != null && parseClassType(cptTypeTmp[0]);
      this[IN_MAIN_PROCESS_KEY] = true;
      var payloads = [payload];
      var batched = false;
      if (payload.batch) {
        batched = true;
        payloads = map$1(payload.batch, function(item) {
          item = defaults(extend({}, item), payload);
          item.batch = null;
          return item;
        });
      }
      var eventObjBatch = [];
      var eventObj;
      var isSelectChange = isSelectChangePayload(payload);
      var isHighDown = isHighDownPayload(payload);
      if (isHighDown) {
        allLeaveBlur(this._api);
      }
      each$g(payloads, function(batchItem) {
        eventObj = actionWrap.action(batchItem, _this._model, _this._api);
        eventObj = eventObj || extend({}, batchItem);
        eventObj.type = actionInfo2.event || eventObj.type;
        eventObjBatch.push(eventObj);
        if (isHighDown) {
          var _a2 = preParseFinder(payload), queryOptionMap = _a2.queryOptionMap, mainTypeSpecified = _a2.mainTypeSpecified;
          var componentMainType = mainTypeSpecified ? queryOptionMap.keys()[0] : "series";
          updateDirectly(_this, updateMethod, batchItem, componentMainType);
          markStatusToUpdate(_this);
        } else if (isSelectChange) {
          updateDirectly(_this, updateMethod, batchItem, "series");
          markStatusToUpdate(_this);
        } else if (cptType) {
          updateDirectly(_this, updateMethod, batchItem, cptType.main, cptType.sub);
        }
      });
      if (updateMethod !== "none" && !isHighDown && !isSelectChange && !cptType) {
        try {
          if (this[PENDING_UPDATE]) {
            prepare(this);
            updateMethods.update.call(this, payload);
            this[PENDING_UPDATE] = null;
          } else {
            updateMethods[updateMethod].call(this, payload);
          }
        } catch (e2) {
          this[IN_MAIN_PROCESS_KEY] = false;
          throw e2;
        }
      }
      if (batched) {
        eventObj = {
          type: actionInfo2.event || payloadType,
          escapeConnect,
          batch: eventObjBatch
        };
      } else {
        eventObj = eventObjBatch[0];
      }
      this[IN_MAIN_PROCESS_KEY] = false;
      if (!silent) {
        var messageCenter = this._messageCenter;
        messageCenter.trigger(eventObj.type, eventObj);
        if (isSelectChange) {
          var newObj = {
            type: "selectchanged",
            escapeConnect,
            selected: getAllSelectedIndices(ecModel),
            isFromClick: payload.isFromClick || false,
            fromAction: payload.type,
            fromActionPayload: payload
          };
          messageCenter.trigger(newObj.type, newObj);
        }
      }
    };
    flushPendingActions = function(silent) {
      var pendingActions = this._pendingActions;
      while (pendingActions.length) {
        var payload = pendingActions.shift();
        doDispatchAction.call(this, payload, silent);
      }
    };
    triggerUpdatedEvent = function(silent) {
      !silent && this.trigger("updated");
    };
    bindRenderedEvent = function(zr, ecIns) {
      zr.on("rendered", function(params) {
        ecIns.trigger("rendered", params);
        if (zr.animation.isFinished() && !ecIns[PENDING_UPDATE] && !ecIns._scheduler.unfinished && !ecIns._pendingActions.length) {
          ecIns.trigger("finished");
        }
      });
    };
    bindMouseEvent = function(zr, ecIns) {
      zr.on("mouseover", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOverForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("mouseout", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOutForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("click", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, function(target) {
          return getECData(target).dataIndex != null;
        }, true);
        if (dispatcher) {
          var actionType = dispatcher.selected ? "unselect" : "select";
          var ecData = getECData(dispatcher);
          ecIns._api.dispatchAction({
            type: actionType,
            dataType: ecData.dataType,
            dataIndexInside: ecData.dataIndex,
            seriesIndex: ecData.seriesIndex,
            isFromClick: true
          });
        }
      });
    };
    function clearColorPalette(ecModel) {
      ecModel.clearColorPalette();
      ecModel.eachSeries(function(seriesModel) {
        seriesModel.clearColorPalette();
      });
    }
    function allocateZlevels(ecModel) {
      var componentZLevels = [];
      var seriesZLevels = [];
      var hasSeperateZLevel = false;
      ecModel.eachComponent(function(componentType, componentModel) {
        var zlevel = componentModel.get("zlevel") || 0;
        var z2 = componentModel.get("z") || 0;
        var zlevelKey = componentModel.getZLevelKey();
        hasSeperateZLevel = hasSeperateZLevel || !!zlevelKey;
        (componentType === "series" ? seriesZLevels : componentZLevels).push({
          zlevel,
          z: z2,
          idx: componentModel.componentIndex,
          type: componentType,
          key: zlevelKey
        });
      });
      if (hasSeperateZLevel) {
        var zLevels = componentZLevels.concat(seriesZLevels);
        var lastSeriesZLevel_1;
        var lastSeriesKey_1;
        sort$2(zLevels, function(a, b2) {
          if (a.zlevel === b2.zlevel) {
            return a.z - b2.z;
          }
          return a.zlevel - b2.zlevel;
        });
        each$g(zLevels, function(item) {
          var componentModel = ecModel.getComponent(item.type, item.idx);
          var zlevel = item.zlevel;
          var key = item.key;
          if (lastSeriesZLevel_1 != null) {
            zlevel = Math.max(lastSeriesZLevel_1, zlevel);
          }
          if (key) {
            if (zlevel === lastSeriesZLevel_1 && key !== lastSeriesKey_1) {
              zlevel++;
            }
            lastSeriesKey_1 = key;
          } else if (lastSeriesKey_1) {
            if (zlevel === lastSeriesZLevel_1) {
              zlevel++;
            }
            lastSeriesKey_1 = "";
          }
          lastSeriesZLevel_1 = zlevel;
          componentModel.setZLevel(zlevel);
        });
      }
    }
    render = function(ecIns, ecModel, api, payload, updateParams) {
      allocateZlevels(ecModel);
      renderComponents(ecIns, ecModel, api, payload, updateParams);
      each$g(ecIns._chartsViews, function(chart) {
        chart.__alive = false;
      });
      renderSeries(ecIns, ecModel, api, payload, updateParams);
      each$g(ecIns._chartsViews, function(chart) {
        if (!chart.__alive) {
          chart.remove(ecModel, api);
        }
      });
    };
    renderComponents = function(ecIns, ecModel, api, payload, updateParams, dirtyList) {
      each$g(dirtyList || ecIns._componentsViews, function(componentView) {
        var componentModel = componentView.__model;
        clearStates(componentModel, componentView);
        componentView.render(componentModel, ecModel, api, payload);
        updateZ2(componentModel, componentView);
        updateStates(componentModel, componentView);
      });
    };
    renderSeries = function(ecIns, ecModel, api, payload, updateParams, dirtyMap) {
      var scheduler2 = ecIns._scheduler;
      updateParams = extend(updateParams || {}, {
        updatedSeries: ecModel.getSeries()
      });
      lifecycle$1.trigger("series:beforeupdate", ecModel, api, updateParams);
      var unfinished = false;
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        chartView.__alive = true;
        var renderTask = chartView.renderTask;
        scheduler2.updatePayload(renderTask, payload);
        clearStates(seriesModel, chartView);
        if (dirtyMap && dirtyMap.get(seriesModel.uid)) {
          renderTask.dirty();
        }
        if (renderTask.perform(scheduler2.getPerformArgs(renderTask))) {
          unfinished = true;
        }
        chartView.group.silent = !!seriesModel.get("silent");
        updateBlend(seriesModel, chartView);
        updateSeriesElementSelection(seriesModel);
      });
      scheduler2.unfinished = unfinished || scheduler2.unfinished;
      lifecycle$1.trigger("series:layoutlabels", ecModel, api, updateParams);
      lifecycle$1.trigger("series:transition", ecModel, api, updateParams);
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        updateZ2(seriesModel, chartView);
        updateStates(seriesModel, chartView);
      });
      updateHoverLayerStatus(ecIns, ecModel);
      lifecycle$1.trigger("series:afterupdate", ecModel, api, updateParams);
    };
    markStatusToUpdate = function(ecIns) {
      ecIns[STATUS_NEEDS_UPDATE_KEY] = true;
      ecIns.getZr().wakeUp();
    };
    applyChangedStates = function(ecIns) {
      if (!ecIns[STATUS_NEEDS_UPDATE_KEY]) {
        return;
      }
      ecIns.getZr().storage.traverse(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        applyElementStates(el);
      });
      ecIns[STATUS_NEEDS_UPDATE_KEY] = false;
    };
    function applyElementStates(el) {
      var newStates = [];
      var oldStates = el.currentStates;
      for (var i = 0; i < oldStates.length; i++) {
        var stateName = oldStates[i];
        if (!(stateName === "emphasis" || stateName === "blur" || stateName === "select")) {
          newStates.push(stateName);
        }
      }
      if (el.selected && el.states.select) {
        newStates.push("select");
      }
      if (el.hoverState === HOVER_STATE_EMPHASIS && el.states.emphasis) {
        newStates.push("emphasis");
      } else if (el.hoverState === HOVER_STATE_BLUR && el.states.blur) {
        newStates.push("blur");
      }
      el.useStates(newStates);
    }
    function updateHoverLayerStatus(ecIns, ecModel) {
      var zr = ecIns._zr;
      var storage2 = zr.storage;
      var elCount = 0;
      storage2.traverse(function(el) {
        if (!el.isGroup) {
          elCount++;
        }
      });
      if (elCount > ecModel.get("hoverLayerThreshold") && !env$1.node && !env$1.worker) {
        ecModel.eachSeries(function(seriesModel) {
          if (seriesModel.preventUsingHoverLayer) {
            return;
          }
          var chartView = ecIns._chartsMap[seriesModel.__viewId];
          if (chartView.__alive) {
            chartView.eachRendered(function(el) {
              if (el.states.emphasis) {
                el.states.emphasis.hoverLayer = true;
              }
            });
          }
        });
      }
    }
    function updateBlend(seriesModel, chartView) {
      var blendMode = seriesModel.get("blendMode") || null;
      chartView.eachRendered(function(el) {
        if (!el.isGroup) {
          el.style.blend = blendMode;
        }
      });
    }
    function updateZ2(model, view) {
      if (model.preventAutoZ) {
        return;
      }
      var z2 = model.get("z") || 0;
      var zlevel = model.get("zlevel") || 0;
      view.eachRendered(function(el) {
        doUpdateZ(el, z2, zlevel, -Infinity);
        return true;
      });
    }
    function doUpdateZ(el, z2, zlevel, maxZ2) {
      var label = el.getTextContent();
      var labelLine = el.getTextGuideLine();
      var isGroup = el.isGroup;
      if (isGroup) {
        var children = el.childrenRef();
        for (var i = 0; i < children.length; i++) {
          maxZ2 = Math.max(doUpdateZ(children[i], z2, zlevel, maxZ2), maxZ2);
        }
      } else {
        el.z = z2;
        el.zlevel = zlevel;
        maxZ2 = Math.max(el.z2, maxZ2);
      }
      if (label) {
        label.z = z2;
        label.zlevel = zlevel;
        isFinite(maxZ2) && (label.z2 = maxZ2 + 2);
      }
      if (labelLine) {
        var textGuideLineConfig = el.textGuideLineConfig;
        labelLine.z = z2;
        labelLine.zlevel = zlevel;
        isFinite(maxZ2) && (labelLine.z2 = maxZ2 + (textGuideLineConfig && textGuideLineConfig.showAbove ? 1 : -1));
      }
      return maxZ2;
    }
    function clearStates(model, view) {
      view.eachRendered(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        var textContent = el.getTextContent();
        var textGuide = el.getTextGuideLine();
        if (el.stateTransition) {
          el.stateTransition = null;
        }
        if (textContent && textContent.stateTransition) {
          textContent.stateTransition = null;
        }
        if (textGuide && textGuide.stateTransition) {
          textGuide.stateTransition = null;
        }
        if (el.hasState()) {
          el.prevStates = el.currentStates;
          el.clearStates();
        } else if (el.prevStates) {
          el.prevStates = null;
        }
      });
    }
    function updateStates(model, view) {
      var stateAnimationModel = model.getModel("stateAnimation");
      var enableAnimation = model.isAnimationEnabled();
      var duration = stateAnimationModel.get("duration");
      var stateTransition = duration > 0 ? {
        duration,
        delay: stateAnimationModel.get("delay"),
        easing: stateAnimationModel.get("easing")
      } : null;
      view.eachRendered(function(el) {
        if (el.states && el.states.emphasis) {
          if (isElementRemoved(el)) {
            return;
          }
          if (el instanceof Path$1) {
            savePathStates(el);
          }
          if (el.__dirty) {
            var prevStates = el.prevStates;
            if (prevStates) {
              el.useStates(prevStates);
            }
          }
          if (enableAnimation) {
            el.stateTransition = stateTransition;
            var textContent = el.getTextContent();
            var textGuide = el.getTextGuideLine();
            if (textContent) {
              textContent.stateTransition = stateTransition;
            }
            if (textGuide) {
              textGuide.stateTransition = stateTransition;
            }
          }
          if (el.__dirty) {
            applyElementStates(el);
          }
        }
      });
    }
    createExtensionAPI = function(ecIns) {
      return new (function(_super2) {
        __extends(class_1, _super2);
        function class_1() {
          return _super2 !== null && _super2.apply(this, arguments) || this;
        }
        class_1.prototype.getCoordinateSystems = function() {
          return ecIns._coordSysMgr.getCoordinateSystems();
        };
        class_1.prototype.getComponentByElement = function(el) {
          while (el) {
            var modelInfo = el.__ecComponentInfo;
            if (modelInfo != null) {
              return ecIns._model.getComponent(modelInfo.mainType, modelInfo.index);
            }
            el = el.parent;
          }
        };
        class_1.prototype.enterEmphasis = function(el, highlightDigit) {
          enterEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveEmphasis = function(el, highlightDigit) {
          leaveEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterBlur = function(el) {
          enterBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveBlur = function(el) {
          leaveBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterSelect = function(el) {
          enterSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveSelect = function(el) {
          leaveSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.getModel = function() {
          return ecIns.getModel();
        };
        class_1.prototype.getViewOfComponentModel = function(componentModel) {
          return ecIns.getViewOfComponentModel(componentModel);
        };
        class_1.prototype.getViewOfSeriesModel = function(seriesModel) {
          return ecIns.getViewOfSeriesModel(seriesModel);
        };
        return class_1;
      }(ExtensionAPI$1))(ecIns);
    };
    enableConnect = function(chart) {
      function updateConnectedChartsStatus(charts, status) {
        for (var i = 0; i < charts.length; i++) {
          var otherChart = charts[i];
          otherChart[CONNECT_STATUS_KEY] = status;
        }
      }
      each$g(eventActionMap, function(actionType, eventType) {
        chart._messageCenter.on(eventType, function(event) {
          if (connectedGroups[chart.group] && chart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_PENDING) {
            if (event && event.escapeConnect) {
              return;
            }
            var action_1 = chart.makeActionFromEvent(event);
            var otherCharts_1 = [];
            each$g(instances, function(otherChart) {
              if (otherChart !== chart && otherChart.group === chart.group) {
                otherCharts_1.push(otherChart);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_PENDING);
            each$g(otherCharts_1, function(otherChart) {
              if (otherChart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_UPDATING) {
                otherChart.dispatchAction(action_1);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_UPDATED);
          }
        });
      });
    };
  }();
  return ECharts2;
}(Eventful$1);
var echartsProto = ECharts.prototype;
echartsProto.on = createRegisterEventWithLowercaseECharts("on");
echartsProto.off = createRegisterEventWithLowercaseECharts("off");
echartsProto.one = function(eventName, cb2, ctx) {
  var self2 = this;
  function wrapped() {
    var args2 = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args2[_i] = arguments[_i];
    }
    cb2 && cb2.apply && cb2.apply(this, args2);
    self2.off(eventName, wrapped);
  }
  this.on.call(this, eventName, wrapped, ctx);
};
var MOUSE_EVENT_NAMES = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function disposedWarning(id2) {
}
var actions = {};
var eventActionMap = {};
var dataProcessorFuncs = [];
var optionPreprocessorFuncs = [];
var visualFuncs = [];
var themeStorage = {};
var loadingEffects = {};
var instances = {};
var connectedGroups = {};
var idBase = +new Date() - 0;
var DOM_ATTRIBUTE_KEY = "_echarts_instance_";
function init$2(dom, theme2, opts) {
  var isClient = !(opts && opts.ssr);
  if (isClient) {
    var existInstance = getInstanceByDom(dom);
    if (existInstance) {
      return existInstance;
    }
  }
  var chart = new ECharts(dom, theme2, opts);
  chart.id = "ec_" + idBase++;
  instances[chart.id] = chart;
  isClient && setAttribute(dom, DOM_ATTRIBUTE_KEY, chart.id);
  enableConnect(chart);
  lifecycle$1.trigger("afterinit", chart);
  return chart;
}
function getInstanceByDom(dom) {
  return instances[getAttribute(dom, DOM_ATTRIBUTE_KEY)];
}
function registerTheme(name2, theme2) {
  themeStorage[name2] = theme2;
}
function registerPreprocessor(preprocessorFunc) {
  if (indexOf(optionPreprocessorFuncs, preprocessorFunc) < 0) {
    optionPreprocessorFuncs.push(preprocessorFunc);
  }
}
function registerProcessor(priority, processor) {
  normalizeRegister(dataProcessorFuncs, priority, processor, PRIORITY_PROCESSOR_DEFAULT);
}
function registerPostInit(postInitFunc) {
  registerUpdateLifecycle("afterinit", postInitFunc);
}
function registerPostUpdate(postUpdateFunc) {
  registerUpdateLifecycle("afterupdate", postUpdateFunc);
}
function registerUpdateLifecycle(name2, cb2) {
  lifecycle$1.on(name2, cb2);
}
function registerAction(actionInfo2, eventName, action) {
  if (isFunction$1(eventName)) {
    action = eventName;
    eventName = "";
  }
  var actionType = isObject$6(actionInfo2) ? actionInfo2.type : [actionInfo2, actionInfo2 = {
    event: eventName
  }][0];
  actionInfo2.event = (actionInfo2.event || actionType).toLowerCase();
  eventName = actionInfo2.event;
  if (eventActionMap[eventName]) {
    return;
  }
  assert(ACTION_REG.test(actionType) && ACTION_REG.test(eventName));
  if (!actions[actionType]) {
    actions[actionType] = {
      action,
      actionInfo: actionInfo2
    };
  }
  eventActionMap[eventName] = actionType;
}
function registerCoordinateSystem(type4, coordSysCreator) {
  CoordinateSystem.register(type4, coordSysCreator);
}
function registerLayout(priority, layoutTask) {
  normalizeRegister(visualFuncs, priority, layoutTask, PRIORITY_VISUAL_LAYOUT, "layout");
}
function registerVisual(priority, visualTask) {
  normalizeRegister(visualFuncs, priority, visualTask, PRIORITY_VISUAL_CHART, "visual");
}
var registeredTasks = [];
function normalizeRegister(targetList, priority, fn, defaultPriority, visualType) {
  if (isFunction$1(priority) || isObject$6(priority)) {
    fn = priority;
    priority = defaultPriority;
  }
  if (indexOf(registeredTasks, fn) >= 0) {
    return;
  }
  registeredTasks.push(fn);
  var stageHandler = Scheduler$1.wrapStageHandler(fn, visualType);
  stageHandler.__prio = priority;
  stageHandler.__raw = fn;
  targetList.push(stageHandler);
}
function registerLoading(name2, loadingFx) {
  loadingEffects[name2] = loadingFx;
}
function registerMap$1(mapName, geoJson, specialAreas) {
  var registerMap2 = getImpl("registerMap");
  registerMap2 && registerMap2(mapName, geoJson, specialAreas);
}
var registerTransform = registerExternalTransform;
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataColorPaletteTask);
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesSymbolTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataSymbolTask);
registerVisual(PRIORITY_VISUAL_DECAL, decalVisual);
registerPreprocessor(globalBackwardCompat);
registerProcessor(PRIORITY_PROCESSOR_DATASTACK, dataStack);
registerLoading("default", defaultLoading);
registerAction({
  type: HIGHLIGHT_ACTION_TYPE,
  event: HIGHLIGHT_ACTION_TYPE,
  update: HIGHLIGHT_ACTION_TYPE
}, noop$1);
registerAction({
  type: DOWNPLAY_ACTION_TYPE,
  event: DOWNPLAY_ACTION_TYPE,
  update: DOWNPLAY_ACTION_TYPE
}, noop$1);
registerAction({
  type: SELECT_ACTION_TYPE,
  event: SELECT_ACTION_TYPE,
  update: SELECT_ACTION_TYPE
}, noop$1);
registerAction({
  type: UNSELECT_ACTION_TYPE,
  event: UNSELECT_ACTION_TYPE,
  update: UNSELECT_ACTION_TYPE
}, noop$1);
registerAction({
  type: TOGGLE_SELECT_ACTION_TYPE,
  event: TOGGLE_SELECT_ACTION_TYPE,
  update: TOGGLE_SELECT_ACTION_TYPE
}, noop$1);
registerTheme("light", lightTheme);
registerTheme("dark", darkTheme);
var extensions = [];
var extensionRegisters = {
  registerPreprocessor,
  registerProcessor,
  registerPostInit,
  registerPostUpdate,
  registerUpdateLifecycle,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerVisual,
  registerTransform,
  registerLoading,
  registerMap: registerMap$1,
  registerImpl,
  PRIORITY,
  ComponentModel: ComponentModel$1,
  ComponentView: ComponentView$1,
  SeriesModel: SeriesModel$1,
  ChartView: ChartView$1,
  registerComponentModel: function(ComponentModelClass) {
    ComponentModel$1.registerClass(ComponentModelClass);
  },
  registerComponentView: function(ComponentViewClass) {
    ComponentView$1.registerClass(ComponentViewClass);
  },
  registerSeriesModel: function(SeriesModelClass) {
    SeriesModel$1.registerClass(SeriesModelClass);
  },
  registerChartView: function(ChartViewClass) {
    ChartView$1.registerClass(ChartViewClass);
  },
  registerSubTypeDefaulter: function(componentType, defaulter) {
    ComponentModel$1.registerSubTypeDefaulter(componentType, defaulter);
  },
  registerPainter: function(painterType, PainterCtor) {
    registerPainter(painterType, PainterCtor);
  }
};
function use(ext) {
  if (isArray$2(ext)) {
    each$g(ext, function(singleExt) {
      use(singleExt);
    });
    return;
  }
  if (indexOf(extensions, ext) >= 0) {
    return;
  }
  extensions.push(ext);
  if (isFunction$1(ext)) {
    ext = {
      install: ext
    };
  }
  ext.install(extensionRegisters);
}
function dataIndexMapValueLength(valNumOrArrLengthMoreThan2) {
  return valNumOrArrLengthMoreThan2 == null ? 0 : valNumOrArrLengthMoreThan2.length || 1;
}
function defaultKeyGetter(item) {
  return item;
}
var DataDiffer = function() {
  function DataDiffer2(oldArr, newArr, oldKeyGetter, newKeyGetter, context, diffMode) {
    this._old = oldArr;
    this._new = newArr;
    this._oldKeyGetter = oldKeyGetter || defaultKeyGetter;
    this._newKeyGetter = newKeyGetter || defaultKeyGetter;
    this.context = context;
    this._diffModeMultiple = diffMode === "multiple";
  }
  DataDiffer2.prototype.add = function(func) {
    this._add = func;
    return this;
  };
  DataDiffer2.prototype.update = function(func) {
    this._update = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToOne = function(func) {
    this._updateManyToOne = func;
    return this;
  };
  DataDiffer2.prototype.updateOneToMany = function(func) {
    this._updateOneToMany = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToMany = function(func) {
    this._updateManyToMany = func;
    return this;
  };
  DataDiffer2.prototype.remove = function(func) {
    this._remove = func;
    return this;
  };
  DataDiffer2.prototype.execute = function() {
    this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
  };
  DataDiffer2.prototype._executeOneToOne = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var newDataIndexMap = {};
    var oldDataKeyArr = new Array(oldArr.length);
    var newDataKeyArr = new Array(newArr.length);
    this._initIndexMap(oldArr, null, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (newIdxMapValLen > 1) {
        var newIdx = newIdxMapVal.shift();
        if (newIdxMapVal.length === 1) {
          newDataIndexMap[oldKey] = newIdxMapVal[0];
        }
        this._update && this._update(newIdx, i);
      } else if (newIdxMapValLen === 1) {
        newDataIndexMap[oldKey] = null;
        this._update && this._update(newIdxMapVal, i);
      } else {
        this._remove && this._remove(i);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._executeMultiple = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var oldDataIndexMap = {};
    var newDataIndexMap = {};
    var oldDataKeyArr = [];
    var newDataKeyArr = [];
    this._initIndexMap(oldArr, oldDataIndexMap, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldDataKeyArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var oldIdxMapVal = oldDataIndexMap[oldKey];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var oldIdxMapValLen = dataIndexMapValueLength(oldIdxMapVal);
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (oldIdxMapValLen > 1 && newIdxMapValLen === 1) {
        this._updateManyToOne && this._updateManyToOne(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen > 1) {
        this._updateOneToMany && this._updateOneToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen === 1) {
        this._update && this._update(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1 && newIdxMapValLen > 1) {
        this._updateManyToMany && this._updateManyToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1) {
        for (var i_1 = 0; i_1 < oldIdxMapValLen; i_1++) {
          this._remove && this._remove(oldIdxMapVal[i_1]);
        }
      } else {
        this._remove && this._remove(oldIdxMapVal);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._performRestAdd = function(newDataKeyArr, newDataIndexMap) {
    for (var i = 0; i < newDataKeyArr.length; i++) {
      var newKey = newDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[newKey];
      var idxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (idxMapValLen > 1) {
        for (var j = 0; j < idxMapValLen; j++) {
          this._add && this._add(newIdxMapVal[j]);
        }
      } else if (idxMapValLen === 1) {
        this._add && this._add(newIdxMapVal);
      }
      newDataIndexMap[newKey] = null;
    }
  };
  DataDiffer2.prototype._initIndexMap = function(arr, map2, keyArr, keyGetterName) {
    var cbModeMultiple = this._diffModeMultiple;
    for (var i = 0; i < arr.length; i++) {
      var key = "_ec_" + this[keyGetterName](arr[i], i);
      if (!cbModeMultiple) {
        keyArr[i] = key;
      }
      if (!map2) {
        continue;
      }
      var idxMapVal = map2[key];
      var idxMapValLen = dataIndexMapValueLength(idxMapVal);
      if (idxMapValLen === 0) {
        map2[key] = i;
        if (cbModeMultiple) {
          keyArr.push(key);
        }
      } else if (idxMapValLen === 1) {
        map2[key] = [idxMapVal, i];
      } else {
        idxMapVal.push(i);
      }
    }
  };
  return DataDiffer2;
}();
var DataDiffer$1 = DataDiffer;
var DimensionUserOuput = function() {
  function DimensionUserOuput2(encode, dimRequest) {
    this._encode = encode;
    this._schema = dimRequest;
  }
  DimensionUserOuput2.prototype.get = function() {
    return {
      fullDimensions: this._getFullDimensionNames(),
      encode: this._encode
    };
  };
  DimensionUserOuput2.prototype._getFullDimensionNames = function() {
    if (!this._cachedDimNames) {
      this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : [];
    }
    return this._cachedDimNames;
  };
  return DimensionUserOuput2;
}();
function summarizeDimensions(data2, schema) {
  var summary = {};
  var encode = summary.encode = {};
  var notExtraCoordDimMap = createHashMap();
  var defaultedLabel = [];
  var defaultedTooltip = [];
  var userOutputEncode = {};
  each$g(data2.dimensions, function(dimName) {
    var dimItem = data2.getDimensionInfo(dimName);
    var coordDim = dimItem.coordDim;
    if (coordDim) {
      var coordDimIndex = dimItem.coordDimIndex;
      getOrCreateEncodeArr(encode, coordDim)[coordDimIndex] = dimName;
      if (!dimItem.isExtraCoord) {
        notExtraCoordDimMap.set(coordDim, 1);
        if (mayLabelDimType(dimItem.type)) {
          defaultedLabel[0] = dimName;
        }
        getOrCreateEncodeArr(userOutputEncode, coordDim)[coordDimIndex] = data2.getDimensionIndex(dimItem.name);
      }
      if (dimItem.defaultTooltip) {
        defaultedTooltip.push(dimName);
      }
    }
    VISUAL_DIMENSIONS.each(function(v4, otherDim) {
      var encodeArr = getOrCreateEncodeArr(encode, otherDim);
      var dimIndex = dimItem.otherDims[otherDim];
      if (dimIndex != null && dimIndex !== false) {
        encodeArr[dimIndex] = dimItem.name;
      }
    });
  });
  var dataDimsOnCoord = [];
  var encodeFirstDimNotExtra = {};
  notExtraCoordDimMap.each(function(v4, coordDim) {
    var dimArr = encode[coordDim];
    encodeFirstDimNotExtra[coordDim] = dimArr[0];
    dataDimsOnCoord = dataDimsOnCoord.concat(dimArr);
  });
  summary.dataDimsOnCoord = dataDimsOnCoord;
  summary.dataDimIndicesOnCoord = map$1(dataDimsOnCoord, function(dimName) {
    return data2.getDimensionInfo(dimName).storeDimIndex;
  });
  summary.encodeFirstDimNotExtra = encodeFirstDimNotExtra;
  var encodeLabel = encode.label;
  if (encodeLabel && encodeLabel.length) {
    defaultedLabel = encodeLabel.slice();
  }
  var encodeTooltip = encode.tooltip;
  if (encodeTooltip && encodeTooltip.length) {
    defaultedTooltip = encodeTooltip.slice();
  } else if (!defaultedTooltip.length) {
    defaultedTooltip = defaultedLabel.slice();
  }
  encode.defaultedLabel = defaultedLabel;
  encode.defaultedTooltip = defaultedTooltip;
  summary.userOutput = new DimensionUserOuput(userOutputEncode, schema);
  return summary;
}
function getOrCreateEncodeArr(encode, dim) {
  if (!encode.hasOwnProperty(dim)) {
    encode[dim] = [];
  }
  return encode[dim];
}
function getDimensionTypeByAxis(axisType) {
  return axisType === "category" ? "ordinal" : axisType === "time" ? "time" : "float";
}
function mayLabelDimType(dimType) {
  return !(dimType === "ordinal" || dimType === "time");
}
var SeriesDimensionDefine = function() {
  function SeriesDimensionDefine2(opt) {
    this.otherDims = {};
    if (opt != null) {
      extend(this, opt);
    }
  }
  return SeriesDimensionDefine2;
}();
var SeriesDimensionDefine$1 = SeriesDimensionDefine;
var inner$h = makeInner();
var dimTypeShort = {
  float: "f",
  int: "i",
  ordinal: "o",
  number: "n",
  time: "t"
};
var SeriesDataSchema = function() {
  function SeriesDataSchema2(opt) {
    this.dimensions = opt.dimensions;
    this._dimOmitted = opt.dimensionOmitted;
    this.source = opt.source;
    this._fullDimCount = opt.fullDimensionCount;
    this._updateDimOmitted(opt.dimensionOmitted);
  }
  SeriesDataSchema2.prototype.isDimensionOmitted = function() {
    return this._dimOmitted;
  };
  SeriesDataSchema2.prototype._updateDimOmitted = function(dimensionOmitted) {
    this._dimOmitted = dimensionOmitted;
    if (!dimensionOmitted) {
      return;
    }
    if (!this._dimNameMap) {
      this._dimNameMap = ensureSourceDimNameMap(this.source);
    }
  };
  SeriesDataSchema2.prototype.getSourceDimensionIndex = function(dimName) {
    return retrieve2(this._dimNameMap.get(dimName), -1);
  };
  SeriesDataSchema2.prototype.getSourceDimension = function(dimIndex) {
    var dimensionsDefine = this.source.dimensionsDefine;
    if (dimensionsDefine) {
      return dimensionsDefine[dimIndex];
    }
  };
  SeriesDataSchema2.prototype.makeStoreSchema = function() {
    var dimCount = this._fullDimCount;
    var willRetrieveDataByName = shouldRetrieveDataByName(this.source);
    var makeHashStrict = !shouldOmitUnusedDimensions(dimCount);
    var dimHash = "";
    var dims = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < dimCount; fullDimIdx++) {
      var property = void 0;
      var type4 = void 0;
      var ordinalMeta = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        property = willRetrieveDataByName ? seriesDimDef.name : null;
        type4 = seriesDimDef.type;
        ordinalMeta = seriesDimDef.ordinalMeta;
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          property = willRetrieveDataByName ? sourceDimDef.name : null;
          type4 = sourceDimDef.type;
        }
      }
      dims.push({
        property,
        type: type4,
        ordinalMeta
      });
      if (willRetrieveDataByName && property != null && (!seriesDimDef || !seriesDimDef.isCalculationCoord)) {
        dimHash += makeHashStrict ? property.replace(/\`/g, "`1").replace(/\$/g, "`2") : property;
      }
      dimHash += "$";
      dimHash += dimTypeShort[type4] || "f";
      if (ordinalMeta) {
        dimHash += ordinalMeta.uid;
      }
      dimHash += "$";
    }
    var source = this.source;
    var hash = [source.seriesLayoutBy, source.startIndex, dimHash].join("$$");
    return {
      dimensions: dims,
      hash
    };
  };
  SeriesDataSchema2.prototype.makeOutputDimensionNames = function() {
    var result = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < this._fullDimCount; fullDimIdx++) {
      var name_1 = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        if (!seriesDimDef.isCalculationCoord) {
          name_1 = seriesDimDef.name;
        }
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          name_1 = sourceDimDef.name;
        }
      }
      result.push(name_1);
    }
    return result;
  };
  SeriesDataSchema2.prototype.appendCalculationDimension = function(dimDef) {
    this.dimensions.push(dimDef);
    dimDef.isCalculationCoord = true;
    this._fullDimCount++;
    this._updateDimOmitted(true);
  };
  return SeriesDataSchema2;
}();
function isSeriesDataSchema(schema) {
  return schema instanceof SeriesDataSchema;
}
function createDimNameMap(dimsDef) {
  var dataDimNameMap = createHashMap();
  for (var i = 0; i < (dimsDef || []).length; i++) {
    var dimDefItemRaw = dimsDef[i];
    var userDimName = isObject$6(dimDefItemRaw) ? dimDefItemRaw.name : dimDefItemRaw;
    if (userDimName != null && dataDimNameMap.get(userDimName) == null) {
      dataDimNameMap.set(userDimName, i);
    }
  }
  return dataDimNameMap;
}
function ensureSourceDimNameMap(source) {
  var innerSource = inner$h(source);
  return innerSource.dimNameMap || (innerSource.dimNameMap = createDimNameMap(source.dimensionsDefine));
}
function shouldOmitUnusedDimensions(dimCount) {
  return dimCount > 30;
}
var isObject$4 = isObject$6;
var map = map$1;
var CtorInt32Array = typeof Int32Array === "undefined" ? Array : Int32Array;
var ID_PREFIX = "e\0\0";
var INDEX_NOT_FOUND = -1;
var TRANSFERABLE_PROPERTIES = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"];
var CLONE_PROPERTIES = ["_approximateExtent"];
var prepareInvertedIndex;
var getId;
var getIdNameFromStore;
var normalizeDimensions;
var transferProperties;
var cloneListForMapAndSample;
var makeIdFromName;
var SeriesData = function() {
  function SeriesData2(dimensionsInput, hostModel) {
    this.type = "list";
    this._dimOmitted = false;
    this._nameList = [];
    this._idList = [];
    this._visual = {};
    this._layout = {};
    this._itemVisuals = [];
    this._itemLayouts = [];
    this._graphicEls = [];
    this._approximateExtent = {};
    this._calculationInfo = {};
    this.hasItemOption = false;
    this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"];
    this.CHANGABLE_METHODS = ["filterSelf", "selectRange"];
    this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
    var dimensions;
    var assignStoreDimIdx = false;
    if (isSeriesDataSchema(dimensionsInput)) {
      dimensions = dimensionsInput.dimensions;
      this._dimOmitted = dimensionsInput.isDimensionOmitted();
      this._schema = dimensionsInput;
    } else {
      assignStoreDimIdx = true;
      dimensions = dimensionsInput;
    }
    dimensions = dimensions || ["x", "y"];
    var dimensionInfos = {};
    var dimensionNames = [];
    var invertedIndicesMap = {};
    var needsHasOwn = false;
    var emptyObj = {};
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfoInput = dimensions[i];
      var dimensionInfo = isString$1(dimInfoInput) ? new SeriesDimensionDefine$1({
        name: dimInfoInput
      }) : !(dimInfoInput instanceof SeriesDimensionDefine$1) ? new SeriesDimensionDefine$1(dimInfoInput) : dimInfoInput;
      var dimensionName = dimensionInfo.name;
      dimensionInfo.type = dimensionInfo.type || "float";
      if (!dimensionInfo.coordDim) {
        dimensionInfo.coordDim = dimensionName;
        dimensionInfo.coordDimIndex = 0;
      }
      var otherDims = dimensionInfo.otherDims = dimensionInfo.otherDims || {};
      dimensionNames.push(dimensionName);
      dimensionInfos[dimensionName] = dimensionInfo;
      if (emptyObj[dimensionName] != null) {
        needsHasOwn = true;
      }
      if (dimensionInfo.createInvertedIndices) {
        invertedIndicesMap[dimensionName] = [];
      }
      if (otherDims.itemName === 0) {
        this._nameDimIdx = i;
      }
      if (otherDims.itemId === 0) {
        this._idDimIdx = i;
      }
      if (assignStoreDimIdx) {
        dimensionInfo.storeDimIndex = i;
      }
    }
    this.dimensions = dimensionNames;
    this._dimInfos = dimensionInfos;
    this._initGetDimensionInfo(needsHasOwn);
    this.hostModel = hostModel;
    this._invertedIndicesMap = invertedIndicesMap;
    if (this._dimOmitted) {
      var dimIdxToName_1 = this._dimIdxToName = createHashMap();
      each$g(dimensionNames, function(dimName) {
        dimIdxToName_1.set(dimensionInfos[dimName].storeDimIndex, dimName);
      });
    }
  }
  SeriesData2.prototype.getDimension = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx == null) {
      return dim;
    }
    dimIdx = dim;
    if (!this._dimOmitted) {
      return this.dimensions[dimIdx];
    }
    var dimName = this._dimIdxToName.get(dimIdx);
    if (dimName != null) {
      return dimName;
    }
    var sourceDimDef = this._schema.getSourceDimension(dimIdx);
    if (sourceDimDef) {
      return sourceDimDef.name;
    }
  };
  SeriesData2.prototype.getDimensionIndex = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx != null) {
      return dimIdx;
    }
    if (dim == null) {
      return -1;
    }
    var dimInfo = this._getDimInfo(dim);
    return dimInfo ? dimInfo.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(dim) : -1;
  };
  SeriesData2.prototype._recognizeDimIndex = function(dim) {
    if (isNumber(dim) || dim != null && !isNaN(dim) && !this._getDimInfo(dim) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(dim) < 0)) {
      return +dim;
    }
  };
  SeriesData2.prototype._getStoreDimIndex = function(dim) {
    var dimIdx = this.getDimensionIndex(dim);
    return dimIdx;
  };
  SeriesData2.prototype.getDimensionInfo = function(dim) {
    return this._getDimInfo(this.getDimension(dim));
  };
  SeriesData2.prototype._initGetDimensionInfo = function(needsHasOwn) {
    var dimensionInfos = this._dimInfos;
    this._getDimInfo = needsHasOwn ? function(dimName) {
      return dimensionInfos.hasOwnProperty(dimName) ? dimensionInfos[dimName] : void 0;
    } : function(dimName) {
      return dimensionInfos[dimName];
    };
  };
  SeriesData2.prototype.getDimensionsOnCoord = function() {
    return this._dimSummary.dataDimsOnCoord.slice();
  };
  SeriesData2.prototype.mapDimension = function(coordDim, idx) {
    var dimensionsSummary = this._dimSummary;
    if (idx == null) {
      return dimensionsSummary.encodeFirstDimNotExtra[coordDim];
    }
    var dims = dimensionsSummary.encode[coordDim];
    return dims ? dims[idx] : null;
  };
  SeriesData2.prototype.mapDimensionsAll = function(coordDim) {
    var dimensionsSummary = this._dimSummary;
    var dims = dimensionsSummary.encode[coordDim];
    return (dims || []).slice();
  };
  SeriesData2.prototype.getStore = function() {
    return this._store;
  };
  SeriesData2.prototype.initData = function(data2, nameList, dimValueGetter) {
    var _this = this;
    var store;
    if (data2 instanceof DataStore) {
      store = data2;
    }
    if (!store) {
      var dimensions = this.dimensions;
      var provider = isSourceInstance(data2) || isArrayLike(data2) ? new DefaultDataProvider(data2, dimensions.length) : data2;
      store = new DataStore();
      var dimensionInfos = map(dimensions, function(dimName) {
        return {
          type: _this._dimInfos[dimName].type,
          property: dimName
        };
      });
      store.initData(provider, dimensionInfos, dimValueGetter);
    }
    this._store = store;
    this._nameList = (nameList || []).slice();
    this._idList = [];
    this._nameRepeatCount = {};
    this._doInit(0, store.count());
    this._dimSummary = summarizeDimensions(this, this._schema);
    this.userOutput = this._dimSummary.userOutput;
  };
  SeriesData2.prototype.appendData = function(data2) {
    var range3 = this._store.appendData(data2);
    this._doInit(range3[0], range3[1]);
  };
  SeriesData2.prototype.appendValues = function(values, names2) {
    var _a2 = this._store.appendValues(values, names2.length), start2 = _a2.start, end2 = _a2.end;
    var shouldMakeIdFromName = this._shouldMakeIdFromName();
    this._updateOrdinalMeta();
    if (names2) {
      for (var idx = start2; idx < end2; idx++) {
        var sourceIdx = idx - start2;
        this._nameList[idx] = names2[sourceIdx];
        if (shouldMakeIdFromName) {
          makeIdFromName(this, idx);
        }
      }
    }
  };
  SeriesData2.prototype._updateOrdinalMeta = function() {
    var store = this._store;
    var dimensions = this.dimensions;
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfo = this._dimInfos[dimensions[i]];
      if (dimInfo.ordinalMeta) {
        store.collectOrdinalMeta(dimInfo.storeDimIndex, dimInfo.ordinalMeta);
      }
    }
  };
  SeriesData2.prototype._shouldMakeIdFromName = function() {
    var provider = this._store.getProvider();
    return this._idDimIdx == null && provider.getSource().sourceFormat !== SOURCE_FORMAT_TYPED_ARRAY && !provider.fillStorage;
  };
  SeriesData2.prototype._doInit = function(start2, end2) {
    if (start2 >= end2) {
      return;
    }
    var store = this._store;
    var provider = store.getProvider();
    this._updateOrdinalMeta();
    var nameList = this._nameList;
    var idList = this._idList;
    var sourceFormat = provider.getSource().sourceFormat;
    var isFormatOriginal = sourceFormat === SOURCE_FORMAT_ORIGINAL;
    if (isFormatOriginal && !provider.pure) {
      var sharedDataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        var dataItem = provider.getItem(idx, sharedDataItem);
        if (!this.hasItemOption && isDataItemOption(dataItem)) {
          this.hasItemOption = true;
        }
        if (dataItem) {
          var itemName = dataItem.name;
          if (nameList[idx] == null && itemName != null) {
            nameList[idx] = convertOptionIdName(itemName, null);
          }
          var itemId = dataItem.id;
          if (idList[idx] == null && itemId != null) {
            idList[idx] = convertOptionIdName(itemId, null);
          }
        }
      }
    }
    if (this._shouldMakeIdFromName()) {
      for (var idx = start2; idx < end2; idx++) {
        makeIdFromName(this, idx);
      }
    }
    prepareInvertedIndex(this);
  };
  SeriesData2.prototype.getApproximateExtent = function(dim) {
    return this._approximateExtent[dim] || this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.setApproximateExtent = function(extent3, dim) {
    dim = this.getDimension(dim);
    this._approximateExtent[dim] = extent3.slice();
  };
  SeriesData2.prototype.getCalculationInfo = function(key) {
    return this._calculationInfo[key];
  };
  SeriesData2.prototype.setCalculationInfo = function(key, value) {
    isObject$4(key) ? extend(this._calculationInfo, key) : this._calculationInfo[key] = value;
  };
  SeriesData2.prototype.getName = function(idx) {
    var rawIndex = this.getRawIndex(idx);
    var name2 = this._nameList[rawIndex];
    if (name2 == null && this._nameDimIdx != null) {
      name2 = getIdNameFromStore(this, this._nameDimIdx, rawIndex);
    }
    if (name2 == null) {
      name2 = "";
    }
    return name2;
  };
  SeriesData2.prototype._getCategory = function(dimIdx, idx) {
    var ordinal = this._store.get(dimIdx, idx);
    var ordinalMeta = this._store.getOrdinalMeta(dimIdx);
    if (ordinalMeta) {
      return ordinalMeta.categories[ordinal];
    }
    return ordinal;
  };
  SeriesData2.prototype.getId = function(idx) {
    return getId(this, this.getRawIndex(idx));
  };
  SeriesData2.prototype.count = function() {
    return this._store.count();
  };
  SeriesData2.prototype.get = function(dim, idx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.get(dimInfo.storeDimIndex, idx);
    }
  };
  SeriesData2.prototype.getByRawIndex = function(dim, rawIdx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.getByRawIndex(dimInfo.storeDimIndex, rawIdx);
    }
  };
  SeriesData2.prototype.getIndices = function() {
    return this._store.getIndices();
  };
  SeriesData2.prototype.getDataExtent = function(dim) {
    return this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getSum = function(dim) {
    return this._store.getSum(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getMedian = function(dim) {
    return this._store.getMedian(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getValues = function(dimensions, idx) {
    var _this = this;
    var store = this._store;
    return isArray$2(dimensions) ? store.getValues(map(dimensions, function(dim) {
      return _this._getStoreDimIndex(dim);
    }), idx) : store.getValues(dimensions);
  };
  SeriesData2.prototype.hasValue = function(idx) {
    var dataDimIndicesOnCoord = this._dimSummary.dataDimIndicesOnCoord;
    for (var i = 0, len2 = dataDimIndicesOnCoord.length; i < len2; i++) {
      if (isNaN(this._store.get(dataDimIndicesOnCoord[i], idx))) {
        return false;
      }
    }
    return true;
  };
  SeriesData2.prototype.indexOfName = function(name2) {
    for (var i = 0, len2 = this._store.count(); i < len2; i++) {
      if (this.getName(i) === name2) {
        return i;
      }
    }
    return -1;
  };
  SeriesData2.prototype.getRawIndex = function(idx) {
    return this._store.getRawIndex(idx);
  };
  SeriesData2.prototype.indexOfRawIndex = function(rawIndex) {
    return this._store.indexOfRawIndex(rawIndex);
  };
  SeriesData2.prototype.rawIndexOf = function(dim, value) {
    var invertedIndices = dim && this._invertedIndicesMap[dim];
    var rawIndex = invertedIndices[value];
    if (rawIndex == null || isNaN(rawIndex)) {
      return INDEX_NOT_FOUND;
    }
    return rawIndex;
  };
  SeriesData2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    return this._store.indicesOfNearest(this._getStoreDimIndex(dim), value, maxDistance);
  };
  SeriesData2.prototype.each = function(dims, cb2, ctx) {
    if (isFunction$1(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.each(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
  };
  SeriesData2.prototype.filterSelf = function(dims, cb2, ctx) {
    if (isFunction$1(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store = this._store.filter(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
    return this;
  };
  SeriesData2.prototype.selectRange = function(range3) {
    var _this = this;
    var innerRange = {};
    var dims = keys(range3);
    each$g(dims, function(dim) {
      var dimIdx = _this._getStoreDimIndex(dim);
      innerRange[dimIdx] = range3[dim];
    });
    this._store = this._store.selectRange(innerRange);
    return this;
  };
  SeriesData2.prototype.mapArray = function(dims, cb2, ctx) {
    if (isFunction$1(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    ctx = ctx || this;
    var result = [];
    this.each(dims, function() {
      result.push(cb2 && cb2.apply(this, arguments));
    }, ctx);
    return result;
  };
  SeriesData2.prototype.map = function(dims, cb2, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    var list = cloneListForMapAndSample(this);
    list._store = this._store.map(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
    return list;
  };
  SeriesData2.prototype.modify = function(dims, cb2, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.modify(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
  };
  SeriesData2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.downSample(this._getStoreDimIndex(dimension), rate, sampleValue, sampleIndex);
    return list;
  };
  SeriesData2.prototype.lttbDownSample = function(valueDimension, rate) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.lttbDownSample(this._getStoreDimIndex(valueDimension), rate);
    return list;
  };
  SeriesData2.prototype.getRawDataItem = function(idx) {
    return this._store.getRawDataItem(idx);
  };
  SeriesData2.prototype.getItemModel = function(idx) {
    var hostModel = this.hostModel;
    var dataItem = this.getRawDataItem(idx);
    return new Model$1(dataItem, hostModel, hostModel && hostModel.ecModel);
  };
  SeriesData2.prototype.diff = function(otherList) {
    var thisList = this;
    return new DataDiffer$1(otherList ? otherList.getStore().getIndices() : [], this.getStore().getIndices(), function(idx) {
      return getId(otherList, idx);
    }, function(idx) {
      return getId(thisList, idx);
    });
  };
  SeriesData2.prototype.getVisual = function(key) {
    var visual = this._visual;
    return visual && visual[key];
  };
  SeriesData2.prototype.setVisual = function(kvObj, val) {
    this._visual = this._visual || {};
    if (isObject$4(kvObj)) {
      extend(this._visual, kvObj);
    } else {
      this._visual[kvObj] = val;
    }
  };
  SeriesData2.prototype.getItemVisual = function(idx, key) {
    var itemVisual = this._itemVisuals[idx];
    var val = itemVisual && itemVisual[key];
    if (val == null) {
      return this.getVisual(key);
    }
    return val;
  };
  SeriesData2.prototype.hasItemVisual = function() {
    return this._itemVisuals.length > 0;
  };
  SeriesData2.prototype.ensureUniqueItemVisual = function(idx, key) {
    var itemVisuals = this._itemVisuals;
    var itemVisual = itemVisuals[idx];
    if (!itemVisual) {
      itemVisual = itemVisuals[idx] = {};
    }
    var val = itemVisual[key];
    if (val == null) {
      val = this.getVisual(key);
      if (isArray$2(val)) {
        val = val.slice();
      } else if (isObject$4(val)) {
        val = extend({}, val);
      }
      itemVisual[key] = val;
    }
    return val;
  };
  SeriesData2.prototype.setItemVisual = function(idx, key, value) {
    var itemVisual = this._itemVisuals[idx] || {};
    this._itemVisuals[idx] = itemVisual;
    if (isObject$4(key)) {
      extend(itemVisual, key);
    } else {
      itemVisual[key] = value;
    }
  };
  SeriesData2.prototype.clearAllVisual = function() {
    this._visual = {};
    this._itemVisuals = [];
  };
  SeriesData2.prototype.setLayout = function(key, val) {
    isObject$4(key) ? extend(this._layout, key) : this._layout[key] = val;
  };
  SeriesData2.prototype.getLayout = function(key) {
    return this._layout[key];
  };
  SeriesData2.prototype.getItemLayout = function(idx) {
    return this._itemLayouts[idx];
  };
  SeriesData2.prototype.setItemLayout = function(idx, layout2, merge3) {
    this._itemLayouts[idx] = merge3 ? extend(this._itemLayouts[idx] || {}, layout2) : layout2;
  };
  SeriesData2.prototype.clearItemLayouts = function() {
    this._itemLayouts.length = 0;
  };
  SeriesData2.prototype.setItemGraphicEl = function(idx, el) {
    var seriesIndex = this.hostModel && this.hostModel.seriesIndex;
    setCommonECData(seriesIndex, this.dataType, idx, el);
    this._graphicEls[idx] = el;
  };
  SeriesData2.prototype.getItemGraphicEl = function(idx) {
    return this._graphicEls[idx];
  };
  SeriesData2.prototype.eachItemGraphicEl = function(cb2, context) {
    each$g(this._graphicEls, function(el, idx) {
      if (el) {
        cb2 && cb2.call(context, el, idx);
      }
    });
  };
  SeriesData2.prototype.cloneShallow = function(list) {
    if (!list) {
      list = new SeriesData2(this._schema ? this._schema : map(this.dimensions, this._getDimInfo, this), this.hostModel);
    }
    transferProperties(list, this);
    list._store = this._store;
    return list;
  };
  SeriesData2.prototype.wrapMethod = function(methodName, injectFunction) {
    var originalMethod = this[methodName];
    if (!isFunction$1(originalMethod)) {
      return;
    }
    this.__wrappedMethods = this.__wrappedMethods || [];
    this.__wrappedMethods.push(methodName);
    this[methodName] = function() {
      var res2 = originalMethod.apply(this, arguments);
      return injectFunction.apply(this, [res2].concat(slice(arguments)));
    };
  };
  SeriesData2.internalField = function() {
    prepareInvertedIndex = function(data2) {
      var invertedIndicesMap = data2._invertedIndicesMap;
      each$g(invertedIndicesMap, function(invertedIndices, dim) {
        var dimInfo = data2._dimInfos[dim];
        var ordinalMeta = dimInfo.ordinalMeta;
        var store = data2._store;
        if (ordinalMeta) {
          invertedIndices = invertedIndicesMap[dim] = new CtorInt32Array(ordinalMeta.categories.length);
          for (var i = 0; i < invertedIndices.length; i++) {
            invertedIndices[i] = INDEX_NOT_FOUND;
          }
          for (var i = 0; i < store.count(); i++) {
            invertedIndices[store.get(dimInfo.storeDimIndex, i)] = i;
          }
        }
      });
    };
    getIdNameFromStore = function(data2, dimIdx, idx) {
      return convertOptionIdName(data2._getCategory(dimIdx, idx), null);
    };
    getId = function(data2, rawIndex) {
      var id2 = data2._idList[rawIndex];
      if (id2 == null && data2._idDimIdx != null) {
        id2 = getIdNameFromStore(data2, data2._idDimIdx, rawIndex);
      }
      if (id2 == null) {
        id2 = ID_PREFIX + rawIndex;
      }
      return id2;
    };
    normalizeDimensions = function(dimensions) {
      if (!isArray$2(dimensions)) {
        dimensions = dimensions != null ? [dimensions] : [];
      }
      return dimensions;
    };
    cloneListForMapAndSample = function(original) {
      var list = new SeriesData2(original._schema ? original._schema : map(original.dimensions, original._getDimInfo, original), original.hostModel);
      transferProperties(list, original);
      return list;
    };
    transferProperties = function(target, source) {
      each$g(TRANSFERABLE_PROPERTIES.concat(source.__wrappedMethods || []), function(propName) {
        if (source.hasOwnProperty(propName)) {
          target[propName] = source[propName];
        }
      });
      target.__wrappedMethods = source.__wrappedMethods;
      each$g(CLONE_PROPERTIES, function(propName) {
        target[propName] = clone$4(source[propName]);
      });
      target._calculationInfo = extend({}, source._calculationInfo);
    };
    makeIdFromName = function(data2, idx) {
      var nameList = data2._nameList;
      var idList = data2._idList;
      var nameDimIdx = data2._nameDimIdx;
      var idDimIdx = data2._idDimIdx;
      var name2 = nameList[idx];
      var id2 = idList[idx];
      if (name2 == null && nameDimIdx != null) {
        nameList[idx] = name2 = getIdNameFromStore(data2, nameDimIdx, idx);
      }
      if (id2 == null && idDimIdx != null) {
        idList[idx] = id2 = getIdNameFromStore(data2, idDimIdx, idx);
      }
      if (id2 == null && name2 != null) {
        var nameRepeatCount = data2._nameRepeatCount;
        var nmCnt = nameRepeatCount[name2] = (nameRepeatCount[name2] || 0) + 1;
        id2 = name2;
        if (nmCnt > 1) {
          id2 += "__ec__" + nmCnt;
        }
        idList[idx] = id2;
      }
    };
  }();
  return SeriesData2;
}();
var SeriesData$1 = SeriesData;
function prepareSeriesDataSchema(source, opt) {
  if (!isSourceInstance(source)) {
    source = createSourceFromSeriesDataOption(source);
  }
  opt = opt || {};
  var sysDims = opt.coordDimensions || [];
  var dimsDef = opt.dimensionsDefine || source.dimensionsDefine || [];
  var coordDimNameMap = createHashMap();
  var resultList = [];
  var dimCount = getDimCount(source, sysDims, dimsDef, opt.dimensionsCount);
  var omitUnusedDimensions = opt.canOmitUnusedDimensions && shouldOmitUnusedDimensions(dimCount);
  var isUsingSourceDimensionsDef = dimsDef === source.dimensionsDefine;
  var dataDimNameMap = isUsingSourceDimensionsDef ? ensureSourceDimNameMap(source) : createDimNameMap(dimsDef);
  var encodeDef = opt.encodeDefine;
  if (!encodeDef && opt.encodeDefaulter) {
    encodeDef = opt.encodeDefaulter(source, dimCount);
  }
  var encodeDefMap = createHashMap(encodeDef);
  var indicesMap = new CtorInt32Array$1(dimCount);
  for (var i = 0; i < indicesMap.length; i++) {
    indicesMap[i] = -1;
  }
  function getResultItem(dimIdx) {
    var idx = indicesMap[dimIdx];
    if (idx < 0) {
      var dimDefItemRaw = dimsDef[dimIdx];
      var dimDefItem = isObject$6(dimDefItemRaw) ? dimDefItemRaw : {
        name: dimDefItemRaw
      };
      var resultItem2 = new SeriesDimensionDefine$1();
      var userDimName = dimDefItem.name;
      if (userDimName != null && dataDimNameMap.get(userDimName) != null) {
        resultItem2.name = resultItem2.displayName = userDimName;
      }
      dimDefItem.type != null && (resultItem2.type = dimDefItem.type);
      dimDefItem.displayName != null && (resultItem2.displayName = dimDefItem.displayName);
      var newIdx = resultList.length;
      indicesMap[dimIdx] = newIdx;
      resultItem2.storeDimIndex = dimIdx;
      resultList.push(resultItem2);
      return resultItem2;
    }
    return resultList[idx];
  }
  if (!omitUnusedDimensions) {
    for (var i = 0; i < dimCount; i++) {
      getResultItem(i);
    }
  }
  encodeDefMap.each(function(dataDimsRaw, coordDim2) {
    var dataDims = normalizeToArray(dataDimsRaw).slice();
    if (dataDims.length === 1 && !isString$1(dataDims[0]) && dataDims[0] < 0) {
      encodeDefMap.set(coordDim2, false);
      return;
    }
    var validDataDims = encodeDefMap.set(coordDim2, []);
    each$g(dataDims, function(resultDimIdxOrName, idx) {
      var resultDimIdx2 = isString$1(resultDimIdxOrName) ? dataDimNameMap.get(resultDimIdxOrName) : resultDimIdxOrName;
      if (resultDimIdx2 != null && resultDimIdx2 < dimCount) {
        validDataDims[idx] = resultDimIdx2;
        applyDim(getResultItem(resultDimIdx2), coordDim2, idx);
      }
    });
  });
  var availDimIdx = 0;
  each$g(sysDims, function(sysDimItemRaw) {
    var coordDim2;
    var sysDimItemDimsDef;
    var sysDimItemOtherDims;
    var sysDimItem;
    if (isString$1(sysDimItemRaw)) {
      coordDim2 = sysDimItemRaw;
      sysDimItem = {};
    } else {
      sysDimItem = sysDimItemRaw;
      coordDim2 = sysDimItem.name;
      var ordinalMeta = sysDimItem.ordinalMeta;
      sysDimItem.ordinalMeta = null;
      sysDimItem = extend({}, sysDimItem);
      sysDimItem.ordinalMeta = ordinalMeta;
      sysDimItemDimsDef = sysDimItem.dimsDef;
      sysDimItemOtherDims = sysDimItem.otherDims;
      sysDimItem.name = sysDimItem.coordDim = sysDimItem.coordDimIndex = sysDimItem.dimsDef = sysDimItem.otherDims = null;
    }
    var dataDims = encodeDefMap.get(coordDim2);
    if (dataDims === false) {
      return;
    }
    dataDims = normalizeToArray(dataDims);
    if (!dataDims.length) {
      for (var i2 = 0; i2 < (sysDimItemDimsDef && sysDimItemDimsDef.length || 1); i2++) {
        while (availDimIdx < dimCount && getResultItem(availDimIdx).coordDim != null) {
          availDimIdx++;
        }
        availDimIdx < dimCount && dataDims.push(availDimIdx++);
      }
    }
    each$g(dataDims, function(resultDimIdx2, coordDimIndex) {
      var resultItem2 = getResultItem(resultDimIdx2);
      if (isUsingSourceDimensionsDef && sysDimItem.type != null) {
        resultItem2.type = sysDimItem.type;
      }
      applyDim(defaults(resultItem2, sysDimItem), coordDim2, coordDimIndex);
      if (resultItem2.name == null && sysDimItemDimsDef) {
        var sysDimItemDimsDefItem = sysDimItemDimsDef[coordDimIndex];
        !isObject$6(sysDimItemDimsDefItem) && (sysDimItemDimsDefItem = {
          name: sysDimItemDimsDefItem
        });
        resultItem2.name = resultItem2.displayName = sysDimItemDimsDefItem.name;
        resultItem2.defaultTooltip = sysDimItemDimsDefItem.defaultTooltip;
      }
      sysDimItemOtherDims && defaults(resultItem2.otherDims, sysDimItemOtherDims);
    });
  });
  function applyDim(resultItem2, coordDim2, coordDimIndex) {
    if (VISUAL_DIMENSIONS.get(coordDim2) != null) {
      resultItem2.otherDims[coordDim2] = coordDimIndex;
    } else {
      resultItem2.coordDim = coordDim2;
      resultItem2.coordDimIndex = coordDimIndex;
      coordDimNameMap.set(coordDim2, true);
    }
  }
  var generateCoord = opt.generateCoord;
  var generateCoordCount = opt.generateCoordCount;
  var fromZero = generateCoordCount != null;
  generateCoordCount = generateCoord ? generateCoordCount || 1 : 0;
  var extra = generateCoord || "value";
  function ifNoNameFillWithCoordName(resultItem2) {
    if (resultItem2.name == null) {
      resultItem2.name = resultItem2.coordDim;
    }
  }
  if (!omitUnusedDimensions) {
    for (var resultDimIdx = 0; resultDimIdx < dimCount; resultDimIdx++) {
      var resultItem = getResultItem(resultDimIdx);
      var coordDim = resultItem.coordDim;
      if (coordDim == null) {
        resultItem.coordDim = genCoordDimName(extra, coordDimNameMap, fromZero);
        resultItem.coordDimIndex = 0;
        if (!generateCoord || generateCoordCount <= 0) {
          resultItem.isExtraCoord = true;
        }
        generateCoordCount--;
      }
      ifNoNameFillWithCoordName(resultItem);
      if (resultItem.type == null && (guessOrdinal(source, resultDimIdx) === BE_ORDINAL.Must || resultItem.isExtraCoord && (resultItem.otherDims.itemName != null || resultItem.otherDims.seriesName != null))) {
        resultItem.type = "ordinal";
      }
    }
  } else {
    each$g(resultList, function(resultItem2) {
      ifNoNameFillWithCoordName(resultItem2);
    });
    resultList.sort(function(item0, item1) {
      return item0.storeDimIndex - item1.storeDimIndex;
    });
  }
  removeDuplication(resultList);
  return new SeriesDataSchema({
    source,
    dimensions: resultList,
    fullDimensionCount: dimCount,
    dimensionOmitted: omitUnusedDimensions
  });
}
function removeDuplication(result) {
  var duplicationMap = createHashMap();
  for (var i = 0; i < result.length; i++) {
    var dim = result[i];
    var dimOriginalName = dim.name;
    var count2 = duplicationMap.get(dimOriginalName) || 0;
    if (count2 > 0) {
      dim.name = dimOriginalName + (count2 - 1);
    }
    count2++;
    duplicationMap.set(dimOriginalName, count2);
  }
}
function getDimCount(source, sysDims, dimsDef, optDimCount) {
  var dimCount = Math.max(source.dimensionsDetectedCount || 1, sysDims.length, dimsDef.length, optDimCount || 0);
  each$g(sysDims, function(sysDimItem) {
    var sysDimItemDimsDef;
    if (isObject$6(sysDimItem) && (sysDimItemDimsDef = sysDimItem.dimsDef)) {
      dimCount = Math.max(dimCount, sysDimItemDimsDef.length);
    }
  });
  return dimCount;
}
function genCoordDimName(name2, map2, fromZero) {
  var mapData = map2.data;
  if (fromZero || mapData.hasOwnProperty(name2)) {
    var i = 0;
    while (mapData.hasOwnProperty(name2 + i)) {
      i++;
    }
    name2 += i;
  }
  map2.set(name2, true);
  return name2;
}
var CoordSysInfo = function() {
  function CoordSysInfo2(coordSysName) {
    this.coordSysDims = [];
    this.axisMap = createHashMap();
    this.categoryAxisMap = createHashMap();
    this.coordSysName = coordSysName;
  }
  return CoordSysInfo2;
}();
function getCoordSysInfoBySeries(seriesModel) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var result = new CoordSysInfo(coordSysName);
  var fetch = fetchers[coordSysName];
  if (fetch) {
    fetch(seriesModel, result, result.axisMap, result.categoryAxisMap);
    return result;
  }
}
var fetchers = {
  cartesian2d: function(seriesModel, result, axisMap, categoryAxisMap) {
    var xAxisModel = seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["x", "y"];
    axisMap.set("x", xAxisModel);
    axisMap.set("y", yAxisModel);
    if (isCategory(xAxisModel)) {
      categoryAxisMap.set("x", xAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(yAxisModel)) {
      categoryAxisMap.set("y", yAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  singleAxis: function(seriesModel, result, axisMap, categoryAxisMap) {
    var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["single"];
    axisMap.set("single", singleAxisModel);
    if (isCategory(singleAxisModel)) {
      categoryAxisMap.set("single", singleAxisModel);
      result.firstCategoryDimIndex = 0;
    }
  },
  polar: function(seriesModel, result, axisMap, categoryAxisMap) {
    var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
    var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
    var angleAxisModel = polarModel.findAxisModel("angleAxis");
    result.coordSysDims = ["radius", "angle"];
    axisMap.set("radius", radiusAxisModel);
    axisMap.set("angle", angleAxisModel);
    if (isCategory(radiusAxisModel)) {
      categoryAxisMap.set("radius", radiusAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(angleAxisModel)) {
      categoryAxisMap.set("angle", angleAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  geo: function(seriesModel, result, axisMap, categoryAxisMap) {
    result.coordSysDims = ["lng", "lat"];
  },
  parallel: function(seriesModel, result, axisMap, categoryAxisMap) {
    var ecModel = seriesModel.ecModel;
    var parallelModel = ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
    var coordSysDims = result.coordSysDims = parallelModel.dimensions.slice();
    each$g(parallelModel.parallelAxisIndex, function(axisIndex, index2) {
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axisDim = coordSysDims[index2];
      axisMap.set(axisDim, axisModel);
      if (isCategory(axisModel)) {
        categoryAxisMap.set(axisDim, axisModel);
        if (result.firstCategoryDimIndex == null) {
          result.firstCategoryDimIndex = index2;
        }
      }
    });
  }
};
function isCategory(axisModel) {
  return axisModel.get("type") === "category";
}
function enableDataStack(seriesModel, dimensionsInput, opt) {
  opt = opt || {};
  var byIndex = opt.byIndex;
  var stackedCoordDimension = opt.stackedCoordDimension;
  var dimensionDefineList;
  var schema;
  var store;
  if (isLegacyDimensionsInput(dimensionsInput)) {
    dimensionDefineList = dimensionsInput;
  } else {
    schema = dimensionsInput.schema;
    dimensionDefineList = schema.dimensions;
    store = dimensionsInput.store;
  }
  var mayStack = !!(seriesModel && seriesModel.get("stack"));
  var stackedByDimInfo;
  var stackedDimInfo;
  var stackResultDimension;
  var stackedOverDimension;
  each$g(dimensionDefineList, function(dimensionInfo, index2) {
    if (isString$1(dimensionInfo)) {
      dimensionDefineList[index2] = dimensionInfo = {
        name: dimensionInfo
      };
    }
    if (mayStack && !dimensionInfo.isExtraCoord) {
      if (!byIndex && !stackedByDimInfo && dimensionInfo.ordinalMeta) {
        stackedByDimInfo = dimensionInfo;
      }
      if (!stackedDimInfo && dimensionInfo.type !== "ordinal" && dimensionInfo.type !== "time" && (!stackedCoordDimension || stackedCoordDimension === dimensionInfo.coordDim)) {
        stackedDimInfo = dimensionInfo;
      }
    }
  });
  if (stackedDimInfo && !byIndex && !stackedByDimInfo) {
    byIndex = true;
  }
  if (stackedDimInfo) {
    stackResultDimension = "__\0ecstackresult_" + seriesModel.id;
    stackedOverDimension = "__\0ecstackedover_" + seriesModel.id;
    if (stackedByDimInfo) {
      stackedByDimInfo.createInvertedIndices = true;
    }
    var stackedDimCoordDim_1 = stackedDimInfo.coordDim;
    var stackedDimType = stackedDimInfo.type;
    var stackedDimCoordIndex_1 = 0;
    each$g(dimensionDefineList, function(dimensionInfo) {
      if (dimensionInfo.coordDim === stackedDimCoordDim_1) {
        stackedDimCoordIndex_1++;
      }
    });
    var stackedOverDimensionDefine = {
      name: stackResultDimension,
      coordDim: stackedDimCoordDim_1,
      coordDimIndex: stackedDimCoordIndex_1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length
    };
    var stackResultDimensionDefine = {
      name: stackedOverDimension,
      coordDim: stackedOverDimension,
      coordDimIndex: stackedDimCoordIndex_1 + 1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length + 1
    };
    if (schema) {
      if (store) {
        stackedOverDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackedOverDimension, stackedDimType);
        stackResultDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackResultDimension, stackedDimType);
      }
      schema.appendCalculationDimension(stackedOverDimensionDefine);
      schema.appendCalculationDimension(stackResultDimensionDefine);
    } else {
      dimensionDefineList.push(stackedOverDimensionDefine);
      dimensionDefineList.push(stackResultDimensionDefine);
    }
  }
  return {
    stackedDimension: stackedDimInfo && stackedDimInfo.name,
    stackedByDimension: stackedByDimInfo && stackedByDimInfo.name,
    isStackedByIndex: byIndex,
    stackedOverDimension,
    stackResultDimension
  };
}
function isLegacyDimensionsInput(dimensionsInput) {
  return !isSeriesDataSchema(dimensionsInput.schema);
}
function isDimensionStacked(data2, stackedDim) {
  return !!stackedDim && stackedDim === data2.getCalculationInfo("stackedDimension");
}
function getStackedDimension(data2, targetDim) {
  return isDimensionStacked(data2, targetDim) ? data2.getCalculationInfo("stackResultDimension") : targetDim;
}
function getCoordSysDimDefs(seriesModel, coordSysInfo) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var registeredCoordSys = CoordinateSystem.get(coordSysName);
  var coordSysDimDefs;
  if (coordSysInfo && coordSysInfo.coordSysDims) {
    coordSysDimDefs = map$1(coordSysInfo.coordSysDims, function(dim) {
      var dimInfo = {
        name: dim
      };
      var axisModel = coordSysInfo.axisMap.get(dim);
      if (axisModel) {
        var axisType = axisModel.get("type");
        dimInfo.type = getDimensionTypeByAxis(axisType);
      }
      return dimInfo;
    });
  }
  if (!coordSysDimDefs) {
    coordSysDimDefs = registeredCoordSys && (registeredCoordSys.getDimensionsInfo ? registeredCoordSys.getDimensionsInfo() : registeredCoordSys.dimensions.slice()) || ["x", "y"];
  }
  return coordSysDimDefs;
}
function injectOrdinalMeta(dimInfoList, createInvertedIndices, coordSysInfo) {
  var firstCategoryDimIndex;
  var hasNameEncode;
  coordSysInfo && each$g(dimInfoList, function(dimInfo, dimIndex) {
    var coordDim = dimInfo.coordDim;
    var categoryAxisModel = coordSysInfo.categoryAxisMap.get(coordDim);
    if (categoryAxisModel) {
      if (firstCategoryDimIndex == null) {
        firstCategoryDimIndex = dimIndex;
      }
      dimInfo.ordinalMeta = categoryAxisModel.getOrdinalMeta();
      if (createInvertedIndices) {
        dimInfo.createInvertedIndices = true;
      }
    }
    if (dimInfo.otherDims.itemName != null) {
      hasNameEncode = true;
    }
  });
  if (!hasNameEncode && firstCategoryDimIndex != null) {
    dimInfoList[firstCategoryDimIndex].otherDims.itemName = 0;
  }
  return firstCategoryDimIndex;
}
function createSeriesData(sourceRaw, seriesModel, opt) {
  opt = opt || {};
  var sourceManager = seriesModel.getSourceManager();
  var source;
  var isOriginalSource = false;
  if (sourceRaw) {
    isOriginalSource = true;
    source = createSourceFromSeriesDataOption(sourceRaw);
  } else {
    source = sourceManager.getSource();
    isOriginalSource = source.sourceFormat === SOURCE_FORMAT_ORIGINAL;
  }
  var coordSysInfo = getCoordSysInfoBySeries(seriesModel);
  var coordSysDimDefs = getCoordSysDimDefs(seriesModel, coordSysInfo);
  var useEncodeDefaulter = opt.useEncodeDefaulter;
  var encodeDefaulter = isFunction$1(useEncodeDefaulter) ? useEncodeDefaulter : useEncodeDefaulter ? curry$3(makeSeriesEncodeForAxisCoordSys, coordSysDimDefs, seriesModel) : null;
  var createDimensionOptions = {
    coordDimensions: coordSysDimDefs,
    generateCoord: opt.generateCoord,
    encodeDefine: seriesModel.getEncode(),
    encodeDefaulter,
    canOmitUnusedDimensions: !isOriginalSource
  };
  var schema = prepareSeriesDataSchema(source, createDimensionOptions);
  var firstCategoryDimIndex = injectOrdinalMeta(schema.dimensions, opt.createInvertedIndices, coordSysInfo);
  var store = !isOriginalSource ? sourceManager.getSharedDataStore(schema) : null;
  var stackCalculationInfo = enableDataStack(seriesModel, {
    schema,
    store
  });
  var data2 = new SeriesData$1(schema, seriesModel);
  data2.setCalculationInfo(stackCalculationInfo);
  var dimValueGetter = firstCategoryDimIndex != null && isNeedCompleteOrdinalData(source) ? function(itemOpt, dimName, dataIndex, dimIndex) {
    return dimIndex === firstCategoryDimIndex ? dataIndex : this.defaultDimValueGetter(itemOpt, dimName, dataIndex, dimIndex);
  } : null;
  data2.hasItemOption = false;
  data2.initData(isOriginalSource ? source : store, null, dimValueGetter);
  return data2;
}
function isNeedCompleteOrdinalData(source) {
  if (source.sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var sampleItem = firstDataNotNull(source.data || []);
    return !isArray$2(getDataItemValue(sampleItem));
  }
}
function firstDataNotNull(arr) {
  var i = 0;
  while (i < arr.length && arr[i] == null) {
    i++;
  }
  return arr[i];
}
var Scale = function() {
  function Scale2(setting) {
    this._setting = setting || {};
    this._extent = [Infinity, -Infinity];
  }
  Scale2.prototype.getSetting = function(name2) {
    return this._setting[name2];
  };
  Scale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
  };
  Scale2.prototype.unionExtentFromData = function(data2, dim) {
    this.unionExtent(data2.getApproximateExtent(dim));
  };
  Scale2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Scale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = start2;
    }
    if (!isNaN(end2)) {
      thisExtent[1] = end2;
    }
  };
  Scale2.prototype.isInExtentRange = function(value) {
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  Scale2.prototype.isBlank = function() {
    return this._isBlank;
  };
  Scale2.prototype.setBlank = function(isBlank) {
    this._isBlank = isBlank;
  };
  return Scale2;
}();
enableClassManagement(Scale);
var Scale$1 = Scale;
var uidBase = 0;
var OrdinalMeta = function() {
  function OrdinalMeta2(opt) {
    this.categories = opt.categories || [];
    this._needCollect = opt.needCollect;
    this._deduplication = opt.deduplication;
    this.uid = ++uidBase;
  }
  OrdinalMeta2.createByAxisModel = function(axisModel) {
    var option = axisModel.option;
    var data2 = option.data;
    var categories = data2 && map$1(data2, getName);
    return new OrdinalMeta2({
      categories,
      needCollect: !categories,
      deduplication: option.dedplication !== false
    });
  };
  OrdinalMeta2.prototype.getOrdinal = function(category) {
    return this._getOrCreateMap().get(category);
  };
  OrdinalMeta2.prototype.parseAndCollect = function(category) {
    var index2;
    var needCollect = this._needCollect;
    if (!isString$1(category) && !needCollect) {
      return category;
    }
    if (needCollect && !this._deduplication) {
      index2 = this.categories.length;
      this.categories[index2] = category;
      return index2;
    }
    var map2 = this._getOrCreateMap();
    index2 = map2.get(category);
    if (index2 == null) {
      if (needCollect) {
        index2 = this.categories.length;
        this.categories[index2] = category;
        map2.set(category, index2);
      } else {
        index2 = NaN;
      }
    }
    return index2;
  };
  OrdinalMeta2.prototype._getOrCreateMap = function() {
    return this._map || (this._map = createHashMap(this.categories));
  };
  return OrdinalMeta2;
}();
function getName(obj) {
  if (isObject$6(obj) && obj.value != null) {
    return obj.value;
  } else {
    return obj + "";
  }
}
var OrdinalMeta$1 = OrdinalMeta;
function isIntervalOrLogScale(scale2) {
  return scale2.type === "interval" || scale2.type === "log";
}
function intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval) {
  var result = {};
  var span = extent3[1] - extent3[0];
  var interval = result.interval = nice(span / splitNumber, true);
  if (minInterval != null && interval < minInterval) {
    interval = result.interval = minInterval;
  }
  if (maxInterval != null && interval > maxInterval) {
    interval = result.interval = maxInterval;
  }
  var precision = result.intervalPrecision = getIntervalPrecision(interval);
  var niceTickExtent = result.niceTickExtent = [round$3(Math.ceil(extent3[0] / interval) * interval, precision), round$3(Math.floor(extent3[1] / interval) * interval, precision)];
  fixExtent(niceTickExtent, extent3);
  return result;
}
function increaseInterval(interval) {
  var exp10 = Math.pow(10, quantityExponent(interval));
  var f2 = interval / exp10;
  if (!f2) {
    f2 = 1;
  } else if (f2 === 2) {
    f2 = 3;
  } else if (f2 === 3) {
    f2 = 5;
  } else {
    f2 *= 2;
  }
  return round$3(f2 * exp10);
}
function getIntervalPrecision(interval) {
  return getPrecision(interval) + 2;
}
function clamp(niceTickExtent, idx, extent3) {
  niceTickExtent[idx] = Math.max(Math.min(niceTickExtent[idx], extent3[1]), extent3[0]);
}
function fixExtent(niceTickExtent, extent3) {
  !isFinite(niceTickExtent[0]) && (niceTickExtent[0] = extent3[0]);
  !isFinite(niceTickExtent[1]) && (niceTickExtent[1] = extent3[1]);
  clamp(niceTickExtent, 0, extent3);
  clamp(niceTickExtent, 1, extent3);
  if (niceTickExtent[0] > niceTickExtent[1]) {
    niceTickExtent[0] = niceTickExtent[1];
  }
}
function contain$1(val, extent3) {
  return val >= extent3[0] && val <= extent3[1];
}
function normalize$3(val, extent3) {
  if (extent3[1] === extent3[0]) {
    return 0.5;
  }
  return (val - extent3[0]) / (extent3[1] - extent3[0]);
}
function scale(val, extent3) {
  return val * (extent3[1] - extent3[0]) + extent3[0];
}
var OrdinalScale = function(_super) {
  __extends(OrdinalScale2, _super);
  function OrdinalScale2(setting) {
    var _this = _super.call(this, setting) || this;
    _this.type = "ordinal";
    var ordinalMeta = _this.getSetting("ordinalMeta");
    if (!ordinalMeta) {
      ordinalMeta = new OrdinalMeta$1({});
    }
    if (isArray$2(ordinalMeta)) {
      ordinalMeta = new OrdinalMeta$1({
        categories: map$1(ordinalMeta, function(item) {
          return isObject$6(item) ? item.value : item;
        })
      });
    }
    _this._ordinalMeta = ordinalMeta;
    _this._extent = _this.getSetting("extent") || [0, ordinalMeta.categories.length - 1];
    return _this;
  }
  OrdinalScale2.prototype.parse = function(val) {
    return isString$1(val) ? this._ordinalMeta.getOrdinal(val) : Math.round(val);
  };
  OrdinalScale2.prototype.contain = function(rank) {
    rank = this.parse(rank);
    return contain$1(rank, this._extent) && this._ordinalMeta.categories[rank] != null;
  };
  OrdinalScale2.prototype.normalize = function(val) {
    val = this._getTickNumber(this.parse(val));
    return normalize$3(val, this._extent);
  };
  OrdinalScale2.prototype.scale = function(val) {
    val = Math.round(scale(val, this._extent));
    return this.getRawOrdinalNumber(val);
  };
  OrdinalScale2.prototype.getTicks = function() {
    var ticks = [];
    var extent3 = this._extent;
    var rank = extent3[0];
    while (rank <= extent3[1]) {
      ticks.push({
        value: rank
      });
      rank++;
    }
    return ticks;
  };
  OrdinalScale2.prototype.getMinorTicks = function(splitNumber) {
    return;
  };
  OrdinalScale2.prototype.setSortInfo = function(info) {
    if (info == null) {
      this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
      return;
    }
    var infoOrdinalNumbers = info.ordinalNumbers;
    var ordinalsByTick = this._ordinalNumbersByTick = [];
    var ticksByOrdinal = this._ticksByOrdinalNumber = [];
    var tickNum = 0;
    var allCategoryLen = this._ordinalMeta.categories.length;
    for (var len2 = Math.min(allCategoryLen, infoOrdinalNumbers.length); tickNum < len2; ++tickNum) {
      var ordinalNumber = infoOrdinalNumbers[tickNum];
      ordinalsByTick[tickNum] = ordinalNumber;
      ticksByOrdinal[ordinalNumber] = tickNum;
    }
    var unusedOrdinal = 0;
    for (; tickNum < allCategoryLen; ++tickNum) {
      while (ticksByOrdinal[unusedOrdinal] != null) {
        unusedOrdinal++;
      }
      ordinalsByTick.push(unusedOrdinal);
      ticksByOrdinal[unusedOrdinal] = tickNum;
    }
  };
  OrdinalScale2.prototype._getTickNumber = function(ordinal) {
    var ticksByOrdinalNumber = this._ticksByOrdinalNumber;
    return ticksByOrdinalNumber && ordinal >= 0 && ordinal < ticksByOrdinalNumber.length ? ticksByOrdinalNumber[ordinal] : ordinal;
  };
  OrdinalScale2.prototype.getRawOrdinalNumber = function(tickNumber) {
    var ordinalNumbersByTick = this._ordinalNumbersByTick;
    return ordinalNumbersByTick && tickNumber >= 0 && tickNumber < ordinalNumbersByTick.length ? ordinalNumbersByTick[tickNumber] : tickNumber;
  };
  OrdinalScale2.prototype.getLabel = function(tick) {
    if (!this.isBlank()) {
      var ordinalNumber = this.getRawOrdinalNumber(tick.value);
      var cateogry = this._ordinalMeta.categories[ordinalNumber];
      return cateogry == null ? "" : cateogry + "";
    }
  };
  OrdinalScale2.prototype.count = function() {
    return this._extent[1] - this._extent[0] + 1;
  };
  OrdinalScale2.prototype.unionExtentFromData = function(data2, dim) {
    this.unionExtent(data2.getApproximateExtent(dim));
  };
  OrdinalScale2.prototype.isInExtentRange = function(value) {
    value = this._getTickNumber(value);
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  OrdinalScale2.prototype.getOrdinalMeta = function() {
    return this._ordinalMeta;
  };
  OrdinalScale2.prototype.calcNiceTicks = function() {
  };
  OrdinalScale2.prototype.calcNiceExtent = function() {
  };
  OrdinalScale2.type = "ordinal";
  return OrdinalScale2;
}(Scale$1);
Scale$1.registerClass(OrdinalScale);
var OrdinalScale$1 = OrdinalScale;
var roundNumber = round$3;
var IntervalScale = function(_super) {
  __extends(IntervalScale2, _super);
  function IntervalScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "interval";
    _this._interval = 0;
    _this._intervalPrecision = 2;
    return _this;
  }
  IntervalScale2.prototype.parse = function(val) {
    return val;
  };
  IntervalScale2.prototype.contain = function(val) {
    return contain$1(val, this._extent);
  };
  IntervalScale2.prototype.normalize = function(val) {
    return normalize$3(val, this._extent);
  };
  IntervalScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  IntervalScale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = parseFloat(start2);
    }
    if (!isNaN(end2)) {
      thisExtent[1] = parseFloat(end2);
    }
  };
  IntervalScale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
    this.setExtent(extent3[0], extent3[1]);
  };
  IntervalScale2.prototype.getInterval = function() {
    return this._interval;
  };
  IntervalScale2.prototype.setInterval = function(interval) {
    this._interval = interval;
    this._niceExtent = this._extent.slice();
    this._intervalPrecision = getIntervalPrecision(interval);
  };
  IntervalScale2.prototype.getTicks = function(expandToNicedExtent) {
    var interval = this._interval;
    var extent3 = this._extent;
    var niceTickExtent = this._niceExtent;
    var intervalPrecision = this._intervalPrecision;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    var safeLimit = 1e4;
    if (extent3[0] < niceTickExtent[0]) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(niceTickExtent[0] - interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[0]
        });
      }
    }
    var tick = niceTickExtent[0];
    while (tick <= niceTickExtent[1]) {
      ticks.push({
        value: tick
      });
      tick = roundNumber(tick + interval, intervalPrecision);
      if (tick === ticks[ticks.length - 1].value) {
        break;
      }
      if (ticks.length > safeLimit) {
        return [];
      }
    }
    var lastNiceTick = ticks.length ? ticks[ticks.length - 1].value : niceTickExtent[1];
    if (extent3[1] > lastNiceTick) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(lastNiceTick + interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[1]
        });
      }
    }
    return ticks;
  };
  IntervalScale2.prototype.getMinorTicks = function(splitNumber) {
    var ticks = this.getTicks(true);
    var minorTicks = [];
    var extent3 = this.getExtent();
    for (var i = 1; i < ticks.length; i++) {
      var nextTick = ticks[i];
      var prevTick = ticks[i - 1];
      var count2 = 0;
      var minorTicksGroup = [];
      var interval = nextTick.value - prevTick.value;
      var minorInterval = interval / splitNumber;
      while (count2 < splitNumber - 1) {
        var minorTick = roundNumber(prevTick.value + (count2 + 1) * minorInterval);
        if (minorTick > extent3[0] && minorTick < extent3[1]) {
          minorTicksGroup.push(minorTick);
        }
        count2++;
      }
      minorTicks.push(minorTicksGroup);
    }
    return minorTicks;
  };
  IntervalScale2.prototype.getLabel = function(data2, opt) {
    if (data2 == null) {
      return "";
    }
    var precision = opt && opt.precision;
    if (precision == null) {
      precision = getPrecision(data2.value) || 0;
    } else if (precision === "auto") {
      precision = this._intervalPrecision;
    }
    var dataNum = roundNumber(data2.value, precision, true);
    return addCommas(dataNum);
  };
  IntervalScale2.prototype.calcNiceTicks = function(splitNumber, minInterval, maxInterval) {
    splitNumber = splitNumber || 5;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      return;
    }
    if (span < 0) {
      span = -span;
      extent3.reverse();
    }
    var result = intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval);
    this._intervalPrecision = result.intervalPrecision;
    this._interval = result.interval;
    this._niceExtent = result.niceTickExtent;
  };
  IntervalScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      if (extent3[0] !== 0) {
        var expandSize = extent3[0];
        if (!opt.fixMax) {
          extent3[1] += expandSize / 2;
          extent3[0] -= expandSize / 2;
        } else {
          extent3[0] -= expandSize / 2;
        }
      } else {
        extent3[1] = 1;
      }
    }
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      extent3[0] = 0;
      extent3[1] = 1;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
    var interval = this._interval;
    if (!opt.fixMin) {
      extent3[0] = roundNumber(Math.floor(extent3[0] / interval) * interval);
    }
    if (!opt.fixMax) {
      extent3[1] = roundNumber(Math.ceil(extent3[1] / interval) * interval);
    }
  };
  IntervalScale2.prototype.setNiceExtent = function(min3, max3) {
    this._niceExtent = [min3, max3];
  };
  IntervalScale2.type = "interval";
  return IntervalScale2;
}(Scale$1);
Scale$1.registerClass(IntervalScale);
var IntervalScale$1 = IntervalScale;
var supportFloat32Array = typeof Float32Array !== "undefined";
var Float32ArrayCtor = !supportFloat32Array ? Array : Float32Array;
function createFloat32Array(arg) {
  if (isArray$2(arg)) {
    return supportFloat32Array ? new Float32Array(arg) : arg;
  }
  return new Float32ArrayCtor(arg);
}
var STACK_PREFIX = "__ec_stack_";
function getSeriesStackId$1(seriesModel) {
  return seriesModel.get("stack") || STACK_PREFIX + seriesModel.seriesIndex;
}
function getAxisKey$1(axis) {
  return axis.dim + axis.index;
}
function getLayoutOnAxis(opt) {
  var params = [];
  var baseAxis = opt.axis;
  var axisKey = "axis0";
  if (baseAxis.type !== "category") {
    return;
  }
  var bandWidth = baseAxis.getBandWidth();
  for (var i = 0; i < opt.count || 0; i++) {
    params.push(defaults({
      bandWidth,
      axisKey,
      stackId: STACK_PREFIX + i
    }, opt));
  }
  var widthAndOffsets = doCalBarWidthAndOffset(params);
  var result = [];
  for (var i = 0; i < opt.count; i++) {
    var item = widthAndOffsets[axisKey][STACK_PREFIX + i];
    item.offsetCenter = item.offset + item.width / 2;
    result.push(item);
  }
  return result;
}
function prepareLayoutBarSeries(seriesType2, ecModel) {
  var seriesModels = [];
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (isOnCartesian(seriesModel)) {
      seriesModels.push(seriesModel);
    }
  });
  return seriesModels;
}
function getValueAxesMinGaps(barSeries) {
  var axisValues = {};
  each$g(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    if (baseAxis.type !== "time" && baseAxis.type !== "value") {
      return;
    }
    var data2 = seriesModel.getData();
    var key2 = baseAxis.dim + "_" + baseAxis.index;
    var dimIdx = data2.getDimensionIndex(data2.mapDimension(baseAxis.dim));
    var store = data2.getStore();
    for (var i = 0, cnt = store.count(); i < cnt; ++i) {
      var value = store.get(dimIdx, i);
      if (!axisValues[key2]) {
        axisValues[key2] = [value];
      } else {
        axisValues[key2].push(value);
      }
    }
  });
  var axisMinGaps = {};
  for (var key in axisValues) {
    if (axisValues.hasOwnProperty(key)) {
      var valuesInAxis = axisValues[key];
      if (valuesInAxis) {
        valuesInAxis.sort(function(a, b2) {
          return a - b2;
        });
        var min3 = null;
        for (var j = 1; j < valuesInAxis.length; ++j) {
          var delta = valuesInAxis[j] - valuesInAxis[j - 1];
          if (delta > 0) {
            min3 = min3 === null ? delta : Math.min(min3, delta);
          }
        }
        axisMinGaps[key] = min3;
      }
    }
  }
  return axisMinGaps;
}
function makeColumnLayout(barSeries) {
  var axisMinGaps = getValueAxesMinGaps(barSeries);
  var seriesInfoList = [];
  each$g(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var axisExtent = baseAxis.getExtent();
    var bandWidth;
    if (baseAxis.type === "category") {
      bandWidth = baseAxis.getBandWidth();
    } else if (baseAxis.type === "value" || baseAxis.type === "time") {
      var key = baseAxis.dim + "_" + baseAxis.index;
      var minGap = axisMinGaps[key];
      var extentSpan = Math.abs(axisExtent[1] - axisExtent[0]);
      var scale2 = baseAxis.scale.getExtent();
      var scaleSpan = Math.abs(scale2[1] - scale2[0]);
      bandWidth = minGap ? extentSpan / scaleSpan * minGap : extentSpan;
    } else {
      var data2 = seriesModel.getData();
      bandWidth = Math.abs(axisExtent[1] - axisExtent[0]) / data2.count();
    }
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barMinWidth = parsePercent(seriesModel.get("barMinWidth") || (isInLargeMode(seriesModel) ? 0.5 : 1), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    seriesInfoList.push({
      bandWidth,
      barWidth,
      barMaxWidth,
      barMinWidth,
      barGap,
      barCategoryGap,
      axisKey: getAxisKey$1(baseAxis),
      stackId: getSeriesStackId$1(seriesModel)
    });
  });
  return doCalBarWidthAndOffset(seriesInfoList);
}
function doCalBarWidthAndOffset(seriesInfoList) {
  var columnsMap = {};
  each$g(seriesInfoList, function(seriesInfo, idx) {
    var axisKey = seriesInfo.axisKey;
    var bandWidth = seriesInfo.bandWidth;
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = seriesInfo.stackId;
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = seriesInfo.barWidth;
    if (barWidth && !stacks[stackId].width) {
      stacks[stackId].width = barWidth;
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      columnsOnAxis.remainedWidth -= barWidth;
    }
    var barMaxWidth = seriesInfo.barMaxWidth;
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    var barMinWidth = seriesInfo.barMinWidth;
    barMinWidth && (stacks[stackId].minWidth = barMinWidth);
    var barGap = seriesInfo.barGap;
    barGap != null && (columnsOnAxis.gap = barGap);
    var barCategoryGap = seriesInfo.barCategoryGap;
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$g(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGapPercent = columnsOnAxis.categoryGap;
    if (categoryGapPercent == null) {
      var columnCount = keys(stacks).length;
      categoryGapPercent = Math.max(35 - columnCount * 4, 15) + "%";
    }
    var categoryGap = parsePercent(categoryGapPercent, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$g(stacks, function(column) {
      var maxWidth = column.maxWidth;
      var minWidth = column.minWidth;
      if (!column.width) {
        var finalWidth = autoWidth;
        if (maxWidth && maxWidth < finalWidth) {
          finalWidth = Math.min(maxWidth, remainedWidth);
        }
        if (minWidth && minWidth > finalWidth) {
          finalWidth = minWidth;
        }
        if (finalWidth !== autoWidth) {
          column.width = finalWidth;
          remainedWidth -= finalWidth + barGapPercent * finalWidth;
          autoWidthCount--;
        }
      } else {
        var finalWidth = column.width;
        if (maxWidth) {
          finalWidth = Math.min(finalWidth, maxWidth);
        }
        if (minWidth) {
          finalWidth = Math.max(finalWidth, minWidth);
        }
        column.width = finalWidth;
        remainedWidth -= finalWidth + barGapPercent * finalWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$g(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset3 = -widthSum / 2;
    each$g(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        bandWidth,
        offset: offset3,
        width: column.width
      };
      offset3 += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
function retrieveColumnLayout(barWidthAndOffset, axis, seriesModel) {
  if (barWidthAndOffset && axis) {
    var result = barWidthAndOffset[getAxisKey$1(axis)];
    if (result != null && seriesModel != null) {
      return result[getSeriesStackId$1(seriesModel)];
    }
    return result;
  }
}
function layout$3(seriesType2, ecModel) {
  var seriesModels = prepareLayoutBarSeries(seriesType2, ecModel);
  var barWidthAndOffset = makeColumnLayout(seriesModels);
  each$g(seriesModels, function(seriesModel) {
    var data2 = seriesModel.getData();
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var stackId = getSeriesStackId$1(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[getAxisKey$1(baseAxis)][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    data2.setLayout({
      bandWidth: columnLayoutInfo.bandWidth,
      offset: columnOffset,
      size: columnWidth
    });
  });
}
function createProgressiveLayout(seriesType2) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      if (!isOnCartesian(seriesModel)) {
        return;
      }
      var data2 = seriesModel.getData();
      var cartesian = seriesModel.coordinateSystem;
      var baseAxis = cartesian.getBaseAxis();
      var valueAxis2 = cartesian.getOtherAxis(baseAxis);
      var valueDimIdx = data2.getDimensionIndex(data2.mapDimension(valueAxis2.dim));
      var baseDimIdx = data2.getDimensionIndex(data2.mapDimension(baseAxis.dim));
      var drawBackground = seriesModel.get("showBackground", true);
      var valueDim = data2.mapDimension(valueAxis2.dim);
      var stackResultDim = data2.getCalculationInfo("stackResultDimension");
      var stacked = isDimensionStacked(data2, valueDim) && !!data2.getCalculationInfo("stackedOnSeries");
      var isValueAxisH = valueAxis2.isHorizontal();
      var valueAxisStart = getValueAxisStart(baseAxis, valueAxis2);
      var isLarge = isInLargeMode(seriesModel);
      var barMinHeight = seriesModel.get("barMinHeight") || 0;
      var stackedDimIdx = stackResultDim && data2.getDimensionIndex(stackResultDim);
      var columnWidth = data2.getLayout("size");
      var columnOffset = data2.getLayout("offset");
      return {
        progress: function(params, data3) {
          var count2 = params.count;
          var largePoints = isLarge && createFloat32Array(count2 * 3);
          var largeBackgroundPoints = isLarge && drawBackground && createFloat32Array(count2 * 3);
          var largeDataIndices = isLarge && createFloat32Array(count2);
          var coordLayout = cartesian.master.getRect();
          var bgSize = isValueAxisH ? coordLayout.width : coordLayout.height;
          var dataIndex;
          var store = data3.getStore();
          var idxOffset = 0;
          while ((dataIndex = params.next()) != null) {
            var value = store.get(stacked ? stackedDimIdx : valueDimIdx, dataIndex);
            var baseValue = store.get(baseDimIdx, dataIndex);
            var baseCoord = valueAxisStart;
            var startValue = void 0;
            if (stacked) {
              startValue = +value - store.get(valueDimIdx, dataIndex);
            }
            var x2 = void 0;
            var y2 = void 0;
            var width = void 0;
            var height = void 0;
            if (isValueAxisH) {
              var coord = cartesian.dataToPoint([value, baseValue]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([startValue, baseValue]);
                baseCoord = startCoord[0];
              }
              x2 = baseCoord;
              y2 = coord[1] + columnOffset;
              width = coord[0] - baseCoord;
              height = columnWidth;
              if (Math.abs(width) < barMinHeight) {
                width = (width < 0 ? -1 : 1) * barMinHeight;
              }
            } else {
              var coord = cartesian.dataToPoint([baseValue, value]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([baseValue, startValue]);
                baseCoord = startCoord[1];
              }
              x2 = coord[0] + columnOffset;
              y2 = baseCoord;
              width = columnWidth;
              height = coord[1] - baseCoord;
              if (Math.abs(height) < barMinHeight) {
                height = (height <= 0 ? -1 : 1) * barMinHeight;
              }
            }
            if (!isLarge) {
              data3.setItemLayout(dataIndex, {
                x: x2,
                y: y2,
                width,
                height
              });
            } else {
              largePoints[idxOffset] = x2;
              largePoints[idxOffset + 1] = y2;
              largePoints[idxOffset + 2] = isValueAxisH ? width : height;
              if (largeBackgroundPoints) {
                largeBackgroundPoints[idxOffset] = isValueAxisH ? coordLayout.x : x2;
                largeBackgroundPoints[idxOffset + 1] = isValueAxisH ? y2 : coordLayout.y;
                largeBackgroundPoints[idxOffset + 2] = bgSize;
              }
              largeDataIndices[dataIndex] = dataIndex;
            }
            idxOffset += 3;
          }
          if (isLarge) {
            data3.setLayout({
              largePoints,
              largeDataIndices,
              largeBackgroundPoints,
              valueAxisHorizontal: isValueAxisH
            });
          }
        }
      };
    }
  };
}
function isOnCartesian(seriesModel) {
  return seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "cartesian2d";
}
function isInLargeMode(seriesModel) {
  return seriesModel.pipelineContext && seriesModel.pipelineContext.large;
}
function getValueAxisStart(baseAxis, valueAxis2) {
  return valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(valueAxis2.type === "log" ? 1 : 0));
}
var bisect = function(a, x2, lo, hi2) {
  while (lo < hi2) {
    var mid = lo + hi2 >>> 1;
    if (a[mid][1] < x2) {
      lo = mid + 1;
    } else {
      hi2 = mid;
    }
  }
  return lo;
};
var TimeScale = function(_super) {
  __extends(TimeScale2, _super);
  function TimeScale2(settings) {
    var _this = _super.call(this, settings) || this;
    _this.type = "time";
    return _this;
  }
  TimeScale2.prototype.getLabel = function(tick) {
    var useUTC = this.getSetting("useUTC");
    return format$1(tick.value, fullLeveledFormatter[getDefaultFormatPrecisionOfInterval(getPrimaryTimeUnit(this._minLevelUnit))] || fullLeveledFormatter.second, useUTC, this.getSetting("locale"));
  };
  TimeScale2.prototype.getFormattedLabel = function(tick, idx, labelFormatter) {
    var isUTC = this.getSetting("useUTC");
    var lang = this.getSetting("locale");
    return leveledFormat(tick, idx, labelFormatter, lang, isUTC);
  };
  TimeScale2.prototype.getTicks = function() {
    var interval = this._interval;
    var extent3 = this._extent;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    ticks.push({
      value: extent3[0],
      level: 0
    });
    var useUTC = this.getSetting("useUTC");
    var innerTicks = getIntervalTicks(this._minLevelUnit, this._approxInterval, useUTC, extent3);
    ticks = ticks.concat(innerTicks);
    ticks.push({
      value: extent3[1],
      level: 0
    });
    return ticks;
  };
  TimeScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      extent3[0] -= ONE_DAY;
      extent3[1] += ONE_DAY;
    }
    if (extent3[1] === -Infinity && extent3[0] === Infinity) {
      var d2 = new Date();
      extent3[1] = +new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
      extent3[0] = extent3[1] - ONE_DAY;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
  };
  TimeScale2.prototype.calcNiceTicks = function(approxTickNum, minInterval, maxInterval) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    this._approxInterval = span / approxTickNum;
    if (minInterval != null && this._approxInterval < minInterval) {
      this._approxInterval = minInterval;
    }
    if (maxInterval != null && this._approxInterval > maxInterval) {
      this._approxInterval = maxInterval;
    }
    var scaleIntervalsLen = scaleIntervals.length;
    var idx = Math.min(bisect(scaleIntervals, this._approxInterval, 0, scaleIntervalsLen), scaleIntervalsLen - 1);
    this._interval = scaleIntervals[idx][1];
    this._minLevelUnit = scaleIntervals[Math.max(idx - 1, 0)][0];
  };
  TimeScale2.prototype.parse = function(val) {
    return isNumber(val) ? val : +parseDate(val);
  };
  TimeScale2.prototype.contain = function(val) {
    return contain$1(this.parse(val), this._extent);
  };
  TimeScale2.prototype.normalize = function(val) {
    return normalize$3(this.parse(val), this._extent);
  };
  TimeScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  TimeScale2.type = "time";
  return TimeScale2;
}(IntervalScale$1);
var scaleIntervals = [
  ["second", ONE_SECOND],
  ["minute", ONE_MINUTE],
  ["hour", ONE_HOUR],
  ["quarter-day", ONE_HOUR * 6],
  ["half-day", ONE_HOUR * 12],
  ["day", ONE_DAY * 1.2],
  ["half-week", ONE_DAY * 3.5],
  ["week", ONE_DAY * 7],
  ["month", ONE_DAY * 31],
  ["quarter", ONE_DAY * 95],
  ["half-year", ONE_YEAR / 2],
  ["year", ONE_YEAR]
];
function isUnitValueSame(unit, valueA, valueB, isUTC) {
  var dateA = parseDate(valueA);
  var dateB = parseDate(valueB);
  var isSame = function(unit2) {
    return getUnitValue(dateA, unit2, isUTC) === getUnitValue(dateB, unit2, isUTC);
  };
  var isSameYear = function() {
    return isSame("year");
  };
  var isSameMonth = function() {
    return isSameYear() && isSame("month");
  };
  var isSameDay = function() {
    return isSameMonth() && isSame("day");
  };
  var isSameHour = function() {
    return isSameDay() && isSame("hour");
  };
  var isSameMinute = function() {
    return isSameHour() && isSame("minute");
  };
  var isSameSecond = function() {
    return isSameMinute() && isSame("second");
  };
  var isSameMilliSecond = function() {
    return isSameSecond() && isSame("millisecond");
  };
  switch (unit) {
    case "year":
      return isSameYear();
    case "month":
      return isSameMonth();
    case "day":
      return isSameDay();
    case "hour":
      return isSameHour();
    case "minute":
      return isSameMinute();
    case "second":
      return isSameSecond();
    case "millisecond":
      return isSameMilliSecond();
  }
}
function getDateInterval(approxInterval, daysInMonth) {
  approxInterval /= ONE_DAY;
  return approxInterval > 16 ? 16 : approxInterval > 7.5 ? 7 : approxInterval > 3.5 ? 4 : approxInterval > 1.5 ? 2 : 1;
}
function getMonthInterval(approxInterval) {
  var APPROX_ONE_MONTH = 30 * ONE_DAY;
  approxInterval /= APPROX_ONE_MONTH;
  return approxInterval > 6 ? 6 : approxInterval > 3 ? 3 : approxInterval > 2 ? 2 : 1;
}
function getHourInterval(approxInterval) {
  approxInterval /= ONE_HOUR;
  return approxInterval > 12 ? 12 : approxInterval > 6 ? 6 : approxInterval > 3.5 ? 4 : approxInterval > 2 ? 2 : 1;
}
function getMinutesAndSecondsInterval(approxInterval, isMinutes) {
  approxInterval /= isMinutes ? ONE_MINUTE : ONE_SECOND;
  return approxInterval > 30 ? 30 : approxInterval > 20 ? 20 : approxInterval > 15 ? 15 : approxInterval > 10 ? 10 : approxInterval > 5 ? 5 : approxInterval > 2 ? 2 : 1;
}
function getMillisecondsInterval(approxInterval) {
  return nice(approxInterval, true);
}
function getFirstTimestampOfUnit(date4, unitName, isUTC) {
  var outDate = new Date(date4);
  switch (getPrimaryTimeUnit(unitName)) {
    case "year":
    case "month":
      outDate[monthSetterName(isUTC)](0);
    case "day":
      outDate[dateSetterName(isUTC)](1);
    case "hour":
      outDate[hoursSetterName(isUTC)](0);
    case "minute":
      outDate[minutesSetterName(isUTC)](0);
    case "second":
      outDate[secondsSetterName(isUTC)](0);
      outDate[millisecondsSetterName(isUTC)](0);
  }
  return outDate.getTime();
}
function getIntervalTicks(bottomUnitName, approxInterval, isUTC, extent3) {
  var safeLimit = 1e4;
  var unitNames = timeUnits;
  var iter = 0;
  function addTicksInSpan(interval, minTimestamp, maxTimestamp, getMethodName, setMethodName, isDate, out2) {
    var date4 = new Date(minTimestamp);
    var dateTime = minTimestamp;
    var d2 = date4[getMethodName]();
    while (dateTime < maxTimestamp && dateTime <= extent3[1]) {
      out2.push({
        value: dateTime
      });
      d2 += interval;
      date4[setMethodName](d2);
      dateTime = date4.getTime();
    }
    out2.push({
      value: dateTime,
      notAdd: true
    });
  }
  function addLevelTicks(unitName, lastLevelTicks, levelTicks2) {
    var newAddedTicks = [];
    var isFirstLevel = !lastLevelTicks.length;
    if (isUnitValueSame(getPrimaryTimeUnit(unitName), extent3[0], extent3[1], isUTC)) {
      return;
    }
    if (isFirstLevel) {
      lastLevelTicks = [{
        value: getFirstTimestampOfUnit(new Date(extent3[0]), unitName, isUTC)
      }, {
        value: extent3[1]
      }];
    }
    for (var i2 = 0; i2 < lastLevelTicks.length - 1; i2++) {
      var startTick = lastLevelTicks[i2].value;
      var endTick = lastLevelTicks[i2 + 1].value;
      if (startTick === endTick) {
        continue;
      }
      var interval = void 0;
      var getterName = void 0;
      var setterName = void 0;
      var isDate = false;
      switch (unitName) {
        case "year":
          interval = Math.max(1, Math.round(approxInterval / ONE_DAY / 365));
          getterName = fullYearGetterName(isUTC);
          setterName = fullYearSetterName(isUTC);
          break;
        case "half-year":
        case "quarter":
        case "month":
          interval = getMonthInterval(approxInterval);
          getterName = monthGetterName(isUTC);
          setterName = monthSetterName(isUTC);
          break;
        case "week":
        case "half-week":
        case "day":
          interval = getDateInterval(approxInterval);
          getterName = dateGetterName(isUTC);
          setterName = dateSetterName(isUTC);
          isDate = true;
          break;
        case "half-day":
        case "quarter-day":
        case "hour":
          interval = getHourInterval(approxInterval);
          getterName = hoursGetterName(isUTC);
          setterName = hoursSetterName(isUTC);
          break;
        case "minute":
          interval = getMinutesAndSecondsInterval(approxInterval, true);
          getterName = minutesGetterName(isUTC);
          setterName = minutesSetterName(isUTC);
          break;
        case "second":
          interval = getMinutesAndSecondsInterval(approxInterval, false);
          getterName = secondsGetterName(isUTC);
          setterName = secondsSetterName(isUTC);
          break;
        case "millisecond":
          interval = getMillisecondsInterval(approxInterval);
          getterName = millisecondsGetterName(isUTC);
          setterName = millisecondsSetterName(isUTC);
          break;
      }
      addTicksInSpan(interval, startTick, endTick, getterName, setterName, isDate, newAddedTicks);
      if (unitName === "year" && levelTicks2.length > 1 && i2 === 0) {
        levelTicks2.unshift({
          value: levelTicks2[0].value - interval
        });
      }
    }
    for (var i2 = 0; i2 < newAddedTicks.length; i2++) {
      levelTicks2.push(newAddedTicks[i2]);
    }
    return newAddedTicks;
  }
  var levelsTicks = [];
  var currentLevelTicks = [];
  var tickCount = 0;
  var lastLevelTickCount = 0;
  for (var i = 0; i < unitNames.length && iter++ < safeLimit; ++i) {
    var primaryTimeUnit = getPrimaryTimeUnit(unitNames[i]);
    if (!isPrimaryTimeUnit(unitNames[i])) {
      continue;
    }
    addLevelTicks(unitNames[i], levelsTicks[levelsTicks.length - 1] || [], currentLevelTicks);
    var nextPrimaryTimeUnit = unitNames[i + 1] ? getPrimaryTimeUnit(unitNames[i + 1]) : null;
    if (primaryTimeUnit !== nextPrimaryTimeUnit) {
      if (currentLevelTicks.length) {
        lastLevelTickCount = tickCount;
        currentLevelTicks.sort(function(a, b2) {
          return a.value - b2.value;
        });
        var levelTicksRemoveDuplicated = [];
        for (var i_1 = 0; i_1 < currentLevelTicks.length; ++i_1) {
          var tickValue = currentLevelTicks[i_1].value;
          if (i_1 === 0 || currentLevelTicks[i_1 - 1].value !== tickValue) {
            levelTicksRemoveDuplicated.push(currentLevelTicks[i_1]);
            if (tickValue >= extent3[0] && tickValue <= extent3[1]) {
              tickCount++;
            }
          }
        }
        var targetTickNum = (extent3[1] - extent3[0]) / approxInterval;
        if (tickCount > targetTickNum * 1.5 && lastLevelTickCount > targetTickNum / 1.5) {
          break;
        }
        levelsTicks.push(levelTicksRemoveDuplicated);
        if (tickCount > targetTickNum || bottomUnitName === unitNames[i]) {
          break;
        }
      }
      currentLevelTicks = [];
    }
  }
  var levelsTicksInExtent = filter(map$1(levelsTicks, function(levelTicks2) {
    return filter(levelTicks2, function(tick) {
      return tick.value >= extent3[0] && tick.value <= extent3[1] && !tick.notAdd;
    });
  }), function(levelTicks2) {
    return levelTicks2.length > 0;
  });
  var ticks = [];
  var maxLevel = levelsTicksInExtent.length - 1;
  for (var i = 0; i < levelsTicksInExtent.length; ++i) {
    var levelTicks = levelsTicksInExtent[i];
    for (var k2 = 0; k2 < levelTicks.length; ++k2) {
      ticks.push({
        value: levelTicks[k2].value,
        level: maxLevel - i
      });
    }
  }
  ticks.sort(function(a, b2) {
    return a.value - b2.value;
  });
  var result = [];
  for (var i = 0; i < ticks.length; ++i) {
    if (i === 0 || ticks[i].value !== ticks[i - 1].value) {
      result.push(ticks[i]);
    }
  }
  return result;
}
Scale$1.registerClass(TimeScale);
var TimeScale$1 = TimeScale;
var scaleProto = Scale$1.prototype;
var intervalScaleProto = IntervalScale$1.prototype;
var roundingErrorFix = round$3;
var mathFloor$1 = Math.floor;
var mathCeil$1 = Math.ceil;
var mathPow$1 = Math.pow;
var mathLog$1 = Math.log;
var LogScale = function(_super) {
  __extends(LogScale2, _super);
  function LogScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "log";
    _this.base = 10;
    _this._originalScale = new IntervalScale$1();
    _this._interval = 0;
    return _this;
  }
  LogScale2.prototype.getTicks = function(expandToNicedExtent) {
    var originalScale = this._originalScale;
    var extent3 = this._extent;
    var originalExtent = originalScale.getExtent();
    var ticks = intervalScaleProto.getTicks.call(this, expandToNicedExtent);
    return map$1(ticks, function(tick) {
      var val = tick.value;
      var powVal = round$3(mathPow$1(this.base, val));
      powVal = val === extent3[0] && this._fixMin ? fixRoundingError(powVal, originalExtent[0]) : powVal;
      powVal = val === extent3[1] && this._fixMax ? fixRoundingError(powVal, originalExtent[1]) : powVal;
      return {
        value: powVal
      };
    }, this);
  };
  LogScale2.prototype.setExtent = function(start2, end2) {
    var base2 = this.base;
    start2 = mathLog$1(start2) / mathLog$1(base2);
    end2 = mathLog$1(end2) / mathLog$1(base2);
    intervalScaleProto.setExtent.call(this, start2, end2);
  };
  LogScale2.prototype.getExtent = function() {
    var base2 = this.base;
    var extent3 = scaleProto.getExtent.call(this);
    extent3[0] = mathPow$1(base2, extent3[0]);
    extent3[1] = mathPow$1(base2, extent3[1]);
    var originalScale = this._originalScale;
    var originalExtent = originalScale.getExtent();
    this._fixMin && (extent3[0] = fixRoundingError(extent3[0], originalExtent[0]));
    this._fixMax && (extent3[1] = fixRoundingError(extent3[1], originalExtent[1]));
    return extent3;
  };
  LogScale2.prototype.unionExtent = function(extent3) {
    this._originalScale.unionExtent(extent3);
    var base2 = this.base;
    extent3[0] = mathLog$1(extent3[0]) / mathLog$1(base2);
    extent3[1] = mathLog$1(extent3[1]) / mathLog$1(base2);
    scaleProto.unionExtent.call(this, extent3);
  };
  LogScale2.prototype.unionExtentFromData = function(data2, dim) {
    this.unionExtent(data2.getApproximateExtent(dim));
  };
  LogScale2.prototype.calcNiceTicks = function(approxTickNum) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (span === Infinity || span <= 0) {
      return;
    }
    var interval = quantity(span);
    var err = approxTickNum / span * interval;
    if (err <= 0.5) {
      interval *= 10;
    }
    while (!isNaN(interval) && Math.abs(interval) < 1 && Math.abs(interval) > 0) {
      interval *= 10;
    }
    var niceExtent = [round$3(mathCeil$1(extent3[0] / interval) * interval), round$3(mathFloor$1(extent3[1] / interval) * interval)];
    this._interval = interval;
    this._niceExtent = niceExtent;
  };
  LogScale2.prototype.calcNiceExtent = function(opt) {
    intervalScaleProto.calcNiceExtent.call(this, opt);
    this._fixMin = opt.fixMin;
    this._fixMax = opt.fixMax;
  };
  LogScale2.prototype.parse = function(val) {
    return val;
  };
  LogScale2.prototype.contain = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return contain$1(val, this._extent);
  };
  LogScale2.prototype.normalize = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return normalize$3(val, this._extent);
  };
  LogScale2.prototype.scale = function(val) {
    val = scale(val, this._extent);
    return mathPow$1(this.base, val);
  };
  LogScale2.type = "log";
  return LogScale2;
}(Scale$1);
var proto = LogScale.prototype;
proto.getMinorTicks = intervalScaleProto.getMinorTicks;
proto.getLabel = intervalScaleProto.getLabel;
function fixRoundingError(val, originalVal) {
  return roundingErrorFix(val, getPrecision(originalVal));
}
Scale$1.registerClass(LogScale);
var LogScale$1 = LogScale;
var ScaleRawExtentInfo = function() {
  function ScaleRawExtentInfo2(scale2, model, originalExtent) {
    this._prepareParams(scale2, model, originalExtent);
  }
  ScaleRawExtentInfo2.prototype._prepareParams = function(scale2, model, dataExtent) {
    if (dataExtent[1] < dataExtent[0]) {
      dataExtent = [NaN, NaN];
    }
    this._dataMin = dataExtent[0];
    this._dataMax = dataExtent[1];
    var isOrdinal = this._isOrdinal = scale2.type === "ordinal";
    this._needCrossZero = scale2.type === "interval" && model.getNeedCrossZero && model.getNeedCrossZero();
    var modelMinRaw = this._modelMinRaw = model.get("min", true);
    if (isFunction$1(modelMinRaw)) {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMinRaw !== "dataMin") {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw);
    }
    var modelMaxRaw = this._modelMaxRaw = model.get("max", true);
    if (isFunction$1(modelMaxRaw)) {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMaxRaw !== "dataMax") {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw);
    }
    if (isOrdinal) {
      this._axisDataLen = model.getCategories().length;
    } else {
      var boundaryGap = model.get("boundaryGap");
      var boundaryGapArr = isArray$2(boundaryGap) ? boundaryGap : [boundaryGap || 0, boundaryGap || 0];
      if (typeof boundaryGapArr[0] === "boolean" || typeof boundaryGapArr[1] === "boolean") {
        this._boundaryGapInner = [0, 0];
      } else {
        this._boundaryGapInner = [parsePercent$1(boundaryGapArr[0], 1), parsePercent$1(boundaryGapArr[1], 1)];
      }
    }
  };
  ScaleRawExtentInfo2.prototype.calculate = function() {
    var isOrdinal = this._isOrdinal;
    var dataMin = this._dataMin;
    var dataMax = this._dataMax;
    var axisDataLen = this._axisDataLen;
    var boundaryGapInner = this._boundaryGapInner;
    var span = !isOrdinal ? dataMax - dataMin || Math.abs(dataMin) : null;
    var min3 = this._modelMinRaw === "dataMin" ? dataMin : this._modelMinNum;
    var max3 = this._modelMaxRaw === "dataMax" ? dataMax : this._modelMaxNum;
    var minFixed = min3 != null;
    var maxFixed = max3 != null;
    if (min3 == null) {
      min3 = isOrdinal ? axisDataLen ? 0 : NaN : dataMin - boundaryGapInner[0] * span;
    }
    if (max3 == null) {
      max3 = isOrdinal ? axisDataLen ? axisDataLen - 1 : NaN : dataMax + boundaryGapInner[1] * span;
    }
    (min3 == null || !isFinite(min3)) && (min3 = NaN);
    (max3 == null || !isFinite(max3)) && (max3 = NaN);
    var isBlank = eqNaN(min3) || eqNaN(max3) || isOrdinal && !axisDataLen;
    if (this._needCrossZero) {
      if (min3 > 0 && max3 > 0 && !minFixed) {
        min3 = 0;
      }
      if (min3 < 0 && max3 < 0 && !maxFixed) {
        max3 = 0;
      }
    }
    var determinedMin = this._determinedMin;
    var determinedMax = this._determinedMax;
    if (determinedMin != null) {
      min3 = determinedMin;
      minFixed = true;
    }
    if (determinedMax != null) {
      max3 = determinedMax;
      maxFixed = true;
    }
    return {
      min: min3,
      max: max3,
      minFixed,
      maxFixed,
      isBlank
    };
  };
  ScaleRawExtentInfo2.prototype.modifyDataMinMax = function(minMaxName, val) {
    this[DATA_MIN_MAX_ATTR[minMaxName]] = val;
  };
  ScaleRawExtentInfo2.prototype.setDeterminedMinMax = function(minMaxName, val) {
    var attr = DETERMINED_MIN_MAX_ATTR[minMaxName];
    this[attr] = val;
  };
  ScaleRawExtentInfo2.prototype.freeze = function() {
    this.frozen = true;
  };
  return ScaleRawExtentInfo2;
}();
var DETERMINED_MIN_MAX_ATTR = {
  min: "_determinedMin",
  max: "_determinedMax"
};
var DATA_MIN_MAX_ATTR = {
  min: "_dataMin",
  max: "_dataMax"
};
function ensureScaleRawExtentInfo(scale2, model, originalExtent) {
  var rawExtentInfo = scale2.rawExtentInfo;
  if (rawExtentInfo) {
    return rawExtentInfo;
  }
  rawExtentInfo = new ScaleRawExtentInfo(scale2, model, originalExtent);
  scale2.rawExtentInfo = rawExtentInfo;
  return rawExtentInfo;
}
function parseAxisModelMinMax(scale2, minMax) {
  return minMax == null ? null : eqNaN(minMax) ? NaN : scale2.parse(minMax);
}
function getScaleExtent(scale2, model) {
  var scaleType = scale2.type;
  var rawExtentResult = ensureScaleRawExtentInfo(scale2, model, scale2.getExtent()).calculate();
  scale2.setBlank(rawExtentResult.isBlank);
  var min3 = rawExtentResult.min;
  var max3 = rawExtentResult.max;
  var ecModel = model.ecModel;
  if (ecModel && scaleType === "time") {
    var barSeriesModels = prepareLayoutBarSeries("bar", ecModel);
    var isBaseAxisAndHasBarSeries_1 = false;
    each$g(barSeriesModels, function(seriesModel) {
      isBaseAxisAndHasBarSeries_1 = isBaseAxisAndHasBarSeries_1 || seriesModel.getBaseAxis() === model.axis;
    });
    if (isBaseAxisAndHasBarSeries_1) {
      var barWidthAndOffset = makeColumnLayout(barSeriesModels);
      var adjustedScale = adjustScaleForOverflow(min3, max3, model, barWidthAndOffset);
      min3 = adjustedScale.min;
      max3 = adjustedScale.max;
    }
  }
  return {
    extent: [min3, max3],
    fixMin: rawExtentResult.minFixed,
    fixMax: rawExtentResult.maxFixed
  };
}
function adjustScaleForOverflow(min3, max3, model, barWidthAndOffset) {
  var axisExtent = model.axis.getExtent();
  var axisLength = axisExtent[1] - axisExtent[0];
  var barsOnCurrentAxis = retrieveColumnLayout(barWidthAndOffset, model.axis);
  if (barsOnCurrentAxis === void 0) {
    return {
      min: min3,
      max: max3
    };
  }
  var minOverflow = Infinity;
  each$g(barsOnCurrentAxis, function(item) {
    minOverflow = Math.min(item.offset, minOverflow);
  });
  var maxOverflow = -Infinity;
  each$g(barsOnCurrentAxis, function(item) {
    maxOverflow = Math.max(item.offset + item.width, maxOverflow);
  });
  minOverflow = Math.abs(minOverflow);
  maxOverflow = Math.abs(maxOverflow);
  var totalOverFlow = minOverflow + maxOverflow;
  var oldRange = max3 - min3;
  var oldRangePercentOfNew = 1 - (minOverflow + maxOverflow) / axisLength;
  var overflowBuffer = oldRange / oldRangePercentOfNew - oldRange;
  max3 += overflowBuffer * (maxOverflow / totalOverFlow);
  min3 -= overflowBuffer * (minOverflow / totalOverFlow);
  return {
    min: min3,
    max: max3
  };
}
function niceScaleExtent(scale2, inModel) {
  var model = inModel;
  var extentInfo = getScaleExtent(scale2, model);
  var extent3 = extentInfo.extent;
  var splitNumber = model.get("splitNumber");
  if (scale2 instanceof LogScale$1) {
    scale2.base = model.get("logBase");
  }
  var scaleType = scale2.type;
  var interval = model.get("interval");
  var isIntervalOrTime = scaleType === "interval" || scaleType === "time";
  scale2.setExtent(extent3[0], extent3[1]);
  scale2.calcNiceExtent({
    splitNumber,
    fixMin: extentInfo.fixMin,
    fixMax: extentInfo.fixMax,
    minInterval: isIntervalOrTime ? model.get("minInterval") : null,
    maxInterval: isIntervalOrTime ? model.get("maxInterval") : null
  });
  if (interval != null) {
    scale2.setInterval && scale2.setInterval(interval);
  }
}
function createScaleByModel$1(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getOrdinalMeta ? model.getOrdinalMeta() : model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new (Scale$1.getClass(axisType) || IntervalScale$1)();
    }
  }
}
function ifAxisCrossZero(axis) {
  var dataExtent = axis.scale.getExtent();
  var min3 = dataExtent[0];
  var max3 = dataExtent[1];
  return !(min3 > 0 && max3 > 0 || min3 < 0 && max3 < 0);
}
function makeLabelFormatter(axis) {
  var labelFormatter = axis.getLabelModel().get("formatter");
  var categoryTickStart = axis.type === "category" ? axis.scale.getExtent()[0] : null;
  if (axis.scale.type === "time") {
    return function(tpl) {
      return function(tick, idx) {
        return axis.scale.getFormattedLabel(tick, idx, tpl);
      };
    }(labelFormatter);
  } else if (isString$1(labelFormatter)) {
    return function(tpl) {
      return function(tick) {
        var label = axis.scale.getLabel(tick);
        var text = tpl.replace("{value}", label != null ? label : "");
        return text;
      };
    }(labelFormatter);
  } else if (isFunction$1(labelFormatter)) {
    return function(cb2) {
      return function(tick, idx) {
        if (categoryTickStart != null) {
          idx = tick.value - categoryTickStart;
        }
        return cb2(getAxisRawValue(axis, tick), idx, tick.level != null ? {
          level: tick.level
        } : null);
      };
    }(labelFormatter);
  } else {
    return function(tick) {
      return axis.scale.getLabel(tick);
    };
  }
}
function getAxisRawValue(axis, tick) {
  return axis.type === "category" ? axis.scale.getLabel(tick) : tick.value;
}
function estimateLabelUnionRect(axis) {
  var axisModel = axis.model;
  var scale2 = axis.scale;
  if (!axisModel.get(["axisLabel", "show"]) || scale2.isBlank()) {
    return;
  }
  var realNumberScaleTicks;
  var tickCount;
  var categoryScaleExtent = scale2.getExtent();
  if (scale2 instanceof OrdinalScale$1) {
    tickCount = scale2.count();
  } else {
    realNumberScaleTicks = scale2.getTicks();
    tickCount = realNumberScaleTicks.length;
  }
  var axisLabelModel = axis.getLabelModel();
  var labelFormatter = makeLabelFormatter(axis);
  var rect;
  var step = 1;
  if (tickCount > 40) {
    step = Math.ceil(tickCount / 40);
  }
  for (var i = 0; i < tickCount; i += step) {
    var tick = realNumberScaleTicks ? realNumberScaleTicks[i] : {
      value: categoryScaleExtent[0] + i
    };
    var label = labelFormatter(tick, i);
    var unrotatedSingleRect = axisLabelModel.getTextRect(label);
    var singleRect = rotateTextRect(unrotatedSingleRect, axisLabelModel.get("rotate") || 0);
    rect ? rect.union(singleRect) : rect = singleRect;
  }
  return rect;
}
function rotateTextRect(textRect, rotate2) {
  var rotateRadians = rotate2 * Math.PI / 180;
  var beforeWidth = textRect.width;
  var beforeHeight = textRect.height;
  var afterWidth = beforeWidth * Math.abs(Math.cos(rotateRadians)) + Math.abs(beforeHeight * Math.sin(rotateRadians));
  var afterHeight = beforeWidth * Math.abs(Math.sin(rotateRadians)) + Math.abs(beforeHeight * Math.cos(rotateRadians));
  var rotatedRect = new BoundingRect$1(textRect.x, textRect.y, afterWidth, afterHeight);
  return rotatedRect;
}
function getOptionCategoryInterval(model) {
  var interval = model.get("interval");
  return interval == null ? "auto" : interval;
}
function shouldShowAllLabels(axis) {
  return axis.type === "category" && getOptionCategoryInterval(axis.getLabelModel()) === 0;
}
function getDataDimensionsOnAxis(data2, axisDim) {
  var dataDimMap = {};
  each$g(data2.mapDimensionsAll(axisDim), function(dataDim) {
    dataDimMap[getStackedDimension(data2, dataDim)] = true;
  });
  return keys(dataDimMap);
}
function unionAxisExtentFromData(dataExtent, data2, axisDim) {
  if (data2) {
    each$g(getDataDimensionsOnAxis(data2, axisDim), function(dim) {
      var seriesExtent = data2.getApproximateExtent(dim);
      seriesExtent[0] < dataExtent[0] && (dataExtent[0] = seriesExtent[0]);
      seriesExtent[1] > dataExtent[1] && (dataExtent[1] = seriesExtent[1]);
    });
  }
}
var AxisModelCommonMixin = function() {
  function AxisModelCommonMixin2() {
  }
  AxisModelCommonMixin2.prototype.getNeedCrossZero = function() {
    var option = this.option;
    return !option.scale;
  };
  AxisModelCommonMixin2.prototype.getCoordSysModel = function() {
    return;
  };
  return AxisModelCommonMixin2;
}();
var EPSILON = 1e-8;
function isAroundEqual(a, b2) {
  return Math.abs(a - b2) < EPSILON;
}
function contain(points2, x2, y2) {
  var w2 = 0;
  var p2 = points2[0];
  if (!p2) {
    return false;
  }
  for (var i = 1; i < points2.length; i++) {
    var p22 = points2[i];
    w2 += windingLine(p2[0], p2[1], p22[0], p22[1], x2, y2);
    p2 = p22;
  }
  var p0 = points2[0];
  if (!isAroundEqual(p2[0], p0[0]) || !isAroundEqual(p2[1], p0[1])) {
    w2 += windingLine(p2[0], p2[1], p0[0], p0[1], x2, y2);
  }
  return w2 !== 0;
}
var TMP_TRANSFORM = [];
function transformPoints(points2, transform2) {
  for (var p2 = 0; p2 < points2.length; p2++) {
    applyTransform$1(points2[p2], points2[p2], transform2);
  }
}
function updateBBoxFromPoints(points2, min3, max3, projection) {
  for (var i = 0; i < points2.length; i++) {
    var p2 = points2[i];
    if (projection) {
      p2 = projection.project(p2);
    }
    if (p2 && isFinite(p2[0]) && isFinite(p2[1])) {
      min$1(min3, min3, p2);
      max$1(max3, max3, p2);
    }
  }
}
function centroid$1(points2) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = points2.length;
  var x0 = points2[len2 - 1][0];
  var y0 = points2[len2 - 1][1];
  for (var i = 0; i < len2; i++) {
    var x1 = points2[i][0];
    var y1 = points2[i][1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
    x0 = x1;
    y0 = y1;
  }
  return signedArea ? [cx / signedArea / 3, cy / signedArea / 3, signedArea] : [points2[0][0] || 0, points2[0][1] || 0];
}
var Region = function() {
  function Region2(name2) {
    this.name = name2;
  }
  Region2.prototype.setCenter = function(center2) {
    this._center = center2;
  };
  Region2.prototype.getCenter = function() {
    var center2 = this._center;
    if (!center2) {
      center2 = this._center = this.calcCenter();
    }
    return center2;
  };
  return Region2;
}();
var GeoJSONPolygonGeometry = function() {
  function GeoJSONPolygonGeometry2(exterior, interiors) {
    this.type = "polygon";
    this.exterior = exterior;
    this.interiors = interiors;
  }
  return GeoJSONPolygonGeometry2;
}();
var GeoJSONLineStringGeometry = function() {
  function GeoJSONLineStringGeometry2(points2) {
    this.type = "linestring";
    this.points = points2;
  }
  return GeoJSONLineStringGeometry2;
}();
var GeoJSONRegion = function(_super) {
  __extends(GeoJSONRegion2, _super);
  function GeoJSONRegion2(name2, geometries, cp) {
    var _this = _super.call(this, name2) || this;
    _this.type = "geoJSON";
    _this.geometries = geometries;
    _this._center = cp && [cp[0], cp[1]];
    return _this;
  }
  GeoJSONRegion2.prototype.calcCenter = function() {
    var geometries = this.geometries;
    var largestGeo;
    var largestGeoSize = 0;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      var exterior = geo.exterior;
      var size = exterior && exterior.length;
      if (size > largestGeoSize) {
        largestGeo = geo;
        largestGeoSize = size;
      }
    }
    if (largestGeo) {
      return centroid$1(largestGeo.exterior);
    }
    var rect = this.getBoundingRect();
    return [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.getBoundingRect = function(projection) {
    var rect = this._rect;
    if (rect && !projection) {
      return rect;
    }
    var min3 = [Infinity, Infinity];
    var max3 = [-Infinity, -Infinity];
    var geometries = this.geometries;
    each$g(geometries, function(geo) {
      if (geo.type === "polygon") {
        updateBBoxFromPoints(geo.exterior, min3, max3, projection);
      } else {
        each$g(geo.points, function(points2) {
          updateBBoxFromPoints(points2, min3, max3, projection);
        });
      }
    });
    if (!(isFinite(min3[0]) && isFinite(min3[1]) && isFinite(max3[0]) && isFinite(max3[1]))) {
      min3[0] = min3[1] = max3[0] = max3[1] = 0;
    }
    rect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    if (!projection) {
      this._rect = rect;
    }
    return rect;
  };
  GeoJSONRegion2.prototype.contain = function(coord) {
    var rect = this.getBoundingRect();
    var geometries = this.geometries;
    if (!rect.contain(coord[0], coord[1])) {
      return false;
    }
    loopGeo:
      for (var i = 0, len2 = geometries.length; i < len2; i++) {
        var geo = geometries[i];
        if (geo.type !== "polygon") {
          continue;
        }
        var exterior = geo.exterior;
        var interiors = geo.interiors;
        if (contain(exterior, coord[0], coord[1])) {
          for (var k2 = 0; k2 < (interiors ? interiors.length : 0); k2++) {
            if (contain(interiors[k2], coord[0], coord[1])) {
              continue loopGeo;
            }
          }
          return true;
        }
      }
    return false;
  };
  GeoJSONRegion2.prototype.transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var aspect = rect.width / rect.height;
    if (!width) {
      width = aspect * height;
    } else if (!height) {
      height = width / aspect;
    }
    var target = new BoundingRect$1(x2, y2, width, height);
    var transform2 = rect.calculateTransform(target);
    var geometries = this.geometries;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      if (geo.type === "polygon") {
        transformPoints(geo.exterior, transform2);
        each$g(geo.interiors, function(interior) {
          transformPoints(interior, transform2);
        });
      } else {
        each$g(geo.points, function(points2) {
          transformPoints(points2, transform2);
        });
      }
    }
    rect = this._rect;
    rect.copy(target);
    this._center = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.cloneShallow = function(name2) {
    name2 == null && (name2 = this.name);
    var newRegion = new GeoJSONRegion2(name2, this.geometries, this._center);
    newRegion._rect = this._rect;
    newRegion.transformTo = null;
    return newRegion;
  };
  return GeoJSONRegion2;
}(Region);
var GeoSVGRegion = function(_super) {
  __extends(GeoSVGRegion2, _super);
  function GeoSVGRegion2(name2, elOnlyForCalculate) {
    var _this = _super.call(this, name2) || this;
    _this.type = "geoSVG";
    _this._elOnlyForCalculate = elOnlyForCalculate;
    return _this;
  }
  GeoSVGRegion2.prototype.calcCenter = function() {
    var el = this._elOnlyForCalculate;
    var rect = el.getBoundingRect();
    var center2 = [rect.x + rect.width / 2, rect.y + rect.height / 2];
    var mat = identity(TMP_TRANSFORM);
    var target = el;
    while (target && !target.isGeoSVGGraphicRoot) {
      mul(mat, target.getLocalTransform(), mat);
      target = target.parent;
    }
    invert(mat, mat);
    applyTransform$1(center2, center2, mat);
    return center2;
  };
  return GeoSVGRegion2;
}(Region);
function decode(json) {
  if (!json.UTF8Encoding) {
    return json;
  }
  var jsonCompressed = json;
  var encodeScale = jsonCompressed.UTF8Scale;
  if (encodeScale == null) {
    encodeScale = 1024;
  }
  var features2 = jsonCompressed.features;
  each$g(features2, function(feature) {
    var geometry = feature.geometry;
    var encodeOffsets = geometry.encodeOffsets;
    var coordinates = geometry.coordinates;
    if (!encodeOffsets) {
      return;
    }
    switch (geometry.type) {
      case "LineString":
        geometry.coordinates = decodeRing(coordinates, encodeOffsets, encodeScale);
        break;
      case "Polygon":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiLineString":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiPolygon":
        each$g(coordinates, function(rings, idx) {
          return decodeRings(rings, encodeOffsets[idx], encodeScale);
        });
    }
  });
  jsonCompressed.UTF8Encoding = false;
  return jsonCompressed;
}
function decodeRings(rings, encodeOffsets, encodeScale) {
  for (var c2 = 0; c2 < rings.length; c2++) {
    rings[c2] = decodeRing(rings[c2], encodeOffsets[c2], encodeScale);
  }
}
function decodeRing(coordinate, encodeOffsets, encodeScale) {
  var result = [];
  var prevX = encodeOffsets[0];
  var prevY = encodeOffsets[1];
  for (var i = 0; i < coordinate.length; i += 2) {
    var x2 = coordinate.charCodeAt(i) - 64;
    var y2 = coordinate.charCodeAt(i + 1) - 64;
    x2 = x2 >> 1 ^ -(x2 & 1);
    y2 = y2 >> 1 ^ -(y2 & 1);
    x2 += prevX;
    y2 += prevY;
    prevX = x2;
    prevY = y2;
    result.push([x2 / encodeScale, y2 / encodeScale]);
  }
  return result;
}
function parseGeoJSON(geoJson, nameProperty) {
  geoJson = decode(geoJson);
  return map$1(filter(geoJson.features, function(featureObj) {
    return featureObj.geometry && featureObj.properties && featureObj.geometry.coordinates.length > 0;
  }), function(featureObj) {
    var properties = featureObj.properties;
    var geo = featureObj.geometry;
    var geometries = [];
    switch (geo.type) {
      case "Polygon":
        var coordinates = geo.coordinates;
        geometries.push(new GeoJSONPolygonGeometry(coordinates[0], coordinates.slice(1)));
        break;
      case "MultiPolygon":
        each$g(geo.coordinates, function(item) {
          if (item[0]) {
            geometries.push(new GeoJSONPolygonGeometry(item[0], item.slice(1)));
          }
        });
        break;
      case "LineString":
        geometries.push(new GeoJSONLineStringGeometry([geo.coordinates]));
        break;
      case "MultiLineString":
        geometries.push(new GeoJSONLineStringGeometry(geo.coordinates));
    }
    var region = new GeoJSONRegion(properties[nameProperty || "name"], geometries, properties.cp);
    region.properties = properties;
    return region;
  });
}
var inner$g = makeInner();
function createAxisLabels(axis) {
  return axis.type === "category" ? makeCategoryLabels(axis) : makeRealNumberLabels(axis);
}
function createAxisTicks(axis, tickModel) {
  return axis.type === "category" ? makeCategoryTicks(axis, tickModel) : {
    ticks: map$1(axis.scale.getTicks(), function(tick) {
      return tick.value;
    })
  };
}
function makeCategoryLabels(axis) {
  var labelModel = axis.getLabelModel();
  var result = makeCategoryLabelsActually(axis, labelModel);
  return !labelModel.get("show") || axis.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: result.labelCategoryInterval
  } : result;
}
function makeCategoryLabelsActually(axis, labelModel) {
  var labelsCache = getListCache(axis, "labels");
  var optionLabelInterval = getOptionCategoryInterval(labelModel);
  var result = listCacheGet(labelsCache, optionLabelInterval);
  if (result) {
    return result;
  }
  var labels;
  var numericLabelInterval;
  if (isFunction$1(optionLabelInterval)) {
    labels = makeLabelsByCustomizedCategoryInterval(axis, optionLabelInterval);
  } else {
    numericLabelInterval = optionLabelInterval === "auto" ? makeAutoCategoryInterval(axis) : optionLabelInterval;
    labels = makeLabelsByNumericCategoryInterval(axis, numericLabelInterval);
  }
  return listCacheSet(labelsCache, optionLabelInterval, {
    labels,
    labelCategoryInterval: numericLabelInterval
  });
}
function makeCategoryTicks(axis, tickModel) {
  var ticksCache = getListCache(axis, "ticks");
  var optionTickInterval = getOptionCategoryInterval(tickModel);
  var result = listCacheGet(ticksCache, optionTickInterval);
  if (result) {
    return result;
  }
  var ticks;
  var tickCategoryInterval;
  if (!tickModel.get("show") || axis.scale.isBlank()) {
    ticks = [];
  }
  if (isFunction$1(optionTickInterval)) {
    ticks = makeLabelsByCustomizedCategoryInterval(axis, optionTickInterval, true);
  } else if (optionTickInterval === "auto") {
    var labelsResult = makeCategoryLabelsActually(axis, axis.getLabelModel());
    tickCategoryInterval = labelsResult.labelCategoryInterval;
    ticks = map$1(labelsResult.labels, function(labelItem) {
      return labelItem.tickValue;
    });
  } else {
    tickCategoryInterval = optionTickInterval;
    ticks = makeLabelsByNumericCategoryInterval(axis, tickCategoryInterval, true);
  }
  return listCacheSet(ticksCache, optionTickInterval, {
    ticks,
    tickCategoryInterval
  });
}
function makeRealNumberLabels(axis) {
  var ticks = axis.scale.getTicks();
  var labelFormatter = makeLabelFormatter(axis);
  return {
    labels: map$1(ticks, function(tick, idx) {
      return {
        level: tick.level,
        formattedLabel: labelFormatter(tick, idx),
        rawLabel: axis.scale.getLabel(tick),
        tickValue: tick.value
      };
    })
  };
}
function getListCache(axis, prop) {
  return inner$g(axis)[prop] || (inner$g(axis)[prop] = []);
}
function listCacheGet(cache, key) {
  for (var i = 0; i < cache.length; i++) {
    if (cache[i].key === key) {
      return cache[i].value;
    }
  }
}
function listCacheSet(cache, key, value) {
  cache.push({
    key,
    value
  });
  return value;
}
function makeAutoCategoryInterval(axis) {
  var result = inner$g(axis).autoInterval;
  return result != null ? result : inner$g(axis).autoInterval = axis.calculateCategoryInterval();
}
function calculateCategoryInterval(axis) {
  var params = fetchAutoCategoryIntervalCalculationParams(axis);
  var labelFormatter = makeLabelFormatter(axis);
  var rotation = (params.axisRotate - params.labelRotate) / 180 * Math.PI;
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var tickCount = ordinalScale.count();
  if (ordinalExtent[1] - ordinalExtent[0] < 1) {
    return 0;
  }
  var step = 1;
  if (tickCount > 40) {
    step = Math.max(1, Math.floor(tickCount / 40));
  }
  var tickValue = ordinalExtent[0];
  var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
  var unitW = Math.abs(unitSpan * Math.cos(rotation));
  var unitH = Math.abs(unitSpan * Math.sin(rotation));
  var maxW = 0;
  var maxH = 0;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    var width = 0;
    var height = 0;
    var rect = getBoundingRect(labelFormatter({
      value: tickValue
    }), params.font, "center", "top");
    width = rect.width * 1.3;
    height = rect.height * 1.3;
    maxW = Math.max(maxW, width, 7);
    maxH = Math.max(maxH, height, 7);
  }
  var dw = maxW / unitW;
  var dh2 = maxH / unitH;
  isNaN(dw) && (dw = Infinity);
  isNaN(dh2) && (dh2 = Infinity);
  var interval = Math.max(0, Math.floor(Math.min(dw, dh2)));
  var cache = inner$g(axis.model);
  var axisExtent = axis.getExtent();
  var lastAutoInterval = cache.lastAutoInterval;
  var lastTickCount = cache.lastTickCount;
  if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval && cache.axisExtent0 === axisExtent[0] && cache.axisExtent1 === axisExtent[1]) {
    interval = lastAutoInterval;
  } else {
    cache.lastTickCount = tickCount;
    cache.lastAutoInterval = interval;
    cache.axisExtent0 = axisExtent[0];
    cache.axisExtent1 = axisExtent[1];
  }
  return interval;
}
function fetchAutoCategoryIntervalCalculationParams(axis) {
  var labelModel = axis.getLabelModel();
  return {
    axisRotate: axis.getRotate ? axis.getRotate() : axis.isHorizontal && !axis.isHorizontal() ? 90 : 0,
    labelRotate: labelModel.get("rotate") || 0,
    font: labelModel.getFont()
  };
}
function makeLabelsByNumericCategoryInterval(axis, categoryInterval, onlyTick) {
  var labelFormatter = makeLabelFormatter(axis);
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var labelModel = axis.getLabelModel();
  var result = [];
  var step = Math.max((categoryInterval || 0) + 1, 1);
  var startTick = ordinalExtent[0];
  var tickCount = ordinalScale.count();
  if (startTick !== 0 && step > 1 && tickCount / step > 2) {
    startTick = Math.round(Math.ceil(startTick / step) * step);
  }
  var showAllLabel = shouldShowAllLabels(axis);
  var includeMinLabel = labelModel.get("showMinLabel") || showAllLabel;
  var includeMaxLabel = labelModel.get("showMaxLabel") || showAllLabel;
  if (includeMinLabel && startTick !== ordinalExtent[0]) {
    addItem(ordinalExtent[0]);
  }
  var tickValue = startTick;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    addItem(tickValue);
  }
  if (includeMaxLabel && tickValue - step !== ordinalExtent[1]) {
    addItem(ordinalExtent[1]);
  }
  function addItem(tickValue2) {
    var tickObj = {
      value: tickValue2
    };
    result.push(onlyTick ? tickValue2 : {
      formattedLabel: labelFormatter(tickObj),
      rawLabel: ordinalScale.getLabel(tickObj),
      tickValue: tickValue2
    });
  }
  return result;
}
function makeLabelsByCustomizedCategoryInterval(axis, categoryInterval, onlyTick) {
  var ordinalScale = axis.scale;
  var labelFormatter = makeLabelFormatter(axis);
  var result = [];
  each$g(ordinalScale.getTicks(), function(tick) {
    var rawLabel = ordinalScale.getLabel(tick);
    var tickValue = tick.value;
    if (categoryInterval(tick.value, rawLabel)) {
      result.push(onlyTick ? tickValue : {
        formattedLabel: labelFormatter(tick),
        rawLabel,
        tickValue
      });
    }
  });
  return result;
}
var NORMALIZED_EXTENT = [0, 1];
var Axis = function() {
  function Axis2(dim, scale2, extent3) {
    this.onBand = false;
    this.inverse = false;
    this.dim = dim;
    this.scale = scale2;
    this._extent = extent3 || [0, 0];
  }
  Axis2.prototype.contain = function(coord) {
    var extent3 = this._extent;
    var min3 = Math.min(extent3[0], extent3[1]);
    var max3 = Math.max(extent3[0], extent3[1]);
    return coord >= min3 && coord <= max3;
  };
  Axis2.prototype.containData = function(data2) {
    return this.scale.contain(data2);
  };
  Axis2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Axis2.prototype.getPixelPrecision = function(dataExtent) {
    return getPixelPrecision(dataExtent || this.scale.getExtent(), this._extent);
  };
  Axis2.prototype.setExtent = function(start2, end2) {
    var extent3 = this._extent;
    extent3[0] = start2;
    extent3[1] = end2;
  };
  Axis2.prototype.dataToCoord = function(data2, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    data2 = scale2.normalize(data2);
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    return linearMap$2(data2, NORMALIZED_EXTENT, extent3, clamp2);
  };
  Axis2.prototype.coordToData = function(coord, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    var t2 = linearMap$2(coord, extent3, NORMALIZED_EXTENT, clamp2);
    return this.scale.scale(t2);
  };
  Axis2.prototype.pointToData = function(point, clamp2) {
    return;
  };
  Axis2.prototype.getTicksCoords = function(opt) {
    opt = opt || {};
    var tickModel = opt.tickModel || this.getTickModel();
    var result = createAxisTicks(this, tickModel);
    var ticks = result.ticks;
    var ticksCoords = map$1(ticks, function(tickVal) {
      return {
        coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(tickVal) : tickVal),
        tickValue: tickVal
      };
    }, this);
    var alignWithLabel = tickModel.get("alignWithLabel");
    fixOnBandTicksCoords(this, ticksCoords, alignWithLabel, opt.clamp);
    return ticksCoords;
  };
  Axis2.prototype.getMinorTicksCoords = function() {
    if (this.scale.type === "ordinal") {
      return [];
    }
    var minorTickModel = this.model.getModel("minorTick");
    var splitNumber = minorTickModel.get("splitNumber");
    if (!(splitNumber > 0 && splitNumber < 100)) {
      splitNumber = 5;
    }
    var minorTicks = this.scale.getMinorTicks(splitNumber);
    var minorTicksCoords = map$1(minorTicks, function(minorTicksGroup) {
      return map$1(minorTicksGroup, function(minorTick) {
        return {
          coord: this.dataToCoord(minorTick),
          tickValue: minorTick
        };
      }, this);
    }, this);
    return minorTicksCoords;
  };
  Axis2.prototype.getViewLabels = function() {
    return createAxisLabels(this).labels;
  };
  Axis2.prototype.getLabelModel = function() {
    return this.model.getModel("axisLabel");
  };
  Axis2.prototype.getTickModel = function() {
    return this.model.getModel("axisTick");
  };
  Axis2.prototype.getBandWidth = function() {
    var axisExtent = this._extent;
    var dataExtent = this.scale.getExtent();
    var len2 = dataExtent[1] - dataExtent[0] + (this.onBand ? 1 : 0);
    len2 === 0 && (len2 = 1);
    var size = Math.abs(axisExtent[1] - axisExtent[0]);
    return Math.abs(size) / len2;
  };
  Axis2.prototype.calculateCategoryInterval = function() {
    return calculateCategoryInterval(this);
  };
  return Axis2;
}();
function fixExtentWithBands(extent3, nTick) {
  var size = extent3[1] - extent3[0];
  var len2 = nTick;
  var margin = size / len2 / 2;
  extent3[0] += margin;
  extent3[1] -= margin;
}
function fixOnBandTicksCoords(axis, ticksCoords, alignWithLabel, clamp2) {
  var ticksLen = ticksCoords.length;
  if (!axis.onBand || alignWithLabel || !ticksLen) {
    return;
  }
  var axisExtent = axis.getExtent();
  var last;
  var diffSize;
  if (ticksLen === 1) {
    ticksCoords[0].coord = axisExtent[0];
    last = ticksCoords[1] = {
      coord: axisExtent[0]
    };
  } else {
    var crossLen = ticksCoords[ticksLen - 1].tickValue - ticksCoords[0].tickValue;
    var shift_1 = (ticksCoords[ticksLen - 1].coord - ticksCoords[0].coord) / crossLen;
    each$g(ticksCoords, function(ticksItem) {
      ticksItem.coord -= shift_1 / 2;
    });
    var dataExtent = axis.scale.getExtent();
    diffSize = 1 + dataExtent[1] - ticksCoords[ticksLen - 1].tickValue;
    last = {
      coord: ticksCoords[ticksLen - 1].coord + shift_1 * diffSize
    };
    ticksCoords.push(last);
  }
  var inverse = axisExtent[0] > axisExtent[1];
  if (littleThan2(ticksCoords[0].coord, axisExtent[0])) {
    clamp2 ? ticksCoords[0].coord = axisExtent[0] : ticksCoords.shift();
  }
  if (clamp2 && littleThan2(axisExtent[0], ticksCoords[0].coord)) {
    ticksCoords.unshift({
      coord: axisExtent[0]
    });
  }
  if (littleThan2(axisExtent[1], last.coord)) {
    clamp2 ? last.coord = axisExtent[1] : ticksCoords.pop();
  }
  if (clamp2 && littleThan2(last.coord, axisExtent[1])) {
    ticksCoords.push({
      coord: axisExtent[1]
    });
  }
  function littleThan2(a, b2) {
    a = round$3(a);
    b2 = round$3(b2);
    return inverse ? a > b2 : a < b2;
  }
}
var Axis$1 = Axis;
var PI2$3 = Math.PI * 2;
var CMD$1 = PathProxy$1.CMD;
var DEFAULT_SEARCH_SPACE = ["top", "right", "bottom", "left"];
function getCandidateAnchor(pos, distance2, rect, outPt, outDir) {
  var width = rect.width;
  var height = rect.height;
  switch (pos) {
    case "top":
      outPt.set(rect.x + width / 2, rect.y - distance2);
      outDir.set(0, -1);
      break;
    case "bottom":
      outPt.set(rect.x + width / 2, rect.y + height + distance2);
      outDir.set(0, 1);
      break;
    case "left":
      outPt.set(rect.x - distance2, rect.y + height / 2);
      outDir.set(-1, 0);
      break;
    case "right":
      outPt.set(rect.x + width + distance2, rect.y + height / 2);
      outDir.set(1, 0);
      break;
  }
}
function projectPointToArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2, out2) {
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  x2 /= d2;
  y2 /= d2;
  var ox = x2 * r2 + cx;
  var oy = y2 * r2 + cy;
  if (Math.abs(startAngle - endAngle) % PI2$3 < 1e-4) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$3;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$3;
  }
  if (angle >= startAngle && angle <= endAngle || angle + PI2$3 >= startAngle && angle + PI2$3 <= endAngle) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  var x1 = r2 * Math.cos(startAngle) + cx;
  var y1 = r2 * Math.sin(startAngle) + cy;
  var x22 = r2 * Math.cos(endAngle) + cx;
  var y22 = r2 * Math.sin(endAngle) + cy;
  var d1 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  var d22 = (x22 - x2) * (x22 - x2) + (y22 - y2) * (y22 - y2);
  if (d1 < d22) {
    out2[0] = x1;
    out2[1] = y1;
    return Math.sqrt(d1);
  } else {
    out2[0] = x22;
    out2[1] = y22;
    return Math.sqrt(d22);
  }
}
function projectPointToLine(x1, y1, x2, y2, x3, y3, out2, limitToEnds) {
  var dx = x3 - x1;
  var dy = y3 - y1;
  var dx1 = x2 - x1;
  var dy1 = y2 - y1;
  var lineLen = Math.sqrt(dx1 * dx1 + dy1 * dy1);
  dx1 /= lineLen;
  dy1 /= lineLen;
  var projectedLen = dx * dx1 + dy * dy1;
  var t2 = projectedLen / lineLen;
  if (limitToEnds) {
    t2 = Math.min(Math.max(t2, 0), 1);
  }
  t2 *= lineLen;
  var ox = out2[0] = x1 + t2 * dx1;
  var oy = out2[1] = y1 + t2 * dy1;
  return Math.sqrt((ox - x3) * (ox - x3) + (oy - y3) * (oy - y3));
}
function projectPointToRect(x1, y1, width, height, x2, y2, out2) {
  if (width < 0) {
    x1 = x1 + width;
    width = -width;
  }
  if (height < 0) {
    y1 = y1 + height;
    height = -height;
  }
  var x22 = x1 + width;
  var y22 = y1 + height;
  var ox = out2[0] = Math.min(Math.max(x2, x1), x22);
  var oy = out2[1] = Math.min(Math.max(y2, y1), y22);
  return Math.sqrt((ox - x2) * (ox - x2) + (oy - y2) * (oy - y2));
}
var tmpPt = [];
function nearestPointOnRect(pt, rect, out2) {
  var dist2 = projectPointToRect(rect.x, rect.y, rect.width, rect.height, pt.x, pt.y, tmpPt);
  out2.set(tmpPt[0], tmpPt[1]);
  return dist2;
}
function nearestPointOnPath(pt, path, out2) {
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  var minDist = Infinity;
  var data2 = path.data;
  var x2 = pt.x;
  var y2 = pt.y;
  for (var i = 0; i < data2.length; ) {
    var cmd = data2[i++];
    if (i === 1) {
      xi2 = data2[i];
      yi2 = data2[i + 1];
      x0 = xi2;
      y0 = yi2;
    }
    var d2 = minDist;
    switch (cmd) {
      case CMD$1.M:
        x0 = data2[i++];
        y0 = data2[i++];
        xi2 = x0;
        yi2 = y0;
        break;
      case CMD$1.L:
        d2 = projectPointToLine(xi2, yi2, data2[i], data2[i + 1], x2, y2, tmpPt, true);
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$1.C:
        d2 = cubicProjectPoint(xi2, yi2, data2[i++], data2[i++], data2[i++], data2[i++], data2[i], data2[i + 1], x2, y2, tmpPt);
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$1.Q:
        d2 = quadraticProjectPoint(xi2, yi2, data2[i++], data2[i++], data2[i], data2[i + 1], x2, y2, tmpPt);
        xi2 = data2[i++];
        yi2 = data2[i++];
        break;
      case CMD$1.A:
        var cx = data2[i++];
        var cy = data2[i++];
        var rx = data2[i++];
        var ry = data2[i++];
        var theta = data2[i++];
        var dTheta = data2[i++];
        i += 1;
        var anticlockwise = !!(1 - data2[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (i <= 1) {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        d2 = projectPointToArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2, tmpPt);
        xi2 = Math.cos(theta + dTheta) * rx + cx;
        yi2 = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$1.R:
        x0 = xi2 = data2[i++];
        y0 = yi2 = data2[i++];
        var width = data2[i++];
        var height = data2[i++];
        d2 = projectPointToRect(x0, y0, width, height, x2, y2, tmpPt);
        break;
      case CMD$1.Z:
        d2 = projectPointToLine(xi2, yi2, x0, y0, x2, y2, tmpPt, true);
        xi2 = x0;
        yi2 = y0;
        break;
    }
    if (d2 < minDist) {
      minDist = d2;
      out2.set(tmpPt[0], tmpPt[1]);
    }
  }
  return minDist;
}
var pt0 = new Point$1();
var pt1 = new Point$1();
var pt2 = new Point$1();
var dir = new Point$1();
var dir2 = new Point$1();
function updateLabelLinePoints(target, labelLineModel) {
  if (!target) {
    return;
  }
  var labelLine = target.getTextGuideLine();
  var label = target.getTextContent();
  if (!(label && labelLine)) {
    return;
  }
  var labelGuideConfig = target.textGuideLineConfig || {};
  var points2 = [[0, 0], [0, 0], [0, 0]];
  var searchSpace = labelGuideConfig.candidates || DEFAULT_SEARCH_SPACE;
  var labelRect = label.getBoundingRect().clone();
  labelRect.applyTransform(label.getComputedTransform());
  var minDist = Infinity;
  var anchorPoint = labelGuideConfig.anchor;
  var targetTransform = target.getComputedTransform();
  var targetInversedTransform = targetTransform && invert([], targetTransform);
  var len2 = labelLineModel.get("length2") || 0;
  if (anchorPoint) {
    pt2.copy(anchorPoint);
  }
  for (var i = 0; i < searchSpace.length; i++) {
    var candidate = searchSpace[i];
    getCandidateAnchor(candidate, 0, labelRect, pt0, dir);
    Point$1.scaleAndAdd(pt1, pt0, dir, len2);
    pt1.transform(targetInversedTransform);
    var boundingRect = target.getBoundingRect();
    var dist2 = anchorPoint ? anchorPoint.distance(pt1) : target instanceof Path$1 ? nearestPointOnPath(pt1, target.path, pt2) : nearestPointOnRect(pt1, boundingRect, pt2);
    if (dist2 < minDist) {
      minDist = dist2;
      pt1.transform(targetTransform);
      pt2.transform(targetTransform);
      pt2.toArray(points2[0]);
      pt1.toArray(points2[1]);
      pt0.toArray(points2[2]);
    }
  }
  limitTurnAngle(points2, labelLineModel.get("minTurnAngle"));
  labelLine.setShape({
    points: points2
  });
}
var tmpArr = [];
var tmpProjPoint = new Point$1();
function limitTurnAngle(linePoints, minTurnAngle) {
  if (!(minTurnAngle <= 180 && minTurnAngle > 0)) {
    return;
  }
  minTurnAngle = minTurnAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt0, pt1);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(dir2);
  var minTurnAngleCos = Math.cos(minTurnAngle);
  if (minTurnAngleCos < angleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI - minTurnAngle));
    var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
    if (isNaN(t2)) {
      return;
    }
    if (t2 < 0) {
      Point$1.copy(tmpProjPoint, pt1);
    } else if (t2 > 1) {
      Point$1.copy(tmpProjPoint, pt2);
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function limitSurfaceAngle(linePoints, surfaceNormal, maxSurfaceAngle) {
  if (!(maxSurfaceAngle <= 180 && maxSurfaceAngle > 0)) {
    return;
  }
  maxSurfaceAngle = maxSurfaceAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt1, pt0);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(surfaceNormal);
  var maxSurfaceAngleCos = Math.cos(maxSurfaceAngle);
  if (angleCos < maxSurfaceAngleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    var HALF_PI = Math.PI / 2;
    var angle2 = Math.acos(dir2.dot(surfaceNormal));
    var newAngle = HALF_PI + angle2 - maxSurfaceAngle;
    if (newAngle >= HALF_PI) {
      Point$1.copy(tmpProjPoint, pt2);
    } else {
      tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI / 2 - newAngle));
      var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
      if (isNaN(t2)) {
        return;
      }
      if (t2 < 0) {
        Point$1.copy(tmpProjPoint, pt1);
      } else if (t2 > 1) {
        Point$1.copy(tmpProjPoint, pt2);
      }
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function setLabelLineState(labelLine, ignore, stateName, stateModel) {
  var isNormal = stateName === "normal";
  var stateObj = isNormal ? labelLine : labelLine.ensureState(stateName);
  stateObj.ignore = ignore;
  var smooth = stateModel.get("smooth");
  if (smooth && smooth === true) {
    smooth = 0.3;
  }
  stateObj.shape = stateObj.shape || {};
  if (smooth > 0) {
    stateObj.shape.smooth = smooth;
  }
  var styleObj = stateModel.getModel("lineStyle").getLineStyle();
  isNormal ? labelLine.useStyle(styleObj) : stateObj.style = styleObj;
}
function buildLabelLinePath(path, shape) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (!points2) {
    return;
  }
  path.moveTo(points2[0][0], points2[0][1]);
  if (smooth > 0 && points2.length >= 3) {
    var len1 = dist$1(points2[0], points2[1]);
    var len2 = dist$1(points2[1], points2[2]);
    if (!len1 || !len2) {
      path.lineTo(points2[1][0], points2[1][1]);
      path.lineTo(points2[2][0], points2[2][1]);
      return;
    }
    var moveLen = Math.min(len1, len2) * smooth;
    var midPoint0 = lerp$1([], points2[1], points2[0], moveLen / len1);
    var midPoint2 = lerp$1([], points2[1], points2[2], moveLen / len2);
    var midPoint1 = lerp$1([], midPoint0, midPoint2, 0.5);
    path.bezierCurveTo(midPoint0[0], midPoint0[1], midPoint0[0], midPoint0[1], midPoint1[0], midPoint1[1]);
    path.bezierCurveTo(midPoint2[0], midPoint2[1], midPoint2[0], midPoint2[1], points2[2][0], points2[2][1]);
  } else {
    for (var i = 1; i < points2.length; i++) {
      path.lineTo(points2[i][0], points2[i][1]);
    }
  }
}
function setLabelLineStyle(targetEl, statesModels, defaultStyle) {
  var labelLine = targetEl.getTextGuideLine();
  var label = targetEl.getTextContent();
  if (!label) {
    if (labelLine) {
      targetEl.removeTextGuideLine();
    }
    return;
  }
  var normalModel = statesModels.normal;
  var showNormal = normalModel.get("show");
  var labelIgnoreNormal = label.ignore;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateName = DISPLAY_STATES[i];
    var stateModel = statesModels[stateName];
    var isNormal = stateName === "normal";
    if (stateModel) {
      var stateShow = stateModel.get("show");
      var isLabelIgnored = isNormal ? labelIgnoreNormal : retrieve2(label.states[stateName] && label.states[stateName].ignore, labelIgnoreNormal);
      if (isLabelIgnored || !retrieve2(stateShow, showNormal)) {
        var stateObj = isNormal ? labelLine : labelLine && labelLine.states.normal;
        if (stateObj) {
          stateObj.ignore = true;
        }
        continue;
      }
      if (!labelLine) {
        labelLine = new Polyline$3();
        targetEl.setTextGuideLine(labelLine);
        if (!isNormal && (labelIgnoreNormal || !showNormal)) {
          setLabelLineState(labelLine, true, "normal", statesModels.normal);
        }
        if (targetEl.stateProxy) {
          labelLine.stateProxy = targetEl.stateProxy;
        }
      }
      setLabelLineState(labelLine, false, stateName, stateModel);
    }
  }
  if (labelLine) {
    defaults(labelLine.style, defaultStyle);
    labelLine.style.fill = null;
    var showAbove = normalModel.get("showAbove");
    var labelLineConfig = targetEl.textGuideLineConfig = targetEl.textGuideLineConfig || {};
    labelLineConfig.showAbove = showAbove || false;
    labelLine.buildPath = buildLabelLinePath;
  }
}
function getLabelLineStatesModels(itemModel, labelLineName) {
  labelLineName = labelLineName || "labelLine";
  var statesModels = {
    normal: itemModel.getModel(labelLineName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelLineName]);
  }
  return statesModels;
}
function prepareLayoutList(input) {
  var list = [];
  for (var i = 0; i < input.length; i++) {
    var rawItem = input[i];
    if (rawItem.defaultAttr.ignore) {
      continue;
    }
    var label = rawItem.label;
    var transform2 = label.getComputedTransform();
    var localRect = label.getBoundingRect();
    var isAxisAligned = !transform2 || transform2[1] < 1e-5 && transform2[2] < 1e-5;
    var minMargin = label.style.margin || 0;
    var globalRect = localRect.clone();
    globalRect.applyTransform(transform2);
    globalRect.x -= minMargin / 2;
    globalRect.y -= minMargin / 2;
    globalRect.width += minMargin;
    globalRect.height += minMargin;
    var obb = isAxisAligned ? new OrientedBoundingRect$1(localRect, transform2) : null;
    list.push({
      label,
      labelLine: rawItem.labelLine,
      rect: globalRect,
      localRect,
      obb,
      priority: rawItem.priority,
      defaultAttr: rawItem.defaultAttr,
      layoutOption: rawItem.computedLayoutOption,
      axisAligned: isAxisAligned,
      transform: transform2
    });
  }
  return list;
}
function shiftLayout(list, xyDim, sizeDim, minBound, maxBound, balanceShift) {
  var len2 = list.length;
  if (len2 < 2) {
    return;
  }
  list.sort(function(a, b2) {
    return a.rect[xyDim] - b2.rect[xyDim];
  });
  var lastPos = 0;
  var delta;
  var adjusted = false;
  var totalShifts = 0;
  for (var i = 0; i < len2; i++) {
    var item = list[i];
    var rect = item.rect;
    delta = rect[xyDim] - lastPos;
    if (delta < 0) {
      rect[xyDim] -= delta;
      item.label[xyDim] -= delta;
      adjusted = true;
    }
    var shift = Math.max(-delta, 0);
    totalShifts += shift;
    lastPos = rect[xyDim] + rect[sizeDim];
  }
  if (totalShifts > 0 && balanceShift) {
    shiftList(-totalShifts / len2, 0, len2);
  }
  var first = list[0];
  var last = list[len2 - 1];
  var minGap;
  var maxGap;
  updateMinMaxGap();
  minGap < 0 && squeezeGaps(-minGap, 0.8);
  maxGap < 0 && squeezeGaps(maxGap, 0.8);
  updateMinMaxGap();
  takeBoundsGap(minGap, maxGap, 1);
  takeBoundsGap(maxGap, minGap, -1);
  updateMinMaxGap();
  if (minGap < 0) {
    squeezeWhenBailout(-minGap);
  }
  if (maxGap < 0) {
    squeezeWhenBailout(maxGap);
  }
  function updateMinMaxGap() {
    minGap = first.rect[xyDim] - minBound;
    maxGap = maxBound - last.rect[xyDim] - last.rect[sizeDim];
  }
  function takeBoundsGap(gapThisBound, gapOtherBound, moveDir) {
    if (gapThisBound < 0) {
      var moveFromMaxGap = Math.min(gapOtherBound, -gapThisBound);
      if (moveFromMaxGap > 0) {
        shiftList(moveFromMaxGap * moveDir, 0, len2);
        var remained = moveFromMaxGap + gapThisBound;
        if (remained < 0) {
          squeezeGaps(-remained * moveDir, 1);
        }
      } else {
        squeezeGaps(-gapThisBound * moveDir, 1);
      }
    }
  }
  function shiftList(delta2, start2, end2) {
    if (delta2 !== 0) {
      adjusted = true;
    }
    for (var i2 = start2; i2 < end2; i2++) {
      var item2 = list[i2];
      var rect2 = item2.rect;
      rect2[xyDim] += delta2;
      item2.label[xyDim] += delta2;
    }
  }
  function squeezeGaps(delta2, maxSqeezePercent) {
    var gaps = [];
    var totalGaps = 0;
    for (var i2 = 1; i2 < len2; i2++) {
      var prevItemRect = list[i2 - 1].rect;
      var gap = Math.max(list[i2].rect[xyDim] - prevItemRect[xyDim] - prevItemRect[sizeDim], 0);
      gaps.push(gap);
      totalGaps += gap;
    }
    if (!totalGaps) {
      return;
    }
    var squeezePercent = Math.min(Math.abs(delta2) / totalGaps, maxSqeezePercent);
    if (delta2 > 0) {
      for (var i2 = 0; i2 < len2 - 1; i2++) {
        var movement = gaps[i2] * squeezePercent;
        shiftList(movement, 0, i2 + 1);
      }
    } else {
      for (var i2 = len2 - 1; i2 > 0; i2--) {
        var movement = gaps[i2 - 1] * squeezePercent;
        shiftList(-movement, i2, len2);
      }
    }
  }
  function squeezeWhenBailout(delta2) {
    var dir3 = delta2 < 0 ? -1 : 1;
    delta2 = Math.abs(delta2);
    var moveForEachLabel = Math.ceil(delta2 / (len2 - 1));
    for (var i2 = 0; i2 < len2 - 1; i2++) {
      if (dir3 > 0) {
        shiftList(moveForEachLabel, 0, i2 + 1);
      } else {
        shiftList(-moveForEachLabel, len2 - i2 - 1, len2);
      }
      delta2 -= moveForEachLabel;
      if (delta2 <= 0) {
        return;
      }
    }
  }
  return adjusted;
}
function shiftLayoutOnX(list, leftBound, rightBound, balanceShift) {
  return shiftLayout(list, "x", "width", leftBound, rightBound, balanceShift);
}
function shiftLayoutOnY(list, topBound, bottomBound, balanceShift) {
  return shiftLayout(list, "y", "height", topBound, bottomBound, balanceShift);
}
function hideOverlap(labelList) {
  var displayedLabels = [];
  labelList.sort(function(a, b2) {
    return b2.priority - a.priority;
  });
  var globalRect = new BoundingRect$1(0, 0, 0, 0);
  function hideEl(el) {
    if (!el.ignore) {
      var emphasisState = el.ensureState("emphasis");
      if (emphasisState.ignore == null) {
        emphasisState.ignore = false;
      }
    }
    el.ignore = true;
  }
  for (var i = 0; i < labelList.length; i++) {
    var labelItem = labelList[i];
    var isAxisAligned = labelItem.axisAligned;
    var localRect = labelItem.localRect;
    var transform2 = labelItem.transform;
    var label = labelItem.label;
    var labelLine = labelItem.labelLine;
    globalRect.copy(labelItem.rect);
    globalRect.width -= 0.1;
    globalRect.height -= 0.1;
    globalRect.x += 0.05;
    globalRect.y += 0.05;
    var obb = labelItem.obb;
    var overlapped = false;
    for (var j = 0; j < displayedLabels.length; j++) {
      var existsTextCfg = displayedLabels[j];
      if (!globalRect.intersect(existsTextCfg.rect)) {
        continue;
      }
      if (isAxisAligned && existsTextCfg.axisAligned) {
        overlapped = true;
        break;
      }
      if (!existsTextCfg.obb) {
        existsTextCfg.obb = new OrientedBoundingRect$1(existsTextCfg.localRect, existsTextCfg.transform);
      }
      if (!obb) {
        obb = new OrientedBoundingRect$1(localRect, transform2);
      }
      if (obb.intersect(existsTextCfg.obb)) {
        overlapped = true;
        break;
      }
    }
    if (overlapped) {
      hideEl(label);
      labelLine && hideEl(labelLine);
    } else {
      label.attr("ignore", labelItem.defaultAttr.ignore);
      labelLine && labelLine.attr("ignore", labelItem.defaultAttr.labelGuideIgnore);
      displayedLabels.push(labelItem);
    }
  }
}
function cloneArr(points2) {
  if (points2) {
    var newPoints = [];
    for (var i = 0; i < points2.length; i++) {
      newPoints.push(points2[i].slice());
    }
    return newPoints;
  }
}
function prepareLayoutCallbackParams(labelItem, hostEl) {
  var label = labelItem.label;
  var labelLine = hostEl && hostEl.getTextGuideLine();
  return {
    dataIndex: labelItem.dataIndex,
    dataType: labelItem.dataType,
    seriesIndex: labelItem.seriesModel.seriesIndex,
    text: labelItem.label.style.text,
    rect: labelItem.hostRect,
    labelRect: labelItem.rect,
    align: label.style.align,
    verticalAlign: label.style.verticalAlign,
    labelLinePoints: cloneArr(labelLine && labelLine.shape.points)
  };
}
var LABEL_OPTION_TO_STYLE_KEYS = ["align", "verticalAlign", "width", "height", "fontSize"];
var dummyTransformable = new Transformable$1();
var labelLayoutInnerStore = makeInner();
var labelLineAnimationStore = makeInner();
function extendWithKeys(target, source, keys2) {
  for (var i = 0; i < keys2.length; i++) {
    var key = keys2[i];
    if (source[key] != null) {
      target[key] = source[key];
    }
  }
}
var LABEL_LAYOUT_PROPS = ["x", "y", "rotation"];
var LabelManager = function() {
  function LabelManager2() {
    this._labelList = [];
    this._chartViewList = [];
  }
  LabelManager2.prototype.clearLabels = function() {
    this._labelList = [];
    this._chartViewList = [];
  };
  LabelManager2.prototype._addLabel = function(dataIndex, dataType, seriesModel, label, layoutOption) {
    var labelStyle = label.style;
    var hostEl = label.__hostTarget;
    var textConfig = hostEl.textConfig || {};
    var labelTransform = label.getComputedTransform();
    var labelRect = label.getBoundingRect().plain();
    BoundingRect$1.applyTransform(labelRect, labelRect, labelTransform);
    if (labelTransform) {
      dummyTransformable.setLocalTransform(labelTransform);
    } else {
      dummyTransformable.x = dummyTransformable.y = dummyTransformable.rotation = dummyTransformable.originX = dummyTransformable.originY = 0;
      dummyTransformable.scaleX = dummyTransformable.scaleY = 1;
    }
    var host = label.__hostTarget;
    var hostRect;
    if (host) {
      hostRect = host.getBoundingRect().plain();
      var transform2 = host.getComputedTransform();
      BoundingRect$1.applyTransform(hostRect, hostRect, transform2);
    }
    var labelGuide = hostRect && host.getTextGuideLine();
    this._labelList.push({
      label,
      labelLine: labelGuide,
      seriesModel,
      dataIndex,
      dataType,
      layoutOption,
      computedLayoutOption: null,
      rect: labelRect,
      hostRect,
      priority: hostRect ? hostRect.width * hostRect.height : 0,
      defaultAttr: {
        ignore: label.ignore,
        labelGuideIgnore: labelGuide && labelGuide.ignore,
        x: dummyTransformable.x,
        y: dummyTransformable.y,
        scaleX: dummyTransformable.scaleX,
        scaleY: dummyTransformable.scaleY,
        rotation: dummyTransformable.rotation,
        style: {
          x: labelStyle.x,
          y: labelStyle.y,
          align: labelStyle.align,
          verticalAlign: labelStyle.verticalAlign,
          width: labelStyle.width,
          height: labelStyle.height,
          fontSize: labelStyle.fontSize
        },
        cursor: label.cursor,
        attachedPos: textConfig.position,
        attachedRot: textConfig.rotation
      }
    });
  };
  LabelManager2.prototype.addLabelsOfSeries = function(chartView) {
    var _this = this;
    this._chartViewList.push(chartView);
    var seriesModel = chartView.__model;
    var layoutOption = seriesModel.get("labelLayout");
    if (!(isFunction$1(layoutOption) || keys(layoutOption).length)) {
      return;
    }
    chartView.group.traverse(function(child) {
      if (child.ignore) {
        return true;
      }
      var textEl = child.getTextContent();
      var ecData = getECData(child);
      if (textEl && !textEl.disableLabelLayout) {
        _this._addLabel(ecData.dataIndex, ecData.dataType, seriesModel, textEl, layoutOption);
      }
    });
  };
  LabelManager2.prototype.updateLayoutConfig = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    function createDragHandler(el, labelLineModel) {
      return function() {
        updateLabelLinePoints(el, labelLineModel);
      };
    }
    for (var i = 0; i < this._labelList.length; i++) {
      var labelItem = this._labelList[i];
      var label = labelItem.label;
      var hostEl = label.__hostTarget;
      var defaultLabelAttr = labelItem.defaultAttr;
      var layoutOption = void 0;
      if (isFunction$1(labelItem.layoutOption)) {
        layoutOption = labelItem.layoutOption(prepareLayoutCallbackParams(labelItem, hostEl));
      } else {
        layoutOption = labelItem.layoutOption;
      }
      layoutOption = layoutOption || {};
      labelItem.computedLayoutOption = layoutOption;
      var degreeToRadian = Math.PI / 180;
      if (hostEl) {
        hostEl.setTextConfig({
          local: false,
          position: layoutOption.x != null || layoutOption.y != null ? null : defaultLabelAttr.attachedPos,
          rotation: layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.attachedRot,
          offset: [layoutOption.dx || 0, layoutOption.dy || 0]
        });
      }
      var needsUpdateLabelLine = false;
      if (layoutOption.x != null) {
        label.x = parsePercent(layoutOption.x, width);
        label.setStyle("x", 0);
        needsUpdateLabelLine = true;
      } else {
        label.x = defaultLabelAttr.x;
        label.setStyle("x", defaultLabelAttr.style.x);
      }
      if (layoutOption.y != null) {
        label.y = parsePercent(layoutOption.y, height);
        label.setStyle("y", 0);
        needsUpdateLabelLine = true;
      } else {
        label.y = defaultLabelAttr.y;
        label.setStyle("y", defaultLabelAttr.style.y);
      }
      if (layoutOption.labelLinePoints) {
        var guideLine = hostEl.getTextGuideLine();
        if (guideLine) {
          guideLine.setShape({
            points: layoutOption.labelLinePoints
          });
          needsUpdateLabelLine = false;
        }
      }
      var labelLayoutStore = labelLayoutInnerStore(label);
      labelLayoutStore.needsUpdateLabelLine = needsUpdateLabelLine;
      label.rotation = layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.rotation;
      label.scaleX = defaultLabelAttr.scaleX;
      label.scaleY = defaultLabelAttr.scaleY;
      for (var k2 = 0; k2 < LABEL_OPTION_TO_STYLE_KEYS.length; k2++) {
        var key = LABEL_OPTION_TO_STYLE_KEYS[k2];
        label.setStyle(key, layoutOption[key] != null ? layoutOption[key] : defaultLabelAttr.style[key]);
      }
      if (layoutOption.draggable) {
        label.draggable = true;
        label.cursor = "move";
        if (hostEl) {
          var hostModel = labelItem.seriesModel;
          if (labelItem.dataIndex != null) {
            var data2 = labelItem.seriesModel.getData(labelItem.dataType);
            hostModel = data2.getItemModel(labelItem.dataIndex);
          }
          label.on("drag", createDragHandler(hostEl, hostModel.getModel("labelLine")));
        }
      } else {
        label.off("drag");
        label.cursor = defaultLabelAttr.cursor;
      }
    }
  };
  LabelManager2.prototype.layout = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    var labelList = prepareLayoutList(this._labelList);
    var labelsNeedsAdjustOnX = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftX";
    });
    var labelsNeedsAdjustOnY = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftY";
    });
    shiftLayoutOnX(labelsNeedsAdjustOnX, 0, width);
    shiftLayoutOnY(labelsNeedsAdjustOnY, 0, height);
    var labelsNeedsHideOverlap = filter(labelList, function(item) {
      return item.layoutOption.hideOverlap;
    });
    hideOverlap(labelsNeedsHideOverlap);
  };
  LabelManager2.prototype.processLabelsOverall = function() {
    var _this = this;
    each$g(this._chartViewList, function(chartView) {
      var seriesModel = chartView.__model;
      var ignoreLabelLineUpdate = chartView.ignoreLabelLineUpdate;
      var animationEnabled = seriesModel.isAnimationEnabled();
      chartView.group.traverse(function(child) {
        if (child.ignore && !child.forceLabelAnimation) {
          return true;
        }
        var needsUpdateLabelLine = !ignoreLabelLineUpdate;
        var label = child.getTextContent();
        if (!needsUpdateLabelLine && label) {
          needsUpdateLabelLine = labelLayoutInnerStore(label).needsUpdateLabelLine;
        }
        if (needsUpdateLabelLine) {
          _this._updateLabelLine(child, seriesModel);
        }
        if (animationEnabled) {
          _this._animateLabels(child, seriesModel);
        }
      });
    });
  };
  LabelManager2.prototype._updateLabelLine = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var ecData = getECData(el);
    var dataIndex = ecData.dataIndex;
    if (textEl && dataIndex != null) {
      var data2 = seriesModel.getData(ecData.dataType);
      var itemModel = data2.getItemModel(dataIndex);
      var defaultStyle = {};
      var visualStyle = data2.getItemVisual(dataIndex, "style");
      var visualType = data2.getVisual("drawType");
      defaultStyle.stroke = visualStyle[visualType];
      var labelLineModel = itemModel.getModel("labelLine");
      setLabelLineStyle(el, getLabelLineStatesModels(itemModel), defaultStyle);
      updateLabelLinePoints(el, labelLineModel);
    }
  };
  LabelManager2.prototype._animateLabels = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var guideLine = el.getTextGuideLine();
    if (textEl && (el.forceLabelAnimation || !textEl.ignore && !textEl.invisible && !el.disableLabelAnimation && !isElementRemoved(el))) {
      var layoutStore = labelLayoutInnerStore(textEl);
      var oldLayout = layoutStore.oldLayout;
      var ecData = getECData(el);
      var dataIndex = ecData.dataIndex;
      var newProps = {
        x: textEl.x,
        y: textEl.y,
        rotation: textEl.rotation
      };
      var data2 = seriesModel.getData(ecData.dataType);
      if (!oldLayout) {
        textEl.attr(newProps);
        if (!labelInner(textEl).valueAnimation) {
          var oldOpacity = retrieve2(textEl.style.opacity, 1);
          textEl.style.opacity = 0;
          initProps(textEl, {
            style: {
              opacity: oldOpacity
            }
          }, seriesModel, dataIndex);
        }
      } else {
        textEl.attr(oldLayout);
        var prevStates = el.prevStates;
        if (prevStates) {
          if (indexOf(prevStates, "select") >= 0) {
            textEl.attr(layoutStore.oldLayoutSelect);
          }
          if (indexOf(prevStates, "emphasis") >= 0) {
            textEl.attr(layoutStore.oldLayoutEmphasis);
          }
        }
        updateProps$1(textEl, newProps, seriesModel, dataIndex);
      }
      layoutStore.oldLayout = newProps;
      if (textEl.states.select) {
        var layoutSelect = layoutStore.oldLayoutSelect = {};
        extendWithKeys(layoutSelect, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutSelect, textEl.states.select, LABEL_LAYOUT_PROPS);
      }
      if (textEl.states.emphasis) {
        var layoutEmphasis = layoutStore.oldLayoutEmphasis = {};
        extendWithKeys(layoutEmphasis, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutEmphasis, textEl.states.emphasis, LABEL_LAYOUT_PROPS);
      }
      animateLabelValue(textEl, dataIndex, data2, seriesModel, seriesModel);
    }
    if (guideLine && !guideLine.ignore && !guideLine.invisible) {
      var layoutStore = labelLineAnimationStore(guideLine);
      var oldLayout = layoutStore.oldLayout;
      var newLayout = {
        points: guideLine.shape.points
      };
      if (!oldLayout) {
        guideLine.setShape(newLayout);
        guideLine.style.strokePercent = 0;
        initProps(guideLine, {
          style: {
            strokePercent: 1
          }
        }, seriesModel);
      } else {
        guideLine.attr({
          shape: oldLayout
        });
        updateProps$1(guideLine, {
          shape: newLayout
        }, seriesModel);
      }
      layoutStore.oldLayout = newLayout;
    }
  };
  return LabelManager2;
}();
var LabelManager$1 = LabelManager;
var getLabelManager = makeInner();
function installLabelLayout(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    if (!labelManager) {
      labelManager = getLabelManager(api).labelManager = new LabelManager$1();
    }
    labelManager.clearLabels();
  });
  registers.registerUpdateLifecycle("series:layoutlabels", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    params.updatedSeries.forEach(function(series) {
      labelManager.addLabelsOfSeries(api.getViewOfSeriesModel(series));
    });
    labelManager.updateLayoutConfig(api);
    labelManager.layout(api);
    labelManager.processLabelsOverall();
  });
}
var mathSin = Math.sin;
var mathCos = Math.cos;
var PI$4 = Math.PI;
var PI2$2 = Math.PI * 2;
var degree = 180 / PI$4;
var SVGPathRebuilder = function() {
  function SVGPathRebuilder2() {
  }
  SVGPathRebuilder2.prototype.reset = function(precision) {
    this._start = true;
    this._d = [];
    this._str = "";
    this._p = Math.pow(10, precision || 4);
  };
  SVGPathRebuilder2.prototype.moveTo = function(x2, y2) {
    this._add("M", x2, y2);
  };
  SVGPathRebuilder2.prototype.lineTo = function(x2, y2) {
    this._add("L", x2, y2);
  };
  SVGPathRebuilder2.prototype.bezierCurveTo = function(x2, y2, x22, y22, x3, y3) {
    this._add("C", x2, y2, x22, y22, x3, y3);
  };
  SVGPathRebuilder2.prototype.quadraticCurveTo = function(x2, y2, x22, y22) {
    this._add("Q", x2, y2, x22, y22);
  };
  SVGPathRebuilder2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this.ellipse(cx, cy, r2, r2, 0, startAngle, endAngle, anticlockwise);
  };
  SVGPathRebuilder2.prototype.ellipse = function(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise) {
    var dTheta = endAngle - startAngle;
    var clockwise = !anticlockwise;
    var dThetaPositive = Math.abs(dTheta);
    var isCircle = isAroundZero(dThetaPositive - PI2$2) || (clockwise ? dTheta >= PI2$2 : -dTheta >= PI2$2);
    var unifiedTheta = dTheta > 0 ? dTheta % PI2$2 : dTheta % PI2$2 + PI2$2;
    var large = false;
    if (isCircle) {
      large = true;
    } else if (isAroundZero(dThetaPositive)) {
      large = false;
    } else {
      large = unifiedTheta >= PI$4 === !!clockwise;
    }
    var x0 = cx + rx * mathCos(startAngle);
    var y0 = cy + ry * mathSin(startAngle);
    if (this._start) {
      this._add("M", x0, y0);
    }
    var xRot = Math.round(psi * degree);
    if (isCircle) {
      var p2 = 1 / this._p;
      var dTheta_1 = (clockwise ? 1 : -1) * (PI2$2 - p2);
      this._add("A", rx, ry, xRot, 1, +clockwise, cx + rx * mathCos(startAngle + dTheta_1), cy + ry * mathSin(startAngle + dTheta_1));
      if (p2 > 0.01) {
        this._add("A", rx, ry, xRot, 0, +clockwise, x0, y0);
      }
    } else {
      var x2 = cx + rx * mathCos(endAngle);
      var y2 = cy + ry * mathSin(endAngle);
      this._add("A", rx, ry, xRot, +large, +clockwise, x2, y2);
    }
  };
  SVGPathRebuilder2.prototype.rect = function(x2, y2, w2, h) {
    this._add("M", x2, y2);
    this._add("l", w2, 0);
    this._add("l", 0, h);
    this._add("l", -w2, 0);
    this._add("Z");
  };
  SVGPathRebuilder2.prototype.closePath = function() {
    if (this._d.length > 0) {
      this._add("Z");
    }
  };
  SVGPathRebuilder2.prototype._add = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    var vals = [];
    var p2 = this._p;
    for (var i = 1; i < arguments.length; i++) {
      var val = arguments[i];
      if (isNaN(val)) {
        this._invalid = true;
        return;
      }
      vals.push(Math.round(val * p2) / p2);
    }
    this._d.push(cmd + vals.join(" "));
    this._start = cmd === "Z";
  };
  SVGPathRebuilder2.prototype.generateStr = function() {
    this._str = this._invalid ? "" : this._d.join("");
    this._d = [];
  };
  SVGPathRebuilder2.prototype.getStr = function() {
    return this._str;
  };
  return SVGPathRebuilder2;
}();
var SVGPathRebuilder$1 = SVGPathRebuilder;
var NONE = "none";
var mathRound = Math.round;
function pathHasFill(style2) {
  var fill = style2.fill;
  return fill != null && fill !== NONE;
}
function pathHasStroke(style2) {
  var stroke = style2.stroke;
  return stroke != null && stroke !== NONE;
}
var strokeProps = ["lineCap", "miterLimit", "lineJoin"];
var svgStrokeProps = map$1(strokeProps, function(prop) {
  return "stroke-" + prop.toLowerCase();
});
function mapStyleToAttrs(updateAttr2, style2, el, forceUpdate) {
  var opacity = style2.opacity == null ? 1 : style2.opacity;
  if (el instanceof ZRImage$1) {
    updateAttr2("opacity", opacity);
    return;
  }
  if (pathHasFill(style2)) {
    var fill = normalizeColor(style2.fill);
    updateAttr2("fill", fill.color);
    var fillOpacity = style2.fillOpacity != null ? style2.fillOpacity * fill.opacity * opacity : fill.opacity * opacity;
    if (forceUpdate || fillOpacity < 1) {
      updateAttr2("fill-opacity", fillOpacity);
    }
  } else {
    updateAttr2("fill", NONE);
  }
  if (pathHasStroke(style2)) {
    var stroke = normalizeColor(style2.stroke);
    updateAttr2("stroke", stroke.color);
    var strokeScale = style2.strokeNoScale ? el.getLineScale() : 1;
    var strokeWidth = strokeScale ? (style2.lineWidth || 0) / strokeScale : 0;
    var strokeOpacity = style2.strokeOpacity != null ? style2.strokeOpacity * stroke.opacity * opacity : stroke.opacity * opacity;
    var strokeFirst = style2.strokeFirst;
    if (forceUpdate || strokeWidth !== 1) {
      updateAttr2("stroke-width", strokeWidth);
    }
    if (forceUpdate || strokeFirst) {
      updateAttr2("paint-order", strokeFirst ? "stroke" : "fill");
    }
    if (forceUpdate || strokeOpacity < 1) {
      updateAttr2("stroke-opacity", strokeOpacity);
    }
    if (style2.lineDash) {
      var _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
      if (lineDash) {
        lineDashOffset = mathRound(lineDashOffset || 0);
        updateAttr2("stroke-dasharray", lineDash.join(","));
        if (lineDashOffset || forceUpdate) {
          updateAttr2("stroke-dashoffset", lineDashOffset);
        }
      }
    } else if (forceUpdate) {
      updateAttr2("stroke-dasharray", NONE);
    }
    for (var i = 0; i < strokeProps.length; i++) {
      var propName = strokeProps[i];
      if (forceUpdate || style2[propName] !== DEFAULT_PATH_STYLE[propName]) {
        var val = style2[propName] || DEFAULT_PATH_STYLE[propName];
        val && updateAttr2(svgStrokeProps[i], val);
      }
    }
  } else if (forceUpdate) {
    updateAttr2("stroke", NONE);
  }
}
var SVGNS = "http://www.w3.org/2000/svg";
var XLINKNS = "http://www.w3.org/1999/xlink";
var XMLNS = "http://www.w3.org/2000/xmlns/";
var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
function createElement(name2) {
  return document.createElementNS(SVGNS, name2);
}
function createVNode(tag, key, attrs, children, text) {
  return {
    tag,
    attrs: attrs || {},
    children,
    text,
    key
  };
}
function createElementOpen(name2, attrs) {
  var attrsStr = [];
  if (attrs) {
    for (var key in attrs) {
      var val = attrs[key];
      var part = key;
      if (val === false) {
        continue;
      } else if (val !== true && val != null) {
        part += '="' + val + '"';
      }
      attrsStr.push(part);
    }
  }
  return "<" + name2 + " " + attrsStr.join(" ") + ">";
}
function createElementClose(name2) {
  return "</" + name2 + ">";
}
function vNodeToString(el, opts) {
  opts = opts || {};
  var S2 = opts.newline ? "\n" : "";
  function convertElToString(el2) {
    var children = el2.children, tag = el2.tag, attrs = el2.attrs;
    return createElementOpen(tag, attrs) + (el2.text || "") + (children ? "" + S2 + map$1(children, function(child) {
      return convertElToString(child);
    }).join(S2) + S2 : "") + createElementClose(tag);
  }
  return convertElToString(el);
}
function getCssString(selectorNodes, animationNodes, opts) {
  opts = opts || {};
  var S2 = opts.newline ? "\n" : "";
  var bracketBegin = " {" + S2;
  var bracketEnd = S2 + "}";
  var selectors = map$1(keys(selectorNodes), function(className) {
    return className + bracketBegin + map$1(keys(selectorNodes[className]), function(attrName) {
      return attrName + ":" + selectorNodes[className][attrName] + ";";
    }).join(S2) + bracketEnd;
  }).join(S2);
  var animations = map$1(keys(animationNodes), function(animationName) {
    return "@keyframes " + animationName + bracketBegin + map$1(keys(animationNodes[animationName]), function(percent) {
      return percent + bracketBegin + map$1(keys(animationNodes[animationName][percent]), function(attrName) {
        var val = animationNodes[animationName][percent][attrName];
        if (attrName === "d") {
          val = 'path("' + val + '")';
        }
        return attrName + ":" + val + ";";
      }).join(S2) + bracketEnd;
    }).join(S2) + bracketEnd;
  }).join(S2);
  if (!selectors && !animations) {
    return "";
  }
  return ["<![CDATA[", selectors, animations, "]]>"].join(S2);
}
function createBrushScope(zrId) {
  return {
    zrId,
    shadowCache: {},
    patternCache: {},
    gradientCache: {},
    clipPathCache: {},
    defs: {},
    cssNodes: {},
    cssAnims: {},
    cssClassIdx: 0,
    cssAnimIdx: 0,
    shadowIdx: 0,
    gradientIdx: 0,
    patternIdx: 0,
    clipPathIdx: 0
  };
}
function createSVGVNode(width, height, children, useViewBox) {
  return createVNode("svg", "root", {
    "width": width,
    "height": height,
    "xmlns": SVGNS,
    "xmlns:xlink": XLINKNS,
    "version": "1.1",
    "baseProfile": "full",
    "viewBox": useViewBox ? "0 0 " + width + " " + height : false
  }, children);
}
var EASING_MAP = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
};
var transformOriginKey = "transform-origin";
function buildPathString(el, kfShape, path) {
  var shape = extend({}, el.shape);
  extend(shape, kfShape);
  el.buildPath(path, shape);
  var svgPathBuilder = new SVGPathRebuilder$1();
  svgPathBuilder.reset(getPathPrecision(el));
  path.rebuildPath(svgPathBuilder, 1);
  svgPathBuilder.generateStr();
  return svgPathBuilder.getStr();
}
function setTransformOrigin(target, transform2) {
  var originX = transform2.originX, originY = transform2.originY;
  if (originX || originY) {
    target[transformOriginKey] = originX + "px " + originY + "px";
  }
}
var ANIMATE_STYLE_MAP = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function addAnimation(cssAnim, scope) {
  var animationName = scope.zrId + "-ani-" + scope.cssAnimIdx++;
  scope.cssAnims[animationName] = cssAnim;
  return animationName;
}
function createCompoundPathCSSAnimation(el, attrs, scope) {
  var paths = el.shape.paths;
  var composedAnim = {};
  var cssAnimationCfg;
  var cssAnimationName;
  each$g(paths, function(path) {
    var subScope = createBrushScope(scope.zrId);
    subScope.animation = true;
    createCSSAnimation(path, {}, subScope, true);
    var cssAnims = subScope.cssAnims;
    var cssNodes = subScope.cssNodes;
    var animNames = keys(cssAnims);
    var len2 = animNames.length;
    if (!len2) {
      return;
    }
    cssAnimationName = animNames[len2 - 1];
    var lastAnim = cssAnims[cssAnimationName];
    for (var percent in lastAnim) {
      var kf2 = lastAnim[percent];
      composedAnim[percent] = composedAnim[percent] || { d: "" };
      composedAnim[percent].d += kf2.d || "";
    }
    for (var className in cssNodes) {
      var val = cssNodes[className].animation;
      if (val.indexOf(cssAnimationName) >= 0) {
        cssAnimationCfg = val;
      }
    }
  });
  if (!cssAnimationCfg) {
    return;
  }
  attrs.d = false;
  var animationName = addAnimation(composedAnim, scope);
  return cssAnimationCfg.replace(cssAnimationName, animationName);
}
function getEasingFunc(easing) {
  return isString$1(easing) ? EASING_MAP[easing] ? "cubic-bezier(" + EASING_MAP[easing] + ")" : createCubicEasingFunc(easing) ? easing : "" : "";
}
function createCSSAnimation(el, attrs, scope, onlyShape) {
  var animators = el.animators;
  var len2 = animators.length;
  var cssAnimations = [];
  if (el instanceof CompoundPath$1) {
    var animationCfg = createCompoundPathCSSAnimation(el, attrs, scope);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    } else if (!len2) {
      return;
    }
  } else if (!len2) {
    return;
  }
  var groupAnimators = {};
  for (var i = 0; i < len2; i++) {
    var animator = animators[i];
    var cfgArr = [animator.getMaxTime() / 1e3 + "s"];
    var easing = getEasingFunc(animator.getClip().easing);
    var delay = animator.getDelay();
    if (easing) {
      cfgArr.push(easing);
    } else {
      cfgArr.push("linear");
    }
    if (delay) {
      cfgArr.push(delay / 1e3 + "s");
    }
    if (animator.getLoop()) {
      cfgArr.push("infinite");
    }
    var cfg = cfgArr.join(" ");
    groupAnimators[cfg] = groupAnimators[cfg] || [cfg, []];
    groupAnimators[cfg][1].push(animator);
  }
  function createSingleCSSAnimation(groupAnimator) {
    var animators2 = groupAnimator[1];
    var len3 = animators2.length;
    var transformKfs = {};
    var shapeKfs = {};
    var finalKfs = {};
    var animationTimingFunctionAttrName = "animation-timing-function";
    function saveAnimatorTrackToCssKfs(animator3, cssKfs, toCssAttrName) {
      var tracks = animator3.getTracks();
      var maxTime = animator3.getMaxTime();
      for (var k2 = 0; k2 < tracks.length; k2++) {
        var track = tracks[k2];
        if (track.needsAnimate()) {
          var kfs = track.keyframes;
          var attrName = track.propName;
          toCssAttrName && (attrName = toCssAttrName(attrName));
          if (attrName) {
            for (var i3 = 0; i3 < kfs.length; i3++) {
              var kf2 = kfs[i3];
              var percent2 = Math.round(kf2.time / maxTime * 100) + "%";
              var kfEasing = getEasingFunc(kf2.easing);
              var rawValue = kf2.rawValue;
              if (isString$1(rawValue) || isNumber(rawValue)) {
                cssKfs[percent2] = cssKfs[percent2] || {};
                cssKfs[percent2][attrName] = kf2.rawValue;
                if (kfEasing) {
                  cssKfs[percent2][animationTimingFunctionAttrName] = kfEasing;
                }
              }
            }
          }
        }
      }
    }
    for (var i2 = 0; i2 < len3; i2++) {
      var animator2 = animators2[i2];
      var targetProp = animator2.targetName;
      if (!targetProp) {
        !onlyShape && saveAnimatorTrackToCssKfs(animator2, transformKfs);
      } else if (targetProp === "shape") {
        saveAnimatorTrackToCssKfs(animator2, shapeKfs);
      }
    }
    for (var percent in transformKfs) {
      var transform2 = {};
      copyTransform(transform2, el);
      extend(transform2, transformKfs[percent]);
      var str = getSRTTransformString(transform2);
      var timingFunction = transformKfs[percent][animationTimingFunctionAttrName];
      finalKfs[percent] = str ? {
        transform: str
      } : {};
      setTransformOrigin(finalKfs[percent], transform2);
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    var path;
    var canAnimateShape = true;
    for (var percent in shapeKfs) {
      finalKfs[percent] = finalKfs[percent] || {};
      var isFirst = !path;
      var timingFunction = shapeKfs[percent][animationTimingFunctionAttrName];
      if (isFirst) {
        path = new PathProxy$1();
      }
      var len_1 = path.len();
      path.reset();
      finalKfs[percent].d = buildPathString(el, shapeKfs[percent], path);
      var newLen = path.len();
      if (!isFirst && len_1 !== newLen) {
        canAnimateShape = false;
        break;
      }
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    if (!canAnimateShape) {
      for (var percent in finalKfs) {
        delete finalKfs[percent].d;
      }
    }
    if (!onlyShape) {
      for (var i2 = 0; i2 < len3; i2++) {
        var animator2 = animators2[i2];
        var targetProp = animator2.targetName;
        if (targetProp === "style") {
          saveAnimatorTrackToCssKfs(animator2, finalKfs, function(propName) {
            return ANIMATE_STYLE_MAP[propName];
          });
        }
      }
    }
    var percents = keys(finalKfs);
    var allTransformOriginSame = true;
    var transformOrigin;
    for (var i2 = 1; i2 < percents.length; i2++) {
      var p0 = percents[i2 - 1];
      var p1 = percents[i2];
      if (finalKfs[p0][transformOriginKey] !== finalKfs[p1][transformOriginKey]) {
        allTransformOriginSame = false;
        break;
      }
      transformOrigin = finalKfs[p0][transformOriginKey];
    }
    if (allTransformOriginSame && transformOrigin) {
      for (var percent in finalKfs) {
        if (finalKfs[percent][transformOriginKey]) {
          delete finalKfs[percent][transformOriginKey];
        }
      }
      attrs[transformOriginKey] = transformOrigin;
    }
    if (filter(percents, function(percent2) {
      return keys(finalKfs[percent2]).length > 0;
    }).length) {
      var animationName = addAnimation(finalKfs, scope);
      return animationName + " " + groupAnimator[0] + " both";
    }
  }
  for (var key in groupAnimators) {
    var animationCfg = createSingleCSSAnimation(groupAnimators[key]);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    }
  }
  if (cssAnimations.length) {
    var className = scope.zrId + "-cls-" + scope.cssClassIdx++;
    scope.cssNodes["." + className] = {
      animation: cssAnimations.join(",")
    };
    attrs["class"] = className;
  }
}
var round$1 = Math.round;
function isImageLike(val) {
  return val && isString$1(val.src);
}
function isCanvasLike(val) {
  return val && isFunction$1(val.toDataURL);
}
function setStyleAttrs(attrs, style2, el, scope) {
  mapStyleToAttrs(function(key, val) {
    var isFillStroke = key === "fill" || key === "stroke";
    if (isFillStroke && isGradient(val)) {
      setGradient(style2, attrs, key, scope);
    } else if (isFillStroke && isPattern(val)) {
      setPattern(el, attrs, key, scope);
    } else {
      attrs[key] = val;
    }
  }, style2, el, false);
  setShadow(el, attrs, scope);
}
function noRotateScale(m2) {
  return isAroundZero(m2[0] - 1) && isAroundZero(m2[1]) && isAroundZero(m2[2]) && isAroundZero(m2[3] - 1);
}
function noTranslate(m2) {
  return isAroundZero(m2[4]) && isAroundZero(m2[5]);
}
function setTransform$2(attrs, m2, compress) {
  if (m2 && !(noTranslate(m2) && noRotateScale(m2))) {
    var mul2 = compress ? 10 : 1e4;
    attrs.transform = noRotateScale(m2) ? "translate(" + round$1(m2[4] * mul2) / mul2 + " " + round$1(m2[5] * mul2) / mul2 + ")" : getMatrixStr(m2);
  }
}
function convertPolyShape(shape, attrs, mul2) {
  var points2 = shape.points;
  var strArr = [];
  for (var i = 0; i < points2.length; i++) {
    strArr.push(round$1(points2[i][0] * mul2) / mul2);
    strArr.push(round$1(points2[i][1] * mul2) / mul2);
  }
  attrs.points = strArr.join(" ");
}
function validatePolyShape(shape) {
  return !shape.smooth;
}
function createAttrsConvert(desc) {
  var normalizedDesc = map$1(desc, function(item) {
    return typeof item === "string" ? [item, item] : item;
  });
  return function(shape, attrs, mul2) {
    for (var i = 0; i < normalizedDesc.length; i++) {
      var item = normalizedDesc[i];
      var val = shape[item[0]];
      if (val != null) {
        attrs[item[1]] = round$1(val * mul2) / mul2;
      }
    }
  };
}
var buitinShapesDef = {
  circle: [createAttrsConvert(["cx", "cy", "r"])],
  polyline: [convertPolyShape, validatePolyShape],
  polygon: [convertPolyShape, validatePolyShape]
};
function hasShapeAnimation(el) {
  var animators = el.animators;
  for (var i = 0; i < animators.length; i++) {
    if (animators[i].targetName === "shape") {
      return true;
    }
  }
  return false;
}
function brushSVGPath(el, scope) {
  var style2 = el.style;
  var shape = el.shape;
  var builtinShpDef = buitinShapesDef[el.type];
  var attrs = {};
  var needsAnimate = scope.animation;
  var svgElType = "path";
  var strokePercent = el.style.strokePercent;
  var precision = scope.compress && getPathPrecision(el) || 4;
  if (builtinShpDef && !scope.willUpdate && !(builtinShpDef[1] && !builtinShpDef[1](shape)) && !(needsAnimate && hasShapeAnimation(el)) && !(strokePercent < 1)) {
    svgElType = el.type;
    var mul2 = Math.pow(10, precision);
    builtinShpDef[0](shape, attrs, mul2);
  } else {
    if (!el.path) {
      el.createPathProxy();
    }
    var path = el.path;
    if (el.shapeChanged()) {
      path.beginPath();
      el.buildPath(path, el.shape);
      el.pathUpdated();
    }
    var pathVersion = path.getVersion();
    var elExt = el;
    var svgPathBuilder = elExt.__svgPathBuilder;
    if (elExt.__svgPathVersion !== pathVersion || !svgPathBuilder || strokePercent !== elExt.__svgPathStrokePercent) {
      if (!svgPathBuilder) {
        svgPathBuilder = elExt.__svgPathBuilder = new SVGPathRebuilder$1();
      }
      svgPathBuilder.reset(precision);
      path.rebuildPath(svgPathBuilder, strokePercent);
      svgPathBuilder.generateStr();
      elExt.__svgPathVersion = pathVersion;
      elExt.__svgPathStrokePercent = strokePercent;
    }
    attrs.d = svgPathBuilder.getStr();
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode(svgElType, el.id + "", attrs);
}
function brushSVGImage(el, scope) {
  var style2 = el.style;
  var image = style2.image;
  if (image && !isString$1(image)) {
    if (isImageLike(image)) {
      image = image.src;
    } else if (isCanvasLike(image)) {
      image = image.toDataURL();
    }
  }
  if (!image) {
    return;
  }
  var x2 = style2.x || 0;
  var y2 = style2.y || 0;
  var dw = style2.width;
  var dh2 = style2.height;
  var attrs = {
    href: image,
    width: dw,
    height: dh2
  };
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("image", el.id + "", attrs);
}
function brushSVGTSpan(el, scope) {
  var style2 = el.style;
  var text = style2.text;
  text != null && (text += "");
  if (!text || isNaN(style2.x) || isNaN(style2.y)) {
    return;
  }
  var font = style2.font || DEFAULT_FONT;
  var x2 = style2.x || 0;
  var y2 = adjustTextY$1(style2.y || 0, getLineHeight(font), style2.textBaseline);
  var textAlign = TEXT_ALIGN_TO_ANCHOR[style2.textAlign] || style2.textAlign;
  var attrs = {
    "dominant-baseline": "central",
    "text-anchor": textAlign
  };
  if (hasSeparateFont(style2)) {
    var separatedFontStr = "";
    var fontStyle = style2.fontStyle;
    var fontSize = parseFontSize(style2.fontSize);
    if (!parseFloat(fontSize)) {
      return;
    }
    var fontFamily = style2.fontFamily || DEFAULT_FONT_FAMILY;
    var fontWeight = style2.fontWeight;
    separatedFontStr += "font-size:" + fontSize + ";font-family:" + fontFamily + ";";
    if (fontStyle && fontStyle !== "normal") {
      separatedFontStr += "font-style:" + fontStyle + ";";
    }
    if (fontWeight && fontWeight !== "normal") {
      separatedFontStr += "font-weight:" + fontWeight + ";";
    }
    attrs.style = separatedFontStr;
  } else {
    attrs.style = "font: " + font;
  }
  if (text.match(/\s/)) {
    attrs["xml:space"] = "preserve";
  }
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("text", el.id + "", attrs, void 0, text);
}
function brush(el, scope) {
  if (el instanceof Path$1) {
    return brushSVGPath(el, scope);
  } else if (el instanceof ZRImage$1) {
    return brushSVGImage(el, scope);
  } else if (el instanceof TSpan$1) {
    return brushSVGTSpan(el, scope);
  }
}
function setShadow(el, attrs, scope) {
  var style2 = el.style;
  if (hasShadow(style2)) {
    var shadowKey = getShadowKey(el);
    var shadowCache = scope.shadowCache;
    var shadowId = shadowCache[shadowKey];
    if (!shadowId) {
      var globalScale = el.getGlobalScale();
      var scaleX = globalScale[0];
      var scaleY = globalScale[1];
      if (!scaleX || !scaleY) {
        return;
      }
      var offsetX = style2.shadowOffsetX || 0;
      var offsetY = style2.shadowOffsetY || 0;
      var blur_1 = style2.shadowBlur;
      var _a2 = normalizeColor(style2.shadowColor), opacity = _a2.opacity, color = _a2.color;
      var stdDx = blur_1 / 2 / scaleX;
      var stdDy = blur_1 / 2 / scaleY;
      var stdDeviation = stdDx + " " + stdDy;
      shadowId = scope.zrId + "-s" + scope.shadowIdx++;
      scope.defs[shadowId] = createVNode("filter", shadowId, {
        "id": shadowId,
        "x": "-100%",
        "y": "-100%",
        "width": "300%",
        "height": "300%"
      }, [
        createVNode("feDropShadow", "", {
          "dx": offsetX / scaleX,
          "dy": offsetY / scaleY,
          "stdDeviation": stdDeviation,
          "flood-color": color,
          "flood-opacity": opacity
        })
      ]);
      shadowCache[shadowKey] = shadowId;
    }
    attrs.filter = getIdURL(shadowId);
  }
}
function setGradient(style2, attrs, target, scope) {
  var val = style2[target];
  var gradientTag;
  var gradientAttrs = {
    "gradientUnits": val.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if (isLinearGradient(val)) {
    gradientTag = "linearGradient";
    gradientAttrs.x1 = val.x;
    gradientAttrs.y1 = val.y;
    gradientAttrs.x2 = val.x2;
    gradientAttrs.y2 = val.y2;
  } else if (isRadialGradient(val)) {
    gradientTag = "radialGradient";
    gradientAttrs.cx = retrieve2(val.x, 0.5);
    gradientAttrs.cy = retrieve2(val.y, 0.5);
    gradientAttrs.r = retrieve2(val.r, 0.5);
  } else {
    return;
  }
  var colors2 = val.colorStops;
  var colorStops = [];
  for (var i = 0, len2 = colors2.length; i < len2; ++i) {
    var offset3 = round4(colors2[i].offset) * 100 + "%";
    var stopColor = colors2[i].color;
    var _a2 = normalizeColor(stopColor), color = _a2.color, opacity = _a2.opacity;
    var stopsAttrs = {
      "offset": offset3
    };
    stopsAttrs["stop-color"] = color;
    if (opacity < 1) {
      stopsAttrs["stop-opacity"] = opacity;
    }
    colorStops.push(createVNode("stop", i + "", stopsAttrs));
  }
  var gradientVNode = createVNode(gradientTag, "", gradientAttrs, colorStops);
  var gradientKey = vNodeToString(gradientVNode);
  var gradientCache = scope.gradientCache;
  var gradientId = gradientCache[gradientKey];
  if (!gradientId) {
    gradientId = scope.zrId + "-g" + scope.gradientIdx++;
    gradientCache[gradientKey] = gradientId;
    gradientAttrs.id = gradientId;
    scope.defs[gradientId] = createVNode(gradientTag, gradientId, gradientAttrs, colorStops);
  }
  attrs[target] = getIdURL(gradientId);
}
function setPattern(el, attrs, target, scope) {
  var val = el.style[target];
  var patternAttrs = {
    "patternUnits": "userSpaceOnUse"
  };
  var child;
  if (isImagePattern(val)) {
    var imageWidth_1 = val.imageWidth;
    var imageHeight_1 = val.imageHeight;
    var imageSrc = void 0;
    var patternImage = val.image;
    if (isString$1(patternImage)) {
      imageSrc = patternImage;
    } else if (isImageLike(patternImage)) {
      imageSrc = patternImage.src;
    } else if (isCanvasLike(patternImage)) {
      imageSrc = patternImage.toDataURL();
    }
    if (typeof Image === "undefined") {
      var errMsg = "Image width/height must been given explictly in svg-ssr renderer.";
      assert(imageWidth_1, errMsg);
      assert(imageHeight_1, errMsg);
    } else if (imageWidth_1 == null || imageHeight_1 == null) {
      var setSizeToVNode_1 = function(vNode, img) {
        if (vNode) {
          var svgEl = vNode.elm;
          var width = vNode.attrs.width = imageWidth_1 || img.width;
          var height = vNode.attrs.height = imageHeight_1 || img.height;
          if (svgEl) {
            svgEl.setAttribute("width", width);
            svgEl.setAttribute("height", height);
          }
        }
      };
      var createdImage = createOrUpdateImage(imageSrc, null, el, function(img) {
        setSizeToVNode_1(patternVNode, img);
        setSizeToVNode_1(child, img);
      });
      if (createdImage && createdImage.width && createdImage.height) {
        imageWidth_1 = imageWidth_1 || createdImage.width;
        imageHeight_1 = imageHeight_1 || createdImage.height;
      }
    }
    child = createVNode("image", "img", {
      href: imageSrc,
      width: imageWidth_1,
      height: imageHeight_1
    });
    patternAttrs.width = imageWidth_1;
    patternAttrs.height = imageHeight_1;
  } else if (val.svgElement) {
    child = clone$4(val.svgElement);
    patternAttrs.width = val.svgWidth;
    patternAttrs.height = val.svgHeight;
  }
  if (!child) {
    return;
  }
  patternAttrs.patternTransform = getSRTTransformString(val);
  var patternVNode = createVNode("pattern", "", patternAttrs, [child]);
  var patternKey = vNodeToString(patternVNode);
  var patternCache = scope.patternCache;
  var patternId = patternCache[patternKey];
  if (!patternId) {
    patternId = scope.zrId + "-p" + scope.patternIdx++;
    patternCache[patternKey] = patternId;
    patternAttrs.id = patternId;
    patternVNode = scope.defs[patternId] = createVNode("pattern", patternId, patternAttrs, [child]);
  }
  attrs[target] = getIdURL(patternId);
}
function setClipPath(clipPath, attrs, scope) {
  var clipPathCache = scope.clipPathCache, defs = scope.defs;
  var clipPathId = clipPathCache[clipPath.id];
  if (!clipPathId) {
    clipPathId = scope.zrId + "-c" + scope.clipPathIdx++;
    var clipPathAttrs = {
      id: clipPathId
    };
    clipPathCache[clipPath.id] = clipPathId;
    defs[clipPathId] = createVNode("clipPath", clipPathId, clipPathAttrs, [brushSVGPath(clipPath, scope)]);
  }
  attrs["clip-path"] = getIdURL(clipPathId);
}
function createTextNode(text) {
  return document.createTextNode(text);
}
function insertBefore(parentNode2, newNode, referenceNode) {
  parentNode2.insertBefore(newNode, referenceNode);
}
function removeChild(node, child) {
  node.removeChild(child);
}
function appendChild(node, child) {
  node.appendChild(child);
}
function parentNode(node) {
  return node.parentNode;
}
function nextSibling(node) {
  return node.nextSibling;
}
function setTextContent(node, text) {
  node.textContent = text;
}
var colonChar = 58;
var xChar = 120;
var emptyNode = createVNode("", "");
function isUndef(s) {
  return s === void 0;
}
function isDef(s) {
  return s !== void 0;
}
function createKeyToOldIdx(children, beginIdx, endIdx) {
  var map2 = {};
  for (var i = beginIdx; i <= endIdx; ++i) {
    var key = children[i].key;
    if (key !== void 0) {
      map2[key] = i;
    }
  }
  return map2;
}
function sameVnode(vnode1, vnode2) {
  var isSameKey = vnode1.key === vnode2.key;
  var isSameTag = vnode1.tag === vnode2.tag;
  return isSameTag && isSameKey;
}
function createElm(vnode) {
  var i;
  var children = vnode.children;
  var tag = vnode.tag;
  if (isDef(tag)) {
    var elm = vnode.elm = createElement(tag);
    updateAttrs(emptyNode, vnode);
    if (isArray$2(children)) {
      for (i = 0; i < children.length; ++i) {
        var ch2 = children[i];
        if (ch2 != null) {
          appendChild(elm, createElm(ch2));
        }
      }
    } else if (isDef(vnode.text) && !isObject$6(vnode.text)) {
      appendChild(elm, createTextNode(vnode.text));
    }
  } else {
    vnode.elm = createTextNode(vnode.text);
  }
  return vnode.elm;
}
function addVnodes(parentElm, before, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch2 = vnodes[startIdx];
    if (ch2 != null) {
      insertBefore(parentElm, createElm(ch2), before);
    }
  }
}
function removeVnodes(parentElm, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch2 = vnodes[startIdx];
    if (ch2 != null) {
      if (isDef(ch2.tag)) {
        var parent_1 = parentNode(ch2.elm);
        removeChild(parent_1, ch2.elm);
      } else {
        removeChild(parentElm, ch2.elm);
      }
    }
  }
}
function updateAttrs(oldVnode, vnode) {
  var key;
  var elm = vnode.elm;
  var oldAttrs = oldVnode && oldVnode.attrs || {};
  var attrs = vnode.attrs || {};
  if (oldAttrs === attrs) {
    return;
  }
  for (key in attrs) {
    var cur = attrs[key];
    var old = oldAttrs[key];
    if (old !== cur) {
      if (cur === true) {
        elm.setAttribute(key, "");
      } else if (cur === false) {
        elm.removeAttribute(key);
      } else {
        if (key.charCodeAt(0) !== xChar) {
          elm.setAttribute(key, cur);
        } else if (key === "xmlns:xlink" || key === "xmlns") {
          elm.setAttributeNS(XMLNS, key, cur);
        } else if (key.charCodeAt(3) === colonChar) {
          elm.setAttributeNS(XML_NAMESPACE, key, cur);
        } else if (key.charCodeAt(5) === colonChar) {
          elm.setAttributeNS(XLINKNS, key, cur);
        } else {
          elm.setAttribute(key, cur);
        }
      }
    }
  }
  for (key in oldAttrs) {
    if (!(key in attrs)) {
      elm.removeAttribute(key);
    }
  }
}
function updateChildren(parentElm, oldCh, newCh) {
  var oldStartIdx = 0;
  var newStartIdx = 0;
  var oldEndIdx = oldCh.length - 1;
  var oldStartVnode = oldCh[0];
  var oldEndVnode = oldCh[oldEndIdx];
  var newEndIdx = newCh.length - 1;
  var newStartVnode = newCh[0];
  var newEndVnode = newCh[newEndIdx];
  var oldKeyToIdx;
  var idxInOld;
  var elmToMove;
  var before;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newStartVnode)) {
      patchVnode(oldStartVnode, newStartVnode);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (sameVnode(oldEndVnode, newEndVnode)) {
      patchVnode(oldEndVnode, newEndVnode);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newEndVnode)) {
      patchVnode(oldStartVnode, newEndVnode);
      insertBefore(parentElm, oldStartVnode.elm, nextSibling(oldEndVnode.elm));
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldEndVnode, newStartVnode)) {
      patchVnode(oldEndVnode, newStartVnode);
      insertBefore(parentElm, oldEndVnode.elm, oldStartVnode.elm);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      if (isUndef(oldKeyToIdx)) {
        oldKeyToIdx = createKeyToOldIdx(oldCh, oldStartIdx, oldEndIdx);
      }
      idxInOld = oldKeyToIdx[newStartVnode.key];
      if (isUndef(idxInOld)) {
        insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
      } else {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.tag !== newStartVnode.tag) {
          insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
        } else {
          patchVnode(elmToMove, newStartVnode);
          oldCh[idxInOld] = void 0;
          insertBefore(parentElm, elmToMove.elm, oldStartVnode.elm);
        }
      }
      newStartVnode = newCh[++newStartIdx];
    }
  }
  if (oldStartIdx <= oldEndIdx || newStartIdx <= newEndIdx) {
    if (oldStartIdx > oldEndIdx) {
      before = newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].elm;
      addVnodes(parentElm, before, newCh, newStartIdx, newEndIdx);
    } else {
      removeVnodes(parentElm, oldCh, oldStartIdx, oldEndIdx);
    }
  }
}
function patchVnode(oldVnode, vnode) {
  var elm = vnode.elm = oldVnode.elm;
  var oldCh = oldVnode.children;
  var ch2 = vnode.children;
  if (oldVnode === vnode) {
    return;
  }
  updateAttrs(oldVnode, vnode);
  if (isUndef(vnode.text)) {
    if (isDef(oldCh) && isDef(ch2)) {
      if (oldCh !== ch2) {
        updateChildren(elm, oldCh, ch2);
      }
    } else if (isDef(ch2)) {
      if (isDef(oldVnode.text)) {
        setTextContent(elm, "");
      }
      addVnodes(elm, null, ch2, 0, ch2.length - 1);
    } else if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    } else if (isDef(oldVnode.text)) {
      setTextContent(elm, "");
    }
  } else if (oldVnode.text !== vnode.text) {
    if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    }
    setTextContent(elm, vnode.text);
  }
}
function patch(oldVnode, vnode) {
  if (sameVnode(oldVnode, vnode)) {
    patchVnode(oldVnode, vnode);
  } else {
    var elm = oldVnode.elm;
    var parent_2 = parentNode(elm);
    createElm(vnode);
    if (parent_2 !== null) {
      insertBefore(parent_2, vnode.elm, nextSibling(elm));
      removeVnodes(parent_2, [oldVnode], 0, 0);
    }
  }
  return vnode;
}
var svgId = 0;
var SVGPainter = function() {
  function SVGPainter2(root2, storage2, opts) {
    this.type = "svg";
    this.refreshHover = createMethodNotSupport();
    this.configLayer = createMethodNotSupport();
    this.storage = storage2;
    this._opts = opts = extend({}, opts);
    this.root = root2;
    this._id = "zr" + svgId++;
    this._oldVNode = createSVGVNode(opts.width, opts.height);
    if (root2 && !opts.ssr) {
      var viewport = this._viewport = document.createElement("div");
      viewport.style.cssText = "position:relative;overflow:hidden";
      var svgDom = this._svgDom = this._oldVNode.elm = createElement("svg");
      updateAttrs(null, this._oldVNode);
      viewport.appendChild(svgDom);
      root2.appendChild(viewport);
    }
    this.resize(opts.width, opts.height);
  }
  SVGPainter2.prototype.getType = function() {
    return this.type;
  };
  SVGPainter2.prototype.getViewportRoot = function() {
    return this._viewport;
  };
  SVGPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  SVGPainter2.prototype.getSvgDom = function() {
    return this._svgDom;
  };
  SVGPainter2.prototype.refresh = function() {
    if (this.root) {
      var vnode = this.renderToVNode({
        willUpdate: true
      });
      vnode.attrs.style = "position:absolute;left:0;top:0;user-select:none";
      patch(this._oldVNode, vnode);
      this._oldVNode = vnode;
    }
  };
  SVGPainter2.prototype.renderOneToVNode = function(el) {
    return brush(el, createBrushScope(this._id));
  };
  SVGPainter2.prototype.renderToVNode = function(opts) {
    opts = opts || {};
    var list = this.storage.getDisplayList(true);
    var bgColor = this._backgroundColor;
    var width = this._width;
    var height = this._height;
    var scope = createBrushScope(this._id);
    scope.animation = opts.animation;
    scope.willUpdate = opts.willUpdate;
    scope.compress = opts.compress;
    var children = [];
    if (bgColor && bgColor !== "none") {
      var _a2 = normalizeColor(bgColor), color = _a2.color, opacity = _a2.opacity;
      this._bgVNode = createVNode("rect", "bg", {
        width,
        height,
        x: "0",
        y: "0",
        id: "0",
        fill: color,
        "fill-opacity": opacity
      });
      children.push(this._bgVNode);
    } else {
      this._bgVNode = null;
    }
    var mainVNode = !opts.compress ? this._mainVNode = createVNode("g", "main", {}, []) : null;
    this._paintList(list, scope, mainVNode ? mainVNode.children : children);
    mainVNode && children.push(mainVNode);
    var defs = map$1(keys(scope.defs), function(id2) {
      return scope.defs[id2];
    });
    if (defs.length) {
      children.push(createVNode("defs", "defs", {}, defs));
    }
    if (opts.animation) {
      var animationCssStr = getCssString(scope.cssNodes, scope.cssAnims, { newline: true });
      if (animationCssStr) {
        var styleNode = createVNode("style", "stl", {}, [], animationCssStr);
        children.push(styleNode);
      }
    }
    return createSVGVNode(width, height, children, opts.useViewBox);
  };
  SVGPainter2.prototype.renderToString = function(opts) {
    opts = opts || {};
    return vNodeToString(this.renderToVNode({
      animation: retrieve2(opts.cssAnimation, true),
      willUpdate: false,
      compress: true,
      useViewBox: retrieve2(opts.useViewBox, true)
    }), { newline: true });
  };
  SVGPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    var bgVNode = this._bgVNode;
    if (bgVNode && bgVNode.elm) {
      var _a2 = normalizeColor(backgroundColor2), color = _a2.color, opacity = _a2.opacity;
      bgVNode.elm.setAttribute("fill", color);
      if (opacity < 1) {
        bgVNode.elm.setAttribute("fill-opacity", opacity);
      }
    }
  };
  SVGPainter2.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  };
  SVGPainter2.prototype._paintList = function(list, scope, out2) {
    var listLen = list.length;
    var clipPathsGroupsStack = [];
    var clipPathsGroupsStackDepth = 0;
    var currentClipPathGroup;
    var prevClipPaths;
    var clipGroupNodeIdx = 0;
    for (var i = 0; i < listLen; i++) {
      var displayable = list[i];
      if (!displayable.invisible) {
        var clipPaths = displayable.__clipPaths;
        var len2 = clipPaths && clipPaths.length || 0;
        var prevLen = prevClipPaths && prevClipPaths.length || 0;
        var lca = void 0;
        for (lca = Math.max(len2 - 1, prevLen - 1); lca >= 0; lca--) {
          if (clipPaths && prevClipPaths && clipPaths[lca] === prevClipPaths[lca]) {
            break;
          }
        }
        for (var i_1 = prevLen - 1; i_1 > lca; i_1--) {
          clipPathsGroupsStackDepth--;
          currentClipPathGroup = clipPathsGroupsStack[clipPathsGroupsStackDepth - 1];
        }
        for (var i_2 = lca + 1; i_2 < len2; i_2++) {
          var groupAttrs = {};
          setClipPath(clipPaths[i_2], groupAttrs, scope);
          var g2 = createVNode("g", "clip-g-" + clipGroupNodeIdx++, groupAttrs, []);
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(g2);
          clipPathsGroupsStack[clipPathsGroupsStackDepth++] = g2;
          currentClipPathGroup = g2;
        }
        prevClipPaths = clipPaths;
        var ret = brush(displayable, scope);
        if (ret) {
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(ret);
        }
      }
    }
  };
  SVGPainter2.prototype.resize = function(width, height) {
    var opts = this._opts;
    var root2 = this.root;
    var viewport = this._viewport;
    width != null && (opts.width = width);
    height != null && (opts.height = height);
    if (root2 && viewport) {
      viewport.style.display = "none";
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      viewport.style.display = "";
    }
    if (this._width !== width || this._height !== height) {
      this._width = width;
      this._height = height;
      if (viewport) {
        var viewportStyle = viewport.style;
        viewportStyle.width = width + "px";
        viewportStyle.height = height + "px";
      }
      var svgDom = this._svgDom;
      if (svgDom) {
        svgDom.setAttribute("width", width);
        svgDom.setAttribute("height", height);
      }
    }
  };
  SVGPainter2.prototype.getWidth = function() {
    return this._width;
  };
  SVGPainter2.prototype.getHeight = function() {
    return this._height;
  };
  SVGPainter2.prototype.dispose = function() {
    if (this.root) {
      this.root.innerHTML = "";
    }
    this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  };
  SVGPainter2.prototype.clear = function() {
    if (this._svgDom) {
      this._svgDom.innerHTML = null;
    }
    this._oldVNode = null;
  };
  SVGPainter2.prototype.toDataURL = function(base642) {
    var str = encodeURIComponent(this.renderToString());
    var prefix = "data:image/svg+xml;";
    if (base642) {
      str = encodeBase64(str);
      return str && prefix + "base64," + str;
    }
    return prefix + "charset=UTF-8," + str;
  };
  return SVGPainter2;
}();
function createMethodNotSupport(method4) {
  return function() {
  };
}
var SVGPainter$1 = SVGPainter;
function install$S(registers) {
  registers.registerPainter("svg", SVGPainter$1);
}
function createDom(id2, painter, dpr2) {
  var newDom = platformApi.createCanvas();
  var width = painter.getWidth();
  var height = painter.getHeight();
  var newDomStyle = newDom.style;
  if (newDomStyle) {
    newDomStyle.position = "absolute";
    newDomStyle.left = "0";
    newDomStyle.top = "0";
    newDomStyle.width = width + "px";
    newDomStyle.height = height + "px";
    newDom.setAttribute("data-zr-dom-id", id2);
  }
  newDom.width = width * dpr2;
  newDom.height = height * dpr2;
  return newDom;
}
var Layer = function(_super) {
  __extends(Layer2, _super);
  function Layer2(id2, painter, dpr2) {
    var _this = _super.call(this) || this;
    _this.motionBlur = false;
    _this.lastFrameAlpha = 0.7;
    _this.dpr = 1;
    _this.virtual = false;
    _this.config = {};
    _this.incremental = false;
    _this.zlevel = 0;
    _this.maxRepaintRectCount = 5;
    _this.__dirty = true;
    _this.__firstTimePaint = true;
    _this.__used = false;
    _this.__drawIndex = 0;
    _this.__startIndex = 0;
    _this.__endIndex = 0;
    _this.__prevStartIndex = null;
    _this.__prevEndIndex = null;
    var dom;
    dpr2 = dpr2 || devicePixelRatio;
    if (typeof id2 === "string") {
      dom = createDom(id2, painter, dpr2);
    } else if (isObject$6(id2)) {
      dom = id2;
      id2 = dom.id;
    }
    _this.id = id2;
    _this.dom = dom;
    var domStyle = dom.style;
    if (domStyle) {
      disableUserSelect(dom);
      dom.onselectstart = function() {
        return false;
      };
      domStyle.padding = "0";
      domStyle.margin = "0";
      domStyle.borderWidth = "0";
    }
    _this.painter = painter;
    _this.dpr = dpr2;
    return _this;
  }
  Layer2.prototype.getElementCount = function() {
    return this.__endIndex - this.__startIndex;
  };
  Layer2.prototype.afterBrush = function() {
    this.__prevStartIndex = this.__startIndex;
    this.__prevEndIndex = this.__endIndex;
  };
  Layer2.prototype.initContext = function() {
    this.ctx = this.dom.getContext("2d");
    this.ctx.dpr = this.dpr;
  };
  Layer2.prototype.setUnpainted = function() {
    this.__firstTimePaint = true;
  };
  Layer2.prototype.createBackBuffer = function() {
    var dpr2 = this.dpr;
    this.domBack = createDom("back-" + this.id, this.painter, dpr2);
    this.ctxBack = this.domBack.getContext("2d");
    if (dpr2 !== 1) {
      this.ctxBack.scale(dpr2, dpr2);
    }
  };
  Layer2.prototype.createRepaintRects = function(displayList, prevList, viewWidth, viewHeight) {
    if (this.__firstTimePaint) {
      this.__firstTimePaint = false;
      return null;
    }
    var mergedRepaintRects = [];
    var maxRepaintRectCount = this.maxRepaintRectCount;
    var full = false;
    var pendingRect = new BoundingRect$1(0, 0, 0, 0);
    function addRectToMergePool(rect) {
      if (!rect.isFinite() || rect.isZero()) {
        return;
      }
      if (mergedRepaintRects.length === 0) {
        var boundingRect = new BoundingRect$1(0, 0, 0, 0);
        boundingRect.copy(rect);
        mergedRepaintRects.push(boundingRect);
      } else {
        var isMerged = false;
        var minDeltaArea = Infinity;
        var bestRectToMergeIdx = 0;
        for (var i2 = 0; i2 < mergedRepaintRects.length; ++i2) {
          var mergedRect = mergedRepaintRects[i2];
          if (mergedRect.intersect(rect)) {
            var pendingRect_1 = new BoundingRect$1(0, 0, 0, 0);
            pendingRect_1.copy(mergedRect);
            pendingRect_1.union(rect);
            mergedRepaintRects[i2] = pendingRect_1;
            isMerged = true;
            break;
          } else if (full) {
            pendingRect.copy(rect);
            pendingRect.union(mergedRect);
            var aArea = rect.width * rect.height;
            var bArea = mergedRect.width * mergedRect.height;
            var pendingArea = pendingRect.width * pendingRect.height;
            var deltaArea = pendingArea - aArea - bArea;
            if (deltaArea < minDeltaArea) {
              minDeltaArea = deltaArea;
              bestRectToMergeIdx = i2;
            }
          }
        }
        if (full) {
          mergedRepaintRects[bestRectToMergeIdx].union(rect);
          isMerged = true;
        }
        if (!isMerged) {
          var boundingRect = new BoundingRect$1(0, 0, 0, 0);
          boundingRect.copy(rect);
          mergedRepaintRects.push(boundingRect);
        }
        if (!full) {
          full = mergedRepaintRects.length >= maxRepaintRectCount;
        }
      }
    }
    for (var i = this.__startIndex; i < this.__endIndex; ++i) {
      var el = displayList[i];
      if (el) {
        var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
        var prevRect = el.__isRendered && (el.__dirty & REDRAW_BIT || !shouldPaint) ? el.getPrevPaintRect() : null;
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
        var curRect = shouldPaint && (el.__dirty & REDRAW_BIT || !el.__isRendered) ? el.getPaintRect() : null;
        if (curRect) {
          addRectToMergePool(curRect);
        }
      }
    }
    for (var i = this.__prevStartIndex; i < this.__prevEndIndex; ++i) {
      var el = prevList[i];
      var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
      if (el && (!shouldPaint || !el.__zr) && el.__isRendered) {
        var prevRect = el.getPrevPaintRect();
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
      }
    }
    var hasIntersections;
    do {
      hasIntersections = false;
      for (var i = 0; i < mergedRepaintRects.length; ) {
        if (mergedRepaintRects[i].isZero()) {
          mergedRepaintRects.splice(i, 1);
          continue;
        }
        for (var j = i + 1; j < mergedRepaintRects.length; ) {
          if (mergedRepaintRects[i].intersect(mergedRepaintRects[j])) {
            hasIntersections = true;
            mergedRepaintRects[i].union(mergedRepaintRects[j]);
            mergedRepaintRects.splice(j, 1);
          } else {
            j++;
          }
        }
        i++;
      }
    } while (hasIntersections);
    this._paintRects = mergedRepaintRects;
    return mergedRepaintRects;
  };
  Layer2.prototype.debugGetPaintRects = function() {
    return (this._paintRects || []).slice();
  };
  Layer2.prototype.resize = function(width, height) {
    var dpr2 = this.dpr;
    var dom = this.dom;
    var domStyle = dom.style;
    var domBack = this.domBack;
    if (domStyle) {
      domStyle.width = width + "px";
      domStyle.height = height + "px";
    }
    dom.width = width * dpr2;
    dom.height = height * dpr2;
    if (domBack) {
      domBack.width = width * dpr2;
      domBack.height = height * dpr2;
      if (dpr2 !== 1) {
        this.ctxBack.scale(dpr2, dpr2);
      }
    }
  };
  Layer2.prototype.clear = function(clearAll, clearColor, repaintRects) {
    var dom = this.dom;
    var ctx = this.ctx;
    var width = dom.width;
    var height = dom.height;
    clearColor = clearColor || this.clearColor;
    var haveMotionBLur = this.motionBlur && !clearAll;
    var lastFrameAlpha = this.lastFrameAlpha;
    var dpr2 = this.dpr;
    var self2 = this;
    if (haveMotionBLur) {
      if (!this.domBack) {
        this.createBackBuffer();
      }
      this.ctxBack.globalCompositeOperation = "copy";
      this.ctxBack.drawImage(dom, 0, 0, width / dpr2, height / dpr2);
    }
    var domBack = this.domBack;
    function doClear(x2, y2, width2, height2) {
      ctx.clearRect(x2, y2, width2, height2);
      if (clearColor && clearColor !== "transparent") {
        var clearColorGradientOrPattern = void 0;
        if (isGradientObject(clearColor)) {
          clearColorGradientOrPattern = clearColor.__canvasGradient || getCanvasGradient(ctx, clearColor, {
            x: 0,
            y: 0,
            width: width2,
            height: height2
          });
          clearColor.__canvasGradient = clearColorGradientOrPattern;
        } else if (isImagePatternObject(clearColor)) {
          clearColorGradientOrPattern = createCanvasPattern(ctx, clearColor, {
            dirty: function() {
              self2.setUnpainted();
              self2.__painter.refresh();
            }
          });
        }
        ctx.save();
        ctx.fillStyle = clearColorGradientOrPattern || clearColor;
        ctx.fillRect(x2, y2, width2, height2);
        ctx.restore();
      }
      if (haveMotionBLur) {
        ctx.save();
        ctx.globalAlpha = lastFrameAlpha;
        ctx.drawImage(domBack, x2, y2, width2, height2);
        ctx.restore();
      }
    }
    if (!repaintRects || haveMotionBLur) {
      doClear(0, 0, width, height);
    } else if (repaintRects.length) {
      each$g(repaintRects, function(rect) {
        doClear(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
      });
    }
  };
  return Layer2;
}(Eventful$1);
var Layer$1 = Layer;
var HOVER_LAYER_ZLEVEL = 1e5;
var CANVAS_ZLEVEL = 314159;
var EL_AFTER_INCREMENTAL_INC = 0.01;
var INCREMENTAL_INC = 1e-3;
function isLayerValid(layer) {
  if (!layer) {
    return false;
  }
  if (layer.__builtin__) {
    return true;
  }
  if (typeof layer.resize !== "function" || typeof layer.refresh !== "function") {
    return false;
  }
  return true;
}
function createRoot(width, height) {
  var domRoot = document.createElement("div");
  domRoot.style.cssText = [
    "position:relative",
    "width:" + width + "px",
    "height:" + height + "px",
    "padding:0",
    "margin:0",
    "border-width:0"
  ].join(";") + ";";
  return domRoot;
}
var CanvasPainter = function() {
  function CanvasPainter2(root2, storage2, opts, id2) {
    this.type = "canvas";
    this._zlevelList = [];
    this._prevDisplayList = [];
    this._layers = {};
    this._layerConfig = {};
    this._needsManuallyCompositing = false;
    this.type = "canvas";
    var singleCanvas = !root2.nodeName || root2.nodeName.toUpperCase() === "CANVAS";
    this._opts = opts = extend({}, opts || {});
    this.dpr = opts.devicePixelRatio || devicePixelRatio;
    this._singleCanvas = singleCanvas;
    this.root = root2;
    var rootStyle = root2.style;
    if (rootStyle) {
      disableUserSelect(root2);
      root2.innerHTML = "";
    }
    this.storage = storage2;
    var zlevelList = this._zlevelList;
    this._prevDisplayList = [];
    var layers = this._layers;
    if (!singleCanvas) {
      this._width = getSize$1(root2, 0, opts);
      this._height = getSize$1(root2, 1, opts);
      var domRoot = this._domRoot = createRoot(this._width, this._height);
      root2.appendChild(domRoot);
    } else {
      var rootCanvas = root2;
      var width = rootCanvas.width;
      var height = rootCanvas.height;
      if (opts.width != null) {
        width = opts.width;
      }
      if (opts.height != null) {
        height = opts.height;
      }
      this.dpr = opts.devicePixelRatio || 1;
      rootCanvas.width = width * this.dpr;
      rootCanvas.height = height * this.dpr;
      this._width = width;
      this._height = height;
      var mainLayer = new Layer$1(rootCanvas, this, this.dpr);
      mainLayer.__builtin__ = true;
      mainLayer.initContext();
      layers[CANVAS_ZLEVEL] = mainLayer;
      mainLayer.zlevel = CANVAS_ZLEVEL;
      zlevelList.push(CANVAS_ZLEVEL);
      this._domRoot = root2;
    }
  }
  CanvasPainter2.prototype.getType = function() {
    return "canvas";
  };
  CanvasPainter2.prototype.isSingleCanvas = function() {
    return this._singleCanvas;
  };
  CanvasPainter2.prototype.getViewportRoot = function() {
    return this._domRoot;
  };
  CanvasPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  CanvasPainter2.prototype.refresh = function(paintAll) {
    var list = this.storage.getDisplayList(true);
    var prevList = this._prevDisplayList;
    var zlevelList = this._zlevelList;
    this._redrawId = Math.random();
    this._paintList(list, prevList, paintAll, this._redrawId);
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__ && layer.refresh) {
        var clearColor = i === 0 ? this._backgroundColor : null;
        layer.refresh(clearColor);
      }
    }
    if (this._opts.useDirtyRect) {
      this._prevDisplayList = list.slice();
    }
    return this;
  };
  CanvasPainter2.prototype.refreshHover = function() {
    this._paintHoverList(this.storage.getDisplayList(false));
  };
  CanvasPainter2.prototype._paintHoverList = function(list) {
    var len2 = list.length;
    var hoverLayer = this._hoverlayer;
    hoverLayer && hoverLayer.clear();
    if (!len2) {
      return;
    }
    var scope = {
      inHover: true,
      viewWidth: this._width,
      viewHeight: this._height
    };
    var ctx;
    for (var i = 0; i < len2; i++) {
      var el = list[i];
      if (el.__inHover) {
        if (!hoverLayer) {
          hoverLayer = this._hoverlayer = this.getLayer(HOVER_LAYER_ZLEVEL);
        }
        if (!ctx) {
          ctx = hoverLayer.ctx;
          ctx.save();
        }
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    if (ctx) {
      ctx.restore();
    }
  };
  CanvasPainter2.prototype.getHoverLayer = function() {
    return this.getLayer(HOVER_LAYER_ZLEVEL);
  };
  CanvasPainter2.prototype.paintOne = function(ctx, el) {
    brushSingle(ctx, el);
  };
  CanvasPainter2.prototype._paintList = function(list, prevList, paintAll, redrawId) {
    if (this._redrawId !== redrawId) {
      return;
    }
    paintAll = paintAll || false;
    this._updateLayerStatus(list);
    var _a2 = this._doPaintList(list, prevList, paintAll), finished = _a2.finished, needsRefreshHover = _a2.needsRefreshHover;
    if (this._needsManuallyCompositing) {
      this._compositeManually();
    }
    if (needsRefreshHover) {
      this._paintHoverList(list);
    }
    if (!finished) {
      var self_1 = this;
      requestAnimationFrame$2(function() {
        self_1._paintList(list, prevList, paintAll, redrawId);
      });
    } else {
      this.eachLayer(function(layer) {
        layer.afterBrush && layer.afterBrush();
      });
    }
  };
  CanvasPainter2.prototype._compositeManually = function() {
    var ctx = this.getLayer(CANVAS_ZLEVEL).ctx;
    var width = this._domRoot.width;
    var height = this._domRoot.height;
    ctx.clearRect(0, 0, width, height);
    this.eachBuiltinLayer(function(layer) {
      if (layer.virtual) {
        ctx.drawImage(layer.dom, 0, 0, width, height);
      }
    });
  };
  CanvasPainter2.prototype._doPaintList = function(list, prevList, paintAll) {
    var _this = this;
    var layerList = [];
    var useDirtyRect = this._opts.useDirtyRect;
    for (var zi2 = 0; zi2 < this._zlevelList.length; zi2++) {
      var zlevel = this._zlevelList[zi2];
      var layer = this._layers[zlevel];
      if (layer.__builtin__ && layer !== this._hoverlayer && (layer.__dirty || paintAll)) {
        layerList.push(layer);
      }
    }
    var finished = true;
    var needsRefreshHover = false;
    var _loop_1 = function(k3) {
      var layer2 = layerList[k3];
      var ctx = layer2.ctx;
      var repaintRects = useDirtyRect && layer2.createRepaintRects(list, prevList, this_1._width, this_1._height);
      var start2 = paintAll ? layer2.__startIndex : layer2.__drawIndex;
      var useTimer = !paintAll && layer2.incremental && Date.now;
      var startTime = useTimer && Date.now();
      var clearColor = layer2.zlevel === this_1._zlevelList[0] ? this_1._backgroundColor : null;
      if (layer2.__startIndex === layer2.__endIndex) {
        layer2.clear(false, clearColor, repaintRects);
      } else if (start2 === layer2.__startIndex) {
        var firstEl = list[start2];
        if (!firstEl.incremental || !firstEl.notClear || paintAll) {
          layer2.clear(false, clearColor, repaintRects);
        }
      }
      if (start2 === -1) {
        console.error("For some unknown reason. drawIndex is -1");
        start2 = layer2.__startIndex;
      }
      var i;
      var repaint = function(repaintRect) {
        var scope = {
          inHover: false,
          allClipped: false,
          prevEl: null,
          viewWidth: _this._width,
          viewHeight: _this._height
        };
        for (i = start2; i < layer2.__endIndex; i++) {
          var el = list[i];
          if (el.__inHover) {
            needsRefreshHover = true;
          }
          _this._doPaintEl(el, layer2, useDirtyRect, repaintRect, scope, i === layer2.__endIndex - 1);
          if (useTimer) {
            var dTime = Date.now() - startTime;
            if (dTime > 15) {
              break;
            }
          }
        }
        if (scope.prevElClipPaths) {
          ctx.restore();
        }
      };
      if (repaintRects) {
        if (repaintRects.length === 0) {
          i = layer2.__endIndex;
        } else {
          var dpr2 = this_1.dpr;
          for (var r2 = 0; r2 < repaintRects.length; ++r2) {
            var rect = repaintRects[r2];
            ctx.save();
            ctx.beginPath();
            ctx.rect(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
            ctx.clip();
            repaint(rect);
            ctx.restore();
          }
        }
      } else {
        ctx.save();
        repaint();
        ctx.restore();
      }
      layer2.__drawIndex = i;
      if (layer2.__drawIndex < layer2.__endIndex) {
        finished = false;
      }
    };
    var this_1 = this;
    for (var k2 = 0; k2 < layerList.length; k2++) {
      _loop_1(k2);
    }
    if (env$1.wxa) {
      each$g(this._layers, function(layer2) {
        if (layer2 && layer2.ctx && layer2.ctx.draw) {
          layer2.ctx.draw();
        }
      });
    }
    return {
      finished,
      needsRefreshHover
    };
  };
  CanvasPainter2.prototype._doPaintEl = function(el, currentLayer, useDirtyRect, repaintRect, scope, isLast) {
    var ctx = currentLayer.ctx;
    if (useDirtyRect) {
      var paintRect = el.getPaintRect();
      if (!repaintRect || paintRect && paintRect.intersect(repaintRect)) {
        brush$1(ctx, el, scope, isLast);
        el.setPrevPaintRect(paintRect);
      }
    } else {
      brush$1(ctx, el, scope, isLast);
    }
  };
  CanvasPainter2.prototype.getLayer = function(zlevel, virtual) {
    if (this._singleCanvas && !this._needsManuallyCompositing) {
      zlevel = CANVAS_ZLEVEL;
    }
    var layer = this._layers[zlevel];
    if (!layer) {
      layer = new Layer$1("zr_" + zlevel, this, this.dpr);
      layer.zlevel = zlevel;
      layer.__builtin__ = true;
      if (this._layerConfig[zlevel]) {
        merge$1(layer, this._layerConfig[zlevel], true);
      } else if (this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC]) {
        merge$1(layer, this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC], true);
      }
      if (virtual) {
        layer.virtual = virtual;
      }
      this.insertLayer(zlevel, layer);
      layer.initContext();
    }
    return layer;
  };
  CanvasPainter2.prototype.insertLayer = function(zlevel, layer) {
    var layersMap = this._layers;
    var zlevelList = this._zlevelList;
    var len2 = zlevelList.length;
    var domRoot = this._domRoot;
    var prevLayer = null;
    var i = -1;
    if (layersMap[zlevel]) {
      return;
    }
    if (!isLayerValid(layer)) {
      return;
    }
    if (len2 > 0 && zlevel > zlevelList[0]) {
      for (i = 0; i < len2 - 1; i++) {
        if (zlevelList[i] < zlevel && zlevelList[i + 1] > zlevel) {
          break;
        }
      }
      prevLayer = layersMap[zlevelList[i]];
    }
    zlevelList.splice(i + 1, 0, zlevel);
    layersMap[zlevel] = layer;
    if (!layer.virtual) {
      if (prevLayer) {
        var prevDom = prevLayer.dom;
        if (prevDom.nextSibling) {
          domRoot.insertBefore(layer.dom, prevDom.nextSibling);
        } else {
          domRoot.appendChild(layer.dom);
        }
      } else {
        if (domRoot.firstChild) {
          domRoot.insertBefore(layer.dom, domRoot.firstChild);
        } else {
          domRoot.appendChild(layer.dom);
        }
      }
    }
    layer.__painter = this;
  };
  CanvasPainter2.prototype.eachLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      cb2.call(context, this._layers[z2], z2);
    }
  };
  CanvasPainter2.prototype.eachBuiltinLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (layer.__builtin__) {
        cb2.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.eachOtherLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__) {
        cb2.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.getLayers = function() {
    return this._layers;
  };
  CanvasPainter2.prototype._updateLayerStatus = function(list) {
    this.eachBuiltinLayer(function(layer2, z2) {
      layer2.__dirty = layer2.__used = false;
    });
    function updatePrevLayer(idx) {
      if (prevLayer) {
        if (prevLayer.__endIndex !== idx) {
          prevLayer.__dirty = true;
        }
        prevLayer.__endIndex = idx;
      }
    }
    if (this._singleCanvas) {
      for (var i_1 = 1; i_1 < list.length; i_1++) {
        var el = list[i_1];
        if (el.zlevel !== list[i_1 - 1].zlevel || el.incremental) {
          this._needsManuallyCompositing = true;
          break;
        }
      }
    }
    var prevLayer = null;
    var incrementalLayerCount = 0;
    var prevZlevel;
    var i;
    for (i = 0; i < list.length; i++) {
      var el = list[i];
      var zlevel = el.zlevel;
      var layer = void 0;
      if (prevZlevel !== zlevel) {
        prevZlevel = zlevel;
        incrementalLayerCount = 0;
      }
      if (el.incremental) {
        layer = this.getLayer(zlevel + INCREMENTAL_INC, this._needsManuallyCompositing);
        layer.incremental = true;
        incrementalLayerCount = 1;
      } else {
        layer = this.getLayer(zlevel + (incrementalLayerCount > 0 ? EL_AFTER_INCREMENTAL_INC : 0), this._needsManuallyCompositing);
      }
      if (!layer.__builtin__) {
        logError("ZLevel " + zlevel + " has been used by unkown layer " + layer.id);
      }
      if (layer !== prevLayer) {
        layer.__used = true;
        if (layer.__startIndex !== i) {
          layer.__dirty = true;
        }
        layer.__startIndex = i;
        if (!layer.incremental) {
          layer.__drawIndex = i;
        } else {
          layer.__drawIndex = -1;
        }
        updatePrevLayer(i);
        prevLayer = layer;
      }
      if (el.__dirty & REDRAW_BIT && !el.__inHover) {
        layer.__dirty = true;
        if (layer.incremental && layer.__drawIndex < 0) {
          layer.__drawIndex = i;
        }
      }
    }
    updatePrevLayer(i);
    this.eachBuiltinLayer(function(layer2, z2) {
      if (!layer2.__used && layer2.getElementCount() > 0) {
        layer2.__dirty = true;
        layer2.__startIndex = layer2.__endIndex = layer2.__drawIndex = 0;
      }
      if (layer2.__dirty && layer2.__drawIndex < 0) {
        layer2.__drawIndex = layer2.__startIndex;
      }
    });
  };
  CanvasPainter2.prototype.clear = function() {
    this.eachBuiltinLayer(this._clearLayer);
    return this;
  };
  CanvasPainter2.prototype._clearLayer = function(layer) {
    layer.clear();
  };
  CanvasPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    each$g(this._layers, function(layer) {
      layer.setUnpainted();
    });
  };
  CanvasPainter2.prototype.configLayer = function(zlevel, config2) {
    if (config2) {
      var layerConfig = this._layerConfig;
      if (!layerConfig[zlevel]) {
        layerConfig[zlevel] = config2;
      } else {
        merge$1(layerConfig[zlevel], config2, true);
      }
      for (var i = 0; i < this._zlevelList.length; i++) {
        var _zlevel = this._zlevelList[i];
        if (_zlevel === zlevel || _zlevel === zlevel + EL_AFTER_INCREMENTAL_INC) {
          var layer = this._layers[_zlevel];
          merge$1(layer, layerConfig[zlevel], true);
        }
      }
    }
  };
  CanvasPainter2.prototype.delLayer = function(zlevel) {
    var layers = this._layers;
    var zlevelList = this._zlevelList;
    var layer = layers[zlevel];
    if (!layer) {
      return;
    }
    layer.dom.parentNode.removeChild(layer.dom);
    delete layers[zlevel];
    zlevelList.splice(indexOf(zlevelList, zlevel), 1);
  };
  CanvasPainter2.prototype.resize = function(width, height) {
    if (!this._domRoot.style) {
      if (width == null || height == null) {
        return;
      }
      this._width = width;
      this._height = height;
      this.getLayer(CANVAS_ZLEVEL).resize(width, height);
    } else {
      var domRoot = this._domRoot;
      domRoot.style.display = "none";
      var opts = this._opts;
      var root2 = this.root;
      width != null && (opts.width = width);
      height != null && (opts.height = height);
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      domRoot.style.display = "";
      if (this._width !== width || height !== this._height) {
        domRoot.style.width = width + "px";
        domRoot.style.height = height + "px";
        for (var id2 in this._layers) {
          if (this._layers.hasOwnProperty(id2)) {
            this._layers[id2].resize(width, height);
          }
        }
        this.refresh(true);
      }
      this._width = width;
      this._height = height;
    }
    return this;
  };
  CanvasPainter2.prototype.clearLayer = function(zlevel) {
    var layer = this._layers[zlevel];
    if (layer) {
      layer.clear();
    }
  };
  CanvasPainter2.prototype.dispose = function() {
    this.root.innerHTML = "";
    this.root = this.storage = this._domRoot = this._layers = null;
  };
  CanvasPainter2.prototype.getRenderedCanvas = function(opts) {
    opts = opts || {};
    if (this._singleCanvas && !this._compositeManually) {
      return this._layers[CANVAS_ZLEVEL].dom;
    }
    var imageLayer = new Layer$1("image", this, opts.pixelRatio || this.dpr);
    imageLayer.initContext();
    imageLayer.clear(false, opts.backgroundColor || this._backgroundColor);
    var ctx = imageLayer.ctx;
    if (opts.pixelRatio <= this.dpr) {
      this.refresh();
      var width_1 = imageLayer.dom.width;
      var height_1 = imageLayer.dom.height;
      this.eachLayer(function(layer) {
        if (layer.__builtin__) {
          ctx.drawImage(layer.dom, 0, 0, width_1, height_1);
        } else if (layer.renderToCanvas) {
          ctx.save();
          layer.renderToCanvas(ctx);
          ctx.restore();
        }
      });
    } else {
      var scope = {
        inHover: false,
        viewWidth: this._width,
        viewHeight: this._height
      };
      var displayList = this.storage.getDisplayList(true);
      for (var i = 0, len2 = displayList.length; i < len2; i++) {
        var el = displayList[i];
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    return imageLayer.dom;
  };
  CanvasPainter2.prototype.getWidth = function() {
    return this._width;
  };
  CanvasPainter2.prototype.getHeight = function() {
    return this._height;
  };
  return CanvasPainter2;
}();
var CanvasPainter$1 = CanvasPainter;
function install$R(registers) {
  registers.registerPainter("canvas", CanvasPainter$1);
}
var LineSeriesModel = function(_super) {
  __extends(LineSeriesModel2, _super);
  function LineSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LineSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  LineSeriesModel2.prototype.getInitialData = function(option) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  LineSeriesModel2.prototype.getLegendIcon = function(opt) {
    var group = new Group$6();
    var line = createSymbol$1("line", 0, opt.itemHeight / 2, opt.itemWidth, 0, opt.lineStyle.stroke, false);
    group.add(line);
    line.setStyle(opt.lineStyle);
    var visualType = this.getData().getVisual("symbol");
    var visualRotate = this.getData().getVisual("symbolRotate");
    var symbolType = visualType === "none" ? "circle" : visualType;
    var size = opt.itemHeight * 0.8;
    var symbol = createSymbol$1(symbolType, (opt.itemWidth - size) / 2, (opt.itemHeight - size) / 2, size, size, opt.itemStyle.fill);
    group.add(symbol);
    symbol.setStyle(opt.itemStyle);
    var symbolRotate = opt.iconRotate === "inherit" ? visualRotate : opt.iconRotate || 0;
    symbol.rotation = symbolRotate * Math.PI / 180;
    symbol.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
    if (symbolType.indexOf("empty") > -1) {
      symbol.style.stroke = symbol.style.fill;
      symbol.style.fill = "#fff";
      symbol.style.lineWidth = 2;
    }
    return group;
  };
  LineSeriesModel2.type = "series.line";
  LineSeriesModel2.dependencies = ["grid", "polar"];
  LineSeriesModel2.defaultOption = {
    z: 3,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    clip: true,
    label: {
      position: "top"
    },
    endLabel: {
      show: false,
      valueAnimation: true,
      distance: 8
    },
    lineStyle: {
      width: 2,
      type: "solid"
    },
    emphasis: {
      scale: true
    },
    step: false,
    smooth: false,
    smoothMonotone: null,
    symbol: "emptyCircle",
    symbolSize: 4,
    symbolRotate: null,
    showSymbol: true,
    showAllSymbol: "auto",
    connectNulls: false,
    sampling: "none",
    animationEasing: "linear",
    progressive: 0,
    hoverLayerThreshold: Infinity,
    universalTransition: {
      divideShape: "clone"
    },
    triggerLineEvent: false
  };
  return LineSeriesModel2;
}(SeriesModel$1);
var LineSeries = LineSeriesModel;
function getDefaultLabel(data2, dataIndex) {
  var labelDims = data2.mapDimensionsAll("defaultedLabel");
  var len2 = labelDims.length;
  if (len2 === 1) {
    var rawVal = retrieveRawValue(data2, dataIndex, labelDims[0]);
    return rawVal != null ? rawVal + "" : null;
  } else if (len2) {
    var vals = [];
    for (var i = 0; i < labelDims.length; i++) {
      vals.push(retrieveRawValue(data2, dataIndex, labelDims[i]));
    }
    return vals.join(" ");
  }
}
function getDefaultInterpolatedLabel(data2, interpolatedValue) {
  var labelDims = data2.mapDimensionsAll("defaultedLabel");
  if (!isArray$2(interpolatedValue)) {
    return interpolatedValue + "";
  }
  var vals = [];
  for (var i = 0; i < labelDims.length; i++) {
    var dimIndex = data2.getDimensionIndex(labelDims[i]);
    if (dimIndex >= 0) {
      vals.push(interpolatedValue[dimIndex]);
    }
  }
  return vals.join(" ");
}
var Symbol$1 = function(_super) {
  __extends(Symbol2, _super);
  function Symbol2(data2, idx, seriesScope, opts) {
    var _this = _super.call(this) || this;
    _this.updateData(data2, idx, seriesScope, opts);
    return _this;
  }
  Symbol2.prototype._createSymbol = function(symbolType, data2, idx, symbolSize, keepAspect) {
    this.removeAll();
    var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2, null, keepAspect);
    symbolPath.attr({
      z2: 100,
      culling: true,
      scaleX: symbolSize[0] / 2,
      scaleY: symbolSize[1] / 2
    });
    symbolPath.drift = driftSymbol;
    this._symbolType = symbolType;
    this.add(symbolPath);
  };
  Symbol2.prototype.stopSymbolAnimation = function(toLastFrame) {
    this.childAt(0).stopAnimation(null, toLastFrame);
  };
  Symbol2.prototype.getSymbolType = function() {
    return this._symbolType;
  };
  Symbol2.prototype.getSymbolPath = function() {
    return this.childAt(0);
  };
  Symbol2.prototype.highlight = function() {
    enterEmphasis(this.childAt(0));
  };
  Symbol2.prototype.downplay = function() {
    leaveEmphasis(this.childAt(0));
  };
  Symbol2.prototype.setZ = function(zlevel, z2) {
    var symbolPath = this.childAt(0);
    symbolPath.zlevel = zlevel;
    symbolPath.z = z2;
  };
  Symbol2.prototype.setDraggable = function(draggable) {
    var symbolPath = this.childAt(0);
    symbolPath.draggable = draggable;
    symbolPath.cursor = draggable ? "move" : symbolPath.cursor;
  };
  Symbol2.prototype.updateData = function(data2, idx, seriesScope, opts) {
    this.silent = false;
    var symbolType = data2.getItemVisual(idx, "symbol") || "circle";
    var seriesModel = data2.hostModel;
    var symbolSize = Symbol2.getSymbolSize(data2, idx);
    var isInit = symbolType !== this._symbolType;
    var disableAnimation = opts && opts.disableAnimation;
    if (isInit) {
      var keepAspect = data2.getItemVisual(idx, "symbolKeepAspect");
      this._createSymbol(symbolType, data2, idx, symbolSize, keepAspect);
    } else {
      var symbolPath = this.childAt(0);
      symbolPath.silent = false;
      var target = {
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2
      };
      disableAnimation ? symbolPath.attr(target) : updateProps$1(symbolPath, target, seriesModel, idx);
      saveOldStyle(symbolPath);
    }
    this._updateCommon(data2, idx, symbolSize, seriesScope, opts);
    if (isInit) {
      var symbolPath = this.childAt(0);
      if (!disableAnimation) {
        var target = {
          scaleX: this._sizeX,
          scaleY: this._sizeY,
          style: {
            opacity: symbolPath.style.opacity
          }
        };
        symbolPath.scaleX = symbolPath.scaleY = 0;
        symbolPath.style.opacity = 0;
        initProps(symbolPath, target, seriesModel, idx);
      }
    }
    if (disableAnimation) {
      this.childAt(0).stopAnimation("leave");
    }
  };
  Symbol2.prototype._updateCommon = function(data2, idx, symbolSize, seriesScope, opts) {
    var symbolPath = this.childAt(0);
    var seriesModel = data2.hostModel;
    var emphasisItemStyle;
    var blurItemStyle;
    var selectItemStyle;
    var focus;
    var blurScope;
    var emphasisDisabled;
    var labelStatesModels;
    var hoverScale;
    var cursorStyle;
    if (seriesScope) {
      emphasisItemStyle = seriesScope.emphasisItemStyle;
      blurItemStyle = seriesScope.blurItemStyle;
      selectItemStyle = seriesScope.selectItemStyle;
      focus = seriesScope.focus;
      blurScope = seriesScope.blurScope;
      labelStatesModels = seriesScope.labelStatesModels;
      hoverScale = seriesScope.hoverScale;
      cursorStyle = seriesScope.cursorStyle;
      emphasisDisabled = seriesScope.emphasisDisabled;
    }
    if (!seriesScope || data2.hasItemOption) {
      var itemModel = seriesScope && seriesScope.itemModel ? seriesScope.itemModel : data2.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisItemStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      selectItemStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
      blurItemStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      emphasisDisabled = emphasisModel.get("disabled");
      labelStatesModels = getLabelStatesModels(itemModel);
      hoverScale = emphasisModel.getShallow("scale");
      cursorStyle = itemModel.getShallow("cursor");
    }
    var symbolRotate = data2.getItemVisual(idx, "symbolRotate");
    symbolPath.attr("rotation", (symbolRotate || 0) * Math.PI / 180 || 0);
    var symbolOffset = normalizeSymbolOffset(data2.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      symbolPath.x = symbolOffset[0];
      symbolPath.y = symbolOffset[1];
    }
    cursorStyle && symbolPath.attr("cursor", cursorStyle);
    var symbolStyle = data2.getItemVisual(idx, "style");
    var visualColor = symbolStyle.fill;
    if (symbolPath instanceof ZRImage$1) {
      var pathStyle = symbolPath.style;
      symbolPath.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolStyle));
    } else {
      if (symbolPath.__isEmptyBrush) {
        symbolPath.useStyle(extend({}, symbolStyle));
      } else {
        symbolPath.useStyle(symbolStyle);
      }
      symbolPath.style.decal = null;
      symbolPath.setColor(visualColor, opts && opts.symbolInnerColor);
      symbolPath.style.strokeNoScale = true;
    }
    var liftZ = data2.getItemVisual(idx, "liftZ");
    var z2Origin = this._z2;
    if (liftZ != null) {
      if (z2Origin == null) {
        this._z2 = symbolPath.z2;
        symbolPath.z2 += liftZ;
      }
    } else if (z2Origin != null) {
      symbolPath.z2 = z2Origin;
      this._z2 = null;
    }
    var useNameLabel = opts && opts.useNameLabel;
    setLabelStyle(symbolPath, labelStatesModels, {
      labelFetcher: seriesModel,
      labelDataIndex: idx,
      defaultText: getLabelDefaultText,
      inheritColor: visualColor,
      defaultOpacity: symbolStyle.opacity
    });
    function getLabelDefaultText(idx2) {
      return useNameLabel ? data2.getName(idx2) : getDefaultLabel(data2, idx2);
    }
    this._sizeX = symbolSize[0] / 2;
    this._sizeY = symbolSize[1] / 2;
    var emphasisState = symbolPath.ensureState("emphasis");
    emphasisState.style = emphasisItemStyle;
    symbolPath.ensureState("select").style = selectItemStyle;
    symbolPath.ensureState("blur").style = blurItemStyle;
    if (hoverScale) {
      var scaleRatio = Math.max(1.1, 3 / this._sizeY);
      emphasisState.scaleX = this._sizeX * scaleRatio;
      emphasisState.scaleY = this._sizeY * scaleRatio;
    }
    this.setSymbolScale(1);
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Symbol2.prototype.setSymbolScale = function(scale2) {
    this.scaleX = this.scaleY = scale2;
  };
  Symbol2.prototype.fadeOut = function(cb2, seriesModel, opt) {
    var symbolPath = this.childAt(0);
    var dataIndex = getECData(this).dataIndex;
    var animationOpt = opt && opt.animation;
    this.silent = symbolPath.silent = true;
    if (opt && opt.fadeLabel) {
      var textContent = symbolPath.getTextContent();
      if (textContent) {
        removeElement(textContent, {
          style: {
            opacity: 0
          }
        }, seriesModel, {
          dataIndex,
          removeOpt: animationOpt,
          cb: function() {
            symbolPath.removeTextContent();
          }
        });
      }
    } else {
      symbolPath.removeTextContent();
    }
    removeElement(symbolPath, {
      style: {
        opacity: 0
      },
      scaleX: 0,
      scaleY: 0
    }, seriesModel, {
      dataIndex,
      cb: cb2,
      removeOpt: animationOpt
    });
  };
  Symbol2.getSymbolSize = function(data2, idx) {
    return normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
  };
  return Symbol2;
}(Group$6);
function driftSymbol(dx, dy) {
  this.parent.drift(dx, dy);
}
var SymbolClz = Symbol$1;
function symbolNeedsDraw$1(data2, point, idx, opt) {
  return point && !isNaN(point[0]) && !isNaN(point[1]) && !(opt.isIgnore && opt.isIgnore(idx)) && !(opt.clipShape && !opt.clipShape.contain(point[0], point[1])) && data2.getItemVisual(idx, "symbol") !== "none";
}
function normalizeUpdateOpt(opt) {
  if (opt != null && !isObject$6(opt)) {
    opt = {
      isIgnore: opt
    };
  }
  return opt || {};
}
function makeSeriesScope$2(data2) {
  var seriesModel = data2.hostModel;
  var emphasisModel = seriesModel.getModel("emphasis");
  return {
    emphasisItemStyle: emphasisModel.getModel("itemStyle").getItemStyle(),
    blurItemStyle: seriesModel.getModel(["blur", "itemStyle"]).getItemStyle(),
    selectItemStyle: seriesModel.getModel(["select", "itemStyle"]).getItemStyle(),
    focus: emphasisModel.get("focus"),
    blurScope: emphasisModel.get("blurScope"),
    emphasisDisabled: emphasisModel.get("disabled"),
    hoverScale: emphasisModel.get("scale"),
    labelStatesModels: getLabelStatesModels(seriesModel),
    cursorStyle: seriesModel.get("cursor")
  };
}
var SymbolDraw = function() {
  function SymbolDraw2(SymbolCtor) {
    this.group = new Group$6();
    this._SymbolCtor = SymbolCtor || SymbolClz;
  }
  SymbolDraw2.prototype.updateData = function(data2, opt) {
    this._progressiveEls = null;
    opt = normalizeUpdateOpt(opt);
    var group = this.group;
    var seriesModel = data2.hostModel;
    var oldData = this._data;
    var SymbolCtor = this._SymbolCtor;
    var disableAnimation = opt.disableAnimation;
    var seriesScope = makeSeriesScope$2(data2);
    var symbolUpdateOpt = {
      disableAnimation
    };
    var getSymbolPoint = opt.getSymbolPoint || function(idx) {
      return data2.getItemLayout(idx);
    };
    if (!oldData) {
      group.removeAll();
    }
    data2.diff(oldData).add(function(newIdx) {
      var point = getSymbolPoint(newIdx);
      if (symbolNeedsDraw$1(data2, point, newIdx, opt)) {
        var symbolEl = new SymbolCtor(data2, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
        data2.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      var point = getSymbolPoint(newIdx);
      if (!symbolNeedsDraw$1(data2, point, newIdx, opt)) {
        group.remove(symbolEl);
        return;
      }
      var newSymbolType = data2.getItemVisual(newIdx, "symbol") || "circle";
      var oldSymbolType = symbolEl && symbolEl.getSymbolType && symbolEl.getSymbolType();
      if (!symbolEl || oldSymbolType && oldSymbolType !== newSymbolType) {
        group.remove(symbolEl);
        symbolEl = new SymbolCtor(data2, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
      } else {
        symbolEl.updateData(data2, newIdx, seriesScope, symbolUpdateOpt);
        var target = {
          x: point[0],
          y: point[1]
        };
        disableAnimation ? symbolEl.attr(target) : updateProps$1(symbolEl, target, seriesModel);
      }
      group.add(symbolEl);
      data2.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && el.fadeOut(function() {
        group.remove(el);
      }, seriesModel);
    }).execute();
    this._getSymbolPoint = getSymbolPoint;
    this._data = data2;
  };
  SymbolDraw2.prototype.updateLayout = function() {
    var _this = this;
    var data2 = this._data;
    if (data2) {
      data2.eachItemGraphicEl(function(el, idx) {
        var point = _this._getSymbolPoint(idx);
        el.setPosition(point);
        el.markRedraw();
      });
    }
  };
  SymbolDraw2.prototype.incrementalPrepareUpdate = function(data2) {
    this._seriesScope = makeSeriesScope$2(data2);
    this._data = null;
    this.group.removeAll();
  };
  SymbolDraw2.prototype.incrementalUpdate = function(taskParams, data2, opt) {
    this._progressiveEls = [];
    opt = normalizeUpdateOpt(opt);
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var point = data2.getItemLayout(idx);
      if (symbolNeedsDraw$1(data2, point, idx, opt)) {
        var el = new this._SymbolCtor(data2, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        el.setPosition(point);
        this.group.add(el);
        data2.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  SymbolDraw2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  SymbolDraw2.prototype.remove = function(enableAnimation) {
    var group = this.group;
    var data2 = this._data;
    if (data2 && enableAnimation) {
      data2.eachItemGraphicEl(function(el) {
        el.fadeOut(function() {
          group.remove(el);
        }, data2.hostModel);
      });
    } else {
      group.removeAll();
    }
  };
  return SymbolDraw2;
}();
var SymbolDraw$1 = SymbolDraw;
function prepareDataCoordInfo(coordSys, data2, valueOrigin) {
  var baseAxis = coordSys.getBaseAxis();
  var valueAxis2 = coordSys.getOtherAxis(baseAxis);
  var valueStart = getValueStart(valueAxis2, valueOrigin);
  var baseAxisDim = baseAxis.dim;
  var valueAxisDim = valueAxis2.dim;
  var valueDim = data2.mapDimension(valueAxisDim);
  var baseDim = data2.mapDimension(baseAxisDim);
  var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
  var dims = map$1(coordSys.dimensions, function(coordDim) {
    return data2.mapDimension(coordDim);
  });
  var stacked = false;
  var stackResultDim = data2.getCalculationInfo("stackResultDimension");
  if (isDimensionStacked(data2, dims[0])) {
    stacked = true;
    dims[0] = stackResultDim;
  }
  if (isDimensionStacked(data2, dims[1])) {
    stacked = true;
    dims[1] = stackResultDim;
  }
  return {
    dataDimsForPoint: dims,
    valueStart,
    valueAxisDim,
    baseAxisDim,
    stacked: !!stacked,
    valueDim,
    baseDim,
    baseDataOffset,
    stackedOverDimension: data2.getCalculationInfo("stackedOverDimension")
  };
}
function getValueStart(valueAxis2, valueOrigin) {
  var valueStart = 0;
  var extent3 = valueAxis2.scale.getExtent();
  if (valueOrigin === "start") {
    valueStart = extent3[0];
  } else if (valueOrigin === "end") {
    valueStart = extent3[1];
  } else {
    if (extent3[0] > 0) {
      valueStart = extent3[0];
    } else if (extent3[1] < 0) {
      valueStart = extent3[1];
    }
  }
  return valueStart;
}
function getStackedOnPoint(dataCoordInfo, coordSys, data2, idx) {
  var value = NaN;
  if (dataCoordInfo.stacked) {
    value = data2.get(data2.getCalculationInfo("stackedOverDimension"), idx);
  }
  if (isNaN(value)) {
    value = dataCoordInfo.valueStart;
  }
  var baseDataOffset = dataCoordInfo.baseDataOffset;
  var stackedData = [];
  stackedData[baseDataOffset] = data2.get(dataCoordInfo.baseDim, idx);
  stackedData[1 - baseDataOffset] = value;
  return coordSys.dataToPoint(stackedData);
}
function diffData(oldData, newData) {
  var diffResult = [];
  newData.diff(oldData).add(function(idx) {
    diffResult.push({
      cmd: "+",
      idx
    });
  }).update(function(newIdx, oldIdx) {
    diffResult.push({
      cmd: "=",
      idx: oldIdx,
      idx1: newIdx
    });
  }).remove(function(idx) {
    diffResult.push({
      cmd: "-",
      idx
    });
  }).execute();
  return diffResult;
}
function lineAnimationDiff(oldData, newData, oldStackedOnPoints, newStackedOnPoints, oldCoordSys, newCoordSys, oldValueOrigin, newValueOrigin) {
  var diff = diffData(oldData, newData);
  var currPoints = [];
  var nextPoints = [];
  var currStackedPoints = [];
  var nextStackedPoints = [];
  var status = [];
  var sortedIndices = [];
  var rawIndices = [];
  var newDataOldCoordInfo = prepareDataCoordInfo(oldCoordSys, newData, oldValueOrigin);
  var oldPoints = oldData.getLayout("points") || [];
  var newPoints = newData.getLayout("points") || [];
  for (var i = 0; i < diff.length; i++) {
    var diffItem = diff[i];
    var pointAdded = true;
    var oldIdx2 = void 0;
    var newIdx2 = void 0;
    switch (diffItem.cmd) {
      case "=":
        oldIdx2 = diffItem.idx * 2;
        newIdx2 = diffItem.idx1 * 2;
        var currentX = oldPoints[oldIdx2];
        var currentY = oldPoints[oldIdx2 + 1];
        var nextX = newPoints[newIdx2];
        var nextY = newPoints[newIdx2 + 1];
        if (isNaN(currentX) || isNaN(currentY)) {
          currentX = nextX;
          currentY = nextY;
        }
        currPoints.push(currentX, currentY);
        nextPoints.push(nextX, nextY);
        currStackedPoints.push(oldStackedOnPoints[oldIdx2], oldStackedOnPoints[oldIdx2 + 1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(diffItem.idx1));
        break;
      case "+":
        var newIdx = diffItem.idx;
        var newDataDimsForPoint = newDataOldCoordInfo.dataDimsForPoint;
        var oldPt = oldCoordSys.dataToPoint([newData.get(newDataDimsForPoint[0], newIdx), newData.get(newDataDimsForPoint[1], newIdx)]);
        newIdx2 = newIdx * 2;
        currPoints.push(oldPt[0], oldPt[1]);
        nextPoints.push(newPoints[newIdx2], newPoints[newIdx2 + 1]);
        var stackedOnPoint = getStackedOnPoint(newDataOldCoordInfo, oldCoordSys, newData, newIdx);
        currStackedPoints.push(stackedOnPoint[0], stackedOnPoint[1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(newIdx));
        break;
      case "-":
        pointAdded = false;
    }
    if (pointAdded) {
      status.push(diffItem);
      sortedIndices.push(sortedIndices.length);
    }
  }
  sortedIndices.sort(function(a, b2) {
    return rawIndices[a] - rawIndices[b2];
  });
  var len2 = currPoints.length;
  var sortedCurrPoints = createFloat32Array(len2);
  var sortedNextPoints = createFloat32Array(len2);
  var sortedCurrStackedPoints = createFloat32Array(len2);
  var sortedNextStackedPoints = createFloat32Array(len2);
  var sortedStatus = [];
  for (var i = 0; i < sortedIndices.length; i++) {
    var idx = sortedIndices[i];
    var i2 = i * 2;
    var idx2 = idx * 2;
    sortedCurrPoints[i2] = currPoints[idx2];
    sortedCurrPoints[i2 + 1] = currPoints[idx2 + 1];
    sortedNextPoints[i2] = nextPoints[idx2];
    sortedNextPoints[i2 + 1] = nextPoints[idx2 + 1];
    sortedCurrStackedPoints[i2] = currStackedPoints[idx2];
    sortedCurrStackedPoints[i2 + 1] = currStackedPoints[idx2 + 1];
    sortedNextStackedPoints[i2] = nextStackedPoints[idx2];
    sortedNextStackedPoints[i2 + 1] = nextStackedPoints[idx2 + 1];
    sortedStatus[i] = status[idx];
  }
  return {
    current: sortedCurrPoints,
    next: sortedNextPoints,
    stackedOnCurrent: sortedCurrStackedPoints,
    stackedOnNext: sortedNextStackedPoints,
    status: sortedStatus
  };
}
var mathMin$5 = Math.min;
var mathMax$5 = Math.max;
function isPointNull$1(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function drawSegment(ctx, points2, start2, segLen, allLen, dir3, smooth, smoothMonotone, connectNulls) {
  var prevX;
  var prevY;
  var cpx0;
  var cpy0;
  var cpx1;
  var cpy1;
  var idx = start2;
  var k2 = 0;
  for (; k2 < segLen; k2++) {
    var x2 = points2[idx * 2];
    var y2 = points2[idx * 2 + 1];
    if (idx >= allLen || idx < 0) {
      break;
    }
    if (isPointNull$1(x2, y2)) {
      if (connectNulls) {
        idx += dir3;
        continue;
      }
      break;
    }
    if (idx === start2) {
      ctx[dir3 > 0 ? "moveTo" : "lineTo"](x2, y2);
      cpx0 = x2;
      cpy0 = y2;
    } else {
      var dx = x2 - prevX;
      var dy = y2 - prevY;
      if (dx * dx + dy * dy < 0.5) {
        idx += dir3;
        continue;
      }
      if (smooth > 0) {
        var nextIdx = idx + dir3;
        var nextX = points2[nextIdx * 2];
        var nextY = points2[nextIdx * 2 + 1];
        while (nextX === x2 && nextY === y2 && k2 < segLen) {
          k2++;
          nextIdx += dir3;
          idx += dir3;
          nextX = points2[nextIdx * 2];
          nextY = points2[nextIdx * 2 + 1];
          x2 = points2[idx * 2];
          y2 = points2[idx * 2 + 1];
          dx = x2 - prevX;
          dy = y2 - prevY;
        }
        var tmpK = k2 + 1;
        if (connectNulls) {
          while (isPointNull$1(nextX, nextY) && tmpK < segLen) {
            tmpK++;
            nextIdx += dir3;
            nextX = points2[nextIdx * 2];
            nextY = points2[nextIdx * 2 + 1];
          }
        }
        var ratioNextSeg = 0.5;
        var vx = 0;
        var vy = 0;
        var nextCpx0 = void 0;
        var nextCpy0 = void 0;
        if (tmpK >= segLen || isPointNull$1(nextX, nextY)) {
          cpx1 = x2;
          cpy1 = y2;
        } else {
          vx = nextX - prevX;
          vy = nextY - prevY;
          var dx0 = x2 - prevX;
          var dx1 = nextX - x2;
          var dy0 = y2 - prevY;
          var dy1 = nextY - y2;
          var lenPrevSeg = void 0;
          var lenNextSeg = void 0;
          if (smoothMonotone === "x") {
            lenPrevSeg = Math.abs(dx0);
            lenNextSeg = Math.abs(dx1);
            var dir_1 = vx > 0 ? 1 : -1;
            cpx1 = x2 - dir_1 * lenPrevSeg * smooth;
            cpy1 = y2;
            nextCpx0 = x2 + dir_1 * lenNextSeg * smooth;
            nextCpy0 = y2;
          } else if (smoothMonotone === "y") {
            lenPrevSeg = Math.abs(dy0);
            lenNextSeg = Math.abs(dy1);
            var dir_2 = vy > 0 ? 1 : -1;
            cpx1 = x2;
            cpy1 = y2 - dir_2 * lenPrevSeg * smooth;
            nextCpx0 = x2;
            nextCpy0 = y2 + dir_2 * lenNextSeg * smooth;
          } else {
            lenPrevSeg = Math.sqrt(dx0 * dx0 + dy0 * dy0);
            lenNextSeg = Math.sqrt(dx1 * dx1 + dy1 * dy1);
            ratioNextSeg = lenNextSeg / (lenNextSeg + lenPrevSeg);
            cpx1 = x2 - vx * smooth * (1 - ratioNextSeg);
            cpy1 = y2 - vy * smooth * (1 - ratioNextSeg);
            nextCpx0 = x2 + vx * smooth * ratioNextSeg;
            nextCpy0 = y2 + vy * smooth * ratioNextSeg;
            nextCpx0 = mathMin$5(nextCpx0, mathMax$5(nextX, x2));
            nextCpy0 = mathMin$5(nextCpy0, mathMax$5(nextY, y2));
            nextCpx0 = mathMax$5(nextCpx0, mathMin$5(nextX, x2));
            nextCpy0 = mathMax$5(nextCpy0, mathMin$5(nextY, y2));
            vx = nextCpx0 - x2;
            vy = nextCpy0 - y2;
            cpx1 = x2 - vx * lenPrevSeg / lenNextSeg;
            cpy1 = y2 - vy * lenPrevSeg / lenNextSeg;
            cpx1 = mathMin$5(cpx1, mathMax$5(prevX, x2));
            cpy1 = mathMin$5(cpy1, mathMax$5(prevY, y2));
            cpx1 = mathMax$5(cpx1, mathMin$5(prevX, x2));
            cpy1 = mathMax$5(cpy1, mathMin$5(prevY, y2));
            vx = x2 - cpx1;
            vy = y2 - cpy1;
            nextCpx0 = x2 + vx * lenNextSeg / lenPrevSeg;
            nextCpy0 = y2 + vy * lenNextSeg / lenPrevSeg;
          }
        }
        ctx.bezierCurveTo(cpx0, cpy0, cpx1, cpy1, x2, y2);
        cpx0 = nextCpx0;
        cpy0 = nextCpy0;
      } else {
        ctx.lineTo(x2, y2);
      }
    }
    prevX = x2;
    prevY = y2;
    idx += dir3;
  }
  return k2;
}
var ECPolylineShape = function() {
  function ECPolylineShape2() {
    this.smooth = 0;
    this.smoothConstraint = true;
  }
  return ECPolylineShape2;
}();
var ECPolyline = function(_super) {
  __extends(ECPolyline2, _super);
  function ECPolyline2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polyline";
    return _this;
  }
  ECPolyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECPolyline2.prototype.getDefaultShape = function() {
    return new ECPolylineShape();
  };
  ECPolyline2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var i = 0;
    var len2 = points2.length / 2;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      i += drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, shape.smoothMonotone, shape.connectNulls) + 1;
    }
  };
  ECPolyline2.prototype.getPointOn = function(xOrY, dim) {
    if (!this.path) {
      this.createPathProxy();
      this.buildPath(this.path, this.shape);
    }
    var path = this.path;
    var data2 = path.data;
    var CMD2 = PathProxy$1.CMD;
    var x0;
    var y0;
    var isDimX = dim === "x";
    var roots2 = [];
    for (var i = 0; i < data2.length; ) {
      var cmd = data2[i++];
      var x2 = void 0;
      var y2 = void 0;
      var x22 = void 0;
      var y22 = void 0;
      var x3 = void 0;
      var y3 = void 0;
      var t2 = void 0;
      switch (cmd) {
        case CMD2.M:
          x0 = data2[i++];
          y0 = data2[i++];
          break;
        case CMD2.L:
          x2 = data2[i++];
          y2 = data2[i++];
          t2 = isDimX ? (xOrY - x0) / (x2 - x0) : (xOrY - y0) / (y2 - y0);
          if (t2 <= 1 && t2 >= 0) {
            var val = isDimX ? (y2 - y0) * t2 + y0 : (x2 - x0) * t2 + x0;
            return isDimX ? [xOrY, val] : [val, xOrY];
          }
          x0 = x2;
          y0 = y2;
          break;
        case CMD2.C:
          x2 = data2[i++];
          y2 = data2[i++];
          x22 = data2[i++];
          y22 = data2[i++];
          x3 = data2[i++];
          y3 = data2[i++];
          var nRoot = isDimX ? cubicRootAt(x0, x2, x22, x3, xOrY, roots2) : cubicRootAt(y0, y2, y22, y3, xOrY, roots2);
          if (nRoot > 0) {
            for (var i_1 = 0; i_1 < nRoot; i_1++) {
              var t_1 = roots2[i_1];
              if (t_1 <= 1 && t_1 >= 0) {
                var val = isDimX ? cubicAt(y0, y2, y22, y3, t_1) : cubicAt(x0, x2, x22, x3, t_1);
                return isDimX ? [xOrY, val] : [val, xOrY];
              }
            }
          }
          x0 = x3;
          y0 = y3;
          break;
      }
    }
  };
  return ECPolyline2;
}(Path$1);
var ECPolygonShape = function(_super) {
  __extends(ECPolygonShape2, _super);
  function ECPolygonShape2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return ECPolygonShape2;
}(ECPolylineShape);
var ECPolygon = function(_super) {
  __extends(ECPolygon2, _super);
  function ECPolygon2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polygon";
    return _this;
  }
  ECPolygon2.prototype.getDefaultShape = function() {
    return new ECPolygonShape();
  };
  ECPolygon2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var stackedOnPoints = shape.stackedOnPoints;
    var i = 0;
    var len2 = points2.length / 2;
    var smoothMonotone = shape.smoothMonotone;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      var k2 = drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, smoothMonotone, shape.connectNulls);
      drawSegment(ctx, stackedOnPoints, i + k2 - 1, k2, len2, -1, shape.stackedOnSmooth, smoothMonotone, shape.connectNulls);
      i += k2 + 1;
      ctx.closePath();
    }
  };
  return ECPolygon2;
}(Path$1);
function createGridClipPath(cartesian, hasAnimation, seriesModel, done, during) {
  var rect = cartesian.getArea();
  var x2 = rect.x;
  var y2 = rect.y;
  var width = rect.width;
  var height = rect.height;
  var lineWidth = seriesModel.get(["lineStyle", "width"]) || 2;
  x2 -= lineWidth / 2;
  y2 -= lineWidth / 2;
  width += lineWidth;
  height += lineWidth;
  x2 = Math.floor(x2);
  width = Math.round(width);
  var clipPath = new Rect$3({
    shape: {
      x: x2,
      y: y2,
      width,
      height
    }
  });
  if (hasAnimation) {
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var isAxisInversed = baseAxis.inverse;
    if (isHorizontal) {
      if (isAxisInversed) {
        clipPath.shape.x += width;
      }
      clipPath.shape.width = 0;
    } else {
      if (!isAxisInversed) {
        clipPath.shape.y += height;
      }
      clipPath.shape.height = 0;
    }
    var duringCb = isFunction$1(during) ? function(percent) {
      during(percent, clipPath);
    } : null;
    initProps(clipPath, {
      shape: {
        width,
        height,
        x: x2,
        y: y2
      }
    }, seriesModel, null, done, duringCb);
  }
  return clipPath;
}
function createPolarClipPath(polar, hasAnimation, seriesModel) {
  var sectorArea = polar.getArea();
  var r0 = round$3(sectorArea.r0, 1);
  var r2 = round$3(sectorArea.r, 1);
  var clipPath = new Sector$1({
    shape: {
      cx: round$3(polar.cx, 1),
      cy: round$3(polar.cy, 1),
      r0,
      r: r2,
      startAngle: sectorArea.startAngle,
      endAngle: sectorArea.endAngle,
      clockwise: sectorArea.clockwise
    }
  });
  if (hasAnimation) {
    var isRadial = polar.getBaseAxis().dim === "angle";
    if (isRadial) {
      clipPath.shape.endAngle = sectorArea.startAngle;
    } else {
      clipPath.shape.r = r0;
    }
    initProps(clipPath, {
      shape: {
        endAngle: sectorArea.endAngle,
        r: r2
      }
    }, seriesModel);
  }
  return clipPath;
}
function createClipPath(coordSys, hasAnimation, seriesModel, done, during) {
  if (!coordSys) {
    return null;
  } else if (coordSys.type === "polar") {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  } else if (coordSys.type === "cartesian2d") {
    return createGridClipPath(coordSys, hasAnimation, seriesModel, done, during);
  }
  return null;
}
function isCoordinateSystemType(coordSys, type4) {
  return coordSys.type === type4;
}
function isPointsSame(points1, points2) {
  if (points1.length !== points2.length) {
    return;
  }
  for (var i = 0; i < points1.length; i++) {
    if (points1[i] !== points2[i]) {
      return;
    }
  }
  return true;
}
function bboxFromPoints(points2) {
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  for (var i = 0; i < points2.length; ) {
    var x2 = points2[i++];
    var y2 = points2[i++];
    if (!isNaN(x2)) {
      minX = Math.min(x2, minX);
      maxX = Math.max(x2, maxX);
    }
    if (!isNaN(y2)) {
      minY = Math.min(y2, minY);
      maxY = Math.max(y2, maxY);
    }
  }
  return [[minX, minY], [maxX, maxY]];
}
function getBoundingDiff(points1, points2) {
  var _a2 = bboxFromPoints(points1), min1 = _a2[0], max1 = _a2[1];
  var _b2 = bboxFromPoints(points2), min22 = _b2[0], max22 = _b2[1];
  return Math.max(Math.abs(min1[0] - min22[0]), Math.abs(min1[1] - min22[1]), Math.abs(max1[0] - max22[0]), Math.abs(max1[1] - max22[1]));
}
function getSmooth(smooth) {
  return isNumber(smooth) ? smooth : smooth ? 0.5 : 0;
}
function getStackedOnPoints(coordSys, data2, dataCoordInfo) {
  if (!dataCoordInfo.valueDim) {
    return [];
  }
  var len2 = data2.count();
  var points2 = createFloat32Array(len2 * 2);
  for (var idx = 0; idx < len2; idx++) {
    var pt = getStackedOnPoint(dataCoordInfo, coordSys, data2, idx);
    points2[idx * 2] = pt[0];
    points2[idx * 2 + 1] = pt[1];
  }
  return points2;
}
function turnPointsIntoStep(points2, coordSys, stepTurnAt, connectNulls) {
  var baseAxis = coordSys.getBaseAxis();
  var baseIndex = baseAxis.dim === "x" || baseAxis.dim === "radius" ? 0 : 1;
  var stepPoints = [];
  var i = 0;
  var stepPt = [];
  var pt = [];
  var nextPt = [];
  var filteredPoints = [];
  if (connectNulls) {
    for (i = 0; i < points2.length; i += 2) {
      if (!isNaN(points2[i]) && !isNaN(points2[i + 1])) {
        filteredPoints.push(points2[i], points2[i + 1]);
      }
    }
    points2 = filteredPoints;
  }
  for (i = 0; i < points2.length - 2; i += 2) {
    nextPt[0] = points2[i + 2];
    nextPt[1] = points2[i + 3];
    pt[0] = points2[i];
    pt[1] = points2[i + 1];
    stepPoints.push(pt[0], pt[1]);
    switch (stepTurnAt) {
      case "end":
        stepPt[baseIndex] = nextPt[baseIndex];
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        break;
      case "middle":
        var middle = (pt[baseIndex] + nextPt[baseIndex]) / 2;
        var stepPt2 = [];
        stepPt[baseIndex] = stepPt2[baseIndex] = middle;
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPt2[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        stepPoints.push(stepPt2[0], stepPt2[1]);
        break;
      default:
        stepPt[baseIndex] = pt[baseIndex];
        stepPt[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
    }
  }
  stepPoints.push(points2[i++], points2[i++]);
  return stepPoints;
}
function clipColorStops(colorStops, maxSize) {
  var newColorStops = [];
  var len2 = colorStops.length;
  var prevOutOfRangeColorStop;
  var prevInRangeColorStop;
  function lerpStop(stop0, stop1, clippedCoord) {
    var coord0 = stop0.coord;
    var p2 = (clippedCoord - coord0) / (stop1.coord - coord0);
    var color = lerp(p2, [stop0.color, stop1.color]);
    return {
      coord: clippedCoord,
      color
    };
  }
  for (var i = 0; i < len2; i++) {
    var stop_1 = colorStops[i];
    var coord = stop_1.coord;
    if (coord < 0) {
      prevOutOfRangeColorStop = stop_1;
    } else if (coord > maxSize) {
      if (prevInRangeColorStop) {
        newColorStops.push(lerpStop(prevInRangeColorStop, stop_1, maxSize));
      } else if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0), lerpStop(prevOutOfRangeColorStop, stop_1, maxSize));
      }
      break;
    } else {
      if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0));
        prevOutOfRangeColorStop = null;
      }
      newColorStops.push(stop_1);
      prevInRangeColorStop = stop_1;
    }
  }
  return newColorStops;
}
function getVisualGradient(data2, coordSys, api) {
  var visualMetaList = data2.getVisual("visualMeta");
  if (!visualMetaList || !visualMetaList.length || !data2.count()) {
    return;
  }
  if (coordSys.type !== "cartesian2d") {
    return;
  }
  var coordDim;
  var visualMeta;
  for (var i = visualMetaList.length - 1; i >= 0; i--) {
    var dimInfo = data2.getDimensionInfo(visualMetaList[i].dimension);
    coordDim = dimInfo && dimInfo.coordDim;
    if (coordDim === "x" || coordDim === "y") {
      visualMeta = visualMetaList[i];
      break;
    }
  }
  if (!visualMeta) {
    return;
  }
  var axis = coordSys.getAxis(coordDim);
  var colorStops = map$1(visualMeta.stops, function(stop2) {
    return {
      coord: axis.toGlobalCoord(axis.dataToCoord(stop2.value)),
      color: stop2.color
    };
  });
  var stopLen = colorStops.length;
  var outerColors = visualMeta.outerColors.slice();
  if (stopLen && colorStops[0].coord > colorStops[stopLen - 1].coord) {
    colorStops.reverse();
    outerColors.reverse();
  }
  var colorStopsInRange = clipColorStops(colorStops, coordDim === "x" ? api.getWidth() : api.getHeight());
  var inRangeStopLen = colorStopsInRange.length;
  if (!inRangeStopLen && stopLen) {
    return colorStops[0].coord < 0 ? outerColors[1] ? outerColors[1] : colorStops[stopLen - 1].color : outerColors[0] ? outerColors[0] : colorStops[0].color;
  }
  var tinyExtent = 10;
  var minCoord = colorStopsInRange[0].coord - tinyExtent;
  var maxCoord = colorStopsInRange[inRangeStopLen - 1].coord + tinyExtent;
  var coordSpan = maxCoord - minCoord;
  if (coordSpan < 1e-3) {
    return "transparent";
  }
  each$g(colorStopsInRange, function(stop2) {
    stop2.offset = (stop2.coord - minCoord) / coordSpan;
  });
  colorStopsInRange.push({
    offset: inRangeStopLen ? colorStopsInRange[inRangeStopLen - 1].offset : 0.5,
    color: outerColors[1] || "transparent"
  });
  colorStopsInRange.unshift({
    offset: inRangeStopLen ? colorStopsInRange[0].offset : 0.5,
    color: outerColors[0] || "transparent"
  });
  var gradient = new LinearGradient$1(0, 0, 0, 0, colorStopsInRange, true);
  gradient[coordDim] = minCoord;
  gradient[coordDim + "2"] = maxCoord;
  return gradient;
}
function getIsIgnoreFunc(seriesModel, data2, coordSys) {
  var showAllSymbol = seriesModel.get("showAllSymbol");
  var isAuto = showAllSymbol === "auto";
  if (showAllSymbol && !isAuto) {
    return;
  }
  var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
  if (!categoryAxis2) {
    return;
  }
  if (isAuto && canShowAllSymbolForCategory(categoryAxis2, data2)) {
    return;
  }
  var categoryDataDim = data2.mapDimension(categoryAxis2.dim);
  var labelMap = {};
  each$g(categoryAxis2.getViewLabels(), function(labelItem) {
    var ordinalNumber = categoryAxis2.scale.getRawOrdinalNumber(labelItem.tickValue);
    labelMap[ordinalNumber] = 1;
  });
  return function(dataIndex) {
    return !labelMap.hasOwnProperty(data2.get(categoryDataDim, dataIndex));
  };
}
function canShowAllSymbolForCategory(categoryAxis2, data2) {
  var axisExtent = categoryAxis2.getExtent();
  var availSize = Math.abs(axisExtent[1] - axisExtent[0]) / categoryAxis2.scale.count();
  isNaN(availSize) && (availSize = 0);
  var dataLen = data2.count();
  var step = Math.max(1, Math.round(dataLen / 5));
  for (var dataIndex = 0; dataIndex < dataLen; dataIndex += step) {
    if (SymbolClz.getSymbolSize(data2, dataIndex)[categoryAxis2.isHorizontal() ? 1 : 0] * 1.5 > availSize) {
      return false;
    }
  }
  return true;
}
function isPointNull(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function getLastIndexNotNull(points2) {
  var len2 = points2.length / 2;
  for (; len2 > 0; len2--) {
    if (!isPointNull(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
      break;
    }
  }
  return len2 - 1;
}
function getPointAtIndex(points2, idx) {
  return [points2[idx * 2], points2[idx * 2 + 1]];
}
function getIndexRange(points2, xOrY, dim) {
  var len2 = points2.length / 2;
  var dimIdx = dim === "x" ? 0 : 1;
  var a;
  var b2;
  var prevIndex = 0;
  var nextIndex2 = -1;
  for (var i = 0; i < len2; i++) {
    b2 = points2[i * 2 + dimIdx];
    if (isNaN(b2) || isNaN(points2[i * 2 + 1 - dimIdx])) {
      continue;
    }
    if (i === 0) {
      a = b2;
      continue;
    }
    if (a <= xOrY && b2 >= xOrY || a >= xOrY && b2 <= xOrY) {
      nextIndex2 = i;
      break;
    }
    prevIndex = i;
    a = b2;
  }
  return {
    range: [prevIndex, nextIndex2],
    t: (xOrY - a) / (b2 - a)
  };
}
function anyStateShowEndLabel(seriesModel) {
  if (seriesModel.get(["endLabel", "show"])) {
    return true;
  }
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    if (seriesModel.get([SPECIAL_STATES[i], "endLabel", "show"])) {
      return true;
    }
  }
  return false;
}
function createLineClipPath(lineView, coordSys, hasAnimation, seriesModel) {
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    var endLabelModel_1 = seriesModel.getModel("endLabel");
    var valueAnimation_1 = endLabelModel_1.get("valueAnimation");
    var data_1 = seriesModel.getData();
    var labelAnimationRecord_1 = {
      lastFrameIndex: 0
    };
    var during = anyStateShowEndLabel(seriesModel) ? function(percent, clipRect) {
      lineView._endLabelOnDuring(percent, clipRect, data_1, labelAnimationRecord_1, valueAnimation_1, endLabelModel_1, coordSys);
    } : null;
    var isHorizontal = coordSys.getBaseAxis().isHorizontal();
    var clipPath = createGridClipPath(coordSys, hasAnimation, seriesModel, function() {
      var endLabel = lineView._endLabel;
      if (endLabel && hasAnimation) {
        if (labelAnimationRecord_1.originalX != null) {
          endLabel.attr({
            x: labelAnimationRecord_1.originalX,
            y: labelAnimationRecord_1.originalY
          });
        }
      }
    }, during);
    if (!seriesModel.get("clip", true)) {
      var rectShape = clipPath.shape;
      var expandSize = Math.max(rectShape.width, rectShape.height);
      if (isHorizontal) {
        rectShape.y -= expandSize;
        rectShape.height += expandSize * 2;
      } else {
        rectShape.x -= expandSize;
        rectShape.width += expandSize * 2;
      }
    }
    if (during) {
      during(1, clipPath);
    }
    return clipPath;
  } else {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  }
}
function getEndLabelStateSpecified(endLabelModel, coordSys) {
  var baseAxis = coordSys.getBaseAxis();
  var isHorizontal = baseAxis.isHorizontal();
  var isBaseInversed = baseAxis.inverse;
  var align = isHorizontal ? isBaseInversed ? "right" : "left" : "center";
  var verticalAlign = isHorizontal ? "middle" : isBaseInversed ? "top" : "bottom";
  return {
    normal: {
      align: endLabelModel.get("align") || align,
      verticalAlign: endLabelModel.get("verticalAlign") || verticalAlign
    }
  };
}
var LineView = function(_super) {
  __extends(LineView2, _super);
  function LineView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  LineView2.prototype.init = function() {
    var lineGroup = new Group$6();
    var symbolDraw = new SymbolDraw$1();
    this.group.add(symbolDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineGroup = lineGroup;
  };
  LineView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    var group = this.group;
    var data2 = seriesModel.getData();
    var lineStyleModel = seriesModel.getModel("lineStyle");
    var areaStyleModel = seriesModel.getModel("areaStyle");
    var points2 = data2.getLayout("points") || [];
    var isCoordSysPolar = coordSys.type === "polar";
    var prevCoordSys = this._coordSys;
    var symbolDraw = this._symbolDraw;
    var polyline = this._polyline;
    var polygon = this._polygon;
    var lineGroup = this._lineGroup;
    var hasAnimation = seriesModel.get("animation");
    var isAreaChart = !areaStyleModel.isEmpty();
    var valueOrigin = areaStyleModel.get("origin");
    var dataCoordInfo = prepareDataCoordInfo(coordSys, data2, valueOrigin);
    var stackedOnPoints = isAreaChart && getStackedOnPoints(coordSys, data2, dataCoordInfo);
    var showSymbol = seriesModel.get("showSymbol");
    var connectNulls = seriesModel.get("connectNulls");
    var isIgnoreFunc = showSymbol && !isCoordSysPolar && getIsIgnoreFunc(seriesModel, data2, coordSys);
    var oldData = this._data;
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    if (!showSymbol) {
      symbolDraw.remove();
    }
    group.add(lineGroup);
    var step = !isCoordSysPolar ? seriesModel.get("step") : false;
    var clipShapeForSymbol;
    if (coordSys && coordSys.getArea && seriesModel.get("clip", true)) {
      clipShapeForSymbol = coordSys.getArea();
      if (clipShapeForSymbol.width != null) {
        clipShapeForSymbol.x -= 0.1;
        clipShapeForSymbol.y -= 0.1;
        clipShapeForSymbol.width += 0.2;
        clipShapeForSymbol.height += 0.2;
      } else if (clipShapeForSymbol.r0) {
        clipShapeForSymbol.r0 -= 0.5;
        clipShapeForSymbol.r += 0.5;
      }
    }
    this._clipShapeForSymbol = clipShapeForSymbol;
    var visualColor = getVisualGradient(data2, coordSys, api) || data2.getVisual("style")[data2.getVisual("drawType")];
    if (!(polyline && prevCoordSys.type === coordSys.type && step === this._step)) {
      showSymbol && symbolDraw.updateData(data2, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      hasAnimation && this._initSymbolLabelAnimation(data2, coordSys, clipShapeForSymbol);
      if (step) {
        points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
        if (stackedOnPoints) {
          stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
        }
      }
      polyline = this._newPolyline(points2);
      if (isAreaChart) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
    } else {
      if (isAreaChart && !polygon) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      } else if (polygon && !isAreaChart) {
        lineGroup.remove(polygon);
        polygon = this._polygon = null;
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      var oldClipPath = lineGroup.getClipPath();
      if (oldClipPath) {
        var newClipPath = createLineClipPath(this, coordSys, false, seriesModel);
        initProps(oldClipPath, {
          shape: newClipPath.shape
        }, seriesModel);
      } else {
        lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
      }
      showSymbol && symbolDraw.updateData(data2, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      if (!isPointsSame(this._stackedOnPoints, stackedOnPoints) || !isPointsSame(this._points, points2)) {
        if (hasAnimation) {
          this._doUpdateAnimation(data2, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls);
        } else {
          if (step) {
            points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
            if (stackedOnPoints) {
              stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
            }
          }
          polyline.setShape({
            points: points2
          });
          polygon && polygon.setShape({
            points: points2,
            stackedOnPoints
          });
        }
      }
    }
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    polyline.useStyle(defaults(lineStyleModel.getLineStyle(), {
      fill: "none",
      stroke: visualColor,
      lineJoin: "bevel"
    }));
    setStatesStylesFromModel(polyline, seriesModel, "lineStyle");
    if (polyline.style.lineWidth > 0 && seriesModel.get(["emphasis", "lineStyle", "width"]) === "bolder") {
      var emphasisLineStyle = polyline.getState("emphasis").style;
      emphasisLineStyle.lineWidth = +polyline.style.lineWidth + 1;
    }
    getECData(polyline).seriesIndex = seriesModel.seriesIndex;
    toggleHoverEmphasis(polyline, focus, blurScope, emphasisDisabled);
    var smooth = getSmooth(seriesModel.get("smooth"));
    var smoothMonotone = seriesModel.get("smoothMonotone");
    polyline.setShape({
      smooth,
      smoothMonotone,
      connectNulls
    });
    if (polygon) {
      var stackedOnSeries = data2.getCalculationInfo("stackedOnSeries");
      var stackedOnSmooth = 0;
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: visualColor,
        opacity: 0.7,
        lineJoin: "bevel",
        decal: data2.getVisual("style").decal
      }));
      if (stackedOnSeries) {
        stackedOnSmooth = getSmooth(stackedOnSeries.get("smooth"));
      }
      polygon.setShape({
        smooth,
        stackedOnSmooth,
        smoothMonotone,
        connectNulls
      });
      setStatesStylesFromModel(polygon, seriesModel, "areaStyle");
      getECData(polygon).seriesIndex = seriesModel.seriesIndex;
      toggleHoverEmphasis(polygon, focus, blurScope, emphasisDisabled);
    }
    var changePolyState = function(toState) {
      _this._changePolyState(toState);
    };
    data2.eachItemGraphicEl(function(el) {
      el && (el.onHoverStateChange = changePolyState);
    });
    this._polyline.onHoverStateChange = changePolyState;
    this._data = data2;
    this._coordSys = coordSys;
    this._stackedOnPoints = stackedOnPoints;
    this._points = points2;
    this._step = step;
    this._valueOrigin = valueOrigin;
    if (seriesModel.get("triggerLineEvent")) {
      this.packEventData(seriesModel, polyline);
      polygon && this.packEventData(seriesModel, polygon);
    }
  };
  LineView2.prototype.packEventData = function(seriesModel, el) {
    getECData(el).eventData = {
      componentType: "series",
      componentSubType: "line",
      componentIndex: seriesModel.componentIndex,
      seriesIndex: seriesModel.seriesIndex,
      seriesName: seriesModel.name,
      seriesType: "line"
    };
  };
  LineView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data2 = seriesModel.getData();
    var dataIndex = queryDataIndex(data2, payload);
    this._changePolyState("emphasis");
    if (!(dataIndex instanceof Array) && dataIndex != null && dataIndex >= 0) {
      var points2 = data2.getLayout("points");
      var symbol = data2.getItemGraphicEl(dataIndex);
      if (!symbol) {
        var x2 = points2[dataIndex * 2];
        var y2 = points2[dataIndex * 2 + 1];
        if (isNaN(x2) || isNaN(y2)) {
          return;
        }
        if (this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x2, y2)) {
          return;
        }
        var zlevel = seriesModel.get("zlevel");
        var z2 = seriesModel.get("z");
        symbol = new SymbolClz(data2, dataIndex);
        symbol.x = x2;
        symbol.y = y2;
        symbol.setZ(zlevel, z2);
        var symbolLabel = symbol.getSymbolPath().getTextContent();
        if (symbolLabel) {
          symbolLabel.zlevel = zlevel;
          symbolLabel.z = z2;
          symbolLabel.z2 = this._polyline.z2 + 1;
        }
        symbol.__temp = true;
        data2.setItemGraphicEl(dataIndex, symbol);
        symbol.stopSymbolAnimation(true);
        this.group.add(symbol);
      }
      symbol.highlight();
    } else {
      ChartView$1.prototype.highlight.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data2 = seriesModel.getData();
    var dataIndex = queryDataIndex(data2, payload);
    this._changePolyState("normal");
    if (dataIndex != null && dataIndex >= 0) {
      var symbol = data2.getItemGraphicEl(dataIndex);
      if (symbol) {
        if (symbol.__temp) {
          data2.setItemGraphicEl(dataIndex, null);
          this.group.remove(symbol);
        } else {
          symbol.downplay();
        }
      }
    } else {
      ChartView$1.prototype.downplay.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype._changePolyState = function(toState) {
    var polygon = this._polygon;
    setStatesFlag(this._polyline, toState);
    polygon && setStatesFlag(polygon, toState);
  };
  LineView2.prototype._newPolyline = function(points2) {
    var polyline = this._polyline;
    if (polyline) {
      this._lineGroup.remove(polyline);
    }
    polyline = new ECPolyline({
      shape: {
        points: points2
      },
      segmentIgnoreThreshold: 2,
      z2: 10
    });
    this._lineGroup.add(polyline);
    this._polyline = polyline;
    return polyline;
  };
  LineView2.prototype._newPolygon = function(points2, stackedOnPoints) {
    var polygon = this._polygon;
    if (polygon) {
      this._lineGroup.remove(polygon);
    }
    polygon = new ECPolygon({
      shape: {
        points: points2,
        stackedOnPoints
      },
      segmentIgnoreThreshold: 2
    });
    this._lineGroup.add(polygon);
    this._polygon = polygon;
    return polygon;
  };
  LineView2.prototype._initSymbolLabelAnimation = function(data2, coordSys, clipShape) {
    var isHorizontalOrRadial;
    var isCoordSysPolar;
    var baseAxis = coordSys.getBaseAxis();
    var isAxisInverse = baseAxis.inverse;
    if (coordSys.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
      isCoordSysPolar = false;
    } else if (coordSys.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
      isCoordSysPolar = true;
    }
    var seriesModel = data2.hostModel;
    var seriesDuration = seriesModel.get("animationDuration");
    if (isFunction$1(seriesDuration)) {
      seriesDuration = seriesDuration(null);
    }
    var seriesDalay = seriesModel.get("animationDelay") || 0;
    var seriesDalayValue = isFunction$1(seriesDalay) ? seriesDalay(null) : seriesDalay;
    data2.eachItemGraphicEl(function(symbol, idx) {
      var el = symbol;
      if (el) {
        var point = [symbol.x, symbol.y];
        var start2 = void 0;
        var end2 = void 0;
        var current2 = void 0;
        if (clipShape) {
          if (isCoordSysPolar) {
            var polarClip = clipShape;
            var coord = coordSys.pointToCoord(point);
            if (isHorizontalOrRadial) {
              start2 = polarClip.startAngle;
              end2 = polarClip.endAngle;
              current2 = -coord[1] / 180 * Math.PI;
            } else {
              start2 = polarClip.r0;
              end2 = polarClip.r;
              current2 = coord[0];
            }
          } else {
            var gridClip = clipShape;
            if (isHorizontalOrRadial) {
              start2 = gridClip.x;
              end2 = gridClip.x + gridClip.width;
              current2 = symbol.x;
            } else {
              start2 = gridClip.y + gridClip.height;
              end2 = gridClip.y;
              current2 = symbol.y;
            }
          }
        }
        var ratio = end2 === start2 ? 0 : (current2 - start2) / (end2 - start2);
        if (isAxisInverse) {
          ratio = 1 - ratio;
        }
        var delay = isFunction$1(seriesDalay) ? seriesDalay(idx) : seriesDuration * ratio + seriesDalayValue;
        var symbolPath = el.getSymbolPath();
        var text = symbolPath.getTextContent();
        el.attr({
          scaleX: 0,
          scaleY: 0
        });
        el.animateTo({
          scaleX: 1,
          scaleY: 1
        }, {
          duration: 200,
          setToFinal: true,
          delay
        });
        if (text) {
          text.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay
          });
        }
        symbolPath.disableLabelAnimation = true;
      }
    });
  };
  LineView2.prototype._initOrUpdateEndLabel = function(seriesModel, coordSys, inheritColor) {
    var endLabelModel = seriesModel.getModel("endLabel");
    if (anyStateShowEndLabel(seriesModel)) {
      var data_2 = seriesModel.getData();
      var polyline = this._polyline;
      var points2 = data_2.getLayout("points");
      if (!points2) {
        polyline.removeTextContent();
        this._endLabel = null;
        return;
      }
      var endLabel = this._endLabel;
      if (!endLabel) {
        endLabel = this._endLabel = new ZRText$1({
          z2: 200
        });
        endLabel.ignoreClip = true;
        polyline.setTextContent(this._endLabel);
        polyline.disableLabelAnimation = true;
      }
      var dataIndex = getLastIndexNotNull(points2);
      if (dataIndex >= 0) {
        setLabelStyle(polyline, getLabelStatesModels(seriesModel, "endLabel"), {
          inheritColor,
          labelFetcher: seriesModel,
          labelDataIndex: dataIndex,
          defaultText: function(dataIndex2, opt, interpolatedValue) {
            return interpolatedValue != null ? getDefaultInterpolatedLabel(data_2, interpolatedValue) : getDefaultLabel(data_2, dataIndex2);
          },
          enableTextSetter: true
        }, getEndLabelStateSpecified(endLabelModel, coordSys));
        polyline.textConfig.position = null;
      }
    } else if (this._endLabel) {
      this._polyline.removeTextContent();
      this._endLabel = null;
    }
  };
  LineView2.prototype._endLabelOnDuring = function(percent, clipRect, data2, animationRecord, valueAnimation, endLabelModel, coordSys) {
    var endLabel = this._endLabel;
    var polyline = this._polyline;
    if (endLabel) {
      if (percent < 1 && animationRecord.originalX == null) {
        animationRecord.originalX = endLabel.x;
        animationRecord.originalY = endLabel.y;
      }
      var points2 = data2.getLayout("points");
      var seriesModel = data2.hostModel;
      var connectNulls = seriesModel.get("connectNulls");
      var precision = endLabelModel.get("precision");
      var distance2 = endLabelModel.get("distance") || 0;
      var baseAxis = coordSys.getBaseAxis();
      var isHorizontal = baseAxis.isHorizontal();
      var isBaseInversed = baseAxis.inverse;
      var clipShape = clipRect.shape;
      var xOrY = isBaseInversed ? isHorizontal ? clipShape.x : clipShape.y + clipShape.height : isHorizontal ? clipShape.x + clipShape.width : clipShape.y;
      var distanceX = (isHorizontal ? distance2 : 0) * (isBaseInversed ? -1 : 1);
      var distanceY = (isHorizontal ? 0 : -distance2) * (isBaseInversed ? -1 : 1);
      var dim = isHorizontal ? "x" : "y";
      var dataIndexRange = getIndexRange(points2, xOrY, dim);
      var indices = dataIndexRange.range;
      var diff = indices[1] - indices[0];
      var value = void 0;
      if (diff >= 1) {
        if (diff > 1 && !connectNulls) {
          var pt = getPointAtIndex(points2, indices[0]);
          endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          valueAnimation && (value = seriesModel.getRawValue(indices[0]));
        } else {
          var pt = polyline.getPointOn(xOrY, dim);
          pt && endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          var startValue = seriesModel.getRawValue(indices[0]);
          var endValue = seriesModel.getRawValue(indices[1]);
          valueAnimation && (value = interpolateRawValues(data2, precision, startValue, endValue, dataIndexRange.t));
        }
        animationRecord.lastFrameIndex = indices[0];
      } else {
        var idx = percent === 1 || animationRecord.lastFrameIndex > 0 ? indices[0] : 0;
        var pt = getPointAtIndex(points2, idx);
        valueAnimation && (value = seriesModel.getRawValue(idx));
        endLabel.attr({
          x: pt[0] + distanceX,
          y: pt[1] + distanceY
        });
      }
      if (valueAnimation) {
        labelInner(endLabel).setLabelText(value);
      }
    }
  };
  LineView2.prototype._doUpdateAnimation = function(data2, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls) {
    var polyline = this._polyline;
    var polygon = this._polygon;
    var seriesModel = data2.hostModel;
    var diff = lineAnimationDiff(this._data, data2, this._stackedOnPoints, stackedOnPoints, this._coordSys, coordSys, this._valueOrigin);
    var current2 = diff.current;
    var stackedOnCurrent = diff.stackedOnCurrent;
    var next = diff.next;
    var stackedOnNext = diff.stackedOnNext;
    if (step) {
      current2 = turnPointsIntoStep(diff.current, coordSys, step, connectNulls);
      stackedOnCurrent = turnPointsIntoStep(diff.stackedOnCurrent, coordSys, step, connectNulls);
      next = turnPointsIntoStep(diff.next, coordSys, step, connectNulls);
      stackedOnNext = turnPointsIntoStep(diff.stackedOnNext, coordSys, step, connectNulls);
    }
    if (getBoundingDiff(current2, next) > 3e3 || polygon && getBoundingDiff(stackedOnCurrent, stackedOnNext) > 3e3) {
      polyline.stopAnimation();
      polyline.setShape({
        points: next
      });
      if (polygon) {
        polygon.stopAnimation();
        polygon.setShape({
          points: next,
          stackedOnPoints: stackedOnNext
        });
      }
      return;
    }
    polyline.shape.__points = diff.current;
    polyline.shape.points = current2;
    var target = {
      shape: {
        points: next
      }
    };
    if (diff.current !== current2) {
      target.shape.__points = diff.next;
    }
    polyline.stopAnimation();
    updateProps$1(polyline, target, seriesModel);
    if (polygon) {
      polygon.setShape({
        points: current2,
        stackedOnPoints: stackedOnCurrent
      });
      polygon.stopAnimation();
      updateProps$1(polygon, {
        shape: {
          stackedOnPoints: stackedOnNext
        }
      }, seriesModel);
      if (polyline.shape.points !== polygon.shape.points) {
        polygon.shape.points = polyline.shape.points;
      }
    }
    var updatedDataInfo = [];
    var diffStatus = diff.status;
    for (var i = 0; i < diffStatus.length; i++) {
      var cmd = diffStatus[i].cmd;
      if (cmd === "=") {
        var el = data2.getItemGraphicEl(diffStatus[i].idx1);
        if (el) {
          updatedDataInfo.push({
            el,
            ptIdx: i
          });
        }
      }
    }
    if (polyline.animators && polyline.animators.length) {
      polyline.animators[0].during(function() {
        polygon && polygon.dirtyShape();
        var points2 = polyline.shape.__points;
        for (var i2 = 0; i2 < updatedDataInfo.length; i2++) {
          var el2 = updatedDataInfo[i2].el;
          var offset3 = updatedDataInfo[i2].ptIdx * 2;
          el2.x = points2[offset3];
          el2.y = points2[offset3 + 1];
          el2.markRedraw();
        }
      });
    }
  };
  LineView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var oldData = this._data;
    this._lineGroup.removeAll();
    this._symbolDraw.remove(true);
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
  };
  LineView2.type = "line";
  return LineView2;
}(ChartView$1);
var LineView$1 = LineView;
function pointsLayout(seriesType2, forceStoreInTypedArray) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      var data2 = seriesModel.getData();
      var coordSys = seriesModel.coordinateSystem;
      var pipelineContext = seriesModel.pipelineContext;
      var useTypedArray = forceStoreInTypedArray || pipelineContext.large;
      if (!coordSys) {
        return;
      }
      var dims = map$1(coordSys.dimensions, function(dim) {
        return data2.mapDimension(dim);
      }).slice(0, 2);
      var dimLen = dims.length;
      var stackResultDim = data2.getCalculationInfo("stackResultDimension");
      if (isDimensionStacked(data2, dims[0])) {
        dims[0] = stackResultDim;
      }
      if (isDimensionStacked(data2, dims[1])) {
        dims[1] = stackResultDim;
      }
      var store = data2.getStore();
      var dimIdx0 = data2.getDimensionIndex(dims[0]);
      var dimIdx1 = data2.getDimensionIndex(dims[1]);
      return dimLen && {
        progress: function(params, data3) {
          var segCount = params.end - params.start;
          var points2 = useTypedArray && createFloat32Array(segCount * dimLen);
          var tmpIn = [];
          var tmpOut = [];
          for (var i = params.start, offset3 = 0; i < params.end; i++) {
            var point = void 0;
            if (dimLen === 1) {
              var x2 = store.get(dimIdx0, i);
              point = coordSys.dataToPoint(x2, null, tmpOut);
            } else {
              tmpIn[0] = store.get(dimIdx0, i);
              tmpIn[1] = store.get(dimIdx1, i);
              point = coordSys.dataToPoint(tmpIn, null, tmpOut);
            }
            if (useTypedArray) {
              points2[offset3++] = point[0];
              points2[offset3++] = point[1];
            } else {
              data3.setItemLayout(i, point.slice());
            }
          }
          useTypedArray && data3.setLayout("points", points2);
        }
      };
    }
  };
}
var samplers = {
  average: function(frame) {
    var sum2 = 0;
    var count2 = 0;
    for (var i = 0; i < frame.length; i++) {
      if (!isNaN(frame[i])) {
        sum2 += frame[i];
        count2++;
      }
    }
    return count2 === 0 ? NaN : sum2 / count2;
  },
  sum: function(frame) {
    var sum2 = 0;
    for (var i = 0; i < frame.length; i++) {
      sum2 += frame[i] || 0;
    }
    return sum2;
  },
  max: function(frame) {
    var max3 = -Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] > max3 && (max3 = frame[i]);
    }
    return isFinite(max3) ? max3 : NaN;
  },
  min: function(frame) {
    var min3 = Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] < min3 && (min3 = frame[i]);
    }
    return isFinite(min3) ? min3 : NaN;
  },
  nearest: function(frame) {
    return frame[0];
  }
};
var indexSampler = function(frame) {
  return Math.round(frame.length / 2);
};
function dataSample(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel, api) {
      var data2 = seriesModel.getData();
      var sampling = seriesModel.get("sampling");
      var coordSys = seriesModel.coordinateSystem;
      var count2 = data2.count();
      if (count2 > 10 && coordSys.type === "cartesian2d" && sampling) {
        var baseAxis = coordSys.getBaseAxis();
        var valueAxis2 = coordSys.getOtherAxis(baseAxis);
        var extent3 = baseAxis.getExtent();
        var dpr2 = api.getDevicePixelRatio();
        var size = Math.abs(extent3[1] - extent3[0]) * (dpr2 || 1);
        var rate = Math.round(count2 / size);
        if (isFinite(rate) && rate > 1) {
          if (sampling === "lttb") {
            seriesModel.setData(data2.lttbDownSample(data2.mapDimension(valueAxis2.dim), 1 / rate));
          }
          var sampler = void 0;
          if (isString$1(sampling)) {
            sampler = samplers[sampling];
          } else if (isFunction$1(sampling)) {
            sampler = sampling;
          }
          if (sampler) {
            seriesModel.setData(data2.downSample(data2.mapDimension(valueAxis2.dim), 1 / rate, sampler, indexSampler));
          }
        }
      }
    }
  };
}
function install$Q(registers) {
  registers.registerChartView(LineView$1);
  registers.registerSeriesModel(LineSeries);
  registers.registerLayout(pointsLayout("line", true));
  registers.registerVisual({
    seriesType: "line",
    reset: function(seriesModel) {
      var data2 = seriesModel.getData();
      var lineStyle = seriesModel.getModel("lineStyle").getLineStyle();
      if (lineStyle && !lineStyle.stroke) {
        lineStyle.stroke = data2.getVisual("style").fill;
      }
      data2.setVisual("legendLineStyle", lineStyle);
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("line"));
}
var BaseBarSeriesModel = function(_super) {
  __extends(BaseBarSeriesModel2, _super);
  function BaseBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BaseBarSeriesModel2.type;
    return _this;
  }
  BaseBarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  BaseBarSeriesModel2.prototype.getMarkerPosition = function(value) {
    var coordSys = this.coordinateSystem;
    if (coordSys && coordSys.clampData) {
      var pt = coordSys.dataToPoint(coordSys.clampData(value));
      var data2 = this.getData();
      var offset3 = data2.getLayout("offset");
      var size = data2.getLayout("size");
      var offsetIndex = coordSys.getBaseAxis().isHorizontal() ? 0 : 1;
      pt[offsetIndex] += offset3 + size / 2;
      return pt;
    }
    return [NaN, NaN];
  };
  BaseBarSeriesModel2.type = "series.__base_bar__";
  BaseBarSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    barMinHeight: 0,
    barMinAngle: 0,
    large: false,
    largeThreshold: 400,
    progressive: 3e3,
    progressiveChunkMode: "mod"
  };
  return BaseBarSeriesModel2;
}(SeriesModel$1);
SeriesModel$1.registerClass(BaseBarSeriesModel);
var BaseBarSeriesModel$1 = BaseBarSeriesModel;
var BarSeriesModel = function(_super) {
  __extends(BarSeriesModel2, _super);
  function BarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BarSeriesModel2.type;
    return _this;
  }
  BarSeriesModel2.prototype.getInitialData = function() {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true,
      createInvertedIndices: !!this.get("realtimeSort", true) || null
    });
  };
  BarSeriesModel2.prototype.getProgressive = function() {
    return this.get("large") ? this.get("progressive") : false;
  };
  BarSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.get("progressiveThreshold");
    var largeThreshold = this.get("largeThreshold");
    if (largeThreshold > progressiveThreshold) {
      progressiveThreshold = largeThreshold;
    }
    return progressiveThreshold;
  };
  BarSeriesModel2.prototype.brushSelector = function(dataIndex, data2, selectors) {
    return selectors.rect(data2.getItemLayout(dataIndex));
  };
  BarSeriesModel2.type = "series.bar";
  BarSeriesModel2.dependencies = ["grid", "polar"];
  BarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    clip: true,
    roundCap: false,
    showBackground: false,
    backgroundStyle: {
      color: "rgba(180, 180, 180, 0.2)",
      borderColor: null,
      borderWidth: 0,
      borderType: "solid",
      borderRadius: 0,
      shadowBlur: 0,
      shadowColor: null,
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    realtimeSort: false
  });
  return BarSeriesModel2;
}(BaseBarSeriesModel$1);
var BarSeries = BarSeriesModel;
var SausageShape = function() {
  function SausageShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return SausageShape2;
}();
var SausagePath = function(_super) {
  __extends(SausagePath2, _super);
  function SausagePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "sausage";
    return _this;
  }
  SausagePath2.prototype.getDefaultShape = function() {
    return new SausageShape();
  };
  SausagePath2.prototype.buildPath = function(ctx, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var r0 = Math.max(shape.r0 || 0, 0);
    var r2 = Math.max(shape.r, 0);
    var dr = (r2 - r0) * 0.5;
    var rCenter = r0 + dr;
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var PI22 = Math.PI * 2;
    var lessThanCircle = clockwise ? endAngle - startAngle < PI22 : startAngle - endAngle < PI22;
    if (!lessThanCircle) {
      startAngle = endAngle - (clockwise ? PI22 : -PI22);
    }
    var unitStartX = Math.cos(startAngle);
    var unitStartY = Math.sin(startAngle);
    var unitEndX = Math.cos(endAngle);
    var unitEndY = Math.sin(endAngle);
    if (lessThanCircle) {
      ctx.moveTo(unitStartX * r0 + cx, unitStartY * r0 + cy);
      ctx.arc(unitStartX * rCenter + cx, unitStartY * rCenter + cy, dr, -Math.PI + startAngle, startAngle, !clockwise);
    } else {
      ctx.moveTo(unitStartX * r2 + cx, unitStartY * r2 + cy);
    }
    ctx.arc(cx, cy, r2, startAngle, endAngle, !clockwise);
    ctx.arc(unitEndX * rCenter + cx, unitEndY * rCenter + cy, dr, endAngle - Math.PI * 2, endAngle - Math.PI, !clockwise);
    if (r0 !== 0) {
      ctx.arc(cx, cy, r0, endAngle, startAngle, clockwise);
    }
  };
  return SausagePath2;
}(Path$1);
var Sausage = SausagePath;
function createSectorCalculateTextPosition(positionMapping, opts) {
  opts = opts || {};
  var isRoundCap = opts.isRoundCap;
  return function(out2, opts2, boundingRect) {
    var textPosition = opts2.position;
    if (!textPosition || textPosition instanceof Array) {
      return calculateTextPosition(out2, opts2, boundingRect);
    }
    var mappedSectorPosition = positionMapping(textPosition);
    var distance2 = opts2.distance != null ? opts2.distance : 5;
    var sector = this.shape;
    var cx = sector.cx;
    var cy = sector.cy;
    var r2 = sector.r;
    var r0 = sector.r0;
    var middleR = (r2 + r0) / 2;
    var startAngle = sector.startAngle;
    var endAngle = sector.endAngle;
    var middleAngle = (startAngle + endAngle) / 2;
    var extraDist = isRoundCap ? Math.abs(r2 - r0) / 2 : 0;
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var x2 = cx + r2 * mathCos2(startAngle);
    var y2 = cy + r2 * mathSin2(startAngle);
    var textAlign = "left";
    var textVerticalAlign = "top";
    switch (mappedSectorPosition) {
      case "startArc":
        x2 = cx + (r0 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "insideStartArc":
        x2 = cx + (r0 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "startAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, distance2 + extraDist, false);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideStartAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, -distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, -distance2 + extraDist, false);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "middle":
        x2 = cx + middleR * mathCos2(middleAngle);
        y2 = cy + middleR * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "endArc":
        x2 = cx + (r2 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideEndArc":
        x2 = cx + (r2 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "endAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, distance2 + extraDist, true);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "insideEndAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, -distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, -distance2 + extraDist, true);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      default:
        return calculateTextPosition(out2, opts2, boundingRect);
    }
    out2 = out2 || {};
    out2.x = x2;
    out2.y = y2;
    out2.align = textAlign;
    out2.verticalAlign = textVerticalAlign;
    return out2;
  };
}
function setSectorTextRotation(sector, textPosition, positionMapping, rotateType) {
  if (isNumber(rotateType)) {
    sector.setTextConfig({
      rotation: rotateType
    });
    return;
  } else if (isArray$2(textPosition)) {
    sector.setTextConfig({
      rotation: 0
    });
    return;
  }
  var shape = sector.shape;
  var startAngle = shape.clockwise ? shape.startAngle : shape.endAngle;
  var endAngle = shape.clockwise ? shape.endAngle : shape.startAngle;
  var middleAngle = (startAngle + endAngle) / 2;
  var anchorAngle;
  var mappedSectorPosition = positionMapping(textPosition);
  switch (mappedSectorPosition) {
    case "startArc":
    case "insideStartArc":
    case "middle":
    case "insideEndArc":
    case "endArc":
      anchorAngle = middleAngle;
      break;
    case "startAngle":
    case "insideStartAngle":
      anchorAngle = startAngle;
      break;
    case "endAngle":
    case "insideEndAngle":
      anchorAngle = endAngle;
      break;
    default:
      sector.setTextConfig({
        rotation: 0
      });
      return;
  }
  var rotate2 = Math.PI * 1.5 - anchorAngle;
  if (mappedSectorPosition === "middle" && rotate2 > Math.PI / 2 && rotate2 < Math.PI * 1.5) {
    rotate2 -= Math.PI;
  }
  sector.setTextConfig({
    rotation: rotate2
  });
}
function adjustAngleDistanceX(angle, distance2, isEnd) {
  return distance2 * Math.sin(angle) * (isEnd ? -1 : 1);
}
function adjustAngleDistanceY(angle, distance2, isEnd) {
  return distance2 * Math.cos(angle) * (isEnd ? 1 : -1);
}
var mathMax$4 = Math.max;
var mathMin$4 = Math.min;
function getClipArea(coord, data2) {
  var coordSysClipArea = coord.getArea && coord.getArea();
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var baseAxis = coord.getBaseAxis();
    if (baseAxis.type !== "category" || !baseAxis.onBand) {
      var expandWidth = data2.getLayout("bandWidth");
      if (baseAxis.isHorizontal()) {
        coordSysClipArea.x -= expandWidth;
        coordSysClipArea.width += expandWidth * 2;
      } else {
        coordSysClipArea.y -= expandWidth;
        coordSysClipArea.height += expandWidth * 2;
      }
    }
  }
  return coordSysClipArea;
}
var BarView = function(_super) {
  __extends(BarView2, _super);
  function BarView2() {
    var _this = _super.call(this) || this;
    _this.type = BarView2.type;
    _this._isFirstFrame = true;
    return _this;
  }
  BarView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._model = seriesModel;
    this._removeOnRenderedListener(api);
    this._updateDrawMode(seriesModel);
    var coordinateSystemType = seriesModel.get("coordinateSystem");
    if (coordinateSystemType === "cartesian2d" || coordinateSystemType === "polar") {
      this._progressiveEls = null;
      this._isLargeDraw ? this._renderLarge(seriesModel, ecModel, api) : this._renderNormal(seriesModel, ecModel, api, payload);
    }
  };
  BarView2.prototype.incrementalPrepareRender = function(seriesModel) {
    this._clear();
    this._updateDrawMode(seriesModel);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype.incrementalRender = function(params, seriesModel) {
    this._progressiveEls = [];
    this._incrementalRenderLarge(params, seriesModel);
  };
  BarView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  BarView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  BarView2.prototype._renderNormal = function(seriesModel, ecModel, api, payload) {
    var group = this.group;
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var coord = seriesModel.coordinateSystem;
    var baseAxis = coord.getBaseAxis();
    var isHorizontalOrRadial;
    if (coord.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
    } else if (coord.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
    }
    var animationModel = seriesModel.isAnimationEnabled() ? seriesModel : null;
    var realtimeSortCfg = shouldRealtimeSort(seriesModel, coord);
    if (realtimeSortCfg) {
      this._enableRealtimeSort(realtimeSortCfg, data2, api);
    }
    var needsClip = seriesModel.get("clip", true) || realtimeSortCfg;
    var coordSysClipArea = getClipArea(coord, data2);
    group.removeClipPath();
    var roundCap = seriesModel.get("roundCap", true);
    var drawBackground = seriesModel.get("showBackground", true);
    var backgroundModel = seriesModel.getModel("backgroundStyle");
    var barBorderRadius = backgroundModel.get("borderRadius") || 0;
    var bgEls = [];
    var oldBgEls = this._backgroundEls;
    var isInitSort = payload && payload.isInitSort;
    var isChangeOrder = payload && payload.type === "changeAxisOrder";
    function createBackground(dataIndex) {
      var bgLayout = getLayout[coord.type](data2, dataIndex);
      var bgEl = createBackgroundEl(coord, isHorizontalOrRadial, bgLayout);
      bgEl.useStyle(backgroundModel.getItemStyle());
      if (coord.type === "cartesian2d") {
        bgEl.setShape("r", barBorderRadius);
      }
      bgEls[dataIndex] = bgEl;
      return bgEl;
    }
    data2.diff(oldData).add(function(dataIndex) {
      var itemModel = data2.getItemModel(dataIndex);
      var layout2 = getLayout[coord.type](data2, dataIndex, itemModel);
      if (drawBackground) {
        createBackground(dataIndex);
      }
      if (!data2.hasValue(dataIndex) || !isValidLayout[coord.type](layout2)) {
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
      }
      var el = elementCreator[coord.type](seriesModel, data2, dataIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, false, roundCap);
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      updateStyle(el, data2, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, dataIndex, isHorizontalOrRadial, false, false);
      } else {
        initProps(el, {
          shape: layout2
        }, seriesModel, dataIndex);
      }
      data2.setItemGraphicEl(dataIndex, el);
      group.add(el);
      el.ignore = isClipped;
    }).update(function(newIndex, oldIndex) {
      var itemModel = data2.getItemModel(newIndex);
      var layout2 = getLayout[coord.type](data2, newIndex, itemModel);
      if (drawBackground) {
        var bgEl = void 0;
        if (oldBgEls.length === 0) {
          bgEl = createBackground(oldIndex);
        } else {
          bgEl = oldBgEls[oldIndex];
          bgEl.useStyle(backgroundModel.getItemStyle());
          if (coord.type === "cartesian2d") {
            bgEl.setShape("r", barBorderRadius);
          }
          bgEls[newIndex] = bgEl;
        }
        var bgLayout = getLayout[coord.type](data2, newIndex);
        var shape = createBackgroundShape(isHorizontalOrRadial, bgLayout, coord);
        updateProps$1(bgEl, {
          shape
        }, animationModel, newIndex);
      }
      var el = oldData.getItemGraphicEl(oldIndex);
      if (!data2.hasValue(newIndex) || !isValidLayout[coord.type](layout2)) {
        group.remove(el);
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
        if (isClipped) {
          group.remove(el);
        }
      }
      if (!el) {
        el = elementCreator[coord.type](seriesModel, data2, newIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, !!el, roundCap);
      } else {
        saveOldStyle(el);
      }
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      if (isChangeOrder) {
        var textEl = el.getTextContent();
        if (textEl) {
          var labelInnerStore = labelInner(textEl);
          if (labelInnerStore.prevValue != null) {
            labelInnerStore.prevValue = labelInnerStore.value;
          }
        }
      } else {
        updateStyle(el, data2, newIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      }
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, newIndex, isHorizontalOrRadial, true, isChangeOrder);
      } else {
        updateProps$1(el, {
          shape: layout2
        }, seriesModel, newIndex, null);
      }
      data2.setItemGraphicEl(newIndex, el);
      el.ignore = isClipped;
      group.add(el);
    }).remove(function(dataIndex) {
      var el = oldData.getItemGraphicEl(dataIndex);
      el && removeElementWithFadeOut(el, seriesModel, dataIndex);
    }).execute();
    var bgGroup = this._backgroundGroup || (this._backgroundGroup = new Group$6());
    bgGroup.removeAll();
    for (var i = 0; i < bgEls.length; ++i) {
      bgGroup.add(bgEls[i]);
    }
    group.add(bgGroup);
    this._backgroundEls = bgEls;
    this._data = data2;
  };
  BarView2.prototype._renderLarge = function(seriesModel, ecModel, api) {
    this._clear();
    createLarge$1(seriesModel, this.group);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    this._removeBackground();
    createLarge$1(seriesModel, this.group, this._progressiveEls, true);
  };
  BarView2.prototype._updateLargeClip = function(seriesModel) {
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    var group = this.group;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
  };
  BarView2.prototype._enableRealtimeSort = function(realtimeSortCfg, data2, api) {
    var _this = this;
    if (!data2.count()) {
      return;
    }
    var baseAxis = realtimeSortCfg.baseAxis;
    if (this._isFirstFrame) {
      this._dispatchInitSort(data2, realtimeSortCfg, api);
      this._isFirstFrame = false;
    } else {
      var orderMapping_1 = function(idx) {
        var el = data2.getItemGraphicEl(idx);
        var shape = el && el.shape;
        return shape && Math.abs(baseAxis.isHorizontal() ? shape.height : shape.width) || 0;
      };
      this._onRendered = function() {
        _this._updateSortWithinSameData(data2, orderMapping_1, baseAxis, api);
      };
      api.getZr().on("rendered", this._onRendered);
    }
  };
  BarView2.prototype._dataSort = function(data2, baseAxis, orderMapping) {
    var info = [];
    data2.each(data2.mapDimension(baseAxis.dim), function(ordinalNumber, dataIdx) {
      var mappedValue = orderMapping(dataIdx);
      mappedValue = mappedValue == null ? NaN : mappedValue;
      info.push({
        dataIndex: dataIdx,
        mappedValue,
        ordinalNumber
      });
    });
    info.sort(function(a, b2) {
      return b2.mappedValue - a.mappedValue;
    });
    return {
      ordinalNumbers: map$1(info, function(item) {
        return item.ordinalNumber;
      })
    };
  };
  BarView2.prototype._isOrderChangedWithinSameData = function(data2, orderMapping, baseAxis) {
    var scale2 = baseAxis.scale;
    var ordinalDataDim = data2.mapDimension(baseAxis.dim);
    var lastValue = Number.MAX_VALUE;
    for (var tickNum = 0, len2 = scale2.getOrdinalMeta().categories.length; tickNum < len2; ++tickNum) {
      var rawIdx = data2.rawIndexOf(ordinalDataDim, scale2.getRawOrdinalNumber(tickNum));
      var value = rawIdx < 0 ? Number.MIN_VALUE : orderMapping(data2.indexOfRawIndex(rawIdx));
      if (value > lastValue) {
        return true;
      }
      lastValue = value;
    }
    return false;
  };
  BarView2.prototype._isOrderDifferentInView = function(orderInfo, baseAxis) {
    var scale2 = baseAxis.scale;
    var extent3 = scale2.getExtent();
    var tickNum = Math.max(0, extent3[0]);
    var tickMax = Math.min(extent3[1], scale2.getOrdinalMeta().categories.length - 1);
    for (; tickNum <= tickMax; ++tickNum) {
      if (orderInfo.ordinalNumbers[tickNum] !== scale2.getRawOrdinalNumber(tickNum)) {
        return true;
      }
    }
  };
  BarView2.prototype._updateSortWithinSameData = function(data2, orderMapping, baseAxis, api) {
    if (!this._isOrderChangedWithinSameData(data2, orderMapping, baseAxis)) {
      return;
    }
    var sortInfo = this._dataSort(data2, baseAxis, orderMapping);
    if (this._isOrderDifferentInView(sortInfo, baseAxis)) {
      this._removeOnRenderedListener(api);
      api.dispatchAction({
        type: "changeAxisOrder",
        componentType: baseAxis.dim + "Axis",
        axisId: baseAxis.index,
        sortInfo
      });
    }
  };
  BarView2.prototype._dispatchInitSort = function(data2, realtimeSortCfg, api) {
    var baseAxis = realtimeSortCfg.baseAxis;
    var sortResult = this._dataSort(data2, baseAxis, function(dataIdx) {
      return data2.get(data2.mapDimension(realtimeSortCfg.otherAxis.dim), dataIdx);
    });
    api.dispatchAction({
      type: "changeAxisOrder",
      componentType: baseAxis.dim + "Axis",
      isInitSort: true,
      axisId: baseAxis.index,
      sortInfo: sortResult
    });
  };
  BarView2.prototype.remove = function(ecModel, api) {
    this._clear(this._model);
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype.dispose = function(ecModel, api) {
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype._removeOnRenderedListener = function(api) {
    if (this._onRendered) {
      api.getZr().off("rendered", this._onRendered);
      this._onRendered = null;
    }
  };
  BarView2.prototype._clear = function(model) {
    var group = this.group;
    var data2 = this._data;
    if (model && model.isAnimationEnabled() && data2 && !this._isLargeDraw) {
      this._removeBackground();
      this._backgroundEls = [];
      data2.eachItemGraphicEl(function(el) {
        removeElementWithFadeOut(el, model, getECData(el).dataIndex);
      });
    } else {
      group.removeAll();
    }
    this._data = null;
    this._isFirstFrame = true;
  };
  BarView2.prototype._removeBackground = function() {
    this.group.remove(this._backgroundGroup);
    this._backgroundGroup = null;
  };
  BarView2.type = "bar";
  return BarView2;
}(ChartView$1);
var clip = {
  cartesian2d: function(coordSysBoundingRect, layout2) {
    var signWidth = layout2.width < 0 ? -1 : 1;
    var signHeight = layout2.height < 0 ? -1 : 1;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    var coordSysX2 = coordSysBoundingRect.x + coordSysBoundingRect.width;
    var coordSysY2 = coordSysBoundingRect.y + coordSysBoundingRect.height;
    var x2 = mathMax$4(layout2.x, coordSysBoundingRect.x);
    var x22 = mathMin$4(layout2.x + layout2.width, coordSysX2);
    var y2 = mathMax$4(layout2.y, coordSysBoundingRect.y);
    var y22 = mathMin$4(layout2.y + layout2.height, coordSysY2);
    var xClipped = x22 < x2;
    var yClipped = y22 < y2;
    layout2.x = xClipped && x2 > coordSysX2 ? x22 : x2;
    layout2.y = yClipped && y2 > coordSysY2 ? y22 : y2;
    layout2.width = xClipped ? 0 : x22 - x2;
    layout2.height = yClipped ? 0 : y22 - y2;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    return xClipped || yClipped;
  },
  polar: function(coordSysClipArea, layout2) {
    var signR = layout2.r0 <= layout2.r ? 1 : -1;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    var r2 = mathMin$4(layout2.r, coordSysClipArea.r);
    var r0 = mathMax$4(layout2.r0, coordSysClipArea.r0);
    layout2.r = r2;
    layout2.r0 = r0;
    var clipped = r2 - r0 < 0;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    return clipped;
  }
};
var elementCreator = {
  cartesian2d: function(seriesModel, data2, newIndex, layout2, isHorizontal, animationModel, axisModel, isUpdate, roundCap) {
    var rect = new Rect$3({
      shape: extend({}, layout2),
      z2: 1
    });
    rect.__dataIndex = newIndex;
    rect.name = "item";
    if (animationModel) {
      var rectShape = rect.shape;
      var animateProperty = isHorizontal ? "height" : "width";
      rectShape[animateProperty] = 0;
    }
    return rect;
  },
  polar: function(seriesModel, data2, newIndex, layout2, isRadial, animationModel, axisModel, isUpdate, roundCap) {
    var ShapeClass = !isRadial && roundCap ? Sausage : Sector$1;
    var sector = new ShapeClass({
      shape: layout2,
      z2: 1
    });
    sector.name = "item";
    var positionMap = createPolarPositionMapping(isRadial);
    sector.calculateTextPosition = createSectorCalculateTextPosition(positionMap, {
      isRoundCap: ShapeClass === Sausage
    });
    if (animationModel) {
      var sectorShape = sector.shape;
      var animateProperty = isRadial ? "r" : "endAngle";
      var animateTarget = {};
      sectorShape[animateProperty] = isRadial ? 0 : layout2.startAngle;
      animateTarget[animateProperty] = layout2[animateProperty];
      (isUpdate ? updateProps$1 : initProps)(sector, {
        shape: animateTarget
      }, animationModel);
    }
    return sector;
  }
};
function shouldRealtimeSort(seriesModel, coordSys) {
  var realtimeSortOption = seriesModel.get("realtimeSort", true);
  var baseAxis = coordSys.getBaseAxis();
  if (realtimeSortOption && baseAxis.type === "category" && coordSys.type === "cartesian2d") {
    return {
      baseAxis,
      otherAxis: coordSys.getOtherAxis(baseAxis)
    };
  }
}
function updateRealtimeAnimation(realtimeSortCfg, seriesAnimationModel, el, layout2, newIndex, isHorizontal, isUpdate, isChangeOrder) {
  var seriesTarget;
  var axisTarget;
  if (isHorizontal) {
    axisTarget = {
      x: layout2.x,
      width: layout2.width
    };
    seriesTarget = {
      y: layout2.y,
      height: layout2.height
    };
  } else {
    axisTarget = {
      y: layout2.y,
      height: layout2.height
    };
    seriesTarget = {
      x: layout2.x,
      width: layout2.width
    };
  }
  if (!isChangeOrder) {
    (isUpdate ? updateProps$1 : initProps)(el, {
      shape: seriesTarget
    }, seriesAnimationModel, newIndex, null);
  }
  var axisAnimationModel = seriesAnimationModel ? realtimeSortCfg.baseAxis.model : null;
  (isUpdate ? updateProps$1 : initProps)(el, {
    shape: axisTarget
  }, axisAnimationModel, newIndex);
}
function checkPropertiesNotValid(obj, props) {
  for (var i = 0; i < props.length; i++) {
    if (!isFinite(obj[props[i]])) {
      return true;
    }
  }
  return false;
}
var rectPropties = ["x", "y", "width", "height"];
var polarPropties = ["cx", "cy", "r", "startAngle", "endAngle"];
var isValidLayout = {
  cartesian2d: function(layout2) {
    return !checkPropertiesNotValid(layout2, rectPropties);
  },
  polar: function(layout2) {
    return !checkPropertiesNotValid(layout2, polarPropties);
  }
};
var getLayout = {
  cartesian2d: function(data2, dataIndex, itemModel) {
    var layout2 = data2.getItemLayout(dataIndex);
    var fixedLineWidth = itemModel ? getLineWidth(itemModel, layout2) : 0;
    var signX = layout2.width > 0 ? 1 : -1;
    var signY = layout2.height > 0 ? 1 : -1;
    return {
      x: layout2.x + signX * fixedLineWidth / 2,
      y: layout2.y + signY * fixedLineWidth / 2,
      width: layout2.width - signX * fixedLineWidth,
      height: layout2.height - signY * fixedLineWidth
    };
  },
  polar: function(data2, dataIndex, itemModel) {
    var layout2 = data2.getItemLayout(dataIndex);
    return {
      cx: layout2.cx,
      cy: layout2.cy,
      r0: layout2.r0,
      r: layout2.r,
      startAngle: layout2.startAngle,
      endAngle: layout2.endAngle,
      clockwise: layout2.clockwise
    };
  }
};
function isZeroOnPolar(layout2) {
  return layout2.startAngle != null && layout2.endAngle != null && layout2.startAngle === layout2.endAngle;
}
function createPolarPositionMapping(isRadial) {
  return function(isRadial2) {
    var arcOrAngle = isRadial2 ? "Arc" : "Angle";
    return function(position2) {
      switch (position2) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return position2 + arcOrAngle;
        default:
          return position2;
      }
    };
  }(isRadial);
}
function updateStyle(el, data2, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, isPolar) {
  var style2 = data2.getItemVisual(dataIndex, "style");
  if (!isPolar) {
    el.setShape("r", itemModel.get(["itemStyle", "borderRadius"]) || 0);
  }
  el.useStyle(style2);
  var cursorStyle = itemModel.getShallow("cursor");
  cursorStyle && el.attr("cursor", cursorStyle);
  var labelPositionOutside = isPolar ? isHorizontalOrRadial ? layout2.r >= layout2.r0 ? "endArc" : "startArc" : layout2.endAngle >= layout2.startAngle ? "endAngle" : "startAngle" : isHorizontalOrRadial ? layout2.height >= 0 ? "bottom" : "top" : layout2.width >= 0 ? "right" : "left";
  var labelStatesModels = getLabelStatesModels(itemModel);
  setLabelStyle(el, labelStatesModels, {
    labelFetcher: seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(seriesModel.getData(), dataIndex),
    inheritColor: style2.fill,
    defaultOpacity: style2.opacity,
    defaultOutsidePosition: labelPositionOutside
  });
  var label = el.getTextContent();
  if (isPolar && label) {
    var position2 = itemModel.get(["label", "position"]);
    el.textConfig.inside = position2 === "middle" ? true : null;
    setSectorTextRotation(el, position2 === "outside" ? labelPositionOutside : position2, createPolarPositionMapping(isHorizontalOrRadial), itemModel.get(["label", "rotate"]));
  }
  setLabelValueAnimation(label, labelStatesModels, seriesModel.getRawValue(dataIndex), function(value) {
    return getDefaultInterpolatedLabel(data2, value);
  });
  var emphasisModel = itemModel.getModel(["emphasis"]);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  setStatesStylesFromModel(el, itemModel);
  if (isZeroOnPolar(layout2)) {
    el.style.fill = "none";
    el.style.stroke = "none";
    each$g(el.states, function(state) {
      if (state.style) {
        state.style.fill = state.style.stroke = "none";
      }
    });
  }
}
function getLineWidth(itemModel, rawLayout) {
  var borderColor = itemModel.get(["itemStyle", "borderColor"]);
  if (!borderColor || borderColor === "none") {
    return 0;
  }
  var lineWidth = itemModel.get(["itemStyle", "borderWidth"]) || 0;
  var width = isNaN(rawLayout.width) ? Number.MAX_VALUE : Math.abs(rawLayout.width);
  var height = isNaN(rawLayout.height) ? Number.MAX_VALUE : Math.abs(rawLayout.height);
  return Math.min(lineWidth, width, height);
}
var LagePathShape = function() {
  function LagePathShape2() {
  }
  return LagePathShape2;
}();
var LargePath = function(_super) {
  __extends(LargePath2, _super);
  function LargePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeBar";
    return _this;
  }
  LargePath2.prototype.getDefaultShape = function() {
    return new LagePathShape();
  };
  LargePath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var baseDimIdx = this.baseDimIdx;
    var valueDimIdx = 1 - this.baseDimIdx;
    var startPoint = [];
    var size = [];
    var barWidth = this.barWidth;
    for (var i = 0; i < points2.length; i += 3) {
      size[baseDimIdx] = barWidth;
      size[valueDimIdx] = points2[i + 2];
      startPoint[baseDimIdx] = points2[i + baseDimIdx];
      startPoint[valueDimIdx] = points2[i + valueDimIdx];
      ctx.rect(startPoint[0], startPoint[1], size[0], size[1]);
    }
  };
  return LargePath2;
}(Path$1);
function createLarge$1(seriesModel, group, progressiveEls, incremental) {
  var data2 = seriesModel.getData();
  var baseDimIdx = data2.getLayout("valueAxisHorizontal") ? 1 : 0;
  var largeDataIndices = data2.getLayout("largeDataIndices");
  var barWidth = data2.getLayout("size");
  var backgroundModel = seriesModel.getModel("backgroundStyle");
  var bgPoints = data2.getLayout("largeBackgroundPoints");
  if (bgPoints) {
    var bgEl = new LargePath({
      shape: {
        points: bgPoints
      },
      incremental: !!incremental,
      silent: true,
      z2: 0
    });
    bgEl.baseDimIdx = baseDimIdx;
    bgEl.largeDataIndices = largeDataIndices;
    bgEl.barWidth = barWidth;
    bgEl.useStyle(backgroundModel.getItemStyle());
    group.add(bgEl);
    progressiveEls && progressiveEls.push(bgEl);
  }
  var el = new LargePath({
    shape: {
      points: data2.getLayout("largePoints")
    },
    incremental: !!incremental,
    z2: 1
  });
  el.baseDimIdx = baseDimIdx;
  el.largeDataIndices = largeDataIndices;
  el.barWidth = barWidth;
  group.add(el);
  el.useStyle(data2.getVisual("style"));
  getECData(el).seriesIndex = seriesModel.seriesIndex;
  if (!seriesModel.get("silent")) {
    el.on("mousedown", largePathUpdateDataIndex);
    el.on("mousemove", largePathUpdateDataIndex);
  }
  progressiveEls && progressiveEls.push(el);
}
var largePathUpdateDataIndex = throttle(function(event) {
  var largePath = this;
  var dataIndex = largePathFindDataIndex(largePath, event.offsetX, event.offsetY);
  getECData(largePath).dataIndex = dataIndex >= 0 ? dataIndex : null;
}, 30, false);
function largePathFindDataIndex(largePath, x2, y2) {
  var baseDimIdx = largePath.baseDimIdx;
  var valueDimIdx = 1 - baseDimIdx;
  var points2 = largePath.shape.points;
  var largeDataIndices = largePath.largeDataIndices;
  var startPoint = [];
  var size = [];
  var barWidth = largePath.barWidth;
  for (var i = 0, len2 = points2.length / 3; i < len2; i++) {
    var ii2 = i * 3;
    size[baseDimIdx] = barWidth;
    size[valueDimIdx] = points2[ii2 + 2];
    startPoint[baseDimIdx] = points2[ii2 + baseDimIdx];
    startPoint[valueDimIdx] = points2[ii2 + valueDimIdx];
    if (size[valueDimIdx] < 0) {
      startPoint[valueDimIdx] += size[valueDimIdx];
      size[valueDimIdx] = -size[valueDimIdx];
    }
    if (x2 >= startPoint[0] && x2 <= startPoint[0] + size[0] && y2 >= startPoint[1] && y2 <= startPoint[1] + size[1]) {
      return largeDataIndices[i];
    }
  }
  return -1;
}
function createBackgroundShape(isHorizontalOrRadial, layout2, coord) {
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var rectShape = layout2;
    var coordLayout = coord.getArea();
    return {
      x: isHorizontalOrRadial ? rectShape.x : coordLayout.x,
      y: isHorizontalOrRadial ? coordLayout.y : rectShape.y,
      width: isHorizontalOrRadial ? rectShape.width : coordLayout.width,
      height: isHorizontalOrRadial ? coordLayout.height : rectShape.height
    };
  } else {
    var coordLayout = coord.getArea();
    var sectorShape = layout2;
    return {
      cx: coordLayout.cx,
      cy: coordLayout.cy,
      r0: isHorizontalOrRadial ? coordLayout.r0 : sectorShape.r0,
      r: isHorizontalOrRadial ? coordLayout.r : sectorShape.r,
      startAngle: isHorizontalOrRadial ? sectorShape.startAngle : 0,
      endAngle: isHorizontalOrRadial ? sectorShape.endAngle : Math.PI * 2
    };
  }
}
function createBackgroundEl(coord, isHorizontalOrRadial, layout2) {
  var ElementClz = coord.type === "polar" ? Sector$1 : Rect$3;
  return new ElementClz({
    shape: createBackgroundShape(isHorizontalOrRadial, layout2, coord),
    silent: true,
    z2: 0
  });
}
var BarView$1 = BarView;
function install$P(registers) {
  registers.registerChartView(BarView$1);
  registers.registerSeriesModel(BarSeries);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$3(layout$3, "bar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("bar"));
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("bar"));
  registers.registerAction({
    type: "changeAxisOrder",
    event: "changeAxisOrder",
    update: "update"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      if (payload.sortInfo) {
        componentModel.axis.setCategorySortInfo(payload.sortInfo);
      }
    });
  });
}
var PI2$1 = Math.PI * 2;
var RADIAN$2 = Math.PI / 180;
function getViewRect$5(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getBasicPieLayout(seriesModel, api) {
  var viewRect2 = getViewRect$5(seriesModel, api);
  var center2 = seriesModel.get("center");
  var radius = seriesModel.get("radius");
  if (!isArray$2(radius)) {
    radius = [0, radius];
  }
  if (!isArray$2(center2)) {
    center2 = [center2, center2];
  }
  var width = parsePercent(viewRect2.width, api.getWidth());
  var height = parsePercent(viewRect2.height, api.getHeight());
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], width) + viewRect2.x;
  var cy = parsePercent(center2[1], height) + viewRect2.y;
  var r0 = parsePercent(radius[0], size / 2);
  var r2 = parsePercent(radius[1], size / 2);
  return {
    cx,
    cy,
    r0,
    r: r2
  };
}
function pieLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var data2 = seriesModel.getData();
    var valueDim = data2.mapDimension("value");
    var viewRect2 = getViewRect$5(seriesModel, api);
    var _a2 = getBasicPieLayout(seriesModel, api), cx = _a2.cx, cy = _a2.cy, r2 = _a2.r, r0 = _a2.r0;
    var startAngle = -seriesModel.get("startAngle") * RADIAN$2;
    var minAngle = seriesModel.get("minAngle") * RADIAN$2;
    var validDataCount = 0;
    data2.each(valueDim, function(value) {
      !isNaN(value) && validDataCount++;
    });
    var sum2 = data2.getSum(valueDim);
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var clockwise = seriesModel.get("clockwise");
    var roseType = seriesModel.get("roseType");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var extent3 = data2.getDataExtent(valueDim);
    extent3[0] = 0;
    var restAngle = PI2$1;
    var valueSumLargerThanMinAngle = 0;
    var currentAngle = startAngle;
    var dir3 = clockwise ? 1 : -1;
    data2.setLayout({
      viewRect: viewRect2,
      r: r2
    });
    data2.each(valueDim, function(value, idx) {
      var angle;
      if (isNaN(value)) {
        data2.setItemLayout(idx, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise,
          cx,
          cy,
          r0,
          r: roseType ? NaN : r2
        });
        return;
      }
      if (roseType !== "area") {
        angle = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
      } else {
        angle = PI2$1 / validDataCount;
      }
      if (angle < minAngle) {
        angle = minAngle;
        restAngle -= minAngle;
      } else {
        valueSumLargerThanMinAngle += value;
      }
      var endAngle = currentAngle + dir3 * angle;
      data2.setItemLayout(idx, {
        angle,
        startAngle: currentAngle,
        endAngle,
        clockwise,
        cx,
        cy,
        r0,
        r: roseType ? linearMap$2(value, extent3, [r0, r2]) : r2
      });
      currentAngle = endAngle;
    });
    if (restAngle < PI2$1 && validDataCount) {
      if (restAngle <= 1e-3) {
        var angle_1 = PI2$1 / validDataCount;
        data2.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_1 = data2.getItemLayout(idx);
            layout_1.angle = angle_1;
            layout_1.startAngle = startAngle + dir3 * idx * angle_1;
            layout_1.endAngle = startAngle + dir3 * (idx + 1) * angle_1;
          }
        });
      } else {
        unitRadian = restAngle / valueSumLargerThanMinAngle;
        currentAngle = startAngle;
        data2.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_2 = data2.getItemLayout(idx);
            var angle = layout_2.angle === minAngle ? minAngle : value * unitRadian;
            layout_2.startAngle = currentAngle;
            layout_2.endAngle = currentAngle + dir3 * angle;
            currentAngle += dir3 * angle;
          }
        });
      }
    }
  });
}
function dataFilter$1(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var legendModels = ecModel.findComponents({
        mainType: "legend"
      });
      if (!legendModels || !legendModels.length) {
        return;
      }
      var data2 = seriesModel.getData();
      data2.filterSelf(function(idx) {
        var name2 = data2.getName(idx);
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(name2)) {
            return false;
          }
        }
        return true;
      });
    }
  };
}
var RADIAN$1 = Math.PI / 180;
function adjustSingleSide(list, cx, cy, r2, dir3, viewWidth, viewHeight, viewLeft, viewTop, farthestX) {
  if (list.length < 2) {
    return;
  }
  function recalculateXOnSemiToAlignOnEllipseCurve(semi) {
    var rB = semi.rB;
    var rB2 = rB * rB;
    for (var i2 = 0; i2 < semi.list.length; i2++) {
      var item = semi.list[i2];
      var dy = Math.abs(item.label.y - cy);
      var rA = r2 + item.len;
      var rA2 = rA * rA;
      var dx2 = Math.sqrt((1 - Math.abs(dy * dy / rB2)) * rA2);
      var newX = cx + (dx2 + item.len2) * dir3;
      var deltaX = newX - item.label.x;
      var newTargetWidth = item.targetTextWidth - deltaX * dir3;
      constrainTextWidth(item, newTargetWidth, true);
      item.label.x = newX;
    }
  }
  function recalculateX(items) {
    var topSemi = {
      list: [],
      maxY: 0
    };
    var bottomSemi = {
      list: [],
      maxY: 0
    };
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].labelAlignTo !== "none") {
        continue;
      }
      var item = items[i2];
      var semi = item.label.y > cy ? bottomSemi : topSemi;
      var dy = Math.abs(item.label.y - cy);
      if (dy >= semi.maxY) {
        var dx2 = item.label.x - cx - item.len2 * dir3;
        var rA = r2 + item.len;
        var rB = Math.abs(dx2) < rA ? Math.sqrt(dy * dy / (1 - dx2 * dx2 / rA / rA)) : rA;
        semi.rB = rB;
        semi.maxY = dy;
      }
      semi.list.push(item);
    }
    recalculateXOnSemiToAlignOnEllipseCurve(topSemi);
    recalculateXOnSemiToAlignOnEllipseCurve(bottomSemi);
  }
  var len2 = list.length;
  for (var i = 0; i < len2; i++) {
    if (list[i].position === "outer" && list[i].labelAlignTo === "labelLine") {
      var dx = list[i].label.x - farthestX;
      list[i].linePoints[1][0] += dx;
      list[i].label.x = farthestX;
    }
  }
  if (shiftLayoutOnY(list, viewTop, viewTop + viewHeight)) {
    recalculateX(list);
  }
}
function avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop) {
  var leftList = [];
  var rightList = [];
  var leftmostX = Number.MAX_VALUE;
  var rightmostX = -Number.MAX_VALUE;
  for (var i = 0; i < labelLayoutList.length; i++) {
    var label = labelLayoutList[i].label;
    if (isPositionCenter(labelLayoutList[i])) {
      continue;
    }
    if (label.x < cx) {
      leftmostX = Math.min(leftmostX, label.x);
      leftList.push(labelLayoutList[i]);
    } else {
      rightmostX = Math.max(rightmostX, label.x);
      rightList.push(labelLayoutList[i]);
    }
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      if (layout2.labelStyleWidth != null) {
        continue;
      }
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var targetTextWidth = void 0;
      if (layout2.labelAlignTo === "edge") {
        if (label.x < cx) {
          targetTextWidth = linePoints[2][0] - layout2.labelDistance - viewLeft - layout2.edgeDistance;
        } else {
          targetTextWidth = viewLeft + viewWidth - layout2.edgeDistance - linePoints[2][0] - layout2.labelDistance;
        }
      } else if (layout2.labelAlignTo === "labelLine") {
        if (label.x < cx) {
          targetTextWidth = leftmostX - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - rightmostX - layout2.bleedMargin;
        }
      } else {
        if (label.x < cx) {
          targetTextWidth = label.x - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - label.x - layout2.bleedMargin;
        }
      }
      layout2.targetTextWidth = targetTextWidth;
      constrainTextWidth(layout2, targetTextWidth);
    }
  }
  adjustSingleSide(rightList, cx, cy, r2, 1, viewWidth, viewHeight, viewLeft, viewTop, rightmostX);
  adjustSingleSide(leftList, cx, cy, r2, -1, viewWidth, viewHeight, viewLeft, viewTop, leftmostX);
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var isAlignToEdge = layout2.labelAlignTo === "edge";
      var padding = label.style.padding;
      var paddingH = padding ? padding[1] + padding[3] : 0;
      var extraPaddingH = label.style.backgroundColor ? 0 : paddingH;
      var realTextWidth = layout2.rect.width + extraPaddingH;
      var dist2 = linePoints[1][0] - linePoints[2][0];
      if (isAlignToEdge) {
        if (label.x < cx) {
          linePoints[2][0] = viewLeft + layout2.edgeDistance + realTextWidth + layout2.labelDistance;
        } else {
          linePoints[2][0] = viewLeft + viewWidth - layout2.edgeDistance - realTextWidth - layout2.labelDistance;
        }
      } else {
        if (label.x < cx) {
          linePoints[2][0] = label.x + layout2.labelDistance;
        } else {
          linePoints[2][0] = label.x - layout2.labelDistance;
        }
        linePoints[1][0] = linePoints[2][0] + dist2;
      }
      linePoints[1][1] = linePoints[2][1] = label.y;
    }
  }
}
function constrainTextWidth(layout2, availableWidth, forceRecalculate) {
  if (forceRecalculate === void 0) {
    forceRecalculate = false;
  }
  if (layout2.labelStyleWidth != null) {
    return;
  }
  var label = layout2.label;
  var style2 = label.style;
  var textRect = layout2.rect;
  var bgColor = style2.backgroundColor;
  var padding = style2.padding;
  var paddingH = padding ? padding[1] + padding[3] : 0;
  var overflow = style2.overflow;
  var oldOuterWidth = textRect.width + (bgColor ? 0 : paddingH);
  if (availableWidth < oldOuterWidth || forceRecalculate) {
    var oldHeight = textRect.height;
    if (overflow && overflow.match("break")) {
      label.setStyle("backgroundColor", null);
      label.setStyle("width", availableWidth - paddingH);
      var innerRect = label.getBoundingRect();
      label.setStyle("width", Math.ceil(innerRect.width));
      label.setStyle("backgroundColor", bgColor);
    } else {
      var availableInnerWidth = availableWidth - paddingH;
      var newWidth = availableWidth < oldOuterWidth ? availableInnerWidth : forceRecalculate ? availableInnerWidth > layout2.unconstrainedWidth ? null : availableInnerWidth : null;
      label.setStyle("width", newWidth);
    }
    var newRect = label.getBoundingRect();
    textRect.width = newRect.width;
    var margin = (label.style.margin || 0) + 2.1;
    textRect.height = newRect.height + margin;
    textRect.y -= (textRect.height - oldHeight) / 2;
  }
}
function isPositionCenter(sectorShape) {
  return sectorShape.position === "center";
}
function pieLabelLayout(seriesModel) {
  var data2 = seriesModel.getData();
  var labelLayoutList = [];
  var cx;
  var cy;
  var hasLabelRotate = false;
  var minShowLabelRadian = (seriesModel.get("minShowLabelAngle") || 0) * RADIAN$1;
  var viewRect2 = data2.getLayout("viewRect");
  var r2 = data2.getLayout("r");
  var viewWidth = viewRect2.width;
  var viewLeft = viewRect2.x;
  var viewTop = viewRect2.y;
  var viewHeight = viewRect2.height;
  function setNotShow(el) {
    el.ignore = true;
  }
  function isLabelShown(label2) {
    if (!label2.ignore) {
      return true;
    }
    for (var key in label2.states) {
      if (label2.states[key].ignore === false) {
        return true;
      }
    }
    return false;
  }
  data2.each(function(idx) {
    var sector = data2.getItemGraphicEl(idx);
    var sectorShape = sector.shape;
    var label2 = sector.getTextContent();
    var labelLine2 = sector.getTextGuideLine();
    var itemModel = data2.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position") || itemModel.get(["emphasis", "label", "position"]);
    var labelDistance = labelModel.get("distanceToLabelLine");
    var labelAlignTo = labelModel.get("alignTo");
    var edgeDistance = parsePercent(labelModel.get("edgeDistance"), viewWidth);
    var bleedMargin = labelModel.get("bleedMargin");
    var labelLineModel = itemModel.getModel("labelLine");
    var labelLineLen = labelLineModel.get("length");
    labelLineLen = parsePercent(labelLineLen, viewWidth);
    var labelLineLen2 = labelLineModel.get("length2");
    labelLineLen2 = parsePercent(labelLineLen2, viewWidth);
    if (Math.abs(sectorShape.endAngle - sectorShape.startAngle) < minShowLabelRadian) {
      each$g(label2.states, setNotShow);
      label2.ignore = true;
      return;
    }
    if (!isLabelShown(label2)) {
      return;
    }
    var midAngle = (sectorShape.startAngle + sectorShape.endAngle) / 2;
    var nx = Math.cos(midAngle);
    var ny = Math.sin(midAngle);
    var textX;
    var textY;
    var linePoints2;
    var textAlign;
    cx = sectorShape.cx;
    cy = sectorShape.cy;
    var isLabelInside = labelPosition === "inside" || labelPosition === "inner";
    if (labelPosition === "center") {
      textX = sectorShape.cx;
      textY = sectorShape.cy;
      textAlign = "center";
    } else {
      var x1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * nx : sectorShape.r * nx) + cx;
      var y1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * ny : sectorShape.r * ny) + cy;
      textX = x1 + nx * 3;
      textY = y1 + ny * 3;
      if (!isLabelInside) {
        var x2 = x1 + nx * (labelLineLen + r2 - sectorShape.r);
        var y2 = y1 + ny * (labelLineLen + r2 - sectorShape.r);
        var x3 = x2 + (nx < 0 ? -1 : 1) * labelLineLen2;
        var y3 = y2;
        if (labelAlignTo === "edge") {
          textX = nx < 0 ? viewLeft + edgeDistance : viewLeft + viewWidth - edgeDistance;
        } else {
          textX = x3 + (nx < 0 ? -labelDistance : labelDistance);
        }
        textY = y3;
        linePoints2 = [[x1, y1], [x2, y2], [x3, y3]];
      }
      textAlign = isLabelInside ? "center" : labelAlignTo === "edge" ? nx > 0 ? "right" : "left" : nx > 0 ? "left" : "right";
    }
    var PI3 = Math.PI;
    var labelRotate = 0;
    var rotate2 = labelModel.get("rotate");
    if (isNumber(rotate2)) {
      labelRotate = rotate2 * (PI3 / 180);
    } else if (labelPosition === "center") {
      labelRotate = 0;
    } else if (rotate2 === "radial" || rotate2 === true) {
      var radialAngle = nx < 0 ? -midAngle + PI3 : -midAngle;
      labelRotate = radialAngle;
    } else if (rotate2 === "tangential" && labelPosition !== "outside" && labelPosition !== "outer") {
      var rad = Math.atan2(nx, ny);
      if (rad < 0) {
        rad = PI3 * 2 + rad;
      }
      var isDown = ny > 0;
      if (isDown) {
        rad = PI3 + rad;
      }
      labelRotate = rad - PI3;
    }
    hasLabelRotate = !!labelRotate;
    label2.x = textX;
    label2.y = textY;
    label2.rotation = labelRotate;
    label2.setStyle({
      verticalAlign: "middle"
    });
    if (!isLabelInside) {
      var textRect = label2.getBoundingRect().clone();
      textRect.applyTransform(label2.getComputedTransform());
      var margin = (label2.style.margin || 0) + 2.1;
      textRect.y -= margin / 2;
      textRect.height += margin;
      labelLayoutList.push({
        label: label2,
        labelLine: labelLine2,
        position: labelPosition,
        len: labelLineLen,
        len2: labelLineLen2,
        minTurnAngle: labelLineModel.get("minTurnAngle"),
        maxSurfaceAngle: labelLineModel.get("maxSurfaceAngle"),
        surfaceNormal: new Point$1(nx, ny),
        linePoints: linePoints2,
        textAlign,
        labelDistance,
        labelAlignTo,
        edgeDistance,
        bleedMargin,
        rect: textRect,
        unconstrainedWidth: textRect.width,
        labelStyleWidth: label2.style.width
      });
    } else {
      label2.setStyle({
        align: textAlign
      });
      var selectState2 = label2.states.select;
      if (selectState2) {
        selectState2.x += label2.x;
        selectState2.y += label2.y;
      }
    }
    sector.setTextConfig({
      inside: isLabelInside
    });
  });
  if (!hasLabelRotate && seriesModel.get("avoidLabelOverlap")) {
    avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop);
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    var label = layout2.label;
    var labelLine = layout2.labelLine;
    var notShowLabel = isNaN(label.x) || isNaN(label.y);
    if (label) {
      label.setStyle({
        align: layout2.textAlign
      });
      if (notShowLabel) {
        each$g(label.states, setNotShow);
        label.ignore = true;
      }
      var selectState = label.states.select;
      if (selectState) {
        selectState.x += label.x;
        selectState.y += label.y;
      }
    }
    if (labelLine) {
      var linePoints = layout2.linePoints;
      if (notShowLabel || !linePoints) {
        each$g(labelLine.states, setNotShow);
        labelLine.ignore = true;
      } else {
        limitTurnAngle(linePoints, layout2.minTurnAngle);
        limitSurfaceAngle(linePoints, layout2.surfaceNormal, layout2.maxSurfaceAngle);
        labelLine.setShape({
          points: linePoints
        });
        label.__hostTarget.textGuideLineConfig = {
          anchor: new Point$1(linePoints[0][0], linePoints[0][1])
        };
      }
    }
  }
}
function getSectorCornerRadius(model, shape, zeroIfNull) {
  var cornerRadius = model.get("borderRadius");
  if (cornerRadius == null) {
    return zeroIfNull ? {
      cornerRadius: 0
    } : null;
  }
  if (!isArray$2(cornerRadius)) {
    cornerRadius = [cornerRadius, cornerRadius, cornerRadius, cornerRadius];
  }
  var dr = Math.abs(shape.r || 0 - shape.r0 || 0);
  return {
    cornerRadius: map$1(cornerRadius, function(cr) {
      return parsePercent$1(cr, dr);
    })
  };
}
var PiePiece = function(_super) {
  __extends(PiePiece2, _super);
  function PiePiece2(data2, idx, startAngle) {
    var _this = _super.call(this) || this;
    _this.z2 = 2;
    var text = new ZRText$1();
    _this.setTextContent(text);
    _this.updateData(data2, idx, startAngle, true);
    return _this;
  }
  PiePiece2.prototype.updateData = function(data2, idx, startAngle, firstCreate) {
    var sector = this;
    var seriesModel = data2.hostModel;
    var itemModel = data2.getItemModel(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = data2.getItemLayout(idx);
    var sectorShape = extend(getSectorCornerRadius(itemModel.getModel("itemStyle"), layout2, true), layout2);
    if (isNaN(sectorShape.startAngle)) {
      sector.setShape(sectorShape);
      return;
    }
    if (firstCreate) {
      sector.setShape(sectorShape);
      var animationType = seriesModel.getShallow("animationType");
      if (seriesModel.ecModel.ssr) {
        initProps(sector, {
          scaleX: 0,
          scaleY: 0
        }, seriesModel, {
          dataIndex: idx,
          isFrom: true
        });
        sector.originX = sectorShape.cx;
        sector.originY = sectorShape.cy;
      } else if (animationType === "scale") {
        sector.shape.r = layout2.r0;
        initProps(sector, {
          shape: {
            r: layout2.r
          }
        }, seriesModel, idx);
      } else {
        if (startAngle != null) {
          sector.setShape({
            startAngle,
            endAngle: startAngle
          });
          initProps(sector, {
            shape: {
              startAngle: layout2.startAngle,
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        } else {
          sector.shape.endAngle = layout2.startAngle;
          updateProps$1(sector, {
            shape: {
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        }
      }
    } else {
      saveOldStyle(sector);
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel, idx);
    }
    sector.useStyle(data2.getItemVisual(idx, "style"));
    setStatesStylesFromModel(sector, itemModel);
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var offset3 = seriesModel.get("selectedOffset");
    var dx = Math.cos(midAngle) * offset3;
    var dy = Math.sin(midAngle) * offset3;
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._updateLabel(seriesModel, data2, idx);
    sector.ensureState("emphasis").shape = extend({
      r: layout2.r + (emphasisModel.get("scale") ? emphasisModel.get("scaleSize") || 0 : 0)
    }, getSectorCornerRadius(emphasisModel.getModel("itemStyle"), layout2));
    extend(sector.ensureState("select"), {
      x: dx,
      y: dy,
      shape: getSectorCornerRadius(itemModel.getModel(["select", "itemStyle"]), layout2)
    });
    extend(sector.ensureState("blur"), {
      shape: getSectorCornerRadius(itemModel.getModel(["blur", "itemStyle"]), layout2)
    });
    var labelLine = sector.getTextGuideLine();
    var labelText = sector.getTextContent();
    labelLine && extend(labelLine.ensureState("select"), {
      x: dx,
      y: dy
    });
    extend(labelText.ensureState("select"), {
      x: dx,
      y: dy
    });
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  PiePiece2.prototype._updateLabel = function(seriesModel, data2, idx) {
    var sector = this;
    var itemModel = data2.getItemModel(idx);
    var labelLineModel = itemModel.getModel("labelLine");
    var style2 = data2.getItemVisual(idx, "style");
    var visualColor = style2 && style2.fill;
    var visualOpacity = style2 && style2.opacity;
    setLabelStyle(sector, getLabelStatesModels(itemModel), {
      labelFetcher: data2.hostModel,
      labelDataIndex: idx,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      defaultText: seriesModel.getFormattedLabel(idx, "normal") || data2.getName(idx)
    });
    var labelText = sector.getTextContent();
    sector.setTextConfig({
      position: null,
      rotation: null
    });
    labelText.attr({
      z2: 10
    });
    var labelPosition = seriesModel.get(["label", "position"]);
    if (labelPosition !== "outside" && labelPosition !== "outer") {
      sector.removeTextGuideLine();
    } else {
      var polyline = this.getTextGuideLine();
      if (!polyline) {
        polyline = new Polyline$3();
        this.setTextGuideLine(polyline);
      }
      setLabelLineStyle(this, getLabelLineStatesModels(itemModel), {
        stroke: visualColor,
        opacity: retrieve3(labelLineModel.get(["lineStyle", "opacity"]), visualOpacity, 1)
      });
    }
  };
  return PiePiece2;
}(Sector$1);
var PieView = function(_super) {
  __extends(PieView2, _super);
  function PieView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  PieView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var startAngle;
    if (!oldData && data2.count() > 0) {
      var shape = data2.getItemLayout(0);
      for (var s = 1; isNaN(shape && shape.startAngle) && s < data2.count(); ++s) {
        shape = data2.getItemLayout(s);
      }
      if (shape) {
        startAngle = shape.startAngle;
      }
    }
    if (this._emptyCircleSector) {
      group.remove(this._emptyCircleSector);
    }
    if (data2.count() === 0 && seriesModel.get("showEmptyCircle")) {
      var sector = new Sector$1({
        shape: getBasicPieLayout(seriesModel, api)
      });
      sector.useStyle(seriesModel.getModel("emptyCircleStyle").getItemStyle());
      this._emptyCircleSector = sector;
      group.add(sector);
    }
    data2.diff(oldData).add(function(idx) {
      var piePiece = new PiePiece(data2, idx, startAngle);
      data2.setItemGraphicEl(idx, piePiece);
      group.add(piePiece);
    }).update(function(newIdx, oldIdx) {
      var piePiece = oldData.getItemGraphicEl(oldIdx);
      piePiece.updateData(data2, newIdx, startAngle);
      piePiece.off("click");
      group.add(piePiece);
      data2.setItemGraphicEl(newIdx, piePiece);
    }).remove(function(idx) {
      var piePiece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piePiece, seriesModel, idx);
    }).execute();
    pieLabelLayout(seriesModel);
    if (seriesModel.get("animationTypeUpdate") !== "expansion") {
      this._data = data2;
    }
  };
  PieView2.prototype.dispose = function() {
  };
  PieView2.prototype.containPoint = function(point, seriesModel) {
    var data2 = seriesModel.getData();
    var itemLayout = data2.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  PieView2.type = "pie";
  return PieView2;
}(ChartView$1);
var PieView$1 = PieView;
function createSeriesDataSimply(seriesModel, opt, nameList) {
  opt = isArray$2(opt) && {
    coordDimensions: opt
  } || extend({
    encodeDefine: seriesModel.getEncode()
  }, opt);
  var source = seriesModel.getSource();
  var dimensions = prepareSeriesDataSchema(source, opt).dimensions;
  var list = new SeriesData$1(dimensions, seriesModel);
  list.initData(source, nameList);
  return list;
}
var LegendVisualProvider = function() {
  function LegendVisualProvider2(getDataWithEncodedVisual, getRawData2) {
    this._getDataWithEncodedVisual = getDataWithEncodedVisual;
    this._getRawData = getRawData2;
  }
  LegendVisualProvider2.prototype.getAllNames = function() {
    var rawData = this._getRawData();
    return rawData.mapArray(rawData.getName);
  };
  LegendVisualProvider2.prototype.containName = function(name2) {
    var rawData = this._getRawData();
    return rawData.indexOfName(name2) >= 0;
  };
  LegendVisualProvider2.prototype.indexOfName = function(name2) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.indexOfName(name2);
  };
  LegendVisualProvider2.prototype.getItemVisual = function(dataIndex, key) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.getItemVisual(dataIndex, key);
  };
  return LegendVisualProvider2;
}();
var LegendVisualProvider$1 = LegendVisualProvider;
var PieSeriesModel = function(_super) {
  __extends(PieSeriesModel2, _super);
  function PieSeriesModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PieSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  PieSeriesModel2.prototype.mergeOption = function() {
    _super.prototype.mergeOption.apply(this, arguments);
  };
  PieSeriesModel2.prototype.getInitialData = function() {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$3(makeSeriesEncodeForNameBased, this)
    });
  };
  PieSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data2 = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueList = [];
    data2.each(data2.mapDimension("value"), function(value) {
      valueList.push(value);
    });
    params.percent = getPercentWithPrecision(valueList, dataIndex, data2.hostModel.get("percentPrecision"));
    params.$vars.push("percent");
    return params;
  };
  PieSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  PieSeriesModel2.type = "series.pie";
  PieSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    minShowLabelAngle: 0,
    selectedOffset: 10,
    percentPrecision: 2,
    stillShowZeroSum: true,
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    width: null,
    height: null,
    label: {
      rotate: 0,
      show: true,
      overflow: "truncate",
      position: "outer",
      alignTo: "none",
      edgeDistance: "25%",
      bleedMargin: 10,
      distanceToLabelLine: 5
    },
    labelLine: {
      show: true,
      length: 15,
      length2: 15,
      smooth: false,
      minTurnAngle: 90,
      maxSurfaceAngle: 90,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      borderWidth: 1,
      borderJoin: "round"
    },
    showEmptyCircle: true,
    emptyCircleStyle: {
      color: "lightgray",
      opacity: 1
    },
    labelLayout: {
      hideOverlap: true
    },
    emphasis: {
      scale: true,
      scaleSize: 5
    },
    avoidLabelOverlap: true,
    animationType: "expansion",
    animationDuration: 1e3,
    animationTypeUpdate: "transition",
    animationEasingUpdate: "cubicInOut",
    animationDurationUpdate: 500,
    animationEasing: "cubicInOut"
  };
  return PieSeriesModel2;
}(SeriesModel$1);
var PieSeriesModel$1 = PieSeriesModel;
function negativeDataFilter(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var data2 = seriesModel.getData();
      data2.filterSelf(function(idx) {
        var valueDim = data2.mapDimension("value");
        var curValue = data2.get(valueDim, idx);
        if (isNumber(curValue) && !isNaN(curValue) && curValue < 0) {
          return false;
        }
        return true;
      });
    }
  };
}
function install$O(registers) {
  registers.registerChartView(PieView$1);
  registers.registerSeriesModel(PieSeriesModel$1);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry$3(pieLayout, "pie"));
  registers.registerProcessor(dataFilter$1("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
var ScatterSeriesModel = function(_super) {
  __extends(ScatterSeriesModel2, _super);
  function ScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  ScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  ScatterSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 5e3 : this.get("progressive");
    }
    return progressive;
  };
  ScatterSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 1e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  ScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data2, selectors) {
    return selectors.point(data2.getItemLayout(dataIndex));
  };
  ScatterSeriesModel2.prototype.getZLevelKey = function() {
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
  };
  ScatterSeriesModel2.type = "series.scatter";
  ScatterSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  ScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    symbolSize: 10,
    large: false,
    largeThreshold: 2e3,
    itemStyle: {
      opacity: 0.8
    },
    emphasis: {
      scale: true
    },
    clip: true,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    universalTransition: {
      divideShape: "clone"
    }
  };
  return ScatterSeriesModel2;
}(SeriesModel$1);
var ScatterSeriesModel$1 = ScatterSeriesModel;
var BOOST_SIZE_THRESHOLD = 4;
var LargeSymbolPathShape = function() {
  function LargeSymbolPathShape2() {
  }
  return LargeSymbolPathShape2;
}();
var LargeSymbolPath = function(_super) {
  __extends(LargeSymbolPath2, _super);
  function LargeSymbolPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeSymbolPath2.prototype.getDefaultShape = function() {
    return new LargeSymbolPathShape();
  };
  LargeSymbolPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeSymbolPath2.prototype.buildPath = function(path, shape) {
    var points2 = shape.points;
    var size = shape.size;
    var symbolProxy = this.symbolProxy;
    var symbolProxyShape = symbolProxy.shape;
    var ctx = path.getContext ? path.getContext() : path;
    var canBoost = ctx && size[0] < BOOST_SIZE_THRESHOLD;
    var softClipShape = this.softClipShape;
    var i;
    if (canBoost) {
      this._ctx = ctx;
      return;
    }
    this._ctx = null;
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      symbolProxyShape.x = x2 - size[0] / 2;
      symbolProxyShape.y = y2 - size[1] / 2;
      symbolProxyShape.width = size[0];
      symbolProxyShape.height = size[1];
      symbolProxy.buildPath(path, symbolProxyShape, true);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.afterBrush = function() {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var ctx = this._ctx;
    var softClipShape = this.softClipShape;
    var i;
    if (!ctx) {
      return;
    }
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      ctx.fillRect(x2 - size[0] / 2, y2 - size[1] / 2, size[0], size[1]);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var w2 = Math.max(size[0], 4);
    var h = Math.max(size[1], 4);
    for (var idx = points2.length / 2 - 1; idx >= 0; idx--) {
      var i = idx * 2;
      var x0 = points2[i] - w2 / 2;
      var y0 = points2[i + 1] - h / 2;
      if (x2 >= x0 && y2 >= y0 && x2 <= x0 + w2 && y2 <= y0 + h) {
        return idx;
      }
    }
    return -1;
  };
  LargeSymbolPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeSymbolPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.points;
      var size = shape.size;
      var w2 = size[0];
      var h = size[1];
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX - w2 / 2, minY - h / 2, maxX - minX + w2, maxY - minY + h);
    }
    return rect;
  };
  return LargeSymbolPath2;
}(Path$1);
var LargeSymbolDraw = function() {
  function LargeSymbolDraw2() {
    this.group = new Group$6();
  }
  LargeSymbolDraw2.prototype.updateData = function(data2, opt) {
    this._clear();
    var symbolEl = this._create();
    symbolEl.setShape({
      points: data2.getLayout("points")
    });
    this._setCommon(symbolEl, data2, opt);
  };
  LargeSymbolDraw2.prototype.updateLayout = function(data2) {
    var points2 = data2.getLayout("points");
    this.group.eachChild(function(child) {
      if (child.startIndex != null) {
        var len2 = (child.endIndex - child.startIndex) * 2;
        var byteOffset = child.startIndex * 4 * 2;
        points2 = new Float32Array(points2.buffer, byteOffset, len2);
      }
      child.setShape("points", points2);
      child.reset();
    });
  };
  LargeSymbolDraw2.prototype.incrementalPrepareUpdate = function(data2) {
    this._clear();
  };
  LargeSymbolDraw2.prototype.incrementalUpdate = function(taskParams, data2, opt) {
    var lastAdded = this._newAdded[0];
    var points2 = data2.getLayout("points");
    var oldPoints = lastAdded && lastAdded.shape.points;
    if (oldPoints && oldPoints.length < 2e4) {
      var oldLen = oldPoints.length;
      var newPoints = new Float32Array(oldLen + points2.length);
      newPoints.set(oldPoints);
      newPoints.set(points2, oldLen);
      lastAdded.endIndex = taskParams.end;
      lastAdded.setShape({
        points: newPoints
      });
    } else {
      this._newAdded = [];
      var symbolEl = this._create();
      symbolEl.startIndex = taskParams.start;
      symbolEl.endIndex = taskParams.end;
      symbolEl.incremental = true;
      symbolEl.setShape({
        points: points2
      });
      this._setCommon(symbolEl, data2, opt);
    }
  };
  LargeSymbolDraw2.prototype.eachRendered = function(cb2) {
    this._newAdded[0] && cb2(this._newAdded[0]);
  };
  LargeSymbolDraw2.prototype._create = function() {
    var symbolEl = new LargeSymbolPath({
      cursor: "default"
    });
    this.group.add(symbolEl);
    this._newAdded.push(symbolEl);
    return symbolEl;
  };
  LargeSymbolDraw2.prototype._setCommon = function(symbolEl, data2, opt) {
    var hostModel = data2.hostModel;
    opt = opt || {};
    var size = data2.getVisual("symbolSize");
    symbolEl.setShape("size", size instanceof Array ? size : [size, size]);
    symbolEl.softClipShape = opt.clipShape || null;
    symbolEl.symbolProxy = createSymbol$1(data2.getVisual("symbol"), 0, 0, 0, 0);
    symbolEl.setColor = symbolEl.symbolProxy.setColor;
    var extrudeShadow = symbolEl.shape.size[0] < BOOST_SIZE_THRESHOLD;
    symbolEl.useStyle(hostModel.getModel("itemStyle").getItemStyle(extrudeShadow ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
    var globalStyle = data2.getVisual("style");
    var visualColor = globalStyle && globalStyle.fill;
    if (visualColor) {
      symbolEl.setColor(visualColor);
    }
    var ecData = getECData(symbolEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    symbolEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = symbolEl.hoverDataIdx;
      if (dataIndex >= 0) {
        ecData.dataIndex = dataIndex + (symbolEl.startIndex || 0);
      }
    });
  };
  LargeSymbolDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeSymbolDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeSymbolDraw2;
}();
var LargeSymbolDraw$1 = LargeSymbolDraw;
var ScatterView = function(_super) {
  __extends(ScatterView2, _super);
  function ScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterView2.type;
    return _this;
  }
  ScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data2, seriesModel);
    symbolDraw.updateData(data2, {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = true;
  };
  ScatterView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data2, seriesModel);
    symbolDraw.incrementalPrepareUpdate(data2);
    this._finished = false;
  };
  ScatterView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._symbolDraw.incrementalUpdate(taskParams, seriesModel.getData(), {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  ScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    this.group.dirty();
    if (!this._finished || data2.count() > 1e4) {
      return {
        update: true
      };
    } else {
      var res2 = pointsLayout("").reset(seriesModel, ecModel, api);
      if (res2.progress) {
        res2.progress({
          start: 0,
          end: data2.count(),
          count: data2.count()
        }, data2);
      }
      this._symbolDraw.updateLayout(data2);
    }
  };
  ScatterView2.prototype.eachRendered = function(cb2) {
    this._symbolDraw && this._symbolDraw.eachRendered(cb2);
  };
  ScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  ScatterView2.prototype._updateSymbolDraw = function(data2, seriesModel) {
    var symbolDraw = this._symbolDraw;
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!symbolDraw || isLargeDraw !== this._isLargeDraw) {
      symbolDraw && symbolDraw.remove();
      symbolDraw = this._symbolDraw = isLargeDraw ? new LargeSymbolDraw$1() : new SymbolDraw$1();
      this._isLargeDraw = isLargeDraw;
      this.group.removeAll();
    }
    this.group.add(symbolDraw.group);
    return symbolDraw;
  };
  ScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
    this._symbolDraw = null;
  };
  ScatterView2.prototype.dispose = function() {
  };
  ScatterView2.type = "scatter";
  return ScatterView2;
}(ChartView$1);
var ScatterView$1 = ScatterView;
var GridModel = function(_super) {
  __extends(GridModel2, _super);
  function GridModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GridModel2.type = "grid";
  GridModel2.dependencies = ["xAxis", "yAxis"];
  GridModel2.layoutMode = "box";
  GridModel2.defaultOption = {
    show: false,
    z: 0,
    left: "10%",
    top: 60,
    right: "10%",
    bottom: 70,
    containLabel: false,
    backgroundColor: "rgba(0,0,0,0)",
    borderWidth: 1,
    borderColor: "#ccc"
  };
  return GridModel2;
}(ComponentModel$1);
var GridModel$1 = GridModel;
var CartesianAxisModel = function(_super) {
  __extends(CartesianAxisModel2, _super);
  function CartesianAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("grid", SINGLE_REFERRING).models[0];
  };
  CartesianAxisModel2.type = "cartesian2dAxis";
  return CartesianAxisModel2;
}(ComponentModel$1);
mixin(CartesianAxisModel, AxisModelCommonMixin);
var defaultOption$1 = {
  show: true,
  z: 0,
  inverse: false,
  name: "",
  nameLocation: "end",
  nameRotate: null,
  nameTruncate: {
    maxWidth: null,
    ellipsis: "...",
    placeholder: "."
  },
  nameTextStyle: {},
  nameGap: 15,
  silent: false,
  triggerEvent: false,
  tooltip: {
    show: false
  },
  axisPointer: {},
  axisLine: {
    show: true,
    onZero: true,
    onZeroAxisIndex: null,
    lineStyle: {
      color: "#6E7079",
      width: 1,
      type: "solid"
    },
    symbol: ["none", "none"],
    symbolSize: [10, 15]
  },
  axisTick: {
    show: true,
    inside: false,
    length: 5,
    lineStyle: {
      width: 1
    }
  },
  axisLabel: {
    show: true,
    inside: false,
    rotate: 0,
    showMinLabel: null,
    showMaxLabel: null,
    margin: 8,
    fontSize: 12
  },
  splitLine: {
    show: true,
    lineStyle: {
      color: ["#E0E6F1"],
      width: 1,
      type: "solid"
    }
  },
  splitArea: {
    show: false,
    areaStyle: {
      color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"]
    }
  }
};
var categoryAxis = merge$1({
  boundaryGap: true,
  deduplication: null,
  splitLine: {
    show: false
  },
  axisTick: {
    alignWithLabel: false,
    interval: "auto"
  },
  axisLabel: {
    interval: "auto"
  }
}, defaultOption$1);
var valueAxis = merge$1({
  boundaryGap: [0, 0],
  axisLine: {
    show: "auto"
  },
  axisTick: {
    show: "auto"
  },
  splitNumber: 5,
  minorTick: {
    show: false,
    splitNumber: 5,
    length: 3,
    lineStyle: {}
  },
  minorSplitLine: {
    show: false,
    lineStyle: {
      color: "#F4F7FD",
      width: 1
    }
  }
}, defaultOption$1);
var timeAxis = merge$1({
  splitNumber: 6,
  axisLabel: {
    showMinLabel: false,
    showMaxLabel: false,
    rich: {
      primary: {
        fontWeight: "bold"
      }
    }
  },
  splitLine: {
    show: false
  }
}, valueAxis);
var logAxis = defaults({
  logBase: 10
}, valueAxis);
var axisDefault = {
  category: categoryAxis,
  value: valueAxis,
  time: timeAxis,
  log: logAxis
};
var AXIS_TYPES = {
  value: 1,
  category: 1,
  time: 1,
  log: 1
};
function axisModelCreator(registers, axisName, BaseAxisModelClass, extraDefaultOption) {
  each$g(AXIS_TYPES, function(v4, axisType) {
    var defaultOption2 = merge$1(merge$1({}, axisDefault[axisType], true), extraDefaultOption, true);
    var AxisModel = function(_super) {
      __extends(AxisModel2, _super);
      function AxisModel2() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.type = axisName + "Axis." + axisType;
        return _this;
      }
      AxisModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
        var layoutMode = fetchLayoutMode(this);
        var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
        var themeModel = ecModel.getTheme();
        merge$1(option, themeModel.get(axisType + "Axis"));
        merge$1(option, this.getDefaultOption());
        option.type = getAxisType(option);
        if (layoutMode) {
          mergeLayoutParam(option, inputPositionParams, layoutMode);
        }
      };
      AxisModel2.prototype.optionUpdated = function() {
        var thisOption = this.option;
        if (thisOption.type === "category") {
          this.__ordinalMeta = OrdinalMeta$1.createByAxisModel(this);
        }
      };
      AxisModel2.prototype.getCategories = function(rawData) {
        var option = this.option;
        if (option.type === "category") {
          if (rawData) {
            return option.data;
          }
          return this.__ordinalMeta.categories;
        }
      };
      AxisModel2.prototype.getOrdinalMeta = function() {
        return this.__ordinalMeta;
      };
      AxisModel2.type = axisName + "Axis." + axisType;
      AxisModel2.defaultOption = defaultOption2;
      return AxisModel2;
    }(BaseAxisModelClass);
    registers.registerComponentModel(AxisModel);
  });
  registers.registerSubTypeDefaulter(axisName + "Axis", getAxisType);
}
function getAxisType(option) {
  return option.type || (option.data ? "category" : "value");
}
var Cartesian = function() {
  function Cartesian2(name2) {
    this.type = "cartesian";
    this._dimList = [];
    this._axes = {};
    this.name = name2 || "";
  }
  Cartesian2.prototype.getAxis = function(dim) {
    return this._axes[dim];
  };
  Cartesian2.prototype.getAxes = function() {
    return map$1(this._dimList, function(dim) {
      return this._axes[dim];
    }, this);
  };
  Cartesian2.prototype.getAxesByScale = function(scaleType) {
    scaleType = scaleType.toLowerCase();
    return filter(this.getAxes(), function(axis) {
      return axis.scale.type === scaleType;
    });
  };
  Cartesian2.prototype.addAxis = function(axis) {
    var dim = axis.dim;
    this._axes[dim] = axis;
    this._dimList.push(dim);
  };
  return Cartesian2;
}();
var Cartesian$1 = Cartesian;
var cartesian2DDimensions = ["x", "y"];
function canCalculateAffineTransform(scale2) {
  return scale2.type === "interval" || scale2.type === "time";
}
var Cartesian2D = function(_super) {
  __extends(Cartesian2D2, _super);
  function Cartesian2D2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "cartesian2d";
    _this.dimensions = cartesian2DDimensions;
    return _this;
  }
  Cartesian2D2.prototype.calcAffineTransform = function() {
    this._transform = this._invTransform = null;
    var xAxisScale = this.getAxis("x").scale;
    var yAxisScale = this.getAxis("y").scale;
    if (!canCalculateAffineTransform(xAxisScale) || !canCalculateAffineTransform(yAxisScale)) {
      return;
    }
    var xScaleExtent = xAxisScale.getExtent();
    var yScaleExtent = yAxisScale.getExtent();
    var start2 = this.dataToPoint([xScaleExtent[0], yScaleExtent[0]]);
    var end2 = this.dataToPoint([xScaleExtent[1], yScaleExtent[1]]);
    var xScaleSpan = xScaleExtent[1] - xScaleExtent[0];
    var yScaleSpan = yScaleExtent[1] - yScaleExtent[0];
    if (!xScaleSpan || !yScaleSpan) {
      return;
    }
    var scaleX = (end2[0] - start2[0]) / xScaleSpan;
    var scaleY = (end2[1] - start2[1]) / yScaleSpan;
    var translateX = start2[0] - xScaleExtent[0] * scaleX;
    var translateY = start2[1] - yScaleExtent[0] * scaleY;
    var m2 = this._transform = [scaleX, 0, 0, scaleY, translateX, translateY];
    this._invTransform = invert([], m2);
  };
  Cartesian2D2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
  };
  Cartesian2D2.prototype.containPoint = function(point) {
    var axisX = this.getAxis("x");
    var axisY = this.getAxis("y");
    return axisX.contain(axisX.toLocalCoord(point[0])) && axisY.contain(axisY.toLocalCoord(point[1]));
  };
  Cartesian2D2.prototype.containData = function(data2) {
    return this.getAxis("x").containData(data2[0]) && this.getAxis("y").containData(data2[1]);
  };
  Cartesian2D2.prototype.dataToPoint = function(data2, clamp2, out2) {
    out2 = out2 || [];
    var xVal = data2[0];
    var yVal = data2[1];
    if (this._transform && xVal != null && isFinite(xVal) && yVal != null && isFinite(yVal)) {
      return applyTransform$1(out2, data2, this._transform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.toGlobalCoord(xAxis.dataToCoord(xVal, clamp2));
    out2[1] = yAxis.toGlobalCoord(yAxis.dataToCoord(yVal, clamp2));
    return out2;
  };
  Cartesian2D2.prototype.clampData = function(data2, out2) {
    var xScale = this.getAxis("x").scale;
    var yScale = this.getAxis("y").scale;
    var xAxisExtent = xScale.getExtent();
    var yAxisExtent = yScale.getExtent();
    var x2 = xScale.parse(data2[0]);
    var y2 = yScale.parse(data2[1]);
    out2 = out2 || [];
    out2[0] = Math.min(Math.max(Math.min(xAxisExtent[0], xAxisExtent[1]), x2), Math.max(xAxisExtent[0], xAxisExtent[1]));
    out2[1] = Math.min(Math.max(Math.min(yAxisExtent[0], yAxisExtent[1]), y2), Math.max(yAxisExtent[0], yAxisExtent[1]));
    return out2;
  };
  Cartesian2D2.prototype.pointToData = function(point, clamp2) {
    var out2 = [];
    if (this._invTransform) {
      return applyTransform$1(out2, point, this._invTransform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.coordToData(xAxis.toLocalCoord(point[0]), clamp2);
    out2[1] = yAxis.coordToData(yAxis.toLocalCoord(point[1]), clamp2);
    return out2;
  };
  Cartesian2D2.prototype.getOtherAxis = function(axis) {
    return this.getAxis(axis.dim === "x" ? "y" : "x");
  };
  Cartesian2D2.prototype.getArea = function() {
    var xExtent = this.getAxis("x").getGlobalExtent();
    var yExtent = this.getAxis("y").getGlobalExtent();
    var x2 = Math.min(xExtent[0], xExtent[1]);
    var y2 = Math.min(yExtent[0], yExtent[1]);
    var width = Math.max(xExtent[0], xExtent[1]) - x2;
    var height = Math.max(yExtent[0], yExtent[1]) - y2;
    return new BoundingRect$1(x2, y2, width, height);
  };
  return Cartesian2D2;
}(Cartesian$1);
var Cartesian2D$1 = Cartesian2D;
var Axis2D = function(_super) {
  __extends(Axis2D2, _super);
  function Axis2D2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.index = 0;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  Axis2D2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  Axis2D2.prototype.getGlobalExtent = function(asc2) {
    var ret = this.getExtent();
    ret[0] = this.toGlobalCoord(ret[0]);
    ret[1] = this.toGlobalCoord(ret[1]);
    asc2 && ret[0] > ret[1] && ret.reverse();
    return ret;
  };
  Axis2D2.prototype.pointToData = function(point, clamp2) {
    return this.coordToData(this.toLocalCoord(point[this.dim === "x" ? 0 : 1]), clamp2);
  };
  Axis2D2.prototype.setCategorySortInfo = function(info) {
    if (this.type !== "category") {
      return false;
    }
    this.model.option.categorySortInfo = info;
    this.scale.setSortInfo(info);
  };
  return Axis2D2;
}(Axis$1);
var Axis2D$1 = Axis2D;
function layout$2(gridModel, axisModel, opt) {
  opt = opt || {};
  var grid = gridModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var otherAxisOnZeroOf = axis.getAxesOnZeroOf()[0];
  var rawAxisPosition = axis.position;
  var axisPosition = otherAxisOnZeroOf ? "onZero" : rawAxisPosition;
  var axisDim = axis.dim;
  var rect = grid.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var idx = {
    left: 0,
    right: 1,
    top: 0,
    bottom: 1,
    onZero: 2
  };
  var axisOffset = axisModel.get("offset") || 0;
  var posBound = axisDim === "x" ? [rectBound[2] - axisOffset, rectBound[3] + axisOffset] : [rectBound[0] - axisOffset, rectBound[1] + axisOffset];
  if (otherAxisOnZeroOf) {
    var onZeroCoord = otherAxisOnZeroOf.toGlobalCoord(otherAxisOnZeroOf.dataToCoord(0));
    posBound[idx.onZero] = Math.max(Math.min(onZeroCoord, posBound[1]), posBound[0]);
  }
  layout2.position = [axisDim === "y" ? posBound[idx[axisPosition]] : rectBound[0], axisDim === "x" ? posBound[idx[axisPosition]] : rectBound[3]];
  layout2.rotation = Math.PI / 2 * (axisDim === "x" ? 0 : 1);
  var dirMap = {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = dirMap[rawAxisPosition];
  layout2.labelOffset = otherAxisOnZeroOf ? posBound[idx[rawAxisPosition]] - posBound[idx.onZero] : 0;
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotate = axisModel.get(["axisLabel", "rotate"]);
  layout2.labelRotate = axisPosition === "top" ? -labelRotate : labelRotate;
  layout2.z2 = 1;
  return layout2;
}
function isCartesian2DSeries(seriesModel) {
  return seriesModel.get("coordinateSystem") === "cartesian2d";
}
function findAxisModels(seriesModel) {
  var axisModelMap = {
    xAxisModel: null,
    yAxisModel: null
  };
  each$g(axisModelMap, function(v4, key) {
    var axisType = key.replace(/Model$/, "");
    var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
    axisModelMap[key] = axisModel;
  });
  return axisModelMap;
}
var mathLog = Math.log;
function alignScaleTicks(scale2, axisModel, alignToScale) {
  var intervalScaleProto2 = IntervalScale$1.prototype;
  var alignToTicks = intervalScaleProto2.getTicks.call(alignToScale);
  var alignToNicedTicks = intervalScaleProto2.getTicks.call(alignToScale, true);
  var alignToSplitNumber = alignToTicks.length - 1;
  var alignToInterval = intervalScaleProto2.getInterval.call(alignToScale);
  var scaleExtent = getScaleExtent(scale2, axisModel);
  var rawExtent = scaleExtent.extent;
  var isMinFixed = scaleExtent.fixMin;
  var isMaxFixed = scaleExtent.fixMax;
  if (scale2.type === "log") {
    var logBase = mathLog(scale2.base);
    rawExtent = [mathLog(rawExtent[0]) / logBase, mathLog(rawExtent[1]) / logBase];
  }
  scale2.setExtent(rawExtent[0], rawExtent[1]);
  scale2.calcNiceExtent({
    splitNumber: alignToSplitNumber,
    fixMin: isMinFixed,
    fixMax: isMaxFixed
  });
  var extent3 = intervalScaleProto2.getExtent.call(scale2);
  if (isMinFixed) {
    rawExtent[0] = extent3[0];
  }
  if (isMaxFixed) {
    rawExtent[1] = extent3[1];
  }
  var interval = intervalScaleProto2.getInterval.call(scale2);
  var min3 = rawExtent[0];
  var max3 = rawExtent[1];
  if (isMinFixed && isMaxFixed) {
    interval = (max3 - min3) / alignToSplitNumber;
  } else if (isMinFixed) {
    max3 = rawExtent[0] + interval * alignToSplitNumber;
    while (max3 < rawExtent[1] && isFinite(max3) && isFinite(rawExtent[1])) {
      interval = increaseInterval(interval);
      max3 = rawExtent[0] + interval * alignToSplitNumber;
    }
  } else if (isMaxFixed) {
    min3 = rawExtent[1] - interval * alignToSplitNumber;
    while (min3 > rawExtent[0] && isFinite(min3) && isFinite(rawExtent[0])) {
      interval = increaseInterval(interval);
      min3 = rawExtent[1] - interval * alignToSplitNumber;
    }
  } else {
    var nicedSplitNumber = scale2.getTicks().length - 1;
    if (nicedSplitNumber > alignToSplitNumber) {
      interval = increaseInterval(interval);
    }
    var range3 = interval * alignToSplitNumber;
    max3 = Math.ceil(rawExtent[1] / interval) * interval;
    min3 = round$3(max3 - range3);
    if (min3 < 0 && rawExtent[0] >= 0) {
      min3 = 0;
      max3 = round$3(range3);
    } else if (max3 > 0 && rawExtent[1] <= 0) {
      max3 = 0;
      min3 = -round$3(range3);
    }
  }
  var t0 = (alignToTicks[0].value - alignToNicedTicks[0].value) / alignToInterval;
  var t1 = (alignToTicks[alignToSplitNumber].value - alignToNicedTicks[alignToSplitNumber].value) / alignToInterval;
  intervalScaleProto2.setExtent.call(scale2, min3 + interval * t0, max3 + interval * t1);
  intervalScaleProto2.setInterval.call(scale2, interval);
  if (t0 || t1) {
    intervalScaleProto2.setNiceExtent.call(scale2, min3 + interval, max3 - interval);
  }
}
var Grid = function() {
  function Grid2(gridModel, ecModel, api) {
    this.type = "grid";
    this._coordsMap = {};
    this._coordsList = [];
    this._axesMap = {};
    this._axesList = [];
    this.axisPointerEnabled = true;
    this.dimensions = cartesian2DDimensions;
    this._initCartesian(gridModel, ecModel, api);
    this.model = gridModel;
  }
  Grid2.prototype.getRect = function() {
    return this._rect;
  };
  Grid2.prototype.update = function(ecModel, api) {
    var axesMap = this._axesMap;
    this._updateScale(ecModel, this.model);
    function updateAxisTicks(axes) {
      var alignTo;
      var axesIndices = keys(axes);
      var len2 = axesIndices.length;
      if (!len2) {
        return;
      }
      var axisNeedsAlign = [];
      for (var i = len2 - 1; i >= 0; i--) {
        var idx = +axesIndices[i];
        var axis = axes[idx];
        var model = axis.model;
        var scale2 = axis.scale;
        if (isIntervalOrLogScale(scale2) && model.get("alignTicks") && model.get("interval") == null) {
          axisNeedsAlign.push(axis);
        } else {
          niceScaleExtent(scale2, model);
          if (isIntervalOrLogScale(scale2)) {
            alignTo = axis;
          }
        }
      }
      if (axisNeedsAlign.length) {
        if (!alignTo) {
          alignTo = axisNeedsAlign.pop();
          niceScaleExtent(alignTo.scale, alignTo.model);
        }
        each$g(axisNeedsAlign, function(axis2) {
          alignScaleTicks(axis2.scale, axis2.model, alignTo.scale);
        });
      }
    }
    updateAxisTicks(axesMap.x);
    updateAxisTicks(axesMap.y);
    var onZeroRecords = {};
    each$g(axesMap.x, function(xAxis) {
      fixAxisOnZero(axesMap, "y", xAxis, onZeroRecords);
    });
    each$g(axesMap.y, function(yAxis) {
      fixAxisOnZero(axesMap, "x", yAxis, onZeroRecords);
    });
    this.resize(this.model, api);
  };
  Grid2.prototype.resize = function(gridModel, api, ignoreContainLabel) {
    var boxLayoutParams = gridModel.getBoxLayoutParams();
    var isContainLabel = !ignoreContainLabel && gridModel.get("containLabel");
    var gridRect = getLayoutRect(boxLayoutParams, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._rect = gridRect;
    var axesList = this._axesList;
    adjustAxes();
    if (isContainLabel) {
      each$g(axesList, function(axis) {
        if (!axis.model.get(["axisLabel", "inside"])) {
          var labelUnionRect = estimateLabelUnionRect(axis);
          if (labelUnionRect) {
            var dim = axis.isHorizontal() ? "height" : "width";
            var margin = axis.model.get(["axisLabel", "margin"]);
            gridRect[dim] -= labelUnionRect[dim] + margin;
            if (axis.position === "top") {
              gridRect.y += labelUnionRect.height + margin;
            } else if (axis.position === "left") {
              gridRect.x += labelUnionRect.width + margin;
            }
          }
        }
      });
      adjustAxes();
    }
    each$g(this._coordsList, function(coord) {
      coord.calcAffineTransform();
    });
    function adjustAxes() {
      each$g(axesList, function(axis) {
        var isHorizontal = axis.isHorizontal();
        var extent3 = isHorizontal ? [0, gridRect.width] : [0, gridRect.height];
        var idx = axis.inverse ? 1 : 0;
        axis.setExtent(extent3[idx], extent3[1 - idx]);
        updateAxisTransform(axis, isHorizontal ? gridRect.x : gridRect.y);
      });
    }
  };
  Grid2.prototype.getAxis = function(dim, axisIndex) {
    var axesMapOnDim = this._axesMap[dim];
    if (axesMapOnDim != null) {
      return axesMapOnDim[axisIndex || 0];
    }
  };
  Grid2.prototype.getAxes = function() {
    return this._axesList.slice();
  };
  Grid2.prototype.getCartesian = function(xAxisIndex, yAxisIndex) {
    if (xAxisIndex != null && yAxisIndex != null) {
      var key = "x" + xAxisIndex + "y" + yAxisIndex;
      return this._coordsMap[key];
    }
    if (isObject$6(xAxisIndex)) {
      yAxisIndex = xAxisIndex.yAxisIndex;
      xAxisIndex = xAxisIndex.xAxisIndex;
    }
    for (var i = 0, coordList = this._coordsList; i < coordList.length; i++) {
      if (coordList[i].getAxis("x").index === xAxisIndex || coordList[i].getAxis("y").index === yAxisIndex) {
        return coordList[i];
      }
    }
  };
  Grid2.prototype.getCartesians = function() {
    return this._coordsList.slice();
  };
  Grid2.prototype.convertToPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.dataToPoint(value) : target.axis ? target.axis.toGlobalCoord(target.axis.dataToCoord(value)) : null;
  };
  Grid2.prototype.convertFromPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.pointToData(value) : target.axis ? target.axis.coordToData(target.axis.toLocalCoord(value)) : null;
  };
  Grid2.prototype._findConvertTarget = function(finder) {
    var seriesModel = finder.seriesModel;
    var xAxisModel = finder.xAxisModel || seriesModel && seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = finder.yAxisModel || seriesModel && seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    var gridModel = finder.gridModel;
    var coordsList = this._coordsList;
    var cartesian;
    var axis;
    if (seriesModel) {
      cartesian = seriesModel.coordinateSystem;
      indexOf(coordsList, cartesian) < 0 && (cartesian = null);
    } else if (xAxisModel && yAxisModel) {
      cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    } else if (xAxisModel) {
      axis = this.getAxis("x", xAxisModel.componentIndex);
    } else if (yAxisModel) {
      axis = this.getAxis("y", yAxisModel.componentIndex);
    } else if (gridModel) {
      var grid = gridModel.coordinateSystem;
      if (grid === this) {
        cartesian = this._coordsList[0];
      }
    }
    return {
      cartesian,
      axis
    };
  };
  Grid2.prototype.containPoint = function(point) {
    var coord = this._coordsList[0];
    if (coord) {
      return coord.containPoint(point);
    }
  };
  Grid2.prototype._initCartesian = function(gridModel, ecModel, api) {
    var _this = this;
    var grid = this;
    var axisPositionUsed = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };
    var axesMap = {
      x: {},
      y: {}
    };
    var axesCount = {
      x: 0,
      y: 0
    };
    ecModel.eachComponent("xAxis", createAxisCreator("x"), this);
    ecModel.eachComponent("yAxis", createAxisCreator("y"), this);
    if (!axesCount.x || !axesCount.y) {
      this._axesMap = {};
      this._axesList = [];
      return;
    }
    this._axesMap = axesMap;
    each$g(axesMap.x, function(xAxis, xAxisIndex) {
      each$g(axesMap.y, function(yAxis, yAxisIndex) {
        var key = "x" + xAxisIndex + "y" + yAxisIndex;
        var cartesian = new Cartesian2D$1(key);
        cartesian.master = _this;
        cartesian.model = gridModel;
        _this._coordsMap[key] = cartesian;
        _this._coordsList.push(cartesian);
        cartesian.addAxis(xAxis);
        cartesian.addAxis(yAxis);
      });
    });
    function createAxisCreator(dimName) {
      return function(axisModel, idx) {
        if (!isAxisUsedInTheGrid(axisModel, gridModel)) {
          return;
        }
        var axisPosition = axisModel.get("position");
        if (dimName === "x") {
          if (axisPosition !== "top" && axisPosition !== "bottom") {
            axisPosition = axisPositionUsed.bottom ? "top" : "bottom";
          }
        } else {
          if (axisPosition !== "left" && axisPosition !== "right") {
            axisPosition = axisPositionUsed.left ? "right" : "left";
          }
        }
        axisPositionUsed[axisPosition] = true;
        var axis = new Axis2D$1(dimName, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisPosition);
        var isCategory2 = axis.type === "category";
        axis.onBand = isCategory2 && axisModel.get("boundaryGap");
        axis.inverse = axisModel.get("inverse");
        axisModel.axis = axis;
        axis.model = axisModel;
        axis.grid = grid;
        axis.index = idx;
        grid._axesList.push(axis);
        axesMap[dimName][idx] = axis;
        axesCount[dimName]++;
      };
    }
  };
  Grid2.prototype._updateScale = function(ecModel, gridModel) {
    each$g(this._axesList, function(axis) {
      axis.scale.setExtent(Infinity, -Infinity);
      if (axis.type === "category") {
        var categorySortInfo = axis.model.get("categorySortInfo");
        axis.scale.setSortInfo(categorySortInfo);
      }
    });
    ecModel.eachSeries(function(seriesModel) {
      if (isCartesian2DSeries(seriesModel)) {
        var axesModelMap = findAxisModels(seriesModel);
        var xAxisModel = axesModelMap.xAxisModel;
        var yAxisModel = axesModelMap.yAxisModel;
        if (!isAxisUsedInTheGrid(xAxisModel, gridModel) || !isAxisUsedInTheGrid(yAxisModel, gridModel)) {
          return;
        }
        var cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
        var data2 = seriesModel.getData();
        var xAxis = cartesian.getAxis("x");
        var yAxis = cartesian.getAxis("y");
        unionExtent(data2, xAxis);
        unionExtent(data2, yAxis);
      }
    }, this);
    function unionExtent(data2, axis) {
      each$g(getDataDimensionsOnAxis(data2, axis.dim), function(dim) {
        axis.scale.unionExtentFromData(data2, dim);
      });
    }
  };
  Grid2.prototype.getTooltipAxes = function(dim) {
    var baseAxes = [];
    var otherAxes = [];
    each$g(this.getCartesians(), function(cartesian) {
      var baseAxis = dim != null && dim !== "auto" ? cartesian.getAxis(dim) : cartesian.getBaseAxis();
      var otherAxis = cartesian.getOtherAxis(baseAxis);
      indexOf(baseAxes, baseAxis) < 0 && baseAxes.push(baseAxis);
      indexOf(otherAxes, otherAxis) < 0 && otherAxes.push(otherAxis);
    });
    return {
      baseAxes,
      otherAxes
    };
  };
  Grid2.create = function(ecModel, api) {
    var grids = [];
    ecModel.eachComponent("grid", function(gridModel, idx) {
      var grid = new Grid2(gridModel, ecModel, api);
      grid.name = "grid_" + idx;
      grid.resize(gridModel, api, true);
      gridModel.coordinateSystem = grid;
      grids.push(grid);
    });
    ecModel.eachSeries(function(seriesModel) {
      if (!isCartesian2DSeries(seriesModel)) {
        return;
      }
      var axesModelMap = findAxisModels(seriesModel);
      var xAxisModel = axesModelMap.xAxisModel;
      var yAxisModel = axesModelMap.yAxisModel;
      var gridModel = xAxisModel.getCoordSysModel();
      var grid = gridModel.coordinateSystem;
      seriesModel.coordinateSystem = grid.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    });
    return grids;
  };
  Grid2.dimensions = cartesian2DDimensions;
  return Grid2;
}();
function isAxisUsedInTheGrid(axisModel, gridModel) {
  return axisModel.getCoordSysModel() === gridModel;
}
function fixAxisOnZero(axesMap, otherAxisDim, axis, onZeroRecords) {
  axis.getAxesOnZeroOf = function() {
    return otherAxisOnZeroOf ? [otherAxisOnZeroOf] : [];
  };
  var otherAxes = axesMap[otherAxisDim];
  var otherAxisOnZeroOf;
  var axisModel = axis.model;
  var onZero = axisModel.get(["axisLine", "onZero"]);
  var onZeroAxisIndex = axisModel.get(["axisLine", "onZeroAxisIndex"]);
  if (!onZero) {
    return;
  }
  if (onZeroAxisIndex != null) {
    if (canOnZeroToAxis(otherAxes[onZeroAxisIndex])) {
      otherAxisOnZeroOf = otherAxes[onZeroAxisIndex];
    }
  } else {
    for (var idx in otherAxes) {
      if (otherAxes.hasOwnProperty(idx) && canOnZeroToAxis(otherAxes[idx]) && !onZeroRecords[getOnZeroRecordKey(otherAxes[idx])]) {
        otherAxisOnZeroOf = otherAxes[idx];
        break;
      }
    }
  }
  if (otherAxisOnZeroOf) {
    onZeroRecords[getOnZeroRecordKey(otherAxisOnZeroOf)] = true;
  }
  function getOnZeroRecordKey(axis2) {
    return axis2.dim + "_" + axis2.index;
  }
}
function canOnZeroToAxis(axis) {
  return axis && axis.type !== "category" && axis.type !== "time" && ifAxisCrossZero(axis);
}
function updateAxisTransform(axis, coordBase) {
  var axisExtent = axis.getExtent();
  var axisExtentSum = axisExtent[0] + axisExtent[1];
  axis.toGlobalCoord = axis.dim === "x" ? function(coord) {
    return coord + coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
  axis.toLocalCoord = axis.dim === "x" ? function(coord) {
    return coord - coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
}
var Grid$1 = Grid;
var PI$3 = Math.PI;
var AxisBuilder = function() {
  function AxisBuilder2(axisModel, opt) {
    this.group = new Group$6();
    this.opt = opt;
    this.axisModel = axisModel;
    defaults(opt, {
      labelOffset: 0,
      nameDirection: 1,
      tickDirection: 1,
      labelDirection: 1,
      silent: true,
      handleAutoShown: function() {
        return true;
      }
    });
    var transformGroup = new Group$6({
      x: opt.position[0],
      y: opt.position[1],
      rotation: opt.rotation
    });
    transformGroup.updateTransform();
    this._transformGroup = transformGroup;
  }
  AxisBuilder2.prototype.hasBuilder = function(name2) {
    return !!builders[name2];
  };
  AxisBuilder2.prototype.add = function(name2) {
    builders[name2](this.opt, this.axisModel, this.group, this._transformGroup);
  };
  AxisBuilder2.prototype.getGroup = function() {
    return this.group;
  };
  AxisBuilder2.innerTextLayout = function(axisRotation, textRotation, direction) {
    var rotationDiff = remRadian(textRotation - axisRotation);
    var textAlign;
    var textVerticalAlign;
    if (isRadianAroundZero(rotationDiff)) {
      textVerticalAlign = direction > 0 ? "top" : "bottom";
      textAlign = "center";
    } else if (isRadianAroundZero(rotationDiff - PI$3)) {
      textVerticalAlign = direction > 0 ? "bottom" : "top";
      textAlign = "center";
    } else {
      textVerticalAlign = "middle";
      if (rotationDiff > 0 && rotationDiff < PI$3) {
        textAlign = direction > 0 ? "right" : "left";
      } else {
        textAlign = direction > 0 ? "left" : "right";
      }
    }
    return {
      rotation: rotationDiff,
      textAlign,
      textVerticalAlign
    };
  };
  AxisBuilder2.makeAxisEventDataBase = function(axisModel) {
    var eventData = {
      componentType: axisModel.mainType,
      componentIndex: axisModel.componentIndex
    };
    eventData[axisModel.mainType + "Index"] = axisModel.componentIndex;
    return eventData;
  };
  AxisBuilder2.isLabelSilent = function(axisModel) {
    var tooltipOpt = axisModel.get("tooltip");
    return axisModel.get("silent") || !(axisModel.get("triggerEvent") || tooltipOpt && tooltipOpt.show);
  };
  return AxisBuilder2;
}();
var builders = {
  axisLine: function(opt, axisModel, group, transformGroup) {
    var shown = axisModel.get(["axisLine", "show"]);
    if (shown === "auto" && opt.handleAutoShown) {
      shown = opt.handleAutoShown("axisLine");
    }
    if (!shown) {
      return;
    }
    var extent3 = axisModel.axis.getExtent();
    var matrix = transformGroup.transform;
    var pt12 = [extent3[0], 0];
    var pt22 = [extent3[1], 0];
    if (matrix) {
      applyTransform$1(pt12, pt12, matrix);
      applyTransform$1(pt22, pt22, matrix);
    }
    var lineStyle = extend({
      lineCap: "round"
    }, axisModel.getModel(["axisLine", "lineStyle"]).getLineStyle());
    var line = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: lineStyle,
      strokeContainThreshold: opt.strokeContainThreshold || 5,
      silent: true,
      z2: 1
    });
    line.anid = "line";
    group.add(line);
    var arrows = axisModel.get(["axisLine", "symbol"]);
    if (arrows != null) {
      var arrowSize = axisModel.get(["axisLine", "symbolSize"]);
      if (isString$1(arrows)) {
        arrows = [arrows, arrows];
      }
      if (isString$1(arrowSize) || isNumber(arrowSize)) {
        arrowSize = [arrowSize, arrowSize];
      }
      var arrowOffset = normalizeSymbolOffset(axisModel.get(["axisLine", "symbolOffset"]) || 0, arrowSize);
      var symbolWidth_1 = arrowSize[0];
      var symbolHeight_1 = arrowSize[1];
      each$g([{
        rotate: opt.rotation + Math.PI / 2,
        offset: arrowOffset[0],
        r: 0
      }, {
        rotate: opt.rotation - Math.PI / 2,
        offset: arrowOffset[1],
        r: Math.sqrt((pt12[0] - pt22[0]) * (pt12[0] - pt22[0]) + (pt12[1] - pt22[1]) * (pt12[1] - pt22[1]))
      }], function(point, index2) {
        if (arrows[index2] !== "none" && arrows[index2] != null) {
          var symbol = createSymbol$1(arrows[index2], -symbolWidth_1 / 2, -symbolHeight_1 / 2, symbolWidth_1, symbolHeight_1, lineStyle.stroke, true);
          var r2 = point.r + point.offset;
          symbol.attr({
            rotation: point.rotate,
            x: pt12[0] + r2 * Math.cos(opt.rotation),
            y: pt12[1] - r2 * Math.sin(opt.rotation),
            silent: true,
            z2: 11
          });
          group.add(symbol);
        }
      });
    }
  },
  axisTickLabel: function(opt, axisModel, group, transformGroup) {
    var ticksEls = buildAxisMajorTicks(group, transformGroup, axisModel, opt);
    var labelEls = buildAxisLabel(group, transformGroup, axisModel, opt);
    fixMinMaxLabelShow(axisModel, labelEls, ticksEls);
    buildAxisMinorTicks(group, transformGroup, axisModel, opt.tickDirection);
    if (axisModel.get(["axisLabel", "hideOverlap"])) {
      var labelList = prepareLayoutList(map$1(labelEls, function(label) {
        return {
          label,
          priority: label.z2,
          defaultAttr: {
            ignore: label.ignore
          }
        };
      }));
      hideOverlap(labelList);
    }
  },
  axisName: function(opt, axisModel, group, transformGroup) {
    var name2 = retrieve(opt.axisName, axisModel.get("name"));
    if (!name2) {
      return;
    }
    var nameLocation = axisModel.get("nameLocation");
    var nameDirection = opt.nameDirection;
    var textStyleModel = axisModel.getModel("nameTextStyle");
    var gap = axisModel.get("nameGap") || 0;
    var extent3 = axisModel.axis.getExtent();
    var gapSignal = extent3[0] > extent3[1] ? -1 : 1;
    var pos = [
      nameLocation === "start" ? extent3[0] - gapSignal * gap : nameLocation === "end" ? extent3[1] + gapSignal * gap : (extent3[0] + extent3[1]) / 2,
      isNameLocationCenter(nameLocation) ? opt.labelOffset + nameDirection * gap : 0
    ];
    var labelLayout2;
    var nameRotation = axisModel.get("nameRotate");
    if (nameRotation != null) {
      nameRotation = nameRotation * PI$3 / 180;
    }
    var axisNameAvailableWidth;
    if (isNameLocationCenter(nameLocation)) {
      labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, nameRotation != null ? nameRotation : opt.rotation, nameDirection);
    } else {
      labelLayout2 = endTextLayout(opt.rotation, nameLocation, nameRotation || 0, extent3);
      axisNameAvailableWidth = opt.axisNameAvailableWidth;
      if (axisNameAvailableWidth != null) {
        axisNameAvailableWidth = Math.abs(axisNameAvailableWidth / Math.sin(labelLayout2.rotation));
        !isFinite(axisNameAvailableWidth) && (axisNameAvailableWidth = null);
      }
    }
    var textFont = textStyleModel.getFont();
    var truncateOpt = axisModel.get("nameTruncate", true) || {};
    var ellipsis = truncateOpt.ellipsis;
    var maxWidth = retrieve(opt.nameTruncateMaxWidth, truncateOpt.maxWidth, axisNameAvailableWidth);
    var textEl = new ZRText$1({
      x: pos[0],
      y: pos[1],
      rotation: labelLayout2.rotation,
      silent: AxisBuilder.isLabelSilent(axisModel),
      style: createTextStyle(textStyleModel, {
        text: name2,
        font: textFont,
        overflow: "truncate",
        width: maxWidth,
        ellipsis,
        fill: textStyleModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]),
        align: textStyleModel.get("align") || labelLayout2.textAlign,
        verticalAlign: textStyleModel.get("verticalAlign") || labelLayout2.textVerticalAlign
      }),
      z2: 1
    });
    setTooltipConfig({
      el: textEl,
      componentModel: axisModel,
      itemName: name2
    });
    textEl.__fullText = name2;
    textEl.anid = "name";
    if (axisModel.get("triggerEvent")) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisName";
      eventData.name = name2;
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    group.add(textEl);
    textEl.decomposeTransform();
  }
};
function endTextLayout(rotation, textPosition, textRotate, extent3) {
  var rotationDiff = remRadian(textRotate - rotation);
  var textAlign;
  var textVerticalAlign;
  var inverse = extent3[0] > extent3[1];
  var onLeft = textPosition === "start" && !inverse || textPosition !== "start" && inverse;
  if (isRadianAroundZero(rotationDiff - PI$3 / 2)) {
    textVerticalAlign = onLeft ? "bottom" : "top";
    textAlign = "center";
  } else if (isRadianAroundZero(rotationDiff - PI$3 * 1.5)) {
    textVerticalAlign = onLeft ? "top" : "bottom";
    textAlign = "center";
  } else {
    textVerticalAlign = "middle";
    if (rotationDiff < PI$3 * 1.5 && rotationDiff > PI$3 / 2) {
      textAlign = onLeft ? "left" : "right";
    } else {
      textAlign = onLeft ? "right" : "left";
    }
  }
  return {
    rotation: rotationDiff,
    textAlign,
    textVerticalAlign
  };
}
function fixMinMaxLabelShow(axisModel, labelEls, tickEls) {
  if (shouldShowAllLabels(axisModel.axis)) {
    return;
  }
  var showMinLabel = axisModel.get(["axisLabel", "showMinLabel"]);
  var showMaxLabel = axisModel.get(["axisLabel", "showMaxLabel"]);
  labelEls = labelEls || [];
  tickEls = tickEls || [];
  var firstLabel = labelEls[0];
  var nextLabel = labelEls[1];
  var lastLabel = labelEls[labelEls.length - 1];
  var prevLabel = labelEls[labelEls.length - 2];
  var firstTick = tickEls[0];
  var nextTick = tickEls[1];
  var lastTick = tickEls[tickEls.length - 1];
  var prevTick = tickEls[tickEls.length - 2];
  if (showMinLabel === false) {
    ignoreEl(firstLabel);
    ignoreEl(firstTick);
  } else if (isTwoLabelOverlapped(firstLabel, nextLabel)) {
    if (showMinLabel) {
      ignoreEl(nextLabel);
      ignoreEl(nextTick);
    } else {
      ignoreEl(firstLabel);
      ignoreEl(firstTick);
    }
  }
  if (showMaxLabel === false) {
    ignoreEl(lastLabel);
    ignoreEl(lastTick);
  } else if (isTwoLabelOverlapped(prevLabel, lastLabel)) {
    if (showMaxLabel) {
      ignoreEl(prevLabel);
      ignoreEl(prevTick);
    } else {
      ignoreEl(lastLabel);
      ignoreEl(lastTick);
    }
  }
}
function ignoreEl(el) {
  el && (el.ignore = true);
}
function isTwoLabelOverlapped(current2, next) {
  var firstRect = current2 && current2.getBoundingRect().clone();
  var nextRect = next && next.getBoundingRect().clone();
  if (!firstRect || !nextRect) {
    return;
  }
  var mRotationBack = identity([]);
  rotate(mRotationBack, mRotationBack, -current2.rotation);
  firstRect.applyTransform(mul([], mRotationBack, current2.getLocalTransform()));
  nextRect.applyTransform(mul([], mRotationBack, next.getLocalTransform()));
  return firstRect.intersect(nextRect);
}
function isNameLocationCenter(nameLocation) {
  return nameLocation === "middle" || nameLocation === "center";
}
function createTicks(ticksCoords, tickTransform, tickEndCoord, tickLineStyle, anidPrefix) {
  var tickEls = [];
  var pt12 = [];
  var pt22 = [];
  for (var i = 0; i < ticksCoords.length; i++) {
    var tickCoord = ticksCoords[i].coord;
    pt12[0] = tickCoord;
    pt12[1] = 0;
    pt22[0] = tickCoord;
    pt22[1] = tickEndCoord;
    if (tickTransform) {
      applyTransform$1(pt12, pt12, tickTransform);
      applyTransform$1(pt22, pt22, tickTransform);
    }
    var tickEl = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: tickLineStyle,
      z2: 2,
      autoBatch: true,
      silent: true
    });
    tickEl.anid = anidPrefix + "_" + ticksCoords[i].tickValue;
    tickEls.push(tickEl);
  }
  return tickEls;
}
function buildAxisMajorTicks(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var tickModel = axisModel.getModel("axisTick");
  var shown = tickModel.get("show");
  if (shown === "auto" && opt.handleAutoShown) {
    shown = opt.handleAutoShown("axisTick");
  }
  if (!shown || axis.scale.isBlank()) {
    return;
  }
  var lineStyleModel = tickModel.getModel("lineStyle");
  var tickEndCoord = opt.tickDirection * tickModel.get("length");
  var ticksCoords = axis.getTicksCoords();
  var ticksEls = createTicks(ticksCoords, transformGroup.transform, tickEndCoord, defaults(lineStyleModel.getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }), "ticks");
  for (var i = 0; i < ticksEls.length; i++) {
    group.add(ticksEls[i]);
  }
  return ticksEls;
}
function buildAxisMinorTicks(group, transformGroup, axisModel, tickDirection) {
  var axis = axisModel.axis;
  var minorTickModel = axisModel.getModel("minorTick");
  if (!minorTickModel.get("show") || axis.scale.isBlank()) {
    return;
  }
  var minorTicksCoords = axis.getMinorTicksCoords();
  if (!minorTicksCoords.length) {
    return;
  }
  var lineStyleModel = minorTickModel.getModel("lineStyle");
  var tickEndCoord = tickDirection * minorTickModel.get("length");
  var minorTickLineStyle = defaults(lineStyleModel.getLineStyle(), defaults(axisModel.getModel("axisTick").getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }));
  for (var i = 0; i < minorTicksCoords.length; i++) {
    var minorTicksEls = createTicks(minorTicksCoords[i], transformGroup.transform, tickEndCoord, minorTickLineStyle, "minorticks_" + i);
    for (var k2 = 0; k2 < minorTicksEls.length; k2++) {
      group.add(minorTicksEls[k2]);
    }
  }
}
function buildAxisLabel(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var show = retrieve(opt.axisLabelShow, axisModel.get(["axisLabel", "show"]));
  if (!show || axis.scale.isBlank()) {
    return;
  }
  var labelModel = axisModel.getModel("axisLabel");
  var labelMargin = labelModel.get("margin");
  var labels = axis.getViewLabels();
  var labelRotation = (retrieve(opt.labelRotate, labelModel.get("rotate")) || 0) * PI$3 / 180;
  var labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, labelRotation, opt.labelDirection);
  var rawCategoryData = axisModel.getCategories && axisModel.getCategories(true);
  var labelEls = [];
  var silent = AxisBuilder.isLabelSilent(axisModel);
  var triggerEvent = axisModel.get("triggerEvent");
  each$g(labels, function(labelItem, index2) {
    var tickValue = axis.scale.type === "ordinal" ? axis.scale.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
    var formattedLabel = labelItem.formattedLabel;
    var rawLabel = labelItem.rawLabel;
    var itemLabelModel = labelModel;
    if (rawCategoryData && rawCategoryData[tickValue]) {
      var rawCategoryItem = rawCategoryData[tickValue];
      if (isObject$6(rawCategoryItem) && rawCategoryItem.textStyle) {
        itemLabelModel = new Model$1(rawCategoryItem.textStyle, labelModel, axisModel.ecModel);
      }
    }
    var textColor = itemLabelModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]);
    var tickCoord = axis.dataToCoord(tickValue);
    var textEl = new ZRText$1({
      x: tickCoord,
      y: opt.labelOffset + opt.labelDirection * labelMargin,
      rotation: labelLayout2.rotation,
      silent,
      z2: 10 + (labelItem.level || 0),
      style: createTextStyle(itemLabelModel, {
        text: formattedLabel,
        align: itemLabelModel.getShallow("align", true) || labelLayout2.textAlign,
        verticalAlign: itemLabelModel.getShallow("verticalAlign", true) || itemLabelModel.getShallow("baseline", true) || labelLayout2.textVerticalAlign,
        fill: isFunction$1(textColor) ? textColor(axis.type === "category" ? rawLabel : axis.type === "value" ? tickValue + "" : tickValue, index2) : textColor
      })
    });
    textEl.anid = "label_" + tickValue;
    if (triggerEvent) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisLabel";
      eventData.value = rawLabel;
      eventData.tickIndex = index2;
      if (axis.type === "category") {
        eventData.dataIndex = tickValue;
      }
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    labelEls.push(textEl);
    group.add(textEl);
    textEl.decomposeTransform();
  });
  return labelEls;
}
var AxisBuilder$1 = AxisBuilder;
function collect(ecModel, api) {
  var result = {
    axesInfo: {},
    seriesInvolved: false,
    coordSysAxesInfo: {},
    coordSysMap: {}
  };
  collectAxesInfo(result, ecModel, api);
  result.seriesInvolved && collectSeriesInfo(result, ecModel);
  return result;
}
function collectAxesInfo(result, ecModel, api) {
  var globalTooltipModel = ecModel.getComponent("tooltip");
  var globalAxisPointerModel = ecModel.getComponent("axisPointer");
  var linksOption = globalAxisPointerModel.get("link", true) || [];
  var linkGroups = [];
  each$g(api.getCoordinateSystems(), function(coordSys) {
    if (!coordSys.axisPointerEnabled) {
      return;
    }
    var coordSysKey = makeKey(coordSys.model);
    var axesInfoInCoordSys = result.coordSysAxesInfo[coordSysKey] = {};
    result.coordSysMap[coordSysKey] = coordSys;
    var coordSysModel = coordSys.model;
    var baseTooltipModel = coordSysModel.getModel("tooltip", globalTooltipModel);
    each$g(coordSys.getAxes(), curry$3(saveTooltipAxisInfo, false, null));
    if (coordSys.getTooltipAxes && globalTooltipModel && baseTooltipModel.get("show")) {
      var triggerAxis = baseTooltipModel.get("trigger") === "axis";
      var cross = baseTooltipModel.get(["axisPointer", "type"]) === "cross";
      var tooltipAxes = coordSys.getTooltipAxes(baseTooltipModel.get(["axisPointer", "axis"]));
      if (triggerAxis || cross) {
        each$g(tooltipAxes.baseAxes, curry$3(saveTooltipAxisInfo, cross ? "cross" : true, triggerAxis));
      }
      if (cross) {
        each$g(tooltipAxes.otherAxes, curry$3(saveTooltipAxisInfo, "cross", false));
      }
    }
    function saveTooltipAxisInfo(fromTooltip, triggerTooltip, axis) {
      var axisPointerModel = axis.model.getModel("axisPointer", globalAxisPointerModel);
      var axisPointerShow = axisPointerModel.get("show");
      if (!axisPointerShow || axisPointerShow === "auto" && !fromTooltip && !isHandleTrigger(axisPointerModel)) {
        return;
      }
      if (triggerTooltip == null) {
        triggerTooltip = axisPointerModel.get("triggerTooltip");
      }
      axisPointerModel = fromTooltip ? makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) : axisPointerModel;
      var snap = axisPointerModel.get("snap");
      var axisKey = makeKey(axis.model);
      var involveSeries = triggerTooltip || snap || axis.type === "category";
      var axisInfo = result.axesInfo[axisKey] = {
        key: axisKey,
        axis,
        coordSys,
        axisPointerModel,
        triggerTooltip,
        involveSeries,
        snap,
        useHandle: isHandleTrigger(axisPointerModel),
        seriesModels: [],
        linkGroup: null
      };
      axesInfoInCoordSys[axisKey] = axisInfo;
      result.seriesInvolved = result.seriesInvolved || involveSeries;
      var groupIndex = getLinkGroupIndex(linksOption, axis);
      if (groupIndex != null) {
        var linkGroup = linkGroups[groupIndex] || (linkGroups[groupIndex] = {
          axesInfo: {}
        });
        linkGroup.axesInfo[axisKey] = axisInfo;
        linkGroup.mapper = linksOption[groupIndex].mapper;
        axisInfo.linkGroup = linkGroup;
      }
    }
  });
}
function makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) {
  var tooltipAxisPointerModel = baseTooltipModel.getModel("axisPointer");
  var fields = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"];
  var volatileOption = {};
  each$g(fields, function(field) {
    volatileOption[field] = clone$4(tooltipAxisPointerModel.get(field));
  });
  volatileOption.snap = axis.type !== "category" && !!triggerTooltip;
  if (tooltipAxisPointerModel.get("type") === "cross") {
    volatileOption.type = "line";
  }
  var labelOption = volatileOption.label || (volatileOption.label = {});
  labelOption.show == null && (labelOption.show = false);
  if (fromTooltip === "cross") {
    var tooltipAxisPointerLabelShow = tooltipAxisPointerModel.get(["label", "show"]);
    labelOption.show = tooltipAxisPointerLabelShow != null ? tooltipAxisPointerLabelShow : true;
    if (!triggerTooltip) {
      var crossStyle = volatileOption.lineStyle = tooltipAxisPointerModel.get("crossStyle");
      crossStyle && defaults(labelOption, crossStyle.textStyle);
    }
  }
  return axis.model.getModel("axisPointer", new Model$1(volatileOption, globalAxisPointerModel, ecModel));
}
function collectSeriesInfo(result, ecModel) {
  ecModel.eachSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesTooltipTrigger = seriesModel.get(["tooltip", "trigger"], true);
    var seriesTooltipShow = seriesModel.get(["tooltip", "show"], true);
    if (!coordSys || seriesTooltipTrigger === "none" || seriesTooltipTrigger === false || seriesTooltipTrigger === "item" || seriesTooltipShow === false || seriesModel.get(["axisPointer", "show"], true) === false) {
      return;
    }
    each$g(result.coordSysAxesInfo[makeKey(coordSys.model)], function(axisInfo) {
      var axis = axisInfo.axis;
      if (coordSys.getAxis(axis.dim) === axis) {
        axisInfo.seriesModels.push(seriesModel);
        axisInfo.seriesDataCount == null && (axisInfo.seriesDataCount = 0);
        axisInfo.seriesDataCount += seriesModel.getData().count();
      }
    });
  });
}
function getLinkGroupIndex(linksOption, axis) {
  var axisModel = axis.model;
  var dim = axis.dim;
  for (var i = 0; i < linksOption.length; i++) {
    var linkOption = linksOption[i] || {};
    if (checkPropInLink(linkOption[dim + "AxisId"], axisModel.id) || checkPropInLink(linkOption[dim + "AxisIndex"], axisModel.componentIndex) || checkPropInLink(linkOption[dim + "AxisName"], axisModel.name)) {
      return i;
    }
  }
}
function checkPropInLink(linkPropValue, axisPropValue) {
  return linkPropValue === "all" || isArray$2(linkPropValue) && indexOf(linkPropValue, axisPropValue) >= 0 || linkPropValue === axisPropValue;
}
function fixValue(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  if (!axisInfo) {
    return;
  }
  var axisPointerModel = axisInfo.axisPointerModel;
  var scale2 = axisInfo.axis.scale;
  var option = axisPointerModel.option;
  var status = axisPointerModel.get("status");
  var value = axisPointerModel.get("value");
  if (value != null) {
    value = scale2.parse(value);
  }
  var useHandle = isHandleTrigger(axisPointerModel);
  if (status == null) {
    option.status = useHandle ? "show" : "hide";
  }
  var extent3 = scale2.getExtent().slice();
  extent3[0] > extent3[1] && extent3.reverse();
  if (value == null || value > extent3[1]) {
    value = extent3[1];
  }
  if (value < extent3[0]) {
    value = extent3[0];
  }
  option.value = value;
  if (useHandle) {
    option.status = axisInfo.axis.scale.isBlank() ? "hide" : "show";
  }
}
function getAxisInfo$1(axisModel) {
  var coordSysAxesInfo = (axisModel.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
  return coordSysAxesInfo && coordSysAxesInfo.axesInfo[makeKey(axisModel)];
}
function getAxisPointerModel(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  return axisInfo && axisInfo.axisPointerModel;
}
function isHandleTrigger(axisPointerModel) {
  return !!axisPointerModel.get(["handle", "show"]);
}
function makeKey(model) {
  return model.type + "||" + model.id;
}
var axisPointerClazz = {};
var AxisView = function(_super) {
  __extends(AxisView2, _super);
  function AxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisView2.type;
    return _this;
  }
  AxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.axisPointerClass && fixValue(axisModel);
    _super.prototype.render.apply(this, arguments);
    this._doUpdateAxisPointerClass(axisModel, api, true);
  };
  AxisView2.prototype.updateAxisPointer = function(axisModel, ecModel, api, payload) {
    this._doUpdateAxisPointerClass(axisModel, api, false);
  };
  AxisView2.prototype.remove = function(ecModel, api) {
    var axisPointer = this._axisPointer;
    axisPointer && axisPointer.remove(api);
  };
  AxisView2.prototype.dispose = function(ecModel, api) {
    this._disposeAxisPointer(api);
    _super.prototype.dispose.apply(this, arguments);
  };
  AxisView2.prototype._doUpdateAxisPointerClass = function(axisModel, api, forceRender) {
    var Clazz = AxisView2.getAxisPointerClass(this.axisPointerClass);
    if (!Clazz) {
      return;
    }
    var axisPointerModel = getAxisPointerModel(axisModel);
    axisPointerModel ? (this._axisPointer || (this._axisPointer = new Clazz())).render(axisModel, axisPointerModel, api, forceRender) : this._disposeAxisPointer(api);
  };
  AxisView2.prototype._disposeAxisPointer = function(api) {
    this._axisPointer && this._axisPointer.dispose(api);
    this._axisPointer = null;
  };
  AxisView2.registerAxisPointerClass = function(type4, clazz) {
    axisPointerClazz[type4] = clazz;
  };
  AxisView2.getAxisPointerClass = function(type4) {
    return type4 && axisPointerClazz[type4];
  };
  AxisView2.type = "axis";
  return AxisView2;
}(ComponentView$1);
var AxisView$1 = AxisView;
var inner$f = makeInner();
function rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel) {
  var axis = axisModel.axis;
  if (axis.scale.isBlank()) {
    return;
  }
  var splitAreaModel = axisModel.getModel("splitArea");
  var areaStyleModel = splitAreaModel.getModel("areaStyle");
  var areaColors = areaStyleModel.get("color");
  var gridRect = gridModel.coordinateSystem.getRect();
  var ticksCoords = axis.getTicksCoords({
    tickModel: splitAreaModel,
    clamp: true
  });
  if (!ticksCoords.length) {
    return;
  }
  var areaColorsLen = areaColors.length;
  var lastSplitAreaColors = inner$f(axisView).splitAreaColors;
  var newSplitAreaColors = createHashMap();
  var colorIndex = 0;
  if (lastSplitAreaColors) {
    for (var i = 0; i < ticksCoords.length; i++) {
      var cIndex = lastSplitAreaColors.get(ticksCoords[i].tickValue);
      if (cIndex != null) {
        colorIndex = (cIndex + (areaColorsLen - 1) * i) % areaColorsLen;
        break;
      }
    }
  }
  var prev = axis.toGlobalCoord(ticksCoords[0].coord);
  var areaStyle = areaStyleModel.getAreaStyle();
  areaColors = isArray$2(areaColors) ? areaColors : [areaColors];
  for (var i = 1; i < ticksCoords.length; i++) {
    var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
    var x2 = void 0;
    var y2 = void 0;
    var width = void 0;
    var height = void 0;
    if (axis.isHorizontal()) {
      x2 = prev;
      y2 = gridRect.y;
      width = tickCoord - x2;
      height = gridRect.height;
      prev = x2 + width;
    } else {
      x2 = gridRect.x;
      y2 = prev;
      width = gridRect.width;
      height = tickCoord - y2;
      prev = y2 + height;
    }
    var tickValue = ticksCoords[i - 1].tickValue;
    tickValue != null && newSplitAreaColors.set(tickValue, colorIndex);
    axisGroup.add(new Rect$3({
      anid: tickValue != null ? "area_" + tickValue : null,
      shape: {
        x: x2,
        y: y2,
        width,
        height
      },
      style: defaults({
        fill: areaColors[colorIndex]
      }, areaStyle),
      autoBatch: true,
      silent: true
    }));
    colorIndex = (colorIndex + 1) % areaColorsLen;
  }
  inner$f(axisView).splitAreaColors = newSplitAreaColors;
}
function rectCoordAxisHandleRemove(axisView) {
  inner$f(axisView).splitAreaColors = null;
}
var axisBuilderAttrs$3 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$2 = ["splitArea", "splitLine", "minorSplitLine"];
var CartesianAxisView = function(_super) {
  __extends(CartesianAxisView2, _super);
  function CartesianAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianAxisView2.type;
    _this.axisPointerClass = "CartesianAxisPointer";
    return _this;
  }
  CartesianAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var gridModel = axisModel.getCoordSysModel();
    var layout2 = layout$2(gridModel, axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, extend({
      handleAutoShown: function(elementType) {
        var cartesians = gridModel.coordinateSystem.getCartesians();
        for (var i = 0; i < cartesians.length; i++) {
          if (isIntervalOrLogScale(cartesians[i].getOtherAxis(axisModel.axis).scale)) {
            return true;
          }
        }
        return false;
      }
    }, layout2));
    each$g(axisBuilderAttrs$3, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    each$g(selfBuilderAttrs$2, function(name2) {
      if (axisModel.get([name2, "show"])) {
        axisElementBuilders$2[name2](this, this._axisGroup, axisModel, gridModel);
      }
    }, this);
    var isInitialSortFromBarRacing = payload && payload.type === "changeAxisOrder" && payload.isInitSort;
    if (!isInitialSortFromBarRacing) {
      groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    }
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  CartesianAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  CartesianAxisView2.type = "cartesianAxis";
  return CartesianAxisView2;
}(AxisView$1);
var axisElementBuilders$2 = {
  splitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = isArray$2(lineColors) ? lineColors : [lineColors];
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < ticksCoords.length; i++) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      var tickValue = ticksCoords[i].tickValue;
      axisGroup.add(new Line$3({
        anid: tickValue != null ? "line_" + ticksCoords[i].tickValue : null,
        subPixelOptimize: true,
        autoBatch: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        style: defaults({
          stroke: lineColors[colorIndex]
        }, lineStyle),
        silent: true
      }));
    }
  },
  minorSplitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    var minorSplitLineModel = axisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var minorTicksCoords = axis.getMinorTicksCoords();
    if (!minorTicksCoords.length) {
      return;
    }
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        var tickCoord = axis.toGlobalCoord(minorTicksCoords[i][k2].coord);
        if (isHorizontal) {
          p1[0] = tickCoord;
          p1[1] = gridRect.y;
          p2[0] = tickCoord;
          p2[1] = gridRect.y + gridRect.height;
        } else {
          p1[0] = gridRect.x;
          p1[1] = tickCoord;
          p2[0] = gridRect.x + gridRect.width;
          p2[1] = tickCoord;
        }
        axisGroup.add(new Line$3({
          anid: "minor_line_" + minorTicksCoords[i][k2].tickValue,
          subPixelOptimize: true,
          autoBatch: true,
          shape: {
            x1: p1[0],
            y1: p1[1],
            x2: p2[0],
            y2: p2[1]
          },
          style: lineStyle,
          silent: true
        }));
      }
    }
  },
  splitArea: function(axisView, axisGroup, axisModel, gridModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel);
  }
};
var CartesianXAxisView = function(_super) {
  __extends(CartesianXAxisView2, _super);
  function CartesianXAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView2.type;
    return _this;
  }
  CartesianXAxisView2.type = "xAxis";
  return CartesianXAxisView2;
}(CartesianAxisView);
var CartesianYAxisView = function(_super) {
  __extends(CartesianYAxisView2, _super);
  function CartesianYAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView.type;
    return _this;
  }
  CartesianYAxisView2.type = "yAxis";
  return CartesianYAxisView2;
}(CartesianAxisView);
var GridView = function(_super) {
  __extends(GridView2, _super);
  function GridView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "grid";
    return _this;
  }
  GridView2.prototype.render = function(gridModel, ecModel) {
    this.group.removeAll();
    if (gridModel.get("show")) {
      this.group.add(new Rect$3({
        shape: gridModel.coordinateSystem.getRect(),
        style: defaults({
          fill: gridModel.get("backgroundColor")
        }, gridModel.getItemStyle()),
        silent: true,
        z2: -1
      }));
    }
  };
  GridView2.type = "grid";
  return GridView2;
}(ComponentView$1);
var extraOption = {
  offset: 0
};
function install$N(registers) {
  registers.registerComponentView(GridView);
  registers.registerComponentModel(GridModel$1);
  registers.registerCoordinateSystem("cartesian2d", Grid$1);
  axisModelCreator(registers, "x", CartesianAxisModel, extraOption);
  axisModelCreator(registers, "y", CartesianAxisModel, extraOption);
  registers.registerComponentView(CartesianXAxisView);
  registers.registerComponentView(CartesianYAxisView);
  registers.registerPreprocessor(function(option) {
    if (option.xAxis && option.yAxis && !option.grid) {
      option.grid = {};
    }
  });
}
function install$M(registers) {
  use(install$N);
  registers.registerSeriesModel(ScatterSeriesModel$1);
  registers.registerChartView(ScatterView$1);
  registers.registerLayout(pointsLayout("scatter"));
}
function radarLayout(ecModel) {
  ecModel.eachSeriesByType("radar", function(seriesModel) {
    var data2 = seriesModel.getData();
    var points2 = [];
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var axes = coordSys.getIndicatorAxes();
    each$g(axes, function(axis, axisIndex) {
      data2.each(data2.mapDimension(axes[axisIndex].dim), function(val, dataIndex) {
        points2[dataIndex] = points2[dataIndex] || [];
        var point = coordSys.dataToPoint(val, axisIndex);
        points2[dataIndex][axisIndex] = isValidPoint(point) ? point : getValueMissingPoint(coordSys);
      });
    });
    data2.each(function(idx) {
      var firstPoint = find(points2[idx], function(point) {
        return isValidPoint(point);
      }) || getValueMissingPoint(coordSys);
      points2[idx].push(firstPoint.slice());
      data2.setItemLayout(idx, points2[idx]);
    });
  });
}
function isValidPoint(point) {
  return !isNaN(point[0]) && !isNaN(point[1]);
}
function getValueMissingPoint(coordSys) {
  return [coordSys.cx, coordSys.cy];
}
function radarBackwardCompat(option) {
  var polarOptArr = option.polar;
  if (polarOptArr) {
    if (!isArray$2(polarOptArr)) {
      polarOptArr = [polarOptArr];
    }
    var polarNotRadar_1 = [];
    each$g(polarOptArr, function(polarOpt, idx) {
      if (polarOpt.indicator) {
        if (polarOpt.type && !polarOpt.shape) {
          polarOpt.shape = polarOpt.type;
        }
        option.radar = option.radar || [];
        if (!isArray$2(option.radar)) {
          option.radar = [option.radar];
        }
        option.radar.push(polarOpt);
      } else {
        polarNotRadar_1.push(polarOpt);
      }
    });
    option.polar = polarNotRadar_1;
  }
  each$g(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "radar" && seriesOpt.polarIndex) {
      seriesOpt.radarIndex = seriesOpt.polarIndex;
    }
  });
}
var RadarView$2 = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(seriesModel, ecModel, api) {
    var polar = seriesModel.coordinateSystem;
    var group = this.group;
    var data2 = seriesModel.getData();
    var oldData = this._data;
    function createSymbol2(data3, idx) {
      var symbolType = data3.getItemVisual(idx, "symbol") || "circle";
      if (symbolType === "none") {
        return;
      }
      var symbolSize = normalizeSymbolSize(data3.getItemVisual(idx, "symbolSize"));
      var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2);
      var symbolRotate = data3.getItemVisual(idx, "symbolRotate") || 0;
      symbolPath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 100,
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2,
        rotation: symbolRotate * Math.PI / 180 || 0
      });
      return symbolPath;
    }
    function updateSymbols(oldPoints, newPoints, symbolGroup, data3, idx, isInit) {
      symbolGroup.removeAll();
      for (var i = 0; i < newPoints.length - 1; i++) {
        var symbolPath = createSymbol2(data3, idx);
        if (symbolPath) {
          symbolPath.__dimIdx = i;
          if (oldPoints[i]) {
            symbolPath.setPosition(oldPoints[i]);
            graphic[isInit ? "initProps" : "updateProps"](symbolPath, {
              x: newPoints[i][0],
              y: newPoints[i][1]
            }, seriesModel, idx);
          } else {
            symbolPath.setPosition(newPoints[i]);
          }
          symbolGroup.add(symbolPath);
        }
      }
    }
    function getInitialPoints(points2) {
      return map$1(points2, function(pt) {
        return [polar.cx, polar.cy];
      });
    }
    data2.diff(oldData).add(function(idx) {
      var points2 = data2.getItemLayout(idx);
      if (!points2) {
        return;
      }
      var polygon = new Polygon$1();
      var polyline = new Polyline$3();
      var target = {
        shape: {
          points: points2
        }
      };
      polygon.shape.points = getInitialPoints(points2);
      polyline.shape.points = getInitialPoints(points2);
      initProps(polygon, target, seriesModel, idx);
      initProps(polyline, target, seriesModel, idx);
      var itemGroup = new Group$6();
      var symbolGroup = new Group$6();
      itemGroup.add(polyline);
      itemGroup.add(polygon);
      itemGroup.add(symbolGroup);
      updateSymbols(polyline.shape.points, points2, symbolGroup, data2, idx, true);
      data2.setItemGraphicEl(idx, itemGroup);
    }).update(function(newIdx, oldIdx) {
      var itemGroup = oldData.getItemGraphicEl(oldIdx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var target = {
        shape: {
          points: data2.getItemLayout(newIdx)
        }
      };
      if (!target.shape.points) {
        return;
      }
      updateSymbols(polyline.shape.points, target.shape.points, symbolGroup, data2, newIdx, false);
      saveOldStyle(polygon);
      saveOldStyle(polyline);
      updateProps$1(polyline, target, seriesModel);
      updateProps$1(polygon, target, seriesModel);
      data2.setItemGraphicEl(newIdx, itemGroup);
    }).remove(function(idx) {
      group.remove(oldData.getItemGraphicEl(idx));
    }).execute();
    data2.eachItemGraphicEl(function(itemGroup, idx) {
      var itemModel = data2.getItemModel(idx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var itemStyle = data2.getItemVisual(idx, "style");
      var color = itemStyle.fill;
      group.add(itemGroup);
      polyline.useStyle(defaults(itemModel.getModel("lineStyle").getLineStyle(), {
        fill: "none",
        stroke: color
      }));
      setStatesStylesFromModel(polyline, itemModel, "lineStyle");
      setStatesStylesFromModel(polygon, itemModel, "areaStyle");
      var areaStyleModel = itemModel.getModel("areaStyle");
      var polygonIgnore = areaStyleModel.isEmpty() && areaStyleModel.parentModel.isEmpty();
      polygon.ignore = polygonIgnore;
      each$g(["emphasis", "select", "blur"], function(stateName) {
        var stateModel = itemModel.getModel([stateName, "areaStyle"]);
        var stateIgnore = stateModel.isEmpty() && stateModel.parentModel.isEmpty();
        polygon.ensureState(stateName).ignore = stateIgnore && polygonIgnore;
      });
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: color,
        opacity: 0.7,
        decal: itemStyle.decal
      }));
      var emphasisModel = itemModel.getModel("emphasis");
      var itemHoverStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      symbolGroup.eachChild(function(symbolPath) {
        if (symbolPath instanceof ZRImage$1) {
          var pathStyle = symbolPath.style;
          symbolPath.useStyle(extend({
            image: pathStyle.image,
            x: pathStyle.x,
            y: pathStyle.y,
            width: pathStyle.width,
            height: pathStyle.height
          }, itemStyle));
        } else {
          symbolPath.useStyle(itemStyle);
          symbolPath.setColor(color);
          symbolPath.style.strokeNoScale = true;
        }
        var pathEmphasisState = symbolPath.ensureState("emphasis");
        pathEmphasisState.style = clone$4(itemHoverStyle);
        var defaultText = data2.getStore().get(data2.getDimensionIndex(symbolPath.__dimIdx), idx);
        (defaultText == null || isNaN(defaultText)) && (defaultText = "");
        setLabelStyle(symbolPath, getLabelStatesModels(itemModel), {
          labelFetcher: data2.hostModel,
          labelDataIndex: idx,
          labelDimIndex: symbolPath.__dimIdx,
          defaultText,
          inheritColor: color,
          defaultOpacity: itemStyle.opacity
        });
      });
      toggleHoverEmphasis(itemGroup, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    this._data = data2;
  };
  RadarView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ChartView$1);
var RadarView$3 = RadarView$2;
var RadarSeriesModel = function(_super) {
  __extends(RadarSeriesModel2, _super);
  function RadarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  RadarSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  RadarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      generateCoord: "indicator_",
      generateCoordCount: Infinity
    });
  };
  RadarSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var coordSys = this.coordinateSystem;
    var indicatorAxes = coordSys.getIndicatorAxes();
    var name2 = this.getData().getName(dataIndex);
    var nameToDisplay = name2 === "" ? this.name : name2;
    var markerColor = retrieveVisualColorForTooltipMarker(this, dataIndex);
    return createTooltipMarkup("section", {
      header: nameToDisplay,
      sortBlocks: true,
      blocks: map$1(indicatorAxes, function(axis) {
        var val = data2.get(data2.mapDimension(axis.dim), dataIndex);
        return createTooltipMarkup("nameValue", {
          markerType: "subItem",
          markerColor,
          name: axis.name,
          value: val,
          sortParam: val
        });
      })
    });
  };
  RadarSeriesModel2.prototype.getTooltipPosition = function(dataIndex) {
    if (dataIndex != null) {
      var data_1 = this.getData();
      var coordSys = this.coordinateSystem;
      var values = data_1.getValues(map$1(coordSys.dimensions, function(dim) {
        return data_1.mapDimension(dim);
      }), dataIndex);
      for (var i = 0, len2 = values.length; i < len2; i++) {
        if (!isNaN(values[i])) {
          var indicatorAxes = coordSys.getIndicatorAxes();
          return coordSys.coordToPoint(indicatorAxes[i].dataToCoord(values[i]), i);
        }
      }
    }
  };
  RadarSeriesModel2.type = "series.radar";
  RadarSeriesModel2.dependencies = ["radar"];
  RadarSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "radar",
    legendHoverLink: true,
    radarIndex: 0,
    lineStyle: {
      width: 2,
      type: "solid",
      join: "round"
    },
    label: {
      position: "top"
    },
    symbolSize: 8
  };
  return RadarSeriesModel2;
}(SeriesModel$1);
var RadarSeriesModel$1 = RadarSeriesModel;
var valueAxisDefault = axisDefault.value;
function defaultsShow(opt, show) {
  return defaults({
    show
  }, opt);
}
var RadarModel = function(_super) {
  __extends(RadarModel2, _super);
  function RadarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarModel2.type;
    return _this;
  }
  RadarModel2.prototype.optionUpdated = function() {
    var boundaryGap = this.get("boundaryGap");
    var splitNumber = this.get("splitNumber");
    var scale2 = this.get("scale");
    var axisLine = this.get("axisLine");
    var axisTick = this.get("axisTick");
    var axisLabel = this.get("axisLabel");
    var nameTextStyle = this.get("axisName");
    var showName = this.get(["axisName", "show"]);
    var nameFormatter = this.get(["axisName", "formatter"]);
    var nameGap = this.get("axisNameGap");
    var triggerEvent = this.get("triggerEvent");
    var indicatorModels = map$1(this.get("indicator") || [], function(indicatorOpt) {
      if (indicatorOpt.max != null && indicatorOpt.max > 0 && !indicatorOpt.min) {
        indicatorOpt.min = 0;
      } else if (indicatorOpt.min != null && indicatorOpt.min < 0 && !indicatorOpt.max) {
        indicatorOpt.max = 0;
      }
      var iNameTextStyle = nameTextStyle;
      if (indicatorOpt.color != null) {
        iNameTextStyle = defaults({
          color: indicatorOpt.color
        }, nameTextStyle);
      }
      var innerIndicatorOpt = merge$1(clone$4(indicatorOpt), {
        boundaryGap,
        splitNumber,
        scale: scale2,
        axisLine,
        axisTick,
        axisLabel,
        name: indicatorOpt.text,
        showName,
        nameLocation: "end",
        nameGap,
        nameTextStyle: iNameTextStyle,
        triggerEvent
      }, false);
      if (!showName) {
        innerIndicatorOpt.name = "";
      }
      if (isString$1(nameFormatter)) {
        var indName = innerIndicatorOpt.name;
        innerIndicatorOpt.name = nameFormatter.replace("{value}", indName != null ? indName : "");
      } else if (isFunction$1(nameFormatter)) {
        innerIndicatorOpt.name = nameFormatter(innerIndicatorOpt.name, innerIndicatorOpt);
      }
      var model = new Model$1(innerIndicatorOpt, null, this.ecModel);
      mixin(model, AxisModelCommonMixin.prototype);
      model.mainType = "radar";
      model.componentIndex = this.componentIndex;
      return model;
    }, this);
    this._indicatorModels = indicatorModels;
  };
  RadarModel2.prototype.getIndicatorModels = function() {
    return this._indicatorModels;
  };
  RadarModel2.type = "radar";
  RadarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "75%",
    startAngle: 90,
    axisName: {
      show: true
    },
    boundaryGap: [0, 0],
    splitNumber: 5,
    axisNameGap: 15,
    scale: false,
    shape: "polygon",
    axisLine: merge$1({
      lineStyle: {
        color: "#bbb"
      }
    }, valueAxisDefault.axisLine),
    axisLabel: defaultsShow(valueAxisDefault.axisLabel, false),
    axisTick: defaultsShow(valueAxisDefault.axisTick, false),
    splitLine: defaultsShow(valueAxisDefault.splitLine, true),
    splitArea: defaultsShow(valueAxisDefault.splitArea, true),
    indicator: []
  };
  return RadarModel2;
}(ComponentModel$1);
var RadarModel$1 = RadarModel;
var axisBuilderAttrs$2 = ["axisLine", "axisTickLabel", "axisName"];
var RadarView = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(radarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    this._buildAxes(radarModel);
    this._buildSplitLineAndArea(radarModel);
  };
  RadarView2.prototype._buildAxes = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    var axisBuilders = map$1(indicatorAxes, function(indicatorAxis) {
      var axisName = indicatorAxis.model.get("showName") ? indicatorAxis.name : "";
      var axisBuilder = new AxisBuilder$1(indicatorAxis.model, {
        axisName,
        position: [radar.cx, radar.cy],
        rotation: indicatorAxis.angle,
        labelDirection: -1,
        tickDirection: -1,
        nameDirection: 1
      });
      return axisBuilder;
    });
    each$g(axisBuilders, function(axisBuilder) {
      each$g(axisBuilderAttrs$2, axisBuilder.add, axisBuilder);
      this.group.add(axisBuilder.getGroup());
    }, this);
  };
  RadarView2.prototype._buildSplitLineAndArea = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    if (!indicatorAxes.length) {
      return;
    }
    var shape = radarModel.get("shape");
    var splitLineModel = radarModel.getModel("splitLine");
    var splitAreaModel = radarModel.getModel("splitArea");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var showSplitLine = splitLineModel.get("show");
    var showSplitArea = splitAreaModel.get("show");
    var splitLineColors = lineStyleModel.get("color");
    var splitAreaColors = areaStyleModel.get("color");
    var splitLineColorsArr = isArray$2(splitLineColors) ? splitLineColors : [splitLineColors];
    var splitAreaColorsArr = isArray$2(splitAreaColors) ? splitAreaColors : [splitAreaColors];
    var splitLines = [];
    var splitAreas = [];
    function getColorIndex(areaOrLine, areaOrLineColorList, idx) {
      var colorIndex2 = idx % areaOrLineColorList.length;
      areaOrLine[colorIndex2] = areaOrLine[colorIndex2] || [];
      return colorIndex2;
    }
    if (shape === "circle") {
      var ticksRadius = indicatorAxes[0].getTicksCoords();
      var cx = radar.cx;
      var cy = radar.cy;
      for (var i = 0; i < ticksRadius.length; i++) {
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Circle$1({
            shape: {
              cx,
              cy,
              r: ticksRadius[i].coord
            }
          }));
        }
        if (showSplitArea && i < ticksRadius.length - 1) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i);
          splitAreas[colorIndex].push(new Ring$1({
            shape: {
              cx,
              cy,
              r0: ticksRadius[i].coord,
              r: ticksRadius[i + 1].coord
            }
          }));
        }
      }
    } else {
      var realSplitNumber_1;
      var axesTicksPoints = map$1(indicatorAxes, function(indicatorAxis, idx) {
        var ticksCoords = indicatorAxis.getTicksCoords();
        realSplitNumber_1 = realSplitNumber_1 == null ? ticksCoords.length - 1 : Math.min(ticksCoords.length - 1, realSplitNumber_1);
        return map$1(ticksCoords, function(tickCoord) {
          return radar.coordToPoint(tickCoord.coord, idx);
        });
      });
      var prevPoints = [];
      for (var i = 0; i <= realSplitNumber_1; i++) {
        var points2 = [];
        for (var j = 0; j < indicatorAxes.length; j++) {
          points2.push(axesTicksPoints[j][i]);
        }
        if (points2[0]) {
          points2.push(points2[0].slice());
        }
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Polyline$3({
            shape: {
              points: points2
            }
          }));
        }
        if (showSplitArea && prevPoints) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i - 1);
          splitAreas[colorIndex].push(new Polygon$1({
            shape: {
              points: points2.concat(prevPoints)
            }
          }));
        }
        prevPoints = points2.slice().reverse();
      }
    }
    var lineStyle = lineStyleModel.getLineStyle();
    var areaStyle = areaStyleModel.getAreaStyle();
    each$g(splitAreas, function(splitAreas2, idx) {
      this.group.add(mergePath(splitAreas2, {
        style: defaults({
          stroke: "none",
          fill: splitAreaColorsArr[idx % splitAreaColorsArr.length]
        }, areaStyle),
        silent: true
      }));
    }, this);
    each$g(splitLines, function(splitLines2, idx) {
      this.group.add(mergePath(splitLines2, {
        style: defaults({
          fill: "none",
          stroke: splitLineColorsArr[idx % splitLineColorsArr.length]
        }, lineStyle),
        silent: true
      }));
    }, this);
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ComponentView$1);
var RadarView$1 = RadarView;
var IndicatorAxis = function(_super) {
  __extends(IndicatorAxis2, _super);
  function IndicatorAxis2(dim, scale2, radiusExtent) {
    var _this = _super.call(this, dim, scale2, radiusExtent) || this;
    _this.type = "value";
    _this.angle = 0;
    _this.name = "";
    return _this;
  }
  return IndicatorAxis2;
}(Axis$1);
var IndicatorAxis$1 = IndicatorAxis;
var Radar = function() {
  function Radar2(radarModel, ecModel, api) {
    this.dimensions = [];
    this._model = radarModel;
    this._indicatorAxes = map$1(radarModel.getIndicatorModels(), function(indicatorModel, idx) {
      var dim = "indicator_" + idx;
      var indicatorAxis = new IndicatorAxis$1(dim, new IntervalScale$1());
      indicatorAxis.name = indicatorModel.get("name");
      indicatorAxis.model = indicatorModel;
      indicatorModel.axis = indicatorAxis;
      this.dimensions.push(dim);
      return indicatorAxis;
    }, this);
    this.resize(radarModel, api);
  }
  Radar2.prototype.getIndicatorAxes = function() {
    return this._indicatorAxes;
  };
  Radar2.prototype.dataToPoint = function(value, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    return this.coordToPoint(indicatorAxis.dataToCoord(value), indicatorIndex);
  };
  Radar2.prototype.coordToPoint = function(coord, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    var angle = indicatorAxis.angle;
    var x2 = this.cx + coord * Math.cos(angle);
    var y2 = this.cy - coord * Math.sin(angle);
    return [x2, y2];
  };
  Radar2.prototype.pointToData = function(pt) {
    var dx = pt[0] - this.cx;
    var dy = pt[1] - this.cy;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx);
    var minRadianDiff = Infinity;
    var closestAxis;
    var closestAxisIdx = -1;
    for (var i = 0; i < this._indicatorAxes.length; i++) {
      var indicatorAxis = this._indicatorAxes[i];
      var diff = Math.abs(radian - indicatorAxis.angle);
      if (diff < minRadianDiff) {
        closestAxis = indicatorAxis;
        closestAxisIdx = i;
        minRadianDiff = diff;
      }
    }
    return [closestAxisIdx, +(closestAxis && closestAxis.coordToData(radius))];
  };
  Radar2.prototype.resize = function(radarModel, api) {
    var center2 = radarModel.get("center");
    var viewWidth = api.getWidth();
    var viewHeight = api.getHeight();
    var viewSize = Math.min(viewWidth, viewHeight) / 2;
    this.cx = parsePercent(center2[0], viewWidth);
    this.cy = parsePercent(center2[1], viewHeight);
    this.startAngle = radarModel.get("startAngle") * Math.PI / 180;
    var radius = radarModel.get("radius");
    if (isString$1(radius) || isNumber(radius)) {
      radius = [0, radius];
    }
    this.r0 = parsePercent(radius[0], viewSize);
    this.r = parsePercent(radius[1], viewSize);
    each$g(this._indicatorAxes, function(indicatorAxis, idx) {
      indicatorAxis.setExtent(this.r0, this.r);
      var angle = this.startAngle + idx * Math.PI * 2 / this._indicatorAxes.length;
      angle = Math.atan2(Math.sin(angle), Math.cos(angle));
      indicatorAxis.angle = angle;
    }, this);
  };
  Radar2.prototype.update = function(ecModel, api) {
    var indicatorAxes = this._indicatorAxes;
    var radarModel = this._model;
    each$g(indicatorAxes, function(indicatorAxis) {
      indicatorAxis.scale.setExtent(Infinity, -Infinity);
    });
    ecModel.eachSeriesByType("radar", function(radarSeries, idx) {
      if (radarSeries.get("coordinateSystem") !== "radar" || ecModel.getComponent("radar", radarSeries.get("radarIndex")) !== radarModel) {
        return;
      }
      var data2 = radarSeries.getData();
      each$g(indicatorAxes, function(indicatorAxis) {
        indicatorAxis.scale.unionExtentFromData(data2, data2.mapDimension(indicatorAxis.dim));
      });
    }, this);
    var splitNumber = radarModel.get("splitNumber");
    var dummyScale = new IntervalScale$1();
    dummyScale.setExtent(0, splitNumber);
    dummyScale.setInterval(1);
    each$g(indicatorAxes, function(indicatorAxis, idx) {
      alignScaleTicks(indicatorAxis.scale, indicatorAxis.model, dummyScale);
    });
  };
  Radar2.prototype.convertToPixel = function(ecModel, finder, value) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Radar2.create = function(ecModel, api) {
    var radarList = [];
    ecModel.eachComponent("radar", function(radarModel) {
      var radar = new Radar2(radarModel, ecModel, api);
      radarList.push(radar);
      radarModel.coordinateSystem = radar;
    });
    ecModel.eachSeriesByType("radar", function(radarSeries) {
      if (radarSeries.get("coordinateSystem") === "radar") {
        radarSeries.coordinateSystem = radarList[radarSeries.get("radarIndex") || 0];
      }
    });
    return radarList;
  };
  Radar2.dimensions = [];
  return Radar2;
}();
var Radar$1 = Radar;
function install$L(registers) {
  registers.registerCoordinateSystem("radar", Radar$1);
  registers.registerComponentModel(RadarModel$1);
  registers.registerComponentView(RadarView$1);
  registers.registerVisual({
    seriesType: "radar",
    reset: function(seriesModel) {
      var data2 = seriesModel.getData();
      data2.each(function(idx) {
        data2.setItemVisual(idx, "legendIcon", "roundRect");
      });
      data2.setVisual("legendIcon", "roundRect");
    }
  });
}
function install$K(registers) {
  use(install$L);
  registers.registerChartView(RadarView$3);
  registers.registerSeriesModel(RadarSeriesModel$1);
  registers.registerLayout(radarLayout);
  registers.registerProcessor(dataFilter$1("radar"));
  registers.registerPreprocessor(radarBackwardCompat);
}
var ATTR = "\0_ec_interaction_mutex";
function take(zr, resourceKey, userKey) {
  var store = getStore(zr);
  store[resourceKey] = userKey;
}
function release(zr, resourceKey, userKey) {
  var store = getStore(zr);
  var uKey = store[resourceKey];
  if (uKey === userKey) {
    store[resourceKey] = null;
  }
}
function isTaken(zr, resourceKey) {
  return !!getStore(zr)[resourceKey];
}
function getStore(zr) {
  return zr[ATTR] || (zr[ATTR] = {});
}
registerAction({
  type: "takeGlobalCursor",
  event: "globalCursorTaken",
  update: "update"
}, noop$1);
var RoamController = function(_super) {
  __extends(RoamController2, _super);
  function RoamController2(zr) {
    var _this = _super.call(this) || this;
    _this._zr = zr;
    var mousedownHandler = bind$1(_this._mousedownHandler, _this);
    var mousemoveHandler = bind$1(_this._mousemoveHandler, _this);
    var mouseupHandler = bind$1(_this._mouseupHandler, _this);
    var mousewheelHandler = bind$1(_this._mousewheelHandler, _this);
    var pinchHandler = bind$1(_this._pinchHandler, _this);
    _this.enable = function(controlType, opt) {
      this.disable();
      this._opt = defaults(clone$4(opt) || {}, {
        zoomOnMouseWheel: true,
        moveOnMouseMove: true,
        moveOnMouseWheel: false,
        preventDefaultMouseMove: true
      });
      if (controlType == null) {
        controlType = true;
      }
      if (controlType === true || controlType === "move" || controlType === "pan") {
        zr.on("mousedown", mousedownHandler);
        zr.on("mousemove", mousemoveHandler);
        zr.on("mouseup", mouseupHandler);
      }
      if (controlType === true || controlType === "scale" || controlType === "zoom") {
        zr.on("mousewheel", mousewheelHandler);
        zr.on("pinch", pinchHandler);
      }
    };
    _this.disable = function() {
      zr.off("mousedown", mousedownHandler);
      zr.off("mousemove", mousemoveHandler);
      zr.off("mouseup", mouseupHandler);
      zr.off("mousewheel", mousewheelHandler);
      zr.off("pinch", pinchHandler);
    };
    return _this;
  }
  RoamController2.prototype.isDragging = function() {
    return this._dragging;
  };
  RoamController2.prototype.isPinching = function() {
    return this._pinching;
  };
  RoamController2.prototype.setPointerChecker = function(pointerChecker) {
    this.pointerChecker = pointerChecker;
  };
  RoamController2.prototype.dispose = function() {
    this.disable();
  };
  RoamController2.prototype._mousedownHandler = function(e2) {
    if (isMiddleOrRightButtonOnMouseUpDown(e2) || e2.target && e2.target.draggable) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    if (this.pointerChecker && this.pointerChecker(e2, x2, y2)) {
      this._x = x2;
      this._y = y2;
      this._dragging = true;
    }
  };
  RoamController2.prototype._mousemoveHandler = function(e2) {
    if (!this._dragging || !isAvailableBehavior("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || isTaken(this._zr, "globalPan")) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var oldX = this._x;
    var oldY = this._y;
    var dx = x2 - oldX;
    var dy = y2 - oldY;
    this._x = x2;
    this._y = y2;
    this._opt.preventDefaultMouseMove && stop(e2.event);
    trigger$1(this, "pan", "moveOnMouseMove", e2, {
      dx,
      dy,
      oldX,
      oldY,
      newX: x2,
      newY: y2,
      isAvailableBehavior: null
    });
  };
  RoamController2.prototype._mouseupHandler = function(e2) {
    if (!isMiddleOrRightButtonOnMouseUpDown(e2)) {
      this._dragging = false;
    }
  };
  RoamController2.prototype._mousewheelHandler = function(e2) {
    var shouldZoom = isAvailableBehavior("zoomOnMouseWheel", e2, this._opt);
    var shouldMove = isAvailableBehavior("moveOnMouseWheel", e2, this._opt);
    var wheelDelta = e2.wheelDelta;
    var absWheelDeltaDelta = Math.abs(wheelDelta);
    var originX = e2.offsetX;
    var originY = e2.offsetY;
    if (wheelDelta === 0 || !shouldZoom && !shouldMove) {
      return;
    }
    if (shouldZoom) {
      var factor = absWheelDeltaDelta > 3 ? 1.4 : absWheelDeltaDelta > 1 ? 1.2 : 1.1;
      var scale2 = wheelDelta > 0 ? factor : 1 / factor;
      checkPointerAndTrigger(this, "zoom", "zoomOnMouseWheel", e2, {
        scale: scale2,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
    if (shouldMove) {
      var absDelta = Math.abs(wheelDelta);
      var scrollDelta = (wheelDelta > 0 ? 1 : -1) * (absDelta > 3 ? 0.4 : absDelta > 1 ? 0.15 : 0.05);
      checkPointerAndTrigger(this, "scrollMove", "moveOnMouseWheel", e2, {
        scrollDelta,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
  };
  RoamController2.prototype._pinchHandler = function(e2) {
    if (isTaken(this._zr, "globalPan")) {
      return;
    }
    var scale2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
    checkPointerAndTrigger(this, "zoom", null, e2, {
      scale: scale2,
      originX: e2.pinchX,
      originY: e2.pinchY,
      isAvailableBehavior: null
    });
  };
  return RoamController2;
}(Eventful$1);
function checkPointerAndTrigger(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  if (controller.pointerChecker && controller.pointerChecker(e2, contollerEvent.originX, contollerEvent.originY)) {
    stop(e2.event);
    trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent);
  }
}
function trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  contollerEvent.isAvailableBehavior = bind$1(isAvailableBehavior, null, behaviorToCheck, e2);
  controller.trigger(eventName, contollerEvent);
}
function isAvailableBehavior(behaviorToCheck, e2, settings) {
  var setting = settings[behaviorToCheck];
  return !behaviorToCheck || setting && (!isString$1(setting) || e2.event[setting + "Key"]);
}
var RoamController$1 = RoamController;
function updateViewOnPan(controllerHost, dx, dy) {
  var target = controllerHost.target;
  target.x += dx;
  target.y += dy;
  target.dirty();
}
function updateViewOnZoom(controllerHost, zoomDelta, zoomX, zoomY) {
  var target = controllerHost.target;
  var zoomLimit = controllerHost.zoomLimit;
  var newZoom = controllerHost.zoom = controllerHost.zoom || 1;
  newZoom *= zoomDelta;
  if (zoomLimit) {
    var zoomMin = zoomLimit.min || 0;
    var zoomMax = zoomLimit.max || Infinity;
    newZoom = Math.max(Math.min(zoomMax, newZoom), zoomMin);
  }
  var zoomScale = newZoom / controllerHost.zoom;
  controllerHost.zoom = newZoom;
  target.x -= (zoomX - target.x) * (zoomScale - 1);
  target.y -= (zoomY - target.y) * (zoomScale - 1);
  target.scaleX *= zoomScale;
  target.scaleY *= zoomScale;
  target.dirty();
}
var IRRELEVANT_EXCLUDES = {
  "axisPointer": 1,
  "tooltip": 1,
  "brush": 1
};
function onIrrelevantElement(e2, api, targetCoordSysModel) {
  var model = api.getComponentByElement(e2.topTarget);
  var coordSys = model && model.coordinateSystem;
  return model && model !== targetCoordSysModel && !IRRELEVANT_EXCLUDES.hasOwnProperty(model.mainType) && coordSys && coordSys.model !== targetCoordSysModel;
}
function parseXML(svg) {
  if (isString$1(svg)) {
    var parser = new DOMParser();
    svg = parser.parseFromString(svg, "text/xml");
  }
  var svgNode = svg;
  if (svgNode.nodeType === 9) {
    svgNode = svgNode.firstChild;
  }
  while (svgNode.nodeName.toLowerCase() !== "svg" || svgNode.nodeType !== 1) {
    svgNode = svgNode.nextSibling;
  }
  return svgNode;
}
var nodeParsers;
var INHERITABLE_STYLE_ATTRIBUTES_MAP = {
  "fill": "fill",
  "stroke": "stroke",
  "stroke-width": "lineWidth",
  "opacity": "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  "visibility": "visibility",
  "display": "display"
};
var INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS = keys(INHERITABLE_STYLE_ATTRIBUTES_MAP);
var SELF_STYLE_ATTRIBUTES_MAP = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
};
var SELF_STYLE_ATTRIBUTES_MAP_KEYS = keys(SELF_STYLE_ATTRIBUTES_MAP);
var SVGParser = function() {
  function SVGParser2() {
    this._defs = {};
    this._root = null;
  }
  SVGParser2.prototype.parse = function(xml, opt) {
    opt = opt || {};
    var svg = parseXML(xml);
    this._defsUsePending = [];
    var root2 = new Group$6();
    this._root = root2;
    var named = [];
    var viewBox = svg.getAttribute("viewBox") || "";
    var width = parseFloat(svg.getAttribute("width") || opt.width);
    var height = parseFloat(svg.getAttribute("height") || opt.height);
    isNaN(width) && (width = null);
    isNaN(height) && (height = null);
    parseAttributes(svg, root2, null, true, false);
    var child = svg.firstChild;
    while (child) {
      this._parseNode(child, root2, named, null, false, false);
      child = child.nextSibling;
    }
    applyDefs(this._defs, this._defsUsePending);
    this._defsUsePending = [];
    var viewBoxRect;
    var viewBoxTransform;
    if (viewBox) {
      var viewBoxArr = splitNumberSequence(viewBox);
      if (viewBoxArr.length >= 4) {
        viewBoxRect = {
          x: parseFloat(viewBoxArr[0] || 0),
          y: parseFloat(viewBoxArr[1] || 0),
          width: parseFloat(viewBoxArr[2]),
          height: parseFloat(viewBoxArr[3])
        };
      }
    }
    if (viewBoxRect && width != null && height != null) {
      viewBoxTransform = makeViewBoxTransform(viewBoxRect, { x: 0, y: 0, width, height });
      if (!opt.ignoreViewBox) {
        var elRoot = root2;
        root2 = new Group$6();
        root2.add(elRoot);
        elRoot.scaleX = elRoot.scaleY = viewBoxTransform.scale;
        elRoot.x = viewBoxTransform.x;
        elRoot.y = viewBoxTransform.y;
      }
    }
    if (!opt.ignoreRootClip && width != null && height != null) {
      root2.setClipPath(new Rect$3({
        shape: { x: 0, y: 0, width, height }
      }));
    }
    return {
      root: root2,
      width,
      height,
      viewBoxRect,
      viewBoxTransform,
      named
    };
  };
  SVGParser2.prototype._parseNode = function(xmlNode, parentGroup, named, namedFrom, isInDefs, isInText) {
    var nodeName = xmlNode.nodeName.toLowerCase();
    var el;
    var namedFromForSub = namedFrom;
    if (nodeName === "defs") {
      isInDefs = true;
    }
    if (nodeName === "text") {
      isInText = true;
    }
    if (nodeName === "defs" || nodeName === "switch") {
      el = parentGroup;
    } else {
      if (!isInDefs) {
        var parser_1 = nodeParsers[nodeName];
        if (parser_1 && hasOwn$1(nodeParsers, nodeName)) {
          el = parser_1.call(this, xmlNode, parentGroup);
          var nameAttr = xmlNode.getAttribute("name");
          if (nameAttr) {
            var newNamed = {
              name: nameAttr,
              namedFrom: null,
              svgNodeTagLower: nodeName,
              el
            };
            named.push(newNamed);
            if (nodeName === "g") {
              namedFromForSub = newNamed;
            }
          } else if (namedFrom) {
            named.push({
              name: namedFrom.name,
              namedFrom,
              svgNodeTagLower: nodeName,
              el
            });
          }
          parentGroup.add(el);
        }
      }
      var parser = paintServerParsers[nodeName];
      if (parser && hasOwn$1(paintServerParsers, nodeName)) {
        var def = parser.call(this, xmlNode);
        var id2 = xmlNode.getAttribute("id");
        if (id2) {
          this._defs[id2] = def;
        }
      }
    }
    if (el && el.isGroup) {
      var child = xmlNode.firstChild;
      while (child) {
        if (child.nodeType === 1) {
          this._parseNode(child, el, named, namedFromForSub, isInDefs, isInText);
        } else if (child.nodeType === 3 && isInText) {
          this._parseText(child, el);
        }
        child = child.nextSibling;
      }
    }
  };
  SVGParser2.prototype._parseText = function(xmlNode, parentGroup) {
    var text = new TSpan$1({
      style: {
        text: xmlNode.textContent
      },
      silent: true,
      x: this._textX || 0,
      y: this._textY || 0
    });
    inheritStyle(parentGroup, text);
    parseAttributes(xmlNode, text, this._defsUsePending, false, false);
    applyTextAlignment(text, parentGroup);
    var textStyle = text.style;
    var fontSize = textStyle.fontSize;
    if (fontSize && fontSize < 9) {
      textStyle.fontSize = 9;
      text.scaleX *= fontSize / 9;
      text.scaleY *= fontSize / 9;
    }
    var font = (textStyle.fontSize || textStyle.fontFamily) && [
      textStyle.fontStyle,
      textStyle.fontWeight,
      (textStyle.fontSize || 12) + "px",
      textStyle.fontFamily || "sans-serif"
    ].join(" ");
    textStyle.font = font;
    var rect = text.getBoundingRect();
    this._textX += rect.width;
    parentGroup.add(text);
    return text;
  };
  SVGParser2.internalField = function() {
    nodeParsers = {
      "g": function(xmlNode, parentGroup) {
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, false);
        return g2;
      },
      "rect": function(xmlNode, parentGroup) {
        var rect = new Rect$3();
        inheritStyle(parentGroup, rect);
        parseAttributes(xmlNode, rect, this._defsUsePending, false, false);
        rect.setShape({
          x: parseFloat(xmlNode.getAttribute("x") || "0"),
          y: parseFloat(xmlNode.getAttribute("y") || "0"),
          width: parseFloat(xmlNode.getAttribute("width") || "0"),
          height: parseFloat(xmlNode.getAttribute("height") || "0")
        });
        rect.silent = true;
        return rect;
      },
      "circle": function(xmlNode, parentGroup) {
        var circle = new Circle$1();
        inheritStyle(parentGroup, circle);
        parseAttributes(xmlNode, circle, this._defsUsePending, false, false);
        circle.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          r: parseFloat(xmlNode.getAttribute("r") || "0")
        });
        circle.silent = true;
        return circle;
      },
      "line": function(xmlNode, parentGroup) {
        var line = new Line$3();
        inheritStyle(parentGroup, line);
        parseAttributes(xmlNode, line, this._defsUsePending, false, false);
        line.setShape({
          x1: parseFloat(xmlNode.getAttribute("x1") || "0"),
          y1: parseFloat(xmlNode.getAttribute("y1") || "0"),
          x2: parseFloat(xmlNode.getAttribute("x2") || "0"),
          y2: parseFloat(xmlNode.getAttribute("y2") || "0")
        });
        line.silent = true;
        return line;
      },
      "ellipse": function(xmlNode, parentGroup) {
        var ellipse = new Ellipse$1();
        inheritStyle(parentGroup, ellipse);
        parseAttributes(xmlNode, ellipse, this._defsUsePending, false, false);
        ellipse.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          rx: parseFloat(xmlNode.getAttribute("rx") || "0"),
          ry: parseFloat(xmlNode.getAttribute("ry") || "0")
        });
        ellipse.silent = true;
        return ellipse;
      },
      "polygon": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polygon = new Polygon$1({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polygon);
        parseAttributes(xmlNode, polygon, this._defsUsePending, false, false);
        return polygon;
      },
      "polyline": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polyline = new Polyline$3({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polyline);
        parseAttributes(xmlNode, polyline, this._defsUsePending, false, false);
        return polyline;
      },
      "image": function(xmlNode, parentGroup) {
        var img = new ZRImage$1();
        inheritStyle(parentGroup, img);
        parseAttributes(xmlNode, img, this._defsUsePending, false, false);
        img.setStyle({
          image: xmlNode.getAttribute("xlink:href") || xmlNode.getAttribute("href"),
          x: +xmlNode.getAttribute("x"),
          y: +xmlNode.getAttribute("y"),
          width: +xmlNode.getAttribute("width"),
          height: +xmlNode.getAttribute("height")
        });
        img.silent = true;
        return img;
      },
      "text": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x") || "0";
        var y2 = xmlNode.getAttribute("y") || "0";
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        this._textX = parseFloat(x2) + parseFloat(dx);
        this._textY = parseFloat(y2) + parseFloat(dy);
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        return g2;
      },
      "tspan": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x");
        var y2 = xmlNode.getAttribute("y");
        if (x2 != null) {
          this._textX = parseFloat(x2);
        }
        if (y2 != null) {
          this._textY = parseFloat(y2);
        }
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        this._textX += parseFloat(dx);
        this._textY += parseFloat(dy);
        return g2;
      },
      "path": function(xmlNode, parentGroup) {
        var d2 = xmlNode.getAttribute("d") || "";
        var path = createFromString(d2);
        inheritStyle(parentGroup, path);
        parseAttributes(xmlNode, path, this._defsUsePending, false, false);
        path.silent = true;
        return path;
      }
    };
  }();
  return SVGParser2;
}();
var paintServerParsers = {
  "lineargradient": function(xmlNode) {
    var x1 = parseInt(xmlNode.getAttribute("x1") || "0", 10);
    var y1 = parseInt(xmlNode.getAttribute("y1") || "0", 10);
    var x2 = parseInt(xmlNode.getAttribute("x2") || "10", 10);
    var y2 = parseInt(xmlNode.getAttribute("y2") || "0", 10);
    var gradient = new LinearGradient$1(x1, y1, x2, y2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  },
  "radialgradient": function(xmlNode) {
    var cx = parseInt(xmlNode.getAttribute("cx") || "0", 10);
    var cy = parseInt(xmlNode.getAttribute("cy") || "0", 10);
    var r2 = parseInt(xmlNode.getAttribute("r") || "0", 10);
    var gradient = new RadialGradient$1(cx, cy, r2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  }
};
function parsePaintServerUnit(xmlNode, gradient) {
  var gradientUnits = xmlNode.getAttribute("gradientUnits");
  if (gradientUnits === "userSpaceOnUse") {
    gradient.global = true;
  }
}
function parseGradientColorStops(xmlNode, gradient) {
  var stop2 = xmlNode.firstChild;
  while (stop2) {
    if (stop2.nodeType === 1 && stop2.nodeName.toLocaleLowerCase() === "stop") {
      var offsetStr = stop2.getAttribute("offset");
      var offset3 = void 0;
      if (offsetStr && offsetStr.indexOf("%") > 0) {
        offset3 = parseInt(offsetStr, 10) / 100;
      } else if (offsetStr) {
        offset3 = parseFloat(offsetStr);
      } else {
        offset3 = 0;
      }
      var styleVals = {};
      parseInlineStyle(stop2, styleVals, styleVals);
      var stopColor = styleVals.stopColor || stop2.getAttribute("stop-color") || "#000000";
      gradient.colorStops.push({
        offset: offset3,
        color: stopColor
      });
    }
    stop2 = stop2.nextSibling;
  }
}
function inheritStyle(parent, child) {
  if (parent && parent.__inheritedStyle) {
    if (!child.__inheritedStyle) {
      child.__inheritedStyle = {};
    }
    defaults(child.__inheritedStyle, parent.__inheritedStyle);
  }
}
function parsePoints(pointsString) {
  var list = splitNumberSequence(pointsString);
  var points2 = [];
  for (var i = 0; i < list.length; i += 2) {
    var x2 = parseFloat(list[i]);
    var y2 = parseFloat(list[i + 1]);
    points2.push([x2, y2]);
  }
  return points2;
}
function parseAttributes(xmlNode, el, defsUsePending, onlyInlineStyle, isTextGroup) {
  var disp = el;
  var inheritedStyle = disp.__inheritedStyle = disp.__inheritedStyle || {};
  var selfStyle = {};
  if (xmlNode.nodeType === 1) {
    parseTransformAttribute(xmlNode, el);
    parseInlineStyle(xmlNode, inheritedStyle, selfStyle);
    if (!onlyInlineStyle) {
      parseAttributeStyle(xmlNode, inheritedStyle, selfStyle);
    }
  }
  disp.style = disp.style || {};
  if (inheritedStyle.fill != null) {
    disp.style.fill = getFillStrokeStyle(disp, "fill", inheritedStyle.fill, defsUsePending);
  }
  if (inheritedStyle.stroke != null) {
    disp.style.stroke = getFillStrokeStyle(disp, "stroke", inheritedStyle.stroke, defsUsePending);
  }
  each$g([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = parseFloat(inheritedStyle[propName]);
    }
  });
  each$g([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = inheritedStyle[propName];
    }
  });
  if (isTextGroup) {
    disp.__selfStyle = selfStyle;
  }
  if (inheritedStyle.lineDash) {
    disp.style.lineDash = map$1(splitNumberSequence(inheritedStyle.lineDash), function(str) {
      return parseFloat(str);
    });
  }
  if (inheritedStyle.visibility === "hidden" || inheritedStyle.visibility === "collapse") {
    disp.invisible = true;
  }
  if (inheritedStyle.display === "none") {
    disp.ignore = true;
  }
}
function applyTextAlignment(text, parentGroup) {
  var parentSelfStyle = parentGroup.__selfStyle;
  if (parentSelfStyle) {
    var textBaseline = parentSelfStyle.textBaseline;
    var zrTextBaseline = textBaseline;
    if (!textBaseline || textBaseline === "auto") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "baseline") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "before-edge" || textBaseline === "text-before-edge") {
      zrTextBaseline = "top";
    } else if (textBaseline === "after-edge" || textBaseline === "text-after-edge") {
      zrTextBaseline = "bottom";
    } else if (textBaseline === "central" || textBaseline === "mathematical") {
      zrTextBaseline = "middle";
    }
    text.style.textBaseline = zrTextBaseline;
  }
  var parentInheritedStyle = parentGroup.__inheritedStyle;
  if (parentInheritedStyle) {
    var textAlign = parentInheritedStyle.textAlign;
    var zrTextAlign = textAlign;
    if (textAlign) {
      if (textAlign === "middle") {
        zrTextAlign = "center";
      }
      text.style.textAlign = zrTextAlign;
    }
  }
}
var urlRegex = /^url\(\s*#(.*?)\)/;
function getFillStrokeStyle(el, method4, str, defsUsePending) {
  var urlMatch = str && str.match(urlRegex);
  if (urlMatch) {
    var url2 = trim$1(urlMatch[1]);
    defsUsePending.push([el, method4, url2]);
    return;
  }
  if (str === "none") {
    str = null;
  }
  return str;
}
function applyDefs(defs, defsUsePending) {
  for (var i = 0; i < defsUsePending.length; i++) {
    var item = defsUsePending[i];
    item[0].style[item[1]] = defs[item[2]];
  }
}
var numberReg = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function splitNumberSequence(rawStr) {
  return rawStr.match(numberReg) || [];
}
var transformRegex = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g;
var DEGREE_TO_ANGLE = Math.PI / 180;
function parseTransformAttribute(xmlNode, node) {
  var transform2 = xmlNode.getAttribute("transform");
  if (transform2) {
    transform2 = transform2.replace(/,/g, " ");
    var transformOps_1 = [];
    var mt = null;
    transform2.replace(transformRegex, function(str, type5, value2) {
      transformOps_1.push(type5, value2);
      return "";
    });
    for (var i = transformOps_1.length - 1; i > 0; i -= 2) {
      var value = transformOps_1[i];
      var type4 = transformOps_1[i - 1];
      var valueArr = splitNumberSequence(value);
      mt = mt || create$2();
      switch (type4) {
        case "translate":
          translate(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || "0")]);
          break;
        case "scale":
          scale$1(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || valueArr[0])]);
          break;
        case "rotate":
          rotate(mt, mt, -parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          break;
        case "skewX":
          var sx = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, 0, sx, 1, 0, 0], mt);
          break;
        case "skewY":
          var sy = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, sy, 0, 1, 0, 0], mt);
          break;
        case "matrix":
          mt[0] = parseFloat(valueArr[0]);
          mt[1] = parseFloat(valueArr[1]);
          mt[2] = parseFloat(valueArr[2]);
          mt[3] = parseFloat(valueArr[3]);
          mt[4] = parseFloat(valueArr[4]);
          mt[5] = parseFloat(valueArr[5]);
          break;
      }
    }
    node.setLocalTransform(mt);
  }
}
var styleRegex = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function parseInlineStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  var style2 = xmlNode.getAttribute("style");
  if (!style2) {
    return;
  }
  styleRegex.lastIndex = 0;
  var styleRegResult;
  while ((styleRegResult = styleRegex.exec(style2)) != null) {
    var svgStlAttr = styleRegResult[1];
    var zrInheritableStlAttr = hasOwn$1(INHERITABLE_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? INHERITABLE_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrInheritableStlAttr) {
      inheritableStyleResult[zrInheritableStlAttr] = styleRegResult[2];
    }
    var zrSelfStlAttr = hasOwn$1(SELF_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? SELF_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrSelfStlAttr) {
      selfStyleResult[zrSelfStlAttr] = styleRegResult[2];
    }
  }
}
function parseAttributeStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  for (var i = 0; i < INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      inheritableStyleResult[INHERITABLE_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
  for (var i = 0; i < SELF_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = SELF_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      selfStyleResult[SELF_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
}
function makeViewBoxTransform(viewBoxRect, boundingRect) {
  var scaleX = boundingRect.width / viewBoxRect.width;
  var scaleY = boundingRect.height / viewBoxRect.height;
  var scale2 = Math.min(scaleX, scaleY);
  return {
    scale: scale2,
    x: -(viewBoxRect.x + viewBoxRect.width / 2) * scale2 + (boundingRect.x + boundingRect.width / 2),
    y: -(viewBoxRect.y + viewBoxRect.height / 2) * scale2 + (boundingRect.y + boundingRect.height / 2)
  };
}
function parseSVG(xml, opt) {
  var parser = new SVGParser();
  return parser.parse(xml, opt);
}
var REGION_AVAILABLE_SVG_TAG_MAP = createHashMap([
  "rect",
  "circle",
  "line",
  "ellipse",
  "polygon",
  "polyline",
  "path",
  "text",
  "tspan",
  "g"
]);
var GeoSVGResource = function() {
  function GeoSVGResource2(mapName, svg) {
    this.type = "geoSVG";
    this._usedGraphicMap = createHashMap();
    this._freedGraphics = [];
    this._mapName = mapName;
    this._parsedXML = parseXML(svg);
  }
  GeoSVGResource2.prototype.load = function() {
    var firstGraphic = this._firstGraphic;
    if (!firstGraphic) {
      firstGraphic = this._firstGraphic = this._buildGraphic(this._parsedXML);
      this._freedGraphics.push(firstGraphic);
      this._boundingRect = this._firstGraphic.boundingRect.clone();
      var _a2 = createRegions(firstGraphic.named), regions = _a2.regions, regionsMap = _a2.regionsMap;
      this._regions = regions;
      this._regionsMap = regionsMap;
    }
    return {
      boundingRect: this._boundingRect,
      regions: this._regions,
      regionsMap: this._regionsMap
    };
  };
  GeoSVGResource2.prototype._buildGraphic = function(svgXML) {
    var result;
    var rootFromParse;
    try {
      result = svgXML && parseSVG(svgXML, {
        ignoreViewBox: true,
        ignoreRootClip: true
      }) || {};
      rootFromParse = result.root;
      assert(rootFromParse != null);
    } catch (e2) {
      throw new Error("Invalid svg format\n" + e2.message);
    }
    var root2 = new Group$6();
    root2.add(rootFromParse);
    root2.isGeoSVGGraphicRoot = true;
    var svgWidth = result.width;
    var svgHeight = result.height;
    var viewBoxRect = result.viewBoxRect;
    var boundingRect = this._boundingRect;
    if (!boundingRect) {
      var bRectX = void 0;
      var bRectY = void 0;
      var bRectWidth = void 0;
      var bRectHeight = void 0;
      if (svgWidth != null) {
        bRectX = 0;
        bRectWidth = svgWidth;
      } else if (viewBoxRect) {
        bRectX = viewBoxRect.x;
        bRectWidth = viewBoxRect.width;
      }
      if (svgHeight != null) {
        bRectY = 0;
        bRectHeight = svgHeight;
      } else if (viewBoxRect) {
        bRectY = viewBoxRect.y;
        bRectHeight = viewBoxRect.height;
      }
      if (bRectX == null || bRectY == null) {
        var calculatedBoundingRect = rootFromParse.getBoundingRect();
        if (bRectX == null) {
          bRectX = calculatedBoundingRect.x;
          bRectWidth = calculatedBoundingRect.width;
        }
        if (bRectY == null) {
          bRectY = calculatedBoundingRect.y;
          bRectHeight = calculatedBoundingRect.height;
        }
      }
      boundingRect = this._boundingRect = new BoundingRect$1(bRectX, bRectY, bRectWidth, bRectHeight);
    }
    if (viewBoxRect) {
      var viewBoxTransform = makeViewBoxTransform(viewBoxRect, boundingRect);
      rootFromParse.scaleX = rootFromParse.scaleY = viewBoxTransform.scale;
      rootFromParse.x = viewBoxTransform.x;
      rootFromParse.y = viewBoxTransform.y;
    }
    root2.setClipPath(new Rect$3({
      shape: boundingRect.plain()
    }));
    var named = [];
    each$g(result.named, function(namedItem) {
      if (REGION_AVAILABLE_SVG_TAG_MAP.get(namedItem.svgNodeTagLower) != null) {
        named.push(namedItem);
        setSilent(namedItem.el);
      }
    });
    return {
      root: root2,
      boundingRect,
      named
    };
  };
  GeoSVGResource2.prototype.useGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      return svgGraphic;
    }
    svgGraphic = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML);
    usedRootMap.set(hostKey, svgGraphic);
    return svgGraphic;
  };
  GeoSVGResource2.prototype.freeGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      usedRootMap.removeKey(hostKey);
      this._freedGraphics.push(svgGraphic);
    }
  };
  return GeoSVGResource2;
}();
function setSilent(el) {
  el.silent = false;
  if (el.isGroup) {
    el.traverse(function(child) {
      child.silent = false;
    });
  }
}
function createRegions(named) {
  var regions = [];
  var regionsMap = createHashMap();
  each$g(named, function(namedItem) {
    if (namedItem.namedFrom != null) {
      return;
    }
    var region = new GeoSVGRegion(namedItem.name, namedItem.el);
    regions.push(region);
    regionsMap.set(namedItem.name, region);
  });
  return {
    regions,
    regionsMap
  };
}
var geoCoord = [126, 25];
var nanhaiName = "\u5357\u6D77\u8BF8\u5C9B";
var points$1 = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
for (var i$1 = 0; i$1 < points$1.length; i$1++) {
  for (var k$1 = 0; k$1 < points$1[i$1].length; k$1++) {
    points$1[i$1][k$1][0] /= 10.5;
    points$1[i$1][k$1][1] /= -10.5 / 0.75;
    points$1[i$1][k$1][0] += geoCoord[0];
    points$1[i$1][k$1][1] += geoCoord[1];
  }
}
function fixNanhai(mapType, regions) {
  if (mapType === "china") {
    for (var i = 0; i < regions.length; i++) {
      if (regions[i].name === nanhaiName) {
        return;
      }
    }
    regions.push(new GeoJSONRegion(nanhaiName, map$1(points$1, function(exterior) {
      return {
        type: "polygon",
        exterior
      };
    }), geoCoord));
  }
}
var coordsOffsetMap = {
  "\u5357\u6D77\u8BF8\u5C9B": [32, 80],
  "\u5E7F\u4E1C": [0, -10],
  "\u9999\u6E2F": [10, 5],
  "\u6FB3\u95E8": [-10, 10],
  "\u5929\u6D25": [5, 5]
};
function fixTextCoords(mapType, region) {
  if (mapType === "china") {
    var coordFix = coordsOffsetMap[region.name];
    if (coordFix) {
      var cp = region.getCenter();
      cp[0] += coordFix[0] / 10.5;
      cp[1] += -coordFix[1] / (10.5 / 0.75);
      region.setCenter(cp);
    }
  }
}
var points = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
function fixDiaoyuIsland(mapType, region) {
  if (mapType === "china" && region.name === "\u53F0\u6E7E") {
    region.geometries.push({
      type: "polygon",
      exterior: points[0]
    });
  }
}
var DEFAULT_NAME_PROPERTY = "name";
var GeoJSONResource = function() {
  function GeoJSONResource2(mapName, geoJSON, specialAreas) {
    this.type = "geoJSON";
    this._parsedMap = createHashMap();
    this._mapName = mapName;
    this._specialAreas = specialAreas;
    this._geoJSON = parseInput(geoJSON);
  }
  GeoJSONResource2.prototype.load = function(nameMap, nameProperty) {
    nameProperty = nameProperty || DEFAULT_NAME_PROPERTY;
    var parsed = this._parsedMap.get(nameProperty);
    if (!parsed) {
      var rawRegions = this._parseToRegions(nameProperty);
      parsed = this._parsedMap.set(nameProperty, {
        regions: rawRegions,
        boundingRect: calculateBoundingRect(rawRegions)
      });
    }
    var regionsMap = createHashMap();
    var finalRegions = [];
    each$g(parsed.regions, function(region) {
      var regionName = region.name;
      if (nameMap && hasOwn$1(nameMap, regionName)) {
        region = region.cloneShallow(regionName = nameMap[regionName]);
      }
      finalRegions.push(region);
      regionsMap.set(regionName, region);
    });
    return {
      regions: finalRegions,
      boundingRect: parsed.boundingRect || new BoundingRect$1(0, 0, 0, 0),
      regionsMap
    };
  };
  GeoJSONResource2.prototype._parseToRegions = function(nameProperty) {
    var mapName = this._mapName;
    var geoJSON = this._geoJSON;
    var rawRegions;
    try {
      rawRegions = geoJSON ? parseGeoJSON(geoJSON, nameProperty) : [];
    } catch (e2) {
      throw new Error("Invalid geoJson format\n" + e2.message);
    }
    fixNanhai(mapName, rawRegions);
    each$g(rawRegions, function(region) {
      var regionName = region.name;
      fixTextCoords(mapName, region);
      fixDiaoyuIsland(mapName, region);
      var specialArea = this._specialAreas && this._specialAreas[regionName];
      if (specialArea) {
        region.transformTo(specialArea.left, specialArea.top, specialArea.width, specialArea.height);
      }
    }, this);
    return rawRegions;
  };
  GeoJSONResource2.prototype.getMapForUser = function() {
    return {
      geoJson: this._geoJSON,
      geoJSON: this._geoJSON,
      specialAreas: this._specialAreas
    };
  };
  return GeoJSONResource2;
}();
function calculateBoundingRect(regions) {
  var rect;
  for (var i = 0; i < regions.length; i++) {
    var regionRect = regions[i].getBoundingRect();
    rect = rect || regionRect.clone();
    rect.union(regionRect);
  }
  return rect;
}
function parseInput(source) {
  return !isString$1(source) ? source : typeof JSON !== "undefined" && JSON.parse ? JSON.parse(source) : new Function("return (" + source + ");")();
}
var storage = createHashMap();
var geoSourceManager = {
  registerMap: function(mapName, rawDef, rawSpecialAreas) {
    if (rawDef.svg) {
      var resource = new GeoSVGResource(mapName, rawDef.svg);
      storage.set(mapName, resource);
    } else {
      var geoJSON = rawDef.geoJson || rawDef.geoJSON;
      if (geoJSON && !rawDef.features) {
        rawSpecialAreas = rawDef.specialAreas;
      } else {
        geoJSON = rawDef;
      }
      var resource = new GeoJSONResource(mapName, geoJSON, rawSpecialAreas);
      storage.set(mapName, resource);
    }
  },
  getGeoResource: function(mapName) {
    return storage.get(mapName);
  },
  getMapForUser: function(mapName) {
    var resource = storage.get(mapName);
    return resource && resource.type === "geoJSON" && resource.getMapForUser();
  },
  load: function(mapName, nameMap, nameProperty) {
    var resource = storage.get(mapName);
    if (!resource) {
      return;
    }
    return resource.load(nameMap, nameProperty);
  }
};
var OPTION_STYLE_ENABLED_TAGS = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"];
var OPTION_STYLE_ENABLED_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS);
var STATE_TRIGGER_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var LABEL_HOST_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var mapLabelRaw = makeInner();
function getFixedItemStyle(model) {
  var itemStyle = model.getItemStyle();
  var areaColor = model.get("areaColor");
  if (areaColor != null) {
    itemStyle.fill = areaColor;
  }
  return itemStyle;
}
function fixLineStyle(styleHost) {
  var style2 = styleHost.style;
  if (style2) {
    style2.stroke = style2.stroke || style2.fill;
    style2.fill = null;
  }
}
var MapDraw = function() {
  function MapDraw2(api) {
    var group = new Group$6();
    this.uid = getUID("ec_map_draw");
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    this.group = group;
    group.add(this._regionsGroup = new Group$6());
    group.add(this._svgGroup = new Group$6());
  }
  MapDraw2.prototype.draw = function(mapOrGeoModel, ecModel, api, fromView, payload) {
    var isGeo = mapOrGeoModel.mainType === "geo";
    var data2 = mapOrGeoModel.getData && mapOrGeoModel.getData();
    isGeo && ecModel.eachComponent({
      mainType: "series",
      subType: "map"
    }, function(mapSeries) {
      if (!data2 && mapSeries.getHostGeoModel() === mapOrGeoModel) {
        data2 = mapSeries.getData();
      }
    });
    var geo = mapOrGeoModel.coordinateSystem;
    var regionsGroup = this._regionsGroup;
    var group = this.group;
    var transformInfo = geo.getTransformInfo();
    var transformInfoRaw = transformInfo.raw;
    var transformInfoRoam = transformInfo.roam;
    var isFirstDraw = !regionsGroup.childAt(0) || payload;
    if (isFirstDraw) {
      group.x = transformInfoRoam.x;
      group.y = transformInfoRoam.y;
      group.scaleX = transformInfoRoam.scaleX;
      group.scaleY = transformInfoRoam.scaleY;
      group.dirty();
    } else {
      updateProps$1(group, transformInfoRoam, mapOrGeoModel);
    }
    var isVisualEncodedByVisualMap = data2 && data2.getVisual("visualMeta") && data2.getVisual("visualMeta").length > 0;
    var viewBuildCtx = {
      api,
      geo,
      mapOrGeoModel,
      data: data2,
      isVisualEncodedByVisualMap,
      isGeo,
      transformInfoRaw
    };
    if (geo.resourceType === "geoJSON") {
      this._buildGeoJSON(viewBuildCtx);
    } else if (geo.resourceType === "geoSVG") {
      this._buildSVG(viewBuildCtx);
    }
    this._updateController(mapOrGeoModel, ecModel, api);
    this._updateMapSelectHandler(mapOrGeoModel, regionsGroup, api, fromView);
  };
  MapDraw2.prototype._buildGeoJSON = function(viewBuildCtx) {
    var regionsGroupByName = this._regionsGroupByName = createHashMap();
    var regionsInfoByName = createHashMap();
    var regionsGroup = this._regionsGroup;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
    var data2 = viewBuildCtx.data;
    var projection = viewBuildCtx.geo.projection;
    var projectionStream = projection && projection.stream;
    function transformPoint(point, project) {
      if (project) {
        point = project(point);
      }
      return point && [point[0] * transformInfoRaw.scaleX + transformInfoRaw.x, point[1] * transformInfoRaw.scaleY + transformInfoRaw.y];
    }
    function transformPolygonPoints(inPoints) {
      var outPoints = [];
      var project = !projectionStream && projection && projection.project;
      for (var i = 0; i < inPoints.length; ++i) {
        var newPt = transformPoint(inPoints[i], project);
        newPt && outPoints.push(newPt);
      }
      return outPoints;
    }
    function getPolyShape(points2) {
      return {
        shape: {
          points: transformPolygonPoints(points2)
        }
      };
    }
    regionsGroup.removeAll();
    each$g(viewBuildCtx.geo.regions, function(region) {
      var regionName = region.name;
      var regionGroup = regionsGroupByName.get(regionName);
      var _a2 = regionsInfoByName.get(regionName) || {}, dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      if (!regionGroup) {
        regionGroup = regionsGroupByName.set(regionName, new Group$6());
        regionsGroup.add(regionGroup);
        dataIdx = data2 ? data2.indexOfName(regionName) : null;
        regionModel = viewBuildCtx.isGeo ? mapOrGeoModel.getRegionModel(regionName) : data2 ? data2.getItemModel(dataIdx) : null;
        regionsInfoByName.set(regionName, {
          dataIdx,
          regionModel
        });
      }
      var polygonSubpaths = [];
      var polylineSubpaths = [];
      each$g(region.geometries, function(geometry) {
        if (geometry.type === "polygon") {
          var polys = [geometry.exterior].concat(geometry.interiors || []);
          if (projectionStream) {
            polys = projectPolys(polys, projectionStream);
          }
          each$g(polys, function(poly) {
            polygonSubpaths.push(new Polygon$1(getPolyShape(poly)));
          });
        } else {
          var points2 = geometry.points;
          if (projectionStream) {
            points2 = projectPolys(points2, projectionStream, true);
          }
          each$g(points2, function(points3) {
            polylineSubpaths.push(new Polyline$3(getPolyShape(points3)));
          });
        }
      });
      var centerPt = transformPoint(region.getCenter(), projection && projection.project);
      function createCompoundPath(subpaths, isLine) {
        if (!subpaths.length) {
          return;
        }
        var compoundPath = new CompoundPath$1({
          culling: true,
          segmentIgnoreThreshold: 1,
          shape: {
            paths: subpaths
          }
        });
        regionGroup.add(compoundPath);
        applyOptionStyleForRegion(viewBuildCtx, compoundPath, dataIdx, regionModel);
        resetLabelForRegion(viewBuildCtx, compoundPath, regionName, regionModel, mapOrGeoModel, dataIdx, centerPt);
        if (isLine) {
          fixLineStyle(compoundPath);
          each$g(compoundPath.states, fixLineStyle);
        }
      }
      createCompoundPath(polygonSubpaths);
      createCompoundPath(polylineSubpaths, true);
    });
    regionsGroupByName.each(function(regionGroup, regionName) {
      var _a2 = regionsInfoByName.get(regionName), dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      resetEventTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel, dataIdx);
      resetTooltipForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
      resetStateTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
    }, this);
  };
  MapDraw2.prototype._buildSVG = function(viewBuildCtx) {
    var mapName = viewBuildCtx.geo.map;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    this._svgGroup.x = transformInfoRaw.x;
    this._svgGroup.y = transformInfoRaw.y;
    this._svgGroup.scaleX = transformInfoRaw.scaleX;
    this._svgGroup.scaleY = transformInfoRaw.scaleY;
    if (this._svgResourceChanged(mapName)) {
      this._freeSVG();
      this._useSVG(mapName);
    }
    var svgDispatcherMap = this._svgDispatcherMap = createHashMap();
    var focusSelf = false;
    each$g(this._svgGraphicRecord.named, function(namedItem) {
      var regionName = namedItem.name;
      var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
      var data2 = viewBuildCtx.data;
      var svgNodeTagLower = namedItem.svgNodeTagLower;
      var el = namedItem.el;
      var dataIdx = data2 ? data2.indexOfName(regionName) : null;
      var regionModel = mapOrGeoModel.getRegionModel(regionName);
      if (OPTION_STYLE_ENABLED_TAG_MAP.get(svgNodeTagLower) != null && el instanceof Displayable$1) {
        applyOptionStyleForRegion(viewBuildCtx, el, dataIdx, regionModel);
      }
      if (el instanceof Displayable$1) {
        el.culling = true;
      }
      el.z2EmphasisLift = 0;
      if (!namedItem.namedFrom) {
        if (LABEL_HOST_MAP.get(svgNodeTagLower) != null) {
          resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, null);
        }
        resetEventTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx);
        resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
        if (STATE_TRIGGER_TAG_MAP.get(svgNodeTagLower) != null) {
          var focus_1 = resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
          if (focus_1 === "self") {
            focusSelf = true;
          }
          var els = svgDispatcherMap.get(regionName) || svgDispatcherMap.set(regionName, []);
          els.push(el);
        }
      }
    }, this);
    this._enableBlurEntireSVG(focusSelf, viewBuildCtx);
  };
  MapDraw2.prototype._enableBlurEntireSVG = function(focusSelf, viewBuildCtx) {
    if (focusSelf && viewBuildCtx.isGeo) {
      var blurStyle = viewBuildCtx.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle();
      var opacity_1 = blurStyle.opacity;
      this._svgGraphicRecord.root.traverse(function(el) {
        if (!el.isGroup) {
          setDefaultStateProxy(el);
          var style2 = el.ensureState("blur").style || {};
          if (style2.opacity == null && opacity_1 != null) {
            style2.opacity = opacity_1;
          }
          el.ensureState("emphasis");
        }
      });
    }
  };
  MapDraw2.prototype.remove = function() {
    this._regionsGroup.removeAll();
    this._regionsGroupByName = null;
    this._svgGroup.removeAll();
    this._freeSVG();
    this._controller.dispose();
    this._controllerHost = null;
  };
  MapDraw2.prototype.findHighDownDispatchers = function(name2, geoModel) {
    if (name2 == null) {
      return [];
    }
    var geo = geoModel.coordinateSystem;
    if (geo.resourceType === "geoJSON") {
      var regionsGroupByName = this._regionsGroupByName;
      if (regionsGroupByName) {
        var regionGroup = regionsGroupByName.get(name2);
        return regionGroup ? [regionGroup] : [];
      }
    } else if (geo.resourceType === "geoSVG") {
      return this._svgDispatcherMap && this._svgDispatcherMap.get(name2) || [];
    }
  };
  MapDraw2.prototype._svgResourceChanged = function(mapName) {
    return this._svgMapName !== mapName;
  };
  MapDraw2.prototype._useSVG = function(mapName) {
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      var svgGraphic = resource.useGraphic(this.uid);
      this._svgGroup.add(svgGraphic.root);
      this._svgGraphicRecord = svgGraphic;
      this._svgMapName = mapName;
    }
  };
  MapDraw2.prototype._freeSVG = function() {
    var mapName = this._svgMapName;
    if (mapName == null) {
      return;
    }
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      resource.freeGraphic(this.uid);
    }
    this._svgGraphicRecord = null;
    this._svgDispatcherMap = null;
    this._svgGroup.removeAll();
    this._svgMapName = null;
  };
  MapDraw2.prototype._updateController = function(mapOrGeoModel, ecModel, api) {
    var geo = mapOrGeoModel.coordinateSystem;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    controllerHost.zoomLimit = mapOrGeoModel.get("scaleLimit");
    controllerHost.zoom = geo.getZoom();
    controller.enable(mapOrGeoModel.get("roam") || false);
    var mainType = mapOrGeoModel.mainType;
    function makeActionBase() {
      var action = {
        type: "geoRoam",
        componentType: mainType
      };
      action[mainType + "Id"] = mapOrGeoModel.id;
      return action;
    }
    controller.off("pan").on("pan", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction(extend(makeActionBase(), {
        dx: e2.dx,
        dy: e2.dy,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.off("zoom").on("zoom", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction(extend(makeActionBase(), {
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.setPointerChecker(function(e2, x2, y2) {
      return geo.containPoint([x2, y2]) && !onIrrelevantElement(e2, api, mapOrGeoModel);
    });
  };
  MapDraw2.prototype.resetForLabelLayout = function() {
    this.group.traverse(function(el) {
      var label = el.getTextContent();
      if (label) {
        label.ignore = mapLabelRaw(label).ignore;
      }
    });
  };
  MapDraw2.prototype._updateMapSelectHandler = function(mapOrGeoModel, regionsGroup, api, fromView) {
    var mapDraw = this;
    regionsGroup.off("mousedown");
    regionsGroup.off("click");
    if (mapOrGeoModel.get("selectedMode")) {
      regionsGroup.on("mousedown", function() {
        mapDraw._mouseDownFlag = true;
      });
      regionsGroup.on("click", function(e2) {
        if (!mapDraw._mouseDownFlag) {
          return;
        }
        mapDraw._mouseDownFlag = false;
      });
    }
  };
  return MapDraw2;
}();
function applyOptionStyleForRegion(viewBuildCtx, el, dataIndex, regionModel) {
  var normalStyleModel = regionModel.getModel("itemStyle");
  var emphasisStyleModel = regionModel.getModel(["emphasis", "itemStyle"]);
  var blurStyleModel = regionModel.getModel(["blur", "itemStyle"]);
  var selectStyleModel = regionModel.getModel(["select", "itemStyle"]);
  var normalStyle = getFixedItemStyle(normalStyleModel);
  var emphasisStyle = getFixedItemStyle(emphasisStyleModel);
  var selectStyle = getFixedItemStyle(selectStyleModel);
  var blurStyle = getFixedItemStyle(blurStyleModel);
  var data2 = viewBuildCtx.data;
  if (data2) {
    var style2 = data2.getItemVisual(dataIndex, "style");
    var decal = data2.getItemVisual(dataIndex, "decal");
    if (viewBuildCtx.isVisualEncodedByVisualMap && style2.fill) {
      normalStyle.fill = style2.fill;
    }
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, viewBuildCtx.api);
    }
  }
  el.setStyle(normalStyle);
  el.style.strokeNoScale = true;
  el.ensureState("emphasis").style = emphasisStyle;
  el.ensureState("select").style = selectStyle;
  el.ensureState("blur").style = blurStyle;
  setDefaultStateProxy(el);
}
function resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, labelXY) {
  var data2 = viewBuildCtx.data;
  var isGeo = viewBuildCtx.isGeo;
  var isDataNaN = data2 && isNaN(data2.get(data2.mapDimension("value"), dataIdx));
  var itemLayout = data2 && data2.getItemLayout(dataIdx);
  if (isGeo || isDataNaN || itemLayout && itemLayout.showLabel) {
    var query = !isGeo ? dataIdx : regionName;
    var labelFetcher = void 0;
    if (!data2 || dataIdx >= 0) {
      labelFetcher = mapOrGeoModel;
    }
    var specifiedTextOpt = labelXY ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    setLabelStyle(el, getLabelStatesModels(regionModel), {
      labelFetcher,
      labelDataIndex: query,
      defaultText: regionName
    }, specifiedTextOpt);
    var textEl = el.getTextContent();
    if (textEl) {
      mapLabelRaw(textEl).ignore = textEl.ignore;
      if (el.textConfig && labelXY) {
        var rect = el.getBoundingRect().clone();
        el.textConfig.layoutRect = rect;
        el.textConfig.position = [(labelXY[0] - rect.x) / rect.width * 100 + "%", (labelXY[1] - rect.y) / rect.height * 100 + "%"];
      }
    }
    el.disableLabelAnimation = true;
  } else {
    el.removeTextContent();
    el.removeTextConfig();
    el.disableLabelAnimation = null;
  }
}
function resetEventTriggerForRegion(viewBuildCtx, eventTrigger, regionName, regionModel, mapOrGeoModel, dataIdx) {
  if (viewBuildCtx.data) {
    viewBuildCtx.data.setItemGraphicEl(dataIdx, eventTrigger);
  } else {
    getECData(eventTrigger).eventData = {
      componentType: "geo",
      componentIndex: mapOrGeoModel.componentIndex,
      geoIndex: mapOrGeoModel.componentIndex,
      name: regionName,
      region: regionModel && regionModel.option || {}
    };
  }
}
function resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  if (!viewBuildCtx.data) {
    setTooltipConfig({
      el,
      componentModel: mapOrGeoModel,
      itemName: regionName,
      itemTooltipOption: regionModel.get("tooltip")
    });
  }
}
function resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  el.highDownSilentOnTouch = !!mapOrGeoModel.get("selectedMode");
  var emphasisModel = regionModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  toggleHoverEmphasis(el, focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  if (viewBuildCtx.isGeo) {
    enableComponentHighDownFeatures(el, mapOrGeoModel, regionName);
  }
  return focus;
}
function projectPolys(rings, createStream, isLine) {
  var polygons = [];
  var curPoly;
  function startPolygon() {
    curPoly = [];
  }
  function endPolygon() {
    if (curPoly.length) {
      polygons.push(curPoly);
      curPoly = [];
    }
  }
  var stream = createStream({
    polygonStart: startPolygon,
    polygonEnd: endPolygon,
    lineStart: startPolygon,
    lineEnd: endPolygon,
    point: function(x2, y2) {
      if (isFinite(x2) && isFinite(y2)) {
        curPoly.push([x2, y2]);
      }
    },
    sphere: function() {
    }
  });
  !isLine && stream.polygonStart();
  each$g(rings, function(ring) {
    stream.lineStart();
    for (var i = 0; i < ring.length; i++) {
      stream.point(ring[i][0], ring[i][1]);
    }
    stream.lineEnd();
  });
  !isLine && stream.polygonEnd();
  return polygons;
}
var MapDraw$1 = MapDraw;
var MapView = function(_super) {
  __extends(MapView2, _super);
  function MapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapView2.type;
    return _this;
  }
  MapView2.prototype.render = function(mapModel, ecModel, api, payload) {
    if (payload && payload.type === "mapToggleSelect" && payload.from === this.uid) {
      return;
    }
    var group = this.group;
    group.removeAll();
    if (mapModel.getHostGeoModel()) {
      return;
    }
    if (this._mapDraw && payload && payload.type === "geoRoam") {
      this._mapDraw.resetForLabelLayout();
    }
    if (!(payload && payload.type === "geoRoam" && payload.componentType === "series" && payload.seriesId === mapModel.id)) {
      if (mapModel.needsDrawMap) {
        var mapDraw = this._mapDraw || new MapDraw$1(api);
        group.add(mapDraw.group);
        mapDraw.draw(mapModel, ecModel, api, this, payload);
        this._mapDraw = mapDraw;
      } else {
        this._mapDraw && this._mapDraw.remove();
        this._mapDraw = null;
      }
    } else {
      var mapDraw = this._mapDraw;
      mapDraw && group.add(mapDraw.group);
    }
    mapModel.get("showLegendSymbol") && ecModel.getComponent("legend") && this._renderSymbols(mapModel, ecModel, api);
  };
  MapView2.prototype.remove = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
    this.group.removeAll();
  };
  MapView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
  };
  MapView2.prototype._renderSymbols = function(mapModel, ecModel, api) {
    var originalData = mapModel.originalData;
    var group = this.group;
    originalData.each(originalData.mapDimension("value"), function(value, originalDataIndex) {
      if (isNaN(value)) {
        return;
      }
      var layout2 = originalData.getItemLayout(originalDataIndex);
      if (!layout2 || !layout2.point) {
        return;
      }
      var point = layout2.point;
      var offset3 = layout2.offset;
      var circle = new Circle$1({
        style: {
          fill: mapModel.getData().getVisual("style").fill
        },
        shape: {
          cx: point[0] + offset3 * 9,
          cy: point[1],
          r: 3
        },
        silent: true,
        z2: 8 + (!offset3 ? Z2_EMPHASIS_LIFT + 1 : 0)
      });
      if (!offset3) {
        var fullData = mapModel.mainSeries.getData();
        var name_1 = originalData.getName(originalDataIndex);
        var fullIndex_1 = fullData.indexOfName(name_1);
        var itemModel = originalData.getItemModel(originalDataIndex);
        var labelModel = itemModel.getModel("label");
        var regionGroup = fullData.getItemGraphicEl(fullIndex_1);
        setLabelStyle(circle, getLabelStatesModels(itemModel), {
          labelFetcher: {
            getFormattedLabel: function(idx, state) {
              return mapModel.getFormattedLabel(fullIndex_1, state);
            }
          },
          defaultText: name_1
        });
        circle.disableLabelAnimation = true;
        if (!labelModel.get("position")) {
          circle.setTextConfig({
            position: "bottom"
          });
        }
        regionGroup.onHoverStateChange = function(toState) {
          setStatesFlag(circle, toState);
        };
      }
      group.add(circle);
    });
  };
  MapView2.type = "map";
  return MapView2;
}(ChartView$1);
var MapView$1 = MapView;
var MapSeries = function(_super) {
  __extends(MapSeries2, _super);
  function MapSeries2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapSeries2.type;
    _this.needsDrawMap = false;
    _this.seriesGroup = [];
    _this.getTooltipPosition = function(dataIndex) {
      if (dataIndex != null) {
        var name_1 = this.getData().getName(dataIndex);
        var geo = this.coordinateSystem;
        var region = geo.getRegion(name_1);
        return region && geo.dataToPoint(region.getCenter());
      }
    };
    return _this;
  }
  MapSeries2.prototype.getInitialData = function(option) {
    var data2 = createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$3(makeSeriesEncodeForNameBased, this)
    });
    var dataNameMap = createHashMap();
    var toAppendNames = [];
    for (var i = 0, len2 = data2.count(); i < len2; i++) {
      var name_2 = data2.getName(i);
      dataNameMap.set(name_2, true);
    }
    var geoSource = geoSourceManager.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
    each$g(geoSource.regions, function(region) {
      var name2 = region.name;
      if (!dataNameMap.get(name2)) {
        toAppendNames.push(name2);
      }
    });
    data2.appendValues([], toAppendNames);
    return data2;
  };
  MapSeries2.prototype.getHostGeoModel = function() {
    var geoIndex = this.option.geoIndex;
    return geoIndex != null ? this.ecModel.getComponent("geo", geoIndex) : null;
  };
  MapSeries2.prototype.getMapType = function() {
    return (this.getHostGeoModel() || this).option.map;
  };
  MapSeries2.prototype.getRawValue = function(dataIndex) {
    var data2 = this.getData();
    return data2.get(data2.mapDimension("value"), dataIndex);
  };
  MapSeries2.prototype.getRegionModel = function(regionName) {
    var data2 = this.getData();
    return data2.getItemModel(data2.indexOfName(regionName));
  };
  MapSeries2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var value = this.getRawValue(dataIndex);
    var name2 = data2.getName(dataIndex);
    var seriesGroup = this.seriesGroup;
    var seriesNames = [];
    for (var i = 0; i < seriesGroup.length; i++) {
      var otherIndex = seriesGroup[i].originalData.indexOfName(name2);
      var valueDim = data2.mapDimension("value");
      if (!isNaN(seriesGroup[i].originalData.get(valueDim, otherIndex))) {
        seriesNames.push(seriesGroup[i].name);
      }
    }
    return createTooltipMarkup("section", {
      header: seriesNames.join(", "),
      noHeader: !seriesNames.length,
      blocks: [createTooltipMarkup("nameValue", {
        name: name2,
        value
      })]
    });
  };
  MapSeries2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  MapSeries2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  MapSeries2.prototype.getLegendIcon = function(opt) {
    var iconType = opt.icon || "roundRect";
    var icon = createSymbol$1(iconType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill);
    icon.setStyle(opt.itemStyle);
    icon.style.stroke = "none";
    if (iconType.indexOf("empty") > -1) {
      icon.style.stroke = icon.style.fill;
      icon.style.fill = "#fff";
      icon.style.lineWidth = 2;
    }
    return icon;
  };
  MapSeries2.type = "series.map";
  MapSeries2.dependencies = ["geo"];
  MapSeries2.layoutMode = "box";
  MapSeries2.defaultOption = {
    z: 2,
    coordinateSystem: "geo",
    map: "",
    left: "center",
    top: "center",
    aspectScale: null,
    showLegendSymbol: true,
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    selectedMode: true,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444",
      areaColor: "#eee"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        areaColor: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    nameProperty: "name"
  };
  return MapSeries2;
}(SeriesModel$1);
var MapSeries$1 = MapSeries;
function dataStatistics(datas, statisticType) {
  var dataNameMap = {};
  each$g(datas, function(data2) {
    data2.each(data2.mapDimension("value"), function(value, idx) {
      var mapKey = "ec-" + data2.getName(idx);
      dataNameMap[mapKey] = dataNameMap[mapKey] || [];
      if (!isNaN(value)) {
        dataNameMap[mapKey].push(value);
      }
    });
  });
  return datas[0].map(datas[0].mapDimension("value"), function(value, idx) {
    var mapKey = "ec-" + datas[0].getName(idx);
    var sum2 = 0;
    var min3 = Infinity;
    var max3 = -Infinity;
    var len2 = dataNameMap[mapKey].length;
    for (var i = 0; i < len2; i++) {
      min3 = Math.min(min3, dataNameMap[mapKey][i]);
      max3 = Math.max(max3, dataNameMap[mapKey][i]);
      sum2 += dataNameMap[mapKey][i];
    }
    var result;
    if (statisticType === "min") {
      result = min3;
    } else if (statisticType === "max") {
      result = max3;
    } else if (statisticType === "average") {
      result = sum2 / len2;
    } else {
      result = sum2;
    }
    return len2 === 0 ? NaN : result;
  });
}
function mapDataStatistic(ecModel) {
  var seriesGroups = {};
  ecModel.eachSeriesByType("map", function(seriesModel) {
    var hostGeoModel = seriesModel.getHostGeoModel();
    var key = hostGeoModel ? "o" + hostGeoModel.id : "i" + seriesModel.getMapType();
    (seriesGroups[key] = seriesGroups[key] || []).push(seriesModel);
  });
  each$g(seriesGroups, function(seriesList, key) {
    var data2 = dataStatistics(map$1(seriesList, function(seriesModel) {
      return seriesModel.getData();
    }), seriesList[0].get("mapValueCalculation"));
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].originalData = seriesList[i].getData();
    }
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].seriesGroup = seriesList;
      seriesList[i].needsDrawMap = i === 0 && !seriesList[i].getHostGeoModel();
      seriesList[i].setData(data2.cloneShallow());
      seriesList[i].mainSeries = seriesList[0];
    }
  });
}
function mapSymbolLayout(ecModel) {
  var processedMapType = {};
  ecModel.eachSeriesByType("map", function(mapSeries) {
    var mapType = mapSeries.getMapType();
    if (mapSeries.getHostGeoModel() || processedMapType[mapType]) {
      return;
    }
    var mapSymbolOffsets = {};
    each$g(mapSeries.seriesGroup, function(subMapSeries) {
      var geo = subMapSeries.coordinateSystem;
      var data3 = subMapSeries.originalData;
      if (subMapSeries.get("showLegendSymbol") && ecModel.getComponent("legend")) {
        data3.each(data3.mapDimension("value"), function(value, idx) {
          var name2 = data3.getName(idx);
          var region = geo.getRegion(name2);
          if (!region || isNaN(value)) {
            return;
          }
          var offset3 = mapSymbolOffsets[name2] || 0;
          var point = geo.dataToPoint(region.getCenter());
          mapSymbolOffsets[name2] = offset3 + 1;
          data3.setItemLayout(idx, {
            point,
            offset: offset3
          });
        });
      }
    });
    var data2 = mapSeries.getData();
    data2.each(function(idx) {
      var name2 = data2.getName(idx);
      var layout2 = data2.getItemLayout(idx) || {};
      layout2.showLabel = !mapSymbolOffsets[name2];
      data2.setItemLayout(idx, layout2);
    });
    processedMapType[mapType] = true;
  });
}
var v2ApplyTransform = applyTransform$1;
var View = function(_super) {
  __extends(View2, _super);
  function View2(name2) {
    var _this = _super.call(this) || this;
    _this.type = "view";
    _this.dimensions = ["x", "y"];
    _this._roamTransformable = new Transformable$1();
    _this._rawTransformable = new Transformable$1();
    _this.name = name2;
    return _this;
  }
  View2.prototype.setBoundingRect = function(x2, y2, width, height) {
    this._rect = new BoundingRect$1(x2, y2, width, height);
    return this._rect;
  };
  View2.prototype.getBoundingRect = function() {
    return this._rect;
  };
  View2.prototype.setViewRect = function(x2, y2, width, height) {
    this._transformTo(x2, y2, width, height);
    this._viewRect = new BoundingRect$1(x2, y2, width, height);
  };
  View2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var rawTransform = this._rawTransformable;
    rawTransform.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransform.parent;
    rawTransform.parent = null;
    rawTransform.decomposeTransform();
    rawTransform.parent = rawParent;
    this._updateTransform();
  };
  View2.prototype.setCenter = function(centerCoord) {
    if (!centerCoord) {
      return;
    }
    this._center = centerCoord;
    this._updateCenterAndZoom();
  };
  View2.prototype.setZoom = function(zoom) {
    zoom = zoom || 1;
    var zoomLimit = this.zoomLimit;
    if (zoomLimit) {
      if (zoomLimit.max != null) {
        zoom = Math.min(zoomLimit.max, zoom);
      }
      if (zoomLimit.min != null) {
        zoom = Math.max(zoomLimit.min, zoom);
      }
    }
    this._zoom = zoom;
    this._updateCenterAndZoom();
  };
  View2.prototype.getDefaultCenter = function() {
    var rawRect = this.getBoundingRect();
    var cx = rawRect.x + rawRect.width / 2;
    var cy = rawRect.y + rawRect.height / 2;
    return [cx, cy];
  };
  View2.prototype.getCenter = function() {
    return this._center || this.getDefaultCenter();
  };
  View2.prototype.getZoom = function() {
    return this._zoom || 1;
  };
  View2.prototype.getRoamTransform = function() {
    return this._roamTransformable.getLocalTransform();
  };
  View2.prototype._updateCenterAndZoom = function() {
    var rawTransformMatrix = this._rawTransformable.getLocalTransform();
    var roamTransform = this._roamTransformable;
    var defaultCenter = this.getDefaultCenter();
    var center2 = this.getCenter();
    var zoom = this.getZoom();
    center2 = applyTransform$1([], center2, rawTransformMatrix);
    defaultCenter = applyTransform$1([], defaultCenter, rawTransformMatrix);
    roamTransform.originX = center2[0];
    roamTransform.originY = center2[1];
    roamTransform.x = defaultCenter[0] - center2[0];
    roamTransform.y = defaultCenter[1] - center2[1];
    roamTransform.scaleX = roamTransform.scaleY = zoom;
    this._updateTransform();
  };
  View2.prototype._updateTransform = function() {
    var roamTransformable = this._roamTransformable;
    var rawTransformable = this._rawTransformable;
    rawTransformable.parent = roamTransformable;
    roamTransformable.updateTransform();
    rawTransformable.updateTransform();
    copy(this.transform || (this.transform = []), rawTransformable.transform || create$2());
    this._rawTransform = rawTransformable.getLocalTransform();
    this.invTransform = this.invTransform || [];
    invert(this.invTransform, this.transform);
    this.decomposeTransform();
  };
  View2.prototype.getTransformInfo = function() {
    var rawTransformable = this._rawTransformable;
    var roamTransformable = this._roamTransformable;
    var dummyTransformable2 = new Transformable$1();
    dummyTransformable2.transform = roamTransformable.transform;
    dummyTransformable2.decomposeTransform();
    return {
      roam: {
        x: dummyTransformable2.x,
        y: dummyTransformable2.y,
        scaleX: dummyTransformable2.scaleX,
        scaleY: dummyTransformable2.scaleY
      },
      raw: {
        x: rawTransformable.x,
        y: rawTransformable.y,
        scaleX: rawTransformable.scaleX,
        scaleY: rawTransformable.scaleY
      }
    };
  };
  View2.prototype.getViewRect = function() {
    return this._viewRect;
  };
  View2.prototype.getViewRectAfterRoam = function() {
    var rect = this.getBoundingRect().clone();
    rect.applyTransform(this.transform);
    return rect;
  };
  View2.prototype.dataToPoint = function(data2, noRoam, out2) {
    var transform2 = noRoam ? this._rawTransform : this.transform;
    out2 = out2 || [];
    return transform2 ? v2ApplyTransform(out2, data2, transform2) : copy$1(out2, data2);
  };
  View2.prototype.pointToData = function(point) {
    var invTransform = this.invTransform;
    return invTransform ? v2ApplyTransform([], point, invTransform) : [point[0], point[1]];
  };
  View2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  View2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  View2.prototype.containPoint = function(point) {
    return this.getViewRectAfterRoam().contain(point[0], point[1]);
  };
  View2.dimensions = ["x", "y"];
  return View2;
}(Transformable$1);
function getCoordSys$4(finder) {
  var seriesModel = finder.seriesModel;
  return seriesModel ? seriesModel.coordinateSystem : null;
}
var View$1 = View;
var GEO_DEFAULT_PARAMS = {
  "geoJSON": {
    aspectScale: 0.75,
    invertLongitute: true
  },
  "geoSVG": {
    aspectScale: 1,
    invertLongitute: false
  }
};
var geo2DDimensions = ["lng", "lat"];
var Geo = function(_super) {
  __extends(Geo2, _super);
  function Geo2(name2, map2, opt) {
    var _this = _super.call(this, name2) || this;
    _this.dimensions = geo2DDimensions;
    _this.type = "geo";
    _this._nameCoordMap = createHashMap();
    _this.map = map2;
    var projection = opt.projection;
    var source = geoSourceManager.load(map2, opt.nameMap, opt.nameProperty);
    var resource = geoSourceManager.getGeoResource(map2);
    _this.resourceType = resource ? resource.type : null;
    var regions = _this.regions = source.regions;
    var defaultParams = GEO_DEFAULT_PARAMS[resource.type];
    _this._regionsMap = source.regionsMap;
    _this.regions = source.regions;
    _this.projection = projection;
    var boundingRect;
    if (projection) {
      for (var i = 0; i < regions.length; i++) {
        var regionRect = regions[i].getBoundingRect(projection);
        boundingRect = boundingRect || regionRect.clone();
        boundingRect.union(regionRect);
      }
    } else {
      boundingRect = source.boundingRect;
    }
    _this.setBoundingRect(boundingRect.x, boundingRect.y, boundingRect.width, boundingRect.height);
    _this.aspectScale = projection ? 1 : retrieve2(opt.aspectScale, defaultParams.aspectScale);
    _this._invertLongitute = projection ? false : defaultParams.invertLongitute;
    return _this;
  }
  Geo2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var invertLongitute = this._invertLongitute;
    rect = rect.clone();
    if (invertLongitute) {
      rect.y = -rect.y - rect.height;
    }
    var rawTransformable = this._rawTransformable;
    rawTransformable.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransformable.parent;
    rawTransformable.parent = null;
    rawTransformable.decomposeTransform();
    rawTransformable.parent = rawParent;
    if (invertLongitute) {
      rawTransformable.scaleY = -rawTransformable.scaleY;
    }
    this._updateTransform();
  };
  Geo2.prototype.getRegion = function(name2) {
    return this._regionsMap.get(name2);
  };
  Geo2.prototype.getRegionByCoord = function(coord) {
    var regions = this.regions;
    for (var i = 0; i < regions.length; i++) {
      var region = regions[i];
      if (region.type === "geoJSON" && region.contain(coord)) {
        return regions[i];
      }
    }
  };
  Geo2.prototype.addGeoCoord = function(name2, geoCoord2) {
    this._nameCoordMap.set(name2, geoCoord2);
  };
  Geo2.prototype.getGeoCoord = function(name2) {
    var region = this._regionsMap.get(name2);
    return this._nameCoordMap.get(name2) || region && region.getCenter();
  };
  Geo2.prototype.dataToPoint = function(data2, noRoam, out2) {
    if (isString$1(data2)) {
      data2 = this.getGeoCoord(data2);
    }
    if (data2) {
      var projection = this.projection;
      if (projection) {
        data2 = projection.project(data2);
      }
      return data2 && this.projectedToPoint(data2);
    }
  };
  Geo2.prototype.pointToData = function(point) {
    var projection = this.projection;
    if (projection) {
      point = projection.unproject(point);
    }
    return point && this.pointToProjected(point);
  };
  Geo2.prototype.pointToProjected = function(point) {
    return _super.prototype.pointToData.call(this, point);
  };
  Geo2.prototype.projectedToPoint = function(projected, noRoam, out2) {
    return _super.prototype.dataToPoint.call(this, projected, noRoam, out2);
  };
  Geo2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Geo2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  return Geo2;
}(View$1);
mixin(Geo, View$1);
function getCoordSys$3(finder) {
  var geoModel = finder.geoModel;
  var seriesModel = finder.seriesModel;
  return geoModel ? geoModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem || (seriesModel.getReferringComponents("geo", SINGLE_REFERRING).models[0] || {}).coordinateSystem : null;
}
var Geo$1 = Geo;
function resizeGeo(geoModel, api) {
  var boundingCoords = geoModel.get("boundingCoords");
  if (boundingCoords != null) {
    var leftTop_1 = boundingCoords[0];
    var rightBottom_1 = boundingCoords[1];
    if (!(isFinite(leftTop_1[0]) && isFinite(leftTop_1[1]) && isFinite(rightBottom_1[0]) && isFinite(rightBottom_1[1])))
      ;
    else {
      var projection_1 = this.projection;
      if (projection_1) {
        var xMin = leftTop_1[0];
        var yMin = leftTop_1[1];
        var xMax = rightBottom_1[0];
        var yMax = rightBottom_1[1];
        leftTop_1 = [Infinity, Infinity];
        rightBottom_1 = [-Infinity, -Infinity];
        var sampleLine = function(x0, y0, x1, y1) {
          var dx = x1 - x0;
          var dy = y1 - y0;
          for (var i = 0; i <= 100; i++) {
            var p2 = i / 100;
            var pt = projection_1.project([x0 + dx * p2, y0 + dy * p2]);
            min$1(leftTop_1, leftTop_1, pt);
            max$1(rightBottom_1, rightBottom_1, pt);
          }
        };
        sampleLine(xMin, yMin, xMax, yMin);
        sampleLine(xMax, yMin, xMax, yMax);
        sampleLine(xMax, yMax, xMin, yMax);
        sampleLine(xMin, yMax, xMax, yMin);
      }
      this.setBoundingRect(leftTop_1[0], leftTop_1[1], rightBottom_1[0] - leftTop_1[0], rightBottom_1[1] - leftTop_1[1]);
    }
  }
  var rect = this.getBoundingRect();
  var centerOption = geoModel.get("layoutCenter");
  var sizeOption = geoModel.get("layoutSize");
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  var aspect = rect.width / rect.height * this.aspectScale;
  var useCenterAndSize = false;
  var center2;
  var size;
  if (centerOption && sizeOption) {
    center2 = [parsePercent(centerOption[0], viewWidth), parsePercent(centerOption[1], viewHeight)];
    size = parsePercent(sizeOption, Math.min(viewWidth, viewHeight));
    if (!isNaN(center2[0]) && !isNaN(center2[1]) && !isNaN(size)) {
      useCenterAndSize = true;
    }
  }
  var viewRect2;
  if (useCenterAndSize) {
    viewRect2 = {};
    if (aspect > 1) {
      viewRect2.width = size;
      viewRect2.height = size / aspect;
    } else {
      viewRect2.height = size;
      viewRect2.width = size * aspect;
    }
    viewRect2.y = center2[1] - viewRect2.height / 2;
    viewRect2.x = center2[0] - viewRect2.width / 2;
  } else {
    var boxLayoutOption = geoModel.getBoxLayoutParams();
    boxLayoutOption.aspect = aspect;
    viewRect2 = getLayoutRect(boxLayoutOption, {
      width: viewWidth,
      height: viewHeight
    });
  }
  this.setViewRect(viewRect2.x, viewRect2.y, viewRect2.width, viewRect2.height);
  this.setCenter(geoModel.get("center"));
  this.setZoom(geoModel.get("zoom"));
}
function setGeoCoords(geo, model) {
  each$g(model.get("geoCoord"), function(geoCoord2, name2) {
    geo.addGeoCoord(name2, geoCoord2);
  });
}
var GeoCreator = function() {
  function GeoCreator2() {
    this.dimensions = geo2DDimensions;
  }
  GeoCreator2.prototype.create = function(ecModel, api) {
    var geoList = [];
    function getCommonGeoProperties(model) {
      return {
        nameProperty: model.get("nameProperty"),
        aspectScale: model.get("aspectScale"),
        projection: model.get("projection")
      };
    }
    ecModel.eachComponent("geo", function(geoModel, idx) {
      var mapName = geoModel.get("map");
      var geo = new Geo$1(mapName + idx, mapName, extend({
        nameMap: geoModel.get("nameMap")
      }, getCommonGeoProperties(geoModel)));
      geo.zoomLimit = geoModel.get("scaleLimit");
      geoList.push(geo);
      geoModel.coordinateSystem = geo;
      geo.model = geoModel;
      geo.resize = resizeGeo;
      geo.resize(geoModel, api);
    });
    ecModel.eachSeries(function(seriesModel) {
      var coordSys = seriesModel.get("coordinateSystem");
      if (coordSys === "geo") {
        var geoIndex = seriesModel.get("geoIndex") || 0;
        seriesModel.coordinateSystem = geoList[geoIndex];
      }
    });
    var mapModelGroupBySeries = {};
    ecModel.eachSeriesByType("map", function(seriesModel) {
      if (!seriesModel.getHostGeoModel()) {
        var mapType = seriesModel.getMapType();
        mapModelGroupBySeries[mapType] = mapModelGroupBySeries[mapType] || [];
        mapModelGroupBySeries[mapType].push(seriesModel);
      }
    });
    each$g(mapModelGroupBySeries, function(mapSeries, mapType) {
      var nameMapList = map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("nameMap");
      });
      var geo = new Geo$1(mapType, mapType, extend({
        nameMap: mergeAll(nameMapList)
      }, getCommonGeoProperties(mapSeries[0])));
      geo.zoomLimit = retrieve.apply(null, map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("scaleLimit");
      }));
      geoList.push(geo);
      geo.resize = resizeGeo;
      geo.resize(mapSeries[0], api);
      each$g(mapSeries, function(singleMapSeries) {
        singleMapSeries.coordinateSystem = geo;
        setGeoCoords(geo, singleMapSeries);
      });
    });
    return geoList;
  };
  GeoCreator2.prototype.getFilledRegions = function(originRegionArr, mapName, nameMap, nameProperty) {
    var regionsArr = (originRegionArr || []).slice();
    var dataNameMap = createHashMap();
    for (var i = 0; i < regionsArr.length; i++) {
      dataNameMap.set(regionsArr[i].name, regionsArr[i]);
    }
    var source = geoSourceManager.load(mapName, nameMap, nameProperty);
    each$g(source.regions, function(region) {
      var name2 = region.name;
      !dataNameMap.get(name2) && regionsArr.push({
        name: name2
      });
    });
    return regionsArr;
  };
  return GeoCreator2;
}();
var geoCreator = new GeoCreator();
var geoCreator$1 = geoCreator;
var GeoModel = function(_super) {
  __extends(GeoModel2, _super);
  function GeoModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoModel2.type;
    return _this;
  }
  GeoModel2.prototype.init = function(option, parentModel, ecModel) {
    var source = geoSourceManager.getGeoResource(option.map);
    if (source && source.type === "geoJSON") {
      var itemStyle = option.itemStyle = option.itemStyle || {};
      if (!("color" in itemStyle)) {
        itemStyle.color = "#eee";
      }
    }
    this.mergeDefaultAndTheme(option, ecModel);
    defaultEmphasis(option, "label", ["show"]);
  };
  GeoModel2.prototype.optionUpdated = function() {
    var _this = this;
    var option = this.option;
    option.regions = geoCreator$1.getFilledRegions(option.regions, option.map, option.nameMap, option.nameProperty);
    var selectedMap = {};
    this._optionModelMap = reduce(option.regions || [], function(optionModelMap, regionOpt) {
      var regionName = regionOpt.name;
      if (regionName) {
        optionModelMap.set(regionName, new Model$1(regionOpt, _this, _this.ecModel));
        if (regionOpt.selected) {
          selectedMap[regionName] = true;
        }
      }
      return optionModelMap;
    }, createHashMap());
    if (!option.selectedMap) {
      option.selectedMap = selectedMap;
    }
  };
  GeoModel2.prototype.getRegionModel = function(name2) {
    return this._optionModelMap.get(name2) || new Model$1(null, this, this.ecModel);
  };
  GeoModel2.prototype.getFormattedLabel = function(name2, status) {
    var regionModel = this.getRegionModel(name2);
    var formatter = status === "normal" ? regionModel.get(["label", "formatter"]) : regionModel.get(["emphasis", "label", "formatter"]);
    var params = {
      name: name2
    };
    if (isFunction$1(formatter)) {
      params.status = status;
      return formatter(params);
    } else if (isString$1(formatter)) {
      return formatter.replace("{a}", name2 != null ? name2 : "");
    }
  };
  GeoModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GeoModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GeoModel2.prototype.select = function(name2) {
    var option = this.option;
    var selectedMode = option.selectedMode;
    if (!selectedMode) {
      return;
    }
    if (selectedMode !== "multiple") {
      option.selectedMap = null;
    }
    var selectedMap = option.selectedMap || (option.selectedMap = {});
    selectedMap[name2] = true;
  };
  GeoModel2.prototype.unSelect = function(name2) {
    var selectedMap = this.option.selectedMap;
    if (selectedMap) {
      selectedMap[name2] = false;
    }
  };
  GeoModel2.prototype.toggleSelected = function(name2) {
    this[this.isSelected(name2) ? "unSelect" : "select"](name2);
  };
  GeoModel2.prototype.isSelected = function(name2) {
    var selectedMap = this.option.selectedMap;
    return !!(selectedMap && selectedMap[name2]);
  };
  GeoModel2.type = "geo";
  GeoModel2.layoutMode = "box";
  GeoModel2.defaultOption = {
    z: 0,
    show: true,
    left: "center",
    top: "center",
    aspectScale: null,
    silent: false,
    map: "",
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    regions: []
  };
  return GeoModel2;
}(ComponentModel$1);
var GeoModel$1 = GeoModel;
function getCenterCoord(view, point) {
  return view.pointToProjected ? view.pointToProjected(point) : view.pointToData(point);
}
function updateCenterAndZoom(view, payload, zoomLimit) {
  var previousZoom = view.getZoom();
  var center2 = view.getCenter();
  var zoom = payload.zoom;
  var point = view.projectedToPoint ? view.projectedToPoint(center2) : view.dataToPoint(center2);
  if (payload.dx != null && payload.dy != null) {
    point[0] -= payload.dx;
    point[1] -= payload.dy;
    view.setCenter(getCenterCoord(view, point));
  }
  if (zoom != null) {
    if (zoomLimit) {
      var zoomMin = zoomLimit.min || 0;
      var zoomMax = zoomLimit.max || Infinity;
      zoom = Math.max(Math.min(previousZoom * zoom, zoomMax), zoomMin) / previousZoom;
    }
    view.scaleX *= zoom;
    view.scaleY *= zoom;
    var fixX = (payload.originX - view.x) * (zoom - 1);
    var fixY = (payload.originY - view.y) * (zoom - 1);
    view.x -= fixX;
    view.y -= fixY;
    view.updateTransform();
    view.setCenter(getCenterCoord(view, point));
    view.setZoom(zoom * previousZoom);
  }
  return {
    center: view.getCenter(),
    zoom: view.getZoom()
  };
}
var GeoView = function(_super) {
  __extends(GeoView2, _super);
  function GeoView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoView2.type;
    _this.focusBlurEnabled = true;
    return _this;
  }
  GeoView2.prototype.init = function(ecModel, api) {
    this._api = api;
  };
  GeoView2.prototype.render = function(geoModel, ecModel, api, payload) {
    this._model = geoModel;
    if (!geoModel.get("show")) {
      this._mapDraw && this._mapDraw.remove();
      this._mapDraw = null;
      return;
    }
    if (!this._mapDraw) {
      this._mapDraw = new MapDraw$1(api);
    }
    var mapDraw = this._mapDraw;
    mapDraw.draw(geoModel, ecModel, api, this, payload);
    mapDraw.group.on("click", this._handleRegionClick, this);
    mapDraw.group.silent = geoModel.get("silent");
    this.group.add(mapDraw.group);
    this.updateSelectStatus(geoModel, ecModel, api);
  };
  GeoView2.prototype._handleRegionClick = function(e2) {
    var eventData;
    findEventDispatcher(e2.target, function(current2) {
      return (eventData = getECData(current2).eventData) != null;
    }, true);
    if (eventData) {
      this._api.dispatchAction({
        type: "geoToggleSelect",
        geoId: this._model.id,
        name: eventData.name
      });
    }
  };
  GeoView2.prototype.updateSelectStatus = function(model, ecModel, api) {
    var _this = this;
    this._mapDraw.group.traverse(function(node) {
      var eventData = getECData(node).eventData;
      if (eventData) {
        _this._model.isSelected(eventData.name) ? api.enterSelect(node) : api.leaveSelect(node);
        return true;
      }
    });
  };
  GeoView2.prototype.findHighDownDispatchers = function(name2) {
    return this._mapDraw && this._mapDraw.findHighDownDispatchers(name2, this._model);
  };
  GeoView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
  };
  GeoView2.type = "geo";
  return GeoView2;
}(ComponentView$1);
var GeoView$1 = GeoView;
function registerMap(mapName, geoJson, specialAreas) {
  geoSourceManager.registerMap(mapName, geoJson, specialAreas);
}
function install$J(registers) {
  registers.registerCoordinateSystem("geo", geoCreator$1);
  registers.registerComponentModel(GeoModel$1);
  registers.registerComponentView(GeoView$1);
  registers.registerImpl("registerMap", registerMap);
  registers.registerImpl("getMap", function(mapName) {
    return geoSourceManager.getMapForUser(mapName);
  });
  function makeAction(method4, actionInfo2) {
    actionInfo2.update = "geo:updateSelectStatus";
    registers.registerAction(actionInfo2, function(payload, ecModel) {
      var selected = {};
      var allSelected = [];
      ecModel.eachComponent({
        mainType: "geo",
        query: payload
      }, function(geoModel) {
        geoModel[method4](payload.name);
        var geo = geoModel.coordinateSystem;
        each$g(geo.regions, function(region) {
          selected[region.name] = geoModel.isSelected(region.name) || false;
        });
        var names2 = [];
        each$g(selected, function(v4, name2) {
          selected[name2] && names2.push(name2);
        });
        allSelected.push({
          geoIndex: geoModel.componentIndex,
          name: names2
        });
      });
      return {
        selected,
        allSelected,
        name: payload.name
      };
    });
  }
  makeAction("toggleSelected", {
    type: "geoToggleSelect",
    event: "geoselectchanged"
  });
  makeAction("select", {
    type: "geoSelect",
    event: "geoselected"
  });
  makeAction("unSelect", {
    type: "geoUnSelect",
    event: "geounselected"
  });
  registers.registerAction({
    type: "geoRoam",
    event: "geoRoam",
    update: "updateTransform"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      var geo = componentModel.coordinateSystem;
      if (geo.type !== "geo") {
        return;
      }
      var res2 = updateCenterAndZoom(geo, payload, componentModel.get("scaleLimit"));
      componentModel.setCenter && componentModel.setCenter(res2.center);
      componentModel.setZoom && componentModel.setZoom(res2.zoom);
      if (componentType === "series") {
        each$g(componentModel.seriesGroup, function(seriesModel) {
          seriesModel.setCenter(res2.center);
          seriesModel.setZoom(res2.zoom);
        });
      }
    });
  });
}
function install$I(registers) {
  use(install$J);
  registers.registerChartView(MapView$1);
  registers.registerSeriesModel(MapSeries$1);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
function init$1(inRoot) {
  var root2 = inRoot;
  root2.hierNode = {
    defaultAncestor: null,
    ancestor: root2,
    prelim: 0,
    modifier: 0,
    change: 0,
    shift: 0,
    i: 0,
    thread: null
  };
  var nodes = [root2];
  var node;
  var children;
  while (node = nodes.pop()) {
    children = node.children;
    if (node.isExpand && children.length) {
      var n2 = children.length;
      for (var i = n2 - 1; i >= 0; i--) {
        var child = children[i];
        child.hierNode = {
          defaultAncestor: null,
          ancestor: child,
          prelim: 0,
          modifier: 0,
          change: 0,
          shift: 0,
          i,
          thread: null
        };
        nodes.push(child);
      }
    }
  }
}
function firstWalk(node, separation2) {
  var children = node.isExpand ? node.children : [];
  var siblings = node.parentNode.children;
  var subtreeW = node.hierNode.i ? siblings[node.hierNode.i - 1] : null;
  if (children.length) {
    executeShifts(node);
    var midPoint = (children[0].hierNode.prelim + children[children.length - 1].hierNode.prelim) / 2;
    if (subtreeW) {
      node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
      node.hierNode.modifier = node.hierNode.prelim - midPoint;
    } else {
      node.hierNode.prelim = midPoint;
    }
  } else if (subtreeW) {
    node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
  }
  node.parentNode.hierNode.defaultAncestor = apportion(node, subtreeW, node.parentNode.hierNode.defaultAncestor || siblings[0], separation2);
}
function secondWalk(node) {
  var nodeX = node.hierNode.prelim + node.parentNode.hierNode.modifier;
  node.setLayout({
    x: nodeX
  }, true);
  node.hierNode.modifier += node.parentNode.hierNode.modifier;
}
function separation(cb2) {
  return arguments.length ? cb2 : defaultSeparation;
}
function radialCoordinate(rad, r2) {
  rad -= Math.PI / 2;
  return {
    x: r2 * Math.cos(rad),
    y: r2 * Math.sin(rad)
  };
}
function getViewRect$4(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function executeShifts(node) {
  var children = node.children;
  var n2 = children.length;
  var shift = 0;
  var change = 0;
  while (--n2 >= 0) {
    var child = children[n2];
    child.hierNode.prelim += shift;
    child.hierNode.modifier += shift;
    change += child.hierNode.change;
    shift += child.hierNode.shift + change;
  }
}
function apportion(subtreeV, subtreeW, ancestor, separation2) {
  if (subtreeW) {
    var nodeOutRight = subtreeV;
    var nodeInRight = subtreeV;
    var nodeOutLeft = nodeInRight.parentNode.children[0];
    var nodeInLeft = subtreeW;
    var sumOutRight = nodeOutRight.hierNode.modifier;
    var sumInRight = nodeInRight.hierNode.modifier;
    var sumOutLeft = nodeOutLeft.hierNode.modifier;
    var sumInLeft = nodeInLeft.hierNode.modifier;
    while (nodeInLeft = nextRight(nodeInLeft), nodeInRight = nextLeft(nodeInRight), nodeInLeft && nodeInRight) {
      nodeOutRight = nextRight(nodeOutRight);
      nodeOutLeft = nextLeft(nodeOutLeft);
      nodeOutRight.hierNode.ancestor = subtreeV;
      var shift = nodeInLeft.hierNode.prelim + sumInLeft - nodeInRight.hierNode.prelim - sumInRight + separation2(nodeInLeft, nodeInRight);
      if (shift > 0) {
        moveSubtree(nextAncestor(nodeInLeft, subtreeV, ancestor), subtreeV, shift);
        sumInRight += shift;
        sumOutRight += shift;
      }
      sumInLeft += nodeInLeft.hierNode.modifier;
      sumInRight += nodeInRight.hierNode.modifier;
      sumOutRight += nodeOutRight.hierNode.modifier;
      sumOutLeft += nodeOutLeft.hierNode.modifier;
    }
    if (nodeInLeft && !nextRight(nodeOutRight)) {
      nodeOutRight.hierNode.thread = nodeInLeft;
      nodeOutRight.hierNode.modifier += sumInLeft - sumOutRight;
    }
    if (nodeInRight && !nextLeft(nodeOutLeft)) {
      nodeOutLeft.hierNode.thread = nodeInRight;
      nodeOutLeft.hierNode.modifier += sumInRight - sumOutLeft;
      ancestor = subtreeV;
    }
  }
  return ancestor;
}
function nextRight(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[children.length - 1] : node.hierNode.thread;
}
function nextLeft(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[0] : node.hierNode.thread;
}
function nextAncestor(nodeInLeft, node, ancestor) {
  return nodeInLeft.hierNode.ancestor.parentNode === node.parentNode ? nodeInLeft.hierNode.ancestor : ancestor;
}
function moveSubtree(wl, wr, shift) {
  var change = shift / (wr.hierNode.i - wl.hierNode.i);
  wr.hierNode.change -= change;
  wr.hierNode.shift += shift;
  wr.hierNode.modifier += shift;
  wr.hierNode.prelim += shift;
  wl.hierNode.change += change;
}
function defaultSeparation(node1, node2) {
  return node1.parentNode === node2.parentNode ? 1 : 2;
}
var TreeEdgeShape = function() {
  function TreeEdgeShape2() {
    this.parentPoint = [];
    this.childPoints = [];
  }
  return TreeEdgeShape2;
}();
var TreePath = function(_super) {
  __extends(TreePath2, _super);
  function TreePath2(opts) {
    return _super.call(this, opts) || this;
  }
  TreePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  TreePath2.prototype.getDefaultShape = function() {
    return new TreeEdgeShape();
  };
  TreePath2.prototype.buildPath = function(ctx, shape) {
    var childPoints = shape.childPoints;
    var childLen = childPoints.length;
    var parentPoint = shape.parentPoint;
    var firstChildPos = childPoints[0];
    var lastChildPos = childPoints[childLen - 1];
    if (childLen === 1) {
      ctx.moveTo(parentPoint[0], parentPoint[1]);
      ctx.lineTo(firstChildPos[0], firstChildPos[1]);
      return;
    }
    var orient = shape.orient;
    var forkDim = orient === "TB" || orient === "BT" ? 0 : 1;
    var otherDim = 1 - forkDim;
    var forkPosition = parsePercent(shape.forkPosition, 1);
    var tmpPoint = [];
    tmpPoint[forkDim] = parentPoint[forkDim];
    tmpPoint[otherDim] = parentPoint[otherDim] + (lastChildPos[otherDim] - parentPoint[otherDim]) * forkPosition;
    ctx.moveTo(parentPoint[0], parentPoint[1]);
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.moveTo(firstChildPos[0], firstChildPos[1]);
    tmpPoint[forkDim] = firstChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    tmpPoint[forkDim] = lastChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.lineTo(lastChildPos[0], lastChildPos[1]);
    for (var i = 1; i < childLen - 1; i++) {
      var point = childPoints[i];
      ctx.moveTo(point[0], point[1]);
      tmpPoint[forkDim] = point[forkDim];
      ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    }
  };
  return TreePath2;
}(Path$1);
var TreeView = function(_super) {
  __extends(TreeView2, _super);
  function TreeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreeView2.type;
    _this._mainGroup = new Group$6();
    return _this;
  }
  TreeView2.prototype.init = function(ecModel, api) {
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: this.group
    };
    this.group.add(this._mainGroup);
  };
  TreeView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var layoutInfo = seriesModel.layoutInfo;
    var group = this._mainGroup;
    var layout2 = seriesModel.get("layout");
    if (layout2 === "radial") {
      group.x = layoutInfo.x + layoutInfo.width / 2;
      group.y = layoutInfo.y + layoutInfo.height / 2;
    } else {
      group.x = layoutInfo.x;
      group.y = layoutInfo.y;
    }
    this._updateViewCoordSys(seriesModel);
    this._updateController(seriesModel, ecModel, api);
    var oldData = this._data;
    data2.diff(oldData).add(function(newIdx) {
      if (symbolNeedsDraw(data2, newIdx)) {
        updateNode(data2, newIdx, null, group, seriesModel);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!symbolNeedsDraw(data2, newIdx)) {
        symbolEl && removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
        return;
      }
      updateNode(data2, newIdx, symbolEl, group, seriesModel);
    }).remove(function(oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (symbolEl) {
        removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
      }
    }).execute();
    this._nodeScaleRatio = seriesModel.get("nodeScaleRatio");
    this._updateNodeAndLinkScale(seriesModel);
    if (seriesModel.get("expandAndCollapse") === true) {
      data2.eachItemGraphicEl(function(el, dataIndex) {
        el.off("click").on("click", function() {
          api.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: seriesModel.id,
            dataIndex
          });
        });
      });
    }
    this._data = data2;
  };
  TreeView2.prototype._updateViewCoordSys = function(seriesModel) {
    var data2 = seriesModel.getData();
    var points2 = [];
    data2.each(function(idx) {
      var layout2 = data2.getItemLayout(idx);
      if (layout2 && !isNaN(layout2.x) && !isNaN(layout2.y)) {
        points2.push([+layout2.x, +layout2.y]);
      }
    });
    var min3 = [];
    var max3 = [];
    fromPoints(points2, min3, max3);
    var oldMin = this._min;
    var oldMax = this._max;
    if (max3[0] - min3[0] === 0) {
      min3[0] = oldMin ? oldMin[0] : min3[0] - 1;
      max3[0] = oldMax ? oldMax[0] : max3[0] + 1;
    }
    if (max3[1] - min3[1] === 0) {
      min3[1] = oldMin ? oldMin[1] : min3[1] - 1;
      max3[1] = oldMax ? oldMax[1] : max3[1] + 1;
    }
    var viewCoordSys = seriesModel.coordinateSystem = new View$1();
    viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
    viewCoordSys.setBoundingRect(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    viewCoordSys.setCenter(seriesModel.get("center"));
    viewCoordSys.setZoom(seriesModel.get("zoom"));
    this.group.attr({
      x: viewCoordSys.x,
      y: viewCoordSys.y,
      scaleX: viewCoordSys.scaleX,
      scaleY: viewCoordSys.scaleY
    });
    this._min = min3;
    this._max = max3;
  };
  TreeView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale(seriesModel);
      api.updateLabelLayout();
    });
  };
  TreeView2.prototype._updateNodeAndLinkScale = function(seriesModel) {
    var data2 = seriesModel.getData();
    var nodeScale = this._getNodeGlobalScale(seriesModel);
    data2.eachItemGraphicEl(function(el, idx) {
      el.setSymbolScale(nodeScale);
    });
  };
  TreeView2.prototype._getNodeGlobalScale = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type !== "view") {
      return 1;
    }
    var nodeScaleRatio = this._nodeScaleRatio;
    var groupZoom = coordSys.scaleX || 1;
    var roamZoom = coordSys.getZoom();
    var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
    return nodeScale / groupZoom;
  };
  TreeView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  TreeView2.prototype.remove = function() {
    this._mainGroup.removeAll();
    this._data = null;
  };
  TreeView2.type = "tree";
  return TreeView2;
}(ChartView$1);
function symbolNeedsDraw(data2, dataIndex) {
  var layout2 = data2.getItemLayout(dataIndex);
  return layout2 && !isNaN(layout2.x) && !isNaN(layout2.y);
}
function updateNode(data2, dataIndex, symbolEl, group, seriesModel) {
  var isInit = !symbolEl;
  var node = data2.tree.getNodeByDataIndex(dataIndex);
  var itemModel = node.getModel();
  var visualColor = node.getVisual("style").fill;
  var symbolInnerColor = node.isExpand === false && node.children.length !== 0 ? visualColor : "#fff";
  var virtualRoot = data2.tree.root;
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceSymbolEl = data2.getItemGraphicEl(source.dataIndex);
  var sourceLayout = source.getLayout();
  var sourceOldLayout = sourceSymbolEl ? {
    x: sourceSymbolEl.__oldX,
    y: sourceSymbolEl.__oldY,
    rawX: sourceSymbolEl.__radialOldRawX,
    rawY: sourceSymbolEl.__radialOldRawY
  } : sourceLayout;
  var targetLayout = node.getLayout();
  if (isInit) {
    symbolEl = new SymbolClz(data2, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
    symbolEl.x = sourceOldLayout.x;
    symbolEl.y = sourceOldLayout.y;
  } else {
    symbolEl.updateData(data2, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
  }
  symbolEl.__radialOldRawX = symbolEl.__radialRawX;
  symbolEl.__radialOldRawY = symbolEl.__radialRawY;
  symbolEl.__radialRawX = targetLayout.rawX;
  symbolEl.__radialRawY = targetLayout.rawY;
  group.add(symbolEl);
  data2.setItemGraphicEl(dataIndex, symbolEl);
  symbolEl.__oldX = symbolEl.x;
  symbolEl.__oldY = symbolEl.y;
  updateProps$1(symbolEl, {
    x: targetLayout.x,
    y: targetLayout.y
  }, seriesModel);
  var symbolPath = symbolEl.getSymbolPath();
  if (seriesModel.get("layout") === "radial") {
    var realRoot = virtualRoot.children[0];
    var rootLayout = realRoot.getLayout();
    var length_1 = realRoot.children.length;
    var rad = void 0;
    var isLeft = void 0;
    if (targetLayout.x === rootLayout.x && node.isExpand === true) {
      var center2 = {
        x: (realRoot.children[0].getLayout().x + realRoot.children[length_1 - 1].getLayout().x) / 2,
        y: (realRoot.children[0].getLayout().y + realRoot.children[length_1 - 1].getLayout().y) / 2
      };
      rad = Math.atan2(center2.y - rootLayout.y, center2.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      isLeft = center2.x < rootLayout.x;
      if (isLeft) {
        rad = rad - Math.PI;
      }
    } else {
      rad = Math.atan2(targetLayout.y - rootLayout.y, targetLayout.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      if (node.children.length === 0 || node.children.length !== 0 && node.isExpand === false) {
        isLeft = targetLayout.x < rootLayout.x;
        if (isLeft) {
          rad = rad - Math.PI;
        }
      } else {
        isLeft = targetLayout.x > rootLayout.x;
        if (!isLeft) {
          rad = rad - Math.PI;
        }
      }
    }
    var textPosition = isLeft ? "left" : "right";
    var normalLabelModel = itemModel.getModel("label");
    var rotate2 = normalLabelModel.get("rotate");
    var labelRotateRadian = rotate2 * (Math.PI / 180);
    var textContent = symbolPath.getTextContent();
    if (textContent) {
      symbolPath.setTextConfig({
        position: normalLabelModel.get("position") || textPosition,
        rotation: rotate2 == null ? -rad : labelRotateRadian,
        origin: "center"
      });
      textContent.setStyle("verticalAlign", "middle");
    }
  }
  var focus = itemModel.get(["emphasis", "focus"]);
  var focusDataIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : null;
  if (focusDataIndices) {
    getECData(symbolEl).focus = focusDataIndices;
  }
  drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group);
  if (symbolEl.__edge) {
    symbolEl.onHoverStateChange = function(toState) {
      if (toState !== "blur") {
        var parentEl = node.parentNode && data2.getItemGraphicEl(node.parentNode.dataIndex);
        if (!(parentEl && parentEl.hoverState === HOVER_STATE_BLUR)) {
          setStatesFlag(symbolEl.__edge, toState);
        }
      }
    };
  }
}
function drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group) {
  var itemModel = node.getModel();
  var edgeShape = seriesModel.get("edgeShape");
  var layout2 = seriesModel.get("layout");
  var orient = seriesModel.getOrient();
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  var edgeForkPosition = seriesModel.get("edgeForkPosition");
  var lineStyle = itemModel.getModel("lineStyle").getLineStyle();
  var edge = symbolEl.__edge;
  if (edgeShape === "curve") {
    if (node.parentNode && node.parentNode !== virtualRoot) {
      if (!edge) {
        edge = symbolEl.__edge = new BezierCurve$1({
          shape: getEdgeShape(layout2, orient, curvature, sourceOldLayout, sourceOldLayout)
        });
      }
      updateProps$1(edge, {
        shape: getEdgeShape(layout2, orient, curvature, sourceLayout, targetLayout)
      }, seriesModel);
    }
  } else if (edgeShape === "polyline") {
    if (layout2 === "orthogonal") {
      if (node !== virtualRoot && node.children && node.children.length !== 0 && node.isExpand === true) {
        var children = node.children;
        var childPoints = [];
        for (var i = 0; i < children.length; i++) {
          var childLayout = children[i].getLayout();
          childPoints.push([childLayout.x, childLayout.y]);
        }
        if (!edge) {
          edge = symbolEl.__edge = new TreePath({
            shape: {
              parentPoint: [targetLayout.x, targetLayout.y],
              childPoints: [[targetLayout.x, targetLayout.y]],
              orient,
              forkPosition: edgeForkPosition
            }
          });
        }
        updateProps$1(edge, {
          shape: {
            parentPoint: [targetLayout.x, targetLayout.y],
            childPoints
          }
        }, seriesModel);
      }
    }
  }
  if (edge) {
    edge.useStyle(defaults({
      strokeNoScale: true,
      fill: null
    }, lineStyle));
    setStatesStylesFromModel(edge, itemModel, "lineStyle");
    setDefaultStateProxy(edge);
    group.add(edge);
  }
}
function removeNodeEdge(node, data2, group, seriesModel, removeAnimationOpt) {
  var virtualRoot = data2.tree.root;
  var _a2 = getSourceNode(virtualRoot, node), source = _a2.source, sourceLayout = _a2.sourceLayout;
  var symbolEl = data2.getItemGraphicEl(node.dataIndex);
  if (!symbolEl) {
    return;
  }
  var sourceSymbolEl = data2.getItemGraphicEl(source.dataIndex);
  var sourceEdge = sourceSymbolEl.__edge;
  var edge = symbolEl.__edge || (source.isExpand === false || source.children.length === 1 ? sourceEdge : void 0);
  var edgeShape = seriesModel.get("edgeShape");
  var layoutOpt = seriesModel.get("layout");
  var orient = seriesModel.get("orient");
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  if (edge) {
    if (edgeShape === "curve") {
      removeElement(edge, {
        shape: getEdgeShape(layoutOpt, orient, curvature, sourceLayout, sourceLayout),
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    } else if (edgeShape === "polyline" && seriesModel.get("layout") === "orthogonal") {
      removeElement(edge, {
        shape: {
          parentPoint: [sourceLayout.x, sourceLayout.y],
          childPoints: [[sourceLayout.x, sourceLayout.y]]
        },
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    }
  }
}
function getSourceNode(virtualRoot, node) {
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceLayout;
  while (sourceLayout = source.getLayout(), sourceLayout == null) {
    source = source.parentNode === virtualRoot ? source : source.parentNode || source;
  }
  return {
    source,
    sourceLayout
  };
}
function removeNode(data2, dataIndex, symbolEl, group, seriesModel) {
  var node = data2.tree.getNodeByDataIndex(dataIndex);
  var virtualRoot = data2.tree.root;
  var sourceLayout = getSourceNode(virtualRoot, node).sourceLayout;
  var removeAnimationOpt = {
    duration: seriesModel.get("animationDurationUpdate"),
    easing: seriesModel.get("animationEasingUpdate")
  };
  removeElement(symbolEl, {
    x: sourceLayout.x + 1,
    y: sourceLayout.y + 1
  }, seriesModel, {
    cb: function() {
      group.remove(symbolEl);
      data2.setItemGraphicEl(dataIndex, null);
    },
    removeOpt: removeAnimationOpt
  });
  symbolEl.fadeOut(null, data2.hostModel, {
    fadeLabel: true,
    animation: removeAnimationOpt
  });
  node.children.forEach(function(childNode) {
    removeNodeEdge(childNode, data2, group, seriesModel, removeAnimationOpt);
  });
  removeNodeEdge(node, data2, group, seriesModel, removeAnimationOpt);
}
function getEdgeShape(layoutOpt, orient, curvature, sourceLayout, targetLayout) {
  var cpx1;
  var cpy1;
  var cpx2;
  var cpy2;
  var x1;
  var x2;
  var y1;
  var y2;
  if (layoutOpt === "radial") {
    x1 = sourceLayout.rawX;
    y1 = sourceLayout.rawY;
    x2 = targetLayout.rawX;
    y2 = targetLayout.rawY;
    var radialCoor1 = radialCoordinate(x1, y1);
    var radialCoor2 = radialCoordinate(x1, y1 + (y2 - y1) * curvature);
    var radialCoor3 = radialCoordinate(x2, y2 + (y1 - y2) * curvature);
    var radialCoor4 = radialCoordinate(x2, y2);
    return {
      x1: radialCoor1.x || 0,
      y1: radialCoor1.y || 0,
      x2: radialCoor4.x || 0,
      y2: radialCoor4.y || 0,
      cpx1: radialCoor2.x || 0,
      cpy1: radialCoor2.y || 0,
      cpx2: radialCoor3.x || 0,
      cpy2: radialCoor3.y || 0
    };
  } else {
    x1 = sourceLayout.x;
    y1 = sourceLayout.y;
    x2 = targetLayout.x;
    y2 = targetLayout.y;
    if (orient === "LR" || orient === "RL") {
      cpx1 = x1 + (x2 - x1) * curvature;
      cpy1 = y1;
      cpx2 = x2 + (x1 - x2) * curvature;
      cpy2 = y2;
    }
    if (orient === "TB" || orient === "BT") {
      cpx1 = x1;
      cpy1 = y1 + (y2 - y1) * curvature;
      cpx2 = x2;
      cpy2 = y2 + (y1 - y2) * curvature;
    }
  }
  return {
    x1,
    y1,
    x2,
    y2,
    cpx1,
    cpy1,
    cpx2,
    cpy2
  };
}
var TreeView$1 = TreeView;
var inner$e = makeInner();
function linkSeriesData(opt) {
  var mainData = opt.mainData;
  var datas = opt.datas;
  if (!datas) {
    datas = {
      main: mainData
    };
    opt.datasAttr = {
      main: "data"
    };
  }
  opt.datas = opt.mainData = null;
  linkAll(mainData, datas, opt);
  each$g(datas, function(data2) {
    each$g(mainData.TRANSFERABLE_METHODS, function(methodName) {
      data2.wrapMethod(methodName, curry$3(transferInjection, opt));
    });
  });
  mainData.wrapMethod("cloneShallow", curry$3(cloneShallowInjection, opt));
  each$g(mainData.CHANGABLE_METHODS, function(methodName) {
    mainData.wrapMethod(methodName, curry$3(changeInjection, opt));
  });
  assert(datas[mainData.dataType] === mainData);
}
function transferInjection(opt, res2) {
  if (isMainData(this)) {
    var datas = extend({}, inner$e(this).datas);
    datas[this.dataType] = res2;
    linkAll(res2, datas, opt);
  } else {
    linkSingle(res2, this.dataType, inner$e(this).mainData, opt);
  }
  return res2;
}
function changeInjection(opt, res2) {
  opt.struct && opt.struct.update();
  return res2;
}
function cloneShallowInjection(opt, res2) {
  each$g(inner$e(res2).datas, function(data2, dataType) {
    data2 !== res2 && linkSingle(data2.cloneShallow(), dataType, res2, opt);
  });
  return res2;
}
function getLinkedData(dataType) {
  var mainData = inner$e(this).mainData;
  return dataType == null || mainData == null ? mainData : inner$e(mainData).datas[dataType];
}
function getLinkedDataAll() {
  var mainData = inner$e(this).mainData;
  return mainData == null ? [{
    data: mainData
  }] : map$1(keys(inner$e(mainData).datas), function(type4) {
    return {
      type: type4,
      data: inner$e(mainData).datas[type4]
    };
  });
}
function isMainData(data2) {
  return inner$e(data2).mainData === data2;
}
function linkAll(mainData, datas, opt) {
  inner$e(mainData).datas = {};
  each$g(datas, function(data2, dataType) {
    linkSingle(data2, dataType, mainData, opt);
  });
}
function linkSingle(data2, dataType, mainData, opt) {
  inner$e(mainData).datas[dataType] = data2;
  inner$e(data2).mainData = mainData;
  data2.dataType = dataType;
  if (opt.struct) {
    data2[opt.structAttr] = opt.struct;
    opt.struct[opt.datasAttr[dataType]] = data2;
  }
  data2.getLinkedData = getLinkedData;
  data2.getLinkedDataAll = getLinkedDataAll;
}
var TreeNode = function() {
  function TreeNode2(name2, hostTree) {
    this.depth = 0;
    this.height = 0;
    this.dataIndex = -1;
    this.children = [];
    this.viewChildren = [];
    this.isExpand = false;
    this.name = name2 || "";
    this.hostTree = hostTree;
  }
  TreeNode2.prototype.isRemoved = function() {
    return this.dataIndex < 0;
  };
  TreeNode2.prototype.eachNode = function(options, cb2, context) {
    if (isFunction$1(options)) {
      context = cb2;
      cb2 = options;
      options = null;
    }
    options = options || {};
    if (isString$1(options)) {
      options = {
        order: options
      };
    }
    var order = options.order || "preorder";
    var children = this[options.attr || "children"];
    var suppressVisitSub;
    order === "preorder" && (suppressVisitSub = cb2.call(context, this));
    for (var i = 0; !suppressVisitSub && i < children.length; i++) {
      children[i].eachNode(options, cb2, context);
    }
    order === "postorder" && cb2.call(context, this);
  };
  TreeNode2.prototype.updateDepthAndHeight = function(depth) {
    var height = 0;
    this.depth = depth;
    for (var i = 0; i < this.children.length; i++) {
      var child = this.children[i];
      child.updateDepthAndHeight(depth + 1);
      if (child.height > height) {
        height = child.height;
      }
    }
    this.height = height + 1;
  };
  TreeNode2.prototype.getNodeById = function(id2) {
    if (this.getId() === id2) {
      return this;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res2 = children[i].getNodeById(id2);
      if (res2) {
        return res2;
      }
    }
  };
  TreeNode2.prototype.contains = function(node) {
    if (node === this) {
      return true;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res2 = children[i].contains(node);
      if (res2) {
        return res2;
      }
    }
  };
  TreeNode2.prototype.getAncestors = function(includeSelf) {
    var ancestors = [];
    var node = includeSelf ? this : this.parentNode;
    while (node) {
      ancestors.push(node);
      node = node.parentNode;
    }
    ancestors.reverse();
    return ancestors;
  };
  TreeNode2.prototype.getAncestorsIndices = function() {
    var indices = [];
    var currNode = this;
    while (currNode) {
      indices.push(currNode.dataIndex);
      currNode = currNode.parentNode;
    }
    indices.reverse();
    return indices;
  };
  TreeNode2.prototype.getDescendantIndices = function() {
    var indices = [];
    this.eachNode(function(childNode) {
      indices.push(childNode.dataIndex);
    });
    return indices;
  };
  TreeNode2.prototype.getValue = function(dimension) {
    var data2 = this.hostTree.data;
    return data2.getStore().get(data2.getDimensionIndex(dimension || "value"), this.dataIndex);
  };
  TreeNode2.prototype.setLayout = function(layout2, merge3) {
    this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, layout2, merge3);
  };
  TreeNode2.prototype.getLayout = function() {
    return this.hostTree.data.getItemLayout(this.dataIndex);
  };
  TreeNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var hostTree = this.hostTree;
    var itemModel = hostTree.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  TreeNode2.prototype.getLevelModel = function() {
    return (this.hostTree.levelModels || [])[this.depth];
  };
  TreeNode2.prototype.setVisual = function(key, value) {
    this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, key, value);
  };
  TreeNode2.prototype.getVisual = function(key) {
    return this.hostTree.data.getItemVisual(this.dataIndex, key);
  };
  TreeNode2.prototype.getRawIndex = function() {
    return this.hostTree.data.getRawIndex(this.dataIndex);
  };
  TreeNode2.prototype.getId = function() {
    return this.hostTree.data.getId(this.dataIndex);
  };
  TreeNode2.prototype.getChildIndex = function() {
    if (this.parentNode) {
      var children = this.parentNode.children;
      for (var i = 0; i < children.length; ++i) {
        if (children[i] === this) {
          return i;
        }
      }
      return -1;
    }
    return -1;
  };
  TreeNode2.prototype.isAncestorOf = function(node) {
    var parent = node.parentNode;
    while (parent) {
      if (parent === this) {
        return true;
      }
      parent = parent.parentNode;
    }
    return false;
  };
  TreeNode2.prototype.isDescendantOf = function(node) {
    return node !== this && node.isAncestorOf(this);
  };
  return TreeNode2;
}();
var Tree = function() {
  function Tree2(hostModel) {
    this.type = "tree";
    this._nodes = [];
    this.hostModel = hostModel;
  }
  Tree2.prototype.eachNode = function(options, cb2, context) {
    this.root.eachNode(options, cb2, context);
  };
  Tree2.prototype.getNodeByDataIndex = function(dataIndex) {
    var rawIndex = this.data.getRawIndex(dataIndex);
    return this._nodes[rawIndex];
  };
  Tree2.prototype.getNodeById = function(name2) {
    return this.root.getNodeById(name2);
  };
  Tree2.prototype.update = function() {
    var data2 = this.data;
    var nodes = this._nodes;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data2.count(); i < len2; i++) {
      nodes[data2.getRawIndex(i)].dataIndex = i;
    }
  };
  Tree2.prototype.clearLayouts = function() {
    this.data.clearItemLayouts();
  };
  Tree2.createTree = function(dataRoot, hostModel, beforeLink) {
    var tree = new Tree2(hostModel);
    var listData = [];
    var dimMax = 1;
    buildHierarchy(dataRoot);
    function buildHierarchy(dataNode, parentNode2) {
      var value = dataNode.value;
      dimMax = Math.max(dimMax, isArray$2(value) ? value.length : 1);
      listData.push(dataNode);
      var node = new TreeNode(convertOptionIdName(dataNode.name, ""), tree);
      parentNode2 ? addChild(node, parentNode2) : tree.root = node;
      tree._nodes.push(node);
      var children = dataNode.children;
      if (children) {
        for (var i = 0; i < children.length; i++) {
          buildHierarchy(children[i], node);
        }
      }
    }
    tree.root.updateDepthAndHeight(0);
    var dimensions = prepareSeriesDataSchema(listData, {
      coordDimensions: ["value"],
      dimensionsCount: dimMax
    }).dimensions;
    var list = new SeriesData$1(dimensions, hostModel);
    list.initData(listData);
    beforeLink && beforeLink(list);
    linkSeriesData({
      mainData: list,
      struct: tree,
      structAttr: "tree"
    });
    tree.update();
    return tree;
  };
  return Tree2;
}();
function addChild(child, node) {
  var children = node.children;
  if (child.parentNode === node) {
    return;
  }
  children.push(child);
  child.parentNode = node;
}
var Tree$1 = Tree;
function retrieveTargetInfo(payload, validPayloadTypes, seriesModel) {
  if (payload && indexOf(validPayloadTypes, payload.type) >= 0) {
    var root2 = seriesModel.getData().tree.root;
    var targetNode = payload.targetNode;
    if (isString$1(targetNode)) {
      targetNode = root2.getNodeById(targetNode);
    }
    if (targetNode && root2.contains(targetNode)) {
      return {
        node: targetNode
      };
    }
    var targetNodeId = payload.targetNodeId;
    if (targetNodeId != null && (targetNode = root2.getNodeById(targetNodeId))) {
      return {
        node: targetNode
      };
    }
  }
}
function getPathToRoot(node) {
  var path = [];
  while (node) {
    node = node.parentNode;
    node && path.push(node);
  }
  return path.reverse();
}
function aboveViewRoot(viewRoot, node) {
  var viewPath = getPathToRoot(viewRoot);
  return indexOf(viewPath, node) >= 0;
}
function wrapTreePathInfo(node, seriesModel) {
  var treePathInfo = [];
  while (node) {
    var nodeDataIndex = node.dataIndex;
    treePathInfo.push({
      name: node.name,
      dataIndex: nodeDataIndex,
      value: seriesModel.getRawValue(nodeDataIndex)
    });
    node = node.parentNode;
  }
  treePathInfo.reverse();
  return treePathInfo;
}
var TreeSeriesModel = function(_super) {
  __extends(TreeSeriesModel2, _super);
  function TreeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.hasSymbolVisual = true;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  TreeSeriesModel2.prototype.getInitialData = function(option) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    var leaves = option.leaves || {};
    var leavesModel = new Model$1(leaves, this, this.ecModel);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        if (!(node && node.children.length && node.isExpand)) {
          model.parentModel = leavesModel;
        }
        return model;
      });
    }
    var treeDepth = 0;
    tree.eachNode("preorder", function(node) {
      if (node.depth > treeDepth) {
        treeDepth = node.depth;
      }
    });
    var expandAndCollapse = option.expandAndCollapse;
    var expandTreeDepth = expandAndCollapse && option.initialTreeDepth >= 0 ? option.initialTreeDepth : treeDepth;
    tree.root.eachNode("preorder", function(node) {
      var item = node.hostTree.data.getRawDataItem(node.dataIndex);
      node.isExpand = item && item.collapsed != null ? !item.collapsed : node.depth <= expandTreeDepth;
    });
    return tree.data;
  };
  TreeSeriesModel2.prototype.getOrient = function() {
    var orient = this.get("orient");
    if (orient === "horizontal") {
      orient = "LR";
    } else if (orient === "vertical") {
      orient = "TB";
    }
    return orient;
  };
  TreeSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  TreeSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  TreeSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var tree = this.getData().tree;
    var realRoot = tree.root.children[0];
    var node = tree.getNodeByDataIndex(dataIndex);
    var value = node.getValue();
    var name2 = node.name;
    while (node && node !== realRoot) {
      name2 = node.parentNode.name + "." + name2;
      node = node.parentNode;
    }
    return createTooltipMarkup("nameValue", {
      name: name2,
      value,
      noValue: isNaN(value) || value == null
    });
  };
  TreeSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    return params;
  };
  TreeSeriesModel2.type = "series.tree";
  TreeSeriesModel2.layoutMode = "box";
  TreeSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "12%",
    top: "12%",
    right: "12%",
    bottom: "12%",
    layout: "orthogonal",
    edgeShape: "curve",
    edgeForkPosition: "50%",
    roam: false,
    nodeScaleRatio: 0.4,
    center: null,
    zoom: 1,
    orient: "LR",
    symbol: "emptyCircle",
    symbolSize: 7,
    expandAndCollapse: true,
    initialTreeDepth: 2,
    lineStyle: {
      color: "#ccc",
      width: 1.5,
      curveness: 0.5
    },
    itemStyle: {
      color: "lightsteelblue",
      borderWidth: 1.5
    },
    label: {
      show: true
    },
    animationEasing: "linear",
    animationDuration: 700,
    animationDurationUpdate: 500
  };
  return TreeSeriesModel2;
}(SeriesModel$1);
var TreeSeriesModel$1 = TreeSeriesModel;
function eachAfter(root2, callback, separation2) {
  var nodes = [root2];
  var next = [];
  var node;
  while (node = nodes.pop()) {
    next.push(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = 0; i < children.length; i++) {
          nodes.push(children[i]);
        }
      }
    }
  }
  while (node = next.pop()) {
    callback(node, separation2);
  }
}
function eachBefore(root2, callback) {
  var nodes = [root2];
  var node;
  while (node = nodes.pop()) {
    callback(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = children.length - 1; i >= 0; i--) {
          nodes.push(children[i]);
        }
      }
    }
  }
}
function treeLayout(ecModel, api) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    commonLayout(seriesModel, api);
  });
}
function commonLayout(seriesModel, api) {
  var layoutInfo = getViewRect$4(seriesModel, api);
  seriesModel.layoutInfo = layoutInfo;
  var layout2 = seriesModel.get("layout");
  var width = 0;
  var height = 0;
  var separation$1 = null;
  if (layout2 === "radial") {
    width = 2 * Math.PI;
    height = Math.min(layoutInfo.height, layoutInfo.width) / 2;
    separation$1 = separation(function(node1, node2) {
      return (node1.parentNode === node2.parentNode ? 1 : 2) / node1.depth;
    });
  } else {
    width = layoutInfo.width;
    height = layoutInfo.height;
    separation$1 = separation();
  }
  var virtualRoot = seriesModel.getData().tree.root;
  var realRoot = virtualRoot.children[0];
  if (realRoot) {
    init$1(virtualRoot);
    eachAfter(realRoot, firstWalk, separation$1);
    virtualRoot.hierNode.modifier = -realRoot.hierNode.prelim;
    eachBefore(realRoot, secondWalk);
    var left_1 = realRoot;
    var right_1 = realRoot;
    var bottom_1 = realRoot;
    eachBefore(realRoot, function(node) {
      var x2 = node.getLayout().x;
      if (x2 < left_1.getLayout().x) {
        left_1 = node;
      }
      if (x2 > right_1.getLayout().x) {
        right_1 = node;
      }
      if (node.depth > bottom_1.depth) {
        bottom_1 = node;
      }
    });
    var delta = left_1 === right_1 ? 1 : separation$1(left_1, right_1) / 2;
    var tx_1 = delta - left_1.getLayout().x;
    var kx_1 = 0;
    var ky_1 = 0;
    var coorX_1 = 0;
    var coorY_1 = 0;
    if (layout2 === "radial") {
      kx_1 = width / (right_1.getLayout().x + delta + tx_1);
      ky_1 = height / (bottom_1.depth - 1 || 1);
      eachBefore(realRoot, function(node) {
        coorX_1 = (node.getLayout().x + tx_1) * kx_1;
        coorY_1 = (node.depth - 1) * ky_1;
        var finalCoor = radialCoordinate(coorX_1, coorY_1);
        node.setLayout({
          x: finalCoor.x,
          y: finalCoor.y,
          rawX: coorX_1,
          rawY: coorY_1
        }, true);
      });
    } else {
      var orient_1 = seriesModel.getOrient();
      if (orient_1 === "RL" || orient_1 === "LR") {
        ky_1 = height / (right_1.getLayout().x + delta + tx_1);
        kx_1 = width / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorY_1 = (node.getLayout().x + tx_1) * ky_1;
          coorX_1 = orient_1 === "LR" ? (node.depth - 1) * kx_1 : width - (node.depth - 1) * kx_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      } else if (orient_1 === "TB" || orient_1 === "BT") {
        kx_1 = width / (right_1.getLayout().x + delta + tx_1);
        ky_1 = height / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorX_1 = (node.getLayout().x + tx_1) * kx_1;
          coorY_1 = orient_1 === "TB" ? (node.depth - 1) * ky_1 : height - (node.depth - 1) * ky_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      }
    }
  }
}
function treeVisual(ecModel) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    var data2 = seriesModel.getData();
    var tree = data2.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style2 = model.getModel("itemStyle").getItemStyle();
      var existsStyle = data2.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style2);
    });
  });
}
function installTreeAction(registers) {
  registers.registerAction({
    type: "treeExpandAndCollapse",
    event: "treeExpandAndCollapse",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var dataIndex = payload.dataIndex;
      var tree = seriesModel.getData().tree;
      var node = tree.getNodeByDataIndex(dataIndex);
      node.isExpand = !node.isExpand;
    });
  });
  registers.registerAction({
    type: "treeRoam",
    event: "treeRoam",
    update: "none"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res2 = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res2.center);
      seriesModel.setZoom && seriesModel.setZoom(res2.zoom);
    });
  });
}
function install$H(registers) {
  registers.registerChartView(TreeView$1);
  registers.registerSeriesModel(TreeSeriesModel$1);
  registers.registerLayout(treeLayout);
  registers.registerVisual(treeVisual);
  installTreeAction(registers);
}
var actionTypes = ["treemapZoomToNode", "treemapRender", "treemapMove"];
function installTreemapAction(registers) {
  for (var i = 0; i < actionTypes.length; i++) {
    registers.registerAction({
      type: actionTypes[i],
      update: "updateView"
    }, noop$1);
  }
  registers.registerAction({
    type: "treemapRootToNode",
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "treemap",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var types2 = ["treemapZoomToNode", "treemapRootToNode"];
      var targetInfo = retrieveTargetInfo(payload, types2, model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
}
function enableAriaDecalForTree(seriesModel) {
  var data2 = seriesModel.getData();
  var tree = data2.tree;
  var decalPaletteScope2 = {};
  tree.eachNode(function(node) {
    var current2 = node;
    while (current2 && current2.depth > 1) {
      current2 = current2.parentNode;
    }
    var decal = getDecalFromPalette(seriesModel.ecModel, current2.name || current2.dataIndex + "", decalPaletteScope2);
    node.setVisual("decal", decal);
  });
}
var TreemapSeriesModel = function(_super) {
  __extends(TreemapSeriesModel2, _super);
  function TreemapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapSeriesModel2.type;
    _this.preventUsingHoverLayer = true;
    return _this;
  }
  TreemapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue$1(root2);
    var levels = option.levels || [];
    var designatedVisualItemStyle = this.designatedVisualItemStyle = {};
    var designatedVisualModel = new Model$1({
      itemStyle: designatedVisualItemStyle
    }, this, ecModel);
    levels = option.levels = setDefault(levels, ecModel);
    var levelModels = map$1(levels || [], function(levelDefine) {
      return new Model$1(levelDefine, designatedVisualModel, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = node ? levelModels[node.depth] : null;
        model.parentModel = levelModel || designatedVisualModel;
        return model;
      });
    }
    return tree.data;
  };
  TreemapSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  TreemapSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var value = this.getRawValue(dataIndex);
    var name2 = data2.getName(dataIndex);
    return createTooltipMarkup("nameValue", {
      name: name2,
      value
    });
  };
  TreemapSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    params.treePathInfo = params.treeAncestors;
    return params;
  };
  TreemapSeriesModel2.prototype.setLayoutInfo = function(layoutInfo) {
    this.layoutInfo = this.layoutInfo || {};
    extend(this.layoutInfo, layoutInfo);
  };
  TreemapSeriesModel2.prototype.mapIdToIndex = function(id2) {
    var idIndexMap = this._idIndexMap;
    if (!idIndexMap) {
      idIndexMap = this._idIndexMap = createHashMap();
      this._idIndexMapCount = 0;
    }
    var index2 = idIndexMap.get(id2);
    if (index2 == null) {
      idIndexMap.set(id2, index2 = this._idIndexMapCount++);
    }
    return index2;
  };
  TreemapSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  TreemapSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  TreemapSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  TreemapSeriesModel2.type = "series.treemap";
  TreemapSeriesModel2.layoutMode = "box";
  TreemapSeriesModel2.defaultOption = {
    progressive: 0,
    left: "center",
    top: "middle",
    width: "80%",
    height: "80%",
    sort: true,
    clipWindow: "origin",
    squareRatio: 0.5 * (1 + Math.sqrt(5)),
    leafDepth: null,
    drillDownIcon: "\u25B6",
    zoomToNodeRatio: 0.32 * 0.32,
    roam: true,
    nodeClick: "zoomToNode",
    animation: true,
    animationDurationUpdate: 900,
    animationEasing: "quinticInOut",
    breadcrumb: {
      show: true,
      height: 22,
      left: "center",
      top: "bottom",
      emptyItemWidth: 25,
      itemStyle: {
        color: "rgba(0,0,0,0.7)",
        textStyle: {
          color: "#fff"
        }
      }
    },
    label: {
      show: true,
      distance: 0,
      padding: 5,
      position: "inside",
      color: "#fff",
      overflow: "truncate"
    },
    upperLabel: {
      show: false,
      position: [0, "50%"],
      height: 20,
      overflow: "truncate",
      verticalAlign: "middle"
    },
    itemStyle: {
      color: null,
      colorAlpha: null,
      colorSaturation: null,
      borderWidth: 0,
      gapWidth: 0,
      borderColor: "#fff",
      borderColorSaturation: null
    },
    emphasis: {
      upperLabel: {
        show: true,
        position: [0, "50%"],
        overflow: "truncate",
        verticalAlign: "middle"
      }
    },
    visualDimension: 0,
    visualMin: null,
    visualMax: null,
    color: [],
    colorAlpha: null,
    colorSaturation: null,
    colorMappingBy: "index",
    visibleMin: 10,
    childrenVisibleMin: null,
    levels: []
  };
  return TreemapSeriesModel2;
}(SeriesModel$1);
function completeTreeValue$1(dataNode) {
  var sum2 = 0;
  each$g(dataNode.children, function(child) {
    completeTreeValue$1(child);
    var childValue = child.value;
    isArray$2(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$2(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$2(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
function setDefault(levels, ecModel) {
  var globalColorList = normalizeToArray(ecModel.get("color"));
  var globalDecalList = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  if (!globalColorList) {
    return;
  }
  levels = levels || [];
  var hasColorDefine;
  var hasDecalDefine;
  each$g(levels, function(levelDefine) {
    var model = new Model$1(levelDefine);
    var modelColor = model.get("color");
    var modelDecal = model.get("decal");
    if (model.get(["itemStyle", "color"]) || modelColor && modelColor !== "none") {
      hasColorDefine = true;
    }
    if (model.get(["itemStyle", "decal"]) || modelDecal && modelDecal !== "none") {
      hasDecalDefine = true;
    }
  });
  var level0 = levels[0] || (levels[0] = {});
  if (!hasColorDefine) {
    level0.color = globalColorList.slice();
  }
  if (!hasDecalDefine && globalDecalList) {
    level0.decal = globalDecalList.slice();
  }
  return levels;
}
var TreemapSeriesModel$1 = TreemapSeriesModel;
var TEXT_PADDING = 8;
var ITEM_GAP = 8;
var ARRAY_LENGTH = 5;
var Breadcrumb = function() {
  function Breadcrumb2(containerGroup) {
    this.group = new Group$6();
    containerGroup.add(this.group);
  }
  Breadcrumb2.prototype.render = function(seriesModel, api, targetNode, onSelect) {
    var model = seriesModel.getModel("breadcrumb");
    var thisGroup = this.group;
    thisGroup.removeAll();
    if (!model.get("show") || !targetNode) {
      return;
    }
    var normalStyleModel = model.getModel("itemStyle");
    var textStyleModel = normalStyleModel.getModel("textStyle");
    var layoutParam = {
      pos: {
        left: model.get("left"),
        right: model.get("right"),
        top: model.get("top"),
        bottom: model.get("bottom")
      },
      box: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      emptyItemWidth: model.get("emptyItemWidth"),
      totalWidth: 0,
      renderList: []
    };
    this._prepare(targetNode, layoutParam, textStyleModel);
    this._renderContent(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect);
    positionElement(thisGroup, layoutParam.pos, layoutParam.box);
  };
  Breadcrumb2.prototype._prepare = function(targetNode, layoutParam, textStyleModel) {
    for (var node = targetNode; node; node = node.parentNode) {
      var text = convertOptionIdName(node.getModel().get("name"), "");
      var textRect = textStyleModel.getTextRect(text);
      var itemWidth = Math.max(textRect.width + TEXT_PADDING * 2, layoutParam.emptyItemWidth);
      layoutParam.totalWidth += itemWidth + ITEM_GAP;
      layoutParam.renderList.push({
        node,
        text,
        width: itemWidth
      });
    }
  };
  Breadcrumb2.prototype._renderContent = function(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect) {
    var lastX = 0;
    var emptyItemWidth = layoutParam.emptyItemWidth;
    var height = seriesModel.get(["breadcrumb", "height"]);
    var availableSize = getAvailableSize(layoutParam.pos, layoutParam.box);
    var totalWidth = layoutParam.totalWidth;
    var renderList = layoutParam.renderList;
    for (var i = renderList.length - 1; i >= 0; i--) {
      var item = renderList[i];
      var itemNode = item.node;
      var itemWidth = item.width;
      var text = item.text;
      if (totalWidth > availableSize.width) {
        totalWidth -= itemWidth - emptyItemWidth;
        itemWidth = emptyItemWidth;
        text = null;
      }
      var el = new Polygon$1({
        shape: {
          points: makeItemPoints(lastX, 0, itemWidth, height, i === renderList.length - 1, i === 0)
        },
        style: defaults(normalStyleModel.getItemStyle(), {
          lineJoin: "bevel"
        }),
        textContent: new ZRText$1({
          style: {
            text,
            fill: textStyleModel.getTextColor(),
            font: textStyleModel.getFont()
          }
        }),
        textConfig: {
          position: "inside"
        },
        z2: Z2_EMPHASIS_LIFT * 1e4,
        onclick: curry$3(onSelect, itemNode)
      });
      el.disableLabelAnimation = true;
      this.group.add(el);
      packEventData(el, seriesModel, itemNode);
      lastX += itemWidth + ITEM_GAP;
    }
  };
  Breadcrumb2.prototype.remove = function() {
    this.group.removeAll();
  };
  return Breadcrumb2;
}();
function makeItemPoints(x2, y2, itemWidth, itemHeight, head, tail) {
  var points2 = [[head ? x2 : x2 - ARRAY_LENGTH, y2], [x2 + itemWidth, y2], [x2 + itemWidth, y2 + itemHeight], [head ? x2 : x2 - ARRAY_LENGTH, y2 + itemHeight]];
  !tail && points2.splice(2, 0, [x2 + itemWidth + ARRAY_LENGTH, y2 + itemHeight / 2]);
  !head && points2.push([x2, y2 + itemHeight / 2]);
  return points2;
}
function packEventData(el, seriesModel, itemNode) {
  getECData(el).eventData = {
    componentType: "series",
    componentSubType: "treemap",
    componentIndex: seriesModel.componentIndex,
    seriesIndex: seriesModel.seriesIndex,
    seriesName: seriesModel.name,
    seriesType: "treemap",
    selfType: "breadcrumb",
    nodeData: {
      dataIndex: itemNode && itemNode.dataIndex,
      name: itemNode && itemNode.name
    },
    treePathInfo: itemNode && wrapTreePathInfo(itemNode, seriesModel)
  };
}
var Breadcrumb$1 = Breadcrumb;
var AnimationWrap = function() {
  function AnimationWrap2() {
    this._storage = [];
    this._elExistsMap = {};
  }
  AnimationWrap2.prototype.add = function(el, target, duration, delay, easing) {
    if (this._elExistsMap[el.id]) {
      return false;
    }
    this._elExistsMap[el.id] = true;
    this._storage.push({
      el,
      target,
      duration,
      delay,
      easing
    });
    return true;
  };
  AnimationWrap2.prototype.finished = function(callback) {
    this._finishedCallback = callback;
    return this;
  };
  AnimationWrap2.prototype.start = function() {
    var _this = this;
    var count2 = this._storage.length;
    var checkTerminate = function() {
      count2--;
      if (count2 <= 0) {
        _this._storage.length = 0;
        _this._elExistsMap = {};
        _this._finishedCallback && _this._finishedCallback();
      }
    };
    for (var i = 0, len2 = this._storage.length; i < len2; i++) {
      var item = this._storage[i];
      item.el.animateTo(item.target, {
        duration: item.duration,
        delay: item.delay,
        easing: item.easing,
        setToFinal: true,
        done: checkTerminate,
        aborted: checkTerminate
      });
    }
    return this;
  };
  return AnimationWrap2;
}();
function createWrap() {
  return new AnimationWrap();
}
var Group$4 = Group$6;
var Rect$1 = Rect$3;
var DRAG_THRESHOLD = 3;
var PATH_LABEL_NOAMAL = "label";
var PATH_UPPERLABEL_NORMAL = "upperLabel";
var Z2_BASE = Z2_EMPHASIS_LIFT * 10;
var Z2_BG = Z2_EMPHASIS_LIFT * 2;
var Z2_CONTENT = Z2_EMPHASIS_LIFT * 3;
var getStateItemStyle = makeStyleMapper([
  ["fill", "color"],
  ["stroke", "strokeColor"],
  ["lineWidth", "strokeWidth"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"]
]);
var getItemStyleNormal = function(model) {
  var itemStyle = getStateItemStyle(model);
  itemStyle.stroke = itemStyle.fill = itemStyle.lineWidth = null;
  return itemStyle;
};
var inner$d = makeInner();
var TreemapView = function(_super) {
  __extends(TreemapView2, _super);
  function TreemapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapView2.type;
    _this._state = "ready";
    _this._storage = createStorage();
    return _this;
  }
  TreemapView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var models = ecModel.findComponents({
      mainType: "series",
      subType: "treemap",
      query: payload
    });
    if (indexOf(models, seriesModel) < 0) {
      return;
    }
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var payloadType = payload && payload.type;
    var layoutInfo = seriesModel.layoutInfo;
    var isInit = !this._oldTree;
    var thisStorage = this._storage;
    var reRoot = payloadType === "treemapRootToNode" && targetInfo && thisStorage ? {
      rootNodeGroup: thisStorage.nodeGroup[targetInfo.node.getRawIndex()],
      direction: payload.direction
    } : null;
    var containerGroup = this._giveContainerGroup(layoutInfo);
    var hasAnimation = seriesModel.get("animation");
    var renderResult = this._doRender(containerGroup, seriesModel, reRoot);
    hasAnimation && !isInit && (!payloadType || payloadType === "treemapZoomToNode" || payloadType === "treemapRootToNode") ? this._doAnimation(containerGroup, renderResult, seriesModel, reRoot) : renderResult.renderFinally();
    this._resetController(api);
    this._renderBreadcrumb(seriesModel, api, targetInfo);
  };
  TreemapView2.prototype._giveContainerGroup = function(layoutInfo) {
    var containerGroup = this._containerGroup;
    if (!containerGroup) {
      containerGroup = this._containerGroup = new Group$4();
      this._initEvents(containerGroup);
      this.group.add(containerGroup);
    }
    containerGroup.x = layoutInfo.x;
    containerGroup.y = layoutInfo.y;
    return containerGroup;
  };
  TreemapView2.prototype._doRender = function(containerGroup, seriesModel, reRoot) {
    var thisTree = seriesModel.getData().tree;
    var oldTree = this._oldTree;
    var lastsForAnimation = createStorage();
    var thisStorage = createStorage();
    var oldStorage = this._storage;
    var willInvisibleEls = [];
    function doRenderNode(thisNode, oldNode, parentGroup, depth) {
      return renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth);
    }
    dualTravel(thisTree.root ? [thisTree.root] : [], oldTree && oldTree.root ? [oldTree.root] : [], containerGroup, thisTree === oldTree || !oldTree, 0);
    var willDeleteEls = clearStorage(oldStorage);
    this._oldTree = thisTree;
    this._storage = thisStorage;
    return {
      lastsForAnimation,
      willDeleteEls,
      renderFinally
    };
    function dualTravel(thisViewChildren, oldViewChildren, parentGroup, sameTree, depth) {
      if (sameTree) {
        oldViewChildren = thisViewChildren;
        each$g(thisViewChildren, function(child, index2) {
          !child.isRemoved() && processNode(index2, index2);
        });
      } else {
        new DataDiffer$1(oldViewChildren, thisViewChildren, getKey2, getKey2).add(processNode).update(processNode).remove(curry$3(processNode, null)).execute();
      }
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIndex, oldIndex) {
        var thisNode = newIndex != null ? thisViewChildren[newIndex] : null;
        var oldNode = oldIndex != null ? oldViewChildren[oldIndex] : null;
        var group = doRenderNode(thisNode, oldNode, parentGroup, depth);
        group && dualTravel(thisNode && thisNode.viewChildren || [], oldNode && oldNode.viewChildren || [], group, sameTree, depth + 1);
      }
    }
    function clearStorage(storage2) {
      var willDeleteEls2 = createStorage();
      storage2 && each$g(storage2, function(store, storageName) {
        var delEls = willDeleteEls2[storageName];
        each$g(store, function(el) {
          el && (delEls.push(el), inner$d(el).willDelete = true);
        });
      });
      return willDeleteEls2;
    }
    function renderFinally() {
      each$g(willDeleteEls, function(els) {
        each$g(els, function(el) {
          el.parent && el.parent.remove(el);
        });
      });
      each$g(willInvisibleEls, function(el) {
        el.invisible = true;
        el.dirty();
      });
    }
  };
  TreemapView2.prototype._doAnimation = function(containerGroup, renderResult, seriesModel, reRoot) {
    var durationOption = seriesModel.get("animationDurationUpdate");
    var easingOption = seriesModel.get("animationEasing");
    var duration = (isFunction$1(durationOption) ? 0 : durationOption) || 0;
    var easing = (isFunction$1(easingOption) ? null : easingOption) || "cubicOut";
    var animationWrap = createWrap();
    each$g(renderResult.willDeleteEls, function(store, storageName) {
      each$g(store, function(el, rawIndex) {
        if (el.invisible) {
          return;
        }
        var parent = el.parent;
        var target;
        var innerStore = inner$d(parent);
        if (reRoot && reRoot.direction === "drillDown") {
          target = parent === reRoot.rootNodeGroup ? {
            shape: {
              x: 0,
              y: 0,
              width: innerStore.nodeWidth,
              height: innerStore.nodeHeight
            },
            style: {
              opacity: 0
            }
          } : {
            style: {
              opacity: 0
            }
          };
        } else {
          var targetX = 0;
          var targetY = 0;
          if (!innerStore.willDelete) {
            targetX = innerStore.nodeWidth / 2;
            targetY = innerStore.nodeHeight / 2;
          }
          target = storageName === "nodeGroup" ? {
            x: targetX,
            y: targetY,
            style: {
              opacity: 0
            }
          } : {
            shape: {
              x: targetX,
              y: targetY,
              width: 0,
              height: 0
            },
            style: {
              opacity: 0
            }
          };
        }
        target && animationWrap.add(el, target, duration, 0, easing);
      });
    });
    each$g(this._storage, function(store, storageName) {
      each$g(store, function(el, rawIndex) {
        var last = renderResult.lastsForAnimation[storageName][rawIndex];
        var target = {};
        if (!last) {
          return;
        }
        if (el instanceof Group$6) {
          if (last.oldX != null) {
            target.x = el.x;
            target.y = el.y;
            el.x = last.oldX;
            el.y = last.oldY;
          }
        } else {
          if (last.oldShape) {
            target.shape = extend({}, el.shape);
            el.setShape(last.oldShape);
          }
          if (last.fadein) {
            el.setStyle("opacity", 0);
            target.style = {
              opacity: 1
            };
          } else if (el.style.opacity !== 1) {
            target.style = {
              opacity: 1
            };
          }
        }
        animationWrap.add(el, target, duration, 0, easing);
      });
    }, this);
    this._state = "animating";
    animationWrap.finished(bind$1(function() {
      this._state = "ready";
      renderResult.renderFinally();
    }, this)).start();
  };
  TreemapView2.prototype._resetController = function(api) {
    var controller = this._controller;
    if (!controller) {
      controller = this._controller = new RoamController$1(api.getZr());
      controller.enable(this.seriesModel.get("roam"));
      controller.on("pan", bind$1(this._onPan, this));
      controller.on("zoom", bind$1(this._onZoom, this));
    }
    var rect = new BoundingRect$1(0, 0, api.getWidth(), api.getHeight());
    controller.setPointerChecker(function(e2, x2, y2) {
      return rect.contain(x2, y2);
    });
  };
  TreemapView2.prototype._clearController = function() {
    var controller = this._controller;
    if (controller) {
      controller.dispose();
      controller = null;
    }
  };
  TreemapView2.prototype._onPan = function(e2) {
    if (this._state !== "animating" && (Math.abs(e2.dx) > DRAG_THRESHOLD || Math.abs(e2.dy) > DRAG_THRESHOLD)) {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      this.api.dispatchAction({
        type: "treemapMove",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rootLayout.x + e2.dx,
          y: rootLayout.y + e2.dy,
          width: rootLayout.width,
          height: rootLayout.height
        }
      });
    }
  };
  TreemapView2.prototype._onZoom = function(e2) {
    var mouseX = e2.originX;
    var mouseY = e2.originY;
    if (this._state !== "animating") {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      var rect = new BoundingRect$1(rootLayout.x, rootLayout.y, rootLayout.width, rootLayout.height);
      var layoutInfo = this.seriesModel.layoutInfo;
      mouseX -= layoutInfo.x;
      mouseY -= layoutInfo.y;
      var m2 = create$2();
      translate(m2, m2, [-mouseX, -mouseY]);
      scale$1(m2, m2, [e2.scale, e2.scale]);
      translate(m2, m2, [mouseX, mouseY]);
      rect.applyTransform(m2);
      this.api.dispatchAction({
        type: "treemapRender",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rect.x,
          y: rect.y,
          width: rect.width,
          height: rect.height
        }
      });
    }
  };
  TreemapView2.prototype._initEvents = function(containerGroup) {
    var _this = this;
    containerGroup.on("click", function(e2) {
      if (_this._state !== "ready") {
        return;
      }
      var nodeClick = _this.seriesModel.get("nodeClick", true);
      if (!nodeClick) {
        return;
      }
      var targetInfo = _this.findTarget(e2.offsetX, e2.offsetY);
      if (!targetInfo) {
        return;
      }
      var node = targetInfo.node;
      if (node.getLayout().isLeafRoot) {
        _this._rootToNode(targetInfo);
      } else {
        if (nodeClick === "zoomToNode") {
          _this._zoomToNode(targetInfo);
        } else if (nodeClick === "link") {
          var itemModel = node.hostTree.data.getItemModel(node.dataIndex);
          var link = itemModel.get("link", true);
          var linkTarget = itemModel.get("target", true) || "blank";
          link && windowOpen(link, linkTarget);
        }
      }
    }, this);
  };
  TreemapView2.prototype._renderBreadcrumb = function(seriesModel, api, targetInfo) {
    var _this = this;
    if (!targetInfo) {
      targetInfo = seriesModel.get("leafDepth", true) != null ? {
        node: seriesModel.getViewRoot()
      } : this.findTarget(api.getWidth() / 2, api.getHeight() / 2);
      if (!targetInfo) {
        targetInfo = {
          node: seriesModel.getData().tree.root
        };
      }
    }
    (this._breadcrumb || (this._breadcrumb = new Breadcrumb$1(this.group))).render(seriesModel, api, targetInfo.node, function(node) {
      if (_this._state !== "animating") {
        aboveViewRoot(seriesModel.getViewRoot(), node) ? _this._rootToNode({
          node
        }) : _this._zoomToNode({
          node
        });
      }
    });
  };
  TreemapView2.prototype.remove = function() {
    this._clearController();
    this._containerGroup && this._containerGroup.removeAll();
    this._storage = createStorage();
    this._state = "ready";
    this._breadcrumb && this._breadcrumb.remove();
  };
  TreemapView2.prototype.dispose = function() {
    this._clearController();
  };
  TreemapView2.prototype._zoomToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapZoomToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype._rootToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapRootToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype.findTarget = function(x2, y2) {
    var targetInfo;
    var viewRoot = this.seriesModel.getViewRoot();
    viewRoot.eachNode({
      attr: "viewChildren",
      order: "preorder"
    }, function(node) {
      var bgEl = this._storage.background[node.getRawIndex()];
      if (bgEl) {
        var point = bgEl.transformCoordToLocal(x2, y2);
        var shape = bgEl.shape;
        if (shape.x <= point[0] && point[0] <= shape.x + shape.width && shape.y <= point[1] && point[1] <= shape.y + shape.height) {
          targetInfo = {
            node,
            offsetX: point[0],
            offsetY: point[1]
          };
        } else {
          return false;
        }
      }
    }, this);
    return targetInfo;
  };
  TreemapView2.type = "treemap";
  return TreemapView2;
}(ChartView$1);
function createStorage() {
  return {
    nodeGroup: [],
    background: [],
    content: []
  };
}
function renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth) {
  if (!thisNode) {
    return;
  }
  var thisLayout = thisNode.getLayout();
  var data2 = seriesModel.getData();
  var nodeModel = thisNode.getModel();
  data2.setItemGraphicEl(thisNode.dataIndex, null);
  if (!thisLayout || !thisLayout.isInView) {
    return;
  }
  var thisWidth = thisLayout.width;
  var thisHeight = thisLayout.height;
  var borderWidth = thisLayout.borderWidth;
  var thisInvisible = thisLayout.invisible;
  var thisRawIndex = thisNode.getRawIndex();
  var oldRawIndex = oldNode && oldNode.getRawIndex();
  var thisViewChildren = thisNode.viewChildren;
  var upperHeight = thisLayout.upperHeight;
  var isParent = thisViewChildren && thisViewChildren.length;
  var itemStyleNormalModel = nodeModel.getModel("itemStyle");
  var itemStyleEmphasisModel = nodeModel.getModel(["emphasis", "itemStyle"]);
  var itemStyleBlurModel = nodeModel.getModel(["blur", "itemStyle"]);
  var itemStyleSelectModel = nodeModel.getModel(["select", "itemStyle"]);
  var borderRadius = itemStyleNormalModel.get("borderRadius") || 0;
  var group = giveGraphic("nodeGroup", Group$4);
  if (!group) {
    return;
  }
  parentGroup.add(group);
  group.x = thisLayout.x || 0;
  group.y = thisLayout.y || 0;
  group.markRedraw();
  inner$d(group).nodeWidth = thisWidth;
  inner$d(group).nodeHeight = thisHeight;
  if (thisLayout.isAboveViewRoot) {
    return group;
  }
  var bg2 = giveGraphic("background", Rect$1, depth, Z2_BG);
  bg2 && renderBackground(group, bg2, isParent && thisLayout.upperLabelHeight);
  var emphasisModel = nodeModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var isDisabled = emphasisModel.get("disabled");
  var focusOrIndices = focus === "ancestor" ? thisNode.getAncestorsIndices() : focus === "descendant" ? thisNode.getDescendantIndices() : focus;
  if (isParent) {
    if (isHighDownDispatcher(group)) {
      setAsHighDownDispatcher(group, false);
    }
    if (bg2) {
      setAsHighDownDispatcher(bg2, !isDisabled);
      data2.setItemGraphicEl(thisNode.dataIndex, bg2);
      enableHoverFocus(bg2, focusOrIndices, blurScope);
    }
  } else {
    var content = giveGraphic("content", Rect$1, depth, Z2_CONTENT);
    content && renderContent(group, content);
    bg2.disableMorphing = true;
    if (bg2 && isHighDownDispatcher(bg2)) {
      setAsHighDownDispatcher(bg2, false);
    }
    setAsHighDownDispatcher(group, !isDisabled);
    data2.setItemGraphicEl(thisNode.dataIndex, group);
    enableHoverFocus(group, focusOrIndices, blurScope);
  }
  return group;
  function renderBackground(group2, bg3, useUpperLabel) {
    var ecData = getECData(bg3);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    bg3.setShape({
      x: 0,
      y: 0,
      width: thisWidth,
      height: thisHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(bg3);
    } else {
      bg3.invisible = false;
      var style2 = thisNode.getVisual("style");
      var visualBorderColor = style2.stroke;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualBorderColor;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      emphasisStyle.fill = itemStyleEmphasisModel.get("borderColor");
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      blurStyle.fill = itemStyleBlurModel.get("borderColor");
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      selectStyle.fill = itemStyleSelectModel.get("borderColor");
      if (useUpperLabel) {
        var upperLabelWidth = thisWidth - 2 * borderWidth;
        prepareText(bg3, visualBorderColor, style2.opacity, {
          x: borderWidth,
          y: 0,
          width: upperLabelWidth,
          height: upperHeight
        });
      } else {
        bg3.removeTextContent();
      }
      bg3.setStyle(normalStyle);
      bg3.ensureState("emphasis").style = emphasisStyle;
      bg3.ensureState("blur").style = blurStyle;
      bg3.ensureState("select").style = selectStyle;
      setDefaultStateProxy(bg3);
    }
    group2.add(bg3);
  }
  function renderContent(group2, content2) {
    var ecData = getECData(content2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    var contentWidth = Math.max(thisWidth - 2 * borderWidth, 0);
    var contentHeight = Math.max(thisHeight - 2 * borderWidth, 0);
    content2.culling = true;
    content2.setShape({
      x: borderWidth,
      y: borderWidth,
      width: contentWidth,
      height: contentHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(content2);
    } else {
      content2.invisible = false;
      var nodeStyle = thisNode.getVisual("style");
      var visualColor = nodeStyle.fill;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualColor;
      normalStyle.decal = nodeStyle.decal;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      prepareText(content2, visualColor, nodeStyle.opacity, null);
      content2.setStyle(normalStyle);
      content2.ensureState("emphasis").style = emphasisStyle;
      content2.ensureState("blur").style = blurStyle;
      content2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(content2);
    }
    group2.add(content2);
  }
  function processInvisible(element) {
    !element.invisible && willInvisibleEls.push(element);
  }
  function prepareText(rectEl, visualColor, visualOpacity, upperLabelRect) {
    var normalLabelModel = nodeModel.getModel(upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL);
    var defaultText = convertOptionIdName(nodeModel.get("name"), null);
    var isShow = normalLabelModel.getShallow("show");
    setLabelStyle(rectEl, getLabelStatesModels(nodeModel, upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL), {
      defaultText: isShow ? defaultText : null,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      labelFetcher: seriesModel,
      labelDataIndex: thisNode.dataIndex
    });
    var textEl = rectEl.getTextContent();
    if (!textEl) {
      return;
    }
    var textStyle = textEl.style;
    var textPadding = normalizeCssArray$1(textStyle.padding || 0);
    if (upperLabelRect) {
      rectEl.setTextConfig({
        layoutRect: upperLabelRect
      });
      textEl.disableLabelLayout = true;
    }
    textEl.beforeUpdate = function() {
      var width = Math.max((upperLabelRect ? upperLabelRect.width : rectEl.shape.width) - textPadding[1] - textPadding[3], 0);
      var height = Math.max((upperLabelRect ? upperLabelRect.height : rectEl.shape.height) - textPadding[0] - textPadding[2], 0);
      if (textStyle.width !== width || textStyle.height !== height) {
        textEl.setStyle({
          width,
          height
        });
      }
    };
    textStyle.truncateMinChar = 2;
    textStyle.lineOverflow = "truncate";
    addDrillDownIcon(textStyle, upperLabelRect, thisLayout);
    var textEmphasisState = textEl.getState("emphasis");
    addDrillDownIcon(textEmphasisState ? textEmphasisState.style : null, upperLabelRect, thisLayout);
  }
  function addDrillDownIcon(style2, upperLabelRect, thisLayout2) {
    var text = style2 ? style2.text : null;
    if (!upperLabelRect && thisLayout2.isLeafRoot && text != null) {
      var iconChar = seriesModel.get("drillDownIcon", true);
      style2.text = iconChar ? iconChar + " " + text : text;
    }
  }
  function giveGraphic(storageName, Ctor, depth2, z2) {
    var element = oldRawIndex != null && oldStorage[storageName][oldRawIndex];
    var lasts = lastsForAnimation[storageName];
    if (element) {
      oldStorage[storageName][oldRawIndex] = null;
      prepareAnimationWhenHasOld(lasts, element);
    } else if (!thisInvisible) {
      element = new Ctor();
      if (element instanceof Displayable$1) {
        element.z2 = calculateZ2(depth2, z2);
      }
      prepareAnimationWhenNoOld(lasts, element);
    }
    return thisStorage[storageName][thisRawIndex] = element;
  }
  function prepareAnimationWhenHasOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    if (element instanceof Group$4) {
      lastCfg.oldX = element.x;
      lastCfg.oldY = element.y;
    } else {
      lastCfg.oldShape = extend({}, element.shape);
    }
  }
  function prepareAnimationWhenNoOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    var parentNode2 = thisNode.parentNode;
    var isGroup = element instanceof Group$6;
    if (parentNode2 && (!reRoot || reRoot.direction === "drillDown")) {
      var parentOldX = 0;
      var parentOldY = 0;
      var parentOldBg = lastsForAnimation.background[parentNode2.getRawIndex()];
      if (!reRoot && parentOldBg && parentOldBg.oldShape) {
        parentOldX = parentOldBg.oldShape.width;
        parentOldY = parentOldBg.oldShape.height;
      }
      if (isGroup) {
        lastCfg.oldX = 0;
        lastCfg.oldY = parentOldY;
      } else {
        lastCfg.oldShape = {
          x: parentOldX,
          y: parentOldY,
          width: 0,
          height: 0
        };
      }
    }
    lastCfg.fadein = !isGroup;
  }
}
function calculateZ2(depth, z2InLevel) {
  return depth * Z2_BASE + z2InLevel;
}
var TreemapView$1 = TreemapView;
var each$d = each$g;
var isObject$3 = isObject$6;
var CATEGORY_DEFAULT_VISUAL_INDEX = -1;
var VisualMapping = function() {
  function VisualMapping2(option) {
    var mappingMethod = option.mappingMethod;
    var visualType = option.type;
    var thisOption = this.option = clone$4(option);
    this.type = visualType;
    this.mappingMethod = mappingMethod;
    this._normalizeData = normalizers[mappingMethod];
    var visualHandler = VisualMapping2.visualHandlers[visualType];
    this.applyVisual = visualHandler.applyVisual;
    this.getColorMapper = visualHandler.getColorMapper;
    this._normalizedToVisual = visualHandler._normalizedToVisual[mappingMethod];
    if (mappingMethod === "piecewise") {
      normalizeVisualRange(thisOption);
      preprocessForPiecewise(thisOption);
    } else if (mappingMethod === "category") {
      thisOption.categories ? preprocessForSpecifiedCategory(thisOption) : normalizeVisualRange(thisOption, true);
    } else {
      assert(mappingMethod !== "linear" || thisOption.dataExtent);
      normalizeVisualRange(thisOption);
    }
  }
  VisualMapping2.prototype.mapValueToVisual = function(value) {
    var normalized = this._normalizeData(value);
    return this._normalizedToVisual(normalized, value);
  };
  VisualMapping2.prototype.getNormalizer = function() {
    return bind$1(this._normalizeData, this);
  };
  VisualMapping2.listVisualTypes = function() {
    return keys(VisualMapping2.visualHandlers);
  };
  VisualMapping2.isValidType = function(visualType) {
    return VisualMapping2.visualHandlers.hasOwnProperty(visualType);
  };
  VisualMapping2.eachVisual = function(visual, callback, context) {
    if (isObject$6(visual)) {
      each$g(visual, callback, context);
    } else {
      callback.call(context, visual);
    }
  };
  VisualMapping2.mapVisual = function(visual, callback, context) {
    var isPrimary;
    var newVisual = isArray$2(visual) ? [] : isObject$6(visual) ? {} : (isPrimary = true, null);
    VisualMapping2.eachVisual(visual, function(v4, key) {
      var newVal = callback.call(context, v4, key);
      isPrimary ? newVisual = newVal : newVisual[key] = newVal;
    });
    return newVisual;
  };
  VisualMapping2.retrieveVisuals = function(obj) {
    var ret = {};
    var hasVisual;
    obj && each$d(VisualMapping2.visualHandlers, function(h, visualType) {
      if (obj.hasOwnProperty(visualType)) {
        ret[visualType] = obj[visualType];
        hasVisual = true;
      }
    });
    return hasVisual ? ret : null;
  };
  VisualMapping2.prepareVisualTypes = function(visualTypes) {
    if (isArray$2(visualTypes)) {
      visualTypes = visualTypes.slice();
    } else if (isObject$3(visualTypes)) {
      var types_1 = [];
      each$d(visualTypes, function(item, type4) {
        types_1.push(type4);
      });
      visualTypes = types_1;
    } else {
      return [];
    }
    visualTypes.sort(function(type1, type22) {
      return type22 === "color" && type1 !== "color" && type1.indexOf("color") === 0 ? 1 : -1;
    });
    return visualTypes;
  };
  VisualMapping2.dependsOn = function(visualType1, visualType2) {
    return visualType2 === "color" ? !!(visualType1 && visualType1.indexOf(visualType2) === 0) : visualType1 === visualType2;
  };
  VisualMapping2.findPieceIndex = function(value, pieceList, findClosestWhenOutside) {
    var possibleI;
    var abs2 = Infinity;
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var pieceValue = pieceList[i].value;
      if (pieceValue != null) {
        if (pieceValue === value || isString$1(pieceValue) && pieceValue === value + "") {
          return i;
        }
        findClosestWhenOutside && updatePossible(pieceValue, i);
      }
    }
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var piece = pieceList[i];
      var interval = piece.interval;
      var close_1 = piece.close;
      if (interval) {
        if (interval[0] === -Infinity) {
          if (littleThan(close_1[1], value, interval[1])) {
            return i;
          }
        } else if (interval[1] === Infinity) {
          if (littleThan(close_1[0], interval[0], value)) {
            return i;
          }
        } else if (littleThan(close_1[0], interval[0], value) && littleThan(close_1[1], value, interval[1])) {
          return i;
        }
        findClosestWhenOutside && updatePossible(interval[0], i);
        findClosestWhenOutside && updatePossible(interval[1], i);
      }
    }
    if (findClosestWhenOutside) {
      return value === Infinity ? pieceList.length - 1 : value === -Infinity ? 0 : possibleI;
    }
    function updatePossible(val, index2) {
      var newAbs = Math.abs(val - value);
      if (newAbs < abs2) {
        abs2 = newAbs;
        possibleI = index2;
      }
    }
  };
  VisualMapping2.visualHandlers = {
    color: {
      applyVisual: makeApplyVisual("color"),
      getColorMapper: function() {
        var thisOption = this.option;
        return bind$1(thisOption.mappingMethod === "category" ? function(value, isNormalized) {
          !isNormalized && (value = this._normalizeData(value));
          return doMapCategory.call(this, value);
        } : function(value, isNormalized, out2) {
          var returnRGBArray = !!out2;
          !isNormalized && (value = this._normalizeData(value));
          out2 = fastLerp(value, thisOption.parsedVisual, out2);
          return returnRGBArray ? out2 : stringify(out2, "rgba");
        }, this);
      },
      _normalizedToVisual: {
        linear: function(normalized) {
          return stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
        },
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    colorHue: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, value);
    }),
    colorSaturation: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, value);
    }),
    colorLightness: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, null, value);
    }),
    colorAlpha: makePartialColorVisualHandler(function(color, value) {
      return modifyAlpha(color, value);
    }),
    decal: {
      applyVisual: makeApplyVisual("decal"),
      _normalizedToVisual: {
        linear: null,
        category: doMapCategory,
        piecewise: null,
        fixed: null
      }
    },
    opacity: {
      applyVisual: makeApplyVisual("opacity"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    },
    liftZ: {
      applyVisual: makeApplyVisual("liftZ"),
      _normalizedToVisual: {
        linear: doMapFixed,
        category: doMapFixed,
        piecewise: doMapFixed,
        fixed: doMapFixed
      }
    },
    symbol: {
      applyVisual: function(value, getter, setter) {
        var symbolCfg = this.mapValueToVisual(value);
        setter("symbol", symbolCfg);
      },
      _normalizedToVisual: {
        linear: doMapToArray,
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = doMapToArray.call(this, normalized);
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    symbolSize: {
      applyVisual: makeApplyVisual("symbolSize"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    }
  };
  return VisualMapping2;
}();
function preprocessForPiecewise(thisOption) {
  var pieceList = thisOption.pieceList;
  thisOption.hasSpecialVisual = false;
  each$g(pieceList, function(piece, index2) {
    piece.originIndex = index2;
    if (piece.visual != null) {
      thisOption.hasSpecialVisual = true;
    }
  });
}
function preprocessForSpecifiedCategory(thisOption) {
  var categories = thisOption.categories;
  var categoryMap = thisOption.categoryMap = {};
  var visual = thisOption.visual;
  each$d(categories, function(cate, index2) {
    categoryMap[cate] = index2;
  });
  if (!isArray$2(visual)) {
    var visualArr_1 = [];
    if (isObject$6(visual)) {
      each$d(visual, function(v4, cate) {
        var index2 = categoryMap[cate];
        visualArr_1[index2 != null ? index2 : CATEGORY_DEFAULT_VISUAL_INDEX] = v4;
      });
    } else {
      visualArr_1[CATEGORY_DEFAULT_VISUAL_INDEX] = visual;
    }
    visual = setVisualToOption(thisOption, visualArr_1);
  }
  for (var i = categories.length - 1; i >= 0; i--) {
    if (visual[i] == null) {
      delete categoryMap[categories[i]];
      categories.pop();
    }
  }
}
function normalizeVisualRange(thisOption, isCategory2) {
  var visual = thisOption.visual;
  var visualArr = [];
  if (isObject$6(visual)) {
    each$d(visual, function(v4) {
      visualArr.push(v4);
    });
  } else if (visual != null) {
    visualArr.push(visual);
  }
  var doNotNeedPair = {
    color: 1,
    symbol: 1
  };
  if (!isCategory2 && visualArr.length === 1 && !doNotNeedPair.hasOwnProperty(thisOption.type)) {
    visualArr[1] = visualArr[0];
  }
  setVisualToOption(thisOption, visualArr);
}
function makePartialColorVisualHandler(applyValue) {
  return {
    applyVisual: function(value, getter, setter) {
      var colorChannel = this.mapValueToVisual(value);
      setter("color", applyValue(getter("color"), colorChannel));
    },
    _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
  };
}
function doMapToArray(normalized) {
  var visual = this.option.visual;
  return visual[Math.round(linearMap$2(normalized, [0, 1], [0, visual.length - 1], true))] || {};
}
function makeApplyVisual(visualType) {
  return function(value, getter, setter) {
    setter(visualType, this.mapValueToVisual(value));
  };
}
function doMapCategory(normalized) {
  var visual = this.option.visual;
  return visual[this.option.loop && normalized !== CATEGORY_DEFAULT_VISUAL_INDEX ? normalized % visual.length : normalized];
}
function doMapFixed() {
  return this.option.visual[0];
}
function createNormalizedToNumericVisual(sourceExtent) {
  return {
    linear: function(normalized) {
      return linearMap$2(normalized, sourceExtent, this.option.visual, true);
    },
    category: doMapCategory,
    piecewise: function(normalized, value) {
      var result = getSpecifiedVisual.call(this, value);
      if (result == null) {
        result = linearMap$2(normalized, sourceExtent, this.option.visual, true);
      }
      return result;
    },
    fixed: doMapFixed
  };
}
function getSpecifiedVisual(value) {
  var thisOption = this.option;
  var pieceList = thisOption.pieceList;
  if (thisOption.hasSpecialVisual) {
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList);
    var piece = pieceList[pieceIndex];
    if (piece && piece.visual) {
      return piece.visual[this.type];
    }
  }
}
function setVisualToOption(thisOption, visualArr) {
  thisOption.visual = visualArr;
  if (thisOption.type === "color") {
    thisOption.parsedVisual = map$1(visualArr, function(item) {
      return parse$1(item);
    });
  }
  return visualArr;
}
var normalizers = {
  linear: function(value) {
    return linearMap$2(value, this.option.dataExtent, [0, 1], true);
  },
  piecewise: function(value) {
    var pieceList = this.option.pieceList;
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList, true);
    if (pieceIndex != null) {
      return linearMap$2(pieceIndex, [0, pieceList.length - 1], [0, 1], true);
    }
  },
  category: function(value) {
    var index2 = this.option.categories ? this.option.categoryMap[value] : value;
    return index2 == null ? CATEGORY_DEFAULT_VISUAL_INDEX : index2;
  },
  fixed: noop$1
};
function littleThan(close, a, b2) {
  return close ? a <= b2 : a < b2;
}
var VisualMapping$1 = VisualMapping;
var ITEM_STYLE_NORMAL = "itemStyle";
var inner$c = makeInner();
var treemapVisual = {
  seriesType: "treemap",
  reset: function(seriesModel) {
    var tree = seriesModel.getData().tree;
    var root2 = tree.root;
    if (root2.isRemoved()) {
      return;
    }
    travelTree(root2, {}, seriesModel.getViewRoot().getAncestors(), seriesModel);
  }
};
function travelTree(node, designatedVisual, viewRootAncestors, seriesModel) {
  var nodeModel = node.getModel();
  var nodeLayout = node.getLayout();
  var data2 = node.hostTree.data;
  if (!nodeLayout || nodeLayout.invisible || !nodeLayout.isInView) {
    return;
  }
  var nodeItemStyleModel = nodeModel.getModel(ITEM_STYLE_NORMAL);
  var visuals = buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel);
  var existsStyle = data2.ensureUniqueItemVisual(node.dataIndex, "style");
  var borderColor = nodeItemStyleModel.get("borderColor");
  var borderColorSaturation = nodeItemStyleModel.get("borderColorSaturation");
  var thisNodeColor;
  if (borderColorSaturation != null) {
    thisNodeColor = calculateColor(visuals);
    borderColor = calculateBorderColor(borderColorSaturation, thisNodeColor);
  }
  existsStyle.stroke = borderColor;
  var viewChildren = node.viewChildren;
  if (!viewChildren || !viewChildren.length) {
    thisNodeColor = calculateColor(visuals);
    existsStyle.fill = thisNodeColor;
  } else {
    var mapping_1 = buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren);
    each$g(viewChildren, function(child, index2) {
      if (child.depth >= viewRootAncestors.length || child === viewRootAncestors[child.depth]) {
        var childVisual = mapVisual$1(nodeModel, visuals, child, index2, mapping_1, seriesModel);
        travelTree(child, childVisual, viewRootAncestors, seriesModel);
      }
    });
  }
}
function buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel) {
  var visuals = extend({}, designatedVisual);
  var designatedVisualItemStyle = seriesModel.designatedVisualItemStyle;
  each$g(["color", "colorAlpha", "colorSaturation"], function(visualName) {
    designatedVisualItemStyle[visualName] = designatedVisual[visualName];
    var val = nodeItemStyleModel.get(visualName);
    designatedVisualItemStyle[visualName] = null;
    val != null && (visuals[visualName] = val);
  });
  return visuals;
}
function calculateColor(visuals) {
  var color = getValueVisualDefine(visuals, "color");
  if (color) {
    var colorAlpha = getValueVisualDefine(visuals, "colorAlpha");
    var colorSaturation = getValueVisualDefine(visuals, "colorSaturation");
    if (colorSaturation) {
      color = modifyHSL(color, null, null, colorSaturation);
    }
    if (colorAlpha) {
      color = modifyAlpha(color, colorAlpha);
    }
    return color;
  }
}
function calculateBorderColor(borderColorSaturation, thisNodeColor) {
  return thisNodeColor != null ? modifyHSL(thisNodeColor, null, null, borderColorSaturation) : null;
}
function getValueVisualDefine(visuals, name2) {
  var value = visuals[name2];
  if (value != null && value !== "none") {
    return value;
  }
}
function buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren) {
  if (!viewChildren || !viewChildren.length) {
    return;
  }
  var rangeVisual = getRangeVisual(nodeModel, "color") || visuals.color != null && visuals.color !== "none" && (getRangeVisual(nodeModel, "colorAlpha") || getRangeVisual(nodeModel, "colorSaturation"));
  if (!rangeVisual) {
    return;
  }
  var visualMin = nodeModel.get("visualMin");
  var visualMax = nodeModel.get("visualMax");
  var dataExtent = nodeLayout.dataExtent.slice();
  visualMin != null && visualMin < dataExtent[0] && (dataExtent[0] = visualMin);
  visualMax != null && visualMax > dataExtent[1] && (dataExtent[1] = visualMax);
  var colorMappingBy = nodeModel.get("colorMappingBy");
  var opt = {
    type: rangeVisual.name,
    dataExtent,
    visual: rangeVisual.range
  };
  if (opt.type === "color" && (colorMappingBy === "index" || colorMappingBy === "id")) {
    opt.mappingMethod = "category";
    opt.loop = true;
  } else {
    opt.mappingMethod = "linear";
  }
  var mapping = new VisualMapping$1(opt);
  inner$c(mapping).drColorMappingBy = colorMappingBy;
  return mapping;
}
function getRangeVisual(nodeModel, name2) {
  var range3 = nodeModel.get(name2);
  return isArray$2(range3) && range3.length ? {
    name: name2,
    range: range3
  } : null;
}
function mapVisual$1(nodeModel, visuals, child, index2, mapping, seriesModel) {
  var childVisuals = extend({}, visuals);
  if (mapping) {
    var mappingType = mapping.type;
    var colorMappingBy = mappingType === "color" && inner$c(mapping).drColorMappingBy;
    var value = colorMappingBy === "index" ? index2 : colorMappingBy === "id" ? seriesModel.mapIdToIndex(child.getId()) : child.getValue(nodeModel.get("visualDimension"));
    childVisuals[mappingType] = mapping.mapValueToVisual(value);
  }
  return childVisuals;
}
var mathMax$3 = Math.max;
var mathMin$3 = Math.min;
var retrieveValue = retrieve;
var each$c = each$g;
var PATH_BORDER_WIDTH = ["itemStyle", "borderWidth"];
var PATH_GAP_WIDTH = ["itemStyle", "gapWidth"];
var PATH_UPPER_LABEL_SHOW = ["upperLabel", "show"];
var PATH_UPPER_LABEL_HEIGHT = ["upperLabel", "height"];
var treemapLayout = {
  seriesType: "treemap",
  reset: function(seriesModel, ecModel, api, payload) {
    var ecWidth = api.getWidth();
    var ecHeight = api.getHeight();
    var seriesOption = seriesModel.option;
    var layoutInfo = getLayoutRect(seriesModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    var size = seriesOption.size || [];
    var containerWidth = parsePercent(retrieveValue(layoutInfo.width, size[0]), ecWidth);
    var containerHeight = parsePercent(retrieveValue(layoutInfo.height, size[1]), ecHeight);
    var payloadType = payload && payload.type;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var rootRect = payloadType === "treemapRender" || payloadType === "treemapMove" ? payload.rootRect : null;
    var viewRoot = seriesModel.getViewRoot();
    var viewAbovePath = getPathToRoot(viewRoot);
    if (payloadType !== "treemapMove") {
      var rootSize = payloadType === "treemapZoomToNode" ? estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) : rootRect ? [rootRect.width, rootRect.height] : [containerWidth, containerHeight];
      var sort_1 = seriesOption.sort;
      if (sort_1 && sort_1 !== "asc" && sort_1 !== "desc") {
        sort_1 = "desc";
      }
      var options = {
        squareRatio: seriesOption.squareRatio,
        sort: sort_1,
        leafDepth: seriesOption.leafDepth
      };
      viewRoot.hostTree.clearLayouts();
      var viewRootLayout_1 = {
        x: 0,
        y: 0,
        width: rootSize[0],
        height: rootSize[1],
        area: rootSize[0] * rootSize[1]
      };
      viewRoot.setLayout(viewRootLayout_1);
      squarify(viewRoot, options, false, 0);
      viewRootLayout_1 = viewRoot.getLayout();
      each$c(viewAbovePath, function(node, index2) {
        var childValue = (viewAbovePath[index2 + 1] || viewRoot).getValue();
        node.setLayout(extend({
          dataExtent: [childValue, childValue],
          borderWidth: 0,
          upperHeight: 0
        }, viewRootLayout_1));
      });
    }
    var treeRoot = seriesModel.getData().tree.root;
    treeRoot.setLayout(calculateRootPosition(layoutInfo, rootRect, targetInfo), true);
    seriesModel.setLayoutInfo(layoutInfo);
    prunning(treeRoot, new BoundingRect$1(-layoutInfo.x, -layoutInfo.y, ecWidth, ecHeight), viewAbovePath, viewRoot, 0);
  }
};
function squarify(node, options, hideChildren, depth) {
  var width;
  var height;
  if (node.isRemoved()) {
    return;
  }
  var thisLayout = node.getLayout();
  width = thisLayout.width;
  height = thisLayout.height;
  var nodeModel = node.getModel();
  var borderWidth = nodeModel.get(PATH_BORDER_WIDTH);
  var halfGapWidth = nodeModel.get(PATH_GAP_WIDTH) / 2;
  var upperLabelHeight = getUpperLabelHeight(nodeModel);
  var upperHeight = Math.max(borderWidth, upperLabelHeight);
  var layoutOffset = borderWidth - halfGapWidth;
  var layoutOffsetUpper = upperHeight - halfGapWidth;
  node.setLayout({
    borderWidth,
    upperHeight,
    upperLabelHeight
  }, true);
  width = mathMax$3(width - 2 * layoutOffset, 0);
  height = mathMax$3(height - layoutOffset - layoutOffsetUpper, 0);
  var totalArea = width * height;
  var viewChildren = initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth);
  if (!viewChildren.length) {
    return;
  }
  var rect = {
    x: layoutOffset,
    y: layoutOffsetUpper,
    width,
    height
  };
  var rowFixedLength = mathMin$3(width, height);
  var best = Infinity;
  var row = [];
  row.area = 0;
  for (var i = 0, len2 = viewChildren.length; i < len2; ) {
    var child = viewChildren[i];
    row.push(child);
    row.area += child.getLayout().area;
    var score = worst(row, rowFixedLength, options.squareRatio);
    if (score <= best) {
      i++;
      best = score;
    } else {
      row.area -= row.pop().getLayout().area;
      position(row, rowFixedLength, rect, halfGapWidth, false);
      rowFixedLength = mathMin$3(rect.width, rect.height);
      row.length = row.area = 0;
      best = Infinity;
    }
  }
  if (row.length) {
    position(row, rowFixedLength, rect, halfGapWidth, true);
  }
  if (!hideChildren) {
    var childrenVisibleMin = nodeModel.get("childrenVisibleMin");
    if (childrenVisibleMin != null && totalArea < childrenVisibleMin) {
      hideChildren = true;
    }
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    squarify(viewChildren[i], options, hideChildren, depth + 1);
  }
}
function initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth) {
  var viewChildren = node.children || [];
  var orderBy = options.sort;
  orderBy !== "asc" && orderBy !== "desc" && (orderBy = null);
  var overLeafDepth = options.leafDepth != null && options.leafDepth <= depth;
  if (hideChildren && !overLeafDepth) {
    return node.viewChildren = [];
  }
  viewChildren = filter(viewChildren, function(child) {
    return !child.isRemoved();
  });
  sort$1(viewChildren, orderBy);
  var info = statistic(nodeModel, viewChildren, orderBy);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  info.sum = filterByThreshold(nodeModel, totalArea, info.sum, orderBy, viewChildren);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    var area = viewChildren[i].getValue() / info.sum * totalArea;
    viewChildren[i].setLayout({
      area
    });
  }
  if (overLeafDepth) {
    viewChildren.length && node.setLayout({
      isLeafRoot: true
    }, true);
    viewChildren.length = 0;
  }
  node.viewChildren = viewChildren;
  node.setLayout({
    dataExtent: info.dataExtent
  }, true);
  return viewChildren;
}
function filterByThreshold(nodeModel, totalArea, sum2, orderBy, orderedChildren) {
  if (!orderBy) {
    return sum2;
  }
  var visibleMin = nodeModel.get("visibleMin");
  var len2 = orderedChildren.length;
  var deletePoint = len2;
  for (var i = len2 - 1; i >= 0; i--) {
    var value = orderedChildren[orderBy === "asc" ? len2 - i - 1 : i].getValue();
    if (value / sum2 * totalArea < visibleMin) {
      deletePoint = i;
      sum2 -= value;
    }
  }
  orderBy === "asc" ? orderedChildren.splice(0, len2 - deletePoint) : orderedChildren.splice(deletePoint, len2 - deletePoint);
  return sum2;
}
function sort$1(viewChildren, orderBy) {
  if (orderBy) {
    viewChildren.sort(function(a, b2) {
      var diff = orderBy === "asc" ? a.getValue() - b2.getValue() : b2.getValue() - a.getValue();
      return diff === 0 ? orderBy === "asc" ? a.dataIndex - b2.dataIndex : b2.dataIndex - a.dataIndex : diff;
    });
  }
  return viewChildren;
}
function statistic(nodeModel, children, orderBy) {
  var sum2 = 0;
  for (var i = 0, len2 = children.length; i < len2; i++) {
    sum2 += children[i].getValue();
  }
  var dimension = nodeModel.get("visualDimension");
  var dataExtent;
  if (!children || !children.length) {
    dataExtent = [NaN, NaN];
  } else if (dimension === "value" && orderBy) {
    dataExtent = [children[children.length - 1].getValue(), children[0].getValue()];
    orderBy === "asc" && dataExtent.reverse();
  } else {
    dataExtent = [Infinity, -Infinity];
    each$c(children, function(child) {
      var value = child.getValue(dimension);
      value < dataExtent[0] && (dataExtent[0] = value);
      value > dataExtent[1] && (dataExtent[1] = value);
    });
  }
  return {
    sum: sum2,
    dataExtent
  };
}
function worst(row, rowFixedLength, ratio) {
  var areaMax = 0;
  var areaMin = Infinity;
  for (var i = 0, area = void 0, len2 = row.length; i < len2; i++) {
    area = row[i].getLayout().area;
    if (area) {
      area < areaMin && (areaMin = area);
      area > areaMax && (areaMax = area);
    }
  }
  var squareArea = row.area * row.area;
  var f2 = rowFixedLength * rowFixedLength * ratio;
  return squareArea ? mathMax$3(f2 * areaMax / squareArea, squareArea / (f2 * areaMin)) : Infinity;
}
function position(row, rowFixedLength, rect, halfGapWidth, flush) {
  var idx0WhenH = rowFixedLength === rect.width ? 0 : 1;
  var idx1WhenH = 1 - idx0WhenH;
  var xy = ["x", "y"];
  var wh2 = ["width", "height"];
  var last = rect[xy[idx0WhenH]];
  var rowOtherLength = rowFixedLength ? row.area / rowFixedLength : 0;
  if (flush || rowOtherLength > rect[wh2[idx1WhenH]]) {
    rowOtherLength = rect[wh2[idx1WhenH]];
  }
  for (var i = 0, rowLen = row.length; i < rowLen; i++) {
    var node = row[i];
    var nodeLayout = {};
    var step = rowOtherLength ? node.getLayout().area / rowOtherLength : 0;
    var wh1 = nodeLayout[wh2[idx1WhenH]] = mathMax$3(rowOtherLength - 2 * halfGapWidth, 0);
    var remain = rect[xy[idx0WhenH]] + rect[wh2[idx0WhenH]] - last;
    var modWH = i === rowLen - 1 || remain < step ? remain : step;
    var wh0 = nodeLayout[wh2[idx0WhenH]] = mathMax$3(modWH - 2 * halfGapWidth, 0);
    nodeLayout[xy[idx1WhenH]] = rect[xy[idx1WhenH]] + mathMin$3(halfGapWidth, wh1 / 2);
    nodeLayout[xy[idx0WhenH]] = last + mathMin$3(halfGapWidth, wh0 / 2);
    last += modWH;
    node.setLayout(nodeLayout, true);
  }
  rect[xy[idx1WhenH]] += rowOtherLength;
  rect[wh2[idx1WhenH]] -= rowOtherLength;
}
function estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) {
  var currNode = (targetInfo || {}).node;
  var defaultSize = [containerWidth, containerHeight];
  if (!currNode || currNode === viewRoot) {
    return defaultSize;
  }
  var parent;
  var viewArea = containerWidth * containerHeight;
  var area = viewArea * seriesModel.option.zoomToNodeRatio;
  while (parent = currNode.parentNode) {
    var sum2 = 0;
    var siblings = parent.children;
    for (var i = 0, len2 = siblings.length; i < len2; i++) {
      sum2 += siblings[i].getValue();
    }
    var currNodeValue = currNode.getValue();
    if (currNodeValue === 0) {
      return defaultSize;
    }
    area *= sum2 / currNodeValue;
    var parentModel = parent.getModel();
    var borderWidth = parentModel.get(PATH_BORDER_WIDTH);
    var upperHeight = Math.max(borderWidth, getUpperLabelHeight(parentModel));
    area += 4 * borderWidth * borderWidth + (3 * borderWidth + upperHeight) * Math.pow(area, 0.5);
    area > MAX_SAFE_INTEGER && (area = MAX_SAFE_INTEGER);
    currNode = parent;
  }
  area < viewArea && (area = viewArea);
  var scale2 = Math.pow(area / viewArea, 0.5);
  return [containerWidth * scale2, containerHeight * scale2];
}
function calculateRootPosition(layoutInfo, rootRect, targetInfo) {
  if (rootRect) {
    return {
      x: rootRect.x,
      y: rootRect.y
    };
  }
  var defaultPosition = {
    x: 0,
    y: 0
  };
  if (!targetInfo) {
    return defaultPosition;
  }
  var targetNode = targetInfo.node;
  var layout2 = targetNode.getLayout();
  if (!layout2) {
    return defaultPosition;
  }
  var targetCenter = [layout2.width / 2, layout2.height / 2];
  var node = targetNode;
  while (node) {
    var nodeLayout = node.getLayout();
    targetCenter[0] += nodeLayout.x;
    targetCenter[1] += nodeLayout.y;
    node = node.parentNode;
  }
  return {
    x: layoutInfo.width / 2 - targetCenter[0],
    y: layoutInfo.height / 2 - targetCenter[1]
  };
}
function prunning(node, clipRect, viewAbovePath, viewRoot, depth) {
  var nodeLayout = node.getLayout();
  var nodeInViewAbovePath = viewAbovePath[depth];
  var isAboveViewRoot = nodeInViewAbovePath && nodeInViewAbovePath === node;
  if (nodeInViewAbovePath && !isAboveViewRoot || depth === viewAbovePath.length && node !== viewRoot) {
    return;
  }
  node.setLayout({
    isInView: true,
    invisible: !isAboveViewRoot && !clipRect.intersect(nodeLayout),
    isAboveViewRoot
  }, true);
  var childClipRect = new BoundingRect$1(clipRect.x - nodeLayout.x, clipRect.y - nodeLayout.y, clipRect.width, clipRect.height);
  each$c(node.viewChildren || [], function(child) {
    prunning(child, childClipRect, viewAbovePath, viewRoot, depth + 1);
  });
}
function getUpperLabelHeight(model) {
  return model.get(PATH_UPPER_LABEL_SHOW) ? model.get(PATH_UPPER_LABEL_HEIGHT) : 0;
}
function install$G(registers) {
  registers.registerSeriesModel(TreemapSeriesModel$1);
  registers.registerChartView(TreemapView$1);
  registers.registerVisual(treemapVisual);
  registers.registerLayout(treemapLayout);
  installTreemapAction(registers);
}
function categoryFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (!legendModels || !legendModels.length) {
    return;
  }
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var categoriesData = graphSeries.getCategoriesData();
    var graph = graphSeries.getGraph();
    var data2 = graph.data;
    var categoryNames = categoriesData.mapArray(categoriesData.getName);
    data2.filterSelf(function(idx) {
      var model = data2.getItemModel(idx);
      var category = model.getShallow("category");
      if (category != null) {
        if (isNumber(category)) {
          category = categoryNames[category];
        }
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(category)) {
            return false;
          }
        }
      }
      return true;
    });
  });
}
function categoryVisual(ecModel) {
  var paletteScope = {};
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var categoriesData = seriesModel.getCategoriesData();
    var data2 = seriesModel.getData();
    var categoryNameIdxMap = {};
    categoriesData.each(function(idx) {
      var name2 = categoriesData.getName(idx);
      categoryNameIdxMap["ec-" + name2] = idx;
      var itemModel = categoriesData.getItemModel(idx);
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      if (!style2.fill) {
        style2.fill = seriesModel.getColorFromPalette(name2, paletteScope);
      }
      categoriesData.setItemVisual(idx, "style", style2);
      var symbolVisualList = ["symbol", "symbolSize", "symbolKeepAspect"];
      for (var i = 0; i < symbolVisualList.length; i++) {
        var symbolVisual = itemModel.getShallow(symbolVisualList[i], true);
        if (symbolVisual != null) {
          categoriesData.setItemVisual(idx, symbolVisualList[i], symbolVisual);
        }
      }
    });
    if (categoriesData.count()) {
      data2.each(function(idx) {
        var model = data2.getItemModel(idx);
        var categoryIdx = model.getShallow("category");
        if (categoryIdx != null) {
          if (isString$1(categoryIdx)) {
            categoryIdx = categoryNameIdxMap["ec-" + categoryIdx];
          }
          var categoryStyle = categoriesData.getItemVisual(categoryIdx, "style");
          var style2 = data2.ensureUniqueItemVisual(idx, "style");
          extend(style2, categoryStyle);
          var visualList = ["symbol", "symbolSize", "symbolKeepAspect"];
          for (var i = 0; i < visualList.length; i++) {
            data2.setItemVisual(idx, visualList[i], categoriesData.getItemVisual(categoryIdx, visualList[i]));
          }
        }
      });
    }
  });
}
function normalize$2(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
function graphEdgeVisual(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var edgeData = seriesModel.getEdgeData();
    var symbolType = normalize$2(seriesModel.get("edgeSymbol"));
    var symbolSize = normalize$2(seriesModel.get("edgeSymbolSize"));
    edgeData.setVisual("fromSymbol", symbolType && symbolType[0]);
    edgeData.setVisual("toSymbol", symbolType && symbolType[1]);
    edgeData.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    edgeData.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    edgeData.setVisual("style", seriesModel.getModel("lineStyle").getLineStyle());
    edgeData.each(function(idx) {
      var itemModel = edgeData.getItemModel(idx);
      var edge = graph.getEdgeByIndex(idx);
      var symbolType2 = normalize$2(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$2(itemModel.getShallow("symbolSize", true));
      var style2 = itemModel.getModel("lineStyle").getLineStyle();
      var existsStyle = edgeData.ensureUniqueItemVisual(idx, "style");
      extend(existsStyle, style2);
      switch (existsStyle.stroke) {
        case "source": {
          var nodeStyle = edge.node1.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
        case "target": {
          var nodeStyle = edge.node2.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
      }
      symbolType2[0] && edge.setVisual("fromSymbol", symbolType2[0]);
      symbolType2[1] && edge.setVisual("toSymbol", symbolType2[1]);
      symbolSize2[0] && edge.setVisual("fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && edge.setVisual("toSymbolSize", symbolSize2[1]);
    });
  });
}
var KEY_DELIMITER = "-->";
var getAutoCurvenessParams = function(seriesModel) {
  return seriesModel.get("autoCurveness") || null;
};
var createCurveness = function(seriesModel, appendLength) {
  var autoCurvenessParmas = getAutoCurvenessParams(seriesModel);
  var length = 20;
  var curvenessList = [];
  if (isNumber(autoCurvenessParmas)) {
    length = autoCurvenessParmas;
  } else if (isArray$2(autoCurvenessParmas)) {
    seriesModel.__curvenessList = autoCurvenessParmas;
    return;
  }
  if (appendLength > length) {
    length = appendLength;
  }
  var len2 = length % 2 ? length + 2 : length + 3;
  curvenessList = [];
  for (var i = 0; i < len2; i++) {
    curvenessList.push((i % 2 ? i + 1 : i) / 10 * (i % 2 ? -1 : 1));
  }
  seriesModel.__curvenessList = curvenessList;
};
var getKeyOfEdges = function(n1, n2, seriesModel) {
  var source = [n1.id, n1.dataIndex].join(".");
  var target = [n2.id, n2.dataIndex].join(".");
  return [seriesModel.uid, source, target].join(KEY_DELIMITER);
};
var getOppositeKey = function(key) {
  var keys2 = key.split(KEY_DELIMITER);
  return [keys2[0], keys2[2], keys2[1]].join(KEY_DELIMITER);
};
var getEdgeFromMap = function(edge, seriesModel) {
  var key = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  return seriesModel.__edgeMap[key];
};
var getTotalLengthBetweenNodes = function(edge, seriesModel) {
  var len2 = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node1, edge.node2, seriesModel), seriesModel);
  var lenV = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node2, edge.node1, seriesModel), seriesModel);
  return len2 + lenV;
};
var getEdgeMapLengthWithKey = function(key, seriesModel) {
  var edgeMap = seriesModel.__edgeMap;
  return edgeMap[key] ? edgeMap[key].length : 0;
};
function initCurvenessList(seriesModel) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  seriesModel.__curvenessList = [];
  seriesModel.__edgeMap = {};
  createCurveness(seriesModel);
}
function createEdgeMapForCurveness(n1, n2, seriesModel, index2) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  var key = getKeyOfEdges(n1, n2, seriesModel);
  var edgeMap = seriesModel.__edgeMap;
  var oppositeEdges = edgeMap[getOppositeKey(key)];
  if (edgeMap[key] && !oppositeEdges) {
    edgeMap[key].isForward = true;
  } else if (oppositeEdges && edgeMap[key]) {
    oppositeEdges.isForward = true;
    edgeMap[key].isForward = false;
  }
  edgeMap[key] = edgeMap[key] || [];
  edgeMap[key].push(index2);
}
function getCurvenessForEdge(edge, seriesModel, index2, needReverse) {
  var autoCurvenessParams = getAutoCurvenessParams(seriesModel);
  var isArrayParam = isArray$2(autoCurvenessParams);
  if (!autoCurvenessParams) {
    return null;
  }
  var edgeArray = getEdgeFromMap(edge, seriesModel);
  if (!edgeArray) {
    return null;
  }
  var edgeIndex = -1;
  for (var i = 0; i < edgeArray.length; i++) {
    if (edgeArray[i] === index2) {
      edgeIndex = i;
      break;
    }
  }
  var totalLen = getTotalLengthBetweenNodes(edge, seriesModel);
  createCurveness(seriesModel, totalLen);
  edge.lineStyle = edge.lineStyle || {};
  var curKey = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  var curvenessList = seriesModel.__curvenessList;
  var parityCorrection = isArrayParam ? 0 : totalLen % 2 ? 0 : 1;
  if (!edgeArray.isForward) {
    var oppositeKey = getOppositeKey(curKey);
    var len2 = getEdgeMapLengthWithKey(oppositeKey, seriesModel);
    var resValue = curvenessList[edgeIndex + len2 + parityCorrection];
    if (needReverse) {
      if (isArrayParam) {
        if (autoCurvenessParams && autoCurvenessParams[0] === 0) {
          return (len2 + parityCorrection) % 2 ? resValue : -resValue;
        } else {
          return ((len2 % 2 ? 0 : 1) + parityCorrection) % 2 ? resValue : -resValue;
        }
      } else {
        return (len2 + parityCorrection) % 2 ? resValue : -resValue;
      }
    } else {
      return curvenessList[edgeIndex + len2 + parityCorrection];
    }
  } else {
    return curvenessList[parityCorrection + edgeIndex];
  }
}
function simpleLayout(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var graph = seriesModel.getGraph();
  graph.eachNode(function(node) {
    var model = node.getModel();
    node.setLayout([+model.get("x"), +model.get("y")]);
  });
  simpleLayoutEdge(graph, seriesModel);
}
function simpleLayoutEdge(graph, seriesModel) {
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, seriesModel, index2, true), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var points2 = [p1, p2];
    if (+curveness) {
      points2.push([(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * curveness]);
    }
    edge.setLayout(points2);
  });
}
function graphSimpleLayout(ecModel, api) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var layout2 = seriesModel.get("layout");
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      var data_1 = seriesModel.getData();
      var dimensions_1 = [];
      each$g(coordSys.dimensions, function(coordDim) {
        dimensions_1 = dimensions_1.concat(data_1.mapDimensionsAll(coordDim));
      });
      for (var dataIndex = 0; dataIndex < data_1.count(); dataIndex++) {
        var value = [];
        var hasValue = false;
        for (var i = 0; i < dimensions_1.length; i++) {
          var val = data_1.get(dimensions_1[i], dataIndex);
          if (!isNaN(val)) {
            hasValue = true;
          }
          value.push(val);
        }
        if (hasValue) {
          data_1.setItemLayout(dataIndex, coordSys.dataToPoint(value));
        } else {
          data_1.setItemLayout(dataIndex, [NaN, NaN]);
        }
      }
      simpleLayoutEdge(data_1.graph, seriesModel);
    } else if (!layout2 || layout2 === "none") {
      simpleLayout(seriesModel);
    }
  });
}
function getNodeGlobalScale(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys.type !== "view") {
    return 1;
  }
  var nodeScaleRatio = seriesModel.option.nodeScaleRatio;
  var groupZoom = coordSys.scaleX;
  var roamZoom = coordSys.getZoom();
  var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
  return nodeScale / groupZoom;
}
function getSymbolSize(node) {
  var symbolSize = node.getVisual("symbolSize");
  if (symbolSize instanceof Array) {
    symbolSize = (symbolSize[0] + symbolSize[1]) / 2;
  }
  return +symbolSize;
}
var PI$2 = Math.PI;
var _symbolRadiansHalf = [];
function circularLayout(seriesModel, basedOn) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var rect = coordSys.getBoundingRect();
  var nodeData = seriesModel.getData();
  var graph = nodeData.graph;
  var cx = rect.width / 2 + rect.x;
  var cy = rect.height / 2 + rect.y;
  var r2 = Math.min(rect.width, rect.height) / 2;
  var count2 = nodeData.count();
  nodeData.setLayout({
    cx,
    cy
  });
  if (!count2) {
    return;
  }
  _layoutNodesBasedOn[basedOn](seriesModel, graph, nodeData, r2, cx, cy, count2);
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), getCurvenessForEdge(edge, seriesModel, index2), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var cp1;
    var x12 = (p1[0] + p2[0]) / 2;
    var y12 = (p1[1] + p2[1]) / 2;
    if (+curveness) {
      curveness *= 3;
      cp1 = [cx * curveness + x12 * (1 - curveness), cy * curveness + y12 * (1 - curveness)];
    }
    edge.setLayout([p1, p2, cp1]);
  });
}
var _layoutNodesBasedOn = {
  value: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var angle = 0;
    var sum2 = nodeData.getSum("value");
    var unitAngle = Math.PI * 2 / (sum2 || count2);
    graph.eachNode(function(node) {
      var value = node.getValue("value");
      var radianHalf = unitAngle * (sum2 ? value : 1) / 2;
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  },
  symbolSize: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var sumRadian = 0;
    _symbolRadiansHalf.length = count2;
    var nodeScale = getNodeGlobalScale(seriesModel);
    graph.eachNode(function(node) {
      var symbolSize = getSymbolSize(node);
      isNaN(symbolSize) && (symbolSize = 2);
      symbolSize < 0 && (symbolSize = 0);
      symbolSize *= nodeScale;
      var symbolRadianHalf = Math.asin(symbolSize / 2 / r2);
      isNaN(symbolRadianHalf) && (symbolRadianHalf = PI$2 / 2);
      _symbolRadiansHalf[node.dataIndex] = symbolRadianHalf;
      sumRadian += symbolRadianHalf * 2;
    });
    var halfRemainRadian = (2 * PI$2 - sumRadian) / count2 / 2;
    var angle = 0;
    graph.eachNode(function(node) {
      var radianHalf = halfRemainRadian + _symbolRadiansHalf[node.dataIndex];
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  }
};
function graphCircularLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    if (seriesModel.get("layout") === "circular") {
      circularLayout(seriesModel, "symbolSize");
    }
  });
}
var scaleAndAdd = scaleAndAdd$1;
function forceLayout(inNodes, inEdges, opts) {
  var nodes = inNodes;
  var edges = inEdges;
  var rect = opts.rect;
  var width = rect.width;
  var height = rect.height;
  var center2 = [rect.x + width / 2, rect.y + height / 2];
  var gravity = opts.gravity == null ? 0.1 : opts.gravity;
  for (var i = 0; i < nodes.length; i++) {
    var n2 = nodes[i];
    if (!n2.p) {
      n2.p = create$3(width * (Math.random() - 0.5) + center2[0], height * (Math.random() - 0.5) + center2[1]);
    }
    n2.pp = clone$3(n2.p);
    n2.edges = null;
  }
  var initialFriction = opts.friction == null ? 0.6 : opts.friction;
  var friction = initialFriction;
  var beforeStepCallback;
  var afterStepCallback;
  return {
    warmUp: function() {
      friction = initialFriction * 0.8;
    },
    setFixed: function(idx) {
      nodes[idx].fixed = true;
    },
    setUnfixed: function(idx) {
      nodes[idx].fixed = false;
    },
    beforeStep: function(cb2) {
      beforeStepCallback = cb2;
    },
    afterStep: function(cb2) {
      afterStepCallback = cb2;
    },
    step: function(cb2) {
      beforeStepCallback && beforeStepCallback(nodes, edges);
      var v12 = [];
      var nLen = nodes.length;
      for (var i2 = 0; i2 < edges.length; i2++) {
        var e2 = edges[i2];
        if (e2.ignoreForceLayout) {
          continue;
        }
        var n1 = e2.n1;
        var n22 = e2.n2;
        sub(v12, n22.p, n1.p);
        var d2 = len(v12) - e2.d;
        var w2 = n22.w / (n1.w + n22.w);
        if (isNaN(w2)) {
          w2 = 0;
        }
        normalize$4(v12, v12);
        !n1.fixed && scaleAndAdd(n1.p, n1.p, v12, w2 * d2 * friction);
        !n22.fixed && scaleAndAdd(n22.p, n22.p, v12, -(1 - w2) * d2 * friction);
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v12, center2, n3.p);
          scaleAndAdd(n3.p, n3.p, v12, gravity * friction);
        }
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n1 = nodes[i2];
        for (var j = i2 + 1; j < nLen; j++) {
          var n22 = nodes[j];
          sub(v12, n22.p, n1.p);
          var d2 = len(v12);
          if (d2 === 0) {
            set$2(v12, Math.random() - 0.5, Math.random() - 0.5);
            d2 = 1;
          }
          var repFact = (n1.rep + n22.rep) / d2 / d2;
          !n1.fixed && scaleAndAdd(n1.pp, n1.pp, v12, repFact);
          !n22.fixed && scaleAndAdd(n22.pp, n22.pp, v12, -repFact);
        }
      }
      var v4 = [];
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v4, n3.p, n3.pp);
          scaleAndAdd(n3.p, n3.p, v4, friction);
          copy$1(n3.pp, n3.p);
        }
      }
      friction = friction * 0.992;
      var finished = friction < 0.01;
      afterStepCallback && afterStepCallback(nodes, edges, finished);
      cb2 && cb2(finished);
    }
  };
}
function graphForceLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var coordSys = graphSeries.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      return;
    }
    if (graphSeries.get("layout") === "force") {
      var preservedPoints_1 = graphSeries.preservedPoints || {};
      var graph_1 = graphSeries.getGraph();
      var nodeData_1 = graph_1.data;
      var edgeData = graph_1.edgeData;
      var forceModel = graphSeries.getModel("force");
      var initLayout = forceModel.get("initLayout");
      if (graphSeries.preservedPoints) {
        nodeData_1.each(function(idx) {
          var id2 = nodeData_1.getId(idx);
          nodeData_1.setItemLayout(idx, preservedPoints_1[id2] || [NaN, NaN]);
        });
      } else if (!initLayout || initLayout === "none") {
        simpleLayout(graphSeries);
      } else if (initLayout === "circular") {
        circularLayout(graphSeries, "value");
      }
      var nodeDataExtent_1 = nodeData_1.getDataExtent("value");
      var edgeDataExtent_1 = edgeData.getDataExtent("value");
      var repulsion = forceModel.get("repulsion");
      var edgeLength = forceModel.get("edgeLength");
      var repulsionArr_1 = isArray$2(repulsion) ? repulsion : [repulsion, repulsion];
      var edgeLengthArr_1 = isArray$2(edgeLength) ? edgeLength : [edgeLength, edgeLength];
      edgeLengthArr_1 = [edgeLengthArr_1[1], edgeLengthArr_1[0]];
      var nodes_1 = nodeData_1.mapArray("value", function(value, idx) {
        var point = nodeData_1.getItemLayout(idx);
        var rep = linearMap$2(value, nodeDataExtent_1, repulsionArr_1);
        if (isNaN(rep)) {
          rep = (repulsionArr_1[0] + repulsionArr_1[1]) / 2;
        }
        return {
          w: rep,
          rep,
          fixed: nodeData_1.getItemModel(idx).get("fixed"),
          p: !point || isNaN(point[0]) || isNaN(point[1]) ? null : point
        };
      });
      var edges = edgeData.mapArray("value", function(value, idx) {
        var edge = graph_1.getEdgeByIndex(idx);
        var d2 = linearMap$2(value, edgeDataExtent_1, edgeLengthArr_1);
        if (isNaN(d2)) {
          d2 = (edgeLengthArr_1[0] + edgeLengthArr_1[1]) / 2;
        }
        var edgeModel = edge.getModel();
        var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, graphSeries, idx, true), 0);
        return {
          n1: nodes_1[edge.node1.dataIndex],
          n2: nodes_1[edge.node2.dataIndex],
          d: d2,
          curveness,
          ignoreForceLayout: edgeModel.get("ignoreForceLayout")
        };
      });
      var rect = coordSys.getBoundingRect();
      var forceInstance = forceLayout(nodes_1, edges, {
        rect,
        gravity: forceModel.get("gravity"),
        friction: forceModel.get("friction")
      });
      forceInstance.beforeStep(function(nodes, edges2) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (nodes[i].fixed) {
            copy$1(nodes[i].p, graph_1.getNodeByIndex(i).getLayout());
          }
        }
      });
      forceInstance.afterStep(function(nodes, edges2, stopped) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (!nodes[i].fixed) {
            graph_1.getNodeByIndex(i).setLayout(nodes[i].p);
          }
          preservedPoints_1[nodeData_1.getId(i)] = nodes[i].p;
        }
        for (var i = 0, l2 = edges2.length; i < l2; i++) {
          var e2 = edges2[i];
          var edge = graph_1.getEdgeByIndex(i);
          var p1 = e2.n1.p;
          var p2 = e2.n2.p;
          var points2 = edge.getLayout();
          points2 = points2 ? points2.slice() : [];
          points2[0] = points2[0] || [];
          points2[1] = points2[1] || [];
          copy$1(points2[0], p1);
          copy$1(points2[1], p2);
          if (+e2.curveness) {
            points2[2] = [(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * e2.curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * e2.curveness];
          }
          edge.setLayout(points2);
        }
      });
      graphSeries.forceLayout = forceInstance;
      graphSeries.preservedPoints = preservedPoints_1;
      forceInstance.step();
    } else {
      graphSeries.forceLayout = null;
    }
  });
}
function getViewRect$3(seriesModel, api, aspect) {
  var option = extend(seriesModel.getBoxLayoutParams(), {
    aspect
  });
  return getLayoutRect(option, {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function createViewCoordSys(ecModel, api) {
  var viewList = [];
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var coordSysType = seriesModel.get("coordinateSystem");
    if (!coordSysType || coordSysType === "view") {
      var data_1 = seriesModel.getData();
      var positions = data_1.mapArray(function(idx) {
        var itemModel = data_1.getItemModel(idx);
        return [+itemModel.get("x"), +itemModel.get("y")];
      });
      var min3 = [];
      var max3 = [];
      fromPoints(positions, min3, max3);
      if (max3[0] - min3[0] === 0) {
        max3[0] += 1;
        min3[0] -= 1;
      }
      if (max3[1] - min3[1] === 0) {
        max3[1] += 1;
        min3[1] -= 1;
      }
      var aspect = (max3[0] - min3[0]) / (max3[1] - min3[1]);
      var viewRect2 = getViewRect$3(seriesModel, api, aspect);
      if (isNaN(aspect)) {
        min3 = [viewRect2.x, viewRect2.y];
        max3 = [viewRect2.x + viewRect2.width, viewRect2.y + viewRect2.height];
      }
      var bbWidth = max3[0] - min3[0];
      var bbHeight = max3[1] - min3[1];
      var viewWidth = viewRect2.width;
      var viewHeight = viewRect2.height;
      var viewCoordSys = seriesModel.coordinateSystem = new View$1();
      viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
      viewCoordSys.setBoundingRect(min3[0], min3[1], bbWidth, bbHeight);
      viewCoordSys.setViewRect(viewRect2.x, viewRect2.y, viewWidth, viewHeight);
      viewCoordSys.setCenter(seriesModel.get("center"));
      viewCoordSys.setZoom(seriesModel.get("zoom"));
      viewList.push(viewCoordSys);
    }
  });
  return viewList;
}
var straightLineProto = Line$3.prototype;
var bezierCurveProto = BezierCurve$1.prototype;
var StraightLineShape = function() {
  function StraightLineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return StraightLineShape2;
}();
(function(_super) {
  __extends(CurveShape, _super);
  function CurveShape() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return CurveShape;
})(StraightLineShape);
function isStraightLine(shape) {
  return isNaN(+shape.cpx1) || isNaN(+shape.cpy1);
}
var ECLinePath = function(_super) {
  __extends(ECLinePath2, _super);
  function ECLinePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-line";
    return _this;
  }
  ECLinePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECLinePath2.prototype.getDefaultShape = function() {
    return new StraightLineShape();
  };
  ECLinePath2.prototype.buildPath = function(ctx, shape) {
    if (isStraightLine(shape)) {
      straightLineProto.buildPath.call(this, ctx, shape);
    } else {
      bezierCurveProto.buildPath.call(this, ctx, shape);
    }
  };
  ECLinePath2.prototype.pointAt = function(t2) {
    if (isStraightLine(this.shape)) {
      return straightLineProto.pointAt.call(this, t2);
    } else {
      return bezierCurveProto.pointAt.call(this, t2);
    }
  };
  ECLinePath2.prototype.tangentAt = function(t2) {
    var shape = this.shape;
    var p2 = isStraightLine(shape) ? [shape.x2 - shape.x1, shape.y2 - shape.y1] : bezierCurveProto.tangentAt.call(this, t2);
    return normalize$4(p2, p2);
  };
  return ECLinePath2;
}(Path$1);
var ECLinePath$1 = ECLinePath;
var SYMBOL_CATEGORIES = ["fromSymbol", "toSymbol"];
function makeSymbolTypeKey(symbolCategory) {
  return "_" + symbolCategory + "Type";
}
function createSymbol(name2, lineData, idx) {
  var symbolType = lineData.getItemVisual(idx, name2);
  if (!symbolType || symbolType === "none") {
    return;
  }
  var symbolSize = lineData.getItemVisual(idx, name2 + "Size");
  var symbolRotate = lineData.getItemVisual(idx, name2 + "Rotate");
  var symbolOffset = lineData.getItemVisual(idx, name2 + "Offset");
  var symbolKeepAspect = lineData.getItemVisual(idx, name2 + "KeepAspect");
  var symbolSizeArr = normalizeSymbolSize(symbolSize);
  var symbolOffsetArr = normalizeSymbolOffset(symbolOffset || 0, symbolSizeArr);
  var symbolPath = createSymbol$1(symbolType, -symbolSizeArr[0] / 2 + symbolOffsetArr[0], -symbolSizeArr[1] / 2 + symbolOffsetArr[1], symbolSizeArr[0], symbolSizeArr[1], null, symbolKeepAspect);
  symbolPath.__specifiedRotation = symbolRotate == null || isNaN(symbolRotate) ? void 0 : +symbolRotate * Math.PI / 180 || 0;
  symbolPath.name = name2;
  return symbolPath;
}
function createLine(points2) {
  var line = new ECLinePath$1({
    name: "line",
    subPixelOptimize: true
  });
  setLinePoints(line.shape, points2);
  return line;
}
function setLinePoints(targetShape, points2) {
  targetShape.x1 = points2[0][0];
  targetShape.y1 = points2[0][1];
  targetShape.x2 = points2[1][0];
  targetShape.y2 = points2[1][1];
  targetShape.percent = 1;
  var cp1 = points2[2];
  if (cp1) {
    targetShape.cpx1 = cp1[0];
    targetShape.cpy1 = cp1[1];
  } else {
    targetShape.cpx1 = NaN;
    targetShape.cpy1 = NaN;
  }
}
var Line = function(_super) {
  __extends(Line2, _super);
  function Line2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createLine(lineData, idx, seriesScope);
    return _this;
  }
  Line2.prototype._createLine = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var linePoints = lineData.getItemLayout(idx);
    var line = createLine(linePoints);
    line.shape.percent = 0;
    initProps(line, {
      shape: {
        percent: 1
      }
    }, seriesModel, idx);
    this.add(line);
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = createSymbol(symbolCategory, lineData, idx);
      this.add(symbol);
      this[makeSymbolTypeKey(symbolCategory)] = lineData.getItemVisual(idx, symbolCategory);
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var linePoints = lineData.getItemLayout(idx);
    var target = {
      shape: {}
    };
    setLinePoints(target.shape, linePoints);
    updateProps$1(line, target, seriesModel, idx);
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbolType = lineData.getItemVisual(idx, symbolCategory);
      var key = makeSymbolTypeKey(symbolCategory);
      if (this[key] !== symbolType) {
        this.remove(this.childOfName(symbolCategory));
        var symbol = createSymbol(symbolCategory, lineData, idx);
        this.add(symbol);
      }
      this[key] = symbolType;
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.getLinePath = function() {
    return this.childAt(0);
  };
  Line2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var blurLineStyle = seriesScope && seriesScope.blurLineStyle;
    var selectLineStyle = seriesScope && seriesScope.selectLineStyle;
    var labelStatesModels = seriesScope && seriesScope.labelStatesModels;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    if (!seriesScope || lineData.hasItemOption) {
      var itemModel = lineData.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      blurLineStyle = itemModel.getModel(["blur", "lineStyle"]).getLineStyle();
      selectLineStyle = itemModel.getModel(["select", "lineStyle"]).getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      labelStatesModels = getLabelStatesModels(itemModel);
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var visualColor = lineStyle.stroke;
    line.useStyle(lineStyle);
    line.style.fill = null;
    line.style.strokeNoScale = true;
    line.ensureState("emphasis").style = emphasisLineStyle;
    line.ensureState("blur").style = blurLineStyle;
    line.ensureState("select").style = selectLineStyle;
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = this.childOfName(symbolCategory);
      if (symbol) {
        symbol.setColor(visualColor);
        symbol.style.opacity = lineStyle.opacity;
        for (var i = 0; i < SPECIAL_STATES.length; i++) {
          var stateName = SPECIAL_STATES[i];
          var lineState = line.getState(stateName);
          if (lineState) {
            var lineStateStyle = lineState.style || {};
            var state = symbol.ensureState(stateName);
            var stateStyle = state.style || (state.style = {});
            if (lineStateStyle.stroke != null) {
              stateStyle[symbol.__isEmptyBrush ? "stroke" : "fill"] = lineStateStyle.stroke;
            }
            if (lineStateStyle.opacity != null) {
              stateStyle.opacity = lineStateStyle.opacity;
            }
          }
        }
        symbol.markRedraw();
      }
    }, this);
    var rawVal = seriesModel.getRawValue(idx);
    setLabelStyle(this, labelStatesModels, {
      labelDataIndex: idx,
      labelFetcher: {
        getFormattedLabel: function(dataIndex, stateName) {
          return seriesModel.getFormattedLabel(dataIndex, stateName, lineData.dataType);
        }
      },
      inheritColor: visualColor || "#000",
      defaultOpacity: lineStyle.opacity,
      defaultText: (rawVal == null ? lineData.getName(idx) : isFinite(rawVal) ? round$3(rawVal) : rawVal) + ""
    });
    var label = this.getTextContent();
    if (label) {
      var labelNormalModel = labelStatesModels.normal;
      label.__align = label.style.align;
      label.__verticalAlign = label.style.verticalAlign;
      label.__position = labelNormalModel.get("position") || "middle";
      var distance2 = labelNormalModel.get("distance");
      if (!isArray$2(distance2)) {
        distance2 = [distance2, distance2];
      }
      label.__labelDistance = distance2;
    }
    this.setTextConfig({
      position: null,
      local: true,
      inside: false
    });
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Line2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  Line2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  Line2.prototype.updateLayout = function(lineData, idx) {
    this.setLinePoints(lineData.getItemLayout(idx));
  };
  Line2.prototype.setLinePoints = function(points2) {
    var linePath = this.childOfName("line");
    setLinePoints(linePath.shape, points2);
    linePath.dirty();
  };
  Line2.prototype.beforeUpdate = function() {
    var lineGroup = this;
    var symbolFrom = lineGroup.childOfName("fromSymbol");
    var symbolTo = lineGroup.childOfName("toSymbol");
    var label = lineGroup.getTextContent();
    if (!symbolFrom && !symbolTo && (!label || label.ignore)) {
      return;
    }
    var invScale = 1;
    var parentNode2 = this.parent;
    while (parentNode2) {
      if (parentNode2.scaleX) {
        invScale /= parentNode2.scaleX;
      }
      parentNode2 = parentNode2.parent;
    }
    var line = lineGroup.childOfName("line");
    if (!this.__dirty && !line.__dirty) {
      return;
    }
    var percent = line.shape.percent;
    var fromPos = line.pointAt(0);
    var toPos = line.pointAt(percent);
    var d2 = sub([], toPos, fromPos);
    normalize$4(d2, d2);
    function setSymbolRotation(symbol, percent2) {
      var specifiedRotation = symbol.__specifiedRotation;
      if (specifiedRotation == null) {
        var tangent2 = line.tangentAt(percent2);
        symbol.attr("rotation", (percent2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(tangent2[1], tangent2[0]));
      } else {
        symbol.attr("rotation", specifiedRotation);
      }
    }
    if (symbolFrom) {
      symbolFrom.setPosition(fromPos);
      setSymbolRotation(symbolFrom, 0);
      symbolFrom.scaleX = symbolFrom.scaleY = invScale * percent;
      symbolFrom.markRedraw();
    }
    if (symbolTo) {
      symbolTo.setPosition(toPos);
      setSymbolRotation(symbolTo, 1);
      symbolTo.scaleX = symbolTo.scaleY = invScale * percent;
      symbolTo.markRedraw();
    }
    if (label && !label.ignore) {
      label.x = label.y = 0;
      label.originX = label.originY = 0;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var distance2 = label.__labelDistance;
      var distanceX = distance2[0] * invScale;
      var distanceY = distance2[1] * invScale;
      var halfPercent = percent / 2;
      var tangent = line.tangentAt(halfPercent);
      var n2 = [tangent[1], -tangent[0]];
      var cp = line.pointAt(halfPercent);
      if (n2[1] > 0) {
        n2[0] = -n2[0];
        n2[1] = -n2[1];
      }
      var dir3 = tangent[0] < 0 ? -1 : 1;
      if (label.__position !== "start" && label.__position !== "end") {
        var rotation = -Math.atan2(tangent[1], tangent[0]);
        if (toPos[0] < fromPos[0]) {
          rotation = Math.PI + rotation;
        }
        label.rotation = rotation;
      }
      var dy = void 0;
      switch (label.__position) {
        case "insideStartTop":
        case "insideMiddleTop":
        case "insideEndTop":
        case "middle":
          dy = -distanceY;
          textVerticalAlign = "bottom";
          break;
        case "insideStartBottom":
        case "insideMiddleBottom":
        case "insideEndBottom":
          dy = distanceY;
          textVerticalAlign = "top";
          break;
        default:
          dy = 0;
          textVerticalAlign = "middle";
      }
      switch (label.__position) {
        case "end":
          label.x = d2[0] * distanceX + toPos[0];
          label.y = d2[1] * distanceY + toPos[1];
          textAlign = d2[0] > 0.8 ? "left" : d2[0] < -0.8 ? "right" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "top" : d2[1] < -0.8 ? "bottom" : "middle";
          break;
        case "start":
          label.x = -d2[0] * distanceX + fromPos[0];
          label.y = -d2[1] * distanceY + fromPos[1];
          textAlign = d2[0] > 0.8 ? "right" : d2[0] < -0.8 ? "left" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "bottom" : d2[1] < -0.8 ? "top" : "middle";
          break;
        case "insideStartTop":
        case "insideStart":
        case "insideStartBottom":
          label.x = distanceX * dir3 + fromPos[0];
          label.y = fromPos[1] + dy;
          textAlign = tangent[0] < 0 ? "right" : "left";
          label.originX = -distanceX * dir3;
          label.originY = -dy;
          break;
        case "insideMiddleTop":
        case "insideMiddle":
        case "insideMiddleBottom":
        case "middle":
          label.x = cp[0];
          label.y = cp[1] + dy;
          textAlign = "center";
          label.originY = -dy;
          break;
        case "insideEndTop":
        case "insideEnd":
        case "insideEndBottom":
          label.x = -distanceX * dir3 + toPos[0];
          label.y = toPos[1] + dy;
          textAlign = tangent[0] >= 0 ? "right" : "left";
          label.originX = distanceX * dir3;
          label.originY = -dy;
          break;
      }
      label.scaleX = label.scaleY = invScale;
      label.setStyle({
        verticalAlign: label.__verticalAlign || textVerticalAlign,
        align: label.__align || textAlign
      });
    }
  };
  return Line2;
}(Group$6);
var Line$1 = Line;
var LineDraw = function() {
  function LineDraw2(LineCtor) {
    this.group = new Group$6();
    this._LineCtor = LineCtor || Line$1;
  }
  LineDraw2.prototype.updateData = function(lineData) {
    var _this = this;
    this._progressiveEls = null;
    var lineDraw = this;
    var group = lineDraw.group;
    var oldLineData = lineDraw._lineData;
    lineDraw._lineData = lineData;
    if (!oldLineData) {
      group.removeAll();
    }
    var seriesScope = makeSeriesScope$1(lineData);
    lineData.diff(oldLineData).add(function(idx) {
      _this._doAdd(lineData, idx, seriesScope);
    }).update(function(newIdx, oldIdx) {
      _this._doUpdate(oldLineData, lineData, oldIdx, newIdx, seriesScope);
    }).remove(function(idx) {
      group.remove(oldLineData.getItemGraphicEl(idx));
    }).execute();
  };
  LineDraw2.prototype.updateLayout = function() {
    var lineData = this._lineData;
    if (!lineData) {
      return;
    }
    lineData.eachItemGraphicEl(function(el, idx) {
      el.updateLayout(lineData, idx);
    }, this);
  };
  LineDraw2.prototype.incrementalPrepareUpdate = function(lineData) {
    this._seriesScope = makeSeriesScope$1(lineData);
    this._lineData = null;
    this.group.removeAll();
  };
  LineDraw2.prototype.incrementalUpdate = function(taskParams, lineData) {
    this._progressiveEls = [];
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup && !isEffectObject(el2)) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var itemLayout = lineData.getItemLayout(idx);
      if (lineNeedsDraw(itemLayout)) {
        var el = new this._LineCtor(lineData, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        this.group.add(el);
        lineData.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  LineDraw2.prototype.remove = function() {
    this.group.removeAll();
  };
  LineDraw2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  LineDraw2.prototype._doAdd = function(lineData, idx, seriesScope) {
    var itemLayout = lineData.getItemLayout(idx);
    if (!lineNeedsDraw(itemLayout)) {
      return;
    }
    var el = new this._LineCtor(lineData, idx, seriesScope);
    lineData.setItemGraphicEl(idx, el);
    this.group.add(el);
  };
  LineDraw2.prototype._doUpdate = function(oldLineData, newLineData, oldIdx, newIdx, seriesScope) {
    var itemEl = oldLineData.getItemGraphicEl(oldIdx);
    if (!lineNeedsDraw(newLineData.getItemLayout(newIdx))) {
      this.group.remove(itemEl);
      return;
    }
    if (!itemEl) {
      itemEl = new this._LineCtor(newLineData, newIdx, seriesScope);
    } else {
      itemEl.updateData(newLineData, newIdx, seriesScope);
    }
    newLineData.setItemGraphicEl(newIdx, itemEl);
    this.group.add(itemEl);
  };
  return LineDraw2;
}();
function isEffectObject(el) {
  return el.animators && el.animators.length > 0;
}
function makeSeriesScope$1(lineData) {
  var hostModel = lineData.hostModel;
  var emphasisModel = hostModel.getModel("emphasis");
  return {
    lineStyle: hostModel.getModel("lineStyle").getLineStyle(),
    emphasisLineStyle: emphasisModel.getModel(["lineStyle"]).getLineStyle(),
    blurLineStyle: hostModel.getModel(["blur", "lineStyle"]).getLineStyle(),
    selectLineStyle: hostModel.getModel(["select", "lineStyle"]).getLineStyle(),
    emphasisDisabled: emphasisModel.get("disabled"),
    blurScope: emphasisModel.get("blurScope"),
    focus: emphasisModel.get("focus"),
    labelStatesModels: getLabelStatesModels(hostModel)
  };
}
function isPointNaN(pt) {
  return isNaN(pt[0]) || isNaN(pt[1]);
}
function lineNeedsDraw(pts) {
  return pts && !isPointNaN(pts[0]) && !isPointNaN(pts[1]);
}
var LineDraw$1 = LineDraw;
var v1 = [];
var v2 = [];
var v3 = [];
var quadraticAt = quadraticAt$1;
var v2DistSquare = distSquare;
var mathAbs = Math.abs;
function intersectCurveCircle(curvePoints, center2, radius) {
  var p0 = curvePoints[0];
  var p1 = curvePoints[1];
  var p2 = curvePoints[2];
  var d2 = Infinity;
  var t2;
  var radiusSquare = radius * radius;
  var interval = 0.1;
  for (var _t = 0.1; _t <= 0.9; _t += 0.1) {
    v1[0] = quadraticAt(p0[0], p1[0], p2[0], _t);
    v1[1] = quadraticAt(p0[1], p1[1], p2[1], _t);
    var diff = mathAbs(v2DistSquare(v1, center2) - radiusSquare);
    if (diff < d2) {
      d2 = diff;
      t2 = _t;
    }
  }
  for (var i = 0; i < 32; i++) {
    var next = t2 + interval;
    v2[0] = quadraticAt(p0[0], p1[0], p2[0], t2);
    v2[1] = quadraticAt(p0[1], p1[1], p2[1], t2);
    v3[0] = quadraticAt(p0[0], p1[0], p2[0], next);
    v3[1] = quadraticAt(p0[1], p1[1], p2[1], next);
    var diff = v2DistSquare(v2, center2) - radiusSquare;
    if (mathAbs(diff) < 0.01) {
      break;
    }
    var nextDiff = v2DistSquare(v3, center2) - radiusSquare;
    interval /= 2;
    if (diff < 0) {
      if (nextDiff >= 0) {
        t2 = t2 + interval;
      } else {
        t2 = t2 - interval;
      }
    } else {
      if (nextDiff >= 0) {
        t2 = t2 - interval;
      } else {
        t2 = t2 + interval;
      }
    }
  }
  return t2;
}
function adjustEdge(graph, scale2) {
  var tmp0 = [];
  var quadraticSubdivide$1 = quadraticSubdivide;
  var pts = [[], [], []];
  var pts2 = [[], []];
  var v4 = [];
  scale2 /= 2;
  graph.eachEdge(function(edge, idx) {
    var linePoints = edge.getLayout();
    var fromSymbol = edge.getVisual("fromSymbol");
    var toSymbol = edge.getVisual("toSymbol");
    if (!linePoints.__original) {
      linePoints.__original = [clone$3(linePoints[0]), clone$3(linePoints[1])];
      if (linePoints[2]) {
        linePoints.__original.push(clone$3(linePoints[2]));
      }
    }
    var originalPoints = linePoints.__original;
    if (linePoints[2] != null) {
      copy$1(pts[0], originalPoints[0]);
      copy$1(pts[1], originalPoints[2]);
      copy$1(pts[2], originalPoints[1]);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        var t2 = intersectCurveCircle(pts, originalPoints[0], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[0][0] = tmp0[3];
        pts[1][0] = tmp0[4];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[0][1] = tmp0[3];
        pts[1][1] = tmp0[4];
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        var t2 = intersectCurveCircle(pts, originalPoints[1], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[1][0] = tmp0[1];
        pts[2][0] = tmp0[2];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[1][1] = tmp0[1];
        pts[2][1] = tmp0[2];
      }
      copy$1(linePoints[0], pts[0]);
      copy$1(linePoints[1], pts[2]);
      copy$1(linePoints[2], pts[1]);
    } else {
      copy$1(pts2[0], originalPoints[0]);
      copy$1(pts2[1], originalPoints[1]);
      sub(v4, pts2[1], pts2[0]);
      normalize$4(v4, v4);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        scaleAndAdd$1(pts2[0], pts2[0], v4, symbolSize * scale2);
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        scaleAndAdd$1(pts2[1], pts2[1], v4, -symbolSize * scale2);
      }
      copy$1(linePoints[0], pts2[0]);
      copy$1(linePoints[1], pts2[1]);
    }
  });
}
function isViewCoordSys(coordSys) {
  return coordSys.type === "view";
}
var GraphView = function(_super) {
  __extends(GraphView2, _super);
  function GraphView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphView2.type;
    return _this;
  }
  GraphView2.prototype.init = function(ecModel, api) {
    var symbolDraw = new SymbolDraw$1();
    var lineDraw = new LineDraw$1();
    var group = this.group;
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    group.add(symbolDraw.group);
    group.add(lineDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineDraw = lineDraw;
    this._firstRender = true;
  };
  GraphView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    this._model = seriesModel;
    var symbolDraw = this._symbolDraw;
    var lineDraw = this._lineDraw;
    var group = this.group;
    if (isViewCoordSys(coordSys)) {
      var groupNewProp = {
        x: coordSys.x,
        y: coordSys.y,
        scaleX: coordSys.scaleX,
        scaleY: coordSys.scaleY
      };
      if (this._firstRender) {
        group.attr(groupNewProp);
      } else {
        updateProps$1(group, groupNewProp, seriesModel);
      }
    }
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    var data2 = seriesModel.getData();
    symbolDraw.updateData(data2);
    var edgeData = seriesModel.getEdgeData();
    lineDraw.updateData(edgeData);
    this._updateNodeAndLinkScale();
    this._updateController(seriesModel, ecModel, api);
    clearTimeout(this._layoutTimeout);
    var forceLayout2 = seriesModel.forceLayout;
    var layoutAnimation = seriesModel.get(["force", "layoutAnimation"]);
    if (forceLayout2) {
      this._startForceLayoutIteration(forceLayout2, layoutAnimation);
    }
    data2.graph.eachNode(function(node) {
      var idx = node.dataIndex;
      var el = node.getGraphicEl();
      var itemModel = node.getModel();
      if (!el) {
        return;
      }
      el.off("drag").off("dragend");
      var draggable = itemModel.get("draggable");
      if (draggable) {
        el.on("drag", function() {
          if (forceLayout2) {
            forceLayout2.warmUp();
            !_this._layouting && _this._startForceLayoutIteration(forceLayout2, layoutAnimation);
            forceLayout2.setFixed(idx);
            data2.setItemLayout(idx, [el.x, el.y]);
          }
        }).on("dragend", function() {
          if (forceLayout2) {
            forceLayout2.setUnfixed(idx);
          }
        });
      }
      el.setDraggable(draggable && !!forceLayout2);
      var focus = itemModel.get(["emphasis", "focus"]);
      if (focus === "adjacency") {
        getECData(el).focus = node.getAdjacentDataIndices();
      }
    });
    data2.graph.eachEdge(function(edge) {
      var el = edge.getGraphicEl();
      var focus = edge.getModel().get(["emphasis", "focus"]);
      if (!el) {
        return;
      }
      if (focus === "adjacency") {
        getECData(el).focus = {
          edge: [edge.dataIndex],
          node: [edge.node1.dataIndex, edge.node2.dataIndex]
        };
      }
    });
    var circularRotateLabel = seriesModel.get("layout") === "circular" && seriesModel.get(["circular", "rotateLabel"]);
    var cx = data2.getLayout("cx");
    var cy = data2.getLayout("cy");
    data2.eachItemGraphicEl(function(el, idx) {
      var itemModel = data2.getItemModel(idx);
      var labelRotate = itemModel.get(["label", "rotate"]) || 0;
      var symbolPath = el.getSymbolPath();
      if (circularRotateLabel) {
        var pos = data2.getItemLayout(idx);
        var rad = Math.atan2(pos[1] - cy, pos[0] - cx);
        if (rad < 0) {
          rad = Math.PI * 2 + rad;
        }
        var isLeft = pos[0] < cx;
        if (isLeft) {
          rad = rad - Math.PI;
        }
        var textPosition = isLeft ? "left" : "right";
        symbolPath.setTextConfig({
          rotation: -rad,
          position: textPosition,
          origin: "center"
        });
        var emphasisState = symbolPath.ensureState("emphasis");
        extend(emphasisState.textConfig || (emphasisState.textConfig = {}), {
          position: textPosition
        });
      } else {
        symbolPath.setTextConfig({
          rotation: labelRotate *= Math.PI / 180
        });
      }
    });
    this._firstRender = false;
  };
  GraphView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  GraphView2.prototype._startForceLayoutIteration = function(forceLayout2, layoutAnimation) {
    var self2 = this;
    (function step() {
      forceLayout2.step(function(stopped) {
        self2.updateLayout(self2._model);
        (self2._layouting = !stopped) && (layoutAnimation ? self2._layoutTimeout = setTimeout(step, 16) : step());
      });
    })();
  };
  GraphView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    if (!isViewCoordSys(seriesModel.coordinateSystem)) {
      controller.disable();
      return;
    }
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale();
      adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
      _this._lineDraw.updateLayout();
      api.updateLabelLayout();
    });
  };
  GraphView2.prototype._updateNodeAndLinkScale = function() {
    var seriesModel = this._model;
    var data2 = seriesModel.getData();
    var nodeScale = getNodeGlobalScale(seriesModel);
    data2.eachItemGraphicEl(function(el, idx) {
      el && el.setSymbolScale(nodeScale);
    });
  };
  GraphView2.prototype.updateLayout = function(seriesModel) {
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    this._symbolDraw.updateLayout();
    this._lineDraw.updateLayout();
  };
  GraphView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove();
    this._lineDraw && this._lineDraw.remove();
  };
  GraphView2.type = "graph";
  return GraphView2;
}(ChartView$1);
var GraphView$1 = GraphView;
function generateNodeKey(id2) {
  return "_EC_" + id2;
}
var Graph = function() {
  function Graph2(directed) {
    this.type = "graph";
    this.nodes = [];
    this.edges = [];
    this._nodesMap = {};
    this._edgesMap = {};
    this._directed = directed || false;
  }
  Graph2.prototype.isDirected = function() {
    return this._directed;
  };
  Graph2.prototype.addNode = function(id2, dataIndex) {
    id2 = id2 == null ? "" + dataIndex : "" + id2;
    var nodesMap = this._nodesMap;
    if (nodesMap[generateNodeKey(id2)]) {
      return;
    }
    var node = new GraphNode(id2, dataIndex);
    node.hostGraph = this;
    this.nodes.push(node);
    nodesMap[generateNodeKey(id2)] = node;
    return node;
  };
  Graph2.prototype.getNodeByIndex = function(dataIndex) {
    var rawIdx = this.data.getRawIndex(dataIndex);
    return this.nodes[rawIdx];
  };
  Graph2.prototype.getNodeById = function(id2) {
    return this._nodesMap[generateNodeKey(id2)];
  };
  Graph2.prototype.addEdge = function(n1, n2, dataIndex) {
    var nodesMap = this._nodesMap;
    var edgesMap = this._edgesMap;
    if (isNumber(n1)) {
      n1 = this.nodes[n1];
    }
    if (isNumber(n2)) {
      n2 = this.nodes[n2];
    }
    if (!(n1 instanceof GraphNode)) {
      n1 = nodesMap[generateNodeKey(n1)];
    }
    if (!(n2 instanceof GraphNode)) {
      n2 = nodesMap[generateNodeKey(n2)];
    }
    if (!n1 || !n2) {
      return;
    }
    var key = n1.id + "-" + n2.id;
    var edge = new GraphEdge(n1, n2, dataIndex);
    edge.hostGraph = this;
    if (this._directed) {
      n1.outEdges.push(edge);
      n2.inEdges.push(edge);
    }
    n1.edges.push(edge);
    if (n1 !== n2) {
      n2.edges.push(edge);
    }
    this.edges.push(edge);
    edgesMap[key] = edge;
    return edge;
  };
  Graph2.prototype.getEdgeByIndex = function(dataIndex) {
    var rawIdx = this.edgeData.getRawIndex(dataIndex);
    return this.edges[rawIdx];
  };
  Graph2.prototype.getEdge = function(n1, n2) {
    if (n1 instanceof GraphNode) {
      n1 = n1.id;
    }
    if (n2 instanceof GraphNode) {
      n2 = n2.id;
    }
    var edgesMap = this._edgesMap;
    if (this._directed) {
      return edgesMap[n1 + "-" + n2];
    } else {
      return edgesMap[n1 + "-" + n2] || edgesMap[n2 + "-" + n1];
    }
  };
  Graph2.prototype.eachNode = function(cb2, context) {
    var nodes = this.nodes;
    var len2 = nodes.length;
    for (var i = 0; i < len2; i++) {
      if (nodes[i].dataIndex >= 0) {
        cb2.call(context, nodes[i], i);
      }
    }
  };
  Graph2.prototype.eachEdge = function(cb2, context) {
    var edges = this.edges;
    var len2 = edges.length;
    for (var i = 0; i < len2; i++) {
      if (edges[i].dataIndex >= 0 && edges[i].node1.dataIndex >= 0 && edges[i].node2.dataIndex >= 0) {
        cb2.call(context, edges[i], i);
      }
    }
  };
  Graph2.prototype.breadthFirstTraverse = function(cb2, startNode, direction, context) {
    if (!(startNode instanceof GraphNode)) {
      startNode = this._nodesMap[generateNodeKey(startNode)];
    }
    if (!startNode) {
      return;
    }
    var edgeType = direction === "out" ? "outEdges" : direction === "in" ? "inEdges" : "edges";
    for (var i = 0; i < this.nodes.length; i++) {
      this.nodes[i].__visited = false;
    }
    if (cb2.call(context, startNode, null)) {
      return;
    }
    var queue = [startNode];
    while (queue.length) {
      var currentNode = queue.shift();
      var edges = currentNode[edgeType];
      for (var i = 0; i < edges.length; i++) {
        var e2 = edges[i];
        var otherNode = e2.node1 === currentNode ? e2.node2 : e2.node1;
        if (!otherNode.__visited) {
          if (cb2.call(context, otherNode, currentNode)) {
            return;
          }
          queue.push(otherNode);
          otherNode.__visited = true;
        }
      }
    }
  };
  Graph2.prototype.update = function() {
    var data2 = this.data;
    var edgeData = this.edgeData;
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data2.count(); i < len2; i++) {
      nodes[data2.getRawIndex(i)].dataIndex = i;
    }
    edgeData.filterSelf(function(idx) {
      var edge = edges[edgeData.getRawIndex(idx)];
      return edge.node1.dataIndex >= 0 && edge.node2.dataIndex >= 0;
    });
    for (var i = 0, len2 = edges.length; i < len2; i++) {
      edges[i].dataIndex = -1;
    }
    for (var i = 0, len2 = edgeData.count(); i < len2; i++) {
      edges[edgeData.getRawIndex(i)].dataIndex = i;
    }
  };
  Graph2.prototype.clone = function() {
    var graph = new Graph2(this._directed);
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0; i < nodes.length; i++) {
      graph.addNode(nodes[i].id, nodes[i].dataIndex);
    }
    for (var i = 0; i < edges.length; i++) {
      var e2 = edges[i];
      graph.addEdge(e2.node1.id, e2.node2.id, e2.dataIndex);
    }
    return graph;
  };
  return Graph2;
}();
var GraphNode = function() {
  function GraphNode2(id2, dataIndex) {
    this.inEdges = [];
    this.outEdges = [];
    this.edges = [];
    this.dataIndex = -1;
    this.id = id2 == null ? "" : id2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphNode2.prototype.degree = function() {
    return this.edges.length;
  };
  GraphNode2.prototype.inDegree = function() {
    return this.inEdges.length;
  };
  GraphNode2.prototype.outDegree = function() {
    return this.outEdges.length;
  };
  GraphNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphNode2.prototype.getAdjacentDataIndices = function() {
    var dataIndices = {
      edge: [],
      node: []
    };
    for (var i = 0; i < this.edges.length; i++) {
      var adjacentEdge = this.edges[i];
      if (adjacentEdge.dataIndex < 0) {
        continue;
      }
      dataIndices.edge.push(adjacentEdge.dataIndex);
      dataIndices.node.push(adjacentEdge.node1.dataIndex, adjacentEdge.node2.dataIndex);
    }
    return dataIndices;
  };
  return GraphNode2;
}();
var GraphEdge = function() {
  function GraphEdge2(n1, n2, dataIndex) {
    this.dataIndex = -1;
    this.node1 = n1;
    this.node2 = n2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphEdge2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.edgeData.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphEdge2.prototype.getAdjacentDataIndices = function() {
    return {
      edge: [this.dataIndex],
      node: [this.node1.dataIndex, this.node2.dataIndex]
    };
  };
  return GraphEdge2;
}();
function createGraphDataProxyMixin(hostName, dataName) {
  return {
    getValue: function(dimension) {
      var data2 = this[hostName][dataName];
      return data2.getStore().get(data2.getDimensionIndex(dimension || "value"), this.dataIndex);
    },
    setVisual: function(key, value) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemVisual(this.dataIndex, key, value);
    },
    getVisual: function(key) {
      return this[hostName][dataName].getItemVisual(this.dataIndex, key);
    },
    setLayout: function(layout2, merge3) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemLayout(this.dataIndex, layout2, merge3);
    },
    getLayout: function() {
      return this[hostName][dataName].getItemLayout(this.dataIndex);
    },
    getGraphicEl: function() {
      return this[hostName][dataName].getItemGraphicEl(this.dataIndex);
    },
    getRawIndex: function() {
      return this[hostName][dataName].getRawIndex(this.dataIndex);
    }
  };
}
mixin(GraphNode, createGraphDataProxyMixin("hostGraph", "data"));
mixin(GraphEdge, createGraphDataProxyMixin("hostGraph", "edgeData"));
var Graph$1 = Graph;
function createGraphFromNodeEdge(nodes, edges, seriesModel, directed, beforeLink) {
  var graph = new Graph$1(directed);
  for (var i = 0; i < nodes.length; i++) {
    graph.addNode(retrieve(nodes[i].id, nodes[i].name, i), i);
  }
  var linkNameList = [];
  var validEdges = [];
  var linkCount = 0;
  for (var i = 0; i < edges.length; i++) {
    var link = edges[i];
    var source = link.source;
    var target = link.target;
    if (graph.addEdge(source, target, linkCount)) {
      validEdges.push(link);
      linkNameList.push(retrieve(convertOptionIdName(link.id, null), source + " > " + target));
      linkCount++;
    }
  }
  var coordSys = seriesModel.get("coordinateSystem");
  var nodeData;
  if (coordSys === "cartesian2d" || coordSys === "polar") {
    nodeData = createSeriesData(nodes, seriesModel);
  } else {
    var coordSysCtor = CoordinateSystem.get(coordSys);
    var coordDimensions = coordSysCtor ? coordSysCtor.dimensions || [] : [];
    if (indexOf(coordDimensions, "value") < 0) {
      coordDimensions.concat(["value"]);
    }
    var dimensions = prepareSeriesDataSchema(nodes, {
      coordDimensions,
      encodeDefine: seriesModel.getEncode()
    }).dimensions;
    nodeData = new SeriesData$1(dimensions, seriesModel);
    nodeData.initData(nodes);
  }
  var edgeData = new SeriesData$1(["value"], seriesModel);
  edgeData.initData(validEdges, linkNameList);
  beforeLink && beforeLink(nodeData, edgeData);
  linkSeriesData({
    mainData: nodeData,
    struct: graph,
    structAttr: "graph",
    datas: {
      node: nodeData,
      edge: edgeData
    },
    datasAttr: {
      node: "data",
      edge: "edgeData"
    }
  });
  graph.update();
  return graph;
}
var GraphSeriesModel = function(_super) {
  __extends(GraphSeriesModel2, _super);
  function GraphSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  GraphSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    var self2 = this;
    function getCategoriesData() {
      return self2._categoriesData;
    }
    this.legendVisualProvider = new LegendVisualProvider$1(getCategoriesData, getCategoriesData);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeDefaultAndTheme = function(option) {
    _super.prototype.mergeDefaultAndTheme.apply(this, arguments);
    defaultEmphasis(option, "edgeLabel", ["show"]);
  };
  GraphSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var edges = option.edges || option.links || [];
    var nodes = option.data || option.nodes || [];
    var self2 = this;
    if (nodes && edges) {
      initCurvenessList(this);
      var graph = createGraphFromNodeEdge(nodes, edges, this, true, beforeLink);
      each$g(graph.edges, function(edge) {
        createEdgeMapForCurveness(edge.node1, edge.node2, this, edge.dataIndex);
      }, this);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model) {
        var categoriesModels = self2._categoriesModels;
        var categoryIdx = model.getShallow("category");
        var categoryModel = categoriesModels[categoryIdx];
        if (categoryModel) {
          categoryModel.parentModel = model.parentModel;
          model.parentModel = categoryModel;
        }
        return model;
      });
      var oldGetModel = Model$1.prototype.getModel;
      function newGetModel(path, parentModel) {
        var model = oldGetModel.call(this, path, parentModel);
        model.resolveParentPath = resolveParentPath;
        return model;
      }
      edgeData.wrapMethod("getItemModel", function(model) {
        model.resolveParentPath = resolveParentPath;
        model.getModel = newGetModel;
        return model;
      });
      function resolveParentPath(pathArr) {
        if (pathArr && (pathArr[0] === "label" || pathArr[1] === "label")) {
          var newPathArr = pathArr.slice();
          if (pathArr[0] === "label") {
            newPathArr[0] = "edgeLabel";
          } else if (pathArr[1] === "label") {
            newPathArr[1] = "edgeLabel";
          }
          return newPathArr;
        }
        return pathArr;
      }
    }
  };
  GraphSeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  GraphSeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  GraphSeriesModel2.prototype.getCategoriesData = function() {
    return this._categoriesData;
  };
  GraphSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    if (dataType === "edge") {
      var nodeData = this.getData();
      var params = this.getDataParams(dataIndex, dataType);
      var edge = nodeData.graph.getEdgeByIndex(dataIndex);
      var sourceName = nodeData.getName(edge.node1.dataIndex);
      var targetName = nodeData.getName(edge.node2.dataIndex);
      var nameArr = [];
      sourceName != null && nameArr.push(sourceName);
      targetName != null && nameArr.push(targetName);
      return createTooltipMarkup("nameValue", {
        name: nameArr.join(" > "),
        value: params.value,
        noValue: params.value == null
      });
    }
    var nodeMarkup = defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
    return nodeMarkup;
  };
  GraphSeriesModel2.prototype._updateCategoriesData = function() {
    var categories = map$1(this.option.categories || [], function(category) {
      return category.value != null ? category : extend({
        value: 0
      }, category);
    });
    var categoriesData = new SeriesData$1(["value"], this);
    categoriesData.initData(categories);
    this._categoriesData = categoriesData;
    this._categoriesModels = categoriesData.mapArray(function(idx) {
      return categoriesData.getItemModel(idx);
    });
  };
  GraphSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GraphSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GraphSeriesModel2.prototype.isAnimationEnabled = function() {
    return _super.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
  };
  GraphSeriesModel2.type = "series.graph";
  GraphSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  GraphSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    legendHoverLink: true,
    layout: null,
    circular: {
      rotateLabel: false
    },
    force: {
      initLayout: null,
      repulsion: [0, 50],
      gravity: 0.1,
      friction: 0.6,
      edgeLength: 30,
      layoutAnimation: true
    },
    left: "center",
    top: "center",
    symbol: "circle",
    symbolSize: 10,
    edgeSymbol: ["none", "none"],
    edgeSymbolSize: 10,
    edgeLabel: {
      position: "middle",
      distance: 5
    },
    draggable: false,
    roam: false,
    center: null,
    zoom: 1,
    nodeScaleRatio: 0.6,
    label: {
      show: false,
      formatter: "{b}"
    },
    itemStyle: {},
    lineStyle: {
      color: "#aaa",
      width: 1,
      opacity: 0.5
    },
    emphasis: {
      scale: true,
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return GraphSeriesModel2;
}(SeriesModel$1);
var GraphSeriesModel$1 = GraphSeriesModel;
var actionInfo$1 = {
  type: "graphRoam",
  event: "graphRoam",
  update: "none"
};
function install$F(registers) {
  registers.registerChartView(GraphView$1);
  registers.registerSeriesModel(GraphSeriesModel$1);
  registers.registerProcessor(categoryFilter);
  registers.registerVisual(categoryVisual);
  registers.registerVisual(graphEdgeVisual);
  registers.registerLayout(graphSimpleLayout);
  registers.registerLayout(registers.PRIORITY.VISUAL.POST_CHART_LAYOUT, graphCircularLayout);
  registers.registerLayout(graphForceLayout);
  registers.registerCoordinateSystem("graphView", {
    dimensions: View$1.dimensions,
    create: createViewCoordSys
  });
  registers.registerAction({
    type: "focusNodeAdjacency",
    event: "focusNodeAdjacency",
    update: "series:focusNodeAdjacency"
  }, noop$1);
  registers.registerAction({
    type: "unfocusNodeAdjacency",
    event: "unfocusNodeAdjacency",
    update: "series:unfocusNodeAdjacency"
  }, noop$1);
  registers.registerAction(actionInfo$1, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res2 = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res2.center);
      seriesModel.setZoom && seriesModel.setZoom(res2.zoom);
    });
  });
}
var PointerShape = function() {
  function PointerShape2() {
    this.angle = 0;
    this.width = 10;
    this.r = 10;
    this.x = 0;
    this.y = 0;
  }
  return PointerShape2;
}();
var PointerPath = function(_super) {
  __extends(PointerPath2, _super);
  function PointerPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "pointer";
    return _this;
  }
  PointerPath2.prototype.getDefaultShape = function() {
    return new PointerShape();
  };
  PointerPath2.prototype.buildPath = function(ctx, shape) {
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var r2 = shape.r;
    var width = shape.width;
    var angle = shape.angle;
    var x2 = shape.x - mathCos2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    var y2 = shape.y - mathSin2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    angle = shape.angle - Math.PI / 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(shape.x + mathCos2(angle) * width, shape.y + mathSin2(angle) * width);
    ctx.lineTo(shape.x + mathCos2(shape.angle) * r2, shape.y + mathSin2(shape.angle) * r2);
    ctx.lineTo(shape.x - mathCos2(angle) * width, shape.y - mathSin2(angle) * width);
    ctx.lineTo(x2, y2);
  };
  return PointerPath2;
}(Path$1);
var PointerPath$1 = PointerPath;
function parsePosition(seriesModel, api) {
  var center2 = seriesModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], api.getWidth());
  var cy = parsePercent(center2[1], api.getHeight());
  var r2 = parsePercent(seriesModel.get("radius"), size / 2);
  return {
    cx,
    cy,
    r: r2
  };
}
function formatLabel(value, labelFormatter) {
  var label = value == null ? "" : value + "";
  if (labelFormatter) {
    if (isString$1(labelFormatter)) {
      label = labelFormatter.replace("{value}", label);
    } else if (isFunction$1(labelFormatter)) {
      label = labelFormatter(value);
    }
  }
  return label;
}
var PI2 = Math.PI * 2;
var GaugeView = function(_super) {
  __extends(GaugeView2, _super);
  function GaugeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeView2.type;
    return _this;
  }
  GaugeView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeAll();
    var colorList = seriesModel.get(["axisLine", "lineStyle", "color"]);
    var posInfo = parsePosition(seriesModel, api);
    this._renderMain(seriesModel, ecModel, api, colorList, posInfo);
    this._data = seriesModel.getData();
  };
  GaugeView2.prototype.dispose = function() {
  };
  GaugeView2.prototype._renderMain = function(seriesModel, ecModel, api, colorList, posInfo) {
    var group = this.group;
    var clockwise = seriesModel.get("clockwise");
    var startAngle = -seriesModel.get("startAngle") / 180 * Math.PI;
    var endAngle = -seriesModel.get("endAngle") / 180 * Math.PI;
    var axisLineModel = seriesModel.getModel("axisLine");
    var roundCap = axisLineModel.get("roundCap");
    var MainPath = roundCap ? Sausage : Sector$1;
    var showAxis = axisLineModel.get("show");
    var lineStyleModel = axisLineModel.getModel("lineStyle");
    var axisLineWidth = lineStyleModel.get("width");
    var angleRangeSpan = !((endAngle - startAngle) % PI2) && endAngle !== startAngle ? PI2 : (endAngle - startAngle) % PI2;
    var prevEndAngle = startAngle;
    for (var i = 0; showAxis && i < colorList.length; i++) {
      var percent = Math.min(Math.max(colorList[i][0], 0), 1);
      endAngle = startAngle + angleRangeSpan * percent;
      var sector = new MainPath({
        shape: {
          startAngle: prevEndAngle,
          endAngle,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0: posInfo.r - axisLineWidth,
          r: posInfo.r
        },
        silent: true
      });
      sector.setStyle({
        fill: colorList[i][1]
      });
      sector.setStyle(lineStyleModel.getLineStyle(["color", "width"]));
      group.add(sector);
      prevEndAngle = endAngle;
    }
    var getColor = function(percent2) {
      if (percent2 <= 0) {
        return colorList[0][1];
      }
      var i2;
      for (i2 = 0; i2 < colorList.length; i2++) {
        if (colorList[i2][0] >= percent2 && (i2 === 0 ? 0 : colorList[i2 - 1][0]) < percent2) {
          return colorList[i2][1];
        }
      }
      return colorList[i2 - 1][1];
    };
    if (!clockwise) {
      var tmp = startAngle;
      startAngle = endAngle;
      endAngle = tmp;
    }
    this._renderTicks(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
    this._renderTitleAndDetail(seriesModel, ecModel, api, getColor, posInfo);
    this._renderAnchor(seriesModel, posInfo);
    this._renderPointer(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
  };
  GaugeView2.prototype._renderTicks = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var cx = posInfo.cx;
    var cy = posInfo.cy;
    var r2 = posInfo.r;
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var splitLineModel = seriesModel.getModel("splitLine");
    var tickModel = seriesModel.getModel("axisTick");
    var labelModel = seriesModel.getModel("axisLabel");
    var splitNumber = seriesModel.get("splitNumber");
    var subSplitNumber = tickModel.get("splitNumber");
    var splitLineLen = parsePercent(splitLineModel.get("length"), r2);
    var tickLen = parsePercent(tickModel.get("length"), r2);
    var angle = startAngle;
    var step = (endAngle - startAngle) / splitNumber;
    var subStep = step / subSplitNumber;
    var splitLineStyle = splitLineModel.getModel("lineStyle").getLineStyle();
    var tickLineStyle = tickModel.getModel("lineStyle").getLineStyle();
    var splitLineDistance = splitLineModel.get("distance");
    var unitX;
    var unitY;
    for (var i = 0; i <= splitNumber; i++) {
      unitX = Math.cos(angle);
      unitY = Math.sin(angle);
      if (splitLineModel.get("show")) {
        var distance2 = splitLineDistance ? splitLineDistance + axisLineWidth : axisLineWidth;
        var splitLine = new Line$3({
          shape: {
            x1: unitX * (r2 - distance2) + cx,
            y1: unitY * (r2 - distance2) + cy,
            x2: unitX * (r2 - splitLineLen - distance2) + cx,
            y2: unitY * (r2 - splitLineLen - distance2) + cy
          },
          style: splitLineStyle,
          silent: true
        });
        if (splitLineStyle.stroke === "auto") {
          splitLine.setStyle({
            stroke: getColor(i / splitNumber)
          });
        }
        group.add(splitLine);
      }
      if (labelModel.get("show")) {
        var distance2 = labelModel.get("distance") + splitLineDistance;
        var label = formatLabel(round$3(i / splitNumber * (maxVal - minVal) + minVal), labelModel.get("formatter"));
        var autoColor = getColor(i / splitNumber);
        group.add(new ZRText$1({
          style: createTextStyle(labelModel, {
            text: label,
            x: unitX * (r2 - splitLineLen - distance2) + cx,
            y: unitY * (r2 - splitLineLen - distance2) + cy,
            verticalAlign: unitY < -0.8 ? "top" : unitY > 0.8 ? "bottom" : "middle",
            align: unitX < -0.4 ? "left" : unitX > 0.4 ? "right" : "center"
          }, {
            inheritColor: autoColor
          }),
          silent: true
        }));
      }
      if (tickModel.get("show") && i !== splitNumber) {
        var distance2 = tickModel.get("distance");
        distance2 = distance2 ? distance2 + axisLineWidth : axisLineWidth;
        for (var j = 0; j <= subSplitNumber; j++) {
          unitX = Math.cos(angle);
          unitY = Math.sin(angle);
          var tickLine = new Line$3({
            shape: {
              x1: unitX * (r2 - distance2) + cx,
              y1: unitY * (r2 - distance2) + cy,
              x2: unitX * (r2 - tickLen - distance2) + cx,
              y2: unitY * (r2 - tickLen - distance2) + cy
            },
            silent: true,
            style: tickLineStyle
          });
          if (tickLineStyle.stroke === "auto") {
            tickLine.setStyle({
              stroke: getColor((i + j / subSplitNumber) / splitNumber)
            });
          }
          group.add(tickLine);
          angle += subStep;
        }
        angle -= subStep;
      } else {
        angle += step;
      }
    }
  };
  GaugeView2.prototype._renderPointer = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var oldData = this._data;
    var oldProgressData = this._progressEls;
    var progressList = [];
    var showPointer2 = seriesModel.get(["pointer", "show"]);
    var progressModel = seriesModel.getModel("progress");
    var showProgress = progressModel.get("show");
    var data2 = seriesModel.getData();
    var valueDim = data2.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var valueExtent = [minVal, maxVal];
    var angleExtent = [startAngle, endAngle];
    function createPointer(idx, angle) {
      var itemModel = data2.getItemModel(idx);
      var pointerModel = itemModel.getModel("pointer");
      var pointerWidth = parsePercent(pointerModel.get("width"), posInfo.r);
      var pointerLength = parsePercent(pointerModel.get("length"), posInfo.r);
      var pointerStr = seriesModel.get(["pointer", "icon"]);
      var pointerOffset = pointerModel.get("offsetCenter");
      var pointerOffsetX = parsePercent(pointerOffset[0], posInfo.r);
      var pointerOffsetY = parsePercent(pointerOffset[1], posInfo.r);
      var pointerKeepAspect = pointerModel.get("keepAspect");
      var pointer;
      if (pointerStr) {
        pointer = createSymbol$1(pointerStr, pointerOffsetX - pointerWidth / 2, pointerOffsetY - pointerLength, pointerWidth, pointerLength, null, pointerKeepAspect);
      } else {
        pointer = new PointerPath$1({
          shape: {
            angle: -Math.PI / 2,
            width: pointerWidth,
            r: pointerLength,
            x: pointerOffsetX,
            y: pointerOffsetY
          }
        });
      }
      pointer.rotation = -(angle + Math.PI / 2);
      pointer.x = posInfo.cx;
      pointer.y = posInfo.cy;
      return pointer;
    }
    function createProgress(idx, endAngle2) {
      var roundCap = progressModel.get("roundCap");
      var ProgressPath = roundCap ? Sausage : Sector$1;
      var isOverlap = progressModel.get("overlap");
      var progressWidth = isOverlap ? progressModel.get("width") : axisLineWidth / data2.count();
      var r0 = isOverlap ? posInfo.r - progressWidth : posInfo.r - (idx + 1) * progressWidth;
      var r2 = isOverlap ? posInfo.r : posInfo.r - idx * progressWidth;
      var progress = new ProgressPath({
        shape: {
          startAngle,
          endAngle: endAngle2,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0,
          r: r2
        }
      });
      isOverlap && (progress.z2 = maxVal - data2.get(valueDim, idx) % maxVal);
      return progress;
    }
    if (showProgress || showPointer2) {
      data2.diff(oldData).add(function(idx) {
        var val = data2.get(valueDim, idx);
        if (showPointer2) {
          var pointer = createPointer(idx, startAngle);
          initProps(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data2.setItemGraphicEl(idx, pointer);
        }
        if (showProgress) {
          var progress = createProgress(idx, startAngle);
          var isClip = progressModel.get("clip");
          initProps(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data2.dataType, idx, progress);
          progressList[idx] = progress;
        }
      }).update(function(newIdx, oldIdx) {
        var val = data2.get(valueDim, newIdx);
        if (showPointer2) {
          var previousPointer = oldData.getItemGraphicEl(oldIdx);
          var previousRotate = previousPointer ? previousPointer.rotation : startAngle;
          var pointer = createPointer(newIdx, previousRotate);
          pointer.rotation = previousRotate;
          updateProps$1(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data2.setItemGraphicEl(newIdx, pointer);
        }
        if (showProgress) {
          var previousProgress = oldProgressData[oldIdx];
          var previousEndAngle = previousProgress ? previousProgress.shape.endAngle : startAngle;
          var progress = createProgress(newIdx, previousEndAngle);
          var isClip = progressModel.get("clip");
          updateProps$1(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data2.dataType, newIdx, progress);
          progressList[newIdx] = progress;
        }
      }).execute();
      data2.each(function(idx) {
        var itemModel = data2.getItemModel(idx);
        var emphasisModel = itemModel.getModel("emphasis");
        var focus = emphasisModel.get("focus");
        var blurScope = emphasisModel.get("blurScope");
        var emphasisDisabled = emphasisModel.get("disabled");
        if (showPointer2) {
          var pointer = data2.getItemGraphicEl(idx);
          var symbolStyle = data2.getItemVisual(idx, "style");
          var visualColor = symbolStyle.fill;
          if (pointer instanceof ZRImage$1) {
            var pathStyle = pointer.style;
            pointer.useStyle(extend({
              image: pathStyle.image,
              x: pathStyle.x,
              y: pathStyle.y,
              width: pathStyle.width,
              height: pathStyle.height
            }, symbolStyle));
          } else {
            pointer.useStyle(symbolStyle);
            pointer.type !== "pointer" && pointer.setColor(visualColor);
          }
          pointer.setStyle(itemModel.getModel(["pointer", "itemStyle"]).getItemStyle());
          if (pointer.style.fill === "auto") {
            pointer.setStyle("fill", getColor(linearMap$2(data2.get(valueDim, idx), valueExtent, [0, 1], true)));
          }
          pointer.z2EmphasisLift = 0;
          setStatesStylesFromModel(pointer, itemModel);
          toggleHoverEmphasis(pointer, focus, blurScope, emphasisDisabled);
        }
        if (showProgress) {
          var progress = progressList[idx];
          progress.useStyle(data2.getItemVisual(idx, "style"));
          progress.setStyle(itemModel.getModel(["progress", "itemStyle"]).getItemStyle());
          progress.z2EmphasisLift = 0;
          setStatesStylesFromModel(progress, itemModel);
          toggleHoverEmphasis(progress, focus, blurScope, emphasisDisabled);
        }
      });
      this._progressEls = progressList;
    }
  };
  GaugeView2.prototype._renderAnchor = function(seriesModel, posInfo) {
    var anchorModel = seriesModel.getModel("anchor");
    var showAnchor = anchorModel.get("show");
    if (showAnchor) {
      var anchorSize = anchorModel.get("size");
      var anchorType = anchorModel.get("icon");
      var offsetCenter = anchorModel.get("offsetCenter");
      var anchorKeepAspect = anchorModel.get("keepAspect");
      var anchor = createSymbol$1(anchorType, posInfo.cx - anchorSize / 2 + parsePercent(offsetCenter[0], posInfo.r), posInfo.cy - anchorSize / 2 + parsePercent(offsetCenter[1], posInfo.r), anchorSize, anchorSize, null, anchorKeepAspect);
      anchor.z2 = anchorModel.get("showAbove") ? 1 : 0;
      anchor.setStyle(anchorModel.getModel("itemStyle").getItemStyle());
      this.group.add(anchor);
    }
  };
  GaugeView2.prototype._renderTitleAndDetail = function(seriesModel, ecModel, api, getColor, posInfo) {
    var _this = this;
    var data2 = seriesModel.getData();
    var valueDim = data2.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var contentGroup = new Group$6();
    var newTitleEls = [];
    var newDetailEls = [];
    var hasAnimation = seriesModel.isAnimationEnabled();
    var showPointerAbove = seriesModel.get(["pointer", "showAbove"]);
    data2.diff(this._data).add(function(idx) {
      newTitleEls[idx] = new ZRText$1({
        silent: true
      });
      newDetailEls[idx] = new ZRText$1({
        silent: true
      });
    }).update(function(idx, oldIdx) {
      newTitleEls[idx] = _this._titleEls[oldIdx];
      newDetailEls[idx] = _this._detailEls[oldIdx];
    }).execute();
    data2.each(function(idx) {
      var itemModel = data2.getItemModel(idx);
      var value = data2.get(valueDim, idx);
      var itemGroup = new Group$6();
      var autoColor = getColor(linearMap$2(value, [minVal, maxVal], [0, 1], true));
      var itemTitleModel = itemModel.getModel("title");
      if (itemTitleModel.get("show")) {
        var titleOffsetCenter = itemTitleModel.get("offsetCenter");
        var titleX = posInfo.cx + parsePercent(titleOffsetCenter[0], posInfo.r);
        var titleY = posInfo.cy + parsePercent(titleOffsetCenter[1], posInfo.r);
        var labelEl = newTitleEls[idx];
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemTitleModel, {
            x: titleX,
            y: titleY,
            text: data2.getName(idx),
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: autoColor
          })
        });
        itemGroup.add(labelEl);
      }
      var itemDetailModel = itemModel.getModel("detail");
      if (itemDetailModel.get("show")) {
        var detailOffsetCenter = itemDetailModel.get("offsetCenter");
        var detailX = posInfo.cx + parsePercent(detailOffsetCenter[0], posInfo.r);
        var detailY = posInfo.cy + parsePercent(detailOffsetCenter[1], posInfo.r);
        var width = parsePercent(itemDetailModel.get("width"), posInfo.r);
        var height = parsePercent(itemDetailModel.get("height"), posInfo.r);
        var detailColor = seriesModel.get(["progress", "show"]) ? data2.getItemVisual(idx, "style").fill : autoColor;
        var labelEl = newDetailEls[idx];
        var formatter_1 = itemDetailModel.get("formatter");
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemDetailModel, {
            x: detailX,
            y: detailY,
            text: formatLabel(value, formatter_1),
            width: isNaN(width) ? null : width,
            height: isNaN(height) ? null : height,
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: detailColor
          })
        });
        setLabelValueAnimation(labelEl, {
          normal: itemDetailModel
        }, value, function(value2) {
          return formatLabel(value2, formatter_1);
        });
        hasAnimation && animateLabelValue(labelEl, idx, data2, seriesModel, {
          getFormattedLabel: function(labelDataIndex, status, dataType, labelDimIndex, fmt, extendParams) {
            return formatLabel(extendParams ? extendParams.interpolatedValue : value, formatter_1);
          }
        });
        itemGroup.add(labelEl);
      }
      contentGroup.add(itemGroup);
    });
    this.group.add(contentGroup);
    this._titleEls = newTitleEls;
    this._detailEls = newDetailEls;
  };
  GaugeView2.type = "gauge";
  return GaugeView2;
}(ChartView$1);
var GaugeView$1 = GaugeView;
var GaugeSeriesModel = function(_super) {
  __extends(GaugeSeriesModel2, _super);
  function GaugeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeSeriesModel2.type;
    _this.visualStyleAccessPath = "itemStyle";
    return _this;
  }
  GaugeSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, ["value"]);
  };
  GaugeSeriesModel2.type = "series.gauge";
  GaugeSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    center: ["50%", "50%"],
    legendHoverLink: true,
    radius: "75%",
    startAngle: 225,
    endAngle: -45,
    clockwise: true,
    min: 0,
    max: 100,
    splitNumber: 10,
    axisLine: {
      show: true,
      roundCap: false,
      lineStyle: {
        color: [[1, "#E6EBF8"]],
        width: 10
      }
    },
    progress: {
      show: false,
      overlap: true,
      width: 10,
      roundCap: false,
      clip: true
    },
    splitLine: {
      show: true,
      length: 10,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 3,
        type: "solid"
      }
    },
    axisTick: {
      show: true,
      splitNumber: 5,
      length: 6,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 1,
        type: "solid"
      }
    },
    axisLabel: {
      show: true,
      distance: 15,
      color: "#464646",
      fontSize: 12
    },
    pointer: {
      icon: null,
      offsetCenter: [0, 0],
      show: true,
      showAbove: true,
      length: "60%",
      width: 6,
      keepAspect: false
    },
    anchor: {
      show: false,
      showAbove: false,
      size: 6,
      icon: "circle",
      offsetCenter: [0, 0],
      keepAspect: false,
      itemStyle: {
        color: "#fff",
        borderWidth: 0,
        borderColor: "#5470c6"
      }
    },
    title: {
      show: true,
      offsetCenter: [0, "20%"],
      color: "#464646",
      fontSize: 16,
      valueAnimation: false
    },
    detail: {
      show: true,
      backgroundColor: "rgba(0,0,0,0)",
      borderWidth: 0,
      borderColor: "#ccc",
      width: 100,
      height: null,
      padding: [5, 10],
      offsetCenter: [0, "40%"],
      color: "#464646",
      fontSize: 30,
      fontWeight: "bold",
      lineHeight: 30,
      valueAnimation: false
    }
  };
  return GaugeSeriesModel2;
}(SeriesModel$1);
var GaugeSeriesModel$1 = GaugeSeriesModel;
function install$E(registers) {
  registers.registerChartView(GaugeView$1);
  registers.registerSeriesModel(GaugeSeriesModel$1);
}
var opacityAccessPath$1 = ["itemStyle", "opacity"];
var FunnelPiece = function(_super) {
  __extends(FunnelPiece2, _super);
  function FunnelPiece2(data2, idx) {
    var _this = _super.call(this) || this;
    var polygon = _this;
    var labelLine = new Polyline$3();
    var text = new ZRText$1();
    polygon.setTextContent(text);
    _this.setTextGuideLine(labelLine);
    _this.updateData(data2, idx, true);
    return _this;
  }
  FunnelPiece2.prototype.updateData = function(data2, idx, firstCreate) {
    var polygon = this;
    var seriesModel = data2.hostModel;
    var itemModel = data2.getItemModel(idx);
    var layout2 = data2.getItemLayout(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var opacity = itemModel.get(opacityAccessPath$1);
    opacity = opacity == null ? 1 : opacity;
    if (!firstCreate) {
      saveOldStyle(polygon);
    }
    polygon.useStyle(data2.getItemVisual(idx, "style"));
    polygon.style.lineJoin = "round";
    if (firstCreate) {
      polygon.setShape({
        points: layout2.points
      });
      polygon.style.opacity = 0;
      initProps(polygon, {
        style: {
          opacity
        }
      }, seriesModel, idx);
    } else {
      updateProps$1(polygon, {
        style: {
          opacity
        },
        shape: {
          points: layout2.points
        }
      }, seriesModel, idx);
    }
    setStatesStylesFromModel(polygon, itemModel);
    this._updateLabel(data2, idx);
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  FunnelPiece2.prototype._updateLabel = function(data2, idx) {
    var polygon = this;
    var labelLine = this.getTextGuideLine();
    var labelText = polygon.getTextContent();
    var seriesModel = data2.hostModel;
    var itemModel = data2.getItemModel(idx);
    var layout2 = data2.getItemLayout(idx);
    var labelLayout2 = layout2.label;
    var style2 = data2.getItemVisual(idx, "style");
    var visualColor = style2.fill;
    setLabelStyle(labelText, getLabelStatesModels(itemModel), {
      labelFetcher: data2.hostModel,
      labelDataIndex: idx,
      defaultOpacity: style2.opacity,
      defaultText: data2.getName(idx)
    }, {
      normal: {
        align: labelLayout2.textAlign,
        verticalAlign: labelLayout2.verticalAlign
      }
    });
    polygon.setTextConfig({
      local: true,
      inside: !!labelLayout2.inside,
      insideStroke: visualColor,
      outsideFill: visualColor
    });
    var linePoints = labelLayout2.linePoints;
    labelLine.setShape({
      points: linePoints
    });
    polygon.textGuideLineConfig = {
      anchor: linePoints ? new Point$1(linePoints[0][0], linePoints[0][1]) : null
    };
    updateProps$1(labelText, {
      style: {
        x: labelLayout2.x,
        y: labelLayout2.y
      }
    }, seriesModel, idx);
    labelText.attr({
      rotation: labelLayout2.rotation,
      originX: labelLayout2.x,
      originY: labelLayout2.y,
      z2: 10
    });
    setLabelLineStyle(polygon, getLabelLineStatesModels(itemModel), {
      stroke: visualColor
    });
  };
  return FunnelPiece2;
}(Polygon$1);
var FunnelView = function(_super) {
  __extends(FunnelView2, _super);
  function FunnelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelView2.type;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  FunnelView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    data2.diff(oldData).add(function(idx) {
      var funnelPiece = new FunnelPiece(data2, idx);
      data2.setItemGraphicEl(idx, funnelPiece);
      group.add(funnelPiece);
    }).update(function(newIdx, oldIdx) {
      var piece = oldData.getItemGraphicEl(oldIdx);
      piece.updateData(data2, newIdx);
      group.add(piece);
      data2.setItemGraphicEl(newIdx, piece);
    }).remove(function(idx) {
      var piece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piece, seriesModel, idx);
    }).execute();
    this._data = data2;
  };
  FunnelView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  FunnelView2.prototype.dispose = function() {
  };
  FunnelView2.type = "funnel";
  return FunnelView2;
}(ChartView$1);
var FunnelView$1 = FunnelView;
var FunnelSeriesModel = function(_super) {
  __extends(FunnelSeriesModel2, _super);
  function FunnelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelSeriesModel2.type;
    return _this;
  }
  FunnelSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  FunnelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$3(makeSeriesEncodeForNameBased, this)
    });
  };
  FunnelSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  FunnelSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data2 = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueDim = data2.mapDimension("value");
    var sum2 = data2.getSum(valueDim);
    params.percent = !sum2 ? 0 : +(data2.get(valueDim, dataIndex) / sum2 * 100).toFixed(2);
    params.$vars.push("percent");
    return params;
  };
  FunnelSeriesModel2.type = "series.funnel";
  FunnelSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    minSize: "0%",
    maxSize: "100%",
    sort: "descending",
    orient: "vertical",
    gap: 0,
    funnelAlign: "center",
    label: {
      show: true,
      position: "outer"
    },
    labelLine: {
      show: true,
      length: 20,
      lineStyle: {
        width: 1
      }
    },
    itemStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return FunnelSeriesModel2;
}(SeriesModel$1);
var FunnelSeriesModel$1 = FunnelSeriesModel;
function getViewRect$2(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getSortedIndices(data2, sort2) {
  var valueDim = data2.mapDimension("value");
  var valueArr = data2.mapArray(valueDim, function(val) {
    return val;
  });
  var indices = [];
  var isAscending = sort2 === "ascending";
  for (var i = 0, len2 = data2.count(); i < len2; i++) {
    indices[i] = i;
  }
  if (isFunction$1(sort2)) {
    indices.sort(sort2);
  } else if (sort2 !== "none") {
    indices.sort(function(a, b2) {
      return isAscending ? valueArr[a] - valueArr[b2] : valueArr[b2] - valueArr[a];
    });
  }
  return indices;
}
function labelLayout(data2) {
  var seriesModel = data2.hostModel;
  var orient = seriesModel.get("orient");
  data2.each(function(idx) {
    var itemModel = data2.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position");
    var labelLineModel = itemModel.getModel("labelLine");
    var layout2 = data2.getItemLayout(idx);
    var points2 = layout2.points;
    var isLabelInside = labelPosition === "inner" || labelPosition === "inside" || labelPosition === "center" || labelPosition === "insideLeft" || labelPosition === "insideRight";
    var textAlign;
    var textX;
    var textY;
    var linePoints;
    if (isLabelInside) {
      if (labelPosition === "insideLeft") {
        textX = (points2[0][0] + points2[3][0]) / 2 + 5;
        textY = (points2[0][1] + points2[3][1]) / 2;
        textAlign = "left";
      } else if (labelPosition === "insideRight") {
        textX = (points2[1][0] + points2[2][0]) / 2 - 5;
        textY = (points2[1][1] + points2[2][1]) / 2;
        textAlign = "right";
      } else {
        textX = (points2[0][0] + points2[1][0] + points2[2][0] + points2[3][0]) / 4;
        textY = (points2[0][1] + points2[1][1] + points2[2][1] + points2[3][1]) / 4;
        textAlign = "center";
      }
      linePoints = [[textX, textY], [textX, textY]];
    } else {
      var x1 = void 0;
      var y1 = void 0;
      var x2 = void 0;
      var y2 = void 0;
      var labelLineLen = labelLineModel.get("length");
      if (labelPosition === "left") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        x2 = x1 - labelLineLen;
        textX = x2 - 5;
        textAlign = "right";
      } else if (labelPosition === "right") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        x2 = x1 + labelLineLen;
        textX = x2 + 5;
        textAlign = "left";
      } else if (labelPosition === "top") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        y2 = y1 - labelLineLen;
        textY = y2 - 5;
        textAlign = "center";
      } else if (labelPosition === "bottom") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        y2 = y1 + labelLineLen;
        textY = y2 + 5;
        textAlign = "center";
      } else if (labelPosition === "rightTop") {
        x1 = orient === "horizontal" ? points2[3][0] : points2[1][0];
        y1 = orient === "horizontal" ? points2[3][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "top";
        }
      } else if (labelPosition === "rightBottom") {
        x1 = points2[2][0];
        y1 = points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "bottom";
        }
      } else if (labelPosition === "leftTop") {
        x1 = points2[0][0];
        y1 = orient === "horizontal" ? points2[0][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else if (labelPosition === "leftBottom") {
        x1 = orient === "horizontal" ? points2[1][0] : points2[3][0];
        y1 = orient === "horizontal" ? points2[1][1] : points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "left";
        }
      }
      if (orient === "horizontal") {
        x2 = x1;
        textX = x2;
      } else {
        y2 = y1;
        textY = y2;
      }
      linePoints = [[x1, y1], [x2, y2]];
    }
    layout2.label = {
      linePoints,
      x: textX,
      y: textY,
      verticalAlign: "middle",
      textAlign,
      inside: isLabelInside
    };
  });
}
function funnelLayout(ecModel, api) {
  ecModel.eachSeriesByType("funnel", function(seriesModel) {
    var data2 = seriesModel.getData();
    var valueDim = data2.mapDimension("value");
    var sort2 = seriesModel.get("sort");
    var viewRect2 = getViewRect$2(seriesModel, api);
    var orient = seriesModel.get("orient");
    var viewWidth = viewRect2.width;
    var viewHeight = viewRect2.height;
    var indices = getSortedIndices(data2, sort2);
    var x2 = viewRect2.x;
    var y2 = viewRect2.y;
    var sizeExtent = orient === "horizontal" ? [parsePercent(seriesModel.get("minSize"), viewHeight), parsePercent(seriesModel.get("maxSize"), viewHeight)] : [parsePercent(seriesModel.get("minSize"), viewWidth), parsePercent(seriesModel.get("maxSize"), viewWidth)];
    var dataExtent = data2.getDataExtent(valueDim);
    var min3 = seriesModel.get("min");
    var max3 = seriesModel.get("max");
    if (min3 == null) {
      min3 = Math.min(dataExtent[0], 0);
    }
    if (max3 == null) {
      max3 = dataExtent[1];
    }
    var funnelAlign = seriesModel.get("funnelAlign");
    var gap = seriesModel.get("gap");
    var viewSize = orient === "horizontal" ? viewWidth : viewHeight;
    var itemSize = (viewSize - gap * (data2.count() - 1)) / data2.count();
    var getLinePoints = function(idx2, offset3) {
      if (orient === "horizontal") {
        var val_1 = data2.get(valueDim, idx2) || 0;
        var itemHeight = linearMap$2(val_1, [min3, max3], sizeExtent, true);
        var y0 = void 0;
        switch (funnelAlign) {
          case "top":
            y0 = y2;
            break;
          case "center":
            y0 = y2 + (viewHeight - itemHeight) / 2;
            break;
          case "bottom":
            y0 = y2 + (viewHeight - itemHeight);
            break;
        }
        return [[offset3, y0], [offset3, y0 + itemHeight]];
      }
      var val = data2.get(valueDim, idx2) || 0;
      var itemWidth = linearMap$2(val, [min3, max3], sizeExtent, true);
      var x0;
      switch (funnelAlign) {
        case "left":
          x0 = x2;
          break;
        case "center":
          x0 = x2 + (viewWidth - itemWidth) / 2;
          break;
        case "right":
          x0 = x2 + viewWidth - itemWidth;
          break;
      }
      return [[x0, offset3], [x0 + itemWidth, offset3]];
    };
    if (sort2 === "ascending") {
      itemSize = -itemSize;
      gap = -gap;
      if (orient === "horizontal") {
        x2 += viewWidth;
      } else {
        y2 += viewHeight;
      }
      indices = indices.reverse();
    }
    for (var i = 0; i < indices.length; i++) {
      var idx = indices[i];
      var nextIdx = indices[i + 1];
      var itemModel = data2.getItemModel(idx);
      if (orient === "horizontal") {
        var width = itemModel.get(["itemStyle", "width"]);
        if (width == null) {
          width = itemSize;
        } else {
          width = parsePercent(width, viewWidth);
          if (sort2 === "ascending") {
            width = -width;
          }
        }
        var start2 = getLinePoints(idx, x2);
        var end2 = getLinePoints(nextIdx, x2 + width);
        x2 += width + gap;
        data2.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      } else {
        var height = itemModel.get(["itemStyle", "height"]);
        if (height == null) {
          height = itemSize;
        } else {
          height = parsePercent(height, viewHeight);
          if (sort2 === "ascending") {
            height = -height;
          }
        }
        var start2 = getLinePoints(idx, y2);
        var end2 = getLinePoints(nextIdx, y2 + height);
        y2 += height + gap;
        data2.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      }
    }
    labelLayout(data2);
  });
}
function install$D(registers) {
  registers.registerChartView(FunnelView$1);
  registers.registerSeriesModel(FunnelSeriesModel$1);
  registers.registerLayout(funnelLayout);
  registers.registerProcessor(dataFilter$1("funnel"));
}
var DEFAULT_SMOOTH = 0.3;
var ParallelView$2 = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    _this._dataGroup = new Group$6();
    _this._initialized = false;
    return _this;
  }
  ParallelView2.prototype.init = function() {
    this.group.add(this._dataGroup);
  };
  ParallelView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._progressiveEls = null;
    var dataGroup = this._dataGroup;
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    data2.diff(oldData).add(add2).update(update).remove(remove).execute();
    function add2(newDataIndex) {
      var line = addEl(data2, dataGroup, newDataIndex, dimensions, coordSys);
      updateElCommon(line, data2, newDataIndex, seriesScope);
    }
    function update(newDataIndex, oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      var points2 = createLinePoints(data2, newDataIndex, dimensions, coordSys);
      data2.setItemGraphicEl(newDataIndex, line);
      updateProps$1(line, {
        shape: {
          points: points2
        }
      }, seriesModel, newDataIndex);
      saveOldStyle(line);
      updateElCommon(line, data2, newDataIndex, seriesScope);
    }
    function remove(oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      dataGroup.remove(line);
    }
    if (!this._initialized) {
      this._initialized = true;
      var clipPath = createGridClipShape$2(coordSys, seriesModel, function() {
        setTimeout(function() {
          dataGroup.removeClipPath();
        });
      });
      dataGroup.setClipPath(clipPath);
    }
    this._data = data2;
  };
  ParallelView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._initialized = true;
    this._data = null;
    this._dataGroup.removeAll();
  };
  ParallelView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    var data2 = seriesModel.getData();
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    var progressiveEls = this._progressiveEls = [];
    for (var dataIndex = taskParams.start; dataIndex < taskParams.end; dataIndex++) {
      var line = addEl(data2, this._dataGroup, dataIndex, dimensions, coordSys);
      line.incremental = true;
      updateElCommon(line, data2, dataIndex, seriesScope);
      progressiveEls.push(line);
    }
  };
  ParallelView2.prototype.remove = function() {
    this._dataGroup && this._dataGroup.removeAll();
    this._data = null;
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ChartView$1);
function createGridClipShape$2(coordSys, seriesModel, cb2) {
  var parallelModel = coordSys.model;
  var rect = coordSys.getRect();
  var rectEl = new Rect$3({
    shape: {
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    }
  });
  var dim = parallelModel.get("layout") === "horizontal" ? "width" : "height";
  rectEl.setShape(dim, 0);
  initProps(rectEl, {
    shape: {
      width: rect.width,
      height: rect.height
    }
  }, seriesModel, cb2);
  return rectEl;
}
function createLinePoints(data2, dataIndex, dimensions, coordSys) {
  var points2 = [];
  for (var i = 0; i < dimensions.length; i++) {
    var dimName = dimensions[i];
    var value = data2.get(data2.mapDimension(dimName), dataIndex);
    if (!isEmptyValue$1(value, coordSys.getAxis(dimName).type)) {
      points2.push(coordSys.dataToPoint(value, dimName));
    }
  }
  return points2;
}
function addEl(data2, dataGroup, dataIndex, dimensions, coordSys) {
  var points2 = createLinePoints(data2, dataIndex, dimensions, coordSys);
  var line = new Polyline$3({
    shape: {
      points: points2
    },
    z2: 10
  });
  dataGroup.add(line);
  data2.setItemGraphicEl(dataIndex, line);
  return line;
}
function makeSeriesScope(seriesModel) {
  var smooth = seriesModel.get("smooth", true);
  smooth === true && (smooth = DEFAULT_SMOOTH);
  smooth = numericToNumber(smooth);
  eqNaN(smooth) && (smooth = 0);
  return {
    smooth
  };
}
function updateElCommon(el, data2, dataIndex, seriesScope) {
  el.useStyle(data2.getItemVisual(dataIndex, "style"));
  el.style.fill = null;
  el.setShape("smooth", seriesScope.smooth);
  var itemModel = data2.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel, "lineStyle");
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function isEmptyValue$1(val, axisType) {
  return axisType === "category" ? val == null : val == null || isNaN(val);
}
var ParallelView$3 = ParallelView$2;
var ParallelSeriesModel = function(_super) {
  __extends(ParallelSeriesModel2, _super);
  function ParallelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  ParallelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: bind$1(makeDefaultEncode, null, this)
    });
  };
  ParallelSeriesModel2.prototype.getRawIndicesByActiveState = function(activeState) {
    var coordSys = this.coordinateSystem;
    var data2 = this.getData();
    var indices = [];
    coordSys.eachActiveState(data2, function(theActiveState, dataIndex) {
      if (activeState === theActiveState) {
        indices.push(data2.getRawIndex(dataIndex));
      }
    });
    return indices;
  };
  ParallelSeriesModel2.type = "series.parallel";
  ParallelSeriesModel2.dependencies = ["parallel"];
  ParallelSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "parallel",
    parallelIndex: 0,
    label: {
      show: false
    },
    inactiveOpacity: 0.05,
    activeOpacity: 1,
    lineStyle: {
      width: 1,
      opacity: 0.45,
      type: "solid"
    },
    emphasis: {
      label: {
        show: false
      }
    },
    progressive: 500,
    smooth: false,
    animationEasing: "linear"
  };
  return ParallelSeriesModel2;
}(SeriesModel$1);
function makeDefaultEncode(seriesModel) {
  var parallelModel = seriesModel.ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
  if (!parallelModel) {
    return;
  }
  var encodeDefine = {};
  each$g(parallelModel.dimensions, function(axisDim) {
    var dataDimIndex = convertDimNameToNumber(axisDim);
    encodeDefine[axisDim] = dataDimIndex;
  });
  return encodeDefine;
}
function convertDimNameToNumber(dimName) {
  return +dimName.replace("dim", "");
}
var ParallelSeriesModel$1 = ParallelSeriesModel;
var opacityAccessPath = ["lineStyle", "opacity"];
var parallelVisual = {
  seriesType: "parallel",
  reset: function(seriesModel, ecModel) {
    var coordSys = seriesModel.coordinateSystem;
    var opacityMap = {
      normal: seriesModel.get(["lineStyle", "opacity"]),
      active: seriesModel.get("activeOpacity"),
      inactive: seriesModel.get("inactiveOpacity")
    };
    return {
      progress: function(params, data2) {
        coordSys.eachActiveState(data2, function(activeState, dataIndex) {
          var opacity = opacityMap[activeState];
          if (activeState === "normal" && data2.hasItemOption) {
            var itemOpacity = data2.getItemModel(dataIndex).get(opacityAccessPath, true);
            itemOpacity != null && (opacity = itemOpacity);
          }
          var existsStyle = data2.ensureUniqueItemVisual(dataIndex, "style");
          existsStyle.opacity = opacity;
        }, params.start, params.end);
      }
    };
  }
};
var parallelVisual$1 = parallelVisual;
function parallelPreprocessor(option) {
  createParallelIfNeeded(option);
  mergeAxisOptionFromParallel(option);
}
function createParallelIfNeeded(option) {
  if (option.parallel) {
    return;
  }
  var hasParallelSeries = false;
  each$g(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "parallel") {
      hasParallelSeries = true;
    }
  });
  if (hasParallelSeries) {
    option.parallel = [{}];
  }
}
function mergeAxisOptionFromParallel(option) {
  var axes = normalizeToArray(option.parallelAxis);
  each$g(axes, function(axisOption) {
    if (!isObject$6(axisOption)) {
      return;
    }
    var parallelIndex = axisOption.parallelIndex || 0;
    var parallelOption = normalizeToArray(option.parallel)[parallelIndex];
    if (parallelOption && parallelOption.parallelAxisDefault) {
      merge$1(axisOption, parallelOption.parallelAxisDefault, false);
    }
  });
}
var CLICK_THRESHOLD = 5;
var ParallelView = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    return _this;
  }
  ParallelView2.prototype.render = function(parallelModel, ecModel, api) {
    this._model = parallelModel;
    this._api = api;
    if (!this._handlers) {
      this._handlers = {};
      each$g(handlers$1, function(handler, eventName) {
        api.getZr().on(eventName, this._handlers[eventName] = bind$1(handler, this));
      }, this);
    }
    createOrUpdate(this, "_throttledDispatchExpand", parallelModel.get("axisExpandRate"), "fixRate");
  };
  ParallelView2.prototype.dispose = function(ecModel, api) {
    clear$1(this, "_throttledDispatchExpand");
    each$g(this._handlers, function(handler, eventName) {
      api.getZr().off(eventName, handler);
    });
    this._handlers = null;
  };
  ParallelView2.prototype._throttledDispatchExpand = function(opt) {
    this._dispatchExpand(opt);
  };
  ParallelView2.prototype._dispatchExpand = function(opt) {
    opt && this._api.dispatchAction(extend({
      type: "parallelAxisExpand"
    }, opt));
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ComponentView$1);
var handlers$1 = {
  mousedown: function(e2) {
    if (checkTrigger(this, "click")) {
      this._mouseDownPoint = [e2.offsetX, e2.offsetY];
    }
  },
  mouseup: function(e2) {
    var mouseDownPoint = this._mouseDownPoint;
    if (checkTrigger(this, "click") && mouseDownPoint) {
      var point = [e2.offsetX, e2.offsetY];
      var dist2 = Math.pow(mouseDownPoint[0] - point[0], 2) + Math.pow(mouseDownPoint[1] - point[1], 2);
      if (dist2 > CLICK_THRESHOLD) {
        return;
      }
      var result = this._model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
      result.behavior !== "none" && this._dispatchExpand({
        axisExpandWindow: result.axisExpandWindow
      });
    }
    this._mouseDownPoint = null;
  },
  mousemove: function(e2) {
    if (this._mouseDownPoint || !checkTrigger(this, "mousemove")) {
      return;
    }
    var model = this._model;
    var result = model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
    var behavior = result.behavior;
    behavior === "jump" && this._throttledDispatchExpand.debounceNextCall(model.get("axisExpandDebounce"));
    this._throttledDispatchExpand(behavior === "none" ? null : {
      axisExpandWindow: result.axisExpandWindow,
      animation: behavior === "jump" ? null : {
        duration: 0
      }
    });
  }
};
function checkTrigger(view, triggerOn) {
  var model = view._model;
  return model.get("axisExpandable") && model.get("axisExpandTriggerOn") === triggerOn;
}
var ParallelView$1 = ParallelView;
var ParallelModel = function(_super) {
  __extends(ParallelModel2, _super);
  function ParallelModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelModel2.type;
    return _this;
  }
  ParallelModel2.prototype.init = function() {
    _super.prototype.init.apply(this, arguments);
    this.mergeOption({});
  };
  ParallelModel2.prototype.mergeOption = function(newOption) {
    var thisOption = this.option;
    newOption && merge$1(thisOption, newOption, true);
    this._initDimensions();
  };
  ParallelModel2.prototype.contains = function(model, ecModel) {
    var parallelIndex = model.get("parallelIndex");
    return parallelIndex != null && ecModel.getComponent("parallel", parallelIndex) === this;
  };
  ParallelModel2.prototype.setAxisExpand = function(opt) {
    each$g(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(name2) {
      if (opt.hasOwnProperty(name2)) {
        this.option[name2] = opt[name2];
      }
    }, this);
  };
  ParallelModel2.prototype._initDimensions = function() {
    var dimensions = this.dimensions = [];
    var parallelAxisIndex = this.parallelAxisIndex = [];
    var axisModels = filter(this.ecModel.queryComponents({
      mainType: "parallelAxis"
    }), function(axisModel) {
      return (axisModel.get("parallelIndex") || 0) === this.componentIndex;
    }, this);
    each$g(axisModels, function(axisModel) {
      dimensions.push("dim" + axisModel.get("dim"));
      parallelAxisIndex.push(axisModel.componentIndex);
    });
  };
  ParallelModel2.type = "parallel";
  ParallelModel2.dependencies = ["parallelAxis"];
  ParallelModel2.layoutMode = "box";
  ParallelModel2.defaultOption = {
    z: 0,
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    layout: "horizontal",
    axisExpandable: false,
    axisExpandCenter: null,
    axisExpandCount: 0,
    axisExpandWidth: 50,
    axisExpandRate: 17,
    axisExpandDebounce: 50,
    axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4],
    axisExpandTriggerOn: "click",
    parallelAxisDefault: null
  };
  return ParallelModel2;
}(ComponentModel$1);
var ParallelModel$1 = ParallelModel;
var ParallelAxis = function(_super) {
  __extends(ParallelAxis2, _super);
  function ParallelAxis2(dim, scale2, coordExtent, axisType, axisIndex) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.axisIndex = axisIndex;
    return _this;
  }
  ParallelAxis2.prototype.isHorizontal = function() {
    return this.coordinateSystem.getModel().get("layout") !== "horizontal";
  };
  return ParallelAxis2;
}(Axis$1);
var ParallelAxis$1 = ParallelAxis;
function sliderMove(delta, handleEnds, extent3, handleIndex, minSpan, maxSpan) {
  delta = delta || 0;
  var extentSpan = extent3[1] - extent3[0];
  if (minSpan != null) {
    minSpan = restrict$1(minSpan, [0, extentSpan]);
  }
  if (maxSpan != null) {
    maxSpan = Math.max(maxSpan, minSpan != null ? minSpan : 0);
  }
  if (handleIndex === "all") {
    var handleSpan = Math.abs(handleEnds[1] - handleEnds[0]);
    handleSpan = restrict$1(handleSpan, [0, extentSpan]);
    minSpan = maxSpan = restrict$1(handleSpan, [minSpan, maxSpan]);
    handleIndex = 0;
  }
  handleEnds[0] = restrict$1(handleEnds[0], extent3);
  handleEnds[1] = restrict$1(handleEnds[1], extent3);
  var originalDistSign = getSpanSign(handleEnds, handleIndex);
  handleEnds[handleIndex] += delta;
  var extentMinSpan = minSpan || 0;
  var realExtent = extent3.slice();
  originalDistSign.sign < 0 ? realExtent[0] += extentMinSpan : realExtent[1] -= extentMinSpan;
  handleEnds[handleIndex] = restrict$1(handleEnds[handleIndex], realExtent);
  var currDistSign;
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (minSpan != null && (currDistSign.sign !== originalDistSign.sign || currDistSign.span < minSpan)) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + originalDistSign.sign * minSpan;
  }
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (maxSpan != null && currDistSign.span > maxSpan) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + currDistSign.sign * maxSpan;
  }
  return handleEnds;
}
function getSpanSign(handleEnds, handleIndex) {
  var dist2 = handleEnds[handleIndex] - handleEnds[1 - handleIndex];
  return {
    span: Math.abs(dist2),
    sign: dist2 > 0 ? -1 : dist2 < 0 ? 1 : handleIndex ? -1 : 1
  };
}
function restrict$1(value, extend3) {
  return Math.min(extend3[1] != null ? extend3[1] : Infinity, Math.max(extend3[0] != null ? extend3[0] : -Infinity, value));
}
var each$b = each$g;
var mathMin$2 = Math.min;
var mathMax$2 = Math.max;
var mathFloor = Math.floor;
var mathCeil = Math.ceil;
var round = round$3;
var PI$1 = Math.PI;
var Parallel = function() {
  function Parallel2(parallelModel, ecModel, api) {
    this.type = "parallel";
    this._axesMap = createHashMap();
    this._axesLayout = {};
    this.dimensions = parallelModel.dimensions;
    this._model = parallelModel;
    this._init(parallelModel, ecModel, api);
  }
  Parallel2.prototype._init = function(parallelModel, ecModel, api) {
    var dimensions = parallelModel.dimensions;
    var parallelAxisIndex = parallelModel.parallelAxisIndex;
    each$b(dimensions, function(dim, idx) {
      var axisIndex = parallelAxisIndex[idx];
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axis = this._axesMap.set(dim, new ParallelAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisIndex));
      var isCategory2 = axis.type === "category";
      axis.onBand = isCategory2 && axisModel.get("boundaryGap");
      axis.inverse = axisModel.get("inverse");
      axisModel.axis = axis;
      axis.model = axisModel;
      axis.coordinateSystem = axisModel.coordinateSystem = this;
    }, this);
  };
  Parallel2.prototype.update = function(ecModel, api) {
    this._updateAxesFromSeries(this._model, ecModel);
  };
  Parallel2.prototype.containPoint = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var axisBase = layoutInfo.axisBase;
    var layoutBase = layoutInfo.layoutBase;
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var pAxis = point[1 - pixelDimIndex];
    var pLayout = point[pixelDimIndex];
    return pAxis >= axisBase && pAxis <= axisBase + layoutInfo.axisLength && pLayout >= layoutBase && pLayout <= layoutBase + layoutInfo.layoutLength;
  };
  Parallel2.prototype.getModel = function() {
    return this._model;
  };
  Parallel2.prototype._updateAxesFromSeries = function(parallelModel, ecModel) {
    ecModel.eachSeries(function(seriesModel) {
      if (!parallelModel.contains(seriesModel, ecModel)) {
        return;
      }
      var data2 = seriesModel.getData();
      each$b(this.dimensions, function(dim) {
        var axis = this._axesMap.get(dim);
        axis.scale.unionExtentFromData(data2, data2.mapDimension(dim));
        niceScaleExtent(axis.scale, axis.model);
      }, this);
    }, this);
  };
  Parallel2.prototype.resize = function(parallelModel, api) {
    this._rect = getLayoutRect(parallelModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._layoutAxes();
  };
  Parallel2.prototype.getRect = function() {
    return this._rect;
  };
  Parallel2.prototype._makeLayoutInfo = function() {
    var parallelModel = this._model;
    var rect = this._rect;
    var xy = ["x", "y"];
    var wh2 = ["width", "height"];
    var layout2 = parallelModel.get("layout");
    var pixelDimIndex = layout2 === "horizontal" ? 0 : 1;
    var layoutLength = rect[wh2[pixelDimIndex]];
    var layoutExtent = [0, layoutLength];
    var axisCount = this.dimensions.length;
    var axisExpandWidth = restrict(parallelModel.get("axisExpandWidth"), layoutExtent);
    var axisExpandCount = restrict(parallelModel.get("axisExpandCount") || 0, [0, axisCount]);
    var axisExpandable = parallelModel.get("axisExpandable") && axisCount > 3 && axisCount > axisExpandCount && axisExpandCount > 1 && axisExpandWidth > 0 && layoutLength > 0;
    var axisExpandWindow = parallelModel.get("axisExpandWindow");
    var winSize;
    if (!axisExpandWindow) {
      winSize = restrict(axisExpandWidth * (axisExpandCount - 1), layoutExtent);
      var axisExpandCenter = parallelModel.get("axisExpandCenter") || mathFloor(axisCount / 2);
      axisExpandWindow = [axisExpandWidth * axisExpandCenter - winSize / 2];
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    } else {
      winSize = restrict(axisExpandWindow[1] - axisExpandWindow[0], layoutExtent);
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    }
    var axisCollapseWidth = (layoutLength - winSize) / (axisCount - axisExpandCount);
    axisCollapseWidth < 3 && (axisCollapseWidth = 0);
    var winInnerIndices = [mathFloor(round(axisExpandWindow[0] / axisExpandWidth, 1)) + 1, mathCeil(round(axisExpandWindow[1] / axisExpandWidth, 1)) - 1];
    var axisExpandWindow0Pos = axisCollapseWidth / axisExpandWidth * axisExpandWindow[0];
    return {
      layout: layout2,
      pixelDimIndex,
      layoutBase: rect[xy[pixelDimIndex]],
      layoutLength,
      axisBase: rect[xy[1 - pixelDimIndex]],
      axisLength: rect[wh2[1 - pixelDimIndex]],
      axisExpandable,
      axisExpandWidth,
      axisCollapseWidth,
      axisExpandWindow,
      axisCount,
      winInnerIndices,
      axisExpandWindow0Pos
    };
  };
  Parallel2.prototype._layoutAxes = function() {
    var rect = this._rect;
    var axes = this._axesMap;
    var dimensions = this.dimensions;
    var layoutInfo = this._makeLayoutInfo();
    var layout2 = layoutInfo.layout;
    axes.each(function(axis) {
      var axisExtent = [0, layoutInfo.axisLength];
      var idx = axis.inverse ? 1 : 0;
      axis.setExtent(axisExtent[idx], axisExtent[1 - idx]);
    });
    each$b(dimensions, function(dim, idx) {
      var posInfo = (layoutInfo.axisExpandable ? layoutAxisWithExpand : layoutAxisWithoutExpand)(idx, layoutInfo);
      var positionTable = {
        horizontal: {
          x: posInfo.position,
          y: layoutInfo.axisLength
        },
        vertical: {
          x: 0,
          y: posInfo.position
        }
      };
      var rotationTable = {
        horizontal: PI$1 / 2,
        vertical: 0
      };
      var position2 = [positionTable[layout2].x + rect.x, positionTable[layout2].y + rect.y];
      var rotation = rotationTable[layout2];
      var transform2 = create$2();
      rotate(transform2, transform2, rotation);
      translate(transform2, transform2, position2);
      this._axesLayout[dim] = {
        position: position2,
        rotation,
        transform: transform2,
        axisNameAvailableWidth: posInfo.axisNameAvailableWidth,
        axisLabelShow: posInfo.axisLabelShow,
        nameTruncateMaxWidth: posInfo.nameTruncateMaxWidth,
        tickDirection: 1,
        labelDirection: 1
      };
    }, this);
  };
  Parallel2.prototype.getAxis = function(dim) {
    return this._axesMap.get(dim);
  };
  Parallel2.prototype.dataToPoint = function(value, dim) {
    return this.axisCoordToPoint(this._axesMap.get(dim).dataToCoord(value), dim);
  };
  Parallel2.prototype.eachActiveState = function(data2, callback, start2, end2) {
    start2 == null && (start2 = 0);
    end2 == null && (end2 = data2.count());
    var axesMap = this._axesMap;
    var dimensions = this.dimensions;
    var dataDimensions = [];
    var axisModels = [];
    each$g(dimensions, function(axisDim) {
      dataDimensions.push(data2.mapDimension(axisDim));
      axisModels.push(axesMap.get(axisDim).model);
    });
    var hasActiveSet = this.hasAxisBrushed();
    for (var dataIndex = start2; dataIndex < end2; dataIndex++) {
      var activeState = void 0;
      if (!hasActiveSet) {
        activeState = "normal";
      } else {
        activeState = "active";
        var values = data2.getValues(dataDimensions, dataIndex);
        for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
          var state = axisModels[j].getActiveState(values[j]);
          if (state === "inactive") {
            activeState = "inactive";
            break;
          }
        }
      }
      callback(activeState, dataIndex);
    }
  };
  Parallel2.prototype.hasAxisBrushed = function() {
    var dimensions = this.dimensions;
    var axesMap = this._axesMap;
    var hasActiveSet = false;
    for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
      if (axesMap.get(dimensions[j]).model.getActiveState() !== "normal") {
        hasActiveSet = true;
      }
    }
    return hasActiveSet;
  };
  Parallel2.prototype.axisCoordToPoint = function(coord, dim) {
    var axisLayout = this._axesLayout[dim];
    return applyTransform([coord, 0], axisLayout.transform);
  };
  Parallel2.prototype.getAxisLayout = function(dim) {
    return clone$4(this._axesLayout[dim]);
  };
  Parallel2.prototype.getSlidedAxisExpandWindow = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var axisExpandWindow = layoutInfo.axisExpandWindow.slice();
    var winSize = axisExpandWindow[1] - axisExpandWindow[0];
    var extent3 = [0, layoutInfo.axisExpandWidth * (layoutInfo.axisCount - 1)];
    if (!this.containPoint(point)) {
      return {
        behavior: "none",
        axisExpandWindow
      };
    }
    var pointCoord = point[pixelDimIndex] - layoutInfo.layoutBase - layoutInfo.axisExpandWindow0Pos;
    var delta;
    var behavior = "slide";
    var axisCollapseWidth = layoutInfo.axisCollapseWidth;
    var triggerArea = this._model.get("axisExpandSlideTriggerArea");
    var useJump = triggerArea[0] != null;
    if (axisCollapseWidth) {
      if (useJump && axisCollapseWidth && pointCoord < winSize * triggerArea[0]) {
        behavior = "jump";
        delta = pointCoord - winSize * triggerArea[2];
      } else if (useJump && axisCollapseWidth && pointCoord > winSize * (1 - triggerArea[0])) {
        behavior = "jump";
        delta = pointCoord - winSize * (1 - triggerArea[2]);
      } else {
        (delta = pointCoord - winSize * triggerArea[1]) >= 0 && (delta = pointCoord - winSize * (1 - triggerArea[1])) <= 0 && (delta = 0);
      }
      delta *= layoutInfo.axisExpandWidth / axisCollapseWidth;
      delta ? sliderMove(delta, axisExpandWindow, extent3, "all") : behavior = "none";
    } else {
      var winSize2 = axisExpandWindow[1] - axisExpandWindow[0];
      var pos = extent3[1] * pointCoord / winSize2;
      axisExpandWindow = [mathMax$2(0, pos - winSize2 / 2)];
      axisExpandWindow[1] = mathMin$2(extent3[1], axisExpandWindow[0] + winSize2);
      axisExpandWindow[0] = axisExpandWindow[1] - winSize2;
    }
    return {
      axisExpandWindow,
      behavior
    };
  };
  return Parallel2;
}();
function restrict(len2, extent3) {
  return mathMin$2(mathMax$2(len2, extent3[0]), extent3[1]);
}
function layoutAxisWithoutExpand(axisIndex, layoutInfo) {
  var step = layoutInfo.layoutLength / (layoutInfo.axisCount - 1);
  return {
    position: step * axisIndex,
    axisNameAvailableWidth: step,
    axisLabelShow: true
  };
}
function layoutAxisWithExpand(axisIndex, layoutInfo) {
  var layoutLength = layoutInfo.layoutLength;
  var axisExpandWidth = layoutInfo.axisExpandWidth;
  var axisCount = layoutInfo.axisCount;
  var axisCollapseWidth = layoutInfo.axisCollapseWidth;
  var winInnerIndices = layoutInfo.winInnerIndices;
  var position2;
  var axisNameAvailableWidth = axisCollapseWidth;
  var axisLabelShow = false;
  var nameTruncateMaxWidth;
  if (axisIndex < winInnerIndices[0]) {
    position2 = axisIndex * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  } else if (axisIndex <= winInnerIndices[1]) {
    position2 = layoutInfo.axisExpandWindow0Pos + axisIndex * axisExpandWidth - layoutInfo.axisExpandWindow[0];
    axisNameAvailableWidth = axisExpandWidth;
    axisLabelShow = true;
  } else {
    position2 = layoutLength - (axisCount - 1 - axisIndex) * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  }
  return {
    position: position2,
    axisNameAvailableWidth,
    axisLabelShow,
    nameTruncateMaxWidth
  };
}
var Parallel$1 = Parallel;
function createParallelCoordSys(ecModel, api) {
  var coordSysList = [];
  ecModel.eachComponent("parallel", function(parallelModel, idx) {
    var coordSys = new Parallel$1(parallelModel, ecModel, api);
    coordSys.name = "parallel_" + idx;
    coordSys.resize(parallelModel, api);
    parallelModel.coordinateSystem = coordSys;
    coordSys.model = parallelModel;
    coordSysList.push(coordSys);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "parallel") {
      var parallelModel = seriesModel.getReferringComponents("parallel", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = parallelModel.coordinateSystem;
    }
  });
  return coordSysList;
}
var parallelCoordSysCreator = {
  create: createParallelCoordSys
};
var parallelCoordSysCreator$1 = parallelCoordSysCreator;
var ParallelAxisModel = function(_super) {
  __extends(ParallelAxisModel2, _super);
  function ParallelAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisModel2.type;
    _this.activeIntervals = [];
    return _this;
  }
  ParallelAxisModel2.prototype.getAreaSelectStyle = function() {
    return makeStyleMapper([
      ["fill", "color"],
      ["lineWidth", "borderWidth"],
      ["stroke", "borderColor"],
      ["width", "width"],
      ["opacity", "opacity"]
    ])(this.getModel("areaSelectStyle"));
  };
  ParallelAxisModel2.prototype.setActiveIntervals = function(intervals) {
    var activeIntervals = this.activeIntervals = clone$4(intervals);
    if (activeIntervals) {
      for (var i = activeIntervals.length - 1; i >= 0; i--) {
        asc$2(activeIntervals[i]);
      }
    }
  };
  ParallelAxisModel2.prototype.getActiveState = function(value) {
    var activeIntervals = this.activeIntervals;
    if (!activeIntervals.length) {
      return "normal";
    }
    if (value == null || isNaN(+value)) {
      return "inactive";
    }
    if (activeIntervals.length === 1) {
      var interval = activeIntervals[0];
      if (interval[0] <= value && value <= interval[1]) {
        return "active";
      }
    } else {
      for (var i = 0, len2 = activeIntervals.length; i < len2; i++) {
        if (activeIntervals[i][0] <= value && value <= activeIntervals[i][1]) {
          return "active";
        }
      }
    }
    return "inactive";
  };
  return ParallelAxisModel2;
}(ComponentModel$1);
mixin(ParallelAxisModel, AxisModelCommonMixin);
var ParallelAxisModel$1 = ParallelAxisModel;
var BRUSH_PANEL_GLOBAL = true;
var mathMin$1 = Math.min;
var mathMax$1 = Math.max;
var mathPow = Math.pow;
var COVER_Z = 1e4;
var UNSELECT_THRESHOLD = 6;
var MIN_RESIZE_LINE_WIDTH = 6;
var MUTEX_RESOURCE_KEY = "globalPan";
var DIRECTION_MAP = {
  w: [0, 0],
  e: [0, 1],
  n: [1, 0],
  s: [1, 1]
};
var CURSOR_MAP = {
  w: "ew",
  e: "ew",
  n: "ns",
  s: "ns",
  ne: "nesw",
  sw: "nesw",
  nw: "nwse",
  se: "nwse"
};
var DEFAULT_BRUSH_OPT = {
  brushStyle: {
    lineWidth: 2,
    stroke: "rgba(210,219,238,0.3)",
    fill: "#D2DBEE"
  },
  transformable: true,
  brushMode: "single",
  removeOnClick: false
};
var baseUID = 0;
var BrushController = function(_super) {
  __extends(BrushController2, _super);
  function BrushController2(zr) {
    var _this = _super.call(this) || this;
    _this._track = [];
    _this._covers = [];
    _this._handlers = {};
    _this._zr = zr;
    _this.group = new Group$6();
    _this._uid = "brushController_" + baseUID++;
    each$g(pointerHandlers, function(handler, eventName) {
      this._handlers[eventName] = bind$1(handler, this);
    }, _this);
    return _this;
  }
  BrushController2.prototype.enableBrush = function(brushOption) {
    this._brushType && this._doDisableBrush();
    brushOption.brushType && this._doEnableBrush(brushOption);
    return this;
  };
  BrushController2.prototype._doEnableBrush = function(brushOption) {
    var zr = this._zr;
    if (!this._enableGlobalPan) {
      take(zr, MUTEX_RESOURCE_KEY, this._uid);
    }
    each$g(this._handlers, function(handler, eventName) {
      zr.on(eventName, handler);
    });
    this._brushType = brushOption.brushType;
    this._brushOption = merge$1(clone$4(DEFAULT_BRUSH_OPT), brushOption, true);
  };
  BrushController2.prototype._doDisableBrush = function() {
    var zr = this._zr;
    release(zr, MUTEX_RESOURCE_KEY, this._uid);
    each$g(this._handlers, function(handler, eventName) {
      zr.off(eventName, handler);
    });
    this._brushType = this._brushOption = null;
  };
  BrushController2.prototype.setPanels = function(panelOpts) {
    if (panelOpts && panelOpts.length) {
      var panels_1 = this._panels = {};
      each$g(panelOpts, function(panelOpts2) {
        panels_1[panelOpts2.panelId] = clone$4(panelOpts2);
      });
    } else {
      this._panels = null;
    }
    return this;
  };
  BrushController2.prototype.mount = function(opt) {
    opt = opt || {};
    this._enableGlobalPan = opt.enableGlobalPan;
    var thisGroup = this.group;
    this._zr.add(thisGroup);
    thisGroup.attr({
      x: opt.x || 0,
      y: opt.y || 0,
      rotation: opt.rotation || 0,
      scaleX: opt.scaleX || 1,
      scaleY: opt.scaleY || 1
    });
    this._transform = thisGroup.getLocalTransform();
    return this;
  };
  BrushController2.prototype.updateCovers = function(coverConfigList) {
    coverConfigList = map$1(coverConfigList, function(coverConfig) {
      return merge$1(clone$4(DEFAULT_BRUSH_OPT), coverConfig, true);
    });
    var tmpIdPrefix = "\0-brush-index-";
    var oldCovers = this._covers;
    var newCovers = this._covers = [];
    var controller = this;
    var creatingCover = this._creatingCover;
    new DataDiffer$1(oldCovers, coverConfigList, oldGetKey, getKey2).add(addOrUpdate).update(addOrUpdate).remove(remove).execute();
    return this;
    function getKey2(brushOption, index2) {
      return (brushOption.id != null ? brushOption.id : tmpIdPrefix + index2) + "-" + brushOption.brushType;
    }
    function oldGetKey(cover, index2) {
      return getKey2(cover.__brushOption, index2);
    }
    function addOrUpdate(newIndex, oldIndex) {
      var newBrushInternal = coverConfigList[newIndex];
      if (oldIndex != null && oldCovers[oldIndex] === creatingCover) {
        newCovers[newIndex] = oldCovers[oldIndex];
      } else {
        var cover = newCovers[newIndex] = oldIndex != null ? (oldCovers[oldIndex].__brushOption = newBrushInternal, oldCovers[oldIndex]) : endCreating(controller, createCover(controller, newBrushInternal));
        updateCoverAfterCreation(controller, cover);
      }
    }
    function remove(oldIndex) {
      if (oldCovers[oldIndex] !== creatingCover) {
        controller.group.remove(oldCovers[oldIndex]);
      }
    }
  };
  BrushController2.prototype.unmount = function() {
    this.enableBrush(false);
    clearCovers(this);
    this._zr.remove(this.group);
    return this;
  };
  BrushController2.prototype.dispose = function() {
    this.unmount();
    this.off();
  };
  return BrushController2;
}(Eventful$1);
function createCover(controller, brushOption) {
  var cover = coverRenderers[brushOption.brushType].createCover(controller, brushOption);
  cover.__brushOption = brushOption;
  updateZ$1(cover, brushOption);
  controller.group.add(cover);
  return cover;
}
function endCreating(controller, creatingCover) {
  var coverRenderer = getCoverRenderer(creatingCover);
  if (coverRenderer.endCreating) {
    coverRenderer.endCreating(controller, creatingCover);
    updateZ$1(creatingCover, creatingCover.__brushOption);
  }
  return creatingCover;
}
function updateCoverShape(controller, cover) {
  var brushOption = cover.__brushOption;
  getCoverRenderer(cover).updateCoverShape(controller, cover, brushOption.range, brushOption);
}
function updateZ$1(cover, brushOption) {
  var z2 = brushOption.z;
  z2 == null && (z2 = COVER_Z);
  cover.traverse(function(el) {
    el.z = z2;
    el.z2 = z2;
  });
}
function updateCoverAfterCreation(controller, cover) {
  getCoverRenderer(cover).updateCommon(controller, cover);
  updateCoverShape(controller, cover);
}
function getCoverRenderer(cover) {
  return coverRenderers[cover.__brushOption.brushType];
}
function getPanelByPoint(controller, e2, localCursorPoint) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panel;
  var transform2 = controller._transform;
  each$g(panels, function(pn) {
    pn.isTargetByCursor(e2, localCursorPoint, transform2) && (panel = pn);
  });
  return panel;
}
function getPanelByCover(controller, cover) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panelId = cover.__brushOption.panelId;
  return panelId != null ? panels[panelId] : BRUSH_PANEL_GLOBAL;
}
function clearCovers(controller) {
  var covers = controller._covers;
  var originalLength = covers.length;
  each$g(covers, function(cover) {
    controller.group.remove(cover);
  }, controller);
  covers.length = 0;
  return !!originalLength;
}
function trigger(controller, opt) {
  var areas = map$1(controller._covers, function(cover) {
    var brushOption = cover.__brushOption;
    var range3 = clone$4(brushOption.range);
    return {
      brushType: brushOption.brushType,
      panelId: brushOption.panelId,
      range: range3
    };
  });
  controller.trigger("brush", {
    areas,
    isEnd: !!opt.isEnd,
    removeOnClick: !!opt.removeOnClick
  });
}
function shouldShowCover(controller) {
  var track = controller._track;
  if (!track.length) {
    return false;
  }
  var p2 = track[track.length - 1];
  var p1 = track[0];
  var dx = p2[0] - p1[0];
  var dy = p2[1] - p1[1];
  var dist2 = mathPow(dx * dx + dy * dy, 0.5);
  return dist2 > UNSELECT_THRESHOLD;
}
function getTrackEnds(track) {
  var tail = track.length - 1;
  tail < 0 && (tail = 0);
  return [track[0], track[tail]];
}
function createBaseRectCover(rectRangeConverter, controller, brushOption, edgeNameSequences) {
  var cover = new Group$6();
  cover.add(new Rect$3({
    name: "main",
    style: makeStyle(brushOption),
    silent: true,
    draggable: true,
    cursor: "move",
    drift: curry$3(driftRect, rectRangeConverter, controller, cover, ["n", "s", "w", "e"]),
    ondragend: curry$3(trigger, controller, {
      isEnd: true
    })
  }));
  each$g(edgeNameSequences, function(nameSequence) {
    cover.add(new Rect$3({
      name: nameSequence.join(""),
      style: {
        opacity: 0
      },
      draggable: true,
      silent: true,
      invisible: true,
      drift: curry$3(driftRect, rectRangeConverter, controller, cover, nameSequence),
      ondragend: curry$3(trigger, controller, {
        isEnd: true
      })
    }));
  });
  return cover;
}
function updateBaseRect(controller, cover, localRange, brushOption) {
  var lineWidth = brushOption.brushStyle.lineWidth || 0;
  var handleSize = mathMax$1(lineWidth, MIN_RESIZE_LINE_WIDTH);
  var x2 = localRange[0][0];
  var y2 = localRange[1][0];
  var xa2 = x2 - lineWidth / 2;
  var ya2 = y2 - lineWidth / 2;
  var x22 = localRange[0][1];
  var y22 = localRange[1][1];
  var x2a = x22 - handleSize + lineWidth / 2;
  var y2a = y22 - handleSize + lineWidth / 2;
  var width = x22 - x2;
  var height = y22 - y2;
  var widtha = width + lineWidth;
  var heighta = height + lineWidth;
  updateRectShape(controller, cover, "main", x2, y2, width, height);
  if (brushOption.transformable) {
    updateRectShape(controller, cover, "w", xa2, ya2, handleSize, heighta);
    updateRectShape(controller, cover, "e", x2a, ya2, handleSize, heighta);
    updateRectShape(controller, cover, "n", xa2, ya2, widtha, handleSize);
    updateRectShape(controller, cover, "s", xa2, y2a, widtha, handleSize);
    updateRectShape(controller, cover, "nw", xa2, ya2, handleSize, handleSize);
    updateRectShape(controller, cover, "ne", x2a, ya2, handleSize, handleSize);
    updateRectShape(controller, cover, "sw", xa2, y2a, handleSize, handleSize);
    updateRectShape(controller, cover, "se", x2a, y2a, handleSize, handleSize);
  }
}
function updateCommon$1(controller, cover) {
  var brushOption = cover.__brushOption;
  var transformable = brushOption.transformable;
  var mainEl = cover.childAt(0);
  mainEl.useStyle(makeStyle(brushOption));
  mainEl.attr({
    silent: !transformable,
    cursor: transformable ? "move" : "default"
  });
  each$g([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(nameSequence) {
    var el = cover.childOfName(nameSequence.join(""));
    var globalDir = nameSequence.length === 1 ? getGlobalDirection1(controller, nameSequence[0]) : getGlobalDirection2(controller, nameSequence);
    el && el.attr({
      silent: !transformable,
      invisible: !transformable,
      cursor: transformable ? CURSOR_MAP[globalDir] + "-resize" : null
    });
  });
}
function updateRectShape(controller, cover, name2, x2, y2, w2, h) {
  var el = cover.childOfName(name2);
  el && el.setShape(pointsToRect(clipByPanel(controller, cover, [[x2, y2], [x2 + w2, y2 + h]])));
}
function makeStyle(brushOption) {
  return defaults({
    strokeNoScale: true
  }, brushOption.brushStyle);
}
function formatRectRange(x2, y2, x22, y22) {
  var min3 = [mathMin$1(x2, x22), mathMin$1(y2, y22)];
  var max3 = [mathMax$1(x2, x22), mathMax$1(y2, y22)];
  return [
    [min3[0], max3[0]],
    [min3[1], max3[1]]
  ];
}
function getTransform(controller) {
  return getTransform$1(controller.group);
}
function getGlobalDirection1(controller, localDirName) {
  var map2 = {
    w: "left",
    e: "right",
    n: "top",
    s: "bottom"
  };
  var inverseMap = {
    left: "w",
    right: "e",
    top: "n",
    bottom: "s"
  };
  var dir3 = transformDirection(map2[localDirName], getTransform(controller));
  return inverseMap[dir3];
}
function getGlobalDirection2(controller, localDirNameSeq) {
  var globalDir = [getGlobalDirection1(controller, localDirNameSeq[0]), getGlobalDirection1(controller, localDirNameSeq[1])];
  (globalDir[0] === "e" || globalDir[0] === "w") && globalDir.reverse();
  return globalDir.join("");
}
function driftRect(rectRangeConverter, controller, cover, dirNameSequence, dx, dy) {
  var brushOption = cover.__brushOption;
  var rectRange = rectRangeConverter.toRectRange(brushOption.range);
  var localDelta = toLocalDelta(controller, dx, dy);
  each$g(dirNameSequence, function(dirName) {
    var ind = DIRECTION_MAP[dirName];
    rectRange[ind[0]][ind[1]] += localDelta[ind[0]];
  });
  brushOption.range = rectRangeConverter.fromRectRange(formatRectRange(rectRange[0][0], rectRange[1][0], rectRange[0][1], rectRange[1][1]));
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function driftPolygon(controller, cover, dx, dy) {
  var range3 = cover.__brushOption.range;
  var localDelta = toLocalDelta(controller, dx, dy);
  each$g(range3, function(point) {
    point[0] += localDelta[0];
    point[1] += localDelta[1];
  });
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function toLocalDelta(controller, dx, dy) {
  var thisGroup = controller.group;
  var localD = thisGroup.transformCoordToLocal(dx, dy);
  var localZero = thisGroup.transformCoordToLocal(0, 0);
  return [localD[0] - localZero[0], localD[1] - localZero[1]];
}
function clipByPanel(controller, cover, data2) {
  var panel = getPanelByCover(controller, cover);
  return panel && panel !== BRUSH_PANEL_GLOBAL ? panel.clipPath(data2, controller._transform) : clone$4(data2);
}
function pointsToRect(points2) {
  var xmin = mathMin$1(points2[0][0], points2[1][0]);
  var ymin = mathMin$1(points2[0][1], points2[1][1]);
  var xmax = mathMax$1(points2[0][0], points2[1][0]);
  var ymax = mathMax$1(points2[0][1], points2[1][1]);
  return {
    x: xmin,
    y: ymin,
    width: xmax - xmin,
    height: ymax - ymin
  };
}
function resetCursor(controller, e2, localCursorPoint) {
  if (!controller._brushType || isOutsideZrArea(controller, e2.offsetX, e2.offsetY)) {
    return;
  }
  var zr = controller._zr;
  var covers = controller._covers;
  var currPanel = getPanelByPoint(controller, e2, localCursorPoint);
  if (!controller._dragging) {
    for (var i = 0; i < covers.length; i++) {
      var brushOption = covers[i].__brushOption;
      if (currPanel && (currPanel === BRUSH_PANEL_GLOBAL || brushOption.panelId === currPanel.panelId) && coverRenderers[brushOption.brushType].contain(covers[i], localCursorPoint[0], localCursorPoint[1])) {
        return;
      }
    }
  }
  currPanel && zr.setCursorStyle("crosshair");
}
function preventDefault(e2) {
  var rawE = e2.event;
  rawE.preventDefault && rawE.preventDefault();
}
function mainShapeContain(cover, x2, y2) {
  return cover.childOfName("main").contain(x2, y2);
}
function updateCoverByMouse(controller, e2, localCursorPoint, isEnd) {
  var creatingCover = controller._creatingCover;
  var panel = controller._creatingPanel;
  var thisBrushOption = controller._brushOption;
  var eventParams;
  controller._track.push(localCursorPoint.slice());
  if (shouldShowCover(controller) || creatingCover) {
    if (panel && !creatingCover) {
      thisBrushOption.brushMode === "single" && clearCovers(controller);
      var brushOption = clone$4(thisBrushOption);
      brushOption.brushType = determineBrushType(brushOption.brushType, panel);
      brushOption.panelId = panel === BRUSH_PANEL_GLOBAL ? null : panel.panelId;
      creatingCover = controller._creatingCover = createCover(controller, brushOption);
      controller._covers.push(creatingCover);
    }
    if (creatingCover) {
      var coverRenderer = coverRenderers[determineBrushType(controller._brushType, panel)];
      var coverBrushOption = creatingCover.__brushOption;
      coverBrushOption.range = coverRenderer.getCreatingRange(clipByPanel(controller, creatingCover, controller._track));
      if (isEnd) {
        endCreating(controller, creatingCover);
        coverRenderer.updateCommon(controller, creatingCover);
      }
      updateCoverShape(controller, creatingCover);
      eventParams = {
        isEnd
      };
    }
  } else if (isEnd && thisBrushOption.brushMode === "single" && thisBrushOption.removeOnClick) {
    if (getPanelByPoint(controller, e2, localCursorPoint) && clearCovers(controller)) {
      eventParams = {
        isEnd,
        removeOnClick: true
      };
    }
  }
  return eventParams;
}
function determineBrushType(brushType, panel) {
  if (brushType === "auto") {
    return panel.defaultBrushType;
  }
  return brushType;
}
var pointerHandlers = {
  mousedown: function(e2) {
    if (this._dragging) {
      handleDragEnd(this, e2);
    } else if (!e2.target || !e2.target.draggable) {
      preventDefault(e2);
      var localCursorPoint = this.group.transformCoordToLocal(e2.offsetX, e2.offsetY);
      this._creatingCover = null;
      var panel = this._creatingPanel = getPanelByPoint(this, e2, localCursorPoint);
      if (panel) {
        this._dragging = true;
        this._track = [localCursorPoint.slice()];
      }
    }
  },
  mousemove: function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = this.group.transformCoordToLocal(x2, y2);
    resetCursor(this, e2, localCursorPoint);
    if (this._dragging) {
      preventDefault(e2);
      var eventParams = updateCoverByMouse(this, e2, localCursorPoint, false);
      eventParams && trigger(this, eventParams);
    }
  },
  mouseup: function(e2) {
    handleDragEnd(this, e2);
  }
};
function handleDragEnd(controller, e2) {
  if (controller._dragging) {
    preventDefault(e2);
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = controller.group.transformCoordToLocal(x2, y2);
    var eventParams = updateCoverByMouse(controller, e2, localCursorPoint, true);
    controller._dragging = false;
    controller._track = [];
    controller._creatingCover = null;
    eventParams && trigger(controller, eventParams);
  }
}
function isOutsideZrArea(controller, x2, y2) {
  var zr = controller._zr;
  return x2 < 0 || x2 > zr.getWidth() || y2 < 0 || y2 > zr.getHeight();
}
var coverRenderers = {
  lineX: getLineRenderer(0),
  lineY: getLineRenderer(1),
  rect: {
    createCover: function(controller, brushOption) {
      function returnInput(range3) {
        return range3;
      }
      return createBaseRectCover({
        toRectRange: returnInput,
        fromRectRange: returnInput
      }, controller, brushOption, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      return formatRectRange(ends[1][0], ends[1][1], ends[0][0], ends[0][1]);
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      updateBaseRect(controller, cover, localRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  },
  polygon: {
    createCover: function(controller, brushOption) {
      var cover = new Group$6();
      cover.add(new Polyline$3({
        name: "main",
        style: makeStyle(brushOption),
        silent: true
      }));
      return cover;
    },
    getCreatingRange: function(localTrack) {
      return localTrack;
    },
    endCreating: function(controller, cover) {
      cover.remove(cover.childAt(0));
      cover.add(new Polygon$1({
        name: "main",
        draggable: true,
        drift: curry$3(driftPolygon, controller, cover),
        ondragend: curry$3(trigger, controller, {
          isEnd: true
        })
      }));
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      cover.childAt(0).setShape({
        points: clipByPanel(controller, cover, localRange)
      });
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  }
};
function getLineRenderer(xyIndex) {
  return {
    createCover: function(controller, brushOption) {
      return createBaseRectCover({
        toRectRange: function(range3) {
          var rectRange = [range3, [0, 100]];
          xyIndex && rectRange.reverse();
          return rectRange;
        },
        fromRectRange: function(rectRange) {
          return rectRange[xyIndex];
        }
      }, controller, brushOption, [[["w"], ["e"]], [["n"], ["s"]]][xyIndex]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      var min3 = mathMin$1(ends[0][xyIndex], ends[1][xyIndex]);
      var max3 = mathMax$1(ends[0][xyIndex], ends[1][xyIndex]);
      return [min3, max3];
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      var otherExtent;
      var panel = getPanelByCover(controller, cover);
      if (panel !== BRUSH_PANEL_GLOBAL && panel.getLinearBrushOtherExtent) {
        otherExtent = panel.getLinearBrushOtherExtent(xyIndex);
      } else {
        var zr = controller._zr;
        otherExtent = [0, [zr.getWidth(), zr.getHeight()][1 - xyIndex]];
      }
      var rectRange = [localRange, otherExtent];
      xyIndex && rectRange.reverse();
      updateBaseRect(controller, cover, rectRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  };
}
var BrushController$1 = BrushController;
function makeRectPanelClipPath(rect) {
  rect = normalizeRect(rect);
  return function(localPoints) {
    return clipPointsByRect(localPoints, rect);
  };
}
function makeLinearBrushOtherExtent(rect, specifiedXYIndex) {
  rect = normalizeRect(rect);
  return function(xyIndex) {
    var idx = specifiedXYIndex != null ? specifiedXYIndex : xyIndex;
    var brushWidth = idx ? rect.width : rect.height;
    var base2 = idx ? rect.x : rect.y;
    return [base2, base2 + (brushWidth || 0)];
  };
}
function makeRectIsTargetByCursor(rect, api, targetModel) {
  var boundingRect = normalizeRect(rect);
  return function(e2, localCursorPoint) {
    return boundingRect.contain(localCursorPoint[0], localCursorPoint[1]) && !onIrrelevantElement(e2, api, targetModel);
  };
}
function normalizeRect(rect) {
  return BoundingRect$1.create(rect);
}
var elementList$1 = ["axisLine", "axisTickLabel", "axisName"];
var ParallelAxisView = function(_super) {
  __extends(ParallelAxisView2, _super);
  function ParallelAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisView2.type;
    return _this;
  }
  ParallelAxisView2.prototype.init = function(ecModel, api) {
    _super.prototype.init.apply(this, arguments);
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this));
  };
  ParallelAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    if (fromAxisAreaSelect(axisModel, ecModel, payload)) {
      return;
    }
    this.axisModel = axisModel;
    this.api = api;
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var coordSysModel = getCoordSysModel(axisModel, ecModel);
    var coordSys = coordSysModel.coordinateSystem;
    var areaSelectStyle = axisModel.getAreaSelectStyle();
    var areaWidth = areaSelectStyle.width;
    var dim = axisModel.axis.dim;
    var axisLayout = coordSys.getAxisLayout(dim);
    var builderOpt = extend({
      strokeContainThreshold: areaWidth
    }, axisLayout);
    var axisBuilder = new AxisBuilder$1(axisModel, builderOpt);
    each$g(elementList$1, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    this._refreshBrushController(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
  };
  ParallelAxisView2.prototype._refreshBrushController = function(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api) {
    var extent3 = axisModel.axis.getExtent();
    var extentLen = extent3[1] - extent3[0];
    var extra = Math.min(30, Math.abs(extentLen) * 0.1);
    var rect = BoundingRect$1.create({
      x: extent3[0],
      y: -areaWidth / 2,
      width: extentLen,
      height: areaWidth
    });
    rect.x -= extra;
    rect.width += 2 * extra;
    this._brushController.mount({
      enableGlobalPan: true,
      rotation: builderOpt.rotation,
      x: builderOpt.position[0],
      y: builderOpt.position[1]
    }).setPanels([{
      panelId: "pl",
      clipPath: makeRectPanelClipPath(rect),
      isTargetByCursor: makeRectIsTargetByCursor(rect, api, coordSysModel),
      getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect, 0)
    }]).enableBrush({
      brushType: "lineX",
      brushStyle: areaSelectStyle,
      removeOnClick: true
    }).updateCovers(getCoverInfoList(axisModel));
  };
  ParallelAxisView2.prototype._onBrush = function(eventParam) {
    var coverInfoList = eventParam.areas;
    var axisModel = this.axisModel;
    var axis = axisModel.axis;
    var intervals = map$1(coverInfoList, function(coverInfo) {
      return [axis.coordToData(coverInfo.range[0], true), axis.coordToData(coverInfo.range[1], true)];
    });
    if (!axisModel.option.realtime === eventParam.isEnd || eventParam.removeOnClick) {
      this.api.dispatchAction({
        type: "axisAreaSelect",
        parallelAxisId: axisModel.id,
        intervals
      });
    }
  };
  ParallelAxisView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  ParallelAxisView2.type = "parallelAxis";
  return ParallelAxisView2;
}(ComponentView$1);
function fromAxisAreaSelect(axisModel, ecModel, payload) {
  return payload && payload.type === "axisAreaSelect" && ecModel.findComponents({
    mainType: "parallelAxis",
    query: payload
  })[0] === axisModel;
}
function getCoverInfoList(axisModel) {
  var axis = axisModel.axis;
  return map$1(axisModel.activeIntervals, function(interval) {
    return {
      brushType: "lineX",
      panelId: "pl",
      range: [axis.dataToCoord(interval[0], true), axis.dataToCoord(interval[1], true)]
    };
  });
}
function getCoordSysModel(axisModel, ecModel) {
  return ecModel.getComponent("parallel", axisModel.get("parallelIndex"));
}
var ParallelAxisView$1 = ParallelAxisView;
var actionInfo = {
  type: "axisAreaSelect",
  event: "axisAreaSelected"
};
function installParallelActions(registers) {
  registers.registerAction(actionInfo, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallelAxis",
      query: payload
    }, function(parallelAxisModel) {
      parallelAxisModel.axis.model.setActiveIntervals(payload.intervals);
    });
  });
  registers.registerAction("parallelAxisExpand", function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallel",
      query: payload
    }, function(parallelModel) {
      parallelModel.setAxisExpand(payload);
    });
  });
}
var defaultAxisOption = {
  type: "value",
  areaSelectStyle: {
    width: 20,
    borderWidth: 1,
    borderColor: "rgba(160,197,232)",
    color: "rgba(160,197,232)",
    opacity: 0.3
  },
  realtime: true,
  z: 10
};
function install$C(registers) {
  registers.registerComponentView(ParallelView$1);
  registers.registerComponentModel(ParallelModel$1);
  registers.registerCoordinateSystem("parallel", parallelCoordSysCreator$1);
  registers.registerPreprocessor(parallelPreprocessor);
  registers.registerComponentModel(ParallelAxisModel$1);
  registers.registerComponentView(ParallelAxisView$1);
  axisModelCreator(registers, "parallel", ParallelAxisModel$1, defaultAxisOption);
  installParallelActions(registers);
}
function install$B(registers) {
  use(install$C);
  registers.registerChartView(ParallelView$3);
  registers.registerSeriesModel(ParallelSeriesModel$1);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, parallelVisual$1);
}
var SankeyPathShape = function() {
  function SankeyPathShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.cpx2 = 0;
    this.cpy2 = 0;
    this.extent = 0;
  }
  return SankeyPathShape2;
}();
var SankeyPath = function(_super) {
  __extends(SankeyPath2, _super);
  function SankeyPath2(opts) {
    return _super.call(this, opts) || this;
  }
  SankeyPath2.prototype.getDefaultShape = function() {
    return new SankeyPathShape();
  };
  SankeyPath2.prototype.buildPath = function(ctx, shape) {
    var extent3 = shape.extent;
    ctx.moveTo(shape.x1, shape.y1);
    ctx.bezierCurveTo(shape.cpx1, shape.cpy1, shape.cpx2, shape.cpy2, shape.x2, shape.y2);
    if (shape.orient === "vertical") {
      ctx.lineTo(shape.x2 + extent3, shape.y2);
      ctx.bezierCurveTo(shape.cpx2 + extent3, shape.cpy2, shape.cpx1 + extent3, shape.cpy1, shape.x1 + extent3, shape.y1);
    } else {
      ctx.lineTo(shape.x2, shape.y2 + extent3);
      ctx.bezierCurveTo(shape.cpx2, shape.cpy2 + extent3, shape.cpx1, shape.cpy1 + extent3, shape.x1, shape.y1 + extent3);
    }
    ctx.closePath();
  };
  SankeyPath2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  SankeyPath2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  return SankeyPath2;
}(Path$1);
var SankeyView = function(_super) {
  __extends(SankeyView2, _super);
  function SankeyView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeyView2.type;
    _this._focusAdjacencyDisabled = false;
    return _this;
  }
  SankeyView2.prototype.render = function(seriesModel, ecModel, api) {
    var sankeyView = this;
    var graph = seriesModel.getGraph();
    var group = this.group;
    var layoutInfo = seriesModel.layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var nodeData = seriesModel.getData();
    var edgeData = seriesModel.getData("edge");
    var orient = seriesModel.get("orient");
    this._model = seriesModel;
    group.removeAll();
    group.x = layoutInfo.x;
    group.y = layoutInfo.y;
    graph.eachEdge(function(edge) {
      var curve = new SankeyPath();
      var ecData = getECData(curve);
      ecData.dataIndex = edge.dataIndex;
      ecData.seriesIndex = seriesModel.seriesIndex;
      ecData.dataType = "edge";
      var edgeModel = edge.getModel();
      var lineStyleModel = edgeModel.getModel("lineStyle");
      var curvature = lineStyleModel.get("curveness");
      var n1Layout = edge.node1.getLayout();
      var node1Model = edge.node1.getModel();
      var dragX1 = node1Model.get("localX");
      var dragY1 = node1Model.get("localY");
      var n2Layout = edge.node2.getLayout();
      var node2Model = edge.node2.getModel();
      var dragX2 = node2Model.get("localX");
      var dragY2 = node2Model.get("localY");
      var edgeLayout = edge.getLayout();
      var x1;
      var y1;
      var x2;
      var y2;
      var cpx1;
      var cpy1;
      var cpx2;
      var cpy2;
      curve.shape.extent = Math.max(1, edgeLayout.dy);
      curve.shape.orient = orient;
      if (orient === "vertical") {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + edgeLayout.sy;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + n1Layout.dy;
        x2 = (dragX2 != null ? dragX2 * width : n2Layout.x) + edgeLayout.ty;
        y2 = dragY2 != null ? dragY2 * height : n2Layout.y;
        cpx1 = x1;
        cpy1 = y1 * (1 - curvature) + y2 * curvature;
        cpx2 = x2;
        cpy2 = y1 * curvature + y2 * (1 - curvature);
      } else {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + n1Layout.dx;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + edgeLayout.sy;
        x2 = dragX2 != null ? dragX2 * width : n2Layout.x;
        y2 = (dragY2 != null ? dragY2 * height : n2Layout.y) + edgeLayout.ty;
        cpx1 = x1 * (1 - curvature) + x2 * curvature;
        cpy1 = y1;
        cpx2 = x1 * curvature + x2 * (1 - curvature);
        cpy2 = y2;
      }
      curve.setShape({
        x1,
        y1,
        x2,
        y2,
        cpx1,
        cpy1,
        cpx2,
        cpy2
      });
      curve.useStyle(lineStyleModel.getItemStyle());
      switch (curve.style.fill) {
        case "source":
          curve.style.fill = edge.node1.getVisual("color");
          curve.style.decal = edge.node1.getVisual("style").decal;
          break;
        case "target":
          curve.style.fill = edge.node2.getVisual("color");
          curve.style.decal = edge.node2.getVisual("style").decal;
          break;
        case "gradient":
          var sourceColor = edge.node1.getVisual("color");
          var targetColor = edge.node2.getVisual("color");
          if (isString$1(sourceColor) && isString$1(targetColor)) {
            curve.style.fill = new LinearGradient$1(0, 0, +(orient === "horizontal"), +(orient === "vertical"), [{
              color: sourceColor,
              offset: 0
            }, {
              color: targetColor,
              offset: 1
            }]);
          }
      }
      var emphasisModel = edgeModel.getModel("emphasis");
      setStatesStylesFromModel(curve, edgeModel, "lineStyle", function(model) {
        return model.getItemStyle();
      });
      group.add(curve);
      edgeData.setItemGraphicEl(edge.dataIndex, curve);
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(curve, focus === "adjacency" ? edge.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
      getECData(curve).dataType = "edge";
    });
    graph.eachNode(function(node) {
      var layout2 = node.getLayout();
      var itemModel = node.getModel();
      var dragX = itemModel.get("localX");
      var dragY = itemModel.get("localY");
      var emphasisModel = itemModel.getModel("emphasis");
      var rect = new Rect$3({
        shape: {
          x: dragX != null ? dragX * width : layout2.x,
          y: dragY != null ? dragY * height : layout2.y,
          width: layout2.dx,
          height: layout2.dy
        },
        style: itemModel.getModel("itemStyle").getItemStyle(),
        z2: 10
      });
      setLabelStyle(rect, getLabelStatesModels(itemModel), {
        labelFetcher: seriesModel,
        labelDataIndex: node.dataIndex,
        defaultText: node.id
      });
      rect.disableLabelAnimation = true;
      rect.setStyle("fill", node.getVisual("color"));
      rect.setStyle("decal", node.getVisual("style").decal);
      setStatesStylesFromModel(rect, itemModel);
      group.add(rect);
      nodeData.setItemGraphicEl(node.dataIndex, rect);
      getECData(rect).dataType = "node";
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(rect, focus === "adjacency" ? node.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    nodeData.eachItemGraphicEl(function(el, dataIndex) {
      var itemModel = nodeData.getItemModel(dataIndex);
      if (itemModel.get("draggable")) {
        el.drift = function(dx, dy) {
          sankeyView._focusAdjacencyDisabled = true;
          this.shape.x += dx;
          this.shape.y += dy;
          this.dirty();
          api.dispatchAction({
            type: "dragNode",
            seriesId: seriesModel.id,
            dataIndex: nodeData.getRawIndex(dataIndex),
            localX: this.shape.x / width,
            localY: this.shape.y / height
          });
        };
        el.ondragend = function() {
          sankeyView._focusAdjacencyDisabled = false;
        };
        el.draggable = true;
        el.cursor = "move";
      }
    });
    if (!this._data && seriesModel.isAnimationEnabled()) {
      group.setClipPath(createGridClipShape$1(group.getBoundingRect(), seriesModel, function() {
        group.removeClipPath();
      }));
    }
    this._data = seriesModel.getData();
  };
  SankeyView2.prototype.dispose = function() {
  };
  SankeyView2.type = "sankey";
  return SankeyView2;
}(ChartView$1);
function createGridClipShape$1(rect, seriesModel, cb2) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      width: rect.width + 20
    }
  }, seriesModel, cb2);
  return rectEl;
}
var SankeyView$1 = SankeyView;
var SankeySeriesModel = function(_super) {
  __extends(SankeySeriesModel2, _super);
  function SankeySeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeySeriesModel2.type;
    return _this;
  }
  SankeySeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var links = option.edges || option.links;
    var nodes = option.data || option.nodes;
    var levels = option.levels;
    this.levelModels = [];
    var levelModels = this.levelModels;
    for (var i = 0; i < levels.length; i++) {
      if (levels[i].depth != null && levels[i].depth >= 0) {
        levelModels[levels[i].depth] = new Model$1(levels[i], this, ecModel);
      }
    }
    if (nodes && links) {
      var graph = createGraphFromNodeEdge(nodes, links, this, true, beforeLink);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var layout2 = seriesModel.getData().getItemLayout(idx);
        if (layout2) {
          var nodeDepth = layout2.depth;
          var levelModel = seriesModel.levelModels[nodeDepth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
      edgeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var edge = seriesModel.getGraph().getEdgeByIndex(idx);
        var layout2 = edge.node1.getLayout();
        if (layout2) {
          var depth = layout2.depth;
          var levelModel = seriesModel.levelModels[depth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
    }
  };
  SankeySeriesModel2.prototype.setNodePosition = function(dataIndex, localPosition) {
    var nodes = this.option.data || this.option.nodes;
    var dataItem = nodes[dataIndex];
    dataItem.localX = localPosition[0];
    dataItem.localY = localPosition[1];
  };
  SankeySeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  SankeySeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  SankeySeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    function noValue(val) {
      return isNaN(val) || val == null;
    }
    if (dataType === "edge") {
      var params = this.getDataParams(dataIndex, dataType);
      var rawDataOpt = params.data;
      var edgeValue = params.value;
      var edgeName = rawDataOpt.source + " -- " + rawDataOpt.target;
      return createTooltipMarkup("nameValue", {
        name: edgeName,
        value: edgeValue,
        noValue: noValue(edgeValue)
      });
    } else {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var value = node.getLayout().value;
      var name_1 = this.getDataParams(dataIndex, dataType).data.name;
      return createTooltipMarkup("nameValue", {
        name: name_1 != null ? name_1 + "" : null,
        value,
        noValue: noValue(value)
      });
    }
  };
  SankeySeriesModel2.prototype.optionUpdated = function() {
  };
  SankeySeriesModel2.prototype.getDataParams = function(dataIndex, dataType) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    if (params.value == null && dataType === "node") {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var nodeValue = node.getLayout().value;
      params.value = nodeValue;
    }
    return params;
  };
  SankeySeriesModel2.type = "series.sankey";
  SankeySeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "5%",
    top: "5%",
    right: "20%",
    bottom: "5%",
    orient: "horizontal",
    nodeWidth: 20,
    nodeGap: 8,
    draggable: true,
    layoutIterations: 32,
    label: {
      show: true,
      position: "right",
      fontSize: 12
    },
    levels: [],
    nodeAlign: "justify",
    lineStyle: {
      color: "#314656",
      opacity: 0.2,
      curveness: 0.5
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        opacity: 0.5
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    animationEasing: "linear",
    animationDuration: 1e3
  };
  return SankeySeriesModel2;
}(SeriesModel$1);
var SankeySeriesModel$1 = SankeySeriesModel;
function sankeyLayout(ecModel, api) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var nodeWidth = seriesModel.get("nodeWidth");
    var nodeGap = seriesModel.get("nodeGap");
    var layoutInfo = getViewRect$1(seriesModel, api);
    seriesModel.layoutInfo = layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    var edges = graph.edges;
    computeNodeValues(nodes);
    var filteredNodes = filter(nodes, function(node) {
      return node.getLayout().value === 0;
    });
    var iterations = filteredNodes.length !== 0 ? 0 : seriesModel.get("layoutIterations");
    var orient = seriesModel.get("orient");
    var nodeAlign = seriesModel.get("nodeAlign");
    layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign);
  });
}
function getViewRect$1(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign) {
  computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign);
  computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient);
  computeEdgeDepths(nodes, orient);
}
function computeNodeValues(nodes) {
  each$g(nodes, function(node) {
    var value1 = sum(node.outEdges, getEdgeValue);
    var value2 = sum(node.inEdges, getEdgeValue);
    var nodeRawValue = node.getValue() || 0;
    var value = Math.max(value1, value2, nodeRawValue);
    node.setLayout({
      value
    }, true);
  });
}
function computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign) {
  var remainEdges = [];
  var indegreeArr = [];
  var zeroIndegrees = [];
  var nextTargetNode = [];
  var x2 = 0;
  for (var i = 0; i < edges.length; i++) {
    remainEdges[i] = 1;
  }
  for (var i = 0; i < nodes.length; i++) {
    indegreeArr[i] = nodes[i].inEdges.length;
    if (indegreeArr[i] === 0) {
      zeroIndegrees.push(nodes[i]);
    }
  }
  var maxNodeDepth = -1;
  while (zeroIndegrees.length) {
    for (var idx = 0; idx < zeroIndegrees.length; idx++) {
      var node = zeroIndegrees[idx];
      var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
      var isItemDepth = item.depth != null && item.depth >= 0;
      if (isItemDepth && item.depth > maxNodeDepth) {
        maxNodeDepth = item.depth;
      }
      node.setLayout({
        depth: isItemDepth ? item.depth : x2
      }, true);
      orient === "vertical" ? node.setLayout({
        dy: nodeWidth
      }, true) : node.setLayout({
        dx: nodeWidth
      }, true);
      for (var edgeIdx = 0; edgeIdx < node.outEdges.length; edgeIdx++) {
        var edge = node.outEdges[edgeIdx];
        var indexEdge = edges.indexOf(edge);
        remainEdges[indexEdge] = 0;
        var targetNode = edge.node2;
        var nodeIndex = nodes.indexOf(targetNode);
        if (--indegreeArr[nodeIndex] === 0 && nextTargetNode.indexOf(targetNode) < 0) {
          nextTargetNode.push(targetNode);
        }
      }
    }
    ++x2;
    zeroIndegrees = nextTargetNode;
    nextTargetNode = [];
  }
  for (var i = 0; i < remainEdges.length; i++) {
    if (remainEdges[i] === 1) {
      throw new Error("Sankey is a DAG, the original data has cycle!");
    }
  }
  var maxDepth = maxNodeDepth > x2 - 1 ? maxNodeDepth : x2 - 1;
  if (nodeAlign && nodeAlign !== "left") {
    adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth);
  }
  var kx = orient === "vertical" ? (height - nodeWidth) / maxDepth : (width - nodeWidth) / maxDepth;
  scaleNodeBreadths(nodes, kx, orient);
}
function isNodeDepth(node) {
  var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
  return item.depth != null && item.depth >= 0;
}
function adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth) {
  if (nodeAlign === "right") {
    var nextSourceNode = [];
    var remainNodes = nodes;
    var nodeHeight = 0;
    while (remainNodes.length) {
      for (var i = 0; i < remainNodes.length; i++) {
        var node = remainNodes[i];
        node.setLayout({
          skNodeHeight: nodeHeight
        }, true);
        for (var j = 0; j < node.inEdges.length; j++) {
          var edge = node.inEdges[j];
          if (nextSourceNode.indexOf(edge.node1) < 0) {
            nextSourceNode.push(edge.node1);
          }
        }
      }
      remainNodes = nextSourceNode;
      nextSourceNode = [];
      ++nodeHeight;
    }
    each$g(nodes, function(node2) {
      if (!isNodeDepth(node2)) {
        node2.setLayout({
          depth: Math.max(0, maxDepth - node2.getLayout().skNodeHeight)
        }, true);
      }
    });
  } else if (nodeAlign === "justify") {
    moveSinksRight(nodes, maxDepth);
  }
}
function moveSinksRight(nodes, maxDepth) {
  each$g(nodes, function(node) {
    if (!isNodeDepth(node) && !node.outEdges.length) {
      node.setLayout({
        depth: maxDepth
      }, true);
    }
  });
}
function scaleNodeBreadths(nodes, kx, orient) {
  each$g(nodes, function(node) {
    var nodeDepth = node.getLayout().depth * kx;
    orient === "vertical" ? node.setLayout({
      y: nodeDepth
    }, true) : node.setLayout({
      x: nodeDepth
    }, true);
  });
}
function computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient) {
  var nodesByBreadth = prepareNodesByBreadth(nodes, orient);
  initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient);
  resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  for (var alpha = 1; iterations > 0; iterations--) {
    alpha *= 0.99;
    relaxRightToLeft(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
    relaxLeftToRight(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  }
}
function prepareNodesByBreadth(nodes, orient) {
  var nodesByBreadth = [];
  var keyAttr = orient === "vertical" ? "y" : "x";
  var groupResult = groupData(nodes, function(node) {
    return node.getLayout()[keyAttr];
  });
  groupResult.keys.sort(function(a, b2) {
    return a - b2;
  });
  each$g(groupResult.keys, function(key) {
    nodesByBreadth.push(groupResult.buckets.get(key));
  });
  return nodesByBreadth;
}
function initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient) {
  var minKy = Infinity;
  each$g(nodesByBreadth, function(nodes) {
    var n2 = nodes.length;
    var sum2 = 0;
    each$g(nodes, function(node) {
      sum2 += node.getLayout().value;
    });
    var ky = orient === "vertical" ? (width - (n2 - 1) * nodeGap) / sum2 : (height - (n2 - 1) * nodeGap) / sum2;
    if (ky < minKy) {
      minKy = ky;
    }
  });
  each$g(nodesByBreadth, function(nodes) {
    each$g(nodes, function(node, i) {
      var nodeDy = node.getLayout().value * minKy;
      if (orient === "vertical") {
        node.setLayout({
          x: i
        }, true);
        node.setLayout({
          dx: nodeDy
        }, true);
      } else {
        node.setLayout({
          y: i
        }, true);
        node.setLayout({
          dy: nodeDy
        }, true);
      }
    });
  });
  each$g(edges, function(edge) {
    var edgeDy = +edge.getValue() * minKy;
    edge.setLayout({
      dy: edgeDy
    }, true);
  });
}
function resolveCollisions(nodesByBreadth, nodeGap, height, width, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$g(nodesByBreadth, function(nodes) {
    nodes.sort(function(a, b2) {
      return a.getLayout()[keyAttr] - b2.getLayout()[keyAttr];
    });
    var nodeX;
    var node;
    var dy;
    var y0 = 0;
    var n2 = nodes.length;
    var nodeDyAttr = orient === "vertical" ? "dx" : "dy";
    for (var i = 0; i < n2; i++) {
      node = nodes[i];
      dy = y0 - node.getLayout()[keyAttr];
      if (dy > 0) {
        nodeX = node.getLayout()[keyAttr] + dy;
        orient === "vertical" ? node.setLayout({
          x: nodeX
        }, true) : node.setLayout({
          y: nodeX
        }, true);
      }
      y0 = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap;
    }
    var viewWidth = orient === "vertical" ? width : height;
    dy = y0 - nodeGap - viewWidth;
    if (dy > 0) {
      nodeX = node.getLayout()[keyAttr] - dy;
      orient === "vertical" ? node.setLayout({
        x: nodeX
      }, true) : node.setLayout({
        y: nodeX
      }, true);
      y0 = nodeX;
      for (var i = n2 - 2; i >= 0; --i) {
        node = nodes[i];
        dy = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap - y0;
        if (dy > 0) {
          nodeX = node.getLayout()[keyAttr] - dy;
          orient === "vertical" ? node.setLayout({
            x: nodeX
          }, true) : node.setLayout({
            y: nodeX
          }, true);
        }
        y0 = node.getLayout()[keyAttr];
      }
    }
  });
}
function relaxRightToLeft(nodesByBreadth, alpha, orient) {
  each$g(nodesByBreadth.slice().reverse(), function(nodes) {
    each$g(nodes, function(node) {
      if (node.outEdges.length) {
        var y2 = sum(node.outEdges, weightedTarget, orient) / sum(node.outEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.outEdges.length;
          y2 = len2 ? sum(node.outEdges, centerTarget, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function weightedTarget(edge, orient) {
  return center(edge.node2, orient) * edge.getValue();
}
function centerTarget(edge, orient) {
  return center(edge.node2, orient);
}
function weightedSource(edge, orient) {
  return center(edge.node1, orient) * edge.getValue();
}
function centerSource(edge, orient) {
  return center(edge.node1, orient);
}
function center(node, orient) {
  return orient === "vertical" ? node.getLayout().x + node.getLayout().dx / 2 : node.getLayout().y + node.getLayout().dy / 2;
}
function getEdgeValue(edge) {
  return edge.getValue();
}
function sum(array4, cb2, orient) {
  var sum2 = 0;
  var len2 = array4.length;
  var i = -1;
  while (++i < len2) {
    var value = +cb2(array4[i], orient);
    if (!isNaN(value)) {
      sum2 += value;
    }
  }
  return sum2;
}
function relaxLeftToRight(nodesByBreadth, alpha, orient) {
  each$g(nodesByBreadth, function(nodes) {
    each$g(nodes, function(node) {
      if (node.inEdges.length) {
        var y2 = sum(node.inEdges, weightedSource, orient) / sum(node.inEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.inEdges.length;
          y2 = len2 ? sum(node.inEdges, centerSource, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function computeEdgeDepths(nodes, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$g(nodes, function(node) {
    node.outEdges.sort(function(a, b2) {
      return a.node2.getLayout()[keyAttr] - b2.node2.getLayout()[keyAttr];
    });
    node.inEdges.sort(function(a, b2) {
      return a.node1.getLayout()[keyAttr] - b2.node1.getLayout()[keyAttr];
    });
  });
  each$g(nodes, function(node) {
    var sy = 0;
    var ty = 0;
    each$g(node.outEdges, function(edge) {
      edge.setLayout({
        sy
      }, true);
      sy += edge.getLayout().dy;
    });
    each$g(node.inEdges, function(edge) {
      edge.setLayout({
        ty
      }, true);
      ty += edge.getLayout().dy;
    });
  });
}
function sankeyVisual(ecModel) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    if (nodes.length) {
      var minValue_1 = Infinity;
      var maxValue_1 = -Infinity;
      each$g(nodes, function(node) {
        var nodeValue = node.getLayout().value;
        if (nodeValue < minValue_1) {
          minValue_1 = nodeValue;
        }
        if (nodeValue > maxValue_1) {
          maxValue_1 = nodeValue;
        }
      });
      each$g(nodes, function(node) {
        var mapping = new VisualMapping$1({
          type: "color",
          mappingMethod: "linear",
          dataExtent: [minValue_1, maxValue_1],
          visual: seriesModel.get("color")
        });
        var mapValueToColor = mapping.mapValueToVisual(node.getLayout().value);
        var customColor = node.getModel().get(["itemStyle", "color"]);
        if (customColor != null) {
          node.setVisual("color", customColor);
          node.setVisual("style", {
            fill: customColor
          });
        } else {
          node.setVisual("color", mapValueToColor);
          node.setVisual("style", {
            fill: mapValueToColor
          });
        }
      });
    }
  });
}
function install$A(registers) {
  registers.registerChartView(SankeyView$1);
  registers.registerSeriesModel(SankeySeriesModel$1);
  registers.registerLayout(sankeyLayout);
  registers.registerVisual(sankeyVisual);
  registers.registerAction({
    type: "dragNode",
    event: "dragnode",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sankey",
      query: payload
    }, function(seriesModel) {
      seriesModel.setNodePosition(payload.dataIndex, [payload.localX, payload.localY]);
    });
  });
}
var WhiskerBoxCommonMixin = function() {
  function WhiskerBoxCommonMixin2() {
  }
  WhiskerBoxCommonMixin2.prototype.getInitialData = function(option, ecModel) {
    var ordinalMeta;
    var xAxisModel = ecModel.getComponent("xAxis", this.get("xAxisIndex"));
    var yAxisModel = ecModel.getComponent("yAxis", this.get("yAxisIndex"));
    var xAxisType = xAxisModel.get("type");
    var yAxisType = yAxisModel.get("type");
    var addOrdinal;
    if (xAxisType === "category") {
      option.layout = "horizontal";
      ordinalMeta = xAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else if (yAxisType === "category") {
      option.layout = "vertical";
      ordinalMeta = yAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else {
      option.layout = option.layout || "horizontal";
    }
    var coordDims = ["x", "y"];
    var baseAxisDimIndex = option.layout === "horizontal" ? 0 : 1;
    var baseAxisDim = this._baseAxisDim = coordDims[baseAxisDimIndex];
    var otherAxisDim = coordDims[1 - baseAxisDimIndex];
    var axisModels = [xAxisModel, yAxisModel];
    var baseAxisType = axisModels[baseAxisDimIndex].get("type");
    var otherAxisType = axisModels[1 - baseAxisDimIndex].get("type");
    var data2 = option.data;
    if (data2 && addOrdinal) {
      var newOptionData_1 = [];
      each$g(data2, function(item, index2) {
        var newItem;
        if (isArray$2(item)) {
          newItem = item.slice();
          item.unshift(index2);
        } else if (isArray$2(item.value)) {
          newItem = extend({}, item);
          newItem.value = newItem.value.slice();
          item.value.unshift(index2);
        } else {
          newItem = item;
        }
        newOptionData_1.push(newItem);
      });
      option.data = newOptionData_1;
    }
    var defaultValueDimensions = this.defaultValueDimensions;
    var coordDimensions = [{
      name: baseAxisDim,
      type: getDimensionTypeByAxis(baseAxisType),
      ordinalMeta,
      otherDims: {
        tooltip: false,
        itemName: 0
      },
      dimsDef: ["base"]
    }, {
      name: otherAxisDim,
      type: getDimensionTypeByAxis(otherAxisType),
      dimsDef: defaultValueDimensions.slice()
    }];
    return createSeriesDataSimply(this, {
      coordDimensions,
      dimensionsCount: defaultValueDimensions.length + 1,
      encodeDefaulter: curry$3(makeSeriesEncodeForAxisCoordSys, coordDimensions, this)
    });
  };
  WhiskerBoxCommonMixin2.prototype.getBaseAxis = function() {
    var dim = this._baseAxisDim;
    return this.ecModel.getComponent(dim + "Axis", this.get(dim + "AxisIndex")).axis;
  };
  return WhiskerBoxCommonMixin2;
}();
var BoxplotSeriesModel = function(_super) {
  __extends(BoxplotSeriesModel2, _super);
  function BoxplotSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "min",
      defaultTooltip: true
    }, {
      name: "Q1",
      defaultTooltip: true
    }, {
      name: "median",
      defaultTooltip: true
    }, {
      name: "Q3",
      defaultTooltip: true
    }, {
      name: "max",
      defaultTooltip: true
    }];
    _this.visualDrawType = "stroke";
    return _this;
  }
  BoxplotSeriesModel2.type = "series.boxplot";
  BoxplotSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  BoxplotSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    boxWidth: [7, 50],
    itemStyle: {
      color: "#fff",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2,
        shadowBlur: 5,
        shadowOffsetX: 1,
        shadowOffsetY: 1,
        shadowColor: "rgba(0,0,0,0.2)"
      }
    },
    animationDuration: 800
  };
  return BoxplotSeriesModel2;
}(SeriesModel$1);
mixin(BoxplotSeriesModel, WhiskerBoxCommonMixin, true);
var BoxplotSeriesModel$1 = BoxplotSeriesModel;
var BoxplotView = function(_super) {
  __extends(BoxplotView2, _super);
  function BoxplotView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotView2.type;
    return _this;
  }
  BoxplotView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var group = this.group;
    var oldData = this._data;
    if (!this._data) {
      group.removeAll();
    }
    var constDim = seriesModel.get("layout") === "horizontal" ? 1 : 0;
    data2.diff(oldData).add(function(newIdx) {
      if (data2.hasValue(newIdx)) {
        var itemLayout = data2.getItemLayout(newIdx);
        var symbolEl = createNormalBox$1(itemLayout, data2, newIdx, constDim, true);
        data2.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!data2.hasValue(newIdx)) {
        group.remove(symbolEl);
        return;
      }
      var itemLayout = data2.getItemLayout(newIdx);
      if (!symbolEl) {
        symbolEl = createNormalBox$1(itemLayout, data2, newIdx, constDim);
      } else {
        saveOldStyle(symbolEl);
        updateNormalBoxData(itemLayout, symbolEl, data2, newIdx);
      }
      group.add(symbolEl);
      data2.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data2;
  };
  BoxplotView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var data2 = this._data;
    this._data = null;
    data2 && data2.eachItemGraphicEl(function(el) {
      el && group.remove(el);
    });
  };
  BoxplotView2.type = "boxplot";
  return BoxplotView2;
}(ChartView$1);
var BoxPathShape = function() {
  function BoxPathShape2() {
  }
  return BoxPathShape2;
}();
var BoxPath = function(_super) {
  __extends(BoxPath2, _super);
  function BoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "boxplotBoxPath";
    return _this;
  }
  BoxPath2.prototype.getDefaultShape = function() {
    return new BoxPathShape();
  };
  BoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    var i = 0;
    ctx.moveTo(ends[i][0], ends[i][1]);
    i++;
    for (; i < 4; i++) {
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
    ctx.closePath();
    for (; i < ends.length; i++) {
      ctx.moveTo(ends[i][0], ends[i][1]);
      i++;
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
  };
  return BoxPath2;
}(Path$1);
function createNormalBox$1(itemLayout, data2, dataIndex, constDim, isInit) {
  var ends = itemLayout.ends;
  var el = new BoxPath({
    shape: {
      points: isInit ? transInit$1(ends, constDim, itemLayout) : ends
    }
  });
  updateNormalBoxData(itemLayout, el, data2, dataIndex, isInit);
  return el;
}
function updateNormalBoxData(itemLayout, el, data2, dataIndex, isInit) {
  var seriesModel = data2.hostModel;
  var updateMethod = graphic[isInit ? "initProps" : "updateProps"];
  updateMethod(el, {
    shape: {
      points: itemLayout.ends
    }
  }, seriesModel, dataIndex);
  el.useStyle(data2.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.z2 = 100;
  var itemModel = data2.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function transInit$1(points2, dim, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[dim] = itemLayout.initBaseline;
    return point;
  });
}
var BoxplotView$1 = BoxplotView;
function boxplotVisual(ecModel, api) {
}
var each$a = each$g;
function boxplotLayout(ecModel) {
  var groupResult = groupSeriesByAxis(ecModel);
  each$a(groupResult, function(groupItem) {
    var seriesModels = groupItem.seriesModels;
    if (!seriesModels.length) {
      return;
    }
    calculateBase(groupItem);
    each$a(seriesModels, function(seriesModel, idx) {
      layoutSingleSeries(seriesModel, groupItem.boxOffsetList[idx], groupItem.boxWidthList[idx]);
    });
  });
}
function groupSeriesByAxis(ecModel) {
  var result = [];
  var axisList = [];
  ecModel.eachSeriesByType("boxplot", function(seriesModel) {
    var baseAxis = seriesModel.getBaseAxis();
    var idx = indexOf(axisList, baseAxis);
    if (idx < 0) {
      idx = axisList.length;
      axisList[idx] = baseAxis;
      result[idx] = {
        axis: baseAxis,
        seriesModels: []
      };
    }
    result[idx].seriesModels.push(seriesModel);
  });
  return result;
}
function calculateBase(groupItem) {
  var baseAxis = groupItem.axis;
  var seriesModels = groupItem.seriesModels;
  var seriesCount = seriesModels.length;
  var boxWidthList = groupItem.boxWidthList = [];
  var boxOffsetList = groupItem.boxOffsetList = [];
  var boundList = [];
  var bandWidth;
  if (baseAxis.type === "category") {
    bandWidth = baseAxis.getBandWidth();
  } else {
    var maxDataCount_1 = 0;
    each$a(seriesModels, function(seriesModel) {
      maxDataCount_1 = Math.max(maxDataCount_1, seriesModel.getData().count());
    });
    var extent3 = baseAxis.getExtent();
    bandWidth = Math.abs(extent3[1] - extent3[0]) / maxDataCount_1;
  }
  each$a(seriesModels, function(seriesModel) {
    var boxWidthBound = seriesModel.get("boxWidth");
    if (!isArray$2(boxWidthBound)) {
      boxWidthBound = [boxWidthBound, boxWidthBound];
    }
    boundList.push([parsePercent(boxWidthBound[0], bandWidth) || 0, parsePercent(boxWidthBound[1], bandWidth) || 0]);
  });
  var availableWidth = bandWidth * 0.8 - 2;
  var boxGap = availableWidth / seriesCount * 0.3;
  var boxWidth = (availableWidth - boxGap * (seriesCount - 1)) / seriesCount;
  var base2 = boxWidth / 2 - availableWidth / 2;
  each$a(seriesModels, function(seriesModel, idx) {
    boxOffsetList.push(base2);
    base2 += boxGap + boxWidth;
    boxWidthList.push(Math.min(Math.max(boxWidth, boundList[idx][0]), boundList[idx][1]));
  });
}
function layoutSingleSeries(seriesModel, offset3, boxWidth) {
  var coordSys = seriesModel.coordinateSystem;
  var data2 = seriesModel.getData();
  var halfWidth = boxWidth / 2;
  var cDimIdx = seriesModel.get("layout") === "horizontal" ? 0 : 1;
  var vDimIdx = 1 - cDimIdx;
  var coordDims = ["x", "y"];
  var cDim = data2.mapDimension(coordDims[cDimIdx]);
  var vDims = data2.mapDimensionsAll(coordDims[vDimIdx]);
  if (cDim == null || vDims.length < 5) {
    return;
  }
  for (var dataIndex = 0; dataIndex < data2.count(); dataIndex++) {
    var axisDimVal = data2.get(cDim, dataIndex);
    var median = getPoint2(axisDimVal, vDims[2], dataIndex);
    var end1 = getPoint2(axisDimVal, vDims[0], dataIndex);
    var end2 = getPoint2(axisDimVal, vDims[1], dataIndex);
    var end4 = getPoint2(axisDimVal, vDims[3], dataIndex);
    var end5 = getPoint2(axisDimVal, vDims[4], dataIndex);
    var ends = [];
    addBodyEnd(ends, end2, false);
    addBodyEnd(ends, end4, true);
    ends.push(end1, end2, end5, end4);
    layEndLine(ends, end1);
    layEndLine(ends, end5);
    layEndLine(ends, median);
    data2.setItemLayout(dataIndex, {
      initBaseline: median[vDimIdx],
      ends
    });
  }
  function getPoint2(axisDimVal2, dim, dataIndex2) {
    var val = data2.get(dim, dataIndex2);
    var p2 = [];
    p2[cDimIdx] = axisDimVal2;
    p2[vDimIdx] = val;
    var point;
    if (isNaN(axisDimVal2) || isNaN(val)) {
      point = [NaN, NaN];
    } else {
      point = coordSys.dataToPoint(p2);
      point[cDimIdx] += offset3;
    }
    return point;
  }
  function addBodyEnd(ends2, point, start2) {
    var point1 = point.slice();
    var point2 = point.slice();
    point1[cDimIdx] += halfWidth;
    point2[cDimIdx] -= halfWidth;
    start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
  }
  function layEndLine(ends2, endCenter) {
    var from2 = endCenter.slice();
    var to = endCenter.slice();
    from2[cDimIdx] -= halfWidth;
    to[cDimIdx] += halfWidth;
    ends2.push(from2, to);
  }
}
function prepareBoxplotData(rawData, opt) {
  opt = opt || {};
  var boxData = [];
  var outliers = [];
  var boundIQR = opt.boundIQR;
  var useExtreme = boundIQR === "none" || boundIQR === 0;
  for (var i = 0; i < rawData.length; i++) {
    var ascList = asc$2(rawData[i].slice());
    var Q1 = quantile(ascList, 0.25);
    var Q2 = quantile(ascList, 0.5);
    var Q3 = quantile(ascList, 0.75);
    var min3 = ascList[0];
    var max3 = ascList[ascList.length - 1];
    var bound = (boundIQR == null ? 1.5 : boundIQR) * (Q3 - Q1);
    var low = useExtreme ? min3 : Math.max(min3, Q1 - bound);
    var high = useExtreme ? max3 : Math.min(max3, Q3 + bound);
    var itemNameFormatter = opt.itemNameFormatter;
    var itemName = isFunction$1(itemNameFormatter) ? itemNameFormatter({
      value: i
    }) : isString$1(itemNameFormatter) ? itemNameFormatter.replace("{value}", i + "") : i + "";
    boxData.push([itemName, low, Q1, Q2, Q3, high]);
    for (var j = 0; j < ascList.length; j++) {
      var dataItem = ascList[j];
      if (dataItem < low || dataItem > high) {
        var outlier = [itemName, dataItem];
        outliers.push(outlier);
      }
    }
  }
  return {
    boxData,
    outliers
  };
}
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      throwError$2(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
function install$z(registers) {
  registers.registerSeriesModel(BoxplotSeriesModel$1);
  registers.registerChartView(BoxplotView$1);
  registers.registerVisual(boxplotVisual);
  registers.registerLayout(boxplotLayout);
  registers.registerTransform(boxplotTransform);
}
var SKIP_PROPS = ["color", "borderColor"];
var CandlestickView = function(_super) {
  __extends(CandlestickView2, _super);
  function CandlestickView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickView2.type;
    return _this;
  }
  CandlestickView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeClipPath();
    this._progressiveEls = null;
    this._updateDrawMode(seriesModel);
    this._isLargeDraw ? this._renderLarge(seriesModel) : this._renderNormal(seriesModel);
  };
  CandlestickView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._clear();
    this._updateDrawMode(seriesModel);
  };
  CandlestickView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    this._progressiveEls = [];
    this._isLargeDraw ? this._incrementalRenderLarge(params, seriesModel) : this._incrementalRenderNormal(params, seriesModel);
  };
  CandlestickView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  CandlestickView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  CandlestickView2.prototype._renderNormal = function(seriesModel) {
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var isSimpleBox = data2.getLayout("isSimpleBox");
    var needsClip = seriesModel.get("clip", true);
    var coord = seriesModel.coordinateSystem;
    var clipArea = coord.getArea && coord.getArea();
    if (!this._data) {
      group.removeAll();
    }
    data2.diff(oldData).add(function(newIdx) {
      if (data2.hasValue(newIdx)) {
        var itemLayout = data2.getItemLayout(newIdx);
        if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
          return;
        }
        var el = createNormalBox(itemLayout, newIdx, true);
        initProps(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        setBoxCommon(el, data2, newIdx, isSimpleBox);
        group.add(el);
        data2.setItemGraphicEl(newIdx, el);
      }
    }).update(function(newIdx, oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      if (!data2.hasValue(newIdx)) {
        group.remove(el);
        return;
      }
      var itemLayout = data2.getItemLayout(newIdx);
      if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
        group.remove(el);
        return;
      }
      if (!el) {
        el = createNormalBox(itemLayout);
      } else {
        updateProps$1(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        saveOldStyle(el);
      }
      setBoxCommon(el, data2, newIdx, isSimpleBox);
      group.add(el);
      data2.setItemGraphicEl(newIdx, el);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data2;
  };
  CandlestickView2.prototype._renderLarge = function(seriesModel) {
    this._clear();
    createLarge(seriesModel, this.group);
    var clipPath = seriesModel.get("clip", true) ? createClipPath(seriesModel.coordinateSystem, false, seriesModel) : null;
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
  };
  CandlestickView2.prototype._incrementalRenderNormal = function(params, seriesModel) {
    var data2 = seriesModel.getData();
    var isSimpleBox = data2.getLayout("isSimpleBox");
    var dataIndex;
    while ((dataIndex = params.next()) != null) {
      var itemLayout = data2.getItemLayout(dataIndex);
      var el = createNormalBox(itemLayout);
      setBoxCommon(el, data2, dataIndex, isSimpleBox);
      el.incremental = true;
      this.group.add(el);
      this._progressiveEls.push(el);
    }
  };
  CandlestickView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    createLarge(seriesModel, this.group, this._progressiveEls, true);
  };
  CandlestickView2.prototype.remove = function(ecModel) {
    this._clear();
  };
  CandlestickView2.prototype._clear = function() {
    this.group.removeAll();
    this._data = null;
  };
  CandlestickView2.type = "candlestick";
  return CandlestickView2;
}(ChartView$1);
var NormalBoxPathShape = function() {
  function NormalBoxPathShape2() {
  }
  return NormalBoxPathShape2;
}();
var NormalBoxPath = function(_super) {
  __extends(NormalBoxPath2, _super);
  function NormalBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "normalCandlestickBox";
    return _this;
  }
  NormalBoxPath2.prototype.getDefaultShape = function() {
    return new NormalBoxPathShape();
  };
  NormalBoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    if (this.__simpleBox) {
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[6][0], ends[6][1]);
    } else {
      ctx.moveTo(ends[0][0], ends[0][1]);
      ctx.lineTo(ends[1][0], ends[1][1]);
      ctx.lineTo(ends[2][0], ends[2][1]);
      ctx.lineTo(ends[3][0], ends[3][1]);
      ctx.closePath();
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[5][0], ends[5][1]);
      ctx.moveTo(ends[6][0], ends[6][1]);
      ctx.lineTo(ends[7][0], ends[7][1]);
    }
  };
  return NormalBoxPath2;
}(Path$1);
function createNormalBox(itemLayout, dataIndex, isInit) {
  var ends = itemLayout.ends;
  return new NormalBoxPath({
    shape: {
      points: isInit ? transInit(ends, itemLayout) : ends
    },
    z2: 100
  });
}
function isNormalBoxClipped(clipArea, itemLayout) {
  var clipped = true;
  for (var i = 0; i < itemLayout.ends.length; i++) {
    if (clipArea.contain(itemLayout.ends[i][0], itemLayout.ends[i][1])) {
      clipped = false;
      break;
    }
  }
  return clipped;
}
function setBoxCommon(el, data2, dataIndex, isSimpleBox) {
  var itemModel = data2.getItemModel(dataIndex);
  el.useStyle(data2.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.__simpleBox = isSimpleBox;
  setStatesStylesFromModel(el, itemModel);
}
function transInit(points2, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[1] = itemLayout.initBaseline;
    return point;
  });
}
var LargeBoxPathShape = function() {
  function LargeBoxPathShape2() {
  }
  return LargeBoxPathShape2;
}();
var LargeBoxPath = function(_super) {
  __extends(LargeBoxPath2, _super);
  function LargeBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeCandlestickBox";
    return _this;
  }
  LargeBoxPath2.prototype.getDefaultShape = function() {
    return new LargeBoxPathShape();
  };
  LargeBoxPath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    for (var i = 0; i < points2.length; ) {
      if (this.__sign === points2[i++]) {
        var x2 = points2[i++];
        ctx.moveTo(x2, points2[i++]);
        ctx.lineTo(x2, points2[i++]);
      } else {
        i += 3;
      }
    }
  };
  return LargeBoxPath2;
}(Path$1);
function createLarge(seriesModel, group, progressiveEls, incremental) {
  var data2 = seriesModel.getData();
  var largePoints = data2.getLayout("largePoints");
  var elP = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: 1
  });
  group.add(elP);
  var elN = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: -1
  });
  group.add(elN);
  setLargeStyle(1, elP, seriesModel);
  setLargeStyle(-1, elN, seriesModel);
  if (incremental) {
    elP.incremental = true;
    elN.incremental = true;
  }
  if (progressiveEls) {
    progressiveEls.push(elP, elN);
  }
}
function setLargeStyle(sign, el, seriesModel, data2) {
  var borderColor = seriesModel.get(["itemStyle", sign > 0 ? "borderColor" : "borderColor0"]) || seriesModel.get(["itemStyle", sign > 0 ? "color" : "color0"]);
  var itemStyle = seriesModel.getModel("itemStyle").getItemStyle(SKIP_PROPS);
  el.useStyle(itemStyle);
  el.style.fill = null;
  el.style.stroke = borderColor;
}
var CandlestickView$1 = CandlestickView;
var CandlestickSeriesModel = function(_super) {
  __extends(CandlestickSeriesModel2, _super);
  function CandlestickSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "open",
      defaultTooltip: true
    }, {
      name: "close",
      defaultTooltip: true
    }, {
      name: "lowest",
      defaultTooltip: true
    }, {
      name: "highest",
      defaultTooltip: true
    }];
    return _this;
  }
  CandlestickSeriesModel2.prototype.getShadowDim = function() {
    return "open";
  };
  CandlestickSeriesModel2.prototype.brushSelector = function(dataIndex, data2, selectors) {
    var itemLayout = data2.getItemLayout(dataIndex);
    return itemLayout && selectors.rect(itemLayout.brushRect);
  };
  CandlestickSeriesModel2.type = "series.candlestick";
  CandlestickSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  CandlestickSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    clip: true,
    itemStyle: {
      color: "#eb5454",
      color0: "#47b262",
      borderColor: "#eb5454",
      borderColor0: "#47b262",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2
      }
    },
    barMaxWidth: null,
    barMinWidth: null,
    barWidth: null,
    large: true,
    largeThreshold: 600,
    progressive: 3e3,
    progressiveThreshold: 1e4,
    progressiveChunkMode: "mod",
    animationEasing: "linear",
    animationDuration: 300
  };
  return CandlestickSeriesModel2;
}(SeriesModel$1);
mixin(CandlestickSeriesModel, WhiskerBoxCommonMixin, true);
var CandlestickSeriesModel$1 = CandlestickSeriesModel;
function candlestickPreprocessor(option) {
  if (!option || !isArray$2(option.series)) {
    return;
  }
  each$g(option.series, function(seriesItem) {
    if (isObject$6(seriesItem) && seriesItem.type === "k") {
      seriesItem.type = "candlestick";
    }
  });
}
var positiveBorderColorQuery = ["itemStyle", "borderColor"];
var negativeBorderColorQuery = ["itemStyle", "borderColor0"];
var positiveColorQuery = ["itemStyle", "color"];
var negativeColorQuery = ["itemStyle", "color0"];
var candlestickVisual = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    function getColor(sign, model) {
      return model.get(sign > 0 ? positiveColorQuery : negativeColorQuery);
    }
    function getBorderColor(sign, model) {
      return model.get(sign > 0 ? positiveBorderColorQuery : negativeBorderColorQuery);
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var isLargeRender = seriesModel.pipelineContext.large;
    return !isLargeRender && {
      progress: function(params, data2) {
        var dataIndex;
        while ((dataIndex = params.next()) != null) {
          var itemModel = data2.getItemModel(dataIndex);
          var sign = data2.getItemLayout(dataIndex).sign;
          var style2 = itemModel.getItemStyle();
          style2.fill = getColor(sign, itemModel);
          style2.stroke = getBorderColor(sign, itemModel) || style2.fill;
          var existsStyle = data2.ensureUniqueItemVisual(dataIndex, "style");
          extend(existsStyle, style2);
        }
      }
    };
  }
};
var candlestickVisual$1 = candlestickVisual;
var candlestickLayout = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var data2 = seriesModel.getData();
    var candleWidth = calculateCandleWidth(seriesModel, data2);
    var cDimIdx = 0;
    var vDimIdx = 1;
    var coordDims = ["x", "y"];
    var cDimI = data2.getDimensionIndex(data2.mapDimension(coordDims[cDimIdx]));
    var vDimsI = map$1(data2.mapDimensionsAll(coordDims[vDimIdx]), data2.getDimensionIndex, data2);
    var openDimI = vDimsI[0];
    var closeDimI = vDimsI[1];
    var lowestDimI = vDimsI[2];
    var highestDimI = vDimsI[3];
    data2.setLayout({
      candleWidth,
      isSimpleBox: candleWidth <= 1.3
    });
    if (cDimI < 0 || vDimsI.length < 4) {
      return;
    }
    return {
      progress: seriesModel.pipelineContext.large ? largeProgress : normalProgress
    };
    function normalProgress(params, data3) {
      var dataIndex;
      var store = data3.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        var ocLow = Math.min(openVal, closeVal);
        var ocHigh = Math.max(openVal, closeVal);
        var ocLowPoint = getPoint2(ocLow, axisDimVal);
        var ocHighPoint = getPoint2(ocHigh, axisDimVal);
        var lowestPoint = getPoint2(lowestVal, axisDimVal);
        var highestPoint = getPoint2(highestVal, axisDimVal);
        var ends = [];
        addBodyEnd(ends, ocHighPoint, 0);
        addBodyEnd(ends, ocLowPoint, 1);
        ends.push(subPixelOptimizePoint(highestPoint), subPixelOptimizePoint(ocHighPoint), subPixelOptimizePoint(lowestPoint), subPixelOptimizePoint(ocLowPoint));
        data3.setItemLayout(dataIndex, {
          sign: getSign(store, dataIndex, openVal, closeVal, closeDimI),
          initBaseline: openVal > closeVal ? ocHighPoint[vDimIdx] : ocLowPoint[vDimIdx],
          ends,
          brushRect: makeBrushRect(lowestVal, highestVal, axisDimVal)
        });
      }
      function getPoint2(val, axisDimVal2) {
        var p2 = [];
        p2[cDimIdx] = axisDimVal2;
        p2[vDimIdx] = val;
        return isNaN(axisDimVal2) || isNaN(val) ? [NaN, NaN] : coordSys.dataToPoint(p2);
      }
      function addBodyEnd(ends2, point, start2) {
        var point1 = point.slice();
        var point2 = point.slice();
        point1[cDimIdx] = subPixelOptimize(point1[cDimIdx] + candleWidth / 2, 1, false);
        point2[cDimIdx] = subPixelOptimize(point2[cDimIdx] - candleWidth / 2, 1, true);
        start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
      }
      function makeBrushRect(lowestVal2, highestVal2, axisDimVal2) {
        var pmin = getPoint2(lowestVal2, axisDimVal2);
        var pmax = getPoint2(highestVal2, axisDimVal2);
        pmin[cDimIdx] -= candleWidth / 2;
        pmax[cDimIdx] -= candleWidth / 2;
        return {
          x: pmin[0],
          y: pmin[1],
          width: candleWidth,
          height: pmax[1] - pmin[1]
        };
      }
      function subPixelOptimizePoint(point) {
        point[cDimIdx] = subPixelOptimize(point[cDimIdx], 1);
        return point;
      }
    }
    function largeProgress(params, data3) {
      var points2 = createFloat32Array(params.count * 4);
      var offset3 = 0;
      var point;
      var tmpIn = [];
      var tmpOut = [];
      var dataIndex;
      var store = data3.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        if (isNaN(axisDimVal) || isNaN(lowestVal) || isNaN(highestVal)) {
          points2[offset3++] = NaN;
          offset3 += 3;
          continue;
        }
        points2[offset3++] = getSign(store, dataIndex, openVal, closeVal, closeDimI);
        tmpIn[cDimIdx] = axisDimVal;
        tmpIn[vDimIdx] = lowestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset3++] = point ? point[0] : NaN;
        points2[offset3++] = point ? point[1] : NaN;
        tmpIn[vDimIdx] = highestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset3++] = point ? point[1] : NaN;
      }
      data3.setLayout("largePoints", points2);
    }
  }
};
function getSign(store, dataIndex, openVal, closeVal, closeDimI) {
  var sign;
  if (openVal > closeVal) {
    sign = -1;
  } else if (openVal < closeVal) {
    sign = 1;
  } else {
    sign = dataIndex > 0 ? store.get(closeDimI, dataIndex - 1) <= closeVal ? 1 : -1 : 1;
  }
  return sign;
}
function calculateCandleWidth(seriesModel, data2) {
  var baseAxis = seriesModel.getBaseAxis();
  var extent3;
  var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : (extent3 = baseAxis.getExtent(), Math.abs(extent3[1] - extent3[0]) / data2.count());
  var barMaxWidth = parsePercent(retrieve2(seriesModel.get("barMaxWidth"), bandWidth), bandWidth);
  var barMinWidth = parsePercent(retrieve2(seriesModel.get("barMinWidth"), 1), bandWidth);
  var barWidth = seriesModel.get("barWidth");
  return barWidth != null ? parsePercent(barWidth, bandWidth) : Math.max(Math.min(bandWidth / 2, barMaxWidth), barMinWidth);
}
var candlestickLayout$1 = candlestickLayout;
function install$y(registers) {
  registers.registerChartView(CandlestickView$1);
  registers.registerSeriesModel(CandlestickSeriesModel$1);
  registers.registerPreprocessor(candlestickPreprocessor);
  registers.registerVisual(candlestickVisual$1);
  registers.registerLayout(candlestickLayout$1);
}
function updateRipplePath(rippleGroup, effectCfg) {
  var color = effectCfg.rippleEffectColor || effectCfg.color;
  rippleGroup.eachChild(function(ripplePath) {
    ripplePath.attr({
      z: effectCfg.z,
      zlevel: effectCfg.zlevel,
      style: {
        stroke: effectCfg.brushType === "stroke" ? color : null,
        fill: effectCfg.brushType === "fill" ? color : null
      }
    });
  });
}
var EffectSymbol = function(_super) {
  __extends(EffectSymbol2, _super);
  function EffectSymbol2(data2, idx) {
    var _this = _super.call(this) || this;
    var symbol = new SymbolClz(data2, idx);
    var rippleGroup = new Group$6();
    _this.add(symbol);
    _this.add(rippleGroup);
    _this.updateData(data2, idx);
    return _this;
  }
  EffectSymbol2.prototype.stopEffectAnimation = function() {
    this.childAt(1).removeAll();
  };
  EffectSymbol2.prototype.startEffectAnimation = function(effectCfg) {
    var symbolType = effectCfg.symbolType;
    var color = effectCfg.color;
    var rippleNumber = effectCfg.rippleNumber;
    var rippleGroup = this.childAt(1);
    for (var i = 0; i < rippleNumber; i++) {
      var ripplePath = createSymbol$1(symbolType, -1, -1, 2, 2, color);
      ripplePath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 99,
        silent: true,
        scaleX: 0.5,
        scaleY: 0.5
      });
      var delay = -i / rippleNumber * effectCfg.period + effectCfg.effectOffset;
      ripplePath.animate("", true).when(effectCfg.period, {
        scaleX: effectCfg.rippleScale / 2,
        scaleY: effectCfg.rippleScale / 2
      }).delay(delay).start();
      ripplePath.animateStyle(true).when(effectCfg.period, {
        opacity: 0
      }).delay(delay).start();
      rippleGroup.add(ripplePath);
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.updateEffectAnimation = function(effectCfg) {
    var oldEffectCfg = this._effectCfg;
    var rippleGroup = this.childAt(1);
    var DIFFICULT_PROPS = ["symbolType", "period", "rippleScale", "rippleNumber"];
    for (var i = 0; i < DIFFICULT_PROPS.length; i++) {
      var propName = DIFFICULT_PROPS[i];
      if (oldEffectCfg[propName] !== effectCfg[propName]) {
        this.stopEffectAnimation();
        this.startEffectAnimation(effectCfg);
        return;
      }
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  EffectSymbol2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  EffectSymbol2.prototype.getSymbolType = function() {
    var symbol = this.childAt(0);
    return symbol && symbol.getSymbolType();
  };
  EffectSymbol2.prototype.updateData = function(data2, idx) {
    var _this = this;
    var seriesModel = data2.hostModel;
    this.childAt(0).updateData(data2, idx);
    var rippleGroup = this.childAt(1);
    var itemModel = data2.getItemModel(idx);
    var symbolType = data2.getItemVisual(idx, "symbol");
    var symbolSize = normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
    var symbolStyle = data2.getItemVisual(idx, "style");
    var color = symbolStyle && symbolStyle.fill;
    var emphasisModel = itemModel.getModel("emphasis");
    rippleGroup.setScale(symbolSize);
    rippleGroup.traverse(function(ripplePath) {
      ripplePath.setStyle("fill", color);
    });
    var symbolOffset = normalizeSymbolOffset(data2.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      rippleGroup.x = symbolOffset[0];
      rippleGroup.y = symbolOffset[1];
    }
    var symbolRotate = data2.getItemVisual(idx, "symbolRotate");
    rippleGroup.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
    var effectCfg = {};
    effectCfg.showEffectOn = seriesModel.get("showEffectOn");
    effectCfg.rippleScale = itemModel.get(["rippleEffect", "scale"]);
    effectCfg.brushType = itemModel.get(["rippleEffect", "brushType"]);
    effectCfg.period = itemModel.get(["rippleEffect", "period"]) * 1e3;
    effectCfg.effectOffset = idx / data2.count();
    effectCfg.z = seriesModel.getShallow("z") || 0;
    effectCfg.zlevel = seriesModel.getShallow("zlevel") || 0;
    effectCfg.symbolType = symbolType;
    effectCfg.color = color;
    effectCfg.rippleEffectColor = itemModel.get(["rippleEffect", "color"]);
    effectCfg.rippleNumber = itemModel.get(["rippleEffect", "number"]);
    if (effectCfg.showEffectOn === "render") {
      this._effectCfg ? this.updateEffectAnimation(effectCfg) : this.startEffectAnimation(effectCfg);
      this._effectCfg = effectCfg;
    } else {
      this._effectCfg = null;
      this.stopEffectAnimation();
      this.onHoverStateChange = function(toState) {
        if (toState === "emphasis") {
          if (effectCfg.showEffectOn !== "render") {
            _this.startEffectAnimation(effectCfg);
          }
        } else if (toState === "normal") {
          if (effectCfg.showEffectOn !== "render") {
            _this.stopEffectAnimation();
          }
        }
      };
    }
    this._effectCfg = effectCfg;
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  EffectSymbol2.prototype.fadeOut = function(cb2) {
    cb2 && cb2();
  };
  return EffectSymbol2;
}(Group$6);
var EffectSymbol$1 = EffectSymbol;
var EffectScatterView = function(_super) {
  __extends(EffectScatterView2, _super);
  function EffectScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterView2.type;
    return _this;
  }
  EffectScatterView2.prototype.init = function() {
    this._symbolDraw = new SymbolDraw$1(EffectSymbol$1);
  };
  EffectScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var effectSymbolDraw = this._symbolDraw;
    effectSymbolDraw.updateData(data2, {
      clipShape: this._getClipShape(seriesModel)
    });
    this.group.add(effectSymbolDraw.group);
  };
  EffectScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  EffectScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    this.group.dirty();
    var res2 = pointsLayout("").reset(seriesModel, ecModel, api);
    if (res2.progress) {
      res2.progress({
        start: 0,
        end: data2.count(),
        count: data2.count()
      }, data2);
    }
    this._symbolDraw.updateLayout();
  };
  EffectScatterView2.prototype._updateGroupTransform = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.getRoamTransform) {
      this.group.transform = clone$2(coordSys.getRoamTransform());
      this.group.decomposeTransform();
    }
  };
  EffectScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
  };
  EffectScatterView2.type = "effectScatter";
  return EffectScatterView2;
}(ChartView$1);
var EffectScatterView$1 = EffectScatterView;
var EffectScatterSeriesModel = function(_super) {
  __extends(EffectScatterSeriesModel2, _super);
  function EffectScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  EffectScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  EffectScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data2, selectors) {
    return selectors.point(data2.getItemLayout(dataIndex));
  };
  EffectScatterSeriesModel2.type = "series.effectScatter";
  EffectScatterSeriesModel2.dependencies = ["grid", "polar"];
  EffectScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    effectType: "ripple",
    progressive: 0,
    showEffectOn: "render",
    clip: true,
    rippleEffect: {
      period: 4,
      scale: 2.5,
      brushType: "fill",
      number: 3
    },
    universalTransition: {
      divideShape: "clone"
    },
    symbolSize: 10
  };
  return EffectScatterSeriesModel2;
}(SeriesModel$1);
var EffectScatterSeriesModel$1 = EffectScatterSeriesModel;
function install$x(registers) {
  registers.registerChartView(EffectScatterView$1);
  registers.registerSeriesModel(EffectScatterSeriesModel$1);
  registers.registerLayout(pointsLayout("effectScatter"));
}
var EffectLine = function(_super) {
  __extends(EffectLine2, _super);
  function EffectLine2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this.add(_this.createLine(lineData, idx, seriesScope));
    _this._updateEffectSymbol(lineData, idx);
    return _this;
  }
  EffectLine2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Line$1(lineData, idx, seriesScope);
  };
  EffectLine2.prototype._updateEffectSymbol = function(lineData, idx) {
    var itemModel = lineData.getItemModel(idx);
    var effectModel = itemModel.getModel("effect");
    var size = effectModel.get("symbolSize");
    var symbolType = effectModel.get("symbol");
    if (!isArray$2(size)) {
      size = [size, size];
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var color = effectModel.get("color") || lineStyle && lineStyle.stroke;
    var symbol = this.childAt(1);
    if (this._symbolType !== symbolType) {
      this.remove(symbol);
      symbol = createSymbol$1(symbolType, -0.5, -0.5, 1, 1, color);
      symbol.z2 = 100;
      symbol.culling = true;
      this.add(symbol);
    }
    if (!symbol) {
      return;
    }
    symbol.setStyle("shadowColor", color);
    symbol.setStyle(effectModel.getItemStyle(["color"]));
    symbol.scaleX = size[0];
    symbol.scaleY = size[1];
    symbol.setColor(color);
    this._symbolType = symbolType;
    this._symbolScale = size;
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  EffectLine2.prototype._updateEffectAnimation = function(lineData, effectModel, idx) {
    var symbol = this.childAt(1);
    if (!symbol) {
      return;
    }
    var points2 = lineData.getItemLayout(idx);
    var period = effectModel.get("period") * 1e3;
    var loop = effectModel.get("loop");
    var constantSpeed = effectModel.get("constantSpeed");
    var delayExpr = retrieve(effectModel.get("delay"), function(idx2) {
      return idx2 / lineData.count() * period / 3;
    });
    symbol.ignore = true;
    this._updateAnimationPoints(symbol, points2);
    if (constantSpeed > 0) {
      period = this._getLineLength(symbol) / constantSpeed * 1e3;
    }
    if (period !== this._period || loop !== this._loop) {
      symbol.stopAnimation();
      var delayNum = void 0;
      if (isFunction$1(delayExpr)) {
        delayNum = delayExpr(idx);
      } else {
        delayNum = delayExpr;
      }
      if (symbol.__t > 0) {
        delayNum = -period * symbol.__t;
      }
      this._animateSymbol(symbol, period, delayNum, loop);
    }
    this._period = period;
    this._loop = loop;
  };
  EffectLine2.prototype._animateSymbol = function(symbol, period, delayNum, loop) {
    if (period > 0) {
      symbol.__t = 0;
      var self_1 = this;
      var animator = symbol.animate("", loop).when(period, {
        __t: 1
      }).delay(delayNum).during(function() {
        self_1._updateSymbolPosition(symbol);
      });
      if (!loop) {
        animator.done(function() {
          self_1.remove(symbol);
        });
      }
      animator.start();
    }
  };
  EffectLine2.prototype._getLineLength = function(symbol) {
    return dist$1(symbol.__p1, symbol.__cp1) + dist$1(symbol.__cp1, symbol.__p2);
  };
  EffectLine2.prototype._updateAnimationPoints = function(symbol, points2) {
    symbol.__p1 = points2[0];
    symbol.__p2 = points2[1];
    symbol.__cp1 = points2[2] || [(points2[0][0] + points2[1][0]) / 2, (points2[0][1] + points2[1][1]) / 2];
  };
  EffectLine2.prototype.updateData = function(lineData, idx, seriesScope) {
    this.childAt(0).updateData(lineData, idx, seriesScope);
    this._updateEffectSymbol(lineData, idx);
  };
  EffectLine2.prototype._updateSymbolPosition = function(symbol) {
    var p1 = symbol.__p1;
    var p2 = symbol.__p2;
    var cp1 = symbol.__cp1;
    var t2 = symbol.__t;
    var pos = [symbol.x, symbol.y];
    var lastPos = pos.slice();
    var quadraticAt2 = quadraticAt$1;
    var quadraticDerivativeAt$1 = quadraticDerivativeAt;
    pos[0] = quadraticAt2(p1[0], cp1[0], p2[0], t2);
    pos[1] = quadraticAt2(p1[1], cp1[1], p2[1], t2);
    var tx = quadraticDerivativeAt$1(p1[0], cp1[0], p2[0], t2);
    var ty = quadraticDerivativeAt$1(p1[1], cp1[1], p2[1], t2);
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    if (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") {
      if (symbol.__lastT !== void 0 && symbol.__lastT < symbol.__t) {
        symbol.scaleY = dist$1(lastPos, pos) * 1.05;
        if (t2 === 1) {
          pos[0] = lastPos[0] + (pos[0] - lastPos[0]) / 2;
          pos[1] = lastPos[1] + (pos[1] - lastPos[1]) / 2;
        }
      } else if (symbol.__lastT === 1) {
        symbol.scaleY = 2 * dist$1(p1, pos);
      } else {
        symbol.scaleY = this._symbolScale[1];
      }
    }
    symbol.__lastT = symbol.__t;
    symbol.ignore = false;
    symbol.x = pos[0];
    symbol.y = pos[1];
  };
  EffectLine2.prototype.updateLayout = function(lineData, idx) {
    this.childAt(0).updateLayout(lineData, idx);
    var effectModel = lineData.getItemModel(idx).getModel("effect");
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  return EffectLine2;
}(Group$6);
var EffectLine$1 = EffectLine;
var Polyline = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createPolyline(lineData, idx, seriesScope);
    return _this;
  }
  Polyline2.prototype._createPolyline = function(lineData, idx, seriesScope) {
    var points2 = lineData.getItemLayout(idx);
    var line = new Polyline$3({
      shape: {
        points: points2
      }
    });
    this.add(line);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childAt(0);
    var target = {
      shape: {
        points: lineData.getItemLayout(idx)
      }
    };
    updateProps$1(line, target, seriesModel, idx);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var line = this.childAt(0);
    var itemModel = lineData.getItemModel(idx);
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    if (!seriesScope || lineData.hasItemOption) {
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
    }
    line.useStyle(lineData.getItemVisual(idx, "style"));
    line.style.fill = null;
    line.style.strokeNoScale = true;
    var lineEmphasisState = line.ensureState("emphasis");
    lineEmphasisState.style = emphasisLineStyle;
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Polyline2.prototype.updateLayout = function(lineData, idx) {
    var polyline = this.childAt(0);
    polyline.setShape("points", lineData.getItemLayout(idx));
  };
  return Polyline2;
}(Group$6);
var Polyline$1 = Polyline;
var EffectPolyline = function(_super) {
  __extends(EffectPolyline2, _super);
  function EffectPolyline2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._lastFrame = 0;
    _this._lastFramePercent = 0;
    return _this;
  }
  EffectPolyline2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Polyline$1(lineData, idx, seriesScope);
  };
  EffectPolyline2.prototype._updateAnimationPoints = function(symbol, points2) {
    this._points = points2;
    var accLenArr = [0];
    var len2 = 0;
    for (var i = 1; i < points2.length; i++) {
      var p1 = points2[i - 1];
      var p2 = points2[i];
      len2 += dist$1(p1, p2);
      accLenArr.push(len2);
    }
    if (len2 === 0) {
      this._length = 0;
      return;
    }
    for (var i = 0; i < accLenArr.length; i++) {
      accLenArr[i] /= len2;
    }
    this._offsets = accLenArr;
    this._length = len2;
  };
  EffectPolyline2.prototype._getLineLength = function() {
    return this._length;
  };
  EffectPolyline2.prototype._updateSymbolPosition = function(symbol) {
    var t2 = symbol.__t;
    var points2 = this._points;
    var offsets = this._offsets;
    var len2 = points2.length;
    if (!offsets) {
      return;
    }
    var lastFrame = this._lastFrame;
    var frame;
    if (t2 < this._lastFramePercent) {
      var start2 = Math.min(lastFrame + 1, len2 - 1);
      for (frame = start2; frame >= 0; frame--) {
        if (offsets[frame] <= t2) {
          break;
        }
      }
      frame = Math.min(frame, len2 - 2);
    } else {
      for (frame = lastFrame; frame < len2; frame++) {
        if (offsets[frame] > t2) {
          break;
        }
      }
      frame = Math.min(frame - 1, len2 - 2);
    }
    var p2 = (t2 - offsets[frame]) / (offsets[frame + 1] - offsets[frame]);
    var p0 = points2[frame];
    var p1 = points2[frame + 1];
    symbol.x = p0[0] * (1 - p2) + p2 * p1[0];
    symbol.y = p0[1] * (1 - p2) + p2 * p1[1];
    var tx = p1[0] - p0[0];
    var ty = p1[1] - p0[1];
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    this._lastFrame = frame;
    this._lastFramePercent = t2;
    symbol.ignore = false;
  };
  return EffectPolyline2;
}(EffectLine$1);
var EffectPolyline$1 = EffectPolyline;
var LargeLinesPathShape = function() {
  function LargeLinesPathShape2() {
    this.polyline = false;
    this.curveness = 0;
    this.segs = [];
  }
  return LargeLinesPathShape2;
}();
var LargeLinesPath = function(_super) {
  __extends(LargeLinesPath2, _super);
  function LargeLinesPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeLinesPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeLinesPath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  LargeLinesPath2.prototype.getDefaultShape = function() {
    return new LargeLinesPathShape();
  };
  LargeLinesPath2.prototype.buildPath = function(ctx, shape) {
    var segs = shape.segs;
    var curveness = shape.curveness;
    var i;
    if (shape.polyline) {
      for (i = this._off; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          ctx.moveTo(segs[i++], segs[i++]);
          for (var k2 = 1; k2 < count2; k2++) {
            ctx.lineTo(segs[i++], segs[i++]);
          }
        }
      }
    } else {
      for (i = this._off; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        ctx.moveTo(x0, y0);
        if (curveness > 0) {
          var x2 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y2 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          ctx.quadraticCurveTo(x2, y2, x1, y1);
        } else {
          ctx.lineTo(x1, y1);
        }
      }
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeLinesPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var segs = shape.segs;
    var curveness = shape.curveness;
    var lineWidth = this.style.lineWidth;
    if (shape.polyline) {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          var x0 = segs[i++];
          var y0 = segs[i++];
          for (var k2 = 1; k2 < count2; k2++) {
            var x1 = segs[i++];
            var y1 = segs[i++];
            if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
              return dataIndex;
            }
          }
        }
        dataIndex++;
      }
    } else {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        if (curveness > 0) {
          var x22 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y22 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          if (containStroke$2(x0, y0, x22, y22, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        } else {
          if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        }
        dataIndex++;
      }
    }
    return -1;
  };
  LargeLinesPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeLinesPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.segs;
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX, minY, maxX, maxY);
    }
    return rect;
  };
  return LargeLinesPath2;
}(Path$1);
var LargeLineDraw = function() {
  function LargeLineDraw2() {
    this.group = new Group$6();
  }
  LargeLineDraw2.prototype.updateData = function(data2) {
    this._clear();
    var lineEl = this._create();
    lineEl.setShape({
      segs: data2.getLayout("linesPoints")
    });
    this._setCommon(lineEl, data2);
  };
  LargeLineDraw2.prototype.incrementalPrepareUpdate = function(data2) {
    this.group.removeAll();
    this._clear();
  };
  LargeLineDraw2.prototype.incrementalUpdate = function(taskParams, data2) {
    var lastAdded = this._newAdded[0];
    var linePoints = data2.getLayout("linesPoints");
    var oldSegs = lastAdded && lastAdded.shape.segs;
    if (oldSegs && oldSegs.length < 2e4) {
      var oldLen = oldSegs.length;
      var newSegs = new Float32Array(oldLen + linePoints.length);
      newSegs.set(oldSegs);
      newSegs.set(linePoints, oldLen);
      lastAdded.setShape({
        segs: newSegs
      });
    } else {
      this._newAdded = [];
      var lineEl = this._create();
      lineEl.incremental = true;
      lineEl.setShape({
        segs: linePoints
      });
      this._setCommon(lineEl, data2);
      lineEl.__startIndex = taskParams.start;
    }
  };
  LargeLineDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeLineDraw2.prototype.eachRendered = function(cb2) {
    this._newAdded[0] && cb2(this._newAdded[0]);
  };
  LargeLineDraw2.prototype._create = function() {
    var lineEl = new LargeLinesPath({
      cursor: "default"
    });
    this._newAdded.push(lineEl);
    this.group.add(lineEl);
    return lineEl;
  };
  LargeLineDraw2.prototype._setCommon = function(lineEl, data2, isIncremental) {
    var hostModel = data2.hostModel;
    lineEl.setShape({
      polyline: hostModel.get("polyline"),
      curveness: hostModel.get(["lineStyle", "curveness"])
    });
    lineEl.useStyle(hostModel.getModel("lineStyle").getLineStyle());
    lineEl.style.strokeNoScale = true;
    var style2 = data2.getVisual("style");
    if (style2 && style2.stroke) {
      lineEl.setStyle("stroke", style2.stroke);
    }
    lineEl.setStyle("fill", null);
    var ecData = getECData(lineEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    lineEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = lineEl.hoverDataIdx;
      if (dataIndex > 0) {
        ecData.dataIndex = dataIndex + lineEl.__startIndex;
      }
    });
  };
  LargeLineDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeLineDraw2;
}();
var LargeLineDraw$1 = LargeLineDraw;
var linesLayout = {
  seriesType: "lines",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var isPolyline = seriesModel.get("polyline");
    var isLarge = seriesModel.pipelineContext.large;
    return {
      progress: function(params, lineData) {
        var lineCoords = [];
        if (isLarge) {
          var points2 = void 0;
          var segCount = params.end - params.start;
          if (isPolyline) {
            var totalCoordsCount = 0;
            for (var i = params.start; i < params.end; i++) {
              totalCoordsCount += seriesModel.getLineCoordsCount(i);
            }
            points2 = new Float32Array(segCount + totalCoordsCount * 2);
          } else {
            points2 = new Float32Array(segCount * 4);
          }
          var offset3 = 0;
          var pt = [];
          for (var i = params.start; i < params.end; i++) {
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            if (isPolyline) {
              points2[offset3++] = len2;
            }
            for (var k2 = 0; k2 < len2; k2++) {
              pt = coordSys.dataToPoint(lineCoords[k2], false, pt);
              points2[offset3++] = pt[0];
              points2[offset3++] = pt[1];
            }
          }
          lineData.setLayout("linesPoints", points2);
        } else {
          for (var i = params.start; i < params.end; i++) {
            var itemModel = lineData.getItemModel(i);
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            var pts = [];
            if (isPolyline) {
              for (var j = 0; j < len2; j++) {
                pts.push(coordSys.dataToPoint(lineCoords[j]));
              }
            } else {
              pts[0] = coordSys.dataToPoint(lineCoords[0]);
              pts[1] = coordSys.dataToPoint(lineCoords[1]);
              var curveness = itemModel.get(["lineStyle", "curveness"]);
              if (+curveness) {
                pts[2] = [(pts[0][0] + pts[1][0]) / 2 - (pts[0][1] - pts[1][1]) * curveness, (pts[0][1] + pts[1][1]) / 2 - (pts[1][0] - pts[0][0]) * curveness];
              }
            }
            lineData.setItemLayout(i, pts);
          }
        }
      }
    };
  }
};
var linesLayout$1 = linesLayout;
var LinesView = function(_super) {
  __extends(LinesView2, _super);
  function LinesView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesView2.type;
    return _this;
  }
  LinesView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data2, seriesModel);
    var zlevel = seriesModel.get("zlevel");
    var trailLength = seriesModel.get(["effect", "trailLength"]);
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg) {
      zr.painter.getLayer(zlevel).clear(true);
    }
    if (this._lastZlevel != null && !isSvg) {
      zr.configLayer(this._lastZlevel, {
        motionBlur: false
      });
    }
    if (this._showEffect(seriesModel) && trailLength > 0) {
      if (!isSvg) {
        zr.configLayer(zlevel, {
          motionBlur: true,
          lastFrameAlpha: Math.max(Math.min(trailLength / 10 + 0.9, 1), 0)
        });
      }
    }
    lineDraw.updateData(data2);
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
    this._lastZlevel = zlevel;
    this._finished = true;
  };
  LinesView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data2, seriesModel);
    lineDraw.incrementalPrepareUpdate(data2);
    this._clearLayer(api);
    this._finished = false;
  };
  LinesView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._lineDraw.incrementalUpdate(taskParams, seriesModel.getData());
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  LinesView2.prototype.eachRendered = function(cb2) {
    this._lineDraw && this._lineDraw.eachRendered(cb2);
  };
  LinesView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var pipelineContext = seriesModel.pipelineContext;
    if (!this._finished || pipelineContext.large || pipelineContext.progressiveRender) {
      return {
        update: true
      };
    } else {
      var res2 = linesLayout$1.reset(seriesModel, ecModel, api);
      if (res2.progress) {
        res2.progress({
          start: 0,
          end: data2.count(),
          count: data2.count()
        }, data2);
      }
      this._lineDraw.updateLayout();
      this._clearLayer(api);
    }
  };
  LinesView2.prototype._updateLineDraw = function(data2, seriesModel) {
    var lineDraw = this._lineDraw;
    var hasEffect = this._showEffect(seriesModel);
    var isPolyline = !!seriesModel.get("polyline");
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!lineDraw || hasEffect !== this._hasEffet || isPolyline !== this._isPolyline || isLargeDraw !== this._isLargeDraw) {
      if (lineDraw) {
        lineDraw.remove();
      }
      lineDraw = this._lineDraw = isLargeDraw ? new LargeLineDraw$1() : new LineDraw$1(isPolyline ? hasEffect ? EffectPolyline$1 : Polyline$1 : hasEffect ? EffectLine$1 : Line$1);
      this._hasEffet = hasEffect;
      this._isPolyline = isPolyline;
      this._isLargeDraw = isLargeDraw;
    }
    this.group.add(lineDraw.group);
    return lineDraw;
  };
  LinesView2.prototype._showEffect = function(seriesModel) {
    return !!seriesModel.get(["effect", "show"]);
  };
  LinesView2.prototype._clearLayer = function(api) {
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg && this._lastZlevel != null) {
      zr.painter.getLayer(this._lastZlevel).clear(true);
    }
  };
  LinesView2.prototype.remove = function(ecModel, api) {
    this._lineDraw && this._lineDraw.remove();
    this._lineDraw = null;
    this._clearLayer(api);
  };
  LinesView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  LinesView2.type = "lines";
  return LinesView2;
}(ChartView$1);
var LinesView$1 = LinesView;
var Uint32Arr = typeof Uint32Array === "undefined" ? Array : Uint32Array;
var Float64Arr = typeof Float64Array === "undefined" ? Array : Float64Array;
function compatEc2(seriesOpt) {
  var data2 = seriesOpt.data;
  if (data2 && data2[0] && data2[0][0] && data2[0][0].coord) {
    seriesOpt.data = map$1(data2, function(itemOpt) {
      var coords = [itemOpt[0].coord, itemOpt[1].coord];
      var target = {
        coords
      };
      if (itemOpt[0].name) {
        target.fromName = itemOpt[0].name;
      }
      if (itemOpt[1].name) {
        target.toName = itemOpt[1].name;
      }
      return mergeAll([target, itemOpt[0], itemOpt[1]]);
    });
  }
}
var LinesSeriesModel = function(_super) {
  __extends(LinesSeriesModel2, _super);
  function LinesSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  LinesSeriesModel2.prototype.init = function(option) {
    option.data = option.data || [];
    compatEc2(option);
    var result = this._processFlatCoordsArray(option.data);
    this._flatCoords = result.flatCoords;
    this._flatCoordsOffset = result.flatCoordsOffset;
    if (result.flatCoords) {
      option.data = new Float32Array(result.count);
    }
    _super.prototype.init.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.mergeOption = function(option) {
    compatEc2(option);
    if (option.data) {
      var result = this._processFlatCoordsArray(option.data);
      this._flatCoords = result.flatCoords;
      this._flatCoordsOffset = result.flatCoordsOffset;
      if (result.flatCoords) {
        option.data = new Float32Array(result.count);
      }
    }
    _super.prototype.mergeOption.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.appendData = function(params) {
    var result = this._processFlatCoordsArray(params.data);
    if (result.flatCoords) {
      if (!this._flatCoords) {
        this._flatCoords = result.flatCoords;
        this._flatCoordsOffset = result.flatCoordsOffset;
      } else {
        this._flatCoords = concatArray(this._flatCoords, result.flatCoords);
        this._flatCoordsOffset = concatArray(this._flatCoordsOffset, result.flatCoordsOffset);
      }
      params.data = new Float32Array(result.count);
    }
    this.getRawData().appendData(params.data);
  };
  LinesSeriesModel2.prototype._getCoordsFromItemModel = function(idx) {
    var itemModel = this.getData().getItemModel(idx);
    var coords = itemModel.option instanceof Array ? itemModel.option : itemModel.getShallow("coords");
    return coords;
  };
  LinesSeriesModel2.prototype.getLineCoordsCount = function(idx) {
    if (this._flatCoordsOffset) {
      return this._flatCoordsOffset[idx * 2 + 1];
    } else {
      return this._getCoordsFromItemModel(idx).length;
    }
  };
  LinesSeriesModel2.prototype.getLineCoords = function(idx, out2) {
    if (this._flatCoordsOffset) {
      var offset3 = this._flatCoordsOffset[idx * 2];
      var len2 = this._flatCoordsOffset[idx * 2 + 1];
      for (var i = 0; i < len2; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = this._flatCoords[offset3 + i * 2];
        out2[i][1] = this._flatCoords[offset3 + i * 2 + 1];
      }
      return len2;
    } else {
      var coords = this._getCoordsFromItemModel(idx);
      for (var i = 0; i < coords.length; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = coords[i][0];
        out2[i][1] = coords[i][1];
      }
      return coords.length;
    }
  };
  LinesSeriesModel2.prototype._processFlatCoordsArray = function(data2) {
    var startOffset = 0;
    if (this._flatCoords) {
      startOffset = this._flatCoords.length;
    }
    if (isNumber(data2[0])) {
      var len2 = data2.length;
      var coordsOffsetAndLenStorage = new Uint32Arr(len2);
      var coordsStorage = new Float64Arr(len2);
      var coordsCursor = 0;
      var offsetCursor = 0;
      var dataCount = 0;
      for (var i = 0; i < len2; ) {
        dataCount++;
        var count2 = data2[i++];
        coordsOffsetAndLenStorage[offsetCursor++] = coordsCursor + startOffset;
        coordsOffsetAndLenStorage[offsetCursor++] = count2;
        for (var k2 = 0; k2 < count2; k2++) {
          var x2 = data2[i++];
          var y2 = data2[i++];
          coordsStorage[coordsCursor++] = x2;
          coordsStorage[coordsCursor++] = y2;
        }
      }
      return {
        flatCoordsOffset: new Uint32Array(coordsOffsetAndLenStorage.buffer, 0, offsetCursor),
        flatCoords: coordsStorage,
        count: dataCount
      };
    }
    return {
      flatCoordsOffset: null,
      flatCoords: null,
      count: data2.length
    };
  };
  LinesSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var lineData = new SeriesData$1(["value"], this);
    lineData.hasItemOption = false;
    lineData.initData(option.data, [], function(dataItem, dimName, dataIndex, dimIndex) {
      if (dataItem instanceof Array) {
        return NaN;
      } else {
        lineData.hasItemOption = true;
        var value = dataItem.value;
        if (value != null) {
          return value instanceof Array ? value[dimIndex] : value;
        }
      }
    });
    return lineData;
  };
  LinesSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var itemModel = data2.getItemModel(dataIndex);
    var name2 = itemModel.get("name");
    if (name2) {
      return name2;
    }
    var fromName = itemModel.get("fromName");
    var toName = itemModel.get("toName");
    var nameArr = [];
    fromName != null && nameArr.push(fromName);
    toName != null && nameArr.push(toName);
    return createTooltipMarkup("nameValue", {
      name: nameArr.join(" > ")
    });
  };
  LinesSeriesModel2.prototype.preventIncremental = function() {
    return !!this.get(["effect", "show"]);
  };
  LinesSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 1e4 : this.get("progressive");
    }
    return progressive;
  };
  LinesSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 2e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  LinesSeriesModel2.prototype.getZLevelKey = function() {
    var effectModel = this.getModel("effect");
    var trailLength = effectModel.get("trailLength");
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : effectModel.get("show") && trailLength > 0 ? trailLength + "" : "";
  };
  LinesSeriesModel2.type = "series.lines";
  LinesSeriesModel2.dependencies = ["grid", "polar", "geo", "calendar"];
  LinesSeriesModel2.defaultOption = {
    coordinateSystem: "geo",
    z: 2,
    legendHoverLink: true,
    xAxisIndex: 0,
    yAxisIndex: 0,
    symbol: ["none", "none"],
    symbolSize: [10, 10],
    geoIndex: 0,
    effect: {
      show: false,
      period: 4,
      constantSpeed: 0,
      symbol: "circle",
      symbolSize: 3,
      loop: true,
      trailLength: 0.2
    },
    large: false,
    largeThreshold: 2e3,
    polyline: false,
    clip: true,
    label: {
      show: false,
      position: "end"
    },
    lineStyle: {
      opacity: 0.5
    }
  };
  return LinesSeriesModel2;
}(SeriesModel$1);
var LinesSeriesModel$1 = LinesSeriesModel;
function normalize$1(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
var linesVisual = {
  seriesType: "lines",
  reset: function(seriesModel) {
    var symbolType = normalize$1(seriesModel.get("symbol"));
    var symbolSize = normalize$1(seriesModel.get("symbolSize"));
    var data2 = seriesModel.getData();
    data2.setVisual("fromSymbol", symbolType && symbolType[0]);
    data2.setVisual("toSymbol", symbolType && symbolType[1]);
    data2.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    data2.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    function dataEach(data3, idx) {
      var itemModel = data3.getItemModel(idx);
      var symbolType2 = normalize$1(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$1(itemModel.getShallow("symbolSize", true));
      symbolType2[0] && data3.setItemVisual(idx, "fromSymbol", symbolType2[0]);
      symbolType2[1] && data3.setItemVisual(idx, "toSymbol", symbolType2[1]);
      symbolSize2[0] && data3.setItemVisual(idx, "fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && data3.setItemVisual(idx, "toSymbolSize", symbolSize2[1]);
    }
    return {
      dataEach: data2.hasItemOption ? dataEach : null
    };
  }
};
var linesVisual$1 = linesVisual;
function install$w(registers) {
  registers.registerChartView(LinesView$1);
  registers.registerSeriesModel(LinesSeriesModel$1);
  registers.registerLayout(linesLayout$1);
  registers.registerVisual(linesVisual$1);
}
var GRADIENT_LEVELS = 256;
var HeatmapLayer = function() {
  function HeatmapLayer2() {
    this.blurSize = 30;
    this.pointSize = 20;
    this.maxOpacity = 1;
    this.minOpacity = 0;
    this._gradientPixels = {
      inRange: null,
      outOfRange: null
    };
    var canvas = platformApi.createCanvas();
    this.canvas = canvas;
  }
  HeatmapLayer2.prototype.update = function(data2, width, height, normalize2, colorFunc, isInRange) {
    var brush2 = this._getBrush();
    var gradientInRange = this._getGradient(colorFunc, "inRange");
    var gradientOutOfRange = this._getGradient(colorFunc, "outOfRange");
    var r2 = this.pointSize + this.blurSize;
    var canvas = this.canvas;
    var ctx = canvas.getContext("2d");
    var len2 = data2.length;
    canvas.width = width;
    canvas.height = height;
    for (var i = 0; i < len2; ++i) {
      var p2 = data2[i];
      var x2 = p2[0];
      var y2 = p2[1];
      var value = p2[2];
      var alpha = normalize2(value);
      ctx.globalAlpha = alpha;
      ctx.drawImage(brush2, x2 - r2, y2 - r2);
    }
    if (!canvas.width || !canvas.height) {
      return canvas;
    }
    var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    var pixels = imageData.data;
    var offset3 = 0;
    var pixelLen = pixels.length;
    var minOpacity = this.minOpacity;
    var maxOpacity = this.maxOpacity;
    var diffOpacity = maxOpacity - minOpacity;
    while (offset3 < pixelLen) {
      var alpha = pixels[offset3 + 3] / 256;
      var gradientOffset = Math.floor(alpha * (GRADIENT_LEVELS - 1)) * 4;
      if (alpha > 0) {
        var gradient = isInRange(alpha) ? gradientInRange : gradientOutOfRange;
        alpha > 0 && (alpha = alpha * diffOpacity + minOpacity);
        pixels[offset3++] = gradient[gradientOffset];
        pixels[offset3++] = gradient[gradientOffset + 1];
        pixels[offset3++] = gradient[gradientOffset + 2];
        pixels[offset3++] = gradient[gradientOffset + 3] * alpha * 256;
      } else {
        offset3 += 4;
      }
    }
    ctx.putImageData(imageData, 0, 0);
    return canvas;
  };
  HeatmapLayer2.prototype._getBrush = function() {
    var brushCanvas = this._brushCanvas || (this._brushCanvas = platformApi.createCanvas());
    var r2 = this.pointSize + this.blurSize;
    var d2 = r2 * 2;
    brushCanvas.width = d2;
    brushCanvas.height = d2;
    var ctx = brushCanvas.getContext("2d");
    ctx.clearRect(0, 0, d2, d2);
    ctx.shadowOffsetX = d2;
    ctx.shadowBlur = this.blurSize;
    ctx.shadowColor = "#000";
    ctx.beginPath();
    ctx.arc(-r2, r2, this.pointSize, 0, Math.PI * 2, true);
    ctx.closePath();
    ctx.fill();
    return brushCanvas;
  };
  HeatmapLayer2.prototype._getGradient = function(colorFunc, state) {
    var gradientPixels = this._gradientPixels;
    var pixelsSingleState = gradientPixels[state] || (gradientPixels[state] = new Uint8ClampedArray(256 * 4));
    var color = [0, 0, 0, 0];
    var off = 0;
    for (var i = 0; i < 256; i++) {
      colorFunc[state](i / 255, true, color);
      pixelsSingleState[off++] = color[0];
      pixelsSingleState[off++] = color[1];
      pixelsSingleState[off++] = color[2];
      pixelsSingleState[off++] = color[3];
    }
    return pixelsSingleState;
  };
  return HeatmapLayer2;
}();
var HeatmapLayer$1 = HeatmapLayer;
function getIsInPiecewiseRange(dataExtent, pieceList, selected) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  pieceList = map$1(pieceList, function(piece) {
    return {
      interval: [(piece.interval[0] - dataExtent[0]) / dataSpan, (piece.interval[1] - dataExtent[0]) / dataSpan]
    };
  });
  var len2 = pieceList.length;
  var lastIndex = 0;
  return function(val) {
    var i;
    for (i = lastIndex; i < len2; i++) {
      var interval = pieceList[i].interval;
      if (interval[0] <= val && val <= interval[1]) {
        lastIndex = i;
        break;
      }
    }
    if (i === len2) {
      for (i = lastIndex - 1; i >= 0; i--) {
        var interval = pieceList[i].interval;
        if (interval[0] <= val && val <= interval[1]) {
          lastIndex = i;
          break;
        }
      }
    }
    return i >= 0 && i < len2 && selected[i];
  };
}
function getIsInContinuousRange(dataExtent, range3) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  range3 = [(range3[0] - dataExtent[0]) / dataSpan, (range3[1] - dataExtent[0]) / dataSpan];
  return function(val) {
    return val >= range3[0] && val <= range3[1];
  };
}
function isGeoCoordSys(coordSys) {
  var dimensions = coordSys.dimensions;
  return dimensions[0] === "lng" && dimensions[1] === "lat";
}
var HeatmapView = function(_super) {
  __extends(HeatmapView2, _super);
  function HeatmapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapView2.type;
    return _this;
  }
  HeatmapView2.prototype.render = function(seriesModel, ecModel, api) {
    var visualMapOfThisSeries;
    ecModel.eachComponent("visualMap", function(visualMap) {
      visualMap.eachTargetSeries(function(targetSeries) {
        if (targetSeries === seriesModel) {
          visualMapOfThisSeries = visualMap;
        }
      });
    });
    this._progressiveEls = null;
    this.group.removeAll();
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type === "cartesian2d" || coordSys.type === "calendar") {
      this._renderOnCartesianAndCalendar(seriesModel, api, 0, seriesModel.getData().count());
    } else if (isGeoCoordSys(coordSys)) {
      this._renderOnGeo(coordSys, seriesModel, visualMapOfThisSeries, api);
    }
  };
  HeatmapView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this.group.removeAll();
  };
  HeatmapView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys) {
      if (isGeoCoordSys(coordSys)) {
        this.render(seriesModel, ecModel, api);
      } else {
        this._progressiveEls = [];
        this._renderOnCartesianAndCalendar(seriesModel, api, params.start, params.end, true);
      }
    }
  };
  HeatmapView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  HeatmapView2.prototype._renderOnCartesianAndCalendar = function(seriesModel, api, start2, end2, incremental) {
    var coordSys = seriesModel.coordinateSystem;
    var width;
    var height;
    var xAxisExtent;
    var yAxisExtent;
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      width = xAxis.getBandWidth();
      height = yAxis.getBandWidth();
      xAxisExtent = xAxis.scale.getExtent();
      yAxisExtent = yAxis.scale.getExtent();
    }
    var group = this.group;
    var data2 = seriesModel.getData();
    var emphasisStyle = seriesModel.getModel(["emphasis", "itemStyle"]).getItemStyle();
    var blurStyle = seriesModel.getModel(["blur", "itemStyle"]).getItemStyle();
    var selectStyle = seriesModel.getModel(["select", "itemStyle"]).getItemStyle();
    var borderRadius = seriesModel.get(["itemStyle", "borderRadius"]);
    var labelStatesModels = getLabelStatesModels(seriesModel);
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    var dataDims = isCoordinateSystemType(coordSys, "cartesian2d") ? [data2.mapDimension("x"), data2.mapDimension("y"), data2.mapDimension("value")] : [data2.mapDimension("time"), data2.mapDimension("value")];
    for (var idx = start2; idx < end2; idx++) {
      var rect = void 0;
      var style2 = data2.getItemVisual(idx, "style");
      if (isCoordinateSystemType(coordSys, "cartesian2d")) {
        var dataDimX = data2.get(dataDims[0], idx);
        var dataDimY = data2.get(dataDims[1], idx);
        if (isNaN(data2.get(dataDims[2], idx)) || dataDimX < xAxisExtent[0] || dataDimX > xAxisExtent[1] || dataDimY < yAxisExtent[0] || dataDimY > yAxisExtent[1]) {
          continue;
        }
        var point = coordSys.dataToPoint([dataDimX, dataDimY]);
        rect = new Rect$3({
          shape: {
            x: Math.floor(Math.round(point[0]) - width / 2),
            y: Math.floor(Math.round(point[1]) - height / 2),
            width: Math.ceil(width),
            height: Math.ceil(height)
          },
          style: style2
        });
      } else {
        if (isNaN(data2.get(dataDims[1], idx))) {
          continue;
        }
        rect = new Rect$3({
          z2: 1,
          shape: coordSys.dataToRect([data2.get(dataDims[0], idx)]).contentShape,
          style: style2
        });
      }
      if (data2.hasItemOption) {
        var itemModel = data2.getItemModel(idx);
        var emphasisModel_1 = itemModel.getModel("emphasis");
        emphasisStyle = emphasisModel_1.getModel("itemStyle").getItemStyle();
        blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
        selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
        borderRadius = itemModel.get(["itemStyle", "borderRadius"]);
        focus = emphasisModel_1.get("focus");
        blurScope = emphasisModel_1.get("blurScope");
        emphasisDisabled = emphasisModel_1.get("disabled");
        labelStatesModels = getLabelStatesModels(itemModel);
      }
      rect.shape.r = borderRadius;
      var rawValue = seriesModel.getRawValue(idx);
      var defaultText = "-";
      if (rawValue && rawValue[2] != null) {
        defaultText = rawValue[2] + "";
      }
      setLabelStyle(rect, labelStatesModels, {
        labelFetcher: seriesModel,
        labelDataIndex: idx,
        defaultOpacity: style2.opacity,
        defaultText
      });
      rect.ensureState("emphasis").style = emphasisStyle;
      rect.ensureState("blur").style = blurStyle;
      rect.ensureState("select").style = selectStyle;
      toggleHoverEmphasis(rect, focus, blurScope, emphasisDisabled);
      rect.incremental = incremental;
      if (incremental) {
        rect.states.emphasis.hoverLayer = true;
      }
      group.add(rect);
      data2.setItemGraphicEl(idx, rect);
      if (this._progressiveEls) {
        this._progressiveEls.push(rect);
      }
    }
  };
  HeatmapView2.prototype._renderOnGeo = function(geo, seriesModel, visualMapModel, api) {
    var inRangeVisuals = visualMapModel.targetVisuals.inRange;
    var outOfRangeVisuals = visualMapModel.targetVisuals.outOfRange;
    var data2 = seriesModel.getData();
    var hmLayer = this._hmLayer || this._hmLayer || new HeatmapLayer$1();
    hmLayer.blurSize = seriesModel.get("blurSize");
    hmLayer.pointSize = seriesModel.get("pointSize");
    hmLayer.minOpacity = seriesModel.get("minOpacity");
    hmLayer.maxOpacity = seriesModel.get("maxOpacity");
    var rect = geo.getViewRect().clone();
    var roamTransform = geo.getRoamTransform();
    rect.applyTransform(roamTransform);
    var x2 = Math.max(rect.x, 0);
    var y2 = Math.max(rect.y, 0);
    var x22 = Math.min(rect.width + rect.x, api.getWidth());
    var y22 = Math.min(rect.height + rect.y, api.getHeight());
    var width = x22 - x2;
    var height = y22 - y2;
    var dims = [data2.mapDimension("lng"), data2.mapDimension("lat"), data2.mapDimension("value")];
    var points2 = data2.mapArray(dims, function(lng, lat, value) {
      var pt = geo.dataToPoint([lng, lat]);
      pt[0] -= x2;
      pt[1] -= y2;
      pt.push(value);
      return pt;
    });
    var dataExtent = visualMapModel.getExtent();
    var isInRange = visualMapModel.type === "visualMap.continuous" ? getIsInContinuousRange(dataExtent, visualMapModel.option.range) : getIsInPiecewiseRange(dataExtent, visualMapModel.getPieceList(), visualMapModel.option.selected);
    hmLayer.update(points2, width, height, inRangeVisuals.color.getNormalizer(), {
      inRange: inRangeVisuals.color.getColorMapper(),
      outOfRange: outOfRangeVisuals.color.getColorMapper()
    }, isInRange);
    var img = new ZRImage$1({
      style: {
        width,
        height,
        x: x2,
        y: y2,
        image: hmLayer.canvas
      },
      silent: true
    });
    this.group.add(img);
  };
  HeatmapView2.type = "heatmap";
  return HeatmapView2;
}(ChartView$1);
var HeatmapView$1 = HeatmapView;
var HeatmapSeriesModel = function(_super) {
  __extends(HeatmapSeriesModel2, _super);
  function HeatmapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapSeriesModel2.type;
    return _this;
  }
  HeatmapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      generateCoord: "value"
    });
  };
  HeatmapSeriesModel2.prototype.preventIncremental = function() {
    var coordSysCreator = CoordinateSystem.get(this.get("coordinateSystem"));
    if (coordSysCreator && coordSysCreator.dimensions) {
      return coordSysCreator.dimensions[0] === "lng" && coordSysCreator.dimensions[1] === "lat";
    }
  };
  HeatmapSeriesModel2.type = "series.heatmap";
  HeatmapSeriesModel2.dependencies = ["grid", "geo", "calendar"];
  HeatmapSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    geoIndex: 0,
    blurSize: 30,
    pointSize: 20,
    maxOpacity: 1,
    minOpacity: 0,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return HeatmapSeriesModel2;
}(SeriesModel$1);
var HeatmapSeriesModel$1 = HeatmapSeriesModel;
function install$v(registers) {
  registers.registerChartView(HeatmapView$1);
  registers.registerSeriesModel(HeatmapSeriesModel$1);
}
var BAR_BORDER_WIDTH_QUERY = ["itemStyle", "borderWidth"];
var LAYOUT_ATTRS = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}];
var pathForLineWidth = new Circle$1();
var PictorialBarView = function(_super) {
  __extends(PictorialBarView2, _super);
  function PictorialBarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarView2.type;
    return _this;
  }
  PictorialBarView2.prototype.render = function(seriesModel, ecModel, api) {
    var group = this.group;
    var data2 = seriesModel.getData();
    var oldData = this._data;
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var coordSysRect = cartesian.master.getRect();
    var opt = {
      ecSize: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      seriesModel,
      coordSys: cartesian,
      coordSysExtent: [[coordSysRect.x, coordSysRect.x + coordSysRect.width], [coordSysRect.y, coordSysRect.y + coordSysRect.height]],
      isHorizontal,
      valueDim: LAYOUT_ATTRS[+isHorizontal],
      categoryDim: LAYOUT_ATTRS[1 - +isHorizontal]
    };
    data2.diff(oldData).add(function(dataIndex) {
      if (!data2.hasValue(dataIndex)) {
        return;
      }
      var itemModel = getItemModel(data2, dataIndex);
      var symbolMeta = getSymbolMeta(data2, dataIndex, itemModel, opt);
      var bar = createBar(data2, opt, symbolMeta);
      data2.setItemGraphicEl(dataIndex, bar);
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).update(function(newIndex, oldIndex) {
      var bar = oldData.getItemGraphicEl(oldIndex);
      if (!data2.hasValue(newIndex)) {
        group.remove(bar);
        return;
      }
      var itemModel = getItemModel(data2, newIndex);
      var symbolMeta = getSymbolMeta(data2, newIndex, itemModel, opt);
      var pictorialShapeStr = getShapeStr(data2, symbolMeta);
      if (bar && pictorialShapeStr !== bar.__pictorialShapeStr) {
        group.remove(bar);
        data2.setItemGraphicEl(newIndex, null);
        bar = null;
      }
      if (bar) {
        updateBar(bar, opt, symbolMeta);
      } else {
        bar = createBar(data2, opt, symbolMeta, true);
      }
      data2.setItemGraphicEl(newIndex, bar);
      bar.__pictorialSymbolMeta = symbolMeta;
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).remove(function(dataIndex) {
      var bar = oldData.getItemGraphicEl(dataIndex);
      bar && removeBar(oldData, dataIndex, bar.__pictorialSymbolMeta.animationModel, bar);
    }).execute();
    this._data = data2;
    return this.group;
  };
  PictorialBarView2.prototype.remove = function(ecModel, api) {
    var group = this.group;
    var data2 = this._data;
    if (ecModel.get("animation")) {
      if (data2) {
        data2.eachItemGraphicEl(function(bar) {
          removeBar(data2, getECData(bar).dataIndex, ecModel, bar);
        });
      }
    } else {
      group.removeAll();
    }
  };
  PictorialBarView2.type = "pictorialBar";
  return PictorialBarView2;
}(ChartView$1);
function getSymbolMeta(data2, dataIndex, itemModel, opt) {
  var layout2 = data2.getItemLayout(dataIndex);
  var symbolRepeat = itemModel.get("symbolRepeat");
  var symbolClip = itemModel.get("symbolClip");
  var symbolPosition = itemModel.get("symbolPosition") || "start";
  var symbolRotate = itemModel.get("symbolRotate");
  var rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  var symbolPatternSize = itemModel.get("symbolPatternSize") || 2;
  var isAnimationEnabled2 = itemModel.isAnimationEnabled();
  var symbolMeta = {
    dataIndex,
    layout: layout2,
    itemModel,
    symbolType: data2.getItemVisual(dataIndex, "symbol") || "circle",
    style: data2.getItemVisual(dataIndex, "style"),
    symbolClip,
    symbolRepeat,
    symbolRepeatDirection: itemModel.get("symbolRepeatDirection"),
    symbolPatternSize,
    rotation,
    animationModel: isAnimationEnabled2 ? itemModel : null,
    hoverScale: isAnimationEnabled2 && itemModel.get(["emphasis", "scale"]),
    z2: itemModel.getShallow("z", true) || 0
  };
  prepareBarLength(itemModel, symbolRepeat, layout2, opt, symbolMeta);
  prepareSymbolSize(data2, dataIndex, layout2, symbolRepeat, symbolClip, symbolMeta.boundingLength, symbolMeta.pxSign, symbolPatternSize, opt, symbolMeta);
  prepareLineWidth(itemModel, symbolMeta.symbolScale, rotation, opt, symbolMeta);
  var symbolSize = symbolMeta.symbolSize;
  var symbolOffset = normalizeSymbolOffset(itemModel.get("symbolOffset"), symbolSize);
  prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, symbolMeta.valueLineWidth, symbolMeta.boundingLength, symbolMeta.repeatCutLength, opt, symbolMeta);
  return symbolMeta;
}
function prepareBarLength(itemModel, symbolRepeat, layout2, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var symbolBoundingData = itemModel.get("symbolBoundingData");
  var valueAxis2 = opt.coordSys.getOtherAxis(opt.coordSys.getBaseAxis());
  var zeroPx = valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(0));
  var pxSignIdx = 1 - +(layout2[valueDim.wh] <= 0);
  var boundingLength;
  if (isArray$2(symbolBoundingData)) {
    var symbolBoundingExtent = [convertToCoordOnAxis(valueAxis2, symbolBoundingData[0]) - zeroPx, convertToCoordOnAxis(valueAxis2, symbolBoundingData[1]) - zeroPx];
    symbolBoundingExtent[1] < symbolBoundingExtent[0] && symbolBoundingExtent.reverse();
    boundingLength = symbolBoundingExtent[pxSignIdx];
  } else if (symbolBoundingData != null) {
    boundingLength = convertToCoordOnAxis(valueAxis2, symbolBoundingData) - zeroPx;
  } else if (symbolRepeat) {
    boundingLength = opt.coordSysExtent[valueDim.index][pxSignIdx] - zeroPx;
  } else {
    boundingLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.boundingLength = boundingLength;
  if (symbolRepeat) {
    outputSymbolMeta.repeatCutLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.pxSign = boundingLength > 0 ? 1 : -1;
}
function convertToCoordOnAxis(axis, value) {
  return axis.toGlobalCoord(axis.dataToCoord(axis.scale.parse(value)));
}
function prepareSymbolSize(data2, dataIndex, layout2, symbolRepeat, symbolClip, boundingLength, pxSign, symbolPatternSize, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var categoryDim = opt.categoryDim;
  var categorySize = Math.abs(layout2[categoryDim.wh]);
  var symbolSize = data2.getItemVisual(dataIndex, "symbolSize");
  var parsedSymbolSize;
  if (isArray$2(symbolSize)) {
    parsedSymbolSize = symbolSize.slice();
  } else {
    if (symbolSize == null) {
      parsedSymbolSize = ["100%", "100%"];
    } else {
      parsedSymbolSize = [symbolSize, symbolSize];
    }
  }
  parsedSymbolSize[categoryDim.index] = parsePercent(parsedSymbolSize[categoryDim.index], categorySize);
  parsedSymbolSize[valueDim.index] = parsePercent(parsedSymbolSize[valueDim.index], symbolRepeat ? categorySize : Math.abs(boundingLength));
  outputSymbolMeta.symbolSize = parsedSymbolSize;
  var symbolScale = outputSymbolMeta.symbolScale = [parsedSymbolSize[0] / symbolPatternSize, parsedSymbolSize[1] / symbolPatternSize];
  symbolScale[valueDim.index] *= (opt.isHorizontal ? -1 : 1) * pxSign;
}
function prepareLineWidth(itemModel, symbolScale, rotation, opt, outputSymbolMeta) {
  var valueLineWidth = itemModel.get(BAR_BORDER_WIDTH_QUERY) || 0;
  if (valueLineWidth) {
    pathForLineWidth.attr({
      scaleX: symbolScale[0],
      scaleY: symbolScale[1],
      rotation
    });
    pathForLineWidth.updateTransform();
    valueLineWidth /= pathForLineWidth.getLineScale();
    valueLineWidth *= symbolScale[opt.valueDim.index];
  }
  outputSymbolMeta.valueLineWidth = valueLineWidth || 0;
}
function prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, valueLineWidth, boundingLength, repeatCutLength, opt, outputSymbolMeta) {
  var categoryDim = opt.categoryDim;
  var valueDim = opt.valueDim;
  var pxSign = outputSymbolMeta.pxSign;
  var unitLength = Math.max(symbolSize[valueDim.index] + valueLineWidth, 0);
  var pathLen = unitLength;
  if (symbolRepeat) {
    var absBoundingLength = Math.abs(boundingLength);
    var symbolMargin = retrieve(itemModel.get("symbolMargin"), "15%") + "";
    var hasEndGap = false;
    if (symbolMargin.lastIndexOf("!") === symbolMargin.length - 1) {
      hasEndGap = true;
      symbolMargin = symbolMargin.slice(0, symbolMargin.length - 1);
    }
    var symbolMarginNumeric = parsePercent(symbolMargin, symbolSize[valueDim.index]);
    var uLenWithMargin = Math.max(unitLength + symbolMarginNumeric * 2, 0);
    var endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    var repeatSpecified = isNumeric$1(symbolRepeat);
    var repeatTimes = repeatSpecified ? symbolRepeat : toIntTimes((absBoundingLength + endFix) / uLenWithMargin);
    var mDiff = absBoundingLength - repeatTimes * unitLength;
    symbolMarginNumeric = mDiff / 2 / (hasEndGap ? repeatTimes : Math.max(repeatTimes - 1, 1));
    uLenWithMargin = unitLength + symbolMarginNumeric * 2;
    endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    if (!repeatSpecified && symbolRepeat !== "fixed") {
      repeatTimes = repeatCutLength ? toIntTimes((Math.abs(repeatCutLength) + endFix) / uLenWithMargin) : 0;
    }
    pathLen = repeatTimes * uLenWithMargin - endFix;
    outputSymbolMeta.repeatTimes = repeatTimes;
    outputSymbolMeta.symbolMargin = symbolMarginNumeric;
  }
  var sizeFix = pxSign * (pathLen / 2);
  var pathPosition = outputSymbolMeta.pathPosition = [];
  pathPosition[categoryDim.index] = layout2[categoryDim.wh] / 2;
  pathPosition[valueDim.index] = symbolPosition === "start" ? sizeFix : symbolPosition === "end" ? boundingLength - sizeFix : boundingLength / 2;
  if (symbolOffset) {
    pathPosition[0] += symbolOffset[0];
    pathPosition[1] += symbolOffset[1];
  }
  var bundlePosition = outputSymbolMeta.bundlePosition = [];
  bundlePosition[categoryDim.index] = layout2[categoryDim.xy];
  bundlePosition[valueDim.index] = layout2[valueDim.xy];
  var barRectShape = outputSymbolMeta.barRectShape = extend({}, layout2);
  barRectShape[valueDim.wh] = pxSign * Math.max(Math.abs(layout2[valueDim.wh]), Math.abs(pathPosition[valueDim.index] + sizeFix));
  barRectShape[categoryDim.wh] = layout2[categoryDim.wh];
  var clipShape = outputSymbolMeta.clipShape = {};
  clipShape[categoryDim.xy] = -layout2[categoryDim.xy];
  clipShape[categoryDim.wh] = opt.ecSize[categoryDim.wh];
  clipShape[valueDim.xy] = 0;
  clipShape[valueDim.wh] = layout2[valueDim.wh];
}
function createPath(symbolMeta) {
  var symbolPatternSize = symbolMeta.symbolPatternSize;
  var path = createSymbol$1(symbolMeta.symbolType, -symbolPatternSize / 2, -symbolPatternSize / 2, symbolPatternSize, symbolPatternSize);
  path.attr({
    culling: true
  });
  path.type !== "image" && path.setStyle({
    strokeNoScale: true
  });
  return path;
}
function createOrUpdateRepeatSymbols(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var symbolSize = symbolMeta.symbolSize;
  var valueLineWidth = symbolMeta.valueLineWidth;
  var pathPosition = symbolMeta.pathPosition;
  var valueDim = opt.valueDim;
  var repeatTimes = symbolMeta.repeatTimes || 0;
  var index2 = 0;
  var unit = symbolSize[opt.valueDim.index] + valueLineWidth + symbolMeta.symbolMargin * 2;
  eachPath(bar, function(path2) {
    path2.__pictorialAnimationIndex = index2;
    path2.__pictorialRepeatTimes = repeatTimes;
    if (index2 < repeatTimes) {
      updateAttr(path2, null, makeTarget(index2), symbolMeta, isUpdate);
    } else {
      updateAttr(path2, null, {
        scaleX: 0,
        scaleY: 0
      }, symbolMeta, isUpdate, function() {
        bundle.remove(path2);
      });
    }
    index2++;
  });
  for (; index2 < repeatTimes; index2++) {
    var path = createPath(symbolMeta);
    path.__pictorialAnimationIndex = index2;
    path.__pictorialRepeatTimes = repeatTimes;
    bundle.add(path);
    var target = makeTarget(index2);
    updateAttr(path, {
      x: target.x,
      y: target.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: target.scaleX,
      scaleY: target.scaleY,
      rotation: target.rotation
    }, symbolMeta, isUpdate);
  }
  function makeTarget(index3) {
    var position2 = pathPosition.slice();
    var pxSign = symbolMeta.pxSign;
    var i = index3;
    if (symbolMeta.symbolRepeatDirection === "start" ? pxSign > 0 : pxSign < 0) {
      i = repeatTimes - 1 - index3;
    }
    position2[valueDim.index] = unit * (i - repeatTimes / 2 + 0.5) + pathPosition[valueDim.index];
    return {
      x: position2[0],
      y: position2[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    };
  }
}
function createOrUpdateSingleSymbol(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var mainPath = bar.__pictorialMainPath;
  if (!mainPath) {
    mainPath = bar.__pictorialMainPath = createPath(symbolMeta);
    bundle.add(mainPath);
    updateAttr(mainPath, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: 0,
      scaleY: 0,
      rotation: symbolMeta.rotation
    }, {
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1]
    }, symbolMeta, isUpdate);
  } else {
    updateAttr(mainPath, null, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateBarRect(bar, symbolMeta, isUpdate) {
  var rectShape = extend({}, symbolMeta.barRectShape);
  var barRect = bar.__pictorialBarRect;
  if (!barRect) {
    barRect = bar.__pictorialBarRect = new Rect$3({
      z2: 2,
      shape: rectShape,
      silent: true,
      style: {
        stroke: "transparent",
        fill: "transparent",
        lineWidth: 0
      }
    });
    barRect.disableMorphing = true;
    bar.add(barRect);
  } else {
    updateAttr(barRect, null, {
      shape: rectShape
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateClip(bar, opt, symbolMeta, isUpdate) {
  if (symbolMeta.symbolClip) {
    var clipPath = bar.__pictorialClipPath;
    var clipShape = extend({}, symbolMeta.clipShape);
    var valueDim = opt.valueDim;
    var animationModel = symbolMeta.animationModel;
    var dataIndex = symbolMeta.dataIndex;
    if (clipPath) {
      updateProps$1(clipPath, {
        shape: clipShape
      }, animationModel, dataIndex);
    } else {
      clipShape[valueDim.wh] = 0;
      clipPath = new Rect$3({
        shape: clipShape
      });
      bar.__pictorialBundle.setClipPath(clipPath);
      bar.__pictorialClipPath = clipPath;
      var target = {};
      target[valueDim.wh] = symbolMeta.clipShape[valueDim.wh];
      graphic[isUpdate ? "updateProps" : "initProps"](clipPath, {
        shape: target
      }, animationModel, dataIndex);
    }
  }
}
function getItemModel(data2, dataIndex) {
  var itemModel = data2.getItemModel(dataIndex);
  itemModel.getAnimationDelayParams = getAnimationDelayParams;
  itemModel.isAnimationEnabled = isAnimationEnabled;
  return itemModel;
}
function getAnimationDelayParams(path) {
  return {
    index: path.__pictorialAnimationIndex,
    count: path.__pictorialRepeatTimes
  };
}
function isAnimationEnabled() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function createBar(data2, opt, symbolMeta, isUpdate) {
  var bar = new Group$6();
  var bundle = new Group$6();
  bar.add(bundle);
  bar.__pictorialBundle = bundle;
  bundle.x = symbolMeta.bundlePosition[0];
  bundle.y = symbolMeta.bundlePosition[1];
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta);
  }
  createOrUpdateBarRect(bar, symbolMeta, isUpdate);
  createOrUpdateClip(bar, opt, symbolMeta, isUpdate);
  bar.__pictorialShapeStr = getShapeStr(data2, symbolMeta);
  bar.__pictorialSymbolMeta = symbolMeta;
  return bar;
}
function updateBar(bar, opt, symbolMeta) {
  var animationModel = symbolMeta.animationModel;
  var dataIndex = symbolMeta.dataIndex;
  var bundle = bar.__pictorialBundle;
  updateProps$1(bundle, {
    x: symbolMeta.bundlePosition[0],
    y: symbolMeta.bundlePosition[1]
  }, animationModel, dataIndex);
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta, true);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta, true);
  }
  createOrUpdateBarRect(bar, symbolMeta, true);
  createOrUpdateClip(bar, opt, symbolMeta, true);
}
function removeBar(data2, dataIndex, animationModel, bar) {
  var labelRect = bar.__pictorialBarRect;
  labelRect && labelRect.removeTextContent();
  var pathes = [];
  eachPath(bar, function(path) {
    pathes.push(path);
  });
  bar.__pictorialMainPath && pathes.push(bar.__pictorialMainPath);
  bar.__pictorialClipPath && (animationModel = null);
  each$g(pathes, function(path) {
    removeElement(path, {
      scaleX: 0,
      scaleY: 0
    }, animationModel, dataIndex, function() {
      bar.parent && bar.parent.remove(bar);
    });
  });
  data2.setItemGraphicEl(dataIndex, null);
}
function getShapeStr(data2, symbolMeta) {
  return [data2.getItemVisual(symbolMeta.dataIndex, "symbol") || "none", !!symbolMeta.symbolRepeat, !!symbolMeta.symbolClip].join(":");
}
function eachPath(bar, cb2, context) {
  each$g(bar.__pictorialBundle.children(), function(el) {
    el !== bar.__pictorialBarRect && cb2.call(context, el);
  });
}
function updateAttr(el, immediateAttrs, animationAttrs, symbolMeta, isUpdate, cb2) {
  immediateAttrs && el.attr(immediateAttrs);
  if (symbolMeta.symbolClip && !isUpdate) {
    animationAttrs && el.attr(animationAttrs);
  } else {
    animationAttrs && graphic[isUpdate ? "updateProps" : "initProps"](el, animationAttrs, symbolMeta.animationModel, symbolMeta.dataIndex, cb2);
  }
}
function updateCommon(bar, opt, symbolMeta) {
  var dataIndex = symbolMeta.dataIndex;
  var itemModel = symbolMeta.itemModel;
  var emphasisModel = itemModel.getModel("emphasis");
  var emphasisStyle = emphasisModel.getModel("itemStyle").getItemStyle();
  var blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
  var selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
  var cursorStyle = itemModel.getShallow("cursor");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var hoverScale = emphasisModel.get("scale");
  eachPath(bar, function(path) {
    if (path instanceof ZRImage$1) {
      var pathStyle = path.style;
      path.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolMeta.style));
    } else {
      path.useStyle(symbolMeta.style);
    }
    var emphasisState = path.ensureState("emphasis");
    emphasisState.style = emphasisStyle;
    if (hoverScale) {
      emphasisState.scaleX = path.scaleX * 1.1;
      emphasisState.scaleY = path.scaleY * 1.1;
    }
    path.ensureState("blur").style = blurStyle;
    path.ensureState("select").style = selectStyle;
    cursorStyle && (path.cursor = cursorStyle);
    path.z2 = symbolMeta.z2;
  });
  var barPositionOutside = opt.valueDim.posDesc[+(symbolMeta.boundingLength > 0)];
  var barRect = bar.__pictorialBarRect;
  setLabelStyle(barRect, getLabelStatesModels(itemModel), {
    labelFetcher: opt.seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(opt.seriesModel.getData(), dataIndex),
    inheritColor: symbolMeta.style.fill,
    defaultOpacity: symbolMeta.style.opacity,
    defaultOutsidePosition: barPositionOutside
  });
  toggleHoverEmphasis(bar, focus, blurScope, emphasisModel.get("disabled"));
}
function toIntTimes(times) {
  var roundedTimes = Math.round(times);
  return Math.abs(times - roundedTimes) < 1e-4 ? roundedTimes : Math.ceil(times);
}
var PictorialBarView$1 = PictorialBarView;
var PictorialBarSeriesModel = function(_super) {
  __extends(PictorialBarSeriesModel2, _super);
  function PictorialBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    _this.defaultSymbol = "roundRect";
    return _this;
  }
  PictorialBarSeriesModel2.prototype.getInitialData = function(option) {
    option.stack = null;
    return _super.prototype.getInitialData.apply(this, arguments);
  };
  PictorialBarSeriesModel2.type = "series.pictorialBar";
  PictorialBarSeriesModel2.dependencies = ["grid"];
  PictorialBarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    symbol: "circle",
    symbolSize: null,
    symbolRotate: null,
    symbolPosition: null,
    symbolOffset: null,
    symbolMargin: null,
    symbolRepeat: false,
    symbolRepeatDirection: "end",
    symbolClip: false,
    symbolBoundingData: null,
    symbolPatternSize: 400,
    barGap: "-100%",
    progressive: 0,
    emphasis: {
      scale: false
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  });
  return PictorialBarSeriesModel2;
}(BaseBarSeriesModel$1);
var PictorialBarSeriesModel$1 = PictorialBarSeriesModel;
function install$u(registers) {
  registers.registerChartView(PictorialBarView$1);
  registers.registerSeriesModel(PictorialBarSeriesModel$1);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$3(layout$3, "pictorialBar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("pictorialBar"));
}
var ThemeRiverView = function(_super) {
  __extends(ThemeRiverView2, _super);
  function ThemeRiverView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverView2.type;
    _this._layers = [];
    return _this;
  }
  ThemeRiverView2.prototype.render = function(seriesModel, ecModel, api) {
    var data2 = seriesModel.getData();
    var self2 = this;
    var group = this.group;
    var layersSeries = seriesModel.getLayerSeries();
    var layoutInfo = data2.getLayout("layoutInfo");
    var rect = layoutInfo.rect;
    var boundaryGap = layoutInfo.boundaryGap;
    group.x = 0;
    group.y = rect.y + boundaryGap[0];
    function keyGetter(item) {
      return item.name;
    }
    var dataDiffer = new DataDiffer$1(this._layersSeries || [], layersSeries, keyGetter, keyGetter);
    var newLayersGroups = [];
    dataDiffer.add(bind$1(process2, this, "add")).update(bind$1(process2, this, "update")).remove(bind$1(process2, this, "remove")).execute();
    function process2(status, idx, oldIdx) {
      var oldLayersGroups = self2._layers;
      if (status === "remove") {
        group.remove(oldLayersGroups[idx]);
        return;
      }
      var points0 = [];
      var points1 = [];
      var style2;
      var indices = layersSeries[idx].indices;
      var j = 0;
      for (; j < indices.length; j++) {
        var layout2 = data2.getItemLayout(indices[j]);
        var x2 = layout2.x;
        var y0 = layout2.y0;
        var y2 = layout2.y;
        points0.push(x2, y0);
        points1.push(x2, y0 + y2);
        style2 = data2.getItemVisual(indices[j], "style");
      }
      var polygon;
      var textLayout = data2.getItemLayout(indices[0]);
      var labelModel = seriesModel.getModel("label");
      var margin = labelModel.get("margin");
      var emphasisModel = seriesModel.getModel("emphasis");
      if (status === "add") {
        var layerGroup = newLayersGroups[idx] = new Group$6();
        polygon = new ECPolygon({
          shape: {
            points: points0,
            stackedOnPoints: points1,
            smooth: 0.4,
            stackedOnSmooth: 0.4,
            smoothConstraint: false
          },
          z2: 0
        });
        layerGroup.add(polygon);
        group.add(layerGroup);
        if (seriesModel.isAnimationEnabled()) {
          polygon.setClipPath(createGridClipShape(polygon.getBoundingRect(), seriesModel, function() {
            polygon.removeClipPath();
          }));
        }
      } else {
        var layerGroup = oldLayersGroups[oldIdx];
        polygon = layerGroup.childAt(0);
        group.add(layerGroup);
        newLayersGroups[idx] = layerGroup;
        updateProps$1(polygon, {
          shape: {
            points: points0,
            stackedOnPoints: points1
          }
        }, seriesModel);
        saveOldStyle(polygon);
      }
      setLabelStyle(polygon, getLabelStatesModels(seriesModel), {
        labelDataIndex: indices[j - 1],
        defaultText: data2.getName(indices[j - 1]),
        inheritColor: style2.fill
      }, {
        normal: {
          verticalAlign: "middle"
        }
      });
      polygon.setTextConfig({
        position: null,
        local: true
      });
      var labelEl = polygon.getTextContent();
      if (labelEl) {
        labelEl.x = textLayout.x - margin;
        labelEl.y = textLayout.y0 + textLayout.y / 2;
      }
      polygon.useStyle(style2);
      data2.setItemGraphicEl(idx, polygon);
      setStatesStylesFromModel(polygon, seriesModel);
      toggleHoverEmphasis(polygon, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    }
    this._layersSeries = layersSeries;
    this._layers = newLayersGroups;
  };
  ThemeRiverView2.type = "themeRiver";
  return ThemeRiverView2;
}(ChartView$1);
function createGridClipShape(rect, seriesModel, cb2) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      x: rect.x - 50,
      width: rect.width + 100,
      height: rect.height + 20
    }
  }, seriesModel, cb2);
  return rectEl;
}
var ThemeRiverView$1 = ThemeRiverView;
var DATA_NAME_INDEX = 2;
var ThemeRiverSeriesModel = function(_super) {
  __extends(ThemeRiverSeriesModel2, _super);
  function ThemeRiverSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverSeriesModel2.type;
    return _this;
  }
  ThemeRiverSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  ThemeRiverSeriesModel2.prototype.fixData = function(data2) {
    var rawDataLength = data2.length;
    var timeValueKeys = {};
    var groupResult = groupData(data2, function(item) {
      if (!timeValueKeys.hasOwnProperty(item[0] + "")) {
        timeValueKeys[item[0] + ""] = -1;
      }
      return item[2];
    });
    var layerData = [];
    groupResult.buckets.each(function(items, key) {
      layerData.push({
        name: key,
        dataList: items
      });
    });
    var layerNum = layerData.length;
    for (var k2 = 0; k2 < layerNum; ++k2) {
      var name_1 = layerData[k2].name;
      for (var j = 0; j < layerData[k2].dataList.length; ++j) {
        var timeValue = layerData[k2].dataList[j][0] + "";
        timeValueKeys[timeValue] = k2;
      }
      for (var timeValue in timeValueKeys) {
        if (timeValueKeys.hasOwnProperty(timeValue) && timeValueKeys[timeValue] !== k2) {
          timeValueKeys[timeValue] = k2;
          data2[rawDataLength] = [timeValue, 0, name_1];
          rawDataLength++;
        }
      }
    }
    return data2;
  };
  ThemeRiverSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var singleAxisModel = this.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    var axisType = singleAxisModel.get("type");
    var filterData = filter(option.data, function(dataItem) {
      return dataItem[2] !== void 0;
    });
    var data2 = this.fixData(filterData || []);
    var nameList = [];
    var nameMap = this.nameMap = createHashMap();
    var count2 = 0;
    for (var i = 0; i < data2.length; ++i) {
      nameList.push(data2[i][DATA_NAME_INDEX]);
      if (!nameMap.get(data2[i][DATA_NAME_INDEX])) {
        nameMap.set(data2[i][DATA_NAME_INDEX], count2);
        count2++;
      }
    }
    var dimensions = prepareSeriesDataSchema(data2, {
      coordDimensions: ["single"],
      dimensionsDefine: [{
        name: "time",
        type: getDimensionTypeByAxis(axisType)
      }, {
        name: "value",
        type: "float"
      }, {
        name: "name",
        type: "ordinal"
      }],
      encodeDefine: {
        single: 0,
        value: 1,
        itemName: 2
      }
    }).dimensions;
    var list = new SeriesData$1(dimensions, this);
    list.initData(data2);
    return list;
  };
  ThemeRiverSeriesModel2.prototype.getLayerSeries = function() {
    var data2 = this.getData();
    var lenCount = data2.count();
    var indexArr = [];
    for (var i = 0; i < lenCount; ++i) {
      indexArr[i] = i;
    }
    var timeDim = data2.mapDimension("single");
    var groupResult = groupData(indexArr, function(index2) {
      return data2.get("name", index2);
    });
    var layerSeries = [];
    groupResult.buckets.each(function(items, key) {
      items.sort(function(index1, index2) {
        return data2.get(timeDim, index1) - data2.get(timeDim, index2);
      });
      layerSeries.push({
        name: key,
        indices: items
      });
    });
    return layerSeries;
  };
  ThemeRiverSeriesModel2.prototype.getAxisTooltipData = function(dim, value, baseAxis) {
    if (!isArray$2(dim)) {
      dim = dim ? [dim] : [];
    }
    var data2 = this.getData();
    var layerSeries = this.getLayerSeries();
    var indices = [];
    var layerNum = layerSeries.length;
    var nestestValue;
    for (var i = 0; i < layerNum; ++i) {
      var minDist = Number.MAX_VALUE;
      var nearestIdx = -1;
      var pointNum = layerSeries[i].indices.length;
      for (var j = 0; j < pointNum; ++j) {
        var theValue = data2.get(dim[0], layerSeries[i].indices[j]);
        var dist2 = Math.abs(theValue - value);
        if (dist2 <= minDist) {
          nestestValue = theValue;
          minDist = dist2;
          nearestIdx = layerSeries[i].indices[j];
        }
      }
      indices.push(nearestIdx);
    }
    return {
      dataIndices: indices,
      nestestValue
    };
  };
  ThemeRiverSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var name2 = data2.getName(dataIndex);
    var value = data2.get(data2.mapDimension("value"), dataIndex);
    return createTooltipMarkup("nameValue", {
      name: name2,
      value
    });
  };
  ThemeRiverSeriesModel2.type = "series.themeRiver";
  ThemeRiverSeriesModel2.dependencies = ["singleAxis"];
  ThemeRiverSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "singleAxis",
    boundaryGap: ["10%", "10%"],
    singleAxisIndex: 0,
    animationEasing: "linear",
    label: {
      margin: 4,
      show: true,
      position: "left",
      fontSize: 11
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return ThemeRiverSeriesModel2;
}(SeriesModel$1);
var ThemeRiverSeriesModel$1 = ThemeRiverSeriesModel;
function themeRiverLayout(ecModel, api) {
  ecModel.eachSeriesByType("themeRiver", function(seriesModel) {
    var data2 = seriesModel.getData();
    var single = seriesModel.coordinateSystem;
    var layoutInfo = {};
    var rect = single.getRect();
    layoutInfo.rect = rect;
    var boundaryGap = seriesModel.get("boundaryGap");
    var axis = single.getAxis();
    layoutInfo.boundaryGap = boundaryGap;
    if (axis.orient === "horizontal") {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.height);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.height);
      var height = rect.height - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data2, seriesModel, height);
    } else {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.width);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.width);
      var width = rect.width - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data2, seriesModel, width);
    }
    data2.setLayout("layoutInfo", layoutInfo);
  });
}
function doThemeRiverLayout(data2, seriesModel, height) {
  if (!data2.count()) {
    return;
  }
  var coordSys = seriesModel.coordinateSystem;
  var layerSeries = seriesModel.getLayerSeries();
  var timeDim = data2.mapDimension("single");
  var valueDim = data2.mapDimension("value");
  var layerPoints = map$1(layerSeries, function(singleLayer) {
    return map$1(singleLayer.indices, function(idx) {
      var pt = coordSys.dataToPoint(data2.get(timeDim, idx));
      pt[1] = data2.get(valueDim, idx);
      return pt;
    });
  });
  var base2 = computeBaseline(layerPoints);
  var baseLine = base2.y0;
  var ky = height / base2.max;
  var n2 = layerSeries.length;
  var m2 = layerSeries[0].indices.length;
  var baseY0;
  for (var j = 0; j < m2; ++j) {
    baseY0 = baseLine[j] * ky;
    data2.setItemLayout(layerSeries[0].indices[j], {
      layerIndex: 0,
      x: layerPoints[0][j][0],
      y0: baseY0,
      y: layerPoints[0][j][1] * ky
    });
    for (var i = 1; i < n2; ++i) {
      baseY0 += layerPoints[i - 1][j][1] * ky;
      data2.setItemLayout(layerSeries[i].indices[j], {
        layerIndex: i,
        x: layerPoints[i][j][0],
        y0: baseY0,
        y: layerPoints[i][j][1] * ky
      });
    }
  }
}
function computeBaseline(data2) {
  var layerNum = data2.length;
  var pointNum = data2[0].length;
  var sums = [];
  var y0 = [];
  var max3 = 0;
  for (var i = 0; i < pointNum; ++i) {
    var temp = 0;
    for (var j = 0; j < layerNum; ++j) {
      temp += data2[j][i][1];
    }
    if (temp > max3) {
      max3 = temp;
    }
    sums.push(temp);
  }
  for (var k2 = 0; k2 < pointNum; ++k2) {
    y0[k2] = (max3 - sums[k2]) / 2;
  }
  max3 = 0;
  for (var l2 = 0; l2 < pointNum; ++l2) {
    var sum2 = sums[l2] + y0[l2];
    if (sum2 > max3) {
      max3 = sum2;
    }
  }
  return {
    y0,
    max: max3
  };
}
function install$t(registers) {
  registers.registerChartView(ThemeRiverView$1);
  registers.registerSeriesModel(ThemeRiverSeriesModel$1);
  registers.registerLayout(themeRiverLayout);
  registers.registerProcessor(dataFilter$1("themeRiver"));
}
var DEFAULT_SECTOR_Z = 2;
var DEFAULT_TEXT_Z = 4;
var SunburstPiece = function(_super) {
  __extends(SunburstPiece2, _super);
  function SunburstPiece2(node, seriesModel, ecModel, api) {
    var _this = _super.call(this) || this;
    _this.z2 = DEFAULT_SECTOR_Z;
    _this.textConfig = {
      inside: true
    };
    getECData(_this).seriesIndex = seriesModel.seriesIndex;
    var text = new ZRText$1({
      z2: DEFAULT_TEXT_Z,
      silent: node.getModel().get(["label", "silent"])
    });
    _this.setTextContent(text);
    _this.updateData(true, node, seriesModel, ecModel, api);
    return _this;
  }
  SunburstPiece2.prototype.updateData = function(firstCreate, node, seriesModel, ecModel, api) {
    this.node = node;
    node.piece = this;
    seriesModel = seriesModel || this._seriesModel;
    ecModel = ecModel || this._ecModel;
    var sector = this;
    getECData(sector).dataIndex = node.dataIndex;
    var itemModel = node.getModel();
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = node.getLayout();
    var sectorShape = extend({}, layout2);
    sectorShape.label = null;
    var normalStyle = node.getVisual("style");
    normalStyle.lineJoin = "bevel";
    var decal = node.getVisual("decal");
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, api);
    }
    var cornerRadius = getSectorCornerRadius(itemModel.getModel("itemStyle"), sectorShape, true);
    extend(sectorShape, cornerRadius);
    each$g(SPECIAL_STATES, function(stateName) {
      var state = sector.ensureState(stateName);
      var itemStyleModel = itemModel.getModel([stateName, "itemStyle"]);
      state.style = itemStyleModel.getItemStyle();
      var cornerRadius2 = getSectorCornerRadius(itemStyleModel, sectorShape);
      if (cornerRadius2) {
        state.shape = cornerRadius2;
      }
    });
    if (firstCreate) {
      sector.setShape(sectorShape);
      sector.shape.r = layout2.r0;
      updateProps$1(sector, {
        shape: {
          r: layout2.r
        }
      }, seriesModel, node.dataIndex);
    } else {
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel);
      saveOldStyle(sector);
    }
    sector.useStyle(normalStyle);
    this._updateLabel(seriesModel);
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._seriesModel = seriesModel || this._seriesModel;
    this._ecModel = ecModel || this._ecModel;
    var focus = emphasisModel.get("focus");
    var focusOrIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : focus;
    toggleHoverEmphasis(this, focusOrIndices, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  SunburstPiece2.prototype._updateLabel = function(seriesModel) {
    var _this = this;
    var itemModel = this.node.getModel();
    var normalLabelModel = itemModel.getModel("label");
    var layout2 = this.node.getLayout();
    var angle = layout2.endAngle - layout2.startAngle;
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var dx = Math.cos(midAngle);
    var dy = Math.sin(midAngle);
    var sector = this;
    var label = sector.getTextContent();
    var dataIndex = this.node.dataIndex;
    var labelMinAngle = normalLabelModel.get("minAngle") / 180 * Math.PI;
    var isNormalShown = normalLabelModel.get("show") && !(labelMinAngle != null && Math.abs(angle) < labelMinAngle);
    label.ignore = !isNormalShown;
    each$g(DISPLAY_STATES, function(stateName) {
      var labelStateModel = stateName === "normal" ? itemModel.getModel("label") : itemModel.getModel([stateName, "label"]);
      var isNormal = stateName === "normal";
      var state = isNormal ? label : label.ensureState(stateName);
      var text = seriesModel.getFormattedLabel(dataIndex, stateName);
      if (isNormal) {
        text = text || _this.node.name;
      }
      state.style = createTextStyle(labelStateModel, {}, null, stateName !== "normal", true);
      if (text) {
        state.style.text = text;
      }
      var isShown = labelStateModel.get("show");
      if (isShown != null && !isNormal) {
        state.ignore = !isShown;
      }
      var labelPosition = getLabelAttr(labelStateModel, "position");
      var sectorState = isNormal ? sector : sector.states[stateName];
      var labelColor = sectorState.style.fill;
      sectorState.textConfig = {
        outsideFill: labelStateModel.get("color") === "inherit" ? labelColor : null,
        inside: labelPosition !== "outside"
      };
      var r2;
      var labelPadding = getLabelAttr(labelStateModel, "distance") || 0;
      var textAlign = getLabelAttr(labelStateModel, "align");
      if (labelPosition === "outside") {
        r2 = layout2.r + labelPadding;
        textAlign = midAngle > Math.PI / 2 ? "right" : "left";
      } else {
        if (!textAlign || textAlign === "center") {
          if (angle === 2 * Math.PI && layout2.r0 === 0) {
            r2 = 0;
          } else {
            r2 = (layout2.r + layout2.r0) / 2;
          }
          textAlign = "center";
        } else if (textAlign === "left") {
          r2 = layout2.r0 + labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "right";
          }
        } else if (textAlign === "right") {
          r2 = layout2.r - labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "left";
          }
        }
      }
      state.style.align = textAlign;
      state.style.verticalAlign = getLabelAttr(labelStateModel, "verticalAlign") || "middle";
      state.x = r2 * dx + layout2.cx;
      state.y = r2 * dy + layout2.cy;
      var rotateType = getLabelAttr(labelStateModel, "rotate");
      var rotate2 = 0;
      if (rotateType === "radial") {
        rotate2 = -midAngle;
        if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (rotateType === "tangential") {
        rotate2 = Math.PI / 2 - midAngle;
        if (rotate2 > Math.PI / 2) {
          rotate2 -= Math.PI;
        } else if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (isNumber(rotateType)) {
        rotate2 = rotateType * Math.PI / 180;
      }
      state.rotation = rotate2;
    });
    function getLabelAttr(model, name2) {
      var stateAttr = model.get(name2);
      if (stateAttr == null) {
        return normalLabelModel.get(name2);
      }
      return stateAttr;
    }
    label.dirtyStyle();
  };
  return SunburstPiece2;
}(Sector$1);
var SunburstPiece$1 = SunburstPiece;
var ROOT_TO_NODE_ACTION = "sunburstRootToNode";
var HIGHLIGHT_ACTION = "sunburstHighlight";
var UNHIGHLIGHT_ACTION = "sunburstUnhighlight";
function installSunburstAction(registers) {
  registers.registerAction({
    type: ROOT_TO_NODE_ACTION,
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var targetInfo = retrieveTargetInfo(payload, [ROOT_TO_NODE_ACTION], model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
  registers.registerAction({
    type: HIGHLIGHT_ACTION,
    update: "none"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleHighlight);
    function handleHighlight(model) {
      var targetInfo = retrieveTargetInfo(payload, [HIGHLIGHT_ACTION], model);
      if (targetInfo) {
        payload.dataIndex = targetInfo.node.dataIndex;
      }
    }
    api.dispatchAction(extend(payload, {
      type: "highlight"
    }));
  });
  registers.registerAction({
    type: UNHIGHLIGHT_ACTION,
    update: "updateView"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    api.dispatchAction(extend(payload, {
      type: "downplay"
    }));
  });
}
var SunburstView = function(_super) {
  __extends(SunburstView2, _super);
  function SunburstView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstView2.type;
    return _this;
  }
  SunburstView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var self2 = this;
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var data2 = seriesModel.getData();
    var virtualRoot = data2.tree.root;
    var newRoot = seriesModel.getViewRoot();
    var group = this.group;
    var renderLabelForZeroData = seriesModel.get("renderLabelForZeroData");
    var newChildren = [];
    newRoot.eachNode(function(node) {
      newChildren.push(node);
    });
    var oldChildren = this._oldChildren || [];
    dualTravel(newChildren, oldChildren);
    renderRollUp(virtualRoot, newRoot);
    this._initEvents();
    this._oldChildren = newChildren;
    function dualTravel(newChildren2, oldChildren2) {
      if (newChildren2.length === 0 && oldChildren2.length === 0) {
        return;
      }
      new DataDiffer$1(oldChildren2, newChildren2, getKey2, getKey2).add(processNode).update(processNode).remove(curry$3(processNode, null)).execute();
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIdx, oldIdx) {
        var newNode = newIdx == null ? null : newChildren2[newIdx];
        var oldNode = oldIdx == null ? null : oldChildren2[oldIdx];
        doRenderNode(newNode, oldNode);
      }
    }
    function doRenderNode(newNode, oldNode) {
      if (!renderLabelForZeroData && newNode && !newNode.getValue()) {
        newNode = null;
      }
      if (newNode !== virtualRoot && oldNode !== virtualRoot) {
        if (oldNode && oldNode.piece) {
          if (newNode) {
            oldNode.piece.updateData(false, newNode, seriesModel, ecModel, api);
            data2.setItemGraphicEl(newNode.dataIndex, oldNode.piece);
          } else {
            removeNode2(oldNode);
          }
        } else if (newNode) {
          var piece = new SunburstPiece$1(newNode, seriesModel, ecModel, api);
          group.add(piece);
          data2.setItemGraphicEl(newNode.dataIndex, piece);
        }
      }
    }
    function removeNode2(node) {
      if (!node) {
        return;
      }
      if (node.piece) {
        group.remove(node.piece);
        node.piece = null;
      }
    }
    function renderRollUp(virtualRoot2, viewRoot) {
      if (viewRoot.depth > 0) {
        if (self2.virtualPiece) {
          self2.virtualPiece.updateData(false, virtualRoot2, seriesModel, ecModel, api);
        } else {
          self2.virtualPiece = new SunburstPiece$1(virtualRoot2, seriesModel, ecModel, api);
          group.add(self2.virtualPiece);
        }
        viewRoot.piece.off("click");
        self2.virtualPiece.on("click", function(e2) {
          self2._rootToNode(viewRoot.parentNode);
        });
      } else if (self2.virtualPiece) {
        group.remove(self2.virtualPiece);
        self2.virtualPiece = null;
      }
    }
  };
  SunburstView2.prototype._initEvents = function() {
    var _this = this;
    this.group.off("click");
    this.group.on("click", function(e2) {
      var targetFound = false;
      var viewRoot = _this.seriesModel.getViewRoot();
      viewRoot.eachNode(function(node) {
        if (!targetFound && node.piece && node.piece === e2.target) {
          var nodeClick = node.getModel().get("nodeClick");
          if (nodeClick === "rootToNode") {
            _this._rootToNode(node);
          } else if (nodeClick === "link") {
            var itemModel = node.getModel();
            var link = itemModel.get("link");
            if (link) {
              var linkTarget = itemModel.get("target", true) || "_blank";
              windowOpen(link, linkTarget);
            }
          }
          targetFound = true;
        }
      });
    });
  };
  SunburstView2.prototype._rootToNode = function(node) {
    if (node !== this.seriesModel.getViewRoot()) {
      this.api.dispatchAction({
        type: ROOT_TO_NODE_ACTION,
        from: this.uid,
        seriesId: this.seriesModel.id,
        targetNode: node
      });
    }
  };
  SunburstView2.prototype.containPoint = function(point, seriesModel) {
    var treeRoot = seriesModel.getData();
    var itemLayout = treeRoot.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  SunburstView2.type = "sunburst";
  return SunburstView2;
}(ChartView$1);
var SunburstView$1 = SunburstView;
var SunburstSeriesModel = function(_super) {
  __extends(SunburstSeriesModel2, _super);
  function SunburstSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstSeriesModel2.type;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  SunburstSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue(root2);
    var levelModels = this._levelModels = map$1(option.levels || [], function(levelDefine) {
      return new Model$1(levelDefine, this, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = levelModels[node.depth];
        levelModel && (model.parentModel = levelModel);
        return model;
      });
    }
    return tree.data;
  };
  SunburstSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  SunburstSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treePathInfo = wrapTreePathInfo(node, this);
    return params;
  };
  SunburstSeriesModel2.prototype.getLevelModel = function(node) {
    return this._levelModels && this._levelModels[node.depth];
  };
  SunburstSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  SunburstSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  SunburstSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  SunburstSeriesModel2.type = "series.sunburst";
  SunburstSeriesModel2.defaultOption = {
    z: 2,
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    stillShowZeroSum: true,
    nodeClick: "rootToNode",
    renderLabelForZeroData: false,
    label: {
      rotate: "radial",
      show: true,
      opacity: 1,
      align: "center",
      position: "inside",
      distance: 5,
      silent: true
    },
    itemStyle: {
      borderWidth: 1,
      borderColor: "white",
      borderType: "solid",
      shadowBlur: 0,
      shadowColor: "rgba(0, 0, 0, 0.2)",
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    emphasis: {
      focus: "descendant"
    },
    blur: {
      itemStyle: {
        opacity: 0.2
      },
      label: {
        opacity: 0.1
      }
    },
    animationType: "expansion",
    animationDuration: 1e3,
    animationDurationUpdate: 500,
    data: [],
    sort: "desc"
  };
  return SunburstSeriesModel2;
}(SeriesModel$1);
function completeTreeValue(dataNode) {
  var sum2 = 0;
  each$g(dataNode.children, function(child) {
    completeTreeValue(child);
    var childValue = child.value;
    isArray$2(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$2(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$2(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
var SunburstSeriesModel$1 = SunburstSeriesModel;
var RADIAN = Math.PI / 180;
function sunburstLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var center2 = seriesModel.get("center");
    var radius = seriesModel.get("radius");
    if (!isArray$2(radius)) {
      radius = [0, radius];
    }
    if (!isArray$2(center2)) {
      center2 = [center2, center2];
    }
    var width = api.getWidth();
    var height = api.getHeight();
    var size = Math.min(width, height);
    var cx = parsePercent(center2[0], width);
    var cy = parsePercent(center2[1], height);
    var r0 = parsePercent(radius[0], size / 2);
    var r2 = parsePercent(radius[1], size / 2);
    var startAngle = -seriesModel.get("startAngle") * RADIAN;
    var minAngle = seriesModel.get("minAngle") * RADIAN;
    var virtualRoot = seriesModel.getData().tree.root;
    var treeRoot = seriesModel.getViewRoot();
    var rootDepth = treeRoot.depth;
    var sort2 = seriesModel.get("sort");
    if (sort2 != null) {
      initChildren(treeRoot, sort2);
    }
    var validDataCount = 0;
    each$g(treeRoot.children, function(child) {
      !isNaN(child.getValue()) && validDataCount++;
    });
    var sum2 = treeRoot.getValue();
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var renderRollupNode = treeRoot.depth > 0;
    var levels = treeRoot.height - (renderRollupNode ? -1 : 1);
    var rPerLevel = (r2 - r0) / (levels || 1);
    var clockwise = seriesModel.get("clockwise");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var dir3 = clockwise ? 1 : -1;
    var renderNode2 = function(node, startAngle2) {
      if (!node) {
        return;
      }
      var endAngle = startAngle2;
      if (node !== virtualRoot) {
        var value = node.getValue();
        var angle2 = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
        if (angle2 < minAngle) {
          angle2 = minAngle;
        }
        endAngle = startAngle2 + dir3 * angle2;
        var depth = node.depth - rootDepth - (renderRollupNode ? -1 : 1);
        var rStart2 = r0 + rPerLevel * depth;
        var rEnd2 = r0 + rPerLevel * (depth + 1);
        var levelModel = seriesModel.getLevelModel(node);
        if (levelModel) {
          var r0_1 = levelModel.get("r0", true);
          var r_1 = levelModel.get("r", true);
          var radius_1 = levelModel.get("radius", true);
          if (radius_1 != null) {
            r0_1 = radius_1[0];
            r_1 = radius_1[1];
          }
          r0_1 != null && (rStart2 = parsePercent(r0_1, size / 2));
          r_1 != null && (rEnd2 = parsePercent(r_1, size / 2));
        }
        node.setLayout({
          angle: angle2,
          startAngle: startAngle2,
          endAngle,
          clockwise,
          cx,
          cy,
          r0: rStart2,
          r: rEnd2
        });
      }
      if (node.children && node.children.length) {
        var siblingAngle_1 = 0;
        each$g(node.children, function(node2) {
          siblingAngle_1 += renderNode2(node2, startAngle2 + siblingAngle_1);
        });
      }
      return endAngle - startAngle2;
    };
    if (renderRollupNode) {
      var rStart = r0;
      var rEnd = r0 + rPerLevel;
      var angle = Math.PI * 2;
      virtualRoot.setLayout({
        angle,
        startAngle,
        endAngle: startAngle + angle,
        clockwise,
        cx,
        cy,
        r0: rStart,
        r: rEnd
      });
    }
    renderNode2(treeRoot, startAngle);
  });
}
function initChildren(node, sortOrder) {
  var children = node.children || [];
  node.children = sort(children, sortOrder);
  if (children.length) {
    each$g(node.children, function(child) {
      initChildren(child, sortOrder);
    });
  }
}
function sort(children, sortOrder) {
  if (isFunction$1(sortOrder)) {
    var sortTargets = map$1(children, function(child, idx) {
      var value = child.getValue();
      return {
        params: {
          depth: child.depth,
          height: child.height,
          dataIndex: child.dataIndex,
          getValue: function() {
            return value;
          }
        },
        index: idx
      };
    });
    sortTargets.sort(function(a, b2) {
      return sortOrder(a.params, b2.params);
    });
    return map$1(sortTargets, function(target) {
      return children[target.index];
    });
  } else {
    var isAsc_1 = sortOrder === "asc";
    return children.sort(function(a, b2) {
      var diff = (a.getValue() - b2.getValue()) * (isAsc_1 ? 1 : -1);
      return diff === 0 ? (a.dataIndex - b2.dataIndex) * (isAsc_1 ? -1 : 1) : diff;
    });
  }
}
function sunburstVisual(ecModel) {
  var paletteScope = {};
  function pickColor(node, seriesModel, treeHeight) {
    var current2 = node;
    while (current2 && current2.depth > 1) {
      current2 = current2.parentNode;
    }
    var color = seriesModel.getColorFromPalette(current2.name || current2.dataIndex + "", paletteScope);
    if (node.depth > 1 && isString$1(color)) {
      color = lift(color, (node.depth - 1) / (treeHeight - 1) * 0.5);
    }
    return color;
  }
  ecModel.eachSeriesByType("sunburst", function(seriesModel) {
    var data2 = seriesModel.getData();
    var tree = data2.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style2 = model.getModel("itemStyle").getItemStyle();
      if (!style2.fill) {
        style2.fill = pickColor(node, seriesModel, tree.root.height);
      }
      var existsStyle = data2.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style2);
    });
  });
}
function install$s(registers) {
  registers.registerChartView(SunburstView$1);
  registers.registerSeriesModel(SunburstSeriesModel$1);
  registers.registerLayout(curry$3(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry$3(dataFilter$1, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
var STYLE_VISUAL_TYPE = {
  color: "fill",
  borderColor: "stroke"
};
var NON_STYLE_VISUAL_PROPS = {
  symbol: 1,
  symbolSize: 1,
  symbolKeepAspect: 1,
  legendIcon: 1,
  visualMeta: 1,
  liftZ: 1,
  decal: 1
};
var customInnerStore = makeInner();
var CustomSeriesModel = function(_super) {
  __extends(CustomSeriesModel2, _super);
  function CustomSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomSeriesModel2.type;
    return _this;
  }
  CustomSeriesModel2.prototype.optionUpdated = function() {
    this.currentZLevel = this.get("zlevel", true);
    this.currentZ = this.get("z", true);
  };
  CustomSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this);
  };
  CustomSeriesModel2.prototype.getDataParams = function(dataIndex, dataType, el) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    el && (params.info = customInnerStore(el).info);
    return params;
  };
  CustomSeriesModel2.type = "series.custom";
  CustomSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  CustomSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    clip: false
  };
  return CustomSeriesModel2;
}(SeriesModel$1);
var CustomSeriesModel$1 = CustomSeriesModel;
function dataToCoordSize$3(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["x", "y"], function(dim, dimIdx) {
    var axis = this.getAxis(dim);
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
  }, this);
}
function cartesianPrepareCustom(coordSys) {
  var rect = coordSys.master.getRect();
  return {
    coordSys: {
      type: "cartesian2d",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(data2) {
        return coordSys.dataToPoint(data2);
      },
      size: bind$1(dataToCoordSize$3, coordSys)
    }
  };
}
function dataToCoordSize$2(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1([0, 1], function(dimIdx) {
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var p1 = [];
    var p2 = [];
    p1[dimIdx] = val - halfSize;
    p2[dimIdx] = val + halfSize;
    p1[1 - dimIdx] = p2[1 - dimIdx] = dataItem[1 - dimIdx];
    return Math.abs(this.dataToPoint(p1)[dimIdx] - this.dataToPoint(p2)[dimIdx]);
  }, this);
}
function geoPrepareCustom(coordSys) {
  var rect = coordSys.getBoundingRect();
  return {
    coordSys: {
      type: "geo",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      zoom: coordSys.getZoom()
    },
    api: {
      coord: function(data2) {
        return coordSys.dataToPoint(data2);
      },
      size: bind$1(dataToCoordSize$2, coordSys)
    }
  };
}
function dataToCoordSize$1(dataSize, dataItem) {
  var axis = this.getAxis();
  var val = dataItem instanceof Array ? dataItem[0] : dataItem;
  var halfSize = (dataSize instanceof Array ? dataSize[0] : dataSize) / 2;
  return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
}
function singlePrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  return {
    coordSys: {
      type: "singleAxis",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(val) {
        return coordSys.dataToPoint(val);
      },
      size: bind$1(dataToCoordSize$1, coordSys)
    }
  };
}
function dataToCoordSize(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["Radius", "Angle"], function(dim, dimIdx) {
    var getterName = "get" + dim + "Axis";
    var axis = this[getterName]();
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var result = axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
    if (dim === "Angle") {
      result = result * Math.PI / 180;
    }
    return result;
  }, this);
}
function polarPrepareCustom(coordSys) {
  var radiusAxis = coordSys.getRadiusAxis();
  var angleAxis = coordSys.getAngleAxis();
  var radius = radiusAxis.getExtent();
  radius[0] > radius[1] && radius.reverse();
  return {
    coordSys: {
      type: "polar",
      cx: coordSys.cx,
      cy: coordSys.cy,
      r: radius[1],
      r0: radius[0]
    },
    api: {
      coord: function(data2) {
        var radius2 = radiusAxis.dataToRadius(data2[0]);
        var angle = angleAxis.dataToAngle(data2[1]);
        var coord = coordSys.coordToPoint([radius2, angle]);
        coord.push(radius2, angle * Math.PI / 180);
        return coord;
      },
      size: bind$1(dataToCoordSize, coordSys)
    }
  };
}
function calendarPrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  var rangeInfo = coordSys.getRangeInfo();
  return {
    coordSys: {
      type: "calendar",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      cellWidth: coordSys.getCellWidth(),
      cellHeight: coordSys.getCellHeight(),
      rangeInfo: {
        start: rangeInfo.start,
        end: rangeInfo.end,
        weeks: rangeInfo.weeks,
        dayCount: rangeInfo.allDay
      }
    },
    api: {
      coord: function(data2, clamp2) {
        return coordSys.dataToPoint(data2, clamp2);
      }
    }
  };
}
function isEC4CompatibleStyle(style2, elType, hasOwnTextContentOption, hasOwnTextConfig) {
  return style2 && (style2.legacy || style2.legacy !== false && !hasOwnTextContentOption && !hasOwnTextConfig && elType !== "tspan" && (elType === "text" || hasOwn$1(style2, "text")));
}
function convertFromEC4CompatibleStyle(hostStyle, elType, isNormal) {
  var srcStyle = hostStyle;
  var textConfig;
  var textContent;
  var textContentStyle;
  if (elType === "text") {
    textContentStyle = srcStyle;
  } else {
    textContentStyle = {};
    hasOwn$1(srcStyle, "text") && (textContentStyle.text = srcStyle.text);
    hasOwn$1(srcStyle, "rich") && (textContentStyle.rich = srcStyle.rich);
    hasOwn$1(srcStyle, "textFill") && (textContentStyle.fill = srcStyle.textFill);
    hasOwn$1(srcStyle, "textStroke") && (textContentStyle.stroke = srcStyle.textStroke);
    hasOwn$1(srcStyle, "fontFamily") && (textContentStyle.fontFamily = srcStyle.fontFamily);
    hasOwn$1(srcStyle, "fontSize") && (textContentStyle.fontSize = srcStyle.fontSize);
    hasOwn$1(srcStyle, "fontStyle") && (textContentStyle.fontStyle = srcStyle.fontStyle);
    hasOwn$1(srcStyle, "fontWeight") && (textContentStyle.fontWeight = srcStyle.fontWeight);
    textContent = {
      type: "text",
      style: textContentStyle,
      silent: true
    };
    textConfig = {};
    var hasOwnPos = hasOwn$1(srcStyle, "textPosition");
    if (isNormal) {
      textConfig.position = hasOwnPos ? srcStyle.textPosition : "inside";
    } else {
      hasOwnPos && (textConfig.position = srcStyle.textPosition);
    }
    hasOwn$1(srcStyle, "textPosition") && (textConfig.position = srcStyle.textPosition);
    hasOwn$1(srcStyle, "textOffset") && (textConfig.offset = srcStyle.textOffset);
    hasOwn$1(srcStyle, "textRotation") && (textConfig.rotation = srcStyle.textRotation);
    hasOwn$1(srcStyle, "textDistance") && (textConfig.distance = srcStyle.textDistance);
  }
  convertEC4CompatibleRichItem(textContentStyle, hostStyle);
  each$g(textContentStyle.rich, function(richItem) {
    convertEC4CompatibleRichItem(richItem, richItem);
  });
  return {
    textConfig,
    textContent
  };
}
function convertEC4CompatibleRichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  richItem.font = richItem.textFont || richItem.font;
  hasOwn$1(richItem, "textStrokeWidth") && (out2.lineWidth = richItem.textStrokeWidth);
  hasOwn$1(richItem, "textAlign") && (out2.align = richItem.textAlign);
  hasOwn$1(richItem, "textVerticalAlign") && (out2.verticalAlign = richItem.textVerticalAlign);
  hasOwn$1(richItem, "textLineHeight") && (out2.lineHeight = richItem.textLineHeight);
  hasOwn$1(richItem, "textWidth") && (out2.width = richItem.textWidth);
  hasOwn$1(richItem, "textHeight") && (out2.height = richItem.textHeight);
  hasOwn$1(richItem, "textBackgroundColor") && (out2.backgroundColor = richItem.textBackgroundColor);
  hasOwn$1(richItem, "textPadding") && (out2.padding = richItem.textPadding);
  hasOwn$1(richItem, "textBorderColor") && (out2.borderColor = richItem.textBorderColor);
  hasOwn$1(richItem, "textBorderWidth") && (out2.borderWidth = richItem.textBorderWidth);
  hasOwn$1(richItem, "textBorderRadius") && (out2.borderRadius = richItem.textBorderRadius);
  hasOwn$1(richItem, "textBoxShadowColor") && (out2.shadowColor = richItem.textBoxShadowColor);
  hasOwn$1(richItem, "textBoxShadowBlur") && (out2.shadowBlur = richItem.textBoxShadowBlur);
  hasOwn$1(richItem, "textBoxShadowOffsetX") && (out2.shadowOffsetX = richItem.textBoxShadowOffsetX);
  hasOwn$1(richItem, "textBoxShadowOffsetY") && (out2.shadowOffsetY = richItem.textBoxShadowOffsetY);
}
function convertToEC4StyleForCustomSerise(itemStl, txStl, txCfg) {
  var out2 = itemStl;
  out2.textPosition = out2.textPosition || txCfg.position || "inside";
  txCfg.offset != null && (out2.textOffset = txCfg.offset);
  txCfg.rotation != null && (out2.textRotation = txCfg.rotation);
  txCfg.distance != null && (out2.textDistance = txCfg.distance);
  var isInside = out2.textPosition.indexOf("inside") >= 0;
  var hostFill = itemStl.fill || "#000";
  convertToEC4RichItem(out2, txStl);
  var textFillNotSet = out2.textFill == null;
  if (isInside) {
    if (textFillNotSet) {
      out2.textFill = txCfg.insideFill || "#fff";
      !out2.textStroke && txCfg.insideStroke && (out2.textStroke = txCfg.insideStroke);
      !out2.textStroke && (out2.textStroke = hostFill);
      out2.textStrokeWidth == null && (out2.textStrokeWidth = 2);
    }
  } else {
    if (textFillNotSet) {
      out2.textFill = itemStl.fill || txCfg.outsideFill || "#000";
    }
    !out2.textStroke && txCfg.outsideStroke && (out2.textStroke = txCfg.outsideStroke);
  }
  out2.text = txStl.text;
  out2.rich = txStl.rich;
  each$g(txStl.rich, function(richItem) {
    convertToEC4RichItem(richItem, richItem);
  });
  return out2;
}
function convertToEC4RichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  hasOwn$1(richItem, "fill") && (out2.textFill = richItem.fill);
  hasOwn$1(richItem, "stroke") && (out2.textStroke = richItem.fill);
  hasOwn$1(richItem, "lineWidth") && (out2.textStrokeWidth = richItem.lineWidth);
  hasOwn$1(richItem, "font") && (out2.font = richItem.font);
  hasOwn$1(richItem, "fontStyle") && (out2.fontStyle = richItem.fontStyle);
  hasOwn$1(richItem, "fontWeight") && (out2.fontWeight = richItem.fontWeight);
  hasOwn$1(richItem, "fontSize") && (out2.fontSize = richItem.fontSize);
  hasOwn$1(richItem, "fontFamily") && (out2.fontFamily = richItem.fontFamily);
  hasOwn$1(richItem, "align") && (out2.textAlign = richItem.align);
  hasOwn$1(richItem, "verticalAlign") && (out2.textVerticalAlign = richItem.verticalAlign);
  hasOwn$1(richItem, "lineHeight") && (out2.textLineHeight = richItem.lineHeight);
  hasOwn$1(richItem, "width") && (out2.textWidth = richItem.width);
  hasOwn$1(richItem, "height") && (out2.textHeight = richItem.height);
  hasOwn$1(richItem, "backgroundColor") && (out2.textBackgroundColor = richItem.backgroundColor);
  hasOwn$1(richItem, "padding") && (out2.textPadding = richItem.padding);
  hasOwn$1(richItem, "borderColor") && (out2.textBorderColor = richItem.borderColor);
  hasOwn$1(richItem, "borderWidth") && (out2.textBorderWidth = richItem.borderWidth);
  hasOwn$1(richItem, "borderRadius") && (out2.textBorderRadius = richItem.borderRadius);
  hasOwn$1(richItem, "shadowColor") && (out2.textBoxShadowColor = richItem.shadowColor);
  hasOwn$1(richItem, "shadowBlur") && (out2.textBoxShadowBlur = richItem.shadowBlur);
  hasOwn$1(richItem, "shadowOffsetX") && (out2.textBoxShadowOffsetX = richItem.shadowOffsetX);
  hasOwn$1(richItem, "shadowOffsetY") && (out2.textBoxShadowOffsetY = richItem.shadowOffsetY);
  hasOwn$1(richItem, "textShadowColor") && (out2.textShadowColor = richItem.textShadowColor);
  hasOwn$1(richItem, "textShadowBlur") && (out2.textShadowBlur = richItem.textShadowBlur);
  hasOwn$1(richItem, "textShadowOffsetX") && (out2.textShadowOffsetX = richItem.textShadowOffsetX);
  hasOwn$1(richItem, "textShadowOffsetY") && (out2.textShadowOffsetY = richItem.textShadowOffsetY);
}
var LEGACY_TRANSFORM_PROPS_MAP = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
};
var LEGACY_TRANSFORM_PROPS = keys(LEGACY_TRANSFORM_PROPS_MAP);
reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = 1;
  return obj;
}, {});
TRANSFORMABLE_PROPS.join(", ");
var ELEMENT_ANIMATABLE_PROPS = ["", "style", "shape", "extra"];
var transitionInnerStore = makeInner();
function getElementAnimationConfig(animationType, el, elOption, parentModel, dataIndex) {
  var animationProp = animationType + "Animation";
  var config2 = getAnimationConfig(animationType, parentModel, dataIndex) || {};
  var userDuring = transitionInnerStore(el).userDuring;
  if (config2.duration > 0) {
    config2.during = userDuring ? bind$1(duringCall, {
      el,
      userDuring
    }) : null;
    config2.setToFinal = true;
    config2.scope = animationType;
  }
  extend(config2, elOption[animationProp]);
  return config2;
}
function applyUpdateTransition(el, elOption, animatableModel, opts) {
  opts = opts || {};
  var dataIndex = opts.dataIndex, isInit = opts.isInit, clearStyle = opts.clearStyle;
  var hasAnimation = animatableModel.isAnimationEnabled();
  var store = transitionInnerStore(el);
  var styleOpt = elOption.style;
  store.userDuring = elOption.during;
  var transFromProps = {};
  var propsToSet = {};
  prepareTransformAllPropsFinal(el, elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("shape", elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("extra", elOption, propsToSet);
  if (!isInit && hasAnimation) {
    prepareTransformTransitionFrom(el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("shape", el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("extra", el, elOption, transFromProps);
    prepareStyleTransitionFrom(el, elOption, styleOpt, transFromProps);
  }
  propsToSet.style = styleOpt;
  applyPropsDirectly(el, propsToSet, clearStyle);
  applyMiscProps(el, elOption);
  if (hasAnimation) {
    if (isInit) {
      var enterFromProps_1 = {};
      each$g(ELEMENT_ANIMATABLE_PROPS, function(propName) {
        var prop = propName ? elOption[propName] : elOption;
        if (prop && prop.enterFrom) {
          if (propName) {
            enterFromProps_1[propName] = enterFromProps_1[propName] || {};
          }
          extend(propName ? enterFromProps_1[propName] : enterFromProps_1, prop.enterFrom);
        }
      });
      var config2 = getElementAnimationConfig("enter", el, elOption, animatableModel, dataIndex);
      if (config2.duration > 0) {
        el.animateFrom(enterFromProps_1, config2);
      }
    } else {
      applyPropsTransition(el, elOption, dataIndex || 0, animatableModel, transFromProps);
    }
  }
  updateLeaveTo(el, elOption);
  styleOpt ? el.dirty() : el.markRedraw();
}
function updateLeaveTo(el, elOption) {
  var leaveToProps = transitionInnerStore(el).leaveToProps;
  for (var i = 0; i < ELEMENT_ANIMATABLE_PROPS.length; i++) {
    var propName = ELEMENT_ANIMATABLE_PROPS[i];
    var prop = propName ? elOption[propName] : elOption;
    if (prop && prop.leaveTo) {
      if (!leaveToProps) {
        leaveToProps = transitionInnerStore(el).leaveToProps = {};
      }
      if (propName) {
        leaveToProps[propName] = leaveToProps[propName] || {};
      }
      extend(propName ? leaveToProps[propName] : leaveToProps, prop.leaveTo);
    }
  }
}
function applyLeaveTransition(el, elOption, animatableModel, onRemove) {
  if (el) {
    var parent_1 = el.parent;
    var leaveToProps = transitionInnerStore(el).leaveToProps;
    if (leaveToProps) {
      var config2 = getElementAnimationConfig("update", el, elOption, animatableModel, 0);
      config2.done = function() {
        parent_1.remove(el);
        onRemove && onRemove();
      };
      el.animateTo(leaveToProps, config2);
    } else {
      parent_1.remove(el);
      onRemove && onRemove();
    }
  }
}
function isTransitionAll(transition) {
  return transition === "all";
}
function applyPropsDirectly(el, allPropsFinal, clearStyle) {
  var styleOpt = allPropsFinal.style;
  if (!el.isGroup && styleOpt) {
    if (clearStyle) {
      el.useStyle({});
      var animators = el.animators;
      for (var i = 0; i < animators.length; i++) {
        var animator = animators[i];
        if (animator.targetName === "style") {
          animator.changeTarget(el.style);
        }
      }
    }
    el.setStyle(styleOpt);
  }
  if (allPropsFinal) {
    allPropsFinal.style = null;
    allPropsFinal && el.attr(allPropsFinal);
    allPropsFinal.style = styleOpt;
  }
}
function applyPropsTransition(el, elOption, dataIndex, model, transFromProps) {
  if (transFromProps) {
    var config2 = getElementAnimationConfig("update", el, elOption, model, dataIndex);
    if (config2.duration > 0) {
      el.animateFrom(transFromProps, config2);
    }
  }
}
function applyMiscProps(el, elOption) {
  hasOwn$1(elOption, "silent") && (el.silent = elOption.silent);
  hasOwn$1(elOption, "ignore") && (el.ignore = elOption.ignore);
  if (el instanceof Displayable$1) {
    hasOwn$1(elOption, "invisible") && (el.invisible = elOption.invisible);
  }
  if (el instanceof Path$1) {
    hasOwn$1(elOption, "autoBatch") && (el.autoBatch = elOption.autoBatch);
  }
}
var tmpDuringScope = {};
var transitionDuringAPI = {
  setTransform: function(key, val) {
    tmpDuringScope.el[key] = val;
    return this;
  },
  getTransform: function(key) {
    return tmpDuringScope.el[key];
  },
  setShape: function(key, val) {
    var el = tmpDuringScope.el;
    var shape = el.shape || (el.shape = {});
    shape[key] = val;
    el.dirtyShape && el.dirtyShape();
    return this;
  },
  getShape: function(key) {
    var shape = tmpDuringScope.el.shape;
    if (shape) {
      return shape[key];
    }
  },
  setStyle: function(key, val) {
    var el = tmpDuringScope.el;
    var style2 = el.style;
    if (style2) {
      style2[key] = val;
      el.dirtyStyle && el.dirtyStyle();
    }
    return this;
  },
  getStyle: function(key) {
    var style2 = tmpDuringScope.el.style;
    if (style2) {
      return style2[key];
    }
  },
  setExtra: function(key, val) {
    var extra = tmpDuringScope.el.extra || (tmpDuringScope.el.extra = {});
    extra[key] = val;
    return this;
  },
  getExtra: function(key) {
    var extra = tmpDuringScope.el.extra;
    if (extra) {
      return extra[key];
    }
  }
};
function duringCall() {
  var scope = this;
  var el = scope.el;
  if (!el) {
    return;
  }
  var latestUserDuring = transitionInnerStore(el).userDuring;
  var scopeUserDuring = scope.userDuring;
  if (latestUserDuring !== scopeUserDuring) {
    scope.el = scope.userDuring = null;
    return;
  }
  tmpDuringScope.el = el;
  scopeUserDuring(transitionDuringAPI);
}
function prepareShapeOrExtraTransitionFrom(mainAttr, fromEl, elOption, transFromProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var elPropsInAttr = fromEl[mainAttr];
  var transFromPropsInAttr;
  if (elPropsInAttr) {
    var transition = elOption.transition;
    var attrTransition = attrOpt.transition;
    if (attrTransition) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      if (isTransitionAll(attrTransition)) {
        extend(transFromPropsInAttr, elPropsInAttr);
      } else {
        var transitionKeys2 = normalizeToArray(attrTransition);
        for (var i = 0; i < transitionKeys2.length; i++) {
          var key = transitionKeys2[i];
          var elVal = elPropsInAttr[key];
          transFromPropsInAttr[key] = elVal;
        }
      }
    } else if (isTransitionAll(transition) || indexOf(transition, mainAttr) >= 0) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      var elPropsInAttrKeys = keys(elPropsInAttr);
      for (var i = 0; i < elPropsInAttrKeys.length; i++) {
        var key = elPropsInAttrKeys[i];
        var elVal = elPropsInAttr[key];
        if (isNonStyleTransitionEnabled(attrOpt[key], elVal)) {
          transFromPropsInAttr[key] = elVal;
        }
      }
    }
  }
}
function prepareShapeOrExtraAllPropsFinal(mainAttr, elOption, allProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var allPropsInAttr = allProps[mainAttr] = {};
  var keysInAttr = keys(attrOpt);
  for (var i = 0; i < keysInAttr.length; i++) {
    var key = keysInAttr[i];
    allPropsInAttr[key] = cloneValue(attrOpt[key]);
  }
}
function prepareTransformTransitionFrom(el, elOption, transFromProps) {
  var transition = elOption.transition;
  var transitionKeys2 = isTransitionAll(transition) ? TRANSFORMABLE_PROPS : normalizeToArray(transition || []);
  for (var i = 0; i < transitionKeys2.length; i++) {
    var key = transitionKeys2[i];
    if (key === "style" || key === "shape" || key === "extra") {
      continue;
    }
    var elVal = el[key];
    transFromProps[key] = elVal;
  }
}
function prepareTransformAllPropsFinal(el, elOption, allProps) {
  for (var i = 0; i < LEGACY_TRANSFORM_PROPS.length; i++) {
    var legacyName = LEGACY_TRANSFORM_PROPS[i];
    var xyName = LEGACY_TRANSFORM_PROPS_MAP[legacyName];
    var legacyArr = elOption[legacyName];
    if (legacyArr) {
      allProps[xyName[0]] = legacyArr[0];
      allProps[xyName[1]] = legacyArr[1];
    }
  }
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var key = TRANSFORMABLE_PROPS[i];
    if (elOption[key] != null) {
      allProps[key] = elOption[key];
    }
  }
}
function prepareStyleTransitionFrom(fromEl, elOption, styleOpt, transFromProps) {
  if (!styleOpt) {
    return;
  }
  var fromElStyle = fromEl.style;
  var transFromStyleProps;
  if (fromElStyle) {
    var styleTransition = styleOpt.transition;
    var elTransition = elOption.transition;
    if (styleTransition && !isTransitionAll(styleTransition)) {
      var transitionKeys2 = normalizeToArray(styleTransition);
      !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
      for (var i = 0; i < transitionKeys2.length; i++) {
        var key = transitionKeys2[i];
        var elVal = fromElStyle[key];
        transFromStyleProps[key] = elVal;
      }
    } else if (fromEl.getAnimationStyleProps && (isTransitionAll(elTransition) || isTransitionAll(styleTransition) || indexOf(elTransition, "style") >= 0)) {
      var animationProps = fromEl.getAnimationStyleProps();
      var animationStyleProps = animationProps ? animationProps.style : null;
      if (animationStyleProps) {
        !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
        var styleKeys = keys(styleOpt);
        for (var i = 0; i < styleKeys.length; i++) {
          var key = styleKeys[i];
          if (animationStyleProps[key]) {
            var elVal = fromElStyle[key];
            transFromStyleProps[key] = elVal;
          }
        }
      }
    }
  }
}
function isNonStyleTransitionEnabled(optVal, elVal) {
  return !isArrayLike(optVal) ? optVal != null && isFinite(optVal) : optVal !== elVal;
}
var getStateToRestore = makeInner();
var KEYFRAME_EXCLUDE_KEYS = ["percent", "easing", "shape", "style", "extra"];
function stopPreviousKeyframeAnimationAndRestore(el) {
  el.stopAnimation("keyframe");
  el.attr(getStateToRestore(el));
}
function applyKeyframeAnimation(el, animationOpts, animatableModel) {
  if (!animatableModel.isAnimationEnabled() || !animationOpts) {
    return;
  }
  if (isArray$2(animationOpts)) {
    each$g(animationOpts, function(singleAnimationOpts) {
      applyKeyframeAnimation(el, singleAnimationOpts, animatableModel);
    });
    return;
  }
  var keyframes = animationOpts.keyframes;
  var duration = animationOpts.duration;
  if (animatableModel && duration == null) {
    var config2 = getAnimationConfig("enter", animatableModel, 0);
    duration = config2 && config2.duration;
  }
  if (!keyframes || !duration) {
    return;
  }
  var stateToRestore = getStateToRestore(el);
  each$g(ELEMENT_ANIMATABLE_PROPS, function(targetPropName) {
    if (targetPropName && !el[targetPropName]) {
      return;
    }
    var animator;
    keyframes.sort(function(a, b2) {
      return a.percent - b2.percent;
    });
    each$g(keyframes, function(kf2) {
      var animators = el.animators;
      var kfValues = targetPropName ? kf2[targetPropName] : kf2;
      if (!kfValues) {
        return;
      }
      var propKeys = keys(kfValues);
      if (!targetPropName) {
        propKeys = filter(propKeys, function(key) {
          return indexOf(KEYFRAME_EXCLUDE_KEYS, key) < 0;
        });
      }
      if (!propKeys.length) {
        return;
      }
      if (!animator) {
        animator = el.animate(targetPropName, animationOpts.loop, true);
        animator.scope = "keyframe";
      }
      for (var i = 0; i < animators.length; i++) {
        if (animators[i] !== animator && animators[i].targetName === animator.targetName) {
          animators[i].stopTracks(propKeys);
        }
      }
      targetPropName && (stateToRestore[targetPropName] = stateToRestore[targetPropName] || {});
      var savedTarget = targetPropName ? stateToRestore[targetPropName] : stateToRestore;
      each$g(propKeys, function(key) {
        savedTarget[key] = ((targetPropName ? el[targetPropName] : el) || {})[key];
      });
      animator.whenWithKeys(duration * kf2.percent, kfValues, propKeys, kf2.easing);
    });
    if (!animator) {
      return;
    }
    animator.delay(animationOpts.delay || 0).duration(duration).start(animationOpts.easing);
  });
}
var EMPHASIS = "emphasis";
var NORMAL = "normal";
var BLUR = "blur";
var SELECT = "select";
var STATES = [NORMAL, EMPHASIS, BLUR, SELECT];
var PATH_ITEM_STYLE = {
  normal: ["itemStyle"],
  emphasis: [EMPHASIS, "itemStyle"],
  blur: [BLUR, "itemStyle"],
  select: [SELECT, "itemStyle"]
};
var PATH_LABEL = {
  normal: ["label"],
  emphasis: [EMPHASIS, "label"],
  blur: [BLUR, "label"],
  select: [SELECT, "label"]
};
var DEFAULT_TRANSITION = ["x", "y"];
var GROUP_DIFF_PREFIX = "e\0\0";
var attachedTxInfoTmp = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
};
var prepareCustoms = {
  cartesian2d: cartesianPrepareCustom,
  geo: geoPrepareCustom,
  singleAxis: singlePrepareCustom,
  polar: polarPrepareCustom,
  calendar: calendarPrepareCustom
};
function isPath(el) {
  return el instanceof Path$1;
}
function isDisplayable(el) {
  return el instanceof Displayable$1;
}
function copyElement(sourceEl, targetEl) {
  targetEl.copyTransform(sourceEl);
  if (isDisplayable(targetEl) && isDisplayable(sourceEl)) {
    targetEl.setStyle(sourceEl.style);
    targetEl.z = sourceEl.z;
    targetEl.z2 = sourceEl.z2;
    targetEl.zlevel = sourceEl.zlevel;
    targetEl.invisible = sourceEl.invisible;
    targetEl.ignore = sourceEl.ignore;
    if (isPath(targetEl) && isPath(sourceEl)) {
      targetEl.setShape(sourceEl.shape);
    }
  }
}
var CustomChartView = function(_super) {
  __extends(CustomChartView2, _super);
  function CustomChartView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomChartView2.type;
    return _this;
  }
  CustomChartView2.prototype.render = function(customSeries, ecModel, api, payload) {
    this._progressiveEls = null;
    var oldData = this._data;
    var data2 = customSeries.getData();
    var group = this.group;
    var renderItem = makeRenderItem(customSeries, data2, ecModel, api);
    if (!oldData) {
      group.removeAll();
    }
    data2.diff(oldData).add(function(newIdx) {
      createOrUpdateItem(api, null, newIdx, renderItem(newIdx, payload), customSeries, group, data2);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      applyLeaveTransition(el, customInnerStore(el).option, customSeries);
    }).update(function(newIdx, oldIdx) {
      var oldEl = oldData.getItemGraphicEl(oldIdx);
      createOrUpdateItem(api, oldEl, newIdx, renderItem(newIdx, payload), customSeries, group, data2);
    }).execute();
    var clipPath = customSeries.get("clip", true) ? createClipPath(customSeries.coordinateSystem, false, customSeries) : null;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
    this._data = data2;
  };
  CustomChartView2.prototype.incrementalPrepareRender = function(customSeries, ecModel, api) {
    this.group.removeAll();
    this._data = null;
  };
  CustomChartView2.prototype.incrementalRender = function(params, customSeries, ecModel, api, payload) {
    var data2 = customSeries.getData();
    var renderItem = makeRenderItem(customSeries, data2, ecModel, api);
    var progressiveEls = this._progressiveEls = [];
    function setIncrementalAndHoverLayer(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = params.start; idx < params.end; idx++) {
      var el = createOrUpdateItem(null, null, idx, renderItem(idx, payload), customSeries, this.group, data2);
      if (el) {
        el.traverse(setIncrementalAndHoverLayer);
        progressiveEls.push(el);
      }
    }
  };
  CustomChartView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  CustomChartView2.prototype.filterForExposedEvent = function(eventType, query, targetEl, packedEvent) {
    var elementName = query.element;
    if (elementName == null || targetEl.name === elementName) {
      return true;
    }
    while ((targetEl = targetEl.__hostTarget || targetEl.parent) && targetEl !== this.group) {
      if (targetEl.name === elementName) {
        return true;
      }
    }
    return false;
  };
  CustomChartView2.type = "custom";
  return CustomChartView2;
}(ChartView$1);
var CustomChartView$1 = CustomChartView;
function createEl$1(elOption) {
  var graphicType = elOption.type;
  var el;
  if (graphicType === "path") {
    var shape = elOption.shape;
    var pathRect = shape.width != null && shape.height != null ? {
      x: shape.x || 0,
      y: shape.y || 0,
      width: shape.width,
      height: shape.height
    } : null;
    var pathData = getPathData(shape);
    el = makePath(pathData, null, pathRect, shape.layout || "center");
    customInnerStore(el).customPathData = pathData;
  } else if (graphicType === "image") {
    el = new ZRImage$1({});
    customInnerStore(el).customImagePath = elOption.style.image;
  } else if (graphicType === "text") {
    el = new ZRText$1({});
  } else if (graphicType === "group") {
    el = new Group$6();
  } else if (graphicType === "compoundPath") {
    throw new Error('"compoundPath" is not supported yet.');
  } else {
    var Clz = getShapeClass(graphicType);
    if (!Clz) {
      var errMsg = "";
      throwError$2(errMsg);
    }
    el = new Clz();
  }
  customInnerStore(el).customGraphicType = graphicType;
  el.name = elOption.name;
  el.z2EmphasisLift = 1;
  el.z2SelectLift = 1;
  return el;
}
function updateElNormal(api, el, dataIndex, elOption, attachedTxInfo, seriesModel, isInit) {
  stopPreviousKeyframeAnimationAndRestore(el);
  var txCfgOpt = attachedTxInfo && attachedTxInfo.normal.cfg;
  if (txCfgOpt) {
    el.setTextConfig(txCfgOpt);
  }
  if (elOption && elOption.transition == null) {
    elOption.transition = DEFAULT_TRANSITION;
  }
  var styleOpt = elOption && elOption.style;
  if (styleOpt) {
    if (el.type === "text") {
      var textOptionStyle = styleOpt;
      hasOwn$1(textOptionStyle, "textFill") && (textOptionStyle.fill = textOptionStyle.textFill);
      hasOwn$1(textOptionStyle, "textStroke") && (textOptionStyle.stroke = textOptionStyle.textStroke);
    }
    var decalPattern = void 0;
    var decalObj = isPath(el) ? styleOpt.decal : null;
    if (api && decalObj) {
      decalObj.dirty = true;
      decalPattern = createOrUpdatePatternFromDecal(decalObj, api);
    }
    styleOpt.__decalPattern = decalPattern;
  }
  if (isDisplayable(el)) {
    if (styleOpt) {
      var decalPattern = styleOpt.__decalPattern;
      if (decalPattern) {
        styleOpt.decal = decalPattern;
      }
    }
  }
  applyUpdateTransition(el, elOption, seriesModel, {
    dataIndex,
    isInit,
    clearStyle: true
  });
  applyKeyframeAnimation(el, elOption.keyframeAnimation, seriesModel);
}
function updateElOnState(state, el, elStateOpt, styleOpt, attachedTxInfo) {
  var elDisplayable = el.isGroup ? null : el;
  var txCfgOpt = attachedTxInfo && attachedTxInfo[state].cfg;
  if (elDisplayable) {
    var stateObj = elDisplayable.ensureState(state);
    if (styleOpt === false) {
      var existingEmphasisState = elDisplayable.getState(state);
      if (existingEmphasisState) {
        existingEmphasisState.style = null;
      }
    } else {
      stateObj.style = styleOpt || null;
    }
    if (txCfgOpt) {
      stateObj.textConfig = txCfgOpt;
    }
    setDefaultStateProxy(elDisplayable);
  }
}
function updateZ(el, elOption, seriesModel) {
  if (el.isGroup) {
    return;
  }
  var elDisplayable = el;
  var currentZ = seriesModel.currentZ;
  var currentZLevel = seriesModel.currentZLevel;
  elDisplayable.z = currentZ;
  elDisplayable.zlevel = currentZLevel;
  var optZ2 = elOption.z2;
  optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  for (var i = 0; i < STATES.length; i++) {
    updateZForEachState(elDisplayable, elOption, STATES[i]);
  }
}
function updateZForEachState(elDisplayable, elOption, state) {
  var isNormal = state === NORMAL;
  var elStateOpt = isNormal ? elOption : retrieveStateOption(elOption, state);
  var optZ2 = elStateOpt ? elStateOpt.z2 : null;
  var stateObj;
  if (optZ2 != null) {
    stateObj = isNormal ? elDisplayable : elDisplayable.ensureState(state);
    stateObj.z2 = optZ2 || 0;
  }
}
function makeRenderItem(customSeries, data2, ecModel, api) {
  var renderItem = customSeries.get("renderItem");
  var coordSys = customSeries.coordinateSystem;
  var prepareResult2 = {};
  if (coordSys) {
    prepareResult2 = coordSys.prepareCustoms ? coordSys.prepareCustoms(coordSys) : prepareCustoms[coordSys.type](coordSys);
  }
  var userAPI = defaults({
    getWidth: api.getWidth,
    getHeight: api.getHeight,
    getZr: api.getZr,
    getDevicePixelRatio: api.getDevicePixelRatio,
    value,
    style: style2,
    ordinalRawValue,
    styleEmphasis,
    visual,
    barLayout,
    currentSeriesIndices,
    font
  }, prepareResult2.api || {});
  var userParams = {
    context: {},
    seriesId: customSeries.id,
    seriesName: customSeries.name,
    seriesIndex: customSeries.seriesIndex,
    coordSys: prepareResult2.coordSys,
    dataInsideLength: data2.count(),
    encode: wrapEncodeDef(customSeries.getData())
  };
  var currDataIndexInside;
  var currItemModel;
  var currItemStyleModels = {};
  var currLabelModels = {};
  var seriesItemStyleModels = {};
  var seriesLabelModels = {};
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    seriesItemStyleModels[stateName] = customSeries.getModel(PATH_ITEM_STYLE[stateName]);
    seriesLabelModels[stateName] = customSeries.getModel(PATH_LABEL[stateName]);
  }
  function getItemModel2(dataIndexInside) {
    return dataIndexInside === currDataIndexInside ? currItemModel || (currItemModel = data2.getItemModel(dataIndexInside)) : data2.getItemModel(dataIndexInside);
  }
  function getItemStyleModel(dataIndexInside, state) {
    return !data2.hasItemOption ? seriesItemStyleModels[state] : dataIndexInside === currDataIndexInside ? currItemStyleModels[state] || (currItemStyleModels[state] = getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state])) : getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state]);
  }
  function getLabelModel(dataIndexInside, state) {
    return !data2.hasItemOption ? seriesLabelModels[state] : dataIndexInside === currDataIndexInside ? currLabelModels[state] || (currLabelModels[state] = getItemModel2(dataIndexInside).getModel(PATH_LABEL[state])) : getItemModel2(dataIndexInside).getModel(PATH_LABEL[state]);
  }
  return function(dataIndexInside, payload) {
    currDataIndexInside = dataIndexInside;
    currItemModel = null;
    currItemStyleModels = {};
    currLabelModels = {};
    return renderItem && renderItem(defaults({
      dataIndexInside,
      dataIndex: data2.getRawIndex(dataIndexInside),
      actionType: payload ? payload.type : null
    }, userParams), userAPI);
  };
  function value(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    return data2.getStore().get(data2.getDimensionIndex(dim || 0), dataIndexInside);
  }
  function ordinalRawValue(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    dim = dim || 0;
    var dimInfo = data2.getDimensionInfo(dim);
    if (!dimInfo) {
      var dimIndex = data2.getDimensionIndex(dim);
      return dimIndex >= 0 ? data2.getStore().get(dimIndex, dataIndexInside) : void 0;
    }
    var val = data2.get(dimInfo.name, dataIndexInside);
    var ordinalMeta = dimInfo && dimInfo.ordinalMeta;
    return ordinalMeta ? ordinalMeta.categories[val] : val;
  }
  function style2(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var style3 = data2.getItemVisual(dataIndexInside, "style");
    var visualColor = style3 && style3.fill;
    var opacity = style3 && style3.opacity;
    var itemStyle = getItemStyleModel(dataIndexInside, NORMAL).getItemStyle();
    visualColor != null && (itemStyle.fill = visualColor);
    opacity != null && (itemStyle.opacity = opacity);
    var opt = {
      inheritColor: isString$1(visualColor) ? visualColor : "#000"
    };
    var labelModel = getLabelModel(dataIndexInside, NORMAL);
    var textStyle = createTextStyle(labelModel, null, opt, false, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve2(customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data2, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, opt, false);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function styleEmphasis(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var itemStyle = getItemStyleModel(dataIndexInside, EMPHASIS).getItemStyle();
    var labelModel = getLabelModel(dataIndexInside, EMPHASIS);
    var textStyle = createTextStyle(labelModel, null, null, true, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve3(customSeries.getFormattedLabel(dataIndexInside, EMPHASIS), customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data2, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, null, true);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function applyUserPropsAfter(itemStyle, extra) {
    for (var key in extra) {
      if (hasOwn$1(extra, key)) {
        itemStyle[key] = extra[key];
      }
    }
  }
  function preFetchFromExtra(extra, itemStyle) {
    if (extra) {
      extra.textFill && (itemStyle.textFill = extra.textFill);
      extra.textPosition && (itemStyle.textPosition = extra.textPosition);
    }
  }
  function visual(visualType, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    if (hasOwn$1(STYLE_VISUAL_TYPE, visualType)) {
      var style_1 = data2.getItemVisual(dataIndexInside, "style");
      return style_1 ? style_1[STYLE_VISUAL_TYPE[visualType]] : null;
    }
    if (hasOwn$1(NON_STYLE_VISUAL_PROPS, visualType)) {
      return data2.getItemVisual(dataIndexInside, visualType);
    }
  }
  function barLayout(opt) {
    if (coordSys.type === "cartesian2d") {
      var baseAxis = coordSys.getBaseAxis();
      return getLayoutOnAxis(defaults({
        axis: baseAxis
      }, opt));
    }
  }
  function currentSeriesIndices() {
    return ecModel.getCurrentSeriesIndices();
  }
  function font(opt) {
    return getFont(opt, ecModel);
  }
}
function wrapEncodeDef(data2) {
  var encodeDef = {};
  each$g(data2.dimensions, function(dimName) {
    var dimInfo = data2.getDimensionInfo(dimName);
    if (!dimInfo.isExtraCoord) {
      var coordDim = dimInfo.coordDim;
      var dataDims = encodeDef[coordDim] = encodeDef[coordDim] || [];
      dataDims[dimInfo.coordDimIndex] = data2.getDimensionIndex(dimName);
    }
  });
  return encodeDef;
}
function createOrUpdateItem(api, existsEl, dataIndex, elOption, seriesModel, group, data2) {
  if (!elOption) {
    group.remove(existsEl);
    return;
  }
  var el = doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group);
  el && data2.setItemGraphicEl(dataIndex, el);
  el && toggleHoverEmphasis(el, elOption.focus, elOption.blurScope, elOption.emphasisDisabled);
  return el;
}
function doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group) {
  var toBeReplacedIdx = -1;
  var oldEl = existsEl;
  if (existsEl && doesElNeedRecreate(existsEl, elOption, seriesModel)) {
    toBeReplacedIdx = indexOf(group.childrenRef(), existsEl);
    existsEl = null;
  }
  var isInit = !existsEl;
  var el = existsEl;
  if (!el) {
    el = createEl$1(elOption);
    if (oldEl) {
      copyElement(oldEl, el);
    }
  } else {
    el.clearStates();
  }
  if (elOption.morph === false) {
    el.disableMorphing = true;
  } else if (el.disableMorphing) {
    el.disableMorphing = false;
  }
  attachedTxInfoTmp.normal.cfg = attachedTxInfoTmp.normal.conOpt = attachedTxInfoTmp.emphasis.cfg = attachedTxInfoTmp.emphasis.conOpt = attachedTxInfoTmp.blur.cfg = attachedTxInfoTmp.blur.conOpt = attachedTxInfoTmp.select.cfg = attachedTxInfoTmp.select.conOpt = null;
  attachedTxInfoTmp.isLegacy = false;
  doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfoTmp);
  doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit);
  updateElNormal(api, el, dataIndex, elOption, attachedTxInfoTmp, seriesModel, isInit);
  hasOwn$1(elOption, "info") && (customInnerStore(el).info = elOption.info);
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    if (stateName !== NORMAL) {
      var otherStateOpt = retrieveStateOption(elOption, stateName);
      var otherStyleOpt = retrieveStyleOptionOnState(elOption, otherStateOpt, stateName);
      updateElOnState(stateName, el, otherStateOpt, otherStyleOpt, attachedTxInfoTmp);
    }
  }
  updateZ(el, elOption, seriesModel);
  if (elOption.type === "group") {
    mergeChildren(api, el, dataIndex, elOption, seriesModel);
  }
  if (toBeReplacedIdx >= 0) {
    group.replaceAt(el, toBeReplacedIdx);
  } else {
    group.add(el);
  }
  return el;
}
function doesElNeedRecreate(el, elOption, seriesModel) {
  var elInner = customInnerStore(el);
  var elOptionType = elOption.type;
  var elOptionShape = elOption.shape;
  var elOptionStyle = elOption.style;
  return seriesModel.isUniversalTransitionEnabled() || elOptionType != null && elOptionType !== elInner.customGraphicType || elOptionType === "path" && hasOwnPathData(elOptionShape) && getPathData(elOptionShape) !== elInner.customPathData || elOptionType === "image" && hasOwn$1(elOptionStyle, "image") && elOptionStyle.image !== elInner.customImagePath;
}
function doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit) {
  var clipPathOpt = elOption.clipPath;
  if (clipPathOpt === false) {
    if (el && el.getClipPath()) {
      el.removeClipPath();
    }
  } else if (clipPathOpt) {
    var clipPath = el.getClipPath();
    if (clipPath && doesElNeedRecreate(clipPath, clipPathOpt, seriesModel)) {
      clipPath = null;
    }
    if (!clipPath) {
      clipPath = createEl$1(clipPathOpt);
      el.setClipPath(clipPath);
    }
    updateElNormal(null, clipPath, dataIndex, clipPathOpt, null, seriesModel, isInit);
  }
}
function doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfo) {
  if (el.isGroup) {
    return;
  }
  processTxInfo(elOption, null, attachedTxInfo);
  processTxInfo(elOption, EMPHASIS, attachedTxInfo);
  var txConOptNormal = attachedTxInfo.normal.conOpt;
  var txConOptEmphasis = attachedTxInfo.emphasis.conOpt;
  var txConOptBlur = attachedTxInfo.blur.conOpt;
  var txConOptSelect = attachedTxInfo.select.conOpt;
  if (txConOptNormal != null || txConOptEmphasis != null || txConOptSelect != null || txConOptBlur != null) {
    var textContent = el.getTextContent();
    if (txConOptNormal === false) {
      textContent && el.removeTextContent();
    } else {
      txConOptNormal = attachedTxInfo.normal.conOpt = txConOptNormal || {
        type: "text"
      };
      if (!textContent) {
        textContent = createEl$1(txConOptNormal);
        el.setTextContent(textContent);
      } else {
        textContent.clearStates();
      }
      updateElNormal(null, textContent, dataIndex, txConOptNormal, null, seriesModel, isInit);
      var txConStlOptNormal = txConOptNormal && txConOptNormal.style;
      for (var i = 0; i < STATES.length; i++) {
        var stateName = STATES[i];
        if (stateName !== NORMAL) {
          var txConOptOtherState = attachedTxInfo[stateName].conOpt;
          updateElOnState(stateName, textContent, txConOptOtherState, retrieveStyleOptionOnState(txConOptNormal, txConOptOtherState, stateName), null);
        }
      }
      txConStlOptNormal ? textContent.dirty() : textContent.markRedraw();
    }
  }
}
function processTxInfo(elOption, state, attachedTxInfo) {
  var stateOpt = !state ? elOption : retrieveStateOption(elOption, state);
  var styleOpt = !state ? elOption.style : retrieveStyleOptionOnState(elOption, stateOpt, EMPHASIS);
  var elType = elOption.type;
  var txCfg = stateOpt ? stateOpt.textConfig : null;
  var txConOptNormal = elOption.textContent;
  var txConOpt = !txConOptNormal ? null : !state ? txConOptNormal : retrieveStateOption(txConOptNormal, state);
  if (styleOpt && (attachedTxInfo.isLegacy || isEC4CompatibleStyle(styleOpt, elType, !!txCfg, !!txConOpt))) {
    attachedTxInfo.isLegacy = true;
    var convertResult = convertFromEC4CompatibleStyle(styleOpt, elType, !state);
    if (!txCfg && convertResult.textConfig) {
      txCfg = convertResult.textConfig;
    }
    if (!txConOpt && convertResult.textContent) {
      txConOpt = convertResult.textContent;
    }
  }
  if (!state && txConOpt) {
    var txConOptNormal_1 = txConOpt;
    !txConOptNormal_1.type && (txConOptNormal_1.type = "text");
  }
  var info = !state ? attachedTxInfo.normal : attachedTxInfo[state];
  info.cfg = txCfg;
  info.conOpt = txConOpt;
}
function retrieveStateOption(elOption, state) {
  return !state ? elOption : elOption ? elOption[state] : null;
}
function retrieveStyleOptionOnState(stateOptionNormal, stateOption, state) {
  var style2 = stateOption && stateOption.style;
  if (style2 == null && state === EMPHASIS && stateOptionNormal) {
    style2 = stateOptionNormal.styleEmphasis;
  }
  return style2;
}
function mergeChildren(api, el, dataIndex, elOption, seriesModel) {
  var newChildren = elOption.children;
  var newLen = newChildren ? newChildren.length : 0;
  var mergeChildren2 = elOption.$mergeChildren;
  var byName = mergeChildren2 === "byName" || elOption.diffChildrenByName;
  var notMerge = mergeChildren2 === false;
  if (!newLen && !byName && !notMerge) {
    return;
  }
  if (byName) {
    diffGroupChildren({
      api,
      oldChildren: el.children() || [],
      newChildren: newChildren || [],
      dataIndex,
      seriesModel,
      group: el
    });
    return;
  }
  notMerge && el.removeAll();
  var index2 = 0;
  for (; index2 < newLen; index2++) {
    newChildren[index2] && doCreateOrUpdateEl(api, el.childAt(index2), dataIndex, newChildren[index2], seriesModel, el);
  }
  for (var i = el.childCount() - 1; i >= index2; i--) {
    var child = el.childAt(i);
    applyLeaveTransition(child, customInnerStore(el).option, seriesModel);
  }
}
function diffGroupChildren(context) {
  new DataDiffer$1(context.oldChildren, context.newChildren, getKey, getKey, context).add(processAddUpdate).update(processAddUpdate).remove(processRemove).execute();
}
function getKey(item, idx) {
  var name2 = item && item.name;
  return name2 != null ? name2 : GROUP_DIFF_PREFIX + idx;
}
function processAddUpdate(newIndex, oldIndex) {
  var context = this.context;
  var childOption = newIndex != null ? context.newChildren[newIndex] : null;
  var child = oldIndex != null ? context.oldChildren[oldIndex] : null;
  doCreateOrUpdateEl(context.api, child, context.dataIndex, childOption, context.seriesModel, context.group);
}
function processRemove(oldIndex) {
  var context = this.context;
  var child = context.oldChildren[oldIndex];
  applyLeaveTransition(child, customInnerStore(child).option, context.seriesModel);
}
function getPathData(shape) {
  return shape && (shape.pathData || shape.d);
}
function hasOwnPathData(shape) {
  return shape && (hasOwn$1(shape, "pathData") || hasOwn$1(shape, "d"));
}
function install$r(registers) {
  registers.registerChartView(CustomChartView$1);
  registers.registerSeriesModel(CustomSeriesModel$1);
}
var inner$b = makeInner();
var clone$1 = clone$4;
var bind = bind$1;
var BaseAxisPointer = function() {
  function BaseAxisPointer2() {
    this._dragging = false;
    this.animationThreshold = 15;
  }
  BaseAxisPointer2.prototype.render = function(axisModel, axisPointerModel, api, forceRender) {
    var value = axisPointerModel.get("value");
    var status = axisPointerModel.get("status");
    this._axisModel = axisModel;
    this._axisPointerModel = axisPointerModel;
    this._api = api;
    if (!forceRender && this._lastValue === value && this._lastStatus === status) {
      return;
    }
    this._lastValue = value;
    this._lastStatus = status;
    var group = this._group;
    var handle = this._handle;
    if (!status || status === "hide") {
      group && group.hide();
      handle && handle.hide();
      return;
    }
    group && group.show();
    handle && handle.show();
    var elOption = {};
    this.makeElOption(elOption, value, axisModel, axisPointerModel, api);
    var graphicKey = elOption.graphicKey;
    if (graphicKey !== this._lastGraphicKey) {
      this.clear(api);
    }
    this._lastGraphicKey = graphicKey;
    var moveAnimation = this._moveAnimation = this.determineAnimation(axisModel, axisPointerModel);
    if (!group) {
      group = this._group = new Group$6();
      this.createPointerEl(group, elOption, axisModel, axisPointerModel);
      this.createLabelEl(group, elOption, axisModel, axisPointerModel);
      api.getZr().add(group);
    } else {
      var doUpdateProps = curry$3(updateProps, axisPointerModel, moveAnimation);
      this.updatePointerEl(group, elOption, doUpdateProps);
      this.updateLabelEl(group, elOption, doUpdateProps, axisPointerModel);
    }
    updateMandatoryProps(group, axisPointerModel, true);
    this._renderHandle(value);
  };
  BaseAxisPointer2.prototype.remove = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.dispose = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.determineAnimation = function(axisModel, axisPointerModel) {
    var animation = axisPointerModel.get("animation");
    var axis = axisModel.axis;
    var isCategoryAxis = axis.type === "category";
    var useSnap = axisPointerModel.get("snap");
    if (!useSnap && !isCategoryAxis) {
      return false;
    }
    if (animation === "auto" || animation == null) {
      var animationThreshold = this.animationThreshold;
      if (isCategoryAxis && axis.getBandWidth() > animationThreshold) {
        return true;
      }
      if (useSnap) {
        var seriesDataCount = getAxisInfo$1(axisModel).seriesDataCount;
        var axisExtent = axis.getExtent();
        return Math.abs(axisExtent[0] - axisExtent[1]) / seriesDataCount > animationThreshold;
      }
      return false;
    }
    return animation === true;
  };
  BaseAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
  };
  BaseAxisPointer2.prototype.createPointerEl = function(group, elOption, axisModel, axisPointerModel) {
    var pointerOption = elOption.pointer;
    if (pointerOption) {
      var pointerEl = inner$b(group).pointerEl = new graphic[pointerOption.type](clone$1(elOption.pointer));
      group.add(pointerEl);
    }
  };
  BaseAxisPointer2.prototype.createLabelEl = function(group, elOption, axisModel, axisPointerModel) {
    if (elOption.label) {
      var labelEl = inner$b(group).labelEl = new ZRText$1(clone$1(elOption.label));
      group.add(labelEl);
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype.updatePointerEl = function(group, elOption, updateProps2) {
    var pointerEl = inner$b(group).pointerEl;
    if (pointerEl && elOption.pointer) {
      pointerEl.setStyle(elOption.pointer.style);
      updateProps2(pointerEl, {
        shape: elOption.pointer.shape
      });
    }
  };
  BaseAxisPointer2.prototype.updateLabelEl = function(group, elOption, updateProps2, axisPointerModel) {
    var labelEl = inner$b(group).labelEl;
    if (labelEl) {
      labelEl.setStyle(elOption.label.style);
      updateProps2(labelEl, {
        x: elOption.label.x,
        y: elOption.label.y
      });
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype._renderHandle = function(value) {
    if (this._dragging || !this.updateHandleTransform) {
      return;
    }
    var axisPointerModel = this._axisPointerModel;
    var zr = this._api.getZr();
    var handle = this._handle;
    var handleModel = axisPointerModel.getModel("handle");
    var status = axisPointerModel.get("status");
    if (!handleModel.get("show") || !status || status === "hide") {
      handle && zr.remove(handle);
      this._handle = null;
      return;
    }
    var isInit;
    if (!this._handle) {
      isInit = true;
      handle = this._handle = createIcon(handleModel.get("icon"), {
        cursor: "move",
        draggable: true,
        onmousemove: function(e2) {
          stop(e2.event);
        },
        onmousedown: bind(this._onHandleDragMove, this, 0, 0),
        drift: bind(this._onHandleDragMove, this),
        ondragend: bind(this._onHandleDragEnd, this)
      });
      zr.add(handle);
    }
    updateMandatoryProps(handle, axisPointerModel, false);
    handle.setStyle(handleModel.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
    var handleSize = handleModel.get("size");
    if (!isArray$2(handleSize)) {
      handleSize = [handleSize, handleSize];
    }
    handle.scaleX = handleSize[0] / 2;
    handle.scaleY = handleSize[1] / 2;
    createOrUpdate(this, "_doDispatchAxisPointer", handleModel.get("throttle") || 0, "fixRate");
    this._moveHandleToValue(value, isInit);
  };
  BaseAxisPointer2.prototype._moveHandleToValue = function(value, isInit) {
    updateProps(this._axisPointerModel, !isInit && this._moveAnimation, this._handle, getHandleTransProps(this.getHandleTransform(value, this._axisModel, this._axisPointerModel)));
  };
  BaseAxisPointer2.prototype._onHandleDragMove = function(dx, dy) {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    this._dragging = true;
    var trans = this.updateHandleTransform(getHandleTransProps(handle), [dx, dy], this._axisModel, this._axisPointerModel);
    this._payloadInfo = trans;
    handle.stopAnimation();
    handle.attr(getHandleTransProps(trans));
    inner$b(handle).lastProp = null;
    this._doDispatchAxisPointer();
  };
  BaseAxisPointer2.prototype._doDispatchAxisPointer = function() {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var payloadInfo = this._payloadInfo;
    var axisModel = this._axisModel;
    this._api.dispatchAction({
      type: "updateAxisPointer",
      x: payloadInfo.cursorPoint[0],
      y: payloadInfo.cursorPoint[1],
      tooltipOption: payloadInfo.tooltipOption,
      axesInfo: [{
        axisDim: axisModel.axis.dim,
        axisIndex: axisModel.componentIndex
      }]
    });
  };
  BaseAxisPointer2.prototype._onHandleDragEnd = function() {
    this._dragging = false;
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var value = this._axisPointerModel.get("value");
    this._moveHandleToValue(value);
    this._api.dispatchAction({
      type: "hideTip"
    });
  };
  BaseAxisPointer2.prototype.clear = function(api) {
    this._lastValue = null;
    this._lastStatus = null;
    var zr = api.getZr();
    var group = this._group;
    var handle = this._handle;
    if (zr && group) {
      this._lastGraphicKey = null;
      group && zr.remove(group);
      handle && zr.remove(handle);
      this._group = null;
      this._handle = null;
      this._payloadInfo = null;
    }
    clear$1(this, "_doDispatchAxisPointer");
  };
  BaseAxisPointer2.prototype.doClear = function() {
  };
  BaseAxisPointer2.prototype.buildLabel = function(xy, wh2, xDimIndex) {
    xDimIndex = xDimIndex || 0;
    return {
      x: xy[xDimIndex],
      y: xy[1 - xDimIndex],
      width: wh2[xDimIndex],
      height: wh2[1 - xDimIndex]
    };
  };
  return BaseAxisPointer2;
}();
function updateProps(animationModel, moveAnimation, el, props) {
  if (!propsEqual(inner$b(el).lastProp, props)) {
    inner$b(el).lastProp = props;
    moveAnimation ? updateProps$1(el, props, animationModel) : (el.stopAnimation(), el.attr(props));
  }
}
function propsEqual(lastProps, newProps) {
  if (isObject$6(lastProps) && isObject$6(newProps)) {
    var equals_1 = true;
    each$g(newProps, function(item, key) {
      equals_1 = equals_1 && propsEqual(lastProps[key], item);
    });
    return !!equals_1;
  } else {
    return lastProps === newProps;
  }
}
function updateLabelShowHide(labelEl, axisPointerModel) {
  labelEl[axisPointerModel.get(["label", "show"]) ? "show" : "hide"]();
}
function getHandleTransProps(trans) {
  return {
    x: trans.x || 0,
    y: trans.y || 0,
    rotation: trans.rotation || 0
  };
}
function updateMandatoryProps(group, axisPointerModel, silent) {
  var z2 = axisPointerModel.get("z");
  var zlevel = axisPointerModel.get("zlevel");
  group && group.traverse(function(el) {
    if (el.type !== "group") {
      z2 != null && (el.z = z2);
      zlevel != null && (el.zlevel = zlevel);
      el.silent = silent;
    }
  });
}
var BaseAxisPointer$1 = BaseAxisPointer;
function buildElStyle(axisPointerModel) {
  var axisPointerType = axisPointerModel.get("type");
  var styleModel = axisPointerModel.getModel(axisPointerType + "Style");
  var style2;
  if (axisPointerType === "line") {
    style2 = styleModel.getLineStyle();
    style2.fill = null;
  } else if (axisPointerType === "shadow") {
    style2 = styleModel.getAreaStyle();
    style2.stroke = null;
  }
  return style2;
}
function buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos) {
  var value = axisPointerModel.get("value");
  var text = getValueLabel(value, axisModel.axis, axisModel.ecModel, axisPointerModel.get("seriesDataIndices"), {
    precision: axisPointerModel.get(["label", "precision"]),
    formatter: axisPointerModel.get(["label", "formatter"])
  });
  var labelModel = axisPointerModel.getModel("label");
  var paddings = normalizeCssArray(labelModel.get("padding") || 0);
  var font = labelModel.getFont();
  var textRect = getBoundingRect(text, font);
  var position2 = labelPos.position;
  var width = textRect.width + paddings[1] + paddings[3];
  var height = textRect.height + paddings[0] + paddings[2];
  var align = labelPos.align;
  align === "right" && (position2[0] -= width);
  align === "center" && (position2[0] -= width / 2);
  var verticalAlign = labelPos.verticalAlign;
  verticalAlign === "bottom" && (position2[1] -= height);
  verticalAlign === "middle" && (position2[1] -= height / 2);
  confineInContainer(position2, width, height, api);
  var bgColor = labelModel.get("backgroundColor");
  if (!bgColor || bgColor === "auto") {
    bgColor = axisModel.get(["axisLine", "lineStyle", "color"]);
  }
  elOption.label = {
    x: position2[0],
    y: position2[1],
    style: createTextStyle(labelModel, {
      text,
      font,
      fill: labelModel.getTextColor(),
      padding: paddings,
      backgroundColor: bgColor
    }),
    z2: 10
  };
}
function confineInContainer(position2, width, height, api) {
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  position2[0] = Math.min(position2[0] + width, viewWidth) - width;
  position2[1] = Math.min(position2[1] + height, viewHeight) - height;
  position2[0] = Math.max(position2[0], 0);
  position2[1] = Math.max(position2[1], 0);
}
function getValueLabel(value, axis, ecModel, seriesDataIndices, opt) {
  value = axis.scale.parse(value);
  var text = axis.scale.getLabel({
    value
  }, {
    precision: opt.precision
  });
  var formatter = opt.formatter;
  if (formatter) {
    var params_1 = {
      value: getAxisRawValue(axis, {
        value
      }),
      axisDimension: axis.dim,
      axisIndex: axis.index,
      seriesData: []
    };
    each$g(seriesDataIndices, function(idxItem) {
      var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
      var dataIndex = idxItem.dataIndexInside;
      var dataParams = series && series.getDataParams(dataIndex);
      dataParams && params_1.seriesData.push(dataParams);
    });
    if (isString$1(formatter)) {
      text = formatter.replace("{value}", text);
    } else if (isFunction$1(formatter)) {
      text = formatter(params_1);
    }
  }
  return text;
}
function getTransformedPosition(axis, value, layoutInfo) {
  var transform2 = create$2();
  rotate(transform2, transform2, layoutInfo.rotation);
  translate(transform2, transform2, layoutInfo.position);
  return applyTransform([axis.dataToCoord(value), (layoutInfo.labelOffset || 0) + (layoutInfo.labelDirection || 1) * (layoutInfo.labelMargin || 0)], transform2);
}
function buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api) {
  var textLayout = AxisBuilder$1.innerTextLayout(layoutInfo.rotation, 0, layoutInfo.labelDirection);
  layoutInfo.labelMargin = axisPointerModel.get(["label", "margin"]);
  buildLabelElOption(elOption, axisModel, axisPointerModel, api, {
    position: getTransformedPosition(axisModel.axis, value, layoutInfo),
    align: textLayout.textAlign,
    verticalAlign: textLayout.textVerticalAlign
  });
}
function makeLineShape(p1, p2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x1: p1[xDimIndex],
    y1: p1[1 - xDimIndex],
    x2: p2[xDimIndex],
    y2: p2[1 - xDimIndex]
  };
}
function makeRectShape(xy, wh2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x: xy[xDimIndex],
    y: xy[1 - xDimIndex],
    width: wh2[xDimIndex],
    height: wh2[1 - xDimIndex]
  };
}
function makeSectorShape(cx, cy, r0, r2, startAngle, endAngle) {
  return {
    cx,
    cy,
    r0,
    r: r2,
    startAngle,
    endAngle,
    clockwise: true
  };
}
var CartesianAxisPointer = function(_super) {
  __extends(CartesianAxisPointer2, _super);
  function CartesianAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisPointerType = axisPointerModel.get("type");
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var pixelValue = axis.toGlobalCoord(axis.dataToCoord(value, true));
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$2[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$2(grid.model, axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  CartesianAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$2(axisModel.axis.grid.model, axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var pos = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: pos[0],
      y: pos[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  CartesianAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisExtent = axis.getGlobalExtent(true);
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var dimIndex = axis.dim === "x" ? 0 : 1;
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    var tooltipOptions = [{
      verticalAlign: "middle"
    }, {
      align: "center"
    }];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: tooltipOptions[dimIndex]
    };
  };
  return CartesianAxisPointer2;
}(BaseAxisPointer$1);
function getCartesian(grid, axis) {
  var opt = {};
  opt[axis.dim + "AxisIndex"] = axis.index;
  return grid.getCartesian(opt);
}
var pointerShapeBuilder$2 = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getAxisDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getAxisDimIndex(axis))
    };
  }
};
function getAxisDimIndex(axis) {
  return axis.dim === "x" ? 0 : 1;
}
var CartesianAxisPointer$1 = CartesianAxisPointer;
var AxisPointerModel = function(_super) {
  __extends(AxisPointerModel2, _super);
  function AxisPointerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerModel2.type;
    return _this;
  }
  AxisPointerModel2.type = "axisPointer";
  AxisPointerModel2.defaultOption = {
    show: "auto",
    z: 50,
    type: "line",
    snap: false,
    triggerTooltip: true,
    value: null,
    status: null,
    link: [],
    animation: null,
    animationDurationUpdate: 200,
    lineStyle: {
      color: "#B9BEC9",
      width: 1,
      type: "dashed"
    },
    shadowStyle: {
      color: "rgba(210,219,238,0.2)"
    },
    label: {
      show: true,
      formatter: null,
      precision: "auto",
      margin: 3,
      color: "#fff",
      padding: [5, 7, 5, 7],
      backgroundColor: "auto",
      borderColor: null,
      borderWidth: 0,
      borderRadius: 3
    },
    handle: {
      show: false,
      icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z",
      size: 45,
      margin: 50,
      color: "#333",
      shadowBlur: 3,
      shadowColor: "#aaa",
      shadowOffsetX: 0,
      shadowOffsetY: 2,
      throttle: 40
    }
  };
  return AxisPointerModel2;
}(ComponentModel$1);
var AxisPointerModel$1 = AxisPointerModel;
var inner$a = makeInner();
var each$9 = each$g;
function register(key, api, handler) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  inner$a(zr).records || (inner$a(zr).records = {});
  initGlobalListeners(zr, api);
  var record = inner$a(zr).records[key] || (inner$a(zr).records[key] = {});
  record.handler = handler;
}
function initGlobalListeners(zr, api) {
  if (inner$a(zr).initialized) {
    return;
  }
  inner$a(zr).initialized = true;
  useHandler("click", curry$3(doEnter, "click"));
  useHandler("mousemove", curry$3(doEnter, "mousemove"));
  useHandler("globalout", onLeave);
  function useHandler(eventType, cb2) {
    zr.on(eventType, function(e2) {
      var dis = makeDispatchAction$1(api);
      each$9(inner$a(zr).records, function(record) {
        record && cb2(record, e2, dis.dispatchAction);
      });
      dispatchTooltipFinally(dis.pendings, api);
    });
  }
}
function dispatchTooltipFinally(pendings, api) {
  var showLen = pendings.showTip.length;
  var hideLen = pendings.hideTip.length;
  var actuallyPayload;
  if (showLen) {
    actuallyPayload = pendings.showTip[showLen - 1];
  } else if (hideLen) {
    actuallyPayload = pendings.hideTip[hideLen - 1];
  }
  if (actuallyPayload) {
    actuallyPayload.dispatchAction = null;
    api.dispatchAction(actuallyPayload);
  }
}
function onLeave(record, e2, dispatchAction2) {
  record.handler("leave", null, dispatchAction2);
}
function doEnter(currTrigger, record, e2, dispatchAction2) {
  record.handler(currTrigger, e2, dispatchAction2);
}
function makeDispatchAction$1(api) {
  var pendings = {
    showTip: [],
    hideTip: []
  };
  var dispatchAction2 = function(payload) {
    var pendingList = pendings[payload.type];
    if (pendingList) {
      pendingList.push(payload);
    } else {
      payload.dispatchAction = dispatchAction2;
      api.dispatchAction(payload);
    }
  };
  return {
    dispatchAction: dispatchAction2,
    pendings
  };
}
function unregister(key, api) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  var record = (inner$a(zr).records || {})[key];
  if (record) {
    inner$a(zr).records[key] = null;
  }
}
var AxisPointerView = function(_super) {
  __extends(AxisPointerView2, _super);
  function AxisPointerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerView2.type;
    return _this;
  }
  AxisPointerView2.prototype.render = function(globalAxisPointerModel, ecModel, api) {
    var globalTooltipModel = ecModel.getComponent("tooltip");
    var triggerOn = globalAxisPointerModel.get("triggerOn") || globalTooltipModel && globalTooltipModel.get("triggerOn") || "mousemove|click";
    register("axisPointer", api, function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none" && (currTrigger === "leave" || triggerOn.indexOf(currTrigger) >= 0)) {
        dispatchAction2({
          type: "updateAxisPointer",
          currTrigger,
          x: e2 && e2.offsetX,
          y: e2 && e2.offsetY
        });
      }
    });
  };
  AxisPointerView2.prototype.remove = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.prototype.dispose = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.type = "axisPointer";
  return AxisPointerView2;
}(ComponentView$1);
var AxisPointerView$1 = AxisPointerView;
function findPointFromSeries(finder, ecModel) {
  var point = [];
  var seriesIndex = finder.seriesIndex;
  var seriesModel;
  if (seriesIndex == null || !(seriesModel = ecModel.getSeriesByIndex(seriesIndex))) {
    return {
      point: []
    };
  }
  var data2 = seriesModel.getData();
  var dataIndex = queryDataIndex(data2, finder);
  if (dataIndex == null || dataIndex < 0 || isArray$2(dataIndex)) {
    return {
      point: []
    };
  }
  var el = data2.getItemGraphicEl(dataIndex);
  var coordSys = seriesModel.coordinateSystem;
  if (seriesModel.getTooltipPosition) {
    point = seriesModel.getTooltipPosition(dataIndex) || [];
  } else if (coordSys && coordSys.dataToPoint) {
    if (finder.isStacked) {
      var baseAxis = coordSys.getBaseAxis();
      var valueAxis2 = coordSys.getOtherAxis(baseAxis);
      var valueAxisDim = valueAxis2.dim;
      var baseAxisDim = baseAxis.dim;
      var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
      var baseDim = data2.mapDimension(baseAxisDim);
      var stackedData = [];
      stackedData[baseDataOffset] = data2.get(baseDim, dataIndex);
      stackedData[1 - baseDataOffset] = data2.get(data2.getCalculationInfo("stackResultDimension"), dataIndex);
      point = coordSys.dataToPoint(stackedData) || [];
    } else {
      point = coordSys.dataToPoint(data2.getValues(map$1(coordSys.dimensions, function(dim) {
        return data2.mapDimension(dim);
      }), dataIndex)) || [];
    }
  } else if (el) {
    var rect = el.getBoundingRect().clone();
    rect.applyTransform(el.transform);
    point = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  }
  return {
    point,
    el
  };
}
var inner$9 = makeInner();
function axisTrigger(payload, ecModel, api) {
  var currTrigger = payload.currTrigger;
  var point = [payload.x, payload.y];
  var finder = payload;
  var dispatchAction2 = payload.dispatchAction || bind$1(api.dispatchAction, api);
  var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
  if (!coordSysAxesInfo) {
    return;
  }
  if (illegalPoint(point)) {
    point = findPointFromSeries({
      seriesIndex: finder.seriesIndex,
      dataIndex: finder.dataIndex
    }, ecModel).point;
  }
  var isIllegalPoint = illegalPoint(point);
  var inputAxesInfo = finder.axesInfo;
  var axesInfo = coordSysAxesInfo.axesInfo;
  var shouldHide = currTrigger === "leave" || illegalPoint(point);
  var outputPayload = {};
  var showValueMap = {};
  var dataByCoordSys = {
    list: [],
    map: {}
  };
  var updaters = {
    showPointer: curry$3(showPointer, showValueMap),
    showTooltip: curry$3(showTooltip, dataByCoordSys)
  };
  each$g(coordSysAxesInfo.coordSysMap, function(coordSys, coordSysKey) {
    var coordSysContainsPoint = isIllegalPoint || coordSys.containPoint(point);
    each$g(coordSysAxesInfo.coordSysAxesInfo[coordSysKey], function(axisInfo, key) {
      var axis = axisInfo.axis;
      var inputAxisInfo = findInputAxisInfo(inputAxesInfo, axisInfo);
      if (!shouldHide && coordSysContainsPoint && (!inputAxesInfo || inputAxisInfo)) {
        var val = inputAxisInfo && inputAxisInfo.value;
        if (val == null && !isIllegalPoint) {
          val = axis.pointToData(point);
        }
        val != null && processOnAxis(axisInfo, val, updaters, false, outputPayload);
      }
    });
  });
  var linkTriggers = {};
  each$g(axesInfo, function(tarAxisInfo, tarKey) {
    var linkGroup = tarAxisInfo.linkGroup;
    if (linkGroup && !showValueMap[tarKey]) {
      each$g(linkGroup.axesInfo, function(srcAxisInfo, srcKey) {
        var srcValItem = showValueMap[srcKey];
        if (srcAxisInfo !== tarAxisInfo && srcValItem) {
          var val = srcValItem.value;
          linkGroup.mapper && (val = tarAxisInfo.axis.scale.parse(linkGroup.mapper(val, makeMapperParam(srcAxisInfo), makeMapperParam(tarAxisInfo))));
          linkTriggers[tarAxisInfo.key] = val;
        }
      });
    }
  });
  each$g(linkTriggers, function(val, tarKey) {
    processOnAxis(axesInfo[tarKey], val, updaters, true, outputPayload);
  });
  updateModelActually(showValueMap, axesInfo, outputPayload);
  dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2);
  dispatchHighDownActually(axesInfo, dispatchAction2, api);
  return outputPayload;
}
function processOnAxis(axisInfo, newValue, updaters, noSnap, outputFinder) {
  var axis = axisInfo.axis;
  if (axis.scale.isBlank() || !axis.containData(newValue)) {
    return;
  }
  if (!axisInfo.involveSeries) {
    updaters.showPointer(axisInfo, newValue);
    return;
  }
  var payloadInfo = buildPayloadsBySeries(newValue, axisInfo);
  var payloadBatch = payloadInfo.payloadBatch;
  var snapToValue = payloadInfo.snapToValue;
  if (payloadBatch[0] && outputFinder.seriesIndex == null) {
    extend(outputFinder, payloadBatch[0]);
  }
  if (!noSnap && axisInfo.snap) {
    if (axis.containData(snapToValue) && snapToValue != null) {
      newValue = snapToValue;
    }
  }
  updaters.showPointer(axisInfo, newValue, payloadBatch);
  updaters.showTooltip(axisInfo, payloadInfo, snapToValue);
}
function buildPayloadsBySeries(value, axisInfo) {
  var axis = axisInfo.axis;
  var dim = axis.dim;
  var snapToValue = value;
  var payloadBatch = [];
  var minDist = Number.MAX_VALUE;
  var minDiff = -1;
  each$g(axisInfo.seriesModels, function(series, idx) {
    var dataDim = series.getData().mapDimensionsAll(dim);
    var seriesNestestValue;
    var dataIndices;
    if (series.getAxisTooltipData) {
      var result = series.getAxisTooltipData(dataDim, value, axis);
      dataIndices = result.dataIndices;
      seriesNestestValue = result.nestestValue;
    } else {
      dataIndices = series.getData().indicesOfNearest(dataDim[0], value, axis.type === "category" ? 0.5 : null);
      if (!dataIndices.length) {
        return;
      }
      seriesNestestValue = series.getData().get(dataDim[0], dataIndices[0]);
    }
    if (seriesNestestValue == null || !isFinite(seriesNestestValue)) {
      return;
    }
    var diff = value - seriesNestestValue;
    var dist2 = Math.abs(diff);
    if (dist2 <= minDist) {
      if (dist2 < minDist || diff >= 0 && minDiff < 0) {
        minDist = dist2;
        minDiff = diff;
        snapToValue = seriesNestestValue;
        payloadBatch.length = 0;
      }
      each$g(dataIndices, function(dataIndex) {
        payloadBatch.push({
          seriesIndex: series.seriesIndex,
          dataIndexInside: dataIndex,
          dataIndex: series.getData().getRawIndex(dataIndex)
        });
      });
    }
  });
  return {
    payloadBatch,
    snapToValue
  };
}
function showPointer(showValueMap, axisInfo, value, payloadBatch) {
  showValueMap[axisInfo.key] = {
    value,
    payloadBatch
  };
}
function showTooltip(dataByCoordSys, axisInfo, payloadInfo, value) {
  var payloadBatch = payloadInfo.payloadBatch;
  var axis = axisInfo.axis;
  var axisModel = axis.model;
  var axisPointerModel = axisInfo.axisPointerModel;
  if (!axisInfo.triggerTooltip || !payloadBatch.length) {
    return;
  }
  var coordSysModel = axisInfo.coordSys.model;
  var coordSysKey = makeKey(coordSysModel);
  var coordSysItem = dataByCoordSys.map[coordSysKey];
  if (!coordSysItem) {
    coordSysItem = dataByCoordSys.map[coordSysKey] = {
      coordSysId: coordSysModel.id,
      coordSysIndex: coordSysModel.componentIndex,
      coordSysType: coordSysModel.type,
      coordSysMainType: coordSysModel.mainType,
      dataByAxis: []
    };
    dataByCoordSys.list.push(coordSysItem);
  }
  coordSysItem.dataByAxis.push({
    axisDim: axis.dim,
    axisIndex: axisModel.componentIndex,
    axisType: axisModel.type,
    axisId: axisModel.id,
    value,
    valueLabelOpt: {
      precision: axisPointerModel.get(["label", "precision"]),
      formatter: axisPointerModel.get(["label", "formatter"])
    },
    seriesDataIndices: payloadBatch.slice()
  });
}
function updateModelActually(showValueMap, axesInfo, outputPayload) {
  var outputAxesInfo = outputPayload.axesInfo = [];
  each$g(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    var valItem = showValueMap[key];
    if (valItem) {
      !axisInfo.useHandle && (option.status = "show");
      option.value = valItem.value;
      option.seriesDataIndices = (valItem.payloadBatch || []).slice();
    } else {
      !axisInfo.useHandle && (option.status = "hide");
    }
    option.status === "show" && outputAxesInfo.push({
      axisDim: axisInfo.axis.dim,
      axisIndex: axisInfo.axis.model.componentIndex,
      value: option.value
    });
  });
}
function dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2) {
  if (illegalPoint(point) || !dataByCoordSys.list.length) {
    dispatchAction2({
      type: "hideTip"
    });
    return;
  }
  var sampleItem = ((dataByCoordSys.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
  dispatchAction2({
    type: "showTip",
    escapeConnect: true,
    x: point[0],
    y: point[1],
    tooltipOption: payload.tooltipOption,
    position: payload.position,
    dataIndexInside: sampleItem.dataIndexInside,
    dataIndex: sampleItem.dataIndex,
    seriesIndex: sampleItem.seriesIndex,
    dataByCoordSys: dataByCoordSys.list
  });
}
function dispatchHighDownActually(axesInfo, dispatchAction2, api) {
  var zr = api.getZr();
  var highDownKey = "axisPointerLastHighlights";
  var lastHighlights = inner$9(zr)[highDownKey] || {};
  var newHighlights = inner$9(zr)[highDownKey] = {};
  each$g(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    option.status === "show" && each$g(option.seriesDataIndices, function(batchItem) {
      var key2 = batchItem.seriesIndex + " | " + batchItem.dataIndex;
      newHighlights[key2] = batchItem;
    });
  });
  var toHighlight = [];
  var toDownplay = [];
  each$g(lastHighlights, function(batchItem, key) {
    !newHighlights[key] && toDownplay.push(batchItem);
  });
  each$g(newHighlights, function(batchItem, key) {
    !lastHighlights[key] && toHighlight.push(batchItem);
  });
  toDownplay.length && api.dispatchAction({
    type: "downplay",
    escapeConnect: true,
    notBlur: true,
    batch: toDownplay
  });
  toHighlight.length && api.dispatchAction({
    type: "highlight",
    escapeConnect: true,
    notBlur: true,
    batch: toHighlight
  });
}
function findInputAxisInfo(inputAxesInfo, axisInfo) {
  for (var i = 0; i < (inputAxesInfo || []).length; i++) {
    var inputAxisInfo = inputAxesInfo[i];
    if (axisInfo.axis.dim === inputAxisInfo.axisDim && axisInfo.axis.model.componentIndex === inputAxisInfo.axisIndex) {
      return inputAxisInfo;
    }
  }
}
function makeMapperParam(axisInfo) {
  var axisModel = axisInfo.axis.model;
  var item = {};
  var dim = item.axisDim = axisInfo.axis.dim;
  item.axisIndex = item[dim + "AxisIndex"] = axisModel.componentIndex;
  item.axisName = item[dim + "AxisName"] = axisModel.name;
  item.axisId = item[dim + "AxisId"] = axisModel.id;
  return item;
}
function illegalPoint(point) {
  return !point || point[0] == null || isNaN(point[0]) || point[1] == null || isNaN(point[1]);
}
function install$q(registers) {
  AxisView$1.registerAxisPointerClass("CartesianAxisPointer", CartesianAxisPointer$1);
  registers.registerComponentModel(AxisPointerModel$1);
  registers.registerComponentView(AxisPointerView$1);
  registers.registerPreprocessor(function(option) {
    if (option) {
      (!option.axisPointer || option.axisPointer.length === 0) && (option.axisPointer = {});
      var link = option.axisPointer.link;
      if (link && !isArray$2(link)) {
        option.axisPointer.link = [link];
      }
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, function(ecModel, api) {
    ecModel.getComponent("axisPointer").coordSysAxesInfo = collect(ecModel, api);
  });
  registers.registerAction({
    type: "updateAxisPointer",
    event: "updateAxisPointer",
    update: ":updateAxisPointer"
  }, axisTrigger);
}
function install$p(registers) {
  use(install$N);
  use(install$q);
}
var PolarAxisPointer = function(_super) {
  __extends(PolarAxisPointer2, _super);
  function PolarAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    if (axis.dim === "angle") {
      this.animationThreshold = Math.PI / 18;
    }
    var polar = axis.polar;
    var otherAxis = polar.getOtherAxis(axis);
    var otherExtent = otherAxis.getExtent();
    var coordValue = axis.dataToCoord(value);
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$1[axisPointerType](axis, polar, coordValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var labelMargin = axisPointerModel.get(["label", "margin"]);
    var labelPos = getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin);
    buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos);
  };
  return PolarAxisPointer2;
}(BaseAxisPointer$1);
function getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin) {
  var axis = axisModel.axis;
  var coord = axis.dataToCoord(value);
  var axisAngle = polar.getAngleAxis().getExtent()[0];
  axisAngle = axisAngle / 180 * Math.PI;
  var radiusExtent = polar.getRadiusAxis().getExtent();
  var position2;
  var align;
  var verticalAlign;
  if (axis.dim === "radius") {
    var transform2 = create$2();
    rotate(transform2, transform2, axisAngle);
    translate(transform2, transform2, [polar.cx, polar.cy]);
    position2 = applyTransform([coord, -labelMargin], transform2);
    var labelRotation = axisModel.getModel("axisLabel").get("rotate") || 0;
    var labelLayout2 = AxisBuilder$1.innerTextLayout(axisAngle, labelRotation * Math.PI / 180, -1);
    align = labelLayout2.textAlign;
    verticalAlign = labelLayout2.textVerticalAlign;
  } else {
    var r2 = radiusExtent[1];
    position2 = polar.coordToPoint([r2 + labelMargin, coord]);
    var cx = polar.cx;
    var cy = polar.cy;
    align = Math.abs(position2[0] - cx) / r2 < 0.3 ? "center" : position2[0] > cx ? "left" : "right";
    verticalAlign = Math.abs(position2[1] - cy) / r2 < 0.3 ? "middle" : position2[1] > cy ? "top" : "bottom";
  }
  return {
    position: position2,
    align,
    verticalAlign
  };
}
var pointerShapeBuilder$1 = {
  line: function(axis, polar, coordValue, otherExtent) {
    return axis.dim === "angle" ? {
      type: "Line",
      shape: makeLineShape(polar.coordToPoint([otherExtent[0], coordValue]), polar.coordToPoint([otherExtent[1], coordValue]))
    } : {
      type: "Circle",
      shape: {
        cx: polar.cx,
        cy: polar.cy,
        r: coordValue
      }
    };
  },
  shadow: function(axis, polar, coordValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var radian = Math.PI / 180;
    return axis.dim === "angle" ? {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, otherExtent[0], otherExtent[1], (-coordValue - bandWidth / 2) * radian, (-coordValue + bandWidth / 2) * radian)
    } : {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, coordValue - bandWidth / 2, coordValue + bandWidth / 2, 0, Math.PI * 2)
    };
  }
};
var PolarAxisPointer$1 = PolarAxisPointer;
var PolarModel = function(_super) {
  __extends(PolarModel2, _super);
  function PolarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarModel2.type;
    return _this;
  }
  PolarModel2.prototype.findAxisModel = function(axisType) {
    var foundAxisModel;
    var ecModel = this.ecModel;
    ecModel.eachComponent(axisType, function(axisModel) {
      if (axisModel.getCoordSysModel() === this) {
        foundAxisModel = axisModel;
      }
    }, this);
    return foundAxisModel;
  };
  PolarModel2.type = "polar";
  PolarModel2.dependencies = ["radiusAxis", "angleAxis"];
  PolarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "80%"
  };
  return PolarModel2;
}(ComponentModel$1);
var PolarModel$1 = PolarModel;
var PolarAxisModel = function(_super) {
  __extends(PolarAxisModel2, _super);
  function PolarAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("polar", SINGLE_REFERRING).models[0];
  };
  PolarAxisModel2.type = "polarAxis";
  return PolarAxisModel2;
}(ComponentModel$1);
mixin(PolarAxisModel, AxisModelCommonMixin);
var AngleAxisModel = function(_super) {
  __extends(AngleAxisModel2, _super);
  function AngleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisModel2.type;
    return _this;
  }
  AngleAxisModel2.type = "angleAxis";
  return AngleAxisModel2;
}(PolarAxisModel);
var RadiusAxisModel = function(_super) {
  __extends(RadiusAxisModel2, _super);
  function RadiusAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisModel2.type;
    return _this;
  }
  RadiusAxisModel2.type = "radiusAxis";
  return RadiusAxisModel2;
}(PolarAxisModel);
var RadiusAxis = function(_super) {
  __extends(RadiusAxis2, _super);
  function RadiusAxis2(scale2, radiusExtent) {
    return _super.call(this, "radius", scale2, radiusExtent) || this;
  }
  RadiusAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  return RadiusAxis2;
}(Axis$1);
RadiusAxis.prototype.dataToRadius = Axis$1.prototype.dataToCoord;
RadiusAxis.prototype.radiusToData = Axis$1.prototype.coordToData;
var RadiusAxis$1 = RadiusAxis;
var inner$8 = makeInner();
var AngleAxis = function(_super) {
  __extends(AngleAxis2, _super);
  function AngleAxis2(scale2, angleExtent) {
    return _super.call(this, "angle", scale2, angleExtent || [0, 360]) || this;
  }
  AngleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  AngleAxis2.prototype.calculateCategoryInterval = function() {
    var axis = this;
    var labelModel = axis.getLabelModel();
    var ordinalScale = axis.scale;
    var ordinalExtent = ordinalScale.getExtent();
    var tickCount = ordinalScale.count();
    if (ordinalExtent[1] - ordinalExtent[0] < 1) {
      return 0;
    }
    var tickValue = ordinalExtent[0];
    var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
    var unitH = Math.abs(unitSpan);
    var rect = getBoundingRect(tickValue == null ? "" : tickValue + "", labelModel.getFont(), "center", "top");
    var maxH = Math.max(rect.height, 7);
    var dh2 = maxH / unitH;
    isNaN(dh2) && (dh2 = Infinity);
    var interval = Math.max(0, Math.floor(dh2));
    var cache = inner$8(axis.model);
    var lastAutoInterval = cache.lastAutoInterval;
    var lastTickCount = cache.lastTickCount;
    if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval) {
      interval = lastAutoInterval;
    } else {
      cache.lastTickCount = tickCount;
      cache.lastAutoInterval = interval;
    }
    return interval;
  };
  return AngleAxis2;
}(Axis$1);
AngleAxis.prototype.dataToAngle = Axis$1.prototype.dataToCoord;
AngleAxis.prototype.angleToData = Axis$1.prototype.coordToData;
var AngleAxis$1 = AngleAxis;
var polarDimensions = ["radius", "angle"];
var Polar = function() {
  function Polar2(name2) {
    this.dimensions = polarDimensions;
    this.type = "polar";
    this.cx = 0;
    this.cy = 0;
    this._radiusAxis = new RadiusAxis$1();
    this._angleAxis = new AngleAxis$1();
    this.axisPointerEnabled = true;
    this.name = name2 || "";
    this._radiusAxis.polar = this._angleAxis.polar = this;
  }
  Polar2.prototype.containPoint = function(point) {
    var coord = this.pointToCoord(point);
    return this._radiusAxis.contain(coord[0]) && this._angleAxis.contain(coord[1]);
  };
  Polar2.prototype.containData = function(data2) {
    return this._radiusAxis.containData(data2[0]) && this._angleAxis.containData(data2[1]);
  };
  Polar2.prototype.getAxis = function(dim) {
    var key = "_" + dim + "Axis";
    return this[key];
  };
  Polar2.prototype.getAxes = function() {
    return [this._radiusAxis, this._angleAxis];
  };
  Polar2.prototype.getAxesByScale = function(scaleType) {
    var axes = [];
    var angleAxis = this._angleAxis;
    var radiusAxis = this._radiusAxis;
    angleAxis.scale.type === scaleType && axes.push(angleAxis);
    radiusAxis.scale.type === scaleType && axes.push(radiusAxis);
    return axes;
  };
  Polar2.prototype.getAngleAxis = function() {
    return this._angleAxis;
  };
  Polar2.prototype.getRadiusAxis = function() {
    return this._radiusAxis;
  };
  Polar2.prototype.getOtherAxis = function(axis) {
    var angleAxis = this._angleAxis;
    return axis === angleAxis ? this._radiusAxis : angleAxis;
  };
  Polar2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
  };
  Polar2.prototype.getTooltipAxes = function(dim) {
    var baseAxis = dim != null && dim !== "auto" ? this.getAxis(dim) : this.getBaseAxis();
    return {
      baseAxes: [baseAxis],
      otherAxes: [this.getOtherAxis(baseAxis)]
    };
  };
  Polar2.prototype.dataToPoint = function(data2, clamp2) {
    return this.coordToPoint([this._radiusAxis.dataToRadius(data2[0], clamp2), this._angleAxis.dataToAngle(data2[1], clamp2)]);
  };
  Polar2.prototype.pointToData = function(point, clamp2) {
    var coord = this.pointToCoord(point);
    return [this._radiusAxis.radiusToData(coord[0], clamp2), this._angleAxis.angleToData(coord[1], clamp2)];
  };
  Polar2.prototype.pointToCoord = function(point) {
    var dx = point[0] - this.cx;
    var dy = point[1] - this.cy;
    var angleAxis = this.getAngleAxis();
    var extent3 = angleAxis.getExtent();
    var minAngle = Math.min(extent3[0], extent3[1]);
    var maxAngle = Math.max(extent3[0], extent3[1]);
    angleAxis.inverse ? minAngle = maxAngle - 360 : maxAngle = minAngle + 360;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx) / Math.PI * 180;
    var dir3 = radian < minAngle ? 1 : -1;
    while (radian < minAngle || radian > maxAngle) {
      radian += dir3 * 360;
    }
    return [radius, radian];
  };
  Polar2.prototype.coordToPoint = function(coord) {
    var radius = coord[0];
    var radian = coord[1] / 180 * Math.PI;
    var x2 = Math.cos(radian) * radius + this.cx;
    var y2 = -Math.sin(radian) * radius + this.cy;
    return [x2, y2];
  };
  Polar2.prototype.getArea = function() {
    var angleAxis = this.getAngleAxis();
    var radiusAxis = this.getRadiusAxis();
    var radiusExtent = radiusAxis.getExtent().slice();
    radiusExtent[0] > radiusExtent[1] && radiusExtent.reverse();
    var angleExtent = angleAxis.getExtent();
    var RADIAN2 = Math.PI / 180;
    return {
      cx: this.cx,
      cy: this.cy,
      r0: radiusExtent[0],
      r: radiusExtent[1],
      startAngle: -angleExtent[0] * RADIAN2,
      endAngle: -angleExtent[1] * RADIAN2,
      clockwise: angleAxis.inverse,
      contain: function(x2, y2) {
        var dx = x2 - this.cx;
        var dy = y2 - this.cy;
        var d2 = dx * dx + dy * dy - 1e-4;
        var r2 = this.r;
        var r0 = this.r0;
        return d2 <= r2 * r2 && d2 >= r0 * r0;
      }
    };
  };
  Polar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Polar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Polar2;
}();
function getCoordSys$2(finder) {
  var seriesModel = finder.seriesModel;
  var polarModel = finder.polarModel;
  return polarModel && polarModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
var Polar$1 = Polar;
function resizePolar(polar, polarModel, api) {
  var center2 = polarModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  polar.cx = parsePercent(center2[0], width);
  polar.cy = parsePercent(center2[1], height);
  var radiusAxis = polar.getRadiusAxis();
  var size = Math.min(width, height) / 2;
  var radius = polarModel.get("radius");
  if (radius == null) {
    radius = [0, "100%"];
  } else if (!isArray$2(radius)) {
    radius = [0, radius];
  }
  var parsedRadius = [parsePercent(radius[0], size), parsePercent(radius[1], size)];
  radiusAxis.inverse ? radiusAxis.setExtent(parsedRadius[1], parsedRadius[0]) : radiusAxis.setExtent(parsedRadius[0], parsedRadius[1]);
}
function updatePolarScale(ecModel, api) {
  var polar = this;
  var angleAxis = polar.getAngleAxis();
  var radiusAxis = polar.getRadiusAxis();
  angleAxis.scale.setExtent(Infinity, -Infinity);
  radiusAxis.scale.setExtent(Infinity, -Infinity);
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.coordinateSystem === polar) {
      var data_1 = seriesModel.getData();
      each$g(getDataDimensionsOnAxis(data_1, "radius"), function(dim) {
        radiusAxis.scale.unionExtentFromData(data_1, dim);
      });
      each$g(getDataDimensionsOnAxis(data_1, "angle"), function(dim) {
        angleAxis.scale.unionExtentFromData(data_1, dim);
      });
    }
  });
  niceScaleExtent(angleAxis.scale, angleAxis.model);
  niceScaleExtent(radiusAxis.scale, radiusAxis.model);
  if (angleAxis.type === "category" && !angleAxis.onBand) {
    var extent3 = angleAxis.getExtent();
    var diff = 360 / angleAxis.scale.count();
    angleAxis.inverse ? extent3[1] += diff : extent3[1] -= diff;
    angleAxis.setExtent(extent3[0], extent3[1]);
  }
}
function isAngleAxisModel(axisModel) {
  return axisModel.mainType === "angleAxis";
}
function setAxis(axis, axisModel) {
  axis.type = axisModel.get("type");
  axis.scale = createScaleByModel$1(axisModel);
  axis.onBand = axisModel.get("boundaryGap") && axis.type === "category";
  axis.inverse = axisModel.get("inverse");
  if (isAngleAxisModel(axisModel)) {
    axis.inverse = axis.inverse !== axisModel.get("clockwise");
    var startAngle = axisModel.get("startAngle");
    axis.setExtent(startAngle, startAngle + (axis.inverse ? -360 : 360));
  }
  axisModel.axis = axis;
  axis.model = axisModel;
}
var polarCreator = {
  dimensions: polarDimensions,
  create: function(ecModel, api) {
    var polarList = [];
    ecModel.eachComponent("polar", function(polarModel, idx) {
      var polar = new Polar$1(idx + "");
      polar.update = updatePolarScale;
      var radiusAxis = polar.getRadiusAxis();
      var angleAxis = polar.getAngleAxis();
      var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
      var angleAxisModel = polarModel.findAxisModel("angleAxis");
      setAxis(radiusAxis, radiusAxisModel);
      setAxis(angleAxis, angleAxisModel);
      resizePolar(polar, polarModel, api);
      polarList.push(polar);
      polarModel.coordinateSystem = polar;
      polar.model = polarModel;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.get("coordinateSystem") === "polar") {
        var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
        seriesModel.coordinateSystem = polarModel.coordinateSystem;
      }
    });
    return polarList;
  }
};
var polarCreator$1 = polarCreator;
var elementList = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function getAxisLineShape(polar, rExtent, angle) {
  rExtent[1] > rExtent[0] && (rExtent = rExtent.slice().reverse());
  var start2 = polar.coordToPoint([rExtent[0], angle]);
  var end2 = polar.coordToPoint([rExtent[1], angle]);
  return {
    x1: start2[0],
    y1: start2[1],
    x2: end2[0],
    y2: end2[1]
  };
}
function getRadiusIdx(polar) {
  var radiusAxis = polar.getRadiusAxis();
  return radiusAxis.inverse ? 0 : 1;
}
function fixAngleOverlap(list) {
  var firstItem = list[0];
  var lastItem = list[list.length - 1];
  if (firstItem && lastItem && Math.abs(Math.abs(firstItem.coord - lastItem.coord) - 360) < 1e-4) {
    list.pop();
  }
}
var AngleAxisView = function(_super) {
  __extends(AngleAxisView2, _super);
  function AngleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  AngleAxisView2.prototype.render = function(angleAxisModel, ecModel) {
    this.group.removeAll();
    if (!angleAxisModel.get("show")) {
      return;
    }
    var angleAxis = angleAxisModel.axis;
    var polar = angleAxis.polar;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var ticksAngles = angleAxis.getTicksCoords();
    var minorTickAngles = angleAxis.getMinorTicksCoords();
    var labels = map$1(angleAxis.getViewLabels(), function(labelItem) {
      labelItem = clone$4(labelItem);
      var scale2 = angleAxis.scale;
      var tickValue = scale2.type === "ordinal" ? scale2.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
      labelItem.coord = angleAxis.dataToCoord(tickValue);
      return labelItem;
    });
    fixAngleOverlap(labels);
    fixAngleOverlap(ticksAngles);
    each$g(elementList, function(name2) {
      if (angleAxisModel.get([name2, "show"]) && (!angleAxis.scale.isBlank() || name2 === "axisLine")) {
        angelAxisElementsBuilders[name2](this.group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels);
      }
    }, this);
  };
  AngleAxisView2.type = "angleAxis";
  return AngleAxisView2;
}(AxisView$1);
var angelAxisElementsBuilders = {
  axisLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var lineStyleModel = angleAxisModel.getModel(["axisLine", "lineStyle"]);
    var rId = getRadiusIdx(polar);
    var r0Id = rId ? 0 : 1;
    var shape;
    if (radiusExtent[r0Id] === 0) {
      shape = new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    } else {
      shape = new Ring$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId],
          r0: radiusExtent[r0Id]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    }
    shape.style.fill = null;
    group.add(shape);
  },
  axisTick: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var tickModel = angleAxisModel.getModel("axisTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * tickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = map$1(ticksAngles, function(tickAngleItem) {
      return new Line$3({
        shape: getAxisLineShape(polar, [radius, radius + tickLen], tickAngleItem.coord)
      });
    });
    group.add(mergePath(lines, {
      style: defaults(tickModel.getModel("lineStyle").getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(group, angleAxisModel, polar, tickAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var tickModel = angleAxisModel.getModel("axisTick");
    var minorTickModel = angleAxisModel.getModel("minorTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * minorTickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, [radius, radius + tickLen], minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults(minorTickModel.getModel("lineStyle").getLineStyle(), defaults(tickModel.getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      }))
    }));
  },
  axisLabel: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels) {
    var rawCategoryData = angleAxisModel.getCategories(true);
    var commonLabelModel = angleAxisModel.getModel("axisLabel");
    var labelMargin = commonLabelModel.get("margin");
    var triggerEvent = angleAxisModel.get("triggerEvent");
    each$g(labels, function(labelItem, idx) {
      var labelModel = commonLabelModel;
      var tickValue = labelItem.tickValue;
      var r2 = radiusExtent[getRadiusIdx(polar)];
      var p2 = polar.coordToPoint([r2 + labelMargin, labelItem.coord]);
      var cx = polar.cx;
      var cy = polar.cy;
      var labelTextAlign = Math.abs(p2[0] - cx) / r2 < 0.3 ? "center" : p2[0] > cx ? "left" : "right";
      var labelTextVerticalAlign = Math.abs(p2[1] - cy) / r2 < 0.3 ? "middle" : p2[1] > cy ? "top" : "bottom";
      if (rawCategoryData && rawCategoryData[tickValue]) {
        var rawCategoryItem = rawCategoryData[tickValue];
        if (isObject$6(rawCategoryItem) && rawCategoryItem.textStyle) {
          labelModel = new Model$1(rawCategoryItem.textStyle, commonLabelModel, commonLabelModel.ecModel);
        }
      }
      var textEl = new ZRText$1({
        silent: AxisBuilder$1.isLabelSilent(angleAxisModel),
        style: createTextStyle(labelModel, {
          x: p2[0],
          y: p2[1],
          fill: labelModel.getTextColor() || angleAxisModel.get(["axisLine", "lineStyle", "color"]),
          text: labelItem.formattedLabel,
          align: labelTextAlign,
          verticalAlign: labelTextVerticalAlign
        })
      });
      group.add(textEl);
      if (triggerEvent) {
        var eventData = AxisBuilder$1.makeAxisEventDataBase(angleAxisModel);
        eventData.targetType = "axisLabel";
        eventData.value = labelItem.rawLabel;
        getECData(textEl).eventData = eventData;
      }
    }, this);
  },
  splitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var splitLineModel = angleAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksAngles.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        shape: getAxisLineShape(polar, radiusExtent, ticksAngles[i].coord)
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyleModel.getLineStyle()),
        silent: true,
        z: angleAxisModel.get("z")
      }));
    }
  },
  minorSplitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var minorSplitLineModel = angleAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, radiusExtent, minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: lineStyleModel.getLineStyle(),
      silent: true,
      z: angleAxisModel.get("z")
    }));
  },
  splitArea: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!ticksAngles.length) {
      return;
    }
    var splitAreaModel = angleAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var RADIAN2 = Math.PI / 180;
    var prevAngle = -ticksAngles[0].coord * RADIAN2;
    var r0 = Math.min(radiusExtent[0], radiusExtent[1]);
    var r1 = Math.max(radiusExtent[0], radiusExtent[1]);
    var clockwise = angleAxisModel.get("clockwise");
    for (var i = 1, len2 = ticksAngles.length; i <= len2; i++) {
      var coord = i === len2 ? ticksAngles[0].coord : ticksAngles[i].coord;
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0,
          r: r1,
          startAngle: prevAngle,
          endAngle: -coord * RADIAN2,
          clockwise
        },
        silent: true
      }));
      prevAngle = -coord * RADIAN2;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
var AngleAxisView$1 = AngleAxisView;
var axisBuilderAttrs$1 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$1 = ["splitLine", "splitArea", "minorSplitLine"];
var RadiusAxisView = function(_super) {
  __extends(RadiusAxisView2, _super);
  function RadiusAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  RadiusAxisView2.prototype.render = function(radiusAxisModel, ecModel) {
    this.group.removeAll();
    if (!radiusAxisModel.get("show")) {
      return;
    }
    var oldAxisGroup = this._axisGroup;
    var newAxisGroup = this._axisGroup = new Group$6();
    this.group.add(newAxisGroup);
    var radiusAxis = radiusAxisModel.axis;
    var polar = radiusAxis.polar;
    var angleAxis = polar.getAngleAxis();
    var ticksCoords = radiusAxis.getTicksCoords();
    var minorTicksCoords = radiusAxis.getMinorTicksCoords();
    var axisAngle = angleAxis.getExtent()[0];
    var radiusExtent = radiusAxis.getExtent();
    var layout2 = layoutAxis(polar, radiusAxisModel, axisAngle);
    var axisBuilder = new AxisBuilder$1(radiusAxisModel, layout2);
    each$g(axisBuilderAttrs$1, axisBuilder.add, axisBuilder);
    newAxisGroup.add(axisBuilder.getGroup());
    groupTransition(oldAxisGroup, newAxisGroup, radiusAxisModel);
    each$g(selfBuilderAttrs$1, function(name2) {
      if (radiusAxisModel.get([name2, "show"]) && !radiusAxis.scale.isBlank()) {
        axisElementBuilders$1[name2](this.group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords);
      }
    }, this);
  };
  RadiusAxisView2.type = "radiusAxis";
  return RadiusAxisView2;
}(AxisView$1);
var axisElementBuilders$1 = {
  splitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    var splitLineModel = radiusAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: ticksCoords[i].coord
        }
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length],
          fill: null
        }, lineStyleModel.getLineStyle()),
        silent: true
      }));
    }
  },
  minorSplitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords) {
    if (!minorTicksCoords.length) {
      return;
    }
    var minorSplitLineModel = radiusAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        lines.push(new Circle$1({
          shape: {
            cx: polar.cx,
            cy: polar.cy,
            r: minorTicksCoords[i][k2].coord
          }
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults({
        fill: null
      }, lineStyleModel.getLineStyle()),
      silent: true
    }));
  },
  splitArea: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    if (!ticksCoords.length) {
      return;
    }
    var splitAreaModel = radiusAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var prevRadius = ticksCoords[0].coord;
    for (var i = 1; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0: prevRadius,
          r: ticksCoords[i].coord,
          startAngle: 0,
          endAngle: Math.PI * 2
        },
        silent: true
      }));
      prevRadius = ticksCoords[i].coord;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
function layoutAxis(polar, radiusAxisModel, axisAngle) {
  return {
    position: [polar.cx, polar.cy],
    rotation: axisAngle / 180 * Math.PI,
    labelDirection: -1,
    tickDirection: -1,
    nameDirection: 1,
    labelRotate: radiusAxisModel.getModel("axisLabel").get("rotate"),
    z2: 1
  };
}
var RadiusAxisView$1 = RadiusAxisView;
function getSeriesStackId(seriesModel) {
  return seriesModel.get("stack") || "__ec_stack_" + seriesModel.seriesIndex;
}
function getAxisKey(polar, axis) {
  return axis.dim + polar.model.componentIndex;
}
function barLayoutPolar(seriesType2, ecModel, api) {
  var lastStackCoords = {};
  var barWidthAndOffset = calRadialBar(filter(ecModel.getSeriesByType(seriesType2), function(seriesModel) {
    return !ecModel.isSeriesFiltered(seriesModel) && seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "polar";
  }));
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (seriesModel.coordinateSystem.type !== "polar") {
      return;
    }
    var data2 = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var stackId = getSeriesStackId(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[axisKey][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    var valueAxis2 = polar.getOtherAxis(baseAxis);
    var cx = seriesModel.coordinateSystem.cx;
    var cy = seriesModel.coordinateSystem.cy;
    var barMinHeight = seriesModel.get("barMinHeight") || 0;
    var barMinAngle = seriesModel.get("barMinAngle") || 0;
    lastStackCoords[stackId] = lastStackCoords[stackId] || [];
    var valueDim = data2.mapDimension(valueAxis2.dim);
    var baseDim = data2.mapDimension(baseAxis.dim);
    var stacked = isDimensionStacked(data2, valueDim);
    var clampLayout = baseAxis.dim !== "radius" || !seriesModel.get("roundCap", true);
    var valueAxisStart = valueAxis2.dataToCoord(0);
    for (var idx = 0, len2 = data2.count(); idx < len2; idx++) {
      var value = data2.get(valueDim, idx);
      var baseValue = data2.get(baseDim, idx);
      var sign = value >= 0 ? "p" : "n";
      var baseCoord = valueAxisStart;
      if (stacked) {
        if (!lastStackCoords[stackId][baseValue]) {
          lastStackCoords[stackId][baseValue] = {
            p: valueAxisStart,
            n: valueAxisStart
          };
        }
        baseCoord = lastStackCoords[stackId][baseValue][sign];
      }
      var r0 = void 0;
      var r2 = void 0;
      var startAngle = void 0;
      var endAngle = void 0;
      if (valueAxis2.dim === "radius") {
        var radiusSpan = valueAxis2.dataToCoord(value) - valueAxisStart;
        var angle = baseAxis.dataToCoord(baseValue);
        if (Math.abs(radiusSpan) < barMinHeight) {
          radiusSpan = (radiusSpan < 0 ? -1 : 1) * barMinHeight;
        }
        r0 = baseCoord;
        r2 = baseCoord + radiusSpan;
        startAngle = angle - columnOffset;
        endAngle = startAngle - columnWidth;
        stacked && (lastStackCoords[stackId][baseValue][sign] = r2);
      } else {
        var angleSpan = valueAxis2.dataToCoord(value, clampLayout) - valueAxisStart;
        var radius = baseAxis.dataToCoord(baseValue);
        if (Math.abs(angleSpan) < barMinAngle) {
          angleSpan = (angleSpan < 0 ? -1 : 1) * barMinAngle;
        }
        r0 = radius + columnOffset;
        r2 = r0 + columnWidth;
        startAngle = baseCoord;
        endAngle = baseCoord + angleSpan;
        stacked && (lastStackCoords[stackId][baseValue][sign] = endAngle);
      }
      data2.setItemLayout(idx, {
        cx,
        cy,
        r0,
        r: r2,
        startAngle: -startAngle * Math.PI / 180,
        endAngle: -endAngle * Math.PI / 180,
        clockwise: startAngle >= endAngle
      });
    }
  });
}
function calRadialBar(barSeries) {
  var columnsMap = {};
  each$g(barSeries, function(seriesModel, idx) {
    var data2 = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var axisExtent = baseAxis.getExtent();
    var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : Math.abs(axisExtent[1] - axisExtent[0]) / data2.count();
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: "20%",
      gap: "30%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = getSeriesStackId(seriesModel);
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    if (barWidth && !stacks[stackId].width) {
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      stacks[stackId].width = barWidth;
      columnsOnAxis.remainedWidth -= barWidth;
    }
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    barGap != null && (columnsOnAxis.gap = barGap);
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$g(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGap = parsePercent(columnsOnAxis.categoryGap, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$g(stacks, function(column, stack) {
      var maxWidth = column.maxWidth;
      if (maxWidth && maxWidth < autoWidth) {
        maxWidth = Math.min(maxWidth, remainedWidth);
        if (column.width) {
          maxWidth = Math.min(maxWidth, column.width);
        }
        remainedWidth -= maxWidth;
        column.width = maxWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$g(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset3 = -widthSum / 2;
    each$g(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        offset: offset3,
        width: column.width
      };
      offset3 += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
var angleAxisExtraOption = {
  startAngle: 90,
  clockwise: true,
  splitNumber: 12,
  axisLabel: {
    rotate: 0
  }
};
var radiusAxisExtraOption = {
  splitNumber: 5
};
var PolarView = function(_super) {
  __extends(PolarView2, _super);
  function PolarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarView2.type;
    return _this;
  }
  PolarView2.type = "polar";
  return PolarView2;
}(ComponentView$1);
function install$o(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("PolarAxisPointer", PolarAxisPointer$1);
  registers.registerCoordinateSystem("polar", polarCreator$1);
  registers.registerComponentModel(PolarModel$1);
  registers.registerComponentView(PolarView);
  axisModelCreator(registers, "angle", AngleAxisModel, angleAxisExtraOption);
  axisModelCreator(registers, "radius", RadiusAxisModel, radiusAxisExtraOption);
  registers.registerComponentView(AngleAxisView$1);
  registers.registerComponentView(RadiusAxisView$1);
  registers.registerLayout(curry$3(barLayoutPolar, "bar"));
}
function layout$1(axisModel, opt) {
  opt = opt || {};
  var single = axisModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var axisPosition = axis.position;
  var orient = axis.orient;
  var rect = single.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var positionMap = {
    horizontal: {
      top: rectBound[2],
      bottom: rectBound[3]
    },
    vertical: {
      left: rectBound[0],
      right: rectBound[1]
    }
  };
  layout2.position = [orient === "vertical" ? positionMap.vertical[axisPosition] : rectBound[0], orient === "horizontal" ? positionMap.horizontal[axisPosition] : rectBound[3]];
  var r2 = {
    horizontal: 0,
    vertical: 1
  };
  layout2.rotation = Math.PI / 2 * r2[orient];
  var directionMap = {
    top: -1,
    bottom: 1,
    right: 1,
    left: -1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = directionMap[axisPosition];
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotation = opt.rotate;
  labelRotation == null && (labelRotation = axisModel.get(["axisLabel", "rotate"]));
  layout2.labelRotation = axisPosition === "top" ? -labelRotation : labelRotation;
  layout2.z2 = 1;
  return layout2;
}
var axisBuilderAttrs = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs = ["splitArea", "splitLine"];
var SingleAxisView = function(_super) {
  __extends(SingleAxisView2, _super);
  function SingleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisView2.type;
    _this.axisPointerClass = "SingleAxisPointer";
    return _this;
  }
  SingleAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    var layout2 = layout$1(axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, layout2);
    each$g(axisBuilderAttrs, axisBuilder.add, axisBuilder);
    group.add(this._axisGroup);
    group.add(axisBuilder.getGroup());
    each$g(selfBuilderAttrs, function(name2) {
      if (axisModel.get([name2, "show"])) {
        axisElementBuilders[name2](this, this.group, this._axisGroup, axisModel);
      }
    }, this);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  SingleAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  SingleAxisView2.type = "singleAxis";
  return SingleAxisView2;
}(AxisView$1);
var axisElementBuilders = {
  splitLine: function(axisView, group, axisGroup, axisModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var gridRect = axisModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var splitLines = [];
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    for (var i = 0; i < ticksCoords.length; ++i) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        subPixelOptimize: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        silent: true
      }));
    }
    var lineStyle = lineStyleModel.getLineStyle(["color"]);
    for (var i = 0; i < splitLines.length; ++i) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyle),
        silent: true
      }));
    }
  },
  splitArea: function(axisView, group, axisGroup, axisModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, axisModel);
  }
};
var SingleAxisView$1 = SingleAxisView;
var SingleAxisModel = function(_super) {
  __extends(SingleAxisModel2, _super);
  function SingleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisModel2.type;
    return _this;
  }
  SingleAxisModel2.prototype.getCoordSysModel = function() {
    return this;
  };
  SingleAxisModel2.type = "singleAxis";
  SingleAxisModel2.layoutMode = "box";
  SingleAxisModel2.defaultOption = {
    left: "5%",
    top: "5%",
    right: "5%",
    bottom: "5%",
    type: "value",
    position: "bottom",
    orient: "horizontal",
    axisLine: {
      show: true,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    tooltip: {
      show: true
    },
    axisTick: {
      show: true,
      length: 6,
      lineStyle: {
        width: 1
      }
    },
    axisLabel: {
      show: true,
      interval: "auto"
    },
    splitLine: {
      show: true,
      lineStyle: {
        type: "dashed",
        opacity: 0.2
      }
    }
  };
  return SingleAxisModel2;
}(ComponentModel$1);
mixin(SingleAxisModel, AxisModelCommonMixin.prototype);
var SingleAxisModel$1 = SingleAxisModel;
var SingleAxis = function(_super) {
  __extends(SingleAxis2, _super);
  function SingleAxis2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  SingleAxis2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  SingleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.coordinateSystem.pointToData(point)[0];
  };
  return SingleAxis2;
}(Axis$1);
var SingleAxis$1 = SingleAxis;
var singleDimensions = ["single"];
var Single = function() {
  function Single2(axisModel, ecModel, api) {
    this.type = "single";
    this.dimension = "single";
    this.dimensions = singleDimensions;
    this.axisPointerEnabled = true;
    this.model = axisModel;
    this._init(axisModel, ecModel, api);
  }
  Single2.prototype._init = function(axisModel, ecModel, api) {
    var dim = this.dimension;
    var axis = new SingleAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisModel.get("position"));
    var isCategory2 = axis.type === "category";
    axis.onBand = isCategory2 && axisModel.get("boundaryGap");
    axis.inverse = axisModel.get("inverse");
    axis.orient = axisModel.get("orient");
    axisModel.axis = axis;
    axis.model = axisModel;
    axis.coordinateSystem = this;
    this._axis = axis;
  };
  Single2.prototype.update = function(ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.coordinateSystem === this) {
        var data_1 = seriesModel.getData();
        each$g(data_1.mapDimensionsAll(this.dimension), function(dim) {
          this._axis.scale.unionExtentFromData(data_1, dim);
        }, this);
        niceScaleExtent(this._axis.scale, this._axis.model);
      }
    }, this);
  };
  Single2.prototype.resize = function(axisModel, api) {
    this._rect = getLayoutRect({
      left: axisModel.get("left"),
      top: axisModel.get("top"),
      right: axisModel.get("right"),
      bottom: axisModel.get("bottom"),
      width: axisModel.get("width"),
      height: axisModel.get("height")
    }, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._adjustAxis();
  };
  Single2.prototype.getRect = function() {
    return this._rect;
  };
  Single2.prototype._adjustAxis = function() {
    var rect = this._rect;
    var axis = this._axis;
    var isHorizontal = axis.isHorizontal();
    var extent3 = isHorizontal ? [0, rect.width] : [0, rect.height];
    var idx = axis.reverse ? 1 : 0;
    axis.setExtent(extent3[idx], extent3[1 - idx]);
    this._updateAxisTransform(axis, isHorizontal ? rect.x : rect.y);
  };
  Single2.prototype._updateAxisTransform = function(axis, coordBase) {
    var axisExtent = axis.getExtent();
    var extentSum = axisExtent[0] + axisExtent[1];
    var isHorizontal = axis.isHorizontal();
    axis.toGlobalCoord = isHorizontal ? function(coord) {
      return coord + coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
    axis.toLocalCoord = isHorizontal ? function(coord) {
      return coord - coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
  };
  Single2.prototype.getAxis = function() {
    return this._axis;
  };
  Single2.prototype.getBaseAxis = function() {
    return this._axis;
  };
  Single2.prototype.getAxes = function() {
    return [this._axis];
  };
  Single2.prototype.getTooltipAxes = function() {
    return {
      baseAxes: [this.getAxis()],
      otherAxes: []
    };
  };
  Single2.prototype.containPoint = function(point) {
    var rect = this.getRect();
    var axis = this.getAxis();
    var orient = axis.orient;
    if (orient === "horizontal") {
      return axis.contain(axis.toLocalCoord(point[0])) && point[1] >= rect.y && point[1] <= rect.y + rect.height;
    } else {
      return axis.contain(axis.toLocalCoord(point[1])) && point[0] >= rect.y && point[0] <= rect.y + rect.height;
    }
  };
  Single2.prototype.pointToData = function(point) {
    var axis = this.getAxis();
    return [axis.coordToData(axis.toLocalCoord(point[axis.orient === "horizontal" ? 0 : 1]))];
  };
  Single2.prototype.dataToPoint = function(val) {
    var axis = this.getAxis();
    var rect = this.getRect();
    var pt = [];
    var idx = axis.orient === "horizontal" ? 0 : 1;
    if (val instanceof Array) {
      val = val[0];
    }
    pt[idx] = axis.toGlobalCoord(axis.dataToCoord(+val));
    pt[1 - idx] = idx === 0 ? rect.y + rect.height / 2 : rect.x + rect.width / 2;
    return pt;
  };
  Single2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Single2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Single2;
}();
function getCoordSys$1(finder) {
  var seriesModel = finder.seriesModel;
  var singleModel = finder.singleAxisModel;
  return singleModel && singleModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
function create$1(ecModel, api) {
  var singles = [];
  ecModel.eachComponent("singleAxis", function(axisModel, idx) {
    var single = new Single(axisModel, ecModel, api);
    single.name = "single_" + idx;
    single.resize(axisModel, api);
    axisModel.coordinateSystem = single;
    singles.push(single);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "singleAxis") {
      var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = singleAxisModel && singleAxisModel.coordinateSystem;
    }
  });
  return singles;
}
var singleCreator = {
  create: create$1,
  dimensions: singleDimensions
};
var singleCreator$1 = singleCreator;
var XY$1 = ["x", "y"];
var WH$1 = ["width", "height"];
var SingleAxisPointer = function(_super) {
  __extends(SingleAxisPointer2, _super);
  function SingleAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SingleAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var otherExtent = getGlobalExtent(coordSys, 1 - getPointDimIndex(axis));
    var pixelValue = coordSys.dataToPoint(value)[0];
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$1(axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  SingleAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$1(axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var position2 = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: position2[0],
      y: position2[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  SingleAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var dimIndex = getPointDimIndex(axis);
    var axisExtent = getGlobalExtent(coordSys, dimIndex);
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var otherExtent = getGlobalExtent(coordSys, 1 - dimIndex);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: {
        verticalAlign: "middle"
      }
    };
  };
  return SingleAxisPointer2;
}(BaseAxisPointer$1);
var pointerShapeBuilder = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getPointDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = axis.getBandWidth();
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getPointDimIndex(axis))
    };
  }
};
function getPointDimIndex(axis) {
  return axis.isHorizontal() ? 0 : 1;
}
function getGlobalExtent(coordSys, dimIndex) {
  var rect = coordSys.getRect();
  return [rect[XY$1[dimIndex]], rect[XY$1[dimIndex]] + rect[WH$1[dimIndex]]];
}
var SingleAxisPointer$1 = SingleAxisPointer;
var SingleView = function(_super) {
  __extends(SingleView2, _super);
  function SingleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleView2.type;
    return _this;
  }
  SingleView2.type = "single";
  return SingleView2;
}(ComponentView$1);
function install$n(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("SingleAxisPointer", SingleAxisPointer$1);
  registers.registerComponentView(SingleView);
  registers.registerComponentView(SingleAxisView$1);
  registers.registerComponentModel(SingleAxisModel$1);
  axisModelCreator(registers, "single", SingleAxisModel$1, SingleAxisModel$1.defaultOption);
  registers.registerCoordinateSystem("single", singleCreator$1);
}
var CalendarModel = function(_super) {
  __extends(CalendarModel2, _super);
  function CalendarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarModel2.type;
    return _this;
  }
  CalendarModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(option, inputPositionParams);
  };
  CalendarModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(this.option, option);
  };
  CalendarModel2.prototype.getCellSize = function() {
    return this.option.cellSize;
  };
  CalendarModel2.type = "calendar";
  CalendarModel2.defaultOption = {
    z: 2,
    left: 80,
    top: 60,
    cellSize: 20,
    orient: "horizontal",
    splitLine: {
      show: true,
      lineStyle: {
        color: "#000",
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      color: "#fff",
      borderWidth: 1,
      borderColor: "#ccc"
    },
    dayLabel: {
      show: true,
      firstDay: 0,
      position: "start",
      margin: "50%",
      color: "#000"
    },
    monthLabel: {
      show: true,
      position: "start",
      margin: 5,
      align: "center",
      formatter: null,
      color: "#000"
    },
    yearLabel: {
      show: true,
      position: null,
      margin: 30,
      formatter: null,
      color: "#ccc",
      fontFamily: "sans-serif",
      fontWeight: "bolder",
      fontSize: 20
    }
  };
  return CalendarModel2;
}(ComponentModel$1);
function mergeAndNormalizeLayoutParams$1(target, raw) {
  var cellSize = target.cellSize;
  var cellSizeArr;
  if (!isArray$2(cellSize)) {
    cellSizeArr = target.cellSize = [cellSize, cellSize];
  } else {
    cellSizeArr = cellSize;
  }
  if (cellSizeArr.length === 1) {
    cellSizeArr[1] = cellSizeArr[0];
  }
  var ignoreSize = map$1([0, 1], function(hvIdx) {
    if (sizeCalculable(raw, hvIdx)) {
      cellSizeArr[hvIdx] = "auto";
    }
    return cellSizeArr[hvIdx] != null && cellSizeArr[hvIdx] !== "auto";
  });
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize
  });
}
var CalendarModel$1 = CalendarModel;
var CalendarView = function(_super) {
  __extends(CalendarView2, _super);
  function CalendarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarView2.type;
    return _this;
  }
  CalendarView2.prototype.render = function(calendarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    var coordSys = calendarModel.coordinateSystem;
    var rangeData = coordSys.getRangeInfo();
    var orient = coordSys.getOrient();
    var localeModel = ecModel.getLocaleModel();
    this._renderDayRect(calendarModel, rangeData, group);
    this._renderLines(calendarModel, rangeData, orient, group);
    this._renderYearText(calendarModel, rangeData, orient, group);
    this._renderMonthText(calendarModel, localeModel, orient, group);
    this._renderWeekText(calendarModel, localeModel, rangeData, orient, group);
  };
  CalendarView2.prototype._renderDayRect = function(calendarModel, rangeData, group) {
    var coordSys = calendarModel.coordinateSystem;
    var itemRectStyleModel = calendarModel.getModel("itemStyle").getItemStyle();
    var sw = coordSys.getCellWidth();
    var sh2 = coordSys.getCellHeight();
    for (var i = rangeData.start.time; i <= rangeData.end.time; i = coordSys.getNextNDay(i, 1).time) {
      var point = coordSys.dataToRect([i], false).tl;
      var rect = new Rect$3({
        shape: {
          x: point[0],
          y: point[1],
          width: sw,
          height: sh2
        },
        cursor: "default",
        style: itemRectStyleModel
      });
      group.add(rect);
    }
  };
  CalendarView2.prototype._renderLines = function(calendarModel, rangeData, orient, group) {
    var self2 = this;
    var coordSys = calendarModel.coordinateSystem;
    var lineStyleModel = calendarModel.getModel(["splitLine", "lineStyle"]).getLineStyle();
    var show = calendarModel.get(["splitLine", "show"]);
    var lineWidth = lineStyleModel.lineWidth;
    this._tlpoints = [];
    this._blpoints = [];
    this._firstDayOfMonth = [];
    this._firstDayPoints = [];
    var firstDay = rangeData.start;
    for (var i = 0; firstDay.time <= rangeData.end.time; i++) {
      addPoints(firstDay.formatedDate);
      if (i === 0) {
        firstDay = coordSys.getDateInfo(rangeData.start.y + "-" + rangeData.start.m);
      }
      var date4 = firstDay.date;
      date4.setMonth(date4.getMonth() + 1);
      firstDay = coordSys.getDateInfo(date4);
    }
    addPoints(coordSys.getNextNDay(rangeData.end.time, 1).formatedDate);
    function addPoints(date5) {
      self2._firstDayOfMonth.push(coordSys.getDateInfo(date5));
      self2._firstDayPoints.push(coordSys.dataToRect([date5], false).tl);
      var points2 = self2._getLinePointsOfOneWeek(calendarModel, date5, orient);
      self2._tlpoints.push(points2[0]);
      self2._blpoints.push(points2[points2.length - 1]);
      show && self2._drawSplitline(points2, lineStyleModel, group);
    }
    show && this._drawSplitline(self2._getEdgesPoints(self2._tlpoints, lineWidth, orient), lineStyleModel, group);
    show && this._drawSplitline(self2._getEdgesPoints(self2._blpoints, lineWidth, orient), lineStyleModel, group);
  };
  CalendarView2.prototype._getEdgesPoints = function(points2, lineWidth, orient) {
    var rs = [points2[0].slice(), points2[points2.length - 1].slice()];
    var idx = orient === "horizontal" ? 0 : 1;
    rs[0][idx] = rs[0][idx] - lineWidth / 2;
    rs[1][idx] = rs[1][idx] + lineWidth / 2;
    return rs;
  };
  CalendarView2.prototype._drawSplitline = function(points2, lineStyle, group) {
    var poyline = new Polyline$3({
      z2: 20,
      shape: {
        points: points2
      },
      style: lineStyle
    });
    group.add(poyline);
  };
  CalendarView2.prototype._getLinePointsOfOneWeek = function(calendarModel, date4, orient) {
    var coordSys = calendarModel.coordinateSystem;
    var parsedDate = coordSys.getDateInfo(date4);
    var points2 = [];
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(parsedDate.time, i);
      var point = coordSys.dataToRect([tmpD.time], false);
      points2[2 * tmpD.day] = point.tl;
      points2[2 * tmpD.day + 1] = point[orient === "horizontal" ? "bl" : "tr"];
    }
    return points2;
  };
  CalendarView2.prototype._formatterLabel = function(formatter, params) {
    if (isString$1(formatter) && formatter) {
      return formatTplSimple(formatter, params);
    }
    if (isFunction$1(formatter)) {
      return formatter(params);
    }
    return params.nameMap;
  };
  CalendarView2.prototype._yearTextPositionControl = function(textEl, point, orient, position2, margin) {
    var x2 = point[0];
    var y2 = point[1];
    var aligns = ["center", "bottom"];
    if (position2 === "bottom") {
      y2 += margin;
      aligns = ["center", "top"];
    } else if (position2 === "left") {
      x2 -= margin;
    } else if (position2 === "right") {
      x2 += margin;
      aligns = ["center", "top"];
    } else {
      y2 -= margin;
    }
    var rotate2 = 0;
    if (position2 === "left" || position2 === "right") {
      rotate2 = Math.PI / 2;
    }
    return {
      rotation: rotate2,
      x: x2,
      y: y2,
      style: {
        align: aligns[0],
        verticalAlign: aligns[1]
      }
    };
  };
  CalendarView2.prototype._renderYearText = function(calendarModel, rangeData, orient, group) {
    var yearLabel = calendarModel.getModel("yearLabel");
    if (!yearLabel.get("show")) {
      return;
    }
    var margin = yearLabel.get("margin");
    var pos = yearLabel.get("position");
    if (!pos) {
      pos = orient !== "horizontal" ? "top" : "left";
    }
    var points2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]];
    var xc2 = (points2[0][0] + points2[1][0]) / 2;
    var yc2 = (points2[0][1] + points2[1][1]) / 2;
    var idx = orient === "horizontal" ? 0 : 1;
    var posPoints = {
      top: [xc2, points2[idx][1]],
      bottom: [xc2, points2[1 - idx][1]],
      left: [points2[1 - idx][0], yc2],
      right: [points2[idx][0], yc2]
    };
    var name2 = rangeData.start.y;
    if (+rangeData.end.y > +rangeData.start.y) {
      name2 = name2 + "-" + rangeData.end.y;
    }
    var formatter = yearLabel.get("formatter");
    var params = {
      start: rangeData.start.y,
      end: rangeData.end.y,
      nameMap: name2
    };
    var content = this._formatterLabel(formatter, params);
    var yearText = new ZRText$1({
      z2: 30,
      style: createTextStyle(yearLabel, {
        text: content
      })
    });
    yearText.attr(this._yearTextPositionControl(yearText, posPoints[pos], orient, pos, margin));
    group.add(yearText);
  };
  CalendarView2.prototype._monthTextPositionControl = function(point, isCenter, orient, position2, margin) {
    var align = "left";
    var vAlign = "top";
    var x2 = point[0];
    var y2 = point[1];
    if (orient === "horizontal") {
      y2 = y2 + margin;
      if (isCenter) {
        align = "center";
      }
      if (position2 === "start") {
        vAlign = "bottom";
      }
    } else {
      x2 = x2 + margin;
      if (isCenter) {
        vAlign = "middle";
      }
      if (position2 === "start") {
        align = "right";
      }
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderMonthText = function(calendarModel, localeModel, orient, group) {
    var monthLabel = calendarModel.getModel("monthLabel");
    if (!monthLabel.get("show")) {
      return;
    }
    var nameMap = monthLabel.get("nameMap");
    var margin = monthLabel.get("margin");
    var pos = monthLabel.get("position");
    var align = monthLabel.get("align");
    var termPoints = [this._tlpoints, this._blpoints];
    if (!nameMap || isString$1(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      nameMap = localeModel.get(["time", "monthAbbr"]) || [];
    }
    var idx = pos === "start" ? 0 : 1;
    var axis = orient === "horizontal" ? 0 : 1;
    margin = pos === "start" ? -margin : margin;
    var isCenter = align === "center";
    for (var i = 0; i < termPoints[idx].length - 1; i++) {
      var tmp = termPoints[idx][i].slice();
      var firstDay = this._firstDayOfMonth[i];
      if (isCenter) {
        var firstDayPoints = this._firstDayPoints[i];
        tmp[axis] = (firstDayPoints[axis] + termPoints[0][i + 1][axis]) / 2;
      }
      var formatter = monthLabel.get("formatter");
      var name_1 = nameMap[+firstDay.m - 1];
      var params = {
        yyyy: firstDay.y,
        yy: (firstDay.y + "").slice(2),
        MM: firstDay.m,
        M: +firstDay.m,
        nameMap: name_1
      };
      var content = this._formatterLabel(formatter, params);
      var monthText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(monthLabel, {
          text: content
        }), this._monthTextPositionControl(tmp, isCenter, orient, pos, margin))
      });
      group.add(monthText);
    }
  };
  CalendarView2.prototype._weekTextPositionControl = function(point, orient, position2, margin, cellSize) {
    var align = "center";
    var vAlign = "middle";
    var x2 = point[0];
    var y2 = point[1];
    var isStart = position2 === "start";
    if (orient === "horizontal") {
      x2 = x2 + margin + (isStart ? 1 : -1) * cellSize[0] / 2;
      align = isStart ? "right" : "left";
    } else {
      y2 = y2 + margin + (isStart ? 1 : -1) * cellSize[1] / 2;
      vAlign = isStart ? "bottom" : "top";
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderWeekText = function(calendarModel, localeModel, rangeData, orient, group) {
    var dayLabel = calendarModel.getModel("dayLabel");
    if (!dayLabel.get("show")) {
      return;
    }
    var coordSys = calendarModel.coordinateSystem;
    var pos = dayLabel.get("position");
    var nameMap = dayLabel.get("nameMap");
    var margin = dayLabel.get("margin");
    var firstDayOfWeek = coordSys.getFirstDayOfWeek();
    if (!nameMap || isString$1(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      var dayOfWeekShort = localeModel.get(["time", "dayOfWeekShort"]);
      nameMap = dayOfWeekShort || map$1(localeModel.get(["time", "dayOfWeekAbbr"]), function(val) {
        return val[0];
      });
    }
    var start2 = coordSys.getNextNDay(rangeData.end.time, 7 - rangeData.lweek).time;
    var cellSize = [coordSys.getCellWidth(), coordSys.getCellHeight()];
    margin = parsePercent(margin, Math.min(cellSize[1], cellSize[0]));
    if (pos === "start") {
      start2 = coordSys.getNextNDay(rangeData.start.time, -(7 + rangeData.fweek)).time;
      margin = -margin;
    }
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(start2, i);
      var point = coordSys.dataToRect([tmpD.time], false).center;
      var day = i;
      day = Math.abs((i + firstDayOfWeek) % 7);
      var weekText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(dayLabel, {
          text: nameMap[day]
        }), this._weekTextPositionControl(point, orient, pos, margin, cellSize))
      });
      group.add(weekText);
    }
  };
  CalendarView2.type = "calendar";
  return CalendarView2;
}(ComponentView$1);
var CalendarView$1 = CalendarView;
var PROXIMATE_ONE_DAY = 864e5;
var Calendar = function() {
  function Calendar2(calendarModel, ecModel, api) {
    this.type = "calendar";
    this.dimensions = Calendar2.dimensions;
    this.getDimensionsInfo = Calendar2.getDimensionsInfo;
    this._model = calendarModel;
  }
  Calendar2.getDimensionsInfo = function() {
    return [{
      name: "time",
      type: "time"
    }, "value"];
  };
  Calendar2.prototype.getRangeInfo = function() {
    return this._rangeInfo;
  };
  Calendar2.prototype.getModel = function() {
    return this._model;
  };
  Calendar2.prototype.getRect = function() {
    return this._rect;
  };
  Calendar2.prototype.getCellWidth = function() {
    return this._sw;
  };
  Calendar2.prototype.getCellHeight = function() {
    return this._sh;
  };
  Calendar2.prototype.getOrient = function() {
    return this._orient;
  };
  Calendar2.prototype.getFirstDayOfWeek = function() {
    return this._firstDayOfWeek;
  };
  Calendar2.prototype.getDateInfo = function(date4) {
    date4 = parseDate(date4);
    var y2 = date4.getFullYear();
    var m2 = date4.getMonth() + 1;
    var mStr = m2 < 10 ? "0" + m2 : "" + m2;
    var d2 = date4.getDate();
    var dStr = d2 < 10 ? "0" + d2 : "" + d2;
    var day = date4.getDay();
    day = Math.abs((day + 7 - this.getFirstDayOfWeek()) % 7);
    return {
      y: y2 + "",
      m: mStr,
      d: dStr,
      day,
      time: date4.getTime(),
      formatedDate: y2 + "-" + mStr + "-" + dStr,
      date: date4
    };
  };
  Calendar2.prototype.getNextNDay = function(date4, n2) {
    n2 = n2 || 0;
    if (n2 === 0) {
      return this.getDateInfo(date4);
    }
    date4 = new Date(this.getDateInfo(date4).time);
    date4.setDate(date4.getDate() + n2);
    return this.getDateInfo(date4);
  };
  Calendar2.prototype.update = function(ecModel, api) {
    this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay");
    this._orient = this._model.get("orient");
    this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0;
    this._rangeInfo = this._getRangeInfo(this._initRangeOption());
    var weeks = this._rangeInfo.weeks || 1;
    var whNames = ["width", "height"];
    var cellSize = this._model.getCellSize().slice();
    var layoutParams = this._model.getBoxLayoutParams();
    var cellNumbers = this._orient === "horizontal" ? [weeks, 7] : [7, weeks];
    each$g([0, 1], function(idx) {
      if (cellSizeSpecified(cellSize, idx)) {
        layoutParams[whNames[idx]] = cellSize[idx] * cellNumbers[idx];
      }
    });
    var whGlobal = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var calendarRect = this._rect = getLayoutRect(layoutParams, whGlobal);
    each$g([0, 1], function(idx) {
      if (!cellSizeSpecified(cellSize, idx)) {
        cellSize[idx] = calendarRect[whNames[idx]] / cellNumbers[idx];
      }
    });
    function cellSizeSpecified(cellSize2, idx) {
      return cellSize2[idx] != null && cellSize2[idx] !== "auto";
    }
    this._sw = cellSize[0];
    this._sh = cellSize[1];
  };
  Calendar2.prototype.dataToPoint = function(data2, clamp2) {
    isArray$2(data2) && (data2 = data2[0]);
    clamp2 == null && (clamp2 = true);
    var dayInfo = this.getDateInfo(data2);
    var range3 = this._rangeInfo;
    var date4 = dayInfo.formatedDate;
    if (clamp2 && !(dayInfo.time >= range3.start.time && dayInfo.time < range3.end.time + PROXIMATE_ONE_DAY)) {
      return [NaN, NaN];
    }
    var week = dayInfo.day;
    var nthWeek = this._getRangeInfo([range3.start.time, date4]).nthWeek;
    if (this._orient === "vertical") {
      return [this._rect.x + week * this._sw + this._sw / 2, this._rect.y + nthWeek * this._sh + this._sh / 2];
    }
    return [this._rect.x + nthWeek * this._sw + this._sw / 2, this._rect.y + week * this._sh + this._sh / 2];
  };
  Calendar2.prototype.pointToData = function(point) {
    var date4 = this.pointToDate(point);
    return date4 && date4.time;
  };
  Calendar2.prototype.dataToRect = function(data2, clamp2) {
    var point = this.dataToPoint(data2, clamp2);
    return {
      contentShape: {
        x: point[0] - (this._sw - this._lineWidth) / 2,
        y: point[1] - (this._sh - this._lineWidth) / 2,
        width: this._sw - this._lineWidth,
        height: this._sh - this._lineWidth
      },
      center: point,
      tl: [point[0] - this._sw / 2, point[1] - this._sh / 2],
      tr: [point[0] + this._sw / 2, point[1] - this._sh / 2],
      br: [point[0] + this._sw / 2, point[1] + this._sh / 2],
      bl: [point[0] - this._sw / 2, point[1] + this._sh / 2]
    };
  };
  Calendar2.prototype.pointToDate = function(point) {
    var nthX = Math.floor((point[0] - this._rect.x) / this._sw) + 1;
    var nthY = Math.floor((point[1] - this._rect.y) / this._sh) + 1;
    var range3 = this._rangeInfo.range;
    if (this._orient === "vertical") {
      return this._getDateByWeeksAndDay(nthY, nthX - 1, range3);
    }
    return this._getDateByWeeksAndDay(nthX, nthY - 1, range3);
  };
  Calendar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Calendar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  Calendar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Calendar2.prototype._initRangeOption = function() {
    var range3 = this._model.get("range");
    var normalizedRange;
    if (isArray$2(range3) && range3.length === 1) {
      range3 = range3[0];
    }
    if (!isArray$2(range3)) {
      var rangeStr = range3.toString();
      if (/^\d{4}$/.test(rangeStr)) {
        normalizedRange = [rangeStr + "-01-01", rangeStr + "-12-31"];
      }
      if (/^\d{4}[\/|-]\d{1,2}$/.test(rangeStr)) {
        var start2 = this.getDateInfo(rangeStr);
        var firstDay = start2.date;
        firstDay.setMonth(firstDay.getMonth() + 1);
        var end2 = this.getNextNDay(firstDay, -1);
        normalizedRange = [start2.formatedDate, end2.formatedDate];
      }
      if (/^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(rangeStr)) {
        normalizedRange = [rangeStr, rangeStr];
      }
    } else {
      normalizedRange = range3;
    }
    if (!normalizedRange) {
      return range3;
    }
    var tmp = this._getRangeInfo(normalizedRange);
    if (tmp.start.time > tmp.end.time) {
      normalizedRange.reverse();
    }
    return normalizedRange;
  };
  Calendar2.prototype._getRangeInfo = function(range3) {
    var parsedRange = [this.getDateInfo(range3[0]), this.getDateInfo(range3[1])];
    var reversed;
    if (parsedRange[0].time > parsedRange[1].time) {
      reversed = true;
      parsedRange.reverse();
    }
    var allDay = Math.floor(parsedRange[1].time / PROXIMATE_ONE_DAY) - Math.floor(parsedRange[0].time / PROXIMATE_ONE_DAY) + 1;
    var date4 = new Date(parsedRange[0].time);
    var startDateNum = date4.getDate();
    var endDateNum = parsedRange[1].date.getDate();
    date4.setDate(startDateNum + allDay - 1);
    var dateNum = date4.getDate();
    if (dateNum !== endDateNum) {
      var sign = date4.getTime() - parsedRange[1].time > 0 ? 1 : -1;
      while ((dateNum = date4.getDate()) !== endDateNum && (date4.getTime() - parsedRange[1].time) * sign > 0) {
        allDay -= sign;
        date4.setDate(dateNum - sign);
      }
    }
    var weeks = Math.floor((allDay + parsedRange[0].day + 6) / 7);
    var nthWeek = reversed ? -weeks + 1 : weeks - 1;
    reversed && parsedRange.reverse();
    return {
      range: [parsedRange[0].formatedDate, parsedRange[1].formatedDate],
      start: parsedRange[0],
      end: parsedRange[1],
      allDay,
      weeks,
      nthWeek,
      fweek: parsedRange[0].day,
      lweek: parsedRange[1].day
    };
  };
  Calendar2.prototype._getDateByWeeksAndDay = function(nthWeek, day, range3) {
    var rangeInfo = this._getRangeInfo(range3);
    if (nthWeek > rangeInfo.weeks || nthWeek === 0 && day < rangeInfo.fweek || nthWeek === rangeInfo.weeks && day > rangeInfo.lweek) {
      return null;
    }
    var nthDay = (nthWeek - 1) * 7 - rangeInfo.fweek + day;
    var date4 = new Date(rangeInfo.start.time);
    date4.setDate(+rangeInfo.start.d + nthDay);
    return this.getDateInfo(date4);
  };
  Calendar2.create = function(ecModel, api) {
    var calendarList = [];
    ecModel.eachComponent("calendar", function(calendarModel) {
      var calendar = new Calendar2(calendarModel, ecModel, api);
      calendarList.push(calendar);
      calendarModel.coordinateSystem = calendar;
    });
    ecModel.eachSeries(function(calendarSeries) {
      if (calendarSeries.get("coordinateSystem") === "calendar") {
        calendarSeries.coordinateSystem = calendarList[calendarSeries.get("calendarIndex") || 0];
      }
    });
    return calendarList;
  };
  Calendar2.dimensions = ["time", "value"];
  return Calendar2;
}();
function getCoordSys(finder) {
  var calendarModel = finder.calendarModel;
  var seriesModel = finder.seriesModel;
  var coordSys = calendarModel ? calendarModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem : null;
  return coordSys;
}
var Calendar$1 = Calendar;
function install$m(registers) {
  registers.registerComponentModel(CalendarModel$1);
  registers.registerComponentView(CalendarView$1);
  registers.registerCoordinateSystem("calendar", Calendar$1);
}
function setKeyInfoToNewElOption(resultItem, newElOption) {
  var existElOption = resultItem.existing;
  newElOption.id = resultItem.keyInfo.id;
  !newElOption.type && existElOption && (newElOption.type = existElOption.type);
  if (newElOption.parentId == null) {
    var newElParentOption = newElOption.parentOption;
    if (newElParentOption) {
      newElOption.parentId = newElParentOption.id;
    } else if (existElOption) {
      newElOption.parentId = existElOption.parentId;
    }
  }
  newElOption.parentOption = null;
}
function isSetLoc(obj, props) {
  var isSet;
  each$g(props, function(prop) {
    obj[prop] != null && obj[prop] !== "auto" && (isSet = true);
  });
  return isSet;
}
function mergeNewElOptionToExist(existList, index2, newElOption) {
  var newElOptCopy = extend({}, newElOption);
  var existElOption = existList[index2];
  var $action = newElOption.$action || "merge";
  if ($action === "merge") {
    if (existElOption) {
      merge$1(existElOption, newElOptCopy, true);
      mergeLayoutParam(existElOption, newElOptCopy, {
        ignoreSize: true
      });
      copyLayoutParams(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption, "shape");
      copyTransitionInfo(newElOption, existElOption, "style");
      copyTransitionInfo(newElOption, existElOption, "extra");
      newElOption.clipPath = existElOption.clipPath;
    } else {
      existList[index2] = newElOptCopy;
    }
  } else if ($action === "replace") {
    existList[index2] = newElOptCopy;
  } else if ($action === "remove") {
    existElOption && (existList[index2] = null);
  }
}
var TRANSITION_PROPS_TO_COPY = ["transition", "enterFrom", "leaveTo"];
var ROOT_TRANSITION_PROPS_TO_COPY = TRANSITION_PROPS_TO_COPY.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
function copyTransitionInfo(target, source, targetProp) {
  if (targetProp) {
    if (!target[targetProp] && source[targetProp]) {
      target[targetProp] = {};
    }
    target = target[targetProp];
    source = source[targetProp];
  }
  if (!target || !source) {
    return;
  }
  var props = targetProp ? TRANSITION_PROPS_TO_COPY : ROOT_TRANSITION_PROPS_TO_COPY;
  for (var i = 0; i < props.length; i++) {
    var prop = props[i];
    if (target[prop] == null && source[prop] != null) {
      target[prop] = source[prop];
    }
  }
}
function setLayoutInfoToExist(existItem, newElOption) {
  if (!existItem) {
    return;
  }
  existItem.hv = newElOption.hv = [
    isSetLoc(newElOption, ["left", "right"]),
    isSetLoc(newElOption, ["top", "bottom"])
  ];
  if (existItem.type === "group") {
    var existingGroupOpt = existItem;
    var newGroupOpt = newElOption;
    existingGroupOpt.width == null && (existingGroupOpt.width = newGroupOpt.width = 0);
    existingGroupOpt.height == null && (existingGroupOpt.height = newGroupOpt.height = 0);
  }
}
var GraphicComponentModel = function(_super) {
  __extends(GraphicComponentModel2, _super);
  function GraphicComponentModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentModel2.type;
    _this.preventAutoZ = true;
    return _this;
  }
  GraphicComponentModel2.prototype.mergeOption = function(option, ecModel) {
    var elements = this.option.elements;
    this.option.elements = null;
    _super.prototype.mergeOption.call(this, option, ecModel);
    this.option.elements = elements;
  };
  GraphicComponentModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    var newList = (isInit ? thisOption : newOption).elements;
    var existList = thisOption.elements = isInit ? [] : thisOption.elements;
    var flattenedList = [];
    this._flatten(newList, flattenedList, null);
    var mappingResult = mappingToExists(existList, flattenedList, "normalMerge");
    var elOptionsToUpdate = this._elOptionsToUpdate = [];
    each$g(mappingResult, function(resultItem, index2) {
      var newElOption = resultItem.newOption;
      if (!newElOption) {
        return;
      }
      elOptionsToUpdate.push(newElOption);
      setKeyInfoToNewElOption(resultItem, newElOption);
      mergeNewElOptionToExist(existList, index2, newElOption);
      setLayoutInfoToExist(existList[index2], newElOption);
    }, this);
    thisOption.elements = filter(existList, function(item) {
      item && delete item.$action;
      return item != null;
    });
  };
  GraphicComponentModel2.prototype._flatten = function(optionList, result, parentOption) {
    each$g(optionList, function(option) {
      if (!option) {
        return;
      }
      if (parentOption) {
        option.parentOption = parentOption;
      }
      result.push(option);
      var children = option.children;
      if (option.type === "group" && children) {
        this._flatten(children, result, option);
      }
      delete option.children;
    }, this);
  };
  GraphicComponentModel2.prototype.useElOptionsToUpdate = function() {
    var els = this._elOptionsToUpdate;
    this._elOptionsToUpdate = null;
    return els;
  };
  GraphicComponentModel2.type = "graphic";
  GraphicComponentModel2.defaultOption = {
    elements: []
  };
  return GraphicComponentModel2;
}(ComponentModel$1);
var nonShapeGraphicElements = {
  path: null,
  compoundPath: null,
  group: Group$6,
  image: ZRImage$1,
  text: ZRText$1
};
var inner$7 = makeInner();
var GraphicComponentView = function(_super) {
  __extends(GraphicComponentView2, _super);
  function GraphicComponentView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentView2.type;
    return _this;
  }
  GraphicComponentView2.prototype.init = function() {
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.render = function(graphicModel, ecModel, api) {
    if (graphicModel !== this._lastGraphicModel) {
      this._clear();
    }
    this._lastGraphicModel = graphicModel;
    this._updateElements(graphicModel);
    this._relocate(graphicModel, api);
  };
  GraphicComponentView2.prototype._updateElements = function(graphicModel) {
    var elOptionsToUpdate = graphicModel.useElOptionsToUpdate();
    if (!elOptionsToUpdate) {
      return;
    }
    var elMap = this._elMap;
    var rootGroup = this.group;
    var globalZ = graphicModel.get("z");
    var globalZLevel = graphicModel.get("zlevel");
    each$g(elOptionsToUpdate, function(elOption) {
      var id2 = convertOptionIdName(elOption.id, null);
      var elExisting = id2 != null ? elMap.get(id2) : null;
      var parentId = convertOptionIdName(elOption.parentId, null);
      var targetElParent = parentId != null ? elMap.get(parentId) : rootGroup;
      var elType = elOption.type;
      var elOptionStyle = elOption.style;
      if (elType === "text" && elOptionStyle) {
        if (elOption.hv && elOption.hv[1]) {
          elOptionStyle.textVerticalAlign = elOptionStyle.textBaseline = elOptionStyle.verticalAlign = elOptionStyle.align = null;
        }
      }
      var textContentOption = elOption.textContent;
      var textConfig = elOption.textConfig;
      if (elOptionStyle && isEC4CompatibleStyle(elOptionStyle, elType, !!textConfig, !!textContentOption)) {
        var convertResult = convertFromEC4CompatibleStyle(elOptionStyle, elType, true);
        if (!textConfig && convertResult.textConfig) {
          textConfig = elOption.textConfig = convertResult.textConfig;
        }
        if (!textContentOption && convertResult.textContent) {
          textContentOption = convertResult.textContent;
        }
      }
      var elOptionCleaned = getCleanedElOption(elOption);
      var $action = elOption.$action || "merge";
      var isMerge = $action === "merge";
      var isReplace = $action === "replace";
      if (isMerge) {
        var isInit = !elExisting;
        var el_1 = elExisting;
        if (isInit) {
          el_1 = createEl(id2, targetElParent, elOption.type, elMap);
        } else {
          el_1 && (inner$7(el_1).isNew = false);
          stopPreviousKeyframeAnimationAndRestore(el_1);
        }
        if (el_1) {
          applyUpdateTransition(el_1, elOptionCleaned, graphicModel, {
            isInit
          });
          updateCommonAttrs(el_1, elOption, globalZ, globalZLevel);
        }
      } else if (isReplace) {
        removeEl$1(elExisting, elOption, elMap, graphicModel);
        var el_2 = createEl(id2, targetElParent, elOption.type, elMap);
        if (el_2) {
          applyUpdateTransition(el_2, elOptionCleaned, graphicModel, {
            isInit: true
          });
          updateCommonAttrs(el_2, elOption, globalZ, globalZLevel);
        }
      } else if ($action === "remove") {
        updateLeaveTo(elExisting, elOption);
        removeEl$1(elExisting, elOption, elMap, graphicModel);
      }
      var el = elMap.get(id2);
      if (el && textContentOption) {
        if (isMerge) {
          var textContentExisting = el.getTextContent();
          textContentExisting ? textContentExisting.attr(textContentOption) : el.setTextContent(new ZRText$1(textContentOption));
        } else if (isReplace) {
          el.setTextContent(new ZRText$1(textContentOption));
        }
      }
      if (el) {
        var clipPathOption = elOption.clipPath;
        if (clipPathOption) {
          var clipPathType = clipPathOption.type;
          var clipPath = void 0;
          var isInit = false;
          if (isMerge) {
            var oldClipPath = el.getClipPath();
            isInit = !oldClipPath || inner$7(oldClipPath).type !== clipPathType;
            clipPath = isInit ? newEl(clipPathType) : oldClipPath;
          } else if (isReplace) {
            isInit = true;
            clipPath = newEl(clipPathType);
          }
          el.setClipPath(clipPath);
          applyUpdateTransition(clipPath, clipPathOption, graphicModel, {
            isInit
          });
          applyKeyframeAnimation(clipPath, clipPathOption.keyframeAnimation, graphicModel);
        }
        var elInner = inner$7(el);
        el.setTextConfig(textConfig);
        elInner.option = elOption;
        setEventData(el, graphicModel, elOption);
        setTooltipConfig({
          el,
          componentModel: graphicModel,
          itemName: el.name,
          itemTooltipOption: elOption.tooltip
        });
        applyKeyframeAnimation(el, elOption.keyframeAnimation, graphicModel);
      }
    });
  };
  GraphicComponentView2.prototype._relocate = function(graphicModel, api) {
    var elOptions = graphicModel.option.elements;
    var rootGroup = this.group;
    var elMap = this._elMap;
    var apiWidth = api.getWidth();
    var apiHeight = api.getHeight();
    var xy = ["x", "y"];
    for (var i = 0; i < elOptions.length; i++) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el || !el.isGroup) {
        continue;
      }
      var parentEl = el.parent;
      var isParentRoot = parentEl === rootGroup;
      var elInner = inner$7(el);
      var parentElInner = inner$7(parentEl);
      elInner.width = parsePercent(elInner.option.width, isParentRoot ? apiWidth : parentElInner.width) || 0;
      elInner.height = parsePercent(elInner.option.height, isParentRoot ? apiHeight : parentElInner.height) || 0;
    }
    for (var i = elOptions.length - 1; i >= 0; i--) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el) {
        continue;
      }
      var parentEl = el.parent;
      var parentElInner = inner$7(parentEl);
      var containerInfo = parentEl === rootGroup ? {
        width: apiWidth,
        height: apiHeight
      } : {
        width: parentElInner.width,
        height: parentElInner.height
      };
      var layoutPos = {};
      var layouted = positionElement(el, elOption, containerInfo, null, {
        hv: elOption.hv,
        boundingMode: elOption.bounding
      }, layoutPos);
      if (!inner$7(el).isNew && layouted) {
        var transition = elOption.transition;
        var animatePos = {};
        for (var k2 = 0; k2 < xy.length; k2++) {
          var key = xy[k2];
          var val = layoutPos[key];
          if (transition && (isTransitionAll(transition) || indexOf(transition, key) >= 0)) {
            animatePos[key] = val;
          } else {
            el[key] = val;
          }
        }
        updateProps$1(el, animatePos, graphicModel, 0);
      } else {
        el.attr(layoutPos);
      }
    }
  };
  GraphicComponentView2.prototype._clear = function() {
    var _this = this;
    var elMap = this._elMap;
    elMap.each(function(el) {
      removeEl$1(el, inner$7(el).option, elMap, _this._lastGraphicModel);
    });
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.dispose = function() {
    this._clear();
  };
  GraphicComponentView2.type = "graphic";
  return GraphicComponentView2;
}(ComponentView$1);
function newEl(graphicType) {
  var Clz = hasOwn$1(nonShapeGraphicElements, graphicType) ? nonShapeGraphicElements[graphicType] : getShapeClass(graphicType);
  var el = new Clz({});
  inner$7(el).type = graphicType;
  return el;
}
function createEl(id2, targetElParent, graphicType, elMap) {
  var el = newEl(graphicType);
  targetElParent.add(el);
  elMap.set(id2, el);
  inner$7(el).id = id2;
  inner$7(el).isNew = true;
  return el;
}
function removeEl$1(elExisting, elOption, elMap, graphicModel) {
  var existElParent = elExisting && elExisting.parent;
  if (existElParent) {
    elExisting.type === "group" && elExisting.traverse(function(el) {
      removeEl$1(el, elOption, elMap, graphicModel);
    });
    applyLeaveTransition(elExisting, elOption, graphicModel);
    elMap.removeKey(inner$7(elExisting).id);
  }
}
function updateCommonAttrs(el, elOption, defaultZ, defaultZlevel) {
  if (!el.isGroup) {
    var elDisplayable = el;
    elDisplayable.cursor = retrieve2(elOption.cursor, Displayable$1.prototype.cursor);
    elDisplayable.z = retrieve2(elOption.z, defaultZ || 0);
    elDisplayable.zlevel = retrieve2(elOption.zlevel, defaultZlevel || 0);
    var optZ2 = elOption.z2;
    optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  }
  each$g(keys(elOption), function(key) {
    var val = elOption[key];
    if (key.indexOf("on") === 0 && isFunction$1(val)) {
      el[key] = val;
    }
  });
  el.draggable = elOption.draggable;
  elOption.name != null && (el.name = elOption.name);
  elOption.id != null && (el.id = elOption.id);
}
function getCleanedElOption(elOption) {
  elOption = extend({}, elOption);
  each$g(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(LOCATION_PARAMS), function(name2) {
    delete elOption[name2];
  });
  return elOption;
}
function setEventData(el, graphicModel, elOption) {
  var eventData = getECData(el).eventData;
  if (!el.silent && !el.ignore && !eventData) {
    eventData = getECData(el).eventData = {
      componentType: "graphic",
      componentIndex: graphicModel.componentIndex,
      name: el.name
    };
  }
  if (eventData) {
    eventData.info = elOption.info;
  }
}
function install$l(registers) {
  registers.registerComponentModel(GraphicComponentModel);
  registers.registerComponentView(GraphicComponentView);
  registers.registerPreprocessor(function(option) {
    var graphicOption = option.graphic;
    if (isArray$2(graphicOption)) {
      if (!graphicOption[0] || !graphicOption[0].elements) {
        option.graphic = [{
          elements: graphicOption
        }];
      } else {
        option.graphic = [option.graphic[0]];
      }
    } else if (graphicOption && !graphicOption.elements) {
      option.graphic = [{
        elements: [graphicOption]
      }];
    }
  });
}
var DATA_ZOOM_AXIS_DIMENSIONS = ["x", "y", "radius", "angle", "single"];
var SERIES_COORDS = ["cartesian2d", "polar", "singleAxis"];
function isCoordSupported(seriesModel) {
  var coordType = seriesModel.get("coordinateSystem");
  return indexOf(SERIES_COORDS, coordType) >= 0;
}
function getAxisMainType(axisDim) {
  return axisDim + "Axis";
}
function findEffectedDataZooms(ecModel, payload) {
  var axisRecords = createHashMap();
  var effectedModels = [];
  var effectedModelMap = createHashMap();
  ecModel.eachComponent({
    mainType: "dataZoom",
    query: payload
  }, function(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid)) {
      addToEffected(dataZoomModel);
    }
  });
  var foundNewLink;
  do {
    foundNewLink = false;
    ecModel.eachComponent("dataZoom", processSingle);
  } while (foundNewLink);
  function processSingle(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid) && isLinked(dataZoomModel)) {
      addToEffected(dataZoomModel);
      foundNewLink = true;
    }
  }
  function addToEffected(dataZoom) {
    effectedModelMap.set(dataZoom.uid, true);
    effectedModels.push(dataZoom);
    markAxisControlled(dataZoom);
  }
  function isLinked(dataZoomModel) {
    var isLink = false;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var axisIdxArr = axisRecords.get(axisDim);
      if (axisIdxArr && axisIdxArr[axisIndex]) {
        isLink = true;
      }
    });
    return isLink;
  }
  function markAxisControlled(dataZoomModel) {
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      (axisRecords.get(axisDim) || axisRecords.set(axisDim, []))[axisIndex] = true;
    });
  }
  return effectedModels;
}
function collectReferCoordSysModelInfo(dataZoomModel) {
  var ecModel = dataZoomModel.ecModel;
  var coordSysInfoWrap = {
    infoList: [],
    infoMap: createHashMap()
  };
  dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
    var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    if (!axisModel) {
      return;
    }
    var coordSysModel = axisModel.getCoordSysModel();
    if (!coordSysModel) {
      return;
    }
    var coordSysUid = coordSysModel.uid;
    var coordSysInfo = coordSysInfoWrap.infoMap.get(coordSysUid);
    if (!coordSysInfo) {
      coordSysInfo = {
        model: coordSysModel,
        axisModels: []
      };
      coordSysInfoWrap.infoList.push(coordSysInfo);
      coordSysInfoWrap.infoMap.set(coordSysUid, coordSysInfo);
    }
    coordSysInfo.axisModels.push(axisModel);
  });
  return coordSysInfoWrap;
}
var DataZoomAxisInfo = function() {
  function DataZoomAxisInfo2() {
    this.indexList = [];
    this.indexMap = [];
  }
  DataZoomAxisInfo2.prototype.add = function(axisCmptIdx) {
    if (!this.indexMap[axisCmptIdx]) {
      this.indexList.push(axisCmptIdx);
      this.indexMap[axisCmptIdx] = true;
    }
  };
  return DataZoomAxisInfo2;
}();
var DataZoomModel = function(_super) {
  __extends(DataZoomModel2, _super);
  function DataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomModel2.type;
    _this._autoThrottle = true;
    _this._noTarget = true;
    _this._rangePropMode = ["percent", "percent"];
    return _this;
  }
  DataZoomModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputRawOption = retrieveRawOption(option);
    this.settledOption = inputRawOption;
    this.mergeDefaultAndTheme(option, ecModel);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype.mergeOption = function(newOption) {
    var inputRawOption = retrieveRawOption(newOption);
    merge$1(this.option, newOption, true);
    merge$1(this.settledOption, inputRawOption, true);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype._doInit = function(inputRawOption) {
    var thisOption = this.option;
    this._setDefaultThrottle(inputRawOption);
    this._updateRangeUse(inputRawOption);
    var settledOption = this.settledOption;
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      if (this._rangePropMode[index2] === "value") {
        thisOption[names2[0]] = settledOption[names2[0]] = null;
      }
    }, this);
    this._resetTarget();
  };
  DataZoomModel2.prototype._resetTarget = function() {
    var optionOrient = this.get("orient", true);
    var targetAxisIndexMap = this._targetAxisInfoMap = createHashMap();
    var hasAxisSpecified = this._fillSpecifiedTargetAxis(targetAxisIndexMap);
    if (hasAxisSpecified) {
      this._orient = optionOrient || this._makeAutoOrientByTargetAxis();
    } else {
      this._orient = optionOrient || "horizontal";
      this._fillAutoTargetAxisByOrient(targetAxisIndexMap, this._orient);
    }
    this._noTarget = true;
    targetAxisIndexMap.each(function(axisInfo) {
      if (axisInfo.indexList.length) {
        this._noTarget = false;
      }
    }, this);
  };
  DataZoomModel2.prototype._fillSpecifiedTargetAxis = function(targetAxisIndexMap) {
    var hasAxisSpecified = false;
    each$g(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim) {
      var refering = this.getReferringComponents(getAxisMainType(axisDim), MULTIPLE_REFERRING);
      if (!refering.specified) {
        return;
      }
      hasAxisSpecified = true;
      var axisInfo = new DataZoomAxisInfo();
      each$g(refering.models, function(axisModel) {
        axisInfo.add(axisModel.componentIndex);
      });
      targetAxisIndexMap.set(axisDim, axisInfo);
    }, this);
    return hasAxisSpecified;
  };
  DataZoomModel2.prototype._fillAutoTargetAxisByOrient = function(targetAxisIndexMap, orient) {
    var ecModel = this.ecModel;
    var needAuto = true;
    if (needAuto) {
      var axisDim = orient === "vertical" ? "y" : "x";
      var axisModels = ecModel.findComponents({
        mainType: axisDim + "Axis"
      });
      setParallelAxis(axisModels, axisDim);
    }
    if (needAuto) {
      var axisModels = ecModel.findComponents({
        mainType: "singleAxis",
        filter: function(axisModel) {
          return axisModel.get("orient", true) === orient;
        }
      });
      setParallelAxis(axisModels, "single");
    }
    function setParallelAxis(axisModels2, axisDim2) {
      var axisModel = axisModels2[0];
      if (!axisModel) {
        return;
      }
      var axisInfo = new DataZoomAxisInfo();
      axisInfo.add(axisModel.componentIndex);
      targetAxisIndexMap.set(axisDim2, axisInfo);
      needAuto = false;
      if (axisDim2 === "x" || axisDim2 === "y") {
        var gridModel_1 = axisModel.getReferringComponents("grid", SINGLE_REFERRING).models[0];
        gridModel_1 && each$g(axisModels2, function(axModel) {
          if (axisModel.componentIndex !== axModel.componentIndex && gridModel_1 === axModel.getReferringComponents("grid", SINGLE_REFERRING).models[0]) {
            axisInfo.add(axModel.componentIndex);
          }
        });
      }
    }
    if (needAuto) {
      each$g(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim2) {
        if (!needAuto) {
          return;
        }
        var axisModels2 = ecModel.findComponents({
          mainType: getAxisMainType(axisDim2),
          filter: function(axisModel) {
            return axisModel.get("type", true) === "category";
          }
        });
        if (axisModels2[0]) {
          var axisInfo = new DataZoomAxisInfo();
          axisInfo.add(axisModels2[0].componentIndex);
          targetAxisIndexMap.set(axisDim2, axisInfo);
          needAuto = false;
        }
      }, this);
    }
  };
  DataZoomModel2.prototype._makeAutoOrientByTargetAxis = function() {
    var dim;
    this.eachTargetAxis(function(axisDim) {
      !dim && (dim = axisDim);
    }, this);
    return dim === "y" ? "vertical" : "horizontal";
  };
  DataZoomModel2.prototype._setDefaultThrottle = function(inputRawOption) {
    if (inputRawOption.hasOwnProperty("throttle")) {
      this._autoThrottle = false;
    }
    if (this._autoThrottle) {
      var globalOption = this.ecModel.option;
      this.option.throttle = globalOption.animation && globalOption.animationDurationUpdate > 0 ? 100 : 20;
    }
  };
  DataZoomModel2.prototype._updateRangeUse = function(inputRawOption) {
    var rangePropMode = this._rangePropMode;
    var rangeModeInOption = this.get("rangeMode");
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      var percentSpecified = inputRawOption[names2[0]] != null;
      var valueSpecified = inputRawOption[names2[1]] != null;
      if (percentSpecified && !valueSpecified) {
        rangePropMode[index2] = "percent";
      } else if (!percentSpecified && valueSpecified) {
        rangePropMode[index2] = "value";
      } else if (rangeModeInOption) {
        rangePropMode[index2] = rangeModeInOption[index2];
      } else if (percentSpecified) {
        rangePropMode[index2] = "percent";
      }
    });
  };
  DataZoomModel2.prototype.noTarget = function() {
    return this._noTarget;
  };
  DataZoomModel2.prototype.getFirstTargetAxisModel = function() {
    var firstAxisModel;
    this.eachTargetAxis(function(axisDim, axisIndex) {
      if (firstAxisModel == null) {
        firstAxisModel = this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
      }
    }, this);
    return firstAxisModel;
  };
  DataZoomModel2.prototype.eachTargetAxis = function(callback, context) {
    this._targetAxisInfoMap.each(function(axisInfo, axisDim) {
      each$g(axisInfo.indexList, function(axisIndex) {
        callback.call(context, axisDim, axisIndex);
      });
    });
  };
  DataZoomModel2.prototype.getAxisProxy = function(axisDim, axisIndex) {
    var axisModel = this.getAxisModel(axisDim, axisIndex);
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
  };
  DataZoomModel2.prototype.getAxisModel = function(axisDim, axisIndex) {
    var axisInfo = this._targetAxisInfoMap.get(axisDim);
    if (axisInfo && axisInfo.indexMap[axisIndex]) {
      return this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    }
  };
  DataZoomModel2.prototype.setRawRange = function(opt) {
    var thisOption = this.option;
    var settledOption = this.settledOption;
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2) {
      if (opt[names2[0]] != null || opt[names2[1]] != null) {
        thisOption[names2[0]] = settledOption[names2[0]] = opt[names2[0]];
        thisOption[names2[1]] = settledOption[names2[1]] = opt[names2[1]];
      }
    }, this);
    this._updateRangeUse(opt);
  };
  DataZoomModel2.prototype.setCalculatedRange = function(opt) {
    var option = this.option;
    each$g(["start", "startValue", "end", "endValue"], function(name2) {
      option[name2] = opt[name2];
    });
  };
  DataZoomModel2.prototype.getPercentRange = function() {
    var axisProxy = this.findRepresentativeAxisProxy();
    if (axisProxy) {
      return axisProxy.getDataPercentWindow();
    }
  };
  DataZoomModel2.prototype.getValueRange = function(axisDim, axisIndex) {
    if (axisDim == null && axisIndex == null) {
      var axisProxy = this.findRepresentativeAxisProxy();
      if (axisProxy) {
        return axisProxy.getDataValueWindow();
      }
    } else {
      return this.getAxisProxy(axisDim, axisIndex).getDataValueWindow();
    }
  };
  DataZoomModel2.prototype.findRepresentativeAxisProxy = function(axisModel) {
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
    var firstProxy;
    var axisDimList = this._targetAxisInfoMap.keys();
    for (var i = 0; i < axisDimList.length; i++) {
      var axisDim = axisDimList[i];
      var axisInfo = this._targetAxisInfoMap.get(axisDim);
      for (var j = 0; j < axisInfo.indexList.length; j++) {
        var proxy = this.getAxisProxy(axisDim, axisInfo.indexList[j]);
        if (proxy.hostedBy(this)) {
          return proxy;
        }
        if (!firstProxy) {
          firstProxy = proxy;
        }
      }
    }
    return firstProxy;
  };
  DataZoomModel2.prototype.getRangePropMode = function() {
    return this._rangePropMode.slice();
  };
  DataZoomModel2.prototype.getOrient = function() {
    return this._orient;
  };
  DataZoomModel2.type = "dataZoom";
  DataZoomModel2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"];
  DataZoomModel2.defaultOption = {
    z: 4,
    filterMode: "filter",
    start: 0,
    end: 100
  };
  return DataZoomModel2;
}(ComponentModel$1);
function retrieveRawOption(option) {
  var ret = {};
  each$g(["start", "end", "startValue", "endValue", "throttle"], function(name2) {
    option.hasOwnProperty(name2) && (ret[name2] = option[name2]);
  });
  return ret;
}
var DataZoomModel$1 = DataZoomModel;
var SelectDataZoomModel = function(_super) {
  __extends(SelectDataZoomModel2, _super);
  function SelectDataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomModel2.type;
    return _this;
  }
  SelectDataZoomModel2.type = "dataZoom.select";
  return SelectDataZoomModel2;
}(DataZoomModel$1);
var SelectZoomModel = SelectDataZoomModel;
var DataZoomView = function(_super) {
  __extends(DataZoomView2, _super);
  function DataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomView2.type;
    return _this;
  }
  DataZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    this.dataZoomModel = dataZoomModel;
    this.ecModel = ecModel;
    this.api = api;
  };
  DataZoomView2.type = "dataZoom";
  return DataZoomView2;
}(ComponentView$1);
var DataZoomView$1 = DataZoomView;
var SelectDataZoomView = function(_super) {
  __extends(SelectDataZoomView2, _super);
  function SelectDataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomView2.type;
    return _this;
  }
  SelectDataZoomView2.type = "dataZoom.select";
  return SelectDataZoomView2;
}(DataZoomView$1);
var SelectZoomView = SelectDataZoomView;
var each$8 = each$g;
var asc$1 = asc$2;
var AxisProxy = function() {
  function AxisProxy2(dimName, axisIndex, dataZoomModel, ecModel) {
    this._dimName = dimName;
    this._axisIndex = axisIndex;
    this.ecModel = ecModel;
    this._dataZoomModel = dataZoomModel;
  }
  AxisProxy2.prototype.hostedBy = function(dataZoomModel) {
    return this._dataZoomModel === dataZoomModel;
  };
  AxisProxy2.prototype.getDataValueWindow = function() {
    return this._valueWindow.slice();
  };
  AxisProxy2.prototype.getDataPercentWindow = function() {
    return this._percentWindow.slice();
  };
  AxisProxy2.prototype.getTargetSeriesModels = function() {
    var seriesModels = [];
    this.ecModel.eachSeries(function(seriesModel) {
      if (isCoordSupported(seriesModel)) {
        var axisMainType = getAxisMainType(this._dimName);
        var axisModel = seriesModel.getReferringComponents(axisMainType, SINGLE_REFERRING).models[0];
        if (axisModel && this._axisIndex === axisModel.componentIndex) {
          seriesModels.push(seriesModel);
        }
      }
    }, this);
    return seriesModels;
  };
  AxisProxy2.prototype.getAxisModel = function() {
    return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
  };
  AxisProxy2.prototype.getMinMaxSpan = function() {
    return clone$4(this._minMaxSpan);
  };
  AxisProxy2.prototype.calculateDataWindow = function(opt) {
    var dataExtent = this._dataExtent;
    var axisModel = this.getAxisModel();
    var scale2 = axisModel.axis.scale;
    var rangePropMode = this._dataZoomModel.getRangePropMode();
    var percentExtent = [0, 100];
    var percentWindow = [];
    var valueWindow = [];
    var hasPropModeValue;
    each$8(["start", "end"], function(prop, idx) {
      var boundPercent = opt[prop];
      var boundValue = opt[prop + "Value"];
      if (rangePropMode[idx] === "percent") {
        boundPercent == null && (boundPercent = percentExtent[idx]);
        boundValue = scale2.parse(linearMap$2(boundPercent, percentExtent, dataExtent));
      } else {
        hasPropModeValue = true;
        boundValue = boundValue == null ? dataExtent[idx] : scale2.parse(boundValue);
        boundPercent = linearMap$2(boundValue, dataExtent, percentExtent);
      }
      valueWindow[idx] = boundValue;
      percentWindow[idx] = boundPercent;
    });
    asc$1(valueWindow);
    asc$1(percentWindow);
    var spans = this._minMaxSpan;
    hasPropModeValue ? restrictSet(valueWindow, percentWindow, dataExtent, percentExtent, false) : restrictSet(percentWindow, valueWindow, percentExtent, dataExtent, true);
    function restrictSet(fromWindow, toWindow, fromExtent, toExtent, toValue) {
      var suffix = toValue ? "Span" : "ValueSpan";
      sliderMove(0, fromWindow, fromExtent, "all", spans["min" + suffix], spans["max" + suffix]);
      for (var i = 0; i < 2; i++) {
        toWindow[i] = linearMap$2(fromWindow[i], fromExtent, toExtent, true);
        toValue && (toWindow[i] = scale2.parse(toWindow[i]));
      }
    }
    return {
      valueWindow,
      percentWindow
    };
  };
  AxisProxy2.prototype.reset = function(dataZoomModel) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var targetSeries = this.getTargetSeriesModels();
    this._dataExtent = calculateDataExtent(this, this._dimName, targetSeries);
    this._updateMinMaxSpan();
    var dataWindow = this.calculateDataWindow(dataZoomModel.settledOption);
    this._valueWindow = dataWindow.valueWindow;
    this._percentWindow = dataWindow.percentWindow;
    this._setAxisModel();
  };
  AxisProxy2.prototype.filterData = function(dataZoomModel, api) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var axisDim = this._dimName;
    var seriesModels = this.getTargetSeriesModels();
    var filterMode = dataZoomModel.get("filterMode");
    var valueWindow = this._valueWindow;
    if (filterMode === "none") {
      return;
    }
    each$8(seriesModels, function(seriesModel) {
      var seriesData = seriesModel.getData();
      var dataDims = seriesData.mapDimensionsAll(axisDim);
      if (!dataDims.length) {
        return;
      }
      if (filterMode === "weakFilter") {
        var store_1 = seriesData.getStore();
        var dataDimIndices_1 = map$1(dataDims, function(dim) {
          return seriesData.getDimensionIndex(dim);
        }, seriesData);
        seriesData.filterSelf(function(dataIndex) {
          var leftOut;
          var rightOut;
          var hasValue;
          for (var i = 0; i < dataDims.length; i++) {
            var value = store_1.get(dataDimIndices_1[i], dataIndex);
            var thisHasValue = !isNaN(value);
            var thisLeftOut = value < valueWindow[0];
            var thisRightOut = value > valueWindow[1];
            if (thisHasValue && !thisLeftOut && !thisRightOut) {
              return true;
            }
            thisHasValue && (hasValue = true);
            thisLeftOut && (leftOut = true);
            thisRightOut && (rightOut = true);
          }
          return hasValue && leftOut && rightOut;
        });
      } else {
        each$8(dataDims, function(dim) {
          if (filterMode === "empty") {
            seriesModel.setData(seriesData = seriesData.map(dim, function(value) {
              return !isInWindow(value) ? NaN : value;
            }));
          } else {
            var range3 = {};
            range3[dim] = valueWindow;
            seriesData.selectRange(range3);
          }
        });
      }
      each$8(dataDims, function(dim) {
        seriesData.setApproximateExtent(valueWindow, dim);
      });
    });
    function isInWindow(value) {
      return value >= valueWindow[0] && value <= valueWindow[1];
    }
  };
  AxisProxy2.prototype._updateMinMaxSpan = function() {
    var minMaxSpan = this._minMaxSpan = {};
    var dataZoomModel = this._dataZoomModel;
    var dataExtent = this._dataExtent;
    each$8(["min", "max"], function(minMax) {
      var percentSpan = dataZoomModel.get(minMax + "Span");
      var valueSpan = dataZoomModel.get(minMax + "ValueSpan");
      valueSpan != null && (valueSpan = this.getAxisModel().axis.scale.parse(valueSpan));
      if (valueSpan != null) {
        percentSpan = linearMap$2(dataExtent[0] + valueSpan, dataExtent, [0, 100], true);
      } else if (percentSpan != null) {
        valueSpan = linearMap$2(percentSpan, [0, 100], dataExtent, true) - dataExtent[0];
      }
      minMaxSpan[minMax + "Span"] = percentSpan;
      minMaxSpan[minMax + "ValueSpan"] = valueSpan;
    }, this);
  };
  AxisProxy2.prototype._setAxisModel = function() {
    var axisModel = this.getAxisModel();
    var percentWindow = this._percentWindow;
    var valueWindow = this._valueWindow;
    if (!percentWindow) {
      return;
    }
    var precision = getPixelPrecision(valueWindow, [0, 500]);
    precision = Math.min(precision, 20);
    var rawExtentInfo = axisModel.axis.scale.rawExtentInfo;
    if (percentWindow[0] !== 0) {
      rawExtentInfo.setDeterminedMinMax("min", +valueWindow[0].toFixed(precision));
    }
    if (percentWindow[1] !== 100) {
      rawExtentInfo.setDeterminedMinMax("max", +valueWindow[1].toFixed(precision));
    }
    rawExtentInfo.freeze();
  };
  return AxisProxy2;
}();
function calculateDataExtent(axisProxy, axisDim, seriesModels) {
  var dataExtent = [Infinity, -Infinity];
  each$8(seriesModels, function(seriesModel) {
    unionAxisExtentFromData(dataExtent, seriesModel.getData(), axisDim);
  });
  var axisModel = axisProxy.getAxisModel();
  var rawExtentResult = ensureScaleRawExtentInfo(axisModel.axis.scale, axisModel, dataExtent).calculate();
  return [rawExtentResult.min, rawExtentResult.max];
}
var AxisProxy$1 = AxisProxy;
var dataZoomProcessor = {
  getTargetSeries: function(ecModel) {
    function eachAxisModel(cb2) {
      ecModel.eachComponent("dataZoom", function(dataZoomModel) {
        dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
          var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
          cb2(axisDim, axisIndex, axisModel, dataZoomModel);
        });
      });
    }
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      axisModel.__dzAxisProxy = null;
    });
    var proxyList = [];
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      if (!axisModel.__dzAxisProxy) {
        axisModel.__dzAxisProxy = new AxisProxy$1(axisDim, axisIndex, dataZoomModel, ecModel);
        proxyList.push(axisModel.__dzAxisProxy);
      }
    });
    var seriesModelMap = createHashMap();
    each$g(proxyList, function(axisProxy) {
      each$g(axisProxy.getTargetSeriesModels(), function(seriesModel) {
        seriesModelMap.set(seriesModel.uid, seriesModel);
      });
    });
    return seriesModelMap;
  },
  overallReset: function(ecModel, api) {
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).reset(dataZoomModel);
      });
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).filterData(dataZoomModel, api);
      });
    });
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var percentRange = axisProxy.getDataPercentWindow();
        var valueRange = axisProxy.getDataValueWindow();
        dataZoomModel.setCalculatedRange({
          start: percentRange[0],
          end: percentRange[1],
          startValue: valueRange[0],
          endValue: valueRange[1]
        });
      }
    });
  }
};
var dataZoomProcessor$1 = dataZoomProcessor;
function installDataZoomAction(registers) {
  registers.registerAction("dataZoom", function(payload, ecModel) {
    var effectedModels = findEffectedDataZooms(ecModel, payload);
    each$g(effectedModels, function(dataZoomModel) {
      dataZoomModel.setRawRange({
        start: payload.start,
        end: payload.end,
        startValue: payload.startValue,
        endValue: payload.endValue
      });
    });
  });
}
var installed$1 = false;
function installCommon$1(registers) {
  if (installed$1) {
    return;
  }
  installed$1 = true;
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, dataZoomProcessor$1);
  installDataZoomAction(registers);
  registers.registerSubTypeDefaulter("dataZoom", function() {
    return "slider";
  });
}
function install$k(registers) {
  registers.registerComponentModel(SelectZoomModel);
  registers.registerComponentView(SelectZoomView);
  installCommon$1(registers);
}
var ToolboxFeature = function() {
  function ToolboxFeature2() {
  }
  return ToolboxFeature2;
}();
var features = {};
function registerFeature(name2, ctor) {
  features[name2] = ctor;
}
function getFeature(name2) {
  return features[name2];
}
var ToolboxModel = function(_super) {
  __extends(ToolboxModel2, _super);
  function ToolboxModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ToolboxModel2.type;
    return _this;
  }
  ToolboxModel2.prototype.optionUpdated = function() {
    _super.prototype.optionUpdated.apply(this, arguments);
    var ecModel = this.ecModel;
    each$g(this.option.feature, function(featureOpt, featureName) {
      var Feature = getFeature(featureName);
      if (Feature) {
        if (Feature.getDefaultOption) {
          Feature.defaultOption = Feature.getDefaultOption(ecModel);
        }
        merge$1(featureOpt, Feature.defaultOption);
      }
    });
  };
  ToolboxModel2.type = "toolbox";
  ToolboxModel2.layoutMode = {
    type: "box",
    ignoreSize: true
  };
  ToolboxModel2.defaultOption = {
    show: true,
    z: 6,
    orient: "horizontal",
    left: "right",
    top: "top",
    backgroundColor: "transparent",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemSize: 15,
    itemGap: 8,
    showTitle: true,
    iconStyle: {
      borderColor: "#666",
      color: "none"
    },
    emphasis: {
      iconStyle: {
        borderColor: "#3E98C5"
      }
    },
    tooltip: {
      show: false,
      position: "bottom"
    }
  };
  return ToolboxModel2;
}(ComponentModel$1);
var ToolboxModel$1 = ToolboxModel;
function layout(group, componentModel, api) {
  var boxLayoutParams = componentModel.getBoxLayoutParams();
  var padding = componentModel.get("padding");
  var viewportSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var rect = getLayoutRect(boxLayoutParams, viewportSize, padding);
  box(componentModel.get("orient"), group, componentModel.get("itemGap"), rect.width, rect.height);
  positionElement(group, boxLayoutParams, viewportSize, padding);
}
function makeBackground(rect, componentModel) {
  var padding = normalizeCssArray(componentModel.get("padding"));
  var style2 = componentModel.getItemStyle(["color", "opacity"]);
  style2.fill = componentModel.get("backgroundColor");
  rect = new Rect$3({
    shape: {
      x: rect.x - padding[3],
      y: rect.y - padding[0],
      width: rect.width + padding[1] + padding[3],
      height: rect.height + padding[0] + padding[2],
      r: componentModel.get("borderRadius")
    },
    style: style2,
    silent: true,
    z2: -1
  });
  return rect;
}
var ToolboxView = function(_super) {
  __extends(ToolboxView2, _super);
  function ToolboxView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ToolboxView2.prototype.render = function(toolboxModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    if (!toolboxModel.get("show")) {
      return;
    }
    var itemSize = +toolboxModel.get("itemSize");
    var featureOpts = toolboxModel.get("feature") || {};
    var features2 = this._features || (this._features = {});
    var featureNames = [];
    each$g(featureOpts, function(opt, name2) {
      featureNames.push(name2);
    });
    new DataDiffer$1(this._featureNames || [], featureNames).add(processFeature).update(processFeature).remove(curry$3(processFeature, null)).execute();
    this._featureNames = featureNames;
    function processFeature(newIndex, oldIndex) {
      var featureName = featureNames[newIndex];
      var oldName = featureNames[oldIndex];
      var featureOpt = featureOpts[featureName];
      var featureModel = new Model$1(featureOpt, toolboxModel, toolboxModel.ecModel);
      var feature;
      if (payload && payload.newTitle != null && payload.featureName === featureName) {
        featureOpt.title = payload.newTitle;
      }
      if (featureName && !oldName) {
        if (isUserFeatureName(featureName)) {
          feature = {
            onclick: featureModel.option.onclick,
            featureName
          };
        } else {
          var Feature = getFeature(featureName);
          if (!Feature) {
            return;
          }
          feature = new Feature();
        }
        features2[featureName] = feature;
      } else {
        feature = features2[oldName];
        if (!feature) {
          return;
        }
      }
      feature.uid = getUID("toolbox-feature");
      feature.model = featureModel;
      feature.ecModel = ecModel;
      feature.api = api;
      var isToolboxFeature = feature instanceof ToolboxFeature;
      if (!featureName && oldName) {
        isToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
        return;
      }
      if (!featureModel.get("show") || isToolboxFeature && feature.unusable) {
        isToolboxFeature && feature.remove && feature.remove(ecModel, api);
        return;
      }
      createIconPaths(featureModel, feature, featureName);
      featureModel.setIconStatus = function(iconName, status) {
        var option = this.option;
        var iconPaths = this.iconPaths;
        option.iconStatus = option.iconStatus || {};
        option.iconStatus[iconName] = status;
        if (iconPaths[iconName]) {
          (status === "emphasis" ? enterEmphasis : leaveEmphasis)(iconPaths[iconName]);
        }
      };
      if (feature instanceof ToolboxFeature) {
        if (feature.render) {
          feature.render(featureModel, ecModel, api, payload);
        }
      }
    }
    function createIconPaths(featureModel, feature, featureName) {
      var iconStyleModel = featureModel.getModel("iconStyle");
      var iconStyleEmphasisModel = featureModel.getModel(["emphasis", "iconStyle"]);
      var icons = feature instanceof ToolboxFeature && feature.getIcons ? feature.getIcons() : featureModel.get("icon");
      var titles = featureModel.get("title") || {};
      var iconsMap;
      var titlesMap;
      if (isString$1(icons)) {
        iconsMap = {};
        iconsMap[featureName] = icons;
      } else {
        iconsMap = icons;
      }
      if (isString$1(titles)) {
        titlesMap = {};
        titlesMap[featureName] = titles;
      } else {
        titlesMap = titles;
      }
      var iconPaths = featureModel.iconPaths = {};
      each$g(iconsMap, function(iconStr, iconName) {
        var path = createIcon(iconStr, {}, {
          x: -itemSize / 2,
          y: -itemSize / 2,
          width: itemSize,
          height: itemSize
        });
        path.setStyle(iconStyleModel.getItemStyle());
        var pathEmphasisState = path.ensureState("emphasis");
        pathEmphasisState.style = iconStyleEmphasisModel.getItemStyle();
        var textContent = new ZRText$1({
          style: {
            text: titlesMap[iconName],
            align: iconStyleEmphasisModel.get("textAlign"),
            borderRadius: iconStyleEmphasisModel.get("textBorderRadius"),
            padding: iconStyleEmphasisModel.get("textPadding"),
            fill: null
          },
          ignore: true
        });
        path.setTextContent(textContent);
        setTooltipConfig({
          el: path,
          componentModel: toolboxModel,
          itemName: iconName,
          formatterParamsExtra: {
            title: titlesMap[iconName]
          }
        });
        path.__title = titlesMap[iconName];
        path.on("mouseover", function() {
          var hoverStyle = iconStyleEmphasisModel.getItemStyle();
          var defaultTextPosition = toolboxModel.get("orient") === "vertical" ? toolboxModel.get("right") == null ? "right" : "left" : toolboxModel.get("bottom") == null ? "bottom" : "top";
          textContent.setStyle({
            fill: iconStyleEmphasisModel.get("textFill") || hoverStyle.fill || hoverStyle.stroke || "#000",
            backgroundColor: iconStyleEmphasisModel.get("textBackgroundColor")
          });
          path.setTextConfig({
            position: iconStyleEmphasisModel.get("textPosition") || defaultTextPosition
          });
          textContent.ignore = !toolboxModel.get("showTitle");
          enterEmphasis(this);
        }).on("mouseout", function() {
          if (featureModel.get(["iconStatus", iconName]) !== "emphasis") {
            leaveEmphasis(this);
          }
          textContent.hide();
        });
        (featureModel.get(["iconStatus", iconName]) === "emphasis" ? enterEmphasis : leaveEmphasis)(path);
        group.add(path);
        path.on("click", bind$1(feature.onclick, feature, ecModel, api, iconName));
        iconPaths[iconName] = path;
      });
    }
    layout(group, toolboxModel, api);
    group.add(makeBackground(group.getBoundingRect(), toolboxModel));
    group.eachChild(function(icon) {
      var titleText = icon.__title;
      var emphasisState = icon.ensureState("emphasis");
      var emphasisTextConfig = emphasisState.textConfig || (emphasisState.textConfig = {});
      var textContent = icon.getTextContent();
      var emphasisTextState = textContent && textContent.states.emphasis;
      if (emphasisTextState && !isFunction$1(emphasisTextState) && titleText) {
        var emphasisTextStyle = emphasisTextState.style || (emphasisTextState.style = {});
        var rect = getBoundingRect(titleText, ZRText$1.makeFont(emphasisTextStyle));
        var offsetX = icon.x + group.x;
        var offsetY = icon.y + group.y + itemSize;
        var needPutOnTop = false;
        if (offsetY + rect.height > api.getHeight()) {
          emphasisTextConfig.position = "top";
          needPutOnTop = true;
        }
        var topOffset = needPutOnTop ? -5 - rect.height : itemSize + 8;
        if (offsetX + rect.width / 2 > api.getWidth()) {
          emphasisTextConfig.position = ["100%", topOffset];
          emphasisTextStyle.align = "right";
        } else if (offsetX - rect.width / 2 < 0) {
          emphasisTextConfig.position = [0, topOffset];
          emphasisTextStyle.align = "left";
        }
      }
    });
  };
  ToolboxView2.prototype.updateView = function(toolboxModel, ecModel, api, payload) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.updateView && feature.updateView(feature.model, ecModel, api, payload);
    });
  };
  ToolboxView2.prototype.remove = function(ecModel, api) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.remove && feature.remove(ecModel, api);
    });
    this.group.removeAll();
  };
  ToolboxView2.prototype.dispose = function(ecModel, api) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
    });
  };
  ToolboxView2.type = "toolbox";
  return ToolboxView2;
}(ComponentView$1);
function isUserFeatureName(featureName) {
  return featureName.indexOf("my") === 0;
}
var ToolboxView$1 = ToolboxView;
var SaveAsImage = function(_super) {
  __extends(SaveAsImage2, _super);
  function SaveAsImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SaveAsImage2.prototype.onclick = function(ecModel, api) {
    var model = this.model;
    var title = model.get("name") || ecModel.get("title.0.text") || "echarts";
    var isSvg = api.getZr().painter.getType() === "svg";
    var type4 = isSvg ? "svg" : model.get("type", true) || "png";
    var url2 = api.getConnectedDataURL({
      type: type4,
      backgroundColor: model.get("backgroundColor", true) || ecModel.get("backgroundColor") || "#fff",
      connectedBackgroundColor: model.get("connectedBackgroundColor"),
      excludeComponents: model.get("excludeComponents"),
      pixelRatio: model.get("pixelRatio")
    });
    var browser = env$1.browser;
    if (isFunction$1(MouseEvent) && (browser.newEdge || !browser.ie && !browser.edge)) {
      var $a2 = document.createElement("a");
      $a2.download = title + "." + type4;
      $a2.target = "_blank";
      $a2.href = url2;
      var evt = new MouseEvent("click", {
        view: document.defaultView,
        bubbles: true,
        cancelable: false
      });
      $a2.dispatchEvent(evt);
    } else {
      if (window.navigator.msSaveOrOpenBlob || isSvg) {
        var parts = url2.split(",");
        var base64Encoded = parts[0].indexOf("base64") > -1;
        var bstr = isSvg ? decodeURIComponent(parts[1]) : parts[1];
        base64Encoded && (bstr = window.atob(bstr));
        var filename = title + "." + type4;
        if (window.navigator.msSaveOrOpenBlob) {
          var n2 = bstr.length;
          var u8arr = new Uint8Array(n2);
          while (n2--) {
            u8arr[n2] = bstr.charCodeAt(n2);
          }
          var blob = new Blob([u8arr]);
          window.navigator.msSaveOrOpenBlob(blob, filename);
        } else {
          var frame = document.createElement("iframe");
          document.body.appendChild(frame);
          var cw = frame.contentWindow;
          var doc = cw.document;
          doc.open("image/svg+xml", "replace");
          doc.write(bstr);
          doc.close();
          cw.focus();
          doc.execCommand("SaveAs", true, filename);
          document.body.removeChild(frame);
        }
      } else {
        var lang = model.get("lang");
        var html = '<body style="margin:0;"><img src="' + url2 + '" style="max-width:100%;" title="' + (lang && lang[0] || "") + '" /></body>';
        var tab = window.open();
        tab.document.write(html);
        tab.document.title = title;
      }
    }
  };
  SaveAsImage2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0",
      title: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "title"]),
      type: "png",
      connectedBackgroundColor: "#fff",
      name: "",
      excludeComponents: ["toolbox"],
      lang: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "lang"])
    };
    return defaultOption2;
  };
  return SaveAsImage2;
}(ToolboxFeature);
var SaveAsImage$1 = SaveAsImage;
var INNER_STACK_KEYWORD = "__ec_magicType_stack__";
var radioTypes = [["line", "bar"], ["stack"]];
var MagicType = function(_super) {
  __extends(MagicType2, _super);
  function MagicType2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  MagicType2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon");
    var icons = {};
    each$g(model.get("type"), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  MagicType2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: [],
      icon: {
        line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4",
        bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7",
        stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "magicType", "title"]),
      option: {},
      seriesIndex: {}
    };
    return defaultOption2;
  };
  MagicType2.prototype.onclick = function(ecModel, api, type4) {
    var model = this.model;
    var seriesIndex = model.get(["seriesIndex", type4]);
    if (!seriesOptGenreator[type4]) {
      return;
    }
    var newOption = {
      series: []
    };
    var generateNewSeriesTypes = function(seriesModel) {
      var seriesType2 = seriesModel.subType;
      var seriesId = seriesModel.id;
      var newSeriesOpt = seriesOptGenreator[type4](seriesType2, seriesId, seriesModel, model);
      if (newSeriesOpt) {
        defaults(newSeriesOpt, seriesModel.option);
        newOption.series.push(newSeriesOpt);
      }
      var coordSys = seriesModel.coordinateSystem;
      if (coordSys && coordSys.type === "cartesian2d" && (type4 === "line" || type4 === "bar")) {
        var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
        if (categoryAxis2) {
          var axisDim = categoryAxis2.dim;
          var axisType = axisDim + "Axis";
          var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
          var axisIndex = axisModel.componentIndex;
          newOption[axisType] = newOption[axisType] || [];
          for (var i = 0; i <= axisIndex; i++) {
            newOption[axisType][axisIndex] = newOption[axisType][axisIndex] || {};
          }
          newOption[axisType][axisIndex].boundaryGap = type4 === "bar";
        }
      }
    };
    each$g(radioTypes, function(radio) {
      if (indexOf(radio, type4) >= 0) {
        each$g(radio, function(item) {
          model.setIconStatus(item, "normal");
        });
      }
    });
    model.setIconStatus(type4, "emphasis");
    ecModel.eachComponent({
      mainType: "series",
      query: seriesIndex == null ? null : {
        seriesIndex
      }
    }, generateNewSeriesTypes);
    var newTitle;
    var currentType = type4;
    if (type4 === "stack") {
      newTitle = merge$1({
        stack: model.option.title.tiled,
        tiled: model.option.title.stack
      }, model.option.title);
      if (model.get(["iconStatus", type4]) !== "emphasis") {
        currentType = "tiled";
      }
    }
    api.dispatchAction({
      type: "changeMagicType",
      currentType,
      newOption,
      newTitle,
      featureName: "magicType"
    });
  };
  return MagicType2;
}(ToolboxFeature);
var seriesOptGenreator = {
  "line": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "bar") {
      return merge$1({
        id: seriesId,
        type: "line",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "line"]) || {}, true);
    }
  },
  "bar": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "line") {
      return merge$1({
        id: seriesId,
        type: "bar",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "bar"]) || {}, true);
    }
  },
  "stack": function(seriesType2, seriesId, seriesModel, model) {
    var isStack = seriesModel.get("stack") === INNER_STACK_KEYWORD;
    if (seriesType2 === "line" || seriesType2 === "bar") {
      model.setIconStatus("stack", isStack ? "normal" : "emphasis");
      return merge$1({
        id: seriesId,
        stack: isStack ? "" : INNER_STACK_KEYWORD
      }, model.get(["option", "stack"]) || {}, true);
    }
  }
};
registerAction({
  type: "changeMagicType",
  event: "magicTypeChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.mergeOption(payload.newOption);
});
var MagicType$1 = MagicType;
var BLOCK_SPLITER = new Array(60).join("-");
var ITEM_SPLITER = "	";
function groupSeries(ecModel) {
  var seriesGroupByCategoryAxis = {};
  var otherSeries = [];
  var meta = [];
  ecModel.eachRawSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && (coordSys.type === "cartesian2d" || coordSys.type === "polar")) {
      var baseAxis = coordSys.getBaseAxis();
      if (baseAxis.type === "category") {
        var key = baseAxis.dim + "_" + baseAxis.index;
        if (!seriesGroupByCategoryAxis[key]) {
          seriesGroupByCategoryAxis[key] = {
            categoryAxis: baseAxis,
            valueAxis: coordSys.getOtherAxis(baseAxis),
            series: []
          };
          meta.push({
            axisDim: baseAxis.dim,
            axisIndex: baseAxis.index
          });
        }
        seriesGroupByCategoryAxis[key].series.push(seriesModel);
      } else {
        otherSeries.push(seriesModel);
      }
    } else {
      otherSeries.push(seriesModel);
    }
  });
  return {
    seriesGroupByCategoryAxis,
    other: otherSeries,
    meta
  };
}
function assembleSeriesWithCategoryAxis(groups) {
  var tables = [];
  each$g(groups, function(group, key) {
    var categoryAxis2 = group.categoryAxis;
    var valueAxis2 = group.valueAxis;
    var valueAxisDim = valueAxis2.dim;
    var headers = [" "].concat(map$1(group.series, function(series) {
      return series.name;
    }));
    var columns = [categoryAxis2.model.getCategories()];
    each$g(group.series, function(series) {
      var rawData = series.getRawData();
      columns.push(series.getRawData().mapArray(rawData.mapDimension(valueAxisDim), function(val) {
        return val;
      }));
    });
    var lines = [headers.join(ITEM_SPLITER)];
    for (var i = 0; i < columns[0].length; i++) {
      var items = [];
      for (var j = 0; j < columns.length; j++) {
        items.push(columns[j][i]);
      }
      lines.push(items.join(ITEM_SPLITER));
    }
    tables.push(lines.join("\n"));
  });
  return tables.join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function assembleOtherSeries(series) {
  return map$1(series, function(series2) {
    var data2 = series2.getRawData();
    var lines = [series2.name];
    var vals = [];
    data2.each(data2.dimensions, function() {
      var argLen = arguments.length;
      var dataIndex = arguments[argLen - 1];
      var name2 = data2.getName(dataIndex);
      for (var i = 0; i < argLen - 1; i++) {
        vals[i] = arguments[i];
      }
      lines.push((name2 ? name2 + ITEM_SPLITER : "") + vals.join(ITEM_SPLITER));
    });
    return lines.join("\n");
  }).join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function getContentFromModel(ecModel) {
  var result = groupSeries(ecModel);
  return {
    value: filter([assembleSeriesWithCategoryAxis(result.seriesGroupByCategoryAxis), assembleOtherSeries(result.other)], function(str) {
      return !!str.replace(/[\n\t\s]/g, "");
    }).join("\n\n" + BLOCK_SPLITER + "\n\n"),
    meta: result.meta
  };
}
function trim(str) {
  return str.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function isTSVFormat(block) {
  var firstLine = block.slice(0, block.indexOf("\n"));
  if (firstLine.indexOf(ITEM_SPLITER) >= 0) {
    return true;
  }
}
var itemSplitRegex = new RegExp("[" + ITEM_SPLITER + "]+", "g");
function parseTSVContents(tsv) {
  var tsvLines = tsv.split(/\n+/g);
  var headers = trim(tsvLines.shift()).split(itemSplitRegex);
  var categories = [];
  var series = map$1(headers, function(header) {
    return {
      name: header,
      data: []
    };
  });
  for (var i = 0; i < tsvLines.length; i++) {
    var items = trim(tsvLines[i]).split(itemSplitRegex);
    categories.push(items.shift());
    for (var j = 0; j < items.length; j++) {
      series[j] && (series[j].data[i] = items[j]);
    }
  }
  return {
    series,
    categories
  };
}
function parseListContents(str) {
  var lines = str.split(/\n+/g);
  var seriesName = trim(lines.shift());
  var data2 = [];
  for (var i = 0; i < lines.length; i++) {
    var line = trim(lines[i]);
    if (!line) {
      continue;
    }
    var items = line.split(itemSplitRegex);
    var name_1 = "";
    var value = void 0;
    var hasName = false;
    if (isNaN(items[0])) {
      hasName = true;
      name_1 = items[0];
      items = items.slice(1);
      data2[i] = {
        name: name_1,
        value: []
      };
      value = data2[i].value;
    } else {
      value = data2[i] = [];
    }
    for (var j = 0; j < items.length; j++) {
      value.push(+items[j]);
    }
    if (value.length === 1) {
      hasName ? data2[i].value = value[0] : data2[i] = value[0];
    }
  }
  return {
    name: seriesName,
    data: data2
  };
}
function parseContents(str, blockMetaList) {
  var blocks = str.split(new RegExp("\n*" + BLOCK_SPLITER + "\n*", "g"));
  var newOption = {
    series: []
  };
  each$g(blocks, function(block, idx) {
    if (isTSVFormat(block)) {
      var result = parseTSVContents(block);
      var blockMeta = blockMetaList[idx];
      var axisKey = blockMeta.axisDim + "Axis";
      if (blockMeta) {
        newOption[axisKey] = newOption[axisKey] || [];
        newOption[axisKey][blockMeta.axisIndex] = {
          data: result.categories
        };
        newOption.series = newOption.series.concat(result.series);
      }
    } else {
      var result = parseListContents(block);
      newOption.series.push(result);
    }
  });
  return newOption;
}
var DataView$1 = function(_super) {
  __extends(DataView2, _super);
  function DataView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataView2.prototype.onclick = function(ecModel, api) {
    setTimeout(function() {
      api.dispatchAction({
        type: "hideTip"
      });
    });
    var container2 = api.getDom();
    var model = this.model;
    if (this._dom) {
      container2.removeChild(this._dom);
    }
    var root2 = document.createElement("div");
    root2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px";
    root2.style.backgroundColor = model.get("backgroundColor") || "#fff";
    var header = document.createElement("h4");
    var lang = model.get("lang") || [];
    header.innerHTML = lang[0] || model.get("title");
    header.style.cssText = "margin:10px 20px";
    header.style.color = model.get("textColor");
    var viewMain = document.createElement("div");
    var textarea = document.createElement("textarea");
    viewMain.style.cssText = "overflow:auto";
    var optionToContent = model.get("optionToContent");
    var contentToOption = model.get("contentToOption");
    var result = getContentFromModel(ecModel);
    if (isFunction$1(optionToContent)) {
      var htmlOrDom = optionToContent(api.getOption());
      if (isString$1(htmlOrDom)) {
        viewMain.innerHTML = htmlOrDom;
      } else if (isDom(htmlOrDom)) {
        viewMain.appendChild(htmlOrDom);
      }
    } else {
      textarea.readOnly = model.get("readOnly");
      var style2 = textarea.style;
      style2.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none";
      style2.color = model.get("textColor");
      style2.borderColor = model.get("textareaBorderColor");
      style2.backgroundColor = model.get("textareaColor");
      textarea.value = result.value;
      viewMain.appendChild(textarea);
    }
    var blockMetaList = result.meta;
    var buttonContainer = document.createElement("div");
    buttonContainer.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
    var buttonStyle = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px";
    var closeButton = document.createElement("div");
    var refreshButton = document.createElement("div");
    buttonStyle += ";background-color:" + model.get("buttonColor");
    buttonStyle += ";color:" + model.get("buttonTextColor");
    var self2 = this;
    function close() {
      container2.removeChild(root2);
      self2._dom = null;
    }
    addEventListener$1(closeButton, "click", close);
    addEventListener$1(refreshButton, "click", function() {
      if (contentToOption == null && optionToContent != null || contentToOption != null && optionToContent == null) {
        close();
        return;
      }
      var newOption;
      try {
        if (isFunction$1(contentToOption)) {
          newOption = contentToOption(viewMain, api.getOption());
        } else {
          newOption = parseContents(textarea.value, blockMetaList);
        }
      } catch (e2) {
        close();
        throw new Error("Data view format error " + e2);
      }
      if (newOption) {
        api.dispatchAction({
          type: "changeDataView",
          newOption
        });
      }
      close();
    });
    closeButton.innerHTML = lang[1];
    refreshButton.innerHTML = lang[2];
    refreshButton.style.cssText = closeButton.style.cssText = buttonStyle;
    !model.get("readOnly") && buttonContainer.appendChild(refreshButton);
    buttonContainer.appendChild(closeButton);
    root2.appendChild(header);
    root2.appendChild(viewMain);
    root2.appendChild(buttonContainer);
    viewMain.style.height = container2.clientHeight - 80 + "px";
    container2.appendChild(root2);
    this._dom = root2;
  };
  DataView2.prototype.remove = function(ecModel, api) {
    this._dom && api.getDom().removeChild(this._dom);
  };
  DataView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  DataView2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      readOnly: false,
      optionToContent: null,
      contentToOption: null,
      icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28",
      title: ecModel.getLocaleModel().get(["toolbox", "dataView", "title"]),
      lang: ecModel.getLocaleModel().get(["toolbox", "dataView", "lang"]),
      backgroundColor: "#fff",
      textColor: "#000",
      textareaColor: "#fff",
      textareaBorderColor: "#333",
      buttonColor: "#c23531",
      buttonTextColor: "#fff"
    };
    return defaultOption2;
  };
  return DataView2;
}(ToolboxFeature);
function tryMergeDataOption(newData, originalData) {
  return map$1(newData, function(newVal, idx) {
    var original = originalData && originalData[idx];
    if (isObject$6(original) && !isArray$2(original)) {
      var newValIsObject = isObject$6(newVal) && !isArray$2(newVal);
      if (!newValIsObject) {
        newVal = {
          value: newVal
        };
      }
      var shouldDeleteName = original.name != null && newVal.name == null;
      newVal = defaults(newVal, original);
      shouldDeleteName && delete newVal.name;
      return newVal;
    } else {
      return newVal;
    }
  });
}
registerAction({
  type: "changeDataView",
  event: "dataViewChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  var newSeriesOptList = [];
  each$g(payload.newOption.series, function(seriesOpt) {
    var seriesModel = ecModel.getSeriesByName(seriesOpt.name)[0];
    if (!seriesModel) {
      newSeriesOptList.push(extend({
        type: "scatter"
      }, seriesOpt));
    } else {
      var originalData = seriesModel.get("data");
      newSeriesOptList.push({
        name: seriesOpt.name,
        data: tryMergeDataOption(seriesOpt.data, originalData)
      });
    }
  });
  ecModel.mergeOption(defaults({
    series: newSeriesOptList
  }, payload.newOption));
});
var DataView$2 = DataView$1;
var each$7 = each$g;
var inner$6 = makeInner();
function push(ecModel, newSnapshot) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  each$7(newSnapshot, function(batchItem, dataZoomId) {
    var i = storedSnapshots.length - 1;
    for (; i >= 0; i--) {
      var snapshot = storedSnapshots[i];
      if (snapshot[dataZoomId]) {
        break;
      }
    }
    if (i < 0) {
      var dataZoomModel = ecModel.queryComponents({
        mainType: "dataZoom",
        subType: "select",
        id: dataZoomId
      })[0];
      if (dataZoomModel) {
        var percentRange = dataZoomModel.getPercentRange();
        storedSnapshots[0][dataZoomId] = {
          dataZoomId,
          start: percentRange[0],
          end: percentRange[1]
        };
      }
    }
  });
  storedSnapshots.push(newSnapshot);
}
function pop(ecModel) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  var head = storedSnapshots[storedSnapshots.length - 1];
  storedSnapshots.length > 1 && storedSnapshots.pop();
  var snapshot = {};
  each$7(head, function(batchItem, dataZoomId) {
    for (var i = storedSnapshots.length - 1; i >= 0; i--) {
      batchItem = storedSnapshots[i][dataZoomId];
      if (batchItem) {
        snapshot[dataZoomId] = batchItem;
        break;
      }
    }
  });
  return snapshot;
}
function clear(ecModel) {
  inner$6(ecModel).snapshots = null;
}
function count(ecModel) {
  return getStoreSnapshots(ecModel).length;
}
function getStoreSnapshots(ecModel) {
  var store = inner$6(ecModel);
  if (!store.snapshots) {
    store.snapshots = [{}];
  }
  return store.snapshots;
}
var RestoreOption = function(_super) {
  __extends(RestoreOption2, _super);
  function RestoreOption2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  RestoreOption2.prototype.onclick = function(ecModel, api) {
    clear(ecModel);
    api.dispatchAction({
      type: "restore",
      from: this.uid
    });
  };
  RestoreOption2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5",
      title: ecModel.getLocaleModel().get(["toolbox", "restore", "title"])
    };
    return defaultOption2;
  };
  return RestoreOption2;
}(ToolboxFeature);
registerAction({
  type: "restore",
  event: "restore",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.resetOption("recreate");
});
var Restore = RestoreOption;
var INCLUDE_FINDER_MAIN_TYPES = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"];
var BrushTargetManager = function() {
  function BrushTargetManager2(finder, ecModel, opt) {
    var _this = this;
    this._targetInfoList = [];
    var foundCpts = parseFinder(ecModel, finder);
    each$g(targetInfoBuilders, function(builder, type4) {
      if (!opt || !opt.include || indexOf(opt.include, type4) >= 0) {
        builder(foundCpts, _this._targetInfoList);
      }
    });
  }
  BrushTargetManager2.prototype.setOutputRanges = function(areas, ecModel) {
    this.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      (area.coordRanges || (area.coordRanges = [])).push(coordRange);
      if (!area.coordRange) {
        area.coordRange = coordRange;
        var result = coordConvert[area.brushType](0, coordSys, coordRange);
        area.__rangeOffset = {
          offset: diffProcessor[area.brushType](result.values, area.range, [1, 1]),
          xyMinMax: result.xyMinMax
        };
      }
    });
    return areas;
  };
  BrushTargetManager2.prototype.matchOutputRanges = function(areas, ecModel, cb2) {
    each$g(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      if (targetInfo && targetInfo !== true) {
        each$g(targetInfo.coordSyses, function(coordSys) {
          var result = coordConvert[area.brushType](1, coordSys, area.range, true);
          cb2(area, result.values, coordSys, ecModel);
        });
      }
    }, this);
  };
  BrushTargetManager2.prototype.setInputRanges = function(areas, ecModel) {
    each$g(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      area.range = area.range || [];
      if (targetInfo && targetInfo !== true) {
        area.panelId = targetInfo.panelId;
        var result = coordConvert[area.brushType](0, targetInfo.coordSys, area.coordRange);
        var rangeOffset = area.__rangeOffset;
        area.range = rangeOffset ? diffProcessor[area.brushType](result.values, rangeOffset.offset, getScales(result.xyMinMax, rangeOffset.xyMinMax)) : result.values;
      }
    }, this);
  };
  BrushTargetManager2.prototype.makePanelOpts = function(api, getDefaultBrushType) {
    return map$1(this._targetInfoList, function(targetInfo) {
      var rect = targetInfo.getPanelRect();
      return {
        panelId: targetInfo.panelId,
        defaultBrushType: getDefaultBrushType ? getDefaultBrushType(targetInfo) : null,
        clipPath: makeRectPanelClipPath(rect),
        isTargetByCursor: makeRectIsTargetByCursor(rect, api, targetInfo.coordSysModel),
        getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect)
      };
    });
  };
  BrushTargetManager2.prototype.controlSeries = function(area, seriesModel, ecModel) {
    var targetInfo = this.findTargetInfo(area, ecModel);
    return targetInfo === true || targetInfo && indexOf(targetInfo.coordSyses, seriesModel.coordinateSystem) >= 0;
  };
  BrushTargetManager2.prototype.findTargetInfo = function(area, ecModel) {
    var targetInfoList = this._targetInfoList;
    var foundCpts = parseFinder(ecModel, area);
    for (var i = 0; i < targetInfoList.length; i++) {
      var targetInfo = targetInfoList[i];
      var areaPanelId = area.panelId;
      if (areaPanelId) {
        if (targetInfo.panelId === areaPanelId) {
          return targetInfo;
        }
      } else {
        for (var j = 0; j < targetInfoMatchers.length; j++) {
          if (targetInfoMatchers[j](foundCpts, targetInfo)) {
            return targetInfo;
          }
        }
      }
    }
    return true;
  };
  return BrushTargetManager2;
}();
function formatMinMax(minMax) {
  minMax[0] > minMax[1] && minMax.reverse();
  return minMax;
}
function parseFinder(ecModel, finder) {
  return parseFinder$1(ecModel, finder, {
    includeMainTypes: INCLUDE_FINDER_MAIN_TYPES
  });
}
var targetInfoBuilders = {
  grid: function(foundCpts, targetInfoList) {
    var xAxisModels = foundCpts.xAxisModels;
    var yAxisModels = foundCpts.yAxisModels;
    var gridModels = foundCpts.gridModels;
    var gridModelMap = createHashMap();
    var xAxesHas = {};
    var yAxesHas = {};
    if (!xAxisModels && !yAxisModels && !gridModels) {
      return;
    }
    each$g(xAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
    });
    each$g(yAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      yAxesHas[gridModel.id] = true;
    });
    each$g(gridModels, function(gridModel) {
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
      yAxesHas[gridModel.id] = true;
    });
    gridModelMap.each(function(gridModel) {
      var grid = gridModel.coordinateSystem;
      var cartesians = [];
      each$g(grid.getCartesians(), function(cartesian, index2) {
        if (indexOf(xAxisModels, cartesian.getAxis("x").model) >= 0 || indexOf(yAxisModels, cartesian.getAxis("y").model) >= 0) {
          cartesians.push(cartesian);
        }
      });
      targetInfoList.push({
        panelId: "grid--" + gridModel.id,
        gridModel,
        coordSysModel: gridModel,
        coordSys: cartesians[0],
        coordSyses: cartesians,
        getPanelRect: panelRectBuilders.grid,
        xAxisDeclared: xAxesHas[gridModel.id],
        yAxisDeclared: yAxesHas[gridModel.id]
      });
    });
  },
  geo: function(foundCpts, targetInfoList) {
    each$g(foundCpts.geoModels, function(geoModel) {
      var coordSys = geoModel.coordinateSystem;
      targetInfoList.push({
        panelId: "geo--" + geoModel.id,
        geoModel,
        coordSysModel: geoModel,
        coordSys,
        coordSyses: [coordSys],
        getPanelRect: panelRectBuilders.geo
      });
    });
  }
};
var targetInfoMatchers = [
  function(foundCpts, targetInfo) {
    var xAxisModel = foundCpts.xAxisModel;
    var yAxisModel = foundCpts.yAxisModel;
    var gridModel = foundCpts.gridModel;
    !gridModel && xAxisModel && (gridModel = xAxisModel.axis.grid.model);
    !gridModel && yAxisModel && (gridModel = yAxisModel.axis.grid.model);
    return gridModel && gridModel === targetInfo.gridModel;
  },
  function(foundCpts, targetInfo) {
    var geoModel = foundCpts.geoModel;
    return geoModel && geoModel === targetInfo.geoModel;
  }
];
var panelRectBuilders = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var coordSys = this.coordSys;
    var rect = coordSys.getBoundingRect().clone();
    rect.applyTransform(getTransform$1(coordSys));
    return rect;
  }
};
var coordConvert = {
  lineX: curry$3(axisConvert, 0),
  lineY: curry$3(axisConvert, 1),
  rect: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xminymin = to ? coordSys.pointToData([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2);
    var xmaxymax = to ? coordSys.pointToData([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2);
    var values = [formatMinMax([xminymin[0], xmaxymax[0]]), formatMinMax([xminymin[1], xmaxymax[1]])];
    return {
      values,
      xyMinMax: values
    };
  },
  polygon: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xyMinMax = [[Infinity, -Infinity], [Infinity, -Infinity]];
    var values = map$1(rangeOrCoordRange, function(item) {
      var p2 = to ? coordSys.pointToData(item, clamp2) : coordSys.dataToPoint(item, clamp2);
      xyMinMax[0][0] = Math.min(xyMinMax[0][0], p2[0]);
      xyMinMax[1][0] = Math.min(xyMinMax[1][0], p2[1]);
      xyMinMax[0][1] = Math.max(xyMinMax[0][1], p2[0]);
      xyMinMax[1][1] = Math.max(xyMinMax[1][1], p2[1]);
      return p2;
    });
    return {
      values,
      xyMinMax
    };
  }
};
function axisConvert(axisNameIndex, to, coordSys, rangeOrCoordRange) {
  var axis = coordSys.getAxis(["x", "y"][axisNameIndex]);
  var values = formatMinMax(map$1([0, 1], function(i) {
    return to ? axis.coordToData(axis.toLocalCoord(rangeOrCoordRange[i]), true) : axis.toGlobalCoord(axis.dataToCoord(rangeOrCoordRange[i]));
  }));
  var xyMinMax = [];
  xyMinMax[axisNameIndex] = values;
  xyMinMax[1 - axisNameIndex] = [NaN, NaN];
  return {
    values,
    xyMinMax
  };
}
var diffProcessor = {
  lineX: curry$3(axisDiffProcessor, 0),
  lineY: curry$3(axisDiffProcessor, 1),
  rect: function(values, refer, scales) {
    return [[values[0][0] - scales[0] * refer[0][0], values[0][1] - scales[0] * refer[0][1]], [values[1][0] - scales[1] * refer[1][0], values[1][1] - scales[1] * refer[1][1]]];
  },
  polygon: function(values, refer, scales) {
    return map$1(values, function(item, idx) {
      return [item[0] - scales[0] * refer[idx][0], item[1] - scales[1] * refer[idx][1]];
    });
  }
};
function axisDiffProcessor(axisNameIndex, values, refer, scales) {
  return [values[0] - scales[axisNameIndex] * refer[0], values[1] - scales[axisNameIndex] * refer[1]];
}
function getScales(xyMinMaxCurr, xyMinMaxOrigin) {
  var sizeCurr = getSize(xyMinMaxCurr);
  var sizeOrigin = getSize(xyMinMaxOrigin);
  var scales = [sizeCurr[0] / sizeOrigin[0], sizeCurr[1] / sizeOrigin[1]];
  isNaN(scales[0]) && (scales[0] = 1);
  isNaN(scales[1]) && (scales[1] = 1);
  return scales;
}
function getSize(xyMinMax) {
  return xyMinMax ? [xyMinMax[0][1] - xyMinMax[0][0], xyMinMax[1][1] - xyMinMax[1][0]] : [NaN, NaN];
}
var BrushTargetManager$1 = BrushTargetManager;
var each$6 = each$g;
var DATA_ZOOM_ID_BASE = makeInternalComponentId("toolbox-dataZoom_");
var DataZoomFeature = function(_super) {
  __extends(DataZoomFeature2, _super);
  function DataZoomFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataZoomFeature2.prototype.render = function(featureModel, ecModel, api, payload) {
    if (!this._brushController) {
      this._brushController = new BrushController$1(api.getZr());
      this._brushController.on("brush", bind$1(this._onBrush, this)).mount();
    }
    updateZoomBtnStatus(featureModel, ecModel, this, payload, api);
    updateBackBtnStatus(featureModel, ecModel);
  };
  DataZoomFeature2.prototype.onclick = function(ecModel, api, type4) {
    handlers[type4].call(this);
  };
  DataZoomFeature2.prototype.remove = function(ecModel, api) {
    this._brushController && this._brushController.unmount();
  };
  DataZoomFeature2.prototype.dispose = function(ecModel, api) {
    this._brushController && this._brushController.dispose();
  };
  DataZoomFeature2.prototype._onBrush = function(eventParam) {
    var areas = eventParam.areas;
    if (!eventParam.isEnd || !areas.length) {
      return;
    }
    var snapshot = {};
    var ecModel = this.ecModel;
    this._brushController.updateCovers([]);
    var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(this.model), ecModel, {
      include: ["grid"]
    });
    brushTargetManager.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      if (coordSys.type !== "cartesian2d") {
        return;
      }
      var brushType = area.brushType;
      if (brushType === "rect") {
        setBatch("x", coordSys, coordRange[0]);
        setBatch("y", coordSys, coordRange[1]);
      } else {
        setBatch({
          lineX: "x",
          lineY: "y"
        }[brushType], coordSys, coordRange);
      }
    });
    push(ecModel, snapshot);
    this._dispatchZoomAction(snapshot);
    function setBatch(dimName, coordSys, minMax) {
      var axis = coordSys.getAxis(dimName);
      var axisModel = axis.model;
      var dataZoomModel = findDataZoom(dimName, axisModel, ecModel);
      var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy(axisModel).getMinMaxSpan();
      if (minMaxSpan.minValueSpan != null || minMaxSpan.maxValueSpan != null) {
        minMax = sliderMove(0, minMax.slice(), axis.scale.getExtent(), 0, minMaxSpan.minValueSpan, minMaxSpan.maxValueSpan);
      }
      dataZoomModel && (snapshot[dataZoomModel.id] = {
        dataZoomId: dataZoomModel.id,
        startValue: minMax[0],
        endValue: minMax[1]
      });
    }
    function findDataZoom(dimName, axisModel, ecModel2) {
      var found;
      ecModel2.eachComponent({
        mainType: "dataZoom",
        subType: "select"
      }, function(dzModel) {
        var has2 = dzModel.getAxisModel(dimName, axisModel.componentIndex);
        has2 && (found = dzModel);
      });
      return found;
    }
  };
  DataZoomFeature2.prototype._dispatchZoomAction = function(snapshot) {
    var batch = [];
    each$6(snapshot, function(batchItem, dataZoomId) {
      batch.push(clone$4(batchItem));
    });
    batch.length && this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      batch
    });
  };
  DataZoomFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      filterMode: "filter",
      icon: {
        zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1",
        back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "dataZoom", "title"]),
      brushStyle: {
        borderWidth: 0,
        color: "rgba(210,219,238,0.2)"
      }
    };
    return defaultOption2;
  };
  return DataZoomFeature2;
}(ToolboxFeature);
var handlers = {
  zoom: function() {
    var nextActive = !this._isZoomActive;
    this.api.dispatchAction({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      dataZoomSelectActive: nextActive
    });
  },
  back: function() {
    this._dispatchZoomAction(pop(this.ecModel));
  }
};
function makeAxisFinder(dzFeatureModel) {
  var setting = {
    xAxisIndex: dzFeatureModel.get("xAxisIndex", true),
    yAxisIndex: dzFeatureModel.get("yAxisIndex", true),
    xAxisId: dzFeatureModel.get("xAxisId", true),
    yAxisId: dzFeatureModel.get("yAxisId", true)
  };
  if (setting.xAxisIndex == null && setting.xAxisId == null) {
    setting.xAxisIndex = "all";
  }
  if (setting.yAxisIndex == null && setting.yAxisId == null) {
    setting.yAxisIndex = "all";
  }
  return setting;
}
function updateBackBtnStatus(featureModel, ecModel) {
  featureModel.setIconStatus("back", count(ecModel) > 1 ? "emphasis" : "normal");
}
function updateZoomBtnStatus(featureModel, ecModel, view, payload, api) {
  var zoomActive = view._isZoomActive;
  if (payload && payload.type === "takeGlobalCursor") {
    zoomActive = payload.key === "dataZoomSelect" ? payload.dataZoomSelectActive : false;
  }
  view._isZoomActive = zoomActive;
  featureModel.setIconStatus("zoom", zoomActive ? "emphasis" : "normal");
  var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(featureModel), ecModel, {
    include: ["grid"]
  });
  var panels = brushTargetManager.makePanelOpts(api, function(targetInfo) {
    return targetInfo.xAxisDeclared && !targetInfo.yAxisDeclared ? "lineX" : !targetInfo.xAxisDeclared && targetInfo.yAxisDeclared ? "lineY" : "rect";
  });
  view._brushController.setPanels(panels).enableBrush(zoomActive && panels.length ? {
    brushType: "auto",
    brushStyle: featureModel.getModel("brushStyle").getItemStyle()
  } : false);
}
registerInternalOptionCreator("dataZoom", function(ecModel) {
  var toolboxModel = ecModel.getComponent("toolbox", 0);
  var featureDataZoomPath = ["feature", "dataZoom"];
  if (!toolboxModel || toolboxModel.get(featureDataZoomPath) == null) {
    return;
  }
  var dzFeatureModel = toolboxModel.getModel(featureDataZoomPath);
  var dzOptions = [];
  var finder = makeAxisFinder(dzFeatureModel);
  var finderResult = parseFinder$1(ecModel, finder);
  each$6(finderResult.xAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "xAxis", "xAxisIndex");
  });
  each$6(finderResult.yAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "yAxis", "yAxisIndex");
  });
  function buildInternalOptions(axisModel, axisMainType, axisIndexPropName) {
    var axisIndex = axisModel.componentIndex;
    var newOpt = {
      type: "select",
      $fromToolbox: true,
      filterMode: dzFeatureModel.get("filterMode", true) || "filter",
      id: DATA_ZOOM_ID_BASE + axisMainType + axisIndex
    };
    newOpt[axisIndexPropName] = axisIndex;
    dzOptions.push(newOpt);
  }
  return dzOptions;
});
var DataZoom = DataZoomFeature;
function install$j(registers) {
  registers.registerComponentModel(ToolboxModel$1);
  registers.registerComponentView(ToolboxView$1);
  registerFeature("saveAsImage", SaveAsImage$1);
  registerFeature("magicType", MagicType$1);
  registerFeature("dataView", DataView$2);
  registerFeature("dataZoom", DataZoom);
  registerFeature("restore", Restore);
  use(install$k);
}
var TooltipModel = function(_super) {
  __extends(TooltipModel2, _super);
  function TooltipModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipModel2.type;
    return _this;
  }
  TooltipModel2.type = "tooltip";
  TooltipModel2.dependencies = ["axisPointer"];
  TooltipModel2.defaultOption = {
    z: 60,
    show: true,
    showContent: true,
    trigger: "item",
    triggerOn: "mousemove|click",
    alwaysShowContent: false,
    displayMode: "single",
    renderMode: "auto",
    confine: null,
    showDelay: 0,
    hideDelay: 100,
    transitionDuration: 0.4,
    enterable: false,
    backgroundColor: "#fff",
    shadowBlur: 10,
    shadowColor: "rgba(0, 0, 0, .2)",
    shadowOffsetX: 1,
    shadowOffsetY: 2,
    borderRadius: 4,
    borderWidth: 1,
    padding: null,
    extraCssText: "",
    axisPointer: {
      type: "line",
      axis: "auto",
      animation: "auto",
      animationDurationUpdate: 200,
      animationEasingUpdate: "exponentialOut",
      crossStyle: {
        color: "#999",
        width: 1,
        type: "dashed",
        textStyle: {}
      }
    },
    textStyle: {
      color: "#666",
      fontSize: 14
    }
  };
  return TooltipModel2;
}(ComponentModel$1);
var TooltipModel$1 = TooltipModel;
function shouldTooltipConfine(tooltipModel) {
  var confineOption = tooltipModel.get("confine");
  return confineOption != null ? !!confineOption : tooltipModel.get("renderMode") === "richText";
}
function testStyle(styleProps) {
  if (!env$1.domSupported) {
    return;
  }
  var style2 = document.documentElement.style;
  for (var i = 0, len2 = styleProps.length; i < len2; i++) {
    if (styleProps[i] in style2) {
      return styleProps[i];
    }
  }
}
var TRANSFORM_VENDOR = testStyle(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]);
var TRANSITION_VENDOR = testStyle(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
function toCSSVendorPrefix(styleVendor, styleProp) {
  if (!styleVendor) {
    return styleProp;
  }
  styleProp = toCamelCase(styleProp, true);
  var idx = styleVendor.indexOf(styleProp);
  styleVendor = idx === -1 ? styleProp : "-" + styleVendor.slice(0, idx) + "-" + styleProp;
  return styleVendor.toLowerCase();
}
function getComputedStyle$1(el, style2) {
  var stl = el.currentStyle || document.defaultView && document.defaultView.getComputedStyle(el);
  return stl ? style2 ? stl[style2] : stl : null;
}
var CSS_TRANSITION_VENDOR = toCSSVendorPrefix(TRANSITION_VENDOR, "transition");
var CSS_TRANSFORM_VENDOR = toCSSVendorPrefix(TRANSFORM_VENDOR, "transform");
var gCssText = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (env$1.transform3dSupported ? "will-change:transform;" : "");
function mirrorPos(pos) {
  pos = pos === "left" ? "right" : pos === "right" ? "left" : pos === "top" ? "bottom" : "top";
  return pos;
}
function assembleArrow(tooltipModel, borderColor, arrowPosition) {
  if (!isString$1(arrowPosition) || arrowPosition === "inside") {
    return "";
  }
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var borderWidth = tooltipModel.get("borderWidth");
  borderColor = convertToColorString(borderColor);
  var arrowPos = mirrorPos(arrowPosition);
  var arrowSize = Math.max(Math.round(borderWidth) * 1.5, 6);
  var positionStyle = "";
  var transformStyle = CSS_TRANSFORM_VENDOR + ":";
  var rotateDeg;
  if (indexOf(["left", "right"], arrowPos) > -1) {
    positionStyle += "top:50%";
    transformStyle += "translateY(-50%) rotate(" + (rotateDeg = arrowPos === "left" ? -225 : -45) + "deg)";
  } else {
    positionStyle += "left:50%";
    transformStyle += "translateX(-50%) rotate(" + (rotateDeg = arrowPos === "top" ? 225 : 45) + "deg)";
  }
  var rotateRadian = rotateDeg * Math.PI / 180;
  var arrowWH = arrowSize + borderWidth;
  var rotatedWH = arrowWH * Math.abs(Math.cos(rotateRadian)) + arrowWH * Math.abs(Math.sin(rotateRadian));
  var arrowOffset = Math.round(((rotatedWH - Math.SQRT2 * borderWidth) / 2 + Math.SQRT2 * borderWidth - (rotatedWH - arrowWH) / 2) * 100) / 100;
  positionStyle += ";" + arrowPos + ":-" + arrowOffset + "px";
  var borderStyle = borderColor + " solid " + borderWidth + "px;";
  var styleCss = ["position:absolute;width:" + arrowSize + "px;height:" + arrowSize + "px;", positionStyle + ";" + transformStyle + ";", "border-bottom:" + borderStyle, "border-right:" + borderStyle, "background-color:" + backgroundColor2 + ";"];
  return '<div style="' + styleCss.join("") + '"></div>';
}
function assembleTransition(duration, onlyFade) {
  var transitionCurve = "cubic-bezier(0.23,1,0.32,1)";
  var transitionOption = " " + duration / 2 + "s " + transitionCurve;
  var transitionText = "opacity" + transitionOption + ",visibility" + transitionOption;
  if (!onlyFade) {
    transitionOption = " " + duration + "s " + transitionCurve;
    transitionText += env$1.transformSupported ? "," + CSS_TRANSFORM_VENDOR + transitionOption : ",left" + transitionOption + ",top" + transitionOption;
  }
  return CSS_TRANSITION_VENDOR + ":" + transitionText;
}
function assembleTransform(x2, y2, toString2) {
  var x0 = x2.toFixed(0) + "px";
  var y0 = y2.toFixed(0) + "px";
  if (!env$1.transformSupported) {
    return toString2 ? "top:" + y0 + ";left:" + x0 + ";" : [["top", y0], ["left", x0]];
  }
  var is3d = env$1.transform3dSupported;
  var translate2 = "translate" + (is3d ? "3d" : "") + "(" + x0 + "," + y0 + (is3d ? ",0" : "") + ")";
  return toString2 ? "top:0;left:0;" + CSS_TRANSFORM_VENDOR + ":" + translate2 + ";" : [["top", 0], ["left", 0], [TRANSFORM_VENDOR, translate2]];
}
function assembleFont(textStyleModel) {
  var cssText = [];
  var fontSize = textStyleModel.get("fontSize");
  var color = textStyleModel.getTextColor();
  color && cssText.push("color:" + color);
  cssText.push("font:" + textStyleModel.getFont());
  fontSize && cssText.push("line-height:" + Math.round(fontSize * 3 / 2) + "px");
  var shadowColor = textStyleModel.get("textShadowColor");
  var shadowBlur = textStyleModel.get("textShadowBlur") || 0;
  var shadowOffsetX = textStyleModel.get("textShadowOffsetX") || 0;
  var shadowOffsetY = textStyleModel.get("textShadowOffsetY") || 0;
  shadowColor && shadowBlur && cssText.push("text-shadow:" + shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor);
  each$g(["decoration", "align"], function(name2) {
    var val = textStyleModel.get(name2);
    val && cssText.push("text-" + name2 + ":" + val);
  });
  return cssText.join(";");
}
function assembleCssText(tooltipModel, enableTransition, onlyFade) {
  var cssText = [];
  var transitionDuration = tooltipModel.get("transitionDuration");
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var shadowBlur = tooltipModel.get("shadowBlur");
  var shadowColor = tooltipModel.get("shadowColor");
  var shadowOffsetX = tooltipModel.get("shadowOffsetX");
  var shadowOffsetY = tooltipModel.get("shadowOffsetY");
  var textStyleModel = tooltipModel.getModel("textStyle");
  var padding = getPaddingFromTooltipModel(tooltipModel, "html");
  var boxShadow = shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor;
  cssText.push("box-shadow:" + boxShadow);
  enableTransition && transitionDuration && cssText.push(assembleTransition(transitionDuration, onlyFade));
  if (backgroundColor2) {
    cssText.push("background-color:" + backgroundColor2);
  }
  each$g(["width", "color", "radius"], function(name2) {
    var borderName = "border-" + name2;
    var camelCase = toCamelCase(borderName);
    var val = tooltipModel.get(camelCase);
    val != null && cssText.push(borderName + ":" + val + (name2 === "color" ? "" : "px"));
  });
  cssText.push(assembleFont(textStyleModel));
  if (padding != null) {
    cssText.push("padding:" + normalizeCssArray(padding).join("px ") + "px");
  }
  return cssText.join(";") + ";";
}
function makeStyleCoord$1(out2, zr, appendToBody, zrX, zrY) {
  var zrPainter = zr && zr.painter;
  if (appendToBody) {
    var zrViewportRoot = zrPainter && zrPainter.getViewportRoot();
    if (zrViewportRoot) {
      transformLocalCoord(out2, zrViewportRoot, document.body, zrX, zrY);
    }
  } else {
    out2[0] = zrX;
    out2[1] = zrY;
    var viewportRootOffset = zrPainter && zrPainter.getViewportRootOffset();
    if (viewportRootOffset) {
      out2[0] += viewportRootOffset.offsetLeft;
      out2[1] += viewportRootOffset.offsetTop;
    }
  }
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipHTMLContent = function() {
  function TooltipHTMLContent2(container2, api, opt) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._firstShow = true;
    this._longHide = true;
    if (env$1.wxa) {
      return null;
    }
    var el = document.createElement("div");
    el.domBelongToZr = true;
    this.el = el;
    var zr = this._zr = api.getZr();
    var appendToBody = this._appendToBody = opt && opt.appendToBody;
    makeStyleCoord$1(this._styleCoord, zr, appendToBody, api.getWidth() / 2, api.getHeight() / 2);
    if (appendToBody) {
      document.body.appendChild(el);
    } else {
      container2.appendChild(el);
    }
    this._container = container2;
    var self2 = this;
    el.onmouseenter = function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    };
    el.onmousemove = function(e2) {
      e2 = e2 || window.event;
      if (!self2._enterable) {
        var handler = zr.handler;
        var zrViewportRoot = zr.painter.getViewportRoot();
        normalizeEvent(zrViewportRoot, e2, true);
        handler.dispatch("mousemove", e2);
      }
    };
    el.onmouseleave = function() {
      self2._inContent = false;
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
    };
  }
  TooltipHTMLContent2.prototype.update = function(tooltipModel) {
    var container2 = this._container;
    var position2 = getComputedStyle$1(container2, "position");
    var domStyle = container2.style;
    if (domStyle.position !== "absolute" && position2 !== "absolute") {
      domStyle.position = "relative";
    }
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
    this.el.className = tooltipModel.get("className") || "";
  };
  TooltipHTMLContent2.prototype.show = function(tooltipModel, nearPointColor) {
    clearTimeout(this._hideTimeout);
    clearTimeout(this._longHideTimeout);
    var el = this.el;
    var style2 = el.style;
    var styleCoord = this._styleCoord;
    if (!el.innerHTML) {
      style2.display = "none";
    } else {
      style2.cssText = gCssText + assembleCssText(tooltipModel, !this._firstShow, this._longHide) + assembleTransform(styleCoord[0], styleCoord[1], true) + ("border-color:" + convertToColorString(nearPointColor) + ";") + (tooltipModel.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none"));
    }
    this._show = true;
    this._firstShow = false;
    this._longHide = false;
  };
  TooltipHTMLContent2.prototype.setContent = function(content, markers, tooltipModel, borderColor, arrowPosition) {
    var el = this.el;
    if (content == null) {
      el.innerHTML = "";
      return;
    }
    var arrow = "";
    if (isString$1(arrowPosition) && tooltipModel.get("trigger") === "item" && !shouldTooltipConfine(tooltipModel)) {
      arrow = assembleArrow(tooltipModel, borderColor, arrowPosition);
    }
    if (isString$1(content)) {
      el.innerHTML = content + arrow;
    } else if (content) {
      el.innerHTML = "";
      if (!isArray$2(content)) {
        content = [content];
      }
      for (var i = 0; i < content.length; i++) {
        if (isDom(content[i]) && content[i].parentNode !== el) {
          el.appendChild(content[i]);
        }
      }
      if (arrow && el.childNodes.length) {
        var arrowEl = document.createElement("div");
        arrowEl.innerHTML = arrow;
        el.appendChild(arrowEl);
      }
    }
  };
  TooltipHTMLContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipHTMLContent2.prototype.getSize = function() {
    var el = this.el;
    return [el.offsetWidth, el.offsetHeight];
  };
  TooltipHTMLContent2.prototype.moveTo = function(zrX, zrY) {
    var styleCoord = this._styleCoord;
    makeStyleCoord$1(styleCoord, this._zr, this._appendToBody, zrX, zrY);
    if (styleCoord[0] != null && styleCoord[1] != null) {
      var style_1 = this.el.style;
      var transforms = assembleTransform(styleCoord[0], styleCoord[1]);
      each$g(transforms, function(transform2) {
        style_1[transform2[0]] = transform2[1];
      });
    }
  };
  TooltipHTMLContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipHTMLContent2.prototype.hide = function() {
    var _this = this;
    var style2 = this.el.style;
    style2.visibility = "hidden";
    style2.opacity = "0";
    env$1.transform3dSupported && (style2.willChange = "");
    this._show = false;
    this._longHideTimeout = setTimeout(function() {
      return _this._longHide = true;
    }, 500);
  };
  TooltipHTMLContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipHTMLContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipHTMLContent2.prototype.dispose = function() {
    this.el.parentNode.removeChild(this.el);
  };
  return TooltipHTMLContent2;
}();
var TooltipHTMLContent$1 = TooltipHTMLContent;
var TooltipRichContent = function() {
  function TooltipRichContent2(api) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._zr = api.getZr();
    makeStyleCoord(this._styleCoord, this._zr, api.getWidth() / 2, api.getHeight() / 2);
  }
  TooltipRichContent2.prototype.update = function(tooltipModel) {
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
  };
  TooltipRichContent2.prototype.show = function() {
    if (this._hideTimeout) {
      clearTimeout(this._hideTimeout);
    }
    this.el.show();
    this._show = true;
  };
  TooltipRichContent2.prototype.setContent = function(content, markupStyleCreator, tooltipModel, borderColor, arrowPosition) {
    var _this = this;
    if (isObject$6(content)) {
      throwError$2("");
    }
    if (this.el) {
      this._zr.remove(this.el);
    }
    var textStyleModel = tooltipModel.getModel("textStyle");
    this.el = new ZRText$1({
      style: {
        rich: markupStyleCreator.richTextStyles,
        text: content,
        lineHeight: 22,
        borderWidth: 1,
        borderColor,
        textShadowColor: textStyleModel.get("textShadowColor"),
        fill: tooltipModel.get(["textStyle", "color"]),
        padding: getPaddingFromTooltipModel(tooltipModel, "richText"),
        verticalAlign: "top",
        align: "left"
      },
      z: tooltipModel.get("z")
    });
    each$g(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(propName) {
      _this.el.style[propName] = tooltipModel.get(propName);
    });
    each$g(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(propName) {
      _this.el.style[propName] = textStyleModel.get(propName) || 0;
    });
    this._zr.add(this.el);
    var self2 = this;
    this.el.on("mouseover", function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    });
    this.el.on("mouseout", function() {
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
      self2._inContent = false;
    });
  };
  TooltipRichContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipRichContent2.prototype.getSize = function() {
    var el = this.el;
    var bounding = this.el.getBoundingRect();
    var shadowOuterSize = calcShadowOuterSize(el.style);
    return [bounding.width + shadowOuterSize.left + shadowOuterSize.right, bounding.height + shadowOuterSize.top + shadowOuterSize.bottom];
  };
  TooltipRichContent2.prototype.moveTo = function(x2, y2) {
    var el = this.el;
    if (el) {
      var styleCoord = this._styleCoord;
      makeStyleCoord(styleCoord, this._zr, x2, y2);
      x2 = styleCoord[0];
      y2 = styleCoord[1];
      var style2 = el.style;
      var borderWidth = mathMaxWith0(style2.borderWidth || 0);
      var shadowOuterSize = calcShadowOuterSize(style2);
      el.x = x2 + borderWidth + shadowOuterSize.left;
      el.y = y2 + borderWidth + shadowOuterSize.top;
      el.markRedraw();
    }
  };
  TooltipRichContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipRichContent2.prototype.hide = function() {
    if (this.el) {
      this.el.hide();
    }
    this._show = false;
  };
  TooltipRichContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipRichContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipRichContent2.prototype.dispose = function() {
    this._zr.remove(this.el);
  };
  return TooltipRichContent2;
}();
function mathMaxWith0(val) {
  return Math.max(0, val);
}
function calcShadowOuterSize(style2) {
  var shadowBlur = mathMaxWith0(style2.shadowBlur || 0);
  var shadowOffsetX = mathMaxWith0(style2.shadowOffsetX || 0);
  var shadowOffsetY = mathMaxWith0(style2.shadowOffsetY || 0);
  return {
    left: mathMaxWith0(shadowBlur - shadowOffsetX),
    right: mathMaxWith0(shadowBlur + shadowOffsetX),
    top: mathMaxWith0(shadowBlur - shadowOffsetY),
    bottom: mathMaxWith0(shadowBlur + shadowOffsetY)
  };
}
function makeStyleCoord(out2, zr, zrX, zrY) {
  out2[0] = zrX;
  out2[1] = zrY;
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipRichContent$1 = TooltipRichContent;
var proxyRect = new Rect$3({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
});
var TooltipView = function(_super) {
  __extends(TooltipView2, _super);
  function TooltipView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipView2.type;
    return _this;
  }
  TooltipView2.prototype.init = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    var tooltipModel = ecModel.getComponent("tooltip");
    var renderMode = this._renderMode = getTooltipRenderMode(tooltipModel.get("renderMode"));
    this._tooltipContent = renderMode === "richText" ? new TooltipRichContent$1(api) : new TooltipHTMLContent$1(api.getDom(), api, {
      appendToBody: tooltipModel.get("appendToBody", true)
    });
  };
  TooltipView2.prototype.render = function(tooltipModel, ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    this.group.removeAll();
    this._tooltipModel = tooltipModel;
    this._ecModel = ecModel;
    this._api = api;
    this._alwaysShowContent = tooltipModel.get("alwaysShowContent");
    var tooltipContent = this._tooltipContent;
    tooltipContent.update(tooltipModel);
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    this._initGlobalListener();
    this._keepShow();
    if (this._renderMode !== "richText" && tooltipModel.get("transitionDuration")) {
      createOrUpdate(this, "_updatePosition", 50, "fixRate");
    } else {
      clear$1(this, "_updatePosition");
    }
  };
  TooltipView2.prototype._initGlobalListener = function() {
    var tooltipModel = this._tooltipModel;
    var triggerOn = tooltipModel.get("triggerOn");
    register("itemTooltip", this._api, bind$1(function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none") {
        if (triggerOn.indexOf(currTrigger) >= 0) {
          this._tryShow(e2, dispatchAction2);
        } else if (currTrigger === "leave") {
          this._hide(dispatchAction2);
        }
      }
    }, this));
  };
  TooltipView2.prototype._keepShow = function() {
    var tooltipModel = this._tooltipModel;
    var ecModel = this._ecModel;
    var api = this._api;
    if (this._lastX != null && this._lastY != null && tooltipModel.get("triggerOn") !== "none") {
      var self_1 = this;
      clearTimeout(this._refreshUpdateTimeout);
      this._refreshUpdateTimeout = setTimeout(function() {
        !api.isDisposed() && self_1.manuallyShowTip(tooltipModel, ecModel, api, {
          x: self_1._lastX,
          y: self_1._lastY,
          dataByCoordSys: self_1._lastDataByCoordSys
        });
      });
    }
  };
  TooltipView2.prototype.manuallyShowTip = function(tooltipModel, ecModel, api, payload) {
    if (payload.from === this.uid || env$1.node || !api.getDom()) {
      return;
    }
    var dispatchAction2 = makeDispatchAction(payload, api);
    this._ticket = "";
    var dataByCoordSys = payload.dataByCoordSys;
    var cmptRef = findComponentReference(payload, ecModel, api);
    if (cmptRef) {
      var rect = cmptRef.el.getBoundingRect().clone();
      rect.applyTransform(cmptRef.el.transform);
      this._tryShow({
        offsetX: rect.x + rect.width / 2,
        offsetY: rect.y + rect.height / 2,
        target: cmptRef.el,
        position: payload.position,
        positionDefault: "bottom"
      }, dispatchAction2);
    } else if (payload.tooltip && payload.x != null && payload.y != null) {
      var el = proxyRect;
      el.x = payload.x;
      el.y = payload.y;
      el.update();
      getECData(el).tooltipConfig = {
        name: null,
        option: payload.tooltip
      };
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        target: el
      }, dispatchAction2);
    } else if (dataByCoordSys) {
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        dataByCoordSys,
        tooltipOption: payload.tooltipOption
      }, dispatchAction2);
    } else if (payload.seriesIndex != null) {
      if (this._manuallyAxisShowTip(tooltipModel, ecModel, api, payload)) {
        return;
      }
      var pointInfo = findPointFromSeries(payload, ecModel);
      var cx = pointInfo.point[0];
      var cy = pointInfo.point[1];
      if (cx != null && cy != null) {
        this._tryShow({
          offsetX: cx,
          offsetY: cy,
          target: pointInfo.el,
          position: payload.position,
          positionDefault: "bottom"
        }, dispatchAction2);
      }
    } else if (payload.x != null && payload.y != null) {
      api.dispatchAction({
        type: "updateAxisPointer",
        x: payload.x,
        y: payload.y
      });
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        target: api.getZr().findHover(payload.x, payload.y).target
      }, dispatchAction2);
    }
  };
  TooltipView2.prototype.manuallyHideTip = function(tooltipModel, ecModel, api, payload) {
    var tooltipContent = this._tooltipContent;
    if (!this._alwaysShowContent && this._tooltipModel) {
      tooltipContent.hideLater(this._tooltipModel.get("hideDelay"));
    }
    this._lastX = this._lastY = this._lastDataByCoordSys = null;
    if (payload.from !== this.uid) {
      this._hide(makeDispatchAction(payload, api));
    }
  };
  TooltipView2.prototype._manuallyAxisShowTip = function(tooltipModel, ecModel, api, payload) {
    var seriesIndex = payload.seriesIndex;
    var dataIndex = payload.dataIndex;
    var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
    if (seriesIndex == null || dataIndex == null || coordSysAxesInfo == null) {
      return;
    }
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    if (!seriesModel) {
      return;
    }
    var data2 = seriesModel.getData();
    var tooltipCascadedModel = buildTooltipModel([data2.getItemModel(dataIndex), seriesModel, (seriesModel.coordinateSystem || {}).model], this._tooltipModel);
    if (tooltipCascadedModel.get("trigger") !== "axis") {
      return;
    }
    api.dispatchAction({
      type: "updateAxisPointer",
      seriesIndex,
      dataIndex,
      position: payload.position
    });
    return true;
  };
  TooltipView2.prototype._tryShow = function(e2, dispatchAction2) {
    var el = e2.target;
    var tooltipModel = this._tooltipModel;
    if (!tooltipModel) {
      return;
    }
    this._lastX = e2.offsetX;
    this._lastY = e2.offsetY;
    var dataByCoordSys = e2.dataByCoordSys;
    if (dataByCoordSys && dataByCoordSys.length) {
      this._showAxisTooltip(dataByCoordSys, e2);
    } else if (el) {
      this._lastDataByCoordSys = null;
      var seriesDispatcher_1;
      var cmptDispatcher_1;
      findEventDispatcher(el, function(target) {
        if (getECData(target).dataIndex != null) {
          seriesDispatcher_1 = target;
          return true;
        }
        if (getECData(target).tooltipConfig != null) {
          cmptDispatcher_1 = target;
          return true;
        }
      }, true);
      if (seriesDispatcher_1) {
        this._showSeriesItemTooltip(e2, seriesDispatcher_1, dispatchAction2);
      } else if (cmptDispatcher_1) {
        this._showComponentItemTooltip(e2, cmptDispatcher_1, dispatchAction2);
      } else {
        this._hide(dispatchAction2);
      }
    } else {
      this._lastDataByCoordSys = null;
      this._hide(dispatchAction2);
    }
  };
  TooltipView2.prototype._showOrMove = function(tooltipModel, cb2) {
    var delay = tooltipModel.get("showDelay");
    cb2 = bind$1(cb2, this);
    clearTimeout(this._showTimout);
    delay > 0 ? this._showTimout = setTimeout(cb2, delay) : cb2();
  };
  TooltipView2.prototype._showAxisTooltip = function(dataByCoordSys, e2) {
    var ecModel = this._ecModel;
    var globalTooltipModel = this._tooltipModel;
    var point = [e2.offsetX, e2.offsetY];
    var singleTooltipModel = buildTooltipModel([e2.tooltipOption], globalTooltipModel);
    var renderMode = this._renderMode;
    var cbParamsList = [];
    var articleMarkup = createTooltipMarkup("section", {
      blocks: [],
      noHeader: true
    });
    var markupTextArrLegacy = [];
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    each$g(dataByCoordSys, function(itemCoordSys) {
      each$g(itemCoordSys.dataByAxis, function(axisItem) {
        var axisModel = ecModel.getComponent(axisItem.axisDim + "Axis", axisItem.axisIndex);
        var axisValue = axisItem.value;
        if (!axisModel || axisValue == null) {
          return;
        }
        var axisValueLabel = getValueLabel(axisValue, axisModel.axis, ecModel, axisItem.seriesDataIndices, axisItem.valueLabelOpt);
        var axisSectionMarkup = createTooltipMarkup("section", {
          header: axisValueLabel,
          noHeader: !trim$1(axisValueLabel),
          sortBlocks: true,
          blocks: []
        });
        articleMarkup.blocks.push(axisSectionMarkup);
        each$g(axisItem.seriesDataIndices, function(idxItem) {
          var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
          var dataIndex = idxItem.dataIndexInside;
          var cbParams = series.getDataParams(dataIndex);
          if (cbParams.dataIndex < 0) {
            return;
          }
          cbParams.axisDim = axisItem.axisDim;
          cbParams.axisIndex = axisItem.axisIndex;
          cbParams.axisType = axisItem.axisType;
          cbParams.axisId = axisItem.axisId;
          cbParams.axisValue = getAxisRawValue(axisModel.axis, {
            value: axisValue
          });
          cbParams.axisValueLabel = axisValueLabel;
          cbParams.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(cbParams.color), renderMode);
          var seriesTooltipResult = normalizeTooltipFormatResult(series.formatTooltip(dataIndex, true, null));
          var frag = seriesTooltipResult.frag;
          if (frag) {
            var valueFormatter = buildTooltipModel([series], globalTooltipModel).get("valueFormatter");
            axisSectionMarkup.blocks.push(valueFormatter ? extend({
              valueFormatter
            }, frag) : frag);
          }
          if (seriesTooltipResult.text) {
            markupTextArrLegacy.push(seriesTooltipResult.text);
          }
          cbParamsList.push(cbParams);
        });
      });
    });
    articleMarkup.blocks.reverse();
    markupTextArrLegacy.reverse();
    var positionExpr = e2.position;
    var orderMode = singleTooltipModel.get("order");
    var builtMarkupText = buildTooltipMarkup(articleMarkup, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), singleTooltipModel.get("textStyle"));
    builtMarkupText && markupTextArrLegacy.unshift(builtMarkupText);
    var blockBreak = renderMode === "richText" ? "\n\n" : "<br/>";
    var allMarkupText = markupTextArrLegacy.join(blockBreak);
    this._showOrMove(singleTooltipModel, function() {
      if (this._updateContentNotChangedOnAxis(dataByCoordSys, cbParamsList)) {
        this._updatePosition(singleTooltipModel, positionExpr, point[0], point[1], this._tooltipContent, cbParamsList);
      } else {
        this._showTooltipContent(singleTooltipModel, allMarkupText, cbParamsList, Math.random() + "", point[0], point[1], positionExpr, null, markupStyleCreator);
      }
    });
  };
  TooltipView2.prototype._showSeriesItemTooltip = function(e2, dispatcher, dispatchAction2) {
    var ecModel = this._ecModel;
    var ecData = getECData(dispatcher);
    var seriesIndex = ecData.seriesIndex;
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    var dataModel = ecData.dataModel || seriesModel;
    var dataIndex = ecData.dataIndex;
    var dataType = ecData.dataType;
    var data2 = dataModel.getData(dataType);
    var renderMode = this._renderMode;
    var positionDefault = e2.positionDefault;
    var tooltipModel = buildTooltipModel([data2.getItemModel(dataIndex), dataModel, seriesModel && (seriesModel.coordinateSystem || {}).model], this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var tooltipTrigger = tooltipModel.get("trigger");
    if (tooltipTrigger != null && tooltipTrigger !== "item") {
      return;
    }
    var params = dataModel.getDataParams(dataIndex, dataType);
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    params.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(params.color), renderMode);
    var seriesTooltipResult = normalizeTooltipFormatResult(dataModel.formatTooltip(dataIndex, false, dataType));
    var orderMode = tooltipModel.get("order");
    var valueFormatter = tooltipModel.get("valueFormatter");
    var frag = seriesTooltipResult.frag;
    var markupText = frag ? buildTooltipMarkup(valueFormatter ? extend({
      valueFormatter
    }, frag) : frag, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), tooltipModel.get("textStyle")) : seriesTooltipResult.text;
    var asyncTicket = "item_" + dataModel.name + "_" + dataIndex;
    this._showOrMove(tooltipModel, function() {
      this._showTooltipContent(tooltipModel, markupText, params, asyncTicket, e2.offsetX, e2.offsetY, e2.position, e2.target, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      dataIndexInside: dataIndex,
      dataIndex: data2.getRawIndex(dataIndex),
      seriesIndex,
      from: this.uid
    });
  };
  TooltipView2.prototype._showComponentItemTooltip = function(e2, el, dispatchAction2) {
    var ecData = getECData(el);
    var tooltipConfig = ecData.tooltipConfig;
    var tooltipOpt = tooltipConfig.option || {};
    if (isString$1(tooltipOpt)) {
      var content = tooltipOpt;
      tooltipOpt = {
        content,
        formatter: content
      };
    }
    var tooltipModelCascade = [tooltipOpt];
    var cmpt = this._ecModel.getComponent(ecData.componentMainType, ecData.componentIndex);
    if (cmpt) {
      tooltipModelCascade.push(cmpt);
    }
    tooltipModelCascade.push({
      formatter: tooltipOpt.content
    });
    var positionDefault = e2.positionDefault;
    var subTooltipModel = buildTooltipModel(tooltipModelCascade, this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var defaultHtml = subTooltipModel.get("content");
    var asyncTicket = Math.random() + "";
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    this._showOrMove(subTooltipModel, function() {
      var formatterParams = clone$4(subTooltipModel.get("formatterParams") || {});
      this._showTooltipContent(subTooltipModel, defaultHtml, formatterParams, asyncTicket, e2.offsetX, e2.offsetY, e2.position, el, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      from: this.uid
    });
  };
  TooltipView2.prototype._showTooltipContent = function(tooltipModel, defaultHtml, params, asyncTicket, x2, y2, positionExpr, el, markupStyleCreator) {
    this._ticket = "";
    if (!tooltipModel.get("showContent") || !tooltipModel.get("show")) {
      return;
    }
    var tooltipContent = this._tooltipContent;
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    var formatter = tooltipModel.get("formatter");
    positionExpr = positionExpr || tooltipModel.get("position");
    var html = defaultHtml;
    var nearPoint = this._getNearestPoint([x2, y2], params, tooltipModel.get("trigger"), tooltipModel.get("borderColor"));
    var nearPointColor = nearPoint.color;
    if (formatter) {
      if (isString$1(formatter)) {
        var useUTC = tooltipModel.ecModel.get("useUTC");
        var params0 = isArray$2(params) ? params[0] : params;
        var isTimeAxis = params0 && params0.axisType && params0.axisType.indexOf("time") >= 0;
        html = formatter;
        if (isTimeAxis) {
          html = format$1(params0.axisValue, html, useUTC);
        }
        html = formatTpl(html, params, true);
      } else if (isFunction$1(formatter)) {
        var callback = bind$1(function(cbTicket, html2) {
          if (cbTicket === this._ticket) {
            tooltipContent.setContent(html2, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
            this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
          }
        }, this);
        this._ticket = asyncTicket;
        html = formatter(params, asyncTicket, callback);
      } else {
        html = formatter;
      }
    }
    tooltipContent.setContent(html, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
    tooltipContent.show(tooltipModel, nearPointColor);
    this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
  };
  TooltipView2.prototype._getNearestPoint = function(point, tooltipDataParams, trigger2, borderColor) {
    if (trigger2 === "axis" || isArray$2(tooltipDataParams)) {
      return {
        color: borderColor || (this._renderMode === "html" ? "#fff" : "none")
      };
    }
    if (!isArray$2(tooltipDataParams)) {
      return {
        color: borderColor || tooltipDataParams.color || tooltipDataParams.borderColor
      };
    }
  };
  TooltipView2.prototype._updatePosition = function(tooltipModel, positionExpr, x2, y2, content, params, el) {
    var viewWidth = this._api.getWidth();
    var viewHeight = this._api.getHeight();
    positionExpr = positionExpr || tooltipModel.get("position");
    var contentSize = content.getSize();
    var align = tooltipModel.get("align");
    var vAlign = tooltipModel.get("verticalAlign");
    var rect = el && el.getBoundingRect().clone();
    el && rect.applyTransform(el.transform);
    if (isFunction$1(positionExpr)) {
      positionExpr = positionExpr([x2, y2], params, content.el, rect, {
        viewSize: [viewWidth, viewHeight],
        contentSize: contentSize.slice()
      });
    }
    if (isArray$2(positionExpr)) {
      x2 = parsePercent(positionExpr[0], viewWidth);
      y2 = parsePercent(positionExpr[1], viewHeight);
    } else if (isObject$6(positionExpr)) {
      var boxLayoutPosition = positionExpr;
      boxLayoutPosition.width = contentSize[0];
      boxLayoutPosition.height = contentSize[1];
      var layoutRect = getLayoutRect(boxLayoutPosition, {
        width: viewWidth,
        height: viewHeight
      });
      x2 = layoutRect.x;
      y2 = layoutRect.y;
      align = null;
      vAlign = null;
    } else if (isString$1(positionExpr) && el) {
      var pos = calcTooltipPosition(positionExpr, rect, contentSize, tooltipModel.get("borderWidth"));
      x2 = pos[0];
      y2 = pos[1];
    } else {
      var pos = refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, align ? null : 20, vAlign ? null : 20);
      x2 = pos[0];
      y2 = pos[1];
    }
    align && (x2 -= isCenterAlign(align) ? contentSize[0] / 2 : align === "right" ? contentSize[0] : 0);
    vAlign && (y2 -= isCenterAlign(vAlign) ? contentSize[1] / 2 : vAlign === "bottom" ? contentSize[1] : 0);
    if (shouldTooltipConfine(tooltipModel)) {
      var pos = confineTooltipPosition(x2, y2, content, viewWidth, viewHeight);
      x2 = pos[0];
      y2 = pos[1];
    }
    content.moveTo(x2, y2);
  };
  TooltipView2.prototype._updateContentNotChangedOnAxis = function(dataByCoordSys, cbParamsList) {
    var lastCoordSys = this._lastDataByCoordSys;
    var lastCbParamsList = this._cbParamsList;
    var contentNotChanged = !!lastCoordSys && lastCoordSys.length === dataByCoordSys.length;
    contentNotChanged && each$g(lastCoordSys, function(lastItemCoordSys, indexCoordSys) {
      var lastDataByAxis = lastItemCoordSys.dataByAxis || [];
      var thisItemCoordSys = dataByCoordSys[indexCoordSys] || {};
      var thisDataByAxis = thisItemCoordSys.dataByAxis || [];
      contentNotChanged = contentNotChanged && lastDataByAxis.length === thisDataByAxis.length;
      contentNotChanged && each$g(lastDataByAxis, function(lastItem, indexAxis) {
        var thisItem = thisDataByAxis[indexAxis] || {};
        var lastIndices = lastItem.seriesDataIndices || [];
        var newIndices = thisItem.seriesDataIndices || [];
        contentNotChanged = contentNotChanged && lastItem.value === thisItem.value && lastItem.axisType === thisItem.axisType && lastItem.axisId === thisItem.axisId && lastIndices.length === newIndices.length;
        contentNotChanged && each$g(lastIndices, function(lastIdxItem, j) {
          var newIdxItem = newIndices[j];
          contentNotChanged = contentNotChanged && lastIdxItem.seriesIndex === newIdxItem.seriesIndex && lastIdxItem.dataIndex === newIdxItem.dataIndex;
        });
        lastCbParamsList && each$g(lastItem.seriesDataIndices, function(idxItem) {
          var seriesIdx = idxItem.seriesIndex;
          var cbParams = cbParamsList[seriesIdx];
          var lastCbParams = lastCbParamsList[seriesIdx];
          if (cbParams && lastCbParams && lastCbParams.data !== cbParams.data) {
            contentNotChanged = false;
          }
        });
      });
    });
    this._lastDataByCoordSys = dataByCoordSys;
    this._cbParamsList = cbParamsList;
    return !!contentNotChanged;
  };
  TooltipView2.prototype._hide = function(dispatchAction2) {
    this._lastDataByCoordSys = null;
    dispatchAction2({
      type: "hideTip",
      from: this.uid
    });
  };
  TooltipView2.prototype.dispose = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    clear$1(this, "_updatePosition");
    this._tooltipContent.dispose();
    unregister("itemTooltip", api);
  };
  TooltipView2.type = "tooltip";
  return TooltipView2;
}(ComponentView$1);
function buildTooltipModel(modelCascade, globalTooltipModel, defaultTooltipOption) {
  var ecModel = globalTooltipModel.ecModel;
  var resultModel;
  if (defaultTooltipOption) {
    resultModel = new Model$1(defaultTooltipOption, ecModel, ecModel);
    resultModel = new Model$1(globalTooltipModel.option, resultModel, ecModel);
  } else {
    resultModel = globalTooltipModel;
  }
  for (var i = modelCascade.length - 1; i >= 0; i--) {
    var tooltipOpt = modelCascade[i];
    if (tooltipOpt) {
      if (tooltipOpt instanceof Model$1) {
        tooltipOpt = tooltipOpt.get("tooltip", true);
      }
      if (isString$1(tooltipOpt)) {
        tooltipOpt = {
          formatter: tooltipOpt
        };
      }
      if (tooltipOpt) {
        resultModel = new Model$1(tooltipOpt, resultModel, ecModel);
      }
    }
  }
  return resultModel;
}
function makeDispatchAction(payload, api) {
  return payload.dispatchAction || bind$1(api.dispatchAction, api);
}
function refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, gapH, gapV) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  if (gapH != null) {
    if (x2 + width + gapH + 2 > viewWidth) {
      x2 -= width + gapH;
    } else {
      x2 += gapH;
    }
  }
  if (gapV != null) {
    if (y2 + height + gapV > viewHeight) {
      y2 -= height + gapV;
    } else {
      y2 += gapV;
    }
  }
  return [x2, y2];
}
function confineTooltipPosition(x2, y2, content, viewWidth, viewHeight) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  x2 = Math.min(x2 + width, viewWidth) - width;
  y2 = Math.min(y2 + height, viewHeight) - height;
  x2 = Math.max(x2, 0);
  y2 = Math.max(y2, 0);
  return [x2, y2];
}
function calcTooltipPosition(position2, rect, contentSize, borderWidth) {
  var domWidth = contentSize[0];
  var domHeight = contentSize[1];
  var offset3 = Math.ceil(Math.SQRT2 * borderWidth) + 8;
  var x2 = 0;
  var y2 = 0;
  var rectWidth = rect.width;
  var rectHeight = rect.height;
  switch (position2) {
    case "inside":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "top":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y - domHeight - offset3;
      break;
    case "bottom":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight + offset3;
      break;
    case "left":
      x2 = rect.x - domWidth - offset3;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "right":
      x2 = rect.x + rectWidth + offset3;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
  }
  return [x2, y2];
}
function isCenterAlign(align) {
  return align === "center" || align === "middle";
}
function findComponentReference(payload, ecModel, api) {
  var queryOptionMap = preParseFinder(payload).queryOptionMap;
  var componentMainType = queryOptionMap.keys()[0];
  if (!componentMainType || componentMainType === "series") {
    return;
  }
  var queryResult = queryReferringComponents(ecModel, componentMainType, queryOptionMap.get(componentMainType), {
    useDefault: false,
    enableAll: false,
    enableNone: false
  });
  var model = queryResult.models[0];
  if (!model) {
    return;
  }
  var view = api.getViewOfComponentModel(model);
  var el;
  view.group.traverse(function(subEl) {
    var tooltipConfig = getECData(subEl).tooltipConfig;
    if (tooltipConfig && tooltipConfig.name === payload.name) {
      el = subEl;
      return true;
    }
  });
  if (el) {
    return {
      componentMainType,
      componentIndex: model.componentIndex,
      el
    };
  }
}
var TooltipView$1 = TooltipView;
function install$i(registers) {
  use(install$q);
  registers.registerComponentModel(TooltipModel$1);
  registers.registerComponentView(TooltipView$1);
  registers.registerAction({
    type: "showTip",
    event: "showTip",
    update: "tooltip:manuallyShowTip"
  }, noop$1);
  registers.registerAction({
    type: "hideTip",
    event: "hideTip",
    update: "tooltip:manuallyHideTip"
  }, noop$1);
}
var DEFAULT_TOOLBOX_BTNS = ["rect", "polygon", "keep", "clear"];
function brushPreprocessor(option, isNew) {
  var brushComponents = normalizeToArray(option ? option.brush : []);
  if (!brushComponents.length) {
    return;
  }
  var brushComponentSpecifiedBtns = [];
  each$g(brushComponents, function(brushOpt) {
    var tbs = brushOpt.hasOwnProperty("toolbox") ? brushOpt.toolbox : [];
    if (tbs instanceof Array) {
      brushComponentSpecifiedBtns = brushComponentSpecifiedBtns.concat(tbs);
    }
  });
  var toolbox = option && option.toolbox;
  if (isArray$2(toolbox)) {
    toolbox = toolbox[0];
  }
  if (!toolbox) {
    toolbox = {
      feature: {}
    };
    option.toolbox = [toolbox];
  }
  var toolboxFeature = toolbox.feature || (toolbox.feature = {});
  var toolboxBrush = toolboxFeature.brush || (toolboxFeature.brush = {});
  var brushTypes = toolboxBrush.type || (toolboxBrush.type = []);
  brushTypes.push.apply(brushTypes, brushComponentSpecifiedBtns);
  removeDuplicate(brushTypes);
  if (isNew && !brushTypes.length) {
    brushTypes.push.apply(brushTypes, DEFAULT_TOOLBOX_BTNS);
  }
}
function removeDuplicate(arr) {
  var map2 = {};
  each$g(arr, function(val) {
    map2[val] = 1;
  });
  arr.length = 0;
  each$g(map2, function(flag, val) {
    arr.push(val);
  });
}
var each$5 = each$g;
function hasKeys(obj) {
  if (obj) {
    for (var name_1 in obj) {
      if (obj.hasOwnProperty(name_1)) {
        return true;
      }
    }
  }
}
function createVisualMappings(option, stateList, supplementVisualOption) {
  var visualMappings = {};
  each$5(stateList, function(state) {
    var mappings = visualMappings[state] = createMappings();
    each$5(option[state], function(visualData, visualType) {
      if (!VisualMapping$1.isValidType(visualType)) {
        return;
      }
      var mappingOption = {
        type: visualType,
        visual: visualData
      };
      supplementVisualOption && supplementVisualOption(mappingOption, state);
      mappings[visualType] = new VisualMapping$1(mappingOption);
      if (visualType === "opacity") {
        mappingOption = clone$4(mappingOption);
        mappingOption.type = "colorAlpha";
        mappings.__hidden.__alphaForOpacity = new VisualMapping$1(mappingOption);
      }
    });
  });
  return visualMappings;
  function createMappings() {
    var Creater = function() {
    };
    Creater.prototype.__hidden = Creater.prototype;
    var obj = new Creater();
    return obj;
  }
}
function replaceVisualOption(thisOption, newOption, keys2) {
  var has2;
  each$g(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      has2 = true;
    }
  });
  has2 && each$g(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      thisOption[key] = clone$4(newOption[key]);
    } else {
      delete thisOption[key];
    }
  });
}
function applyVisual(stateList, visualMappings, data2, getValueState, scope, dimension) {
  var visualTypesMap = {};
  each$g(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  var dataIndex;
  function getVisual(key) {
    return getItemVisualFromData(data2, dataIndex, key);
  }
  function setVisual(key, value) {
    setItemVisualFromData(data2, dataIndex, key, value);
  }
  if (dimension == null) {
    data2.each(eachItem);
  } else {
    data2.each([dimension], eachItem);
  }
  function eachItem(valueOrIndex, index2) {
    dataIndex = dimension == null ? valueOrIndex : index2;
    var rawDataItem = data2.getRawDataItem(dataIndex);
    if (rawDataItem && rawDataItem.visualMap === false) {
      return;
    }
    var valueState = getValueState.call(scope, valueOrIndex);
    var mappings = visualMappings[valueState];
    var visualTypes = visualTypesMap[valueState];
    for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
      var type4 = visualTypes[i];
      mappings[type4] && mappings[type4].applyVisual(valueOrIndex, getVisual, setVisual);
    }
  }
}
function incrementalApplyVisual(stateList, visualMappings, getValueState, dim) {
  var visualTypesMap = {};
  each$g(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  return {
    progress: function progress(params, data2) {
      var dimIndex;
      if (dim != null) {
        dimIndex = data2.getDimensionIndex(dim);
      }
      function getVisual(key) {
        return getItemVisualFromData(data2, dataIndex, key);
      }
      function setVisual(key, value2) {
        setItemVisualFromData(data2, dataIndex, key, value2);
      }
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var rawDataItem = data2.getRawDataItem(dataIndex);
        if (rawDataItem && rawDataItem.visualMap === false) {
          continue;
        }
        var value = dim != null ? store.get(dimIndex, dataIndex) : dataIndex;
        var valueState = getValueState(value);
        var mappings = visualMappings[valueState];
        var visualTypes = visualTypesMap[valueState];
        for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
          var type4 = visualTypes[i];
          mappings[type4] && mappings[type4].applyVisual(value, getVisual, setVisual);
        }
      }
    }
  };
}
function makeBrushCommonSelectorForSeries(area) {
  var brushType = area.brushType;
  var selectors = {
    point: function(itemLayout) {
      return selector[brushType].point(itemLayout, selectors, area);
    },
    rect: function(itemLayout) {
      return selector[brushType].rect(itemLayout, selectors, area);
    }
  };
  return selectors;
}
var selector = {
  lineX: getLineSelectors(0),
  lineY: getLineSelectors(1),
  rect: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.intersect(itemLayout);
    }
  },
  polygon: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]) && contain(area.range, itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      var points2 = area.range;
      if (!itemLayout || points2.length <= 1) {
        return false;
      }
      var x2 = itemLayout.x;
      var y2 = itemLayout.y;
      var width = itemLayout.width;
      var height = itemLayout.height;
      var p2 = points2[0];
      if (contain(points2, x2, y2) || contain(points2, x2 + width, y2) || contain(points2, x2, y2 + height) || contain(points2, x2 + width, y2 + height) || BoundingRect$1.create(itemLayout).contain(p2[0], p2[1]) || linePolygonIntersect(x2, y2, x2 + width, y2, points2) || linePolygonIntersect(x2, y2, x2, y2 + height, points2) || linePolygonIntersect(x2 + width, y2, x2 + width, y2 + height, points2) || linePolygonIntersect(x2, y2 + height, x2 + width, y2 + height, points2)) {
        return true;
      }
    }
  }
};
function getLineSelectors(xyIndex) {
  var xy = ["x", "y"];
  var wh2 = ["width", "height"];
  return {
    point: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var p2 = itemLayout[xyIndex];
        return inLineRange(p2, range3);
      }
    },
    rect: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var layoutRange = [itemLayout[xy[xyIndex]], itemLayout[xy[xyIndex]] + itemLayout[wh2[xyIndex]]];
        layoutRange[1] < layoutRange[0] && layoutRange.reverse();
        return inLineRange(layoutRange[0], range3) || inLineRange(layoutRange[1], range3) || inLineRange(range3[0], layoutRange) || inLineRange(range3[1], layoutRange);
      }
    }
  };
}
function inLineRange(p2, range3) {
  return range3[0] <= p2 && p2 <= range3[1];
}
var STATE_LIST = ["inBrush", "outOfBrush"];
var DISPATCH_METHOD = "__ecBrushSelect";
var DISPATCH_FLAG = "__ecInBrushSelectEvent";
function layoutCovers(ecModel) {
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    var brushTargetManager = brushModel.brushTargetManager = new BrushTargetManager$1(brushModel.option, ecModel);
    brushTargetManager.setInputRanges(brushModel.areas, ecModel);
  });
}
function brushVisual(ecModel, api, payload) {
  var brushSelected = [];
  var throttleType;
  var throttleDelay;
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    payload && payload.type === "takeGlobalCursor" && brushModel.setBrushOption(payload.key === "brush" ? payload.brushOption : {
      brushType: false
    });
  });
  layoutCovers(ecModel);
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel, brushIndex) {
    var thisBrushSelected = {
      brushId: brushModel.id,
      brushIndex,
      brushName: brushModel.name,
      areas: clone$4(brushModel.areas),
      selected: []
    };
    brushSelected.push(thisBrushSelected);
    var brushOption = brushModel.option;
    var brushLink = brushOption.brushLink;
    var linkedSeriesMap = [];
    var selectedDataIndexForLink = [];
    var rangeInfoBySeries = [];
    var hasBrushExists = false;
    if (!brushIndex) {
      throttleType = brushOption.throttleType;
      throttleDelay = brushOption.throttleDelay;
    }
    var areas = map$1(brushModel.areas, function(area) {
      var builder = boundingRectBuilders[area.brushType];
      var selectableArea = defaults({
        boundingRect: builder ? builder(area) : void 0
      }, area);
      selectableArea.selectors = makeBrushCommonSelectorForSeries(selectableArea);
      return selectableArea;
    });
    var visualMappings = createVisualMappings(brushModel.option, STATE_LIST, function(mappingOption) {
      mappingOption.mappingMethod = "fixed";
    });
    isArray$2(brushLink) && each$g(brushLink, function(seriesIndex) {
      linkedSeriesMap[seriesIndex] = 1;
    });
    function linkOthers(seriesIndex) {
      return brushLink === "all" || !!linkedSeriesMap[seriesIndex];
    }
    function brushed(rangeInfoList) {
      return !!rangeInfoList.length;
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var rangeInfoList = rangeInfoBySeries[seriesIndex] = [];
      seriesModel.subType === "parallel" ? stepAParallel(seriesModel, seriesIndex) : stepAOthers(seriesModel, seriesIndex, rangeInfoList);
    });
    function stepAParallel(seriesModel, seriesIndex) {
      var coordSys = seriesModel.coordinateSystem;
      hasBrushExists = hasBrushExists || coordSys.hasAxisBrushed();
      linkOthers(seriesIndex) && coordSys.eachActiveState(seriesModel.getData(), function(activeState, dataIndex) {
        activeState === "active" && (selectedDataIndexForLink[dataIndex] = 1);
      });
    }
    function stepAOthers(seriesModel, seriesIndex, rangeInfoList) {
      if (!seriesModel.brushSelector || brushModelNotControll(brushModel, seriesIndex)) {
        return;
      }
      each$g(areas, function(area) {
        if (brushModel.brushTargetManager.controlSeries(area, seriesModel, ecModel)) {
          rangeInfoList.push(area);
        }
        hasBrushExists = hasBrushExists || brushed(rangeInfoList);
      });
      if (linkOthers(seriesIndex) && brushed(rangeInfoList)) {
        var data_1 = seriesModel.getData();
        data_1.each(function(dataIndex) {
          if (checkInRange(seriesModel, rangeInfoList, data_1, dataIndex)) {
            selectedDataIndexForLink[dataIndex] = 1;
          }
        });
      }
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var seriesBrushSelected = {
        seriesId: seriesModel.id,
        seriesIndex,
        seriesName: seriesModel.name,
        dataIndex: []
      };
      thisBrushSelected.selected.push(seriesBrushSelected);
      var rangeInfoList = rangeInfoBySeries[seriesIndex];
      var data2 = seriesModel.getData();
      var getValueState = linkOthers(seriesIndex) ? function(dataIndex) {
        return selectedDataIndexForLink[dataIndex] ? (seriesBrushSelected.dataIndex.push(data2.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      } : function(dataIndex) {
        return checkInRange(seriesModel, rangeInfoList, data2, dataIndex) ? (seriesBrushSelected.dataIndex.push(data2.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      };
      (linkOthers(seriesIndex) ? hasBrushExists : brushed(rangeInfoList)) && applyVisual(STATE_LIST, visualMappings, data2, getValueState);
    });
  });
  dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload);
}
function dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload) {
  if (!payload) {
    return;
  }
  var zr = api.getZr();
  if (zr[DISPATCH_FLAG]) {
    return;
  }
  if (!zr[DISPATCH_METHOD]) {
    zr[DISPATCH_METHOD] = doDispatch;
  }
  var fn = createOrUpdate(zr, DISPATCH_METHOD, throttleDelay, throttleType);
  fn(api, brushSelected);
}
function doDispatch(api, brushSelected) {
  if (!api.isDisposed()) {
    var zr = api.getZr();
    zr[DISPATCH_FLAG] = true;
    api.dispatchAction({
      type: "brushSelect",
      batch: brushSelected
    });
    zr[DISPATCH_FLAG] = false;
  }
}
function checkInRange(seriesModel, rangeInfoList, data2, dataIndex) {
  for (var i = 0, len2 = rangeInfoList.length; i < len2; i++) {
    var area = rangeInfoList[i];
    if (seriesModel.brushSelector(dataIndex, data2, area.selectors, area)) {
      return true;
    }
  }
}
function brushModelNotControll(brushModel, seriesIndex) {
  var seriesIndices = brushModel.option.seriesIndex;
  return seriesIndices != null && seriesIndices !== "all" && (isArray$2(seriesIndices) ? indexOf(seriesIndices, seriesIndex) < 0 : seriesIndex !== seriesIndices);
}
var boundingRectBuilders = {
  rect: function(area) {
    return getBoundingRectFromMinMax(area.range);
  },
  polygon: function(area) {
    var minMax;
    var range3 = area.range;
    for (var i = 0, len2 = range3.length; i < len2; i++) {
      minMax = minMax || [[Infinity, -Infinity], [Infinity, -Infinity]];
      var rg2 = range3[i];
      rg2[0] < minMax[0][0] && (minMax[0][0] = rg2[0]);
      rg2[0] > minMax[0][1] && (minMax[0][1] = rg2[0]);
      rg2[1] < minMax[1][0] && (minMax[1][0] = rg2[1]);
      rg2[1] > minMax[1][1] && (minMax[1][1] = rg2[1]);
    }
    return minMax && getBoundingRectFromMinMax(minMax);
  }
};
function getBoundingRectFromMinMax(minMax) {
  return new BoundingRect$1(minMax[0][0], minMax[1][0], minMax[0][1] - minMax[0][0], minMax[1][1] - minMax[1][0]);
}
var BrushView = function(_super) {
  __extends(BrushView2, _super);
  function BrushView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushView2.type;
    return _this;
  }
  BrushView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
    this.model;
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this)).mount();
  };
  BrushView2.prototype.render = function(brushModel, ecModel, api, payload) {
    this.model = brushModel;
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateTransform = function(brushModel, ecModel, api, payload) {
    layoutCovers(ecModel);
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateVisual = function(brushModel, ecModel, api, payload) {
    this.updateTransform(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateView = function(brushModel, ecModel, api, payload) {
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype._updateController = function(brushModel, ecModel, api, payload) {
    (!payload || payload.$from !== brushModel.id) && this._brushController.setPanels(brushModel.brushTargetManager.makePanelOpts(api)).enableBrush(brushModel.brushOption).updateCovers(brushModel.areas.slice());
  };
  BrushView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  BrushView2.prototype._onBrush = function(eventParam) {
    var modelId = this.model.id;
    var areas = this.model.brushTargetManager.setOutputRanges(eventParam.areas, this.ecModel);
    (!eventParam.isEnd || eventParam.removeOnClick) && this.api.dispatchAction({
      type: "brush",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
    eventParam.isEnd && this.api.dispatchAction({
      type: "brushEnd",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
  };
  BrushView2.type = "brush";
  return BrushView2;
}(ComponentView$1);
var BrushView$1 = BrushView;
var DEFAULT_OUT_OF_BRUSH_COLOR = "#ddd";
var BrushModel = function(_super) {
  __extends(BrushModel2, _super);
  function BrushModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushModel2.type;
    _this.areas = [];
    _this.brushOption = {};
    return _this;
  }
  BrushModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, ["inBrush", "outOfBrush"]);
    var inBrush = thisOption.inBrush = thisOption.inBrush || {};
    thisOption.outOfBrush = thisOption.outOfBrush || {
      color: DEFAULT_OUT_OF_BRUSH_COLOR
    };
    if (!inBrush.hasOwnProperty("liftZ")) {
      inBrush.liftZ = 5;
    }
  };
  BrushModel2.prototype.setAreas = function(areas) {
    if (!areas) {
      return;
    }
    this.areas = map$1(areas, function(area) {
      return generateBrushOption(this.option, area);
    }, this);
  };
  BrushModel2.prototype.setBrushOption = function(brushOption) {
    this.brushOption = generateBrushOption(this.option, brushOption);
    this.brushType = this.brushOption.brushType;
  };
  BrushModel2.type = "brush";
  BrushModel2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"];
  BrushModel2.defaultOption = {
    seriesIndex: "all",
    brushType: "rect",
    brushMode: "single",
    transformable: true,
    brushStyle: {
      borderWidth: 1,
      color: "rgba(210,219,238,0.3)",
      borderColor: "#D2DBEE"
    },
    throttleType: "fixRate",
    throttleDelay: 0,
    removeOnClick: true,
    z: 1e4
  };
  return BrushModel2;
}(ComponentModel$1);
function generateBrushOption(option, brushOption) {
  return merge$1({
    brushType: option.brushType,
    brushMode: option.brushMode,
    transformable: option.transformable,
    brushStyle: new Model$1(option.brushStyle).getItemStyle(),
    removeOnClick: option.removeOnClick,
    z: option.z
  }, brushOption, true);
}
var BrushModel$1 = BrushModel;
var ICON_TYPES = ["rect", "polygon", "lineX", "lineY", "keep", "clear"];
var BrushFeature = function(_super) {
  __extends(BrushFeature2, _super);
  function BrushFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  BrushFeature2.prototype.render = function(featureModel, ecModel, api) {
    var brushType;
    var brushMode;
    var isBrushed;
    ecModel.eachComponent({
      mainType: "brush"
    }, function(brushModel) {
      brushType = brushModel.brushType;
      brushMode = brushModel.brushOption.brushMode || "single";
      isBrushed = isBrushed || !!brushModel.areas.length;
    });
    this._brushType = brushType;
    this._brushMode = brushMode;
    each$g(featureModel.get("type", true), function(type4) {
      featureModel.setIconStatus(type4, (type4 === "keep" ? brushMode === "multiple" : type4 === "clear" ? isBrushed : type4 === brushType) ? "emphasis" : "normal");
    });
  };
  BrushFeature2.prototype.updateView = function(featureModel, ecModel, api) {
    this.render(featureModel, ecModel, api);
  };
  BrushFeature2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon", true);
    var icons = {};
    each$g(model.get("type", true), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  BrushFeature2.prototype.onclick = function(ecModel, api, type4) {
    var brushType = this._brushType;
    var brushMode = this._brushMode;
    if (type4 === "clear") {
      api.dispatchAction({
        type: "axisAreaSelect",
        intervals: []
      });
      api.dispatchAction({
        type: "brush",
        command: "clear",
        areas: []
      });
    } else {
      api.dispatchAction({
        type: "takeGlobalCursor",
        key: "brush",
        brushOption: {
          brushType: type4 === "keep" ? brushType : brushType === type4 ? false : type4,
          brushMode: type4 === "keep" ? brushMode === "multiple" ? "single" : "multiple" : brushMode
        }
      });
    }
  };
  BrushFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: ICON_TYPES.slice(),
      icon: {
        rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13",
        polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2",
        lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4",
        lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4",
        keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z",
        clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "brush", "title"])
    };
    return defaultOption2;
  };
  return BrushFeature2;
}(ToolboxFeature);
var BrushFeature$1 = BrushFeature;
function install$h(registers) {
  registers.registerComponentView(BrushView$1);
  registers.registerComponentModel(BrushModel$1);
  registers.registerPreprocessor(brushPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, brushVisual);
  registers.registerAction({
    type: "brush",
    event: "brush",
    update: "updateVisual"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "brush",
      query: payload
    }, function(brushModel) {
      brushModel.setAreas(payload.areas);
    });
  });
  registers.registerAction({
    type: "brushSelect",
    event: "brushSelected",
    update: "none"
  }, noop$1);
  registers.registerAction({
    type: "brushEnd",
    event: "brushEnd",
    update: "none"
  }, noop$1);
  registerFeature("brush", BrushFeature$1);
}
var TitleModel = function(_super) {
  __extends(TitleModel2, _super);
  function TitleModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  TitleModel2.type = "title";
  TitleModel2.defaultOption = {
    z: 6,
    show: true,
    text: "",
    target: "blank",
    subtext: "",
    subtarget: "blank",
    left: 0,
    top: 0,
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    textStyle: {
      fontSize: 18,
      fontWeight: "bold",
      color: "#464646"
    },
    subtextStyle: {
      fontSize: 12,
      color: "#6E7079"
    }
  };
  return TitleModel2;
}(ComponentModel$1);
var TitleView = function(_super) {
  __extends(TitleView2, _super);
  function TitleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleView2.type;
    return _this;
  }
  TitleView2.prototype.render = function(titleModel, ecModel, api) {
    this.group.removeAll();
    if (!titleModel.get("show")) {
      return;
    }
    var group = this.group;
    var textStyleModel = titleModel.getModel("textStyle");
    var subtextStyleModel = titleModel.getModel("subtextStyle");
    var textAlign = titleModel.get("textAlign");
    var textVerticalAlign = retrieve2(titleModel.get("textBaseline"), titleModel.get("textVerticalAlign"));
    var textEl = new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: titleModel.get("text"),
        fill: textStyleModel.getTextColor()
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var textRect = textEl.getBoundingRect();
    var subText = titleModel.get("subtext");
    var subTextEl = new ZRText$1({
      style: createTextStyle(subtextStyleModel, {
        text: subText,
        fill: subtextStyleModel.getTextColor(),
        y: textRect.height + titleModel.get("itemGap"),
        verticalAlign: "top"
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var link = titleModel.get("link");
    var sublink = titleModel.get("sublink");
    var triggerEvent = titleModel.get("triggerEvent", true);
    textEl.silent = !link && !triggerEvent;
    subTextEl.silent = !sublink && !triggerEvent;
    if (link) {
      textEl.on("click", function() {
        windowOpen(link, "_" + titleModel.get("target"));
      });
    }
    if (sublink) {
      subTextEl.on("click", function() {
        windowOpen(sublink, "_" + titleModel.get("subtarget"));
      });
    }
    getECData(textEl).eventData = getECData(subTextEl).eventData = triggerEvent ? {
      componentType: "title",
      componentIndex: titleModel.componentIndex
    } : null;
    group.add(textEl);
    subText && group.add(subTextEl);
    var groupRect = group.getBoundingRect();
    var layoutOption = titleModel.getBoxLayoutParams();
    layoutOption.width = groupRect.width;
    layoutOption.height = groupRect.height;
    var layoutRect = getLayoutRect(layoutOption, {
      width: api.getWidth(),
      height: api.getHeight()
    }, titleModel.get("padding"));
    if (!textAlign) {
      textAlign = titleModel.get("left") || titleModel.get("right");
      if (textAlign === "middle") {
        textAlign = "center";
      }
      if (textAlign === "right") {
        layoutRect.x += layoutRect.width;
      } else if (textAlign === "center") {
        layoutRect.x += layoutRect.width / 2;
      }
    }
    if (!textVerticalAlign) {
      textVerticalAlign = titleModel.get("top") || titleModel.get("bottom");
      if (textVerticalAlign === "center") {
        textVerticalAlign = "middle";
      }
      if (textVerticalAlign === "bottom") {
        layoutRect.y += layoutRect.height;
      } else if (textVerticalAlign === "middle") {
        layoutRect.y += layoutRect.height / 2;
      }
      textVerticalAlign = textVerticalAlign || "top";
    }
    group.x = layoutRect.x;
    group.y = layoutRect.y;
    group.markRedraw();
    var alignStyle = {
      align: textAlign,
      verticalAlign: textVerticalAlign
    };
    textEl.setStyle(alignStyle);
    subTextEl.setStyle(alignStyle);
    groupRect = group.getBoundingRect();
    var padding = layoutRect.margin;
    var style2 = titleModel.getItemStyle(["color", "opacity"]);
    style2.fill = titleModel.get("backgroundColor");
    var rect = new Rect$3({
      shape: {
        x: groupRect.x - padding[3],
        y: groupRect.y - padding[0],
        width: groupRect.width + padding[1] + padding[3],
        height: groupRect.height + padding[0] + padding[2],
        r: titleModel.get("borderRadius")
      },
      style: style2,
      subPixelOptimize: true,
      silent: true
    });
    group.add(rect);
  };
  TitleView2.type = "title";
  return TitleView2;
}(ComponentView$1);
function install$g(registers) {
  registers.registerComponentModel(TitleModel);
  registers.registerComponentView(TitleView);
}
var TimelineModel = function(_super) {
  __extends(TimelineModel2, _super);
  function TimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineModel2.type;
    _this.layoutMode = "box";
    return _this;
  }
  TimelineModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._initData();
  };
  TimelineModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this._initData();
  };
  TimelineModel2.prototype.setCurrentIndex = function(currentIndex) {
    if (currentIndex == null) {
      currentIndex = this.option.currentIndex;
    }
    var count2 = this._data.count();
    if (this.option.loop) {
      currentIndex = (currentIndex % count2 + count2) % count2;
    } else {
      currentIndex >= count2 && (currentIndex = count2 - 1);
      currentIndex < 0 && (currentIndex = 0);
    }
    this.option.currentIndex = currentIndex;
  };
  TimelineModel2.prototype.getCurrentIndex = function() {
    return this.option.currentIndex;
  };
  TimelineModel2.prototype.isIndexMax = function() {
    return this.getCurrentIndex() >= this._data.count() - 1;
  };
  TimelineModel2.prototype.setPlayState = function(state) {
    this.option.autoPlay = !!state;
  };
  TimelineModel2.prototype.getPlayState = function() {
    return !!this.option.autoPlay;
  };
  TimelineModel2.prototype._initData = function() {
    var thisOption = this.option;
    var dataArr = thisOption.data || [];
    var axisType = thisOption.axisType;
    var names2 = this._names = [];
    var processedDataArr;
    if (axisType === "category") {
      processedDataArr = [];
      each$g(dataArr, function(item, index2) {
        var value = convertOptionIdName(getDataItemValue(item), "");
        var newItem;
        if (isObject$6(item)) {
          newItem = clone$4(item);
          newItem.value = index2;
        } else {
          newItem = index2;
        }
        processedDataArr.push(newItem);
        names2.push(value);
      });
    } else {
      processedDataArr = dataArr;
    }
    var dimType = {
      category: "ordinal",
      time: "time",
      value: "number"
    }[axisType] || "number";
    var data2 = this._data = new SeriesData$1([{
      name: "value",
      type: dimType
    }], this);
    data2.initData(processedDataArr, names2);
  };
  TimelineModel2.prototype.getData = function() {
    return this._data;
  };
  TimelineModel2.prototype.getCategories = function() {
    if (this.get("axisType") === "category") {
      return this._names.slice();
    }
  };
  TimelineModel2.type = "timeline";
  TimelineModel2.defaultOption = {
    z: 4,
    show: true,
    axisType: "time",
    realtime: true,
    left: "20%",
    top: null,
    right: "20%",
    bottom: 0,
    width: null,
    height: 40,
    padding: 5,
    controlPosition: "left",
    autoPlay: false,
    rewind: false,
    loop: true,
    playInterval: 2e3,
    currentIndex: 0,
    itemStyle: {},
    label: {
      color: "#000"
    },
    data: []
  };
  return TimelineModel2;
}(ComponentModel$1);
var TimelineModel$1 = TimelineModel;
var SliderTimelineModel = function(_super) {
  __extends(SliderTimelineModel2, _super);
  function SliderTimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineModel2.type;
    return _this;
  }
  SliderTimelineModel2.type = "timeline.slider";
  SliderTimelineModel2.defaultOption = inheritDefaultOption(TimelineModel$1.defaultOption, {
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    orient: "horizontal",
    inverse: false,
    tooltip: {
      trigger: "item"
    },
    symbol: "circle",
    symbolSize: 12,
    lineStyle: {
      show: true,
      width: 2,
      color: "#DAE1F5"
    },
    label: {
      position: "auto",
      show: true,
      interval: "auto",
      rotate: 0,
      color: "#A4B1D7"
    },
    itemStyle: {
      color: "#A4B1D7",
      borderWidth: 1
    },
    checkpointStyle: {
      symbol: "circle",
      symbolSize: 15,
      color: "#316bf3",
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0, 0, 0, 0.3)",
      animation: true,
      animationDuration: 300,
      animationEasing: "quinticInOut"
    },
    controlStyle: {
      show: true,
      showPlayBtn: true,
      showPrevBtn: true,
      showNextBtn: true,
      itemSize: 24,
      itemGap: 12,
      position: "left",
      playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z",
      stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z",
      nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z",
      prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z",
      prevBtnSize: 18,
      nextBtnSize: 18,
      color: "#A4B1D7",
      borderColor: "#A4B1D7",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true,
        color: "#6f778d"
      },
      itemStyle: {
        color: "#316BF3"
      },
      controlStyle: {
        color: "#316BF3",
        borderColor: "#316BF3",
        borderWidth: 2
      }
    },
    progress: {
      lineStyle: {
        color: "#316BF3"
      },
      itemStyle: {
        color: "#316BF3"
      },
      label: {
        color: "#6f778d"
      }
    },
    data: []
  });
  return SliderTimelineModel2;
}(TimelineModel$1);
mixin(SliderTimelineModel, DataFormatMixin.prototype);
var SliderTimelineModel$1 = SliderTimelineModel;
var TimelineView = function(_super) {
  __extends(TimelineView2, _super);
  function TimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineView2.type;
    return _this;
  }
  TimelineView2.type = "timeline";
  return TimelineView2;
}(ComponentView$1);
var TimelineView$1 = TimelineView;
var TimelineAxis = function(_super) {
  __extends(TimelineAxis2, _super);
  function TimelineAxis2(dim, scale2, coordExtent, axisType) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    return _this;
  }
  TimelineAxis2.prototype.getLabelModel = function() {
    return this.model.getModel("label");
  };
  TimelineAxis2.prototype.isHorizontal = function() {
    return this.model.get("orient") === "horizontal";
  };
  return TimelineAxis2;
}(Axis$1);
var TimelineAxis$1 = TimelineAxis;
var PI = Math.PI;
var labelDataIndexStore = makeInner();
var SliderTimelineView = function(_super) {
  __extends(SliderTimelineView2, _super);
  function SliderTimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineView2.type;
    return _this;
  }
  SliderTimelineView2.prototype.init = function(ecModel, api) {
    this.api = api;
  };
  SliderTimelineView2.prototype.render = function(timelineModel, ecModel, api) {
    this.model = timelineModel;
    this.api = api;
    this.ecModel = ecModel;
    this.group.removeAll();
    if (timelineModel.get("show", true)) {
      var layoutInfo_1 = this._layout(timelineModel, api);
      var mainGroup_1 = this._createGroup("_mainGroup");
      var labelGroup = this._createGroup("_labelGroup");
      var axis_1 = this._axis = this._createAxis(layoutInfo_1, timelineModel);
      timelineModel.formatTooltip = function(dataIndex) {
        var name2 = axis_1.scale.getLabel({
          value: dataIndex
        });
        return createTooltipMarkup("nameValue", {
          noName: true,
          value: name2
        });
      };
      each$g(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(name2) {
        this["_render" + name2](layoutInfo_1, mainGroup_1, axis_1, timelineModel);
      }, this);
      this._renderAxisLabel(layoutInfo_1, labelGroup, axis_1, timelineModel);
      this._position(layoutInfo_1, timelineModel);
    }
    this._doPlayStop();
    this._updateTicksStatus();
  };
  SliderTimelineView2.prototype.remove = function() {
    this._clearTimer();
    this.group.removeAll();
  };
  SliderTimelineView2.prototype.dispose = function() {
    this._clearTimer();
  };
  SliderTimelineView2.prototype._layout = function(timelineModel, api) {
    var labelPosOpt = timelineModel.get(["label", "position"]);
    var orient = timelineModel.get("orient");
    var viewRect2 = getViewRect(timelineModel, api);
    var parsedLabelPos;
    if (labelPosOpt == null || labelPosOpt === "auto") {
      parsedLabelPos = orient === "horizontal" ? viewRect2.y + viewRect2.height / 2 < api.getHeight() / 2 ? "-" : "+" : viewRect2.x + viewRect2.width / 2 < api.getWidth() / 2 ? "+" : "-";
    } else if (isString$1(labelPosOpt)) {
      parsedLabelPos = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[orient][labelPosOpt];
    } else {
      parsedLabelPos = labelPosOpt;
    }
    var labelAlignMap = {
      horizontal: "center",
      vertical: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "left" : "right"
    };
    var labelBaselineMap = {
      horizontal: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "top" : "bottom",
      vertical: "middle"
    };
    var rotationMap = {
      horizontal: 0,
      vertical: PI / 2
    };
    var mainLength = orient === "vertical" ? viewRect2.height : viewRect2.width;
    var controlModel = timelineModel.getModel("controlStyle");
    var showControl = controlModel.get("show", true);
    var controlSize = showControl ? controlModel.get("itemSize") : 0;
    var controlGap = showControl ? controlModel.get("itemGap") : 0;
    var sizePlusGap = controlSize + controlGap;
    var labelRotation = timelineModel.get(["label", "rotate"]) || 0;
    labelRotation = labelRotation * PI / 180;
    var playPosition;
    var prevBtnPosition;
    var nextBtnPosition;
    var controlPosition = controlModel.get("position", true);
    var showPlayBtn = showControl && controlModel.get("showPlayBtn", true);
    var showPrevBtn = showControl && controlModel.get("showPrevBtn", true);
    var showNextBtn = showControl && controlModel.get("showNextBtn", true);
    var xLeft = 0;
    var xRight = mainLength;
    if (controlPosition === "left" || controlPosition === "bottom") {
      showPlayBtn && (playPosition = [0, 0], xLeft += sizePlusGap);
      showPrevBtn && (prevBtnPosition = [xLeft, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    } else {
      showPlayBtn && (playPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
      showPrevBtn && (prevBtnPosition = [0, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    }
    var axisExtent = [xLeft, xRight];
    if (timelineModel.get("inverse")) {
      axisExtent.reverse();
    }
    return {
      viewRect: viewRect2,
      mainLength,
      orient,
      rotation: rotationMap[orient],
      labelRotation,
      labelPosOpt: parsedLabelPos,
      labelAlign: timelineModel.get(["label", "align"]) || labelAlignMap[orient],
      labelBaseline: timelineModel.get(["label", "verticalAlign"]) || timelineModel.get(["label", "baseline"]) || labelBaselineMap[orient],
      playPosition,
      prevBtnPosition,
      nextBtnPosition,
      axisExtent,
      controlSize,
      controlGap
    };
  };
  SliderTimelineView2.prototype._position = function(layoutInfo, timelineModel) {
    var mainGroup = this._mainGroup;
    var labelGroup = this._labelGroup;
    var viewRect2 = layoutInfo.viewRect;
    if (layoutInfo.orient === "vertical") {
      var m2 = create$2();
      var rotateOriginX = viewRect2.x;
      var rotateOriginY = viewRect2.y + viewRect2.height;
      translate(m2, m2, [-rotateOriginX, -rotateOriginY]);
      rotate(m2, m2, -PI / 2);
      translate(m2, m2, [rotateOriginX, rotateOriginY]);
      viewRect2 = viewRect2.clone();
      viewRect2.applyTransform(m2);
    }
    var viewBound = getBound(viewRect2);
    var mainBound = getBound(mainGroup.getBoundingRect());
    var labelBound = getBound(labelGroup.getBoundingRect());
    var mainPosition = [mainGroup.x, mainGroup.y];
    var labelsPosition = [labelGroup.x, labelGroup.y];
    labelsPosition[0] = mainPosition[0] = viewBound[0][0];
    var labelPosOpt = layoutInfo.labelPosOpt;
    if (labelPosOpt == null || isString$1(labelPosOpt)) {
      var mainBoundIdx = labelPosOpt === "+" ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      toBound(labelsPosition, labelBound, viewBound, 1, 1 - mainBoundIdx);
    } else {
      var mainBoundIdx = labelPosOpt >= 0 ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      labelsPosition[1] = mainPosition[1] + labelPosOpt;
    }
    mainGroup.setPosition(mainPosition);
    labelGroup.setPosition(labelsPosition);
    mainGroup.rotation = labelGroup.rotation = layoutInfo.rotation;
    setOrigin(mainGroup);
    setOrigin(labelGroup);
    function setOrigin(targetGroup) {
      targetGroup.originX = viewBound[0][0] - targetGroup.x;
      targetGroup.originY = viewBound[1][0] - targetGroup.y;
    }
    function getBound(rect) {
      return [[rect.x, rect.x + rect.width], [rect.y, rect.y + rect.height]];
    }
    function toBound(fromPos, from2, to, dimIdx, boundIdx) {
      fromPos[dimIdx] += to[dimIdx][boundIdx] - from2[dimIdx][boundIdx];
    }
  };
  SliderTimelineView2.prototype._createAxis = function(layoutInfo, timelineModel) {
    var data2 = timelineModel.getData();
    var axisType = timelineModel.get("axisType");
    var scale2 = createScaleByModel(timelineModel, axisType);
    scale2.getTicks = function() {
      return data2.mapArray(["value"], function(value) {
        return {
          value
        };
      });
    };
    var dataExtent = data2.getDataExtent("value");
    scale2.setExtent(dataExtent[0], dataExtent[1]);
    scale2.calcNiceTicks();
    var axis = new TimelineAxis$1("value", scale2, layoutInfo.axisExtent, axisType);
    axis.model = timelineModel;
    return axis;
  };
  SliderTimelineView2.prototype._createGroup = function(key) {
    var newGroup = this[key] = new Group$6();
    this.group.add(newGroup);
    return newGroup;
  };
  SliderTimelineView2.prototype._renderAxisLine = function(layoutInfo, group, axis, timelineModel) {
    var axisExtent = axis.getExtent();
    if (!timelineModel.get(["lineStyle", "show"])) {
      return;
    }
    var line = new Line$3({
      shape: {
        x1: axisExtent[0],
        y1: 0,
        x2: axisExtent[1],
        y2: 0
      },
      style: extend({
        lineCap: "round"
      }, timelineModel.getModel("lineStyle").getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(line);
    var progressLine = this._progressLine = new Line$3({
      shape: {
        x1: axisExtent[0],
        x2: this._currentPointer ? this._currentPointer.x : axisExtent[0],
        y1: 0,
        y2: 0
      },
      style: defaults({
        lineCap: "round",
        lineWidth: line.style.lineWidth
      }, timelineModel.getModel(["progress", "lineStyle"]).getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(progressLine);
  };
  SliderTimelineView2.prototype._renderAxisTick = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var data2 = timelineModel.getData();
    var ticks = axis.scale.getTicks();
    this._tickSymbols = [];
    each$g(ticks, function(tick) {
      var tickCoord = axis.dataToCoord(tick.value);
      var itemModel = data2.getItemModel(tick.value);
      var itemStyleModel = itemModel.getModel("itemStyle");
      var hoverStyleModel = itemModel.getModel(["emphasis", "itemStyle"]);
      var progressStyleModel = itemModel.getModel(["progress", "itemStyle"]);
      var symbolOpt = {
        x: tickCoord,
        y: 0,
        onclick: bind$1(_this._changeTimeline, _this, tick.value)
      };
      var el = giveSymbol(itemModel, itemStyleModel, group, symbolOpt);
      el.ensureState("emphasis").style = hoverStyleModel.getItemStyle();
      el.ensureState("progress").style = progressStyleModel.getItemStyle();
      enableHoverEmphasis(el);
      var ecData = getECData(el);
      if (itemModel.get("tooltip")) {
        ecData.dataIndex = tick.value;
        ecData.dataModel = timelineModel;
      } else {
        ecData.dataIndex = ecData.dataModel = null;
      }
      _this._tickSymbols.push(el);
    });
  };
  SliderTimelineView2.prototype._renderAxisLabel = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var labelModel = axis.getLabelModel();
    if (!labelModel.get("show")) {
      return;
    }
    var data2 = timelineModel.getData();
    var labels = axis.getViewLabels();
    this._tickLabels = [];
    each$g(labels, function(labelItem) {
      var dataIndex = labelItem.tickValue;
      var itemModel = data2.getItemModel(dataIndex);
      var normalLabelModel = itemModel.getModel("label");
      var hoverLabelModel = itemModel.getModel(["emphasis", "label"]);
      var progressLabelModel = itemModel.getModel(["progress", "label"]);
      var tickCoord = axis.dataToCoord(labelItem.tickValue);
      var textEl = new ZRText$1({
        x: tickCoord,
        y: 0,
        rotation: layoutInfo.labelRotation - layoutInfo.rotation,
        onclick: bind$1(_this._changeTimeline, _this, dataIndex),
        silent: false,
        style: createTextStyle(normalLabelModel, {
          text: labelItem.formattedLabel,
          align: layoutInfo.labelAlign,
          verticalAlign: layoutInfo.labelBaseline
        })
      });
      textEl.ensureState("emphasis").style = createTextStyle(hoverLabelModel);
      textEl.ensureState("progress").style = createTextStyle(progressLabelModel);
      group.add(textEl);
      enableHoverEmphasis(textEl);
      labelDataIndexStore(textEl).dataIndex = dataIndex;
      _this._tickLabels.push(textEl);
    });
  };
  SliderTimelineView2.prototype._renderControl = function(layoutInfo, group, axis, timelineModel) {
    var controlSize = layoutInfo.controlSize;
    var rotation = layoutInfo.rotation;
    var itemStyle = timelineModel.getModel("controlStyle").getItemStyle();
    var hoverStyle = timelineModel.getModel(["emphasis", "controlStyle"]).getItemStyle();
    var playState = timelineModel.getPlayState();
    var inverse = timelineModel.get("inverse", true);
    makeBtn(layoutInfo.nextBtnPosition, "next", bind$1(this._changeTimeline, this, inverse ? "-" : "+"));
    makeBtn(layoutInfo.prevBtnPosition, "prev", bind$1(this._changeTimeline, this, inverse ? "+" : "-"));
    makeBtn(layoutInfo.playPosition, playState ? "stop" : "play", bind$1(this._handlePlayClick, this, !playState), true);
    function makeBtn(position2, iconName, onclick, willRotate) {
      if (!position2) {
        return;
      }
      var iconSize = parsePercent$1(retrieve2(timelineModel.get(["controlStyle", iconName + "BtnSize"]), controlSize), controlSize);
      var rect = [0, -iconSize / 2, iconSize, iconSize];
      var btn = makeControlIcon(timelineModel, iconName + "Icon", rect, {
        x: position2[0],
        y: position2[1],
        originX: controlSize / 2,
        originY: 0,
        rotation: willRotate ? -rotation : 0,
        rectHover: true,
        style: itemStyle,
        onclick
      });
      btn.ensureState("emphasis").style = hoverStyle;
      group.add(btn);
      enableHoverEmphasis(btn);
    }
  };
  SliderTimelineView2.prototype._renderCurrentPointer = function(layoutInfo, group, axis, timelineModel) {
    var data2 = timelineModel.getData();
    var currentIndex = timelineModel.getCurrentIndex();
    var pointerModel = data2.getItemModel(currentIndex).getModel("checkpointStyle");
    var me2 = this;
    var callback = {
      onCreate: function(pointer) {
        pointer.draggable = true;
        pointer.drift = bind$1(me2._handlePointerDrag, me2);
        pointer.ondragend = bind$1(me2._handlePointerDragend, me2);
        pointerMoveTo(pointer, me2._progressLine, currentIndex, axis, timelineModel, true);
      },
      onUpdate: function(pointer) {
        pointerMoveTo(pointer, me2._progressLine, currentIndex, axis, timelineModel);
      }
    };
    this._currentPointer = giveSymbol(pointerModel, pointerModel, this._mainGroup, {}, this._currentPointer, callback);
  };
  SliderTimelineView2.prototype._handlePlayClick = function(nextState) {
    this._clearTimer();
    this.api.dispatchAction({
      type: "timelinePlayChange",
      playState: nextState,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._handlePointerDrag = function(dx, dy, e2) {
    this._clearTimer();
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY]);
  };
  SliderTimelineView2.prototype._handlePointerDragend = function(e2) {
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
  };
  SliderTimelineView2.prototype._pointerChangeTimeline = function(mousePos, trigger2) {
    var toCoord = this._toAxisCoord(mousePos)[0];
    var axis = this._axis;
    var axisExtent = asc$2(axis.getExtent().slice());
    toCoord > axisExtent[1] && (toCoord = axisExtent[1]);
    toCoord < axisExtent[0] && (toCoord = axisExtent[0]);
    this._currentPointer.x = toCoord;
    this._currentPointer.markRedraw();
    this._progressLine.shape.x2 = toCoord;
    this._progressLine.dirty();
    var targetDataIndex = this._findNearestTick(toCoord);
    var timelineModel = this.model;
    if (trigger2 || targetDataIndex !== timelineModel.getCurrentIndex() && timelineModel.get("realtime")) {
      this._changeTimeline(targetDataIndex);
    }
  };
  SliderTimelineView2.prototype._doPlayStop = function() {
    var _this = this;
    this._clearTimer();
    if (this.model.getPlayState()) {
      this._timer = setTimeout(function() {
        var timelineModel = _this.model;
        _this._changeTimeline(timelineModel.getCurrentIndex() + (timelineModel.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval"));
    }
  };
  SliderTimelineView2.prototype._toAxisCoord = function(vertex) {
    var trans = this._mainGroup.getLocalTransform();
    return applyTransform(vertex, trans, true);
  };
  SliderTimelineView2.prototype._findNearestTick = function(axisCoord) {
    var data2 = this.model.getData();
    var dist2 = Infinity;
    var targetDataIndex;
    var axis = this._axis;
    data2.each(["value"], function(value, dataIndex) {
      var coord = axis.dataToCoord(value);
      var d2 = Math.abs(coord - axisCoord);
      if (d2 < dist2) {
        dist2 = d2;
        targetDataIndex = dataIndex;
      }
    });
    return targetDataIndex;
  };
  SliderTimelineView2.prototype._clearTimer = function() {
    if (this._timer) {
      clearTimeout(this._timer);
      this._timer = null;
    }
  };
  SliderTimelineView2.prototype._changeTimeline = function(nextIndex2) {
    var currentIndex = this.model.getCurrentIndex();
    if (nextIndex2 === "+") {
      nextIndex2 = currentIndex + 1;
    } else if (nextIndex2 === "-") {
      nextIndex2 = currentIndex - 1;
    }
    this.api.dispatchAction({
      type: "timelineChange",
      currentIndex: nextIndex2,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._updateTicksStatus = function() {
    var currentIndex = this.model.getCurrentIndex();
    var tickSymbols = this._tickSymbols;
    var tickLabels = this._tickLabels;
    if (tickSymbols) {
      for (var i = 0; i < tickSymbols.length; i++) {
        tickSymbols && tickSymbols[i] && tickSymbols[i].toggleState("progress", i < currentIndex);
      }
    }
    if (tickLabels) {
      for (var i = 0; i < tickLabels.length; i++) {
        tickLabels && tickLabels[i] && tickLabels[i].toggleState("progress", labelDataIndexStore(tickLabels[i]).dataIndex <= currentIndex);
      }
    }
  };
  SliderTimelineView2.type = "timeline.slider";
  return SliderTimelineView2;
}(TimelineView$1);
function createScaleByModel(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new IntervalScale$1();
    }
  }
}
function getViewRect(model, api) {
  return getLayoutRect(model.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  }, model.get("padding"));
}
function makeControlIcon(timelineModel, objPath, rect, opts) {
  var style2 = opts.style;
  var icon = createIcon(timelineModel.get(["controlStyle", objPath]), opts || {}, new BoundingRect$1(rect[0], rect[1], rect[2], rect[3]));
  if (style2) {
    icon.setStyle(style2);
  }
  return icon;
}
function giveSymbol(hostModel, itemStyleModel, group, opt, symbol, callback) {
  var color = itemStyleModel.get("color");
  if (!symbol) {
    var symbolType = hostModel.get("symbol");
    symbol = createSymbol$1(symbolType, -1, -1, 2, 2, color);
    symbol.setStyle("strokeNoScale", true);
    group.add(symbol);
    callback && callback.onCreate(symbol);
  } else {
    symbol.setColor(color);
    group.add(symbol);
    callback && callback.onUpdate(symbol);
  }
  var itemStyle = itemStyleModel.getItemStyle(["color"]);
  symbol.setStyle(itemStyle);
  opt = merge$1({
    rectHover: true,
    z2: 100
  }, opt, true);
  var symbolSize = normalizeSymbolSize(hostModel.get("symbolSize"));
  opt.scaleX = symbolSize[0] / 2;
  opt.scaleY = symbolSize[1] / 2;
  var symbolOffset = normalizeSymbolOffset(hostModel.get("symbolOffset"), symbolSize);
  if (symbolOffset) {
    opt.x = (opt.x || 0) + symbolOffset[0];
    opt.y = (opt.y || 0) + symbolOffset[1];
  }
  var symbolRotate = hostModel.get("symbolRotate");
  opt.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  symbol.attr(opt);
  symbol.updateTransform();
  return symbol;
}
function pointerMoveTo(pointer, progressLine, dataIndex, axis, timelineModel, noAnimation) {
  if (pointer.dragging) {
    return;
  }
  var pointerModel = timelineModel.getModel("checkpointStyle");
  var toCoord = axis.dataToCoord(timelineModel.getData().get("value", dataIndex));
  if (noAnimation || !pointerModel.get("animation", true)) {
    pointer.attr({
      x: toCoord,
      y: 0
    });
    progressLine && progressLine.attr({
      shape: {
        x2: toCoord
      }
    });
  } else {
    var animationCfg = {
      duration: pointerModel.get("animationDuration", true),
      easing: pointerModel.get("animationEasing", true)
    };
    pointer.stopAnimation(null, true);
    pointer.animateTo({
      x: toCoord,
      y: 0
    }, animationCfg);
    progressLine && progressLine.animateTo({
      shape: {
        x2: toCoord
      }
    }, animationCfg);
  }
}
var SliderTimelineView$1 = SliderTimelineView;
function installTimelineAction(registers) {
  registers.registerAction({
    type: "timelineChange",
    event: "timelineChanged",
    update: "prepareAndUpdate"
  }, function(payload, ecModel, api) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.currentIndex != null) {
      timelineModel.setCurrentIndex(payload.currentIndex);
      if (!timelineModel.get("loop", true) && timelineModel.isIndexMax() && timelineModel.getPlayState()) {
        timelineModel.setPlayState(false);
        api.dispatchAction({
          type: "timelinePlayChange",
          playState: false,
          from: payload.from
        });
      }
    }
    ecModel.resetOption("timeline", {
      replaceMerge: timelineModel.get("replaceMerge", true)
    });
    return defaults({
      currentIndex: timelineModel.option.currentIndex
    }, payload);
  });
  registers.registerAction({
    type: "timelinePlayChange",
    event: "timelinePlayChanged",
    update: "update"
  }, function(payload, ecModel) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.playState != null) {
      timelineModel.setPlayState(payload.playState);
    }
  });
}
function timelinePreprocessor(option) {
  var timelineOpt = option && option.timeline;
  if (!isArray$2(timelineOpt)) {
    timelineOpt = timelineOpt ? [timelineOpt] : [];
  }
  each$g(timelineOpt, function(opt) {
    if (!opt) {
      return;
    }
    compatibleEC2(opt);
  });
}
function compatibleEC2(opt) {
  var type4 = opt.type;
  var ec2Types = {
    "number": "value",
    "time": "time"
  };
  if (ec2Types[type4]) {
    opt.axisType = ec2Types[type4];
    delete opt.type;
  }
  transferItem(opt);
  if (has$2(opt, "controlPosition")) {
    var controlStyle = opt.controlStyle || (opt.controlStyle = {});
    if (!has$2(controlStyle, "position")) {
      controlStyle.position = opt.controlPosition;
    }
    if (controlStyle.position === "none" && !has$2(controlStyle, "show")) {
      controlStyle.show = false;
      delete controlStyle.position;
    }
    delete opt.controlPosition;
  }
  each$g(opt.data || [], function(dataItem) {
    if (isObject$6(dataItem) && !isArray$2(dataItem)) {
      if (!has$2(dataItem, "value") && has$2(dataItem, "name")) {
        dataItem.value = dataItem.name;
      }
      transferItem(dataItem);
    }
  });
}
function transferItem(opt) {
  var itemStyle = opt.itemStyle || (opt.itemStyle = {});
  var itemStyleEmphasis = itemStyle.emphasis || (itemStyle.emphasis = {});
  var label = opt.label || opt.label || {};
  var labelNormal = label.normal || (label.normal = {});
  var excludeLabelAttr = {
    normal: 1,
    emphasis: 1
  };
  each$g(label, function(value, name2) {
    if (!excludeLabelAttr[name2] && !has$2(labelNormal, name2)) {
      labelNormal[name2] = value;
    }
  });
  if (itemStyleEmphasis.label && !has$2(label, "emphasis")) {
    label.emphasis = itemStyleEmphasis.label;
    delete itemStyleEmphasis.label;
  }
}
function has$2(obj, attr) {
  return obj.hasOwnProperty(attr);
}
function install$f(registers) {
  registers.registerComponentModel(SliderTimelineModel$1);
  registers.registerComponentView(SliderTimelineView$1);
  registers.registerSubTypeDefaulter("timeline", function() {
    return "slider";
  });
  installTimelineAction(registers);
  registers.registerPreprocessor(timelinePreprocessor);
}
function checkMarkerInSeries(seriesOpts, markerType) {
  if (!seriesOpts) {
    return false;
  }
  var seriesOptArr = isArray$2(seriesOpts) ? seriesOpts : [seriesOpts];
  for (var idx = 0; idx < seriesOptArr.length; idx++) {
    if (seriesOptArr[idx] && seriesOptArr[idx][markerType]) {
      return true;
    }
  }
  return false;
}
function fillLabel(opt) {
  defaultEmphasis(opt, "label", ["show"]);
}
var inner$5 = makeInner();
var MarkerModel = function(_super) {
  __extends(MarkerModel2, _super);
  function MarkerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerModel2.type;
    _this.createdBySelf = false;
    return _this;
  }
  MarkerModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._mergeOption(option, ecModel, false, true);
  };
  MarkerModel2.prototype.isAnimationEnabled = function() {
    if (env$1.node) {
      return false;
    }
    var hostSeries = this.__hostSeries;
    return this.getShallow("animation") && hostSeries && hostSeries.isAnimationEnabled();
  };
  MarkerModel2.prototype.mergeOption = function(newOpt, ecModel) {
    this._mergeOption(newOpt, ecModel, false, false);
  };
  MarkerModel2.prototype._mergeOption = function(newOpt, ecModel, createdBySelf, isInit) {
    var componentType = this.mainType;
    if (!createdBySelf) {
      ecModel.eachSeries(function(seriesModel) {
        var markerOpt = seriesModel.get(this.mainType, true);
        var markerModel = inner$5(seriesModel)[componentType];
        if (!markerOpt || !markerOpt.data) {
          inner$5(seriesModel)[componentType] = null;
          return;
        }
        if (!markerModel) {
          if (isInit) {
            fillLabel(markerOpt);
          }
          each$g(markerOpt.data, function(item) {
            if (item instanceof Array) {
              fillLabel(item[0]);
              fillLabel(item[1]);
            } else {
              fillLabel(item);
            }
          });
          markerModel = this.createMarkerModelFromSeries(markerOpt, this, ecModel);
          extend(markerModel, {
            mainType: this.mainType,
            seriesIndex: seriesModel.seriesIndex,
            name: seriesModel.name,
            createdBySelf: true
          });
          markerModel.__hostSeries = seriesModel;
        } else {
          markerModel._mergeOption(markerOpt, ecModel, true);
        }
        inner$5(seriesModel)[componentType] = markerModel;
      }, this);
    }
  };
  MarkerModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data2 = this.getData();
    var value = this.getRawValue(dataIndex);
    var itemName = data2.getName(dataIndex);
    return createTooltipMarkup("section", {
      header: this.name,
      blocks: [createTooltipMarkup("nameValue", {
        name: itemName,
        value,
        noName: !itemName,
        noValue: value == null
      })]
    });
  };
  MarkerModel2.prototype.getData = function() {
    return this._data;
  };
  MarkerModel2.prototype.setData = function(data2) {
    this._data = data2;
  };
  MarkerModel2.getMarkerModelFromSeries = function(seriesModel, componentType) {
    return inner$5(seriesModel)[componentType];
  };
  MarkerModel2.type = "marker";
  MarkerModel2.dependencies = ["series", "grid", "polar", "geo"];
  return MarkerModel2;
}(ComponentModel$1);
mixin(MarkerModel, DataFormatMixin.prototype);
var MarkerModel$1 = MarkerModel;
var MarkPointModel = function(_super) {
  __extends(MarkPointModel2, _super);
  function MarkPointModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointModel2.type;
    return _this;
  }
  MarkPointModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkPointModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkPointModel2.type = "markPoint";
  MarkPointModel2.defaultOption = {
    z: 5,
    symbol: "pin",
    symbolSize: 50,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "inside"
    },
    itemStyle: {
      borderWidth: 2
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return MarkPointModel2;
}(MarkerModel$1);
var MarkPointModel$1 = MarkPointModel;
function hasXOrY(item) {
  return !(isNaN(parseFloat(item.x)) && isNaN(parseFloat(item.y)));
}
function hasXAndY(item) {
  return !isNaN(parseFloat(item.x)) && !isNaN(parseFloat(item.y));
}
function markerTypeCalculatorWithExtent(markerType, data2, otherDataDim, targetDataDim, otherCoordIndex, targetCoordIndex) {
  var coordArr = [];
  var stacked = isDimensionStacked(data2, targetDataDim);
  var calcDataDim = stacked ? data2.getCalculationInfo("stackResultDimension") : targetDataDim;
  var value = numCalculate(data2, calcDataDim, markerType);
  var dataIndex = data2.indicesOfNearest(calcDataDim, value)[0];
  coordArr[otherCoordIndex] = data2.get(otherDataDim, dataIndex);
  coordArr[targetCoordIndex] = data2.get(calcDataDim, dataIndex);
  var coordArrValue = data2.get(targetDataDim, dataIndex);
  var precision = getPrecision(data2.get(targetDataDim, dataIndex));
  precision = Math.min(precision, 20);
  if (precision >= 0) {
    coordArr[targetCoordIndex] = +coordArr[targetCoordIndex].toFixed(precision);
  }
  return [coordArr, coordArrValue];
}
var markerTypeCalculator = {
  min: curry$3(markerTypeCalculatorWithExtent, "min"),
  max: curry$3(markerTypeCalculatorWithExtent, "max"),
  average: curry$3(markerTypeCalculatorWithExtent, "average"),
  median: curry$3(markerTypeCalculatorWithExtent, "median")
};
function dataTransform(seriesModel, item) {
  var data2 = seriesModel.getData();
  var coordSys = seriesModel.coordinateSystem;
  if (item && !hasXAndY(item) && !isArray$2(item.coord) && coordSys) {
    var dims = coordSys.dimensions;
    var axisInfo = getAxisInfo(item, data2, coordSys, seriesModel);
    item = clone$4(item);
    if (item.type && markerTypeCalculator[item.type] && axisInfo.baseAxis && axisInfo.valueAxis) {
      var otherCoordIndex = indexOf(dims, axisInfo.baseAxis.dim);
      var targetCoordIndex = indexOf(dims, axisInfo.valueAxis.dim);
      var coordInfo = markerTypeCalculator[item.type](data2, axisInfo.baseDataDim, axisInfo.valueDataDim, otherCoordIndex, targetCoordIndex);
      item.coord = coordInfo[0];
      item.value = coordInfo[1];
    } else {
      var coord = [item.xAxis != null ? item.xAxis : item.radiusAxis, item.yAxis != null ? item.yAxis : item.angleAxis];
      for (var i = 0; i < 2; i++) {
        if (markerTypeCalculator[coord[i]]) {
          coord[i] = numCalculate(data2, data2.mapDimension(dims[i]), coord[i]);
        }
      }
      item.coord = coord;
    }
  }
  return item;
}
function getAxisInfo(item, data2, coordSys, seriesModel) {
  var ret = {};
  if (item.valueIndex != null || item.valueDim != null) {
    ret.valueDataDim = item.valueIndex != null ? data2.getDimension(item.valueIndex) : item.valueDim;
    ret.valueAxis = coordSys.getAxis(dataDimToCoordDim(seriesModel, ret.valueDataDim));
    ret.baseAxis = coordSys.getOtherAxis(ret.valueAxis);
    ret.baseDataDim = data2.mapDimension(ret.baseAxis.dim);
  } else {
    ret.baseAxis = seriesModel.getBaseAxis();
    ret.valueAxis = coordSys.getOtherAxis(ret.baseAxis);
    ret.baseDataDim = data2.mapDimension(ret.baseAxis.dim);
    ret.valueDataDim = data2.mapDimension(ret.valueAxis.dim);
  }
  return ret;
}
function dataDimToCoordDim(seriesModel, dataDim) {
  var dimItem = seriesModel.getData().getDimensionInfo(dataDim);
  return dimItem && dimItem.coordDim;
}
function dataFilter(coordSys, item) {
  return coordSys && coordSys.containData && item.coord && !hasXOrY(item) ? coordSys.containData(item.coord) : true;
}
function createMarkerDimValueGetter(inCoordSys, dims) {
  return inCoordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = dimIndex < 2 ? item.coord && item.coord[dimIndex] : item.value;
    return parseDataValue(rawVal, dims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dims[dimIndex]);
  };
}
function numCalculate(data2, valueDataDim, type4) {
  if (type4 === "average") {
    var sum_1 = 0;
    var count_1 = 0;
    data2.each(valueDataDim, function(val, idx) {
      if (!isNaN(val)) {
        sum_1 += val;
        count_1++;
      }
    });
    return sum_1 / count_1;
  } else if (type4 === "median") {
    return data2.getMedian(valueDataDim);
  } else {
    return data2.getDataExtent(valueDataDim)[type4 === "max" ? 1 : 0];
  }
}
var inner$4 = makeInner();
var MarkerView = function(_super) {
  __extends(MarkerView2, _super);
  function MarkerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerView2.type;
    return _this;
  }
  MarkerView2.prototype.init = function() {
    this.markerGroupMap = createHashMap();
  };
  MarkerView2.prototype.render = function(markerModel, ecModel, api) {
    var _this = this;
    var markerGroupMap = this.markerGroupMap;
    markerGroupMap.each(function(item) {
      inner$4(item).keep = false;
    });
    ecModel.eachSeries(function(seriesModel) {
      var markerModel2 = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      markerModel2 && _this.renderSeries(seriesModel, markerModel2, ecModel, api);
    });
    markerGroupMap.each(function(item) {
      !inner$4(item).keep && _this.group.remove(item.group);
    });
  };
  MarkerView2.prototype.markKeep = function(drawGroup) {
    inner$4(drawGroup).keep = true;
  };
  MarkerView2.prototype.blurSeries = function(seriesModelList) {
    var _this = this;
    each$g(seriesModelList, function(seriesModel) {
      var markerModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      if (markerModel) {
        var data2 = markerModel.getData();
        data2.eachItemGraphicEl(function(el) {
          if (el) {
            enterBlur(el);
          }
        });
      }
    });
  };
  MarkerView2.type = "marker";
  return MarkerView2;
}(ComponentView$1);
var MarkerView$1 = MarkerView;
function updateMarkerLayout(mpData, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  mpData.each(function(idx) {
    var itemModel = mpData.getItemModel(idx);
    var point;
    var xPx = parsePercent(itemModel.get("x"), api.getWidth());
    var yPx = parsePercent(itemModel.get("y"), api.getHeight());
    if (!isNaN(xPx) && !isNaN(yPx)) {
      point = [xPx, yPx];
    } else if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(mpData.getValues(mpData.dimensions, idx));
    } else if (coordSys) {
      var x2 = mpData.get(coordSys.dimensions[0], idx);
      var y2 = mpData.get(coordSys.dimensions[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
    mpData.setItemLayout(idx, point);
  });
}
var MarkPointView = function(_super) {
  __extends(MarkPointView2, _super);
  function MarkPointView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointView2.type;
    return _this;
  }
  MarkPointView2.prototype.updateTransform = function(markPointModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mpModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markPoint");
      if (mpModel) {
        updateMarkerLayout(mpModel.getData(), seriesModel, api);
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkPointView2.prototype.renderSeries = function(seriesModel, mpModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var symbolDrawMap = this.markerGroupMap;
    var symbolDraw = symbolDrawMap.get(seriesId) || symbolDrawMap.set(seriesId, new SymbolDraw$1());
    var mpData = createData(coordSys, seriesModel, mpModel);
    mpModel.setData(mpData);
    updateMarkerLayout(mpModel.getData(), seriesModel, api);
    mpData.each(function(idx) {
      var itemModel = mpData.getItemModel(idx);
      var symbol = itemModel.getShallow("symbol");
      var symbolSize = itemModel.getShallow("symbolSize");
      var symbolRotate = itemModel.getShallow("symbolRotate");
      var symbolOffset = itemModel.getShallow("symbolOffset");
      var symbolKeepAspect = itemModel.getShallow("symbolKeepAspect");
      if (isFunction$1(symbol) || isFunction$1(symbolSize) || isFunction$1(symbolRotate) || isFunction$1(symbolOffset)) {
        var rawIdx = mpModel.getRawValue(idx);
        var dataParams = mpModel.getDataParams(idx);
        if (isFunction$1(symbol)) {
          symbol = symbol(rawIdx, dataParams);
        }
        if (isFunction$1(symbolSize)) {
          symbolSize = symbolSize(rawIdx, dataParams);
        }
        if (isFunction$1(symbolRotate)) {
          symbolRotate = symbolRotate(rawIdx, dataParams);
        }
        if (isFunction$1(symbolOffset)) {
          symbolOffset = symbolOffset(rawIdx, dataParams);
        }
      }
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style2.fill) {
        style2.fill = color;
      }
      mpData.setItemVisual(idx, {
        symbol,
        symbolSize,
        symbolRotate,
        symbolOffset,
        symbolKeepAspect,
        style: style2
      });
    });
    symbolDraw.updateData(mpData);
    this.group.add(symbolDraw.group);
    mpData.eachItemGraphicEl(function(el) {
      el.traverse(function(child) {
        getECData(child).dataModel = mpModel;
      });
    });
    this.markKeep(symbolDraw);
    symbolDraw.group.silent = mpModel.get("silent") || seriesModel.get("silent");
  };
  MarkPointView2.type = "markPoint";
  return MarkPointView2;
}(MarkerView$1);
function createData(coordSys, seriesModel, mpModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var mpData = new SeriesData$1(coordDimsInfos, mpModel);
  var dataOpt = map$1(mpModel.get("data"), curry$3(dataTransform, seriesModel));
  if (coordSys) {
    dataOpt = filter(dataOpt, curry$3(dataFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  mpData.initData(dataOpt, null, dimValueGetter);
  return mpData;
}
var MarkPointView$1 = MarkPointView;
function install$e(registers) {
  registers.registerComponentModel(MarkPointModel$1);
  registers.registerComponentView(MarkPointView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markPoint")) {
      opt.markPoint = opt.markPoint || {};
    }
  });
}
var MarkLineModel = function(_super) {
  __extends(MarkLineModel2, _super);
  function MarkLineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineModel2.type;
    return _this;
  }
  MarkLineModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkLineModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkLineModel2.type = "markLine";
  MarkLineModel2.defaultOption = {
    z: 5,
    symbol: ["circle", "arrow"],
    symbolSize: [8, 16],
    symbolOffset: 0,
    precision: 2,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "end",
      distance: 5
    },
    lineStyle: {
      type: "dashed"
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        width: 3
      }
    },
    animationEasing: "linear"
  };
  return MarkLineModel2;
}(MarkerModel$1);
var MarkLineModel$1 = MarkLineModel;
var inner$3 = makeInner();
var markLineTransform = function(seriesModel, coordSys, mlModel, item) {
  var data2 = seriesModel.getData();
  var itemArray;
  if (!isArray$2(item)) {
    var mlType = item.type;
    if (mlType === "min" || mlType === "max" || mlType === "average" || mlType === "median" || item.xAxis != null || item.yAxis != null) {
      var valueAxis2 = void 0;
      var value = void 0;
      if (item.yAxis != null || item.xAxis != null) {
        valueAxis2 = coordSys.getAxis(item.yAxis != null ? "y" : "x");
        value = retrieve(item.yAxis, item.xAxis);
      } else {
        var axisInfo = getAxisInfo(item, data2, coordSys, seriesModel);
        valueAxis2 = axisInfo.valueAxis;
        var valueDataDim = getStackedDimension(data2, axisInfo.valueDataDim);
        value = numCalculate(data2, valueDataDim, mlType);
      }
      var valueIndex = valueAxis2.dim === "x" ? 0 : 1;
      var baseIndex = 1 - valueIndex;
      var mlFrom = clone$4(item);
      var mlTo = {
        coord: []
      };
      mlFrom.type = null;
      mlFrom.coord = [];
      mlFrom.coord[baseIndex] = -Infinity;
      mlTo.coord[baseIndex] = Infinity;
      var precision = mlModel.get("precision");
      if (precision >= 0 && isNumber(value)) {
        value = +value.toFixed(Math.min(precision, 20));
      }
      mlFrom.coord[valueIndex] = mlTo.coord[valueIndex] = value;
      itemArray = [mlFrom, mlTo, {
        type: mlType,
        valueIndex: item.valueIndex,
        value
      }];
    } else {
      itemArray = [];
    }
  } else {
    itemArray = item;
  }
  var normalizedItem = [dataTransform(seriesModel, itemArray[0]), dataTransform(seriesModel, itemArray[1]), extend({}, itemArray[2])];
  normalizedItem[2].type = normalizedItem[2].type || null;
  merge$1(normalizedItem[2], normalizedItem[0]);
  merge$1(normalizedItem[2], normalizedItem[1]);
  return normalizedItem;
};
function isInifinity$1(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkLineHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  var dimName = coordSys.dimensions[dimIndex];
  return isInifinity$1(fromCoord[otherDimIndex]) && isInifinity$1(toCoord[otherDimIndex]) && fromCoord[dimIndex] === toCoord[dimIndex] && coordSys.getAxis(dimName).containData(fromCoord[dimIndex]);
}
function markLineFilter(coordSys, item) {
  if (coordSys.type === "cartesian2d") {
    var fromCoord = item[0].coord;
    var toCoord = item[1].coord;
    if (fromCoord && toCoord && (ifMarkLineHasOnlyDim(1, fromCoord, toCoord, coordSys) || ifMarkLineHasOnlyDim(0, fromCoord, toCoord, coordSys))) {
      return true;
    }
  }
  return dataFilter(coordSys, item[0]) && dataFilter(coordSys, item[1]);
}
function updateSingleMarkerEndLayout(data2, idx, isFrom, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data2.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get("x"), api.getWidth());
  var yPx = parsePercent(itemModel.get("y"), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data2.getValues(data2.dimensions, idx));
    } else {
      var dims = coordSys.dimensions;
      var x2 = data2.get(dims[0], idx);
      var y2 = data2.get(dims[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var dims = coordSys.dimensions;
      if (isInifinity$1(data2.get(dims[0], idx))) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[isFrom ? 0 : 1]);
      } else if (isInifinity$1(data2.get(dims[1], idx))) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[isFrom ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  data2.setItemLayout(idx, point);
}
var MarkLineView = function(_super) {
  __extends(MarkLineView2, _super);
  function MarkLineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineView2.type;
    return _this;
  }
  MarkLineView2.prototype.updateTransform = function(markLineModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mlModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markLine");
      if (mlModel) {
        var mlData_1 = mlModel.getData();
        var fromData_1 = inner$3(mlModel).from;
        var toData_1 = inner$3(mlModel).to;
        fromData_1.each(function(idx) {
          updateSingleMarkerEndLayout(fromData_1, idx, true, seriesModel, api);
          updateSingleMarkerEndLayout(toData_1, idx, false, seriesModel, api);
        });
        mlData_1.each(function(idx) {
          mlData_1.setItemLayout(idx, [fromData_1.getItemLayout(idx), toData_1.getItemLayout(idx)]);
        });
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkLineView2.prototype.renderSeries = function(seriesModel, mlModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var lineDrawMap = this.markerGroupMap;
    var lineDraw = lineDrawMap.get(seriesId) || lineDrawMap.set(seriesId, new LineDraw$1());
    this.group.add(lineDraw.group);
    var mlData = createList$1(coordSys, seriesModel, mlModel);
    var fromData = mlData.from;
    var toData = mlData.to;
    var lineData = mlData.line;
    inner$3(mlModel).from = fromData;
    inner$3(mlModel).to = toData;
    mlModel.setData(lineData);
    var symbolType = mlModel.get("symbol");
    var symbolSize = mlModel.get("symbolSize");
    var symbolRotate = mlModel.get("symbolRotate");
    var symbolOffset = mlModel.get("symbolOffset");
    if (!isArray$2(symbolType)) {
      symbolType = [symbolType, symbolType];
    }
    if (!isArray$2(symbolSize)) {
      symbolSize = [symbolSize, symbolSize];
    }
    if (!isArray$2(symbolRotate)) {
      symbolRotate = [symbolRotate, symbolRotate];
    }
    if (!isArray$2(symbolOffset)) {
      symbolOffset = [symbolOffset, symbolOffset];
    }
    mlData.from.each(function(idx) {
      updateDataVisualAndLayout(fromData, idx, true);
      updateDataVisualAndLayout(toData, idx, false);
    });
    lineData.each(function(idx) {
      var lineStyle = lineData.getItemModel(idx).getModel("lineStyle").getLineStyle();
      lineData.setItemLayout(idx, [fromData.getItemLayout(idx), toData.getItemLayout(idx)]);
      if (lineStyle.stroke == null) {
        lineStyle.stroke = fromData.getItemVisual(idx, "style").fill;
      }
      lineData.setItemVisual(idx, {
        fromSymbolKeepAspect: fromData.getItemVisual(idx, "symbolKeepAspect"),
        fromSymbolOffset: fromData.getItemVisual(idx, "symbolOffset"),
        fromSymbolRotate: fromData.getItemVisual(idx, "symbolRotate"),
        fromSymbolSize: fromData.getItemVisual(idx, "symbolSize"),
        fromSymbol: fromData.getItemVisual(idx, "symbol"),
        toSymbolKeepAspect: toData.getItemVisual(idx, "symbolKeepAspect"),
        toSymbolOffset: toData.getItemVisual(idx, "symbolOffset"),
        toSymbolRotate: toData.getItemVisual(idx, "symbolRotate"),
        toSymbolSize: toData.getItemVisual(idx, "symbolSize"),
        toSymbol: toData.getItemVisual(idx, "symbol"),
        style: lineStyle
      });
    });
    lineDraw.updateData(lineData);
    mlData.line.eachItemGraphicEl(function(el, idx) {
      el.traverse(function(child) {
        getECData(child).dataModel = mlModel;
      });
    });
    function updateDataVisualAndLayout(data2, idx, isFrom) {
      var itemModel = data2.getItemModel(idx);
      updateSingleMarkerEndLayout(data2, idx, isFrom, seriesModel, api);
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      if (style2.fill == null) {
        style2.fill = getVisualFromData(seriesData, "color");
      }
      data2.setItemVisual(idx, {
        symbolKeepAspect: itemModel.get("symbolKeepAspect"),
        symbolOffset: retrieve2(itemModel.get("symbolOffset", true), symbolOffset[isFrom ? 0 : 1]),
        symbolRotate: retrieve2(itemModel.get("symbolRotate", true), symbolRotate[isFrom ? 0 : 1]),
        symbolSize: retrieve2(itemModel.get("symbolSize"), symbolSize[isFrom ? 0 : 1]),
        symbol: retrieve2(itemModel.get("symbol", true), symbolType[isFrom ? 0 : 1]),
        style: style2
      });
    }
    this.markKeep(lineDraw);
    lineDraw.group.silent = mlModel.get("silent") || seriesModel.get("silent");
  };
  MarkLineView2.type = "markLine";
  return MarkLineView2;
}(MarkerView$1);
function createList$1(coordSys, seriesModel, mlModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var fromData = new SeriesData$1(coordDimsInfos, mlModel);
  var toData = new SeriesData$1(coordDimsInfos, mlModel);
  var lineData = new SeriesData$1([], mlModel);
  var optData = map$1(mlModel.get("data"), curry$3(markLineTransform, seriesModel, coordSys, mlModel));
  if (coordSys) {
    optData = filter(optData, curry$3(markLineFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  fromData.initData(map$1(optData, function(item) {
    return item[0];
  }), null, dimValueGetter);
  toData.initData(map$1(optData, function(item) {
    return item[1];
  }), null, dimValueGetter);
  lineData.initData(map$1(optData, function(item) {
    return item[2];
  }));
  lineData.hasItemOption = true;
  return {
    from: fromData,
    to: toData,
    line: lineData
  };
}
var MarkLineView$1 = MarkLineView;
function install$d(registers) {
  registers.registerComponentModel(MarkLineModel$1);
  registers.registerComponentView(MarkLineView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markLine")) {
      opt.markLine = opt.markLine || {};
    }
  });
}
var MarkAreaModel = function(_super) {
  __extends(MarkAreaModel2, _super);
  function MarkAreaModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaModel2.type;
    return _this;
  }
  MarkAreaModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkAreaModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkAreaModel2.type = "markArea";
  MarkAreaModel2.defaultOption = {
    z: 1,
    tooltip: {
      trigger: "item"
    },
    animation: false,
    label: {
      show: true,
      position: "top"
    },
    itemStyle: {
      borderWidth: 0
    },
    emphasis: {
      label: {
        show: true,
        position: "top"
      }
    }
  };
  return MarkAreaModel2;
}(MarkerModel$1);
var MarkAreaModel$1 = MarkAreaModel;
var inner$2 = makeInner();
var markAreaTransform = function(seriesModel, coordSys, maModel, item) {
  var lt2 = dataTransform(seriesModel, item[0]);
  var rb2 = dataTransform(seriesModel, item[1]);
  var ltCoord = lt2.coord;
  var rbCoord = rb2.coord;
  ltCoord[0] = retrieve(ltCoord[0], -Infinity);
  ltCoord[1] = retrieve(ltCoord[1], -Infinity);
  rbCoord[0] = retrieve(rbCoord[0], Infinity);
  rbCoord[1] = retrieve(rbCoord[1], Infinity);
  var result = mergeAll([{}, lt2, rb2]);
  result.coord = [lt2.coord, rb2.coord];
  result.x0 = lt2.x;
  result.y0 = lt2.y;
  result.x1 = rb2.x;
  result.y1 = rb2.y;
  return result;
};
function isInifinity(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkAreaHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  return isInifinity(fromCoord[otherDimIndex]) && isInifinity(toCoord[otherDimIndex]);
}
function markAreaFilter(coordSys, item) {
  var fromCoord = item.coord[0];
  var toCoord = item.coord[1];
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    if (fromCoord && toCoord && (ifMarkAreaHasOnlyDim(1, fromCoord, toCoord) || ifMarkAreaHasOnlyDim(0, fromCoord, toCoord))) {
      return true;
    }
  }
  return dataFilter(coordSys, {
    coord: fromCoord,
    x: item.x0,
    y: item.y0
  }) || dataFilter(coordSys, {
    coord: toCoord,
    x: item.x1,
    y: item.y1
  });
}
function getSingleMarkerEndPoint(data2, idx, dims, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data2.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get(dims[0]), api.getWidth());
  var yPx = parsePercent(itemModel.get(dims[1]), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data2.getValues(dims, idx));
    } else {
      var x2 = data2.get(dims[0], idx);
      var y2 = data2.get(dims[1], idx);
      var pt = [x2, y2];
      coordSys.clampData && coordSys.clampData(pt, pt);
      point = coordSys.dataToPoint(pt, true);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var x2 = data2.get(dims[0], idx);
      var y2 = data2.get(dims[1], idx);
      if (isInifinity(x2)) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[dims[0] === "x0" ? 0 : 1]);
      } else if (isInifinity(y2)) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[dims[1] === "y0" ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  return point;
}
var dimPermutations = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]];
var MarkAreaView = function(_super) {
  __extends(MarkAreaView2, _super);
  function MarkAreaView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaView2.type;
    return _this;
  }
  MarkAreaView2.prototype.updateTransform = function(markAreaModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var maModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markArea");
      if (maModel) {
        var areaData_1 = maModel.getData();
        areaData_1.each(function(idx) {
          var points2 = map$1(dimPermutations, function(dim) {
            return getSingleMarkerEndPoint(areaData_1, idx, dim, seriesModel, api);
          });
          areaData_1.setItemLayout(idx, points2);
          var el = areaData_1.getItemGraphicEl(idx);
          el.setShape("points", points2);
        });
      }
    }, this);
  };
  MarkAreaView2.prototype.renderSeries = function(seriesModel, maModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var areaGroupMap = this.markerGroupMap;
    var polygonGroup = areaGroupMap.get(seriesId) || areaGroupMap.set(seriesId, {
      group: new Group$6()
    });
    this.group.add(polygonGroup.group);
    this.markKeep(polygonGroup);
    var areaData = createList(coordSys, seriesModel, maModel);
    maModel.setData(areaData);
    areaData.each(function(idx) {
      var points2 = map$1(dimPermutations, function(dim) {
        return getSingleMarkerEndPoint(areaData, idx, dim, seriesModel, api);
      });
      var xAxisScale = coordSys.getAxis("x").scale;
      var yAxisScale = coordSys.getAxis("y").scale;
      var xAxisExtent = xAxisScale.getExtent();
      var yAxisExtent = yAxisScale.getExtent();
      var xPointExtent = [xAxisScale.parse(areaData.get("x0", idx)), xAxisScale.parse(areaData.get("x1", idx))];
      var yPointExtent = [yAxisScale.parse(areaData.get("y0", idx)), yAxisScale.parse(areaData.get("y1", idx))];
      asc$2(xPointExtent);
      asc$2(yPointExtent);
      var overlapped = !(xAxisExtent[0] > xPointExtent[1] || xAxisExtent[1] < xPointExtent[0] || yAxisExtent[0] > yPointExtent[1] || yAxisExtent[1] < yPointExtent[0]);
      var allClipped = !overlapped;
      areaData.setItemLayout(idx, {
        points: points2,
        allClipped
      });
      var style2 = areaData.getItemModel(idx).getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style2.fill) {
        style2.fill = color;
        if (isString$1(style2.fill)) {
          style2.fill = modifyAlpha(style2.fill, 0.4);
        }
      }
      if (!style2.stroke) {
        style2.stroke = color;
      }
      areaData.setItemVisual(idx, "style", style2);
    });
    areaData.diff(inner$2(polygonGroup).data).add(function(idx) {
      var layout2 = areaData.getItemLayout(idx);
      if (!layout2.allClipped) {
        var polygon = new Polygon$1({
          shape: {
            points: layout2.points
          }
        });
        areaData.setItemGraphicEl(idx, polygon);
        polygonGroup.group.add(polygon);
      }
    }).update(function(newIdx, oldIdx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(oldIdx);
      var layout2 = areaData.getItemLayout(newIdx);
      if (!layout2.allClipped) {
        if (polygon) {
          updateProps$1(polygon, {
            shape: {
              points: layout2.points
            }
          }, maModel, newIdx);
        } else {
          polygon = new Polygon$1({
            shape: {
              points: layout2.points
            }
          });
        }
        areaData.setItemGraphicEl(newIdx, polygon);
        polygonGroup.group.add(polygon);
      } else if (polygon) {
        polygonGroup.group.remove(polygon);
      }
    }).remove(function(idx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(idx);
      polygonGroup.group.remove(polygon);
    }).execute();
    areaData.eachItemGraphicEl(function(polygon, idx) {
      var itemModel = areaData.getItemModel(idx);
      var style2 = areaData.getItemVisual(idx, "style");
      polygon.useStyle(areaData.getItemVisual(idx, "style"));
      setLabelStyle(polygon, getLabelStatesModels(itemModel), {
        labelFetcher: maModel,
        labelDataIndex: idx,
        defaultText: areaData.getName(idx) || "",
        inheritColor: isString$1(style2.fill) ? modifyAlpha(style2.fill, 1) : "#000"
      });
      setStatesStylesFromModel(polygon, itemModel);
      toggleHoverEmphasis(polygon, null, null, itemModel.get(["emphasis", "disabled"]));
      getECData(polygon).dataModel = maModel;
    });
    inner$2(polygonGroup).data = areaData;
    polygonGroup.group.silent = maModel.get("silent") || seriesModel.get("silent");
  };
  MarkAreaView2.type = "markArea";
  return MarkAreaView2;
}(MarkerView$1);
function createList(coordSys, seriesModel, maModel) {
  var areaData;
  var dataDims;
  var dims = ["x0", "y0", "x1", "y1"];
  if (coordSys) {
    var coordDimsInfos_1 = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var data2 = seriesModel.getData();
      var info = data2.getDimensionInfo(data2.mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
    dataDims = map$1(dims, function(dim, idx) {
      return {
        name: dim,
        type: coordDimsInfos_1[idx % 2].type
      };
    });
    areaData = new SeriesData$1(dataDims, maModel);
  } else {
    dataDims = [{
      name: "value",
      type: "float"
    }];
    areaData = new SeriesData$1(dataDims, maModel);
  }
  var optData = map$1(maModel.get("data"), curry$3(markAreaTransform, seriesModel, coordSys, maModel));
  if (coordSys) {
    optData = filter(optData, curry$3(markAreaFilter, coordSys));
  }
  var dimValueGetter = coordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = item.coord[Math.floor(dimIndex / 2)][dimIndex % 2];
    return parseDataValue(rawVal, dataDims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dataDims[dimIndex]);
  };
  areaData.initData(optData, null, dimValueGetter);
  areaData.hasItemOption = true;
  return areaData;
}
var MarkAreaView$1 = MarkAreaView;
function install$c(registers) {
  registers.registerComponentModel(MarkAreaModel$1);
  registers.registerComponentView(MarkAreaView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markArea")) {
      opt.markArea = opt.markArea || {};
    }
  });
}
var getDefaultSelectorOptions = function(ecModel, type4) {
  if (type4 === "all") {
    return {
      type: "all",
      title: ecModel.getLocaleModel().get(["legend", "selector", "all"])
    };
  } else if (type4 === "inverse") {
    return {
      type: "inverse",
      title: ecModel.getLocaleModel().get(["legend", "selector", "inverse"])
    };
  }
};
var LegendModel = function(_super) {
  __extends(LegendModel2, _super);
  function LegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  LegendModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    option.selected = option.selected || {};
    this._updateSelector(option);
  };
  LegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    this._updateSelector(option);
  };
  LegendModel2.prototype._updateSelector = function(option) {
    var selector2 = option.selector;
    var ecModel = this.ecModel;
    if (selector2 === true) {
      selector2 = option.selector = ["all", "inverse"];
    }
    if (isArray$2(selector2)) {
      each$g(selector2, function(item, index2) {
        isString$1(item) && (item = {
          type: item
        });
        selector2[index2] = merge$1(item, getDefaultSelectorOptions(ecModel, item.type));
      });
    }
  };
  LegendModel2.prototype.optionUpdated = function() {
    this._updateData(this.ecModel);
    var legendData = this._data;
    if (legendData[0] && this.get("selectedMode") === "single") {
      var hasSelected = false;
      for (var i = 0; i < legendData.length; i++) {
        var name_1 = legendData[i].get("name");
        if (this.isSelected(name_1)) {
          this.select(name_1);
          hasSelected = true;
          break;
        }
      }
      !hasSelected && this.select(legendData[0].get("name"));
    }
  };
  LegendModel2.prototype._updateData = function(ecModel) {
    var potentialData = [];
    var availableNames = [];
    ecModel.eachRawSeries(function(seriesModel) {
      var seriesName = seriesModel.name;
      availableNames.push(seriesName);
      var isPotential;
      if (seriesModel.legendVisualProvider) {
        var provider = seriesModel.legendVisualProvider;
        var names2 = provider.getAllNames();
        if (!ecModel.isSeriesFiltered(seriesModel)) {
          availableNames = availableNames.concat(names2);
        }
        if (names2.length) {
          potentialData = potentialData.concat(names2);
        } else {
          isPotential = true;
        }
      } else {
        isPotential = true;
      }
      if (isPotential && isNameSpecified(seriesModel)) {
        potentialData.push(seriesModel.name);
      }
    });
    this._availableNames = availableNames;
    var rawData = this.get("data") || potentialData;
    var legendData = map$1(rawData, function(dataItem) {
      if (isString$1(dataItem) || isNumber(dataItem)) {
        dataItem = {
          name: dataItem
        };
      }
      return new Model$1(dataItem, this, this.ecModel);
    }, this);
    this._data = legendData;
  };
  LegendModel2.prototype.getData = function() {
    return this._data;
  };
  LegendModel2.prototype.select = function(name2) {
    var selected = this.option.selected;
    var selectedMode = this.get("selectedMode");
    if (selectedMode === "single") {
      var data2 = this._data;
      each$g(data2, function(dataItem) {
        selected[dataItem.get("name")] = false;
      });
    }
    selected[name2] = true;
  };
  LegendModel2.prototype.unSelect = function(name2) {
    if (this.get("selectedMode") !== "single") {
      this.option.selected[name2] = false;
    }
  };
  LegendModel2.prototype.toggleSelected = function(name2) {
    var selected = this.option.selected;
    if (!selected.hasOwnProperty(name2)) {
      selected[name2] = true;
    }
    this[selected[name2] ? "unSelect" : "select"](name2);
  };
  LegendModel2.prototype.allSelect = function() {
    var data2 = this._data;
    var selected = this.option.selected;
    each$g(data2, function(dataItem) {
      selected[dataItem.get("name", true)] = true;
    });
  };
  LegendModel2.prototype.inverseSelect = function() {
    var data2 = this._data;
    var selected = this.option.selected;
    each$g(data2, function(dataItem) {
      var name2 = dataItem.get("name", true);
      if (!selected.hasOwnProperty(name2)) {
        selected[name2] = true;
      }
      selected[name2] = !selected[name2];
    });
  };
  LegendModel2.prototype.isSelected = function(name2) {
    var selected = this.option.selected;
    return !(selected.hasOwnProperty(name2) && !selected[name2]) && indexOf(this._availableNames, name2) >= 0;
  };
  LegendModel2.prototype.getOrient = function() {
    return this.get("orient") === "vertical" ? {
      index: 1,
      name: "vertical"
    } : {
      index: 0,
      name: "horizontal"
    };
  };
  LegendModel2.type = "legend.plain";
  LegendModel2.dependencies = ["series"];
  LegendModel2.defaultOption = {
    z: 4,
    show: true,
    orient: "horizontal",
    left: "center",
    top: 0,
    align: "auto",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    itemWidth: 25,
    itemHeight: 14,
    symbolRotate: "inherit",
    symbolKeepAspect: true,
    inactiveColor: "#ccc",
    inactiveBorderColor: "#ccc",
    inactiveBorderWidth: "auto",
    itemStyle: {
      color: "inherit",
      opacity: "inherit",
      borderColor: "inherit",
      borderWidth: "auto",
      borderCap: "inherit",
      borderJoin: "inherit",
      borderDashOffset: "inherit",
      borderMiterLimit: "inherit"
    },
    lineStyle: {
      width: "auto",
      color: "inherit",
      inactiveColor: "#ccc",
      inactiveWidth: 2,
      opacity: "inherit",
      type: "inherit",
      cap: "inherit",
      join: "inherit",
      dashOffset: "inherit",
      miterLimit: "inherit"
    },
    textStyle: {
      color: "#333"
    },
    selectedMode: true,
    selector: false,
    selectorLabel: {
      show: true,
      borderRadius: 10,
      padding: [3, 5, 3, 5],
      fontSize: 12,
      fontFamily: "sans-serif",
      color: "#666",
      borderWidth: 1,
      borderColor: "#666"
    },
    emphasis: {
      selectorLabel: {
        show: true,
        color: "#eee",
        backgroundColor: "#666"
      }
    },
    selectorPosition: "auto",
    selectorItemGap: 7,
    selectorButtonGap: 10,
    tooltip: {
      show: false
    }
  };
  return LegendModel2;
}(ComponentModel$1);
var LegendModel$1 = LegendModel;
var curry$2 = curry$3;
var each$4 = each$g;
var Group$3 = Group$6;
var LegendView = function(_super) {
  __extends(LegendView2, _super);
  function LegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendView2.type;
    _this.newlineDisabled = false;
    return _this;
  }
  LegendView2.prototype.init = function() {
    this.group.add(this._contentGroup = new Group$3());
    this.group.add(this._selectorGroup = new Group$3());
    this._isFirstRender = true;
  };
  LegendView2.prototype.getContentGroup = function() {
    return this._contentGroup;
  };
  LegendView2.prototype.getSelectorGroup = function() {
    return this._selectorGroup;
  };
  LegendView2.prototype.render = function(legendModel, ecModel, api) {
    var isFirstRender = this._isFirstRender;
    this._isFirstRender = false;
    this.resetInner();
    if (!legendModel.get("show", true)) {
      return;
    }
    var itemAlign = legendModel.get("align");
    var orient = legendModel.get("orient");
    if (!itemAlign || itemAlign === "auto") {
      itemAlign = legendModel.get("left") === "right" && orient === "vertical" ? "right" : "left";
    }
    var selector2 = legendModel.get("selector", true);
    var selectorPosition = legendModel.get("selectorPosition", true);
    if (selector2 && (!selectorPosition || selectorPosition === "auto")) {
      selectorPosition = orient === "horizontal" ? "end" : "start";
    }
    this.renderInner(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var positionInfo = legendModel.getBoxLayoutParams();
    var viewportSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var padding = legendModel.get("padding");
    var maxSize = getLayoutRect(positionInfo, viewportSize, padding);
    var mainRect = this.layoutInner(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition);
    var layoutRect = getLayoutRect(defaults({
      width: mainRect.width,
      height: mainRect.height
    }, positionInfo), viewportSize, padding);
    this.group.x = layoutRect.x - mainRect.x;
    this.group.y = layoutRect.y - mainRect.y;
    this.group.markRedraw();
    this.group.add(this._backgroundEl = makeBackground(mainRect, legendModel));
  };
  LegendView2.prototype.resetInner = function() {
    this.getContentGroup().removeAll();
    this._backgroundEl && this.group.remove(this._backgroundEl);
    this.getSelectorGroup().removeAll();
  };
  LegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var legendDrawnMap = createHashMap();
    var selectMode = legendModel.get("selectedMode");
    var excludeSeriesId = [];
    ecModel.eachRawSeries(function(seriesModel) {
      !seriesModel.get("legendHoverLink") && excludeSeriesId.push(seriesModel.id);
    });
    each$4(legendModel.getData(), function(legendItemModel, dataIndex) {
      var name2 = legendItemModel.get("name");
      if (!this.newlineDisabled && (name2 === "" || name2 === "\n")) {
        var g2 = new Group$3();
        g2.newline = true;
        contentGroup.add(g2);
        return;
      }
      var seriesModel = ecModel.getSeriesByName(name2)[0];
      if (legendDrawnMap.get(name2)) {
        return;
      }
      if (seriesModel) {
        var data2 = seriesModel.getData();
        var lineVisualStyle = data2.getVisual("legendLineStyle") || {};
        var legendIcon = data2.getVisual("legendIcon");
        var style2 = data2.getVisual("style");
        var itemGroup = this._createItem(seriesModel, name2, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, style2, legendIcon, selectMode);
        itemGroup.on("click", curry$2(dispatchSelectAction, name2, null, api, excludeSeriesId)).on("mouseover", curry$2(dispatchHighlightAction, seriesModel.name, null, api, excludeSeriesId)).on("mouseout", curry$2(dispatchDownplayAction, seriesModel.name, null, api, excludeSeriesId));
        legendDrawnMap.set(name2, true);
      } else {
        ecModel.eachRawSeries(function(seriesModel2) {
          if (legendDrawnMap.get(name2)) {
            return;
          }
          if (seriesModel2.legendVisualProvider) {
            var provider = seriesModel2.legendVisualProvider;
            if (!provider.containName(name2)) {
              return;
            }
            var idx = provider.indexOfName(name2);
            var style3 = provider.getItemVisual(idx, "style");
            var legendIcon2 = provider.getItemVisual(idx, "legendIcon");
            var colorArr = parse$1(style3.fill);
            if (colorArr && colorArr[3] === 0) {
              colorArr[3] = 0.2;
              style3 = extend(extend({}, style3), {
                fill: stringify(colorArr, "rgba")
              });
            }
            var itemGroup2 = this._createItem(seriesModel2, name2, dataIndex, legendItemModel, legendModel, itemAlign, {}, style3, legendIcon2, selectMode);
            itemGroup2.on("click", curry$2(dispatchSelectAction, null, name2, api, excludeSeriesId)).on("mouseover", curry$2(dispatchHighlightAction, null, name2, api, excludeSeriesId)).on("mouseout", curry$2(dispatchDownplayAction, null, name2, api, excludeSeriesId));
            legendDrawnMap.set(name2, true);
          }
        }, this);
      }
    }, this);
    if (selector2) {
      this._createSelector(selector2, legendModel, api, orient, selectorPosition);
    }
  };
  LegendView2.prototype._createSelector = function(selector2, legendModel, api, orient, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    each$4(selector2, function createSelectorButton(selectorItem) {
      var type4 = selectorItem.type;
      var labelText = new ZRText$1({
        style: {
          x: 0,
          y: 0,
          align: "center",
          verticalAlign: "middle"
        },
        onclick: function() {
          api.dispatchAction({
            type: type4 === "all" ? "legendAllSelect" : "legendInverseSelect"
          });
        }
      });
      selectorGroup.add(labelText);
      var labelModel = legendModel.getModel("selectorLabel");
      var emphasisLabelModel = legendModel.getModel(["emphasis", "selectorLabel"]);
      setLabelStyle(labelText, {
        normal: labelModel,
        emphasis: emphasisLabelModel
      }, {
        defaultText: selectorItem.title
      });
      enableHoverEmphasis(labelText);
    });
  };
  LegendView2.prototype._createItem = function(seriesModel, name2, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, itemVisualStyle, legendIcon, selectMode) {
    var drawType = seriesModel.visualDrawType;
    var itemWidth = legendModel.get("itemWidth");
    var itemHeight = legendModel.get("itemHeight");
    var isSelected = legendModel.isSelected(name2);
    var iconRotate = legendItemModel.get("symbolRotate");
    var symbolKeepAspect = legendItemModel.get("symbolKeepAspect");
    var legendIconType = legendItemModel.get("icon");
    legendIcon = legendIconType || legendIcon || "roundRect";
    var style2 = getLegendStyle(legendIcon, legendItemModel, lineVisualStyle, itemVisualStyle, drawType, isSelected);
    var itemGroup = new Group$3();
    var textStyleModel = legendItemModel.getModel("textStyle");
    if (isFunction$1(seriesModel.getLegendIcon) && (!legendIconType || legendIconType === "inherit")) {
      itemGroup.add(seriesModel.getLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate,
        itemStyle: style2.itemStyle,
        lineStyle: style2.lineStyle,
        symbolKeepAspect
      }));
    } else {
      var rotate2 = legendIconType === "inherit" && seriesModel.getData().getVisual("symbol") ? iconRotate === "inherit" ? seriesModel.getData().getVisual("symbolRotate") : iconRotate : 0;
      itemGroup.add(getDefaultLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate: rotate2,
        itemStyle: style2.itemStyle,
        lineStyle: style2.lineStyle,
        symbolKeepAspect
      }));
    }
    var textX = itemAlign === "left" ? itemWidth + 5 : -5;
    var textAlign = itemAlign;
    var formatter = legendModel.get("formatter");
    var content = name2;
    if (isString$1(formatter) && formatter) {
      content = formatter.replace("{name}", name2 != null ? name2 : "");
    } else if (isFunction$1(formatter)) {
      content = formatter(name2);
    }
    var inactiveColor = legendItemModel.get("inactiveColor");
    itemGroup.add(new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: content,
        x: textX,
        y: itemHeight / 2,
        fill: isSelected ? textStyleModel.getTextColor() : inactiveColor,
        align: textAlign,
        verticalAlign: "middle"
      })
    }));
    var hitRect = new Rect$3({
      shape: itemGroup.getBoundingRect(),
      invisible: true
    });
    var tooltipModel = legendItemModel.getModel("tooltip");
    if (tooltipModel.get("show")) {
      setTooltipConfig({
        el: hitRect,
        componentModel: legendModel,
        itemName: name2,
        itemTooltipOption: tooltipModel.option
      });
    }
    itemGroup.add(hitRect);
    itemGroup.eachChild(function(child) {
      child.silent = true;
    });
    hitRect.silent = !selectMode;
    this.getContentGroup().add(itemGroup);
    enableHoverEmphasis(itemGroup);
    itemGroup.__legendDataIndex = dataIndex;
    return itemGroup;
  };
  LegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var selectorGroup = this.getSelectorGroup();
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), maxSize.width, maxSize.height);
    var contentRect = contentGroup.getBoundingRect();
    var contentPos = [-contentRect.x, -contentRect.y];
    selectorGroup.markRedraw();
    contentGroup.markRedraw();
    if (selector2) {
      box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
      var selectorRect = selectorGroup.getBoundingRect();
      var selectorPos = [-selectorRect.x, -selectorRect.y];
      var selectorButtonGap = legendModel.get("selectorButtonGap", true);
      var orientIdx = legendModel.getOrient().index;
      var wh2 = orientIdx === 0 ? "width" : "height";
      var hw = orientIdx === 0 ? "height" : "width";
      var yx = orientIdx === 0 ? "y" : "x";
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += contentRect[wh2] + selectorButtonGap;
      } else {
        contentPos[orientIdx] += selectorRect[wh2] + selectorButtonGap;
      }
      selectorPos[1 - orientIdx] += contentRect[hw] / 2 - selectorRect[hw] / 2;
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      var mainRect = {
        x: 0,
        y: 0
      };
      mainRect[wh2] = contentRect[wh2] + selectorButtonGap + selectorRect[wh2];
      mainRect[hw] = Math.max(contentRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(0, selectorRect[yx] + selectorPos[1 - orientIdx]);
      return mainRect;
    } else {
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      return this.group.getBoundingRect();
    }
  };
  LegendView2.prototype.remove = function() {
    this.getContentGroup().removeAll();
    this._isFirstRender = true;
  };
  LegendView2.type = "legend.plain";
  return LegendView2;
}(ComponentView$1);
function getLegendStyle(iconType, legendModel, lineVisualStyle, itemVisualStyle, drawType, isSelected) {
  function handleCommonProps(style2, visualStyle) {
    if (style2.lineWidth === "auto") {
      style2.lineWidth = visualStyle.lineWidth > 0 ? 2 : 0;
    }
    each$4(style2, function(propVal, propName) {
      style2[propName] === "inherit" && (style2[propName] = visualStyle[propName]);
    });
  }
  var legendItemModel = legendModel.getModel("itemStyle");
  var itemStyle = legendItemModel.getItemStyle();
  var iconBrushType = iconType.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
  itemStyle.decal = itemVisualStyle.decal;
  if (itemStyle.fill === "inherit") {
    itemStyle.fill = itemVisualStyle[drawType];
  }
  if (itemStyle.stroke === "inherit") {
    itemStyle.stroke = itemVisualStyle[iconBrushType];
  }
  if (itemStyle.opacity === "inherit") {
    itemStyle.opacity = (drawType === "fill" ? itemVisualStyle : lineVisualStyle).opacity;
  }
  handleCommonProps(itemStyle, itemVisualStyle);
  var legendLineModel = legendModel.getModel("lineStyle");
  var lineStyle = legendLineModel.getLineStyle();
  handleCommonProps(lineStyle, lineVisualStyle);
  itemStyle.fill === "auto" && (itemStyle.fill = itemVisualStyle.fill);
  itemStyle.stroke === "auto" && (itemStyle.stroke = itemVisualStyle.fill);
  lineStyle.stroke === "auto" && (lineStyle.stroke = itemVisualStyle.fill);
  if (!isSelected) {
    var borderWidth = legendModel.get("inactiveBorderWidth");
    var visualHasBorder = itemStyle[iconBrushType];
    itemStyle.lineWidth = borderWidth === "auto" ? itemVisualStyle.lineWidth > 0 && visualHasBorder ? 2 : 0 : itemStyle.lineWidth;
    itemStyle.fill = legendModel.get("inactiveColor");
    itemStyle.stroke = legendModel.get("inactiveBorderColor");
    lineStyle.stroke = legendLineModel.get("inactiveColor");
    lineStyle.lineWidth = legendLineModel.get("inactiveWidth");
  }
  return {
    itemStyle,
    lineStyle
  };
}
function getDefaultLegendIcon(opt) {
  var symboType = opt.icon || "roundRect";
  var icon = createSymbol$1(symboType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill, opt.symbolKeepAspect);
  icon.setStyle(opt.itemStyle);
  icon.rotation = (opt.iconRotate || 0) * Math.PI / 180;
  icon.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
  if (symboType.indexOf("empty") > -1) {
    icon.style.stroke = icon.style.fill;
    icon.style.fill = "#fff";
    icon.style.lineWidth = 2;
  }
  return icon;
}
function dispatchSelectAction(seriesName, dataName, api, excludeSeriesId) {
  dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId);
  api.dispatchAction({
    type: "legendToggleSelect",
    name: seriesName != null ? seriesName : dataName
  });
  dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId);
}
function isUseHoverLayer(api) {
  var list = api.getZr().storage.getDisplayList();
  var emphasisState;
  var i = 0;
  var len2 = list.length;
  while (i < len2 && !(emphasisState = list[i].states.emphasis)) {
    i++;
  }
  return emphasisState && emphasisState.hoverLayer;
}
function dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "highlight",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
function dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "downplay",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
var LegendView$1 = LegendView;
function legendFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (legendModels && legendModels.length) {
    ecModel.filterSeries(function(series) {
      for (var i = 0; i < legendModels.length; i++) {
        if (!legendModels[i].isSelected(series.name)) {
          return false;
        }
      }
      return true;
    });
  }
}
function legendSelectActionHandler(methodName, payload, ecModel) {
  var selectedMap = {};
  var isToggleSelect = methodName === "toggleSelected";
  var isSelected;
  ecModel.eachComponent("legend", function(legendModel) {
    if (isToggleSelect && isSelected != null) {
      legendModel[isSelected ? "select" : "unSelect"](payload.name);
    } else if (methodName === "allSelect" || methodName === "inverseSelect") {
      legendModel[methodName]();
    } else {
      legendModel[methodName](payload.name);
      isSelected = legendModel.isSelected(payload.name);
    }
    var legendData = legendModel.getData();
    each$g(legendData, function(model) {
      var name2 = model.get("name");
      if (name2 === "\n" || name2 === "") {
        return;
      }
      var isItemSelected = legendModel.isSelected(name2);
      if (selectedMap.hasOwnProperty(name2)) {
        selectedMap[name2] = selectedMap[name2] && isItemSelected;
      } else {
        selectedMap[name2] = isItemSelected;
      }
    });
  });
  return methodName === "allSelect" || methodName === "inverseSelect" ? {
    selected: selectedMap
  } : {
    name: payload.name,
    selected: selectedMap
  };
}
function installLegendAction(registers) {
  registers.registerAction("legendToggleSelect", "legendselectchanged", curry$3(legendSelectActionHandler, "toggleSelected"));
  registers.registerAction("legendAllSelect", "legendselectall", curry$3(legendSelectActionHandler, "allSelect"));
  registers.registerAction("legendInverseSelect", "legendinverseselect", curry$3(legendSelectActionHandler, "inverseSelect"));
  registers.registerAction("legendSelect", "legendselected", curry$3(legendSelectActionHandler, "select"));
  registers.registerAction("legendUnSelect", "legendunselected", curry$3(legendSelectActionHandler, "unSelect"));
}
function install$b(registers) {
  registers.registerComponentModel(LegendModel$1);
  registers.registerComponentView(LegendView$1);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.SERIES_FILTER, legendFilter);
  registers.registerSubTypeDefaulter("legend", function() {
    return "plain";
  });
  installLegendAction(registers);
}
var ScrollableLegendModel = function(_super) {
  __extends(ScrollableLegendModel2, _super);
  function ScrollableLegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendModel2.type;
    return _this;
  }
  ScrollableLegendModel2.prototype.setScrollDataIndex = function(scrollDataIndex) {
    this.option.scrollDataIndex = scrollDataIndex;
  };
  ScrollableLegendModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.call(this, option, parentModel, ecModel);
    mergeAndNormalizeLayoutParams(this, option, inputPositionParams);
  };
  ScrollableLegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    mergeAndNormalizeLayoutParams(this, this.option, option);
  };
  ScrollableLegendModel2.type = "legend.scroll";
  ScrollableLegendModel2.defaultOption = inheritDefaultOption(LegendModel$1.defaultOption, {
    scrollDataIndex: 0,
    pageButtonItemGap: 5,
    pageButtonGap: null,
    pageButtonPosition: "end",
    pageFormatter: "{current}/{total}",
    pageIcons: {
      horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"],
      vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"]
    },
    pageIconColor: "#2f4554",
    pageIconInactiveColor: "#aaa",
    pageIconSize: 15,
    pageTextStyle: {
      color: "#333"
    },
    animationDurationUpdate: 800
  });
  return ScrollableLegendModel2;
}(LegendModel$1);
function mergeAndNormalizeLayoutParams(legendModel, target, raw) {
  var orient = legendModel.getOrient();
  var ignoreSize = [1, 1];
  ignoreSize[orient.index] = 0;
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize: !!ignoreSize
  });
}
var ScrollableLegendModel$1 = ScrollableLegendModel;
var Group$2 = Group$6;
var WH = ["width", "height"];
var XY = ["x", "y"];
var ScrollableLegendView = function(_super) {
  __extends(ScrollableLegendView2, _super);
  function ScrollableLegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendView2.type;
    _this.newlineDisabled = true;
    _this._currentIndex = 0;
    return _this;
  }
  ScrollableLegendView2.prototype.init = function() {
    _super.prototype.init.call(this);
    this.group.add(this._containerGroup = new Group$2());
    this._containerGroup.add(this.getContentGroup());
    this.group.add(this._controllerGroup = new Group$2());
  };
  ScrollableLegendView2.prototype.resetInner = function() {
    _super.prototype.resetInner.call(this);
    this._controllerGroup.removeAll();
    this._containerGroup.removeClipPath();
    this._containerGroup.__rectSize = null;
  };
  ScrollableLegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var self2 = this;
    _super.prototype.renderInner.call(this, itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var controllerGroup = this._controllerGroup;
    var pageIconSize = legendModel.get("pageIconSize", true);
    var pageIconSizeArr = isArray$2(pageIconSize) ? pageIconSize : [pageIconSize, pageIconSize];
    createPageButton("pagePrev", 0);
    var pageTextStyleModel = legendModel.getModel("pageTextStyle");
    controllerGroup.add(new ZRText$1({
      name: "pageText",
      style: {
        text: "xx/xx",
        fill: pageTextStyleModel.getTextColor(),
        font: pageTextStyleModel.getFont(),
        verticalAlign: "middle",
        align: "center"
      },
      silent: true
    }));
    createPageButton("pageNext", 1);
    function createPageButton(name2, iconIdx) {
      var pageDataIndexName = name2 + "DataIndex";
      var icon = createIcon(legendModel.get("pageIcons", true)[legendModel.getOrient().name][iconIdx], {
        onclick: bind$1(self2._pageGo, self2, pageDataIndexName, legendModel, api)
      }, {
        x: -pageIconSizeArr[0] / 2,
        y: -pageIconSizeArr[1] / 2,
        width: pageIconSizeArr[0],
        height: pageIconSizeArr[1]
      });
      icon.name = name2;
      controllerGroup.add(icon);
    }
  };
  ScrollableLegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    var orientIdx = legendModel.getOrient().index;
    var wh2 = WH[orientIdx];
    var xy = XY[orientIdx];
    var hw = WH[1 - orientIdx];
    var yx = XY[1 - orientIdx];
    selector2 && box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
    var selectorButtonGap = legendModel.get("selectorButtonGap", true);
    var selectorRect = selectorGroup.getBoundingRect();
    var selectorPos = [-selectorRect.x, -selectorRect.y];
    var processMaxSize = clone$4(maxSize);
    selector2 && (processMaxSize[wh2] = maxSize[wh2] - selectorRect[wh2] - selectorButtonGap);
    var mainRect = this._layoutContentAndController(legendModel, isFirstRender, processMaxSize, orientIdx, wh2, hw, yx, xy);
    if (selector2) {
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += mainRect[wh2] + selectorButtonGap;
      } else {
        var offset3 = selectorRect[wh2] + selectorButtonGap;
        selectorPos[orientIdx] -= offset3;
        mainRect[xy] -= offset3;
      }
      mainRect[wh2] += selectorRect[wh2] + selectorButtonGap;
      selectorPos[1 - orientIdx] += mainRect[yx] + mainRect[hw] / 2 - selectorRect[hw] / 2;
      mainRect[hw] = Math.max(mainRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(mainRect[yx], selectorRect[yx] + selectorPos[1 - orientIdx]);
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      selectorGroup.markRedraw();
    }
    return mainRect;
  };
  ScrollableLegendView2.prototype._layoutContentAndController = function(legendModel, isFirstRender, maxSize, orientIdx, wh2, hw, yx, xy) {
    var contentGroup = this.getContentGroup();
    var containerGroup = this._containerGroup;
    var controllerGroup = this._controllerGroup;
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), !orientIdx ? null : maxSize.width, orientIdx ? null : maxSize.height);
    box("horizontal", controllerGroup, legendModel.get("pageButtonItemGap", true));
    var contentRect = contentGroup.getBoundingRect();
    var controllerRect = controllerGroup.getBoundingRect();
    var showController = this._showController = contentRect[wh2] > maxSize[wh2];
    var contentPos = [-contentRect.x, -contentRect.y];
    if (!isFirstRender) {
      contentPos[orientIdx] = contentGroup[xy];
    }
    var containerPos = [0, 0];
    var controllerPos = [-controllerRect.x, -controllerRect.y];
    var pageButtonGap = retrieve2(legendModel.get("pageButtonGap", true), legendModel.get("itemGap", true));
    if (showController) {
      var pageButtonPosition = legendModel.get("pageButtonPosition", true);
      if (pageButtonPosition === "end") {
        controllerPos[orientIdx] += maxSize[wh2] - controllerRect[wh2];
      } else {
        containerPos[orientIdx] += controllerRect[wh2] + pageButtonGap;
      }
    }
    controllerPos[1 - orientIdx] += contentRect[hw] / 2 - controllerRect[hw] / 2;
    contentGroup.setPosition(contentPos);
    containerGroup.setPosition(containerPos);
    controllerGroup.setPosition(controllerPos);
    var mainRect = {
      x: 0,
      y: 0
    };
    mainRect[wh2] = showController ? maxSize[wh2] : contentRect[wh2];
    mainRect[hw] = Math.max(contentRect[hw], controllerRect[hw]);
    mainRect[yx] = Math.min(0, controllerRect[yx] + controllerPos[1 - orientIdx]);
    containerGroup.__rectSize = maxSize[wh2];
    if (showController) {
      var clipShape = {
        x: 0,
        y: 0
      };
      clipShape[wh2] = Math.max(maxSize[wh2] - controllerRect[wh2] - pageButtonGap, 0);
      clipShape[hw] = mainRect[hw];
      containerGroup.setClipPath(new Rect$3({
        shape: clipShape
      }));
      containerGroup.__rectSize = clipShape[wh2];
    } else {
      controllerGroup.eachChild(function(child) {
        child.attr({
          invisible: true,
          silent: true
        });
      });
    }
    var pageInfo = this._getPageInfo(legendModel);
    pageInfo.pageIndex != null && updateProps$1(contentGroup, {
      x: pageInfo.contentPosition[0],
      y: pageInfo.contentPosition[1]
    }, showController ? legendModel : null);
    this._updatePageInfoView(legendModel, pageInfo);
    return mainRect;
  };
  ScrollableLegendView2.prototype._pageGo = function(to, legendModel, api) {
    var scrollDataIndex = this._getPageInfo(legendModel)[to];
    scrollDataIndex != null && api.dispatchAction({
      type: "legendScroll",
      scrollDataIndex,
      legendId: legendModel.id
    });
  };
  ScrollableLegendView2.prototype._updatePageInfoView = function(legendModel, pageInfo) {
    var controllerGroup = this._controllerGroup;
    each$g(["pagePrev", "pageNext"], function(name2) {
      var key = name2 + "DataIndex";
      var canJump = pageInfo[key] != null;
      var icon = controllerGroup.childOfName(name2);
      if (icon) {
        icon.setStyle("fill", canJump ? legendModel.get("pageIconColor", true) : legendModel.get("pageIconInactiveColor", true));
        icon.cursor = canJump ? "pointer" : "default";
      }
    });
    var pageText = controllerGroup.childOfName("pageText");
    var pageFormatter = legendModel.get("pageFormatter");
    var pageIndex = pageInfo.pageIndex;
    var current2 = pageIndex != null ? pageIndex + 1 : 0;
    var total = pageInfo.pageCount;
    pageText && pageFormatter && pageText.setStyle("text", isString$1(pageFormatter) ? pageFormatter.replace("{current}", current2 == null ? "" : current2 + "").replace("{total}", total == null ? "" : total + "") : pageFormatter({
      current: current2,
      total
    }));
  };
  ScrollableLegendView2.prototype._getPageInfo = function(legendModel) {
    var scrollDataIndex = legendModel.get("scrollDataIndex", true);
    var contentGroup = this.getContentGroup();
    var containerRectSize = this._containerGroup.__rectSize;
    var orientIdx = legendModel.getOrient().index;
    var wh2 = WH[orientIdx];
    var xy = XY[orientIdx];
    var targetItemIndex = this._findTargetItemIndex(scrollDataIndex);
    var children = contentGroup.children();
    var targetItem = children[targetItemIndex];
    var itemCount = children.length;
    var pCount = !itemCount ? 0 : 1;
    var result = {
      contentPosition: [contentGroup.x, contentGroup.y],
      pageCount: pCount,
      pageIndex: pCount - 1,
      pagePrevDataIndex: null,
      pageNextDataIndex: null
    };
    if (!targetItem) {
      return result;
    }
    var targetItemInfo = getItemInfo(targetItem);
    result.contentPosition[orientIdx] = -targetItemInfo.s;
    for (var i = targetItemIndex + 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i <= itemCount; ++i) {
      currItemInfo = getItemInfo(children[i]);
      if (!currItemInfo && winEndItemInfo.e > winStartItemInfo.s + containerRectSize || currItemInfo && !intersect2(currItemInfo, winStartItemInfo.s)) {
        if (winEndItemInfo.i > winStartItemInfo.i) {
          winStartItemInfo = winEndItemInfo;
        } else {
          winStartItemInfo = currItemInfo;
        }
        if (winStartItemInfo) {
          if (result.pageNextDataIndex == null) {
            result.pageNextDataIndex = winStartItemInfo.i;
          }
          ++result.pageCount;
        }
      }
      winEndItemInfo = currItemInfo;
    }
    for (var i = targetItemIndex - 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i >= -1; --i) {
      currItemInfo = getItemInfo(children[i]);
      if ((!currItemInfo || !intersect2(winEndItemInfo, currItemInfo.s)) && winStartItemInfo.i < winEndItemInfo.i) {
        winEndItemInfo = winStartItemInfo;
        if (result.pagePrevDataIndex == null) {
          result.pagePrevDataIndex = winStartItemInfo.i;
        }
        ++result.pageCount;
        ++result.pageIndex;
      }
      winStartItemInfo = currItemInfo;
    }
    return result;
    function getItemInfo(el) {
      if (el) {
        var itemRect = el.getBoundingRect();
        var start2 = itemRect[xy] + el[xy];
        return {
          s: start2,
          e: start2 + itemRect[wh2],
          i: el.__legendDataIndex
        };
      }
    }
    function intersect2(itemInfo, winStart) {
      return itemInfo.e >= winStart && itemInfo.s <= winStart + containerRectSize;
    }
  };
  ScrollableLegendView2.prototype._findTargetItemIndex = function(targetDataIndex) {
    if (!this._showController) {
      return 0;
    }
    var index2;
    var contentGroup = this.getContentGroup();
    var defaultIndex;
    contentGroup.eachChild(function(child, idx) {
      var legendDataIdx = child.__legendDataIndex;
      if (defaultIndex == null && legendDataIdx != null) {
        defaultIndex = idx;
      }
      if (legendDataIdx === targetDataIndex) {
        index2 = idx;
      }
    });
    return index2 != null ? index2 : defaultIndex;
  };
  ScrollableLegendView2.type = "legend.scroll";
  return ScrollableLegendView2;
}(LegendView$1);
var ScrollableLegendView$1 = ScrollableLegendView;
function installScrollableLegendAction(registers) {
  registers.registerAction("legendScroll", "legendscroll", function(payload, ecModel) {
    var scrollDataIndex = payload.scrollDataIndex;
    scrollDataIndex != null && ecModel.eachComponent({
      mainType: "legend",
      subType: "scroll",
      query: payload
    }, function(legendModel) {
      legendModel.setScrollDataIndex(scrollDataIndex);
    });
  });
}
function install$a(registers) {
  use(install$b);
  registers.registerComponentModel(ScrollableLegendModel$1);
  registers.registerComponentView(ScrollableLegendView$1);
  installScrollableLegendAction(registers);
}
function install$9(registers) {
  use(install$b);
  use(install$a);
}
var InsideZoomModel = function(_super) {
  __extends(InsideZoomModel2, _super);
  function InsideZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = InsideZoomModel2.type;
    return _this;
  }
  InsideZoomModel2.type = "dataZoom.inside";
  InsideZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    disabled: false,
    zoomLock: false,
    zoomOnMouseWheel: true,
    moveOnMouseMove: true,
    moveOnMouseWheel: false,
    preventDefaultMouseMove: true
  });
  return InsideZoomModel2;
}(DataZoomModel$1);
var InsideZoomModel$1 = InsideZoomModel;
var inner$1 = makeInner();
function setViewInfoToCoordSysRecord(api, dataZoomModel, getRange) {
  inner$1(api).coordSysRecordMap.each(function(coordSysRecord) {
    var dzInfo = coordSysRecord.dataZoomInfoMap.get(dataZoomModel.uid);
    if (dzInfo) {
      dzInfo.getRange = getRange;
    }
  });
}
function disposeCoordSysRecordIfNeeded(api, dataZoomModel) {
  var coordSysRecordMap = inner$1(api).coordSysRecordMap;
  var coordSysKeyArr = coordSysRecordMap.keys();
  for (var i = 0; i < coordSysKeyArr.length; i++) {
    var coordSysKey = coordSysKeyArr[i];
    var coordSysRecord = coordSysRecordMap.get(coordSysKey);
    var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
    if (dataZoomInfoMap) {
      var dzUid = dataZoomModel.uid;
      var dzInfo = dataZoomInfoMap.get(dzUid);
      if (dzInfo) {
        dataZoomInfoMap.removeKey(dzUid);
        if (!dataZoomInfoMap.keys().length) {
          disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        }
      }
    }
  }
}
function disposeCoordSysRecord(coordSysRecordMap, coordSysRecord) {
  if (coordSysRecord) {
    coordSysRecordMap.removeKey(coordSysRecord.model.uid);
    var controller = coordSysRecord.controller;
    controller && controller.dispose();
  }
}
function createCoordSysRecord(api, coordSysModel) {
  var coordSysRecord = {
    model: coordSysModel,
    containsPoint: curry$3(containsPoint, coordSysModel),
    dispatchAction: curry$3(dispatchAction, api),
    dataZoomInfoMap: null,
    controller: null
  };
  var controller = coordSysRecord.controller = new RoamController$1(api.getZr());
  each$g(["pan", "zoom", "scrollMove"], function(eventName) {
    controller.on(eventName, function(event) {
      var batch = [];
      coordSysRecord.dataZoomInfoMap.each(function(dzInfo) {
        if (!event.isAvailableBehavior(dzInfo.model.option)) {
          return;
        }
        var method4 = (dzInfo.getRange || {})[eventName];
        var range3 = method4 && method4(dzInfo.dzReferCoordSysInfo, coordSysRecord.model.mainType, coordSysRecord.controller, event);
        !dzInfo.model.get("disabled", true) && range3 && batch.push({
          dataZoomId: dzInfo.model.id,
          start: range3[0],
          end: range3[1]
        });
      });
      batch.length && coordSysRecord.dispatchAction(batch);
    });
  });
  return coordSysRecord;
}
function dispatchAction(api, batch) {
  if (!api.isDisposed()) {
    api.dispatchAction({
      type: "dataZoom",
      animation: {
        easing: "cubicOut",
        duration: 100
      },
      batch
    });
  }
}
function containsPoint(coordSysModel, e2, x2, y2) {
  return coordSysModel.coordinateSystem.containPoint([x2, y2]);
}
function mergeControllerParams(dataZoomInfoMap) {
  var controlType;
  var prefix = "type_";
  var typePriority = {
    "type_true": 2,
    "type_move": 1,
    "type_false": 0,
    "type_undefined": -1
  };
  var preventDefaultMouseMove = true;
  dataZoomInfoMap.each(function(dataZoomInfo) {
    var dataZoomModel = dataZoomInfo.model;
    var oneType = dataZoomModel.get("disabled", true) ? false : dataZoomModel.get("zoomLock", true) ? "move" : true;
    if (typePriority[prefix + oneType] > typePriority[prefix + controlType]) {
      controlType = oneType;
    }
    preventDefaultMouseMove = preventDefaultMouseMove && dataZoomModel.get("preventDefaultMouseMove", true);
  });
  return {
    controlType,
    opt: {
      zoomOnMouseWheel: true,
      moveOnMouseMove: true,
      moveOnMouseWheel: true,
      preventDefaultMouseMove: !!preventDefaultMouseMove
    }
  };
}
function installDataZoomRoamProcessor(registers) {
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, function(ecModel, api) {
    var apiInner = inner$1(api);
    var coordSysRecordMap = apiInner.coordSysRecordMap || (apiInner.coordSysRecordMap = createHashMap());
    coordSysRecordMap.each(function(coordSysRecord) {
      coordSysRecord.dataZoomInfoMap = null;
    });
    ecModel.eachComponent({
      mainType: "dataZoom",
      subType: "inside"
    }, function(dataZoomModel) {
      var dzReferCoordSysWrap = collectReferCoordSysModelInfo(dataZoomModel);
      each$g(dzReferCoordSysWrap.infoList, function(dzCoordSysInfo) {
        var coordSysUid = dzCoordSysInfo.model.uid;
        var coordSysRecord = coordSysRecordMap.get(coordSysUid) || coordSysRecordMap.set(coordSysUid, createCoordSysRecord(api, dzCoordSysInfo.model));
        var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap || (coordSysRecord.dataZoomInfoMap = createHashMap());
        dataZoomInfoMap.set(dataZoomModel.uid, {
          dzReferCoordSysInfo: dzCoordSysInfo,
          model: dataZoomModel,
          getRange: null
        });
      });
    });
    coordSysRecordMap.each(function(coordSysRecord) {
      var controller = coordSysRecord.controller;
      var firstDzInfo;
      var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
      if (dataZoomInfoMap) {
        var firstDzKey = dataZoomInfoMap.keys()[0];
        if (firstDzKey != null) {
          firstDzInfo = dataZoomInfoMap.get(firstDzKey);
        }
      }
      if (!firstDzInfo) {
        disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        return;
      }
      var controllerParams = mergeControllerParams(dataZoomInfoMap);
      controller.enable(controllerParams.controlType, controllerParams.opt);
      controller.setPointerChecker(coordSysRecord.containsPoint);
      createOrUpdate(coordSysRecord, "dispatchAction", firstDzInfo.model.get("throttle", true), "fixRate");
    });
  });
}
var InsideZoomView = function(_super) {
  __extends(InsideZoomView2, _super);
  function InsideZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataZoom.inside";
    return _this;
  }
  InsideZoomView2.prototype.render = function(dataZoomModel, ecModel, api) {
    _super.prototype.render.apply(this, arguments);
    if (dataZoomModel.noTarget()) {
      this._clear();
      return;
    }
    this.range = dataZoomModel.getPercentRange();
    setViewInfoToCoordSysRecord(api, dataZoomModel, {
      pan: bind$1(getRangeHandlers.pan, this),
      zoom: bind$1(getRangeHandlers.zoom, this),
      scrollMove: bind$1(getRangeHandlers.scrollMove, this)
    });
  };
  InsideZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  InsideZoomView2.prototype._clear = function() {
    disposeCoordSysRecordIfNeeded(this.api, this.dataZoomModel);
    this.range = null;
  };
  InsideZoomView2.type = "dataZoom.inside";
  return InsideZoomView2;
}(DataZoomView$1);
var getRangeHandlers = {
  zoom: function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var directionInfo = getDirectionInfo[coordSysMainType](null, [e2.originX, e2.originY], axisModel, controller, coordSysInfo);
    var percentPoint = (directionInfo.signal > 0 ? directionInfo.pixelStart + directionInfo.pixelLength - directionInfo.pixel : directionInfo.pixel - directionInfo.pixelStart) / directionInfo.pixelLength * (range3[1] - range3[0]) + range3[0];
    var scale2 = Math.max(1 / e2.scale, 0);
    range3[0] = (range3[0] - percentPoint) * scale2 + percentPoint;
    range3[1] = (range3[1] - percentPoint) * scale2 + percentPoint;
    var minMaxSpan = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    sliderMove(0, range3, [0, 100], 0, minMaxSpan.minSpan, minMaxSpan.maxSpan);
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  },
  pan: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([e2.oldX, e2.oldY], [e2.newX, e2.newY], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * directionInfo.pixel / directionInfo.pixelLength;
  }),
  scrollMove: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([0, 0], [e2.scrollDelta, e2.scrollDelta], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * e2.scrollDelta;
  })
};
function makeMover(getPercentDelta) {
  return function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var percentDelta = getPercentDelta(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2);
    sliderMove(percentDelta, range3, [0, 100], "all");
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  };
}
var getDirectionInfo = {
  grid: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    oldPoint = oldPoint || [0, 0];
    if (axis.dim === "x") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  polar: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var polar = coordSysInfo.model.coordinateSystem;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var angleExtent = polar.getAngleAxis().getExtent();
    oldPoint = oldPoint ? polar.pointToCoord(oldPoint) : [0, 0];
    newPoint = polar.pointToCoord(newPoint);
    if (axisModel.mainType === "radiusAxis") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = radiusExtent[1] - radiusExtent[0];
      ret.pixelStart = radiusExtent[0];
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = angleExtent[1] - angleExtent[0];
      ret.pixelStart = angleExtent[0];
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  singleAxis: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    var ret = {};
    oldPoint = oldPoint || [0, 0];
    if (axis.orient === "horizontal") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  }
};
var InsideZoomView$1 = InsideZoomView;
function install$8(registers) {
  installCommon$1(registers);
  registers.registerComponentModel(InsideZoomModel$1);
  registers.registerComponentView(InsideZoomView$1);
  installDataZoomRoamProcessor(registers);
}
var SliderZoomModel = function(_super) {
  __extends(SliderZoomModel2, _super);
  function SliderZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomModel2.type;
    return _this;
  }
  SliderZoomModel2.type = "dataZoom.slider";
  SliderZoomModel2.layoutMode = "box";
  SliderZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    show: true,
    right: "ph",
    top: "ph",
    width: "ph",
    height: "ph",
    left: null,
    bottom: null,
    borderColor: "#d2dbee",
    borderRadius: 3,
    backgroundColor: "rgba(47,69,84,0)",
    dataBackground: {
      lineStyle: {
        color: "#d2dbee",
        width: 0.5
      },
      areaStyle: {
        color: "#d2dbee",
        opacity: 0.2
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#8fb0f7",
        width: 0.5
      },
      areaStyle: {
        color: "#8fb0f7",
        opacity: 0.2
      }
    },
    fillerColor: "rgba(135,175,274,0.2)",
    handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z",
    handleSize: "100%",
    handleStyle: {
      color: "#fff",
      borderColor: "#ACB8D1"
    },
    moveHandleSize: 7,
    moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z",
    moveHandleStyle: {
      color: "#D2DBEE",
      opacity: 0.7
    },
    showDetail: true,
    showDataShadow: "auto",
    realtime: true,
    zoomLock: false,
    textStyle: {
      color: "#6E7079"
    },
    brushSelect: true,
    brushStyle: {
      color: "rgba(135,175,274,0.15)"
    },
    emphasis: {
      handleStyle: {
        borderColor: "#8FB0F7"
      },
      moveHandleStyle: {
        color: "#8FB0F7"
      }
    }
  });
  return SliderZoomModel2;
}(DataZoomModel$1);
var SliderZoomModel$1 = SliderZoomModel;
var Rect = Rect$3;
var DEFAULT_LOCATION_EDGE_GAP = 7;
var DEFAULT_FRAME_BORDER_WIDTH = 1;
var DEFAULT_FILLER_SIZE = 30;
var DEFAULT_MOVE_HANDLE_SIZE = 7;
var HORIZONTAL = "horizontal";
var VERTICAL = "vertical";
var LABEL_GAP = 5;
var SHOW_DATA_SHADOW_SERIES_TYPE = ["line", "bar", "candlestick", "scatter"];
var REALTIME_ANIMATION_CONFIG = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
};
var SliderZoomView = function(_super) {
  __extends(SliderZoomView2, _super);
  function SliderZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomView2.type;
    _this._displayables = {};
    return _this;
  }
  SliderZoomView2.prototype.init = function(ecModel, api) {
    this.api = api;
    this._onBrush = bind$1(this._onBrush, this);
    this._onBrushEnd = bind$1(this._onBrushEnd, this);
  };
  SliderZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    _super.prototype.render.apply(this, arguments);
    createOrUpdate(this, "_dispatchZoomAction", dataZoomModel.get("throttle"), "fixRate");
    this._orient = dataZoomModel.getOrient();
    if (dataZoomModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    if (dataZoomModel.noTarget()) {
      this._clear();
      this.group.removeAll();
      return;
    }
    if (!payload || payload.type !== "dataZoom" || payload.from !== this.uid) {
      this._buildView();
    }
    this._updateView();
  };
  SliderZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  SliderZoomView2.prototype._clear = function() {
    clear$1(this, "_dispatchZoomAction");
    var zr = this.api.getZr();
    zr.off("mousemove", this._onBrush);
    zr.off("mouseup", this._onBrushEnd);
  };
  SliderZoomView2.prototype._buildView = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    this._brushing = false;
    this._displayables.brushRect = null;
    this._resetLocation();
    this._resetInterval();
    var barGroup = this._displayables.sliderGroup = new Group$6();
    this._renderBackground();
    this._renderHandle();
    this._renderDataShadow();
    thisGroup.add(barGroup);
    this._positionGroup();
  };
  SliderZoomView2.prototype._resetLocation = function() {
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var showMoveHandle = dataZoomModel.get("brushSelect");
    var moveHandleSize = showMoveHandle ? DEFAULT_MOVE_HANDLE_SIZE : 0;
    var coordRect = this._findCoordRect();
    var ecSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var positionInfo = this._orient === HORIZONTAL ? {
      right: ecSize.width - coordRect.x - coordRect.width,
      top: ecSize.height - DEFAULT_FILLER_SIZE - DEFAULT_LOCATION_EDGE_GAP - moveHandleSize,
      width: coordRect.width,
      height: DEFAULT_FILLER_SIZE
    } : {
      right: DEFAULT_LOCATION_EDGE_GAP,
      top: coordRect.y,
      width: DEFAULT_FILLER_SIZE,
      height: coordRect.height
    };
    var layoutParams = getLayoutParams(dataZoomModel.option);
    each$g(["right", "top", "width", "height"], function(name2) {
      if (layoutParams[name2] === "ph") {
        layoutParams[name2] = positionInfo[name2];
      }
    });
    var layoutRect = getLayoutRect(layoutParams, ecSize);
    this._location = {
      x: layoutRect.x,
      y: layoutRect.y
    };
    this._size = [layoutRect.width, layoutRect.height];
    this._orient === VERTICAL && this._size.reverse();
  };
  SliderZoomView2.prototype._positionGroup = function() {
    var thisGroup = this.group;
    var location = this._location;
    var orient = this._orient;
    var targetAxisModel = this.dataZoomModel.getFirstTargetAxisModel();
    var inverse = targetAxisModel && targetAxisModel.get("inverse");
    var sliderGroup = this._displayables.sliderGroup;
    var otherAxisInverse = (this._dataShadowInfo || {}).otherAxisInverse;
    sliderGroup.attr(orient === HORIZONTAL && !inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: 1
    } : orient === HORIZONTAL && inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: -1
    } : orient === VERTICAL && !inverse ? {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: 1,
      rotation: Math.PI / 2
    } : {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: -1,
      rotation: Math.PI / 2
    });
    var rect = thisGroup.getBoundingRect([sliderGroup]);
    thisGroup.x = location.x - rect.x;
    thisGroup.y = location.y - rect.y;
    thisGroup.markRedraw();
  };
  SliderZoomView2.prototype._getViewExtent = function() {
    return [0, this._size[0]];
  };
  SliderZoomView2.prototype._renderBackground = function() {
    var dataZoomModel = this.dataZoomModel;
    var size = this._size;
    var barGroup = this._displayables.sliderGroup;
    var brushSelect = dataZoomModel.get("brushSelect");
    barGroup.add(new Rect({
      silent: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: dataZoomModel.get("backgroundColor")
      },
      z2: -40
    }));
    var clickPanel = new Rect({
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: "transparent"
      },
      z2: 0,
      onclick: bind$1(this._onClickPanel, this)
    });
    var zr = this.api.getZr();
    if (brushSelect) {
      clickPanel.on("mousedown", this._onBrushStart, this);
      clickPanel.cursor = "crosshair";
      zr.on("mousemove", this._onBrush);
      zr.on("mouseup", this._onBrushEnd);
    } else {
      zr.off("mousemove", this._onBrush);
      zr.off("mouseup", this._onBrushEnd);
    }
    barGroup.add(clickPanel);
  };
  SliderZoomView2.prototype._renderDataShadow = function() {
    var info = this._dataShadowInfo = this._prepareDataShadowInfo();
    this._displayables.dataShadowSegs = [];
    if (!info) {
      return;
    }
    var size = this._size;
    var oldSize = this._shadowSize || [];
    var seriesModel = info.series;
    var data2 = seriesModel.getRawData();
    var otherDim = seriesModel.getShadowDim ? seriesModel.getShadowDim() : info.otherDim;
    if (otherDim == null) {
      return;
    }
    var polygonPts = this._shadowPolygonPts;
    var polylinePts = this._shadowPolylinePts;
    if (data2 !== this._shadowData || otherDim !== this._shadowDim || size[0] !== oldSize[0] || size[1] !== oldSize[1]) {
      var otherDataExtent_1 = data2.getDataExtent(otherDim);
      var otherOffset = (otherDataExtent_1[1] - otherDataExtent_1[0]) * 0.3;
      otherDataExtent_1 = [otherDataExtent_1[0] - otherOffset, otherDataExtent_1[1] + otherOffset];
      var otherShadowExtent_1 = [0, size[1]];
      var thisShadowExtent = [0, size[0]];
      var areaPoints_1 = [[size[0], 0], [0, 0]];
      var linePoints_1 = [];
      var step_1 = thisShadowExtent[1] / (data2.count() - 1);
      var thisCoord_1 = 0;
      var stride_1 = Math.round(data2.count() / size[0]);
      var lastIsEmpty_1;
      data2.each([otherDim], function(value, index2) {
        if (stride_1 > 0 && index2 % stride_1) {
          thisCoord_1 += step_1;
          return;
        }
        var isEmpty2 = value == null || isNaN(value) || value === "";
        var otherCoord = isEmpty2 ? 0 : linearMap$2(value, otherDataExtent_1, otherShadowExtent_1, true);
        if (isEmpty2 && !lastIsEmpty_1 && index2) {
          areaPoints_1.push([areaPoints_1[areaPoints_1.length - 1][0], 0]);
          linePoints_1.push([linePoints_1[linePoints_1.length - 1][0], 0]);
        } else if (!isEmpty2 && lastIsEmpty_1) {
          areaPoints_1.push([thisCoord_1, 0]);
          linePoints_1.push([thisCoord_1, 0]);
        }
        areaPoints_1.push([thisCoord_1, otherCoord]);
        linePoints_1.push([thisCoord_1, otherCoord]);
        thisCoord_1 += step_1;
        lastIsEmpty_1 = isEmpty2;
      });
      polygonPts = this._shadowPolygonPts = areaPoints_1;
      polylinePts = this._shadowPolylinePts = linePoints_1;
    }
    this._shadowData = data2;
    this._shadowDim = otherDim;
    this._shadowSize = [size[0], size[1]];
    var dataZoomModel = this.dataZoomModel;
    function createDataShadowGroup(isSelectedArea) {
      var model = dataZoomModel.getModel(isSelectedArea ? "selectedDataBackground" : "dataBackground");
      var group2 = new Group$6();
      var polygon = new Polygon$1({
        shape: {
          points: polygonPts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("areaStyle").getAreaStyle(),
        silent: true,
        z2: -20
      });
      var polyline = new Polyline$3({
        shape: {
          points: polylinePts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("lineStyle").getLineStyle(),
        silent: true,
        z2: -19
      });
      group2.add(polygon);
      group2.add(polyline);
      return group2;
    }
    for (var i = 0; i < 3; i++) {
      var group = createDataShadowGroup(i === 1);
      this._displayables.sliderGroup.add(group);
      this._displayables.dataShadowSegs.push(group);
    }
  };
  SliderZoomView2.prototype._prepareDataShadowInfo = function() {
    var dataZoomModel = this.dataZoomModel;
    var showDataShadow = dataZoomModel.get("showDataShadow");
    if (showDataShadow === false) {
      return;
    }
    var result;
    var ecModel = this.ecModel;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var seriesModels = dataZoomModel.getAxisProxy(axisDim, axisIndex).getTargetSeriesModels();
      each$g(seriesModels, function(seriesModel) {
        if (result) {
          return;
        }
        if (showDataShadow !== true && indexOf(SHOW_DATA_SHADOW_SERIES_TYPE, seriesModel.get("type")) < 0) {
          return;
        }
        var thisAxis = ecModel.getComponent(getAxisMainType(axisDim), axisIndex).axis;
        var otherDim = getOtherDim(axisDim);
        var otherAxisInverse;
        var coordSys = seriesModel.coordinateSystem;
        if (otherDim != null && coordSys.getOtherAxis) {
          otherAxisInverse = coordSys.getOtherAxis(thisAxis).inverse;
        }
        otherDim = seriesModel.getData().mapDimension(otherDim);
        result = {
          thisAxis,
          series: seriesModel,
          thisDim: axisDim,
          otherDim,
          otherAxisInverse
        };
      }, this);
    }, this);
    return result;
  };
  SliderZoomView2.prototype._renderHandle = function() {
    var thisGroup = this.group;
    var displayables = this._displayables;
    var handles = displayables.handles = [null, null];
    var handleLabels = displayables.handleLabels = [null, null];
    var sliderGroup = this._displayables.sliderGroup;
    var size = this._size;
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var borderRadius = dataZoomModel.get("borderRadius") || 0;
    var brushSelect = dataZoomModel.get("brushSelect");
    var filler = displayables.filler = new Rect({
      silent: brushSelect,
      style: {
        fill: dataZoomModel.get("fillerColor")
      },
      textConfig: {
        position: "inside"
      }
    });
    sliderGroup.add(filler);
    sliderGroup.add(new Rect({
      silent: true,
      subPixelOptimize: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1],
        r: borderRadius
      },
      style: {
        stroke: dataZoomModel.get("dataBackgroundColor") || dataZoomModel.get("borderColor"),
        lineWidth: DEFAULT_FRAME_BORDER_WIDTH,
        fill: "rgba(0,0,0,0)"
      }
    }));
    each$g([0, 1], function(handleIndex) {
      var iconStr = dataZoomModel.get("handleIcon");
      if (!symbolBuildProxies[iconStr] && iconStr.indexOf("path://") < 0 && iconStr.indexOf("image://") < 0) {
        iconStr = "path://" + iconStr;
      }
      var path = createSymbol$1(iconStr, -1, 0, 2, 2, null, true);
      path.attr({
        cursor: getCursor$1(this._orient),
        draggable: true,
        drift: bind$1(this._onDragMove, this, handleIndex),
        ondragend: bind$1(this._onDragEnd, this),
        onmouseover: bind$1(this._showDataInfo, this, true),
        onmouseout: bind$1(this._showDataInfo, this, false),
        z2: 5
      });
      var bRect = path.getBoundingRect();
      var handleSize = dataZoomModel.get("handleSize");
      this._handleHeight = parsePercent(handleSize, this._size[1]);
      this._handleWidth = bRect.width / bRect.height * this._handleHeight;
      path.setStyle(dataZoomModel.getModel("handleStyle").getItemStyle());
      path.style.strokeNoScale = true;
      path.rectHover = true;
      path.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
      enableHoverEmphasis(path);
      var handleColor = dataZoomModel.get("handleColor");
      if (handleColor != null) {
        path.style.fill = handleColor;
      }
      sliderGroup.add(handles[handleIndex] = path);
      var textStyleModel = dataZoomModel.getModel("textStyle");
      thisGroup.add(handleLabels[handleIndex] = new ZRText$1({
        silent: true,
        invisible: true,
        style: createTextStyle(textStyleModel, {
          x: 0,
          y: 0,
          text: "",
          verticalAlign: "middle",
          align: "center",
          fill: textStyleModel.getTextColor(),
          font: textStyleModel.getFont()
        }),
        z2: 10
      }));
    }, this);
    var actualMoveZone = filler;
    if (brushSelect) {
      var moveHandleHeight = parsePercent(dataZoomModel.get("moveHandleSize"), size[1]);
      var moveHandle_1 = displayables.moveHandle = new Rect$3({
        style: dataZoomModel.getModel("moveHandleStyle").getItemStyle(),
        silent: true,
        shape: {
          r: [0, 0, 2, 2],
          y: size[1] - 0.5,
          height: moveHandleHeight
        }
      });
      var iconSize = moveHandleHeight * 0.8;
      var moveHandleIcon = displayables.moveHandleIcon = createSymbol$1(dataZoomModel.get("moveHandleIcon"), -iconSize / 2, -iconSize / 2, iconSize, iconSize, "#fff", true);
      moveHandleIcon.silent = true;
      moveHandleIcon.y = size[1] + moveHandleHeight / 2 - 0.5;
      moveHandle_1.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
      var moveZoneExpandSize = Math.min(size[1] / 2, Math.max(moveHandleHeight, 10));
      actualMoveZone = displayables.moveZone = new Rect$3({
        invisible: true,
        shape: {
          y: size[1] - moveZoneExpandSize,
          height: moveHandleHeight + moveZoneExpandSize
        }
      });
      actualMoveZone.on("mouseover", function() {
        api.enterEmphasis(moveHandle_1);
      }).on("mouseout", function() {
        api.leaveEmphasis(moveHandle_1);
      });
      sliderGroup.add(moveHandle_1);
      sliderGroup.add(moveHandleIcon);
      sliderGroup.add(actualMoveZone);
    }
    actualMoveZone.attr({
      draggable: true,
      cursor: getCursor$1(this._orient),
      drift: bind$1(this._onDragMove, this, "all"),
      ondragstart: bind$1(this._showDataInfo, this, true),
      ondragend: bind$1(this._onDragEnd, this),
      onmouseover: bind$1(this._showDataInfo, this, true),
      onmouseout: bind$1(this._showDataInfo, this, false)
    });
  };
  SliderZoomView2.prototype._resetInterval = function() {
    var range3 = this._range = this.dataZoomModel.getPercentRange();
    var viewExtent = this._getViewExtent();
    this._handleEnds = [linearMap$2(range3[0], [0, 100], viewExtent, true), linearMap$2(range3[1], [0, 100], viewExtent, true)];
  };
  SliderZoomView2.prototype._updateInterval = function(handleIndex, delta) {
    var dataZoomModel = this.dataZoomModel;
    var handleEnds = this._handleEnds;
    var viewExtend = this._getViewExtent();
    var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    var percentExtent = [0, 100];
    sliderMove(delta, handleEnds, viewExtend, dataZoomModel.get("zoomLock") ? "all" : handleIndex, minMaxSpan.minSpan != null ? linearMap$2(minMaxSpan.minSpan, percentExtent, viewExtend, true) : null, minMaxSpan.maxSpan != null ? linearMap$2(minMaxSpan.maxSpan, percentExtent, viewExtend, true) : null);
    var lastRange = this._range;
    var range3 = this._range = asc$2([linearMap$2(handleEnds[0], viewExtend, percentExtent, true), linearMap$2(handleEnds[1], viewExtend, percentExtent, true)]);
    return !lastRange || lastRange[0] !== range3[0] || lastRange[1] !== range3[1];
  };
  SliderZoomView2.prototype._updateView = function(nonRealtime) {
    var displaybles = this._displayables;
    var handleEnds = this._handleEnds;
    var handleInterval = asc$2(handleEnds.slice());
    var size = this._size;
    each$g([0, 1], function(handleIndex) {
      var handle = displaybles.handles[handleIndex];
      var handleHeight = this._handleHeight;
      handle.attr({
        scaleX: handleHeight / 2,
        scaleY: handleHeight / 2,
        x: handleEnds[handleIndex] + (handleIndex ? -1 : 1),
        y: size[1] / 2 - handleHeight / 2
      });
    }, this);
    displaybles.filler.setShape({
      x: handleInterval[0],
      y: 0,
      width: handleInterval[1] - handleInterval[0],
      height: size[1]
    });
    var viewExtent = {
      x: handleInterval[0],
      width: handleInterval[1] - handleInterval[0]
    };
    if (displaybles.moveHandle) {
      displaybles.moveHandle.setShape(viewExtent);
      displaybles.moveZone.setShape(viewExtent);
      displaybles.moveZone.getBoundingRect();
      displaybles.moveHandleIcon && displaybles.moveHandleIcon.attr("x", viewExtent.x + viewExtent.width / 2);
    }
    var dataShadowSegs = displaybles.dataShadowSegs;
    var segIntervals = [0, handleInterval[0], handleInterval[1], size[0]];
    for (var i = 0; i < dataShadowSegs.length; i++) {
      var segGroup = dataShadowSegs[i];
      var clipPath = segGroup.getClipPath();
      if (!clipPath) {
        clipPath = new Rect$3();
        segGroup.setClipPath(clipPath);
      }
      clipPath.setShape({
        x: segIntervals[i],
        y: 0,
        width: segIntervals[i + 1] - segIntervals[i],
        height: size[1]
      });
    }
    this._updateDataInfo(nonRealtime);
  };
  SliderZoomView2.prototype._updateDataInfo = function(nonRealtime) {
    var dataZoomModel = this.dataZoomModel;
    var displaybles = this._displayables;
    var handleLabels = displaybles.handleLabels;
    var orient = this._orient;
    var labelTexts = ["", ""];
    if (dataZoomModel.get("showDetail")) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var axis = axisProxy.getAxisModel().axis;
        var range3 = this._range;
        var dataInterval = nonRealtime ? axisProxy.calculateDataWindow({
          start: range3[0],
          end: range3[1]
        }).valueWindow : axisProxy.getDataValueWindow();
        labelTexts = [this._formatLabel(dataInterval[0], axis), this._formatLabel(dataInterval[1], axis)];
      }
    }
    var orderedHandleEnds = asc$2(this._handleEnds.slice());
    setLabel.call(this, 0);
    setLabel.call(this, 1);
    function setLabel(handleIndex) {
      var barTransform = getTransform$1(displaybles.handles[handleIndex].parent, this.group);
      var direction = transformDirection(handleIndex === 0 ? "right" : "left", barTransform);
      var offset3 = this._handleWidth / 2 + LABEL_GAP;
      var textPoint = applyTransform([orderedHandleEnds[handleIndex] + (handleIndex === 0 ? -offset3 : offset3), this._size[1] / 2], barTransform);
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        verticalAlign: orient === HORIZONTAL ? "middle" : direction,
        align: orient === HORIZONTAL ? direction : "center",
        text: labelTexts[handleIndex]
      });
    }
  };
  SliderZoomView2.prototype._formatLabel = function(value, axis) {
    var dataZoomModel = this.dataZoomModel;
    var labelFormatter = dataZoomModel.get("labelFormatter");
    var labelPrecision = dataZoomModel.get("labelPrecision");
    if (labelPrecision == null || labelPrecision === "auto") {
      labelPrecision = axis.getPixelPrecision();
    }
    var valueStr = value == null || isNaN(value) ? "" : axis.type === "category" || axis.type === "time" ? axis.scale.getLabel({
      value: Math.round(value)
    }) : value.toFixed(Math.min(labelPrecision, 20));
    return isFunction$1(labelFormatter) ? labelFormatter(value, valueStr) : isString$1(labelFormatter) ? labelFormatter.replace("{value}", valueStr) : valueStr;
  };
  SliderZoomView2.prototype._showDataInfo = function(showOrHide) {
    showOrHide = this._dragging || showOrHide;
    var displayables = this._displayables;
    var handleLabels = displayables.handleLabels;
    handleLabels[0].attr("invisible", !showOrHide);
    handleLabels[1].attr("invisible", !showOrHide);
    displayables.moveHandle && this.api[showOrHide ? "enterEmphasis" : "leaveEmphasis"](displayables.moveHandle, 1);
  };
  SliderZoomView2.prototype._onDragMove = function(handleIndex, dx, dy, event) {
    this._dragging = true;
    stop(event.event);
    var barTransform = this._displayables.sliderGroup.getLocalTransform();
    var vertex = applyTransform([dx, dy], barTransform, true);
    var changed = this._updateInterval(handleIndex, vertex[0]);
    var realtime = this.dataZoomModel.get("realtime");
    this._updateView(!realtime);
    changed && realtime && this._dispatchZoomAction(true);
  };
  SliderZoomView2.prototype._onDragEnd = function() {
    this._dragging = false;
    this._showDataInfo(false);
    var realtime = this.dataZoomModel.get("realtime");
    !realtime && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onClickPanel = function(e2) {
    var size = this._size;
    var localPoint = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
    if (localPoint[0] < 0 || localPoint[0] > size[0] || localPoint[1] < 0 || localPoint[1] > size[1]) {
      return;
    }
    var handleEnds = this._handleEnds;
    var center2 = (handleEnds[0] + handleEnds[1]) / 2;
    var changed = this._updateInterval("all", localPoint[0] - center2);
    this._updateView();
    changed && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrushStart = function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    this._brushStart = new Point$1(x2, y2);
    this._brushing = true;
    this._brushStartTime = +new Date();
  };
  SliderZoomView2.prototype._onBrushEnd = function(e2) {
    if (!this._brushing) {
      return;
    }
    var brushRect = this._displayables.brushRect;
    this._brushing = false;
    if (!brushRect) {
      return;
    }
    brushRect.attr("ignore", true);
    var brushShape = brushRect.shape;
    var brushEndTime = +new Date();
    if (brushEndTime - this._brushStartTime < 200 && Math.abs(brushShape.width) < 5) {
      return;
    }
    var viewExtend = this._getViewExtent();
    var percentExtent = [0, 100];
    this._range = asc$2([linearMap$2(brushShape.x, viewExtend, percentExtent, true), linearMap$2(brushShape.x + brushShape.width, viewExtend, percentExtent, true)]);
    this._handleEnds = [brushShape.x, brushShape.x + brushShape.width];
    this._updateView();
    this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrush = function(e2) {
    if (this._brushing) {
      stop(e2.event);
      this._updateBrushRect(e2.offsetX, e2.offsetY);
    }
  };
  SliderZoomView2.prototype._updateBrushRect = function(mouseX, mouseY) {
    var displayables = this._displayables;
    var dataZoomModel = this.dataZoomModel;
    var brushRect = displayables.brushRect;
    if (!brushRect) {
      brushRect = displayables.brushRect = new Rect({
        silent: true,
        style: dataZoomModel.getModel("brushStyle").getItemStyle()
      });
      displayables.sliderGroup.add(brushRect);
    }
    brushRect.attr("ignore", false);
    var brushStart = this._brushStart;
    var sliderGroup = this._displayables.sliderGroup;
    var endPoint = sliderGroup.transformCoordToLocal(mouseX, mouseY);
    var startPoint = sliderGroup.transformCoordToLocal(brushStart.x, brushStart.y);
    var size = this._size;
    endPoint[0] = Math.max(Math.min(size[0], endPoint[0]), 0);
    brushRect.setShape({
      x: startPoint[0],
      y: 0,
      width: endPoint[0] - startPoint[0],
      height: size[1]
    });
  };
  SliderZoomView2.prototype._dispatchZoomAction = function(realtime) {
    var range3 = this._range;
    this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      dataZoomId: this.dataZoomModel.id,
      animation: realtime ? REALTIME_ANIMATION_CONFIG : null,
      start: range3[0],
      end: range3[1]
    });
  };
  SliderZoomView2.prototype._findCoordRect = function() {
    var rect;
    var coordSysInfoList = collectReferCoordSysModelInfo(this.dataZoomModel).infoList;
    if (!rect && coordSysInfoList.length) {
      var coordSys = coordSysInfoList[0].model.coordinateSystem;
      rect = coordSys.getRect && coordSys.getRect();
    }
    if (!rect) {
      var width = this.api.getWidth();
      var height = this.api.getHeight();
      rect = {
        x: width * 0.2,
        y: height * 0.2,
        width: width * 0.6,
        height: height * 0.6
      };
    }
    return rect;
  };
  SliderZoomView2.type = "dataZoom.slider";
  return SliderZoomView2;
}(DataZoomView$1);
function getOtherDim(thisDim) {
  var map2 = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return map2[thisDim];
}
function getCursor$1(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var SliderZoomView$1 = SliderZoomView;
function install$7(registers) {
  registers.registerComponentModel(SliderZoomModel$1);
  registers.registerComponentView(SliderZoomView$1);
  installCommon$1(registers);
}
function install$6(registers) {
  use(install$8);
  use(install$7);
}
var visualDefault = {
  get: function(visualType, key, isCategory2) {
    var value = clone$4((defaultOption[visualType] || {})[key]);
    return isCategory2 ? isArray$2(value) ? value[value.length - 1] : value : value;
  }
};
var defaultOption = {
  color: {
    active: ["#006edd", "#e0ffff"],
    inactive: ["rgba(0,0,0,0)"]
  },
  colorHue: {
    active: [0, 360],
    inactive: [0, 0]
  },
  colorSaturation: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  colorLightness: {
    active: [0.9, 0.5],
    inactive: [0, 0]
  },
  colorAlpha: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  opacity: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  symbol: {
    active: ["circle", "roundRect", "diamond"],
    inactive: ["none"]
  },
  symbolSize: {
    active: [10, 50],
    inactive: [0, 0]
  }
};
var visualDefault$1 = visualDefault;
var mapVisual = VisualMapping$1.mapVisual;
var eachVisual = VisualMapping$1.eachVisual;
var isArray$1 = isArray$2;
var each$3 = each$g;
var asc = asc$2;
var linearMap$1 = linearMap$2;
var VisualMapModel = function(_super) {
  __extends(VisualMapModel2, _super);
  function VisualMapModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapModel2.type;
    _this.stateList = ["inRange", "outOfRange"];
    _this.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"];
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    _this.dataBound = [-Infinity, Infinity];
    _this.targetVisuals = {};
    _this.controllerVisuals = {};
    return _this;
  }
  VisualMapModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  VisualMapModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, this.replacableOptionKeys);
    this.textStyleModel = this.getModel("textStyle");
    this.resetItemSize();
    this.completeVisualOption();
  };
  VisualMapModel2.prototype.resetVisual = function(supplementVisualOption) {
    var stateList = this.stateList;
    supplementVisualOption = bind$1(supplementVisualOption, this);
    this.controllerVisuals = createVisualMappings(this.option.controller, stateList, supplementVisualOption);
    this.targetVisuals = createVisualMappings(this.option.target, stateList, supplementVisualOption);
  };
  VisualMapModel2.prototype.getItemSymbol = function() {
    return null;
  };
  VisualMapModel2.prototype.getTargetSeriesIndices = function() {
    var optionSeriesIndex = this.option.seriesIndex;
    var seriesIndices = [];
    if (optionSeriesIndex == null || optionSeriesIndex === "all") {
      this.ecModel.eachSeries(function(seriesModel, index2) {
        seriesIndices.push(index2);
      });
    } else {
      seriesIndices = normalizeToArray(optionSeriesIndex);
    }
    return seriesIndices;
  };
  VisualMapModel2.prototype.eachTargetSeries = function(callback, context) {
    each$g(this.getTargetSeriesIndices(), function(seriesIndex) {
      var seriesModel = this.ecModel.getSeriesByIndex(seriesIndex);
      if (seriesModel) {
        callback.call(context, seriesModel);
      }
    }, this);
  };
  VisualMapModel2.prototype.isTargetSeries = function(seriesModel) {
    var is = false;
    this.eachTargetSeries(function(model) {
      model === seriesModel && (is = true);
    });
    return is;
  };
  VisualMapModel2.prototype.formatValueText = function(value, isCategory2, edgeSymbols) {
    var option = this.option;
    var precision = option.precision;
    var dataBound = this.dataBound;
    var formatter = option.formatter;
    var isMinMax;
    edgeSymbols = edgeSymbols || ["<", ">"];
    if (isArray$2(value)) {
      value = value.slice();
      isMinMax = true;
    }
    var textValue = isCategory2 ? value : isMinMax ? [toFixed(value[0]), toFixed(value[1])] : toFixed(value);
    if (isString$1(formatter)) {
      return formatter.replace("{value}", isMinMax ? textValue[0] : textValue).replace("{value2}", isMinMax ? textValue[1] : textValue);
    } else if (isFunction$1(formatter)) {
      return isMinMax ? formatter(value[0], value[1]) : formatter(value);
    }
    if (isMinMax) {
      if (value[0] === dataBound[0]) {
        return edgeSymbols[0] + " " + textValue[1];
      } else if (value[1] === dataBound[1]) {
        return edgeSymbols[1] + " " + textValue[0];
      } else {
        return textValue[0] + " - " + textValue[1];
      }
    } else {
      return textValue;
    }
    function toFixed(val) {
      return val === dataBound[0] ? "min" : val === dataBound[1] ? "max" : (+val).toFixed(Math.min(precision, 20));
    }
  };
  VisualMapModel2.prototype.resetExtent = function() {
    var thisOption = this.option;
    var extent3 = asc([thisOption.min, thisOption.max]);
    this._dataExtent = extent3;
  };
  VisualMapModel2.prototype.getDataDimensionIndex = function(data2) {
    var optDim = this.option.dimension;
    if (optDim != null) {
      return data2.getDimensionIndex(optDim);
    }
    var dimNames = data2.dimensions;
    for (var i = dimNames.length - 1; i >= 0; i--) {
      var dimName = dimNames[i];
      var dimInfo = data2.getDimensionInfo(dimName);
      if (!dimInfo.isCalculationCoord) {
        return dimInfo.storeDimIndex;
      }
    }
  };
  VisualMapModel2.prototype.getExtent = function() {
    return this._dataExtent.slice();
  };
  VisualMapModel2.prototype.completeVisualOption = function() {
    var ecModel = this.ecModel;
    var thisOption = this.option;
    var base2 = {
      inRange: thisOption.inRange,
      outOfRange: thisOption.outOfRange
    };
    var target = thisOption.target || (thisOption.target = {});
    var controller = thisOption.controller || (thisOption.controller = {});
    merge$1(target, base2);
    merge$1(controller, base2);
    var isCategory2 = this.isCategory();
    completeSingle.call(this, target);
    completeSingle.call(this, controller);
    completeInactive.call(this, target, "inRange", "outOfRange");
    completeController.call(this, controller);
    function completeSingle(base3) {
      if (isArray$1(thisOption.color) && !base3.inRange) {
        base3.inRange = {
          color: thisOption.color.slice().reverse()
        };
      }
      base3.inRange = base3.inRange || {
        color: ecModel.get("gradientColor")
      };
    }
    function completeInactive(base3, stateExist, stateAbsent) {
      var optExist = base3[stateExist];
      var optAbsent = base3[stateAbsent];
      if (optExist && !optAbsent) {
        optAbsent = base3[stateAbsent] = {};
        each$3(optExist, function(visualData, visualType) {
          if (!VisualMapping$1.isValidType(visualType)) {
            return;
          }
          var defa = visualDefault$1.get(visualType, "inactive", isCategory2);
          if (defa != null) {
            optAbsent[visualType] = defa;
            if (visualType === "color" && !optAbsent.hasOwnProperty("opacity") && !optAbsent.hasOwnProperty("colorAlpha")) {
              optAbsent.opacity = [0, 0];
            }
          }
        });
      }
    }
    function completeController(controller2) {
      var symbolExists = (controller2.inRange || {}).symbol || (controller2.outOfRange || {}).symbol;
      var symbolSizeExists = (controller2.inRange || {}).symbolSize || (controller2.outOfRange || {}).symbolSize;
      var inactiveColor = this.get("inactiveColor");
      var itemSymbol = this.getItemSymbol();
      var defaultSymbol = itemSymbol || "roundRect";
      each$3(this.stateList, function(state) {
        var itemSize = this.itemSize;
        var visuals = controller2[state];
        if (!visuals) {
          visuals = controller2[state] = {
            color: isCategory2 ? inactiveColor : [inactiveColor]
          };
        }
        if (visuals.symbol == null) {
          visuals.symbol = symbolExists && clone$4(symbolExists) || (isCategory2 ? defaultSymbol : [defaultSymbol]);
        }
        if (visuals.symbolSize == null) {
          visuals.symbolSize = symbolSizeExists && clone$4(symbolSizeExists) || (isCategory2 ? itemSize[0] : [itemSize[0], itemSize[0]]);
        }
        visuals.symbol = mapVisual(visuals.symbol, function(symbol) {
          return symbol === "none" ? defaultSymbol : symbol;
        });
        var symbolSize = visuals.symbolSize;
        if (symbolSize != null) {
          var max_1 = -Infinity;
          eachVisual(symbolSize, function(value) {
            value > max_1 && (max_1 = value);
          });
          visuals.symbolSize = mapVisual(symbolSize, function(value) {
            return linearMap$1(value, [0, max_1], [0, itemSize[0]], true);
          });
        }
      }, this);
    }
  };
  VisualMapModel2.prototype.resetItemSize = function() {
    this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
  };
  VisualMapModel2.prototype.isCategory = function() {
    return !!this.option.categories;
  };
  VisualMapModel2.prototype.setSelected = function(selected) {
  };
  VisualMapModel2.prototype.getSelected = function() {
    return null;
  };
  VisualMapModel2.prototype.getValueState = function(value) {
    return null;
  };
  VisualMapModel2.prototype.getVisualMeta = function(getColorVisual2) {
    return null;
  };
  VisualMapModel2.type = "visualMap";
  VisualMapModel2.dependencies = ["series"];
  VisualMapModel2.defaultOption = {
    show: true,
    z: 4,
    seriesIndex: "all",
    min: 0,
    max: 200,
    left: 0,
    right: null,
    top: null,
    bottom: 0,
    itemWidth: null,
    itemHeight: null,
    inverse: false,
    orient: "vertical",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    contentColor: "#5793f3",
    inactiveColor: "#aaa",
    borderWidth: 0,
    padding: 5,
    textGap: 10,
    precision: 0,
    textStyle: {
      color: "#333"
    }
  };
  return VisualMapModel2;
}(ComponentModel$1);
var VisualMapModel$1 = VisualMapModel;
var DEFAULT_BAR_BOUND = [20, 140];
var ContinuousModel = function(_super) {
  __extends(ContinuousModel2, _super);
  function ContinuousModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousModel2.type;
    return _this;
  }
  ContinuousModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    this.resetVisual(function(mappingOption) {
      mappingOption.mappingMethod = "linear";
      mappingOption.dataExtent = this.getExtent();
    });
    this._resetRange();
  };
  ContinuousModel2.prototype.resetItemSize = function() {
    _super.prototype.resetItemSize.apply(this, arguments);
    var itemSize = this.itemSize;
    (itemSize[0] == null || isNaN(itemSize[0])) && (itemSize[0] = DEFAULT_BAR_BOUND[0]);
    (itemSize[1] == null || isNaN(itemSize[1])) && (itemSize[1] = DEFAULT_BAR_BOUND[1]);
  };
  ContinuousModel2.prototype._resetRange = function() {
    var dataExtent = this.getExtent();
    var range3 = this.option.range;
    if (!range3 || range3.auto) {
      dataExtent.auto = 1;
      this.option.range = dataExtent;
    } else if (isArray$2(range3)) {
      if (range3[0] > range3[1]) {
        range3.reverse();
      }
      range3[0] = Math.max(range3[0], dataExtent[0]);
      range3[1] = Math.min(range3[1], dataExtent[1]);
    }
  };
  ContinuousModel2.prototype.completeVisualOption = function() {
    _super.prototype.completeVisualOption.apply(this, arguments);
    each$g(this.stateList, function(state) {
      var symbolSize = this.option.controller[state].symbolSize;
      if (symbolSize && symbolSize[0] !== symbolSize[1]) {
        symbolSize[0] = symbolSize[1] / 3;
      }
    }, this);
  };
  ContinuousModel2.prototype.setSelected = function(selected) {
    this.option.range = selected.slice();
    this._resetRange();
  };
  ContinuousModel2.prototype.getSelected = function() {
    var dataExtent = this.getExtent();
    var dataInterval = asc$2((this.get("range") || []).slice());
    dataInterval[0] > dataExtent[1] && (dataInterval[0] = dataExtent[1]);
    dataInterval[1] > dataExtent[1] && (dataInterval[1] = dataExtent[1]);
    dataInterval[0] < dataExtent[0] && (dataInterval[0] = dataExtent[0]);
    dataInterval[1] < dataExtent[0] && (dataInterval[1] = dataExtent[0]);
    return dataInterval;
  };
  ContinuousModel2.prototype.getValueState = function(value) {
    var range3 = this.option.range;
    var dataExtent = this.getExtent();
    return (range3[0] <= dataExtent[0] || range3[0] <= value) && (range3[1] >= dataExtent[1] || value <= range3[1]) ? "inRange" : "outOfRange";
  };
  ContinuousModel2.prototype.findTargetDataIndices = function(range3) {
    var result = [];
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data2 = seriesModel.getData();
      data2.each(this.getDataDimensionIndex(data2), function(value, dataIndex) {
        range3[0] <= value && value <= range3[1] && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  ContinuousModel2.prototype.getVisualMeta = function(getColorVisual2) {
    var oVals = getColorStopValues(this, "outOfRange", this.getExtent());
    var iVals = getColorStopValues(this, "inRange", this.option.range.slice());
    var stops = [];
    function setStop(value, valueState) {
      stops.push({
        value,
        color: getColorVisual2(value, valueState)
      });
    }
    var iIdx = 0;
    var oIdx = 0;
    var iLen = iVals.length;
    var oLen = oVals.length;
    for (; oIdx < oLen && (!iVals.length || oVals[oIdx] <= iVals[0]); oIdx++) {
      if (oVals[oIdx] < iVals[iIdx]) {
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    for (var first = 1; iIdx < iLen; iIdx++, first = 0) {
      first && stops.length && setStop(iVals[iIdx], "outOfRange");
      setStop(iVals[iIdx], "inRange");
    }
    for (var first = 1; oIdx < oLen; oIdx++) {
      if (!iVals.length || iVals[iVals.length - 1] < oVals[oIdx]) {
        if (first) {
          stops.length && setStop(stops[stops.length - 1].value, "outOfRange");
          first = 0;
        }
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    var stopsLen = stops.length;
    return {
      stops,
      outerColors: [stopsLen ? stops[0].color : "transparent", stopsLen ? stops[stopsLen - 1].color : "transparent"]
    };
  };
  ContinuousModel2.type = "visualMap.continuous";
  ContinuousModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    align: "auto",
    calculable: false,
    hoverLink: true,
    realtime: true,
    handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z",
    handleSize: "120%",
    handleStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    indicatorIcon: "circle",
    indicatorSize: "50%",
    indicatorStyle: {
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0,0,0,0.2)"
    }
  });
  return ContinuousModel2;
}(VisualMapModel$1);
function getColorStopValues(visualMapModel, valueState, dataExtent) {
  if (dataExtent[0] === dataExtent[1]) {
    return dataExtent.slice();
  }
  var count2 = 200;
  var step = (dataExtent[1] - dataExtent[0]) / count2;
  var value = dataExtent[0];
  var stopValues = [];
  for (var i = 0; i <= count2 && value < dataExtent[1]; i++) {
    stopValues.push(value);
    value += step;
  }
  stopValues.push(dataExtent[1]);
  return stopValues;
}
var ContinuousModel$1 = ContinuousModel;
var VisualMapView = function(_super) {
  __extends(VisualMapView2, _super);
  function VisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapView2.type;
    _this.autoPositionValues = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 1
    };
    return _this;
  }
  VisualMapView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
  };
  VisualMapView2.prototype.render = function(visualMapModel, ecModel, api, payload) {
    this.visualMapModel = visualMapModel;
    if (visualMapModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    this.doRender(visualMapModel, ecModel, api, payload);
  };
  VisualMapView2.prototype.renderBackground = function(group) {
    var visualMapModel = this.visualMapModel;
    var padding = normalizeCssArray(visualMapModel.get("padding") || 0);
    var rect = group.getBoundingRect();
    group.add(new Rect$3({
      z2: -1,
      silent: true,
      shape: {
        x: rect.x - padding[3],
        y: rect.y - padding[0],
        width: rect.width + padding[3] + padding[1],
        height: rect.height + padding[0] + padding[2]
      },
      style: {
        fill: visualMapModel.get("backgroundColor"),
        stroke: visualMapModel.get("borderColor"),
        lineWidth: visualMapModel.get("borderWidth")
      }
    }));
  };
  VisualMapView2.prototype.getControllerVisual = function(targetValue, visualCluster, opts) {
    opts = opts || {};
    var forceState = opts.forceState;
    var visualMapModel = this.visualMapModel;
    var visualObj = {};
    if (visualCluster === "color") {
      var defaultColor = visualMapModel.get("contentColor");
      visualObj.color = defaultColor;
    }
    function getter(key) {
      return visualObj[key];
    }
    function setter(key, value) {
      visualObj[key] = value;
    }
    var mappings = visualMapModel.controllerVisuals[forceState || visualMapModel.getValueState(targetValue)];
    var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
    each$g(visualTypes, function(type4) {
      var visualMapping = mappings[type4];
      if (opts.convertOpacityToAlpha && type4 === "opacity") {
        type4 = "colorAlpha";
        visualMapping = mappings.__alphaForOpacity;
      }
      if (VisualMapping$1.dependsOn(type4, visualCluster)) {
        visualMapping && visualMapping.applyVisual(targetValue, getter, setter);
      }
    });
    return visualObj[visualCluster];
  };
  VisualMapView2.prototype.positionGroup = function(group) {
    var model = this.visualMapModel;
    var api = this.api;
    positionElement(group, model.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  VisualMapView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
  };
  VisualMapView2.type = "visualMap";
  return VisualMapView2;
}(ComponentView$1);
var VisualMapView$1 = VisualMapView;
var paramsSet = [["left", "right", "width"], ["top", "bottom", "height"]];
function getItemAlign(visualMapModel, api, itemSize) {
  var modelOption = visualMapModel.option;
  var itemAlign = modelOption.align;
  if (itemAlign != null && itemAlign !== "auto") {
    return itemAlign;
  }
  var ecSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var realIndex = modelOption.orient === "horizontal" ? 1 : 0;
  var reals = paramsSet[realIndex];
  var fakeValue = [0, null, 10];
  var layoutInput = {};
  for (var i = 0; i < 3; i++) {
    layoutInput[paramsSet[1 - realIndex][i]] = fakeValue[i];
    layoutInput[reals[i]] = i === 2 ? itemSize[0] : modelOption[reals[i]];
  }
  var rParam = [["x", "width", 3], ["y", "height", 0]][realIndex];
  var rect = getLayoutRect(layoutInput, ecSize, modelOption.padding);
  return reals[(rect.margin[rParam[2]] || 0) + rect[rParam[0]] + rect[rParam[1]] * 0.5 < ecSize[rParam[1]] * 0.5 ? 0 : 1];
}
function makeHighDownBatch(batch, visualMapModel) {
  each$g(batch || [], function(batchItem) {
    if (batchItem.dataIndex != null) {
      batchItem.dataIndexInside = batchItem.dataIndex;
      batchItem.dataIndex = null;
    }
    batchItem.highlightKey = "visualMap" + (visualMapModel ? visualMapModel.componentIndex : "");
  });
  return batch;
}
var linearMap = linearMap$2;
var each$2 = each$g;
var mathMin = Math.min;
var mathMax = Math.max;
var HOVER_LINK_SIZE = 12;
var HOVER_LINK_OUT = 6;
var ContinuousView = function(_super) {
  __extends(ContinuousView2, _super);
  function ContinuousView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousView2.type;
    _this._shapes = {};
    _this._dataInterval = [];
    _this._handleEnds = [];
    _this._hoverLinkDataIndices = [];
    return _this;
  }
  ContinuousView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
    this._api = api;
    if (!payload || payload.type !== "selectDataRange" || payload.from !== this.uid) {
      this._buildView();
    }
  };
  ContinuousView2.prototype._buildView = function() {
    this.group.removeAll();
    var visualMapModel = this.visualMapModel;
    var thisGroup = this.group;
    this._orient = visualMapModel.get("orient");
    this._useHandle = visualMapModel.get("calculable");
    this._resetInterval();
    this._renderBar(thisGroup);
    var dataRangeText = visualMapModel.get("text");
    this._renderEndsText(thisGroup, dataRangeText, 0);
    this._renderEndsText(thisGroup, dataRangeText, 1);
    this._updateView(true);
    this.renderBackground(thisGroup);
    this._updateView();
    this._enableHoverLinkToSeries();
    this._enableHoverLinkFromSeries();
    this.positionGroup(thisGroup);
  };
  ContinuousView2.prototype._renderEndsText = function(group, dataRangeText, endsIndex) {
    if (!dataRangeText) {
      return;
    }
    var text = dataRangeText[1 - endsIndex];
    text = text != null ? text + "" : "";
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var itemSize = visualMapModel.itemSize;
    var barGroup = this._shapes.mainGroup;
    var position2 = this._applyTransform([itemSize[0] / 2, endsIndex === 0 ? -textGap : itemSize[1] + textGap], barGroup);
    var align = this._applyTransform(endsIndex === 0 ? "bottom" : "top", barGroup);
    var orient = this._orient;
    var textStyleModel = this.visualMapModel.textStyleModel;
    this.group.add(new ZRText$1({
      style: {
        x: position2[0],
        y: position2[1],
        verticalAlign: orient === "horizontal" ? "middle" : align,
        align: orient === "horizontal" ? align : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
  };
  ContinuousView2.prototype._renderBar = function(targetGroup) {
    var visualMapModel = this.visualMapModel;
    var shapes = this._shapes;
    var itemSize = visualMapModel.itemSize;
    var orient = this._orient;
    var useHandle = this._useHandle;
    var itemAlign = getItemAlign(visualMapModel, this.api, itemSize);
    var mainGroup = shapes.mainGroup = this._createBarGroup(itemAlign);
    var gradientBarGroup = new Group$6();
    mainGroup.add(gradientBarGroup);
    gradientBarGroup.add(shapes.outOfRange = createPolygon());
    gradientBarGroup.add(shapes.inRange = createPolygon(null, useHandle ? getCursor(this._orient) : null, bind$1(this._dragHandle, this, "all", false), bind$1(this._dragHandle, this, "all", true)));
    gradientBarGroup.setClipPath(new Rect$3({
      shape: {
        x: 0,
        y: 0,
        width: itemSize[0],
        height: itemSize[1],
        r: 3
      }
    }));
    var textRect = visualMapModel.textStyleModel.getTextRect("\u56FD");
    var textSize = mathMax(textRect.width, textRect.height);
    if (useHandle) {
      shapes.handleThumbs = [];
      shapes.handleLabels = [];
      shapes.handleLabelPoints = [];
      this._createHandle(visualMapModel, mainGroup, 0, itemSize, textSize, orient);
      this._createHandle(visualMapModel, mainGroup, 1, itemSize, textSize, orient);
    }
    this._createIndicator(visualMapModel, mainGroup, itemSize, textSize, orient);
    targetGroup.add(mainGroup);
  };
  ContinuousView2.prototype._createHandle = function(visualMapModel, mainGroup, handleIndex, itemSize, textSize, orient) {
    var onDrift = bind$1(this._dragHandle, this, handleIndex, false);
    var onDragEnd = bind$1(this._dragHandle, this, handleIndex, true);
    var handleSize = parsePercent$1(visualMapModel.get("handleSize"), itemSize[0]);
    var handleThumb = createSymbol$1(visualMapModel.get("handleIcon"), -handleSize / 2, -handleSize / 2, handleSize, handleSize, null, true);
    var cursor = getCursor(this._orient);
    handleThumb.attr({
      cursor,
      draggable: true,
      drift: onDrift,
      ondragend: onDragEnd,
      onmousemove: function(e2) {
        stop(e2.event);
      }
    });
    handleThumb.x = itemSize[0] / 2;
    handleThumb.useStyle(visualMapModel.getModel("handleStyle").getItemStyle());
    handleThumb.setStyle({
      strokeNoScale: true,
      strokeFirst: true
    });
    handleThumb.style.lineWidth *= 2;
    handleThumb.ensureState("emphasis").style = visualMapModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
    setAsHighDownDispatcher(handleThumb, true);
    mainGroup.add(handleThumb);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var handleLabel = new ZRText$1({
      cursor,
      draggable: true,
      drift: onDrift,
      onmousemove: function(e2) {
        stop(e2.event);
      },
      ondragend: onDragEnd,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    handleLabel.ensureState("blur").style = {
      opacity: 0.1
    };
    handleLabel.stateTransition = {
      duration: 200
    };
    this.group.add(handleLabel);
    var handleLabelPoint = [handleSize, 0];
    var shapes = this._shapes;
    shapes.handleThumbs[handleIndex] = handleThumb;
    shapes.handleLabelPoints[handleIndex] = handleLabelPoint;
    shapes.handleLabels[handleIndex] = handleLabel;
  };
  ContinuousView2.prototype._createIndicator = function(visualMapModel, mainGroup, itemSize, textSize, orient) {
    var scale2 = parsePercent$1(visualMapModel.get("indicatorSize"), itemSize[0]);
    var indicator = createSymbol$1(visualMapModel.get("indicatorIcon"), -scale2 / 2, -scale2 / 2, scale2, scale2, null, true);
    indicator.attr({
      cursor: "move",
      invisible: true,
      silent: true,
      x: itemSize[0] / 2
    });
    var indicatorStyle = visualMapModel.getModel("indicatorStyle").getItemStyle();
    if (indicator instanceof ZRImage$1) {
      var pathStyle = indicator.style;
      indicator.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, indicatorStyle));
    } else {
      indicator.useStyle(indicatorStyle);
    }
    mainGroup.add(indicator);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var indicatorLabel = new ZRText$1({
      silent: true,
      invisible: true,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    this.group.add(indicatorLabel);
    var indicatorLabelPoint = [(orient === "horizontal" ? textSize / 2 : HOVER_LINK_OUT) + itemSize[0] / 2, 0];
    var shapes = this._shapes;
    shapes.indicator = indicator;
    shapes.indicatorLabel = indicatorLabel;
    shapes.indicatorLabelPoint = indicatorLabelPoint;
    this._firstShowIndicator = true;
  };
  ContinuousView2.prototype._dragHandle = function(handleIndex, isEnd, dx, dy) {
    if (!this._useHandle) {
      return;
    }
    this._dragging = !isEnd;
    if (!isEnd) {
      var vertex = this._applyTransform([dx, dy], this._shapes.mainGroup, true);
      this._updateInterval(handleIndex, vertex[1]);
      this._hideIndicator();
      this._updateView();
    }
    if (isEnd === !this.visualMapModel.get("realtime")) {
      this.api.dispatchAction({
        type: "selectDataRange",
        from: this.uid,
        visualMapId: this.visualMapModel.id,
        selected: this._dataInterval.slice()
      });
    }
    if (isEnd) {
      !this._hovering && this._clearHoverLinkToSeries();
    } else if (useHoverLinkOnHandle(this.visualMapModel)) {
      this._doHoverLinkToSeries(this._handleEnds[handleIndex], false);
    }
  };
  ContinuousView2.prototype._resetInterval = function() {
    var visualMapModel = this.visualMapModel;
    var dataInterval = this._dataInterval = visualMapModel.getSelected();
    var dataExtent = visualMapModel.getExtent();
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    this._handleEnds = [linearMap(dataInterval[0], dataExtent, sizeExtent, true), linearMap(dataInterval[1], dataExtent, sizeExtent, true)];
  };
  ContinuousView2.prototype._updateInterval = function(handleIndex, delta) {
    delta = delta || 0;
    var visualMapModel = this.visualMapModel;
    var handleEnds = this._handleEnds;
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    sliderMove(delta, handleEnds, sizeExtent, handleIndex, 0);
    var dataExtent = visualMapModel.getExtent();
    this._dataInterval = [linearMap(handleEnds[0], sizeExtent, dataExtent, true), linearMap(handleEnds[1], sizeExtent, dataExtent, true)];
  };
  ContinuousView2.prototype._updateView = function(forSketch) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var shapes = this._shapes;
    var outOfRangeHandleEnds = [0, visualMapModel.itemSize[1]];
    var inRangeHandleEnds = forSketch ? outOfRangeHandleEnds : this._handleEnds;
    var visualInRange = this._createBarVisual(this._dataInterval, dataExtent, inRangeHandleEnds, "inRange");
    var visualOutOfRange = this._createBarVisual(dataExtent, dataExtent, outOfRangeHandleEnds, "outOfRange");
    shapes.inRange.setStyle({
      fill: visualInRange.barColor
    }).setShape("points", visualInRange.barPoints);
    shapes.outOfRange.setStyle({
      fill: visualOutOfRange.barColor
    }).setShape("points", visualOutOfRange.barPoints);
    this._updateHandle(inRangeHandleEnds, visualInRange);
  };
  ContinuousView2.prototype._createBarVisual = function(dataInterval, dataExtent, handleEnds, forceState) {
    var opts = {
      forceState,
      convertOpacityToAlpha: true
    };
    var colorStops = this._makeColorGradient(dataInterval, opts);
    var symbolSizes = [this.getControllerVisual(dataInterval[0], "symbolSize", opts), this.getControllerVisual(dataInterval[1], "symbolSize", opts)];
    var barPoints = this._createBarPoints(handleEnds, symbolSizes);
    return {
      barColor: new LinearGradient$1(0, 0, 0, 1, colorStops),
      barPoints,
      handlesColor: [colorStops[0].color, colorStops[colorStops.length - 1].color]
    };
  };
  ContinuousView2.prototype._makeColorGradient = function(dataInterval, opts) {
    var sampleNumber = 100;
    var colorStops = [];
    var step = (dataInterval[1] - dataInterval[0]) / sampleNumber;
    colorStops.push({
      color: this.getControllerVisual(dataInterval[0], "color", opts),
      offset: 0
    });
    for (var i = 1; i < sampleNumber; i++) {
      var currValue = dataInterval[0] + step * i;
      if (currValue > dataInterval[1]) {
        break;
      }
      colorStops.push({
        color: this.getControllerVisual(currValue, "color", opts),
        offset: i / sampleNumber
      });
    }
    colorStops.push({
      color: this.getControllerVisual(dataInterval[1], "color", opts),
      offset: 1
    });
    return colorStops;
  };
  ContinuousView2.prototype._createBarPoints = function(handleEnds, symbolSizes) {
    var itemSize = this.visualMapModel.itemSize;
    return [[itemSize[0] - symbolSizes[0], handleEnds[0]], [itemSize[0], handleEnds[0]], [itemSize[0], handleEnds[1]], [itemSize[0] - symbolSizes[1], handleEnds[1]]];
  };
  ContinuousView2.prototype._createBarGroup = function(itemAlign) {
    var orient = this._orient;
    var inverse = this.visualMapModel.get("inverse");
    return new Group$6(orient === "horizontal" && !inverse ? {
      scaleX: itemAlign === "bottom" ? 1 : -1,
      rotation: Math.PI / 2
    } : orient === "horizontal" && inverse ? {
      scaleX: itemAlign === "bottom" ? -1 : 1,
      rotation: -Math.PI / 2
    } : orient === "vertical" && !inverse ? {
      scaleX: itemAlign === "left" ? 1 : -1,
      scaleY: -1
    } : {
      scaleX: itemAlign === "left" ? 1 : -1
    });
  };
  ContinuousView2.prototype._updateHandle = function(handleEnds, visualInRange) {
    if (!this._useHandle) {
      return;
    }
    var shapes = this._shapes;
    var visualMapModel = this.visualMapModel;
    var handleThumbs = shapes.handleThumbs;
    var handleLabels = shapes.handleLabels;
    var itemSize = visualMapModel.itemSize;
    var dataExtent = visualMapModel.getExtent();
    each$2([0, 1], function(handleIndex) {
      var handleThumb = handleThumbs[handleIndex];
      handleThumb.setStyle("fill", visualInRange.handlesColor[handleIndex]);
      handleThumb.y = handleEnds[handleIndex];
      var val = linearMap(handleEnds[handleIndex], [0, itemSize[1]], dataExtent, true);
      var symbolSize = this.getControllerVisual(val, "symbolSize");
      handleThumb.scaleX = handleThumb.scaleY = symbolSize / itemSize[0];
      handleThumb.x = itemSize[0] - symbolSize / 2;
      var textPoint = applyTransform(shapes.handleLabelPoints[handleIndex], getTransform$1(handleThumb, this.group));
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        text: visualMapModel.formatValueText(this._dataInterval[handleIndex]),
        verticalAlign: "middle",
        align: this._orient === "vertical" ? this._applyTransform("left", shapes.mainGroup) : "center"
      });
    }, this);
  };
  ContinuousView2.prototype._showIndicator = function(cursorValue, textValue, rangeSymbol, halfHoverLinkSize) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var itemSize = visualMapModel.itemSize;
    var sizeExtent = [0, itemSize[1]];
    var shapes = this._shapes;
    var indicator = shapes.indicator;
    if (!indicator) {
      return;
    }
    indicator.attr("invisible", false);
    var opts = {
      convertOpacityToAlpha: true
    };
    var color = this.getControllerVisual(cursorValue, "color", opts);
    var symbolSize = this.getControllerVisual(cursorValue, "symbolSize");
    var y2 = linearMap(cursorValue, dataExtent, sizeExtent, true);
    var x2 = itemSize[0] - symbolSize / 2;
    var oldIndicatorPos = {
      x: indicator.x,
      y: indicator.y
    };
    indicator.y = y2;
    indicator.x = x2;
    var textPoint = applyTransform(shapes.indicatorLabelPoint, getTransform$1(indicator, this.group));
    var indicatorLabel = shapes.indicatorLabel;
    indicatorLabel.attr("invisible", false);
    var align = this._applyTransform("left", shapes.mainGroup);
    var orient = this._orient;
    var isHorizontal = orient === "horizontal";
    indicatorLabel.setStyle({
      text: (rangeSymbol ? rangeSymbol : "") + visualMapModel.formatValueText(textValue),
      verticalAlign: isHorizontal ? align : "middle",
      align: isHorizontal ? "center" : align
    });
    var indicatorNewProps = {
      x: x2,
      y: y2,
      style: {
        fill: color
      }
    };
    var labelNewProps = {
      style: {
        x: textPoint[0],
        y: textPoint[1]
      }
    };
    if (visualMapModel.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
      var animationCfg = {
        duration: 100,
        easing: "cubicInOut",
        additive: true
      };
      indicator.x = oldIndicatorPos.x;
      indicator.y = oldIndicatorPos.y;
      indicator.animateTo(indicatorNewProps, animationCfg);
      indicatorLabel.animateTo(labelNewProps, animationCfg);
    } else {
      indicator.attr(indicatorNewProps);
      indicatorLabel.attr(labelNewProps);
    }
    this._firstShowIndicator = false;
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.enterBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._enableHoverLinkToSeries = function() {
    var self2 = this;
    this._shapes.mainGroup.on("mousemove", function(e2) {
      self2._hovering = true;
      if (!self2._dragging) {
        var itemSize = self2.visualMapModel.itemSize;
        var pos = self2._applyTransform([e2.offsetX, e2.offsetY], self2._shapes.mainGroup, true, true);
        pos[1] = mathMin(mathMax(0, pos[1]), itemSize[1]);
        self2._doHoverLinkToSeries(pos[1], 0 <= pos[0] && pos[0] <= itemSize[0]);
      }
    }).on("mouseout", function() {
      self2._hovering = false;
      !self2._dragging && self2._clearHoverLinkToSeries();
    });
  };
  ContinuousView2.prototype._enableHoverLinkFromSeries = function() {
    var zr = this.api.getZr();
    if (this.visualMapModel.option.hoverLink) {
      zr.on("mouseover", this._hoverLinkFromSeriesMouseOver, this);
      zr.on("mouseout", this._hideIndicator, this);
    } else {
      this._clearHoverLinkFromSeries();
    }
  };
  ContinuousView2.prototype._doHoverLinkToSeries = function(cursorPos, hoverOnBar) {
    var visualMapModel = this.visualMapModel;
    var itemSize = visualMapModel.itemSize;
    if (!visualMapModel.option.hoverLink) {
      return;
    }
    var sizeExtent = [0, itemSize[1]];
    var dataExtent = visualMapModel.getExtent();
    cursorPos = mathMin(mathMax(sizeExtent[0], cursorPos), sizeExtent[1]);
    var halfHoverLinkSize = getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent);
    var hoverRange = [cursorPos - halfHoverLinkSize, cursorPos + halfHoverLinkSize];
    var cursorValue = linearMap(cursorPos, sizeExtent, dataExtent, true);
    var valueRange = [linearMap(hoverRange[0], sizeExtent, dataExtent, true), linearMap(hoverRange[1], sizeExtent, dataExtent, true)];
    hoverRange[0] < sizeExtent[0] && (valueRange[0] = -Infinity);
    hoverRange[1] > sizeExtent[1] && (valueRange[1] = Infinity);
    if (hoverOnBar) {
      if (valueRange[0] === -Infinity) {
        this._showIndicator(cursorValue, valueRange[1], "< ", halfHoverLinkSize);
      } else if (valueRange[1] === Infinity) {
        this._showIndicator(cursorValue, valueRange[0], "> ", halfHoverLinkSize);
      } else {
        this._showIndicator(cursorValue, cursorValue, "\u2248 ", halfHoverLinkSize);
      }
    }
    var oldBatch = this._hoverLinkDataIndices;
    var newBatch = [];
    if (hoverOnBar || useHoverLinkOnHandle(visualMapModel)) {
      newBatch = this._hoverLinkDataIndices = visualMapModel.findTargetDataIndices(valueRange);
    }
    var resultBatches = compressBatches(oldBatch, newBatch);
    this._dispatchHighDown("downplay", makeHighDownBatch(resultBatches[0], visualMapModel));
    this._dispatchHighDown("highlight", makeHighDownBatch(resultBatches[1], visualMapModel));
  };
  ContinuousView2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
    var el = e2.target;
    var visualMapModel = this.visualMapModel;
    if (!el || getECData(el).dataIndex == null) {
      return;
    }
    var ecData = getECData(el);
    var dataModel = this.ecModel.getSeriesByIndex(ecData.seriesIndex);
    if (!visualMapModel.isTargetSeries(dataModel)) {
      return;
    }
    var data2 = dataModel.getData(ecData.dataType);
    var value = data2.getStore().get(visualMapModel.getDataDimensionIndex(data2), ecData.dataIndex);
    if (!isNaN(value)) {
      this._showIndicator(value, value);
    }
  };
  ContinuousView2.prototype._hideIndicator = function() {
    var shapes = this._shapes;
    shapes.indicator && shapes.indicator.attr("invisible", true);
    shapes.indicatorLabel && shapes.indicatorLabel.attr("invisible", true);
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.leaveBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._clearHoverLinkToSeries = function() {
    this._hideIndicator();
    var indices = this._hoverLinkDataIndices;
    this._dispatchHighDown("downplay", makeHighDownBatch(indices, this.visualMapModel));
    indices.length = 0;
  };
  ContinuousView2.prototype._clearHoverLinkFromSeries = function() {
    this._hideIndicator();
    var zr = this.api.getZr();
    zr.off("mouseover", this._hoverLinkFromSeriesMouseOver);
    zr.off("mouseout", this._hideIndicator);
  };
  ContinuousView2.prototype._applyTransform = function(vertex, element, inverse, global2) {
    var transform2 = getTransform$1(element, global2 ? null : this.group);
    return isArray$2(vertex) ? applyTransform(vertex, transform2, inverse) : transformDirection(vertex, transform2, inverse);
  };
  ContinuousView2.prototype._dispatchHighDown = function(type4, batch) {
    batch && batch.length && this.api.dispatchAction({
      type: type4,
      batch
    });
  };
  ContinuousView2.prototype.dispose = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.prototype.remove = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.type = "visualMap.continuous";
  return ContinuousView2;
}(VisualMapView$1);
function createPolygon(points2, cursor, onDrift, onDragEnd) {
  return new Polygon$1({
    shape: {
      points: points2
    },
    draggable: !!onDrift,
    cursor,
    drift: onDrift,
    onmousemove: function(e2) {
      stop(e2.event);
    },
    ondragend: onDragEnd
  });
}
function getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent) {
  var halfHoverLinkSize = HOVER_LINK_SIZE / 2;
  var hoverLinkDataSize = visualMapModel.get("hoverLinkDataSize");
  if (hoverLinkDataSize) {
    halfHoverLinkSize = linearMap(hoverLinkDataSize, dataExtent, sizeExtent, true) / 2;
  }
  return halfHoverLinkSize;
}
function useHoverLinkOnHandle(visualMapModel) {
  var hoverLinkOnHandle = visualMapModel.get("hoverLinkOnHandle");
  return !!(hoverLinkOnHandle == null ? visualMapModel.get("realtime") : hoverLinkOnHandle);
}
function getCursor(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var ContinuousView$1 = ContinuousView;
var visualMapActionInfo = {
  type: "selectDataRange",
  event: "dataRangeSelected",
  update: "update"
};
var visualMapActionHander = function(payload, ecModel) {
  ecModel.eachComponent({
    mainType: "visualMap",
    query: payload
  }, function(model) {
    model.setSelected(payload.selected);
  });
};
var visualMapEncodingHandlers = [
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var resetDefines = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        var pipelineContext = seriesModel.pipelineContext;
        if (!visualMapModel.isTargetSeries(seriesModel) || pipelineContext && pipelineContext.large) {
          return;
        }
        resetDefines.push(incrementalApplyVisual(visualMapModel.stateList, visualMapModel.targetVisuals, bind$1(visualMapModel.getValueState, visualMapModel), visualMapModel.getDataDimensionIndex(seriesModel.getData())));
      });
      return resetDefines;
    }
  },
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var data2 = seriesModel.getData();
      var visualMetaList = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        if (visualMapModel.isTargetSeries(seriesModel)) {
          var visualMeta = visualMapModel.getVisualMeta(bind$1(getColorVisual, null, seriesModel, visualMapModel)) || {
            stops: [],
            outerColors: []
          };
          var dimIdx = visualMapModel.getDataDimensionIndex(data2);
          if (dimIdx >= 0) {
            visualMeta.dimension = dimIdx;
            visualMetaList.push(visualMeta);
          }
        }
      });
      seriesModel.getData().setVisual("visualMeta", visualMetaList);
    }
  }
];
function getColorVisual(seriesModel, visualMapModel, value, valueState) {
  var mappings = visualMapModel.targetVisuals[valueState];
  var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
  var resultVisual = {
    color: getVisualFromData(seriesModel.getData(), "color")
  };
  for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
    var type4 = visualTypes[i];
    var mapping = mappings[type4 === "opacity" ? "__alphaForOpacity" : type4];
    mapping && mapping.applyVisual(value, getVisual, setVisual);
  }
  return resultVisual.color;
  function getVisual(key) {
    return resultVisual[key];
  }
  function setVisual(key, value2) {
    resultVisual[key] = value2;
  }
}
var each$1 = each$g;
function visualMapPreprocessor(option) {
  var visualMap = option && option.visualMap;
  if (!isArray$2(visualMap)) {
    visualMap = visualMap ? [visualMap] : [];
  }
  each$1(visualMap, function(opt) {
    if (!opt) {
      return;
    }
    if (has$1(opt, "splitList") && !has$1(opt, "pieces")) {
      opt.pieces = opt.splitList;
      delete opt.splitList;
    }
    var pieces = opt.pieces;
    if (pieces && isArray$2(pieces)) {
      each$1(pieces, function(piece) {
        if (isObject$6(piece)) {
          if (has$1(piece, "start") && !has$1(piece, "min")) {
            piece.min = piece.start;
          }
          if (has$1(piece, "end") && !has$1(piece, "max")) {
            piece.max = piece.end;
          }
        }
      });
    }
  });
}
function has$1(obj, name2) {
  return obj && obj.hasOwnProperty && obj.hasOwnProperty(name2);
}
var installed = false;
function installCommon(registers) {
  if (installed) {
    return;
  }
  installed = true;
  registers.registerSubTypeDefaulter("visualMap", function(option) {
    return !option.categories && (!(option.pieces ? option.pieces.length > 0 : option.splitNumber > 0) || option.calculable) ? "continuous" : "piecewise";
  });
  registers.registerAction(visualMapActionInfo, visualMapActionHander);
  each$g(visualMapEncodingHandlers, function(handler) {
    registers.registerVisual(registers.PRIORITY.VISUAL.COMPONENT, handler);
  });
  registers.registerPreprocessor(visualMapPreprocessor);
}
function install$5(registers) {
  registers.registerComponentModel(ContinuousModel$1);
  registers.registerComponentView(ContinuousView$1);
  installCommon(registers);
}
var PiecewiseModel = function(_super) {
  __extends(PiecewiseModel2, _super);
  function PiecewiseModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseModel2.type;
    _this._pieceList = [];
    return _this;
  }
  PiecewiseModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    var mode = this._mode = this._determineMode();
    this._pieceList = [];
    resetMethods[this._mode].call(this, this._pieceList);
    this._resetSelected(newOption, isInit);
    var categories = this.option.categories;
    this.resetVisual(function(mappingOption, state) {
      if (mode === "categories") {
        mappingOption.mappingMethod = "category";
        mappingOption.categories = clone$4(categories);
      } else {
        mappingOption.dataExtent = this.getExtent();
        mappingOption.mappingMethod = "piecewise";
        mappingOption.pieceList = map$1(this._pieceList, function(piece) {
          piece = clone$4(piece);
          if (state !== "inRange") {
            piece.visual = null;
          }
          return piece;
        });
      }
    });
  };
  PiecewiseModel2.prototype.completeVisualOption = function() {
    var option = this.option;
    var visualTypesInPieces = {};
    var visualTypes = VisualMapping$1.listVisualTypes();
    var isCategory2 = this.isCategory();
    each$g(option.pieces, function(piece) {
      each$g(visualTypes, function(visualType) {
        if (piece.hasOwnProperty(visualType)) {
          visualTypesInPieces[visualType] = 1;
        }
      });
    });
    each$g(visualTypesInPieces, function(v4, visualType) {
      var exists = false;
      each$g(this.stateList, function(state) {
        exists = exists || has2(option, state, visualType) || has2(option.target, state, visualType);
      }, this);
      !exists && each$g(this.stateList, function(state) {
        (option[state] || (option[state] = {}))[visualType] = visualDefault$1.get(visualType, state === "inRange" ? "active" : "inactive", isCategory2);
      });
    }, this);
    function has2(obj, state, visualType) {
      return obj && obj[state] && obj[state].hasOwnProperty(visualType);
    }
    _super.prototype.completeVisualOption.apply(this, arguments);
  };
  PiecewiseModel2.prototype._resetSelected = function(newOption, isInit) {
    var thisOption = this.option;
    var pieceList = this._pieceList;
    var selected = (isInit ? thisOption : newOption).selected || {};
    thisOption.selected = selected;
    each$g(pieceList, function(piece, index2) {
      var key = this.getSelectedMapKey(piece);
      if (!selected.hasOwnProperty(key)) {
        selected[key] = true;
      }
    }, this);
    if (thisOption.selectedMode === "single") {
      var hasSel_1 = false;
      each$g(pieceList, function(piece, index2) {
        var key = this.getSelectedMapKey(piece);
        if (selected[key]) {
          hasSel_1 ? selected[key] = false : hasSel_1 = true;
        }
      }, this);
    }
  };
  PiecewiseModel2.prototype.getItemSymbol = function() {
    return this.get("itemSymbol");
  };
  PiecewiseModel2.prototype.getSelectedMapKey = function(piece) {
    return this._mode === "categories" ? piece.value + "" : piece.index + "";
  };
  PiecewiseModel2.prototype.getPieceList = function() {
    return this._pieceList;
  };
  PiecewiseModel2.prototype._determineMode = function() {
    var option = this.option;
    return option.pieces && option.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
  };
  PiecewiseModel2.prototype.setSelected = function(selected) {
    this.option.selected = clone$4(selected);
  };
  PiecewiseModel2.prototype.getValueState = function(value) {
    var index2 = VisualMapping$1.findPieceIndex(value, this._pieceList);
    return index2 != null ? this.option.selected[this.getSelectedMapKey(this._pieceList[index2])] ? "inRange" : "outOfRange" : "outOfRange";
  };
  PiecewiseModel2.prototype.findTargetDataIndices = function(pieceIndex) {
    var result = [];
    var pieceList = this._pieceList;
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data2 = seriesModel.getData();
      data2.each(this.getDataDimensionIndex(data2), function(value, dataIndex) {
        var pIdx = VisualMapping$1.findPieceIndex(value, pieceList);
        pIdx === pieceIndex && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  PiecewiseModel2.prototype.getRepresentValue = function(piece) {
    var representValue;
    if (this.isCategory()) {
      representValue = piece.value;
    } else {
      if (piece.value != null) {
        representValue = piece.value;
      } else {
        var pieceInterval = piece.interval || [];
        representValue = pieceInterval[0] === -Infinity && pieceInterval[1] === Infinity ? 0 : (pieceInterval[0] + pieceInterval[1]) / 2;
      }
    }
    return representValue;
  };
  PiecewiseModel2.prototype.getVisualMeta = function(getColorVisual2) {
    if (this.isCategory()) {
      return;
    }
    var stops = [];
    var outerColors = ["", ""];
    var visualMapModel = this;
    function setStop(interval, valueState) {
      var representValue = visualMapModel.getRepresentValue({
        interval
      });
      if (!valueState) {
        valueState = visualMapModel.getValueState(representValue);
      }
      var color = getColorVisual2(representValue, valueState);
      if (interval[0] === -Infinity) {
        outerColors[0] = color;
      } else if (interval[1] === Infinity) {
        outerColors[1] = color;
      } else {
        stops.push({
          value: interval[0],
          color
        }, {
          value: interval[1],
          color
        });
      }
    }
    var pieceList = this._pieceList.slice();
    if (!pieceList.length) {
      pieceList.push({
        interval: [-Infinity, Infinity]
      });
    } else {
      var edge = pieceList[0].interval[0];
      edge !== -Infinity && pieceList.unshift({
        interval: [-Infinity, edge]
      });
      edge = pieceList[pieceList.length - 1].interval[1];
      edge !== Infinity && pieceList.push({
        interval: [edge, Infinity]
      });
    }
    var curr = -Infinity;
    each$g(pieceList, function(piece) {
      var interval = piece.interval;
      if (interval) {
        interval[0] > curr && setStop([curr, interval[0]], "outOfRange");
        setStop(interval.slice());
        curr = interval[1];
      }
    }, this);
    return {
      stops,
      outerColors
    };
  };
  PiecewiseModel2.type = "visualMap.piecewise";
  PiecewiseModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    selected: null,
    minOpen: false,
    maxOpen: false,
    align: "auto",
    itemWidth: 20,
    itemHeight: 14,
    itemSymbol: "roundRect",
    pieces: null,
    categories: null,
    splitNumber: 5,
    selectedMode: "multiple",
    itemGap: 10,
    hoverLink: true
  });
  return PiecewiseModel2;
}(VisualMapModel$1);
var resetMethods = {
  splitNumber: function(outPieceList) {
    var thisOption = this.option;
    var precision = Math.min(thisOption.precision, 20);
    var dataExtent = this.getExtent();
    var splitNumber = thisOption.splitNumber;
    splitNumber = Math.max(parseInt(splitNumber, 10), 1);
    thisOption.splitNumber = splitNumber;
    var splitStep = (dataExtent[1] - dataExtent[0]) / splitNumber;
    while (+splitStep.toFixed(precision) !== splitStep && precision < 5) {
      precision++;
    }
    thisOption.precision = precision;
    splitStep = +splitStep.toFixed(precision);
    if (thisOption.minOpen) {
      outPieceList.push({
        interval: [-Infinity, dataExtent[0]],
        close: [0, 0]
      });
    }
    for (var index2 = 0, curr = dataExtent[0]; index2 < splitNumber; curr += splitStep, index2++) {
      var max3 = index2 === splitNumber - 1 ? dataExtent[1] : curr + splitStep;
      outPieceList.push({
        interval: [curr, max3],
        close: [1, 1]
      });
    }
    if (thisOption.maxOpen) {
      outPieceList.push({
        interval: [dataExtent[1], Infinity],
        close: [0, 0]
      });
    }
    reformIntervals(outPieceList);
    each$g(outPieceList, function(piece, index3) {
      piece.index = index3;
      piece.text = this.formatValueText(piece.interval);
    }, this);
  },
  categories: function(outPieceList) {
    var thisOption = this.option;
    each$g(thisOption.categories, function(cate) {
      outPieceList.push({
        text: this.formatValueText(cate, true),
        value: cate
      });
    }, this);
    normalizeReverse(thisOption, outPieceList);
  },
  pieces: function(outPieceList) {
    var thisOption = this.option;
    each$g(thisOption.pieces, function(pieceListItem, index2) {
      if (!isObject$6(pieceListItem)) {
        pieceListItem = {
          value: pieceListItem
        };
      }
      var item = {
        text: "",
        index: index2
      };
      if (pieceListItem.label != null) {
        item.text = pieceListItem.label;
      }
      if (pieceListItem.hasOwnProperty("value")) {
        var value = item.value = pieceListItem.value;
        item.interval = [value, value];
        item.close = [1, 1];
      } else {
        var interval = item.interval = [];
        var close_1 = item.close = [0, 0];
        var closeList = [1, 0, 1];
        var infinityList = [-Infinity, Infinity];
        var useMinMax = [];
        for (var lg2 = 0; lg2 < 2; lg2++) {
          var names2 = [["gte", "gt", "min"], ["lte", "lt", "max"]][lg2];
          for (var i = 0; i < 3 && interval[lg2] == null; i++) {
            interval[lg2] = pieceListItem[names2[i]];
            close_1[lg2] = closeList[i];
            useMinMax[lg2] = i === 2;
          }
          interval[lg2] == null && (interval[lg2] = infinityList[lg2]);
        }
        useMinMax[0] && interval[1] === Infinity && (close_1[0] = 0);
        useMinMax[1] && interval[0] === -Infinity && (close_1[1] = 0);
        if (interval[0] === interval[1] && close_1[0] && close_1[1]) {
          item.value = interval[0];
        }
      }
      item.visual = VisualMapping$1.retrieveVisuals(pieceListItem);
      outPieceList.push(item);
    }, this);
    normalizeReverse(thisOption, outPieceList);
    reformIntervals(outPieceList);
    each$g(outPieceList, function(piece) {
      var close = piece.close;
      var edgeSymbols = [["<", "\u2264"][close[1]], [">", "\u2265"][close[0]]];
      piece.text = piece.text || this.formatValueText(piece.value != null ? piece.value : piece.interval, false, edgeSymbols);
    }, this);
  }
};
function normalizeReverse(thisOption, pieceList) {
  var inverse = thisOption.inverse;
  if (thisOption.orient === "vertical" ? !inverse : inverse) {
    pieceList.reverse();
  }
}
var PiecewiseModel$1 = PiecewiseModel;
var PiecewiseVisualMapView = function(_super) {
  __extends(PiecewiseVisualMapView2, _super);
  function PiecewiseVisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseVisualMapView2.type;
    return _this;
  }
  PiecewiseVisualMapView2.prototype.doRender = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var textStyleModel = visualMapModel.textStyleModel;
    var textFont = textStyleModel.getFont();
    var textFill = textStyleModel.getTextColor();
    var itemAlign = this._getItemAlign();
    var itemSize = visualMapModel.itemSize;
    var viewData = this._getViewData();
    var endsText = viewData.endsText;
    var showLabel = retrieve(visualMapModel.get("showLabel", true), !endsText);
    endsText && this._renderEndsText(thisGroup, endsText[0], itemSize, showLabel, itemAlign);
    each$g(viewData.viewPieceList, function(item) {
      var piece = item.piece;
      var itemGroup = new Group$6();
      itemGroup.onclick = bind$1(this._onItemClick, this, piece);
      this._enableHoverLink(itemGroup, item.indexInModelPieceList);
      var representValue = visualMapModel.getRepresentValue(piece);
      this._createItemSymbol(itemGroup, representValue, [0, 0, itemSize[0], itemSize[1]]);
      if (showLabel) {
        var visualState = this.visualMapModel.getValueState(representValue);
        itemGroup.add(new ZRText$1({
          style: {
            x: itemAlign === "right" ? -textGap : itemSize[0] + textGap,
            y: itemSize[1] / 2,
            text: piece.text,
            verticalAlign: "middle",
            align: itemAlign,
            font: textFont,
            fill: textFill,
            opacity: visualState === "outOfRange" ? 0.5 : 1
          }
        }));
      }
      thisGroup.add(itemGroup);
    }, this);
    endsText && this._renderEndsText(thisGroup, endsText[1], itemSize, showLabel, itemAlign);
    box(visualMapModel.get("orient"), thisGroup, visualMapModel.get("itemGap"));
    this.renderBackground(thisGroup);
    this.positionGroup(thisGroup);
  };
  PiecewiseVisualMapView2.prototype._enableHoverLink = function(itemGroup, pieceIndex) {
    var _this = this;
    itemGroup.on("mouseover", function() {
      return onHoverLink("highlight");
    }).on("mouseout", function() {
      return onHoverLink("downplay");
    });
    var onHoverLink = function(method4) {
      var visualMapModel = _this.visualMapModel;
      visualMapModel.option.hoverLink && _this.api.dispatchAction({
        type: method4,
        batch: makeHighDownBatch(visualMapModel.findTargetDataIndices(pieceIndex), visualMapModel)
      });
    };
  };
  PiecewiseVisualMapView2.prototype._getItemAlign = function() {
    var visualMapModel = this.visualMapModel;
    var modelOption = visualMapModel.option;
    if (modelOption.orient === "vertical") {
      return getItemAlign(visualMapModel, this.api, visualMapModel.itemSize);
    } else {
      var align = modelOption.align;
      if (!align || align === "auto") {
        align = "left";
      }
      return align;
    }
  };
  PiecewiseVisualMapView2.prototype._renderEndsText = function(group, text, itemSize, showLabel, itemAlign) {
    if (!text) {
      return;
    }
    var itemGroup = new Group$6();
    var textStyleModel = this.visualMapModel.textStyleModel;
    itemGroup.add(new ZRText$1({
      style: {
        x: showLabel ? itemAlign === "right" ? itemSize[0] : 0 : itemSize[0] / 2,
        y: itemSize[1] / 2,
        verticalAlign: "middle",
        align: showLabel ? itemAlign : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
    group.add(itemGroup);
  };
  PiecewiseVisualMapView2.prototype._getViewData = function() {
    var visualMapModel = this.visualMapModel;
    var viewPieceList = map$1(visualMapModel.getPieceList(), function(piece, index2) {
      return {
        piece,
        indexInModelPieceList: index2
      };
    });
    var endsText = visualMapModel.get("text");
    var orient = visualMapModel.get("orient");
    var inverse = visualMapModel.get("inverse");
    if (orient === "horizontal" ? inverse : !inverse) {
      viewPieceList.reverse();
    } else if (endsText) {
      endsText = endsText.slice().reverse();
    }
    return {
      viewPieceList,
      endsText
    };
  };
  PiecewiseVisualMapView2.prototype._createItemSymbol = function(group, representValue, shapeParam) {
    group.add(createSymbol$1(this.getControllerVisual(representValue, "symbol"), shapeParam[0], shapeParam[1], shapeParam[2], shapeParam[3], this.getControllerVisual(representValue, "color")));
  };
  PiecewiseVisualMapView2.prototype._onItemClick = function(piece) {
    var visualMapModel = this.visualMapModel;
    var option = visualMapModel.option;
    var selected = clone$4(option.selected);
    var newKey = visualMapModel.getSelectedMapKey(piece);
    if (option.selectedMode === "single") {
      selected[newKey] = true;
      each$g(selected, function(o, key) {
        selected[key] = key === newKey;
      });
    } else {
      selected[newKey] = !selected[newKey];
    }
    this.api.dispatchAction({
      type: "selectDataRange",
      from: this.uid,
      visualMapId: this.visualMapModel.id,
      selected
    });
  };
  PiecewiseVisualMapView2.type = "visualMap.piecewise";
  return PiecewiseVisualMapView2;
}(VisualMapView$1);
var PiecewiseView = PiecewiseVisualMapView;
function install$4(registers) {
  registers.registerComponentModel(PiecewiseModel$1);
  registers.registerComponentView(PiecewiseView);
  installCommon(registers);
}
function install$3(registers) {
  use(install$5);
  use(install$4);
}
var DEFAULT_OPTION = {
  label: {
    enabled: true
  },
  decal: {
    show: false
  }
};
var inner = makeInner();
var decalPaletteScope = {};
function ariaVisual(ecModel, api) {
  var ariaModel = ecModel.getModel("aria");
  if (!ariaModel.get("enabled")) {
    return;
  }
  var defaultOption2 = clone$4(DEFAULT_OPTION);
  merge$1(defaultOption2.label, ecModel.getLocaleModel().get("aria"), false);
  merge$1(ariaModel.option, defaultOption2, false);
  setDecal();
  setLabel();
  function setDecal() {
    var decalModel = ariaModel.getModel("decal");
    var useDecal = decalModel.get("show");
    if (useDecal) {
      var paletteScopeGroupByType_1 = createHashMap();
      ecModel.eachSeries(function(seriesModel) {
        if (seriesModel.isColorBySeries()) {
          return;
        }
        var decalScope = paletteScopeGroupByType_1.get(seriesModel.type);
        if (!decalScope) {
          decalScope = {};
          paletteScopeGroupByType_1.set(seriesModel.type, decalScope);
        }
        inner(seriesModel).scope = decalScope;
      });
      ecModel.eachRawSeries(function(seriesModel) {
        if (ecModel.isSeriesFiltered(seriesModel)) {
          return;
        }
        if (isFunction$1(seriesModel.enableAriaDecal)) {
          seriesModel.enableAriaDecal();
          return;
        }
        var data2 = seriesModel.getData();
        if (!seriesModel.isColorBySeries()) {
          var dataAll_1 = seriesModel.getRawData();
          var idxMap_1 = {};
          var decalScope_1 = inner(seriesModel).scope;
          data2.each(function(idx) {
            var rawIdx = data2.getRawIndex(idx);
            idxMap_1[rawIdx] = idx;
          });
          var dataCount_1 = dataAll_1.count();
          dataAll_1.each(function(rawIdx) {
            var idx = idxMap_1[rawIdx];
            var name2 = dataAll_1.getName(rawIdx) || rawIdx + "";
            var paletteDecal2 = getDecalFromPalette(seriesModel.ecModel, name2, decalScope_1, dataCount_1);
            var specifiedDecal2 = data2.getItemVisual(idx, "decal");
            data2.setItemVisual(idx, "decal", mergeDecal(specifiedDecal2, paletteDecal2));
          });
        } else {
          var paletteDecal = getDecalFromPalette(seriesModel.ecModel, seriesModel.name, decalPaletteScope, ecModel.getSeriesCount());
          var specifiedDecal = data2.getVisual("decal");
          data2.setVisual("decal", mergeDecal(specifiedDecal, paletteDecal));
        }
        function mergeDecal(specifiedDecal2, paletteDecal2) {
          var resultDecal = specifiedDecal2 ? extend(extend({}, paletteDecal2), specifiedDecal2) : paletteDecal2;
          resultDecal.dirty = true;
          return resultDecal;
        }
      });
    }
  }
  function setLabel() {
    var labelLocale = ecModel.getLocaleModel().get("aria");
    var labelModel = ariaModel.getModel("label");
    labelModel.option = defaults(labelModel.option, labelLocale);
    if (!labelModel.get("enabled")) {
      return;
    }
    var dom = api.getZr().dom;
    if (labelModel.get("description")) {
      dom.setAttribute("aria-label", labelModel.get("description"));
      return;
    }
    var seriesCnt = ecModel.getSeriesCount();
    var maxDataCnt = labelModel.get(["data", "maxCount"]) || 10;
    var maxSeriesCnt = labelModel.get(["series", "maxCount"]) || 10;
    var displaySeriesCnt = Math.min(seriesCnt, maxSeriesCnt);
    var ariaLabel;
    if (seriesCnt < 1) {
      return;
    } else {
      var title = getTitle();
      if (title) {
        var withTitle = labelModel.get(["general", "withTitle"]);
        ariaLabel = replace(withTitle, {
          title
        });
      } else {
        ariaLabel = labelModel.get(["general", "withoutTitle"]);
      }
      var seriesLabels_1 = [];
      var prefix = seriesCnt > 1 ? labelModel.get(["series", "multiple", "prefix"]) : labelModel.get(["series", "single", "prefix"]);
      ariaLabel += replace(prefix, {
        seriesCount: seriesCnt
      });
      ecModel.eachSeries(function(seriesModel, idx) {
        if (idx < displaySeriesCnt) {
          var seriesLabel = void 0;
          var seriesName = seriesModel.get("name");
          var withName = seriesName ? "withName" : "withoutName";
          seriesLabel = seriesCnt > 1 ? labelModel.get(["series", "multiple", withName]) : labelModel.get(["series", "single", withName]);
          seriesLabel = replace(seriesLabel, {
            seriesId: seriesModel.seriesIndex,
            seriesName: seriesModel.get("name"),
            seriesType: getSeriesTypeName(seriesModel.subType)
          });
          var data2 = seriesModel.getData();
          if (data2.count() > maxDataCnt) {
            var partialLabel = labelModel.get(["data", "partialData"]);
            seriesLabel += replace(partialLabel, {
              displayCnt: maxDataCnt
            });
          } else {
            seriesLabel += labelModel.get(["data", "allData"]);
          }
          var middleSeparator_1 = labelModel.get(["data", "separator", "middle"]);
          var endSeparator_1 = labelModel.get(["data", "separator", "end"]);
          var dataLabels = [];
          for (var i = 0; i < data2.count(); i++) {
            if (i < maxDataCnt) {
              var name_1 = data2.getName(i);
              var value = data2.getValues(i);
              var dataLabel = labelModel.get(["data", name_1 ? "withName" : "withoutName"]);
              dataLabels.push(replace(dataLabel, {
                name: name_1,
                value: value.join(middleSeparator_1)
              }));
            }
          }
          seriesLabel += dataLabels.join(middleSeparator_1) + endSeparator_1;
          seriesLabels_1.push(seriesLabel);
        }
      });
      var separatorModel = labelModel.getModel(["series", "multiple", "separator"]);
      var middleSeparator = separatorModel.get("middle");
      var endSeparator = separatorModel.get("end");
      ariaLabel += seriesLabels_1.join(middleSeparator) + endSeparator;
      dom.setAttribute("aria-label", ariaLabel);
    }
  }
  function replace(str, keyValues) {
    if (!isString$1(str)) {
      return str;
    }
    var result = str;
    each$g(keyValues, function(value, key) {
      result = result.replace(new RegExp("\\{\\s*" + key + "\\s*\\}", "g"), value);
    });
    return result;
  }
  function getTitle() {
    var title = ecModel.get("title");
    if (title && title.length) {
      title = title[0];
    }
    return title && title.text;
  }
  function getSeriesTypeName(type4) {
    return ecModel.getLocaleModel().get(["series", "typeNames"])[type4] || "\u81EA\u5B9A\u4E49\u56FE";
  }
}
function ariaPreprocessor(option) {
  if (!option || !option.aria) {
    return;
  }
  var aria = option.aria;
  if (aria.show != null) {
    aria.enabled = aria.show;
  }
  aria.label = aria.label || {};
  each$g(["description", "general", "series", "data"], function(name2) {
    if (aria[name2] != null) {
      aria.label[name2] = aria[name2];
    }
  });
}
function install$2(registers) {
  registers.registerPreprocessor(ariaPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.ARIA, ariaVisual);
}
var RELATIONAL_EXPRESSION_OP_ALIAS_MAP = {
  value: "eq",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  "=": "eq",
  "!=": "ne",
  "<>": "ne"
};
var RegExpEvaluator = function() {
  function RegExpEvaluator2(rVal) {
    var condValue = this._condVal = isString$1(rVal) ? new RegExp(rVal) : isRegExp(rVal) ? rVal : null;
    if (condValue == null) {
      var errMsg = "";
      throwError$2(errMsg);
    }
  }
  RegExpEvaluator2.prototype.evaluate = function(lVal) {
    var type4 = typeof lVal;
    return isString$1(type4) ? this._condVal.test(lVal) : isNumber(type4) ? this._condVal.test(lVal + "") : false;
  };
  return RegExpEvaluator2;
}();
var ConstConditionInternal = function() {
  function ConstConditionInternal2() {
  }
  ConstConditionInternal2.prototype.evaluate = function() {
    return this.value;
  };
  return ConstConditionInternal2;
}();
var AndConditionInternal = function() {
  function AndConditionInternal2() {
  }
  AndConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (!children[i].evaluate()) {
        return false;
      }
    }
    return true;
  };
  return AndConditionInternal2;
}();
var OrConditionInternal = function() {
  function OrConditionInternal2() {
  }
  OrConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].evaluate()) {
        return true;
      }
    }
    return false;
  };
  return OrConditionInternal2;
}();
var NotConditionInternal = function() {
  function NotConditionInternal2() {
  }
  NotConditionInternal2.prototype.evaluate = function() {
    return !this.child.evaluate();
  };
  return NotConditionInternal2;
}();
var RelationalConditionInternal = function() {
  function RelationalConditionInternal2() {
  }
  RelationalConditionInternal2.prototype.evaluate = function() {
    var needParse = !!this.valueParser;
    var getValue2 = this.getValue;
    var tarValRaw = getValue2(this.valueGetterParam);
    var tarValParsed = needParse ? this.valueParser(tarValRaw) : null;
    for (var i = 0; i < this.subCondList.length; i++) {
      if (!this.subCondList[i].evaluate(needParse ? tarValParsed : tarValRaw)) {
        return false;
      }
    }
    return true;
  };
  return RelationalConditionInternal2;
}();
function parseOption(exprOption, getters) {
  if (exprOption === true || exprOption === false) {
    var cond = new ConstConditionInternal();
    cond.value = exprOption;
    return cond;
  }
  var errMsg = "";
  if (!isObjectNotArray(exprOption)) {
    throwError$2(errMsg);
  }
  if (exprOption.and) {
    return parseAndOrOption("and", exprOption, getters);
  } else if (exprOption.or) {
    return parseAndOrOption("or", exprOption, getters);
  } else if (exprOption.not) {
    return parseNotOption(exprOption, getters);
  }
  return parseRelationalOption(exprOption, getters);
}
function parseAndOrOption(op, exprOption, getters) {
  var subOptionArr = exprOption[op];
  var errMsg = "";
  if (!isArray$2(subOptionArr)) {
    throwError$2(errMsg);
  }
  if (!subOptionArr.length) {
    throwError$2(errMsg);
  }
  var cond = op === "and" ? new AndConditionInternal() : new OrConditionInternal();
  cond.children = map$1(subOptionArr, function(subOption) {
    return parseOption(subOption, getters);
  });
  if (!cond.children.length) {
    throwError$2(errMsg);
  }
  return cond;
}
function parseNotOption(exprOption, getters) {
  var subOption = exprOption.not;
  var errMsg = "";
  if (!isObjectNotArray(subOption)) {
    throwError$2(errMsg);
  }
  var cond = new NotConditionInternal();
  cond.child = parseOption(subOption, getters);
  if (!cond.child) {
    throwError$2(errMsg);
  }
  return cond;
}
function parseRelationalOption(exprOption, getters) {
  var errMsg = "";
  var valueGetterParam = getters.prepareGetValue(exprOption);
  var subCondList = [];
  var exprKeys = keys(exprOption);
  var parserName = exprOption.parser;
  var valueParser = parserName ? getRawValueParser(parserName) : null;
  for (var i = 0; i < exprKeys.length; i++) {
    var keyRaw = exprKeys[i];
    if (keyRaw === "parser" || getters.valueGetterAttrMap.get(keyRaw)) {
      continue;
    }
    var op = hasOwn$1(RELATIONAL_EXPRESSION_OP_ALIAS_MAP, keyRaw) ? RELATIONAL_EXPRESSION_OP_ALIAS_MAP[keyRaw] : keyRaw;
    var condValueRaw = exprOption[keyRaw];
    var condValueParsed = valueParser ? valueParser(condValueRaw) : condValueRaw;
    var evaluator = createFilterComparator(op, condValueParsed) || op === "reg" && new RegExpEvaluator(condValueParsed);
    if (!evaluator) {
      throwError$2(errMsg);
    }
    subCondList.push(evaluator);
  }
  if (!subCondList.length) {
    throwError$2(errMsg);
  }
  var cond = new RelationalConditionInternal();
  cond.valueGetterParam = valueGetterParam;
  cond.valueParser = valueParser;
  cond.getValue = getters.getValue;
  cond.subCondList = subCondList;
  return cond;
}
function isObjectNotArray(val) {
  return isObject$6(val) && !isArrayLike(val);
}
var ConditionalExpressionParsed = function() {
  function ConditionalExpressionParsed2(exprOption, getters) {
    this._cond = parseOption(exprOption, getters);
  }
  ConditionalExpressionParsed2.prototype.evaluate = function() {
    return this._cond.evaluate();
  };
  return ConditionalExpressionParsed2;
}();
function parseConditionalExpression(exprOption, getters) {
  return new ConditionalExpressionParsed(exprOption, getters);
}
var filterTransform = {
  type: "echarts:filter",
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = parseConditionalExpression(params.config, {
      valueGetterAttrMap: createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!hasOwn$1(exprOption, "dimension")) {
          throwError$2(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          throwError$2(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
var sortTransform = {
  type: "echarts:sort",
  transform: function(params) {
    var upstream = params.upstream;
    var config2 = params.config;
    var errMsg = "";
    var orderExprList = normalizeToArray(config2);
    if (!orderExprList.length) {
      throwError$2(errMsg);
    }
    var orderDefList = [];
    each$g(orderExprList, function(orderExpr) {
      var dimLoose = orderExpr.dimension;
      var order = orderExpr.order;
      var parserName = orderExpr.parser;
      var incomparable = orderExpr.incomparable;
      if (dimLoose == null) {
        throwError$2(errMsg);
      }
      if (order !== "asc" && order !== "desc") {
        throwError$2(errMsg);
      }
      if (incomparable && incomparable !== "min" && incomparable !== "max") {
        var errMsg_1 = "";
        throwError$2(errMsg_1);
      }
      if (order !== "asc" && order !== "desc") {
        var errMsg_2 = "";
        throwError$2(errMsg_2);
      }
      var dimInfo = upstream.getDimensionInfo(dimLoose);
      if (!dimInfo) {
        throwError$2(errMsg);
      }
      var parser = parserName ? getRawValueParser(parserName) : null;
      if (parserName && !parser) {
        throwError$2(errMsg);
      }
      orderDefList.push({
        dimIdx: dimInfo.index,
        parser,
        comparator: new SortOrderComparator(order, incomparable)
      });
    });
    var sourceFormat = upstream.sourceFormat;
    if (sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS && sourceFormat !== SOURCE_FORMAT_OBJECT_ROWS) {
      throwError$2(errMsg);
    }
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      resultData.push(upstream.getRawDataItem(i));
    }
    resultData.sort(function(item0, item1) {
      for (var i2 = 0; i2 < orderDefList.length; i2++) {
        var orderDef = orderDefList[i2];
        var val0 = upstream.retrieveValueFromItem(item0, orderDef.dimIdx);
        var val1 = upstream.retrieveValueFromItem(item1, orderDef.dimIdx);
        if (orderDef.parser) {
          val0 = orderDef.parser(val0);
          val1 = orderDef.parser(val1);
        }
        var result = orderDef.comparator.evaluate(val0, val1);
        if (result !== 0) {
          return result;
        }
      }
      return 0;
    });
    return {
      data: resultData
    };
  }
};
function install$1(registers) {
  registers.registerTransform(filterTransform);
  registers.registerTransform(sortTransform);
}
var DatasetModel = function(_super) {
  __extends(DatasetModel2, _super);
  function DatasetModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetModel2.prototype.init = function(option, parentModel, ecModel) {
    _super.prototype.init.call(this, option, parentModel, ecModel);
    this._sourceManager = new SourceManager(this);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.mergeOption = function(newOption, ecModel) {
    _super.prototype.mergeOption.call(this, newOption, ecModel);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.optionUpdated = function() {
    this._sourceManager.dirty();
  };
  DatasetModel2.prototype.getSourceManager = function() {
    return this._sourceManager;
  };
  DatasetModel2.type = "dataset";
  DatasetModel2.defaultOption = {
    seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN
  };
  return DatasetModel2;
}(ComponentModel$1);
var DatasetView = function(_super) {
  __extends(DatasetView2, _super);
  function DatasetView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetView2.type = "dataset";
  return DatasetView2;
}(ComponentView$1);
function install(registers) {
  registers.registerComponentModel(DatasetModel);
  registers.registerComponentView(DatasetView);
}
var CMD = PathProxy$1.CMD;
function aroundEqual(a, b2) {
  return Math.abs(a - b2) < 1e-5;
}
function pathToBezierCurves(path) {
  var data2 = path.data;
  var len2 = path.len();
  var bezierArrayGroups = [];
  var currentSubpath;
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  function createNewSubpath(x3, y3) {
    if (currentSubpath && currentSubpath.length > 2) {
      bezierArrayGroups.push(currentSubpath);
    }
    currentSubpath = [x3, y3];
  }
  function addLine(x02, y02, x12, y12) {
    if (!(aroundEqual(x02, x12) && aroundEqual(y02, y12))) {
      currentSubpath.push(x02, y02, x12, y12, x12, y12);
    }
  }
  function addArc(startAngle2, endAngle2, cx2, cy2, rx2, ry2) {
    var delta = Math.abs(endAngle2 - startAngle2);
    var len3 = Math.tan(delta / 4) * 4 / 3;
    var dir3 = endAngle2 < startAngle2 ? -1 : 1;
    var c1 = Math.cos(startAngle2);
    var s1 = Math.sin(startAngle2);
    var c2 = Math.cos(endAngle2);
    var s2 = Math.sin(endAngle2);
    var x12 = c1 * rx2 + cx2;
    var y12 = s1 * ry2 + cy2;
    var x4 = c2 * rx2 + cx2;
    var y4 = s2 * ry2 + cy2;
    var hx = rx2 * len3 * dir3;
    var hy = ry2 * len3 * dir3;
    currentSubpath.push(x12 - hx * s1, y12 + hy * c1, x4 + hx * s2, y4 - hy * c2, x4, y4);
  }
  var x1;
  var y1;
  var x2;
  var y2;
  for (var i = 0; i < len2; ) {
    var cmd = data2[i++];
    var isFirst = i === 1;
    if (isFirst) {
      xi2 = data2[i];
      yi2 = data2[i + 1];
      x0 = xi2;
      y0 = yi2;
      if (cmd === CMD.L || cmd === CMD.C || cmd === CMD.Q) {
        currentSubpath = [x0, y0];
      }
    }
    switch (cmd) {
      case CMD.M:
        xi2 = x0 = data2[i++];
        yi2 = y0 = data2[i++];
        createNewSubpath(x0, y0);
        break;
      case CMD.L:
        x1 = data2[i++];
        y1 = data2[i++];
        addLine(xi2, yi2, x1, y1);
        xi2 = x1;
        yi2 = y1;
        break;
      case CMD.C:
        currentSubpath.push(data2[i++], data2[i++], data2[i++], data2[i++], xi2 = data2[i++], yi2 = data2[i++]);
        break;
      case CMD.Q:
        x1 = data2[i++];
        y1 = data2[i++];
        x2 = data2[i++];
        y2 = data2[i++];
        currentSubpath.push(xi2 + 2 / 3 * (x1 - xi2), yi2 + 2 / 3 * (y1 - yi2), x2 + 2 / 3 * (x1 - x2), y2 + 2 / 3 * (y1 - y2), x2, y2);
        xi2 = x2;
        yi2 = y2;
        break;
      case CMD.A:
        var cx = data2[i++];
        var cy = data2[i++];
        var rx = data2[i++];
        var ry = data2[i++];
        var startAngle = data2[i++];
        var endAngle = data2[i++] + startAngle;
        i += 1;
        var anticlockwise = !data2[i++];
        x1 = Math.cos(startAngle) * rx + cx;
        y1 = Math.sin(startAngle) * ry + cy;
        if (isFirst) {
          x0 = x1;
          y0 = y1;
          createNewSubpath(x0, y0);
        } else {
          addLine(xi2, yi2, x1, y1);
        }
        xi2 = Math.cos(endAngle) * rx + cx;
        yi2 = Math.sin(endAngle) * ry + cy;
        var step = (anticlockwise ? -1 : 1) * Math.PI / 2;
        for (var angle = startAngle; anticlockwise ? angle > endAngle : angle < endAngle; angle += step) {
          var nextAngle = anticlockwise ? Math.max(angle + step, endAngle) : Math.min(angle + step, endAngle);
          addArc(angle, nextAngle, cx, cy, rx, ry);
        }
        break;
      case CMD.R:
        x0 = xi2 = data2[i++];
        y0 = yi2 = data2[i++];
        x1 = x0 + data2[i++];
        y1 = y0 + data2[i++];
        createNewSubpath(x1, y0);
        addLine(x1, y0, x1, y1);
        addLine(x1, y1, x0, y1);
        addLine(x0, y1, x0, y0);
        addLine(x0, y0, x1, y0);
        break;
      case CMD.Z:
        currentSubpath && addLine(xi2, yi2, x0, y0);
        xi2 = x0;
        yi2 = y0;
        break;
    }
  }
  if (currentSubpath && currentSubpath.length > 2) {
    bezierArrayGroups.push(currentSubpath);
  }
  return bezierArrayGroups;
}
function adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, out2, scale2) {
  if (aroundEqual(x0, x1) && aroundEqual(y0, y1) && aroundEqual(x2, x3) && aroundEqual(y2, y3)) {
    out2.push(x3, y3);
    return;
  }
  var PIXEL_DISTANCE = 2 / scale2;
  var PIXEL_DISTANCE_SQR = PIXEL_DISTANCE * PIXEL_DISTANCE;
  var dx = x3 - x0;
  var dy = y3 - y0;
  var d2 = Math.sqrt(dx * dx + dy * dy);
  dx /= d2;
  dy /= d2;
  var dx1 = x1 - x0;
  var dy1 = y1 - y0;
  var dx2 = x2 - x3;
  var dy2 = y2 - y3;
  var cp1LenSqr = dx1 * dx1 + dy1 * dy1;
  var cp2LenSqr = dx2 * dx2 + dy2 * dy2;
  if (cp1LenSqr < PIXEL_DISTANCE_SQR && cp2LenSqr < PIXEL_DISTANCE_SQR) {
    out2.push(x3, y3);
    return;
  }
  var projLen1 = dx * dx1 + dy * dy1;
  var projLen2 = -dx * dx2 - dy * dy2;
  var d1Sqr = cp1LenSqr - projLen1 * projLen1;
  var d2Sqr = cp2LenSqr - projLen2 * projLen2;
  if (d1Sqr < PIXEL_DISTANCE_SQR && projLen1 >= 0 && d2Sqr < PIXEL_DISTANCE_SQR && projLen2 >= 0) {
    out2.push(x3, y3);
    return;
  }
  var tmpSegX = [];
  var tmpSegY = [];
  cubicSubdivide(x0, x1, x2, x3, 0.5, tmpSegX);
  cubicSubdivide(y0, y1, y2, y3, 0.5, tmpSegY);
  adpativeBezier(tmpSegX[0], tmpSegY[0], tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], tmpSegX[3], tmpSegY[3], out2, scale2);
  adpativeBezier(tmpSegX[4], tmpSegY[4], tmpSegX[5], tmpSegY[5], tmpSegX[6], tmpSegY[6], tmpSegX[7], tmpSegY[7], out2, scale2);
}
function pathToPolygons(path, scale2) {
  var bezierArrayGroups = pathToBezierCurves(path);
  var polygons = [];
  scale2 = scale2 || 1;
  for (var i = 0; i < bezierArrayGroups.length; i++) {
    var beziers = bezierArrayGroups[i];
    var polygon = [];
    var x0 = beziers[0];
    var y0 = beziers[1];
    polygon.push(x0, y0);
    for (var k2 = 2; k2 < beziers.length; ) {
      var x1 = beziers[k2++];
      var y1 = beziers[k2++];
      var x2 = beziers[k2++];
      var y2 = beziers[k2++];
      var x3 = beziers[k2++];
      var y3 = beziers[k2++];
      adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, polygon, scale2);
      x0 = x3;
      y0 = y3;
    }
    polygons.push(polygon);
  }
  return polygons;
}
function getDividingGrids(dimSize, rowDim, count2) {
  var rowSize = dimSize[rowDim];
  var columnSize = dimSize[1 - rowDim];
  var ratio = Math.abs(rowSize / columnSize);
  var rowCount = Math.ceil(Math.sqrt(ratio * count2));
  var columnCount = Math.floor(count2 / rowCount);
  if (columnCount === 0) {
    columnCount = 1;
    rowCount = count2;
  }
  var grids = [];
  for (var i = 0; i < rowCount; i++) {
    grids.push(columnCount);
  }
  var currentCount = rowCount * columnCount;
  var remained = count2 - currentCount;
  if (remained > 0) {
    for (var i = 0; i < remained; i++) {
      grids[i % rowCount] += 1;
    }
  }
  return grids;
}
function divideSector(sectorShape, count2, outShapes) {
  var r0 = sectorShape.r0;
  var r2 = sectorShape.r;
  var startAngle = sectorShape.startAngle;
  var endAngle = sectorShape.endAngle;
  var angle = Math.abs(endAngle - startAngle);
  var arcLen = angle * r2;
  var deltaR = r2 - r0;
  var isAngleRow = arcLen > Math.abs(deltaR);
  var grids = getDividingGrids([arcLen, deltaR], isAngleRow ? 0 : 1, count2);
  var rowSize = (isAngleRow ? angle : deltaR) / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = (isAngleRow ? deltaR : angle) / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      if (isAngleRow) {
        newShape.startAngle = startAngle + rowSize * row;
        newShape.endAngle = startAngle + rowSize * (row + 1);
        newShape.r0 = r0 + columnSize * column;
        newShape.r = r0 + columnSize * (column + 1);
      } else {
        newShape.startAngle = startAngle + columnSize * column;
        newShape.endAngle = startAngle + columnSize * (column + 1);
        newShape.r0 = r0 + rowSize * row;
        newShape.r = r0 + rowSize * (row + 1);
      }
      newShape.clockwise = sectorShape.clockwise;
      newShape.cx = sectorShape.cx;
      newShape.cy = sectorShape.cy;
      outShapes.push(newShape);
    }
  }
}
function divideRect(rectShape, count2, outShapes) {
  var width = rectShape.width;
  var height = rectShape.height;
  var isHorizontalRow = width > height;
  var grids = getDividingGrids([width, height], isHorizontalRow ? 0 : 1, count2);
  var rowSizeDim = isHorizontalRow ? "width" : "height";
  var columnSizeDim = isHorizontalRow ? "height" : "width";
  var rowDim = isHorizontalRow ? "x" : "y";
  var columnDim = isHorizontalRow ? "y" : "x";
  var rowSize = rectShape[rowSizeDim] / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = rectShape[columnSizeDim] / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      newShape[rowDim] = row * rowSize;
      newShape[columnDim] = column * columnSize;
      newShape[rowSizeDim] = rowSize;
      newShape[columnSizeDim] = columnSize;
      newShape.x += rectShape.x;
      newShape.y += rectShape.y;
      outShapes.push(newShape);
    }
  }
}
function crossProduct2d(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function lineLineIntersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d(nx, ny, mx, my);
  if (Math.abs(nmCrossProduct) < 1e-6) {
    return null;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var p2 = crossProduct2d(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return null;
  }
  return new Point$1(p2 * mx + a1x, p2 * my + a1y);
}
function projPtOnLine(pt, lineA, lineB) {
  var dir3 = new Point$1();
  Point$1.sub(dir3, lineB, lineA);
  dir3.normalize();
  var dir22 = new Point$1();
  Point$1.sub(dir22, pt, lineA);
  var len2 = dir22.dot(dir3);
  return len2;
}
function addToPoly(poly, pt) {
  var last = poly[poly.length - 1];
  if (last && last[0] === pt[0] && last[1] === pt[1]) {
    return;
  }
  poly.push(pt);
}
function splitPolygonByLine(points2, lineA, lineB) {
  var len2 = points2.length;
  var intersections = [];
  for (var i = 0; i < len2; i++) {
    var p0 = points2[i];
    var p1 = points2[(i + 1) % len2];
    var intersectionPt = lineLineIntersect(p0[0], p0[1], p1[0], p1[1], lineA.x, lineA.y, lineB.x, lineB.y);
    if (intersectionPt) {
      intersections.push({
        projPt: projPtOnLine(intersectionPt, lineA, lineB),
        pt: intersectionPt,
        idx: i
      });
    }
  }
  if (intersections.length < 2) {
    return [{ points: points2 }, { points: points2 }];
  }
  intersections.sort(function(a, b2) {
    return a.projPt - b2.projPt;
  });
  var splitPt0 = intersections[0];
  var splitPt1 = intersections[intersections.length - 1];
  if (splitPt1.idx < splitPt0.idx) {
    var tmp = splitPt0;
    splitPt0 = splitPt1;
    splitPt1 = tmp;
  }
  var splitPt0Arr = [splitPt0.pt.x, splitPt0.pt.y];
  var splitPt1Arr = [splitPt1.pt.x, splitPt1.pt.y];
  var newPolyA = [splitPt0Arr];
  var newPolyB = [splitPt1Arr];
  for (var i = splitPt0.idx + 1; i <= splitPt1.idx; i++) {
    addToPoly(newPolyA, points2[i].slice());
  }
  addToPoly(newPolyA, splitPt1Arr);
  addToPoly(newPolyA, splitPt0Arr);
  for (var i = splitPt1.idx + 1; i <= splitPt0.idx + len2; i++) {
    addToPoly(newPolyB, points2[i % len2].slice());
  }
  addToPoly(newPolyB, splitPt0Arr);
  addToPoly(newPolyB, splitPt1Arr);
  return [{
    points: newPolyA
  }, {
    points: newPolyB
  }];
}
function binaryDividePolygon(polygonShape) {
  var points2 = polygonShape.points;
  var min3 = [];
  var max3 = [];
  fromPoints(points2, min3, max3);
  var boundingRect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
  var width = boundingRect.width;
  var height = boundingRect.height;
  var x2 = boundingRect.x;
  var y2 = boundingRect.y;
  var pt02 = new Point$1();
  var pt12 = new Point$1();
  if (width > height) {
    pt02.x = pt12.x = x2 + width / 2;
    pt02.y = y2;
    pt12.y = y2 + height;
  } else {
    pt02.y = pt12.y = y2 + height / 2;
    pt02.x = x2;
    pt12.x = x2 + width;
  }
  return splitPolygonByLine(points2, pt02, pt12);
}
function binaryDivideRecursive(divider, shape, count2, out2) {
  if (count2 === 1) {
    out2.push(shape);
  } else {
    var mid = Math.floor(count2 / 2);
    var sub2 = divider(shape);
    binaryDivideRecursive(divider, sub2[0], mid, out2);
    binaryDivideRecursive(divider, sub2[1], count2 - mid, out2);
  }
  return out2;
}
function clone(path, count2) {
  var paths = [];
  for (var i = 0; i < count2; i++) {
    paths.push(clonePath(path));
  }
  return paths;
}
function copyPathProps(source, target) {
  target.setStyle(source.style);
  target.z = source.z;
  target.z2 = source.z2;
  target.zlevel = source.zlevel;
}
function polygonConvert(points2) {
  var out2 = [];
  for (var i = 0; i < points2.length; ) {
    out2.push([points2[i++], points2[i++]]);
  }
  return out2;
}
function split(path, count2) {
  var outShapes = [];
  var shape = path.shape;
  var OutShapeCtor;
  switch (path.type) {
    case "rect":
      divideRect(shape, count2, outShapes);
      OutShapeCtor = Rect$3;
      break;
    case "sector":
      divideSector(shape, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    case "circle":
      divideSector({
        r0: 0,
        r: shape.r,
        startAngle: 0,
        endAngle: Math.PI * 2,
        cx: shape.cx,
        cy: shape.cy
      }, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    default:
      var m2 = path.getComputedTransform();
      var scale2 = m2 ? Math.sqrt(Math.max(m2[0] * m2[0] + m2[1] * m2[1], m2[2] * m2[2] + m2[3] * m2[3])) : 1;
      var polygons = map$1(pathToPolygons(path.getUpdatedPathProxy(), scale2), function(poly) {
        return polygonConvert(poly);
      });
      var polygonCount = polygons.length;
      if (polygonCount === 0) {
        binaryDivideRecursive(binaryDividePolygon, {
          points: polygons[0]
        }, count2, outShapes);
      } else if (polygonCount === count2) {
        for (var i = 0; i < polygonCount; i++) {
          outShapes.push({
            points: polygons[i]
          });
        }
      } else {
        var totalArea_1 = 0;
        var items = map$1(polygons, function(poly) {
          var min3 = [];
          var max3 = [];
          fromPoints(poly, min3, max3);
          var area = (max3[1] - min3[1]) * (max3[0] - min3[0]);
          totalArea_1 += area;
          return { poly, area };
        });
        items.sort(function(a, b2) {
          return b2.area - a.area;
        });
        var left = count2;
        for (var i = 0; i < polygonCount; i++) {
          var item = items[i];
          if (left <= 0) {
            break;
          }
          var selfCount = i === polygonCount - 1 ? left : Math.ceil(item.area / totalArea_1 * count2);
          if (selfCount < 0) {
            continue;
          }
          binaryDivideRecursive(binaryDividePolygon, {
            points: item.poly
          }, selfCount, outShapes);
          left -= selfCount;
        }
      }
      OutShapeCtor = Polygon$1;
      break;
  }
  if (!OutShapeCtor) {
    return clone(path, count2);
  }
  var out2 = [];
  for (var i = 0; i < outShapes.length; i++) {
    var subPath = new OutShapeCtor();
    subPath.setShape(outShapes[i]);
    copyPathProps(path, subPath);
    out2.push(subPath);
  }
  return out2;
}
function alignSubpath(subpath1, subpath2) {
  var len1 = subpath1.length;
  var len2 = subpath2.length;
  if (len1 === len2) {
    return [subpath1, subpath2];
  }
  var tmpSegX = [];
  var tmpSegY = [];
  var shorterPath = len1 < len2 ? subpath1 : subpath2;
  var shorterLen = Math.min(len1, len2);
  var diff = Math.abs(len2 - len1) / 6;
  var shorterBezierCount = (shorterLen - 2) / 6;
  var eachCurveSubDivCount = Math.ceil(diff / shorterBezierCount) + 1;
  var newSubpath = [shorterPath[0], shorterPath[1]];
  var remained = diff;
  for (var i = 2; i < shorterLen; ) {
    var x0 = shorterPath[i - 2];
    var y0 = shorterPath[i - 1];
    var x1 = shorterPath[i++];
    var y1 = shorterPath[i++];
    var x2 = shorterPath[i++];
    var y2 = shorterPath[i++];
    var x3 = shorterPath[i++];
    var y3 = shorterPath[i++];
    if (remained <= 0) {
      newSubpath.push(x1, y1, x2, y2, x3, y3);
      continue;
    }
    var actualSubDivCount = Math.min(remained, eachCurveSubDivCount - 1) + 1;
    for (var k2 = 1; k2 <= actualSubDivCount; k2++) {
      var p2 = k2 / actualSubDivCount;
      cubicSubdivide(x0, x1, x2, x3, p2, tmpSegX);
      cubicSubdivide(y0, y1, y2, y3, p2, tmpSegY);
      x0 = tmpSegX[3];
      y0 = tmpSegY[3];
      newSubpath.push(tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], x0, y0);
      x1 = tmpSegX[5];
      y1 = tmpSegY[5];
      x2 = tmpSegX[6];
      y2 = tmpSegY[6];
    }
    remained -= actualSubDivCount - 1;
  }
  return shorterPath === subpath1 ? [newSubpath, subpath2] : [subpath1, newSubpath];
}
function createSubpath(lastSubpathSubpath, otherSubpath) {
  var len2 = lastSubpathSubpath.length;
  var lastX = lastSubpathSubpath[len2 - 2];
  var lastY = lastSubpathSubpath[len2 - 1];
  var newSubpath = [];
  for (var i = 0; i < otherSubpath.length; ) {
    newSubpath[i++] = lastX;
    newSubpath[i++] = lastY;
  }
  return newSubpath;
}
function alignBezierCurves(array1, array22) {
  var _a2;
  var lastSubpath1;
  var lastSubpath2;
  var newArray1 = [];
  var newArray2 = [];
  for (var i = 0; i < Math.max(array1.length, array22.length); i++) {
    var subpath1 = array1[i];
    var subpath2 = array22[i];
    var newSubpath1 = void 0;
    var newSubpath2 = void 0;
    if (!subpath1) {
      newSubpath1 = createSubpath(lastSubpath1 || subpath2, subpath2);
      newSubpath2 = subpath2;
    } else if (!subpath2) {
      newSubpath2 = createSubpath(lastSubpath2 || subpath1, subpath1);
      newSubpath1 = subpath1;
    } else {
      _a2 = alignSubpath(subpath1, subpath2), newSubpath1 = _a2[0], newSubpath2 = _a2[1];
      lastSubpath1 = newSubpath1;
      lastSubpath2 = newSubpath2;
    }
    newArray1.push(newSubpath1);
    newArray2.push(newSubpath2);
  }
  return [newArray1, newArray2];
}
function centroid(array4) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = array4.length;
  for (var i = 0, j = len2 - 2; i < len2; j = i, i += 2) {
    var x0 = array4[j];
    var y0 = array4[j + 1];
    var x1 = array4[i];
    var y1 = array4[i + 1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
  }
  if (signedArea === 0) {
    return [array4[0] || 0, array4[1] || 0];
  }
  return [cx / signedArea / 3, cy / signedArea / 3, signedArea];
}
function findBestRingOffset(fromSubBeziers, toSubBeziers, fromCp, toCp) {
  var bezierCount = (fromSubBeziers.length - 2) / 6;
  var bestScore = Infinity;
  var bestOffset = 0;
  var len2 = fromSubBeziers.length;
  var len22 = len2 - 2;
  for (var offset3 = 0; offset3 < bezierCount; offset3++) {
    var cursorOffset = offset3 * 6;
    var score = 0;
    for (var k2 = 0; k2 < len2; k2 += 2) {
      var idx = k2 === 0 ? cursorOffset : (cursorOffset + k2 - 2) % len22 + 2;
      var x0 = fromSubBeziers[idx] - fromCp[0];
      var y0 = fromSubBeziers[idx + 1] - fromCp[1];
      var x1 = toSubBeziers[k2] - toCp[0];
      var y1 = toSubBeziers[k2 + 1] - toCp[1];
      var dx = x1 - x0;
      var dy = y1 - y0;
      score += dx * dx + dy * dy;
    }
    if (score < bestScore) {
      bestScore = score;
      bestOffset = offset3;
    }
  }
  return bestOffset;
}
function reverse(array4) {
  var newArr = [];
  var len2 = array4.length;
  for (var i = 0; i < len2; i += 2) {
    newArr[i] = array4[len2 - i - 2];
    newArr[i + 1] = array4[len2 - i - 1];
  }
  return newArr;
}
function findBestMorphingRotation(fromArr, toArr2, searchAngleIteration, searchAngleRange) {
  var result = [];
  var fromNeedsReverse;
  for (var i = 0; i < fromArr.length; i++) {
    var fromSubpathBezier = fromArr[i];
    var toSubpathBezier = toArr2[i];
    var fromCp = centroid(fromSubpathBezier);
    var toCp = centroid(toSubpathBezier);
    if (fromNeedsReverse == null) {
      fromNeedsReverse = fromCp[2] < 0 !== toCp[2] < 0;
    }
    var newFromSubpathBezier = [];
    var newToSubpathBezier = [];
    var bestAngle = 0;
    var bestScore = Infinity;
    var tmpArr2 = [];
    var len2 = fromSubpathBezier.length;
    if (fromNeedsReverse) {
      fromSubpathBezier = reverse(fromSubpathBezier);
    }
    var offset3 = findBestRingOffset(fromSubpathBezier, toSubpathBezier, fromCp, toCp) * 6;
    var len22 = len2 - 2;
    for (var k2 = 0; k2 < len22; k2 += 2) {
      var idx = (offset3 + k2) % len22 + 2;
      newFromSubpathBezier[k2 + 2] = fromSubpathBezier[idx] - fromCp[0];
      newFromSubpathBezier[k2 + 3] = fromSubpathBezier[idx + 1] - fromCp[1];
    }
    newFromSubpathBezier[0] = fromSubpathBezier[offset3] - fromCp[0];
    newFromSubpathBezier[1] = fromSubpathBezier[offset3 + 1] - fromCp[1];
    if (searchAngleIteration > 0) {
      var step = searchAngleRange / searchAngleIteration;
      for (var angle = -searchAngleRange / 2; angle <= searchAngleRange / 2; angle += step) {
        var sa2 = Math.sin(angle);
        var ca2 = Math.cos(angle);
        var score = 0;
        for (var k2 = 0; k2 < fromSubpathBezier.length; k2 += 2) {
          var x0 = newFromSubpathBezier[k2];
          var y0 = newFromSubpathBezier[k2 + 1];
          var x1 = toSubpathBezier[k2] - toCp[0];
          var y1 = toSubpathBezier[k2 + 1] - toCp[1];
          var newX1 = x1 * ca2 - y1 * sa2;
          var newY1 = x1 * sa2 + y1 * ca2;
          tmpArr2[k2] = newX1;
          tmpArr2[k2 + 1] = newY1;
          var dx = newX1 - x0;
          var dy = newY1 - y0;
          score += dx * dx + dy * dy;
        }
        if (score < bestScore) {
          bestScore = score;
          bestAngle = angle;
          for (var m2 = 0; m2 < tmpArr2.length; m2++) {
            newToSubpathBezier[m2] = tmpArr2[m2];
          }
        }
      }
    } else {
      for (var i_1 = 0; i_1 < len2; i_1 += 2) {
        newToSubpathBezier[i_1] = toSubpathBezier[i_1] - toCp[0];
        newToSubpathBezier[i_1 + 1] = toSubpathBezier[i_1 + 1] - toCp[1];
      }
    }
    result.push({
      from: newFromSubpathBezier,
      to: newToSubpathBezier,
      fromCp,
      toCp,
      rotation: -bestAngle
    });
  }
  return result;
}
function isCombineMorphing(path) {
  return path.__isCombineMorphing;
}
var SAVED_METHOD_PREFIX = "__mOriginal_";
function saveAndModifyMethod(obj, methodName, modifiers) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  var originalMethod = obj[savedMethodName] || obj[methodName];
  if (!obj[savedMethodName]) {
    obj[savedMethodName] = obj[methodName];
  }
  var replace = modifiers.replace;
  var after = modifiers.after;
  var before = modifiers.before;
  obj[methodName] = function() {
    var args = arguments;
    var res2;
    before && before.apply(this, args);
    if (replace) {
      res2 = replace.apply(this, args);
    } else {
      res2 = originalMethod.apply(this, args);
    }
    after && after.apply(this, args);
    return res2;
  };
}
function restoreMethod(obj, methodName) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  if (obj[savedMethodName]) {
    obj[methodName] = obj[savedMethodName];
    obj[savedMethodName] = null;
  }
}
function applyTransformOnBeziers(bezierCurves, mm) {
  for (var i = 0; i < bezierCurves.length; i++) {
    var subBeziers = bezierCurves[i];
    for (var k2 = 0; k2 < subBeziers.length; ) {
      var x2 = subBeziers[k2];
      var y2 = subBeziers[k2 + 1];
      subBeziers[k2++] = mm[0] * x2 + mm[2] * y2 + mm[4];
      subBeziers[k2++] = mm[1] * x2 + mm[3] * y2 + mm[5];
    }
  }
}
function prepareMorphPath(fromPath, toPath) {
  var fromPathProxy = fromPath.getUpdatedPathProxy();
  var toPathProxy = toPath.getUpdatedPathProxy();
  var _a2 = alignBezierCurves(pathToBezierCurves(fromPathProxy), pathToBezierCurves(toPathProxy)), fromBezierCurves = _a2[0], toBezierCurves = _a2[1];
  var fromPathTransform = fromPath.getComputedTransform();
  var toPathTransform = toPath.getComputedTransform();
  function updateIdentityTransform() {
    this.transform = null;
  }
  fromPathTransform && applyTransformOnBeziers(fromBezierCurves, fromPathTransform);
  toPathTransform && applyTransformOnBeziers(toBezierCurves, toPathTransform);
  saveAndModifyMethod(toPath, "updateTransform", { replace: updateIdentityTransform });
  toPath.transform = null;
  var morphingData = findBestMorphingRotation(fromBezierCurves, toBezierCurves, 10, Math.PI);
  var tmpArr2 = [];
  saveAndModifyMethod(toPath, "buildPath", { replace: function(path) {
    var t2 = toPath.__morphT;
    var onet = 1 - t2;
    var newCp = [];
    for (var i = 0; i < morphingData.length; i++) {
      var item = morphingData[i];
      var from2 = item.from;
      var to = item.to;
      var angle = item.rotation * t2;
      var fromCp = item.fromCp;
      var toCp = item.toCp;
      var sa2 = Math.sin(angle);
      var ca2 = Math.cos(angle);
      lerp$1(newCp, fromCp, toCp, t2);
      for (var m2 = 0; m2 < from2.length; m2 += 2) {
        var x0_1 = from2[m2];
        var y0_1 = from2[m2 + 1];
        var x1 = to[m2];
        var y1 = to[m2 + 1];
        var x2 = x0_1 * onet + x1 * t2;
        var y2 = y0_1 * onet + y1 * t2;
        tmpArr2[m2] = x2 * ca2 - y2 * sa2 + newCp[0];
        tmpArr2[m2 + 1] = x2 * sa2 + y2 * ca2 + newCp[1];
      }
      var x0 = tmpArr2[0];
      var y0 = tmpArr2[1];
      path.moveTo(x0, y0);
      for (var m2 = 2; m2 < from2.length; ) {
        var x1 = tmpArr2[m2++];
        var y1 = tmpArr2[m2++];
        var x22 = tmpArr2[m2++];
        var y22 = tmpArr2[m2++];
        var x3 = tmpArr2[m2++];
        var y3 = tmpArr2[m2++];
        if (x0 === x1 && y0 === y1 && x22 === x3 && y22 === y3) {
          path.lineTo(x3, y3);
        } else {
          path.bezierCurveTo(x1, y1, x22, y22, x3, y3);
        }
        x0 = x3;
        y0 = y3;
      }
    }
  } });
}
function morphPath(fromPath, toPath, animationOpts) {
  if (!fromPath || !toPath) {
    return toPath;
  }
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  prepareMorphPath(fromPath, toPath);
  toPath.__morphT = 0;
  function restoreToPath() {
    restoreMethod(toPath, "buildPath");
    restoreMethod(toPath, "updateTransform");
    toPath.__morphT = -1;
    toPath.createPathProxy();
    toPath.dirtyShape();
  }
  toPath.animateTo({
    __morphT: 1
  }, defaults({
    during: function(p2) {
      toPath.dirtyShape();
      oldDuring && oldDuring(p2);
    },
    done: function() {
      restoreToPath();
      oldDone && oldDone();
    }
  }, animationOpts));
  return toPath;
}
function hilbert(x2, y2, minX, minY, maxX, maxY) {
  var bits = 16;
  x2 = maxX === minX ? 0 : Math.round(32767 * (x2 - minX) / (maxX - minX));
  y2 = maxY === minY ? 0 : Math.round(32767 * (y2 - minY) / (maxY - minY));
  var d2 = 0;
  var tmp;
  for (var s = (1 << bits) / 2; s > 0; s /= 2) {
    var rx = 0;
    var ry = 0;
    if ((x2 & s) > 0) {
      rx = 1;
    }
    if ((y2 & s) > 0) {
      ry = 1;
    }
    d2 += s * s * (3 * rx ^ ry);
    if (ry === 0) {
      if (rx === 1) {
        x2 = s - 1 - x2;
        y2 = s - 1 - y2;
      }
      tmp = x2;
      x2 = y2;
      y2 = tmp;
    }
  }
  return d2;
}
function sortPaths(pathList) {
  var xMin = Infinity;
  var yMin = Infinity;
  var xMax = -Infinity;
  var yMax = -Infinity;
  var cps = map$1(pathList, function(path) {
    var rect = path.getBoundingRect();
    var m2 = path.getComputedTransform();
    var x2 = rect.x + rect.width / 2 + (m2 ? m2[4] : 0);
    var y2 = rect.y + rect.height / 2 + (m2 ? m2[5] : 0);
    xMin = Math.min(x2, xMin);
    yMin = Math.min(y2, yMin);
    xMax = Math.max(x2, xMax);
    yMax = Math.max(y2, yMax);
    return [x2, y2];
  });
  var items = map$1(cps, function(cp, idx) {
    return {
      cp,
      z: hilbert(cp[0], cp[1], xMin, yMin, xMax, yMax),
      path: pathList[idx]
    };
  });
  return items.sort(function(a, b2) {
    return a.z - b2.z;
  }).map(function(item) {
    return item.path;
  });
}
function defaultDividePath(param) {
  return split(param.path, param.count);
}
function createEmptyReturn() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function combineMorph(fromList, toPath, animationOpts) {
  var fromPathList = [];
  function addFromPath(fromList2) {
    for (var i2 = 0; i2 < fromList2.length; i2++) {
      var from3 = fromList2[i2];
      if (isCombineMorphing(from3)) {
        addFromPath(from3.childrenRef());
      } else if (from3 instanceof Path$1) {
        fromPathList.push(from3);
      }
    }
  }
  addFromPath(fromList);
  var separateCount = fromPathList.length;
  if (!separateCount) {
    return createEmptyReturn();
  }
  var dividePath = animationOpts.dividePath || defaultDividePath;
  var toSubPathList = dividePath({
    path: toPath,
    count: separateCount
  });
  if (toSubPathList.length !== separateCount) {
    console.error("Invalid morphing: unmatched splitted path");
    return createEmptyReturn();
  }
  fromPathList = sortPaths(fromPathList);
  toSubPathList = sortPaths(toSubPathList);
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  var individualDelay = animationOpts.individualDelay;
  var identityTransform = new Transformable$1();
  for (var i = 0; i < separateCount; i++) {
    var from2 = fromPathList[i];
    var to = toSubPathList[i];
    to.parent = toPath;
    to.copyTransform(identityTransform);
    if (!individualDelay) {
      prepareMorphPath(from2, to);
    }
  }
  toPath.__isCombineMorphing = true;
  toPath.childrenRef = function() {
    return toSubPathList;
  };
  function addToSubPathListToZr(zr) {
    for (var i2 = 0; i2 < toSubPathList.length; i2++) {
      toSubPathList[i2].addSelfToZr(zr);
    }
  }
  saveAndModifyMethod(toPath, "addSelfToZr", {
    after: function(zr) {
      addToSubPathListToZr(zr);
    }
  });
  saveAndModifyMethod(toPath, "removeSelfFromZr", {
    after: function(zr) {
      for (var i2 = 0; i2 < toSubPathList.length; i2++) {
        toSubPathList[i2].removeSelfFromZr(zr);
      }
    }
  });
  function restoreToPath() {
    toPath.__isCombineMorphing = false;
    toPath.__morphT = -1;
    toPath.childrenRef = null;
    restoreMethod(toPath, "addSelfToZr");
    restoreMethod(toPath, "removeSelfFromZr");
  }
  var toLen = toSubPathList.length;
  if (individualDelay) {
    var animating_1 = toLen;
    var eachDone = function() {
      animating_1--;
      if (animating_1 === 0) {
        restoreToPath();
        oldDone && oldDone();
      }
    };
    for (var i = 0; i < toLen; i++) {
      var indivdualAnimationOpts = individualDelay ? defaults({
        delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toSubPathList[i]),
        done: eachDone
      }, animationOpts) : animationOpts;
      morphPath(fromPathList[i], toSubPathList[i], indivdualAnimationOpts);
    }
  } else {
    toPath.__morphT = 0;
    toPath.animateTo({
      __morphT: 1
    }, defaults({
      during: function(p2) {
        for (var i2 = 0; i2 < toLen; i2++) {
          var child = toSubPathList[i2];
          child.__morphT = toPath.__morphT;
          child.dirtyShape();
        }
        oldDuring && oldDuring(p2);
      },
      done: function() {
        restoreToPath();
        for (var i2 = 0; i2 < fromList.length; i2++) {
          restoreMethod(fromList[i2], "updateTransform");
        }
        oldDone && oldDone();
      }
    }, animationOpts));
  }
  if (toPath.__zr) {
    addToSubPathListToZr(toPath.__zr);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toSubPathList,
    count: toLen
  };
}
function separateMorph(fromPath, toPathList, animationOpts) {
  var toLen = toPathList.length;
  var fromPathList = [];
  var dividePath = animationOpts.dividePath || defaultDividePath;
  function addFromPath(fromList) {
    for (var i2 = 0; i2 < fromList.length; i2++) {
      var from2 = fromList[i2];
      if (isCombineMorphing(from2)) {
        addFromPath(from2.childrenRef());
      } else if (from2 instanceof Path$1) {
        fromPathList.push(from2);
      }
    }
  }
  if (isCombineMorphing(fromPath)) {
    addFromPath(fromPath.childrenRef());
    var fromLen = fromPathList.length;
    if (fromLen < toLen) {
      var k2 = 0;
      for (var i = fromLen; i < toLen; i++) {
        fromPathList.push(clonePath(fromPathList[k2++ % fromLen]));
      }
    }
    fromPathList.length = toLen;
  } else {
    fromPathList = dividePath({ path: fromPath, count: toLen });
    var fromPathTransform = fromPath.getComputedTransform();
    for (var i = 0; i < fromPathList.length; i++) {
      fromPathList[i].setLocalTransform(fromPathTransform);
    }
    if (fromPathList.length !== toLen) {
      console.error("Invalid morphing: unmatched splitted path");
      return createEmptyReturn();
    }
  }
  fromPathList = sortPaths(fromPathList);
  toPathList = sortPaths(toPathList);
  var individualDelay = animationOpts.individualDelay;
  for (var i = 0; i < toLen; i++) {
    var indivdualAnimationOpts = individualDelay ? defaults({
      delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toPathList[i])
    }, animationOpts) : animationOpts;
    morphPath(fromPathList[i], toPathList[i], indivdualAnimationOpts);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toPathList,
    count: toPathList.length
  };
}
function isMultiple(elements) {
  return isArray$2(elements[0]);
}
function prepareMorphBatches(one, many) {
  var batches = [];
  var batchCount = one.length;
  for (var i = 0; i < batchCount; i++) {
    batches.push({
      one: one[i],
      many: []
    });
  }
  for (var i = 0; i < many.length; i++) {
    var len2 = many[i].length;
    var k2 = void 0;
    for (k2 = 0; k2 < len2; k2++) {
      batches[k2 % batchCount].many.push(many[i][k2]);
    }
  }
  var off = 0;
  for (var i = batchCount - 1; i >= 0; i--) {
    if (!batches[i].many.length) {
      var moveFrom = batches[off].many;
      if (moveFrom.length <= 1) {
        if (off) {
          off = 0;
        } else {
          return batches;
        }
      }
      var len2 = moveFrom.length;
      var mid = Math.ceil(len2 / 2);
      batches[i].many = moveFrom.slice(mid, len2);
      batches[off].many = moveFrom.slice(0, mid);
      off++;
    }
  }
  return batches;
}
var pathDividers = {
  clone: function(params) {
    var ret = [];
    var approxOpacity = 1 - Math.pow(1 - params.path.style.opacity, 1 / params.count);
    for (var i = 0; i < params.count; i++) {
      var cloned = clonePath(params.path);
      cloned.setStyle("opacity", approxOpacity);
      ret.push(cloned);
    }
    return ret;
  },
  split: null
};
function applyMorphAnimation(from2, to, divideShape, seriesModel, dataIndex, animateOtherProps) {
  if (!from2.length || !to.length) {
    return;
  }
  var updateAnimationCfg = getAnimationConfig("update", seriesModel, dataIndex);
  if (!(updateAnimationCfg && updateAnimationCfg.duration > 0)) {
    return;
  }
  var animationDelay = seriesModel.getModel("universalTransition").get("delay");
  var animationCfg = Object.assign({
    setToFinal: true
  }, updateAnimationCfg);
  var many;
  var one;
  if (isMultiple(from2)) {
    many = from2;
    one = to;
  }
  if (isMultiple(to)) {
    many = to;
    one = from2;
  }
  function morphOneBatch(batch, fromIsMany2, animateIndex2, animateCount2, forceManyOne) {
    var batchMany = batch.many;
    var batchOne = batch.one;
    if (batchMany.length === 1 && !forceManyOne) {
      var batchFrom = fromIsMany2 ? batchMany[0] : batchOne;
      var batchTo = fromIsMany2 ? batchOne : batchMany[0];
      if (isCombineMorphing(batchFrom)) {
        morphOneBatch({
          many: [batchFrom],
          one: batchTo
        }, true, animateIndex2, animateCount2, true);
      } else {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(animateIndex2, animateCount2)
        }, animationCfg) : animationCfg;
        morphPath(batchFrom, batchTo, individualAnimationCfg);
        animateOtherProps(batchFrom, batchTo, batchFrom, batchTo, individualAnimationCfg);
      }
    } else {
      var separateAnimationCfg = defaults({
        dividePath: pathDividers[divideShape],
        individualDelay: animationDelay && function(idx, count3, fromPath, toPath) {
          return animationDelay(idx + animateIndex2, animateCount2);
        }
      }, animationCfg);
      var _a2 = fromIsMany2 ? combineMorph(batchMany, batchOne, separateAnimationCfg) : separateMorph(batchOne, batchMany, separateAnimationCfg), fromIndividuals = _a2.fromIndividuals, toIndividuals = _a2.toIndividuals;
      var count2 = fromIndividuals.length;
      for (var k2 = 0; k2 < count2; k2++) {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(k2, count2)
        }, animationCfg) : animationCfg;
        animateOtherProps(fromIndividuals[k2], toIndividuals[k2], fromIsMany2 ? batchMany[k2] : batch.one, fromIsMany2 ? batch.one : batchMany[k2], individualAnimationCfg);
      }
    }
  }
  var fromIsMany = many ? many === from2 : from2.length > to.length;
  var morphBatches = many ? prepareMorphBatches(one, many) : prepareMorphBatches(fromIsMany ? to : from2, [fromIsMany ? from2 : to]);
  var animateCount = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    animateCount += morphBatches[i].many.length;
  }
  var animateIndex = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    morphOneBatch(morphBatches[i], fromIsMany, animateIndex, animateCount);
    animateIndex += morphBatches[i].many.length;
  }
}
function getPathList(elements) {
  if (!elements) {
    return [];
  }
  if (isArray$2(elements)) {
    var pathList_1 = [];
    for (var i = 0; i < elements.length; i++) {
      pathList_1.push(getPathList(elements[i]));
    }
    return pathList_1;
  }
  var pathList = [];
  elements.traverse(function(el) {
    if (el instanceof Path$1 && !el.disableMorphing && !el.invisible && !el.ignore) {
      pathList.push(el);
    }
  });
  return pathList;
}
var DATA_COUNT_THRESHOLD = 1e4;
var getUniversalTransitionGlobalStore = makeInner();
function getGroupIdDimension(data2) {
  var dimensions = data2.dimensions;
  for (var i = 0; i < dimensions.length; i++) {
    var dimInfo = data2.getDimensionInfo(dimensions[i]);
    if (dimInfo && dimInfo.otherDims.itemGroupId === 0) {
      return dimensions[i];
    }
  }
}
function flattenDataDiffItems(list) {
  var items = [];
  each$g(list, function(seriesInfo) {
    var data2 = seriesInfo.data;
    if (data2.count() > DATA_COUNT_THRESHOLD) {
      return;
    }
    var indices = data2.getIndices();
    var groupDim = getGroupIdDimension(data2);
    for (var dataIndex = 0; dataIndex < indices.length; dataIndex++) {
      items.push({
        data: data2,
        dim: seriesInfo.dim || groupDim,
        divide: seriesInfo.divide,
        dataIndex
      });
    }
  });
  return items;
}
function fadeInElement(newEl2, newSeries, newIndex) {
  newEl2.traverse(function(el) {
    if (el instanceof Path$1) {
      initProps(el, {
        style: {
          opacity: 0
        }
      }, newSeries, {
        dataIndex: newIndex,
        isFrom: true
      });
    }
  });
}
function removeEl(el) {
  if (el.parent) {
    var computedTransform = el.getComputedTransform();
    el.setLocalTransform(computedTransform);
    el.parent.remove(el);
  }
}
function stopAnimation(el) {
  el.stopAnimation();
  if (el.isGroup) {
    el.traverse(function(child) {
      child.stopAnimation();
    });
  }
}
function animateElementStyles(el, dataIndex, seriesModel) {
  var animationConfig = getAnimationConfig("update", seriesModel, dataIndex);
  animationConfig && el.traverse(function(child) {
    if (child instanceof Displayable$1) {
      var oldStyle = getOldStyle(child);
      if (oldStyle) {
        child.animateFrom({
          style: oldStyle
        }, animationConfig);
      }
    }
  });
}
function isAllIdSame(oldDiffItems, newDiffItems) {
  var len2 = oldDiffItems.length;
  if (len2 !== newDiffItems.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    var oldItem = oldDiffItems[i];
    var newItem = newDiffItems[i];
    if (oldItem.data.getId(oldItem.dataIndex) !== newItem.data.getId(newItem.dataIndex)) {
      return false;
    }
  }
  return true;
}
function transitionBetween(oldList, newList, api) {
  var oldDiffItems = flattenDataDiffItems(oldList);
  var newDiffItems = flattenDataDiffItems(newList);
  function updateMorphingPathProps(from2, to, rawFrom, rawTo, animationCfg) {
    if (rawFrom || from2) {
      to.animateFrom({
        style: rawFrom && rawFrom !== from2 ? extend(extend({}, rawFrom.style), from2.style) : from2.style
      }, animationCfg);
    }
  }
  function findKeyDim(items) {
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].dim) {
        return items[i2].dim;
      }
    }
  }
  var oldKeyDim = findKeyDim(oldDiffItems);
  var newKeyDim = findKeyDim(newDiffItems);
  var hasMorphAnimation = false;
  function createKeyGetter(isOld, onlyGetId) {
    return function(diffItem) {
      var data2 = diffItem.data;
      var dataIndex = diffItem.dataIndex;
      if (onlyGetId) {
        return data2.getId(dataIndex);
      }
      var dataGroupId = data2.hostModel && data2.hostModel.get("dataGroupId");
      var keyDim = isOld ? oldKeyDim || newKeyDim : newKeyDim || oldKeyDim;
      var dimInfo = keyDim && data2.getDimensionInfo(keyDim);
      var dimOrdinalMeta = dimInfo && dimInfo.ordinalMeta;
      if (dimInfo) {
        var key = data2.get(dimInfo.name, dataIndex);
        if (dimOrdinalMeta) {
          return dimOrdinalMeta.categories[key] || key + "";
        }
        return key + "";
      }
      var itemVal = data2.getRawDataItem(dataIndex);
      if (itemVal && itemVal.groupId) {
        return itemVal.groupId + "";
      }
      return dataGroupId || data2.getId(dataIndex);
    };
  }
  var useId = isAllIdSame(oldDiffItems, newDiffItems);
  var isElementStillInChart = {};
  if (!useId) {
    for (var i = 0; i < newDiffItems.length; i++) {
      var newItem = newDiffItems[i];
      var el = newItem.data.getItemGraphicEl(newItem.dataIndex);
      if (el) {
        isElementStillInChart[el.id] = true;
      }
    }
  }
  function updateOneToOne(newIndex, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var newItem2 = newDiffItems[newIndex];
    var newSeries = newItem2.data.hostModel;
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    var newEl2 = newItem2.data.getItemGraphicEl(newItem2.dataIndex);
    if (oldEl === newEl2) {
      newEl2 && animateElementStyles(newEl2, newItem2.dataIndex, newSeries);
      return;
    }
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newIndex);
      }
    }
  }
  new DataDiffer$1(oldDiffItems, newDiffItems, createKeyGetter(true, useId), createKeyGetter(false, useId), null, "multiple").update(updateOneToOne).updateManyToOne(function(newIndex, oldIndices) {
    var newItem2 = newDiffItems[newIndex];
    var newData = newItem2.data;
    var newSeries = newData.hostModel;
    var newEl2 = newData.getItemGraphicEl(newItem2.dataIndex);
    var oldElsList = filter(map$1(oldIndices, function(idx) {
      return oldDiffItems[idx].data.getItemGraphicEl(oldDiffItems[idx].dataIndex);
    }), function(oldEl) {
      return oldEl && oldEl !== newEl2 && !isElementStillInChart[oldEl.id];
    });
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldElsList.length) {
        each$g(oldElsList, function(oldEl) {
          stopAnimation(oldEl);
          removeEl(oldEl);
        });
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldElsList), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newItem2.dataIndex);
      }
    }
  }).updateOneToMany(function(newIndices, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    var newElsList = filter(map$1(newIndices, function(idx) {
      return newDiffItems[idx].data.getItemGraphicEl(newDiffItems[idx].dataIndex);
    }), function(el2) {
      return el2 && el2 !== oldEl;
    });
    var newSeris = newDiffItems[newIndices[0]].data.hostModel;
    if (newElsList.length) {
      each$g(newElsList, function(newEl2) {
        return stopAnimation(newEl2);
      });
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newElsList), oldItem.divide, newSeris, newIndices[0], updateMorphingPathProps);
      } else {
        each$g(newElsList, function(newEl2) {
          return fadeInElement(newEl2, newSeris, newIndices[0]);
        });
      }
    }
  }).updateManyToMany(function(newIndices, oldIndices) {
    new DataDiffer$1(oldIndices, newIndices, function(rawIdx) {
      return oldDiffItems[rawIdx].data.getId(oldDiffItems[rawIdx].dataIndex);
    }, function(rawIdx) {
      return newDiffItems[rawIdx].data.getId(newDiffItems[rawIdx].dataIndex);
    }).update(function(newIndex, oldIndex) {
      updateOneToOne(newIndices[newIndex], oldIndices[oldIndex]);
    }).execute();
  }).execute();
  if (hasMorphAnimation) {
    each$g(newList, function(_a2) {
      var data2 = _a2.data;
      var seriesModel = data2.hostModel;
      var view = seriesModel && api.getViewOfSeriesModel(seriesModel);
      var animationCfg = getAnimationConfig("update", seriesModel, 0);
      if (view && seriesModel.isAnimationEnabled() && animationCfg && animationCfg.duration > 0) {
        view.group.traverse(function(el2) {
          if (el2 instanceof Path$1 && !el2.animators.length) {
            el2.animateFrom({
              style: {
                opacity: 0
              }
            }, animationCfg);
          }
        });
      }
    });
  }
}
function getSeriesTransitionKey(series) {
  var seriesKey = series.getModel("universalTransition").get("seriesKey");
  if (!seriesKey) {
    return series.id;
  }
  return seriesKey;
}
function convertArraySeriesKeyToString(seriesKey) {
  if (isArray$2(seriesKey)) {
    return seriesKey.sort().join(",");
  }
  return seriesKey;
}
function getDivideShapeFromData(data2) {
  if (data2.hostModel) {
    return data2.hostModel.getModel("universalTransition").get("divideShape");
  }
}
function findTransitionSeriesBatches(globalStore, params) {
  var updateBatches = createHashMap();
  var oldDataMap = createHashMap();
  var oldDataMapForSplit = createHashMap();
  each$g(globalStore.oldSeries, function(series, idx) {
    var oldData = globalStore.oldData[idx];
    var transitionKey = getSeriesTransitionKey(series);
    var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
    oldDataMap.set(transitionKeyStr, oldData);
    if (isArray$2(transitionKey)) {
      each$g(transitionKey, function(key) {
        oldDataMapForSplit.set(key, {
          data: oldData,
          key: transitionKeyStr
        });
      });
    }
  });
  each$g(params.updatedSeries, function(series) {
    if (series.isUniversalTransitionEnabled() && series.isAnimationEnabled()) {
      var newData = series.getData();
      var transitionKey = getSeriesTransitionKey(series);
      var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
      var oldData = oldDataMap.get(transitionKeyStr);
      if (oldData) {
        updateBatches.set(transitionKeyStr, {
          oldSeries: [{
            divide: getDivideShapeFromData(oldData),
            data: oldData
          }],
          newSeries: [{
            divide: getDivideShapeFromData(newData),
            data: newData
          }]
        });
      } else {
        if (isArray$2(transitionKey)) {
          var oldSeries_1 = [];
          each$g(transitionKey, function(key) {
            var oldData2 = oldDataMap.get(key);
            if (oldData2) {
              oldSeries_1.push({
                divide: getDivideShapeFromData(oldData2),
                data: oldData2
              });
            }
          });
          if (oldSeries_1.length) {
            updateBatches.set(transitionKeyStr, {
              oldSeries: oldSeries_1,
              newSeries: [{
                data: newData,
                divide: getDivideShapeFromData(newData)
              }]
            });
          }
        } else {
          var oldData_1 = oldDataMapForSplit.get(transitionKey);
          if (oldData_1) {
            var batch = updateBatches.get(oldData_1.key);
            if (!batch) {
              batch = {
                oldSeries: [{
                  data: oldData_1.data,
                  divide: getDivideShapeFromData(oldData_1.data)
                }],
                newSeries: []
              };
              updateBatches.set(oldData_1.key, batch);
            }
            batch.newSeries.push({
              data: newData,
              divide: getDivideShapeFromData(newData)
            });
          }
        }
      }
    }
  });
  return updateBatches;
}
function querySeries(series, finder) {
  for (var i = 0; i < series.length; i++) {
    var found = finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id;
    if (found) {
      return i;
    }
  }
}
function transitionSeriesFromOpt(transitionOpt, globalStore, params, api) {
  var from2 = [];
  var to = [];
  each$g(normalizeToArray(transitionOpt.from), function(finder) {
    var idx = querySeries(globalStore.oldSeries, finder);
    if (idx >= 0) {
      from2.push({
        data: globalStore.oldData[idx],
        divide: getDivideShapeFromData(globalStore.oldData[idx]),
        dim: finder.dimension
      });
    }
  });
  each$g(normalizeToArray(transitionOpt.to), function(finder) {
    var idx = querySeries(params.updatedSeries, finder);
    if (idx >= 0) {
      var data2 = params.updatedSeries[idx].getData();
      to.push({
        data: data2,
        divide: getDivideShapeFromData(data2),
        dim: finder.dimension
      });
    }
  });
  if (from2.length > 0 && to.length > 0) {
    transitionBetween(from2, to, api);
  }
}
function installUniversalTransition(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecMOdel, api, params) {
    each$g(normalizeToArray(params.seriesTransition), function(transOpt) {
      each$g(normalizeToArray(transOpt.to), function(finder) {
        var series = params.updatedSeries;
        for (var i = 0; i < series.length; i++) {
          if (finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id) {
            series[i][SERIES_UNIVERSAL_TRANSITION_PROP] = true;
          }
        }
      });
    });
  });
  registers.registerUpdateLifecycle("series:transition", function(ecModel, api, params) {
    var globalStore = getUniversalTransitionGlobalStore(api);
    if (globalStore.oldSeries && params.updatedSeries && params.optionChanged) {
      var transitionOpt = params.seriesTransition;
      if (transitionOpt) {
        each$g(normalizeToArray(transitionOpt), function(opt) {
          transitionSeriesFromOpt(opt, globalStore, params, api);
        });
      } else {
        var updateBatches_1 = findTransitionSeriesBatches(globalStore, params);
        each$g(updateBatches_1.keys(), function(key) {
          var batch = updateBatches_1.get(key);
          transitionBetween(batch.oldSeries, batch.newSeries, api);
        });
      }
      each$g(params.updatedSeries, function(series) {
        if (series[SERIES_UNIVERSAL_TRANSITION_PROP]) {
          series[SERIES_UNIVERSAL_TRANSITION_PROP] = false;
        }
      });
    }
    var allSeries = ecModel.getSeries();
    var savedSeries = globalStore.oldSeries = [];
    var savedData = globalStore.oldData = [];
    for (var i = 0; i < allSeries.length; i++) {
      var data2 = allSeries[i].getData();
      if (data2.count() < DATA_COUNT_THRESHOLD) {
        savedSeries.push(allSeries[i]);
        savedData.push(data2);
      }
    }
  });
}
use([install$R]);
use([install$S]);
use([install$Q, install$P, install$O, install$M, install$K, install$I, install$H, install$G, install$F, install$E, install$D, install$B, install$A, install$z, install$y, install$x, install$w, install$v, install$u, install$t, install$s, install$r]);
use(install$p);
use(install$o);
use(install$J);
use(install$n);
use(install$C);
use(install$m);
use(install$l);
use(install$j);
use(install$i);
use(install$q);
use(install$h);
use(install$g);
use(install$f);
use(install$e);
use(install$d);
use(install$c);
use(install$9);
use(install$6);
use(install$8);
use(install$7);
use(install$3);
use(install$5);
use(install$4);
use(install$2);
use(install$1);
use(install);
use(installUniversalTransition);
use(installLabelLayout);
function useEcharts(options) {
  const {
    defaultOptions: defaultOptions2
  } = options != null ? options : {};
  const container2 = useRef(null);
  const chart = useRef();
  const optionsRef = useRef(defaultOptions2);
  useEffect(() => {
    if (!container2.current) {
      return;
    }
    const myEcharts = init$2(container2.current);
    chart.current = myEcharts;
    if (optionsRef.current) {
      myEcharts.setOption(optionsRef.current);
    }
  }, []);
  useEffect(() => {
    return () => {
      var _a2, _b2, _c2, _d;
      (_b2 = (_a2 = chart.current) == null ? void 0 : _a2.dispose) == null ? void 0 : _b2.call(_a2);
      (_d = (_c2 = chart.current) == null ? void 0 : _c2.off) == null ? void 0 : _d.call(_c2, "*");
      chart.current = void 0;
    };
  }, []);
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a2, _b2;
      (_b2 = (_a2 = chart == null ? void 0 : chart.current) == null ? void 0 : _a2.resize) == null ? void 0 : _b2.call(_a2);
    });
  });
  return {
    chart,
    container: container2
  };
}
function useMedia(queries, values, defaultValue) {
  const mediaQueryLists = queries.map((q2) => window.matchMedia(q2));
  const getValue2 = () => {
    const index2 = mediaQueryLists.findIndex((mql) => mql.matches);
    return typeof values[index2] !== "undefined" ? values[index2] : defaultValue;
  };
  const [value, setValue2] = useState(getValue2);
  useEffect(() => {
    const handler = () => setValue2(getValue2);
    mediaQueryLists.forEach((mql) => mql.addListener(handler));
    return () => mediaQueryLists.forEach((mql) => mql.removeListener(handler));
  }, []);
  return value;
}
function useDarkMode() {
  const [enabledState, setEnabledState] = useLocalStorageState$1("dark-mode-enabled");
  const prefersDarkMode = usePrefersDarkMode();
  const enabled = typeof enabledState !== "undefined" ? enabledState : prefersDarkMode;
  useEffect(() => {
    const className = "dark-mode";
    const element = window.document.body;
    if (enabled) {
      element.classList.add(className);
    } else {
      element.classList.remove(className);
    }
  }, [enabled]);
  return [enabled, setEnabledState];
}
function usePrefersDarkMode() {
  return useMedia(["(prefers-color-scheme: dark)"], [true], false);
}
class Charts {
  constructor() {
    __publicField(this, "chartsEmitters", /* @__PURE__ */ new Map());
    __publicField(this, "add", ({ id: id2, chart, option, name: name2, container: container2 }) => {
      if (chart && option && id2) {
        this.chartsEmitters.set(id2, {
          chart,
          container: container2,
          option,
          name: name2
        });
      } else {
        console.log("\u6DFB\u52A0\u5931\u8D25");
      }
    });
    __publicField(this, "get", (id2) => {
      return this.chartsEmitters.get(id2);
    });
    __publicField(this, "clear", () => {
      this.chartsEmitters.clear();
    });
    __publicField(this, "delete", (id2) => {
      this.chartsEmitters.delete(id2);
    });
    __publicField(this, "select", ({
      id: id2,
      normal = "transparent",
      active = "rgba(37,168,246,.15)"
    }) => {
      var _a2, _b2, _c2;
      if (id2) {
        for (const key of this.chartsEmitters.keys()) {
          (_c2 = (_a2 = this.chartsEmitters.get(key)) == null ? void 0 : (_b2 = _a2.chart).setOption) == null ? void 0 : _c2.call(_b2, {
            backgroundColor: id2 === key ? active : normal
          });
        }
      }
    });
    __publicField(this, "list", () => {
      const list = [];
      for (const key of this.chartsEmitters.keys()) {
        list.push(__spreadValues({
          id: key
        }, this.chartsEmitters.get(key)));
      }
      return list;
    });
  }
}
const _Charts = new Charts();
class Logs {
  constructor() {
    __publicField(this, "logs", /* @__PURE__ */ new Set());
  }
  updata(params) {
    this.logs.add(__spreadValues({}, params));
  }
  depsUpdata(params) {
    this.logs.add(__spreadValues({}, params));
  }
  getList(id2) {
    var _a2;
    if (id2)
      return (_a2 = Array.from(this.logs)) == null ? void 0 : _a2.filter((i) => i.id === id2);
    return Array.from(this.logs);
  }
}
const LogsInstance = new Logs();
var lodash = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(module, exports) {
  (function() {
    var undefined$1;
    var VERSION = "4.17.21";
    var LARGE_ARRAY_SIZE2 = 200;
    var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
    var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = "__lodash_placeholder__";
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG2 = 1, COMPARE_UNORDERED_FLAG2 = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER2 = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [
      ["ary", WRAP_ARY_FLAG],
      ["bind", WRAP_BIND_FLAG],
      ["bindKey", WRAP_BIND_KEY_FLAG],
      ["curry", WRAP_CURRY_FLAG],
      ["curryRight", WRAP_CURRY_RIGHT_FLAG],
      ["flip", WRAP_FLIP_FLAG],
      ["partial", WRAP_PARTIAL_FLAG],
      ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
      ["rearg", WRAP_REARG_FLAG]
    ];
    var argsTag2 = "[object Arguments]", arrayTag2 = "[object Array]", asyncTag2 = "[object AsyncFunction]", boolTag2 = "[object Boolean]", dateTag2 = "[object Date]", domExcTag = "[object DOMException]", errorTag2 = "[object Error]", funcTag2 = "[object Function]", genTag2 = "[object GeneratorFunction]", mapTag2 = "[object Map]", numberTag2 = "[object Number]", nullTag2 = "[object Null]", objectTag2 = "[object Object]", promiseTag2 = "[object Promise]", proxyTag2 = "[object Proxy]", regexpTag2 = "[object RegExp]", setTag2 = "[object Set]", stringTag2 = "[object String]", symbolTag2 = "[object Symbol]", undefinedTag2 = "[object Undefined]", weakMapTag2 = "[object WeakMap]", weakSetTag = "[object WeakSet]";
    var arrayBufferTag2 = "[object ArrayBuffer]", dataViewTag2 = "[object DataView]", float32Tag2 = "[object Float32Array]", float64Tag2 = "[object Float64Array]", int8Tag2 = "[object Int8Array]", int16Tag2 = "[object Int16Array]", int32Tag2 = "[object Int32Array]", uint8Tag2 = "[object Uint8Array]", uint8ClampedTag2 = "[object Uint8ClampedArray]", uint16Tag2 = "[object Uint16Array]", uint32Tag2 = "[object Uint32Array]";
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar2 = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar2.source);
    var reTrimStart = /^\s+/;
    var reWhitespace = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary = /^0b[01]+$/i;
    var reIsHostCtor2 = /^\[object .+?Constructor\]$/;
    var reIsOctal = /^0o[0-7]+$/i;
    var reIsUint2 = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reApos = RegExp(rsApos, "g");
    var reComboMark = RegExp(rsCombo, "g");
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ];
    var templateCounter = -1;
    var typedArrayTags2 = {};
    typedArrayTags2[float32Tag2] = typedArrayTags2[float64Tag2] = typedArrayTags2[int8Tag2] = typedArrayTags2[int16Tag2] = typedArrayTags2[int32Tag2] = typedArrayTags2[uint8Tag2] = typedArrayTags2[uint8ClampedTag2] = typedArrayTags2[uint16Tag2] = typedArrayTags2[uint32Tag2] = true;
    typedArrayTags2[argsTag2] = typedArrayTags2[arrayTag2] = typedArrayTags2[arrayBufferTag2] = typedArrayTags2[boolTag2] = typedArrayTags2[dataViewTag2] = typedArrayTags2[dateTag2] = typedArrayTags2[errorTag2] = typedArrayTags2[funcTag2] = typedArrayTags2[mapTag2] = typedArrayTags2[numberTag2] = typedArrayTags2[objectTag2] = typedArrayTags2[regexpTag2] = typedArrayTags2[setTag2] = typedArrayTags2[stringTag2] = typedArrayTags2[weakMapTag2] = false;
    var cloneableTags = {};
    cloneableTags[argsTag2] = cloneableTags[arrayTag2] = cloneableTags[arrayBufferTag2] = cloneableTags[dataViewTag2] = cloneableTags[boolTag2] = cloneableTags[dateTag2] = cloneableTags[float32Tag2] = cloneableTags[float64Tag2] = cloneableTags[int8Tag2] = cloneableTags[int16Tag2] = cloneableTags[int32Tag2] = cloneableTags[mapTag2] = cloneableTags[numberTag2] = cloneableTags[objectTag2] = cloneableTags[regexpTag2] = cloneableTags[setTag2] = cloneableTags[stringTag2] = cloneableTags[symbolTag2] = cloneableTags[uint8Tag2] = cloneableTags[uint8ClampedTag2] = cloneableTags[uint16Tag2] = cloneableTags[uint32Tag2] = true;
    cloneableTags[errorTag2] = cloneableTags[funcTag2] = cloneableTags[weakMapTag2] = false;
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    };
    var htmlUnescapes = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    };
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    };
    var freeParseFloat = parseFloat, freeParseInt = parseInt;
    var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && true && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal2.process;
    var nodeUtil2 = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsArrayBuffer = nodeUtil2 && nodeUtil2.isArrayBuffer, nodeIsDate = nodeUtil2 && nodeUtil2.isDate, nodeIsMap = nodeUtil2 && nodeUtil2.isMap, nodeIsRegExp = nodeUtil2 && nodeUtil2.isRegExp, nodeIsSet = nodeUtil2 && nodeUtil2.isSet, nodeIsTypedArray2 = nodeUtil2 && nodeUtil2.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array4, setter, iteratee, accumulator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        var value = array4[index2];
        setter(accumulator, value, iteratee(value), array4);
      }
      return accumulator;
    }
    function arrayEach(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (iteratee(array4[index2], index2, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEachRight(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      while (length--) {
        if (iteratee(array4[length], length, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEvery(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (!predicate(array4[index2], index2, array4)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter2(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (predicate(value, index2, array4)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array4, value) {
      var length = array4 == null ? 0 : array4.length;
      return !!length && baseIndexOf(array4, value, 0) > -1;
    }
    function arrayIncludesWith(array4, value, comparator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (comparator(value, array4[index2])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, result = Array(length);
      while (++index2 < length) {
        result[index2] = iteratee(array4[index2], index2, array4);
      }
      return result;
    }
    function arrayPush2(array4, values) {
      var index2 = -1, length = values.length, offset3 = array4.length;
      while (++index2 < length) {
        array4[offset3 + index2] = values[index2];
      }
      return array4;
    }
    function arrayReduce(array4, iteratee, accumulator, initAccum) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[++index2];
      }
      while (++index2 < length) {
        accumulator = iteratee(accumulator, array4[index2], index2, array4);
      }
      return accumulator;
    }
    function arrayReduceRight(array4, iteratee, accumulator, initAccum) {
      var length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array4[length], length, array4);
      }
      return accumulator;
    }
    function arraySome2(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty("length");
    function asciiToArray(string3) {
      return string3.split("");
    }
    function asciiWords(string3) {
      return string3.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function(value, key, collection2) {
        if (predicate(value, key, collection2)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array4, predicate, fromIndex, fromRight) {
      var length = array4.length, index2 = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index2-- : ++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIndexOf(array4, value, fromIndex) {
      return value === value ? strictIndexOf(array4, value, fromIndex) : baseFindIndex(array4, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array4, value, fromIndex, comparator) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (comparator(array4[index2], value)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      return length ? baseSum(array4, iteratee) / length : NAN;
    }
    function baseProperty(key) {
      return function(object4) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function basePropertyOf(object4) {
      return function(key) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function(value, index2, collection2) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index2, collection2);
      });
      return accumulator;
    }
    function baseSortBy(array4, comparer) {
      var length = array4.length;
      array4.sort(comparer);
      while (length--) {
        array4[length] = array4[length].value;
      }
      return array4;
    }
    function baseSum(array4, iteratee) {
      var result, index2 = -1, length = array4.length;
      while (++index2 < length) {
        var current2 = iteratee(array4[index2]);
        if (current2 !== undefined$1) {
          result = result === undefined$1 ? current2 : result + current2;
        }
      }
      return result;
    }
    function baseTimes2(n2, iteratee) {
      var index2 = -1, result = Array(n2);
      while (++index2 < n2) {
        result[index2] = iteratee(index2);
      }
      return result;
    }
    function baseToPairs(object4, props) {
      return arrayMap(props, function(key) {
        return [key, object4[key]];
      });
    }
    function baseTrim(string3) {
      return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
    }
    function baseUnary2(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object4, props) {
      return arrayMap(props, function(key) {
        return object4[key];
      });
    }
    function cacheHas2(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index2 = -1, length = strSymbols.length;
      while (++index2 < length && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index2 = strSymbols.length;
      while (index2-- && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function countHolders(array4, placeholder) {
      var length = array4.length, result = 0;
      while (length--) {
        if (array4[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue2(object4, key) {
      return object4 == null ? undefined$1 : object4[key];
    }
    function hasUnicode(string3) {
      return reHasUnicode.test(string3);
    }
    function hasUnicodeWord(string3) {
      return reHasUnicodeWord.test(string3);
    }
    function iteratorToArray(iterator2) {
      var data2, result = [];
      while (!(data2 = iterator2.next()).done) {
        result.push(data2.value);
      }
      return result;
    }
    function mapToArray2(map2) {
      var index2 = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index2] = [key, value];
      });
      return result;
    }
    function overArg2(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function replaceHolders(array4, placeholder) {
      var index2 = -1, length = array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (value === placeholder || value === PLACEHOLDER) {
          array4[index2] = PLACEHOLDER;
          result[resIndex++] = index2;
        }
      }
      return result;
    }
    function setToArray2(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = value;
      });
      return result;
    }
    function setToPairs(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex + 1;
      while (index2--) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return index2;
    }
    function stringSize(string3) {
      return hasUnicode(string3) ? unicodeSize(string3) : asciiSize(string3);
    }
    function stringToArray(string3) {
      return hasUnicode(string3) ? unicodeToArray(string3) : asciiToArray(string3);
    }
    function trimmedEndIndex(string3) {
      var index2 = string3.length;
      while (index2-- && reWhitespace.test(string3.charAt(index2))) {
      }
      return index2;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string3) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string3)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string3) {
      return string3.match(reUnicode) || [];
    }
    function unicodeWords(string3) {
      return string3.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext2(context) {
      context = context == null ? root2 : _.defaults(root2.Object(), context, _.pick(root2, contextProps));
      var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
      var arrayProto2 = Array2.prototype, funcProto2 = Function2.prototype, objectProto2 = Object2.prototype;
      var coreJsData2 = context["__core-js_shared__"];
      var funcToString2 = funcProto2.toString;
      var hasOwnProperty2 = objectProto2.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey2 = function() {
        var uid = /[^.]+$/.exec(coreJsData2 && coreJsData2.keys && coreJsData2.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var nativeObjectToString2 = objectProto2.toString;
      var objectCtorString = funcToString2.call(Object2);
      var oldDash = root2._;
      var reIsNative2 = RegExp2("^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? context.Buffer : undefined$1, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined$1, getPrototype = overArg2(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable2 = objectProto2.propertyIsEnumerable, splice2 = arrayProto2.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined$1, symIterator = Symbol2 ? Symbol2.iterator : undefined$1, symToStringTag2 = Symbol2 ? Symbol2.toStringTag : undefined$1;
      var defineProperty = function() {
        try {
          var func = getNative2(Object2, "defineProperty");
          func({}, "", {});
          return func;
        } catch (e2) {
        }
      }();
      var ctxClearTimeout = context.clearTimeout !== root2.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root2.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root2.setTimeout && context.setTimeout;
      var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols2 = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto2.join, nativeKeys2 = overArg2(Object2.keys, Object2), nativeMax = Math2.max, nativeMin = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto2.reverse;
      var DataView2 = getNative2(context, "DataView"), Map2 = getNative2(context, "Map"), Promise2 = getNative2(context, "Promise"), Set2 = getNative2(context, "Set"), WeakMap2 = getNative2(context, "WeakMap"), nativeCreate2 = getNative2(Object2, "create");
      var metaMap = WeakMap2 && new WeakMap2();
      var realNames = {};
      var dataViewCtorString2 = toSource2(DataView2), mapCtorString2 = toSource2(Map2), promiseCtorString2 = toSource2(Promise2), setCtorString2 = toSource2(Set2), weakMapCtorString2 = toSource2(WeakMap2);
      var symbolProto2 = Symbol2 ? Symbol2.prototype : undefined$1, symbolValueOf2 = symbolProto2 ? symbolProto2.valueOf : undefined$1, symbolToString = symbolProto2 ? symbolProto2.toString : undefined$1;
      function lodash2(value) {
        if (isObjectLike2(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty2.call(value, "__wrapped__")) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = function() {
        function object4() {
        }
        return function(proto2) {
          if (!isObject2(proto2)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto2);
          }
          object4.prototype = proto2;
          var result2 = new object4();
          object4.prototype = undefined$1;
          return result2;
        };
      }();
      function baseLodash() {
      }
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash2.templateSettings = {
        "escape": reEscape,
        "evaluate": reEvaluate,
        "interpolate": reInterpolate,
        "variable": "",
        "imports": {
          "_": lodash2
        }
      };
      lodash2.prototype = baseLodash.prototype;
      lodash2.prototype.constructor = lodash2;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result2 = new LazyWrapper(this.__wrapped__);
        result2.__actions__ = copyArray(this.__actions__);
        result2.__dir__ = this.__dir__;
        result2.__filtered__ = this.__filtered__;
        result2.__iteratees__ = copyArray(this.__iteratees__);
        result2.__takeCount__ = this.__takeCount__;
        result2.__views__ = copyArray(this.__views__);
        return result2;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result2 = new LazyWrapper(this);
          result2.__dir__ = -1;
          result2.__filtered__ = true;
        } else {
          result2 = this.clone();
          result2.__dir__ *= -1;
        }
        return result2;
      }
      function lazyValue() {
        var array4 = this.__wrapped__.value(), dir3 = this.__dir__, isArr = isArray2(array4), isRight = dir3 < 0, arrLength = isArr ? array4.length : 0, view = getView(0, arrLength, this.__views__), start2 = view.start, end2 = view.end, length = end2 - start2, index2 = isRight ? end2 : start2 - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array4, this.__actions__);
        }
        var result2 = [];
        outer:
          while (length-- && resIndex < takeCount) {
            index2 += dir3;
            var iterIndex = -1, value = array4[index2];
            while (++iterIndex < iterLength) {
              var data2 = iteratees[iterIndex], iteratee2 = data2.iteratee, type4 = data2.type, computed = iteratee2(value);
              if (type4 == LAZY_MAP_FLAG) {
                value = computed;
              } else if (!computed) {
                if (type4 == LAZY_FILTER_FLAG) {
                  continue outer;
                } else {
                  break outer;
                }
              }
            }
            result2[resIndex++] = value;
          }
        return result2;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear2() {
        this.__data__ = nativeCreate2 ? nativeCreate2(null) : {};
        this.size = 0;
      }
      function hashDelete2(key) {
        var result2 = this.has(key) && delete this.__data__[key];
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function hashGet2(key) {
        var data2 = this.__data__;
        if (nativeCreate2) {
          var result2 = data2[key];
          return result2 === HASH_UNDEFINED2 ? undefined$1 : result2;
        }
        return hasOwnProperty2.call(data2, key) ? data2[key] : undefined$1;
      }
      function hashHas2(key) {
        var data2 = this.__data__;
        return nativeCreate2 ? data2[key] !== undefined$1 : hasOwnProperty2.call(data2, key);
      }
      function hashSet2(key, value) {
        var data2 = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data2[key] = nativeCreate2 && value === undefined$1 ? HASH_UNDEFINED2 : value;
        return this;
      }
      Hash2.prototype.clear = hashClear2;
      Hash2.prototype["delete"] = hashDelete2;
      Hash2.prototype.get = hashGet2;
      Hash2.prototype.has = hashHas2;
      Hash2.prototype.set = hashSet2;
      function ListCache2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear2() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete2(key) {
        var data2 = this.__data__, index2 = assocIndexOf2(data2, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data2.length - 1;
        if (index2 == lastIndex) {
          data2.pop();
        } else {
          splice2.call(data2, index2, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet2(key) {
        var data2 = this.__data__, index2 = assocIndexOf2(data2, key);
        return index2 < 0 ? undefined$1 : data2[index2][1];
      }
      function listCacheHas2(key) {
        return assocIndexOf2(this.__data__, key) > -1;
      }
      function listCacheSet2(key, value) {
        var data2 = this.__data__, index2 = assocIndexOf2(data2, key);
        if (index2 < 0) {
          ++this.size;
          data2.push([key, value]);
        } else {
          data2[index2][1] = value;
        }
        return this;
      }
      ListCache2.prototype.clear = listCacheClear2;
      ListCache2.prototype["delete"] = listCacheDelete2;
      ListCache2.prototype.get = listCacheGet2;
      ListCache2.prototype.has = listCacheHas2;
      ListCache2.prototype.set = listCacheSet2;
      function MapCache2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear2() {
        this.size = 0;
        this.__data__ = {
          "hash": new Hash2(),
          "map": new (Map2 || ListCache2)(),
          "string": new Hash2()
        };
      }
      function mapCacheDelete2(key) {
        var result2 = getMapData2(this, key)["delete"](key);
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function mapCacheGet2(key) {
        return getMapData2(this, key).get(key);
      }
      function mapCacheHas2(key) {
        return getMapData2(this, key).has(key);
      }
      function mapCacheSet2(key, value) {
        var data2 = getMapData2(this, key), size2 = data2.size;
        data2.set(key, value);
        this.size += data2.size == size2 ? 0 : 1;
        return this;
      }
      MapCache2.prototype.clear = mapCacheClear2;
      MapCache2.prototype["delete"] = mapCacheDelete2;
      MapCache2.prototype.get = mapCacheGet2;
      MapCache2.prototype.has = mapCacheHas2;
      MapCache2.prototype.set = mapCacheSet2;
      function SetCache2(values2) {
        var index2 = -1, length = values2 == null ? 0 : values2.length;
        this.__data__ = new MapCache2();
        while (++index2 < length) {
          this.add(values2[index2]);
        }
      }
      function setCacheAdd2(value) {
        this.__data__.set(value, HASH_UNDEFINED2);
        return this;
      }
      function setCacheHas2(value) {
        return this.__data__.has(value);
      }
      SetCache2.prototype.add = SetCache2.prototype.push = setCacheAdd2;
      SetCache2.prototype.has = setCacheHas2;
      function Stack2(entries) {
        var data2 = this.__data__ = new ListCache2(entries);
        this.size = data2.size;
      }
      function stackClear2() {
        this.__data__ = new ListCache2();
        this.size = 0;
      }
      function stackDelete2(key) {
        var data2 = this.__data__, result2 = data2["delete"](key);
        this.size = data2.size;
        return result2;
      }
      function stackGet2(key) {
        return this.__data__.get(key);
      }
      function stackHas2(key) {
        return this.__data__.has(key);
      }
      function stackSet2(key, value) {
        var data2 = this.__data__;
        if (data2 instanceof ListCache2) {
          var pairs = data2.__data__;
          if (!Map2 || pairs.length < LARGE_ARRAY_SIZE2 - 1) {
            pairs.push([key, value]);
            this.size = ++data2.size;
            return this;
          }
          data2 = this.__data__ = new MapCache2(pairs);
        }
        data2.set(key, value);
        this.size = data2.size;
        return this;
      }
      Stack2.prototype.clear = stackClear2;
      Stack2.prototype["delete"] = stackDelete2;
      Stack2.prototype.get = stackGet2;
      Stack2.prototype.has = stackHas2;
      Stack2.prototype.set = stackSet2;
      function arrayLikeKeys2(value, inherited) {
        var isArr = isArray2(value), isArg = !isArr && isArguments2(value), isBuff = !isArr && !isArg && isBuffer2(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes2(value.length, String2) : [], length = result2.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex2(key, length)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function arraySample(array4) {
        var length = array4.length;
        return length ? array4[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array4, n2) {
        return shuffleSelf(copyArray(array4), baseClamp(n2, 0, array4.length));
      }
      function arrayShuffle(array4) {
        return shuffleSelf(copyArray(array4));
      }
      function assignMergeValue(object4, key, value) {
        if (value !== undefined$1 && !eq2(object4[key], value) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assignValue(object4, key, value) {
        var objValue = object4[key];
        if (!(hasOwnProperty2.call(object4, key) && eq2(objValue, value)) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assocIndexOf2(array4, key) {
        var length = array4.length;
        while (length--) {
          if (eq2(array4[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee2, accumulator) {
        baseEach(collection, function(value, key, collection2) {
          setter(accumulator, value, iteratee2(value), collection2);
        });
        return accumulator;
      }
      function baseAssign(object4, source) {
        return object4 && copyObject(source, keys2(source), object4);
      }
      function baseAssignIn(object4, source) {
        return object4 && copyObject(source, keysIn(source), object4);
      }
      function baseAssignValue(object4, key, value) {
        if (key == "__proto__" && defineProperty) {
          defineProperty(object4, key, {
            "configurable": true,
            "enumerable": true,
            "value": value,
            "writable": true
          });
        } else {
          object4[key] = value;
        }
      }
      function baseAt(object4, paths) {
        var index2 = -1, length = paths.length, result2 = Array2(length), skip = object4 == null;
        while (++index2 < length) {
          result2[index2] = skip ? undefined$1 : get2(object4, paths[index2]);
        }
        return result2;
      }
      function baseClamp(number4, lower, upper) {
        if (number4 === number4) {
          if (upper !== undefined$1) {
            number4 = number4 <= upper ? number4 : upper;
          }
          if (lower !== undefined$1) {
            number4 = number4 >= lower ? number4 : lower;
          }
        }
        return number4;
      }
      function baseClone(value, bitmask, customizer, key, object4, stack) {
        var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result2 = object4 ? customizer(value, key, object4, stack) : customizer(value);
        }
        if (result2 !== undefined$1) {
          return result2;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result2 = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result2);
          }
        } else {
          var tag = getTag2(value), isFunc = tag == funcTag2 || tag == genTag2;
          if (isBuffer2(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag2 || tag == argsTag2 || isFunc && !object4) {
            result2 = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object4 ? value : {};
            }
            result2 = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack2());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result2);
        if (isSet(value)) {
          value.forEach(function(subValue) {
            result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function(subValue, key2) {
            result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys2 : isFlat ? keysIn : keys2;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
        return result2;
      }
      function baseConforms(source) {
        var props = keys2(source);
        return function(object4) {
          return baseConformsTo(object4, source, props);
        };
      }
      function baseConformsTo(object4, source, props) {
        var length = props.length;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (length--) {
          var key = props[length], predicate = source[key], value = object4[key];
          if (value === undefined$1 && !(key in object4) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        return setTimeout2(function() {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array4, values2, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, isCommon = true, length = array4.length, result2 = [], valuesLength = values2.length;
        if (!length) {
          return result2;
        }
        if (iteratee2) {
          values2 = arrayMap(values2, baseUnary2(iteratee2));
        }
        if (comparator) {
          includes2 = arrayIncludesWith;
          isCommon = false;
        } else if (values2.length >= LARGE_ARRAY_SIZE2) {
          includes2 = cacheHas2;
          isCommon = false;
          values2 = new SetCache2(values2);
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 == null ? value : iteratee2(value);
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var valuesIndex = valuesLength;
              while (valuesIndex--) {
                if (values2[valuesIndex] === computed) {
                  continue outer;
                }
              }
              result2.push(value);
            } else if (!includes2(values2, computed, comparator)) {
              result2.push(value);
            }
          }
        return result2;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result2 = true;
        baseEach(collection, function(value, index2, collection2) {
          result2 = !!predicate(value, index2, collection2);
          return result2;
        });
        return result2;
      }
      function baseExtremum(array4, iteratee2, comparator) {
        var index2 = -1, length = array4.length;
        while (++index2 < length) {
          var value = array4[index2], current2 = iteratee2(value);
          if (current2 != null && (computed === undefined$1 ? current2 === current2 && !isSymbol(current2) : comparator(current2, computed))) {
            var computed = current2, result2 = value;
          }
        }
        return result2;
      }
      function baseFill(array4, value, start2, end2) {
        var length = array4.length;
        start2 = toInteger(start2);
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 === undefined$1 || end2 > length ? length : toInteger(end2);
        if (end2 < 0) {
          end2 += length;
        }
        end2 = start2 > end2 ? 0 : toLength(end2);
        while (start2 < end2) {
          array4[start2++] = value;
        }
        return array4;
      }
      function baseFilter(collection, predicate) {
        var result2 = [];
        baseEach(collection, function(value, index2, collection2) {
          if (predicate(value, index2, collection2)) {
            result2.push(value);
          }
        });
        return result2;
      }
      function baseFlatten(array4, depth, predicate, isStrict, result2) {
        var index2 = -1, length = array4.length;
        predicate || (predicate = isFlattenable);
        result2 || (result2 = []);
        while (++index2 < length) {
          var value = array4[index2];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result2);
            } else {
              arrayPush2(result2, value);
            }
          } else if (!isStrict) {
            result2[result2.length] = value;
          }
        }
        return result2;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object4, iteratee2) {
        return object4 && baseFor(object4, iteratee2, keys2);
      }
      function baseForOwnRight(object4, iteratee2) {
        return object4 && baseForRight(object4, iteratee2, keys2);
      }
      function baseFunctions(object4, props) {
        return arrayFilter2(props, function(key) {
          return isFunction2(object4[key]);
        });
      }
      function baseGet(object4, path) {
        path = castPath(path, object4);
        var index2 = 0, length = path.length;
        while (object4 != null && index2 < length) {
          object4 = object4[toKey(path[index2++])];
        }
        return index2 && index2 == length ? object4 : undefined$1;
      }
      function baseGetAllKeys2(object4, keysFunc, symbolsFunc) {
        var result2 = keysFunc(object4);
        return isArray2(object4) ? result2 : arrayPush2(result2, symbolsFunc(object4));
      }
      function baseGetTag2(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag2 : nullTag2;
        }
        return symToStringTag2 && symToStringTag2 in Object2(value) ? getRawTag2(value) : objectToString2(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object4, key) {
        return object4 != null && hasOwnProperty2.call(object4, key);
      }
      function baseHasIn(object4, key) {
        return object4 != null && key in Object2(object4);
      }
      function baseInRange(number4, start2, end2) {
        return number4 >= nativeMin(start2, end2) && number4 < nativeMax(start2, end2);
      }
      function baseIntersection(arrays, iteratee2, comparator) {
        var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
        while (othIndex--) {
          var array4 = arrays[othIndex];
          if (othIndex && iteratee2) {
            array4 = arrayMap(array4, baseUnary2(iteratee2));
          }
          maxLength = nativeMin(array4.length, maxLength);
          caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array4.length >= 120) ? new SetCache2(othIndex && array4) : undefined$1;
        }
        array4 = arrays[0];
        var index2 = -1, seen = caches[0];
        outer:
          while (++index2 < length && result2.length < maxLength) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (!(seen ? cacheHas2(seen, computed) : includes2(result2, computed, comparator))) {
              othIndex = othLength;
              while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache ? cacheHas2(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                  continue outer;
                }
              }
              if (seen) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseInverter(object4, setter, iteratee2, accumulator) {
        baseForOwn(object4, function(value, key, object5) {
          setter(accumulator, iteratee2(value), key, object5);
        });
        return accumulator;
      }
      function baseInvoke(object4, path, args) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        var func = object4 == null ? object4 : object4[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object4, args);
      }
      function baseIsArguments2(value) {
        return isObjectLike2(value) && baseGetTag2(value) == argsTag2;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike2(value) && baseGetTag2(value) == arrayBufferTag2;
      }
      function baseIsDate(value) {
        return isObjectLike2(value) && baseGetTag2(value) == dateTag2;
      }
      function baseIsEqual2(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike2(value) && !isObjectLike2(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep2(value, other, bitmask, customizer, baseIsEqual2, stack);
      }
      function baseIsEqualDeep2(object4, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray2(object4), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag2 : getTag2(object4), othTag = othIsArr ? arrayTag2 : getTag2(other);
        objTag = objTag == argsTag2 ? objectTag2 : objTag;
        othTag = othTag == argsTag2 ? objectTag2 : othTag;
        var objIsObj = objTag == objectTag2, othIsObj = othTag == objectTag2, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer2(object4)) {
          if (!isBuffer2(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack2());
          return objIsArr || isTypedArray2(object4) ? equalArrays2(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag2(object4, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG2)) {
          var objIsWrapped = objIsObj && hasOwnProperty2.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack2());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack2());
        return equalObjects2(object4, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike2(value) && getTag2(value) == mapTag2;
      }
      function baseIsMatch(object4, source, matchData, customizer) {
        var index2 = matchData.length, length = index2, noCustomizer = !customizer;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (index2--) {
          var data2 = matchData[index2];
          if (noCustomizer && data2[2] ? data2[1] !== object4[data2[0]] : !(data2[0] in object4)) {
            return false;
          }
        }
        while (++index2 < length) {
          data2 = matchData[index2];
          var key = data2[0], objValue = object4[key], srcValue = data2[1];
          if (noCustomizer && data2[2]) {
            if (objValue === undefined$1 && !(key in object4)) {
              return false;
            }
          } else {
            var stack = new Stack2();
            if (customizer) {
              var result2 = customizer(objValue, srcValue, key, object4, source, stack);
            }
            if (!(result2 === undefined$1 ? baseIsEqual2(srcValue, objValue, COMPARE_PARTIAL_FLAG2 | COMPARE_UNORDERED_FLAG2, customizer, stack) : result2)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative2(value) {
        if (!isObject2(value) || isMasked2(value)) {
          return false;
        }
        var pattern4 = isFunction2(value) ? reIsNative2 : reIsHostCtor2;
        return pattern4.test(toSource2(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike2(value) && baseGetTag2(value) == regexpTag2;
      }
      function baseIsSet(value) {
        return isObjectLike2(value) && getTag2(value) == setTag2;
      }
      function baseIsTypedArray2(value) {
        return isObjectLike2(value) && isLength2(value.length) && !!typedArrayTags2[baseGetTag2(value)];
      }
      function baseIteratee(value) {
        if (typeof value == "function") {
          return value;
        }
        if (value == null) {
          return identity2;
        }
        if (typeof value == "object") {
          return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys2(object4) {
        if (!isPrototype2(object4)) {
          return nativeKeys2(object4);
        }
        var result2 = [];
        for (var key in Object2(object4)) {
          if (hasOwnProperty2.call(object4, key) && key != "constructor") {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseKeysIn(object4) {
        if (!isObject2(object4)) {
          return nativeKeysIn(object4);
        }
        var isProto = isPrototype2(object4), result2 = [];
        for (var key in object4) {
          if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object4, key)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee2) {
        var index2 = -1, result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value, key, collection2) {
          result2[++index2] = iteratee2(value, key, collection2);
        });
        return result2;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function(object4) {
          return object4 === source || baseIsMatch(object4, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function(object4) {
          var objValue = get2(object4, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object4, path) : baseIsEqual2(srcValue, objValue, COMPARE_PARTIAL_FLAG2 | COMPARE_UNORDERED_FLAG2);
        };
      }
      function baseMerge(object4, source, srcIndex, customizer, stack) {
        if (object4 === source) {
          return;
        }
        baseFor(source, function(srcValue, key) {
          stack || (stack = new Stack2());
          if (isObject2(srcValue)) {
            baseMergeDeep(object4, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object4, key), srcValue, key + "", object4, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object4, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object4, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object4, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object4, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + "", object4, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer2(srcValue), isTyped = !isArr && !isBuff && isTypedArray2(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray2(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments2(srcValue)) {
            newValue = objValue;
            if (isArguments2(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject2(objValue) || isFunction2(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack["delete"](srcValue);
        }
        assignMergeValue(object4, key, newValue);
      }
      function baseNth(array4, n2) {
        var length = array4.length;
        if (!length) {
          return;
        }
        n2 += n2 < 0 ? length : 0;
        return isIndex2(n2, length) ? array4[n2] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function(iteratee2) {
            if (isArray2(iteratee2)) {
              return function(value) {
                return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
              };
            }
            return iteratee2;
          });
        } else {
          iteratees = [identity2];
        }
        var index2 = -1;
        iteratees = arrayMap(iteratees, baseUnary2(getIteratee()));
        var result2 = baseMap(collection, function(value, key, collection2) {
          var criteria = arrayMap(iteratees, function(iteratee2) {
            return iteratee2(value);
          });
          return { "criteria": criteria, "index": ++index2, "value": value };
        });
        return baseSortBy(result2, function(object4, other) {
          return compareMultiple(object4, other, orders);
        });
      }
      function basePick(object4, paths) {
        return basePickBy(object4, paths, function(value, path) {
          return hasIn(object4, path);
        });
      }
      function basePickBy(object4, paths, predicate) {
        var index2 = -1, length = paths.length, result2 = {};
        while (++index2 < length) {
          var path = paths[index2], value = baseGet(object4, path);
          if (predicate(value, path)) {
            baseSet(result2, castPath(path, object4), value);
          }
        }
        return result2;
      }
      function basePropertyDeep(path) {
        return function(object4) {
          return baseGet(object4, path);
        };
      }
      function basePullAll(array4, values2, iteratee2, comparator) {
        var indexOf3 = comparator ? baseIndexOfWith : baseIndexOf, index2 = -1, length = values2.length, seen = array4;
        if (array4 === values2) {
          values2 = copyArray(values2);
        }
        if (iteratee2) {
          seen = arrayMap(array4, baseUnary2(iteratee2));
        }
        while (++index2 < length) {
          var fromIndex = 0, value = values2[index2], computed = iteratee2 ? iteratee2(value) : value;
          while ((fromIndex = indexOf3(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array4) {
              splice2.call(seen, fromIndex, 1);
            }
            splice2.call(array4, fromIndex, 1);
          }
        }
        return array4;
      }
      function basePullAt(array4, indexes) {
        var length = array4 ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index2 = indexes[length];
          if (length == lastIndex || index2 !== previous) {
            var previous = index2;
            if (isIndex2(index2)) {
              splice2.call(array4, index2, 1);
            } else {
              baseUnset(array4, index2);
            }
          }
        }
        return array4;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start2, end2, step, fromRight) {
        var index2 = -1, length = nativeMax(nativeCeil((end2 - start2) / (step || 1)), 0), result2 = Array2(length);
        while (length--) {
          result2[fromRight ? length : ++index2] = start2;
          start2 += step;
        }
        return result2;
      }
      function baseRepeat(string3, n2) {
        var result2 = "";
        if (!string3 || n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return result2;
        }
        do {
          if (n2 % 2) {
            result2 += string3;
          }
          n2 = nativeFloor(n2 / 2);
          if (n2) {
            string3 += string3;
          }
        } while (n2);
        return result2;
      }
      function baseRest(func, start2) {
        return setToString(overRest(func, start2, identity2), func + "");
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n2) {
        var array4 = values(collection);
        return shuffleSelf(array4, baseClamp(n2, 0, array4.length));
      }
      function baseSet(object4, path, value, customizer) {
        if (!isObject2(object4)) {
          return object4;
        }
        path = castPath(path, object4);
        var index2 = -1, length = path.length, lastIndex = length - 1, nested = object4;
        while (nested != null && ++index2 < length) {
          var key = toKey(path[index2]), newValue = value;
          if (key === "__proto__" || key === "constructor" || key === "prototype") {
            return object4;
          }
          if (index2 != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject2(objValue) ? objValue : isIndex2(path[index2 + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object4;
      }
      var baseSetData = !metaMap ? identity2 : function(func, data2) {
        metaMap.set(func, data2);
        return func;
      };
      var baseSetToString = !defineProperty ? identity2 : function(func, string3) {
        return defineProperty(func, "toString", {
          "configurable": true,
          "enumerable": false,
          "value": constant(string3),
          "writable": true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array4, start2, end2) {
        var index2 = -1, length = array4.length;
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 > length ? length : end2;
        if (end2 < 0) {
          end2 += length;
        }
        length = start2 > end2 ? 0 : end2 - start2 >>> 0;
        start2 >>>= 0;
        var result2 = Array2(length);
        while (++index2 < length) {
          result2[index2] = array4[index2 + start2];
        }
        return result2;
      }
      function baseSome(collection, predicate) {
        var result2;
        baseEach(collection, function(value, index2, collection2) {
          result2 = predicate(value, index2, collection2);
          return !result2;
        });
        return !!result2;
      }
      function baseSortedIndex(array4, value, retHighest) {
        var low = 0, high = array4 == null ? low : array4.length;
        if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array4[mid];
            if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array4, value, identity2, retHighest);
      }
      function baseSortedIndexBy(array4, value, iteratee2, retHighest) {
        var low = 0, high = array4 == null ? 0 : array4.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee2(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee2(array4[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array4, iteratee2) {
        var index2 = -1, length = array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
          if (!index2 || !eq2(computed, seen)) {
            var seen = computed;
            result2[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result2;
      }
      function baseToNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == "string") {
          return value;
        }
        if (isArray2(value)) {
          return arrayMap(value, baseToString) + "";
        }
        if (isSymbol(value)) {
          return symbolToString ? symbolToString.call(value) : "";
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function baseUniq(array4, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, length = array4.length, isCommon = true, result2 = [], seen = result2;
        if (comparator) {
          isCommon = false;
          includes2 = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE2) {
          var set3 = iteratee2 ? null : createSet(array4);
          if (set3) {
            return setToArray2(set3);
          }
          isCommon = false;
          includes2 = cacheHas2;
          seen = new SetCache2();
        } else {
          seen = iteratee2 ? [] : result2;
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var seenIndex = seen.length;
              while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                  continue outer;
                }
              }
              if (iteratee2) {
                seen.push(computed);
              }
              result2.push(value);
            } else if (!includes2(seen, computed, comparator)) {
              if (seen !== result2) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseUnset(object4, path) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        return object4 == null || delete object4[toKey(last(path))];
      }
      function baseUpdate(object4, path, updater, customizer) {
        return baseSet(object4, path, updater(baseGet(object4, path)), customizer);
      }
      function baseWhile(array4, predicate, isDrop, fromRight) {
        var length = array4.length, index2 = fromRight ? length : -1;
        while ((fromRight ? index2-- : ++index2 < length) && predicate(array4[index2], index2, array4)) {
        }
        return isDrop ? baseSlice(array4, fromRight ? 0 : index2, fromRight ? index2 + 1 : length) : baseSlice(array4, fromRight ? index2 + 1 : 0, fromRight ? length : index2);
      }
      function baseWrapperValue(value, actions2) {
        var result2 = value;
        if (result2 instanceof LazyWrapper) {
          result2 = result2.value();
        }
        return arrayReduce(actions2, function(result3, action) {
          return action.func.apply(action.thisArg, arrayPush2([result3], action.args));
        }, result2);
      }
      function baseXor(arrays, iteratee2, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index2 = -1, result2 = Array2(length);
        while (++index2 < length) {
          var array4 = arrays[index2], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index2) {
              result2[index2] = baseDifference(result2[index2] || array4, arrays[othIndex], iteratee2, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
      }
      function baseZipObject(props, values2, assignFunc) {
        var index2 = -1, length = props.length, valsLength = values2.length, result2 = {};
        while (++index2 < length) {
          var value = index2 < valsLength ? values2[index2] : undefined$1;
          assignFunc(result2, props[index2], value);
        }
        return result2;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == "function" ? value : identity2;
      }
      function castPath(value, object4) {
        if (isArray2(value)) {
          return value;
        }
        return isKey(value, object4) ? [value] : stringToPath(toString2(value));
      }
      var castRest = baseRest;
      function castSlice(array4, start2, end2) {
        var length = array4.length;
        end2 = end2 === undefined$1 ? length : end2;
        return !start2 && end2 >= length ? array4 : baseSlice(array4, start2, end2);
      }
      var clearTimeout2 = ctxClearTimeout || function(id2) {
        return root2.clearTimeout(id2);
      };
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result2);
        return result2;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
        return result2;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp4) {
        var result2 = new regexp4.constructor(regexp4.source, reFlags.exec(regexp4));
        result2.lastIndex = regexp4.lastIndex;
        return result2;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf2 ? Object2(symbolValueOf2.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object4, other, orders) {
        var index2 = -1, objCriteria = object4.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index2 < length) {
          var result2 = compareAscending(objCriteria[index2], othCriteria[index2]);
          if (result2) {
            if (index2 >= ordersLength) {
              return result2;
            }
            var order = orders[index2];
            return result2 * (order == "desc" ? -1 : 1);
          }
        }
        return object4.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result2[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result2[leftIndex++] = args[argsIndex++];
        }
        return result2;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result2[argsIndex] = args[argsIndex];
        }
        var offset3 = argsIndex;
        while (++rightIndex < rightLength) {
          result2[offset3 + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[offset3 + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result2;
      }
      function copyArray(source, array4) {
        var index2 = -1, length = source.length;
        array4 || (array4 = Array2(length));
        while (++index2 < length) {
          array4[index2] = source[index2];
        }
        return array4;
      }
      function copyObject(source, props, object4, customizer) {
        var isNew = !object4;
        object4 || (object4 = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object4[key], source[key], key, object4, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object4, key, newValue);
          } else {
            assignValue(object4, key, newValue);
          }
        }
        return object4;
      }
      function copySymbols(source, object4) {
        return copyObject(source, getSymbols2(source), object4);
      }
      function copySymbolsIn(source, object4) {
        return copyObject(source, getSymbolsIn(source), object4);
      }
      function createAggregator(setter, initializer) {
        return function(collection, iteratee2) {
          var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function(object4, sources) {
          var index2 = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object4 = Object2(object4);
          while (++index2 < length) {
            var source = sources[index2];
            if (source) {
              assigner(object4, source, index2, customizer);
            }
          }
          return object4;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function(collection, iteratee2) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike2(collection)) {
            return eachFunc(collection, iteratee2);
          }
          var length = collection.length, index2 = fromRight ? length : -1, iterable = Object2(collection);
          while (fromRight ? index2-- : ++index2 < length) {
            if (iteratee2(iterable[index2], index2, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function(object4, iteratee2, keysFunc) {
          var index2 = -1, iterable = Object2(object4), props = keysFunc(object4), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index2];
            if (iteratee2(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object4;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function(string3) {
          string3 = toString2(string3);
          var strSymbols = hasUnicode(string3) ? stringToArray(string3) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string3.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function(string3) {
          return arrayReduce(words(deburr(string3).replace(reApos, "")), callback, "");
        };
      }
      function createCtor(Ctor) {
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
          return isObject2(result2) ? result2 : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length, placeholder = getHolder(wrapper);
          while (index2--) {
            args[index2] = arguments[index2];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function(collection, predicate, fromIndex) {
          var iterable = Object2(collection);
          if (!isArrayLike2(collection)) {
            var iteratee2 = getIteratee(predicate, 3);
            collection = keys2(collection);
            predicate = function(key) {
              return iteratee2(iterable[key], key, iterable);
            };
          }
          var index2 = findIndexFunc(collection, predicate, fromIndex);
          return index2 > -1 ? iterable[iteratee2 ? collection[index2] : index2] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function(funcs) {
          var length = funcs.length, index2 = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index2--) {
            var func = funcs[index2];
            if (typeof func != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT);
            }
            if (prereq && !wrapper && getFuncName(func) == "wrapper") {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index2 = wrapper ? index2 : length;
          while (++index2 < length) {
            func = funcs[index2];
            var funcName = getFuncName(func), data2 = funcName == "wrapper" ? getData(func) : undefined$1;
            if (data2 && isLaziable(data2[0]) && data2[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data2[4].length && data2[9] == 1) {
              wrapper = wrapper[getFuncName(data2[0])].apply(wrapper, data2[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function() {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray2(value)) {
              return wrapper.plant(value).value();
            }
            var index3 = 0, result2 = length ? funcs[index3].apply(this, args) : value;
            while (++index3 < length) {
              result2 = funcs[index3].call(this, result2);
            }
            return result2;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length;
          while (index2--) {
            args[index2] = arguments[index2];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary2 < length) {
            args.length = ary2;
          }
          if (this && this !== root2 && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function(object4, iteratee2) {
          return baseInverter(object4, setter, toIteratee(iteratee2), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function(value, other) {
          var result2;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result2 = value;
          }
          if (other !== undefined$1) {
            if (result2 === undefined$1) {
              return other;
            }
            if (typeof value == "string" || typeof other == "string") {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result2 = operator(value, other);
          }
          return result2;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function(iteratees) {
          iteratees = arrayMap(iteratees, baseUnary2(getIteratee()));
          return baseRest(function(args) {
            var thisArg = this;
            return arrayFunc(iteratees, function(iteratee2) {
              return apply(iteratee2, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? " " : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function(start2, end2, step) {
          if (step && typeof step != "number" && isIterateeCall(start2, end2, step)) {
            end2 = step = undefined$1;
          }
          start2 = toFinite(start2);
          if (end2 === undefined$1) {
            end2 = start2;
            start2 = 0;
          } else {
            end2 = toFinite(end2);
          }
          step = step === undefined$1 ? start2 < end2 ? 1 : -1 : toFinite(step);
          return baseRange(start2, end2, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function(value, other) {
          if (!(typeof value == "string" && typeof other == "string")) {
            value = toNumber(value);
            other = toNumber(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [
          func,
          bitmask,
          thisArg,
          newPartials,
          newHolders,
          newPartialsRight,
          newHoldersRight,
          argPos,
          ary2,
          arity
        ];
        var result2 = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result2, newData);
        }
        result2.placeholder = placeholder;
        return setWrapToString(result2, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math2[methodName];
        return function(number4, precision) {
          number4 = toNumber(number4);
          precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
          if (precision && nativeIsFinite(number4)) {
            var pair = (toString2(number4) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
            pair = (toString2(value) + "e").split("e");
            return +(pair[0] + "e" + (+pair[1] - precision));
          }
          return func(number4);
        };
      }
      var createSet = !(Set2 && 1 / setToArray2(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
        return new Set2(values2);
      };
      function createToPairs(keysFunc) {
        return function(object4) {
          var tag = getTag2(object4);
          if (tag == mapTag2) {
            return mapToArray2(object4);
          }
          if (tag == setTag2) {
            return setToPairs(object4);
          }
          return baseToPairs(object4, keysFunc(object4));
        };
      }
      function createWrap2(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary2 = ary2 === undefined$1 ? ary2 : nativeMax(toInteger(ary2), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data2 = isBindKey ? undefined$1 : getData(func);
        var newData = [
          func,
          bitmask,
          thisArg,
          partials,
          holders,
          partialsRight,
          holdersRight,
          argPos,
          ary2,
          arity
        ];
        if (data2) {
          mergeData(newData, data2);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result2 = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result2 = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result2 = createPartial(func, bitmask, thisArg, partials);
        } else {
          result2 = createHybrid.apply(undefined$1, newData);
        }
        var setter = data2 ? baseSetData : setData;
        return setWrapToString(setter(result2, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object4) {
        if (objValue === undefined$1 || eq2(objValue, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object4, source, stack) {
        if (isObject2(objValue) && isObject2(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack["delete"](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays2(array4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG2, arrLength = array4.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array4);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array4;
        }
        var index2 = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG2 ? new SetCache2() : undefined$1;
        stack.set(array4, other);
        stack.set(other, array4);
        while (++index2 < arrLength) {
          var arrValue = array4[index2], othValue = other[index2];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result2 = false;
            break;
          }
          if (seen) {
            if (!arraySome2(other, function(othValue2, othIndex) {
              if (!cacheHas2(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result2 = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result2 = false;
            break;
          }
        }
        stack["delete"](array4);
        stack["delete"](other);
        return result2;
      }
      function equalByTag2(object4, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag2:
            if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
              return false;
            }
            object4 = object4.buffer;
            other = other.buffer;
          case arrayBufferTag2:
            if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object4), new Uint8Array2(other))) {
              return false;
            }
            return true;
          case boolTag2:
          case dateTag2:
          case numberTag2:
            return eq2(+object4, +other);
          case errorTag2:
            return object4.name == other.name && object4.message == other.message;
          case regexpTag2:
          case stringTag2:
            return object4 == other + "";
          case mapTag2:
            var convert = mapToArray2;
          case setTag2:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG2;
            convert || (convert = setToArray2);
            if (object4.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object4);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG2;
            stack.set(object4, other);
            var result2 = equalArrays2(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
            stack["delete"](object4);
            return result2;
          case symbolTag2:
            if (symbolValueOf2) {
              return symbolValueOf2.call(object4) == symbolValueOf2.call(other);
            }
        }
        return false;
      }
      function equalObjects2(object4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG2, objProps = getAllKeys2(object4), objLength = objProps.length, othProps = getAllKeys2(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index2 = objLength;
        while (index2--) {
          var key = objProps[index2];
          if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object4);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object4;
        }
        var result2 = true;
        stack.set(object4, other);
        stack.set(other, object4);
        var skipCtor = isPartial;
        while (++index2 < objLength) {
          key = objProps[index2];
          var objValue = object4[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result2 = false;
            break;
          }
          skipCtor || (skipCtor = key == "constructor");
        }
        if (result2 && !skipCtor) {
          var objCtor = object4.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
            result2 = false;
          }
        }
        stack["delete"](object4);
        stack["delete"](other);
        return result2;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + "");
      }
      function getAllKeys2(object4) {
        return baseGetAllKeys2(object4, keys2, getSymbols2);
      }
      function getAllKeysIn(object4) {
        return baseGetAllKeys2(object4, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop2 : function(func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result2 = func.name + "", array4 = realNames[result2], length = hasOwnProperty2.call(realNames, result2) ? array4.length : 0;
        while (length--) {
          var data2 = array4[length], otherFunc = data2.func;
          if (otherFunc == null || otherFunc == func) {
            return data2.name;
          }
        }
        return result2;
      }
      function getHolder(func) {
        var object4 = hasOwnProperty2.call(lodash2, "placeholder") ? lodash2 : func;
        return object4.placeholder;
      }
      function getIteratee() {
        var result2 = lodash2.iteratee || iteratee;
        result2 = result2 === iteratee ? baseIteratee : result2;
        return arguments.length ? result2(arguments[0], arguments[1]) : result2;
      }
      function getMapData2(map3, key) {
        var data2 = map3.__data__;
        return isKeyable2(key) ? data2[typeof key == "string" ? "string" : "hash"] : data2.map;
      }
      function getMatchData(object4) {
        var result2 = keys2(object4), length = result2.length;
        while (length--) {
          var key = result2[length], value = object4[key];
          result2[length] = [key, value, isStrictComparable(value)];
        }
        return result2;
      }
      function getNative2(object4, key) {
        var value = getValue2(object4, key);
        return baseIsNative2(value) ? value : undefined$1;
      }
      function getRawTag2(value) {
        var isOwn = hasOwnProperty2.call(value, symToStringTag2), tag = value[symToStringTag2];
        try {
          value[symToStringTag2] = undefined$1;
          var unmasked = true;
        } catch (e2) {
        }
        var result2 = nativeObjectToString2.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag2] = tag;
          } else {
            delete value[symToStringTag2];
          }
        }
        return result2;
      }
      var getSymbols2 = !nativeGetSymbols2 ? stubArray2 : function(object4) {
        if (object4 == null) {
          return [];
        }
        object4 = Object2(object4);
        return arrayFilter2(nativeGetSymbols2(object4), function(symbol) {
          return propertyIsEnumerable2.call(object4, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols2 ? stubArray2 : function(object4) {
        var result2 = [];
        while (object4) {
          arrayPush2(result2, getSymbols2(object4));
          object4 = getPrototype(object4);
        }
        return result2;
      };
      var getTag2 = baseGetTag2;
      if (DataView2 && getTag2(new DataView2(new ArrayBuffer(1))) != dataViewTag2 || Map2 && getTag2(new Map2()) != mapTag2 || Promise2 && getTag2(Promise2.resolve()) != promiseTag2 || Set2 && getTag2(new Set2()) != setTag2 || WeakMap2 && getTag2(new WeakMap2()) != weakMapTag2) {
        getTag2 = function(value) {
          var result2 = baseGetTag2(value), Ctor = result2 == objectTag2 ? value.constructor : undefined$1, ctorString = Ctor ? toSource2(Ctor) : "";
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString2:
                return dataViewTag2;
              case mapCtorString2:
                return mapTag2;
              case promiseCtorString2:
                return promiseTag2;
              case setCtorString2:
                return setTag2;
              case weakMapCtorString2:
                return weakMapTag2;
            }
          }
          return result2;
        };
      }
      function getView(start2, end2, transforms) {
        var index2 = -1, length = transforms.length;
        while (++index2 < length) {
          var data2 = transforms[index2], size2 = data2.size;
          switch (data2.type) {
            case "drop":
              start2 += size2;
              break;
            case "dropRight":
              end2 -= size2;
              break;
            case "take":
              end2 = nativeMin(end2, start2 + size2);
              break;
            case "takeRight":
              start2 = nativeMax(start2, end2 - size2);
              break;
          }
        }
        return { "start": start2, "end": end2 };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object4, path, hasFunc) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length, result2 = false;
        while (++index2 < length) {
          var key = toKey(path[index2]);
          if (!(result2 = object4 != null && hasFunc(object4, key))) {
            break;
          }
          object4 = object4[key];
        }
        if (result2 || ++index2 != length) {
          return result2;
        }
        length = object4 == null ? 0 : object4.length;
        return !!length && isLength2(length) && isIndex2(key, length) && (isArray2(object4) || isArguments2(object4));
      }
      function initCloneArray(array4) {
        var length = array4.length, result2 = new array4.constructor(length);
        if (length && typeof array4[0] == "string" && hasOwnProperty2.call(array4, "index")) {
          result2.index = array4.index;
          result2.input = array4.input;
        }
        return result2;
      }
      function initCloneObject(object4) {
        return typeof object4.constructor == "function" && !isPrototype2(object4) ? baseCreate(getPrototype(object4)) : {};
      }
      function initCloneByTag(object4, tag, isDeep) {
        var Ctor = object4.constructor;
        switch (tag) {
          case arrayBufferTag2:
            return cloneArrayBuffer(object4);
          case boolTag2:
          case dateTag2:
            return new Ctor(+object4);
          case dataViewTag2:
            return cloneDataView(object4, isDeep);
          case float32Tag2:
          case float64Tag2:
          case int8Tag2:
          case int16Tag2:
          case int32Tag2:
          case uint8Tag2:
          case uint8ClampedTag2:
          case uint16Tag2:
          case uint32Tag2:
            return cloneTypedArray(object4, isDeep);
          case mapTag2:
            return new Ctor();
          case numberTag2:
          case stringTag2:
            return new Ctor(object4);
          case regexpTag2:
            return cloneRegExp(object4);
          case setTag2:
            return new Ctor();
          case symbolTag2:
            return cloneSymbol(object4);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
        details = details.join(length > 2 ? ", " : " ");
        return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
      }
      function isFlattenable(value) {
        return isArray2(value) || isArguments2(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex2(value, length) {
        var type4 = typeof value;
        length = length == null ? MAX_SAFE_INTEGER2 : length;
        return !!length && (type4 == "number" || type4 != "symbol" && reIsUint2.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index2, object4) {
        if (!isObject2(object4)) {
          return false;
        }
        var type4 = typeof index2;
        if (type4 == "number" ? isArrayLike2(object4) && isIndex2(index2, object4.length) : type4 == "string" && index2 in object4) {
          return eq2(object4[index2], value);
        }
        return false;
      }
      function isKey(value, object4) {
        if (isArray2(value)) {
          return false;
        }
        var type4 = typeof value;
        if (type4 == "number" || type4 == "symbol" || type4 == "boolean" || value == null || isSymbol(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object4 != null && value in Object2(object4);
      }
      function isKeyable2(value) {
        var type4 = typeof value;
        return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash2[funcName];
        if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data2 = getData(other);
        return !!data2 && func === data2[0];
      }
      function isMasked2(func) {
        return !!maskSrcKey2 && maskSrcKey2 in func;
      }
      var isMaskable = coreJsData2 ? isFunction2 : stubFalse2;
      function isPrototype2(value) {
        var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto2;
        return value === proto2;
      }
      function isStrictComparable(value) {
        return value === value && !isObject2(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function(object4) {
          if (object4 == null) {
            return false;
          }
          return object4[key] === srcValue && (srcValue !== undefined$1 || key in Object2(object4));
        };
      }
      function memoizeCapped(func) {
        var result2 = memoize(func, function(key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result2.cache;
        return result2;
      }
      function mergeData(data2, source) {
        var bitmask = data2[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data2[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data2;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data2[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data2[3];
          data2[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data2[4] = partials ? replaceHolders(data2[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data2[5];
          data2[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data2[6] = partials ? replaceHolders(data2[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data2[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data2[8] = data2[8] == null ? source[8] : nativeMin(data2[8], source[8]);
        }
        if (data2[9] == null) {
          data2[9] = source[9];
        }
        data2[0] = source[0];
        data2[1] = newBitmask;
        return data2;
      }
      function nativeKeysIn(object4) {
        var result2 = [];
        if (object4 != null) {
          for (var key in Object2(object4)) {
            result2.push(key);
          }
        }
        return result2;
      }
      function objectToString2(value) {
        return nativeObjectToString2.call(value);
      }
      function overRest(func, start2, transform3) {
        start2 = nativeMax(start2 === undefined$1 ? func.length - 1 : start2, 0);
        return function() {
          var args = arguments, index2 = -1, length = nativeMax(args.length - start2, 0), array4 = Array2(length);
          while (++index2 < length) {
            array4[index2] = args[start2 + index2];
          }
          index2 = -1;
          var otherArgs = Array2(start2 + 1);
          while (++index2 < start2) {
            otherArgs[index2] = args[index2];
          }
          otherArgs[start2] = transform3(array4);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object4, path) {
        return path.length < 2 ? object4 : baseGet(object4, baseSlice(path, 0, -1));
      }
      function reorder(array4, indexes) {
        var arrLength = array4.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array4);
        while (length--) {
          var index2 = indexes[length];
          array4[length] = isIndex2(index2, arrLength) ? oldArray[index2] : undefined$1;
        }
        return array4;
      }
      function safeGet(object4, key) {
        if (key === "constructor" && typeof object4[key] === "function") {
          return;
        }
        if (key == "__proto__") {
          return;
        }
        return object4[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout2 = ctxSetTimeout || function(func, wait) {
        return root2.setTimeout(func, wait);
      };
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + "";
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count2 = 0, lastCalled = 0;
        return function() {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count2 >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count2 = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array4, size2) {
        var index2 = -1, length = array4.length, lastIndex = length - 1;
        size2 = size2 === undefined$1 ? length : size2;
        while (++index2 < size2) {
          var rand = baseRandom(index2, lastIndex), value = array4[rand];
          array4[rand] = array4[index2];
          array4[index2] = value;
        }
        array4.length = size2;
        return array4;
      }
      var stringToPath = memoizeCapped(function(string3) {
        var result2 = [];
        if (string3.charCodeAt(0) === 46) {
          result2.push("");
        }
        string3.replace(rePropName, function(match, number4, quote, subString) {
          result2.push(quote ? subString.replace(reEscapeChar, "$1") : number4 || match);
        });
        return result2;
      });
      function toKey(value) {
        if (typeof value == "string" || isSymbol(value)) {
          return value;
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function toSource2(func) {
        if (func != null) {
          try {
            return funcToString2.call(func);
          } catch (e2) {
          }
          try {
            return func + "";
          } catch (e2) {
          }
        }
        return "";
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function(pair) {
          var value = "_." + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result2.__actions__ = copyArray(wrapper.__actions__);
        result2.__index__ = wrapper.__index__;
        result2.__values__ = wrapper.__values__;
        return result2;
      }
      function chunk(array4, size2, guard) {
        if (guard ? isIterateeCall(array4, size2, guard) : size2 === undefined$1) {
          size2 = 1;
        } else {
          size2 = nativeMax(toInteger(size2), 0);
        }
        var length = array4 == null ? 0 : array4.length;
        if (!length || size2 < 1) {
          return [];
        }
        var index2 = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
        while (index2 < length) {
          result2[resIndex++] = baseSlice(array4, index2, index2 += size2);
        }
        return result2;
      }
      function compact(array4) {
        var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2];
          if (value) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array2(length - 1), array4 = arguments[0], index2 = length;
        while (index2--) {
          args[index2 - 1] = arguments[index2];
        }
        return arrayPush2(isArray2(array4) ? copyArray(array4) : [array4], baseFlatten(args, 1));
      }
      var difference = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function(array4, values2) {
        var iteratee2 = last(values2);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
      });
      var differenceWith = baseRest(function(array4, values2) {
        var comparator = last(values2);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function dropRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function dropRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true) : [];
      }
      function fill(array4, value, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (start2 && typeof start2 != "number" && isIterateeCall(array4, value, start2)) {
          start2 = 0;
          end2 = length;
        }
        return baseFill(array4, value, start2, end2);
      }
      function findIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax(length + index2, 0);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2);
      }
      function findLastIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length - 1;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = fromIndex < 0 ? nativeMax(length + index2, 0) : nativeMin(index2, length - 1);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2, true);
      }
      function flatten(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, 1) : [];
      }
      function flattenDeep(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, INFINITY) : [];
      }
      function flattenDepth(array4, depth) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array4, depth);
      }
      function fromPairs(pairs) {
        var index2 = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
        while (++index2 < length) {
          var pair = pairs[index2];
          result2[pair[0]] = pair[1];
        }
        return result2;
      }
      function head(array4) {
        return array4 && array4.length ? array4[0] : undefined$1;
      }
      function indexOf2(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax(length + index2, 0);
        }
        return baseIndexOf(array4, value, index2);
      }
      function initial(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 0, -1) : [];
      }
      var intersection = baseRest(function(arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee2 === last(mapped)) {
          iteratee2 = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
      });
      var intersectionWith = baseRest(function(arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array4, separator) {
        return array4 == null ? "" : nativeJoin.call(array4, separator);
      }
      function last(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? array4[length - 1] : undefined$1;
      }
      function lastIndexOf(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = index2 < 0 ? nativeMax(length + index2, 0) : nativeMin(index2, length - 1);
        }
        return value === value ? strictLastIndexOf(array4, value, index2) : baseFindIndex(array4, baseIsNaN, index2, true);
      }
      function nth(array4, n2) {
        return array4 && array4.length ? baseNth(array4, toInteger(n2)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array4, values2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2) : array4;
      }
      function pullAllBy(array4, values2, iteratee2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, getIteratee(iteratee2, 2)) : array4;
      }
      function pullAllWith(array4, values2, comparator) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, undefined$1, comparator) : array4;
      }
      var pullAt = flatRest(function(array4, indexes) {
        var length = array4 == null ? 0 : array4.length, result2 = baseAt(array4, indexes);
        basePullAt(array4, arrayMap(indexes, function(index2) {
          return isIndex2(index2, length) ? +index2 : index2;
        }).sort(compareAscending));
        return result2;
      });
      function remove(array4, predicate) {
        var result2 = [];
        if (!(array4 && array4.length)) {
          return result2;
        }
        var index2 = -1, indexes = [], length = array4.length;
        predicate = getIteratee(predicate, 3);
        while (++index2 < length) {
          var value = array4[index2];
          if (predicate(value, index2, array4)) {
            result2.push(value);
            indexes.push(index2);
          }
        }
        basePullAt(array4, indexes);
        return result2;
      }
      function reverse2(array4) {
        return array4 == null ? array4 : nativeReverse.call(array4);
      }
      function slice2(array4, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (end2 && typeof end2 != "number" && isIterateeCall(array4, start2, end2)) {
          start2 = 0;
          end2 = length;
        } else {
          start2 = start2 == null ? 0 : toInteger(start2);
          end2 = end2 === undefined$1 ? length : toInteger(end2);
        }
        return baseSlice(array4, start2, end2);
      }
      function sortedIndex(array4, value) {
        return baseSortedIndex(array4, value);
      }
      function sortedIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2));
      }
      function sortedIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value);
          if (index2 < length && eq2(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedLastIndex(array4, value) {
        return baseSortedIndex(array4, value, true);
      }
      function sortedLastIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2), true);
      }
      function sortedLastIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value, true) - 1;
          if (eq2(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedUniq(array4) {
        return array4 && array4.length ? baseSortedUniq(array4) : [];
      }
      function sortedUniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseSortedUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function tail(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 1, length) : [];
      }
      function take2(array4, n2, guard) {
        if (!(array4 && array4.length)) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function takeRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function takeRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function(arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
      });
      var unionWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array4) {
        return array4 && array4.length ? baseUniq(array4) : [];
      }
      function uniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function uniqWith(array4, comparator) {
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return array4 && array4.length ? baseUniq(array4, undefined$1, comparator) : [];
      }
      function unzip(array4) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var length = 0;
        array4 = arrayFilter2(array4, function(group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax(group.length, length);
            return true;
          }
        });
        return baseTimes2(length, function(index2) {
          return arrayMap(array4, baseProperty(index2));
        });
      }
      function unzipWith(array4, iteratee2) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var result2 = unzip(array4);
        if (iteratee2 == null) {
          return result2;
        }
        return arrayMap(result2, function(group) {
          return apply(iteratee2, undefined$1, group);
        });
      }
      var without = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, values2) : [];
      });
      var xor = baseRest(function(arrays) {
        return baseXor(arrayFilter2(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseXor(arrayFilter2(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
      });
      var xorWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseXor(arrayFilter2(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values2) {
        return baseZipObject(props || [], values2 || [], assignValue);
      }
      function zipObjectDeep(props, values2) {
        return baseZipObject(props || [], values2 || [], baseSet);
      }
      var zipWith = baseRest(function(arrays) {
        var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined$1;
        return unzipWith(arrays, iteratee2);
      });
      function chain(value) {
        var result2 = lodash2(value);
        result2.__chain__ = true;
        return result2;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function(paths) {
        var length = paths.length, start2 = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object4) {
          return baseAt(object4, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex2(start2)) {
          return this.thru(interceptor);
        }
        value = value.slice(start2, +start2 + (length ? 1 : 0));
        value.__actions__.push({
          "func": thru,
          "args": [interceptor],
          "thisArg": undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function(array4) {
          if (length && !array4.length) {
            array4.push(undefined$1);
          }
          return array4;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray2(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return { "done": done, "value": value };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result2, parent2 = this;
        while (parent2 instanceof baseLodash) {
          var clone4 = wrapperClone(parent2);
          clone4.__index__ = 0;
          clone4.__values__ = undefined$1;
          if (result2) {
            previous.__wrapped__ = clone4;
          } else {
            result2 = clone4;
          }
          var previous = clone4;
          parent2 = parent2.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result2;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            "func": thru,
            "args": [reverse2],
            "thisArg": undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse2);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          ++result2[key];
        } else {
          baseAssignValue(result2, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray2(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter2(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter2 : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find2 = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), 1);
      }
      function flatMapDeep(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), INFINITY);
      }
      function flatMapDepth(collection, iteratee2, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map2(collection, iteratee2), depth);
      }
      function forEach(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function forEachRight(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee2, 3));
      }
      var groupBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          result2[key].push(value);
        } else {
          baseAssignValue(result2, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike2(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax(length + fromIndex, 0);
        }
        return isString2(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function(collection, path, args) {
        var index2 = -1, isFunc = typeof path == "function", result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value) {
          result2[++index2] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result2;
      });
      var keyBy = createAggregator(function(result2, value, key) {
        baseAssignValue(result2, key, value);
      });
      function map2(collection, iteratee2) {
        var func = isArray2(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray2(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray2(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function(result2, value, key) {
        result2[key ? 0 : 1].push(value);
      }, function() {
        return [[], []];
      });
      function reduce2(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter2 : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray2(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n2, guard) {
        if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n2);
      }
      function shuffle(collection) {
        var func = isArray2(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike2(collection)) {
          return isString2(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag2(collection);
        if (tag == mapTag2 || tag == setTag2) {
          return collection.size;
        }
        return baseKeys2(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray2(collection) ? arraySome2 : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function(collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now = ctxNow || function() {
        return root2.Date.now();
      };
      function after(n2, func) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n2, guard) {
        n2 = guard ? undefined$1 : n2;
        n2 = func && n2 == null ? func.length : n2;
        return createWrap2(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n2);
      }
      function before(n2, func) {
        var result2;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 > 0) {
            result2 = func.apply(this, arguments);
          }
          if (n2 <= 1) {
            func = undefined$1;
          }
          return result2;
        };
      }
      var bind2 = baseRest(function(func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind2));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function(object4, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(key, bitmask, object4, partials, holders);
      });
      function curry2(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curry2.placeholder;
        return result2;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curryRight.placeholder;
        return result2;
      }
      function debounce(func, wait, options) {
        var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        wait = toNumber(wait) || 0;
        if (isObject2(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result2 = func.apply(thisArg, args);
          return result2;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout2(timerExpired, wait);
          return leading ? invokeFunc(time) : result2;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout2(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result2;
        }
        function cancel2() {
          if (timerId !== undefined$1) {
            clearTimeout2(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result2 : trailingEdge(now());
        }
        function debounced() {
          var time = now(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout2(timerId);
              timerId = setTimeout2(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout2(timerExpired, wait);
          }
          return result2;
        }
        debounced.cancel = cancel2;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function(func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function(func, wait, args) {
        return baseDelay(func, toNumber(wait) || 0, args);
      });
      function flip2(func) {
        return createWrap2(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != "function" || resolver != null && typeof resolver != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        var memoized = function() {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result2 = func.apply(this, args);
          memoized.cache = cache.set(key, result2) || cache;
          return result2;
        };
        memoized.cache = new (memoize.Cache || MapCache2)();
        return memoized;
      }
      memoize.Cache = MapCache2;
      function negate(predicate) {
        if (typeof predicate != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function(func, transforms) {
        transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary2(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary2(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function(args) {
          var index2 = -1, length = nativeMin(args.length, funcsLength);
          while (++index2 < length) {
            args[index2] = transforms[index2].call(this, args[index2]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap2(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap2(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function(func, indexes) {
        return createWrap2(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        start2 = start2 === undefined$1 ? start2 : toInteger(start2);
        return baseRest(func, start2);
      }
      function spread(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        start2 = start2 == null ? 0 : nativeMax(toInteger(start2), 0);
        return baseRest(function(args) {
          var array4 = args[start2], otherArgs = castSlice(args, 0, start2);
          if (array4) {
            arrayPush2(otherArgs, array4);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT);
        }
        if (isObject2(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray2(value) ? value : [value];
      }
      function clone3(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object4, source) {
        return source == null || baseConformsTo(object4, source, keys2(source));
      }
      function eq2(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function(value, other) {
        return value >= other;
      });
      var isArguments2 = baseIsArguments2(function() {
        return arguments;
      }()) ? baseIsArguments2 : function(value) {
        return isObjectLike2(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable2.call(value, "callee");
      };
      var isArray2 = Array2.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary2(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike2(value) {
        return value != null && isLength2(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike2(value) && isArrayLike2(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike2(value) && baseGetTag2(value) == boolTag2;
      }
      var isBuffer2 = nativeIsBuffer || stubFalse2;
      var isDate = nodeIsDate ? baseUnary2(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike2(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty2(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike2(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer2(value) || isTypedArray2(value) || isArguments2(value))) {
          return !value.length;
        }
        var tag = getTag2(value);
        if (tag == mapTag2 || tag == setTag2) {
          return !value.size;
        }
        if (isPrototype2(value)) {
          return !baseKeys2(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty2.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual2(value, other) {
        return baseIsEqual2(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        var result2 = customizer ? customizer(value, other) : undefined$1;
        return result2 === undefined$1 ? baseIsEqual2(value, other, undefined$1, customizer) : !!result2;
      }
      function isError(value) {
        if (!isObjectLike2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == errorTag2 || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
      }
      function isFinite2(value) {
        return typeof value == "number" && nativeIsFinite(value);
      }
      function isFunction2(value) {
        if (!isObject2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == funcTag2 || tag == genTag2 || tag == asyncTag2 || tag == proxyTag2;
      }
      function isInteger(value) {
        return typeof value == "number" && value == toInteger(value);
      }
      function isLength2(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
      }
      function isObject2(value) {
        var type4 = typeof value;
        return value != null && (type4 == "object" || type4 == "function");
      }
      function isObjectLike2(value) {
        return value != null && typeof value == "object";
      }
      var isMap = nodeIsMap ? baseUnary2(nodeIsMap) : baseIsMap;
      function isMatch(object4, source) {
        return object4 === source || baseIsMatch(object4, source, getMatchData(source));
      }
      function isMatchWith(object4, source, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseIsMatch(object4, source, getMatchData(source), customizer);
      }
      function isNaN2(value) {
        return isNumber2(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error2(CORE_ERROR_TEXT);
        }
        return baseIsNative2(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber2(value) {
        return typeof value == "number" || isObjectLike2(value) && baseGetTag2(value) == numberTag2;
      }
      function isPlainObject(value) {
        if (!isObjectLike2(value) || baseGetTag2(value) != objectTag2) {
          return false;
        }
        var proto2 = getPrototype(value);
        if (proto2 === null) {
          return true;
        }
        var Ctor = hasOwnProperty2.call(proto2, "constructor") && proto2.constructor;
        return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString2.call(Ctor) == objectCtorString;
      }
      var isRegExp2 = nodeIsRegExp ? baseUnary2(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER2 && value <= MAX_SAFE_INTEGER2;
      }
      var isSet = nodeIsSet ? baseUnary2(nodeIsSet) : baseIsSet;
      function isString2(value) {
        return typeof value == "string" || !isArray2(value) && isObjectLike2(value) && baseGetTag2(value) == stringTag2;
      }
      function isSymbol(value) {
        return typeof value == "symbol" || isObjectLike2(value) && baseGetTag2(value) == symbolTag2;
      }
      var isTypedArray2 = nodeIsTypedArray2 ? baseUnary2(nodeIsTypedArray2) : baseIsTypedArray2;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike2(value) && getTag2(value) == weakMapTag2;
      }
      function isWeakSet(value) {
        return isObjectLike2(value) && baseGetTag2(value) == weakSetTag;
      }
      var lt2 = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function(value, other) {
        return value <= other;
      });
      function toArray2(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike2(value)) {
          return isString2(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag2(value), func = tag == mapTag2 ? mapToArray2 : tag == setTag2 ? setToArray2 : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result2 = toFinite(value), remainder = result2 % 1;
        return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        if (isObject2(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject2(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim(value);
        var isBinary = reIsBinary.test(value);
        return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER2, MAX_SAFE_INTEGER2) : value === 0 ? value : 0;
      }
      function toString2(value) {
        return value == null ? "" : baseToString(value);
      }
      var assign = createAssigner(function(object4, source) {
        if (isPrototype2(source) || isArrayLike2(source)) {
          copyObject(source, keys2(source), object4);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty2.call(source, key)) {
            assignValue(object4, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function(object4, source) {
        copyObject(source, keysIn(source), object4);
      });
      var assignInWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object4, customizer);
      });
      var assignWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keys2(source), object4, customizer);
      });
      var at2 = flatRest(baseAt);
      function create2(prototype, properties) {
        var result2 = baseCreate(prototype);
        return properties == null ? result2 : baseAssign(result2, properties);
      }
      var defaults2 = baseRest(function(object4, sources) {
        object4 = Object2(object4);
        var index2 = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index2 < length) {
          var source = sources[index2];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object4[key];
            if (value === undefined$1 || eq2(value, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
              object4[key] = source[key];
            }
          }
        }
        return object4;
      });
      var defaultsDeep = baseRest(function(args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object4, iteratee2) {
        return object4 == null ? object4 : baseFor(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forInRight(object4, iteratee2) {
        return object4 == null ? object4 : baseForRight(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forOwn(object4, iteratee2) {
        return object4 && baseForOwn(object4, getIteratee(iteratee2, 3));
      }
      function forOwnRight(object4, iteratee2) {
        return object4 && baseForOwnRight(object4, getIteratee(iteratee2, 3));
      }
      function functions(object4) {
        return object4 == null ? [] : baseFunctions(object4, keys2(object4));
      }
      function functionsIn(object4) {
        return object4 == null ? [] : baseFunctions(object4, keysIn(object4));
      }
      function get2(object4, path, defaultValue) {
        var result2 = object4 == null ? undefined$1 : baseGet(object4, path);
        return result2 === undefined$1 ? defaultValue : result2;
      }
      function has2(object4, path) {
        return object4 != null && hasPath(object4, path, baseHas);
      }
      function hasIn(object4, path) {
        return object4 != null && hasPath(object4, path, baseHasIn);
      }
      var invert2 = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        result2[value] = key;
      }, constant(identity2));
      var invertBy = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        if (hasOwnProperty2.call(result2, value)) {
          result2[value].push(key);
        } else {
          result2[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys2(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys2(object4) : baseKeys2(object4);
      }
      function keysIn(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys2(object4, true) : baseKeysIn(object4);
      }
      function mapKeys(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, iteratee2(value, key, object5), value);
        });
        return result2;
      }
      function mapValues(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, key, iteratee2(value, key, object5));
        });
        return result2;
      }
      var merge3 = createAssigner(function(object4, source, srcIndex) {
        baseMerge(object4, source, srcIndex);
      });
      var mergeWith = createAssigner(function(object4, source, srcIndex, customizer) {
        baseMerge(object4, source, srcIndex, customizer);
      });
      var omit2 = flatRest(function(object4, paths) {
        var result2 = {};
        if (object4 == null) {
          return result2;
        }
        var isDeep = false;
        paths = arrayMap(paths, function(path) {
          path = castPath(path, object4);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object4, getAllKeysIn(object4), result2);
        if (isDeep) {
          result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result2, paths[length]);
        }
        return result2;
      });
      function omitBy(object4, predicate) {
        return pickBy(object4, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function(object4, paths) {
        return object4 == null ? {} : basePick(object4, paths);
      });
      function pickBy(object4, predicate) {
        if (object4 == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object4), function(prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object4, props, function(value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object4, path, defaultValue) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length;
        if (!length) {
          length = 1;
          object4 = undefined$1;
        }
        while (++index2 < length) {
          var value = object4 == null ? undefined$1 : object4[toKey(path[index2])];
          if (value === undefined$1) {
            index2 = length;
            value = defaultValue;
          }
          object4 = isFunction2(value) ? value.call(object4) : value;
        }
        return object4;
      }
      function set2(object4, path, value) {
        return object4 == null ? object4 : baseSet(object4, path, value);
      }
      function setWith(object4, path, value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseSet(object4, path, value, customizer);
      }
      var toPairs = createToPairs(keys2);
      var toPairsIn = createToPairs(keysIn);
      function transform2(object4, iteratee2, accumulator) {
        var isArr = isArray2(object4), isArrLike = isArr || isBuffer2(object4) || isTypedArray2(object4);
        iteratee2 = getIteratee(iteratee2, 4);
        if (accumulator == null) {
          var Ctor = object4 && object4.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject2(object4)) {
            accumulator = isFunction2(Ctor) ? baseCreate(getPrototype(object4)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object4, function(value, index2, object5) {
          return iteratee2(accumulator, value, index2, object5);
        });
        return accumulator;
      }
      function unset(object4, path) {
        return object4 == null ? true : baseUnset(object4, path);
      }
      function update(object4, path, updater) {
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater));
      }
      function updateWith(object4, path, updater, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater), customizer);
      }
      function values(object4) {
        return object4 == null ? [] : baseValues(object4, keys2(object4));
      }
      function valuesIn(object4) {
        return object4 == null ? [] : baseValues(object4, keysIn(object4));
      }
      function clamp2(number4, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber(number4), lower, upper);
      }
      function inRange(number4, start2, end2) {
        start2 = toFinite(start2);
        if (end2 === undefined$1) {
          end2 = start2;
          start2 = 0;
        } else {
          end2 = toFinite(end2);
        }
        number4 = toNumber(number4);
        return baseInRange(number4, start2, end2);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == "boolean") {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == "boolean") {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function(result2, word, index2) {
        word = word.toLowerCase();
        return result2 + (index2 ? capitalize(word) : word);
      });
      function capitalize(string3) {
        return upperFirst(toString2(string3).toLowerCase());
      }
      function deburr(string3) {
        string3 = toString2(string3);
        return string3 && string3.replace(reLatin, deburrLetter).replace(reComboMark, "");
      }
      function endsWith(string3, target, position2) {
        string3 = toString2(string3);
        target = baseToString(target);
        var length = string3.length;
        position2 = position2 === undefined$1 ? length : baseClamp(toInteger(position2), 0, length);
        var end2 = position2;
        position2 -= target.length;
        return position2 >= 0 && string3.slice(position2, end2) == target;
      }
      function escape(string3) {
        string3 = toString2(string3);
        return string3 && reHasUnescapedHtml.test(string3) ? string3.replace(reUnescapedHtml, escapeHtmlChar) : string3;
      }
      function escapeRegExp(string3) {
        string3 = toString2(string3);
        return string3 && reHasRegExpChar.test(string3) ? string3.replace(reRegExpChar2, "\\$&") : string3;
      }
      var kebabCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "-" : "") + word.toLowerCase();
      });
      var lowerCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst("toLowerCase");
      function pad3(string3, length, chars) {
        string3 = toString2(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        if (!length || strLength >= length) {
          return string3;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string3 + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string3, length, chars) {
        string3 = toString2(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? string3 + createPadding(length - strLength, chars) : string3;
      }
      function padStart(string3, length, chars) {
        string3 = toString2(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string3 : string3;
      }
      function parseInt2(string3, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString2(string3).replace(reTrimStart, ""), radix || 0);
      }
      function repeat(string3, n2, guard) {
        if (guard ? isIterateeCall(string3, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        return baseRepeat(toString2(string3), n2);
      }
      function replace() {
        var args = arguments, string3 = toString2(args[0]);
        return args.length < 3 ? string3 : string3.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "_" : "") + word.toLowerCase();
      });
      function split2(string3, separator, limit) {
        if (limit && typeof limit != "number" && isIterateeCall(string3, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string3 = toString2(string3);
        if (string3 && (typeof separator == "string" || separator != null && !isRegExp2(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string3)) {
            return castSlice(stringToArray(string3), 0, limit);
          }
        }
        return string3.split(separator, limit);
      }
      var startCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + upperFirst(word);
      });
      function startsWith(string3, target, position2) {
        string3 = toString2(string3);
        position2 = position2 == null ? 0 : baseClamp(toInteger(position2), 0, string3.length);
        target = baseToString(target);
        return string3.slice(position2, position2 + target.length) == target;
      }
      function template(string3, options, guard) {
        var settings = lodash2.templateSettings;
        if (guard && isIterateeCall(string3, options, guard)) {
          options = undefined$1;
        }
        string3 = toString2(string3);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys2(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index2 = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
        var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
        string3.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset3) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string3.slice(index2, offset3).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index2 = offset3 + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty2.call(options, "variable") && options.variable;
        if (!variable) {
          source = "with (obj) {\n" + source + "\n}\n";
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
        source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
        var result2 = attempt(function() {
          return Function2(importsKeys, sourceURL + "return " + source).apply(undefined$1, importsValues);
        });
        result2.source = source;
        if (isError(result2)) {
          throw result2;
        }
        return result2;
      }
      function toLower(value) {
        return toString2(value).toLowerCase();
      }
      function toUpper(value) {
        return toString2(value).toUpperCase();
      }
      function trim2(string3, chars, guard) {
        string3 = toString2(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return baseTrim(string3);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), chrSymbols = stringToArray(chars), start2 = charsStartIndex(strSymbols, chrSymbols), end2 = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start2, end2).join("");
      }
      function trimEnd(string3, chars, guard) {
        string3 = toString2(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.slice(0, trimmedEndIndex(string3) + 1);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), end2 = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end2).join("");
      }
      function trimStart(string3, chars, guard) {
        string3 = toString2(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.replace(reTrimStart, "");
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), start2 = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start2).join("");
      }
      function truncate(string3, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject2(options)) {
          var separator = "separator" in options ? options.separator : separator;
          length = "length" in options ? toInteger(options.length) : length;
          omission = "omission" in options ? baseToString(options.omission) : omission;
        }
        string3 = toString2(string3);
        var strLength = string3.length;
        if (hasUnicode(string3)) {
          var strSymbols = stringToArray(string3);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string3;
        }
        var end2 = length - stringSize(omission);
        if (end2 < 1) {
          return omission;
        }
        var result2 = strSymbols ? castSlice(strSymbols, 0, end2).join("") : string3.slice(0, end2);
        if (separator === undefined$1) {
          return result2 + omission;
        }
        if (strSymbols) {
          end2 += result2.length - end2;
        }
        if (isRegExp2(separator)) {
          if (string3.slice(end2).search(separator)) {
            var match, substring = result2;
            if (!separator.global) {
              separator = RegExp2(separator.source, toString2(reFlags.exec(separator)) + "g");
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result2 = result2.slice(0, newEnd === undefined$1 ? end2 : newEnd);
          }
        } else if (string3.indexOf(baseToString(separator), end2) != end2) {
          var index2 = result2.lastIndexOf(separator);
          if (index2 > -1) {
            result2 = result2.slice(0, index2);
          }
        }
        return result2 + omission;
      }
      function unescape2(string3) {
        string3 = toString2(string3);
        return string3 && reHasEscapedHtml.test(string3) ? string3.replace(reEscapedHtml, unescapeHtmlChar) : string3;
      }
      var upperCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toUpperCase();
      });
      var upperFirst = createCaseFirst("toUpperCase");
      function words(string3, pattern4, guard) {
        string3 = toString2(string3);
        pattern4 = guard ? undefined$1 : pattern4;
        if (pattern4 === undefined$1) {
          return hasUnicodeWord(string3) ? unicodeWords(string3) : asciiWords(string3);
        }
        return string3.match(pattern4) || [];
      }
      var attempt = baseRest(function(func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e2) {
          return isError(e2) ? e2 : new Error2(e2);
        }
      });
      var bindAll = flatRest(function(object4, methodNames) {
        arrayEach(methodNames, function(key) {
          key = toKey(key);
          baseAssignValue(object4, key, bind2(object4[key], object4));
        });
        return object4;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function(pair) {
          if (typeof pair[1] != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function(args) {
          var index2 = -1;
          while (++index2 < length) {
            var pair = pairs[index2];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function() {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity2(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method4 = baseRest(function(path, args) {
        return function(object4) {
          return baseInvoke(object4, path, args);
        };
      });
      var methodOf = baseRest(function(object4, args) {
        return function(path) {
          return baseInvoke(object4, path, args);
        };
      });
      function mixin2(object4, source, options) {
        var props = keys2(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object4;
          object4 = this;
          methodNames = baseFunctions(source, keys2(source));
        }
        var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction2(object4);
        arrayEach(methodNames, function(methodName) {
          var func = source[methodName];
          object4[methodName] = func;
          if (isFunc) {
            object4.prototype[methodName] = function() {
              var chainAll = this.__chain__;
              if (chain2 || chainAll) {
                var result2 = object4(this.__wrapped__), actions2 = result2.__actions__ = copyArray(this.__actions__);
                actions2.push({ "func": func, "args": arguments, "thisArg": object4 });
                result2.__chain__ = chainAll;
                return result2;
              }
              return func.apply(object4, arrayPush2([this.value()], arguments));
            };
          }
        });
        return object4;
      }
      function noConflict() {
        if (root2._ === this) {
          root2._ = oldDash;
        }
        return this;
      }
      function noop2() {
      }
      function nthArg(n2) {
        n2 = toInteger(n2);
        return baseRest(function(args) {
          return baseNth(args, n2);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome2);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object4) {
        return function(path) {
          return object4 == null ? undefined$1 : baseGet(object4, path);
        };
      }
      var range3 = createRange();
      var rangeRight = createRange(true);
      function stubArray2() {
        return [];
      }
      function stubFalse2() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return "";
      }
      function stubTrue() {
        return true;
      }
      function times(n2, iteratee2) {
        n2 = toInteger(n2);
        if (n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return [];
        }
        var index2 = MAX_ARRAY_LENGTH, length = nativeMin(n2, MAX_ARRAY_LENGTH);
        iteratee2 = getIteratee(iteratee2);
        n2 -= MAX_ARRAY_LENGTH;
        var result2 = baseTimes2(length, iteratee2);
        while (++index2 < n2) {
          iteratee2(index2);
        }
        return result2;
      }
      function toPath(value) {
        if (isArray2(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol(value) ? [value] : copyArray(stringToPath(toString2(value)));
      }
      function uniqueId(prefix) {
        var id2 = ++idCounter;
        return toString2(prefix) + id2;
      }
      var add2 = createMathOperation(function(augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound("ceil");
      var divide = createMathOperation(function(dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound("floor");
      function max3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseGt) : undefined$1;
      }
      function maxBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseGt) : undefined$1;
      }
      function mean(array4) {
        return baseMean(array4, identity2);
      }
      function meanBy(array4, iteratee2) {
        return baseMean(array4, getIteratee(iteratee2, 2));
      }
      function min3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseLt) : undefined$1;
      }
      function minBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function(multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round2 = createRound("round");
      var subtract = createMathOperation(function(minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum2(array4) {
        return array4 && array4.length ? baseSum(array4, identity2) : 0;
      }
      function sumBy(array4, iteratee2) {
        return array4 && array4.length ? baseSum(array4, getIteratee(iteratee2, 2)) : 0;
      }
      lodash2.after = after;
      lodash2.ary = ary;
      lodash2.assign = assign;
      lodash2.assignIn = assignIn;
      lodash2.assignInWith = assignInWith;
      lodash2.assignWith = assignWith;
      lodash2.at = at2;
      lodash2.before = before;
      lodash2.bind = bind2;
      lodash2.bindAll = bindAll;
      lodash2.bindKey = bindKey;
      lodash2.castArray = castArray;
      lodash2.chain = chain;
      lodash2.chunk = chunk;
      lodash2.compact = compact;
      lodash2.concat = concat;
      lodash2.cond = cond;
      lodash2.conforms = conforms;
      lodash2.constant = constant;
      lodash2.countBy = countBy;
      lodash2.create = create2;
      lodash2.curry = curry2;
      lodash2.curryRight = curryRight;
      lodash2.debounce = debounce;
      lodash2.defaults = defaults2;
      lodash2.defaultsDeep = defaultsDeep;
      lodash2.defer = defer;
      lodash2.delay = delay;
      lodash2.difference = difference;
      lodash2.differenceBy = differenceBy;
      lodash2.differenceWith = differenceWith;
      lodash2.drop = drop;
      lodash2.dropRight = dropRight;
      lodash2.dropRightWhile = dropRightWhile;
      lodash2.dropWhile = dropWhile;
      lodash2.fill = fill;
      lodash2.filter = filter2;
      lodash2.flatMap = flatMap;
      lodash2.flatMapDeep = flatMapDeep;
      lodash2.flatMapDepth = flatMapDepth;
      lodash2.flatten = flatten;
      lodash2.flattenDeep = flattenDeep;
      lodash2.flattenDepth = flattenDepth;
      lodash2.flip = flip2;
      lodash2.flow = flow;
      lodash2.flowRight = flowRight;
      lodash2.fromPairs = fromPairs;
      lodash2.functions = functions;
      lodash2.functionsIn = functionsIn;
      lodash2.groupBy = groupBy;
      lodash2.initial = initial;
      lodash2.intersection = intersection;
      lodash2.intersectionBy = intersectionBy;
      lodash2.intersectionWith = intersectionWith;
      lodash2.invert = invert2;
      lodash2.invertBy = invertBy;
      lodash2.invokeMap = invokeMap;
      lodash2.iteratee = iteratee;
      lodash2.keyBy = keyBy;
      lodash2.keys = keys2;
      lodash2.keysIn = keysIn;
      lodash2.map = map2;
      lodash2.mapKeys = mapKeys;
      lodash2.mapValues = mapValues;
      lodash2.matches = matches;
      lodash2.matchesProperty = matchesProperty;
      lodash2.memoize = memoize;
      lodash2.merge = merge3;
      lodash2.mergeWith = mergeWith;
      lodash2.method = method4;
      lodash2.methodOf = methodOf;
      lodash2.mixin = mixin2;
      lodash2.negate = negate;
      lodash2.nthArg = nthArg;
      lodash2.omit = omit2;
      lodash2.omitBy = omitBy;
      lodash2.once = once;
      lodash2.orderBy = orderBy;
      lodash2.over = over;
      lodash2.overArgs = overArgs;
      lodash2.overEvery = overEvery;
      lodash2.overSome = overSome;
      lodash2.partial = partial;
      lodash2.partialRight = partialRight;
      lodash2.partition = partition;
      lodash2.pick = pick;
      lodash2.pickBy = pickBy;
      lodash2.property = property;
      lodash2.propertyOf = propertyOf;
      lodash2.pull = pull;
      lodash2.pullAll = pullAll;
      lodash2.pullAllBy = pullAllBy;
      lodash2.pullAllWith = pullAllWith;
      lodash2.pullAt = pullAt;
      lodash2.range = range3;
      lodash2.rangeRight = rangeRight;
      lodash2.rearg = rearg;
      lodash2.reject = reject;
      lodash2.remove = remove;
      lodash2.rest = rest;
      lodash2.reverse = reverse2;
      lodash2.sampleSize = sampleSize;
      lodash2.set = set2;
      lodash2.setWith = setWith;
      lodash2.shuffle = shuffle;
      lodash2.slice = slice2;
      lodash2.sortBy = sortBy;
      lodash2.sortedUniq = sortedUniq;
      lodash2.sortedUniqBy = sortedUniqBy;
      lodash2.split = split2;
      lodash2.spread = spread;
      lodash2.tail = tail;
      lodash2.take = take2;
      lodash2.takeRight = takeRight;
      lodash2.takeRightWhile = takeRightWhile;
      lodash2.takeWhile = takeWhile;
      lodash2.tap = tap;
      lodash2.throttle = throttle2;
      lodash2.thru = thru;
      lodash2.toArray = toArray2;
      lodash2.toPairs = toPairs;
      lodash2.toPairsIn = toPairsIn;
      lodash2.toPath = toPath;
      lodash2.toPlainObject = toPlainObject;
      lodash2.transform = transform2;
      lodash2.unary = unary;
      lodash2.union = union;
      lodash2.unionBy = unionBy;
      lodash2.unionWith = unionWith;
      lodash2.uniq = uniq;
      lodash2.uniqBy = uniqBy;
      lodash2.uniqWith = uniqWith;
      lodash2.unset = unset;
      lodash2.unzip = unzip;
      lodash2.unzipWith = unzipWith;
      lodash2.update = update;
      lodash2.updateWith = updateWith;
      lodash2.values = values;
      lodash2.valuesIn = valuesIn;
      lodash2.without = without;
      lodash2.words = words;
      lodash2.wrap = wrap;
      lodash2.xor = xor;
      lodash2.xorBy = xorBy;
      lodash2.xorWith = xorWith;
      lodash2.zip = zip;
      lodash2.zipObject = zipObject;
      lodash2.zipObjectDeep = zipObjectDeep;
      lodash2.zipWith = zipWith;
      lodash2.entries = toPairs;
      lodash2.entriesIn = toPairsIn;
      lodash2.extend = assignIn;
      lodash2.extendWith = assignInWith;
      mixin2(lodash2, lodash2);
      lodash2.add = add2;
      lodash2.attempt = attempt;
      lodash2.camelCase = camelCase;
      lodash2.capitalize = capitalize;
      lodash2.ceil = ceil;
      lodash2.clamp = clamp2;
      lodash2.clone = clone3;
      lodash2.cloneDeep = cloneDeep;
      lodash2.cloneDeepWith = cloneDeepWith;
      lodash2.cloneWith = cloneWith;
      lodash2.conformsTo = conformsTo;
      lodash2.deburr = deburr;
      lodash2.defaultTo = defaultTo;
      lodash2.divide = divide;
      lodash2.endsWith = endsWith;
      lodash2.eq = eq2;
      lodash2.escape = escape;
      lodash2.escapeRegExp = escapeRegExp;
      lodash2.every = every;
      lodash2.find = find2;
      lodash2.findIndex = findIndex;
      lodash2.findKey = findKey;
      lodash2.findLast = findLast;
      lodash2.findLastIndex = findLastIndex;
      lodash2.findLastKey = findLastKey;
      lodash2.floor = floor;
      lodash2.forEach = forEach;
      lodash2.forEachRight = forEachRight;
      lodash2.forIn = forIn;
      lodash2.forInRight = forInRight;
      lodash2.forOwn = forOwn;
      lodash2.forOwnRight = forOwnRight;
      lodash2.get = get2;
      lodash2.gt = gt;
      lodash2.gte = gte;
      lodash2.has = has2;
      lodash2.hasIn = hasIn;
      lodash2.head = head;
      lodash2.identity = identity2;
      lodash2.includes = includes;
      lodash2.indexOf = indexOf2;
      lodash2.inRange = inRange;
      lodash2.invoke = invoke;
      lodash2.isArguments = isArguments2;
      lodash2.isArray = isArray2;
      lodash2.isArrayBuffer = isArrayBuffer;
      lodash2.isArrayLike = isArrayLike2;
      lodash2.isArrayLikeObject = isArrayLikeObject;
      lodash2.isBoolean = isBoolean;
      lodash2.isBuffer = isBuffer2;
      lodash2.isDate = isDate;
      lodash2.isElement = isElement;
      lodash2.isEmpty = isEmpty2;
      lodash2.isEqual = isEqual2;
      lodash2.isEqualWith = isEqualWith;
      lodash2.isError = isError;
      lodash2.isFinite = isFinite2;
      lodash2.isFunction = isFunction2;
      lodash2.isInteger = isInteger;
      lodash2.isLength = isLength2;
      lodash2.isMap = isMap;
      lodash2.isMatch = isMatch;
      lodash2.isMatchWith = isMatchWith;
      lodash2.isNaN = isNaN2;
      lodash2.isNative = isNative;
      lodash2.isNil = isNil;
      lodash2.isNull = isNull;
      lodash2.isNumber = isNumber2;
      lodash2.isObject = isObject2;
      lodash2.isObjectLike = isObjectLike2;
      lodash2.isPlainObject = isPlainObject;
      lodash2.isRegExp = isRegExp2;
      lodash2.isSafeInteger = isSafeInteger;
      lodash2.isSet = isSet;
      lodash2.isString = isString2;
      lodash2.isSymbol = isSymbol;
      lodash2.isTypedArray = isTypedArray2;
      lodash2.isUndefined = isUndefined;
      lodash2.isWeakMap = isWeakMap;
      lodash2.isWeakSet = isWeakSet;
      lodash2.join = join;
      lodash2.kebabCase = kebabCase;
      lodash2.last = last;
      lodash2.lastIndexOf = lastIndexOf;
      lodash2.lowerCase = lowerCase;
      lodash2.lowerFirst = lowerFirst;
      lodash2.lt = lt2;
      lodash2.lte = lte;
      lodash2.max = max3;
      lodash2.maxBy = maxBy;
      lodash2.mean = mean;
      lodash2.meanBy = meanBy;
      lodash2.min = min3;
      lodash2.minBy = minBy;
      lodash2.stubArray = stubArray2;
      lodash2.stubFalse = stubFalse2;
      lodash2.stubObject = stubObject;
      lodash2.stubString = stubString;
      lodash2.stubTrue = stubTrue;
      lodash2.multiply = multiply;
      lodash2.nth = nth;
      lodash2.noConflict = noConflict;
      lodash2.noop = noop2;
      lodash2.now = now;
      lodash2.pad = pad3;
      lodash2.padEnd = padEnd;
      lodash2.padStart = padStart;
      lodash2.parseInt = parseInt2;
      lodash2.random = random;
      lodash2.reduce = reduce2;
      lodash2.reduceRight = reduceRight;
      lodash2.repeat = repeat;
      lodash2.replace = replace;
      lodash2.result = result;
      lodash2.round = round2;
      lodash2.runInContext = runInContext2;
      lodash2.sample = sample;
      lodash2.size = size;
      lodash2.snakeCase = snakeCase;
      lodash2.some = some;
      lodash2.sortedIndex = sortedIndex;
      lodash2.sortedIndexBy = sortedIndexBy;
      lodash2.sortedIndexOf = sortedIndexOf;
      lodash2.sortedLastIndex = sortedLastIndex;
      lodash2.sortedLastIndexBy = sortedLastIndexBy;
      lodash2.sortedLastIndexOf = sortedLastIndexOf;
      lodash2.startCase = startCase;
      lodash2.startsWith = startsWith;
      lodash2.subtract = subtract;
      lodash2.sum = sum2;
      lodash2.sumBy = sumBy;
      lodash2.template = template;
      lodash2.times = times;
      lodash2.toFinite = toFinite;
      lodash2.toInteger = toInteger;
      lodash2.toLength = toLength;
      lodash2.toLower = toLower;
      lodash2.toNumber = toNumber;
      lodash2.toSafeInteger = toSafeInteger;
      lodash2.toString = toString2;
      lodash2.toUpper = toUpper;
      lodash2.trim = trim2;
      lodash2.trimEnd = trimEnd;
      lodash2.trimStart = trimStart;
      lodash2.truncate = truncate;
      lodash2.unescape = unescape2;
      lodash2.uniqueId = uniqueId;
      lodash2.upperCase = upperCase;
      lodash2.upperFirst = upperFirst;
      lodash2.each = forEach;
      lodash2.eachRight = forEachRight;
      lodash2.first = head;
      mixin2(lodash2, function() {
        var source = {};
        baseForOwn(lodash2, function(func, methodName) {
          if (!hasOwnProperty2.call(lodash2.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      }(), { "chain": false });
      lodash2.VERSION = VERSION;
      arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
        lodash2[methodName].placeholder = lodash2;
      });
      arrayEach(["drop", "take"], function(methodName, index2) {
        LazyWrapper.prototype[methodName] = function(n2) {
          n2 = n2 === undefined$1 ? 1 : nativeMax(toInteger(n2), 0);
          var result2 = this.__filtered__ && !index2 ? new LazyWrapper(this) : this.clone();
          if (result2.__filtered__) {
            result2.__takeCount__ = nativeMin(n2, result2.__takeCount__);
          } else {
            result2.__views__.push({
              "size": nativeMin(n2, MAX_ARRAY_LENGTH),
              "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
            });
          }
          return result2;
        };
        LazyWrapper.prototype[methodName + "Right"] = function(n2) {
          return this.reverse()[methodName](n2).reverse();
        };
      });
      arrayEach(["filter", "map", "takeWhile"], function(methodName, index2) {
        var type4 = index2 + 1, isFilter = type4 == LAZY_FILTER_FLAG || type4 == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function(iteratee2) {
          var result2 = this.clone();
          result2.__iteratees__.push({
            "iteratee": getIteratee(iteratee2, 3),
            "type": type4
          });
          result2.__filtered__ = result2.__filtered__ || isFilter;
          return result2;
        };
      });
      arrayEach(["head", "last"], function(methodName, index2) {
        var takeName = "take" + (index2 ? "Right" : "");
        LazyWrapper.prototype[methodName] = function() {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(["initial", "tail"], function(methodName, index2) {
        var dropName = "drop" + (index2 ? "" : "Right");
        LazyWrapper.prototype[methodName] = function() {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function() {
        return this.filter(identity2);
      };
      LazyWrapper.prototype.find = function(predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function(predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
        if (typeof path == "function") {
          return new LazyWrapper(this);
        }
        return this.map(function(value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function(predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function(start2, end2) {
        start2 = toInteger(start2);
        var result2 = this;
        if (result2.__filtered__ && (start2 > 0 || end2 < 0)) {
          return new LazyWrapper(result2);
        }
        if (start2 < 0) {
          result2 = result2.takeRight(-start2);
        } else if (start2) {
          result2 = result2.drop(start2);
        }
        if (end2 !== undefined$1) {
          end2 = toInteger(end2);
          result2 = end2 < 0 ? result2.dropRight(-end2) : result2.take(end2 - start2);
        }
        return result2;
      };
      LazyWrapper.prototype.takeRightWhile = function(predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function() {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash2[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash2.prototype[methodName] = function() {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
          var interceptor = function(value2) {
            var result3 = lodashFunc.apply(lodash2, arrayPush2([value2], args));
            return isTaker && chainAll ? result3[0] : result3;
          };
          if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result2 = func.apply(value, args);
            result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined$1 });
            return new LodashWrapper(result2, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result2 = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
        };
      });
      arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
        var func = arrayProto2[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
        lodash2.prototype[methodName] = function() {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray2(value) ? value : [], args);
          }
          return this[chainName](function(value2) {
            return func.apply(isArray2(value2) ? value2 : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var lodashFunc = lodash2[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + "";
          if (!hasOwnProperty2.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({ "name": methodName, "func": lodashFunc });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        "name": "wrapper",
        "func": undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash2.prototype.at = wrapperAt;
      lodash2.prototype.chain = wrapperChain;
      lodash2.prototype.commit = wrapperCommit;
      lodash2.prototype.next = wrapperNext;
      lodash2.prototype.plant = wrapperPlant;
      lodash2.prototype.reverse = wrapperReverse;
      lodash2.prototype.toJSON = lodash2.prototype.valueOf = lodash2.prototype.value = wrapperValue;
      lodash2.prototype.first = lodash2.prototype.head;
      if (symIterator) {
        lodash2.prototype[symIterator] = wrapperToIterator;
      }
      return lodash2;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root2._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = useRef();
      useEffect(() => {
        var _a2, _b2;
        callbackRef.current = listener;
        function subscription(val) {
          if (callbackRef.current) {
            callbackRef.current(val);
          }
        }
        const subscriptions = (_b2 = (_a2 = this.subscriptions) == null ? void 0 : _a2.get(event)) != null ? _b2 : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        return () => {
          this.subscriptions.delete(event);
        };
      }, []);
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners == null ? void 0 : listeners.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useChartEventEmitter(options) {
  const ref2 = useRef();
  const eventEmitterOptions = useMemo$1(() => options != null ? options : { global: false }, [options]);
  const event = useCreation(() => {
    if (!ref2.current) {
      ref2.current = eventEmitterOptions.global ? ref2.current = eventEmitterOverall : ref2.current = new EventEmitter();
    }
    return ref2.current;
  }, [eventEmitterOptions]);
  useEffect(() => {
    return () => event == null ? void 0 : event.clear();
  }, [event]);
  return event;
}
const useInjection = ({
  id: id2,
  name: name2,
  chart,
  option,
  container: container2
}, deps) => {
  const ref2 = useCreation(() => _Charts, []);
  const logs = useCreation(() => LogsInstance, []);
  const event = useChartEventEmitter({ global: true });
  const previewValue = useRef();
  const currentValue = useRef();
  useEffect(() => {
    if (ref2 && (chart == null ? void 0 : chart.current) && id2 && option) {
      currentValue.current = option;
      ref2.add({
        id: id2,
        chart: chart == null ? void 0 : chart.current,
        option,
        name: name2,
        container: container2 == null ? void 0 : container2.current
      });
      logs.depsUpdata({
        id: id2,
        name: name2,
        namespace: [`deps-update`],
        currentValue: currentValue.current,
        previewValue: previewValue.current
      });
      previewValue.current = currentValue.current;
      event.emit("list");
    }
  }, deps != null ? deps : []);
  return { tool: ref2 };
};
function useChartSelect({
  normal,
  active
}) {
  const { tool } = useInjection({});
  const runSelect = ({ id: id2 }) => {
    tool.select({ id: id2, normal, active });
  };
  return {
    runSelect
  };
}
var reactDom = { exports: {} };
var reactDom_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
var objectAssign = shouldUseNative() ? Object.assign : function(target, source) {
  var from2;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from2 = Object(arguments[s]);
    for (var key in from2) {
      if (hasOwnProperty$3.call(from2, key)) {
        to[key] = from2[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from2);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from2, symbols[i])) {
          to[symbols[i]] = from2[symbols[i]];
        }
      }
    }
  }
  return to;
};
var scheduler = { exports: {} };
var scheduler_production_min = {};
/** @license React v0.20.2
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function(exports) {
  var f2, g2, h, k2;
  if (typeof performance === "object" && typeof performance.now === "function") {
    var l2 = performance;
    exports.unstable_now = function() {
      return l2.now();
    };
  } else {
    var p2 = Date, q2 = p2.now();
    exports.unstable_now = function() {
      return p2.now() - q2;
    };
  }
  if (typeof window === "undefined" || typeof MessageChannel !== "function") {
    var t2 = null, u = null, w2 = function() {
      if (t2 !== null)
        try {
          var a = exports.unstable_now();
          t2(true, a);
          t2 = null;
        } catch (b2) {
          throw setTimeout(w2, 0), b2;
        }
    };
    f2 = function(a) {
      t2 !== null ? setTimeout(f2, 0, a) : (t2 = a, setTimeout(w2, 0));
    };
    g2 = function(a, b2) {
      u = setTimeout(a, b2);
    };
    h = function() {
      clearTimeout(u);
    };
    exports.unstable_shouldYield = function() {
      return false;
    };
    k2 = exports.unstable_forceFrameRate = function() {
    };
  } else {
    var x2 = window.setTimeout, y2 = window.clearTimeout;
    if (typeof console !== "undefined") {
      var z2 = window.cancelAnimationFrame;
      typeof window.requestAnimationFrame !== "function" && console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");
      typeof z2 !== "function" && console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");
    }
    var A2 = false, B2 = null, C = -1, D2 = 5, E = 0;
    exports.unstable_shouldYield = function() {
      return exports.unstable_now() >= E;
    };
    k2 = function() {
    };
    exports.unstable_forceFrameRate = function(a) {
      0 > a || 125 < a ? console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported") : D2 = 0 < a ? Math.floor(1e3 / a) : 5;
    };
    var F2 = new MessageChannel(), G2 = F2.port2;
    F2.port1.onmessage = function() {
      if (B2 !== null) {
        var a = exports.unstable_now();
        E = a + D2;
        try {
          B2(true, a) ? G2.postMessage(null) : (A2 = false, B2 = null);
        } catch (b2) {
          throw G2.postMessage(null), b2;
        }
      } else
        A2 = false;
    };
    f2 = function(a) {
      B2 = a;
      A2 || (A2 = true, G2.postMessage(null));
    };
    g2 = function(a, b2) {
      C = x2(function() {
        a(exports.unstable_now());
      }, b2);
    };
    h = function() {
      y2(C);
      C = -1;
    };
  }
  function H2(a, b2) {
    var c2 = a.length;
    a.push(b2);
    a:
      for (; ; ) {
        var d2 = c2 - 1 >>> 1, e2 = a[d2];
        if (e2 !== void 0 && 0 < I2(e2, b2))
          a[d2] = b2, a[c2] = e2, c2 = d2;
        else
          break a;
      }
  }
  function J(a) {
    a = a[0];
    return a === void 0 ? null : a;
  }
  function K(a) {
    var b2 = a[0];
    if (b2 !== void 0) {
      var c2 = a.pop();
      if (c2 !== b2) {
        a[0] = c2;
        a:
          for (var d2 = 0, e2 = a.length; d2 < e2; ) {
            var m2 = 2 * (d2 + 1) - 1, n2 = a[m2], v4 = m2 + 1, r2 = a[v4];
            if (n2 !== void 0 && 0 > I2(n2, c2))
              r2 !== void 0 && 0 > I2(r2, n2) ? (a[d2] = r2, a[v4] = c2, d2 = v4) : (a[d2] = n2, a[m2] = c2, d2 = m2);
            else if (r2 !== void 0 && 0 > I2(r2, c2))
              a[d2] = r2, a[v4] = c2, d2 = v4;
            else
              break a;
          }
      }
      return b2;
    }
    return null;
  }
  function I2(a, b2) {
    var c2 = a.sortIndex - b2.sortIndex;
    return c2 !== 0 ? c2 : a.id - b2.id;
  }
  var L = [], M2 = [], N2 = 1, O2 = null, P2 = 3, Q = false, R2 = false, S2 = false;
  function T2(a) {
    for (var b2 = J(M2); b2 !== null; ) {
      if (b2.callback === null)
        K(M2);
      else if (b2.startTime <= a)
        K(M2), b2.sortIndex = b2.expirationTime, H2(L, b2);
      else
        break;
      b2 = J(M2);
    }
  }
  function U2(a) {
    S2 = false;
    T2(a);
    if (!R2)
      if (J(L) !== null)
        R2 = true, f2(V2);
      else {
        var b2 = J(M2);
        b2 !== null && g2(U2, b2.startTime - a);
      }
  }
  function V2(a, b2) {
    R2 = false;
    S2 && (S2 = false, h());
    Q = true;
    var c2 = P2;
    try {
      T2(b2);
      for (O2 = J(L); O2 !== null && (!(O2.expirationTime > b2) || a && !exports.unstable_shouldYield()); ) {
        var d2 = O2.callback;
        if (typeof d2 === "function") {
          O2.callback = null;
          P2 = O2.priorityLevel;
          var e2 = d2(O2.expirationTime <= b2);
          b2 = exports.unstable_now();
          typeof e2 === "function" ? O2.callback = e2 : O2 === J(L) && K(L);
          T2(b2);
        } else
          K(L);
        O2 = J(L);
      }
      if (O2 !== null)
        var m2 = true;
      else {
        var n2 = J(M2);
        n2 !== null && g2(U2, n2.startTime - b2);
        m2 = false;
      }
      return m2;
    } finally {
      O2 = null, P2 = c2, Q = false;
    }
  }
  var W2 = k2;
  exports.unstable_IdlePriority = 5;
  exports.unstable_ImmediatePriority = 1;
  exports.unstable_LowPriority = 4;
  exports.unstable_NormalPriority = 3;
  exports.unstable_Profiling = null;
  exports.unstable_UserBlockingPriority = 2;
  exports.unstable_cancelCallback = function(a) {
    a.callback = null;
  };
  exports.unstable_continueExecution = function() {
    R2 || Q || (R2 = true, f2(V2));
  };
  exports.unstable_getCurrentPriorityLevel = function() {
    return P2;
  };
  exports.unstable_getFirstCallbackNode = function() {
    return J(L);
  };
  exports.unstable_next = function(a) {
    switch (P2) {
      case 1:
      case 2:
      case 3:
        var b2 = 3;
        break;
      default:
        b2 = P2;
    }
    var c2 = P2;
    P2 = b2;
    try {
      return a();
    } finally {
      P2 = c2;
    }
  };
  exports.unstable_pauseExecution = function() {
  };
  exports.unstable_requestPaint = W2;
  exports.unstable_runWithPriority = function(a, b2) {
    switch (a) {
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
        break;
      default:
        a = 3;
    }
    var c2 = P2;
    P2 = a;
    try {
      return b2();
    } finally {
      P2 = c2;
    }
  };
  exports.unstable_scheduleCallback = function(a, b2, c2) {
    var d2 = exports.unstable_now();
    typeof c2 === "object" && c2 !== null ? (c2 = c2.delay, c2 = typeof c2 === "number" && 0 < c2 ? d2 + c2 : d2) : c2 = d2;
    switch (a) {
      case 1:
        var e2 = -1;
        break;
      case 2:
        e2 = 250;
        break;
      case 5:
        e2 = 1073741823;
        break;
      case 4:
        e2 = 1e4;
        break;
      default:
        e2 = 5e3;
    }
    e2 = c2 + e2;
    a = { id: N2++, callback: b2, priorityLevel: a, startTime: c2, expirationTime: e2, sortIndex: -1 };
    c2 > d2 ? (a.sortIndex = c2, H2(M2, a), J(L) === null && a === J(M2) && (S2 ? h() : S2 = true, g2(U2, c2 - d2))) : (a.sortIndex = e2, H2(L, a), R2 || Q || (R2 = true, f2(V2)));
    return a;
  };
  exports.unstable_wrapCallback = function(a) {
    var b2 = P2;
    return function() {
      var c2 = P2;
      P2 = b2;
      try {
        return a.apply(this, arguments);
      } finally {
        P2 = c2;
      }
    };
  };
})(scheduler_production_min);
{
  scheduler.exports = scheduler_production_min;
}
/** @license React v17.0.2
 * react-dom.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var aa = React__default, m$2 = objectAssign, r$1 = scheduler.exports;
function y$1(a) {
  for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a, c2 = 1; c2 < arguments.length; c2++)
    b2 += "&args[]=" + encodeURIComponent(arguments[c2]);
  return "Minified React error #" + a + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
}
if (!aa)
  throw Error(y$1(227));
var ba = /* @__PURE__ */ new Set(), ca = {};
function da(a, b2) {
  ea(a, b2);
  ea(a + "Capture", b2);
}
function ea(a, b2) {
  ca[a] = b2;
  for (a = 0; a < b2.length; a++)
    ba.add(b2[a]);
}
var fa = !(typeof window === "undefined" || typeof window.document === "undefined" || typeof window.document.createElement === "undefined"), ha = /^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/, ia = Object.prototype.hasOwnProperty, ja = {}, ka = {};
function la(a) {
  if (ia.call(ka, a))
    return true;
  if (ia.call(ja, a))
    return false;
  if (ha.test(a))
    return ka[a] = true;
  ja[a] = true;
  return false;
}
function ma(a, b2, c2, d2) {
  if (c2 !== null && c2.type === 0)
    return false;
  switch (typeof b2) {
    case "function":
    case "symbol":
      return true;
    case "boolean":
      if (d2)
        return false;
      if (c2 !== null)
        return !c2.acceptsBooleans;
      a = a.toLowerCase().slice(0, 5);
      return a !== "data-" && a !== "aria-";
    default:
      return false;
  }
}
function na(a, b2, c2, d2) {
  if (b2 === null || typeof b2 === "undefined" || ma(a, b2, c2, d2))
    return true;
  if (d2)
    return false;
  if (c2 !== null)
    switch (c2.type) {
      case 3:
        return !b2;
      case 4:
        return b2 === false;
      case 5:
        return isNaN(b2);
      case 6:
        return isNaN(b2) || 1 > b2;
    }
  return false;
}
function B(a, b2, c2, d2, e2, f2, g2) {
  this.acceptsBooleans = b2 === 2 || b2 === 3 || b2 === 4;
  this.attributeName = d2;
  this.attributeNamespace = e2;
  this.mustUseProperty = c2;
  this.propertyName = a;
  this.type = b2;
  this.sanitizeURL = f2;
  this.removeEmptyString = g2;
}
var D = {};
"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a) {
  D[a] = new B(a, 0, false, a, null, false, false);
});
[["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(a) {
  var b2 = a[0];
  D[b2] = new B(b2, 1, false, a[1], null, false, false);
});
["contentEditable", "draggable", "spellCheck", "value"].forEach(function(a) {
  D[a] = new B(a, 2, false, a.toLowerCase(), null, false, false);
});
["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(a) {
  D[a] = new B(a, 2, false, a, null, false, false);
});
"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a) {
  D[a] = new B(a, 3, false, a.toLowerCase(), null, false, false);
});
["checked", "multiple", "muted", "selected"].forEach(function(a) {
  D[a] = new B(a, 3, true, a, null, false, false);
});
["capture", "download"].forEach(function(a) {
  D[a] = new B(a, 4, false, a, null, false, false);
});
["cols", "rows", "size", "span"].forEach(function(a) {
  D[a] = new B(a, 6, false, a, null, false, false);
});
["rowSpan", "start"].forEach(function(a) {
  D[a] = new B(a, 5, false, a.toLowerCase(), null, false, false);
});
var oa = /[\-:]([a-z])/g;
function pa(a) {
  return a[1].toUpperCase();
}
"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, null, false, false);
});
"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, "http://www.w3.org/1999/xlink", false, false);
});
["xml:base", "xml:lang", "xml:space"].forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, "http://www.w3.org/XML/1998/namespace", false, false);
});
["tabIndex", "crossOrigin"].forEach(function(a) {
  D[a] = new B(a, 1, false, a.toLowerCase(), null, false, false);
});
D.xlinkHref = new B("xlinkHref", 1, false, "xlink:href", "http://www.w3.org/1999/xlink", true, false);
["src", "href", "action", "formAction"].forEach(function(a) {
  D[a] = new B(a, 1, false, a.toLowerCase(), null, true, true);
});
function qa(a, b2, c2, d2) {
  var e2 = D.hasOwnProperty(b2) ? D[b2] : null;
  var f2 = e2 !== null ? e2.type === 0 : d2 ? false : !(2 < b2.length) || b2[0] !== "o" && b2[0] !== "O" || b2[1] !== "n" && b2[1] !== "N" ? false : true;
  f2 || (na(b2, c2, e2, d2) && (c2 = null), d2 || e2 === null ? la(b2) && (c2 === null ? a.removeAttribute(b2) : a.setAttribute(b2, "" + c2)) : e2.mustUseProperty ? a[e2.propertyName] = c2 === null ? e2.type === 3 ? false : "" : c2 : (b2 = e2.attributeName, d2 = e2.attributeNamespace, c2 === null ? a.removeAttribute(b2) : (e2 = e2.type, c2 = e2 === 3 || e2 === 4 && c2 === true ? "" : "" + c2, d2 ? a.setAttributeNS(d2, b2, c2) : a.setAttribute(b2, c2))));
}
var ra = aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED, sa = 60103, ta = 60106, ua = 60107, wa = 60108, xa = 60114, ya = 60109, za = 60110, Aa = 60112, Ba = 60113, Ca = 60120, Da = 60115, Ea = 60116, Fa = 60121, Ga = 60128, Ha = 60129, Ia = 60130, Ja = 60131;
if (typeof Symbol === "function" && Symbol.for) {
  var E = Symbol.for;
  sa = E("react.element");
  ta = E("react.portal");
  ua = E("react.fragment");
  wa = E("react.strict_mode");
  xa = E("react.profiler");
  ya = E("react.provider");
  za = E("react.context");
  Aa = E("react.forward_ref");
  Ba = E("react.suspense");
  Ca = E("react.suspense_list");
  Da = E("react.memo");
  Ea = E("react.lazy");
  Fa = E("react.block");
  E("react.scope");
  Ga = E("react.opaque.id");
  Ha = E("react.debug_trace_mode");
  Ia = E("react.offscreen");
  Ja = E("react.legacy_hidden");
}
var Ka = typeof Symbol === "function" && Symbol.iterator;
function La(a) {
  if (a === null || typeof a !== "object")
    return null;
  a = Ka && a[Ka] || a["@@iterator"];
  return typeof a === "function" ? a : null;
}
var Ma;
function Na(a) {
  if (Ma === void 0)
    try {
      throw Error();
    } catch (c2) {
      var b2 = c2.stack.trim().match(/\n( *(at )?)/);
      Ma = b2 && b2[1] || "";
    }
  return "\n" + Ma + a;
}
var Oa = false;
function Pa(a, b2) {
  if (!a || Oa)
    return "";
  Oa = true;
  var c2 = Error.prepareStackTrace;
  Error.prepareStackTrace = void 0;
  try {
    if (b2)
      if (b2 = function() {
        throw Error();
      }, Object.defineProperty(b2.prototype, "props", { set: function() {
        throw Error();
      } }), typeof Reflect === "object" && Reflect.construct) {
        try {
          Reflect.construct(b2, []);
        } catch (k2) {
          var d2 = k2;
        }
        Reflect.construct(a, [], b2);
      } else {
        try {
          b2.call();
        } catch (k2) {
          d2 = k2;
        }
        a.call(b2.prototype);
      }
    else {
      try {
        throw Error();
      } catch (k2) {
        d2 = k2;
      }
      a();
    }
  } catch (k2) {
    if (k2 && d2 && typeof k2.stack === "string") {
      for (var e2 = k2.stack.split("\n"), f2 = d2.stack.split("\n"), g2 = e2.length - 1, h = f2.length - 1; 1 <= g2 && 0 <= h && e2[g2] !== f2[h]; )
        h--;
      for (; 1 <= g2 && 0 <= h; g2--, h--)
        if (e2[g2] !== f2[h]) {
          if (g2 !== 1 || h !== 1) {
            do
              if (g2--, h--, 0 > h || e2[g2] !== f2[h])
                return "\n" + e2[g2].replace(" at new ", " at ");
            while (1 <= g2 && 0 <= h);
          }
          break;
        }
    }
  } finally {
    Oa = false, Error.prepareStackTrace = c2;
  }
  return (a = a ? a.displayName || a.name : "") ? Na(a) : "";
}
function Qa(a) {
  switch (a.tag) {
    case 5:
      return Na(a.type);
    case 16:
      return Na("Lazy");
    case 13:
      return Na("Suspense");
    case 19:
      return Na("SuspenseList");
    case 0:
    case 2:
    case 15:
      return a = Pa(a.type, false), a;
    case 11:
      return a = Pa(a.type.render, false), a;
    case 22:
      return a = Pa(a.type._render, false), a;
    case 1:
      return a = Pa(a.type, true), a;
    default:
      return "";
  }
}
function Ra(a) {
  if (a == null)
    return null;
  if (typeof a === "function")
    return a.displayName || a.name || null;
  if (typeof a === "string")
    return a;
  switch (a) {
    case ua:
      return "Fragment";
    case ta:
      return "Portal";
    case xa:
      return "Profiler";
    case wa:
      return "StrictMode";
    case Ba:
      return "Suspense";
    case Ca:
      return "SuspenseList";
  }
  if (typeof a === "object")
    switch (a.$$typeof) {
      case za:
        return (a.displayName || "Context") + ".Consumer";
      case ya:
        return (a._context.displayName || "Context") + ".Provider";
      case Aa:
        var b2 = a.render;
        b2 = b2.displayName || b2.name || "";
        return a.displayName || (b2 !== "" ? "ForwardRef(" + b2 + ")" : "ForwardRef");
      case Da:
        return Ra(a.type);
      case Fa:
        return Ra(a._render);
      case Ea:
        b2 = a._payload;
        a = a._init;
        try {
          return Ra(a(b2));
        } catch (c2) {
        }
    }
  return null;
}
function Sa(a) {
  switch (typeof a) {
    case "boolean":
    case "number":
    case "object":
    case "string":
    case "undefined":
      return a;
    default:
      return "";
  }
}
function Ta(a) {
  var b2 = a.type;
  return (a = a.nodeName) && a.toLowerCase() === "input" && (b2 === "checkbox" || b2 === "radio");
}
function Ua(a) {
  var b2 = Ta(a) ? "checked" : "value", c2 = Object.getOwnPropertyDescriptor(a.constructor.prototype, b2), d2 = "" + a[b2];
  if (!a.hasOwnProperty(b2) && typeof c2 !== "undefined" && typeof c2.get === "function" && typeof c2.set === "function") {
    var e2 = c2.get, f2 = c2.set;
    Object.defineProperty(a, b2, { configurable: true, get: function() {
      return e2.call(this);
    }, set: function(a2) {
      d2 = "" + a2;
      f2.call(this, a2);
    } });
    Object.defineProperty(a, b2, { enumerable: c2.enumerable });
    return { getValue: function() {
      return d2;
    }, setValue: function(a2) {
      d2 = "" + a2;
    }, stopTracking: function() {
      a._valueTracker = null;
      delete a[b2];
    } };
  }
}
function Va(a) {
  a._valueTracker || (a._valueTracker = Ua(a));
}
function Wa(a) {
  if (!a)
    return false;
  var b2 = a._valueTracker;
  if (!b2)
    return true;
  var c2 = b2.getValue();
  var d2 = "";
  a && (d2 = Ta(a) ? a.checked ? "true" : "false" : a.value);
  a = d2;
  return a !== c2 ? (b2.setValue(a), true) : false;
}
function Xa(a) {
  a = a || (typeof document !== "undefined" ? document : void 0);
  if (typeof a === "undefined")
    return null;
  try {
    return a.activeElement || a.body;
  } catch (b2) {
    return a.body;
  }
}
function Ya(a, b2) {
  var c2 = b2.checked;
  return m$2({}, b2, { defaultChecked: void 0, defaultValue: void 0, value: void 0, checked: c2 != null ? c2 : a._wrapperState.initialChecked });
}
function Za(a, b2) {
  var c2 = b2.defaultValue == null ? "" : b2.defaultValue, d2 = b2.checked != null ? b2.checked : b2.defaultChecked;
  c2 = Sa(b2.value != null ? b2.value : c2);
  a._wrapperState = { initialChecked: d2, initialValue: c2, controlled: b2.type === "checkbox" || b2.type === "radio" ? b2.checked != null : b2.value != null };
}
function $a(a, b2) {
  b2 = b2.checked;
  b2 != null && qa(a, "checked", b2, false);
}
function ab(a, b2) {
  $a(a, b2);
  var c2 = Sa(b2.value), d2 = b2.type;
  if (c2 != null)
    if (d2 === "number") {
      if (c2 === 0 && a.value === "" || a.value != c2)
        a.value = "" + c2;
    } else
      a.value !== "" + c2 && (a.value = "" + c2);
  else if (d2 === "submit" || d2 === "reset") {
    a.removeAttribute("value");
    return;
  }
  b2.hasOwnProperty("value") ? bb(a, b2.type, c2) : b2.hasOwnProperty("defaultValue") && bb(a, b2.type, Sa(b2.defaultValue));
  b2.checked == null && b2.defaultChecked != null && (a.defaultChecked = !!b2.defaultChecked);
}
function cb(a, b2, c2) {
  if (b2.hasOwnProperty("value") || b2.hasOwnProperty("defaultValue")) {
    var d2 = b2.type;
    if (!(d2 !== "submit" && d2 !== "reset" || b2.value !== void 0 && b2.value !== null))
      return;
    b2 = "" + a._wrapperState.initialValue;
    c2 || b2 === a.value || (a.value = b2);
    a.defaultValue = b2;
  }
  c2 = a.name;
  c2 !== "" && (a.name = "");
  a.defaultChecked = !!a._wrapperState.initialChecked;
  c2 !== "" && (a.name = c2);
}
function bb(a, b2, c2) {
  if (b2 !== "number" || Xa(a.ownerDocument) !== a)
    c2 == null ? a.defaultValue = "" + a._wrapperState.initialValue : a.defaultValue !== "" + c2 && (a.defaultValue = "" + c2);
}
function db(a) {
  var b2 = "";
  aa.Children.forEach(a, function(a2) {
    a2 != null && (b2 += a2);
  });
  return b2;
}
function eb(a, b2) {
  a = m$2({ children: void 0 }, b2);
  if (b2 = db(b2.children))
    a.children = b2;
  return a;
}
function fb(a, b2, c2, d2) {
  a = a.options;
  if (b2) {
    b2 = {};
    for (var e2 = 0; e2 < c2.length; e2++)
      b2["$" + c2[e2]] = true;
    for (c2 = 0; c2 < a.length; c2++)
      e2 = b2.hasOwnProperty("$" + a[c2].value), a[c2].selected !== e2 && (a[c2].selected = e2), e2 && d2 && (a[c2].defaultSelected = true);
  } else {
    c2 = "" + Sa(c2);
    b2 = null;
    for (e2 = 0; e2 < a.length; e2++) {
      if (a[e2].value === c2) {
        a[e2].selected = true;
        d2 && (a[e2].defaultSelected = true);
        return;
      }
      b2 !== null || a[e2].disabled || (b2 = a[e2]);
    }
    b2 !== null && (b2.selected = true);
  }
}
function gb(a, b2) {
  if (b2.dangerouslySetInnerHTML != null)
    throw Error(y$1(91));
  return m$2({}, b2, { value: void 0, defaultValue: void 0, children: "" + a._wrapperState.initialValue });
}
function hb(a, b2) {
  var c2 = b2.value;
  if (c2 == null) {
    c2 = b2.children;
    b2 = b2.defaultValue;
    if (c2 != null) {
      if (b2 != null)
        throw Error(y$1(92));
      if (Array.isArray(c2)) {
        if (!(1 >= c2.length))
          throw Error(y$1(93));
        c2 = c2[0];
      }
      b2 = c2;
    }
    b2 == null && (b2 = "");
    c2 = b2;
  }
  a._wrapperState = { initialValue: Sa(c2) };
}
function ib(a, b2) {
  var c2 = Sa(b2.value), d2 = Sa(b2.defaultValue);
  c2 != null && (c2 = "" + c2, c2 !== a.value && (a.value = c2), b2.defaultValue == null && a.defaultValue !== c2 && (a.defaultValue = c2));
  d2 != null && (a.defaultValue = "" + d2);
}
function jb(a) {
  var b2 = a.textContent;
  b2 === a._wrapperState.initialValue && b2 !== "" && b2 !== null && (a.value = b2);
}
var kb = { html: "http://www.w3.org/1999/xhtml", mathml: "http://www.w3.org/1998/Math/MathML", svg: "http://www.w3.org/2000/svg" };
function lb(a) {
  switch (a) {
    case "svg":
      return "http://www.w3.org/2000/svg";
    case "math":
      return "http://www.w3.org/1998/Math/MathML";
    default:
      return "http://www.w3.org/1999/xhtml";
  }
}
function mb(a, b2) {
  return a == null || a === "http://www.w3.org/1999/xhtml" ? lb(b2) : a === "http://www.w3.org/2000/svg" && b2 === "foreignObject" ? "http://www.w3.org/1999/xhtml" : a;
}
var nb, ob = function(a) {
  return typeof MSApp !== "undefined" && MSApp.execUnsafeLocalFunction ? function(b2, c2, d2, e2) {
    MSApp.execUnsafeLocalFunction(function() {
      return a(b2, c2, d2, e2);
    });
  } : a;
}(function(a, b2) {
  if (a.namespaceURI !== kb.svg || "innerHTML" in a)
    a.innerHTML = b2;
  else {
    nb = nb || document.createElement("div");
    nb.innerHTML = "<svg>" + b2.valueOf().toString() + "</svg>";
    for (b2 = nb.firstChild; a.firstChild; )
      a.removeChild(a.firstChild);
    for (; b2.firstChild; )
      a.appendChild(b2.firstChild);
  }
});
function pb(a, b2) {
  if (b2) {
    var c2 = a.firstChild;
    if (c2 && c2 === a.lastChild && c2.nodeType === 3) {
      c2.nodeValue = b2;
      return;
    }
  }
  a.textContent = b2;
}
var qb = {
  animationIterationCount: true,
  borderImageOutset: true,
  borderImageSlice: true,
  borderImageWidth: true,
  boxFlex: true,
  boxFlexGroup: true,
  boxOrdinalGroup: true,
  columnCount: true,
  columns: true,
  flex: true,
  flexGrow: true,
  flexPositive: true,
  flexShrink: true,
  flexNegative: true,
  flexOrder: true,
  gridArea: true,
  gridRow: true,
  gridRowEnd: true,
  gridRowSpan: true,
  gridRowStart: true,
  gridColumn: true,
  gridColumnEnd: true,
  gridColumnSpan: true,
  gridColumnStart: true,
  fontWeight: true,
  lineClamp: true,
  lineHeight: true,
  opacity: true,
  order: true,
  orphans: true,
  tabSize: true,
  widows: true,
  zIndex: true,
  zoom: true,
  fillOpacity: true,
  floodOpacity: true,
  stopOpacity: true,
  strokeDasharray: true,
  strokeDashoffset: true,
  strokeMiterlimit: true,
  strokeOpacity: true,
  strokeWidth: true
}, rb = ["Webkit", "ms", "Moz", "O"];
Object.keys(qb).forEach(function(a) {
  rb.forEach(function(b2) {
    b2 = b2 + a.charAt(0).toUpperCase() + a.substring(1);
    qb[b2] = qb[a];
  });
});
function sb(a, b2, c2) {
  return b2 == null || typeof b2 === "boolean" || b2 === "" ? "" : c2 || typeof b2 !== "number" || b2 === 0 || qb.hasOwnProperty(a) && qb[a] ? ("" + b2).trim() : b2 + "px";
}
function tb(a, b2) {
  a = a.style;
  for (var c2 in b2)
    if (b2.hasOwnProperty(c2)) {
      var d2 = c2.indexOf("--") === 0, e2 = sb(c2, b2[c2], d2);
      c2 === "float" && (c2 = "cssFloat");
      d2 ? a.setProperty(c2, e2) : a[c2] = e2;
    }
}
var ub = m$2({ menuitem: true }, { area: true, base: true, br: true, col: true, embed: true, hr: true, img: true, input: true, keygen: true, link: true, meta: true, param: true, source: true, track: true, wbr: true });
function vb(a, b2) {
  if (b2) {
    if (ub[a] && (b2.children != null || b2.dangerouslySetInnerHTML != null))
      throw Error(y$1(137, a));
    if (b2.dangerouslySetInnerHTML != null) {
      if (b2.children != null)
        throw Error(y$1(60));
      if (!(typeof b2.dangerouslySetInnerHTML === "object" && "__html" in b2.dangerouslySetInnerHTML))
        throw Error(y$1(61));
    }
    if (b2.style != null && typeof b2.style !== "object")
      throw Error(y$1(62));
  }
}
function wb(a, b2) {
  if (a.indexOf("-") === -1)
    return typeof b2.is === "string";
  switch (a) {
    case "annotation-xml":
    case "color-profile":
    case "font-face":
    case "font-face-src":
    case "font-face-uri":
    case "font-face-format":
    case "font-face-name":
    case "missing-glyph":
      return false;
    default:
      return true;
  }
}
function xb(a) {
  a = a.target || a.srcElement || window;
  a.correspondingUseElement && (a = a.correspondingUseElement);
  return a.nodeType === 3 ? a.parentNode : a;
}
var yb = null, zb = null, Ab = null;
function Bb(a) {
  if (a = Cb(a)) {
    if (typeof yb !== "function")
      throw Error(y$1(280));
    var b2 = a.stateNode;
    b2 && (b2 = Db(b2), yb(a.stateNode, a.type, b2));
  }
}
function Eb(a) {
  zb ? Ab ? Ab.push(a) : Ab = [a] : zb = a;
}
function Fb() {
  if (zb) {
    var a = zb, b2 = Ab;
    Ab = zb = null;
    Bb(a);
    if (b2)
      for (a = 0; a < b2.length; a++)
        Bb(b2[a]);
  }
}
function Gb(a, b2) {
  return a(b2);
}
function Hb(a, b2, c2, d2, e2) {
  return a(b2, c2, d2, e2);
}
function Ib() {
}
var Jb = Gb, Kb = false, Lb = false;
function Mb() {
  if (zb !== null || Ab !== null)
    Ib(), Fb();
}
function Nb(a, b2, c2) {
  if (Lb)
    return a(b2, c2);
  Lb = true;
  try {
    return Jb(a, b2, c2);
  } finally {
    Lb = false, Mb();
  }
}
function Ob(a, b2) {
  var c2 = a.stateNode;
  if (c2 === null)
    return null;
  var d2 = Db(c2);
  if (d2 === null)
    return null;
  c2 = d2[b2];
  a:
    switch (b2) {
      case "onClick":
      case "onClickCapture":
      case "onDoubleClick":
      case "onDoubleClickCapture":
      case "onMouseDown":
      case "onMouseDownCapture":
      case "onMouseMove":
      case "onMouseMoveCapture":
      case "onMouseUp":
      case "onMouseUpCapture":
      case "onMouseEnter":
        (d2 = !d2.disabled) || (a = a.type, d2 = !(a === "button" || a === "input" || a === "select" || a === "textarea"));
        a = !d2;
        break a;
      default:
        a = false;
    }
  if (a)
    return null;
  if (c2 && typeof c2 !== "function")
    throw Error(y$1(231, b2, typeof c2));
  return c2;
}
var Pb = false;
if (fa)
  try {
    var Qb = {};
    Object.defineProperty(Qb, "passive", { get: function() {
      Pb = true;
    } });
    window.addEventListener("test", Qb, Qb);
    window.removeEventListener("test", Qb, Qb);
  } catch (a) {
    Pb = false;
  }
function Rb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  var l2 = Array.prototype.slice.call(arguments, 3);
  try {
    b2.apply(c2, l2);
  } catch (n2) {
    this.onError(n2);
  }
}
var Sb = false, Tb = null, Ub = false, Vb = null, Wb = { onError: function(a) {
  Sb = true;
  Tb = a;
} };
function Xb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  Sb = false;
  Tb = null;
  Rb.apply(Wb, arguments);
}
function Yb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  Xb.apply(this, arguments);
  if (Sb) {
    if (Sb) {
      var l2 = Tb;
      Sb = false;
      Tb = null;
    } else
      throw Error(y$1(198));
    Ub || (Ub = true, Vb = l2);
  }
}
function Zb(a) {
  var b2 = a, c2 = a;
  if (a.alternate)
    for (; b2.return; )
      b2 = b2.return;
  else {
    a = b2;
    do
      b2 = a, (b2.flags & 1026) !== 0 && (c2 = b2.return), a = b2.return;
    while (a);
  }
  return b2.tag === 3 ? c2 : null;
}
function $b(a) {
  if (a.tag === 13) {
    var b2 = a.memoizedState;
    b2 === null && (a = a.alternate, a !== null && (b2 = a.memoizedState));
    if (b2 !== null)
      return b2.dehydrated;
  }
  return null;
}
function ac(a) {
  if (Zb(a) !== a)
    throw Error(y$1(188));
}
function bc(a) {
  var b2 = a.alternate;
  if (!b2) {
    b2 = Zb(a);
    if (b2 === null)
      throw Error(y$1(188));
    return b2 !== a ? null : a;
  }
  for (var c2 = a, d2 = b2; ; ) {
    var e2 = c2.return;
    if (e2 === null)
      break;
    var f2 = e2.alternate;
    if (f2 === null) {
      d2 = e2.return;
      if (d2 !== null) {
        c2 = d2;
        continue;
      }
      break;
    }
    if (e2.child === f2.child) {
      for (f2 = e2.child; f2; ) {
        if (f2 === c2)
          return ac(e2), a;
        if (f2 === d2)
          return ac(e2), b2;
        f2 = f2.sibling;
      }
      throw Error(y$1(188));
    }
    if (c2.return !== d2.return)
      c2 = e2, d2 = f2;
    else {
      for (var g2 = false, h = e2.child; h; ) {
        if (h === c2) {
          g2 = true;
          c2 = e2;
          d2 = f2;
          break;
        }
        if (h === d2) {
          g2 = true;
          d2 = e2;
          c2 = f2;
          break;
        }
        h = h.sibling;
      }
      if (!g2) {
        for (h = f2.child; h; ) {
          if (h === c2) {
            g2 = true;
            c2 = f2;
            d2 = e2;
            break;
          }
          if (h === d2) {
            g2 = true;
            d2 = f2;
            c2 = e2;
            break;
          }
          h = h.sibling;
        }
        if (!g2)
          throw Error(y$1(189));
      }
    }
    if (c2.alternate !== d2)
      throw Error(y$1(190));
  }
  if (c2.tag !== 3)
    throw Error(y$1(188));
  return c2.stateNode.current === c2 ? a : b2;
}
function cc(a) {
  a = bc(a);
  if (!a)
    return null;
  for (var b2 = a; ; ) {
    if (b2.tag === 5 || b2.tag === 6)
      return b2;
    if (b2.child)
      b2.child.return = b2, b2 = b2.child;
    else {
      if (b2 === a)
        break;
      for (; !b2.sibling; ) {
        if (!b2.return || b2.return === a)
          return null;
        b2 = b2.return;
      }
      b2.sibling.return = b2.return;
      b2 = b2.sibling;
    }
  }
  return null;
}
function dc(a, b2) {
  for (var c2 = a.alternate; b2 !== null; ) {
    if (b2 === a || b2 === c2)
      return true;
    b2 = b2.return;
  }
  return false;
}
var ec, fc, gc, hc, ic = false, jc = [], kc = null, lc = null, mc = null, nc = /* @__PURE__ */ new Map(), oc = /* @__PURE__ */ new Map(), pc = [], qc = "mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
function rc(a, b2, c2, d2, e2) {
  return { blockedOn: a, domEventName: b2, eventSystemFlags: c2 | 16, nativeEvent: e2, targetContainers: [d2] };
}
function sc(a, b2) {
  switch (a) {
    case "focusin":
    case "focusout":
      kc = null;
      break;
    case "dragenter":
    case "dragleave":
      lc = null;
      break;
    case "mouseover":
    case "mouseout":
      mc = null;
      break;
    case "pointerover":
    case "pointerout":
      nc.delete(b2.pointerId);
      break;
    case "gotpointercapture":
    case "lostpointercapture":
      oc.delete(b2.pointerId);
  }
}
function tc(a, b2, c2, d2, e2, f2) {
  if (a === null || a.nativeEvent !== f2)
    return a = rc(b2, c2, d2, e2, f2), b2 !== null && (b2 = Cb(b2), b2 !== null && fc(b2)), a;
  a.eventSystemFlags |= d2;
  b2 = a.targetContainers;
  e2 !== null && b2.indexOf(e2) === -1 && b2.push(e2);
  return a;
}
function uc(a, b2, c2, d2, e2) {
  switch (b2) {
    case "focusin":
      return kc = tc(kc, a, b2, c2, d2, e2), true;
    case "dragenter":
      return lc = tc(lc, a, b2, c2, d2, e2), true;
    case "mouseover":
      return mc = tc(mc, a, b2, c2, d2, e2), true;
    case "pointerover":
      var f2 = e2.pointerId;
      nc.set(f2, tc(nc.get(f2) || null, a, b2, c2, d2, e2));
      return true;
    case "gotpointercapture":
      return f2 = e2.pointerId, oc.set(f2, tc(oc.get(f2) || null, a, b2, c2, d2, e2)), true;
  }
  return false;
}
function vc(a) {
  var b2 = wc(a.target);
  if (b2 !== null) {
    var c2 = Zb(b2);
    if (c2 !== null) {
      if (b2 = c2.tag, b2 === 13) {
        if (b2 = $b(c2), b2 !== null) {
          a.blockedOn = b2;
          hc(a.lanePriority, function() {
            r$1.unstable_runWithPriority(a.priority, function() {
              gc(c2);
            });
          });
          return;
        }
      } else if (b2 === 3 && c2.stateNode.hydrate) {
        a.blockedOn = c2.tag === 3 ? c2.stateNode.containerInfo : null;
        return;
      }
    }
  }
  a.blockedOn = null;
}
function xc(a) {
  if (a.blockedOn !== null)
    return false;
  for (var b2 = a.targetContainers; 0 < b2.length; ) {
    var c2 = yc(a.domEventName, a.eventSystemFlags, b2[0], a.nativeEvent);
    if (c2 !== null)
      return b2 = Cb(c2), b2 !== null && fc(b2), a.blockedOn = c2, false;
    b2.shift();
  }
  return true;
}
function zc(a, b2, c2) {
  xc(a) && c2.delete(b2);
}
function Ac() {
  for (ic = false; 0 < jc.length; ) {
    var a = jc[0];
    if (a.blockedOn !== null) {
      a = Cb(a.blockedOn);
      a !== null && ec(a);
      break;
    }
    for (var b2 = a.targetContainers; 0 < b2.length; ) {
      var c2 = yc(a.domEventName, a.eventSystemFlags, b2[0], a.nativeEvent);
      if (c2 !== null) {
        a.blockedOn = c2;
        break;
      }
      b2.shift();
    }
    a.blockedOn === null && jc.shift();
  }
  kc !== null && xc(kc) && (kc = null);
  lc !== null && xc(lc) && (lc = null);
  mc !== null && xc(mc) && (mc = null);
  nc.forEach(zc);
  oc.forEach(zc);
}
function Bc(a, b2) {
  a.blockedOn === b2 && (a.blockedOn = null, ic || (ic = true, r$1.unstable_scheduleCallback(r$1.unstable_NormalPriority, Ac)));
}
function Cc(a) {
  function b2(b3) {
    return Bc(b3, a);
  }
  if (0 < jc.length) {
    Bc(jc[0], a);
    for (var c2 = 1; c2 < jc.length; c2++) {
      var d2 = jc[c2];
      d2.blockedOn === a && (d2.blockedOn = null);
    }
  }
  kc !== null && Bc(kc, a);
  lc !== null && Bc(lc, a);
  mc !== null && Bc(mc, a);
  nc.forEach(b2);
  oc.forEach(b2);
  for (c2 = 0; c2 < pc.length; c2++)
    d2 = pc[c2], d2.blockedOn === a && (d2.blockedOn = null);
  for (; 0 < pc.length && (c2 = pc[0], c2.blockedOn === null); )
    vc(c2), c2.blockedOn === null && pc.shift();
}
function Dc(a, b2) {
  var c2 = {};
  c2[a.toLowerCase()] = b2.toLowerCase();
  c2["Webkit" + a] = "webkit" + b2;
  c2["Moz" + a] = "moz" + b2;
  return c2;
}
var Ec = { animationend: Dc("Animation", "AnimationEnd"), animationiteration: Dc("Animation", "AnimationIteration"), animationstart: Dc("Animation", "AnimationStart"), transitionend: Dc("Transition", "TransitionEnd") }, Fc = {}, Gc = {};
fa && (Gc = document.createElement("div").style, "AnimationEvent" in window || (delete Ec.animationend.animation, delete Ec.animationiteration.animation, delete Ec.animationstart.animation), "TransitionEvent" in window || delete Ec.transitionend.transition);
function Hc(a) {
  if (Fc[a])
    return Fc[a];
  if (!Ec[a])
    return a;
  var b2 = Ec[a], c2;
  for (c2 in b2)
    if (b2.hasOwnProperty(c2) && c2 in Gc)
      return Fc[a] = b2[c2];
  return a;
}
var Ic = Hc("animationend"), Jc = Hc("animationiteration"), Kc = Hc("animationstart"), Lc = Hc("transitionend"), Mc = /* @__PURE__ */ new Map(), Nc = /* @__PURE__ */ new Map(), Oc = [
  "abort",
  "abort",
  Ic,
  "animationEnd",
  Jc,
  "animationIteration",
  Kc,
  "animationStart",
  "canplay",
  "canPlay",
  "canplaythrough",
  "canPlayThrough",
  "durationchange",
  "durationChange",
  "emptied",
  "emptied",
  "encrypted",
  "encrypted",
  "ended",
  "ended",
  "error",
  "error",
  "gotpointercapture",
  "gotPointerCapture",
  "load",
  "load",
  "loadeddata",
  "loadedData",
  "loadedmetadata",
  "loadedMetadata",
  "loadstart",
  "loadStart",
  "lostpointercapture",
  "lostPointerCapture",
  "playing",
  "playing",
  "progress",
  "progress",
  "seeking",
  "seeking",
  "stalled",
  "stalled",
  "suspend",
  "suspend",
  "timeupdate",
  "timeUpdate",
  Lc,
  "transitionEnd",
  "waiting",
  "waiting"
];
function Pc(a, b2) {
  for (var c2 = 0; c2 < a.length; c2 += 2) {
    var d2 = a[c2], e2 = a[c2 + 1];
    e2 = "on" + (e2[0].toUpperCase() + e2.slice(1));
    Nc.set(d2, b2);
    Mc.set(d2, e2);
    da(e2, [d2]);
  }
}
var Qc = r$1.unstable_now;
Qc();
var F = 8;
function Rc(a) {
  if ((1 & a) !== 0)
    return F = 15, 1;
  if ((2 & a) !== 0)
    return F = 14, 2;
  if ((4 & a) !== 0)
    return F = 13, 4;
  var b2 = 24 & a;
  if (b2 !== 0)
    return F = 12, b2;
  if ((a & 32) !== 0)
    return F = 11, 32;
  b2 = 192 & a;
  if (b2 !== 0)
    return F = 10, b2;
  if ((a & 256) !== 0)
    return F = 9, 256;
  b2 = 3584 & a;
  if (b2 !== 0)
    return F = 8, b2;
  if ((a & 4096) !== 0)
    return F = 7, 4096;
  b2 = 4186112 & a;
  if (b2 !== 0)
    return F = 6, b2;
  b2 = 62914560 & a;
  if (b2 !== 0)
    return F = 5, b2;
  if (a & 67108864)
    return F = 4, 67108864;
  if ((a & 134217728) !== 0)
    return F = 3, 134217728;
  b2 = 805306368 & a;
  if (b2 !== 0)
    return F = 2, b2;
  if ((1073741824 & a) !== 0)
    return F = 1, 1073741824;
  F = 8;
  return a;
}
function Sc(a) {
  switch (a) {
    case 99:
      return 15;
    case 98:
      return 10;
    case 97:
    case 96:
      return 8;
    case 95:
      return 2;
    default:
      return 0;
  }
}
function Tc(a) {
  switch (a) {
    case 15:
    case 14:
      return 99;
    case 13:
    case 12:
    case 11:
    case 10:
      return 98;
    case 9:
    case 8:
    case 7:
    case 6:
    case 4:
    case 5:
      return 97;
    case 3:
    case 2:
    case 1:
      return 95;
    case 0:
      return 90;
    default:
      throw Error(y$1(358, a));
  }
}
function Uc(a, b2) {
  var c2 = a.pendingLanes;
  if (c2 === 0)
    return F = 0;
  var d2 = 0, e2 = 0, f2 = a.expiredLanes, g2 = a.suspendedLanes, h = a.pingedLanes;
  if (f2 !== 0)
    d2 = f2, e2 = F = 15;
  else if (f2 = c2 & 134217727, f2 !== 0) {
    var k2 = f2 & ~g2;
    k2 !== 0 ? (d2 = Rc(k2), e2 = F) : (h &= f2, h !== 0 && (d2 = Rc(h), e2 = F));
  } else
    f2 = c2 & ~g2, f2 !== 0 ? (d2 = Rc(f2), e2 = F) : h !== 0 && (d2 = Rc(h), e2 = F);
  if (d2 === 0)
    return 0;
  d2 = 31 - Vc(d2);
  d2 = c2 & ((0 > d2 ? 0 : 1 << d2) << 1) - 1;
  if (b2 !== 0 && b2 !== d2 && (b2 & g2) === 0) {
    Rc(b2);
    if (e2 <= F)
      return b2;
    F = e2;
  }
  b2 = a.entangledLanes;
  if (b2 !== 0)
    for (a = a.entanglements, b2 &= d2; 0 < b2; )
      c2 = 31 - Vc(b2), e2 = 1 << c2, d2 |= a[c2], b2 &= ~e2;
  return d2;
}
function Wc(a) {
  a = a.pendingLanes & -1073741825;
  return a !== 0 ? a : a & 1073741824 ? 1073741824 : 0;
}
function Xc(a, b2) {
  switch (a) {
    case 15:
      return 1;
    case 14:
      return 2;
    case 12:
      return a = Yc(24 & ~b2), a === 0 ? Xc(10, b2) : a;
    case 10:
      return a = Yc(192 & ~b2), a === 0 ? Xc(8, b2) : a;
    case 8:
      return a = Yc(3584 & ~b2), a === 0 && (a = Yc(4186112 & ~b2), a === 0 && (a = 512)), a;
    case 2:
      return b2 = Yc(805306368 & ~b2), b2 === 0 && (b2 = 268435456), b2;
  }
  throw Error(y$1(358, a));
}
function Yc(a) {
  return a & -a;
}
function Zc(a) {
  for (var b2 = [], c2 = 0; 31 > c2; c2++)
    b2.push(a);
  return b2;
}
function $c(a, b2, c2) {
  a.pendingLanes |= b2;
  var d2 = b2 - 1;
  a.suspendedLanes &= d2;
  a.pingedLanes &= d2;
  a = a.eventTimes;
  b2 = 31 - Vc(b2);
  a[b2] = c2;
}
var Vc = Math.clz32 ? Math.clz32 : ad, bd = Math.log, cd = Math.LN2;
function ad(a) {
  return a === 0 ? 32 : 31 - (bd(a) / cd | 0) | 0;
}
var dd = r$1.unstable_UserBlockingPriority, ed = r$1.unstable_runWithPriority, fd = true;
function gd(a, b2, c2, d2) {
  Kb || Ib();
  var e2 = hd, f2 = Kb;
  Kb = true;
  try {
    Hb(e2, a, b2, c2, d2);
  } finally {
    (Kb = f2) || Mb();
  }
}
function id$1(a, b2, c2, d2) {
  ed(dd, hd.bind(null, a, b2, c2, d2));
}
function hd(a, b2, c2, d2) {
  if (fd) {
    var e2;
    if ((e2 = (b2 & 4) === 0) && 0 < jc.length && -1 < qc.indexOf(a))
      a = rc(null, a, b2, c2, d2), jc.push(a);
    else {
      var f2 = yc(a, b2, c2, d2);
      if (f2 === null)
        e2 && sc(a, d2);
      else {
        if (e2) {
          if (-1 < qc.indexOf(a)) {
            a = rc(f2, a, b2, c2, d2);
            jc.push(a);
            return;
          }
          if (uc(f2, a, b2, c2, d2))
            return;
          sc(a, d2);
        }
        jd(a, b2, d2, null, c2);
      }
    }
  }
}
function yc(a, b2, c2, d2) {
  var e2 = xb(d2);
  e2 = wc(e2);
  if (e2 !== null) {
    var f2 = Zb(e2);
    if (f2 === null)
      e2 = null;
    else {
      var g2 = f2.tag;
      if (g2 === 13) {
        e2 = $b(f2);
        if (e2 !== null)
          return e2;
        e2 = null;
      } else if (g2 === 3) {
        if (f2.stateNode.hydrate)
          return f2.tag === 3 ? f2.stateNode.containerInfo : null;
        e2 = null;
      } else
        f2 !== e2 && (e2 = null);
    }
  }
  jd(a, b2, d2, e2, c2);
  return null;
}
var kd = null, ld = null, md = null;
function nd() {
  if (md)
    return md;
  var a, b2 = ld, c2 = b2.length, d2, e2 = "value" in kd ? kd.value : kd.textContent, f2 = e2.length;
  for (a = 0; a < c2 && b2[a] === e2[a]; a++)
    ;
  var g2 = c2 - a;
  for (d2 = 1; d2 <= g2 && b2[c2 - d2] === e2[f2 - d2]; d2++)
    ;
  return md = e2.slice(a, 1 < d2 ? 1 - d2 : void 0);
}
function od(a) {
  var b2 = a.keyCode;
  "charCode" in a ? (a = a.charCode, a === 0 && b2 === 13 && (a = 13)) : a = b2;
  a === 10 && (a = 13);
  return 32 <= a || a === 13 ? a : 0;
}
function pd() {
  return true;
}
function qd() {
  return false;
}
function rd(a) {
  function b2(b3, d2, e2, f2, g2) {
    this._reactName = b3;
    this._targetInst = e2;
    this.type = d2;
    this.nativeEvent = f2;
    this.target = g2;
    this.currentTarget = null;
    for (var c2 in a)
      a.hasOwnProperty(c2) && (b3 = a[c2], this[c2] = b3 ? b3(f2) : f2[c2]);
    this.isDefaultPrevented = (f2.defaultPrevented != null ? f2.defaultPrevented : f2.returnValue === false) ? pd : qd;
    this.isPropagationStopped = qd;
    return this;
  }
  m$2(b2.prototype, { preventDefault: function() {
    this.defaultPrevented = true;
    var a2 = this.nativeEvent;
    a2 && (a2.preventDefault ? a2.preventDefault() : typeof a2.returnValue !== "unknown" && (a2.returnValue = false), this.isDefaultPrevented = pd);
  }, stopPropagation: function() {
    var a2 = this.nativeEvent;
    a2 && (a2.stopPropagation ? a2.stopPropagation() : typeof a2.cancelBubble !== "unknown" && (a2.cancelBubble = true), this.isPropagationStopped = pd);
  }, persist: function() {
  }, isPersistent: pd });
  return b2;
}
var sd = { eventPhase: 0, bubbles: 0, cancelable: 0, timeStamp: function(a) {
  return a.timeStamp || Date.now();
}, defaultPrevented: 0, isTrusted: 0 }, td = rd(sd), ud = m$2({}, sd, { view: 0, detail: 0 }), vd = rd(ud), wd, xd, yd, Ad = m$2({}, ud, { screenX: 0, screenY: 0, clientX: 0, clientY: 0, pageX: 0, pageY: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, getModifierState: zd, button: 0, buttons: 0, relatedTarget: function(a) {
  return a.relatedTarget === void 0 ? a.fromElement === a.srcElement ? a.toElement : a.fromElement : a.relatedTarget;
}, movementX: function(a) {
  if ("movementX" in a)
    return a.movementX;
  a !== yd && (yd && a.type === "mousemove" ? (wd = a.screenX - yd.screenX, xd = a.screenY - yd.screenY) : xd = wd = 0, yd = a);
  return wd;
}, movementY: function(a) {
  return "movementY" in a ? a.movementY : xd;
} }), Bd = rd(Ad), Cd = m$2({}, Ad, { dataTransfer: 0 }), Dd = rd(Cd), Ed = m$2({}, ud, { relatedTarget: 0 }), Fd = rd(Ed), Gd = m$2({}, sd, { animationName: 0, elapsedTime: 0, pseudoElement: 0 }), Hd = rd(Gd), Id = m$2({}, sd, { clipboardData: function(a) {
  return "clipboardData" in a ? a.clipboardData : window.clipboardData;
} }), Jd = rd(Id), Kd = m$2({}, sd, { data: 0 }), Ld = rd(Kd), Md = {
  Esc: "Escape",
  Spacebar: " ",
  Left: "ArrowLeft",
  Up: "ArrowUp",
  Right: "ArrowRight",
  Down: "ArrowDown",
  Del: "Delete",
  Win: "OS",
  Menu: "ContextMenu",
  Apps: "ContextMenu",
  Scroll: "ScrollLock",
  MozPrintableKey: "Unidentified"
}, Nd = {
  8: "Backspace",
  9: "Tab",
  12: "Clear",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  19: "Pause",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  45: "Insert",
  46: "Delete",
  112: "F1",
  113: "F2",
  114: "F3",
  115: "F4",
  116: "F5",
  117: "F6",
  118: "F7",
  119: "F8",
  120: "F9",
  121: "F10",
  122: "F11",
  123: "F12",
  144: "NumLock",
  145: "ScrollLock",
  224: "Meta"
}, Od = { Alt: "altKey", Control: "ctrlKey", Meta: "metaKey", Shift: "shiftKey" };
function Pd(a) {
  var b2 = this.nativeEvent;
  return b2.getModifierState ? b2.getModifierState(a) : (a = Od[a]) ? !!b2[a] : false;
}
function zd() {
  return Pd;
}
var Qd = m$2({}, ud, { key: function(a) {
  if (a.key) {
    var b2 = Md[a.key] || a.key;
    if (b2 !== "Unidentified")
      return b2;
  }
  return a.type === "keypress" ? (a = od(a), a === 13 ? "Enter" : String.fromCharCode(a)) : a.type === "keydown" || a.type === "keyup" ? Nd[a.keyCode] || "Unidentified" : "";
}, code: 0, location: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, repeat: 0, locale: 0, getModifierState: zd, charCode: function(a) {
  return a.type === "keypress" ? od(a) : 0;
}, keyCode: function(a) {
  return a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
}, which: function(a) {
  return a.type === "keypress" ? od(a) : a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
} }), Rd = rd(Qd), Sd = m$2({}, Ad, { pointerId: 0, width: 0, height: 0, pressure: 0, tangentialPressure: 0, tiltX: 0, tiltY: 0, twist: 0, pointerType: 0, isPrimary: 0 }), Td = rd(Sd), Ud = m$2({}, ud, { touches: 0, targetTouches: 0, changedTouches: 0, altKey: 0, metaKey: 0, ctrlKey: 0, shiftKey: 0, getModifierState: zd }), Vd = rd(Ud), Wd = m$2({}, sd, { propertyName: 0, elapsedTime: 0, pseudoElement: 0 }), Xd = rd(Wd), Yd = m$2({}, Ad, {
  deltaX: function(a) {
    return "deltaX" in a ? a.deltaX : "wheelDeltaX" in a ? -a.wheelDeltaX : 0;
  },
  deltaY: function(a) {
    return "deltaY" in a ? a.deltaY : "wheelDeltaY" in a ? -a.wheelDeltaY : "wheelDelta" in a ? -a.wheelDelta : 0;
  },
  deltaZ: 0,
  deltaMode: 0
}), Zd = rd(Yd), $d = [9, 13, 27, 32], ae = fa && "CompositionEvent" in window, be = null;
fa && "documentMode" in document && (be = document.documentMode);
var ce = fa && "TextEvent" in window && !be, de = fa && (!ae || be && 8 < be && 11 >= be), ee = String.fromCharCode(32), fe = false;
function ge(a, b2) {
  switch (a) {
    case "keyup":
      return $d.indexOf(b2.keyCode) !== -1;
    case "keydown":
      return b2.keyCode !== 229;
    case "keypress":
    case "mousedown":
    case "focusout":
      return true;
    default:
      return false;
  }
}
function he(a) {
  a = a.detail;
  return typeof a === "object" && "data" in a ? a.data : null;
}
var ie = false;
function je(a, b2) {
  switch (a) {
    case "compositionend":
      return he(b2);
    case "keypress":
      if (b2.which !== 32)
        return null;
      fe = true;
      return ee;
    case "textInput":
      return a = b2.data, a === ee && fe ? null : a;
    default:
      return null;
  }
}
function ke(a, b2) {
  if (ie)
    return a === "compositionend" || !ae && ge(a, b2) ? (a = nd(), md = ld = kd = null, ie = false, a) : null;
  switch (a) {
    case "paste":
      return null;
    case "keypress":
      if (!(b2.ctrlKey || b2.altKey || b2.metaKey) || b2.ctrlKey && b2.altKey) {
        if (b2.char && 1 < b2.char.length)
          return b2.char;
        if (b2.which)
          return String.fromCharCode(b2.which);
      }
      return null;
    case "compositionend":
      return de && b2.locale !== "ko" ? null : b2.data;
    default:
      return null;
  }
}
var le = { color: true, date: true, datetime: true, "datetime-local": true, email: true, month: true, number: true, password: true, range: true, search: true, tel: true, text: true, time: true, url: true, week: true };
function me(a) {
  var b2 = a && a.nodeName && a.nodeName.toLowerCase();
  return b2 === "input" ? !!le[a.type] : b2 === "textarea" ? true : false;
}
function ne(a, b2, c2, d2) {
  Eb(d2);
  b2 = oe(b2, "onChange");
  0 < b2.length && (c2 = new td("onChange", "change", null, c2, d2), a.push({ event: c2, listeners: b2 }));
}
var pe = null, qe = null;
function re(a) {
  se(a, 0);
}
function te(a) {
  var b2 = ue(a);
  if (Wa(b2))
    return a;
}
function ve(a, b2) {
  if (a === "change")
    return b2;
}
var we = false;
if (fa) {
  var xe;
  if (fa) {
    var ye = "oninput" in document;
    if (!ye) {
      var ze = document.createElement("div");
      ze.setAttribute("oninput", "return;");
      ye = typeof ze.oninput === "function";
    }
    xe = ye;
  } else
    xe = false;
  we = xe && (!document.documentMode || 9 < document.documentMode);
}
function Ae() {
  pe && (pe.detachEvent("onpropertychange", Be), qe = pe = null);
}
function Be(a) {
  if (a.propertyName === "value" && te(qe)) {
    var b2 = [];
    ne(b2, qe, a, xb(a));
    a = re;
    if (Kb)
      a(b2);
    else {
      Kb = true;
      try {
        Gb(a, b2);
      } finally {
        Kb = false, Mb();
      }
    }
  }
}
function Ce(a, b2, c2) {
  a === "focusin" ? (Ae(), pe = b2, qe = c2, pe.attachEvent("onpropertychange", Be)) : a === "focusout" && Ae();
}
function De(a) {
  if (a === "selectionchange" || a === "keyup" || a === "keydown")
    return te(qe);
}
function Ee(a, b2) {
  if (a === "click")
    return te(b2);
}
function Fe(a, b2) {
  if (a === "input" || a === "change")
    return te(b2);
}
function Ge(a, b2) {
  return a === b2 && (a !== 0 || 1 / a === 1 / b2) || a !== a && b2 !== b2;
}
var He = typeof Object.is === "function" ? Object.is : Ge, Ie = Object.prototype.hasOwnProperty;
function Je(a, b2) {
  if (He(a, b2))
    return true;
  if (typeof a !== "object" || a === null || typeof b2 !== "object" || b2 === null)
    return false;
  var c2 = Object.keys(a), d2 = Object.keys(b2);
  if (c2.length !== d2.length)
    return false;
  for (d2 = 0; d2 < c2.length; d2++)
    if (!Ie.call(b2, c2[d2]) || !He(a[c2[d2]], b2[c2[d2]]))
      return false;
  return true;
}
function Ke(a) {
  for (; a && a.firstChild; )
    a = a.firstChild;
  return a;
}
function Le(a, b2) {
  var c2 = Ke(a);
  a = 0;
  for (var d2; c2; ) {
    if (c2.nodeType === 3) {
      d2 = a + c2.textContent.length;
      if (a <= b2 && d2 >= b2)
        return { node: c2, offset: b2 - a };
      a = d2;
    }
    a: {
      for (; c2; ) {
        if (c2.nextSibling) {
          c2 = c2.nextSibling;
          break a;
        }
        c2 = c2.parentNode;
      }
      c2 = void 0;
    }
    c2 = Ke(c2);
  }
}
function Me(a, b2) {
  return a && b2 ? a === b2 ? true : a && a.nodeType === 3 ? false : b2 && b2.nodeType === 3 ? Me(a, b2.parentNode) : "contains" in a ? a.contains(b2) : a.compareDocumentPosition ? !!(a.compareDocumentPosition(b2) & 16) : false : false;
}
function Ne() {
  for (var a = window, b2 = Xa(); b2 instanceof a.HTMLIFrameElement; ) {
    try {
      var c2 = typeof b2.contentWindow.location.href === "string";
    } catch (d2) {
      c2 = false;
    }
    if (c2)
      a = b2.contentWindow;
    else
      break;
    b2 = Xa(a.document);
  }
  return b2;
}
function Oe(a) {
  var b2 = a && a.nodeName && a.nodeName.toLowerCase();
  return b2 && (b2 === "input" && (a.type === "text" || a.type === "search" || a.type === "tel" || a.type === "url" || a.type === "password") || b2 === "textarea" || a.contentEditable === "true");
}
var Pe = fa && "documentMode" in document && 11 >= document.documentMode, Qe = null, Re = null, Se = null, Te = false;
function Ue(a, b2, c2) {
  var d2 = c2.window === c2 ? c2.document : c2.nodeType === 9 ? c2 : c2.ownerDocument;
  Te || Qe == null || Qe !== Xa(d2) || (d2 = Qe, "selectionStart" in d2 && Oe(d2) ? d2 = { start: d2.selectionStart, end: d2.selectionEnd } : (d2 = (d2.ownerDocument && d2.ownerDocument.defaultView || window).getSelection(), d2 = { anchorNode: d2.anchorNode, anchorOffset: d2.anchorOffset, focusNode: d2.focusNode, focusOffset: d2.focusOffset }), Se && Je(Se, d2) || (Se = d2, d2 = oe(Re, "onSelect"), 0 < d2.length && (b2 = new td("onSelect", "select", null, b2, c2), a.push({ event: b2, listeners: d2 }), b2.target = Qe)));
}
Pc("cancel cancel click click close close contextmenu contextMenu copy copy cut cut auxclick auxClick dblclick doubleClick dragend dragEnd dragstart dragStart drop drop focusin focus focusout blur input input invalid invalid keydown keyDown keypress keyPress keyup keyUp mousedown mouseDown mouseup mouseUp paste paste pause pause play play pointercancel pointerCancel pointerdown pointerDown pointerup pointerUp ratechange rateChange reset reset seeked seeked submit submit touchcancel touchCancel touchend touchEnd touchstart touchStart volumechange volumeChange".split(" "), 0);
Pc("drag drag dragenter dragEnter dragexit dragExit dragleave dragLeave dragover dragOver mousemove mouseMove mouseout mouseOut mouseover mouseOver pointermove pointerMove pointerout pointerOut pointerover pointerOver scroll scroll toggle toggle touchmove touchMove wheel wheel".split(" "), 1);
Pc(Oc, 2);
for (var Ve = "change selectionchange textInput compositionstart compositionend compositionupdate".split(" "), We = 0; We < Ve.length; We++)
  Nc.set(Ve[We], 0);
ea("onMouseEnter", ["mouseout", "mouseover"]);
ea("onMouseLeave", ["mouseout", "mouseover"]);
ea("onPointerEnter", ["pointerout", "pointerover"]);
ea("onPointerLeave", ["pointerout", "pointerover"]);
da("onChange", "change click focusin focusout input keydown keyup selectionchange".split(" "));
da("onSelect", "focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));
da("onBeforeInput", ["compositionend", "keypress", "textInput", "paste"]);
da("onCompositionEnd", "compositionend focusout keydown keypress keyup mousedown".split(" "));
da("onCompositionStart", "compositionstart focusout keydown keypress keyup mousedown".split(" "));
da("onCompositionUpdate", "compositionupdate focusout keydown keypress keyup mousedown".split(" "));
var Xe = "abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange seeked seeking stalled suspend timeupdate volumechange waiting".split(" "), Ye = new Set("cancel close invalid load scroll toggle".split(" ").concat(Xe));
function Ze(a, b2, c2) {
  var d2 = a.type || "unknown-event";
  a.currentTarget = c2;
  Yb(d2, b2, void 0, a);
  a.currentTarget = null;
}
function se(a, b2) {
  b2 = (b2 & 4) !== 0;
  for (var c2 = 0; c2 < a.length; c2++) {
    var d2 = a[c2], e2 = d2.event;
    d2 = d2.listeners;
    a: {
      var f2 = void 0;
      if (b2)
        for (var g2 = d2.length - 1; 0 <= g2; g2--) {
          var h = d2[g2], k2 = h.instance, l2 = h.currentTarget;
          h = h.listener;
          if (k2 !== f2 && e2.isPropagationStopped())
            break a;
          Ze(e2, h, l2);
          f2 = k2;
        }
      else
        for (g2 = 0; g2 < d2.length; g2++) {
          h = d2[g2];
          k2 = h.instance;
          l2 = h.currentTarget;
          h = h.listener;
          if (k2 !== f2 && e2.isPropagationStopped())
            break a;
          Ze(e2, h, l2);
          f2 = k2;
        }
    }
  }
  if (Ub)
    throw a = Vb, Ub = false, Vb = null, a;
}
function G(a, b2) {
  var c2 = $e(b2), d2 = a + "__bubble";
  c2.has(d2) || (af(b2, a, 2, false), c2.add(d2));
}
var bf = "_reactListening" + Math.random().toString(36).slice(2);
function cf(a) {
  a[bf] || (a[bf] = true, ba.forEach(function(b2) {
    Ye.has(b2) || df(b2, false, a, null);
    df(b2, true, a, null);
  }));
}
function df(a, b2, c2, d2) {
  var e2 = 4 < arguments.length && arguments[4] !== void 0 ? arguments[4] : 0, f2 = c2;
  a === "selectionchange" && c2.nodeType !== 9 && (f2 = c2.ownerDocument);
  if (d2 !== null && !b2 && Ye.has(a)) {
    if (a !== "scroll")
      return;
    e2 |= 2;
    f2 = d2;
  }
  var g2 = $e(f2), h = a + "__" + (b2 ? "capture" : "bubble");
  g2.has(h) || (b2 && (e2 |= 4), af(f2, a, e2, b2), g2.add(h));
}
function af(a, b2, c2, d2) {
  var e2 = Nc.get(b2);
  switch (e2 === void 0 ? 2 : e2) {
    case 0:
      e2 = gd;
      break;
    case 1:
      e2 = id$1;
      break;
    default:
      e2 = hd;
  }
  c2 = e2.bind(null, b2, c2, a);
  e2 = void 0;
  !Pb || b2 !== "touchstart" && b2 !== "touchmove" && b2 !== "wheel" || (e2 = true);
  d2 ? e2 !== void 0 ? a.addEventListener(b2, c2, { capture: true, passive: e2 }) : a.addEventListener(b2, c2, true) : e2 !== void 0 ? a.addEventListener(b2, c2, { passive: e2 }) : a.addEventListener(b2, c2, false);
}
function jd(a, b2, c2, d2, e2) {
  var f2 = d2;
  if ((b2 & 1) === 0 && (b2 & 2) === 0 && d2 !== null)
    a:
      for (; ; ) {
        if (d2 === null)
          return;
        var g2 = d2.tag;
        if (g2 === 3 || g2 === 4) {
          var h = d2.stateNode.containerInfo;
          if (h === e2 || h.nodeType === 8 && h.parentNode === e2)
            break;
          if (g2 === 4)
            for (g2 = d2.return; g2 !== null; ) {
              var k2 = g2.tag;
              if (k2 === 3 || k2 === 4) {
                if (k2 = g2.stateNode.containerInfo, k2 === e2 || k2.nodeType === 8 && k2.parentNode === e2)
                  return;
              }
              g2 = g2.return;
            }
          for (; h !== null; ) {
            g2 = wc(h);
            if (g2 === null)
              return;
            k2 = g2.tag;
            if (k2 === 5 || k2 === 6) {
              d2 = f2 = g2;
              continue a;
            }
            h = h.parentNode;
          }
        }
        d2 = d2.return;
      }
  Nb(function() {
    var d3 = f2, e3 = xb(c2), g3 = [];
    a: {
      var h2 = Mc.get(a);
      if (h2 !== void 0) {
        var k3 = td, x2 = a;
        switch (a) {
          case "keypress":
            if (od(c2) === 0)
              break a;
          case "keydown":
          case "keyup":
            k3 = Rd;
            break;
          case "focusin":
            x2 = "focus";
            k3 = Fd;
            break;
          case "focusout":
            x2 = "blur";
            k3 = Fd;
            break;
          case "beforeblur":
          case "afterblur":
            k3 = Fd;
            break;
          case "click":
            if (c2.button === 2)
              break a;
          case "auxclick":
          case "dblclick":
          case "mousedown":
          case "mousemove":
          case "mouseup":
          case "mouseout":
          case "mouseover":
          case "contextmenu":
            k3 = Bd;
            break;
          case "drag":
          case "dragend":
          case "dragenter":
          case "dragexit":
          case "dragleave":
          case "dragover":
          case "dragstart":
          case "drop":
            k3 = Dd;
            break;
          case "touchcancel":
          case "touchend":
          case "touchmove":
          case "touchstart":
            k3 = Vd;
            break;
          case Ic:
          case Jc:
          case Kc:
            k3 = Hd;
            break;
          case Lc:
            k3 = Xd;
            break;
          case "scroll":
            k3 = vd;
            break;
          case "wheel":
            k3 = Zd;
            break;
          case "copy":
          case "cut":
          case "paste":
            k3 = Jd;
            break;
          case "gotpointercapture":
          case "lostpointercapture":
          case "pointercancel":
          case "pointerdown":
          case "pointermove":
          case "pointerout":
          case "pointerover":
          case "pointerup":
            k3 = Td;
        }
        var w2 = (b2 & 4) !== 0, z2 = !w2 && a === "scroll", u = w2 ? h2 !== null ? h2 + "Capture" : null : h2;
        w2 = [];
        for (var t2 = d3, q2; t2 !== null; ) {
          q2 = t2;
          var v4 = q2.stateNode;
          q2.tag === 5 && v4 !== null && (q2 = v4, u !== null && (v4 = Ob(t2, u), v4 != null && w2.push(ef(t2, v4, q2))));
          if (z2)
            break;
          t2 = t2.return;
        }
        0 < w2.length && (h2 = new k3(h2, x2, null, c2, e3), g3.push({ event: h2, listeners: w2 }));
      }
    }
    if ((b2 & 7) === 0) {
      a: {
        h2 = a === "mouseover" || a === "pointerover";
        k3 = a === "mouseout" || a === "pointerout";
        if (h2 && (b2 & 16) === 0 && (x2 = c2.relatedTarget || c2.fromElement) && (wc(x2) || x2[ff]))
          break a;
        if (k3 || h2) {
          h2 = e3.window === e3 ? e3 : (h2 = e3.ownerDocument) ? h2.defaultView || h2.parentWindow : window;
          if (k3) {
            if (x2 = c2.relatedTarget || c2.toElement, k3 = d3, x2 = x2 ? wc(x2) : null, x2 !== null && (z2 = Zb(x2), x2 !== z2 || x2.tag !== 5 && x2.tag !== 6))
              x2 = null;
          } else
            k3 = null, x2 = d3;
          if (k3 !== x2) {
            w2 = Bd;
            v4 = "onMouseLeave";
            u = "onMouseEnter";
            t2 = "mouse";
            if (a === "pointerout" || a === "pointerover")
              w2 = Td, v4 = "onPointerLeave", u = "onPointerEnter", t2 = "pointer";
            z2 = k3 == null ? h2 : ue(k3);
            q2 = x2 == null ? h2 : ue(x2);
            h2 = new w2(v4, t2 + "leave", k3, c2, e3);
            h2.target = z2;
            h2.relatedTarget = q2;
            v4 = null;
            wc(e3) === d3 && (w2 = new w2(u, t2 + "enter", x2, c2, e3), w2.target = q2, w2.relatedTarget = z2, v4 = w2);
            z2 = v4;
            if (k3 && x2)
              b: {
                w2 = k3;
                u = x2;
                t2 = 0;
                for (q2 = w2; q2; q2 = gf(q2))
                  t2++;
                q2 = 0;
                for (v4 = u; v4; v4 = gf(v4))
                  q2++;
                for (; 0 < t2 - q2; )
                  w2 = gf(w2), t2--;
                for (; 0 < q2 - t2; )
                  u = gf(u), q2--;
                for (; t2--; ) {
                  if (w2 === u || u !== null && w2 === u.alternate)
                    break b;
                  w2 = gf(w2);
                  u = gf(u);
                }
                w2 = null;
              }
            else
              w2 = null;
            k3 !== null && hf(g3, h2, k3, w2, false);
            x2 !== null && z2 !== null && hf(g3, z2, x2, w2, true);
          }
        }
      }
      a: {
        h2 = d3 ? ue(d3) : window;
        k3 = h2.nodeName && h2.nodeName.toLowerCase();
        if (k3 === "select" || k3 === "input" && h2.type === "file")
          var J = ve;
        else if (me(h2))
          if (we)
            J = Fe;
          else {
            J = De;
            var K = Ce;
          }
        else
          (k3 = h2.nodeName) && k3.toLowerCase() === "input" && (h2.type === "checkbox" || h2.type === "radio") && (J = Ee);
        if (J && (J = J(a, d3))) {
          ne(g3, J, c2, e3);
          break a;
        }
        K && K(a, h2, d3);
        a === "focusout" && (K = h2._wrapperState) && K.controlled && h2.type === "number" && bb(h2, "number", h2.value);
      }
      K = d3 ? ue(d3) : window;
      switch (a) {
        case "focusin":
          if (me(K) || K.contentEditable === "true")
            Qe = K, Re = d3, Se = null;
          break;
        case "focusout":
          Se = Re = Qe = null;
          break;
        case "mousedown":
          Te = true;
          break;
        case "contextmenu":
        case "mouseup":
        case "dragend":
          Te = false;
          Ue(g3, c2, e3);
          break;
        case "selectionchange":
          if (Pe)
            break;
        case "keydown":
        case "keyup":
          Ue(g3, c2, e3);
      }
      var Q;
      if (ae)
        b: {
          switch (a) {
            case "compositionstart":
              var L = "onCompositionStart";
              break b;
            case "compositionend":
              L = "onCompositionEnd";
              break b;
            case "compositionupdate":
              L = "onCompositionUpdate";
              break b;
          }
          L = void 0;
        }
      else
        ie ? ge(a, c2) && (L = "onCompositionEnd") : a === "keydown" && c2.keyCode === 229 && (L = "onCompositionStart");
      L && (de && c2.locale !== "ko" && (ie || L !== "onCompositionStart" ? L === "onCompositionEnd" && ie && (Q = nd()) : (kd = e3, ld = "value" in kd ? kd.value : kd.textContent, ie = true)), K = oe(d3, L), 0 < K.length && (L = new Ld(L, a, null, c2, e3), g3.push({ event: L, listeners: K }), Q ? L.data = Q : (Q = he(c2), Q !== null && (L.data = Q))));
      if (Q = ce ? je(a, c2) : ke(a, c2))
        d3 = oe(d3, "onBeforeInput"), 0 < d3.length && (e3 = new Ld("onBeforeInput", "beforeinput", null, c2, e3), g3.push({ event: e3, listeners: d3 }), e3.data = Q);
    }
    se(g3, b2);
  });
}
function ef(a, b2, c2) {
  return { instance: a, listener: b2, currentTarget: c2 };
}
function oe(a, b2) {
  for (var c2 = b2 + "Capture", d2 = []; a !== null; ) {
    var e2 = a, f2 = e2.stateNode;
    e2.tag === 5 && f2 !== null && (e2 = f2, f2 = Ob(a, c2), f2 != null && d2.unshift(ef(a, f2, e2)), f2 = Ob(a, b2), f2 != null && d2.push(ef(a, f2, e2)));
    a = a.return;
  }
  return d2;
}
function gf(a) {
  if (a === null)
    return null;
  do
    a = a.return;
  while (a && a.tag !== 5);
  return a ? a : null;
}
function hf(a, b2, c2, d2, e2) {
  for (var f2 = b2._reactName, g2 = []; c2 !== null && c2 !== d2; ) {
    var h = c2, k2 = h.alternate, l2 = h.stateNode;
    if (k2 !== null && k2 === d2)
      break;
    h.tag === 5 && l2 !== null && (h = l2, e2 ? (k2 = Ob(c2, f2), k2 != null && g2.unshift(ef(c2, k2, h))) : e2 || (k2 = Ob(c2, f2), k2 != null && g2.push(ef(c2, k2, h))));
    c2 = c2.return;
  }
  g2.length !== 0 && a.push({ event: b2, listeners: g2 });
}
function jf() {
}
var kf = null, lf = null;
function mf(a, b2) {
  switch (a) {
    case "button":
    case "input":
    case "select":
    case "textarea":
      return !!b2.autoFocus;
  }
  return false;
}
function nf(a, b2) {
  return a === "textarea" || a === "option" || a === "noscript" || typeof b2.children === "string" || typeof b2.children === "number" || typeof b2.dangerouslySetInnerHTML === "object" && b2.dangerouslySetInnerHTML !== null && b2.dangerouslySetInnerHTML.__html != null;
}
var of = typeof setTimeout === "function" ? setTimeout : void 0, pf = typeof clearTimeout === "function" ? clearTimeout : void 0;
function qf(a) {
  a.nodeType === 1 ? a.textContent = "" : a.nodeType === 9 && (a = a.body, a != null && (a.textContent = ""));
}
function rf(a) {
  for (; a != null; a = a.nextSibling) {
    var b2 = a.nodeType;
    if (b2 === 1 || b2 === 3)
      break;
  }
  return a;
}
function sf(a) {
  a = a.previousSibling;
  for (var b2 = 0; a; ) {
    if (a.nodeType === 8) {
      var c2 = a.data;
      if (c2 === "$" || c2 === "$!" || c2 === "$?") {
        if (b2 === 0)
          return a;
        b2--;
      } else
        c2 === "/$" && b2++;
    }
    a = a.previousSibling;
  }
  return null;
}
var tf = 0;
function uf(a) {
  return { $$typeof: Ga, toString: a, valueOf: a };
}
var vf = Math.random().toString(36).slice(2), wf = "__reactFiber$" + vf, xf = "__reactProps$" + vf, ff = "__reactContainer$" + vf, yf = "__reactEvents$" + vf;
function wc(a) {
  var b2 = a[wf];
  if (b2)
    return b2;
  for (var c2 = a.parentNode; c2; ) {
    if (b2 = c2[ff] || c2[wf]) {
      c2 = b2.alternate;
      if (b2.child !== null || c2 !== null && c2.child !== null)
        for (a = sf(a); a !== null; ) {
          if (c2 = a[wf])
            return c2;
          a = sf(a);
        }
      return b2;
    }
    a = c2;
    c2 = a.parentNode;
  }
  return null;
}
function Cb(a) {
  a = a[wf] || a[ff];
  return !a || a.tag !== 5 && a.tag !== 6 && a.tag !== 13 && a.tag !== 3 ? null : a;
}
function ue(a) {
  if (a.tag === 5 || a.tag === 6)
    return a.stateNode;
  throw Error(y$1(33));
}
function Db(a) {
  return a[xf] || null;
}
function $e(a) {
  var b2 = a[yf];
  b2 === void 0 && (b2 = a[yf] = /* @__PURE__ */ new Set());
  return b2;
}
var zf = [], Af = -1;
function Bf(a) {
  return { current: a };
}
function H(a) {
  0 > Af || (a.current = zf[Af], zf[Af] = null, Af--);
}
function I(a, b2) {
  Af++;
  zf[Af] = a.current;
  a.current = b2;
}
var Cf = {}, M = Bf(Cf), N = Bf(false), Df = Cf;
function Ef(a, b2) {
  var c2 = a.type.contextTypes;
  if (!c2)
    return Cf;
  var d2 = a.stateNode;
  if (d2 && d2.__reactInternalMemoizedUnmaskedChildContext === b2)
    return d2.__reactInternalMemoizedMaskedChildContext;
  var e2 = {}, f2;
  for (f2 in c2)
    e2[f2] = b2[f2];
  d2 && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = b2, a.__reactInternalMemoizedMaskedChildContext = e2);
  return e2;
}
function Ff(a) {
  a = a.childContextTypes;
  return a !== null && a !== void 0;
}
function Gf() {
  H(N);
  H(M);
}
function Hf(a, b2, c2) {
  if (M.current !== Cf)
    throw Error(y$1(168));
  I(M, b2);
  I(N, c2);
}
function If(a, b2, c2) {
  var d2 = a.stateNode;
  a = b2.childContextTypes;
  if (typeof d2.getChildContext !== "function")
    return c2;
  d2 = d2.getChildContext();
  for (var e2 in d2)
    if (!(e2 in a))
      throw Error(y$1(108, Ra(b2) || "Unknown", e2));
  return m$2({}, c2, d2);
}
function Jf(a) {
  a = (a = a.stateNode) && a.__reactInternalMemoizedMergedChildContext || Cf;
  Df = M.current;
  I(M, a);
  I(N, N.current);
  return true;
}
function Kf(a, b2, c2) {
  var d2 = a.stateNode;
  if (!d2)
    throw Error(y$1(169));
  c2 ? (a = If(a, b2, Df), d2.__reactInternalMemoizedMergedChildContext = a, H(N), H(M), I(M, a)) : H(N);
  I(N, c2);
}
var Lf = null, Mf = null, Nf = r$1.unstable_runWithPriority, Of = r$1.unstable_scheduleCallback, Pf = r$1.unstable_cancelCallback, Qf = r$1.unstable_shouldYield, Rf = r$1.unstable_requestPaint, Sf = r$1.unstable_now, Tf = r$1.unstable_getCurrentPriorityLevel, Uf = r$1.unstable_ImmediatePriority, Vf = r$1.unstable_UserBlockingPriority, Wf = r$1.unstable_NormalPriority, Xf = r$1.unstable_LowPriority, Yf = r$1.unstable_IdlePriority, Zf = {}, $f = Rf !== void 0 ? Rf : function() {
}, ag = null, bg = null, cg = false, dg = Sf(), O = 1e4 > dg ? Sf : function() {
  return Sf() - dg;
};
function eg() {
  switch (Tf()) {
    case Uf:
      return 99;
    case Vf:
      return 98;
    case Wf:
      return 97;
    case Xf:
      return 96;
    case Yf:
      return 95;
    default:
      throw Error(y$1(332));
  }
}
function fg(a) {
  switch (a) {
    case 99:
      return Uf;
    case 98:
      return Vf;
    case 97:
      return Wf;
    case 96:
      return Xf;
    case 95:
      return Yf;
    default:
      throw Error(y$1(332));
  }
}
function gg(a, b2) {
  a = fg(a);
  return Nf(a, b2);
}
function hg(a, b2, c2) {
  a = fg(a);
  return Of(a, b2, c2);
}
function ig() {
  if (bg !== null) {
    var a = bg;
    bg = null;
    Pf(a);
  }
  jg();
}
function jg() {
  if (!cg && ag !== null) {
    cg = true;
    var a = 0;
    try {
      var b2 = ag;
      gg(99, function() {
        for (; a < b2.length; a++) {
          var c2 = b2[a];
          do
            c2 = c2(true);
          while (c2 !== null);
        }
      });
      ag = null;
    } catch (c2) {
      throw ag !== null && (ag = ag.slice(a + 1)), Of(Uf, ig), c2;
    } finally {
      cg = false;
    }
  }
}
var kg = ra.ReactCurrentBatchConfig;
function lg(a, b2) {
  if (a && a.defaultProps) {
    b2 = m$2({}, b2);
    a = a.defaultProps;
    for (var c2 in a)
      b2[c2] === void 0 && (b2[c2] = a[c2]);
    return b2;
  }
  return b2;
}
var mg = Bf(null), ng = null, og = null, pg = null;
function qg() {
  pg = og = ng = null;
}
function rg(a) {
  var b2 = mg.current;
  H(mg);
  a.type._context._currentValue = b2;
}
function sg(a, b2) {
  for (; a !== null; ) {
    var c2 = a.alternate;
    if ((a.childLanes & b2) === b2)
      if (c2 === null || (c2.childLanes & b2) === b2)
        break;
      else
        c2.childLanes |= b2;
    else
      a.childLanes |= b2, c2 !== null && (c2.childLanes |= b2);
    a = a.return;
  }
}
function tg(a, b2) {
  ng = a;
  pg = og = null;
  a = a.dependencies;
  a !== null && a.firstContext !== null && ((a.lanes & b2) !== 0 && (ug = true), a.firstContext = null);
}
function vg(a, b2) {
  if (pg !== a && b2 !== false && b2 !== 0) {
    if (typeof b2 !== "number" || b2 === 1073741823)
      pg = a, b2 = 1073741823;
    b2 = { context: a, observedBits: b2, next: null };
    if (og === null) {
      if (ng === null)
        throw Error(y$1(308));
      og = b2;
      ng.dependencies = { lanes: 0, firstContext: b2, responders: null };
    } else
      og = og.next = b2;
  }
  return a._currentValue;
}
var wg = false;
function xg(a) {
  a.updateQueue = { baseState: a.memoizedState, firstBaseUpdate: null, lastBaseUpdate: null, shared: { pending: null }, effects: null };
}
function yg(a, b2) {
  a = a.updateQueue;
  b2.updateQueue === a && (b2.updateQueue = { baseState: a.baseState, firstBaseUpdate: a.firstBaseUpdate, lastBaseUpdate: a.lastBaseUpdate, shared: a.shared, effects: a.effects });
}
function zg(a, b2) {
  return { eventTime: a, lane: b2, tag: 0, payload: null, callback: null, next: null };
}
function Ag(a, b2) {
  a = a.updateQueue;
  if (a !== null) {
    a = a.shared;
    var c2 = a.pending;
    c2 === null ? b2.next = b2 : (b2.next = c2.next, c2.next = b2);
    a.pending = b2;
  }
}
function Bg(a, b2) {
  var c2 = a.updateQueue, d2 = a.alternate;
  if (d2 !== null && (d2 = d2.updateQueue, c2 === d2)) {
    var e2 = null, f2 = null;
    c2 = c2.firstBaseUpdate;
    if (c2 !== null) {
      do {
        var g2 = { eventTime: c2.eventTime, lane: c2.lane, tag: c2.tag, payload: c2.payload, callback: c2.callback, next: null };
        f2 === null ? e2 = f2 = g2 : f2 = f2.next = g2;
        c2 = c2.next;
      } while (c2 !== null);
      f2 === null ? e2 = f2 = b2 : f2 = f2.next = b2;
    } else
      e2 = f2 = b2;
    c2 = { baseState: d2.baseState, firstBaseUpdate: e2, lastBaseUpdate: f2, shared: d2.shared, effects: d2.effects };
    a.updateQueue = c2;
    return;
  }
  a = c2.lastBaseUpdate;
  a === null ? c2.firstBaseUpdate = b2 : a.next = b2;
  c2.lastBaseUpdate = b2;
}
function Cg(a, b2, c2, d2) {
  var e2 = a.updateQueue;
  wg = false;
  var f2 = e2.firstBaseUpdate, g2 = e2.lastBaseUpdate, h = e2.shared.pending;
  if (h !== null) {
    e2.shared.pending = null;
    var k2 = h, l2 = k2.next;
    k2.next = null;
    g2 === null ? f2 = l2 : g2.next = l2;
    g2 = k2;
    var n2 = a.alternate;
    if (n2 !== null) {
      n2 = n2.updateQueue;
      var A2 = n2.lastBaseUpdate;
      A2 !== g2 && (A2 === null ? n2.firstBaseUpdate = l2 : A2.next = l2, n2.lastBaseUpdate = k2);
    }
  }
  if (f2 !== null) {
    A2 = e2.baseState;
    g2 = 0;
    n2 = l2 = k2 = null;
    do {
      h = f2.lane;
      var p2 = f2.eventTime;
      if ((d2 & h) === h) {
        n2 !== null && (n2 = n2.next = {
          eventTime: p2,
          lane: 0,
          tag: f2.tag,
          payload: f2.payload,
          callback: f2.callback,
          next: null
        });
        a: {
          var C = a, x2 = f2;
          h = b2;
          p2 = c2;
          switch (x2.tag) {
            case 1:
              C = x2.payload;
              if (typeof C === "function") {
                A2 = C.call(p2, A2, h);
                break a;
              }
              A2 = C;
              break a;
            case 3:
              C.flags = C.flags & -4097 | 64;
            case 0:
              C = x2.payload;
              h = typeof C === "function" ? C.call(p2, A2, h) : C;
              if (h === null || h === void 0)
                break a;
              A2 = m$2({}, A2, h);
              break a;
            case 2:
              wg = true;
          }
        }
        f2.callback !== null && (a.flags |= 32, h = e2.effects, h === null ? e2.effects = [f2] : h.push(f2));
      } else
        p2 = { eventTime: p2, lane: h, tag: f2.tag, payload: f2.payload, callback: f2.callback, next: null }, n2 === null ? (l2 = n2 = p2, k2 = A2) : n2 = n2.next = p2, g2 |= h;
      f2 = f2.next;
      if (f2 === null)
        if (h = e2.shared.pending, h === null)
          break;
        else
          f2 = h.next, h.next = null, e2.lastBaseUpdate = h, e2.shared.pending = null;
    } while (1);
    n2 === null && (k2 = A2);
    e2.baseState = k2;
    e2.firstBaseUpdate = l2;
    e2.lastBaseUpdate = n2;
    Dg |= g2;
    a.lanes = g2;
    a.memoizedState = A2;
  }
}
function Eg(a, b2, c2) {
  a = b2.effects;
  b2.effects = null;
  if (a !== null)
    for (b2 = 0; b2 < a.length; b2++) {
      var d2 = a[b2], e2 = d2.callback;
      if (e2 !== null) {
        d2.callback = null;
        d2 = c2;
        if (typeof e2 !== "function")
          throw Error(y$1(191, e2));
        e2.call(d2);
      }
    }
}
var Fg = new aa.Component().refs;
function Gg(a, b2, c2, d2) {
  b2 = a.memoizedState;
  c2 = c2(d2, b2);
  c2 = c2 === null || c2 === void 0 ? b2 : m$2({}, b2, c2);
  a.memoizedState = c2;
  a.lanes === 0 && (a.updateQueue.baseState = c2);
}
var Kg = { isMounted: function(a) {
  return (a = a._reactInternals) ? Zb(a) === a : false;
}, enqueueSetState: function(a, b2, c2) {
  a = a._reactInternals;
  var d2 = Hg(), e2 = Ig(a), f2 = zg(d2, e2);
  f2.payload = b2;
  c2 !== void 0 && c2 !== null && (f2.callback = c2);
  Ag(a, f2);
  Jg(a, e2, d2);
}, enqueueReplaceState: function(a, b2, c2) {
  a = a._reactInternals;
  var d2 = Hg(), e2 = Ig(a), f2 = zg(d2, e2);
  f2.tag = 1;
  f2.payload = b2;
  c2 !== void 0 && c2 !== null && (f2.callback = c2);
  Ag(a, f2);
  Jg(a, e2, d2);
}, enqueueForceUpdate: function(a, b2) {
  a = a._reactInternals;
  var c2 = Hg(), d2 = Ig(a), e2 = zg(c2, d2);
  e2.tag = 2;
  b2 !== void 0 && b2 !== null && (e2.callback = b2);
  Ag(a, e2);
  Jg(a, d2, c2);
} };
function Lg(a, b2, c2, d2, e2, f2, g2) {
  a = a.stateNode;
  return typeof a.shouldComponentUpdate === "function" ? a.shouldComponentUpdate(d2, f2, g2) : b2.prototype && b2.prototype.isPureReactComponent ? !Je(c2, d2) || !Je(e2, f2) : true;
}
function Mg(a, b2, c2) {
  var d2 = false, e2 = Cf;
  var f2 = b2.contextType;
  typeof f2 === "object" && f2 !== null ? f2 = vg(f2) : (e2 = Ff(b2) ? Df : M.current, d2 = b2.contextTypes, f2 = (d2 = d2 !== null && d2 !== void 0) ? Ef(a, e2) : Cf);
  b2 = new b2(c2, f2);
  a.memoizedState = b2.state !== null && b2.state !== void 0 ? b2.state : null;
  b2.updater = Kg;
  a.stateNode = b2;
  b2._reactInternals = a;
  d2 && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = e2, a.__reactInternalMemoizedMaskedChildContext = f2);
  return b2;
}
function Ng(a, b2, c2, d2) {
  a = b2.state;
  typeof b2.componentWillReceiveProps === "function" && b2.componentWillReceiveProps(c2, d2);
  typeof b2.UNSAFE_componentWillReceiveProps === "function" && b2.UNSAFE_componentWillReceiveProps(c2, d2);
  b2.state !== a && Kg.enqueueReplaceState(b2, b2.state, null);
}
function Og(a, b2, c2, d2) {
  var e2 = a.stateNode;
  e2.props = c2;
  e2.state = a.memoizedState;
  e2.refs = Fg;
  xg(a);
  var f2 = b2.contextType;
  typeof f2 === "object" && f2 !== null ? e2.context = vg(f2) : (f2 = Ff(b2) ? Df : M.current, e2.context = Ef(a, f2));
  Cg(a, c2, e2, d2);
  e2.state = a.memoizedState;
  f2 = b2.getDerivedStateFromProps;
  typeof f2 === "function" && (Gg(a, b2, f2, c2), e2.state = a.memoizedState);
  typeof b2.getDerivedStateFromProps === "function" || typeof e2.getSnapshotBeforeUpdate === "function" || typeof e2.UNSAFE_componentWillMount !== "function" && typeof e2.componentWillMount !== "function" || (b2 = e2.state, typeof e2.componentWillMount === "function" && e2.componentWillMount(), typeof e2.UNSAFE_componentWillMount === "function" && e2.UNSAFE_componentWillMount(), b2 !== e2.state && Kg.enqueueReplaceState(e2, e2.state, null), Cg(a, c2, e2, d2), e2.state = a.memoizedState);
  typeof e2.componentDidMount === "function" && (a.flags |= 4);
}
var Pg = Array.isArray;
function Qg(a, b2, c2) {
  a = c2.ref;
  if (a !== null && typeof a !== "function" && typeof a !== "object") {
    if (c2._owner) {
      c2 = c2._owner;
      if (c2) {
        if (c2.tag !== 1)
          throw Error(y$1(309));
        var d2 = c2.stateNode;
      }
      if (!d2)
        throw Error(y$1(147, a));
      var e2 = "" + a;
      if (b2 !== null && b2.ref !== null && typeof b2.ref === "function" && b2.ref._stringRef === e2)
        return b2.ref;
      b2 = function(a2) {
        var b3 = d2.refs;
        b3 === Fg && (b3 = d2.refs = {});
        a2 === null ? delete b3[e2] : b3[e2] = a2;
      };
      b2._stringRef = e2;
      return b2;
    }
    if (typeof a !== "string")
      throw Error(y$1(284));
    if (!c2._owner)
      throw Error(y$1(290, a));
  }
  return a;
}
function Rg(a, b2) {
  if (a.type !== "textarea")
    throw Error(y$1(31, Object.prototype.toString.call(b2) === "[object Object]" ? "object with keys {" + Object.keys(b2).join(", ") + "}" : b2));
}
function Sg(a) {
  function b2(b3, c3) {
    if (a) {
      var d3 = b3.lastEffect;
      d3 !== null ? (d3.nextEffect = c3, b3.lastEffect = c3) : b3.firstEffect = b3.lastEffect = c3;
      c3.nextEffect = null;
      c3.flags = 8;
    }
  }
  function c2(c3, d3) {
    if (!a)
      return null;
    for (; d3 !== null; )
      b2(c3, d3), d3 = d3.sibling;
    return null;
  }
  function d2(a2, b3) {
    for (a2 = /* @__PURE__ */ new Map(); b3 !== null; )
      b3.key !== null ? a2.set(b3.key, b3) : a2.set(b3.index, b3), b3 = b3.sibling;
    return a2;
  }
  function e2(a2, b3) {
    a2 = Tg(a2, b3);
    a2.index = 0;
    a2.sibling = null;
    return a2;
  }
  function f2(b3, c3, d3) {
    b3.index = d3;
    if (!a)
      return c3;
    d3 = b3.alternate;
    if (d3 !== null)
      return d3 = d3.index, d3 < c3 ? (b3.flags = 2, c3) : d3;
    b3.flags = 2;
    return c3;
  }
  function g2(b3) {
    a && b3.alternate === null && (b3.flags = 2);
    return b3;
  }
  function h(a2, b3, c3, d3) {
    if (b3 === null || b3.tag !== 6)
      return b3 = Ug(c3, a2.mode, d3), b3.return = a2, b3;
    b3 = e2(b3, c3);
    b3.return = a2;
    return b3;
  }
  function k2(a2, b3, c3, d3) {
    if (b3 !== null && b3.elementType === c3.type)
      return d3 = e2(b3, c3.props), d3.ref = Qg(a2, b3, c3), d3.return = a2, d3;
    d3 = Vg(c3.type, c3.key, c3.props, null, a2.mode, d3);
    d3.ref = Qg(a2, b3, c3);
    d3.return = a2;
    return d3;
  }
  function l2(a2, b3, c3, d3) {
    if (b3 === null || b3.tag !== 4 || b3.stateNode.containerInfo !== c3.containerInfo || b3.stateNode.implementation !== c3.implementation)
      return b3 = Wg(c3, a2.mode, d3), b3.return = a2, b3;
    b3 = e2(b3, c3.children || []);
    b3.return = a2;
    return b3;
  }
  function n2(a2, b3, c3, d3, f3) {
    if (b3 === null || b3.tag !== 7)
      return b3 = Xg(c3, a2.mode, d3, f3), b3.return = a2, b3;
    b3 = e2(b3, c3);
    b3.return = a2;
    return b3;
  }
  function A2(a2, b3, c3) {
    if (typeof b3 === "string" || typeof b3 === "number")
      return b3 = Ug("" + b3, a2.mode, c3), b3.return = a2, b3;
    if (typeof b3 === "object" && b3 !== null) {
      switch (b3.$$typeof) {
        case sa:
          return c3 = Vg(b3.type, b3.key, b3.props, null, a2.mode, c3), c3.ref = Qg(a2, null, b3), c3.return = a2, c3;
        case ta:
          return b3 = Wg(b3, a2.mode, c3), b3.return = a2, b3;
      }
      if (Pg(b3) || La(b3))
        return b3 = Xg(b3, a2.mode, c3, null), b3.return = a2, b3;
      Rg(a2, b3);
    }
    return null;
  }
  function p2(a2, b3, c3, d3) {
    var e3 = b3 !== null ? b3.key : null;
    if (typeof c3 === "string" || typeof c3 === "number")
      return e3 !== null ? null : h(a2, b3, "" + c3, d3);
    if (typeof c3 === "object" && c3 !== null) {
      switch (c3.$$typeof) {
        case sa:
          return c3.key === e3 ? c3.type === ua ? n2(a2, b3, c3.props.children, d3, e3) : k2(a2, b3, c3, d3) : null;
        case ta:
          return c3.key === e3 ? l2(a2, b3, c3, d3) : null;
      }
      if (Pg(c3) || La(c3))
        return e3 !== null ? null : n2(a2, b3, c3, d3, null);
      Rg(a2, c3);
    }
    return null;
  }
  function C(a2, b3, c3, d3, e3) {
    if (typeof d3 === "string" || typeof d3 === "number")
      return a2 = a2.get(c3) || null, h(b3, a2, "" + d3, e3);
    if (typeof d3 === "object" && d3 !== null) {
      switch (d3.$$typeof) {
        case sa:
          return a2 = a2.get(d3.key === null ? c3 : d3.key) || null, d3.type === ua ? n2(b3, a2, d3.props.children, e3, d3.key) : k2(b3, a2, d3, e3);
        case ta:
          return a2 = a2.get(d3.key === null ? c3 : d3.key) || null, l2(b3, a2, d3, e3);
      }
      if (Pg(d3) || La(d3))
        return a2 = a2.get(c3) || null, n2(b3, a2, d3, e3, null);
      Rg(b3, d3);
    }
    return null;
  }
  function x2(e3, g3, h2, k3) {
    for (var l3 = null, t2 = null, u = g3, z2 = g3 = 0, q2 = null; u !== null && z2 < h2.length; z2++) {
      u.index > z2 ? (q2 = u, u = null) : q2 = u.sibling;
      var n3 = p2(e3, u, h2[z2], k3);
      if (n3 === null) {
        u === null && (u = q2);
        break;
      }
      a && u && n3.alternate === null && b2(e3, u);
      g3 = f2(n3, g3, z2);
      t2 === null ? l3 = n3 : t2.sibling = n3;
      t2 = n3;
      u = q2;
    }
    if (z2 === h2.length)
      return c2(e3, u), l3;
    if (u === null) {
      for (; z2 < h2.length; z2++)
        u = A2(e3, h2[z2], k3), u !== null && (g3 = f2(u, g3, z2), t2 === null ? l3 = u : t2.sibling = u, t2 = u);
      return l3;
    }
    for (u = d2(e3, u); z2 < h2.length; z2++)
      q2 = C(u, e3, z2, h2[z2], k3), q2 !== null && (a && q2.alternate !== null && u.delete(q2.key === null ? z2 : q2.key), g3 = f2(q2, g3, z2), t2 === null ? l3 = q2 : t2.sibling = q2, t2 = q2);
    a && u.forEach(function(a2) {
      return b2(e3, a2);
    });
    return l3;
  }
  function w2(e3, g3, h2, k3) {
    var l3 = La(h2);
    if (typeof l3 !== "function")
      throw Error(y$1(150));
    h2 = l3.call(h2);
    if (h2 == null)
      throw Error(y$1(151));
    for (var t2 = l3 = null, u = g3, z2 = g3 = 0, q2 = null, n3 = h2.next(); u !== null && !n3.done; z2++, n3 = h2.next()) {
      u.index > z2 ? (q2 = u, u = null) : q2 = u.sibling;
      var w3 = p2(e3, u, n3.value, k3);
      if (w3 === null) {
        u === null && (u = q2);
        break;
      }
      a && u && w3.alternate === null && b2(e3, u);
      g3 = f2(w3, g3, z2);
      t2 === null ? l3 = w3 : t2.sibling = w3;
      t2 = w3;
      u = q2;
    }
    if (n3.done)
      return c2(e3, u), l3;
    if (u === null) {
      for (; !n3.done; z2++, n3 = h2.next())
        n3 = A2(e3, n3.value, k3), n3 !== null && (g3 = f2(n3, g3, z2), t2 === null ? l3 = n3 : t2.sibling = n3, t2 = n3);
      return l3;
    }
    for (u = d2(e3, u); !n3.done; z2++, n3 = h2.next())
      n3 = C(u, e3, z2, n3.value, k3), n3 !== null && (a && n3.alternate !== null && u.delete(n3.key === null ? z2 : n3.key), g3 = f2(n3, g3, z2), t2 === null ? l3 = n3 : t2.sibling = n3, t2 = n3);
    a && u.forEach(function(a2) {
      return b2(e3, a2);
    });
    return l3;
  }
  return function(a2, d3, f3, h2) {
    var k3 = typeof f3 === "object" && f3 !== null && f3.type === ua && f3.key === null;
    k3 && (f3 = f3.props.children);
    var l3 = typeof f3 === "object" && f3 !== null;
    if (l3)
      switch (f3.$$typeof) {
        case sa:
          a: {
            l3 = f3.key;
            for (k3 = d3; k3 !== null; ) {
              if (k3.key === l3) {
                switch (k3.tag) {
                  case 7:
                    if (f3.type === ua) {
                      c2(a2, k3.sibling);
                      d3 = e2(k3, f3.props.children);
                      d3.return = a2;
                      a2 = d3;
                      break a;
                    }
                    break;
                  default:
                    if (k3.elementType === f3.type) {
                      c2(a2, k3.sibling);
                      d3 = e2(k3, f3.props);
                      d3.ref = Qg(a2, k3, f3);
                      d3.return = a2;
                      a2 = d3;
                      break a;
                    }
                }
                c2(a2, k3);
                break;
              } else
                b2(a2, k3);
              k3 = k3.sibling;
            }
            f3.type === ua ? (d3 = Xg(f3.props.children, a2.mode, h2, f3.key), d3.return = a2, a2 = d3) : (h2 = Vg(f3.type, f3.key, f3.props, null, a2.mode, h2), h2.ref = Qg(a2, d3, f3), h2.return = a2, a2 = h2);
          }
          return g2(a2);
        case ta:
          a: {
            for (k3 = f3.key; d3 !== null; ) {
              if (d3.key === k3)
                if (d3.tag === 4 && d3.stateNode.containerInfo === f3.containerInfo && d3.stateNode.implementation === f3.implementation) {
                  c2(a2, d3.sibling);
                  d3 = e2(d3, f3.children || []);
                  d3.return = a2;
                  a2 = d3;
                  break a;
                } else {
                  c2(a2, d3);
                  break;
                }
              else
                b2(a2, d3);
              d3 = d3.sibling;
            }
            d3 = Wg(f3, a2.mode, h2);
            d3.return = a2;
            a2 = d3;
          }
          return g2(a2);
      }
    if (typeof f3 === "string" || typeof f3 === "number")
      return f3 = "" + f3, d3 !== null && d3.tag === 6 ? (c2(a2, d3.sibling), d3 = e2(d3, f3), d3.return = a2, a2 = d3) : (c2(a2, d3), d3 = Ug(f3, a2.mode, h2), d3.return = a2, a2 = d3), g2(a2);
    if (Pg(f3))
      return x2(a2, d3, f3, h2);
    if (La(f3))
      return w2(a2, d3, f3, h2);
    l3 && Rg(a2, f3);
    if (typeof f3 === "undefined" && !k3)
      switch (a2.tag) {
        case 1:
        case 22:
        case 0:
        case 11:
        case 15:
          throw Error(y$1(152, Ra(a2.type) || "Component"));
      }
    return c2(a2, d3);
  };
}
var Yg = Sg(true), Zg = Sg(false), $g = {}, ah = Bf($g), bh = Bf($g), ch = Bf($g);
function dh(a) {
  if (a === $g)
    throw Error(y$1(174));
  return a;
}
function eh(a, b2) {
  I(ch, b2);
  I(bh, a);
  I(ah, $g);
  a = b2.nodeType;
  switch (a) {
    case 9:
    case 11:
      b2 = (b2 = b2.documentElement) ? b2.namespaceURI : mb(null, "");
      break;
    default:
      a = a === 8 ? b2.parentNode : b2, b2 = a.namespaceURI || null, a = a.tagName, b2 = mb(b2, a);
  }
  H(ah);
  I(ah, b2);
}
function fh() {
  H(ah);
  H(bh);
  H(ch);
}
function gh(a) {
  dh(ch.current);
  var b2 = dh(ah.current);
  var c2 = mb(b2, a.type);
  b2 !== c2 && (I(bh, a), I(ah, c2));
}
function hh(a) {
  bh.current === a && (H(ah), H(bh));
}
var P = Bf(0);
function ih(a) {
  for (var b2 = a; b2 !== null; ) {
    if (b2.tag === 13) {
      var c2 = b2.memoizedState;
      if (c2 !== null && (c2 = c2.dehydrated, c2 === null || c2.data === "$?" || c2.data === "$!"))
        return b2;
    } else if (b2.tag === 19 && b2.memoizedProps.revealOrder !== void 0) {
      if ((b2.flags & 64) !== 0)
        return b2;
    } else if (b2.child !== null) {
      b2.child.return = b2;
      b2 = b2.child;
      continue;
    }
    if (b2 === a)
      break;
    for (; b2.sibling === null; ) {
      if (b2.return === null || b2.return === a)
        return null;
      b2 = b2.return;
    }
    b2.sibling.return = b2.return;
    b2 = b2.sibling;
  }
  return null;
}
var jh = null, kh = null, lh = false;
function mh(a, b2) {
  var c2 = nh(5, null, null, 0);
  c2.elementType = "DELETED";
  c2.type = "DELETED";
  c2.stateNode = b2;
  c2.return = a;
  c2.flags = 8;
  a.lastEffect !== null ? (a.lastEffect.nextEffect = c2, a.lastEffect = c2) : a.firstEffect = a.lastEffect = c2;
}
function oh(a, b2) {
  switch (a.tag) {
    case 5:
      var c2 = a.type;
      b2 = b2.nodeType !== 1 || c2.toLowerCase() !== b2.nodeName.toLowerCase() ? null : b2;
      return b2 !== null ? (a.stateNode = b2, true) : false;
    case 6:
      return b2 = a.pendingProps === "" || b2.nodeType !== 3 ? null : b2, b2 !== null ? (a.stateNode = b2, true) : false;
    case 13:
      return false;
    default:
      return false;
  }
}
function ph(a) {
  if (lh) {
    var b2 = kh;
    if (b2) {
      var c2 = b2;
      if (!oh(a, b2)) {
        b2 = rf(c2.nextSibling);
        if (!b2 || !oh(a, b2)) {
          a.flags = a.flags & -1025 | 2;
          lh = false;
          jh = a;
          return;
        }
        mh(jh, c2);
      }
      jh = a;
      kh = rf(b2.firstChild);
    } else
      a.flags = a.flags & -1025 | 2, lh = false, jh = a;
  }
}
function qh(a) {
  for (a = a.return; a !== null && a.tag !== 5 && a.tag !== 3 && a.tag !== 13; )
    a = a.return;
  jh = a;
}
function rh(a) {
  if (a !== jh)
    return false;
  if (!lh)
    return qh(a), lh = true, false;
  var b2 = a.type;
  if (a.tag !== 5 || b2 !== "head" && b2 !== "body" && !nf(b2, a.memoizedProps))
    for (b2 = kh; b2; )
      mh(a, b2), b2 = rf(b2.nextSibling);
  qh(a);
  if (a.tag === 13) {
    a = a.memoizedState;
    a = a !== null ? a.dehydrated : null;
    if (!a)
      throw Error(y$1(317));
    a: {
      a = a.nextSibling;
      for (b2 = 0; a; ) {
        if (a.nodeType === 8) {
          var c2 = a.data;
          if (c2 === "/$") {
            if (b2 === 0) {
              kh = rf(a.nextSibling);
              break a;
            }
            b2--;
          } else
            c2 !== "$" && c2 !== "$!" && c2 !== "$?" || b2++;
        }
        a = a.nextSibling;
      }
      kh = null;
    }
  } else
    kh = jh ? rf(a.stateNode.nextSibling) : null;
  return true;
}
function sh() {
  kh = jh = null;
  lh = false;
}
var th = [];
function uh() {
  for (var a = 0; a < th.length; a++)
    th[a]._workInProgressVersionPrimary = null;
  th.length = 0;
}
var vh = ra.ReactCurrentDispatcher, wh = ra.ReactCurrentBatchConfig, xh = 0, R = null, S = null, T = null, yh = false, zh = false;
function Ah() {
  throw Error(y$1(321));
}
function Bh(a, b2) {
  if (b2 === null)
    return false;
  for (var c2 = 0; c2 < b2.length && c2 < a.length; c2++)
    if (!He(a[c2], b2[c2]))
      return false;
  return true;
}
function Ch(a, b2, c2, d2, e2, f2) {
  xh = f2;
  R = b2;
  b2.memoizedState = null;
  b2.updateQueue = null;
  b2.lanes = 0;
  vh.current = a === null || a.memoizedState === null ? Dh : Eh;
  a = c2(d2, e2);
  if (zh) {
    f2 = 0;
    do {
      zh = false;
      if (!(25 > f2))
        throw Error(y$1(301));
      f2 += 1;
      T = S = null;
      b2.updateQueue = null;
      vh.current = Fh;
      a = c2(d2, e2);
    } while (zh);
  }
  vh.current = Gh;
  b2 = S !== null && S.next !== null;
  xh = 0;
  T = S = R = null;
  yh = false;
  if (b2)
    throw Error(y$1(300));
  return a;
}
function Hh() {
  var a = { memoizedState: null, baseState: null, baseQueue: null, queue: null, next: null };
  T === null ? R.memoizedState = T = a : T = T.next = a;
  return T;
}
function Ih() {
  if (S === null) {
    var a = R.alternate;
    a = a !== null ? a.memoizedState : null;
  } else
    a = S.next;
  var b2 = T === null ? R.memoizedState : T.next;
  if (b2 !== null)
    T = b2, S = a;
  else {
    if (a === null)
      throw Error(y$1(310));
    S = a;
    a = { memoizedState: S.memoizedState, baseState: S.baseState, baseQueue: S.baseQueue, queue: S.queue, next: null };
    T === null ? R.memoizedState = T = a : T = T.next = a;
  }
  return T;
}
function Jh(a, b2) {
  return typeof b2 === "function" ? b2(a) : b2;
}
function Kh(a) {
  var b2 = Ih(), c2 = b2.queue;
  if (c2 === null)
    throw Error(y$1(311));
  c2.lastRenderedReducer = a;
  var d2 = S, e2 = d2.baseQueue, f2 = c2.pending;
  if (f2 !== null) {
    if (e2 !== null) {
      var g2 = e2.next;
      e2.next = f2.next;
      f2.next = g2;
    }
    d2.baseQueue = e2 = f2;
    c2.pending = null;
  }
  if (e2 !== null) {
    e2 = e2.next;
    d2 = d2.baseState;
    var h = g2 = f2 = null, k2 = e2;
    do {
      var l2 = k2.lane;
      if ((xh & l2) === l2)
        h !== null && (h = h.next = { lane: 0, action: k2.action, eagerReducer: k2.eagerReducer, eagerState: k2.eagerState, next: null }), d2 = k2.eagerReducer === a ? k2.eagerState : a(d2, k2.action);
      else {
        var n2 = {
          lane: l2,
          action: k2.action,
          eagerReducer: k2.eagerReducer,
          eagerState: k2.eagerState,
          next: null
        };
        h === null ? (g2 = h = n2, f2 = d2) : h = h.next = n2;
        R.lanes |= l2;
        Dg |= l2;
      }
      k2 = k2.next;
    } while (k2 !== null && k2 !== e2);
    h === null ? f2 = d2 : h.next = g2;
    He(d2, b2.memoizedState) || (ug = true);
    b2.memoizedState = d2;
    b2.baseState = f2;
    b2.baseQueue = h;
    c2.lastRenderedState = d2;
  }
  return [b2.memoizedState, c2.dispatch];
}
function Lh(a) {
  var b2 = Ih(), c2 = b2.queue;
  if (c2 === null)
    throw Error(y$1(311));
  c2.lastRenderedReducer = a;
  var d2 = c2.dispatch, e2 = c2.pending, f2 = b2.memoizedState;
  if (e2 !== null) {
    c2.pending = null;
    var g2 = e2 = e2.next;
    do
      f2 = a(f2, g2.action), g2 = g2.next;
    while (g2 !== e2);
    He(f2, b2.memoizedState) || (ug = true);
    b2.memoizedState = f2;
    b2.baseQueue === null && (b2.baseState = f2);
    c2.lastRenderedState = f2;
  }
  return [f2, d2];
}
function Mh(a, b2, c2) {
  var d2 = b2._getVersion;
  d2 = d2(b2._source);
  var e2 = b2._workInProgressVersionPrimary;
  if (e2 !== null)
    a = e2 === d2;
  else if (a = a.mutableReadLanes, a = (xh & a) === a)
    b2._workInProgressVersionPrimary = d2, th.push(b2);
  if (a)
    return c2(b2._source);
  th.push(b2);
  throw Error(y$1(350));
}
function Nh(a, b2, c2, d2) {
  var e2 = U;
  if (e2 === null)
    throw Error(y$1(349));
  var f2 = b2._getVersion, g2 = f2(b2._source), h = vh.current, k2 = h.useState(function() {
    return Mh(e2, b2, c2);
  }), l2 = k2[1], n2 = k2[0];
  k2 = T;
  var A2 = a.memoizedState, p2 = A2.refs, C = p2.getSnapshot, x2 = A2.source;
  A2 = A2.subscribe;
  var w2 = R;
  a.memoizedState = { refs: p2, source: b2, subscribe: d2 };
  h.useEffect(function() {
    p2.getSnapshot = c2;
    p2.setSnapshot = l2;
    var a2 = f2(b2._source);
    if (!He(g2, a2)) {
      a2 = c2(b2._source);
      He(n2, a2) || (l2(a2), a2 = Ig(w2), e2.mutableReadLanes |= a2 & e2.pendingLanes);
      a2 = e2.mutableReadLanes;
      e2.entangledLanes |= a2;
      for (var d3 = e2.entanglements, h2 = a2; 0 < h2; ) {
        var k3 = 31 - Vc(h2), v4 = 1 << k3;
        d3[k3] |= a2;
        h2 &= ~v4;
      }
    }
  }, [c2, b2, d2]);
  h.useEffect(function() {
    return d2(b2._source, function() {
      var a2 = p2.getSnapshot, c3 = p2.setSnapshot;
      try {
        c3(a2(b2._source));
        var d3 = Ig(w2);
        e2.mutableReadLanes |= d3 & e2.pendingLanes;
      } catch (q2) {
        c3(function() {
          throw q2;
        });
      }
    });
  }, [b2, d2]);
  He(C, c2) && He(x2, b2) && He(A2, d2) || (a = { pending: null, dispatch: null, lastRenderedReducer: Jh, lastRenderedState: n2 }, a.dispatch = l2 = Oh.bind(null, R, a), k2.queue = a, k2.baseQueue = null, n2 = Mh(e2, b2, c2), k2.memoizedState = k2.baseState = n2);
  return n2;
}
function Ph(a, b2, c2) {
  var d2 = Ih();
  return Nh(d2, a, b2, c2);
}
function Qh(a) {
  var b2 = Hh();
  typeof a === "function" && (a = a());
  b2.memoizedState = b2.baseState = a;
  a = b2.queue = { pending: null, dispatch: null, lastRenderedReducer: Jh, lastRenderedState: a };
  a = a.dispatch = Oh.bind(null, R, a);
  return [b2.memoizedState, a];
}
function Rh(a, b2, c2, d2) {
  a = { tag: a, create: b2, destroy: c2, deps: d2, next: null };
  b2 = R.updateQueue;
  b2 === null ? (b2 = { lastEffect: null }, R.updateQueue = b2, b2.lastEffect = a.next = a) : (c2 = b2.lastEffect, c2 === null ? b2.lastEffect = a.next = a : (d2 = c2.next, c2.next = a, a.next = d2, b2.lastEffect = a));
  return a;
}
function Sh(a) {
  var b2 = Hh();
  a = { current: a };
  return b2.memoizedState = a;
}
function Th() {
  return Ih().memoizedState;
}
function Uh(a, b2, c2, d2) {
  var e2 = Hh();
  R.flags |= a;
  e2.memoizedState = Rh(1 | b2, c2, void 0, d2 === void 0 ? null : d2);
}
function Vh(a, b2, c2, d2) {
  var e2 = Ih();
  d2 = d2 === void 0 ? null : d2;
  var f2 = void 0;
  if (S !== null) {
    var g2 = S.memoizedState;
    f2 = g2.destroy;
    if (d2 !== null && Bh(d2, g2.deps)) {
      Rh(b2, c2, f2, d2);
      return;
    }
  }
  R.flags |= a;
  e2.memoizedState = Rh(1 | b2, c2, f2, d2);
}
function Wh(a, b2) {
  return Uh(516, 4, a, b2);
}
function Xh(a, b2) {
  return Vh(516, 4, a, b2);
}
function Yh(a, b2) {
  return Vh(4, 2, a, b2);
}
function Zh(a, b2) {
  if (typeof b2 === "function")
    return a = a(), b2(a), function() {
      b2(null);
    };
  if (b2 !== null && b2 !== void 0)
    return a = a(), b2.current = a, function() {
      b2.current = null;
    };
}
function $h(a, b2, c2) {
  c2 = c2 !== null && c2 !== void 0 ? c2.concat([a]) : null;
  return Vh(4, 2, Zh.bind(null, b2, a), c2);
}
function ai() {
}
function bi(a, b2) {
  var c2 = Ih();
  b2 = b2 === void 0 ? null : b2;
  var d2 = c2.memoizedState;
  if (d2 !== null && b2 !== null && Bh(b2, d2[1]))
    return d2[0];
  c2.memoizedState = [a, b2];
  return a;
}
function ci(a, b2) {
  var c2 = Ih();
  b2 = b2 === void 0 ? null : b2;
  var d2 = c2.memoizedState;
  if (d2 !== null && b2 !== null && Bh(b2, d2[1]))
    return d2[0];
  a = a();
  c2.memoizedState = [a, b2];
  return a;
}
function di(a, b2) {
  var c2 = eg();
  gg(98 > c2 ? 98 : c2, function() {
    a(true);
  });
  gg(97 < c2 ? 97 : c2, function() {
    var c3 = wh.transition;
    wh.transition = 1;
    try {
      a(false), b2();
    } finally {
      wh.transition = c3;
    }
  });
}
function Oh(a, b2, c2) {
  var d2 = Hg(), e2 = Ig(a), f2 = { lane: e2, action: c2, eagerReducer: null, eagerState: null, next: null }, g2 = b2.pending;
  g2 === null ? f2.next = f2 : (f2.next = g2.next, g2.next = f2);
  b2.pending = f2;
  g2 = a.alternate;
  if (a === R || g2 !== null && g2 === R)
    zh = yh = true;
  else {
    if (a.lanes === 0 && (g2 === null || g2.lanes === 0) && (g2 = b2.lastRenderedReducer, g2 !== null))
      try {
        var h = b2.lastRenderedState, k2 = g2(h, c2);
        f2.eagerReducer = g2;
        f2.eagerState = k2;
        if (He(k2, h))
          return;
      } catch (l2) {
      } finally {
      }
    Jg(a, e2, d2);
  }
}
var Gh = { readContext: vg, useCallback: Ah, useContext: Ah, useEffect: Ah, useImperativeHandle: Ah, useLayoutEffect: Ah, useMemo: Ah, useReducer: Ah, useRef: Ah, useState: Ah, useDebugValue: Ah, useDeferredValue: Ah, useTransition: Ah, useMutableSource: Ah, useOpaqueIdentifier: Ah, unstable_isNewReconciler: false }, Dh = { readContext: vg, useCallback: function(a, b2) {
  Hh().memoizedState = [a, b2 === void 0 ? null : b2];
  return a;
}, useContext: vg, useEffect: Wh, useImperativeHandle: function(a, b2, c2) {
  c2 = c2 !== null && c2 !== void 0 ? c2.concat([a]) : null;
  return Uh(4, 2, Zh.bind(null, b2, a), c2);
}, useLayoutEffect: function(a, b2) {
  return Uh(4, 2, a, b2);
}, useMemo: function(a, b2) {
  var c2 = Hh();
  b2 = b2 === void 0 ? null : b2;
  a = a();
  c2.memoizedState = [a, b2];
  return a;
}, useReducer: function(a, b2, c2) {
  var d2 = Hh();
  b2 = c2 !== void 0 ? c2(b2) : b2;
  d2.memoizedState = d2.baseState = b2;
  a = d2.queue = { pending: null, dispatch: null, lastRenderedReducer: a, lastRenderedState: b2 };
  a = a.dispatch = Oh.bind(null, R, a);
  return [d2.memoizedState, a];
}, useRef: Sh, useState: Qh, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Qh(a), c2 = b2[0], d2 = b2[1];
  Wh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Qh(false), b2 = a[0];
  a = di.bind(null, a[1]);
  Sh(a);
  return [a, b2];
}, useMutableSource: function(a, b2, c2) {
  var d2 = Hh();
  d2.memoizedState = { refs: { getSnapshot: b2, setSnapshot: null }, source: a, subscribe: c2 };
  return Nh(d2, a, b2, c2);
}, useOpaqueIdentifier: function() {
  if (lh) {
    var a = false, b2 = uf(function() {
      a || (a = true, c2("r:" + (tf++).toString(36)));
      throw Error(y$1(355));
    }), c2 = Qh(b2)[1];
    (R.mode & 2) === 0 && (R.flags |= 516, Rh(5, function() {
      c2("r:" + (tf++).toString(36));
    }, void 0, null));
    return b2;
  }
  b2 = "r:" + (tf++).toString(36);
  Qh(b2);
  return b2;
}, unstable_isNewReconciler: false }, Eh = { readContext: vg, useCallback: bi, useContext: vg, useEffect: Xh, useImperativeHandle: $h, useLayoutEffect: Yh, useMemo: ci, useReducer: Kh, useRef: Th, useState: function() {
  return Kh(Jh);
}, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Kh(Jh), c2 = b2[0], d2 = b2[1];
  Xh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Kh(Jh)[0];
  return [
    Th().current,
    a
  ];
}, useMutableSource: Ph, useOpaqueIdentifier: function() {
  return Kh(Jh)[0];
}, unstable_isNewReconciler: false }, Fh = { readContext: vg, useCallback: bi, useContext: vg, useEffect: Xh, useImperativeHandle: $h, useLayoutEffect: Yh, useMemo: ci, useReducer: Lh, useRef: Th, useState: function() {
  return Lh(Jh);
}, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Lh(Jh), c2 = b2[0], d2 = b2[1];
  Xh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Lh(Jh)[0];
  return [
    Th().current,
    a
  ];
}, useMutableSource: Ph, useOpaqueIdentifier: function() {
  return Lh(Jh)[0];
}, unstable_isNewReconciler: false }, ei = ra.ReactCurrentOwner, ug = false;
function fi(a, b2, c2, d2) {
  b2.child = a === null ? Zg(b2, null, c2, d2) : Yg(b2, a.child, c2, d2);
}
function gi(a, b2, c2, d2, e2) {
  c2 = c2.render;
  var f2 = b2.ref;
  tg(b2, e2);
  d2 = Ch(a, b2, c2, d2, f2, e2);
  if (a !== null && !ug)
    return b2.updateQueue = a.updateQueue, b2.flags &= -517, a.lanes &= ~e2, hi(a, b2, e2);
  b2.flags |= 1;
  fi(a, b2, d2, e2);
  return b2.child;
}
function ii(a, b2, c2, d2, e2, f2) {
  if (a === null) {
    var g2 = c2.type;
    if (typeof g2 === "function" && !ji(g2) && g2.defaultProps === void 0 && c2.compare === null && c2.defaultProps === void 0)
      return b2.tag = 15, b2.type = g2, ki(a, b2, g2, d2, e2, f2);
    a = Vg(c2.type, null, d2, b2, b2.mode, f2);
    a.ref = b2.ref;
    a.return = b2;
    return b2.child = a;
  }
  g2 = a.child;
  if ((e2 & f2) === 0 && (e2 = g2.memoizedProps, c2 = c2.compare, c2 = c2 !== null ? c2 : Je, c2(e2, d2) && a.ref === b2.ref))
    return hi(a, b2, f2);
  b2.flags |= 1;
  a = Tg(g2, d2);
  a.ref = b2.ref;
  a.return = b2;
  return b2.child = a;
}
function ki(a, b2, c2, d2, e2, f2) {
  if (a !== null && Je(a.memoizedProps, d2) && a.ref === b2.ref)
    if (ug = false, (f2 & e2) !== 0)
      (a.flags & 16384) !== 0 && (ug = true);
    else
      return b2.lanes = a.lanes, hi(a, b2, f2);
  return li(a, b2, c2, d2, f2);
}
function mi(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = d2.children, f2 = a !== null ? a.memoizedState : null;
  if (d2.mode === "hidden" || d2.mode === "unstable-defer-without-hiding")
    if ((b2.mode & 4) === 0)
      b2.memoizedState = { baseLanes: 0 }, ni(b2, c2);
    else if ((c2 & 1073741824) !== 0)
      b2.memoizedState = { baseLanes: 0 }, ni(b2, f2 !== null ? f2.baseLanes : c2);
    else
      return a = f2 !== null ? f2.baseLanes | c2 : c2, b2.lanes = b2.childLanes = 1073741824, b2.memoizedState = { baseLanes: a }, ni(b2, a), null;
  else
    f2 !== null ? (d2 = f2.baseLanes | c2, b2.memoizedState = null) : d2 = c2, ni(b2, d2);
  fi(a, b2, e2, c2);
  return b2.child;
}
function oi(a, b2) {
  var c2 = b2.ref;
  if (a === null && c2 !== null || a !== null && a.ref !== c2)
    b2.flags |= 128;
}
function li(a, b2, c2, d2, e2) {
  var f2 = Ff(c2) ? Df : M.current;
  f2 = Ef(b2, f2);
  tg(b2, e2);
  c2 = Ch(a, b2, c2, d2, f2, e2);
  if (a !== null && !ug)
    return b2.updateQueue = a.updateQueue, b2.flags &= -517, a.lanes &= ~e2, hi(a, b2, e2);
  b2.flags |= 1;
  fi(a, b2, c2, e2);
  return b2.child;
}
function pi(a, b2, c2, d2, e2) {
  if (Ff(c2)) {
    var f2 = true;
    Jf(b2);
  } else
    f2 = false;
  tg(b2, e2);
  if (b2.stateNode === null)
    a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2), Mg(b2, c2, d2), Og(b2, c2, d2, e2), d2 = true;
  else if (a === null) {
    var g2 = b2.stateNode, h = b2.memoizedProps;
    g2.props = h;
    var k2 = g2.context, l2 = c2.contextType;
    typeof l2 === "object" && l2 !== null ? l2 = vg(l2) : (l2 = Ff(c2) ? Df : M.current, l2 = Ef(b2, l2));
    var n2 = c2.getDerivedStateFromProps, A2 = typeof n2 === "function" || typeof g2.getSnapshotBeforeUpdate === "function";
    A2 || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (h !== d2 || k2 !== l2) && Ng(b2, g2, d2, l2);
    wg = false;
    var p2 = b2.memoizedState;
    g2.state = p2;
    Cg(b2, d2, g2, e2);
    k2 = b2.memoizedState;
    h !== d2 || p2 !== k2 || N.current || wg ? (typeof n2 === "function" && (Gg(b2, c2, n2, d2), k2 = b2.memoizedState), (h = wg || Lg(b2, c2, h, d2, p2, k2, l2)) ? (A2 || typeof g2.UNSAFE_componentWillMount !== "function" && typeof g2.componentWillMount !== "function" || (typeof g2.componentWillMount === "function" && g2.componentWillMount(), typeof g2.UNSAFE_componentWillMount === "function" && g2.UNSAFE_componentWillMount()), typeof g2.componentDidMount === "function" && (b2.flags |= 4)) : (typeof g2.componentDidMount === "function" && (b2.flags |= 4), b2.memoizedProps = d2, b2.memoizedState = k2), g2.props = d2, g2.state = k2, g2.context = l2, d2 = h) : (typeof g2.componentDidMount === "function" && (b2.flags |= 4), d2 = false);
  } else {
    g2 = b2.stateNode;
    yg(a, b2);
    h = b2.memoizedProps;
    l2 = b2.type === b2.elementType ? h : lg(b2.type, h);
    g2.props = l2;
    A2 = b2.pendingProps;
    p2 = g2.context;
    k2 = c2.contextType;
    typeof k2 === "object" && k2 !== null ? k2 = vg(k2) : (k2 = Ff(c2) ? Df : M.current, k2 = Ef(b2, k2));
    var C = c2.getDerivedStateFromProps;
    (n2 = typeof C === "function" || typeof g2.getSnapshotBeforeUpdate === "function") || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (h !== A2 || p2 !== k2) && Ng(b2, g2, d2, k2);
    wg = false;
    p2 = b2.memoizedState;
    g2.state = p2;
    Cg(b2, d2, g2, e2);
    var x2 = b2.memoizedState;
    h !== A2 || p2 !== x2 || N.current || wg ? (typeof C === "function" && (Gg(b2, c2, C, d2), x2 = b2.memoizedState), (l2 = wg || Lg(b2, c2, l2, d2, p2, x2, k2)) ? (n2 || typeof g2.UNSAFE_componentWillUpdate !== "function" && typeof g2.componentWillUpdate !== "function" || (typeof g2.componentWillUpdate === "function" && g2.componentWillUpdate(d2, x2, k2), typeof g2.UNSAFE_componentWillUpdate === "function" && g2.UNSAFE_componentWillUpdate(d2, x2, k2)), typeof g2.componentDidUpdate === "function" && (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate === "function" && (b2.flags |= 256)) : (typeof g2.componentDidUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 256), b2.memoizedProps = d2, b2.memoizedState = x2), g2.props = d2, g2.state = x2, g2.context = k2, d2 = l2) : (typeof g2.componentDidUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 256), d2 = false);
  }
  return qi(a, b2, c2, d2, f2, e2);
}
function qi(a, b2, c2, d2, e2, f2) {
  oi(a, b2);
  var g2 = (b2.flags & 64) !== 0;
  if (!d2 && !g2)
    return e2 && Kf(b2, c2, false), hi(a, b2, f2);
  d2 = b2.stateNode;
  ei.current = b2;
  var h = g2 && typeof c2.getDerivedStateFromError !== "function" ? null : d2.render();
  b2.flags |= 1;
  a !== null && g2 ? (b2.child = Yg(b2, a.child, null, f2), b2.child = Yg(b2, null, h, f2)) : fi(a, b2, h, f2);
  b2.memoizedState = d2.state;
  e2 && Kf(b2, c2, true);
  return b2.child;
}
function ri(a) {
  var b2 = a.stateNode;
  b2.pendingContext ? Hf(a, b2.pendingContext, b2.pendingContext !== b2.context) : b2.context && Hf(a, b2.context, false);
  eh(a, b2.containerInfo);
}
var si = { dehydrated: null, retryLane: 0 };
function ti(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = P.current, f2 = false, g2;
  (g2 = (b2.flags & 64) !== 0) || (g2 = a !== null && a.memoizedState === null ? false : (e2 & 2) !== 0);
  g2 ? (f2 = true, b2.flags &= -65) : a !== null && a.memoizedState === null || d2.fallback === void 0 || d2.unstable_avoidThisFallback === true || (e2 |= 1);
  I(P, e2 & 1);
  if (a === null) {
    d2.fallback !== void 0 && ph(b2);
    a = d2.children;
    e2 = d2.fallback;
    if (f2)
      return a = ui(b2, a, e2, c2), b2.child.memoizedState = { baseLanes: c2 }, b2.memoizedState = si, a;
    if (typeof d2.unstable_expectedLoadTime === "number")
      return a = ui(b2, a, e2, c2), b2.child.memoizedState = { baseLanes: c2 }, b2.memoizedState = si, b2.lanes = 33554432, a;
    c2 = vi({ mode: "visible", children: a }, b2.mode, c2, null);
    c2.return = b2;
    return b2.child = c2;
  }
  if (a.memoizedState !== null) {
    if (f2)
      return d2 = wi(a, b2, d2.children, d2.fallback, c2), f2 = b2.child, e2 = a.child.memoizedState, f2.memoizedState = e2 === null ? { baseLanes: c2 } : { baseLanes: e2.baseLanes | c2 }, f2.childLanes = a.childLanes & ~c2, b2.memoizedState = si, d2;
    c2 = xi(a, b2, d2.children, c2);
    b2.memoizedState = null;
    return c2;
  }
  if (f2)
    return d2 = wi(a, b2, d2.children, d2.fallback, c2), f2 = b2.child, e2 = a.child.memoizedState, f2.memoizedState = e2 === null ? { baseLanes: c2 } : { baseLanes: e2.baseLanes | c2 }, f2.childLanes = a.childLanes & ~c2, b2.memoizedState = si, d2;
  c2 = xi(a, b2, d2.children, c2);
  b2.memoizedState = null;
  return c2;
}
function ui(a, b2, c2, d2) {
  var e2 = a.mode, f2 = a.child;
  b2 = { mode: "hidden", children: b2 };
  (e2 & 2) === 0 && f2 !== null ? (f2.childLanes = 0, f2.pendingProps = b2) : f2 = vi(b2, e2, 0, null);
  c2 = Xg(c2, e2, d2, null);
  f2.return = a;
  c2.return = a;
  f2.sibling = c2;
  a.child = f2;
  return c2;
}
function xi(a, b2, c2, d2) {
  var e2 = a.child;
  a = e2.sibling;
  c2 = Tg(e2, { mode: "visible", children: c2 });
  (b2.mode & 2) === 0 && (c2.lanes = d2);
  c2.return = b2;
  c2.sibling = null;
  a !== null && (a.nextEffect = null, a.flags = 8, b2.firstEffect = b2.lastEffect = a);
  return b2.child = c2;
}
function wi(a, b2, c2, d2, e2) {
  var f2 = b2.mode, g2 = a.child;
  a = g2.sibling;
  var h = { mode: "hidden", children: c2 };
  (f2 & 2) === 0 && b2.child !== g2 ? (c2 = b2.child, c2.childLanes = 0, c2.pendingProps = h, g2 = c2.lastEffect, g2 !== null ? (b2.firstEffect = c2.firstEffect, b2.lastEffect = g2, g2.nextEffect = null) : b2.firstEffect = b2.lastEffect = null) : c2 = Tg(g2, h);
  a !== null ? d2 = Tg(a, d2) : (d2 = Xg(d2, f2, e2, null), d2.flags |= 2);
  d2.return = b2;
  c2.return = b2;
  c2.sibling = d2;
  b2.child = c2;
  return d2;
}
function yi(a, b2) {
  a.lanes |= b2;
  var c2 = a.alternate;
  c2 !== null && (c2.lanes |= b2);
  sg(a.return, b2);
}
function zi(a, b2, c2, d2, e2, f2) {
  var g2 = a.memoizedState;
  g2 === null ? a.memoizedState = { isBackwards: b2, rendering: null, renderingStartTime: 0, last: d2, tail: c2, tailMode: e2, lastEffect: f2 } : (g2.isBackwards = b2, g2.rendering = null, g2.renderingStartTime = 0, g2.last = d2, g2.tail = c2, g2.tailMode = e2, g2.lastEffect = f2);
}
function Ai(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = d2.revealOrder, f2 = d2.tail;
  fi(a, b2, d2.children, c2);
  d2 = P.current;
  if ((d2 & 2) !== 0)
    d2 = d2 & 1 | 2, b2.flags |= 64;
  else {
    if (a !== null && (a.flags & 64) !== 0)
      a:
        for (a = b2.child; a !== null; ) {
          if (a.tag === 13)
            a.memoizedState !== null && yi(a, c2);
          else if (a.tag === 19)
            yi(a, c2);
          else if (a.child !== null) {
            a.child.return = a;
            a = a.child;
            continue;
          }
          if (a === b2)
            break a;
          for (; a.sibling === null; ) {
            if (a.return === null || a.return === b2)
              break a;
            a = a.return;
          }
          a.sibling.return = a.return;
          a = a.sibling;
        }
    d2 &= 1;
  }
  I(P, d2);
  if ((b2.mode & 2) === 0)
    b2.memoizedState = null;
  else
    switch (e2) {
      case "forwards":
        c2 = b2.child;
        for (e2 = null; c2 !== null; )
          a = c2.alternate, a !== null && ih(a) === null && (e2 = c2), c2 = c2.sibling;
        c2 = e2;
        c2 === null ? (e2 = b2.child, b2.child = null) : (e2 = c2.sibling, c2.sibling = null);
        zi(b2, false, e2, c2, f2, b2.lastEffect);
        break;
      case "backwards":
        c2 = null;
        e2 = b2.child;
        for (b2.child = null; e2 !== null; ) {
          a = e2.alternate;
          if (a !== null && ih(a) === null) {
            b2.child = e2;
            break;
          }
          a = e2.sibling;
          e2.sibling = c2;
          c2 = e2;
          e2 = a;
        }
        zi(b2, true, c2, null, f2, b2.lastEffect);
        break;
      case "together":
        zi(b2, false, null, null, void 0, b2.lastEffect);
        break;
      default:
        b2.memoizedState = null;
    }
  return b2.child;
}
function hi(a, b2, c2) {
  a !== null && (b2.dependencies = a.dependencies);
  Dg |= b2.lanes;
  if ((c2 & b2.childLanes) !== 0) {
    if (a !== null && b2.child !== a.child)
      throw Error(y$1(153));
    if (b2.child !== null) {
      a = b2.child;
      c2 = Tg(a, a.pendingProps);
      b2.child = c2;
      for (c2.return = b2; a.sibling !== null; )
        a = a.sibling, c2 = c2.sibling = Tg(a, a.pendingProps), c2.return = b2;
      c2.sibling = null;
    }
    return b2.child;
  }
  return null;
}
var Bi, Ci, Di, Ei;
Bi = function(a, b2) {
  for (var c2 = b2.child; c2 !== null; ) {
    if (c2.tag === 5 || c2.tag === 6)
      a.appendChild(c2.stateNode);
    else if (c2.tag !== 4 && c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === b2)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === b2)
        return;
      c2 = c2.return;
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
};
Ci = function() {
};
Di = function(a, b2, c2, d2) {
  var e2 = a.memoizedProps;
  if (e2 !== d2) {
    a = b2.stateNode;
    dh(ah.current);
    var f2 = null;
    switch (c2) {
      case "input":
        e2 = Ya(a, e2);
        d2 = Ya(a, d2);
        f2 = [];
        break;
      case "option":
        e2 = eb(a, e2);
        d2 = eb(a, d2);
        f2 = [];
        break;
      case "select":
        e2 = m$2({}, e2, { value: void 0 });
        d2 = m$2({}, d2, { value: void 0 });
        f2 = [];
        break;
      case "textarea":
        e2 = gb(a, e2);
        d2 = gb(a, d2);
        f2 = [];
        break;
      default:
        typeof e2.onClick !== "function" && typeof d2.onClick === "function" && (a.onclick = jf);
    }
    vb(c2, d2);
    var g2;
    c2 = null;
    for (l2 in e2)
      if (!d2.hasOwnProperty(l2) && e2.hasOwnProperty(l2) && e2[l2] != null)
        if (l2 === "style") {
          var h = e2[l2];
          for (g2 in h)
            h.hasOwnProperty(g2) && (c2 || (c2 = {}), c2[g2] = "");
        } else
          l2 !== "dangerouslySetInnerHTML" && l2 !== "children" && l2 !== "suppressContentEditableWarning" && l2 !== "suppressHydrationWarning" && l2 !== "autoFocus" && (ca.hasOwnProperty(l2) ? f2 || (f2 = []) : (f2 = f2 || []).push(l2, null));
    for (l2 in d2) {
      var k2 = d2[l2];
      h = e2 != null ? e2[l2] : void 0;
      if (d2.hasOwnProperty(l2) && k2 !== h && (k2 != null || h != null))
        if (l2 === "style")
          if (h) {
            for (g2 in h)
              !h.hasOwnProperty(g2) || k2 && k2.hasOwnProperty(g2) || (c2 || (c2 = {}), c2[g2] = "");
            for (g2 in k2)
              k2.hasOwnProperty(g2) && h[g2] !== k2[g2] && (c2 || (c2 = {}), c2[g2] = k2[g2]);
          } else
            c2 || (f2 || (f2 = []), f2.push(l2, c2)), c2 = k2;
        else
          l2 === "dangerouslySetInnerHTML" ? (k2 = k2 ? k2.__html : void 0, h = h ? h.__html : void 0, k2 != null && h !== k2 && (f2 = f2 || []).push(l2, k2)) : l2 === "children" ? typeof k2 !== "string" && typeof k2 !== "number" || (f2 = f2 || []).push(l2, "" + k2) : l2 !== "suppressContentEditableWarning" && l2 !== "suppressHydrationWarning" && (ca.hasOwnProperty(l2) ? (k2 != null && l2 === "onScroll" && G("scroll", a), f2 || h === k2 || (f2 = [])) : typeof k2 === "object" && k2 !== null && k2.$$typeof === Ga ? k2.toString() : (f2 = f2 || []).push(l2, k2));
    }
    c2 && (f2 = f2 || []).push("style", c2);
    var l2 = f2;
    if (b2.updateQueue = l2)
      b2.flags |= 4;
  }
};
Ei = function(a, b2, c2, d2) {
  c2 !== d2 && (b2.flags |= 4);
};
function Fi(a, b2) {
  if (!lh)
    switch (a.tailMode) {
      case "hidden":
        b2 = a.tail;
        for (var c2 = null; b2 !== null; )
          b2.alternate !== null && (c2 = b2), b2 = b2.sibling;
        c2 === null ? a.tail = null : c2.sibling = null;
        break;
      case "collapsed":
        c2 = a.tail;
        for (var d2 = null; c2 !== null; )
          c2.alternate !== null && (d2 = c2), c2 = c2.sibling;
        d2 === null ? b2 || a.tail === null ? a.tail = null : a.tail.sibling = null : d2.sibling = null;
    }
}
function Gi(a, b2, c2) {
  var d2 = b2.pendingProps;
  switch (b2.tag) {
    case 2:
    case 16:
    case 15:
    case 0:
    case 11:
    case 7:
    case 8:
    case 12:
    case 9:
    case 14:
      return null;
    case 1:
      return Ff(b2.type) && Gf(), null;
    case 3:
      fh();
      H(N);
      H(M);
      uh();
      d2 = b2.stateNode;
      d2.pendingContext && (d2.context = d2.pendingContext, d2.pendingContext = null);
      if (a === null || a.child === null)
        rh(b2) ? b2.flags |= 4 : d2.hydrate || (b2.flags |= 256);
      Ci(b2);
      return null;
    case 5:
      hh(b2);
      var e2 = dh(ch.current);
      c2 = b2.type;
      if (a !== null && b2.stateNode != null)
        Di(a, b2, c2, d2, e2), a.ref !== b2.ref && (b2.flags |= 128);
      else {
        if (!d2) {
          if (b2.stateNode === null)
            throw Error(y$1(166));
          return null;
        }
        a = dh(ah.current);
        if (rh(b2)) {
          d2 = b2.stateNode;
          c2 = b2.type;
          var f2 = b2.memoizedProps;
          d2[wf] = b2;
          d2[xf] = f2;
          switch (c2) {
            case "dialog":
              G("cancel", d2);
              G("close", d2);
              break;
            case "iframe":
            case "object":
            case "embed":
              G("load", d2);
              break;
            case "video":
            case "audio":
              for (a = 0; a < Xe.length; a++)
                G(Xe[a], d2);
              break;
            case "source":
              G("error", d2);
              break;
            case "img":
            case "image":
            case "link":
              G("error", d2);
              G("load", d2);
              break;
            case "details":
              G("toggle", d2);
              break;
            case "input":
              Za(d2, f2);
              G("invalid", d2);
              break;
            case "select":
              d2._wrapperState = { wasMultiple: !!f2.multiple };
              G("invalid", d2);
              break;
            case "textarea":
              hb(d2, f2), G("invalid", d2);
          }
          vb(c2, f2);
          a = null;
          for (var g2 in f2)
            f2.hasOwnProperty(g2) && (e2 = f2[g2], g2 === "children" ? typeof e2 === "string" ? d2.textContent !== e2 && (a = ["children", e2]) : typeof e2 === "number" && d2.textContent !== "" + e2 && (a = ["children", "" + e2]) : ca.hasOwnProperty(g2) && e2 != null && g2 === "onScroll" && G("scroll", d2));
          switch (c2) {
            case "input":
              Va(d2);
              cb(d2, f2, true);
              break;
            case "textarea":
              Va(d2);
              jb(d2);
              break;
            case "select":
            case "option":
              break;
            default:
              typeof f2.onClick === "function" && (d2.onclick = jf);
          }
          d2 = a;
          b2.updateQueue = d2;
          d2 !== null && (b2.flags |= 4);
        } else {
          g2 = e2.nodeType === 9 ? e2 : e2.ownerDocument;
          a === kb.html && (a = lb(c2));
          a === kb.html ? c2 === "script" ? (a = g2.createElement("div"), a.innerHTML = "<script><\/script>", a = a.removeChild(a.firstChild)) : typeof d2.is === "string" ? a = g2.createElement(c2, { is: d2.is }) : (a = g2.createElement(c2), c2 === "select" && (g2 = a, d2.multiple ? g2.multiple = true : d2.size && (g2.size = d2.size))) : a = g2.createElementNS(a, c2);
          a[wf] = b2;
          a[xf] = d2;
          Bi(a, b2, false, false);
          b2.stateNode = a;
          g2 = wb(c2, d2);
          switch (c2) {
            case "dialog":
              G("cancel", a);
              G("close", a);
              e2 = d2;
              break;
            case "iframe":
            case "object":
            case "embed":
              G("load", a);
              e2 = d2;
              break;
            case "video":
            case "audio":
              for (e2 = 0; e2 < Xe.length; e2++)
                G(Xe[e2], a);
              e2 = d2;
              break;
            case "source":
              G("error", a);
              e2 = d2;
              break;
            case "img":
            case "image":
            case "link":
              G("error", a);
              G("load", a);
              e2 = d2;
              break;
            case "details":
              G("toggle", a);
              e2 = d2;
              break;
            case "input":
              Za(a, d2);
              e2 = Ya(a, d2);
              G("invalid", a);
              break;
            case "option":
              e2 = eb(a, d2);
              break;
            case "select":
              a._wrapperState = { wasMultiple: !!d2.multiple };
              e2 = m$2({}, d2, { value: void 0 });
              G("invalid", a);
              break;
            case "textarea":
              hb(a, d2);
              e2 = gb(a, d2);
              G("invalid", a);
              break;
            default:
              e2 = d2;
          }
          vb(c2, e2);
          var h = e2;
          for (f2 in h)
            if (h.hasOwnProperty(f2)) {
              var k2 = h[f2];
              f2 === "style" ? tb(a, k2) : f2 === "dangerouslySetInnerHTML" ? (k2 = k2 ? k2.__html : void 0, k2 != null && ob(a, k2)) : f2 === "children" ? typeof k2 === "string" ? (c2 !== "textarea" || k2 !== "") && pb(a, k2) : typeof k2 === "number" && pb(a, "" + k2) : f2 !== "suppressContentEditableWarning" && f2 !== "suppressHydrationWarning" && f2 !== "autoFocus" && (ca.hasOwnProperty(f2) ? k2 != null && f2 === "onScroll" && G("scroll", a) : k2 != null && qa(a, f2, k2, g2));
            }
          switch (c2) {
            case "input":
              Va(a);
              cb(a, d2, false);
              break;
            case "textarea":
              Va(a);
              jb(a);
              break;
            case "option":
              d2.value != null && a.setAttribute("value", "" + Sa(d2.value));
              break;
            case "select":
              a.multiple = !!d2.multiple;
              f2 = d2.value;
              f2 != null ? fb(a, !!d2.multiple, f2, false) : d2.defaultValue != null && fb(a, !!d2.multiple, d2.defaultValue, true);
              break;
            default:
              typeof e2.onClick === "function" && (a.onclick = jf);
          }
          mf(c2, d2) && (b2.flags |= 4);
        }
        b2.ref !== null && (b2.flags |= 128);
      }
      return null;
    case 6:
      if (a && b2.stateNode != null)
        Ei(a, b2, a.memoizedProps, d2);
      else {
        if (typeof d2 !== "string" && b2.stateNode === null)
          throw Error(y$1(166));
        c2 = dh(ch.current);
        dh(ah.current);
        rh(b2) ? (d2 = b2.stateNode, c2 = b2.memoizedProps, d2[wf] = b2, d2.nodeValue !== c2 && (b2.flags |= 4)) : (d2 = (c2.nodeType === 9 ? c2 : c2.ownerDocument).createTextNode(d2), d2[wf] = b2, b2.stateNode = d2);
      }
      return null;
    case 13:
      H(P);
      d2 = b2.memoizedState;
      if ((b2.flags & 64) !== 0)
        return b2.lanes = c2, b2;
      d2 = d2 !== null;
      c2 = false;
      a === null ? b2.memoizedProps.fallback !== void 0 && rh(b2) : c2 = a.memoizedState !== null;
      if (d2 && !c2 && (b2.mode & 2) !== 0)
        if (a === null && b2.memoizedProps.unstable_avoidThisFallback !== true || (P.current & 1) !== 0)
          V === 0 && (V = 3);
        else {
          if (V === 0 || V === 3)
            V = 4;
          U === null || (Dg & 134217727) === 0 && (Hi & 134217727) === 0 || Ii(U, W);
        }
      if (d2 || c2)
        b2.flags |= 4;
      return null;
    case 4:
      return fh(), Ci(b2), a === null && cf(b2.stateNode.containerInfo), null;
    case 10:
      return rg(b2), null;
    case 17:
      return Ff(b2.type) && Gf(), null;
    case 19:
      H(P);
      d2 = b2.memoizedState;
      if (d2 === null)
        return null;
      f2 = (b2.flags & 64) !== 0;
      g2 = d2.rendering;
      if (g2 === null)
        if (f2)
          Fi(d2, false);
        else {
          if (V !== 0 || a !== null && (a.flags & 64) !== 0)
            for (a = b2.child; a !== null; ) {
              g2 = ih(a);
              if (g2 !== null) {
                b2.flags |= 64;
                Fi(d2, false);
                f2 = g2.updateQueue;
                f2 !== null && (b2.updateQueue = f2, b2.flags |= 4);
                d2.lastEffect === null && (b2.firstEffect = null);
                b2.lastEffect = d2.lastEffect;
                d2 = c2;
                for (c2 = b2.child; c2 !== null; )
                  f2 = c2, a = d2, f2.flags &= 2, f2.nextEffect = null, f2.firstEffect = null, f2.lastEffect = null, g2 = f2.alternate, g2 === null ? (f2.childLanes = 0, f2.lanes = a, f2.child = null, f2.memoizedProps = null, f2.memoizedState = null, f2.updateQueue = null, f2.dependencies = null, f2.stateNode = null) : (f2.childLanes = g2.childLanes, f2.lanes = g2.lanes, f2.child = g2.child, f2.memoizedProps = g2.memoizedProps, f2.memoizedState = g2.memoizedState, f2.updateQueue = g2.updateQueue, f2.type = g2.type, a = g2.dependencies, f2.dependencies = a === null ? null : { lanes: a.lanes, firstContext: a.firstContext }), c2 = c2.sibling;
                I(P, P.current & 1 | 2);
                return b2.child;
              }
              a = a.sibling;
            }
          d2.tail !== null && O() > Ji && (b2.flags |= 64, f2 = true, Fi(d2, false), b2.lanes = 33554432);
        }
      else {
        if (!f2)
          if (a = ih(g2), a !== null) {
            if (b2.flags |= 64, f2 = true, c2 = a.updateQueue, c2 !== null && (b2.updateQueue = c2, b2.flags |= 4), Fi(d2, true), d2.tail === null && d2.tailMode === "hidden" && !g2.alternate && !lh)
              return b2 = b2.lastEffect = d2.lastEffect, b2 !== null && (b2.nextEffect = null), null;
          } else
            2 * O() - d2.renderingStartTime > Ji && c2 !== 1073741824 && (b2.flags |= 64, f2 = true, Fi(d2, false), b2.lanes = 33554432);
        d2.isBackwards ? (g2.sibling = b2.child, b2.child = g2) : (c2 = d2.last, c2 !== null ? c2.sibling = g2 : b2.child = g2, d2.last = g2);
      }
      return d2.tail !== null ? (c2 = d2.tail, d2.rendering = c2, d2.tail = c2.sibling, d2.lastEffect = b2.lastEffect, d2.renderingStartTime = O(), c2.sibling = null, b2 = P.current, I(P, f2 ? b2 & 1 | 2 : b2 & 1), c2) : null;
    case 23:
    case 24:
      return Ki(), a !== null && a.memoizedState !== null !== (b2.memoizedState !== null) && d2.mode !== "unstable-defer-without-hiding" && (b2.flags |= 4), null;
  }
  throw Error(y$1(156, b2.tag));
}
function Li(a) {
  switch (a.tag) {
    case 1:
      Ff(a.type) && Gf();
      var b2 = a.flags;
      return b2 & 4096 ? (a.flags = b2 & -4097 | 64, a) : null;
    case 3:
      fh();
      H(N);
      H(M);
      uh();
      b2 = a.flags;
      if ((b2 & 64) !== 0)
        throw Error(y$1(285));
      a.flags = b2 & -4097 | 64;
      return a;
    case 5:
      return hh(a), null;
    case 13:
      return H(P), b2 = a.flags, b2 & 4096 ? (a.flags = b2 & -4097 | 64, a) : null;
    case 19:
      return H(P), null;
    case 4:
      return fh(), null;
    case 10:
      return rg(a), null;
    case 23:
    case 24:
      return Ki(), null;
    default:
      return null;
  }
}
function Mi(a, b2) {
  try {
    var c2 = "", d2 = b2;
    do
      c2 += Qa(d2), d2 = d2.return;
    while (d2);
    var e2 = c2;
  } catch (f2) {
    e2 = "\nError generating stack: " + f2.message + "\n" + f2.stack;
  }
  return { value: a, source: b2, stack: e2 };
}
function Ni(a, b2) {
  try {
    console.error(b2.value);
  } catch (c2) {
    setTimeout(function() {
      throw c2;
    });
  }
}
var Oi = typeof WeakMap === "function" ? WeakMap : Map;
function Pi(a, b2, c2) {
  c2 = zg(-1, c2);
  c2.tag = 3;
  c2.payload = { element: null };
  var d2 = b2.value;
  c2.callback = function() {
    Qi || (Qi = true, Ri = d2);
    Ni(a, b2);
  };
  return c2;
}
function Si(a, b2, c2) {
  c2 = zg(-1, c2);
  c2.tag = 3;
  var d2 = a.type.getDerivedStateFromError;
  if (typeof d2 === "function") {
    var e2 = b2.value;
    c2.payload = function() {
      Ni(a, b2);
      return d2(e2);
    };
  }
  var f2 = a.stateNode;
  f2 !== null && typeof f2.componentDidCatch === "function" && (c2.callback = function() {
    typeof d2 !== "function" && (Ti === null ? Ti = /* @__PURE__ */ new Set([this]) : Ti.add(this), Ni(a, b2));
    var c3 = b2.stack;
    this.componentDidCatch(b2.value, { componentStack: c3 !== null ? c3 : "" });
  });
  return c2;
}
var Ui = typeof WeakSet === "function" ? WeakSet : Set;
function Vi(a) {
  var b2 = a.ref;
  if (b2 !== null)
    if (typeof b2 === "function")
      try {
        b2(null);
      } catch (c2) {
        Wi(a, c2);
      }
    else
      b2.current = null;
}
function Xi(a, b2) {
  switch (b2.tag) {
    case 0:
    case 11:
    case 15:
    case 22:
      return;
    case 1:
      if (b2.flags & 256 && a !== null) {
        var c2 = a.memoizedProps, d2 = a.memoizedState;
        a = b2.stateNode;
        b2 = a.getSnapshotBeforeUpdate(b2.elementType === b2.type ? c2 : lg(b2.type, c2), d2);
        a.__reactInternalSnapshotBeforeUpdate = b2;
      }
      return;
    case 3:
      b2.flags & 256 && qf(b2.stateNode.containerInfo);
      return;
    case 5:
    case 6:
    case 4:
    case 17:
      return;
  }
  throw Error(y$1(163));
}
function Yi(a, b2, c2) {
  switch (c2.tag) {
    case 0:
    case 11:
    case 15:
    case 22:
      b2 = c2.updateQueue;
      b2 = b2 !== null ? b2.lastEffect : null;
      if (b2 !== null) {
        a = b2 = b2.next;
        do {
          if ((a.tag & 3) === 3) {
            var d2 = a.create;
            a.destroy = d2();
          }
          a = a.next;
        } while (a !== b2);
      }
      b2 = c2.updateQueue;
      b2 = b2 !== null ? b2.lastEffect : null;
      if (b2 !== null) {
        a = b2 = b2.next;
        do {
          var e2 = a;
          d2 = e2.next;
          e2 = e2.tag;
          (e2 & 4) !== 0 && (e2 & 1) !== 0 && (Zi(c2, a), $i(c2, a));
          a = d2;
        } while (a !== b2);
      }
      return;
    case 1:
      a = c2.stateNode;
      c2.flags & 4 && (b2 === null ? a.componentDidMount() : (d2 = c2.elementType === c2.type ? b2.memoizedProps : lg(c2.type, b2.memoizedProps), a.componentDidUpdate(d2, b2.memoizedState, a.__reactInternalSnapshotBeforeUpdate)));
      b2 = c2.updateQueue;
      b2 !== null && Eg(c2, b2, a);
      return;
    case 3:
      b2 = c2.updateQueue;
      if (b2 !== null) {
        a = null;
        if (c2.child !== null)
          switch (c2.child.tag) {
            case 5:
              a = c2.child.stateNode;
              break;
            case 1:
              a = c2.child.stateNode;
          }
        Eg(c2, b2, a);
      }
      return;
    case 5:
      a = c2.stateNode;
      b2 === null && c2.flags & 4 && mf(c2.type, c2.memoizedProps) && a.focus();
      return;
    case 6:
      return;
    case 4:
      return;
    case 12:
      return;
    case 13:
      c2.memoizedState === null && (c2 = c2.alternate, c2 !== null && (c2 = c2.memoizedState, c2 !== null && (c2 = c2.dehydrated, c2 !== null && Cc(c2))));
      return;
    case 19:
    case 17:
    case 20:
    case 21:
    case 23:
    case 24:
      return;
  }
  throw Error(y$1(163));
}
function aj(a, b2) {
  for (var c2 = a; ; ) {
    if (c2.tag === 5) {
      var d2 = c2.stateNode;
      if (b2)
        d2 = d2.style, typeof d2.setProperty === "function" ? d2.setProperty("display", "none", "important") : d2.display = "none";
      else {
        d2 = c2.stateNode;
        var e2 = c2.memoizedProps.style;
        e2 = e2 !== void 0 && e2 !== null && e2.hasOwnProperty("display") ? e2.display : null;
        d2.style.display = sb("display", e2);
      }
    } else if (c2.tag === 6)
      c2.stateNode.nodeValue = b2 ? "" : c2.memoizedProps;
    else if ((c2.tag !== 23 && c2.tag !== 24 || c2.memoizedState === null || c2 === a) && c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === a)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === a)
        return;
      c2 = c2.return;
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
}
function bj(a, b2) {
  if (Mf && typeof Mf.onCommitFiberUnmount === "function")
    try {
      Mf.onCommitFiberUnmount(Lf, b2);
    } catch (f2) {
    }
  switch (b2.tag) {
    case 0:
    case 11:
    case 14:
    case 15:
    case 22:
      a = b2.updateQueue;
      if (a !== null && (a = a.lastEffect, a !== null)) {
        var c2 = a = a.next;
        do {
          var d2 = c2, e2 = d2.destroy;
          d2 = d2.tag;
          if (e2 !== void 0)
            if ((d2 & 4) !== 0)
              Zi(b2, c2);
            else {
              d2 = b2;
              try {
                e2();
              } catch (f2) {
                Wi(d2, f2);
              }
            }
          c2 = c2.next;
        } while (c2 !== a);
      }
      break;
    case 1:
      Vi(b2);
      a = b2.stateNode;
      if (typeof a.componentWillUnmount === "function")
        try {
          a.props = b2.memoizedProps, a.state = b2.memoizedState, a.componentWillUnmount();
        } catch (f2) {
          Wi(b2, f2);
        }
      break;
    case 5:
      Vi(b2);
      break;
    case 4:
      cj(a, b2);
  }
}
function dj(a) {
  a.alternate = null;
  a.child = null;
  a.dependencies = null;
  a.firstEffect = null;
  a.lastEffect = null;
  a.memoizedProps = null;
  a.memoizedState = null;
  a.pendingProps = null;
  a.return = null;
  a.updateQueue = null;
}
function ej(a) {
  return a.tag === 5 || a.tag === 3 || a.tag === 4;
}
function fj(a) {
  a: {
    for (var b2 = a.return; b2 !== null; ) {
      if (ej(b2))
        break a;
      b2 = b2.return;
    }
    throw Error(y$1(160));
  }
  var c2 = b2;
  b2 = c2.stateNode;
  switch (c2.tag) {
    case 5:
      var d2 = false;
      break;
    case 3:
      b2 = b2.containerInfo;
      d2 = true;
      break;
    case 4:
      b2 = b2.containerInfo;
      d2 = true;
      break;
    default:
      throw Error(y$1(161));
  }
  c2.flags & 16 && (pb(b2, ""), c2.flags &= -17);
  a:
    b:
      for (c2 = a; ; ) {
        for (; c2.sibling === null; ) {
          if (c2.return === null || ej(c2.return)) {
            c2 = null;
            break a;
          }
          c2 = c2.return;
        }
        c2.sibling.return = c2.return;
        for (c2 = c2.sibling; c2.tag !== 5 && c2.tag !== 6 && c2.tag !== 18; ) {
          if (c2.flags & 2)
            continue b;
          if (c2.child === null || c2.tag === 4)
            continue b;
          else
            c2.child.return = c2, c2 = c2.child;
        }
        if (!(c2.flags & 2)) {
          c2 = c2.stateNode;
          break a;
        }
      }
  d2 ? gj(a, c2, b2) : hj(a, c2, b2);
}
function gj(a, b2, c2) {
  var d2 = a.tag, e2 = d2 === 5 || d2 === 6;
  if (e2)
    a = e2 ? a.stateNode : a.stateNode.instance, b2 ? c2.nodeType === 8 ? c2.parentNode.insertBefore(a, b2) : c2.insertBefore(a, b2) : (c2.nodeType === 8 ? (b2 = c2.parentNode, b2.insertBefore(a, c2)) : (b2 = c2, b2.appendChild(a)), c2 = c2._reactRootContainer, c2 !== null && c2 !== void 0 || b2.onclick !== null || (b2.onclick = jf));
  else if (d2 !== 4 && (a = a.child, a !== null))
    for (gj(a, b2, c2), a = a.sibling; a !== null; )
      gj(a, b2, c2), a = a.sibling;
}
function hj(a, b2, c2) {
  var d2 = a.tag, e2 = d2 === 5 || d2 === 6;
  if (e2)
    a = e2 ? a.stateNode : a.stateNode.instance, b2 ? c2.insertBefore(a, b2) : c2.appendChild(a);
  else if (d2 !== 4 && (a = a.child, a !== null))
    for (hj(a, b2, c2), a = a.sibling; a !== null; )
      hj(a, b2, c2), a = a.sibling;
}
function cj(a, b2) {
  for (var c2 = b2, d2 = false, e2, f2; ; ) {
    if (!d2) {
      d2 = c2.return;
      a:
        for (; ; ) {
          if (d2 === null)
            throw Error(y$1(160));
          e2 = d2.stateNode;
          switch (d2.tag) {
            case 5:
              f2 = false;
              break a;
            case 3:
              e2 = e2.containerInfo;
              f2 = true;
              break a;
            case 4:
              e2 = e2.containerInfo;
              f2 = true;
              break a;
          }
          d2 = d2.return;
        }
      d2 = true;
    }
    if (c2.tag === 5 || c2.tag === 6) {
      a:
        for (var g2 = a, h = c2, k2 = h; ; )
          if (bj(g2, k2), k2.child !== null && k2.tag !== 4)
            k2.child.return = k2, k2 = k2.child;
          else {
            if (k2 === h)
              break a;
            for (; k2.sibling === null; ) {
              if (k2.return === null || k2.return === h)
                break a;
              k2 = k2.return;
            }
            k2.sibling.return = k2.return;
            k2 = k2.sibling;
          }
      f2 ? (g2 = e2, h = c2.stateNode, g2.nodeType === 8 ? g2.parentNode.removeChild(h) : g2.removeChild(h)) : e2.removeChild(c2.stateNode);
    } else if (c2.tag === 4) {
      if (c2.child !== null) {
        e2 = c2.stateNode.containerInfo;
        f2 = true;
        c2.child.return = c2;
        c2 = c2.child;
        continue;
      }
    } else if (bj(a, c2), c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === b2)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === b2)
        return;
      c2 = c2.return;
      c2.tag === 4 && (d2 = false);
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
}
function ij(a, b2) {
  switch (b2.tag) {
    case 0:
    case 11:
    case 14:
    case 15:
    case 22:
      var c2 = b2.updateQueue;
      c2 = c2 !== null ? c2.lastEffect : null;
      if (c2 !== null) {
        var d2 = c2 = c2.next;
        do
          (d2.tag & 3) === 3 && (a = d2.destroy, d2.destroy = void 0, a !== void 0 && a()), d2 = d2.next;
        while (d2 !== c2);
      }
      return;
    case 1:
      return;
    case 5:
      c2 = b2.stateNode;
      if (c2 != null) {
        d2 = b2.memoizedProps;
        var e2 = a !== null ? a.memoizedProps : d2;
        a = b2.type;
        var f2 = b2.updateQueue;
        b2.updateQueue = null;
        if (f2 !== null) {
          c2[xf] = d2;
          a === "input" && d2.type === "radio" && d2.name != null && $a(c2, d2);
          wb(a, e2);
          b2 = wb(a, d2);
          for (e2 = 0; e2 < f2.length; e2 += 2) {
            var g2 = f2[e2], h = f2[e2 + 1];
            g2 === "style" ? tb(c2, h) : g2 === "dangerouslySetInnerHTML" ? ob(c2, h) : g2 === "children" ? pb(c2, h) : qa(c2, g2, h, b2);
          }
          switch (a) {
            case "input":
              ab(c2, d2);
              break;
            case "textarea":
              ib(c2, d2);
              break;
            case "select":
              a = c2._wrapperState.wasMultiple, c2._wrapperState.wasMultiple = !!d2.multiple, f2 = d2.value, f2 != null ? fb(c2, !!d2.multiple, f2, false) : a !== !!d2.multiple && (d2.defaultValue != null ? fb(c2, !!d2.multiple, d2.defaultValue, true) : fb(c2, !!d2.multiple, d2.multiple ? [] : "", false));
          }
        }
      }
      return;
    case 6:
      if (b2.stateNode === null)
        throw Error(y$1(162));
      b2.stateNode.nodeValue = b2.memoizedProps;
      return;
    case 3:
      c2 = b2.stateNode;
      c2.hydrate && (c2.hydrate = false, Cc(c2.containerInfo));
      return;
    case 12:
      return;
    case 13:
      b2.memoizedState !== null && (jj = O(), aj(b2.child, true));
      kj(b2);
      return;
    case 19:
      kj(b2);
      return;
    case 17:
      return;
    case 23:
    case 24:
      aj(b2, b2.memoizedState !== null);
      return;
  }
  throw Error(y$1(163));
}
function kj(a) {
  var b2 = a.updateQueue;
  if (b2 !== null) {
    a.updateQueue = null;
    var c2 = a.stateNode;
    c2 === null && (c2 = a.stateNode = new Ui());
    b2.forEach(function(b3) {
      var d2 = lj.bind(null, a, b3);
      c2.has(b3) || (c2.add(b3), b3.then(d2, d2));
    });
  }
}
function mj(a, b2) {
  return a !== null && (a = a.memoizedState, a === null || a.dehydrated !== null) ? (b2 = b2.memoizedState, b2 !== null && b2.dehydrated === null) : false;
}
var nj = Math.ceil, oj = ra.ReactCurrentDispatcher, pj = ra.ReactCurrentOwner, X = 0, U = null, Y = null, W = 0, qj = 0, rj = Bf(0), V = 0, sj = null, tj = 0, Dg = 0, Hi = 0, uj = 0, vj = null, jj = 0, Ji = Infinity;
function wj() {
  Ji = O() + 500;
}
var Z = null, Qi = false, Ri = null, Ti = null, xj = false, yj = null, zj = 90, Aj = [], Bj = [], Cj = null, Dj = 0, Ej = null, Fj = -1, Gj = 0, Hj = 0, Ij = null, Jj = false;
function Hg() {
  return (X & 48) !== 0 ? O() : Fj !== -1 ? Fj : Fj = O();
}
function Ig(a) {
  a = a.mode;
  if ((a & 2) === 0)
    return 1;
  if ((a & 4) === 0)
    return eg() === 99 ? 1 : 2;
  Gj === 0 && (Gj = tj);
  if (kg.transition !== 0) {
    Hj !== 0 && (Hj = vj !== null ? vj.pendingLanes : 0);
    a = Gj;
    var b2 = 4186112 & ~Hj;
    b2 &= -b2;
    b2 === 0 && (a = 4186112 & ~a, b2 = a & -a, b2 === 0 && (b2 = 8192));
    return b2;
  }
  a = eg();
  (X & 4) !== 0 && a === 98 ? a = Xc(12, Gj) : (a = Sc(a), a = Xc(a, Gj));
  return a;
}
function Jg(a, b2, c2) {
  if (50 < Dj)
    throw Dj = 0, Ej = null, Error(y$1(185));
  a = Kj(a, b2);
  if (a === null)
    return null;
  $c(a, b2, c2);
  a === U && (Hi |= b2, V === 4 && Ii(a, W));
  var d2 = eg();
  b2 === 1 ? (X & 8) !== 0 && (X & 48) === 0 ? Lj(a) : (Mj(a, c2), X === 0 && (wj(), ig())) : ((X & 4) === 0 || d2 !== 98 && d2 !== 99 || (Cj === null ? Cj = /* @__PURE__ */ new Set([a]) : Cj.add(a)), Mj(a, c2));
  vj = a;
}
function Kj(a, b2) {
  a.lanes |= b2;
  var c2 = a.alternate;
  c2 !== null && (c2.lanes |= b2);
  c2 = a;
  for (a = a.return; a !== null; )
    a.childLanes |= b2, c2 = a.alternate, c2 !== null && (c2.childLanes |= b2), c2 = a, a = a.return;
  return c2.tag === 3 ? c2.stateNode : null;
}
function Mj(a, b2) {
  for (var c2 = a.callbackNode, d2 = a.suspendedLanes, e2 = a.pingedLanes, f2 = a.expirationTimes, g2 = a.pendingLanes; 0 < g2; ) {
    var h = 31 - Vc(g2), k2 = 1 << h, l2 = f2[h];
    if (l2 === -1) {
      if ((k2 & d2) === 0 || (k2 & e2) !== 0) {
        l2 = b2;
        Rc(k2);
        var n2 = F;
        f2[h] = 10 <= n2 ? l2 + 250 : 6 <= n2 ? l2 + 5e3 : -1;
      }
    } else
      l2 <= b2 && (a.expiredLanes |= k2);
    g2 &= ~k2;
  }
  d2 = Uc(a, a === U ? W : 0);
  b2 = F;
  if (d2 === 0)
    c2 !== null && (c2 !== Zf && Pf(c2), a.callbackNode = null, a.callbackPriority = 0);
  else {
    if (c2 !== null) {
      if (a.callbackPriority === b2)
        return;
      c2 !== Zf && Pf(c2);
    }
    b2 === 15 ? (c2 = Lj.bind(null, a), ag === null ? (ag = [c2], bg = Of(Uf, jg)) : ag.push(c2), c2 = Zf) : b2 === 14 ? c2 = hg(99, Lj.bind(null, a)) : (c2 = Tc(b2), c2 = hg(c2, Nj.bind(null, a)));
    a.callbackPriority = b2;
    a.callbackNode = c2;
  }
}
function Nj(a) {
  Fj = -1;
  Hj = Gj = 0;
  if ((X & 48) !== 0)
    throw Error(y$1(327));
  var b2 = a.callbackNode;
  if (Oj() && a.callbackNode !== b2)
    return null;
  var c2 = Uc(a, a === U ? W : 0);
  if (c2 === 0)
    return null;
  var d2 = c2;
  var e2 = X;
  X |= 16;
  var f2 = Pj();
  if (U !== a || W !== d2)
    wj(), Qj(a, d2);
  do
    try {
      Rj();
      break;
    } catch (h) {
      Sj(a, h);
    }
  while (1);
  qg();
  oj.current = f2;
  X = e2;
  Y !== null ? d2 = 0 : (U = null, W = 0, d2 = V);
  if ((tj & Hi) !== 0)
    Qj(a, 0);
  else if (d2 !== 0) {
    d2 === 2 && (X |= 64, a.hydrate && (a.hydrate = false, qf(a.containerInfo)), c2 = Wc(a), c2 !== 0 && (d2 = Tj(a, c2)));
    if (d2 === 1)
      throw b2 = sj, Qj(a, 0), Ii(a, c2), Mj(a, O()), b2;
    a.finishedWork = a.current.alternate;
    a.finishedLanes = c2;
    switch (d2) {
      case 0:
      case 1:
        throw Error(y$1(345));
      case 2:
        Uj(a);
        break;
      case 3:
        Ii(a, c2);
        if ((c2 & 62914560) === c2 && (d2 = jj + 500 - O(), 10 < d2)) {
          if (Uc(a, 0) !== 0)
            break;
          e2 = a.suspendedLanes;
          if ((e2 & c2) !== c2) {
            Hg();
            a.pingedLanes |= a.suspendedLanes & e2;
            break;
          }
          a.timeoutHandle = of(Uj.bind(null, a), d2);
          break;
        }
        Uj(a);
        break;
      case 4:
        Ii(a, c2);
        if ((c2 & 4186112) === c2)
          break;
        d2 = a.eventTimes;
        for (e2 = -1; 0 < c2; ) {
          var g2 = 31 - Vc(c2);
          f2 = 1 << g2;
          g2 = d2[g2];
          g2 > e2 && (e2 = g2);
          c2 &= ~f2;
        }
        c2 = e2;
        c2 = O() - c2;
        c2 = (120 > c2 ? 120 : 480 > c2 ? 480 : 1080 > c2 ? 1080 : 1920 > c2 ? 1920 : 3e3 > c2 ? 3e3 : 4320 > c2 ? 4320 : 1960 * nj(c2 / 1960)) - c2;
        if (10 < c2) {
          a.timeoutHandle = of(Uj.bind(null, a), c2);
          break;
        }
        Uj(a);
        break;
      case 5:
        Uj(a);
        break;
      default:
        throw Error(y$1(329));
    }
  }
  Mj(a, O());
  return a.callbackNode === b2 ? Nj.bind(null, a) : null;
}
function Ii(a, b2) {
  b2 &= ~uj;
  b2 &= ~Hi;
  a.suspendedLanes |= b2;
  a.pingedLanes &= ~b2;
  for (a = a.expirationTimes; 0 < b2; ) {
    var c2 = 31 - Vc(b2), d2 = 1 << c2;
    a[c2] = -1;
    b2 &= ~d2;
  }
}
function Lj(a) {
  if ((X & 48) !== 0)
    throw Error(y$1(327));
  Oj();
  if (a === U && (a.expiredLanes & W) !== 0) {
    var b2 = W;
    var c2 = Tj(a, b2);
    (tj & Hi) !== 0 && (b2 = Uc(a, b2), c2 = Tj(a, b2));
  } else
    b2 = Uc(a, 0), c2 = Tj(a, b2);
  a.tag !== 0 && c2 === 2 && (X |= 64, a.hydrate && (a.hydrate = false, qf(a.containerInfo)), b2 = Wc(a), b2 !== 0 && (c2 = Tj(a, b2)));
  if (c2 === 1)
    throw c2 = sj, Qj(a, 0), Ii(a, b2), Mj(a, O()), c2;
  a.finishedWork = a.current.alternate;
  a.finishedLanes = b2;
  Uj(a);
  Mj(a, O());
  return null;
}
function Vj() {
  if (Cj !== null) {
    var a = Cj;
    Cj = null;
    a.forEach(function(a2) {
      a2.expiredLanes |= 24 & a2.pendingLanes;
      Mj(a2, O());
    });
  }
  ig();
}
function Wj(a, b2) {
  var c2 = X;
  X |= 1;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
}
function Xj(a, b2) {
  var c2 = X;
  X &= -2;
  X |= 8;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
}
function ni(a, b2) {
  I(rj, qj);
  qj |= b2;
  tj |= b2;
}
function Ki() {
  qj = rj.current;
  H(rj);
}
function Qj(a, b2) {
  a.finishedWork = null;
  a.finishedLanes = 0;
  var c2 = a.timeoutHandle;
  c2 !== -1 && (a.timeoutHandle = -1, pf(c2));
  if (Y !== null)
    for (c2 = Y.return; c2 !== null; ) {
      var d2 = c2;
      switch (d2.tag) {
        case 1:
          d2 = d2.type.childContextTypes;
          d2 !== null && d2 !== void 0 && Gf();
          break;
        case 3:
          fh();
          H(N);
          H(M);
          uh();
          break;
        case 5:
          hh(d2);
          break;
        case 4:
          fh();
          break;
        case 13:
          H(P);
          break;
        case 19:
          H(P);
          break;
        case 10:
          rg(d2);
          break;
        case 23:
        case 24:
          Ki();
      }
      c2 = c2.return;
    }
  U = a;
  Y = Tg(a.current, null);
  W = qj = tj = b2;
  V = 0;
  sj = null;
  uj = Hi = Dg = 0;
}
function Sj(a, b2) {
  do {
    var c2 = Y;
    try {
      qg();
      vh.current = Gh;
      if (yh) {
        for (var d2 = R.memoizedState; d2 !== null; ) {
          var e2 = d2.queue;
          e2 !== null && (e2.pending = null);
          d2 = d2.next;
        }
        yh = false;
      }
      xh = 0;
      T = S = R = null;
      zh = false;
      pj.current = null;
      if (c2 === null || c2.return === null) {
        V = 1;
        sj = b2;
        Y = null;
        break;
      }
      a: {
        var f2 = a, g2 = c2.return, h = c2, k2 = b2;
        b2 = W;
        h.flags |= 2048;
        h.firstEffect = h.lastEffect = null;
        if (k2 !== null && typeof k2 === "object" && typeof k2.then === "function") {
          var l2 = k2;
          if ((h.mode & 2) === 0) {
            var n2 = h.alternate;
            n2 ? (h.updateQueue = n2.updateQueue, h.memoizedState = n2.memoizedState, h.lanes = n2.lanes) : (h.updateQueue = null, h.memoizedState = null);
          }
          var A2 = (P.current & 1) !== 0, p2 = g2;
          do {
            var C;
            if (C = p2.tag === 13) {
              var x2 = p2.memoizedState;
              if (x2 !== null)
                C = x2.dehydrated !== null ? true : false;
              else {
                var w2 = p2.memoizedProps;
                C = w2.fallback === void 0 ? false : w2.unstable_avoidThisFallback !== true ? true : A2 ? false : true;
              }
            }
            if (C) {
              var z2 = p2.updateQueue;
              if (z2 === null) {
                var u = /* @__PURE__ */ new Set();
                u.add(l2);
                p2.updateQueue = u;
              } else
                z2.add(l2);
              if ((p2.mode & 2) === 0) {
                p2.flags |= 64;
                h.flags |= 16384;
                h.flags &= -2981;
                if (h.tag === 1)
                  if (h.alternate === null)
                    h.tag = 17;
                  else {
                    var t2 = zg(-1, 1);
                    t2.tag = 2;
                    Ag(h, t2);
                  }
                h.lanes |= 1;
                break a;
              }
              k2 = void 0;
              h = b2;
              var q2 = f2.pingCache;
              q2 === null ? (q2 = f2.pingCache = new Oi(), k2 = /* @__PURE__ */ new Set(), q2.set(l2, k2)) : (k2 = q2.get(l2), k2 === void 0 && (k2 = /* @__PURE__ */ new Set(), q2.set(l2, k2)));
              if (!k2.has(h)) {
                k2.add(h);
                var v4 = Yj.bind(null, f2, l2, h);
                l2.then(v4, v4);
              }
              p2.flags |= 4096;
              p2.lanes = b2;
              break a;
            }
            p2 = p2.return;
          } while (p2 !== null);
          k2 = Error((Ra(h.type) || "A React component") + " suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display.");
        }
        V !== 5 && (V = 2);
        k2 = Mi(k2, h);
        p2 = g2;
        do {
          switch (p2.tag) {
            case 3:
              f2 = k2;
              p2.flags |= 4096;
              b2 &= -b2;
              p2.lanes |= b2;
              var J = Pi(p2, f2, b2);
              Bg(p2, J);
              break a;
            case 1:
              f2 = k2;
              var K = p2.type, Q = p2.stateNode;
              if ((p2.flags & 64) === 0 && (typeof K.getDerivedStateFromError === "function" || Q !== null && typeof Q.componentDidCatch === "function" && (Ti === null || !Ti.has(Q)))) {
                p2.flags |= 4096;
                b2 &= -b2;
                p2.lanes |= b2;
                var L = Si(p2, f2, b2);
                Bg(p2, L);
                break a;
              }
          }
          p2 = p2.return;
        } while (p2 !== null);
      }
      Zj(c2);
    } catch (va) {
      b2 = va;
      Y === c2 && c2 !== null && (Y = c2 = c2.return);
      continue;
    }
    break;
  } while (1);
}
function Pj() {
  var a = oj.current;
  oj.current = Gh;
  return a === null ? Gh : a;
}
function Tj(a, b2) {
  var c2 = X;
  X |= 16;
  var d2 = Pj();
  U === a && W === b2 || Qj(a, b2);
  do
    try {
      ak();
      break;
    } catch (e2) {
      Sj(a, e2);
    }
  while (1);
  qg();
  X = c2;
  oj.current = d2;
  if (Y !== null)
    throw Error(y$1(261));
  U = null;
  W = 0;
  return V;
}
function ak() {
  for (; Y !== null; )
    bk(Y);
}
function Rj() {
  for (; Y !== null && !Qf(); )
    bk(Y);
}
function bk(a) {
  var b2 = ck(a.alternate, a, qj);
  a.memoizedProps = a.pendingProps;
  b2 === null ? Zj(a) : Y = b2;
  pj.current = null;
}
function Zj(a) {
  var b2 = a;
  do {
    var c2 = b2.alternate;
    a = b2.return;
    if ((b2.flags & 2048) === 0) {
      c2 = Gi(c2, b2, qj);
      if (c2 !== null) {
        Y = c2;
        return;
      }
      c2 = b2;
      if (c2.tag !== 24 && c2.tag !== 23 || c2.memoizedState === null || (qj & 1073741824) !== 0 || (c2.mode & 4) === 0) {
        for (var d2 = 0, e2 = c2.child; e2 !== null; )
          d2 |= e2.lanes | e2.childLanes, e2 = e2.sibling;
        c2.childLanes = d2;
      }
      a !== null && (a.flags & 2048) === 0 && (a.firstEffect === null && (a.firstEffect = b2.firstEffect), b2.lastEffect !== null && (a.lastEffect !== null && (a.lastEffect.nextEffect = b2.firstEffect), a.lastEffect = b2.lastEffect), 1 < b2.flags && (a.lastEffect !== null ? a.lastEffect.nextEffect = b2 : a.firstEffect = b2, a.lastEffect = b2));
    } else {
      c2 = Li(b2);
      if (c2 !== null) {
        c2.flags &= 2047;
        Y = c2;
        return;
      }
      a !== null && (a.firstEffect = a.lastEffect = null, a.flags |= 2048);
    }
    b2 = b2.sibling;
    if (b2 !== null) {
      Y = b2;
      return;
    }
    Y = b2 = a;
  } while (b2 !== null);
  V === 0 && (V = 5);
}
function Uj(a) {
  var b2 = eg();
  gg(99, dk.bind(null, a, b2));
  return null;
}
function dk(a, b2) {
  do
    Oj();
  while (yj !== null);
  if ((X & 48) !== 0)
    throw Error(y$1(327));
  var c2 = a.finishedWork;
  if (c2 === null)
    return null;
  a.finishedWork = null;
  a.finishedLanes = 0;
  if (c2 === a.current)
    throw Error(y$1(177));
  a.callbackNode = null;
  var d2 = c2.lanes | c2.childLanes, e2 = d2, f2 = a.pendingLanes & ~e2;
  a.pendingLanes = e2;
  a.suspendedLanes = 0;
  a.pingedLanes = 0;
  a.expiredLanes &= e2;
  a.mutableReadLanes &= e2;
  a.entangledLanes &= e2;
  e2 = a.entanglements;
  for (var g2 = a.eventTimes, h = a.expirationTimes; 0 < f2; ) {
    var k2 = 31 - Vc(f2), l2 = 1 << k2;
    e2[k2] = 0;
    g2[k2] = -1;
    h[k2] = -1;
    f2 &= ~l2;
  }
  Cj !== null && (d2 & 24) === 0 && Cj.has(a) && Cj.delete(a);
  a === U && (Y = U = null, W = 0);
  1 < c2.flags ? c2.lastEffect !== null ? (c2.lastEffect.nextEffect = c2, d2 = c2.firstEffect) : d2 = c2 : d2 = c2.firstEffect;
  if (d2 !== null) {
    e2 = X;
    X |= 32;
    pj.current = null;
    kf = fd;
    g2 = Ne();
    if (Oe(g2)) {
      if ("selectionStart" in g2)
        h = { start: g2.selectionStart, end: g2.selectionEnd };
      else
        a:
          if (h = (h = g2.ownerDocument) && h.defaultView || window, (l2 = h.getSelection && h.getSelection()) && l2.rangeCount !== 0) {
            h = l2.anchorNode;
            f2 = l2.anchorOffset;
            k2 = l2.focusNode;
            l2 = l2.focusOffset;
            try {
              h.nodeType, k2.nodeType;
            } catch (va) {
              h = null;
              break a;
            }
            var n2 = 0, A2 = -1, p2 = -1, C = 0, x2 = 0, w2 = g2, z2 = null;
            b:
              for (; ; ) {
                for (var u; ; ) {
                  w2 !== h || f2 !== 0 && w2.nodeType !== 3 || (A2 = n2 + f2);
                  w2 !== k2 || l2 !== 0 && w2.nodeType !== 3 || (p2 = n2 + l2);
                  w2.nodeType === 3 && (n2 += w2.nodeValue.length);
                  if ((u = w2.firstChild) === null)
                    break;
                  z2 = w2;
                  w2 = u;
                }
                for (; ; ) {
                  if (w2 === g2)
                    break b;
                  z2 === h && ++C === f2 && (A2 = n2);
                  z2 === k2 && ++x2 === l2 && (p2 = n2);
                  if ((u = w2.nextSibling) !== null)
                    break;
                  w2 = z2;
                  z2 = w2.parentNode;
                }
                w2 = u;
              }
            h = A2 === -1 || p2 === -1 ? null : { start: A2, end: p2 };
          } else
            h = null;
      h = h || { start: 0, end: 0 };
    } else
      h = null;
    lf = { focusedElem: g2, selectionRange: h };
    fd = false;
    Ij = null;
    Jj = false;
    Z = d2;
    do
      try {
        ek();
      } catch (va) {
        if (Z === null)
          throw Error(y$1(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    Ij = null;
    Z = d2;
    do
      try {
        for (g2 = a; Z !== null; ) {
          var t2 = Z.flags;
          t2 & 16 && pb(Z.stateNode, "");
          if (t2 & 128) {
            var q2 = Z.alternate;
            if (q2 !== null) {
              var v4 = q2.ref;
              v4 !== null && (typeof v4 === "function" ? v4(null) : v4.current = null);
            }
          }
          switch (t2 & 1038) {
            case 2:
              fj(Z);
              Z.flags &= -3;
              break;
            case 6:
              fj(Z);
              Z.flags &= -3;
              ij(Z.alternate, Z);
              break;
            case 1024:
              Z.flags &= -1025;
              break;
            case 1028:
              Z.flags &= -1025;
              ij(Z.alternate, Z);
              break;
            case 4:
              ij(Z.alternate, Z);
              break;
            case 8:
              h = Z;
              cj(g2, h);
              var J = h.alternate;
              dj(h);
              J !== null && dj(J);
          }
          Z = Z.nextEffect;
        }
      } catch (va) {
        if (Z === null)
          throw Error(y$1(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    v4 = lf;
    q2 = Ne();
    t2 = v4.focusedElem;
    g2 = v4.selectionRange;
    if (q2 !== t2 && t2 && t2.ownerDocument && Me(t2.ownerDocument.documentElement, t2)) {
      g2 !== null && Oe(t2) && (q2 = g2.start, v4 = g2.end, v4 === void 0 && (v4 = q2), "selectionStart" in t2 ? (t2.selectionStart = q2, t2.selectionEnd = Math.min(v4, t2.value.length)) : (v4 = (q2 = t2.ownerDocument || document) && q2.defaultView || window, v4.getSelection && (v4 = v4.getSelection(), h = t2.textContent.length, J = Math.min(g2.start, h), g2 = g2.end === void 0 ? J : Math.min(g2.end, h), !v4.extend && J > g2 && (h = g2, g2 = J, J = h), h = Le(t2, J), f2 = Le(t2, g2), h && f2 && (v4.rangeCount !== 1 || v4.anchorNode !== h.node || v4.anchorOffset !== h.offset || v4.focusNode !== f2.node || v4.focusOffset !== f2.offset) && (q2 = q2.createRange(), q2.setStart(h.node, h.offset), v4.removeAllRanges(), J > g2 ? (v4.addRange(q2), v4.extend(f2.node, f2.offset)) : (q2.setEnd(f2.node, f2.offset), v4.addRange(q2))))));
      q2 = [];
      for (v4 = t2; v4 = v4.parentNode; )
        v4.nodeType === 1 && q2.push({ element: v4, left: v4.scrollLeft, top: v4.scrollTop });
      typeof t2.focus === "function" && t2.focus();
      for (t2 = 0; t2 < q2.length; t2++)
        v4 = q2[t2], v4.element.scrollLeft = v4.left, v4.element.scrollTop = v4.top;
    }
    fd = !!kf;
    lf = kf = null;
    a.current = c2;
    Z = d2;
    do
      try {
        for (t2 = a; Z !== null; ) {
          var K = Z.flags;
          K & 36 && Yi(t2, Z.alternate, Z);
          if (K & 128) {
            q2 = void 0;
            var Q = Z.ref;
            if (Q !== null) {
              var L = Z.stateNode;
              switch (Z.tag) {
                case 5:
                  q2 = L;
                  break;
                default:
                  q2 = L;
              }
              typeof Q === "function" ? Q(q2) : Q.current = q2;
            }
          }
          Z = Z.nextEffect;
        }
      } catch (va) {
        if (Z === null)
          throw Error(y$1(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    Z = null;
    $f();
    X = e2;
  } else
    a.current = c2;
  if (xj)
    xj = false, yj = a, zj = b2;
  else
    for (Z = d2; Z !== null; )
      b2 = Z.nextEffect, Z.nextEffect = null, Z.flags & 8 && (K = Z, K.sibling = null, K.stateNode = null), Z = b2;
  d2 = a.pendingLanes;
  d2 === 0 && (Ti = null);
  d2 === 1 ? a === Ej ? Dj++ : (Dj = 0, Ej = a) : Dj = 0;
  c2 = c2.stateNode;
  if (Mf && typeof Mf.onCommitFiberRoot === "function")
    try {
      Mf.onCommitFiberRoot(Lf, c2, void 0, (c2.current.flags & 64) === 64);
    } catch (va) {
    }
  Mj(a, O());
  if (Qi)
    throw Qi = false, a = Ri, Ri = null, a;
  if ((X & 8) !== 0)
    return null;
  ig();
  return null;
}
function ek() {
  for (; Z !== null; ) {
    var a = Z.alternate;
    Jj || Ij === null || ((Z.flags & 8) !== 0 ? dc(Z, Ij) && (Jj = true) : Z.tag === 13 && mj(a, Z) && dc(Z, Ij) && (Jj = true));
    var b2 = Z.flags;
    (b2 & 256) !== 0 && Xi(a, Z);
    (b2 & 512) === 0 || xj || (xj = true, hg(97, function() {
      Oj();
      return null;
    }));
    Z = Z.nextEffect;
  }
}
function Oj() {
  if (zj !== 90) {
    var a = 97 < zj ? 97 : zj;
    zj = 90;
    return gg(a, fk);
  }
  return false;
}
function $i(a, b2) {
  Aj.push(b2, a);
  xj || (xj = true, hg(97, function() {
    Oj();
    return null;
  }));
}
function Zi(a, b2) {
  Bj.push(b2, a);
  xj || (xj = true, hg(97, function() {
    Oj();
    return null;
  }));
}
function fk() {
  if (yj === null)
    return false;
  var a = yj;
  yj = null;
  if ((X & 48) !== 0)
    throw Error(y$1(331));
  var b2 = X;
  X |= 32;
  var c2 = Bj;
  Bj = [];
  for (var d2 = 0; d2 < c2.length; d2 += 2) {
    var e2 = c2[d2], f2 = c2[d2 + 1], g2 = e2.destroy;
    e2.destroy = void 0;
    if (typeof g2 === "function")
      try {
        g2();
      } catch (k2) {
        if (f2 === null)
          throw Error(y$1(330));
        Wi(f2, k2);
      }
  }
  c2 = Aj;
  Aj = [];
  for (d2 = 0; d2 < c2.length; d2 += 2) {
    e2 = c2[d2];
    f2 = c2[d2 + 1];
    try {
      var h = e2.create;
      e2.destroy = h();
    } catch (k2) {
      if (f2 === null)
        throw Error(y$1(330));
      Wi(f2, k2);
    }
  }
  for (h = a.current.firstEffect; h !== null; )
    a = h.nextEffect, h.nextEffect = null, h.flags & 8 && (h.sibling = null, h.stateNode = null), h = a;
  X = b2;
  ig();
  return true;
}
function gk(a, b2, c2) {
  b2 = Mi(c2, b2);
  b2 = Pi(a, b2, 1);
  Ag(a, b2);
  b2 = Hg();
  a = Kj(a, 1);
  a !== null && ($c(a, 1, b2), Mj(a, b2));
}
function Wi(a, b2) {
  if (a.tag === 3)
    gk(a, a, b2);
  else
    for (var c2 = a.return; c2 !== null; ) {
      if (c2.tag === 3) {
        gk(c2, a, b2);
        break;
      } else if (c2.tag === 1) {
        var d2 = c2.stateNode;
        if (typeof c2.type.getDerivedStateFromError === "function" || typeof d2.componentDidCatch === "function" && (Ti === null || !Ti.has(d2))) {
          a = Mi(b2, a);
          var e2 = Si(c2, a, 1);
          Ag(c2, e2);
          e2 = Hg();
          c2 = Kj(c2, 1);
          if (c2 !== null)
            $c(c2, 1, e2), Mj(c2, e2);
          else if (typeof d2.componentDidCatch === "function" && (Ti === null || !Ti.has(d2)))
            try {
              d2.componentDidCatch(b2, a);
            } catch (f2) {
            }
          break;
        }
      }
      c2 = c2.return;
    }
}
function Yj(a, b2, c2) {
  var d2 = a.pingCache;
  d2 !== null && d2.delete(b2);
  b2 = Hg();
  a.pingedLanes |= a.suspendedLanes & c2;
  U === a && (W & c2) === c2 && (V === 4 || V === 3 && (W & 62914560) === W && 500 > O() - jj ? Qj(a, 0) : uj |= c2);
  Mj(a, b2);
}
function lj(a, b2) {
  var c2 = a.stateNode;
  c2 !== null && c2.delete(b2);
  b2 = 0;
  b2 === 0 && (b2 = a.mode, (b2 & 2) === 0 ? b2 = 1 : (b2 & 4) === 0 ? b2 = eg() === 99 ? 1 : 2 : (Gj === 0 && (Gj = tj), b2 = Yc(62914560 & ~Gj), b2 === 0 && (b2 = 4194304)));
  c2 = Hg();
  a = Kj(a, b2);
  a !== null && ($c(a, b2, c2), Mj(a, c2));
}
var ck;
ck = function(a, b2, c2) {
  var d2 = b2.lanes;
  if (a !== null)
    if (a.memoizedProps !== b2.pendingProps || N.current)
      ug = true;
    else if ((c2 & d2) !== 0)
      ug = (a.flags & 16384) !== 0 ? true : false;
    else {
      ug = false;
      switch (b2.tag) {
        case 3:
          ri(b2);
          sh();
          break;
        case 5:
          gh(b2);
          break;
        case 1:
          Ff(b2.type) && Jf(b2);
          break;
        case 4:
          eh(b2, b2.stateNode.containerInfo);
          break;
        case 10:
          d2 = b2.memoizedProps.value;
          var e2 = b2.type._context;
          I(mg, e2._currentValue);
          e2._currentValue = d2;
          break;
        case 13:
          if (b2.memoizedState !== null) {
            if ((c2 & b2.child.childLanes) !== 0)
              return ti(a, b2, c2);
            I(P, P.current & 1);
            b2 = hi(a, b2, c2);
            return b2 !== null ? b2.sibling : null;
          }
          I(P, P.current & 1);
          break;
        case 19:
          d2 = (c2 & b2.childLanes) !== 0;
          if ((a.flags & 64) !== 0) {
            if (d2)
              return Ai(a, b2, c2);
            b2.flags |= 64;
          }
          e2 = b2.memoizedState;
          e2 !== null && (e2.rendering = null, e2.tail = null, e2.lastEffect = null);
          I(P, P.current);
          if (d2)
            break;
          else
            return null;
        case 23:
        case 24:
          return b2.lanes = 0, mi(a, b2, c2);
      }
      return hi(a, b2, c2);
    }
  else
    ug = false;
  b2.lanes = 0;
  switch (b2.tag) {
    case 2:
      d2 = b2.type;
      a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2);
      a = b2.pendingProps;
      e2 = Ef(b2, M.current);
      tg(b2, c2);
      e2 = Ch(null, b2, d2, a, e2, c2);
      b2.flags |= 1;
      if (typeof e2 === "object" && e2 !== null && typeof e2.render === "function" && e2.$$typeof === void 0) {
        b2.tag = 1;
        b2.memoizedState = null;
        b2.updateQueue = null;
        if (Ff(d2)) {
          var f2 = true;
          Jf(b2);
        } else
          f2 = false;
        b2.memoizedState = e2.state !== null && e2.state !== void 0 ? e2.state : null;
        xg(b2);
        var g2 = d2.getDerivedStateFromProps;
        typeof g2 === "function" && Gg(b2, d2, g2, a);
        e2.updater = Kg;
        b2.stateNode = e2;
        e2._reactInternals = b2;
        Og(b2, d2, a, c2);
        b2 = qi(null, b2, d2, true, f2, c2);
      } else
        b2.tag = 0, fi(null, b2, e2, c2), b2 = b2.child;
      return b2;
    case 16:
      e2 = b2.elementType;
      a: {
        a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2);
        a = b2.pendingProps;
        f2 = e2._init;
        e2 = f2(e2._payload);
        b2.type = e2;
        f2 = b2.tag = hk(e2);
        a = lg(e2, a);
        switch (f2) {
          case 0:
            b2 = li(null, b2, e2, a, c2);
            break a;
          case 1:
            b2 = pi(null, b2, e2, a, c2);
            break a;
          case 11:
            b2 = gi(null, b2, e2, a, c2);
            break a;
          case 14:
            b2 = ii(null, b2, e2, lg(e2.type, a), d2, c2);
            break a;
        }
        throw Error(y$1(306, e2, ""));
      }
      return b2;
    case 0:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), li(a, b2, d2, e2, c2);
    case 1:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), pi(a, b2, d2, e2, c2);
    case 3:
      ri(b2);
      d2 = b2.updateQueue;
      if (a === null || d2 === null)
        throw Error(y$1(282));
      d2 = b2.pendingProps;
      e2 = b2.memoizedState;
      e2 = e2 !== null ? e2.element : null;
      yg(a, b2);
      Cg(b2, d2, null, c2);
      d2 = b2.memoizedState.element;
      if (d2 === e2)
        sh(), b2 = hi(a, b2, c2);
      else {
        e2 = b2.stateNode;
        if (f2 = e2.hydrate)
          kh = rf(b2.stateNode.containerInfo.firstChild), jh = b2, f2 = lh = true;
        if (f2) {
          a = e2.mutableSourceEagerHydrationData;
          if (a != null)
            for (e2 = 0; e2 < a.length; e2 += 2)
              f2 = a[e2], f2._workInProgressVersionPrimary = a[e2 + 1], th.push(f2);
          c2 = Zg(b2, null, d2, c2);
          for (b2.child = c2; c2; )
            c2.flags = c2.flags & -3 | 1024, c2 = c2.sibling;
        } else
          fi(a, b2, d2, c2), sh();
        b2 = b2.child;
      }
      return b2;
    case 5:
      return gh(b2), a === null && ph(b2), d2 = b2.type, e2 = b2.pendingProps, f2 = a !== null ? a.memoizedProps : null, g2 = e2.children, nf(d2, e2) ? g2 = null : f2 !== null && nf(d2, f2) && (b2.flags |= 16), oi(a, b2), fi(a, b2, g2, c2), b2.child;
    case 6:
      return a === null && ph(b2), null;
    case 13:
      return ti(a, b2, c2);
    case 4:
      return eh(b2, b2.stateNode.containerInfo), d2 = b2.pendingProps, a === null ? b2.child = Yg(b2, null, d2, c2) : fi(a, b2, d2, c2), b2.child;
    case 11:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), gi(a, b2, d2, e2, c2);
    case 7:
      return fi(a, b2, b2.pendingProps, c2), b2.child;
    case 8:
      return fi(a, b2, b2.pendingProps.children, c2), b2.child;
    case 12:
      return fi(a, b2, b2.pendingProps.children, c2), b2.child;
    case 10:
      a: {
        d2 = b2.type._context;
        e2 = b2.pendingProps;
        g2 = b2.memoizedProps;
        f2 = e2.value;
        var h = b2.type._context;
        I(mg, h._currentValue);
        h._currentValue = f2;
        if (g2 !== null)
          if (h = g2.value, f2 = He(h, f2) ? 0 : (typeof d2._calculateChangedBits === "function" ? d2._calculateChangedBits(h, f2) : 1073741823) | 0, f2 === 0) {
            if (g2.children === e2.children && !N.current) {
              b2 = hi(a, b2, c2);
              break a;
            }
          } else
            for (h = b2.child, h !== null && (h.return = b2); h !== null; ) {
              var k2 = h.dependencies;
              if (k2 !== null) {
                g2 = h.child;
                for (var l2 = k2.firstContext; l2 !== null; ) {
                  if (l2.context === d2 && (l2.observedBits & f2) !== 0) {
                    h.tag === 1 && (l2 = zg(-1, c2 & -c2), l2.tag = 2, Ag(h, l2));
                    h.lanes |= c2;
                    l2 = h.alternate;
                    l2 !== null && (l2.lanes |= c2);
                    sg(h.return, c2);
                    k2.lanes |= c2;
                    break;
                  }
                  l2 = l2.next;
                }
              } else
                g2 = h.tag === 10 ? h.type === b2.type ? null : h.child : h.child;
              if (g2 !== null)
                g2.return = h;
              else
                for (g2 = h; g2 !== null; ) {
                  if (g2 === b2) {
                    g2 = null;
                    break;
                  }
                  h = g2.sibling;
                  if (h !== null) {
                    h.return = g2.return;
                    g2 = h;
                    break;
                  }
                  g2 = g2.return;
                }
              h = g2;
            }
        fi(a, b2, e2.children, c2);
        b2 = b2.child;
      }
      return b2;
    case 9:
      return e2 = b2.type, f2 = b2.pendingProps, d2 = f2.children, tg(b2, c2), e2 = vg(e2, f2.unstable_observedBits), d2 = d2(e2), b2.flags |= 1, fi(a, b2, d2, c2), b2.child;
    case 14:
      return e2 = b2.type, f2 = lg(e2, b2.pendingProps), f2 = lg(e2.type, f2), ii(a, b2, e2, f2, d2, c2);
    case 15:
      return ki(a, b2, b2.type, b2.pendingProps, d2, c2);
    case 17:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2), b2.tag = 1, Ff(d2) ? (a = true, Jf(b2)) : a = false, tg(b2, c2), Mg(b2, d2, e2), Og(b2, d2, e2, c2), qi(null, b2, d2, true, a, c2);
    case 19:
      return Ai(a, b2, c2);
    case 23:
      return mi(a, b2, c2);
    case 24:
      return mi(a, b2, c2);
  }
  throw Error(y$1(156, b2.tag));
};
function ik(a, b2, c2, d2) {
  this.tag = a;
  this.key = c2;
  this.sibling = this.child = this.return = this.stateNode = this.type = this.elementType = null;
  this.index = 0;
  this.ref = null;
  this.pendingProps = b2;
  this.dependencies = this.memoizedState = this.updateQueue = this.memoizedProps = null;
  this.mode = d2;
  this.flags = 0;
  this.lastEffect = this.firstEffect = this.nextEffect = null;
  this.childLanes = this.lanes = 0;
  this.alternate = null;
}
function nh(a, b2, c2, d2) {
  return new ik(a, b2, c2, d2);
}
function ji(a) {
  a = a.prototype;
  return !(!a || !a.isReactComponent);
}
function hk(a) {
  if (typeof a === "function")
    return ji(a) ? 1 : 0;
  if (a !== void 0 && a !== null) {
    a = a.$$typeof;
    if (a === Aa)
      return 11;
    if (a === Da)
      return 14;
  }
  return 2;
}
function Tg(a, b2) {
  var c2 = a.alternate;
  c2 === null ? (c2 = nh(a.tag, b2, a.key, a.mode), c2.elementType = a.elementType, c2.type = a.type, c2.stateNode = a.stateNode, c2.alternate = a, a.alternate = c2) : (c2.pendingProps = b2, c2.type = a.type, c2.flags = 0, c2.nextEffect = null, c2.firstEffect = null, c2.lastEffect = null);
  c2.childLanes = a.childLanes;
  c2.lanes = a.lanes;
  c2.child = a.child;
  c2.memoizedProps = a.memoizedProps;
  c2.memoizedState = a.memoizedState;
  c2.updateQueue = a.updateQueue;
  b2 = a.dependencies;
  c2.dependencies = b2 === null ? null : { lanes: b2.lanes, firstContext: b2.firstContext };
  c2.sibling = a.sibling;
  c2.index = a.index;
  c2.ref = a.ref;
  return c2;
}
function Vg(a, b2, c2, d2, e2, f2) {
  var g2 = 2;
  d2 = a;
  if (typeof a === "function")
    ji(a) && (g2 = 1);
  else if (typeof a === "string")
    g2 = 5;
  else
    a:
      switch (a) {
        case ua:
          return Xg(c2.children, e2, f2, b2);
        case Ha:
          g2 = 8;
          e2 |= 16;
          break;
        case wa:
          g2 = 8;
          e2 |= 1;
          break;
        case xa:
          return a = nh(12, c2, b2, e2 | 8), a.elementType = xa, a.type = xa, a.lanes = f2, a;
        case Ba:
          return a = nh(13, c2, b2, e2), a.type = Ba, a.elementType = Ba, a.lanes = f2, a;
        case Ca:
          return a = nh(19, c2, b2, e2), a.elementType = Ca, a.lanes = f2, a;
        case Ia:
          return vi(c2, e2, f2, b2);
        case Ja:
          return a = nh(24, c2, b2, e2), a.elementType = Ja, a.lanes = f2, a;
        default:
          if (typeof a === "object" && a !== null)
            switch (a.$$typeof) {
              case ya:
                g2 = 10;
                break a;
              case za:
                g2 = 9;
                break a;
              case Aa:
                g2 = 11;
                break a;
              case Da:
                g2 = 14;
                break a;
              case Ea:
                g2 = 16;
                d2 = null;
                break a;
              case Fa:
                g2 = 22;
                break a;
            }
          throw Error(y$1(130, a == null ? a : typeof a, ""));
      }
  b2 = nh(g2, c2, b2, e2);
  b2.elementType = a;
  b2.type = d2;
  b2.lanes = f2;
  return b2;
}
function Xg(a, b2, c2, d2) {
  a = nh(7, a, d2, b2);
  a.lanes = c2;
  return a;
}
function vi(a, b2, c2, d2) {
  a = nh(23, a, d2, b2);
  a.elementType = Ia;
  a.lanes = c2;
  return a;
}
function Ug(a, b2, c2) {
  a = nh(6, a, null, b2);
  a.lanes = c2;
  return a;
}
function Wg(a, b2, c2) {
  b2 = nh(4, a.children !== null ? a.children : [], a.key, b2);
  b2.lanes = c2;
  b2.stateNode = { containerInfo: a.containerInfo, pendingChildren: null, implementation: a.implementation };
  return b2;
}
function jk(a, b2, c2) {
  this.tag = b2;
  this.containerInfo = a;
  this.finishedWork = this.pingCache = this.current = this.pendingChildren = null;
  this.timeoutHandle = -1;
  this.pendingContext = this.context = null;
  this.hydrate = c2;
  this.callbackNode = null;
  this.callbackPriority = 0;
  this.eventTimes = Zc(0);
  this.expirationTimes = Zc(-1);
  this.entangledLanes = this.finishedLanes = this.mutableReadLanes = this.expiredLanes = this.pingedLanes = this.suspendedLanes = this.pendingLanes = 0;
  this.entanglements = Zc(0);
  this.mutableSourceEagerHydrationData = null;
}
function kk(a, b2, c2) {
  var d2 = 3 < arguments.length && arguments[3] !== void 0 ? arguments[3] : null;
  return { $$typeof: ta, key: d2 == null ? null : "" + d2, children: a, containerInfo: b2, implementation: c2 };
}
function lk(a, b2, c2, d2) {
  var e2 = b2.current, f2 = Hg(), g2 = Ig(e2);
  a:
    if (c2) {
      c2 = c2._reactInternals;
      b: {
        if (Zb(c2) !== c2 || c2.tag !== 1)
          throw Error(y$1(170));
        var h = c2;
        do {
          switch (h.tag) {
            case 3:
              h = h.stateNode.context;
              break b;
            case 1:
              if (Ff(h.type)) {
                h = h.stateNode.__reactInternalMemoizedMergedChildContext;
                break b;
              }
          }
          h = h.return;
        } while (h !== null);
        throw Error(y$1(171));
      }
      if (c2.tag === 1) {
        var k2 = c2.type;
        if (Ff(k2)) {
          c2 = If(c2, k2, h);
          break a;
        }
      }
      c2 = h;
    } else
      c2 = Cf;
  b2.context === null ? b2.context = c2 : b2.pendingContext = c2;
  b2 = zg(f2, g2);
  b2.payload = { element: a };
  d2 = d2 === void 0 ? null : d2;
  d2 !== null && (b2.callback = d2);
  Ag(e2, b2);
  Jg(e2, g2, f2);
  return g2;
}
function mk(a) {
  a = a.current;
  if (!a.child)
    return null;
  switch (a.child.tag) {
    case 5:
      return a.child.stateNode;
    default:
      return a.child.stateNode;
  }
}
function nk(a, b2) {
  a = a.memoizedState;
  if (a !== null && a.dehydrated !== null) {
    var c2 = a.retryLane;
    a.retryLane = c2 !== 0 && c2 < b2 ? c2 : b2;
  }
}
function ok(a, b2) {
  nk(a, b2);
  (a = a.alternate) && nk(a, b2);
}
function pk() {
  return null;
}
function qk(a, b2, c2) {
  var d2 = c2 != null && c2.hydrationOptions != null && c2.hydrationOptions.mutableSources || null;
  c2 = new jk(a, b2, c2 != null && c2.hydrate === true);
  b2 = nh(3, null, null, b2 === 2 ? 7 : b2 === 1 ? 3 : 0);
  c2.current = b2;
  b2.stateNode = c2;
  xg(b2);
  a[ff] = c2.current;
  cf(a.nodeType === 8 ? a.parentNode : a);
  if (d2)
    for (a = 0; a < d2.length; a++) {
      b2 = d2[a];
      var e2 = b2._getVersion;
      e2 = e2(b2._source);
      c2.mutableSourceEagerHydrationData == null ? c2.mutableSourceEagerHydrationData = [b2, e2] : c2.mutableSourceEagerHydrationData.push(b2, e2);
    }
  this._internalRoot = c2;
}
qk.prototype.render = function(a) {
  lk(a, this._internalRoot, null, null);
};
qk.prototype.unmount = function() {
  var a = this._internalRoot, b2 = a.containerInfo;
  lk(null, a, null, function() {
    b2[ff] = null;
  });
};
function rk(a) {
  return !(!a || a.nodeType !== 1 && a.nodeType !== 9 && a.nodeType !== 11 && (a.nodeType !== 8 || a.nodeValue !== " react-mount-point-unstable "));
}
function sk(a, b2) {
  b2 || (b2 = a ? a.nodeType === 9 ? a.documentElement : a.firstChild : null, b2 = !(!b2 || b2.nodeType !== 1 || !b2.hasAttribute("data-reactroot")));
  if (!b2)
    for (var c2; c2 = a.lastChild; )
      a.removeChild(c2);
  return new qk(a, 0, b2 ? { hydrate: true } : void 0);
}
function tk(a, b2, c2, d2, e2) {
  var f2 = c2._reactRootContainer;
  if (f2) {
    var g2 = f2._internalRoot;
    if (typeof e2 === "function") {
      var h = e2;
      e2 = function() {
        var a2 = mk(g2);
        h.call(a2);
      };
    }
    lk(b2, g2, a, e2);
  } else {
    f2 = c2._reactRootContainer = sk(c2, d2);
    g2 = f2._internalRoot;
    if (typeof e2 === "function") {
      var k2 = e2;
      e2 = function() {
        var a2 = mk(g2);
        k2.call(a2);
      };
    }
    Xj(function() {
      lk(b2, g2, a, e2);
    });
  }
  return mk(g2);
}
ec = function(a) {
  if (a.tag === 13) {
    var b2 = Hg();
    Jg(a, 4, b2);
    ok(a, 4);
  }
};
fc = function(a) {
  if (a.tag === 13) {
    var b2 = Hg();
    Jg(a, 67108864, b2);
    ok(a, 67108864);
  }
};
gc = function(a) {
  if (a.tag === 13) {
    var b2 = Hg(), c2 = Ig(a);
    Jg(a, c2, b2);
    ok(a, c2);
  }
};
hc = function(a, b2) {
  return b2();
};
yb = function(a, b2, c2) {
  switch (b2) {
    case "input":
      ab(a, c2);
      b2 = c2.name;
      if (c2.type === "radio" && b2 != null) {
        for (c2 = a; c2.parentNode; )
          c2 = c2.parentNode;
        c2 = c2.querySelectorAll("input[name=" + JSON.stringify("" + b2) + '][type="radio"]');
        for (b2 = 0; b2 < c2.length; b2++) {
          var d2 = c2[b2];
          if (d2 !== a && d2.form === a.form) {
            var e2 = Db(d2);
            if (!e2)
              throw Error(y$1(90));
            Wa(d2);
            ab(d2, e2);
          }
        }
      }
      break;
    case "textarea":
      ib(a, c2);
      break;
    case "select":
      b2 = c2.value, b2 != null && fb(a, !!c2.multiple, b2, false);
  }
};
Gb = Wj;
Hb = function(a, b2, c2, d2, e2) {
  var f2 = X;
  X |= 4;
  try {
    return gg(98, a.bind(null, b2, c2, d2, e2));
  } finally {
    X = f2, X === 0 && (wj(), ig());
  }
};
Ib = function() {
  (X & 49) === 0 && (Vj(), Oj());
};
Jb = function(a, b2) {
  var c2 = X;
  X |= 2;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
};
function uk(a, b2) {
  var c2 = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : null;
  if (!rk(b2))
    throw Error(y$1(200));
  return kk(a, b2, null, c2);
}
var vk = { Events: [Cb, ue, Db, Eb, Fb, Oj, { current: false }] }, wk = { findFiberByHostInstance: wc, bundleType: 0, version: "17.0.2", rendererPackageName: "react-dom" };
var xk = { bundleType: wk.bundleType, version: wk.version, rendererPackageName: wk.rendererPackageName, rendererConfig: wk.rendererConfig, overrideHookState: null, overrideHookStateDeletePath: null, overrideHookStateRenamePath: null, overrideProps: null, overridePropsDeletePath: null, overridePropsRenamePath: null, setSuspenseHandler: null, scheduleUpdate: null, currentDispatcherRef: ra.ReactCurrentDispatcher, findHostInstanceByFiber: function(a) {
  a = cc(a);
  return a === null ? null : a.stateNode;
}, findFiberByHostInstance: wk.findFiberByHostInstance || pk, findHostInstancesForRefresh: null, scheduleRefresh: null, scheduleRoot: null, setRefreshHandler: null, getCurrentFiber: null };
if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined") {
  var yk = __REACT_DEVTOOLS_GLOBAL_HOOK__;
  if (!yk.isDisabled && yk.supportsFiber)
    try {
      Lf = yk.inject(xk), Mf = yk;
    } catch (a) {
    }
}
reactDom_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = vk;
reactDom_production_min.createPortal = uk;
reactDom_production_min.findDOMNode = function(a) {
  if (a == null)
    return null;
  if (a.nodeType === 1)
    return a;
  var b2 = a._reactInternals;
  if (b2 === void 0) {
    if (typeof a.render === "function")
      throw Error(y$1(188));
    throw Error(y$1(268, Object.keys(a)));
  }
  a = cc(b2);
  a = a === null ? null : a.stateNode;
  return a;
};
reactDom_production_min.flushSync = function(a, b2) {
  var c2 = X;
  if ((c2 & 48) !== 0)
    return a(b2);
  X |= 1;
  try {
    if (a)
      return gg(99, a.bind(null, b2));
  } finally {
    X = c2, ig();
  }
};
reactDom_production_min.hydrate = function(a, b2, c2) {
  if (!rk(b2))
    throw Error(y$1(200));
  return tk(null, a, b2, true, c2);
};
reactDom_production_min.render = function(a, b2, c2) {
  if (!rk(b2))
    throw Error(y$1(200));
  return tk(null, a, b2, false, c2);
};
reactDom_production_min.unmountComponentAtNode = function(a) {
  if (!rk(a))
    throw Error(y$1(40));
  return a._reactRootContainer ? (Xj(function() {
    tk(null, null, a, false, function() {
      a._reactRootContainer = null;
      a[ff] = null;
    });
  }), true) : false;
};
reactDom_production_min.unstable_batchedUpdates = Wj;
reactDom_production_min.unstable_createPortal = function(a, b2) {
  return uk(a, b2, 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : null);
};
reactDom_production_min.unstable_renderSubtreeIntoContainer = function(a, b2, c2, d2) {
  if (!rk(c2))
    throw Error(y$1(200));
  if (a == null || a._reactInternals === void 0)
    throw Error(y$1(38));
  return tk(a, b2, c2, false, d2);
};
reactDom_production_min.version = "17.0.2";
function checkDCE() {
  if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined" || typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE !== "function") {
    return;
  }
  try {
    __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
  } catch (err) {
    console.error(err);
  }
}
{
  checkDCE();
  reactDom.exports = reactDom_production_min;
}
var ReactDOM = reactDom.exports;
var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
var reservedWords = {
  3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",
  5: "class enum extends super const export import",
  6: "enum",
  strict: "implements interface let package private protected public static yield",
  strictBind: "eval arguments"
};
var ecma5AndLessKeywords = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this";
var keywords$1 = {
  5: ecma5AndLessKeywords,
  "5module": ecma5AndLessKeywords + " export import",
  6: ecma5AndLessKeywords + " const class extends export import super"
};
var keywordRelationalOperator = /^in(stanceof)?$/;
var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
function isInAstralSet(code2, set2) {
  var pos = 65536;
  for (var i = 0; i < set2.length; i += 2) {
    pos += set2[i];
    if (pos > code2) {
      return false;
    }
    pos += set2[i + 1];
    if (pos >= code2) {
      return true;
    }
  }
}
function isIdentifierStart(code2, astral) {
  if (code2 < 65) {
    return code2 === 36;
  }
  if (code2 < 91) {
    return true;
  }
  if (code2 < 97) {
    return code2 === 95;
  }
  if (code2 < 123) {
    return true;
  }
  if (code2 <= 65535) {
    return code2 >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code2));
  }
  if (astral === false) {
    return false;
  }
  return isInAstralSet(code2, astralIdentifierStartCodes);
}
function isIdentifierChar(code2, astral) {
  if (code2 < 48) {
    return code2 === 36;
  }
  if (code2 < 58) {
    return true;
  }
  if (code2 < 65) {
    return false;
  }
  if (code2 < 91) {
    return true;
  }
  if (code2 < 97) {
    return code2 === 95;
  }
  if (code2 < 123) {
    return true;
  }
  if (code2 <= 65535) {
    return code2 >= 170 && nonASCIIidentifier.test(String.fromCharCode(code2));
  }
  if (astral === false) {
    return false;
  }
  return isInAstralSet(code2, astralIdentifierStartCodes) || isInAstralSet(code2, astralIdentifierCodes);
}
var TokenType = function TokenType2(label, conf) {
  if (conf === void 0)
    conf = {};
  this.label = label;
  this.keyword = conf.keyword;
  this.beforeExpr = !!conf.beforeExpr;
  this.startsExpr = !!conf.startsExpr;
  this.isLoop = !!conf.isLoop;
  this.isAssign = !!conf.isAssign;
  this.prefix = !!conf.prefix;
  this.postfix = !!conf.postfix;
  this.binop = conf.binop || null;
  this.updateContext = null;
};
function binop(name2, prec) {
  return new TokenType(name2, { beforeExpr: true, binop: prec });
}
var beforeExpr = { beforeExpr: true }, startsExpr = { startsExpr: true };
var keywords = {};
function kw(name2, options) {
  if (options === void 0)
    options = {};
  options.keyword = name2;
  return keywords[name2] = new TokenType(name2, options);
}
var types$1 = {
  num: new TokenType("num", startsExpr),
  regexp: new TokenType("regexp", startsExpr),
  string: new TokenType("string", startsExpr),
  name: new TokenType("name", startsExpr),
  privateId: new TokenType("privateId", startsExpr),
  eof: new TokenType("eof"),
  bracketL: new TokenType("[", { beforeExpr: true, startsExpr: true }),
  bracketR: new TokenType("]"),
  braceL: new TokenType("{", { beforeExpr: true, startsExpr: true }),
  braceR: new TokenType("}"),
  parenL: new TokenType("(", { beforeExpr: true, startsExpr: true }),
  parenR: new TokenType(")"),
  comma: new TokenType(",", beforeExpr),
  semi: new TokenType(";", beforeExpr),
  colon: new TokenType(":", beforeExpr),
  dot: new TokenType("."),
  question: new TokenType("?", beforeExpr),
  questionDot: new TokenType("?."),
  arrow: new TokenType("=>", beforeExpr),
  template: new TokenType("template"),
  invalidTemplate: new TokenType("invalidTemplate"),
  ellipsis: new TokenType("...", beforeExpr),
  backQuote: new TokenType("`", startsExpr),
  dollarBraceL: new TokenType("${", { beforeExpr: true, startsExpr: true }),
  eq: new TokenType("=", { beforeExpr: true, isAssign: true }),
  assign: new TokenType("_=", { beforeExpr: true, isAssign: true }),
  incDec: new TokenType("++/--", { prefix: true, postfix: true, startsExpr: true }),
  prefix: new TokenType("!/~", { beforeExpr: true, prefix: true, startsExpr: true }),
  logicalOR: binop("||", 1),
  logicalAND: binop("&&", 2),
  bitwiseOR: binop("|", 3),
  bitwiseXOR: binop("^", 4),
  bitwiseAND: binop("&", 5),
  equality: binop("==/!=/===/!==", 6),
  relational: binop("</>/<=/>=", 7),
  bitShift: binop("<</>>/>>>", 8),
  plusMin: new TokenType("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }),
  modulo: binop("%", 10),
  star: binop("*", 10),
  slash: binop("/", 10),
  starstar: new TokenType("**", { beforeExpr: true }),
  coalesce: binop("??", 1),
  _break: kw("break"),
  _case: kw("case", beforeExpr),
  _catch: kw("catch"),
  _continue: kw("continue"),
  _debugger: kw("debugger"),
  _default: kw("default", beforeExpr),
  _do: kw("do", { isLoop: true, beforeExpr: true }),
  _else: kw("else", beforeExpr),
  _finally: kw("finally"),
  _for: kw("for", { isLoop: true }),
  _function: kw("function", startsExpr),
  _if: kw("if"),
  _return: kw("return", beforeExpr),
  _switch: kw("switch"),
  _throw: kw("throw", beforeExpr),
  _try: kw("try"),
  _var: kw("var"),
  _const: kw("const"),
  _while: kw("while", { isLoop: true }),
  _with: kw("with"),
  _new: kw("new", { beforeExpr: true, startsExpr: true }),
  _this: kw("this", startsExpr),
  _super: kw("super", startsExpr),
  _class: kw("class", startsExpr),
  _extends: kw("extends", beforeExpr),
  _export: kw("export"),
  _import: kw("import", startsExpr),
  _null: kw("null", startsExpr),
  _true: kw("true", startsExpr),
  _false: kw("false", startsExpr),
  _in: kw("in", { beforeExpr: true, binop: 7 }),
  _instanceof: kw("instanceof", { beforeExpr: true, binop: 7 }),
  _typeof: kw("typeof", { beforeExpr: true, prefix: true, startsExpr: true }),
  _void: kw("void", { beforeExpr: true, prefix: true, startsExpr: true }),
  _delete: kw("delete", { beforeExpr: true, prefix: true, startsExpr: true })
};
var lineBreak = /\r\n?|\n|\u2028|\u2029/;
var lineBreakG = new RegExp(lineBreak.source, "g");
function isNewLine(code2) {
  return code2 === 10 || code2 === 13 || code2 === 8232 || code2 === 8233;
}
function nextLineBreak(code2, from2, end2) {
  if (end2 === void 0)
    end2 = code2.length;
  for (var i = from2; i < end2; i++) {
    var next = code2.charCodeAt(i);
    if (isNewLine(next)) {
      return i < end2 - 1 && next === 13 && code2.charCodeAt(i + 1) === 10 ? i + 2 : i + 1;
    }
  }
  return -1;
}
var nonASCIIwhitespace = /[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/;
var skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
var ref = Object.prototype;
var hasOwnProperty$2 = ref.hasOwnProperty;
var toString = ref.toString;
var hasOwn = Object.hasOwn || function(obj, propName) {
  return hasOwnProperty$2.call(obj, propName);
};
var isArray = Array.isArray || function(obj) {
  return toString.call(obj) === "[object Array]";
};
function wordsRegexp(words) {
  return new RegExp("^(?:" + words.replace(/ /g, "|") + ")$");
}
function codePointToString(code2) {
  if (code2 <= 65535) {
    return String.fromCharCode(code2);
  }
  code2 -= 65536;
  return String.fromCharCode((code2 >> 10) + 55296, (code2 & 1023) + 56320);
}
var loneSurrogate = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/;
var Position = function Position2(line, col) {
  this.line = line;
  this.column = col;
};
Position.prototype.offset = function offset(n2) {
  return new Position(this.line, this.column + n2);
};
var SourceLocation = function SourceLocation2(p2, start2, end2) {
  this.start = start2;
  this.end = end2;
  if (p2.sourceFile !== null) {
    this.source = p2.sourceFile;
  }
};
function getLineInfo(input, offset3) {
  for (var line = 1, cur = 0; ; ) {
    var nextBreak = nextLineBreak(input, cur, offset3);
    if (nextBreak < 0) {
      return new Position(line, offset3 - cur);
    }
    ++line;
    cur = nextBreak;
  }
}
var defaultOptions = {
  ecmaVersion: null,
  sourceType: "script",
  onInsertedSemicolon: null,
  onTrailingComma: null,
  allowReserved: null,
  allowReturnOutsideFunction: false,
  allowImportExportEverywhere: false,
  allowAwaitOutsideFunction: null,
  allowSuperOutsideMethod: null,
  allowHashBang: false,
  locations: false,
  onToken: null,
  onComment: null,
  ranges: false,
  program: null,
  sourceFile: null,
  directSourceFile: null,
  preserveParens: false
};
var warnedAboutEcmaVersion = false;
function getOptions(opts) {
  var options = {};
  for (var opt in defaultOptions) {
    options[opt] = opts && hasOwn(opts, opt) ? opts[opt] : defaultOptions[opt];
  }
  if (options.ecmaVersion === "latest") {
    options.ecmaVersion = 1e8;
  } else if (options.ecmaVersion == null) {
    if (!warnedAboutEcmaVersion && typeof console === "object" && console.warn) {
      warnedAboutEcmaVersion = true;
      console.warn("Since Acorn 8.0.0, options.ecmaVersion is required.\nDefaulting to 2020, but this will stop working in the future.");
    }
    options.ecmaVersion = 11;
  } else if (options.ecmaVersion >= 2015) {
    options.ecmaVersion -= 2009;
  }
  if (options.allowReserved == null) {
    options.allowReserved = options.ecmaVersion < 5;
  }
  if (isArray(options.onToken)) {
    var tokens = options.onToken;
    options.onToken = function(token) {
      return tokens.push(token);
    };
  }
  if (isArray(options.onComment)) {
    options.onComment = pushComment(options, options.onComment);
  }
  return options;
}
function pushComment(options, array4) {
  return function(block, text, start2, end2, startLoc, endLoc) {
    var comment = {
      type: block ? "Block" : "Line",
      value: text,
      start: start2,
      end: end2
    };
    if (options.locations) {
      comment.loc = new SourceLocation(this, startLoc, endLoc);
    }
    if (options.ranges) {
      comment.range = [start2, end2];
    }
    array4.push(comment);
  };
}
var SCOPE_TOP = 1, SCOPE_FUNCTION = 2, SCOPE_ASYNC = 4, SCOPE_GENERATOR = 8, SCOPE_ARROW = 16, SCOPE_SIMPLE_CATCH = 32, SCOPE_SUPER = 64, SCOPE_DIRECT_SUPER = 128, SCOPE_CLASS_STATIC_BLOCK = 256, SCOPE_VAR = SCOPE_TOP | SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK;
function functionFlags(async, generator) {
  return SCOPE_FUNCTION | (async ? SCOPE_ASYNC : 0) | (generator ? SCOPE_GENERATOR : 0);
}
var BIND_NONE = 0, BIND_VAR = 1, BIND_LEXICAL = 2, BIND_FUNCTION = 3, BIND_SIMPLE_CATCH = 4, BIND_OUTSIDE = 5;
var Parser = function Parser2(options, input, startPos) {
  this.options = options = getOptions(options);
  this.sourceFile = options.sourceFile;
  this.keywords = wordsRegexp(keywords$1[options.ecmaVersion >= 6 ? 6 : options.sourceType === "module" ? "5module" : 5]);
  var reserved = "";
  if (options.allowReserved !== true) {
    reserved = reservedWords[options.ecmaVersion >= 6 ? 6 : options.ecmaVersion === 5 ? 5 : 3];
    if (options.sourceType === "module") {
      reserved += " await";
    }
  }
  this.reservedWords = wordsRegexp(reserved);
  var reservedStrict = (reserved ? reserved + " " : "") + reservedWords.strict;
  this.reservedWordsStrict = wordsRegexp(reservedStrict);
  this.reservedWordsStrictBind = wordsRegexp(reservedStrict + " " + reservedWords.strictBind);
  this.input = String(input);
  this.containsEsc = false;
  if (startPos) {
    this.pos = startPos;
    this.lineStart = this.input.lastIndexOf("\n", startPos - 1) + 1;
    this.curLine = this.input.slice(0, this.lineStart).split(lineBreak).length;
  } else {
    this.pos = this.lineStart = 0;
    this.curLine = 1;
  }
  this.type = types$1.eof;
  this.value = null;
  this.start = this.end = this.pos;
  this.startLoc = this.endLoc = this.curPosition();
  this.lastTokEndLoc = this.lastTokStartLoc = null;
  this.lastTokStart = this.lastTokEnd = this.pos;
  this.context = this.initialContext();
  this.exprAllowed = true;
  this.inModule = options.sourceType === "module";
  this.strict = this.inModule || this.strictDirective(this.pos);
  this.potentialArrowAt = -1;
  this.potentialArrowInForAwait = false;
  this.yieldPos = this.awaitPos = this.awaitIdentPos = 0;
  this.labels = [];
  this.undefinedExports = /* @__PURE__ */ Object.create(null);
  if (this.pos === 0 && options.allowHashBang && this.input.slice(0, 2) === "#!") {
    this.skipLineComment(2);
  }
  this.scopeStack = [];
  this.enterScope(SCOPE_TOP);
  this.regexpState = null;
  this.privateNameStack = [];
};
var prototypeAccessors = { inFunction: { configurable: true }, inGenerator: { configurable: true }, inAsync: { configurable: true }, canAwait: { configurable: true }, allowSuper: { configurable: true }, allowDirectSuper: { configurable: true }, treatFunctionsAsVar: { configurable: true }, allowNewDotTarget: { configurable: true }, inClassStaticBlock: { configurable: true } };
Parser.prototype.parse = function parse() {
  var node = this.options.program || this.startNode();
  this.nextToken();
  return this.parseTopLevel(node);
};
prototypeAccessors.inFunction.get = function() {
  return (this.currentVarScope().flags & SCOPE_FUNCTION) > 0;
};
prototypeAccessors.inGenerator.get = function() {
  return (this.currentVarScope().flags & SCOPE_GENERATOR) > 0 && !this.currentVarScope().inClassFieldInit;
};
prototypeAccessors.inAsync.get = function() {
  return (this.currentVarScope().flags & SCOPE_ASYNC) > 0 && !this.currentVarScope().inClassFieldInit;
};
prototypeAccessors.canAwait.get = function() {
  for (var i = this.scopeStack.length - 1; i >= 0; i--) {
    var scope = this.scopeStack[i];
    if (scope.inClassFieldInit || scope.flags & SCOPE_CLASS_STATIC_BLOCK) {
      return false;
    }
    if (scope.flags & SCOPE_FUNCTION) {
      return (scope.flags & SCOPE_ASYNC) > 0;
    }
  }
  return this.inModule && this.options.ecmaVersion >= 13 || this.options.allowAwaitOutsideFunction;
};
prototypeAccessors.allowSuper.get = function() {
  var ref2 = this.currentThisScope();
  var flags = ref2.flags;
  var inClassFieldInit = ref2.inClassFieldInit;
  return (flags & SCOPE_SUPER) > 0 || inClassFieldInit || this.options.allowSuperOutsideMethod;
};
prototypeAccessors.allowDirectSuper.get = function() {
  return (this.currentThisScope().flags & SCOPE_DIRECT_SUPER) > 0;
};
prototypeAccessors.treatFunctionsAsVar.get = function() {
  return this.treatFunctionsAsVarInScope(this.currentScope());
};
prototypeAccessors.allowNewDotTarget.get = function() {
  var ref2 = this.currentThisScope();
  var flags = ref2.flags;
  var inClassFieldInit = ref2.inClassFieldInit;
  return (flags & (SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK)) > 0 || inClassFieldInit;
};
prototypeAccessors.inClassStaticBlock.get = function() {
  return (this.currentVarScope().flags & SCOPE_CLASS_STATIC_BLOCK) > 0;
};
Parser.extend = function extend2() {
  var plugins = [], len2 = arguments.length;
  while (len2--)
    plugins[len2] = arguments[len2];
  var cls = this;
  for (var i = 0; i < plugins.length; i++) {
    cls = plugins[i](cls);
  }
  return cls;
};
Parser.parse = function parse2(input, options) {
  return new this(options, input).parse();
};
Parser.parseExpressionAt = function parseExpressionAt(input, pos, options) {
  var parser = new this(options, input, pos);
  parser.nextToken();
  return parser.parseExpression();
};
Parser.tokenizer = function tokenizer(input, options) {
  return new this(options, input);
};
Object.defineProperties(Parser.prototype, prototypeAccessors);
var pp$9 = Parser.prototype;
var literal = /^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;
pp$9.strictDirective = function(start2) {
  if (this.options.ecmaVersion < 5) {
    return false;
  }
  for (; ; ) {
    skipWhiteSpace.lastIndex = start2;
    start2 += skipWhiteSpace.exec(this.input)[0].length;
    var match = literal.exec(this.input.slice(start2));
    if (!match) {
      return false;
    }
    if ((match[1] || match[2]) === "use strict") {
      skipWhiteSpace.lastIndex = start2 + match[0].length;
      var spaceAfter = skipWhiteSpace.exec(this.input), end2 = spaceAfter.index + spaceAfter[0].length;
      var next = this.input.charAt(end2);
      return next === ";" || next === "}" || lineBreak.test(spaceAfter[0]) && !(/[(`.[+\-/*%<>=,?^&]/.test(next) || next === "!" && this.input.charAt(end2 + 1) === "=");
    }
    start2 += match[0].length;
    skipWhiteSpace.lastIndex = start2;
    start2 += skipWhiteSpace.exec(this.input)[0].length;
    if (this.input[start2] === ";") {
      start2++;
    }
  }
};
pp$9.eat = function(type4) {
  if (this.type === type4) {
    this.next();
    return true;
  } else {
    return false;
  }
};
pp$9.isContextual = function(name2) {
  return this.type === types$1.name && this.value === name2 && !this.containsEsc;
};
pp$9.eatContextual = function(name2) {
  if (!this.isContextual(name2)) {
    return false;
  }
  this.next();
  return true;
};
pp$9.expectContextual = function(name2) {
  if (!this.eatContextual(name2)) {
    this.unexpected();
  }
};
pp$9.canInsertSemicolon = function() {
  return this.type === types$1.eof || this.type === types$1.braceR || lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
};
pp$9.insertSemicolon = function() {
  if (this.canInsertSemicolon()) {
    if (this.options.onInsertedSemicolon) {
      this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc);
    }
    return true;
  }
};
pp$9.semicolon = function() {
  if (!this.eat(types$1.semi) && !this.insertSemicolon()) {
    this.unexpected();
  }
};
pp$9.afterTrailingComma = function(tokType, notNext) {
  if (this.type === tokType) {
    if (this.options.onTrailingComma) {
      this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc);
    }
    if (!notNext) {
      this.next();
    }
    return true;
  }
};
pp$9.expect = function(type4) {
  this.eat(type4) || this.unexpected();
};
pp$9.unexpected = function(pos) {
  this.raise(pos != null ? pos : this.start, "Unexpected token");
};
var DestructuringErrors = function DestructuringErrors2() {
  this.shorthandAssign = this.trailingComma = this.parenthesizedAssign = this.parenthesizedBind = this.doubleProto = -1;
};
pp$9.checkPatternErrors = function(refDestructuringErrors, isAssign) {
  if (!refDestructuringErrors) {
    return;
  }
  if (refDestructuringErrors.trailingComma > -1) {
    this.raiseRecoverable(refDestructuringErrors.trailingComma, "Comma is not permitted after the rest element");
  }
  var parens = isAssign ? refDestructuringErrors.parenthesizedAssign : refDestructuringErrors.parenthesizedBind;
  if (parens > -1) {
    this.raiseRecoverable(parens, "Parenthesized pattern");
  }
};
pp$9.checkExpressionErrors = function(refDestructuringErrors, andThrow) {
  if (!refDestructuringErrors) {
    return false;
  }
  var shorthandAssign = refDestructuringErrors.shorthandAssign;
  var doubleProto = refDestructuringErrors.doubleProto;
  if (!andThrow) {
    return shorthandAssign >= 0 || doubleProto >= 0;
  }
  if (shorthandAssign >= 0) {
    this.raise(shorthandAssign, "Shorthand property assignments are valid only in destructuring patterns");
  }
  if (doubleProto >= 0) {
    this.raiseRecoverable(doubleProto, "Redefinition of __proto__ property");
  }
};
pp$9.checkYieldAwaitInDefaultParams = function() {
  if (this.yieldPos && (!this.awaitPos || this.yieldPos < this.awaitPos)) {
    this.raise(this.yieldPos, "Yield expression cannot be a default value");
  }
  if (this.awaitPos) {
    this.raise(this.awaitPos, "Await expression cannot be a default value");
  }
};
pp$9.isSimpleAssignTarget = function(expr) {
  if (expr.type === "ParenthesizedExpression") {
    return this.isSimpleAssignTarget(expr.expression);
  }
  return expr.type === "Identifier" || expr.type === "MemberExpression";
};
var pp$8 = Parser.prototype;
pp$8.parseTopLevel = function(node) {
  var exports = /* @__PURE__ */ Object.create(null);
  if (!node.body) {
    node.body = [];
  }
  while (this.type !== types$1.eof) {
    var stmt = this.parseStatement(null, true, exports);
    node.body.push(stmt);
  }
  if (this.inModule) {
    for (var i = 0, list = Object.keys(this.undefinedExports); i < list.length; i += 1) {
      var name2 = list[i];
      this.raiseRecoverable(this.undefinedExports[name2].start, "Export '" + name2 + "' is not defined");
    }
  }
  this.adaptDirectivePrologue(node.body);
  this.next();
  node.sourceType = this.options.sourceType;
  return this.finishNode(node, "Program");
};
var loopLabel = { kind: "loop" }, switchLabel = { kind: "switch" };
pp$8.isLet = function(context) {
  if (this.options.ecmaVersion < 6 || !this.isContextual("let")) {
    return false;
  }
  skipWhiteSpace.lastIndex = this.pos;
  var skip = skipWhiteSpace.exec(this.input);
  var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
  if (nextCh === 91 || nextCh === 92 || nextCh > 55295 && nextCh < 56320) {
    return true;
  }
  if (context) {
    return false;
  }
  if (nextCh === 123) {
    return true;
  }
  if (isIdentifierStart(nextCh, true)) {
    var pos = next + 1;
    while (isIdentifierChar(nextCh = this.input.charCodeAt(pos), true)) {
      ++pos;
    }
    if (nextCh === 92 || nextCh > 55295 && nextCh < 56320) {
      return true;
    }
    var ident = this.input.slice(next, pos);
    if (!keywordRelationalOperator.test(ident)) {
      return true;
    }
  }
  return false;
};
pp$8.isAsyncFunction = function() {
  if (this.options.ecmaVersion < 8 || !this.isContextual("async")) {
    return false;
  }
  skipWhiteSpace.lastIndex = this.pos;
  var skip = skipWhiteSpace.exec(this.input);
  var next = this.pos + skip[0].length, after;
  return !lineBreak.test(this.input.slice(this.pos, next)) && this.input.slice(next, next + 8) === "function" && (next + 8 === this.input.length || !(isIdentifierChar(after = this.input.charCodeAt(next + 8)) || after > 55295 && after < 56320));
};
pp$8.parseStatement = function(context, topLevel, exports) {
  var starttype = this.type, node = this.startNode(), kind;
  if (this.isLet(context)) {
    starttype = types$1._var;
    kind = "let";
  }
  switch (starttype) {
    case types$1._break:
    case types$1._continue:
      return this.parseBreakContinueStatement(node, starttype.keyword);
    case types$1._debugger:
      return this.parseDebuggerStatement(node);
    case types$1._do:
      return this.parseDoStatement(node);
    case types$1._for:
      return this.parseForStatement(node);
    case types$1._function:
      if (context && (this.strict || context !== "if" && context !== "label") && this.options.ecmaVersion >= 6) {
        this.unexpected();
      }
      return this.parseFunctionStatement(node, false, !context);
    case types$1._class:
      if (context) {
        this.unexpected();
      }
      return this.parseClass(node, true);
    case types$1._if:
      return this.parseIfStatement(node);
    case types$1._return:
      return this.parseReturnStatement(node);
    case types$1._switch:
      return this.parseSwitchStatement(node);
    case types$1._throw:
      return this.parseThrowStatement(node);
    case types$1._try:
      return this.parseTryStatement(node);
    case types$1._const:
    case types$1._var:
      kind = kind || this.value;
      if (context && kind !== "var") {
        this.unexpected();
      }
      return this.parseVarStatement(node, kind);
    case types$1._while:
      return this.parseWhileStatement(node);
    case types$1._with:
      return this.parseWithStatement(node);
    case types$1.braceL:
      return this.parseBlock(true, node);
    case types$1.semi:
      return this.parseEmptyStatement(node);
    case types$1._export:
    case types$1._import:
      if (this.options.ecmaVersion > 10 && starttype === types$1._import) {
        skipWhiteSpace.lastIndex = this.pos;
        var skip = skipWhiteSpace.exec(this.input);
        var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
        if (nextCh === 40 || nextCh === 46) {
          return this.parseExpressionStatement(node, this.parseExpression());
        }
      }
      if (!this.options.allowImportExportEverywhere) {
        if (!topLevel) {
          this.raise(this.start, "'import' and 'export' may only appear at the top level");
        }
        if (!this.inModule) {
          this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'");
        }
      }
      return starttype === types$1._import ? this.parseImport(node) : this.parseExport(node, exports);
    default:
      if (this.isAsyncFunction()) {
        if (context) {
          this.unexpected();
        }
        this.next();
        return this.parseFunctionStatement(node, true, !context);
      }
      var maybeName = this.value, expr = this.parseExpression();
      if (starttype === types$1.name && expr.type === "Identifier" && this.eat(types$1.colon)) {
        return this.parseLabeledStatement(node, maybeName, expr, context);
      } else {
        return this.parseExpressionStatement(node, expr);
      }
  }
};
pp$8.parseBreakContinueStatement = function(node, keyword2) {
  var isBreak = keyword2 === "break";
  this.next();
  if (this.eat(types$1.semi) || this.insertSemicolon()) {
    node.label = null;
  } else if (this.type !== types$1.name) {
    this.unexpected();
  } else {
    node.label = this.parseIdent();
    this.semicolon();
  }
  var i = 0;
  for (; i < this.labels.length; ++i) {
    var lab = this.labels[i];
    if (node.label == null || lab.name === node.label.name) {
      if (lab.kind != null && (isBreak || lab.kind === "loop")) {
        break;
      }
      if (node.label && isBreak) {
        break;
      }
    }
  }
  if (i === this.labels.length) {
    this.raise(node.start, "Unsyntactic " + keyword2);
  }
  return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
};
pp$8.parseDebuggerStatement = function(node) {
  this.next();
  this.semicolon();
  return this.finishNode(node, "DebuggerStatement");
};
pp$8.parseDoStatement = function(node) {
  this.next();
  this.labels.push(loopLabel);
  node.body = this.parseStatement("do");
  this.labels.pop();
  this.expect(types$1._while);
  node.test = this.parseParenExpression();
  if (this.options.ecmaVersion >= 6) {
    this.eat(types$1.semi);
  } else {
    this.semicolon();
  }
  return this.finishNode(node, "DoWhileStatement");
};
pp$8.parseForStatement = function(node) {
  this.next();
  var awaitAt = this.options.ecmaVersion >= 9 && this.canAwait && this.eatContextual("await") ? this.lastTokStart : -1;
  this.labels.push(loopLabel);
  this.enterScope(0);
  this.expect(types$1.parenL);
  if (this.type === types$1.semi) {
    if (awaitAt > -1) {
      this.unexpected(awaitAt);
    }
    return this.parseFor(node, null);
  }
  var isLet = this.isLet();
  if (this.type === types$1._var || this.type === types$1._const || isLet) {
    var init$12 = this.startNode(), kind = isLet ? "let" : this.value;
    this.next();
    this.parseVar(init$12, true, kind);
    this.finishNode(init$12, "VariableDeclaration");
    if ((this.type === types$1._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && init$12.declarations.length === 1) {
      if (this.options.ecmaVersion >= 9) {
        if (this.type === types$1._in) {
          if (awaitAt > -1) {
            this.unexpected(awaitAt);
          }
        } else {
          node.await = awaitAt > -1;
        }
      }
      return this.parseForIn(node, init$12);
    }
    if (awaitAt > -1) {
      this.unexpected(awaitAt);
    }
    return this.parseFor(node, init$12);
  }
  var startsWithLet = this.isContextual("let"), isForOf = false;
  var refDestructuringErrors = new DestructuringErrors();
  var init2 = this.parseExpression(awaitAt > -1 ? "await" : true, refDestructuringErrors);
  if (this.type === types$1._in || (isForOf = this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
    if (this.options.ecmaVersion >= 9) {
      if (this.type === types$1._in) {
        if (awaitAt > -1) {
          this.unexpected(awaitAt);
        }
      } else {
        node.await = awaitAt > -1;
      }
    }
    if (startsWithLet && isForOf) {
      this.raise(init2.start, "The left-hand side of a for-of loop may not start with 'let'.");
    }
    this.toAssignable(init2, false, refDestructuringErrors);
    this.checkLValPattern(init2);
    return this.parseForIn(node, init2);
  } else {
    this.checkExpressionErrors(refDestructuringErrors, true);
  }
  if (awaitAt > -1) {
    this.unexpected(awaitAt);
  }
  return this.parseFor(node, init2);
};
pp$8.parseFunctionStatement = function(node, isAsync, declarationPosition) {
  this.next();
  return this.parseFunction(node, FUNC_STATEMENT | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT), false, isAsync);
};
pp$8.parseIfStatement = function(node) {
  this.next();
  node.test = this.parseParenExpression();
  node.consequent = this.parseStatement("if");
  node.alternate = this.eat(types$1._else) ? this.parseStatement("if") : null;
  return this.finishNode(node, "IfStatement");
};
pp$8.parseReturnStatement = function(node) {
  if (!this.inFunction && !this.options.allowReturnOutsideFunction) {
    this.raise(this.start, "'return' outside of function");
  }
  this.next();
  if (this.eat(types$1.semi) || this.insertSemicolon()) {
    node.argument = null;
  } else {
    node.argument = this.parseExpression();
    this.semicolon();
  }
  return this.finishNode(node, "ReturnStatement");
};
pp$8.parseSwitchStatement = function(node) {
  this.next();
  node.discriminant = this.parseParenExpression();
  node.cases = [];
  this.expect(types$1.braceL);
  this.labels.push(switchLabel);
  this.enterScope(0);
  var cur;
  for (var sawDefault = false; this.type !== types$1.braceR; ) {
    if (this.type === types$1._case || this.type === types$1._default) {
      var isCase = this.type === types$1._case;
      if (cur) {
        this.finishNode(cur, "SwitchCase");
      }
      node.cases.push(cur = this.startNode());
      cur.consequent = [];
      this.next();
      if (isCase) {
        cur.test = this.parseExpression();
      } else {
        if (sawDefault) {
          this.raiseRecoverable(this.lastTokStart, "Multiple default clauses");
        }
        sawDefault = true;
        cur.test = null;
      }
      this.expect(types$1.colon);
    } else {
      if (!cur) {
        this.unexpected();
      }
      cur.consequent.push(this.parseStatement(null));
    }
  }
  this.exitScope();
  if (cur) {
    this.finishNode(cur, "SwitchCase");
  }
  this.next();
  this.labels.pop();
  return this.finishNode(node, "SwitchStatement");
};
pp$8.parseThrowStatement = function(node) {
  this.next();
  if (lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) {
    this.raise(this.lastTokEnd, "Illegal newline after throw");
  }
  node.argument = this.parseExpression();
  this.semicolon();
  return this.finishNode(node, "ThrowStatement");
};
var empty$1 = [];
pp$8.parseTryStatement = function(node) {
  this.next();
  node.block = this.parseBlock();
  node.handler = null;
  if (this.type === types$1._catch) {
    var clause = this.startNode();
    this.next();
    if (this.eat(types$1.parenL)) {
      clause.param = this.parseBindingAtom();
      var simple = clause.param.type === "Identifier";
      this.enterScope(simple ? SCOPE_SIMPLE_CATCH : 0);
      this.checkLValPattern(clause.param, simple ? BIND_SIMPLE_CATCH : BIND_LEXICAL);
      this.expect(types$1.parenR);
    } else {
      if (this.options.ecmaVersion < 10) {
        this.unexpected();
      }
      clause.param = null;
      this.enterScope(0);
    }
    clause.body = this.parseBlock(false);
    this.exitScope();
    node.handler = this.finishNode(clause, "CatchClause");
  }
  node.finalizer = this.eat(types$1._finally) ? this.parseBlock() : null;
  if (!node.handler && !node.finalizer) {
    this.raise(node.start, "Missing catch or finally clause");
  }
  return this.finishNode(node, "TryStatement");
};
pp$8.parseVarStatement = function(node, kind) {
  this.next();
  this.parseVar(node, false, kind);
  this.semicolon();
  return this.finishNode(node, "VariableDeclaration");
};
pp$8.parseWhileStatement = function(node) {
  this.next();
  node.test = this.parseParenExpression();
  this.labels.push(loopLabel);
  node.body = this.parseStatement("while");
  this.labels.pop();
  return this.finishNode(node, "WhileStatement");
};
pp$8.parseWithStatement = function(node) {
  if (this.strict) {
    this.raise(this.start, "'with' in strict mode");
  }
  this.next();
  node.object = this.parseParenExpression();
  node.body = this.parseStatement("with");
  return this.finishNode(node, "WithStatement");
};
pp$8.parseEmptyStatement = function(node) {
  this.next();
  return this.finishNode(node, "EmptyStatement");
};
pp$8.parseLabeledStatement = function(node, maybeName, expr, context) {
  for (var i$1 = 0, list = this.labels; i$1 < list.length; i$1 += 1) {
    var label = list[i$1];
    if (label.name === maybeName) {
      this.raise(expr.start, "Label '" + maybeName + "' is already declared");
    }
  }
  var kind = this.type.isLoop ? "loop" : this.type === types$1._switch ? "switch" : null;
  for (var i = this.labels.length - 1; i >= 0; i--) {
    var label$1 = this.labels[i];
    if (label$1.statementStart === node.start) {
      label$1.statementStart = this.start;
      label$1.kind = kind;
    } else {
      break;
    }
  }
  this.labels.push({ name: maybeName, kind, statementStart: this.start });
  node.body = this.parseStatement(context ? context.indexOf("label") === -1 ? context + "label" : context : "label");
  this.labels.pop();
  node.label = expr;
  return this.finishNode(node, "LabeledStatement");
};
pp$8.parseExpressionStatement = function(node, expr) {
  node.expression = expr;
  this.semicolon();
  return this.finishNode(node, "ExpressionStatement");
};
pp$8.parseBlock = function(createNewLexicalScope, node, exitStrict) {
  if (createNewLexicalScope === void 0)
    createNewLexicalScope = true;
  if (node === void 0)
    node = this.startNode();
  node.body = [];
  this.expect(types$1.braceL);
  if (createNewLexicalScope) {
    this.enterScope(0);
  }
  while (this.type !== types$1.braceR) {
    var stmt = this.parseStatement(null);
    node.body.push(stmt);
  }
  if (exitStrict) {
    this.strict = false;
  }
  this.next();
  if (createNewLexicalScope) {
    this.exitScope();
  }
  return this.finishNode(node, "BlockStatement");
};
pp$8.parseFor = function(node, init2) {
  node.init = init2;
  this.expect(types$1.semi);
  node.test = this.type === types$1.semi ? null : this.parseExpression();
  this.expect(types$1.semi);
  node.update = this.type === types$1.parenR ? null : this.parseExpression();
  this.expect(types$1.parenR);
  node.body = this.parseStatement("for");
  this.exitScope();
  this.labels.pop();
  return this.finishNode(node, "ForStatement");
};
pp$8.parseForIn = function(node, init2) {
  var isForIn = this.type === types$1._in;
  this.next();
  if (init2.type === "VariableDeclaration" && init2.declarations[0].init != null && (!isForIn || this.options.ecmaVersion < 8 || this.strict || init2.kind !== "var" || init2.declarations[0].id.type !== "Identifier")) {
    this.raise(init2.start, (isForIn ? "for-in" : "for-of") + " loop variable declaration may not have an initializer");
  }
  node.left = init2;
  node.right = isForIn ? this.parseExpression() : this.parseMaybeAssign();
  this.expect(types$1.parenR);
  node.body = this.parseStatement("for");
  this.exitScope();
  this.labels.pop();
  return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
};
pp$8.parseVar = function(node, isFor, kind) {
  node.declarations = [];
  node.kind = kind;
  for (; ; ) {
    var decl = this.startNode();
    this.parseVarId(decl, kind);
    if (this.eat(types$1.eq)) {
      decl.init = this.parseMaybeAssign(isFor);
    } else if (kind === "const" && !(this.type === types$1._in || this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
      this.unexpected();
    } else if (decl.id.type !== "Identifier" && !(isFor && (this.type === types$1._in || this.isContextual("of")))) {
      this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value");
    } else {
      decl.init = null;
    }
    node.declarations.push(this.finishNode(decl, "VariableDeclarator"));
    if (!this.eat(types$1.comma)) {
      break;
    }
  }
  return node;
};
pp$8.parseVarId = function(decl, kind) {
  decl.id = this.parseBindingAtom();
  this.checkLValPattern(decl.id, kind === "var" ? BIND_VAR : BIND_LEXICAL, false);
};
var FUNC_STATEMENT = 1, FUNC_HANGING_STATEMENT = 2, FUNC_NULLABLE_ID = 4;
pp$8.parseFunction = function(node, statement, allowExpressionBody, isAsync, forInit) {
  this.initFunction(node);
  if (this.options.ecmaVersion >= 9 || this.options.ecmaVersion >= 6 && !isAsync) {
    if (this.type === types$1.star && statement & FUNC_HANGING_STATEMENT) {
      this.unexpected();
    }
    node.generator = this.eat(types$1.star);
  }
  if (this.options.ecmaVersion >= 8) {
    node.async = !!isAsync;
  }
  if (statement & FUNC_STATEMENT) {
    node.id = statement & FUNC_NULLABLE_ID && this.type !== types$1.name ? null : this.parseIdent();
    if (node.id && !(statement & FUNC_HANGING_STATEMENT)) {
      this.checkLValSimple(node.id, this.strict || node.generator || node.async ? this.treatFunctionsAsVar ? BIND_VAR : BIND_LEXICAL : BIND_FUNCTION);
    }
  }
  var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
  this.yieldPos = 0;
  this.awaitPos = 0;
  this.awaitIdentPos = 0;
  this.enterScope(functionFlags(node.async, node.generator));
  if (!(statement & FUNC_STATEMENT)) {
    node.id = this.type === types$1.name ? this.parseIdent() : null;
  }
  this.parseFunctionParams(node);
  this.parseFunctionBody(node, allowExpressionBody, false, forInit);
  this.yieldPos = oldYieldPos;
  this.awaitPos = oldAwaitPos;
  this.awaitIdentPos = oldAwaitIdentPos;
  return this.finishNode(node, statement & FUNC_STATEMENT ? "FunctionDeclaration" : "FunctionExpression");
};
pp$8.parseFunctionParams = function(node) {
  this.expect(types$1.parenL);
  node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
  this.checkYieldAwaitInDefaultParams();
};
pp$8.parseClass = function(node, isStatement) {
  this.next();
  var oldStrict = this.strict;
  this.strict = true;
  this.parseClassId(node, isStatement);
  this.parseClassSuper(node);
  var privateNameMap = this.enterClassBody();
  var classBody = this.startNode();
  var hadConstructor = false;
  classBody.body = [];
  this.expect(types$1.braceL);
  while (this.type !== types$1.braceR) {
    var element = this.parseClassElement(node.superClass !== null);
    if (element) {
      classBody.body.push(element);
      if (element.type === "MethodDefinition" && element.kind === "constructor") {
        if (hadConstructor) {
          this.raise(element.start, "Duplicate constructor in the same class");
        }
        hadConstructor = true;
      } else if (element.key && element.key.type === "PrivateIdentifier" && isPrivateNameConflicted(privateNameMap, element)) {
        this.raiseRecoverable(element.key.start, "Identifier '#" + element.key.name + "' has already been declared");
      }
    }
  }
  this.strict = oldStrict;
  this.next();
  node.body = this.finishNode(classBody, "ClassBody");
  this.exitClassBody();
  return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
};
pp$8.parseClassElement = function(constructorAllowsSuper) {
  if (this.eat(types$1.semi)) {
    return null;
  }
  var ecmaVersion = this.options.ecmaVersion;
  var node = this.startNode();
  var keyName = "";
  var isGenerator = false;
  var isAsync = false;
  var kind = "method";
  var isStatic = false;
  if (this.eatContextual("static")) {
    if (ecmaVersion >= 13 && this.eat(types$1.braceL)) {
      this.parseClassStaticBlock(node);
      return node;
    }
    if (this.isClassElementNameStart() || this.type === types$1.star) {
      isStatic = true;
    } else {
      keyName = "static";
    }
  }
  node.static = isStatic;
  if (!keyName && ecmaVersion >= 8 && this.eatContextual("async")) {
    if ((this.isClassElementNameStart() || this.type === types$1.star) && !this.canInsertSemicolon()) {
      isAsync = true;
    } else {
      keyName = "async";
    }
  }
  if (!keyName && (ecmaVersion >= 9 || !isAsync) && this.eat(types$1.star)) {
    isGenerator = true;
  }
  if (!keyName && !isAsync && !isGenerator) {
    var lastValue = this.value;
    if (this.eatContextual("get") || this.eatContextual("set")) {
      if (this.isClassElementNameStart()) {
        kind = lastValue;
      } else {
        keyName = lastValue;
      }
    }
  }
  if (keyName) {
    node.computed = false;
    node.key = this.startNodeAt(this.lastTokStart, this.lastTokStartLoc);
    node.key.name = keyName;
    this.finishNode(node.key, "Identifier");
  } else {
    this.parseClassElementName(node);
  }
  if (ecmaVersion < 13 || this.type === types$1.parenL || kind !== "method" || isGenerator || isAsync) {
    var isConstructor = !node.static && checkKeyName(node, "constructor");
    var allowsDirectSuper = isConstructor && constructorAllowsSuper;
    if (isConstructor && kind !== "method") {
      this.raise(node.key.start, "Constructor can't have get/set modifier");
    }
    node.kind = isConstructor ? "constructor" : kind;
    this.parseClassMethod(node, isGenerator, isAsync, allowsDirectSuper);
  } else {
    this.parseClassField(node);
  }
  return node;
};
pp$8.isClassElementNameStart = function() {
  return this.type === types$1.name || this.type === types$1.privateId || this.type === types$1.num || this.type === types$1.string || this.type === types$1.bracketL || this.type.keyword;
};
pp$8.parseClassElementName = function(element) {
  if (this.type === types$1.privateId) {
    if (this.value === "constructor") {
      this.raise(this.start, "Classes can't have an element named '#constructor'");
    }
    element.computed = false;
    element.key = this.parsePrivateIdent();
  } else {
    this.parsePropertyName(element);
  }
};
pp$8.parseClassMethod = function(method4, isGenerator, isAsync, allowsDirectSuper) {
  var key = method4.key;
  if (method4.kind === "constructor") {
    if (isGenerator) {
      this.raise(key.start, "Constructor can't be a generator");
    }
    if (isAsync) {
      this.raise(key.start, "Constructor can't be an async method");
    }
  } else if (method4.static && checkKeyName(method4, "prototype")) {
    this.raise(key.start, "Classes may not have a static property named prototype");
  }
  var value = method4.value = this.parseMethod(isGenerator, isAsync, allowsDirectSuper);
  if (method4.kind === "get" && value.params.length !== 0) {
    this.raiseRecoverable(value.start, "getter should have no params");
  }
  if (method4.kind === "set" && value.params.length !== 1) {
    this.raiseRecoverable(value.start, "setter should have exactly one param");
  }
  if (method4.kind === "set" && value.params[0].type === "RestElement") {
    this.raiseRecoverable(value.params[0].start, "Setter cannot use rest params");
  }
  return this.finishNode(method4, "MethodDefinition");
};
pp$8.parseClassField = function(field) {
  if (checkKeyName(field, "constructor")) {
    this.raise(field.key.start, "Classes can't have a field named 'constructor'");
  } else if (field.static && checkKeyName(field, "prototype")) {
    this.raise(field.key.start, "Classes can't have a static field named 'prototype'");
  }
  if (this.eat(types$1.eq)) {
    var scope = this.currentThisScope();
    var inClassFieldInit = scope.inClassFieldInit;
    scope.inClassFieldInit = true;
    field.value = this.parseMaybeAssign();
    scope.inClassFieldInit = inClassFieldInit;
  } else {
    field.value = null;
  }
  this.semicolon();
  return this.finishNode(field, "PropertyDefinition");
};
pp$8.parseClassStaticBlock = function(node) {
  node.body = [];
  var oldLabels = this.labels;
  this.labels = [];
  this.enterScope(SCOPE_CLASS_STATIC_BLOCK | SCOPE_SUPER);
  while (this.type !== types$1.braceR) {
    var stmt = this.parseStatement(null);
    node.body.push(stmt);
  }
  this.next();
  this.exitScope();
  this.labels = oldLabels;
  return this.finishNode(node, "StaticBlock");
};
pp$8.parseClassId = function(node, isStatement) {
  if (this.type === types$1.name) {
    node.id = this.parseIdent();
    if (isStatement) {
      this.checkLValSimple(node.id, BIND_LEXICAL, false);
    }
  } else {
    if (isStatement === true) {
      this.unexpected();
    }
    node.id = null;
  }
};
pp$8.parseClassSuper = function(node) {
  node.superClass = this.eat(types$1._extends) ? this.parseExprSubscripts(false) : null;
};
pp$8.enterClassBody = function() {
  var element = { declared: /* @__PURE__ */ Object.create(null), used: [] };
  this.privateNameStack.push(element);
  return element.declared;
};
pp$8.exitClassBody = function() {
  var ref2 = this.privateNameStack.pop();
  var declared = ref2.declared;
  var used = ref2.used;
  var len2 = this.privateNameStack.length;
  var parent = len2 === 0 ? null : this.privateNameStack[len2 - 1];
  for (var i = 0; i < used.length; ++i) {
    var id2 = used[i];
    if (!hasOwn(declared, id2.name)) {
      if (parent) {
        parent.used.push(id2);
      } else {
        this.raiseRecoverable(id2.start, "Private field '#" + id2.name + "' must be declared in an enclosing class");
      }
    }
  }
};
function isPrivateNameConflicted(privateNameMap, element) {
  var name2 = element.key.name;
  var curr = privateNameMap[name2];
  var next = "true";
  if (element.type === "MethodDefinition" && (element.kind === "get" || element.kind === "set")) {
    next = (element.static ? "s" : "i") + element.kind;
  }
  if (curr === "iget" && next === "iset" || curr === "iset" && next === "iget" || curr === "sget" && next === "sset" || curr === "sset" && next === "sget") {
    privateNameMap[name2] = "true";
    return false;
  } else if (!curr) {
    privateNameMap[name2] = next;
    return false;
  } else {
    return true;
  }
}
function checkKeyName(node, name2) {
  var computed = node.computed;
  var key = node.key;
  return !computed && (key.type === "Identifier" && key.name === name2 || key.type === "Literal" && key.value === name2);
}
pp$8.parseExport = function(node, exports) {
  this.next();
  if (this.eat(types$1.star)) {
    if (this.options.ecmaVersion >= 11) {
      if (this.eatContextual("as")) {
        node.exported = this.parseModuleExportName();
        this.checkExport(exports, node.exported, this.lastTokStart);
      } else {
        node.exported = null;
      }
    }
    this.expectContextual("from");
    if (this.type !== types$1.string) {
      this.unexpected();
    }
    node.source = this.parseExprAtom();
    this.semicolon();
    return this.finishNode(node, "ExportAllDeclaration");
  }
  if (this.eat(types$1._default)) {
    this.checkExport(exports, "default", this.lastTokStart);
    var isAsync;
    if (this.type === types$1._function || (isAsync = this.isAsyncFunction())) {
      var fNode = this.startNode();
      this.next();
      if (isAsync) {
        this.next();
      }
      node.declaration = this.parseFunction(fNode, FUNC_STATEMENT | FUNC_NULLABLE_ID, false, isAsync);
    } else if (this.type === types$1._class) {
      var cNode = this.startNode();
      node.declaration = this.parseClass(cNode, "nullableID");
    } else {
      node.declaration = this.parseMaybeAssign();
      this.semicolon();
    }
    return this.finishNode(node, "ExportDefaultDeclaration");
  }
  if (this.shouldParseExportStatement()) {
    node.declaration = this.parseStatement(null);
    if (node.declaration.type === "VariableDeclaration") {
      this.checkVariableExport(exports, node.declaration.declarations);
    } else {
      this.checkExport(exports, node.declaration.id, node.declaration.id.start);
    }
    node.specifiers = [];
    node.source = null;
  } else {
    node.declaration = null;
    node.specifiers = this.parseExportSpecifiers(exports);
    if (this.eatContextual("from")) {
      if (this.type !== types$1.string) {
        this.unexpected();
      }
      node.source = this.parseExprAtom();
    } else {
      for (var i = 0, list = node.specifiers; i < list.length; i += 1) {
        var spec = list[i];
        this.checkUnreserved(spec.local);
        this.checkLocalExport(spec.local);
        if (spec.local.type === "Literal") {
          this.raise(spec.local.start, "A string literal cannot be used as an exported binding without `from`.");
        }
      }
      node.source = null;
    }
    this.semicolon();
  }
  return this.finishNode(node, "ExportNamedDeclaration");
};
pp$8.checkExport = function(exports, name2, pos) {
  if (!exports) {
    return;
  }
  if (typeof name2 !== "string") {
    name2 = name2.type === "Identifier" ? name2.name : name2.value;
  }
  if (hasOwn(exports, name2)) {
    this.raiseRecoverable(pos, "Duplicate export '" + name2 + "'");
  }
  exports[name2] = true;
};
pp$8.checkPatternExport = function(exports, pat) {
  var type4 = pat.type;
  if (type4 === "Identifier") {
    this.checkExport(exports, pat, pat.start);
  } else if (type4 === "ObjectPattern") {
    for (var i = 0, list = pat.properties; i < list.length; i += 1) {
      var prop = list[i];
      this.checkPatternExport(exports, prop);
    }
  } else if (type4 === "ArrayPattern") {
    for (var i$1 = 0, list$1 = pat.elements; i$1 < list$1.length; i$1 += 1) {
      var elt = list$1[i$1];
      if (elt) {
        this.checkPatternExport(exports, elt);
      }
    }
  } else if (type4 === "Property") {
    this.checkPatternExport(exports, pat.value);
  } else if (type4 === "AssignmentPattern") {
    this.checkPatternExport(exports, pat.left);
  } else if (type4 === "RestElement") {
    this.checkPatternExport(exports, pat.argument);
  } else if (type4 === "ParenthesizedExpression") {
    this.checkPatternExport(exports, pat.expression);
  }
};
pp$8.checkVariableExport = function(exports, decls) {
  if (!exports) {
    return;
  }
  for (var i = 0, list = decls; i < list.length; i += 1) {
    var decl = list[i];
    this.checkPatternExport(exports, decl.id);
  }
};
pp$8.shouldParseExportStatement = function() {
  return this.type.keyword === "var" || this.type.keyword === "const" || this.type.keyword === "class" || this.type.keyword === "function" || this.isLet() || this.isAsyncFunction();
};
pp$8.parseExportSpecifiers = function(exports) {
  var nodes = [], first = true;
  this.expect(types$1.braceL);
  while (!this.eat(types$1.braceR)) {
    if (!first) {
      this.expect(types$1.comma);
      if (this.afterTrailingComma(types$1.braceR)) {
        break;
      }
    } else {
      first = false;
    }
    var node = this.startNode();
    node.local = this.parseModuleExportName();
    node.exported = this.eatContextual("as") ? this.parseModuleExportName() : node.local;
    this.checkExport(exports, node.exported, node.exported.start);
    nodes.push(this.finishNode(node, "ExportSpecifier"));
  }
  return nodes;
};
pp$8.parseImport = function(node) {
  this.next();
  if (this.type === types$1.string) {
    node.specifiers = empty$1;
    node.source = this.parseExprAtom();
  } else {
    node.specifiers = this.parseImportSpecifiers();
    this.expectContextual("from");
    node.source = this.type === types$1.string ? this.parseExprAtom() : this.unexpected();
  }
  this.semicolon();
  return this.finishNode(node, "ImportDeclaration");
};
pp$8.parseImportSpecifiers = function() {
  var nodes = [], first = true;
  if (this.type === types$1.name) {
    var node = this.startNode();
    node.local = this.parseIdent();
    this.checkLValSimple(node.local, BIND_LEXICAL);
    nodes.push(this.finishNode(node, "ImportDefaultSpecifier"));
    if (!this.eat(types$1.comma)) {
      return nodes;
    }
  }
  if (this.type === types$1.star) {
    var node$1 = this.startNode();
    this.next();
    this.expectContextual("as");
    node$1.local = this.parseIdent();
    this.checkLValSimple(node$1.local, BIND_LEXICAL);
    nodes.push(this.finishNode(node$1, "ImportNamespaceSpecifier"));
    return nodes;
  }
  this.expect(types$1.braceL);
  while (!this.eat(types$1.braceR)) {
    if (!first) {
      this.expect(types$1.comma);
      if (this.afterTrailingComma(types$1.braceR)) {
        break;
      }
    } else {
      first = false;
    }
    var node$2 = this.startNode();
    node$2.imported = this.parseModuleExportName();
    if (this.eatContextual("as")) {
      node$2.local = this.parseIdent();
    } else {
      this.checkUnreserved(node$2.imported);
      node$2.local = node$2.imported;
    }
    this.checkLValSimple(node$2.local, BIND_LEXICAL);
    nodes.push(this.finishNode(node$2, "ImportSpecifier"));
  }
  return nodes;
};
pp$8.parseModuleExportName = function() {
  if (this.options.ecmaVersion >= 13 && this.type === types$1.string) {
    var stringLiteral = this.parseLiteral(this.value);
    if (loneSurrogate.test(stringLiteral.value)) {
      this.raise(stringLiteral.start, "An export name cannot include a lone surrogate.");
    }
    return stringLiteral;
  }
  return this.parseIdent(true);
};
pp$8.adaptDirectivePrologue = function(statements) {
  for (var i = 0; i < statements.length && this.isDirectiveCandidate(statements[i]); ++i) {
    statements[i].directive = statements[i].expression.raw.slice(1, -1);
  }
};
pp$8.isDirectiveCandidate = function(statement) {
  return statement.type === "ExpressionStatement" && statement.expression.type === "Literal" && typeof statement.expression.value === "string" && (this.input[statement.start] === '"' || this.input[statement.start] === "'");
};
var pp$7 = Parser.prototype;
pp$7.toAssignable = function(node, isBinding, refDestructuringErrors) {
  if (this.options.ecmaVersion >= 6 && node) {
    switch (node.type) {
      case "Identifier":
        if (this.inAsync && node.name === "await") {
          this.raise(node.start, "Cannot use 'await' as identifier inside an async function");
        }
        break;
      case "ObjectPattern":
      case "ArrayPattern":
      case "AssignmentPattern":
      case "RestElement":
        break;
      case "ObjectExpression":
        node.type = "ObjectPattern";
        if (refDestructuringErrors) {
          this.checkPatternErrors(refDestructuringErrors, true);
        }
        for (var i = 0, list = node.properties; i < list.length; i += 1) {
          var prop = list[i];
          this.toAssignable(prop, isBinding);
          if (prop.type === "RestElement" && (prop.argument.type === "ArrayPattern" || prop.argument.type === "ObjectPattern")) {
            this.raise(prop.argument.start, "Unexpected token");
          }
        }
        break;
      case "Property":
        if (node.kind !== "init") {
          this.raise(node.key.start, "Object pattern can't contain getter or setter");
        }
        this.toAssignable(node.value, isBinding);
        break;
      case "ArrayExpression":
        node.type = "ArrayPattern";
        if (refDestructuringErrors) {
          this.checkPatternErrors(refDestructuringErrors, true);
        }
        this.toAssignableList(node.elements, isBinding);
        break;
      case "SpreadElement":
        node.type = "RestElement";
        this.toAssignable(node.argument, isBinding);
        if (node.argument.type === "AssignmentPattern") {
          this.raise(node.argument.start, "Rest elements cannot have a default value");
        }
        break;
      case "AssignmentExpression":
        if (node.operator !== "=") {
          this.raise(node.left.end, "Only '=' operator can be used for specifying default value.");
        }
        node.type = "AssignmentPattern";
        delete node.operator;
        this.toAssignable(node.left, isBinding);
        break;
      case "ParenthesizedExpression":
        this.toAssignable(node.expression, isBinding, refDestructuringErrors);
        break;
      case "ChainExpression":
        this.raiseRecoverable(node.start, "Optional chaining cannot appear in left-hand side");
        break;
      case "MemberExpression":
        if (!isBinding) {
          break;
        }
      default:
        this.raise(node.start, "Assigning to rvalue");
    }
  } else if (refDestructuringErrors) {
    this.checkPatternErrors(refDestructuringErrors, true);
  }
  return node;
};
pp$7.toAssignableList = function(exprList, isBinding) {
  var end2 = exprList.length;
  for (var i = 0; i < end2; i++) {
    var elt = exprList[i];
    if (elt) {
      this.toAssignable(elt, isBinding);
    }
  }
  if (end2) {
    var last = exprList[end2 - 1];
    if (this.options.ecmaVersion === 6 && isBinding && last && last.type === "RestElement" && last.argument.type !== "Identifier") {
      this.unexpected(last.argument.start);
    }
  }
  return exprList;
};
pp$7.parseSpread = function(refDestructuringErrors) {
  var node = this.startNode();
  this.next();
  node.argument = this.parseMaybeAssign(false, refDestructuringErrors);
  return this.finishNode(node, "SpreadElement");
};
pp$7.parseRestBinding = function() {
  var node = this.startNode();
  this.next();
  if (this.options.ecmaVersion === 6 && this.type !== types$1.name) {
    this.unexpected();
  }
  node.argument = this.parseBindingAtom();
  return this.finishNode(node, "RestElement");
};
pp$7.parseBindingAtom = function() {
  if (this.options.ecmaVersion >= 6) {
    switch (this.type) {
      case types$1.bracketL:
        var node = this.startNode();
        this.next();
        node.elements = this.parseBindingList(types$1.bracketR, true, true);
        return this.finishNode(node, "ArrayPattern");
      case types$1.braceL:
        return this.parseObj(true);
    }
  }
  return this.parseIdent();
};
pp$7.parseBindingList = function(close, allowEmpty, allowTrailingComma) {
  var elts = [], first = true;
  while (!this.eat(close)) {
    if (first) {
      first = false;
    } else {
      this.expect(types$1.comma);
    }
    if (allowEmpty && this.type === types$1.comma) {
      elts.push(null);
    } else if (allowTrailingComma && this.afterTrailingComma(close)) {
      break;
    } else if (this.type === types$1.ellipsis) {
      var rest = this.parseRestBinding();
      this.parseBindingListItem(rest);
      elts.push(rest);
      if (this.type === types$1.comma) {
        this.raise(this.start, "Comma is not permitted after the rest element");
      }
      this.expect(close);
      break;
    } else {
      var elem = this.parseMaybeDefault(this.start, this.startLoc);
      this.parseBindingListItem(elem);
      elts.push(elem);
    }
  }
  return elts;
};
pp$7.parseBindingListItem = function(param) {
  return param;
};
pp$7.parseMaybeDefault = function(startPos, startLoc, left) {
  left = left || this.parseBindingAtom();
  if (this.options.ecmaVersion < 6 || !this.eat(types$1.eq)) {
    return left;
  }
  var node = this.startNodeAt(startPos, startLoc);
  node.left = left;
  node.right = this.parseMaybeAssign();
  return this.finishNode(node, "AssignmentPattern");
};
pp$7.checkLValSimple = function(expr, bindingType, checkClashes) {
  if (bindingType === void 0)
    bindingType = BIND_NONE;
  var isBind = bindingType !== BIND_NONE;
  switch (expr.type) {
    case "Identifier":
      if (this.strict && this.reservedWordsStrictBind.test(expr.name)) {
        this.raiseRecoverable(expr.start, (isBind ? "Binding " : "Assigning to ") + expr.name + " in strict mode");
      }
      if (isBind) {
        if (bindingType === BIND_LEXICAL && expr.name === "let") {
          this.raiseRecoverable(expr.start, "let is disallowed as a lexically bound name");
        }
        if (checkClashes) {
          if (hasOwn(checkClashes, expr.name)) {
            this.raiseRecoverable(expr.start, "Argument name clash");
          }
          checkClashes[expr.name] = true;
        }
        if (bindingType !== BIND_OUTSIDE) {
          this.declareName(expr.name, bindingType, expr.start);
        }
      }
      break;
    case "ChainExpression":
      this.raiseRecoverable(expr.start, "Optional chaining cannot appear in left-hand side");
      break;
    case "MemberExpression":
      if (isBind) {
        this.raiseRecoverable(expr.start, "Binding member expression");
      }
      break;
    case "ParenthesizedExpression":
      if (isBind) {
        this.raiseRecoverable(expr.start, "Binding parenthesized expression");
      }
      return this.checkLValSimple(expr.expression, bindingType, checkClashes);
    default:
      this.raise(expr.start, (isBind ? "Binding" : "Assigning to") + " rvalue");
  }
};
pp$7.checkLValPattern = function(expr, bindingType, checkClashes) {
  if (bindingType === void 0)
    bindingType = BIND_NONE;
  switch (expr.type) {
    case "ObjectPattern":
      for (var i = 0, list = expr.properties; i < list.length; i += 1) {
        var prop = list[i];
        this.checkLValInnerPattern(prop, bindingType, checkClashes);
      }
      break;
    case "ArrayPattern":
      for (var i$1 = 0, list$1 = expr.elements; i$1 < list$1.length; i$1 += 1) {
        var elem = list$1[i$1];
        if (elem) {
          this.checkLValInnerPattern(elem, bindingType, checkClashes);
        }
      }
      break;
    default:
      this.checkLValSimple(expr, bindingType, checkClashes);
  }
};
pp$7.checkLValInnerPattern = function(expr, bindingType, checkClashes) {
  if (bindingType === void 0)
    bindingType = BIND_NONE;
  switch (expr.type) {
    case "Property":
      this.checkLValInnerPattern(expr.value, bindingType, checkClashes);
      break;
    case "AssignmentPattern":
      this.checkLValPattern(expr.left, bindingType, checkClashes);
      break;
    case "RestElement":
      this.checkLValPattern(expr.argument, bindingType, checkClashes);
      break;
    default:
      this.checkLValPattern(expr, bindingType, checkClashes);
  }
};
var TokContext = function TokContext2(token, isExpr, preserveSpace, override, generator) {
  this.token = token;
  this.isExpr = !!isExpr;
  this.preserveSpace = !!preserveSpace;
  this.override = override;
  this.generator = !!generator;
};
var types$2 = {
  b_stat: new TokContext("{", false),
  b_expr: new TokContext("{", true),
  b_tmpl: new TokContext("${", false),
  p_stat: new TokContext("(", false),
  p_expr: new TokContext("(", true),
  q_tmpl: new TokContext("`", true, true, function(p2) {
    return p2.tryReadTemplateToken();
  }),
  f_stat: new TokContext("function", false),
  f_expr: new TokContext("function", true),
  f_expr_gen: new TokContext("function", true, false, null, true),
  f_gen: new TokContext("function", false, false, null, true)
};
var pp$6 = Parser.prototype;
pp$6.initialContext = function() {
  return [types$2.b_stat];
};
pp$6.curContext = function() {
  return this.context[this.context.length - 1];
};
pp$6.braceIsBlock = function(prevType) {
  var parent = this.curContext();
  if (parent === types$2.f_expr || parent === types$2.f_stat) {
    return true;
  }
  if (prevType === types$1.colon && (parent === types$2.b_stat || parent === types$2.b_expr)) {
    return !parent.isExpr;
  }
  if (prevType === types$1._return || prevType === types$1.name && this.exprAllowed) {
    return lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
  }
  if (prevType === types$1._else || prevType === types$1.semi || prevType === types$1.eof || prevType === types$1.parenR || prevType === types$1.arrow) {
    return true;
  }
  if (prevType === types$1.braceL) {
    return parent === types$2.b_stat;
  }
  if (prevType === types$1._var || prevType === types$1._const || prevType === types$1.name) {
    return false;
  }
  return !this.exprAllowed;
};
pp$6.inGeneratorContext = function() {
  for (var i = this.context.length - 1; i >= 1; i--) {
    var context = this.context[i];
    if (context.token === "function") {
      return context.generator;
    }
  }
  return false;
};
pp$6.updateContext = function(prevType) {
  var update, type4 = this.type;
  if (type4.keyword && prevType === types$1.dot) {
    this.exprAllowed = false;
  } else if (update = type4.updateContext) {
    update.call(this, prevType);
  } else {
    this.exprAllowed = type4.beforeExpr;
  }
};
pp$6.overrideContext = function(tokenCtx) {
  if (this.curContext() !== tokenCtx) {
    this.context[this.context.length - 1] = tokenCtx;
  }
};
types$1.parenR.updateContext = types$1.braceR.updateContext = function() {
  if (this.context.length === 1) {
    this.exprAllowed = true;
    return;
  }
  var out2 = this.context.pop();
  if (out2 === types$2.b_stat && this.curContext().token === "function") {
    out2 = this.context.pop();
  }
  this.exprAllowed = !out2.isExpr;
};
types$1.braceL.updateContext = function(prevType) {
  this.context.push(this.braceIsBlock(prevType) ? types$2.b_stat : types$2.b_expr);
  this.exprAllowed = true;
};
types$1.dollarBraceL.updateContext = function() {
  this.context.push(types$2.b_tmpl);
  this.exprAllowed = true;
};
types$1.parenL.updateContext = function(prevType) {
  var statementParens = prevType === types$1._if || prevType === types$1._for || prevType === types$1._with || prevType === types$1._while;
  this.context.push(statementParens ? types$2.p_stat : types$2.p_expr);
  this.exprAllowed = true;
};
types$1.incDec.updateContext = function() {
};
types$1._function.updateContext = types$1._class.updateContext = function(prevType) {
  if (prevType.beforeExpr && prevType !== types$1._else && !(prevType === types$1.semi && this.curContext() !== types$2.p_stat) && !(prevType === types$1._return && lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) && !((prevType === types$1.colon || prevType === types$1.braceL) && this.curContext() === types$2.b_stat)) {
    this.context.push(types$2.f_expr);
  } else {
    this.context.push(types$2.f_stat);
  }
  this.exprAllowed = false;
};
types$1.backQuote.updateContext = function() {
  if (this.curContext() === types$2.q_tmpl) {
    this.context.pop();
  } else {
    this.context.push(types$2.q_tmpl);
  }
  this.exprAllowed = false;
};
types$1.star.updateContext = function(prevType) {
  if (prevType === types$1._function) {
    var index2 = this.context.length - 1;
    if (this.context[index2] === types$2.f_expr) {
      this.context[index2] = types$2.f_expr_gen;
    } else {
      this.context[index2] = types$2.f_gen;
    }
  }
  this.exprAllowed = true;
};
types$1.name.updateContext = function(prevType) {
  var allowed = false;
  if (this.options.ecmaVersion >= 6 && prevType !== types$1.dot) {
    if (this.value === "of" && !this.exprAllowed || this.value === "yield" && this.inGeneratorContext()) {
      allowed = true;
    }
  }
  this.exprAllowed = allowed;
};
var pp$5 = Parser.prototype;
pp$5.checkPropClash = function(prop, propHash, refDestructuringErrors) {
  if (this.options.ecmaVersion >= 9 && prop.type === "SpreadElement") {
    return;
  }
  if (this.options.ecmaVersion >= 6 && (prop.computed || prop.method || prop.shorthand)) {
    return;
  }
  var key = prop.key;
  var name2;
  switch (key.type) {
    case "Identifier":
      name2 = key.name;
      break;
    case "Literal":
      name2 = String(key.value);
      break;
    default:
      return;
  }
  var kind = prop.kind;
  if (this.options.ecmaVersion >= 6) {
    if (name2 === "__proto__" && kind === "init") {
      if (propHash.proto) {
        if (refDestructuringErrors) {
          if (refDestructuringErrors.doubleProto < 0) {
            refDestructuringErrors.doubleProto = key.start;
          }
        } else {
          this.raiseRecoverable(key.start, "Redefinition of __proto__ property");
        }
      }
      propHash.proto = true;
    }
    return;
  }
  name2 = "$" + name2;
  var other = propHash[name2];
  if (other) {
    var redefinition;
    if (kind === "init") {
      redefinition = this.strict && other.init || other.get || other.set;
    } else {
      redefinition = other.init || other[kind];
    }
    if (redefinition) {
      this.raiseRecoverable(key.start, "Redefinition of property");
    }
  } else {
    other = propHash[name2] = {
      init: false,
      get: false,
      set: false
    };
  }
  other[kind] = true;
};
pp$5.parseExpression = function(forInit, refDestructuringErrors) {
  var startPos = this.start, startLoc = this.startLoc;
  var expr = this.parseMaybeAssign(forInit, refDestructuringErrors);
  if (this.type === types$1.comma) {
    var node = this.startNodeAt(startPos, startLoc);
    node.expressions = [expr];
    while (this.eat(types$1.comma)) {
      node.expressions.push(this.parseMaybeAssign(forInit, refDestructuringErrors));
    }
    return this.finishNode(node, "SequenceExpression");
  }
  return expr;
};
pp$5.parseMaybeAssign = function(forInit, refDestructuringErrors, afterLeftParse) {
  if (this.isContextual("yield")) {
    if (this.inGenerator) {
      return this.parseYield(forInit);
    } else {
      this.exprAllowed = false;
    }
  }
  var ownDestructuringErrors = false, oldParenAssign = -1, oldTrailingComma = -1, oldDoubleProto = -1;
  if (refDestructuringErrors) {
    oldParenAssign = refDestructuringErrors.parenthesizedAssign;
    oldTrailingComma = refDestructuringErrors.trailingComma;
    oldDoubleProto = refDestructuringErrors.doubleProto;
    refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = -1;
  } else {
    refDestructuringErrors = new DestructuringErrors();
    ownDestructuringErrors = true;
  }
  var startPos = this.start, startLoc = this.startLoc;
  if (this.type === types$1.parenL || this.type === types$1.name) {
    this.potentialArrowAt = this.start;
    this.potentialArrowInForAwait = forInit === "await";
  }
  var left = this.parseMaybeConditional(forInit, refDestructuringErrors);
  if (afterLeftParse) {
    left = afterLeftParse.call(this, left, startPos, startLoc);
  }
  if (this.type.isAssign) {
    var node = this.startNodeAt(startPos, startLoc);
    node.operator = this.value;
    if (this.type === types$1.eq) {
      left = this.toAssignable(left, false, refDestructuringErrors);
    }
    if (!ownDestructuringErrors) {
      refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = refDestructuringErrors.doubleProto = -1;
    }
    if (refDestructuringErrors.shorthandAssign >= left.start) {
      refDestructuringErrors.shorthandAssign = -1;
    }
    if (this.type === types$1.eq) {
      this.checkLValPattern(left);
    } else {
      this.checkLValSimple(left);
    }
    node.left = left;
    this.next();
    node.right = this.parseMaybeAssign(forInit);
    if (oldDoubleProto > -1) {
      refDestructuringErrors.doubleProto = oldDoubleProto;
    }
    return this.finishNode(node, "AssignmentExpression");
  } else {
    if (ownDestructuringErrors) {
      this.checkExpressionErrors(refDestructuringErrors, true);
    }
  }
  if (oldParenAssign > -1) {
    refDestructuringErrors.parenthesizedAssign = oldParenAssign;
  }
  if (oldTrailingComma > -1) {
    refDestructuringErrors.trailingComma = oldTrailingComma;
  }
  return left;
};
pp$5.parseMaybeConditional = function(forInit, refDestructuringErrors) {
  var startPos = this.start, startLoc = this.startLoc;
  var expr = this.parseExprOps(forInit, refDestructuringErrors);
  if (this.checkExpressionErrors(refDestructuringErrors)) {
    return expr;
  }
  if (this.eat(types$1.question)) {
    var node = this.startNodeAt(startPos, startLoc);
    node.test = expr;
    node.consequent = this.parseMaybeAssign();
    this.expect(types$1.colon);
    node.alternate = this.parseMaybeAssign(forInit);
    return this.finishNode(node, "ConditionalExpression");
  }
  return expr;
};
pp$5.parseExprOps = function(forInit, refDestructuringErrors) {
  var startPos = this.start, startLoc = this.startLoc;
  var expr = this.parseMaybeUnary(refDestructuringErrors, false, false, forInit);
  if (this.checkExpressionErrors(refDestructuringErrors)) {
    return expr;
  }
  return expr.start === startPos && expr.type === "ArrowFunctionExpression" ? expr : this.parseExprOp(expr, startPos, startLoc, -1, forInit);
};
pp$5.parseExprOp = function(left, leftStartPos, leftStartLoc, minPrec, forInit) {
  var prec = this.type.binop;
  if (prec != null && (!forInit || this.type !== types$1._in)) {
    if (prec > minPrec) {
      var logical = this.type === types$1.logicalOR || this.type === types$1.logicalAND;
      var coalesce = this.type === types$1.coalesce;
      if (coalesce) {
        prec = types$1.logicalAND.binop;
      }
      var op = this.value;
      this.next();
      var startPos = this.start, startLoc = this.startLoc;
      var right = this.parseExprOp(this.parseMaybeUnary(null, false, false, forInit), startPos, startLoc, prec, forInit);
      var node = this.buildBinary(leftStartPos, leftStartLoc, left, right, op, logical || coalesce);
      if (logical && this.type === types$1.coalesce || coalesce && (this.type === types$1.logicalOR || this.type === types$1.logicalAND)) {
        this.raiseRecoverable(this.start, "Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses");
      }
      return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec, forInit);
    }
  }
  return left;
};
pp$5.buildBinary = function(startPos, startLoc, left, right, op, logical) {
  if (right.type === "PrivateIdentifier") {
    this.raise(right.start, "Private identifier can only be left side of binary expression");
  }
  var node = this.startNodeAt(startPos, startLoc);
  node.left = left;
  node.operator = op;
  node.right = right;
  return this.finishNode(node, logical ? "LogicalExpression" : "BinaryExpression");
};
pp$5.parseMaybeUnary = function(refDestructuringErrors, sawUnary, incDec, forInit) {
  var startPos = this.start, startLoc = this.startLoc, expr;
  if (this.isContextual("await") && this.canAwait) {
    expr = this.parseAwait(forInit);
    sawUnary = true;
  } else if (this.type.prefix) {
    var node = this.startNode(), update = this.type === types$1.incDec;
    node.operator = this.value;
    node.prefix = true;
    this.next();
    node.argument = this.parseMaybeUnary(null, true, update, forInit);
    this.checkExpressionErrors(refDestructuringErrors, true);
    if (update) {
      this.checkLValSimple(node.argument);
    } else if (this.strict && node.operator === "delete" && node.argument.type === "Identifier") {
      this.raiseRecoverable(node.start, "Deleting local variable in strict mode");
    } else if (node.operator === "delete" && isPrivateFieldAccess(node.argument)) {
      this.raiseRecoverable(node.start, "Private fields can not be deleted");
    } else {
      sawUnary = true;
    }
    expr = this.finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
  } else if (!sawUnary && this.type === types$1.privateId) {
    if (forInit || this.privateNameStack.length === 0) {
      this.unexpected();
    }
    expr = this.parsePrivateIdent();
    if (this.type !== types$1._in) {
      this.unexpected();
    }
  } else {
    expr = this.parseExprSubscripts(refDestructuringErrors, forInit);
    if (this.checkExpressionErrors(refDestructuringErrors)) {
      return expr;
    }
    while (this.type.postfix && !this.canInsertSemicolon()) {
      var node$1 = this.startNodeAt(startPos, startLoc);
      node$1.operator = this.value;
      node$1.prefix = false;
      node$1.argument = expr;
      this.checkLValSimple(expr);
      this.next();
      expr = this.finishNode(node$1, "UpdateExpression");
    }
  }
  if (!incDec && this.eat(types$1.starstar)) {
    if (sawUnary) {
      this.unexpected(this.lastTokStart);
    } else {
      return this.buildBinary(startPos, startLoc, expr, this.parseMaybeUnary(null, false, false, forInit), "**", false);
    }
  } else {
    return expr;
  }
};
function isPrivateFieldAccess(node) {
  return node.type === "MemberExpression" && node.property.type === "PrivateIdentifier" || node.type === "ChainExpression" && isPrivateFieldAccess(node.expression);
}
pp$5.parseExprSubscripts = function(refDestructuringErrors, forInit) {
  var startPos = this.start, startLoc = this.startLoc;
  var expr = this.parseExprAtom(refDestructuringErrors, forInit);
  if (expr.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")") {
    return expr;
  }
  var result = this.parseSubscripts(expr, startPos, startLoc, false, forInit);
  if (refDestructuringErrors && result.type === "MemberExpression") {
    if (refDestructuringErrors.parenthesizedAssign >= result.start) {
      refDestructuringErrors.parenthesizedAssign = -1;
    }
    if (refDestructuringErrors.parenthesizedBind >= result.start) {
      refDestructuringErrors.parenthesizedBind = -1;
    }
    if (refDestructuringErrors.trailingComma >= result.start) {
      refDestructuringErrors.trailingComma = -1;
    }
  }
  return result;
};
pp$5.parseSubscripts = function(base2, startPos, startLoc, noCalls, forInit) {
  var maybeAsyncArrow = this.options.ecmaVersion >= 8 && base2.type === "Identifier" && base2.name === "async" && this.lastTokEnd === base2.end && !this.canInsertSemicolon() && base2.end - base2.start === 5 && this.potentialArrowAt === base2.start;
  var optionalChained = false;
  while (true) {
    var element = this.parseSubscript(base2, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit);
    if (element.optional) {
      optionalChained = true;
    }
    if (element === base2 || element.type === "ArrowFunctionExpression") {
      if (optionalChained) {
        var chainNode = this.startNodeAt(startPos, startLoc);
        chainNode.expression = element;
        element = this.finishNode(chainNode, "ChainExpression");
      }
      return element;
    }
    base2 = element;
  }
};
pp$5.parseSubscript = function(base2, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit) {
  var optionalSupported = this.options.ecmaVersion >= 11;
  var optional = optionalSupported && this.eat(types$1.questionDot);
  if (noCalls && optional) {
    this.raise(this.lastTokStart, "Optional chaining cannot appear in the callee of new expressions");
  }
  var computed = this.eat(types$1.bracketL);
  if (computed || optional && this.type !== types$1.parenL && this.type !== types$1.backQuote || this.eat(types$1.dot)) {
    var node = this.startNodeAt(startPos, startLoc);
    node.object = base2;
    if (computed) {
      node.property = this.parseExpression();
      this.expect(types$1.bracketR);
    } else if (this.type === types$1.privateId && base2.type !== "Super") {
      node.property = this.parsePrivateIdent();
    } else {
      node.property = this.parseIdent(this.options.allowReserved !== "never");
    }
    node.computed = !!computed;
    if (optionalSupported) {
      node.optional = optional;
    }
    base2 = this.finishNode(node, "MemberExpression");
  } else if (!noCalls && this.eat(types$1.parenL)) {
    var refDestructuringErrors = new DestructuringErrors(), oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
    this.yieldPos = 0;
    this.awaitPos = 0;
    this.awaitIdentPos = 0;
    var exprList = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false, refDestructuringErrors);
    if (maybeAsyncArrow && !optional && !this.canInsertSemicolon() && this.eat(types$1.arrow)) {
      this.checkPatternErrors(refDestructuringErrors, false);
      this.checkYieldAwaitInDefaultParams();
      if (this.awaitIdentPos > 0) {
        this.raise(this.awaitIdentPos, "Cannot use 'await' as identifier inside an async function");
      }
      this.yieldPos = oldYieldPos;
      this.awaitPos = oldAwaitPos;
      this.awaitIdentPos = oldAwaitIdentPos;
      return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, true, forInit);
    }
    this.checkExpressionErrors(refDestructuringErrors, true);
    this.yieldPos = oldYieldPos || this.yieldPos;
    this.awaitPos = oldAwaitPos || this.awaitPos;
    this.awaitIdentPos = oldAwaitIdentPos || this.awaitIdentPos;
    var node$1 = this.startNodeAt(startPos, startLoc);
    node$1.callee = base2;
    node$1.arguments = exprList;
    if (optionalSupported) {
      node$1.optional = optional;
    }
    base2 = this.finishNode(node$1, "CallExpression");
  } else if (this.type === types$1.backQuote) {
    if (optional || optionalChained) {
      this.raise(this.start, "Optional chaining cannot appear in the tag of tagged template expressions");
    }
    var node$2 = this.startNodeAt(startPos, startLoc);
    node$2.tag = base2;
    node$2.quasi = this.parseTemplate({ isTagged: true });
    base2 = this.finishNode(node$2, "TaggedTemplateExpression");
  }
  return base2;
};
pp$5.parseExprAtom = function(refDestructuringErrors, forInit) {
  if (this.type === types$1.slash) {
    this.readRegexp();
  }
  var node, canBeArrow = this.potentialArrowAt === this.start;
  switch (this.type) {
    case types$1._super:
      if (!this.allowSuper) {
        this.raise(this.start, "'super' keyword outside a method");
      }
      node = this.startNode();
      this.next();
      if (this.type === types$1.parenL && !this.allowDirectSuper) {
        this.raise(node.start, "super() call outside constructor of a subclass");
      }
      if (this.type !== types$1.dot && this.type !== types$1.bracketL && this.type !== types$1.parenL) {
        this.unexpected();
      }
      return this.finishNode(node, "Super");
    case types$1._this:
      node = this.startNode();
      this.next();
      return this.finishNode(node, "ThisExpression");
    case types$1.name:
      var startPos = this.start, startLoc = this.startLoc, containsEsc = this.containsEsc;
      var id2 = this.parseIdent(false);
      if (this.options.ecmaVersion >= 8 && !containsEsc && id2.name === "async" && !this.canInsertSemicolon() && this.eat(types$1._function)) {
        this.overrideContext(types$2.f_expr);
        return this.parseFunction(this.startNodeAt(startPos, startLoc), 0, false, true, forInit);
      }
      if (canBeArrow && !this.canInsertSemicolon()) {
        if (this.eat(types$1.arrow)) {
          return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id2], false, forInit);
        }
        if (this.options.ecmaVersion >= 8 && id2.name === "async" && this.type === types$1.name && !containsEsc && (!this.potentialArrowInForAwait || this.value !== "of" || this.containsEsc)) {
          id2 = this.parseIdent(false);
          if (this.canInsertSemicolon() || !this.eat(types$1.arrow)) {
            this.unexpected();
          }
          return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id2], true, forInit);
        }
      }
      return id2;
    case types$1.regexp:
      var value = this.value;
      node = this.parseLiteral(value.value);
      node.regex = { pattern: value.pattern, flags: value.flags };
      return node;
    case types$1.num:
    case types$1.string:
      return this.parseLiteral(this.value);
    case types$1._null:
    case types$1._true:
    case types$1._false:
      node = this.startNode();
      node.value = this.type === types$1._null ? null : this.type === types$1._true;
      node.raw = this.type.keyword;
      this.next();
      return this.finishNode(node, "Literal");
    case types$1.parenL:
      var start2 = this.start, expr = this.parseParenAndDistinguishExpression(canBeArrow, forInit);
      if (refDestructuringErrors) {
        if (refDestructuringErrors.parenthesizedAssign < 0 && !this.isSimpleAssignTarget(expr)) {
          refDestructuringErrors.parenthesizedAssign = start2;
        }
        if (refDestructuringErrors.parenthesizedBind < 0) {
          refDestructuringErrors.parenthesizedBind = start2;
        }
      }
      return expr;
    case types$1.bracketL:
      node = this.startNode();
      this.next();
      node.elements = this.parseExprList(types$1.bracketR, true, true, refDestructuringErrors);
      return this.finishNode(node, "ArrayExpression");
    case types$1.braceL:
      this.overrideContext(types$2.b_expr);
      return this.parseObj(false, refDestructuringErrors);
    case types$1._function:
      node = this.startNode();
      this.next();
      return this.parseFunction(node, 0);
    case types$1._class:
      return this.parseClass(this.startNode(), false);
    case types$1._new:
      return this.parseNew();
    case types$1.backQuote:
      return this.parseTemplate();
    case types$1._import:
      if (this.options.ecmaVersion >= 11) {
        return this.parseExprImport();
      } else {
        return this.unexpected();
      }
    default:
      this.unexpected();
  }
};
pp$5.parseExprImport = function() {
  var node = this.startNode();
  if (this.containsEsc) {
    this.raiseRecoverable(this.start, "Escape sequence in keyword import");
  }
  var meta = this.parseIdent(true);
  switch (this.type) {
    case types$1.parenL:
      return this.parseDynamicImport(node);
    case types$1.dot:
      node.meta = meta;
      return this.parseImportMeta(node);
    default:
      this.unexpected();
  }
};
pp$5.parseDynamicImport = function(node) {
  this.next();
  node.source = this.parseMaybeAssign();
  if (!this.eat(types$1.parenR)) {
    var errorPos = this.start;
    if (this.eat(types$1.comma) && this.eat(types$1.parenR)) {
      this.raiseRecoverable(errorPos, "Trailing comma is not allowed in import()");
    } else {
      this.unexpected(errorPos);
    }
  }
  return this.finishNode(node, "ImportExpression");
};
pp$5.parseImportMeta = function(node) {
  this.next();
  var containsEsc = this.containsEsc;
  node.property = this.parseIdent(true);
  if (node.property.name !== "meta") {
    this.raiseRecoverable(node.property.start, "The only valid meta property for import is 'import.meta'");
  }
  if (containsEsc) {
    this.raiseRecoverable(node.start, "'import.meta' must not contain escaped characters");
  }
  if (this.options.sourceType !== "module" && !this.options.allowImportExportEverywhere) {
    this.raiseRecoverable(node.start, "Cannot use 'import.meta' outside a module");
  }
  return this.finishNode(node, "MetaProperty");
};
pp$5.parseLiteral = function(value) {
  var node = this.startNode();
  node.value = value;
  node.raw = this.input.slice(this.start, this.end);
  if (node.raw.charCodeAt(node.raw.length - 1) === 110) {
    node.bigint = node.raw.slice(0, -1).replace(/_/g, "");
  }
  this.next();
  return this.finishNode(node, "Literal");
};
pp$5.parseParenExpression = function() {
  this.expect(types$1.parenL);
  var val = this.parseExpression();
  this.expect(types$1.parenR);
  return val;
};
pp$5.parseParenAndDistinguishExpression = function(canBeArrow, forInit) {
  var startPos = this.start, startLoc = this.startLoc, val, allowTrailingComma = this.options.ecmaVersion >= 8;
  if (this.options.ecmaVersion >= 6) {
    this.next();
    var innerStartPos = this.start, innerStartLoc = this.startLoc;
    var exprList = [], first = true, lastIsComma = false;
    var refDestructuringErrors = new DestructuringErrors(), oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, spreadStart;
    this.yieldPos = 0;
    this.awaitPos = 0;
    while (this.type !== types$1.parenR) {
      first ? first = false : this.expect(types$1.comma);
      if (allowTrailingComma && this.afterTrailingComma(types$1.parenR, true)) {
        lastIsComma = true;
        break;
      } else if (this.type === types$1.ellipsis) {
        spreadStart = this.start;
        exprList.push(this.parseParenItem(this.parseRestBinding()));
        if (this.type === types$1.comma) {
          this.raise(this.start, "Comma is not permitted after the rest element");
        }
        break;
      } else {
        exprList.push(this.parseMaybeAssign(false, refDestructuringErrors, this.parseParenItem));
      }
    }
    var innerEndPos = this.lastTokEnd, innerEndLoc = this.lastTokEndLoc;
    this.expect(types$1.parenR);
    if (canBeArrow && !this.canInsertSemicolon() && this.eat(types$1.arrow)) {
      this.checkPatternErrors(refDestructuringErrors, false);
      this.checkYieldAwaitInDefaultParams();
      this.yieldPos = oldYieldPos;
      this.awaitPos = oldAwaitPos;
      return this.parseParenArrowList(startPos, startLoc, exprList, forInit);
    }
    if (!exprList.length || lastIsComma) {
      this.unexpected(this.lastTokStart);
    }
    if (spreadStart) {
      this.unexpected(spreadStart);
    }
    this.checkExpressionErrors(refDestructuringErrors, true);
    this.yieldPos = oldYieldPos || this.yieldPos;
    this.awaitPos = oldAwaitPos || this.awaitPos;
    if (exprList.length > 1) {
      val = this.startNodeAt(innerStartPos, innerStartLoc);
      val.expressions = exprList;
      this.finishNodeAt(val, "SequenceExpression", innerEndPos, innerEndLoc);
    } else {
      val = exprList[0];
    }
  } else {
    val = this.parseParenExpression();
  }
  if (this.options.preserveParens) {
    var par = this.startNodeAt(startPos, startLoc);
    par.expression = val;
    return this.finishNode(par, "ParenthesizedExpression");
  } else {
    return val;
  }
};
pp$5.parseParenItem = function(item) {
  return item;
};
pp$5.parseParenArrowList = function(startPos, startLoc, exprList, forInit) {
  return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, false, forInit);
};
var empty = [];
pp$5.parseNew = function() {
  if (this.containsEsc) {
    this.raiseRecoverable(this.start, "Escape sequence in keyword new");
  }
  var node = this.startNode();
  var meta = this.parseIdent(true);
  if (this.options.ecmaVersion >= 6 && this.eat(types$1.dot)) {
    node.meta = meta;
    var containsEsc = this.containsEsc;
    node.property = this.parseIdent(true);
    if (node.property.name !== "target") {
      this.raiseRecoverable(node.property.start, "The only valid meta property for new is 'new.target'");
    }
    if (containsEsc) {
      this.raiseRecoverable(node.start, "'new.target' must not contain escaped characters");
    }
    if (!this.allowNewDotTarget) {
      this.raiseRecoverable(node.start, "'new.target' can only be used in functions and class static block");
    }
    return this.finishNode(node, "MetaProperty");
  }
  var startPos = this.start, startLoc = this.startLoc, isImport = this.type === types$1._import;
  node.callee = this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true, false);
  if (isImport && node.callee.type === "ImportExpression") {
    this.raise(startPos, "Cannot use new with import()");
  }
  if (this.eat(types$1.parenL)) {
    node.arguments = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false);
  } else {
    node.arguments = empty;
  }
  return this.finishNode(node, "NewExpression");
};
pp$5.parseTemplateElement = function(ref2) {
  var isTagged = ref2.isTagged;
  var elem = this.startNode();
  if (this.type === types$1.invalidTemplate) {
    if (!isTagged) {
      this.raiseRecoverable(this.start, "Bad escape sequence in untagged template literal");
    }
    elem.value = {
      raw: this.value,
      cooked: null
    };
  } else {
    elem.value = {
      raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, "\n"),
      cooked: this.value
    };
  }
  this.next();
  elem.tail = this.type === types$1.backQuote;
  return this.finishNode(elem, "TemplateElement");
};
pp$5.parseTemplate = function(ref2) {
  if (ref2 === void 0)
    ref2 = {};
  var isTagged = ref2.isTagged;
  if (isTagged === void 0)
    isTagged = false;
  var node = this.startNode();
  this.next();
  node.expressions = [];
  var curElt = this.parseTemplateElement({ isTagged });
  node.quasis = [curElt];
  while (!curElt.tail) {
    if (this.type === types$1.eof) {
      this.raise(this.pos, "Unterminated template literal");
    }
    this.expect(types$1.dollarBraceL);
    node.expressions.push(this.parseExpression());
    this.expect(types$1.braceR);
    node.quasis.push(curElt = this.parseTemplateElement({ isTagged }));
  }
  this.next();
  return this.finishNode(node, "TemplateLiteral");
};
pp$5.isAsyncProp = function(prop) {
  return !prop.computed && prop.key.type === "Identifier" && prop.key.name === "async" && (this.type === types$1.name || this.type === types$1.num || this.type === types$1.string || this.type === types$1.bracketL || this.type.keyword || this.options.ecmaVersion >= 9 && this.type === types$1.star) && !lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
};
pp$5.parseObj = function(isPattern2, refDestructuringErrors) {
  var node = this.startNode(), first = true, propHash = {};
  node.properties = [];
  this.next();
  while (!this.eat(types$1.braceR)) {
    if (!first) {
      this.expect(types$1.comma);
      if (this.options.ecmaVersion >= 5 && this.afterTrailingComma(types$1.braceR)) {
        break;
      }
    } else {
      first = false;
    }
    var prop = this.parseProperty(isPattern2, refDestructuringErrors);
    if (!isPattern2) {
      this.checkPropClash(prop, propHash, refDestructuringErrors);
    }
    node.properties.push(prop);
  }
  return this.finishNode(node, isPattern2 ? "ObjectPattern" : "ObjectExpression");
};
pp$5.parseProperty = function(isPattern2, refDestructuringErrors) {
  var prop = this.startNode(), isGenerator, isAsync, startPos, startLoc;
  if (this.options.ecmaVersion >= 9 && this.eat(types$1.ellipsis)) {
    if (isPattern2) {
      prop.argument = this.parseIdent(false);
      if (this.type === types$1.comma) {
        this.raise(this.start, "Comma is not permitted after the rest element");
      }
      return this.finishNode(prop, "RestElement");
    }
    if (this.type === types$1.parenL && refDestructuringErrors) {
      if (refDestructuringErrors.parenthesizedAssign < 0) {
        refDestructuringErrors.parenthesizedAssign = this.start;
      }
      if (refDestructuringErrors.parenthesizedBind < 0) {
        refDestructuringErrors.parenthesizedBind = this.start;
      }
    }
    prop.argument = this.parseMaybeAssign(false, refDestructuringErrors);
    if (this.type === types$1.comma && refDestructuringErrors && refDestructuringErrors.trailingComma < 0) {
      refDestructuringErrors.trailingComma = this.start;
    }
    return this.finishNode(prop, "SpreadElement");
  }
  if (this.options.ecmaVersion >= 6) {
    prop.method = false;
    prop.shorthand = false;
    if (isPattern2 || refDestructuringErrors) {
      startPos = this.start;
      startLoc = this.startLoc;
    }
    if (!isPattern2) {
      isGenerator = this.eat(types$1.star);
    }
  }
  var containsEsc = this.containsEsc;
  this.parsePropertyName(prop);
  if (!isPattern2 && !containsEsc && this.options.ecmaVersion >= 8 && !isGenerator && this.isAsyncProp(prop)) {
    isAsync = true;
    isGenerator = this.options.ecmaVersion >= 9 && this.eat(types$1.star);
    this.parsePropertyName(prop, refDestructuringErrors);
  } else {
    isAsync = false;
  }
  this.parsePropertyValue(prop, isPattern2, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc);
  return this.finishNode(prop, "Property");
};
pp$5.parsePropertyValue = function(prop, isPattern2, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc) {
  if ((isGenerator || isAsync) && this.type === types$1.colon) {
    this.unexpected();
  }
  if (this.eat(types$1.colon)) {
    prop.value = isPattern2 ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, refDestructuringErrors);
    prop.kind = "init";
  } else if (this.options.ecmaVersion >= 6 && this.type === types$1.parenL) {
    if (isPattern2) {
      this.unexpected();
    }
    prop.kind = "init";
    prop.method = true;
    prop.value = this.parseMethod(isGenerator, isAsync);
  } else if (!isPattern2 && !containsEsc && this.options.ecmaVersion >= 5 && !prop.computed && prop.key.type === "Identifier" && (prop.key.name === "get" || prop.key.name === "set") && (this.type !== types$1.comma && this.type !== types$1.braceR && this.type !== types$1.eq)) {
    if (isGenerator || isAsync) {
      this.unexpected();
    }
    prop.kind = prop.key.name;
    this.parsePropertyName(prop);
    prop.value = this.parseMethod(false);
    var paramCount = prop.kind === "get" ? 0 : 1;
    if (prop.value.params.length !== paramCount) {
      var start2 = prop.value.start;
      if (prop.kind === "get") {
        this.raiseRecoverable(start2, "getter should have no params");
      } else {
        this.raiseRecoverable(start2, "setter should have exactly one param");
      }
    } else {
      if (prop.kind === "set" && prop.value.params[0].type === "RestElement") {
        this.raiseRecoverable(prop.value.params[0].start, "Setter cannot use rest params");
      }
    }
  } else if (this.options.ecmaVersion >= 6 && !prop.computed && prop.key.type === "Identifier") {
    if (isGenerator || isAsync) {
      this.unexpected();
    }
    this.checkUnreserved(prop.key);
    if (prop.key.name === "await" && !this.awaitIdentPos) {
      this.awaitIdentPos = startPos;
    }
    prop.kind = "init";
    if (isPattern2) {
      prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
    } else if (this.type === types$1.eq && refDestructuringErrors) {
      if (refDestructuringErrors.shorthandAssign < 0) {
        refDestructuringErrors.shorthandAssign = this.start;
      }
      prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
    } else {
      prop.value = this.copyNode(prop.key);
    }
    prop.shorthand = true;
  } else {
    this.unexpected();
  }
};
pp$5.parsePropertyName = function(prop) {
  if (this.options.ecmaVersion >= 6) {
    if (this.eat(types$1.bracketL)) {
      prop.computed = true;
      prop.key = this.parseMaybeAssign();
      this.expect(types$1.bracketR);
      return prop.key;
    } else {
      prop.computed = false;
    }
  }
  return prop.key = this.type === types$1.num || this.type === types$1.string ? this.parseExprAtom() : this.parseIdent(this.options.allowReserved !== "never");
};
pp$5.initFunction = function(node) {
  node.id = null;
  if (this.options.ecmaVersion >= 6) {
    node.generator = node.expression = false;
  }
  if (this.options.ecmaVersion >= 8) {
    node.async = false;
  }
};
pp$5.parseMethod = function(isGenerator, isAsync, allowDirectSuper) {
  var node = this.startNode(), oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
  this.initFunction(node);
  if (this.options.ecmaVersion >= 6) {
    node.generator = isGenerator;
  }
  if (this.options.ecmaVersion >= 8) {
    node.async = !!isAsync;
  }
  this.yieldPos = 0;
  this.awaitPos = 0;
  this.awaitIdentPos = 0;
  this.enterScope(functionFlags(isAsync, node.generator) | SCOPE_SUPER | (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0));
  this.expect(types$1.parenL);
  node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
  this.checkYieldAwaitInDefaultParams();
  this.parseFunctionBody(node, false, true, false);
  this.yieldPos = oldYieldPos;
  this.awaitPos = oldAwaitPos;
  this.awaitIdentPos = oldAwaitIdentPos;
  return this.finishNode(node, "FunctionExpression");
};
pp$5.parseArrowExpression = function(node, params, isAsync, forInit) {
  var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
  this.enterScope(functionFlags(isAsync, false) | SCOPE_ARROW);
  this.initFunction(node);
  if (this.options.ecmaVersion >= 8) {
    node.async = !!isAsync;
  }
  this.yieldPos = 0;
  this.awaitPos = 0;
  this.awaitIdentPos = 0;
  node.params = this.toAssignableList(params, true);
  this.parseFunctionBody(node, true, false, forInit);
  this.yieldPos = oldYieldPos;
  this.awaitPos = oldAwaitPos;
  this.awaitIdentPos = oldAwaitIdentPos;
  return this.finishNode(node, "ArrowFunctionExpression");
};
pp$5.parseFunctionBody = function(node, isArrowFunction, isMethod, forInit) {
  var isExpression = isArrowFunction && this.type !== types$1.braceL;
  var oldStrict = this.strict, useStrict = false;
  if (isExpression) {
    node.body = this.parseMaybeAssign(forInit);
    node.expression = true;
    this.checkParams(node, false);
  } else {
    var nonSimple = this.options.ecmaVersion >= 7 && !this.isSimpleParamList(node.params);
    if (!oldStrict || nonSimple) {
      useStrict = this.strictDirective(this.end);
      if (useStrict && nonSimple) {
        this.raiseRecoverable(node.start, "Illegal 'use strict' directive in function with non-simple parameter list");
      }
    }
    var oldLabels = this.labels;
    this.labels = [];
    if (useStrict) {
      this.strict = true;
    }
    this.checkParams(node, !oldStrict && !useStrict && !isArrowFunction && !isMethod && this.isSimpleParamList(node.params));
    if (this.strict && node.id) {
      this.checkLValSimple(node.id, BIND_OUTSIDE);
    }
    node.body = this.parseBlock(false, void 0, useStrict && !oldStrict);
    node.expression = false;
    this.adaptDirectivePrologue(node.body.body);
    this.labels = oldLabels;
  }
  this.exitScope();
};
pp$5.isSimpleParamList = function(params) {
  for (var i = 0, list = params; i < list.length; i += 1) {
    var param = list[i];
    if (param.type !== "Identifier") {
      return false;
    }
  }
  return true;
};
pp$5.checkParams = function(node, allowDuplicates) {
  var nameHash = /* @__PURE__ */ Object.create(null);
  for (var i = 0, list = node.params; i < list.length; i += 1) {
    var param = list[i];
    this.checkLValInnerPattern(param, BIND_VAR, allowDuplicates ? null : nameHash);
  }
};
pp$5.parseExprList = function(close, allowTrailingComma, allowEmpty, refDestructuringErrors) {
  var elts = [], first = true;
  while (!this.eat(close)) {
    if (!first) {
      this.expect(types$1.comma);
      if (allowTrailingComma && this.afterTrailingComma(close)) {
        break;
      }
    } else {
      first = false;
    }
    var elt = void 0;
    if (allowEmpty && this.type === types$1.comma) {
      elt = null;
    } else if (this.type === types$1.ellipsis) {
      elt = this.parseSpread(refDestructuringErrors);
      if (refDestructuringErrors && this.type === types$1.comma && refDestructuringErrors.trailingComma < 0) {
        refDestructuringErrors.trailingComma = this.start;
      }
    } else {
      elt = this.parseMaybeAssign(false, refDestructuringErrors);
    }
    elts.push(elt);
  }
  return elts;
};
pp$5.checkUnreserved = function(ref2) {
  var start2 = ref2.start;
  var end2 = ref2.end;
  var name2 = ref2.name;
  if (this.inGenerator && name2 === "yield") {
    this.raiseRecoverable(start2, "Cannot use 'yield' as identifier inside a generator");
  }
  if (this.inAsync && name2 === "await") {
    this.raiseRecoverable(start2, "Cannot use 'await' as identifier inside an async function");
  }
  if (this.currentThisScope().inClassFieldInit && name2 === "arguments") {
    this.raiseRecoverable(start2, "Cannot use 'arguments' in class field initializer");
  }
  if (this.inClassStaticBlock && (name2 === "arguments" || name2 === "await")) {
    this.raise(start2, "Cannot use " + name2 + " in class static initialization block");
  }
  if (this.keywords.test(name2)) {
    this.raise(start2, "Unexpected keyword '" + name2 + "'");
  }
  if (this.options.ecmaVersion < 6 && this.input.slice(start2, end2).indexOf("\\") !== -1) {
    return;
  }
  var re2 = this.strict ? this.reservedWordsStrict : this.reservedWords;
  if (re2.test(name2)) {
    if (!this.inAsync && name2 === "await") {
      this.raiseRecoverable(start2, "Cannot use keyword 'await' outside an async function");
    }
    this.raiseRecoverable(start2, "The keyword '" + name2 + "' is reserved");
  }
};
pp$5.parseIdent = function(liberal, isBinding) {
  var node = this.startNode();
  if (this.type === types$1.name) {
    node.name = this.value;
  } else if (this.type.keyword) {
    node.name = this.type.keyword;
    if ((node.name === "class" || node.name === "function") && (this.lastTokEnd !== this.lastTokStart + 1 || this.input.charCodeAt(this.lastTokStart) !== 46)) {
      this.context.pop();
    }
  } else {
    this.unexpected();
  }
  this.next(!!liberal);
  this.finishNode(node, "Identifier");
  if (!liberal) {
    this.checkUnreserved(node);
    if (node.name === "await" && !this.awaitIdentPos) {
      this.awaitIdentPos = node.start;
    }
  }
  return node;
};
pp$5.parsePrivateIdent = function() {
  var node = this.startNode();
  if (this.type === types$1.privateId) {
    node.name = this.value;
  } else {
    this.unexpected();
  }
  this.next();
  this.finishNode(node, "PrivateIdentifier");
  if (this.privateNameStack.length === 0) {
    this.raise(node.start, "Private field '#" + node.name + "' must be declared in an enclosing class");
  } else {
    this.privateNameStack[this.privateNameStack.length - 1].used.push(node);
  }
  return node;
};
pp$5.parseYield = function(forInit) {
  if (!this.yieldPos) {
    this.yieldPos = this.start;
  }
  var node = this.startNode();
  this.next();
  if (this.type === types$1.semi || this.canInsertSemicolon() || this.type !== types$1.star && !this.type.startsExpr) {
    node.delegate = false;
    node.argument = null;
  } else {
    node.delegate = this.eat(types$1.star);
    node.argument = this.parseMaybeAssign(forInit);
  }
  return this.finishNode(node, "YieldExpression");
};
pp$5.parseAwait = function(forInit) {
  if (!this.awaitPos) {
    this.awaitPos = this.start;
  }
  var node = this.startNode();
  this.next();
  node.argument = this.parseMaybeUnary(null, true, false, forInit);
  return this.finishNode(node, "AwaitExpression");
};
var pp$4 = Parser.prototype;
pp$4.raise = function(pos, message) {
  var loc = getLineInfo(this.input, pos);
  message += " (" + loc.line + ":" + loc.column + ")";
  var err = new SyntaxError(message);
  err.pos = pos;
  err.loc = loc;
  err.raisedAt = this.pos;
  throw err;
};
pp$4.raiseRecoverable = pp$4.raise;
pp$4.curPosition = function() {
  if (this.options.locations) {
    return new Position(this.curLine, this.pos - this.lineStart);
  }
};
var pp$3 = Parser.prototype;
var Scope = function Scope2(flags) {
  this.flags = flags;
  this.var = [];
  this.lexical = [];
  this.functions = [];
  this.inClassFieldInit = false;
};
pp$3.enterScope = function(flags) {
  this.scopeStack.push(new Scope(flags));
};
pp$3.exitScope = function() {
  this.scopeStack.pop();
};
pp$3.treatFunctionsAsVarInScope = function(scope) {
  return scope.flags & SCOPE_FUNCTION || !this.inModule && scope.flags & SCOPE_TOP;
};
pp$3.declareName = function(name2, bindingType, pos) {
  var redeclared = false;
  if (bindingType === BIND_LEXICAL) {
    var scope = this.currentScope();
    redeclared = scope.lexical.indexOf(name2) > -1 || scope.functions.indexOf(name2) > -1 || scope.var.indexOf(name2) > -1;
    scope.lexical.push(name2);
    if (this.inModule && scope.flags & SCOPE_TOP) {
      delete this.undefinedExports[name2];
    }
  } else if (bindingType === BIND_SIMPLE_CATCH) {
    var scope$1 = this.currentScope();
    scope$1.lexical.push(name2);
  } else if (bindingType === BIND_FUNCTION) {
    var scope$2 = this.currentScope();
    if (this.treatFunctionsAsVar) {
      redeclared = scope$2.lexical.indexOf(name2) > -1;
    } else {
      redeclared = scope$2.lexical.indexOf(name2) > -1 || scope$2.var.indexOf(name2) > -1;
    }
    scope$2.functions.push(name2);
  } else {
    for (var i = this.scopeStack.length - 1; i >= 0; --i) {
      var scope$3 = this.scopeStack[i];
      if (scope$3.lexical.indexOf(name2) > -1 && !(scope$3.flags & SCOPE_SIMPLE_CATCH && scope$3.lexical[0] === name2) || !this.treatFunctionsAsVarInScope(scope$3) && scope$3.functions.indexOf(name2) > -1) {
        redeclared = true;
        break;
      }
      scope$3.var.push(name2);
      if (this.inModule && scope$3.flags & SCOPE_TOP) {
        delete this.undefinedExports[name2];
      }
      if (scope$3.flags & SCOPE_VAR) {
        break;
      }
    }
  }
  if (redeclared) {
    this.raiseRecoverable(pos, "Identifier '" + name2 + "' has already been declared");
  }
};
pp$3.checkLocalExport = function(id2) {
  if (this.scopeStack[0].lexical.indexOf(id2.name) === -1 && this.scopeStack[0].var.indexOf(id2.name) === -1) {
    this.undefinedExports[id2.name] = id2;
  }
};
pp$3.currentScope = function() {
  return this.scopeStack[this.scopeStack.length - 1];
};
pp$3.currentVarScope = function() {
  for (var i = this.scopeStack.length - 1; ; i--) {
    var scope = this.scopeStack[i];
    if (scope.flags & SCOPE_VAR) {
      return scope;
    }
  }
};
pp$3.currentThisScope = function() {
  for (var i = this.scopeStack.length - 1; ; i--) {
    var scope = this.scopeStack[i];
    if (scope.flags & SCOPE_VAR && !(scope.flags & SCOPE_ARROW)) {
      return scope;
    }
  }
};
var Node = function Node2(parser, pos, loc) {
  this.type = "";
  this.start = pos;
  this.end = 0;
  if (parser.options.locations) {
    this.loc = new SourceLocation(parser, loc);
  }
  if (parser.options.directSourceFile) {
    this.sourceFile = parser.options.directSourceFile;
  }
  if (parser.options.ranges) {
    this.range = [pos, 0];
  }
};
var pp$2 = Parser.prototype;
pp$2.startNode = function() {
  return new Node(this, this.start, this.startLoc);
};
pp$2.startNodeAt = function(pos, loc) {
  return new Node(this, pos, loc);
};
function finishNodeAt(node, type4, pos, loc) {
  node.type = type4;
  node.end = pos;
  if (this.options.locations) {
    node.loc.end = loc;
  }
  if (this.options.ranges) {
    node.range[1] = pos;
  }
  return node;
}
pp$2.finishNode = function(node, type4) {
  return finishNodeAt.call(this, node, type4, this.lastTokEnd, this.lastTokEndLoc);
};
pp$2.finishNodeAt = function(node, type4, pos, loc) {
  return finishNodeAt.call(this, node, type4, pos, loc);
};
pp$2.copyNode = function(node) {
  var newNode = new Node(this, node.start, this.startLoc);
  for (var prop in node) {
    newNode[prop] = node[prop];
  }
  return newNode;
};
var ecma9BinaryProperties = "ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS";
var ecma10BinaryProperties = ecma9BinaryProperties + " Extended_Pictographic";
var ecma11BinaryProperties = ecma10BinaryProperties;
var ecma12BinaryProperties = ecma11BinaryProperties + " EBase EComp EMod EPres ExtPict";
var ecma13BinaryProperties = ecma12BinaryProperties;
var unicodeBinaryProperties = {
  9: ecma9BinaryProperties,
  10: ecma10BinaryProperties,
  11: ecma11BinaryProperties,
  12: ecma12BinaryProperties,
  13: ecma13BinaryProperties
};
var unicodeGeneralCategoryValues = "Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu";
var ecma9ScriptValues = "Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb";
var ecma10ScriptValues = ecma9ScriptValues + " Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd";
var ecma11ScriptValues = ecma10ScriptValues + " Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho";
var ecma12ScriptValues = ecma11ScriptValues + " Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi";
var ecma13ScriptValues = ecma12ScriptValues + " Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith";
var unicodeScriptValues = {
  9: ecma9ScriptValues,
  10: ecma10ScriptValues,
  11: ecma11ScriptValues,
  12: ecma12ScriptValues,
  13: ecma13ScriptValues
};
var data = {};
function buildUnicodeData(ecmaVersion) {
  var d2 = data[ecmaVersion] = {
    binary: wordsRegexp(unicodeBinaryProperties[ecmaVersion] + " " + unicodeGeneralCategoryValues),
    nonBinary: {
      General_Category: wordsRegexp(unicodeGeneralCategoryValues),
      Script: wordsRegexp(unicodeScriptValues[ecmaVersion])
    }
  };
  d2.nonBinary.Script_Extensions = d2.nonBinary.Script;
  d2.nonBinary.gc = d2.nonBinary.General_Category;
  d2.nonBinary.sc = d2.nonBinary.Script;
  d2.nonBinary.scx = d2.nonBinary.Script_Extensions;
}
for (var i = 0, list = [9, 10, 11, 12, 13]; i < list.length; i += 1) {
  var ecmaVersion = list[i];
  buildUnicodeData(ecmaVersion);
}
var pp$1 = Parser.prototype;
var RegExpValidationState = function RegExpValidationState2(parser) {
  this.parser = parser;
  this.validFlags = "gim" + (parser.options.ecmaVersion >= 6 ? "uy" : "") + (parser.options.ecmaVersion >= 9 ? "s" : "") + (parser.options.ecmaVersion >= 13 ? "d" : "");
  this.unicodeProperties = data[parser.options.ecmaVersion >= 13 ? 13 : parser.options.ecmaVersion];
  this.source = "";
  this.flags = "";
  this.start = 0;
  this.switchU = false;
  this.switchN = false;
  this.pos = 0;
  this.lastIntValue = 0;
  this.lastStringValue = "";
  this.lastAssertionIsQuantifiable = false;
  this.numCapturingParens = 0;
  this.maxBackReference = 0;
  this.groupNames = [];
  this.backReferenceNames = [];
};
RegExpValidationState.prototype.reset = function reset(start2, pattern4, flags) {
  var unicode = flags.indexOf("u") !== -1;
  this.start = start2 | 0;
  this.source = pattern4 + "";
  this.flags = flags;
  this.switchU = unicode && this.parser.options.ecmaVersion >= 6;
  this.switchN = unicode && this.parser.options.ecmaVersion >= 9;
};
RegExpValidationState.prototype.raise = function raise(message) {
  this.parser.raiseRecoverable(this.start, "Invalid regular expression: /" + this.source + "/: " + message);
};
RegExpValidationState.prototype.at = function at(i, forceU) {
  if (forceU === void 0)
    forceU = false;
  var s = this.source;
  var l2 = s.length;
  if (i >= l2) {
    return -1;
  }
  var c2 = s.charCodeAt(i);
  if (!(forceU || this.switchU) || c2 <= 55295 || c2 >= 57344 || i + 1 >= l2) {
    return c2;
  }
  var next = s.charCodeAt(i + 1);
  return next >= 56320 && next <= 57343 ? (c2 << 10) + next - 56613888 : c2;
};
RegExpValidationState.prototype.nextIndex = function nextIndex(i, forceU) {
  if (forceU === void 0)
    forceU = false;
  var s = this.source;
  var l2 = s.length;
  if (i >= l2) {
    return l2;
  }
  var c2 = s.charCodeAt(i), next;
  if (!(forceU || this.switchU) || c2 <= 55295 || c2 >= 57344 || i + 1 >= l2 || (next = s.charCodeAt(i + 1)) < 56320 || next > 57343) {
    return i + 1;
  }
  return i + 2;
};
RegExpValidationState.prototype.current = function current(forceU) {
  if (forceU === void 0)
    forceU = false;
  return this.at(this.pos, forceU);
};
RegExpValidationState.prototype.lookahead = function lookahead(forceU) {
  if (forceU === void 0)
    forceU = false;
  return this.at(this.nextIndex(this.pos, forceU), forceU);
};
RegExpValidationState.prototype.advance = function advance(forceU) {
  if (forceU === void 0)
    forceU = false;
  this.pos = this.nextIndex(this.pos, forceU);
};
RegExpValidationState.prototype.eat = function eat(ch2, forceU) {
  if (forceU === void 0)
    forceU = false;
  if (this.current(forceU) === ch2) {
    this.advance(forceU);
    return true;
  }
  return false;
};
pp$1.validateRegExpFlags = function(state) {
  var validFlags = state.validFlags;
  var flags = state.flags;
  for (var i = 0; i < flags.length; i++) {
    var flag = flags.charAt(i);
    if (validFlags.indexOf(flag) === -1) {
      this.raise(state.start, "Invalid regular expression flag");
    }
    if (flags.indexOf(flag, i + 1) > -1) {
      this.raise(state.start, "Duplicate regular expression flag");
    }
  }
};
pp$1.validateRegExpPattern = function(state) {
  this.regexp_pattern(state);
  if (!state.switchN && this.options.ecmaVersion >= 9 && state.groupNames.length > 0) {
    state.switchN = true;
    this.regexp_pattern(state);
  }
};
pp$1.regexp_pattern = function(state) {
  state.pos = 0;
  state.lastIntValue = 0;
  state.lastStringValue = "";
  state.lastAssertionIsQuantifiable = false;
  state.numCapturingParens = 0;
  state.maxBackReference = 0;
  state.groupNames.length = 0;
  state.backReferenceNames.length = 0;
  this.regexp_disjunction(state);
  if (state.pos !== state.source.length) {
    if (state.eat(41)) {
      state.raise("Unmatched ')'");
    }
    if (state.eat(93) || state.eat(125)) {
      state.raise("Lone quantifier brackets");
    }
  }
  if (state.maxBackReference > state.numCapturingParens) {
    state.raise("Invalid escape");
  }
  for (var i = 0, list = state.backReferenceNames; i < list.length; i += 1) {
    var name2 = list[i];
    if (state.groupNames.indexOf(name2) === -1) {
      state.raise("Invalid named capture referenced");
    }
  }
};
pp$1.regexp_disjunction = function(state) {
  this.regexp_alternative(state);
  while (state.eat(124)) {
    this.regexp_alternative(state);
  }
  if (this.regexp_eatQuantifier(state, true)) {
    state.raise("Nothing to repeat");
  }
  if (state.eat(123)) {
    state.raise("Lone quantifier brackets");
  }
};
pp$1.regexp_alternative = function(state) {
  while (state.pos < state.source.length && this.regexp_eatTerm(state)) {
  }
};
pp$1.regexp_eatTerm = function(state) {
  if (this.regexp_eatAssertion(state)) {
    if (state.lastAssertionIsQuantifiable && this.regexp_eatQuantifier(state)) {
      if (state.switchU) {
        state.raise("Invalid quantifier");
      }
    }
    return true;
  }
  if (state.switchU ? this.regexp_eatAtom(state) : this.regexp_eatExtendedAtom(state)) {
    this.regexp_eatQuantifier(state);
    return true;
  }
  return false;
};
pp$1.regexp_eatAssertion = function(state) {
  var start2 = state.pos;
  state.lastAssertionIsQuantifiable = false;
  if (state.eat(94) || state.eat(36)) {
    return true;
  }
  if (state.eat(92)) {
    if (state.eat(66) || state.eat(98)) {
      return true;
    }
    state.pos = start2;
  }
  if (state.eat(40) && state.eat(63)) {
    var lookbehind = false;
    if (this.options.ecmaVersion >= 9) {
      lookbehind = state.eat(60);
    }
    if (state.eat(61) || state.eat(33)) {
      this.regexp_disjunction(state);
      if (!state.eat(41)) {
        state.raise("Unterminated group");
      }
      state.lastAssertionIsQuantifiable = !lookbehind;
      return true;
    }
  }
  state.pos = start2;
  return false;
};
pp$1.regexp_eatQuantifier = function(state, noError) {
  if (noError === void 0)
    noError = false;
  if (this.regexp_eatQuantifierPrefix(state, noError)) {
    state.eat(63);
    return true;
  }
  return false;
};
pp$1.regexp_eatQuantifierPrefix = function(state, noError) {
  return state.eat(42) || state.eat(43) || state.eat(63) || this.regexp_eatBracedQuantifier(state, noError);
};
pp$1.regexp_eatBracedQuantifier = function(state, noError) {
  var start2 = state.pos;
  if (state.eat(123)) {
    var min3 = 0, max3 = -1;
    if (this.regexp_eatDecimalDigits(state)) {
      min3 = state.lastIntValue;
      if (state.eat(44) && this.regexp_eatDecimalDigits(state)) {
        max3 = state.lastIntValue;
      }
      if (state.eat(125)) {
        if (max3 !== -1 && max3 < min3 && !noError) {
          state.raise("numbers out of order in {} quantifier");
        }
        return true;
      }
    }
    if (state.switchU && !noError) {
      state.raise("Incomplete quantifier");
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatAtom = function(state) {
  return this.regexp_eatPatternCharacters(state) || state.eat(46) || this.regexp_eatReverseSolidusAtomEscape(state) || this.regexp_eatCharacterClass(state) || this.regexp_eatUncapturingGroup(state) || this.regexp_eatCapturingGroup(state);
};
pp$1.regexp_eatReverseSolidusAtomEscape = function(state) {
  var start2 = state.pos;
  if (state.eat(92)) {
    if (this.regexp_eatAtomEscape(state)) {
      return true;
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatUncapturingGroup = function(state) {
  var start2 = state.pos;
  if (state.eat(40)) {
    if (state.eat(63) && state.eat(58)) {
      this.regexp_disjunction(state);
      if (state.eat(41)) {
        return true;
      }
      state.raise("Unterminated group");
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatCapturingGroup = function(state) {
  if (state.eat(40)) {
    if (this.options.ecmaVersion >= 9) {
      this.regexp_groupSpecifier(state);
    } else if (state.current() === 63) {
      state.raise("Invalid group");
    }
    this.regexp_disjunction(state);
    if (state.eat(41)) {
      state.numCapturingParens += 1;
      return true;
    }
    state.raise("Unterminated group");
  }
  return false;
};
pp$1.regexp_eatExtendedAtom = function(state) {
  return state.eat(46) || this.regexp_eatReverseSolidusAtomEscape(state) || this.regexp_eatCharacterClass(state) || this.regexp_eatUncapturingGroup(state) || this.regexp_eatCapturingGroup(state) || this.regexp_eatInvalidBracedQuantifier(state) || this.regexp_eatExtendedPatternCharacter(state);
};
pp$1.regexp_eatInvalidBracedQuantifier = function(state) {
  if (this.regexp_eatBracedQuantifier(state, true)) {
    state.raise("Nothing to repeat");
  }
  return false;
};
pp$1.regexp_eatSyntaxCharacter = function(state) {
  var ch2 = state.current();
  if (isSyntaxCharacter(ch2)) {
    state.lastIntValue = ch2;
    state.advance();
    return true;
  }
  return false;
};
function isSyntaxCharacter(ch2) {
  return ch2 === 36 || ch2 >= 40 && ch2 <= 43 || ch2 === 46 || ch2 === 63 || ch2 >= 91 && ch2 <= 94 || ch2 >= 123 && ch2 <= 125;
}
pp$1.regexp_eatPatternCharacters = function(state) {
  var start2 = state.pos;
  var ch2 = 0;
  while ((ch2 = state.current()) !== -1 && !isSyntaxCharacter(ch2)) {
    state.advance();
  }
  return state.pos !== start2;
};
pp$1.regexp_eatExtendedPatternCharacter = function(state) {
  var ch2 = state.current();
  if (ch2 !== -1 && ch2 !== 36 && !(ch2 >= 40 && ch2 <= 43) && ch2 !== 46 && ch2 !== 63 && ch2 !== 91 && ch2 !== 94 && ch2 !== 124) {
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_groupSpecifier = function(state) {
  if (state.eat(63)) {
    if (this.regexp_eatGroupName(state)) {
      if (state.groupNames.indexOf(state.lastStringValue) !== -1) {
        state.raise("Duplicate capture group name");
      }
      state.groupNames.push(state.lastStringValue);
      return;
    }
    state.raise("Invalid group");
  }
};
pp$1.regexp_eatGroupName = function(state) {
  state.lastStringValue = "";
  if (state.eat(60)) {
    if (this.regexp_eatRegExpIdentifierName(state) && state.eat(62)) {
      return true;
    }
    state.raise("Invalid capture group name");
  }
  return false;
};
pp$1.regexp_eatRegExpIdentifierName = function(state) {
  state.lastStringValue = "";
  if (this.regexp_eatRegExpIdentifierStart(state)) {
    state.lastStringValue += codePointToString(state.lastIntValue);
    while (this.regexp_eatRegExpIdentifierPart(state)) {
      state.lastStringValue += codePointToString(state.lastIntValue);
    }
    return true;
  }
  return false;
};
pp$1.regexp_eatRegExpIdentifierStart = function(state) {
  var start2 = state.pos;
  var forceU = this.options.ecmaVersion >= 11;
  var ch2 = state.current(forceU);
  state.advance(forceU);
  if (ch2 === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
    ch2 = state.lastIntValue;
  }
  if (isRegExpIdentifierStart(ch2)) {
    state.lastIntValue = ch2;
    return true;
  }
  state.pos = start2;
  return false;
};
function isRegExpIdentifierStart(ch2) {
  return isIdentifierStart(ch2, true) || ch2 === 36 || ch2 === 95;
}
pp$1.regexp_eatRegExpIdentifierPart = function(state) {
  var start2 = state.pos;
  var forceU = this.options.ecmaVersion >= 11;
  var ch2 = state.current(forceU);
  state.advance(forceU);
  if (ch2 === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
    ch2 = state.lastIntValue;
  }
  if (isRegExpIdentifierPart(ch2)) {
    state.lastIntValue = ch2;
    return true;
  }
  state.pos = start2;
  return false;
};
function isRegExpIdentifierPart(ch2) {
  return isIdentifierChar(ch2, true) || ch2 === 36 || ch2 === 95 || ch2 === 8204 || ch2 === 8205;
}
pp$1.regexp_eatAtomEscape = function(state) {
  if (this.regexp_eatBackReference(state) || this.regexp_eatCharacterClassEscape(state) || this.regexp_eatCharacterEscape(state) || state.switchN && this.regexp_eatKGroupName(state)) {
    return true;
  }
  if (state.switchU) {
    if (state.current() === 99) {
      state.raise("Invalid unicode escape");
    }
    state.raise("Invalid escape");
  }
  return false;
};
pp$1.regexp_eatBackReference = function(state) {
  var start2 = state.pos;
  if (this.regexp_eatDecimalEscape(state)) {
    var n2 = state.lastIntValue;
    if (state.switchU) {
      if (n2 > state.maxBackReference) {
        state.maxBackReference = n2;
      }
      return true;
    }
    if (n2 <= state.numCapturingParens) {
      return true;
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatKGroupName = function(state) {
  if (state.eat(107)) {
    if (this.regexp_eatGroupName(state)) {
      state.backReferenceNames.push(state.lastStringValue);
      return true;
    }
    state.raise("Invalid named reference");
  }
  return false;
};
pp$1.regexp_eatCharacterEscape = function(state) {
  return this.regexp_eatControlEscape(state) || this.regexp_eatCControlLetter(state) || this.regexp_eatZero(state) || this.regexp_eatHexEscapeSequence(state) || this.regexp_eatRegExpUnicodeEscapeSequence(state, false) || !state.switchU && this.regexp_eatLegacyOctalEscapeSequence(state) || this.regexp_eatIdentityEscape(state);
};
pp$1.regexp_eatCControlLetter = function(state) {
  var start2 = state.pos;
  if (state.eat(99)) {
    if (this.regexp_eatControlLetter(state)) {
      return true;
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatZero = function(state) {
  if (state.current() === 48 && !isDecimalDigit(state.lookahead())) {
    state.lastIntValue = 0;
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_eatControlEscape = function(state) {
  var ch2 = state.current();
  if (ch2 === 116) {
    state.lastIntValue = 9;
    state.advance();
    return true;
  }
  if (ch2 === 110) {
    state.lastIntValue = 10;
    state.advance();
    return true;
  }
  if (ch2 === 118) {
    state.lastIntValue = 11;
    state.advance();
    return true;
  }
  if (ch2 === 102) {
    state.lastIntValue = 12;
    state.advance();
    return true;
  }
  if (ch2 === 114) {
    state.lastIntValue = 13;
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_eatControlLetter = function(state) {
  var ch2 = state.current();
  if (isControlLetter(ch2)) {
    state.lastIntValue = ch2 % 32;
    state.advance();
    return true;
  }
  return false;
};
function isControlLetter(ch2) {
  return ch2 >= 65 && ch2 <= 90 || ch2 >= 97 && ch2 <= 122;
}
pp$1.regexp_eatRegExpUnicodeEscapeSequence = function(state, forceU) {
  if (forceU === void 0)
    forceU = false;
  var start2 = state.pos;
  var switchU = forceU || state.switchU;
  if (state.eat(117)) {
    if (this.regexp_eatFixedHexDigits(state, 4)) {
      var lead = state.lastIntValue;
      if (switchU && lead >= 55296 && lead <= 56319) {
        var leadSurrogateEnd = state.pos;
        if (state.eat(92) && state.eat(117) && this.regexp_eatFixedHexDigits(state, 4)) {
          var trail = state.lastIntValue;
          if (trail >= 56320 && trail <= 57343) {
            state.lastIntValue = (lead - 55296) * 1024 + (trail - 56320) + 65536;
            return true;
          }
        }
        state.pos = leadSurrogateEnd;
        state.lastIntValue = lead;
      }
      return true;
    }
    if (switchU && state.eat(123) && this.regexp_eatHexDigits(state) && state.eat(125) && isValidUnicode(state.lastIntValue)) {
      return true;
    }
    if (switchU) {
      state.raise("Invalid unicode escape");
    }
    state.pos = start2;
  }
  return false;
};
function isValidUnicode(ch2) {
  return ch2 >= 0 && ch2 <= 1114111;
}
pp$1.regexp_eatIdentityEscape = function(state) {
  if (state.switchU) {
    if (this.regexp_eatSyntaxCharacter(state)) {
      return true;
    }
    if (state.eat(47)) {
      state.lastIntValue = 47;
      return true;
    }
    return false;
  }
  var ch2 = state.current();
  if (ch2 !== 99 && (!state.switchN || ch2 !== 107)) {
    state.lastIntValue = ch2;
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_eatDecimalEscape = function(state) {
  state.lastIntValue = 0;
  var ch2 = state.current();
  if (ch2 >= 49 && ch2 <= 57) {
    do {
      state.lastIntValue = 10 * state.lastIntValue + (ch2 - 48);
      state.advance();
    } while ((ch2 = state.current()) >= 48 && ch2 <= 57);
    return true;
  }
  return false;
};
pp$1.regexp_eatCharacterClassEscape = function(state) {
  var ch2 = state.current();
  if (isCharacterClassEscape(ch2)) {
    state.lastIntValue = -1;
    state.advance();
    return true;
  }
  if (state.switchU && this.options.ecmaVersion >= 9 && (ch2 === 80 || ch2 === 112)) {
    state.lastIntValue = -1;
    state.advance();
    if (state.eat(123) && this.regexp_eatUnicodePropertyValueExpression(state) && state.eat(125)) {
      return true;
    }
    state.raise("Invalid property name");
  }
  return false;
};
function isCharacterClassEscape(ch2) {
  return ch2 === 100 || ch2 === 68 || ch2 === 115 || ch2 === 83 || ch2 === 119 || ch2 === 87;
}
pp$1.regexp_eatUnicodePropertyValueExpression = function(state) {
  var start2 = state.pos;
  if (this.regexp_eatUnicodePropertyName(state) && state.eat(61)) {
    var name2 = state.lastStringValue;
    if (this.regexp_eatUnicodePropertyValue(state)) {
      var value = state.lastStringValue;
      this.regexp_validateUnicodePropertyNameAndValue(state, name2, value);
      return true;
    }
  }
  state.pos = start2;
  if (this.regexp_eatLoneUnicodePropertyNameOrValue(state)) {
    var nameOrValue = state.lastStringValue;
    this.regexp_validateUnicodePropertyNameOrValue(state, nameOrValue);
    return true;
  }
  return false;
};
pp$1.regexp_validateUnicodePropertyNameAndValue = function(state, name2, value) {
  if (!hasOwn(state.unicodeProperties.nonBinary, name2)) {
    state.raise("Invalid property name");
  }
  if (!state.unicodeProperties.nonBinary[name2].test(value)) {
    state.raise("Invalid property value");
  }
};
pp$1.regexp_validateUnicodePropertyNameOrValue = function(state, nameOrValue) {
  if (!state.unicodeProperties.binary.test(nameOrValue)) {
    state.raise("Invalid property name");
  }
};
pp$1.regexp_eatUnicodePropertyName = function(state) {
  var ch2 = 0;
  state.lastStringValue = "";
  while (isUnicodePropertyNameCharacter(ch2 = state.current())) {
    state.lastStringValue += codePointToString(ch2);
    state.advance();
  }
  return state.lastStringValue !== "";
};
function isUnicodePropertyNameCharacter(ch2) {
  return isControlLetter(ch2) || ch2 === 95;
}
pp$1.regexp_eatUnicodePropertyValue = function(state) {
  var ch2 = 0;
  state.lastStringValue = "";
  while (isUnicodePropertyValueCharacter(ch2 = state.current())) {
    state.lastStringValue += codePointToString(ch2);
    state.advance();
  }
  return state.lastStringValue !== "";
};
function isUnicodePropertyValueCharacter(ch2) {
  return isUnicodePropertyNameCharacter(ch2) || isDecimalDigit(ch2);
}
pp$1.regexp_eatLoneUnicodePropertyNameOrValue = function(state) {
  return this.regexp_eatUnicodePropertyValue(state);
};
pp$1.regexp_eatCharacterClass = function(state) {
  if (state.eat(91)) {
    state.eat(94);
    this.regexp_classRanges(state);
    if (state.eat(93)) {
      return true;
    }
    state.raise("Unterminated character class");
  }
  return false;
};
pp$1.regexp_classRanges = function(state) {
  while (this.regexp_eatClassAtom(state)) {
    var left = state.lastIntValue;
    if (state.eat(45) && this.regexp_eatClassAtom(state)) {
      var right = state.lastIntValue;
      if (state.switchU && (left === -1 || right === -1)) {
        state.raise("Invalid character class");
      }
      if (left !== -1 && right !== -1 && left > right) {
        state.raise("Range out of order in character class");
      }
    }
  }
};
pp$1.regexp_eatClassAtom = function(state) {
  var start2 = state.pos;
  if (state.eat(92)) {
    if (this.regexp_eatClassEscape(state)) {
      return true;
    }
    if (state.switchU) {
      var ch$1 = state.current();
      if (ch$1 === 99 || isOctalDigit(ch$1)) {
        state.raise("Invalid class escape");
      }
      state.raise("Invalid escape");
    }
    state.pos = start2;
  }
  var ch2 = state.current();
  if (ch2 !== 93) {
    state.lastIntValue = ch2;
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_eatClassEscape = function(state) {
  var start2 = state.pos;
  if (state.eat(98)) {
    state.lastIntValue = 8;
    return true;
  }
  if (state.switchU && state.eat(45)) {
    state.lastIntValue = 45;
    return true;
  }
  if (!state.switchU && state.eat(99)) {
    if (this.regexp_eatClassControlLetter(state)) {
      return true;
    }
    state.pos = start2;
  }
  return this.regexp_eatCharacterClassEscape(state) || this.regexp_eatCharacterEscape(state);
};
pp$1.regexp_eatClassControlLetter = function(state) {
  var ch2 = state.current();
  if (isDecimalDigit(ch2) || ch2 === 95) {
    state.lastIntValue = ch2 % 32;
    state.advance();
    return true;
  }
  return false;
};
pp$1.regexp_eatHexEscapeSequence = function(state) {
  var start2 = state.pos;
  if (state.eat(120)) {
    if (this.regexp_eatFixedHexDigits(state, 2)) {
      return true;
    }
    if (state.switchU) {
      state.raise("Invalid escape");
    }
    state.pos = start2;
  }
  return false;
};
pp$1.regexp_eatDecimalDigits = function(state) {
  var start2 = state.pos;
  var ch2 = 0;
  state.lastIntValue = 0;
  while (isDecimalDigit(ch2 = state.current())) {
    state.lastIntValue = 10 * state.lastIntValue + (ch2 - 48);
    state.advance();
  }
  return state.pos !== start2;
};
function isDecimalDigit(ch2) {
  return ch2 >= 48 && ch2 <= 57;
}
pp$1.regexp_eatHexDigits = function(state) {
  var start2 = state.pos;
  var ch2 = 0;
  state.lastIntValue = 0;
  while (isHexDigit(ch2 = state.current())) {
    state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch2);
    state.advance();
  }
  return state.pos !== start2;
};
function isHexDigit(ch2) {
  return ch2 >= 48 && ch2 <= 57 || ch2 >= 65 && ch2 <= 70 || ch2 >= 97 && ch2 <= 102;
}
function hexToInt(ch2) {
  if (ch2 >= 65 && ch2 <= 70) {
    return 10 + (ch2 - 65);
  }
  if (ch2 >= 97 && ch2 <= 102) {
    return 10 + (ch2 - 97);
  }
  return ch2 - 48;
}
pp$1.regexp_eatLegacyOctalEscapeSequence = function(state) {
  if (this.regexp_eatOctalDigit(state)) {
    var n1 = state.lastIntValue;
    if (this.regexp_eatOctalDigit(state)) {
      var n2 = state.lastIntValue;
      if (n1 <= 3 && this.regexp_eatOctalDigit(state)) {
        state.lastIntValue = n1 * 64 + n2 * 8 + state.lastIntValue;
      } else {
        state.lastIntValue = n1 * 8 + n2;
      }
    } else {
      state.lastIntValue = n1;
    }
    return true;
  }
  return false;
};
pp$1.regexp_eatOctalDigit = function(state) {
  var ch2 = state.current();
  if (isOctalDigit(ch2)) {
    state.lastIntValue = ch2 - 48;
    state.advance();
    return true;
  }
  state.lastIntValue = 0;
  return false;
};
function isOctalDigit(ch2) {
  return ch2 >= 48 && ch2 <= 55;
}
pp$1.regexp_eatFixedHexDigits = function(state, length) {
  var start2 = state.pos;
  state.lastIntValue = 0;
  for (var i = 0; i < length; ++i) {
    var ch2 = state.current();
    if (!isHexDigit(ch2)) {
      state.pos = start2;
      return false;
    }
    state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch2);
    state.advance();
  }
  return true;
};
var Token = function Token2(p2) {
  this.type = p2.type;
  this.value = p2.value;
  this.start = p2.start;
  this.end = p2.end;
  if (p2.options.locations) {
    this.loc = new SourceLocation(p2, p2.startLoc, p2.endLoc);
  }
  if (p2.options.ranges) {
    this.range = [p2.start, p2.end];
  }
};
var pp = Parser.prototype;
pp.next = function(ignoreEscapeSequenceInKeyword) {
  if (!ignoreEscapeSequenceInKeyword && this.type.keyword && this.containsEsc) {
    this.raiseRecoverable(this.start, "Escape sequence in keyword " + this.type.keyword);
  }
  if (this.options.onToken) {
    this.options.onToken(new Token(this));
  }
  this.lastTokEnd = this.end;
  this.lastTokStart = this.start;
  this.lastTokEndLoc = this.endLoc;
  this.lastTokStartLoc = this.startLoc;
  this.nextToken();
};
pp.getToken = function() {
  this.next();
  return new Token(this);
};
if (typeof Symbol !== "undefined") {
  pp[Symbol.iterator] = function() {
    var this$1$1 = this;
    return {
      next: function() {
        var token = this$1$1.getToken();
        return {
          done: token.type === types$1.eof,
          value: token
        };
      }
    };
  };
}
pp.nextToken = function() {
  var curContext = this.curContext();
  if (!curContext || !curContext.preserveSpace) {
    this.skipSpace();
  }
  this.start = this.pos;
  if (this.options.locations) {
    this.startLoc = this.curPosition();
  }
  if (this.pos >= this.input.length) {
    return this.finishToken(types$1.eof);
  }
  if (curContext.override) {
    return curContext.override(this);
  } else {
    this.readToken(this.fullCharCodeAtPos());
  }
};
pp.readToken = function(code2) {
  if (isIdentifierStart(code2, this.options.ecmaVersion >= 6) || code2 === 92) {
    return this.readWord();
  }
  return this.getTokenFromCode(code2);
};
pp.fullCharCodeAtPos = function() {
  var code2 = this.input.charCodeAt(this.pos);
  if (code2 <= 55295 || code2 >= 56320) {
    return code2;
  }
  var next = this.input.charCodeAt(this.pos + 1);
  return next <= 56319 || next >= 57344 ? code2 : (code2 << 10) + next - 56613888;
};
pp.skipBlockComment = function() {
  var startLoc = this.options.onComment && this.curPosition();
  var start2 = this.pos, end2 = this.input.indexOf("*/", this.pos += 2);
  if (end2 === -1) {
    this.raise(this.pos - 2, "Unterminated comment");
  }
  this.pos = end2 + 2;
  if (this.options.locations) {
    for (var nextBreak = void 0, pos = start2; (nextBreak = nextLineBreak(this.input, pos, this.pos)) > -1; ) {
      ++this.curLine;
      pos = this.lineStart = nextBreak;
    }
  }
  if (this.options.onComment) {
    this.options.onComment(true, this.input.slice(start2 + 2, end2), start2, this.pos, startLoc, this.curPosition());
  }
};
pp.skipLineComment = function(startSkip) {
  var start2 = this.pos;
  var startLoc = this.options.onComment && this.curPosition();
  var ch2 = this.input.charCodeAt(this.pos += startSkip);
  while (this.pos < this.input.length && !isNewLine(ch2)) {
    ch2 = this.input.charCodeAt(++this.pos);
  }
  if (this.options.onComment) {
    this.options.onComment(false, this.input.slice(start2 + startSkip, this.pos), start2, this.pos, startLoc, this.curPosition());
  }
};
pp.skipSpace = function() {
  loop:
    while (this.pos < this.input.length) {
      var ch2 = this.input.charCodeAt(this.pos);
      switch (ch2) {
        case 32:
        case 160:
          ++this.pos;
          break;
        case 13:
          if (this.input.charCodeAt(this.pos + 1) === 10) {
            ++this.pos;
          }
        case 10:
        case 8232:
        case 8233:
          ++this.pos;
          if (this.options.locations) {
            ++this.curLine;
            this.lineStart = this.pos;
          }
          break;
        case 47:
          switch (this.input.charCodeAt(this.pos + 1)) {
            case 42:
              this.skipBlockComment();
              break;
            case 47:
              this.skipLineComment(2);
              break;
            default:
              break loop;
          }
          break;
        default:
          if (ch2 > 8 && ch2 < 14 || ch2 >= 5760 && nonASCIIwhitespace.test(String.fromCharCode(ch2))) {
            ++this.pos;
          } else {
            break loop;
          }
      }
    }
};
pp.finishToken = function(type4, val) {
  this.end = this.pos;
  if (this.options.locations) {
    this.endLoc = this.curPosition();
  }
  var prevType = this.type;
  this.type = type4;
  this.value = val;
  this.updateContext(prevType);
};
pp.readToken_dot = function() {
  var next = this.input.charCodeAt(this.pos + 1);
  if (next >= 48 && next <= 57) {
    return this.readNumber(true);
  }
  var next2 = this.input.charCodeAt(this.pos + 2);
  if (this.options.ecmaVersion >= 6 && next === 46 && next2 === 46) {
    this.pos += 3;
    return this.finishToken(types$1.ellipsis);
  } else {
    ++this.pos;
    return this.finishToken(types$1.dot);
  }
};
pp.readToken_slash = function() {
  var next = this.input.charCodeAt(this.pos + 1);
  if (this.exprAllowed) {
    ++this.pos;
    return this.readRegexp();
  }
  if (next === 61) {
    return this.finishOp(types$1.assign, 2);
  }
  return this.finishOp(types$1.slash, 1);
};
pp.readToken_mult_modulo_exp = function(code2) {
  var next = this.input.charCodeAt(this.pos + 1);
  var size = 1;
  var tokentype = code2 === 42 ? types$1.star : types$1.modulo;
  if (this.options.ecmaVersion >= 7 && code2 === 42 && next === 42) {
    ++size;
    tokentype = types$1.starstar;
    next = this.input.charCodeAt(this.pos + 2);
  }
  if (next === 61) {
    return this.finishOp(types$1.assign, size + 1);
  }
  return this.finishOp(tokentype, size);
};
pp.readToken_pipe_amp = function(code2) {
  var next = this.input.charCodeAt(this.pos + 1);
  if (next === code2) {
    if (this.options.ecmaVersion >= 12) {
      var next2 = this.input.charCodeAt(this.pos + 2);
      if (next2 === 61) {
        return this.finishOp(types$1.assign, 3);
      }
    }
    return this.finishOp(code2 === 124 ? types$1.logicalOR : types$1.logicalAND, 2);
  }
  if (next === 61) {
    return this.finishOp(types$1.assign, 2);
  }
  return this.finishOp(code2 === 124 ? types$1.bitwiseOR : types$1.bitwiseAND, 1);
};
pp.readToken_caret = function() {
  var next = this.input.charCodeAt(this.pos + 1);
  if (next === 61) {
    return this.finishOp(types$1.assign, 2);
  }
  return this.finishOp(types$1.bitwiseXOR, 1);
};
pp.readToken_plus_min = function(code2) {
  var next = this.input.charCodeAt(this.pos + 1);
  if (next === code2) {
    if (next === 45 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 62 && (this.lastTokEnd === 0 || lineBreak.test(this.input.slice(this.lastTokEnd, this.pos)))) {
      this.skipLineComment(3);
      this.skipSpace();
      return this.nextToken();
    }
    return this.finishOp(types$1.incDec, 2);
  }
  if (next === 61) {
    return this.finishOp(types$1.assign, 2);
  }
  return this.finishOp(types$1.plusMin, 1);
};
pp.readToken_lt_gt = function(code2) {
  var next = this.input.charCodeAt(this.pos + 1);
  var size = 1;
  if (next === code2) {
    size = code2 === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2;
    if (this.input.charCodeAt(this.pos + size) === 61) {
      return this.finishOp(types$1.assign, size + 1);
    }
    return this.finishOp(types$1.bitShift, size);
  }
  if (next === 33 && code2 === 60 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 45 && this.input.charCodeAt(this.pos + 3) === 45) {
    this.skipLineComment(4);
    this.skipSpace();
    return this.nextToken();
  }
  if (next === 61) {
    size = 2;
  }
  return this.finishOp(types$1.relational, size);
};
pp.readToken_eq_excl = function(code2) {
  var next = this.input.charCodeAt(this.pos + 1);
  if (next === 61) {
    return this.finishOp(types$1.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2);
  }
  if (code2 === 61 && next === 62 && this.options.ecmaVersion >= 6) {
    this.pos += 2;
    return this.finishToken(types$1.arrow);
  }
  return this.finishOp(code2 === 61 ? types$1.eq : types$1.prefix, 1);
};
pp.readToken_question = function() {
  var ecmaVersion = this.options.ecmaVersion;
  if (ecmaVersion >= 11) {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next === 46) {
      var next2 = this.input.charCodeAt(this.pos + 2);
      if (next2 < 48 || next2 > 57) {
        return this.finishOp(types$1.questionDot, 2);
      }
    }
    if (next === 63) {
      if (ecmaVersion >= 12) {
        var next2$1 = this.input.charCodeAt(this.pos + 2);
        if (next2$1 === 61) {
          return this.finishOp(types$1.assign, 3);
        }
      }
      return this.finishOp(types$1.coalesce, 2);
    }
  }
  return this.finishOp(types$1.question, 1);
};
pp.readToken_numberSign = function() {
  var ecmaVersion = this.options.ecmaVersion;
  var code2 = 35;
  if (ecmaVersion >= 13) {
    ++this.pos;
    code2 = this.fullCharCodeAtPos();
    if (isIdentifierStart(code2, true) || code2 === 92) {
      return this.finishToken(types$1.privateId, this.readWord1());
    }
  }
  this.raise(this.pos, "Unexpected character '" + codePointToString(code2) + "'");
};
pp.getTokenFromCode = function(code2) {
  switch (code2) {
    case 46:
      return this.readToken_dot();
    case 40:
      ++this.pos;
      return this.finishToken(types$1.parenL);
    case 41:
      ++this.pos;
      return this.finishToken(types$1.parenR);
    case 59:
      ++this.pos;
      return this.finishToken(types$1.semi);
    case 44:
      ++this.pos;
      return this.finishToken(types$1.comma);
    case 91:
      ++this.pos;
      return this.finishToken(types$1.bracketL);
    case 93:
      ++this.pos;
      return this.finishToken(types$1.bracketR);
    case 123:
      ++this.pos;
      return this.finishToken(types$1.braceL);
    case 125:
      ++this.pos;
      return this.finishToken(types$1.braceR);
    case 58:
      ++this.pos;
      return this.finishToken(types$1.colon);
    case 96:
      if (this.options.ecmaVersion < 6) {
        break;
      }
      ++this.pos;
      return this.finishToken(types$1.backQuote);
    case 48:
      var next = this.input.charCodeAt(this.pos + 1);
      if (next === 120 || next === 88) {
        return this.readRadixNumber(16);
      }
      if (this.options.ecmaVersion >= 6) {
        if (next === 111 || next === 79) {
          return this.readRadixNumber(8);
        }
        if (next === 98 || next === 66) {
          return this.readRadixNumber(2);
        }
      }
    case 49:
    case 50:
    case 51:
    case 52:
    case 53:
    case 54:
    case 55:
    case 56:
    case 57:
      return this.readNumber(false);
    case 34:
    case 39:
      return this.readString(code2);
    case 47:
      return this.readToken_slash();
    case 37:
    case 42:
      return this.readToken_mult_modulo_exp(code2);
    case 124:
    case 38:
      return this.readToken_pipe_amp(code2);
    case 94:
      return this.readToken_caret();
    case 43:
    case 45:
      return this.readToken_plus_min(code2);
    case 60:
    case 62:
      return this.readToken_lt_gt(code2);
    case 61:
    case 33:
      return this.readToken_eq_excl(code2);
    case 63:
      return this.readToken_question();
    case 126:
      return this.finishOp(types$1.prefix, 1);
    case 35:
      return this.readToken_numberSign();
  }
  this.raise(this.pos, "Unexpected character '" + codePointToString(code2) + "'");
};
pp.finishOp = function(type4, size) {
  var str = this.input.slice(this.pos, this.pos + size);
  this.pos += size;
  return this.finishToken(type4, str);
};
pp.readRegexp = function() {
  var escaped, inClass, start2 = this.pos;
  for (; ; ) {
    if (this.pos >= this.input.length) {
      this.raise(start2, "Unterminated regular expression");
    }
    var ch2 = this.input.charAt(this.pos);
    if (lineBreak.test(ch2)) {
      this.raise(start2, "Unterminated regular expression");
    }
    if (!escaped) {
      if (ch2 === "[") {
        inClass = true;
      } else if (ch2 === "]" && inClass) {
        inClass = false;
      } else if (ch2 === "/" && !inClass) {
        break;
      }
      escaped = ch2 === "\\";
    } else {
      escaped = false;
    }
    ++this.pos;
  }
  var pattern4 = this.input.slice(start2, this.pos);
  ++this.pos;
  var flagsStart = this.pos;
  var flags = this.readWord1();
  if (this.containsEsc) {
    this.unexpected(flagsStart);
  }
  var state = this.regexpState || (this.regexpState = new RegExpValidationState(this));
  state.reset(start2, pattern4, flags);
  this.validateRegExpFlags(state);
  this.validateRegExpPattern(state);
  var value = null;
  try {
    value = new RegExp(pattern4, flags);
  } catch (e2) {
  }
  return this.finishToken(types$1.regexp, { pattern: pattern4, flags, value });
};
pp.readInt = function(radix, len2, maybeLegacyOctalNumericLiteral) {
  var allowSeparators = this.options.ecmaVersion >= 12 && len2 === void 0;
  var isLegacyOctalNumericLiteral = maybeLegacyOctalNumericLiteral && this.input.charCodeAt(this.pos) === 48;
  var start2 = this.pos, total = 0, lastCode = 0;
  for (var i = 0, e2 = len2 == null ? Infinity : len2; i < e2; ++i, ++this.pos) {
    var code2 = this.input.charCodeAt(this.pos), val = void 0;
    if (allowSeparators && code2 === 95) {
      if (isLegacyOctalNumericLiteral) {
        this.raiseRecoverable(this.pos, "Numeric separator is not allowed in legacy octal numeric literals");
      }
      if (lastCode === 95) {
        this.raiseRecoverable(this.pos, "Numeric separator must be exactly one underscore");
      }
      if (i === 0) {
        this.raiseRecoverable(this.pos, "Numeric separator is not allowed at the first of digits");
      }
      lastCode = code2;
      continue;
    }
    if (code2 >= 97) {
      val = code2 - 97 + 10;
    } else if (code2 >= 65) {
      val = code2 - 65 + 10;
    } else if (code2 >= 48 && code2 <= 57) {
      val = code2 - 48;
    } else {
      val = Infinity;
    }
    if (val >= radix) {
      break;
    }
    lastCode = code2;
    total = total * radix + val;
  }
  if (allowSeparators && lastCode === 95) {
    this.raiseRecoverable(this.pos - 1, "Numeric separator is not allowed at the last of digits");
  }
  if (this.pos === start2 || len2 != null && this.pos - start2 !== len2) {
    return null;
  }
  return total;
};
function stringToNumber(str, isLegacyOctalNumericLiteral) {
  if (isLegacyOctalNumericLiteral) {
    return parseInt(str, 8);
  }
  return parseFloat(str.replace(/_/g, ""));
}
function stringToBigInt(str) {
  if (typeof BigInt !== "function") {
    return null;
  }
  return BigInt(str.replace(/_/g, ""));
}
pp.readRadixNumber = function(radix) {
  var start2 = this.pos;
  this.pos += 2;
  var val = this.readInt(radix);
  if (val == null) {
    this.raise(this.start + 2, "Expected number in radix " + radix);
  }
  if (this.options.ecmaVersion >= 11 && this.input.charCodeAt(this.pos) === 110) {
    val = stringToBigInt(this.input.slice(start2, this.pos));
    ++this.pos;
  } else if (isIdentifierStart(this.fullCharCodeAtPos())) {
    this.raise(this.pos, "Identifier directly after number");
  }
  return this.finishToken(types$1.num, val);
};
pp.readNumber = function(startsWithDot) {
  var start2 = this.pos;
  if (!startsWithDot && this.readInt(10, void 0, true) === null) {
    this.raise(start2, "Invalid number");
  }
  var octal = this.pos - start2 >= 2 && this.input.charCodeAt(start2) === 48;
  if (octal && this.strict) {
    this.raise(start2, "Invalid number");
  }
  var next = this.input.charCodeAt(this.pos);
  if (!octal && !startsWithDot && this.options.ecmaVersion >= 11 && next === 110) {
    var val$1 = stringToBigInt(this.input.slice(start2, this.pos));
    ++this.pos;
    if (isIdentifierStart(this.fullCharCodeAtPos())) {
      this.raise(this.pos, "Identifier directly after number");
    }
    return this.finishToken(types$1.num, val$1);
  }
  if (octal && /[89]/.test(this.input.slice(start2, this.pos))) {
    octal = false;
  }
  if (next === 46 && !octal) {
    ++this.pos;
    this.readInt(10);
    next = this.input.charCodeAt(this.pos);
  }
  if ((next === 69 || next === 101) && !octal) {
    next = this.input.charCodeAt(++this.pos);
    if (next === 43 || next === 45) {
      ++this.pos;
    }
    if (this.readInt(10) === null) {
      this.raise(start2, "Invalid number");
    }
  }
  if (isIdentifierStart(this.fullCharCodeAtPos())) {
    this.raise(this.pos, "Identifier directly after number");
  }
  var val = stringToNumber(this.input.slice(start2, this.pos), octal);
  return this.finishToken(types$1.num, val);
};
pp.readCodePoint = function() {
  var ch2 = this.input.charCodeAt(this.pos), code2;
  if (ch2 === 123) {
    if (this.options.ecmaVersion < 6) {
      this.unexpected();
    }
    var codePos = ++this.pos;
    code2 = this.readHexChar(this.input.indexOf("}", this.pos) - this.pos);
    ++this.pos;
    if (code2 > 1114111) {
      this.invalidStringToken(codePos, "Code point out of bounds");
    }
  } else {
    code2 = this.readHexChar(4);
  }
  return code2;
};
pp.readString = function(quote) {
  var out2 = "", chunkStart = ++this.pos;
  for (; ; ) {
    if (this.pos >= this.input.length) {
      this.raise(this.start, "Unterminated string constant");
    }
    var ch2 = this.input.charCodeAt(this.pos);
    if (ch2 === quote) {
      break;
    }
    if (ch2 === 92) {
      out2 += this.input.slice(chunkStart, this.pos);
      out2 += this.readEscapedChar(false);
      chunkStart = this.pos;
    } else if (ch2 === 8232 || ch2 === 8233) {
      if (this.options.ecmaVersion < 10) {
        this.raise(this.start, "Unterminated string constant");
      }
      ++this.pos;
      if (this.options.locations) {
        this.curLine++;
        this.lineStart = this.pos;
      }
    } else {
      if (isNewLine(ch2)) {
        this.raise(this.start, "Unterminated string constant");
      }
      ++this.pos;
    }
  }
  out2 += this.input.slice(chunkStart, this.pos++);
  return this.finishToken(types$1.string, out2);
};
var INVALID_TEMPLATE_ESCAPE_ERROR = {};
pp.tryReadTemplateToken = function() {
  this.inTemplateElement = true;
  try {
    this.readTmplToken();
  } catch (err) {
    if (err === INVALID_TEMPLATE_ESCAPE_ERROR) {
      this.readInvalidTemplateToken();
    } else {
      throw err;
    }
  }
  this.inTemplateElement = false;
};
pp.invalidStringToken = function(position2, message) {
  if (this.inTemplateElement && this.options.ecmaVersion >= 9) {
    throw INVALID_TEMPLATE_ESCAPE_ERROR;
  } else {
    this.raise(position2, message);
  }
};
pp.readTmplToken = function() {
  var out2 = "", chunkStart = this.pos;
  for (; ; ) {
    if (this.pos >= this.input.length) {
      this.raise(this.start, "Unterminated template");
    }
    var ch2 = this.input.charCodeAt(this.pos);
    if (ch2 === 96 || ch2 === 36 && this.input.charCodeAt(this.pos + 1) === 123) {
      if (this.pos === this.start && (this.type === types$1.template || this.type === types$1.invalidTemplate)) {
        if (ch2 === 36) {
          this.pos += 2;
          return this.finishToken(types$1.dollarBraceL);
        } else {
          ++this.pos;
          return this.finishToken(types$1.backQuote);
        }
      }
      out2 += this.input.slice(chunkStart, this.pos);
      return this.finishToken(types$1.template, out2);
    }
    if (ch2 === 92) {
      out2 += this.input.slice(chunkStart, this.pos);
      out2 += this.readEscapedChar(true);
      chunkStart = this.pos;
    } else if (isNewLine(ch2)) {
      out2 += this.input.slice(chunkStart, this.pos);
      ++this.pos;
      switch (ch2) {
        case 13:
          if (this.input.charCodeAt(this.pos) === 10) {
            ++this.pos;
          }
        case 10:
          out2 += "\n";
          break;
        default:
          out2 += String.fromCharCode(ch2);
          break;
      }
      if (this.options.locations) {
        ++this.curLine;
        this.lineStart = this.pos;
      }
      chunkStart = this.pos;
    } else {
      ++this.pos;
    }
  }
};
pp.readInvalidTemplateToken = function() {
  for (; this.pos < this.input.length; this.pos++) {
    switch (this.input[this.pos]) {
      case "\\":
        ++this.pos;
        break;
      case "$":
        if (this.input[this.pos + 1] !== "{") {
          break;
        }
      case "`":
        return this.finishToken(types$1.invalidTemplate, this.input.slice(this.start, this.pos));
    }
  }
  this.raise(this.start, "Unterminated template");
};
pp.readEscapedChar = function(inTemplate) {
  var ch2 = this.input.charCodeAt(++this.pos);
  ++this.pos;
  switch (ch2) {
    case 110:
      return "\n";
    case 114:
      return "\r";
    case 120:
      return String.fromCharCode(this.readHexChar(2));
    case 117:
      return codePointToString(this.readCodePoint());
    case 116:
      return "	";
    case 98:
      return "\b";
    case 118:
      return "\v";
    case 102:
      return "\f";
    case 13:
      if (this.input.charCodeAt(this.pos) === 10) {
        ++this.pos;
      }
    case 10:
      if (this.options.locations) {
        this.lineStart = this.pos;
        ++this.curLine;
      }
      return "";
    case 56:
    case 57:
      if (this.strict) {
        this.invalidStringToken(this.pos - 1, "Invalid escape sequence");
      }
      if (inTemplate) {
        var codePos = this.pos - 1;
        this.invalidStringToken(codePos, "Invalid escape sequence in template string");
        return null;
      }
    default:
      if (ch2 >= 48 && ch2 <= 55) {
        var octalStr = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0];
        var octal = parseInt(octalStr, 8);
        if (octal > 255) {
          octalStr = octalStr.slice(0, -1);
          octal = parseInt(octalStr, 8);
        }
        this.pos += octalStr.length - 1;
        ch2 = this.input.charCodeAt(this.pos);
        if ((octalStr !== "0" || ch2 === 56 || ch2 === 57) && (this.strict || inTemplate)) {
          this.invalidStringToken(this.pos - 1 - octalStr.length, inTemplate ? "Octal literal in template string" : "Octal literal in strict mode");
        }
        return String.fromCharCode(octal);
      }
      if (isNewLine(ch2)) {
        return "";
      }
      return String.fromCharCode(ch2);
  }
};
pp.readHexChar = function(len2) {
  var codePos = this.pos;
  var n2 = this.readInt(16, len2);
  if (n2 === null) {
    this.invalidStringToken(codePos, "Bad character escape sequence");
  }
  return n2;
};
pp.readWord1 = function() {
  this.containsEsc = false;
  var word = "", first = true, chunkStart = this.pos;
  var astral = this.options.ecmaVersion >= 6;
  while (this.pos < this.input.length) {
    var ch2 = this.fullCharCodeAtPos();
    if (isIdentifierChar(ch2, astral)) {
      this.pos += ch2 <= 65535 ? 1 : 2;
    } else if (ch2 === 92) {
      this.containsEsc = true;
      word += this.input.slice(chunkStart, this.pos);
      var escStart = this.pos;
      if (this.input.charCodeAt(++this.pos) !== 117) {
        this.invalidStringToken(this.pos, "Expecting Unicode escape sequence \\uXXXX");
      }
      ++this.pos;
      var esc = this.readCodePoint();
      if (!(first ? isIdentifierStart : isIdentifierChar)(esc, astral)) {
        this.invalidStringToken(escStart, "Invalid Unicode escape");
      }
      word += codePointToString(esc);
      chunkStart = this.pos;
    } else {
      break;
    }
    first = false;
  }
  return word + this.input.slice(chunkStart, this.pos);
};
pp.readWord = function() {
  var word = this.readWord1();
  var type4 = types$1.name;
  if (this.keywords.test(word)) {
    type4 = keywords[word];
  }
  return this.finishToken(type4, word);
};
var version$1 = "8.7.1";
Parser.acorn = {
  Parser,
  version: version$1,
  defaultOptions,
  Position,
  SourceLocation,
  getLineInfo,
  Node,
  TokenType,
  tokTypes: types$1,
  keywordTypes: keywords,
  TokContext,
  tokContexts: types$2,
  isIdentifierChar,
  isIdentifierStart,
  Token,
  isNewLine,
  lineBreak,
  lineBreakG,
  nonASCIIwhitespace
};
function parse3(input, options) {
  return Parser.parse(input, options);
}
var escodegen = {};
var estraverse = {};
(function(exports) {
  (function clone3(exports2) {
    var Syntax, VisitorOption, VisitorKeys, BREAK, SKIP, REMOVE;
    function deepCopy(obj) {
      var ret = {}, key, val;
      for (key in obj) {
        if (obj.hasOwnProperty(key)) {
          val = obj[key];
          if (typeof val === "object" && val !== null) {
            ret[key] = deepCopy(val);
          } else {
            ret[key] = val;
          }
        }
      }
      return ret;
    }
    function upperBound(array4, func) {
      var diff, len2, i, current2;
      len2 = array4.length;
      i = 0;
      while (len2) {
        diff = len2 >>> 1;
        current2 = i + diff;
        if (func(array4[current2])) {
          len2 = diff;
        } else {
          i = current2 + 1;
          len2 -= diff + 1;
        }
      }
      return i;
    }
    Syntax = {
      AssignmentExpression: "AssignmentExpression",
      AssignmentPattern: "AssignmentPattern",
      ArrayExpression: "ArrayExpression",
      ArrayPattern: "ArrayPattern",
      ArrowFunctionExpression: "ArrowFunctionExpression",
      AwaitExpression: "AwaitExpression",
      BlockStatement: "BlockStatement",
      BinaryExpression: "BinaryExpression",
      BreakStatement: "BreakStatement",
      CallExpression: "CallExpression",
      CatchClause: "CatchClause",
      ChainExpression: "ChainExpression",
      ClassBody: "ClassBody",
      ClassDeclaration: "ClassDeclaration",
      ClassExpression: "ClassExpression",
      ComprehensionBlock: "ComprehensionBlock",
      ComprehensionExpression: "ComprehensionExpression",
      ConditionalExpression: "ConditionalExpression",
      ContinueStatement: "ContinueStatement",
      DebuggerStatement: "DebuggerStatement",
      DirectiveStatement: "DirectiveStatement",
      DoWhileStatement: "DoWhileStatement",
      EmptyStatement: "EmptyStatement",
      ExportAllDeclaration: "ExportAllDeclaration",
      ExportDefaultDeclaration: "ExportDefaultDeclaration",
      ExportNamedDeclaration: "ExportNamedDeclaration",
      ExportSpecifier: "ExportSpecifier",
      ExpressionStatement: "ExpressionStatement",
      ForStatement: "ForStatement",
      ForInStatement: "ForInStatement",
      ForOfStatement: "ForOfStatement",
      FunctionDeclaration: "FunctionDeclaration",
      FunctionExpression: "FunctionExpression",
      GeneratorExpression: "GeneratorExpression",
      Identifier: "Identifier",
      IfStatement: "IfStatement",
      ImportExpression: "ImportExpression",
      ImportDeclaration: "ImportDeclaration",
      ImportDefaultSpecifier: "ImportDefaultSpecifier",
      ImportNamespaceSpecifier: "ImportNamespaceSpecifier",
      ImportSpecifier: "ImportSpecifier",
      Literal: "Literal",
      LabeledStatement: "LabeledStatement",
      LogicalExpression: "LogicalExpression",
      MemberExpression: "MemberExpression",
      MetaProperty: "MetaProperty",
      MethodDefinition: "MethodDefinition",
      ModuleSpecifier: "ModuleSpecifier",
      NewExpression: "NewExpression",
      ObjectExpression: "ObjectExpression",
      ObjectPattern: "ObjectPattern",
      PrivateIdentifier: "PrivateIdentifier",
      Program: "Program",
      Property: "Property",
      PropertyDefinition: "PropertyDefinition",
      RestElement: "RestElement",
      ReturnStatement: "ReturnStatement",
      SequenceExpression: "SequenceExpression",
      SpreadElement: "SpreadElement",
      Super: "Super",
      SwitchStatement: "SwitchStatement",
      SwitchCase: "SwitchCase",
      TaggedTemplateExpression: "TaggedTemplateExpression",
      TemplateElement: "TemplateElement",
      TemplateLiteral: "TemplateLiteral",
      ThisExpression: "ThisExpression",
      ThrowStatement: "ThrowStatement",
      TryStatement: "TryStatement",
      UnaryExpression: "UnaryExpression",
      UpdateExpression: "UpdateExpression",
      VariableDeclaration: "VariableDeclaration",
      VariableDeclarator: "VariableDeclarator",
      WhileStatement: "WhileStatement",
      WithStatement: "WithStatement",
      YieldExpression: "YieldExpression"
    };
    VisitorKeys = {
      AssignmentExpression: ["left", "right"],
      AssignmentPattern: ["left", "right"],
      ArrayExpression: ["elements"],
      ArrayPattern: ["elements"],
      ArrowFunctionExpression: ["params", "body"],
      AwaitExpression: ["argument"],
      BlockStatement: ["body"],
      BinaryExpression: ["left", "right"],
      BreakStatement: ["label"],
      CallExpression: ["callee", "arguments"],
      CatchClause: ["param", "body"],
      ChainExpression: ["expression"],
      ClassBody: ["body"],
      ClassDeclaration: ["id", "superClass", "body"],
      ClassExpression: ["id", "superClass", "body"],
      ComprehensionBlock: ["left", "right"],
      ComprehensionExpression: ["blocks", "filter", "body"],
      ConditionalExpression: ["test", "consequent", "alternate"],
      ContinueStatement: ["label"],
      DebuggerStatement: [],
      DirectiveStatement: [],
      DoWhileStatement: ["body", "test"],
      EmptyStatement: [],
      ExportAllDeclaration: ["source"],
      ExportDefaultDeclaration: ["declaration"],
      ExportNamedDeclaration: ["declaration", "specifiers", "source"],
      ExportSpecifier: ["exported", "local"],
      ExpressionStatement: ["expression"],
      ForStatement: ["init", "test", "update", "body"],
      ForInStatement: ["left", "right", "body"],
      ForOfStatement: ["left", "right", "body"],
      FunctionDeclaration: ["id", "params", "body"],
      FunctionExpression: ["id", "params", "body"],
      GeneratorExpression: ["blocks", "filter", "body"],
      Identifier: [],
      IfStatement: ["test", "consequent", "alternate"],
      ImportExpression: ["source"],
      ImportDeclaration: ["specifiers", "source"],
      ImportDefaultSpecifier: ["local"],
      ImportNamespaceSpecifier: ["local"],
      ImportSpecifier: ["imported", "local"],
      Literal: [],
      LabeledStatement: ["label", "body"],
      LogicalExpression: ["left", "right"],
      MemberExpression: ["object", "property"],
      MetaProperty: ["meta", "property"],
      MethodDefinition: ["key", "value"],
      ModuleSpecifier: [],
      NewExpression: ["callee", "arguments"],
      ObjectExpression: ["properties"],
      ObjectPattern: ["properties"],
      PrivateIdentifier: [],
      Program: ["body"],
      Property: ["key", "value"],
      PropertyDefinition: ["key", "value"],
      RestElement: ["argument"],
      ReturnStatement: ["argument"],
      SequenceExpression: ["expressions"],
      SpreadElement: ["argument"],
      Super: [],
      SwitchStatement: ["discriminant", "cases"],
      SwitchCase: ["test", "consequent"],
      TaggedTemplateExpression: ["tag", "quasi"],
      TemplateElement: [],
      TemplateLiteral: ["quasis", "expressions"],
      ThisExpression: [],
      ThrowStatement: ["argument"],
      TryStatement: ["block", "handler", "finalizer"],
      UnaryExpression: ["argument"],
      UpdateExpression: ["argument"],
      VariableDeclaration: ["declarations"],
      VariableDeclarator: ["id", "init"],
      WhileStatement: ["test", "body"],
      WithStatement: ["object", "body"],
      YieldExpression: ["argument"]
    };
    BREAK = {};
    SKIP = {};
    REMOVE = {};
    VisitorOption = {
      Break: BREAK,
      Skip: SKIP,
      Remove: REMOVE
    };
    function Reference(parent, key) {
      this.parent = parent;
      this.key = key;
    }
    Reference.prototype.replace = function replace2(node) {
      this.parent[this.key] = node;
    };
    Reference.prototype.remove = function remove() {
      if (Array.isArray(this.parent)) {
        this.parent.splice(this.key, 1);
        return true;
      } else {
        this.replace(null);
        return false;
      }
    };
    function Element2(node, path, wrap, ref2) {
      this.node = node;
      this.path = path;
      this.wrap = wrap;
      this.ref = ref2;
    }
    function Controller() {
    }
    Controller.prototype.path = function path() {
      var i, iz, j, jz, result, element;
      function addToPath(result2, path2) {
        if (Array.isArray(path2)) {
          for (j = 0, jz = path2.length; j < jz; ++j) {
            result2.push(path2[j]);
          }
        } else {
          result2.push(path2);
        }
      }
      if (!this.__current.path) {
        return null;
      }
      result = [];
      for (i = 2, iz = this.__leavelist.length; i < iz; ++i) {
        element = this.__leavelist[i];
        addToPath(result, element.path);
      }
      addToPath(result, this.__current.path);
      return result;
    };
    Controller.prototype.type = function() {
      var node = this.current();
      return node.type || this.__current.wrap;
    };
    Controller.prototype.parents = function parents() {
      var i, iz, result;
      result = [];
      for (i = 1, iz = this.__leavelist.length; i < iz; ++i) {
        result.push(this.__leavelist[i].node);
      }
      return result;
    };
    Controller.prototype.current = function current2() {
      return this.__current.node;
    };
    Controller.prototype.__execute = function __execute(callback, element) {
      var previous, result;
      result = void 0;
      previous = this.__current;
      this.__current = element;
      this.__state = null;
      if (callback) {
        result = callback.call(this, element.node, this.__leavelist[this.__leavelist.length - 1].node);
      }
      this.__current = previous;
      return result;
    };
    Controller.prototype.notify = function notify(flag) {
      this.__state = flag;
    };
    Controller.prototype.skip = function() {
      this.notify(SKIP);
    };
    Controller.prototype["break"] = function() {
      this.notify(BREAK);
    };
    Controller.prototype.remove = function() {
      this.notify(REMOVE);
    };
    Controller.prototype.__initialize = function(root2, visitor) {
      this.visitor = visitor;
      this.root = root2;
      this.__worklist = [];
      this.__leavelist = [];
      this.__current = null;
      this.__state = null;
      this.__fallback = null;
      if (visitor.fallback === "iteration") {
        this.__fallback = Object.keys;
      } else if (typeof visitor.fallback === "function") {
        this.__fallback = visitor.fallback;
      }
      this.__keys = VisitorKeys;
      if (visitor.keys) {
        this.__keys = Object.assign(Object.create(this.__keys), visitor.keys);
      }
    };
    function isNode(node) {
      if (node == null) {
        return false;
      }
      return typeof node === "object" && typeof node.type === "string";
    }
    function isProperty(nodeType, key) {
      return (nodeType === Syntax.ObjectExpression || nodeType === Syntax.ObjectPattern) && key === "properties";
    }
    function candidateExistsInLeaveList(leavelist, candidate) {
      for (var i = leavelist.length - 1; i >= 0; --i) {
        if (leavelist[i].node === candidate) {
          return true;
        }
      }
      return false;
    }
    Controller.prototype.traverse = function traverse2(root2, visitor) {
      var worklist, leavelist, element, node, nodeType, ret, key, current2, current22, candidates, candidate, sentinel;
      this.__initialize(root2, visitor);
      sentinel = {};
      worklist = this.__worklist;
      leavelist = this.__leavelist;
      worklist.push(new Element2(root2, null, null, null));
      leavelist.push(new Element2(null, null, null, null));
      while (worklist.length) {
        element = worklist.pop();
        if (element === sentinel) {
          element = leavelist.pop();
          ret = this.__execute(visitor.leave, element);
          if (this.__state === BREAK || ret === BREAK) {
            return;
          }
          continue;
        }
        if (element.node) {
          ret = this.__execute(visitor.enter, element);
          if (this.__state === BREAK || ret === BREAK) {
            return;
          }
          worklist.push(sentinel);
          leavelist.push(element);
          if (this.__state === SKIP || ret === SKIP) {
            continue;
          }
          node = element.node;
          nodeType = node.type || element.wrap;
          candidates = this.__keys[nodeType];
          if (!candidates) {
            if (this.__fallback) {
              candidates = this.__fallback(node);
            } else {
              throw new Error("Unknown node type " + nodeType + ".");
            }
          }
          current2 = candidates.length;
          while ((current2 -= 1) >= 0) {
            key = candidates[current2];
            candidate = node[key];
            if (!candidate) {
              continue;
            }
            if (Array.isArray(candidate)) {
              current22 = candidate.length;
              while ((current22 -= 1) >= 0) {
                if (!candidate[current22]) {
                  continue;
                }
                if (candidateExistsInLeaveList(leavelist, candidate[current22])) {
                  continue;
                }
                if (isProperty(nodeType, candidates[current2])) {
                  element = new Element2(candidate[current22], [key, current22], "Property", null);
                } else if (isNode(candidate[current22])) {
                  element = new Element2(candidate[current22], [key, current22], null, null);
                } else {
                  continue;
                }
                worklist.push(element);
              }
            } else if (isNode(candidate)) {
              if (candidateExistsInLeaveList(leavelist, candidate)) {
                continue;
              }
              worklist.push(new Element2(candidate, key, null, null));
            }
          }
        }
      }
    };
    Controller.prototype.replace = function replace2(root2, visitor) {
      var worklist, leavelist, node, nodeType, target, element, current2, current22, candidates, candidate, sentinel, outer, key;
      function removeElem(element2) {
        var i, key2, nextElem, parent;
        if (element2.ref.remove()) {
          key2 = element2.ref.key;
          parent = element2.ref.parent;
          i = worklist.length;
          while (i--) {
            nextElem = worklist[i];
            if (nextElem.ref && nextElem.ref.parent === parent) {
              if (nextElem.ref.key < key2) {
                break;
              }
              --nextElem.ref.key;
            }
          }
        }
      }
      this.__initialize(root2, visitor);
      sentinel = {};
      worklist = this.__worklist;
      leavelist = this.__leavelist;
      outer = {
        root: root2
      };
      element = new Element2(root2, null, null, new Reference(outer, "root"));
      worklist.push(element);
      leavelist.push(element);
      while (worklist.length) {
        element = worklist.pop();
        if (element === sentinel) {
          element = leavelist.pop();
          target = this.__execute(visitor.leave, element);
          if (target !== void 0 && target !== BREAK && target !== SKIP && target !== REMOVE) {
            element.ref.replace(target);
          }
          if (this.__state === REMOVE || target === REMOVE) {
            removeElem(element);
          }
          if (this.__state === BREAK || target === BREAK) {
            return outer.root;
          }
          continue;
        }
        target = this.__execute(visitor.enter, element);
        if (target !== void 0 && target !== BREAK && target !== SKIP && target !== REMOVE) {
          element.ref.replace(target);
          element.node = target;
        }
        if (this.__state === REMOVE || target === REMOVE) {
          removeElem(element);
          element.node = null;
        }
        if (this.__state === BREAK || target === BREAK) {
          return outer.root;
        }
        node = element.node;
        if (!node) {
          continue;
        }
        worklist.push(sentinel);
        leavelist.push(element);
        if (this.__state === SKIP || target === SKIP) {
          continue;
        }
        nodeType = node.type || element.wrap;
        candidates = this.__keys[nodeType];
        if (!candidates) {
          if (this.__fallback) {
            candidates = this.__fallback(node);
          } else {
            throw new Error("Unknown node type " + nodeType + ".");
          }
        }
        current2 = candidates.length;
        while ((current2 -= 1) >= 0) {
          key = candidates[current2];
          candidate = node[key];
          if (!candidate) {
            continue;
          }
          if (Array.isArray(candidate)) {
            current22 = candidate.length;
            while ((current22 -= 1) >= 0) {
              if (!candidate[current22]) {
                continue;
              }
              if (isProperty(nodeType, candidates[current2])) {
                element = new Element2(candidate[current22], [key, current22], "Property", new Reference(candidate, current22));
              } else if (isNode(candidate[current22])) {
                element = new Element2(candidate[current22], [key, current22], null, new Reference(candidate, current22));
              } else {
                continue;
              }
              worklist.push(element);
            }
          } else if (isNode(candidate)) {
            worklist.push(new Element2(candidate, key, null, new Reference(node, key)));
          }
        }
      }
      return outer.root;
    };
    function traverse(root2, visitor) {
      var controller = new Controller();
      return controller.traverse(root2, visitor);
    }
    function replace(root2, visitor) {
      var controller = new Controller();
      return controller.replace(root2, visitor);
    }
    function extendCommentRange(comment, tokens) {
      var target;
      target = upperBound(tokens, function search(token) {
        return token.range[0] > comment.range[0];
      });
      comment.extendedRange = [comment.range[0], comment.range[1]];
      if (target !== tokens.length) {
        comment.extendedRange[1] = tokens[target].range[0];
      }
      target -= 1;
      if (target >= 0) {
        comment.extendedRange[0] = tokens[target].range[1];
      }
      return comment;
    }
    function attachComments(tree, providedComments, tokens) {
      var comments = [], comment, len2, i, cursor;
      if (!tree.range) {
        throw new Error("attachComments needs range information");
      }
      if (!tokens.length) {
        if (providedComments.length) {
          for (i = 0, len2 = providedComments.length; i < len2; i += 1) {
            comment = deepCopy(providedComments[i]);
            comment.extendedRange = [0, tree.range[0]];
            comments.push(comment);
          }
          tree.leadingComments = comments;
        }
        return tree;
      }
      for (i = 0, len2 = providedComments.length; i < len2; i += 1) {
        comments.push(extendCommentRange(deepCopy(providedComments[i]), tokens));
      }
      cursor = 0;
      traverse(tree, {
        enter: function(node) {
          var comment2;
          while (cursor < comments.length) {
            comment2 = comments[cursor];
            if (comment2.extendedRange[1] > node.range[0]) {
              break;
            }
            if (comment2.extendedRange[1] === node.range[0]) {
              if (!node.leadingComments) {
                node.leadingComments = [];
              }
              node.leadingComments.push(comment2);
              comments.splice(cursor, 1);
            } else {
              cursor += 1;
            }
          }
          if (cursor === comments.length) {
            return VisitorOption.Break;
          }
          if (comments[cursor].extendedRange[0] > node.range[1]) {
            return VisitorOption.Skip;
          }
        }
      });
      cursor = 0;
      traverse(tree, {
        leave: function(node) {
          var comment2;
          while (cursor < comments.length) {
            comment2 = comments[cursor];
            if (node.range[1] < comment2.extendedRange[0]) {
              break;
            }
            if (node.range[1] === comment2.extendedRange[0]) {
              if (!node.trailingComments) {
                node.trailingComments = [];
              }
              node.trailingComments.push(comment2);
              comments.splice(cursor, 1);
            } else {
              cursor += 1;
            }
          }
          if (cursor === comments.length) {
            return VisitorOption.Break;
          }
          if (comments[cursor].extendedRange[0] > node.range[1]) {
            return VisitorOption.Skip;
          }
        }
      });
      return tree;
    }
    exports2.Syntax = Syntax;
    exports2.traverse = traverse;
    exports2.replace = replace;
    exports2.attachComments = attachComments;
    exports2.VisitorKeys = VisitorKeys;
    exports2.VisitorOption = VisitorOption;
    exports2.Controller = Controller;
    exports2.cloneEnvironment = function() {
      return clone3({});
    };
    return exports2;
  })(exports);
})(estraverse);
var utils$1 = {};
var ast = { exports: {} };
(function() {
  function isExpression(node) {
    if (node == null) {
      return false;
    }
    switch (node.type) {
      case "ArrayExpression":
      case "AssignmentExpression":
      case "BinaryExpression":
      case "CallExpression":
      case "ConditionalExpression":
      case "FunctionExpression":
      case "Identifier":
      case "Literal":
      case "LogicalExpression":
      case "MemberExpression":
      case "NewExpression":
      case "ObjectExpression":
      case "SequenceExpression":
      case "ThisExpression":
      case "UnaryExpression":
      case "UpdateExpression":
        return true;
    }
    return false;
  }
  function isIterationStatement(node) {
    if (node == null) {
      return false;
    }
    switch (node.type) {
      case "DoWhileStatement":
      case "ForInStatement":
      case "ForStatement":
      case "WhileStatement":
        return true;
    }
    return false;
  }
  function isStatement(node) {
    if (node == null) {
      return false;
    }
    switch (node.type) {
      case "BlockStatement":
      case "BreakStatement":
      case "ContinueStatement":
      case "DebuggerStatement":
      case "DoWhileStatement":
      case "EmptyStatement":
      case "ExpressionStatement":
      case "ForInStatement":
      case "ForStatement":
      case "IfStatement":
      case "LabeledStatement":
      case "ReturnStatement":
      case "SwitchStatement":
      case "ThrowStatement":
      case "TryStatement":
      case "VariableDeclaration":
      case "WhileStatement":
      case "WithStatement":
        return true;
    }
    return false;
  }
  function isSourceElement(node) {
    return isStatement(node) || node != null && node.type === "FunctionDeclaration";
  }
  function trailingStatement(node) {
    switch (node.type) {
      case "IfStatement":
        if (node.alternate != null) {
          return node.alternate;
        }
        return node.consequent;
      case "LabeledStatement":
      case "ForStatement":
      case "ForInStatement":
      case "WhileStatement":
      case "WithStatement":
        return node.body;
    }
    return null;
  }
  function isProblematicIfStatement(node) {
    var current2;
    if (node.type !== "IfStatement") {
      return false;
    }
    if (node.alternate == null) {
      return false;
    }
    current2 = node.consequent;
    do {
      if (current2.type === "IfStatement") {
        if (current2.alternate == null) {
          return true;
        }
      }
      current2 = trailingStatement(current2);
    } while (current2);
    return false;
  }
  ast.exports = {
    isExpression,
    isStatement,
    isIterationStatement,
    isSourceElement,
    isProblematicIfStatement,
    trailingStatement
  };
})();
var code = { exports: {} };
(function() {
  var ES6Regex, ES5Regex, NON_ASCII_WHITESPACES, IDENTIFIER_START, IDENTIFIER_PART, ch2;
  ES5Regex = {
    NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/,
    NonAsciiIdentifierPart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/
  };
  ES6Regex = {
    NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
    NonAsciiIdentifierPart: /[\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/
  };
  function isDecimalDigit2(ch3) {
    return 48 <= ch3 && ch3 <= 57;
  }
  function isHexDigit2(ch3) {
    return 48 <= ch3 && ch3 <= 57 || 97 <= ch3 && ch3 <= 102 || 65 <= ch3 && ch3 <= 70;
  }
  function isOctalDigit2(ch3) {
    return ch3 >= 48 && ch3 <= 55;
  }
  NON_ASCII_WHITESPACES = [
    5760,
    8192,
    8193,
    8194,
    8195,
    8196,
    8197,
    8198,
    8199,
    8200,
    8201,
    8202,
    8239,
    8287,
    12288,
    65279
  ];
  function isWhiteSpace(ch3) {
    return ch3 === 32 || ch3 === 9 || ch3 === 11 || ch3 === 12 || ch3 === 160 || ch3 >= 5760 && NON_ASCII_WHITESPACES.indexOf(ch3) >= 0;
  }
  function isLineTerminator(ch3) {
    return ch3 === 10 || ch3 === 13 || ch3 === 8232 || ch3 === 8233;
  }
  function fromCodePoint(cp) {
    if (cp <= 65535) {
      return String.fromCharCode(cp);
    }
    var cu1 = String.fromCharCode(Math.floor((cp - 65536) / 1024) + 55296);
    var cu2 = String.fromCharCode((cp - 65536) % 1024 + 56320);
    return cu1 + cu2;
  }
  IDENTIFIER_START = new Array(128);
  for (ch2 = 0; ch2 < 128; ++ch2) {
    IDENTIFIER_START[ch2] = ch2 >= 97 && ch2 <= 122 || ch2 >= 65 && ch2 <= 90 || ch2 === 36 || ch2 === 95;
  }
  IDENTIFIER_PART = new Array(128);
  for (ch2 = 0; ch2 < 128; ++ch2) {
    IDENTIFIER_PART[ch2] = ch2 >= 97 && ch2 <= 122 || ch2 >= 65 && ch2 <= 90 || ch2 >= 48 && ch2 <= 57 || ch2 === 36 || ch2 === 95;
  }
  function isIdentifierStartES5(ch3) {
    return ch3 < 128 ? IDENTIFIER_START[ch3] : ES5Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch3));
  }
  function isIdentifierPartES5(ch3) {
    return ch3 < 128 ? IDENTIFIER_PART[ch3] : ES5Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch3));
  }
  function isIdentifierStartES6(ch3) {
    return ch3 < 128 ? IDENTIFIER_START[ch3] : ES6Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch3));
  }
  function isIdentifierPartES6(ch3) {
    return ch3 < 128 ? IDENTIFIER_PART[ch3] : ES6Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch3));
  }
  code.exports = {
    isDecimalDigit: isDecimalDigit2,
    isHexDigit: isHexDigit2,
    isOctalDigit: isOctalDigit2,
    isWhiteSpace,
    isLineTerminator,
    isIdentifierStartES5,
    isIdentifierPartES5,
    isIdentifierStartES6,
    isIdentifierPartES6
  };
})();
var keyword = { exports: {} };
(function() {
  var code$1 = code.exports;
  function isStrictModeReservedWordES6(id2) {
    switch (id2) {
      case "implements":
      case "interface":
      case "package":
      case "private":
      case "protected":
      case "public":
      case "static":
      case "let":
        return true;
      default:
        return false;
    }
  }
  function isKeywordES5(id2, strict) {
    if (!strict && id2 === "yield") {
      return false;
    }
    return isKeywordES6(id2, strict);
  }
  function isKeywordES6(id2, strict) {
    if (strict && isStrictModeReservedWordES6(id2)) {
      return true;
    }
    switch (id2.length) {
      case 2:
        return id2 === "if" || id2 === "in" || id2 === "do";
      case 3:
        return id2 === "var" || id2 === "for" || id2 === "new" || id2 === "try";
      case 4:
        return id2 === "this" || id2 === "else" || id2 === "case" || id2 === "void" || id2 === "with" || id2 === "enum";
      case 5:
        return id2 === "while" || id2 === "break" || id2 === "catch" || id2 === "throw" || id2 === "const" || id2 === "yield" || id2 === "class" || id2 === "super";
      case 6:
        return id2 === "return" || id2 === "typeof" || id2 === "delete" || id2 === "switch" || id2 === "export" || id2 === "import";
      case 7:
        return id2 === "default" || id2 === "finally" || id2 === "extends";
      case 8:
        return id2 === "function" || id2 === "continue" || id2 === "debugger";
      case 10:
        return id2 === "instanceof";
      default:
        return false;
    }
  }
  function isReservedWordES5(id2, strict) {
    return id2 === "null" || id2 === "true" || id2 === "false" || isKeywordES5(id2, strict);
  }
  function isReservedWordES6(id2, strict) {
    return id2 === "null" || id2 === "true" || id2 === "false" || isKeywordES6(id2, strict);
  }
  function isRestrictedWord(id2) {
    return id2 === "eval" || id2 === "arguments";
  }
  function isIdentifierNameES5(id2) {
    var i, iz, ch2;
    if (id2.length === 0) {
      return false;
    }
    ch2 = id2.charCodeAt(0);
    if (!code$1.isIdentifierStartES5(ch2)) {
      return false;
    }
    for (i = 1, iz = id2.length; i < iz; ++i) {
      ch2 = id2.charCodeAt(i);
      if (!code$1.isIdentifierPartES5(ch2)) {
        return false;
      }
    }
    return true;
  }
  function decodeUtf16(lead, trail) {
    return (lead - 55296) * 1024 + (trail - 56320) + 65536;
  }
  function isIdentifierNameES6(id2) {
    var i, iz, ch2, lowCh, check;
    if (id2.length === 0) {
      return false;
    }
    check = code$1.isIdentifierStartES6;
    for (i = 0, iz = id2.length; i < iz; ++i) {
      ch2 = id2.charCodeAt(i);
      if (55296 <= ch2 && ch2 <= 56319) {
        ++i;
        if (i >= iz) {
          return false;
        }
        lowCh = id2.charCodeAt(i);
        if (!(56320 <= lowCh && lowCh <= 57343)) {
          return false;
        }
        ch2 = decodeUtf16(ch2, lowCh);
      }
      if (!check(ch2)) {
        return false;
      }
      check = code$1.isIdentifierPartES6;
    }
    return true;
  }
  function isIdentifierES5(id2, strict) {
    return isIdentifierNameES5(id2) && !isReservedWordES5(id2, strict);
  }
  function isIdentifierES6(id2, strict) {
    return isIdentifierNameES6(id2) && !isReservedWordES6(id2, strict);
  }
  keyword.exports = {
    isKeywordES5,
    isKeywordES6,
    isReservedWordES5,
    isReservedWordES6,
    isRestrictedWord,
    isIdentifierNameES5,
    isIdentifierNameES6,
    isIdentifierES5,
    isIdentifierES6
  };
})();
(function() {
  utils$1.ast = ast.exports;
  utils$1.code = code.exports;
  utils$1.keyword = keyword.exports;
})();
var sourceMap = {};
var sourceMapGenerator = {};
var base64Vlq = {};
var base64$1 = {};
var intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
base64$1.encode = function(number4) {
  if (0 <= number4 && number4 < intToCharMap.length) {
    return intToCharMap[number4];
  }
  throw new TypeError("Must be between 0 and 63: " + number4);
};
base64$1.decode = function(charCode) {
  var bigA = 65;
  var bigZ = 90;
  var littleA = 97;
  var littleZ = 122;
  var zero = 48;
  var nine = 57;
  var plus = 43;
  var slash = 47;
  var littleOffset = 26;
  var numberOffset = 52;
  if (bigA <= charCode && charCode <= bigZ) {
    return charCode - bigA;
  }
  if (littleA <= charCode && charCode <= littleZ) {
    return charCode - littleA + littleOffset;
  }
  if (zero <= charCode && charCode <= nine) {
    return charCode - zero + numberOffset;
  }
  if (charCode == plus) {
    return 62;
  }
  if (charCode == slash) {
    return 63;
  }
  return -1;
};
var base64 = base64$1;
var VLQ_BASE_SHIFT = 5;
var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
var VLQ_BASE_MASK = VLQ_BASE - 1;
var VLQ_CONTINUATION_BIT = VLQ_BASE;
function toVLQSigned(aValue) {
  return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
}
function fromVLQSigned(aValue) {
  var isNegative = (aValue & 1) === 1;
  var shifted = aValue >> 1;
  return isNegative ? -shifted : shifted;
}
base64Vlq.encode = function base64VLQ_encode(aValue) {
  var encoded = "";
  var digit;
  var vlq = toVLQSigned(aValue);
  do {
    digit = vlq & VLQ_BASE_MASK;
    vlq >>>= VLQ_BASE_SHIFT;
    if (vlq > 0) {
      digit |= VLQ_CONTINUATION_BIT;
    }
    encoded += base64.encode(digit);
  } while (vlq > 0);
  return encoded;
};
base64Vlq.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
  var strLen = aStr.length;
  var result = 0;
  var shift = 0;
  var continuation, digit;
  do {
    if (aIndex >= strLen) {
      throw new Error("Expected more digits in base 64 VLQ value.");
    }
    digit = base64.decode(aStr.charCodeAt(aIndex++));
    if (digit === -1) {
      throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
    }
    continuation = !!(digit & VLQ_CONTINUATION_BIT);
    digit &= VLQ_BASE_MASK;
    result = result + (digit << shift);
    shift += VLQ_BASE_SHIFT;
  } while (continuation);
  aOutParam.value = fromVLQSigned(result);
  aOutParam.rest = aIndex;
};
var util$5 = {};
(function(exports) {
  function getArg(aArgs, aName, aDefaultValue) {
    if (aName in aArgs) {
      return aArgs[aName];
    } else if (arguments.length === 3) {
      return aDefaultValue;
    } else {
      throw new Error('"' + aName + '" is a required argument.');
    }
  }
  exports.getArg = getArg;
  var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
  var dataUrlRegexp = /^data:.+\,.+$/;
  function urlParse(aUrl) {
    var match = aUrl.match(urlRegexp);
    if (!match) {
      return null;
    }
    return {
      scheme: match[1],
      auth: match[2],
      host: match[3],
      port: match[4],
      path: match[5]
    };
  }
  exports.urlParse = urlParse;
  function urlGenerate(aParsedUrl) {
    var url2 = "";
    if (aParsedUrl.scheme) {
      url2 += aParsedUrl.scheme + ":";
    }
    url2 += "//";
    if (aParsedUrl.auth) {
      url2 += aParsedUrl.auth + "@";
    }
    if (aParsedUrl.host) {
      url2 += aParsedUrl.host;
    }
    if (aParsedUrl.port) {
      url2 += ":" + aParsedUrl.port;
    }
    if (aParsedUrl.path) {
      url2 += aParsedUrl.path;
    }
    return url2;
  }
  exports.urlGenerate = urlGenerate;
  function normalize2(aPath) {
    var path = aPath;
    var url2 = urlParse(aPath);
    if (url2) {
      if (!url2.path) {
        return aPath;
      }
      path = url2.path;
    }
    var isAbsolute = exports.isAbsolute(path);
    var parts = path.split(/\/+/);
    for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
      part = parts[i];
      if (part === ".") {
        parts.splice(i, 1);
      } else if (part === "..") {
        up++;
      } else if (up > 0) {
        if (part === "") {
          parts.splice(i + 1, up);
          up = 0;
        } else {
          parts.splice(i, 2);
          up--;
        }
      }
    }
    path = parts.join("/");
    if (path === "") {
      path = isAbsolute ? "/" : ".";
    }
    if (url2) {
      url2.path = path;
      return urlGenerate(url2);
    }
    return path;
  }
  exports.normalize = normalize2;
  function join(aRoot, aPath) {
    if (aRoot === "") {
      aRoot = ".";
    }
    if (aPath === "") {
      aPath = ".";
    }
    var aPathUrl = urlParse(aPath);
    var aRootUrl = urlParse(aRoot);
    if (aRootUrl) {
      aRoot = aRootUrl.path || "/";
    }
    if (aPathUrl && !aPathUrl.scheme) {
      if (aRootUrl) {
        aPathUrl.scheme = aRootUrl.scheme;
      }
      return urlGenerate(aPathUrl);
    }
    if (aPathUrl || aPath.match(dataUrlRegexp)) {
      return aPath;
    }
    if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
      aRootUrl.host = aPath;
      return urlGenerate(aRootUrl);
    }
    var joined = aPath.charAt(0) === "/" ? aPath : normalize2(aRoot.replace(/\/+$/, "") + "/" + aPath);
    if (aRootUrl) {
      aRootUrl.path = joined;
      return urlGenerate(aRootUrl);
    }
    return joined;
  }
  exports.join = join;
  exports.isAbsolute = function(aPath) {
    return aPath.charAt(0) === "/" || urlRegexp.test(aPath);
  };
  function relative(aRoot, aPath) {
    if (aRoot === "") {
      aRoot = ".";
    }
    aRoot = aRoot.replace(/\/$/, "");
    var level = 0;
    while (aPath.indexOf(aRoot + "/") !== 0) {
      var index2 = aRoot.lastIndexOf("/");
      if (index2 < 0) {
        return aPath;
      }
      aRoot = aRoot.slice(0, index2);
      if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
        return aPath;
      }
      ++level;
    }
    return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
  }
  exports.relative = relative;
  var supportsNullProto = function() {
    var obj = /* @__PURE__ */ Object.create(null);
    return !("__proto__" in obj);
  }();
  function identity2(s) {
    return s;
  }
  function toSetString(aStr) {
    if (isProtoString(aStr)) {
      return "$" + aStr;
    }
    return aStr;
  }
  exports.toSetString = supportsNullProto ? identity2 : toSetString;
  function fromSetString(aStr) {
    if (isProtoString(aStr)) {
      return aStr.slice(1);
    }
    return aStr;
  }
  exports.fromSetString = supportsNullProto ? identity2 : fromSetString;
  function isProtoString(s) {
    if (!s) {
      return false;
    }
    var length = s.length;
    if (length < 9) {
      return false;
    }
    if (s.charCodeAt(length - 1) !== 95 || s.charCodeAt(length - 2) !== 95 || s.charCodeAt(length - 3) !== 111 || s.charCodeAt(length - 4) !== 116 || s.charCodeAt(length - 5) !== 111 || s.charCodeAt(length - 6) !== 114 || s.charCodeAt(length - 7) !== 112 || s.charCodeAt(length - 8) !== 95 || s.charCodeAt(length - 9) !== 95) {
      return false;
    }
    for (var i = length - 10; i >= 0; i--) {
      if (s.charCodeAt(i) !== 36) {
        return false;
      }
    }
    return true;
  }
  function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
    var cmp = strcmp(mappingA.source, mappingB.source);
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalLine - mappingB.originalLine;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalColumn - mappingB.originalColumn;
    if (cmp !== 0 || onlyCompareOriginal) {
      return cmp;
    }
    cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.generatedLine - mappingB.generatedLine;
    if (cmp !== 0) {
      return cmp;
    }
    return strcmp(mappingA.name, mappingB.name);
  }
  exports.compareByOriginalPositions = compareByOriginalPositions;
  function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
    var cmp = mappingA.generatedLine - mappingB.generatedLine;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    if (cmp !== 0 || onlyCompareGenerated) {
      return cmp;
    }
    cmp = strcmp(mappingA.source, mappingB.source);
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalLine - mappingB.originalLine;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalColumn - mappingB.originalColumn;
    if (cmp !== 0) {
      return cmp;
    }
    return strcmp(mappingA.name, mappingB.name);
  }
  exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;
  function strcmp(aStr1, aStr2) {
    if (aStr1 === aStr2) {
      return 0;
    }
    if (aStr1 === null) {
      return 1;
    }
    if (aStr2 === null) {
      return -1;
    }
    if (aStr1 > aStr2) {
      return 1;
    }
    return -1;
  }
  function compareByGeneratedPositionsInflated(mappingA, mappingB) {
    var cmp = mappingA.generatedLine - mappingB.generatedLine;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = strcmp(mappingA.source, mappingB.source);
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalLine - mappingB.originalLine;
    if (cmp !== 0) {
      return cmp;
    }
    cmp = mappingA.originalColumn - mappingB.originalColumn;
    if (cmp !== 0) {
      return cmp;
    }
    return strcmp(mappingA.name, mappingB.name);
  }
  exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
  function parseSourceMapInput(str) {
    return JSON.parse(str.replace(/^\)]}'[^\n]*\n/, ""));
  }
  exports.parseSourceMapInput = parseSourceMapInput;
  function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
    sourceURL = sourceURL || "";
    if (sourceRoot) {
      if (sourceRoot[sourceRoot.length - 1] !== "/" && sourceURL[0] !== "/") {
        sourceRoot += "/";
      }
      sourceURL = sourceRoot + sourceURL;
    }
    if (sourceMapURL) {
      var parsed = urlParse(sourceMapURL);
      if (!parsed) {
        throw new Error("sourceMapURL could not be parsed");
      }
      if (parsed.path) {
        var index2 = parsed.path.lastIndexOf("/");
        if (index2 >= 0) {
          parsed.path = parsed.path.substring(0, index2 + 1);
        }
      }
      sourceURL = join(urlGenerate(parsed), sourceURL);
    }
    return normalize2(sourceURL);
  }
  exports.computeSourceURL = computeSourceURL;
})(util$5);
var arraySet = {};
var util$4 = util$5;
var has = Object.prototype.hasOwnProperty;
var hasNativeMap = typeof Map !== "undefined";
function ArraySet$2() {
  this._array = [];
  this._set = hasNativeMap ? /* @__PURE__ */ new Map() : /* @__PURE__ */ Object.create(null);
}
ArraySet$2.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
  var set2 = new ArraySet$2();
  for (var i = 0, len2 = aArray.length; i < len2; i++) {
    set2.add(aArray[i], aAllowDuplicates);
  }
  return set2;
};
ArraySet$2.prototype.size = function ArraySet_size() {
  return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
};
ArraySet$2.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
  var sStr = hasNativeMap ? aStr : util$4.toSetString(aStr);
  var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
  var idx = this._array.length;
  if (!isDuplicate || aAllowDuplicates) {
    this._array.push(aStr);
  }
  if (!isDuplicate) {
    if (hasNativeMap) {
      this._set.set(aStr, idx);
    } else {
      this._set[sStr] = idx;
    }
  }
};
ArraySet$2.prototype.has = function ArraySet_has(aStr) {
  if (hasNativeMap) {
    return this._set.has(aStr);
  } else {
    var sStr = util$4.toSetString(aStr);
    return has.call(this._set, sStr);
  }
};
ArraySet$2.prototype.indexOf = function ArraySet_indexOf(aStr) {
  if (hasNativeMap) {
    var idx = this._set.get(aStr);
    if (idx >= 0) {
      return idx;
    }
  } else {
    var sStr = util$4.toSetString(aStr);
    if (has.call(this._set, sStr)) {
      return this._set[sStr];
    }
  }
  throw new Error('"' + aStr + '" is not in the set.');
};
ArraySet$2.prototype.at = function ArraySet_at(aIdx) {
  if (aIdx >= 0 && aIdx < this._array.length) {
    return this._array[aIdx];
  }
  throw new Error("No element indexed by " + aIdx);
};
ArraySet$2.prototype.toArray = function ArraySet_toArray() {
  return this._array.slice();
};
arraySet.ArraySet = ArraySet$2;
var mappingList = {};
var util$3 = util$5;
function generatedPositionAfter(mappingA, mappingB) {
  var lineA = mappingA.generatedLine;
  var lineB = mappingB.generatedLine;
  var columnA = mappingA.generatedColumn;
  var columnB = mappingB.generatedColumn;
  return lineB > lineA || lineB == lineA && columnB >= columnA || util$3.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
}
function MappingList$1() {
  this._array = [];
  this._sorted = true;
  this._last = { generatedLine: -1, generatedColumn: 0 };
}
MappingList$1.prototype.unsortedForEach = function MappingList_forEach(aCallback, aThisArg) {
  this._array.forEach(aCallback, aThisArg);
};
MappingList$1.prototype.add = function MappingList_add(aMapping) {
  if (generatedPositionAfter(this._last, aMapping)) {
    this._last = aMapping;
    this._array.push(aMapping);
  } else {
    this._sorted = false;
    this._array.push(aMapping);
  }
};
MappingList$1.prototype.toArray = function MappingList_toArray() {
  if (!this._sorted) {
    this._array.sort(util$3.compareByGeneratedPositionsInflated);
    this._sorted = true;
  }
  return this._array;
};
mappingList.MappingList = MappingList$1;
var base64VLQ$1 = base64Vlq;
var util$2 = util$5;
var ArraySet$1 = arraySet.ArraySet;
var MappingList = mappingList.MappingList;
function SourceMapGenerator$1(aArgs) {
  if (!aArgs) {
    aArgs = {};
  }
  this._file = util$2.getArg(aArgs, "file", null);
  this._sourceRoot = util$2.getArg(aArgs, "sourceRoot", null);
  this._skipValidation = util$2.getArg(aArgs, "skipValidation", false);
  this._sources = new ArraySet$1();
  this._names = new ArraySet$1();
  this._mappings = new MappingList();
  this._sourcesContents = null;
}
SourceMapGenerator$1.prototype._version = 3;
SourceMapGenerator$1.fromSourceMap = function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
  var sourceRoot = aSourceMapConsumer.sourceRoot;
  var generator = new SourceMapGenerator$1({
    file: aSourceMapConsumer.file,
    sourceRoot
  });
  aSourceMapConsumer.eachMapping(function(mapping) {
    var newMapping = {
      generated: {
        line: mapping.generatedLine,
        column: mapping.generatedColumn
      }
    };
    if (mapping.source != null) {
      newMapping.source = mapping.source;
      if (sourceRoot != null) {
        newMapping.source = util$2.relative(sourceRoot, newMapping.source);
      }
      newMapping.original = {
        line: mapping.originalLine,
        column: mapping.originalColumn
      };
      if (mapping.name != null) {
        newMapping.name = mapping.name;
      }
    }
    generator.addMapping(newMapping);
  });
  aSourceMapConsumer.sources.forEach(function(sourceFile) {
    var sourceRelative = sourceFile;
    if (sourceRoot !== null) {
      sourceRelative = util$2.relative(sourceRoot, sourceFile);
    }
    if (!generator._sources.has(sourceRelative)) {
      generator._sources.add(sourceRelative);
    }
    var content = aSourceMapConsumer.sourceContentFor(sourceFile);
    if (content != null) {
      generator.setSourceContent(sourceFile, content);
    }
  });
  return generator;
};
SourceMapGenerator$1.prototype.addMapping = function SourceMapGenerator_addMapping(aArgs) {
  var generated = util$2.getArg(aArgs, "generated");
  var original = util$2.getArg(aArgs, "original", null);
  var source = util$2.getArg(aArgs, "source", null);
  var name2 = util$2.getArg(aArgs, "name", null);
  if (!this._skipValidation) {
    this._validateMapping(generated, original, source, name2);
  }
  if (source != null) {
    source = String(source);
    if (!this._sources.has(source)) {
      this._sources.add(source);
    }
  }
  if (name2 != null) {
    name2 = String(name2);
    if (!this._names.has(name2)) {
      this._names.add(name2);
    }
  }
  this._mappings.add({
    generatedLine: generated.line,
    generatedColumn: generated.column,
    originalLine: original != null && original.line,
    originalColumn: original != null && original.column,
    source,
    name: name2
  });
};
SourceMapGenerator$1.prototype.setSourceContent = function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
  var source = aSourceFile;
  if (this._sourceRoot != null) {
    source = util$2.relative(this._sourceRoot, source);
  }
  if (aSourceContent != null) {
    if (!this._sourcesContents) {
      this._sourcesContents = /* @__PURE__ */ Object.create(null);
    }
    this._sourcesContents[util$2.toSetString(source)] = aSourceContent;
  } else if (this._sourcesContents) {
    delete this._sourcesContents[util$2.toSetString(source)];
    if (Object.keys(this._sourcesContents).length === 0) {
      this._sourcesContents = null;
    }
  }
};
SourceMapGenerator$1.prototype.applySourceMap = function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
  var sourceFile = aSourceFile;
  if (aSourceFile == null) {
    if (aSourceMapConsumer.file == null) {
      throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);
    }
    sourceFile = aSourceMapConsumer.file;
  }
  var sourceRoot = this._sourceRoot;
  if (sourceRoot != null) {
    sourceFile = util$2.relative(sourceRoot, sourceFile);
  }
  var newSources = new ArraySet$1();
  var newNames = new ArraySet$1();
  this._mappings.unsortedForEach(function(mapping) {
    if (mapping.source === sourceFile && mapping.originalLine != null) {
      var original = aSourceMapConsumer.originalPositionFor({
        line: mapping.originalLine,
        column: mapping.originalColumn
      });
      if (original.source != null) {
        mapping.source = original.source;
        if (aSourceMapPath != null) {
          mapping.source = util$2.join(aSourceMapPath, mapping.source);
        }
        if (sourceRoot != null) {
          mapping.source = util$2.relative(sourceRoot, mapping.source);
        }
        mapping.originalLine = original.line;
        mapping.originalColumn = original.column;
        if (original.name != null) {
          mapping.name = original.name;
        }
      }
    }
    var source = mapping.source;
    if (source != null && !newSources.has(source)) {
      newSources.add(source);
    }
    var name2 = mapping.name;
    if (name2 != null && !newNames.has(name2)) {
      newNames.add(name2);
    }
  }, this);
  this._sources = newSources;
  this._names = newNames;
  aSourceMapConsumer.sources.forEach(function(sourceFile2) {
    var content = aSourceMapConsumer.sourceContentFor(sourceFile2);
    if (content != null) {
      if (aSourceMapPath != null) {
        sourceFile2 = util$2.join(aSourceMapPath, sourceFile2);
      }
      if (sourceRoot != null) {
        sourceFile2 = util$2.relative(sourceRoot, sourceFile2);
      }
      this.setSourceContent(sourceFile2, content);
    }
  }, this);
};
SourceMapGenerator$1.prototype._validateMapping = function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource, aName) {
  if (aOriginal && typeof aOriginal.line !== "number" && typeof aOriginal.column !== "number") {
    throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");
  }
  if (aGenerated && "line" in aGenerated && "column" in aGenerated && aGenerated.line > 0 && aGenerated.column >= 0 && !aOriginal && !aSource && !aName) {
    return;
  } else if (aGenerated && "line" in aGenerated && "column" in aGenerated && aOriginal && "line" in aOriginal && "column" in aOriginal && aGenerated.line > 0 && aGenerated.column >= 0 && aOriginal.line > 0 && aOriginal.column >= 0 && aSource) {
    return;
  } else {
    throw new Error("Invalid mapping: " + JSON.stringify({
      generated: aGenerated,
      source: aSource,
      original: aOriginal,
      name: aName
    }));
  }
};
SourceMapGenerator$1.prototype._serializeMappings = function SourceMapGenerator_serializeMappings() {
  var previousGeneratedColumn = 0;
  var previousGeneratedLine = 1;
  var previousOriginalColumn = 0;
  var previousOriginalLine = 0;
  var previousName = 0;
  var previousSource = 0;
  var result = "";
  var next;
  var mapping;
  var nameIdx;
  var sourceIdx;
  var mappings = this._mappings.toArray();
  for (var i = 0, len2 = mappings.length; i < len2; i++) {
    mapping = mappings[i];
    next = "";
    if (mapping.generatedLine !== previousGeneratedLine) {
      previousGeneratedColumn = 0;
      while (mapping.generatedLine !== previousGeneratedLine) {
        next += ";";
        previousGeneratedLine++;
      }
    } else {
      if (i > 0) {
        if (!util$2.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
          continue;
        }
        next += ",";
      }
    }
    next += base64VLQ$1.encode(mapping.generatedColumn - previousGeneratedColumn);
    previousGeneratedColumn = mapping.generatedColumn;
    if (mapping.source != null) {
      sourceIdx = this._sources.indexOf(mapping.source);
      next += base64VLQ$1.encode(sourceIdx - previousSource);
      previousSource = sourceIdx;
      next += base64VLQ$1.encode(mapping.originalLine - 1 - previousOriginalLine);
      previousOriginalLine = mapping.originalLine - 1;
      next += base64VLQ$1.encode(mapping.originalColumn - previousOriginalColumn);
      previousOriginalColumn = mapping.originalColumn;
      if (mapping.name != null) {
        nameIdx = this._names.indexOf(mapping.name);
        next += base64VLQ$1.encode(nameIdx - previousName);
        previousName = nameIdx;
      }
    }
    result += next;
  }
  return result;
};
SourceMapGenerator$1.prototype._generateSourcesContent = function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
  return aSources.map(function(source) {
    if (!this._sourcesContents) {
      return null;
    }
    if (aSourceRoot != null) {
      source = util$2.relative(aSourceRoot, source);
    }
    var key = util$2.toSetString(source);
    return Object.prototype.hasOwnProperty.call(this._sourcesContents, key) ? this._sourcesContents[key] : null;
  }, this);
};
SourceMapGenerator$1.prototype.toJSON = function SourceMapGenerator_toJSON() {
  var map2 = {
    version: this._version,
    sources: this._sources.toArray(),
    names: this._names.toArray(),
    mappings: this._serializeMappings()
  };
  if (this._file != null) {
    map2.file = this._file;
  }
  if (this._sourceRoot != null) {
    map2.sourceRoot = this._sourceRoot;
  }
  if (this._sourcesContents) {
    map2.sourcesContent = this._generateSourcesContent(map2.sources, map2.sourceRoot);
  }
  return map2;
};
SourceMapGenerator$1.prototype.toString = function SourceMapGenerator_toString() {
  return JSON.stringify(this.toJSON());
};
sourceMapGenerator.SourceMapGenerator = SourceMapGenerator$1;
var sourceMapConsumer = {};
var binarySearch$1 = {};
(function(exports) {
  exports.GREATEST_LOWER_BOUND = 1;
  exports.LEAST_UPPER_BOUND = 2;
  function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
    var mid = Math.floor((aHigh - aLow) / 2) + aLow;
    var cmp = aCompare(aNeedle, aHaystack[mid], true);
    if (cmp === 0) {
      return mid;
    } else if (cmp > 0) {
      if (aHigh - mid > 1) {
        return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
      }
      if (aBias == exports.LEAST_UPPER_BOUND) {
        return aHigh < aHaystack.length ? aHigh : -1;
      } else {
        return mid;
      }
    } else {
      if (mid - aLow > 1) {
        return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
      }
      if (aBias == exports.LEAST_UPPER_BOUND) {
        return mid;
      } else {
        return aLow < 0 ? -1 : aLow;
      }
    }
  }
  exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
    if (aHaystack.length === 0) {
      return -1;
    }
    var index2 = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack, aCompare, aBias || exports.GREATEST_LOWER_BOUND);
    if (index2 < 0) {
      return -1;
    }
    while (index2 - 1 >= 0) {
      if (aCompare(aHaystack[index2], aHaystack[index2 - 1], true) !== 0) {
        break;
      }
      --index2;
    }
    return index2;
  };
})(binarySearch$1);
var quickSort$1 = {};
function swap$1(ary, x2, y2) {
  var temp = ary[x2];
  ary[x2] = ary[y2];
  ary[y2] = temp;
}
function randomIntInRange(low, high) {
  return Math.round(low + Math.random() * (high - low));
}
function doQuickSort(ary, comparator, p2, r2) {
  if (p2 < r2) {
    var pivotIndex = randomIntInRange(p2, r2);
    var i = p2 - 1;
    swap$1(ary, pivotIndex, r2);
    var pivot = ary[r2];
    for (var j = p2; j < r2; j++) {
      if (comparator(ary[j], pivot) <= 0) {
        i += 1;
        swap$1(ary, i, j);
      }
    }
    swap$1(ary, i + 1, j);
    var q2 = i + 1;
    doQuickSort(ary, comparator, p2, q2 - 1);
    doQuickSort(ary, comparator, q2 + 1, r2);
  }
}
quickSort$1.quickSort = function(ary, comparator) {
  doQuickSort(ary, comparator, 0, ary.length - 1);
};
var util$1 = util$5;
var binarySearch = binarySearch$1;
var ArraySet = arraySet.ArraySet;
var base64VLQ = base64Vlq;
var quickSort = quickSort$1.quickSort;
function SourceMapConsumer(aSourceMap, aSourceMapURL) {
  var sourceMap2 = aSourceMap;
  if (typeof aSourceMap === "string") {
    sourceMap2 = util$1.parseSourceMapInput(aSourceMap);
  }
  return sourceMap2.sections != null ? new IndexedSourceMapConsumer(sourceMap2, aSourceMapURL) : new BasicSourceMapConsumer(sourceMap2, aSourceMapURL);
}
SourceMapConsumer.fromSourceMap = function(aSourceMap, aSourceMapURL) {
  return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
};
SourceMapConsumer.prototype._version = 3;
SourceMapConsumer.prototype.__generatedMappings = null;
Object.defineProperty(SourceMapConsumer.prototype, "_generatedMappings", {
  configurable: true,
  enumerable: true,
  get: function() {
    if (!this.__generatedMappings) {
      this._parseMappings(this._mappings, this.sourceRoot);
    }
    return this.__generatedMappings;
  }
});
SourceMapConsumer.prototype.__originalMappings = null;
Object.defineProperty(SourceMapConsumer.prototype, "_originalMappings", {
  configurable: true,
  enumerable: true,
  get: function() {
    if (!this.__originalMappings) {
      this._parseMappings(this._mappings, this.sourceRoot);
    }
    return this.__originalMappings;
  }
});
SourceMapConsumer.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index2) {
  var c2 = aStr.charAt(index2);
  return c2 === ";" || c2 === ",";
};
SourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
  throw new Error("Subclasses must implement _parseMappings");
};
SourceMapConsumer.GENERATED_ORDER = 1;
SourceMapConsumer.ORIGINAL_ORDER = 2;
SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
SourceMapConsumer.LEAST_UPPER_BOUND = 2;
SourceMapConsumer.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
  var context = aContext || null;
  var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
  var mappings;
  switch (order) {
    case SourceMapConsumer.GENERATED_ORDER:
      mappings = this._generatedMappings;
      break;
    case SourceMapConsumer.ORIGINAL_ORDER:
      mappings = this._originalMappings;
      break;
    default:
      throw new Error("Unknown order of iteration.");
  }
  var sourceRoot = this.sourceRoot;
  mappings.map(function(mapping) {
    var source = mapping.source === null ? null : this._sources.at(mapping.source);
    source = util$1.computeSourceURL(sourceRoot, source, this._sourceMapURL);
    return {
      source,
      generatedLine: mapping.generatedLine,
      generatedColumn: mapping.generatedColumn,
      originalLine: mapping.originalLine,
      originalColumn: mapping.originalColumn,
      name: mapping.name === null ? null : this._names.at(mapping.name)
    };
  }, this).forEach(aCallback, context);
};
SourceMapConsumer.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
  var line = util$1.getArg(aArgs, "line");
  var needle = {
    source: util$1.getArg(aArgs, "source"),
    originalLine: line,
    originalColumn: util$1.getArg(aArgs, "column", 0)
  };
  needle.source = this._findSourceIndex(needle.source);
  if (needle.source < 0) {
    return [];
  }
  var mappings = [];
  var index2 = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util$1.compareByOriginalPositions, binarySearch.LEAST_UPPER_BOUND);
  if (index2 >= 0) {
    var mapping = this._originalMappings[index2];
    if (aArgs.column === void 0) {
      var originalLine = mapping.originalLine;
      while (mapping && mapping.originalLine === originalLine) {
        mappings.push({
          line: util$1.getArg(mapping, "generatedLine", null),
          column: util$1.getArg(mapping, "generatedColumn", null),
          lastColumn: util$1.getArg(mapping, "lastGeneratedColumn", null)
        });
        mapping = this._originalMappings[++index2];
      }
    } else {
      var originalColumn = mapping.originalColumn;
      while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
        mappings.push({
          line: util$1.getArg(mapping, "generatedLine", null),
          column: util$1.getArg(mapping, "generatedColumn", null),
          lastColumn: util$1.getArg(mapping, "lastGeneratedColumn", null)
        });
        mapping = this._originalMappings[++index2];
      }
    }
  }
  return mappings;
};
sourceMapConsumer.SourceMapConsumer = SourceMapConsumer;
function BasicSourceMapConsumer(aSourceMap, aSourceMapURL) {
  var sourceMap2 = aSourceMap;
  if (typeof aSourceMap === "string") {
    sourceMap2 = util$1.parseSourceMapInput(aSourceMap);
  }
  var version2 = util$1.getArg(sourceMap2, "version");
  var sources = util$1.getArg(sourceMap2, "sources");
  var names2 = util$1.getArg(sourceMap2, "names", []);
  var sourceRoot = util$1.getArg(sourceMap2, "sourceRoot", null);
  var sourcesContent = util$1.getArg(sourceMap2, "sourcesContent", null);
  var mappings = util$1.getArg(sourceMap2, "mappings");
  var file = util$1.getArg(sourceMap2, "file", null);
  if (version2 != this._version) {
    throw new Error("Unsupported version: " + version2);
  }
  if (sourceRoot) {
    sourceRoot = util$1.normalize(sourceRoot);
  }
  sources = sources.map(String).map(util$1.normalize).map(function(source) {
    return sourceRoot && util$1.isAbsolute(sourceRoot) && util$1.isAbsolute(source) ? util$1.relative(sourceRoot, source) : source;
  });
  this._names = ArraySet.fromArray(names2.map(String), true);
  this._sources = ArraySet.fromArray(sources, true);
  this._absoluteSources = this._sources.toArray().map(function(s) {
    return util$1.computeSourceURL(sourceRoot, s, aSourceMapURL);
  });
  this.sourceRoot = sourceRoot;
  this.sourcesContent = sourcesContent;
  this._mappings = mappings;
  this._sourceMapURL = aSourceMapURL;
  this.file = file;
}
BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
BasicSourceMapConsumer.prototype._findSourceIndex = function(aSource) {
  var relativeSource = aSource;
  if (this.sourceRoot != null) {
    relativeSource = util$1.relative(this.sourceRoot, relativeSource);
  }
  if (this._sources.has(relativeSource)) {
    return this._sources.indexOf(relativeSource);
  }
  var i;
  for (i = 0; i < this._absoluteSources.length; ++i) {
    if (this._absoluteSources[i] == aSource) {
      return i;
    }
  }
  return -1;
};
BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap, aSourceMapURL) {
  var smc = Object.create(BasicSourceMapConsumer.prototype);
  var names2 = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
  var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
  smc.sourceRoot = aSourceMap._sourceRoot;
  smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(), smc.sourceRoot);
  smc.file = aSourceMap._file;
  smc._sourceMapURL = aSourceMapURL;
  smc._absoluteSources = smc._sources.toArray().map(function(s) {
    return util$1.computeSourceURL(smc.sourceRoot, s, aSourceMapURL);
  });
  var generatedMappings = aSourceMap._mappings.toArray().slice();
  var destGeneratedMappings = smc.__generatedMappings = [];
  var destOriginalMappings = smc.__originalMappings = [];
  for (var i = 0, length = generatedMappings.length; i < length; i++) {
    var srcMapping = generatedMappings[i];
    var destMapping = new Mapping();
    destMapping.generatedLine = srcMapping.generatedLine;
    destMapping.generatedColumn = srcMapping.generatedColumn;
    if (srcMapping.source) {
      destMapping.source = sources.indexOf(srcMapping.source);
      destMapping.originalLine = srcMapping.originalLine;
      destMapping.originalColumn = srcMapping.originalColumn;
      if (srcMapping.name) {
        destMapping.name = names2.indexOf(srcMapping.name);
      }
      destOriginalMappings.push(destMapping);
    }
    destGeneratedMappings.push(destMapping);
  }
  quickSort(smc.__originalMappings, util$1.compareByOriginalPositions);
  return smc;
};
BasicSourceMapConsumer.prototype._version = 3;
Object.defineProperty(BasicSourceMapConsumer.prototype, "sources", {
  get: function() {
    return this._absoluteSources.slice();
  }
});
function Mapping() {
  this.generatedLine = 0;
  this.generatedColumn = 0;
  this.source = null;
  this.originalLine = null;
  this.originalColumn = null;
  this.name = null;
}
BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings2(aStr, aSourceRoot) {
  var generatedLine = 1;
  var previousGeneratedColumn = 0;
  var previousOriginalLine = 0;
  var previousOriginalColumn = 0;
  var previousSource = 0;
  var previousName = 0;
  var length = aStr.length;
  var index2 = 0;
  var cachedSegments = {};
  var temp = {};
  var originalMappings = [];
  var generatedMappings = [];
  var mapping, str, segment, end2, value;
  while (index2 < length) {
    if (aStr.charAt(index2) === ";") {
      generatedLine++;
      index2++;
      previousGeneratedColumn = 0;
    } else if (aStr.charAt(index2) === ",") {
      index2++;
    } else {
      mapping = new Mapping();
      mapping.generatedLine = generatedLine;
      for (end2 = index2; end2 < length; end2++) {
        if (this._charIsMappingSeparator(aStr, end2)) {
          break;
        }
      }
      str = aStr.slice(index2, end2);
      segment = cachedSegments[str];
      if (segment) {
        index2 += str.length;
      } else {
        segment = [];
        while (index2 < end2) {
          base64VLQ.decode(aStr, index2, temp);
          value = temp.value;
          index2 = temp.rest;
          segment.push(value);
        }
        if (segment.length === 2) {
          throw new Error("Found a source, but no line and column");
        }
        if (segment.length === 3) {
          throw new Error("Found a source and line, but no column");
        }
        cachedSegments[str] = segment;
      }
      mapping.generatedColumn = previousGeneratedColumn + segment[0];
      previousGeneratedColumn = mapping.generatedColumn;
      if (segment.length > 1) {
        mapping.source = previousSource + segment[1];
        previousSource += segment[1];
        mapping.originalLine = previousOriginalLine + segment[2];
        previousOriginalLine = mapping.originalLine;
        mapping.originalLine += 1;
        mapping.originalColumn = previousOriginalColumn + segment[3];
        previousOriginalColumn = mapping.originalColumn;
        if (segment.length > 4) {
          mapping.name = previousName + segment[4];
          previousName += segment[4];
        }
      }
      generatedMappings.push(mapping);
      if (typeof mapping.originalLine === "number") {
        originalMappings.push(mapping);
      }
    }
  }
  quickSort(generatedMappings, util$1.compareByGeneratedPositionsDeflated);
  this.__generatedMappings = generatedMappings;
  quickSort(originalMappings, util$1.compareByOriginalPositions);
  this.__originalMappings = originalMappings;
};
BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
  if (aNeedle[aLineName] <= 0) {
    throw new TypeError("Line must be greater than or equal to 1, got " + aNeedle[aLineName]);
  }
  if (aNeedle[aColumnName] < 0) {
    throw new TypeError("Column must be greater than or equal to 0, got " + aNeedle[aColumnName]);
  }
  return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
};
BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
  for (var index2 = 0; index2 < this._generatedMappings.length; ++index2) {
    var mapping = this._generatedMappings[index2];
    if (index2 + 1 < this._generatedMappings.length) {
      var nextMapping = this._generatedMappings[index2 + 1];
      if (mapping.generatedLine === nextMapping.generatedLine) {
        mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
        continue;
      }
    }
    mapping.lastGeneratedColumn = Infinity;
  }
};
BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
  var needle = {
    generatedLine: util$1.getArg(aArgs, "line"),
    generatedColumn: util$1.getArg(aArgs, "column")
  };
  var index2 = this._findMapping(needle, this._generatedMappings, "generatedLine", "generatedColumn", util$1.compareByGeneratedPositionsDeflated, util$1.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
  if (index2 >= 0) {
    var mapping = this._generatedMappings[index2];
    if (mapping.generatedLine === needle.generatedLine) {
      var source = util$1.getArg(mapping, "source", null);
      if (source !== null) {
        source = this._sources.at(source);
        source = util$1.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
      }
      var name2 = util$1.getArg(mapping, "name", null);
      if (name2 !== null) {
        name2 = this._names.at(name2);
      }
      return {
        source,
        line: util$1.getArg(mapping, "originalLine", null),
        column: util$1.getArg(mapping, "originalColumn", null),
        name: name2
      };
    }
  }
  return {
    source: null,
    line: null,
    column: null,
    name: null
  };
};
BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
  if (!this.sourcesContent) {
    return false;
  }
  return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function(sc2) {
    return sc2 == null;
  });
};
BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
  if (!this.sourcesContent) {
    return null;
  }
  var index2 = this._findSourceIndex(aSource);
  if (index2 >= 0) {
    return this.sourcesContent[index2];
  }
  var relativeSource = aSource;
  if (this.sourceRoot != null) {
    relativeSource = util$1.relative(this.sourceRoot, relativeSource);
  }
  var url2;
  if (this.sourceRoot != null && (url2 = util$1.urlParse(this.sourceRoot))) {
    var fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
    if (url2.scheme == "file" && this._sources.has(fileUriAbsPath)) {
      return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
    }
    if ((!url2.path || url2.path == "/") && this._sources.has("/" + relativeSource)) {
      return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
    }
  }
  if (nullOnMissing) {
    return null;
  } else {
    throw new Error('"' + relativeSource + '" is not in the SourceMap.');
  }
};
BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
  var source = util$1.getArg(aArgs, "source");
  source = this._findSourceIndex(source);
  if (source < 0) {
    return {
      line: null,
      column: null,
      lastColumn: null
    };
  }
  var needle = {
    source,
    originalLine: util$1.getArg(aArgs, "line"),
    originalColumn: util$1.getArg(aArgs, "column")
  };
  var index2 = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util$1.compareByOriginalPositions, util$1.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
  if (index2 >= 0) {
    var mapping = this._originalMappings[index2];
    if (mapping.source === needle.source) {
      return {
        line: util$1.getArg(mapping, "generatedLine", null),
        column: util$1.getArg(mapping, "generatedColumn", null),
        lastColumn: util$1.getArg(mapping, "lastGeneratedColumn", null)
      };
    }
  }
  return {
    line: null,
    column: null,
    lastColumn: null
  };
};
sourceMapConsumer.BasicSourceMapConsumer = BasicSourceMapConsumer;
function IndexedSourceMapConsumer(aSourceMap, aSourceMapURL) {
  var sourceMap2 = aSourceMap;
  if (typeof aSourceMap === "string") {
    sourceMap2 = util$1.parseSourceMapInput(aSourceMap);
  }
  var version2 = util$1.getArg(sourceMap2, "version");
  var sections = util$1.getArg(sourceMap2, "sections");
  if (version2 != this._version) {
    throw new Error("Unsupported version: " + version2);
  }
  this._sources = new ArraySet();
  this._names = new ArraySet();
  var lastOffset = {
    line: -1,
    column: 0
  };
  this._sections = sections.map(function(s) {
    if (s.url) {
      throw new Error("Support for url field in sections not implemented.");
    }
    var offset3 = util$1.getArg(s, "offset");
    var offsetLine = util$1.getArg(offset3, "line");
    var offsetColumn = util$1.getArg(offset3, "column");
    if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
      throw new Error("Section offsets must be ordered and non-overlapping.");
    }
    lastOffset = offset3;
    return {
      generatedOffset: {
        generatedLine: offsetLine + 1,
        generatedColumn: offsetColumn + 1
      },
      consumer: new SourceMapConsumer(util$1.getArg(s, "map"), aSourceMapURL)
    };
  });
}
IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
IndexedSourceMapConsumer.prototype._version = 3;
Object.defineProperty(IndexedSourceMapConsumer.prototype, "sources", {
  get: function() {
    var sources = [];
    for (var i = 0; i < this._sections.length; i++) {
      for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
        sources.push(this._sections[i].consumer.sources[j]);
      }
    }
    return sources;
  }
});
IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
  var needle = {
    generatedLine: util$1.getArg(aArgs, "line"),
    generatedColumn: util$1.getArg(aArgs, "column")
  };
  var sectionIndex = binarySearch.search(needle, this._sections, function(needle2, section2) {
    var cmp = needle2.generatedLine - section2.generatedOffset.generatedLine;
    if (cmp) {
      return cmp;
    }
    return needle2.generatedColumn - section2.generatedOffset.generatedColumn;
  });
  var section = this._sections[sectionIndex];
  if (!section) {
    return {
      source: null,
      line: null,
      column: null,
      name: null
    };
  }
  return section.consumer.originalPositionFor({
    line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
    column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
    bias: aArgs.bias
  });
};
IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
  return this._sections.every(function(s) {
    return s.consumer.hasContentsOfAllSources();
  });
};
IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
  for (var i = 0; i < this._sections.length; i++) {
    var section = this._sections[i];
    var content = section.consumer.sourceContentFor(aSource, true);
    if (content) {
      return content;
    }
  }
  if (nullOnMissing) {
    return null;
  } else {
    throw new Error('"' + aSource + '" is not in the SourceMap.');
  }
};
IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
  for (var i = 0; i < this._sections.length; i++) {
    var section = this._sections[i];
    if (section.consumer._findSourceIndex(util$1.getArg(aArgs, "source")) === -1) {
      continue;
    }
    var generatedPosition = section.consumer.generatedPositionFor(aArgs);
    if (generatedPosition) {
      var ret = {
        line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
        column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
      };
      return ret;
    }
  }
  return {
    line: null,
    column: null
  };
};
IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
  this.__generatedMappings = [];
  this.__originalMappings = [];
  for (var i = 0; i < this._sections.length; i++) {
    var section = this._sections[i];
    var sectionMappings = section.consumer._generatedMappings;
    for (var j = 0; j < sectionMappings.length; j++) {
      var mapping = sectionMappings[j];
      var source = section.consumer._sources.at(mapping.source);
      source = util$1.computeSourceURL(section.consumer.sourceRoot, source, this._sourceMapURL);
      this._sources.add(source);
      source = this._sources.indexOf(source);
      var name2 = null;
      if (mapping.name) {
        name2 = section.consumer._names.at(mapping.name);
        this._names.add(name2);
        name2 = this._names.indexOf(name2);
      }
      var adjustedMapping = {
        source,
        generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
        generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
        originalLine: mapping.originalLine,
        originalColumn: mapping.originalColumn,
        name: name2
      };
      this.__generatedMappings.push(adjustedMapping);
      if (typeof adjustedMapping.originalLine === "number") {
        this.__originalMappings.push(adjustedMapping);
      }
    }
  }
  quickSort(this.__generatedMappings, util$1.compareByGeneratedPositionsDeflated);
  quickSort(this.__originalMappings, util$1.compareByOriginalPositions);
};
sourceMapConsumer.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
var sourceNode = {};
var SourceMapGenerator = sourceMapGenerator.SourceMapGenerator;
var util = util$5;
var REGEX_NEWLINE = /(\r?\n)/;
var NEWLINE_CODE = 10;
var isSourceNode = "$$$isSourceNode$$$";
function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
  this.children = [];
  this.sourceContents = {};
  this.line = aLine == null ? null : aLine;
  this.column = aColumn == null ? null : aColumn;
  this.source = aSource == null ? null : aSource;
  this.name = aName == null ? null : aName;
  this[isSourceNode] = true;
  if (aChunks != null)
    this.add(aChunks);
}
SourceNode.fromStringWithSourceMap = function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
  var node = new SourceNode();
  var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
  var remainingLinesIndex = 0;
  var shiftNextLine = function() {
    var lineContents = getNextLine();
    var newLine = getNextLine() || "";
    return lineContents + newLine;
    function getNextLine() {
      return remainingLinesIndex < remainingLines.length ? remainingLines[remainingLinesIndex++] : void 0;
    }
  };
  var lastGeneratedLine = 1, lastGeneratedColumn = 0;
  var lastMapping = null;
  aSourceMapConsumer.eachMapping(function(mapping) {
    if (lastMapping !== null) {
      if (lastGeneratedLine < mapping.generatedLine) {
        addMappingWithCode(lastMapping, shiftNextLine());
        lastGeneratedLine++;
        lastGeneratedColumn = 0;
      } else {
        var nextLine = remainingLines[remainingLinesIndex] || "";
        var code2 = nextLine.substr(0, mapping.generatedColumn - lastGeneratedColumn);
        remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn - lastGeneratedColumn);
        lastGeneratedColumn = mapping.generatedColumn;
        addMappingWithCode(lastMapping, code2);
        lastMapping = mapping;
        return;
      }
    }
    while (lastGeneratedLine < mapping.generatedLine) {
      node.add(shiftNextLine());
      lastGeneratedLine++;
    }
    if (lastGeneratedColumn < mapping.generatedColumn) {
      var nextLine = remainingLines[remainingLinesIndex] || "";
      node.add(nextLine.substr(0, mapping.generatedColumn));
      remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
      lastGeneratedColumn = mapping.generatedColumn;
    }
    lastMapping = mapping;
  }, this);
  if (remainingLinesIndex < remainingLines.length) {
    if (lastMapping) {
      addMappingWithCode(lastMapping, shiftNextLine());
    }
    node.add(remainingLines.splice(remainingLinesIndex).join(""));
  }
  aSourceMapConsumer.sources.forEach(function(sourceFile) {
    var content = aSourceMapConsumer.sourceContentFor(sourceFile);
    if (content != null) {
      if (aRelativePath != null) {
        sourceFile = util.join(aRelativePath, sourceFile);
      }
      node.setSourceContent(sourceFile, content);
    }
  });
  return node;
  function addMappingWithCode(mapping, code2) {
    if (mapping === null || mapping.source === void 0) {
      node.add(code2);
    } else {
      var source = aRelativePath ? util.join(aRelativePath, mapping.source) : mapping.source;
      node.add(new SourceNode(mapping.originalLine, mapping.originalColumn, source, code2, mapping.name));
    }
  }
};
SourceNode.prototype.add = function SourceNode_add(aChunk) {
  if (Array.isArray(aChunk)) {
    aChunk.forEach(function(chunk) {
      this.add(chunk);
    }, this);
  } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
    if (aChunk) {
      this.children.push(aChunk);
    }
  } else {
    throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
  }
  return this;
};
SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
  if (Array.isArray(aChunk)) {
    for (var i = aChunk.length - 1; i >= 0; i--) {
      this.prepend(aChunk[i]);
    }
  } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
    this.children.unshift(aChunk);
  } else {
    throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
  }
  return this;
};
SourceNode.prototype.walk = function SourceNode_walk(aFn) {
  var chunk;
  for (var i = 0, len2 = this.children.length; i < len2; i++) {
    chunk = this.children[i];
    if (chunk[isSourceNode]) {
      chunk.walk(aFn);
    } else {
      if (chunk !== "") {
        aFn(chunk, {
          source: this.source,
          line: this.line,
          column: this.column,
          name: this.name
        });
      }
    }
  }
};
SourceNode.prototype.join = function SourceNode_join(aSep) {
  var newChildren;
  var i;
  var len2 = this.children.length;
  if (len2 > 0) {
    newChildren = [];
    for (i = 0; i < len2 - 1; i++) {
      newChildren.push(this.children[i]);
      newChildren.push(aSep);
    }
    newChildren.push(this.children[i]);
    this.children = newChildren;
  }
  return this;
};
SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
  var lastChild = this.children[this.children.length - 1];
  if (lastChild[isSourceNode]) {
    lastChild.replaceRight(aPattern, aReplacement);
  } else if (typeof lastChild === "string") {
    this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
  } else {
    this.children.push("".replace(aPattern, aReplacement));
  }
  return this;
};
SourceNode.prototype.setSourceContent = function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
  this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
};
SourceNode.prototype.walkSourceContents = function SourceNode_walkSourceContents(aFn) {
  for (var i = 0, len2 = this.children.length; i < len2; i++) {
    if (this.children[i][isSourceNode]) {
      this.children[i].walkSourceContents(aFn);
    }
  }
  var sources = Object.keys(this.sourceContents);
  for (var i = 0, len2 = sources.length; i < len2; i++) {
    aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
  }
};
SourceNode.prototype.toString = function SourceNode_toString() {
  var str = "";
  this.walk(function(chunk) {
    str += chunk;
  });
  return str;
};
SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
  var generated = {
    code: "",
    line: 1,
    column: 0
  };
  var map2 = new SourceMapGenerator(aArgs);
  var sourceMappingActive = false;
  var lastOriginalSource = null;
  var lastOriginalLine = null;
  var lastOriginalColumn = null;
  var lastOriginalName = null;
  this.walk(function(chunk, original) {
    generated.code += chunk;
    if (original.source !== null && original.line !== null && original.column !== null) {
      if (lastOriginalSource !== original.source || lastOriginalLine !== original.line || lastOriginalColumn !== original.column || lastOriginalName !== original.name) {
        map2.addMapping({
          source: original.source,
          original: {
            line: original.line,
            column: original.column
          },
          generated: {
            line: generated.line,
            column: generated.column
          },
          name: original.name
        });
      }
      lastOriginalSource = original.source;
      lastOriginalLine = original.line;
      lastOriginalColumn = original.column;
      lastOriginalName = original.name;
      sourceMappingActive = true;
    } else if (sourceMappingActive) {
      map2.addMapping({
        generated: {
          line: generated.line,
          column: generated.column
        }
      });
      lastOriginalSource = null;
      sourceMappingActive = false;
    }
    for (var idx = 0, length = chunk.length; idx < length; idx++) {
      if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
        generated.line++;
        generated.column = 0;
        if (idx + 1 === length) {
          lastOriginalSource = null;
          sourceMappingActive = false;
        } else if (sourceMappingActive) {
          map2.addMapping({
            source: original.source,
            original: {
              line: original.line,
              column: original.column
            },
            generated: {
              line: generated.line,
              column: generated.column
            },
            name: original.name
          });
        }
      } else {
        generated.column++;
      }
    }
  });
  this.walkSourceContents(function(sourceFile, sourceContent) {
    map2.setSourceContent(sourceFile, sourceContent);
  });
  return { code: generated.code, map: map2 };
};
sourceNode.SourceNode = SourceNode;
sourceMap.SourceMapGenerator = sourceMapGenerator.SourceMapGenerator;
sourceMap.SourceMapConsumer = sourceMapConsumer.SourceMapConsumer;
sourceMap.SourceNode = sourceNode.SourceNode;
const name = "escodegen";
const description = "ECMAScript code generator";
const homepage = "http://github.com/estools/escodegen";
const main$1 = "escodegen.js";
const bin = {
  esgenerate: "./bin/esgenerate.js",
  escodegen: "./bin/escodegen.js"
};
const files = [
  "LICENSE.BSD",
  "README.md",
  "bin",
  "escodegen.js",
  "package.json"
];
const version = "2.0.0";
const engines = {
  node: ">=6.0"
};
const maintainers = [
  {
    name: "Yusuke Suzuki",
    email: "utatane.tea@gmail.com",
    web: "http://github.com/Constellation"
  }
];
const repository = {
  type: "git",
  url: "http://github.com/estools/escodegen.git"
};
const dependencies = {
  estraverse: "^5.2.0",
  esutils: "^2.0.2",
  esprima: "^4.0.1",
  optionator: "^0.8.1"
};
const optionalDependencies = {
  "source-map": "~0.6.1"
};
const devDependencies = {
  acorn: "^7.3.1",
  bluebird: "^3.4.7",
  "bower-registry-client": "^1.0.0",
  chai: "^4.2.0",
  "chai-exclude": "^2.0.2",
  "commonjs-everywhere": "^0.9.7",
  gulp: "^3.8.10",
  "gulp-eslint": "^3.0.1",
  "gulp-mocha": "^3.0.1",
  semver: "^5.1.0"
};
const license = "BSD-2-Clause";
const scripts = {
  test: "gulp travis",
  "unit-test": "gulp test",
  lint: "gulp lint",
  release: "node tools/release.js",
  "build-min": "./node_modules/.bin/cjsify -ma path: tools/entry-point.js > escodegen.browser.min.js",
  build: "./node_modules/.bin/cjsify -a path: tools/entry-point.js > escodegen.browser.js"
};
var require$$3 = {
  name,
  description,
  homepage,
  main: main$1,
  bin,
  files,
  version,
  engines,
  maintainers,
  repository,
  dependencies,
  optionalDependencies,
  devDependencies,
  license,
  scripts
};
(function(exports) {
  (function() {
    var Syntax, Precedence, BinaryPrecedence, SourceNode2, estraverse$1, esutils, base2, indent, json, renumber, hexadecimal, quotes, escapeless, newline, space, parentheses, semicolons, safeConcatenation, directive, extra, parse4, sourceMap$1, sourceCode, preserveBlankLines, FORMAT_MINIFY, FORMAT_DEFAULTS;
    estraverse$1 = estraverse;
    esutils = utils$1;
    Syntax = estraverse$1.Syntax;
    function isExpression(node) {
      return CodeGenerator.Expression.hasOwnProperty(node.type);
    }
    function isStatement(node) {
      return CodeGenerator.Statement.hasOwnProperty(node.type);
    }
    Precedence = {
      Sequence: 0,
      Yield: 1,
      Assignment: 1,
      Conditional: 2,
      ArrowFunction: 2,
      LogicalOR: 3,
      LogicalAND: 4,
      BitwiseOR: 5,
      BitwiseXOR: 6,
      BitwiseAND: 7,
      Equality: 8,
      Relational: 9,
      BitwiseSHIFT: 10,
      Additive: 11,
      Multiplicative: 12,
      Exponentiation: 13,
      Await: 14,
      Unary: 14,
      Postfix: 15,
      OptionalChaining: 16,
      Call: 17,
      New: 18,
      TaggedTemplate: 19,
      Member: 20,
      Primary: 21
    };
    BinaryPrecedence = {
      "||": Precedence.LogicalOR,
      "&&": Precedence.LogicalAND,
      "|": Precedence.BitwiseOR,
      "^": Precedence.BitwiseXOR,
      "&": Precedence.BitwiseAND,
      "==": Precedence.Equality,
      "!=": Precedence.Equality,
      "===": Precedence.Equality,
      "!==": Precedence.Equality,
      "is": Precedence.Equality,
      "isnt": Precedence.Equality,
      "<": Precedence.Relational,
      ">": Precedence.Relational,
      "<=": Precedence.Relational,
      ">=": Precedence.Relational,
      "in": Precedence.Relational,
      "instanceof": Precedence.Relational,
      "<<": Precedence.BitwiseSHIFT,
      ">>": Precedence.BitwiseSHIFT,
      ">>>": Precedence.BitwiseSHIFT,
      "+": Precedence.Additive,
      "-": Precedence.Additive,
      "*": Precedence.Multiplicative,
      "%": Precedence.Multiplicative,
      "/": Precedence.Multiplicative,
      "**": Precedence.Exponentiation
    };
    var F_ALLOW_IN = 1, F_ALLOW_CALL = 1 << 1, F_ALLOW_UNPARATH_NEW = 1 << 2, F_FUNC_BODY = 1 << 3, F_DIRECTIVE_CTX = 1 << 4, F_SEMICOLON_OPT = 1 << 5;
    var E_FTT = F_ALLOW_CALL | F_ALLOW_UNPARATH_NEW, E_TTF = F_ALLOW_IN | F_ALLOW_CALL, E_TTT = F_ALLOW_IN | F_ALLOW_CALL | F_ALLOW_UNPARATH_NEW, E_TFF = F_ALLOW_IN, E_FFT = F_ALLOW_UNPARATH_NEW, E_TFT = F_ALLOW_IN | F_ALLOW_UNPARATH_NEW;
    var S_TFFF = F_ALLOW_IN, S_TFFT = F_ALLOW_IN | F_SEMICOLON_OPT, S_FFFF = 0, S_TFTF = F_ALLOW_IN | F_DIRECTIVE_CTX, S_TTFF = F_ALLOW_IN | F_FUNC_BODY;
    function getDefaultOptions() {
      return {
        indent: null,
        base: null,
        parse: null,
        comment: false,
        format: {
          indent: {
            style: "    ",
            base: 0,
            adjustMultilineComment: false
          },
          newline: "\n",
          space: " ",
          json: false,
          renumber: false,
          hexadecimal: false,
          quotes: "single",
          escapeless: false,
          compact: false,
          parentheses: true,
          semicolons: true,
          safeConcatenation: false,
          preserveBlankLines: false
        },
        moz: {
          comprehensionExpressionStartsWithAssignment: false,
          starlessGenerator: false
        },
        sourceMap: null,
        sourceMapRoot: null,
        sourceMapWithCode: false,
        directive: false,
        raw: true,
        verbatim: null,
        sourceCode: null
      };
    }
    function stringRepeat(str, num) {
      var result = "";
      for (num |= 0; num > 0; num >>>= 1, str += str) {
        if (num & 1) {
          result += str;
        }
      }
      return result;
    }
    function hasLineTerminator(str) {
      return /[\r\n]/g.test(str);
    }
    function endsWithLineTerminator(str) {
      var len2 = str.length;
      return len2 && esutils.code.isLineTerminator(str.charCodeAt(len2 - 1));
    }
    function merge3(target, override) {
      var key;
      for (key in override) {
        if (override.hasOwnProperty(key)) {
          target[key] = override[key];
        }
      }
      return target;
    }
    function updateDeeply(target, override) {
      var key, val;
      function isHashObject(target2) {
        return typeof target2 === "object" && target2 instanceof Object && !(target2 instanceof RegExp);
      }
      for (key in override) {
        if (override.hasOwnProperty(key)) {
          val = override[key];
          if (isHashObject(val)) {
            if (isHashObject(target[key])) {
              updateDeeply(target[key], val);
            } else {
              target[key] = updateDeeply({}, val);
            }
          } else {
            target[key] = val;
          }
        }
      }
      return target;
    }
    function generateNumber(value) {
      var result, point, temp, exponent, pos;
      if (value !== value) {
        throw new Error("Numeric literal whose value is NaN");
      }
      if (value < 0 || value === 0 && 1 / value < 0) {
        throw new Error("Numeric literal whose value is negative");
      }
      if (value === 1 / 0) {
        return json ? "null" : renumber ? "1e400" : "1e+400";
      }
      result = "" + value;
      if (!renumber || result.length < 3) {
        return result;
      }
      point = result.indexOf(".");
      if (!json && result.charCodeAt(0) === 48 && point === 1) {
        point = 0;
        result = result.slice(1);
      }
      temp = result;
      result = result.replace("e+", "e");
      exponent = 0;
      if ((pos = temp.indexOf("e")) > 0) {
        exponent = +temp.slice(pos + 1);
        temp = temp.slice(0, pos);
      }
      if (point >= 0) {
        exponent -= temp.length - point - 1;
        temp = +(temp.slice(0, point) + temp.slice(point + 1)) + "";
      }
      pos = 0;
      while (temp.charCodeAt(temp.length + pos - 1) === 48) {
        --pos;
      }
      if (pos !== 0) {
        exponent -= pos;
        temp = temp.slice(0, pos);
      }
      if (exponent !== 0) {
        temp += "e" + exponent;
      }
      if ((temp.length < result.length || hexadecimal && value > 1e12 && Math.floor(value) === value && (temp = "0x" + value.toString(16)).length < result.length) && +temp === value) {
        result = temp;
      }
      return result;
    }
    function escapeRegExpCharacter(ch2, previousIsBackslash) {
      if ((ch2 & ~1) === 8232) {
        return (previousIsBackslash ? "u" : "\\u") + (ch2 === 8232 ? "2028" : "2029");
      } else if (ch2 === 10 || ch2 === 13) {
        return (previousIsBackslash ? "" : "\\") + (ch2 === 10 ? "n" : "r");
      }
      return String.fromCharCode(ch2);
    }
    function generateRegExp(reg) {
      var match, result, flags, i, iz, ch2, characterInBrack, previousIsBackslash;
      result = reg.toString();
      if (reg.source) {
        match = result.match(/\/([^/]*)$/);
        if (!match) {
          return result;
        }
        flags = match[1];
        result = "";
        characterInBrack = false;
        previousIsBackslash = false;
        for (i = 0, iz = reg.source.length; i < iz; ++i) {
          ch2 = reg.source.charCodeAt(i);
          if (!previousIsBackslash) {
            if (characterInBrack) {
              if (ch2 === 93) {
                characterInBrack = false;
              }
            } else {
              if (ch2 === 47) {
                result += "\\";
              } else if (ch2 === 91) {
                characterInBrack = true;
              }
            }
            result += escapeRegExpCharacter(ch2, previousIsBackslash);
            previousIsBackslash = ch2 === 92;
          } else {
            result += escapeRegExpCharacter(ch2, previousIsBackslash);
            previousIsBackslash = false;
          }
        }
        return "/" + result + "/" + flags;
      }
      return result;
    }
    function escapeAllowedCharacter(code2, next) {
      var hex2;
      if (code2 === 8) {
        return "\\b";
      }
      if (code2 === 12) {
        return "\\f";
      }
      if (code2 === 9) {
        return "\\t";
      }
      hex2 = code2.toString(16).toUpperCase();
      if (json || code2 > 255) {
        return "\\u" + "0000".slice(hex2.length) + hex2;
      } else if (code2 === 0 && !esutils.code.isDecimalDigit(next)) {
        return "\\0";
      } else if (code2 === 11) {
        return "\\x0B";
      } else {
        return "\\x" + "00".slice(hex2.length) + hex2;
      }
    }
    function escapeDisallowedCharacter(code2) {
      if (code2 === 92) {
        return "\\\\";
      }
      if (code2 === 10) {
        return "\\n";
      }
      if (code2 === 13) {
        return "\\r";
      }
      if (code2 === 8232) {
        return "\\u2028";
      }
      if (code2 === 8233) {
        return "\\u2029";
      }
      throw new Error("Incorrectly classified character");
    }
    function escapeDirective(str) {
      var i, iz, code2, quote;
      quote = quotes === "double" ? '"' : "'";
      for (i = 0, iz = str.length; i < iz; ++i) {
        code2 = str.charCodeAt(i);
        if (code2 === 39) {
          quote = '"';
          break;
        } else if (code2 === 34) {
          quote = "'";
          break;
        } else if (code2 === 92) {
          ++i;
        }
      }
      return quote + str + quote;
    }
    function escapeString(str) {
      var result = "", i, len2, code2, singleQuotes = 0, doubleQuotes = 0, single, quote;
      for (i = 0, len2 = str.length; i < len2; ++i) {
        code2 = str.charCodeAt(i);
        if (code2 === 39) {
          ++singleQuotes;
        } else if (code2 === 34) {
          ++doubleQuotes;
        } else if (code2 === 47 && json) {
          result += "\\";
        } else if (esutils.code.isLineTerminator(code2) || code2 === 92) {
          result += escapeDisallowedCharacter(code2);
          continue;
        } else if (!esutils.code.isIdentifierPartES5(code2) && (json && code2 < 32 || !json && !escapeless && (code2 < 32 || code2 > 126))) {
          result += escapeAllowedCharacter(code2, str.charCodeAt(i + 1));
          continue;
        }
        result += String.fromCharCode(code2);
      }
      single = !(quotes === "double" || quotes === "auto" && doubleQuotes < singleQuotes);
      quote = single ? "'" : '"';
      if (!(single ? singleQuotes : doubleQuotes)) {
        return quote + result + quote;
      }
      str = result;
      result = quote;
      for (i = 0, len2 = str.length; i < len2; ++i) {
        code2 = str.charCodeAt(i);
        if (code2 === 39 && single || code2 === 34 && !single) {
          result += "\\";
        }
        result += String.fromCharCode(code2);
      }
      return result + quote;
    }
    function flattenToString(arr) {
      var i, iz, elem, result = "";
      for (i = 0, iz = arr.length; i < iz; ++i) {
        elem = arr[i];
        result += Array.isArray(elem) ? flattenToString(elem) : elem;
      }
      return result;
    }
    function toSourceNodeWhenNeeded(generated, node) {
      if (!sourceMap$1) {
        if (Array.isArray(generated)) {
          return flattenToString(generated);
        } else {
          return generated;
        }
      }
      if (node == null) {
        if (generated instanceof SourceNode2) {
          return generated;
        } else {
          node = {};
        }
      }
      if (node.loc == null) {
        return new SourceNode2(null, null, sourceMap$1, generated, node.name || null);
      }
      return new SourceNode2(node.loc.start.line, node.loc.start.column, sourceMap$1 === true ? node.loc.source || null : sourceMap$1, generated, node.name || null);
    }
    function noEmptySpace() {
      return space ? space : " ";
    }
    function join(left, right) {
      var leftSource, rightSource, leftCharCode, rightCharCode;
      leftSource = toSourceNodeWhenNeeded(left).toString();
      if (leftSource.length === 0) {
        return [right];
      }
      rightSource = toSourceNodeWhenNeeded(right).toString();
      if (rightSource.length === 0) {
        return [left];
      }
      leftCharCode = leftSource.charCodeAt(leftSource.length - 1);
      rightCharCode = rightSource.charCodeAt(0);
      if ((leftCharCode === 43 || leftCharCode === 45) && leftCharCode === rightCharCode || esutils.code.isIdentifierPartES5(leftCharCode) && esutils.code.isIdentifierPartES5(rightCharCode) || leftCharCode === 47 && rightCharCode === 105) {
        return [left, noEmptySpace(), right];
      } else if (esutils.code.isWhiteSpace(leftCharCode) || esutils.code.isLineTerminator(leftCharCode) || esutils.code.isWhiteSpace(rightCharCode) || esutils.code.isLineTerminator(rightCharCode)) {
        return [left, right];
      }
      return [left, space, right];
    }
    function addIndent(stmt) {
      return [base2, stmt];
    }
    function withIndent(fn) {
      var previousBase;
      previousBase = base2;
      base2 += indent;
      fn(base2);
      base2 = previousBase;
    }
    function calculateSpaces(str) {
      var i;
      for (i = str.length - 1; i >= 0; --i) {
        if (esutils.code.isLineTerminator(str.charCodeAt(i))) {
          break;
        }
      }
      return str.length - 1 - i;
    }
    function adjustMultilineComment(value, specialBase) {
      var array4, i, len2, line, j, spaces, previousBase, sn;
      array4 = value.split(/\r\n|[\r\n]/);
      spaces = Number.MAX_VALUE;
      for (i = 1, len2 = array4.length; i < len2; ++i) {
        line = array4[i];
        j = 0;
        while (j < line.length && esutils.code.isWhiteSpace(line.charCodeAt(j))) {
          ++j;
        }
        if (spaces > j) {
          spaces = j;
        }
      }
      if (typeof specialBase !== "undefined") {
        previousBase = base2;
        if (array4[1][spaces] === "*") {
          specialBase += " ";
        }
        base2 = specialBase;
      } else {
        if (spaces & 1) {
          --spaces;
        }
        previousBase = base2;
      }
      for (i = 1, len2 = array4.length; i < len2; ++i) {
        sn = toSourceNodeWhenNeeded(addIndent(array4[i].slice(spaces)));
        array4[i] = sourceMap$1 ? sn.join("") : sn;
      }
      base2 = previousBase;
      return array4.join("\n");
    }
    function generateComment(comment, specialBase) {
      if (comment.type === "Line") {
        if (endsWithLineTerminator(comment.value)) {
          return "//" + comment.value;
        } else {
          var result = "//" + comment.value;
          if (!preserveBlankLines) {
            result += "\n";
          }
          return result;
        }
      }
      if (extra.format.indent.adjustMultilineComment && /[\n\r]/.test(comment.value)) {
        return adjustMultilineComment("/*" + comment.value + "*/", specialBase);
      }
      return "/*" + comment.value + "*/";
    }
    function addComments(stmt, result) {
      var i, len2, comment, save, tailingToStatement, specialBase, fragment, extRange, range3, prevRange, prefix, infix, suffix, count2;
      if (stmt.leadingComments && stmt.leadingComments.length > 0) {
        save = result;
        if (preserveBlankLines) {
          comment = stmt.leadingComments[0];
          result = [];
          extRange = comment.extendedRange;
          range3 = comment.range;
          prefix = sourceCode.substring(extRange[0], range3[0]);
          count2 = (prefix.match(/\n/g) || []).length;
          if (count2 > 0) {
            result.push(stringRepeat("\n", count2));
            result.push(addIndent(generateComment(comment)));
          } else {
            result.push(prefix);
            result.push(generateComment(comment));
          }
          prevRange = range3;
          for (i = 1, len2 = stmt.leadingComments.length; i < len2; i++) {
            comment = stmt.leadingComments[i];
            range3 = comment.range;
            infix = sourceCode.substring(prevRange[1], range3[0]);
            count2 = (infix.match(/\n/g) || []).length;
            result.push(stringRepeat("\n", count2));
            result.push(addIndent(generateComment(comment)));
            prevRange = range3;
          }
          suffix = sourceCode.substring(range3[1], extRange[1]);
          count2 = (suffix.match(/\n/g) || []).length;
          result.push(stringRepeat("\n", count2));
        } else {
          comment = stmt.leadingComments[0];
          result = [];
          if (safeConcatenation && stmt.type === Syntax.Program && stmt.body.length === 0) {
            result.push("\n");
          }
          result.push(generateComment(comment));
          if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
            result.push("\n");
          }
          for (i = 1, len2 = stmt.leadingComments.length; i < len2; ++i) {
            comment = stmt.leadingComments[i];
            fragment = [generateComment(comment)];
            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
              fragment.push("\n");
            }
            result.push(addIndent(fragment));
          }
        }
        result.push(addIndent(save));
      }
      if (stmt.trailingComments) {
        if (preserveBlankLines) {
          comment = stmt.trailingComments[0];
          extRange = comment.extendedRange;
          range3 = comment.range;
          prefix = sourceCode.substring(extRange[0], range3[0]);
          count2 = (prefix.match(/\n/g) || []).length;
          if (count2 > 0) {
            result.push(stringRepeat("\n", count2));
            result.push(addIndent(generateComment(comment)));
          } else {
            result.push(prefix);
            result.push(generateComment(comment));
          }
        } else {
          tailingToStatement = !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());
          specialBase = stringRepeat(" ", calculateSpaces(toSourceNodeWhenNeeded([base2, result, indent]).toString()));
          for (i = 0, len2 = stmt.trailingComments.length; i < len2; ++i) {
            comment = stmt.trailingComments[i];
            if (tailingToStatement) {
              if (i === 0) {
                result = [result, indent];
              } else {
                result = [result, specialBase];
              }
              result.push(generateComment(comment, specialBase));
            } else {
              result = [result, addIndent(generateComment(comment))];
            }
            if (i !== len2 - 1 && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
              result = [result, "\n"];
            }
          }
        }
      }
      return result;
    }
    function generateBlankLines(start2, end2, result) {
      var j, newlineCount = 0;
      for (j = start2; j < end2; j++) {
        if (sourceCode[j] === "\n") {
          newlineCount++;
        }
      }
      for (j = 1; j < newlineCount; j++) {
        result.push(newline);
      }
    }
    function parenthesize(text, current2, should) {
      if (current2 < should) {
        return ["(", text, ")"];
      }
      return text;
    }
    function generateVerbatimString(string3) {
      var i, iz, result;
      result = string3.split(/\r\n|\n/);
      for (i = 1, iz = result.length; i < iz; i++) {
        result[i] = newline + base2 + result[i];
      }
      return result;
    }
    function generateVerbatim(expr, precedence) {
      var verbatim, result, prec;
      verbatim = expr[extra.verbatim];
      if (typeof verbatim === "string") {
        result = parenthesize(generateVerbatimString(verbatim), Precedence.Sequence, precedence);
      } else {
        result = generateVerbatimString(verbatim.content);
        prec = verbatim.precedence != null ? verbatim.precedence : Precedence.Sequence;
        result = parenthesize(result, prec, precedence);
      }
      return toSourceNodeWhenNeeded(result, expr);
    }
    function CodeGenerator() {
    }
    CodeGenerator.prototype.maybeBlock = function(stmt, flags) {
      var result, noLeadingComment, that = this;
      noLeadingComment = !extra.comment || !stmt.leadingComments;
      if (stmt.type === Syntax.BlockStatement && noLeadingComment) {
        return [space, this.generateStatement(stmt, flags)];
      }
      if (stmt.type === Syntax.EmptyStatement && noLeadingComment) {
        return ";";
      }
      withIndent(function() {
        result = [
          newline,
          addIndent(that.generateStatement(stmt, flags))
        ];
      });
      return result;
    };
    CodeGenerator.prototype.maybeBlockSuffix = function(stmt, result) {
      var ends = endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());
      if (stmt.type === Syntax.BlockStatement && (!extra.comment || !stmt.leadingComments) && !ends) {
        return [result, space];
      }
      if (ends) {
        return [result, base2];
      }
      return [result, newline, base2];
    };
    function generateIdentifier(node) {
      return toSourceNodeWhenNeeded(node.name, node);
    }
    function generateAsyncPrefix(node, spaceRequired) {
      return node.async ? "async" + (spaceRequired ? noEmptySpace() : space) : "";
    }
    function generateStarSuffix(node) {
      var isGenerator = node.generator && !extra.moz.starlessGenerator;
      return isGenerator ? "*" + space : "";
    }
    function generateMethodPrefix(prop) {
      var func = prop.value, prefix = "";
      if (func.async) {
        prefix += generateAsyncPrefix(func, !prop.computed);
      }
      if (func.generator) {
        prefix += generateStarSuffix(func) ? "*" : "";
      }
      return prefix;
    }
    CodeGenerator.prototype.generatePattern = function(node, precedence, flags) {
      if (node.type === Syntax.Identifier) {
        return generateIdentifier(node);
      }
      return this.generateExpression(node, precedence, flags);
    };
    CodeGenerator.prototype.generateFunctionParams = function(node) {
      var i, iz, result, hasDefault;
      hasDefault = false;
      if (node.type === Syntax.ArrowFunctionExpression && !node.rest && (!node.defaults || node.defaults.length === 0) && node.params.length === 1 && node.params[0].type === Syntax.Identifier) {
        result = [generateAsyncPrefix(node, true), generateIdentifier(node.params[0])];
      } else {
        result = node.type === Syntax.ArrowFunctionExpression ? [generateAsyncPrefix(node, false)] : [];
        result.push("(");
        if (node.defaults) {
          hasDefault = true;
        }
        for (i = 0, iz = node.params.length; i < iz; ++i) {
          if (hasDefault && node.defaults[i]) {
            result.push(this.generateAssignment(node.params[i], node.defaults[i], "=", Precedence.Assignment, E_TTT));
          } else {
            result.push(this.generatePattern(node.params[i], Precedence.Assignment, E_TTT));
          }
          if (i + 1 < iz) {
            result.push("," + space);
          }
        }
        if (node.rest) {
          if (node.params.length) {
            result.push("," + space);
          }
          result.push("...");
          result.push(generateIdentifier(node.rest));
        }
        result.push(")");
      }
      return result;
    };
    CodeGenerator.prototype.generateFunctionBody = function(node) {
      var result, expr;
      result = this.generateFunctionParams(node);
      if (node.type === Syntax.ArrowFunctionExpression) {
        result.push(space);
        result.push("=>");
      }
      if (node.expression) {
        result.push(space);
        expr = this.generateExpression(node.body, Precedence.Assignment, E_TTT);
        if (expr.toString().charAt(0) === "{") {
          expr = ["(", expr, ")"];
        }
        result.push(expr);
      } else {
        result.push(this.maybeBlock(node.body, S_TTFF));
      }
      return result;
    };
    CodeGenerator.prototype.generateIterationForStatement = function(operator, stmt, flags) {
      var result = ["for" + (stmt.await ? noEmptySpace() + "await" : "") + space + "("], that = this;
      withIndent(function() {
        if (stmt.left.type === Syntax.VariableDeclaration) {
          withIndent(function() {
            result.push(stmt.left.kind + noEmptySpace());
            result.push(that.generateStatement(stmt.left.declarations[0], S_FFFF));
          });
        } else {
          result.push(that.generateExpression(stmt.left, Precedence.Call, E_TTT));
        }
        result = join(result, operator);
        result = [join(result, that.generateExpression(stmt.right, Precedence.Assignment, E_TTT)), ")"];
      });
      result.push(this.maybeBlock(stmt.body, flags));
      return result;
    };
    CodeGenerator.prototype.generatePropertyKey = function(expr, computed) {
      var result = [];
      if (computed) {
        result.push("[");
      }
      result.push(this.generateExpression(expr, Precedence.Assignment, E_TTT));
      if (computed) {
        result.push("]");
      }
      return result;
    };
    CodeGenerator.prototype.generateAssignment = function(left, right, operator, precedence, flags) {
      if (Precedence.Assignment < precedence) {
        flags |= F_ALLOW_IN;
      }
      return parenthesize([
        this.generateExpression(left, Precedence.Call, flags),
        space + operator + space,
        this.generateExpression(right, Precedence.Assignment, flags)
      ], Precedence.Assignment, precedence);
    };
    CodeGenerator.prototype.semicolon = function(flags) {
      if (!semicolons && flags & F_SEMICOLON_OPT) {
        return "";
      }
      return ";";
    };
    CodeGenerator.Statement = {
      BlockStatement: function(stmt, flags) {
        var range3, content, result = ["{", newline], that = this;
        withIndent(function() {
          if (stmt.body.length === 0 && preserveBlankLines) {
            range3 = stmt.range;
            if (range3[1] - range3[0] > 2) {
              content = sourceCode.substring(range3[0] + 1, range3[1] - 1);
              if (content[0] === "\n") {
                result = ["{"];
              }
              result.push(content);
            }
          }
          var i, iz, fragment, bodyFlags;
          bodyFlags = S_TFFF;
          if (flags & F_FUNC_BODY) {
            bodyFlags |= F_DIRECTIVE_CTX;
          }
          for (i = 0, iz = stmt.body.length; i < iz; ++i) {
            if (preserveBlankLines) {
              if (i === 0) {
                if (stmt.body[0].leadingComments) {
                  range3 = stmt.body[0].leadingComments[0].extendedRange;
                  content = sourceCode.substring(range3[0], range3[1]);
                  if (content[0] === "\n") {
                    result = ["{"];
                  }
                }
                if (!stmt.body[0].leadingComments) {
                  generateBlankLines(stmt.range[0], stmt.body[0].range[0], result);
                }
              }
              if (i > 0) {
                if (!stmt.body[i - 1].trailingComments && !stmt.body[i].leadingComments) {
                  generateBlankLines(stmt.body[i - 1].range[1], stmt.body[i].range[0], result);
                }
              }
            }
            if (i === iz - 1) {
              bodyFlags |= F_SEMICOLON_OPT;
            }
            if (stmt.body[i].leadingComments && preserveBlankLines) {
              fragment = that.generateStatement(stmt.body[i], bodyFlags);
            } else {
              fragment = addIndent(that.generateStatement(stmt.body[i], bodyFlags));
            }
            result.push(fragment);
            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
              if (preserveBlankLines && i < iz - 1) {
                if (!stmt.body[i + 1].leadingComments) {
                  result.push(newline);
                }
              } else {
                result.push(newline);
              }
            }
            if (preserveBlankLines) {
              if (i === iz - 1) {
                if (!stmt.body[i].trailingComments) {
                  generateBlankLines(stmt.body[i].range[1], stmt.range[1], result);
                }
              }
            }
          }
        });
        result.push(addIndent("}"));
        return result;
      },
      BreakStatement: function(stmt, flags) {
        if (stmt.label) {
          return "break " + stmt.label.name + this.semicolon(flags);
        }
        return "break" + this.semicolon(flags);
      },
      ContinueStatement: function(stmt, flags) {
        if (stmt.label) {
          return "continue " + stmt.label.name + this.semicolon(flags);
        }
        return "continue" + this.semicolon(flags);
      },
      ClassBody: function(stmt, flags) {
        var result = ["{", newline], that = this;
        withIndent(function(indent2) {
          var i, iz;
          for (i = 0, iz = stmt.body.length; i < iz; ++i) {
            result.push(indent2);
            result.push(that.generateExpression(stmt.body[i], Precedence.Sequence, E_TTT));
            if (i + 1 < iz) {
              result.push(newline);
            }
          }
        });
        if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
          result.push(newline);
        }
        result.push(base2);
        result.push("}");
        return result;
      },
      ClassDeclaration: function(stmt, flags) {
        var result, fragment;
        result = ["class"];
        if (stmt.id) {
          result = join(result, this.generateExpression(stmt.id, Precedence.Sequence, E_TTT));
        }
        if (stmt.superClass) {
          fragment = join("extends", this.generateExpression(stmt.superClass, Precedence.Unary, E_TTT));
          result = join(result, fragment);
        }
        result.push(space);
        result.push(this.generateStatement(stmt.body, S_TFFT));
        return result;
      },
      DirectiveStatement: function(stmt, flags) {
        if (extra.raw && stmt.raw) {
          return stmt.raw + this.semicolon(flags);
        }
        return escapeDirective(stmt.directive) + this.semicolon(flags);
      },
      DoWhileStatement: function(stmt, flags) {
        var result = join("do", this.maybeBlock(stmt.body, S_TFFF));
        result = this.maybeBlockSuffix(stmt.body, result);
        return join(result, [
          "while" + space + "(",
          this.generateExpression(stmt.test, Precedence.Sequence, E_TTT),
          ")" + this.semicolon(flags)
        ]);
      },
      CatchClause: function(stmt, flags) {
        var result, that = this;
        withIndent(function() {
          var guard;
          if (stmt.param) {
            result = [
              "catch" + space + "(",
              that.generateExpression(stmt.param, Precedence.Sequence, E_TTT),
              ")"
            ];
            if (stmt.guard) {
              guard = that.generateExpression(stmt.guard, Precedence.Sequence, E_TTT);
              result.splice(2, 0, " if ", guard);
            }
          } else {
            result = ["catch"];
          }
        });
        result.push(this.maybeBlock(stmt.body, S_TFFF));
        return result;
      },
      DebuggerStatement: function(stmt, flags) {
        return "debugger" + this.semicolon(flags);
      },
      EmptyStatement: function(stmt, flags) {
        return ";";
      },
      ExportDefaultDeclaration: function(stmt, flags) {
        var result = ["export"], bodyFlags;
        bodyFlags = flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF;
        result = join(result, "default");
        if (isStatement(stmt.declaration)) {
          result = join(result, this.generateStatement(stmt.declaration, bodyFlags));
        } else {
          result = join(result, this.generateExpression(stmt.declaration, Precedence.Assignment, E_TTT) + this.semicolon(flags));
        }
        return result;
      },
      ExportNamedDeclaration: function(stmt, flags) {
        var result = ["export"], bodyFlags, that = this;
        bodyFlags = flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF;
        if (stmt.declaration) {
          return join(result, this.generateStatement(stmt.declaration, bodyFlags));
        }
        if (stmt.specifiers) {
          if (stmt.specifiers.length === 0) {
            result = join(result, "{" + space + "}");
          } else if (stmt.specifiers[0].type === Syntax.ExportBatchSpecifier) {
            result = join(result, this.generateExpression(stmt.specifiers[0], Precedence.Sequence, E_TTT));
          } else {
            result = join(result, "{");
            withIndent(function(indent2) {
              var i, iz;
              result.push(newline);
              for (i = 0, iz = stmt.specifiers.length; i < iz; ++i) {
                result.push(indent2);
                result.push(that.generateExpression(stmt.specifiers[i], Precedence.Sequence, E_TTT));
                if (i + 1 < iz) {
                  result.push("," + newline);
                }
              }
            });
            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
              result.push(newline);
            }
            result.push(base2 + "}");
          }
          if (stmt.source) {
            result = join(result, [
              "from" + space,
              this.generateExpression(stmt.source, Precedence.Sequence, E_TTT),
              this.semicolon(flags)
            ]);
          } else {
            result.push(this.semicolon(flags));
          }
        }
        return result;
      },
      ExportAllDeclaration: function(stmt, flags) {
        return [
          "export" + space,
          "*" + space,
          "from" + space,
          this.generateExpression(stmt.source, Precedence.Sequence, E_TTT),
          this.semicolon(flags)
        ];
      },
      ExpressionStatement: function(stmt, flags) {
        var result, fragment;
        function isClassPrefixed(fragment2) {
          var code2;
          if (fragment2.slice(0, 5) !== "class") {
            return false;
          }
          code2 = fragment2.charCodeAt(5);
          return code2 === 123 || esutils.code.isWhiteSpace(code2) || esutils.code.isLineTerminator(code2);
        }
        function isFunctionPrefixed(fragment2) {
          var code2;
          if (fragment2.slice(0, 8) !== "function") {
            return false;
          }
          code2 = fragment2.charCodeAt(8);
          return code2 === 40 || esutils.code.isWhiteSpace(code2) || code2 === 42 || esutils.code.isLineTerminator(code2);
        }
        function isAsyncPrefixed(fragment2) {
          var code2, i, iz;
          if (fragment2.slice(0, 5) !== "async") {
            return false;
          }
          if (!esutils.code.isWhiteSpace(fragment2.charCodeAt(5))) {
            return false;
          }
          for (i = 6, iz = fragment2.length; i < iz; ++i) {
            if (!esutils.code.isWhiteSpace(fragment2.charCodeAt(i))) {
              break;
            }
          }
          if (i === iz) {
            return false;
          }
          if (fragment2.slice(i, i + 8) !== "function") {
            return false;
          }
          code2 = fragment2.charCodeAt(i + 8);
          return code2 === 40 || esutils.code.isWhiteSpace(code2) || code2 === 42 || esutils.code.isLineTerminator(code2);
        }
        result = [this.generateExpression(stmt.expression, Precedence.Sequence, E_TTT)];
        fragment = toSourceNodeWhenNeeded(result).toString();
        if (fragment.charCodeAt(0) === 123 || isClassPrefixed(fragment) || isFunctionPrefixed(fragment) || isAsyncPrefixed(fragment) || directive && flags & F_DIRECTIVE_CTX && stmt.expression.type === Syntax.Literal && typeof stmt.expression.value === "string") {
          result = ["(", result, ")" + this.semicolon(flags)];
        } else {
          result.push(this.semicolon(flags));
        }
        return result;
      },
      ImportDeclaration: function(stmt, flags) {
        var result, cursor, that = this;
        if (stmt.specifiers.length === 0) {
          return [
            "import",
            space,
            this.generateExpression(stmt.source, Precedence.Sequence, E_TTT),
            this.semicolon(flags)
          ];
        }
        result = [
          "import"
        ];
        cursor = 0;
        if (stmt.specifiers[cursor].type === Syntax.ImportDefaultSpecifier) {
          result = join(result, [
            this.generateExpression(stmt.specifiers[cursor], Precedence.Sequence, E_TTT)
          ]);
          ++cursor;
        }
        if (stmt.specifiers[cursor]) {
          if (cursor !== 0) {
            result.push(",");
          }
          if (stmt.specifiers[cursor].type === Syntax.ImportNamespaceSpecifier) {
            result = join(result, [
              space,
              this.generateExpression(stmt.specifiers[cursor], Precedence.Sequence, E_TTT)
            ]);
          } else {
            result.push(space + "{");
            if (stmt.specifiers.length - cursor === 1) {
              result.push(space);
              result.push(this.generateExpression(stmt.specifiers[cursor], Precedence.Sequence, E_TTT));
              result.push(space + "}" + space);
            } else {
              withIndent(function(indent2) {
                var i, iz;
                result.push(newline);
                for (i = cursor, iz = stmt.specifiers.length; i < iz; ++i) {
                  result.push(indent2);
                  result.push(that.generateExpression(stmt.specifiers[i], Precedence.Sequence, E_TTT));
                  if (i + 1 < iz) {
                    result.push("," + newline);
                  }
                }
              });
              if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                result.push(newline);
              }
              result.push(base2 + "}" + space);
            }
          }
        }
        result = join(result, [
          "from" + space,
          this.generateExpression(stmt.source, Precedence.Sequence, E_TTT),
          this.semicolon(flags)
        ]);
        return result;
      },
      VariableDeclarator: function(stmt, flags) {
        var itemFlags = flags & F_ALLOW_IN ? E_TTT : E_FTT;
        if (stmt.init) {
          return [
            this.generateExpression(stmt.id, Precedence.Assignment, itemFlags),
            space,
            "=",
            space,
            this.generateExpression(stmt.init, Precedence.Assignment, itemFlags)
          ];
        }
        return this.generatePattern(stmt.id, Precedence.Assignment, itemFlags);
      },
      VariableDeclaration: function(stmt, flags) {
        var result, i, iz, node, bodyFlags, that = this;
        result = [stmt.kind];
        bodyFlags = flags & F_ALLOW_IN ? S_TFFF : S_FFFF;
        function block() {
          node = stmt.declarations[0];
          if (extra.comment && node.leadingComments) {
            result.push("\n");
            result.push(addIndent(that.generateStatement(node, bodyFlags)));
          } else {
            result.push(noEmptySpace());
            result.push(that.generateStatement(node, bodyFlags));
          }
          for (i = 1, iz = stmt.declarations.length; i < iz; ++i) {
            node = stmt.declarations[i];
            if (extra.comment && node.leadingComments) {
              result.push("," + newline);
              result.push(addIndent(that.generateStatement(node, bodyFlags)));
            } else {
              result.push("," + space);
              result.push(that.generateStatement(node, bodyFlags));
            }
          }
        }
        if (stmt.declarations.length > 1) {
          withIndent(block);
        } else {
          block();
        }
        result.push(this.semicolon(flags));
        return result;
      },
      ThrowStatement: function(stmt, flags) {
        return [join("throw", this.generateExpression(stmt.argument, Precedence.Sequence, E_TTT)), this.semicolon(flags)];
      },
      TryStatement: function(stmt, flags) {
        var result, i, iz, guardedHandlers;
        result = ["try", this.maybeBlock(stmt.block, S_TFFF)];
        result = this.maybeBlockSuffix(stmt.block, result);
        if (stmt.handlers) {
          for (i = 0, iz = stmt.handlers.length; i < iz; ++i) {
            result = join(result, this.generateStatement(stmt.handlers[i], S_TFFF));
            if (stmt.finalizer || i + 1 !== iz) {
              result = this.maybeBlockSuffix(stmt.handlers[i].body, result);
            }
          }
        } else {
          guardedHandlers = stmt.guardedHandlers || [];
          for (i = 0, iz = guardedHandlers.length; i < iz; ++i) {
            result = join(result, this.generateStatement(guardedHandlers[i], S_TFFF));
            if (stmt.finalizer || i + 1 !== iz) {
              result = this.maybeBlockSuffix(guardedHandlers[i].body, result);
            }
          }
          if (stmt.handler) {
            if (Array.isArray(stmt.handler)) {
              for (i = 0, iz = stmt.handler.length; i < iz; ++i) {
                result = join(result, this.generateStatement(stmt.handler[i], S_TFFF));
                if (stmt.finalizer || i + 1 !== iz) {
                  result = this.maybeBlockSuffix(stmt.handler[i].body, result);
                }
              }
            } else {
              result = join(result, this.generateStatement(stmt.handler, S_TFFF));
              if (stmt.finalizer) {
                result = this.maybeBlockSuffix(stmt.handler.body, result);
              }
            }
          }
        }
        if (stmt.finalizer) {
          result = join(result, ["finally", this.maybeBlock(stmt.finalizer, S_TFFF)]);
        }
        return result;
      },
      SwitchStatement: function(stmt, flags) {
        var result, fragment, i, iz, bodyFlags, that = this;
        withIndent(function() {
          result = [
            "switch" + space + "(",
            that.generateExpression(stmt.discriminant, Precedence.Sequence, E_TTT),
            ")" + space + "{" + newline
          ];
        });
        if (stmt.cases) {
          bodyFlags = S_TFFF;
          for (i = 0, iz = stmt.cases.length; i < iz; ++i) {
            if (i === iz - 1) {
              bodyFlags |= F_SEMICOLON_OPT;
            }
            fragment = addIndent(this.generateStatement(stmt.cases[i], bodyFlags));
            result.push(fragment);
            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
              result.push(newline);
            }
          }
        }
        result.push(addIndent("}"));
        return result;
      },
      SwitchCase: function(stmt, flags) {
        var result, fragment, i, iz, bodyFlags, that = this;
        withIndent(function() {
          if (stmt.test) {
            result = [
              join("case", that.generateExpression(stmt.test, Precedence.Sequence, E_TTT)),
              ":"
            ];
          } else {
            result = ["default:"];
          }
          i = 0;
          iz = stmt.consequent.length;
          if (iz && stmt.consequent[0].type === Syntax.BlockStatement) {
            fragment = that.maybeBlock(stmt.consequent[0], S_TFFF);
            result.push(fragment);
            i = 1;
          }
          if (i !== iz && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
            result.push(newline);
          }
          bodyFlags = S_TFFF;
          for (; i < iz; ++i) {
            if (i === iz - 1 && flags & F_SEMICOLON_OPT) {
              bodyFlags |= F_SEMICOLON_OPT;
            }
            fragment = addIndent(that.generateStatement(stmt.consequent[i], bodyFlags));
            result.push(fragment);
            if (i + 1 !== iz && !endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
              result.push(newline);
            }
          }
        });
        return result;
      },
      IfStatement: function(stmt, flags) {
        var result, bodyFlags, semicolonOptional, that = this;
        withIndent(function() {
          result = [
            "if" + space + "(",
            that.generateExpression(stmt.test, Precedence.Sequence, E_TTT),
            ")"
          ];
        });
        semicolonOptional = flags & F_SEMICOLON_OPT;
        bodyFlags = S_TFFF;
        if (semicolonOptional) {
          bodyFlags |= F_SEMICOLON_OPT;
        }
        if (stmt.alternate) {
          result.push(this.maybeBlock(stmt.consequent, S_TFFF));
          result = this.maybeBlockSuffix(stmt.consequent, result);
          if (stmt.alternate.type === Syntax.IfStatement) {
            result = join(result, ["else ", this.generateStatement(stmt.alternate, bodyFlags)]);
          } else {
            result = join(result, join("else", this.maybeBlock(stmt.alternate, bodyFlags)));
          }
        } else {
          result.push(this.maybeBlock(stmt.consequent, bodyFlags));
        }
        return result;
      },
      ForStatement: function(stmt, flags) {
        var result, that = this;
        withIndent(function() {
          result = ["for" + space + "("];
          if (stmt.init) {
            if (stmt.init.type === Syntax.VariableDeclaration) {
              result.push(that.generateStatement(stmt.init, S_FFFF));
            } else {
              result.push(that.generateExpression(stmt.init, Precedence.Sequence, E_FTT));
              result.push(";");
            }
          } else {
            result.push(";");
          }
          if (stmt.test) {
            result.push(space);
            result.push(that.generateExpression(stmt.test, Precedence.Sequence, E_TTT));
            result.push(";");
          } else {
            result.push(";");
          }
          if (stmt.update) {
            result.push(space);
            result.push(that.generateExpression(stmt.update, Precedence.Sequence, E_TTT));
            result.push(")");
          } else {
            result.push(")");
          }
        });
        result.push(this.maybeBlock(stmt.body, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF));
        return result;
      },
      ForInStatement: function(stmt, flags) {
        return this.generateIterationForStatement("in", stmt, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF);
      },
      ForOfStatement: function(stmt, flags) {
        return this.generateIterationForStatement("of", stmt, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF);
      },
      LabeledStatement: function(stmt, flags) {
        return [stmt.label.name + ":", this.maybeBlock(stmt.body, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF)];
      },
      Program: function(stmt, flags) {
        var result, fragment, i, iz, bodyFlags;
        iz = stmt.body.length;
        result = [safeConcatenation && iz > 0 ? "\n" : ""];
        bodyFlags = S_TFTF;
        for (i = 0; i < iz; ++i) {
          if (!safeConcatenation && i === iz - 1) {
            bodyFlags |= F_SEMICOLON_OPT;
          }
          if (preserveBlankLines) {
            if (i === 0) {
              if (!stmt.body[0].leadingComments) {
                generateBlankLines(stmt.range[0], stmt.body[i].range[0], result);
              }
            }
            if (i > 0) {
              if (!stmt.body[i - 1].trailingComments && !stmt.body[i].leadingComments) {
                generateBlankLines(stmt.body[i - 1].range[1], stmt.body[i].range[0], result);
              }
            }
          }
          fragment = addIndent(this.generateStatement(stmt.body[i], bodyFlags));
          result.push(fragment);
          if (i + 1 < iz && !endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
            if (preserveBlankLines) {
              if (!stmt.body[i + 1].leadingComments) {
                result.push(newline);
              }
            } else {
              result.push(newline);
            }
          }
          if (preserveBlankLines) {
            if (i === iz - 1) {
              if (!stmt.body[i].trailingComments) {
                generateBlankLines(stmt.body[i].range[1], stmt.range[1], result);
              }
            }
          }
        }
        return result;
      },
      FunctionDeclaration: function(stmt, flags) {
        return [
          generateAsyncPrefix(stmt, true),
          "function",
          generateStarSuffix(stmt) || noEmptySpace(),
          stmt.id ? generateIdentifier(stmt.id) : "",
          this.generateFunctionBody(stmt)
        ];
      },
      ReturnStatement: function(stmt, flags) {
        if (stmt.argument) {
          return [join("return", this.generateExpression(stmt.argument, Precedence.Sequence, E_TTT)), this.semicolon(flags)];
        }
        return ["return" + this.semicolon(flags)];
      },
      WhileStatement: function(stmt, flags) {
        var result, that = this;
        withIndent(function() {
          result = [
            "while" + space + "(",
            that.generateExpression(stmt.test, Precedence.Sequence, E_TTT),
            ")"
          ];
        });
        result.push(this.maybeBlock(stmt.body, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF));
        return result;
      },
      WithStatement: function(stmt, flags) {
        var result, that = this;
        withIndent(function() {
          result = [
            "with" + space + "(",
            that.generateExpression(stmt.object, Precedence.Sequence, E_TTT),
            ")"
          ];
        });
        result.push(this.maybeBlock(stmt.body, flags & F_SEMICOLON_OPT ? S_TFFT : S_TFFF));
        return result;
      }
    };
    merge3(CodeGenerator.prototype, CodeGenerator.Statement);
    CodeGenerator.Expression = {
      SequenceExpression: function(expr, precedence, flags) {
        var result, i, iz;
        if (Precedence.Sequence < precedence) {
          flags |= F_ALLOW_IN;
        }
        result = [];
        for (i = 0, iz = expr.expressions.length; i < iz; ++i) {
          result.push(this.generateExpression(expr.expressions[i], Precedence.Assignment, flags));
          if (i + 1 < iz) {
            result.push("," + space);
          }
        }
        return parenthesize(result, Precedence.Sequence, precedence);
      },
      AssignmentExpression: function(expr, precedence, flags) {
        return this.generateAssignment(expr.left, expr.right, expr.operator, precedence, flags);
      },
      ArrowFunctionExpression: function(expr, precedence, flags) {
        return parenthesize(this.generateFunctionBody(expr), Precedence.ArrowFunction, precedence);
      },
      ConditionalExpression: function(expr, precedence, flags) {
        if (Precedence.Conditional < precedence) {
          flags |= F_ALLOW_IN;
        }
        return parenthesize([
          this.generateExpression(expr.test, Precedence.LogicalOR, flags),
          space + "?" + space,
          this.generateExpression(expr.consequent, Precedence.Assignment, flags),
          space + ":" + space,
          this.generateExpression(expr.alternate, Precedence.Assignment, flags)
        ], Precedence.Conditional, precedence);
      },
      LogicalExpression: function(expr, precedence, flags) {
        return this.BinaryExpression(expr, precedence, flags);
      },
      BinaryExpression: function(expr, precedence, flags) {
        var result, leftPrecedence, rightPrecedence, currentPrecedence, fragment, leftSource;
        currentPrecedence = BinaryPrecedence[expr.operator];
        leftPrecedence = expr.operator === "**" ? Precedence.Postfix : currentPrecedence;
        rightPrecedence = expr.operator === "**" ? currentPrecedence : currentPrecedence + 1;
        if (currentPrecedence < precedence) {
          flags |= F_ALLOW_IN;
        }
        fragment = this.generateExpression(expr.left, leftPrecedence, flags);
        leftSource = fragment.toString();
        if (leftSource.charCodeAt(leftSource.length - 1) === 47 && esutils.code.isIdentifierPartES5(expr.operator.charCodeAt(0))) {
          result = [fragment, noEmptySpace(), expr.operator];
        } else {
          result = join(fragment, expr.operator);
        }
        fragment = this.generateExpression(expr.right, rightPrecedence, flags);
        if (expr.operator === "/" && fragment.toString().charAt(0) === "/" || expr.operator.slice(-1) === "<" && fragment.toString().slice(0, 3) === "!--") {
          result.push(noEmptySpace());
          result.push(fragment);
        } else {
          result = join(result, fragment);
        }
        if (expr.operator === "in" && !(flags & F_ALLOW_IN)) {
          return ["(", result, ")"];
        }
        return parenthesize(result, currentPrecedence, precedence);
      },
      CallExpression: function(expr, precedence, flags) {
        var result, i, iz;
        result = [this.generateExpression(expr.callee, Precedence.Call, E_TTF)];
        if (expr.optional) {
          result.push("?.");
        }
        result.push("(");
        for (i = 0, iz = expr["arguments"].length; i < iz; ++i) {
          result.push(this.generateExpression(expr["arguments"][i], Precedence.Assignment, E_TTT));
          if (i + 1 < iz) {
            result.push("," + space);
          }
        }
        result.push(")");
        if (!(flags & F_ALLOW_CALL)) {
          return ["(", result, ")"];
        }
        return parenthesize(result, Precedence.Call, precedence);
      },
      ChainExpression: function(expr, precedence, flags) {
        if (Precedence.OptionalChaining < precedence) {
          flags |= F_ALLOW_CALL;
        }
        var result = this.generateExpression(expr.expression, Precedence.OptionalChaining, flags);
        return parenthesize(result, Precedence.OptionalChaining, precedence);
      },
      NewExpression: function(expr, precedence, flags) {
        var result, length, i, iz, itemFlags;
        length = expr["arguments"].length;
        itemFlags = flags & F_ALLOW_UNPARATH_NEW && !parentheses && length === 0 ? E_TFT : E_TFF;
        result = join("new", this.generateExpression(expr.callee, Precedence.New, itemFlags));
        if (!(flags & F_ALLOW_UNPARATH_NEW) || parentheses || length > 0) {
          result.push("(");
          for (i = 0, iz = length; i < iz; ++i) {
            result.push(this.generateExpression(expr["arguments"][i], Precedence.Assignment, E_TTT));
            if (i + 1 < iz) {
              result.push("," + space);
            }
          }
          result.push(")");
        }
        return parenthesize(result, Precedence.New, precedence);
      },
      MemberExpression: function(expr, precedence, flags) {
        var result, fragment;
        result = [this.generateExpression(expr.object, Precedence.Call, flags & F_ALLOW_CALL ? E_TTF : E_TFF)];
        if (expr.computed) {
          if (expr.optional) {
            result.push("?.");
          }
          result.push("[");
          result.push(this.generateExpression(expr.property, Precedence.Sequence, flags & F_ALLOW_CALL ? E_TTT : E_TFT));
          result.push("]");
        } else {
          if (!expr.optional && expr.object.type === Syntax.Literal && typeof expr.object.value === "number") {
            fragment = toSourceNodeWhenNeeded(result).toString();
            if (fragment.indexOf(".") < 0 && !/[eExX]/.test(fragment) && esutils.code.isDecimalDigit(fragment.charCodeAt(fragment.length - 1)) && !(fragment.length >= 2 && fragment.charCodeAt(0) === 48)) {
              result.push(" ");
            }
          }
          result.push(expr.optional ? "?." : ".");
          result.push(generateIdentifier(expr.property));
        }
        return parenthesize(result, Precedence.Member, precedence);
      },
      MetaProperty: function(expr, precedence, flags) {
        var result;
        result = [];
        result.push(typeof expr.meta === "string" ? expr.meta : generateIdentifier(expr.meta));
        result.push(".");
        result.push(typeof expr.property === "string" ? expr.property : generateIdentifier(expr.property));
        return parenthesize(result, Precedence.Member, precedence);
      },
      UnaryExpression: function(expr, precedence, flags) {
        var result, fragment, rightCharCode, leftSource, leftCharCode;
        fragment = this.generateExpression(expr.argument, Precedence.Unary, E_TTT);
        if (space === "") {
          result = join(expr.operator, fragment);
        } else {
          result = [expr.operator];
          if (expr.operator.length > 2) {
            result = join(result, fragment);
          } else {
            leftSource = toSourceNodeWhenNeeded(result).toString();
            leftCharCode = leftSource.charCodeAt(leftSource.length - 1);
            rightCharCode = fragment.toString().charCodeAt(0);
            if ((leftCharCode === 43 || leftCharCode === 45) && leftCharCode === rightCharCode || esutils.code.isIdentifierPartES5(leftCharCode) && esutils.code.isIdentifierPartES5(rightCharCode)) {
              result.push(noEmptySpace());
              result.push(fragment);
            } else {
              result.push(fragment);
            }
          }
        }
        return parenthesize(result, Precedence.Unary, precedence);
      },
      YieldExpression: function(expr, precedence, flags) {
        var result;
        if (expr.delegate) {
          result = "yield*";
        } else {
          result = "yield";
        }
        if (expr.argument) {
          result = join(result, this.generateExpression(expr.argument, Precedence.Yield, E_TTT));
        }
        return parenthesize(result, Precedence.Yield, precedence);
      },
      AwaitExpression: function(expr, precedence, flags) {
        var result = join(expr.all ? "await*" : "await", this.generateExpression(expr.argument, Precedence.Await, E_TTT));
        return parenthesize(result, Precedence.Await, precedence);
      },
      UpdateExpression: function(expr, precedence, flags) {
        if (expr.prefix) {
          return parenthesize([
            expr.operator,
            this.generateExpression(expr.argument, Precedence.Unary, E_TTT)
          ], Precedence.Unary, precedence);
        }
        return parenthesize([
          this.generateExpression(expr.argument, Precedence.Postfix, E_TTT),
          expr.operator
        ], Precedence.Postfix, precedence);
      },
      FunctionExpression: function(expr, precedence, flags) {
        var result = [
          generateAsyncPrefix(expr, true),
          "function"
        ];
        if (expr.id) {
          result.push(generateStarSuffix(expr) || noEmptySpace());
          result.push(generateIdentifier(expr.id));
        } else {
          result.push(generateStarSuffix(expr) || space);
        }
        result.push(this.generateFunctionBody(expr));
        return result;
      },
      ArrayPattern: function(expr, precedence, flags) {
        return this.ArrayExpression(expr, precedence, flags, true);
      },
      ArrayExpression: function(expr, precedence, flags, isPattern2) {
        var result, multiline, that = this;
        if (!expr.elements.length) {
          return "[]";
        }
        multiline = isPattern2 ? false : expr.elements.length > 1;
        result = ["[", multiline ? newline : ""];
        withIndent(function(indent2) {
          var i, iz;
          for (i = 0, iz = expr.elements.length; i < iz; ++i) {
            if (!expr.elements[i]) {
              if (multiline) {
                result.push(indent2);
              }
              if (i + 1 === iz) {
                result.push(",");
              }
            } else {
              result.push(multiline ? indent2 : "");
              result.push(that.generateExpression(expr.elements[i], Precedence.Assignment, E_TTT));
            }
            if (i + 1 < iz) {
              result.push("," + (multiline ? newline : space));
            }
          }
        });
        if (multiline && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
          result.push(newline);
        }
        result.push(multiline ? base2 : "");
        result.push("]");
        return result;
      },
      RestElement: function(expr, precedence, flags) {
        return "..." + this.generatePattern(expr.argument);
      },
      ClassExpression: function(expr, precedence, flags) {
        var result, fragment;
        result = ["class"];
        if (expr.id) {
          result = join(result, this.generateExpression(expr.id, Precedence.Sequence, E_TTT));
        }
        if (expr.superClass) {
          fragment = join("extends", this.generateExpression(expr.superClass, Precedence.Unary, E_TTT));
          result = join(result, fragment);
        }
        result.push(space);
        result.push(this.generateStatement(expr.body, S_TFFT));
        return result;
      },
      MethodDefinition: function(expr, precedence, flags) {
        var result, fragment;
        if (expr["static"]) {
          result = ["static" + space];
        } else {
          result = [];
        }
        if (expr.kind === "get" || expr.kind === "set") {
          fragment = [
            join(expr.kind, this.generatePropertyKey(expr.key, expr.computed)),
            this.generateFunctionBody(expr.value)
          ];
        } else {
          fragment = [
            generateMethodPrefix(expr),
            this.generatePropertyKey(expr.key, expr.computed),
            this.generateFunctionBody(expr.value)
          ];
        }
        return join(result, fragment);
      },
      Property: function(expr, precedence, flags) {
        if (expr.kind === "get" || expr.kind === "set") {
          return [
            expr.kind,
            noEmptySpace(),
            this.generatePropertyKey(expr.key, expr.computed),
            this.generateFunctionBody(expr.value)
          ];
        }
        if (expr.shorthand) {
          if (expr.value.type === "AssignmentPattern") {
            return this.AssignmentPattern(expr.value, Precedence.Sequence, E_TTT);
          }
          return this.generatePropertyKey(expr.key, expr.computed);
        }
        if (expr.method) {
          return [
            generateMethodPrefix(expr),
            this.generatePropertyKey(expr.key, expr.computed),
            this.generateFunctionBody(expr.value)
          ];
        }
        return [
          this.generatePropertyKey(expr.key, expr.computed),
          ":" + space,
          this.generateExpression(expr.value, Precedence.Assignment, E_TTT)
        ];
      },
      ObjectExpression: function(expr, precedence, flags) {
        var multiline, result, fragment, that = this;
        if (!expr.properties.length) {
          return "{}";
        }
        multiline = expr.properties.length > 1;
        withIndent(function() {
          fragment = that.generateExpression(expr.properties[0], Precedence.Sequence, E_TTT);
        });
        if (!multiline) {
          if (!hasLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
            return ["{", space, fragment, space, "}"];
          }
        }
        withIndent(function(indent2) {
          var i, iz;
          result = ["{", newline, indent2, fragment];
          if (multiline) {
            result.push("," + newline);
            for (i = 1, iz = expr.properties.length; i < iz; ++i) {
              result.push(indent2);
              result.push(that.generateExpression(expr.properties[i], Precedence.Sequence, E_TTT));
              if (i + 1 < iz) {
                result.push("," + newline);
              }
            }
          }
        });
        if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
          result.push(newline);
        }
        result.push(base2);
        result.push("}");
        return result;
      },
      AssignmentPattern: function(expr, precedence, flags) {
        return this.generateAssignment(expr.left, expr.right, "=", precedence, flags);
      },
      ObjectPattern: function(expr, precedence, flags) {
        var result, i, iz, multiline, property, that = this;
        if (!expr.properties.length) {
          return "{}";
        }
        multiline = false;
        if (expr.properties.length === 1) {
          property = expr.properties[0];
          if (property.type === Syntax.Property && property.value.type !== Syntax.Identifier) {
            multiline = true;
          }
        } else {
          for (i = 0, iz = expr.properties.length; i < iz; ++i) {
            property = expr.properties[i];
            if (property.type === Syntax.Property && !property.shorthand) {
              multiline = true;
              break;
            }
          }
        }
        result = ["{", multiline ? newline : ""];
        withIndent(function(indent2) {
          var i2, iz2;
          for (i2 = 0, iz2 = expr.properties.length; i2 < iz2; ++i2) {
            result.push(multiline ? indent2 : "");
            result.push(that.generateExpression(expr.properties[i2], Precedence.Sequence, E_TTT));
            if (i2 + 1 < iz2) {
              result.push("," + (multiline ? newline : space));
            }
          }
        });
        if (multiline && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
          result.push(newline);
        }
        result.push(multiline ? base2 : "");
        result.push("}");
        return result;
      },
      ThisExpression: function(expr, precedence, flags) {
        return "this";
      },
      Super: function(expr, precedence, flags) {
        return "super";
      },
      Identifier: function(expr, precedence, flags) {
        return generateIdentifier(expr);
      },
      ImportDefaultSpecifier: function(expr, precedence, flags) {
        return generateIdentifier(expr.id || expr.local);
      },
      ImportNamespaceSpecifier: function(expr, precedence, flags) {
        var result = ["*"];
        var id2 = expr.id || expr.local;
        if (id2) {
          result.push(space + "as" + noEmptySpace() + generateIdentifier(id2));
        }
        return result;
      },
      ImportSpecifier: function(expr, precedence, flags) {
        var imported = expr.imported;
        var result = [imported.name];
        var local = expr.local;
        if (local && local.name !== imported.name) {
          result.push(noEmptySpace() + "as" + noEmptySpace() + generateIdentifier(local));
        }
        return result;
      },
      ExportSpecifier: function(expr, precedence, flags) {
        var local = expr.local;
        var result = [local.name];
        var exported = expr.exported;
        if (exported && exported.name !== local.name) {
          result.push(noEmptySpace() + "as" + noEmptySpace() + generateIdentifier(exported));
        }
        return result;
      },
      Literal: function(expr, precedence, flags) {
        var raw;
        if (expr.hasOwnProperty("raw") && parse4 && extra.raw) {
          try {
            raw = parse4(expr.raw).body[0].expression;
            if (raw.type === Syntax.Literal) {
              if (raw.value === expr.value) {
                return expr.raw;
              }
            }
          } catch (e2) {
          }
        }
        if (expr.regex) {
          return "/" + expr.regex.pattern + "/" + expr.regex.flags;
        }
        if (expr.value === null) {
          return "null";
        }
        if (typeof expr.value === "string") {
          return escapeString(expr.value);
        }
        if (typeof expr.value === "number") {
          return generateNumber(expr.value);
        }
        if (typeof expr.value === "boolean") {
          return expr.value ? "true" : "false";
        }
        return generateRegExp(expr.value);
      },
      GeneratorExpression: function(expr, precedence, flags) {
        return this.ComprehensionExpression(expr, precedence, flags);
      },
      ComprehensionExpression: function(expr, precedence, flags) {
        var result, i, iz, fragment, that = this;
        result = expr.type === Syntax.GeneratorExpression ? ["("] : ["["];
        if (extra.moz.comprehensionExpressionStartsWithAssignment) {
          fragment = this.generateExpression(expr.body, Precedence.Assignment, E_TTT);
          result.push(fragment);
        }
        if (expr.blocks) {
          withIndent(function() {
            for (i = 0, iz = expr.blocks.length; i < iz; ++i) {
              fragment = that.generateExpression(expr.blocks[i], Precedence.Sequence, E_TTT);
              if (i > 0 || extra.moz.comprehensionExpressionStartsWithAssignment) {
                result = join(result, fragment);
              } else {
                result.push(fragment);
              }
            }
          });
        }
        if (expr.filter) {
          result = join(result, "if" + space);
          fragment = this.generateExpression(expr.filter, Precedence.Sequence, E_TTT);
          result = join(result, ["(", fragment, ")"]);
        }
        if (!extra.moz.comprehensionExpressionStartsWithAssignment) {
          fragment = this.generateExpression(expr.body, Precedence.Assignment, E_TTT);
          result = join(result, fragment);
        }
        result.push(expr.type === Syntax.GeneratorExpression ? ")" : "]");
        return result;
      },
      ComprehensionBlock: function(expr, precedence, flags) {
        var fragment;
        if (expr.left.type === Syntax.VariableDeclaration) {
          fragment = [
            expr.left.kind,
            noEmptySpace(),
            this.generateStatement(expr.left.declarations[0], S_FFFF)
          ];
        } else {
          fragment = this.generateExpression(expr.left, Precedence.Call, E_TTT);
        }
        fragment = join(fragment, expr.of ? "of" : "in");
        fragment = join(fragment, this.generateExpression(expr.right, Precedence.Sequence, E_TTT));
        return ["for" + space + "(", fragment, ")"];
      },
      SpreadElement: function(expr, precedence, flags) {
        return [
          "...",
          this.generateExpression(expr.argument, Precedence.Assignment, E_TTT)
        ];
      },
      TaggedTemplateExpression: function(expr, precedence, flags) {
        var itemFlags = E_TTF;
        if (!(flags & F_ALLOW_CALL)) {
          itemFlags = E_TFF;
        }
        var result = [
          this.generateExpression(expr.tag, Precedence.Call, itemFlags),
          this.generateExpression(expr.quasi, Precedence.Primary, E_FFT)
        ];
        return parenthesize(result, Precedence.TaggedTemplate, precedence);
      },
      TemplateElement: function(expr, precedence, flags) {
        return expr.value.raw;
      },
      TemplateLiteral: function(expr, precedence, flags) {
        var result, i, iz;
        result = ["`"];
        for (i = 0, iz = expr.quasis.length; i < iz; ++i) {
          result.push(this.generateExpression(expr.quasis[i], Precedence.Primary, E_TTT));
          if (i + 1 < iz) {
            result.push("${" + space);
            result.push(this.generateExpression(expr.expressions[i], Precedence.Sequence, E_TTT));
            result.push(space + "}");
          }
        }
        result.push("`");
        return result;
      },
      ModuleSpecifier: function(expr, precedence, flags) {
        return this.Literal(expr, precedence, flags);
      },
      ImportExpression: function(expr, precedence, flag) {
        return parenthesize([
          "import(",
          this.generateExpression(expr.source, Precedence.Assignment, E_TTT),
          ")"
        ], Precedence.Call, precedence);
      }
    };
    merge3(CodeGenerator.prototype, CodeGenerator.Expression);
    CodeGenerator.prototype.generateExpression = function(expr, precedence, flags) {
      var result, type4;
      type4 = expr.type || Syntax.Property;
      if (extra.verbatim && expr.hasOwnProperty(extra.verbatim)) {
        return generateVerbatim(expr, precedence);
      }
      result = this[type4](expr, precedence, flags);
      if (extra.comment) {
        result = addComments(expr, result);
      }
      return toSourceNodeWhenNeeded(result, expr);
    };
    CodeGenerator.prototype.generateStatement = function(stmt, flags) {
      var result, fragment;
      result = this[stmt.type](stmt, flags);
      if (extra.comment) {
        result = addComments(stmt, result);
      }
      fragment = toSourceNodeWhenNeeded(result).toString();
      if (stmt.type === Syntax.Program && !safeConcatenation && newline === "" && fragment.charAt(fragment.length - 1) === "\n") {
        result = sourceMap$1 ? toSourceNodeWhenNeeded(result).replaceRight(/\s+$/, "") : fragment.replace(/\s+$/, "");
      }
      return toSourceNodeWhenNeeded(result, stmt);
    };
    function generateInternal(node) {
      var codegen;
      codegen = new CodeGenerator();
      if (isStatement(node)) {
        return codegen.generateStatement(node, S_TFFF);
      }
      if (isExpression(node)) {
        return codegen.generateExpression(node, Precedence.Sequence, E_TTT);
      }
      throw new Error("Unknown node type: " + node.type);
    }
    function generate2(node, options) {
      var defaultOptions2 = getDefaultOptions(), result, pair;
      if (options != null) {
        if (typeof options.indent === "string") {
          defaultOptions2.format.indent.style = options.indent;
        }
        if (typeof options.base === "number") {
          defaultOptions2.format.indent.base = options.base;
        }
        options = updateDeeply(defaultOptions2, options);
        indent = options.format.indent.style;
        if (typeof options.base === "string") {
          base2 = options.base;
        } else {
          base2 = stringRepeat(indent, options.format.indent.base);
        }
      } else {
        options = defaultOptions2;
        indent = options.format.indent.style;
        base2 = stringRepeat(indent, options.format.indent.base);
      }
      json = options.format.json;
      renumber = options.format.renumber;
      hexadecimal = json ? false : options.format.hexadecimal;
      quotes = json ? "double" : options.format.quotes;
      escapeless = options.format.escapeless;
      newline = options.format.newline;
      space = options.format.space;
      if (options.format.compact) {
        newline = space = indent = base2 = "";
      }
      parentheses = options.format.parentheses;
      semicolons = options.format.semicolons;
      safeConcatenation = options.format.safeConcatenation;
      directive = options.directive;
      parse4 = json ? null : options.parse;
      sourceMap$1 = options.sourceMap;
      sourceCode = options.sourceCode;
      preserveBlankLines = options.format.preserveBlankLines && sourceCode !== null;
      extra = options;
      if (sourceMap$1) {
        if (!exports.browser) {
          SourceNode2 = sourceMap.SourceNode;
        } else {
          SourceNode2 = commonjsGlobal.sourceMap.SourceNode;
        }
      }
      result = generateInternal(node);
      if (!sourceMap$1) {
        pair = { code: result.toString(), map: null };
        return options.sourceMapWithCode ? pair : pair.code;
      }
      pair = result.toStringWithSourceMap({
        file: options.file,
        sourceRoot: options.sourceMapRoot
      });
      if (options.sourceContent) {
        pair.map.setSourceContent(options.sourceMap, options.sourceContent);
      }
      if (options.sourceMapWithCode) {
        return pair;
      }
      return pair.map.toString();
    }
    FORMAT_MINIFY = {
      indent: {
        style: "",
        base: 0
      },
      renumber: true,
      hexadecimal: true,
      quotes: "auto",
      escapeless: true,
      compact: true,
      parentheses: false,
      semicolons: false
    };
    FORMAT_DEFAULTS = getDefaultOptions().format;
    exports.version = require$$3.version;
    exports.generate = generate2;
    exports.attachComments = estraverse$1.attachComments;
    exports.Precedence = updateDeeply({}, Precedence);
    exports.browser = false;
    exports.FORMAT_MINIFY = FORMAT_MINIFY;
    exports.FORMAT_DEFAULTS = FORMAT_DEFAULTS;
  })();
})(escodegen);
var babel = { exports: {} };
(function(module, exports) {
  (function(global2, factory) {
    factory(exports);
  })(commonjsGlobal, function(exports2) {
    var babel2 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      get version() {
        return version$3;
      },
      get types() {
        return t$a;
      },
      get DEFAULT_EXTENSIONS() {
        return DEFAULT_EXTENSIONS;
      },
      get OptionManager() {
        return OptionManager2;
      },
      get Plugin() {
        return Plugin;
      },
      get File() {
        return File;
      },
      get buildExternalHelpers() {
        return babelBuildExternalHelpers;
      },
      get resolvePlugin() {
        return resolvePlugin;
      },
      get resolvePreset() {
        return resolvePreset;
      },
      get getEnv() {
        return getEnv;
      },
      get tokTypes() {
        return tokTypes;
      },
      get traverse() {
        return traverse;
      },
      get template() {
        return template$2;
      },
      get createConfigItem() {
        return createConfigItem;
      },
      get createConfigItemSync() {
        return createConfigItemSync;
      },
      get createConfigItemAsync() {
        return createConfigItemAsync;
      },
      get loadPartialConfig() {
        return loadPartialConfig;
      },
      get loadPartialConfigSync() {
        return loadPartialConfigSync;
      },
      get loadPartialConfigAsync() {
        return loadPartialConfigAsync;
      },
      get loadOptions() {
        return loadOptions;
      },
      get loadOptionsSync() {
        return loadOptionsSync;
      },
      get loadOptionsAsync() {
        return loadOptionsAsync;
      },
      get transform() {
        return transform$3;
      },
      get transformSync() {
        return transformSync;
      },
      get transformAsync() {
        return transformAsync;
      },
      get transformFile() {
        return transformFile;
      },
      get transformFileSync() {
        return transformFileSync;
      },
      get transformFileAsync() {
        return transformFileAsync;
      },
      get transformFromAst() {
        return transformFromAst$1;
      },
      get transformFromAstSync() {
        return transformFromAstSync;
      },
      get transformFromAstAsync() {
        return transformFromAstAsync;
      },
      get parse() {
        return parse$3;
      },
      get parseSync() {
        return parseSync;
      },
      get parseAsync() {
        return parseAsync;
      }
    });
    function _defineProperties2(target, props) {
      for (var i2 = 0; i2 < props.length; i2++) {
        var descriptor = props[i2];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass2(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties2(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties2(Constructor, staticProps);
      Object.defineProperty(Constructor, "prototype", {
        writable: false
      });
      return Constructor;
    }
    function _inherits2(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      });
      Object.defineProperty(subClass, "prototype", {
        writable: false
      });
      if (superClass)
        _setPrototypeOf2(subClass, superClass);
    }
    function _setPrototypeOf2(o, p2) {
      _setPrototypeOf2 = Object.setPrototypeOf || function _setPrototypeOf3(o2, p3) {
        o2.__proto__ = p3;
        return o2;
      };
      return _setPrototypeOf2(o, p2);
    }
    function _objectWithoutPropertiesLoose2(source, excluded) {
      if (source == null)
        return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key2, i2;
      for (i2 = 0; i2 < sourceKeys.length; i2++) {
        key2 = sourceKeys[i2];
        if (excluded.indexOf(key2) >= 0)
          continue;
        target[key2] = source[key2];
      }
      return target;
    }
    function _objectWithoutProperties2(source, excluded) {
      if (source == null)
        return {};
      var target = _objectWithoutPropertiesLoose2(source, excluded);
      var key2, i2;
      if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i2 = 0; i2 < sourceSymbolKeys.length; i2++) {
          key2 = sourceSymbolKeys[i2];
          if (excluded.indexOf(key2) >= 0)
            continue;
          if (!Object.prototype.propertyIsEnumerable.call(source, key2))
            continue;
          target[key2] = source[key2];
        }
      }
      return target;
    }
    function _taggedTemplateLiteralLoose(strings, raw) {
      if (!raw) {
        raw = strings.slice(0);
      }
      strings.raw = raw;
      return strings;
    }
    function _slicedToArray$12(arr, i2) {
      return _arrayWithHoles2(arr) || _iterableToArrayLimit2(arr, i2) || _unsupportedIterableToArray2(arr, i2) || _nonIterableRest2();
    }
    function _toConsumableArray2(arr) {
      return _arrayWithoutHoles2(arr) || _iterableToArray2(arr) || _unsupportedIterableToArray2(arr) || _nonIterableSpread2();
    }
    function _arrayWithoutHoles2(arr) {
      if (Array.isArray(arr))
        return _arrayLikeToArray2(arr);
    }
    function _arrayWithHoles2(arr) {
      if (Array.isArray(arr))
        return arr;
    }
    function _iterableToArray2(iter) {
      if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
        return Array.from(iter);
    }
    function _iterableToArrayLimit2(arr, i2) {
      var _i3 = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
      if (_i3 == null)
        return;
      var _arr = [];
      var _n = true;
      var _d = false;
      var _s, _e;
      try {
        for (_i3 = _i3.call(arr); !(_n = (_s = _i3.next()).done); _n = true) {
          _arr.push(_s.value);
          if (i2 && _arr.length === i2)
            break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i3["return"] != null)
            _i3["return"]();
        } finally {
          if (_d)
            throw _e;
        }
      }
      return _arr;
    }
    function _unsupportedIterableToArray2(o, minLen) {
      if (!o)
        return;
      if (typeof o === "string")
        return _arrayLikeToArray2(o, minLen);
      var n2 = Object.prototype.toString.call(o).slice(8, -1);
      if (n2 === "Object" && o.constructor)
        n2 = o.constructor.name;
      if (n2 === "Map" || n2 === "Set")
        return Array.from(o);
      if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
        return _arrayLikeToArray2(o, minLen);
    }
    function _arrayLikeToArray2(arr, len3) {
      if (len3 == null || len3 > arr.length)
        len3 = arr.length;
      for (var i2 = 0, arr2 = new Array(len3); i2 < len3; i2++)
        arr2[i2] = arr[i2];
      return arr2;
    }
    function _nonIterableSpread2() {
      throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    function _nonIterableRest2() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    function _createForOfIteratorHelperLoose(o, allowArrayLike) {
      var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
      if (it)
        return (it = it.call(o)).next.bind(it);
      if (Array.isArray(o) || (it = _unsupportedIterableToArray2(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it)
          o = it;
        var i2 = 0;
        return function() {
          if (i2 >= o.length)
            return {
              done: true
            };
          return {
            done: false,
            value: o[i2++]
          };
        };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    function shallowEqual2(actual, expected) {
      var keys2 = Object.keys(expected);
      for (var _i3 = 0, _keys = keys2; _i3 < _keys.length; _i3++) {
        var key2 = _keys[_i3];
        if (actual[key2] !== expected[key2]) {
          return false;
        }
      }
      return true;
    }
    function isArrayExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrayExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isAssignmentExpression$4(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AssignmentExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBinaryExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BinaryExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isInterpreterDirective(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "InterpreterDirective") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDirective(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Directive") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDirectiveLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DirectiveLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBlockStatement$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BlockStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBreakStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BreakStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isCallExpression$7(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "CallExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isCatchClause(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "CatchClause") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isConditionalExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ConditionalExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isContinueStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ContinueStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDebuggerStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DebuggerStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDoWhileStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DoWhileStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEmptyStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EmptyStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExpressionStatement$4(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExpressionStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFile$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "File") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isForInStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ForInStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isForStatement$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ForStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunctionDeclaration$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunctionExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isIdentifier$i(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Identifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isIfStatement$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "IfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isLabeledStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "LabeledStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStringLiteral$7(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "StringLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNumericLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NumericLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNullLiteral$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NullLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBooleanLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BooleanLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isRegExpLiteral$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "RegExpLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isLogicalExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "LogicalExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isMemberExpression$8(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "MemberExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNewExpression$4(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NewExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isProgram$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Program") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectExpression$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectMethod$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectProperty$5(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isRestElement$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "RestElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isReturnStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ReturnStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSequenceExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SequenceExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isParenthesizedExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ParenthesizedExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSwitchCase(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SwitchCase") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSwitchStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SwitchStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isThisExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ThisExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isThrowStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ThrowStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTryStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TryStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isUnaryExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "UnaryExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isUpdateExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "UpdateExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isVariableDeclaration$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "VariableDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isVariableDeclarator$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "VariableDeclarator") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isWhileStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "WhileStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isWithStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "WithStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isAssignmentPattern$5(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AssignmentPattern") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isArrayPattern$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrayPattern") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isArrowFunctionExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrowFunctionExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassBody$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassDeclaration$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportAllDeclaration$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportAllDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportDefaultDeclaration$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportDefaultDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportNamedDeclaration$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportNamedDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportSpecifier(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isForOfStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ForOfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImportDeclaration$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ImportDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImportDefaultSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ImportDefaultSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImportNamespaceSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ImportNamespaceSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImportSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ImportSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isMetaProperty$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "MetaProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassMethod$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectPattern$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectPattern") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSpreadElement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SpreadElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSuper$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Super") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTaggedTemplateExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TaggedTemplateExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTemplateElement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TemplateElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTemplateLiteral$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TemplateLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isYieldExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "YieldExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isAwaitExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AwaitExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImport(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Import") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBigIntLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BigIntLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportNamespaceSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportNamespaceSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isOptionalMemberExpression$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "OptionalMemberExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isOptionalCallExpression$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "OptionalCallExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassAccessorProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassAccessorProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassPrivateProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassPrivateProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassPrivateMethod(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassPrivateMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPrivateName$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "PrivateName") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStaticBlock(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "StaticBlock") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isAnyTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AnyTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isArrayTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrayTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBooleanTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BooleanTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBooleanLiteralTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BooleanLiteralTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNullLiteralTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NullLiteralTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClassImplements(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassImplements") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareClass(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareClass") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareFunction(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareFunction") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareInterface(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareInterface") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareModule(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareModule") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareModuleExports(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareModuleExports") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareTypeAlias(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareTypeAlias") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareOpaqueType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareOpaqueType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareVariable(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareVariable") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareExportDeclaration$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareExportDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclareExportAllDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareExportAllDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclaredPredicate(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclaredPredicate") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExistsTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExistsTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunctionTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunctionTypeParam(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionTypeParam") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isGenericTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "GenericTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isInferredPredicate(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "InferredPredicate") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isInterfaceExtends(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "InterfaceExtends") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isInterfaceDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "InterfaceDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isInterfaceTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "InterfaceTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isIntersectionTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "IntersectionTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isMixedTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "MixedTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEmptyTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EmptyTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNullableTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NullableTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNumberLiteralTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NumberLiteralTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNumberTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NumberTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeInternalSlot(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeInternalSlot") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeCallProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeCallProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeIndexer(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeIndexer") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectTypeSpreadProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectTypeSpreadProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isOpaqueType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "OpaqueType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isQualifiedTypeIdentifier(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "QualifiedTypeIdentifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStringLiteralTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "StringLiteralTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStringTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "StringTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSymbolTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SymbolTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isThisTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ThisTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTupleTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TupleTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeofTypeAnnotation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeofTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeAlias(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeAlias") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeAnnotation$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeCastExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeCastExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeParameter(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeParameter") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeParameterDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeParameterDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeParameterInstantiation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TypeParameterInstantiation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isUnionTypeAnnotation$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "UnionTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isVariance(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Variance") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isVoidTypeAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "VoidTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumBooleanBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumBooleanBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumNumberBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumNumberBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumStringBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumStringBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumSymbolBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumSymbolBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumBooleanMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumBooleanMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumNumberMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumNumberMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumStringMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumStringMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumDefaultedMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumDefaultedMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isIndexedAccessType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "IndexedAccessType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isOptionalIndexedAccessType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "OptionalIndexedAccessType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXAttribute(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXAttribute") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXClosingElement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXClosingElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXElement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXEmptyExpression(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXEmptyExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXExpressionContainer$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXExpressionContainer") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXSpreadChild(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXSpreadChild") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXIdentifier$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXIdentifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXMemberExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXMemberExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXNamespacedName$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXNamespacedName") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXOpeningElement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXOpeningElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXSpreadAttribute$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXSpreadAttribute") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXText(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXText") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXFragment(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXFragment") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXOpeningFragment(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXOpeningFragment") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSXClosingFragment(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXClosingFragment") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNoop(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Noop") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPlaceholder$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Placeholder") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isV8IntrinsicIdentifier(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "V8IntrinsicIdentifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isArgumentPlaceholder(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArgumentPlaceholder") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBindExpression(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BindExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isImportAttribute(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ImportAttribute") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDecorator(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Decorator") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDoExpression(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DoExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportDefaultSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportDefaultSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isRecordExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "RecordExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTupleExpression$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TupleExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDecimalLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DecimalLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isModuleExpression(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ModuleExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTopicReference$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TopicReference") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPipelineTopicExpression(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "PipelineTopicExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPipelineBareFunction(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "PipelineBareFunction") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPipelinePrimaryTopicReference(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "PipelinePrimaryTopicReference") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSParameterProperty(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSParameterProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSDeclareFunction(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSDeclareFunction") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSDeclareMethod(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSDeclareMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSQualifiedName(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSQualifiedName") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSCallSignatureDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSCallSignatureDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSConstructSignatureDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSConstructSignatureDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSPropertySignature(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSPropertySignature") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSMethodSignature(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSMethodSignature") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSIndexSignature(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSIndexSignature") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSAnyKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSAnyKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSBooleanKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSBooleanKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSBigIntKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSBigIntKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSIntrinsicKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSIntrinsicKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNeverKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNeverKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNullKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNullKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNumberKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNumberKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSObjectKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSObjectKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSStringKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSStringKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSSymbolKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSSymbolKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSUndefinedKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSUndefinedKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSUnknownKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSUnknownKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSVoidKeyword(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSVoidKeyword") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSThisType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSThisType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSFunctionType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSFunctionType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSConstructorType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSConstructorType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeReference(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeReference") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypePredicate(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypePredicate") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeQuery(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeQuery") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeLiteral(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSArrayType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSArrayType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTupleType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTupleType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSOptionalType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSOptionalType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSRestType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSRestType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNamedTupleMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNamedTupleMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSUnionType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSUnionType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSIntersectionType$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSIntersectionType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSConditionalType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSConditionalType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSInferType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSInferType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSParenthesizedType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSParenthesizedType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeOperator(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeOperator") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSIndexedAccessType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSIndexedAccessType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSMappedType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSMappedType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSLiteralType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSLiteralType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSExpressionWithTypeArguments(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSExpressionWithTypeArguments") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSInterfaceDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSInterfaceDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSInterfaceBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSInterfaceBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeAliasDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeAliasDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSAsExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSAsExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeAssertion$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeAssertion") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSEnumDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSEnumDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSEnumMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSEnumMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSModuleDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSModuleDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSModuleBlock(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSModuleBlock") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSImportType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSImportType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSImportEqualsDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSImportEqualsDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSExternalModuleReference(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSExternalModuleReference") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNonNullExpression$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNonNullExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSExportAssignment(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSExportAssignment") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSNamespaceExportDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSNamespaceExportDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeAnnotation$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeParameterInstantiation(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeParameterInstantiation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeParameterDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeParameterDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeParameter(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSTypeParameter") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStandardized(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrayExpression" || nodeType === "AssignmentExpression" || nodeType === "BinaryExpression" || nodeType === "InterpreterDirective" || nodeType === "Directive" || nodeType === "DirectiveLiteral" || nodeType === "BlockStatement" || nodeType === "BreakStatement" || nodeType === "CallExpression" || nodeType === "CatchClause" || nodeType === "ConditionalExpression" || nodeType === "ContinueStatement" || nodeType === "DebuggerStatement" || nodeType === "DoWhileStatement" || nodeType === "EmptyStatement" || nodeType === "ExpressionStatement" || nodeType === "File" || nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "Identifier" || nodeType === "IfStatement" || nodeType === "LabeledStatement" || nodeType === "StringLiteral" || nodeType === "NumericLiteral" || nodeType === "NullLiteral" || nodeType === "BooleanLiteral" || nodeType === "RegExpLiteral" || nodeType === "LogicalExpression" || nodeType === "MemberExpression" || nodeType === "NewExpression" || nodeType === "Program" || nodeType === "ObjectExpression" || nodeType === "ObjectMethod" || nodeType === "ObjectProperty" || nodeType === "RestElement" || nodeType === "ReturnStatement" || nodeType === "SequenceExpression" || nodeType === "ParenthesizedExpression" || nodeType === "SwitchCase" || nodeType === "SwitchStatement" || nodeType === "ThisExpression" || nodeType === "ThrowStatement" || nodeType === "TryStatement" || nodeType === "UnaryExpression" || nodeType === "UpdateExpression" || nodeType === "VariableDeclaration" || nodeType === "VariableDeclarator" || nodeType === "WhileStatement" || nodeType === "WithStatement" || nodeType === "AssignmentPattern" || nodeType === "ArrayPattern" || nodeType === "ArrowFunctionExpression" || nodeType === "ClassBody" || nodeType === "ClassExpression" || nodeType === "ClassDeclaration" || nodeType === "ExportAllDeclaration" || nodeType === "ExportDefaultDeclaration" || nodeType === "ExportNamedDeclaration" || nodeType === "ExportSpecifier" || nodeType === "ForOfStatement" || nodeType === "ImportDeclaration" || nodeType === "ImportDefaultSpecifier" || nodeType === "ImportNamespaceSpecifier" || nodeType === "ImportSpecifier" || nodeType === "MetaProperty" || nodeType === "ClassMethod" || nodeType === "ObjectPattern" || nodeType === "SpreadElement" || nodeType === "Super" || nodeType === "TaggedTemplateExpression" || nodeType === "TemplateElement" || nodeType === "TemplateLiteral" || nodeType === "YieldExpression" || nodeType === "AwaitExpression" || nodeType === "Import" || nodeType === "BigIntLiteral" || nodeType === "ExportNamespaceSpecifier" || nodeType === "OptionalMemberExpression" || nodeType === "OptionalCallExpression" || nodeType === "ClassProperty" || nodeType === "ClassAccessorProperty" || nodeType === "ClassPrivateProperty" || nodeType === "ClassPrivateMethod" || nodeType === "PrivateName" || nodeType === "StaticBlock" || nodeType === "Placeholder" && (node2.expectedNode === "Identifier" || node2.expectedNode === "StringLiteral" || node2.expectedNode === "BlockStatement" || node2.expectedNode === "ClassBody")) {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExpression$4(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ArrayExpression" || nodeType === "AssignmentExpression" || nodeType === "BinaryExpression" || nodeType === "CallExpression" || nodeType === "ConditionalExpression" || nodeType === "FunctionExpression" || nodeType === "Identifier" || nodeType === "StringLiteral" || nodeType === "NumericLiteral" || nodeType === "NullLiteral" || nodeType === "BooleanLiteral" || nodeType === "RegExpLiteral" || nodeType === "LogicalExpression" || nodeType === "MemberExpression" || nodeType === "NewExpression" || nodeType === "ObjectExpression" || nodeType === "SequenceExpression" || nodeType === "ParenthesizedExpression" || nodeType === "ThisExpression" || nodeType === "UnaryExpression" || nodeType === "UpdateExpression" || nodeType === "ArrowFunctionExpression" || nodeType === "ClassExpression" || nodeType === "MetaProperty" || nodeType === "Super" || nodeType === "TaggedTemplateExpression" || nodeType === "TemplateLiteral" || nodeType === "YieldExpression" || nodeType === "AwaitExpression" || nodeType === "Import" || nodeType === "BigIntLiteral" || nodeType === "OptionalMemberExpression" || nodeType === "OptionalCallExpression" || nodeType === "TypeCastExpression" || nodeType === "JSXElement" || nodeType === "JSXFragment" || nodeType === "BindExpression" || nodeType === "DoExpression" || nodeType === "RecordExpression" || nodeType === "TupleExpression" || nodeType === "DecimalLiteral" || nodeType === "ModuleExpression" || nodeType === "TopicReference" || nodeType === "PipelineTopicExpression" || nodeType === "PipelineBareFunction" || nodeType === "PipelinePrimaryTopicReference" || nodeType === "TSAsExpression" || nodeType === "TSTypeAssertion" || nodeType === "TSNonNullExpression" || nodeType === "Placeholder" && (node2.expectedNode === "Expression" || node2.expectedNode === "Identifier" || node2.expectedNode === "StringLiteral")) {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBinary$3(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BinaryExpression" || nodeType === "LogicalExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isScopable(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BlockStatement" || nodeType === "CatchClause" || nodeType === "DoWhileStatement" || nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "Program" || nodeType === "ObjectMethod" || nodeType === "SwitchStatement" || nodeType === "WhileStatement" || nodeType === "ArrowFunctionExpression" || nodeType === "ClassExpression" || nodeType === "ClassDeclaration" || nodeType === "ForOfStatement" || nodeType === "ClassMethod" || nodeType === "ClassPrivateMethod" || nodeType === "StaticBlock" || nodeType === "TSModuleBlock" || nodeType === "Placeholder" && node2.expectedNode === "BlockStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBlockParent(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BlockStatement" || nodeType === "CatchClause" || nodeType === "DoWhileStatement" || nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "Program" || nodeType === "ObjectMethod" || nodeType === "SwitchStatement" || nodeType === "WhileStatement" || nodeType === "ArrowFunctionExpression" || nodeType === "ForOfStatement" || nodeType === "ClassMethod" || nodeType === "ClassPrivateMethod" || nodeType === "StaticBlock" || nodeType === "TSModuleBlock" || nodeType === "Placeholder" && node2.expectedNode === "BlockStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isBlock(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BlockStatement" || nodeType === "Program" || nodeType === "TSModuleBlock" || nodeType === "Placeholder" && node2.expectedNode === "BlockStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isStatement$7(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BlockStatement" || nodeType === "BreakStatement" || nodeType === "ContinueStatement" || nodeType === "DebuggerStatement" || nodeType === "DoWhileStatement" || nodeType === "EmptyStatement" || nodeType === "ExpressionStatement" || nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "FunctionDeclaration" || nodeType === "IfStatement" || nodeType === "LabeledStatement" || nodeType === "ReturnStatement" || nodeType === "SwitchStatement" || nodeType === "ThrowStatement" || nodeType === "TryStatement" || nodeType === "VariableDeclaration" || nodeType === "WhileStatement" || nodeType === "WithStatement" || nodeType === "ClassDeclaration" || nodeType === "ExportAllDeclaration" || nodeType === "ExportDefaultDeclaration" || nodeType === "ExportNamedDeclaration" || nodeType === "ForOfStatement" || nodeType === "ImportDeclaration" || nodeType === "DeclareClass" || nodeType === "DeclareFunction" || nodeType === "DeclareInterface" || nodeType === "DeclareModule" || nodeType === "DeclareModuleExports" || nodeType === "DeclareTypeAlias" || nodeType === "DeclareOpaqueType" || nodeType === "DeclareVariable" || nodeType === "DeclareExportDeclaration" || nodeType === "DeclareExportAllDeclaration" || nodeType === "InterfaceDeclaration" || nodeType === "OpaqueType" || nodeType === "TypeAlias" || nodeType === "EnumDeclaration" || nodeType === "TSDeclareFunction" || nodeType === "TSInterfaceDeclaration" || nodeType === "TSTypeAliasDeclaration" || nodeType === "TSEnumDeclaration" || nodeType === "TSModuleDeclaration" || nodeType === "TSImportEqualsDeclaration" || nodeType === "TSExportAssignment" || nodeType === "TSNamespaceExportDeclaration" || nodeType === "Placeholder" && (node2.expectedNode === "Statement" || node2.expectedNode === "Declaration" || node2.expectedNode === "BlockStatement")) {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTerminatorless(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BreakStatement" || nodeType === "ContinueStatement" || nodeType === "ReturnStatement" || nodeType === "ThrowStatement" || nodeType === "YieldExpression" || nodeType === "AwaitExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isCompletionStatement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "BreakStatement" || nodeType === "ContinueStatement" || nodeType === "ReturnStatement" || nodeType === "ThrowStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isConditional$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ConditionalExpression" || nodeType === "IfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isLoop$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DoWhileStatement" || nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "WhileStatement" || nodeType === "ForOfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isWhile(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DoWhileStatement" || nodeType === "WhileStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExpressionWrapper(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExpressionStatement" || nodeType === "ParenthesizedExpression" || nodeType === "TypeCastExpression") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFor$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ForInStatement" || nodeType === "ForStatement" || nodeType === "ForOfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isForXStatement$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ForInStatement" || nodeType === "ForOfStatement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunction$32(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "ObjectMethod" || nodeType === "ArrowFunctionExpression" || nodeType === "ClassMethod" || nodeType === "ClassPrivateMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFunctionParent(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "ObjectMethod" || nodeType === "ArrowFunctionExpression" || nodeType === "ClassMethod" || nodeType === "ClassPrivateMethod" || nodeType === "StaticBlock") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPureish$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionDeclaration" || nodeType === "FunctionExpression" || nodeType === "StringLiteral" || nodeType === "NumericLiteral" || nodeType === "NullLiteral" || nodeType === "BooleanLiteral" || nodeType === "RegExpLiteral" || nodeType === "ArrowFunctionExpression" || nodeType === "BigIntLiteral" || nodeType === "DecimalLiteral" || nodeType === "Placeholder" && node2.expectedNode === "StringLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isDeclaration$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "FunctionDeclaration" || nodeType === "VariableDeclaration" || nodeType === "ClassDeclaration" || nodeType === "ExportAllDeclaration" || nodeType === "ExportDefaultDeclaration" || nodeType === "ExportNamedDeclaration" || nodeType === "ImportDeclaration" || nodeType === "DeclareClass" || nodeType === "DeclareFunction" || nodeType === "DeclareInterface" || nodeType === "DeclareModule" || nodeType === "DeclareModuleExports" || nodeType === "DeclareTypeAlias" || nodeType === "DeclareOpaqueType" || nodeType === "DeclareVariable" || nodeType === "DeclareExportDeclaration" || nodeType === "DeclareExportAllDeclaration" || nodeType === "InterfaceDeclaration" || nodeType === "OpaqueType" || nodeType === "TypeAlias" || nodeType === "EnumDeclaration" || nodeType === "TSDeclareFunction" || nodeType === "TSInterfaceDeclaration" || nodeType === "TSTypeAliasDeclaration" || nodeType === "TSEnumDeclaration" || nodeType === "TSModuleDeclaration" || nodeType === "Placeholder" && node2.expectedNode === "Declaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPatternLike(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Identifier" || nodeType === "RestElement" || nodeType === "AssignmentPattern" || nodeType === "ArrayPattern" || nodeType === "ObjectPattern" || nodeType === "Placeholder" && (node2.expectedNode === "Pattern" || node2.expectedNode === "Identifier")) {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isLVal(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Identifier" || nodeType === "MemberExpression" || nodeType === "RestElement" || nodeType === "AssignmentPattern" || nodeType === "ArrayPattern" || nodeType === "ObjectPattern" || nodeType === "TSParameterProperty" || nodeType === "Placeholder" && (node2.expectedNode === "Pattern" || node2.expectedNode === "Identifier")) {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSEntityName(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Identifier" || nodeType === "TSQualifiedName" || nodeType === "Placeholder" && node2.expectedNode === "Identifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isLiteral$7(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "StringLiteral" || nodeType === "NumericLiteral" || nodeType === "NullLiteral" || nodeType === "BooleanLiteral" || nodeType === "RegExpLiteral" || nodeType === "TemplateLiteral" || nodeType === "BigIntLiteral" || nodeType === "DecimalLiteral" || nodeType === "Placeholder" && node2.expectedNode === "StringLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isUserWhitespacable(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectMethod" || nodeType === "ObjectProperty" || nodeType === "ObjectTypeInternalSlot" || nodeType === "ObjectTypeCallProperty" || nodeType === "ObjectTypeIndexer" || nodeType === "ObjectTypeProperty" || nodeType === "ObjectTypeSpreadProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isMethod$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectMethod" || nodeType === "ClassMethod" || nodeType === "ClassPrivateMethod") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isObjectMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectMethod" || nodeType === "ObjectProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isProperty$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ObjectProperty" || nodeType === "ClassProperty" || nodeType === "ClassAccessorProperty" || nodeType === "ClassPrivateProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isUnaryLike$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "UnaryExpression" || nodeType === "SpreadElement") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPattern2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AssignmentPattern" || nodeType === "ArrayPattern" || nodeType === "ObjectPattern" || nodeType === "Placeholder" && node2.expectedNode === "Pattern") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isClass$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassExpression" || nodeType === "ClassDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isModuleDeclaration$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportAllDeclaration" || nodeType === "ExportDefaultDeclaration" || nodeType === "ExportNamedDeclaration" || nodeType === "ImportDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isExportDeclaration$2(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportAllDeclaration" || nodeType === "ExportDefaultDeclaration" || nodeType === "ExportNamedDeclaration") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isModuleSpecifier$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ExportSpecifier" || nodeType === "ImportDefaultSpecifier" || nodeType === "ImportNamespaceSpecifier" || nodeType === "ImportSpecifier" || nodeType === "ExportNamespaceSpecifier" || nodeType === "ExportDefaultSpecifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isAccessor(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassAccessorProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isPrivate(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "ClassPrivateProperty" || nodeType === "ClassPrivateMethod" || nodeType === "PrivateName") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFlow$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AnyTypeAnnotation" || nodeType === "ArrayTypeAnnotation" || nodeType === "BooleanTypeAnnotation" || nodeType === "BooleanLiteralTypeAnnotation" || nodeType === "NullLiteralTypeAnnotation" || nodeType === "ClassImplements" || nodeType === "DeclareClass" || nodeType === "DeclareFunction" || nodeType === "DeclareInterface" || nodeType === "DeclareModule" || nodeType === "DeclareModuleExports" || nodeType === "DeclareTypeAlias" || nodeType === "DeclareOpaqueType" || nodeType === "DeclareVariable" || nodeType === "DeclareExportDeclaration" || nodeType === "DeclareExportAllDeclaration" || nodeType === "DeclaredPredicate" || nodeType === "ExistsTypeAnnotation" || nodeType === "FunctionTypeAnnotation" || nodeType === "FunctionTypeParam" || nodeType === "GenericTypeAnnotation" || nodeType === "InferredPredicate" || nodeType === "InterfaceExtends" || nodeType === "InterfaceDeclaration" || nodeType === "InterfaceTypeAnnotation" || nodeType === "IntersectionTypeAnnotation" || nodeType === "MixedTypeAnnotation" || nodeType === "EmptyTypeAnnotation" || nodeType === "NullableTypeAnnotation" || nodeType === "NumberLiteralTypeAnnotation" || nodeType === "NumberTypeAnnotation" || nodeType === "ObjectTypeAnnotation" || nodeType === "ObjectTypeInternalSlot" || nodeType === "ObjectTypeCallProperty" || nodeType === "ObjectTypeIndexer" || nodeType === "ObjectTypeProperty" || nodeType === "ObjectTypeSpreadProperty" || nodeType === "OpaqueType" || nodeType === "QualifiedTypeIdentifier" || nodeType === "StringLiteralTypeAnnotation" || nodeType === "StringTypeAnnotation" || nodeType === "SymbolTypeAnnotation" || nodeType === "ThisTypeAnnotation" || nodeType === "TupleTypeAnnotation" || nodeType === "TypeofTypeAnnotation" || nodeType === "TypeAlias" || nodeType === "TypeAnnotation" || nodeType === "TypeCastExpression" || nodeType === "TypeParameter" || nodeType === "TypeParameterDeclaration" || nodeType === "TypeParameterInstantiation" || nodeType === "UnionTypeAnnotation" || nodeType === "Variance" || nodeType === "VoidTypeAnnotation" || nodeType === "EnumDeclaration" || nodeType === "EnumBooleanBody" || nodeType === "EnumNumberBody" || nodeType === "EnumStringBody" || nodeType === "EnumSymbolBody" || nodeType === "EnumBooleanMember" || nodeType === "EnumNumberMember" || nodeType === "EnumStringMember" || nodeType === "EnumDefaultedMember" || nodeType === "IndexedAccessType" || nodeType === "OptionalIndexedAccessType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFlowType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AnyTypeAnnotation" || nodeType === "ArrayTypeAnnotation" || nodeType === "BooleanTypeAnnotation" || nodeType === "BooleanLiteralTypeAnnotation" || nodeType === "NullLiteralTypeAnnotation" || nodeType === "ExistsTypeAnnotation" || nodeType === "FunctionTypeAnnotation" || nodeType === "GenericTypeAnnotation" || nodeType === "InterfaceTypeAnnotation" || nodeType === "IntersectionTypeAnnotation" || nodeType === "MixedTypeAnnotation" || nodeType === "EmptyTypeAnnotation" || nodeType === "NullableTypeAnnotation" || nodeType === "NumberLiteralTypeAnnotation" || nodeType === "NumberTypeAnnotation" || nodeType === "ObjectTypeAnnotation" || nodeType === "StringLiteralTypeAnnotation" || nodeType === "StringTypeAnnotation" || nodeType === "SymbolTypeAnnotation" || nodeType === "ThisTypeAnnotation" || nodeType === "TupleTypeAnnotation" || nodeType === "TypeofTypeAnnotation" || nodeType === "UnionTypeAnnotation" || nodeType === "VoidTypeAnnotation" || nodeType === "IndexedAccessType" || nodeType === "OptionalIndexedAccessType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFlowBaseAnnotation$1(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "AnyTypeAnnotation" || nodeType === "BooleanTypeAnnotation" || nodeType === "NullLiteralTypeAnnotation" || nodeType === "MixedTypeAnnotation" || nodeType === "EmptyTypeAnnotation" || nodeType === "NumberTypeAnnotation" || nodeType === "StringTypeAnnotation" || nodeType === "SymbolTypeAnnotation" || nodeType === "ThisTypeAnnotation" || nodeType === "VoidTypeAnnotation") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFlowDeclaration(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclareClass" || nodeType === "DeclareFunction" || nodeType === "DeclareInterface" || nodeType === "DeclareModule" || nodeType === "DeclareModuleExports" || nodeType === "DeclareTypeAlias" || nodeType === "DeclareOpaqueType" || nodeType === "DeclareVariable" || nodeType === "DeclareExportDeclaration" || nodeType === "DeclareExportAllDeclaration" || nodeType === "InterfaceDeclaration" || nodeType === "OpaqueType" || nodeType === "TypeAlias") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isFlowPredicate(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "DeclaredPredicate" || nodeType === "InferredPredicate") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumBody(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumBooleanBody" || nodeType === "EnumNumberBody" || nodeType === "EnumStringBody" || nodeType === "EnumSymbolBody") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isEnumMember(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "EnumBooleanMember" || nodeType === "EnumNumberMember" || nodeType === "EnumStringMember" || nodeType === "EnumDefaultedMember") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isJSX(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "JSXAttribute" || nodeType === "JSXClosingElement" || nodeType === "JSXElement" || nodeType === "JSXEmptyExpression" || nodeType === "JSXExpressionContainer" || nodeType === "JSXSpreadChild" || nodeType === "JSXIdentifier" || nodeType === "JSXMemberExpression" || nodeType === "JSXNamespacedName" || nodeType === "JSXOpeningElement" || nodeType === "JSXSpreadAttribute" || nodeType === "JSXText" || nodeType === "JSXFragment" || nodeType === "JSXOpeningFragment" || nodeType === "JSXClosingFragment") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isMiscellaneous(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "Noop" || nodeType === "Placeholder" || nodeType === "V8IntrinsicIdentifier") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTypeScript(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSParameterProperty" || nodeType === "TSDeclareFunction" || nodeType === "TSDeclareMethod" || nodeType === "TSQualifiedName" || nodeType === "TSCallSignatureDeclaration" || nodeType === "TSConstructSignatureDeclaration" || nodeType === "TSPropertySignature" || nodeType === "TSMethodSignature" || nodeType === "TSIndexSignature" || nodeType === "TSAnyKeyword" || nodeType === "TSBooleanKeyword" || nodeType === "TSBigIntKeyword" || nodeType === "TSIntrinsicKeyword" || nodeType === "TSNeverKeyword" || nodeType === "TSNullKeyword" || nodeType === "TSNumberKeyword" || nodeType === "TSObjectKeyword" || nodeType === "TSStringKeyword" || nodeType === "TSSymbolKeyword" || nodeType === "TSUndefinedKeyword" || nodeType === "TSUnknownKeyword" || nodeType === "TSVoidKeyword" || nodeType === "TSThisType" || nodeType === "TSFunctionType" || nodeType === "TSConstructorType" || nodeType === "TSTypeReference" || nodeType === "TSTypePredicate" || nodeType === "TSTypeQuery" || nodeType === "TSTypeLiteral" || nodeType === "TSArrayType" || nodeType === "TSTupleType" || nodeType === "TSOptionalType" || nodeType === "TSRestType" || nodeType === "TSNamedTupleMember" || nodeType === "TSUnionType" || nodeType === "TSIntersectionType" || nodeType === "TSConditionalType" || nodeType === "TSInferType" || nodeType === "TSParenthesizedType" || nodeType === "TSTypeOperator" || nodeType === "TSIndexedAccessType" || nodeType === "TSMappedType" || nodeType === "TSLiteralType" || nodeType === "TSExpressionWithTypeArguments" || nodeType === "TSInterfaceDeclaration" || nodeType === "TSInterfaceBody" || nodeType === "TSTypeAliasDeclaration" || nodeType === "TSAsExpression" || nodeType === "TSTypeAssertion" || nodeType === "TSEnumDeclaration" || nodeType === "TSEnumMember" || nodeType === "TSModuleDeclaration" || nodeType === "TSModuleBlock" || nodeType === "TSImportType" || nodeType === "TSImportEqualsDeclaration" || nodeType === "TSExternalModuleReference" || nodeType === "TSNonNullExpression" || nodeType === "TSExportAssignment" || nodeType === "TSNamespaceExportDeclaration" || nodeType === "TSTypeAnnotation" || nodeType === "TSTypeParameterInstantiation" || nodeType === "TSTypeParameterDeclaration" || nodeType === "TSTypeParameter") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSTypeElement(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSCallSignatureDeclaration" || nodeType === "TSConstructSignatureDeclaration" || nodeType === "TSPropertySignature" || nodeType === "TSMethodSignature" || nodeType === "TSIndexSignature") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSAnyKeyword" || nodeType === "TSBooleanKeyword" || nodeType === "TSBigIntKeyword" || nodeType === "TSIntrinsicKeyword" || nodeType === "TSNeverKeyword" || nodeType === "TSNullKeyword" || nodeType === "TSNumberKeyword" || nodeType === "TSObjectKeyword" || nodeType === "TSStringKeyword" || nodeType === "TSSymbolKeyword" || nodeType === "TSUndefinedKeyword" || nodeType === "TSUnknownKeyword" || nodeType === "TSVoidKeyword" || nodeType === "TSThisType" || nodeType === "TSFunctionType" || nodeType === "TSConstructorType" || nodeType === "TSTypeReference" || nodeType === "TSTypePredicate" || nodeType === "TSTypeQuery" || nodeType === "TSTypeLiteral" || nodeType === "TSArrayType" || nodeType === "TSTupleType" || nodeType === "TSOptionalType" || nodeType === "TSRestType" || nodeType === "TSUnionType" || nodeType === "TSIntersectionType" || nodeType === "TSConditionalType" || nodeType === "TSInferType" || nodeType === "TSParenthesizedType" || nodeType === "TSTypeOperator" || nodeType === "TSIndexedAccessType" || nodeType === "TSMappedType" || nodeType === "TSLiteralType" || nodeType === "TSExpressionWithTypeArguments" || nodeType === "TSImportType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isTSBaseType(node2, opts) {
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "TSAnyKeyword" || nodeType === "TSBooleanKeyword" || nodeType === "TSBigIntKeyword" || nodeType === "TSIntrinsicKeyword" || nodeType === "TSNeverKeyword" || nodeType === "TSNullKeyword" || nodeType === "TSNumberKeyword" || nodeType === "TSObjectKeyword" || nodeType === "TSStringKeyword" || nodeType === "TSSymbolKeyword" || nodeType === "TSUndefinedKeyword" || nodeType === "TSUnknownKeyword" || nodeType === "TSVoidKeyword" || nodeType === "TSThisType" || nodeType === "TSLiteralType") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isNumberLiteral(node2, opts) {
      console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "NumberLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isRegexLiteral(node2, opts) {
      console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "RegexLiteral") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isRestProperty(node2, opts) {
      console.trace("The node type RestProperty has been renamed to RestElement");
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "RestProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function isSpreadProperty(node2, opts) {
      console.trace("The node type SpreadProperty has been renamed to SpreadElement");
      if (!node2)
        return false;
      var nodeType = node2.type;
      if (nodeType === "SpreadProperty") {
        if (typeof opts === "undefined") {
          return true;
        } else {
          return shallowEqual2(node2, opts);
        }
      }
      return false;
    }
    function matchesPattern$2(member, match, allowPartial) {
      if (!isMemberExpression$8(member))
        return false;
      var parts = Array.isArray(match) ? match : match.split(".");
      var nodes2 = [];
      var node2;
      for (node2 = member; isMemberExpression$8(node2); node2 = node2.object) {
        nodes2.push(node2.property);
      }
      nodes2.push(node2);
      if (nodes2.length < parts.length)
        return false;
      if (!allowPartial && nodes2.length > parts.length)
        return false;
      for (var i2 = 0, j = nodes2.length - 1; i2 < parts.length; i2++, j--) {
        var _node = nodes2[j];
        var value = void 0;
        if (isIdentifier$i(_node)) {
          value = _node.name;
        } else if (isStringLiteral$7(_node)) {
          value = _node.value;
        } else if (isThisExpression$2(_node)) {
          value = "this";
        } else {
          return false;
        }
        if (parts[i2] !== value)
          return false;
      }
      return true;
    }
    function buildMatchMemberExpression$1(match, allowPartial) {
      var parts = match.split(".");
      return function(member) {
        return matchesPattern$2(member, parts, allowPartial);
      };
    }
    var isReactComponent = buildMatchMemberExpression$1("React.Component");
    function isCompatTag$1(tagName) {
      return !!tagName && /^[a-z]/.test(tagName);
    }
    var commonjsGlobal$1 = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof commonjsGlobal !== "undefined" ? commonjsGlobal : typeof self !== "undefined" ? self : {};
    function getAugmentedNamespace(n2) {
      var f2 = n2.default;
      if (typeof f2 == "function") {
        var a = function() {
          return f2.apply(this, arguments);
        };
        a.prototype = f2.prototype;
      } else
        a = {};
      Object.defineProperty(a, "__esModule", { value: true });
      Object.keys(n2).forEach(function(k2) {
        var d2 = Object.getOwnPropertyDescriptor(n2, k2);
        Object.defineProperty(a, k2, d2.get ? d2 : {
          enumerable: true,
          get: function() {
            return n2[k2];
          }
        });
      });
      return a;
    }
    var fastProto = null;
    function FastObject(o) {
      if (fastProto !== null && typeof fastProto.property) {
        var result = fastProto;
        fastProto = FastObject.prototype = null;
        return result;
      }
      fastProto = FastObject.prototype = o == null ? /* @__PURE__ */ Object.create(null) : o;
      return new FastObject();
    }
    FastObject();
    var toFastProperties = function toFastproperties(o) {
      return FastObject(o);
    };
    var global$12 = typeof commonjsGlobal !== "undefined" ? commonjsGlobal : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};
    function defaultSetTimout() {
      throw new Error("setTimeout has not been defined");
    }
    function defaultClearTimeout() {
      throw new Error("clearTimeout has not been defined");
    }
    var cachedSetTimeout = defaultSetTimout;
    var cachedClearTimeout = defaultClearTimeout;
    if (typeof global$12.setTimeout === "function") {
      cachedSetTimeout = setTimeout;
    }
    if (typeof global$12.clearTimeout === "function") {
      cachedClearTimeout = clearTimeout;
    }
    function runTimeout(fun) {
      if (cachedSetTimeout === setTimeout) {
        return setTimeout(fun, 0);
      }
      if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
      }
      try {
        return cachedSetTimeout(fun, 0);
      } catch (e2) {
        try {
          return cachedSetTimeout.call(null, fun, 0);
        } catch (e3) {
          return cachedSetTimeout.call(this, fun, 0);
        }
      }
    }
    function runClearTimeout(marker) {
      if (cachedClearTimeout === clearTimeout) {
        return clearTimeout(marker);
      }
      if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
      }
      try {
        return cachedClearTimeout(marker);
      } catch (e2) {
        try {
          return cachedClearTimeout.call(null, marker);
        } catch (e3) {
          return cachedClearTimeout.call(this, marker);
        }
      }
    }
    var queue = [];
    var draining = false;
    var currentQueue;
    var queueIndex = -1;
    function cleanUpNextTick() {
      if (!draining || !currentQueue) {
        return;
      }
      draining = false;
      if (currentQueue.length) {
        queue = currentQueue.concat(queue);
      } else {
        queueIndex = -1;
      }
      if (queue.length) {
        drainQueue();
      }
    }
    function drainQueue() {
      if (draining) {
        return;
      }
      var timeout = runTimeout(cleanUpNextTick);
      draining = true;
      var len3 = queue.length;
      while (len3) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len3) {
          if (currentQueue) {
            currentQueue[queueIndex].run();
          }
        }
        queueIndex = -1;
        len3 = queue.length;
      }
      currentQueue = null;
      draining = false;
      runClearTimeout(timeout);
    }
    function nextTick(fun) {
      var args = new Array(arguments.length - 1);
      if (arguments.length > 1) {
        for (var i2 = 1; i2 < arguments.length; i2++) {
          args[i2 - 1] = arguments[i2];
        }
      }
      queue.push(new Item2(fun, args));
      if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
      }
    }
    function Item2(fun, array4) {
      this.fun = fun;
      this.array = array4;
    }
    Item2.prototype.run = function() {
      this.fun.apply(null, this.array);
    };
    var title = "browser";
    var platform2 = "browser";
    var browser$4 = true;
    var env$12 = {};
    var argv = [];
    var version$4 = "";
    var versions$2 = {};
    var release2 = {};
    var config$12 = {};
    function noop$2() {
    }
    var on = noop$2;
    var addListener = noop$2;
    var once = noop$2;
    var off = noop$2;
    var removeListener = noop$2;
    var removeAllListeners = noop$2;
    var emit$1 = noop$2;
    function binding(name2) {
      throw new Error("process.binding is not supported");
    }
    function cwd() {
      return "/";
    }
    function chdir(dir3) {
      throw new Error("process.chdir is not supported");
    }
    function umask() {
      return 0;
    }
    var performance2 = global$12.performance || {};
    var performanceNow = performance2.now || performance2.mozNow || performance2.msNow || performance2.oNow || performance2.webkitNow || function() {
      return new Date().getTime();
    };
    function hrtime(previousTimestamp) {
      var clocktime = performanceNow.call(performance2) * 1e-3;
      var seconds = Math.floor(clocktime);
      var nanoseconds = Math.floor(clocktime % 1 * 1e9);
      if (previousTimestamp) {
        seconds = seconds - previousTimestamp[0];
        nanoseconds = nanoseconds - previousTimestamp[1];
        if (nanoseconds < 0) {
          seconds--;
          nanoseconds += 1e9;
        }
      }
      return [seconds, nanoseconds];
    }
    var startTime = new Date();
    function uptime() {
      var currentTime = new Date();
      var dif = currentTime - startTime;
      return dif / 1e3;
    }
    var browser$1$1 = {
      nextTick,
      title,
      browser: browser$4,
      env: env$12,
      argv,
      version: version$4,
      versions: versions$2,
      on,
      addListener,
      once,
      off,
      removeListener,
      removeAllListeners,
      emit: emit$1,
      binding,
      cwd,
      chdir,
      umask,
      hrtime,
      platform: platform2,
      release: release2,
      config: config$12,
      uptime
    };
    function isType$2(nodeType, targetType) {
      if (nodeType === targetType)
        return true;
      if (ALIAS_KEYS[targetType])
        return false;
      var aliases = FLIPPED_ALIAS_KEYS$3[targetType];
      if (aliases) {
        if (aliases[0] === nodeType)
          return true;
        for (var _iterator2 = _createForOfIteratorHelperLoose(aliases), _step2; !(_step2 = _iterator2()).done; ) {
          var alias2 = _step2.value;
          if (nodeType === alias2)
            return true;
        }
      }
      return false;
    }
    function isPlaceholderType(placeholderType, targetType) {
      if (placeholderType === targetType)
        return true;
      var aliases = PLACEHOLDERS_ALIAS[placeholderType];
      if (aliases) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(aliases), _step2; !(_step2 = _iterator2()).done; ) {
          var alias2 = _step2.value;
          if (targetType === alias2)
            return true;
        }
      }
      return false;
    }
    function is$1(type5, node2, opts) {
      if (!node2)
        return false;
      var matches = isType$2(node2.type, type5);
      if (!matches) {
        if (!opts && node2.type === "Placeholder" && type5 in FLIPPED_ALIAS_KEYS$3) {
          return isPlaceholderType(node2.expectedNode, type5);
        }
        return false;
      }
      if (typeof opts === "undefined") {
        return true;
      } else {
        return shallowEqual2(node2, opts);
      }
    }
    var nonASCIIidentifierStartChars2 = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
    var nonASCIIidentifierChars2 = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
    var nonASCIIidentifierStart2 = new RegExp("[" + nonASCIIidentifierStartChars2 + "]");
    var nonASCIIidentifier2 = new RegExp("[" + nonASCIIidentifierStartChars2 + nonASCIIidentifierChars2 + "]");
    nonASCIIidentifierStartChars2 = nonASCIIidentifierChars2 = null;
    var astralIdentifierStartCodes2 = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
    var astralIdentifierCodes2 = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
    function isInAstralSet2(code3, set3) {
      var pos = 65536;
      for (var i2 = 0, length = set3.length; i2 < length; i2 += 2) {
        pos += set3[i2];
        if (pos > code3)
          return false;
        pos += set3[i2 + 1];
        if (pos >= code3)
          return true;
      }
      return false;
    }
    function isIdentifierStart2(code3) {
      if (code3 < 65)
        return code3 === 36;
      if (code3 <= 90)
        return true;
      if (code3 < 97)
        return code3 === 95;
      if (code3 <= 122)
        return true;
      if (code3 <= 65535) {
        return code3 >= 170 && nonASCIIidentifierStart2.test(String.fromCharCode(code3));
      }
      return isInAstralSet2(code3, astralIdentifierStartCodes2);
    }
    function isIdentifierChar2(code3) {
      if (code3 < 48)
        return code3 === 36;
      if (code3 < 58)
        return true;
      if (code3 < 65)
        return false;
      if (code3 <= 90)
        return true;
      if (code3 < 97)
        return code3 === 95;
      if (code3 <= 122)
        return true;
      if (code3 <= 65535) {
        return code3 >= 170 && nonASCIIidentifier2.test(String.fromCharCode(code3));
      }
      return isInAstralSet2(code3, astralIdentifierStartCodes2) || isInAstralSet2(code3, astralIdentifierCodes2);
    }
    function isIdentifierName(name2) {
      var isFirst = true;
      for (var i2 = 0; i2 < name2.length; i2++) {
        var cp = name2.charCodeAt(i2);
        if ((cp & 64512) === 55296 && i2 + 1 < name2.length) {
          var trail = name2.charCodeAt(++i2);
          if ((trail & 64512) === 56320) {
            cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
          }
        }
        if (isFirst) {
          isFirst = false;
          if (!isIdentifierStart2(cp)) {
            return false;
          }
        } else if (!isIdentifierChar2(cp)) {
          return false;
        }
      }
      return !isFirst;
    }
    var reservedWords2 = {
      keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
      strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
      strictBind: ["eval", "arguments"]
    };
    var keywords$12 = new Set(reservedWords2.keyword);
    var reservedWordsStrictSet = new Set(reservedWords2.strict);
    var reservedWordsStrictBindSet = new Set(reservedWords2.strictBind);
    function isReservedWord(word, inModule) {
      return inModule && word === "await" || word === "enum";
    }
    function isStrictReservedWord(word, inModule) {
      return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
    }
    function isStrictBindOnlyReservedWord(word) {
      return reservedWordsStrictBindSet.has(word);
    }
    function isStrictBindReservedWord(word, inModule) {
      return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
    }
    function isKeyword(word) {
      return keywords$12.has(word);
    }
    function isValidIdentifier$1(name2, reserved) {
      if (reserved === void 0) {
        reserved = true;
      }
      if (typeof name2 !== "string")
        return false;
      if (reserved) {
        if (isKeyword(name2) || isStrictReservedWord(name2, true)) {
          return false;
        }
      }
      return isIdentifierName(name2);
    }
    var STATEMENT_OR_BLOCK_KEYS$1 = ["consequent", "body", "alternate"];
    var FLATTENABLE_KEYS = ["body", "expressions"];
    var FOR_INIT_KEYS = ["left", "init"];
    var COMMENT_KEYS = ["leadingComments", "trailingComments", "innerComments"];
    var LOGICAL_OPERATORS$3 = ["||", "&&", "??"];
    var UPDATE_OPERATORS = ["++", "--"];
    var BOOLEAN_NUMBER_BINARY_OPERATORS$1 = [">", "<", ">=", "<="];
    var EQUALITY_BINARY_OPERATORS = ["==", "===", "!=", "!=="];
    var COMPARISON_BINARY_OPERATORS = [].concat(EQUALITY_BINARY_OPERATORS, ["in", "instanceof"]);
    var BOOLEAN_BINARY_OPERATORS$1 = [].concat(_toConsumableArray2(COMPARISON_BINARY_OPERATORS), BOOLEAN_NUMBER_BINARY_OPERATORS$1);
    var NUMBER_BINARY_OPERATORS$1 = ["-", "/", "%", "*", "**", "&", "|", ">>", ">>>", "<<", "^"];
    var BINARY_OPERATORS = ["+"].concat(NUMBER_BINARY_OPERATORS$1, _toConsumableArray2(BOOLEAN_BINARY_OPERATORS$1));
    var ASSIGNMENT_OPERATORS = ["=", "+="].concat(_toConsumableArray2(NUMBER_BINARY_OPERATORS$1.map(function(op) {
      return op + "=";
    })), _toConsumableArray2(LOGICAL_OPERATORS$3.map(function(op) {
      return op + "=";
    })));
    var BOOLEAN_UNARY_OPERATORS$1 = ["delete", "!"];
    var NUMBER_UNARY_OPERATORS$1 = ["+", "-", "~"];
    var STRING_UNARY_OPERATORS$1 = ["typeof"];
    var UNARY_OPERATORS = ["void", "throw"].concat(BOOLEAN_UNARY_OPERATORS$1, NUMBER_UNARY_OPERATORS$1, STRING_UNARY_OPERATORS$1);
    var INHERIT_KEYS = {
      optional: ["typeAnnotation", "typeParameters", "returnType"],
      force: ["start", "loc", "end"]
    };
    var BLOCK_SCOPED_SYMBOL = Symbol["for"]("var used to be block scoped");
    var NOT_LOCAL_BINDING$2 = Symbol["for"]("should not be considered a local binding");
    function validate$6(node2, key2, val) {
      if (!node2)
        return;
      var fields = NODE_FIELDS[node2.type];
      if (!fields)
        return;
      var field = fields[key2];
      validateField(node2, key2, val, field);
      validateChild(node2, key2, val);
    }
    function validateField(node2, key2, val, field) {
      if (!(field != null && field.validate))
        return;
      if (field.optional && val == null)
        return;
      field.validate(node2, key2, val);
    }
    function validateChild(node2, key2, val) {
      if (val == null)
        return;
      var validate2 = NODE_PARENT_VALIDATIONS[val.type];
      if (!validate2)
        return;
      validate2(node2, key2, val);
    }
    var VISITOR_KEYS$7 = {};
    var ALIAS_KEYS = {};
    var FLIPPED_ALIAS_KEYS$3 = {};
    var NODE_FIELDS = {};
    var BUILDER_KEYS = {};
    var DEPRECATED_KEYS$1 = {};
    var NODE_PARENT_VALIDATIONS = {};
    function getType$2(val) {
      if (Array.isArray(val)) {
        return "array";
      } else if (val === null) {
        return "null";
      } else {
        return typeof val;
      }
    }
    function validate$5(validate2) {
      return {
        validate: validate2
      };
    }
    function typeIs(typeName) {
      return typeof typeName === "string" ? assertNodeType(typeName) : assertNodeType.apply(void 0, _toConsumableArray2(typeName));
    }
    function validateType(typeName) {
      return validate$5(typeIs(typeName));
    }
    function validateOptional(validate2) {
      return {
        validate: validate2,
        optional: true
      };
    }
    function validateOptionalType(typeName) {
      return {
        validate: typeIs(typeName),
        optional: true
      };
    }
    function arrayOf(elementType) {
      return chain$1(assertValueType("array"), assertEach(elementType));
    }
    function arrayOfType(typeName) {
      return arrayOf(typeIs(typeName));
    }
    function validateArrayOfType(typeName) {
      return validate$5(arrayOfType(typeName));
    }
    function assertEach(callback) {
      function validator(node2, key2, val) {
        if (!Array.isArray(val))
          return;
        for (var i2 = 0; i2 < val.length; i2++) {
          var subkey = key2 + "[" + i2 + "]";
          var v22 = val[i2];
          callback(node2, subkey, v22);
          if (browser$1$1.env.BABEL_TYPES_8_BREAKING)
            validateChild(node2, subkey, v22);
        }
      }
      validator.each = callback;
      return validator;
    }
    function assertOneOf() {
      for (var _len = arguments.length, values = new Array(_len), _key = 0; _key < _len; _key++) {
        values[_key] = arguments[_key];
      }
      function validate2(node2, key2, val) {
        if (values.indexOf(val) < 0) {
          throw new TypeError("Property " + key2 + " expected value to be one of " + JSON.stringify(values) + " but got " + JSON.stringify(val));
        }
      }
      validate2.oneOf = values;
      return validate2;
    }
    function assertNodeType() {
      for (var _len2 = arguments.length, types3 = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        types3[_key2] = arguments[_key2];
      }
      function validate2(node2, key2, val) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(types3), _step2; !(_step2 = _iterator2()).done; ) {
          var type5 = _step2.value;
          if (is$1(type5, val)) {
            validateChild(node2, key2, val);
            return;
          }
        }
        throw new TypeError("Property " + key2 + " of " + node2.type + " expected node to be of a type " + JSON.stringify(types3) + " but instead got " + JSON.stringify(val == null ? void 0 : val.type));
      }
      validate2.oneOfNodeTypes = types3;
      return validate2;
    }
    function assertNodeOrValueType() {
      for (var _len3 = arguments.length, types3 = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        types3[_key3] = arguments[_key3];
      }
      function validate2(node2, key2, val) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(types3), _step2; !(_step2 = _iterator2()).done; ) {
          var type5 = _step2.value;
          if (getType$2(val) === type5 || is$1(type5, val)) {
            validateChild(node2, key2, val);
            return;
          }
        }
        throw new TypeError("Property " + key2 + " of " + node2.type + " expected node to be of a type " + JSON.stringify(types3) + " but instead got " + JSON.stringify(val == null ? void 0 : val.type));
      }
      validate2.oneOfNodeOrValueTypes = types3;
      return validate2;
    }
    function assertValueType(type5) {
      function validate2(node2, key2, val) {
        var valid = getType$2(val) === type5;
        if (!valid) {
          throw new TypeError("Property " + key2 + " expected type of " + type5 + " but got " + getType$2(val));
        }
      }
      validate2.type = type5;
      return validate2;
    }
    function assertShape(shape) {
      function validate2(node2, key2, val) {
        var errors = [];
        for (var _i3 = 0, _Object$keys3 = Object.keys(shape); _i3 < _Object$keys3.length; _i3++) {
          var property2 = _Object$keys3[_i3];
          try {
            validateField(node2, property2, val[property2], shape[property2]);
          } catch (error2) {
            if (error2 instanceof TypeError) {
              errors.push(error2.message);
              continue;
            }
            throw error2;
          }
        }
        if (errors.length) {
          throw new TypeError("Property " + key2 + " of " + node2.type + " expected to have the following:\n" + errors.join("\n"));
        }
      }
      validate2.shapeOf = shape;
      return validate2;
    }
    function assertOptionalChainStart() {
      function validate2(node2) {
        var _current2;
        var current2 = node2;
        while (node2) {
          var _current = current2, type5 = _current.type;
          if (type5 === "OptionalCallExpression") {
            if (current2.optional)
              return;
            current2 = current2.callee;
            continue;
          }
          if (type5 === "OptionalMemberExpression") {
            if (current2.optional)
              return;
            current2 = current2.object;
            continue;
          }
          break;
        }
        throw new TypeError("Non-optional " + node2.type + " must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from " + ((_current2 = current2) == null ? void 0 : _current2.type));
      }
      return validate2;
    }
    function chain$1() {
      for (var _len4 = arguments.length, fns = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        fns[_key4] = arguments[_key4];
      }
      function validate2() {
        for (var _iterator3 = _createForOfIteratorHelperLoose(fns), _step3; !(_step3 = _iterator3()).done; ) {
          var fn = _step3.value;
          fn.apply(void 0, arguments);
        }
      }
      validate2.chainOf = fns;
      if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
        throw new Error('An assertValueType("array") validator can only be followed by an assertEach(...) validator.');
      }
      return validate2;
    }
    var validTypeOpts = ["aliases", "builder", "deprecatedAlias", "fields", "inherits", "visitor", "validate"];
    var validFieldKeys = ["default", "optional", "validate"];
    function defineAliasedType() {
      for (var _len5 = arguments.length, aliases = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        aliases[_key5] = arguments[_key5];
      }
      return function(type5, opts) {
        var _defined2;
        if (opts === void 0) {
          opts = {};
        }
        var defined = opts.aliases;
        if (!defined) {
          var _store$opts$inherits$, _defined;
          if (opts.inherits)
            defined = (_store$opts$inherits$ = store[opts.inherits].aliases) == null ? void 0 : _store$opts$inherits$.slice();
          (_defined = defined) != null ? _defined : defined = [];
          opts.aliases = defined;
        }
        var additional = aliases.filter(function(a) {
          return !defined.includes(a);
        });
        (_defined2 = defined).unshift.apply(_defined2, _toConsumableArray2(additional));
        return defineType$5(type5, opts);
      };
    }
    function defineType$5(type5, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var inherits3 = opts.inherits && store[opts.inherits] || {};
      var fields = opts.fields;
      if (!fields) {
        fields = {};
        if (inherits3.fields) {
          var keys2 = Object.getOwnPropertyNames(inherits3.fields);
          for (var _iterator4 = _createForOfIteratorHelperLoose(keys2), _step4; !(_step4 = _iterator4()).done; ) {
            var _key6 = _step4.value;
            var field = inherits3.fields[_key6];
            var def = field["default"];
            if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
              throw new Error("field defaults can only be primitives or empty arrays currently");
            }
            fields[_key6] = {
              "default": Array.isArray(def) ? [] : def,
              optional: field.optional,
              validate: field.validate
            };
          }
        }
      }
      var visitor2 = opts.visitor || inherits3.visitor || [];
      var aliases = opts.aliases || inherits3.aliases || [];
      var builder2 = opts.builder || inherits3.builder || opts.visitor || [];
      for (var _i22 = 0, _Object$keys22 = Object.keys(opts); _i22 < _Object$keys22.length; _i22++) {
        var k2 = _Object$keys22[_i22];
        if (validTypeOpts.indexOf(k2) === -1) {
          throw new Error('Unknown type option "' + k2 + '" on ' + type5);
        }
      }
      if (opts.deprecatedAlias) {
        DEPRECATED_KEYS$1[opts.deprecatedAlias] = type5;
      }
      for (var _iterator5 = _createForOfIteratorHelperLoose(visitor2.concat(builder2)), _step5; !(_step5 = _iterator5()).done; ) {
        var _key8 = _step5.value;
        fields[_key8] = fields[_key8] || {};
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(fields); _i3 < _Object$keys3.length; _i3++) {
        var _key7 = _Object$keys3[_i3];
        var _field = fields[_key7];
        if (_field["default"] !== void 0 && builder2.indexOf(_key7) === -1) {
          _field.optional = true;
        }
        if (_field["default"] === void 0) {
          _field["default"] = null;
        } else if (!_field.validate && _field["default"] != null) {
          _field.validate = assertValueType(getType$2(_field["default"]));
        }
        for (var _i4 = 0, _Object$keys4 = Object.keys(_field); _i4 < _Object$keys4.length; _i4++) {
          var _k = _Object$keys4[_i4];
          if (validFieldKeys.indexOf(_k) === -1) {
            throw new Error('Unknown field key "' + _k + '" on ' + type5 + "." + _key7);
          }
        }
      }
      VISITOR_KEYS$7[type5] = opts.visitor = visitor2;
      BUILDER_KEYS[type5] = opts.builder = builder2;
      NODE_FIELDS[type5] = opts.fields = fields;
      ALIAS_KEYS[type5] = opts.aliases = aliases;
      aliases.forEach(function(alias2) {
        FLIPPED_ALIAS_KEYS$3[alias2] = FLIPPED_ALIAS_KEYS$3[alias2] || [];
        FLIPPED_ALIAS_KEYS$3[alias2].push(type5);
      });
      if (opts.validate) {
        NODE_PARENT_VALIDATIONS[type5] = opts.validate;
      }
      store[type5] = opts;
    }
    var store = {};
    var defineType$4 = defineAliasedType("Standardized");
    defineType$4("ArrayExpression", {
      fields: {
        elements: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "Expression", "SpreadElement"))),
          "default": !browser$1$1.env.BABEL_TYPES_8_BREAKING ? [] : void 0
        }
      },
      visitor: ["elements"],
      aliases: ["Expression"]
    });
    defineType$4("AssignmentExpression", {
      fields: {
        operator: {
          validate: function() {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
              return assertValueType("string");
            }
            var identifier2 = assertOneOf.apply(void 0, _toConsumableArray2(ASSIGNMENT_OPERATORS));
            var pattern5 = assertOneOf("=");
            return function(node2, key2, val) {
              var validator = is$1("Pattern", node2.left) ? pattern5 : identifier2;
              validator(node2, key2, val);
            };
          }()
        },
        left: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern")
        },
        right: {
          validate: assertNodeType("Expression")
        }
      },
      builder: ["operator", "left", "right"],
      visitor: ["left", "right"],
      aliases: ["Expression"]
    });
    defineType$4("BinaryExpression", {
      builder: ["operator", "left", "right"],
      fields: {
        operator: {
          validate: assertOneOf.apply(void 0, _toConsumableArray2(BINARY_OPERATORS))
        },
        left: {
          validate: function() {
            var expression2 = assertNodeType("Expression");
            var inOp = assertNodeType("Expression", "PrivateName");
            var validator = function validator2(node2, key2, val) {
              var validator3 = node2.operator === "in" ? inOp : expression2;
              validator3(node2, key2, val);
            };
            validator.oneOfNodeTypes = ["Expression", "PrivateName"];
            return validator;
          }()
        },
        right: {
          validate: assertNodeType("Expression")
        }
      },
      visitor: ["left", "right"],
      aliases: ["Binary", "Expression"]
    });
    defineType$4("InterpreterDirective", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      }
    });
    defineType$4("Directive", {
      visitor: ["value"],
      fields: {
        value: {
          validate: assertNodeType("DirectiveLiteral")
        }
      }
    });
    defineType$4("DirectiveLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      }
    });
    defineType$4("BlockStatement", {
      builder: ["body", "directives"],
      visitor: ["directives", "body"],
      fields: {
        directives: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
          "default": []
        },
        body: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
      },
      aliases: ["Scopable", "BlockParent", "Block", "Statement"]
    });
    defineType$4("BreakStatement", {
      visitor: ["label"],
      fields: {
        label: {
          validate: assertNodeType("Identifier"),
          optional: true
        }
      },
      aliases: ["Statement", "Terminatorless", "CompletionStatement"]
    });
    defineType$4("CallExpression", {
      visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
      builder: ["callee", "arguments"],
      aliases: ["Expression"],
      fields: Object.assign({
        callee: {
          validate: assertNodeType("Expression", "V8IntrinsicIdentifier")
        },
        arguments: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
        }
      }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
        optional: {
          validate: assertOneOf(true, false),
          optional: true
        }
      } : {}, {
        typeArguments: {
          validate: assertNodeType("TypeParameterInstantiation"),
          optional: true
        },
        typeParameters: {
          validate: assertNodeType("TSTypeParameterInstantiation"),
          optional: true
        }
      })
    });
    defineType$4("CatchClause", {
      visitor: ["param", "body"],
      fields: {
        param: {
          validate: assertNodeType("Identifier", "ArrayPattern", "ObjectPattern"),
          optional: true
        },
        body: {
          validate: assertNodeType("BlockStatement")
        }
      },
      aliases: ["Scopable", "BlockParent"]
    });
    defineType$4("ConditionalExpression", {
      visitor: ["test", "consequent", "alternate"],
      fields: {
        test: {
          validate: assertNodeType("Expression")
        },
        consequent: {
          validate: assertNodeType("Expression")
        },
        alternate: {
          validate: assertNodeType("Expression")
        }
      },
      aliases: ["Expression", "Conditional"]
    });
    defineType$4("ContinueStatement", {
      visitor: ["label"],
      fields: {
        label: {
          validate: assertNodeType("Identifier"),
          optional: true
        }
      },
      aliases: ["Statement", "Terminatorless", "CompletionStatement"]
    });
    defineType$4("DebuggerStatement", {
      aliases: ["Statement"]
    });
    defineType$4("DoWhileStatement", {
      visitor: ["test", "body"],
      fields: {
        test: {
          validate: assertNodeType("Expression")
        },
        body: {
          validate: assertNodeType("Statement")
        }
      },
      aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"]
    });
    defineType$4("EmptyStatement", {
      aliases: ["Statement"]
    });
    defineType$4("ExpressionStatement", {
      visitor: ["expression"],
      fields: {
        expression: {
          validate: assertNodeType("Expression")
        }
      },
      aliases: ["Statement", "ExpressionWrapper"]
    });
    defineType$4("File", {
      builder: ["program", "comments", "tokens"],
      visitor: ["program"],
      fields: {
        program: {
          validate: assertNodeType("Program")
        },
        comments: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? Object.assign(function() {
          }, {
            each: {
              oneOfNodeTypes: ["CommentBlock", "CommentLine"]
            }
          }) : assertEach(assertNodeType("CommentBlock", "CommentLine")),
          optional: true
        },
        tokens: {
          validate: assertEach(Object.assign(function() {
          }, {
            type: "any"
          })),
          optional: true
        }
      }
    });
    defineType$4("ForInStatement", {
      visitor: ["left", "right", "body"],
      aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
      fields: {
        left: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("VariableDeclaration", "LVal") : assertNodeType("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern")
        },
        right: {
          validate: assertNodeType("Expression")
        },
        body: {
          validate: assertNodeType("Statement")
        }
      }
    });
    defineType$4("ForStatement", {
      visitor: ["init", "test", "update", "body"],
      aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop"],
      fields: {
        init: {
          validate: assertNodeType("VariableDeclaration", "Expression"),
          optional: true
        },
        test: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        update: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        body: {
          validate: assertNodeType("Statement")
        }
      }
    });
    var functionCommon = {
      params: {
        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement")))
      },
      generator: {
        "default": false
      },
      async: {
        "default": false
      }
    };
    var functionTypeAnnotationCommon = {
      returnType: {
        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
        optional: true
      },
      typeParameters: {
        validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
        optional: true
      }
    };
    var functionDeclarationCommon = Object.assign({}, functionCommon, {
      declare: {
        validate: assertValueType("boolean"),
        optional: true
      },
      id: {
        validate: assertNodeType("Identifier"),
        optional: true
      }
    });
    defineType$4("FunctionDeclaration", {
      builder: ["id", "params", "body", "generator", "async"],
      visitor: ["id", "params", "body", "returnType", "typeParameters"],
      fields: Object.assign({}, functionDeclarationCommon, functionTypeAnnotationCommon, {
        body: {
          validate: assertNodeType("BlockStatement")
        }
      }),
      aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Statement", "Pureish", "Declaration"],
      validate: function() {
        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
          return function() {
          };
        var identifier2 = assertNodeType("Identifier");
        return function(parent, key2, node2) {
          if (!is$1("ExportDefaultDeclaration", parent)) {
            identifier2(node2, "id", node2.id);
          }
        };
      }()
    });
    defineType$4("FunctionExpression", {
      inherits: "FunctionDeclaration",
      aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
      fields: Object.assign({}, functionCommon, functionTypeAnnotationCommon, {
        id: {
          validate: assertNodeType("Identifier"),
          optional: true
        },
        body: {
          validate: assertNodeType("BlockStatement")
        }
      })
    });
    var patternLikeCommon = {
      typeAnnotation: {
        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
        optional: true
      },
      decorators: {
        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator")))
      }
    };
    defineType$4("Identifier", {
      builder: ["name"],
      visitor: ["typeAnnotation", "decorators"],
      aliases: ["Expression", "PatternLike", "LVal", "TSEntityName"],
      fields: Object.assign({}, patternLikeCommon, {
        name: {
          validate: chain$1(assertValueType("string"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (!isValidIdentifier$1(val, false)) {
              throw new TypeError('"' + val + '" is not a valid identifier name');
            }
          }, {
            type: "string"
          }))
        },
        optional: {
          validate: assertValueType("boolean"),
          optional: true
        }
      }),
      validate: function validate2(parent, key2, node2) {
        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
          return;
        var match = /\.(\w+)$/.exec(key2);
        if (!match)
          return;
        var _match = _slicedToArray$12(match, 2), parentKey = _match[1];
        var nonComp = {
          computed: false
        };
        if (parentKey === "property") {
          if (is$1("MemberExpression", parent, nonComp))
            return;
          if (is$1("OptionalMemberExpression", parent, nonComp))
            return;
        } else if (parentKey === "key") {
          if (is$1("Property", parent, nonComp))
            return;
          if (is$1("Method", parent, nonComp))
            return;
        } else if (parentKey === "exported") {
          if (is$1("ExportSpecifier", parent))
            return;
        } else if (parentKey === "imported") {
          if (is$1("ImportSpecifier", parent, {
            imported: node2
          }))
            return;
        } else if (parentKey === "meta") {
          if (is$1("MetaProperty", parent, {
            meta: node2
          }))
            return;
        }
        if ((isKeyword(node2.name) || isReservedWord(node2.name, false)) && node2.name !== "this") {
          throw new TypeError('"' + node2.name + '" is not a valid identifier');
        }
      }
    });
    defineType$4("IfStatement", {
      visitor: ["test", "consequent", "alternate"],
      aliases: ["Statement", "Conditional"],
      fields: {
        test: {
          validate: assertNodeType("Expression")
        },
        consequent: {
          validate: assertNodeType("Statement")
        },
        alternate: {
          optional: true,
          validate: assertNodeType("Statement")
        }
      }
    });
    defineType$4("LabeledStatement", {
      visitor: ["label", "body"],
      aliases: ["Statement"],
      fields: {
        label: {
          validate: assertNodeType("Identifier")
        },
        body: {
          validate: assertNodeType("Statement")
        }
      }
    });
    defineType$4("StringLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$4("NumericLiteral", {
      builder: ["value"],
      deprecatedAlias: "NumberLiteral",
      fields: {
        value: {
          validate: assertValueType("number")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$4("NullLiteral", {
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$4("BooleanLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("boolean")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$4("RegExpLiteral", {
      builder: ["pattern", "flags"],
      deprecatedAlias: "RegexLiteral",
      aliases: ["Expression", "Pureish", "Literal"],
      fields: {
        pattern: {
          validate: assertValueType("string")
        },
        flags: {
          validate: chain$1(assertValueType("string"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            var invalid = /[^gimsuy]/.exec(val);
            if (invalid) {
              throw new TypeError('"' + invalid[0] + '" is not a valid RegExp flag');
            }
          }, {
            type: "string"
          })),
          "default": ""
        }
      }
    });
    defineType$4("LogicalExpression", {
      builder: ["operator", "left", "right"],
      visitor: ["left", "right"],
      aliases: ["Binary", "Expression"],
      fields: {
        operator: {
          validate: assertOneOf.apply(void 0, _toConsumableArray2(LOGICAL_OPERATORS$3))
        },
        left: {
          validate: assertNodeType("Expression")
        },
        right: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("MemberExpression", {
      builder: ["object", "property", "computed"].concat(_toConsumableArray2(!browser$1$1.env.BABEL_TYPES_8_BREAKING ? ["optional"] : [])),
      visitor: ["object", "property"],
      aliases: ["Expression", "LVal"],
      fields: Object.assign({
        object: {
          validate: assertNodeType("Expression")
        },
        property: {
          validate: function() {
            var normal = assertNodeType("Identifier", "PrivateName");
            var computed = assertNodeType("Expression");
            var validator = function validator2(node2, key2, val) {
              var validator3 = node2.computed ? computed : normal;
              validator3(node2, key2, val);
            };
            validator.oneOfNodeTypes = ["Expression", "Identifier", "PrivateName"];
            return validator;
          }()
        },
        computed: {
          "default": false
        }
      }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
        optional: {
          validate: assertOneOf(true, false),
          optional: true
        }
      } : {})
    });
    defineType$4("NewExpression", {
      inherits: "CallExpression"
    });
    defineType$4("Program", {
      visitor: ["directives", "body"],
      builder: ["body", "directives", "sourceType", "interpreter"],
      fields: {
        sourceFile: {
          validate: assertValueType("string")
        },
        sourceType: {
          validate: assertOneOf("script", "module"),
          "default": "script"
        },
        interpreter: {
          validate: assertNodeType("InterpreterDirective"),
          "default": null,
          optional: true
        },
        directives: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
          "default": []
        },
        body: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
      },
      aliases: ["Scopable", "BlockParent", "Block"]
    });
    defineType$4("ObjectExpression", {
      visitor: ["properties"],
      aliases: ["Expression"],
      fields: {
        properties: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectMethod", "ObjectProperty", "SpreadElement")))
        }
      }
    });
    defineType$4("ObjectMethod", {
      builder: ["kind", "key", "params", "body", "computed", "generator", "async"],
      fields: Object.assign({}, functionCommon, functionTypeAnnotationCommon, {
        kind: Object.assign({
          validate: assertOneOf("method", "get", "set")
        }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
          "default": "method"
        } : {}),
        computed: {
          "default": false
        },
        key: {
          validate: function() {
            var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
            var computed = assertNodeType("Expression");
            var validator = function validator2(node2, key2, val) {
              var validator3 = node2.computed ? computed : normal;
              validator3(node2, key2, val);
            };
            validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral"];
            return validator;
          }()
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        body: {
          validate: assertNodeType("BlockStatement")
        }
      }),
      visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
      aliases: ["UserWhitespacable", "Function", "Scopable", "BlockParent", "FunctionParent", "Method", "ObjectMember"]
    });
    defineType$4("ObjectProperty", {
      builder: ["key", "value", "computed", "shorthand"].concat(_toConsumableArray2(!browser$1$1.env.BABEL_TYPES_8_BREAKING ? ["decorators"] : [])),
      fields: {
        computed: {
          "default": false
        },
        key: {
          validate: function() {
            var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
            var computed = assertNodeType("Expression");
            var validator = function validator2(node2, key2, val) {
              var validator3 = node2.computed ? computed : normal;
              validator3(node2, key2, val);
            };
            validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral"];
            return validator;
          }()
        },
        value: {
          validate: assertNodeType("Expression", "PatternLike")
        },
        shorthand: {
          validate: chain$1(assertValueType("boolean"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (val && node2.computed) {
              throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
            }
          }, {
            type: "boolean"
          }), function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (val && !is$1("Identifier", node2.key)) {
              throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
            }
          }),
          "default": false
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        }
      },
      visitor: ["key", "value", "decorators"],
      aliases: ["UserWhitespacable", "Property", "ObjectMember"],
      validate: function() {
        var pattern5 = assertNodeType("Identifier", "Pattern");
        var expression2 = assertNodeType("Expression");
        return function(parent, key2, node2) {
          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
            return;
          var validator = is$1("ObjectPattern", parent) ? pattern5 : expression2;
          validator(node2, "value", node2.value);
        };
      }()
    });
    defineType$4("RestElement", {
      visitor: ["argument", "typeAnnotation"],
      builder: ["argument"],
      aliases: ["LVal", "PatternLike"],
      deprecatedAlias: "RestProperty",
      fields: Object.assign({}, patternLikeCommon, {
        argument: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression")
        },
        optional: {
          validate: assertValueType("boolean"),
          optional: true
        }
      }),
      validate: function validate2(parent, key2) {
        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
          return;
        var match = /(\w+)\[(\d+)\]/.exec(key2);
        if (!match)
          throw new Error("Internal Babel error: malformed key.");
        var _match2 = _slicedToArray$12(match, 3), listKey = _match2[1], index3 = _match2[2];
        if (parent[listKey].length > index3 + 1) {
          throw new TypeError("RestElement must be last element of " + listKey);
        }
      }
    });
    defineType$4("ReturnStatement", {
      visitor: ["argument"],
      aliases: ["Statement", "Terminatorless", "CompletionStatement"],
      fields: {
        argument: {
          validate: assertNodeType("Expression"),
          optional: true
        }
      }
    });
    defineType$4("SequenceExpression", {
      visitor: ["expressions"],
      fields: {
        expressions: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression")))
        }
      },
      aliases: ["Expression"]
    });
    defineType$4("ParenthesizedExpression", {
      visitor: ["expression"],
      aliases: ["Expression", "ExpressionWrapper"],
      fields: {
        expression: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("SwitchCase", {
      visitor: ["test", "consequent"],
      fields: {
        test: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        consequent: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
      }
    });
    defineType$4("SwitchStatement", {
      visitor: ["discriminant", "cases"],
      aliases: ["Statement", "BlockParent", "Scopable"],
      fields: {
        discriminant: {
          validate: assertNodeType("Expression")
        },
        cases: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("SwitchCase")))
        }
      }
    });
    defineType$4("ThisExpression", {
      aliases: ["Expression"]
    });
    defineType$4("ThrowStatement", {
      visitor: ["argument"],
      aliases: ["Statement", "Terminatorless", "CompletionStatement"],
      fields: {
        argument: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("TryStatement", {
      visitor: ["block", "handler", "finalizer"],
      aliases: ["Statement"],
      fields: {
        block: {
          validate: chain$1(assertNodeType("BlockStatement"), Object.assign(function(node2) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (!node2.handler && !node2.finalizer) {
              throw new TypeError("TryStatement expects either a handler or finalizer, or both");
            }
          }, {
            oneOfNodeTypes: ["BlockStatement"]
          }))
        },
        handler: {
          optional: true,
          validate: assertNodeType("CatchClause")
        },
        finalizer: {
          optional: true,
          validate: assertNodeType("BlockStatement")
        }
      }
    });
    defineType$4("UnaryExpression", {
      builder: ["operator", "argument", "prefix"],
      fields: {
        prefix: {
          "default": true
        },
        argument: {
          validate: assertNodeType("Expression")
        },
        operator: {
          validate: assertOneOf.apply(void 0, _toConsumableArray2(UNARY_OPERATORS))
        }
      },
      visitor: ["argument"],
      aliases: ["UnaryLike", "Expression"]
    });
    defineType$4("UpdateExpression", {
      builder: ["operator", "argument", "prefix"],
      fields: {
        prefix: {
          "default": false
        },
        argument: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("Expression") : assertNodeType("Identifier", "MemberExpression")
        },
        operator: {
          validate: assertOneOf.apply(void 0, _toConsumableArray2(UPDATE_OPERATORS))
        }
      },
      visitor: ["argument"],
      aliases: ["Expression"]
    });
    defineType$4("VariableDeclaration", {
      builder: ["kind", "declarations"],
      visitor: ["declarations"],
      aliases: ["Statement", "Declaration"],
      fields: {
        declare: {
          validate: assertValueType("boolean"),
          optional: true
        },
        kind: {
          validate: assertOneOf("var", "let", "const")
        },
        declarations: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("VariableDeclarator")))
        }
      },
      validate: function validate2(parent, key2, node2) {
        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
          return;
        if (!is$1("ForXStatement", parent, {
          left: node2
        }))
          return;
        if (node2.declarations.length !== 1) {
          throw new TypeError("Exactly one VariableDeclarator is required in the VariableDeclaration of a " + parent.type);
        }
      }
    });
    defineType$4("VariableDeclarator", {
      visitor: ["id", "init"],
      fields: {
        id: {
          validate: function() {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
              return assertNodeType("LVal");
            }
            var normal = assertNodeType("Identifier", "ArrayPattern", "ObjectPattern");
            var without = assertNodeType("Identifier");
            return function(node2, key2, val) {
              var validator = node2.init ? normal : without;
              validator(node2, key2, val);
            };
          }()
        },
        definite: {
          optional: true,
          validate: assertValueType("boolean")
        },
        init: {
          optional: true,
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("WhileStatement", {
      visitor: ["test", "body"],
      aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"],
      fields: {
        test: {
          validate: assertNodeType("Expression")
        },
        body: {
          validate: assertNodeType("Statement")
        }
      }
    });
    defineType$4("WithStatement", {
      visitor: ["object", "body"],
      aliases: ["Statement"],
      fields: {
        object: {
          validate: assertNodeType("Expression")
        },
        body: {
          validate: assertNodeType("Statement")
        }
      }
    });
    defineType$4("AssignmentPattern", {
      visitor: ["left", "right", "decorators"],
      builder: ["left", "right"],
      aliases: ["Pattern", "PatternLike", "LVal"],
      fields: Object.assign({}, patternLikeCommon, {
        left: {
          validate: assertNodeType("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression")
        },
        right: {
          validate: assertNodeType("Expression")
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        }
      })
    });
    defineType$4("ArrayPattern", {
      visitor: ["elements", "typeAnnotation"],
      builder: ["elements"],
      aliases: ["Pattern", "PatternLike", "LVal"],
      fields: Object.assign({}, patternLikeCommon, {
        elements: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "PatternLike")))
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        optional: {
          validate: assertValueType("boolean"),
          optional: true
        }
      })
    });
    defineType$4("ArrowFunctionExpression", {
      builder: ["params", "body", "async"],
      visitor: ["params", "body", "returnType", "typeParameters"],
      aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
      fields: Object.assign({}, functionCommon, functionTypeAnnotationCommon, {
        expression: {
          validate: assertValueType("boolean")
        },
        body: {
          validate: assertNodeType("BlockStatement", "Expression")
        }
      })
    });
    defineType$4("ClassBody", {
      visitor: ["body"],
      fields: {
        body: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")))
        }
      }
    });
    defineType$4("ClassExpression", {
      builder: ["id", "superClass", "body", "decorators"],
      visitor: ["id", "body", "superClass", "mixins", "typeParameters", "superTypeParameters", "implements", "decorators"],
      aliases: ["Scopable", "Class", "Expression"],
      fields: {
        id: {
          validate: assertNodeType("Identifier"),
          optional: true
        },
        typeParameters: {
          validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
          optional: true
        },
        body: {
          validate: assertNodeType("ClassBody")
        },
        superClass: {
          optional: true,
          validate: assertNodeType("Expression")
        },
        superTypeParameters: {
          validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
          optional: true
        },
        "implements": {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        mixins: {
          validate: assertNodeType("InterfaceExtends"),
          optional: true
        }
      }
    });
    defineType$4("ClassDeclaration", {
      inherits: "ClassExpression",
      aliases: ["Scopable", "Class", "Statement", "Declaration"],
      fields: {
        id: {
          validate: assertNodeType("Identifier")
        },
        typeParameters: {
          validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
          optional: true
        },
        body: {
          validate: assertNodeType("ClassBody")
        },
        superClass: {
          optional: true,
          validate: assertNodeType("Expression")
        },
        superTypeParameters: {
          validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
          optional: true
        },
        "implements": {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        mixins: {
          validate: assertNodeType("InterfaceExtends"),
          optional: true
        },
        declare: {
          validate: assertValueType("boolean"),
          optional: true
        },
        "abstract": {
          validate: assertValueType("boolean"),
          optional: true
        }
      },
      validate: function() {
        var identifier2 = assertNodeType("Identifier");
        return function(parent, key2, node2) {
          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
            return;
          if (!is$1("ExportDefaultDeclaration", parent)) {
            identifier2(node2, "id", node2.id);
          }
        };
      }()
    });
    defineType$4("ExportAllDeclaration", {
      visitor: ["source"],
      aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
      fields: {
        source: {
          validate: assertNodeType("StringLiteral")
        },
        exportKind: validateOptional(assertOneOf("type", "value")),
        assertions: {
          optional: true,
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        }
      }
    });
    defineType$4("ExportDefaultDeclaration", {
      visitor: ["declaration"],
      aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
      fields: {
        declaration: {
          validate: assertNodeType("FunctionDeclaration", "TSDeclareFunction", "ClassDeclaration", "Expression")
        },
        exportKind: validateOptional(assertOneOf("value"))
      }
    });
    defineType$4("ExportNamedDeclaration", {
      visitor: ["declaration", "specifiers", "source"],
      aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
      fields: {
        declaration: {
          optional: true,
          validate: chain$1(assertNodeType("Declaration"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (val && node2.specifiers.length) {
              throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
            }
          }, {
            oneOfNodeTypes: ["Declaration"]
          }), function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (val && node2.source) {
              throw new TypeError("Cannot export a declaration from a source");
            }
          })
        },
        assertions: {
          optional: true,
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        specifiers: {
          "default": [],
          validate: chain$1(assertValueType("array"), assertEach(function() {
            var sourced = assertNodeType("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
            var sourceless = assertNodeType("ExportSpecifier");
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return sourced;
            return function(node2, key2, val) {
              var validator = node2.source ? sourced : sourceless;
              validator(node2, key2, val);
            };
          }()))
        },
        source: {
          validate: assertNodeType("StringLiteral"),
          optional: true
        },
        exportKind: validateOptional(assertOneOf("type", "value"))
      }
    });
    defineType$4("ExportSpecifier", {
      visitor: ["local", "exported"],
      aliases: ["ModuleSpecifier"],
      fields: {
        local: {
          validate: assertNodeType("Identifier")
        },
        exported: {
          validate: assertNodeType("Identifier", "StringLiteral")
        },
        exportKind: {
          validate: assertOneOf("type", "value"),
          optional: true
        }
      }
    });
    defineType$4("ForOfStatement", {
      visitor: ["left", "right", "body"],
      builder: ["left", "right", "body", "await"],
      aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
      fields: {
        left: {
          validate: function() {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
              return assertNodeType("VariableDeclaration", "LVal");
            }
            var declaration = assertNodeType("VariableDeclaration");
            var lval = assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern");
            return function(node2, key2, val) {
              if (is$1("VariableDeclaration", val)) {
                declaration(node2, key2, val);
              } else {
                lval(node2, key2, val);
              }
            };
          }()
        },
        right: {
          validate: assertNodeType("Expression")
        },
        body: {
          validate: assertNodeType("Statement")
        },
        "await": {
          "default": false
        }
      }
    });
    defineType$4("ImportDeclaration", {
      visitor: ["specifiers", "source"],
      aliases: ["Statement", "Declaration", "ModuleDeclaration"],
      fields: {
        assertions: {
          optional: true,
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        specifiers: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier")))
        },
        source: {
          validate: assertNodeType("StringLiteral")
        },
        importKind: {
          validate: assertOneOf("type", "typeof", "value"),
          optional: true
        }
      }
    });
    defineType$4("ImportDefaultSpecifier", {
      visitor: ["local"],
      aliases: ["ModuleSpecifier"],
      fields: {
        local: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    defineType$4("ImportNamespaceSpecifier", {
      visitor: ["local"],
      aliases: ["ModuleSpecifier"],
      fields: {
        local: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    defineType$4("ImportSpecifier", {
      visitor: ["local", "imported"],
      aliases: ["ModuleSpecifier"],
      fields: {
        local: {
          validate: assertNodeType("Identifier")
        },
        imported: {
          validate: assertNodeType("Identifier", "StringLiteral")
        },
        importKind: {
          validate: assertOneOf("type", "typeof", "value"),
          optional: true
        }
      }
    });
    defineType$4("MetaProperty", {
      visitor: ["meta", "property"],
      aliases: ["Expression"],
      fields: {
        meta: {
          validate: chain$1(assertNodeType("Identifier"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            var property2;
            switch (val.name) {
              case "function":
                property2 = "sent";
                break;
              case "new":
                property2 = "target";
                break;
              case "import":
                property2 = "meta";
                break;
            }
            if (!is$1("Identifier", node2.property, {
              name: property2
            })) {
              throw new TypeError("Unrecognised MetaProperty");
            }
          }, {
            oneOfNodeTypes: ["Identifier"]
          }))
        },
        property: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    var classMethodOrPropertyCommon = {
      "abstract": {
        validate: assertValueType("boolean"),
        optional: true
      },
      accessibility: {
        validate: assertOneOf("public", "private", "protected"),
        optional: true
      },
      "static": {
        "default": false
      },
      override: {
        "default": false
      },
      computed: {
        "default": false
      },
      optional: {
        validate: assertValueType("boolean"),
        optional: true
      },
      key: {
        validate: chain$1(function() {
          var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
          var computed = assertNodeType("Expression");
          return function(node2, key2, val) {
            var validator = node2.computed ? computed : normal;
            validator(node2, key2, val);
          };
        }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "Expression"))
      }
    };
    var classMethodOrDeclareMethodCommon = Object.assign({}, functionCommon, classMethodOrPropertyCommon, {
      params: {
        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement", "TSParameterProperty")))
      },
      kind: {
        validate: assertOneOf("get", "set", "method", "constructor"),
        "default": "method"
      },
      access: {
        validate: chain$1(assertValueType("string"), assertOneOf("public", "private", "protected")),
        optional: true
      },
      decorators: {
        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
        optional: true
      }
    });
    defineType$4("ClassMethod", {
      aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method"],
      builder: ["kind", "key", "params", "body", "computed", "static", "generator", "async"],
      visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
      fields: Object.assign({}, classMethodOrDeclareMethodCommon, functionTypeAnnotationCommon, {
        body: {
          validate: assertNodeType("BlockStatement")
        }
      })
    });
    defineType$4("ObjectPattern", {
      visitor: ["properties", "typeAnnotation", "decorators"],
      builder: ["properties"],
      aliases: ["Pattern", "PatternLike", "LVal"],
      fields: Object.assign({}, patternLikeCommon, {
        properties: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("RestElement", "ObjectProperty")))
        }
      })
    });
    defineType$4("SpreadElement", {
      visitor: ["argument"],
      aliases: ["UnaryLike"],
      deprecatedAlias: "SpreadProperty",
      fields: {
        argument: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("Super", {
      aliases: ["Expression"]
    });
    defineType$4("TaggedTemplateExpression", {
      visitor: ["tag", "quasi", "typeParameters"],
      builder: ["tag", "quasi"],
      aliases: ["Expression"],
      fields: {
        tag: {
          validate: assertNodeType("Expression")
        },
        quasi: {
          validate: assertNodeType("TemplateLiteral")
        },
        typeParameters: {
          validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
          optional: true
        }
      }
    });
    defineType$4("TemplateElement", {
      builder: ["value", "tail"],
      fields: {
        value: {
          validate: assertShape({
            raw: {
              validate: assertValueType("string")
            },
            cooked: {
              validate: assertValueType("string"),
              optional: true
            }
          })
        },
        tail: {
          "default": false
        }
      }
    });
    defineType$4("TemplateLiteral", {
      visitor: ["quasis", "expressions"],
      aliases: ["Expression", "Literal"],
      fields: {
        quasis: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TemplateElement")))
        },
        expressions: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "TSType")), function(node2, key2, val) {
            if (node2.quasis.length !== val.length + 1) {
              throw new TypeError("Number of " + node2.type + " quasis should be exactly one more than the number of expressions.\nExpected " + (val.length + 1) + " quasis but got " + node2.quasis.length);
            }
          })
        }
      }
    });
    defineType$4("YieldExpression", {
      builder: ["argument", "delegate"],
      visitor: ["argument"],
      aliases: ["Expression", "Terminatorless"],
      fields: {
        delegate: {
          validate: chain$1(assertValueType("boolean"), Object.assign(function(node2, key2, val) {
            if (!browser$1$1.env.BABEL_TYPES_8_BREAKING)
              return;
            if (val && !node2.argument) {
              throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
            }
          }, {
            type: "boolean"
          })),
          "default": false
        },
        argument: {
          optional: true,
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("AwaitExpression", {
      builder: ["argument"],
      visitor: ["argument"],
      aliases: ["Expression", "Terminatorless"],
      fields: {
        argument: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$4("Import", {
      aliases: ["Expression"]
    });
    defineType$4("BigIntLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$4("ExportNamespaceSpecifier", {
      visitor: ["exported"],
      aliases: ["ModuleSpecifier"],
      fields: {
        exported: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    defineType$4("OptionalMemberExpression", {
      builder: ["object", "property", "computed", "optional"],
      visitor: ["object", "property"],
      aliases: ["Expression"],
      fields: {
        object: {
          validate: assertNodeType("Expression")
        },
        property: {
          validate: function() {
            var normal = assertNodeType("Identifier");
            var computed = assertNodeType("Expression");
            var validator = function validator2(node2, key2, val) {
              var validator3 = node2.computed ? computed : normal;
              validator3(node2, key2, val);
            };
            validator.oneOfNodeTypes = ["Expression", "Identifier"];
            return validator;
          }()
        },
        computed: {
          "default": false
        },
        optional: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
        }
      }
    });
    defineType$4("OptionalCallExpression", {
      visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
      builder: ["callee", "arguments", "optional"],
      aliases: ["Expression"],
      fields: {
        callee: {
          validate: assertNodeType("Expression")
        },
        arguments: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
        },
        optional: {
          validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
        },
        typeArguments: {
          validate: assertNodeType("TypeParameterInstantiation"),
          optional: true
        },
        typeParameters: {
          validate: assertNodeType("TSTypeParameterInstantiation"),
          optional: true
        }
      }
    });
    defineType$4("ClassProperty", {
      visitor: ["key", "value", "typeAnnotation", "decorators"],
      builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
      aliases: ["Property"],
      fields: Object.assign({}, classMethodOrPropertyCommon, {
        value: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        definite: {
          validate: assertValueType("boolean"),
          optional: true
        },
        typeAnnotation: {
          validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        readonly: {
          validate: assertValueType("boolean"),
          optional: true
        },
        declare: {
          validate: assertValueType("boolean"),
          optional: true
        },
        variance: {
          validate: assertNodeType("Variance"),
          optional: true
        }
      })
    });
    defineType$4("ClassAccessorProperty", {
      visitor: ["key", "value", "typeAnnotation", "decorators"],
      builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
      aliases: ["Property", "Accessor"],
      fields: Object.assign({}, classMethodOrPropertyCommon, {
        key: {
          validate: chain$1(function() {
            var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "PrivateName");
            var computed = assertNodeType("Expression");
            return function(node2, key2, val) {
              var validator = node2.computed ? computed : normal;
              validator(node2, key2, val);
            };
          }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "Expression", "PrivateName"))
        },
        value: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        definite: {
          validate: assertValueType("boolean"),
          optional: true
        },
        typeAnnotation: {
          validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        readonly: {
          validate: assertValueType("boolean"),
          optional: true
        },
        declare: {
          validate: assertValueType("boolean"),
          optional: true
        },
        variance: {
          validate: assertNodeType("Variance"),
          optional: true
        }
      })
    });
    defineType$4("ClassPrivateProperty", {
      visitor: ["key", "value", "decorators", "typeAnnotation"],
      builder: ["key", "value", "decorators", "static"],
      aliases: ["Property", "Private"],
      fields: {
        key: {
          validate: assertNodeType("PrivateName")
        },
        value: {
          validate: assertNodeType("Expression"),
          optional: true
        },
        typeAnnotation: {
          validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        },
        readonly: {
          validate: assertValueType("boolean"),
          optional: true
        },
        definite: {
          validate: assertValueType("boolean"),
          optional: true
        },
        variance: {
          validate: assertNodeType("Variance"),
          optional: true
        }
      }
    });
    defineType$4("ClassPrivateMethod", {
      builder: ["kind", "key", "params", "body", "static"],
      visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
      aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method", "Private"],
      fields: Object.assign({}, classMethodOrDeclareMethodCommon, functionTypeAnnotationCommon, {
        key: {
          validate: assertNodeType("PrivateName")
        },
        body: {
          validate: assertNodeType("BlockStatement")
        }
      })
    });
    defineType$4("PrivateName", {
      visitor: ["id"],
      aliases: ["Private"],
      fields: {
        id: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    defineType$4("StaticBlock", {
      visitor: ["body"],
      fields: {
        body: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
      },
      aliases: ["Scopable", "BlockParent", "FunctionParent"]
    });
    var defineType$3 = defineAliasedType("Flow");
    var defineInterfaceishType = function defineInterfaceishType2(name2, typeParameterType) {
      if (typeParameterType === void 0) {
        typeParameterType = "TypeParameterDeclaration";
      }
      defineType$3(name2, {
        builder: ["id", "typeParameters", "extends", "body"],
        visitor: ["id", "typeParameters", "extends", "mixins", "implements", "body"],
        aliases: ["FlowDeclaration", "Statement", "Declaration"],
        fields: {
          id: validateType("Identifier"),
          typeParameters: validateOptionalType(typeParameterType),
          "extends": validateOptional(arrayOfType("InterfaceExtends")),
          mixins: validateOptional(arrayOfType("InterfaceExtends")),
          "implements": validateOptional(arrayOfType("ClassImplements")),
          body: validateType("ObjectTypeAnnotation")
        }
      });
    };
    defineType$3("AnyTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("ArrayTypeAnnotation", {
      visitor: ["elementType"],
      aliases: ["FlowType"],
      fields: {
        elementType: validateType("FlowType")
      }
    });
    defineType$3("BooleanTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("BooleanLiteralTypeAnnotation", {
      builder: ["value"],
      aliases: ["FlowType"],
      fields: {
        value: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("NullLiteralTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("ClassImplements", {
      visitor: ["id", "typeParameters"],
      fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
      }
    });
    defineInterfaceishType("DeclareClass");
    defineType$3("DeclareFunction", {
      visitor: ["id"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier"),
        predicate: validateOptionalType("DeclaredPredicate")
      }
    });
    defineInterfaceishType("DeclareInterface");
    defineType$3("DeclareModule", {
      builder: ["id", "body", "kind"],
      visitor: ["id", "body"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType(["Identifier", "StringLiteral"]),
        body: validateType("BlockStatement"),
        kind: validateOptional(assertOneOf("CommonJS", "ES"))
      }
    });
    defineType$3("DeclareModuleExports", {
      visitor: ["typeAnnotation"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        typeAnnotation: validateType("TypeAnnotation")
      }
    });
    defineType$3("DeclareTypeAlias", {
      visitor: ["id", "typeParameters", "right"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        right: validateType("FlowType")
      }
    });
    defineType$3("DeclareOpaqueType", {
      visitor: ["id", "typeParameters", "supertype"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        supertype: validateOptionalType("FlowType"),
        impltype: validateOptionalType("FlowType")
      }
    });
    defineType$3("DeclareVariable", {
      visitor: ["id"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier")
      }
    });
    defineType$3("DeclareExportDeclaration", {
      visitor: ["declaration", "specifiers", "source"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        declaration: validateOptionalType("Flow"),
        specifiers: validateOptional(arrayOfType(["ExportSpecifier", "ExportNamespaceSpecifier"])),
        source: validateOptionalType("StringLiteral"),
        "default": validateOptional(assertValueType("boolean"))
      }
    });
    defineType$3("DeclareExportAllDeclaration", {
      visitor: ["source"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        source: validateType("StringLiteral"),
        exportKind: validateOptional(assertOneOf("type", "value"))
      }
    });
    defineType$3("DeclaredPredicate", {
      visitor: ["value"],
      aliases: ["FlowPredicate"],
      fields: {
        value: validateType("Flow")
      }
    });
    defineType$3("ExistsTypeAnnotation", {
      aliases: ["FlowType"]
    });
    defineType$3("FunctionTypeAnnotation", {
      visitor: ["typeParameters", "params", "rest", "returnType"],
      aliases: ["FlowType"],
      fields: {
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        params: validate$5(arrayOfType("FunctionTypeParam")),
        rest: validateOptionalType("FunctionTypeParam"),
        "this": validateOptionalType("FunctionTypeParam"),
        returnType: validateType("FlowType")
      }
    });
    defineType$3("FunctionTypeParam", {
      visitor: ["name", "typeAnnotation"],
      fields: {
        name: validateOptionalType("Identifier"),
        typeAnnotation: validateType("FlowType"),
        optional: validateOptional(assertValueType("boolean"))
      }
    });
    defineType$3("GenericTypeAnnotation", {
      visitor: ["id", "typeParameters"],
      aliases: ["FlowType"],
      fields: {
        id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
      }
    });
    defineType$3("InferredPredicate", {
      aliases: ["FlowPredicate"]
    });
    defineType$3("InterfaceExtends", {
      visitor: ["id", "typeParameters"],
      fields: {
        id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
      }
    });
    defineInterfaceishType("InterfaceDeclaration");
    defineType$3("InterfaceTypeAnnotation", {
      visitor: ["extends", "body"],
      aliases: ["FlowType"],
      fields: {
        "extends": validateOptional(arrayOfType("InterfaceExtends")),
        body: validateType("ObjectTypeAnnotation")
      }
    });
    defineType$3("IntersectionTypeAnnotation", {
      visitor: ["types"],
      aliases: ["FlowType"],
      fields: {
        types: validate$5(arrayOfType("FlowType"))
      }
    });
    defineType$3("MixedTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("EmptyTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("NullableTypeAnnotation", {
      visitor: ["typeAnnotation"],
      aliases: ["FlowType"],
      fields: {
        typeAnnotation: validateType("FlowType")
      }
    });
    defineType$3("NumberLiteralTypeAnnotation", {
      builder: ["value"],
      aliases: ["FlowType"],
      fields: {
        value: validate$5(assertValueType("number"))
      }
    });
    defineType$3("NumberTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("ObjectTypeAnnotation", {
      visitor: ["properties", "indexers", "callProperties", "internalSlots"],
      aliases: ["FlowType"],
      builder: ["properties", "indexers", "callProperties", "internalSlots", "exact"],
      fields: {
        properties: validate$5(arrayOfType(["ObjectTypeProperty", "ObjectTypeSpreadProperty"])),
        indexers: {
          validate: arrayOfType("ObjectTypeIndexer"),
          optional: true,
          "default": void 0
        },
        callProperties: {
          validate: arrayOfType("ObjectTypeCallProperty"),
          optional: true,
          "default": void 0
        },
        internalSlots: {
          validate: arrayOfType("ObjectTypeInternalSlot"),
          optional: true,
          "default": void 0
        },
        exact: {
          validate: assertValueType("boolean"),
          "default": false
        },
        inexact: validateOptional(assertValueType("boolean"))
      }
    });
    defineType$3("ObjectTypeInternalSlot", {
      visitor: ["id", "value", "optional", "static", "method"],
      aliases: ["UserWhitespacable"],
      fields: {
        id: validateType("Identifier"),
        value: validateType("FlowType"),
        optional: validate$5(assertValueType("boolean")),
        "static": validate$5(assertValueType("boolean")),
        method: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("ObjectTypeCallProperty", {
      visitor: ["value"],
      aliases: ["UserWhitespacable"],
      fields: {
        value: validateType("FlowType"),
        "static": validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("ObjectTypeIndexer", {
      visitor: ["id", "key", "value", "variance"],
      aliases: ["UserWhitespacable"],
      fields: {
        id: validateOptionalType("Identifier"),
        key: validateType("FlowType"),
        value: validateType("FlowType"),
        "static": validate$5(assertValueType("boolean")),
        variance: validateOptionalType("Variance")
      }
    });
    defineType$3("ObjectTypeProperty", {
      visitor: ["key", "value", "variance"],
      aliases: ["UserWhitespacable"],
      fields: {
        key: validateType(["Identifier", "StringLiteral"]),
        value: validateType("FlowType"),
        kind: validate$5(assertOneOf("init", "get", "set")),
        "static": validate$5(assertValueType("boolean")),
        proto: validate$5(assertValueType("boolean")),
        optional: validate$5(assertValueType("boolean")),
        variance: validateOptionalType("Variance"),
        method: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("ObjectTypeSpreadProperty", {
      visitor: ["argument"],
      aliases: ["UserWhitespacable"],
      fields: {
        argument: validateType("FlowType")
      }
    });
    defineType$3("OpaqueType", {
      visitor: ["id", "typeParameters", "supertype", "impltype"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        supertype: validateOptionalType("FlowType"),
        impltype: validateType("FlowType")
      }
    });
    defineType$3("QualifiedTypeIdentifier", {
      visitor: ["id", "qualification"],
      fields: {
        id: validateType("Identifier"),
        qualification: validateType(["Identifier", "QualifiedTypeIdentifier"])
      }
    });
    defineType$3("StringLiteralTypeAnnotation", {
      builder: ["value"],
      aliases: ["FlowType"],
      fields: {
        value: validate$5(assertValueType("string"))
      }
    });
    defineType$3("StringTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("SymbolTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("ThisTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("TupleTypeAnnotation", {
      visitor: ["types"],
      aliases: ["FlowType"],
      fields: {
        types: validate$5(arrayOfType("FlowType"))
      }
    });
    defineType$3("TypeofTypeAnnotation", {
      visitor: ["argument"],
      aliases: ["FlowType"],
      fields: {
        argument: validateType("FlowType")
      }
    });
    defineType$3("TypeAlias", {
      visitor: ["id", "typeParameters", "right"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        right: validateType("FlowType")
      }
    });
    defineType$3("TypeAnnotation", {
      visitor: ["typeAnnotation"],
      fields: {
        typeAnnotation: validateType("FlowType")
      }
    });
    defineType$3("TypeCastExpression", {
      visitor: ["expression", "typeAnnotation"],
      aliases: ["ExpressionWrapper", "Expression"],
      fields: {
        expression: validateType("Expression"),
        typeAnnotation: validateType("TypeAnnotation")
      }
    });
    defineType$3("TypeParameter", {
      visitor: ["bound", "default", "variance"],
      fields: {
        name: validate$5(assertValueType("string")),
        bound: validateOptionalType("TypeAnnotation"),
        "default": validateOptionalType("FlowType"),
        variance: validateOptionalType("Variance")
      }
    });
    defineType$3("TypeParameterDeclaration", {
      visitor: ["params"],
      fields: {
        params: validate$5(arrayOfType("TypeParameter"))
      }
    });
    defineType$3("TypeParameterInstantiation", {
      visitor: ["params"],
      fields: {
        params: validate$5(arrayOfType("FlowType"))
      }
    });
    defineType$3("UnionTypeAnnotation", {
      visitor: ["types"],
      aliases: ["FlowType"],
      fields: {
        types: validate$5(arrayOfType("FlowType"))
      }
    });
    defineType$3("Variance", {
      builder: ["kind"],
      fields: {
        kind: validate$5(assertOneOf("minus", "plus"))
      }
    });
    defineType$3("VoidTypeAnnotation", {
      aliases: ["FlowType", "FlowBaseAnnotation"]
    });
    defineType$3("EnumDeclaration", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "body"],
      fields: {
        id: validateType("Identifier"),
        body: validateType(["EnumBooleanBody", "EnumNumberBody", "EnumStringBody", "EnumSymbolBody"])
      }
    });
    defineType$3("EnumBooleanBody", {
      aliases: ["EnumBody"],
      visitor: ["members"],
      fields: {
        explicitType: validate$5(assertValueType("boolean")),
        members: validateArrayOfType("EnumBooleanMember"),
        hasUnknownMembers: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("EnumNumberBody", {
      aliases: ["EnumBody"],
      visitor: ["members"],
      fields: {
        explicitType: validate$5(assertValueType("boolean")),
        members: validateArrayOfType("EnumNumberMember"),
        hasUnknownMembers: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("EnumStringBody", {
      aliases: ["EnumBody"],
      visitor: ["members"],
      fields: {
        explicitType: validate$5(assertValueType("boolean")),
        members: validateArrayOfType(["EnumStringMember", "EnumDefaultedMember"]),
        hasUnknownMembers: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("EnumSymbolBody", {
      aliases: ["EnumBody"],
      visitor: ["members"],
      fields: {
        members: validateArrayOfType("EnumDefaultedMember"),
        hasUnknownMembers: validate$5(assertValueType("boolean"))
      }
    });
    defineType$3("EnumBooleanMember", {
      aliases: ["EnumMember"],
      visitor: ["id"],
      fields: {
        id: validateType("Identifier"),
        init: validateType("BooleanLiteral")
      }
    });
    defineType$3("EnumNumberMember", {
      aliases: ["EnumMember"],
      visitor: ["id", "init"],
      fields: {
        id: validateType("Identifier"),
        init: validateType("NumericLiteral")
      }
    });
    defineType$3("EnumStringMember", {
      aliases: ["EnumMember"],
      visitor: ["id", "init"],
      fields: {
        id: validateType("Identifier"),
        init: validateType("StringLiteral")
      }
    });
    defineType$3("EnumDefaultedMember", {
      aliases: ["EnumMember"],
      visitor: ["id"],
      fields: {
        id: validateType("Identifier")
      }
    });
    defineType$3("IndexedAccessType", {
      visitor: ["objectType", "indexType"],
      aliases: ["FlowType"],
      fields: {
        objectType: validateType("FlowType"),
        indexType: validateType("FlowType")
      }
    });
    defineType$3("OptionalIndexedAccessType", {
      visitor: ["objectType", "indexType"],
      aliases: ["FlowType"],
      fields: {
        objectType: validateType("FlowType"),
        indexType: validateType("FlowType"),
        optional: validate$5(assertValueType("boolean"))
      }
    });
    var defineType$2 = defineAliasedType("JSX");
    defineType$2("JSXAttribute", {
      visitor: ["name", "value"],
      aliases: ["Immutable"],
      fields: {
        name: {
          validate: assertNodeType("JSXIdentifier", "JSXNamespacedName")
        },
        value: {
          optional: true,
          validate: assertNodeType("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
        }
      }
    });
    defineType$2("JSXClosingElement", {
      visitor: ["name"],
      aliases: ["Immutable"],
      fields: {
        name: {
          validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
        }
      }
    });
    defineType$2("JSXElement", {
      builder: ["openingElement", "closingElement", "children", "selfClosing"],
      visitor: ["openingElement", "children", "closingElement"],
      aliases: ["Immutable", "Expression"],
      fields: Object.assign({
        openingElement: {
          validate: assertNodeType("JSXOpeningElement")
        },
        closingElement: {
          optional: true,
          validate: assertNodeType("JSXClosingElement")
        },
        children: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
        }
      }, {
        selfClosing: {
          validate: assertValueType("boolean"),
          optional: true
        }
      })
    });
    defineType$2("JSXEmptyExpression", {});
    defineType$2("JSXExpressionContainer", {
      visitor: ["expression"],
      aliases: ["Immutable"],
      fields: {
        expression: {
          validate: assertNodeType("Expression", "JSXEmptyExpression")
        }
      }
    });
    defineType$2("JSXSpreadChild", {
      visitor: ["expression"],
      aliases: ["Immutable"],
      fields: {
        expression: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$2("JSXIdentifier", {
      builder: ["name"],
      fields: {
        name: {
          validate: assertValueType("string")
        }
      }
    });
    defineType$2("JSXMemberExpression", {
      visitor: ["object", "property"],
      fields: {
        object: {
          validate: assertNodeType("JSXMemberExpression", "JSXIdentifier")
        },
        property: {
          validate: assertNodeType("JSXIdentifier")
        }
      }
    });
    defineType$2("JSXNamespacedName", {
      visitor: ["namespace", "name"],
      fields: {
        namespace: {
          validate: assertNodeType("JSXIdentifier")
        },
        name: {
          validate: assertNodeType("JSXIdentifier")
        }
      }
    });
    defineType$2("JSXOpeningElement", {
      builder: ["name", "attributes", "selfClosing"],
      visitor: ["name", "attributes"],
      aliases: ["Immutable"],
      fields: {
        name: {
          validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
        },
        selfClosing: {
          "default": false
        },
        attributes: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXAttribute", "JSXSpreadAttribute")))
        },
        typeParameters: {
          validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
          optional: true
        }
      }
    });
    defineType$2("JSXSpreadAttribute", {
      visitor: ["argument"],
      fields: {
        argument: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$2("JSXText", {
      aliases: ["Immutable"],
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      }
    });
    defineType$2("JSXFragment", {
      builder: ["openingFragment", "closingFragment", "children"],
      visitor: ["openingFragment", "children", "closingFragment"],
      aliases: ["Immutable", "Expression"],
      fields: {
        openingFragment: {
          validate: assertNodeType("JSXOpeningFragment")
        },
        closingFragment: {
          validate: assertNodeType("JSXClosingFragment")
        },
        children: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
        }
      }
    });
    defineType$2("JSXOpeningFragment", {
      aliases: ["Immutable"]
    });
    defineType$2("JSXClosingFragment", {
      aliases: ["Immutable"]
    });
    var PLACEHOLDERS = ["Identifier", "StringLiteral", "Expression", "Statement", "Declaration", "BlockStatement", "ClassBody", "Pattern"];
    var PLACEHOLDERS_ALIAS = {
      Declaration: ["Statement"],
      Pattern: ["PatternLike", "LVal"]
    };
    for (var _i$3 = 0, _PLACEHOLDERS = PLACEHOLDERS; _i$3 < _PLACEHOLDERS.length; _i$3++) {
      var type$12 = _PLACEHOLDERS[_i$3];
      var alias = ALIAS_KEYS[type$12];
      if (alias != null && alias.length)
        PLACEHOLDERS_ALIAS[type$12] = alias;
    }
    var PLACEHOLDERS_FLIPPED_ALIAS = {};
    Object.keys(PLACEHOLDERS_ALIAS).forEach(function(type5) {
      PLACEHOLDERS_ALIAS[type5].forEach(function(alias2) {
        if (!Object.hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias2)) {
          PLACEHOLDERS_FLIPPED_ALIAS[alias2] = [];
        }
        PLACEHOLDERS_FLIPPED_ALIAS[alias2].push(type5);
      });
    });
    var defineType$1 = defineAliasedType("Miscellaneous");
    {
      defineType$1("Noop", {
        visitor: []
      });
    }
    defineType$1("Placeholder", {
      visitor: [],
      builder: ["expectedNode", "name"],
      fields: {
        name: {
          validate: assertNodeType("Identifier")
        },
        expectedNode: {
          validate: assertOneOf.apply(void 0, _toConsumableArray2(PLACEHOLDERS))
        }
      }
    });
    defineType$1("V8IntrinsicIdentifier", {
      builder: ["name"],
      fields: {
        name: {
          validate: assertValueType("string")
        }
      }
    });
    defineType$5("ArgumentPlaceholder", {});
    defineType$5("BindExpression", {
      visitor: ["object", "callee"],
      aliases: ["Expression"],
      fields: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
        object: {
          validate: Object.assign(function() {
          }, {
            oneOfNodeTypes: ["Expression"]
          })
        },
        callee: {
          validate: Object.assign(function() {
          }, {
            oneOfNodeTypes: ["Expression"]
          })
        }
      } : {
        object: {
          validate: assertNodeType("Expression")
        },
        callee: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$5("ImportAttribute", {
      visitor: ["key", "value"],
      fields: {
        key: {
          validate: assertNodeType("Identifier", "StringLiteral")
        },
        value: {
          validate: assertNodeType("StringLiteral")
        }
      }
    });
    defineType$5("Decorator", {
      visitor: ["expression"],
      fields: {
        expression: {
          validate: assertNodeType("Expression")
        }
      }
    });
    defineType$5("DoExpression", {
      visitor: ["body"],
      builder: ["body", "async"],
      aliases: ["Expression"],
      fields: {
        body: {
          validate: assertNodeType("BlockStatement")
        },
        async: {
          validate: assertValueType("boolean"),
          "default": false
        }
      }
    });
    defineType$5("ExportDefaultSpecifier", {
      visitor: ["exported"],
      aliases: ["ModuleSpecifier"],
      fields: {
        exported: {
          validate: assertNodeType("Identifier")
        }
      }
    });
    defineType$5("RecordExpression", {
      visitor: ["properties"],
      aliases: ["Expression"],
      fields: {
        properties: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectProperty", "SpreadElement")))
        }
      }
    });
    defineType$5("TupleExpression", {
      fields: {
        elements: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement"))),
          "default": []
        }
      },
      visitor: ["elements"],
      aliases: ["Expression"]
    });
    defineType$5("DecimalLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: assertValueType("string")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
    defineType$5("ModuleExpression", {
      visitor: ["body"],
      fields: {
        body: {
          validate: assertNodeType("Program")
        }
      },
      aliases: ["Expression"]
    });
    defineType$5("TopicReference", {
      aliases: ["Expression"]
    });
    defineType$5("PipelineTopicExpression", {
      builder: ["expression"],
      visitor: ["expression"],
      fields: {
        expression: {
          validate: assertNodeType("Expression")
        }
      },
      aliases: ["Expression"]
    });
    defineType$5("PipelineBareFunction", {
      builder: ["callee"],
      visitor: ["callee"],
      fields: {
        callee: {
          validate: assertNodeType("Expression")
        }
      },
      aliases: ["Expression"]
    });
    defineType$5("PipelinePrimaryTopicReference", {
      aliases: ["Expression"]
    });
    var _signatureDeclaration;
    var defineType = defineAliasedType("TypeScript");
    var bool = assertValueType("boolean");
    var tSFunctionTypeAnnotationCommon = {
      returnType: {
        validate: assertNodeType("TSTypeAnnotation", "Noop"),
        optional: true
      },
      typeParameters: {
        validate: assertNodeType("TSTypeParameterDeclaration", "Noop"),
        optional: true
      }
    };
    defineType("TSParameterProperty", {
      aliases: ["LVal"],
      visitor: ["parameter"],
      fields: {
        accessibility: {
          validate: assertOneOf("public", "private", "protected"),
          optional: true
        },
        readonly: {
          validate: assertValueType("boolean"),
          optional: true
        },
        parameter: {
          validate: assertNodeType("Identifier", "AssignmentPattern")
        },
        override: {
          validate: assertValueType("boolean"),
          optional: true
        },
        decorators: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
          optional: true
        }
      }
    });
    defineType("TSDeclareFunction", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "typeParameters", "params", "returnType"],
      fields: Object.assign({}, functionDeclarationCommon, tSFunctionTypeAnnotationCommon)
    });
    defineType("TSDeclareMethod", {
      visitor: ["decorators", "key", "typeParameters", "params", "returnType"],
      fields: Object.assign({}, classMethodOrDeclareMethodCommon, tSFunctionTypeAnnotationCommon)
    });
    defineType("TSQualifiedName", {
      aliases: ["TSEntityName"],
      visitor: ["left", "right"],
      fields: {
        left: validateType("TSEntityName"),
        right: validateType("Identifier")
      }
    });
    var signatureDeclarationCommon = (_signatureDeclaration = {
      typeParameters: validateOptionalType("TSTypeParameterDeclaration")
    }, _signatureDeclaration["parameters"] = validateArrayOfType(["Identifier", "RestElement"]), _signatureDeclaration["typeAnnotation"] = validateOptionalType("TSTypeAnnotation"), _signatureDeclaration);
    var callConstructSignatureDeclaration = {
      aliases: ["TSTypeElement"],
      visitor: ["typeParameters", "parameters", "typeAnnotation"],
      fields: signatureDeclarationCommon
    };
    defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
    defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
    var namedTypeElementCommon = {
      key: validateType("Expression"),
      computed: validate$5(bool),
      optional: validateOptional(bool)
    };
    defineType("TSPropertySignature", {
      aliases: ["TSTypeElement"],
      visitor: ["key", "typeAnnotation", "initializer"],
      fields: Object.assign({}, namedTypeElementCommon, {
        readonly: validateOptional(bool),
        typeAnnotation: validateOptionalType("TSTypeAnnotation"),
        initializer: validateOptionalType("Expression"),
        kind: {
          validate: assertOneOf("get", "set")
        }
      })
    });
    defineType("TSMethodSignature", {
      aliases: ["TSTypeElement"],
      visitor: ["key", "typeParameters", "parameters", "typeAnnotation"],
      fields: Object.assign({}, signatureDeclarationCommon, namedTypeElementCommon, {
        kind: {
          validate: assertOneOf("method", "get", "set")
        }
      })
    });
    defineType("TSIndexSignature", {
      aliases: ["TSTypeElement"],
      visitor: ["parameters", "typeAnnotation"],
      fields: {
        readonly: validateOptional(bool),
        "static": validateOptional(bool),
        parameters: validateArrayOfType("Identifier"),
        typeAnnotation: validateOptionalType("TSTypeAnnotation")
      }
    });
    var tsKeywordTypes = ["TSAnyKeyword", "TSBooleanKeyword", "TSBigIntKeyword", "TSIntrinsicKeyword", "TSNeverKeyword", "TSNullKeyword", "TSNumberKeyword", "TSObjectKeyword", "TSStringKeyword", "TSSymbolKeyword", "TSUndefinedKeyword", "TSUnknownKeyword", "TSVoidKeyword"];
    for (var _i$2 = 0, _tsKeywordTypes = tsKeywordTypes; _i$2 < _tsKeywordTypes.length; _i$2++) {
      var type4 = _tsKeywordTypes[_i$2];
      defineType(type4, {
        aliases: ["TSType", "TSBaseType"],
        visitor: [],
        fields: {}
      });
    }
    defineType("TSThisType", {
      aliases: ["TSType", "TSBaseType"],
      visitor: [],
      fields: {}
    });
    var fnOrCtrBase = {
      aliases: ["TSType"],
      visitor: ["typeParameters", "parameters", "typeAnnotation"]
    };
    defineType("TSFunctionType", Object.assign({}, fnOrCtrBase, {
      fields: signatureDeclarationCommon
    }));
    defineType("TSConstructorType", Object.assign({}, fnOrCtrBase, {
      fields: Object.assign({}, signatureDeclarationCommon, {
        "abstract": validateOptional(bool)
      })
    }));
    defineType("TSTypeReference", {
      aliases: ["TSType"],
      visitor: ["typeName", "typeParameters"],
      fields: {
        typeName: validateType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
      }
    });
    defineType("TSTypePredicate", {
      aliases: ["TSType"],
      visitor: ["parameterName", "typeAnnotation"],
      builder: ["parameterName", "typeAnnotation", "asserts"],
      fields: {
        parameterName: validateType(["Identifier", "TSThisType"]),
        typeAnnotation: validateOptionalType("TSTypeAnnotation"),
        asserts: validateOptional(bool)
      }
    });
    defineType("TSTypeQuery", {
      aliases: ["TSType"],
      visitor: ["exprName"],
      fields: {
        exprName: validateType(["TSEntityName", "TSImportType"])
      }
    });
    defineType("TSTypeLiteral", {
      aliases: ["TSType"],
      visitor: ["members"],
      fields: {
        members: validateArrayOfType("TSTypeElement")
      }
    });
    defineType("TSArrayType", {
      aliases: ["TSType"],
      visitor: ["elementType"],
      fields: {
        elementType: validateType("TSType")
      }
    });
    defineType("TSTupleType", {
      aliases: ["TSType"],
      visitor: ["elementTypes"],
      fields: {
        elementTypes: validateArrayOfType(["TSType", "TSNamedTupleMember"])
      }
    });
    defineType("TSOptionalType", {
      aliases: ["TSType"],
      visitor: ["typeAnnotation"],
      fields: {
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSRestType", {
      aliases: ["TSType"],
      visitor: ["typeAnnotation"],
      fields: {
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSNamedTupleMember", {
      visitor: ["label", "elementType"],
      builder: ["label", "elementType", "optional"],
      fields: {
        label: validateType("Identifier"),
        optional: {
          validate: bool,
          "default": false
        },
        elementType: validateType("TSType")
      }
    });
    var unionOrIntersection = {
      aliases: ["TSType"],
      visitor: ["types"],
      fields: {
        types: validateArrayOfType("TSType")
      }
    };
    defineType("TSUnionType", unionOrIntersection);
    defineType("TSIntersectionType", unionOrIntersection);
    defineType("TSConditionalType", {
      aliases: ["TSType"],
      visitor: ["checkType", "extendsType", "trueType", "falseType"],
      fields: {
        checkType: validateType("TSType"),
        extendsType: validateType("TSType"),
        trueType: validateType("TSType"),
        falseType: validateType("TSType")
      }
    });
    defineType("TSInferType", {
      aliases: ["TSType"],
      visitor: ["typeParameter"],
      fields: {
        typeParameter: validateType("TSTypeParameter")
      }
    });
    defineType("TSParenthesizedType", {
      aliases: ["TSType"],
      visitor: ["typeAnnotation"],
      fields: {
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSTypeOperator", {
      aliases: ["TSType"],
      visitor: ["typeAnnotation"],
      fields: {
        operator: validate$5(assertValueType("string")),
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSIndexedAccessType", {
      aliases: ["TSType"],
      visitor: ["objectType", "indexType"],
      fields: {
        objectType: validateType("TSType"),
        indexType: validateType("TSType")
      }
    });
    defineType("TSMappedType", {
      aliases: ["TSType"],
      visitor: ["typeParameter", "typeAnnotation", "nameType"],
      fields: {
        readonly: validateOptional(bool),
        typeParameter: validateType("TSTypeParameter"),
        optional: validateOptional(bool),
        typeAnnotation: validateOptionalType("TSType"),
        nameType: validateOptionalType("TSType")
      }
    });
    defineType("TSLiteralType", {
      aliases: ["TSType", "TSBaseType"],
      visitor: ["literal"],
      fields: {
        literal: {
          validate: function() {
            var unaryExpression2 = assertNodeType("NumericLiteral", "BigIntLiteral");
            var unaryOperator = assertOneOf("-");
            var literal2 = assertNodeType("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral");
            function validator(parent, key2, node2) {
              if (is$1("UnaryExpression", node2)) {
                unaryOperator(node2, "operator", node2.operator);
                unaryExpression2(node2, "argument", node2.argument);
              } else {
                literal2(parent, key2, node2);
              }
            }
            validator.oneOfNodeTypes = ["NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "UnaryExpression"];
            return validator;
          }()
        }
      }
    });
    defineType("TSExpressionWithTypeArguments", {
      aliases: ["TSType"],
      visitor: ["expression", "typeParameters"],
      fields: {
        expression: validateType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
      }
    });
    defineType("TSInterfaceDeclaration", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "typeParameters", "extends", "body"],
      fields: {
        declare: validateOptional(bool),
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
        "extends": validateOptional(arrayOfType("TSExpressionWithTypeArguments")),
        body: validateType("TSInterfaceBody")
      }
    });
    defineType("TSInterfaceBody", {
      visitor: ["body"],
      fields: {
        body: validateArrayOfType("TSTypeElement")
      }
    });
    defineType("TSTypeAliasDeclaration", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "typeParameters", "typeAnnotation"],
      fields: {
        declare: validateOptional(bool),
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSAsExpression", {
      aliases: ["Expression"],
      visitor: ["expression", "typeAnnotation"],
      fields: {
        expression: validateType("Expression"),
        typeAnnotation: validateType("TSType")
      }
    });
    defineType("TSTypeAssertion", {
      aliases: ["Expression"],
      visitor: ["typeAnnotation", "expression"],
      fields: {
        typeAnnotation: validateType("TSType"),
        expression: validateType("Expression")
      }
    });
    defineType("TSEnumDeclaration", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "members"],
      fields: {
        declare: validateOptional(bool),
        "const": validateOptional(bool),
        id: validateType("Identifier"),
        members: validateArrayOfType("TSEnumMember"),
        initializer: validateOptionalType("Expression")
      }
    });
    defineType("TSEnumMember", {
      visitor: ["id", "initializer"],
      fields: {
        id: validateType(["Identifier", "StringLiteral"]),
        initializer: validateOptionalType("Expression")
      }
    });
    defineType("TSModuleDeclaration", {
      aliases: ["Statement", "Declaration"],
      visitor: ["id", "body"],
      fields: {
        declare: validateOptional(bool),
        global: validateOptional(bool),
        id: validateType(["Identifier", "StringLiteral"]),
        body: validateType(["TSModuleBlock", "TSModuleDeclaration"])
      }
    });
    defineType("TSModuleBlock", {
      aliases: ["Scopable", "Block", "BlockParent"],
      visitor: ["body"],
      fields: {
        body: validateArrayOfType("Statement")
      }
    });
    defineType("TSImportType", {
      aliases: ["TSType"],
      visitor: ["argument", "qualifier", "typeParameters"],
      fields: {
        argument: validateType("StringLiteral"),
        qualifier: validateOptionalType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
      }
    });
    defineType("TSImportEqualsDeclaration", {
      aliases: ["Statement"],
      visitor: ["id", "moduleReference"],
      fields: {
        isExport: validate$5(bool),
        id: validateType("Identifier"),
        moduleReference: validateType(["TSEntityName", "TSExternalModuleReference"]),
        importKind: {
          validate: assertOneOf("type", "value"),
          optional: true
        }
      }
    });
    defineType("TSExternalModuleReference", {
      visitor: ["expression"],
      fields: {
        expression: validateType("StringLiteral")
      }
    });
    defineType("TSNonNullExpression", {
      aliases: ["Expression"],
      visitor: ["expression"],
      fields: {
        expression: validateType("Expression")
      }
    });
    defineType("TSExportAssignment", {
      aliases: ["Statement"],
      visitor: ["expression"],
      fields: {
        expression: validateType("Expression")
      }
    });
    defineType("TSNamespaceExportDeclaration", {
      aliases: ["Statement"],
      visitor: ["id"],
      fields: {
        id: validateType("Identifier")
      }
    });
    defineType("TSTypeAnnotation", {
      visitor: ["typeAnnotation"],
      fields: {
        typeAnnotation: {
          validate: assertNodeType("TSType")
        }
      }
    });
    defineType("TSTypeParameterInstantiation", {
      visitor: ["params"],
      fields: {
        params: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSType")))
        }
      }
    });
    defineType("TSTypeParameterDeclaration", {
      visitor: ["params"],
      fields: {
        params: {
          validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSTypeParameter")))
        }
      }
    });
    defineType("TSTypeParameter", {
      builder: ["constraint", "default", "name"],
      visitor: ["constraint", "default"],
      fields: {
        name: {
          validate: assertValueType("string")
        },
        constraint: {
          validate: assertNodeType("TSType"),
          optional: true
        },
        "default": {
          validate: assertNodeType("TSType"),
          optional: true
        }
      }
    });
    toFastProperties(VISITOR_KEYS$7);
    toFastProperties(ALIAS_KEYS);
    toFastProperties(FLIPPED_ALIAS_KEYS$3);
    toFastProperties(NODE_FIELDS);
    toFastProperties(BUILDER_KEYS);
    toFastProperties(DEPRECATED_KEYS$1);
    toFastProperties(PLACEHOLDERS_ALIAS);
    toFastProperties(PLACEHOLDERS_FLIPPED_ALIAS);
    var TYPES$1 = [].concat(Object.keys(VISITOR_KEYS$7), Object.keys(FLIPPED_ALIAS_KEYS$3), Object.keys(DEPRECATED_KEYS$1));
    function builder() {
      var type5 = this;
      var keys2 = BUILDER_KEYS[type5];
      var countArgs = arguments.length;
      if (countArgs > keys2.length) {
        throw new Error(type5 + ": Too many arguments passed. Received " + countArgs + " but can receive no more than " + keys2.length);
      }
      var node2 = {
        type: type5
      };
      for (var i2 = 0; i2 < keys2.length; ++i2) {
        var key2 = keys2[i2];
        var field = NODE_FIELDS[type5][key2];
        var arg = void 0;
        if (i2 < countArgs)
          arg = arguments[i2];
        if (arg === void 0) {
          arg = Array.isArray(field["default"]) ? [] : field["default"];
        }
        node2[key2] = arg;
      }
      for (var _key in node2) {
        validate$6(node2, _key, node2[_key]);
      }
      return node2;
    }
    function arrayExpression$2(elements) {
      return builder.apply("ArrayExpression", arguments);
    }
    function assignmentExpression$c(operator, left, right) {
      return builder.apply("AssignmentExpression", arguments);
    }
    function binaryExpression$4(operator, left, right) {
      return builder.apply("BinaryExpression", arguments);
    }
    function interpreterDirective$1(value) {
      return builder.apply("InterpreterDirective", arguments);
    }
    function directive$1(value) {
      return builder.apply("Directive", arguments);
    }
    function directiveLiteral$1(value) {
      return builder.apply("DirectiveLiteral", arguments);
    }
    function blockStatement$6(body, directives) {
      return builder.apply("BlockStatement", arguments);
    }
    function breakStatement(label) {
      return builder.apply("BreakStatement", arguments);
    }
    function callExpression$e(callee, _arguments) {
      return builder.apply("CallExpression", arguments);
    }
    function catchClause(param, body) {
      return builder.apply("CatchClause", arguments);
    }
    function conditionalExpression$3(test, consequent, alternate) {
      return builder.apply("ConditionalExpression", arguments);
    }
    function continueStatement(label) {
      return builder.apply("ContinueStatement", arguments);
    }
    function debuggerStatement() {
      return builder.apply("DebuggerStatement", arguments);
    }
    function doWhileStatement(test, body) {
      return builder.apply("DoWhileStatement", arguments);
    }
    function emptyStatement$1() {
      return builder.apply("EmptyStatement", arguments);
    }
    function expressionStatement$a(expression2) {
      return builder.apply("ExpressionStatement", arguments);
    }
    function file$2(program2, comments, tokens) {
      return builder.apply("File", arguments);
    }
    function forInStatement(left, right, body) {
      return builder.apply("ForInStatement", arguments);
    }
    function forStatement(init3, test, update2, body) {
      return builder.apply("ForStatement", arguments);
    }
    function functionDeclaration(id3, params, body, generator, async) {
      return builder.apply("FunctionDeclaration", arguments);
    }
    function functionExpression$3(id3, params, body, generator, async) {
      return builder.apply("FunctionExpression", arguments);
    }
    function identifier$j(name2) {
      return builder.apply("Identifier", arguments);
    }
    function ifStatement(test, consequent, alternate) {
      return builder.apply("IfStatement", arguments);
    }
    function labeledStatement(label, body) {
      return builder.apply("LabeledStatement", arguments);
    }
    function stringLiteral$8(value) {
      return builder.apply("StringLiteral", arguments);
    }
    function numericLiteral$7(value) {
      return builder.apply("NumericLiteral", arguments);
    }
    function nullLiteral$2() {
      return builder.apply("NullLiteral", arguments);
    }
    function booleanLiteral$5(value) {
      return builder.apply("BooleanLiteral", arguments);
    }
    function regExpLiteral(pattern5, flags) {
      return builder.apply("RegExpLiteral", arguments);
    }
    function logicalExpression$3(operator, left, right) {
      return builder.apply("LogicalExpression", arguments);
    }
    function memberExpression$b(object4, property2, computed, optional) {
      return builder.apply("MemberExpression", arguments);
    }
    function newExpression(callee, _arguments) {
      return builder.apply("NewExpression", arguments);
    }
    function program$3(body, directives, sourceType, interpreter) {
      return builder.apply("Program", arguments);
    }
    function objectExpression$4(properties) {
      return builder.apply("ObjectExpression", arguments);
    }
    function objectMethod(kind, key2, params, body, computed, generator, async) {
      return builder.apply("ObjectMethod", arguments);
    }
    function objectProperty$2(key2, value, computed, shorthand, decorators) {
      return builder.apply("ObjectProperty", arguments);
    }
    function restElement$1(argument) {
      return builder.apply("RestElement", arguments);
    }
    function returnStatement$3(argument) {
      return builder.apply("ReturnStatement", arguments);
    }
    function sequenceExpression$7(expressions) {
      return builder.apply("SequenceExpression", arguments);
    }
    function parenthesizedExpression(expression2) {
      return builder.apply("ParenthesizedExpression", arguments);
    }
    function switchCase(test, consequent) {
      return builder.apply("SwitchCase", arguments);
    }
    function switchStatement(discriminant, cases) {
      return builder.apply("SwitchStatement", arguments);
    }
    function thisExpression$4() {
      return builder.apply("ThisExpression", arguments);
    }
    function throwStatement(argument) {
      return builder.apply("ThrowStatement", arguments);
    }
    function tryStatement(block, handler, finalizer) {
      return builder.apply("TryStatement", arguments);
    }
    function unaryExpression$6(operator, argument, prefix2) {
      return builder.apply("UnaryExpression", arguments);
    }
    function updateExpression$1(operator, argument, prefix2) {
      return builder.apply("UpdateExpression", arguments);
    }
    function variableDeclaration$7(kind, declarations) {
      return builder.apply("VariableDeclaration", arguments);
    }
    function variableDeclarator$7(id3, init3) {
      return builder.apply("VariableDeclarator", arguments);
    }
    function whileStatement(test, body) {
      return builder.apply("WhileStatement", arguments);
    }
    function withStatement(object4, body) {
      return builder.apply("WithStatement", arguments);
    }
    function assignmentPattern(left, right) {
      return builder.apply("AssignmentPattern", arguments);
    }
    function arrayPattern(elements) {
      return builder.apply("ArrayPattern", arguments);
    }
    function arrowFunctionExpression$4(params, body, async) {
      return builder.apply("ArrowFunctionExpression", arguments);
    }
    function classBody(body) {
      return builder.apply("ClassBody", arguments);
    }
    function classExpression(id3, superClass, body, decorators) {
      return builder.apply("ClassExpression", arguments);
    }
    function classDeclaration(id3, superClass, body, decorators) {
      return builder.apply("ClassDeclaration", arguments);
    }
    function exportAllDeclaration(source) {
      return builder.apply("ExportAllDeclaration", arguments);
    }
    function exportDefaultDeclaration(declaration) {
      return builder.apply("ExportDefaultDeclaration", arguments);
    }
    function exportNamedDeclaration$2(declaration, specifiers, source) {
      return builder.apply("ExportNamedDeclaration", arguments);
    }
    function exportSpecifier$2(local, exported) {
      return builder.apply("ExportSpecifier", arguments);
    }
    function forOfStatement(left, right, body, _await) {
      return builder.apply("ForOfStatement", arguments);
    }
    function importDeclaration$1(specifiers, source) {
      return builder.apply("ImportDeclaration", arguments);
    }
    function importDefaultSpecifier$1(local) {
      return builder.apply("ImportDefaultSpecifier", arguments);
    }
    function importNamespaceSpecifier$1(local) {
      return builder.apply("ImportNamespaceSpecifier", arguments);
    }
    function importSpecifier$1(local, imported) {
      return builder.apply("ImportSpecifier", arguments);
    }
    function metaProperty$1(meta2, property2) {
      return builder.apply("MetaProperty", arguments);
    }
    function classMethod(kind, key2, params, body, computed, _static, generator, async) {
      return builder.apply("ClassMethod", arguments);
    }
    function objectPattern(properties) {
      return builder.apply("ObjectPattern", arguments);
    }
    function spreadElement$2(argument) {
      return builder.apply("SpreadElement", arguments);
    }
    function _super$1() {
      return builder.apply("Super", arguments);
    }
    function taggedTemplateExpression(tag, quasi) {
      return builder.apply("TaggedTemplateExpression", arguments);
    }
    function templateElement(value, tail) {
      return builder.apply("TemplateElement", arguments);
    }
    function templateLiteral(quasis, expressions) {
      return builder.apply("TemplateLiteral", arguments);
    }
    function yieldExpression$2(argument, delegate) {
      return builder.apply("YieldExpression", arguments);
    }
    function awaitExpression$1(argument) {
      return builder.apply("AwaitExpression", arguments);
    }
    function _import() {
      return builder.apply("Import", arguments);
    }
    function bigIntLiteral(value) {
      return builder.apply("BigIntLiteral", arguments);
    }
    function exportNamespaceSpecifier(exported) {
      return builder.apply("ExportNamespaceSpecifier", arguments);
    }
    function optionalMemberExpression$2(object4, property2, computed, optional) {
      return builder.apply("OptionalMemberExpression", arguments);
    }
    function optionalCallExpression$2(callee, _arguments, optional) {
      return builder.apply("OptionalCallExpression", arguments);
    }
    function classProperty(key2, value, typeAnnotation2, decorators, computed, _static) {
      return builder.apply("ClassProperty", arguments);
    }
    function classAccessorProperty(key2, value, typeAnnotation2, decorators, computed, _static) {
      return builder.apply("ClassAccessorProperty", arguments);
    }
    function classPrivateProperty(key2, value, decorators, _static) {
      return builder.apply("ClassPrivateProperty", arguments);
    }
    function classPrivateMethod(kind, key2, params, body, _static) {
      return builder.apply("ClassPrivateMethod", arguments);
    }
    function privateName(id3) {
      return builder.apply("PrivateName", arguments);
    }
    function staticBlock$1(body) {
      return builder.apply("StaticBlock", arguments);
    }
    function anyTypeAnnotation$2() {
      return builder.apply("AnyTypeAnnotation", arguments);
    }
    function arrayTypeAnnotation$1(elementType) {
      return builder.apply("ArrayTypeAnnotation", arguments);
    }
    function booleanTypeAnnotation$1() {
      return builder.apply("BooleanTypeAnnotation", arguments);
    }
    function booleanLiteralTypeAnnotation(value) {
      return builder.apply("BooleanLiteralTypeAnnotation", arguments);
    }
    function nullLiteralTypeAnnotation$1() {
      return builder.apply("NullLiteralTypeAnnotation", arguments);
    }
    function classImplements(id3, typeParameters) {
      return builder.apply("ClassImplements", arguments);
    }
    function declareClass(id3, typeParameters, _extends2, body) {
      return builder.apply("DeclareClass", arguments);
    }
    function declareFunction(id3) {
      return builder.apply("DeclareFunction", arguments);
    }
    function declareInterface(id3, typeParameters, _extends2, body) {
      return builder.apply("DeclareInterface", arguments);
    }
    function declareModule(id3, body, kind) {
      return builder.apply("DeclareModule", arguments);
    }
    function declareModuleExports(typeAnnotation2) {
      return builder.apply("DeclareModuleExports", arguments);
    }
    function declareTypeAlias(id3, typeParameters, right) {
      return builder.apply("DeclareTypeAlias", arguments);
    }
    function declareOpaqueType(id3, typeParameters, supertype) {
      return builder.apply("DeclareOpaqueType", arguments);
    }
    function declareVariable(id3) {
      return builder.apply("DeclareVariable", arguments);
    }
    function declareExportDeclaration(declaration, specifiers, source) {
      return builder.apply("DeclareExportDeclaration", arguments);
    }
    function declareExportAllDeclaration(source) {
      return builder.apply("DeclareExportAllDeclaration", arguments);
    }
    function declaredPredicate(value) {
      return builder.apply("DeclaredPredicate", arguments);
    }
    function existsTypeAnnotation() {
      return builder.apply("ExistsTypeAnnotation", arguments);
    }
    function functionTypeAnnotation(typeParameters, params, rest, returnType) {
      return builder.apply("FunctionTypeAnnotation", arguments);
    }
    function functionTypeParam(name2, typeAnnotation2) {
      return builder.apply("FunctionTypeParam", arguments);
    }
    function genericTypeAnnotation$1(id3, typeParameters) {
      return builder.apply("GenericTypeAnnotation", arguments);
    }
    function inferredPredicate() {
      return builder.apply("InferredPredicate", arguments);
    }
    function interfaceExtends(id3, typeParameters) {
      return builder.apply("InterfaceExtends", arguments);
    }
    function interfaceDeclaration(id3, typeParameters, _extends2, body) {
      return builder.apply("InterfaceDeclaration", arguments);
    }
    function interfaceTypeAnnotation(_extends2, body) {
      return builder.apply("InterfaceTypeAnnotation", arguments);
    }
    function intersectionTypeAnnotation(types3) {
      return builder.apply("IntersectionTypeAnnotation", arguments);
    }
    function mixedTypeAnnotation() {
      return builder.apply("MixedTypeAnnotation", arguments);
    }
    function emptyTypeAnnotation() {
      return builder.apply("EmptyTypeAnnotation", arguments);
    }
    function nullableTypeAnnotation(typeAnnotation2) {
      return builder.apply("NullableTypeAnnotation", arguments);
    }
    function numberLiteralTypeAnnotation(value) {
      return builder.apply("NumberLiteralTypeAnnotation", arguments);
    }
    function numberTypeAnnotation$2() {
      return builder.apply("NumberTypeAnnotation", arguments);
    }
    function objectTypeAnnotation(properties, indexers, callProperties, internalSlots, exact) {
      return builder.apply("ObjectTypeAnnotation", arguments);
    }
    function objectTypeInternalSlot(id3, value, optional, _static, method5) {
      return builder.apply("ObjectTypeInternalSlot", arguments);
    }
    function objectTypeCallProperty(value) {
      return builder.apply("ObjectTypeCallProperty", arguments);
    }
    function objectTypeIndexer(id3, key2, value, variance2) {
      return builder.apply("ObjectTypeIndexer", arguments);
    }
    function objectTypeProperty(key2, value, variance2) {
      return builder.apply("ObjectTypeProperty", arguments);
    }
    function objectTypeSpreadProperty(argument) {
      return builder.apply("ObjectTypeSpreadProperty", arguments);
    }
    function opaqueType(id3, typeParameters, supertype, impltype) {
      return builder.apply("OpaqueType", arguments);
    }
    function qualifiedTypeIdentifier(id3, qualification) {
      return builder.apply("QualifiedTypeIdentifier", arguments);
    }
    function stringLiteralTypeAnnotation(value) {
      return builder.apply("StringLiteralTypeAnnotation", arguments);
    }
    function stringTypeAnnotation$2() {
      return builder.apply("StringTypeAnnotation", arguments);
    }
    function symbolTypeAnnotation() {
      return builder.apply("SymbolTypeAnnotation", arguments);
    }
    function thisTypeAnnotation() {
      return builder.apply("ThisTypeAnnotation", arguments);
    }
    function tupleTypeAnnotation$1(types3) {
      return builder.apply("TupleTypeAnnotation", arguments);
    }
    function typeofTypeAnnotation(argument) {
      return builder.apply("TypeofTypeAnnotation", arguments);
    }
    function typeAlias(id3, typeParameters, right) {
      return builder.apply("TypeAlias", arguments);
    }
    function typeAnnotation(typeAnnotation2) {
      return builder.apply("TypeAnnotation", arguments);
    }
    function typeCastExpression(expression2, typeAnnotation2) {
      return builder.apply("TypeCastExpression", arguments);
    }
    function typeParameter(bound, _default3, variance2) {
      return builder.apply("TypeParameter", arguments);
    }
    function typeParameterDeclaration(params) {
      return builder.apply("TypeParameterDeclaration", arguments);
    }
    function typeParameterInstantiation(params) {
      return builder.apply("TypeParameterInstantiation", arguments);
    }
    function unionTypeAnnotation$1(types3) {
      return builder.apply("UnionTypeAnnotation", arguments);
    }
    function variance(kind) {
      return builder.apply("Variance", arguments);
    }
    function voidTypeAnnotation$3() {
      return builder.apply("VoidTypeAnnotation", arguments);
    }
    function enumDeclaration(id3, body) {
      return builder.apply("EnumDeclaration", arguments);
    }
    function enumBooleanBody(members) {
      return builder.apply("EnumBooleanBody", arguments);
    }
    function enumNumberBody(members) {
      return builder.apply("EnumNumberBody", arguments);
    }
    function enumStringBody(members) {
      return builder.apply("EnumStringBody", arguments);
    }
    function enumSymbolBody(members) {
      return builder.apply("EnumSymbolBody", arguments);
    }
    function enumBooleanMember(id3) {
      return builder.apply("EnumBooleanMember", arguments);
    }
    function enumNumberMember(id3, init3) {
      return builder.apply("EnumNumberMember", arguments);
    }
    function enumStringMember(id3, init3) {
      return builder.apply("EnumStringMember", arguments);
    }
    function enumDefaultedMember(id3) {
      return builder.apply("EnumDefaultedMember", arguments);
    }
    function indexedAccessType(objectType, indexType) {
      return builder.apply("IndexedAccessType", arguments);
    }
    function optionalIndexedAccessType(objectType, indexType) {
      return builder.apply("OptionalIndexedAccessType", arguments);
    }
    function jsxAttribute(name2, value) {
      return builder.apply("JSXAttribute", arguments);
    }
    function jsxClosingElement(name2) {
      return builder.apply("JSXClosingElement", arguments);
    }
    function jsxElement(openingElement, closingElement, children, selfClosing) {
      return builder.apply("JSXElement", arguments);
    }
    function jsxEmptyExpression() {
      return builder.apply("JSXEmptyExpression", arguments);
    }
    function jsxExpressionContainer$1(expression2) {
      return builder.apply("JSXExpressionContainer", arguments);
    }
    function jsxSpreadChild(expression2) {
      return builder.apply("JSXSpreadChild", arguments);
    }
    function jsxIdentifier$2(name2) {
      return builder.apply("JSXIdentifier", arguments);
    }
    function jsxMemberExpression$1(object4, property2) {
      return builder.apply("JSXMemberExpression", arguments);
    }
    function jsxNamespacedName(namespace, name2) {
      return builder.apply("JSXNamespacedName", arguments);
    }
    function jsxOpeningElement(name2, attributes, selfClosing) {
      return builder.apply("JSXOpeningElement", arguments);
    }
    function jsxSpreadAttribute(argument) {
      return builder.apply("JSXSpreadAttribute", arguments);
    }
    function jsxText(value) {
      return builder.apply("JSXText", arguments);
    }
    function jsxFragment(openingFragment, closingFragment, children) {
      return builder.apply("JSXFragment", arguments);
    }
    function jsxOpeningFragment() {
      return builder.apply("JSXOpeningFragment", arguments);
    }
    function jsxClosingFragment() {
      return builder.apply("JSXClosingFragment", arguments);
    }
    function noop$12() {
      return builder.apply("Noop", arguments);
    }
    function placeholder(expectedNode, name2) {
      return builder.apply("Placeholder", arguments);
    }
    function v8IntrinsicIdentifier(name2) {
      return builder.apply("V8IntrinsicIdentifier", arguments);
    }
    function argumentPlaceholder() {
      return builder.apply("ArgumentPlaceholder", arguments);
    }
    function bindExpression(object4, callee) {
      return builder.apply("BindExpression", arguments);
    }
    function importAttribute(key2, value) {
      return builder.apply("ImportAttribute", arguments);
    }
    function decorator(expression2) {
      return builder.apply("Decorator", arguments);
    }
    function doExpression(body, async) {
      return builder.apply("DoExpression", arguments);
    }
    function exportDefaultSpecifier(exported) {
      return builder.apply("ExportDefaultSpecifier", arguments);
    }
    function recordExpression(properties) {
      return builder.apply("RecordExpression", arguments);
    }
    function tupleExpression(elements) {
      return builder.apply("TupleExpression", arguments);
    }
    function decimalLiteral(value) {
      return builder.apply("DecimalLiteral", arguments);
    }
    function moduleExpression(body) {
      return builder.apply("ModuleExpression", arguments);
    }
    function topicReference() {
      return builder.apply("TopicReference", arguments);
    }
    function pipelineTopicExpression(expression2) {
      return builder.apply("PipelineTopicExpression", arguments);
    }
    function pipelineBareFunction(callee) {
      return builder.apply("PipelineBareFunction", arguments);
    }
    function pipelinePrimaryTopicReference() {
      return builder.apply("PipelinePrimaryTopicReference", arguments);
    }
    function tsParameterProperty(parameter) {
      return builder.apply("TSParameterProperty", arguments);
    }
    function tsDeclareFunction(id3, typeParameters, params, returnType) {
      return builder.apply("TSDeclareFunction", arguments);
    }
    function tsDeclareMethod(decorators, key2, typeParameters, params, returnType) {
      return builder.apply("TSDeclareMethod", arguments);
    }
    function tsQualifiedName(left, right) {
      return builder.apply("TSQualifiedName", arguments);
    }
    function tsCallSignatureDeclaration(typeParameters, parameters, typeAnnotation2) {
      return builder.apply("TSCallSignatureDeclaration", arguments);
    }
    function tsConstructSignatureDeclaration(typeParameters, parameters, typeAnnotation2) {
      return builder.apply("TSConstructSignatureDeclaration", arguments);
    }
    function tsPropertySignature(key2, typeAnnotation2, initializer) {
      return builder.apply("TSPropertySignature", arguments);
    }
    function tsMethodSignature(key2, typeParameters, parameters, typeAnnotation2) {
      return builder.apply("TSMethodSignature", arguments);
    }
    function tsIndexSignature(parameters, typeAnnotation2) {
      return builder.apply("TSIndexSignature", arguments);
    }
    function tsAnyKeyword() {
      return builder.apply("TSAnyKeyword", arguments);
    }
    function tsBooleanKeyword() {
      return builder.apply("TSBooleanKeyword", arguments);
    }
    function tsBigIntKeyword() {
      return builder.apply("TSBigIntKeyword", arguments);
    }
    function tsIntrinsicKeyword() {
      return builder.apply("TSIntrinsicKeyword", arguments);
    }
    function tsNeverKeyword() {
      return builder.apply("TSNeverKeyword", arguments);
    }
    function tsNullKeyword() {
      return builder.apply("TSNullKeyword", arguments);
    }
    function tsNumberKeyword() {
      return builder.apply("TSNumberKeyword", arguments);
    }
    function tsObjectKeyword() {
      return builder.apply("TSObjectKeyword", arguments);
    }
    function tsStringKeyword() {
      return builder.apply("TSStringKeyword", arguments);
    }
    function tsSymbolKeyword() {
      return builder.apply("TSSymbolKeyword", arguments);
    }
    function tsUndefinedKeyword() {
      return builder.apply("TSUndefinedKeyword", arguments);
    }
    function tsUnknownKeyword() {
      return builder.apply("TSUnknownKeyword", arguments);
    }
    function tsVoidKeyword() {
      return builder.apply("TSVoidKeyword", arguments);
    }
    function tsThisType() {
      return builder.apply("TSThisType", arguments);
    }
    function tsFunctionType(typeParameters, parameters, typeAnnotation2) {
      return builder.apply("TSFunctionType", arguments);
    }
    function tsConstructorType(typeParameters, parameters, typeAnnotation2) {
      return builder.apply("TSConstructorType", arguments);
    }
    function tsTypeReference(typeName, typeParameters) {
      return builder.apply("TSTypeReference", arguments);
    }
    function tsTypePredicate(parameterName, typeAnnotation2, asserts) {
      return builder.apply("TSTypePredicate", arguments);
    }
    function tsTypeQuery(exprName) {
      return builder.apply("TSTypeQuery", arguments);
    }
    function tsTypeLiteral(members) {
      return builder.apply("TSTypeLiteral", arguments);
    }
    function tsArrayType(elementType) {
      return builder.apply("TSArrayType", arguments);
    }
    function tsTupleType(elementTypes) {
      return builder.apply("TSTupleType", arguments);
    }
    function tsOptionalType(typeAnnotation2) {
      return builder.apply("TSOptionalType", arguments);
    }
    function tsRestType(typeAnnotation2) {
      return builder.apply("TSRestType", arguments);
    }
    function tsNamedTupleMember(label, elementType, optional) {
      return builder.apply("TSNamedTupleMember", arguments);
    }
    function tsUnionType(types3) {
      return builder.apply("TSUnionType", arguments);
    }
    function tsIntersectionType(types3) {
      return builder.apply("TSIntersectionType", arguments);
    }
    function tsConditionalType(checkType, extendsType, trueType, falseType) {
      return builder.apply("TSConditionalType", arguments);
    }
    function tsInferType(typeParameter2) {
      return builder.apply("TSInferType", arguments);
    }
    function tsParenthesizedType(typeAnnotation2) {
      return builder.apply("TSParenthesizedType", arguments);
    }
    function tsTypeOperator(typeAnnotation2) {
      return builder.apply("TSTypeOperator", arguments);
    }
    function tsIndexedAccessType(objectType, indexType) {
      return builder.apply("TSIndexedAccessType", arguments);
    }
    function tsMappedType(typeParameter2, typeAnnotation2, nameType) {
      return builder.apply("TSMappedType", arguments);
    }
    function tsLiteralType(literal2) {
      return builder.apply("TSLiteralType", arguments);
    }
    function tsExpressionWithTypeArguments(expression2, typeParameters) {
      return builder.apply("TSExpressionWithTypeArguments", arguments);
    }
    function tsInterfaceDeclaration(id3, typeParameters, _extends2, body) {
      return builder.apply("TSInterfaceDeclaration", arguments);
    }
    function tsInterfaceBody(body) {
      return builder.apply("TSInterfaceBody", arguments);
    }
    function tsTypeAliasDeclaration(id3, typeParameters, typeAnnotation2) {
      return builder.apply("TSTypeAliasDeclaration", arguments);
    }
    function tsAsExpression(expression2, typeAnnotation2) {
      return builder.apply("TSAsExpression", arguments);
    }
    function tsTypeAssertion(typeAnnotation2, expression2) {
      return builder.apply("TSTypeAssertion", arguments);
    }
    function tsEnumDeclaration(id3, members) {
      return builder.apply("TSEnumDeclaration", arguments);
    }
    function tsEnumMember(id3, initializer) {
      return builder.apply("TSEnumMember", arguments);
    }
    function tsModuleDeclaration(id3, body) {
      return builder.apply("TSModuleDeclaration", arguments);
    }
    function tsModuleBlock(body) {
      return builder.apply("TSModuleBlock", arguments);
    }
    function tsImportType(argument, qualifier, typeParameters) {
      return builder.apply("TSImportType", arguments);
    }
    function tsImportEqualsDeclaration(id3, moduleReference) {
      return builder.apply("TSImportEqualsDeclaration", arguments);
    }
    function tsExternalModuleReference(expression2) {
      return builder.apply("TSExternalModuleReference", arguments);
    }
    function tsNonNullExpression(expression2) {
      return builder.apply("TSNonNullExpression", arguments);
    }
    function tsExportAssignment(expression2) {
      return builder.apply("TSExportAssignment", arguments);
    }
    function tsNamespaceExportDeclaration(id3) {
      return builder.apply("TSNamespaceExportDeclaration", arguments);
    }
    function tsTypeAnnotation(typeAnnotation2) {
      return builder.apply("TSTypeAnnotation", arguments);
    }
    function tsTypeParameterInstantiation(params) {
      return builder.apply("TSTypeParameterInstantiation", arguments);
    }
    function tsTypeParameterDeclaration(params) {
      return builder.apply("TSTypeParameterDeclaration", arguments);
    }
    function tsTypeParameter(constraint, _default3, name2) {
      return builder.apply("TSTypeParameter", arguments);
    }
    function NumberLiteral(value) {
      console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
      return builder.apply("NumberLiteral", arguments);
    }
    function RegexLiteral(pattern5, flags) {
      console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
      return builder.apply("RegexLiteral", arguments);
    }
    function RestProperty$1(argument) {
      console.trace("The node type RestProperty has been renamed to RestElement");
      return builder.apply("RestProperty", arguments);
    }
    function SpreadProperty$1(argument) {
      console.trace("The node type SpreadProperty has been renamed to SpreadElement");
      return builder.apply("SpreadProperty", arguments);
    }
    function cleanJSXElementLiteralChild(child, args) {
      var lines = child.value.split(/\r\n|\n|\r/);
      var lastNonEmptyLine = 0;
      for (var i2 = 0; i2 < lines.length; i2++) {
        if (lines[i2].match(/[^ \t]/)) {
          lastNonEmptyLine = i2;
        }
      }
      var str = "";
      for (var _i3 = 0; _i3 < lines.length; _i3++) {
        var line = lines[_i3];
        var isFirstLine = _i3 === 0;
        var isLastLine = _i3 === lines.length - 1;
        var isLastNonEmptyLine = _i3 === lastNonEmptyLine;
        var trimmedLine = line.replace(/\t/g, " ");
        if (!isFirstLine) {
          trimmedLine = trimmedLine.replace(/^[ ]+/, "");
        }
        if (!isLastLine) {
          trimmedLine = trimmedLine.replace(/[ ]+$/, "");
        }
        if (trimmedLine) {
          if (!isLastNonEmptyLine) {
            trimmedLine += " ";
          }
          str += trimmedLine;
        }
      }
      if (str)
        args.push(stringLiteral$8(str));
    }
    function buildChildren(node2) {
      var elements = [];
      for (var i2 = 0; i2 < node2.children.length; i2++) {
        var child = node2.children[i2];
        if (isJSXText(child)) {
          cleanJSXElementLiteralChild(child, elements);
          continue;
        }
        if (isJSXExpressionContainer$1(child))
          child = child.expression;
        if (isJSXEmptyExpression(child))
          continue;
        elements.push(child);
      }
      return elements;
    }
    function isNode(node2) {
      return !!(node2 && VISITOR_KEYS$7[node2.type]);
    }
    function assertNode(node2) {
      if (!isNode(node2)) {
        var _node$type;
        var type5 = (_node$type = node2 == null ? void 0 : node2.type) != null ? _node$type : JSON.stringify(node2);
        throw new TypeError('Not a valid node of type "' + type5 + '"');
      }
    }
    function assert$3(type5, node2, opts) {
      if (!is$1(type5, node2, opts)) {
        throw new Error('Expected type "' + type5 + '" with option ' + JSON.stringify(opts) + ", " + ('but instead got "' + node2.type + '".'));
      }
    }
    function assertArrayExpression(node2, opts) {
      assert$3("ArrayExpression", node2, opts);
    }
    function assertAssignmentExpression(node2, opts) {
      assert$3("AssignmentExpression", node2, opts);
    }
    function assertBinaryExpression(node2, opts) {
      assert$3("BinaryExpression", node2, opts);
    }
    function assertInterpreterDirective(node2, opts) {
      assert$3("InterpreterDirective", node2, opts);
    }
    function assertDirective(node2, opts) {
      assert$3("Directive", node2, opts);
    }
    function assertDirectiveLiteral(node2, opts) {
      assert$3("DirectiveLiteral", node2, opts);
    }
    function assertBlockStatement(node2, opts) {
      assert$3("BlockStatement", node2, opts);
    }
    function assertBreakStatement(node2, opts) {
      assert$3("BreakStatement", node2, opts);
    }
    function assertCallExpression(node2, opts) {
      assert$3("CallExpression", node2, opts);
    }
    function assertCatchClause(node2, opts) {
      assert$3("CatchClause", node2, opts);
    }
    function assertConditionalExpression(node2, opts) {
      assert$3("ConditionalExpression", node2, opts);
    }
    function assertContinueStatement(node2, opts) {
      assert$3("ContinueStatement", node2, opts);
    }
    function assertDebuggerStatement(node2, opts) {
      assert$3("DebuggerStatement", node2, opts);
    }
    function assertDoWhileStatement(node2, opts) {
      assert$3("DoWhileStatement", node2, opts);
    }
    function assertEmptyStatement(node2, opts) {
      assert$3("EmptyStatement", node2, opts);
    }
    function assertExpressionStatement$1(node2, opts) {
      assert$3("ExpressionStatement", node2, opts);
    }
    function assertFile(node2, opts) {
      assert$3("File", node2, opts);
    }
    function assertForInStatement(node2, opts) {
      assert$3("ForInStatement", node2, opts);
    }
    function assertForStatement(node2, opts) {
      assert$3("ForStatement", node2, opts);
    }
    function assertFunctionDeclaration(node2, opts) {
      assert$3("FunctionDeclaration", node2, opts);
    }
    function assertFunctionExpression(node2, opts) {
      assert$3("FunctionExpression", node2, opts);
    }
    function assertIdentifier(node2, opts) {
      assert$3("Identifier", node2, opts);
    }
    function assertIfStatement(node2, opts) {
      assert$3("IfStatement", node2, opts);
    }
    function assertLabeledStatement(node2, opts) {
      assert$3("LabeledStatement", node2, opts);
    }
    function assertStringLiteral(node2, opts) {
      assert$3("StringLiteral", node2, opts);
    }
    function assertNumericLiteral(node2, opts) {
      assert$3("NumericLiteral", node2, opts);
    }
    function assertNullLiteral(node2, opts) {
      assert$3("NullLiteral", node2, opts);
    }
    function assertBooleanLiteral(node2, opts) {
      assert$3("BooleanLiteral", node2, opts);
    }
    function assertRegExpLiteral(node2, opts) {
      assert$3("RegExpLiteral", node2, opts);
    }
    function assertLogicalExpression(node2, opts) {
      assert$3("LogicalExpression", node2, opts);
    }
    function assertMemberExpression(node2, opts) {
      assert$3("MemberExpression", node2, opts);
    }
    function assertNewExpression(node2, opts) {
      assert$3("NewExpression", node2, opts);
    }
    function assertProgram(node2, opts) {
      assert$3("Program", node2, opts);
    }
    function assertObjectExpression(node2, opts) {
      assert$3("ObjectExpression", node2, opts);
    }
    function assertObjectMethod(node2, opts) {
      assert$3("ObjectMethod", node2, opts);
    }
    function assertObjectProperty(node2, opts) {
      assert$3("ObjectProperty", node2, opts);
    }
    function assertRestElement(node2, opts) {
      assert$3("RestElement", node2, opts);
    }
    function assertReturnStatement(node2, opts) {
      assert$3("ReturnStatement", node2, opts);
    }
    function assertSequenceExpression(node2, opts) {
      assert$3("SequenceExpression", node2, opts);
    }
    function assertParenthesizedExpression(node2, opts) {
      assert$3("ParenthesizedExpression", node2, opts);
    }
    function assertSwitchCase(node2, opts) {
      assert$3("SwitchCase", node2, opts);
    }
    function assertSwitchStatement(node2, opts) {
      assert$3("SwitchStatement", node2, opts);
    }
    function assertThisExpression(node2, opts) {
      assert$3("ThisExpression", node2, opts);
    }
    function assertThrowStatement(node2, opts) {
      assert$3("ThrowStatement", node2, opts);
    }
    function assertTryStatement(node2, opts) {
      assert$3("TryStatement", node2, opts);
    }
    function assertUnaryExpression(node2, opts) {
      assert$3("UnaryExpression", node2, opts);
    }
    function assertUpdateExpression(node2, opts) {
      assert$3("UpdateExpression", node2, opts);
    }
    function assertVariableDeclaration(node2, opts) {
      assert$3("VariableDeclaration", node2, opts);
    }
    function assertVariableDeclarator(node2, opts) {
      assert$3("VariableDeclarator", node2, opts);
    }
    function assertWhileStatement(node2, opts) {
      assert$3("WhileStatement", node2, opts);
    }
    function assertWithStatement(node2, opts) {
      assert$3("WithStatement", node2, opts);
    }
    function assertAssignmentPattern(node2, opts) {
      assert$3("AssignmentPattern", node2, opts);
    }
    function assertArrayPattern(node2, opts) {
      assert$3("ArrayPattern", node2, opts);
    }
    function assertArrowFunctionExpression(node2, opts) {
      assert$3("ArrowFunctionExpression", node2, opts);
    }
    function assertClassBody(node2, opts) {
      assert$3("ClassBody", node2, opts);
    }
    function assertClassExpression(node2, opts) {
      assert$3("ClassExpression", node2, opts);
    }
    function assertClassDeclaration(node2, opts) {
      assert$3("ClassDeclaration", node2, opts);
    }
    function assertExportAllDeclaration(node2, opts) {
      assert$3("ExportAllDeclaration", node2, opts);
    }
    function assertExportDefaultDeclaration(node2, opts) {
      assert$3("ExportDefaultDeclaration", node2, opts);
    }
    function assertExportNamedDeclaration(node2, opts) {
      assert$3("ExportNamedDeclaration", node2, opts);
    }
    function assertExportSpecifier$1(node2, opts) {
      assert$3("ExportSpecifier", node2, opts);
    }
    function assertForOfStatement(node2, opts) {
      assert$3("ForOfStatement", node2, opts);
    }
    function assertImportDeclaration(node2, opts) {
      assert$3("ImportDeclaration", node2, opts);
    }
    function assertImportDefaultSpecifier(node2, opts) {
      assert$3("ImportDefaultSpecifier", node2, opts);
    }
    function assertImportNamespaceSpecifier(node2, opts) {
      assert$3("ImportNamespaceSpecifier", node2, opts);
    }
    function assertImportSpecifier(node2, opts) {
      assert$3("ImportSpecifier", node2, opts);
    }
    function assertMetaProperty(node2, opts) {
      assert$3("MetaProperty", node2, opts);
    }
    function assertClassMethod(node2, opts) {
      assert$3("ClassMethod", node2, opts);
    }
    function assertObjectPattern(node2, opts) {
      assert$3("ObjectPattern", node2, opts);
    }
    function assertSpreadElement(node2, opts) {
      assert$3("SpreadElement", node2, opts);
    }
    function assertSuper(node2, opts) {
      assert$3("Super", node2, opts);
    }
    function assertTaggedTemplateExpression(node2, opts) {
      assert$3("TaggedTemplateExpression", node2, opts);
    }
    function assertTemplateElement(node2, opts) {
      assert$3("TemplateElement", node2, opts);
    }
    function assertTemplateLiteral(node2, opts) {
      assert$3("TemplateLiteral", node2, opts);
    }
    function assertYieldExpression(node2, opts) {
      assert$3("YieldExpression", node2, opts);
    }
    function assertAwaitExpression(node2, opts) {
      assert$3("AwaitExpression", node2, opts);
    }
    function assertImport(node2, opts) {
      assert$3("Import", node2, opts);
    }
    function assertBigIntLiteral(node2, opts) {
      assert$3("BigIntLiteral", node2, opts);
    }
    function assertExportNamespaceSpecifier(node2, opts) {
      assert$3("ExportNamespaceSpecifier", node2, opts);
    }
    function assertOptionalMemberExpression(node2, opts) {
      assert$3("OptionalMemberExpression", node2, opts);
    }
    function assertOptionalCallExpression(node2, opts) {
      assert$3("OptionalCallExpression", node2, opts);
    }
    function assertClassProperty(node2, opts) {
      assert$3("ClassProperty", node2, opts);
    }
    function assertClassAccessorProperty(node2, opts) {
      assert$3("ClassAccessorProperty", node2, opts);
    }
    function assertClassPrivateProperty(node2, opts) {
      assert$3("ClassPrivateProperty", node2, opts);
    }
    function assertClassPrivateMethod(node2, opts) {
      assert$3("ClassPrivateMethod", node2, opts);
    }
    function assertPrivateName(node2, opts) {
      assert$3("PrivateName", node2, opts);
    }
    function assertStaticBlock(node2, opts) {
      assert$3("StaticBlock", node2, opts);
    }
    function assertAnyTypeAnnotation(node2, opts) {
      assert$3("AnyTypeAnnotation", node2, opts);
    }
    function assertArrayTypeAnnotation(node2, opts) {
      assert$3("ArrayTypeAnnotation", node2, opts);
    }
    function assertBooleanTypeAnnotation(node2, opts) {
      assert$3("BooleanTypeAnnotation", node2, opts);
    }
    function assertBooleanLiteralTypeAnnotation(node2, opts) {
      assert$3("BooleanLiteralTypeAnnotation", node2, opts);
    }
    function assertNullLiteralTypeAnnotation(node2, opts) {
      assert$3("NullLiteralTypeAnnotation", node2, opts);
    }
    function assertClassImplements(node2, opts) {
      assert$3("ClassImplements", node2, opts);
    }
    function assertDeclareClass(node2, opts) {
      assert$3("DeclareClass", node2, opts);
    }
    function assertDeclareFunction(node2, opts) {
      assert$3("DeclareFunction", node2, opts);
    }
    function assertDeclareInterface(node2, opts) {
      assert$3("DeclareInterface", node2, opts);
    }
    function assertDeclareModule(node2, opts) {
      assert$3("DeclareModule", node2, opts);
    }
    function assertDeclareModuleExports(node2, opts) {
      assert$3("DeclareModuleExports", node2, opts);
    }
    function assertDeclareTypeAlias(node2, opts) {
      assert$3("DeclareTypeAlias", node2, opts);
    }
    function assertDeclareOpaqueType(node2, opts) {
      assert$3("DeclareOpaqueType", node2, opts);
    }
    function assertDeclareVariable(node2, opts) {
      assert$3("DeclareVariable", node2, opts);
    }
    function assertDeclareExportDeclaration(node2, opts) {
      assert$3("DeclareExportDeclaration", node2, opts);
    }
    function assertDeclareExportAllDeclaration(node2, opts) {
      assert$3("DeclareExportAllDeclaration", node2, opts);
    }
    function assertDeclaredPredicate(node2, opts) {
      assert$3("DeclaredPredicate", node2, opts);
    }
    function assertExistsTypeAnnotation(node2, opts) {
      assert$3("ExistsTypeAnnotation", node2, opts);
    }
    function assertFunctionTypeAnnotation(node2, opts) {
      assert$3("FunctionTypeAnnotation", node2, opts);
    }
    function assertFunctionTypeParam(node2, opts) {
      assert$3("FunctionTypeParam", node2, opts);
    }
    function assertGenericTypeAnnotation(node2, opts) {
      assert$3("GenericTypeAnnotation", node2, opts);
    }
    function assertInferredPredicate(node2, opts) {
      assert$3("InferredPredicate", node2, opts);
    }
    function assertInterfaceExtends(node2, opts) {
      assert$3("InterfaceExtends", node2, opts);
    }
    function assertInterfaceDeclaration(node2, opts) {
      assert$3("InterfaceDeclaration", node2, opts);
    }
    function assertInterfaceTypeAnnotation(node2, opts) {
      assert$3("InterfaceTypeAnnotation", node2, opts);
    }
    function assertIntersectionTypeAnnotation(node2, opts) {
      assert$3("IntersectionTypeAnnotation", node2, opts);
    }
    function assertMixedTypeAnnotation(node2, opts) {
      assert$3("MixedTypeAnnotation", node2, opts);
    }
    function assertEmptyTypeAnnotation(node2, opts) {
      assert$3("EmptyTypeAnnotation", node2, opts);
    }
    function assertNullableTypeAnnotation(node2, opts) {
      assert$3("NullableTypeAnnotation", node2, opts);
    }
    function assertNumberLiteralTypeAnnotation(node2, opts) {
      assert$3("NumberLiteralTypeAnnotation", node2, opts);
    }
    function assertNumberTypeAnnotation(node2, opts) {
      assert$3("NumberTypeAnnotation", node2, opts);
    }
    function assertObjectTypeAnnotation(node2, opts) {
      assert$3("ObjectTypeAnnotation", node2, opts);
    }
    function assertObjectTypeInternalSlot(node2, opts) {
      assert$3("ObjectTypeInternalSlot", node2, opts);
    }
    function assertObjectTypeCallProperty(node2, opts) {
      assert$3("ObjectTypeCallProperty", node2, opts);
    }
    function assertObjectTypeIndexer(node2, opts) {
      assert$3("ObjectTypeIndexer", node2, opts);
    }
    function assertObjectTypeProperty(node2, opts) {
      assert$3("ObjectTypeProperty", node2, opts);
    }
    function assertObjectTypeSpreadProperty(node2, opts) {
      assert$3("ObjectTypeSpreadProperty", node2, opts);
    }
    function assertOpaqueType(node2, opts) {
      assert$3("OpaqueType", node2, opts);
    }
    function assertQualifiedTypeIdentifier(node2, opts) {
      assert$3("QualifiedTypeIdentifier", node2, opts);
    }
    function assertStringLiteralTypeAnnotation(node2, opts) {
      assert$3("StringLiteralTypeAnnotation", node2, opts);
    }
    function assertStringTypeAnnotation(node2, opts) {
      assert$3("StringTypeAnnotation", node2, opts);
    }
    function assertSymbolTypeAnnotation(node2, opts) {
      assert$3("SymbolTypeAnnotation", node2, opts);
    }
    function assertThisTypeAnnotation(node2, opts) {
      assert$3("ThisTypeAnnotation", node2, opts);
    }
    function assertTupleTypeAnnotation(node2, opts) {
      assert$3("TupleTypeAnnotation", node2, opts);
    }
    function assertTypeofTypeAnnotation(node2, opts) {
      assert$3("TypeofTypeAnnotation", node2, opts);
    }
    function assertTypeAlias(node2, opts) {
      assert$3("TypeAlias", node2, opts);
    }
    function assertTypeAnnotation(node2, opts) {
      assert$3("TypeAnnotation", node2, opts);
    }
    function assertTypeCastExpression(node2, opts) {
      assert$3("TypeCastExpression", node2, opts);
    }
    function assertTypeParameter(node2, opts) {
      assert$3("TypeParameter", node2, opts);
    }
    function assertTypeParameterDeclaration(node2, opts) {
      assert$3("TypeParameterDeclaration", node2, opts);
    }
    function assertTypeParameterInstantiation(node2, opts) {
      assert$3("TypeParameterInstantiation", node2, opts);
    }
    function assertUnionTypeAnnotation(node2, opts) {
      assert$3("UnionTypeAnnotation", node2, opts);
    }
    function assertVariance(node2, opts) {
      assert$3("Variance", node2, opts);
    }
    function assertVoidTypeAnnotation(node2, opts) {
      assert$3("VoidTypeAnnotation", node2, opts);
    }
    function assertEnumDeclaration(node2, opts) {
      assert$3("EnumDeclaration", node2, opts);
    }
    function assertEnumBooleanBody(node2, opts) {
      assert$3("EnumBooleanBody", node2, opts);
    }
    function assertEnumNumberBody(node2, opts) {
      assert$3("EnumNumberBody", node2, opts);
    }
    function assertEnumStringBody(node2, opts) {
      assert$3("EnumStringBody", node2, opts);
    }
    function assertEnumSymbolBody(node2, opts) {
      assert$3("EnumSymbolBody", node2, opts);
    }
    function assertEnumBooleanMember(node2, opts) {
      assert$3("EnumBooleanMember", node2, opts);
    }
    function assertEnumNumberMember(node2, opts) {
      assert$3("EnumNumberMember", node2, opts);
    }
    function assertEnumStringMember(node2, opts) {
      assert$3("EnumStringMember", node2, opts);
    }
    function assertEnumDefaultedMember(node2, opts) {
      assert$3("EnumDefaultedMember", node2, opts);
    }
    function assertIndexedAccessType(node2, opts) {
      assert$3("IndexedAccessType", node2, opts);
    }
    function assertOptionalIndexedAccessType(node2, opts) {
      assert$3("OptionalIndexedAccessType", node2, opts);
    }
    function assertJSXAttribute(node2, opts) {
      assert$3("JSXAttribute", node2, opts);
    }
    function assertJSXClosingElement(node2, opts) {
      assert$3("JSXClosingElement", node2, opts);
    }
    function assertJSXElement(node2, opts) {
      assert$3("JSXElement", node2, opts);
    }
    function assertJSXEmptyExpression(node2, opts) {
      assert$3("JSXEmptyExpression", node2, opts);
    }
    function assertJSXExpressionContainer(node2, opts) {
      assert$3("JSXExpressionContainer", node2, opts);
    }
    function assertJSXSpreadChild(node2, opts) {
      assert$3("JSXSpreadChild", node2, opts);
    }
    function assertJSXIdentifier(node2, opts) {
      assert$3("JSXIdentifier", node2, opts);
    }
    function assertJSXMemberExpression(node2, opts) {
      assert$3("JSXMemberExpression", node2, opts);
    }
    function assertJSXNamespacedName(node2, opts) {
      assert$3("JSXNamespacedName", node2, opts);
    }
    function assertJSXOpeningElement(node2, opts) {
      assert$3("JSXOpeningElement", node2, opts);
    }
    function assertJSXSpreadAttribute(node2, opts) {
      assert$3("JSXSpreadAttribute", node2, opts);
    }
    function assertJSXText(node2, opts) {
      assert$3("JSXText", node2, opts);
    }
    function assertJSXFragment(node2, opts) {
      assert$3("JSXFragment", node2, opts);
    }
    function assertJSXOpeningFragment(node2, opts) {
      assert$3("JSXOpeningFragment", node2, opts);
    }
    function assertJSXClosingFragment(node2, opts) {
      assert$3("JSXClosingFragment", node2, opts);
    }
    function assertNoop(node2, opts) {
      assert$3("Noop", node2, opts);
    }
    function assertPlaceholder(node2, opts) {
      assert$3("Placeholder", node2, opts);
    }
    function assertV8IntrinsicIdentifier(node2, opts) {
      assert$3("V8IntrinsicIdentifier", node2, opts);
    }
    function assertArgumentPlaceholder(node2, opts) {
      assert$3("ArgumentPlaceholder", node2, opts);
    }
    function assertBindExpression(node2, opts) {
      assert$3("BindExpression", node2, opts);
    }
    function assertImportAttribute(node2, opts) {
      assert$3("ImportAttribute", node2, opts);
    }
    function assertDecorator(node2, opts) {
      assert$3("Decorator", node2, opts);
    }
    function assertDoExpression(node2, opts) {
      assert$3("DoExpression", node2, opts);
    }
    function assertExportDefaultSpecifier(node2, opts) {
      assert$3("ExportDefaultSpecifier", node2, opts);
    }
    function assertRecordExpression(node2, opts) {
      assert$3("RecordExpression", node2, opts);
    }
    function assertTupleExpression(node2, opts) {
      assert$3("TupleExpression", node2, opts);
    }
    function assertDecimalLiteral(node2, opts) {
      assert$3("DecimalLiteral", node2, opts);
    }
    function assertModuleExpression(node2, opts) {
      assert$3("ModuleExpression", node2, opts);
    }
    function assertTopicReference(node2, opts) {
      assert$3("TopicReference", node2, opts);
    }
    function assertPipelineTopicExpression(node2, opts) {
      assert$3("PipelineTopicExpression", node2, opts);
    }
    function assertPipelineBareFunction(node2, opts) {
      assert$3("PipelineBareFunction", node2, opts);
    }
    function assertPipelinePrimaryTopicReference(node2, opts) {
      assert$3("PipelinePrimaryTopicReference", node2, opts);
    }
    function assertTSParameterProperty(node2, opts) {
      assert$3("TSParameterProperty", node2, opts);
    }
    function assertTSDeclareFunction(node2, opts) {
      assert$3("TSDeclareFunction", node2, opts);
    }
    function assertTSDeclareMethod(node2, opts) {
      assert$3("TSDeclareMethod", node2, opts);
    }
    function assertTSQualifiedName(node2, opts) {
      assert$3("TSQualifiedName", node2, opts);
    }
    function assertTSCallSignatureDeclaration(node2, opts) {
      assert$3("TSCallSignatureDeclaration", node2, opts);
    }
    function assertTSConstructSignatureDeclaration(node2, opts) {
      assert$3("TSConstructSignatureDeclaration", node2, opts);
    }
    function assertTSPropertySignature(node2, opts) {
      assert$3("TSPropertySignature", node2, opts);
    }
    function assertTSMethodSignature(node2, opts) {
      assert$3("TSMethodSignature", node2, opts);
    }
    function assertTSIndexSignature(node2, opts) {
      assert$3("TSIndexSignature", node2, opts);
    }
    function assertTSAnyKeyword(node2, opts) {
      assert$3("TSAnyKeyword", node2, opts);
    }
    function assertTSBooleanKeyword(node2, opts) {
      assert$3("TSBooleanKeyword", node2, opts);
    }
    function assertTSBigIntKeyword(node2, opts) {
      assert$3("TSBigIntKeyword", node2, opts);
    }
    function assertTSIntrinsicKeyword(node2, opts) {
      assert$3("TSIntrinsicKeyword", node2, opts);
    }
    function assertTSNeverKeyword(node2, opts) {
      assert$3("TSNeverKeyword", node2, opts);
    }
    function assertTSNullKeyword(node2, opts) {
      assert$3("TSNullKeyword", node2, opts);
    }
    function assertTSNumberKeyword(node2, opts) {
      assert$3("TSNumberKeyword", node2, opts);
    }
    function assertTSObjectKeyword(node2, opts) {
      assert$3("TSObjectKeyword", node2, opts);
    }
    function assertTSStringKeyword(node2, opts) {
      assert$3("TSStringKeyword", node2, opts);
    }
    function assertTSSymbolKeyword(node2, opts) {
      assert$3("TSSymbolKeyword", node2, opts);
    }
    function assertTSUndefinedKeyword(node2, opts) {
      assert$3("TSUndefinedKeyword", node2, opts);
    }
    function assertTSUnknownKeyword(node2, opts) {
      assert$3("TSUnknownKeyword", node2, opts);
    }
    function assertTSVoidKeyword(node2, opts) {
      assert$3("TSVoidKeyword", node2, opts);
    }
    function assertTSThisType(node2, opts) {
      assert$3("TSThisType", node2, opts);
    }
    function assertTSFunctionType(node2, opts) {
      assert$3("TSFunctionType", node2, opts);
    }
    function assertTSConstructorType(node2, opts) {
      assert$3("TSConstructorType", node2, opts);
    }
    function assertTSTypeReference(node2, opts) {
      assert$3("TSTypeReference", node2, opts);
    }
    function assertTSTypePredicate(node2, opts) {
      assert$3("TSTypePredicate", node2, opts);
    }
    function assertTSTypeQuery(node2, opts) {
      assert$3("TSTypeQuery", node2, opts);
    }
    function assertTSTypeLiteral(node2, opts) {
      assert$3("TSTypeLiteral", node2, opts);
    }
    function assertTSArrayType(node2, opts) {
      assert$3("TSArrayType", node2, opts);
    }
    function assertTSTupleType(node2, opts) {
      assert$3("TSTupleType", node2, opts);
    }
    function assertTSOptionalType(node2, opts) {
      assert$3("TSOptionalType", node2, opts);
    }
    function assertTSRestType(node2, opts) {
      assert$3("TSRestType", node2, opts);
    }
    function assertTSNamedTupleMember(node2, opts) {
      assert$3("TSNamedTupleMember", node2, opts);
    }
    function assertTSUnionType(node2, opts) {
      assert$3("TSUnionType", node2, opts);
    }
    function assertTSIntersectionType(node2, opts) {
      assert$3("TSIntersectionType", node2, opts);
    }
    function assertTSConditionalType(node2, opts) {
      assert$3("TSConditionalType", node2, opts);
    }
    function assertTSInferType(node2, opts) {
      assert$3("TSInferType", node2, opts);
    }
    function assertTSParenthesizedType(node2, opts) {
      assert$3("TSParenthesizedType", node2, opts);
    }
    function assertTSTypeOperator(node2, opts) {
      assert$3("TSTypeOperator", node2, opts);
    }
    function assertTSIndexedAccessType(node2, opts) {
      assert$3("TSIndexedAccessType", node2, opts);
    }
    function assertTSMappedType(node2, opts) {
      assert$3("TSMappedType", node2, opts);
    }
    function assertTSLiteralType(node2, opts) {
      assert$3("TSLiteralType", node2, opts);
    }
    function assertTSExpressionWithTypeArguments(node2, opts) {
      assert$3("TSExpressionWithTypeArguments", node2, opts);
    }
    function assertTSInterfaceDeclaration(node2, opts) {
      assert$3("TSInterfaceDeclaration", node2, opts);
    }
    function assertTSInterfaceBody(node2, opts) {
      assert$3("TSInterfaceBody", node2, opts);
    }
    function assertTSTypeAliasDeclaration(node2, opts) {
      assert$3("TSTypeAliasDeclaration", node2, opts);
    }
    function assertTSAsExpression(node2, opts) {
      assert$3("TSAsExpression", node2, opts);
    }
    function assertTSTypeAssertion(node2, opts) {
      assert$3("TSTypeAssertion", node2, opts);
    }
    function assertTSEnumDeclaration(node2, opts) {
      assert$3("TSEnumDeclaration", node2, opts);
    }
    function assertTSEnumMember(node2, opts) {
      assert$3("TSEnumMember", node2, opts);
    }
    function assertTSModuleDeclaration(node2, opts) {
      assert$3("TSModuleDeclaration", node2, opts);
    }
    function assertTSModuleBlock(node2, opts) {
      assert$3("TSModuleBlock", node2, opts);
    }
    function assertTSImportType(node2, opts) {
      assert$3("TSImportType", node2, opts);
    }
    function assertTSImportEqualsDeclaration(node2, opts) {
      assert$3("TSImportEqualsDeclaration", node2, opts);
    }
    function assertTSExternalModuleReference(node2, opts) {
      assert$3("TSExternalModuleReference", node2, opts);
    }
    function assertTSNonNullExpression(node2, opts) {
      assert$3("TSNonNullExpression", node2, opts);
    }
    function assertTSExportAssignment(node2, opts) {
      assert$3("TSExportAssignment", node2, opts);
    }
    function assertTSNamespaceExportDeclaration(node2, opts) {
      assert$3("TSNamespaceExportDeclaration", node2, opts);
    }
    function assertTSTypeAnnotation(node2, opts) {
      assert$3("TSTypeAnnotation", node2, opts);
    }
    function assertTSTypeParameterInstantiation(node2, opts) {
      assert$3("TSTypeParameterInstantiation", node2, opts);
    }
    function assertTSTypeParameterDeclaration(node2, opts) {
      assert$3("TSTypeParameterDeclaration", node2, opts);
    }
    function assertTSTypeParameter(node2, opts) {
      assert$3("TSTypeParameter", node2, opts);
    }
    function assertStandardized(node2, opts) {
      assert$3("Standardized", node2, opts);
    }
    function assertExpression$1(node2, opts) {
      assert$3("Expression", node2, opts);
    }
    function assertBinary(node2, opts) {
      assert$3("Binary", node2, opts);
    }
    function assertScopable(node2, opts) {
      assert$3("Scopable", node2, opts);
    }
    function assertBlockParent(node2, opts) {
      assert$3("BlockParent", node2, opts);
    }
    function assertBlock(node2, opts) {
      assert$3("Block", node2, opts);
    }
    function assertStatement(node2, opts) {
      assert$3("Statement", node2, opts);
    }
    function assertTerminatorless(node2, opts) {
      assert$3("Terminatorless", node2, opts);
    }
    function assertCompletionStatement(node2, opts) {
      assert$3("CompletionStatement", node2, opts);
    }
    function assertConditional(node2, opts) {
      assert$3("Conditional", node2, opts);
    }
    function assertLoop(node2, opts) {
      assert$3("Loop", node2, opts);
    }
    function assertWhile(node2, opts) {
      assert$3("While", node2, opts);
    }
    function assertExpressionWrapper(node2, opts) {
      assert$3("ExpressionWrapper", node2, opts);
    }
    function assertFor(node2, opts) {
      assert$3("For", node2, opts);
    }
    function assertForXStatement(node2, opts) {
      assert$3("ForXStatement", node2, opts);
    }
    function assertFunction$1(node2, opts) {
      assert$3("Function", node2, opts);
    }
    function assertFunctionParent(node2, opts) {
      assert$3("FunctionParent", node2, opts);
    }
    function assertPureish(node2, opts) {
      assert$3("Pureish", node2, opts);
    }
    function assertDeclaration(node2, opts) {
      assert$3("Declaration", node2, opts);
    }
    function assertPatternLike(node2, opts) {
      assert$3("PatternLike", node2, opts);
    }
    function assertLVal(node2, opts) {
      assert$3("LVal", node2, opts);
    }
    function assertTSEntityName(node2, opts) {
      assert$3("TSEntityName", node2, opts);
    }
    function assertLiteral(node2, opts) {
      assert$3("Literal", node2, opts);
    }
    function assertImmutable(node2, opts) {
      assert$3("Immutable", node2, opts);
    }
    function assertUserWhitespacable(node2, opts) {
      assert$3("UserWhitespacable", node2, opts);
    }
    function assertMethod(node2, opts) {
      assert$3("Method", node2, opts);
    }
    function assertObjectMember(node2, opts) {
      assert$3("ObjectMember", node2, opts);
    }
    function assertProperty(node2, opts) {
      assert$3("Property", node2, opts);
    }
    function assertUnaryLike(node2, opts) {
      assert$3("UnaryLike", node2, opts);
    }
    function assertPattern(node2, opts) {
      assert$3("Pattern", node2, opts);
    }
    function assertClass(node2, opts) {
      assert$3("Class", node2, opts);
    }
    function assertModuleDeclaration(node2, opts) {
      assert$3("ModuleDeclaration", node2, opts);
    }
    function assertExportDeclaration(node2, opts) {
      assert$3("ExportDeclaration", node2, opts);
    }
    function assertModuleSpecifier(node2, opts) {
      assert$3("ModuleSpecifier", node2, opts);
    }
    function assertAccessor(node2, opts) {
      assert$3("Accessor", node2, opts);
    }
    function assertPrivate(node2, opts) {
      assert$3("Private", node2, opts);
    }
    function assertFlow(node2, opts) {
      assert$3("Flow", node2, opts);
    }
    function assertFlowType(node2, opts) {
      assert$3("FlowType", node2, opts);
    }
    function assertFlowBaseAnnotation(node2, opts) {
      assert$3("FlowBaseAnnotation", node2, opts);
    }
    function assertFlowDeclaration(node2, opts) {
      assert$3("FlowDeclaration", node2, opts);
    }
    function assertFlowPredicate(node2, opts) {
      assert$3("FlowPredicate", node2, opts);
    }
    function assertEnumBody(node2, opts) {
      assert$3("EnumBody", node2, opts);
    }
    function assertEnumMember(node2, opts) {
      assert$3("EnumMember", node2, opts);
    }
    function assertJSX(node2, opts) {
      assert$3("JSX", node2, opts);
    }
    function assertMiscellaneous(node2, opts) {
      assert$3("Miscellaneous", node2, opts);
    }
    function assertTypeScript(node2, opts) {
      assert$3("TypeScript", node2, opts);
    }
    function assertTSTypeElement(node2, opts) {
      assert$3("TSTypeElement", node2, opts);
    }
    function assertTSType(node2, opts) {
      assert$3("TSType", node2, opts);
    }
    function assertTSBaseType(node2, opts) {
      assert$3("TSBaseType", node2, opts);
    }
    function assertNumberLiteral(node2, opts) {
      console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
      assert$3("NumberLiteral", node2, opts);
    }
    function assertRegexLiteral(node2, opts) {
      console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
      assert$3("RegexLiteral", node2, opts);
    }
    function assertRestProperty(node2, opts) {
      console.trace("The node type RestProperty has been renamed to RestElement");
      assert$3("RestProperty", node2, opts);
    }
    function assertSpreadProperty(node2, opts) {
      console.trace("The node type SpreadProperty has been renamed to SpreadElement");
      assert$3("SpreadProperty", node2, opts);
    }
    function createTypeAnnotationBasedOnTypeof$1(type5) {
      switch (type5) {
        case "string":
          return stringTypeAnnotation$2();
        case "number":
          return numberTypeAnnotation$2();
        case "undefined":
          return voidTypeAnnotation$3();
        case "boolean":
          return booleanTypeAnnotation$1();
        case "function":
          return genericTypeAnnotation$1(identifier$j("Function"));
        case "object":
          return genericTypeAnnotation$1(identifier$j("Object"));
        case "symbol":
          return genericTypeAnnotation$1(identifier$j("Symbol"));
        case "bigint":
          return anyTypeAnnotation$2();
      }
      throw new Error("Invalid typeof value: " + type5);
    }
    function getQualifiedName(node2) {
      return isIdentifier$i(node2) ? node2.name : node2.id.name + "." + getQualifiedName(node2.qualification);
    }
    function removeTypeDuplicates$1(nodes2) {
      var generics = {};
      var bases = {};
      var typeGroups = /* @__PURE__ */ new Set();
      var types3 = [];
      for (var i2 = 0; i2 < nodes2.length; i2++) {
        var node2 = nodes2[i2];
        if (!node2)
          continue;
        if (types3.indexOf(node2) >= 0) {
          continue;
        }
        if (isAnyTypeAnnotation$1(node2)) {
          return [node2];
        }
        if (isFlowBaseAnnotation$1(node2)) {
          bases[node2.type] = node2;
          continue;
        }
        if (isUnionTypeAnnotation$2(node2)) {
          if (!typeGroups.has(node2.types)) {
            nodes2 = nodes2.concat(node2.types);
            typeGroups.add(node2.types);
          }
          continue;
        }
        if (isGenericTypeAnnotation$1(node2)) {
          var name2 = getQualifiedName(node2.id);
          if (generics[name2]) {
            var existing = generics[name2];
            if (existing.typeParameters) {
              if (node2.typeParameters) {
                existing.typeParameters.params = removeTypeDuplicates$1(existing.typeParameters.params.concat(node2.typeParameters.params));
              }
            } else {
              existing = node2.typeParameters;
            }
          } else {
            generics[name2] = node2;
          }
          continue;
        }
        types3.push(node2);
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(bases); _i3 < _Object$keys3.length; _i3++) {
        var type5 = _Object$keys3[_i3];
        types3.push(bases[type5]);
      }
      for (var _i22 = 0, _Object$keys22 = Object.keys(generics); _i22 < _Object$keys22.length; _i22++) {
        var _name = _Object$keys22[_i22];
        types3.push(generics[_name]);
      }
      return types3;
    }
    function createFlowUnionType$2(types3) {
      var flattened = removeTypeDuplicates$1(types3);
      if (flattened.length === 1) {
        return flattened[0];
      } else {
        return unionTypeAnnotation$1(flattened);
      }
    }
    function removeTypeDuplicates(nodes2) {
      var generics = {};
      var bases = {};
      var typeGroups = /* @__PURE__ */ new Set();
      var types3 = [];
      for (var i2 = 0; i2 < nodes2.length; i2++) {
        var node2 = nodes2[i2];
        if (!node2)
          continue;
        if (types3.indexOf(node2) >= 0) {
          continue;
        }
        if (isTSAnyKeyword(node2)) {
          return [node2];
        }
        if (isTSBaseType(node2)) {
          bases[node2.type] = node2;
          continue;
        }
        if (isTSUnionType$1(node2)) {
          if (!typeGroups.has(node2.types)) {
            nodes2.push.apply(nodes2, _toConsumableArray2(node2.types));
            typeGroups.add(node2.types);
          }
          continue;
        }
        types3.push(node2);
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(bases); _i3 < _Object$keys3.length; _i3++) {
        var type5 = _Object$keys3[_i3];
        types3.push(bases[type5]);
      }
      for (var _i22 = 0, _Object$keys22 = Object.keys(generics); _i22 < _Object$keys22.length; _i22++) {
        var name2 = _Object$keys22[_i22];
        types3.push(generics[name2]);
      }
      return types3;
    }
    function createTSUnionType$2(typeAnnotations) {
      var types3 = typeAnnotations.map(function(type5) {
        return type5.typeAnnotation;
      });
      var flattened = removeTypeDuplicates(types3);
      if (flattened.length === 1) {
        return flattened[0];
      } else {
        return tsUnionType(flattened);
      }
    }
    var has$b = Function.call.bind(Object.prototype.hasOwnProperty);
    function cloneIfNode(obj, deep, withoutLoc) {
      if (obj && typeof obj.type === "string") {
        return cloneNode$i(obj, deep, withoutLoc);
      }
      return obj;
    }
    function cloneIfNodeOrArray(obj, deep, withoutLoc) {
      if (Array.isArray(obj)) {
        return obj.map(function(node2) {
          return cloneIfNode(node2, deep, withoutLoc);
        });
      }
      return cloneIfNode(obj, deep, withoutLoc);
    }
    function cloneNode$i(node2, deep, withoutLoc) {
      if (deep === void 0) {
        deep = true;
      }
      if (withoutLoc === void 0) {
        withoutLoc = false;
      }
      if (!node2)
        return node2;
      var type5 = node2.type;
      var newNode = {
        type: node2.type
      };
      if (isIdentifier$i(node2)) {
        newNode.name = node2.name;
        if (has$b(node2, "optional") && typeof node2.optional === "boolean") {
          newNode.optional = node2.optional;
        }
        if (has$b(node2, "typeAnnotation")) {
          newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node2.typeAnnotation, true, withoutLoc) : node2.typeAnnotation;
        }
      } else if (!has$b(NODE_FIELDS, type5)) {
        throw new Error('Unknown node type: "' + type5 + '"');
      } else {
        for (var _i3 = 0, _Object$keys3 = Object.keys(NODE_FIELDS[type5]); _i3 < _Object$keys3.length; _i3++) {
          var field = _Object$keys3[_i3];
          if (has$b(node2, field)) {
            if (deep) {
              newNode[field] = isFile$1(node2) && field === "comments" ? maybeCloneComments(node2.comments, deep, withoutLoc) : cloneIfNodeOrArray(node2[field], true, withoutLoc);
            } else {
              newNode[field] = node2[field];
            }
          }
        }
      }
      if (has$b(node2, "loc")) {
        if (withoutLoc) {
          newNode.loc = null;
        } else {
          newNode.loc = node2.loc;
        }
      }
      if (has$b(node2, "leadingComments")) {
        newNode.leadingComments = maybeCloneComments(node2.leadingComments, deep, withoutLoc);
      }
      if (has$b(node2, "innerComments")) {
        newNode.innerComments = maybeCloneComments(node2.innerComments, deep, withoutLoc);
      }
      if (has$b(node2, "trailingComments")) {
        newNode.trailingComments = maybeCloneComments(node2.trailingComments, deep, withoutLoc);
      }
      if (has$b(node2, "extra")) {
        newNode.extra = Object.assign({}, node2.extra);
      }
      return newNode;
    }
    function maybeCloneComments(comments, deep, withoutLoc) {
      if (!comments || !deep) {
        return comments;
      }
      return comments.map(function(_ref3) {
        var type5 = _ref3.type, value = _ref3.value, loc = _ref3.loc;
        if (withoutLoc) {
          return {
            type: type5,
            value,
            loc: null
          };
        }
        return {
          type: type5,
          value,
          loc
        };
      });
    }
    function clone3(node2) {
      return cloneNode$i(node2, false);
    }
    function cloneDeep$1(node2) {
      return cloneNode$i(node2);
    }
    function cloneDeepWithoutLoc(node2) {
      return cloneNode$i(node2, true, true);
    }
    function cloneWithoutLoc(node2) {
      return cloneNode$i(node2, false, true);
    }
    function addComments$1(node2, type5, comments) {
      if (!comments || !node2)
        return node2;
      var key2 = type5 + "Comments";
      if (node2[key2]) {
        if (type5 === "leading") {
          node2[key2] = comments.concat(node2[key2]);
        } else {
          var _node$key;
          (_node$key = node2[key2]).push.apply(_node$key, _toConsumableArray2(comments));
        }
      } else {
        node2[key2] = comments;
      }
      return node2;
    }
    function addComment$2(node2, type5, content, line) {
      return addComments$1(node2, type5, [{
        type: line ? "CommentLine" : "CommentBlock",
        value: content
      }]);
    }
    function inherit(key2, child, parent) {
      if (child && parent) {
        child[key2] = Array.from(new Set([].concat(child[key2], parent[key2]).filter(Boolean)));
      }
    }
    function inheritInnerComments(child, parent) {
      inherit("innerComments", child, parent);
    }
    function inheritLeadingComments$1(child, parent) {
      inherit("leadingComments", child, parent);
    }
    function inheritTrailingComments$1(child, parent) {
      inherit("trailingComments", child, parent);
    }
    function inheritsComments$2(child, parent) {
      inheritTrailingComments$1(child, parent);
      inheritLeadingComments$1(child, parent);
      inheritInnerComments(child, parent);
      return child;
    }
    function removeComments$2(node2) {
      COMMENT_KEYS.forEach(function(key2) {
        node2[key2] = null;
      });
      return node2;
    }
    var STANDARDIZED_TYPES = FLIPPED_ALIAS_KEYS$3["Standardized"];
    var EXPRESSION_TYPES = FLIPPED_ALIAS_KEYS$3["Expression"];
    var BINARY_TYPES = FLIPPED_ALIAS_KEYS$3["Binary"];
    var SCOPABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Scopable"];
    var BLOCKPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["BlockParent"];
    var BLOCK_TYPES = FLIPPED_ALIAS_KEYS$3["Block"];
    var STATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["Statement"];
    var TERMINATORLESS_TYPES = FLIPPED_ALIAS_KEYS$3["Terminatorless"];
    var COMPLETIONSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["CompletionStatement"];
    var CONDITIONAL_TYPES = FLIPPED_ALIAS_KEYS$3["Conditional"];
    var LOOP_TYPES = FLIPPED_ALIAS_KEYS$3["Loop"];
    var WHILE_TYPES = FLIPPED_ALIAS_KEYS$3["While"];
    var EXPRESSIONWRAPPER_TYPES = FLIPPED_ALIAS_KEYS$3["ExpressionWrapper"];
    var FOR_TYPES = FLIPPED_ALIAS_KEYS$3["For"];
    var FORXSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["ForXStatement"];
    var FUNCTION_TYPES$1 = FLIPPED_ALIAS_KEYS$3["Function"];
    var FUNCTIONPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["FunctionParent"];
    var PUREISH_TYPES = FLIPPED_ALIAS_KEYS$3["Pureish"];
    var DECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["Declaration"];
    var PATTERNLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["PatternLike"];
    var LVAL_TYPES = FLIPPED_ALIAS_KEYS$3["LVal"];
    var TSENTITYNAME_TYPES = FLIPPED_ALIAS_KEYS$3["TSEntityName"];
    var LITERAL_TYPES = FLIPPED_ALIAS_KEYS$3["Literal"];
    var IMMUTABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Immutable"];
    var USERWHITESPACABLE_TYPES = FLIPPED_ALIAS_KEYS$3["UserWhitespacable"];
    var METHOD_TYPES = FLIPPED_ALIAS_KEYS$3["Method"];
    var OBJECTMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["ObjectMember"];
    var PROPERTY_TYPES = FLIPPED_ALIAS_KEYS$3["Property"];
    var UNARYLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["UnaryLike"];
    var PATTERN_TYPES = FLIPPED_ALIAS_KEYS$3["Pattern"];
    var CLASS_TYPES = FLIPPED_ALIAS_KEYS$3["Class"];
    var MODULEDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ModuleDeclaration"];
    var EXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ExportDeclaration"];
    var MODULESPECIFIER_TYPES = FLIPPED_ALIAS_KEYS$3["ModuleSpecifier"];
    var ACCESSOR_TYPES = FLIPPED_ALIAS_KEYS$3["Accessor"];
    var PRIVATE_TYPES = FLIPPED_ALIAS_KEYS$3["Private"];
    var FLOW_TYPES = FLIPPED_ALIAS_KEYS$3["Flow"];
    var FLOWTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowType"];
    var FLOWBASEANNOTATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowBaseAnnotation"];
    var FLOWDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowDeclaration"];
    var FLOWPREDICATE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowPredicate"];
    var ENUMBODY_TYPES = FLIPPED_ALIAS_KEYS$3["EnumBody"];
    var ENUMMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["EnumMember"];
    var JSX_TYPES = FLIPPED_ALIAS_KEYS$3["JSX"];
    var MISCELLANEOUS_TYPES = FLIPPED_ALIAS_KEYS$3["Miscellaneous"];
    var TYPESCRIPT_TYPES = FLIPPED_ALIAS_KEYS$3["TypeScript"];
    var TSTYPEELEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["TSTypeElement"];
    var TSTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSType"];
    var TSBASETYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSBaseType"];
    function toBlock(node2, parent) {
      if (isBlockStatement$2(node2)) {
        return node2;
      }
      var blockNodes = [];
      if (isEmptyStatement$1(node2)) {
        blockNodes = [];
      } else {
        if (!isStatement$7(node2)) {
          if (isFunction$32(parent)) {
            node2 = returnStatement$3(node2);
          } else {
            node2 = expressionStatement$a(node2);
          }
        }
        blockNodes = [node2];
      }
      return blockStatement$6(blockNodes);
    }
    function ensureBlock$1(node2, key2) {
      if (key2 === void 0) {
        key2 = "body";
      }
      return node2[key2] = toBlock(node2[key2], node2);
    }
    function toIdentifier$1(input) {
      input = input + "";
      var name2 = "";
      for (var _iterator2 = _createForOfIteratorHelperLoose(input), _step2; !(_step2 = _iterator2()).done; ) {
        var c2 = _step2.value;
        name2 += isIdentifierChar2(c2.codePointAt(0)) ? c2 : "-";
      }
      name2 = name2.replace(/^[-0-9]+/, "");
      name2 = name2.replace(/[-\s]+(.)?/g, function(match, c3) {
        return c3 ? c3.toUpperCase() : "";
      });
      if (!isValidIdentifier$1(name2)) {
        name2 = "_" + name2;
      }
      return name2 || "_";
    }
    function toBindingIdentifierName$1(name2) {
      name2 = toIdentifier$1(name2);
      if (name2 === "eval" || name2 === "arguments")
        name2 = "_" + name2;
      return name2;
    }
    function toComputedKey$3(node2, key2) {
      if (key2 === void 0) {
        key2 = node2.key || node2.property;
      }
      if (!node2.computed && isIdentifier$i(key2))
        key2 = stringLiteral$8(key2.name);
      return key2;
    }
    function toExpression$1(node2) {
      if (isExpressionStatement$4(node2)) {
        node2 = node2.expression;
      }
      if (isExpression$4(node2)) {
        return node2;
      }
      if (isClass$1(node2)) {
        node2.type = "ClassExpression";
      } else if (isFunction$32(node2)) {
        node2.type = "FunctionExpression";
      }
      if (!isExpression$4(node2)) {
        throw new Error("cannot turn " + node2.type + " to an expression");
      }
      return node2;
    }
    function traverseFast$2(node2, enter, opts) {
      if (!node2)
        return;
      var keys2 = VISITOR_KEYS$7[node2.type];
      if (!keys2)
        return;
      opts = opts || {};
      enter(node2, opts);
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        var subNode = node2[key2];
        if (Array.isArray(subNode)) {
          for (var _iterator22 = _createForOfIteratorHelperLoose(subNode), _step22; !(_step22 = _iterator22()).done; ) {
            var _node = _step22.value;
            traverseFast$2(_node, enter, opts);
          }
        } else {
          traverseFast$2(subNode, enter, opts);
        }
      }
    }
    var CLEAR_KEYS = ["tokens", "start", "end", "loc", "raw", "rawValue"];
    var CLEAR_KEYS_PLUS_COMMENTS = COMMENT_KEYS.concat(["comments"]).concat(CLEAR_KEYS);
    function removeProperties$1(node2, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var map2 = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;
      for (var _iterator2 = _createForOfIteratorHelperLoose(map2), _step2; !(_step2 = _iterator2()).done; ) {
        var _key = _step2.value;
        if (node2[_key] != null)
          node2[_key] = void 0;
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(node2); _i3 < _Object$keys3.length; _i3++) {
        var key2 = _Object$keys3[_i3];
        if (key2[0] === "_" && node2[key2] != null)
          node2[key2] = void 0;
      }
      var symbols = Object.getOwnPropertySymbols(node2);
      for (var _iterator22 = _createForOfIteratorHelperLoose(symbols), _step22; !(_step22 = _iterator22()).done; ) {
        var sym = _step22.value;
        node2[sym] = null;
      }
    }
    function removePropertiesDeep$1(tree, opts) {
      traverseFast$2(tree, removeProperties$1, opts);
      return tree;
    }
    function toKeyAlias$1(node2, key2) {
      if (key2 === void 0) {
        key2 = node2.key;
      }
      var alias2;
      if (node2.kind === "method") {
        return toKeyAlias$1.increment() + "";
      } else if (isIdentifier$i(key2)) {
        alias2 = key2.name;
      } else if (isStringLiteral$7(key2)) {
        alias2 = JSON.stringify(key2.value);
      } else {
        alias2 = JSON.stringify(removePropertiesDeep$1(cloneNode$i(key2)));
      }
      if (node2.computed) {
        alias2 = "[" + alias2 + "]";
      }
      if (node2["static"]) {
        alias2 = "static:" + alias2;
      }
      return alias2;
    }
    toKeyAlias$1.uid = 0;
    toKeyAlias$1.increment = function() {
      if (toKeyAlias$1.uid >= Number.MAX_SAFE_INTEGER) {
        return toKeyAlias$1.uid = 0;
      } else {
        return toKeyAlias$1.uid++;
      }
    };
    function getBindingIdentifiers$2(node2, duplicates, outerOnly) {
      var search = [].concat(node2);
      var ids2 = /* @__PURE__ */ Object.create(null);
      while (search.length) {
        var id3 = search.shift();
        if (!id3)
          continue;
        var keys2 = getBindingIdentifiers$2.keys[id3.type];
        if (isIdentifier$i(id3)) {
          if (duplicates) {
            var _ids = ids2[id3.name] = ids2[id3.name] || [];
            _ids.push(id3);
          } else {
            ids2[id3.name] = id3;
          }
          continue;
        }
        if (isExportDeclaration$2(id3) && !isExportAllDeclaration$1(id3)) {
          if (isDeclaration$1(id3.declaration)) {
            search.push(id3.declaration);
          }
          continue;
        }
        if (outerOnly) {
          if (isFunctionDeclaration$1(id3)) {
            search.push(id3.id);
            continue;
          }
          if (isFunctionExpression$1(id3)) {
            continue;
          }
        }
        if (keys2) {
          for (var i2 = 0; i2 < keys2.length; i2++) {
            var key2 = keys2[i2];
            if (id3[key2]) {
              search = search.concat(id3[key2]);
            }
          }
        }
      }
      return ids2;
    }
    getBindingIdentifiers$2.keys = {
      DeclareClass: ["id"],
      DeclareFunction: ["id"],
      DeclareModule: ["id"],
      DeclareVariable: ["id"],
      DeclareInterface: ["id"],
      DeclareTypeAlias: ["id"],
      DeclareOpaqueType: ["id"],
      InterfaceDeclaration: ["id"],
      TypeAlias: ["id"],
      OpaqueType: ["id"],
      CatchClause: ["param"],
      LabeledStatement: ["label"],
      UnaryExpression: ["argument"],
      AssignmentExpression: ["left"],
      ImportSpecifier: ["local"],
      ImportNamespaceSpecifier: ["local"],
      ImportDefaultSpecifier: ["local"],
      ImportDeclaration: ["specifiers"],
      ExportSpecifier: ["exported"],
      ExportNamespaceSpecifier: ["exported"],
      ExportDefaultSpecifier: ["exported"],
      FunctionDeclaration: ["id", "params"],
      FunctionExpression: ["id", "params"],
      ArrowFunctionExpression: ["params"],
      ObjectMethod: ["params"],
      ClassMethod: ["params"],
      ClassPrivateMethod: ["params"],
      ForInStatement: ["left"],
      ForOfStatement: ["left"],
      ClassDeclaration: ["id"],
      ClassExpression: ["id"],
      RestElement: ["argument"],
      UpdateExpression: ["argument"],
      ObjectProperty: ["value"],
      AssignmentPattern: ["left"],
      ArrayPattern: ["elements"],
      ObjectPattern: ["properties"],
      VariableDeclaration: ["declarations"],
      VariableDeclarator: ["id"]
    };
    function gatherSequenceExpressions(nodes2, scope2, declars) {
      var exprs = [];
      var ensureLastUndefined = true;
      for (var _iterator2 = _createForOfIteratorHelperLoose(nodes2), _step2; !(_step2 = _iterator2()).done; ) {
        var node2 = _step2.value;
        if (!isEmptyStatement$1(node2)) {
          ensureLastUndefined = false;
        }
        if (isExpression$4(node2)) {
          exprs.push(node2);
        } else if (isExpressionStatement$4(node2)) {
          exprs.push(node2.expression);
        } else if (isVariableDeclaration$3(node2)) {
          if (node2.kind !== "var")
            return;
          for (var _iterator22 = _createForOfIteratorHelperLoose(node2.declarations), _step22; !(_step22 = _iterator22()).done; ) {
            var declar = _step22.value;
            var bindings = getBindingIdentifiers$2(declar);
            for (var _i3 = 0, _Object$keys3 = Object.keys(bindings); _i3 < _Object$keys3.length; _i3++) {
              var key2 = _Object$keys3[_i3];
              declars.push({
                kind: node2.kind,
                id: cloneNode$i(bindings[key2])
              });
            }
            if (declar.init) {
              exprs.push(assignmentExpression$c("=", declar.id, declar.init));
            }
          }
          ensureLastUndefined = true;
        } else if (isIfStatement$2(node2)) {
          var consequent = node2.consequent ? gatherSequenceExpressions([node2.consequent], scope2, declars) : scope2.buildUndefinedNode();
          var alternate = node2.alternate ? gatherSequenceExpressions([node2.alternate], scope2, declars) : scope2.buildUndefinedNode();
          if (!consequent || !alternate)
            return;
          exprs.push(conditionalExpression$3(node2.test, consequent, alternate));
        } else if (isBlockStatement$2(node2)) {
          var body = gatherSequenceExpressions(node2.body, scope2, declars);
          if (!body)
            return;
          exprs.push(body);
        } else if (isEmptyStatement$1(node2)) {
          if (nodes2.indexOf(node2) === 0) {
            ensureLastUndefined = true;
          }
        } else {
          return;
        }
      }
      if (ensureLastUndefined) {
        exprs.push(scope2.buildUndefinedNode());
      }
      if (exprs.length === 1) {
        return exprs[0];
      } else {
        return sequenceExpression$7(exprs);
      }
    }
    function toSequenceExpression$1(nodes2, scope2) {
      if (!(nodes2 != null && nodes2.length))
        return;
      var declars = [];
      var result = gatherSequenceExpressions(nodes2, scope2, declars);
      if (!result)
        return;
      for (var _i3 = 0, _declars = declars; _i3 < _declars.length; _i3++) {
        var declar = _declars[_i3];
        scope2.push(declar);
      }
      return result;
    }
    function toStatement(node2, ignore) {
      if (isStatement$7(node2)) {
        return node2;
      }
      var mustHaveId = false;
      var newType;
      if (isClass$1(node2)) {
        mustHaveId = true;
        newType = "ClassDeclaration";
      } else if (isFunction$32(node2)) {
        mustHaveId = true;
        newType = "FunctionDeclaration";
      } else if (isAssignmentExpression$4(node2)) {
        return expressionStatement$a(node2);
      }
      if (mustHaveId && !node2.id) {
        newType = false;
      }
      if (!newType) {
        if (ignore) {
          return false;
        } else {
          throw new Error("cannot turn " + node2.type + " to a statement");
        }
      }
      node2.type = newType;
      return node2;
    }
    var objectToString2 = Function.call.bind(Object.prototype.toString);
    function isRegExp2(value) {
      return objectToString2(value) === "[object RegExp]";
    }
    function isPlainObject(value) {
      if (typeof value !== "object" || value === null || Object.prototype.toString.call(value) !== "[object Object]") {
        return false;
      }
      var proto2 = Object.getPrototypeOf(value);
      return proto2 === null || Object.getPrototypeOf(proto2) === null;
    }
    function valueToNode$1(value) {
      if (value === void 0) {
        return identifier$j("undefined");
      }
      if (value === true || value === false) {
        return booleanLiteral$5(value);
      }
      if (value === null) {
        return nullLiteral$2();
      }
      if (typeof value === "string") {
        return stringLiteral$8(value);
      }
      if (typeof value === "number") {
        var result;
        if (Number.isFinite(value)) {
          result = numericLiteral$7(Math.abs(value));
        } else {
          var numerator;
          if (Number.isNaN(value)) {
            numerator = numericLiteral$7(0);
          } else {
            numerator = numericLiteral$7(1);
          }
          result = binaryExpression$4("/", numerator, numericLiteral$7(0));
        }
        if (value < 0 || Object.is(value, -0)) {
          result = unaryExpression$6("-", result);
        }
        return result;
      }
      if (isRegExp2(value)) {
        var pattern5 = value.source;
        var flags = value.toString().match(/\/([a-z]+|)$/)[1];
        return regExpLiteral(pattern5, flags);
      }
      if (Array.isArray(value)) {
        return arrayExpression$2(value.map(valueToNode$1));
      }
      if (isPlainObject(value)) {
        var props = [];
        for (var _i3 = 0, _Object$keys3 = Object.keys(value); _i3 < _Object$keys3.length; _i3++) {
          var key2 = _Object$keys3[_i3];
          var nodeKey = void 0;
          if (isValidIdentifier$1(key2)) {
            nodeKey = identifier$j(key2);
          } else {
            nodeKey = stringLiteral$8(key2);
          }
          props.push(objectProperty$2(nodeKey, valueToNode$1(value[key2])));
        }
        return objectExpression$4(props);
      }
      throw new Error("don't know how to turn this value into a node");
    }
    function appendToMemberExpression(member, append, computed) {
      if (computed === void 0) {
        computed = false;
      }
      member.object = memberExpression$b(member.object, member.property, member.computed);
      member.property = append;
      member.computed = !!computed;
      return member;
    }
    function inherits$1(child, parent) {
      if (!child || !parent)
        return child;
      for (var _iterator2 = _createForOfIteratorHelperLoose(INHERIT_KEYS.optional), _step2; !(_step2 = _iterator2()).done; ) {
        var _key = _step2.value;
        if (child[_key] == null) {
          child[_key] = parent[_key];
        }
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(parent); _i3 < _Object$keys3.length; _i3++) {
        var key2 = _Object$keys3[_i3];
        if (key2[0] === "_" && key2 !== "__clone")
          child[key2] = parent[key2];
      }
      for (var _iterator22 = _createForOfIteratorHelperLoose(INHERIT_KEYS.force), _step22; !(_step22 = _iterator22()).done; ) {
        var _key2 = _step22.value;
        child[_key2] = parent[_key2];
      }
      inheritsComments$2(child, parent);
      return child;
    }
    function prependToMemberExpression(member, prepend) {
      member.object = memberExpression$b(prepend, member.object);
      return member;
    }
    function getOuterBindingIdentifiers$2(node2, duplicates) {
      return getBindingIdentifiers$2(node2, duplicates, true);
    }
    function traverse$2(node2, handlers2, state) {
      if (typeof handlers2 === "function") {
        handlers2 = {
          enter: handlers2
        };
      }
      var _ref3 = handlers2, enter = _ref3.enter, exit = _ref3.exit;
      traverseSimpleImpl(node2, enter, exit, state, []);
    }
    function traverseSimpleImpl(node2, enter, exit, state, ancestors) {
      var keys2 = VISITOR_KEYS$7[node2.type];
      if (!keys2)
        return;
      if (enter)
        enter(node2, ancestors, state);
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        var subNode = node2[key2];
        if (Array.isArray(subNode)) {
          for (var i2 = 0; i2 < subNode.length; i2++) {
            var child = subNode[i2];
            if (!child)
              continue;
            ancestors.push({
              node: node2,
              key: key2,
              index: i2
            });
            traverseSimpleImpl(child, enter, exit, state, ancestors);
            ancestors.pop();
          }
        } else if (subNode) {
          ancestors.push({
            node: node2,
            key: key2
          });
          traverseSimpleImpl(subNode, enter, exit, state, ancestors);
          ancestors.pop();
        }
      }
      if (exit)
        exit(node2, ancestors, state);
    }
    function isBinding$1(node2, parent, grandparent) {
      if (grandparent && node2.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
        return false;
      }
      var keys2 = getBindingIdentifiers$2.keys[parent.type];
      if (keys2) {
        for (var i2 = 0; i2 < keys2.length; i2++) {
          var key2 = keys2[i2];
          var val = parent[key2];
          if (Array.isArray(val)) {
            if (val.indexOf(node2) >= 0)
              return true;
          } else {
            if (val === node2)
              return true;
          }
        }
      }
      return false;
    }
    function isLet(node2) {
      return isVariableDeclaration$3(node2) && (node2.kind !== "var" || node2[BLOCK_SCOPED_SYMBOL]);
    }
    function isBlockScoped$2(node2) {
      return isFunctionDeclaration$1(node2) || isClassDeclaration$3(node2) || isLet(node2);
    }
    function isImmutable(node2) {
      if (isType$2(node2.type, "Immutable"))
        return true;
      if (isIdentifier$i(node2)) {
        if (node2.name === "undefined") {
          return true;
        } else {
          return false;
        }
      }
      return false;
    }
    function isNodesEquivalent(a, b2) {
      if (typeof a !== "object" || typeof b2 !== "object" || a == null || b2 == null) {
        return a === b2;
      }
      if (a.type !== b2.type) {
        return false;
      }
      var fields = Object.keys(NODE_FIELDS[a.type] || a.type);
      var visitorKeys = VISITOR_KEYS$7[a.type];
      for (var _i3 = 0, _fields = fields; _i3 < _fields.length; _i3++) {
        var field = _fields[_i3];
        if (typeof a[field] !== typeof b2[field]) {
          return false;
        }
        if (a[field] == null && b2[field] == null) {
          continue;
        } else if (a[field] == null || b2[field] == null) {
          return false;
        }
        if (Array.isArray(a[field])) {
          if (!Array.isArray(b2[field])) {
            return false;
          }
          if (a[field].length !== b2[field].length) {
            return false;
          }
          for (var i2 = 0; i2 < a[field].length; i2++) {
            if (!isNodesEquivalent(a[field][i2], b2[field][i2])) {
              return false;
            }
          }
          continue;
        }
        if (typeof a[field] === "object" && !(visitorKeys != null && visitorKeys.includes(field))) {
          for (var _i22 = 0, _Object$keys3 = Object.keys(a[field]); _i22 < _Object$keys3.length; _i22++) {
            var key2 = _Object$keys3[_i22];
            if (a[field][key2] !== b2[field][key2]) {
              return false;
            }
          }
          continue;
        }
        if (!isNodesEquivalent(a[field], b2[field])) {
          return false;
        }
      }
      return true;
    }
    function isReferenced$2(node2, parent, grandparent) {
      switch (parent.type) {
        case "MemberExpression":
        case "OptionalMemberExpression":
          if (parent.property === node2) {
            return !!parent.computed;
          }
          return parent.object === node2;
        case "JSXMemberExpression":
          return parent.object === node2;
        case "VariableDeclarator":
          return parent.init === node2;
        case "ArrowFunctionExpression":
          return parent.body === node2;
        case "PrivateName":
          return false;
        case "ClassMethod":
        case "ClassPrivateMethod":
        case "ObjectMethod":
          if (parent.key === node2) {
            return !!parent.computed;
          }
          return false;
        case "ObjectProperty":
          if (parent.key === node2) {
            return !!parent.computed;
          }
          return !grandparent || grandparent.type !== "ObjectPattern";
        case "ClassProperty":
        case "ClassAccessorProperty":
          if (parent.key === node2) {
            return !!parent.computed;
          }
          return true;
        case "ClassPrivateProperty":
          return parent.key !== node2;
        case "ClassDeclaration":
        case "ClassExpression":
          return parent.superClass === node2;
        case "AssignmentExpression":
          return parent.right === node2;
        case "AssignmentPattern":
          return parent.right === node2;
        case "LabeledStatement":
          return false;
        case "CatchClause":
          return false;
        case "RestElement":
          return false;
        case "BreakStatement":
        case "ContinueStatement":
          return false;
        case "FunctionDeclaration":
        case "FunctionExpression":
          return false;
        case "ExportNamespaceSpecifier":
        case "ExportDefaultSpecifier":
          return false;
        case "ExportSpecifier":
          if (grandparent != null && grandparent.source) {
            return false;
          }
          return parent.local === node2;
        case "ImportDefaultSpecifier":
        case "ImportNamespaceSpecifier":
        case "ImportSpecifier":
          return false;
        case "ImportAttribute":
          return false;
        case "JSXAttribute":
          return false;
        case "ObjectPattern":
        case "ArrayPattern":
          return false;
        case "MetaProperty":
          return false;
        case "ObjectTypeProperty":
          return parent.key !== node2;
        case "TSEnumMember":
          return parent.id !== node2;
        case "TSPropertySignature":
          if (parent.key === node2) {
            return !!parent.computed;
          }
          return true;
      }
      return true;
    }
    function isScope$1(node2, parent) {
      if (isBlockStatement$2(node2) && (isFunction$32(parent) || isCatchClause(parent))) {
        return false;
      }
      if (isPattern2(node2) && (isFunction$32(parent) || isCatchClause(parent))) {
        return true;
      }
      return isScopable(node2);
    }
    function isSpecifierDefault(specifier) {
      return isImportDefaultSpecifier$1(specifier) || isIdentifier$i(specifier.imported || specifier.exported, {
        name: "default"
      });
    }
    var RESERVED_WORDS_ES3_ONLY = /* @__PURE__ */ new Set(["abstract", "boolean", "byte", "char", "double", "enum", "final", "float", "goto", "implements", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "synchronized", "throws", "transient", "volatile"]);
    function isValidES3Identifier(name2) {
      return isValidIdentifier$1(name2) && !RESERVED_WORDS_ES3_ONLY.has(name2);
    }
    function isVar$2(node2) {
      return isVariableDeclaration$3(node2, {
        kind: "var"
      }) && !node2[BLOCK_SCOPED_SYMBOL];
    }
    var react$3 = {
      isReactComponent,
      isCompatTag: isCompatTag$1,
      buildChildren
    };
    var t$a = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      react: react$3,
      assertNode,
      createTypeAnnotationBasedOnTypeof: createTypeAnnotationBasedOnTypeof$1,
      createUnionTypeAnnotation: createFlowUnionType$2,
      createFlowUnionType: createFlowUnionType$2,
      createTSUnionType: createTSUnionType$2,
      cloneNode: cloneNode$i,
      clone: clone3,
      cloneDeep: cloneDeep$1,
      cloneDeepWithoutLoc,
      cloneWithoutLoc,
      addComment: addComment$2,
      addComments: addComments$1,
      inheritInnerComments,
      inheritLeadingComments: inheritLeadingComments$1,
      inheritsComments: inheritsComments$2,
      inheritTrailingComments: inheritTrailingComments$1,
      removeComments: removeComments$2,
      ensureBlock: ensureBlock$1,
      toBindingIdentifierName: toBindingIdentifierName$1,
      toBlock,
      toComputedKey: toComputedKey$3,
      toExpression: toExpression$1,
      toIdentifier: toIdentifier$1,
      toKeyAlias: toKeyAlias$1,
      toSequenceExpression: toSequenceExpression$1,
      toStatement,
      valueToNode: valueToNode$1,
      appendToMemberExpression,
      inherits: inherits$1,
      prependToMemberExpression,
      removeProperties: removeProperties$1,
      removePropertiesDeep: removePropertiesDeep$1,
      removeTypeDuplicates: removeTypeDuplicates$1,
      getBindingIdentifiers: getBindingIdentifiers$2,
      getOuterBindingIdentifiers: getOuterBindingIdentifiers$2,
      traverse: traverse$2,
      traverseFast: traverseFast$2,
      shallowEqual: shallowEqual2,
      is: is$1,
      isBinding: isBinding$1,
      isBlockScoped: isBlockScoped$2,
      isImmutable,
      isLet,
      isNode,
      isNodesEquivalent,
      isPlaceholderType,
      isReferenced: isReferenced$2,
      isScope: isScope$1,
      isSpecifierDefault,
      isType: isType$2,
      isValidES3Identifier,
      isValidIdentifier: isValidIdentifier$1,
      isVar: isVar$2,
      matchesPattern: matchesPattern$2,
      validate: validate$6,
      buildMatchMemberExpression: buildMatchMemberExpression$1,
      assertArrayExpression,
      assertAssignmentExpression,
      assertBinaryExpression,
      assertInterpreterDirective,
      assertDirective,
      assertDirectiveLiteral,
      assertBlockStatement,
      assertBreakStatement,
      assertCallExpression,
      assertCatchClause,
      assertConditionalExpression,
      assertContinueStatement,
      assertDebuggerStatement,
      assertDoWhileStatement,
      assertEmptyStatement,
      assertExpressionStatement: assertExpressionStatement$1,
      assertFile,
      assertForInStatement,
      assertForStatement,
      assertFunctionDeclaration,
      assertFunctionExpression,
      assertIdentifier,
      assertIfStatement,
      assertLabeledStatement,
      assertStringLiteral,
      assertNumericLiteral,
      assertNullLiteral,
      assertBooleanLiteral,
      assertRegExpLiteral,
      assertLogicalExpression,
      assertMemberExpression,
      assertNewExpression,
      assertProgram,
      assertObjectExpression,
      assertObjectMethod,
      assertObjectProperty,
      assertRestElement,
      assertReturnStatement,
      assertSequenceExpression,
      assertParenthesizedExpression,
      assertSwitchCase,
      assertSwitchStatement,
      assertThisExpression,
      assertThrowStatement,
      assertTryStatement,
      assertUnaryExpression,
      assertUpdateExpression,
      assertVariableDeclaration,
      assertVariableDeclarator,
      assertWhileStatement,
      assertWithStatement,
      assertAssignmentPattern,
      assertArrayPattern,
      assertArrowFunctionExpression,
      assertClassBody,
      assertClassExpression,
      assertClassDeclaration,
      assertExportAllDeclaration,
      assertExportDefaultDeclaration,
      assertExportNamedDeclaration,
      assertExportSpecifier: assertExportSpecifier$1,
      assertForOfStatement,
      assertImportDeclaration,
      assertImportDefaultSpecifier,
      assertImportNamespaceSpecifier,
      assertImportSpecifier,
      assertMetaProperty,
      assertClassMethod,
      assertObjectPattern,
      assertSpreadElement,
      assertSuper,
      assertTaggedTemplateExpression,
      assertTemplateElement,
      assertTemplateLiteral,
      assertYieldExpression,
      assertAwaitExpression,
      assertImport,
      assertBigIntLiteral,
      assertExportNamespaceSpecifier,
      assertOptionalMemberExpression,
      assertOptionalCallExpression,
      assertClassProperty,
      assertClassAccessorProperty,
      assertClassPrivateProperty,
      assertClassPrivateMethod,
      assertPrivateName,
      assertStaticBlock,
      assertAnyTypeAnnotation,
      assertArrayTypeAnnotation,
      assertBooleanTypeAnnotation,
      assertBooleanLiteralTypeAnnotation,
      assertNullLiteralTypeAnnotation,
      assertClassImplements,
      assertDeclareClass,
      assertDeclareFunction,
      assertDeclareInterface,
      assertDeclareModule,
      assertDeclareModuleExports,
      assertDeclareTypeAlias,
      assertDeclareOpaqueType,
      assertDeclareVariable,
      assertDeclareExportDeclaration,
      assertDeclareExportAllDeclaration,
      assertDeclaredPredicate,
      assertExistsTypeAnnotation,
      assertFunctionTypeAnnotation,
      assertFunctionTypeParam,
      assertGenericTypeAnnotation,
      assertInferredPredicate,
      assertInterfaceExtends,
      assertInterfaceDeclaration,
      assertInterfaceTypeAnnotation,
      assertIntersectionTypeAnnotation,
      assertMixedTypeAnnotation,
      assertEmptyTypeAnnotation,
      assertNullableTypeAnnotation,
      assertNumberLiteralTypeAnnotation,
      assertNumberTypeAnnotation,
      assertObjectTypeAnnotation,
      assertObjectTypeInternalSlot,
      assertObjectTypeCallProperty,
      assertObjectTypeIndexer,
      assertObjectTypeProperty,
      assertObjectTypeSpreadProperty,
      assertOpaqueType,
      assertQualifiedTypeIdentifier,
      assertStringLiteralTypeAnnotation,
      assertStringTypeAnnotation,
      assertSymbolTypeAnnotation,
      assertThisTypeAnnotation,
      assertTupleTypeAnnotation,
      assertTypeofTypeAnnotation,
      assertTypeAlias,
      assertTypeAnnotation,
      assertTypeCastExpression,
      assertTypeParameter,
      assertTypeParameterDeclaration,
      assertTypeParameterInstantiation,
      assertUnionTypeAnnotation,
      assertVariance,
      assertVoidTypeAnnotation,
      assertEnumDeclaration,
      assertEnumBooleanBody,
      assertEnumNumberBody,
      assertEnumStringBody,
      assertEnumSymbolBody,
      assertEnumBooleanMember,
      assertEnumNumberMember,
      assertEnumStringMember,
      assertEnumDefaultedMember,
      assertIndexedAccessType,
      assertOptionalIndexedAccessType,
      assertJSXAttribute,
      assertJSXClosingElement,
      assertJSXElement,
      assertJSXEmptyExpression,
      assertJSXExpressionContainer,
      assertJSXSpreadChild,
      assertJSXIdentifier,
      assertJSXMemberExpression,
      assertJSXNamespacedName,
      assertJSXOpeningElement,
      assertJSXSpreadAttribute,
      assertJSXText,
      assertJSXFragment,
      assertJSXOpeningFragment,
      assertJSXClosingFragment,
      assertNoop,
      assertPlaceholder,
      assertV8IntrinsicIdentifier,
      assertArgumentPlaceholder,
      assertBindExpression,
      assertImportAttribute,
      assertDecorator,
      assertDoExpression,
      assertExportDefaultSpecifier,
      assertRecordExpression,
      assertTupleExpression,
      assertDecimalLiteral,
      assertModuleExpression,
      assertTopicReference,
      assertPipelineTopicExpression,
      assertPipelineBareFunction,
      assertPipelinePrimaryTopicReference,
      assertTSParameterProperty,
      assertTSDeclareFunction,
      assertTSDeclareMethod,
      assertTSQualifiedName,
      assertTSCallSignatureDeclaration,
      assertTSConstructSignatureDeclaration,
      assertTSPropertySignature,
      assertTSMethodSignature,
      assertTSIndexSignature,
      assertTSAnyKeyword,
      assertTSBooleanKeyword,
      assertTSBigIntKeyword,
      assertTSIntrinsicKeyword,
      assertTSNeverKeyword,
      assertTSNullKeyword,
      assertTSNumberKeyword,
      assertTSObjectKeyword,
      assertTSStringKeyword,
      assertTSSymbolKeyword,
      assertTSUndefinedKeyword,
      assertTSUnknownKeyword,
      assertTSVoidKeyword,
      assertTSThisType,
      assertTSFunctionType,
      assertTSConstructorType,
      assertTSTypeReference,
      assertTSTypePredicate,
      assertTSTypeQuery,
      assertTSTypeLiteral,
      assertTSArrayType,
      assertTSTupleType,
      assertTSOptionalType,
      assertTSRestType,
      assertTSNamedTupleMember,
      assertTSUnionType,
      assertTSIntersectionType,
      assertTSConditionalType,
      assertTSInferType,
      assertTSParenthesizedType,
      assertTSTypeOperator,
      assertTSIndexedAccessType,
      assertTSMappedType,
      assertTSLiteralType,
      assertTSExpressionWithTypeArguments,
      assertTSInterfaceDeclaration,
      assertTSInterfaceBody,
      assertTSTypeAliasDeclaration,
      assertTSAsExpression,
      assertTSTypeAssertion,
      assertTSEnumDeclaration,
      assertTSEnumMember,
      assertTSModuleDeclaration,
      assertTSModuleBlock,
      assertTSImportType,
      assertTSImportEqualsDeclaration,
      assertTSExternalModuleReference,
      assertTSNonNullExpression,
      assertTSExportAssignment,
      assertTSNamespaceExportDeclaration,
      assertTSTypeAnnotation,
      assertTSTypeParameterInstantiation,
      assertTSTypeParameterDeclaration,
      assertTSTypeParameter,
      assertStandardized,
      assertExpression: assertExpression$1,
      assertBinary,
      assertScopable,
      assertBlockParent,
      assertBlock,
      assertStatement,
      assertTerminatorless,
      assertCompletionStatement,
      assertConditional,
      assertLoop,
      assertWhile,
      assertExpressionWrapper,
      assertFor,
      assertForXStatement,
      assertFunction: assertFunction$1,
      assertFunctionParent,
      assertPureish,
      assertDeclaration,
      assertPatternLike,
      assertLVal,
      assertTSEntityName,
      assertLiteral,
      assertImmutable,
      assertUserWhitespacable,
      assertMethod,
      assertObjectMember,
      assertProperty,
      assertUnaryLike,
      assertPattern,
      assertClass,
      assertModuleDeclaration,
      assertExportDeclaration,
      assertModuleSpecifier,
      assertAccessor,
      assertPrivate,
      assertFlow,
      assertFlowType,
      assertFlowBaseAnnotation,
      assertFlowDeclaration,
      assertFlowPredicate,
      assertEnumBody,
      assertEnumMember,
      assertJSX,
      assertMiscellaneous,
      assertTypeScript,
      assertTSTypeElement,
      assertTSType,
      assertTSBaseType,
      assertNumberLiteral,
      assertRegexLiteral,
      assertRestProperty,
      assertSpreadProperty,
      arrayExpression: arrayExpression$2,
      assignmentExpression: assignmentExpression$c,
      binaryExpression: binaryExpression$4,
      interpreterDirective: interpreterDirective$1,
      directive: directive$1,
      directiveLiteral: directiveLiteral$1,
      blockStatement: blockStatement$6,
      breakStatement,
      callExpression: callExpression$e,
      catchClause,
      conditionalExpression: conditionalExpression$3,
      continueStatement,
      debuggerStatement,
      doWhileStatement,
      emptyStatement: emptyStatement$1,
      expressionStatement: expressionStatement$a,
      file: file$2,
      forInStatement,
      forStatement,
      functionDeclaration,
      functionExpression: functionExpression$3,
      identifier: identifier$j,
      ifStatement,
      labeledStatement,
      stringLiteral: stringLiteral$8,
      numericLiteral: numericLiteral$7,
      nullLiteral: nullLiteral$2,
      booleanLiteral: booleanLiteral$5,
      regExpLiteral,
      logicalExpression: logicalExpression$3,
      memberExpression: memberExpression$b,
      newExpression,
      program: program$3,
      objectExpression: objectExpression$4,
      objectMethod,
      objectProperty: objectProperty$2,
      restElement: restElement$1,
      returnStatement: returnStatement$3,
      sequenceExpression: sequenceExpression$7,
      parenthesizedExpression,
      switchCase,
      switchStatement,
      thisExpression: thisExpression$4,
      throwStatement,
      tryStatement,
      unaryExpression: unaryExpression$6,
      updateExpression: updateExpression$1,
      variableDeclaration: variableDeclaration$7,
      variableDeclarator: variableDeclarator$7,
      whileStatement,
      withStatement,
      assignmentPattern,
      arrayPattern,
      arrowFunctionExpression: arrowFunctionExpression$4,
      classBody,
      classExpression,
      classDeclaration,
      exportAllDeclaration,
      exportDefaultDeclaration,
      exportNamedDeclaration: exportNamedDeclaration$2,
      exportSpecifier: exportSpecifier$2,
      forOfStatement,
      importDeclaration: importDeclaration$1,
      importDefaultSpecifier: importDefaultSpecifier$1,
      importNamespaceSpecifier: importNamespaceSpecifier$1,
      importSpecifier: importSpecifier$1,
      metaProperty: metaProperty$1,
      classMethod,
      objectPattern,
      spreadElement: spreadElement$2,
      "super": _super$1,
      taggedTemplateExpression,
      templateElement,
      templateLiteral,
      yieldExpression: yieldExpression$2,
      awaitExpression: awaitExpression$1,
      "import": _import,
      bigIntLiteral,
      exportNamespaceSpecifier,
      optionalMemberExpression: optionalMemberExpression$2,
      optionalCallExpression: optionalCallExpression$2,
      classProperty,
      classAccessorProperty,
      classPrivateProperty,
      classPrivateMethod,
      privateName,
      staticBlock: staticBlock$1,
      anyTypeAnnotation: anyTypeAnnotation$2,
      arrayTypeAnnotation: arrayTypeAnnotation$1,
      booleanTypeAnnotation: booleanTypeAnnotation$1,
      booleanLiteralTypeAnnotation,
      nullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
      classImplements,
      declareClass,
      declareFunction,
      declareInterface,
      declareModule,
      declareModuleExports,
      declareTypeAlias,
      declareOpaqueType,
      declareVariable,
      declareExportDeclaration,
      declareExportAllDeclaration,
      declaredPredicate,
      existsTypeAnnotation,
      functionTypeAnnotation,
      functionTypeParam,
      genericTypeAnnotation: genericTypeAnnotation$1,
      inferredPredicate,
      interfaceExtends,
      interfaceDeclaration,
      interfaceTypeAnnotation,
      intersectionTypeAnnotation,
      mixedTypeAnnotation,
      emptyTypeAnnotation,
      nullableTypeAnnotation,
      numberLiteralTypeAnnotation,
      numberTypeAnnotation: numberTypeAnnotation$2,
      objectTypeAnnotation,
      objectTypeInternalSlot,
      objectTypeCallProperty,
      objectTypeIndexer,
      objectTypeProperty,
      objectTypeSpreadProperty,
      opaqueType,
      qualifiedTypeIdentifier,
      stringLiteralTypeAnnotation,
      stringTypeAnnotation: stringTypeAnnotation$2,
      symbolTypeAnnotation,
      thisTypeAnnotation,
      tupleTypeAnnotation: tupleTypeAnnotation$1,
      typeofTypeAnnotation,
      typeAlias,
      typeAnnotation,
      typeCastExpression,
      typeParameter,
      typeParameterDeclaration,
      typeParameterInstantiation,
      unionTypeAnnotation: unionTypeAnnotation$1,
      variance,
      voidTypeAnnotation: voidTypeAnnotation$3,
      enumDeclaration,
      enumBooleanBody,
      enumNumberBody,
      enumStringBody,
      enumSymbolBody,
      enumBooleanMember,
      enumNumberMember,
      enumStringMember,
      enumDefaultedMember,
      indexedAccessType,
      optionalIndexedAccessType,
      jsxAttribute,
      jSXAttribute: jsxAttribute,
      jsxClosingElement,
      jSXClosingElement: jsxClosingElement,
      jsxElement,
      jSXElement: jsxElement,
      jsxEmptyExpression,
      jSXEmptyExpression: jsxEmptyExpression,
      jsxExpressionContainer: jsxExpressionContainer$1,
      jSXExpressionContainer: jsxExpressionContainer$1,
      jsxSpreadChild,
      jSXSpreadChild: jsxSpreadChild,
      jsxIdentifier: jsxIdentifier$2,
      jSXIdentifier: jsxIdentifier$2,
      jsxMemberExpression: jsxMemberExpression$1,
      jSXMemberExpression: jsxMemberExpression$1,
      jsxNamespacedName,
      jSXNamespacedName: jsxNamespacedName,
      jsxOpeningElement,
      jSXOpeningElement: jsxOpeningElement,
      jsxSpreadAttribute,
      jSXSpreadAttribute: jsxSpreadAttribute,
      jsxText,
      jSXText: jsxText,
      jsxFragment,
      jSXFragment: jsxFragment,
      jsxOpeningFragment,
      jSXOpeningFragment: jsxOpeningFragment,
      jsxClosingFragment,
      jSXClosingFragment: jsxClosingFragment,
      noop: noop$12,
      placeholder,
      v8IntrinsicIdentifier,
      argumentPlaceholder,
      bindExpression,
      importAttribute,
      decorator,
      doExpression,
      exportDefaultSpecifier,
      recordExpression,
      tupleExpression,
      decimalLiteral,
      moduleExpression,
      topicReference,
      pipelineTopicExpression,
      pipelineBareFunction,
      pipelinePrimaryTopicReference,
      tsParameterProperty,
      tSParameterProperty: tsParameterProperty,
      tsDeclareFunction,
      tSDeclareFunction: tsDeclareFunction,
      tsDeclareMethod,
      tSDeclareMethod: tsDeclareMethod,
      tsQualifiedName,
      tSQualifiedName: tsQualifiedName,
      tsCallSignatureDeclaration,
      tSCallSignatureDeclaration: tsCallSignatureDeclaration,
      tsConstructSignatureDeclaration,
      tSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
      tsPropertySignature,
      tSPropertySignature: tsPropertySignature,
      tsMethodSignature,
      tSMethodSignature: tsMethodSignature,
      tsIndexSignature,
      tSIndexSignature: tsIndexSignature,
      tsAnyKeyword,
      tSAnyKeyword: tsAnyKeyword,
      tsBooleanKeyword,
      tSBooleanKeyword: tsBooleanKeyword,
      tsBigIntKeyword,
      tSBigIntKeyword: tsBigIntKeyword,
      tsIntrinsicKeyword,
      tSIntrinsicKeyword: tsIntrinsicKeyword,
      tsNeverKeyword,
      tSNeverKeyword: tsNeverKeyword,
      tsNullKeyword,
      tSNullKeyword: tsNullKeyword,
      tsNumberKeyword,
      tSNumberKeyword: tsNumberKeyword,
      tsObjectKeyword,
      tSObjectKeyword: tsObjectKeyword,
      tsStringKeyword,
      tSStringKeyword: tsStringKeyword,
      tsSymbolKeyword,
      tSSymbolKeyword: tsSymbolKeyword,
      tsUndefinedKeyword,
      tSUndefinedKeyword: tsUndefinedKeyword,
      tsUnknownKeyword,
      tSUnknownKeyword: tsUnknownKeyword,
      tsVoidKeyword,
      tSVoidKeyword: tsVoidKeyword,
      tsThisType,
      tSThisType: tsThisType,
      tsFunctionType,
      tSFunctionType: tsFunctionType,
      tsConstructorType,
      tSConstructorType: tsConstructorType,
      tsTypeReference,
      tSTypeReference: tsTypeReference,
      tsTypePredicate,
      tSTypePredicate: tsTypePredicate,
      tsTypeQuery,
      tSTypeQuery: tsTypeQuery,
      tsTypeLiteral,
      tSTypeLiteral: tsTypeLiteral,
      tsArrayType,
      tSArrayType: tsArrayType,
      tsTupleType,
      tSTupleType: tsTupleType,
      tsOptionalType,
      tSOptionalType: tsOptionalType,
      tsRestType,
      tSRestType: tsRestType,
      tsNamedTupleMember,
      tSNamedTupleMember: tsNamedTupleMember,
      tsUnionType,
      tSUnionType: tsUnionType,
      tsIntersectionType,
      tSIntersectionType: tsIntersectionType,
      tsConditionalType,
      tSConditionalType: tsConditionalType,
      tsInferType,
      tSInferType: tsInferType,
      tsParenthesizedType,
      tSParenthesizedType: tsParenthesizedType,
      tsTypeOperator,
      tSTypeOperator: tsTypeOperator,
      tsIndexedAccessType,
      tSIndexedAccessType: tsIndexedAccessType,
      tsMappedType,
      tSMappedType: tsMappedType,
      tsLiteralType,
      tSLiteralType: tsLiteralType,
      tsExpressionWithTypeArguments,
      tSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
      tsInterfaceDeclaration,
      tSInterfaceDeclaration: tsInterfaceDeclaration,
      tsInterfaceBody,
      tSInterfaceBody: tsInterfaceBody,
      tsTypeAliasDeclaration,
      tSTypeAliasDeclaration: tsTypeAliasDeclaration,
      tsAsExpression,
      tSAsExpression: tsAsExpression,
      tsTypeAssertion,
      tSTypeAssertion: tsTypeAssertion,
      tsEnumDeclaration,
      tSEnumDeclaration: tsEnumDeclaration,
      tsEnumMember,
      tSEnumMember: tsEnumMember,
      tsModuleDeclaration,
      tSModuleDeclaration: tsModuleDeclaration,
      tsModuleBlock,
      tSModuleBlock: tsModuleBlock,
      tsImportType,
      tSImportType: tsImportType,
      tsImportEqualsDeclaration,
      tSImportEqualsDeclaration: tsImportEqualsDeclaration,
      tsExternalModuleReference,
      tSExternalModuleReference: tsExternalModuleReference,
      tsNonNullExpression,
      tSNonNullExpression: tsNonNullExpression,
      tsExportAssignment,
      tSExportAssignment: tsExportAssignment,
      tsNamespaceExportDeclaration,
      tSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
      tsTypeAnnotation,
      tSTypeAnnotation: tsTypeAnnotation,
      tsTypeParameterInstantiation,
      tSTypeParameterInstantiation: tsTypeParameterInstantiation,
      tsTypeParameterDeclaration,
      tSTypeParameterDeclaration: tsTypeParameterDeclaration,
      tsTypeParameter,
      tSTypeParameter: tsTypeParameter,
      numberLiteral: NumberLiteral,
      regexLiteral: RegexLiteral,
      restProperty: RestProperty$1,
      spreadProperty: SpreadProperty$1,
      ArrayExpression: arrayExpression$2,
      AssignmentExpression: assignmentExpression$c,
      BinaryExpression: binaryExpression$4,
      InterpreterDirective: interpreterDirective$1,
      Directive: directive$1,
      DirectiveLiteral: directiveLiteral$1,
      BlockStatement: blockStatement$6,
      BreakStatement: breakStatement,
      CallExpression: callExpression$e,
      CatchClause: catchClause,
      ConditionalExpression: conditionalExpression$3,
      ContinueStatement: continueStatement,
      DebuggerStatement: debuggerStatement,
      DoWhileStatement: doWhileStatement,
      EmptyStatement: emptyStatement$1,
      ExpressionStatement: expressionStatement$a,
      File: file$2,
      ForInStatement: forInStatement,
      ForStatement: forStatement,
      FunctionDeclaration: functionDeclaration,
      FunctionExpression: functionExpression$3,
      Identifier: identifier$j,
      IfStatement: ifStatement,
      LabeledStatement: labeledStatement,
      StringLiteral: stringLiteral$8,
      NumericLiteral: numericLiteral$7,
      NullLiteral: nullLiteral$2,
      BooleanLiteral: booleanLiteral$5,
      RegExpLiteral: regExpLiteral,
      LogicalExpression: logicalExpression$3,
      MemberExpression: memberExpression$b,
      NewExpression: newExpression,
      Program: program$3,
      ObjectExpression: objectExpression$4,
      ObjectMethod: objectMethod,
      ObjectProperty: objectProperty$2,
      RestElement: restElement$1,
      ReturnStatement: returnStatement$3,
      SequenceExpression: sequenceExpression$7,
      ParenthesizedExpression: parenthesizedExpression,
      SwitchCase: switchCase,
      SwitchStatement: switchStatement,
      ThisExpression: thisExpression$4,
      ThrowStatement: throwStatement,
      TryStatement: tryStatement,
      UnaryExpression: unaryExpression$6,
      UpdateExpression: updateExpression$1,
      VariableDeclaration: variableDeclaration$7,
      VariableDeclarator: variableDeclarator$7,
      WhileStatement: whileStatement,
      WithStatement: withStatement,
      AssignmentPattern: assignmentPattern,
      ArrayPattern: arrayPattern,
      ArrowFunctionExpression: arrowFunctionExpression$4,
      ClassBody: classBody,
      ClassExpression: classExpression,
      ClassDeclaration: classDeclaration,
      ExportAllDeclaration: exportAllDeclaration,
      ExportDefaultDeclaration: exportDefaultDeclaration,
      ExportNamedDeclaration: exportNamedDeclaration$2,
      ExportSpecifier: exportSpecifier$2,
      ForOfStatement: forOfStatement,
      ImportDeclaration: importDeclaration$1,
      ImportDefaultSpecifier: importDefaultSpecifier$1,
      ImportNamespaceSpecifier: importNamespaceSpecifier$1,
      ImportSpecifier: importSpecifier$1,
      MetaProperty: metaProperty$1,
      ClassMethod: classMethod,
      ObjectPattern: objectPattern,
      SpreadElement: spreadElement$2,
      Super: _super$1,
      TaggedTemplateExpression: taggedTemplateExpression,
      TemplateElement: templateElement,
      TemplateLiteral: templateLiteral,
      YieldExpression: yieldExpression$2,
      AwaitExpression: awaitExpression$1,
      Import: _import,
      BigIntLiteral: bigIntLiteral,
      ExportNamespaceSpecifier: exportNamespaceSpecifier,
      OptionalMemberExpression: optionalMemberExpression$2,
      OptionalCallExpression: optionalCallExpression$2,
      ClassProperty: classProperty,
      ClassAccessorProperty: classAccessorProperty,
      ClassPrivateProperty: classPrivateProperty,
      ClassPrivateMethod: classPrivateMethod,
      PrivateName: privateName,
      StaticBlock: staticBlock$1,
      AnyTypeAnnotation: anyTypeAnnotation$2,
      ArrayTypeAnnotation: arrayTypeAnnotation$1,
      BooleanTypeAnnotation: booleanTypeAnnotation$1,
      BooleanLiteralTypeAnnotation: booleanLiteralTypeAnnotation,
      NullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
      ClassImplements: classImplements,
      DeclareClass: declareClass,
      DeclareFunction: declareFunction,
      DeclareInterface: declareInterface,
      DeclareModule: declareModule,
      DeclareModuleExports: declareModuleExports,
      DeclareTypeAlias: declareTypeAlias,
      DeclareOpaqueType: declareOpaqueType,
      DeclareVariable: declareVariable,
      DeclareExportDeclaration: declareExportDeclaration,
      DeclareExportAllDeclaration: declareExportAllDeclaration,
      DeclaredPredicate: declaredPredicate,
      ExistsTypeAnnotation: existsTypeAnnotation,
      FunctionTypeAnnotation: functionTypeAnnotation,
      FunctionTypeParam: functionTypeParam,
      GenericTypeAnnotation: genericTypeAnnotation$1,
      InferredPredicate: inferredPredicate,
      InterfaceExtends: interfaceExtends,
      InterfaceDeclaration: interfaceDeclaration,
      InterfaceTypeAnnotation: interfaceTypeAnnotation,
      IntersectionTypeAnnotation: intersectionTypeAnnotation,
      MixedTypeAnnotation: mixedTypeAnnotation,
      EmptyTypeAnnotation: emptyTypeAnnotation,
      NullableTypeAnnotation: nullableTypeAnnotation,
      NumberLiteralTypeAnnotation: numberLiteralTypeAnnotation,
      NumberTypeAnnotation: numberTypeAnnotation$2,
      ObjectTypeAnnotation: objectTypeAnnotation,
      ObjectTypeInternalSlot: objectTypeInternalSlot,
      ObjectTypeCallProperty: objectTypeCallProperty,
      ObjectTypeIndexer: objectTypeIndexer,
      ObjectTypeProperty: objectTypeProperty,
      ObjectTypeSpreadProperty: objectTypeSpreadProperty,
      OpaqueType: opaqueType,
      QualifiedTypeIdentifier: qualifiedTypeIdentifier,
      StringLiteralTypeAnnotation: stringLiteralTypeAnnotation,
      StringTypeAnnotation: stringTypeAnnotation$2,
      SymbolTypeAnnotation: symbolTypeAnnotation,
      ThisTypeAnnotation: thisTypeAnnotation,
      TupleTypeAnnotation: tupleTypeAnnotation$1,
      TypeofTypeAnnotation: typeofTypeAnnotation,
      TypeAlias: typeAlias,
      TypeAnnotation: typeAnnotation,
      TypeCastExpression: typeCastExpression,
      TypeParameter: typeParameter,
      TypeParameterDeclaration: typeParameterDeclaration,
      TypeParameterInstantiation: typeParameterInstantiation,
      UnionTypeAnnotation: unionTypeAnnotation$1,
      Variance: variance,
      VoidTypeAnnotation: voidTypeAnnotation$3,
      EnumDeclaration: enumDeclaration,
      EnumBooleanBody: enumBooleanBody,
      EnumNumberBody: enumNumberBody,
      EnumStringBody: enumStringBody,
      EnumSymbolBody: enumSymbolBody,
      EnumBooleanMember: enumBooleanMember,
      EnumNumberMember: enumNumberMember,
      EnumStringMember: enumStringMember,
      EnumDefaultedMember: enumDefaultedMember,
      IndexedAccessType: indexedAccessType,
      OptionalIndexedAccessType: optionalIndexedAccessType,
      JSXAttribute: jsxAttribute,
      JSXClosingElement: jsxClosingElement,
      JSXElement: jsxElement,
      JSXEmptyExpression: jsxEmptyExpression,
      JSXExpressionContainer: jsxExpressionContainer$1,
      JSXSpreadChild: jsxSpreadChild,
      JSXIdentifier: jsxIdentifier$2,
      JSXMemberExpression: jsxMemberExpression$1,
      JSXNamespacedName: jsxNamespacedName,
      JSXOpeningElement: jsxOpeningElement,
      JSXSpreadAttribute: jsxSpreadAttribute,
      JSXText: jsxText,
      JSXFragment: jsxFragment,
      JSXOpeningFragment: jsxOpeningFragment,
      JSXClosingFragment: jsxClosingFragment,
      Noop: noop$12,
      Placeholder: placeholder,
      V8IntrinsicIdentifier: v8IntrinsicIdentifier,
      ArgumentPlaceholder: argumentPlaceholder,
      BindExpression: bindExpression,
      ImportAttribute: importAttribute,
      Decorator: decorator,
      DoExpression: doExpression,
      ExportDefaultSpecifier: exportDefaultSpecifier,
      RecordExpression: recordExpression,
      TupleExpression: tupleExpression,
      DecimalLiteral: decimalLiteral,
      ModuleExpression: moduleExpression,
      TopicReference: topicReference,
      PipelineTopicExpression: pipelineTopicExpression,
      PipelineBareFunction: pipelineBareFunction,
      PipelinePrimaryTopicReference: pipelinePrimaryTopicReference,
      TSParameterProperty: tsParameterProperty,
      TSDeclareFunction: tsDeclareFunction,
      TSDeclareMethod: tsDeclareMethod,
      TSQualifiedName: tsQualifiedName,
      TSCallSignatureDeclaration: tsCallSignatureDeclaration,
      TSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
      TSPropertySignature: tsPropertySignature,
      TSMethodSignature: tsMethodSignature,
      TSIndexSignature: tsIndexSignature,
      TSAnyKeyword: tsAnyKeyword,
      TSBooleanKeyword: tsBooleanKeyword,
      TSBigIntKeyword: tsBigIntKeyword,
      TSIntrinsicKeyword: tsIntrinsicKeyword,
      TSNeverKeyword: tsNeverKeyword,
      TSNullKeyword: tsNullKeyword,
      TSNumberKeyword: tsNumberKeyword,
      TSObjectKeyword: tsObjectKeyword,
      TSStringKeyword: tsStringKeyword,
      TSSymbolKeyword: tsSymbolKeyword,
      TSUndefinedKeyword: tsUndefinedKeyword,
      TSUnknownKeyword: tsUnknownKeyword,
      TSVoidKeyword: tsVoidKeyword,
      TSThisType: tsThisType,
      TSFunctionType: tsFunctionType,
      TSConstructorType: tsConstructorType,
      TSTypeReference: tsTypeReference,
      TSTypePredicate: tsTypePredicate,
      TSTypeQuery: tsTypeQuery,
      TSTypeLiteral: tsTypeLiteral,
      TSArrayType: tsArrayType,
      TSTupleType: tsTupleType,
      TSOptionalType: tsOptionalType,
      TSRestType: tsRestType,
      TSNamedTupleMember: tsNamedTupleMember,
      TSUnionType: tsUnionType,
      TSIntersectionType: tsIntersectionType,
      TSConditionalType: tsConditionalType,
      TSInferType: tsInferType,
      TSParenthesizedType: tsParenthesizedType,
      TSTypeOperator: tsTypeOperator,
      TSIndexedAccessType: tsIndexedAccessType,
      TSMappedType: tsMappedType,
      TSLiteralType: tsLiteralType,
      TSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
      TSInterfaceDeclaration: tsInterfaceDeclaration,
      TSInterfaceBody: tsInterfaceBody,
      TSTypeAliasDeclaration: tsTypeAliasDeclaration,
      TSAsExpression: tsAsExpression,
      TSTypeAssertion: tsTypeAssertion,
      TSEnumDeclaration: tsEnumDeclaration,
      TSEnumMember: tsEnumMember,
      TSModuleDeclaration: tsModuleDeclaration,
      TSModuleBlock: tsModuleBlock,
      TSImportType: tsImportType,
      TSImportEqualsDeclaration: tsImportEqualsDeclaration,
      TSExternalModuleReference: tsExternalModuleReference,
      TSNonNullExpression: tsNonNullExpression,
      TSExportAssignment: tsExportAssignment,
      TSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
      TSTypeAnnotation: tsTypeAnnotation,
      TSTypeParameterInstantiation: tsTypeParameterInstantiation,
      TSTypeParameterDeclaration: tsTypeParameterDeclaration,
      TSTypeParameter: tsTypeParameter,
      NumberLiteral,
      RegexLiteral,
      RestProperty: RestProperty$1,
      SpreadProperty: SpreadProperty$1,
      STANDARDIZED_TYPES,
      EXPRESSION_TYPES,
      BINARY_TYPES,
      SCOPABLE_TYPES,
      BLOCKPARENT_TYPES,
      BLOCK_TYPES,
      STATEMENT_TYPES,
      TERMINATORLESS_TYPES,
      COMPLETIONSTATEMENT_TYPES,
      CONDITIONAL_TYPES,
      LOOP_TYPES,
      WHILE_TYPES,
      EXPRESSIONWRAPPER_TYPES,
      FOR_TYPES,
      FORXSTATEMENT_TYPES,
      FUNCTION_TYPES: FUNCTION_TYPES$1,
      FUNCTIONPARENT_TYPES,
      PUREISH_TYPES,
      DECLARATION_TYPES,
      PATTERNLIKE_TYPES,
      LVAL_TYPES,
      TSENTITYNAME_TYPES,
      LITERAL_TYPES,
      IMMUTABLE_TYPES,
      USERWHITESPACABLE_TYPES,
      METHOD_TYPES,
      OBJECTMEMBER_TYPES,
      PROPERTY_TYPES,
      UNARYLIKE_TYPES,
      PATTERN_TYPES,
      CLASS_TYPES,
      MODULEDECLARATION_TYPES,
      EXPORTDECLARATION_TYPES,
      MODULESPECIFIER_TYPES,
      ACCESSOR_TYPES,
      PRIVATE_TYPES,
      FLOW_TYPES,
      FLOWTYPE_TYPES,
      FLOWBASEANNOTATION_TYPES,
      FLOWDECLARATION_TYPES,
      FLOWPREDICATE_TYPES,
      ENUMBODY_TYPES,
      ENUMMEMBER_TYPES,
      JSX_TYPES,
      MISCELLANEOUS_TYPES,
      TYPESCRIPT_TYPES,
      TSTYPEELEMENT_TYPES,
      TSTYPE_TYPES,
      TSBASETYPE_TYPES,
      STATEMENT_OR_BLOCK_KEYS: STATEMENT_OR_BLOCK_KEYS$1,
      FLATTENABLE_KEYS,
      FOR_INIT_KEYS,
      COMMENT_KEYS,
      LOGICAL_OPERATORS: LOGICAL_OPERATORS$3,
      UPDATE_OPERATORS,
      BOOLEAN_NUMBER_BINARY_OPERATORS: BOOLEAN_NUMBER_BINARY_OPERATORS$1,
      EQUALITY_BINARY_OPERATORS,
      COMPARISON_BINARY_OPERATORS,
      BOOLEAN_BINARY_OPERATORS: BOOLEAN_BINARY_OPERATORS$1,
      NUMBER_BINARY_OPERATORS: NUMBER_BINARY_OPERATORS$1,
      BINARY_OPERATORS,
      ASSIGNMENT_OPERATORS,
      BOOLEAN_UNARY_OPERATORS: BOOLEAN_UNARY_OPERATORS$1,
      NUMBER_UNARY_OPERATORS: NUMBER_UNARY_OPERATORS$1,
      STRING_UNARY_OPERATORS: STRING_UNARY_OPERATORS$1,
      UNARY_OPERATORS,
      INHERIT_KEYS,
      BLOCK_SCOPED_SYMBOL,
      NOT_LOCAL_BINDING: NOT_LOCAL_BINDING$2,
      VISITOR_KEYS: VISITOR_KEYS$7,
      ALIAS_KEYS,
      FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS$3,
      NODE_FIELDS,
      BUILDER_KEYS,
      DEPRECATED_KEYS: DEPRECATED_KEYS$1,
      NODE_PARENT_VALIDATIONS,
      PLACEHOLDERS,
      PLACEHOLDERS_ALIAS,
      PLACEHOLDERS_FLIPPED_ALIAS,
      TYPES: TYPES$1,
      isArrayExpression: isArrayExpression$2,
      isAssignmentExpression: isAssignmentExpression$4,
      isBinaryExpression: isBinaryExpression$1,
      isInterpreterDirective,
      isDirective,
      isDirectiveLiteral,
      isBlockStatement: isBlockStatement$2,
      isBreakStatement,
      isCallExpression: isCallExpression$7,
      isCatchClause,
      isConditionalExpression: isConditionalExpression$1,
      isContinueStatement,
      isDebuggerStatement,
      isDoWhileStatement,
      isEmptyStatement: isEmptyStatement$1,
      isExpressionStatement: isExpressionStatement$4,
      isFile: isFile$1,
      isForInStatement: isForInStatement$1,
      isForStatement: isForStatement$3,
      isFunctionDeclaration: isFunctionDeclaration$1,
      isFunctionExpression: isFunctionExpression$1,
      isIdentifier: isIdentifier$i,
      isIfStatement: isIfStatement$2,
      isLabeledStatement,
      isStringLiteral: isStringLiteral$7,
      isNumericLiteral,
      isNullLiteral: isNullLiteral$1,
      isBooleanLiteral,
      isRegExpLiteral: isRegExpLiteral$1,
      isLogicalExpression: isLogicalExpression$1,
      isMemberExpression: isMemberExpression$8,
      isNewExpression: isNewExpression$4,
      isProgram: isProgram$2,
      isObjectExpression: isObjectExpression$3,
      isObjectMethod: isObjectMethod$2,
      isObjectProperty: isObjectProperty$5,
      isRestElement: isRestElement$3,
      isReturnStatement: isReturnStatement$1,
      isSequenceExpression: isSequenceExpression$2,
      isParenthesizedExpression: isParenthesizedExpression$1,
      isSwitchCase,
      isSwitchStatement: isSwitchStatement$1,
      isThisExpression: isThisExpression$2,
      isThrowStatement: isThrowStatement$1,
      isTryStatement,
      isUnaryExpression: isUnaryExpression$1,
      isUpdateExpression: isUpdateExpression$1,
      isVariableDeclaration: isVariableDeclaration$3,
      isVariableDeclarator: isVariableDeclarator$2,
      isWhileStatement: isWhileStatement$1,
      isWithStatement,
      isAssignmentPattern: isAssignmentPattern$5,
      isArrayPattern: isArrayPattern$1,
      isArrowFunctionExpression: isArrowFunctionExpression$1,
      isClassBody: isClassBody$1,
      isClassExpression: isClassExpression$1,
      isClassDeclaration: isClassDeclaration$3,
      isExportAllDeclaration: isExportAllDeclaration$1,
      isExportDefaultDeclaration: isExportDefaultDeclaration$3,
      isExportNamedDeclaration: isExportNamedDeclaration$2,
      isExportSpecifier,
      isForOfStatement: isForOfStatement$1,
      isImportDeclaration: isImportDeclaration$2,
      isImportDefaultSpecifier: isImportDefaultSpecifier$1,
      isImportNamespaceSpecifier: isImportNamespaceSpecifier$1,
      isImportSpecifier: isImportSpecifier$1,
      isMetaProperty: isMetaProperty$1,
      isClassMethod: isClassMethod$1,
      isObjectPattern: isObjectPattern$2,
      isSpreadElement: isSpreadElement$1,
      isSuper: isSuper$3,
      isTaggedTemplateExpression: isTaggedTemplateExpression$2,
      isTemplateElement,
      isTemplateLiteral: isTemplateLiteral$2,
      isYieldExpression: isYieldExpression$1,
      isAwaitExpression: isAwaitExpression$1,
      isImport,
      isBigIntLiteral,
      isExportNamespaceSpecifier: isExportNamespaceSpecifier$1,
      isOptionalMemberExpression: isOptionalMemberExpression$3,
      isOptionalCallExpression: isOptionalCallExpression$3,
      isClassProperty,
      isClassAccessorProperty,
      isClassPrivateProperty,
      isClassPrivateMethod,
      isPrivateName: isPrivateName$2,
      isStaticBlock,
      isAnyTypeAnnotation: isAnyTypeAnnotation$1,
      isArrayTypeAnnotation: isArrayTypeAnnotation$1,
      isBooleanTypeAnnotation: isBooleanTypeAnnotation$1,
      isBooleanLiteralTypeAnnotation,
      isNullLiteralTypeAnnotation,
      isClassImplements,
      isDeclareClass,
      isDeclareFunction,
      isDeclareInterface,
      isDeclareModule,
      isDeclareModuleExports,
      isDeclareTypeAlias,
      isDeclareOpaqueType,
      isDeclareVariable,
      isDeclareExportDeclaration: isDeclareExportDeclaration$1,
      isDeclareExportAllDeclaration,
      isDeclaredPredicate,
      isExistsTypeAnnotation,
      isFunctionTypeAnnotation,
      isFunctionTypeParam,
      isGenericTypeAnnotation: isGenericTypeAnnotation$1,
      isInferredPredicate,
      isInterfaceExtends,
      isInterfaceDeclaration,
      isInterfaceTypeAnnotation,
      isIntersectionTypeAnnotation: isIntersectionTypeAnnotation$1,
      isMixedTypeAnnotation: isMixedTypeAnnotation$1,
      isEmptyTypeAnnotation: isEmptyTypeAnnotation$1,
      isNullableTypeAnnotation: isNullableTypeAnnotation$1,
      isNumberLiteralTypeAnnotation,
      isNumberTypeAnnotation: isNumberTypeAnnotation$1,
      isObjectTypeAnnotation,
      isObjectTypeInternalSlot,
      isObjectTypeCallProperty,
      isObjectTypeIndexer,
      isObjectTypeProperty,
      isObjectTypeSpreadProperty,
      isOpaqueType,
      isQualifiedTypeIdentifier,
      isStringLiteralTypeAnnotation,
      isStringTypeAnnotation: isStringTypeAnnotation$1,
      isSymbolTypeAnnotation,
      isThisTypeAnnotation,
      isTupleTypeAnnotation,
      isTypeofTypeAnnotation,
      isTypeAlias,
      isTypeAnnotation: isTypeAnnotation$2,
      isTypeCastExpression: isTypeCastExpression$1,
      isTypeParameter,
      isTypeParameterDeclaration,
      isTypeParameterInstantiation,
      isUnionTypeAnnotation: isUnionTypeAnnotation$2,
      isVariance,
      isVoidTypeAnnotation: isVoidTypeAnnotation$1,
      isEnumDeclaration,
      isEnumBooleanBody,
      isEnumNumberBody,
      isEnumStringBody,
      isEnumSymbolBody,
      isEnumBooleanMember,
      isEnumNumberMember,
      isEnumStringMember,
      isEnumDefaultedMember,
      isIndexedAccessType: isIndexedAccessType$1,
      isOptionalIndexedAccessType,
      isJSXAttribute,
      isJSXClosingElement,
      isJSXElement,
      isJSXEmptyExpression,
      isJSXExpressionContainer: isJSXExpressionContainer$1,
      isJSXSpreadChild,
      isJSXIdentifier: isJSXIdentifier$3,
      isJSXMemberExpression: isJSXMemberExpression$2,
      isJSXNamespacedName: isJSXNamespacedName$1,
      isJSXOpeningElement,
      isJSXSpreadAttribute: isJSXSpreadAttribute$1,
      isJSXText,
      isJSXFragment,
      isJSXOpeningFragment,
      isJSXClosingFragment,
      isNoop,
      isPlaceholder: isPlaceholder$1,
      isV8IntrinsicIdentifier,
      isArgumentPlaceholder,
      isBindExpression,
      isImportAttribute,
      isDecorator,
      isDoExpression,
      isExportDefaultSpecifier: isExportDefaultSpecifier$1,
      isRecordExpression: isRecordExpression$1,
      isTupleExpression: isTupleExpression$1,
      isDecimalLiteral,
      isModuleExpression,
      isTopicReference: isTopicReference$1,
      isPipelineTopicExpression,
      isPipelineBareFunction,
      isPipelinePrimaryTopicReference,
      isTSParameterProperty,
      isTSDeclareFunction,
      isTSDeclareMethod,
      isTSQualifiedName,
      isTSCallSignatureDeclaration,
      isTSConstructSignatureDeclaration,
      isTSPropertySignature,
      isTSMethodSignature,
      isTSIndexSignature,
      isTSAnyKeyword,
      isTSBooleanKeyword,
      isTSBigIntKeyword,
      isTSIntrinsicKeyword,
      isTSNeverKeyword,
      isTSNullKeyword,
      isTSNumberKeyword,
      isTSObjectKeyword,
      isTSStringKeyword,
      isTSSymbolKeyword,
      isTSUndefinedKeyword,
      isTSUnknownKeyword,
      isTSVoidKeyword,
      isTSThisType,
      isTSFunctionType,
      isTSConstructorType,
      isTSTypeReference,
      isTSTypePredicate,
      isTSTypeQuery,
      isTSTypeLiteral,
      isTSArrayType: isTSArrayType$1,
      isTSTupleType,
      isTSOptionalType: isTSOptionalType$1,
      isTSRestType: isTSRestType$1,
      isTSNamedTupleMember,
      isTSUnionType: isTSUnionType$1,
      isTSIntersectionType: isTSIntersectionType$1,
      isTSConditionalType,
      isTSInferType,
      isTSParenthesizedType,
      isTSTypeOperator,
      isTSIndexedAccessType,
      isTSMappedType,
      isTSLiteralType,
      isTSExpressionWithTypeArguments,
      isTSInterfaceDeclaration,
      isTSInterfaceBody,
      isTSTypeAliasDeclaration,
      isTSAsExpression: isTSAsExpression$2,
      isTSTypeAssertion: isTSTypeAssertion$2,
      isTSEnumDeclaration,
      isTSEnumMember,
      isTSModuleDeclaration,
      isTSModuleBlock,
      isTSImportType,
      isTSImportEqualsDeclaration,
      isTSExternalModuleReference,
      isTSNonNullExpression: isTSNonNullExpression$2,
      isTSExportAssignment,
      isTSNamespaceExportDeclaration,
      isTSTypeAnnotation: isTSTypeAnnotation$2,
      isTSTypeParameterInstantiation,
      isTSTypeParameterDeclaration,
      isTSTypeParameter,
      isStandardized,
      isExpression: isExpression$4,
      isBinary: isBinary$3,
      isScopable,
      isBlockParent,
      isBlock,
      isStatement: isStatement$7,
      isTerminatorless,
      isCompletionStatement,
      isConditional: isConditional$1,
      isLoop: isLoop$1,
      isWhile,
      isExpressionWrapper,
      isFor: isFor$2,
      isForXStatement: isForXStatement$1,
      isFunction: isFunction$32,
      isFunctionParent,
      isPureish: isPureish$2,
      isDeclaration: isDeclaration$1,
      isPatternLike,
      isLVal,
      isTSEntityName,
      isLiteral: isLiteral$7,
      isUserWhitespacable,
      isMethod: isMethod$1,
      isObjectMember,
      isProperty: isProperty$2,
      isUnaryLike: isUnaryLike$1,
      isPattern: isPattern2,
      isClass: isClass$1,
      isModuleDeclaration: isModuleDeclaration$1,
      isExportDeclaration: isExportDeclaration$2,
      isModuleSpecifier: isModuleSpecifier$1,
      isAccessor,
      isPrivate,
      isFlow: isFlow$1,
      isFlowType,
      isFlowBaseAnnotation: isFlowBaseAnnotation$1,
      isFlowDeclaration,
      isFlowPredicate,
      isEnumBody,
      isEnumMember,
      isJSX,
      isMiscellaneous,
      isTypeScript,
      isTSTypeElement,
      isTSType,
      isTSBaseType,
      isNumberLiteral,
      isRegexLiteral,
      isRestProperty,
      isSpreadProperty
    });
    var isBinding = isBinding$1, isBlockScoped$1 = isBlockScoped$2, isExportDeclaration$1 = isExportDeclaration$2, isExpression$3 = isExpression$4, isFlow = isFlow$1, isForStatement$2 = isForStatement$3, isForXStatement = isForXStatement$1, isIdentifier$h = isIdentifier$i, isImportDeclaration$1 = isImportDeclaration$2, isImportSpecifier = isImportSpecifier$1, isJSXIdentifier$2 = isJSXIdentifier$3, isJSXMemberExpression$1 = isJSXMemberExpression$2, isMemberExpression$7 = isMemberExpression$8, isReferenced$1 = isReferenced$2, isScope = isScope$1, isStatement$6 = isStatement$7, isVar$1 = isVar$2, isVariableDeclaration$2 = isVariableDeclaration$3, react$2 = react$3;
    var isCompatTag = react$2.isCompatTag;
    var ReferencedIdentifier$1 = {
      types: ["Identifier", "JSXIdentifier"],
      checkPath: function checkPath(path2, opts) {
        var node2 = path2.node, parent = path2.parent;
        if (!isIdentifier$h(node2, opts) && !isJSXMemberExpression$1(parent, opts)) {
          if (isJSXIdentifier$2(node2, opts)) {
            if (isCompatTag(node2.name))
              return false;
          } else {
            return false;
          }
        }
        return isReferenced$1(node2, parent, path2.parentPath.parent);
      }
    };
    var ReferencedMemberExpression = {
      types: ["MemberExpression"],
      checkPath: function checkPath(_ref3) {
        var node2 = _ref3.node, parent = _ref3.parent;
        return isMemberExpression$7(node2) && isReferenced$1(node2, parent);
      }
    };
    var BindingIdentifier = {
      types: ["Identifier"],
      checkPath: function checkPath(path2) {
        var node2 = path2.node, parent = path2.parent;
        var grandparent = path2.parentPath.parent;
        return isIdentifier$h(node2) && isBinding(node2, parent, grandparent);
      }
    };
    var Statement = {
      types: ["Statement"],
      checkPath: function checkPath(_ref22) {
        var node2 = _ref22.node, parent = _ref22.parent;
        if (isStatement$6(node2)) {
          if (isVariableDeclaration$2(node2)) {
            if (isForXStatement(parent, {
              left: node2
            }))
              return false;
            if (isForStatement$2(parent, {
              init: node2
            }))
              return false;
          }
          return true;
        } else {
          return false;
        }
      }
    };
    var Expression = {
      types: ["Expression"],
      checkPath: function checkPath(path2) {
        if (path2.isIdentifier()) {
          return path2.isReferencedIdentifier();
        } else {
          return isExpression$3(path2.node);
        }
      }
    };
    var Scope$2 = {
      types: ["Scopable", "Pattern"],
      checkPath: function checkPath(path2) {
        return isScope(path2.node, path2.parent);
      }
    };
    var Referenced = {
      checkPath: function checkPath(path2) {
        return isReferenced$1(path2.node, path2.parent);
      }
    };
    var BlockScoped = {
      checkPath: function checkPath(path2) {
        return isBlockScoped$1(path2.node);
      }
    };
    var Var = {
      types: ["VariableDeclaration"],
      checkPath: function checkPath(path2) {
        return isVar$1(path2.node);
      }
    };
    var User = {
      checkPath: function checkPath(path2) {
        return path2.node && !!path2.node.loc;
      }
    };
    var Generated = {
      checkPath: function checkPath(path2) {
        return !path2.isUser();
      }
    };
    var Pure = {
      checkPath: function checkPath(path2, constantsOnly) {
        return path2.scope.isPure(path2.node, constantsOnly);
      }
    };
    var Flow = {
      types: ["Flow", "ImportDeclaration", "ExportDeclaration", "ImportSpecifier"],
      checkPath: function checkPath(_ref3) {
        var node2 = _ref3.node;
        if (isFlow(node2)) {
          return true;
        } else if (isImportDeclaration$1(node2)) {
          return node2.importKind === "type" || node2.importKind === "typeof";
        } else if (isExportDeclaration$1(node2)) {
          return node2.exportKind === "type";
        } else if (isImportSpecifier(node2)) {
          return node2.importKind === "type" || node2.importKind === "typeof";
        } else {
          return false;
        }
      }
    };
    var RestProperty = {
      types: ["RestElement"],
      checkPath: function checkPath(path2) {
        return path2.parentPath && path2.parentPath.isObjectPattern();
      }
    };
    var SpreadProperty = {
      types: ["RestElement"],
      checkPath: function checkPath(path2) {
        return path2.parentPath && path2.parentPath.isObjectExpression();
      }
    };
    var ExistentialTypeParam = {
      types: ["ExistsTypeAnnotation"]
    };
    var NumericLiteralTypeAnnotation = {
      types: ["NumberLiteralTypeAnnotation"]
    };
    var ForAwaitStatement = {
      types: ["ForOfStatement"],
      checkPath: function checkPath(_ref42) {
        var node2 = _ref42.node;
        return node2["await"] === true;
      }
    };
    var virtualTypes = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      ReferencedIdentifier: ReferencedIdentifier$1,
      ReferencedMemberExpression,
      BindingIdentifier,
      Statement,
      Expression,
      Scope: Scope$2,
      Referenced,
      BlockScoped,
      Var,
      User,
      Generated,
      Pure,
      Flow,
      RestProperty,
      SpreadProperty,
      ExistentialTypeParam,
      NumericLiteralTypeAnnotation,
      ForAwaitStatement
    });
    var DEPRECATED_KEYS = DEPRECATED_KEYS$1, FLIPPED_ALIAS_KEYS$2 = FLIPPED_ALIAS_KEYS$3, TYPES = TYPES$1;
    function explode$1(visitor2) {
      if (visitor2._exploded)
        return visitor2;
      visitor2._exploded = true;
      for (var _i3 = 0, _Object$keys3 = Object.keys(visitor2); _i3 < _Object$keys3.length; _i3++) {
        var nodeType = _Object$keys3[_i3];
        if (shouldIgnoreKey(nodeType))
          continue;
        var parts = nodeType.split("|");
        if (parts.length === 1)
          continue;
        var fns = visitor2[nodeType];
        delete visitor2[nodeType];
        for (var _iterator2 = _createForOfIteratorHelperLoose(parts), _step2; !(_step2 = _iterator2()).done; ) {
          var part = _step2.value;
          visitor2[part] = fns;
        }
      }
      verify(visitor2);
      delete visitor2.__esModule;
      ensureEntranceObjects(visitor2);
      ensureCallbackArrays(visitor2);
      for (var _i22 = 0, _Object$keys22 = Object.keys(visitor2); _i22 < _Object$keys22.length; _i22++) {
        var _nodeType = _Object$keys22[_i22];
        if (shouldIgnoreKey(_nodeType))
          continue;
        var _wrapper = virtualTypes[_nodeType];
        if (!_wrapper)
          continue;
        var _fns = visitor2[_nodeType];
        for (var _i32 = 0, _Object$keys32 = Object.keys(_fns); _i32 < _Object$keys32.length; _i32++) {
          var type5 = _Object$keys32[_i32];
          _fns[type5] = wrapCheck(_wrapper, _fns[type5]);
        }
        delete visitor2[_nodeType];
        if (_wrapper.types) {
          for (var _iterator22 = _createForOfIteratorHelperLoose(_wrapper.types), _step22; !(_step22 = _iterator22()).done; ) {
            var _type = _step22.value;
            if (visitor2[_type]) {
              mergePair(visitor2[_type], _fns);
            } else {
              visitor2[_type] = _fns;
            }
          }
        } else {
          mergePair(visitor2, _fns);
        }
      }
      for (var _i4 = 0, _Object$keys4 = Object.keys(visitor2); _i4 < _Object$keys4.length; _i4++) {
        var _nodeType2 = _Object$keys4[_i4];
        if (shouldIgnoreKey(_nodeType2))
          continue;
        var _fns2 = visitor2[_nodeType2];
        var aliases = FLIPPED_ALIAS_KEYS$2[_nodeType2];
        var deprecatedKey = DEPRECATED_KEYS[_nodeType2];
        if (deprecatedKey) {
          console.trace("Visitor defined for " + _nodeType2 + " but it has been renamed to " + deprecatedKey);
          aliases = [deprecatedKey];
        }
        if (!aliases)
          continue;
        delete visitor2[_nodeType2];
        for (var _iterator3 = _createForOfIteratorHelperLoose(aliases), _step3; !(_step3 = _iterator3()).done; ) {
          var alias2 = _step3.value;
          var existing = visitor2[alias2];
          if (existing) {
            mergePair(existing, _fns2);
          } else {
            visitor2[alias2] = Object.assign({}, _fns2);
          }
        }
      }
      for (var _i5 = 0, _Object$keys5 = Object.keys(visitor2); _i5 < _Object$keys5.length; _i5++) {
        var _nodeType3 = _Object$keys5[_i5];
        if (shouldIgnoreKey(_nodeType3))
          continue;
        ensureCallbackArrays(visitor2[_nodeType3]);
      }
      return visitor2;
    }
    function verify(visitor2) {
      if (visitor2._verified)
        return;
      if (typeof visitor2 === "function") {
        throw new Error("You passed `traverse()` a function when it expected a visitor object, are you sure you didn't mean `{ enter: Function }`?");
      }
      for (var _i6 = 0, _Object$keys6 = Object.keys(visitor2); _i6 < _Object$keys6.length; _i6++) {
        var nodeType = _Object$keys6[_i6];
        if (nodeType === "enter" || nodeType === "exit") {
          validateVisitorMethods(nodeType, visitor2[nodeType]);
        }
        if (shouldIgnoreKey(nodeType))
          continue;
        if (TYPES.indexOf(nodeType) < 0) {
          throw new Error("You gave us a visitor for the node type " + nodeType + " but it's not a valid type");
        }
        var _visitors = visitor2[nodeType];
        if (typeof _visitors === "object") {
          for (var _i7 = 0, _Object$keys7 = Object.keys(_visitors); _i7 < _Object$keys7.length; _i7++) {
            var visitorKey = _Object$keys7[_i7];
            if (visitorKey === "enter" || visitorKey === "exit") {
              validateVisitorMethods(nodeType + "." + visitorKey, _visitors[visitorKey]);
            } else {
              throw new Error("You passed `traverse()` a visitor object with the property " + (nodeType + " that has the invalid property " + visitorKey));
            }
          }
        }
      }
      visitor2._verified = true;
    }
    function validateVisitorMethods(path2, val) {
      var fns = [].concat(val);
      for (var _iterator4 = _createForOfIteratorHelperLoose(fns), _step4; !(_step4 = _iterator4()).done; ) {
        var fn = _step4.value;
        if (typeof fn !== "function") {
          throw new TypeError("Non-function found defined in " + path2 + " with type " + typeof fn);
        }
      }
    }
    function merge$12(visitors2, states, wrapper) {
      if (states === void 0) {
        states = [];
      }
      var rootVisitor = {};
      for (var i2 = 0; i2 < visitors2.length; i2++) {
        var visitor2 = visitors2[i2];
        var state = states[i2];
        explode$1(visitor2);
        for (var _i8 = 0, _Object$keys8 = Object.keys(visitor2); _i8 < _Object$keys8.length; _i8++) {
          var type5 = _Object$keys8[_i8];
          var visitorType = visitor2[type5];
          if (state || wrapper) {
            visitorType = wrapWithStateOrWrapper(visitorType, state, wrapper);
          }
          var nodeVisitor = rootVisitor[type5] = rootVisitor[type5] || {};
          mergePair(nodeVisitor, visitorType);
        }
      }
      return rootVisitor;
    }
    function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
      var newVisitor = {};
      var _loop3 = function _loop4() {
        var key2 = _Object$keys9[_i9];
        var fns = oldVisitor[key2];
        if (!Array.isArray(fns))
          return "continue";
        fns = fns.map(function(fn) {
          var newFn = fn;
          if (state) {
            newFn = function newFn2(path2) {
              return fn.call(state, path2, state);
            };
          }
          if (wrapper) {
            newFn = wrapper(state.key, key2, newFn);
          }
          if (newFn !== fn) {
            newFn.toString = function() {
              return fn.toString();
            };
          }
          return newFn;
        });
        newVisitor[key2] = fns;
      };
      for (var _i9 = 0, _Object$keys9 = Object.keys(oldVisitor); _i9 < _Object$keys9.length; _i9++) {
        var _ret2 = _loop3();
        if (_ret2 === "continue")
          continue;
      }
      return newVisitor;
    }
    function ensureEntranceObjects(obj) {
      for (var _i10 = 0, _Object$keys10 = Object.keys(obj); _i10 < _Object$keys10.length; _i10++) {
        var key2 = _Object$keys10[_i10];
        if (shouldIgnoreKey(key2))
          continue;
        var fns = obj[key2];
        if (typeof fns === "function") {
          obj[key2] = {
            enter: fns
          };
        }
      }
    }
    function ensureCallbackArrays(obj) {
      if (obj.enter && !Array.isArray(obj.enter))
        obj.enter = [obj.enter];
      if (obj.exit && !Array.isArray(obj.exit))
        obj.exit = [obj.exit];
    }
    function wrapCheck(wrapper, fn) {
      var newFn = function newFn2(path2) {
        if (wrapper.checkPath(path2)) {
          return fn.apply(this, arguments);
        }
      };
      newFn.toString = function() {
        return fn.toString();
      };
      return newFn;
    }
    function shouldIgnoreKey(key2) {
      if (key2[0] === "_")
        return true;
      if (key2 === "enter" || key2 === "exit" || key2 === "shouldSkip")
        return true;
      if (key2 === "denylist" || key2 === "noScope" || key2 === "skipKeys" || key2 === "blacklist") {
        return true;
      }
      return false;
    }
    function mergePair(dest, src2) {
      for (var _i11 = 0, _Object$keys11 = Object.keys(src2); _i11 < _Object$keys11.length; _i11++) {
        var key2 = _Object$keys11[_i11];
        dest[key2] = [].concat(dest[key2] || [], src2[key2]);
      }
    }
    var visitors = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      explode: explode$1,
      verify,
      merge: merge$12
    });
    var path$2 = /* @__PURE__ */ new WeakMap();
    var scope = /* @__PURE__ */ new WeakMap();
    function clear2() {
      clearPath();
      clearScope();
    }
    function clearPath() {
      path$2 = /* @__PURE__ */ new WeakMap();
    }
    function clearScope() {
      scope = /* @__PURE__ */ new WeakMap();
    }
    var cache$1 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      get path() {
        return path$2;
      },
      get scope() {
        return scope;
      },
      clear: clear2,
      clearPath,
      clearScope
    });
    var browser$3 = { exports: {} };
    var ms;
    var hasRequiredMs;
    function requireMs() {
      if (hasRequiredMs)
        return ms;
      hasRequiredMs = 1;
      var s = 1e3;
      var m2 = s * 60;
      var h = m2 * 60;
      var d2 = h * 24;
      var w2 = d2 * 7;
      var y2 = d2 * 365.25;
      ms = function ms2(val, options) {
        options = options || {};
        var type5 = typeof val;
        if (type5 === "string" && val.length > 0) {
          return parse5(val);
        } else if (type5 === "number" && isFinite(val)) {
          return options["long"] ? fmtLong(val) : fmtShort(val);
        }
        throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
      };
      function parse5(str) {
        str = String(str);
        if (str.length > 100) {
          return;
        }
        var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);
        if (!match) {
          return;
        }
        var n2 = parseFloat(match[1]);
        var type5 = (match[2] || "ms").toLowerCase();
        switch (type5) {
          case "years":
          case "year":
          case "yrs":
          case "yr":
          case "y":
            return n2 * y2;
          case "weeks":
          case "week":
          case "w":
            return n2 * w2;
          case "days":
          case "day":
          case "d":
            return n2 * d2;
          case "hours":
          case "hour":
          case "hrs":
          case "hr":
          case "h":
            return n2 * h;
          case "minutes":
          case "minute":
          case "mins":
          case "min":
          case "m":
            return n2 * m2;
          case "seconds":
          case "second":
          case "secs":
          case "sec":
          case "s":
            return n2 * s;
          case "milliseconds":
          case "millisecond":
          case "msecs":
          case "msec":
          case "ms":
            return n2;
          default:
            return void 0;
        }
      }
      function fmtShort(ms2) {
        var msAbs = Math.abs(ms2);
        if (msAbs >= d2) {
          return Math.round(ms2 / d2) + "d";
        }
        if (msAbs >= h) {
          return Math.round(ms2 / h) + "h";
        }
        if (msAbs >= m2) {
          return Math.round(ms2 / m2) + "m";
        }
        if (msAbs >= s) {
          return Math.round(ms2 / s) + "s";
        }
        return ms2 + "ms";
      }
      function fmtLong(ms2) {
        var msAbs = Math.abs(ms2);
        if (msAbs >= d2) {
          return plural(ms2, msAbs, d2, "day");
        }
        if (msAbs >= h) {
          return plural(ms2, msAbs, h, "hour");
        }
        if (msAbs >= m2) {
          return plural(ms2, msAbs, m2, "minute");
        }
        if (msAbs >= s) {
          return plural(ms2, msAbs, s, "second");
        }
        return ms2 + " ms";
      }
      function plural(ms2, msAbs, n2, name2) {
        var isPlural = msAbs >= n2 * 1.5;
        return Math.round(ms2 / n2) + " " + name2 + (isPlural ? "s" : "");
      }
      return ms;
    }
    function setup$1(env3) {
      createDebug.debug = createDebug;
      createDebug["default"] = createDebug;
      createDebug.coerce = coerce2;
      createDebug.disable = disable;
      createDebug.enable = enable;
      createDebug.enabled = enabled;
      createDebug.humanize = requireMs();
      createDebug.destroy = destroy;
      Object.keys(env3).forEach(function(key2) {
        createDebug[key2] = env3[key2];
      });
      createDebug.names = [];
      createDebug.skips = [];
      createDebug.formatters = {};
      function selectColor(namespace) {
        var hash = 0;
        for (var i2 = 0; i2 < namespace.length; i2++) {
          hash = (hash << 5) - hash + namespace.charCodeAt(i2);
          hash |= 0;
        }
        return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
      }
      createDebug.selectColor = selectColor;
      function createDebug(namespace) {
        var prevTime;
        var enableOverride = null;
        var namespacesCache;
        var enabledCache;
        function debug2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          if (!debug2.enabled) {
            return;
          }
          var self2 = debug2;
          var curr = Number(new Date());
          var ms2 = curr - (prevTime || curr);
          self2.diff = ms2;
          self2.prev = prevTime;
          self2.curr = curr;
          prevTime = curr;
          args[0] = createDebug.coerce(args[0]);
          if (typeof args[0] !== "string") {
            args.unshift("%O");
          }
          var index3 = 0;
          args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format2) {
            if (match === "%%") {
              return "%";
            }
            index3++;
            var formatter = createDebug.formatters[format2];
            if (typeof formatter === "function") {
              var val = args[index3];
              match = formatter.call(self2, val);
              args.splice(index3, 1);
              index3--;
            }
            return match;
          });
          createDebug.formatArgs.call(self2, args);
          var logFn = self2.log || createDebug.log;
          logFn.apply(self2, args);
        }
        debug2.namespace = namespace;
        debug2.useColors = createDebug.useColors();
        debug2.color = createDebug.selectColor(namespace);
        debug2.extend = extend3;
        debug2.destroy = createDebug.destroy;
        Object.defineProperty(debug2, "enabled", {
          enumerable: true,
          configurable: false,
          get: function get3() {
            if (enableOverride !== null) {
              return enableOverride;
            }
            if (namespacesCache !== createDebug.namespaces) {
              namespacesCache = createDebug.namespaces;
              enabledCache = createDebug.enabled(namespace);
            }
            return enabledCache;
          },
          set: function set3(v22) {
            enableOverride = v22;
          }
        });
        if (typeof createDebug.init === "function") {
          createDebug.init(debug2);
        }
        return debug2;
      }
      function extend3(namespace, delimiter2) {
        var newDebug = createDebug(this.namespace + (typeof delimiter2 === "undefined" ? ":" : delimiter2) + namespace);
        newDebug.log = this.log;
        return newDebug;
      }
      function enable(namespaces) {
        createDebug.save(namespaces);
        createDebug.namespaces = namespaces;
        createDebug.names = [];
        createDebug.skips = [];
        var i2;
        var split2 = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
        var len3 = split2.length;
        for (i2 = 0; i2 < len3; i2++) {
          if (!split2[i2]) {
            continue;
          }
          namespaces = split2[i2].replace(/\*/g, ".*?");
          if (namespaces[0] === "-") {
            createDebug.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
          } else {
            createDebug.names.push(new RegExp("^" + namespaces + "$"));
          }
        }
      }
      function disable() {
        var namespaces = [].concat(_toConsumableArray2(createDebug.names.map(toNamespace)), _toConsumableArray2(createDebug.skips.map(toNamespace).map(function(namespace) {
          return "-" + namespace;
        }))).join(",");
        createDebug.enable("");
        return namespaces;
      }
      function enabled(name2) {
        if (name2[name2.length - 1] === "*") {
          return true;
        }
        var i2;
        var len3;
        for (i2 = 0, len3 = createDebug.skips.length; i2 < len3; i2++) {
          if (createDebug.skips[i2].test(name2)) {
            return false;
          }
        }
        for (i2 = 0, len3 = createDebug.names.length; i2 < len3; i2++) {
          if (createDebug.names[i2].test(name2)) {
            return true;
          }
        }
        return false;
      }
      function toNamespace(regexp4) {
        return regexp4.toString().substring(2, regexp4.toString().length - 2).replace(/\.\*\?$/, "*");
      }
      function coerce2(val) {
        if (val instanceof Error) {
          return val.stack || val.message;
        }
        return val;
      }
      function destroy() {
        console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
      }
      createDebug.enable(createDebug.load());
      return createDebug;
    }
    var common = setup$1;
    (function(module2, exports3) {
      exports3.formatArgs = formatArgs;
      exports3.save = save;
      exports3.load = load2;
      exports3.useColors = useColors;
      exports3.storage = localstorage();
      exports3.destroy = function() {
        var warned2 = false;
        return function() {
          if (!warned2) {
            warned2 = true;
            console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
          }
        };
      }();
      exports3.colors = ["#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33"];
      function useColors() {
        if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
          return true;
        }
        if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
          return false;
        }
        return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
      }
      function formatArgs(args) {
        args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module2.exports.humanize(this.diff);
        if (!this.useColors) {
          return;
        }
        var c2 = "color: " + this.color;
        args.splice(1, 0, c2, "color: inherit");
        var index3 = 0;
        var lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, function(match) {
          if (match === "%%") {
            return;
          }
          index3++;
          if (match === "%c") {
            lastC = index3;
          }
        });
        args.splice(lastC, 0, c2);
      }
      exports3.log = console.debug || console.log || function() {
      };
      function save(namespaces) {
        try {
          if (namespaces) {
            exports3.storage.setItem("debug", namespaces);
          } else {
            exports3.storage.removeItem("debug");
          }
        } catch (error2) {
        }
      }
      function load2() {
        var r2;
        try {
          r2 = exports3.storage.getItem("debug");
        } catch (error2) {
        }
        if (!r2 && typeof browser$1$1 !== "undefined" && "env" in browser$1$1) {
          r2 = browser$1$1.env.DEBUG;
        }
        return r2;
      }
      function localstorage() {
        try {
          return localStorage;
        } catch (error2) {
        }
      }
      module2.exports = common(exports3);
      var formatters = module2.exports.formatters;
      formatters.j = function(v22) {
        try {
          return JSON.stringify(v22);
        } catch (error2) {
          return "[UnexpectedJSONParseError]: " + error2.message;
        }
      };
    })(browser$3, browser$3.exports);
    var buildDebug = browser$3.exports;
    var Binding = function() {
      function Binding2(_ref3) {
        var identifier2 = _ref3.identifier, scope2 = _ref3.scope, path2 = _ref3.path, kind = _ref3.kind;
        this.identifier = void 0;
        this.scope = void 0;
        this.path = void 0;
        this.kind = void 0;
        this.constantViolations = [];
        this.constant = true;
        this.referencePaths = [];
        this.referenced = false;
        this.references = 0;
        this.identifier = identifier2;
        this.scope = scope2;
        this.path = path2;
        this.kind = kind;
        this.clearValue();
      }
      var _proto = Binding2.prototype;
      _proto.deoptValue = function deoptValue() {
        this.clearValue();
        this.hasDeoptedValue = true;
      };
      _proto.setValue = function setValue2(value) {
        if (this.hasDeoptedValue)
          return;
        this.hasValue = true;
        this.value = value;
      };
      _proto.clearValue = function clearValue() {
        this.hasDeoptedValue = false;
        this.hasValue = false;
        this.value = null;
      };
      _proto.reassign = function reassign(path2) {
        this.constant = false;
        if (this.constantViolations.indexOf(path2) !== -1) {
          return;
        }
        this.constantViolations.push(path2);
      };
      _proto.reference = function reference(path2) {
        if (this.referencePaths.indexOf(path2) !== -1) {
          return;
        }
        this.referenced = true;
        this.references++;
        this.referencePaths.push(path2);
      };
      _proto.dereference = function dereference() {
        this.references--;
        this.referenced = !!this.references;
      };
      return _createClass2(Binding2);
    }();
    var cloneNode$h = cloneNode$i, exportNamedDeclaration$1 = exportNamedDeclaration$2, exportSpecifier$1 = exportSpecifier$2, identifier$i = identifier$j, variableDeclaration$6 = variableDeclaration$7, variableDeclarator$6 = variableDeclarator$7;
    function splitExportDeclaration(exportDeclaration) {
      if (!exportDeclaration.isExportDeclaration()) {
        throw new Error("Only export declarations can be split.");
      }
      var isDefault = exportDeclaration.isExportDefaultDeclaration();
      var declaration = exportDeclaration.get("declaration");
      var isClassDeclaration2 = declaration.isClassDeclaration();
      if (isDefault) {
        var standaloneDeclaration = declaration.isFunctionDeclaration() || isClassDeclaration2;
        var scope2 = declaration.isScope() ? declaration.scope.parent : declaration.scope;
        var id3 = declaration.node.id;
        var needBindingRegistration = false;
        if (!id3) {
          needBindingRegistration = true;
          id3 = scope2.generateUidIdentifier("default");
          if (standaloneDeclaration || declaration.isFunctionExpression() || declaration.isClassExpression()) {
            declaration.node.id = cloneNode$h(id3);
          }
        }
        var updatedDeclaration = standaloneDeclaration ? declaration : variableDeclaration$6("var", [variableDeclarator$6(cloneNode$h(id3), declaration.node)]);
        var updatedExportDeclaration = exportNamedDeclaration$1(null, [exportSpecifier$1(cloneNode$h(id3), identifier$i("default"))]);
        exportDeclaration.insertAfter(updatedExportDeclaration);
        exportDeclaration.replaceWith(updatedDeclaration);
        if (needBindingRegistration) {
          scope2.registerDeclaration(exportDeclaration);
        }
        return exportDeclaration;
      }
      if (exportDeclaration.get("specifiers").length > 0) {
        throw new Error("It doesn't make sense to split exported specifiers.");
      }
      var bindingIdentifiers = declaration.getOuterBindingIdentifiers();
      var specifiers = Object.keys(bindingIdentifiers).map(function(name2) {
        return exportSpecifier$1(identifier$i(name2), identifier$i(name2));
      });
      var aliasDeclar = exportNamedDeclaration$1(null, specifiers);
      exportDeclaration.insertAfter(aliasDeclar);
      exportDeclaration.replaceWith(declaration.node);
      return exportDeclaration;
    }
    var VISITOR_KEYS$6 = VISITOR_KEYS$7;
    var renameVisitor = {
      ReferencedIdentifier: function ReferencedIdentifier2(_ref3, state) {
        var node2 = _ref3.node;
        if (node2.name === state.oldName) {
          node2.name = state.newName;
        }
      },
      Scope: function Scope4(path2, state) {
        if (!path2.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
          skipAllButComputedMethodKey(path2);
        }
      },
      "AssignmentExpression|Declaration|VariableDeclarator": function AssignmentExpressionDeclarationVariableDeclarator(path2, state) {
        if (path2.isVariableDeclaration())
          return;
        var ids2 = path2.getOuterBindingIdentifiers();
        for (var name2 in ids2) {
          if (name2 === state.oldName)
            ids2[name2].name = state.newName;
        }
      }
    };
    var Renamer = function() {
      function Renamer2(binding2, oldName, newName) {
        this.newName = newName;
        this.oldName = oldName;
        this.binding = binding2;
      }
      var _proto = Renamer2.prototype;
      _proto.maybeConvertFromExportDeclaration = function maybeConvertFromExportDeclaration(parentDeclar) {
        var maybeExportDeclar = parentDeclar.parentPath;
        if (!maybeExportDeclar.isExportDeclaration()) {
          return;
        }
        if (maybeExportDeclar.isExportDefaultDeclaration() && !maybeExportDeclar.get("declaration").node.id) {
          return;
        }
        splitExportDeclaration(maybeExportDeclar);
      };
      _proto.maybeConvertFromClassFunctionDeclaration = function maybeConvertFromClassFunctionDeclaration(path2) {
        return;
      };
      _proto.maybeConvertFromClassFunctionExpression = function maybeConvertFromClassFunctionExpression(path2) {
        return;
      };
      _proto.rename = function rename(block) {
        var _this = this;
        var binding2 = this.binding, oldName = this.oldName, newName = this.newName;
        var scope2 = binding2.scope, path2 = binding2.path;
        var parentDeclar = path2.find(function(path3) {
          return path3.isDeclaration() || path3.isFunctionExpression() || path3.isClassExpression();
        });
        if (parentDeclar) {
          var bindingIds = parentDeclar.getOuterBindingIdentifiers();
          if (bindingIds[oldName] === binding2.identifier) {
            this.maybeConvertFromExportDeclaration(parentDeclar);
          }
        }
        var blockToTraverse = block || scope2.block;
        if ((blockToTraverse == null ? void 0 : blockToTraverse.type) === "SwitchStatement") {
          blockToTraverse.cases.forEach(function(c2) {
            scope2.traverse(c2, renameVisitor, _this);
          });
        } else {
          scope2.traverse(blockToTraverse, renameVisitor, this);
        }
        if (!block) {
          scope2.removeOwnBinding(oldName);
          scope2.bindings[newName] = binding2;
          this.binding.identifier.name = newName;
        }
        if (parentDeclar) {
          this.maybeConvertFromClassFunctionDeclaration(parentDeclar);
          this.maybeConvertFromClassFunctionExpression(parentDeclar);
        }
      };
      return _createClass2(Renamer2);
    }();
    function skipAllButComputedMethodKey(path2) {
      if (!path2.isMethod() || !path2.node.computed) {
        path2.skip();
        return;
      }
      var keys2 = VISITOR_KEYS$6[path2.type];
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        if (key2 !== "key")
          path2.skipKey(key2);
      }
    }
    var builtin = {
      "Array": false,
      "ArrayBuffer": false,
      Atomics: false,
      BigInt: false,
      BigInt64Array: false,
      BigUint64Array: false,
      "Boolean": false,
      constructor: false,
      "DataView": false,
      "Date": false,
      "decodeURI": false,
      "decodeURIComponent": false,
      "encodeURI": false,
      "encodeURIComponent": false,
      "Error": false,
      "escape": false,
      "eval": false,
      "EvalError": false,
      "Float32Array": false,
      "Float64Array": false,
      "Function": false,
      globalThis: false,
      hasOwnProperty: false,
      "Infinity": false,
      "Int16Array": false,
      "Int32Array": false,
      "Int8Array": false,
      "isFinite": false,
      "isNaN": false,
      isPrototypeOf: false,
      "JSON": false,
      "Map": false,
      "Math": false,
      "NaN": false,
      "Number": false,
      "Object": false,
      "parseFloat": false,
      "parseInt": false,
      "Promise": false,
      propertyIsEnumerable: false,
      "Proxy": false,
      "RangeError": false,
      "ReferenceError": false,
      "Reflect": false,
      "RegExp": false,
      "Set": false,
      SharedArrayBuffer: false,
      "String": false,
      "Symbol": false,
      "SyntaxError": false,
      toLocaleString: false,
      toString: false,
      "TypeError": false,
      "Uint16Array": false,
      "Uint32Array": false,
      "Uint8Array": false,
      "Uint8ClampedArray": false,
      "undefined": false,
      "unescape": false,
      "URIError": false,
      valueOf: false,
      "WeakMap": false,
      "WeakSet": false
    };
    var es5 = {
      "Array": false,
      "Boolean": false,
      constructor: false,
      "Date": false,
      "decodeURI": false,
      "decodeURIComponent": false,
      "encodeURI": false,
      "encodeURIComponent": false,
      "Error": false,
      "escape": false,
      "eval": false,
      "EvalError": false,
      "Function": false,
      hasOwnProperty: false,
      "Infinity": false,
      "isFinite": false,
      "isNaN": false,
      isPrototypeOf: false,
      "JSON": false,
      "Math": false,
      "NaN": false,
      "Number": false,
      "Object": false,
      "parseFloat": false,
      "parseInt": false,
      propertyIsEnumerable: false,
      "RangeError": false,
      "ReferenceError": false,
      "RegExp": false,
      "String": false,
      "SyntaxError": false,
      toLocaleString: false,
      toString: false,
      "TypeError": false,
      "undefined": false,
      "unescape": false,
      "URIError": false,
      valueOf: false
    };
    var es2015 = {
      "Array": false,
      "ArrayBuffer": false,
      "Boolean": false,
      constructor: false,
      "DataView": false,
      "Date": false,
      "decodeURI": false,
      "decodeURIComponent": false,
      "encodeURI": false,
      "encodeURIComponent": false,
      "Error": false,
      "escape": false,
      "eval": false,
      "EvalError": false,
      "Float32Array": false,
      "Float64Array": false,
      "Function": false,
      hasOwnProperty: false,
      "Infinity": false,
      "Int16Array": false,
      "Int32Array": false,
      "Int8Array": false,
      "isFinite": false,
      "isNaN": false,
      isPrototypeOf: false,
      "JSON": false,
      "Map": false,
      "Math": false,
      "NaN": false,
      "Number": false,
      "Object": false,
      "parseFloat": false,
      "parseInt": false,
      "Promise": false,
      propertyIsEnumerable: false,
      "Proxy": false,
      "RangeError": false,
      "ReferenceError": false,
      "Reflect": false,
      "RegExp": false,
      "Set": false,
      "String": false,
      "Symbol": false,
      "SyntaxError": false,
      toLocaleString: false,
      toString: false,
      "TypeError": false,
      "Uint16Array": false,
      "Uint32Array": false,
      "Uint8Array": false,
      "Uint8ClampedArray": false,
      "undefined": false,
      "unescape": false,
      "URIError": false,
      valueOf: false,
      "WeakMap": false,
      "WeakSet": false
    };
    var es2017 = {
      "Array": false,
      "ArrayBuffer": false,
      Atomics: false,
      "Boolean": false,
      constructor: false,
      "DataView": false,
      "Date": false,
      "decodeURI": false,
      "decodeURIComponent": false,
      "encodeURI": false,
      "encodeURIComponent": false,
      "Error": false,
      "escape": false,
      "eval": false,
      "EvalError": false,
      "Float32Array": false,
      "Float64Array": false,
      "Function": false,
      hasOwnProperty: false,
      "Infinity": false,
      "Int16Array": false,
      "Int32Array": false,
      "Int8Array": false,
      "isFinite": false,
      "isNaN": false,
      isPrototypeOf: false,
      "JSON": false,
      "Map": false,
      "Math": false,
      "NaN": false,
      "Number": false,
      "Object": false,
      "parseFloat": false,
      "parseInt": false,
      "Promise": false,
      propertyIsEnumerable: false,
      "Proxy": false,
      "RangeError": false,
      "ReferenceError": false,
      "Reflect": false,
      "RegExp": false,
      "Set": false,
      SharedArrayBuffer: false,
      "String": false,
      "Symbol": false,
      "SyntaxError": false,
      toLocaleString: false,
      toString: false,
      "TypeError": false,
      "Uint16Array": false,
      "Uint32Array": false,
      "Uint8Array": false,
      "Uint8ClampedArray": false,
      "undefined": false,
      "unescape": false,
      "URIError": false,
      valueOf: false,
      "WeakMap": false,
      "WeakSet": false
    };
    var browser$2 = {
      AbortController: false,
      AbortSignal: false,
      addEventListener: false,
      alert: false,
      AnalyserNode: false,
      Animation: false,
      AnimationEffectReadOnly: false,
      AnimationEffectTiming: false,
      AnimationEffectTimingReadOnly: false,
      AnimationEvent: false,
      AnimationPlaybackEvent: false,
      AnimationTimeline: false,
      applicationCache: false,
      ApplicationCache: false,
      ApplicationCacheErrorEvent: false,
      atob: false,
      Attr: false,
      Audio: false,
      AudioBuffer: false,
      AudioBufferSourceNode: false,
      AudioContext: false,
      AudioDestinationNode: false,
      AudioListener: false,
      AudioNode: false,
      AudioParam: false,
      AudioProcessingEvent: false,
      AudioScheduledSourceNode: false,
      "AudioWorkletGlobalScope ": false,
      AudioWorkletNode: false,
      AudioWorkletProcessor: false,
      BarProp: false,
      BaseAudioContext: false,
      BatteryManager: false,
      BeforeUnloadEvent: false,
      BiquadFilterNode: false,
      Blob: false,
      BlobEvent: false,
      blur: false,
      BroadcastChannel: false,
      btoa: false,
      BudgetService: false,
      ByteLengthQueuingStrategy: false,
      Cache: false,
      caches: false,
      CacheStorage: false,
      cancelAnimationFrame: false,
      cancelIdleCallback: false,
      CanvasCaptureMediaStreamTrack: false,
      CanvasGradient: false,
      CanvasPattern: false,
      CanvasRenderingContext2D: false,
      ChannelMergerNode: false,
      ChannelSplitterNode: false,
      CharacterData: false,
      clearInterval: false,
      clearTimeout: false,
      clientInformation: false,
      ClipboardEvent: false,
      close: false,
      closed: false,
      CloseEvent: false,
      Comment: false,
      CompositionEvent: false,
      confirm: false,
      console: false,
      ConstantSourceNode: false,
      ConvolverNode: false,
      CountQueuingStrategy: false,
      createImageBitmap: false,
      Credential: false,
      CredentialsContainer: false,
      crypto: false,
      Crypto: false,
      CryptoKey: false,
      CSS: false,
      CSSConditionRule: false,
      CSSFontFaceRule: false,
      CSSGroupingRule: false,
      CSSImportRule: false,
      CSSKeyframeRule: false,
      CSSKeyframesRule: false,
      CSSMediaRule: false,
      CSSNamespaceRule: false,
      CSSPageRule: false,
      CSSRule: false,
      CSSRuleList: false,
      CSSStyleDeclaration: false,
      CSSStyleRule: false,
      CSSStyleSheet: false,
      CSSSupportsRule: false,
      CustomElementRegistry: false,
      customElements: false,
      CustomEvent: false,
      DataTransfer: false,
      DataTransferItem: false,
      DataTransferItemList: false,
      defaultstatus: false,
      defaultStatus: false,
      DelayNode: false,
      DeviceMotionEvent: false,
      DeviceOrientationEvent: false,
      devicePixelRatio: false,
      dispatchEvent: false,
      document: false,
      Document: false,
      DocumentFragment: false,
      DocumentType: false,
      DOMError: false,
      DOMException: false,
      DOMImplementation: false,
      DOMMatrix: false,
      DOMMatrixReadOnly: false,
      DOMParser: false,
      DOMPoint: false,
      DOMPointReadOnly: false,
      DOMQuad: false,
      DOMRect: false,
      DOMRectReadOnly: false,
      DOMStringList: false,
      DOMStringMap: false,
      DOMTokenList: false,
      DragEvent: false,
      DynamicsCompressorNode: false,
      Element: false,
      ErrorEvent: false,
      event: false,
      Event: false,
      EventSource: false,
      EventTarget: false,
      external: false,
      fetch: false,
      File: false,
      FileList: false,
      FileReader: false,
      find: false,
      focus: false,
      FocusEvent: false,
      FontFace: false,
      FontFaceSetLoadEvent: false,
      FormData: false,
      frameElement: false,
      frames: false,
      GainNode: false,
      Gamepad: false,
      GamepadButton: false,
      GamepadEvent: false,
      getComputedStyle: false,
      getSelection: false,
      HashChangeEvent: false,
      Headers: false,
      history: false,
      History: false,
      HTMLAllCollection: false,
      HTMLAnchorElement: false,
      HTMLAreaElement: false,
      HTMLAudioElement: false,
      HTMLBaseElement: false,
      HTMLBodyElement: false,
      HTMLBRElement: false,
      HTMLButtonElement: false,
      HTMLCanvasElement: false,
      HTMLCollection: false,
      HTMLContentElement: false,
      HTMLDataElement: false,
      HTMLDataListElement: false,
      HTMLDetailsElement: false,
      HTMLDialogElement: false,
      HTMLDirectoryElement: false,
      HTMLDivElement: false,
      HTMLDListElement: false,
      HTMLDocument: false,
      HTMLElement: false,
      HTMLEmbedElement: false,
      HTMLFieldSetElement: false,
      HTMLFontElement: false,
      HTMLFormControlsCollection: false,
      HTMLFormElement: false,
      HTMLFrameElement: false,
      HTMLFrameSetElement: false,
      HTMLHeadElement: false,
      HTMLHeadingElement: false,
      HTMLHRElement: false,
      HTMLHtmlElement: false,
      HTMLIFrameElement: false,
      HTMLImageElement: false,
      HTMLInputElement: false,
      HTMLLabelElement: false,
      HTMLLegendElement: false,
      HTMLLIElement: false,
      HTMLLinkElement: false,
      HTMLMapElement: false,
      HTMLMarqueeElement: false,
      HTMLMediaElement: false,
      HTMLMenuElement: false,
      HTMLMetaElement: false,
      HTMLMeterElement: false,
      HTMLModElement: false,
      HTMLObjectElement: false,
      HTMLOListElement: false,
      HTMLOptGroupElement: false,
      HTMLOptionElement: false,
      HTMLOptionsCollection: false,
      HTMLOutputElement: false,
      HTMLParagraphElement: false,
      HTMLParamElement: false,
      HTMLPictureElement: false,
      HTMLPreElement: false,
      HTMLProgressElement: false,
      HTMLQuoteElement: false,
      HTMLScriptElement: false,
      HTMLSelectElement: false,
      HTMLShadowElement: false,
      HTMLSlotElement: false,
      HTMLSourceElement: false,
      HTMLSpanElement: false,
      HTMLStyleElement: false,
      HTMLTableCaptionElement: false,
      HTMLTableCellElement: false,
      HTMLTableColElement: false,
      HTMLTableElement: false,
      HTMLTableRowElement: false,
      HTMLTableSectionElement: false,
      HTMLTemplateElement: false,
      HTMLTextAreaElement: false,
      HTMLTimeElement: false,
      HTMLTitleElement: false,
      HTMLTrackElement: false,
      HTMLUListElement: false,
      HTMLUnknownElement: false,
      HTMLVideoElement: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      IdleDeadline: false,
      IIRFilterNode: false,
      Image: false,
      ImageBitmap: false,
      ImageBitmapRenderingContext: false,
      ImageCapture: false,
      ImageData: false,
      indexedDB: false,
      innerHeight: false,
      innerWidth: false,
      InputEvent: false,
      IntersectionObserver: false,
      IntersectionObserverEntry: false,
      "Intl": false,
      isSecureContext: false,
      KeyboardEvent: false,
      KeyframeEffect: false,
      KeyframeEffectReadOnly: false,
      length: false,
      localStorage: false,
      location: true,
      Location: false,
      locationbar: false,
      matchMedia: false,
      MediaDeviceInfo: false,
      MediaDevices: false,
      MediaElementAudioSourceNode: false,
      MediaEncryptedEvent: false,
      MediaError: false,
      MediaKeyMessageEvent: false,
      MediaKeySession: false,
      MediaKeyStatusMap: false,
      MediaKeySystemAccess: false,
      MediaList: false,
      MediaQueryList: false,
      MediaQueryListEvent: false,
      MediaRecorder: false,
      MediaSettingsRange: false,
      MediaSource: false,
      MediaStream: false,
      MediaStreamAudioDestinationNode: false,
      MediaStreamAudioSourceNode: false,
      MediaStreamEvent: false,
      MediaStreamTrack: false,
      MediaStreamTrackEvent: false,
      menubar: false,
      MessageChannel: false,
      MessageEvent: false,
      MessagePort: false,
      MIDIAccess: false,
      MIDIConnectionEvent: false,
      MIDIInput: false,
      MIDIInputMap: false,
      MIDIMessageEvent: false,
      MIDIOutput: false,
      MIDIOutputMap: false,
      MIDIPort: false,
      MimeType: false,
      MimeTypeArray: false,
      MouseEvent: false,
      moveBy: false,
      moveTo: false,
      MutationEvent: false,
      MutationObserver: false,
      MutationRecord: false,
      name: false,
      NamedNodeMap: false,
      NavigationPreloadManager: false,
      navigator: false,
      Navigator: false,
      NetworkInformation: false,
      Node: false,
      NodeFilter: false,
      NodeIterator: false,
      NodeList: false,
      Notification: false,
      OfflineAudioCompletionEvent: false,
      OfflineAudioContext: false,
      offscreenBuffering: false,
      OffscreenCanvas: true,
      onabort: true,
      onafterprint: true,
      onanimationend: true,
      onanimationiteration: true,
      onanimationstart: true,
      onappinstalled: true,
      onauxclick: true,
      onbeforeinstallprompt: true,
      onbeforeprint: true,
      onbeforeunload: true,
      onblur: true,
      oncancel: true,
      oncanplay: true,
      oncanplaythrough: true,
      onchange: true,
      onclick: true,
      onclose: true,
      oncontextmenu: true,
      oncuechange: true,
      ondblclick: true,
      ondevicemotion: true,
      ondeviceorientation: true,
      ondeviceorientationabsolute: true,
      ondrag: true,
      ondragend: true,
      ondragenter: true,
      ondragleave: true,
      ondragover: true,
      ondragstart: true,
      ondrop: true,
      ondurationchange: true,
      onemptied: true,
      onended: true,
      onerror: true,
      onfocus: true,
      ongotpointercapture: true,
      onhashchange: true,
      oninput: true,
      oninvalid: true,
      onkeydown: true,
      onkeypress: true,
      onkeyup: true,
      onlanguagechange: true,
      onload: true,
      onloadeddata: true,
      onloadedmetadata: true,
      onloadstart: true,
      onlostpointercapture: true,
      onmessage: true,
      onmessageerror: true,
      onmousedown: true,
      onmouseenter: true,
      onmouseleave: true,
      onmousemove: true,
      onmouseout: true,
      onmouseover: true,
      onmouseup: true,
      onmousewheel: true,
      onoffline: true,
      ononline: true,
      onpagehide: true,
      onpageshow: true,
      onpause: true,
      onplay: true,
      onplaying: true,
      onpointercancel: true,
      onpointerdown: true,
      onpointerenter: true,
      onpointerleave: true,
      onpointermove: true,
      onpointerout: true,
      onpointerover: true,
      onpointerup: true,
      onpopstate: true,
      onprogress: true,
      onratechange: true,
      onrejectionhandled: true,
      onreset: true,
      onresize: true,
      onscroll: true,
      onsearch: true,
      onseeked: true,
      onseeking: true,
      onselect: true,
      onstalled: true,
      onstorage: true,
      onsubmit: true,
      onsuspend: true,
      ontimeupdate: true,
      ontoggle: true,
      ontransitionend: true,
      onunhandledrejection: true,
      onunload: true,
      onvolumechange: true,
      onwaiting: true,
      onwheel: true,
      open: false,
      openDatabase: false,
      opener: false,
      Option: false,
      origin: false,
      OscillatorNode: false,
      outerHeight: false,
      outerWidth: false,
      PageTransitionEvent: false,
      pageXOffset: false,
      pageYOffset: false,
      PannerNode: false,
      parent: false,
      Path2D: false,
      PaymentAddress: false,
      PaymentRequest: false,
      PaymentRequestUpdateEvent: false,
      PaymentResponse: false,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceLongTaskTiming: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceNavigationTiming: false,
      PerformanceObserver: false,
      PerformanceObserverEntryList: false,
      PerformancePaintTiming: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      PeriodicWave: false,
      Permissions: false,
      PermissionStatus: false,
      personalbar: false,
      PhotoCapabilities: false,
      Plugin: false,
      PluginArray: false,
      PointerEvent: false,
      PopStateEvent: false,
      postMessage: false,
      Presentation: false,
      PresentationAvailability: false,
      PresentationConnection: false,
      PresentationConnectionAvailableEvent: false,
      PresentationConnectionCloseEvent: false,
      PresentationConnectionList: false,
      PresentationReceiver: false,
      PresentationRequest: false,
      print: false,
      ProcessingInstruction: false,
      ProgressEvent: false,
      PromiseRejectionEvent: false,
      prompt: false,
      PushManager: false,
      PushSubscription: false,
      PushSubscriptionOptions: false,
      queueMicrotask: false,
      RadioNodeList: false,
      Range: false,
      ReadableStream: false,
      registerProcessor: false,
      RemotePlayback: false,
      removeEventListener: false,
      Request: false,
      requestAnimationFrame: false,
      requestIdleCallback: false,
      resizeBy: false,
      ResizeObserver: false,
      ResizeObserverEntry: false,
      resizeTo: false,
      Response: false,
      RTCCertificate: false,
      RTCDataChannel: false,
      RTCDataChannelEvent: false,
      RTCDtlsTransport: false,
      RTCIceCandidate: false,
      RTCIceGatherer: false,
      RTCIceTransport: false,
      RTCPeerConnection: false,
      RTCPeerConnectionIceEvent: false,
      RTCRtpContributingSource: false,
      RTCRtpReceiver: false,
      RTCRtpSender: false,
      RTCSctpTransport: false,
      RTCSessionDescription: false,
      RTCStatsReport: false,
      RTCTrackEvent: false,
      screen: false,
      Screen: false,
      screenLeft: false,
      ScreenOrientation: false,
      screenTop: false,
      screenX: false,
      screenY: false,
      ScriptProcessorNode: false,
      scroll: false,
      scrollbars: false,
      scrollBy: false,
      scrollTo: false,
      scrollX: false,
      scrollY: false,
      SecurityPolicyViolationEvent: false,
      Selection: false,
      self: false,
      ServiceWorker: false,
      ServiceWorkerContainer: false,
      ServiceWorkerRegistration: false,
      sessionStorage: false,
      setInterval: false,
      setTimeout: false,
      ShadowRoot: false,
      SharedWorker: false,
      SourceBuffer: false,
      SourceBufferList: false,
      speechSynthesis: false,
      SpeechSynthesisEvent: false,
      SpeechSynthesisUtterance: false,
      StaticRange: false,
      status: false,
      statusbar: false,
      StereoPannerNode: false,
      stop: false,
      Storage: false,
      StorageEvent: false,
      StorageManager: false,
      styleMedia: false,
      StyleSheet: false,
      StyleSheetList: false,
      SubtleCrypto: false,
      SVGAElement: false,
      SVGAngle: false,
      SVGAnimatedAngle: false,
      SVGAnimatedBoolean: false,
      SVGAnimatedEnumeration: false,
      SVGAnimatedInteger: false,
      SVGAnimatedLength: false,
      SVGAnimatedLengthList: false,
      SVGAnimatedNumber: false,
      SVGAnimatedNumberList: false,
      SVGAnimatedPreserveAspectRatio: false,
      SVGAnimatedRect: false,
      SVGAnimatedString: false,
      SVGAnimatedTransformList: false,
      SVGAnimateElement: false,
      SVGAnimateMotionElement: false,
      SVGAnimateTransformElement: false,
      SVGAnimationElement: false,
      SVGCircleElement: false,
      SVGClipPathElement: false,
      SVGComponentTransferFunctionElement: false,
      SVGDefsElement: false,
      SVGDescElement: false,
      SVGDiscardElement: false,
      SVGElement: false,
      SVGEllipseElement: false,
      SVGFEBlendElement: false,
      SVGFEColorMatrixElement: false,
      SVGFEComponentTransferElement: false,
      SVGFECompositeElement: false,
      SVGFEConvolveMatrixElement: false,
      SVGFEDiffuseLightingElement: false,
      SVGFEDisplacementMapElement: false,
      SVGFEDistantLightElement: false,
      SVGFEDropShadowElement: false,
      SVGFEFloodElement: false,
      SVGFEFuncAElement: false,
      SVGFEFuncBElement: false,
      SVGFEFuncGElement: false,
      SVGFEFuncRElement: false,
      SVGFEGaussianBlurElement: false,
      SVGFEImageElement: false,
      SVGFEMergeElement: false,
      SVGFEMergeNodeElement: false,
      SVGFEMorphologyElement: false,
      SVGFEOffsetElement: false,
      SVGFEPointLightElement: false,
      SVGFESpecularLightingElement: false,
      SVGFESpotLightElement: false,
      SVGFETileElement: false,
      SVGFETurbulenceElement: false,
      SVGFilterElement: false,
      SVGForeignObjectElement: false,
      SVGGElement: false,
      SVGGeometryElement: false,
      SVGGradientElement: false,
      SVGGraphicsElement: false,
      SVGImageElement: false,
      SVGLength: false,
      SVGLengthList: false,
      SVGLinearGradientElement: false,
      SVGLineElement: false,
      SVGMarkerElement: false,
      SVGMaskElement: false,
      SVGMatrix: false,
      SVGMetadataElement: false,
      SVGMPathElement: false,
      SVGNumber: false,
      SVGNumberList: false,
      SVGPathElement: false,
      SVGPatternElement: false,
      SVGPoint: false,
      SVGPointList: false,
      SVGPolygonElement: false,
      SVGPolylineElement: false,
      SVGPreserveAspectRatio: false,
      SVGRadialGradientElement: false,
      SVGRect: false,
      SVGRectElement: false,
      SVGScriptElement: false,
      SVGSetElement: false,
      SVGStopElement: false,
      SVGStringList: false,
      SVGStyleElement: false,
      SVGSVGElement: false,
      SVGSwitchElement: false,
      SVGSymbolElement: false,
      SVGTextContentElement: false,
      SVGTextElement: false,
      SVGTextPathElement: false,
      SVGTextPositioningElement: false,
      SVGTitleElement: false,
      SVGTransform: false,
      SVGTransformList: false,
      SVGTSpanElement: false,
      SVGUnitTypes: false,
      SVGUseElement: false,
      SVGViewElement: false,
      TaskAttributionTiming: false,
      Text: false,
      TextDecoder: false,
      TextEncoder: false,
      TextEvent: false,
      TextMetrics: false,
      TextTrack: false,
      TextTrackCue: false,
      TextTrackCueList: false,
      TextTrackList: false,
      TimeRanges: false,
      toolbar: false,
      top: false,
      Touch: false,
      TouchEvent: false,
      TouchList: false,
      TrackEvent: false,
      TransitionEvent: false,
      TreeWalker: false,
      UIEvent: false,
      URL: false,
      URLSearchParams: false,
      ValidityState: false,
      visualViewport: false,
      VisualViewport: false,
      VTTCue: false,
      WaveShaperNode: false,
      WebAssembly: false,
      WebGL2RenderingContext: false,
      WebGLActiveInfo: false,
      WebGLBuffer: false,
      WebGLContextEvent: false,
      WebGLFramebuffer: false,
      WebGLProgram: false,
      WebGLQuery: false,
      WebGLRenderbuffer: false,
      WebGLRenderingContext: false,
      WebGLSampler: false,
      WebGLShader: false,
      WebGLShaderPrecisionFormat: false,
      WebGLSync: false,
      WebGLTexture: false,
      WebGLTransformFeedback: false,
      WebGLUniformLocation: false,
      WebGLVertexArrayObject: false,
      WebSocket: false,
      WheelEvent: false,
      window: false,
      Window: false,
      Worker: false,
      WritableStream: false,
      XMLDocument: false,
      XMLHttpRequest: false,
      XMLHttpRequestEventTarget: false,
      XMLHttpRequestUpload: false,
      XMLSerializer: false,
      XPathEvaluator: false,
      XPathExpression: false,
      XPathResult: false,
      XSLTProcessor: false
    };
    var worker = {
      addEventListener: false,
      applicationCache: false,
      atob: false,
      Blob: false,
      BroadcastChannel: false,
      btoa: false,
      Cache: false,
      caches: false,
      clearInterval: false,
      clearTimeout: false,
      close: true,
      console: false,
      fetch: false,
      FileReaderSync: false,
      FormData: false,
      Headers: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      ImageData: false,
      importScripts: true,
      indexedDB: false,
      location: false,
      MessageChannel: false,
      MessagePort: false,
      name: false,
      navigator: false,
      Notification: false,
      onclose: true,
      onconnect: true,
      onerror: true,
      onlanguagechange: true,
      onmessage: true,
      onoffline: true,
      ononline: true,
      onrejectionhandled: true,
      onunhandledrejection: true,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      postMessage: true,
      "Promise": false,
      queueMicrotask: false,
      removeEventListener: false,
      Request: false,
      Response: false,
      self: true,
      ServiceWorkerRegistration: false,
      setInterval: false,
      setTimeout: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false,
      WebSocket: false,
      Worker: false,
      WorkerGlobalScope: false,
      XMLHttpRequest: false
    };
    var node$1 = {
      __dirname: false,
      __filename: false,
      Buffer: false,
      clearImmediate: false,
      clearInterval: false,
      clearTimeout: false,
      console: false,
      exports: true,
      global: false,
      "Intl": false,
      module: false,
      process: false,
      queueMicrotask: false,
      require: false,
      setImmediate: false,
      setInterval: false,
      setTimeout: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false
    };
    var commonjs = {
      exports: true,
      global: false,
      module: false,
      require: false
    };
    var amd = {
      define: false,
      require: false
    };
    var mocha = {
      after: false,
      afterEach: false,
      before: false,
      beforeEach: false,
      context: false,
      describe: false,
      it: false,
      mocha: false,
      run: false,
      setup: false,
      specify: false,
      suite: false,
      suiteSetup: false,
      suiteTeardown: false,
      teardown: false,
      test: false,
      xcontext: false,
      xdescribe: false,
      xit: false,
      xspecify: false
    };
    var jasmine = {
      afterAll: false,
      afterEach: false,
      beforeAll: false,
      beforeEach: false,
      describe: false,
      expect: false,
      fail: false,
      fdescribe: false,
      fit: false,
      it: false,
      jasmine: false,
      pending: false,
      runs: false,
      spyOn: false,
      spyOnProperty: false,
      waits: false,
      waitsFor: false,
      xdescribe: false,
      xit: false
    };
    var jest = {
      afterAll: false,
      afterEach: false,
      beforeAll: false,
      beforeEach: false,
      describe: false,
      expect: false,
      fdescribe: false,
      fit: false,
      it: false,
      jest: false,
      pit: false,
      require: false,
      test: false,
      xdescribe: false,
      xit: false,
      xtest: false
    };
    var qunit = {
      asyncTest: false,
      deepEqual: false,
      equal: false,
      expect: false,
      module: false,
      notDeepEqual: false,
      notEqual: false,
      notOk: false,
      notPropEqual: false,
      notStrictEqual: false,
      ok: false,
      propEqual: false,
      QUnit: false,
      raises: false,
      start: false,
      stop: false,
      strictEqual: false,
      test: false,
      throws: false
    };
    var phantomjs = {
      console: true,
      exports: true,
      phantom: true,
      require: true,
      WebPage: true
    };
    var couch = {
      emit: false,
      exports: false,
      getRow: false,
      log: false,
      module: false,
      provides: false,
      require: false,
      respond: false,
      send: false,
      start: false,
      sum: false
    };
    var rhino = {
      defineClass: false,
      deserialize: false,
      gc: false,
      help: false,
      importClass: false,
      importPackage: false,
      java: false,
      load: false,
      loadClass: false,
      Packages: false,
      print: false,
      quit: false,
      readFile: false,
      readUrl: false,
      runCommand: false,
      seal: false,
      serialize: false,
      spawn: false,
      sync: false,
      toint32: false,
      version: false
    };
    var nashorn = {
      __DIR__: false,
      __FILE__: false,
      __LINE__: false,
      com: false,
      edu: false,
      exit: false,
      java: false,
      Java: false,
      javafx: false,
      JavaImporter: false,
      javax: false,
      JSAdapter: false,
      load: false,
      loadWithNewGlobal: false,
      org: false,
      Packages: false,
      print: false,
      quit: false
    };
    var wsh = {
      ActiveXObject: true,
      Enumerator: true,
      GetObject: true,
      ScriptEngine: true,
      ScriptEngineBuildVersion: true,
      ScriptEngineMajorVersion: true,
      ScriptEngineMinorVersion: true,
      VBArray: true,
      WScript: true,
      WSH: true,
      XDomainRequest: true
    };
    var jquery = {
      $: false,
      jQuery: false
    };
    var yui = {
      YAHOO: false,
      YAHOO_config: false,
      YUI: false,
      YUI_config: false
    };
    var shelljs = {
      cat: false,
      cd: false,
      chmod: false,
      config: false,
      cp: false,
      dirs: false,
      echo: false,
      env: false,
      error: false,
      exec: false,
      exit: false,
      find: false,
      grep: false,
      ln: false,
      ls: false,
      mkdir: false,
      mv: false,
      popd: false,
      pushd: false,
      pwd: false,
      rm: false,
      sed: false,
      set: false,
      target: false,
      tempdir: false,
      test: false,
      touch: false,
      which: false
    };
    var prototypejs = {
      $: false,
      $$: false,
      $A: false,
      $break: false,
      $continue: false,
      $F: false,
      $H: false,
      $R: false,
      $w: false,
      Abstract: false,
      Ajax: false,
      Autocompleter: false,
      Builder: false,
      Class: false,
      Control: false,
      Draggable: false,
      Draggables: false,
      Droppables: false,
      Effect: false,
      Element: false,
      Enumerable: false,
      Event: false,
      Field: false,
      Form: false,
      Hash: false,
      Insertion: false,
      ObjectRange: false,
      PeriodicalExecuter: false,
      Position: false,
      Prototype: false,
      Scriptaculous: false,
      Selector: false,
      Sortable: false,
      SortableObserver: false,
      Sound: false,
      Template: false,
      Toggle: false,
      Try: false
    };
    var meteor = {
      _: false,
      $: false,
      Accounts: false,
      AccountsClient: false,
      AccountsCommon: false,
      AccountsServer: false,
      App: false,
      Assets: false,
      Blaze: false,
      check: false,
      Cordova: false,
      DDP: false,
      DDPRateLimiter: false,
      DDPServer: false,
      Deps: false,
      EJSON: false,
      Email: false,
      HTTP: false,
      Log: false,
      Match: false,
      Meteor: false,
      Mongo: false,
      MongoInternals: false,
      Npm: false,
      Package: false,
      Plugin: false,
      process: false,
      Random: false,
      ReactiveDict: false,
      ReactiveVar: false,
      Router: false,
      ServiceConfiguration: false,
      Session: false,
      share: false,
      Spacebars: false,
      Template: false,
      Tinytest: false,
      Tracker: false,
      UI: false,
      Utils: false,
      WebApp: false,
      WebAppInternals: false
    };
    var mongo = {
      _isWindows: false,
      _rand: false,
      BulkWriteResult: false,
      cat: false,
      cd: false,
      connect: false,
      db: false,
      getHostName: false,
      getMemInfo: false,
      hostname: false,
      ISODate: false,
      listFiles: false,
      load: false,
      ls: false,
      md5sumFile: false,
      mkdir: false,
      Mongo: false,
      NumberInt: false,
      NumberLong: false,
      ObjectId: false,
      PlanCache: false,
      print: false,
      printjson: false,
      pwd: false,
      quit: false,
      removeFile: false,
      rs: false,
      sh: false,
      UUID: false,
      version: false,
      WriteResult: false
    };
    var applescript = {
      $: false,
      Application: false,
      Automation: false,
      console: false,
      delay: false,
      Library: false,
      ObjC: false,
      ObjectSpecifier: false,
      Path: false,
      Progress: false,
      Ref: false
    };
    var serviceworker = {
      addEventListener: false,
      applicationCache: false,
      atob: false,
      Blob: false,
      BroadcastChannel: false,
      btoa: false,
      Cache: false,
      caches: false,
      CacheStorage: false,
      clearInterval: false,
      clearTimeout: false,
      Client: false,
      clients: false,
      Clients: false,
      close: true,
      console: false,
      ExtendableEvent: false,
      ExtendableMessageEvent: false,
      fetch: false,
      FetchEvent: false,
      FileReaderSync: false,
      FormData: false,
      Headers: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      ImageData: false,
      importScripts: false,
      indexedDB: false,
      location: false,
      MessageChannel: false,
      MessagePort: false,
      name: false,
      navigator: false,
      Notification: false,
      onclose: true,
      onconnect: true,
      onerror: true,
      onfetch: true,
      oninstall: true,
      onlanguagechange: true,
      onmessage: true,
      onmessageerror: true,
      onnotificationclick: true,
      onnotificationclose: true,
      onoffline: true,
      ononline: true,
      onpush: true,
      onpushsubscriptionchange: true,
      onrejectionhandled: true,
      onsync: true,
      onunhandledrejection: true,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      postMessage: true,
      "Promise": false,
      queueMicrotask: false,
      registration: false,
      removeEventListener: false,
      Request: false,
      Response: false,
      self: false,
      ServiceWorker: false,
      ServiceWorkerContainer: false,
      ServiceWorkerGlobalScope: false,
      ServiceWorkerMessageEvent: false,
      ServiceWorkerRegistration: false,
      setInterval: false,
      setTimeout: false,
      skipWaiting: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false,
      WebSocket: false,
      WindowClient: false,
      Worker: false,
      WorkerGlobalScope: false,
      XMLHttpRequest: false
    };
    var atomtest = {
      advanceClock: false,
      fakeClearInterval: false,
      fakeClearTimeout: false,
      fakeSetInterval: false,
      fakeSetTimeout: false,
      resetTimeouts: false,
      waitsForPromise: false
    };
    var embertest = {
      andThen: false,
      click: false,
      currentPath: false,
      currentRouteName: false,
      currentURL: false,
      fillIn: false,
      find: false,
      findAll: false,
      findWithAssert: false,
      keyEvent: false,
      pauseTest: false,
      resumeTest: false,
      triggerEvent: false,
      visit: false,
      wait: false
    };
    var protractor = {
      $: false,
      $$: false,
      browser: false,
      by: false,
      By: false,
      DartObject: false,
      element: false,
      protractor: false
    };
    var webextensions = {
      browser: false,
      chrome: false,
      opr: false
    };
    var greasemonkey = {
      cloneInto: false,
      createObjectIn: false,
      exportFunction: false,
      GM: false,
      GM_addStyle: false,
      GM_deleteValue: false,
      GM_getResourceText: false,
      GM_getResourceURL: false,
      GM_getValue: false,
      GM_info: false,
      GM_listValues: false,
      GM_log: false,
      GM_openInTab: false,
      GM_registerMenuCommand: false,
      GM_setClipboard: false,
      GM_setValue: false,
      GM_xmlhttpRequest: false,
      unsafeWindow: false
    };
    var devtools = {
      $: false,
      $_: false,
      $$: false,
      $0: false,
      $1: false,
      $2: false,
      $3: false,
      $4: false,
      $x: false,
      chrome: false,
      clear: false,
      copy: false,
      debug: false,
      dir: false,
      dirxml: false,
      getEventListeners: false,
      inspect: false,
      keys: false,
      monitor: false,
      monitorEvents: false,
      profile: false,
      profileEnd: false,
      queryObjects: false,
      table: false,
      undebug: false,
      unmonitor: false,
      unmonitorEvents: false,
      values: false
    };
    var require$$0$a = {
      builtin,
      es5,
      es2015,
      es2017,
      browser: browser$2,
      worker,
      node: node$1,
      commonjs,
      amd,
      mocha,
      jasmine,
      jest,
      qunit,
      phantomjs,
      couch,
      rhino,
      nashorn,
      wsh,
      jquery,
      yui,
      shelljs,
      prototypejs,
      meteor,
      mongo,
      applescript,
      serviceworker,
      atomtest,
      embertest,
      protractor,
      "shared-node-browser": {
        clearInterval: false,
        clearTimeout: false,
        console: false,
        setInterval: false,
        setTimeout: false,
        URL: false,
        URLSearchParams: false
      },
      webextensions,
      greasemonkey,
      devtools
    };
    var globalsBABEL_8_BREAKINGFalse;
    var hasRequiredGlobalsBABEL_8_BREAKINGFalse;
    function requireGlobalsBABEL_8_BREAKINGFalse() {
      if (hasRequiredGlobalsBABEL_8_BREAKINGFalse)
        return globalsBABEL_8_BREAKINGFalse;
      hasRequiredGlobalsBABEL_8_BREAKINGFalse = 1;
      globalsBABEL_8_BREAKINGFalse = require$$0$a;
      return globalsBABEL_8_BREAKINGFalse;
    }
    var globals = requireGlobalsBABEL_8_BREAKINGFalse();
    var NOT_LOCAL_BINDING$1 = NOT_LOCAL_BINDING$2, callExpression$d = callExpression$e, cloneNode$g = cloneNode$i, getBindingIdentifiers$1 = getBindingIdentifiers$2, identifier$h = identifier$j, isArrayExpression$1 = isArrayExpression$2, isBinary$2 = isBinary$3, isClass = isClass$1, isClassBody = isClassBody$1, isClassDeclaration$2 = isClassDeclaration$3, isExportAllDeclaration = isExportAllDeclaration$1, isExportDefaultDeclaration$2 = isExportDefaultDeclaration$3, isExportNamedDeclaration$1 = isExportNamedDeclaration$2, isFunctionDeclaration = isFunctionDeclaration$1, isIdentifier$g = isIdentifier$i, isImportDeclaration = isImportDeclaration$2, isLiteral$6 = isLiteral$7, isMethod = isMethod$1, isModuleDeclaration = isModuleDeclaration$1, isModuleSpecifier = isModuleSpecifier$1, isObjectExpression$2 = isObjectExpression$3, isProperty$1 = isProperty$2, isPureish$1 = isPureish$2, isSuper$2 = isSuper$3, isTaggedTemplateExpression$1 = isTaggedTemplateExpression$2, isTemplateLiteral$1 = isTemplateLiteral$2, isThisExpression$1 = isThisExpression$2, isUnaryExpression = isUnaryExpression$1, isVariableDeclaration$1 = isVariableDeclaration$3, matchesPattern$1 = matchesPattern$2, memberExpression$a = memberExpression$b, numericLiteral$6 = numericLiteral$7, toIdentifier = toIdentifier$1, unaryExpression$5 = unaryExpression$6, variableDeclaration$5 = variableDeclaration$7, variableDeclarator$5 = variableDeclarator$7, isRecordExpression = isRecordExpression$1, isTupleExpression = isTupleExpression$1, isObjectProperty$4 = isObjectProperty$5, isTopicReference = isTopicReference$1, isMetaProperty = isMetaProperty$1, isPrivateName$1 = isPrivateName$2;
    function gatherNodeParts(node2, parts) {
      switch (node2 == null ? void 0 : node2.type) {
        default:
          if (isModuleDeclaration(node2)) {
            if ((isExportAllDeclaration(node2) || isExportNamedDeclaration$1(node2) || isImportDeclaration(node2)) && node2.source) {
              gatherNodeParts(node2.source, parts);
            } else if ((isExportNamedDeclaration$1(node2) || isImportDeclaration(node2)) && node2.specifiers && node2.specifiers.length) {
              for (var _iterator2 = _createForOfIteratorHelperLoose(node2.specifiers), _step2; !(_step2 = _iterator2()).done; ) {
                var e2 = _step2.value;
                gatherNodeParts(e2, parts);
              }
            } else if ((isExportDefaultDeclaration$2(node2) || isExportNamedDeclaration$1(node2)) && node2.declaration) {
              gatherNodeParts(node2.declaration, parts);
            }
          } else if (isModuleSpecifier(node2)) {
            gatherNodeParts(node2.local, parts);
          } else if (isLiteral$6(node2)) {
            parts.push(node2.value);
          }
          break;
        case "MemberExpression":
        case "OptionalMemberExpression":
        case "JSXMemberExpression":
          gatherNodeParts(node2.object, parts);
          gatherNodeParts(node2.property, parts);
          break;
        case "Identifier":
        case "JSXIdentifier":
          parts.push(node2.name);
          break;
        case "CallExpression":
        case "OptionalCallExpression":
        case "NewExpression":
          gatherNodeParts(node2.callee, parts);
          break;
        case "ObjectExpression":
        case "ObjectPattern":
          for (var _iterator22 = _createForOfIteratorHelperLoose(node2.properties), _step22; !(_step22 = _iterator22()).done; ) {
            var _e = _step22.value;
            gatherNodeParts(_e, parts);
          }
          break;
        case "SpreadElement":
        case "RestElement":
          gatherNodeParts(node2.argument, parts);
          break;
        case "ObjectProperty":
        case "ObjectMethod":
        case "ClassProperty":
        case "ClassMethod":
        case "ClassPrivateProperty":
        case "ClassPrivateMethod":
          gatherNodeParts(node2.key, parts);
          break;
        case "ThisExpression":
          parts.push("this");
          break;
        case "Super":
          parts.push("super");
          break;
        case "Import":
          parts.push("import");
          break;
        case "DoExpression":
          parts.push("do");
          break;
        case "YieldExpression":
          parts.push("yield");
          gatherNodeParts(node2.argument, parts);
          break;
        case "AwaitExpression":
          parts.push("await");
          gatherNodeParts(node2.argument, parts);
          break;
        case "AssignmentExpression":
          gatherNodeParts(node2.left, parts);
          break;
        case "VariableDeclarator":
          gatherNodeParts(node2.id, parts);
          break;
        case "FunctionExpression":
        case "FunctionDeclaration":
        case "ClassExpression":
        case "ClassDeclaration":
          gatherNodeParts(node2.id, parts);
          break;
        case "PrivateName":
          gatherNodeParts(node2.id, parts);
          break;
        case "ParenthesizedExpression":
          gatherNodeParts(node2.expression, parts);
          break;
        case "UnaryExpression":
        case "UpdateExpression":
          gatherNodeParts(node2.argument, parts);
          break;
        case "MetaProperty":
          gatherNodeParts(node2.meta, parts);
          gatherNodeParts(node2.property, parts);
          break;
        case "JSXElement":
          gatherNodeParts(node2.openingElement, parts);
          break;
        case "JSXOpeningElement":
          parts.push(node2.name);
          break;
        case "JSXFragment":
          gatherNodeParts(node2.openingFragment, parts);
          break;
        case "JSXOpeningFragment":
          parts.push("Fragment");
          break;
        case "JSXNamespacedName":
          gatherNodeParts(node2.namespace, parts);
          gatherNodeParts(node2.name, parts);
          break;
      }
    }
    var collectorVisitor = {
      ForStatement: function ForStatement2(path2) {
        var declar = path2.get("init");
        if (declar.isVar()) {
          var scope2 = path2.scope;
          var parentScope = scope2.getFunctionParent() || scope2.getProgramParent();
          parentScope.registerBinding("var", declar);
        }
      },
      Declaration: function Declaration(path2) {
        if (path2.isBlockScoped())
          return;
        if (path2.isImportDeclaration())
          return;
        if (path2.isExportDeclaration())
          return;
        var parent = path2.scope.getFunctionParent() || path2.scope.getProgramParent();
        parent.registerDeclaration(path2);
      },
      ImportDeclaration: function ImportDeclaration2(path2) {
        var parent = path2.scope.getBlockParent();
        parent.registerDeclaration(path2);
      },
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        state.references.push(path2);
      },
      ForXStatement: function ForXStatement(path2, state) {
        var left = path2.get("left");
        if (left.isPattern() || left.isIdentifier()) {
          state.constantViolations.push(path2);
        } else if (left.isVar()) {
          var scope2 = path2.scope;
          var parentScope = scope2.getFunctionParent() || scope2.getProgramParent();
          parentScope.registerBinding("var", left);
        }
      },
      ExportDeclaration: {
        exit: function exit(path2) {
          var node2 = path2.node, scope2 = path2.scope;
          if (isExportAllDeclaration(node2))
            return;
          var declar = node2.declaration;
          if (isClassDeclaration$2(declar) || isFunctionDeclaration(declar)) {
            var id3 = declar.id;
            if (!id3)
              return;
            var binding2 = scope2.getBinding(id3.name);
            binding2 == null ? void 0 : binding2.reference(path2);
          } else if (isVariableDeclaration$1(declar)) {
            for (var _iterator3 = _createForOfIteratorHelperLoose(declar.declarations), _step3; !(_step3 = _iterator3()).done; ) {
              var decl = _step3.value;
              for (var _i3 = 0, _Object$keys3 = Object.keys(getBindingIdentifiers$1(decl)); _i3 < _Object$keys3.length; _i3++) {
                var _name = _Object$keys3[_i3];
                var _binding = scope2.getBinding(_name);
                _binding == null ? void 0 : _binding.reference(path2);
              }
            }
          }
        }
      },
      LabeledStatement: function LabeledStatement2(path2) {
        path2.scope.getBlockParent().registerDeclaration(path2);
      },
      AssignmentExpression: function AssignmentExpression2(path2, state) {
        state.assignments.push(path2);
      },
      UpdateExpression: function UpdateExpression2(path2, state) {
        state.constantViolations.push(path2);
      },
      UnaryExpression: function UnaryExpression2(path2, state) {
        if (path2.node.operator === "delete") {
          state.constantViolations.push(path2);
        }
      },
      BlockScoped: function BlockScoped2(path2) {
        var scope2 = path2.scope;
        if (scope2.path === path2)
          scope2 = scope2.parent;
        var parent = scope2.getBlockParent();
        parent.registerDeclaration(path2);
        if (path2.isClassDeclaration() && path2.node.id) {
          var id3 = path2.node.id;
          var _name2 = id3.name;
          path2.scope.bindings[_name2] = path2.scope.parent.getBinding(_name2);
        }
      },
      CatchClause: function CatchClause2(path2) {
        path2.scope.registerBinding("let", path2);
      },
      Function: function Function2(path2) {
        var params = path2.get("params");
        for (var _iterator4 = _createForOfIteratorHelperLoose(params), _step4; !(_step4 = _iterator4()).done; ) {
          var param = _step4.value;
          path2.scope.registerBinding("param", param);
        }
        if (path2.isFunctionExpression() && path2.has("id") && !path2.get("id").node[NOT_LOCAL_BINDING$1]) {
          path2.scope.registerBinding("local", path2.get("id"), path2);
        }
      },
      ClassExpression: function ClassExpression2(path2) {
        if (path2.has("id") && !path2.get("id").node[NOT_LOCAL_BINDING$1]) {
          path2.scope.registerBinding("local", path2);
        }
      }
    };
    var uid = 0;
    var Scope$1 = function() {
      function Scope4(path2) {
        this.uid = void 0;
        this.path = void 0;
        this.block = void 0;
        this.labels = void 0;
        this.inited = void 0;
        this.bindings = void 0;
        this.references = void 0;
        this.globals = void 0;
        this.uids = void 0;
        this.data = void 0;
        this.crawling = void 0;
        var node2 = path2.node;
        var cached2 = scope.get(node2);
        if ((cached2 == null ? void 0 : cached2.path) === path2) {
          return cached2;
        }
        scope.set(node2, this);
        this.uid = uid++;
        this.block = node2;
        this.path = path2;
        this.labels = /* @__PURE__ */ new Map();
        this.inited = false;
      }
      var _proto = Scope4.prototype;
      _proto.traverse = function traverse$12(node2, opts, state) {
        traverse(node2, opts, this, state, this.path);
      };
      _proto.generateDeclaredUidIdentifier = function generateDeclaredUidIdentifier(name2) {
        var id3 = this.generateUidIdentifier(name2);
        this.push({
          id: id3
        });
        return cloneNode$g(id3);
      };
      _proto.generateUidIdentifier = function generateUidIdentifier(name2) {
        return identifier$h(this.generateUid(name2));
      };
      _proto.generateUid = function generateUid2(name2) {
        if (name2 === void 0) {
          name2 = "temp";
        }
        name2 = toIdentifier(name2).replace(/^_+/, "").replace(/[0-9]+$/g, "");
        var uid2;
        var i2 = 1;
        do {
          uid2 = this._generateUid(name2, i2);
          i2++;
        } while (this.hasLabel(uid2) || this.hasBinding(uid2) || this.hasGlobal(uid2) || this.hasReference(uid2));
        var program2 = this.getProgramParent();
        program2.references[uid2] = true;
        program2.uids[uid2] = true;
        return uid2;
      };
      _proto._generateUid = function _generateUid(name2, i2) {
        var id3 = name2;
        if (i2 > 1)
          id3 += i2;
        return "_" + id3;
      };
      _proto.generateUidBasedOnNode = function generateUidBasedOnNode(node2, defaultName) {
        var parts = [];
        gatherNodeParts(node2, parts);
        var id3 = parts.join("$");
        id3 = id3.replace(/^_/, "") || defaultName || "ref";
        return this.generateUid(id3.slice(0, 20));
      };
      _proto.generateUidIdentifierBasedOnNode = function generateUidIdentifierBasedOnNode(node2, defaultName) {
        return identifier$h(this.generateUidBasedOnNode(node2, defaultName));
      };
      _proto.isStatic = function isStatic2(node2) {
        if (isThisExpression$1(node2) || isSuper$2(node2) || isTopicReference(node2)) {
          return true;
        }
        if (isIdentifier$g(node2)) {
          var binding2 = this.getBinding(node2.name);
          if (binding2) {
            return binding2.constant;
          } else {
            return this.hasBinding(node2.name);
          }
        }
        return false;
      };
      _proto.maybeGenerateMemoised = function maybeGenerateMemoised(node2, dontPush) {
        if (this.isStatic(node2)) {
          return null;
        } else {
          var id3 = this.generateUidIdentifierBasedOnNode(node2);
          if (!dontPush) {
            this.push({
              id: id3
            });
            return cloneNode$g(id3);
          }
          return id3;
        }
      };
      _proto.checkBlockScopedCollisions = function checkBlockScopedCollisions(local, kind, name2, id3) {
        if (kind === "param")
          return;
        if (local.kind === "local")
          return;
        var duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";
        if (duplicate) {
          throw this.hub.buildError(id3, 'Duplicate declaration "' + name2 + '"', TypeError);
        }
      };
      _proto.rename = function rename(oldName, newName, block) {
        var binding2 = this.getBinding(oldName);
        if (binding2) {
          newName = newName || this.generateUidIdentifier(oldName).name;
          return new Renamer(binding2, oldName, newName).rename(block);
        }
      };
      _proto._renameFromMap = function _renameFromMap(map2, oldName, newName, value) {
        if (map2[oldName]) {
          map2[newName] = value;
          map2[oldName] = null;
        }
      };
      _proto.dump = function dump() {
        var sep2 = "-".repeat(60);
        console.log(sep2);
        var scope2 = this;
        do {
          console.log("#", scope2.block.type);
          for (var _i22 = 0, _Object$keys22 = Object.keys(scope2.bindings); _i22 < _Object$keys22.length; _i22++) {
            var _name3 = _Object$keys22[_i22];
            var binding2 = scope2.bindings[_name3];
            console.log(" -", _name3, {
              constant: binding2.constant,
              references: binding2.references,
              violations: binding2.constantViolations.length,
              kind: binding2.kind
            });
          }
        } while (scope2 = scope2.parent);
        console.log(sep2);
      };
      _proto.toArray = function toArray2(node2, i2, arrayLikeIsIterable) {
        if (isIdentifier$g(node2)) {
          var binding2 = this.getBinding(node2.name);
          if (binding2 != null && binding2.constant && binding2.path.isGenericType("Array")) {
            return node2;
          }
        }
        if (isArrayExpression$1(node2)) {
          return node2;
        }
        if (isIdentifier$g(node2, {
          name: "arguments"
        })) {
          return callExpression$d(memberExpression$a(memberExpression$a(memberExpression$a(identifier$h("Array"), identifier$h("prototype")), identifier$h("slice")), identifier$h("call")), [node2]);
        }
        var helperName;
        var args = [node2];
        if (i2 === true) {
          helperName = "toConsumableArray";
        } else if (i2) {
          args.push(numericLiteral$6(i2));
          helperName = "slicedToArray";
        } else {
          helperName = "toArray";
        }
        if (arrayLikeIsIterable) {
          args.unshift(this.hub.addHelper(helperName));
          helperName = "maybeArrayLike";
        }
        return callExpression$d(this.hub.addHelper(helperName), args);
      };
      _proto.hasLabel = function hasLabel(name2) {
        return !!this.getLabel(name2);
      };
      _proto.getLabel = function getLabel(name2) {
        return this.labels.get(name2);
      };
      _proto.registerLabel = function registerLabel(path2) {
        this.labels.set(path2.node.label.name, path2);
      };
      _proto.registerDeclaration = function registerDeclaration(path2) {
        if (path2.isLabeledStatement()) {
          this.registerLabel(path2);
        } else if (path2.isFunctionDeclaration()) {
          this.registerBinding("hoisted", path2.get("id"), path2);
        } else if (path2.isVariableDeclaration()) {
          var declarations = path2.get("declarations");
          for (var _iterator5 = _createForOfIteratorHelperLoose(declarations), _step5; !(_step5 = _iterator5()).done; ) {
            var declar = _step5.value;
            this.registerBinding(path2.node.kind, declar);
          }
        } else if (path2.isClassDeclaration()) {
          if (path2.node.declare)
            return;
          this.registerBinding("let", path2);
        } else if (path2.isImportDeclaration()) {
          var specifiers = path2.get("specifiers");
          for (var _iterator6 = _createForOfIteratorHelperLoose(specifiers), _step6; !(_step6 = _iterator6()).done; ) {
            var specifier = _step6.value;
            this.registerBinding("module", specifier);
          }
        } else if (path2.isExportDeclaration()) {
          var _declar = path2.get("declaration");
          if (_declar.isClassDeclaration() || _declar.isFunctionDeclaration() || _declar.isVariableDeclaration()) {
            this.registerDeclaration(_declar);
          }
        } else {
          this.registerBinding("unknown", path2);
        }
      };
      _proto.buildUndefinedNode = function buildUndefinedNode() {
        return unaryExpression$5("void", numericLiteral$6(0), true);
      };
      _proto.registerConstantViolation = function registerConstantViolation(path2) {
        var ids2 = path2.getBindingIdentifiers();
        for (var _i3 = 0, _Object$keys3 = Object.keys(ids2); _i3 < _Object$keys3.length; _i3++) {
          var _name4 = _Object$keys3[_i3];
          var binding2 = this.getBinding(_name4);
          if (binding2)
            binding2.reassign(path2);
        }
      };
      _proto.registerBinding = function registerBinding(kind, path2, bindingPath) {
        if (bindingPath === void 0) {
          bindingPath = path2;
        }
        if (!kind)
          throw new ReferenceError("no `kind`");
        if (path2.isVariableDeclaration()) {
          var declarators = path2.get("declarations");
          for (var _iterator7 = _createForOfIteratorHelperLoose(declarators), _step7; !(_step7 = _iterator7()).done; ) {
            var declar = _step7.value;
            this.registerBinding(kind, declar);
          }
          return;
        }
        var parent = this.getProgramParent();
        var ids2 = path2.getOuterBindingIdentifiers(true);
        for (var _i4 = 0, _Object$keys4 = Object.keys(ids2); _i4 < _Object$keys4.length; _i4++) {
          var _name5 = _Object$keys4[_i4];
          parent.references[_name5] = true;
          for (var _iterator8 = _createForOfIteratorHelperLoose(ids2[_name5]), _step8; !(_step8 = _iterator8()).done; ) {
            var id3 = _step8.value;
            var local = this.getOwnBinding(_name5);
            if (local) {
              if (local.identifier === id3)
                continue;
              this.checkBlockScopedCollisions(local, kind, _name5, id3);
            }
            if (local) {
              this.registerConstantViolation(bindingPath);
            } else {
              this.bindings[_name5] = new Binding({
                identifier: id3,
                scope: this,
                path: bindingPath,
                kind
              });
            }
          }
        }
      };
      _proto.addGlobal = function addGlobal(node2) {
        this.globals[node2.name] = node2;
      };
      _proto.hasUid = function hasUid(name2) {
        var scope2 = this;
        do {
          if (scope2.uids[name2])
            return true;
        } while (scope2 = scope2.parent);
        return false;
      };
      _proto.hasGlobal = function hasGlobal(name2) {
        var scope2 = this;
        do {
          if (scope2.globals[name2])
            return true;
        } while (scope2 = scope2.parent);
        return false;
      };
      _proto.hasReference = function hasReference(name2) {
        return !!this.getProgramParent().references[name2];
      };
      _proto.isPure = function isPure(node2, constantsOnly) {
        if (isIdentifier$g(node2)) {
          var binding2 = this.getBinding(node2.name);
          if (!binding2)
            return false;
          if (constantsOnly)
            return binding2.constant;
          return true;
        } else if (isThisExpression$1(node2) || isMetaProperty(node2) || isTopicReference(node2) || isPrivateName$1(node2)) {
          return true;
        } else if (isClass(node2)) {
          var _node$decorators;
          if (node2.superClass && !this.isPure(node2.superClass, constantsOnly)) {
            return false;
          }
          if (((_node$decorators = node2.decorators) == null ? void 0 : _node$decorators.length) > 0) {
            return false;
          }
          return this.isPure(node2.body, constantsOnly);
        } else if (isClassBody(node2)) {
          for (var _iterator9 = _createForOfIteratorHelperLoose(node2.body), _step9; !(_step9 = _iterator9()).done; ) {
            var method5 = _step9.value;
            if (!this.isPure(method5, constantsOnly))
              return false;
          }
          return true;
        } else if (isBinary$2(node2)) {
          return this.isPure(node2.left, constantsOnly) && this.isPure(node2.right, constantsOnly);
        } else if (isArrayExpression$1(node2) || isTupleExpression(node2)) {
          for (var _iterator10 = _createForOfIteratorHelperLoose(node2.elements), _step10; !(_step10 = _iterator10()).done; ) {
            var elem = _step10.value;
            if (elem !== null && !this.isPure(elem, constantsOnly))
              return false;
          }
          return true;
        } else if (isObjectExpression$2(node2) || isRecordExpression(node2)) {
          for (var _iterator11 = _createForOfIteratorHelperLoose(node2.properties), _step11; !(_step11 = _iterator11()).done; ) {
            var prop2 = _step11.value;
            if (!this.isPure(prop2, constantsOnly))
              return false;
          }
          return true;
        } else if (isMethod(node2)) {
          var _node$decorators2;
          if (node2.computed && !this.isPure(node2.key, constantsOnly))
            return false;
          if (((_node$decorators2 = node2.decorators) == null ? void 0 : _node$decorators2.length) > 0) {
            return false;
          }
          return true;
        } else if (isProperty$1(node2)) {
          var _node$decorators3;
          if (node2.computed && !this.isPure(node2.key, constantsOnly))
            return false;
          if (((_node$decorators3 = node2.decorators) == null ? void 0 : _node$decorators3.length) > 0) {
            return false;
          }
          if (isObjectProperty$4(node2) || node2["static"]) {
            if (node2.value !== null && !this.isPure(node2.value, constantsOnly)) {
              return false;
            }
          }
          return true;
        } else if (isUnaryExpression(node2)) {
          return this.isPure(node2.argument, constantsOnly);
        } else if (isTaggedTemplateExpression$1(node2)) {
          return matchesPattern$1(node2.tag, "String.raw") && !this.hasBinding("String", true) && this.isPure(node2.quasi, constantsOnly);
        } else if (isTemplateLiteral$1(node2)) {
          for (var _iterator12 = _createForOfIteratorHelperLoose(node2.expressions), _step12; !(_step12 = _iterator12()).done; ) {
            var expression2 = _step12.value;
            if (!this.isPure(expression2, constantsOnly))
              return false;
          }
          return true;
        } else {
          return isPureish$1(node2);
        }
      };
      _proto.setData = function setData(key2, val) {
        return this.data[key2] = val;
      };
      _proto.getData = function getData(key2) {
        var scope2 = this;
        do {
          var data3 = scope2.data[key2];
          if (data3 != null)
            return data3;
        } while (scope2 = scope2.parent);
      };
      _proto.removeData = function removeData(key2) {
        var scope2 = this;
        do {
          var data3 = scope2.data[key2];
          if (data3 != null)
            scope2.data[key2] = null;
        } while (scope2 = scope2.parent);
      };
      _proto.init = function init3() {
        if (!this.inited) {
          this.inited = true;
          this.crawl();
        }
      };
      _proto.crawl = function crawl2() {
        var path2 = this.path;
        this.references = /* @__PURE__ */ Object.create(null);
        this.bindings = /* @__PURE__ */ Object.create(null);
        this.globals = /* @__PURE__ */ Object.create(null);
        this.uids = /* @__PURE__ */ Object.create(null);
        this.data = /* @__PURE__ */ Object.create(null);
        var programParent = this.getProgramParent();
        if (programParent.crawling)
          return;
        var state = {
          references: [],
          constantViolations: [],
          assignments: []
        };
        this.crawling = true;
        if (path2.type !== "Program" && collectorVisitor._exploded) {
          for (var _iterator13 = _createForOfIteratorHelperLoose(collectorVisitor.enter), _step13; !(_step13 = _iterator13()).done; ) {
            var _visit = _step13.value;
            _visit(path2, state);
          }
          var typeVisitors = collectorVisitor[path2.type];
          if (typeVisitors) {
            for (var _iterator14 = _createForOfIteratorHelperLoose(typeVisitors.enter), _step14; !(_step14 = _iterator14()).done; ) {
              var visit2 = _step14.value;
              visit2(path2, state);
            }
          }
        }
        path2.traverse(collectorVisitor, state);
        this.crawling = false;
        for (var _iterator15 = _createForOfIteratorHelperLoose(state.assignments), _step15; !(_step15 = _iterator15()).done; ) {
          var _path = _step15.value;
          var ids2 = _path.getBindingIdentifiers();
          for (var _i5 = 0, _Object$keys5 = Object.keys(ids2); _i5 < _Object$keys5.length; _i5++) {
            var _name6 = _Object$keys5[_i5];
            if (_path.scope.getBinding(_name6))
              continue;
            programParent.addGlobal(ids2[_name6]);
          }
          _path.scope.registerConstantViolation(_path);
        }
        for (var _iterator16 = _createForOfIteratorHelperLoose(state.references), _step16; !(_step16 = _iterator16()).done; ) {
          var ref2 = _step16.value;
          var binding2 = ref2.scope.getBinding(ref2.node.name);
          if (binding2) {
            binding2.reference(ref2);
          } else {
            programParent.addGlobal(ref2.node);
          }
        }
        for (var _iterator17 = _createForOfIteratorHelperLoose(state.constantViolations), _step17; !(_step17 = _iterator17()).done; ) {
          var _path2 = _step17.value;
          _path2.scope.registerConstantViolation(_path2);
        }
      };
      _proto.push = function push3(opts) {
        var path2 = this.path;
        if (!path2.isBlockStatement() && !path2.isProgram()) {
          path2 = this.getBlockParent().path;
        }
        if (path2.isSwitchStatement()) {
          path2 = (this.getFunctionParent() || this.getProgramParent()).path;
        }
        if (path2.isLoop() || path2.isCatchClause() || path2.isFunction()) {
          path2.ensureBlock();
          path2 = path2.get("body");
        }
        var unique = opts.unique;
        var kind = opts.kind || "var";
        var blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
        var dataKey = "declaration:" + kind + ":" + blockHoist;
        var declarPath = !unique && path2.getData(dataKey);
        if (!declarPath) {
          var declar = variableDeclaration$5(kind, []);
          declar._blockHoist = blockHoist;
          var _path$unshiftContaine = path2.unshiftContainer("body", [declar]);
          var _path$unshiftContaine2 = _slicedToArray$12(_path$unshiftContaine, 1);
          declarPath = _path$unshiftContaine2[0];
          if (!unique)
            path2.setData(dataKey, declarPath);
        }
        var declarator = variableDeclarator$5(opts.id, opts.init);
        var len3 = declarPath.node.declarations.push(declarator);
        path2.scope.registerBinding(kind, declarPath.get("declarations")[len3 - 1]);
      };
      _proto.getProgramParent = function getProgramParent() {
        var scope2 = this;
        do {
          if (scope2.path.isProgram()) {
            return scope2;
          }
        } while (scope2 = scope2.parent);
        throw new Error("Couldn't find a Program");
      };
      _proto.getFunctionParent = function getFunctionParent2() {
        var scope2 = this;
        do {
          if (scope2.path.isFunctionParent()) {
            return scope2;
          }
        } while (scope2 = scope2.parent);
        return null;
      };
      _proto.getBlockParent = function getBlockParent() {
        var scope2 = this;
        do {
          if (scope2.path.isBlockParent()) {
            return scope2;
          }
        } while (scope2 = scope2.parent);
        throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
      };
      _proto.getAllBindings = function getAllBindings() {
        var ids2 = /* @__PURE__ */ Object.create(null);
        var scope2 = this;
        do {
          for (var _i6 = 0, _Object$keys6 = Object.keys(scope2.bindings); _i6 < _Object$keys6.length; _i6++) {
            var key2 = _Object$keys6[_i6];
            if (key2 in ids2 === false) {
              ids2[key2] = scope2.bindings[key2];
            }
          }
          scope2 = scope2.parent;
        } while (scope2);
        return ids2;
      };
      _proto.getAllBindingsOfKind = function getAllBindingsOfKind() {
        var ids2 = /* @__PURE__ */ Object.create(null);
        for (var _len = arguments.length, kinds = new Array(_len), _key = 0; _key < _len; _key++) {
          kinds[_key] = arguments[_key];
        }
        for (var _i7 = 0, _kinds = kinds; _i7 < _kinds.length; _i7++) {
          var kind = _kinds[_i7];
          var scope2 = this;
          do {
            for (var _i8 = 0, _Object$keys7 = Object.keys(scope2.bindings); _i8 < _Object$keys7.length; _i8++) {
              var _name7 = _Object$keys7[_i8];
              var binding2 = scope2.bindings[_name7];
              if (binding2.kind === kind)
                ids2[_name7] = binding2;
            }
            scope2 = scope2.parent;
          } while (scope2);
        }
        return ids2;
      };
      _proto.bindingIdentifierEquals = function bindingIdentifierEquals(name2, node2) {
        return this.getBindingIdentifier(name2) === node2;
      };
      _proto.getBinding = function getBinding2(name2) {
        var scope2 = this;
        var previousPath;
        do {
          var binding2 = scope2.getOwnBinding(name2);
          if (binding2) {
            var _previousPath;
            if ((_previousPath = previousPath) != null && _previousPath.isPattern() && binding2.kind !== "param" && binding2.kind !== "local")
              ;
            else {
              return binding2;
            }
          } else if (!binding2 && name2 === "arguments" && scope2.path.isFunction() && !scope2.path.isArrowFunctionExpression()) {
            break;
          }
          previousPath = scope2.path;
        } while (scope2 = scope2.parent);
      };
      _proto.getOwnBinding = function getOwnBinding(name2) {
        return this.bindings[name2];
      };
      _proto.getBindingIdentifier = function getBindingIdentifier(name2) {
        var _this$getBinding;
        return (_this$getBinding = this.getBinding(name2)) == null ? void 0 : _this$getBinding.identifier;
      };
      _proto.getOwnBindingIdentifier = function getOwnBindingIdentifier(name2) {
        var binding2 = this.bindings[name2];
        return binding2 == null ? void 0 : binding2.identifier;
      };
      _proto.hasOwnBinding = function hasOwnBinding(name2) {
        return !!this.getOwnBinding(name2);
      };
      _proto.hasBinding = function hasBinding(name2, noGlobals) {
        if (!name2)
          return false;
        if (this.hasOwnBinding(name2))
          return true;
        if (this.parentHasBinding(name2, noGlobals))
          return true;
        if (this.hasUid(name2))
          return true;
        if (!noGlobals && Scope4.globals.includes(name2))
          return true;
        if (!noGlobals && Scope4.contextVariables.includes(name2))
          return true;
        return false;
      };
      _proto.parentHasBinding = function parentHasBinding(name2, noGlobals) {
        var _this$parent;
        return (_this$parent = this.parent) == null ? void 0 : _this$parent.hasBinding(name2, noGlobals);
      };
      _proto.moveBindingTo = function moveBindingTo(name2, scope2) {
        var info = this.getBinding(name2);
        if (info) {
          info.scope.removeOwnBinding(name2);
          info.scope = scope2;
          scope2.bindings[name2] = info;
        }
      };
      _proto.removeOwnBinding = function removeOwnBinding(name2) {
        delete this.bindings[name2];
      };
      _proto.removeBinding = function removeBinding(name2) {
        var _this$getBinding2;
        (_this$getBinding2 = this.getBinding(name2)) == null ? void 0 : _this$getBinding2.scope.removeOwnBinding(name2);
        var scope2 = this;
        do {
          if (scope2.uids[name2]) {
            scope2.uids[name2] = false;
          }
        } while (scope2 = scope2.parent);
      };
      _createClass2(Scope4, [{
        key: "parent",
        get: function get3() {
          var _parent;
          var parent, path2 = this.path;
          do {
            var isKey = path2.key === "key";
            path2 = path2.parentPath;
            if (isKey && path2.isMethod())
              path2 = path2.parentPath;
            if (path2 && path2.isScope())
              parent = path2;
          } while (path2 && !parent);
          return (_parent = parent) == null ? void 0 : _parent.scope;
        }
      }, {
        key: "parentBlock",
        get: function get3() {
          return this.path.parent;
        }
      }, {
        key: "hub",
        get: function get3() {
          return this.path.hub;
        }
      }]);
      return Scope4;
    }();
    Scope$1.globals = Object.keys(globals.builtin);
    Scope$1.contextVariables = ["arguments", "undefined", "Infinity", "NaN"];
    var genMapping_umd = { exports: {} };
    var setArray_umd = { exports: {} };
    var hasRequiredSetArray_umd;
    function requireSetArray_umd() {
      if (hasRequiredSetArray_umd)
        return setArray_umd.exports;
      hasRequiredSetArray_umd = 1;
      (function(module2, exports3) {
        (function(global2, factory) {
          factory(exports3);
        })(commonjsGlobal$1, function(exports4) {
          exports4.get = void 0;
          exports4.put = void 0;
          var SetArray = _createClass2(function SetArray2() {
            this._indexes = {
              __proto__: null
            };
            this.array = [];
          });
          (function() {
            exports4.get = function(strarr, key2) {
              return strarr._indexes[key2];
            };
            exports4.put = function(strarr, key2) {
              var index3 = exports4.get(strarr, key2);
              if (index3 !== void 0)
                return index3;
              var array4 = strarr.array, indexes = strarr._indexes;
              return indexes[key2] = array4.push(key2) - 1;
            };
          })();
          exports4.SetArray = SetArray;
          Object.defineProperty(exports4, "__esModule", {
            value: true
          });
        });
      })(setArray_umd, setArray_umd.exports);
      return setArray_umd.exports;
    }
    var lookup$1 = [];
    var revLookup$1 = [];
    var Arr$1 = typeof Uint8Array !== "undefined" ? Uint8Array : Array;
    var inited = false;
    function init2() {
      inited = true;
      var code3 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
      for (var i2 = 0, len3 = code3.length; i2 < len3; ++i2) {
        lookup$1[i2] = code3[i2];
        revLookup$1[code3.charCodeAt(i2)] = i2;
      }
      revLookup$1["-".charCodeAt(0)] = 62;
      revLookup$1["_".charCodeAt(0)] = 63;
    }
    function toByteArray$1(b64) {
      if (!inited) {
        init2();
      }
      var i2, j, l2, tmp, placeHolders, arr;
      var len3 = b64.length;
      if (len3 % 4 > 0) {
        throw new Error("Invalid string. Length must be a multiple of 4");
      }
      placeHolders = b64[len3 - 2] === "=" ? 2 : b64[len3 - 1] === "=" ? 1 : 0;
      arr = new Arr$1(len3 * 3 / 4 - placeHolders);
      l2 = placeHolders > 0 ? len3 - 4 : len3;
      var L = 0;
      for (i2 = 0, j = 0; i2 < l2; i2 += 4, j += 3) {
        tmp = revLookup$1[b64.charCodeAt(i2)] << 18 | revLookup$1[b64.charCodeAt(i2 + 1)] << 12 | revLookup$1[b64.charCodeAt(i2 + 2)] << 6 | revLookup$1[b64.charCodeAt(i2 + 3)];
        arr[L++] = tmp >> 16 & 255;
        arr[L++] = tmp >> 8 & 255;
        arr[L++] = tmp & 255;
      }
      if (placeHolders === 2) {
        tmp = revLookup$1[b64.charCodeAt(i2)] << 2 | revLookup$1[b64.charCodeAt(i2 + 1)] >> 4;
        arr[L++] = tmp & 255;
      } else if (placeHolders === 1) {
        tmp = revLookup$1[b64.charCodeAt(i2)] << 10 | revLookup$1[b64.charCodeAt(i2 + 1)] << 4 | revLookup$1[b64.charCodeAt(i2 + 2)] >> 2;
        arr[L++] = tmp >> 8 & 255;
        arr[L++] = tmp & 255;
      }
      return arr;
    }
    function tripletToBase64$1(num) {
      return lookup$1[num >> 18 & 63] + lookup$1[num >> 12 & 63] + lookup$1[num >> 6 & 63] + lookup$1[num & 63];
    }
    function encodeChunk$1(uint8, start2, end2) {
      var tmp;
      var output = [];
      for (var i2 = start2; i2 < end2; i2 += 3) {
        tmp = (uint8[i2] << 16) + (uint8[i2 + 1] << 8) + uint8[i2 + 2];
        output.push(tripletToBase64$1(tmp));
      }
      return output.join("");
    }
    function fromByteArray$1(uint8) {
      if (!inited) {
        init2();
      }
      var tmp;
      var len3 = uint8.length;
      var extraBytes = len3 % 3;
      var output = "";
      var parts = [];
      var maxChunkLength = 16383;
      for (var i2 = 0, len22 = len3 - extraBytes; i2 < len22; i2 += maxChunkLength) {
        parts.push(encodeChunk$1(uint8, i2, i2 + maxChunkLength > len22 ? len22 : i2 + maxChunkLength));
      }
      if (extraBytes === 1) {
        tmp = uint8[len3 - 1];
        output += lookup$1[tmp >> 2];
        output += lookup$1[tmp << 4 & 63];
        output += "==";
      } else if (extraBytes === 2) {
        tmp = (uint8[len3 - 2] << 8) + uint8[len3 - 1];
        output += lookup$1[tmp >> 10];
        output += lookup$1[tmp >> 4 & 63];
        output += lookup$1[tmp << 2 & 63];
        output += "=";
      }
      parts.push(output);
      return parts.join("");
    }
    function read(buffer2, offset3, isLE, mLen, nBytes) {
      var e2, m2;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var nBits = -7;
      var i2 = isLE ? nBytes - 1 : 0;
      var d2 = isLE ? -1 : 1;
      var s = buffer2[offset3 + i2];
      i2 += d2;
      e2 = s & (1 << -nBits) - 1;
      s >>= -nBits;
      nBits += eLen;
      for (; nBits > 0; e2 = e2 * 256 + buffer2[offset3 + i2], i2 += d2, nBits -= 8) {
      }
      m2 = e2 & (1 << -nBits) - 1;
      e2 >>= -nBits;
      nBits += mLen;
      for (; nBits > 0; m2 = m2 * 256 + buffer2[offset3 + i2], i2 += d2, nBits -= 8) {
      }
      if (e2 === 0) {
        e2 = 1 - eBias;
      } else if (e2 === eMax) {
        return m2 ? NaN : (s ? -1 : 1) * Infinity;
      } else {
        m2 = m2 + Math.pow(2, mLen);
        e2 = e2 - eBias;
      }
      return (s ? -1 : 1) * m2 * Math.pow(2, e2 - mLen);
    }
    function write(buffer2, value, offset3, isLE, mLen, nBytes) {
      var e2, m2, c2;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var rt2 = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
      var i2 = isLE ? 0 : nBytes - 1;
      var d2 = isLE ? 1 : -1;
      var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
      value = Math.abs(value);
      if (isNaN(value) || value === Infinity) {
        m2 = isNaN(value) ? 1 : 0;
        e2 = eMax;
      } else {
        e2 = Math.floor(Math.log(value) / Math.LN2);
        if (value * (c2 = Math.pow(2, -e2)) < 1) {
          e2--;
          c2 *= 2;
        }
        if (e2 + eBias >= 1) {
          value += rt2 / c2;
        } else {
          value += rt2 * Math.pow(2, 1 - eBias);
        }
        if (value * c2 >= 2) {
          e2++;
          c2 /= 2;
        }
        if (e2 + eBias >= eMax) {
          m2 = 0;
          e2 = eMax;
        } else if (e2 + eBias >= 1) {
          m2 = (value * c2 - 1) * Math.pow(2, mLen);
          e2 = e2 + eBias;
        } else {
          m2 = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
          e2 = 0;
        }
      }
      for (; mLen >= 8; buffer2[offset3 + i2] = m2 & 255, i2 += d2, m2 /= 256, mLen -= 8) {
      }
      e2 = e2 << mLen | m2;
      eLen += mLen;
      for (; eLen > 0; buffer2[offset3 + i2] = e2 & 255, i2 += d2, e2 /= 256, eLen -= 8) {
      }
      buffer2[offset3 + i2 - d2] |= s * 128;
    }
    var toString2 = {}.toString;
    var isArray$12 = Array.isArray || function(arr) {
      return toString2.call(arr) == "[object Array]";
    };
    /*!
     * The buffer module from node.js, for the browser.
     *
     * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
     * @license  MIT
     */
    var INSPECT_MAX_BYTES = 50;
    Buffer$1.TYPED_ARRAY_SUPPORT = global$12.TYPED_ARRAY_SUPPORT !== void 0 ? global$12.TYPED_ARRAY_SUPPORT : true;
    function kMaxLength() {
      return Buffer$1.TYPED_ARRAY_SUPPORT ? 2147483647 : 1073741823;
    }
    function createBuffer(that, length) {
      if (kMaxLength() < length) {
        throw new RangeError("Invalid typed array length");
      }
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        that = new Uint8Array(length);
        that.__proto__ = Buffer$1.prototype;
      } else {
        if (that === null) {
          that = new Buffer$1(length);
        }
        that.length = length;
      }
      return that;
    }
    function Buffer$1(arg, encodingOrOffset, length) {
      if (!Buffer$1.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer$1)) {
        return new Buffer$1(arg, encodingOrOffset, length);
      }
      if (typeof arg === "number") {
        if (typeof encodingOrOffset === "string") {
          throw new Error("If encoding is specified then the first argument must be a string");
        }
        return allocUnsafe(this, arg);
      }
      return from$1(this, arg, encodingOrOffset, length);
    }
    Buffer$1.poolSize = 8192;
    Buffer$1._augment = function(arr) {
      arr.__proto__ = Buffer$1.prototype;
      return arr;
    };
    function from$1(that, value, encodingOrOffset, length) {
      if (typeof value === "number") {
        throw new TypeError('"value" argument must not be a number');
      }
      if (typeof ArrayBuffer !== "undefined" && value instanceof ArrayBuffer) {
        return fromArrayBuffer(that, value, encodingOrOffset, length);
      }
      if (typeof value === "string") {
        return fromString(that, value, encodingOrOffset);
      }
      return fromObject(that, value);
    }
    Buffer$1.from = function(value, encodingOrOffset, length) {
      return from$1(null, value, encodingOrOffset, length);
    };
    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
      Buffer$1.prototype.__proto__ = Uint8Array.prototype;
      Buffer$1.__proto__ = Uint8Array;
    }
    function assertSize(size) {
      if (typeof size !== "number") {
        throw new TypeError('"size" argument must be a number');
      } else if (size < 0) {
        throw new RangeError('"size" argument must not be negative');
      }
    }
    function alloc(that, size, fill, encoding) {
      assertSize(size);
      if (size <= 0) {
        return createBuffer(that, size);
      }
      if (fill !== void 0) {
        return typeof encoding === "string" ? createBuffer(that, size).fill(fill, encoding) : createBuffer(that, size).fill(fill);
      }
      return createBuffer(that, size);
    }
    Buffer$1.alloc = function(size, fill, encoding) {
      return alloc(null, size, fill, encoding);
    };
    function allocUnsafe(that, size) {
      assertSize(size);
      that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
      if (!Buffer$1.TYPED_ARRAY_SUPPORT) {
        for (var i2 = 0; i2 < size; ++i2) {
          that[i2] = 0;
        }
      }
      return that;
    }
    Buffer$1.allocUnsafe = function(size) {
      return allocUnsafe(null, size);
    };
    Buffer$1.allocUnsafeSlow = function(size) {
      return allocUnsafe(null, size);
    };
    function fromString(that, string3, encoding) {
      if (typeof encoding !== "string" || encoding === "") {
        encoding = "utf8";
      }
      if (!Buffer$1.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding');
      }
      var length = byteLength$1(string3, encoding) | 0;
      that = createBuffer(that, length);
      var actual = that.write(string3, encoding);
      if (actual !== length) {
        that = that.slice(0, actual);
      }
      return that;
    }
    function fromArrayLike(that, array4) {
      var length = array4.length < 0 ? 0 : checked(array4.length) | 0;
      that = createBuffer(that, length);
      for (var i2 = 0; i2 < length; i2 += 1) {
        that[i2] = array4[i2] & 255;
      }
      return that;
    }
    function fromArrayBuffer(that, array4, byteOffset, length) {
      array4.byteLength;
      if (byteOffset < 0 || array4.byteLength < byteOffset) {
        throw new RangeError("'offset' is out of bounds");
      }
      if (array4.byteLength < byteOffset + (length || 0)) {
        throw new RangeError("'length' is out of bounds");
      }
      if (byteOffset === void 0 && length === void 0) {
        array4 = new Uint8Array(array4);
      } else if (length === void 0) {
        array4 = new Uint8Array(array4, byteOffset);
      } else {
        array4 = new Uint8Array(array4, byteOffset, length);
      }
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        that = array4;
        that.__proto__ = Buffer$1.prototype;
      } else {
        that = fromArrayLike(that, array4);
      }
      return that;
    }
    function fromObject(that, obj) {
      if (internalIsBuffer(obj)) {
        var len3 = checked(obj.length) | 0;
        that = createBuffer(that, len3);
        if (that.length === 0) {
          return that;
        }
        obj.copy(that, 0, 0, len3);
        return that;
      }
      if (obj) {
        if (typeof ArrayBuffer !== "undefined" && obj.buffer instanceof ArrayBuffer || "length" in obj) {
          if (typeof obj.length !== "number" || isnan(obj.length)) {
            return createBuffer(that, 0);
          }
          return fromArrayLike(that, obj);
        }
        if (obj.type === "Buffer" && isArray$12(obj.data)) {
          return fromArrayLike(that, obj.data);
        }
      }
      throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.");
    }
    function checked(length) {
      if (length >= kMaxLength()) {
        throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + kMaxLength().toString(16) + " bytes");
      }
      return length | 0;
    }
    Buffer$1.isBuffer = isBuffer$12;
    function internalIsBuffer(b2) {
      return !!(b2 != null && b2._isBuffer);
    }
    Buffer$1.compare = function compare3(a, b2) {
      if (!internalIsBuffer(a) || !internalIsBuffer(b2)) {
        throw new TypeError("Arguments must be Buffers");
      }
      if (a === b2)
        return 0;
      var x2 = a.length;
      var y2 = b2.length;
      for (var i2 = 0, len3 = Math.min(x2, y2); i2 < len3; ++i2) {
        if (a[i2] !== b2[i2]) {
          x2 = a[i2];
          y2 = b2[i2];
          break;
        }
      }
      if (x2 < y2)
        return -1;
      if (y2 < x2)
        return 1;
      return 0;
    };
    Buffer$1.isEncoding = function isEncoding(encoding) {
      switch (String(encoding).toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "latin1":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
          return true;
        default:
          return false;
      }
    };
    Buffer$1.concat = function concat(list2, length) {
      if (!isArray$12(list2)) {
        throw new TypeError('"list" argument must be an Array of Buffers');
      }
      if (list2.length === 0) {
        return Buffer$1.alloc(0);
      }
      var i2;
      if (length === void 0) {
        length = 0;
        for (i2 = 0; i2 < list2.length; ++i2) {
          length += list2[i2].length;
        }
      }
      var buffer2 = Buffer$1.allocUnsafe(length);
      var pos = 0;
      for (i2 = 0; i2 < list2.length; ++i2) {
        var buf = list2[i2];
        if (!internalIsBuffer(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers');
        }
        buf.copy(buffer2, pos);
        pos += buf.length;
      }
      return buffer2;
    };
    function byteLength$1(string3, encoding) {
      if (internalIsBuffer(string3)) {
        return string3.length;
      }
      if (typeof ArrayBuffer !== "undefined" && typeof ArrayBuffer.isView === "function" && (ArrayBuffer.isView(string3) || string3 instanceof ArrayBuffer)) {
        return string3.byteLength;
      }
      if (typeof string3 !== "string") {
        string3 = "" + string3;
      }
      var len3 = string3.length;
      if (len3 === 0)
        return 0;
      var loweredCase = false;
      for (; ; ) {
        switch (encoding) {
          case "ascii":
          case "latin1":
          case "binary":
            return len3;
          case "utf8":
          case "utf-8":
          case void 0:
            return utf8ToBytes(string3).length;
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return len3 * 2;
          case "hex":
            return len3 >>> 1;
          case "base64":
            return base64ToBytes(string3).length;
          default:
            if (loweredCase)
              return utf8ToBytes(string3).length;
            encoding = ("" + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    }
    Buffer$1.byteLength = byteLength$1;
    function slowToString(encoding, start2, end2) {
      var loweredCase = false;
      if (start2 === void 0 || start2 < 0) {
        start2 = 0;
      }
      if (start2 > this.length) {
        return "";
      }
      if (end2 === void 0 || end2 > this.length) {
        end2 = this.length;
      }
      if (end2 <= 0) {
        return "";
      }
      end2 >>>= 0;
      start2 >>>= 0;
      if (end2 <= start2) {
        return "";
      }
      if (!encoding)
        encoding = "utf8";
      while (true) {
        switch (encoding) {
          case "hex":
            return hexSlice(this, start2, end2);
          case "utf8":
          case "utf-8":
            return utf8Slice(this, start2, end2);
          case "ascii":
            return asciiSlice(this, start2, end2);
          case "latin1":
          case "binary":
            return latin1Slice(this, start2, end2);
          case "base64":
            return base64Slice(this, start2, end2);
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return utf16leSlice(this, start2, end2);
          default:
            if (loweredCase)
              throw new TypeError("Unknown encoding: " + encoding);
            encoding = (encoding + "").toLowerCase();
            loweredCase = true;
        }
      }
    }
    Buffer$1.prototype._isBuffer = true;
    function swap2(b2, n2, m2) {
      var i2 = b2[n2];
      b2[n2] = b2[m2];
      b2[m2] = i2;
    }
    Buffer$1.prototype.swap16 = function swap16() {
      var len3 = this.length;
      if (len3 % 2 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 16-bits");
      }
      for (var i2 = 0; i2 < len3; i2 += 2) {
        swap2(this, i2, i2 + 1);
      }
      return this;
    };
    Buffer$1.prototype.swap32 = function swap32() {
      var len3 = this.length;
      if (len3 % 4 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 32-bits");
      }
      for (var i2 = 0; i2 < len3; i2 += 4) {
        swap2(this, i2, i2 + 3);
        swap2(this, i2 + 1, i2 + 2);
      }
      return this;
    };
    Buffer$1.prototype.swap64 = function swap64() {
      var len3 = this.length;
      if (len3 % 8 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 64-bits");
      }
      for (var i2 = 0; i2 < len3; i2 += 8) {
        swap2(this, i2, i2 + 7);
        swap2(this, i2 + 1, i2 + 6);
        swap2(this, i2 + 2, i2 + 5);
        swap2(this, i2 + 3, i2 + 4);
      }
      return this;
    };
    Buffer$1.prototype.toString = function toString3() {
      var length = this.length | 0;
      if (length === 0)
        return "";
      if (arguments.length === 0)
        return utf8Slice(this, 0, length);
      return slowToString.apply(this, arguments);
    };
    Buffer$1.prototype.equals = function equals2(b2) {
      if (!internalIsBuffer(b2))
        throw new TypeError("Argument must be a Buffer");
      if (this === b2)
        return true;
      return Buffer$1.compare(this, b2) === 0;
    };
    Buffer$1.prototype.inspect = function inspect2() {
      var str = "";
      var max3 = INSPECT_MAX_BYTES;
      if (this.length > 0) {
        str = this.toString("hex", 0, max3).match(/.{2}/g).join(" ");
        if (this.length > max3)
          str += " ... ";
      }
      return "<Buffer " + str + ">";
    };
    Buffer$1.prototype.compare = function compare3(target, start2, end2, thisStart, thisEnd) {
      if (!internalIsBuffer(target)) {
        throw new TypeError("Argument must be a Buffer");
      }
      if (start2 === void 0) {
        start2 = 0;
      }
      if (end2 === void 0) {
        end2 = target ? target.length : 0;
      }
      if (thisStart === void 0) {
        thisStart = 0;
      }
      if (thisEnd === void 0) {
        thisEnd = this.length;
      }
      if (start2 < 0 || end2 > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError("out of range index");
      }
      if (thisStart >= thisEnd && start2 >= end2) {
        return 0;
      }
      if (thisStart >= thisEnd) {
        return -1;
      }
      if (start2 >= end2) {
        return 1;
      }
      start2 >>>= 0;
      end2 >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;
      if (this === target)
        return 0;
      var x2 = thisEnd - thisStart;
      var y2 = end2 - start2;
      var len3 = Math.min(x2, y2);
      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start2, end2);
      for (var i2 = 0; i2 < len3; ++i2) {
        if (thisCopy[i2] !== targetCopy[i2]) {
          x2 = thisCopy[i2];
          y2 = targetCopy[i2];
          break;
        }
      }
      if (x2 < y2)
        return -1;
      if (y2 < x2)
        return 1;
      return 0;
    };
    function bidirectionalIndexOf(buffer2, val, byteOffset, encoding, dir3) {
      if (buffer2.length === 0)
        return -1;
      if (typeof byteOffset === "string") {
        encoding = byteOffset;
        byteOffset = 0;
      } else if (byteOffset > 2147483647) {
        byteOffset = 2147483647;
      } else if (byteOffset < -2147483648) {
        byteOffset = -2147483648;
      }
      byteOffset = +byteOffset;
      if (isNaN(byteOffset)) {
        byteOffset = dir3 ? 0 : buffer2.length - 1;
      }
      if (byteOffset < 0)
        byteOffset = buffer2.length + byteOffset;
      if (byteOffset >= buffer2.length) {
        if (dir3)
          return -1;
        else
          byteOffset = buffer2.length - 1;
      } else if (byteOffset < 0) {
        if (dir3)
          byteOffset = 0;
        else
          return -1;
      }
      if (typeof val === "string") {
        val = Buffer$1.from(val, encoding);
      }
      if (internalIsBuffer(val)) {
        if (val.length === 0) {
          return -1;
        }
        return arrayIndexOf(buffer2, val, byteOffset, encoding, dir3);
      } else if (typeof val === "number") {
        val = val & 255;
        if (Buffer$1.TYPED_ARRAY_SUPPORT && typeof Uint8Array.prototype.indexOf === "function") {
          if (dir3) {
            return Uint8Array.prototype.indexOf.call(buffer2, val, byteOffset);
          } else {
            return Uint8Array.prototype.lastIndexOf.call(buffer2, val, byteOffset);
          }
        }
        return arrayIndexOf(buffer2, [val], byteOffset, encoding, dir3);
      }
      throw new TypeError("val must be string, number or Buffer");
    }
    function arrayIndexOf(arr, val, byteOffset, encoding, dir3) {
      var indexSize = 1;
      var arrLength = arr.length;
      var valLength = val.length;
      if (encoding !== void 0) {
        encoding = String(encoding).toLowerCase();
        if (encoding === "ucs2" || encoding === "ucs-2" || encoding === "utf16le" || encoding === "utf-16le") {
          if (arr.length < 2 || val.length < 2) {
            return -1;
          }
          indexSize = 2;
          arrLength /= 2;
          valLength /= 2;
          byteOffset /= 2;
        }
      }
      function read2(buf, i3) {
        if (indexSize === 1) {
          return buf[i3];
        } else {
          return buf.readUInt16BE(i3 * indexSize);
        }
      }
      var i2;
      if (dir3) {
        var foundIndex = -1;
        for (i2 = byteOffset; i2 < arrLength; i2++) {
          if (read2(arr, i2) === read2(val, foundIndex === -1 ? 0 : i2 - foundIndex)) {
            if (foundIndex === -1)
              foundIndex = i2;
            if (i2 - foundIndex + 1 === valLength)
              return foundIndex * indexSize;
          } else {
            if (foundIndex !== -1)
              i2 -= i2 - foundIndex;
            foundIndex = -1;
          }
        }
      } else {
        if (byteOffset + valLength > arrLength)
          byteOffset = arrLength - valLength;
        for (i2 = byteOffset; i2 >= 0; i2--) {
          var found = true;
          for (var j = 0; j < valLength; j++) {
            if (read2(arr, i2 + j) !== read2(val, j)) {
              found = false;
              break;
            }
          }
          if (found)
            return i2;
        }
      }
      return -1;
    }
    Buffer$1.prototype.includes = function includes(val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1;
    };
    Buffer$1.prototype.indexOf = function indexOf2(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
    };
    Buffer$1.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
    };
    function hexWrite(buf, string3, offset3, length) {
      offset3 = Number(offset3) || 0;
      var remaining = buf.length - offset3;
      if (!length) {
        length = remaining;
      } else {
        length = Number(length);
        if (length > remaining) {
          length = remaining;
        }
      }
      var strLen = string3.length;
      if (strLen % 2 !== 0)
        throw new TypeError("Invalid hex string");
      if (length > strLen / 2) {
        length = strLen / 2;
      }
      for (var i2 = 0; i2 < length; ++i2) {
        var parsed = parseInt(string3.substr(i2 * 2, 2), 16);
        if (isNaN(parsed))
          return i2;
        buf[offset3 + i2] = parsed;
      }
      return i2;
    }
    function utf8Write(buf, string3, offset3, length) {
      return blitBuffer(utf8ToBytes(string3, buf.length - offset3), buf, offset3, length);
    }
    function asciiWrite(buf, string3, offset3, length) {
      return blitBuffer(asciiToBytes(string3), buf, offset3, length);
    }
    function latin1Write(buf, string3, offset3, length) {
      return asciiWrite(buf, string3, offset3, length);
    }
    function base64Write(buf, string3, offset3, length) {
      return blitBuffer(base64ToBytes(string3), buf, offset3, length);
    }
    function ucs2Write(buf, string3, offset3, length) {
      return blitBuffer(utf16leToBytes(string3, buf.length - offset3), buf, offset3, length);
    }
    Buffer$1.prototype.write = function write2(string3, offset3, length, encoding) {
      if (offset3 === void 0) {
        encoding = "utf8";
        length = this.length;
        offset3 = 0;
      } else if (length === void 0 && typeof offset3 === "string") {
        encoding = offset3;
        length = this.length;
        offset3 = 0;
      } else if (isFinite(offset3)) {
        offset3 = offset3 | 0;
        if (isFinite(length)) {
          length = length | 0;
          if (encoding === void 0)
            encoding = "utf8";
        } else {
          encoding = length;
          length = void 0;
        }
      } else {
        throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");
      }
      var remaining = this.length - offset3;
      if (length === void 0 || length > remaining)
        length = remaining;
      if (string3.length > 0 && (length < 0 || offset3 < 0) || offset3 > this.length) {
        throw new RangeError("Attempt to write outside buffer bounds");
      }
      if (!encoding)
        encoding = "utf8";
      var loweredCase = false;
      for (; ; ) {
        switch (encoding) {
          case "hex":
            return hexWrite(this, string3, offset3, length);
          case "utf8":
          case "utf-8":
            return utf8Write(this, string3, offset3, length);
          case "ascii":
            return asciiWrite(this, string3, offset3, length);
          case "latin1":
          case "binary":
            return latin1Write(this, string3, offset3, length);
          case "base64":
            return base64Write(this, string3, offset3, length);
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return ucs2Write(this, string3, offset3, length);
          default:
            if (loweredCase)
              throw new TypeError("Unknown encoding: " + encoding);
            encoding = ("" + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };
    Buffer$1.prototype.toJSON = function toJSON() {
      return {
        type: "Buffer",
        data: Array.prototype.slice.call(this._arr || this, 0)
      };
    };
    function base64Slice(buf, start2, end2) {
      if (start2 === 0 && end2 === buf.length) {
        return fromByteArray$1(buf);
      } else {
        return fromByteArray$1(buf.slice(start2, end2));
      }
    }
    function utf8Slice(buf, start2, end2) {
      end2 = Math.min(buf.length, end2);
      var res2 = [];
      var i2 = start2;
      while (i2 < end2) {
        var firstByte = buf[i2];
        var codePoint = null;
        var bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
        if (i2 + bytesPerSequence <= end2) {
          var secondByte, thirdByte, fourthByte, tempCodePoint;
          switch (bytesPerSequence) {
            case 1:
              if (firstByte < 128) {
                codePoint = firstByte;
              }
              break;
            case 2:
              secondByte = buf[i2 + 1];
              if ((secondByte & 192) === 128) {
                tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
                if (tempCodePoint > 127) {
                  codePoint = tempCodePoint;
                }
              }
              break;
            case 3:
              secondByte = buf[i2 + 1];
              thirdByte = buf[i2 + 2];
              if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
                tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
                if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
                  codePoint = tempCodePoint;
                }
              }
              break;
            case 4:
              secondByte = buf[i2 + 1];
              thirdByte = buf[i2 + 2];
              fourthByte = buf[i2 + 3];
              if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
                tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
                if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
                  codePoint = tempCodePoint;
                }
              }
          }
        }
        if (codePoint === null) {
          codePoint = 65533;
          bytesPerSequence = 1;
        } else if (codePoint > 65535) {
          codePoint -= 65536;
          res2.push(codePoint >>> 10 & 1023 | 55296);
          codePoint = 56320 | codePoint & 1023;
        }
        res2.push(codePoint);
        i2 += bytesPerSequence;
      }
      return decodeCodePointsArray(res2);
    }
    var MAX_ARGUMENTS_LENGTH = 4096;
    function decodeCodePointsArray(codePoints) {
      var len3 = codePoints.length;
      if (len3 <= MAX_ARGUMENTS_LENGTH) {
        return String.fromCharCode.apply(String, codePoints);
      }
      var res2 = "";
      var i2 = 0;
      while (i2 < len3) {
        res2 += String.fromCharCode.apply(String, codePoints.slice(i2, i2 += MAX_ARGUMENTS_LENGTH));
      }
      return res2;
    }
    function asciiSlice(buf, start2, end2) {
      var ret = "";
      end2 = Math.min(buf.length, end2);
      for (var i2 = start2; i2 < end2; ++i2) {
        ret += String.fromCharCode(buf[i2] & 127);
      }
      return ret;
    }
    function latin1Slice(buf, start2, end2) {
      var ret = "";
      end2 = Math.min(buf.length, end2);
      for (var i2 = start2; i2 < end2; ++i2) {
        ret += String.fromCharCode(buf[i2]);
      }
      return ret;
    }
    function hexSlice(buf, start2, end2) {
      var len3 = buf.length;
      if (!start2 || start2 < 0)
        start2 = 0;
      if (!end2 || end2 < 0 || end2 > len3)
        end2 = len3;
      var out2 = "";
      for (var i2 = start2; i2 < end2; ++i2) {
        out2 += toHex2(buf[i2]);
      }
      return out2;
    }
    function utf16leSlice(buf, start2, end2) {
      var bytes = buf.slice(start2, end2);
      var res2 = "";
      for (var i2 = 0; i2 < bytes.length; i2 += 2) {
        res2 += String.fromCharCode(bytes[i2] + bytes[i2 + 1] * 256);
      }
      return res2;
    }
    Buffer$1.prototype.slice = function slice2(start2, end2) {
      var len3 = this.length;
      start2 = ~~start2;
      end2 = end2 === void 0 ? len3 : ~~end2;
      if (start2 < 0) {
        start2 += len3;
        if (start2 < 0)
          start2 = 0;
      } else if (start2 > len3) {
        start2 = len3;
      }
      if (end2 < 0) {
        end2 += len3;
        if (end2 < 0)
          end2 = 0;
      } else if (end2 > len3) {
        end2 = len3;
      }
      if (end2 < start2)
        end2 = start2;
      var newBuf;
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start2, end2);
        newBuf.__proto__ = Buffer$1.prototype;
      } else {
        var sliceLen = end2 - start2;
        newBuf = new Buffer$1(sliceLen, void 0);
        for (var i2 = 0; i2 < sliceLen; ++i2) {
          newBuf[i2] = this[i2 + start2];
        }
      }
      return newBuf;
    };
    function checkOffset(offset3, ext, length) {
      if (offset3 % 1 !== 0 || offset3 < 0)
        throw new RangeError("offset is not uint");
      if (offset3 + ext > length)
        throw new RangeError("Trying to access beyond buffer length");
    }
    Buffer$1.prototype.readUIntLE = function readUIntLE(offset3, byteLength2, noAssert) {
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert)
        checkOffset(offset3, byteLength2, this.length);
      var val = this[offset3];
      var mul2 = 1;
      var i2 = 0;
      while (++i2 < byteLength2 && (mul2 *= 256)) {
        val += this[offset3 + i2] * mul2;
      }
      return val;
    };
    Buffer$1.prototype.readUIntBE = function readUIntBE(offset3, byteLength2, noAssert) {
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        checkOffset(offset3, byteLength2, this.length);
      }
      var val = this[offset3 + --byteLength2];
      var mul2 = 1;
      while (byteLength2 > 0 && (mul2 *= 256)) {
        val += this[offset3 + --byteLength2] * mul2;
      }
      return val;
    };
    Buffer$1.prototype.readUInt8 = function readUInt8(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 1, this.length);
      return this[offset3];
    };
    Buffer$1.prototype.readUInt16LE = function readUInt16LE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 2, this.length);
      return this[offset3] | this[offset3 + 1] << 8;
    };
    Buffer$1.prototype.readUInt16BE = function readUInt16BE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 2, this.length);
      return this[offset3] << 8 | this[offset3 + 1];
    };
    Buffer$1.prototype.readUInt32LE = function readUInt32LE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return (this[offset3] | this[offset3 + 1] << 8 | this[offset3 + 2] << 16) + this[offset3 + 3] * 16777216;
    };
    Buffer$1.prototype.readUInt32BE = function readUInt32BE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return this[offset3] * 16777216 + (this[offset3 + 1] << 16 | this[offset3 + 2] << 8 | this[offset3 + 3]);
    };
    Buffer$1.prototype.readIntLE = function readIntLE(offset3, byteLength2, noAssert) {
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert)
        checkOffset(offset3, byteLength2, this.length);
      var val = this[offset3];
      var mul2 = 1;
      var i2 = 0;
      while (++i2 < byteLength2 && (mul2 *= 256)) {
        val += this[offset3 + i2] * mul2;
      }
      mul2 *= 128;
      if (val >= mul2)
        val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer$1.prototype.readIntBE = function readIntBE(offset3, byteLength2, noAssert) {
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert)
        checkOffset(offset3, byteLength2, this.length);
      var i2 = byteLength2;
      var mul2 = 1;
      var val = this[offset3 + --i2];
      while (i2 > 0 && (mul2 *= 256)) {
        val += this[offset3 + --i2] * mul2;
      }
      mul2 *= 128;
      if (val >= mul2)
        val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer$1.prototype.readInt8 = function readInt8(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 1, this.length);
      if (!(this[offset3] & 128))
        return this[offset3];
      return (255 - this[offset3] + 1) * -1;
    };
    Buffer$1.prototype.readInt16LE = function readInt16LE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 2, this.length);
      var val = this[offset3] | this[offset3 + 1] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer$1.prototype.readInt16BE = function readInt16BE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 2, this.length);
      var val = this[offset3 + 1] | this[offset3] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer$1.prototype.readInt32LE = function readInt32LE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return this[offset3] | this[offset3 + 1] << 8 | this[offset3 + 2] << 16 | this[offset3 + 3] << 24;
    };
    Buffer$1.prototype.readInt32BE = function readInt32BE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return this[offset3] << 24 | this[offset3 + 1] << 16 | this[offset3 + 2] << 8 | this[offset3 + 3];
    };
    Buffer$1.prototype.readFloatLE = function readFloatLE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return read(this, offset3, true, 23, 4);
    };
    Buffer$1.prototype.readFloatBE = function readFloatBE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 4, this.length);
      return read(this, offset3, false, 23, 4);
    };
    Buffer$1.prototype.readDoubleLE = function readDoubleLE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 8, this.length);
      return read(this, offset3, true, 52, 8);
    };
    Buffer$1.prototype.readDoubleBE = function readDoubleBE(offset3, noAssert) {
      if (!noAssert)
        checkOffset(offset3, 8, this.length);
      return read(this, offset3, false, 52, 8);
    };
    function checkInt(buf, value, offset3, ext, max3, min4) {
      if (!internalIsBuffer(buf))
        throw new TypeError('"buffer" argument must be a Buffer instance');
      if (value > max3 || value < min4)
        throw new RangeError('"value" argument is out of bounds');
      if (offset3 + ext > buf.length)
        throw new RangeError("Index out of range");
    }
    Buffer$1.prototype.writeUIntLE = function writeUIntLE(value, offset3, byteLength2, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset3, byteLength2, maxBytes, 0);
      }
      var mul2 = 1;
      var i2 = 0;
      this[offset3] = value & 255;
      while (++i2 < byteLength2 && (mul2 *= 256)) {
        this[offset3 + i2] = value / mul2 & 255;
      }
      return offset3 + byteLength2;
    };
    Buffer$1.prototype.writeUIntBE = function writeUIntBE(value, offset3, byteLength2, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset3, byteLength2, maxBytes, 0);
      }
      var i2 = byteLength2 - 1;
      var mul2 = 1;
      this[offset3 + i2] = value & 255;
      while (--i2 >= 0 && (mul2 *= 256)) {
        this[offset3 + i2] = value / mul2 & 255;
      }
      return offset3 + byteLength2;
    };
    Buffer$1.prototype.writeUInt8 = function writeUInt8(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 1, 255, 0);
      if (!Buffer$1.TYPED_ARRAY_SUPPORT)
        value = Math.floor(value);
      this[offset3] = value & 255;
      return offset3 + 1;
    };
    function objectWriteUInt16(buf, value, offset3, littleEndian) {
      if (value < 0)
        value = 65535 + value + 1;
      for (var i2 = 0, j = Math.min(buf.length - offset3, 2); i2 < j; ++i2) {
        buf[offset3 + i2] = (value & 255 << 8 * (littleEndian ? i2 : 1 - i2)) >>> (littleEndian ? i2 : 1 - i2) * 8;
      }
    }
    Buffer$1.prototype.writeUInt16LE = function writeUInt16LE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 2, 65535, 0);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset3, true);
      }
      return offset3 + 2;
    };
    Buffer$1.prototype.writeUInt16BE = function writeUInt16BE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 2, 65535, 0);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value >>> 8;
        this[offset3 + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset3, false);
      }
      return offset3 + 2;
    };
    function objectWriteUInt32(buf, value, offset3, littleEndian) {
      if (value < 0)
        value = 4294967295 + value + 1;
      for (var i2 = 0, j = Math.min(buf.length - offset3, 4); i2 < j; ++i2) {
        buf[offset3 + i2] = value >>> (littleEndian ? i2 : 3 - i2) * 8 & 255;
      }
    }
    Buffer$1.prototype.writeUInt32LE = function writeUInt32LE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 4, 4294967295, 0);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3 + 3] = value >>> 24;
        this[offset3 + 2] = value >>> 16;
        this[offset3 + 1] = value >>> 8;
        this[offset3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset3, true);
      }
      return offset3 + 4;
    };
    Buffer$1.prototype.writeUInt32BE = function writeUInt32BE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 4, 4294967295, 0);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value >>> 24;
        this[offset3 + 1] = value >>> 16;
        this[offset3 + 2] = value >>> 8;
        this[offset3 + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset3, false);
      }
      return offset3 + 4;
    };
    Buffer$1.prototype.writeIntLE = function writeIntLE(value, offset3, byteLength2, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset3, byteLength2, limit - 1, -limit);
      }
      var i2 = 0;
      var mul2 = 1;
      var sub2 = 0;
      this[offset3] = value & 255;
      while (++i2 < byteLength2 && (mul2 *= 256)) {
        if (value < 0 && sub2 === 0 && this[offset3 + i2 - 1] !== 0) {
          sub2 = 1;
        }
        this[offset3 + i2] = (value / mul2 >> 0) - sub2 & 255;
      }
      return offset3 + byteLength2;
    };
    Buffer$1.prototype.writeIntBE = function writeIntBE(value, offset3, byteLength2, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset3, byteLength2, limit - 1, -limit);
      }
      var i2 = byteLength2 - 1;
      var mul2 = 1;
      var sub2 = 0;
      this[offset3 + i2] = value & 255;
      while (--i2 >= 0 && (mul2 *= 256)) {
        if (value < 0 && sub2 === 0 && this[offset3 + i2 + 1] !== 0) {
          sub2 = 1;
        }
        this[offset3 + i2] = (value / mul2 >> 0) - sub2 & 255;
      }
      return offset3 + byteLength2;
    };
    Buffer$1.prototype.writeInt8 = function writeInt8(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 1, 127, -128);
      if (!Buffer$1.TYPED_ARRAY_SUPPORT)
        value = Math.floor(value);
      if (value < 0)
        value = 255 + value + 1;
      this[offset3] = value & 255;
      return offset3 + 1;
    };
    Buffer$1.prototype.writeInt16LE = function writeInt16LE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 2, 32767, -32768);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset3, true);
      }
      return offset3 + 2;
    };
    Buffer$1.prototype.writeInt16BE = function writeInt16BE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 2, 32767, -32768);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value >>> 8;
        this[offset3 + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset3, false);
      }
      return offset3 + 2;
    };
    Buffer$1.prototype.writeInt32LE = function writeInt32LE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 4, 2147483647, -2147483648);
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
        this[offset3 + 2] = value >>> 16;
        this[offset3 + 3] = value >>> 24;
      } else {
        objectWriteUInt32(this, value, offset3, true);
      }
      return offset3 + 4;
    };
    Buffer$1.prototype.writeInt32BE = function writeInt32BE(value, offset3, noAssert) {
      value = +value;
      offset3 = offset3 | 0;
      if (!noAssert)
        checkInt(this, value, offset3, 4, 2147483647, -2147483648);
      if (value < 0)
        value = 4294967295 + value + 1;
      if (Buffer$1.TYPED_ARRAY_SUPPORT) {
        this[offset3] = value >>> 24;
        this[offset3 + 1] = value >>> 16;
        this[offset3 + 2] = value >>> 8;
        this[offset3 + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset3, false);
      }
      return offset3 + 4;
    };
    function checkIEEE754(buf, value, offset3, ext, max3, min4) {
      if (offset3 + ext > buf.length)
        throw new RangeError("Index out of range");
      if (offset3 < 0)
        throw new RangeError("Index out of range");
    }
    function writeFloat(buf, value, offset3, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset3, 4);
      }
      write(buf, value, offset3, littleEndian, 23, 4);
      return offset3 + 4;
    }
    Buffer$1.prototype.writeFloatLE = function writeFloatLE(value, offset3, noAssert) {
      return writeFloat(this, value, offset3, true, noAssert);
    };
    Buffer$1.prototype.writeFloatBE = function writeFloatBE(value, offset3, noAssert) {
      return writeFloat(this, value, offset3, false, noAssert);
    };
    function writeDouble(buf, value, offset3, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset3, 8);
      }
      write(buf, value, offset3, littleEndian, 52, 8);
      return offset3 + 8;
    }
    Buffer$1.prototype.writeDoubleLE = function writeDoubleLE(value, offset3, noAssert) {
      return writeDouble(this, value, offset3, true, noAssert);
    };
    Buffer$1.prototype.writeDoubleBE = function writeDoubleBE(value, offset3, noAssert) {
      return writeDouble(this, value, offset3, false, noAssert);
    };
    Buffer$1.prototype.copy = function copy2(target, targetStart, start2, end2) {
      if (!start2)
        start2 = 0;
      if (!end2 && end2 !== 0)
        end2 = this.length;
      if (targetStart >= target.length)
        targetStart = target.length;
      if (!targetStart)
        targetStart = 0;
      if (end2 > 0 && end2 < start2)
        end2 = start2;
      if (end2 === start2)
        return 0;
      if (target.length === 0 || this.length === 0)
        return 0;
      if (targetStart < 0) {
        throw new RangeError("targetStart out of bounds");
      }
      if (start2 < 0 || start2 >= this.length)
        throw new RangeError("sourceStart out of bounds");
      if (end2 < 0)
        throw new RangeError("sourceEnd out of bounds");
      if (end2 > this.length)
        end2 = this.length;
      if (target.length - targetStart < end2 - start2) {
        end2 = target.length - targetStart + start2;
      }
      var len3 = end2 - start2;
      var i2;
      if (this === target && start2 < targetStart && targetStart < end2) {
        for (i2 = len3 - 1; i2 >= 0; --i2) {
          target[i2 + targetStart] = this[i2 + start2];
        }
      } else if (len3 < 1e3 || !Buffer$1.TYPED_ARRAY_SUPPORT) {
        for (i2 = 0; i2 < len3; ++i2) {
          target[i2 + targetStart] = this[i2 + start2];
        }
      } else {
        Uint8Array.prototype.set.call(target, this.subarray(start2, start2 + len3), targetStart);
      }
      return len3;
    };
    Buffer$1.prototype.fill = function fill(val, start2, end2, encoding) {
      if (typeof val === "string") {
        if (typeof start2 === "string") {
          encoding = start2;
          start2 = 0;
          end2 = this.length;
        } else if (typeof end2 === "string") {
          encoding = end2;
          end2 = this.length;
        }
        if (val.length === 1) {
          var code3 = val.charCodeAt(0);
          if (code3 < 256) {
            val = code3;
          }
        }
        if (encoding !== void 0 && typeof encoding !== "string") {
          throw new TypeError("encoding must be a string");
        }
        if (typeof encoding === "string" && !Buffer$1.isEncoding(encoding)) {
          throw new TypeError("Unknown encoding: " + encoding);
        }
      } else if (typeof val === "number") {
        val = val & 255;
      }
      if (start2 < 0 || this.length < start2 || this.length < end2) {
        throw new RangeError("Out of range index");
      }
      if (end2 <= start2) {
        return this;
      }
      start2 = start2 >>> 0;
      end2 = end2 === void 0 ? this.length : end2 >>> 0;
      if (!val)
        val = 0;
      var i2;
      if (typeof val === "number") {
        for (i2 = start2; i2 < end2; ++i2) {
          this[i2] = val;
        }
      } else {
        var bytes = internalIsBuffer(val) ? val : utf8ToBytes(new Buffer$1(val, encoding).toString());
        var len3 = bytes.length;
        for (i2 = 0; i2 < end2 - start2; ++i2) {
          this[i2 + start2] = bytes[i2 % len3];
        }
      }
      return this;
    };
    var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;
    function base64clean(str) {
      str = stringtrim(str).replace(INVALID_BASE64_RE, "");
      if (str.length < 2)
        return "";
      while (str.length % 4 !== 0) {
        str = str + "=";
      }
      return str;
    }
    function stringtrim(str) {
      if (str.trim)
        return str.trim();
      return str.replace(/^\s+|\s+$/g, "");
    }
    function toHex2(n2) {
      if (n2 < 16)
        return "0" + n2.toString(16);
      return n2.toString(16);
    }
    function utf8ToBytes(string3, units) {
      units = units || Infinity;
      var codePoint;
      var length = string3.length;
      var leadSurrogate = null;
      var bytes = [];
      for (var i2 = 0; i2 < length; ++i2) {
        codePoint = string3.charCodeAt(i2);
        if (codePoint > 55295 && codePoint < 57344) {
          if (!leadSurrogate) {
            if (codePoint > 56319) {
              if ((units -= 3) > -1)
                bytes.push(239, 191, 189);
              continue;
            } else if (i2 + 1 === length) {
              if ((units -= 3) > -1)
                bytes.push(239, 191, 189);
              continue;
            }
            leadSurrogate = codePoint;
            continue;
          }
          if (codePoint < 56320) {
            if ((units -= 3) > -1)
              bytes.push(239, 191, 189);
            leadSurrogate = codePoint;
            continue;
          }
          codePoint = (leadSurrogate - 55296 << 10 | codePoint - 56320) + 65536;
        } else if (leadSurrogate) {
          if ((units -= 3) > -1)
            bytes.push(239, 191, 189);
        }
        leadSurrogate = null;
        if (codePoint < 128) {
          if ((units -= 1) < 0)
            break;
          bytes.push(codePoint);
        } else if (codePoint < 2048) {
          if ((units -= 2) < 0)
            break;
          bytes.push(codePoint >> 6 | 192, codePoint & 63 | 128);
        } else if (codePoint < 65536) {
          if ((units -= 3) < 0)
            break;
          bytes.push(codePoint >> 12 | 224, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
        } else if (codePoint < 1114112) {
          if ((units -= 4) < 0)
            break;
          bytes.push(codePoint >> 18 | 240, codePoint >> 12 & 63 | 128, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
        } else {
          throw new Error("Invalid code point");
        }
      }
      return bytes;
    }
    function asciiToBytes(str) {
      var byteArray = [];
      for (var i2 = 0; i2 < str.length; ++i2) {
        byteArray.push(str.charCodeAt(i2) & 255);
      }
      return byteArray;
    }
    function utf16leToBytes(str, units) {
      var c2, hi2, lo;
      var byteArray = [];
      for (var i2 = 0; i2 < str.length; ++i2) {
        if ((units -= 2) < 0)
          break;
        c2 = str.charCodeAt(i2);
        hi2 = c2 >> 8;
        lo = c2 % 256;
        byteArray.push(lo);
        byteArray.push(hi2);
      }
      return byteArray;
    }
    function base64ToBytes(str) {
      return toByteArray$1(base64clean(str));
    }
    function blitBuffer(src2, dst, offset3, length) {
      for (var i2 = 0; i2 < length; ++i2) {
        if (i2 + offset3 >= dst.length || i2 >= src2.length)
          break;
        dst[i2 + offset3] = src2[i2];
      }
      return i2;
    }
    function isnan(val) {
      return val !== val;
    }
    function isBuffer$12(obj) {
      return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj));
    }
    function isFastBuffer(obj) {
      return !!obj.constructor && typeof obj.constructor.isBuffer === "function" && obj.constructor.isBuffer(obj);
    }
    function isSlowBuffer(obj) {
      return typeof obj.readFloatLE === "function" && typeof obj.slice === "function" && isFastBuffer(obj.slice(0, 0));
    }
    var sourcemapCodec_umd = { exports: {} };
    var hasRequiredSourcemapCodec_umd;
    function requireSourcemapCodec_umd() {
      if (hasRequiredSourcemapCodec_umd)
        return sourcemapCodec_umd.exports;
      hasRequiredSourcemapCodec_umd = 1;
      (function(module2, exports3) {
        (function(global2, factory) {
          factory(exports3);
        })(commonjsGlobal$1, function(exports4) {
          var comma = 44;
          var semicolon = 59;
          var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
          var intToChar = new Uint8Array(65);
          var charToInteger = new Uint8Array(123);
          for (var i2 = 0; i2 < chars.length; i2++) {
            var c2 = chars.charCodeAt(i2);
            charToInteger[c2] = i2;
            intToChar[i2] = c2;
          }
          var td2 = typeof TextDecoder !== "undefined" ? new TextDecoder() : typeof Buffer$1 !== "undefined" ? {
            decode: function decode3(buf) {
              var out2 = Buffer$1.from(buf.buffer, buf.byteOffset, buf.byteLength);
              return out2.toString();
            }
          } : {
            decode: function decode3(buf) {
              var out2 = "";
              for (var _i3 = 0; _i3 < buf.length; _i3++) {
                out2 += String.fromCharCode(buf[_i3]);
              }
              return out2;
            }
          };
          function decode2(mappings2) {
            var state = new Int32Array(5);
            var decoded = [];
            var line = [];
            var sorted = true;
            var lastCol = 0;
            for (var _i22 = 0; _i22 < mappings2.length; ) {
              var _c2 = mappings2.charCodeAt(_i22);
              if (_c2 === comma) {
                _i22++;
              } else if (_c2 === semicolon) {
                state[0] = lastCol = 0;
                if (!sorted)
                  sort2(line);
                sorted = true;
                decoded.push(line);
                line = [];
                _i22++;
              } else {
                _i22 = decodeInteger(mappings2, _i22, state, 0);
                var col = state[0];
                if (col < lastCol)
                  sorted = false;
                lastCol = col;
                if (!hasMoreSegments(mappings2, _i22)) {
                  line.push([col]);
                  continue;
                }
                _i22 = decodeInteger(mappings2, _i22, state, 1);
                _i22 = decodeInteger(mappings2, _i22, state, 2);
                _i22 = decodeInteger(mappings2, _i22, state, 3);
                if (!hasMoreSegments(mappings2, _i22)) {
                  line.push([col, state[1], state[2], state[3]]);
                  continue;
                }
                _i22 = decodeInteger(mappings2, _i22, state, 4);
                line.push([col, state[1], state[2], state[3], state[4]]);
              }
            }
            if (!sorted)
              sort2(line);
            decoded.push(line);
            return decoded;
          }
          function decodeInteger(mappings2, pos, state, j) {
            var value = 0;
            var shift = 0;
            var integer4 = 0;
            do {
              var _c2 = mappings2.charCodeAt(pos++);
              integer4 = charToInteger[_c2];
              value |= (integer4 & 31) << shift;
              shift += 5;
            } while (integer4 & 32);
            var shouldNegate = value & 1;
            value >>>= 1;
            if (shouldNegate) {
              value = value === 0 ? -2147483648 : -value;
            }
            state[j] += value;
            return pos;
          }
          function hasMoreSegments(mappings2, i3) {
            if (i3 >= mappings2.length)
              return false;
            var c3 = mappings2.charCodeAt(i3);
            if (c3 === comma || c3 === semicolon)
              return false;
            return true;
          }
          function sort2(line) {
            line.sort(sortComparator);
          }
          function sortComparator(a, b2) {
            return a[0] - b2[0];
          }
          function encode(decoded) {
            var state = new Int32Array(5);
            var buf = new Uint8Array(1e3);
            var pos = 0;
            for (var _i3 = 0; _i3 < decoded.length; _i3++) {
              var line = decoded[_i3];
              if (_i3 > 0) {
                buf = reserve(buf, pos, 1);
                buf[pos++] = semicolon;
              }
              if (line.length === 0)
                continue;
              state[0] = 0;
              for (var j = 0; j < line.length; j++) {
                var segment = line[j];
                buf = reserve(buf, pos, 36);
                if (j > 0)
                  buf[pos++] = comma;
                pos = encodeInteger(buf, pos, state, segment, 0);
                if (segment.length === 1)
                  continue;
                pos = encodeInteger(buf, pos, state, segment, 1);
                pos = encodeInteger(buf, pos, state, segment, 2);
                pos = encodeInteger(buf, pos, state, segment, 3);
                if (segment.length === 4)
                  continue;
                pos = encodeInteger(buf, pos, state, segment, 4);
              }
            }
            return td2.decode(buf.subarray(0, pos));
          }
          function reserve(buf, pos, count2) {
            if (buf.length > pos + count2)
              return buf;
            var swap3 = new Uint8Array(buf.length * 2);
            swap3.set(buf);
            return swap3;
          }
          function encodeInteger(buf, pos, state, segment, j) {
            var next = segment[j];
            var num = next - state[j];
            state[j] = next;
            num = num < 0 ? -num << 1 | 1 : num << 1;
            do {
              var clamped = num & 31;
              num >>>= 5;
              if (num > 0)
                clamped |= 32;
              buf[pos++] = intToChar[clamped];
            } while (num > 0);
            return pos;
          }
          exports4.decode = decode2;
          exports4.encode = encode;
          Object.defineProperty(exports4, "__esModule", {
            value: true
          });
        });
      })(sourcemapCodec_umd, sourcemapCodec_umd.exports);
      return sourcemapCodec_umd.exports;
    }
    (function(module2, exports3) {
      (function(global2, factory) {
        factory(exports3, requireSetArray_umd(), requireSourcemapCodec_umd());
      })(commonjsGlobal$1, function(exports4, setArray, sourcemapCodec) {
        exports4.addSegment = void 0;
        exports4.addMapping = void 0;
        exports4.setSourceContent = void 0;
        exports4.decodedMap = void 0;
        exports4.encodedMap = void 0;
        exports4.allMappings = void 0;
        var GenMapping = _createClass2(function GenMapping2(_temp) {
          var _ref3 = _temp === void 0 ? {} : _temp, file2 = _ref3.file, sourceRoot = _ref3.sourceRoot;
          this._names = new setArray.SetArray();
          this._sources = new setArray.SetArray();
          this._sourcesContent = [];
          this._mappings = [];
          this.file = file2;
          this.sourceRoot = sourceRoot;
        });
        (function() {
          exports4.addSegment = function(map2, genLine, genColumn, source, sourceLine, sourceColumn, name2) {
            var mappings2 = map2._mappings, sources = map2._sources, sourcesContent = map2._sourcesContent, names2 = map2._names;
            var line = getLine(mappings2, genLine);
            if (source == null) {
              var _seg = [genColumn];
              var _index = getColumnIndex(line, genColumn, _seg);
              return insert(line, _index, _seg);
            }
            var sourcesIndex = setArray.put(sources, source);
            var seg = name2 ? [genColumn, sourcesIndex, sourceLine, sourceColumn, setArray.put(names2, name2)] : [genColumn, sourcesIndex, sourceLine, sourceColumn];
            var index3 = getColumnIndex(line, genColumn, seg);
            if (sourcesIndex === sourcesContent.length)
              sourcesContent[sourcesIndex] = null;
            insert(line, index3, seg);
          };
          exports4.addMapping = function(map2, mapping) {
            var generated2 = mapping.generated, source = mapping.source, original = mapping.original, name2 = mapping.name;
            return exports4.addSegment(map2, generated2.line - 1, generated2.column, source, original == null ? void 0 : original.line - 1, original === null || original === void 0 ? void 0 : original.column, name2);
          };
          exports4.setSourceContent = function(map2, source, content) {
            var sources = map2._sources, sourcesContent = map2._sourcesContent;
            sourcesContent[setArray.put(sources, source)] = content;
          };
          exports4.decodedMap = function(map2) {
            var file2 = map2.file, sourceRoot = map2.sourceRoot, mappings2 = map2._mappings, sources = map2._sources, sourcesContent = map2._sourcesContent, names2 = map2._names;
            return {
              version: 3,
              file: file2,
              names: names2.array,
              sourceRoot: sourceRoot || void 0,
              sources: sources.array,
              sourcesContent,
              mappings: mappings2
            };
          };
          exports4.encodedMap = function(map2) {
            var decoded = exports4.decodedMap(map2);
            return Object.assign(Object.assign({}, decoded), {
              mappings: sourcemapCodec.encode(decoded.mappings)
            });
          };
          exports4.allMappings = function(map2) {
            var out2 = [];
            var mappings2 = map2._mappings, sources = map2._sources, names2 = map2._names;
            for (var i2 = 0; i2 < mappings2.length; i2++) {
              var line = mappings2[i2];
              for (var j = 0; j < line.length; j++) {
                var seg = line[j];
                var generated2 = {
                  line: i2 + 1,
                  column: seg[0]
                };
                var source = void 0;
                var original = void 0;
                var name2 = void 0;
                if (seg.length !== 1) {
                  source = sources.array[seg[1]];
                  original = {
                    line: seg[2] + 1,
                    column: seg[3]
                  };
                  if (seg.length === 5)
                    name2 = names2.array[seg[4]];
                }
                out2.push({
                  generated: generated2,
                  source,
                  original,
                  name: name2
                });
              }
            }
            return out2;
          };
        })();
        function getLine(mappings2, index3) {
          for (var i2 = mappings2.length; i2 <= index3; i2++) {
            mappings2[i2] = [];
          }
          return mappings2[index3];
        }
        function getColumnIndex(line, column, seg) {
          var index3 = line.length;
          for (var i2 = index3 - 1; i2 >= 0; i2--, index3--) {
            var current2 = line[i2];
            var col = current2[0];
            if (col > column)
              continue;
            if (col < column)
              break;
            var cmp2 = compare3(current2, seg);
            if (cmp2 === 0)
              return index3;
            if (cmp2 < 0)
              break;
          }
          return index3;
        }
        function compare3(a, b2) {
          var cmp2 = compareNum(a.length, b2.length);
          if (cmp2 !== 0)
            return cmp2;
          if (a.length === 1)
            return 0;
          cmp2 = compareNum(a[1], b2[1]);
          if (cmp2 !== 0)
            return cmp2;
          cmp2 = compareNum(a[2], b2[2]);
          if (cmp2 !== 0)
            return cmp2;
          cmp2 = compareNum(a[3], b2[3]);
          if (cmp2 !== 0)
            return cmp2;
          if (a.length === 4)
            return 0;
          return compareNum(a[4], b2[4]);
        }
        function compareNum(a, b2) {
          return a - b2;
        }
        function insert(array4, index3, value) {
          if (index3 === -1)
            return;
          for (var i2 = array4.length; i2 > index3; i2--) {
            array4[i2] = array4[i2 - 1];
          }
          array4[index3] = value;
        }
        exports4.GenMapping = GenMapping;
        Object.defineProperty(exports4, "__esModule", {
          value: true
        });
      });
    })(genMapping_umd, genMapping_umd.exports);
    var SourceMap$1 = function() {
      function SourceMap2(opts, code3) {
        var _opts$sourceFileName;
        this._map = void 0;
        this._rawMappings = void 0;
        this._sourceFileName = void 0;
        this._lastGenLine = 0;
        this._lastSourceLine = 0;
        this._lastSourceColumn = 0;
        var map2 = this._map = new genMapping_umd.exports.GenMapping({
          sourceRoot: opts.sourceRoot
        });
        this._sourceFileName = (_opts$sourceFileName = opts.sourceFileName) == null ? void 0 : _opts$sourceFileName.replace(/\\/g, "/");
        this._rawMappings = void 0;
        if (typeof code3 === "string") {
          genMapping_umd.exports.setSourceContent(map2, this._sourceFileName, code3);
        } else if (typeof code3 === "object") {
          Object.keys(code3).forEach(function(sourceFileName) {
            genMapping_umd.exports.setSourceContent(map2, sourceFileName.replace(/\\/g, "/"), code3[sourceFileName]);
          });
        }
      }
      var _proto = SourceMap2.prototype;
      _proto.get = function get3() {
        return genMapping_umd.exports.encodedMap(this._map);
      };
      _proto.getDecoded = function getDecoded() {
        return genMapping_umd.exports.decodedMap(this._map);
      };
      _proto.getRawMappings = function getRawMappings() {
        return this._rawMappings || (this._rawMappings = genMapping_umd.exports.allMappings(this._map));
      };
      _proto.mark = function mark(generated2, line, column, identifierName, filename, force) {
        var generatedLine = generated2.line;
        if (this._lastGenLine !== generatedLine && line == null)
          return;
        if (!force && this._lastGenLine === generatedLine && this._lastSourceLine === line && this._lastSourceColumn === column) {
          return;
        }
        this._rawMappings = void 0;
        this._lastGenLine = generatedLine;
        this._lastSourceLine = line;
        this._lastSourceColumn = column;
        genMapping_umd.exports.addMapping(this._map, {
          name: identifierName,
          generated: generated2,
          source: line == null ? void 0 : (filename == null ? void 0 : filename.replace(/\\/g, "/")) || this._sourceFileName,
          original: line == null ? void 0 : {
            line,
            column
          }
        });
      };
      return _createClass2(SourceMap2);
    }();
    function SourcePos() {
      return {
        identifierName: void 0,
        line: void 0,
        column: void 0,
        filename: void 0,
        force: false
      };
    }
    var SPACES_RE = /^[ \t]+$/;
    var Buffer2 = function() {
      function Buffer3(map2) {
        this._map = null;
        this._buf = "";
        this._last = 0;
        this._queue = [];
        this._position = {
          line: 1,
          column: 0
        };
        this._sourcePosition = SourcePos();
        this._disallowedPop = null;
        this._map = map2;
      }
      var _proto = Buffer3.prototype;
      _proto.get = function get3() {
        this._flush();
        var map2 = this._map;
        var result = {
          code: this._buf.trimRight(),
          decodedMap: map2 == null ? void 0 : map2.getDecoded(),
          get map() {
            return result.map = map2 ? map2.get() : null;
          },
          set map(value) {
            Object.defineProperty(result, "map", {
              value,
              writable: true
            });
          },
          get rawMappings() {
            return result.rawMappings = map2 == null ? void 0 : map2.getRawMappings();
          },
          set rawMappings(value) {
            Object.defineProperty(result, "rawMappings", {
              value,
              writable: true
            });
          }
        };
        return result;
      };
      _proto.append = function append(str) {
        this._flush();
        var _this$_sourcePosition = this._sourcePosition, line = _this$_sourcePosition.line, column = _this$_sourcePosition.column, filename = _this$_sourcePosition.filename, identifierName = _this$_sourcePosition.identifierName, force = _this$_sourcePosition.force;
        this._append(str, line, column, identifierName, filename, force);
      };
      _proto.queue = function queue2(str) {
        if (str === "\n") {
          while (this._queue.length > 0 && SPACES_RE.test(this._queue[0][0])) {
            this._queue.shift();
          }
        }
        var _this$_sourcePosition2 = this._sourcePosition, line = _this$_sourcePosition2.line, column = _this$_sourcePosition2.column, filename = _this$_sourcePosition2.filename, identifierName = _this$_sourcePosition2.identifierName, force = _this$_sourcePosition2.force;
        this._queue.unshift([str, line, column, identifierName, filename, force]);
      };
      _proto.queueIndentation = function queueIndentation(str) {
        this._queue.unshift([str, void 0, void 0, void 0, void 0, false]);
      };
      _proto._flush = function _flush() {
        var item;
        while (item = this._queue.pop()) {
          this._append.apply(this, _toConsumableArray2(item));
        }
      };
      _proto._append = function _append(str, line, column, identifierName, filename, force) {
        this._buf += str;
        this._last = str.charCodeAt(str.length - 1);
        var i2 = str.indexOf("\n");
        var last2 = 0;
        if (i2 !== 0) {
          this._mark(line, column, identifierName, filename, force);
        }
        while (i2 !== -1) {
          this._position.line++;
          this._position.column = 0;
          last2 = i2 + 1;
          if (last2 < str.length) {
            this._mark(++line, 0, identifierName, filename, force);
          }
          i2 = str.indexOf("\n", last2);
        }
        this._position.column += str.length - last2;
      };
      _proto._mark = function _mark(line, column, identifierName, filename, force) {
        var _this$_map;
        (_this$_map = this._map) == null ? void 0 : _this$_map.mark(this._position, line, column, identifierName, filename, force);
      };
      _proto.removeTrailingNewline = function removeTrailingNewline() {
        if (this._queue.length > 0 && this._queue[0][0] === "\n") {
          this._queue.shift();
        }
      };
      _proto.removeLastSemicolon = function removeLastSemicolon() {
        if (this._queue.length > 0 && this._queue[0][0] === ";") {
          this._queue.shift();
        }
      };
      _proto.getLastChar = function getLastChar() {
        var last2;
        if (this._queue.length > 0) {
          var str = this._queue[0][0];
          last2 = str.charCodeAt(0);
        } else {
          last2 = this._last;
        }
        return last2;
      };
      _proto.endsWithCharAndNewline = function endsWithCharAndNewline() {
        var queue2 = this._queue;
        if (queue2.length > 0) {
          var last2 = queue2[0][0];
          var lastCp = last2.charCodeAt(0);
          if (lastCp !== 10)
            return;
          if (queue2.length > 1) {
            var secondLast = queue2[1][0];
            return secondLast.charCodeAt(0);
          } else {
            return this._last;
          }
        }
      };
      _proto.hasContent = function hasContent() {
        return this._queue.length > 0 || !!this._last;
      };
      _proto.exactSource = function exactSource(loc, cb2) {
        this.source("start", loc, true);
        cb2();
        this.source("end", loc);
        this._disallowPop("start", loc);
      };
      _proto.source = function source(prop2, loc, force) {
        if (prop2 && !loc)
          return;
        this._normalizePosition(prop2, loc, this._sourcePosition, force);
      };
      _proto.withSource = function withSource(prop2, loc, cb2) {
        if (!this._map)
          return cb2();
        var originalLine = this._sourcePosition.line;
        var originalColumn = this._sourcePosition.column;
        var originalFilename = this._sourcePosition.filename;
        var originalIdentifierName = this._sourcePosition.identifierName;
        this.source(prop2, loc);
        cb2();
        if ((!this._sourcePosition.force || this._sourcePosition.line !== originalLine || this._sourcePosition.column !== originalColumn || this._sourcePosition.filename !== originalFilename) && (!this._disallowedPop || this._disallowedPop.line !== originalLine || this._disallowedPop.column !== originalColumn || this._disallowedPop.filename !== originalFilename)) {
          this._sourcePosition.line = originalLine;
          this._sourcePosition.column = originalColumn;
          this._sourcePosition.filename = originalFilename;
          this._sourcePosition.identifierName = originalIdentifierName;
          this._sourcePosition.force = false;
          this._disallowedPop = null;
        }
      };
      _proto._disallowPop = function _disallowPop(prop2, loc) {
        if (prop2 && !loc)
          return;
        this._disallowedPop = this._normalizePosition(prop2, loc, SourcePos(), false);
      };
      _proto._normalizePosition = function _normalizePosition(prop2, loc, targetObj, force) {
        var pos = loc ? loc[prop2] : null;
        var origLine = targetObj.line;
        var origColumn = targetObj.column;
        var origFilename = targetObj.filename;
        targetObj.identifierName = prop2 === "start" && (loc == null ? void 0 : loc.identifierName) || null;
        targetObj.line = pos == null ? void 0 : pos.line;
        targetObj.column = pos == null ? void 0 : pos.column;
        targetObj.filename = loc == null ? void 0 : loc.filename;
        if (force || targetObj.line !== origLine || targetObj.column !== origColumn || targetObj.filename !== origFilename) {
          targetObj.force = force;
        }
        return targetObj;
      };
      _proto.getCurrentColumn = function getCurrentColumn() {
        var extra = this._queue.reduce(function(acc, item) {
          return item[0] + acc;
        }, "");
        var lastIndex = extra.lastIndexOf("\n");
        return lastIndex === -1 ? this._position.column + extra.length : extra.length - 1 - lastIndex;
      };
      _proto.getCurrentLine = function getCurrentLine() {
        var extra = this._queue.reduce(function(acc, item) {
          return item[0] + acc;
        }, "");
        var count2 = 0;
        for (var i2 = 0; i2 < extra.length; i2++) {
          if (extra[i2] === "\n")
            count2++;
        }
        return this._position.line + count2;
      };
      return _createClass2(Buffer3);
    }();
    var FLIPPED_ALIAS_KEYS$1 = FLIPPED_ALIAS_KEYS$3, isArrayExpression = isArrayExpression$2, isAssignmentExpression$3 = isAssignmentExpression$4, isBinary$1 = isBinary$3, isBlockStatement$1 = isBlockStatement$2, isCallExpression$6 = isCallExpression$7, isFunction$22 = isFunction$32, isIdentifier$f = isIdentifier$i, isLiteral$5 = isLiteral$7, isMemberExpression$6 = isMemberExpression$8, isObjectExpression$1 = isObjectExpression$3, isOptionalCallExpression$2 = isOptionalCallExpression$3, isOptionalMemberExpression$2 = isOptionalMemberExpression$3, isStringLiteral$6 = isStringLiteral$7;
    function crawl(node2, state) {
      if (state === void 0) {
        state = {};
      }
      if (isMemberExpression$6(node2) || isOptionalMemberExpression$2(node2)) {
        crawl(node2.object, state);
        if (node2.computed)
          crawl(node2.property, state);
      } else if (isBinary$1(node2) || isAssignmentExpression$3(node2)) {
        crawl(node2.left, state);
        crawl(node2.right, state);
      } else if (isCallExpression$6(node2) || isOptionalCallExpression$2(node2)) {
        state.hasCall = true;
        crawl(node2.callee, state);
      } else if (isFunction$22(node2)) {
        state.hasFunction = true;
      } else if (isIdentifier$f(node2)) {
        state.hasHelper = state.hasHelper || isHelper(node2.callee);
      }
      return state;
    }
    function isHelper(node2) {
      if (isMemberExpression$6(node2)) {
        return isHelper(node2.object) || isHelper(node2.property);
      } else if (isIdentifier$f(node2)) {
        return node2.name === "require" || node2.name[0] === "_";
      } else if (isCallExpression$6(node2)) {
        return isHelper(node2.callee);
      } else if (isBinary$1(node2) || isAssignmentExpression$3(node2)) {
        return isIdentifier$f(node2.left) && isHelper(node2.left) || isHelper(node2.right);
      } else {
        return false;
      }
    }
    function isType$1(node2) {
      return isLiteral$5(node2) || isObjectExpression$1(node2) || isArrayExpression(node2) || isIdentifier$f(node2) || isMemberExpression$6(node2);
    }
    var nodes = {
      AssignmentExpression: function(_AssignmentExpression) {
        function AssignmentExpression2(_x) {
          return _AssignmentExpression.apply(this, arguments);
        }
        AssignmentExpression2.toString = function() {
          return _AssignmentExpression.toString();
        };
        return AssignmentExpression2;
      }(function(node2) {
        var state = crawl(node2.right);
        if (state.hasCall && state.hasHelper || state.hasFunction) {
          return {
            before: state.hasFunction,
            after: true
          };
        }
      }),
      SwitchCase: function(_SwitchCase) {
        function SwitchCase2(_x2, _x3) {
          return _SwitchCase.apply(this, arguments);
        }
        SwitchCase2.toString = function() {
          return _SwitchCase.toString();
        };
        return SwitchCase2;
      }(function(node2, parent) {
        return {
          before: !!node2.consequent.length || parent.cases[0] === node2,
          after: !node2.consequent.length && parent.cases[parent.cases.length - 1] === node2
        };
      }),
      LogicalExpression: function(_LogicalExpression) {
        function LogicalExpression2(_x4) {
          return _LogicalExpression.apply(this, arguments);
        }
        LogicalExpression2.toString = function() {
          return _LogicalExpression.toString();
        };
        return LogicalExpression2;
      }(function(node2) {
        if (isFunction$22(node2.left) || isFunction$22(node2.right)) {
          return {
            after: true
          };
        }
      }),
      Literal: function(_Literal) {
        function Literal(_x5) {
          return _Literal.apply(this, arguments);
        }
        Literal.toString = function() {
          return _Literal.toString();
        };
        return Literal;
      }(function(node2) {
        if (isStringLiteral$6(node2) && node2.value === "use strict") {
          return {
            after: true
          };
        }
      }),
      CallExpression: function(_CallExpression) {
        function CallExpression2(_x6) {
          return _CallExpression.apply(this, arguments);
        }
        CallExpression2.toString = function() {
          return _CallExpression.toString();
        };
        return CallExpression2;
      }(function(node2) {
        if (isFunction$22(node2.callee) || isHelper(node2)) {
          return {
            before: true,
            after: true
          };
        }
      }),
      OptionalCallExpression: function(_OptionalCallExpression) {
        function OptionalCallExpression2(_x7) {
          return _OptionalCallExpression.apply(this, arguments);
        }
        OptionalCallExpression2.toString = function() {
          return _OptionalCallExpression.toString();
        };
        return OptionalCallExpression2;
      }(function(node2) {
        if (isFunction$22(node2.callee)) {
          return {
            before: true,
            after: true
          };
        }
      }),
      VariableDeclaration: function(_VariableDeclaration) {
        function VariableDeclaration2(_x8) {
          return _VariableDeclaration.apply(this, arguments);
        }
        VariableDeclaration2.toString = function() {
          return _VariableDeclaration.toString();
        };
        return VariableDeclaration2;
      }(function(node2) {
        for (var i2 = 0; i2 < node2.declarations.length; i2++) {
          var declar = node2.declarations[i2];
          var enabled = isHelper(declar.id) && !isType$1(declar.init);
          if (!enabled) {
            var state = crawl(declar.init);
            enabled = isHelper(declar.init) && state.hasCall || state.hasFunction;
          }
          if (enabled) {
            return {
              before: true,
              after: true
            };
          }
        }
      }),
      IfStatement: function(_IfStatement) {
        function IfStatement2(_x9) {
          return _IfStatement.apply(this, arguments);
        }
        IfStatement2.toString = function() {
          return _IfStatement.toString();
        };
        return IfStatement2;
      }(function(node2) {
        if (isBlockStatement$1(node2.consequent)) {
          return {
            before: true,
            after: true
          };
        }
      })
    };
    nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function(node2, parent) {
      if (parent.properties[0] === node2) {
        return {
          before: true
        };
      }
    };
    nodes.ObjectTypeCallProperty = function(node2, parent) {
      var _parent$properties;
      if (parent.callProperties[0] === node2 && !((_parent$properties = parent.properties) != null && _parent$properties.length)) {
        return {
          before: true
        };
      }
    };
    nodes.ObjectTypeIndexer = function(node2, parent) {
      var _parent$properties2, _parent$callPropertie;
      if (parent.indexers[0] === node2 && !((_parent$properties2 = parent.properties) != null && _parent$properties2.length) && !((_parent$callPropertie = parent.callProperties) != null && _parent$callPropertie.length)) {
        return {
          before: true
        };
      }
    };
    nodes.ObjectTypeInternalSlot = function(node2, parent) {
      var _parent$properties3, _parent$callPropertie2, _parent$indexers;
      if (parent.internalSlots[0] === node2 && !((_parent$properties3 = parent.properties) != null && _parent$properties3.length) && !((_parent$callPropertie2 = parent.callProperties) != null && _parent$callPropertie2.length) && !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)) {
        return {
          before: true
        };
      }
    };
    var list$1 = {
      VariableDeclaration: function(_VariableDeclaration2) {
        function VariableDeclaration2(_x10) {
          return _VariableDeclaration2.apply(this, arguments);
        }
        VariableDeclaration2.toString = function() {
          return _VariableDeclaration2.toString();
        };
        return VariableDeclaration2;
      }(function(node2) {
        return node2.declarations.map(function(decl) {
          return decl.init;
        });
      }),
      ArrayExpression: function(_ArrayExpression) {
        function ArrayExpression2(_x11) {
          return _ArrayExpression.apply(this, arguments);
        }
        ArrayExpression2.toString = function() {
          return _ArrayExpression.toString();
        };
        return ArrayExpression2;
      }(function(node2) {
        return node2.elements;
      }),
      ObjectExpression: function(_ObjectExpression) {
        function ObjectExpression2(_x12) {
          return _ObjectExpression.apply(this, arguments);
        }
        ObjectExpression2.toString = function() {
          return _ObjectExpression.toString();
        };
        return ObjectExpression2;
      }(function(node2) {
        return node2.properties;
      })
    };
    [["Function", true], ["Class", true], ["Loop", true], ["LabeledStatement", true], ["SwitchStatement", true], ["TryStatement", true]].forEach(function(_ref3) {
      var _ref22 = _slicedToArray$12(_ref3, 2), type5 = _ref22[0], amounts = _ref22[1];
      if (typeof amounts === "boolean") {
        amounts = {
          after: amounts,
          before: amounts
        };
      }
      [type5].concat(FLIPPED_ALIAS_KEYS$1[type5] || []).forEach(function(type6) {
        nodes[type6] = function() {
          return amounts;
        };
      });
    });
    var isArrayTypeAnnotation = isArrayTypeAnnotation$1, isArrowFunctionExpression = isArrowFunctionExpression$1, isAssignmentExpression$2 = isAssignmentExpression$4, isAwaitExpression = isAwaitExpression$1, isBinary = isBinary$3, isBinaryExpression = isBinaryExpression$1, isCallExpression$5 = isCallExpression$7, isClassDeclaration$1 = isClassDeclaration$3, isClassExpression = isClassExpression$1, isConditional = isConditional$1, isConditionalExpression = isConditionalExpression$1, isExportDeclaration = isExportDeclaration$2, isExportDefaultDeclaration$1 = isExportDefaultDeclaration$3, isExpressionStatement$3 = isExpressionStatement$4, isFor$1 = isFor$2, isForInStatement = isForInStatement$1, isForOfStatement = isForOfStatement$1, isForStatement$1 = isForStatement$3, isIfStatement$1 = isIfStatement$2, isIndexedAccessType = isIndexedAccessType$1, isIntersectionTypeAnnotation = isIntersectionTypeAnnotation$1, isLogicalExpression = isLogicalExpression$1, isMemberExpression$5 = isMemberExpression$8, isNewExpression$3 = isNewExpression$4, isNullableTypeAnnotation = isNullableTypeAnnotation$1, isObjectPattern$1 = isObjectPattern$2, isOptionalCallExpression$1 = isOptionalCallExpression$3, isOptionalMemberExpression$1 = isOptionalMemberExpression$3, isReturnStatement = isReturnStatement$1, isSequenceExpression$1 = isSequenceExpression$2, isSwitchStatement = isSwitchStatement$1, isTSArrayType = isTSArrayType$1, isTSAsExpression$1 = isTSAsExpression$2, isTSIntersectionType = isTSIntersectionType$1, isTSNonNullExpression$1 = isTSNonNullExpression$2, isTSOptionalType = isTSOptionalType$1, isTSRestType = isTSRestType$1, isTSTypeAssertion$1 = isTSTypeAssertion$2, isTSUnionType = isTSUnionType$1, isTaggedTemplateExpression = isTaggedTemplateExpression$2, isThrowStatement = isThrowStatement$1, isTypeAnnotation$1 = isTypeAnnotation$2, isUnaryLike = isUnaryLike$1, isUnionTypeAnnotation$1 = isUnionTypeAnnotation$2, isVariableDeclarator$1 = isVariableDeclarator$2, isWhileStatement = isWhileStatement$1, isYieldExpression = isYieldExpression$1;
    var PRECEDENCE = {
      "||": 0,
      "??": 0,
      "&&": 1,
      "|": 2,
      "^": 3,
      "&": 4,
      "==": 5,
      "===": 5,
      "!=": 5,
      "!==": 5,
      "<": 6,
      ">": 6,
      "<=": 6,
      ">=": 6,
      "in": 6,
      "instanceof": 6,
      ">>": 7,
      "<<": 7,
      ">>>": 7,
      "+": 8,
      "-": 8,
      "*": 9,
      "/": 9,
      "%": 9,
      "**": 10
    };
    var isClassExtendsClause = function isClassExtendsClause2(node2, parent) {
      return (isClassDeclaration$1(parent) || isClassExpression(parent)) && parent.superClass === node2;
    };
    var hasPostfixPart = function hasPostfixPart2(node2, parent) {
      return (isMemberExpression$5(parent) || isOptionalMemberExpression$1(parent)) && parent.object === node2 || (isCallExpression$5(parent) || isOptionalCallExpression$1(parent) || isNewExpression$3(parent)) && parent.callee === node2 || isTaggedTemplateExpression(parent) && parent.tag === node2 || isTSNonNullExpression$1(parent);
    };
    function NullableTypeAnnotation$1(node2, parent) {
      return isArrayTypeAnnotation(parent);
    }
    function FunctionTypeAnnotation$1(node2, parent, printStack) {
      return isUnionTypeAnnotation$1(parent) || isIntersectionTypeAnnotation(parent) || isArrayTypeAnnotation(parent) || isTypeAnnotation$1(parent) && isArrowFunctionExpression(printStack[printStack.length - 3]);
    }
    function UpdateExpression$2(node2, parent) {
      return hasPostfixPart(node2, parent) || isClassExtendsClause(node2, parent);
    }
    function ObjectExpression$2(node2, parent, printStack) {
      return isFirstInContext(printStack, {
        expressionStatement: true,
        arrowBody: true
      });
    }
    function DoExpression$1(node2, parent, printStack) {
      return !node2.async && isFirstInContext(printStack, {
        expressionStatement: true
      });
    }
    function Binary(node2, parent) {
      if (node2.operator === "**" && isBinaryExpression(parent, {
        operator: "**"
      })) {
        return parent.left === node2;
      }
      if (isClassExtendsClause(node2, parent)) {
        return true;
      }
      if (hasPostfixPart(node2, parent) || isUnaryLike(parent) || isAwaitExpression(parent)) {
        return true;
      }
      if (isBinary(parent)) {
        var parentOp = parent.operator;
        var parentPos = PRECEDENCE[parentOp];
        var nodeOp = node2.operator;
        var nodePos = PRECEDENCE[nodeOp];
        if (parentPos === nodePos && parent.right === node2 && !isLogicalExpression(parent) || parentPos > nodePos) {
          return true;
        }
      }
    }
    function UnionTypeAnnotation$1(node2, parent) {
      return isArrayTypeAnnotation(parent) || isNullableTypeAnnotation(parent) || isIntersectionTypeAnnotation(parent) || isUnionTypeAnnotation$1(parent);
    }
    function OptionalIndexedAccessType$1(node2, parent) {
      return isIndexedAccessType(parent, {
        objectType: node2
      });
    }
    function TSAsExpression$1() {
      return true;
    }
    function TSTypeAssertion$1() {
      return true;
    }
    function TSUnionType$1(node2, parent) {
      return isTSArrayType(parent) || isTSOptionalType(parent) || isTSIntersectionType(parent) || isTSUnionType(parent) || isTSRestType(parent);
    }
    function TSInferType$1(node2, parent) {
      return isTSArrayType(parent) || isTSOptionalType(parent);
    }
    function BinaryExpression$1(node2, parent) {
      return node2.operator === "in" && (isVariableDeclarator$1(parent) || isFor$1(parent));
    }
    function SequenceExpression$2(node2, parent) {
      if (isForStatement$1(parent) || isThrowStatement(parent) || isReturnStatement(parent) || isIfStatement$1(parent) && parent.test === node2 || isWhileStatement(parent) && parent.test === node2 || isForInStatement(parent) && parent.right === node2 || isSwitchStatement(parent) && parent.discriminant === node2 || isExpressionStatement$3(parent) && parent.expression === node2) {
        return false;
      }
      return true;
    }
    function YieldExpression$1(node2, parent) {
      return isBinary(parent) || isUnaryLike(parent) || hasPostfixPart(node2, parent) || isAwaitExpression(parent) && isYieldExpression(node2) || isConditionalExpression(parent) && node2 === parent.test || isClassExtendsClause(node2, parent);
    }
    function ClassExpression(node2, parent, printStack) {
      return isFirstInContext(printStack, {
        expressionStatement: true,
        exportDefault: true
      });
    }
    function UnaryLike(node2, parent) {
      return hasPostfixPart(node2, parent) || isBinaryExpression(parent, {
        operator: "**",
        left: node2
      }) || isClassExtendsClause(node2, parent);
    }
    function FunctionExpression$1(node2, parent, printStack) {
      return isFirstInContext(printStack, {
        expressionStatement: true,
        exportDefault: true
      });
    }
    function ArrowFunctionExpression$1(node2, parent) {
      return isExportDeclaration(parent) || ConditionalExpression$2(node2, parent);
    }
    function ConditionalExpression$2(node2, parent) {
      if (isUnaryLike(parent) || isBinary(parent) || isConditionalExpression(parent, {
        test: node2
      }) || isAwaitExpression(parent) || isTSTypeAssertion$1(parent) || isTSAsExpression$1(parent)) {
        return true;
      }
      return UnaryLike(node2, parent);
    }
    function OptionalMemberExpression$1(node2, parent) {
      return isCallExpression$5(parent, {
        callee: node2
      }) || isMemberExpression$5(parent, {
        object: node2
      });
    }
    function AssignmentExpression$2(node2, parent) {
      if (isObjectPattern$1(node2.left)) {
        return true;
      } else {
        return ConditionalExpression$2(node2, parent);
      }
    }
    function LogicalExpression$1(node2, parent) {
      switch (node2.operator) {
        case "||":
          if (!isLogicalExpression(parent))
            return false;
          return parent.operator === "??" || parent.operator === "&&";
        case "&&":
          return isLogicalExpression(parent, {
            operator: "??"
          });
        case "??":
          return isLogicalExpression(parent) && parent.operator !== "??";
      }
    }
    function Identifier$1(node2, parent, printStack) {
      if (node2.name === "let") {
        var isFollowedByBracket = isMemberExpression$5(parent, {
          object: node2,
          computed: true
        }) || isOptionalMemberExpression$1(parent, {
          object: node2,
          computed: true,
          optional: false
        });
        return isFirstInContext(printStack, {
          expressionStatement: isFollowedByBracket,
          forHead: isFollowedByBracket,
          forInHead: isFollowedByBracket,
          forOfHead: true
        });
      }
      return node2.name === "async" && isForOfStatement(parent) && node2 === parent.left;
    }
    function isFirstInContext(printStack, _ref3) {
      var _ref$expressionStatem = _ref3.expressionStatement, expressionStatement2 = _ref$expressionStatem === void 0 ? false : _ref$expressionStatem, _ref$arrowBody = _ref3.arrowBody, arrowBody = _ref$arrowBody === void 0 ? false : _ref$arrowBody, _ref$exportDefault = _ref3.exportDefault, exportDefault = _ref$exportDefault === void 0 ? false : _ref$exportDefault, _ref$forHead = _ref3.forHead, forHead = _ref$forHead === void 0 ? false : _ref$forHead, _ref$forInHead = _ref3.forInHead, forInHead = _ref$forInHead === void 0 ? false : _ref$forInHead, _ref$forOfHead = _ref3.forOfHead, forOfHead = _ref$forOfHead === void 0 ? false : _ref$forOfHead;
      var i2 = printStack.length - 1;
      var node2 = printStack[i2];
      i2--;
      var parent = printStack[i2];
      while (i2 >= 0) {
        if (expressionStatement2 && isExpressionStatement$3(parent, {
          expression: node2
        }) || exportDefault && isExportDefaultDeclaration$1(parent, {
          declaration: node2
        }) || arrowBody && isArrowFunctionExpression(parent, {
          body: node2
        }) || forHead && isForStatement$1(parent, {
          init: node2
        }) || forInHead && isForInStatement(parent, {
          left: node2
        }) || forOfHead && isForOfStatement(parent, {
          left: node2
        })) {
          return true;
        }
        if (hasPostfixPart(node2, parent) && !isNewExpression$3(parent) || isSequenceExpression$1(parent) && parent.expressions[0] === node2 || isConditional(parent, {
          test: node2
        }) || isBinary(parent, {
          left: node2
        }) || isAssignmentExpression$2(parent, {
          left: node2
        })) {
          node2 = parent;
          i2--;
          parent = printStack[i2];
        } else {
          return false;
        }
      }
      return false;
    }
    var parens = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      NullableTypeAnnotation: NullableTypeAnnotation$1,
      FunctionTypeAnnotation: FunctionTypeAnnotation$1,
      UpdateExpression: UpdateExpression$2,
      ObjectExpression: ObjectExpression$2,
      DoExpression: DoExpression$1,
      Binary,
      UnionTypeAnnotation: UnionTypeAnnotation$1,
      IntersectionTypeAnnotation: UnionTypeAnnotation$1,
      OptionalIndexedAccessType: OptionalIndexedAccessType$1,
      TSAsExpression: TSAsExpression$1,
      TSTypeAssertion: TSTypeAssertion$1,
      TSUnionType: TSUnionType$1,
      TSIntersectionType: TSUnionType$1,
      TSInferType: TSInferType$1,
      BinaryExpression: BinaryExpression$1,
      SequenceExpression: SequenceExpression$2,
      YieldExpression: YieldExpression$1,
      AwaitExpression: YieldExpression$1,
      ClassExpression,
      UnaryLike,
      FunctionExpression: FunctionExpression$1,
      ArrowFunctionExpression: ArrowFunctionExpression$1,
      ConditionalExpression: ConditionalExpression$2,
      OptionalMemberExpression: OptionalMemberExpression$1,
      OptionalCallExpression: OptionalMemberExpression$1,
      AssignmentExpression: AssignmentExpression$2,
      LogicalExpression: LogicalExpression$1,
      Identifier: Identifier$1
    });
    var FLIPPED_ALIAS_KEYS = FLIPPED_ALIAS_KEYS$3, isCallExpression$4 = isCallExpression$7, isExpressionStatement$2 = isExpressionStatement$4, isMemberExpression$4 = isMemberExpression$8, isNewExpression$2 = isNewExpression$4;
    function expandAliases(obj) {
      var newObj = {};
      function add2(type6, func) {
        var fn = newObj[type6];
        newObj[type6] = fn ? function(node2, parent, stack) {
          var result = fn(node2, parent, stack);
          return result == null ? func(node2, parent, stack) : result;
        } : func;
      }
      for (var _i3 = 0, _Object$keys3 = Object.keys(obj); _i3 < _Object$keys3.length; _i3++) {
        var type5 = _Object$keys3[_i3];
        var aliases = FLIPPED_ALIAS_KEYS[type5];
        if (aliases) {
          for (var _iterator2 = _createForOfIteratorHelperLoose(aliases), _step2; !(_step2 = _iterator2()).done; ) {
            var alias2 = _step2.value;
            add2(alias2, obj[type5]);
          }
        } else {
          add2(type5, obj[type5]);
        }
      }
      return newObj;
    }
    var expandedParens = expandAliases(parens);
    var expandedWhitespaceNodes = expandAliases(nodes);
    var expandedWhitespaceList = expandAliases(list$1);
    function find$2(obj, node2, parent, printStack) {
      var fn = obj[node2.type];
      return fn ? fn(node2, parent, printStack) : null;
    }
    function isOrHasCallExpression(node2) {
      if (isCallExpression$4(node2)) {
        return true;
      }
      return isMemberExpression$4(node2) && isOrHasCallExpression(node2.object);
    }
    function needsWhitespace(node2, parent, type5) {
      if (!node2)
        return 0;
      if (isExpressionStatement$2(node2)) {
        node2 = node2.expression;
      }
      var linesInfo = find$2(expandedWhitespaceNodes, node2, parent);
      if (!linesInfo) {
        var items = find$2(expandedWhitespaceList, node2, parent);
        if (items) {
          for (var i2 = 0; i2 < items.length; i2++) {
            linesInfo = needsWhitespace(items[i2], node2, type5);
            if (linesInfo)
              break;
          }
        }
      }
      if (typeof linesInfo === "object" && linesInfo !== null) {
        return linesInfo[type5] || 0;
      }
      return 0;
    }
    function needsWhitespaceBefore$1(node2, parent) {
      return needsWhitespace(node2, parent, "before");
    }
    function needsWhitespaceAfter$1(node2, parent) {
      return needsWhitespace(node2, parent, "after");
    }
    function needsParens$1(node2, parent, printStack) {
      if (!parent)
        return false;
      if (isNewExpression$2(parent) && parent.callee === node2) {
        if (isOrHasCallExpression(node2))
          return true;
      }
      return find$2(expandedParens, node2, parent, printStack);
    }
    function TaggedTemplateExpression$1(node2) {
      this.print(node2.tag, node2);
      this.print(node2.typeParameters, node2);
      this.print(node2.quasi, node2);
    }
    function TemplateElement(node2, parent) {
      var isFirst = parent.quasis[0] === node2;
      var isLast = parent.quasis[parent.quasis.length - 1] === node2;
      var value = (isFirst ? "`" : "}") + node2.value.raw + (isLast ? "`" : "${");
      this.token(value);
    }
    function TemplateLiteral$1(node2) {
      var quasis = node2.quasis;
      for (var i2 = 0; i2 < quasis.length; i2++) {
        this.print(quasis[i2], node2);
        if (i2 + 1 < quasis.length) {
          this.print(node2.expressions[i2], node2);
        }
      }
    }
    var isCallExpression$3 = isCallExpression$7, isLiteral$4 = isLiteral$7, isMemberExpression$3 = isMemberExpression$8, isNewExpression$1 = isNewExpression$4;
    function UnaryExpression$1(node2) {
      if (node2.operator === "void" || node2.operator === "delete" || node2.operator === "typeof" || node2.operator === "throw") {
        this.word(node2.operator);
        this.space();
      } else {
        this.token(node2.operator);
      }
      this.print(node2.argument, node2);
    }
    function DoExpression(node2) {
      if (node2.async) {
        this.word("async");
        this.space();
      }
      this.word("do");
      this.space();
      this.print(node2.body, node2);
    }
    function ParenthesizedExpression$1(node2) {
      this.token("(");
      this.print(node2.expression, node2);
      this.token(")");
    }
    function UpdateExpression$1(node2) {
      if (node2.prefix) {
        this.token(node2.operator);
        this.print(node2.argument, node2);
      } else {
        this.startTerminatorless(true);
        this.print(node2.argument, node2);
        this.endTerminatorless();
        this.token(node2.operator);
      }
    }
    function ConditionalExpression$1(node2) {
      this.print(node2.test, node2);
      this.space();
      this.token("?");
      this.space();
      this.print(node2.consequent, node2);
      this.space();
      this.token(":");
      this.space();
      this.print(node2.alternate, node2);
    }
    function NewExpression$1(node2, parent) {
      this.word("new");
      this.space();
      this.print(node2.callee, node2);
      if (this.format.minified && node2.arguments.length === 0 && !node2.optional && !isCallExpression$3(parent, {
        callee: node2
      }) && !isMemberExpression$3(parent) && !isNewExpression$1(parent)) {
        return;
      }
      this.print(node2.typeArguments, node2);
      this.print(node2.typeParameters, node2);
      if (node2.optional) {
        this.token("?.");
      }
      this.token("(");
      this.printList(node2.arguments, node2);
      this.token(")");
    }
    function SequenceExpression$1(node2) {
      this.printList(node2.expressions, node2);
    }
    function ThisExpression() {
      this.word("this");
    }
    function Super() {
      this.word("super");
    }
    function isDecoratorMemberExpression(node2) {
      switch (node2.type) {
        case "Identifier":
          return true;
        case "MemberExpression":
          return !node2.computed && node2.property.type === "Identifier" && isDecoratorMemberExpression(node2.object);
        default:
          return false;
      }
    }
    function shouldParenthesizeDecoratorExpression(node2) {
      if (node2.type === "CallExpression") {
        node2 = node2.callee;
      }
      if (node2.type === "ParenthesizedExpression") {
        return false;
      }
      return !isDecoratorMemberExpression(node2);
    }
    function Decorator(node2) {
      this.token("@");
      var expression2 = node2.expression;
      if (shouldParenthesizeDecoratorExpression(expression2)) {
        this.token("(");
        this.print(expression2, node2);
        this.token(")");
      } else {
        this.print(expression2, node2);
      }
      this.newline();
    }
    function OptionalMemberExpression(node2) {
      this.print(node2.object, node2);
      if (!node2.computed && isMemberExpression$3(node2.property)) {
        throw new TypeError("Got a MemberExpression for MemberExpression property");
      }
      var computed = node2.computed;
      if (isLiteral$4(node2.property) && typeof node2.property.value === "number") {
        computed = true;
      }
      if (node2.optional) {
        this.token("?.");
      }
      if (computed) {
        this.token("[");
        this.print(node2.property, node2);
        this.token("]");
      } else {
        if (!node2.optional) {
          this.token(".");
        }
        this.print(node2.property, node2);
      }
    }
    function OptionalCallExpression(node2) {
      this.print(node2.callee, node2);
      this.print(node2.typeArguments, node2);
      this.print(node2.typeParameters, node2);
      if (node2.optional) {
        this.token("?.");
      }
      this.token("(");
      this.printList(node2.arguments, node2);
      this.token(")");
    }
    function CallExpression$1(node2) {
      this.print(node2.callee, node2);
      this.print(node2.typeArguments, node2);
      this.print(node2.typeParameters, node2);
      this.token("(");
      this.printList(node2.arguments, node2);
      this.token(")");
    }
    function Import() {
      this.word("import");
    }
    function buildYieldAwait(keyword2) {
      return function(node2) {
        this.word(keyword2);
        if (node2.delegate) {
          this.token("*");
        }
        if (node2.argument) {
          this.space();
          var terminatorState = this.startTerminatorless();
          this.print(node2.argument, node2);
          this.endTerminatorless(terminatorState);
        }
      };
    }
    var YieldExpression = buildYieldAwait("yield");
    var AwaitExpression = buildYieldAwait("await");
    function EmptyStatement() {
      this.semicolon(true);
    }
    function ExpressionStatement(node2) {
      this.print(node2.expression, node2);
      this.semicolon();
    }
    function AssignmentPattern(node2) {
      this.print(node2.left, node2);
      if (node2.left.optional)
        this.token("?");
      this.print(node2.left.typeAnnotation, node2);
      this.space();
      this.token("=");
      this.space();
      this.print(node2.right, node2);
    }
    function AssignmentExpression$1(node2, parent) {
      var parens2 = this.inForStatementInitCounter && node2.operator === "in" && !needsParens$1(node2, parent);
      if (parens2) {
        this.token("(");
      }
      this.print(node2.left, node2);
      this.space();
      if (node2.operator === "in" || node2.operator === "instanceof") {
        this.word(node2.operator);
      } else {
        this.token(node2.operator);
      }
      this.space();
      this.print(node2.right, node2);
      if (parens2) {
        this.token(")");
      }
    }
    function BindExpression(node2) {
      this.print(node2.object, node2);
      this.token("::");
      this.print(node2.callee, node2);
    }
    function MemberExpression(node2) {
      this.print(node2.object, node2);
      if (!node2.computed && isMemberExpression$3(node2.property)) {
        throw new TypeError("Got a MemberExpression for MemberExpression property");
      }
      var computed = node2.computed;
      if (isLiteral$4(node2.property) && typeof node2.property.value === "number") {
        computed = true;
      }
      if (computed) {
        this.token("[");
        this.print(node2.property, node2);
        this.token("]");
      } else {
        this.token(".");
        this.print(node2.property, node2);
      }
    }
    function MetaProperty(node2) {
      this.print(node2.meta, node2);
      this.token(".");
      this.print(node2.property, node2);
    }
    function PrivateName(node2) {
      this.token("#");
      this.print(node2.id, node2);
    }
    function V8IntrinsicIdentifier(node2) {
      this.token("%");
      this.word(node2.name);
    }
    function ModuleExpression(node2) {
      this.word("module");
      this.space();
      this.token("{");
      if (node2.body.body.length === 0) {
        this.token("}");
      } else {
        this.newline();
        this.printSequence(node2.body.body, node2, {
          indent: true
        });
        this.rightBrace();
      }
    }
    var isFor = isFor$2, isForStatement = isForStatement$3, isIfStatement = isIfStatement$2, isStatement$5 = isStatement$7;
    function WithStatement(node2) {
      this.word("with");
      this.space();
      this.token("(");
      this.print(node2.object, node2);
      this.token(")");
      this.printBlock(node2);
    }
    function IfStatement(node2) {
      this.word("if");
      this.space();
      this.token("(");
      this.print(node2.test, node2);
      this.token(")");
      this.space();
      var needsBlock = node2.alternate && isIfStatement(getLastStatement(node2.consequent));
      if (needsBlock) {
        this.token("{");
        this.newline();
        this.indent();
      }
      this.printAndIndentOnComments(node2.consequent, node2);
      if (needsBlock) {
        this.dedent();
        this.newline();
        this.token("}");
      }
      if (node2.alternate) {
        if (this.endsWith(125))
          this.space();
        this.word("else");
        this.space();
        this.printAndIndentOnComments(node2.alternate, node2);
      }
    }
    function getLastStatement(statement2) {
      if (!isStatement$5(statement2.body))
        return statement2;
      return getLastStatement(statement2.body);
    }
    function ForStatement(node2) {
      this.word("for");
      this.space();
      this.token("(");
      this.inForStatementInitCounter++;
      this.print(node2.init, node2);
      this.inForStatementInitCounter--;
      this.token(";");
      if (node2.test) {
        this.space();
        this.print(node2.test, node2);
      }
      this.token(";");
      if (node2.update) {
        this.space();
        this.print(node2.update, node2);
      }
      this.token(")");
      this.printBlock(node2);
    }
    function WhileStatement(node2) {
      this.word("while");
      this.space();
      this.token("(");
      this.print(node2.test, node2);
      this.token(")");
      this.printBlock(node2);
    }
    var buildForXStatement = function buildForXStatement2(op) {
      return function(node2) {
        this.word("for");
        this.space();
        if (op === "of" && node2["await"]) {
          this.word("await");
          this.space();
        }
        this.token("(");
        this.print(node2.left, node2);
        this.space();
        this.word(op);
        this.space();
        this.print(node2.right, node2);
        this.token(")");
        this.printBlock(node2);
      };
    };
    var ForInStatement = buildForXStatement("in");
    var ForOfStatement = buildForXStatement("of");
    function DoWhileStatement(node2) {
      this.word("do");
      this.space();
      this.print(node2.body, node2);
      this.space();
      this.word("while");
      this.space();
      this.token("(");
      this.print(node2.test, node2);
      this.token(")");
      this.semicolon();
    }
    function buildLabelStatement(prefix2, key2) {
      if (key2 === void 0) {
        key2 = "label";
      }
      return function(node2) {
        this.word(prefix2);
        var label = node2[key2];
        if (label) {
          this.space();
          var isLabel = key2 == "label";
          var terminatorState = this.startTerminatorless(isLabel);
          this.print(label, node2);
          this.endTerminatorless(terminatorState);
        }
        this.semicolon();
      };
    }
    var ContinueStatement = buildLabelStatement("continue");
    var ReturnStatement = buildLabelStatement("return", "argument");
    var BreakStatement = buildLabelStatement("break");
    var ThrowStatement = buildLabelStatement("throw", "argument");
    function LabeledStatement(node2) {
      this.print(node2.label, node2);
      this.token(":");
      this.space();
      this.print(node2.body, node2);
    }
    function TryStatement(node2) {
      this.word("try");
      this.space();
      this.print(node2.block, node2);
      this.space();
      if (node2.handlers) {
        this.print(node2.handlers[0], node2);
      } else {
        this.print(node2.handler, node2);
      }
      if (node2.finalizer) {
        this.space();
        this.word("finally");
        this.space();
        this.print(node2.finalizer, node2);
      }
    }
    function CatchClause(node2) {
      this.word("catch");
      this.space();
      if (node2.param) {
        this.token("(");
        this.print(node2.param, node2);
        this.print(node2.param.typeAnnotation, node2);
        this.token(")");
        this.space();
      }
      this.print(node2.body, node2);
    }
    function SwitchStatement(node2) {
      this.word("switch");
      this.space();
      this.token("(");
      this.print(node2.discriminant, node2);
      this.token(")");
      this.space();
      this.token("{");
      this.printSequence(node2.cases, node2, {
        indent: true,
        addNewlines: function addNewlines(leading, cas) {
          if (!leading && node2.cases[node2.cases.length - 1] === cas)
            return -1;
        }
      });
      this.token("}");
    }
    function SwitchCase(node2) {
      if (node2.test) {
        this.word("case");
        this.space();
        this.print(node2.test, node2);
        this.token(":");
      } else {
        this.word("default");
        this.token(":");
      }
      if (node2.consequent.length) {
        this.newline();
        this.printSequence(node2.consequent, node2, {
          indent: true
        });
      }
    }
    function DebuggerStatement() {
      this.word("debugger");
      this.semicolon();
    }
    function variableDeclarationIndent() {
      this.token(",");
      this.newline();
      if (this.endsWith(10)) {
        for (var i2 = 0; i2 < 4; i2++) {
          this.space(true);
        }
      }
    }
    function constDeclarationIndent() {
      this.token(",");
      this.newline();
      if (this.endsWith(10)) {
        for (var i2 = 0; i2 < 6; i2++) {
          this.space(true);
        }
      }
    }
    function VariableDeclaration(node2, parent) {
      if (node2.declare) {
        this.word("declare");
        this.space();
      }
      this.word(node2.kind);
      this.space();
      var hasInits = false;
      if (!isFor(parent)) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(node2.declarations), _step2; !(_step2 = _iterator2()).done; ) {
          var declar = _step2.value;
          if (declar.init) {
            hasInits = true;
          }
        }
      }
      var separator;
      if (hasInits) {
        separator = node2.kind === "const" ? constDeclarationIndent : variableDeclarationIndent;
      }
      this.printList(node2.declarations, node2, {
        separator
      });
      if (isFor(parent)) {
        if (isForStatement(parent)) {
          if (parent.init === node2)
            return;
        } else {
          if (parent.left === node2)
            return;
        }
      }
      this.semicolon();
    }
    function VariableDeclarator$1(node2) {
      this.print(node2.id, node2);
      if (node2.definite)
        this.token("!");
      this.print(node2.id.typeAnnotation, node2);
      if (node2.init) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2.init, node2);
      }
    }
    var isExportDefaultDeclaration = isExportDefaultDeclaration$3, isExportNamedDeclaration = isExportNamedDeclaration$2;
    function ClassDeclaration(node2, parent) {
      if (!this.format.decoratorsBeforeExport || !isExportDefaultDeclaration(parent) && !isExportNamedDeclaration(parent)) {
        this.printJoin(node2.decorators, node2);
      }
      if (node2.declare) {
        this.word("declare");
        this.space();
      }
      if (node2["abstract"]) {
        this.word("abstract");
        this.space();
      }
      this.word("class");
      this.printInnerComments(node2);
      if (node2.id) {
        this.space();
        this.print(node2.id, node2);
      }
      this.print(node2.typeParameters, node2);
      if (node2.superClass) {
        this.space();
        this.word("extends");
        this.space();
        this.print(node2.superClass, node2);
        this.print(node2.superTypeParameters, node2);
      }
      if (node2["implements"]) {
        this.space();
        this.word("implements");
        this.space();
        this.printList(node2["implements"], node2);
      }
      this.space();
      this.print(node2.body, node2);
    }
    function ClassBody(node2) {
      this.token("{");
      this.printInnerComments(node2);
      if (node2.body.length === 0) {
        this.token("}");
      } else {
        this.newline();
        this.indent();
        this.printSequence(node2.body, node2);
        this.dedent();
        if (!this.endsWith(10))
          this.newline();
        this.rightBrace();
      }
    }
    function ClassProperty(node2) {
      this.printJoin(node2.decorators, node2);
      this.source("end", node2.key.loc);
      this.tsPrintClassMemberModifiers(node2, true);
      if (node2.computed) {
        this.token("[");
        this.print(node2.key, node2);
        this.token("]");
      } else {
        this._variance(node2);
        this.print(node2.key, node2);
      }
      if (node2.optional) {
        this.token("?");
      }
      if (node2.definite) {
        this.token("!");
      }
      this.print(node2.typeAnnotation, node2);
      if (node2.value) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2.value, node2);
      }
      this.semicolon();
    }
    function ClassAccessorProperty(node2) {
      this.printJoin(node2.decorators, node2);
      this.source("end", node2.key.loc);
      this.tsPrintClassMemberModifiers(node2, true);
      this.word("accessor");
      this.printInnerComments(node2);
      this.space();
      if (node2.computed) {
        this.token("[");
        this.print(node2.key, node2);
        this.token("]");
      } else {
        this._variance(node2);
        this.print(node2.key, node2);
      }
      if (node2.optional) {
        this.token("?");
      }
      if (node2.definite) {
        this.token("!");
      }
      this.print(node2.typeAnnotation, node2);
      if (node2.value) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2.value, node2);
      }
      this.semicolon();
    }
    function ClassPrivateProperty(node2) {
      this.printJoin(node2.decorators, node2);
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      this.print(node2.key, node2);
      this.print(node2.typeAnnotation, node2);
      if (node2.value) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2.value, node2);
      }
      this.semicolon();
    }
    function ClassMethod(node2) {
      this._classMethodHead(node2);
      this.space();
      this.print(node2.body, node2);
    }
    function ClassPrivateMethod(node2) {
      this._classMethodHead(node2);
      this.space();
      this.print(node2.body, node2);
    }
    function _classMethodHead(node2) {
      this.printJoin(node2.decorators, node2);
      this.source("end", node2.key.loc);
      this.tsPrintClassMemberModifiers(node2, false);
      this._methodHead(node2);
    }
    function StaticBlock(node2) {
      this.word("static");
      this.space();
      this.token("{");
      if (node2.body.length === 0) {
        this.token("}");
      } else {
        this.newline();
        this.printSequence(node2.body, node2, {
          indent: true
        });
        this.rightBrace();
      }
    }
    var isIdentifier$e = isIdentifier$i;
    function _params(node2) {
      this.print(node2.typeParameters, node2);
      this.token("(");
      this._parameters(node2.params, node2);
      this.token(")");
      this.print(node2.returnType, node2);
    }
    function _parameters(parameters, parent) {
      for (var i2 = 0; i2 < parameters.length; i2++) {
        this._param(parameters[i2], parent);
        if (i2 < parameters.length - 1) {
          this.token(",");
          this.space();
        }
      }
    }
    function _param(parameter, parent) {
      this.printJoin(parameter.decorators, parameter);
      this.print(parameter, parent);
      if (parameter.optional)
        this.token("?");
      this.print(parameter.typeAnnotation, parameter);
    }
    function _methodHead(node2) {
      var kind = node2.kind;
      var key2 = node2.key;
      if (kind === "get" || kind === "set") {
        this.word(kind);
        this.space();
      }
      if (node2.async) {
        this._catchUp("start", key2.loc);
        this.word("async");
        this.space();
      }
      if (kind === "method" || kind === "init") {
        if (node2.generator) {
          this.token("*");
        }
      }
      if (node2.computed) {
        this.token("[");
        this.print(key2, node2);
        this.token("]");
      } else {
        this.print(key2, node2);
      }
      if (node2.optional) {
        this.token("?");
      }
      this._params(node2);
    }
    function _predicate(node2) {
      if (node2.predicate) {
        if (!node2.returnType) {
          this.token(":");
        }
        this.space();
        this.print(node2.predicate, node2);
      }
    }
    function _functionHead(node2) {
      if (node2.async) {
        this.word("async");
        this.space();
      }
      this.word("function");
      if (node2.generator)
        this.token("*");
      this.printInnerComments(node2);
      this.space();
      if (node2.id) {
        this.print(node2.id, node2);
      }
      this._params(node2);
      this._predicate(node2);
    }
    function FunctionExpression(node2) {
      this._functionHead(node2);
      this.space();
      this.print(node2.body, node2);
    }
    function ArrowFunctionExpression(node2) {
      if (node2.async) {
        this.word("async");
        this.space();
      }
      var firstParam = node2.params[0];
      if (!this.format.retainLines && !this.format.auxiliaryCommentBefore && !this.format.auxiliaryCommentAfter && node2.params.length === 1 && isIdentifier$e(firstParam) && !hasTypesOrComments(node2, firstParam)) {
        this.print(firstParam, node2);
      } else {
        this._params(node2);
      }
      this._predicate(node2);
      this.space();
      this.token("=>");
      this.space();
      this.print(node2.body, node2);
    }
    function hasTypesOrComments(node2, param) {
      var _param$leadingComment, _param$trailingCommen;
      return !!(node2.typeParameters || node2.returnType || node2.predicate || param.typeAnnotation || param.optional || (_param$leadingComment = param.leadingComments) != null && _param$leadingComment.length || (_param$trailingCommen = param.trailingComments) != null && _param$trailingCommen.length);
    }
    var isClassDeclaration = isClassDeclaration$3, isExportDefaultSpecifier = isExportDefaultSpecifier$1, isExportNamespaceSpecifier = isExportNamespaceSpecifier$1, isImportDefaultSpecifier = isImportDefaultSpecifier$1, isImportNamespaceSpecifier = isImportNamespaceSpecifier$1, isStatement$4 = isStatement$7;
    function ImportSpecifier(node2) {
      if (node2.importKind === "type" || node2.importKind === "typeof") {
        this.word(node2.importKind);
        this.space();
      }
      this.print(node2.imported, node2);
      if (node2.local && node2.local.name !== node2.imported.name) {
        this.space();
        this.word("as");
        this.space();
        this.print(node2.local, node2);
      }
    }
    function ImportDefaultSpecifier(node2) {
      this.print(node2.local, node2);
    }
    function ExportDefaultSpecifier(node2) {
      this.print(node2.exported, node2);
    }
    function ExportSpecifier(node2) {
      if (node2.exportKind === "type") {
        this.word("type");
        this.space();
      }
      this.print(node2.local, node2);
      if (node2.exported && node2.local.name !== node2.exported.name) {
        this.space();
        this.word("as");
        this.space();
        this.print(node2.exported, node2);
      }
    }
    function ExportNamespaceSpecifier(node2) {
      this.token("*");
      this.space();
      this.word("as");
      this.space();
      this.print(node2.exported, node2);
    }
    function ExportAllDeclaration(node2) {
      this.word("export");
      this.space();
      if (node2.exportKind === "type") {
        this.word("type");
        this.space();
      }
      this.token("*");
      this.space();
      this.word("from");
      this.space();
      this.print(node2.source, node2);
      this.printAssertions(node2);
      this.semicolon();
    }
    function ExportNamedDeclaration(node2) {
      if (this.format.decoratorsBeforeExport && isClassDeclaration(node2.declaration)) {
        this.printJoin(node2.declaration.decorators, node2);
      }
      this.word("export");
      this.space();
      ExportDeclaration.apply(this, arguments);
    }
    function ExportDefaultDeclaration(node2) {
      if (this.format.decoratorsBeforeExport && isClassDeclaration(node2.declaration)) {
        this.printJoin(node2.declaration.decorators, node2);
      }
      this.word("export");
      this.space();
      this.word("default");
      this.space();
      ExportDeclaration.apply(this, arguments);
    }
    function ExportDeclaration(node2) {
      if (node2.declaration) {
        var declar = node2.declaration;
        this.print(declar, node2);
        if (!isStatement$4(declar))
          this.semicolon();
      } else {
        if (node2.exportKind === "type") {
          this.word("type");
          this.space();
        }
        var specifiers = node2.specifiers.slice(0);
        var hasSpecial = false;
        for (; ; ) {
          var first = specifiers[0];
          if (isExportDefaultSpecifier(first) || isExportNamespaceSpecifier(first)) {
            hasSpecial = true;
            this.print(specifiers.shift(), node2);
            if (specifiers.length) {
              this.token(",");
              this.space();
            }
          } else {
            break;
          }
        }
        if (specifiers.length || !specifiers.length && !hasSpecial) {
          this.token("{");
          if (specifiers.length) {
            this.space();
            this.printList(specifiers, node2);
            this.space();
          }
          this.token("}");
        }
        if (node2.source) {
          this.space();
          this.word("from");
          this.space();
          this.print(node2.source, node2);
          this.printAssertions(node2);
        }
        this.semicolon();
      }
    }
    function ImportDeclaration(node2) {
      this.word("import");
      this.space();
      var isTypeKind = node2.importKind === "type" || node2.importKind === "typeof";
      if (isTypeKind) {
        this.word(node2.importKind);
        this.space();
      }
      var specifiers = node2.specifiers.slice(0);
      var hasSpecifiers = !!specifiers.length;
      while (hasSpecifiers) {
        var first = specifiers[0];
        if (isImportDefaultSpecifier(first) || isImportNamespaceSpecifier(first)) {
          this.print(specifiers.shift(), node2);
          if (specifiers.length) {
            this.token(",");
            this.space();
          }
        } else {
          break;
        }
      }
      if (specifiers.length) {
        this.token("{");
        this.space();
        this.printList(specifiers, node2);
        this.space();
        this.token("}");
      } else if (isTypeKind && !hasSpecifiers) {
        this.token("{");
        this.token("}");
      }
      if (hasSpecifiers || isTypeKind) {
        this.space();
        this.word("from");
        this.space();
      }
      this.print(node2.source, node2);
      this.printAssertions(node2);
      {
        var _node$attributes;
        if ((_node$attributes = node2.attributes) != null && _node$attributes.length) {
          this.space();
          this.word("with");
          this.space();
          this.printList(node2.attributes, node2);
        }
      }
      this.semicolon();
    }
    function ImportAttribute(node2) {
      this.print(node2.key);
      this.token(":");
      this.space();
      this.print(node2.value);
    }
    function ImportNamespaceSpecifier(node2) {
      this.token("*");
      this.space();
      this.word("as");
      this.space();
      this.print(node2.local, node2);
    }
    var jsesc_1;
    var hasRequiredJsesc;
    function requireJsesc() {
      if (hasRequiredJsesc)
        return jsesc_1;
      hasRequiredJsesc = 1;
      var object4 = {};
      var hasOwnProperty2 = object4.hasOwnProperty;
      var forOwn = function forOwn2(object5, callback) {
        for (var key2 in object5) {
          if (hasOwnProperty2.call(object5, key2)) {
            callback(key2, object5[key2]);
          }
        }
      };
      var extend3 = function extend4(destination, source) {
        if (!source) {
          return destination;
        }
        forOwn(source, function(key2, value) {
          destination[key2] = value;
        });
        return destination;
      };
      var forEach = function forEach2(array4, callback) {
        var length = array4.length;
        var index3 = -1;
        while (++index3 < length) {
          callback(array4[index3]);
        }
      };
      var toString3 = object4.toString;
      var isArray3 = Array.isArray;
      var isBuffer3 = Buffer$1.isBuffer;
      var isObject2 = function isObject3(value) {
        return toString3.call(value) == "[object Object]";
      };
      var isString2 = function isString3(value) {
        return typeof value == "string" || toString3.call(value) == "[object String]";
      };
      var isNumber2 = function isNumber3(value) {
        return typeof value == "number" || toString3.call(value) == "[object Number]";
      };
      var isFunction3 = function isFunction4(value) {
        return typeof value == "function";
      };
      var isMap = function isMap2(value) {
        return toString3.call(value) == "[object Map]";
      };
      var isSet = function isSet2(value) {
        return toString3.call(value) == "[object Set]";
      };
      var singleEscapes = {
        '"': '\\"',
        "'": "\\'",
        "\\": "\\\\",
        "\b": "\\b",
        "\f": "\\f",
        "\n": "\\n",
        "\r": "\\r",
        "	": "\\t"
      };
      var regexSingleEscape = /["'\\\b\f\n\r\t]/;
      var regexDigit = /[0-9]/;
      var regexWhitelist = /[ !#-&\(-\[\]-_a-~]/;
      var jsesc2 = function jsesc3(argument, options) {
        var increaseIndentation = function increaseIndentation2() {
          oldIndent = indent;
          ++options.indentLevel;
          indent = options.indent.repeat(options.indentLevel);
        };
        var defaults2 = {
          "escapeEverything": false,
          "minimal": false,
          "isScriptContext": false,
          "quotes": "single",
          "wrap": false,
          "es6": false,
          "json": false,
          "compact": true,
          "lowercaseHex": false,
          "numbers": "decimal",
          "indent": "	",
          "indentLevel": 0,
          "__inline1__": false,
          "__inline2__": false
        };
        var json = options && options.json;
        if (json) {
          defaults2.quotes = "double";
          defaults2.wrap = true;
        }
        options = extend3(defaults2, options);
        if (options.quotes != "single" && options.quotes != "double" && options.quotes != "backtick") {
          options.quotes = "single";
        }
        var quote = options.quotes == "double" ? '"' : options.quotes == "backtick" ? "`" : "'";
        var compact = options.compact;
        var lowercaseHex = options.lowercaseHex;
        var indent = options.indent.repeat(options.indentLevel);
        var oldIndent = "";
        var inline1 = options.__inline1__;
        var inline2 = options.__inline2__;
        var newLine = compact ? "" : "\n";
        var result;
        var isEmpty2 = true;
        var useBinNumbers = options.numbers == "binary";
        var useOctNumbers = options.numbers == "octal";
        var useDecNumbers = options.numbers == "decimal";
        var useHexNumbers = options.numbers == "hexadecimal";
        if (json && argument && isFunction3(argument.toJSON)) {
          argument = argument.toJSON();
        }
        if (!isString2(argument)) {
          if (isMap(argument)) {
            if (argument.size == 0) {
              return "new Map()";
            }
            if (!compact) {
              options.__inline1__ = true;
              options.__inline2__ = false;
            }
            return "new Map(" + jsesc3(Array.from(argument), options) + ")";
          }
          if (isSet(argument)) {
            if (argument.size == 0) {
              return "new Set()";
            }
            return "new Set(" + jsesc3(Array.from(argument), options) + ")";
          }
          if (isBuffer3(argument)) {
            if (argument.length == 0) {
              return "Buffer.from([])";
            }
            return "Buffer.from(" + jsesc3(Array.from(argument), options) + ")";
          }
          if (isArray3(argument)) {
            result = [];
            options.wrap = true;
            if (inline1) {
              options.__inline1__ = false;
              options.__inline2__ = true;
            }
            if (!inline2) {
              increaseIndentation();
            }
            forEach(argument, function(value) {
              isEmpty2 = false;
              if (inline2) {
                options.__inline2__ = false;
              }
              result.push((compact || inline2 ? "" : indent) + jsesc3(value, options));
            });
            if (isEmpty2) {
              return "[]";
            }
            if (inline2) {
              return "[" + result.join(", ") + "]";
            }
            return "[" + newLine + result.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "]";
          } else if (isNumber2(argument)) {
            if (json) {
              return JSON.stringify(argument);
            }
            if (useDecNumbers) {
              return String(argument);
            }
            if (useHexNumbers) {
              var hexadecimal = argument.toString(16);
              if (!lowercaseHex) {
                hexadecimal = hexadecimal.toUpperCase();
              }
              return "0x" + hexadecimal;
            }
            if (useBinNumbers) {
              return "0b" + argument.toString(2);
            }
            if (useOctNumbers) {
              return "0o" + argument.toString(8);
            }
          } else if (!isObject2(argument)) {
            if (json) {
              return JSON.stringify(argument) || "null";
            }
            return String(argument);
          } else {
            result = [];
            options.wrap = true;
            increaseIndentation();
            forOwn(argument, function(key2, value) {
              isEmpty2 = false;
              result.push((compact ? "" : indent) + jsesc3(key2, options) + ":" + (compact ? "" : " ") + jsesc3(value, options));
            });
            if (isEmpty2) {
              return "{}";
            }
            return "{" + newLine + result.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "}";
          }
        }
        var string3 = argument;
        var index3 = -1;
        var length = string3.length;
        result = "";
        while (++index3 < length) {
          var character = string3.charAt(index3);
          if (options.es6) {
            var first = string3.charCodeAt(index3);
            if (first >= 55296 && first <= 56319 && length > index3 + 1) {
              var second = string3.charCodeAt(index3 + 1);
              if (second >= 56320 && second <= 57343) {
                var codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
                var _hexadecimal2 = codePoint.toString(16);
                if (!lowercaseHex) {
                  _hexadecimal2 = _hexadecimal2.toUpperCase();
                }
                result += "\\u{" + _hexadecimal2 + "}";
                ++index3;
                continue;
              }
            }
          }
          if (!options.escapeEverything) {
            if (regexWhitelist.test(character)) {
              result += character;
              continue;
            }
            if (character == '"') {
              result += quote == character ? '\\"' : character;
              continue;
            }
            if (character == "`") {
              result += quote == character ? "\\`" : character;
              continue;
            }
            if (character == "'") {
              result += quote == character ? "\\'" : character;
              continue;
            }
          }
          if (character == "\0" && !json && !regexDigit.test(string3.charAt(index3 + 1))) {
            result += "\\0";
            continue;
          }
          if (regexSingleEscape.test(character)) {
            result += singleEscapes[character];
            continue;
          }
          var charCode = character.charCodeAt(0);
          if (options.minimal && charCode != 8232 && charCode != 8233) {
            result += character;
            continue;
          }
          var _hexadecimal = charCode.toString(16);
          if (!lowercaseHex) {
            _hexadecimal = _hexadecimal.toUpperCase();
          }
          var longhand = _hexadecimal.length > 2 || json;
          var escaped = "\\" + (longhand ? "u" : "x") + ("0000" + _hexadecimal).slice(longhand ? -4 : -2);
          result += escaped;
          continue;
        }
        if (options.wrap) {
          result = quote + result + quote;
        }
        if (quote == "`") {
          result = result.replace(/\$\{/g, "\\${");
        }
        if (options.isScriptContext) {
          return result.replace(/<\/(script|style)/gi, "<\\/$1").replace(/<!--/g, json ? "\\u003C!--" : "\\x3C!--");
        }
        return result;
      };
      jsesc2.version = "2.5.2";
      jsesc_1 = jsesc2;
      return jsesc_1;
    }
    var jsesc = requireJsesc();
    var isAssignmentPattern$4 = isAssignmentPattern$5, isIdentifier$d = isIdentifier$i;
    function Identifier(node2) {
      var _this = this;
      this.exactSource(node2.loc, function() {
        _this.word(node2.name);
      });
    }
    function ArgumentPlaceholder() {
      this.token("?");
    }
    function RestElement$1(node2) {
      this.token("...");
      this.print(node2.argument, node2);
    }
    function ObjectExpression$1(node2) {
      var props = node2.properties;
      this.token("{");
      this.printInnerComments(node2);
      if (props.length) {
        this.space();
        this.printList(props, node2, {
          indent: true,
          statement: true
        });
        this.space();
      }
      this.token("}");
    }
    function ObjectMethod(node2) {
      this.printJoin(node2.decorators, node2);
      this._methodHead(node2);
      this.space();
      this.print(node2.body, node2);
    }
    function ObjectProperty(node2) {
      this.printJoin(node2.decorators, node2);
      if (node2.computed) {
        this.token("[");
        this.print(node2.key, node2);
        this.token("]");
      } else {
        if (isAssignmentPattern$4(node2.value) && isIdentifier$d(node2.key) && node2.key.name === node2.value.left.name) {
          this.print(node2.value, node2);
          return;
        }
        this.print(node2.key, node2);
        if (node2.shorthand && isIdentifier$d(node2.key) && isIdentifier$d(node2.value) && node2.key.name === node2.value.name) {
          return;
        }
      }
      this.token(":");
      this.space();
      this.print(node2.value, node2);
    }
    function ArrayExpression$1(node2) {
      var elems = node2.elements;
      var len3 = elems.length;
      this.token("[");
      this.printInnerComments(node2);
      for (var i2 = 0; i2 < elems.length; i2++) {
        var elem = elems[i2];
        if (elem) {
          if (i2 > 0)
            this.space();
          this.print(elem, node2);
          if (i2 < len3 - 1)
            this.token(",");
        } else {
          this.token(",");
        }
      }
      this.token("]");
    }
    function RecordExpression(node2) {
      var props = node2.properties;
      var startToken;
      var endToken;
      if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "{|";
        endToken = "|}";
      } else if (this.format.recordAndTupleSyntaxType === "hash") {
        startToken = "#{";
        endToken = "}";
      } else {
        throw new Error('The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (' + JSON.stringify(this.format.recordAndTupleSyntaxType) + " received).");
      }
      this.token(startToken);
      this.printInnerComments(node2);
      if (props.length) {
        this.space();
        this.printList(props, node2, {
          indent: true,
          statement: true
        });
        this.space();
      }
      this.token(endToken);
    }
    function TupleExpression(node2) {
      var elems = node2.elements;
      var len3 = elems.length;
      var startToken;
      var endToken;
      if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "[|";
        endToken = "|]";
      } else if (this.format.recordAndTupleSyntaxType === "hash") {
        startToken = "#[";
        endToken = "]";
      } else {
        throw new Error(this.format.recordAndTupleSyntaxType + " is not a valid recordAndTuple syntax type");
      }
      this.token(startToken);
      this.printInnerComments(node2);
      for (var i2 = 0; i2 < elems.length; i2++) {
        var elem = elems[i2];
        if (elem) {
          if (i2 > 0)
            this.space();
          this.print(elem, node2);
          if (i2 < len3 - 1)
            this.token(",");
        }
      }
      this.token(endToken);
    }
    function RegExpLiteral$1(node2) {
      this.word("/" + node2.pattern + "/" + node2.flags);
    }
    function BooleanLiteral$1(node2) {
      this.word(node2.value ? "true" : "false");
    }
    function NullLiteral$1() {
      this.word("null");
    }
    function NumericLiteral$1(node2) {
      var raw = this.getPossibleRaw(node2);
      var opts = this.format.jsescOption;
      var value = node2.value + "";
      if (opts.numbers) {
        this.number(jsesc(node2.value, opts));
      } else if (raw == null) {
        this.number(value);
      } else if (this.format.minified) {
        this.number(raw.length < value.length ? raw : value);
      } else {
        this.number(raw);
      }
    }
    function StringLiteral$1(node2) {
      var raw = this.getPossibleRaw(node2);
      if (!this.format.minified && raw != null) {
        this.token(raw);
        return;
      }
      var val = jsesc(node2.value, Object.assign(this.format.jsescOption, this.format.jsonCompatibleStrings && {
        json: true
      }));
      return this.token(val);
    }
    function BigIntLiteral(node2) {
      var raw = this.getPossibleRaw(node2);
      if (!this.format.minified && raw != null) {
        this.word(raw);
        return;
      }
      this.word(node2.value + "n");
    }
    function DecimalLiteral(node2) {
      var raw = this.getPossibleRaw(node2);
      if (!this.format.minified && raw != null) {
        this.word(raw);
        return;
      }
      this.word(node2.value + "m");
    }
    var validTopicTokenSet = /* @__PURE__ */ new Set(["^^", "@@", "^", "%", "#"]);
    function TopicReference() {
      var topicToken = this.format.topicToken;
      if (validTopicTokenSet.has(topicToken)) {
        this.token(topicToken);
      } else {
        var givenTopicTokenJSON = JSON.stringify(topicToken);
        var validTopics = Array.from(validTopicTokenSet, function(v22) {
          return JSON.stringify(v22);
        });
        throw new Error('The "topicToken" generator option must be one of ' + (validTopics.join(", ") + " (" + givenTopicTokenJSON + " received instead)."));
      }
    }
    function PipelineTopicExpression(node2) {
      this.print(node2.expression, node2);
    }
    function PipelineBareFunction(node2) {
      this.print(node2.callee, node2);
    }
    function PipelinePrimaryTopicReference() {
      this.token("#");
    }
    var isDeclareExportDeclaration = isDeclareExportDeclaration$1, isStatement$3 = isStatement$7;
    function AnyTypeAnnotation() {
      this.word("any");
    }
    function ArrayTypeAnnotation(node2) {
      this.print(node2.elementType, node2);
      this.token("[");
      this.token("]");
    }
    function BooleanTypeAnnotation() {
      this.word("boolean");
    }
    function BooleanLiteralTypeAnnotation(node2) {
      this.word(node2.value ? "true" : "false");
    }
    function NullLiteralTypeAnnotation() {
      this.word("null");
    }
    function DeclareClass(node2, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word("declare");
        this.space();
      }
      this.word("class");
      this.space();
      this._interfaceish(node2);
    }
    function DeclareFunction(node2, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word("declare");
        this.space();
      }
      this.word("function");
      this.space();
      this.print(node2.id, node2);
      this.print(node2.id.typeAnnotation.typeAnnotation, node2);
      if (node2.predicate) {
        this.space();
        this.print(node2.predicate, node2);
      }
      this.semicolon();
    }
    function InferredPredicate() {
      this.token("%");
      this.word("checks");
    }
    function DeclaredPredicate(node2) {
      this.token("%");
      this.word("checks");
      this.token("(");
      this.print(node2.value, node2);
      this.token(")");
    }
    function DeclareInterface(node2) {
      this.word("declare");
      this.space();
      this.InterfaceDeclaration(node2);
    }
    function DeclareModule(node2) {
      this.word("declare");
      this.space();
      this.word("module");
      this.space();
      this.print(node2.id, node2);
      this.space();
      this.print(node2.body, node2);
    }
    function DeclareModuleExports(node2) {
      this.word("declare");
      this.space();
      this.word("module");
      this.token(".");
      this.word("exports");
      this.print(node2.typeAnnotation, node2);
    }
    function DeclareTypeAlias(node2) {
      this.word("declare");
      this.space();
      this.TypeAlias(node2);
    }
    function DeclareOpaqueType(node2, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word("declare");
        this.space();
      }
      this.OpaqueType(node2);
    }
    function DeclareVariable(node2, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word("declare");
        this.space();
      }
      this.word("var");
      this.space();
      this.print(node2.id, node2);
      this.print(node2.id.typeAnnotation, node2);
      this.semicolon();
    }
    function DeclareExportDeclaration(node2) {
      this.word("declare");
      this.space();
      this.word("export");
      this.space();
      if (node2["default"]) {
        this.word("default");
        this.space();
      }
      FlowExportDeclaration.apply(this, arguments);
    }
    function DeclareExportAllDeclaration() {
      this.word("declare");
      this.space();
      ExportAllDeclaration.apply(this, arguments);
    }
    function EnumDeclaration(node2) {
      var id3 = node2.id, body = node2.body;
      this.word("enum");
      this.space();
      this.print(id3, node2);
      this.print(body, node2);
    }
    function enumExplicitType(context, name2, hasExplicitType) {
      if (hasExplicitType) {
        context.space();
        context.word("of");
        context.space();
        context.word(name2);
      }
      context.space();
    }
    function enumBody(context, node2) {
      var members = node2.members;
      context.token("{");
      context.indent();
      context.newline();
      for (var _iterator2 = _createForOfIteratorHelperLoose(members), _step2; !(_step2 = _iterator2()).done; ) {
        var member = _step2.value;
        context.print(member, node2);
        context.newline();
      }
      if (node2.hasUnknownMembers) {
        context.token("...");
        context.newline();
      }
      context.dedent();
      context.token("}");
    }
    function EnumBooleanBody(node2) {
      var explicitType = node2.explicitType;
      enumExplicitType(this, "boolean", explicitType);
      enumBody(this, node2);
    }
    function EnumNumberBody(node2) {
      var explicitType = node2.explicitType;
      enumExplicitType(this, "number", explicitType);
      enumBody(this, node2);
    }
    function EnumStringBody(node2) {
      var explicitType = node2.explicitType;
      enumExplicitType(this, "string", explicitType);
      enumBody(this, node2);
    }
    function EnumSymbolBody(node2) {
      enumExplicitType(this, "symbol", true);
      enumBody(this, node2);
    }
    function EnumDefaultedMember(node2) {
      var id3 = node2.id;
      this.print(id3, node2);
      this.token(",");
    }
    function enumInitializedMember(context, node2) {
      var id3 = node2.id, init3 = node2.init;
      context.print(id3, node2);
      context.space();
      context.token("=");
      context.space();
      context.print(init3, node2);
      context.token(",");
    }
    function EnumBooleanMember(node2) {
      enumInitializedMember(this, node2);
    }
    function EnumNumberMember(node2) {
      enumInitializedMember(this, node2);
    }
    function EnumStringMember(node2) {
      enumInitializedMember(this, node2);
    }
    function FlowExportDeclaration(node2) {
      if (node2.declaration) {
        var declar = node2.declaration;
        this.print(declar, node2);
        if (!isStatement$3(declar))
          this.semicolon();
      } else {
        this.token("{");
        if (node2.specifiers.length) {
          this.space();
          this.printList(node2.specifiers, node2);
          this.space();
        }
        this.token("}");
        if (node2.source) {
          this.space();
          this.word("from");
          this.space();
          this.print(node2.source, node2);
        }
        this.semicolon();
      }
    }
    function ExistsTypeAnnotation() {
      this.token("*");
    }
    function FunctionTypeAnnotation(node2, parent) {
      this.print(node2.typeParameters, node2);
      this.token("(");
      if (node2["this"]) {
        this.word("this");
        this.token(":");
        this.space();
        this.print(node2["this"].typeAnnotation, node2);
        if (node2.params.length || node2.rest) {
          this.token(",");
          this.space();
        }
      }
      this.printList(node2.params, node2);
      if (node2.rest) {
        if (node2.params.length) {
          this.token(",");
          this.space();
        }
        this.token("...");
        this.print(node2.rest, node2);
      }
      this.token(")");
      if (parent && (parent.type === "ObjectTypeCallProperty" || parent.type === "DeclareFunction" || parent.type === "ObjectTypeProperty" && parent.method)) {
        this.token(":");
      } else {
        this.space();
        this.token("=>");
      }
      this.space();
      this.print(node2.returnType, node2);
    }
    function FunctionTypeParam(node2) {
      this.print(node2.name, node2);
      if (node2.optional)
        this.token("?");
      if (node2.name) {
        this.token(":");
        this.space();
      }
      this.print(node2.typeAnnotation, node2);
    }
    function InterfaceExtends(node2) {
      this.print(node2.id, node2);
      this.print(node2.typeParameters, node2);
    }
    function _interfaceish(node2) {
      var _node$extends;
      this.print(node2.id, node2);
      this.print(node2.typeParameters, node2);
      if ((_node$extends = node2["extends"]) != null && _node$extends.length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(node2["extends"], node2);
      }
      if (node2.mixins && node2.mixins.length) {
        this.space();
        this.word("mixins");
        this.space();
        this.printList(node2.mixins, node2);
      }
      if (node2["implements"] && node2["implements"].length) {
        this.space();
        this.word("implements");
        this.space();
        this.printList(node2["implements"], node2);
      }
      this.space();
      this.print(node2.body, node2);
    }
    function _variance(node2) {
      if (node2.variance) {
        if (node2.variance.kind === "plus") {
          this.token("+");
        } else if (node2.variance.kind === "minus") {
          this.token("-");
        }
      }
    }
    function InterfaceDeclaration(node2) {
      this.word("interface");
      this.space();
      this._interfaceish(node2);
    }
    function andSeparator() {
      this.space();
      this.token("&");
      this.space();
    }
    function InterfaceTypeAnnotation(node2) {
      this.word("interface");
      if (node2["extends"] && node2["extends"].length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(node2["extends"], node2);
      }
      this.space();
      this.print(node2.body, node2);
    }
    function IntersectionTypeAnnotation(node2) {
      this.printJoin(node2.types, node2, {
        separator: andSeparator
      });
    }
    function MixedTypeAnnotation() {
      this.word("mixed");
    }
    function EmptyTypeAnnotation() {
      this.word("empty");
    }
    function NullableTypeAnnotation(node2) {
      this.token("?");
      this.print(node2.typeAnnotation, node2);
    }
    function NumberTypeAnnotation() {
      this.word("number");
    }
    function StringTypeAnnotation() {
      this.word("string");
    }
    function ThisTypeAnnotation() {
      this.word("this");
    }
    function TupleTypeAnnotation(node2) {
      this.token("[");
      this.printList(node2.types, node2);
      this.token("]");
    }
    function TypeofTypeAnnotation(node2) {
      this.word("typeof");
      this.space();
      this.print(node2.argument, node2);
    }
    function TypeAlias(node2) {
      this.word("type");
      this.space();
      this.print(node2.id, node2);
      this.print(node2.typeParameters, node2);
      this.space();
      this.token("=");
      this.space();
      this.print(node2.right, node2);
      this.semicolon();
    }
    function TypeAnnotation(node2) {
      this.token(":");
      this.space();
      if (node2.optional)
        this.token("?");
      this.print(node2.typeAnnotation, node2);
    }
    function TypeParameterInstantiation(node2) {
      this.token("<");
      this.printList(node2.params, node2, {});
      this.token(">");
    }
    function TypeParameter(node2) {
      this._variance(node2);
      this.word(node2.name);
      if (node2.bound) {
        this.print(node2.bound, node2);
      }
      if (node2["default"]) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2["default"], node2);
      }
    }
    function OpaqueType(node2) {
      this.word("opaque");
      this.space();
      this.word("type");
      this.space();
      this.print(node2.id, node2);
      this.print(node2.typeParameters, node2);
      if (node2.supertype) {
        this.token(":");
        this.space();
        this.print(node2.supertype, node2);
      }
      if (node2.impltype) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2.impltype, node2);
      }
      this.semicolon();
    }
    function ObjectTypeAnnotation(node2) {
      var _this = this;
      if (node2.exact) {
        this.token("{|");
      } else {
        this.token("{");
      }
      var props = [].concat(_toConsumableArray2(node2.properties), _toConsumableArray2(node2.callProperties || []), _toConsumableArray2(node2.indexers || []), _toConsumableArray2(node2.internalSlots || []));
      if (props.length) {
        this.space();
        this.printJoin(props, node2, {
          addNewlines: function addNewlines(leading) {
            if (leading && !props[0])
              return 1;
          },
          indent: true,
          statement: true,
          iterator: function iterator2() {
            if (props.length !== 1 || node2.inexact) {
              _this.token(",");
              _this.space();
            }
          }
        });
        this.space();
      }
      if (node2.inexact) {
        this.indent();
        this.token("...");
        if (props.length) {
          this.newline();
        }
        this.dedent();
      }
      if (node2.exact) {
        this.token("|}");
      } else {
        this.token("}");
      }
    }
    function ObjectTypeInternalSlot(node2) {
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      this.token("[");
      this.token("[");
      this.print(node2.id, node2);
      this.token("]");
      this.token("]");
      if (node2.optional)
        this.token("?");
      if (!node2.method) {
        this.token(":");
        this.space();
      }
      this.print(node2.value, node2);
    }
    function ObjectTypeCallProperty(node2) {
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      this.print(node2.value, node2);
    }
    function ObjectTypeIndexer(node2) {
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      this._variance(node2);
      this.token("[");
      if (node2.id) {
        this.print(node2.id, node2);
        this.token(":");
        this.space();
      }
      this.print(node2.key, node2);
      this.token("]");
      this.token(":");
      this.space();
      this.print(node2.value, node2);
    }
    function ObjectTypeProperty(node2) {
      if (node2.proto) {
        this.word("proto");
        this.space();
      }
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      if (node2.kind === "get" || node2.kind === "set") {
        this.word(node2.kind);
        this.space();
      }
      this._variance(node2);
      this.print(node2.key, node2);
      if (node2.optional)
        this.token("?");
      if (!node2.method) {
        this.token(":");
        this.space();
      }
      this.print(node2.value, node2);
    }
    function ObjectTypeSpreadProperty(node2) {
      this.token("...");
      this.print(node2.argument, node2);
    }
    function QualifiedTypeIdentifier(node2) {
      this.print(node2.qualification, node2);
      this.token(".");
      this.print(node2.id, node2);
    }
    function SymbolTypeAnnotation() {
      this.word("symbol");
    }
    function orSeparator() {
      this.space();
      this.token("|");
      this.space();
    }
    function UnionTypeAnnotation(node2) {
      this.printJoin(node2.types, node2, {
        separator: orSeparator
      });
    }
    function TypeCastExpression$1(node2) {
      this.token("(");
      this.print(node2.expression, node2);
      this.print(node2.typeAnnotation, node2);
      this.token(")");
    }
    function Variance(node2) {
      if (node2.kind === "plus") {
        this.token("+");
      } else {
        this.token("-");
      }
    }
    function VoidTypeAnnotation() {
      this.word("void");
    }
    function IndexedAccessType(node2) {
      this.print(node2.objectType, node2);
      this.token("[");
      this.print(node2.indexType, node2);
      this.token("]");
    }
    function OptionalIndexedAccessType(node2) {
      this.print(node2.objectType, node2);
      if (node2.optional) {
        this.token("?.");
      }
      this.token("[");
      this.print(node2.indexType, node2);
      this.token("]");
    }
    function File$1(node2) {
      if (node2.program) {
        this.print(node2.program.interpreter, node2);
      }
      this.print(node2.program, node2);
    }
    function Program(node2) {
      this.printInnerComments(node2, false);
      this.printSequence(node2.directives, node2);
      if (node2.directives && node2.directives.length)
        this.newline();
      this.printSequence(node2.body, node2);
    }
    function BlockStatement(node2) {
      var _node$directives;
      this.token("{");
      this.printInnerComments(node2);
      var hasDirectives = (_node$directives = node2.directives) == null ? void 0 : _node$directives.length;
      if (node2.body.length || hasDirectives) {
        this.newline();
        this.printSequence(node2.directives, node2, {
          indent: true
        });
        if (hasDirectives)
          this.newline();
        this.printSequence(node2.body, node2, {
          indent: true
        });
        this.removeTrailingNewline();
        this.source("end", node2.loc);
        if (!this.endsWith(10))
          this.newline();
        this.rightBrace();
      } else {
        this.source("end", node2.loc);
        this.token("}");
      }
    }
    function Directive(node2) {
      this.print(node2.value, node2);
      this.semicolon();
    }
    var unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
    var unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
    function DirectiveLiteral(node2) {
      var raw = this.getPossibleRaw(node2);
      if (!this.format.minified && raw != null) {
        this.token(raw);
        return;
      }
      var value = node2.value;
      if (!unescapedDoubleQuoteRE.test(value)) {
        this.token('"' + value + '"');
      } else if (!unescapedSingleQuoteRE.test(value)) {
        this.token("'" + value + "'");
      } else {
        throw new Error("Malformed AST: it is not possible to print a directive containing both unescaped single and double quotes.");
      }
    }
    function InterpreterDirective(node2) {
      this.token("#!" + node2.value + "\n");
    }
    function Placeholder(node2) {
      this.token("%%");
      this.print(node2.name);
      this.token("%%");
      if (node2.expectedNode === "Statement") {
        this.semicolon();
      }
    }
    function JSXAttribute(node2) {
      this.print(node2.name, node2);
      if (node2.value) {
        this.token("=");
        this.print(node2.value, node2);
      }
    }
    function JSXIdentifier(node2) {
      this.word(node2.name);
    }
    function JSXNamespacedName(node2) {
      this.print(node2.namespace, node2);
      this.token(":");
      this.print(node2.name, node2);
    }
    function JSXMemberExpression(node2) {
      this.print(node2.object, node2);
      this.token(".");
      this.print(node2.property, node2);
    }
    function JSXSpreadAttribute(node2) {
      this.token("{");
      this.token("...");
      this.print(node2.argument, node2);
      this.token("}");
    }
    function JSXExpressionContainer(node2) {
      this.token("{");
      this.print(node2.expression, node2);
      this.token("}");
    }
    function JSXSpreadChild(node2) {
      this.token("{");
      this.token("...");
      this.print(node2.expression, node2);
      this.token("}");
    }
    function JSXText(node2) {
      var raw = this.getPossibleRaw(node2);
      if (raw != null) {
        this.token(raw);
      } else {
        this.token(node2.value);
      }
    }
    function JSXElement(node2) {
      var open = node2.openingElement;
      this.print(open, node2);
      if (open.selfClosing)
        return;
      this.indent();
      for (var _iterator2 = _createForOfIteratorHelperLoose(node2.children), _step2; !(_step2 = _iterator2()).done; ) {
        var child = _step2.value;
        this.print(child, node2);
      }
      this.dedent();
      this.print(node2.closingElement, node2);
    }
    function spaceSeparator() {
      this.space();
    }
    function JSXOpeningElement(node2) {
      this.token("<");
      this.print(node2.name, node2);
      this.print(node2.typeParameters, node2);
      if (node2.attributes.length > 0) {
        this.space();
        this.printJoin(node2.attributes, node2, {
          separator: spaceSeparator
        });
      }
      if (node2.selfClosing) {
        this.space();
        this.token("/>");
      } else {
        this.token(">");
      }
    }
    function JSXClosingElement(node2) {
      this.token("</");
      this.print(node2.name, node2);
      this.token(">");
    }
    function JSXEmptyExpression(node2) {
      this.printInnerComments(node2);
    }
    function JSXFragment(node2) {
      this.print(node2.openingFragment, node2);
      this.indent();
      for (var _iterator2 = _createForOfIteratorHelperLoose(node2.children), _step2; !(_step2 = _iterator2()).done; ) {
        var child = _step2.value;
        this.print(child, node2);
      }
      this.dedent();
      this.print(node2.closingFragment, node2);
    }
    function JSXOpeningFragment() {
      this.token("<");
      this.token(">");
    }
    function JSXClosingFragment() {
      this.token("</");
      this.token(">");
    }
    function TSTypeAnnotation(node2) {
      this.token(":");
      this.space();
      if (node2.optional)
        this.token("?");
      this.print(node2.typeAnnotation, node2);
    }
    function TSTypeParameterInstantiation(node2, parent) {
      this.token("<");
      this.printList(node2.params, node2, {});
      if (parent.type === "ArrowFunctionExpression" && node2.params.length === 1) {
        this.token(",");
      }
      this.token(">");
    }
    function TSTypeParameter(node2) {
      this.word(node2.name);
      if (node2.constraint) {
        this.space();
        this.word("extends");
        this.space();
        this.print(node2.constraint, node2);
      }
      if (node2["default"]) {
        this.space();
        this.token("=");
        this.space();
        this.print(node2["default"], node2);
      }
    }
    function TSParameterProperty(node2) {
      if (node2.accessibility) {
        this.word(node2.accessibility);
        this.space();
      }
      if (node2.readonly) {
        this.word("readonly");
        this.space();
      }
      this._param(node2.parameter);
    }
    function TSDeclareFunction(node2) {
      if (node2.declare) {
        this.word("declare");
        this.space();
      }
      this._functionHead(node2);
      this.token(";");
    }
    function TSDeclareMethod(node2) {
      this._classMethodHead(node2);
      this.token(";");
    }
    function TSQualifiedName(node2) {
      this.print(node2.left, node2);
      this.token(".");
      this.print(node2.right, node2);
    }
    function TSCallSignatureDeclaration(node2) {
      this.tsPrintSignatureDeclarationBase(node2);
      this.token(";");
    }
    function TSConstructSignatureDeclaration(node2) {
      this.word("new");
      this.space();
      this.tsPrintSignatureDeclarationBase(node2);
      this.token(";");
    }
    function TSPropertySignature(node2) {
      var readonly = node2.readonly, initializer = node2.initializer;
      if (readonly) {
        this.word("readonly");
        this.space();
      }
      this.tsPrintPropertyOrMethodName(node2);
      this.print(node2.typeAnnotation, node2);
      if (initializer) {
        this.space();
        this.token("=");
        this.space();
        this.print(initializer, node2);
      }
      this.token(";");
    }
    function tsPrintPropertyOrMethodName(node2) {
      if (node2.computed) {
        this.token("[");
      }
      this.print(node2.key, node2);
      if (node2.computed) {
        this.token("]");
      }
      if (node2.optional) {
        this.token("?");
      }
    }
    function TSMethodSignature(node2) {
      var kind = node2.kind;
      if (kind === "set" || kind === "get") {
        this.word(kind);
        this.space();
      }
      this.tsPrintPropertyOrMethodName(node2);
      this.tsPrintSignatureDeclarationBase(node2);
      this.token(";");
    }
    function TSIndexSignature(node2) {
      var readonly = node2.readonly, isStatic2 = node2["static"];
      if (isStatic2) {
        this.word("static");
        this.space();
      }
      if (readonly) {
        this.word("readonly");
        this.space();
      }
      this.token("[");
      this._parameters(node2.parameters, node2);
      this.token("]");
      this.print(node2.typeAnnotation, node2);
      this.token(";");
    }
    function TSAnyKeyword() {
      this.word("any");
    }
    function TSBigIntKeyword() {
      this.word("bigint");
    }
    function TSUnknownKeyword() {
      this.word("unknown");
    }
    function TSNumberKeyword() {
      this.word("number");
    }
    function TSObjectKeyword() {
      this.word("object");
    }
    function TSBooleanKeyword() {
      this.word("boolean");
    }
    function TSStringKeyword() {
      this.word("string");
    }
    function TSSymbolKeyword() {
      this.word("symbol");
    }
    function TSVoidKeyword() {
      this.word("void");
    }
    function TSUndefinedKeyword() {
      this.word("undefined");
    }
    function TSNullKeyword() {
      this.word("null");
    }
    function TSNeverKeyword() {
      this.word("never");
    }
    function TSIntrinsicKeyword() {
      this.word("intrinsic");
    }
    function TSThisType() {
      this.word("this");
    }
    function TSFunctionType(node2) {
      this.tsPrintFunctionOrConstructorType(node2);
    }
    function TSConstructorType(node2) {
      if (node2["abstract"]) {
        this.word("abstract");
        this.space();
      }
      this.word("new");
      this.space();
      this.tsPrintFunctionOrConstructorType(node2);
    }
    function tsPrintFunctionOrConstructorType(node2) {
      var typeParameters = node2.typeParameters;
      var parameters = node2.parameters;
      this.print(typeParameters, node2);
      this.token("(");
      this._parameters(parameters, node2);
      this.token(")");
      this.space();
      this.token("=>");
      this.space();
      var returnType = node2.typeAnnotation;
      this.print(returnType.typeAnnotation, node2);
    }
    function TSTypeReference(node2) {
      this.print(node2.typeName, node2);
      this.print(node2.typeParameters, node2);
    }
    function TSTypePredicate(node2) {
      if (node2.asserts) {
        this.word("asserts");
        this.space();
      }
      this.print(node2.parameterName);
      if (node2.typeAnnotation) {
        this.space();
        this.word("is");
        this.space();
        this.print(node2.typeAnnotation.typeAnnotation);
      }
    }
    function TSTypeQuery(node2) {
      this.word("typeof");
      this.space();
      this.print(node2.exprName);
    }
    function TSTypeLiteral(node2) {
      this.tsPrintTypeLiteralOrInterfaceBody(node2.members, node2);
    }
    function tsPrintTypeLiteralOrInterfaceBody(members, node2) {
      this.tsPrintBraced(members, node2);
    }
    function tsPrintBraced(members, node2) {
      this.token("{");
      if (members.length) {
        this.indent();
        this.newline();
        for (var _iterator2 = _createForOfIteratorHelperLoose(members), _step2; !(_step2 = _iterator2()).done; ) {
          var member = _step2.value;
          this.print(member, node2);
          this.newline();
        }
        this.dedent();
        this.rightBrace();
      } else {
        this.token("}");
      }
    }
    function TSArrayType(node2) {
      this.print(node2.elementType, node2);
      this.token("[]");
    }
    function TSTupleType(node2) {
      this.token("[");
      this.printList(node2.elementTypes, node2);
      this.token("]");
    }
    function TSOptionalType(node2) {
      this.print(node2.typeAnnotation, node2);
      this.token("?");
    }
    function TSRestType(node2) {
      this.token("...");
      this.print(node2.typeAnnotation, node2);
    }
    function TSNamedTupleMember(node2) {
      this.print(node2.label, node2);
      if (node2.optional)
        this.token("?");
      this.token(":");
      this.space();
      this.print(node2.elementType, node2);
    }
    function TSUnionType(node2) {
      this.tsPrintUnionOrIntersectionType(node2, "|");
    }
    function TSIntersectionType(node2) {
      this.tsPrintUnionOrIntersectionType(node2, "&");
    }
    function tsPrintUnionOrIntersectionType(node2, sep2) {
      this.printJoin(node2.types, node2, {
        separator: function separator() {
          this.space();
          this.token(sep2);
          this.space();
        }
      });
    }
    function TSConditionalType(node2) {
      this.print(node2.checkType);
      this.space();
      this.word("extends");
      this.space();
      this.print(node2.extendsType);
      this.space();
      this.token("?");
      this.space();
      this.print(node2.trueType);
      this.space();
      this.token(":");
      this.space();
      this.print(node2.falseType);
    }
    function TSInferType(node2) {
      this.token("infer");
      this.space();
      this.print(node2.typeParameter);
    }
    function TSParenthesizedType(node2) {
      this.token("(");
      this.print(node2.typeAnnotation, node2);
      this.token(")");
    }
    function TSTypeOperator(node2) {
      this.word(node2.operator);
      this.space();
      this.print(node2.typeAnnotation, node2);
    }
    function TSIndexedAccessType(node2) {
      this.print(node2.objectType, node2);
      this.token("[");
      this.print(node2.indexType, node2);
      this.token("]");
    }
    function TSMappedType(node2) {
      var nameType = node2.nameType, optional = node2.optional, readonly = node2.readonly, typeParameter2 = node2.typeParameter;
      this.token("{");
      this.space();
      if (readonly) {
        tokenIfPlusMinus(this, readonly);
        this.word("readonly");
        this.space();
      }
      this.token("[");
      this.word(typeParameter2.name);
      this.space();
      this.word("in");
      this.space();
      this.print(typeParameter2.constraint, typeParameter2);
      if (nameType) {
        this.space();
        this.word("as");
        this.space();
        this.print(nameType, node2);
      }
      this.token("]");
      if (optional) {
        tokenIfPlusMinus(this, optional);
        this.token("?");
      }
      this.token(":");
      this.space();
      this.print(node2.typeAnnotation, node2);
      this.space();
      this.token("}");
    }
    function tokenIfPlusMinus(self2, tok) {
      if (tok !== true) {
        self2.token(tok);
      }
    }
    function TSLiteralType(node2) {
      this.print(node2.literal, node2);
    }
    function TSExpressionWithTypeArguments(node2) {
      this.print(node2.expression, node2);
      this.print(node2.typeParameters, node2);
    }
    function TSInterfaceDeclaration(node2) {
      var declare2 = node2.declare, id3 = node2.id, typeParameters = node2.typeParameters, extendz = node2["extends"], body = node2.body;
      if (declare2) {
        this.word("declare");
        this.space();
      }
      this.word("interface");
      this.space();
      this.print(id3, node2);
      this.print(typeParameters, node2);
      if (extendz != null && extendz.length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(extendz, node2);
      }
      this.space();
      this.print(body, node2);
    }
    function TSInterfaceBody(node2) {
      this.tsPrintTypeLiteralOrInterfaceBody(node2.body, node2);
    }
    function TSTypeAliasDeclaration(node2) {
      var declare2 = node2.declare, id3 = node2.id, typeParameters = node2.typeParameters, typeAnnotation2 = node2.typeAnnotation;
      if (declare2) {
        this.word("declare");
        this.space();
      }
      this.word("type");
      this.space();
      this.print(id3, node2);
      this.print(typeParameters, node2);
      this.space();
      this.token("=");
      this.space();
      this.print(typeAnnotation2, node2);
      this.token(";");
    }
    function TSAsExpression(node2) {
      var expression2 = node2.expression, typeAnnotation2 = node2.typeAnnotation;
      this.print(expression2, node2);
      this.space();
      this.word("as");
      this.space();
      this.print(typeAnnotation2, node2);
    }
    function TSTypeAssertion(node2) {
      var typeAnnotation2 = node2.typeAnnotation, expression2 = node2.expression;
      this.token("<");
      this.print(typeAnnotation2, node2);
      this.token(">");
      this.space();
      this.print(expression2, node2);
    }
    function TSEnumDeclaration(node2) {
      var declare2 = node2.declare, isConst = node2["const"], id3 = node2.id, members = node2.members;
      if (declare2) {
        this.word("declare");
        this.space();
      }
      if (isConst) {
        this.word("const");
        this.space();
      }
      this.word("enum");
      this.space();
      this.print(id3, node2);
      this.space();
      this.tsPrintBraced(members, node2);
    }
    function TSEnumMember(node2) {
      var id3 = node2.id, initializer = node2.initializer;
      this.print(id3, node2);
      if (initializer) {
        this.space();
        this.token("=");
        this.space();
        this.print(initializer, node2);
      }
      this.token(",");
    }
    function TSModuleDeclaration(node2) {
      var declare2 = node2.declare, id3 = node2.id;
      if (declare2) {
        this.word("declare");
        this.space();
      }
      if (!node2.global) {
        this.word(id3.type === "Identifier" ? "namespace" : "module");
        this.space();
      }
      this.print(id3, node2);
      if (!node2.body) {
        this.token(";");
        return;
      }
      var body = node2.body;
      while (body.type === "TSModuleDeclaration") {
        this.token(".");
        this.print(body.id, body);
        body = body.body;
      }
      this.space();
      this.print(body, node2);
    }
    function TSModuleBlock(node2) {
      this.tsPrintBraced(node2.body, node2);
    }
    function TSImportType(node2) {
      var argument = node2.argument, qualifier = node2.qualifier, typeParameters = node2.typeParameters;
      this.word("import");
      this.token("(");
      this.print(argument, node2);
      this.token(")");
      if (qualifier) {
        this.token(".");
        this.print(qualifier, node2);
      }
      if (typeParameters) {
        this.print(typeParameters, node2);
      }
    }
    function TSImportEqualsDeclaration(node2) {
      var isExport = node2.isExport, id3 = node2.id, moduleReference = node2.moduleReference;
      if (isExport) {
        this.word("export");
        this.space();
      }
      this.word("import");
      this.space();
      this.print(id3, node2);
      this.space();
      this.token("=");
      this.space();
      this.print(moduleReference, node2);
      this.token(";");
    }
    function TSExternalModuleReference(node2) {
      this.token("require(");
      this.print(node2.expression, node2);
      this.token(")");
    }
    function TSNonNullExpression(node2) {
      this.print(node2.expression, node2);
      this.token("!");
    }
    function TSExportAssignment(node2) {
      this.word("export");
      this.space();
      this.token("=");
      this.space();
      this.print(node2.expression, node2);
      this.token(";");
    }
    function TSNamespaceExportDeclaration(node2) {
      this.word("export");
      this.space();
      this.word("as");
      this.space();
      this.word("namespace");
      this.space();
      this.print(node2.id, node2);
    }
    function tsPrintSignatureDeclarationBase(node2) {
      var typeParameters = node2.typeParameters;
      var parameters = node2.parameters;
      this.print(typeParameters, node2);
      this.token("(");
      this._parameters(parameters, node2);
      this.token(")");
      var returnType = node2.typeAnnotation;
      this.print(returnType, node2);
    }
    function tsPrintClassMemberModifiers(node2, isField) {
      if (isField && node2.declare) {
        this.word("declare");
        this.space();
      }
      if (node2.accessibility) {
        this.word(node2.accessibility);
        this.space();
      }
      if (node2["static"]) {
        this.word("static");
        this.space();
      }
      if (node2.override) {
        this.word("override");
        this.space();
      }
      if (node2["abstract"]) {
        this.word("abstract");
        this.space();
      }
      if (isField && node2.readonly) {
        this.word("readonly");
        this.space();
      }
    }
    var generatorFunctions = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      TaggedTemplateExpression: TaggedTemplateExpression$1,
      TemplateElement,
      TemplateLiteral: TemplateLiteral$1,
      UnaryExpression: UnaryExpression$1,
      DoExpression,
      ParenthesizedExpression: ParenthesizedExpression$1,
      UpdateExpression: UpdateExpression$1,
      ConditionalExpression: ConditionalExpression$1,
      NewExpression: NewExpression$1,
      SequenceExpression: SequenceExpression$1,
      ThisExpression,
      Super,
      Decorator,
      OptionalMemberExpression,
      OptionalCallExpression,
      CallExpression: CallExpression$1,
      Import,
      YieldExpression,
      AwaitExpression,
      EmptyStatement,
      ExpressionStatement,
      AssignmentPattern,
      AssignmentExpression: AssignmentExpression$1,
      BindExpression,
      BinaryExpression: AssignmentExpression$1,
      LogicalExpression: AssignmentExpression$1,
      MemberExpression,
      MetaProperty,
      PrivateName,
      V8IntrinsicIdentifier,
      ModuleExpression,
      WithStatement,
      IfStatement,
      ForStatement,
      WhileStatement,
      ForInStatement,
      ForOfStatement,
      DoWhileStatement,
      ContinueStatement,
      ReturnStatement,
      BreakStatement,
      ThrowStatement,
      LabeledStatement,
      TryStatement,
      CatchClause,
      SwitchStatement,
      SwitchCase,
      DebuggerStatement,
      VariableDeclaration,
      VariableDeclarator: VariableDeclarator$1,
      ClassDeclaration,
      ClassExpression: ClassDeclaration,
      ClassBody,
      ClassProperty,
      ClassAccessorProperty,
      ClassPrivateProperty,
      ClassMethod,
      ClassPrivateMethod,
      _classMethodHead,
      StaticBlock,
      _params,
      _parameters,
      _param,
      _methodHead,
      _predicate,
      _functionHead,
      FunctionExpression,
      FunctionDeclaration: FunctionExpression,
      ArrowFunctionExpression,
      ImportSpecifier,
      ImportDefaultSpecifier,
      ExportDefaultSpecifier,
      ExportSpecifier,
      ExportNamespaceSpecifier,
      ExportAllDeclaration,
      ExportNamedDeclaration,
      ExportDefaultDeclaration,
      ImportDeclaration,
      ImportAttribute,
      ImportNamespaceSpecifier,
      Identifier,
      ArgumentPlaceholder,
      RestElement: RestElement$1,
      SpreadElement: RestElement$1,
      ObjectExpression: ObjectExpression$1,
      ObjectPattern: ObjectExpression$1,
      ObjectMethod,
      ObjectProperty,
      ArrayExpression: ArrayExpression$1,
      ArrayPattern: ArrayExpression$1,
      RecordExpression,
      TupleExpression,
      RegExpLiteral: RegExpLiteral$1,
      BooleanLiteral: BooleanLiteral$1,
      NullLiteral: NullLiteral$1,
      NumericLiteral: NumericLiteral$1,
      StringLiteral: StringLiteral$1,
      BigIntLiteral,
      DecimalLiteral,
      TopicReference,
      PipelineTopicExpression,
      PipelineBareFunction,
      PipelinePrimaryTopicReference,
      NumberLiteralTypeAnnotation: NumericLiteral$1,
      StringLiteralTypeAnnotation: StringLiteral$1,
      AnyTypeAnnotation,
      ArrayTypeAnnotation,
      BooleanTypeAnnotation,
      BooleanLiteralTypeAnnotation,
      NullLiteralTypeAnnotation,
      DeclareClass,
      DeclareFunction,
      InferredPredicate,
      DeclaredPredicate,
      DeclareInterface,
      DeclareModule,
      DeclareModuleExports,
      DeclareTypeAlias,
      DeclareOpaqueType,
      DeclareVariable,
      DeclareExportDeclaration,
      DeclareExportAllDeclaration,
      EnumDeclaration,
      EnumBooleanBody,
      EnumNumberBody,
      EnumStringBody,
      EnumSymbolBody,
      EnumDefaultedMember,
      EnumBooleanMember,
      EnumNumberMember,
      EnumStringMember,
      ExistsTypeAnnotation,
      FunctionTypeAnnotation,
      FunctionTypeParam,
      InterfaceExtends,
      ClassImplements: InterfaceExtends,
      GenericTypeAnnotation: InterfaceExtends,
      _interfaceish,
      _variance,
      InterfaceDeclaration,
      InterfaceTypeAnnotation,
      IntersectionTypeAnnotation,
      MixedTypeAnnotation,
      EmptyTypeAnnotation,
      NullableTypeAnnotation,
      NumberTypeAnnotation,
      StringTypeAnnotation,
      ThisTypeAnnotation,
      TupleTypeAnnotation,
      TypeofTypeAnnotation,
      TypeAlias,
      TypeAnnotation,
      TypeParameterInstantiation,
      TypeParameterDeclaration: TypeParameterInstantiation,
      TypeParameter,
      OpaqueType,
      ObjectTypeAnnotation,
      ObjectTypeInternalSlot,
      ObjectTypeCallProperty,
      ObjectTypeIndexer,
      ObjectTypeProperty,
      ObjectTypeSpreadProperty,
      QualifiedTypeIdentifier,
      SymbolTypeAnnotation,
      UnionTypeAnnotation,
      TypeCastExpression: TypeCastExpression$1,
      Variance,
      VoidTypeAnnotation,
      IndexedAccessType,
      OptionalIndexedAccessType,
      File: File$1,
      Program,
      BlockStatement,
      Directive,
      DirectiveLiteral,
      InterpreterDirective,
      Placeholder,
      JSXAttribute,
      JSXIdentifier,
      JSXNamespacedName,
      JSXMemberExpression,
      JSXSpreadAttribute,
      JSXExpressionContainer,
      JSXSpreadChild,
      JSXText,
      JSXElement,
      JSXOpeningElement,
      JSXClosingElement,
      JSXEmptyExpression,
      JSXFragment,
      JSXOpeningFragment,
      JSXClosingFragment,
      TSTypeAnnotation,
      TSTypeParameterInstantiation,
      TSTypeParameterDeclaration: TSTypeParameterInstantiation,
      TSTypeParameter,
      TSParameterProperty,
      TSDeclareFunction,
      TSDeclareMethod,
      TSQualifiedName,
      TSCallSignatureDeclaration,
      TSConstructSignatureDeclaration,
      TSPropertySignature,
      tsPrintPropertyOrMethodName,
      TSMethodSignature,
      TSIndexSignature,
      TSAnyKeyword,
      TSBigIntKeyword,
      TSUnknownKeyword,
      TSNumberKeyword,
      TSObjectKeyword,
      TSBooleanKeyword,
      TSStringKeyword,
      TSSymbolKeyword,
      TSVoidKeyword,
      TSUndefinedKeyword,
      TSNullKeyword,
      TSNeverKeyword,
      TSIntrinsicKeyword,
      TSThisType,
      TSFunctionType,
      TSConstructorType,
      tsPrintFunctionOrConstructorType,
      TSTypeReference,
      TSTypePredicate,
      TSTypeQuery,
      TSTypeLiteral,
      tsPrintTypeLiteralOrInterfaceBody,
      tsPrintBraced,
      TSArrayType,
      TSTupleType,
      TSOptionalType,
      TSRestType,
      TSNamedTupleMember,
      TSUnionType,
      TSIntersectionType,
      tsPrintUnionOrIntersectionType,
      TSConditionalType,
      TSInferType,
      TSParenthesizedType,
      TSTypeOperator,
      TSIndexedAccessType,
      TSMappedType,
      TSLiteralType,
      TSExpressionWithTypeArguments,
      TSInterfaceDeclaration,
      TSInterfaceBody,
      TSTypeAliasDeclaration,
      TSAsExpression,
      TSTypeAssertion,
      TSEnumDeclaration,
      TSEnumMember,
      TSModuleDeclaration,
      TSModuleBlock,
      TSImportType,
      TSImportEqualsDeclaration,
      TSExternalModuleReference,
      TSNonNullExpression,
      TSExportAssignment,
      TSNamespaceExportDeclaration,
      tsPrintSignatureDeclarationBase,
      tsPrintClassMemberModifiers
    });
    var isProgram$1 = isProgram$2, isFile = isFile$1, isEmptyStatement = isEmptyStatement$1;
    var SCIENTIFIC_NOTATION = /e/i;
    var ZERO_DECIMAL_INTEGER = /\.0+$/;
    var NON_DECIMAL_LITERAL = /^0[box]/;
    var PURE_ANNOTATION_RE = /^\s*[@#]__PURE__\s*$/;
    var needsParens = needsParens$1, needsWhitespaceAfter = needsWhitespaceAfter$1, needsWhitespaceBefore = needsWhitespaceBefore$1;
    var Printer = function() {
      function Printer2(format2, map2) {
        this.inForStatementInitCounter = 0;
        this._printStack = [];
        this._indent = 0;
        this._insideAux = false;
        this._parenPushNewlineState = null;
        this._noLineTerminator = false;
        this._printAuxAfterOnNextUserNode = false;
        this._printedComments = /* @__PURE__ */ new WeakSet();
        this._endsWithInteger = false;
        this._endsWithWord = false;
        this.format = format2;
        this._buf = new Buffer2(map2);
      }
      var _proto = Printer2.prototype;
      _proto.generate = function generate3(ast3) {
        this.print(ast3);
        this._maybeAddAuxComment();
        return this._buf.get();
      };
      _proto.indent = function indent() {
        if (this.format.compact || this.format.concise)
          return;
        this._indent++;
      };
      _proto.dedent = function dedent() {
        if (this.format.compact || this.format.concise)
          return;
        this._indent--;
      };
      _proto.semicolon = function semicolon(force) {
        if (force === void 0) {
          force = false;
        }
        this._maybeAddAuxComment();
        this._append(";", !force);
      };
      _proto.rightBrace = function rightBrace() {
        if (this.format.minified) {
          this._buf.removeLastSemicolon();
        }
        this.token("}");
      };
      _proto.space = function space(force) {
        if (force === void 0) {
          force = false;
        }
        if (this.format.compact)
          return;
        if (force) {
          this._space();
        } else if (this._buf.hasContent()) {
          var lastCp = this.getLastChar();
          if (lastCp !== 32 && lastCp !== 10) {
            this._space();
          }
        }
      };
      _proto.word = function word(str) {
        if (this._endsWithWord || this.endsWith(47) && str.charCodeAt(0) === 47) {
          this._space();
        }
        this._maybeAddAuxComment();
        this._append(str);
        this._endsWithWord = true;
      };
      _proto.number = function number4(str) {
        this.word(str);
        this._endsWithInteger = Number.isInteger(+str) && !NON_DECIMAL_LITERAL.test(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
      };
      _proto.token = function token(str) {
        var lastChar = this.getLastChar();
        var strFirst = str.charCodeAt(0);
        if (str === "--" && lastChar === 33 || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
          this._space();
        }
        this._maybeAddAuxComment();
        this._append(str);
      };
      _proto.newline = function newline(i2) {
        if (i2 === void 0) {
          i2 = 1;
        }
        if (this.format.retainLines || this.format.compact)
          return;
        if (this.format.concise) {
          this.space();
          return;
        }
        var charBeforeNewline = this.endsWithCharAndNewline();
        if (charBeforeNewline === 10)
          return;
        if (charBeforeNewline === 123 || charBeforeNewline === 58) {
          i2--;
        }
        if (i2 <= 0)
          return;
        for (var j = 0; j < i2; j++) {
          this._newline();
        }
      };
      _proto.endsWith = function endsWith(_char) {
        return this.getLastChar() === _char;
      };
      _proto.getLastChar = function getLastChar() {
        return this._buf.getLastChar();
      };
      _proto.endsWithCharAndNewline = function endsWithCharAndNewline() {
        return this._buf.endsWithCharAndNewline();
      };
      _proto.removeTrailingNewline = function removeTrailingNewline() {
        this._buf.removeTrailingNewline();
      };
      _proto.exactSource = function exactSource(loc, cb2) {
        this._catchUp("start", loc);
        this._buf.exactSource(loc, cb2);
      };
      _proto.source = function source(prop2, loc) {
        this._catchUp(prop2, loc);
        this._buf.source(prop2, loc);
      };
      _proto.withSource = function withSource(prop2, loc, cb2) {
        this._catchUp(prop2, loc);
        this._buf.withSource(prop2, loc, cb2);
      };
      _proto._space = function _space() {
        this._append(" ", true);
      };
      _proto._newline = function _newline() {
        this._append("\n", true);
      };
      _proto._append = function _append(str, queue2) {
        if (queue2 === void 0) {
          queue2 = false;
        }
        this._maybeAddParen(str);
        this._maybeIndent(str);
        if (queue2)
          this._buf.queue(str);
        else
          this._buf.append(str);
        this._endsWithWord = false;
        this._endsWithInteger = false;
      };
      _proto._maybeIndent = function _maybeIndent(str) {
        if (this._indent && this.endsWith(10) && str.charCodeAt(0) !== 10) {
          this._buf.queueIndentation(this._getIndent());
        }
      };
      _proto._maybeAddParen = function _maybeAddParen(str) {
        var parenPushNewlineState = this._parenPushNewlineState;
        if (!parenPushNewlineState)
          return;
        var i2;
        for (i2 = 0; i2 < str.length && str[i2] === " "; i2++) {
          continue;
        }
        if (i2 === str.length) {
          return;
        }
        var cha = str[i2];
        if (cha !== "\n") {
          if (cha !== "/" || i2 + 1 === str.length) {
            this._parenPushNewlineState = null;
            return;
          }
          var chaPost = str[i2 + 1];
          if (chaPost === "*") {
            if (PURE_ANNOTATION_RE.test(str.slice(i2 + 2, str.length - 2))) {
              return;
            }
          } else if (chaPost !== "/") {
            this._parenPushNewlineState = null;
            return;
          }
        }
        this.token("(");
        this.indent();
        parenPushNewlineState.printed = true;
      };
      _proto._catchUp = function _catchUp(prop2, loc) {
        if (!this.format.retainLines)
          return;
        var pos = loc ? loc[prop2] : null;
        if ((pos == null ? void 0 : pos.line) != null) {
          var count2 = pos.line - this._buf.getCurrentLine();
          for (var i2 = 0; i2 < count2; i2++) {
            this._newline();
          }
        }
      };
      _proto._getIndent = function _getIndent() {
        return this.format.indent.style.repeat(this._indent);
      };
      _proto.startTerminatorless = function startTerminatorless(isLabel) {
        if (isLabel === void 0) {
          isLabel = false;
        }
        if (isLabel) {
          this._noLineTerminator = true;
          return null;
        } else {
          return this._parenPushNewlineState = {
            printed: false
          };
        }
      };
      _proto.endTerminatorless = function endTerminatorless(state) {
        this._noLineTerminator = false;
        if (state != null && state.printed) {
          this.dedent();
          this.newline();
          this.token(")");
        }
      };
      _proto.print = function print(node2, parent) {
        var _this = this;
        if (!node2)
          return;
        var oldConcise = this.format.concise;
        if (node2._compact) {
          this.format.concise = true;
        }
        var printMethod = this[node2.type];
        if (!printMethod) {
          throw new ReferenceError("unknown node of type " + JSON.stringify(node2.type) + " with constructor " + JSON.stringify(node2 == null ? void 0 : node2.constructor.name));
        }
        this._printStack.push(node2);
        var oldInAux = this._insideAux;
        this._insideAux = !node2.loc;
        this._maybeAddAuxComment(this._insideAux && !oldInAux);
        var shouldPrintParens = needsParens(node2, parent, this._printStack);
        if (this.format.retainFunctionParens && node2.type === "FunctionExpression" && node2.extra && node2.extra.parenthesized) {
          shouldPrintParens = true;
        }
        if (shouldPrintParens)
          this.token("(");
        this._printLeadingComments(node2);
        var loc = isProgram$1(node2) || isFile(node2) ? null : node2.loc;
        this.withSource("start", loc, function() {
          printMethod.call(_this, node2, parent);
        });
        this._printTrailingComments(node2);
        if (shouldPrintParens)
          this.token(")");
        this._printStack.pop();
        this.format.concise = oldConcise;
        this._insideAux = oldInAux;
      };
      _proto._maybeAddAuxComment = function _maybeAddAuxComment(enteredPositionlessNode) {
        if (enteredPositionlessNode)
          this._printAuxBeforeComment();
        if (!this._insideAux)
          this._printAuxAfterComment();
      };
      _proto._printAuxBeforeComment = function _printAuxBeforeComment() {
        if (this._printAuxAfterOnNextUserNode)
          return;
        this._printAuxAfterOnNextUserNode = true;
        var comment = this.format.auxiliaryCommentBefore;
        if (comment) {
          this._printComment({
            type: "CommentBlock",
            value: comment
          });
        }
      };
      _proto._printAuxAfterComment = function _printAuxAfterComment() {
        if (!this._printAuxAfterOnNextUserNode)
          return;
        this._printAuxAfterOnNextUserNode = false;
        var comment = this.format.auxiliaryCommentAfter;
        if (comment) {
          this._printComment({
            type: "CommentBlock",
            value: comment
          });
        }
      };
      _proto.getPossibleRaw = function getPossibleRaw(node2) {
        var extra = node2.extra;
        if (extra && extra.raw != null && extra.rawValue != null && node2.value === extra.rawValue) {
          return extra.raw;
        }
      };
      _proto.printJoin = function printJoin(nodes2, parent, opts) {
        if (opts === void 0) {
          opts = {};
        }
        if (!(nodes2 != null && nodes2.length))
          return;
        if (opts.indent)
          this.indent();
        var newlineOpts = {
          addNewlines: opts.addNewlines
        };
        for (var i2 = 0; i2 < nodes2.length; i2++) {
          var node2 = nodes2[i2];
          if (!node2)
            continue;
          if (opts.statement)
            this._printNewline(true, node2, parent, newlineOpts);
          this.print(node2, parent);
          if (opts.iterator) {
            opts.iterator(node2, i2);
          }
          if (opts.separator && i2 < nodes2.length - 1) {
            opts.separator.call(this);
          }
          if (opts.statement)
            this._printNewline(false, node2, parent, newlineOpts);
        }
        if (opts.indent)
          this.dedent();
      };
      _proto.printAndIndentOnComments = function printAndIndentOnComments(node2, parent) {
        var indent = node2.leadingComments && node2.leadingComments.length > 0;
        if (indent)
          this.indent();
        this.print(node2, parent);
        if (indent)
          this.dedent();
      };
      _proto.printBlock = function printBlock(parent) {
        var node2 = parent.body;
        if (!isEmptyStatement(node2)) {
          this.space();
        }
        this.print(node2, parent);
      };
      _proto._printTrailingComments = function _printTrailingComments(node2) {
        this._printComments(this._getComments(false, node2));
      };
      _proto._printLeadingComments = function _printLeadingComments(node2) {
        this._printComments(this._getComments(true, node2), true);
      };
      _proto.printInnerComments = function printInnerComments(node2, indent) {
        var _node$innerComments;
        if (indent === void 0) {
          indent = true;
        }
        if (!((_node$innerComments = node2.innerComments) != null && _node$innerComments.length))
          return;
        if (indent)
          this.indent();
        this._printComments(node2.innerComments);
        if (indent)
          this.dedent();
      };
      _proto.printSequence = function printSequence(nodes2, parent, opts) {
        if (opts === void 0) {
          opts = {};
        }
        opts.statement = true;
        return this.printJoin(nodes2, parent, opts);
      };
      _proto.printList = function printList(items, parent, opts) {
        if (opts === void 0) {
          opts = {};
        }
        if (opts.separator == null) {
          opts.separator = commaSeparator;
        }
        return this.printJoin(items, parent, opts);
      };
      _proto._printNewline = function _printNewline(leading, node2, parent, opts) {
        if (this.format.retainLines || this.format.compact)
          return;
        if (this.format.concise) {
          this.space();
          return;
        }
        var lines = 0;
        if (this._buf.hasContent()) {
          if (!leading)
            lines++;
          if (opts.addNewlines)
            lines += opts.addNewlines(leading, node2) || 0;
          var needs = leading ? needsWhitespaceBefore : needsWhitespaceAfter;
          if (needs(node2, parent))
            lines++;
        }
        this.newline(Math.min(2, lines));
      };
      _proto._getComments = function _getComments(leading, node2) {
        return node2 && (leading ? node2.leadingComments : node2.trailingComments) || [];
      };
      _proto._printComment = function _printComment(comment, skipNewLines) {
        var _this2 = this;
        if (!this.format.shouldPrintComment(comment.value))
          return;
        if (comment.ignore)
          return;
        if (this._printedComments.has(comment))
          return;
        this._printedComments.add(comment);
        var isBlockComment = comment.type === "CommentBlock";
        var printNewLines = isBlockComment && !skipNewLines && !this._noLineTerminator;
        if (printNewLines && this._buf.hasContent())
          this.newline(1);
        var lastCharCode = this.getLastChar();
        if (lastCharCode !== 91 && lastCharCode !== 123) {
          this.space();
        }
        var val = !isBlockComment && !this._noLineTerminator ? "//" + comment.value + "\n" : "/*" + comment.value + "*/";
        if (isBlockComment && this.format.indent.adjustMultilineComment) {
          var _comment$loc;
          var offset3 = (_comment$loc = comment.loc) == null ? void 0 : _comment$loc.start.column;
          if (offset3) {
            var newlineRegex = new RegExp("\\n\\s{1," + offset3 + "}", "g");
            val = val.replace(newlineRegex, "\n");
          }
          var indentSize = Math.max(this._getIndent().length, this.format.retainLines ? 0 : this._buf.getCurrentColumn());
          val = val.replace(/\n(?!$)/g, "\n" + " ".repeat(indentSize));
        }
        if (this.endsWith(47))
          this._space();
        this.withSource("start", comment.loc, function() {
          _this2._append(val);
        });
        if (printNewLines)
          this.newline(1);
      };
      _proto._printComments = function _printComments(comments, inlinePureAnnotation) {
        if (!(comments != null && comments.length))
          return;
        if (inlinePureAnnotation && comments.length === 1 && PURE_ANNOTATION_RE.test(comments[0].value)) {
          this._printComment(comments[0], this._buf.hasContent() && !this.endsWith(10));
        } else {
          for (var _iterator2 = _createForOfIteratorHelperLoose(comments), _step2; !(_step2 = _iterator2()).done; ) {
            var _comment = _step2.value;
            this._printComment(_comment);
          }
        }
      };
      _proto.printAssertions = function printAssertions(node2) {
        var _node$assertions;
        if ((_node$assertions = node2.assertions) != null && _node$assertions.length) {
          this.space();
          this.word("assert");
          this.space();
          this.token("{");
          this.space();
          this.printList(node2.assertions, node2);
          this.space();
          this.token("}");
        }
      };
      return _createClass2(Printer2);
    }();
    Object.assign(Printer.prototype, generatorFunctions);
    {
      Printer.prototype.Noop = function Noop() {
      };
    }
    function commaSeparator() {
      this.token(",");
      this.space();
    }
    var Generator = function(_Printer) {
      _inherits2(Generator2, _Printer);
      function Generator2(ast3, opts, code3) {
        var _this;
        if (opts === void 0) {
          opts = {};
        }
        var format2 = normalizeOptions$6(code3, opts);
        var map2 = opts.sourceMaps ? new SourceMap$1(opts, code3) : null;
        _this = _Printer.call(this, format2, map2) || this;
        _this.ast = void 0;
        _this.ast = ast3;
        return _this;
      }
      var _proto = Generator2.prototype;
      _proto.generate = function generate3() {
        return _Printer.prototype.generate.call(this, this.ast);
      };
      return _createClass2(Generator2);
    }(Printer);
    function normalizeOptions$6(code3, opts) {
      var format2 = {
        auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
        auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
        shouldPrintComment: opts.shouldPrintComment,
        retainLines: opts.retainLines,
        retainFunctionParens: opts.retainFunctionParens,
        comments: opts.comments == null || opts.comments,
        compact: opts.compact,
        minified: opts.minified,
        concise: opts.concise,
        indent: {
          adjustMultilineComment: true,
          style: "  ",
          base: 0
        },
        decoratorsBeforeExport: !!opts.decoratorsBeforeExport,
        jsescOption: Object.assign({
          quotes: "double",
          wrap: true,
          minimal: false
        }, opts.jsescOption),
        recordAndTupleSyntaxType: opts.recordAndTupleSyntaxType,
        topicToken: opts.topicToken
      };
      {
        format2.jsonCompatibleStrings = opts.jsonCompatibleStrings;
      }
      if (format2.minified) {
        format2.compact = true;
        format2.shouldPrintComment = format2.shouldPrintComment || function() {
          return format2.comments;
        };
      } else {
        format2.shouldPrintComment = format2.shouldPrintComment || function(value) {
          return format2.comments || value.indexOf("@license") >= 0 || value.indexOf("@preserve") >= 0;
        };
      }
      if (format2.compact === "auto") {
        format2.compact = code3.length > 5e5;
        if (format2.compact) {
          console.error("[BABEL] Note: The code generator has deoptimised the styling of " + (opts.filename + " as it exceeds the max of 500KB."));
        }
      }
      if (format2.compact) {
        format2.indent.adjustMultilineComment = false;
      }
      return format2;
    }
    (function() {
      function CodeGenerator(ast3, opts, code3) {
        this._generator = void 0;
        this._generator = new Generator(ast3, opts, code3);
      }
      var _proto2 = CodeGenerator.prototype;
      _proto2.generate = function generate3() {
        return this._generator.generate();
      };
      return _createClass2(CodeGenerator);
    })();
    function generate$12(ast3, opts, code3) {
      var gen = new Generator(ast3, opts, code3);
      return gen.generate();
    }
    var VISITOR_KEYS$5 = VISITOR_KEYS$7;
    function findParent(callback) {
      var path2 = this;
      while (path2 = path2.parentPath) {
        if (callback(path2))
          return path2;
      }
      return null;
    }
    function find$1(callback) {
      var path2 = this;
      do {
        if (callback(path2))
          return path2;
      } while (path2 = path2.parentPath);
      return null;
    }
    function getFunctionParent() {
      return this.findParent(function(p2) {
        return p2.isFunction();
      });
    }
    function getStatementParent() {
      var path2 = this;
      do {
        if (!path2.parentPath || Array.isArray(path2.container) && path2.isStatement()) {
          break;
        } else {
          path2 = path2.parentPath;
        }
      } while (path2);
      if (path2 && (path2.isProgram() || path2.isFile())) {
        throw new Error("File/Program node, we can't possibly find a statement parent to this");
      }
      return path2;
    }
    function getEarliestCommonAncestorFrom(paths) {
      return this.getDeepestCommonAncestorFrom(paths, function(deepest, i2, ancestries) {
        var earliest;
        var keys2 = VISITOR_KEYS$5[deepest.type];
        for (var _iterator2 = _createForOfIteratorHelperLoose(ancestries), _step2; !(_step2 = _iterator2()).done; ) {
          var ancestry = _step2.value;
          var path2 = ancestry[i2 + 1];
          if (!earliest) {
            earliest = path2;
            continue;
          }
          if (path2.listKey && earliest.listKey === path2.listKey) {
            if (path2.key < earliest.key) {
              earliest = path2;
              continue;
            }
          }
          var earliestKeyIndex = keys2.indexOf(earliest.parentKey);
          var currentKeyIndex = keys2.indexOf(path2.parentKey);
          if (earliestKeyIndex > currentKeyIndex) {
            earliest = path2;
          }
        }
        return earliest;
      });
    }
    function getDeepestCommonAncestorFrom(paths, filter3) {
      var _this = this;
      if (!paths.length) {
        return this;
      }
      if (paths.length === 1) {
        return paths[0];
      }
      var minDepth = Infinity;
      var lastCommonIndex, lastCommon;
      var ancestries = paths.map(function(path2) {
        var ancestry2 = [];
        do {
          ancestry2.unshift(path2);
        } while ((path2 = path2.parentPath) && path2 !== _this);
        if (ancestry2.length < minDepth) {
          minDepth = ancestry2.length;
        }
        return ancestry2;
      });
      var first = ancestries[0];
      depthLoop:
        for (var _i3 = 0; _i3 < minDepth; _i3++) {
          var shouldMatch = first[_i3];
          for (var _iterator2 = _createForOfIteratorHelperLoose(ancestries), _step2; !(_step2 = _iterator2()).done; ) {
            var ancestry = _step2.value;
            if (ancestry[_i3] !== shouldMatch) {
              break depthLoop;
            }
          }
          lastCommonIndex = _i3;
          lastCommon = shouldMatch;
        }
      if (lastCommon) {
        if (filter3) {
          return filter3(lastCommon, lastCommonIndex, ancestries);
        } else {
          return lastCommon;
        }
      } else {
        throw new Error("Couldn't find intersection");
      }
    }
    function getAncestry() {
      var path2 = this;
      var paths = [];
      do {
        paths.push(path2);
      } while (path2 = path2.parentPath);
      return paths;
    }
    function isAncestor(maybeDescendant) {
      return maybeDescendant.isDescendant(this);
    }
    function isDescendant(maybeAncestor) {
      return !!this.findParent(function(parent) {
        return parent === maybeAncestor;
      });
    }
    function inType() {
      var path2 = this;
      for (var _len = arguments.length, candidateTypes = new Array(_len), _key = 0; _key < _len; _key++) {
        candidateTypes[_key] = arguments[_key];
      }
      while (path2) {
        for (var _iterator3 = _createForOfIteratorHelperLoose(candidateTypes), _step3; !(_step3 = _iterator3()).done; ) {
          var type5 = _step3.value;
          if (path2.node.type === type5)
            return true;
        }
        path2 = path2.parentPath;
      }
      return false;
    }
    var NodePath_ancestry = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      findParent,
      find: find$1,
      getFunctionParent,
      getStatementParent,
      getEarliestCommonAncestorFrom,
      getDeepestCommonAncestorFrom,
      getAncestry,
      isAncestor,
      isDescendant,
      inType
    });
    var BOOLEAN_NUMBER_BINARY_OPERATORS = BOOLEAN_NUMBER_BINARY_OPERATORS$1, createFlowUnionType$1 = createFlowUnionType$2, createTSUnionType$1 = createTSUnionType$2, createTypeAnnotationBasedOnTypeof = createTypeAnnotationBasedOnTypeof$1, createUnionTypeAnnotation$1 = createFlowUnionType$2, isTSTypeAnnotation$1 = isTSTypeAnnotation$2, numberTypeAnnotation$1 = numberTypeAnnotation$2, voidTypeAnnotation$2 = voidTypeAnnotation$3;
    function infererReference(node2) {
      if (!this.isReferenced())
        return;
      var binding2 = this.scope.getBinding(node2.name);
      if (binding2) {
        if (binding2.identifier.typeAnnotation) {
          return binding2.identifier.typeAnnotation;
        } else {
          return getTypeAnnotationBindingConstantViolations(binding2, this, node2.name);
        }
      }
      if (node2.name === "undefined") {
        return voidTypeAnnotation$2();
      } else if (node2.name === "NaN" || node2.name === "Infinity") {
        return numberTypeAnnotation$1();
      } else if (node2.name === "arguments")
        ;
    }
    function getTypeAnnotationBindingConstantViolations(binding2, path2, name2) {
      var types3 = [];
      var functionConstantViolations = [];
      var constantViolations = getConstantViolationsBefore(binding2, path2, functionConstantViolations);
      var testType = getConditionalAnnotation(binding2, path2, name2);
      if (testType) {
        var testConstantViolations = getConstantViolationsBefore(binding2, testType.ifStatement);
        constantViolations = constantViolations.filter(function(path3) {
          return testConstantViolations.indexOf(path3) < 0;
        });
        types3.push(testType.typeAnnotation);
      }
      if (constantViolations.length) {
        var _constantViolations;
        (_constantViolations = constantViolations).push.apply(_constantViolations, functionConstantViolations);
        for (var _iterator2 = _createForOfIteratorHelperLoose(constantViolations), _step2; !(_step2 = _iterator2()).done; ) {
          var violation = _step2.value;
          types3.push(violation.getTypeAnnotation());
        }
      }
      if (!types3.length) {
        return;
      }
      if (isTSTypeAnnotation$1(types3[0]) && createTSUnionType$1) {
        return createTSUnionType$1(types3);
      }
      if (createFlowUnionType$1) {
        return createFlowUnionType$1(types3);
      }
      return createUnionTypeAnnotation$1(types3);
    }
    function getConstantViolationsBefore(binding2, path2, functions) {
      var violations = binding2.constantViolations.slice();
      violations.unshift(binding2.path);
      return violations.filter(function(violation) {
        violation = violation.resolve();
        var status = violation._guessExecutionStatusRelativeTo(path2);
        if (functions && status === "unknown")
          functions.push(violation);
        return status === "before";
      });
    }
    function inferAnnotationFromBinaryExpression(name2, path2) {
      var operator = path2.node.operator;
      var right = path2.get("right").resolve();
      var left = path2.get("left").resolve();
      var target;
      if (left.isIdentifier({
        name: name2
      })) {
        target = right;
      } else if (right.isIdentifier({
        name: name2
      })) {
        target = left;
      }
      if (target) {
        if (operator === "===") {
          return target.getTypeAnnotation();
        }
        if (BOOLEAN_NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
          return numberTypeAnnotation$1();
        }
        return;
      }
      if (operator !== "===" && operator !== "==")
        return;
      var typeofPath;
      var typePath;
      if (left.isUnaryExpression({
        operator: "typeof"
      })) {
        typeofPath = left;
        typePath = right;
      } else if (right.isUnaryExpression({
        operator: "typeof"
      })) {
        typeofPath = right;
        typePath = left;
      }
      if (!typeofPath)
        return;
      if (!typeofPath.get("argument").isIdentifier({
        name: name2
      }))
        return;
      typePath = typePath.resolve();
      if (!typePath.isLiteral())
        return;
      var typeValue = typePath.node.value;
      if (typeof typeValue !== "string")
        return;
      return createTypeAnnotationBasedOnTypeof(typeValue);
    }
    function getParentConditionalPath(binding2, path2, name2) {
      var parentPath;
      while (parentPath = path2.parentPath) {
        if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
          if (path2.key === "test") {
            return;
          }
          return parentPath;
        }
        if (parentPath.isFunction()) {
          if (parentPath.parentPath.scope.getBinding(name2) !== binding2)
            return;
        }
        path2 = parentPath;
      }
    }
    function getConditionalAnnotation(binding2, path2, name2) {
      var ifStatement2 = getParentConditionalPath(binding2, path2, name2);
      if (!ifStatement2)
        return;
      var test = ifStatement2.get("test");
      var paths = [test];
      var types3 = [];
      for (var i2 = 0; i2 < paths.length; i2++) {
        var _path = paths[i2];
        if (_path.isLogicalExpression()) {
          if (_path.node.operator === "&&") {
            paths.push(_path.get("left"));
            paths.push(_path.get("right"));
          }
        } else if (_path.isBinaryExpression()) {
          var type5 = inferAnnotationFromBinaryExpression(name2, _path);
          if (type5)
            types3.push(type5);
        }
      }
      if (types3.length) {
        if (isTSTypeAnnotation$1(types3[0]) && createTSUnionType$1) {
          return {
            typeAnnotation: createTSUnionType$1(types3),
            ifStatement: ifStatement2
          };
        }
        if (createFlowUnionType$1) {
          return {
            typeAnnotation: createFlowUnionType$1(types3),
            ifStatement: ifStatement2
          };
        }
        return {
          typeAnnotation: createUnionTypeAnnotation$1(types3),
          ifStatement: ifStatement2
        };
      }
      return getConditionalAnnotation(ifStatement2, name2);
    }
    var BOOLEAN_BINARY_OPERATORS = BOOLEAN_BINARY_OPERATORS$1, BOOLEAN_UNARY_OPERATORS = BOOLEAN_UNARY_OPERATORS$1, NUMBER_BINARY_OPERATORS = NUMBER_BINARY_OPERATORS$1, NUMBER_UNARY_OPERATORS = NUMBER_UNARY_OPERATORS$1, STRING_UNARY_OPERATORS = STRING_UNARY_OPERATORS$1, anyTypeAnnotation$1 = anyTypeAnnotation$2, arrayTypeAnnotation = arrayTypeAnnotation$1, booleanTypeAnnotation = booleanTypeAnnotation$1, buildMatchMemberExpression = buildMatchMemberExpression$1, createFlowUnionType = createFlowUnionType$2, createTSUnionType = createTSUnionType$2, createUnionTypeAnnotation = createFlowUnionType$2, genericTypeAnnotation = genericTypeAnnotation$1, identifier$g = identifier$j, isTSTypeAnnotation = isTSTypeAnnotation$2, nullLiteralTypeAnnotation = nullLiteralTypeAnnotation$1, numberTypeAnnotation = numberTypeAnnotation$2, stringTypeAnnotation$1 = stringTypeAnnotation$2, tupleTypeAnnotation = tupleTypeAnnotation$1, unionTypeAnnotation = unionTypeAnnotation$1, voidTypeAnnotation$1 = voidTypeAnnotation$3;
    function VariableDeclarator() {
      var _type;
      var id3 = this.get("id");
      if (!id3.isIdentifier())
        return;
      var init3 = this.get("init");
      var type5 = init3.getTypeAnnotation();
      if (((_type = type5) == null ? void 0 : _type.type) === "AnyTypeAnnotation") {
        if (init3.isCallExpression() && init3.get("callee").isIdentifier({
          name: "Array"
        }) && !init3.scope.hasBinding("Array", true)) {
          type5 = ArrayExpression();
        }
      }
      return type5;
    }
    function TypeCastExpression(node2) {
      return node2.typeAnnotation;
    }
    TypeCastExpression.validParent = true;
    function NewExpression(node2) {
      if (this.get("callee").isIdentifier()) {
        return genericTypeAnnotation(node2.callee);
      }
    }
    function TemplateLiteral() {
      return stringTypeAnnotation$1();
    }
    function UnaryExpression(node2) {
      var operator = node2.operator;
      if (operator === "void") {
        return voidTypeAnnotation$1();
      } else if (NUMBER_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return numberTypeAnnotation();
      } else if (STRING_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return stringTypeAnnotation$1();
      } else if (BOOLEAN_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return booleanTypeAnnotation();
      }
    }
    function BinaryExpression(node2) {
      var operator = node2.operator;
      if (NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
        return numberTypeAnnotation();
      } else if (BOOLEAN_BINARY_OPERATORS.indexOf(operator) >= 0) {
        return booleanTypeAnnotation();
      } else if (operator === "+") {
        var right = this.get("right");
        var left = this.get("left");
        if (left.isBaseType("number") && right.isBaseType("number")) {
          return numberTypeAnnotation();
        } else if (left.isBaseType("string") || right.isBaseType("string")) {
          return stringTypeAnnotation$1();
        }
        return unionTypeAnnotation([stringTypeAnnotation$1(), numberTypeAnnotation()]);
      }
    }
    function LogicalExpression() {
      var argumentTypes = [this.get("left").getTypeAnnotation(), this.get("right").getTypeAnnotation()];
      if (isTSTypeAnnotation(argumentTypes[0]) && createTSUnionType) {
        return createTSUnionType(argumentTypes);
      }
      if (createFlowUnionType) {
        return createFlowUnionType(argumentTypes);
      }
      return createUnionTypeAnnotation(argumentTypes);
    }
    function ConditionalExpression() {
      var argumentTypes = [this.get("consequent").getTypeAnnotation(), this.get("alternate").getTypeAnnotation()];
      if (isTSTypeAnnotation(argumentTypes[0]) && createTSUnionType) {
        return createTSUnionType(argumentTypes);
      }
      if (createFlowUnionType) {
        return createFlowUnionType(argumentTypes);
      }
      return createUnionTypeAnnotation(argumentTypes);
    }
    function SequenceExpression() {
      return this.get("expressions").pop().getTypeAnnotation();
    }
    function ParenthesizedExpression() {
      return this.get("expression").getTypeAnnotation();
    }
    function AssignmentExpression() {
      return this.get("right").getTypeAnnotation();
    }
    function UpdateExpression(node2) {
      var operator = node2.operator;
      if (operator === "++" || operator === "--") {
        return numberTypeAnnotation();
      }
    }
    function StringLiteral() {
      return stringTypeAnnotation$1();
    }
    function NumericLiteral() {
      return numberTypeAnnotation();
    }
    function BooleanLiteral() {
      return booleanTypeAnnotation();
    }
    function NullLiteral() {
      return nullLiteralTypeAnnotation();
    }
    function RegExpLiteral() {
      return genericTypeAnnotation(identifier$g("RegExp"));
    }
    function ObjectExpression() {
      return genericTypeAnnotation(identifier$g("Object"));
    }
    function ArrayExpression() {
      return genericTypeAnnotation(identifier$g("Array"));
    }
    function RestElement() {
      return ArrayExpression();
    }
    RestElement.validParent = true;
    function Func() {
      return genericTypeAnnotation(identifier$g("Function"));
    }
    var isArrayFrom = buildMatchMemberExpression("Array.from");
    var isObjectKeys = buildMatchMemberExpression("Object.keys");
    var isObjectValues = buildMatchMemberExpression("Object.values");
    var isObjectEntries = buildMatchMemberExpression("Object.entries");
    function CallExpression() {
      var callee = this.node.callee;
      if (isObjectKeys(callee)) {
        return arrayTypeAnnotation(stringTypeAnnotation$1());
      } else if (isArrayFrom(callee) || isObjectValues(callee)) {
        return arrayTypeAnnotation(anyTypeAnnotation$1());
      } else if (isObjectEntries(callee)) {
        return arrayTypeAnnotation(tupleTypeAnnotation([stringTypeAnnotation$1(), anyTypeAnnotation$1()]));
      }
      return resolveCall(this.get("callee"));
    }
    function TaggedTemplateExpression() {
      return resolveCall(this.get("tag"));
    }
    function resolveCall(callee) {
      callee = callee.resolve();
      if (callee.isFunction()) {
        if (callee.is("async")) {
          if (callee.is("generator")) {
            return genericTypeAnnotation(identifier$g("AsyncIterator"));
          } else {
            return genericTypeAnnotation(identifier$g("Promise"));
          }
        } else {
          if (callee.node.returnType) {
            return callee.node.returnType;
          }
        }
      }
    }
    var inferers = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      VariableDeclarator,
      TypeCastExpression,
      NewExpression,
      TemplateLiteral,
      UnaryExpression,
      BinaryExpression,
      LogicalExpression,
      ConditionalExpression,
      SequenceExpression,
      ParenthesizedExpression,
      AssignmentExpression,
      UpdateExpression,
      StringLiteral,
      NumericLiteral,
      BooleanLiteral,
      NullLiteral,
      RegExpLiteral,
      ObjectExpression,
      ArrayExpression,
      RestElement,
      FunctionExpression: Func,
      ArrowFunctionExpression: Func,
      FunctionDeclaration: Func,
      ClassExpression: Func,
      ClassDeclaration: Func,
      CallExpression,
      TaggedTemplateExpression,
      Identifier: infererReference
    });
    var anyTypeAnnotation = anyTypeAnnotation$2, isAnyTypeAnnotation = isAnyTypeAnnotation$1, isBooleanTypeAnnotation = isBooleanTypeAnnotation$1, isEmptyTypeAnnotation = isEmptyTypeAnnotation$1, isFlowBaseAnnotation = isFlowBaseAnnotation$1, isGenericTypeAnnotation = isGenericTypeAnnotation$1, isIdentifier$c = isIdentifier$i, isMixedTypeAnnotation = isMixedTypeAnnotation$1, isNumberTypeAnnotation = isNumberTypeAnnotation$1, isStringTypeAnnotation = isStringTypeAnnotation$1, isTypeAnnotation = isTypeAnnotation$2, isUnionTypeAnnotation = isUnionTypeAnnotation$2, isVoidTypeAnnotation = isVoidTypeAnnotation$1, stringTypeAnnotation = stringTypeAnnotation$2, voidTypeAnnotation = voidTypeAnnotation$3;
    function getTypeAnnotation() {
      if (this.typeAnnotation)
        return this.typeAnnotation;
      var type5 = this._getTypeAnnotation() || anyTypeAnnotation();
      if (isTypeAnnotation(type5))
        type5 = type5.typeAnnotation;
      return this.typeAnnotation = type5;
    }
    var typeAnnotationInferringNodes = /* @__PURE__ */ new WeakSet();
    function _getTypeAnnotation() {
      var node2 = this.node;
      if (!node2) {
        if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
          var declar = this.parentPath.parentPath;
          var declarParent = declar.parentPath;
          if (declar.key === "left" && declarParent.isForInStatement()) {
            return stringTypeAnnotation();
          }
          if (declar.key === "left" && declarParent.isForOfStatement()) {
            return anyTypeAnnotation();
          }
          return voidTypeAnnotation();
        } else {
          return;
        }
      }
      if (node2.typeAnnotation) {
        return node2.typeAnnotation;
      }
      if (typeAnnotationInferringNodes.has(node2)) {
        return;
      }
      typeAnnotationInferringNodes.add(node2);
      try {
        var _inferer;
        var inferer = inferers[node2.type];
        if (inferer) {
          return inferer.call(this, node2);
        }
        inferer = inferers[this.parentPath.type];
        if ((_inferer = inferer) != null && _inferer.validParent) {
          return this.parentPath.getTypeAnnotation();
        }
      } finally {
        typeAnnotationInferringNodes["delete"](node2);
      }
    }
    function isBaseType(baseName, soft) {
      return _isBaseType(baseName, this.getTypeAnnotation(), soft);
    }
    function _isBaseType(baseName, type5, soft) {
      if (baseName === "string") {
        return isStringTypeAnnotation(type5);
      } else if (baseName === "number") {
        return isNumberTypeAnnotation(type5);
      } else if (baseName === "boolean") {
        return isBooleanTypeAnnotation(type5);
      } else if (baseName === "any") {
        return isAnyTypeAnnotation(type5);
      } else if (baseName === "mixed") {
        return isMixedTypeAnnotation(type5);
      } else if (baseName === "empty") {
        return isEmptyTypeAnnotation(type5);
      } else if (baseName === "void") {
        return isVoidTypeAnnotation(type5);
      } else {
        if (soft) {
          return false;
        } else {
          throw new Error("Unknown base type " + baseName);
        }
      }
    }
    function couldBeBaseType(name2) {
      var type5 = this.getTypeAnnotation();
      if (isAnyTypeAnnotation(type5))
        return true;
      if (isUnionTypeAnnotation(type5)) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(type5.types), _step2; !(_step2 = _iterator2()).done; ) {
          var type22 = _step2.value;
          if (isAnyTypeAnnotation(type22) || _isBaseType(name2, type22, true)) {
            return true;
          }
        }
        return false;
      } else {
        return _isBaseType(name2, type5, true);
      }
    }
    function baseTypeStrictlyMatches(rightArg) {
      var left = this.getTypeAnnotation();
      var right = rightArg.getTypeAnnotation();
      if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
        return right.type === left.type;
      }
      return false;
    }
    function isGenericType(genericName) {
      var type5 = this.getTypeAnnotation();
      return isGenericTypeAnnotation(type5) && isIdentifier$c(type5.id, {
        name: genericName
      });
    }
    var NodePath_inference = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      getTypeAnnotation,
      _getTypeAnnotation,
      isBaseType,
      couldBeBaseType,
      baseTypeStrictlyMatches,
      isGenericType
    });
    var runtime2 = { exports: {} };
    (function(module2) {
      var runtime3 = function(exports3) {
        var Op = Object.prototype;
        var hasOwn3 = Op.hasOwnProperty;
        var undefined$1;
        var $Symbol = typeof Symbol === "function" ? Symbol : {};
        var iteratorSymbol = $Symbol.iterator || "@@iterator";
        var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
        var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
        function define2(obj, key2, value) {
          Object.defineProperty(obj, key2, {
            value,
            enumerable: true,
            configurable: true,
            writable: true
          });
          return obj[key2];
        }
        try {
          define2({}, "");
        } catch (err) {
          define2 = function define3(obj, key2, value) {
            return obj[key2] = value;
          };
        }
        function wrap2(innerFn, outerFn, self2, tryLocsList) {
          var protoGenerator = outerFn && outerFn.prototype instanceof Generator2 ? outerFn : Generator2;
          var generator = Object.create(protoGenerator.prototype);
          var context = new Context2(tryLocsList || []);
          generator._invoke = makeInvokeMethod(innerFn, self2, context);
          return generator;
        }
        exports3.wrap = wrap2;
        function tryCatch(fn, obj, arg) {
          try {
            return {
              type: "normal",
              arg: fn.call(obj, arg)
            };
          } catch (err) {
            return {
              type: "throw",
              arg: err
            };
          }
        }
        var GenStateSuspendedStart = "suspendedStart";
        var GenStateSuspendedYield = "suspendedYield";
        var GenStateExecuting = "executing";
        var GenStateCompleted = "completed";
        var ContinueSentinel = {};
        function Generator2() {
        }
        function GeneratorFunction() {
        }
        function GeneratorFunctionPrototype() {
        }
        var IteratorPrototype = {};
        IteratorPrototype[iteratorSymbol] = function() {
          return this;
        };
        var getProto = Object.getPrototypeOf;
        var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
        if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn3.call(NativeIteratorPrototype, iteratorSymbol)) {
          IteratorPrototype = NativeIteratorPrototype;
        }
        var Gp = GeneratorFunctionPrototype.prototype = Generator2.prototype = Object.create(IteratorPrototype);
        GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
        GeneratorFunctionPrototype.constructor = GeneratorFunction;
        GeneratorFunction.displayName = define2(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
        function defineIteratorMethods(prototype) {
          ["next", "throw", "return"].forEach(function(method5) {
            define2(prototype, method5, function(arg) {
              return this._invoke(method5, arg);
            });
          });
        }
        exports3.isGeneratorFunction = function(genFun) {
          var ctor = typeof genFun === "function" && genFun.constructor;
          return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
        };
        exports3.mark = function(genFun) {
          if (Object.setPrototypeOf) {
            Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
          } else {
            genFun.__proto__ = GeneratorFunctionPrototype;
            define2(genFun, toStringTagSymbol, "GeneratorFunction");
          }
          genFun.prototype = Object.create(Gp);
          return genFun;
        };
        exports3.awrap = function(arg) {
          return {
            __await: arg
          };
        };
        function AsyncIterator(generator, PromiseImpl) {
          function invoke(method5, arg, resolve2, reject) {
            var record = tryCatch(generator[method5], generator, arg);
            if (record.type === "throw") {
              reject(record.arg);
            } else {
              var result = record.arg;
              var value = result.value;
              if (value && typeof value === "object" && hasOwn3.call(value, "__await")) {
                return PromiseImpl.resolve(value.__await).then(function(value2) {
                  invoke("next", value2, resolve2, reject);
                }, function(err) {
                  invoke("throw", err, resolve2, reject);
                });
              }
              return PromiseImpl.resolve(value).then(function(unwrapped) {
                result.value = unwrapped;
                resolve2(result);
              }, function(error2) {
                return invoke("throw", error2, resolve2, reject);
              });
            }
          }
          var previousPromise;
          function enqueue(method5, arg) {
            function callInvokeWithMethodAndArg() {
              return new PromiseImpl(function(resolve2, reject) {
                invoke(method5, arg, resolve2, reject);
              });
            }
            return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
          }
          this._invoke = enqueue;
        }
        defineIteratorMethods(AsyncIterator.prototype);
        AsyncIterator.prototype[asyncIteratorSymbol] = function() {
          return this;
        };
        exports3.AsyncIterator = AsyncIterator;
        exports3.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
          if (PromiseImpl === void 0)
            PromiseImpl = Promise;
          var iter = new AsyncIterator(wrap2(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
          return exports3.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
            return result.done ? result.value : iter.next();
          });
        };
        function makeInvokeMethod(innerFn, self2, context) {
          var state = GenStateSuspendedStart;
          return function invoke(method5, arg) {
            if (state === GenStateExecuting) {
              throw new Error("Generator is already running");
            }
            if (state === GenStateCompleted) {
              if (method5 === "throw") {
                throw arg;
              }
              return doneResult();
            }
            context.method = method5;
            context.arg = arg;
            while (true) {
              var delegate = context.delegate;
              if (delegate) {
                var delegateResult = maybeInvokeDelegate(delegate, context);
                if (delegateResult) {
                  if (delegateResult === ContinueSentinel)
                    continue;
                  return delegateResult;
                }
              }
              if (context.method === "next") {
                context.sent = context._sent = context.arg;
              } else if (context.method === "throw") {
                if (state === GenStateSuspendedStart) {
                  state = GenStateCompleted;
                  throw context.arg;
                }
                context.dispatchException(context.arg);
              } else if (context.method === "return") {
                context.abrupt("return", context.arg);
              }
              state = GenStateExecuting;
              var record = tryCatch(innerFn, self2, context);
              if (record.type === "normal") {
                state = context.done ? GenStateCompleted : GenStateSuspendedYield;
                if (record.arg === ContinueSentinel) {
                  continue;
                }
                return {
                  value: record.arg,
                  done: context.done
                };
              } else if (record.type === "throw") {
                state = GenStateCompleted;
                context.method = "throw";
                context.arg = record.arg;
              }
            }
          };
        }
        function maybeInvokeDelegate(delegate, context) {
          var method5 = delegate.iterator[context.method];
          if (method5 === undefined$1) {
            context.delegate = null;
            if (context.method === "throw") {
              if (delegate.iterator["return"]) {
                context.method = "return";
                context.arg = undefined$1;
                maybeInvokeDelegate(delegate, context);
                if (context.method === "throw") {
                  return ContinueSentinel;
                }
              }
              context.method = "throw";
              context.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return ContinueSentinel;
          }
          var record = tryCatch(method5, delegate.iterator, context.arg);
          if (record.type === "throw") {
            context.method = "throw";
            context.arg = record.arg;
            context.delegate = null;
            return ContinueSentinel;
          }
          var info = record.arg;
          if (!info) {
            context.method = "throw";
            context.arg = new TypeError("iterator result is not an object");
            context.delegate = null;
            return ContinueSentinel;
          }
          if (info.done) {
            context[delegate.resultName] = info.value;
            context.next = delegate.nextLoc;
            if (context.method !== "return") {
              context.method = "next";
              context.arg = undefined$1;
            }
          } else {
            return info;
          }
          context.delegate = null;
          return ContinueSentinel;
        }
        defineIteratorMethods(Gp);
        define2(Gp, toStringTagSymbol, "Generator");
        Gp[iteratorSymbol] = function() {
          return this;
        };
        Gp.toString = function() {
          return "[object Generator]";
        };
        function pushTryEntry(locs) {
          var entry2 = {
            tryLoc: locs[0]
          };
          if (1 in locs) {
            entry2.catchLoc = locs[1];
          }
          if (2 in locs) {
            entry2.finallyLoc = locs[2];
            entry2.afterLoc = locs[3];
          }
          this.tryEntries.push(entry2);
        }
        function resetTryEntry(entry2) {
          var record = entry2.completion || {};
          record.type = "normal";
          delete record.arg;
          entry2.completion = record;
        }
        function Context2(tryLocsList) {
          this.tryEntries = [{
            tryLoc: "root"
          }];
          tryLocsList.forEach(pushTryEntry, this);
          this.reset(true);
        }
        exports3.keys = function(object4) {
          var keys2 = [];
          for (var key2 in object4) {
            keys2.push(key2);
          }
          keys2.reverse();
          return function next() {
            while (keys2.length) {
              var key3 = keys2.pop();
              if (key3 in object4) {
                next.value = key3;
                next.done = false;
                return next;
              }
            }
            next.done = true;
            return next;
          };
        };
        function values(iterable) {
          if (iterable) {
            var iteratorMethod = iterable[iteratorSymbol];
            if (iteratorMethod) {
              return iteratorMethod.call(iterable);
            }
            if (typeof iterable.next === "function") {
              return iterable;
            }
            if (!isNaN(iterable.length)) {
              var i2 = -1, next = function next2() {
                while (++i2 < iterable.length) {
                  if (hasOwn3.call(iterable, i2)) {
                    next2.value = iterable[i2];
                    next2.done = false;
                    return next2;
                  }
                }
                next2.value = undefined$1;
                next2.done = true;
                return next2;
              };
              return next.next = next;
            }
          }
          return {
            next: doneResult
          };
        }
        exports3.values = values;
        function doneResult() {
          return {
            value: undefined$1,
            done: true
          };
        }
        Context2.prototype = {
          constructor: Context2,
          reset: function reset2(skipTempReset) {
            this.prev = 0;
            this.next = 0;
            this.sent = this._sent = undefined$1;
            this.done = false;
            this.delegate = null;
            this.method = "next";
            this.arg = undefined$1;
            this.tryEntries.forEach(resetTryEntry);
            if (!skipTempReset) {
              for (var name2 in this) {
                if (name2.charAt(0) === "t" && hasOwn3.call(this, name2) && !isNaN(+name2.slice(1))) {
                  this[name2] = undefined$1;
                }
              }
            }
          },
          stop: function stop3() {
            this.done = true;
            var rootEntry = this.tryEntries[0];
            var rootRecord = rootEntry.completion;
            if (rootRecord.type === "throw") {
              throw rootRecord.arg;
            }
            return this.rval;
          },
          dispatchException: function dispatchException(exception) {
            if (this.done) {
              throw exception;
            }
            var context = this;
            function handle2(loc, caught) {
              record.type = "throw";
              record.arg = exception;
              context.next = loc;
              if (caught) {
                context.method = "next";
                context.arg = undefined$1;
              }
              return !!caught;
            }
            for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
              var entry2 = this.tryEntries[i2];
              var record = entry2.completion;
              if (entry2.tryLoc === "root") {
                return handle2("end");
              }
              if (entry2.tryLoc <= this.prev) {
                var hasCatch = hasOwn3.call(entry2, "catchLoc");
                var hasFinally = hasOwn3.call(entry2, "finallyLoc");
                if (hasCatch && hasFinally) {
                  if (this.prev < entry2.catchLoc) {
                    return handle2(entry2.catchLoc, true);
                  } else if (this.prev < entry2.finallyLoc) {
                    return handle2(entry2.finallyLoc);
                  }
                } else if (hasCatch) {
                  if (this.prev < entry2.catchLoc) {
                    return handle2(entry2.catchLoc, true);
                  }
                } else if (hasFinally) {
                  if (this.prev < entry2.finallyLoc) {
                    return handle2(entry2.finallyLoc);
                  }
                } else {
                  throw new Error("try statement without catch or finally");
                }
              }
            }
          },
          abrupt: function abrupt(type5, arg) {
            for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
              var entry2 = this.tryEntries[i2];
              if (entry2.tryLoc <= this.prev && hasOwn3.call(entry2, "finallyLoc") && this.prev < entry2.finallyLoc) {
                var finallyEntry = entry2;
                break;
              }
            }
            if (finallyEntry && (type5 === "break" || type5 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
              finallyEntry = null;
            }
            var record = finallyEntry ? finallyEntry.completion : {};
            record.type = type5;
            record.arg = arg;
            if (finallyEntry) {
              this.method = "next";
              this.next = finallyEntry.finallyLoc;
              return ContinueSentinel;
            }
            return this.complete(record);
          },
          complete: function complete(record, afterLoc) {
            if (record.type === "throw") {
              throw record.arg;
            }
            if (record.type === "break" || record.type === "continue") {
              this.next = record.arg;
            } else if (record.type === "return") {
              this.rval = this.arg = record.arg;
              this.method = "return";
              this.next = "end";
            } else if (record.type === "normal" && afterLoc) {
              this.next = afterLoc;
            }
            return ContinueSentinel;
          },
          finish: function finish(finallyLoc) {
            for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
              var entry2 = this.tryEntries[i2];
              if (entry2.finallyLoc === finallyLoc) {
                this.complete(entry2.completion, entry2.afterLoc);
                resetTryEntry(entry2);
                return ContinueSentinel;
              }
            }
          },
          "catch": function _catch(tryLoc) {
            for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
              var entry2 = this.tryEntries[i2];
              if (entry2.tryLoc === tryLoc) {
                var record = entry2.completion;
                if (record.type === "throw") {
                  var thrown = record.arg;
                  resetTryEntry(entry2);
                }
                return thrown;
              }
            }
            throw new Error("illegal catch attempt");
          },
          delegateYield: function delegateYield(iterable, resultName, nextLoc) {
            this.delegate = {
              iterator: values(iterable),
              resultName,
              nextLoc
            };
            if (this.method === "next") {
              this.arg = undefined$1;
            }
            return ContinueSentinel;
          }
        };
        return exports3;
      }(module2.exports);
      try {
        regeneratorRuntime = runtime3;
      } catch (accidentalStrictMode) {
        Function("r", "regeneratorRuntime = r")(runtime3);
      }
    })(runtime2);
    var regenerator2 = runtime2.exports;
    var jsTokensBABEL_8_BREAKINGFalse = {};
    var hasRequiredJsTokensBABEL_8_BREAKINGFalse;
    function requireJsTokensBABEL_8_BREAKINGFalse() {
      if (hasRequiredJsTokensBABEL_8_BREAKINGFalse)
        return jsTokensBABEL_8_BREAKINGFalse;
      hasRequiredJsTokensBABEL_8_BREAKINGFalse = 1;
      Object.defineProperty(jsTokensBABEL_8_BREAKINGFalse, "__esModule", {
        value: true
      });
      jsTokensBABEL_8_BREAKINGFalse["default"] = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
      jsTokensBABEL_8_BREAKINGFalse.matchToToken = function(match) {
        var token = {
          type: "invalid",
          value: match[0],
          closed: void 0
        };
        if (match[1])
          token.type = "string", token.closed = !!(match[3] || match[4]);
        else if (match[5])
          token.type = "comment";
        else if (match[6])
          token.type = "comment", token.closed = !!match[7];
        else if (match[8])
          token.type = "regex";
        else if (match[9])
          token.type = "number";
        else if (match[10])
          token.type = "name";
        else if (match[11])
          token.type = "punctuator";
        else if (match[12])
          token.type = "whitespace";
        return token;
      };
      return jsTokensBABEL_8_BREAKINGFalse;
    }
    var jsTokens = requireJsTokensBABEL_8_BREAKINGFalse();
    var chalk = { exports: {} };
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    var escapeStringRegexp = function escapeStringRegexp2(str) {
      if (typeof str !== "string") {
        throw new TypeError("Expected a string");
      }
      return str.replace(matchOperatorsRe, "\\$&");
    };
    var ansiStyles = { exports: {} };
    var conversions$2 = { exports: {} };
    var colorName = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
    var cssKeywords = colorName;
    var reverseKeywords = {};
    for (var key in cssKeywords) {
      if (cssKeywords.hasOwnProperty(key)) {
        reverseKeywords[cssKeywords[key]] = key;
      }
    }
    var convert$1 = conversions$2.exports = {
      rgb: {
        channels: 3,
        labels: "rgb"
      },
      hsl: {
        channels: 3,
        labels: "hsl"
      },
      hsv: {
        channels: 3,
        labels: "hsv"
      },
      hwb: {
        channels: 3,
        labels: "hwb"
      },
      cmyk: {
        channels: 4,
        labels: "cmyk"
      },
      xyz: {
        channels: 3,
        labels: "xyz"
      },
      lab: {
        channels: 3,
        labels: "lab"
      },
      lch: {
        channels: 3,
        labels: "lch"
      },
      hex: {
        channels: 1,
        labels: ["hex"]
      },
      keyword: {
        channels: 1,
        labels: ["keyword"]
      },
      ansi16: {
        channels: 1,
        labels: ["ansi16"]
      },
      ansi256: {
        channels: 1,
        labels: ["ansi256"]
      },
      hcg: {
        channels: 3,
        labels: ["h", "c", "g"]
      },
      apple: {
        channels: 3,
        labels: ["r16", "g16", "b16"]
      },
      gray: {
        channels: 1,
        labels: ["gray"]
      }
    };
    for (var model in convert$1) {
      if (convert$1.hasOwnProperty(model)) {
        if (!("channels" in convert$1[model])) {
          throw new Error("missing channels property: " + model);
        }
        if (!("labels" in convert$1[model])) {
          throw new Error("missing channel labels property: " + model);
        }
        if (convert$1[model].labels.length !== convert$1[model].channels) {
          throw new Error("channel and label counts mismatch: " + model);
        }
        var channels = convert$1[model].channels;
        var labels = convert$1[model].labels;
        delete convert$1[model].channels;
        delete convert$1[model].labels;
        Object.defineProperty(convert$1[model], "channels", {
          value: channels
        });
        Object.defineProperty(convert$1[model], "labels", {
          value: labels
        });
      }
    }
    convert$1.rgb.hsl = function(rgb) {
      var r2 = rgb[0] / 255;
      var g2 = rgb[1] / 255;
      var b2 = rgb[2] / 255;
      var min4 = Math.min(r2, g2, b2);
      var max3 = Math.max(r2, g2, b2);
      var delta = max3 - min4;
      var h;
      var s;
      var l2;
      if (max3 === min4) {
        h = 0;
      } else if (r2 === max3) {
        h = (g2 - b2) / delta;
      } else if (g2 === max3) {
        h = 2 + (b2 - r2) / delta;
      } else if (b2 === max3) {
        h = 4 + (r2 - g2) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      l2 = (min4 + max3) / 2;
      if (max3 === min4) {
        s = 0;
      } else if (l2 <= 0.5) {
        s = delta / (max3 + min4);
      } else {
        s = delta / (2 - max3 - min4);
      }
      return [h, s * 100, l2 * 100];
    };
    convert$1.rgb.hsv = function(rgb) {
      var rdif;
      var gdif;
      var bdif;
      var h;
      var s;
      var r2 = rgb[0] / 255;
      var g2 = rgb[1] / 255;
      var b2 = rgb[2] / 255;
      var v22 = Math.max(r2, g2, b2);
      var diff = v22 - Math.min(r2, g2, b2);
      var diffc = function diffc2(c2) {
        return (v22 - c2) / 6 / diff + 1 / 2;
      };
      if (diff === 0) {
        h = s = 0;
      } else {
        s = diff / v22;
        rdif = diffc(r2);
        gdif = diffc(g2);
        bdif = diffc(b2);
        if (r2 === v22) {
          h = bdif - gdif;
        } else if (g2 === v22) {
          h = 1 / 3 + rdif - bdif;
        } else if (b2 === v22) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [h * 360, s * 100, v22 * 100];
    };
    convert$1.rgb.hwb = function(rgb) {
      var r2 = rgb[0];
      var g2 = rgb[1];
      var b2 = rgb[2];
      var h = convert$1.rgb.hsl(rgb)[0];
      var w2 = 1 / 255 * Math.min(r2, Math.min(g2, b2));
      b2 = 1 - 1 / 255 * Math.max(r2, Math.max(g2, b2));
      return [h, w2 * 100, b2 * 100];
    };
    convert$1.rgb.cmyk = function(rgb) {
      var r2 = rgb[0] / 255;
      var g2 = rgb[1] / 255;
      var b2 = rgb[2] / 255;
      var c2;
      var m2;
      var y2;
      var k2;
      k2 = Math.min(1 - r2, 1 - g2, 1 - b2);
      c2 = (1 - r2 - k2) / (1 - k2) || 0;
      m2 = (1 - g2 - k2) / (1 - k2) || 0;
      y2 = (1 - b2 - k2) / (1 - k2) || 0;
      return [c2 * 100, m2 * 100, y2 * 100, k2 * 100];
    };
    function comparativeDistance(x2, y2) {
      return Math.pow(x2[0] - y2[0], 2) + Math.pow(x2[1] - y2[1], 2) + Math.pow(x2[2] - y2[2], 2);
    }
    convert$1.rgb.keyword = function(rgb) {
      var reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      var currentClosestDistance = Infinity;
      var currentClosestKeyword;
      for (var keyword2 in cssKeywords) {
        if (cssKeywords.hasOwnProperty(keyword2)) {
          var value = cssKeywords[keyword2];
          var distance2 = comparativeDistance(rgb, value);
          if (distance2 < currentClosestDistance) {
            currentClosestDistance = distance2;
            currentClosestKeyword = keyword2;
          }
        }
      }
      return currentClosestKeyword;
    };
    convert$1.keyword.rgb = function(keyword2) {
      return cssKeywords[keyword2];
    };
    convert$1.rgb.xyz = function(rgb) {
      var r2 = rgb[0] / 255;
      var g2 = rgb[1] / 255;
      var b2 = rgb[2] / 255;
      r2 = r2 > 0.04045 ? Math.pow((r2 + 0.055) / 1.055, 2.4) : r2 / 12.92;
      g2 = g2 > 0.04045 ? Math.pow((g2 + 0.055) / 1.055, 2.4) : g2 / 12.92;
      b2 = b2 > 0.04045 ? Math.pow((b2 + 0.055) / 1.055, 2.4) : b2 / 12.92;
      var x2 = r2 * 0.4124 + g2 * 0.3576 + b2 * 0.1805;
      var y2 = r2 * 0.2126 + g2 * 0.7152 + b2 * 0.0722;
      var z2 = r2 * 0.0193 + g2 * 0.1192 + b2 * 0.9505;
      return [x2 * 100, y2 * 100, z2 * 100];
    };
    convert$1.rgb.lab = function(rgb) {
      var xyz = convert$1.rgb.xyz(rgb);
      var x2 = xyz[0];
      var y2 = xyz[1];
      var z2 = xyz[2];
      var l2;
      var a;
      var b2;
      x2 /= 95.047;
      y2 /= 100;
      z2 /= 108.883;
      x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
      y2 = y2 > 8856e-6 ? Math.pow(y2, 1 / 3) : 7.787 * y2 + 16 / 116;
      z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
      l2 = 116 * y2 - 16;
      a = 500 * (x2 - y2);
      b2 = 200 * (y2 - z2);
      return [l2, a, b2];
    };
    convert$1.hsl.rgb = function(hsl) {
      var h = hsl[0] / 360;
      var s = hsl[1] / 100;
      var l2 = hsl[2] / 100;
      var t1;
      var t22;
      var t3;
      var rgb;
      var val;
      if (s === 0) {
        val = l2 * 255;
        return [val, val, val];
      }
      if (l2 < 0.5) {
        t22 = l2 * (1 + s);
      } else {
        t22 = l2 + s - l2 * s;
      }
      t1 = 2 * l2 - t22;
      rgb = [0, 0, 0];
      for (var i2 = 0; i2 < 3; i2++) {
        t3 = h + 1 / 3 * -(i2 - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t22 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t22;
        } else if (3 * t3 < 2) {
          val = t1 + (t22 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i2] = val * 255;
      }
      return rgb;
    };
    convert$1.hsl.hsv = function(hsl) {
      var h = hsl[0];
      var s = hsl[1] / 100;
      var l2 = hsl[2] / 100;
      var smin = s;
      var lmin = Math.max(l2, 0.01);
      var sv;
      var v22;
      l2 *= 2;
      s *= l2 <= 1 ? l2 : 2 - l2;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      v22 = (l2 + s) / 2;
      sv = l2 === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l2 + s);
      return [h, sv * 100, v22 * 100];
    };
    convert$1.hsv.rgb = function(hsv) {
      var h = hsv[0] / 60;
      var s = hsv[1] / 100;
      var v22 = hsv[2] / 100;
      var hi2 = Math.floor(h) % 6;
      var f2 = h - Math.floor(h);
      var p2 = 255 * v22 * (1 - s);
      var q2 = 255 * v22 * (1 - s * f2);
      var t3 = 255 * v22 * (1 - s * (1 - f2));
      v22 *= 255;
      switch (hi2) {
        case 0:
          return [v22, t3, p2];
        case 1:
          return [q2, v22, p2];
        case 2:
          return [p2, v22, t3];
        case 3:
          return [p2, q2, v22];
        case 4:
          return [t3, p2, v22];
        case 5:
          return [v22, p2, q2];
      }
    };
    convert$1.hsv.hsl = function(hsv) {
      var h = hsv[0];
      var s = hsv[1] / 100;
      var v22 = hsv[2] / 100;
      var vmin = Math.max(v22, 0.01);
      var lmin;
      var sl;
      var l2;
      l2 = (2 - s) * v22;
      lmin = (2 - s) * vmin;
      sl = s * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l2 /= 2;
      return [h, sl * 100, l2 * 100];
    };
    convert$1.hwb.rgb = function(hwb) {
      var h = hwb[0] / 360;
      var wh2 = hwb[1] / 100;
      var bl = hwb[2] / 100;
      var ratio = wh2 + bl;
      var i2;
      var v22;
      var f2;
      var n2;
      if (ratio > 1) {
        wh2 /= ratio;
        bl /= ratio;
      }
      i2 = Math.floor(6 * h);
      v22 = 1 - bl;
      f2 = 6 * h - i2;
      if ((i2 & 1) !== 0) {
        f2 = 1 - f2;
      }
      n2 = wh2 + f2 * (v22 - wh2);
      var r2;
      var g2;
      var b2;
      switch (i2) {
        default:
        case 6:
        case 0:
          r2 = v22;
          g2 = n2;
          b2 = wh2;
          break;
        case 1:
          r2 = n2;
          g2 = v22;
          b2 = wh2;
          break;
        case 2:
          r2 = wh2;
          g2 = v22;
          b2 = n2;
          break;
        case 3:
          r2 = wh2;
          g2 = n2;
          b2 = v22;
          break;
        case 4:
          r2 = n2;
          g2 = wh2;
          b2 = v22;
          break;
        case 5:
          r2 = v22;
          g2 = wh2;
          b2 = n2;
          break;
      }
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert$1.cmyk.rgb = function(cmyk) {
      var c2 = cmyk[0] / 100;
      var m2 = cmyk[1] / 100;
      var y2 = cmyk[2] / 100;
      var k2 = cmyk[3] / 100;
      var r2;
      var g2;
      var b2;
      r2 = 1 - Math.min(1, c2 * (1 - k2) + k2);
      g2 = 1 - Math.min(1, m2 * (1 - k2) + k2);
      b2 = 1 - Math.min(1, y2 * (1 - k2) + k2);
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert$1.xyz.rgb = function(xyz) {
      var x2 = xyz[0] / 100;
      var y2 = xyz[1] / 100;
      var z2 = xyz[2] / 100;
      var r2;
      var g2;
      var b2;
      r2 = x2 * 3.2406 + y2 * -1.5372 + z2 * -0.4986;
      g2 = x2 * -0.9689 + y2 * 1.8758 + z2 * 0.0415;
      b2 = x2 * 0.0557 + y2 * -0.204 + z2 * 1.057;
      r2 = r2 > 31308e-7 ? 1.055 * Math.pow(r2, 1 / 2.4) - 0.055 : r2 * 12.92;
      g2 = g2 > 31308e-7 ? 1.055 * Math.pow(g2, 1 / 2.4) - 0.055 : g2 * 12.92;
      b2 = b2 > 31308e-7 ? 1.055 * Math.pow(b2, 1 / 2.4) - 0.055 : b2 * 12.92;
      r2 = Math.min(Math.max(0, r2), 1);
      g2 = Math.min(Math.max(0, g2), 1);
      b2 = Math.min(Math.max(0, b2), 1);
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert$1.xyz.lab = function(xyz) {
      var x2 = xyz[0];
      var y2 = xyz[1];
      var z2 = xyz[2];
      var l2;
      var a;
      var b2;
      x2 /= 95.047;
      y2 /= 100;
      z2 /= 108.883;
      x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
      y2 = y2 > 8856e-6 ? Math.pow(y2, 1 / 3) : 7.787 * y2 + 16 / 116;
      z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
      l2 = 116 * y2 - 16;
      a = 500 * (x2 - y2);
      b2 = 200 * (y2 - z2);
      return [l2, a, b2];
    };
    convert$1.lab.xyz = function(lab) {
      var l2 = lab[0];
      var a = lab[1];
      var b2 = lab[2];
      var x2;
      var y2;
      var z2;
      y2 = (l2 + 16) / 116;
      x2 = a / 500 + y2;
      z2 = y2 - b2 / 200;
      var y22 = Math.pow(y2, 3);
      var x22 = Math.pow(x2, 3);
      var z22 = Math.pow(z2, 3);
      y2 = y22 > 8856e-6 ? y22 : (y2 - 16 / 116) / 7.787;
      x2 = x22 > 8856e-6 ? x22 : (x2 - 16 / 116) / 7.787;
      z2 = z22 > 8856e-6 ? z22 : (z2 - 16 / 116) / 7.787;
      x2 *= 95.047;
      y2 *= 100;
      z2 *= 108.883;
      return [x2, y2, z2];
    };
    convert$1.lab.lch = function(lab) {
      var l2 = lab[0];
      var a = lab[1];
      var b2 = lab[2];
      var hr;
      var h;
      var c2;
      hr = Math.atan2(b2, a);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      c2 = Math.sqrt(a * a + b2 * b2);
      return [l2, c2, h];
    };
    convert$1.lch.lab = function(lch) {
      var l2 = lch[0];
      var c2 = lch[1];
      var h = lch[2];
      var a;
      var b2;
      var hr;
      hr = h / 360 * 2 * Math.PI;
      a = c2 * Math.cos(hr);
      b2 = c2 * Math.sin(hr);
      return [l2, a, b2];
    };
    convert$1.rgb.ansi16 = function(args) {
      var r2 = args[0];
      var g2 = args[1];
      var b2 = args[2];
      var value = 1 in arguments ? arguments[1] : convert$1.rgb.hsv(args)[2];
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      var ansi = 30 + (Math.round(b2 / 255) << 2 | Math.round(g2 / 255) << 1 | Math.round(r2 / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert$1.hsv.ansi16 = function(args) {
      return convert$1.rgb.ansi16(convert$1.hsv.rgb(args), args[2]);
    };
    convert$1.rgb.ansi256 = function(args) {
      var r2 = args[0];
      var g2 = args[1];
      var b2 = args[2];
      if (r2 === g2 && g2 === b2) {
        if (r2 < 8) {
          return 16;
        }
        if (r2 > 248) {
          return 231;
        }
        return Math.round((r2 - 8) / 247 * 24) + 232;
      }
      var ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g2 / 255 * 5) + Math.round(b2 / 255 * 5);
      return ansi;
    };
    convert$1.ansi16.rgb = function(args) {
      var color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      var mult = (~~(args > 50) + 1) * 0.5;
      var r2 = (color & 1) * mult * 255;
      var g2 = (color >> 1 & 1) * mult * 255;
      var b2 = (color >> 2 & 1) * mult * 255;
      return [r2, g2, b2];
    };
    convert$1.ansi256.rgb = function(args) {
      if (args >= 232) {
        var c2 = (args - 232) * 10 + 8;
        return [c2, c2, c2];
      }
      args -= 16;
      var rem;
      var r2 = Math.floor(args / 36) / 5 * 255;
      var g2 = Math.floor((rem = args % 36) / 6) / 5 * 255;
      var b2 = rem % 6 / 5 * 255;
      return [r2, g2, b2];
    };
    convert$1.rgb.hex = function(args) {
      var integer4 = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      var string3 = integer4.toString(16).toUpperCase();
      return "000000".substring(string3.length) + string3;
    };
    convert$1.hex.rgb = function(args) {
      var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      var colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map(function(_char) {
          return _char + _char;
        }).join("");
      }
      var integer4 = parseInt(colorString, 16);
      var r2 = integer4 >> 16 & 255;
      var g2 = integer4 >> 8 & 255;
      var b2 = integer4 & 255;
      return [r2, g2, b2];
    };
    convert$1.rgb.hcg = function(rgb) {
      var r2 = rgb[0] / 255;
      var g2 = rgb[1] / 255;
      var b2 = rgb[2] / 255;
      var max3 = Math.max(Math.max(r2, g2), b2);
      var min4 = Math.min(Math.min(r2, g2), b2);
      var chroma = max3 - min4;
      var grayscale;
      var hue;
      if (chroma < 1) {
        grayscale = min4 / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max3 === r2) {
        hue = (g2 - b2) / chroma % 6;
      } else if (max3 === g2) {
        hue = 2 + (b2 - r2) / chroma;
      } else {
        hue = 4 + (r2 - g2) / chroma + 4;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert$1.hsl.hcg = function(hsl) {
      var s = hsl[1] / 100;
      var l2 = hsl[2] / 100;
      var c2 = 1;
      var f2 = 0;
      if (l2 < 0.5) {
        c2 = 2 * s * l2;
      } else {
        c2 = 2 * s * (1 - l2);
      }
      if (c2 < 1) {
        f2 = (l2 - 0.5 * c2) / (1 - c2);
      }
      return [hsl[0], c2 * 100, f2 * 100];
    };
    convert$1.hsv.hcg = function(hsv) {
      var s = hsv[1] / 100;
      var v22 = hsv[2] / 100;
      var c2 = s * v22;
      var f2 = 0;
      if (c2 < 1) {
        f2 = (v22 - c2) / (1 - c2);
      }
      return [hsv[0], c2 * 100, f2 * 100];
    };
    convert$1.hcg.rgb = function(hcg) {
      var h = hcg[0] / 360;
      var c2 = hcg[1] / 100;
      var g2 = hcg[2] / 100;
      if (c2 === 0) {
        return [g2 * 255, g2 * 255, g2 * 255];
      }
      var pure = [0, 0, 0];
      var hi2 = h % 1 * 6;
      var v22 = hi2 % 1;
      var w2 = 1 - v22;
      var mg2 = 0;
      switch (Math.floor(hi2)) {
        case 0:
          pure[0] = 1;
          pure[1] = v22;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w2;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v22;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w2;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v22;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w2;
      }
      mg2 = (1 - c2) * g2;
      return [(c2 * pure[0] + mg2) * 255, (c2 * pure[1] + mg2) * 255, (c2 * pure[2] + mg2) * 255];
    };
    convert$1.hcg.hsv = function(hcg) {
      var c2 = hcg[1] / 100;
      var g2 = hcg[2] / 100;
      var v22 = c2 + g2 * (1 - c2);
      var f2 = 0;
      if (v22 > 0) {
        f2 = c2 / v22;
      }
      return [hcg[0], f2 * 100, v22 * 100];
    };
    convert$1.hcg.hsl = function(hcg) {
      var c2 = hcg[1] / 100;
      var g2 = hcg[2] / 100;
      var l2 = g2 * (1 - c2) + 0.5 * c2;
      var s = 0;
      if (l2 > 0 && l2 < 0.5) {
        s = c2 / (2 * l2);
      } else if (l2 >= 0.5 && l2 < 1) {
        s = c2 / (2 * (1 - l2));
      }
      return [hcg[0], s * 100, l2 * 100];
    };
    convert$1.hcg.hwb = function(hcg) {
      var c2 = hcg[1] / 100;
      var g2 = hcg[2] / 100;
      var v22 = c2 + g2 * (1 - c2);
      return [hcg[0], (v22 - c2) * 100, (1 - v22) * 100];
    };
    convert$1.hwb.hcg = function(hwb) {
      var w2 = hwb[1] / 100;
      var b2 = hwb[2] / 100;
      var v22 = 1 - b2;
      var c2 = v22 - w2;
      var g2 = 0;
      if (c2 < 1) {
        g2 = (v22 - c2) / (1 - c2);
      }
      return [hwb[0], c2 * 100, g2 * 100];
    };
    convert$1.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert$1.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert$1.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert$1.gray.hsl = convert$1.gray.hsv = function(args) {
      return [0, 0, args[0]];
    };
    convert$1.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert$1.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert$1.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert$1.gray.hex = function(gray) {
      var val = Math.round(gray[0] / 100 * 255) & 255;
      var integer4 = (val << 16) + (val << 8) + val;
      var string3 = integer4.toString(16).toUpperCase();
      return "000000".substring(string3.length) + string3;
    };
    convert$1.rgb.gray = function(rgb) {
      var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
    var conversions$1 = conversions$2.exports;
    function buildGraph() {
      var graph = {};
      var models2 = Object.keys(conversions$1);
      for (var len3 = models2.length, i2 = 0; i2 < len3; i2++) {
        graph[models2[i2]] = {
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      var graph = buildGraph();
      var queue2 = [fromModel];
      graph[fromModel].distance = 0;
      while (queue2.length) {
        var current2 = queue2.pop();
        var adjacents = Object.keys(conversions$1[current2]);
        for (var len3 = adjacents.length, i2 = 0; i2 < len3; i2++) {
          var adjacent = adjacents[i2];
          var node2 = graph[adjacent];
          if (node2.distance === -1) {
            node2.distance = graph[current2].distance + 1;
            node2.parent = current2;
            queue2.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link(from2, to) {
      return function(args) {
        return to(from2(args));
      };
    }
    function wrapConversion(toModel, graph) {
      var path2 = [graph[toModel].parent, toModel];
      var fn = conversions$1[graph[toModel].parent][toModel];
      var cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path2.unshift(graph[cur].parent);
        fn = link(conversions$1[graph[cur].parent][cur], fn);
        cur = graph[cur].parent;
      }
      fn.conversion = path2;
      return fn;
    }
    var route$1 = function route2(fromModel) {
      var graph = deriveBFS(fromModel);
      var conversion = {};
      var models2 = Object.keys(graph);
      for (var len3 = models2.length, i2 = 0; i2 < len3; i2++) {
        var toModel = models2[i2];
        var node2 = graph[toModel];
        if (node2.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
    var conversions = conversions$2.exports;
    var route = route$1;
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn) {
      var wrappedFn = function wrappedFn2(args) {
        if (args === void 0 || args === null) {
          return args;
        }
        if (arguments.length > 1) {
          args = Array.prototype.slice.call(arguments);
        }
        return fn(args);
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn) {
      var wrappedFn = function wrappedFn2(args) {
        if (args === void 0 || args === null) {
          return args;
        }
        if (arguments.length > 1) {
          args = Array.prototype.slice.call(arguments);
        }
        var result = fn(args);
        if (typeof result === "object") {
          for (var len3 = result.length, i2 = 0; i2 < len3; i2++) {
            result[i2] = Math.round(result[i2]);
          }
        }
        return result;
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    models.forEach(function(fromModel) {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", {
        value: conversions[fromModel].channels
      });
      Object.defineProperty(convert[fromModel], "labels", {
        value: conversions[fromModel].labels
      });
      var routes = route(fromModel);
      var routeModels = Object.keys(routes);
      routeModels.forEach(function(toModel) {
        var fn = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn);
        convert[fromModel][toModel].raw = wrapRaw(fn);
      });
    });
    var colorConvert = convert;
    (function(module2) {
      var colorConvert$1 = colorConvert;
      var wrapAnsi16 = function wrapAnsi162(fn, offset3) {
        return function() {
          var code3 = fn.apply(colorConvert$1, arguments);
          return "\x1B[" + (code3 + offset3) + "m";
        };
      };
      var wrapAnsi256 = function wrapAnsi2562(fn, offset3) {
        return function() {
          var code3 = fn.apply(colorConvert$1, arguments);
          return "\x1B[" + (38 + offset3) + ";5;" + code3 + "m";
        };
      };
      var wrapAnsi16m = function wrapAnsi16m2(fn, offset3) {
        return function() {
          var rgb = fn.apply(colorConvert$1, arguments);
          return "\x1B[" + (38 + offset3) + ";2;" + rgb[0] + ";" + rgb[1] + ";" + rgb[2] + "m";
        };
      };
      function assembleStyles() {
        var codes = /* @__PURE__ */ new Map();
        var styles2 = {
          modifier: {
            reset: [0, 0],
            bold: [1, 22],
            dim: [2, 22],
            italic: [3, 23],
            underline: [4, 24],
            inverse: [7, 27],
            hidden: [8, 28],
            strikethrough: [9, 29]
          },
          color: {
            black: [30, 39],
            red: [31, 39],
            green: [32, 39],
            yellow: [33, 39],
            blue: [34, 39],
            magenta: [35, 39],
            cyan: [36, 39],
            white: [37, 39],
            gray: [90, 39],
            redBright: [91, 39],
            greenBright: [92, 39],
            yellowBright: [93, 39],
            blueBright: [94, 39],
            magentaBright: [95, 39],
            cyanBright: [96, 39],
            whiteBright: [97, 39]
          },
          bgColor: {
            bgBlack: [40, 49],
            bgRed: [41, 49],
            bgGreen: [42, 49],
            bgYellow: [43, 49],
            bgBlue: [44, 49],
            bgMagenta: [45, 49],
            bgCyan: [46, 49],
            bgWhite: [47, 49],
            bgBlackBright: [100, 49],
            bgRedBright: [101, 49],
            bgGreenBright: [102, 49],
            bgYellowBright: [103, 49],
            bgBlueBright: [104, 49],
            bgMagentaBright: [105, 49],
            bgCyanBright: [106, 49],
            bgWhiteBright: [107, 49]
          }
        };
        styles2.color.grey = styles2.color.gray;
        for (var _i3 = 0, _Object$keys3 = Object.keys(styles2); _i3 < _Object$keys3.length; _i3++) {
          var groupName = _Object$keys3[_i3];
          var group = styles2[groupName];
          for (var _i22 = 0, _Object$keys22 = Object.keys(group); _i22 < _Object$keys22.length; _i22++) {
            var styleName = _Object$keys22[_i22];
            var style2 = group[styleName];
            styles2[styleName] = {
              open: "\x1B[" + style2[0] + "m",
              close: "\x1B[" + style2[1] + "m"
            };
            group[styleName] = styles2[styleName];
            codes.set(style2[0], style2[1]);
          }
          Object.defineProperty(styles2, groupName, {
            value: group,
            enumerable: false
          });
          Object.defineProperty(styles2, "codes", {
            value: codes,
            enumerable: false
          });
        }
        var ansi2ansi = function ansi2ansi2(n2) {
          return n2;
        };
        var rgb2rgb = function rgb2rgb2(r2, g2, b2) {
          return [r2, g2, b2];
        };
        styles2.color.close = "\x1B[39m";
        styles2.bgColor.close = "\x1B[49m";
        styles2.color.ansi = {
          ansi: wrapAnsi16(ansi2ansi, 0)
        };
        styles2.color.ansi256 = {
          ansi256: wrapAnsi256(ansi2ansi, 0)
        };
        styles2.color.ansi16m = {
          rgb: wrapAnsi16m(rgb2rgb, 0)
        };
        styles2.bgColor.ansi = {
          ansi: wrapAnsi16(ansi2ansi, 10)
        };
        styles2.bgColor.ansi256 = {
          ansi256: wrapAnsi256(ansi2ansi, 10)
        };
        styles2.bgColor.ansi16m = {
          rgb: wrapAnsi16m(rgb2rgb, 10)
        };
        for (var _i32 = 0, _Object$keys32 = Object.keys(colorConvert$1); _i32 < _Object$keys32.length; _i32++) {
          var key2 = _Object$keys32[_i32];
          if (typeof colorConvert$1[key2] !== "object") {
            continue;
          }
          var suite = colorConvert$1[key2];
          if (key2 === "ansi16") {
            key2 = "ansi";
          }
          if ("ansi16" in suite) {
            styles2.color.ansi[key2] = wrapAnsi16(suite.ansi16, 0);
            styles2.bgColor.ansi[key2] = wrapAnsi16(suite.ansi16, 10);
          }
          if ("ansi256" in suite) {
            styles2.color.ansi256[key2] = wrapAnsi256(suite.ansi256, 0);
            styles2.bgColor.ansi256[key2] = wrapAnsi256(suite.ansi256, 10);
          }
          if ("rgb" in suite) {
            styles2.color.ansi16m[key2] = wrapAnsi16m(suite.rgb, 0);
            styles2.bgColor.ansi16m[key2] = wrapAnsi16m(suite.rgb, 10);
          }
        }
        return styles2;
      }
      Object.defineProperty(module2, "exports", {
        enumerable: true,
        get: assembleStyles
      });
    })(ansiStyles);
    var browser$1 = {
      stdout: false,
      stderr: false
    };
    var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
    function unescape2(c2) {
      if (c2[0] === "u" && c2.length === 5 || c2[0] === "x" && c2.length === 3) {
        return String.fromCharCode(parseInt(c2.slice(1), 16));
      }
      return ESCAPES.get(c2) || c2;
    }
    function parseArguments(name2, args) {
      var results = [];
      var chunks = args.trim().split(/\s*,\s*/g);
      var matches;
      for (var _iterator2 = _createForOfIteratorHelperLoose(chunks), _step2; !(_step2 = _iterator2()).done; ) {
        var chunk = _step2.value;
        if (!isNaN(chunk)) {
          results.push(Number(chunk));
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, function(m2, escape, chr) {
            return escape ? unescape2(escape) : chr;
          }));
        } else {
          throw new Error("Invalid Chalk template style argument: " + chunk + " (in style '" + name2 + "')");
        }
      }
      return results;
    }
    function parseStyle(style2) {
      STYLE_REGEX.lastIndex = 0;
      var results = [];
      var matches;
      while ((matches = STYLE_REGEX.exec(style2)) !== null) {
        var name2 = matches[1];
        if (matches[2]) {
          var args = parseArguments(name2, matches[2]);
          results.push([name2].concat(args));
        } else {
          results.push([name2]);
        }
      }
      return results;
    }
    function buildStyle(chalk2, styles2) {
      var enabled = {};
      for (var _iterator2 = _createForOfIteratorHelperLoose(styles2), _step2; !(_step2 = _iterator2()).done; ) {
        var layer = _step2.value;
        for (var _iterator3 = _createForOfIteratorHelperLoose(layer.styles), _step3; !(_step3 = _iterator3()).done; ) {
          var style2 = _step3.value;
          enabled[style2[0]] = layer.inverse ? null : style2.slice(1);
        }
      }
      var current2 = chalk2;
      for (var _i3 = 0, _Object$keys3 = Object.keys(enabled); _i3 < _Object$keys3.length; _i3++) {
        var styleName = _Object$keys3[_i3];
        if (Array.isArray(enabled[styleName])) {
          if (!(styleName in current2)) {
            throw new Error("Unknown Chalk style: " + styleName);
          }
          if (enabled[styleName].length > 0) {
            current2 = current2[styleName].apply(current2, enabled[styleName]);
          } else {
            current2 = current2[styleName];
          }
        }
      }
      return current2;
    }
    var templates = function templates2(chalk2, tmp) {
      var styles2 = [];
      var chunks = [];
      var chunk = [];
      tmp.replace(TEMPLATE_REGEX, function(m2, escapeChar, inverse, style2, close, chr) {
        if (escapeChar) {
          chunk.push(unescape2(escapeChar));
        } else if (style2) {
          var str = chunk.join("");
          chunk = [];
          chunks.push(styles2.length === 0 ? str : buildStyle(chalk2, styles2)(str));
          styles2.push({
            inverse,
            styles: parseStyle(style2)
          });
        } else if (close) {
          if (styles2.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk2, styles2)(chunk.join("")));
          chunk = [];
          styles2.pop();
        } else {
          chunk.push(chr);
        }
      });
      chunks.push(chunk.join(""));
      if (styles2.length > 0) {
        var errMsg = "Chalk template literal is missing " + styles2.length + " closing bracket" + (styles2.length === 1 ? "" : "s") + " (`}`)";
        throw new Error(errMsg);
      }
      return chunks.join("");
    };
    (function(module2) {
      var escapeStringRegexp$1 = escapeStringRegexp;
      var ansiStyles$1 = ansiStyles.exports;
      var stdoutColor = browser$1.stdout;
      var template2 = templates;
      var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
      var skipModels = /* @__PURE__ */ new Set(["gray"]);
      var styles2 = /* @__PURE__ */ Object.create(null);
      function applyOptions(obj, options) {
        options = options || {};
        var scLevel = 0;
        obj.level = options.level === void 0 ? scLevel : options.level;
        obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
      }
      function Chalk2(options) {
        if (!this || !(this instanceof Chalk2) || this.template) {
          var _chalk = {};
          applyOptions(_chalk, options);
          _chalk.template = function() {
            var args = [].slice.call(arguments);
            return chalkTag.apply(null, [_chalk.template].concat(args));
          };
          Object.setPrototypeOf(_chalk, Chalk2.prototype);
          Object.setPrototypeOf(_chalk.template, _chalk);
          _chalk.template.constructor = Chalk2;
          return _chalk.template;
        }
        applyOptions(this, options);
      }
      var _loop3 = function _loop4() {
        var key2 = _Object$keys3[_i3];
        ansiStyles$1[key2].closeRe = new RegExp(escapeStringRegexp$1(ansiStyles$1[key2].close), "g");
        styles2[key2] = {
          get: function get3() {
            var codes = ansiStyles$1[key2];
            return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key2);
          }
        };
      };
      for (var _i3 = 0, _Object$keys3 = Object.keys(ansiStyles$1); _i3 < _Object$keys3.length; _i3++) {
        _loop3();
      }
      styles2.visible = {
        get: function get3() {
          return build2.call(this, this._styles || [], true, "visible");
        }
      };
      ansiStyles$1.color.closeRe = new RegExp(escapeStringRegexp$1(ansiStyles$1.color.close), "g");
      var _loop22 = function _loop23() {
        var model2 = _Object$keys22[_i22];
        if (skipModels.has(model2)) {
          return "continue";
        }
        styles2[model2] = {
          get: function get3() {
            var level = this.level;
            return function() {
              var open = ansiStyles$1.color[levelMapping[level]][model2].apply(null, arguments);
              var codes = {
                open,
                close: ansiStyles$1.color.close,
                closeRe: ansiStyles$1.color.closeRe
              };
              return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model2);
            };
          }
        };
      };
      for (var _i22 = 0, _Object$keys22 = Object.keys(ansiStyles$1.color.ansi); _i22 < _Object$keys22.length; _i22++) {
        var _ret2 = _loop22();
        if (_ret2 === "continue")
          continue;
      }
      ansiStyles$1.bgColor.closeRe = new RegExp(escapeStringRegexp$1(ansiStyles$1.bgColor.close), "g");
      var _loop32 = function _loop33() {
        var model2 = _Object$keys32[_i32];
        if (skipModels.has(model2)) {
          return "continue";
        }
        var bgModel = "bg" + model2[0].toUpperCase() + model2.slice(1);
        styles2[bgModel] = {
          get: function get3() {
            var level = this.level;
            return function() {
              var open = ansiStyles$1.bgColor[levelMapping[level]][model2].apply(null, arguments);
              var codes = {
                open,
                close: ansiStyles$1.bgColor.close,
                closeRe: ansiStyles$1.bgColor.closeRe
              };
              return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model2);
            };
          }
        };
      };
      for (var _i32 = 0, _Object$keys32 = Object.keys(ansiStyles$1.bgColor.ansi); _i32 < _Object$keys32.length; _i32++) {
        var _ret22 = _loop32();
        if (_ret22 === "continue")
          continue;
      }
      var proto2 = Object.defineProperties(function() {
      }, styles2);
      function build2(_styles, _empty, key2) {
        var builder2 = function builder3() {
          return applyStyle.apply(builder3, arguments);
        };
        builder2._styles = _styles;
        builder2._empty = _empty;
        var self2 = this;
        Object.defineProperty(builder2, "level", {
          enumerable: true,
          get: function get3() {
            return self2.level;
          },
          set: function set3(level) {
            self2.level = level;
          }
        });
        Object.defineProperty(builder2, "enabled", {
          enumerable: true,
          get: function get3() {
            return self2.enabled;
          },
          set: function set3(enabled) {
            self2.enabled = enabled;
          }
        });
        builder2.hasGrey = this.hasGrey || key2 === "gray" || key2 === "grey";
        builder2.__proto__ = proto2;
        return builder2;
      }
      function applyStyle() {
        var args = arguments;
        var argsLen = args.length;
        var str = String(arguments[0]);
        if (argsLen === 0) {
          return "";
        }
        if (argsLen > 1) {
          for (var a = 1; a < argsLen; a++) {
            str += " " + args[a];
          }
        }
        if (!this.enabled || this.level <= 0 || !str) {
          return this._empty ? "" : str;
        }
        var originalDim = ansiStyles$1.dim.open;
        for (var _iterator2 = _createForOfIteratorHelperLoose(this._styles.slice().reverse()), _step2; !(_step2 = _iterator2()).done; ) {
          var code3 = _step2.value;
          str = code3.open + str.replace(code3.closeRe, code3.open) + code3.close;
          str = str.replace(/\r?\n/g, code3.close + "$&" + code3.open);
        }
        ansiStyles$1.dim.open = originalDim;
        return str;
      }
      function chalkTag(chalk2, strings) {
        if (!Array.isArray(strings)) {
          return [].slice.call(arguments, 1).join(" ");
        }
        var args = [].slice.call(arguments, 2);
        var parts = [strings.raw[0]];
        for (var i2 = 1; i2 < strings.length; i2++) {
          parts.push(String(args[i2 - 1]).replace(/[{}\\]/g, "\\$&"));
          parts.push(String(strings.raw[i2]));
        }
        return template2(chalk2, parts.join(""));
      }
      Object.defineProperties(Chalk2.prototype, styles2);
      module2.exports = Chalk2();
      module2.exports.supportsColor = stdoutColor;
      module2.exports["default"] = module2.exports;
    })(chalk);
    var Chalk = chalk.exports;
    var sometimesKeywords = /* @__PURE__ */ new Set(["as", "async", "from", "get", "of", "set"]);
    function getDefs$1(chalk2) {
      return {
        keyword: chalk2.cyan,
        capitalized: chalk2.yellow,
        jsxIdentifier: chalk2.yellow,
        punctuator: chalk2.yellow,
        number: chalk2.magenta,
        string: chalk2.green,
        regex: chalk2.magenta,
        comment: chalk2.grey,
        invalid: chalk2.white.bgRed.bold
      };
    }
    var NEWLINE$1 = /\r\n|[\n\r\u2028\u2029]/;
    var BRACKET = /^[()[\]{}]$/;
    var tokenize;
    {
      var JSX_TAG = /^[a-z][\w-]*$/i;
      var getTokenType = function getTokenType2(token, offset3, text) {
        if (token.type === "name") {
          if (isKeyword(token.value) || isStrictReservedWord(token.value, true) || sometimesKeywords.has(token.value)) {
            return "keyword";
          }
          if (JSX_TAG.test(token.value) && (text[offset3 - 1] === "<" || text.slice(offset3 - 2, offset3) == "</")) {
            return "jsxIdentifier";
          }
          if (token.value[0] !== token.value[0].toLowerCase()) {
            return "capitalized";
          }
        }
        if (token.type === "punctuator" && BRACKET.test(token.value)) {
          return "bracket";
        }
        if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
          return "punctuator";
        }
        return token.type;
      };
      tokenize = regenerator2.mark(function tokenize2(text) {
        var match, token;
        return regenerator2.wrap(function tokenize$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(match = jsTokens["default"].exec(text))) {
                  _context.next = 6;
                  break;
                }
                token = jsTokens.matchToToken(match);
                _context.next = 4;
                return {
                  type: getTokenType(token, match.index, text),
                  value: token.value
                };
              case 4:
                _context.next = 0;
                break;
              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, tokenize2);
      });
    }
    function highlightTokens(defs, text) {
      var highlighted = "";
      var _loop3 = function _loop4() {
        var _step$value = _step2.value, type5 = _step$value.type, value = _step$value.value;
        var colorize = defs[type5];
        if (colorize) {
          highlighted += value.split(NEWLINE$1).map(function(str) {
            return colorize(str);
          }).join("\n");
        } else {
          highlighted += value;
        }
      };
      for (var _iterator2 = _createForOfIteratorHelperLoose(tokenize(text)), _step2; !(_step2 = _iterator2()).done; ) {
        _loop3();
      }
      return highlighted;
    }
    function shouldHighlight(options) {
      return !!Chalk.supportsColor || options.forceColor;
    }
    function getChalk(options) {
      return options.forceColor ? new Chalk.constructor({
        enabled: true,
        level: 1
      }) : Chalk;
    }
    function highlight(code3, options) {
      if (options === void 0) {
        options = {};
      }
      if (code3 !== "" && shouldHighlight(options)) {
        var chalk2 = getChalk(options);
        var defs = getDefs$1(chalk2);
        return highlightTokens(defs, code3);
      } else {
        return code3;
      }
    }
    function getDefs(chalk2) {
      return {
        gutter: chalk2.grey,
        marker: chalk2.red.bold,
        message: chalk2.red.bold
      };
    }
    var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
    function getMarkerLines(loc, source, opts) {
      var startLoc = Object.assign({
        column: 0,
        line: -1
      }, loc.start);
      var endLoc = Object.assign({}, startLoc, loc.end);
      var _ref3 = opts || {}, _ref$linesAbove = _ref3.linesAbove, linesAbove = _ref$linesAbove === void 0 ? 2 : _ref$linesAbove, _ref$linesBelow = _ref3.linesBelow, linesBelow = _ref$linesBelow === void 0 ? 3 : _ref$linesBelow;
      var startLine = startLoc.line;
      var startColumn = startLoc.column;
      var endLine = endLoc.line;
      var endColumn = endLoc.column;
      var start2 = Math.max(startLine - (linesAbove + 1), 0);
      var end2 = Math.min(source.length, endLine + linesBelow);
      if (startLine === -1) {
        start2 = 0;
      }
      if (endLine === -1) {
        end2 = source.length;
      }
      var lineDiff = endLine - startLine;
      var markerLines = {};
      if (lineDiff) {
        for (var i2 = 0; i2 <= lineDiff; i2++) {
          var lineNumber = i2 + startLine;
          if (!startColumn) {
            markerLines[lineNumber] = true;
          } else if (i2 === 0) {
            var sourceLength = source[lineNumber - 1].length;
            markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
          } else if (i2 === lineDiff) {
            markerLines[lineNumber] = [0, endColumn];
          } else {
            var _sourceLength = source[lineNumber - i2].length;
            markerLines[lineNumber] = [0, _sourceLength];
          }
        }
      } else {
        if (startColumn === endColumn) {
          if (startColumn) {
            markerLines[startLine] = [startColumn, 0];
          } else {
            markerLines[startLine] = true;
          }
        } else {
          markerLines[startLine] = [startColumn, endColumn - startColumn];
        }
      }
      return {
        start: start2,
        end: end2,
        markerLines
      };
    }
    function codeFrameColumns(rawLines, loc, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var highlighted = (opts.highlightCode || opts.forceColor) && shouldHighlight(opts);
      var chalk2 = getChalk(opts);
      var defs = getDefs(chalk2);
      var maybeHighlight = function maybeHighlight2(chalkFn, string3) {
        return highlighted ? chalkFn(string3) : string3;
      };
      var lines = rawLines.split(NEWLINE);
      var _getMarkerLines = getMarkerLines(loc, lines, opts), start2 = _getMarkerLines.start, end2 = _getMarkerLines.end, markerLines = _getMarkerLines.markerLines;
      var hasColumns = loc.start && typeof loc.start.column === "number";
      var numberMaxWidth = String(end2).length;
      var highlightedLines = highlighted ? highlight(rawLines, opts) : rawLines;
      var frame = highlightedLines.split(NEWLINE, end2).slice(start2, end2).map(function(line, index3) {
        var number4 = start2 + 1 + index3;
        var paddedNumber = (" " + number4).slice(-numberMaxWidth);
        var gutter = " " + paddedNumber + " |";
        var hasMarker = markerLines[number4];
        var lastMarkerLine = !markerLines[number4 + 1];
        if (hasMarker) {
          var markerLine = "";
          if (Array.isArray(hasMarker)) {
            var markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
            var numberOfMarkers = hasMarker[1] || 1;
            markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
            if (lastMarkerLine && opts.message) {
              markerLine += " " + maybeHighlight(defs.message, opts.message);
            }
          }
          return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? " " + line : "", markerLine].join("");
        } else {
          return " " + maybeHighlight(defs.gutter, gutter) + (line.length > 0 ? " " + line : "");
        }
      }).join("\n");
      if (opts.message && !hasColumns) {
        frame = "" + " ".repeat(numberMaxWidth + 1) + opts.message + "\n" + frame;
      }
      if (highlighted) {
        return chalk2.reset(frame);
      } else {
        return frame;
      }
    }
    var Position3 = _createClass2(function Position4(line, col, index3) {
      this.line = void 0;
      this.column = void 0;
      this.index = void 0;
      this.line = line;
      this.column = col;
      this.index = index3;
    });
    var SourceLocation3 = _createClass2(function SourceLocation4(start2, end2) {
      this.start = void 0;
      this.end = void 0;
      this.filename = void 0;
      this.identifierName = void 0;
      this.start = start2;
      this.end = end2;
    });
    function createPositionWithColumnOffset(position2, columnOffset) {
      var line = position2.line, column = position2.column, index3 = position2.index;
      return new Position3(line, column + columnOffset, index3 + columnOffset);
    }
    var ParseErrorCodes = Object.freeze({
      SyntaxError: "BABEL_PARSER_SYNTAX_ERROR",
      SourceTypeModuleError: "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED"
    });
    var reflect = function reflect2(keys2, last2) {
      if (last2 === void 0) {
        last2 = keys2.length - 1;
      }
      return {
        get: function get3() {
          return keys2.reduce(function(object4, key2) {
            return object4[key2];
          }, this);
        },
        set: function set3(value) {
          keys2.reduce(function(item, key2, i2) {
            return i2 === last2 ? item[key2] = value : item[key2];
          }, this);
        }
      };
    };
    var instantiate = function instantiate2(constructor, properties, descriptors) {
      return Object.keys(descriptors).map(function(key2) {
        return [key2, descriptors[key2]];
      }).filter(function(_ref3) {
        var descriptor = _ref3[1];
        return !!descriptor;
      }).map(function(_ref22) {
        var key2 = _ref22[0], descriptor = _ref22[1];
        return [key2, typeof descriptor === "function" ? {
          value: descriptor,
          enumerable: false
        } : typeof descriptor.reflect === "string" ? Object.assign({}, descriptor, reflect(descriptor.reflect.split("."))) : descriptor];
      }).reduce(function(instance, _ref3) {
        var key2 = _ref3[0], descriptor = _ref3[1];
        return Object.defineProperty(instance, key2, Object.assign({
          configurable: true
        }, descriptor));
      }, Object.assign(new constructor(), properties));
    };
    var ModuleErrors = function(_) {
      return {
        ImportMetaOutsideModule: _(`import.meta may appear only with 'sourceType: "module"'`, {
          code: ParseErrorCodes.SourceTypeModuleError
        }),
        ImportOutsideModule: _(`'import' and 'export' may appear only with 'sourceType: "module"'`, {
          code: ParseErrorCodes.SourceTypeModuleError
        })
      };
    };
    var NodeDescriptions = {
      ArrayPattern: "array destructuring pattern",
      AssignmentExpression: "assignment expression",
      AssignmentPattern: "assignment expression",
      ArrowFunctionExpression: "arrow function expression",
      ConditionalExpression: "conditional expression",
      ForOfStatement: "for-of statement",
      ForInStatement: "for-in statement",
      ForStatement: "for-loop",
      FormalParameters: "function parameter list",
      Identifier: "identifier",
      ObjectPattern: "object destructuring pattern",
      ParenthesizedExpression: "parenthesized expression",
      RestElement: "rest element",
      UpdateExpression: {
        "true": "prefix operation",
        "false": "postfix operation"
      },
      VariableDeclarator: "variable declaration",
      YieldExpression: "yield expression"
    };
    var toNodeDescription = function toNodeDescription2(_ref3) {
      var type5 = _ref3.type, prefix2 = _ref3.prefix;
      return type5 === "UpdateExpression" ? NodeDescriptions.UpdateExpression[String(prefix2)] : NodeDescriptions[type5];
    };
    var StandardErrors = function(_) {
      return {
        AccessorIsGenerator: _(function(_ref3) {
          var kind = _ref3.kind;
          return "A " + kind + "ter cannot be a generator.";
        }),
        ArgumentsInClass: _("'arguments' is only allowed in functions and class methods."),
        AsyncFunctionInSingleStatementContext: _("Async functions can only be declared at the top level or inside a block."),
        AwaitBindingIdentifier: _("Can not use 'await' as identifier inside an async function."),
        AwaitBindingIdentifierInStaticBlock: _("Can not use 'await' as identifier inside a static block."),
        AwaitExpressionFormalParameter: _("'await' is not allowed in async function parameters."),
        AwaitNotInAsyncContext: _("'await' is only allowed within async functions and at the top levels of modules."),
        AwaitNotInAsyncFunction: _("'await' is only allowed within async functions."),
        BadGetterArity: _("A 'get' accesor must not have any formal parameters."),
        BadSetterArity: _("A 'set' accesor must have exactly one formal parameter."),
        BadSetterRestParameter: _("A 'set' accesor function argument must not be a rest parameter."),
        ConstructorClassField: _("Classes may not have a field named 'constructor'."),
        ConstructorClassPrivateField: _("Classes may not have a private field named '#constructor'."),
        ConstructorIsAccessor: _("Class constructor may not be an accessor."),
        ConstructorIsAsync: _("Constructor can't be an async function."),
        ConstructorIsGenerator: _("Constructor can't be a generator."),
        DeclarationMissingInitializer: _(function(_ref22) {
          var kind = _ref22.kind;
          return "Missing initializer in " + kind + " declaration.";
        }),
        DecoratorBeforeExport: _("Decorators must be placed *before* the 'export' keyword. You can set the 'decoratorsBeforeExport' option to false to use the 'export @decorator class {}' syntax."),
        DecoratorConstructor: _("Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?"),
        DecoratorExportClass: _("Using the export keyword between a decorator and a class is not allowed. Please use `export @dec class` instead."),
        DecoratorSemicolon: _("Decorators must not be followed by a semicolon."),
        DecoratorStaticBlock: _("Decorators can't be used with a static block."),
        DeletePrivateField: _("Deleting a private field is not allowed."),
        DestructureNamedImport: _("ES2015 named imports do not destructure. Use another statement for destructuring after the import."),
        DuplicateConstructor: _("Duplicate constructor in the same class."),
        DuplicateDefaultExport: _("Only one default export allowed per module."),
        DuplicateExport: _(function(_ref3) {
          var exportName = _ref3.exportName;
          return "`" + exportName + "` has already been exported. Exported identifiers must be unique.";
        }),
        DuplicateProto: _("Redefinition of __proto__ property."),
        DuplicateRegExpFlags: _("Duplicate regular expression flag."),
        ElementAfterRest: _("Rest element must be last element."),
        EscapedCharNotAnIdentifier: _("Invalid Unicode escape."),
        ExportBindingIsString: _(function(_ref42) {
          var localName = _ref42.localName, exportName = _ref42.exportName;
          return "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '" + localName + "' as '" + exportName + "' } from 'some-module'`?";
        }),
        ExportDefaultFromAsIdentifier: _("'from' is not allowed as an identifier after 'export default'."),
        ForInOfLoopInitializer: _(function(_ref5) {
          var type5 = _ref5.type;
          return "'" + (type5 === "ForInStatement" ? "for-in" : "for-of") + "' loop variable declaration may not have an initializer.";
        }),
        ForOfAsync: _("The left-hand side of a for-of loop may not be 'async'."),
        ForOfLet: _("The left-hand side of a for-of loop may not start with 'let'."),
        GeneratorInSingleStatementContext: _("Generators can only be declared at the top level or inside a block."),
        IllegalBreakContinue: _(function(_ref6) {
          var type5 = _ref6.type;
          return "Unsyntactic " + (type5 === "BreakStatement" ? "break" : "continue") + ".";
        }),
        IllegalLanguageModeDirective: _("Illegal 'use strict' directive in function with non-simple parameter list."),
        IllegalReturn: _("'return' outside of function."),
        ImportBindingIsString: _(function(_ref7) {
          var importName = _ref7.importName;
          return 'A string literal cannot be used as an imported binding.\n- Did you mean `import { "' + importName + '" as foo }`?';
        }),
        ImportCallArgumentTrailingComma: _("Trailing comma is disallowed inside import(...) arguments."),
        ImportCallArity: _(function(_ref8) {
          var maxArgumentCount = _ref8.maxArgumentCount;
          return "`import()` requires exactly " + (maxArgumentCount === 1 ? "one argument" : "one or two arguments") + ".";
        }),
        ImportCallNotNewExpression: _("Cannot use new with import(...)."),
        ImportCallSpreadArgument: _("`...` is not allowed in `import()`."),
        IncompatibleRegExpUVFlags: _("The 'u' and 'v' regular expression flags cannot be enabled at the same time."),
        InvalidBigIntLiteral: _("Invalid BigIntLiteral."),
        InvalidCodePoint: _("Code point out of bounds."),
        InvalidCoverInitializedName: _("Invalid shorthand property initializer."),
        InvalidDecimal: _("Invalid decimal."),
        InvalidDigit: _(function(_ref9) {
          var radix = _ref9.radix;
          return "Expected number in radix " + radix + ".";
        }),
        InvalidEscapeSequence: _("Bad character escape sequence."),
        InvalidEscapeSequenceTemplate: _("Invalid escape sequence in template."),
        InvalidEscapedReservedWord: _(function(_ref10) {
          var reservedWord = _ref10.reservedWord;
          return "Escape sequence in keyword " + reservedWord + ".";
        }),
        InvalidIdentifier: _(function(_ref11) {
          var identifierName = _ref11.identifierName;
          return "Invalid identifier " + identifierName + ".";
        }),
        InvalidLhs: _(function(_ref12) {
          var ancestor = _ref12.ancestor;
          return "Invalid left-hand side in " + toNodeDescription(ancestor) + ".";
        }),
        InvalidLhsBinding: _(function(_ref13) {
          var ancestor = _ref13.ancestor;
          return "Binding invalid left-hand side in " + toNodeDescription(ancestor) + ".";
        }),
        InvalidNumber: _("Invalid number."),
        InvalidOrMissingExponent: _("Floating-point numbers require a valid exponent after the 'e'."),
        InvalidOrUnexpectedToken: _(function(_ref14) {
          var unexpected = _ref14.unexpected;
          return "Unexpected character '" + unexpected + "'.";
        }),
        InvalidParenthesizedAssignment: _("Invalid parenthesized assignment pattern."),
        InvalidPrivateFieldResolution: _(function(_ref15) {
          var identifierName = _ref15.identifierName;
          return "Private name #" + identifierName + " is not defined.";
        }),
        InvalidPropertyBindingPattern: _("Binding member expression."),
        InvalidRecordProperty: _("Only properties and spread elements are allowed in record definitions."),
        InvalidRestAssignmentPattern: _("Invalid rest operator's argument."),
        LabelRedeclaration: _(function(_ref16) {
          var labelName = _ref16.labelName;
          return "Label '" + labelName + "' is already declared.";
        }),
        LetInLexicalBinding: _("'let' is not allowed to be used as a name in 'let' or 'const' declarations."),
        LineTerminatorBeforeArrow: _("No line break is allowed before '=>'."),
        MalformedRegExpFlags: _("Invalid regular expression flag."),
        MissingClassName: _("A class name is required."),
        MissingEqInAssignment: _("Only '=' operator can be used for specifying default value."),
        MissingSemicolon: _("Missing semicolon."),
        MissingPlugin: _(function(_ref17) {
          var missingPlugin = _ref17.missingPlugin;
          return "This experimental syntax requires enabling the parser plugin: " + missingPlugin.map(function(name2) {
            return JSON.stringify(name2);
          }).join(", ") + ".";
        }),
        MissingOneOfPlugins: _(function(_ref18) {
          var missingPlugin = _ref18.missingPlugin;
          return "This experimental syntax requires enabling one of the following parser plugin(s): " + missingPlugin.map(function(name2) {
            return JSON.stringify(name2);
          }).join(", ") + ".";
        }),
        MissingUnicodeEscape: _("Expecting Unicode escape sequence \\uXXXX."),
        MixingCoalesceWithLogical: _("Nullish coalescing operator(??) requires parens when mixing with logical operators."),
        ModuleAttributeDifferentFromType: _("The only accepted module attribute is `type`."),
        ModuleAttributeInvalidValue: _("Only string literals are allowed as module attribute values."),
        ModuleAttributesWithDuplicateKeys: _(function(_ref19) {
          var key2 = _ref19.key;
          return 'Duplicate key "' + key2 + '" is not allowed in module attributes.';
        }),
        ModuleExportNameHasLoneSurrogate: _(function(_ref20) {
          var surrogateCharCode = _ref20.surrogateCharCode;
          return "An export name cannot include a lone surrogate, found '\\u" + surrogateCharCode.toString(16) + "'.";
        }),
        ModuleExportUndefined: _(function(_ref21) {
          var localName = _ref21.localName;
          return "Export '" + localName + "' is not defined.";
        }),
        MultipleDefaultsInSwitch: _("Multiple default clauses."),
        NewlineAfterThrow: _("Illegal newline after throw."),
        NoCatchOrFinally: _("Missing catch or finally clause."),
        NumberIdentifier: _("Identifier directly after number."),
        NumericSeparatorInEscapeSequence: _("Numeric separators are not allowed inside unicode escape sequences or hex escape sequences."),
        ObsoleteAwaitStar: _("'await*' has been removed from the async functions proposal. Use Promise.all() instead."),
        OptionalChainingNoNew: _("Constructors in/after an Optional Chain are not allowed."),
        OptionalChainingNoTemplate: _("Tagged Template Literals are not allowed in optionalChain."),
        OverrideOnConstructor: _("'override' modifier cannot appear on a constructor declaration."),
        ParamDupe: _("Argument name clash."),
        PatternHasAccessor: _("Object pattern can't contain getter or setter."),
        PatternHasMethod: _("Object pattern can't contain methods."),
        PrivateInExpectedIn: _(function(_ref22) {
          var identifierName = _ref22.identifierName;
          return "Private names are only allowed in property accesses (`obj.#" + identifierName + "`) or in `in` expressions (`#" + identifierName + " in obj`).";
        }),
        PrivateNameRedeclaration: _(function(_ref23) {
          var identifierName = _ref23.identifierName;
          return "Duplicate private name #" + identifierName + ".";
        }),
        RecordExpressionBarIncorrectEndSyntaxType: _("Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."),
        RecordExpressionBarIncorrectStartSyntaxType: _("Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."),
        RecordExpressionHashIncorrectStartSyntaxType: _("Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."),
        RecordNoProto: _("'__proto__' is not allowed in Record expressions."),
        RestTrailingComma: _("Unexpected trailing comma after rest element."),
        SloppyFunction: _("In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement."),
        StaticPrototype: _("Classes may not have static property named prototype."),
        SuperNotAllowed: _("`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?"),
        SuperPrivateField: _("Private fields can't be accessed on super."),
        TrailingDecorator: _("Decorators must be attached to a class element."),
        TupleExpressionBarIncorrectEndSyntaxType: _("Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."),
        TupleExpressionBarIncorrectStartSyntaxType: _("Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."),
        TupleExpressionHashIncorrectStartSyntaxType: _("Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."),
        UnexpectedArgumentPlaceholder: _("Unexpected argument placeholder."),
        UnexpectedAwaitAfterPipelineBody: _('Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.'),
        UnexpectedDigitAfterHash: _("Unexpected digit after hash token."),
        UnexpectedImportExport: _("'import' and 'export' may only appear at the top level."),
        UnexpectedKeyword: _(function(_ref24) {
          var keyword2 = _ref24.keyword;
          return "Unexpected keyword '" + keyword2 + "'.";
        }),
        UnexpectedLeadingDecorator: _("Leading decorators must be attached to a class declaration."),
        UnexpectedLexicalDeclaration: _("Lexical declaration cannot appear in a single-statement context."),
        UnexpectedNewTarget: _("`new.target` can only be used in functions or class properties."),
        UnexpectedNumericSeparator: _("A numeric separator is only allowed between two digits."),
        UnexpectedPrivateField: _("Unexpected private name."),
        UnexpectedReservedWord: _(function(_ref25) {
          var reservedWord = _ref25.reservedWord;
          return "Unexpected reserved word '" + reservedWord + "'.";
        }),
        UnexpectedSuper: _("'super' is only allowed in object methods and classes."),
        UnexpectedToken: _(function(_ref26) {
          var expected = _ref26.expected, unexpected = _ref26.unexpected;
          return "Unexpected token" + (unexpected ? " '" + unexpected + "'." : "") + (expected ? ', expected "' + expected + '"' : "");
        }),
        UnexpectedTokenUnaryExponentiation: _("Illegal expression. Wrap left hand side or entire exponentiation in parentheses."),
        UnsupportedBind: _("Binding should be performed on object property."),
        UnsupportedDecoratorExport: _("A decorated export must export a class declaration."),
        UnsupportedDefaultExport: _("Only expressions, functions or classes are allowed as the `default` export."),
        UnsupportedImport: _("`import` can only be used in `import()` or `import.meta`."),
        UnsupportedMetaProperty: _(function(_ref27) {
          var target = _ref27.target, onlyValidPropertyName = _ref27.onlyValidPropertyName;
          return "The only valid meta property for " + target + " is " + target + "." + onlyValidPropertyName + ".";
        }),
        UnsupportedParameterDecorator: _("Decorators cannot be used to decorate parameters."),
        UnsupportedPropertyDecorator: _("Decorators cannot be used to decorate object literal properties."),
        UnsupportedSuper: _("'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop])."),
        UnterminatedComment: _("Unterminated comment."),
        UnterminatedRegExp: _("Unterminated regular expression."),
        UnterminatedString: _("Unterminated string constant."),
        UnterminatedTemplate: _("Unterminated template."),
        VarRedeclaration: _(function(_ref28) {
          var identifierName = _ref28.identifierName;
          return "Identifier '" + identifierName + "' has already been declared.";
        }),
        YieldBindingIdentifier: _("Can not use 'yield' as identifier inside a generator."),
        YieldInParameter: _("Yield expression is not allowed in formal parameters."),
        ZeroDigitNumericSeparator: _("Numeric separator can not be used after leading 0.")
      };
    };
    var StrictModeErrors = function(_) {
      return {
        StrictDelete: _("Deleting local variable in strict mode."),
        StrictEvalArguments: _(function(_ref3) {
          var referenceName = _ref3.referenceName;
          return "Assigning to '" + referenceName + "' in strict mode.";
        }),
        StrictEvalArgumentsBinding: _(function(_ref22) {
          var bindingName = _ref22.bindingName;
          return "Binding '" + bindingName + "' in strict mode.";
        }),
        StrictFunction: _("In strict mode code, functions can only be declared at top level or inside a block."),
        StrictNumericEscape: _("The only valid numeric escape in strict mode is '\\0'."),
        StrictOctalLiteral: _("Legacy octal literals are not allowed in strict mode."),
        StrictWith: _("'with' in strict mode.")
      };
    };
    var UnparenthesizedPipeBodyDescriptions = /* @__PURE__ */ new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]);
    var PipelineOperatorErrors = function(_) {
      return {
        PipeBodyIsTighter: _("Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence."),
        PipeTopicRequiresHackPipes: _('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'),
        PipeTopicUnbound: _("Topic reference is unbound; it must be inside a pipe body."),
        PipeTopicUnconfiguredToken: _(function(_ref3) {
          var token = _ref3.token;
          return "Invalid topic token " + token + ". In order to use " + token + ' as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "' + token + '" }.';
        }),
        PipeTopicUnused: _("Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once."),
        PipeUnparenthesizedBody: _(function(_ref22) {
          var type5 = _ref22.type;
          return "Hack-style pipe body cannot be an unparenthesized " + toNodeDescription({
            type: type5
          }) + "; please wrap it in parentheses.";
        }),
        PipelineBodyNoArrow: _('Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.'),
        PipelineBodySequenceExpression: _("Pipeline body may not be a comma-separated sequence expression."),
        PipelineHeadSequenceExpression: _("Pipeline head should not be a comma-separated sequence expression."),
        PipelineTopicUnused: _("Pipeline is in topic style but does not use topic reference."),
        PrimaryTopicNotAllowed: _("Topic reference was used in a lexical context without topic binding."),
        PrimaryTopicRequiresSmartPipeline: _('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.')
      };
    };
    var _templateObject$t;
    var _excluded$52 = ["toMessage"];
    function toParseErrorConstructor(_ref3) {
      var toMessage = _ref3.toMessage, properties = _objectWithoutPropertiesLoose2(_ref3, _excluded$52);
      return function constructor(_ref22) {
        var loc = _ref22.loc, details = _ref22.details;
        return instantiate(SyntaxError, Object.assign({}, properties, {
          loc
        }), {
          clone: function clone4(overrides) {
            if (overrides === void 0) {
              overrides = {};
            }
            var loc2 = overrides.loc || {};
            return constructor({
              loc: new Position3("line" in loc2 ? loc2.line : this.loc.line, "column" in loc2 ? loc2.column : this.loc.column, "index" in loc2 ? loc2.index : this.loc.index),
              details: Object.assign({}, this.details, overrides.details)
            });
          },
          details: {
            value: details,
            enumerable: false
          },
          message: {
            get: function get3() {
              return toMessage(this.details) + " (" + this.loc.line + ":" + this.loc.column + ")";
            },
            set: function set3(value) {
              Object.defineProperty(this, "message", {
                value
              });
            }
          },
          pos: {
            reflect: "loc.index",
            enumerable: true
          },
          missingPlugin: "missingPlugin" in details && {
            reflect: "details.missingPlugin",
            enumerable: true
          }
        });
      };
    }
    function toParseErrorCredentials(toMessageOrMessage, credentials) {
      return Object.assign({
        toMessage: typeof toMessageOrMessage === "string" ? function() {
          return toMessageOrMessage;
        } : toMessageOrMessage
      }, credentials);
    }
    function ParseErrorEnum(argument, syntaxPlugin) {
      if (Array.isArray(argument)) {
        return function(toParseErrorCredentialsMap) {
          return ParseErrorEnum(toParseErrorCredentialsMap, argument[0]);
        };
      }
      var partialCredentials = argument(toParseErrorCredentials);
      var ParseErrorConstructors = {};
      for (var _i22 = 0, _Object$keys22 = Object.keys(partialCredentials); _i22 < _Object$keys22.length; _i22++) {
        var reasonCode = _Object$keys22[_i22];
        ParseErrorConstructors[reasonCode] = toParseErrorConstructor(Object.assign({
          code: ParseErrorCodes.SyntaxError,
          reasonCode
        }, syntaxPlugin ? {
          syntaxPlugin
        } : {}, partialCredentials[reasonCode]));
      }
      return ParseErrorConstructors;
    }
    var Errors = Object.assign({}, ParseErrorEnum(ModuleErrors), ParseErrorEnum(StandardErrors), ParseErrorEnum(StrictModeErrors), ParseErrorEnum(_templateObject$t || (_templateObject$t = _taggedTemplateLiteralLoose(["pipelineOperator"])))(PipelineOperatorErrors));
    var defineProperty = Object.defineProperty;
    var toUnenumerable = function toUnenumerable2(object4, key2) {
      return defineProperty(object4, key2, {
        enumerable: false,
        value: object4[key2]
      });
    };
    function toESTreeLocation(node2) {
      toUnenumerable(node2.loc.start, "index");
      toUnenumerable(node2.loc.end, "index");
      return node2;
    }
    var estree = function(superClass) {
      return function(_superClass) {
        _inherits2(_class, _superClass);
        function _class() {
          return _superClass.apply(this, arguments) || this;
        }
        var _proto = _class.prototype;
        _proto.parse = function parse5() {
          var file2 = toESTreeLocation(_superClass.prototype.parse.call(this));
          if (this.options.tokens) {
            file2.tokens = file2.tokens.map(toESTreeLocation);
          }
          return file2;
        };
        _proto.parseRegExpLiteral = function parseRegExpLiteral(_ref3) {
          var pattern5 = _ref3.pattern, flags = _ref3.flags;
          var regex2 = null;
          try {
            regex2 = new RegExp(pattern5, flags);
          } catch (e2) {
          }
          var node2 = this.estreeParseLiteral(regex2);
          node2.regex = {
            pattern: pattern5,
            flags
          };
          return node2;
        };
        _proto.parseBigIntLiteral = function parseBigIntLiteral(value) {
          var bigInt;
          try {
            bigInt = BigInt(value);
          } catch (_unused) {
            bigInt = null;
          }
          var node2 = this.estreeParseLiteral(bigInt);
          node2.bigint = String(node2.value || value);
          return node2;
        };
        _proto.parseDecimalLiteral = function parseDecimalLiteral(value) {
          var decimal = null;
          var node2 = this.estreeParseLiteral(decimal);
          node2.decimal = String(node2.value || value);
          return node2;
        };
        _proto.estreeParseLiteral = function estreeParseLiteral(value) {
          return this.parseLiteral(value, "Literal");
        };
        _proto.parseStringLiteral = function parseStringLiteral(value) {
          return this.estreeParseLiteral(value);
        };
        _proto.parseNumericLiteral = function parseNumericLiteral(value) {
          return this.estreeParseLiteral(value);
        };
        _proto.parseNullLiteral = function parseNullLiteral() {
          return this.estreeParseLiteral(null);
        };
        _proto.parseBooleanLiteral = function parseBooleanLiteral(value) {
          return this.estreeParseLiteral(value);
        };
        _proto.directiveToStmt = function directiveToStmt(directive2) {
          var directiveLiteral2 = directive2.value;
          var stmt = this.startNodeAt(directive2.start, directive2.loc.start);
          var expression2 = this.startNodeAt(directiveLiteral2.start, directiveLiteral2.loc.start);
          expression2.value = directiveLiteral2.extra.expressionValue;
          expression2.raw = directiveLiteral2.extra.raw;
          stmt.expression = this.finishNodeAt(expression2, "Literal", directiveLiteral2.loc.end);
          stmt.directive = directiveLiteral2.extra.raw.slice(1, -1);
          return this.finishNodeAt(stmt, "ExpressionStatement", directive2.loc.end);
        };
        _proto.initFunction = function initFunction(node2, isAsync2) {
          _superClass.prototype.initFunction.call(this, node2, isAsync2);
          node2.expression = false;
        };
        _proto.checkDeclaration = function checkDeclaration(node2) {
          if (node2 != null && this.isObjectProperty(node2)) {
            this.checkDeclaration(node2.value);
          } else {
            _superClass.prototype.checkDeclaration.call(this, node2);
          }
        };
        _proto.getObjectOrClassMethodParams = function getObjectOrClassMethodParams(method5) {
          return method5.value.params;
        };
        _proto.isValidDirective = function isValidDirective(stmt) {
          var _stmt$expression$extr;
          return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !((_stmt$expression$extr = stmt.expression.extra) != null && _stmt$expression$extr.parenthesized);
        };
        _proto.parseBlockBody = function parseBlockBody(node2) {
          var _superClass$prototype, _this = this;
          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }
          (_superClass$prototype = _superClass.prototype.parseBlockBody).call.apply(_superClass$prototype, [this, node2].concat(args));
          var directiveStatements = node2.directives.map(function(d2) {
            return _this.directiveToStmt(d2);
          });
          node2.body = directiveStatements.concat(node2.body);
          delete node2.directives;
        };
        _proto.pushClassMethod = function pushClassMethod(classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper) {
          this.parseMethod(method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper, "ClassMethod", true);
          if (method5.typeParameters) {
            method5.value.typeParameters = method5.typeParameters;
            delete method5.typeParameters;
          }
          classBody2.body.push(method5);
        };
        _proto.parsePrivateName = function parsePrivateName() {
          var node2 = _superClass.prototype.parsePrivateName.call(this);
          {
            if (!this.getPluginOption("estree", "classFeatures")) {
              return node2;
            }
          }
          return this.convertPrivateNameToPrivateIdentifier(node2);
        };
        _proto.convertPrivateNameToPrivateIdentifier = function convertPrivateNameToPrivateIdentifier(node2) {
          var name2 = _superClass.prototype.getPrivateNameSV.call(this, node2);
          node2 = node2;
          delete node2.id;
          node2.name = name2;
          node2.type = "PrivateIdentifier";
          return node2;
        };
        _proto.isPrivateName = function isPrivateName2(node2) {
          {
            if (!this.getPluginOption("estree", "classFeatures")) {
              return _superClass.prototype.isPrivateName.call(this, node2);
            }
          }
          return node2.type === "PrivateIdentifier";
        };
        _proto.getPrivateNameSV = function getPrivateNameSV(node2) {
          {
            if (!this.getPluginOption("estree", "classFeatures")) {
              return _superClass.prototype.getPrivateNameSV.call(this, node2);
            }
          }
          return node2.name;
        };
        _proto.parseLiteral = function parseLiteral(value, type5) {
          var node2 = _superClass.prototype.parseLiteral.call(this, value, type5);
          node2.raw = node2.extra.raw;
          delete node2.extra;
          return node2;
        };
        _proto.parseFunctionBody = function parseFunctionBody(node2, allowExpression, isMethod2) {
          if (isMethod2 === void 0) {
            isMethod2 = false;
          }
          _superClass.prototype.parseFunctionBody.call(this, node2, allowExpression, isMethod2);
          node2.expression = node2.body.type !== "BlockStatement";
        };
        _proto.parseMethod = function parseMethod(node2, isGenerator, isAsync2, isConstructor, allowDirectSuper, type5, inClassScope) {
          if (inClassScope === void 0) {
            inClassScope = false;
          }
          var funcNode = this.startNode();
          funcNode.kind = node2.kind;
          funcNode = _superClass.prototype.parseMethod.call(this, funcNode, isGenerator, isAsync2, isConstructor, allowDirectSuper, type5, inClassScope);
          funcNode.type = "FunctionExpression";
          delete funcNode.kind;
          node2.value = funcNode;
          if (type5 === "ClassPrivateMethod") {
            node2.computed = false;
          }
          type5 = "MethodDefinition";
          return this.finishNode(node2, type5);
        };
        _proto.parseClassProperty = function parseClassProperty() {
          var _superClass$prototype2;
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }
          var propertyNode = (_superClass$prototype2 = _superClass.prototype.parseClassProperty).call.apply(_superClass$prototype2, [this].concat(args));
          {
            if (!this.getPluginOption("estree", "classFeatures")) {
              return propertyNode;
            }
          }
          propertyNode.type = "PropertyDefinition";
          return propertyNode;
        };
        _proto.parseClassPrivateProperty = function parseClassPrivateProperty() {
          var _superClass$prototype3;
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }
          var propertyNode = (_superClass$prototype3 = _superClass.prototype.parseClassPrivateProperty).call.apply(_superClass$prototype3, [this].concat(args));
          {
            if (!this.getPluginOption("estree", "classFeatures")) {
              return propertyNode;
            }
          }
          propertyNode.type = "PropertyDefinition";
          propertyNode.computed = false;
          return propertyNode;
        };
        _proto.parseObjectMethod = function parseObjectMethod(prop2, isGenerator, isAsync2, isPattern3, isAccessor2) {
          var node2 = _superClass.prototype.parseObjectMethod.call(this, prop2, isGenerator, isAsync2, isPattern3, isAccessor2);
          if (node2) {
            node2.type = "Property";
            if (node2.kind === "method")
              node2.kind = "init";
            node2.shorthand = false;
          }
          return node2;
        };
        _proto.parseObjectProperty = function parseObjectProperty(prop2, startPos, startLoc, isPattern3, refExpressionErrors) {
          var node2 = _superClass.prototype.parseObjectProperty.call(this, prop2, startPos, startLoc, isPattern3, refExpressionErrors);
          if (node2) {
            node2.kind = "init";
            node2.type = "Property";
          }
          return node2;
        };
        _proto.isValidLVal = function isValidLVal(type5) {
          var _superClass$prototype4;
          for (var _len4 = arguments.length, rest = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
            rest[_key4 - 1] = arguments[_key4];
          }
          return type5 === "Property" ? "value" : (_superClass$prototype4 = _superClass.prototype.isValidLVal).call.apply(_superClass$prototype4, [this, type5].concat(rest));
        };
        _proto.isAssignable = function isAssignable(node2, isBinding2) {
          if (node2 != null && this.isObjectProperty(node2)) {
            return this.isAssignable(node2.value, isBinding2);
          }
          return _superClass.prototype.isAssignable.call(this, node2, isBinding2);
        };
        _proto.toAssignable = function toAssignable(node2, isLHS) {
          if (isLHS === void 0) {
            isLHS = false;
          }
          if (node2 != null && this.isObjectProperty(node2)) {
            var key2 = node2.key, value = node2.value;
            if (this.isPrivateName(key2)) {
              this.classScope.usePrivateName(this.getPrivateNameSV(key2), key2.loc.start);
            }
            this.toAssignable(value, isLHS);
            return node2;
          }
          return _superClass.prototype.toAssignable.call(this, node2, isLHS);
        };
        _proto.toAssignableObjectExpressionProp = function toAssignableObjectExpressionProp(prop2) {
          if (prop2.kind === "get" || prop2.kind === "set") {
            this.raise(Errors.PatternHasAccessor, {
              at: prop2.key
            });
          } else if (prop2.method) {
            this.raise(Errors.PatternHasMethod, {
              at: prop2.key
            });
          } else {
            var _superClass$prototype5;
            for (var _len5 = arguments.length, args = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
              args[_key5 - 1] = arguments[_key5];
            }
            (_superClass$prototype5 = _superClass.prototype.toAssignableObjectExpressionProp).call.apply(_superClass$prototype5, [this, prop2].concat(args));
          }
        };
        _proto.finishCallExpression = function finishCallExpression(node2, optional) {
          _superClass.prototype.finishCallExpression.call(this, node2, optional);
          if (node2.callee.type === "Import") {
            node2.type = "ImportExpression";
            node2.source = node2.arguments[0];
            if (this.hasPlugin("importAssertions")) {
              var _node$arguments$;
              node2.attributes = (_node$arguments$ = node2.arguments[1]) != null ? _node$arguments$ : null;
            }
            delete node2.arguments;
            delete node2.callee;
          }
          return node2;
        };
        _proto.toReferencedArguments = function toReferencedArguments(node2) {
          if (node2.type === "ImportExpression") {
            return;
          }
          _superClass.prototype.toReferencedArguments.call(this, node2);
        };
        _proto.parseExport = function parseExport(node2) {
          _superClass.prototype.parseExport.call(this, node2);
          switch (node2.type) {
            case "ExportAllDeclaration":
              node2.exported = null;
              break;
            case "ExportNamedDeclaration":
              if (node2.specifiers.length === 1 && node2.specifiers[0].type === "ExportNamespaceSpecifier") {
                node2.type = "ExportAllDeclaration";
                node2.exported = node2.specifiers[0].exported;
                delete node2.specifiers;
              }
              break;
          }
          return node2;
        };
        _proto.parseSubscript = function parseSubscript(base2, startPos, startLoc, noCalls, state) {
          var node2 = _superClass.prototype.parseSubscript.call(this, base2, startPos, startLoc, noCalls, state);
          if (state.optionalChainMember) {
            if (node2.type === "OptionalMemberExpression" || node2.type === "OptionalCallExpression") {
              node2.type = node2.type.substring(8);
            }
            if (state.stop) {
              var chain2 = this.startNodeAtNode(node2);
              chain2.expression = node2;
              return this.finishNode(chain2, "ChainExpression");
            }
          } else if (node2.type === "MemberExpression" || node2.type === "CallExpression") {
            node2.optional = false;
          }
          return node2;
        };
        _proto.hasPropertyAsPrivateName = function hasPropertyAsPrivateName(node2) {
          if (node2.type === "ChainExpression") {
            node2 = node2.expression;
          }
          return _superClass.prototype.hasPropertyAsPrivateName.call(this, node2);
        };
        _proto.isOptionalChain = function isOptionalChain(node2) {
          return node2.type === "ChainExpression";
        };
        _proto.isObjectProperty = function isObjectProperty2(node2) {
          return node2.type === "Property" && node2.kind === "init" && !node2.method;
        };
        _proto.isObjectMethod = function isObjectMethod2(node2) {
          return node2.method || node2.kind === "get" || node2.kind === "set";
        };
        _proto.finishNodeAt = function finishNodeAt2(node2, type5, endLoc) {
          return toESTreeLocation(_superClass.prototype.finishNodeAt.call(this, node2, type5, endLoc));
        };
        _proto.resetEndLocation = function resetEndLocation(node2, endLoc) {
          if (endLoc === void 0) {
            endLoc = this.state.lastTokEndLoc;
          }
          _superClass.prototype.resetEndLocation.call(this, node2, endLoc);
          toESTreeLocation(node2);
        };
        return _createClass2(_class);
      }(superClass);
    };
    var TokContext3 = _createClass2(function TokContext4(token, preserveSpace) {
      this.token = void 0;
      this.preserveSpace = void 0;
      this.token = token;
      this.preserveSpace = !!preserveSpace;
    });
    var types2 = {
      brace: new TokContext3("{"),
      j_oTag: new TokContext3("<tag"),
      j_cTag: new TokContext3("</tag"),
      j_expr: new TokContext3("<tag>...</tag>", true)
    };
    {
      types2.template = new TokContext3("`", true);
    }
    var beforeExpr2 = true;
    var startsExpr2 = true;
    var isLoop = true;
    var isAssign = true;
    var prefix = true;
    var postfix = true;
    var ExportedTokenType = _createClass2(function ExportedTokenType2(label, conf) {
      if (conf === void 0) {
        conf = {};
      }
      this.label = void 0;
      this.keyword = void 0;
      this.beforeExpr = void 0;
      this.startsExpr = void 0;
      this.rightAssociative = void 0;
      this.isLoop = void 0;
      this.isAssign = void 0;
      this.prefix = void 0;
      this.postfix = void 0;
      this.binop = void 0;
      this.label = label;
      this.keyword = conf.keyword;
      this.beforeExpr = !!conf.beforeExpr;
      this.startsExpr = !!conf.startsExpr;
      this.rightAssociative = !!conf.rightAssociative;
      this.isLoop = !!conf.isLoop;
      this.isAssign = !!conf.isAssign;
      this.prefix = !!conf.prefix;
      this.postfix = !!conf.postfix;
      this.binop = conf.binop != null ? conf.binop : null;
      {
        this.updateContext = null;
      }
    });
    var keywords2 = /* @__PURE__ */ new Map();
    function createKeyword(name2, options) {
      if (options === void 0) {
        options = {};
      }
      options.keyword = name2;
      var token = createToken(name2, options);
      keywords2.set(name2, token);
      return token;
    }
    function createBinop(name2, binop2) {
      return createToken(name2, {
        beforeExpr: beforeExpr2,
        binop: binop2
      });
    }
    var tokenTypeCounter = -1;
    var tokenTypes = [];
    var tokenLabels = [];
    var tokenBinops = [];
    var tokenBeforeExprs = [];
    var tokenStartsExprs = [];
    var tokenPrefixes = [];
    function createToken(name2, options) {
      var _options$binop, _options$beforeExpr, _options$startsExpr, _options$prefix;
      if (options === void 0) {
        options = {};
      }
      ++tokenTypeCounter;
      tokenLabels.push(name2);
      tokenBinops.push((_options$binop = options.binop) != null ? _options$binop : -1);
      tokenBeforeExprs.push((_options$beforeExpr = options.beforeExpr) != null ? _options$beforeExpr : false);
      tokenStartsExprs.push((_options$startsExpr = options.startsExpr) != null ? _options$startsExpr : false);
      tokenPrefixes.push((_options$prefix = options.prefix) != null ? _options$prefix : false);
      tokenTypes.push(new ExportedTokenType(name2, options));
      return tokenTypeCounter;
    }
    function createKeywordLike(name2, options) {
      var _options$binop2, _options$beforeExpr2, _options$startsExpr2, _options$prefix2;
      if (options === void 0) {
        options = {};
      }
      ++tokenTypeCounter;
      keywords2.set(name2, tokenTypeCounter);
      tokenLabels.push(name2);
      tokenBinops.push((_options$binop2 = options.binop) != null ? _options$binop2 : -1);
      tokenBeforeExprs.push((_options$beforeExpr2 = options.beforeExpr) != null ? _options$beforeExpr2 : false);
      tokenStartsExprs.push((_options$startsExpr2 = options.startsExpr) != null ? _options$startsExpr2 : false);
      tokenPrefixes.push((_options$prefix2 = options.prefix) != null ? _options$prefix2 : false);
      tokenTypes.push(new ExportedTokenType("name", options));
      return tokenTypeCounter;
    }
    var tt = {
      bracketL: createToken("[", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      bracketHashL: createToken("#[", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      bracketBarL: createToken("[|", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      bracketR: createToken("]"),
      bracketBarR: createToken("|]"),
      braceL: createToken("{", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      braceBarL: createToken("{|", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      braceHashL: createToken("#{", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      braceR: createToken("}", {
        beforeExpr: beforeExpr2
      }),
      braceBarR: createToken("|}"),
      parenL: createToken("(", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      parenR: createToken(")"),
      comma: createToken(",", {
        beforeExpr: beforeExpr2
      }),
      semi: createToken(";", {
        beforeExpr: beforeExpr2
      }),
      colon: createToken(":", {
        beforeExpr: beforeExpr2
      }),
      doubleColon: createToken("::", {
        beforeExpr: beforeExpr2
      }),
      dot: createToken("."),
      question: createToken("?", {
        beforeExpr: beforeExpr2
      }),
      questionDot: createToken("?."),
      arrow: createToken("=>", {
        beforeExpr: beforeExpr2
      }),
      template: createToken("template"),
      ellipsis: createToken("...", {
        beforeExpr: beforeExpr2
      }),
      backQuote: createToken("`", {
        startsExpr: startsExpr2
      }),
      dollarBraceL: createToken("${", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      templateTail: createToken("...`", {
        startsExpr: startsExpr2
      }),
      templateNonTail: createToken("...${", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      at: createToken("@"),
      hash: createToken("#", {
        startsExpr: startsExpr2
      }),
      interpreterDirective: createToken("#!..."),
      eq: createToken("=", {
        beforeExpr: beforeExpr2,
        isAssign
      }),
      assign: createToken("_=", {
        beforeExpr: beforeExpr2,
        isAssign
      }),
      slashAssign: createToken("_=", {
        beforeExpr: beforeExpr2,
        isAssign
      }),
      xorAssign: createToken("_=", {
        beforeExpr: beforeExpr2,
        isAssign
      }),
      moduloAssign: createToken("_=", {
        beforeExpr: beforeExpr2,
        isAssign
      }),
      incDec: createToken("++/--", {
        prefix,
        postfix,
        startsExpr: startsExpr2
      }),
      bang: createToken("!", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      tilde: createToken("~", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      doubleCaret: createToken("^^", {
        startsExpr: startsExpr2
      }),
      doubleAt: createToken("@@", {
        startsExpr: startsExpr2
      }),
      pipeline: createBinop("|>", 0),
      nullishCoalescing: createBinop("??", 1),
      logicalOR: createBinop("||", 1),
      logicalAND: createBinop("&&", 2),
      bitwiseOR: createBinop("|", 3),
      bitwiseXOR: createBinop("^", 4),
      bitwiseAND: createBinop("&", 5),
      equality: createBinop("==/!=/===/!==", 6),
      lt: createBinop("</>/<=/>=", 7),
      gt: createBinop("</>/<=/>=", 7),
      relational: createBinop("</>/<=/>=", 7),
      bitShift: createBinop("<</>>/>>>", 8),
      bitShiftL: createBinop("<</>>/>>>", 8),
      bitShiftR: createBinop("<</>>/>>>", 8),
      plusMin: createToken("+/-", {
        beforeExpr: beforeExpr2,
        binop: 9,
        prefix,
        startsExpr: startsExpr2
      }),
      modulo: createToken("%", {
        binop: 10,
        startsExpr: startsExpr2
      }),
      star: createToken("*", {
        binop: 10
      }),
      slash: createBinop("/", 10),
      exponent: createToken("**", {
        beforeExpr: beforeExpr2,
        binop: 11,
        rightAssociative: true
      }),
      _in: createKeyword("in", {
        beforeExpr: beforeExpr2,
        binop: 7
      }),
      _instanceof: createKeyword("instanceof", {
        beforeExpr: beforeExpr2,
        binop: 7
      }),
      _break: createKeyword("break"),
      _case: createKeyword("case", {
        beforeExpr: beforeExpr2
      }),
      _catch: createKeyword("catch"),
      _continue: createKeyword("continue"),
      _debugger: createKeyword("debugger"),
      _default: createKeyword("default", {
        beforeExpr: beforeExpr2
      }),
      _else: createKeyword("else", {
        beforeExpr: beforeExpr2
      }),
      _finally: createKeyword("finally"),
      _function: createKeyword("function", {
        startsExpr: startsExpr2
      }),
      _if: createKeyword("if"),
      _return: createKeyword("return", {
        beforeExpr: beforeExpr2
      }),
      _switch: createKeyword("switch"),
      _throw: createKeyword("throw", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      _try: createKeyword("try"),
      _var: createKeyword("var"),
      _const: createKeyword("const"),
      _with: createKeyword("with"),
      _new: createKeyword("new", {
        beforeExpr: beforeExpr2,
        startsExpr: startsExpr2
      }),
      _this: createKeyword("this", {
        startsExpr: startsExpr2
      }),
      _super: createKeyword("super", {
        startsExpr: startsExpr2
      }),
      _class: createKeyword("class", {
        startsExpr: startsExpr2
      }),
      _extends: createKeyword("extends", {
        beforeExpr: beforeExpr2
      }),
      _export: createKeyword("export"),
      _import: createKeyword("import", {
        startsExpr: startsExpr2
      }),
      _null: createKeyword("null", {
        startsExpr: startsExpr2
      }),
      _true: createKeyword("true", {
        startsExpr: startsExpr2
      }),
      _false: createKeyword("false", {
        startsExpr: startsExpr2
      }),
      _typeof: createKeyword("typeof", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      _void: createKeyword("void", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      _delete: createKeyword("delete", {
        beforeExpr: beforeExpr2,
        prefix,
        startsExpr: startsExpr2
      }),
      _do: createKeyword("do", {
        isLoop,
        beforeExpr: beforeExpr2
      }),
      _for: createKeyword("for", {
        isLoop
      }),
      _while: createKeyword("while", {
        isLoop
      }),
      _as: createKeywordLike("as", {
        startsExpr: startsExpr2
      }),
      _assert: createKeywordLike("assert", {
        startsExpr: startsExpr2
      }),
      _async: createKeywordLike("async", {
        startsExpr: startsExpr2
      }),
      _await: createKeywordLike("await", {
        startsExpr: startsExpr2
      }),
      _from: createKeywordLike("from", {
        startsExpr: startsExpr2
      }),
      _get: createKeywordLike("get", {
        startsExpr: startsExpr2
      }),
      _let: createKeywordLike("let", {
        startsExpr: startsExpr2
      }),
      _meta: createKeywordLike("meta", {
        startsExpr: startsExpr2
      }),
      _of: createKeywordLike("of", {
        startsExpr: startsExpr2
      }),
      _sent: createKeywordLike("sent", {
        startsExpr: startsExpr2
      }),
      _set: createKeywordLike("set", {
        startsExpr: startsExpr2
      }),
      _static: createKeywordLike("static", {
        startsExpr: startsExpr2
      }),
      _yield: createKeywordLike("yield", {
        startsExpr: startsExpr2
      }),
      _asserts: createKeywordLike("asserts", {
        startsExpr: startsExpr2
      }),
      _checks: createKeywordLike("checks", {
        startsExpr: startsExpr2
      }),
      _exports: createKeywordLike("exports", {
        startsExpr: startsExpr2
      }),
      _global: createKeywordLike("global", {
        startsExpr: startsExpr2
      }),
      _implements: createKeywordLike("implements", {
        startsExpr: startsExpr2
      }),
      _intrinsic: createKeywordLike("intrinsic", {
        startsExpr: startsExpr2
      }),
      _infer: createKeywordLike("infer", {
        startsExpr: startsExpr2
      }),
      _is: createKeywordLike("is", {
        startsExpr: startsExpr2
      }),
      _mixins: createKeywordLike("mixins", {
        startsExpr: startsExpr2
      }),
      _proto: createKeywordLike("proto", {
        startsExpr: startsExpr2
      }),
      _require: createKeywordLike("require", {
        startsExpr: startsExpr2
      }),
      _keyof: createKeywordLike("keyof", {
        startsExpr: startsExpr2
      }),
      _readonly: createKeywordLike("readonly", {
        startsExpr: startsExpr2
      }),
      _unique: createKeywordLike("unique", {
        startsExpr: startsExpr2
      }),
      _abstract: createKeywordLike("abstract", {
        startsExpr: startsExpr2
      }),
      _declare: createKeywordLike("declare", {
        startsExpr: startsExpr2
      }),
      _enum: createKeywordLike("enum", {
        startsExpr: startsExpr2
      }),
      _module: createKeywordLike("module", {
        startsExpr: startsExpr2
      }),
      _namespace: createKeywordLike("namespace", {
        startsExpr: startsExpr2
      }),
      _interface: createKeywordLike("interface", {
        startsExpr: startsExpr2
      }),
      _type: createKeywordLike("type", {
        startsExpr: startsExpr2
      }),
      _opaque: createKeywordLike("opaque", {
        startsExpr: startsExpr2
      }),
      name: createToken("name", {
        startsExpr: startsExpr2
      }),
      string: createToken("string", {
        startsExpr: startsExpr2
      }),
      num: createToken("num", {
        startsExpr: startsExpr2
      }),
      bigint: createToken("bigint", {
        startsExpr: startsExpr2
      }),
      decimal: createToken("decimal", {
        startsExpr: startsExpr2
      }),
      regexp: createToken("regexp", {
        startsExpr: startsExpr2
      }),
      privateName: createToken("#name", {
        startsExpr: startsExpr2
      }),
      eof: createToken("eof"),
      jsxName: createToken("jsxName"),
      jsxText: createToken("jsxText", {
        beforeExpr: true
      }),
      jsxTagStart: createToken("jsxTagStart", {
        startsExpr: true
      }),
      jsxTagEnd: createToken("jsxTagEnd"),
      placeholder: createToken("%%", {
        startsExpr: true
      })
    };
    function tokenIsIdentifier(token) {
      return token >= 93 && token <= 128;
    }
    function tokenKeywordOrIdentifierIsKeyword(token) {
      return token <= 92;
    }
    function tokenIsKeywordOrIdentifier(token) {
      return token >= 58 && token <= 128;
    }
    function tokenIsLiteralPropertyName(token) {
      return token >= 58 && token <= 132;
    }
    function tokenComesBeforeExpression(token) {
      return tokenBeforeExprs[token];
    }
    function tokenCanStartExpression(token) {
      return tokenStartsExprs[token];
    }
    function tokenIsAssignment(token) {
      return token >= 29 && token <= 33;
    }
    function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
      return token >= 125 && token <= 127;
    }
    function tokenIsLoop(token) {
      return token >= 90 && token <= 92;
    }
    function tokenIsKeyword(token) {
      return token >= 58 && token <= 92;
    }
    function tokenIsOperator(token) {
      return token >= 39 && token <= 59;
    }
    function tokenIsPostfix(token) {
      return token === 34;
    }
    function tokenIsPrefix(token) {
      return tokenPrefixes[token];
    }
    function tokenIsTSTypeOperator(token) {
      return token >= 117 && token <= 119;
    }
    function tokenIsTSDeclarationStart(token) {
      return token >= 120 && token <= 126;
    }
    function tokenLabelName(token) {
      return tokenLabels[token];
    }
    function tokenOperatorPrecedence(token) {
      return tokenBinops[token];
    }
    function tokenIsRightAssociative(token) {
      return token === 57;
    }
    function tokenIsTemplate(token) {
      return token >= 24 && token <= 25;
    }
    function getExportedToken(token) {
      return tokenTypes[token];
    }
    {
      tokenTypes[8].updateContext = function(context) {
        context.pop();
      };
      tokenTypes[5].updateContext = tokenTypes[7].updateContext = tokenTypes[23].updateContext = function(context) {
        context.push(types2.brace);
      };
      tokenTypes[22].updateContext = function(context) {
        if (context[context.length - 1] === types2.template) {
          context.pop();
        } else {
          context.push(types2.template);
        }
      };
      tokenTypes[138].updateContext = function(context) {
        context.push(types2.j_expr, types2.j_oTag);
      };
    }
    function isIteratorStart(current2, next, next2) {
      return current2 === 64 && next === 64 && isIdentifierStart2(next2);
    }
    var reservedWordLikeSet = /* @__PURE__ */ new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
    function canBeReservedWord(word) {
      return reservedWordLikeSet.has(word);
    }
    var SCOPE_OTHER = 0, SCOPE_PROGRAM = 1, SCOPE_FUNCTION2 = 2, SCOPE_ARROW2 = 4, SCOPE_SIMPLE_CATCH2 = 8, SCOPE_SUPER2 = 16, SCOPE_DIRECT_SUPER2 = 32, SCOPE_CLASS = 64, SCOPE_STATIC_BLOCK = 128, SCOPE_TS_MODULE = 256, SCOPE_VAR2 = SCOPE_PROGRAM | SCOPE_FUNCTION2 | SCOPE_TS_MODULE;
    var BIND_KIND_VALUE = 1, BIND_KIND_TYPE = 2, BIND_SCOPE_VAR = 4, BIND_SCOPE_LEXICAL = 8, BIND_SCOPE_FUNCTION = 16, BIND_FLAGS_NONE = 64, BIND_FLAGS_CLASS = 128, BIND_FLAGS_TS_ENUM = 256, BIND_FLAGS_TS_CONST_ENUM = 512, BIND_FLAGS_TS_EXPORT_ONLY = 1024, BIND_FLAGS_FLOW_DECLARE_FN = 2048;
    var BIND_CLASS = BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_CLASS, BIND_LEXICAL2 = BIND_KIND_VALUE | 0 | BIND_SCOPE_LEXICAL | 0, BIND_VAR2 = BIND_KIND_VALUE | 0 | BIND_SCOPE_VAR | 0, BIND_FUNCTION2 = BIND_KIND_VALUE | 0 | BIND_SCOPE_FUNCTION | 0, BIND_TS_INTERFACE = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_CLASS, BIND_TS_TYPE = 0 | BIND_KIND_TYPE | 0 | 0, BIND_TS_ENUM = BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_TS_ENUM, BIND_TS_AMBIENT = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY, BIND_NONE2 = 0 | 0 | 0 | BIND_FLAGS_NONE, BIND_OUTSIDE2 = BIND_KIND_VALUE | 0 | 0 | BIND_FLAGS_NONE, BIND_TS_CONST_ENUM = BIND_TS_ENUM | BIND_FLAGS_TS_CONST_ENUM, BIND_TS_NAMESPACE = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY, BIND_FLOW_DECLARE_FN = BIND_FLAGS_FLOW_DECLARE_FN;
    var CLASS_ELEMENT_FLAG_STATIC = 4, CLASS_ELEMENT_KIND_GETTER = 2, CLASS_ELEMENT_KIND_SETTER = 1, CLASS_ELEMENT_KIND_ACCESSOR = CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_KIND_SETTER;
    var CLASS_ELEMENT_STATIC_GETTER = CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_FLAG_STATIC, CLASS_ELEMENT_STATIC_SETTER = CLASS_ELEMENT_KIND_SETTER | CLASS_ELEMENT_FLAG_STATIC, CLASS_ELEMENT_INSTANCE_GETTER = CLASS_ELEMENT_KIND_GETTER, CLASS_ELEMENT_INSTANCE_SETTER = CLASS_ELEMENT_KIND_SETTER, CLASS_ELEMENT_OTHER = 0;
    var BaseParser = function() {
      function BaseParser2() {
        this.sawUnambiguousESM = false;
        this.ambiguousScriptDifferentAst = false;
      }
      var _proto = BaseParser2.prototype;
      _proto.hasPlugin = function hasPlugin2(pluginConfig) {
        if (typeof pluginConfig === "string") {
          return this.plugins.has(pluginConfig);
        } else {
          var pluginName = pluginConfig[0], pluginOptions = pluginConfig[1];
          if (!this.hasPlugin(pluginName)) {
            return false;
          }
          var actualOptions = this.plugins.get(pluginName);
          for (var _i22 = 0, _Object$keys22 = Object.keys(pluginOptions); _i22 < _Object$keys22.length; _i22++) {
            var key2 = _Object$keys22[_i22];
            if ((actualOptions == null ? void 0 : actualOptions[key2]) !== pluginOptions[key2]) {
              return false;
            }
          }
          return true;
        }
      };
      _proto.getPluginOption = function getPluginOption2(plugin2, name2) {
        var _this$plugins$get;
        return (_this$plugins$get = this.plugins.get(plugin2)) == null ? void 0 : _this$plugins$get[name2];
      };
      return _createClass2(BaseParser2);
    }();
    function setTrailingComments(node2, comments) {
      if (node2.trailingComments === void 0) {
        node2.trailingComments = comments;
      } else {
        var _node$trailingComment;
        (_node$trailingComment = node2.trailingComments).unshift.apply(_node$trailingComment, comments);
      }
    }
    function setLeadingComments(node2, comments) {
      if (node2.leadingComments === void 0) {
        node2.leadingComments = comments;
      } else {
        var _node$leadingComments;
        (_node$leadingComments = node2.leadingComments).unshift.apply(_node$leadingComments, comments);
      }
    }
    function setInnerComments(node2, comments) {
      if (node2.innerComments === void 0) {
        node2.innerComments = comments;
      } else {
        var _node$innerComments;
        (_node$innerComments = node2.innerComments).unshift.apply(_node$innerComments, comments);
      }
    }
    function adjustInnerComments(node2, elements, commentWS) {
      var lastElement = null;
      var i2 = elements.length;
      while (lastElement === null && i2 > 0) {
        lastElement = elements[--i2];
      }
      if (lastElement === null || lastElement.start > commentWS.start) {
        setInnerComments(node2, commentWS.comments);
      } else {
        setTrailingComments(lastElement, commentWS.comments);
      }
    }
    var CommentsParser = function(_BaseParser) {
      _inherits2(CommentsParser2, _BaseParser);
      function CommentsParser2() {
        return _BaseParser.apply(this, arguments) || this;
      }
      var _proto = CommentsParser2.prototype;
      _proto.addComment = function addComment2(comment) {
        if (this.filename)
          comment.loc.filename = this.filename;
        this.state.comments.push(comment);
      };
      _proto.processComment = function processComment(node2) {
        var commentStack = this.state.commentStack;
        var commentStackLength = commentStack.length;
        if (commentStackLength === 0)
          return;
        var i2 = commentStackLength - 1;
        var lastCommentWS = commentStack[i2];
        if (lastCommentWS.start === node2.end) {
          lastCommentWS.leadingNode = node2;
          i2--;
        }
        var nodeStart = node2.start;
        for (; i2 >= 0; i2--) {
          var commentWS = commentStack[i2];
          var commentEnd = commentWS.end;
          if (commentEnd > nodeStart) {
            commentWS.containingNode = node2;
            this.finalizeComment(commentWS);
            commentStack.splice(i2, 1);
          } else {
            if (commentEnd === nodeStart) {
              commentWS.trailingNode = node2;
            }
            break;
          }
        }
      };
      _proto.finalizeComment = function finalizeComment(commentWS) {
        var comments = commentWS.comments;
        if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
          if (commentWS.leadingNode !== null) {
            setTrailingComments(commentWS.leadingNode, comments);
          }
          if (commentWS.trailingNode !== null) {
            setLeadingComments(commentWS.trailingNode, comments);
          }
        } else {
          var node2 = commentWS.containingNode, commentStart = commentWS.start;
          if (this.input.charCodeAt(commentStart - 1) === 44) {
            switch (node2.type) {
              case "ObjectExpression":
              case "ObjectPattern":
              case "RecordExpression":
                adjustInnerComments(node2, node2.properties, commentWS);
                break;
              case "CallExpression":
              case "OptionalCallExpression":
                adjustInnerComments(node2, node2.arguments, commentWS);
                break;
              case "FunctionDeclaration":
              case "FunctionExpression":
              case "ArrowFunctionExpression":
              case "ObjectMethod":
              case "ClassMethod":
              case "ClassPrivateMethod":
                adjustInnerComments(node2, node2.params, commentWS);
                break;
              case "ArrayExpression":
              case "ArrayPattern":
              case "TupleExpression":
                adjustInnerComments(node2, node2.elements, commentWS);
                break;
              case "ExportNamedDeclaration":
              case "ImportDeclaration":
                adjustInnerComments(node2, node2.specifiers, commentWS);
                break;
              default: {
                setInnerComments(node2, comments);
              }
            }
          } else {
            setInnerComments(node2, comments);
          }
        }
      };
      _proto.finalizeRemainingComments = function finalizeRemainingComments() {
        var commentStack = this.state.commentStack;
        for (var i2 = commentStack.length - 1; i2 >= 0; i2--) {
          this.finalizeComment(commentStack[i2]);
        }
        this.state.commentStack = [];
      };
      _proto.resetPreviousNodeTrailingComments = function resetPreviousNodeTrailingComments(node2) {
        var commentStack = this.state.commentStack;
        var length = commentStack.length;
        if (length === 0)
          return;
        var commentWS = commentStack[length - 1];
        if (commentWS.leadingNode === node2) {
          commentWS.leadingNode = null;
        }
      };
      _proto.takeSurroundingComments = function takeSurroundingComments(node2, start2, end2) {
        var commentStack = this.state.commentStack;
        var commentStackLength = commentStack.length;
        if (commentStackLength === 0)
          return;
        var i2 = commentStackLength - 1;
        for (; i2 >= 0; i2--) {
          var commentWS = commentStack[i2];
          var commentEnd = commentWS.end;
          var commentStart = commentWS.start;
          if (commentStart === end2) {
            commentWS.leadingNode = node2;
          } else if (commentEnd === start2) {
            commentWS.trailingNode = node2;
          } else if (commentEnd < start2) {
            break;
          }
        }
      };
      return _createClass2(CommentsParser2);
    }(BaseParser);
    var lineBreak2 = /\r\n?|[\n\u2028\u2029]/;
    var lineBreakG2 = new RegExp(lineBreak2.source, "g");
    function isNewLine2(code3) {
      switch (code3) {
        case 10:
        case 13:
        case 8232:
        case 8233:
          return true;
        default:
          return false;
      }
    }
    var skipWhiteSpace2 = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
    var skipWhiteSpaceInLine = new RegExp("(?:[^\\S\\n\\r\\u2028\\u2029]|\\/\\/.*|\\/\\*.*?\\*\\/)*", "y");
    var skipWhiteSpaceToLineBreak = new RegExp("(?=(" + skipWhiteSpaceInLine.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
    function isWhitespace(code3) {
      switch (code3) {
        case 9:
        case 11:
        case 12:
        case 32:
        case 160:
        case 5760:
        case 8192:
        case 8193:
        case 8194:
        case 8195:
        case 8196:
        case 8197:
        case 8198:
        case 8199:
        case 8200:
        case 8201:
        case 8202:
        case 8239:
        case 8287:
        case 12288:
        case 65279:
          return true;
        default:
          return false;
      }
    }
    var State = function() {
      function State2() {
        this.strict = void 0;
        this.curLine = void 0;
        this.lineStart = void 0;
        this.startLoc = void 0;
        this.endLoc = void 0;
        this.errors = [];
        this.potentialArrowAt = -1;
        this.noArrowAt = [];
        this.noArrowParamsConversionAt = [];
        this.maybeInArrowParameters = false;
        this.inType = false;
        this.noAnonFunctionType = false;
        this.hasFlowComment = false;
        this.isAmbientContext = false;
        this.inAbstractClass = false;
        this.topicContext = {
          maxNumOfResolvableTopics: 0,
          maxTopicIndex: null
        };
        this.soloAwait = false;
        this.inFSharpPipelineDirectBody = false;
        this.labels = [];
        this.decoratorStack = [[]];
        this.comments = [];
        this.commentStack = [];
        this.pos = 0;
        this.type = 135;
        this.value = null;
        this.start = 0;
        this.end = 0;
        this.lastTokEndLoc = null;
        this.lastTokStartLoc = null;
        this.lastTokStart = 0;
        this.context = [types2.brace];
        this.canStartJSXElement = true;
        this.containsEsc = false;
        this.strictErrors = /* @__PURE__ */ new Map();
        this.tokensLength = 0;
      }
      var _proto = State2.prototype;
      _proto.init = function init3(_ref3) {
        var strictMode = _ref3.strictMode, sourceType = _ref3.sourceType, startLine = _ref3.startLine, startColumn = _ref3.startColumn;
        this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
        this.curLine = startLine;
        this.lineStart = -startColumn;
        this.startLoc = this.endLoc = new Position3(startLine, startColumn, 0);
      };
      _proto.curPosition = function curPosition() {
        return new Position3(this.curLine, this.pos - this.lineStart, this.pos);
      };
      _proto.clone = function clone4(skipArrays) {
        var state = new State2();
        var keys2 = Object.keys(this);
        for (var i2 = 0, length = keys2.length; i2 < length; i2++) {
          var key2 = keys2[i2];
          var val = this[key2];
          if (!skipArrays && Array.isArray(val)) {
            val = val.slice();
          }
          state[key2] = val;
        }
        return state;
      };
      return _createClass2(State2);
    }();
    var _excluded$42 = ["at"], _excluded22 = ["at"];
    var _isDigit = function isDigit(code3) {
      return code3 >= 48 && code3 <= 57;
    };
    var VALID_REGEX_FLAGS = /* @__PURE__ */ new Set([103, 109, 115, 105, 121, 117, 100, 118]);
    var forbiddenNumericSeparatorSiblings = {
      decBinOct: /* @__PURE__ */ new Set([46, 66, 69, 79, 95, 98, 101, 111]),
      hex: /* @__PURE__ */ new Set([46, 88, 95, 120])
    };
    var isAllowedNumericSeparatorSibling = {
      bin: function bin2(ch2) {
        return ch2 === 48 || ch2 === 49;
      },
      oct: function oct(ch2) {
        return ch2 >= 48 && ch2 <= 55;
      },
      dec: function dec(ch2) {
        return ch2 >= 48 && ch2 <= 57;
      },
      hex: function hex2(ch2) {
        return ch2 >= 48 && ch2 <= 57 || ch2 >= 65 && ch2 <= 70 || ch2 >= 97 && ch2 <= 102;
      }
    };
    var Token3 = _createClass2(function Token4(state) {
      this.type = state.type;
      this.value = state.value;
      this.start = state.start;
      this.end = state.end;
      this.loc = new SourceLocation3(state.startLoc, state.endLoc);
    });
    var Tokenizer = function(_CommentsParser) {
      _inherits2(Tokenizer2, _CommentsParser);
      function Tokenizer2(options, input) {
        var _this;
        _this = _CommentsParser.call(this) || this;
        _this.isLookahead = void 0;
        _this.tokens = [];
        _this.state = new State();
        _this.state.init(options);
        _this.input = input;
        _this.length = input.length;
        _this.isLookahead = false;
        return _this;
      }
      var _proto = Tokenizer2.prototype;
      _proto.pushToken = function pushToken(token) {
        this.tokens.length = this.state.tokensLength;
        this.tokens.push(token);
        ++this.state.tokensLength;
      };
      _proto.next = function next() {
        this.checkKeywordEscapes();
        if (this.options.tokens) {
          this.pushToken(new Token3(this.state));
        }
        this.state.lastTokStart = this.state.start;
        this.state.lastTokEndLoc = this.state.endLoc;
        this.state.lastTokStartLoc = this.state.startLoc;
        this.nextToken();
      };
      _proto.eat = function eat2(type5) {
        if (this.match(type5)) {
          this.next();
          return true;
        } else {
          return false;
        }
      };
      _proto.match = function match(type5) {
        return this.state.type === type5;
      };
      _proto.createLookaheadState = function createLookaheadState(state) {
        return {
          pos: state.pos,
          value: null,
          type: state.type,
          start: state.start,
          end: state.end,
          context: [this.curContext()],
          inType: state.inType,
          startLoc: state.startLoc,
          lastTokEndLoc: state.lastTokEndLoc,
          curLine: state.curLine,
          lineStart: state.lineStart,
          curPosition: state.curPosition
        };
      };
      _proto.lookahead = function lookahead2() {
        var old = this.state;
        this.state = this.createLookaheadState(old);
        this.isLookahead = true;
        this.nextToken();
        this.isLookahead = false;
        var curr = this.state;
        this.state = old;
        return curr;
      };
      _proto.nextTokenStart = function nextTokenStart() {
        return this.nextTokenStartSince(this.state.pos);
      };
      _proto.nextTokenStartSince = function nextTokenStartSince(pos) {
        skipWhiteSpace2.lastIndex = pos;
        return skipWhiteSpace2.test(this.input) ? skipWhiteSpace2.lastIndex : pos;
      };
      _proto.lookaheadCharCode = function lookaheadCharCode() {
        return this.input.charCodeAt(this.nextTokenStart());
      };
      _proto.codePointAtPos = function codePointAtPos(pos) {
        var cp = this.input.charCodeAt(pos);
        if ((cp & 64512) === 55296 && ++pos < this.input.length) {
          var trail = this.input.charCodeAt(pos);
          if ((trail & 64512) === 56320) {
            cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
          }
        }
        return cp;
      };
      _proto.setStrict = function setStrict(strict2) {
        var _this2 = this;
        this.state.strict = strict2;
        if (strict2) {
          this.state.strictErrors.forEach(function(_ref3) {
            var toParseError = _ref3[0], at2 = _ref3[1];
            return _this2.raise(toParseError, {
              at: at2
            });
          });
          this.state.strictErrors.clear();
        }
      };
      _proto.curContext = function curContext() {
        return this.state.context[this.state.context.length - 1];
      };
      _proto.nextToken = function nextToken() {
        this.skipSpace();
        this.state.start = this.state.pos;
        if (!this.isLookahead)
          this.state.startLoc = this.state.curPosition();
        if (this.state.pos >= this.length) {
          this.finishToken(135);
          return;
        }
        this.getTokenFromCode(this.codePointAtPos(this.state.pos));
      };
      _proto.skipBlockComment = function skipBlockComment() {
        var startLoc;
        if (!this.isLookahead)
          startLoc = this.state.curPosition();
        var start2 = this.state.pos;
        var end2 = this.input.indexOf("*/", start2 + 2);
        if (end2 === -1) {
          throw this.raise(Errors.UnterminatedComment, {
            at: this.state.curPosition()
          });
        }
        this.state.pos = end2 + 2;
        lineBreakG2.lastIndex = start2 + 2;
        while (lineBreakG2.test(this.input) && lineBreakG2.lastIndex <= end2) {
          ++this.state.curLine;
          this.state.lineStart = lineBreakG2.lastIndex;
        }
        if (this.isLookahead)
          return;
        var comment = {
          type: "CommentBlock",
          value: this.input.slice(start2 + 2, end2),
          start: start2,
          end: end2 + 2,
          loc: new SourceLocation3(startLoc, this.state.curPosition())
        };
        if (this.options.tokens)
          this.pushToken(comment);
        return comment;
      };
      _proto.skipLineComment = function skipLineComment(startSkip) {
        var start2 = this.state.pos;
        var startLoc;
        if (!this.isLookahead)
          startLoc = this.state.curPosition();
        var ch2 = this.input.charCodeAt(this.state.pos += startSkip);
        if (this.state.pos < this.length) {
          while (!isNewLine2(ch2) && ++this.state.pos < this.length) {
            ch2 = this.input.charCodeAt(this.state.pos);
          }
        }
        if (this.isLookahead)
          return;
        var end2 = this.state.pos;
        var value = this.input.slice(start2 + startSkip, end2);
        var comment = {
          type: "CommentLine",
          value,
          start: start2,
          end: end2,
          loc: new SourceLocation3(startLoc, this.state.curPosition())
        };
        if (this.options.tokens)
          this.pushToken(comment);
        return comment;
      };
      _proto.skipSpace = function skipSpace() {
        var spaceStart = this.state.pos;
        var comments = [];
        loop:
          while (this.state.pos < this.length) {
            var ch2 = this.input.charCodeAt(this.state.pos);
            switch (ch2) {
              case 32:
              case 160:
              case 9:
                ++this.state.pos;
                break;
              case 13:
                if (this.input.charCodeAt(this.state.pos + 1) === 10) {
                  ++this.state.pos;
                }
              case 10:
              case 8232:
              case 8233:
                ++this.state.pos;
                ++this.state.curLine;
                this.state.lineStart = this.state.pos;
                break;
              case 47:
                switch (this.input.charCodeAt(this.state.pos + 1)) {
                  case 42: {
                    var comment = this.skipBlockComment();
                    if (comment !== void 0) {
                      this.addComment(comment);
                      if (this.options.attachComment)
                        comments.push(comment);
                    }
                    break;
                  }
                  case 47: {
                    var _comment = this.skipLineComment(2);
                    if (_comment !== void 0) {
                      this.addComment(_comment);
                      if (this.options.attachComment)
                        comments.push(_comment);
                    }
                    break;
                  }
                  default:
                    break loop;
                }
                break;
              default:
                if (isWhitespace(ch2)) {
                  ++this.state.pos;
                } else if (ch2 === 45 && !this.inModule) {
                  var pos = this.state.pos;
                  if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
                    var _comment2 = this.skipLineComment(3);
                    if (_comment2 !== void 0) {
                      this.addComment(_comment2);
                      if (this.options.attachComment)
                        comments.push(_comment2);
                    }
                  } else {
                    break loop;
                  }
                } else if (ch2 === 60 && !this.inModule) {
                  var _pos = this.state.pos;
                  if (this.input.charCodeAt(_pos + 1) === 33 && this.input.charCodeAt(_pos + 2) === 45 && this.input.charCodeAt(_pos + 3) === 45) {
                    var _comment3 = this.skipLineComment(4);
                    if (_comment3 !== void 0) {
                      this.addComment(_comment3);
                      if (this.options.attachComment)
                        comments.push(_comment3);
                    }
                  } else {
                    break loop;
                  }
                } else {
                  break loop;
                }
            }
          }
        if (comments.length > 0) {
          var end2 = this.state.pos;
          var CommentWhitespace = {
            start: spaceStart,
            end: end2,
            comments,
            leadingNode: null,
            trailingNode: null,
            containingNode: null
          };
          this.state.commentStack.push(CommentWhitespace);
        }
      };
      _proto.finishToken = function finishToken(type5, val) {
        this.state.end = this.state.pos;
        this.state.endLoc = this.state.curPosition();
        var prevType = this.state.type;
        this.state.type = type5;
        this.state.value = val;
        if (!this.isLookahead) {
          this.updateContext(prevType);
        }
      };
      _proto.replaceToken = function replaceToken(type5) {
        this.state.type = type5;
        this.updateContext();
      };
      _proto.readToken_numberSign = function readToken_numberSign() {
        if (this.state.pos === 0 && this.readToken_interpreter()) {
          return;
        }
        var nextPos = this.state.pos + 1;
        var next = this.codePointAtPos(nextPos);
        if (next >= 48 && next <= 57) {
          throw this.raise(Errors.UnexpectedDigitAfterHash, {
            at: this.state.curPosition()
          });
        }
        if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
          this.expectPlugin("recordAndTuple");
          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "hash") {
            throw this.raise(next === 123 ? Errors.RecordExpressionHashIncorrectStartSyntaxType : Errors.TupleExpressionHashIncorrectStartSyntaxType, {
              at: this.state.curPosition()
            });
          }
          this.state.pos += 2;
          if (next === 123) {
            this.finishToken(7);
          } else {
            this.finishToken(1);
          }
        } else if (isIdentifierStart2(next)) {
          ++this.state.pos;
          this.finishToken(134, this.readWord1(next));
        } else if (next === 92) {
          ++this.state.pos;
          this.finishToken(134, this.readWord1());
        } else {
          this.finishOp(27, 1);
        }
      };
      _proto.readToken_dot = function readToken_dot() {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next >= 48 && next <= 57) {
          this.readNumber(true);
          return;
        }
        if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
          this.state.pos += 3;
          this.finishToken(21);
        } else {
          ++this.state.pos;
          this.finishToken(16);
        }
      };
      _proto.readToken_slash = function readToken_slash() {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === 61) {
          this.finishOp(31, 2);
        } else {
          this.finishOp(56, 1);
        }
      };
      _proto.readToken_interpreter = function readToken_interpreter() {
        if (this.state.pos !== 0 || this.length < 2)
          return false;
        var ch2 = this.input.charCodeAt(this.state.pos + 1);
        if (ch2 !== 33)
          return false;
        var start2 = this.state.pos;
        this.state.pos += 1;
        while (!isNewLine2(ch2) && ++this.state.pos < this.length) {
          ch2 = this.input.charCodeAt(this.state.pos);
        }
        var value = this.input.slice(start2 + 2, this.state.pos);
        this.finishToken(28, value);
        return true;
      };
      _proto.readToken_mult_modulo = function readToken_mult_modulo(code3) {
        var type5 = code3 === 42 ? 55 : 54;
        var width = 1;
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (code3 === 42 && next === 42) {
          width++;
          next = this.input.charCodeAt(this.state.pos + 2);
          type5 = 57;
        }
        if (next === 61 && !this.state.inType) {
          width++;
          type5 = code3 === 37 ? 33 : 30;
        }
        this.finishOp(type5, width);
      };
      _proto.readToken_pipe_amp = function readToken_pipe_amp(code3) {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === code3) {
          if (this.input.charCodeAt(this.state.pos + 2) === 61) {
            this.finishOp(30, 3);
          } else {
            this.finishOp(code3 === 124 ? 41 : 42, 2);
          }
          return;
        }
        if (code3 === 124) {
          if (next === 62) {
            this.finishOp(39, 2);
            return;
          }
          if (this.hasPlugin("recordAndTuple") && next === 125) {
            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
              throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, {
                at: this.state.curPosition()
              });
            }
            this.state.pos += 2;
            this.finishToken(9);
            return;
          }
          if (this.hasPlugin("recordAndTuple") && next === 93) {
            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
              throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, {
                at: this.state.curPosition()
              });
            }
            this.state.pos += 2;
            this.finishToken(4);
            return;
          }
        }
        if (next === 61) {
          this.finishOp(30, 2);
          return;
        }
        this.finishOp(code3 === 124 ? 43 : 45, 1);
      };
      _proto.readToken_caret = function readToken_caret() {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === 61 && !this.state.inType) {
          this.finishOp(32, 2);
        } else if (next === 94 && this.hasPlugin(["pipelineOperator", {
          proposal: "hack",
          topicToken: "^^"
        }])) {
          this.finishOp(37, 2);
          var lookaheadCh = this.input.codePointAt(this.state.pos);
          if (lookaheadCh === 94) {
            throw this.unexpected();
          }
        } else {
          this.finishOp(44, 1);
        }
      };
      _proto.readToken_atSign = function readToken_atSign() {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === 64 && this.hasPlugin(["pipelineOperator", {
          proposal: "hack",
          topicToken: "@@"
        }])) {
          this.finishOp(38, 2);
        } else {
          this.finishOp(26, 1);
        }
      };
      _proto.readToken_plus_min = function readToken_plus_min(code3) {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === code3) {
          this.finishOp(34, 2);
          return;
        }
        if (next === 61) {
          this.finishOp(30, 2);
        } else {
          this.finishOp(53, 1);
        }
      };
      _proto.readToken_lt = function readToken_lt() {
        var pos = this.state.pos;
        var next = this.input.charCodeAt(pos + 1);
        if (next === 60) {
          if (this.input.charCodeAt(pos + 2) === 61) {
            this.finishOp(30, 3);
            return;
          }
          this.finishOp(51, 2);
          return;
        }
        if (next === 61) {
          this.finishOp(49, 2);
          return;
        }
        this.finishOp(47, 1);
      };
      _proto.readToken_gt = function readToken_gt() {
        var pos = this.state.pos;
        var next = this.input.charCodeAt(pos + 1);
        if (next === 62) {
          var size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
          if (this.input.charCodeAt(pos + size) === 61) {
            this.finishOp(30, size + 1);
            return;
          }
          this.finishOp(52, size);
          return;
        }
        if (next === 61) {
          this.finishOp(49, 2);
          return;
        }
        this.finishOp(48, 1);
      };
      _proto.readToken_eq_excl = function readToken_eq_excl(code3) {
        var next = this.input.charCodeAt(this.state.pos + 1);
        if (next === 61) {
          this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
          return;
        }
        if (code3 === 61 && next === 62) {
          this.state.pos += 2;
          this.finishToken(19);
          return;
        }
        this.finishOp(code3 === 61 ? 29 : 35, 1);
      };
      _proto.readToken_question = function readToken_question() {
        var next = this.input.charCodeAt(this.state.pos + 1);
        var next2 = this.input.charCodeAt(this.state.pos + 2);
        if (next === 63) {
          if (next2 === 61) {
            this.finishOp(30, 3);
          } else {
            this.finishOp(40, 2);
          }
        } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
          this.state.pos += 2;
          this.finishToken(18);
        } else {
          ++this.state.pos;
          this.finishToken(17);
        }
      };
      _proto.getTokenFromCode = function getTokenFromCode(code3) {
        switch (code3) {
          case 46:
            this.readToken_dot();
            return;
          case 40:
            ++this.state.pos;
            this.finishToken(10);
            return;
          case 41:
            ++this.state.pos;
            this.finishToken(11);
            return;
          case 59:
            ++this.state.pos;
            this.finishToken(13);
            return;
          case 44:
            ++this.state.pos;
            this.finishToken(12);
            return;
          case 91:
            if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
              if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                throw this.raise(Errors.TupleExpressionBarIncorrectStartSyntaxType, {
                  at: this.state.curPosition()
                });
              }
              this.state.pos += 2;
              this.finishToken(2);
            } else {
              ++this.state.pos;
              this.finishToken(0);
            }
            return;
          case 93:
            ++this.state.pos;
            this.finishToken(3);
            return;
          case 123:
            if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
              if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                throw this.raise(Errors.RecordExpressionBarIncorrectStartSyntaxType, {
                  at: this.state.curPosition()
                });
              }
              this.state.pos += 2;
              this.finishToken(6);
            } else {
              ++this.state.pos;
              this.finishToken(5);
            }
            return;
          case 125:
            ++this.state.pos;
            this.finishToken(8);
            return;
          case 58:
            if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
              this.finishOp(15, 2);
            } else {
              ++this.state.pos;
              this.finishToken(14);
            }
            return;
          case 63:
            this.readToken_question();
            return;
          case 96:
            this.readTemplateToken();
            return;
          case 48: {
            var next = this.input.charCodeAt(this.state.pos + 1);
            if (next === 120 || next === 88) {
              this.readRadixNumber(16);
              return;
            }
            if (next === 111 || next === 79) {
              this.readRadixNumber(8);
              return;
            }
            if (next === 98 || next === 66) {
              this.readRadixNumber(2);
              return;
            }
          }
          case 49:
          case 50:
          case 51:
          case 52:
          case 53:
          case 54:
          case 55:
          case 56:
          case 57:
            this.readNumber(false);
            return;
          case 34:
          case 39:
            this.readString(code3);
            return;
          case 47:
            this.readToken_slash();
            return;
          case 37:
          case 42:
            this.readToken_mult_modulo(code3);
            return;
          case 124:
          case 38:
            this.readToken_pipe_amp(code3);
            return;
          case 94:
            this.readToken_caret();
            return;
          case 43:
          case 45:
            this.readToken_plus_min(code3);
            return;
          case 60:
            this.readToken_lt();
            return;
          case 62:
            this.readToken_gt();
            return;
          case 61:
          case 33:
            this.readToken_eq_excl(code3);
            return;
          case 126:
            this.finishOp(36, 1);
            return;
          case 64:
            this.readToken_atSign();
            return;
          case 35:
            this.readToken_numberSign();
            return;
          case 92:
            this.readWord();
            return;
          default:
            if (isIdentifierStart2(code3)) {
              this.readWord(code3);
              return;
            }
        }
        throw this.raise(Errors.InvalidOrUnexpectedToken, {
          at: this.state.curPosition(),
          unexpected: String.fromCodePoint(code3)
        });
      };
      _proto.finishOp = function finishOp(type5, size) {
        var str = this.input.slice(this.state.pos, this.state.pos + size);
        this.state.pos += size;
        this.finishToken(type5, str);
      };
      _proto.readRegexp = function readRegexp() {
        var startLoc = this.state.startLoc;
        var start2 = this.state.start + 1;
        var escaped, inClass;
        var pos = this.state.pos;
        for (; ; ++pos) {
          if (pos >= this.length) {
            throw this.raise(Errors.UnterminatedRegExp, {
              at: createPositionWithColumnOffset(startLoc, 1)
            });
          }
          var ch2 = this.input.charCodeAt(pos);
          if (isNewLine2(ch2)) {
            throw this.raise(Errors.UnterminatedRegExp, {
              at: createPositionWithColumnOffset(startLoc, 1)
            });
          }
          if (escaped) {
            escaped = false;
          } else {
            if (ch2 === 91) {
              inClass = true;
            } else if (ch2 === 93 && inClass) {
              inClass = false;
            } else if (ch2 === 47 && !inClass) {
              break;
            }
            escaped = ch2 === 92;
          }
        }
        var content = this.input.slice(start2, pos);
        ++pos;
        var mods = "";
        var nextPos = function nextPos2() {
          return createPositionWithColumnOffset(startLoc, pos + 2 - start2);
        };
        while (pos < this.length) {
          var cp = this.codePointAtPos(pos);
          var _char = String.fromCharCode(cp);
          if (VALID_REGEX_FLAGS.has(cp)) {
            if (cp === 118) {
              this.expectPlugin("regexpUnicodeSets", nextPos());
              if (mods.includes("u")) {
                this.raise(Errors.IncompatibleRegExpUVFlags, {
                  at: nextPos()
                });
              }
            } else if (cp === 117) {
              if (mods.includes("v")) {
                this.raise(Errors.IncompatibleRegExpUVFlags, {
                  at: nextPos()
                });
              }
            }
            if (mods.includes(_char)) {
              this.raise(Errors.DuplicateRegExpFlags, {
                at: nextPos()
              });
            }
          } else if (isIdentifierChar2(cp) || cp === 92) {
            this.raise(Errors.MalformedRegExpFlags, {
              at: nextPos()
            });
          } else {
            break;
          }
          ++pos;
          mods += _char;
        }
        this.state.pos = pos;
        this.finishToken(133, {
          pattern: content,
          flags: mods
        });
      };
      _proto.readInt = function readInt(radix, len3, forceLen, allowNumSeparator) {
        if (allowNumSeparator === void 0) {
          allowNumSeparator = true;
        }
        var start2 = this.state.pos;
        var forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
        var isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
        var invalid = false;
        var total = 0;
        for (var i2 = 0, e2 = len3 == null ? Infinity : len3; i2 < e2; ++i2) {
          var code3 = this.input.charCodeAt(this.state.pos);
          var val = void 0;
          if (code3 === 95 && allowNumSeparator !== "bail") {
            var prev = this.input.charCodeAt(this.state.pos - 1);
            var next = this.input.charCodeAt(this.state.pos + 1);
            if (!allowNumSeparator) {
              this.raise(Errors.NumericSeparatorInEscapeSequence, {
                at: this.state.curPosition()
              });
            } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
              this.raise(Errors.UnexpectedNumericSeparator, {
                at: this.state.curPosition()
              });
            }
            ++this.state.pos;
            continue;
          }
          if (code3 >= 97) {
            val = code3 - 97 + 10;
          } else if (code3 >= 65) {
            val = code3 - 65 + 10;
          } else if (_isDigit(code3)) {
            val = code3 - 48;
          } else {
            val = Infinity;
          }
          if (val >= radix) {
            if (this.options.errorRecovery && val <= 9) {
              val = 0;
              this.raise(Errors.InvalidDigit, {
                at: this.state.curPosition(),
                radix
              });
            } else if (forceLen) {
              val = 0;
              invalid = true;
            } else {
              break;
            }
          }
          ++this.state.pos;
          total = total * radix + val;
        }
        if (this.state.pos === start2 || len3 != null && this.state.pos - start2 !== len3 || invalid) {
          return null;
        }
        return total;
      };
      _proto.readRadixNumber = function readRadixNumber(radix) {
        var startLoc = this.state.curPosition();
        var isBigInt = false;
        this.state.pos += 2;
        var val = this.readInt(radix);
        if (val == null) {
          this.raise(Errors.InvalidDigit, {
            at: createPositionWithColumnOffset(startLoc, 2),
            radix
          });
        }
        var next = this.input.charCodeAt(this.state.pos);
        if (next === 110) {
          ++this.state.pos;
          isBigInt = true;
        } else if (next === 109) {
          throw this.raise(Errors.InvalidDecimal, {
            at: startLoc
          });
        }
        if (isIdentifierStart2(this.codePointAtPos(this.state.pos))) {
          throw this.raise(Errors.NumberIdentifier, {
            at: this.state.curPosition()
          });
        }
        if (isBigInt) {
          var str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
          this.finishToken(131, str);
          return;
        }
        this.finishToken(130, val);
      };
      _proto.readNumber = function readNumber(startsWithDot) {
        var start2 = this.state.pos;
        var startLoc = this.state.curPosition();
        var isFloat = false;
        var isBigInt = false;
        var isDecimal = false;
        var hasExponent = false;
        var isOctal = false;
        if (!startsWithDot && this.readInt(10) === null) {
          this.raise(Errors.InvalidNumber, {
            at: this.state.curPosition()
          });
        }
        var hasLeadingZero = this.state.pos - start2 >= 2 && this.input.charCodeAt(start2) === 48;
        if (hasLeadingZero) {
          var integer4 = this.input.slice(start2, this.state.pos);
          this.recordStrictModeErrors(Errors.StrictOctalLiteral, {
            at: startLoc
          });
          if (!this.state.strict) {
            var underscorePos = integer4.indexOf("_");
            if (underscorePos > 0) {
              this.raise(Errors.ZeroDigitNumericSeparator, {
                at: createPositionWithColumnOffset(startLoc, underscorePos)
              });
            }
          }
          isOctal = hasLeadingZero && !/[89]/.test(integer4);
        }
        var next = this.input.charCodeAt(this.state.pos);
        if (next === 46 && !isOctal) {
          ++this.state.pos;
          this.readInt(10);
          isFloat = true;
          next = this.input.charCodeAt(this.state.pos);
        }
        if ((next === 69 || next === 101) && !isOctal) {
          next = this.input.charCodeAt(++this.state.pos);
          if (next === 43 || next === 45) {
            ++this.state.pos;
          }
          if (this.readInt(10) === null) {
            this.raise(Errors.InvalidOrMissingExponent, {
              at: startLoc
            });
          }
          isFloat = true;
          hasExponent = true;
          next = this.input.charCodeAt(this.state.pos);
        }
        if (next === 110) {
          if (isFloat || hasLeadingZero) {
            this.raise(Errors.InvalidBigIntLiteral, {
              at: startLoc
            });
          }
          ++this.state.pos;
          isBigInt = true;
        }
        if (next === 109) {
          this.expectPlugin("decimal", this.state.curPosition());
          if (hasExponent || hasLeadingZero) {
            this.raise(Errors.InvalidDecimal, {
              at: startLoc
            });
          }
          ++this.state.pos;
          isDecimal = true;
        }
        if (isIdentifierStart2(this.codePointAtPos(this.state.pos))) {
          throw this.raise(Errors.NumberIdentifier, {
            at: this.state.curPosition()
          });
        }
        var str = this.input.slice(start2, this.state.pos).replace(/[_mn]/g, "");
        if (isBigInt) {
          this.finishToken(131, str);
          return;
        }
        if (isDecimal) {
          this.finishToken(132, str);
          return;
        }
        var val = isOctal ? parseInt(str, 8) : parseFloat(str);
        this.finishToken(130, val);
      };
      _proto.readCodePoint = function readCodePoint(throwOnInvalid) {
        var ch2 = this.input.charCodeAt(this.state.pos);
        var code3;
        if (ch2 === 123) {
          ++this.state.pos;
          code3 = this.readHexChar(this.input.indexOf("}", this.state.pos) - this.state.pos, true, throwOnInvalid);
          ++this.state.pos;
          if (code3 !== null && code3 > 1114111) {
            if (throwOnInvalid) {
              this.raise(Errors.InvalidCodePoint, {
                at: this.state.curPosition()
              });
            } else {
              return null;
            }
          }
        } else {
          code3 = this.readHexChar(4, false, throwOnInvalid);
        }
        return code3;
      };
      _proto.readString = function readString(quote) {
        var out2 = "", chunkStart = ++this.state.pos;
        for (; ; ) {
          if (this.state.pos >= this.length) {
            throw this.raise(Errors.UnterminatedString, {
              at: this.state.startLoc
            });
          }
          var ch2 = this.input.charCodeAt(this.state.pos);
          if (ch2 === quote)
            break;
          if (ch2 === 92) {
            out2 += this.input.slice(chunkStart, this.state.pos);
            out2 += this.readEscapedChar(false);
            chunkStart = this.state.pos;
          } else if (ch2 === 8232 || ch2 === 8233) {
            ++this.state.pos;
            ++this.state.curLine;
            this.state.lineStart = this.state.pos;
          } else if (isNewLine2(ch2)) {
            throw this.raise(Errors.UnterminatedString, {
              at: this.state.startLoc
            });
          } else {
            ++this.state.pos;
          }
        }
        out2 += this.input.slice(chunkStart, this.state.pos++);
        this.finishToken(129, out2);
      };
      _proto.readTemplateContinuation = function readTemplateContinuation() {
        if (!this.match(8)) {
          this.unexpected(null, 8);
        }
        this.state.pos--;
        this.readTemplateToken();
      };
      _proto.readTemplateToken = function readTemplateToken() {
        var out2 = "", chunkStart = this.state.pos, containsInvalid = false;
        ++this.state.pos;
        for (; ; ) {
          if (this.state.pos >= this.length) {
            throw this.raise(Errors.UnterminatedTemplate, {
              at: createPositionWithColumnOffset(this.state.startLoc, 1)
            });
          }
          var ch2 = this.input.charCodeAt(this.state.pos);
          if (ch2 === 96) {
            ++this.state.pos;
            out2 += this.input.slice(chunkStart, this.state.pos);
            this.finishToken(24, containsInvalid ? null : out2);
            return;
          }
          if (ch2 === 36 && this.input.charCodeAt(this.state.pos + 1) === 123) {
            this.state.pos += 2;
            out2 += this.input.slice(chunkStart, this.state.pos);
            this.finishToken(25, containsInvalid ? null : out2);
            return;
          }
          if (ch2 === 92) {
            out2 += this.input.slice(chunkStart, this.state.pos);
            var escaped = this.readEscapedChar(true);
            if (escaped === null) {
              containsInvalid = true;
            } else {
              out2 += escaped;
            }
            chunkStart = this.state.pos;
          } else if (isNewLine2(ch2)) {
            out2 += this.input.slice(chunkStart, this.state.pos);
            ++this.state.pos;
            switch (ch2) {
              case 13:
                if (this.input.charCodeAt(this.state.pos) === 10) {
                  ++this.state.pos;
                }
              case 10:
                out2 += "\n";
                break;
              default:
                out2 += String.fromCharCode(ch2);
                break;
            }
            ++this.state.curLine;
            this.state.lineStart = this.state.pos;
            chunkStart = this.state.pos;
          } else {
            ++this.state.pos;
          }
        }
      };
      _proto.recordStrictModeErrors = function recordStrictModeErrors(toParseError, _ref22) {
        var at2 = _ref22.at;
        var index3 = at2.index;
        if (this.state.strict && !this.state.strictErrors.has(index3)) {
          this.raise(toParseError, {
            at: at2
          });
        } else {
          this.state.strictErrors.set(index3, [toParseError, at2]);
        }
      };
      _proto.readEscapedChar = function readEscapedChar(inTemplate) {
        var throwOnInvalid = !inTemplate;
        var ch2 = this.input.charCodeAt(++this.state.pos);
        ++this.state.pos;
        switch (ch2) {
          case 110:
            return "\n";
          case 114:
            return "\r";
          case 120: {
            var code3 = this.readHexChar(2, false, throwOnInvalid);
            return code3 === null ? null : String.fromCharCode(code3);
          }
          case 117: {
            var _code = this.readCodePoint(throwOnInvalid);
            return _code === null ? null : String.fromCodePoint(_code);
          }
          case 116:
            return "	";
          case 98:
            return "\b";
          case 118:
            return "\v";
          case 102:
            return "\f";
          case 13:
            if (this.input.charCodeAt(this.state.pos) === 10) {
              ++this.state.pos;
            }
          case 10:
            this.state.lineStart = this.state.pos;
            ++this.state.curLine;
          case 8232:
          case 8233:
            return "";
          case 56:
          case 57:
            if (inTemplate) {
              return null;
            } else {
              this.recordStrictModeErrors(Errors.StrictNumericEscape, {
                at: createPositionWithColumnOffset(this.state.curPosition(), -1)
              });
            }
          default:
            if (ch2 >= 48 && ch2 <= 55) {
              var codePos = createPositionWithColumnOffset(this.state.curPosition(), -1);
              var match = this.input.slice(this.state.pos - 1, this.state.pos + 2).match(/^[0-7]+/);
              var octalStr = match[0];
              var octal = parseInt(octalStr, 8);
              if (octal > 255) {
                octalStr = octalStr.slice(0, -1);
                octal = parseInt(octalStr, 8);
              }
              this.state.pos += octalStr.length - 1;
              var next = this.input.charCodeAt(this.state.pos);
              if (octalStr !== "0" || next === 56 || next === 57) {
                if (inTemplate) {
                  return null;
                } else {
                  this.recordStrictModeErrors(Errors.StrictNumericEscape, {
                    at: codePos
                  });
                }
              }
              return String.fromCharCode(octal);
            }
            return String.fromCharCode(ch2);
        }
      };
      _proto.readHexChar = function readHexChar(len3, forceLen, throwOnInvalid) {
        var codeLoc = this.state.curPosition();
        var n2 = this.readInt(16, len3, forceLen, false);
        if (n2 === null) {
          if (throwOnInvalid) {
            this.raise(Errors.InvalidEscapeSequence, {
              at: codeLoc
            });
          } else {
            this.state.pos = codeLoc.index - 1;
          }
        }
        return n2;
      };
      _proto.readWord1 = function readWord1(firstCode) {
        this.state.containsEsc = false;
        var word = "";
        var start2 = this.state.pos;
        var chunkStart = this.state.pos;
        if (firstCode !== void 0) {
          this.state.pos += firstCode <= 65535 ? 1 : 2;
        }
        while (this.state.pos < this.length) {
          var ch2 = this.codePointAtPos(this.state.pos);
          if (isIdentifierChar2(ch2)) {
            this.state.pos += ch2 <= 65535 ? 1 : 2;
          } else if (ch2 === 92) {
            this.state.containsEsc = true;
            word += this.input.slice(chunkStart, this.state.pos);
            var escStart = this.state.curPosition();
            var identifierCheck = this.state.pos === start2 ? isIdentifierStart2 : isIdentifierChar2;
            if (this.input.charCodeAt(++this.state.pos) !== 117) {
              this.raise(Errors.MissingUnicodeEscape, {
                at: this.state.curPosition()
              });
              chunkStart = this.state.pos - 1;
              continue;
            }
            ++this.state.pos;
            var esc = this.readCodePoint(true);
            if (esc !== null) {
              if (!identifierCheck(esc)) {
                this.raise(Errors.EscapedCharNotAnIdentifier, {
                  at: escStart
                });
              }
              word += String.fromCodePoint(esc);
            }
            chunkStart = this.state.pos;
          } else {
            break;
          }
        }
        return word + this.input.slice(chunkStart, this.state.pos);
      };
      _proto.readWord = function readWord(firstCode) {
        var word = this.readWord1(firstCode);
        var type5 = keywords2.get(word);
        if (type5 !== void 0) {
          this.finishToken(type5, tokenLabelName(type5));
        } else {
          this.finishToken(128, word);
        }
      };
      _proto.checkKeywordEscapes = function checkKeywordEscapes() {
        var type5 = this.state.type;
        if (tokenIsKeyword(type5) && this.state.containsEsc) {
          this.raise(Errors.InvalidEscapedReservedWord, {
            at: this.state.startLoc,
            reservedWord: tokenLabelName(type5)
          });
        }
      };
      _proto.raise = function raise2(toParseError, raiseProperties) {
        var at2 = raiseProperties.at, details = _objectWithoutPropertiesLoose2(raiseProperties, _excluded$42);
        var loc = at2 instanceof Position3 ? at2 : at2.loc.start;
        var error2 = toParseError({
          loc,
          details
        });
        if (!this.options.errorRecovery)
          throw error2;
        if (!this.isLookahead)
          this.state.errors.push(error2);
        return error2;
      };
      _proto.raiseOverwrite = function raiseOverwrite(toParseError, raiseProperties) {
        var at2 = raiseProperties.at, details = _objectWithoutPropertiesLoose2(raiseProperties, _excluded22);
        var loc = at2 instanceof Position3 ? at2 : at2.loc.start;
        var pos = loc.index;
        var errors = this.state.errors;
        for (var i2 = errors.length - 1; i2 >= 0; i2--) {
          var error2 = errors[i2];
          if (error2.loc.index === pos) {
            return errors[i2] = toParseError({
              loc,
              details
            });
          }
          if (error2.loc.index < pos)
            break;
        }
        return this.raise(toParseError, raiseProperties);
      };
      _proto.updateContext = function updateContext(prevType) {
      };
      _proto.unexpected = function unexpected(loc, type5) {
        throw this.raise(Errors.UnexpectedToken, {
          expected: type5 ? tokenLabelName(type5) : null,
          at: loc != null ? loc : this.state.startLoc
        });
      };
      _proto.expectPlugin = function expectPlugin(pluginName, loc) {
        if (this.hasPlugin(pluginName)) {
          return true;
        }
        throw this.raise(Errors.MissingPlugin, {
          at: loc != null ? loc : this.state.startLoc,
          missingPlugin: [pluginName]
        });
      };
      _proto.expectOnePlugin = function expectOnePlugin(pluginNames) {
        var _this3 = this;
        if (!pluginNames.some(function(name2) {
          return _this3.hasPlugin(name2);
        })) {
          throw this.raise(Errors.MissingOneOfPlugins, {
            at: this.state.startLoc,
            missingPlugin: pluginNames
          });
        }
      };
      return _createClass2(Tokenizer2);
    }(CommentsParser);
    var Scope3 = _createClass2(function Scope4(flags) {
      this["var"] = /* @__PURE__ */ new Set();
      this.lexical = /* @__PURE__ */ new Set();
      this.functions = /* @__PURE__ */ new Set();
      this.flags = flags;
    });
    var ScopeHandler = function() {
      function ScopeHandler2(parser2, inModule) {
        this.parser = void 0;
        this.scopeStack = [];
        this.inModule = void 0;
        this.undefinedExports = /* @__PURE__ */ new Map();
        this.parser = parser2;
        this.inModule = inModule;
      }
      var _proto = ScopeHandler2.prototype;
      _proto.createScope = function createScope(flags) {
        return new Scope3(flags);
      };
      _proto.enter = function enter(flags) {
        this.scopeStack.push(this.createScope(flags));
      };
      _proto.exit = function exit() {
        this.scopeStack.pop();
      };
      _proto.treatFunctionsAsVarInScope = function treatFunctionsAsVarInScope(scope2) {
        return !!(scope2.flags & (SCOPE_FUNCTION2 | SCOPE_STATIC_BLOCK) || !this.parser.inModule && scope2.flags & SCOPE_PROGRAM);
      };
      _proto.declareName = function declareName(name2, bindingType, loc) {
        var scope2 = this.currentScope();
        if (bindingType & BIND_SCOPE_LEXICAL || bindingType & BIND_SCOPE_FUNCTION) {
          this.checkRedeclarationInScope(scope2, name2, bindingType, loc);
          if (bindingType & BIND_SCOPE_FUNCTION) {
            scope2.functions.add(name2);
          } else {
            scope2.lexical.add(name2);
          }
          if (bindingType & BIND_SCOPE_LEXICAL) {
            this.maybeExportDefined(scope2, name2);
          }
        } else if (bindingType & BIND_SCOPE_VAR) {
          for (var i2 = this.scopeStack.length - 1; i2 >= 0; --i2) {
            scope2 = this.scopeStack[i2];
            this.checkRedeclarationInScope(scope2, name2, bindingType, loc);
            scope2["var"].add(name2);
            this.maybeExportDefined(scope2, name2);
            if (scope2.flags & SCOPE_VAR2)
              break;
          }
        }
        if (this.parser.inModule && scope2.flags & SCOPE_PROGRAM) {
          this.undefinedExports["delete"](name2);
        }
      };
      _proto.maybeExportDefined = function maybeExportDefined(scope2, name2) {
        if (this.parser.inModule && scope2.flags & SCOPE_PROGRAM) {
          this.undefinedExports["delete"](name2);
        }
      };
      _proto.checkRedeclarationInScope = function checkRedeclarationInScope(scope2, name2, bindingType, loc) {
        if (this.isRedeclaredInScope(scope2, name2, bindingType)) {
          this.parser.raise(Errors.VarRedeclaration, {
            at: loc,
            identifierName: name2
          });
        }
      };
      _proto.isRedeclaredInScope = function isRedeclaredInScope(scope2, name2, bindingType) {
        if (!(bindingType & BIND_KIND_VALUE))
          return false;
        if (bindingType & BIND_SCOPE_LEXICAL) {
          return scope2.lexical.has(name2) || scope2.functions.has(name2) || scope2["var"].has(name2);
        }
        if (bindingType & BIND_SCOPE_FUNCTION) {
          return scope2.lexical.has(name2) || !this.treatFunctionsAsVarInScope(scope2) && scope2["var"].has(name2);
        }
        return scope2.lexical.has(name2) && !(scope2.flags & SCOPE_SIMPLE_CATCH2 && scope2.lexical.values().next().value === name2) || !this.treatFunctionsAsVarInScope(scope2) && scope2.functions.has(name2);
      };
      _proto.checkLocalExport = function checkLocalExport(id3) {
        var name2 = id3.name;
        var topLevelScope = this.scopeStack[0];
        if (!topLevelScope.lexical.has(name2) && !topLevelScope["var"].has(name2) && !topLevelScope.functions.has(name2)) {
          this.undefinedExports.set(name2, id3.loc.start);
        }
      };
      _proto.currentScope = function currentScope() {
        return this.scopeStack[this.scopeStack.length - 1];
      };
      _proto.currentVarScopeFlags = function currentVarScopeFlags() {
        for (var i2 = this.scopeStack.length - 1; ; i2--) {
          var flags = this.scopeStack[i2].flags;
          if (flags & SCOPE_VAR2) {
            return flags;
          }
        }
      };
      _proto.currentThisScopeFlags = function currentThisScopeFlags() {
        for (var i2 = this.scopeStack.length - 1; ; i2--) {
          var flags = this.scopeStack[i2].flags;
          if (flags & (SCOPE_VAR2 | SCOPE_CLASS) && !(flags & SCOPE_ARROW2)) {
            return flags;
          }
        }
      };
      _createClass2(ScopeHandler2, [{
        key: "inFunction",
        get: function get3() {
          return (this.currentVarScopeFlags() & SCOPE_FUNCTION2) > 0;
        }
      }, {
        key: "allowSuper",
        get: function get3() {
          return (this.currentThisScopeFlags() & SCOPE_SUPER2) > 0;
        }
      }, {
        key: "allowDirectSuper",
        get: function get3() {
          return (this.currentThisScopeFlags() & SCOPE_DIRECT_SUPER2) > 0;
        }
      }, {
        key: "inClass",
        get: function get3() {
          return (this.currentThisScopeFlags() & SCOPE_CLASS) > 0;
        }
      }, {
        key: "inClassAndNotInNonArrowFunction",
        get: function get3() {
          var flags = this.currentThisScopeFlags();
          return (flags & SCOPE_CLASS) > 0 && (flags & SCOPE_FUNCTION2) === 0;
        }
      }, {
        key: "inStaticBlock",
        get: function get3() {
          for (var i2 = this.scopeStack.length - 1; ; i2--) {
            var flags = this.scopeStack[i2].flags;
            if (flags & SCOPE_STATIC_BLOCK) {
              return true;
            }
            if (flags & (SCOPE_VAR2 | SCOPE_CLASS)) {
              return false;
            }
          }
        }
      }, {
        key: "inNonArrowFunction",
        get: function get3() {
          return (this.currentThisScopeFlags() & SCOPE_FUNCTION2) > 0;
        }
      }, {
        key: "treatFunctionsAsVar",
        get: function get3() {
          return this.treatFunctionsAsVarInScope(this.currentScope());
        }
      }]);
      return ScopeHandler2;
    }();
    var FlowScope = function(_Scope) {
      _inherits2(FlowScope2, _Scope);
      function FlowScope2() {
        var _this;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        _this = _Scope.call.apply(_Scope, [this].concat(args)) || this;
        _this.declareFunctions = /* @__PURE__ */ new Set();
        return _this;
      }
      return _createClass2(FlowScope2);
    }(Scope3);
    var FlowScopeHandler = function(_ScopeHandler) {
      _inherits2(FlowScopeHandler2, _ScopeHandler);
      function FlowScopeHandler2() {
        return _ScopeHandler.apply(this, arguments) || this;
      }
      var _proto = FlowScopeHandler2.prototype;
      _proto.createScope = function createScope(flags) {
        return new FlowScope(flags);
      };
      _proto.declareName = function declareName(name2, bindingType, loc) {
        var scope2 = this.currentScope();
        if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
          this.checkRedeclarationInScope(scope2, name2, bindingType, loc);
          this.maybeExportDefined(scope2, name2);
          scope2.declareFunctions.add(name2);
          return;
        }
        _ScopeHandler.prototype.declareName.apply(this, arguments);
      };
      _proto.isRedeclaredInScope = function isRedeclaredInScope(scope2, name2, bindingType) {
        if (_ScopeHandler.prototype.isRedeclaredInScope.apply(this, arguments))
          return true;
        if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
          return !scope2.declareFunctions.has(name2) && (scope2.lexical.has(name2) || scope2.functions.has(name2));
        }
        return false;
      };
      _proto.checkLocalExport = function checkLocalExport(id3) {
        if (!this.scopeStack[0].declareFunctions.has(id3.name)) {
          _ScopeHandler.prototype.checkLocalExport.call(this, id3);
        }
      };
      return _createClass2(FlowScopeHandler2);
    }(ScopeHandler);
    var ClassScope = _createClass2(function ClassScope2() {
      this.privateNames = /* @__PURE__ */ new Set();
      this.loneAccessors = /* @__PURE__ */ new Map();
      this.undefinedPrivateNames = /* @__PURE__ */ new Map();
    });
    var ClassScopeHandler = function() {
      function ClassScopeHandler2(parser2) {
        this.parser = void 0;
        this.stack = [];
        this.undefinedPrivateNames = /* @__PURE__ */ new Map();
        this.parser = parser2;
      }
      var _proto = ClassScopeHandler2.prototype;
      _proto.current = function current2() {
        return this.stack[this.stack.length - 1];
      };
      _proto.enter = function enter() {
        this.stack.push(new ClassScope());
      };
      _proto.exit = function exit() {
        var oldClassScope = this.stack.pop();
        var current2 = this.current();
        for (var _i22 = 0, _Array$from2 = Array.from(oldClassScope.undefinedPrivateNames); _i22 < _Array$from2.length; _i22++) {
          var _Array$from2$_i = _Array$from2[_i22], name2 = _Array$from2$_i[0], loc = _Array$from2$_i[1];
          if (current2) {
            if (!current2.undefinedPrivateNames.has(name2)) {
              current2.undefinedPrivateNames.set(name2, loc);
            }
          } else {
            this.parser.raise(Errors.InvalidPrivateFieldResolution, {
              at: loc,
              identifierName: name2
            });
          }
        }
      };
      _proto.declarePrivateName = function declarePrivateName(name2, elementType, loc) {
        var _this$current = this.current(), privateNames = _this$current.privateNames, loneAccessors = _this$current.loneAccessors, undefinedPrivateNames = _this$current.undefinedPrivateNames;
        var redefined = privateNames.has(name2);
        if (elementType & CLASS_ELEMENT_KIND_ACCESSOR) {
          var accessor = redefined && loneAccessors.get(name2);
          if (accessor) {
            var oldStatic = accessor & CLASS_ELEMENT_FLAG_STATIC;
            var newStatic = elementType & CLASS_ELEMENT_FLAG_STATIC;
            var oldKind = accessor & CLASS_ELEMENT_KIND_ACCESSOR;
            var newKind = elementType & CLASS_ELEMENT_KIND_ACCESSOR;
            redefined = oldKind === newKind || oldStatic !== newStatic;
            if (!redefined)
              loneAccessors["delete"](name2);
          } else if (!redefined) {
            loneAccessors.set(name2, elementType);
          }
        }
        if (redefined) {
          this.parser.raise(Errors.PrivateNameRedeclaration, {
            at: loc,
            identifierName: name2
          });
        }
        privateNames.add(name2);
        undefinedPrivateNames["delete"](name2);
      };
      _proto.usePrivateName = function usePrivateName(name2, loc) {
        var classScope;
        for (var _i4 = 0, _this$stack2 = this.stack; _i4 < _this$stack2.length; _i4++) {
          classScope = _this$stack2[_i4];
          if (classScope.privateNames.has(name2))
            return;
        }
        if (classScope) {
          classScope.undefinedPrivateNames.set(name2, loc);
        } else {
          this.parser.raise(Errors.InvalidPrivateFieldResolution, {
            at: loc,
            identifierName: name2
          });
        }
      };
      return _createClass2(ClassScopeHandler2);
    }();
    var kExpression = 0, kMaybeArrowParameterDeclaration = 1, kMaybeAsyncArrowParameterDeclaration = 2, kParameterDeclaration = 3;
    var ExpressionScope = function() {
      function ExpressionScope2(type5) {
        if (type5 === void 0) {
          type5 = kExpression;
        }
        this.type = void 0;
        this.type = type5;
      }
      var _proto = ExpressionScope2.prototype;
      _proto.canBeArrowParameterDeclaration = function canBeArrowParameterDeclaration() {
        return this.type === kMaybeAsyncArrowParameterDeclaration || this.type === kMaybeArrowParameterDeclaration;
      };
      _proto.isCertainlyParameterDeclaration = function isCertainlyParameterDeclaration() {
        return this.type === kParameterDeclaration;
      };
      return _createClass2(ExpressionScope2);
    }();
    var ArrowHeadParsingScope = function(_ExpressionScope) {
      _inherits2(ArrowHeadParsingScope2, _ExpressionScope);
      function ArrowHeadParsingScope2(type5) {
        var _this;
        _this = _ExpressionScope.call(this, type5) || this;
        _this.declarationErrors = /* @__PURE__ */ new Map();
        return _this;
      }
      var _proto2 = ArrowHeadParsingScope2.prototype;
      _proto2.recordDeclarationError = function recordDeclarationError(ParsingErrorClass, _ref3) {
        var at2 = _ref3.at;
        var index3 = at2.index;
        this.declarationErrors.set(index3, [ParsingErrorClass, at2]);
      };
      _proto2.clearDeclarationError = function clearDeclarationError(index3) {
        this.declarationErrors["delete"](index3);
      };
      _proto2.iterateErrors = function iterateErrors(iterator2) {
        this.declarationErrors.forEach(iterator2);
      };
      return _createClass2(ArrowHeadParsingScope2);
    }(ExpressionScope);
    var ExpressionScopeHandler = function() {
      function ExpressionScopeHandler2(parser2) {
        this.parser = void 0;
        this.stack = [new ExpressionScope()];
        this.parser = parser2;
      }
      var _proto3 = ExpressionScopeHandler2.prototype;
      _proto3.enter = function enter(scope2) {
        this.stack.push(scope2);
      };
      _proto3.exit = function exit() {
        this.stack.pop();
      };
      _proto3.recordParameterInitializerError = function recordParameterInitializerError(toParseError, _ref22) {
        var node2 = _ref22.at;
        var origin = {
          at: node2.loc.start
        };
        var stack = this.stack;
        var i2 = stack.length - 1;
        var scope2 = stack[i2];
        while (!scope2.isCertainlyParameterDeclaration()) {
          if (scope2.canBeArrowParameterDeclaration()) {
            scope2.recordDeclarationError(toParseError, origin);
          } else {
            return;
          }
          scope2 = stack[--i2];
        }
        this.parser.raise(toParseError, origin);
      };
      _proto3.recordParenthesizedIdentifierError = function recordParenthesizedIdentifierError(_ref3) {
        var node2 = _ref3.at;
        var stack = this.stack;
        var scope2 = stack[stack.length - 1];
        var origin = {
          at: node2.loc.start
        };
        if (scope2.isCertainlyParameterDeclaration()) {
          this.parser.raise(Errors.InvalidParenthesizedAssignment, origin);
        } else if (scope2.canBeArrowParameterDeclaration()) {
          scope2.recordDeclarationError(Errors.InvalidParenthesizedAssignment, origin);
        } else {
          return;
        }
      };
      _proto3.recordAsyncArrowParametersError = function recordAsyncArrowParametersError(_ref42) {
        var at2 = _ref42.at;
        var stack = this.stack;
        var i2 = stack.length - 1;
        var scope2 = stack[i2];
        while (scope2.canBeArrowParameterDeclaration()) {
          if (scope2.type === kMaybeAsyncArrowParameterDeclaration) {
            scope2.recordDeclarationError(Errors.AwaitBindingIdentifier, {
              at: at2
            });
          }
          scope2 = stack[--i2];
        }
      };
      _proto3.validateAsPattern = function validateAsPattern() {
        var _this2 = this;
        var stack = this.stack;
        var currentScope = stack[stack.length - 1];
        if (!currentScope.canBeArrowParameterDeclaration())
          return;
        currentScope.iterateErrors(function(_ref5) {
          var toParseError = _ref5[0], loc = _ref5[1];
          _this2.parser.raise(toParseError, {
            at: loc
          });
          var i2 = stack.length - 2;
          var scope2 = stack[i2];
          while (scope2.canBeArrowParameterDeclaration()) {
            scope2.clearDeclarationError(loc.index);
            scope2 = stack[--i2];
          }
        });
      };
      return _createClass2(ExpressionScopeHandler2);
    }();
    function newParameterDeclarationScope() {
      return new ExpressionScope(kParameterDeclaration);
    }
    function newArrowHeadScope() {
      return new ArrowHeadParsingScope(kMaybeArrowParameterDeclaration);
    }
    function newAsyncArrowScope() {
      return new ArrowHeadParsingScope(kMaybeAsyncArrowParameterDeclaration);
    }
    function newExpressionScope() {
      return new ExpressionScope();
    }
    var PARAM = 0, PARAM_YIELD = 1, PARAM_AWAIT = 2, PARAM_RETURN = 4, PARAM_IN = 8;
    var ProductionParameterHandler = function() {
      function ProductionParameterHandler2() {
        this.stacks = [];
      }
      var _proto = ProductionParameterHandler2.prototype;
      _proto.enter = function enter(flags) {
        this.stacks.push(flags);
      };
      _proto.exit = function exit() {
        this.stacks.pop();
      };
      _proto.currentFlags = function currentFlags() {
        return this.stacks[this.stacks.length - 1];
      };
      _createClass2(ProductionParameterHandler2, [{
        key: "hasAwait",
        get: function get3() {
          return (this.currentFlags() & PARAM_AWAIT) > 0;
        }
      }, {
        key: "hasYield",
        get: function get3() {
          return (this.currentFlags() & PARAM_YIELD) > 0;
        }
      }, {
        key: "hasReturn",
        get: function get3() {
          return (this.currentFlags() & PARAM_RETURN) > 0;
        }
      }, {
        key: "hasIn",
        get: function get3() {
          return (this.currentFlags() & PARAM_IN) > 0;
        }
      }]);
      return ProductionParameterHandler2;
    }();
    function functionFlags2(isAsync2, isGenerator) {
      return (isAsync2 ? PARAM_AWAIT : 0) | (isGenerator ? PARAM_YIELD : 0);
    }
    var UtilParser = function(_Tokenizer) {
      _inherits2(UtilParser2, _Tokenizer);
      function UtilParser2() {
        return _Tokenizer.apply(this, arguments) || this;
      }
      var _proto = UtilParser2.prototype;
      _proto.addExtra = function addExtra(node2, key2, value, enumerable4) {
        if (enumerable4 === void 0) {
          enumerable4 = true;
        }
        if (!node2)
          return;
        var extra = node2.extra = node2.extra || {};
        if (enumerable4) {
          extra[key2] = value;
        } else {
          Object.defineProperty(extra, key2, {
            enumerable: enumerable4,
            value
          });
        }
      };
      _proto.isContextual = function isContextual(token) {
        return this.state.type === token && !this.state.containsEsc;
      };
      _proto.isUnparsedContextual = function isUnparsedContextual(nameStart, name2) {
        var nameEnd = nameStart + name2.length;
        if (this.input.slice(nameStart, nameEnd) === name2) {
          var nextCh = this.input.charCodeAt(nameEnd);
          return !(isIdentifierChar2(nextCh) || (nextCh & 64512) === 55296);
        }
        return false;
      };
      _proto.isLookaheadContextual = function isLookaheadContextual(name2) {
        var next = this.nextTokenStart();
        return this.isUnparsedContextual(next, name2);
      };
      _proto.eatContextual = function eatContextual(token) {
        if (this.isContextual(token)) {
          this.next();
          return true;
        }
        return false;
      };
      _proto.expectContextual = function expectContextual(token, toParseError) {
        if (!this.eatContextual(token)) {
          if (toParseError != null) {
            throw this.raise(toParseError, {
              at: this.state.startLoc
            });
          }
          throw this.unexpected(null, token);
        }
      };
      _proto.canInsertSemicolon = function canInsertSemicolon() {
        return this.match(135) || this.match(8) || this.hasPrecedingLineBreak();
      };
      _proto.hasPrecedingLineBreak = function hasPrecedingLineBreak() {
        return lineBreak2.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
      };
      _proto.hasFollowingLineBreak = function hasFollowingLineBreak() {
        skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
        return skipWhiteSpaceToLineBreak.test(this.input);
      };
      _proto.isLineTerminator = function isLineTerminator() {
        return this.eat(13) || this.canInsertSemicolon();
      };
      _proto.semicolon = function semicolon(allowAsi) {
        if (allowAsi === void 0) {
          allowAsi = true;
        }
        if (allowAsi ? this.isLineTerminator() : this.eat(13))
          return;
        this.raise(Errors.MissingSemicolon, {
          at: this.state.lastTokEndLoc
        });
      };
      _proto.expect = function expect(type5, loc) {
        this.eat(type5) || this.unexpected(loc, type5);
      };
      _proto.tryParse = function tryParse(fn, oldState) {
        if (oldState === void 0) {
          oldState = this.state.clone();
        }
        var abortSignal = {
          node: null
        };
        try {
          var _node = fn(function(node2) {
            if (node2 === void 0) {
              node2 = null;
            }
            abortSignal.node = node2;
            throw abortSignal;
          });
          if (this.state.errors.length > oldState.errors.length) {
            var failState = this.state;
            this.state = oldState;
            this.state.tokensLength = failState.tokensLength;
            return {
              node: _node,
              error: failState.errors[oldState.errors.length],
              thrown: false,
              aborted: false,
              failState
            };
          }
          return {
            node: _node,
            error: null,
            thrown: false,
            aborted: false,
            failState: null
          };
        } catch (error2) {
          var _failState = this.state;
          this.state = oldState;
          if (error2 instanceof SyntaxError) {
            return {
              node: null,
              error: error2,
              thrown: true,
              aborted: false,
              failState: _failState
            };
          }
          if (error2 === abortSignal) {
            return {
              node: abortSignal.node,
              error: null,
              thrown: false,
              aborted: true,
              failState: _failState
            };
          }
          throw error2;
        }
      };
      _proto.checkExpressionErrors = function checkExpressionErrors(refExpressionErrors, andThrow) {
        if (!refExpressionErrors)
          return false;
        var shorthandAssignLoc = refExpressionErrors.shorthandAssignLoc, doubleProtoLoc = refExpressionErrors.doubleProtoLoc, privateKeyLoc = refExpressionErrors.privateKeyLoc, optionalParametersLoc = refExpressionErrors.optionalParametersLoc;
        var hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;
        if (!andThrow) {
          return hasErrors;
        }
        if (shorthandAssignLoc != null) {
          this.raise(Errors.InvalidCoverInitializedName, {
            at: shorthandAssignLoc
          });
        }
        if (doubleProtoLoc != null) {
          this.raise(Errors.DuplicateProto, {
            at: doubleProtoLoc
          });
        }
        if (privateKeyLoc != null) {
          this.raise(Errors.UnexpectedPrivateField, {
            at: privateKeyLoc
          });
        }
        if (optionalParametersLoc != null) {
          this.unexpected(optionalParametersLoc);
        }
      };
      _proto.isLiteralPropertyName = function isLiteralPropertyName() {
        return tokenIsLiteralPropertyName(this.state.type);
      };
      _proto.isPrivateName = function isPrivateName2(node2) {
        return node2.type === "PrivateName";
      };
      _proto.getPrivateNameSV = function getPrivateNameSV(node2) {
        return node2.id.name;
      };
      _proto.hasPropertyAsPrivateName = function hasPropertyAsPrivateName(node2) {
        return (node2.type === "MemberExpression" || node2.type === "OptionalMemberExpression") && this.isPrivateName(node2.property);
      };
      _proto.isOptionalChain = function isOptionalChain(node2) {
        return node2.type === "OptionalMemberExpression" || node2.type === "OptionalCallExpression";
      };
      _proto.isObjectProperty = function isObjectProperty2(node2) {
        return node2.type === "ObjectProperty";
      };
      _proto.isObjectMethod = function isObjectMethod2(node2) {
        return node2.type === "ObjectMethod";
      };
      _proto.initializeScopes = function initializeScopes(inModule) {
        var _this = this;
        if (inModule === void 0) {
          inModule = this.options.sourceType === "module";
        }
        var oldLabels = this.state.labels;
        this.state.labels = [];
        var oldExportedIdentifiers = this.exportedIdentifiers;
        this.exportedIdentifiers = /* @__PURE__ */ new Set();
        var oldInModule = this.inModule;
        this.inModule = inModule;
        var oldScope = this.scope;
        var ScopeHandler2 = this.getScopeHandler();
        this.scope = new ScopeHandler2(this, inModule);
        var oldProdParam = this.prodParam;
        this.prodParam = new ProductionParameterHandler();
        var oldClassScope = this.classScope;
        this.classScope = new ClassScopeHandler(this);
        var oldExpressionScope = this.expressionScope;
        this.expressionScope = new ExpressionScopeHandler(this);
        return function() {
          _this.state.labels = oldLabels;
          _this.exportedIdentifiers = oldExportedIdentifiers;
          _this.inModule = oldInModule;
          _this.scope = oldScope;
          _this.prodParam = oldProdParam;
          _this.classScope = oldClassScope;
          _this.expressionScope = oldExpressionScope;
        };
      };
      _proto.enterInitialScopes = function enterInitialScopes() {
        var paramFlags = PARAM;
        if (this.inModule) {
          paramFlags |= PARAM_AWAIT;
        }
        this.scope.enter(SCOPE_PROGRAM);
        this.prodParam.enter(paramFlags);
      };
      _proto.checkDestructuringPrivate = function checkDestructuringPrivate(refExpressionErrors) {
        var privateKeyLoc = refExpressionErrors.privateKeyLoc;
        if (privateKeyLoc !== null) {
          this.expectPlugin("destructuringPrivate", privateKeyLoc);
        }
      };
      return _createClass2(UtilParser2);
    }(Tokenizer);
    var ExpressionErrors = _createClass2(function ExpressionErrors2() {
      this.shorthandAssignLoc = null;
      this.doubleProtoLoc = null;
      this.privateKeyLoc = null;
      this.optionalParametersLoc = null;
    });
    var Node3 = _createClass2(function Node4(parser2, pos, loc) {
      this.type = "";
      this.start = pos;
      this.end = 0;
      this.loc = new SourceLocation3(loc);
      if (parser2 != null && parser2.options.ranges)
        this.range = [pos, 0];
      if (parser2 != null && parser2.filename)
        this.loc.filename = parser2.filename;
    });
    var NodePrototype = Node3.prototype;
    {
      NodePrototype.__clone = function() {
        var newNode = new Node3();
        var keys2 = Object.keys(this);
        for (var i2 = 0, length = keys2.length; i2 < length; i2++) {
          var _key = keys2[i2];
          if (_key !== "leadingComments" && _key !== "trailingComments" && _key !== "innerComments") {
            newNode[_key] = this[_key];
          }
        }
        return newNode;
      };
    }
    function clonePlaceholder(node2) {
      return cloneIdentifier(node2);
    }
    function cloneIdentifier(node2) {
      var type5 = node2.type, start2 = node2.start, end2 = node2.end, loc = node2.loc, range3 = node2.range, extra = node2.extra, name2 = node2.name;
      var cloned = Object.create(NodePrototype);
      cloned.type = type5;
      cloned.start = start2;
      cloned.end = end2;
      cloned.loc = loc;
      cloned.range = range3;
      cloned.extra = extra;
      cloned.name = name2;
      if (type5 === "Placeholder") {
        cloned.expectedNode = node2.expectedNode;
      }
      return cloned;
    }
    function cloneStringLiteral(node2) {
      var type5 = node2.type, start2 = node2.start, end2 = node2.end, loc = node2.loc, range3 = node2.range, extra = node2.extra;
      if (type5 === "Placeholder") {
        return clonePlaceholder(node2);
      }
      var cloned = Object.create(NodePrototype);
      cloned.type = type5;
      cloned.start = start2;
      cloned.end = end2;
      cloned.loc = loc;
      cloned.range = range3;
      if (node2.raw !== void 0) {
        cloned.raw = node2.raw;
      } else {
        cloned.extra = extra;
      }
      cloned.value = node2.value;
      return cloned;
    }
    var NodeUtils = function(_UtilParser) {
      _inherits2(NodeUtils2, _UtilParser);
      function NodeUtils2() {
        return _UtilParser.apply(this, arguments) || this;
      }
      var _proto = NodeUtils2.prototype;
      _proto.startNode = function startNode() {
        return new Node3(this, this.state.start, this.state.startLoc);
      };
      _proto.startNodeAt = function startNodeAt(pos, loc) {
        return new Node3(this, pos, loc);
      };
      _proto.startNodeAtNode = function startNodeAtNode(type5) {
        return this.startNodeAt(type5.start, type5.loc.start);
      };
      _proto.finishNode = function finishNode(node2, type5) {
        return this.finishNodeAt(node2, type5, this.state.lastTokEndLoc);
      };
      _proto.finishNodeAt = function finishNodeAt2(node2, type5, endLoc) {
        if (node2.end > 0) {
          throw new Error("Do not call finishNode*() twice on the same node. Instead use resetEndLocation() or change type directly.");
        }
        node2.type = type5;
        node2.end = endLoc.index;
        node2.loc.end = endLoc;
        if (this.options.ranges)
          node2.range[1] = endLoc.index;
        if (this.options.attachComment)
          this.processComment(node2);
        return node2;
      };
      _proto.resetStartLocation = function resetStartLocation(node2, start2, startLoc) {
        node2.start = start2;
        node2.loc.start = startLoc;
        if (this.options.ranges)
          node2.range[0] = start2;
      };
      _proto.resetEndLocation = function resetEndLocation(node2, endLoc) {
        if (endLoc === void 0) {
          endLoc = this.state.lastTokEndLoc;
        }
        node2.end = endLoc.index;
        node2.loc.end = endLoc;
        if (this.options.ranges)
          node2.range[1] = endLoc.index;
      };
      _proto.resetStartLocationFromNode = function resetStartLocationFromNode(node2, locationNode) {
        this.resetStartLocation(node2, locationNode.start, locationNode.loc.start);
      };
      return _createClass2(NodeUtils2);
    }(UtilParser);
    var _templateObject$s;
    var reservedTypes = /* @__PURE__ */ new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]);
    var FlowErrors = ParseErrorEnum(_templateObject$s || (_templateObject$s = _taggedTemplateLiteralLoose(["flow"])))(function(_) {
      return {
        AmbiguousConditionalArrow: _("Ambiguous expression: wrap the arrow functions in parentheses to disambiguate."),
        AmbiguousDeclareModuleKind: _("Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module."),
        AssignReservedType: _(function(_ref3) {
          var reservedType = _ref3.reservedType;
          return "Cannot overwrite reserved type " + reservedType + ".";
        }),
        DeclareClassElement: _("The `declare` modifier can only appear on class fields."),
        DeclareClassFieldInitializer: _("Initializers are not allowed in fields with the `declare` modifier."),
        DuplicateDeclareModuleExports: _("Duplicate `declare module.exports` statement."),
        EnumBooleanMemberNotInitialized: _(function(_ref22) {
          var memberName = _ref22.memberName, enumName = _ref22.enumName;
          return "Boolean enum members need to be initialized. Use either `" + memberName + " = true,` or `" + memberName + " = false,` in enum `" + enumName + "`.";
        }),
        EnumDuplicateMemberName: _(function(_ref3) {
          var memberName = _ref3.memberName, enumName = _ref3.enumName;
          return "Enum member names need to be unique, but the name `" + memberName + "` has already been used before in enum `" + enumName + "`.";
        }),
        EnumInconsistentMemberValues: _(function(_ref42) {
          var enumName = _ref42.enumName;
          return "Enum `" + enumName + "` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.";
        }),
        EnumInvalidExplicitType: _(function(_ref5) {
          var invalidEnumType = _ref5.invalidEnumType, enumName = _ref5.enumName;
          return "Enum type `" + invalidEnumType + "` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `" + enumName + "`.";
        }),
        EnumInvalidExplicitTypeUnknownSupplied: _(function(_ref6) {
          var enumName = _ref6.enumName;
          return "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `" + enumName + "`.";
        }),
        EnumInvalidMemberInitializerPrimaryType: _(function(_ref7) {
          var enumName = _ref7.enumName, memberName = _ref7.memberName, explicitType = _ref7.explicitType;
          return "Enum `" + enumName + "` has type `" + explicitType + "`, so the initializer of `" + memberName + "` needs to be a " + explicitType + " literal.";
        }),
        EnumInvalidMemberInitializerSymbolType: _(function(_ref8) {
          var enumName = _ref8.enumName, memberName = _ref8.memberName;
          return "Symbol enum members cannot be initialized. Use `" + memberName + ",` in enum `" + enumName + "`.";
        }),
        EnumInvalidMemberInitializerUnknownType: _(function(_ref9) {
          var enumName = _ref9.enumName, memberName = _ref9.memberName;
          return "The enum member initializer for `" + memberName + "` needs to be a literal (either a boolean, number, or string) in enum `" + enumName + "`.";
        }),
        EnumInvalidMemberName: _(function(_ref10) {
          var enumName = _ref10.enumName, memberName = _ref10.memberName, suggestion = _ref10.suggestion;
          return "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `" + memberName + "`, consider using `" + suggestion + "`, in enum `" + enumName + "`.";
        }),
        EnumNumberMemberNotInitialized: _(function(_ref11) {
          var enumName = _ref11.enumName, memberName = _ref11.memberName;
          return "Number enum members need to be initialized, e.g. `" + memberName + " = 1` in enum `" + enumName + "`.";
        }),
        EnumStringMemberInconsistentlyInitailized: _(function(_ref12) {
          var enumName = _ref12.enumName;
          return "String enum members need to consistently either all use initializers, or use no initializers, in enum `" + enumName + "`.";
        }),
        GetterMayNotHaveThisParam: _("A getter cannot have a `this` parameter."),
        ImportTypeShorthandOnlyInPureImport: _("The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements."),
        InexactInsideExact: _("Explicit inexact syntax cannot appear inside an explicit exact object type."),
        InexactInsideNonObject: _("Explicit inexact syntax cannot appear in class or interface definitions."),
        InexactVariance: _("Explicit inexact syntax cannot have variance."),
        InvalidNonTypeImportInDeclareModule: _("Imports within a `declare module` body must always be `import type` or `import typeof`."),
        MissingTypeParamDefault: _("Type parameter declaration needs a default, since a preceding type parameter declaration has a default."),
        NestedDeclareModule: _("`declare module` cannot be used inside another `declare module`."),
        NestedFlowComment: _("Cannot have a flow comment inside another flow comment."),
        PatternIsOptional: _("A binding pattern parameter cannot be optional in an implementation signature.", {
          reasonCode: "OptionalBindingPattern"
        }),
        SetterMayNotHaveThisParam: _("A setter cannot have a `this` parameter."),
        SpreadVariance: _("Spread properties cannot have variance."),
        ThisParamAnnotationRequired: _("A type annotation is required for the `this` parameter."),
        ThisParamBannedInConstructor: _("Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions."),
        ThisParamMayNotBeOptional: _("The `this` parameter cannot be optional."),
        ThisParamMustBeFirst: _("The `this` parameter must be the first function parameter."),
        ThisParamNoDefault: _("The `this` parameter may not have a default value."),
        TypeBeforeInitializer: _("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."),
        TypeCastInPattern: _("The type cast expression is expected to be wrapped with parenthesis."),
        UnexpectedExplicitInexactInObject: _("Explicit inexact syntax must appear at the end of an inexact object."),
        UnexpectedReservedType: _(function(_ref13) {
          var reservedType = _ref13.reservedType;
          return "Unexpected reserved type " + reservedType + ".";
        }),
        UnexpectedReservedUnderscore: _("`_` is only allowed as a type argument to call or new."),
        UnexpectedSpaceBetweenModuloChecks: _("Spaces between `%` and `checks` are not allowed here."),
        UnexpectedSpreadType: _("Spread operator cannot appear in class or interface definitions."),
        UnexpectedSubtractionOperand: _('Unexpected token, expected "number" or "bigint".'),
        UnexpectedTokenAfterTypeParameter: _("Expected an arrow function after this type parameter declaration."),
        UnexpectedTypeParameterBeforeAsyncArrowFunction: _("Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`."),
        UnsupportedDeclareExportKind: _(function(_ref14) {
          var unsupportedExportKind = _ref14.unsupportedExportKind, suggestion = _ref14.suggestion;
          return "`declare export " + unsupportedExportKind + "` is not supported. Use `" + suggestion + "` instead.";
        }),
        UnsupportedStatementInDeclareModule: _("Only declares and type imports are allowed inside declare module."),
        UnterminatedFlowComment: _("Unterminated flow-comment.")
      };
    });
    function isEsModuleType(bodyElement) {
      return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
    }
    function hasTypeImportKind(node2) {
      return node2.importKind === "type" || node2.importKind === "typeof";
    }
    function isMaybeDefaultImport(type5) {
      return tokenIsKeywordOrIdentifier(type5) && type5 !== 97;
    }
    var exportSuggestions = {
      "const": "declare export var",
      "let": "declare export var",
      type: "export type",
      "interface": "export interface"
    };
    function partition(list2, test) {
      var list1 = [];
      var list22 = [];
      for (var i2 = 0; i2 < list2.length; i2++) {
        (test(list2[i2], i2, list2) ? list1 : list22).push(list2[i2]);
      }
      return [list1, list22];
    }
    var FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
    var flow = function(superClass) {
      return function(_superClass) {
        _inherits2(_class2, _superClass);
        function _class2() {
          var _this2;
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          _this2 = _superClass.call.apply(_superClass, [this].concat(args)) || this;
          _this2.flowPragma = void 0;
          return _this2;
        }
        var _proto = _class2.prototype;
        _proto.getScopeHandler = function getScopeHandler() {
          return FlowScopeHandler;
        };
        _proto.shouldParseTypes = function shouldParseTypes() {
          return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
        };
        _proto.shouldParseEnums = function shouldParseEnums() {
          return !!this.getPluginOption("flow", "enums");
        };
        _proto.finishToken = function finishToken(type5, val) {
          if (type5 !== 129 && type5 !== 13 && type5 !== 28) {
            if (this.flowPragma === void 0) {
              this.flowPragma = null;
            }
          }
          return _superClass.prototype.finishToken.call(this, type5, val);
        };
        _proto.addComment = function addComment2(comment) {
          if (this.flowPragma === void 0) {
            var matches = FLOW_PRAGMA_REGEX.exec(comment.value);
            if (!matches)
              ;
            else if (matches[1] === "flow") {
              this.flowPragma = "flow";
            } else if (matches[1] === "noflow") {
              this.flowPragma = "noflow";
            } else {
              throw new Error("Unexpected flow pragma");
            }
          }
          return _superClass.prototype.addComment.call(this, comment);
        };
        _proto.flowParseTypeInitialiser = function flowParseTypeInitialiser(tok) {
          var oldInType = this.state.inType;
          this.state.inType = true;
          this.expect(tok || 14);
          var type5 = this.flowParseType();
          this.state.inType = oldInType;
          return type5;
        };
        _proto.flowParsePredicate = function flowParsePredicate() {
          var node2 = this.startNode();
          var moduloLoc = this.state.startLoc;
          this.next();
          this.expectContextual(107);
          if (this.state.lastTokStart > moduloLoc.index + 1) {
            this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, {
              at: moduloLoc
            });
          }
          if (this.eat(10)) {
            node2.value = this.parseExpression();
            this.expect(11);
            return this.finishNode(node2, "DeclaredPredicate");
          } else {
            return this.finishNode(node2, "InferredPredicate");
          }
        };
        _proto.flowParseTypeAndPredicateInitialiser = function flowParseTypeAndPredicateInitialiser() {
          var oldInType = this.state.inType;
          this.state.inType = true;
          this.expect(14);
          var type5 = null;
          var predicate = null;
          if (this.match(54)) {
            this.state.inType = oldInType;
            predicate = this.flowParsePredicate();
          } else {
            type5 = this.flowParseType();
            this.state.inType = oldInType;
            if (this.match(54)) {
              predicate = this.flowParsePredicate();
            }
          }
          return [type5, predicate];
        };
        _proto.flowParseDeclareClass = function flowParseDeclareClass(node2) {
          this.next();
          this.flowParseInterfaceish(node2, true);
          return this.finishNode(node2, "DeclareClass");
        };
        _proto.flowParseDeclareFunction = function flowParseDeclareFunction(node2) {
          this.next();
          var id3 = node2.id = this.parseIdentifier();
          var typeNode = this.startNode();
          var typeContainer = this.startNode();
          if (this.match(47)) {
            typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
          } else {
            typeNode.typeParameters = null;
          }
          this.expect(10);
          var tmp = this.flowParseFunctionTypeParams();
          typeNode.params = tmp.params;
          typeNode.rest = tmp.rest;
          typeNode["this"] = tmp._this;
          this.expect(11);
          var _this$flowParseTypeAn = this.flowParseTypeAndPredicateInitialiser();
          typeNode.returnType = _this$flowParseTypeAn[0];
          node2.predicate = _this$flowParseTypeAn[1];
          typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
          id3.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
          this.resetEndLocation(id3);
          this.semicolon();
          this.scope.declareName(node2.id.name, BIND_FLOW_DECLARE_FN, node2.id.loc.start);
          return this.finishNode(node2, "DeclareFunction");
        };
        _proto.flowParseDeclare = function flowParseDeclare(node2, insideModule) {
          if (this.match(80)) {
            return this.flowParseDeclareClass(node2);
          } else if (this.match(68)) {
            return this.flowParseDeclareFunction(node2);
          } else if (this.match(74)) {
            return this.flowParseDeclareVariable(node2);
          } else if (this.eatContextual(123)) {
            if (this.match(16)) {
              return this.flowParseDeclareModuleExports(node2);
            } else {
              if (insideModule) {
                this.raise(FlowErrors.NestedDeclareModule, {
                  at: this.state.lastTokStartLoc
                });
              }
              return this.flowParseDeclareModule(node2);
            }
          } else if (this.isContextual(126)) {
            return this.flowParseDeclareTypeAlias(node2);
          } else if (this.isContextual(127)) {
            return this.flowParseDeclareOpaqueType(node2);
          } else if (this.isContextual(125)) {
            return this.flowParseDeclareInterface(node2);
          } else if (this.match(82)) {
            return this.flowParseDeclareExportDeclaration(node2, insideModule);
          } else {
            throw this.unexpected();
          }
        };
        _proto.flowParseDeclareVariable = function flowParseDeclareVariable(node2) {
          this.next();
          node2.id = this.flowParseTypeAnnotatableIdentifier(true);
          this.scope.declareName(node2.id.name, BIND_VAR2, node2.id.loc.start);
          this.semicolon();
          return this.finishNode(node2, "DeclareVariable");
        };
        _proto.flowParseDeclareModule = function flowParseDeclareModule(node2) {
          var _this3 = this;
          this.scope.enter(SCOPE_OTHER);
          if (this.match(129)) {
            node2.id = this.parseExprAtom();
          } else {
            node2.id = this.parseIdentifier();
          }
          var bodyNode = node2.body = this.startNode();
          var body = bodyNode.body = [];
          this.expect(5);
          while (!this.match(8)) {
            var _bodyNode = this.startNode();
            if (this.match(83)) {
              this.next();
              if (!this.isContextual(126) && !this.match(87)) {
                this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, {
                  at: this.state.lastTokStartLoc
                });
              }
              this.parseImport(_bodyNode);
            } else {
              this.expectContextual(121, FlowErrors.UnsupportedStatementInDeclareModule);
              _bodyNode = this.flowParseDeclare(_bodyNode, true);
            }
            body.push(_bodyNode);
          }
          this.scope.exit();
          this.expect(8);
          this.finishNode(bodyNode, "BlockStatement");
          var kind = null;
          var hasModuleExport = false;
          body.forEach(function(bodyElement) {
            if (isEsModuleType(bodyElement)) {
              if (kind === "CommonJS") {
                _this3.raise(FlowErrors.AmbiguousDeclareModuleKind, {
                  at: bodyElement
                });
              }
              kind = "ES";
            } else if (bodyElement.type === "DeclareModuleExports") {
              if (hasModuleExport) {
                _this3.raise(FlowErrors.DuplicateDeclareModuleExports, {
                  at: bodyElement
                });
              }
              if (kind === "ES") {
                _this3.raise(FlowErrors.AmbiguousDeclareModuleKind, {
                  at: bodyElement
                });
              }
              kind = "CommonJS";
              hasModuleExport = true;
            }
          });
          node2.kind = kind || "CommonJS";
          return this.finishNode(node2, "DeclareModule");
        };
        _proto.flowParseDeclareExportDeclaration = function flowParseDeclareExportDeclaration(node2, insideModule) {
          this.expect(82);
          if (this.eat(65)) {
            if (this.match(68) || this.match(80)) {
              node2.declaration = this.flowParseDeclare(this.startNode());
            } else {
              node2.declaration = this.flowParseType();
              this.semicolon();
            }
            node2["default"] = true;
            return this.finishNode(node2, "DeclareExportDeclaration");
          } else {
            if (this.match(75) || this.isLet() || (this.isContextual(126) || this.isContextual(125)) && !insideModule) {
              var label = this.state.value;
              throw this.raise(FlowErrors.UnsupportedDeclareExportKind, {
                at: this.state.startLoc,
                unsupportedExportKind: label,
                suggestion: exportSuggestions[label]
              });
            }
            if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(127)) {
              node2.declaration = this.flowParseDeclare(this.startNode());
              node2["default"] = false;
              return this.finishNode(node2, "DeclareExportDeclaration");
            } else if (this.match(55) || this.match(5) || this.isContextual(125) || this.isContextual(126) || this.isContextual(127)) {
              node2 = this.parseExport(node2);
              if (node2.type === "ExportNamedDeclaration") {
                node2.type = "ExportDeclaration";
                node2["default"] = false;
                delete node2.exportKind;
              }
              node2.type = "Declare" + node2.type;
              return node2;
            }
          }
          throw this.unexpected();
        };
        _proto.flowParseDeclareModuleExports = function flowParseDeclareModuleExports(node2) {
          this.next();
          this.expectContextual(108);
          node2.typeAnnotation = this.flowParseTypeAnnotation();
          this.semicolon();
          return this.finishNode(node2, "DeclareModuleExports");
        };
        _proto.flowParseDeclareTypeAlias = function flowParseDeclareTypeAlias(node2) {
          this.next();
          this.flowParseTypeAlias(node2);
          node2.type = "DeclareTypeAlias";
          return node2;
        };
        _proto.flowParseDeclareOpaqueType = function flowParseDeclareOpaqueType(node2) {
          this.next();
          this.flowParseOpaqueType(node2, true);
          node2.type = "DeclareOpaqueType";
          return node2;
        };
        _proto.flowParseDeclareInterface = function flowParseDeclareInterface(node2) {
          this.next();
          this.flowParseInterfaceish(node2);
          return this.finishNode(node2, "DeclareInterface");
        };
        _proto.flowParseInterfaceish = function flowParseInterfaceish(node2, isClass2) {
          if (isClass2 === void 0) {
            isClass2 = false;
          }
          node2.id = this.flowParseRestrictedIdentifier(!isClass2, true);
          this.scope.declareName(node2.id.name, isClass2 ? BIND_FUNCTION2 : BIND_LEXICAL2, node2.id.loc.start);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          } else {
            node2.typeParameters = null;
          }
          node2["extends"] = [];
          node2["implements"] = [];
          node2.mixins = [];
          if (this.eat(81)) {
            do {
              node2["extends"].push(this.flowParseInterfaceExtends());
            } while (!isClass2 && this.eat(12));
          }
          if (this.isContextual(114)) {
            this.next();
            do {
              node2.mixins.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          if (this.isContextual(110)) {
            this.next();
            do {
              node2["implements"].push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          node2.body = this.flowParseObjectType({
            allowStatic: isClass2,
            allowExact: false,
            allowSpread: false,
            allowProto: isClass2,
            allowInexact: false
          });
        };
        _proto.flowParseInterfaceExtends = function flowParseInterfaceExtends() {
          var node2 = this.startNode();
          node2.id = this.flowParseQualifiedTypeIdentifier();
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterInstantiation();
          } else {
            node2.typeParameters = null;
          }
          return this.finishNode(node2, "InterfaceExtends");
        };
        _proto.flowParseInterface = function flowParseInterface(node2) {
          this.flowParseInterfaceish(node2);
          return this.finishNode(node2, "InterfaceDeclaration");
        };
        _proto.checkNotUnderscore = function checkNotUnderscore(word) {
          if (word === "_") {
            this.raise(FlowErrors.UnexpectedReservedUnderscore, {
              at: this.state.startLoc
            });
          }
        };
        _proto.checkReservedType = function checkReservedType(word, startLoc, declaration) {
          if (!reservedTypes.has(word))
            return;
          this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, {
            at: startLoc,
            reservedType: word
          });
        };
        _proto.flowParseRestrictedIdentifier = function flowParseRestrictedIdentifier(liberal, declaration) {
          this.checkReservedType(this.state.value, this.state.startLoc, declaration);
          return this.parseIdentifier(liberal);
        };
        _proto.flowParseTypeAlias = function flowParseTypeAlias(node2) {
          node2.id = this.flowParseRestrictedIdentifier(false, true);
          this.scope.declareName(node2.id.name, BIND_LEXICAL2, node2.id.loc.start);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          } else {
            node2.typeParameters = null;
          }
          node2.right = this.flowParseTypeInitialiser(29);
          this.semicolon();
          return this.finishNode(node2, "TypeAlias");
        };
        _proto.flowParseOpaqueType = function flowParseOpaqueType(node2, declare2) {
          this.expectContextual(126);
          node2.id = this.flowParseRestrictedIdentifier(true, true);
          this.scope.declareName(node2.id.name, BIND_LEXICAL2, node2.id.loc.start);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          } else {
            node2.typeParameters = null;
          }
          node2.supertype = null;
          if (this.match(14)) {
            node2.supertype = this.flowParseTypeInitialiser(14);
          }
          node2.impltype = null;
          if (!declare2) {
            node2.impltype = this.flowParseTypeInitialiser(29);
          }
          this.semicolon();
          return this.finishNode(node2, "OpaqueType");
        };
        _proto.flowParseTypeParameter = function flowParseTypeParameter(requireDefault) {
          if (requireDefault === void 0) {
            requireDefault = false;
          }
          var nodeStartLoc = this.state.startLoc;
          var node2 = this.startNode();
          var variance2 = this.flowParseVariance();
          var ident = this.flowParseTypeAnnotatableIdentifier();
          node2.name = ident.name;
          node2.variance = variance2;
          node2.bound = ident.typeAnnotation;
          if (this.match(29)) {
            this.eat(29);
            node2["default"] = this.flowParseType();
          } else {
            if (requireDefault) {
              this.raise(FlowErrors.MissingTypeParamDefault, {
                at: nodeStartLoc
              });
            }
          }
          return this.finishNode(node2, "TypeParameter");
        };
        _proto.flowParseTypeParameterDeclaration = function flowParseTypeParameterDeclaration() {
          var oldInType = this.state.inType;
          var node2 = this.startNode();
          node2.params = [];
          this.state.inType = true;
          if (this.match(47) || this.match(138)) {
            this.next();
          } else {
            this.unexpected();
          }
          var defaultRequired = false;
          do {
            var typeParameter2 = this.flowParseTypeParameter(defaultRequired);
            node2.params.push(typeParameter2);
            if (typeParameter2["default"]) {
              defaultRequired = true;
            }
            if (!this.match(48)) {
              this.expect(12);
            }
          } while (!this.match(48));
          this.expect(48);
          this.state.inType = oldInType;
          return this.finishNode(node2, "TypeParameterDeclaration");
        };
        _proto.flowParseTypeParameterInstantiation = function flowParseTypeParameterInstantiation() {
          var node2 = this.startNode();
          var oldInType = this.state.inType;
          node2.params = [];
          this.state.inType = true;
          this.expect(47);
          var oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = false;
          while (!this.match(48)) {
            node2.params.push(this.flowParseType());
            if (!this.match(48)) {
              this.expect(12);
            }
          }
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
          this.expect(48);
          this.state.inType = oldInType;
          return this.finishNode(node2, "TypeParameterInstantiation");
        };
        _proto.flowParseTypeParameterInstantiationCallOrNew = function flowParseTypeParameterInstantiationCallOrNew() {
          var node2 = this.startNode();
          var oldInType = this.state.inType;
          node2.params = [];
          this.state.inType = true;
          this.expect(47);
          while (!this.match(48)) {
            node2.params.push(this.flowParseTypeOrImplicitInstantiation());
            if (!this.match(48)) {
              this.expect(12);
            }
          }
          this.expect(48);
          this.state.inType = oldInType;
          return this.finishNode(node2, "TypeParameterInstantiation");
        };
        _proto.flowParseInterfaceType = function flowParseInterfaceType() {
          var node2 = this.startNode();
          this.expectContextual(125);
          node2["extends"] = [];
          if (this.eat(81)) {
            do {
              node2["extends"].push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          node2.body = this.flowParseObjectType({
            allowStatic: false,
            allowExact: false,
            allowSpread: false,
            allowProto: false,
            allowInexact: false
          });
          return this.finishNode(node2, "InterfaceTypeAnnotation");
        };
        _proto.flowParseObjectPropertyKey = function flowParseObjectPropertyKey() {
          return this.match(130) || this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);
        };
        _proto.flowParseObjectTypeIndexer = function flowParseObjectTypeIndexer(node2, isStatic2, variance2) {
          node2["static"] = isStatic2;
          if (this.lookahead().type === 14) {
            node2.id = this.flowParseObjectPropertyKey();
            node2.key = this.flowParseTypeInitialiser();
          } else {
            node2.id = null;
            node2.key = this.flowParseType();
          }
          this.expect(3);
          node2.value = this.flowParseTypeInitialiser();
          node2.variance = variance2;
          return this.finishNode(node2, "ObjectTypeIndexer");
        };
        _proto.flowParseObjectTypeInternalSlot = function flowParseObjectTypeInternalSlot(node2, isStatic2) {
          node2["static"] = isStatic2;
          node2.id = this.flowParseObjectPropertyKey();
          this.expect(3);
          this.expect(3);
          if (this.match(47) || this.match(10)) {
            node2.method = true;
            node2.optional = false;
            node2.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node2.start, node2.loc.start));
          } else {
            node2.method = false;
            if (this.eat(17)) {
              node2.optional = true;
            }
            node2.value = this.flowParseTypeInitialiser();
          }
          return this.finishNode(node2, "ObjectTypeInternalSlot");
        };
        _proto.flowParseObjectTypeMethodish = function flowParseObjectTypeMethodish(node2) {
          node2.params = [];
          node2.rest = null;
          node2.typeParameters = null;
          node2["this"] = null;
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          }
          this.expect(10);
          if (this.match(78)) {
            node2["this"] = this.flowParseFunctionTypeParam(true);
            node2["this"].name = null;
            if (!this.match(11)) {
              this.expect(12);
            }
          }
          while (!this.match(11) && !this.match(21)) {
            node2.params.push(this.flowParseFunctionTypeParam(false));
            if (!this.match(11)) {
              this.expect(12);
            }
          }
          if (this.eat(21)) {
            node2.rest = this.flowParseFunctionTypeParam(false);
          }
          this.expect(11);
          node2.returnType = this.flowParseTypeInitialiser();
          return this.finishNode(node2, "FunctionTypeAnnotation");
        };
        _proto.flowParseObjectTypeCallProperty = function flowParseObjectTypeCallProperty(node2, isStatic2) {
          var valueNode = this.startNode();
          node2["static"] = isStatic2;
          node2.value = this.flowParseObjectTypeMethodish(valueNode);
          return this.finishNode(node2, "ObjectTypeCallProperty");
        };
        _proto.flowParseObjectType = function flowParseObjectType(_ref15) {
          var allowStatic = _ref15.allowStatic, allowExact = _ref15.allowExact, allowSpread = _ref15.allowSpread, allowProto = _ref15.allowProto, allowInexact = _ref15.allowInexact;
          var oldInType = this.state.inType;
          this.state.inType = true;
          var nodeStart = this.startNode();
          nodeStart.callProperties = [];
          nodeStart.properties = [];
          nodeStart.indexers = [];
          nodeStart.internalSlots = [];
          var endDelim;
          var exact;
          var inexact = false;
          if (allowExact && this.match(6)) {
            this.expect(6);
            endDelim = 9;
            exact = true;
          } else {
            this.expect(5);
            endDelim = 8;
            exact = false;
          }
          nodeStart.exact = exact;
          while (!this.match(endDelim)) {
            var isStatic2 = false;
            var protoStartLoc = null;
            var inexactStartLoc = null;
            var node2 = this.startNode();
            if (allowProto && this.isContextual(115)) {
              var lookahead2 = this.lookahead();
              if (lookahead2.type !== 14 && lookahead2.type !== 17) {
                this.next();
                protoStartLoc = this.state.startLoc;
                allowStatic = false;
              }
            }
            if (allowStatic && this.isContextual(104)) {
              var _lookahead = this.lookahead();
              if (_lookahead.type !== 14 && _lookahead.type !== 17) {
                this.next();
                isStatic2 = true;
              }
            }
            var variance2 = this.flowParseVariance();
            if (this.eat(0)) {
              if (protoStartLoc != null) {
                this.unexpected(protoStartLoc);
              }
              if (this.eat(0)) {
                if (variance2) {
                  this.unexpected(variance2.loc.start);
                }
                nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node2, isStatic2));
              } else {
                nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node2, isStatic2, variance2));
              }
            } else if (this.match(10) || this.match(47)) {
              if (protoStartLoc != null) {
                this.unexpected(protoStartLoc);
              }
              if (variance2) {
                this.unexpected(variance2.loc.start);
              }
              nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node2, isStatic2));
            } else {
              var kind = "init";
              if (this.isContextual(98) || this.isContextual(103)) {
                var _lookahead2 = this.lookahead();
                if (tokenIsLiteralPropertyName(_lookahead2.type)) {
                  kind = this.state.value;
                  this.next();
                }
              }
              var propOrInexact = this.flowParseObjectTypeProperty(node2, isStatic2, protoStartLoc, variance2, kind, allowSpread, allowInexact != null ? allowInexact : !exact);
              if (propOrInexact === null) {
                inexact = true;
                inexactStartLoc = this.state.lastTokStartLoc;
              } else {
                nodeStart.properties.push(propOrInexact);
              }
            }
            this.flowObjectTypeSemicolon();
            if (inexactStartLoc && !this.match(8) && !this.match(9)) {
              this.raise(FlowErrors.UnexpectedExplicitInexactInObject, {
                at: inexactStartLoc
              });
            }
          }
          this.expect(endDelim);
          if (allowSpread) {
            nodeStart.inexact = inexact;
          }
          var out2 = this.finishNode(nodeStart, "ObjectTypeAnnotation");
          this.state.inType = oldInType;
          return out2;
        };
        _proto.flowParseObjectTypeProperty = function flowParseObjectTypeProperty(node2, isStatic2, protoStartLoc, variance2, kind, allowSpread, allowInexact) {
          if (this.eat(21)) {
            var isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);
            if (isInexactToken) {
              if (!allowSpread) {
                this.raise(FlowErrors.InexactInsideNonObject, {
                  at: this.state.lastTokStartLoc
                });
              } else if (!allowInexact) {
                this.raise(FlowErrors.InexactInsideExact, {
                  at: this.state.lastTokStartLoc
                });
              }
              if (variance2) {
                this.raise(FlowErrors.InexactVariance, {
                  at: variance2
                });
              }
              return null;
            }
            if (!allowSpread) {
              this.raise(FlowErrors.UnexpectedSpreadType, {
                at: this.state.lastTokStartLoc
              });
            }
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance2) {
              this.raise(FlowErrors.SpreadVariance, {
                at: variance2
              });
            }
            node2.argument = this.flowParseType();
            return this.finishNode(node2, "ObjectTypeSpreadProperty");
          } else {
            node2.key = this.flowParseObjectPropertyKey();
            node2["static"] = isStatic2;
            node2.proto = protoStartLoc != null;
            node2.kind = kind;
            var optional = false;
            if (this.match(47) || this.match(10)) {
              node2.method = true;
              if (protoStartLoc != null) {
                this.unexpected(protoStartLoc);
              }
              if (variance2) {
                this.unexpected(variance2.loc.start);
              }
              node2.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node2.start, node2.loc.start));
              if (kind === "get" || kind === "set") {
                this.flowCheckGetterSetterParams(node2);
              }
              if (!allowSpread && node2.key.name === "constructor" && node2.value["this"]) {
                this.raise(FlowErrors.ThisParamBannedInConstructor, {
                  at: node2.value["this"]
                });
              }
            } else {
              if (kind !== "init")
                this.unexpected();
              node2.method = false;
              if (this.eat(17)) {
                optional = true;
              }
              node2.value = this.flowParseTypeInitialiser();
              node2.variance = variance2;
            }
            node2.optional = optional;
            return this.finishNode(node2, "ObjectTypeProperty");
          }
        };
        _proto.flowCheckGetterSetterParams = function flowCheckGetterSetterParams(property2) {
          var paramCount = property2.kind === "get" ? 0 : 1;
          var length = property2.value.params.length + (property2.value.rest ? 1 : 0);
          if (property2.value["this"]) {
            this.raise(property2.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, {
              at: property2.value["this"]
            });
          }
          if (length !== paramCount) {
            this.raise(property2.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, {
              at: property2
            });
          }
          if (property2.kind === "set" && property2.value.rest) {
            this.raise(Errors.BadSetterRestParameter, {
              at: property2
            });
          }
        };
        _proto.flowObjectTypeSemicolon = function flowObjectTypeSemicolon() {
          if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
            this.unexpected();
          }
        };
        _proto.flowParseQualifiedTypeIdentifier = function flowParseQualifiedTypeIdentifier(startPos, startLoc, id3) {
          startPos = startPos || this.state.start;
          startLoc = startLoc || this.state.startLoc;
          var node2 = id3 || this.flowParseRestrictedIdentifier(true);
          while (this.eat(16)) {
            var node22 = this.startNodeAt(startPos, startLoc);
            node22.qualification = node2;
            node22.id = this.flowParseRestrictedIdentifier(true);
            node2 = this.finishNode(node22, "QualifiedTypeIdentifier");
          }
          return node2;
        };
        _proto.flowParseGenericType = function flowParseGenericType(startPos, startLoc, id3) {
          var node2 = this.startNodeAt(startPos, startLoc);
          node2.typeParameters = null;
          node2.id = this.flowParseQualifiedTypeIdentifier(startPos, startLoc, id3);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterInstantiation();
          }
          return this.finishNode(node2, "GenericTypeAnnotation");
        };
        _proto.flowParseTypeofType = function flowParseTypeofType() {
          var node2 = this.startNode();
          this.expect(87);
          node2.argument = this.flowParsePrimaryType();
          return this.finishNode(node2, "TypeofTypeAnnotation");
        };
        _proto.flowParseTupleType = function flowParseTupleType() {
          var node2 = this.startNode();
          node2.types = [];
          this.expect(0);
          while (this.state.pos < this.length && !this.match(3)) {
            node2.types.push(this.flowParseType());
            if (this.match(3))
              break;
            this.expect(12);
          }
          this.expect(3);
          return this.finishNode(node2, "TupleTypeAnnotation");
        };
        _proto.flowParseFunctionTypeParam = function flowParseFunctionTypeParam(first) {
          var name2 = null;
          var optional = false;
          var typeAnnotation2 = null;
          var node2 = this.startNode();
          var lh2 = this.lookahead();
          var isThis = this.state.type === 78;
          if (lh2.type === 14 || lh2.type === 17) {
            if (isThis && !first) {
              this.raise(FlowErrors.ThisParamMustBeFirst, {
                at: node2
              });
            }
            name2 = this.parseIdentifier(isThis);
            if (this.eat(17)) {
              optional = true;
              if (isThis) {
                this.raise(FlowErrors.ThisParamMayNotBeOptional, {
                  at: node2
                });
              }
            }
            typeAnnotation2 = this.flowParseTypeInitialiser();
          } else {
            typeAnnotation2 = this.flowParseType();
          }
          node2.name = name2;
          node2.optional = optional;
          node2.typeAnnotation = typeAnnotation2;
          return this.finishNode(node2, "FunctionTypeParam");
        };
        _proto.reinterpretTypeAsFunctionTypeParam = function reinterpretTypeAsFunctionTypeParam(type5) {
          var node2 = this.startNodeAt(type5.start, type5.loc.start);
          node2.name = null;
          node2.optional = false;
          node2.typeAnnotation = type5;
          return this.finishNode(node2, "FunctionTypeParam");
        };
        _proto.flowParseFunctionTypeParams = function flowParseFunctionTypeParams(params) {
          if (params === void 0) {
            params = [];
          }
          var rest = null;
          var _this = null;
          if (this.match(78)) {
            _this = this.flowParseFunctionTypeParam(true);
            _this.name = null;
            if (!this.match(11)) {
              this.expect(12);
            }
          }
          while (!this.match(11) && !this.match(21)) {
            params.push(this.flowParseFunctionTypeParam(false));
            if (!this.match(11)) {
              this.expect(12);
            }
          }
          if (this.eat(21)) {
            rest = this.flowParseFunctionTypeParam(false);
          }
          return {
            params,
            rest,
            _this
          };
        };
        _proto.flowIdentToTypeAnnotation = function flowIdentToTypeAnnotation(startPos, startLoc, node2, id3) {
          switch (id3.name) {
            case "any":
              return this.finishNode(node2, "AnyTypeAnnotation");
            case "bool":
            case "boolean":
              return this.finishNode(node2, "BooleanTypeAnnotation");
            case "mixed":
              return this.finishNode(node2, "MixedTypeAnnotation");
            case "empty":
              return this.finishNode(node2, "EmptyTypeAnnotation");
            case "number":
              return this.finishNode(node2, "NumberTypeAnnotation");
            case "string":
              return this.finishNode(node2, "StringTypeAnnotation");
            case "symbol":
              return this.finishNode(node2, "SymbolTypeAnnotation");
            default:
              this.checkNotUnderscore(id3.name);
              return this.flowParseGenericType(startPos, startLoc, id3);
          }
        };
        _proto.flowParsePrimaryType = function flowParsePrimaryType() {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var node2 = this.startNode();
          var tmp;
          var type5;
          var isGroupedType = false;
          var oldNoAnonFunctionType = this.state.noAnonFunctionType;
          switch (this.state.type) {
            case 5:
              return this.flowParseObjectType({
                allowStatic: false,
                allowExact: false,
                allowSpread: true,
                allowProto: false,
                allowInexact: true
              });
            case 6:
              return this.flowParseObjectType({
                allowStatic: false,
                allowExact: true,
                allowSpread: true,
                allowProto: false,
                allowInexact: false
              });
            case 0:
              this.state.noAnonFunctionType = false;
              type5 = this.flowParseTupleType();
              this.state.noAnonFunctionType = oldNoAnonFunctionType;
              return type5;
            case 47:
              node2.typeParameters = this.flowParseTypeParameterDeclaration();
              this.expect(10);
              tmp = this.flowParseFunctionTypeParams();
              node2.params = tmp.params;
              node2.rest = tmp.rest;
              node2["this"] = tmp._this;
              this.expect(11);
              this.expect(19);
              node2.returnType = this.flowParseType();
              return this.finishNode(node2, "FunctionTypeAnnotation");
            case 10:
              this.next();
              if (!this.match(11) && !this.match(21)) {
                if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                  var token = this.lookahead().type;
                  isGroupedType = token !== 17 && token !== 14;
                } else {
                  isGroupedType = true;
                }
              }
              if (isGroupedType) {
                this.state.noAnonFunctionType = false;
                type5 = this.flowParseType();
                this.state.noAnonFunctionType = oldNoAnonFunctionType;
                if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
                  this.expect(11);
                  return type5;
                } else {
                  this.eat(12);
                }
              }
              if (type5) {
                tmp = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(type5)]);
              } else {
                tmp = this.flowParseFunctionTypeParams();
              }
              node2.params = tmp.params;
              node2.rest = tmp.rest;
              node2["this"] = tmp._this;
              this.expect(11);
              this.expect(19);
              node2.returnType = this.flowParseType();
              node2.typeParameters = null;
              return this.finishNode(node2, "FunctionTypeAnnotation");
            case 129:
              return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
            case 85:
            case 86:
              node2.value = this.match(85);
              this.next();
              return this.finishNode(node2, "BooleanLiteralTypeAnnotation");
            case 53:
              if (this.state.value === "-") {
                this.next();
                if (this.match(130)) {
                  return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node2);
                }
                if (this.match(131)) {
                  return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node2);
                }
                throw this.raise(FlowErrors.UnexpectedSubtractionOperand, {
                  at: this.state.startLoc
                });
              }
              throw this.unexpected();
            case 130:
              return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
            case 131:
              return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
            case 88:
              this.next();
              return this.finishNode(node2, "VoidTypeAnnotation");
            case 84:
              this.next();
              return this.finishNode(node2, "NullLiteralTypeAnnotation");
            case 78:
              this.next();
              return this.finishNode(node2, "ThisTypeAnnotation");
            case 55:
              this.next();
              return this.finishNode(node2, "ExistsTypeAnnotation");
            case 87:
              return this.flowParseTypeofType();
            default:
              if (tokenIsKeyword(this.state.type)) {
                var label = tokenLabelName(this.state.type);
                this.next();
                return _superClass.prototype.createIdentifier.call(this, node2, label);
              } else if (tokenIsIdentifier(this.state.type)) {
                if (this.isContextual(125)) {
                  return this.flowParseInterfaceType();
                }
                return this.flowIdentToTypeAnnotation(startPos, startLoc, node2, this.parseIdentifier());
              }
          }
          throw this.unexpected();
        };
        _proto.flowParsePostfixType = function flowParsePostfixType() {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var type5 = this.flowParsePrimaryType();
          var seenOptionalIndexedAccess = false;
          while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
            var node2 = this.startNodeAt(startPos, startLoc);
            var optional = this.eat(18);
            seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
            this.expect(0);
            if (!optional && this.match(3)) {
              node2.elementType = type5;
              this.next();
              type5 = this.finishNode(node2, "ArrayTypeAnnotation");
            } else {
              node2.objectType = type5;
              node2.indexType = this.flowParseType();
              this.expect(3);
              if (seenOptionalIndexedAccess) {
                node2.optional = optional;
                type5 = this.finishNode(node2, "OptionalIndexedAccessType");
              } else {
                type5 = this.finishNode(node2, "IndexedAccessType");
              }
            }
          }
          return type5;
        };
        _proto.flowParsePrefixType = function flowParsePrefixType() {
          var node2 = this.startNode();
          if (this.eat(17)) {
            node2.typeAnnotation = this.flowParsePrefixType();
            return this.finishNode(node2, "NullableTypeAnnotation");
          } else {
            return this.flowParsePostfixType();
          }
        };
        _proto.flowParseAnonFunctionWithoutParens = function flowParseAnonFunctionWithoutParens() {
          var param = this.flowParsePrefixType();
          if (!this.state.noAnonFunctionType && this.eat(19)) {
            var node2 = this.startNodeAt(param.start, param.loc.start);
            node2.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
            node2.rest = null;
            node2["this"] = null;
            node2.returnType = this.flowParseType();
            node2.typeParameters = null;
            return this.finishNode(node2, "FunctionTypeAnnotation");
          }
          return param;
        };
        _proto.flowParseIntersectionType = function flowParseIntersectionType() {
          var node2 = this.startNode();
          this.eat(45);
          var type5 = this.flowParseAnonFunctionWithoutParens();
          node2.types = [type5];
          while (this.eat(45)) {
            node2.types.push(this.flowParseAnonFunctionWithoutParens());
          }
          return node2.types.length === 1 ? type5 : this.finishNode(node2, "IntersectionTypeAnnotation");
        };
        _proto.flowParseUnionType = function flowParseUnionType() {
          var node2 = this.startNode();
          this.eat(43);
          var type5 = this.flowParseIntersectionType();
          node2.types = [type5];
          while (this.eat(43)) {
            node2.types.push(this.flowParseIntersectionType());
          }
          return node2.types.length === 1 ? type5 : this.finishNode(node2, "UnionTypeAnnotation");
        };
        _proto.flowParseType = function flowParseType() {
          var oldInType = this.state.inType;
          this.state.inType = true;
          var type5 = this.flowParseUnionType();
          this.state.inType = oldInType;
          return type5;
        };
        _proto.flowParseTypeOrImplicitInstantiation = function flowParseTypeOrImplicitInstantiation() {
          if (this.state.type === 128 && this.state.value === "_") {
            var startPos = this.state.start;
            var startLoc = this.state.startLoc;
            var node2 = this.parseIdentifier();
            return this.flowParseGenericType(startPos, startLoc, node2);
          } else {
            return this.flowParseType();
          }
        };
        _proto.flowParseTypeAnnotation = function flowParseTypeAnnotation() {
          var node2 = this.startNode();
          node2.typeAnnotation = this.flowParseTypeInitialiser();
          return this.finishNode(node2, "TypeAnnotation");
        };
        _proto.flowParseTypeAnnotatableIdentifier = function flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
          var ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
          if (this.match(14)) {
            ident.typeAnnotation = this.flowParseTypeAnnotation();
            this.resetEndLocation(ident);
          }
          return ident;
        };
        _proto.typeCastToParameter = function typeCastToParameter(node2) {
          node2.expression.typeAnnotation = node2.typeAnnotation;
          this.resetEndLocation(node2.expression, node2.typeAnnotation.loc.end);
          return node2.expression;
        };
        _proto.flowParseVariance = function flowParseVariance() {
          var variance2 = null;
          if (this.match(53)) {
            variance2 = this.startNode();
            if (this.state.value === "+") {
              variance2.kind = "plus";
            } else {
              variance2.kind = "minus";
            }
            this.next();
            this.finishNode(variance2, "Variance");
          }
          return variance2;
        };
        _proto.parseFunctionBody = function parseFunctionBody(node2, allowExpressionBody, isMethod2) {
          var _this4 = this;
          if (isMethod2 === void 0) {
            isMethod2 = false;
          }
          if (allowExpressionBody) {
            return this.forwardNoArrowParamsConversionAt(node2, function() {
              return _superClass.prototype.parseFunctionBody.call(_this4, node2, true, isMethod2);
            });
          }
          return _superClass.prototype.parseFunctionBody.call(this, node2, false, isMethod2);
        };
        _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node2, type5, isMethod2) {
          if (isMethod2 === void 0) {
            isMethod2 = false;
          }
          if (this.match(14)) {
            var typeNode = this.startNode();
            var _this$flowParseTypeAn2 = this.flowParseTypeAndPredicateInitialiser();
            typeNode.typeAnnotation = _this$flowParseTypeAn2[0];
            node2.predicate = _this$flowParseTypeAn2[1];
            node2.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
          }
          _superClass.prototype.parseFunctionBodyAndFinish.call(this, node2, type5, isMethod2);
        };
        _proto.parseStatement = function parseStatement(context, topLevel) {
          if (this.state.strict && this.isContextual(125)) {
            var lookahead2 = this.lookahead();
            if (tokenIsKeywordOrIdentifier(lookahead2.type)) {
              var node2 = this.startNode();
              this.next();
              return this.flowParseInterface(node2);
            }
          } else if (this.shouldParseEnums() && this.isContextual(122)) {
            var _node = this.startNode();
            this.next();
            return this.flowParseEnumDeclaration(_node);
          }
          var stmt = _superClass.prototype.parseStatement.call(this, context, topLevel);
          if (this.flowPragma === void 0 && !this.isValidDirective(stmt)) {
            this.flowPragma = null;
          }
          return stmt;
        };
        _proto.parseExpressionStatement = function parseExpressionStatement(node2, expr) {
          if (expr.type === "Identifier") {
            if (expr.name === "declare") {
              if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
                return this.flowParseDeclare(node2);
              }
            } else if (tokenIsIdentifier(this.state.type)) {
              if (expr.name === "interface") {
                return this.flowParseInterface(node2);
              } else if (expr.name === "type") {
                return this.flowParseTypeAlias(node2);
              } else if (expr.name === "opaque") {
                return this.flowParseOpaqueType(node2, false);
              }
            }
          }
          return _superClass.prototype.parseExpressionStatement.call(this, node2, expr);
        };
        _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
          var type5 = this.state.type;
          if (tokenIsFlowInterfaceOrTypeOrOpaque(type5) || this.shouldParseEnums() && type5 === 122) {
            return !this.state.containsEsc;
          }
          return _superClass.prototype.shouldParseExportDeclaration.call(this);
        };
        _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier2() {
          var type5 = this.state.type;
          if (tokenIsFlowInterfaceOrTypeOrOpaque(type5) || this.shouldParseEnums() && type5 === 122) {
            return this.state.containsEsc;
          }
          return _superClass.prototype.isExportDefaultSpecifier.call(this);
        };
        _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
          if (this.shouldParseEnums() && this.isContextual(122)) {
            var node2 = this.startNode();
            this.next();
            return this.flowParseEnumDeclaration(node2);
          }
          return _superClass.prototype.parseExportDefaultExpression.call(this);
        };
        _proto.parseConditional = function parseConditional(expr, startPos, startLoc, refExpressionErrors) {
          var _this5 = this;
          if (!this.match(17))
            return expr;
          if (this.state.maybeInArrowParameters) {
            var nextCh = this.lookaheadCharCode();
            if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
              this.setOptionalParametersError(refExpressionErrors);
              return expr;
            }
          }
          this.expect(17);
          var state = this.state.clone();
          var originalNoArrowAt = this.state.noArrowAt;
          var node2 = this.startNodeAt(startPos, startLoc);
          var _this$tryParseConditi = this.tryParseConditionalConsequent(), consequent = _this$tryParseConditi.consequent, failed = _this$tryParseConditi.failed;
          var _this$getArrowLikeExp = this.getArrowLikeExpressions(consequent), valid = _this$getArrowLikeExp[0], invalid = _this$getArrowLikeExp[1];
          if (failed || invalid.length > 0) {
            var noArrowAt = [].concat(originalNoArrowAt);
            if (invalid.length > 0) {
              this.state = state;
              this.state.noArrowAt = noArrowAt;
              for (var i2 = 0; i2 < invalid.length; i2++) {
                noArrowAt.push(invalid[i2].start);
              }
              var _this$tryParseConditi2 = this.tryParseConditionalConsequent();
              consequent = _this$tryParseConditi2.consequent;
              failed = _this$tryParseConditi2.failed;
              var _this$getArrowLikeExp2 = this.getArrowLikeExpressions(consequent);
              valid = _this$getArrowLikeExp2[0];
              invalid = _this$getArrowLikeExp2[1];
            }
            if (failed && valid.length > 1) {
              this.raise(FlowErrors.AmbiguousConditionalArrow, {
                at: state.startLoc
              });
            }
            if (failed && valid.length === 1) {
              this.state = state;
              noArrowAt.push(valid[0].start);
              this.state.noArrowAt = noArrowAt;
              var _this$tryParseConditi3 = this.tryParseConditionalConsequent();
              consequent = _this$tryParseConditi3.consequent;
              failed = _this$tryParseConditi3.failed;
            }
          }
          this.getArrowLikeExpressions(consequent, true);
          this.state.noArrowAt = originalNoArrowAt;
          this.expect(14);
          node2.test = expr;
          node2.consequent = consequent;
          node2.alternate = this.forwardNoArrowParamsConversionAt(node2, function() {
            return _this5.parseMaybeAssign(void 0, void 0);
          });
          return this.finishNode(node2, "ConditionalExpression");
        };
        _proto.tryParseConditionalConsequent = function tryParseConditionalConsequent() {
          this.state.noArrowParamsConversionAt.push(this.state.start);
          var consequent = this.parseMaybeAssignAllowIn();
          var failed = !this.match(14);
          this.state.noArrowParamsConversionAt.pop();
          return {
            consequent,
            failed
          };
        };
        _proto.getArrowLikeExpressions = function getArrowLikeExpressions(node2, disallowInvalid) {
          var _this6 = this;
          var stack = [node2];
          var arrows = [];
          while (stack.length !== 0) {
            var _node2 = stack.pop();
            if (_node2.type === "ArrowFunctionExpression") {
              if (_node2.typeParameters || !_node2.returnType) {
                this.finishArrowValidation(_node2);
              } else {
                arrows.push(_node2);
              }
              stack.push(_node2.body);
            } else if (_node2.type === "ConditionalExpression") {
              stack.push(_node2.consequent);
              stack.push(_node2.alternate);
            }
          }
          if (disallowInvalid) {
            arrows.forEach(function(node3) {
              return _this6.finishArrowValidation(node3);
            });
            return [arrows, []];
          }
          return partition(arrows, function(node3) {
            return node3.params.every(function(param) {
              return _this6.isAssignable(param, true);
            });
          });
        };
        _proto.finishArrowValidation = function finishArrowValidation(node2) {
          var _node$extra;
          this.toAssignableList(node2.params, (_node$extra = node2.extra) == null ? void 0 : _node$extra.trailingCommaLoc, false);
          this.scope.enter(SCOPE_FUNCTION2 | SCOPE_ARROW2);
          _superClass.prototype.checkParams.call(this, node2, false, true);
          this.scope.exit();
        };
        _proto.forwardNoArrowParamsConversionAt = function forwardNoArrowParamsConversionAt(node2, parse5) {
          var result;
          if (this.state.noArrowParamsConversionAt.indexOf(node2.start) !== -1) {
            this.state.noArrowParamsConversionAt.push(this.state.start);
            result = parse5();
            this.state.noArrowParamsConversionAt.pop();
          } else {
            result = parse5();
          }
          return result;
        };
        _proto.parseParenItem = function parseParenItem(node2, startPos, startLoc) {
          node2 = _superClass.prototype.parseParenItem.call(this, node2, startPos, startLoc);
          if (this.eat(17)) {
            node2.optional = true;
            this.resetEndLocation(node2);
          }
          if (this.match(14)) {
            var typeCastNode = this.startNodeAt(startPos, startLoc);
            typeCastNode.expression = node2;
            typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
            return this.finishNode(typeCastNode, "TypeCastExpression");
          }
          return node2;
        };
        _proto.assertModuleNodeAllowed = function assertModuleNodeAllowed(node2) {
          if (node2.type === "ImportDeclaration" && (node2.importKind === "type" || node2.importKind === "typeof") || node2.type === "ExportNamedDeclaration" && node2.exportKind === "type" || node2.type === "ExportAllDeclaration" && node2.exportKind === "type") {
            return;
          }
          _superClass.prototype.assertModuleNodeAllowed.call(this, node2);
        };
        _proto.parseExport = function parseExport(node2) {
          var decl = _superClass.prototype.parseExport.call(this, node2);
          if (decl.type === "ExportNamedDeclaration" || decl.type === "ExportAllDeclaration") {
            decl.exportKind = decl.exportKind || "value";
          }
          return decl;
        };
        _proto.parseExportDeclaration = function parseExportDeclaration(node2) {
          if (this.isContextual(126)) {
            node2.exportKind = "type";
            var declarationNode = this.startNode();
            this.next();
            if (this.match(5)) {
              node2.specifiers = this.parseExportSpecifiers(true);
              this.parseExportFrom(node2);
              return null;
            } else {
              return this.flowParseTypeAlias(declarationNode);
            }
          } else if (this.isContextual(127)) {
            node2.exportKind = "type";
            var _declarationNode = this.startNode();
            this.next();
            return this.flowParseOpaqueType(_declarationNode, false);
          } else if (this.isContextual(125)) {
            node2.exportKind = "type";
            var _declarationNode2 = this.startNode();
            this.next();
            return this.flowParseInterface(_declarationNode2);
          } else if (this.shouldParseEnums() && this.isContextual(122)) {
            node2.exportKind = "value";
            var _declarationNode3 = this.startNode();
            this.next();
            return this.flowParseEnumDeclaration(_declarationNode3);
          } else {
            return _superClass.prototype.parseExportDeclaration.call(this, node2);
          }
        };
        _proto.eatExportStar = function eatExportStar(node2) {
          if (_superClass.prototype.eatExportStar.apply(this, arguments))
            return true;
          if (this.isContextual(126) && this.lookahead().type === 55) {
            node2.exportKind = "type";
            this.next();
            this.next();
            return true;
          }
          return false;
        };
        _proto.maybeParseExportNamespaceSpecifier = function maybeParseExportNamespaceSpecifier(node2) {
          var startLoc = this.state.startLoc;
          var hasNamespace = _superClass.prototype.maybeParseExportNamespaceSpecifier.call(this, node2);
          if (hasNamespace && node2.exportKind === "type") {
            this.unexpected(startLoc);
          }
          return hasNamespace;
        };
        _proto.parseClassId = function parseClassId(node2, isStatement2, optionalId) {
          _superClass.prototype.parseClassId.call(this, node2, isStatement2, optionalId);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          }
        };
        _proto.parseClassMember = function parseClassMember(classBody2, member, state) {
          var startLoc = this.state.startLoc;
          if (this.isContextual(121)) {
            if (this.parseClassMemberFromModifier(classBody2, member)) {
              return;
            }
            member.declare = true;
          }
          _superClass.prototype.parseClassMember.call(this, classBody2, member, state);
          if (member.declare) {
            if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
              this.raise(FlowErrors.DeclareClassElement, {
                at: startLoc
              });
            } else if (member.value) {
              this.raise(FlowErrors.DeclareClassFieldInitializer, {
                at: member.value
              });
            }
          }
        };
        _proto.isIterator = function isIterator(word) {
          return word === "iterator" || word === "asyncIterator";
        };
        _proto.readIterator = function readIterator() {
          var word = _superClass.prototype.readWord1.call(this);
          var fullWord = "@@" + word;
          if (!this.isIterator(word) || !this.state.inType) {
            this.raise(Errors.InvalidIdentifier, {
              at: this.state.curPosition(),
              identifierName: fullWord
            });
          }
          this.finishToken(128, fullWord);
        };
        _proto.getTokenFromCode = function getTokenFromCode(code3) {
          var next = this.input.charCodeAt(this.state.pos + 1);
          if (code3 === 123 && next === 124) {
            return this.finishOp(6, 2);
          } else if (this.state.inType && (code3 === 62 || code3 === 60)) {
            return this.finishOp(code3 === 62 ? 48 : 47, 1);
          } else if (this.state.inType && code3 === 63) {
            if (next === 46) {
              return this.finishOp(18, 2);
            }
            return this.finishOp(17, 1);
          } else if (isIteratorStart(code3, next, this.input.charCodeAt(this.state.pos + 2))) {
            this.state.pos += 2;
            return this.readIterator();
          } else {
            return _superClass.prototype.getTokenFromCode.call(this, code3);
          }
        };
        _proto.isAssignable = function isAssignable(node2, isBinding2) {
          if (node2.type === "TypeCastExpression") {
            return this.isAssignable(node2.expression, isBinding2);
          } else {
            return _superClass.prototype.isAssignable.call(this, node2, isBinding2);
          }
        };
        _proto.toAssignable = function toAssignable(node2, isLHS) {
          if (isLHS === void 0) {
            isLHS = false;
          }
          if (node2.type === "TypeCastExpression") {
            return _superClass.prototype.toAssignable.call(this, this.typeCastToParameter(node2), isLHS);
          } else {
            return _superClass.prototype.toAssignable.call(this, node2, isLHS);
          }
        };
        _proto.toAssignableList = function toAssignableList(exprList, trailingCommaLoc, isLHS) {
          for (var i2 = 0; i2 < exprList.length; i2++) {
            var expr = exprList[i2];
            if ((expr == null ? void 0 : expr.type) === "TypeCastExpression") {
              exprList[i2] = this.typeCastToParameter(expr);
            }
          }
          return _superClass.prototype.toAssignableList.call(this, exprList, trailingCommaLoc, isLHS);
        };
        _proto.toReferencedList = function toReferencedList(exprList, isParenthesizedExpr) {
          for (var i2 = 0; i2 < exprList.length; i2++) {
            var _expr$extra;
            var expr = exprList[i2];
            if (expr && expr.type === "TypeCastExpression" && !((_expr$extra = expr.extra) != null && _expr$extra.parenthesized) && (exprList.length > 1 || !isParenthesizedExpr)) {
              this.raise(FlowErrors.TypeCastInPattern, {
                at: expr.typeAnnotation
              });
            }
          }
          return exprList;
        };
        _proto.parseArrayLike = function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
          var node2 = _superClass.prototype.parseArrayLike.call(this, close, canBePattern, isTuple, refExpressionErrors);
          if (canBePattern && !this.state.maybeInArrowParameters) {
            this.toReferencedList(node2.elements);
          }
          return node2;
        };
        _proto.isValidLVal = function isValidLVal(type5) {
          var _superClass$prototype;
          for (var _len2 = arguments.length, rest = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            rest[_key2 - 1] = arguments[_key2];
          }
          return type5 === "TypeCastExpression" || (_superClass$prototype = _superClass.prototype.isValidLVal).call.apply(_superClass$prototype, [this, type5].concat(rest));
        };
        _proto.parseClassProperty = function parseClassProperty(node2) {
          if (this.match(14)) {
            node2.typeAnnotation = this.flowParseTypeAnnotation();
          }
          return _superClass.prototype.parseClassProperty.call(this, node2);
        };
        _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node2) {
          if (this.match(14)) {
            node2.typeAnnotation = this.flowParseTypeAnnotation();
          }
          return _superClass.prototype.parseClassPrivateProperty.call(this, node2);
        };
        _proto.isClassMethod = function isClassMethod2() {
          return this.match(47) || _superClass.prototype.isClassMethod.call(this);
        };
        _proto.isClassProperty = function isClassProperty2() {
          return this.match(14) || _superClass.prototype.isClassProperty.call(this);
        };
        _proto.isNonstaticConstructor = function isNonstaticConstructor(method5) {
          return !this.match(14) && _superClass.prototype.isNonstaticConstructor.call(this, method5);
        };
        _proto.pushClassMethod = function pushClassMethod(classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper) {
          if (method5.variance) {
            this.unexpected(method5.variance.loc.start);
          }
          delete method5.variance;
          if (this.match(47)) {
            method5.typeParameters = this.flowParseTypeParameterDeclaration();
          }
          _superClass.prototype.pushClassMethod.call(this, classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper);
          if (method5.params && isConstructor) {
            var params = method5.params;
            if (params.length > 0 && this.isThisParam(params[0])) {
              this.raise(FlowErrors.ThisParamBannedInConstructor, {
                at: method5
              });
            }
          } else if (method5.type === "MethodDefinition" && isConstructor && method5.value.params) {
            var _params2 = method5.value.params;
            if (_params2.length > 0 && this.isThisParam(_params2[0])) {
              this.raise(FlowErrors.ThisParamBannedInConstructor, {
                at: method5
              });
            }
          }
        };
        _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody2, method5, isGenerator, isAsync2) {
          if (method5.variance) {
            this.unexpected(method5.variance.loc.start);
          }
          delete method5.variance;
          if (this.match(47)) {
            method5.typeParameters = this.flowParseTypeParameterDeclaration();
          }
          _superClass.prototype.pushClassPrivateMethod.call(this, classBody2, method5, isGenerator, isAsync2);
        };
        _proto.parseClassSuper = function parseClassSuper(node2) {
          _superClass.prototype.parseClassSuper.call(this, node2);
          if (node2.superClass && this.match(47)) {
            node2.superTypeParameters = this.flowParseTypeParameterInstantiation();
          }
          if (this.isContextual(110)) {
            this.next();
            var implemented = node2["implements"] = [];
            do {
              var _node3 = this.startNode();
              _node3.id = this.flowParseRestrictedIdentifier(true);
              if (this.match(47)) {
                _node3.typeParameters = this.flowParseTypeParameterInstantiation();
              } else {
                _node3.typeParameters = null;
              }
              implemented.push(this.finishNode(_node3, "ClassImplements"));
            } while (this.eat(12));
          }
        };
        _proto.checkGetterSetterParams = function checkGetterSetterParams(method5) {
          _superClass.prototype.checkGetterSetterParams.call(this, method5);
          var params = this.getObjectOrClassMethodParams(method5);
          if (params.length > 0) {
            var param = params[0];
            if (this.isThisParam(param) && method5.kind === "get") {
              this.raise(FlowErrors.GetterMayNotHaveThisParam, {
                at: param
              });
            } else if (this.isThisParam(param)) {
              this.raise(FlowErrors.SetterMayNotHaveThisParam, {
                at: param
              });
            }
          }
        };
        _proto.parsePropertyNamePrefixOperator = function parsePropertyNamePrefixOperator(node2) {
          node2.variance = this.flowParseVariance();
        };
        _proto.parseObjPropValue = function parseObjPropValue(prop2, startPos, startLoc, isGenerator, isAsync2, isPattern3, isAccessor2, refExpressionErrors) {
          if (prop2.variance) {
            this.unexpected(prop2.variance.loc.start);
          }
          delete prop2.variance;
          var typeParameters;
          if (this.match(47) && !isAccessor2) {
            typeParameters = this.flowParseTypeParameterDeclaration();
            if (!this.match(10))
              this.unexpected();
          }
          _superClass.prototype.parseObjPropValue.call(this, prop2, startPos, startLoc, isGenerator, isAsync2, isPattern3, isAccessor2, refExpressionErrors);
          if (typeParameters) {
            (prop2.value || prop2).typeParameters = typeParameters;
          }
        };
        _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param) {
          if (this.eat(17)) {
            if (param.type !== "Identifier") {
              this.raise(FlowErrors.PatternIsOptional, {
                at: param
              });
            }
            if (this.isThisParam(param)) {
              this.raise(FlowErrors.ThisParamMayNotBeOptional, {
                at: param
              });
            }
            param.optional = true;
          }
          if (this.match(14)) {
            param.typeAnnotation = this.flowParseTypeAnnotation();
          } else if (this.isThisParam(param)) {
            this.raise(FlowErrors.ThisParamAnnotationRequired, {
              at: param
            });
          }
          if (this.match(29) && this.isThisParam(param)) {
            this.raise(FlowErrors.ThisParamNoDefault, {
              at: param
            });
          }
          this.resetEndLocation(param);
          return param;
        };
        _proto.parseMaybeDefault = function parseMaybeDefault(startPos, startLoc, left) {
          var node2 = _superClass.prototype.parseMaybeDefault.call(this, startPos, startLoc, left);
          if (node2.type === "AssignmentPattern" && node2.typeAnnotation && node2.right.start < node2.typeAnnotation.start) {
            this.raise(FlowErrors.TypeBeforeInitializer, {
              at: node2.typeAnnotation
            });
          }
          return node2;
        };
        _proto.shouldParseDefaultImport = function shouldParseDefaultImport(node2) {
          if (!hasTypeImportKind(node2)) {
            return _superClass.prototype.shouldParseDefaultImport.call(this, node2);
          }
          return isMaybeDefaultImport(this.state.type);
        };
        _proto.parseImportSpecifierLocal = function parseImportSpecifierLocal(node2, specifier, type5) {
          specifier.local = hasTypeImportKind(node2) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
          node2.specifiers.push(this.finishImportSpecifier(specifier, type5));
        };
        _proto.maybeParseDefaultImportSpecifier = function maybeParseDefaultImportSpecifier(node2) {
          node2.importKind = "value";
          var kind = null;
          if (this.match(87)) {
            kind = "typeof";
          } else if (this.isContextual(126)) {
            kind = "type";
          }
          if (kind) {
            var lh2 = this.lookahead();
            var type5 = lh2.type;
            if (kind === "type" && type5 === 55) {
              this.unexpected(null, lh2.type);
            }
            if (isMaybeDefaultImport(type5) || type5 === 5 || type5 === 55) {
              this.next();
              node2.importKind = kind;
            }
          }
          return _superClass.prototype.maybeParseDefaultImportSpecifier.call(this, node2);
        };
        _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
          var firstIdent = specifier.imported;
          var specifierTypeKind = null;
          if (firstIdent.type === "Identifier") {
            if (firstIdent.name === "type") {
              specifierTypeKind = "type";
            } else if (firstIdent.name === "typeof") {
              specifierTypeKind = "typeof";
            }
          }
          var isBinding2 = false;
          if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
            var as_ident = this.parseIdentifier(true);
            if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
              specifier.imported = as_ident;
              specifier.importKind = specifierTypeKind;
              specifier.local = cloneIdentifier(as_ident);
            } else {
              specifier.imported = firstIdent;
              specifier.importKind = null;
              specifier.local = this.parseIdentifier();
            }
          } else {
            if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
              specifier.imported = this.parseIdentifier(true);
              specifier.importKind = specifierTypeKind;
            } else {
              if (importedIsString) {
                throw this.raise(Errors.ImportBindingIsString, {
                  at: specifier,
                  importName: firstIdent.value
                });
              }
              specifier.imported = firstIdent;
              specifier.importKind = null;
            }
            if (this.eatContextual(93)) {
              specifier.local = this.parseIdentifier();
            } else {
              isBinding2 = true;
              specifier.local = cloneIdentifier(specifier.imported);
            }
          }
          var specifierIsTypeImport = hasTypeImportKind(specifier);
          if (isInTypeOnlyImport && specifierIsTypeImport) {
            this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, {
              at: specifier
            });
          }
          if (isInTypeOnlyImport || specifierIsTypeImport) {
            this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
          }
          if (isBinding2 && !isInTypeOnlyImport && !specifierIsTypeImport) {
            this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
          }
          return this.finishImportSpecifier(specifier, "ImportSpecifier");
        };
        _proto.parseBindingAtom = function parseBindingAtom() {
          switch (this.state.type) {
            case 78:
              return this.parseIdentifier(true);
            default:
              return _superClass.prototype.parseBindingAtom.call(this);
          }
        };
        _proto.parseFunctionParams = function parseFunctionParams(node2, allowModifiers) {
          var kind = node2.kind;
          if (kind !== "get" && kind !== "set" && this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterDeclaration();
          }
          _superClass.prototype.parseFunctionParams.call(this, node2, allowModifiers);
        };
        _proto.parseVarId = function parseVarId(decl, kind) {
          _superClass.prototype.parseVarId.call(this, decl, kind);
          if (this.match(14)) {
            decl.id.typeAnnotation = this.flowParseTypeAnnotation();
            this.resetEndLocation(decl.id);
          }
        };
        _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node2, call3) {
          if (this.match(14)) {
            var oldNoAnonFunctionType = this.state.noAnonFunctionType;
            this.state.noAnonFunctionType = true;
            node2.returnType = this.flowParseTypeAnnotation();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
          }
          return _superClass.prototype.parseAsyncArrowFromCallExpression.call(this, node2, call3);
        };
        _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
          return this.match(14) || _superClass.prototype.shouldParseAsyncArrow.call(this);
        };
        _proto.parseMaybeAssign = function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
          var _this7 = this, _jsx;
          var state = null;
          var jsx3;
          if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
            state = this.state.clone();
            jsx3 = this.tryParse(function() {
              return _superClass.prototype.parseMaybeAssign.call(_this7, refExpressionErrors, afterLeftParse);
            }, state);
            if (!jsx3.error)
              return jsx3.node;
            var context = this.state.context;
            var currentContext = context[context.length - 1];
            if (currentContext === types2.j_oTag || currentContext === types2.j_expr) {
              context.pop();
            }
          }
          if ((_jsx = jsx3) != null && _jsx.error || this.match(47)) {
            var _jsx2, _jsx3;
            state = state || this.state.clone();
            var typeParameters;
            var arrow = this.tryParse(function(abort) {
              var _arrowExpression$extr;
              typeParameters = _this7.flowParseTypeParameterDeclaration();
              var arrowExpression2 = _this7.forwardNoArrowParamsConversionAt(typeParameters, function() {
                var result = _superClass.prototype.parseMaybeAssign.call(_this7, refExpressionErrors, afterLeftParse);
                _this7.resetStartLocationFromNode(result, typeParameters);
                return result;
              });
              if ((_arrowExpression$extr = arrowExpression2.extra) != null && _arrowExpression$extr.parenthesized)
                abort();
              var expr = _this7.maybeUnwrapTypeCastExpression(arrowExpression2);
              if (expr.type !== "ArrowFunctionExpression")
                abort();
              expr.typeParameters = typeParameters;
              _this7.resetStartLocationFromNode(expr, typeParameters);
              return arrowExpression2;
            }, state);
            var arrowExpression = null;
            if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
              if (!arrow.error && !arrow.aborted) {
                if (arrow.node.async) {
                  this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, {
                    at: typeParameters
                  });
                }
                return arrow.node;
              }
              arrowExpression = arrow.node;
            }
            if ((_jsx2 = jsx3) != null && _jsx2.node) {
              this.state = jsx3.failState;
              return jsx3.node;
            }
            if (arrowExpression) {
              this.state = arrow.failState;
              return arrowExpression;
            }
            if ((_jsx3 = jsx3) != null && _jsx3.thrown)
              throw jsx3.error;
            if (arrow.thrown)
              throw arrow.error;
            throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, {
              at: typeParameters
            });
          }
          return _superClass.prototype.parseMaybeAssign.call(this, refExpressionErrors, afterLeftParse);
        };
        _proto.parseArrow = function parseArrow(node2) {
          var _this8 = this;
          if (this.match(14)) {
            var result = this.tryParse(function() {
              var oldNoAnonFunctionType = _this8.state.noAnonFunctionType;
              _this8.state.noAnonFunctionType = true;
              var typeNode = _this8.startNode();
              var _this8$flowParseTypeA = _this8.flowParseTypeAndPredicateInitialiser();
              typeNode.typeAnnotation = _this8$flowParseTypeA[0];
              node2.predicate = _this8$flowParseTypeA[1];
              _this8.state.noAnonFunctionType = oldNoAnonFunctionType;
              if (_this8.canInsertSemicolon())
                _this8.unexpected();
              if (!_this8.match(19))
                _this8.unexpected();
              return typeNode;
            });
            if (result.thrown)
              return null;
            if (result.error)
              this.state = result.failState;
            node2.returnType = result.node.typeAnnotation ? this.finishNode(result.node, "TypeAnnotation") : null;
          }
          return _superClass.prototype.parseArrow.call(this, node2);
        };
        _proto.shouldParseArrow = function shouldParseArrow(params) {
          return this.match(14) || _superClass.prototype.shouldParseArrow.call(this, params);
        };
        _proto.setArrowFunctionParameters = function setArrowFunctionParameters(node2, params) {
          if (this.state.noArrowParamsConversionAt.indexOf(node2.start) !== -1) {
            node2.params = params;
          } else {
            _superClass.prototype.setArrowFunctionParameters.call(this, node2, params);
          }
        };
        _proto.checkParams = function checkParams(node2, allowDuplicates, isArrowFunction) {
          if (isArrowFunction && this.state.noArrowParamsConversionAt.indexOf(node2.start) !== -1) {
            return;
          }
          for (var i2 = 0; i2 < node2.params.length; i2++) {
            if (this.isThisParam(node2.params[i2]) && i2 > 0) {
              this.raise(FlowErrors.ThisParamMustBeFirst, {
                at: node2.params[i2]
              });
            }
          }
          return _superClass.prototype.checkParams.apply(this, arguments);
        };
        _proto.parseParenAndDistinguishExpression = function parseParenAndDistinguishExpression(canBeArrow) {
          return _superClass.prototype.parseParenAndDistinguishExpression.call(this, canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1);
        };
        _proto.parseSubscripts = function parseSubscripts(base2, startPos, startLoc, noCalls) {
          var _this9 = this;
          if (base2.type === "Identifier" && base2.name === "async" && this.state.noArrowAt.indexOf(startPos) !== -1) {
            this.next();
            var node2 = this.startNodeAt(startPos, startLoc);
            node2.callee = base2;
            node2.arguments = this.parseCallExpressionArguments(11, false);
            base2 = this.finishNode(node2, "CallExpression");
          } else if (base2.type === "Identifier" && base2.name === "async" && this.match(47)) {
            var state = this.state.clone();
            var arrow = this.tryParse(function(abort) {
              return _this9.parseAsyncArrowWithTypeParameters(startPos, startLoc) || abort();
            }, state);
            if (!arrow.error && !arrow.aborted)
              return arrow.node;
            var result = this.tryParse(function() {
              return _superClass.prototype.parseSubscripts.call(_this9, base2, startPos, startLoc, noCalls);
            }, state);
            if (result.node && !result.error)
              return result.node;
            if (arrow.node) {
              this.state = arrow.failState;
              return arrow.node;
            }
            if (result.node) {
              this.state = result.failState;
              return result.node;
            }
            throw arrow.error || result.error;
          }
          return _superClass.prototype.parseSubscripts.call(this, base2, startPos, startLoc, noCalls);
        };
        _proto.parseSubscript = function parseSubscript(base2, startPos, startLoc, noCalls, subscriptState) {
          var _this10 = this;
          if (this.match(18) && this.isLookaheadToken_lt()) {
            subscriptState.optionalChainMember = true;
            if (noCalls) {
              subscriptState.stop = true;
              return base2;
            }
            this.next();
            var node2 = this.startNodeAt(startPos, startLoc);
            node2.callee = base2;
            node2.typeArguments = this.flowParseTypeParameterInstantiation();
            this.expect(10);
            node2.arguments = this.parseCallExpressionArguments(11, false);
            node2.optional = true;
            return this.finishCallExpression(node2, true);
          } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
            var _node4 = this.startNodeAt(startPos, startLoc);
            _node4.callee = base2;
            var result = this.tryParse(function() {
              _node4.typeArguments = _this10.flowParseTypeParameterInstantiationCallOrNew();
              _this10.expect(10);
              _node4.arguments = _this10.parseCallExpressionArguments(11, false);
              if (subscriptState.optionalChainMember)
                _node4.optional = false;
              return _this10.finishCallExpression(_node4, subscriptState.optionalChainMember);
            });
            if (result.node) {
              if (result.error)
                this.state = result.failState;
              return result.node;
            }
          }
          return _superClass.prototype.parseSubscript.call(this, base2, startPos, startLoc, noCalls, subscriptState);
        };
        _proto.parseNewArguments = function parseNewArguments(node2) {
          var _this11 = this;
          var targs = null;
          if (this.shouldParseTypes() && this.match(47)) {
            targs = this.tryParse(function() {
              return _this11.flowParseTypeParameterInstantiationCallOrNew();
            }).node;
          }
          node2.typeArguments = targs;
          _superClass.prototype.parseNewArguments.call(this, node2);
        };
        _proto.parseAsyncArrowWithTypeParameters = function parseAsyncArrowWithTypeParameters(startPos, startLoc) {
          var node2 = this.startNodeAt(startPos, startLoc);
          this.parseFunctionParams(node2);
          if (!this.parseArrow(node2))
            return;
          return this.parseArrowExpression(node2, void 0, true);
        };
        _proto.readToken_mult_modulo = function readToken_mult_modulo(code3) {
          var next = this.input.charCodeAt(this.state.pos + 1);
          if (code3 === 42 && next === 47 && this.state.hasFlowComment) {
            this.state.hasFlowComment = false;
            this.state.pos += 2;
            this.nextToken();
            return;
          }
          _superClass.prototype.readToken_mult_modulo.call(this, code3);
        };
        _proto.readToken_pipe_amp = function readToken_pipe_amp(code3) {
          var next = this.input.charCodeAt(this.state.pos + 1);
          if (code3 === 124 && next === 125) {
            this.finishOp(9, 2);
            return;
          }
          _superClass.prototype.readToken_pipe_amp.call(this, code3);
        };
        _proto.parseTopLevel = function parseTopLevel(file2, program2) {
          var fileNode = _superClass.prototype.parseTopLevel.call(this, file2, program2);
          if (this.state.hasFlowComment) {
            this.raise(FlowErrors.UnterminatedFlowComment, {
              at: this.state.curPosition()
            });
          }
          return fileNode;
        };
        _proto.skipBlockComment = function skipBlockComment() {
          if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
            if (this.state.hasFlowComment) {
              throw this.raise(FlowErrors.NestedFlowComment, {
                at: this.state.startLoc
              });
            }
            this.hasFlowCommentCompletion();
            this.state.pos += this.skipFlowComment();
            this.state.hasFlowComment = true;
            return;
          }
          if (this.state.hasFlowComment) {
            var end2 = this.input.indexOf("*-/", this.state.pos + 2);
            if (end2 === -1) {
              throw this.raise(Errors.UnterminatedComment, {
                at: this.state.curPosition()
              });
            }
            this.state.pos = end2 + 2 + 3;
            return;
          }
          return _superClass.prototype.skipBlockComment.call(this);
        };
        _proto.skipFlowComment = function skipFlowComment() {
          var pos = this.state.pos;
          var shiftToFirstNonWhiteSpace = 2;
          while ([32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))) {
            shiftToFirstNonWhiteSpace++;
          }
          var ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
          var ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
          if (ch2 === 58 && ch3 === 58) {
            return shiftToFirstNonWhiteSpace + 2;
          }
          if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
            return shiftToFirstNonWhiteSpace + 12;
          }
          if (ch2 === 58 && ch3 !== 58) {
            return shiftToFirstNonWhiteSpace;
          }
          return false;
        };
        _proto.hasFlowCommentCompletion = function hasFlowCommentCompletion() {
          var end2 = this.input.indexOf("*/", this.state.pos);
          if (end2 === -1) {
            throw this.raise(Errors.UnterminatedComment, {
              at: this.state.curPosition()
            });
          }
        };
        _proto.flowEnumErrorBooleanMemberNotInitialized = function flowEnumErrorBooleanMemberNotInitialized(loc, _ref16) {
          var enumName = _ref16.enumName, memberName = _ref16.memberName;
          this.raise(FlowErrors.EnumBooleanMemberNotInitialized, {
            at: loc,
            memberName,
            enumName
          });
        };
        _proto.flowEnumErrorInvalidMemberInitializer = function flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
          return this.raise(!enumContext.explicitType ? FlowErrors.EnumInvalidMemberInitializerUnknownType : enumContext.explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerPrimaryType, Object.assign({
            at: loc
          }, enumContext));
        };
        _proto.flowEnumErrorNumberMemberNotInitialized = function flowEnumErrorNumberMemberNotInitialized(loc, _ref17) {
          var enumName = _ref17.enumName, memberName = _ref17.memberName;
          this.raise(FlowErrors.EnumNumberMemberNotInitialized, {
            at: loc,
            enumName,
            memberName
          });
        };
        _proto.flowEnumErrorStringMemberInconsistentlyInitailized = function flowEnumErrorStringMemberInconsistentlyInitailized(node2, _ref18) {
          var enumName = _ref18.enumName;
          this.raise(FlowErrors.EnumStringMemberInconsistentlyInitailized, {
            at: node2,
            enumName
          });
        };
        _proto.flowEnumMemberInit = function flowEnumMemberInit() {
          var _this12 = this;
          var startLoc = this.state.startLoc;
          var endOfInit = function endOfInit2() {
            return _this12.match(12) || _this12.match(8);
          };
          switch (this.state.type) {
            case 130: {
              var literal2 = this.parseNumericLiteral(this.state.value);
              if (endOfInit()) {
                return {
                  type: "number",
                  loc: literal2.loc.start,
                  value: literal2
                };
              }
              return {
                type: "invalid",
                loc: startLoc
              };
            }
            case 129: {
              var _literal = this.parseStringLiteral(this.state.value);
              if (endOfInit()) {
                return {
                  type: "string",
                  loc: _literal.loc.start,
                  value: _literal
                };
              }
              return {
                type: "invalid",
                loc: startLoc
              };
            }
            case 85:
            case 86: {
              var _literal2 = this.parseBooleanLiteral(this.match(85));
              if (endOfInit()) {
                return {
                  type: "boolean",
                  loc: _literal2.loc.start,
                  value: _literal2
                };
              }
              return {
                type: "invalid",
                loc: startLoc
              };
            }
            default:
              return {
                type: "invalid",
                loc: startLoc
              };
          }
        };
        _proto.flowEnumMemberRaw = function flowEnumMemberRaw() {
          var loc = this.state.startLoc;
          var id3 = this.parseIdentifier(true);
          var init3 = this.eat(29) ? this.flowEnumMemberInit() : {
            type: "none",
            loc
          };
          return {
            id: id3,
            init: init3
          };
        };
        _proto.flowEnumCheckExplicitTypeMismatch = function flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
          var explicitType = context.explicitType;
          if (explicitType === null) {
            return;
          }
          if (explicitType !== expectedType) {
            this.flowEnumErrorInvalidMemberInitializer(loc, context);
          }
        };
        _proto.flowEnumMembers = function flowEnumMembers(_ref19) {
          var enumName = _ref19.enumName, explicitType = _ref19.explicitType;
          var seenNames = /* @__PURE__ */ new Set();
          var members = {
            booleanMembers: [],
            numberMembers: [],
            stringMembers: [],
            defaultedMembers: []
          };
          var hasUnknownMembers = false;
          while (!this.match(8)) {
            if (this.eat(21)) {
              hasUnknownMembers = true;
              break;
            }
            var memberNode = this.startNode();
            var _this$flowEnumMemberR = this.flowEnumMemberRaw(), id3 = _this$flowEnumMemberR.id, init3 = _this$flowEnumMemberR.init;
            var memberName = id3.name;
            if (memberName === "") {
              continue;
            }
            if (/^[a-z]/.test(memberName)) {
              this.raise(FlowErrors.EnumInvalidMemberName, {
                at: id3,
                memberName,
                suggestion: memberName[0].toUpperCase() + memberName.slice(1),
                enumName
              });
            }
            if (seenNames.has(memberName)) {
              this.raise(FlowErrors.EnumDuplicateMemberName, {
                at: id3,
                memberName,
                enumName
              });
            }
            seenNames.add(memberName);
            var context = {
              enumName,
              explicitType,
              memberName
            };
            memberNode.id = id3;
            switch (init3.type) {
              case "boolean": {
                this.flowEnumCheckExplicitTypeMismatch(init3.loc, context, "boolean");
                memberNode.init = init3.value;
                members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
                break;
              }
              case "number": {
                this.flowEnumCheckExplicitTypeMismatch(init3.loc, context, "number");
                memberNode.init = init3.value;
                members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
                break;
              }
              case "string": {
                this.flowEnumCheckExplicitTypeMismatch(init3.loc, context, "string");
                memberNode.init = init3.value;
                members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
                break;
              }
              case "invalid": {
                throw this.flowEnumErrorInvalidMemberInitializer(init3.loc, context);
              }
              case "none": {
                switch (explicitType) {
                  case "boolean":
                    this.flowEnumErrorBooleanMemberNotInitialized(init3.loc, context);
                    break;
                  case "number":
                    this.flowEnumErrorNumberMemberNotInitialized(init3.loc, context);
                    break;
                  default:
                    members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
                }
              }
            }
            if (!this.match(8)) {
              this.expect(12);
            }
          }
          return {
            members,
            hasUnknownMembers
          };
        };
        _proto.flowEnumStringMembers = function flowEnumStringMembers(initializedMembers, defaultedMembers, _ref20) {
          var enumName = _ref20.enumName;
          if (initializedMembers.length === 0) {
            return defaultedMembers;
          } else if (defaultedMembers.length === 0) {
            return initializedMembers;
          } else if (defaultedMembers.length > initializedMembers.length) {
            for (var _i22 = 0; _i22 < initializedMembers.length; _i22++) {
              var member = initializedMembers[_i22];
              this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
                enumName
              });
            }
            return defaultedMembers;
          } else {
            for (var _i4 = 0; _i4 < defaultedMembers.length; _i4++) {
              var _member = defaultedMembers[_i4];
              this.flowEnumErrorStringMemberInconsistentlyInitailized(_member, {
                enumName
              });
            }
            return initializedMembers;
          }
        };
        _proto.flowEnumParseExplicitType = function flowEnumParseExplicitType(_ref21) {
          var enumName = _ref21.enumName;
          if (!this.eatContextual(101))
            return null;
          if (!tokenIsIdentifier(this.state.type)) {
            throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, {
              at: this.state.startLoc,
              enumName
            });
          }
          var value = this.state.value;
          this.next();
          if (value !== "boolean" && value !== "number" && value !== "string" && value !== "symbol") {
            this.raise(FlowErrors.EnumInvalidExplicitType, {
              at: this.state.startLoc,
              enumName,
              invalidEnumType: value
            });
          }
          return value;
        };
        _proto.flowEnumBody = function flowEnumBody(node2, id3) {
          var _this13 = this;
          var enumName = id3.name;
          var nameLoc = id3.loc.start;
          var explicitType = this.flowEnumParseExplicitType({
            enumName
          });
          this.expect(5);
          var _this$flowEnumMembers = this.flowEnumMembers({
            enumName,
            explicitType
          }), members = _this$flowEnumMembers.members, hasUnknownMembers = _this$flowEnumMembers.hasUnknownMembers;
          node2.hasUnknownMembers = hasUnknownMembers;
          switch (explicitType) {
            case "boolean":
              node2.explicitType = true;
              node2.members = members.booleanMembers;
              this.expect(8);
              return this.finishNode(node2, "EnumBooleanBody");
            case "number":
              node2.explicitType = true;
              node2.members = members.numberMembers;
              this.expect(8);
              return this.finishNode(node2, "EnumNumberBody");
            case "string":
              node2.explicitType = true;
              node2.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
                enumName
              });
              this.expect(8);
              return this.finishNode(node2, "EnumStringBody");
            case "symbol":
              node2.members = members.defaultedMembers;
              this.expect(8);
              return this.finishNode(node2, "EnumSymbolBody");
            default: {
              var empty2 = function empty3() {
                node2.members = [];
                _this13.expect(8);
                return _this13.finishNode(node2, "EnumStringBody");
              };
              node2.explicitType = false;
              var boolsLen = members.booleanMembers.length;
              var numsLen = members.numberMembers.length;
              var strsLen = members.stringMembers.length;
              var defaultedLen = members.defaultedMembers.length;
              if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
                return empty2();
              } else if (!boolsLen && !numsLen) {
                node2.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
                  enumName
                });
                this.expect(8);
                return this.finishNode(node2, "EnumStringBody");
              } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
                for (var _i6 = 0, _members$defaultedMem2 = members.defaultedMembers; _i6 < _members$defaultedMem2.length; _i6++) {
                  var member = _members$defaultedMem2[_i6];
                  this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
                    enumName,
                    memberName: member.id.name
                  });
                }
                node2.members = members.booleanMembers;
                this.expect(8);
                return this.finishNode(node2, "EnumBooleanBody");
              } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
                for (var _i8 = 0, _members$defaultedMem4 = members.defaultedMembers; _i8 < _members$defaultedMem4.length; _i8++) {
                  var _member2 = _members$defaultedMem4[_i8];
                  this.flowEnumErrorNumberMemberNotInitialized(_member2.loc.start, {
                    enumName,
                    memberName: _member2.id.name
                  });
                }
                node2.members = members.numberMembers;
                this.expect(8);
                return this.finishNode(node2, "EnumNumberBody");
              } else {
                this.raise(FlowErrors.EnumInconsistentMemberValues, {
                  at: nameLoc,
                  enumName
                });
                return empty2();
              }
            }
          }
        };
        _proto.flowParseEnumDeclaration = function flowParseEnumDeclaration(node2) {
          var id3 = this.parseIdentifier();
          node2.id = id3;
          node2.body = this.flowEnumBody(this.startNode(), id3);
          return this.finishNode(node2, "EnumDeclaration");
        };
        _proto.isLookaheadToken_lt = function isLookaheadToken_lt() {
          var next = this.nextTokenStart();
          if (this.input.charCodeAt(next) === 60) {
            var afterNext = this.input.charCodeAt(next + 1);
            return afterNext !== 60 && afterNext !== 61;
          }
          return false;
        };
        _proto.maybeUnwrapTypeCastExpression = function maybeUnwrapTypeCastExpression(node2) {
          return node2.type === "TypeCastExpression" ? node2.expression : node2;
        };
        return _createClass2(_class2);
      }(superClass);
    };
    var entities = {
      __proto__: null,
      quot: '"',
      amp: "&",
      apos: "'",
      lt: "<",
      gt: ">",
      nbsp: "\xA0",
      iexcl: "\xA1",
      cent: "\xA2",
      pound: "\xA3",
      curren: "\xA4",
      yen: "\xA5",
      brvbar: "\xA6",
      sect: "\xA7",
      uml: "\xA8",
      copy: "\xA9",
      ordf: "\xAA",
      laquo: "\xAB",
      not: "\xAC",
      shy: "\xAD",
      reg: "\xAE",
      macr: "\xAF",
      deg: "\xB0",
      plusmn: "\xB1",
      sup2: "\xB2",
      sup3: "\xB3",
      acute: "\xB4",
      micro: "\xB5",
      para: "\xB6",
      middot: "\xB7",
      cedil: "\xB8",
      sup1: "\xB9",
      ordm: "\xBA",
      raquo: "\xBB",
      frac14: "\xBC",
      frac12: "\xBD",
      frac34: "\xBE",
      iquest: "\xBF",
      Agrave: "\xC0",
      Aacute: "\xC1",
      Acirc: "\xC2",
      Atilde: "\xC3",
      Auml: "\xC4",
      Aring: "\xC5",
      AElig: "\xC6",
      Ccedil: "\xC7",
      Egrave: "\xC8",
      Eacute: "\xC9",
      Ecirc: "\xCA",
      Euml: "\xCB",
      Igrave: "\xCC",
      Iacute: "\xCD",
      Icirc: "\xCE",
      Iuml: "\xCF",
      ETH: "\xD0",
      Ntilde: "\xD1",
      Ograve: "\xD2",
      Oacute: "\xD3",
      Ocirc: "\xD4",
      Otilde: "\xD5",
      Ouml: "\xD6",
      times: "\xD7",
      Oslash: "\xD8",
      Ugrave: "\xD9",
      Uacute: "\xDA",
      Ucirc: "\xDB",
      Uuml: "\xDC",
      Yacute: "\xDD",
      THORN: "\xDE",
      szlig: "\xDF",
      agrave: "\xE0",
      aacute: "\xE1",
      acirc: "\xE2",
      atilde: "\xE3",
      auml: "\xE4",
      aring: "\xE5",
      aelig: "\xE6",
      ccedil: "\xE7",
      egrave: "\xE8",
      eacute: "\xE9",
      ecirc: "\xEA",
      euml: "\xEB",
      igrave: "\xEC",
      iacute: "\xED",
      icirc: "\xEE",
      iuml: "\xEF",
      eth: "\xF0",
      ntilde: "\xF1",
      ograve: "\xF2",
      oacute: "\xF3",
      ocirc: "\xF4",
      otilde: "\xF5",
      ouml: "\xF6",
      divide: "\xF7",
      oslash: "\xF8",
      ugrave: "\xF9",
      uacute: "\xFA",
      ucirc: "\xFB",
      uuml: "\xFC",
      yacute: "\xFD",
      thorn: "\xFE",
      yuml: "\xFF",
      OElig: "\u0152",
      oelig: "\u0153",
      Scaron: "\u0160",
      scaron: "\u0161",
      Yuml: "\u0178",
      fnof: "\u0192",
      circ: "\u02C6",
      tilde: "\u02DC",
      Alpha: "\u0391",
      Beta: "\u0392",
      Gamma: "\u0393",
      Delta: "\u0394",
      Epsilon: "\u0395",
      Zeta: "\u0396",
      Eta: "\u0397",
      Theta: "\u0398",
      Iota: "\u0399",
      Kappa: "\u039A",
      Lambda: "\u039B",
      Mu: "\u039C",
      Nu: "\u039D",
      Xi: "\u039E",
      Omicron: "\u039F",
      Pi: "\u03A0",
      Rho: "\u03A1",
      Sigma: "\u03A3",
      Tau: "\u03A4",
      Upsilon: "\u03A5",
      Phi: "\u03A6",
      Chi: "\u03A7",
      Psi: "\u03A8",
      Omega: "\u03A9",
      alpha: "\u03B1",
      beta: "\u03B2",
      gamma: "\u03B3",
      delta: "\u03B4",
      epsilon: "\u03B5",
      zeta: "\u03B6",
      eta: "\u03B7",
      theta: "\u03B8",
      iota: "\u03B9",
      kappa: "\u03BA",
      lambda: "\u03BB",
      mu: "\u03BC",
      nu: "\u03BD",
      xi: "\u03BE",
      omicron: "\u03BF",
      pi: "\u03C0",
      rho: "\u03C1",
      sigmaf: "\u03C2",
      sigma: "\u03C3",
      tau: "\u03C4",
      upsilon: "\u03C5",
      phi: "\u03C6",
      chi: "\u03C7",
      psi: "\u03C8",
      omega: "\u03C9",
      thetasym: "\u03D1",
      upsih: "\u03D2",
      piv: "\u03D6",
      ensp: "\u2002",
      emsp: "\u2003",
      thinsp: "\u2009",
      zwnj: "\u200C",
      zwj: "\u200D",
      lrm: "\u200E",
      rlm: "\u200F",
      ndash: "\u2013",
      mdash: "\u2014",
      lsquo: "\u2018",
      rsquo: "\u2019",
      sbquo: "\u201A",
      ldquo: "\u201C",
      rdquo: "\u201D",
      bdquo: "\u201E",
      dagger: "\u2020",
      Dagger: "\u2021",
      bull: "\u2022",
      hellip: "\u2026",
      permil: "\u2030",
      prime: "\u2032",
      Prime: "\u2033",
      lsaquo: "\u2039",
      rsaquo: "\u203A",
      oline: "\u203E",
      frasl: "\u2044",
      euro: "\u20AC",
      image: "\u2111",
      weierp: "\u2118",
      real: "\u211C",
      trade: "\u2122",
      alefsym: "\u2135",
      larr: "\u2190",
      uarr: "\u2191",
      rarr: "\u2192",
      darr: "\u2193",
      harr: "\u2194",
      crarr: "\u21B5",
      lArr: "\u21D0",
      uArr: "\u21D1",
      rArr: "\u21D2",
      dArr: "\u21D3",
      hArr: "\u21D4",
      forall: "\u2200",
      part: "\u2202",
      exist: "\u2203",
      empty: "\u2205",
      nabla: "\u2207",
      isin: "\u2208",
      notin: "\u2209",
      ni: "\u220B",
      prod: "\u220F",
      sum: "\u2211",
      minus: "\u2212",
      lowast: "\u2217",
      radic: "\u221A",
      prop: "\u221D",
      infin: "\u221E",
      ang: "\u2220",
      and: "\u2227",
      or: "\u2228",
      cap: "\u2229",
      cup: "\u222A",
      "int": "\u222B",
      there4: "\u2234",
      sim: "\u223C",
      cong: "\u2245",
      asymp: "\u2248",
      ne: "\u2260",
      equiv: "\u2261",
      le: "\u2264",
      ge: "\u2265",
      sub: "\u2282",
      sup: "\u2283",
      nsub: "\u2284",
      sube: "\u2286",
      supe: "\u2287",
      oplus: "\u2295",
      otimes: "\u2297",
      perp: "\u22A5",
      sdot: "\u22C5",
      lceil: "\u2308",
      rceil: "\u2309",
      lfloor: "\u230A",
      rfloor: "\u230B",
      lang: "\u2329",
      rang: "\u232A",
      loz: "\u25CA",
      spades: "\u2660",
      clubs: "\u2663",
      hearts: "\u2665",
      diams: "\u2666"
    };
    var _templateObject$r;
    var JsxErrors = ParseErrorEnum(_templateObject$r || (_templateObject$r = _taggedTemplateLiteralLoose(["jsx"])))(function(_) {
      return {
        AttributeIsEmpty: _("JSX attributes must only be assigned a non-empty expression."),
        MissingClosingTagElement: _(function(_ref3) {
          var openingTagName = _ref3.openingTagName;
          return "Expected corresponding JSX closing tag for <" + openingTagName + ">.";
        }),
        MissingClosingTagFragment: _("Expected corresponding JSX closing tag for <>."),
        UnexpectedSequenceExpression: _("Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?"),
        UnexpectedToken: _(function(_ref22) {
          var unexpected = _ref22.unexpected, HTMLEntity = _ref22.HTMLEntity;
          return "Unexpected token `" + unexpected + "`. Did you mean `" + HTMLEntity + "` or `{'" + unexpected + "'}`?";
        }),
        UnsupportedJsxValue: _("JSX value should be either an expression or a quoted JSX text."),
        UnterminatedJsxContent: _("Unterminated JSX contents."),
        UnwrappedAdjacentJSXElements: _("Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?")
      };
    });
    function isFragment(object4) {
      return object4 ? object4.type === "JSXOpeningFragment" || object4.type === "JSXClosingFragment" : false;
    }
    function getQualifiedJSXName(object4) {
      if (object4.type === "JSXIdentifier") {
        return object4.name;
      }
      if (object4.type === "JSXNamespacedName") {
        return object4.namespace.name + ":" + object4.name.name;
      }
      if (object4.type === "JSXMemberExpression") {
        return getQualifiedJSXName(object4.object) + "." + getQualifiedJSXName(object4.property);
      }
      throw new Error("Node had unexpected type: " + object4.type);
    }
    var jsx2 = function(superClass) {
      return function(_superClass) {
        _inherits2(_class, _superClass);
        function _class() {
          return _superClass.apply(this, arguments) || this;
        }
        var _proto = _class.prototype;
        _proto.jsxReadToken = function jsxReadToken() {
          var out2 = "";
          var chunkStart = this.state.pos;
          for (; ; ) {
            if (this.state.pos >= this.length) {
              throw this.raise(JsxErrors.UnterminatedJsxContent, {
                at: this.state.startLoc
              });
            }
            var ch2 = this.input.charCodeAt(this.state.pos);
            switch (ch2) {
              case 60:
              case 123:
                if (this.state.pos === this.state.start) {
                  if (ch2 === 60 && this.state.canStartJSXElement) {
                    ++this.state.pos;
                    return this.finishToken(138);
                  }
                  return _superClass.prototype.getTokenFromCode.call(this, ch2);
                }
                out2 += this.input.slice(chunkStart, this.state.pos);
                return this.finishToken(137, out2);
              case 38:
                out2 += this.input.slice(chunkStart, this.state.pos);
                out2 += this.jsxReadEntity();
                chunkStart = this.state.pos;
                break;
              case 62:
              case 125:
              default:
                if (isNewLine2(ch2)) {
                  out2 += this.input.slice(chunkStart, this.state.pos);
                  out2 += this.jsxReadNewLine(true);
                  chunkStart = this.state.pos;
                } else {
                  ++this.state.pos;
                }
            }
          }
        };
        _proto.jsxReadNewLine = function jsxReadNewLine(normalizeCRLF) {
          var ch2 = this.input.charCodeAt(this.state.pos);
          var out2;
          ++this.state.pos;
          if (ch2 === 13 && this.input.charCodeAt(this.state.pos) === 10) {
            ++this.state.pos;
            out2 = normalizeCRLF ? "\n" : "\r\n";
          } else {
            out2 = String.fromCharCode(ch2);
          }
          ++this.state.curLine;
          this.state.lineStart = this.state.pos;
          return out2;
        };
        _proto.jsxReadString = function jsxReadString(quote) {
          var out2 = "";
          var chunkStart = ++this.state.pos;
          for (; ; ) {
            if (this.state.pos >= this.length) {
              throw this.raise(Errors.UnterminatedString, {
                at: this.state.startLoc
              });
            }
            var ch2 = this.input.charCodeAt(this.state.pos);
            if (ch2 === quote)
              break;
            if (ch2 === 38) {
              out2 += this.input.slice(chunkStart, this.state.pos);
              out2 += this.jsxReadEntity();
              chunkStart = this.state.pos;
            } else if (isNewLine2(ch2)) {
              out2 += this.input.slice(chunkStart, this.state.pos);
              out2 += this.jsxReadNewLine(false);
              chunkStart = this.state.pos;
            } else {
              ++this.state.pos;
            }
          }
          out2 += this.input.slice(chunkStart, this.state.pos++);
          return this.finishToken(129, out2);
        };
        _proto.jsxReadEntity = function jsxReadEntity() {
          var startPos = ++this.state.pos;
          if (this.codePointAtPos(this.state.pos) === 35) {
            ++this.state.pos;
            var radix = 10;
            if (this.codePointAtPos(this.state.pos) === 120) {
              radix = 16;
              ++this.state.pos;
            }
            var codePoint = this.readInt(radix, void 0, false, "bail");
            if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
              ++this.state.pos;
              return String.fromCodePoint(codePoint);
            }
          } else {
            var count2 = 0;
            var semi = false;
            while (count2++ < 10 && this.state.pos < this.length && !(semi = this.codePointAtPos(this.state.pos) == 59)) {
              ++this.state.pos;
            }
            if (semi) {
              var desc = this.input.slice(startPos, this.state.pos);
              var entity = entities[desc];
              ++this.state.pos;
              if (entity) {
                return entity;
              }
            }
          }
          this.state.pos = startPos;
          return "&";
        };
        _proto.jsxReadWord = function jsxReadWord() {
          var ch2;
          var start2 = this.state.pos;
          do {
            ch2 = this.input.charCodeAt(++this.state.pos);
          } while (isIdentifierChar2(ch2) || ch2 === 45);
          return this.finishToken(136, this.input.slice(start2, this.state.pos));
        };
        _proto.jsxParseIdentifier = function jsxParseIdentifier() {
          var node2 = this.startNode();
          if (this.match(136)) {
            node2.name = this.state.value;
          } else if (tokenIsKeyword(this.state.type)) {
            node2.name = tokenLabelName(this.state.type);
          } else {
            this.unexpected();
          }
          this.next();
          return this.finishNode(node2, "JSXIdentifier");
        };
        _proto.jsxParseNamespacedName = function jsxParseNamespacedName() {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var name2 = this.jsxParseIdentifier();
          if (!this.eat(14))
            return name2;
          var node2 = this.startNodeAt(startPos, startLoc);
          node2.namespace = name2;
          node2.name = this.jsxParseIdentifier();
          return this.finishNode(node2, "JSXNamespacedName");
        };
        _proto.jsxParseElementName = function jsxParseElementName() {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var node2 = this.jsxParseNamespacedName();
          if (node2.type === "JSXNamespacedName") {
            return node2;
          }
          while (this.eat(16)) {
            var newNode = this.startNodeAt(startPos, startLoc);
            newNode.object = node2;
            newNode.property = this.jsxParseIdentifier();
            node2 = this.finishNode(newNode, "JSXMemberExpression");
          }
          return node2;
        };
        _proto.jsxParseAttributeValue = function jsxParseAttributeValue() {
          var node2;
          switch (this.state.type) {
            case 5:
              node2 = this.startNode();
              this.setContext(types2.brace);
              this.next();
              node2 = this.jsxParseExpressionContainer(node2, types2.j_oTag);
              if (node2.expression.type === "JSXEmptyExpression") {
                this.raise(JsxErrors.AttributeIsEmpty, {
                  at: node2
                });
              }
              return node2;
            case 138:
            case 129:
              return this.parseExprAtom();
            default:
              throw this.raise(JsxErrors.UnsupportedJsxValue, {
                at: this.state.startLoc
              });
          }
        };
        _proto.jsxParseEmptyExpression = function jsxParseEmptyExpression() {
          var node2 = this.startNodeAt(this.state.lastTokEndLoc.index, this.state.lastTokEndLoc);
          return this.finishNodeAt(node2, "JSXEmptyExpression", this.state.startLoc);
        };
        _proto.jsxParseSpreadChild = function jsxParseSpreadChild(node2) {
          this.next();
          node2.expression = this.parseExpression();
          this.setContext(types2.j_oTag);
          this.expect(8);
          return this.finishNode(node2, "JSXSpreadChild");
        };
        _proto.jsxParseExpressionContainer = function jsxParseExpressionContainer(node2, previousContext) {
          if (this.match(8)) {
            node2.expression = this.jsxParseEmptyExpression();
          } else {
            var expression2 = this.parseExpression();
            node2.expression = expression2;
          }
          this.setContext(previousContext);
          this.expect(8);
          return this.finishNode(node2, "JSXExpressionContainer");
        };
        _proto.jsxParseAttribute = function jsxParseAttribute() {
          var node2 = this.startNode();
          if (this.match(5)) {
            this.setContext(types2.brace);
            this.next();
            this.expect(21);
            node2.argument = this.parseMaybeAssignAllowIn();
            this.setContext(types2.j_oTag);
            this.expect(8);
            return this.finishNode(node2, "JSXSpreadAttribute");
          }
          node2.name = this.jsxParseNamespacedName();
          node2.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
          return this.finishNode(node2, "JSXAttribute");
        };
        _proto.jsxParseOpeningElementAt = function jsxParseOpeningElementAt(startPos, startLoc) {
          var node2 = this.startNodeAt(startPos, startLoc);
          if (this.match(139)) {
            this.expect(139);
            return this.finishNode(node2, "JSXOpeningFragment");
          }
          node2.name = this.jsxParseElementName();
          return this.jsxParseOpeningElementAfterName(node2);
        };
        _proto.jsxParseOpeningElementAfterName = function jsxParseOpeningElementAfterName(node2) {
          var attributes = [];
          while (!this.match(56) && !this.match(139)) {
            attributes.push(this.jsxParseAttribute());
          }
          node2.attributes = attributes;
          node2.selfClosing = this.eat(56);
          this.expect(139);
          return this.finishNode(node2, "JSXOpeningElement");
        };
        _proto.jsxParseClosingElementAt = function jsxParseClosingElementAt(startPos, startLoc) {
          var node2 = this.startNodeAt(startPos, startLoc);
          if (this.match(139)) {
            this.expect(139);
            return this.finishNode(node2, "JSXClosingFragment");
          }
          node2.name = this.jsxParseElementName();
          this.expect(139);
          return this.finishNode(node2, "JSXClosingElement");
        };
        _proto.jsxParseElementAt = function jsxParseElementAt(startPos, startLoc) {
          var node2 = this.startNodeAt(startPos, startLoc);
          var children = [];
          var openingElement = this.jsxParseOpeningElementAt(startPos, startLoc);
          var closingElement = null;
          if (!openingElement.selfClosing) {
            contents:
              for (; ; ) {
                switch (this.state.type) {
                  case 138:
                    startPos = this.state.start;
                    startLoc = this.state.startLoc;
                    this.next();
                    if (this.eat(56)) {
                      closingElement = this.jsxParseClosingElementAt(startPos, startLoc);
                      break contents;
                    }
                    children.push(this.jsxParseElementAt(startPos, startLoc));
                    break;
                  case 137:
                    children.push(this.parseExprAtom());
                    break;
                  case 5: {
                    var _node = this.startNode();
                    this.setContext(types2.brace);
                    this.next();
                    if (this.match(21)) {
                      children.push(this.jsxParseSpreadChild(_node));
                    } else {
                      children.push(this.jsxParseExpressionContainer(_node, types2.j_expr));
                    }
                    break;
                  }
                  default:
                    throw this.unexpected();
                }
              }
            if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
              this.raise(JsxErrors.MissingClosingTagFragment, {
                at: closingElement
              });
            } else if (!isFragment(openingElement) && isFragment(closingElement)) {
              this.raise(JsxErrors.MissingClosingTagElement, {
                at: closingElement,
                openingTagName: getQualifiedJSXName(openingElement.name)
              });
            } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
              if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
                this.raise(JsxErrors.MissingClosingTagElement, {
                  at: closingElement,
                  openingTagName: getQualifiedJSXName(openingElement.name)
                });
              }
            }
          }
          if (isFragment(openingElement)) {
            node2.openingFragment = openingElement;
            node2.closingFragment = closingElement;
          } else {
            node2.openingElement = openingElement;
            node2.closingElement = closingElement;
          }
          node2.children = children;
          if (this.match(47)) {
            throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, {
              at: this.state.startLoc
            });
          }
          return isFragment(openingElement) ? this.finishNode(node2, "JSXFragment") : this.finishNode(node2, "JSXElement");
        };
        _proto.jsxParseElement = function jsxParseElement() {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          this.next();
          return this.jsxParseElementAt(startPos, startLoc);
        };
        _proto.setContext = function setContext2(newContext) {
          var context = this.state.context;
          context[context.length - 1] = newContext;
        };
        _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
          if (this.match(137)) {
            return this.parseLiteral(this.state.value, "JSXText");
          } else if (this.match(138)) {
            return this.jsxParseElement();
          } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
            this.replaceToken(138);
            return this.jsxParseElement();
          } else {
            return _superClass.prototype.parseExprAtom.call(this, refExpressionErrors);
          }
        };
        _proto.skipSpace = function skipSpace() {
          var curContext = this.curContext();
          if (!curContext.preserveSpace)
            _superClass.prototype.skipSpace.call(this);
        };
        _proto.getTokenFromCode = function getTokenFromCode(code3) {
          var context = this.curContext();
          if (context === types2.j_expr) {
            return this.jsxReadToken();
          }
          if (context === types2.j_oTag || context === types2.j_cTag) {
            if (isIdentifierStart2(code3)) {
              return this.jsxReadWord();
            }
            if (code3 === 62) {
              ++this.state.pos;
              return this.finishToken(139);
            }
            if ((code3 === 34 || code3 === 39) && context === types2.j_oTag) {
              return this.jsxReadString(code3);
            }
          }
          if (code3 === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
            ++this.state.pos;
            return this.finishToken(138);
          }
          return _superClass.prototype.getTokenFromCode.call(this, code3);
        };
        _proto.updateContext = function updateContext(prevType) {
          var _this$state = this.state, context = _this$state.context, type5 = _this$state.type;
          if (type5 === 56 && prevType === 138) {
            context.splice(-2, 2, types2.j_cTag);
            this.state.canStartJSXElement = false;
          } else if (type5 === 138) {
            context.push(types2.j_oTag);
          } else if (type5 === 139) {
            var out2 = context[context.length - 1];
            if (out2 === types2.j_oTag && prevType === 56 || out2 === types2.j_cTag) {
              context.pop();
              this.state.canStartJSXElement = context[context.length - 1] === types2.j_expr;
            } else {
              this.setContext(types2.j_expr);
              this.state.canStartJSXElement = true;
            }
          } else {
            this.state.canStartJSXElement = tokenComesBeforeExpression(type5);
          }
        };
        return _createClass2(_class);
      }(superClass);
    };
    var TypeScriptScope = function(_Scope) {
      _inherits2(TypeScriptScope2, _Scope);
      function TypeScriptScope2() {
        var _this;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        _this = _Scope.call.apply(_Scope, [this].concat(args)) || this;
        _this.types = /* @__PURE__ */ new Set();
        _this.enums = /* @__PURE__ */ new Set();
        _this.constEnums = /* @__PURE__ */ new Set();
        _this.classes = /* @__PURE__ */ new Set();
        _this.exportOnlyBindings = /* @__PURE__ */ new Set();
        return _this;
      }
      return _createClass2(TypeScriptScope2);
    }(Scope3);
    var TypeScriptScopeHandler = function(_ScopeHandler) {
      _inherits2(TypeScriptScopeHandler2, _ScopeHandler);
      function TypeScriptScopeHandler2() {
        return _ScopeHandler.apply(this, arguments) || this;
      }
      var _proto = TypeScriptScopeHandler2.prototype;
      _proto.createScope = function createScope(flags) {
        return new TypeScriptScope(flags);
      };
      _proto.declareName = function declareName(name2, bindingType, loc) {
        var scope2 = this.currentScope();
        if (bindingType & BIND_FLAGS_TS_EXPORT_ONLY) {
          this.maybeExportDefined(scope2, name2);
          scope2.exportOnlyBindings.add(name2);
          return;
        }
        _ScopeHandler.prototype.declareName.apply(this, arguments);
        if (bindingType & BIND_KIND_TYPE) {
          if (!(bindingType & BIND_KIND_VALUE)) {
            this.checkRedeclarationInScope(scope2, name2, bindingType, loc);
            this.maybeExportDefined(scope2, name2);
          }
          scope2.types.add(name2);
        }
        if (bindingType & BIND_FLAGS_TS_ENUM)
          scope2.enums.add(name2);
        if (bindingType & BIND_FLAGS_TS_CONST_ENUM)
          scope2.constEnums.add(name2);
        if (bindingType & BIND_FLAGS_CLASS)
          scope2.classes.add(name2);
      };
      _proto.isRedeclaredInScope = function isRedeclaredInScope(scope2, name2, bindingType) {
        if (scope2.enums.has(name2)) {
          if (bindingType & BIND_FLAGS_TS_ENUM) {
            var isConst = !!(bindingType & BIND_FLAGS_TS_CONST_ENUM);
            var wasConst = scope2.constEnums.has(name2);
            return isConst !== wasConst;
          }
          return true;
        }
        if (bindingType & BIND_FLAGS_CLASS && scope2.classes.has(name2)) {
          if (scope2.lexical.has(name2)) {
            return !!(bindingType & BIND_KIND_VALUE);
          } else {
            return false;
          }
        }
        if (bindingType & BIND_KIND_TYPE && scope2.types.has(name2)) {
          return true;
        }
        return _ScopeHandler.prototype.isRedeclaredInScope.apply(this, arguments);
      };
      _proto.checkLocalExport = function checkLocalExport(id3) {
        var topLevelScope = this.scopeStack[0];
        var name2 = id3.name;
        if (!topLevelScope.types.has(name2) && !topLevelScope.exportOnlyBindings.has(name2)) {
          _ScopeHandler.prototype.checkLocalExport.call(this, id3);
        }
      };
      return _createClass2(TypeScriptScopeHandler2);
    }(ScopeHandler);
    var _templateObject$q;
    var getOwn$1 = function getOwn2(object4, key2) {
      return Object.hasOwnProperty.call(object4, key2) && object4[key2];
    };
    function nonNull(x2) {
      if (x2 == null) {
        throw new Error("Unexpected " + x2 + " value.");
      }
      return x2;
    }
    function assert$2(x2) {
      if (!x2) {
        throw new Error("Assert fail");
      }
    }
    var TSErrors = ParseErrorEnum(_templateObject$q || (_templateObject$q = _taggedTemplateLiteralLoose(["typescript"])))(function(_) {
      return {
        AbstractMethodHasImplementation: _(function(_ref3) {
          var methodName = _ref3.methodName;
          return "Method '" + methodName + "' cannot have an implementation because it is marked abstract.";
        }),
        AbstractPropertyHasInitializer: _(function(_ref22) {
          var propertyName = _ref22.propertyName;
          return "Property '" + propertyName + "' cannot have an initializer because it is marked abstract.";
        }),
        AccesorCannotDeclareThisParameter: _("'get' and 'set' accessors cannot declare 'this' parameters."),
        AccesorCannotHaveTypeParameters: _("An accessor cannot have type parameters."),
        CannotFindName: _(function(_ref3) {
          var name2 = _ref3.name;
          return "Cannot find name '" + name2 + "'.";
        }),
        ClassMethodHasDeclare: _("Class methods cannot have the 'declare' modifier."),
        ClassMethodHasReadonly: _("Class methods cannot have the 'readonly' modifier."),
        ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: _("A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),
        ConstructorHasTypeParameters: _("Type parameters cannot appear on a constructor declaration."),
        DeclareAccessor: _(function(_ref42) {
          var kind = _ref42.kind;
          return "'declare' is not allowed in " + kind + "ters.";
        }),
        DeclareClassFieldHasInitializer: _("Initializers are not allowed in ambient contexts."),
        DeclareFunctionHasImplementation: _("An implementation cannot be declared in ambient contexts."),
        DuplicateAccessibilityModifier: _(function(_ref5) {
          _ref5.modifier;
          return "Accessibility modifier already seen.";
        }),
        DuplicateModifier: _(function(_ref6) {
          var modifier = _ref6.modifier;
          return "Duplicate modifier: '" + modifier + "'.";
        }),
        EmptyHeritageClauseType: _(function(_ref7) {
          var token = _ref7.token;
          return "'" + token + "' list cannot be empty.";
        }),
        EmptyTypeArguments: _("Type argument list cannot be empty."),
        EmptyTypeParameters: _("Type parameter list cannot be empty."),
        ExpectedAmbientAfterExportDeclare: _("'export declare' must be followed by an ambient declaration."),
        ImportAliasHasImportType: _("An import alias can not use 'import type'."),
        IncompatibleModifiers: _(function(_ref8) {
          var modifiers = _ref8.modifiers;
          return "'" + modifiers[0] + "' modifier cannot be used with '" + modifiers[1] + "' modifier.";
        }),
        IndexSignatureHasAbstract: _("Index signatures cannot have the 'abstract' modifier."),
        IndexSignatureHasAccessibility: _(function(_ref9) {
          var modifier = _ref9.modifier;
          return "Index signatures cannot have an accessibility modifier ('" + modifier + "').";
        }),
        IndexSignatureHasDeclare: _("Index signatures cannot have the 'declare' modifier."),
        IndexSignatureHasOverride: _("'override' modifier cannot appear on an index signature."),
        IndexSignatureHasStatic: _("Index signatures cannot have the 'static' modifier."),
        InitializerNotAllowedInAmbientContext: _("Initializers are not allowed in ambient contexts."),
        InvalidModifierOnTypeMember: _(function(_ref10) {
          var modifier = _ref10.modifier;
          return "'" + modifier + "' modifier cannot appear on a type member.";
        }),
        InvalidModifiersOrder: _(function(_ref11) {
          var orderedModifiers = _ref11.orderedModifiers;
          return "'" + orderedModifiers[0] + "' modifier must precede '" + orderedModifiers[1] + "' modifier.";
        }),
        InvalidTupleMemberLabel: _("Tuple members must be labeled with a simple identifier."),
        MissingInterfaceName: _("'interface' declarations must be followed by an identifier."),
        MixedLabeledAndUnlabeledElements: _("Tuple members must all have names or all not have names."),
        NonAbstractClassHasAbstractMethod: _("Abstract methods can only appear within an abstract class."),
        NonClassMethodPropertyHasAbstractModifer: _("'abstract' modifier can only appear on a class, method, or property declaration."),
        OptionalTypeBeforeRequired: _("A required element cannot follow an optional element."),
        OverrideNotInSubClass: _("This member cannot have an 'override' modifier because its containing class does not extend another class."),
        PatternIsOptional: _("A binding pattern parameter cannot be optional in an implementation signature."),
        PrivateElementHasAbstract: _("Private elements cannot have the 'abstract' modifier."),
        PrivateElementHasAccessibility: _(function(_ref12) {
          var modifier = _ref12.modifier;
          return "Private elements cannot have an accessibility modifier ('" + modifier + "').";
        }),
        ReadonlyForMethodSignature: _("'readonly' modifier can only appear on a property declaration or index signature."),
        ReservedArrowTypeParam: _("This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`."),
        ReservedTypeAssertion: _("This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."),
        SetAccesorCannotHaveOptionalParameter: _("A 'set' accessor cannot have an optional parameter."),
        SetAccesorCannotHaveRestParameter: _("A 'set' accessor cannot have rest parameter."),
        SetAccesorCannotHaveReturnType: _("A 'set' accessor cannot have a return type annotation."),
        SingleTypeParameterWithoutTrailingComma: _(function(_ref13) {
          var typeParameterName = _ref13.typeParameterName;
          return "Single type parameter " + typeParameterName + " should have a trailing comma. Example usage: <" + typeParameterName + ",>.";
        }),
        StaticBlockCannotHaveModifier: _("Static class blocks cannot have any modifier."),
        TypeAnnotationAfterAssign: _("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."),
        TypeImportCannotSpecifyDefaultAndNamed: _("A type-only import can specify a default import or named bindings, but not both."),
        TypeModifierIsUsedInTypeExports: _("The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."),
        TypeModifierIsUsedInTypeImports: _("The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."),
        UnexpectedParameterModifier: _("A parameter property is only allowed in a constructor implementation."),
        UnexpectedReadonly: _("'readonly' type modifier is only permitted on array and tuple literal types."),
        UnexpectedTypeAnnotation: _("Did not expect a type annotation here."),
        UnexpectedTypeCastInParameter: _("Unexpected type cast in parameter position."),
        UnsupportedImportTypeArgument: _("Argument in a type import must be a string literal."),
        UnsupportedParameterPropertyKind: _("A parameter property may not be declared using a binding pattern."),
        UnsupportedSignatureParameterKind: _(function(_ref14) {
          var type5 = _ref14.type;
          return "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got " + type5 + ".";
        })
      };
    });
    function keywordTypeFromName(value) {
      switch (value) {
        case "any":
          return "TSAnyKeyword";
        case "boolean":
          return "TSBooleanKeyword";
        case "bigint":
          return "TSBigIntKeyword";
        case "never":
          return "TSNeverKeyword";
        case "number":
          return "TSNumberKeyword";
        case "object":
          return "TSObjectKeyword";
        case "string":
          return "TSStringKeyword";
        case "symbol":
          return "TSSymbolKeyword";
        case "undefined":
          return "TSUndefinedKeyword";
        case "unknown":
          return "TSUnknownKeyword";
        default:
          return void 0;
      }
    }
    function tsIsAccessModifier(modifier) {
      return modifier === "private" || modifier === "public" || modifier === "protected";
    }
    var typescript = function(superClass) {
      return function(_superClass) {
        _inherits2(_class, _superClass);
        function _class() {
          return _superClass.apply(this, arguments) || this;
        }
        var _proto = _class.prototype;
        _proto.getScopeHandler = function getScopeHandler() {
          return TypeScriptScopeHandler;
        };
        _proto.tsIsIdentifier = function tsIsIdentifier() {
          return tokenIsIdentifier(this.state.type);
        };
        _proto.tsTokenCanFollowModifier = function tsTokenCanFollowModifier() {
          return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(134) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
        };
        _proto.tsNextTokenCanFollowModifier = function tsNextTokenCanFollowModifier() {
          this.next();
          return this.tsTokenCanFollowModifier();
        };
        _proto.tsParseModifier = function tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
          if (!tokenIsIdentifier(this.state.type)) {
            return void 0;
          }
          var modifier = this.state.value;
          if (allowedModifiers.indexOf(modifier) !== -1) {
            if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
              return void 0;
            }
            if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
              return modifier;
            }
          }
          return void 0;
        };
        _proto.tsParseModifiers = function tsParseModifiers(_ref15) {
          var _this = this;
          var modified = _ref15.modified, allowedModifiers = _ref15.allowedModifiers, disallowedModifiers = _ref15.disallowedModifiers, stopOnStartOfClassStaticBlock = _ref15.stopOnStartOfClassStaticBlock;
          var enforceOrder = function enforceOrder2(loc, modifier2, before, after) {
            if (modifier2 === before && modified[after]) {
              _this.raise(TSErrors.InvalidModifiersOrder, {
                at: loc,
                orderedModifiers: [before, after]
              });
            }
          };
          var incompatible = function incompatible2(loc, modifier2, mod1, mod2) {
            if (modified[mod1] && modifier2 === mod2 || modified[mod2] && modifier2 === mod1) {
              _this.raise(TSErrors.IncompatibleModifiers, {
                at: loc,
                modifiers: [mod1, mod2]
              });
            }
          };
          for (; ; ) {
            var startLoc = this.state.startLoc;
            var modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers != null ? disallowedModifiers : []), stopOnStartOfClassStaticBlock);
            if (!modifier)
              break;
            if (tsIsAccessModifier(modifier)) {
              if (modified.accessibility) {
                this.raise(TSErrors.DuplicateAccessibilityModifier, {
                  at: startLoc,
                  modifier
                });
              } else {
                enforceOrder(startLoc, modifier, modifier, "override");
                enforceOrder(startLoc, modifier, modifier, "static");
                enforceOrder(startLoc, modifier, modifier, "readonly");
                modified.accessibility = modifier;
              }
            } else {
              if (Object.hasOwnProperty.call(modified, modifier)) {
                this.raise(TSErrors.DuplicateModifier, {
                  at: startLoc,
                  modifier
                });
              } else {
                enforceOrder(startLoc, modifier, "static", "readonly");
                enforceOrder(startLoc, modifier, "static", "override");
                enforceOrder(startLoc, modifier, "override", "readonly");
                enforceOrder(startLoc, modifier, "abstract", "override");
                incompatible(startLoc, modifier, "declare", "override");
                incompatible(startLoc, modifier, "static", "abstract");
              }
              modified[modifier] = true;
            }
            if (disallowedModifiers != null && disallowedModifiers.includes(modifier)) {
              this.raise(TSErrors.InvalidModifierOnTypeMember, {
                at: startLoc,
                modifier
              });
            }
          }
        };
        _proto.tsIsListTerminator = function tsIsListTerminator(kind) {
          switch (kind) {
            case "EnumMembers":
            case "TypeMembers":
              return this.match(8);
            case "HeritageClauseElement":
              return this.match(5);
            case "TupleElementTypes":
              return this.match(3);
            case "TypeParametersOrArguments":
              return this.match(48);
          }
          throw new Error("Unreachable");
        };
        _proto.tsParseList = function tsParseList(kind, parseElement) {
          var result = [];
          while (!this.tsIsListTerminator(kind)) {
            result.push(parseElement());
          }
          return result;
        };
        _proto.tsParseDelimitedList = function tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
          return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
        };
        _proto.tsParseDelimitedListWorker = function tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
          var result = [];
          var trailingCommaPos = -1;
          for (; ; ) {
            if (this.tsIsListTerminator(kind)) {
              break;
            }
            trailingCommaPos = -1;
            var element = parseElement();
            if (element == null) {
              return void 0;
            }
            result.push(element);
            if (this.eat(12)) {
              trailingCommaPos = this.state.lastTokStart;
              continue;
            }
            if (this.tsIsListTerminator(kind)) {
              break;
            }
            if (expectSuccess) {
              this.expect(12);
            }
            return void 0;
          }
          if (refTrailingCommaPos) {
            refTrailingCommaPos.value = trailingCommaPos;
          }
          return result;
        };
        _proto.tsParseBracketedList = function tsParseBracketedList(kind, parseElement, bracket, skipFirstToken, refTrailingCommaPos) {
          if (!skipFirstToken) {
            if (bracket) {
              this.expect(0);
            } else {
              this.expect(47);
            }
          }
          var result = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);
          if (bracket) {
            this.expect(3);
          } else {
            this.expect(48);
          }
          return result;
        };
        _proto.tsParseImportType = function tsParseImportType() {
          var node2 = this.startNode();
          this.expect(83);
          this.expect(10);
          if (!this.match(129)) {
            this.raise(TSErrors.UnsupportedImportTypeArgument, {
              at: this.state.startLoc
            });
          }
          node2.argument = this.parseExprAtom();
          this.expect(11);
          if (this.eat(16)) {
            node2.qualifier = this.tsParseEntityName();
          }
          if (this.match(47)) {
            node2.typeParameters = this.tsParseTypeArguments();
          }
          return this.finishNode(node2, "TSImportType");
        };
        _proto.tsParseEntityName = function tsParseEntityName(allowReservedWords) {
          if (allowReservedWords === void 0) {
            allowReservedWords = true;
          }
          var entity = this.parseIdentifier(allowReservedWords);
          while (this.eat(16)) {
            var node2 = this.startNodeAtNode(entity);
            node2.left = entity;
            node2.right = this.parseIdentifier(allowReservedWords);
            entity = this.finishNode(node2, "TSQualifiedName");
          }
          return entity;
        };
        _proto.tsParseTypeReference = function tsParseTypeReference() {
          var node2 = this.startNode();
          node2.typeName = this.tsParseEntityName();
          if (!this.hasPrecedingLineBreak() && this.match(47)) {
            node2.typeParameters = this.tsParseTypeArguments();
          }
          return this.finishNode(node2, "TSTypeReference");
        };
        _proto.tsParseThisTypePredicate = function tsParseThisTypePredicate(lhs) {
          this.next();
          var node2 = this.startNodeAtNode(lhs);
          node2.parameterName = lhs;
          node2.typeAnnotation = this.tsParseTypeAnnotation(false);
          node2.asserts = false;
          return this.finishNode(node2, "TSTypePredicate");
        };
        _proto.tsParseThisTypeNode = function tsParseThisTypeNode() {
          var node2 = this.startNode();
          this.next();
          return this.finishNode(node2, "TSThisType");
        };
        _proto.tsParseTypeQuery = function tsParseTypeQuery() {
          var node2 = this.startNode();
          this.expect(87);
          if (this.match(83)) {
            node2.exprName = this.tsParseImportType();
          } else {
            node2.exprName = this.tsParseEntityName();
          }
          return this.finishNode(node2, "TSTypeQuery");
        };
        _proto.tsParseTypeParameter = function tsParseTypeParameter() {
          var node2 = this.startNode();
          node2.name = this.tsParseTypeParameterName();
          node2.constraint = this.tsEatThenParseType(81);
          node2["default"] = this.tsEatThenParseType(29);
          return this.finishNode(node2, "TSTypeParameter");
        };
        _proto.tsTryParseTypeParameters = function tsTryParseTypeParameters() {
          if (this.match(47)) {
            return this.tsParseTypeParameters();
          }
        };
        _proto.tsParseTypeParameters = function tsParseTypeParameters() {
          var node2 = this.startNode();
          if (this.match(47) || this.match(138)) {
            this.next();
          } else {
            this.unexpected();
          }
          var refTrailingCommaPos = {
            value: -1
          };
          node2.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this), false, true, refTrailingCommaPos);
          if (node2.params.length === 0) {
            this.raise(TSErrors.EmptyTypeParameters, {
              at: node2
            });
          }
          if (refTrailingCommaPos.value !== -1) {
            this.addExtra(node2, "trailingComma", refTrailingCommaPos.value);
          }
          return this.finishNode(node2, "TSTypeParameterDeclaration");
        };
        _proto.tsTryNextParseConstantContext = function tsTryNextParseConstantContext() {
          if (this.lookahead().type !== 75)
            return null;
          this.next();
          var typeReference = this.tsParseTypeReference();
          if (typeReference.typeParameters) {
            this.raise(TSErrors.CannotFindName, {
              at: typeReference.typeName,
              name: "const"
            });
          }
          return typeReference;
        };
        _proto.tsFillSignature = function tsFillSignature(returnToken, signature) {
          var returnTokenRequired = returnToken === 19;
          var paramsKey = "parameters";
          var returnTypeKey = "typeAnnotation";
          signature.typeParameters = this.tsTryParseTypeParameters();
          this.expect(10);
          signature[paramsKey] = this.tsParseBindingListForSignature();
          if (returnTokenRequired) {
            signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
          } else if (this.match(returnToken)) {
            signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
          }
        };
        _proto.tsParseBindingListForSignature = function tsParseBindingListForSignature() {
          var _this2 = this;
          return this.parseBindingList(11, 41).map(function(pattern5) {
            if (pattern5.type !== "Identifier" && pattern5.type !== "RestElement" && pattern5.type !== "ObjectPattern" && pattern5.type !== "ArrayPattern") {
              _this2.raise(TSErrors.UnsupportedSignatureParameterKind, {
                at: pattern5,
                type: pattern5.type
              });
            }
            return pattern5;
          });
        };
        _proto.tsParseTypeMemberSemicolon = function tsParseTypeMemberSemicolon() {
          if (!this.eat(12) && !this.isLineTerminator()) {
            this.expect(13);
          }
        };
        _proto.tsParseSignatureMember = function tsParseSignatureMember(kind, node2) {
          this.tsFillSignature(14, node2);
          this.tsParseTypeMemberSemicolon();
          return this.finishNode(node2, kind);
        };
        _proto.tsIsUnambiguouslyIndexSignature = function tsIsUnambiguouslyIndexSignature() {
          this.next();
          if (tokenIsIdentifier(this.state.type)) {
            this.next();
            return this.match(14);
          }
          return false;
        };
        _proto.tsTryParseIndexSignature = function tsTryParseIndexSignature(node2) {
          if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
            return void 0;
          }
          this.expect(0);
          var id3 = this.parseIdentifier();
          id3.typeAnnotation = this.tsParseTypeAnnotation();
          this.resetEndLocation(id3);
          this.expect(3);
          node2.parameters = [id3];
          var type5 = this.tsTryParseTypeAnnotation();
          if (type5)
            node2.typeAnnotation = type5;
          this.tsParseTypeMemberSemicolon();
          return this.finishNode(node2, "TSIndexSignature");
        };
        _proto.tsParsePropertyOrMethodSignature = function tsParsePropertyOrMethodSignature(node2, readonly) {
          if (this.eat(17))
            node2.optional = true;
          var nodeAny = node2;
          if (this.match(10) || this.match(47)) {
            if (readonly) {
              this.raise(TSErrors.ReadonlyForMethodSignature, {
                at: node2
              });
            }
            var method5 = nodeAny;
            if (method5.kind && this.match(47)) {
              this.raise(TSErrors.AccesorCannotHaveTypeParameters, {
                at: this.state.curPosition()
              });
            }
            this.tsFillSignature(14, method5);
            this.tsParseTypeMemberSemicolon();
            var paramsKey = "parameters";
            var returnTypeKey = "typeAnnotation";
            if (method5.kind === "get") {
              if (method5[paramsKey].length > 0) {
                this.raise(Errors.BadGetterArity, {
                  at: this.state.curPosition()
                });
                if (this.isThisParam(method5[paramsKey][0])) {
                  this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                    at: this.state.curPosition()
                  });
                }
              }
            } else if (method5.kind === "set") {
              if (method5[paramsKey].length !== 1) {
                this.raise(Errors.BadSetterArity, {
                  at: this.state.curPosition()
                });
              } else {
                var firstParameter = method5[paramsKey][0];
                if (this.isThisParam(firstParameter)) {
                  this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                    at: this.state.curPosition()
                  });
                }
                if (firstParameter.type === "Identifier" && firstParameter.optional) {
                  this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, {
                    at: this.state.curPosition()
                  });
                }
                if (firstParameter.type === "RestElement") {
                  this.raise(TSErrors.SetAccesorCannotHaveRestParameter, {
                    at: this.state.curPosition()
                  });
                }
              }
              if (method5[returnTypeKey]) {
                this.raise(TSErrors.SetAccesorCannotHaveReturnType, {
                  at: method5[returnTypeKey]
                });
              }
            } else {
              method5.kind = "method";
            }
            return this.finishNode(method5, "TSMethodSignature");
          } else {
            var property2 = nodeAny;
            if (readonly)
              property2.readonly = true;
            var type5 = this.tsTryParseTypeAnnotation();
            if (type5)
              property2.typeAnnotation = type5;
            this.tsParseTypeMemberSemicolon();
            return this.finishNode(property2, "TSPropertySignature");
          }
        };
        _proto.tsParseTypeMember = function tsParseTypeMember() {
          var node2 = this.startNode();
          if (this.match(10) || this.match(47)) {
            return this.tsParseSignatureMember("TSCallSignatureDeclaration", node2);
          }
          if (this.match(77)) {
            var id3 = this.startNode();
            this.next();
            if (this.match(10) || this.match(47)) {
              return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node2);
            } else {
              node2.key = this.createIdentifier(id3, "new");
              return this.tsParsePropertyOrMethodSignature(node2, false);
            }
          }
          this.tsParseModifiers({
            modified: node2,
            allowedModifiers: ["readonly"],
            disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"]
          });
          var idx = this.tsTryParseIndexSignature(node2);
          if (idx) {
            return idx;
          }
          this.parsePropertyName(node2);
          if (!node2.computed && node2.key.type === "Identifier" && (node2.key.name === "get" || node2.key.name === "set") && this.tsTokenCanFollowModifier()) {
            node2.kind = node2.key.name;
            this.parsePropertyName(node2);
          }
          return this.tsParsePropertyOrMethodSignature(node2, !!node2.readonly);
        };
        _proto.tsParseTypeLiteral = function tsParseTypeLiteral() {
          var node2 = this.startNode();
          node2.members = this.tsParseObjectTypeMembers();
          return this.finishNode(node2, "TSTypeLiteral");
        };
        _proto.tsParseObjectTypeMembers = function tsParseObjectTypeMembers() {
          this.expect(5);
          var members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
          this.expect(8);
          return members;
        };
        _proto.tsIsStartOfMappedType = function tsIsStartOfMappedType() {
          this.next();
          if (this.eat(53)) {
            return this.isContextual(118);
          }
          if (this.isContextual(118)) {
            this.next();
          }
          if (!this.match(0)) {
            return false;
          }
          this.next();
          if (!this.tsIsIdentifier()) {
            return false;
          }
          this.next();
          return this.match(58);
        };
        _proto.tsParseMappedTypeParameter = function tsParseMappedTypeParameter() {
          var node2 = this.startNode();
          node2.name = this.tsParseTypeParameterName();
          node2.constraint = this.tsExpectThenParseType(58);
          return this.finishNode(node2, "TSTypeParameter");
        };
        _proto.tsParseMappedType = function tsParseMappedType() {
          var node2 = this.startNode();
          this.expect(5);
          if (this.match(53)) {
            node2.readonly = this.state.value;
            this.next();
            this.expectContextual(118);
          } else if (this.eatContextual(118)) {
            node2.readonly = true;
          }
          this.expect(0);
          node2.typeParameter = this.tsParseMappedTypeParameter();
          node2.nameType = this.eatContextual(93) ? this.tsParseType() : null;
          this.expect(3);
          if (this.match(53)) {
            node2.optional = this.state.value;
            this.next();
            this.expect(17);
          } else if (this.eat(17)) {
            node2.optional = true;
          }
          node2.typeAnnotation = this.tsTryParseType();
          this.semicolon();
          this.expect(8);
          return this.finishNode(node2, "TSMappedType");
        };
        _proto.tsParseTupleType = function tsParseTupleType() {
          var _this3 = this;
          var node2 = this.startNode();
          node2.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
          var seenOptionalElement = false;
          var labeledElements = null;
          node2.elementTypes.forEach(function(elementNode) {
            var _labeledElements;
            var _elementNode = elementNode, type5 = _elementNode.type;
            if (seenOptionalElement && type5 !== "TSRestType" && type5 !== "TSOptionalType" && !(type5 === "TSNamedTupleMember" && elementNode.optional)) {
              _this3.raise(TSErrors.OptionalTypeBeforeRequired, {
                at: elementNode
              });
            }
            seenOptionalElement = seenOptionalElement || type5 === "TSNamedTupleMember" && elementNode.optional || type5 === "TSOptionalType";
            if (type5 === "TSRestType") {
              elementNode = elementNode.typeAnnotation;
              type5 = elementNode.type;
            }
            var isLabeled = type5 === "TSNamedTupleMember";
            labeledElements = (_labeledElements = labeledElements) != null ? _labeledElements : isLabeled;
            if (labeledElements !== isLabeled) {
              _this3.raise(TSErrors.MixedLabeledAndUnlabeledElements, {
                at: elementNode
              });
            }
          });
          return this.finishNode(node2, "TSTupleType");
        };
        _proto.tsParseTupleElementType = function tsParseTupleElementType() {
          var _this$state = this.state, startPos = _this$state.start, startLoc = _this$state.startLoc;
          var rest = this.eat(21);
          var type5 = this.tsParseType();
          var optional = this.eat(17);
          var labeled = this.eat(14);
          if (labeled) {
            var labeledNode = this.startNodeAtNode(type5);
            labeledNode.optional = optional;
            if (type5.type === "TSTypeReference" && !type5.typeParameters && type5.typeName.type === "Identifier") {
              labeledNode.label = type5.typeName;
            } else {
              this.raise(TSErrors.InvalidTupleMemberLabel, {
                at: type5
              });
              labeledNode.label = type5;
            }
            labeledNode.elementType = this.tsParseType();
            type5 = this.finishNode(labeledNode, "TSNamedTupleMember");
          } else if (optional) {
            var optionalTypeNode = this.startNodeAtNode(type5);
            optionalTypeNode.typeAnnotation = type5;
            type5 = this.finishNode(optionalTypeNode, "TSOptionalType");
          }
          if (rest) {
            var restNode = this.startNodeAt(startPos, startLoc);
            restNode.typeAnnotation = type5;
            type5 = this.finishNode(restNode, "TSRestType");
          }
          return type5;
        };
        _proto.tsParseParenthesizedType = function tsParseParenthesizedType() {
          var node2 = this.startNode();
          this.expect(10);
          node2.typeAnnotation = this.tsParseType();
          this.expect(11);
          return this.finishNode(node2, "TSParenthesizedType");
        };
        _proto.tsParseFunctionOrConstructorType = function tsParseFunctionOrConstructorType(type5, _abstract) {
          var node2 = this.startNode();
          if (type5 === "TSConstructorType") {
            node2["abstract"] = !!_abstract;
            if (_abstract)
              this.next();
            this.next();
          }
          this.tsFillSignature(19, node2);
          return this.finishNode(node2, type5);
        };
        _proto.tsParseLiteralTypeNode = function tsParseLiteralTypeNode() {
          var _this4 = this;
          var node2 = this.startNode();
          node2.literal = function() {
            switch (_this4.state.type) {
              case 130:
              case 131:
              case 129:
              case 85:
              case 86:
                return _this4.parseExprAtom();
              default:
                throw _this4.unexpected();
            }
          }();
          return this.finishNode(node2, "TSLiteralType");
        };
        _proto.tsParseTemplateLiteralType = function tsParseTemplateLiteralType() {
          var node2 = this.startNode();
          node2.literal = this.parseTemplate(false);
          return this.finishNode(node2, "TSLiteralType");
        };
        _proto.parseTemplateSubstitution = function parseTemplateSubstitution() {
          if (this.state.inType)
            return this.tsParseType();
          return _superClass.prototype.parseTemplateSubstitution.call(this);
        };
        _proto.tsParseThisTypeOrThisTypePredicate = function tsParseThisTypeOrThisTypePredicate() {
          var thisKeyword = this.tsParseThisTypeNode();
          if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
            return this.tsParseThisTypePredicate(thisKeyword);
          } else {
            return thisKeyword;
          }
        };
        _proto.tsParseNonArrayType = function tsParseNonArrayType() {
          switch (this.state.type) {
            case 129:
            case 130:
            case 131:
            case 85:
            case 86:
              return this.tsParseLiteralTypeNode();
            case 53:
              if (this.state.value === "-") {
                var node2 = this.startNode();
                var nextToken = this.lookahead();
                if (nextToken.type !== 130 && nextToken.type !== 131) {
                  throw this.unexpected();
                }
                node2.literal = this.parseMaybeUnary();
                return this.finishNode(node2, "TSLiteralType");
              }
              break;
            case 78:
              return this.tsParseThisTypeOrThisTypePredicate();
            case 87:
              return this.tsParseTypeQuery();
            case 83:
              return this.tsParseImportType();
            case 5:
              return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
            case 0:
              return this.tsParseTupleType();
            case 10:
              return this.tsParseParenthesizedType();
            case 25:
            case 24:
              return this.tsParseTemplateLiteralType();
            default: {
              var type5 = this.state.type;
              if (tokenIsIdentifier(type5) || type5 === 88 || type5 === 84) {
                var nodeType = type5 === 88 ? "TSVoidKeyword" : type5 === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);
                if (nodeType !== void 0 && this.lookaheadCharCode() !== 46) {
                  var _node = this.startNode();
                  this.next();
                  return this.finishNode(_node, nodeType);
                }
                return this.tsParseTypeReference();
              }
            }
          }
          throw this.unexpected();
        };
        _proto.tsParseArrayTypeOrHigher = function tsParseArrayTypeOrHigher() {
          var type5 = this.tsParseNonArrayType();
          while (!this.hasPrecedingLineBreak() && this.eat(0)) {
            if (this.match(3)) {
              var node2 = this.startNodeAtNode(type5);
              node2.elementType = type5;
              this.expect(3);
              type5 = this.finishNode(node2, "TSArrayType");
            } else {
              var _node2 = this.startNodeAtNode(type5);
              _node2.objectType = type5;
              _node2.indexType = this.tsParseType();
              this.expect(3);
              type5 = this.finishNode(_node2, "TSIndexedAccessType");
            }
          }
          return type5;
        };
        _proto.tsParseTypeOperator = function tsParseTypeOperator() {
          var node2 = this.startNode();
          var operator = this.state.value;
          this.next();
          node2.operator = operator;
          node2.typeAnnotation = this.tsParseTypeOperatorOrHigher();
          if (operator === "readonly") {
            this.tsCheckTypeAnnotationForReadOnly(node2);
          }
          return this.finishNode(node2, "TSTypeOperator");
        };
        _proto.tsCheckTypeAnnotationForReadOnly = function tsCheckTypeAnnotationForReadOnly(node2) {
          switch (node2.typeAnnotation.type) {
            case "TSTupleType":
            case "TSArrayType":
              return;
            default:
              this.raise(TSErrors.UnexpectedReadonly, {
                at: node2
              });
          }
        };
        _proto.tsParseInferType = function tsParseInferType() {
          var node2 = this.startNode();
          this.expectContextual(112);
          var typeParameter2 = this.startNode();
          typeParameter2.name = this.tsParseTypeParameterName();
          node2.typeParameter = this.finishNode(typeParameter2, "TSTypeParameter");
          return this.finishNode(node2, "TSInferType");
        };
        _proto.tsParseTypeOperatorOrHigher = function tsParseTypeOperatorOrHigher() {
          var isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
          return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(112) ? this.tsParseInferType() : this.tsParseArrayTypeOrHigher();
        };
        _proto.tsParseUnionOrIntersectionType = function tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
          var node2 = this.startNode();
          var hasLeadingOperator = this.eat(operator);
          var types3 = [];
          do {
            types3.push(parseConstituentType());
          } while (this.eat(operator));
          if (types3.length === 1 && !hasLeadingOperator) {
            return types3[0];
          }
          node2.types = types3;
          return this.finishNode(node2, kind);
        };
        _proto.tsParseIntersectionTypeOrHigher = function tsParseIntersectionTypeOrHigher() {
          return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
        };
        _proto.tsParseUnionTypeOrHigher = function tsParseUnionTypeOrHigher() {
          return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
        };
        _proto.tsIsStartOfFunctionType = function tsIsStartOfFunctionType() {
          if (this.match(47)) {
            return true;
          }
          return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
        };
        _proto.tsSkipParameterStart = function tsSkipParameterStart() {
          if (tokenIsIdentifier(this.state.type) || this.match(78)) {
            this.next();
            return true;
          }
          if (this.match(5)) {
            var errors = this.state.errors;
            var previousErrorCount = errors.length;
            try {
              this.parseObjectLike(8, true);
              return errors.length === previousErrorCount;
            } catch (_unused) {
              return false;
            }
          }
          if (this.match(0)) {
            this.next();
            var _errors = this.state.errors;
            var _previousErrorCount = _errors.length;
            try {
              this.parseBindingList(3, 93, true);
              return _errors.length === _previousErrorCount;
            } catch (_unused2) {
              return false;
            }
          }
          return false;
        };
        _proto.tsIsUnambiguouslyStartOfFunctionType = function tsIsUnambiguouslyStartOfFunctionType() {
          this.next();
          if (this.match(11) || this.match(21)) {
            return true;
          }
          if (this.tsSkipParameterStart()) {
            if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
              return true;
            }
            if (this.match(11)) {
              this.next();
              if (this.match(19)) {
                return true;
              }
            }
          }
          return false;
        };
        _proto.tsParseTypeOrTypePredicateAnnotation = function tsParseTypeOrTypePredicateAnnotation(returnToken) {
          var _this5 = this;
          return this.tsInType(function() {
            var t3 = _this5.startNode();
            _this5.expect(returnToken);
            var node2 = _this5.startNode();
            var asserts = !!_this5.tsTryParse(_this5.tsParseTypePredicateAsserts.bind(_this5));
            if (asserts && _this5.match(78)) {
              var thisTypePredicate = _this5.tsParseThisTypeOrThisTypePredicate();
              if (thisTypePredicate.type === "TSThisType") {
                node2.parameterName = thisTypePredicate;
                node2.asserts = true;
                node2.typeAnnotation = null;
                thisTypePredicate = _this5.finishNode(node2, "TSTypePredicate");
              } else {
                _this5.resetStartLocationFromNode(thisTypePredicate, node2);
                thisTypePredicate.asserts = true;
              }
              t3.typeAnnotation = thisTypePredicate;
              return _this5.finishNode(t3, "TSTypeAnnotation");
            }
            var typePredicateVariable = _this5.tsIsIdentifier() && _this5.tsTryParse(_this5.tsParseTypePredicatePrefix.bind(_this5));
            if (!typePredicateVariable) {
              if (!asserts) {
                return _this5.tsParseTypeAnnotation(false, t3);
              }
              node2.parameterName = _this5.parseIdentifier();
              node2.asserts = asserts;
              node2.typeAnnotation = null;
              t3.typeAnnotation = _this5.finishNode(node2, "TSTypePredicate");
              return _this5.finishNode(t3, "TSTypeAnnotation");
            }
            var type5 = _this5.tsParseTypeAnnotation(false);
            node2.parameterName = typePredicateVariable;
            node2.typeAnnotation = type5;
            node2.asserts = asserts;
            t3.typeAnnotation = _this5.finishNode(node2, "TSTypePredicate");
            return _this5.finishNode(t3, "TSTypeAnnotation");
          });
        };
        _proto.tsTryParseTypeOrTypePredicateAnnotation = function tsTryParseTypeOrTypePredicateAnnotation() {
          return this.match(14) ? this.tsParseTypeOrTypePredicateAnnotation(14) : void 0;
        };
        _proto.tsTryParseTypeAnnotation = function tsTryParseTypeAnnotation() {
          return this.match(14) ? this.tsParseTypeAnnotation() : void 0;
        };
        _proto.tsTryParseType = function tsTryParseType() {
          return this.tsEatThenParseType(14);
        };
        _proto.tsParseTypePredicatePrefix = function tsParseTypePredicatePrefix() {
          var id3 = this.parseIdentifier();
          if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
            this.next();
            return id3;
          }
        };
        _proto.tsParseTypePredicateAsserts = function tsParseTypePredicateAsserts() {
          if (this.state.type !== 106) {
            return false;
          }
          var containsEsc = this.state.containsEsc;
          this.next();
          if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
            return false;
          }
          if (containsEsc) {
            this.raise(Errors.InvalidEscapedReservedWord, {
              at: this.state.lastTokStartLoc,
              reservedWord: "asserts"
            });
          }
          return true;
        };
        _proto.tsParseTypeAnnotation = function tsParseTypeAnnotation(eatColon, t3) {
          var _this6 = this;
          if (eatColon === void 0) {
            eatColon = true;
          }
          if (t3 === void 0) {
            t3 = this.startNode();
          }
          this.tsInType(function() {
            if (eatColon)
              _this6.expect(14);
            t3.typeAnnotation = _this6.tsParseType();
          });
          return this.finishNode(t3, "TSTypeAnnotation");
        };
        _proto.tsParseType = function tsParseType() {
          assert$2(this.state.inType);
          var type5 = this.tsParseNonConditionalType();
          if (this.hasPrecedingLineBreak() || !this.eat(81)) {
            return type5;
          }
          var node2 = this.startNodeAtNode(type5);
          node2.checkType = type5;
          node2.extendsType = this.tsParseNonConditionalType();
          this.expect(17);
          node2.trueType = this.tsParseType();
          this.expect(14);
          node2.falseType = this.tsParseType();
          return this.finishNode(node2, "TSConditionalType");
        };
        _proto.isAbstractConstructorSignature = function isAbstractConstructorSignature() {
          return this.isContextual(120) && this.lookahead().type === 77;
        };
        _proto.tsParseNonConditionalType = function tsParseNonConditionalType() {
          if (this.tsIsStartOfFunctionType()) {
            return this.tsParseFunctionOrConstructorType("TSFunctionType");
          }
          if (this.match(77)) {
            return this.tsParseFunctionOrConstructorType("TSConstructorType");
          } else if (this.isAbstractConstructorSignature()) {
            return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
          }
          return this.tsParseUnionTypeOrHigher();
        };
        _proto.tsParseTypeAssertion = function tsParseTypeAssertion() {
          if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
            this.raise(TSErrors.ReservedTypeAssertion, {
              at: this.state.startLoc
            });
          }
          var node2 = this.startNode();
          var _const = this.tsTryNextParseConstantContext();
          node2.typeAnnotation = _const || this.tsNextThenParseType();
          this.expect(48);
          node2.expression = this.parseMaybeUnary();
          return this.finishNode(node2, "TSTypeAssertion");
        };
        _proto.tsParseHeritageClause = function tsParseHeritageClause(token) {
          var originalStartLoc = this.state.startLoc;
          var delimitedList = this.tsParseDelimitedList("HeritageClauseElement", this.tsParseExpressionWithTypeArguments.bind(this));
          if (!delimitedList.length) {
            this.raise(TSErrors.EmptyHeritageClauseType, {
              at: originalStartLoc,
              token
            });
          }
          return delimitedList;
        };
        _proto.tsParseExpressionWithTypeArguments = function tsParseExpressionWithTypeArguments() {
          var node2 = this.startNode();
          node2.expression = this.tsParseEntityName();
          if (this.match(47)) {
            node2.typeParameters = this.tsParseTypeArguments();
          }
          return this.finishNode(node2, "TSExpressionWithTypeArguments");
        };
        _proto.tsParseInterfaceDeclaration = function tsParseInterfaceDeclaration(node2, properties) {
          if (properties === void 0) {
            properties = {};
          }
          if (this.hasFollowingLineBreak())
            return null;
          this.expectContextual(125);
          if (properties.declare)
            node2.declare = true;
          if (tokenIsIdentifier(this.state.type)) {
            node2.id = this.parseIdentifier();
            this.checkIdentifier(node2.id, BIND_TS_INTERFACE);
          } else {
            node2.id = null;
            this.raise(TSErrors.MissingInterfaceName, {
              at: this.state.startLoc
            });
          }
          node2.typeParameters = this.tsTryParseTypeParameters();
          if (this.eat(81)) {
            node2["extends"] = this.tsParseHeritageClause("extends");
          }
          var body = this.startNode();
          body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
          node2.body = this.finishNode(body, "TSInterfaceBody");
          return this.finishNode(node2, "TSInterfaceDeclaration");
        };
        _proto.tsParseTypeAliasDeclaration = function tsParseTypeAliasDeclaration(node2) {
          var _this7 = this;
          node2.id = this.parseIdentifier();
          this.checkIdentifier(node2.id, BIND_TS_TYPE);
          node2.typeAnnotation = this.tsInType(function() {
            node2.typeParameters = _this7.tsTryParseTypeParameters();
            _this7.expect(29);
            if (_this7.isContextual(111) && _this7.lookahead().type !== 16) {
              var _node3 = _this7.startNode();
              _this7.next();
              return _this7.finishNode(_node3, "TSIntrinsicKeyword");
            }
            return _this7.tsParseType();
          });
          this.semicolon();
          return this.finishNode(node2, "TSTypeAliasDeclaration");
        };
        _proto.tsInNoContext = function tsInNoContext(cb2) {
          var oldContext = this.state.context;
          this.state.context = [oldContext[0]];
          try {
            return cb2();
          } finally {
            this.state.context = oldContext;
          }
        };
        _proto.tsInType = function tsInType(cb2) {
          var oldInType = this.state.inType;
          this.state.inType = true;
          try {
            return cb2();
          } finally {
            this.state.inType = oldInType;
          }
        };
        _proto.tsEatThenParseType = function tsEatThenParseType(token) {
          return !this.match(token) ? void 0 : this.tsNextThenParseType();
        };
        _proto.tsExpectThenParseType = function tsExpectThenParseType(token) {
          var _this8 = this;
          return this.tsDoThenParseType(function() {
            return _this8.expect(token);
          });
        };
        _proto.tsNextThenParseType = function tsNextThenParseType() {
          var _this9 = this;
          return this.tsDoThenParseType(function() {
            return _this9.next();
          });
        };
        _proto.tsDoThenParseType = function tsDoThenParseType(cb2) {
          var _this10 = this;
          return this.tsInType(function() {
            cb2();
            return _this10.tsParseType();
          });
        };
        _proto.tsParseEnumMember = function tsParseEnumMember() {
          var node2 = this.startNode();
          node2.id = this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);
          if (this.eat(29)) {
            node2.initializer = this.parseMaybeAssignAllowIn();
          }
          return this.finishNode(node2, "TSEnumMember");
        };
        _proto.tsParseEnumDeclaration = function tsParseEnumDeclaration(node2, properties) {
          if (properties === void 0) {
            properties = {};
          }
          if (properties["const"])
            node2["const"] = true;
          if (properties.declare)
            node2.declare = true;
          this.expectContextual(122);
          node2.id = this.parseIdentifier();
          this.checkIdentifier(node2.id, node2["const"] ? BIND_TS_CONST_ENUM : BIND_TS_ENUM);
          this.expect(5);
          node2.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
          this.expect(8);
          return this.finishNode(node2, "TSEnumDeclaration");
        };
        _proto.tsParseModuleBlock = function tsParseModuleBlock() {
          var node2 = this.startNode();
          this.scope.enter(SCOPE_OTHER);
          this.expect(5);
          this.parseBlockOrModuleBlockBody(node2.body = [], void 0, true, 8);
          this.scope.exit();
          return this.finishNode(node2, "TSModuleBlock");
        };
        _proto.tsParseModuleOrNamespaceDeclaration = function tsParseModuleOrNamespaceDeclaration(node2, nested) {
          if (nested === void 0) {
            nested = false;
          }
          node2.id = this.parseIdentifier();
          if (!nested) {
            this.checkIdentifier(node2.id, BIND_TS_NAMESPACE);
          }
          if (this.eat(16)) {
            var inner2 = this.startNode();
            this.tsParseModuleOrNamespaceDeclaration(inner2, true);
            node2.body = inner2;
          } else {
            this.scope.enter(SCOPE_TS_MODULE);
            this.prodParam.enter(PARAM);
            node2.body = this.tsParseModuleBlock();
            this.prodParam.exit();
            this.scope.exit();
          }
          return this.finishNode(node2, "TSModuleDeclaration");
        };
        _proto.tsParseAmbientExternalModuleDeclaration = function tsParseAmbientExternalModuleDeclaration(node2) {
          if (this.isContextual(109)) {
            node2.global = true;
            node2.id = this.parseIdentifier();
          } else if (this.match(129)) {
            node2.id = this.parseExprAtom();
          } else {
            this.unexpected();
          }
          if (this.match(5)) {
            this.scope.enter(SCOPE_TS_MODULE);
            this.prodParam.enter(PARAM);
            node2.body = this.tsParseModuleBlock();
            this.prodParam.exit();
            this.scope.exit();
          } else {
            this.semicolon();
          }
          return this.finishNode(node2, "TSModuleDeclaration");
        };
        _proto.tsParseImportEqualsDeclaration = function tsParseImportEqualsDeclaration(node2, isExport) {
          node2.isExport = isExport || false;
          node2.id = this.parseIdentifier();
          this.checkIdentifier(node2.id, BIND_LEXICAL2);
          this.expect(29);
          var moduleReference = this.tsParseModuleReference();
          if (node2.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
            this.raise(TSErrors.ImportAliasHasImportType, {
              at: moduleReference
            });
          }
          node2.moduleReference = moduleReference;
          this.semicolon();
          return this.finishNode(node2, "TSImportEqualsDeclaration");
        };
        _proto.tsIsExternalModuleReference = function tsIsExternalModuleReference() {
          return this.isContextual(116) && this.lookaheadCharCode() === 40;
        };
        _proto.tsParseModuleReference = function tsParseModuleReference() {
          return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
        };
        _proto.tsParseExternalModuleReference = function tsParseExternalModuleReference() {
          var node2 = this.startNode();
          this.expectContextual(116);
          this.expect(10);
          if (!this.match(129)) {
            throw this.unexpected();
          }
          node2.expression = this.parseExprAtom();
          this.expect(11);
          return this.finishNode(node2, "TSExternalModuleReference");
        };
        _proto.tsLookAhead = function tsLookAhead(f2) {
          var state = this.state.clone();
          var res2 = f2();
          this.state = state;
          return res2;
        };
        _proto.tsTryParseAndCatch = function tsTryParseAndCatch(f2) {
          var result = this.tryParse(function(abort) {
            return f2() || abort();
          });
          if (result.aborted || !result.node)
            return void 0;
          if (result.error)
            this.state = result.failState;
          return result.node;
        };
        _proto.tsTryParse = function tsTryParse(f2) {
          var state = this.state.clone();
          var result = f2();
          if (result !== void 0 && result !== false) {
            return result;
          } else {
            this.state = state;
            return void 0;
          }
        };
        _proto.tsTryParseDeclare = function tsTryParseDeclare(nany) {
          var _this11 = this;
          if (this.isLineTerminator()) {
            return;
          }
          var starttype = this.state.type;
          var kind;
          if (this.isContextual(99)) {
            starttype = 74;
            kind = "let";
          }
          return this.tsInAmbientContext(function() {
            if (starttype === 68) {
              nany.declare = true;
              return _this11.parseFunctionStatement(nany, false, true);
            }
            if (starttype === 80) {
              nany.declare = true;
              return _this11.parseClass(nany, true, false);
            }
            if (starttype === 122) {
              return _this11.tsParseEnumDeclaration(nany, {
                declare: true
              });
            }
            if (starttype === 109) {
              return _this11.tsParseAmbientExternalModuleDeclaration(nany);
            }
            if (starttype === 75 || starttype === 74) {
              if (!_this11.match(75) || !_this11.isLookaheadContextual("enum")) {
                nany.declare = true;
                return _this11.parseVarStatement(nany, kind || _this11.state.value, true);
              }
              _this11.expect(75);
              return _this11.tsParseEnumDeclaration(nany, {
                "const": true,
                declare: true
              });
            }
            if (starttype === 125) {
              var result = _this11.tsParseInterfaceDeclaration(nany, {
                declare: true
              });
              if (result)
                return result;
            }
            if (tokenIsIdentifier(starttype)) {
              return _this11.tsParseDeclaration(nany, _this11.state.value, true);
            }
          });
        };
        _proto.tsTryParseExportDeclaration = function tsTryParseExportDeclaration() {
          return this.tsParseDeclaration(this.startNode(), this.state.value, true);
        };
        _proto.tsParseExpressionStatement = function tsParseExpressionStatement(node2, expr) {
          switch (expr.name) {
            case "declare": {
              var declaration = this.tsTryParseDeclare(node2);
              if (declaration) {
                declaration.declare = true;
                return declaration;
              }
              break;
            }
            case "global":
              if (this.match(5)) {
                this.scope.enter(SCOPE_TS_MODULE);
                this.prodParam.enter(PARAM);
                var mod = node2;
                mod.global = true;
                mod.id = expr;
                mod.body = this.tsParseModuleBlock();
                this.scope.exit();
                this.prodParam.exit();
                return this.finishNode(mod, "TSModuleDeclaration");
              }
              break;
            default:
              return this.tsParseDeclaration(node2, expr.name, false);
          }
        };
        _proto.tsParseDeclaration = function tsParseDeclaration(node2, value, next) {
          switch (value) {
            case "abstract":
              if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
                return this.tsParseAbstractDeclaration(node2);
              }
              break;
            case "module":
              if (this.tsCheckLineTerminator(next)) {
                if (this.match(129)) {
                  return this.tsParseAmbientExternalModuleDeclaration(node2);
                } else if (tokenIsIdentifier(this.state.type)) {
                  return this.tsParseModuleOrNamespaceDeclaration(node2);
                }
              }
              break;
            case "namespace":
              if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
                return this.tsParseModuleOrNamespaceDeclaration(node2);
              }
              break;
            case "type":
              if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
                return this.tsParseTypeAliasDeclaration(node2);
              }
              break;
          }
        };
        _proto.tsCheckLineTerminator = function tsCheckLineTerminator(next) {
          if (next) {
            if (this.hasFollowingLineBreak())
              return false;
            this.next();
            return true;
          }
          return !this.isLineTerminator();
        };
        _proto.tsTryParseGenericAsyncArrowFunction = function tsTryParseGenericAsyncArrowFunction(startPos, startLoc) {
          var _this12 = this;
          if (!this.match(47)) {
            return void 0;
          }
          var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
          this.state.maybeInArrowParameters = true;
          var res2 = this.tsTryParseAndCatch(function() {
            var node2 = _this12.startNodeAt(startPos, startLoc);
            node2.typeParameters = _this12.tsParseTypeParameters();
            _superClass.prototype.parseFunctionParams.call(_this12, node2);
            node2.returnType = _this12.tsTryParseTypeOrTypePredicateAnnotation();
            _this12.expect(19);
            return node2;
          });
          this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
          if (!res2) {
            return void 0;
          }
          return this.parseArrowExpression(res2, null, true);
        };
        _proto.tsParseTypeArgumentsInExpression = function tsParseTypeArgumentsInExpression() {
          if (this.reScan_lt() !== 47) {
            return void 0;
          }
          return this.tsParseTypeArguments();
        };
        _proto.tsParseTypeArguments = function tsParseTypeArguments() {
          var _this13 = this;
          var node2 = this.startNode();
          node2.params = this.tsInType(function() {
            return _this13.tsInNoContext(function() {
              _this13.expect(47);
              return _this13.tsParseDelimitedList("TypeParametersOrArguments", _this13.tsParseType.bind(_this13));
            });
          });
          if (node2.params.length === 0) {
            this.raise(TSErrors.EmptyTypeArguments, {
              at: node2
            });
          }
          this.expect(48);
          return this.finishNode(node2, "TSTypeParameterInstantiation");
        };
        _proto.tsIsDeclarationStart = function tsIsDeclarationStart() {
          return tokenIsTSDeclarationStart(this.state.type);
        };
        _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier2() {
          if (this.tsIsDeclarationStart())
            return false;
          return _superClass.prototype.isExportDefaultSpecifier.call(this);
        };
        _proto.parseAssignableListItem = function parseAssignableListItem(allowModifiers, decorators) {
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var accessibility;
          var readonly = false;
          var override = false;
          if (allowModifiers !== void 0) {
            var modified = {};
            this.tsParseModifiers({
              modified,
              allowedModifiers: ["public", "private", "protected", "override", "readonly"]
            });
            accessibility = modified.accessibility;
            override = modified.override;
            readonly = modified.readonly;
            if (allowModifiers === false && (accessibility || readonly || override)) {
              this.raise(TSErrors.UnexpectedParameterModifier, {
                at: startLoc
              });
            }
          }
          var left = this.parseMaybeDefault();
          this.parseAssignableListItemTypes(left);
          var elt = this.parseMaybeDefault(left.start, left.loc.start, left);
          if (accessibility || readonly || override) {
            var pp2 = this.startNodeAt(startPos, startLoc);
            if (decorators.length) {
              pp2.decorators = decorators;
            }
            if (accessibility)
              pp2.accessibility = accessibility;
            if (readonly)
              pp2.readonly = readonly;
            if (override)
              pp2.override = override;
            if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
              this.raise(TSErrors.UnsupportedParameterPropertyKind, {
                at: pp2
              });
            }
            pp2.parameter = elt;
            return this.finishNode(pp2, "TSParameterProperty");
          }
          if (decorators.length) {
            left.decorators = decorators;
          }
          return elt;
        };
        _proto.isSimpleParameter = function isSimpleParameter(node2) {
          return node2.type === "TSParameterProperty" && _superClass.prototype.isSimpleParameter.call(this, node2.parameter) || _superClass.prototype.isSimpleParameter.call(this, node2);
        };
        _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node2, type5, isMethod2) {
          if (isMethod2 === void 0) {
            isMethod2 = false;
          }
          if (this.match(14)) {
            node2.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
          }
          var bodilessType = type5 === "FunctionDeclaration" ? "TSDeclareFunction" : type5 === "ClassMethod" || type5 === "ClassPrivateMethod" ? "TSDeclareMethod" : void 0;
          if (bodilessType && !this.match(5) && this.isLineTerminator()) {
            this.finishNode(node2, bodilessType);
            return;
          }
          if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
            this.raise(TSErrors.DeclareFunctionHasImplementation, {
              at: node2
            });
            if (node2.declare) {
              _superClass.prototype.parseFunctionBodyAndFinish.call(this, node2, bodilessType, isMethod2);
              return;
            }
          }
          _superClass.prototype.parseFunctionBodyAndFinish.call(this, node2, type5, isMethod2);
        };
        _proto.registerFunctionStatementId = function registerFunctionStatementId(node2) {
          if (!node2.body && node2.id) {
            this.checkIdentifier(node2.id, BIND_TS_AMBIENT);
          } else {
            _superClass.prototype.registerFunctionStatementId.apply(this, arguments);
          }
        };
        _proto.tsCheckForInvalidTypeCasts = function tsCheckForInvalidTypeCasts(items) {
          var _this14 = this;
          items.forEach(function(node2) {
            if ((node2 == null ? void 0 : node2.type) === "TSTypeCastExpression") {
              _this14.raise(TSErrors.UnexpectedTypeAnnotation, {
                at: node2.typeAnnotation
              });
            }
          });
        };
        _proto.toReferencedList = function toReferencedList(exprList, isInParens) {
          this.tsCheckForInvalidTypeCasts(exprList);
          return exprList;
        };
        _proto.parseArrayLike = function parseArrayLike() {
          var _superClass$prototype;
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          var node2 = (_superClass$prototype = _superClass.prototype.parseArrayLike).call.apply(_superClass$prototype, [this].concat(args));
          if (node2.type === "ArrayExpression") {
            this.tsCheckForInvalidTypeCasts(node2.elements);
          }
          return node2;
        };
        _proto.parseSubscript = function parseSubscript(base2, startPos, startLoc, noCalls, state) {
          var _this15 = this;
          if (!this.hasPrecedingLineBreak() && this.match(35)) {
            this.state.canStartJSXElement = false;
            this.next();
            var nonNullExpression = this.startNodeAt(startPos, startLoc);
            nonNullExpression.expression = base2;
            return this.finishNode(nonNullExpression, "TSNonNullExpression");
          }
          var isOptionalCall = false;
          if (this.match(18) && this.lookaheadCharCode() === 60) {
            if (noCalls) {
              state.stop = true;
              return base2;
            }
            state.optionalChainMember = isOptionalCall = true;
            this.next();
          }
          if (this.match(47) || this.match(51)) {
            var missingParenErrorLoc;
            var result = this.tsTryParseAndCatch(function() {
              if (!noCalls && _this15.atPossibleAsyncArrow(base2)) {
                var asyncArrowFn = _this15.tsTryParseGenericAsyncArrowFunction(startPos, startLoc);
                if (asyncArrowFn) {
                  return asyncArrowFn;
                }
              }
              var node2 = _this15.startNodeAt(startPos, startLoc);
              node2.callee = base2;
              var typeArguments = _this15.tsParseTypeArgumentsInExpression();
              if (typeArguments) {
                if (isOptionalCall && !_this15.match(10)) {
                  missingParenErrorLoc = _this15.state.curPosition();
                  _this15.unexpected();
                }
                if (!noCalls && _this15.eat(10)) {
                  node2.arguments = _this15.parseCallExpressionArguments(11, false);
                  _this15.tsCheckForInvalidTypeCasts(node2.arguments);
                  node2.typeParameters = typeArguments;
                  if (state.optionalChainMember) {
                    node2.optional = isOptionalCall;
                  }
                  return _this15.finishCallExpression(node2, state.optionalChainMember);
                } else if (tokenIsTemplate(_this15.state.type)) {
                  var _result = _this15.parseTaggedTemplateExpression(base2, startPos, startLoc, state);
                  _result.typeParameters = typeArguments;
                  return _result;
                }
              }
              _this15.unexpected();
            });
            if (missingParenErrorLoc) {
              this.unexpected(missingParenErrorLoc, 10);
            }
            if (result)
              return result;
          }
          return _superClass.prototype.parseSubscript.call(this, base2, startPos, startLoc, noCalls, state);
        };
        _proto.parseNewArguments = function parseNewArguments(node2) {
          var _this16 = this;
          if (this.match(47) || this.match(51)) {
            var typeParameters = this.tsTryParseAndCatch(function() {
              var args = _this16.tsParseTypeArgumentsInExpression();
              if (!_this16.match(10))
                _this16.unexpected();
              return args;
            });
            if (typeParameters) {
              node2.typeParameters = typeParameters;
            }
          }
          _superClass.prototype.parseNewArguments.call(this, node2);
        };
        _proto.parseExprOp = function parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
          if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && this.isContextual(93)) {
            var node2 = this.startNodeAt(leftStartPos, leftStartLoc);
            node2.expression = left;
            var _const = this.tsTryNextParseConstantContext();
            if (_const) {
              node2.typeAnnotation = _const;
            } else {
              node2.typeAnnotation = this.tsNextThenParseType();
            }
            this.finishNode(node2, "TSAsExpression");
            this.reScan_lt_gt();
            return this.parseExprOp(node2, leftStartPos, leftStartLoc, minPrec);
          }
          return _superClass.prototype.parseExprOp.call(this, left, leftStartPos, leftStartLoc, minPrec);
        };
        _proto.checkReservedWord = function checkReservedWord(word, startLoc, checkKeywords, isBinding2) {
          if (!this.state.isAmbientContext) {
            _superClass.prototype.checkReservedWord.call(this, word, startLoc, checkKeywords, isBinding2);
          }
        };
        _proto.checkDuplicateExports = function checkDuplicateExports() {
        };
        _proto.parseImport = function parseImport(node2) {
          node2.importKind = "value";
          if (tokenIsIdentifier(this.state.type) || this.match(55) || this.match(5)) {
            var ahead = this.lookahead();
            if (this.isContextual(126) && ahead.type !== 12 && ahead.type !== 97 && ahead.type !== 29) {
              node2.importKind = "type";
              this.next();
              ahead = this.lookahead();
            }
            if (tokenIsIdentifier(this.state.type) && ahead.type === 29) {
              return this.tsParseImportEqualsDeclaration(node2);
            }
          }
          var importNode = _superClass.prototype.parseImport.call(this, node2);
          if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
            this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, {
              at: importNode
            });
          }
          return importNode;
        };
        _proto.parseExport = function parseExport(node2) {
          if (this.match(83)) {
            this.next();
            if (this.isContextual(126) && this.lookaheadCharCode() !== 61) {
              node2.importKind = "type";
              this.next();
            } else {
              node2.importKind = "value";
            }
            return this.tsParseImportEqualsDeclaration(node2, true);
          } else if (this.eat(29)) {
            var assign = node2;
            assign.expression = this.parseExpression();
            this.semicolon();
            return this.finishNode(assign, "TSExportAssignment");
          } else if (this.eatContextual(93)) {
            var decl = node2;
            this.expectContextual(124);
            decl.id = this.parseIdentifier();
            this.semicolon();
            return this.finishNode(decl, "TSNamespaceExportDeclaration");
          } else {
            if (this.isContextual(126) && this.lookahead().type === 5) {
              this.next();
              node2.exportKind = "type";
            } else {
              node2.exportKind = "value";
            }
            return _superClass.prototype.parseExport.call(this, node2);
          }
        };
        _proto.isAbstractClass = function isAbstractClass() {
          return this.isContextual(120) && this.lookahead().type === 80;
        };
        _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
          if (this.isAbstractClass()) {
            var cls = this.startNode();
            this.next();
            cls["abstract"] = true;
            this.parseClass(cls, true, true);
            return cls;
          }
          if (this.match(125)) {
            var result = this.tsParseInterfaceDeclaration(this.startNode());
            if (result)
              return result;
          }
          return _superClass.prototype.parseExportDefaultExpression.call(this);
        };
        _proto.parseVarStatement = function parseVarStatement(node2, kind, allowMissingInitializer) {
          if (allowMissingInitializer === void 0) {
            allowMissingInitializer = false;
          }
          var isAmbientContext = this.state.isAmbientContext;
          var declaration = _superClass.prototype.parseVarStatement.call(this, node2, kind, allowMissingInitializer || isAmbientContext);
          if (!isAmbientContext)
            return declaration;
          for (var _i22 = 0, _declaration$declarat2 = declaration.declarations; _i22 < _declaration$declarat2.length; _i22++) {
            var _declaration$declarat3 = _declaration$declarat2[_i22], id3 = _declaration$declarat3.id, init3 = _declaration$declarat3.init;
            if (!init3)
              continue;
            if (kind !== "const" || !!id3.typeAnnotation) {
              this.raise(TSErrors.InitializerNotAllowedInAmbientContext, {
                at: init3
              });
            } else if (init3.type !== "StringLiteral" && init3.type !== "BooleanLiteral" && init3.type !== "NumericLiteral" && init3.type !== "BigIntLiteral" && (init3.type !== "TemplateLiteral" || init3.expressions.length > 0) && !isPossiblyLiteralEnum(init3)) {
              this.raise(TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, {
                at: init3
              });
            }
          }
          return declaration;
        };
        _proto.parseStatementContent = function parseStatementContent(context, topLevel) {
          if (this.match(75) && this.isLookaheadContextual("enum")) {
            var node2 = this.startNode();
            this.expect(75);
            return this.tsParseEnumDeclaration(node2, {
              "const": true
            });
          }
          if (this.isContextual(122)) {
            return this.tsParseEnumDeclaration(this.startNode());
          }
          if (this.isContextual(125)) {
            var result = this.tsParseInterfaceDeclaration(this.startNode());
            if (result)
              return result;
          }
          return _superClass.prototype.parseStatementContent.call(this, context, topLevel);
        };
        _proto.parseAccessModifier = function parseAccessModifier() {
          return this.tsParseModifier(["public", "protected", "private"]);
        };
        _proto.tsHasSomeModifiers = function tsHasSomeModifiers(member, modifiers) {
          return modifiers.some(function(modifier) {
            if (tsIsAccessModifier(modifier)) {
              return member.accessibility === modifier;
            }
            return !!member[modifier];
          });
        };
        _proto.tsIsStartOfStaticBlocks = function tsIsStartOfStaticBlocks() {
          return this.isContextual(104) && this.lookaheadCharCode() === 123;
        };
        _proto.parseClassMember = function parseClassMember(classBody2, member, state) {
          var _this17 = this;
          var modifiers = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
          this.tsParseModifiers({
            modified: member,
            allowedModifiers: modifiers,
            stopOnStartOfClassStaticBlock: true
          });
          var callParseClassMemberWithIsStatic = function callParseClassMemberWithIsStatic2() {
            if (_this17.tsIsStartOfStaticBlocks()) {
              _this17.next();
              _this17.next();
              if (_this17.tsHasSomeModifiers(member, modifiers)) {
                _this17.raise(TSErrors.StaticBlockCannotHaveModifier, {
                  at: _this17.state.curPosition()
                });
              }
              _this17.parseClassStaticBlock(classBody2, member);
            } else {
              _this17.parseClassMemberWithIsStatic(classBody2, member, state, !!member["static"]);
            }
          };
          if (member.declare) {
            this.tsInAmbientContext(callParseClassMemberWithIsStatic);
          } else {
            callParseClassMemberWithIsStatic();
          }
        };
        _proto.parseClassMemberWithIsStatic = function parseClassMemberWithIsStatic(classBody2, member, state, isStatic2) {
          var idx = this.tsTryParseIndexSignature(member);
          if (idx) {
            classBody2.body.push(idx);
            if (member["abstract"]) {
              this.raise(TSErrors.IndexSignatureHasAbstract, {
                at: member
              });
            }
            if (member.accessibility) {
              this.raise(TSErrors.IndexSignatureHasAccessibility, {
                at: member,
                modifier: member.accessibility
              });
            }
            if (member.declare) {
              this.raise(TSErrors.IndexSignatureHasDeclare, {
                at: member
              });
            }
            if (member.override) {
              this.raise(TSErrors.IndexSignatureHasOverride, {
                at: member
              });
            }
            return;
          }
          if (!this.state.inAbstractClass && member["abstract"]) {
            this.raise(TSErrors.NonAbstractClassHasAbstractMethod, {
              at: member
            });
          }
          if (member.override) {
            if (!state.hadSuperClass) {
              this.raise(TSErrors.OverrideNotInSubClass, {
                at: member
              });
            }
          }
          _superClass.prototype.parseClassMemberWithIsStatic.call(this, classBody2, member, state, isStatic2);
        };
        _proto.parsePostMemberNameModifiers = function parsePostMemberNameModifiers(methodOrProp) {
          var optional = this.eat(17);
          if (optional)
            methodOrProp.optional = true;
          if (methodOrProp.readonly && this.match(10)) {
            this.raise(TSErrors.ClassMethodHasReadonly, {
              at: methodOrProp
            });
          }
          if (methodOrProp.declare && this.match(10)) {
            this.raise(TSErrors.ClassMethodHasDeclare, {
              at: methodOrProp
            });
          }
        };
        _proto.parseExpressionStatement = function parseExpressionStatement(node2, expr) {
          var decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node2, expr) : void 0;
          return decl || _superClass.prototype.parseExpressionStatement.call(this, node2, expr);
        };
        _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
          if (this.tsIsDeclarationStart())
            return true;
          return _superClass.prototype.shouldParseExportDeclaration.call(this);
        };
        _proto.parseConditional = function parseConditional(expr, startPos, startLoc, refExpressionErrors) {
          var _this18 = this;
          if (!this.state.maybeInArrowParameters || !this.match(17)) {
            return _superClass.prototype.parseConditional.call(this, expr, startPos, startLoc, refExpressionErrors);
          }
          var result = this.tryParse(function() {
            return _superClass.prototype.parseConditional.call(_this18, expr, startPos, startLoc);
          });
          if (!result.node) {
            if (result.error) {
              _superClass.prototype.setOptionalParametersError.call(this, refExpressionErrors, result.error);
            }
            return expr;
          }
          if (result.error)
            this.state = result.failState;
          return result.node;
        };
        _proto.parseParenItem = function parseParenItem(node2, startPos, startLoc) {
          node2 = _superClass.prototype.parseParenItem.call(this, node2, startPos, startLoc);
          if (this.eat(17)) {
            node2.optional = true;
            this.resetEndLocation(node2);
          }
          if (this.match(14)) {
            var typeCastNode = this.startNodeAt(startPos, startLoc);
            typeCastNode.expression = node2;
            typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
            return this.finishNode(typeCastNode, "TSTypeCastExpression");
          }
          return node2;
        };
        _proto.parseExportDeclaration = function parseExportDeclaration(node2) {
          var _this19 = this;
          if (!this.state.isAmbientContext && this.isContextual(121)) {
            return this.tsInAmbientContext(function() {
              return _this19.parseExportDeclaration(node2);
            });
          }
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var isDeclare = this.eatContextual(121);
          if (isDeclare && (this.isContextual(121) || !this.shouldParseExportDeclaration())) {
            throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, {
              at: this.state.startLoc
            });
          }
          var isIdentifier2 = tokenIsIdentifier(this.state.type);
          var declaration = isIdentifier2 && this.tsTryParseExportDeclaration() || _superClass.prototype.parseExportDeclaration.call(this, node2);
          if (!declaration)
            return null;
          if (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare) {
            node2.exportKind = "type";
          }
          if (isDeclare) {
            this.resetStartLocation(declaration, startPos, startLoc);
            declaration.declare = true;
          }
          return declaration;
        };
        _proto.parseClassId = function parseClassId(node2, isStatement2, optionalId) {
          if ((!isStatement2 || optionalId) && this.isContextual(110)) {
            return;
          }
          _superClass.prototype.parseClassId.call(this, node2, isStatement2, optionalId, node2.declare ? BIND_TS_AMBIENT : BIND_CLASS);
          var typeParameters = this.tsTryParseTypeParameters();
          if (typeParameters)
            node2.typeParameters = typeParameters;
        };
        _proto.parseClassPropertyAnnotation = function parseClassPropertyAnnotation(node2) {
          if (!node2.optional && this.eat(35)) {
            node2.definite = true;
          }
          var type5 = this.tsTryParseTypeAnnotation();
          if (type5)
            node2.typeAnnotation = type5;
        };
        _proto.parseClassProperty = function parseClassProperty(node2) {
          this.parseClassPropertyAnnotation(node2);
          if (this.state.isAmbientContext && this.match(29)) {
            this.raise(TSErrors.DeclareClassFieldHasInitializer, {
              at: this.state.startLoc
            });
          }
          if (node2["abstract"] && this.match(29)) {
            var _key2 = node2.key;
            this.raise(TSErrors.AbstractPropertyHasInitializer, {
              at: this.state.startLoc,
              propertyName: _key2.type === "Identifier" && !node2.computed ? _key2.name : "[" + this.input.slice(_key2.start, _key2.end) + "]"
            });
          }
          return _superClass.prototype.parseClassProperty.call(this, node2);
        };
        _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node2) {
          if (node2["abstract"]) {
            this.raise(TSErrors.PrivateElementHasAbstract, {
              at: node2
            });
          }
          if (node2.accessibility) {
            this.raise(TSErrors.PrivateElementHasAccessibility, {
              at: node2,
              modifier: node2.accessibility
            });
          }
          this.parseClassPropertyAnnotation(node2);
          return _superClass.prototype.parseClassPrivateProperty.call(this, node2);
        };
        _proto.pushClassMethod = function pushClassMethod(classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper) {
          var typeParameters = this.tsTryParseTypeParameters();
          if (typeParameters && isConstructor) {
            this.raise(TSErrors.ConstructorHasTypeParameters, {
              at: typeParameters
            });
          }
          var _method$declare = method5.declare, declare2 = _method$declare === void 0 ? false : _method$declare, kind = method5.kind;
          if (declare2 && (kind === "get" || kind === "set")) {
            this.raise(TSErrors.DeclareAccessor, {
              at: method5,
              kind
            });
          }
          if (typeParameters)
            method5.typeParameters = typeParameters;
          _superClass.prototype.pushClassMethod.call(this, classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper);
        };
        _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody2, method5, isGenerator, isAsync2) {
          var typeParameters = this.tsTryParseTypeParameters();
          if (typeParameters)
            method5.typeParameters = typeParameters;
          _superClass.prototype.pushClassPrivateMethod.call(this, classBody2, method5, isGenerator, isAsync2);
        };
        _proto.declareClassPrivateMethodInScope = function declareClassPrivateMethodInScope(node2, kind) {
          if (node2.type === "TSDeclareMethod")
            return;
          if (node2.type === "MethodDefinition" && !node2.value.body)
            return;
          _superClass.prototype.declareClassPrivateMethodInScope.call(this, node2, kind);
        };
        _proto.parseClassSuper = function parseClassSuper(node2) {
          _superClass.prototype.parseClassSuper.call(this, node2);
          if (node2.superClass && (this.match(47) || this.match(51))) {
            node2.superTypeParameters = this.tsParseTypeArgumentsInExpression();
          }
          if (this.eatContextual(110)) {
            node2["implements"] = this.tsParseHeritageClause("implements");
          }
        };
        _proto.parseObjPropValue = function parseObjPropValue(prop2) {
          var _superClass$prototype2;
          var typeParameters = this.tsTryParseTypeParameters();
          if (typeParameters)
            prop2.typeParameters = typeParameters;
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key3 = 1; _key3 < _len2; _key3++) {
            args[_key3 - 1] = arguments[_key3];
          }
          (_superClass$prototype2 = _superClass.prototype.parseObjPropValue).call.apply(_superClass$prototype2, [this, prop2].concat(args));
        };
        _proto.parseFunctionParams = function parseFunctionParams(node2, allowModifiers) {
          var typeParameters = this.tsTryParseTypeParameters();
          if (typeParameters)
            node2.typeParameters = typeParameters;
          _superClass.prototype.parseFunctionParams.call(this, node2, allowModifiers);
        };
        _proto.parseVarId = function parseVarId(decl, kind) {
          _superClass.prototype.parseVarId.call(this, decl, kind);
          if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
            decl.definite = true;
          }
          var type5 = this.tsTryParseTypeAnnotation();
          if (type5) {
            decl.id.typeAnnotation = type5;
            this.resetEndLocation(decl.id);
          }
        };
        _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node2, call3) {
          if (this.match(14)) {
            node2.returnType = this.tsParseTypeAnnotation();
          }
          return _superClass.prototype.parseAsyncArrowFromCallExpression.call(this, node2, call3);
        };
        _proto.parseMaybeAssign = function parseMaybeAssign() {
          var _this20 = this, _jsx, _jsx2, _typeCast, _jsx3, _typeCast2, _jsx4, _typeCast3;
          for (var _len3 = arguments.length, args = new Array(_len3), _key4 = 0; _key4 < _len3; _key4++) {
            args[_key4] = arguments[_key4];
          }
          var state;
          var jsx3;
          var typeCast;
          if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
            state = this.state.clone();
            jsx3 = this.tryParse(function() {
              var _superClass$prototype3;
              return (_superClass$prototype3 = _superClass.prototype.parseMaybeAssign).call.apply(_superClass$prototype3, [_this20].concat(args));
            }, state);
            if (!jsx3.error)
              return jsx3.node;
            var context = this.state.context;
            var currentContext = context[context.length - 1];
            if (currentContext === types2.j_oTag || currentContext === types2.j_expr) {
              context.pop();
            }
          }
          if (!((_jsx = jsx3) != null && _jsx.error) && !this.match(47)) {
            var _superClass$prototype4;
            return (_superClass$prototype4 = _superClass.prototype.parseMaybeAssign).call.apply(_superClass$prototype4, [this].concat(args));
          }
          var typeParameters;
          state = state || this.state.clone();
          var arrow = this.tryParse(function(abort) {
            var _superClass$prototype5, _expr$extra, _typeParameters, _expr$typeParameters$;
            typeParameters = _this20.tsParseTypeParameters();
            var expr = (_superClass$prototype5 = _superClass.prototype.parseMaybeAssign).call.apply(_superClass$prototype5, [_this20].concat(args));
            if (expr.type !== "ArrowFunctionExpression" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
              abort();
            }
            if (((_typeParameters = typeParameters) == null ? void 0 : _typeParameters.params.length) !== 0) {
              _this20.resetStartLocationFromNode(expr, typeParameters);
            }
            expr.typeParameters = typeParameters;
            if (_this20.hasPlugin("jsx") && expr.typeParameters.params.length === 1 && !((_expr$typeParameters$ = expr.typeParameters.extra) != null && _expr$typeParameters$.trailingComma)) {
              var parameter = expr.typeParameters.params[0];
              if (!parameter.constraint)
                ;
            }
            return expr;
          }, state);
          if (!arrow.error && !arrow.aborted) {
            if (typeParameters)
              this.reportReservedArrowTypeParam(typeParameters);
            return arrow.node;
          }
          if (!jsx3) {
            assert$2(!this.hasPlugin("jsx"));
            typeCast = this.tryParse(function() {
              var _superClass$prototype6;
              return (_superClass$prototype6 = _superClass.prototype.parseMaybeAssign).call.apply(_superClass$prototype6, [_this20].concat(args));
            }, state);
            if (!typeCast.error)
              return typeCast.node;
          }
          if ((_jsx2 = jsx3) != null && _jsx2.node) {
            this.state = jsx3.failState;
            return jsx3.node;
          }
          if (arrow.node) {
            this.state = arrow.failState;
            if (typeParameters)
              this.reportReservedArrowTypeParam(typeParameters);
            return arrow.node;
          }
          if ((_typeCast = typeCast) != null && _typeCast.node) {
            this.state = typeCast.failState;
            return typeCast.node;
          }
          if ((_jsx3 = jsx3) != null && _jsx3.thrown)
            throw jsx3.error;
          if (arrow.thrown)
            throw arrow.error;
          if ((_typeCast2 = typeCast) != null && _typeCast2.thrown)
            throw typeCast.error;
          throw ((_jsx4 = jsx3) == null ? void 0 : _jsx4.error) || arrow.error || ((_typeCast3 = typeCast) == null ? void 0 : _typeCast3.error);
        };
        _proto.reportReservedArrowTypeParam = function reportReservedArrowTypeParam(node2) {
          var _node$extra;
          if (node2.params.length === 1 && !((_node$extra = node2.extra) != null && _node$extra.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
            this.raise(TSErrors.ReservedArrowTypeParam, {
              at: node2
            });
          }
        };
        _proto.parseMaybeUnary = function parseMaybeUnary(refExpressionErrors) {
          if (!this.hasPlugin("jsx") && this.match(47)) {
            return this.tsParseTypeAssertion();
          } else {
            return _superClass.prototype.parseMaybeUnary.call(this, refExpressionErrors);
          }
        };
        _proto.parseArrow = function parseArrow(node2) {
          var _this21 = this;
          if (this.match(14)) {
            var result = this.tryParse(function(abort) {
              var returnType = _this21.tsParseTypeOrTypePredicateAnnotation(14);
              if (_this21.canInsertSemicolon() || !_this21.match(19))
                abort();
              return returnType;
            });
            if (result.aborted)
              return;
            if (!result.thrown) {
              if (result.error)
                this.state = result.failState;
              node2.returnType = result.node;
            }
          }
          return _superClass.prototype.parseArrow.call(this, node2);
        };
        _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param) {
          if (this.eat(17)) {
            if (param.type !== "Identifier" && !this.state.isAmbientContext && !this.state.inType) {
              this.raise(TSErrors.PatternIsOptional, {
                at: param
              });
            }
            param.optional = true;
          }
          var type5 = this.tsTryParseTypeAnnotation();
          if (type5)
            param.typeAnnotation = type5;
          this.resetEndLocation(param);
          return param;
        };
        _proto.isAssignable = function isAssignable(node2, isBinding2) {
          switch (node2.type) {
            case "TSTypeCastExpression":
              return this.isAssignable(node2.expression, isBinding2);
            case "TSParameterProperty":
              return true;
            default:
              return _superClass.prototype.isAssignable.call(this, node2, isBinding2);
          }
        };
        _proto.toAssignable = function toAssignable(node2, isLHS) {
          if (isLHS === void 0) {
            isLHS = false;
          }
          switch (node2.type) {
            case "TSTypeCastExpression":
              return _superClass.prototype.toAssignable.call(this, this.typeCastToParameter(node2), isLHS);
            case "TSParameterProperty":
              return _superClass.prototype.toAssignable.call(this, node2, isLHS);
            case "ParenthesizedExpression":
              return this.toAssignableParenthesizedExpression(node2, isLHS);
            case "TSAsExpression":
            case "TSNonNullExpression":
            case "TSTypeAssertion":
              node2.expression = this.toAssignable(node2.expression, isLHS);
              return node2;
            default:
              return _superClass.prototype.toAssignable.call(this, node2, isLHS);
          }
        };
        _proto.toAssignableParenthesizedExpression = function toAssignableParenthesizedExpression(node2, isLHS) {
          switch (node2.expression.type) {
            case "TSAsExpression":
            case "TSNonNullExpression":
            case "TSTypeAssertion":
            case "ParenthesizedExpression":
              node2.expression = this.toAssignable(node2.expression, isLHS);
              return node2;
            default:
              return _superClass.prototype.toAssignable.call(this, node2, isLHS);
          }
        };
        _proto.isValidLVal = function isValidLVal(type5, isParenthesized, binding2) {
          return getOwn$1({
            TSTypeCastExpression: true,
            TSParameterProperty: "parameter",
            TSNonNullExpression: "expression",
            TSAsExpression: (binding2 !== BIND_NONE2 || isParenthesized) && ["expression", true],
            TSTypeAssertion: (binding2 !== BIND_NONE2 || isParenthesized) && ["expression", true]
          }, type5) || _superClass.prototype.isValidLVal.call(this, type5, isParenthesized, binding2);
        };
        _proto.parseBindingAtom = function parseBindingAtom() {
          switch (this.state.type) {
            case 78:
              return this.parseIdentifier(true);
            default:
              return _superClass.prototype.parseBindingAtom.call(this);
          }
        };
        _proto.parseMaybeDecoratorArguments = function parseMaybeDecoratorArguments(expr) {
          if (this.match(47) || this.match(51)) {
            var typeArguments = this.tsParseTypeArgumentsInExpression();
            if (this.match(10)) {
              var call3 = _superClass.prototype.parseMaybeDecoratorArguments.call(this, expr);
              call3.typeParameters = typeArguments;
              return call3;
            }
            this.unexpected(null, 10);
          }
          return _superClass.prototype.parseMaybeDecoratorArguments.call(this, expr);
        };
        _proto.checkCommaAfterRest = function checkCommaAfterRest(close) {
          if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
            this.next();
            return false;
          } else {
            return _superClass.prototype.checkCommaAfterRest.call(this, close);
          }
        };
        _proto.isClassMethod = function isClassMethod2() {
          return this.match(47) || _superClass.prototype.isClassMethod.call(this);
        };
        _proto.isClassProperty = function isClassProperty2() {
          return this.match(35) || this.match(14) || _superClass.prototype.isClassProperty.call(this);
        };
        _proto.parseMaybeDefault = function parseMaybeDefault() {
          var _superClass$prototype7;
          for (var _len4 = arguments.length, args = new Array(_len4), _key5 = 0; _key5 < _len4; _key5++) {
            args[_key5] = arguments[_key5];
          }
          var node2 = (_superClass$prototype7 = _superClass.prototype.parseMaybeDefault).call.apply(_superClass$prototype7, [this].concat(args));
          if (node2.type === "AssignmentPattern" && node2.typeAnnotation && node2.right.start < node2.typeAnnotation.start) {
            this.raise(TSErrors.TypeAnnotationAfterAssign, {
              at: node2.typeAnnotation
            });
          }
          return node2;
        };
        _proto.getTokenFromCode = function getTokenFromCode(code3) {
          if (this.state.inType) {
            if (code3 === 62) {
              return this.finishOp(48, 1);
            }
            if (code3 === 60) {
              return this.finishOp(47, 1);
            }
          }
          return _superClass.prototype.getTokenFromCode.call(this, code3);
        };
        _proto.reScan_lt_gt = function reScan_lt_gt() {
          var type5 = this.state.type;
          if (type5 === 47) {
            this.state.pos -= 1;
            this.readToken_lt();
          } else if (type5 === 48) {
            this.state.pos -= 1;
            this.readToken_gt();
          }
        };
        _proto.reScan_lt = function reScan_lt() {
          var type5 = this.state.type;
          if (type5 === 51) {
            this.state.pos -= 2;
            this.finishOp(47, 1);
            return 47;
          }
          return type5;
        };
        _proto.toAssignableList = function toAssignableList(exprList) {
          for (var i2 = 0; i2 < exprList.length; i2++) {
            var expr = exprList[i2];
            if (!expr)
              continue;
            switch (expr.type) {
              case "TSTypeCastExpression":
                exprList[i2] = this.typeCastToParameter(expr);
                break;
              case "TSAsExpression":
              case "TSTypeAssertion":
                if (!this.state.maybeInArrowParameters) {
                  exprList[i2] = this.typeCastToParameter(expr);
                } else {
                  this.raise(TSErrors.UnexpectedTypeCastInParameter, {
                    at: expr
                  });
                }
                break;
            }
          }
          return _superClass.prototype.toAssignableList.apply(this, arguments);
        };
        _proto.typeCastToParameter = function typeCastToParameter(node2) {
          node2.expression.typeAnnotation = node2.typeAnnotation;
          this.resetEndLocation(node2.expression, node2.typeAnnotation.loc.end);
          return node2.expression;
        };
        _proto.shouldParseArrow = function shouldParseArrow(params) {
          var _this22 = this;
          if (this.match(14)) {
            return params.every(function(expr) {
              return _this22.isAssignable(expr, true);
            });
          }
          return _superClass.prototype.shouldParseArrow.call(this, params);
        };
        _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
          return this.match(14) || _superClass.prototype.shouldParseAsyncArrow.call(this);
        };
        _proto.canHaveLeadingDecorator = function canHaveLeadingDecorator() {
          return _superClass.prototype.canHaveLeadingDecorator.call(this) || this.isAbstractClass();
        };
        _proto.jsxParseOpeningElementAfterName = function jsxParseOpeningElementAfterName(node2) {
          var _this23 = this;
          if (this.match(47) || this.match(51)) {
            var typeArguments = this.tsTryParseAndCatch(function() {
              return _this23.tsParseTypeArgumentsInExpression();
            });
            if (typeArguments)
              node2.typeParameters = typeArguments;
          }
          return _superClass.prototype.jsxParseOpeningElementAfterName.call(this, node2);
        };
        _proto.getGetterSetterExpectedParamCount = function getGetterSetterExpectedParamCount(method5) {
          var baseCount = _superClass.prototype.getGetterSetterExpectedParamCount.call(this, method5);
          var params = this.getObjectOrClassMethodParams(method5);
          var firstParam = params[0];
          var hasContextParam = firstParam && this.isThisParam(firstParam);
          return hasContextParam ? baseCount + 1 : baseCount;
        };
        _proto.parseCatchClauseParam = function parseCatchClauseParam() {
          var param = _superClass.prototype.parseCatchClauseParam.call(this);
          var type5 = this.tsTryParseTypeAnnotation();
          if (type5) {
            param.typeAnnotation = type5;
            this.resetEndLocation(param);
          }
          return param;
        };
        _proto.tsInAmbientContext = function tsInAmbientContext(cb2) {
          var oldIsAmbientContext = this.state.isAmbientContext;
          this.state.isAmbientContext = true;
          try {
            return cb2();
          } finally {
            this.state.isAmbientContext = oldIsAmbientContext;
          }
        };
        _proto.parseClass = function parseClass(node2) {
          var oldInAbstractClass = this.state.inAbstractClass;
          this.state.inAbstractClass = !!node2["abstract"];
          try {
            var _superClass$prototype8;
            for (var _len5 = arguments.length, args = new Array(_len5 > 1 ? _len5 - 1 : 0), _key6 = 1; _key6 < _len5; _key6++) {
              args[_key6 - 1] = arguments[_key6];
            }
            return (_superClass$prototype8 = _superClass.prototype.parseClass).call.apply(_superClass$prototype8, [this, node2].concat(args));
          } finally {
            this.state.inAbstractClass = oldInAbstractClass;
          }
        };
        _proto.tsParseAbstractDeclaration = function tsParseAbstractDeclaration(node2) {
          if (this.match(80)) {
            node2["abstract"] = true;
            return this.parseClass(node2, true, false);
          } else if (this.isContextual(125)) {
            if (!this.hasFollowingLineBreak()) {
              node2["abstract"] = true;
              this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, {
                at: node2
              });
              return this.tsParseInterfaceDeclaration(node2);
            }
          } else {
            this.unexpected(null, 80);
          }
        };
        _proto.parseMethod = function parseMethod() {
          var _superClass$prototype9;
          for (var _len6 = arguments.length, args = new Array(_len6), _key7 = 0; _key7 < _len6; _key7++) {
            args[_key7] = arguments[_key7];
          }
          var method5 = (_superClass$prototype9 = _superClass.prototype.parseMethod).call.apply(_superClass$prototype9, [this].concat(args));
          if (method5["abstract"]) {
            var hasBody = this.hasPlugin("estree") ? !!method5.value.body : !!method5.body;
            if (hasBody) {
              var _key8 = method5.key;
              this.raise(TSErrors.AbstractMethodHasImplementation, {
                at: method5,
                methodName: _key8.type === "Identifier" && !method5.computed ? _key8.name : "[" + this.input.slice(_key8.start, _key8.end) + "]"
              });
            }
          }
          return method5;
        };
        _proto.tsParseTypeParameterName = function tsParseTypeParameterName() {
          var typeName = this.parseIdentifier();
          return typeName.name;
        };
        _proto.shouldParseAsAmbientContext = function shouldParseAsAmbientContext() {
          return !!this.getPluginOption("typescript", "dts");
        };
        _proto.parse = function parse5() {
          if (this.shouldParseAsAmbientContext()) {
            this.state.isAmbientContext = true;
          }
          return _superClass.prototype.parse.call(this);
        };
        _proto.getExpression = function getExpression() {
          if (this.shouldParseAsAmbientContext()) {
            this.state.isAmbientContext = true;
          }
          return _superClass.prototype.getExpression.call(this);
        };
        _proto.parseExportSpecifier = function parseExportSpecifier(node2, isString2, isInTypeExport, isMaybeTypeOnly) {
          if (!isString2 && isMaybeTypeOnly) {
            this.parseTypeOnlyImportExportSpecifier(node2, false, isInTypeExport);
            return this.finishNode(node2, "ExportSpecifier");
          }
          node2.exportKind = "value";
          return _superClass.prototype.parseExportSpecifier.call(this, node2, isString2, isInTypeExport, isMaybeTypeOnly);
        };
        _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
          if (!importedIsString && isMaybeTypeOnly) {
            this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
            return this.finishNode(specifier, "ImportSpecifier");
          }
          specifier.importKind = "value";
          return _superClass.prototype.parseImportSpecifier.call(this, specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly);
        };
        _proto.parseTypeOnlyImportExportSpecifier = function parseTypeOnlyImportExportSpecifier(node2, isImport2, isInTypeOnlyImportExport) {
          var leftOfAsKey = isImport2 ? "imported" : "local";
          var rightOfAsKey = isImport2 ? "local" : "exported";
          var leftOfAs = node2[leftOfAsKey];
          var rightOfAs;
          var hasTypeSpecifier = false;
          var canParseAsKeyword = true;
          var loc = leftOfAs.loc.start;
          if (this.isContextual(93)) {
            var firstAs = this.parseIdentifier();
            if (this.isContextual(93)) {
              var secondAs = this.parseIdentifier();
              if (tokenIsKeywordOrIdentifier(this.state.type)) {
                hasTypeSpecifier = true;
                leftOfAs = firstAs;
                rightOfAs = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
                canParseAsKeyword = false;
              } else {
                rightOfAs = secondAs;
                canParseAsKeyword = false;
              }
            } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
              canParseAsKeyword = false;
              rightOfAs = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
            } else {
              hasTypeSpecifier = true;
              leftOfAs = firstAs;
            }
          } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
            hasTypeSpecifier = true;
            leftOfAs = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
          }
          if (hasTypeSpecifier && isInTypeOnlyImportExport) {
            this.raise(isImport2 ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, {
              at: loc
            });
          }
          node2[leftOfAsKey] = leftOfAs;
          node2[rightOfAsKey] = rightOfAs;
          var kindKey = isImport2 ? "importKind" : "exportKind";
          node2[kindKey] = hasTypeSpecifier ? "type" : "value";
          if (canParseAsKeyword && this.eatContextual(93)) {
            node2[rightOfAsKey] = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
          }
          if (!node2[rightOfAsKey]) {
            node2[rightOfAsKey] = cloneIdentifier(node2[leftOfAsKey]);
          }
          if (isImport2) {
            this.checkIdentifier(node2[rightOfAsKey], BIND_LEXICAL2);
          }
        };
        return _createClass2(_class);
      }(superClass);
    };
    function isPossiblyLiteralEnum(expression2) {
      if (expression2.type !== "MemberExpression")
        return false;
      var computed = expression2.computed, property2 = expression2.property;
      if (computed && property2.type !== "StringLiteral" && (property2.type !== "TemplateLiteral" || property2.expressions.length > 0)) {
        return false;
      }
      return isUncomputedMemberExpressionChain(expression2.object);
    }
    function isUncomputedMemberExpressionChain(expression2) {
      if (expression2.type === "Identifier")
        return true;
      if (expression2.type !== "MemberExpression")
        return false;
      if (expression2.computed)
        return false;
      return isUncomputedMemberExpressionChain(expression2.object);
    }
    var _templateObject$p;
    var PlaceholderErrors = ParseErrorEnum(_templateObject$p || (_templateObject$p = _taggedTemplateLiteralLoose(["placeholders"])))(function(_) {
      return {
        ClassNameIsRequired: _("A class name is required."),
        UnexpectedSpace: _("Unexpected space in placeholder.")
      };
    });
    var placeholders = function(superClass) {
      return function(_superClass) {
        _inherits2(_class, _superClass);
        function _class() {
          return _superClass.apply(this, arguments) || this;
        }
        var _proto = _class.prototype;
        _proto.parsePlaceholder = function parsePlaceholder(expectedNode) {
          if (this.match(140)) {
            var node2 = this.startNode();
            this.next();
            this.assertNoSpace();
            node2.name = _superClass.prototype.parseIdentifier.call(this, true);
            this.assertNoSpace();
            this.expect(140);
            return this.finishPlaceholder(node2, expectedNode);
          }
        };
        _proto.finishPlaceholder = function finishPlaceholder(node2, expectedNode) {
          var isFinished = !!(node2.expectedNode && node2.type === "Placeholder");
          node2.expectedNode = expectedNode;
          return isFinished ? node2 : this.finishNode(node2, "Placeholder");
        };
        _proto.getTokenFromCode = function getTokenFromCode(code3) {
          if (code3 === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
            return this.finishOp(140, 2);
          }
          return _superClass.prototype.getTokenFromCode.apply(this, arguments);
        };
        _proto.parseExprAtom = function parseExprAtom() {
          return this.parsePlaceholder("Expression") || _superClass.prototype.parseExprAtom.apply(this, arguments);
        };
        _proto.parseIdentifier = function parseIdentifier() {
          return this.parsePlaceholder("Identifier") || _superClass.prototype.parseIdentifier.apply(this, arguments);
        };
        _proto.checkReservedWord = function checkReservedWord(word) {
          if (word !== void 0)
            _superClass.prototype.checkReservedWord.apply(this, arguments);
        };
        _proto.parseBindingAtom = function parseBindingAtom() {
          return this.parsePlaceholder("Pattern") || _superClass.prototype.parseBindingAtom.apply(this, arguments);
        };
        _proto.isValidLVal = function isValidLVal(type5) {
          var _superClass$prototype;
          for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            rest[_key - 1] = arguments[_key];
          }
          return type5 === "Placeholder" || (_superClass$prototype = _superClass.prototype.isValidLVal).call.apply(_superClass$prototype, [this, type5].concat(rest));
        };
        _proto.toAssignable = function toAssignable(node2) {
          if (node2 && node2.type === "Placeholder" && node2.expectedNode === "Expression") {
            node2.expectedNode = "Pattern";
            return node2;
          }
          return _superClass.prototype.toAssignable.apply(this, arguments);
        };
        _proto.isLet = function isLet2(context) {
          if (_superClass.prototype.isLet.call(this, context)) {
            return true;
          }
          if (!this.isContextual(99)) {
            return false;
          }
          if (context)
            return false;
          var nextToken = this.lookahead();
          if (nextToken.type === 140) {
            return true;
          }
          return false;
        };
        _proto.verifyBreakContinue = function verifyBreakContinue(node2) {
          if (node2.label && node2.label.type === "Placeholder")
            return;
          _superClass.prototype.verifyBreakContinue.apply(this, arguments);
        };
        _proto.parseExpressionStatement = function parseExpressionStatement(node2, expr) {
          if (expr.type !== "Placeholder" || expr.extra && expr.extra.parenthesized) {
            return _superClass.prototype.parseExpressionStatement.apply(this, arguments);
          }
          if (this.match(14)) {
            var stmt = node2;
            stmt.label = this.finishPlaceholder(expr, "Identifier");
            this.next();
            stmt.body = this.parseStatement("label");
            return this.finishNode(stmt, "LabeledStatement");
          }
          this.semicolon();
          node2.name = expr.name;
          return this.finishPlaceholder(node2, "Statement");
        };
        _proto.parseBlock = function parseBlock() {
          return this.parsePlaceholder("BlockStatement") || _superClass.prototype.parseBlock.apply(this, arguments);
        };
        _proto.parseFunctionId = function parseFunctionId() {
          return this.parsePlaceholder("Identifier") || _superClass.prototype.parseFunctionId.apply(this, arguments);
        };
        _proto.parseClass = function parseClass(node2, isStatement2, optionalId) {
          var type5 = isStatement2 ? "ClassDeclaration" : "ClassExpression";
          this.next();
          this.takeDecorators(node2);
          var oldStrict = this.state.strict;
          var placeholder2 = this.parsePlaceholder("Identifier");
          if (placeholder2) {
            if (this.match(81) || this.match(140) || this.match(5)) {
              node2.id = placeholder2;
            } else if (optionalId || !isStatement2) {
              node2.id = null;
              node2.body = this.finishPlaceholder(placeholder2, "ClassBody");
              return this.finishNode(node2, type5);
            } else {
              throw this.raise(PlaceholderErrors.ClassNameIsRequired, {
                at: this.state.startLoc
              });
            }
          } else {
            this.parseClassId(node2, isStatement2, optionalId);
          }
          this.parseClassSuper(node2);
          node2.body = this.parsePlaceholder("ClassBody") || this.parseClassBody(!!node2.superClass, oldStrict);
          return this.finishNode(node2, type5);
        };
        _proto.parseExport = function parseExport(node2) {
          var placeholder2 = this.parsePlaceholder("Identifier");
          if (!placeholder2)
            return _superClass.prototype.parseExport.apply(this, arguments);
          if (!this.isContextual(97) && !this.match(12)) {
            node2.specifiers = [];
            node2.source = null;
            node2.declaration = this.finishPlaceholder(placeholder2, "Declaration");
            return this.finishNode(node2, "ExportNamedDeclaration");
          }
          this.expectPlugin("exportDefaultFrom");
          var specifier = this.startNode();
          specifier.exported = placeholder2;
          node2.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
          return _superClass.prototype.parseExport.call(this, node2);
        };
        _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier2() {
          if (this.match(65)) {
            var next = this.nextTokenStart();
            if (this.isUnparsedContextual(next, "from")) {
              if (this.input.startsWith(tokenLabelName(140), this.nextTokenStartSince(next + 4))) {
                return true;
              }
            }
          }
          return _superClass.prototype.isExportDefaultSpecifier.call(this);
        };
        _proto.maybeParseExportDefaultSpecifier = function maybeParseExportDefaultSpecifier(node2) {
          if (node2.specifiers && node2.specifiers.length > 0) {
            return true;
          }
          return _superClass.prototype.maybeParseExportDefaultSpecifier.apply(this, arguments);
        };
        _proto.checkExport = function checkExport(node2) {
          var specifiers = node2.specifiers;
          if (specifiers != null && specifiers.length) {
            node2.specifiers = specifiers.filter(function(node3) {
              return node3.exported.type === "Placeholder";
            });
          }
          _superClass.prototype.checkExport.call(this, node2);
          node2.specifiers = specifiers;
        };
        _proto.parseImport = function parseImport(node2) {
          var placeholder2 = this.parsePlaceholder("Identifier");
          if (!placeholder2)
            return _superClass.prototype.parseImport.apply(this, arguments);
          node2.specifiers = [];
          if (!this.isContextual(97) && !this.match(12)) {
            node2.source = this.finishPlaceholder(placeholder2, "StringLiteral");
            this.semicolon();
            return this.finishNode(node2, "ImportDeclaration");
          }
          var specifier = this.startNodeAtNode(placeholder2);
          specifier.local = placeholder2;
          this.finishNode(specifier, "ImportDefaultSpecifier");
          node2.specifiers.push(specifier);
          if (this.eat(12)) {
            var hasStarImport = this.maybeParseStarImportSpecifier(node2);
            if (!hasStarImport)
              this.parseNamedImportSpecifiers(node2);
          }
          this.expectContextual(97);
          node2.source = this.parseImportSource();
          this.semicolon();
          return this.finishNode(node2, "ImportDeclaration");
        };
        _proto.parseImportSource = function parseImportSource() {
          return this.parsePlaceholder("StringLiteral") || _superClass.prototype.parseImportSource.apply(this, arguments);
        };
        _proto.assertNoSpace = function assertNoSpace() {
          if (this.state.start > this.state.lastTokEndLoc.index) {
            this.raise(PlaceholderErrors.UnexpectedSpace, {
              at: this.state.lastTokEndLoc
            });
          }
        };
        return _createClass2(_class);
      }(superClass);
    };
    var v8intrinsic = function(superClass) {
      return function(_superClass) {
        _inherits2(_class, _superClass);
        function _class() {
          return _superClass.apply(this, arguments) || this;
        }
        var _proto = _class.prototype;
        _proto.parseV8Intrinsic = function parseV8Intrinsic() {
          if (this.match(54)) {
            var v8IntrinsicStartLoc = this.state.startLoc;
            var node2 = this.startNode();
            this.next();
            if (tokenIsIdentifier(this.state.type)) {
              var name2 = this.parseIdentifierName(this.state.start);
              var identifier2 = this.createIdentifier(node2, name2);
              identifier2.type = "V8IntrinsicIdentifier";
              if (this.match(10)) {
                return identifier2;
              }
            }
            this.unexpected(v8IntrinsicStartLoc);
          }
        };
        _proto.parseExprAtom = function parseExprAtom() {
          return this.parseV8Intrinsic() || _superClass.prototype.parseExprAtom.apply(this, arguments);
        };
        return _createClass2(_class);
      }(superClass);
    };
    function hasPlugin(plugins2, expectedConfig) {
      var _ref3 = typeof expectedConfig === "string" ? [expectedConfig, {}] : expectedConfig, expectedName = _ref3[0], expectedOptions = _ref3[1];
      var expectedKeys = Object.keys(expectedOptions);
      var expectedOptionsIsEmpty = expectedKeys.length === 0;
      return plugins2.some(function(p2) {
        if (typeof p2 === "string") {
          return expectedOptionsIsEmpty && p2 === expectedName;
        } else {
          var pluginName = p2[0], pluginOptions = p2[1];
          if (pluginName !== expectedName) {
            return false;
          }
          for (var _i22 = 0; _i22 < expectedKeys.length; _i22++) {
            var key2 = expectedKeys[_i22];
            if (pluginOptions[key2] !== expectedOptions[key2]) {
              return false;
            }
          }
          return true;
        }
      });
    }
    function getPluginOption(plugins2, name2, option) {
      var plugin2 = plugins2.find(function(plugin3) {
        if (Array.isArray(plugin3)) {
          return plugin3[0] === name2;
        } else {
          return plugin3 === name2;
        }
      });
      if (plugin2 && Array.isArray(plugin2)) {
        return plugin2[1][option];
      }
      return null;
    }
    var PIPELINE_PROPOSALS$1 = ["minimal", "fsharp", "hack", "smart"];
    var TOPIC_TOKENS$1 = ["^^", "@@", "^", "%", "#"];
    var RECORD_AND_TUPLE_SYNTAX_TYPES = ["hash", "bar"];
    function validatePlugins(plugins2) {
      if (hasPlugin(plugins2, "decorators")) {
        if (hasPlugin(plugins2, "decorators-legacy")) {
          throw new Error("Cannot use the decorators and decorators-legacy plugin together");
        }
        var decoratorsBeforeExport = getPluginOption(plugins2, "decorators", "decoratorsBeforeExport");
        if (decoratorsBeforeExport == null) {
          throw new Error("The 'decorators' plugin requires a 'decoratorsBeforeExport' option, whose value must be a boolean. If you are migrating from Babylon/Babel 6 or want to use the old decorators proposal, you should use the 'decorators-legacy' plugin instead of 'decorators'.");
        } else if (typeof decoratorsBeforeExport !== "boolean") {
          throw new Error("'decoratorsBeforeExport' must be a boolean.");
        }
      }
      if (hasPlugin(plugins2, "flow") && hasPlugin(plugins2, "typescript")) {
        throw new Error("Cannot combine flow and typescript plugins.");
      }
      if (hasPlugin(plugins2, "placeholders") && hasPlugin(plugins2, "v8intrinsic")) {
        throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
      }
      if (hasPlugin(plugins2, "pipelineOperator")) {
        var proposal = getPluginOption(plugins2, "pipelineOperator", "proposal");
        if (!PIPELINE_PROPOSALS$1.includes(proposal)) {
          var proposalList = PIPELINE_PROPOSALS$1.map(function(p2) {
            return '"' + p2 + '"';
          }).join(", ");
          throw new Error('"pipelineOperator" requires "proposal" option whose value must be one of: ' + proposalList + ".");
        }
        var tupleSyntaxIsHash = hasPlugin(plugins2, ["recordAndTuple", {
          syntaxType: "hash"
        }]);
        if (proposal === "hack") {
          if (hasPlugin(plugins2, "placeholders")) {
            throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
          }
          if (hasPlugin(plugins2, "v8intrinsic")) {
            throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
          }
          var topicToken = getPluginOption(plugins2, "pipelineOperator", "topicToken");
          if (!TOPIC_TOKENS$1.includes(topicToken)) {
            var tokenList = TOPIC_TOKENS$1.map(function(t3) {
              return '"' + t3 + '"';
            }).join(", ");
            throw new Error('"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ' + tokenList + ".");
          }
          if (topicToken === "#" && tupleSyntaxIsHash) {
            throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
          }
        } else if (proposal === "smart" && tupleSyntaxIsHash) {
          throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
        }
      }
      if (hasPlugin(plugins2, "moduleAttributes")) {
        {
          if (hasPlugin(plugins2, "importAssertions")) {
            throw new Error("Cannot combine importAssertions and moduleAttributes plugins.");
          }
          var moduleAttributesVerionPluginOption = getPluginOption(plugins2, "moduleAttributes", "version");
          if (moduleAttributesVerionPluginOption !== "may-2020") {
            throw new Error("The 'moduleAttributes' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is 'may-2020'.");
          }
        }
      }
      if (hasPlugin(plugins2, "recordAndTuple") && !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(getPluginOption(plugins2, "recordAndTuple", "syntaxType"))) {
        throw new Error("'recordAndTuple' requires 'syntaxType' option whose value should be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map(function(p2) {
          return "'" + p2 + "'";
        }).join(", "));
      }
      if (hasPlugin(plugins2, "asyncDoExpressions") && !hasPlugin(plugins2, "doExpressions")) {
        var error2 = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
        error2.missingPlugins = "doExpressions";
        throw error2;
      }
    }
    var mixinPlugins = {
      estree,
      jsx: jsx2,
      flow,
      typescript,
      v8intrinsic,
      placeholders
    };
    var mixinPluginNames = Object.keys(mixinPlugins);
    var defaultOptions2 = {
      sourceType: "script",
      sourceFilename: void 0,
      startColumn: 0,
      startLine: 1,
      allowAwaitOutsideFunction: false,
      allowReturnOutsideFunction: false,
      allowImportExportEverywhere: false,
      allowSuperOutsideMethod: false,
      allowUndeclaredExports: false,
      plugins: [],
      strictMode: null,
      ranges: false,
      tokens: false,
      createParenthesizedExpressions: false,
      errorRecovery: false,
      attachComment: true
    };
    function getOptions2(opts) {
      var options = {};
      for (var _i22 = 0, _Object$keys22 = Object.keys(defaultOptions2); _i22 < _Object$keys22.length; _i22++) {
        var key2 = _Object$keys22[_i22];
        options[key2] = opts && opts[key2] != null ? opts[key2] : defaultOptions2[key2];
      }
      return options;
    }
    var getOwn = function getOwn2(object4, key2) {
      return Object.hasOwnProperty.call(object4, key2) && object4[key2];
    };
    var unwrapParenthesizedExpression = function unwrapParenthesizedExpression2(node2) {
      return node2.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression2(node2.expression) : node2;
    };
    var LValParser = function(_NodeUtils) {
      _inherits2(LValParser2, _NodeUtils);
      function LValParser2() {
        return _NodeUtils.apply(this, arguments) || this;
      }
      var _proto = LValParser2.prototype;
      _proto.toAssignable = function toAssignable(node2, isLHS) {
        var _node$extra, _node$extra3;
        if (isLHS === void 0) {
          isLHS = false;
        }
        var parenthesized = void 0;
        if (node2.type === "ParenthesizedExpression" || (_node$extra = node2.extra) != null && _node$extra.parenthesized) {
          parenthesized = unwrapParenthesizedExpression(node2);
          if (isLHS) {
            if (parenthesized.type === "Identifier") {
              this.expressionScope.recordParenthesizedIdentifierError({
                at: node2
              });
            } else if (parenthesized.type !== "MemberExpression") {
              this.raise(Errors.InvalidParenthesizedAssignment, {
                at: node2
              });
            }
          } else {
            this.raise(Errors.InvalidParenthesizedAssignment, {
              at: node2
            });
          }
        }
        switch (node2.type) {
          case "Identifier":
          case "ObjectPattern":
          case "ArrayPattern":
          case "AssignmentPattern":
          case "RestElement":
            break;
          case "ObjectExpression":
            node2.type = "ObjectPattern";
            for (var i2 = 0, length = node2.properties.length, last2 = length - 1; i2 < length; i2++) {
              var _node$extra2;
              var prop2 = node2.properties[i2];
              var isLast = i2 === last2;
              this.toAssignableObjectExpressionProp(prop2, isLast, isLHS);
              if (isLast && prop2.type === "RestElement" && (_node$extra2 = node2.extra) != null && _node$extra2.trailingCommaLoc) {
                this.raise(Errors.RestTrailingComma, {
                  at: node2.extra.trailingCommaLoc
                });
              }
            }
            break;
          case "ObjectProperty": {
            var key2 = node2.key, value = node2.value;
            if (this.isPrivateName(key2)) {
              this.classScope.usePrivateName(this.getPrivateNameSV(key2), key2.loc.start);
            }
            this.toAssignable(value, isLHS);
            break;
          }
          case "SpreadElement": {
            this.checkToRestConversion(node2);
            node2.type = "RestElement";
            var arg = node2.argument;
            this.toAssignable(arg, isLHS);
            break;
          }
          case "ArrayExpression":
            node2.type = "ArrayPattern";
            this.toAssignableList(node2.elements, (_node$extra3 = node2.extra) == null ? void 0 : _node$extra3.trailingCommaLoc, isLHS);
            break;
          case "AssignmentExpression":
            if (node2.operator !== "=") {
              this.raise(Errors.MissingEqInAssignment, {
                at: node2.left.loc.end
              });
            }
            node2.type = "AssignmentPattern";
            delete node2.operator;
            this.toAssignable(node2.left, isLHS);
            break;
          case "ParenthesizedExpression":
            this.toAssignable(parenthesized, isLHS);
            break;
        }
        return node2;
      };
      _proto.toAssignableObjectExpressionProp = function toAssignableObjectExpressionProp(prop2, isLast, isLHS) {
        if (prop2.type === "ObjectMethod") {
          this.raise(prop2.kind === "get" || prop2.kind === "set" ? Errors.PatternHasAccessor : Errors.PatternHasMethod, {
            at: prop2.key
          });
        } else if (prop2.type === "SpreadElement" && !isLast) {
          this.raise(Errors.RestTrailingComma, {
            at: prop2
          });
        } else {
          this.toAssignable(prop2, isLHS);
        }
      };
      _proto.toAssignableList = function toAssignableList(exprList, trailingCommaLoc, isLHS) {
        var end2 = exprList.length;
        if (end2) {
          var last2 = exprList[end2 - 1];
          if ((last2 == null ? void 0 : last2.type) === "RestElement") {
            --end2;
          } else if ((last2 == null ? void 0 : last2.type) === "SpreadElement") {
            last2.type = "RestElement";
            var arg = last2.argument;
            this.toAssignable(arg, isLHS);
            arg = unwrapParenthesizedExpression(arg);
            if (arg.type !== "Identifier" && arg.type !== "MemberExpression" && arg.type !== "ArrayPattern" && arg.type !== "ObjectPattern") {
              this.unexpected(arg.start);
            }
            if (trailingCommaLoc) {
              this.raise(Errors.RestTrailingComma, {
                at: trailingCommaLoc
              });
            }
            --end2;
          }
        }
        for (var i2 = 0; i2 < end2; i2++) {
          var elt = exprList[i2];
          if (elt) {
            this.toAssignable(elt, isLHS);
            if (elt.type === "RestElement") {
              this.raise(Errors.RestTrailingComma, {
                at: elt
              });
            }
          }
        }
        return exprList;
      };
      _proto.isAssignable = function isAssignable(node2, isBinding2) {
        var _this = this;
        switch (node2.type) {
          case "Identifier":
          case "ObjectPattern":
          case "ArrayPattern":
          case "AssignmentPattern":
          case "RestElement":
            return true;
          case "ObjectExpression": {
            var last2 = node2.properties.length - 1;
            return node2.properties.every(function(prop2, i2) {
              return prop2.type !== "ObjectMethod" && (i2 === last2 || prop2.type !== "SpreadElement") && _this.isAssignable(prop2);
            });
          }
          case "ObjectProperty":
            return this.isAssignable(node2.value);
          case "SpreadElement":
            return this.isAssignable(node2.argument);
          case "ArrayExpression":
            return node2.elements.every(function(element) {
              return element === null || _this.isAssignable(element);
            });
          case "AssignmentExpression":
            return node2.operator === "=";
          case "ParenthesizedExpression":
            return this.isAssignable(node2.expression);
          case "MemberExpression":
          case "OptionalMemberExpression":
            return !isBinding2;
          default:
            return false;
        }
      };
      _proto.toReferencedList = function toReferencedList(exprList, isParenthesizedExpr) {
        return exprList;
      };
      _proto.toReferencedListDeep = function toReferencedListDeep(exprList, isParenthesizedExpr) {
        this.toReferencedList(exprList, isParenthesizedExpr);
        for (var _i22 = 0; _i22 < exprList.length; _i22++) {
          var expr = exprList[_i22];
          if ((expr == null ? void 0 : expr.type) === "ArrayExpression") {
            this.toReferencedListDeep(expr.elements);
          }
        }
      };
      _proto.parseSpread = function parseSpread(refExpressionErrors, refNeedsArrowPos) {
        var node2 = this.startNode();
        this.next();
        node2.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, void 0, refNeedsArrowPos);
        return this.finishNode(node2, "SpreadElement");
      };
      _proto.parseRestBinding = function parseRestBinding() {
        var node2 = this.startNode();
        this.next();
        node2.argument = this.parseBindingAtom();
        return this.finishNode(node2, "RestElement");
      };
      _proto.parseBindingAtom = function parseBindingAtom() {
        switch (this.state.type) {
          case 0: {
            var node2 = this.startNode();
            this.next();
            node2.elements = this.parseBindingList(3, 93, true);
            return this.finishNode(node2, "ArrayPattern");
          }
          case 5:
            return this.parseObjectLike(8, true);
        }
        return this.parseIdentifier();
      };
      _proto.parseBindingList = function parseBindingList(close, closeCharCode, allowEmpty, allowModifiers) {
        var elts = [];
        var first = true;
        while (!this.eat(close)) {
          if (first) {
            first = false;
          } else {
            this.expect(12);
          }
          if (allowEmpty && this.match(12)) {
            elts.push(null);
          } else if (this.eat(close)) {
            break;
          } else if (this.match(21)) {
            elts.push(this.parseAssignableListItemTypes(this.parseRestBinding()));
            if (!this.checkCommaAfterRest(closeCharCode)) {
              this.expect(close);
              break;
            }
          } else {
            var decorators = [];
            if (this.match(26) && this.hasPlugin("decorators")) {
              this.raise(Errors.UnsupportedParameterDecorator, {
                at: this.state.startLoc
              });
            }
            while (this.match(26)) {
              decorators.push(this.parseDecorator());
            }
            elts.push(this.parseAssignableListItem(allowModifiers, decorators));
          }
        }
        return elts;
      };
      _proto.parseBindingRestProperty = function parseBindingRestProperty(prop2) {
        this.next();
        prop2.argument = this.parseIdentifier();
        this.checkCommaAfterRest(125);
        return this.finishNode(prop2, "RestElement");
      };
      _proto.parseBindingProperty = function parseBindingProperty() {
        var prop2 = this.startNode();
        var _this$state = this.state, type5 = _this$state.type, startPos = _this$state.start, startLoc = _this$state.startLoc;
        if (type5 === 21) {
          return this.parseBindingRestProperty(prop2);
        } else if (type5 === 134) {
          this.expectPlugin("destructuringPrivate", startLoc);
          this.classScope.usePrivateName(this.state.value, startLoc);
          prop2.key = this.parsePrivateName();
        } else {
          this.parsePropertyName(prop2);
        }
        prop2.method = false;
        this.parseObjPropValue(prop2, startPos, startLoc, false, false, true, false);
        return prop2;
      };
      _proto.parseAssignableListItem = function parseAssignableListItem(allowModifiers, decorators) {
        var left = this.parseMaybeDefault();
        this.parseAssignableListItemTypes(left);
        var elt = this.parseMaybeDefault(left.start, left.loc.start, left);
        if (decorators.length) {
          left.decorators = decorators;
        }
        return elt;
      };
      _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param) {
        return param;
      };
      _proto.parseMaybeDefault = function parseMaybeDefault(startPos, startLoc, left) {
        var _startLoc, _startPos, _left;
        startLoc = (_startLoc = startLoc) != null ? _startLoc : this.state.startLoc;
        startPos = (_startPos = startPos) != null ? _startPos : this.state.start;
        left = (_left = left) != null ? _left : this.parseBindingAtom();
        if (!this.eat(29))
          return left;
        var node2 = this.startNodeAt(startPos, startLoc);
        node2.left = left;
        node2.right = this.parseMaybeAssignAllowIn();
        return this.finishNode(node2, "AssignmentPattern");
      };
      _proto.isValidLVal = function isValidLVal(type5, isParenthesized, binding2) {
        return getOwn({
          AssignmentPattern: "left",
          RestElement: "argument",
          ObjectProperty: "value",
          ParenthesizedExpression: "expression",
          ArrayPattern: "elements",
          ObjectPattern: "properties"
        }, type5);
      };
      _proto.checkLVal = function checkLVal(expression2, _ref3) {
        var _expression$extra;
        var ancestor = _ref3["in"], _ref$binding = _ref3.binding, binding2 = _ref$binding === void 0 ? BIND_NONE2 : _ref$binding, _ref$checkClashes = _ref3.checkClashes, checkClashes = _ref$checkClashes === void 0 ? false : _ref$checkClashes, _ref$strictModeChange = _ref3.strictModeChanged, strictModeChanged = _ref$strictModeChange === void 0 ? false : _ref$strictModeChange, _ref$allowingSloppyLe = _ref3.allowingSloppyLetBinding, allowingSloppyLetBinding = _ref$allowingSloppyLe === void 0 ? !(binding2 & BIND_SCOPE_LEXICAL) : _ref$allowingSloppyLe, _ref$hasParenthesized = _ref3.hasParenthesizedAncestor, hasParenthesizedAncestor = _ref$hasParenthesized === void 0 ? false : _ref$hasParenthesized;
        var type5 = expression2.type;
        if (this.isObjectMethod(expression2))
          return;
        if (type5 === "MemberExpression") {
          if (binding2 !== BIND_NONE2) {
            this.raise(Errors.InvalidPropertyBindingPattern, {
              at: expression2
            });
          }
          return;
        }
        if (expression2.type === "Identifier") {
          this.checkIdentifier(expression2, binding2, strictModeChanged, allowingSloppyLetBinding);
          var name2 = expression2.name;
          if (checkClashes) {
            if (checkClashes.has(name2)) {
              this.raise(Errors.ParamDupe, {
                at: expression2
              });
            } else {
              checkClashes.add(name2);
            }
          }
          return;
        }
        var validity = this.isValidLVal(expression2.type, hasParenthesizedAncestor || ((_expression$extra = expression2.extra) == null ? void 0 : _expression$extra.parenthesized), binding2);
        if (validity === true)
          return;
        if (validity === false) {
          var ParseErrorClass = binding2 === BIND_NONE2 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
          this.raise(ParseErrorClass, {
            at: expression2,
            ancestor: ancestor.type === "UpdateExpression" ? {
              type: "UpdateExpression",
              prefix: ancestor.prefix
            } : {
              type: ancestor.type
            }
          });
          return;
        }
        var _ref22 = Array.isArray(validity) ? validity : [validity, type5 === "ParenthesizedExpression"], key2 = _ref22[0], isParenthesizedExpression2 = _ref22[1];
        var nextAncestor2 = expression2.type === "ArrayPattern" || expression2.type === "ObjectPattern" || expression2.type === "ParenthesizedExpression" ? expression2 : ancestor;
        for (var _i4 = 0, _concat2 = [].concat(expression2[key2]); _i4 < _concat2.length; _i4++) {
          var child = _concat2[_i4];
          if (child) {
            this.checkLVal(child, {
              "in": nextAncestor2,
              binding: binding2,
              checkClashes,
              allowingSloppyLetBinding,
              strictModeChanged,
              hasParenthesizedAncestor: isParenthesizedExpression2
            });
          }
        }
      };
      _proto.checkIdentifier = function checkIdentifier(at2, bindingType, strictModeChanged, allowLetBinding) {
        if (strictModeChanged === void 0) {
          strictModeChanged = false;
        }
        if (allowLetBinding === void 0) {
          allowLetBinding = !(bindingType & BIND_SCOPE_LEXICAL);
        }
        if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(at2.name, this.inModule) : isStrictBindOnlyReservedWord(at2.name))) {
          if (bindingType === BIND_NONE2) {
            this.raise(Errors.StrictEvalArguments, {
              at: at2,
              referenceName: at2.name
            });
          } else {
            this.raise(Errors.StrictEvalArgumentsBinding, {
              at: at2,
              bindingName: at2.name
            });
          }
        }
        if (!allowLetBinding && at2.name === "let") {
          this.raise(Errors.LetInLexicalBinding, {
            at: at2
          });
        }
        if (!(bindingType & BIND_NONE2)) {
          this.declareNameFromIdentifier(at2, bindingType);
        }
      };
      _proto.declareNameFromIdentifier = function declareNameFromIdentifier(identifier2, binding2) {
        this.scope.declareName(identifier2.name, binding2, identifier2.loc.start);
      };
      _proto.checkToRestConversion = function checkToRestConversion(node2) {
        if (node2.argument.type !== "Identifier" && node2.argument.type !== "MemberExpression") {
          this.raise(Errors.InvalidRestAssignmentPattern, {
            at: node2.argument
          });
        }
      };
      _proto.checkCommaAfterRest = function checkCommaAfterRest(close) {
        if (!this.match(12)) {
          return false;
        }
        this.raise(this.lookaheadCharCode() === close ? Errors.RestTrailingComma : Errors.ElementAfterRest, {
          at: this.state.startLoc
        });
        return true;
      };
      return _createClass2(LValParser2);
    }(NodeUtils);
    var ExpressionParser = function(_LValParser) {
      _inherits2(ExpressionParser2, _LValParser);
      function ExpressionParser2() {
        return _LValParser.apply(this, arguments) || this;
      }
      var _proto = ExpressionParser2.prototype;
      _proto.checkProto = function checkProto(prop2, isRecord, protoRef, refExpressionErrors) {
        if (prop2.type === "SpreadElement" || this.isObjectMethod(prop2) || prop2.computed || prop2.shorthand) {
          return;
        }
        var key2 = prop2.key;
        var name2 = key2.type === "Identifier" ? key2.name : key2.value;
        if (name2 === "__proto__") {
          if (isRecord) {
            this.raise(Errors.RecordNoProto, {
              at: key2
            });
            return;
          }
          if (protoRef.used) {
            if (refExpressionErrors) {
              if (refExpressionErrors.doubleProtoLoc === null) {
                refExpressionErrors.doubleProtoLoc = key2.loc.start;
              }
            } else {
              this.raise(Errors.DuplicateProto, {
                at: key2
              });
            }
          }
          protoRef.used = true;
        }
      };
      _proto.shouldExitDescending = function shouldExitDescending(expr, potentialArrowAt) {
        return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
      };
      _proto.getExpression = function getExpression() {
        this.enterInitialScopes();
        this.nextToken();
        var expr = this.parseExpression();
        if (!this.match(135)) {
          this.unexpected();
        }
        this.finalizeRemainingComments();
        expr.comments = this.state.comments;
        expr.errors = this.state.errors;
        if (this.options.tokens) {
          expr.tokens = this.tokens;
        }
        return expr;
      };
      _proto.parseExpression = function parseExpression(disallowIn, refExpressionErrors) {
        var _this = this;
        if (disallowIn) {
          return this.disallowInAnd(function() {
            return _this.parseExpressionBase(refExpressionErrors);
          });
        }
        return this.allowInAnd(function() {
          return _this.parseExpressionBase(refExpressionErrors);
        });
      };
      _proto.parseExpressionBase = function parseExpressionBase(refExpressionErrors) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var expr = this.parseMaybeAssign(refExpressionErrors);
        if (this.match(12)) {
          var node2 = this.startNodeAt(startPos, startLoc);
          node2.expressions = [expr];
          while (this.eat(12)) {
            node2.expressions.push(this.parseMaybeAssign(refExpressionErrors));
          }
          this.toReferencedList(node2.expressions);
          return this.finishNode(node2, "SequenceExpression");
        }
        return expr;
      };
      _proto.parseMaybeAssignDisallowIn = function parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
        var _this2 = this;
        return this.disallowInAnd(function() {
          return _this2.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        });
      };
      _proto.parseMaybeAssignAllowIn = function parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
        var _this3 = this;
        return this.allowInAnd(function() {
          return _this3.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        });
      };
      _proto.setOptionalParametersError = function setOptionalParametersError(refExpressionErrors, resultError) {
        var _resultError$loc;
        refExpressionErrors.optionalParametersLoc = (_resultError$loc = resultError == null ? void 0 : resultError.loc) != null ? _resultError$loc : this.state.startLoc;
      };
      _proto.parseMaybeAssign = function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        if (this.isContextual(105)) {
          if (this.prodParam.hasYield) {
            var _left = this.parseYield();
            if (afterLeftParse) {
              _left = afterLeftParse.call(this, _left, startPos, startLoc);
            }
            return _left;
          }
        }
        var ownExpressionErrors;
        if (refExpressionErrors) {
          ownExpressionErrors = false;
        } else {
          refExpressionErrors = new ExpressionErrors();
          ownExpressionErrors = true;
        }
        var type5 = this.state.type;
        if (type5 === 10 || tokenIsIdentifier(type5)) {
          this.state.potentialArrowAt = this.state.start;
        }
        var left = this.parseMaybeConditional(refExpressionErrors);
        if (afterLeftParse) {
          left = afterLeftParse.call(this, left, startPos, startLoc);
        }
        if (tokenIsAssignment(this.state.type)) {
          var node2 = this.startNodeAt(startPos, startLoc);
          var operator = this.state.value;
          node2.operator = operator;
          if (this.match(29)) {
            node2.left = this.toAssignable(left, true);
            if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startPos) {
              refExpressionErrors.doubleProtoLoc = null;
            }
            if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startPos) {
              refExpressionErrors.shorthandAssignLoc = null;
            }
            if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startPos) {
              this.checkDestructuringPrivate(refExpressionErrors);
              refExpressionErrors.privateKeyLoc = null;
            }
          } else {
            node2.left = left;
          }
          this.next();
          node2.right = this.parseMaybeAssign();
          this.checkLVal(left, {
            "in": this.finishNode(node2, "AssignmentExpression")
          });
          return node2;
        } else if (ownExpressionErrors) {
          this.checkExpressionErrors(refExpressionErrors, true);
        }
        return left;
      };
      _proto.parseMaybeConditional = function parseMaybeConditional(refExpressionErrors) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var potentialArrowAt = this.state.potentialArrowAt;
        var expr = this.parseExprOps(refExpressionErrors);
        if (this.shouldExitDescending(expr, potentialArrowAt)) {
          return expr;
        }
        return this.parseConditional(expr, startPos, startLoc, refExpressionErrors);
      };
      _proto.parseConditional = function parseConditional(expr, startPos, startLoc, refExpressionErrors) {
        if (this.eat(17)) {
          var node2 = this.startNodeAt(startPos, startLoc);
          node2.test = expr;
          node2.consequent = this.parseMaybeAssignAllowIn();
          this.expect(14);
          node2.alternate = this.parseMaybeAssign();
          return this.finishNode(node2, "ConditionalExpression");
        }
        return expr;
      };
      _proto.parseMaybeUnaryOrPrivate = function parseMaybeUnaryOrPrivate(refExpressionErrors) {
        return this.match(134) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
      };
      _proto.parseExprOps = function parseExprOps(refExpressionErrors) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var potentialArrowAt = this.state.potentialArrowAt;
        var expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
        if (this.shouldExitDescending(expr, potentialArrowAt)) {
          return expr;
        }
        return this.parseExprOp(expr, startPos, startLoc, -1);
      };
      _proto.parseExprOp = function parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
        if (this.isPrivateName(left)) {
          var value = this.getPrivateNameSV(left);
          if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
            this.raise(Errors.PrivateInExpectedIn, {
              at: left,
              identifierName: value
            });
          }
          this.classScope.usePrivateName(value, left.loc.start);
        }
        var op = this.state.type;
        if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
          var prec = tokenOperatorPrecedence(op);
          if (prec > minPrec) {
            if (op === 39) {
              this.expectPlugin("pipelineOperator");
              if (this.state.inFSharpPipelineDirectBody) {
                return left;
              }
              this.checkPipelineAtInfixOperator(left, leftStartLoc);
            }
            var node2 = this.startNodeAt(leftStartPos, leftStartLoc);
            node2.left = left;
            node2.operator = this.state.value;
            var logical = op === 41 || op === 42;
            var coalesce = op === 40;
            if (coalesce) {
              prec = tokenOperatorPrecedence(42);
            }
            this.next();
            if (op === 39 && this.hasPlugin(["pipelineOperator", {
              proposal: "minimal"
            }])) {
              if (this.state.type === 96 && this.prodParam.hasAwait) {
                throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, {
                  at: this.state.startLoc
                });
              }
            }
            node2.right = this.parseExprOpRightExpr(op, prec);
            this.finishNode(node2, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
            var nextOp = this.state.type;
            if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
              throw this.raise(Errors.MixingCoalesceWithLogical, {
                at: this.state.startLoc
              });
            }
            return this.parseExprOp(node2, leftStartPos, leftStartLoc, minPrec);
          }
        }
        return left;
      };
      _proto.parseExprOpRightExpr = function parseExprOpRightExpr(op, prec) {
        var _this4 = this;
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        switch (op) {
          case 39:
            switch (this.getPluginOption("pipelineOperator", "proposal")) {
              case "hack":
                return this.withTopicBindingContext(function() {
                  return _this4.parseHackPipeBody();
                });
              case "smart":
                return this.withTopicBindingContext(function() {
                  if (_this4.prodParam.hasYield && _this4.isContextual(105)) {
                    throw _this4.raise(Errors.PipeBodyIsTighter, {
                      at: _this4.state.startLoc
                    });
                  }
                  return _this4.parseSmartPipelineBodyInStyle(_this4.parseExprOpBaseRightExpr(op, prec), startPos, startLoc);
                });
              case "fsharp":
                return this.withSoloAwaitPermittingContext(function() {
                  return _this4.parseFSharpPipelineBody(prec);
                });
            }
          default:
            return this.parseExprOpBaseRightExpr(op, prec);
        }
      };
      _proto.parseExprOpBaseRightExpr = function parseExprOpBaseRightExpr(op, prec) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startPos, startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
      };
      _proto.parseHackPipeBody = function parseHackPipeBody() {
        var _body$extra;
        var startLoc = this.state.startLoc;
        var body = this.parseMaybeAssign();
        var requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(body.type);
        if (requiredParentheses && !((_body$extra = body.extra) != null && _body$extra.parenthesized)) {
          this.raise(Errors.PipeUnparenthesizedBody, {
            at: startLoc,
            type: body.type
          });
        }
        if (!this.topicReferenceWasUsedInCurrentContext()) {
          this.raise(Errors.PipeTopicUnused, {
            at: startLoc
          });
        }
        return body;
      };
      _proto.checkExponentialAfterUnary = function checkExponentialAfterUnary(node2) {
        if (this.match(57)) {
          this.raise(Errors.UnexpectedTokenUnaryExponentiation, {
            at: node2.argument
          });
        }
      };
      _proto.parseMaybeUnary = function parseMaybeUnary(refExpressionErrors, sawUnary) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var isAwait = this.isContextual(96);
        if (isAwait && this.isAwaitAllowed()) {
          this.next();
          var _expr = this.parseAwait(startPos, startLoc);
          if (!sawUnary)
            this.checkExponentialAfterUnary(_expr);
          return _expr;
        }
        var update2 = this.match(34);
        var node2 = this.startNode();
        if (tokenIsPrefix(this.state.type)) {
          node2.operator = this.state.value;
          node2.prefix = true;
          if (this.match(72)) {
            this.expectPlugin("throwExpressions");
          }
          var isDelete = this.match(89);
          this.next();
          node2.argument = this.parseMaybeUnary(null, true);
          this.checkExpressionErrors(refExpressionErrors, true);
          if (this.state.strict && isDelete) {
            var arg = node2.argument;
            if (arg.type === "Identifier") {
              this.raise(Errors.StrictDelete, {
                at: node2
              });
            } else if (this.hasPropertyAsPrivateName(arg)) {
              this.raise(Errors.DeletePrivateField, {
                at: node2
              });
            }
          }
          if (!update2) {
            if (!sawUnary)
              this.checkExponentialAfterUnary(node2);
            return this.finishNode(node2, "UnaryExpression");
          }
        }
        var expr = this.parseUpdate(node2, update2, refExpressionErrors);
        if (isAwait) {
          var type5 = this.state.type;
          var startsExpr3 = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type5) : tokenCanStartExpression(type5) && !this.match(54);
          if (startsExpr3 && !this.isAmbiguousAwait()) {
            this.raiseOverwrite(Errors.AwaitNotInAsyncContext, {
              at: startLoc
            });
            return this.parseAwait(startPos, startLoc);
          }
        }
        return expr;
      };
      _proto.parseUpdate = function parseUpdate(node2, update2, refExpressionErrors) {
        if (update2) {
          this.checkLVal(node2.argument, {
            "in": this.finishNode(node2, "UpdateExpression")
          });
          return node2;
        }
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var expr = this.parseExprSubscripts(refExpressionErrors);
        if (this.checkExpressionErrors(refExpressionErrors, false))
          return expr;
        while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
          var _node = this.startNodeAt(startPos, startLoc);
          _node.operator = this.state.value;
          _node.prefix = false;
          _node.argument = expr;
          this.next();
          this.checkLVal(expr, {
            "in": expr = this.finishNode(_node, "UpdateExpression")
          });
        }
        return expr;
      };
      _proto.parseExprSubscripts = function parseExprSubscripts(refExpressionErrors) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var potentialArrowAt = this.state.potentialArrowAt;
        var expr = this.parseExprAtom(refExpressionErrors);
        if (this.shouldExitDescending(expr, potentialArrowAt)) {
          return expr;
        }
        return this.parseSubscripts(expr, startPos, startLoc);
      };
      _proto.parseSubscripts = function parseSubscripts(base2, startPos, startLoc, noCalls) {
        var state = {
          optionalChainMember: false,
          maybeAsyncArrow: this.atPossibleAsyncArrow(base2),
          stop: false
        };
        do {
          base2 = this.parseSubscript(base2, startPos, startLoc, noCalls, state);
          state.maybeAsyncArrow = false;
        } while (!state.stop);
        return base2;
      };
      _proto.parseSubscript = function parseSubscript(base2, startPos, startLoc, noCalls, state) {
        var type5 = this.state.type;
        if (!noCalls && type5 === 15) {
          return this.parseBind(base2, startPos, startLoc, noCalls, state);
        } else if (tokenIsTemplate(type5)) {
          return this.parseTaggedTemplateExpression(base2, startPos, startLoc, state);
        }
        var optional = false;
        if (type5 === 18) {
          if (noCalls && this.lookaheadCharCode() === 40) {
            state.stop = true;
            return base2;
          }
          state.optionalChainMember = optional = true;
          this.next();
        }
        if (!noCalls && this.match(10)) {
          return this.parseCoverCallAndAsyncArrowHead(base2, startPos, startLoc, state, optional);
        } else {
          var computed = this.eat(0);
          if (computed || optional || this.eat(16)) {
            return this.parseMember(base2, startPos, startLoc, state, computed, optional);
          } else {
            state.stop = true;
            return base2;
          }
        }
      };
      _proto.parseMember = function parseMember(base2, startPos, startLoc, state, computed, optional) {
        var node2 = this.startNodeAt(startPos, startLoc);
        node2.object = base2;
        node2.computed = computed;
        if (computed) {
          node2.property = this.parseExpression();
          this.expect(3);
        } else if (this.match(134)) {
          if (base2.type === "Super") {
            this.raise(Errors.SuperPrivateField, {
              at: startLoc
            });
          }
          this.classScope.usePrivateName(this.state.value, this.state.startLoc);
          node2.property = this.parsePrivateName();
        } else {
          node2.property = this.parseIdentifier(true);
        }
        if (state.optionalChainMember) {
          node2.optional = optional;
          return this.finishNode(node2, "OptionalMemberExpression");
        } else {
          return this.finishNode(node2, "MemberExpression");
        }
      };
      _proto.parseBind = function parseBind(base2, startPos, startLoc, noCalls, state) {
        var node2 = this.startNodeAt(startPos, startLoc);
        node2.object = base2;
        this.next();
        node2.callee = this.parseNoCallExpr();
        state.stop = true;
        return this.parseSubscripts(this.finishNode(node2, "BindExpression"), startPos, startLoc, noCalls);
      };
      _proto.parseCoverCallAndAsyncArrowHead = function parseCoverCallAndAsyncArrowHead(base2, startPos, startLoc, state, optional) {
        var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        var refExpressionErrors = null;
        this.state.maybeInArrowParameters = true;
        this.next();
        var node2 = this.startNodeAt(startPos, startLoc);
        node2.callee = base2;
        var maybeAsyncArrow = state.maybeAsyncArrow, optionalChainMember = state.optionalChainMember;
        if (maybeAsyncArrow) {
          this.expressionScope.enter(newAsyncArrowScope());
          refExpressionErrors = new ExpressionErrors();
        }
        if (optionalChainMember) {
          node2.optional = optional;
        }
        if (optional) {
          node2.arguments = this.parseCallExpressionArguments(11);
        } else {
          node2.arguments = this.parseCallExpressionArguments(11, base2.type === "Import", base2.type !== "Super", node2, refExpressionErrors);
        }
        this.finishCallExpression(node2, optionalChainMember);
        if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
          state.stop = true;
          this.checkDestructuringPrivate(refExpressionErrors);
          this.expressionScope.validateAsPattern();
          this.expressionScope.exit();
          node2 = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startPos, startLoc), node2);
        } else {
          if (maybeAsyncArrow) {
            this.checkExpressionErrors(refExpressionErrors, true);
            this.expressionScope.exit();
          }
          this.toReferencedArguments(node2);
        }
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        return node2;
      };
      _proto.toReferencedArguments = function toReferencedArguments(node2, isParenthesizedExpr) {
        this.toReferencedListDeep(node2.arguments, isParenthesizedExpr);
      };
      _proto.parseTaggedTemplateExpression = function parseTaggedTemplateExpression(base2, startPos, startLoc, state) {
        var node2 = this.startNodeAt(startPos, startLoc);
        node2.tag = base2;
        node2.quasi = this.parseTemplate(true);
        if (state.optionalChainMember) {
          this.raise(Errors.OptionalChainingNoTemplate, {
            at: startLoc
          });
        }
        return this.finishNode(node2, "TaggedTemplateExpression");
      };
      _proto.atPossibleAsyncArrow = function atPossibleAsyncArrow(base2) {
        return base2.type === "Identifier" && base2.name === "async" && this.state.lastTokEndLoc.index === base2.end && !this.canInsertSemicolon() && base2.end - base2.start === 5 && base2.start === this.state.potentialArrowAt;
      };
      _proto.finishCallExpression = function finishCallExpression(node2, optional) {
        if (node2.callee.type === "Import") {
          if (node2.arguments.length === 2) {
            {
              if (!this.hasPlugin("moduleAttributes")) {
                this.expectPlugin("importAssertions");
              }
            }
          }
          if (node2.arguments.length === 0 || node2.arguments.length > 2) {
            this.raise(Errors.ImportCallArity, {
              at: node2,
              maxArgumentCount: this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1
            });
          } else {
            for (var _i22 = 0, _node$arguments2 = node2.arguments; _i22 < _node$arguments2.length; _i22++) {
              var arg = _node$arguments2[_i22];
              if (arg.type === "SpreadElement") {
                this.raise(Errors.ImportCallSpreadArgument, {
                  at: arg
                });
              }
            }
          }
        }
        return this.finishNode(node2, optional ? "OptionalCallExpression" : "CallExpression");
      };
      _proto.parseCallExpressionArguments = function parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
        var elts = [];
        var first = true;
        var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
        this.state.inFSharpPipelineDirectBody = false;
        while (!this.eat(close)) {
          if (first) {
            first = false;
          } else {
            this.expect(12);
            if (this.match(close)) {
              if (dynamicImport && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
                this.raise(Errors.ImportCallArgumentTrailingComma, {
                  at: this.state.lastTokStartLoc
                });
              }
              if (nodeForExtra) {
                this.addTrailingCommaExtraToNode(nodeForExtra);
              }
              this.next();
              break;
            }
          }
          elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
        }
        this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
        return elts;
      };
      _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
        return this.match(19) && !this.canInsertSemicolon();
      };
      _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node2, call3) {
        var _call$extra;
        this.resetPreviousNodeTrailingComments(call3);
        this.expect(19);
        this.parseArrowExpression(node2, call3.arguments, true, (_call$extra = call3.extra) == null ? void 0 : _call$extra.trailingCommaLoc);
        if (call3.innerComments) {
          setInnerComments(node2, call3.innerComments);
        }
        if (call3.callee.trailingComments) {
          setInnerComments(node2, call3.callee.trailingComments);
        }
        return node2;
      };
      _proto.parseNoCallExpr = function parseNoCallExpr() {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        return this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true);
      };
      _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
        var node2;
        var type5 = this.state.type;
        switch (type5) {
          case 79:
            return this.parseSuper();
          case 83:
            node2 = this.startNode();
            this.next();
            if (this.match(16)) {
              return this.parseImportMetaProperty(node2);
            }
            if (!this.match(10)) {
              this.raise(Errors.UnsupportedImport, {
                at: this.state.lastTokStartLoc
              });
            }
            return this.finishNode(node2, "Import");
          case 78:
            node2 = this.startNode();
            this.next();
            return this.finishNode(node2, "ThisExpression");
          case 90: {
            return this.parseDo(this.startNode(), false);
          }
          case 56:
          case 31: {
            this.readRegexp();
            return this.parseRegExpLiteral(this.state.value);
          }
          case 130:
            return this.parseNumericLiteral(this.state.value);
          case 131:
            return this.parseBigIntLiteral(this.state.value);
          case 132:
            return this.parseDecimalLiteral(this.state.value);
          case 129:
            return this.parseStringLiteral(this.state.value);
          case 84:
            return this.parseNullLiteral();
          case 85:
            return this.parseBooleanLiteral(true);
          case 86:
            return this.parseBooleanLiteral(false);
          case 10: {
            var canBeArrow = this.state.potentialArrowAt === this.state.start;
            return this.parseParenAndDistinguishExpression(canBeArrow);
          }
          case 2:
          case 1: {
            return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
          }
          case 0: {
            return this.parseArrayLike(3, true, false, refExpressionErrors);
          }
          case 6:
          case 7: {
            return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
          }
          case 5: {
            return this.parseObjectLike(8, false, false, refExpressionErrors);
          }
          case 68:
            return this.parseFunctionOrFunctionSent();
          case 26:
            this.parseDecorators();
          case 80:
            node2 = this.startNode();
            this.takeDecorators(node2);
            return this.parseClass(node2, false);
          case 77:
            return this.parseNewOrNewTarget();
          case 25:
          case 24:
            return this.parseTemplate(false);
          case 15: {
            node2 = this.startNode();
            this.next();
            node2.object = null;
            var callee = node2.callee = this.parseNoCallExpr();
            if (callee.type === "MemberExpression") {
              return this.finishNode(node2, "BindExpression");
            } else {
              throw this.raise(Errors.UnsupportedBind, {
                at: callee
              });
            }
          }
          case 134: {
            this.raise(Errors.PrivateInExpectedIn, {
              at: this.state.startLoc,
              identifierName: this.state.value
            });
            return this.parsePrivateName();
          }
          case 33: {
            return this.parseTopicReferenceThenEqualsSign(54, "%");
          }
          case 32: {
            return this.parseTopicReferenceThenEqualsSign(44, "^");
          }
          case 37:
          case 38: {
            return this.parseTopicReference("hack");
          }
          case 44:
          case 54:
          case 27: {
            var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
            if (pipeProposal) {
              return this.parseTopicReference(pipeProposal);
            } else {
              throw this.unexpected();
            }
          }
          case 47: {
            var lookaheadCh = this.input.codePointAt(this.nextTokenStart());
            if (isIdentifierStart2(lookaheadCh) || lookaheadCh === 62) {
              this.expectOnePlugin(["jsx", "flow", "typescript"]);
              break;
            } else {
              throw this.unexpected();
            }
          }
          default:
            if (tokenIsIdentifier(type5)) {
              if (this.isContextual(123) && this.lookaheadCharCode() === 123 && !this.hasFollowingLineBreak()) {
                return this.parseModuleExpression();
              }
              var _canBeArrow = this.state.potentialArrowAt === this.state.start;
              var containsEsc = this.state.containsEsc;
              var id3 = this.parseIdentifier();
              if (!containsEsc && id3.name === "async" && !this.canInsertSemicolon()) {
                var _type = this.state.type;
                if (_type === 68) {
                  this.resetPreviousNodeTrailingComments(id3);
                  this.next();
                  return this.parseFunction(this.startNodeAtNode(id3), void 0, true);
                } else if (tokenIsIdentifier(_type)) {
                  if (this.lookaheadCharCode() === 61) {
                    return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id3));
                  } else {
                    return id3;
                  }
                } else if (_type === 90) {
                  this.resetPreviousNodeTrailingComments(id3);
                  return this.parseDo(this.startNodeAtNode(id3), true);
                }
              }
              if (_canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
                this.next();
                return this.parseArrowExpression(this.startNodeAtNode(id3), [id3], false);
              }
              return id3;
            } else {
              throw this.unexpected();
            }
        }
      };
      _proto.parseTopicReferenceThenEqualsSign = function parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
        var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
        if (pipeProposal) {
          this.state.type = topicTokenType;
          this.state.value = topicTokenValue;
          this.state.pos--;
          this.state.end--;
          this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
          return this.parseTopicReference(pipeProposal);
        } else {
          throw this.unexpected();
        }
      };
      _proto.parseTopicReference = function parseTopicReference(pipeProposal) {
        var node2 = this.startNode();
        var startLoc = this.state.startLoc;
        var tokenType = this.state.type;
        this.next();
        return this.finishTopicReference(node2, startLoc, pipeProposal, tokenType);
      };
      _proto.finishTopicReference = function finishTopicReference(node2, startLoc, pipeProposal, tokenType) {
        if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
          var nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
          if (!this.topicReferenceIsAllowedInCurrentContext()) {
            this.raise(pipeProposal === "smart" ? Errors.PrimaryTopicNotAllowed : Errors.PipeTopicUnbound, {
              at: startLoc
            });
          }
          this.registerTopicReference();
          return this.finishNode(node2, nodeType);
        } else {
          throw this.raise(Errors.PipeTopicUnconfiguredToken, {
            at: startLoc,
            token: tokenLabelName(tokenType)
          });
        }
      };
      _proto.testTopicReferenceConfiguration = function testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
        switch (pipeProposal) {
          case "hack": {
            return this.hasPlugin(["pipelineOperator", {
              topicToken: tokenLabelName(tokenType)
            }]);
          }
          case "smart":
            return tokenType === 27;
          default:
            throw this.raise(Errors.PipeTopicRequiresHackPipes, {
              at: startLoc
            });
        }
      };
      _proto.parseAsyncArrowUnaryFunction = function parseAsyncArrowUnaryFunction(node2) {
        this.prodParam.enter(functionFlags2(true, this.prodParam.hasYield));
        var params = [this.parseIdentifier()];
        this.prodParam.exit();
        if (this.hasPrecedingLineBreak()) {
          this.raise(Errors.LineTerminatorBeforeArrow, {
            at: this.state.curPosition()
          });
        }
        this.expect(19);
        this.parseArrowExpression(node2, params, true);
        return node2;
      };
      _proto.parseDo = function parseDo(node2, isAsync2) {
        this.expectPlugin("doExpressions");
        if (isAsync2) {
          this.expectPlugin("asyncDoExpressions");
        }
        node2.async = isAsync2;
        this.next();
        var oldLabels = this.state.labels;
        this.state.labels = [];
        if (isAsync2) {
          this.prodParam.enter(PARAM_AWAIT);
          node2.body = this.parseBlock();
          this.prodParam.exit();
        } else {
          node2.body = this.parseBlock();
        }
        this.state.labels = oldLabels;
        return this.finishNode(node2, "DoExpression");
      };
      _proto.parseSuper = function parseSuper() {
        var node2 = this.startNode();
        this.next();
        if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
          this.raise(Errors.SuperNotAllowed, {
            at: node2
          });
        } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
          this.raise(Errors.UnexpectedSuper, {
            at: node2
          });
        }
        if (!this.match(10) && !this.match(0) && !this.match(16)) {
          this.raise(Errors.UnsupportedSuper, {
            at: node2
          });
        }
        return this.finishNode(node2, "Super");
      };
      _proto.parsePrivateName = function parsePrivateName() {
        var node2 = this.startNode();
        var id3 = this.startNodeAt(this.state.start + 1, new Position3(this.state.curLine, this.state.start + 1 - this.state.lineStart, this.state.start + 1));
        var name2 = this.state.value;
        this.next();
        node2.id = this.createIdentifier(id3, name2);
        return this.finishNode(node2, "PrivateName");
      };
      _proto.parseFunctionOrFunctionSent = function parseFunctionOrFunctionSent() {
        var node2 = this.startNode();
        this.next();
        if (this.prodParam.hasYield && this.match(16)) {
          var meta2 = this.createIdentifier(this.startNodeAtNode(node2), "function");
          this.next();
          if (this.match(102)) {
            this.expectPlugin("functionSent");
          } else if (!this.hasPlugin("functionSent")) {
            this.unexpected();
          }
          return this.parseMetaProperty(node2, meta2, "sent");
        }
        return this.parseFunction(node2);
      };
      _proto.parseMetaProperty = function parseMetaProperty(node2, meta2, propertyName) {
        node2.meta = meta2;
        var containsEsc = this.state.containsEsc;
        node2.property = this.parseIdentifier(true);
        if (node2.property.name !== propertyName || containsEsc) {
          this.raise(Errors.UnsupportedMetaProperty, {
            at: node2.property,
            target: meta2.name,
            onlyValidPropertyName: propertyName
          });
        }
        return this.finishNode(node2, "MetaProperty");
      };
      _proto.parseImportMetaProperty = function parseImportMetaProperty(node2) {
        var id3 = this.createIdentifier(this.startNodeAtNode(node2), "import");
        this.next();
        if (this.isContextual(100)) {
          if (!this.inModule) {
            this.raise(Errors.ImportMetaOutsideModule, {
              at: id3
            });
          }
          this.sawUnambiguousESM = true;
        }
        return this.parseMetaProperty(node2, id3, "meta");
      };
      _proto.parseLiteralAtNode = function parseLiteralAtNode(value, type5, node2) {
        this.addExtra(node2, "rawValue", value);
        this.addExtra(node2, "raw", this.input.slice(node2.start, this.state.end));
        node2.value = value;
        this.next();
        return this.finishNode(node2, type5);
      };
      _proto.parseLiteral = function parseLiteral(value, type5) {
        var node2 = this.startNode();
        return this.parseLiteralAtNode(value, type5, node2);
      };
      _proto.parseStringLiteral = function parseStringLiteral(value) {
        return this.parseLiteral(value, "StringLiteral");
      };
      _proto.parseNumericLiteral = function parseNumericLiteral(value) {
        return this.parseLiteral(value, "NumericLiteral");
      };
      _proto.parseBigIntLiteral = function parseBigIntLiteral(value) {
        return this.parseLiteral(value, "BigIntLiteral");
      };
      _proto.parseDecimalLiteral = function parseDecimalLiteral(value) {
        return this.parseLiteral(value, "DecimalLiteral");
      };
      _proto.parseRegExpLiteral = function parseRegExpLiteral(value) {
        var node2 = this.parseLiteral(value.value, "RegExpLiteral");
        node2.pattern = value.pattern;
        node2.flags = value.flags;
        return node2;
      };
      _proto.parseBooleanLiteral = function parseBooleanLiteral(value) {
        var node2 = this.startNode();
        node2.value = value;
        this.next();
        return this.finishNode(node2, "BooleanLiteral");
      };
      _proto.parseNullLiteral = function parseNullLiteral() {
        var node2 = this.startNode();
        this.next();
        return this.finishNode(node2, "NullLiteral");
      };
      _proto.parseParenAndDistinguishExpression = function parseParenAndDistinguishExpression(canBeArrow) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        var val;
        this.next();
        this.expressionScope.enter(newArrowHeadScope());
        var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
        this.state.maybeInArrowParameters = true;
        this.state.inFSharpPipelineDirectBody = false;
        var innerStartPos = this.state.start;
        var innerStartLoc = this.state.startLoc;
        var exprList = [];
        var refExpressionErrors = new ExpressionErrors();
        var first = true;
        var spreadStartLoc;
        var optionalCommaStartLoc;
        while (!this.match(11)) {
          if (first) {
            first = false;
          } else {
            this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);
            if (this.match(11)) {
              optionalCommaStartLoc = this.state.startLoc;
              break;
            }
          }
          if (this.match(21)) {
            var spreadNodeStartPos = this.state.start;
            var spreadNodeStartLoc = this.state.startLoc;
            spreadStartLoc = this.state.startLoc;
            exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartPos, spreadNodeStartLoc));
            if (!this.checkCommaAfterRest(41)) {
              break;
            }
          } else {
            exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
          }
        }
        var innerEndLoc = this.state.lastTokEndLoc;
        this.expect(11);
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
        var arrowNode = this.startNodeAt(startPos, startLoc);
        if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
          this.checkDestructuringPrivate(refExpressionErrors);
          this.expressionScope.validateAsPattern();
          this.expressionScope.exit();
          this.parseArrowExpression(arrowNode, exprList, false);
          return arrowNode;
        }
        this.expressionScope.exit();
        if (!exprList.length) {
          this.unexpected(this.state.lastTokStartLoc);
        }
        if (optionalCommaStartLoc)
          this.unexpected(optionalCommaStartLoc);
        if (spreadStartLoc)
          this.unexpected(spreadStartLoc);
        this.checkExpressionErrors(refExpressionErrors, true);
        this.toReferencedListDeep(exprList, true);
        if (exprList.length > 1) {
          val = this.startNodeAt(innerStartPos, innerStartLoc);
          val.expressions = exprList;
          this.finishNode(val, "SequenceExpression");
          this.resetEndLocation(val, innerEndLoc);
        } else {
          val = exprList[0];
        }
        return this.wrapParenthesis(startPos, startLoc, val);
      };
      _proto.wrapParenthesis = function wrapParenthesis(startPos, startLoc, expression2) {
        if (!this.options.createParenthesizedExpressions) {
          this.addExtra(expression2, "parenthesized", true);
          this.addExtra(expression2, "parenStart", startPos);
          this.takeSurroundingComments(expression2, startPos, this.state.lastTokEndLoc.index);
          return expression2;
        }
        var parenExpression = this.startNodeAt(startPos, startLoc);
        parenExpression.expression = expression2;
        this.finishNode(parenExpression, "ParenthesizedExpression");
        return parenExpression;
      };
      _proto.shouldParseArrow = function shouldParseArrow(params) {
        return !this.canInsertSemicolon();
      };
      _proto.parseArrow = function parseArrow(node2) {
        if (this.eat(19)) {
          return node2;
        }
      };
      _proto.parseParenItem = function parseParenItem(node2, startPos, startLoc) {
        return node2;
      };
      _proto.parseNewOrNewTarget = function parseNewOrNewTarget() {
        var node2 = this.startNode();
        this.next();
        if (this.match(16)) {
          var meta2 = this.createIdentifier(this.startNodeAtNode(node2), "new");
          this.next();
          var metaProp = this.parseMetaProperty(node2, meta2, "target");
          if (!this.scope.inNonArrowFunction && !this.scope.inClass) {
            this.raise(Errors.UnexpectedNewTarget, {
              at: metaProp
            });
          }
          return metaProp;
        }
        return this.parseNew(node2);
      };
      _proto.parseNew = function parseNew(node2) {
        node2.callee = this.parseNoCallExpr();
        if (node2.callee.type === "Import") {
          this.raise(Errors.ImportCallNotNewExpression, {
            at: node2.callee
          });
        } else if (this.isOptionalChain(node2.callee)) {
          this.raise(Errors.OptionalChainingNoNew, {
            at: this.state.lastTokEndLoc
          });
        } else if (this.eat(18)) {
          this.raise(Errors.OptionalChainingNoNew, {
            at: this.state.startLoc
          });
        }
        this.parseNewArguments(node2);
        return this.finishNode(node2, "NewExpression");
      };
      _proto.parseNewArguments = function parseNewArguments(node2) {
        if (this.eat(10)) {
          var args = this.parseExprList(11);
          this.toReferencedList(args);
          node2.arguments = args;
        } else {
          node2.arguments = [];
        }
      };
      _proto.parseTemplateElement = function parseTemplateElement(isTagged) {
        var _this$state = this.state, start2 = _this$state.start, startLoc = _this$state.startLoc, end2 = _this$state.end, value = _this$state.value;
        var elemStart = start2 + 1;
        var elem = this.startNodeAt(elemStart, createPositionWithColumnOffset(startLoc, 1));
        if (value === null) {
          if (!isTagged) {
            this.raise(Errors.InvalidEscapeSequenceTemplate, {
              at: createPositionWithColumnOffset(startLoc, 2)
            });
          }
        }
        var isTail = this.match(24);
        var endOffset = isTail ? -1 : -2;
        var elemEnd = end2 + endOffset;
        elem.value = {
          raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
          cooked: value === null ? null : value.slice(1, endOffset)
        };
        elem.tail = isTail;
        this.next();
        this.finishNode(elem, "TemplateElement");
        this.resetEndLocation(elem, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
        return elem;
      };
      _proto.parseTemplate = function parseTemplate(isTagged) {
        var node2 = this.startNode();
        node2.expressions = [];
        var curElt = this.parseTemplateElement(isTagged);
        node2.quasis = [curElt];
        while (!curElt.tail) {
          node2.expressions.push(this.parseTemplateSubstitution());
          this.readTemplateContinuation();
          node2.quasis.push(curElt = this.parseTemplateElement(isTagged));
        }
        return this.finishNode(node2, "TemplateLiteral");
      };
      _proto.parseTemplateSubstitution = function parseTemplateSubstitution() {
        return this.parseExpression();
      };
      _proto.parseObjectLike = function parseObjectLike(close, isPattern3, isRecord, refExpressionErrors) {
        if (isRecord) {
          this.expectPlugin("recordAndTuple");
        }
        var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
        this.state.inFSharpPipelineDirectBody = false;
        var propHash = /* @__PURE__ */ Object.create(null);
        var first = true;
        var node2 = this.startNode();
        node2.properties = [];
        this.next();
        while (!this.match(close)) {
          if (first) {
            first = false;
          } else {
            this.expect(12);
            if (this.match(close)) {
              this.addTrailingCommaExtraToNode(node2);
              break;
            }
          }
          var prop2 = void 0;
          if (isPattern3) {
            prop2 = this.parseBindingProperty();
          } else {
            prop2 = this.parsePropertyDefinition(refExpressionErrors);
            this.checkProto(prop2, isRecord, propHash, refExpressionErrors);
          }
          if (isRecord && !this.isObjectProperty(prop2) && prop2.type !== "SpreadElement") {
            this.raise(Errors.InvalidRecordProperty, {
              at: prop2
            });
          }
          if (prop2.shorthand) {
            this.addExtra(prop2, "shorthand", true);
          }
          node2.properties.push(prop2);
        }
        this.next();
        this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
        var type5 = "ObjectExpression";
        if (isPattern3) {
          type5 = "ObjectPattern";
        } else if (isRecord) {
          type5 = "RecordExpression";
        }
        return this.finishNode(node2, type5);
      };
      _proto.addTrailingCommaExtraToNode = function addTrailingCommaExtraToNode(node2) {
        this.addExtra(node2, "trailingComma", this.state.lastTokStart);
        this.addExtra(node2, "trailingCommaLoc", this.state.lastTokStartLoc, false);
      };
      _proto.maybeAsyncOrAccessorProp = function maybeAsyncOrAccessorProp(prop2) {
        return !prop2.computed && prop2.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
      };
      _proto.parsePropertyDefinition = function parsePropertyDefinition(refExpressionErrors) {
        var decorators = [];
        if (this.match(26)) {
          if (this.hasPlugin("decorators")) {
            this.raise(Errors.UnsupportedPropertyDecorator, {
              at: this.state.startLoc
            });
          }
          while (this.match(26)) {
            decorators.push(this.parseDecorator());
          }
        }
        var prop2 = this.startNode();
        var isAsync2 = false;
        var isAccessor2 = false;
        var startPos;
        var startLoc;
        if (this.match(21)) {
          if (decorators.length)
            this.unexpected();
          return this.parseSpread();
        }
        if (decorators.length) {
          prop2.decorators = decorators;
          decorators = [];
        }
        prop2.method = false;
        if (refExpressionErrors) {
          startPos = this.state.start;
          startLoc = this.state.startLoc;
        }
        var isGenerator = this.eat(55);
        this.parsePropertyNamePrefixOperator(prop2);
        var containsEsc = this.state.containsEsc;
        var key2 = this.parsePropertyName(prop2, refExpressionErrors);
        if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop2)) {
          var keyName = key2.name;
          if (keyName === "async" && !this.hasPrecedingLineBreak()) {
            isAsync2 = true;
            this.resetPreviousNodeTrailingComments(key2);
            isGenerator = this.eat(55);
            this.parsePropertyName(prop2);
          }
          if (keyName === "get" || keyName === "set") {
            isAccessor2 = true;
            this.resetPreviousNodeTrailingComments(key2);
            prop2.kind = keyName;
            if (this.match(55)) {
              isGenerator = true;
              this.raise(Errors.AccessorIsGenerator, {
                at: this.state.curPosition(),
                kind: keyName
              });
              this.next();
            }
            this.parsePropertyName(prop2);
          }
        }
        this.parseObjPropValue(prop2, startPos, startLoc, isGenerator, isAsync2, false, isAccessor2, refExpressionErrors);
        return prop2;
      };
      _proto.getGetterSetterExpectedParamCount = function getGetterSetterExpectedParamCount(method5) {
        return method5.kind === "get" ? 0 : 1;
      };
      _proto.getObjectOrClassMethodParams = function getObjectOrClassMethodParams(method5) {
        return method5.params;
      };
      _proto.checkGetterSetterParams = function checkGetterSetterParams(method5) {
        var _params2;
        var paramCount = this.getGetterSetterExpectedParamCount(method5);
        var params = this.getObjectOrClassMethodParams(method5);
        if (params.length !== paramCount) {
          this.raise(method5.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, {
            at: method5
          });
        }
        if (method5.kind === "set" && ((_params2 = params[params.length - 1]) == null ? void 0 : _params2.type) === "RestElement") {
          this.raise(Errors.BadSetterRestParameter, {
            at: method5
          });
        }
      };
      _proto.parseObjectMethod = function parseObjectMethod(prop2, isGenerator, isAsync2, isPattern3, isAccessor2) {
        if (isAccessor2) {
          this.parseMethod(prop2, isGenerator, false, false, false, "ObjectMethod");
          this.checkGetterSetterParams(prop2);
          return prop2;
        }
        if (isAsync2 || isGenerator || this.match(10)) {
          if (isPattern3)
            this.unexpected();
          prop2.kind = "method";
          prop2.method = true;
          return this.parseMethod(prop2, isGenerator, isAsync2, false, false, "ObjectMethod");
        }
      };
      _proto.parseObjectProperty = function parseObjectProperty(prop2, startPos, startLoc, isPattern3, refExpressionErrors) {
        prop2.shorthand = false;
        if (this.eat(14)) {
          prop2.value = isPattern3 ? this.parseMaybeDefault(this.state.start, this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
          return this.finishNode(prop2, "ObjectProperty");
        }
        if (!prop2.computed && prop2.key.type === "Identifier") {
          this.checkReservedWord(prop2.key.name, prop2.key.loc.start, true, false);
          if (isPattern3) {
            prop2.value = this.parseMaybeDefault(startPos, startLoc, cloneIdentifier(prop2.key));
          } else if (this.match(29)) {
            var shorthandAssignLoc = this.state.startLoc;
            if (refExpressionErrors != null) {
              if (refExpressionErrors.shorthandAssignLoc === null) {
                refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
              }
            } else {
              this.raise(Errors.InvalidCoverInitializedName, {
                at: shorthandAssignLoc
              });
            }
            prop2.value = this.parseMaybeDefault(startPos, startLoc, cloneIdentifier(prop2.key));
          } else {
            prop2.value = cloneIdentifier(prop2.key);
          }
          prop2.shorthand = true;
          return this.finishNode(prop2, "ObjectProperty");
        }
      };
      _proto.parseObjPropValue = function parseObjPropValue(prop2, startPos, startLoc, isGenerator, isAsync2, isPattern3, isAccessor2, refExpressionErrors) {
        var node2 = this.parseObjectMethod(prop2, isGenerator, isAsync2, isPattern3, isAccessor2) || this.parseObjectProperty(prop2, startPos, startLoc, isPattern3, refExpressionErrors);
        if (!node2)
          this.unexpected();
        return node2;
      };
      _proto.parsePropertyName = function parsePropertyName(prop2, refExpressionErrors) {
        if (this.eat(0)) {
          prop2.computed = true;
          prop2.key = this.parseMaybeAssignAllowIn();
          this.expect(3);
        } else {
          var _this$state2 = this.state, type5 = _this$state2.type, value = _this$state2.value;
          var key2;
          if (tokenIsKeywordOrIdentifier(type5)) {
            key2 = this.parseIdentifier(true);
          } else {
            switch (type5) {
              case 130:
                key2 = this.parseNumericLiteral(value);
                break;
              case 129:
                key2 = this.parseStringLiteral(value);
                break;
              case 131:
                key2 = this.parseBigIntLiteral(value);
                break;
              case 132:
                key2 = this.parseDecimalLiteral(value);
                break;
              case 134: {
                var privateKeyLoc = this.state.startLoc;
                if (refExpressionErrors != null) {
                  if (refExpressionErrors.privateKeyLoc === null) {
                    refExpressionErrors.privateKeyLoc = privateKeyLoc;
                  }
                } else {
                  this.raise(Errors.UnexpectedPrivateField, {
                    at: privateKeyLoc
                  });
                }
                key2 = this.parsePrivateName();
                break;
              }
              default:
                throw this.unexpected();
            }
          }
          prop2.key = key2;
          if (type5 !== 134) {
            prop2.computed = false;
          }
        }
        return prop2.key;
      };
      _proto.initFunction = function initFunction(node2, isAsync2) {
        node2.id = null;
        node2.generator = false;
        node2.async = !!isAsync2;
      };
      _proto.parseMethod = function parseMethod(node2, isGenerator, isAsync2, isConstructor, allowDirectSuper, type5, inClassScope) {
        if (inClassScope === void 0) {
          inClassScope = false;
        }
        this.initFunction(node2, isAsync2);
        node2.generator = !!isGenerator;
        var allowModifiers = isConstructor;
        this.scope.enter(SCOPE_FUNCTION2 | SCOPE_SUPER2 | (inClassScope ? SCOPE_CLASS : 0) | (allowDirectSuper ? SCOPE_DIRECT_SUPER2 : 0));
        this.prodParam.enter(functionFlags2(isAsync2, node2.generator));
        this.parseFunctionParams(node2, allowModifiers);
        this.parseFunctionBodyAndFinish(node2, type5, true);
        this.prodParam.exit();
        this.scope.exit();
        return node2;
      };
      _proto.parseArrayLike = function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        if (isTuple) {
          this.expectPlugin("recordAndTuple");
        }
        var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
        this.state.inFSharpPipelineDirectBody = false;
        var node2 = this.startNode();
        this.next();
        node2.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node2);
        this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
        return this.finishNode(node2, isTuple ? "TupleExpression" : "ArrayExpression");
      };
      _proto.parseArrowExpression = function parseArrowExpression(node2, params, isAsync2, trailingCommaLoc) {
        this.scope.enter(SCOPE_FUNCTION2 | SCOPE_ARROW2);
        var flags = functionFlags2(isAsync2, false);
        if (!this.match(5) && this.prodParam.hasIn) {
          flags |= PARAM_IN;
        }
        this.prodParam.enter(flags);
        this.initFunction(node2, isAsync2);
        var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        if (params) {
          this.state.maybeInArrowParameters = true;
          this.setArrowFunctionParameters(node2, params, trailingCommaLoc);
        }
        this.state.maybeInArrowParameters = false;
        this.parseFunctionBody(node2, true);
        this.prodParam.exit();
        this.scope.exit();
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        return this.finishNode(node2, "ArrowFunctionExpression");
      };
      _proto.setArrowFunctionParameters = function setArrowFunctionParameters(node2, params, trailingCommaLoc) {
        node2.params = this.toAssignableList(params, trailingCommaLoc, false);
      };
      _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node2, type5, isMethod2) {
        if (isMethod2 === void 0) {
          isMethod2 = false;
        }
        this.parseFunctionBody(node2, false, isMethod2);
        this.finishNode(node2, type5);
      };
      _proto.parseFunctionBody = function parseFunctionBody(node2, allowExpression, isMethod2) {
        var _this5 = this;
        if (isMethod2 === void 0) {
          isMethod2 = false;
        }
        var isExpression2 = allowExpression && !this.match(5);
        this.expressionScope.enter(newExpressionScope());
        if (isExpression2) {
          node2.body = this.parseMaybeAssign();
          this.checkParams(node2, false, allowExpression, false);
        } else {
          var oldStrict = this.state.strict;
          var oldLabels = this.state.labels;
          this.state.labels = [];
          this.prodParam.enter(this.prodParam.currentFlags() | PARAM_RETURN);
          node2.body = this.parseBlock(true, false, function(hasStrictModeDirective) {
            var nonSimple = !_this5.isSimpleParamList(node2.params);
            if (hasStrictModeDirective && nonSimple) {
              _this5.raise(Errors.IllegalLanguageModeDirective, {
                at: (node2.kind === "method" || node2.kind === "constructor") && !!node2.key ? node2.key.loc.end : node2
              });
            }
            var strictModeChanged = !oldStrict && _this5.state.strict;
            _this5.checkParams(node2, !_this5.state.strict && !allowExpression && !isMethod2 && !nonSimple, allowExpression, strictModeChanged);
            if (_this5.state.strict && node2.id) {
              _this5.checkIdentifier(node2.id, BIND_OUTSIDE2, strictModeChanged);
            }
          });
          this.prodParam.exit();
          this.state.labels = oldLabels;
        }
        this.expressionScope.exit();
      };
      _proto.isSimpleParameter = function isSimpleParameter(node2) {
        return node2.type === "Identifier";
      };
      _proto.isSimpleParamList = function isSimpleParamList(params) {
        for (var i2 = 0, len3 = params.length; i2 < len3; i2++) {
          if (!this.isSimpleParameter(params[i2]))
            return false;
        }
        return true;
      };
      _proto.checkParams = function checkParams(node2, allowDuplicates, isArrowFunction, strictModeChanged) {
        if (strictModeChanged === void 0) {
          strictModeChanged = true;
        }
        var checkClashes = !allowDuplicates && /* @__PURE__ */ new Set();
        var formalParameters = {
          type: "FormalParameters"
        };
        for (var _i4 = 0, _node$params2 = node2.params; _i4 < _node$params2.length; _i4++) {
          var param = _node$params2[_i4];
          this.checkLVal(param, {
            "in": formalParameters,
            binding: BIND_VAR2,
            checkClashes,
            strictModeChanged
          });
        }
      };
      _proto.parseExprList = function parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
        var elts = [];
        var first = true;
        while (!this.eat(close)) {
          if (first) {
            first = false;
          } else {
            this.expect(12);
            if (this.match(close)) {
              if (nodeForExtra) {
                this.addTrailingCommaExtraToNode(nodeForExtra);
              }
              this.next();
              break;
            }
          }
          elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
        }
        return elts;
      };
      _proto.parseExprListItem = function parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
        var elt;
        if (this.match(12)) {
          if (!allowEmpty) {
            this.raise(Errors.UnexpectedToken, {
              at: this.state.curPosition(),
              unexpected: ","
            });
          }
          elt = null;
        } else if (this.match(21)) {
          var spreadNodeStartPos = this.state.start;
          var spreadNodeStartLoc = this.state.startLoc;
          elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartPos, spreadNodeStartLoc);
        } else if (this.match(17)) {
          this.expectPlugin("partialApplication");
          if (!allowPlaceholder) {
            this.raise(Errors.UnexpectedArgumentPlaceholder, {
              at: this.state.startLoc
            });
          }
          var node2 = this.startNode();
          this.next();
          elt = this.finishNode(node2, "ArgumentPlaceholder");
        } else {
          elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
        }
        return elt;
      };
      _proto.parseIdentifier = function parseIdentifier(liberal) {
        var node2 = this.startNode();
        var name2 = this.parseIdentifierName(node2.start, liberal);
        return this.createIdentifier(node2, name2);
      };
      _proto.createIdentifier = function createIdentifier(node2, name2) {
        node2.name = name2;
        node2.loc.identifierName = name2;
        return this.finishNode(node2, "Identifier");
      };
      _proto.parseIdentifierName = function parseIdentifierName(pos, liberal) {
        var name2;
        var _this$state3 = this.state, startLoc = _this$state3.startLoc, type5 = _this$state3.type;
        if (tokenIsKeywordOrIdentifier(type5)) {
          name2 = this.state.value;
        } else {
          throw this.unexpected();
        }
        var tokenIsKeyword2 = tokenKeywordOrIdentifierIsKeyword(type5);
        if (liberal) {
          if (tokenIsKeyword2) {
            this.replaceToken(128);
          }
        } else {
          this.checkReservedWord(name2, startLoc, tokenIsKeyword2, false);
        }
        this.next();
        return name2;
      };
      _proto.checkReservedWord = function checkReservedWord(word, startLoc, checkKeywords, isBinding2) {
        if (word.length > 10) {
          return;
        }
        if (!canBeReservedWord(word)) {
          return;
        }
        if (word === "yield") {
          if (this.prodParam.hasYield) {
            this.raise(Errors.YieldBindingIdentifier, {
              at: startLoc
            });
            return;
          }
        } else if (word === "await") {
          if (this.prodParam.hasAwait) {
            this.raise(Errors.AwaitBindingIdentifier, {
              at: startLoc
            });
            return;
          }
          if (this.scope.inStaticBlock) {
            this.raise(Errors.AwaitBindingIdentifierInStaticBlock, {
              at: startLoc
            });
            return;
          }
          this.expressionScope.recordAsyncArrowParametersError({
            at: startLoc
          });
        } else if (word === "arguments") {
          if (this.scope.inClassAndNotInNonArrowFunction) {
            this.raise(Errors.ArgumentsInClass, {
              at: startLoc
            });
            return;
          }
        }
        if (checkKeywords && isKeyword(word)) {
          this.raise(Errors.UnexpectedKeyword, {
            at: startLoc,
            keyword: word
          });
          return;
        }
        var reservedTest = !this.state.strict ? isReservedWord : isBinding2 ? isStrictBindReservedWord : isStrictReservedWord;
        if (reservedTest(word, this.inModule)) {
          this.raise(Errors.UnexpectedReservedWord, {
            at: startLoc,
            reservedWord: word
          });
        }
      };
      _proto.isAwaitAllowed = function isAwaitAllowed() {
        if (this.prodParam.hasAwait)
          return true;
        if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
          return true;
        }
        return false;
      };
      _proto.parseAwait = function parseAwait(startPos, startLoc) {
        var node2 = this.startNodeAt(startPos, startLoc);
        this.expressionScope.recordParameterInitializerError(Errors.AwaitExpressionFormalParameter, {
          at: node2
        });
        if (this.eat(55)) {
          this.raise(Errors.ObsoleteAwaitStar, {
            at: node2
          });
        }
        if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
          if (this.isAmbiguousAwait()) {
            this.ambiguousScriptDifferentAst = true;
          } else {
            this.sawUnambiguousESM = true;
          }
        }
        if (!this.state.soloAwait) {
          node2.argument = this.parseMaybeUnary(null, true);
        }
        return this.finishNode(node2, "AwaitExpression");
      };
      _proto.isAmbiguousAwait = function isAmbiguousAwait() {
        if (this.hasPrecedingLineBreak())
          return true;
        var type5 = this.state.type;
        return type5 === 53 || type5 === 10 || type5 === 0 || tokenIsTemplate(type5) || type5 === 133 || type5 === 56 || this.hasPlugin("v8intrinsic") && type5 === 54;
      };
      _proto.parseYield = function parseYield() {
        var node2 = this.startNode();
        this.expressionScope.recordParameterInitializerError(Errors.YieldInParameter, {
          at: node2
        });
        this.next();
        var delegating = false;
        var argument = null;
        if (!this.hasPrecedingLineBreak()) {
          delegating = this.eat(55);
          switch (this.state.type) {
            case 13:
            case 135:
            case 8:
            case 11:
            case 3:
            case 9:
            case 14:
            case 12:
              if (!delegating)
                break;
            default:
              argument = this.parseMaybeAssign();
          }
        }
        node2.delegate = delegating;
        node2.argument = argument;
        return this.finishNode(node2, "YieldExpression");
      };
      _proto.checkPipelineAtInfixOperator = function checkPipelineAtInfixOperator(left, leftStartLoc) {
        if (this.hasPlugin(["pipelineOperator", {
          proposal: "smart"
        }])) {
          if (left.type === "SequenceExpression") {
            this.raise(Errors.PipelineHeadSequenceExpression, {
              at: leftStartLoc
            });
          }
        }
      };
      _proto.parseSmartPipelineBodyInStyle = function parseSmartPipelineBodyInStyle(childExpr, startPos, startLoc) {
        var bodyNode = this.startNodeAt(startPos, startLoc);
        if (this.isSimpleReference(childExpr)) {
          bodyNode.callee = childExpr;
          return this.finishNode(bodyNode, "PipelineBareFunction");
        } else {
          this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
          bodyNode.expression = childExpr;
          return this.finishNode(bodyNode, "PipelineTopicExpression");
        }
      };
      _proto.isSimpleReference = function isSimpleReference(expression2) {
        switch (expression2.type) {
          case "MemberExpression":
            return !expression2.computed && this.isSimpleReference(expression2.object);
          case "Identifier":
            return true;
          default:
            return false;
        }
      };
      _proto.checkSmartPipeTopicBodyEarlyErrors = function checkSmartPipeTopicBodyEarlyErrors(startLoc) {
        if (this.match(19)) {
          throw this.raise(Errors.PipelineBodyNoArrow, {
            at: this.state.startLoc
          });
        }
        if (!this.topicReferenceWasUsedInCurrentContext()) {
          this.raise(Errors.PipelineTopicUnused, {
            at: startLoc
          });
        }
      };
      _proto.withTopicBindingContext = function withTopicBindingContext(callback) {
        var outerContextTopicState = this.state.topicContext;
        this.state.topicContext = {
          maxNumOfResolvableTopics: 1,
          maxTopicIndex: null
        };
        try {
          return callback();
        } finally {
          this.state.topicContext = outerContextTopicState;
        }
      };
      _proto.withSmartMixTopicForbiddingContext = function withSmartMixTopicForbiddingContext(callback) {
        if (this.hasPlugin(["pipelineOperator", {
          proposal: "smart"
        }])) {
          var outerContextTopicState = this.state.topicContext;
          this.state.topicContext = {
            maxNumOfResolvableTopics: 0,
            maxTopicIndex: null
          };
          try {
            return callback();
          } finally {
            this.state.topicContext = outerContextTopicState;
          }
        } else {
          return callback();
        }
      };
      _proto.withSoloAwaitPermittingContext = function withSoloAwaitPermittingContext(callback) {
        var outerContextSoloAwaitState = this.state.soloAwait;
        this.state.soloAwait = true;
        try {
          return callback();
        } finally {
          this.state.soloAwait = outerContextSoloAwaitState;
        }
      };
      _proto.allowInAnd = function allowInAnd(callback) {
        var flags = this.prodParam.currentFlags();
        var prodParamToSet = PARAM_IN & ~flags;
        if (prodParamToSet) {
          this.prodParam.enter(flags | PARAM_IN);
          try {
            return callback();
          } finally {
            this.prodParam.exit();
          }
        }
        return callback();
      };
      _proto.disallowInAnd = function disallowInAnd(callback) {
        var flags = this.prodParam.currentFlags();
        var prodParamToClear = PARAM_IN & flags;
        if (prodParamToClear) {
          this.prodParam.enter(flags & ~PARAM_IN);
          try {
            return callback();
          } finally {
            this.prodParam.exit();
          }
        }
        return callback();
      };
      _proto.registerTopicReference = function registerTopicReference() {
        this.state.topicContext.maxTopicIndex = 0;
      };
      _proto.topicReferenceIsAllowedInCurrentContext = function topicReferenceIsAllowedInCurrentContext() {
        return this.state.topicContext.maxNumOfResolvableTopics >= 1;
      };
      _proto.topicReferenceWasUsedInCurrentContext = function topicReferenceWasUsedInCurrentContext() {
        return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
      };
      _proto.parseFSharpPipelineBody = function parseFSharpPipelineBody(prec) {
        var startPos = this.state.start;
        var startLoc = this.state.startLoc;
        this.state.potentialArrowAt = this.state.start;
        var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
        this.state.inFSharpPipelineDirectBody = true;
        var ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startPos, startLoc, prec);
        this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
        return ret;
      };
      _proto.parseModuleExpression = function parseModuleExpression() {
        this.expectPlugin("moduleBlocks");
        var node2 = this.startNode();
        this.next();
        this.eat(5);
        var revertScopes = this.initializeScopes(true);
        this.enterInitialScopes();
        var program2 = this.startNode();
        try {
          node2.body = this.parseProgram(program2, 8, "module");
        } finally {
          revertScopes();
        }
        this.eat(8);
        return this.finishNode(node2, "ModuleExpression");
      };
      _proto.parsePropertyNamePrefixOperator = function parsePropertyNamePrefixOperator(prop2) {
      };
      return _createClass2(ExpressionParser2);
    }(LValParser);
    var loopLabel2 = {
      kind: "loop"
    }, switchLabel2 = {
      kind: "switch"
    };
    var FUNC_NO_FLAGS = 0, FUNC_STATEMENT2 = 1, FUNC_HANGING_STATEMENT2 = 2, FUNC_NULLABLE_ID2 = 4;
    var loneSurrogate2 = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/;
    var keywordRelationalOperator2 = new RegExp("in(?:stanceof)?", "y");
    function babel7CompatTokens(tokens, input) {
      for (var i2 = 0; i2 < tokens.length; i2++) {
        var token = tokens[i2];
        var type5 = token.type;
        if (typeof type5 === "number") {
          {
            if (type5 === 134) {
              var loc = token.loc, start2 = token.start, value = token.value, end2 = token.end;
              var hashEndPos = start2 + 1;
              var hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
              tokens.splice(i2, 1, new Token3({
                type: getExportedToken(27),
                value: "#",
                start: start2,
                end: hashEndPos,
                startLoc: loc.start,
                endLoc: hashEndLoc
              }), new Token3({
                type: getExportedToken(128),
                value,
                start: hashEndPos,
                end: end2,
                startLoc: hashEndLoc,
                endLoc: loc.end
              }));
              i2++;
              continue;
            }
            if (tokenIsTemplate(type5)) {
              var _loc = token.loc, _start = token.start, _value = token.value, _end = token.end;
              var backquoteEnd = _start + 1;
              var backquoteEndLoc = createPositionWithColumnOffset(_loc.start, 1);
              var startToken = void 0;
              if (input.charCodeAt(_start) === 96) {
                startToken = new Token3({
                  type: getExportedToken(22),
                  value: "`",
                  start: _start,
                  end: backquoteEnd,
                  startLoc: _loc.start,
                  endLoc: backquoteEndLoc
                });
              } else {
                startToken = new Token3({
                  type: getExportedToken(8),
                  value: "}",
                  start: _start,
                  end: backquoteEnd,
                  startLoc: _loc.start,
                  endLoc: backquoteEndLoc
                });
              }
              var templateValue = void 0, templateElementEnd = void 0, templateElementEndLoc = void 0, endToken = void 0;
              if (type5 === 24) {
                templateElementEnd = _end - 1;
                templateElementEndLoc = createPositionWithColumnOffset(_loc.end, -1);
                templateValue = _value === null ? null : _value.slice(1, -1);
                endToken = new Token3({
                  type: getExportedToken(22),
                  value: "`",
                  start: templateElementEnd,
                  end: _end,
                  startLoc: templateElementEndLoc,
                  endLoc: _loc.end
                });
              } else {
                templateElementEnd = _end - 2;
                templateElementEndLoc = createPositionWithColumnOffset(_loc.end, -2);
                templateValue = _value === null ? null : _value.slice(1, -2);
                endToken = new Token3({
                  type: getExportedToken(23),
                  value: "${",
                  start: templateElementEnd,
                  end: _end,
                  startLoc: templateElementEndLoc,
                  endLoc: _loc.end
                });
              }
              tokens.splice(i2, 1, startToken, new Token3({
                type: getExportedToken(20),
                value: templateValue,
                start: backquoteEnd,
                end: templateElementEnd,
                startLoc: backquoteEndLoc,
                endLoc: templateElementEndLoc
              }), endToken);
              i2 += 2;
              continue;
            }
          }
          token.type = getExportedToken(type5);
        }
      }
      return tokens;
    }
    var StatementParser = function(_ExpressionParser) {
      _inherits2(StatementParser2, _ExpressionParser);
      function StatementParser2() {
        return _ExpressionParser.apply(this, arguments) || this;
      }
      var _proto = StatementParser2.prototype;
      _proto.parseTopLevel = function parseTopLevel(file2, program2) {
        file2.program = this.parseProgram(program2);
        file2.comments = this.state.comments;
        if (this.options.tokens) {
          file2.tokens = babel7CompatTokens(this.tokens, this.input);
        }
        return this.finishNode(file2, "File");
      };
      _proto.parseProgram = function parseProgram(program2, end2, sourceType) {
        if (end2 === void 0) {
          end2 = 135;
        }
        if (sourceType === void 0) {
          sourceType = this.options.sourceType;
        }
        program2.sourceType = sourceType;
        program2.interpreter = this.parseInterpreterDirective();
        this.parseBlockBody(program2, true, true, end2);
        if (this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
          for (var _i22 = 0, _Array$from2 = Array.from(this.scope.undefinedExports); _i22 < _Array$from2.length; _i22++) {
            var _Array$from2$_i = _Array$from2[_i22], localName = _Array$from2$_i[0], at2 = _Array$from2$_i[1];
            this.raise(Errors.ModuleExportUndefined, {
              at: at2,
              localName
            });
          }
        }
        return this.finishNode(program2, "Program");
      };
      _proto.stmtToDirective = function stmtToDirective(stmt) {
        var directive2 = stmt;
        directive2.type = "Directive";
        directive2.value = directive2.expression;
        delete directive2.expression;
        var directiveLiteral2 = directive2.value;
        var expressionValue = directiveLiteral2.value;
        var raw = this.input.slice(directiveLiteral2.start, directiveLiteral2.end);
        var val = directiveLiteral2.value = raw.slice(1, -1);
        this.addExtra(directiveLiteral2, "raw", raw);
        this.addExtra(directiveLiteral2, "rawValue", val);
        this.addExtra(directiveLiteral2, "expressionValue", expressionValue);
        directiveLiteral2.type = "DirectiveLiteral";
        return directive2;
      };
      _proto.parseInterpreterDirective = function parseInterpreterDirective() {
        if (!this.match(28)) {
          return null;
        }
        var node2 = this.startNode();
        node2.value = this.state.value;
        this.next();
        return this.finishNode(node2, "InterpreterDirective");
      };
      _proto.isLet = function isLet2(context) {
        if (!this.isContextual(99)) {
          return false;
        }
        return this.isLetKeyword(context);
      };
      _proto.isLetKeyword = function isLetKeyword(context) {
        var next = this.nextTokenStart();
        var nextCh = this.codePointAtPos(next);
        if (nextCh === 92 || nextCh === 91) {
          return true;
        }
        if (context)
          return false;
        if (nextCh === 123)
          return true;
        if (isIdentifierStart2(nextCh)) {
          keywordRelationalOperator2.lastIndex = next;
          if (keywordRelationalOperator2.test(this.input)) {
            var endCh = this.codePointAtPos(keywordRelationalOperator2.lastIndex);
            if (!isIdentifierChar2(endCh) && endCh !== 92) {
              return false;
            }
          }
          return true;
        }
        return false;
      };
      _proto.parseStatement = function parseStatement(context, topLevel) {
        if (this.match(26)) {
          this.parseDecorators(true);
        }
        return this.parseStatementContent(context, topLevel);
      };
      _proto.parseStatementContent = function parseStatementContent(context, topLevel) {
        var starttype = this.state.type;
        var node2 = this.startNode();
        var kind;
        if (this.isLet(context)) {
          starttype = 74;
          kind = "let";
        }
        switch (starttype) {
          case 60:
            return this.parseBreakContinueStatement(node2, true);
          case 63:
            return this.parseBreakContinueStatement(node2, false);
          case 64:
            return this.parseDebuggerStatement(node2);
          case 90:
            return this.parseDoStatement(node2);
          case 91:
            return this.parseForStatement(node2);
          case 68:
            if (this.lookaheadCharCode() === 46)
              break;
            if (context) {
              if (this.state.strict) {
                this.raise(Errors.StrictFunction, {
                  at: this.state.startLoc
                });
              } else if (context !== "if" && context !== "label") {
                this.raise(Errors.SloppyFunction, {
                  at: this.state.startLoc
                });
              }
            }
            return this.parseFunctionStatement(node2, false, !context);
          case 80:
            if (context)
              this.unexpected();
            return this.parseClass(node2, true);
          case 69:
            return this.parseIfStatement(node2);
          case 70:
            return this.parseReturnStatement(node2);
          case 71:
            return this.parseSwitchStatement(node2);
          case 72:
            return this.parseThrowStatement(node2);
          case 73:
            return this.parseTryStatement(node2);
          case 75:
          case 74:
            kind = kind || this.state.value;
            if (context && kind !== "var") {
              this.raise(Errors.UnexpectedLexicalDeclaration, {
                at: this.state.startLoc
              });
            }
            return this.parseVarStatement(node2, kind);
          case 92:
            return this.parseWhileStatement(node2);
          case 76:
            return this.parseWithStatement(node2);
          case 5:
            return this.parseBlock();
          case 13:
            return this.parseEmptyStatement(node2);
          case 83: {
            var nextTokenCharCode = this.lookaheadCharCode();
            if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
              break;
            }
          }
          case 82: {
            if (!this.options.allowImportExportEverywhere && !topLevel) {
              this.raise(Errors.UnexpectedImportExport, {
                at: this.state.startLoc
              });
            }
            this.next();
            var result;
            if (starttype === 83) {
              result = this.parseImport(node2);
              if (result.type === "ImportDeclaration" && (!result.importKind || result.importKind === "value")) {
                this.sawUnambiguousESM = true;
              }
            } else {
              result = this.parseExport(node2);
              if (result.type === "ExportNamedDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportAllDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportDefaultDeclaration") {
                this.sawUnambiguousESM = true;
              }
            }
            this.assertModuleNodeAllowed(node2);
            return result;
          }
          default: {
            if (this.isAsyncFunction()) {
              if (context) {
                this.raise(Errors.AsyncFunctionInSingleStatementContext, {
                  at: this.state.startLoc
                });
              }
              this.next();
              return this.parseFunctionStatement(node2, true, !context);
            }
          }
        }
        var maybeName = this.state.value;
        var expr = this.parseExpression();
        if (tokenIsIdentifier(starttype) && expr.type === "Identifier" && this.eat(14)) {
          return this.parseLabeledStatement(node2, maybeName, expr, context);
        } else {
          return this.parseExpressionStatement(node2, expr);
        }
      };
      _proto.assertModuleNodeAllowed = function assertModuleNodeAllowed(node2) {
        if (!this.options.allowImportExportEverywhere && !this.inModule) {
          this.raise(Errors.ImportOutsideModule, {
            at: node2
          });
        }
      };
      _proto.takeDecorators = function takeDecorators2(node2) {
        var decorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];
        if (decorators.length) {
          node2.decorators = decorators;
          this.resetStartLocationFromNode(node2, decorators[0]);
          this.state.decoratorStack[this.state.decoratorStack.length - 1] = [];
        }
      };
      _proto.canHaveLeadingDecorator = function canHaveLeadingDecorator() {
        return this.match(80);
      };
      _proto.parseDecorators = function parseDecorators(allowExport) {
        var currentContextDecorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];
        while (this.match(26)) {
          var decorator2 = this.parseDecorator();
          currentContextDecorators.push(decorator2);
        }
        if (this.match(82)) {
          if (!allowExport) {
            this.unexpected();
          }
          if (this.hasPlugin("decorators") && !this.getPluginOption("decorators", "decoratorsBeforeExport")) {
            this.raise(Errors.DecoratorExportClass, {
              at: this.state.startLoc
            });
          }
        } else if (!this.canHaveLeadingDecorator()) {
          throw this.raise(Errors.UnexpectedLeadingDecorator, {
            at: this.state.startLoc
          });
        }
      };
      _proto.parseDecorator = function parseDecorator() {
        this.expectOnePlugin(["decorators-legacy", "decorators"]);
        var node2 = this.startNode();
        this.next();
        if (this.hasPlugin("decorators")) {
          this.state.decoratorStack.push([]);
          var startPos = this.state.start;
          var startLoc = this.state.startLoc;
          var expr;
          if (this.match(10)) {
            var _startPos = this.state.start;
            var _startLoc = this.state.startLoc;
            this.next();
            expr = this.parseExpression();
            this.expect(11);
            expr = this.wrapParenthesis(_startPos, _startLoc, expr);
          } else {
            expr = this.parseIdentifier(false);
            while (this.eat(16)) {
              var _node = this.startNodeAt(startPos, startLoc);
              _node.object = expr;
              _node.property = this.parseIdentifier(true);
              _node.computed = false;
              expr = this.finishNode(_node, "MemberExpression");
            }
          }
          node2.expression = this.parseMaybeDecoratorArguments(expr);
          this.state.decoratorStack.pop();
        } else {
          node2.expression = this.parseExprSubscripts();
        }
        return this.finishNode(node2, "Decorator");
      };
      _proto.parseMaybeDecoratorArguments = function parseMaybeDecoratorArguments(expr) {
        if (this.eat(10)) {
          var node2 = this.startNodeAtNode(expr);
          node2.callee = expr;
          node2.arguments = this.parseCallExpressionArguments(11, false);
          this.toReferencedList(node2.arguments);
          return this.finishNode(node2, "CallExpression");
        }
        return expr;
      };
      _proto.parseBreakContinueStatement = function parseBreakContinueStatement(node2, isBreak) {
        this.next();
        if (this.isLineTerminator()) {
          node2.label = null;
        } else {
          node2.label = this.parseIdentifier();
          this.semicolon();
        }
        this.verifyBreakContinue(node2, isBreak);
        return this.finishNode(node2, isBreak ? "BreakStatement" : "ContinueStatement");
      };
      _proto.verifyBreakContinue = function verifyBreakContinue(node2, isBreak) {
        var i2;
        for (i2 = 0; i2 < this.state.labels.length; ++i2) {
          var lab = this.state.labels[i2];
          if (node2.label == null || lab.name === node2.label.name) {
            if (lab.kind != null && (isBreak || lab.kind === "loop"))
              break;
            if (node2.label && isBreak)
              break;
          }
        }
        if (i2 === this.state.labels.length) {
          var type5 = isBreak ? "BreakStatement" : "ContinueStatement";
          this.raise(Errors.IllegalBreakContinue, {
            at: node2,
            type: type5
          });
        }
      };
      _proto.parseDebuggerStatement = function parseDebuggerStatement(node2) {
        this.next();
        this.semicolon();
        return this.finishNode(node2, "DebuggerStatement");
      };
      _proto.parseHeaderExpression = function parseHeaderExpression() {
        this.expect(10);
        var val = this.parseExpression();
        this.expect(11);
        return val;
      };
      _proto.parseDoStatement = function parseDoStatement(node2) {
        var _this = this;
        this.next();
        this.state.labels.push(loopLabel2);
        node2.body = this.withSmartMixTopicForbiddingContext(function() {
          return _this.parseStatement("do");
        });
        this.state.labels.pop();
        this.expect(92);
        node2.test = this.parseHeaderExpression();
        this.eat(13);
        return this.finishNode(node2, "DoWhileStatement");
      };
      _proto.parseForStatement = function parseForStatement(node2) {
        this.next();
        this.state.labels.push(loopLabel2);
        var awaitAt = null;
        if (this.isAwaitAllowed() && this.eatContextual(96)) {
          awaitAt = this.state.lastTokStartLoc;
        }
        this.scope.enter(SCOPE_OTHER);
        this.expect(10);
        if (this.match(13)) {
          if (awaitAt !== null) {
            this.unexpected(awaitAt);
          }
          return this.parseFor(node2, null);
        }
        var startsWithLet = this.isContextual(99);
        var isLet2 = startsWithLet && this.isLetKeyword();
        if (this.match(74) || this.match(75) || isLet2) {
          var _init = this.startNode();
          var kind = isLet2 ? "let" : this.state.value;
          this.next();
          this.parseVar(_init, true, kind);
          this.finishNode(_init, "VariableDeclaration");
          if ((this.match(58) || this.isContextual(101)) && _init.declarations.length === 1) {
            return this.parseForIn(node2, _init, awaitAt);
          }
          if (awaitAt !== null) {
            this.unexpected(awaitAt);
          }
          return this.parseFor(node2, _init);
        }
        var startsWithAsync = this.isContextual(95);
        var refExpressionErrors = new ExpressionErrors();
        var init3 = this.parseExpression(true, refExpressionErrors);
        var isForOf = this.isContextual(101);
        if (isForOf) {
          if (startsWithLet) {
            this.raise(Errors.ForOfLet, {
              at: init3
            });
          }
          if (awaitAt === null && startsWithAsync && init3.type === "Identifier") {
            this.raise(Errors.ForOfAsync, {
              at: init3
            });
          }
        }
        if (isForOf || this.match(58)) {
          this.checkDestructuringPrivate(refExpressionErrors);
          this.toAssignable(init3, true);
          var type5 = isForOf ? "ForOfStatement" : "ForInStatement";
          this.checkLVal(init3, {
            "in": {
              type: type5
            }
          });
          return this.parseForIn(node2, init3, awaitAt);
        } else {
          this.checkExpressionErrors(refExpressionErrors, true);
        }
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node2, init3);
      };
      _proto.parseFunctionStatement = function parseFunctionStatement(node2, isAsync2, declarationPosition) {
        this.next();
        return this.parseFunction(node2, FUNC_STATEMENT2 | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT2), isAsync2);
      };
      _proto.parseIfStatement = function parseIfStatement(node2) {
        this.next();
        node2.test = this.parseHeaderExpression();
        node2.consequent = this.parseStatement("if");
        node2.alternate = this.eat(66) ? this.parseStatement("if") : null;
        return this.finishNode(node2, "IfStatement");
      };
      _proto.parseReturnStatement = function parseReturnStatement(node2) {
        if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
          this.raise(Errors.IllegalReturn, {
            at: this.state.startLoc
          });
        }
        this.next();
        if (this.isLineTerminator()) {
          node2.argument = null;
        } else {
          node2.argument = this.parseExpression();
          this.semicolon();
        }
        return this.finishNode(node2, "ReturnStatement");
      };
      _proto.parseSwitchStatement = function parseSwitchStatement(node2) {
        this.next();
        node2.discriminant = this.parseHeaderExpression();
        var cases = node2.cases = [];
        this.expect(5);
        this.state.labels.push(switchLabel2);
        this.scope.enter(SCOPE_OTHER);
        var cur;
        for (var sawDefault; !this.match(8); ) {
          if (this.match(61) || this.match(65)) {
            var isCase = this.match(61);
            if (cur)
              this.finishNode(cur, "SwitchCase");
            cases.push(cur = this.startNode());
            cur.consequent = [];
            this.next();
            if (isCase) {
              cur.test = this.parseExpression();
            } else {
              if (sawDefault) {
                this.raise(Errors.MultipleDefaultsInSwitch, {
                  at: this.state.lastTokStartLoc
                });
              }
              sawDefault = true;
              cur.test = null;
            }
            this.expect(14);
          } else {
            if (cur) {
              cur.consequent.push(this.parseStatement(null));
            } else {
              this.unexpected();
            }
          }
        }
        this.scope.exit();
        if (cur)
          this.finishNode(cur, "SwitchCase");
        this.next();
        this.state.labels.pop();
        return this.finishNode(node2, "SwitchStatement");
      };
      _proto.parseThrowStatement = function parseThrowStatement(node2) {
        this.next();
        if (this.hasPrecedingLineBreak()) {
          this.raise(Errors.NewlineAfterThrow, {
            at: this.state.lastTokEndLoc
          });
        }
        node2.argument = this.parseExpression();
        this.semicolon();
        return this.finishNode(node2, "ThrowStatement");
      };
      _proto.parseCatchClauseParam = function parseCatchClauseParam() {
        var param = this.parseBindingAtom();
        var simple = param.type === "Identifier";
        this.scope.enter(simple ? SCOPE_SIMPLE_CATCH2 : 0);
        this.checkLVal(param, {
          "in": {
            type: "CatchClause"
          },
          binding: BIND_LEXICAL2,
          allowingSloppyLetBinding: true
        });
        return param;
      };
      _proto.parseTryStatement = function parseTryStatement(node2) {
        var _this2 = this;
        this.next();
        node2.block = this.parseBlock();
        node2.handler = null;
        if (this.match(62)) {
          var clause = this.startNode();
          this.next();
          if (this.match(10)) {
            this.expect(10);
            clause.param = this.parseCatchClauseParam();
            this.expect(11);
          } else {
            clause.param = null;
            this.scope.enter(SCOPE_OTHER);
          }
          clause.body = this.withSmartMixTopicForbiddingContext(function() {
            return _this2.parseBlock(false, false);
          });
          this.scope.exit();
          node2.handler = this.finishNode(clause, "CatchClause");
        }
        node2.finalizer = this.eat(67) ? this.parseBlock() : null;
        if (!node2.handler && !node2.finalizer) {
          this.raise(Errors.NoCatchOrFinally, {
            at: node2
          });
        }
        return this.finishNode(node2, "TryStatement");
      };
      _proto.parseVarStatement = function parseVarStatement(node2, kind, allowMissingInitializer) {
        if (allowMissingInitializer === void 0) {
          allowMissingInitializer = false;
        }
        this.next();
        this.parseVar(node2, false, kind, allowMissingInitializer);
        this.semicolon();
        return this.finishNode(node2, "VariableDeclaration");
      };
      _proto.parseWhileStatement = function parseWhileStatement(node2) {
        var _this3 = this;
        this.next();
        node2.test = this.parseHeaderExpression();
        this.state.labels.push(loopLabel2);
        node2.body = this.withSmartMixTopicForbiddingContext(function() {
          return _this3.parseStatement("while");
        });
        this.state.labels.pop();
        return this.finishNode(node2, "WhileStatement");
      };
      _proto.parseWithStatement = function parseWithStatement(node2) {
        var _this4 = this;
        if (this.state.strict) {
          this.raise(Errors.StrictWith, {
            at: this.state.startLoc
          });
        }
        this.next();
        node2.object = this.parseHeaderExpression();
        node2.body = this.withSmartMixTopicForbiddingContext(function() {
          return _this4.parseStatement("with");
        });
        return this.finishNode(node2, "WithStatement");
      };
      _proto.parseEmptyStatement = function parseEmptyStatement(node2) {
        this.next();
        return this.finishNode(node2, "EmptyStatement");
      };
      _proto.parseLabeledStatement = function parseLabeledStatement(node2, maybeName, expr, context) {
        for (var _i4 = 0, _this$state$labels2 = this.state.labels; _i4 < _this$state$labels2.length; _i4++) {
          var label = _this$state$labels2[_i4];
          if (label.name === maybeName) {
            this.raise(Errors.LabelRedeclaration, {
              at: expr,
              labelName: maybeName
            });
          }
        }
        var kind = tokenIsLoop(this.state.type) ? "loop" : this.match(71) ? "switch" : null;
        for (var i2 = this.state.labels.length - 1; i2 >= 0; i2--) {
          var _label = this.state.labels[i2];
          if (_label.statementStart === node2.start) {
            _label.statementStart = this.state.start;
            _label.kind = kind;
          } else {
            break;
          }
        }
        this.state.labels.push({
          name: maybeName,
          kind,
          statementStart: this.state.start
        });
        node2.body = this.parseStatement(context ? context.indexOf("label") === -1 ? context + "label" : context : "label");
        this.state.labels.pop();
        node2.label = expr;
        return this.finishNode(node2, "LabeledStatement");
      };
      _proto.parseExpressionStatement = function parseExpressionStatement(node2, expr) {
        node2.expression = expr;
        this.semicolon();
        return this.finishNode(node2, "ExpressionStatement");
      };
      _proto.parseBlock = function parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
        if (allowDirectives === void 0) {
          allowDirectives = false;
        }
        if (createNewLexicalScope === void 0) {
          createNewLexicalScope = true;
        }
        var node2 = this.startNode();
        if (allowDirectives) {
          this.state.strictErrors.clear();
        }
        this.expect(5);
        if (createNewLexicalScope) {
          this.scope.enter(SCOPE_OTHER);
        }
        this.parseBlockBody(node2, allowDirectives, false, 8, afterBlockParse);
        if (createNewLexicalScope) {
          this.scope.exit();
        }
        return this.finishNode(node2, "BlockStatement");
      };
      _proto.isValidDirective = function isValidDirective(stmt) {
        return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
      };
      _proto.parseBlockBody = function parseBlockBody(node2, allowDirectives, topLevel, end2, afterBlockParse) {
        var body = node2.body = [];
        var directives = node2.directives = [];
        this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : void 0, topLevel, end2, afterBlockParse);
      };
      _proto.parseBlockOrModuleBlockBody = function parseBlockOrModuleBlockBody(body, directives, topLevel, end2, afterBlockParse) {
        var oldStrict = this.state.strict;
        var hasStrictModeDirective = false;
        var parsedNonDirective = false;
        while (!this.match(end2)) {
          var stmt = this.parseStatement(null, topLevel);
          if (directives && !parsedNonDirective) {
            if (this.isValidDirective(stmt)) {
              var directive2 = this.stmtToDirective(stmt);
              directives.push(directive2);
              if (!hasStrictModeDirective && directive2.value.value === "use strict") {
                hasStrictModeDirective = true;
                this.setStrict(true);
              }
              continue;
            }
            parsedNonDirective = true;
            this.state.strictErrors.clear();
          }
          body.push(stmt);
        }
        if (afterBlockParse) {
          afterBlockParse.call(this, hasStrictModeDirective);
        }
        if (!oldStrict) {
          this.setStrict(false);
        }
        this.next();
      };
      _proto.parseFor = function parseFor(node2, init3) {
        var _this5 = this;
        node2.init = init3;
        this.semicolon(false);
        node2.test = this.match(13) ? null : this.parseExpression();
        this.semicolon(false);
        node2.update = this.match(11) ? null : this.parseExpression();
        this.expect(11);
        node2.body = this.withSmartMixTopicForbiddingContext(function() {
          return _this5.parseStatement("for");
        });
        this.scope.exit();
        this.state.labels.pop();
        return this.finishNode(node2, "ForStatement");
      };
      _proto.parseForIn = function parseForIn(node2, init3, awaitAt) {
        var _this6 = this;
        var isForIn = this.match(58);
        this.next();
        if (isForIn) {
          if (awaitAt !== null)
            this.unexpected(awaitAt);
        } else {
          node2["await"] = awaitAt !== null;
        }
        if (init3.type === "VariableDeclaration" && init3.declarations[0].init != null && (!isForIn || this.state.strict || init3.kind !== "var" || init3.declarations[0].id.type !== "Identifier")) {
          this.raise(Errors.ForInOfLoopInitializer, {
            at: init3,
            type: isForIn ? "ForInStatement" : "ForOfStatement"
          });
        }
        if (init3.type === "AssignmentPattern") {
          this.raise(Errors.InvalidLhs, {
            at: init3,
            ancestor: {
              type: "ForStatement"
            }
          });
        }
        node2.left = init3;
        node2.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
        this.expect(11);
        node2.body = this.withSmartMixTopicForbiddingContext(function() {
          return _this6.parseStatement("for");
        });
        this.scope.exit();
        this.state.labels.pop();
        return this.finishNode(node2, isForIn ? "ForInStatement" : "ForOfStatement");
      };
      _proto.parseVar = function parseVar(node2, isFor2, kind, allowMissingInitializer) {
        if (allowMissingInitializer === void 0) {
          allowMissingInitializer = false;
        }
        var declarations = node2.declarations = [];
        node2.kind = kind;
        for (; ; ) {
          var decl = this.startNode();
          this.parseVarId(decl, kind);
          decl.init = !this.eat(29) ? null : isFor2 ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
          if (decl.init === null && !allowMissingInitializer) {
            if (decl.id.type !== "Identifier" && !(isFor2 && (this.match(58) || this.isContextual(101)))) {
              this.raise(Errors.DeclarationMissingInitializer, {
                at: this.state.lastTokEndLoc,
                kind: "destructuring"
              });
            } else if (kind === "const" && !(this.match(58) || this.isContextual(101))) {
              this.raise(Errors.DeclarationMissingInitializer, {
                at: this.state.lastTokEndLoc,
                kind: "const"
              });
            }
          }
          declarations.push(this.finishNode(decl, "VariableDeclarator"));
          if (!this.eat(12))
            break;
        }
        return node2;
      };
      _proto.parseVarId = function parseVarId(decl, kind) {
        decl.id = this.parseBindingAtom();
        this.checkLVal(decl.id, {
          "in": {
            type: "VariableDeclarator"
          },
          binding: kind === "var" ? BIND_VAR2 : BIND_LEXICAL2
        });
      };
      _proto.parseFunction = function parseFunction(node2, statement2, isAsync2) {
        var _this7 = this;
        if (statement2 === void 0) {
          statement2 = FUNC_NO_FLAGS;
        }
        if (isAsync2 === void 0) {
          isAsync2 = false;
        }
        var isStatement2 = statement2 & FUNC_STATEMENT2;
        var isHangingStatement = statement2 & FUNC_HANGING_STATEMENT2;
        var requireId = !!isStatement2 && !(statement2 & FUNC_NULLABLE_ID2);
        this.initFunction(node2, isAsync2);
        if (this.match(55) && isHangingStatement) {
          this.raise(Errors.GeneratorInSingleStatementContext, {
            at: this.state.startLoc
          });
        }
        node2.generator = this.eat(55);
        if (isStatement2) {
          node2.id = this.parseFunctionId(requireId);
        }
        var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        this.state.maybeInArrowParameters = false;
        this.scope.enter(SCOPE_FUNCTION2);
        this.prodParam.enter(functionFlags2(isAsync2, node2.generator));
        if (!isStatement2) {
          node2.id = this.parseFunctionId();
        }
        this.parseFunctionParams(node2, false);
        this.withSmartMixTopicForbiddingContext(function() {
          _this7.parseFunctionBodyAndFinish(node2, isStatement2 ? "FunctionDeclaration" : "FunctionExpression");
        });
        this.prodParam.exit();
        this.scope.exit();
        if (isStatement2 && !isHangingStatement) {
          this.registerFunctionStatementId(node2);
        }
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        return node2;
      };
      _proto.parseFunctionId = function parseFunctionId(requireId) {
        return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
      };
      _proto.parseFunctionParams = function parseFunctionParams(node2, allowModifiers) {
        this.expect(10);
        this.expressionScope.enter(newParameterDeclarationScope());
        node2.params = this.parseBindingList(11, 41, false, allowModifiers);
        this.expressionScope.exit();
      };
      _proto.registerFunctionStatementId = function registerFunctionStatementId(node2) {
        if (!node2.id)
          return;
        this.scope.declareName(node2.id.name, this.state.strict || node2.generator || node2.async ? this.scope.treatFunctionsAsVar ? BIND_VAR2 : BIND_LEXICAL2 : BIND_FUNCTION2, node2.id.loc.start);
      };
      _proto.parseClass = function parseClass(node2, isStatement2, optionalId) {
        this.next();
        this.takeDecorators(node2);
        var oldStrict = this.state.strict;
        this.state.strict = true;
        this.parseClassId(node2, isStatement2, optionalId);
        this.parseClassSuper(node2);
        node2.body = this.parseClassBody(!!node2.superClass, oldStrict);
        return this.finishNode(node2, isStatement2 ? "ClassDeclaration" : "ClassExpression");
      };
      _proto.isClassProperty = function isClassProperty2() {
        return this.match(29) || this.match(13) || this.match(8);
      };
      _proto.isClassMethod = function isClassMethod2() {
        return this.match(10);
      };
      _proto.isNonstaticConstructor = function isNonstaticConstructor(method5) {
        return !method5.computed && !method5["static"] && (method5.key.name === "constructor" || method5.key.value === "constructor");
      };
      _proto.parseClassBody = function parseClassBody(hadSuperClass, oldStrict) {
        var _this8 = this;
        this.classScope.enter();
        var state = {
          hadConstructor: false,
          hadSuperClass
        };
        var decorators = [];
        var classBody2 = this.startNode();
        classBody2.body = [];
        this.expect(5);
        this.withSmartMixTopicForbiddingContext(function() {
          while (!_this8.match(8)) {
            if (_this8.eat(13)) {
              if (decorators.length > 0) {
                throw _this8.raise(Errors.DecoratorSemicolon, {
                  at: _this8.state.lastTokEndLoc
                });
              }
              continue;
            }
            if (_this8.match(26)) {
              decorators.push(_this8.parseDecorator());
              continue;
            }
            var member = _this8.startNode();
            if (decorators.length) {
              member.decorators = decorators;
              _this8.resetStartLocationFromNode(member, decorators[0]);
              decorators = [];
            }
            _this8.parseClassMember(classBody2, member, state);
            if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
              _this8.raise(Errors.DecoratorConstructor, {
                at: member
              });
            }
          }
        });
        this.state.strict = oldStrict;
        this.next();
        if (decorators.length) {
          throw this.raise(Errors.TrailingDecorator, {
            at: this.state.startLoc
          });
        }
        this.classScope.exit();
        return this.finishNode(classBody2, "ClassBody");
      };
      _proto.parseClassMemberFromModifier = function parseClassMemberFromModifier(classBody2, member) {
        var key2 = this.parseIdentifier(true);
        if (this.isClassMethod()) {
          var method5 = member;
          method5.kind = "method";
          method5.computed = false;
          method5.key = key2;
          method5["static"] = false;
          this.pushClassMethod(classBody2, method5, false, false, false, false);
          return true;
        } else if (this.isClassProperty()) {
          var prop2 = member;
          prop2.computed = false;
          prop2.key = key2;
          prop2["static"] = false;
          classBody2.body.push(this.parseClassProperty(prop2));
          return true;
        }
        this.resetPreviousNodeTrailingComments(key2);
        return false;
      };
      _proto.parseClassMember = function parseClassMember(classBody2, member, state) {
        var isStatic2 = this.isContextual(104);
        if (isStatic2) {
          if (this.parseClassMemberFromModifier(classBody2, member)) {
            return;
          }
          if (this.eat(5)) {
            this.parseClassStaticBlock(classBody2, member);
            return;
          }
        }
        this.parseClassMemberWithIsStatic(classBody2, member, state, isStatic2);
      };
      _proto.parseClassMemberWithIsStatic = function parseClassMemberWithIsStatic(classBody2, member, state, isStatic2) {
        var publicMethod = member;
        var privateMethod = member;
        var publicProp = member;
        var privateProp = member;
        var accessorProp = member;
        var method5 = publicMethod;
        var publicMember = publicMethod;
        member["static"] = isStatic2;
        this.parsePropertyNamePrefixOperator(member);
        if (this.eat(55)) {
          method5.kind = "method";
          var isPrivateName2 = this.match(134);
          this.parseClassElementName(method5);
          if (isPrivateName2) {
            this.pushClassPrivateMethod(classBody2, privateMethod, true, false);
            return;
          }
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsGenerator, {
              at: publicMethod.key
            });
          }
          this.pushClassMethod(classBody2, publicMethod, true, false, false, false);
          return;
        }
        var isContextual = tokenIsIdentifier(this.state.type) && !this.state.containsEsc;
        var isPrivate2 = this.match(134);
        var key2 = this.parseClassElementName(member);
        var maybeQuestionTokenStartLoc = this.state.startLoc;
        this.parsePostMemberNameModifiers(publicMember);
        if (this.isClassMethod()) {
          method5.kind = "method";
          if (isPrivate2) {
            this.pushClassPrivateMethod(classBody2, privateMethod, false, false);
            return;
          }
          var isConstructor = this.isNonstaticConstructor(publicMethod);
          var allowsDirectSuper = false;
          if (isConstructor) {
            publicMethod.kind = "constructor";
            if (state.hadConstructor && !this.hasPlugin("typescript")) {
              this.raise(Errors.DuplicateConstructor, {
                at: key2
              });
            }
            if (isConstructor && this.hasPlugin("typescript") && member.override) {
              this.raise(Errors.OverrideOnConstructor, {
                at: key2
              });
            }
            state.hadConstructor = true;
            allowsDirectSuper = state.hadSuperClass;
          }
          this.pushClassMethod(classBody2, publicMethod, false, false, isConstructor, allowsDirectSuper);
        } else if (this.isClassProperty()) {
          if (isPrivate2) {
            this.pushClassPrivateProperty(classBody2, privateProp);
          } else {
            this.pushClassProperty(classBody2, publicProp);
          }
        } else if (isContextual && key2.name === "async" && !this.isLineTerminator()) {
          this.resetPreviousNodeTrailingComments(key2);
          var isGenerator = this.eat(55);
          if (publicMember.optional) {
            this.unexpected(maybeQuestionTokenStartLoc);
          }
          method5.kind = "method";
          var _isPrivate = this.match(134);
          this.parseClassElementName(method5);
          this.parsePostMemberNameModifiers(publicMember);
          if (_isPrivate) {
            this.pushClassPrivateMethod(classBody2, privateMethod, isGenerator, true);
          } else {
            if (this.isNonstaticConstructor(publicMethod)) {
              this.raise(Errors.ConstructorIsAsync, {
                at: publicMethod.key
              });
            }
            this.pushClassMethod(classBody2, publicMethod, isGenerator, true, false, false);
          }
        } else if (isContextual && (key2.name === "get" || key2.name === "set") && !(this.match(55) && this.isLineTerminator())) {
          this.resetPreviousNodeTrailingComments(key2);
          method5.kind = key2.name;
          var _isPrivate2 = this.match(134);
          this.parseClassElementName(publicMethod);
          if (_isPrivate2) {
            this.pushClassPrivateMethod(classBody2, privateMethod, false, false);
          } else {
            if (this.isNonstaticConstructor(publicMethod)) {
              this.raise(Errors.ConstructorIsAccessor, {
                at: publicMethod.key
              });
            }
            this.pushClassMethod(classBody2, publicMethod, false, false, false, false);
          }
          this.checkGetterSetterParams(publicMethod);
        } else if (isContextual && key2.name === "accessor" && !this.isLineTerminator()) {
          this.expectPlugin("decoratorAutoAccessors");
          this.resetPreviousNodeTrailingComments(key2);
          var _isPrivate3 = this.match(134);
          this.parseClassElementName(publicProp);
          this.pushClassAccessorProperty(classBody2, accessorProp, _isPrivate3);
        } else if (this.isLineTerminator()) {
          if (isPrivate2) {
            this.pushClassPrivateProperty(classBody2, privateProp);
          } else {
            this.pushClassProperty(classBody2, publicProp);
          }
        } else {
          this.unexpected();
        }
      };
      _proto.parseClassElementName = function parseClassElementName(member) {
        var _this$state = this.state, type5 = _this$state.type, value = _this$state.value;
        if ((type5 === 128 || type5 === 129) && member["static"] && value === "prototype") {
          this.raise(Errors.StaticPrototype, {
            at: this.state.startLoc
          });
        }
        if (type5 === 134) {
          if (value === "constructor") {
            this.raise(Errors.ConstructorClassPrivateField, {
              at: this.state.startLoc
            });
          }
          var key2 = this.parsePrivateName();
          member.key = key2;
          return key2;
        }
        return this.parsePropertyName(member);
      };
      _proto.parseClassStaticBlock = function parseClassStaticBlock(classBody2, member) {
        var _member$decorators;
        this.scope.enter(SCOPE_CLASS | SCOPE_STATIC_BLOCK | SCOPE_SUPER2);
        var oldLabels = this.state.labels;
        this.state.labels = [];
        this.prodParam.enter(PARAM);
        var body = member.body = [];
        this.parseBlockOrModuleBlockBody(body, void 0, false, 8);
        this.prodParam.exit();
        this.scope.exit();
        this.state.labels = oldLabels;
        classBody2.body.push(this.finishNode(member, "StaticBlock"));
        if ((_member$decorators = member.decorators) != null && _member$decorators.length) {
          this.raise(Errors.DecoratorStaticBlock, {
            at: member
          });
        }
      };
      _proto.pushClassProperty = function pushClassProperty(classBody2, prop2) {
        if (!prop2.computed && (prop2.key.name === "constructor" || prop2.key.value === "constructor")) {
          this.raise(Errors.ConstructorClassField, {
            at: prop2.key
          });
        }
        classBody2.body.push(this.parseClassProperty(prop2));
      };
      _proto.pushClassPrivateProperty = function pushClassPrivateProperty(classBody2, prop2) {
        var node2 = this.parseClassPrivateProperty(prop2);
        classBody2.body.push(node2);
        this.classScope.declarePrivateName(this.getPrivateNameSV(node2.key), CLASS_ELEMENT_OTHER, node2.key.loc.start);
      };
      _proto.pushClassAccessorProperty = function pushClassAccessorProperty(classBody2, prop2, isPrivate2) {
        if (!isPrivate2 && !prop2.computed) {
          var key2 = prop2.key;
          if (key2.name === "constructor" || key2.value === "constructor") {
            this.raise(Errors.ConstructorClassField, {
              at: key2
            });
          }
        }
        var node2 = this.parseClassAccessorProperty(prop2);
        classBody2.body.push(node2);
        if (isPrivate2) {
          this.classScope.declarePrivateName(this.getPrivateNameSV(node2.key), CLASS_ELEMENT_OTHER, node2.key.loc.start);
        }
      };
      _proto.pushClassMethod = function pushClassMethod(classBody2, method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper) {
        classBody2.body.push(this.parseMethod(method5, isGenerator, isAsync2, isConstructor, allowsDirectSuper, "ClassMethod", true));
      };
      _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody2, method5, isGenerator, isAsync2) {
        var node2 = this.parseMethod(method5, isGenerator, isAsync2, false, false, "ClassPrivateMethod", true);
        classBody2.body.push(node2);
        var kind = node2.kind === "get" ? node2["static"] ? CLASS_ELEMENT_STATIC_GETTER : CLASS_ELEMENT_INSTANCE_GETTER : node2.kind === "set" ? node2["static"] ? CLASS_ELEMENT_STATIC_SETTER : CLASS_ELEMENT_INSTANCE_SETTER : CLASS_ELEMENT_OTHER;
        this.declareClassPrivateMethodInScope(node2, kind);
      };
      _proto.declareClassPrivateMethodInScope = function declareClassPrivateMethodInScope(node2, kind) {
        this.classScope.declarePrivateName(this.getPrivateNameSV(node2.key), kind, node2.key.loc.start);
      };
      _proto.parsePostMemberNameModifiers = function parsePostMemberNameModifiers(methodOrProp) {
      };
      _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node2) {
        this.parseInitializer(node2);
        this.semicolon();
        return this.finishNode(node2, "ClassPrivateProperty");
      };
      _proto.parseClassProperty = function parseClassProperty(node2) {
        this.parseInitializer(node2);
        this.semicolon();
        return this.finishNode(node2, "ClassProperty");
      };
      _proto.parseClassAccessorProperty = function parseClassAccessorProperty(node2) {
        this.parseInitializer(node2);
        this.semicolon();
        return this.finishNode(node2, "ClassAccessorProperty");
      };
      _proto.parseInitializer = function parseInitializer(node2) {
        this.scope.enter(SCOPE_CLASS | SCOPE_SUPER2);
        this.expressionScope.enter(newExpressionScope());
        this.prodParam.enter(PARAM);
        node2.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
        this.expressionScope.exit();
        this.prodParam.exit();
        this.scope.exit();
      };
      _proto.parseClassId = function parseClassId(node2, isStatement2, optionalId, bindingType) {
        if (bindingType === void 0) {
          bindingType = BIND_CLASS;
        }
        if (tokenIsIdentifier(this.state.type)) {
          node2.id = this.parseIdentifier();
          if (isStatement2) {
            this.declareNameFromIdentifier(node2.id, bindingType);
          }
        } else {
          if (optionalId || !isStatement2) {
            node2.id = null;
          } else {
            throw this.raise(Errors.MissingClassName, {
              at: this.state.startLoc
            });
          }
        }
      };
      _proto.parseClassSuper = function parseClassSuper(node2) {
        node2.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
      };
      _proto.parseExport = function parseExport(node2) {
        var hasDefault = this.maybeParseExportDefaultSpecifier(node2);
        var parseAfterDefault = !hasDefault || this.eat(12);
        var hasStar = parseAfterDefault && this.eatExportStar(node2);
        var hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node2);
        var parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
        var isFromRequired = hasDefault || hasStar;
        if (hasStar && !hasNamespace) {
          if (hasDefault)
            this.unexpected();
          this.parseExportFrom(node2, true);
          return this.finishNode(node2, "ExportAllDeclaration");
        }
        var hasSpecifiers = this.maybeParseExportNamedSpecifiers(node2);
        if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers || hasNamespace && parseAfterNamespace && !hasSpecifiers) {
          throw this.unexpected(null, 5);
        }
        var hasDeclaration;
        if (isFromRequired || hasSpecifiers) {
          hasDeclaration = false;
          this.parseExportFrom(node2, isFromRequired);
        } else {
          hasDeclaration = this.maybeParseExportDeclaration(node2);
        }
        if (isFromRequired || hasSpecifiers || hasDeclaration) {
          this.checkExport(node2, true, false, !!node2.source);
          return this.finishNode(node2, "ExportNamedDeclaration");
        }
        if (this.eat(65)) {
          node2.declaration = this.parseExportDefaultExpression();
          this.checkExport(node2, true, true);
          return this.finishNode(node2, "ExportDefaultDeclaration");
        }
        throw this.unexpected(null, 5);
      };
      _proto.eatExportStar = function eatExportStar(node2) {
        return this.eat(55);
      };
      _proto.maybeParseExportDefaultSpecifier = function maybeParseExportDefaultSpecifier(node2) {
        if (this.isExportDefaultSpecifier()) {
          this.expectPlugin("exportDefaultFrom");
          var specifier = this.startNode();
          specifier.exported = this.parseIdentifier(true);
          node2.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
          return true;
        }
        return false;
      };
      _proto.maybeParseExportNamespaceSpecifier = function maybeParseExportNamespaceSpecifier(node2) {
        if (this.isContextual(93)) {
          if (!node2.specifiers)
            node2.specifiers = [];
          var specifier = this.startNodeAt(this.state.lastTokStart, this.state.lastTokStartLoc);
          this.next();
          specifier.exported = this.parseModuleExportName();
          node2.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
          return true;
        }
        return false;
      };
      _proto.maybeParseExportNamedSpecifiers = function maybeParseExportNamedSpecifiers(node2) {
        if (this.match(5)) {
          var _node$specifiers;
          if (!node2.specifiers)
            node2.specifiers = [];
          var isTypeExport = node2.exportKind === "type";
          (_node$specifiers = node2.specifiers).push.apply(_node$specifiers, this.parseExportSpecifiers(isTypeExport));
          node2.source = null;
          node2.declaration = null;
          if (this.hasPlugin("importAssertions")) {
            node2.assertions = [];
          }
          return true;
        }
        return false;
      };
      _proto.maybeParseExportDeclaration = function maybeParseExportDeclaration(node2) {
        if (this.shouldParseExportDeclaration()) {
          node2.specifiers = [];
          node2.source = null;
          if (this.hasPlugin("importAssertions")) {
            node2.assertions = [];
          }
          node2.declaration = this.parseExportDeclaration(node2);
          return true;
        }
        return false;
      };
      _proto.isAsyncFunction = function isAsyncFunction() {
        if (!this.isContextual(95))
          return false;
        var next = this.nextTokenStart();
        return !lineBreak2.test(this.input.slice(this.state.pos, next)) && this.isUnparsedContextual(next, "function");
      };
      _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
        var expr = this.startNode();
        var isAsync2 = this.isAsyncFunction();
        if (this.match(68) || isAsync2) {
          this.next();
          if (isAsync2) {
            this.next();
          }
          return this.parseFunction(expr, FUNC_STATEMENT2 | FUNC_NULLABLE_ID2, isAsync2);
        }
        if (this.match(80)) {
          return this.parseClass(expr, true, true);
        }
        if (this.match(26)) {
          if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport")) {
            this.raise(Errors.DecoratorBeforeExport, {
              at: this.state.startLoc
            });
          }
          this.parseDecorators(false);
          return this.parseClass(expr, true, true);
        }
        if (this.match(75) || this.match(74) || this.isLet()) {
          throw this.raise(Errors.UnsupportedDefaultExport, {
            at: this.state.startLoc
          });
        }
        var res2 = this.parseMaybeAssignAllowIn();
        this.semicolon();
        return res2;
      };
      _proto.parseExportDeclaration = function parseExportDeclaration(node2) {
        return this.parseStatement(null);
      };
      _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier2() {
        var type5 = this.state.type;
        if (tokenIsIdentifier(type5)) {
          if (type5 === 95 && !this.state.containsEsc || type5 === 99) {
            return false;
          }
          if ((type5 === 126 || type5 === 125) && !this.state.containsEsc) {
            var _this$lookahead = this.lookahead(), nextType = _this$lookahead.type;
            if (tokenIsIdentifier(nextType) && nextType !== 97 || nextType === 5) {
              this.expectOnePlugin(["flow", "typescript"]);
              return false;
            }
          }
        } else if (!this.match(65)) {
          return false;
        }
        var next = this.nextTokenStart();
        var hasFrom = this.isUnparsedContextual(next, "from");
        if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
          return true;
        }
        if (this.match(65) && hasFrom) {
          var nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
          return nextAfterFrom === 34 || nextAfterFrom === 39;
        }
        return false;
      };
      _proto.parseExportFrom = function parseExportFrom(node2, expect) {
        if (this.eatContextual(97)) {
          node2.source = this.parseImportSource();
          this.checkExport(node2);
          var assertions = this.maybeParseImportAssertions();
          if (assertions) {
            node2.assertions = assertions;
          }
        } else if (expect) {
          this.unexpected();
        }
        this.semicolon();
      };
      _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
        var type5 = this.state.type;
        if (type5 === 26) {
          this.expectOnePlugin(["decorators", "decorators-legacy"]);
          if (this.hasPlugin("decorators")) {
            if (this.getPluginOption("decorators", "decoratorsBeforeExport")) {
              throw this.raise(Errors.DecoratorBeforeExport, {
                at: this.state.startLoc
              });
            }
            return true;
          }
        }
        return type5 === 74 || type5 === 75 || type5 === 68 || type5 === 80 || this.isLet() || this.isAsyncFunction();
      };
      _proto.checkExport = function checkExport(node2, checkNames, isDefault, isFrom) {
        if (checkNames) {
          if (isDefault) {
            this.checkDuplicateExports(node2, "default");
            if (this.hasPlugin("exportDefaultFrom")) {
              var _declaration$extra;
              var declaration = node2.declaration;
              if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !((_declaration$extra = declaration.extra) != null && _declaration$extra.parenthesized)) {
                this.raise(Errors.ExportDefaultFromAsIdentifier, {
                  at: declaration
                });
              }
            }
          } else if (node2.specifiers && node2.specifiers.length) {
            for (var _i6 = 0, _node$specifiers3 = node2.specifiers; _i6 < _node$specifiers3.length; _i6++) {
              var specifier = _node$specifiers3[_i6];
              var exported = specifier.exported;
              var exportName = exported.type === "Identifier" ? exported.name : exported.value;
              this.checkDuplicateExports(specifier, exportName);
              if (!isFrom && specifier.local) {
                var local = specifier.local;
                if (local.type !== "Identifier") {
                  this.raise(Errors.ExportBindingIsString, {
                    at: specifier,
                    localName: local.value,
                    exportName
                  });
                } else {
                  this.checkReservedWord(local.name, local.loc.start, true, false);
                  this.scope.checkLocalExport(local);
                }
              }
            }
          } else if (node2.declaration) {
            if (node2.declaration.type === "FunctionDeclaration" || node2.declaration.type === "ClassDeclaration") {
              var id3 = node2.declaration.id;
              if (!id3)
                throw new Error("Assertion failure");
              this.checkDuplicateExports(node2, id3.name);
            } else if (node2.declaration.type === "VariableDeclaration") {
              for (var _i8 = 0, _node$declaration$dec2 = node2.declaration.declarations; _i8 < _node$declaration$dec2.length; _i8++) {
                var _declaration = _node$declaration$dec2[_i8];
                this.checkDeclaration(_declaration.id);
              }
            }
          }
        }
        var currentContextDecorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];
        if (currentContextDecorators.length) {
          throw this.raise(Errors.UnsupportedDecoratorExport, {
            at: node2
          });
        }
      };
      _proto.checkDeclaration = function checkDeclaration(node2) {
        if (node2.type === "Identifier") {
          this.checkDuplicateExports(node2, node2.name);
        } else if (node2.type === "ObjectPattern") {
          for (var _i10 = 0, _node$properties2 = node2.properties; _i10 < _node$properties2.length; _i10++) {
            var prop2 = _node$properties2[_i10];
            this.checkDeclaration(prop2);
          }
        } else if (node2.type === "ArrayPattern") {
          for (var _i12 = 0, _node$elements2 = node2.elements; _i12 < _node$elements2.length; _i12++) {
            var elem = _node$elements2[_i12];
            if (elem) {
              this.checkDeclaration(elem);
            }
          }
        } else if (node2.type === "ObjectProperty") {
          this.checkDeclaration(node2.value);
        } else if (node2.type === "RestElement") {
          this.checkDeclaration(node2.argument);
        } else if (node2.type === "AssignmentPattern") {
          this.checkDeclaration(node2.left);
        }
      };
      _proto.checkDuplicateExports = function checkDuplicateExports(node2, exportName) {
        if (this.exportedIdentifiers.has(exportName)) {
          if (exportName === "default") {
            this.raise(Errors.DuplicateDefaultExport, {
              at: node2
            });
          } else {
            this.raise(Errors.DuplicateExport, {
              at: node2,
              exportName
            });
          }
        }
        this.exportedIdentifiers.add(exportName);
      };
      _proto.parseExportSpecifiers = function parseExportSpecifiers(isInTypeExport) {
        var nodes2 = [];
        var first = true;
        this.expect(5);
        while (!this.eat(8)) {
          if (first) {
            first = false;
          } else {
            this.expect(12);
            if (this.eat(8))
              break;
          }
          var isMaybeTypeOnly = this.isContextual(126);
          var isString2 = this.match(129);
          var node2 = this.startNode();
          node2.local = this.parseModuleExportName();
          nodes2.push(this.parseExportSpecifier(node2, isString2, isInTypeExport, isMaybeTypeOnly));
        }
        return nodes2;
      };
      _proto.parseExportSpecifier = function parseExportSpecifier(node2, isString2, isInTypeExport, isMaybeTypeOnly) {
        if (this.eatContextual(93)) {
          node2.exported = this.parseModuleExportName();
        } else if (isString2) {
          node2.exported = cloneStringLiteral(node2.local);
        } else if (!node2.exported) {
          node2.exported = cloneIdentifier(node2.local);
        }
        return this.finishNode(node2, "ExportSpecifier");
      };
      _proto.parseModuleExportName = function parseModuleExportName() {
        if (this.match(129)) {
          var result = this.parseStringLiteral(this.state.value);
          var surrogate = result.value.match(loneSurrogate2);
          if (surrogate) {
            this.raise(Errors.ModuleExportNameHasLoneSurrogate, {
              at: result,
              surrogateCharCode: surrogate[0].charCodeAt(0)
            });
          }
          return result;
        }
        return this.parseIdentifier(true);
      };
      _proto.parseImport = function parseImport(node2) {
        node2.specifiers = [];
        if (!this.match(129)) {
          var hasDefault = this.maybeParseDefaultImportSpecifier(node2);
          var parseNext = !hasDefault || this.eat(12);
          var hasStar = parseNext && this.maybeParseStarImportSpecifier(node2);
          if (parseNext && !hasStar)
            this.parseNamedImportSpecifiers(node2);
          this.expectContextual(97);
        }
        node2.source = this.parseImportSource();
        var assertions = this.maybeParseImportAssertions();
        if (assertions) {
          node2.assertions = assertions;
        } else {
          var attributes = this.maybeParseModuleAttributes();
          if (attributes) {
            node2.attributes = attributes;
          }
        }
        this.semicolon();
        return this.finishNode(node2, "ImportDeclaration");
      };
      _proto.parseImportSource = function parseImportSource() {
        if (!this.match(129))
          this.unexpected();
        return this.parseExprAtom();
      };
      _proto.shouldParseDefaultImport = function shouldParseDefaultImport(node2) {
        return tokenIsIdentifier(this.state.type);
      };
      _proto.parseImportSpecifierLocal = function parseImportSpecifierLocal(node2, specifier, type5) {
        specifier.local = this.parseIdentifier();
        node2.specifiers.push(this.finishImportSpecifier(specifier, type5));
      };
      _proto.finishImportSpecifier = function finishImportSpecifier(specifier, type5) {
        this.checkLVal(specifier.local, {
          "in": specifier,
          binding: BIND_LEXICAL2
        });
        return this.finishNode(specifier, type5);
      };
      _proto.parseAssertEntries = function parseAssertEntries() {
        var attrs = [];
        var attrNames = /* @__PURE__ */ new Set();
        do {
          if (this.match(8)) {
            break;
          }
          var node2 = this.startNode();
          var keyName = this.state.value;
          if (attrNames.has(keyName)) {
            this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
              at: this.state.startLoc,
              key: keyName
            });
          }
          attrNames.add(keyName);
          if (this.match(129)) {
            node2.key = this.parseStringLiteral(keyName);
          } else {
            node2.key = this.parseIdentifier(true);
          }
          this.expect(14);
          if (!this.match(129)) {
            throw this.raise(Errors.ModuleAttributeInvalidValue, {
              at: this.state.startLoc
            });
          }
          node2.value = this.parseStringLiteral(this.state.value);
          this.finishNode(node2, "ImportAttribute");
          attrs.push(node2);
        } while (this.eat(12));
        return attrs;
      };
      _proto.maybeParseModuleAttributes = function maybeParseModuleAttributes() {
        if (this.match(76) && !this.hasPrecedingLineBreak()) {
          this.expectPlugin("moduleAttributes");
          this.next();
        } else {
          if (this.hasPlugin("moduleAttributes"))
            return [];
          return null;
        }
        var attrs = [];
        var attributes = /* @__PURE__ */ new Set();
        do {
          var node2 = this.startNode();
          node2.key = this.parseIdentifier(true);
          if (node2.key.name !== "type") {
            this.raise(Errors.ModuleAttributeDifferentFromType, {
              at: node2.key
            });
          }
          if (attributes.has(node2.key.name)) {
            this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
              at: node2.key,
              key: node2.key.name
            });
          }
          attributes.add(node2.key.name);
          this.expect(14);
          if (!this.match(129)) {
            throw this.raise(Errors.ModuleAttributeInvalidValue, {
              at: this.state.startLoc
            });
          }
          node2.value = this.parseStringLiteral(this.state.value);
          this.finishNode(node2, "ImportAttribute");
          attrs.push(node2);
        } while (this.eat(12));
        return attrs;
      };
      _proto.maybeParseImportAssertions = function maybeParseImportAssertions() {
        if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
          this.expectPlugin("importAssertions");
          this.next();
        } else {
          if (this.hasPlugin("importAssertions"))
            return [];
          return null;
        }
        this.eat(5);
        var attrs = this.parseAssertEntries();
        this.eat(8);
        return attrs;
      };
      _proto.maybeParseDefaultImportSpecifier = function maybeParseDefaultImportSpecifier(node2) {
        if (this.shouldParseDefaultImport(node2)) {
          this.parseImportSpecifierLocal(node2, this.startNode(), "ImportDefaultSpecifier");
          return true;
        }
        return false;
      };
      _proto.maybeParseStarImportSpecifier = function maybeParseStarImportSpecifier(node2) {
        if (this.match(55)) {
          var specifier = this.startNode();
          this.next();
          this.expectContextual(93);
          this.parseImportSpecifierLocal(node2, specifier, "ImportNamespaceSpecifier");
          return true;
        }
        return false;
      };
      _proto.parseNamedImportSpecifiers = function parseNamedImportSpecifiers(node2) {
        var first = true;
        this.expect(5);
        while (!this.eat(8)) {
          if (first) {
            first = false;
          } else {
            if (this.eat(14)) {
              throw this.raise(Errors.DestructureNamedImport, {
                at: this.state.startLoc
              });
            }
            this.expect(12);
            if (this.eat(8))
              break;
          }
          var specifier = this.startNode();
          var importedIsString = this.match(129);
          var isMaybeTypeOnly = this.isContextual(126);
          specifier.imported = this.parseModuleExportName();
          var importSpecifier2 = this.parseImportSpecifier(specifier, importedIsString, node2.importKind === "type" || node2.importKind === "typeof", isMaybeTypeOnly);
          node2.specifiers.push(importSpecifier2);
        }
      };
      _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
        if (this.eatContextual(93)) {
          specifier.local = this.parseIdentifier();
        } else {
          var imported = specifier.imported;
          if (importedIsString) {
            throw this.raise(Errors.ImportBindingIsString, {
              at: specifier,
              importName: imported.value
            });
          }
          this.checkReservedWord(imported.name, specifier.loc.start, true, true);
          if (!specifier.local) {
            specifier.local = cloneIdentifier(imported);
          }
        }
        return this.finishImportSpecifier(specifier, "ImportSpecifier");
      };
      _proto.isThisParam = function isThisParam(param) {
        return param.type === "Identifier" && param.name === "this";
      };
      return _createClass2(StatementParser2);
    }(ExpressionParser);
    var Parser3 = function(_StatementParser) {
      _inherits2(Parser4, _StatementParser);
      function Parser4(options, input) {
        var _this;
        options = getOptions2(options);
        _this = _StatementParser.call(this, options, input) || this;
        _this.options = options;
        _this.initializeScopes();
        _this.plugins = pluginsMap(_this.options.plugins);
        _this.filename = options.sourceFilename;
        return _this;
      }
      var _proto = Parser4.prototype;
      _proto.getScopeHandler = function getScopeHandler() {
        return ScopeHandler;
      };
      _proto.parse = function parse5() {
        this.enterInitialScopes();
        var file2 = this.startNode();
        var program2 = this.startNode();
        this.nextToken();
        file2.errors = null;
        this.parseTopLevel(file2, program2);
        file2.errors = this.state.errors;
        return file2;
      };
      return _createClass2(Parser4);
    }(StatementParser);
    function pluginsMap(plugins2) {
      var pluginMap = /* @__PURE__ */ new Map();
      for (var _i22 = 0; _i22 < plugins2.length; _i22++) {
        var plugin2 = plugins2[_i22];
        var _ref3 = Array.isArray(plugin2) ? plugin2 : [plugin2, {}], name2 = _ref3[0], options = _ref3[1];
        if (!pluginMap.has(name2))
          pluginMap.set(name2, options || {});
      }
      return pluginMap;
    }
    function parse$5(input, options) {
      var _options;
      if (((_options = options) == null ? void 0 : _options.sourceType) === "unambiguous") {
        options = Object.assign({}, options);
        try {
          options.sourceType = "module";
          var parser2 = getParser(options, input);
          var ast3 = parser2.parse();
          if (parser2.sawUnambiguousESM) {
            return ast3;
          }
          if (parser2.ambiguousScriptDifferentAst) {
            try {
              options.sourceType = "script";
              return getParser(options, input).parse();
            } catch (_unused) {
            }
          } else {
            ast3.program.sourceType = "script";
          }
          return ast3;
        } catch (moduleError) {
          try {
            options.sourceType = "script";
            return getParser(options, input).parse();
          } catch (_unused2) {
          }
          throw moduleError;
        }
      } else {
        return getParser(options, input).parse();
      }
    }
    function generateExportedTokenTypes(internalTokenTypes) {
      var tokenTypes2 = {};
      for (var _i22 = 0, _Object$keys22 = Object.keys(internalTokenTypes); _i22 < _Object$keys22.length; _i22++) {
        var typeName = _Object$keys22[_i22];
        tokenTypes2[typeName] = getExportedToken(internalTokenTypes[typeName]);
      }
      return tokenTypes2;
    }
    var tokTypes = generateExportedTokenTypes(tt);
    function getParser(options, input) {
      var cls = Parser3;
      if (options != null && options.plugins) {
        validatePlugins(options.plugins);
        cls = getParserClass(options.plugins);
      }
      return new cls(options, input);
    }
    var parserClassCache = {};
    function getParserClass(pluginsFromOptions) {
      var pluginList = mixinPluginNames.filter(function(name2) {
        return hasPlugin(pluginsFromOptions, name2);
      });
      var key2 = pluginList.join("/");
      var cls = parserClassCache[key2];
      if (!cls) {
        cls = Parser3;
        for (var _i4 = 0; _i4 < pluginList.length; _i4++) {
          var plugin2 = pluginList[_i4];
          cls = mixinPlugins[plugin2](cls);
        }
        parserClassCache[key2] = cls;
      }
      return cls;
    }
    var assignmentExpression$b = assignmentExpression$c, expressionStatement$9 = expressionStatement$a, identifier$f = identifier$j;
    var visitor$3 = {
      Scope: function Scope4(path2, state) {
        if (state.kind === "let")
          path2.skip();
      },
      FunctionParent: function FunctionParent(path2) {
        path2.skip();
      },
      VariableDeclaration: function(_VariableDeclaration) {
        function VariableDeclaration2(_x, _x2) {
          return _VariableDeclaration.apply(this, arguments);
        }
        VariableDeclaration2.toString = function() {
          return _VariableDeclaration.toString();
        };
        return VariableDeclaration2;
      }(function(path2, state) {
        if (state.kind && path2.node.kind !== state.kind)
          return;
        var nodes2 = [];
        var declarations = path2.get("declarations");
        var firstId;
        for (var _iterator2 = _createForOfIteratorHelperLoose(declarations), _step2; !(_step2 = _iterator2()).done; ) {
          var declar = _step2.value;
          firstId = declar.node.id;
          if (declar.node.init) {
            nodes2.push(expressionStatement$9(assignmentExpression$b("=", declar.node.id, declar.node.init)));
          }
          for (var _i3 = 0, _Object$keys3 = Object.keys(declar.getBindingIdentifiers()); _i3 < _Object$keys3.length; _i3++) {
            var name2 = _Object$keys3[_i3];
            state.emit(identifier$f(name2), name2, declar.node.init !== null);
          }
        }
        if (path2.parentPath.isFor({
          left: path2.node
        })) {
          path2.replaceWith(firstId);
        } else {
          path2.replaceWithMultiple(nodes2);
        }
      })
    };
    function hoistVariables(path2, emit2, kind) {
      if (kind === void 0) {
        kind = "var";
      }
      path2.traverse(visitor$3, {
        kind,
        emit: emit2
      });
    }
    var FUNCTION_TYPES = FUNCTION_TYPES$1, arrowFunctionExpression$3 = arrowFunctionExpression$4, assignmentExpression$a = assignmentExpression$c, awaitExpression = awaitExpression$1, blockStatement$5 = blockStatement$6, callExpression$c = callExpression$e, cloneNode$f = cloneNode$i, expressionStatement$8 = expressionStatement$a, identifier$e = identifier$j, inheritLeadingComments = inheritLeadingComments$1, inheritTrailingComments = inheritTrailingComments$1, inheritsComments$1 = inheritsComments$2, isExpression$2 = isExpression$4, isProgram = isProgram$2, isStatement$2 = isStatement$7, removeComments$1 = removeComments$2, returnStatement$2 = returnStatement$3, toSequenceExpression = toSequenceExpression$1, validate$4 = validate$6, yieldExpression$1 = yieldExpression$2;
    function replaceWithMultiple(nodes2) {
      var _pathCache$get;
      this.resync();
      nodes2 = this._verifyNodeList(nodes2);
      inheritLeadingComments(nodes2[0], this.node);
      inheritTrailingComments(nodes2[nodes2.length - 1], this.node);
      (_pathCache$get = path$2.get(this.parent)) == null ? void 0 : _pathCache$get["delete"](this.node);
      this.node = this.container[this.key] = null;
      var paths = this.insertAfter(nodes2);
      if (this.node) {
        this.requeue();
      } else {
        this.remove();
      }
      return paths;
    }
    function replaceWithSourceString(replacement) {
      this.resync();
      try {
        replacement = "(" + replacement + ")";
        replacement = parse$5(replacement);
      } catch (err) {
        var loc = err.loc;
        if (loc) {
          err.message += " - make sure this is an expression.\n" + codeFrameColumns(replacement, {
            start: {
              line: loc.line,
              column: loc.column + 1
            }
          });
          err.code = "BABEL_REPLACE_SOURCE_ERROR";
        }
        throw err;
      }
      replacement = replacement.program.body[0].expression;
      traverse.removeProperties(replacement);
      return this.replaceWith(replacement);
    }
    function replaceWith(replacement) {
      this.resync();
      if (this.removed) {
        throw new Error("You can't replace this node, we've already removed it");
      }
      if (replacement instanceof NodePath) {
        replacement = replacement.node;
      }
      if (!replacement) {
        throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
      }
      if (this.node === replacement) {
        return [this];
      }
      if (this.isProgram() && !isProgram(replacement)) {
        throw new Error("You can only replace a Program root node with another Program node");
      }
      if (Array.isArray(replacement)) {
        throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
      }
      if (typeof replacement === "string") {
        throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
      }
      var nodePath = "";
      if (this.isNodeType("Statement") && isExpression$2(replacement)) {
        if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
          replacement = expressionStatement$8(replacement);
          nodePath = "expression";
        }
      }
      if (this.isNodeType("Expression") && isStatement$2(replacement)) {
        if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
          return this.replaceExpressionWithStatements([replacement]);
        }
      }
      var oldNode = this.node;
      if (oldNode) {
        inheritsComments$1(replacement, oldNode);
        removeComments$1(oldNode);
      }
      this._replaceWith(replacement);
      this.type = replacement.type;
      this.setScope();
      this.requeue();
      return [nodePath ? this.get(nodePath) : this];
    }
    function _replaceWith(node2) {
      var _pathCache$get2;
      if (!this.container) {
        throw new ReferenceError("Container is falsy");
      }
      if (this.inList) {
        validate$4(this.parent, this.key, [node2]);
      } else {
        validate$4(this.parent, this.key, node2);
      }
      this.debug("Replace with " + (node2 == null ? void 0 : node2.type));
      (_pathCache$get2 = path$2.get(this.parent)) == null ? void 0 : _pathCache$get2.set(node2, this)["delete"](this.node);
      this.node = this.container[this.key] = node2;
    }
    function replaceExpressionWithStatements(nodes2) {
      var _this = this;
      this.resync();
      var nodesAsSequenceExpression = toSequenceExpression(nodes2, this.scope);
      if (nodesAsSequenceExpression) {
        return this.replaceWith(nodesAsSequenceExpression)[0].get("expressions");
      }
      var functionParent = this.getFunctionParent();
      var isParentAsync = functionParent == null ? void 0 : functionParent.is("async");
      var isParentGenerator = functionParent == null ? void 0 : functionParent.is("generator");
      var container2 = arrowFunctionExpression$3([], blockStatement$5(nodes2));
      this.replaceWith(callExpression$c(container2, []));
      var callee = this.get("callee");
      hoistVariables(callee.get("body"), function(id3) {
        _this.scope.push({
          id: id3
        });
      }, "var");
      var completionRecords = this.get("callee").getCompletionRecords();
      for (var _iterator2 = _createForOfIteratorHelperLoose(completionRecords), _step2; !(_step2 = _iterator2()).done; ) {
        var path2 = _step2.value;
        if (!path2.isExpressionStatement())
          continue;
        var loop = path2.findParent(function(path3) {
          return path3.isLoop();
        });
        if (loop) {
          var uid2 = loop.getData("expressionReplacementReturnUid");
          if (!uid2) {
            uid2 = callee.scope.generateDeclaredUidIdentifier("ret");
            callee.get("body").pushContainer("body", returnStatement$2(cloneNode$f(uid2)));
            loop.setData("expressionReplacementReturnUid", uid2);
          } else {
            uid2 = identifier$e(uid2.name);
          }
          path2.get("expression").replaceWith(assignmentExpression$a("=", cloneNode$f(uid2), path2.node.expression));
        } else {
          path2.replaceWith(returnStatement$2(path2.node.expression));
        }
      }
      callee.arrowFunctionToExpression();
      var newCallee = callee;
      var needToAwaitFunction = isParentAsync && traverse.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES);
      var needToYieldFunction = isParentGenerator && traverse.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES);
      if (needToAwaitFunction) {
        newCallee.set("async", true);
        if (!needToYieldFunction) {
          this.replaceWith(awaitExpression(this.node));
        }
      }
      if (needToYieldFunction) {
        newCallee.set("generator", true);
        this.replaceWith(yieldExpression$1(this.node, true));
      }
      return newCallee.get("body.body");
    }
    function replaceInline(nodes2) {
      this.resync();
      if (Array.isArray(nodes2)) {
        if (Array.isArray(this.container)) {
          nodes2 = this._verifyNodeList(nodes2);
          var paths = this._containerInsertAfter(nodes2);
          this.remove();
          return paths;
        } else {
          return this.replaceWithMultiple(nodes2);
        }
      } else {
        return this.replaceWith(nodes2);
      }
    }
    var NodePath_replacement = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      replaceWithMultiple,
      replaceWithSourceString,
      replaceWith,
      _replaceWith,
      replaceExpressionWithStatements,
      replaceInline
    });
    var VALID_CALLEES = ["String", "Number", "Math"];
    var INVALID_METHODS = ["random"];
    function evaluateTruthy() {
      var res2 = this.evaluate();
      if (res2.confident)
        return !!res2.value;
    }
    function deopt(path2, state) {
      if (!state.confident)
        return;
      state.deoptPath = path2;
      state.confident = false;
    }
    function evaluateCached(path2, state) {
      var node2 = path2.node;
      var seen = state.seen;
      if (seen.has(node2)) {
        var existing = seen.get(node2);
        if (existing.resolved) {
          return existing.value;
        } else {
          deopt(path2, state);
          return;
        }
      } else {
        var item = {
          resolved: false
        };
        seen.set(node2, item);
        var val = _evaluate(path2, state);
        if (state.confident) {
          item.resolved = true;
          item.value = val;
        }
        return val;
      }
    }
    function _evaluate(path2, state) {
      if (!state.confident)
        return;
      if (path2.isSequenceExpression()) {
        var exprs = path2.get("expressions");
        return evaluateCached(exprs[exprs.length - 1], state);
      }
      if (path2.isStringLiteral() || path2.isNumericLiteral() || path2.isBooleanLiteral()) {
        return path2.node.value;
      }
      if (path2.isNullLiteral()) {
        return null;
      }
      if (path2.isTemplateLiteral()) {
        return evaluateQuasis(path2, path2.node.quasis, state);
      }
      if (path2.isTaggedTemplateExpression() && path2.get("tag").isMemberExpression()) {
        var object4 = path2.get("tag.object");
        var name2 = object4.node.name;
        var property2 = path2.get("tag.property");
        if (object4.isIdentifier() && name2 === "String" && !path2.scope.getBinding(name2) && property2.isIdentifier() && property2.node.name === "raw") {
          return evaluateQuasis(path2, path2.node.quasi.quasis, state, true);
        }
      }
      if (path2.isConditionalExpression()) {
        var testResult = evaluateCached(path2.get("test"), state);
        if (!state.confident)
          return;
        if (testResult) {
          return evaluateCached(path2.get("consequent"), state);
        } else {
          return evaluateCached(path2.get("alternate"), state);
        }
      }
      if (path2.isExpressionWrapper()) {
        return evaluateCached(path2.get("expression"), state);
      }
      if (path2.isMemberExpression() && !path2.parentPath.isCallExpression({
        callee: path2.node
      })) {
        var _property = path2.get("property");
        var _object = path2.get("object");
        if (_object.isLiteral() && _property.isIdentifier()) {
          var value = _object.node.value;
          var type5 = typeof value;
          if (type5 === "number" || type5 === "string") {
            return value[_property.node.name];
          }
        }
      }
      if (path2.isReferencedIdentifier()) {
        var binding2 = path2.scope.getBinding(path2.node.name);
        if (binding2 && binding2.constantViolations.length > 0) {
          return deopt(binding2.path, state);
        }
        if (binding2 && path2.node.start < binding2.path.node.end) {
          return deopt(binding2.path, state);
        }
        if (binding2 != null && binding2.hasValue) {
          return binding2.value;
        } else {
          if (path2.node.name === "undefined") {
            return binding2 ? deopt(binding2.path, state) : void 0;
          } else if (path2.node.name === "Infinity") {
            return binding2 ? deopt(binding2.path, state) : Infinity;
          } else if (path2.node.name === "NaN") {
            return binding2 ? deopt(binding2.path, state) : NaN;
          }
          var resolved = path2.resolve();
          if (resolved === path2) {
            return deopt(path2, state);
          } else {
            return evaluateCached(resolved, state);
          }
        }
      }
      if (path2.isUnaryExpression({
        prefix: true
      })) {
        if (path2.node.operator === "void") {
          return void 0;
        }
        var argument = path2.get("argument");
        if (path2.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
          return "function";
        }
        var arg = evaluateCached(argument, state);
        if (!state.confident)
          return;
        switch (path2.node.operator) {
          case "!":
            return !arg;
          case "+":
            return +arg;
          case "-":
            return -arg;
          case "~":
            return ~arg;
          case "typeof":
            return typeof arg;
        }
      }
      if (path2.isArrayExpression()) {
        var arr = [];
        var elems = path2.get("elements");
        for (var _iterator2 = _createForOfIteratorHelperLoose(elems), _step2; !(_step2 = _iterator2()).done; ) {
          var elem = _step2.value;
          var elemValue = elem.evaluate();
          if (elemValue.confident) {
            arr.push(elemValue.value);
          } else {
            return deopt(elemValue.deopt, state);
          }
        }
        return arr;
      }
      if (path2.isObjectExpression()) {
        var obj = {};
        var props = path2.get("properties");
        for (var _iterator22 = _createForOfIteratorHelperLoose(props), _step22; !(_step22 = _iterator22()).done; ) {
          var prop2 = _step22.value;
          if (prop2.isObjectMethod() || prop2.isSpreadElement()) {
            return deopt(prop2, state);
          }
          var keyPath = prop2.get("key");
          var key2 = keyPath;
          if (prop2.node.computed) {
            key2 = key2.evaluate();
            if (!key2.confident) {
              return deopt(key2.deopt, state);
            }
            key2 = key2.value;
          } else if (key2.isIdentifier()) {
            key2 = key2.node.name;
          } else {
            key2 = key2.node.value;
          }
          var valuePath = prop2.get("value");
          var _value = valuePath.evaluate();
          if (!_value.confident) {
            return deopt(_value.deopt, state);
          }
          _value = _value.value;
          obj[key2] = _value;
        }
        return obj;
      }
      if (path2.isLogicalExpression()) {
        var wasConfident = state.confident;
        var left = evaluateCached(path2.get("left"), state);
        var leftConfident = state.confident;
        state.confident = wasConfident;
        var right = evaluateCached(path2.get("right"), state);
        var rightConfident = state.confident;
        switch (path2.node.operator) {
          case "||":
            state.confident = leftConfident && (!!left || rightConfident);
            if (!state.confident)
              return;
            return left || right;
          case "&&":
            state.confident = leftConfident && (!left || rightConfident);
            if (!state.confident)
              return;
            return left && right;
        }
      }
      if (path2.isBinaryExpression()) {
        var _left = evaluateCached(path2.get("left"), state);
        if (!state.confident)
          return;
        var _right = evaluateCached(path2.get("right"), state);
        if (!state.confident)
          return;
        switch (path2.node.operator) {
          case "-":
            return _left - _right;
          case "+":
            return _left + _right;
          case "/":
            return _left / _right;
          case "*":
            return _left * _right;
          case "%":
            return _left % _right;
          case "**":
            return Math.pow(_left, _right);
          case "<":
            return _left < _right;
          case ">":
            return _left > _right;
          case "<=":
            return _left <= _right;
          case ">=":
            return _left >= _right;
          case "==":
            return _left == _right;
          case "!=":
            return _left != _right;
          case "===":
            return _left === _right;
          case "!==":
            return _left !== _right;
          case "|":
            return _left | _right;
          case "&":
            return _left & _right;
          case "^":
            return _left ^ _right;
          case "<<":
            return _left << _right;
          case ">>":
            return _left >> _right;
          case ">>>":
            return _left >>> _right;
        }
      }
      if (path2.isCallExpression()) {
        var callee = path2.get("callee");
        var context;
        var func;
        if (callee.isIdentifier() && !path2.scope.getBinding(callee.node.name) && VALID_CALLEES.indexOf(callee.node.name) >= 0) {
          func = global$12[callee.node.name];
        }
        if (callee.isMemberExpression()) {
          var _object2 = callee.get("object");
          var _property2 = callee.get("property");
          if (_object2.isIdentifier() && _property2.isIdentifier() && VALID_CALLEES.indexOf(_object2.node.name) >= 0 && INVALID_METHODS.indexOf(_property2.node.name) < 0) {
            context = global$12[_object2.node.name];
            func = context[_property2.node.name];
          }
          if (_object2.isLiteral() && _property2.isIdentifier()) {
            var _type = typeof _object2.node.value;
            if (_type === "string" || _type === "number") {
              context = _object2.node.value;
              func = context[_property2.node.name];
            }
          }
        }
        if (func) {
          var args = path2.get("arguments").map(function(arg2) {
            return evaluateCached(arg2, state);
          });
          if (!state.confident)
            return;
          return func.apply(context, args);
        }
      }
      deopt(path2, state);
    }
    function evaluateQuasis(path2, quasis, state, raw) {
      if (raw === void 0) {
        raw = false;
      }
      var str = "";
      var i2 = 0;
      var exprs = path2.get("expressions");
      for (var _iterator3 = _createForOfIteratorHelperLoose(quasis), _step3; !(_step3 = _iterator3()).done; ) {
        var elem = _step3.value;
        if (!state.confident)
          break;
        str += raw ? elem.value.raw : elem.value.cooked;
        var expr = exprs[i2++];
        if (expr)
          str += String(evaluateCached(expr, state));
      }
      if (!state.confident)
        return;
      return str;
    }
    function evaluate$1() {
      var state = {
        confident: true,
        deoptPath: null,
        seen: /* @__PURE__ */ new Map()
      };
      var value = evaluateCached(this, state);
      if (!state.confident)
        value = void 0;
      return {
        confident: state.confident,
        deopt: state.deoptPath,
        value
      };
    }
    var NodePath_evaluation = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      evaluateTruthy,
      evaluate: evaluate$1
    });
    var _skipKey$MethodClass;
    var VISITOR_KEYS$4 = VISITOR_KEYS$7, staticBlock = staticBlock$1;
    function skipAllButComputedKey(path2) {
      if (!path2.node.computed) {
        path2.skip();
        return;
      }
      var keys2 = VISITOR_KEYS$4[path2.type];
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        if (key2 !== "key")
          path2.skipKey(key2);
      }
    }
    var skipKey$1 = (staticBlock ? "StaticBlock|" : "") + "ClassPrivateProperty|TypeAnnotation|FunctionDeclaration|FunctionExpression";
    var environmentVisitor = (_skipKey$MethodClass = {}, _skipKey$MethodClass[skipKey$1] = function(path2) {
      return path2.skip();
    }, _skipKey$MethodClass["Method|ClassProperty"] = function MethodClassProperty(path2) {
      skipAllButComputedKey(path2);
    }, _skipKey$MethodClass);
    var assertExpressionStatement = assertExpressionStatement$1;
    function makeStatementFormatter(fn) {
      return {
        code: function code3(str) {
          return "/* @babel/template */;\n" + str;
        },
        validate: function validate2() {
        },
        unwrap: function unwrap(ast3) {
          return fn(ast3.program.body.slice(1));
        }
      };
    }
    var smart$1 = makeStatementFormatter(function(body) {
      if (body.length > 1) {
        return body;
      } else {
        return body[0];
      }
    });
    var statements$1 = makeStatementFormatter(function(body) {
      return body;
    });
    var statement$1 = makeStatementFormatter(function(body) {
      if (body.length === 0) {
        throw new Error("Found nothing to return.");
      }
      if (body.length > 1) {
        throw new Error("Found multiple statements but wanted one");
      }
      return body[0];
    });
    var expression$1 = {
      code: function code3(str) {
        return "(\n" + str + "\n)";
      },
      validate: function validate2(ast3) {
        if (ast3.program.body.length > 1) {
          throw new Error("Found multiple statements but wanted one");
        }
        if (expression$1.unwrap(ast3).start === 0) {
          throw new Error("Parse result included parens.");
        }
      },
      unwrap: function unwrap(_ref3) {
        var program2 = _ref3.program;
        var _program$body = _slicedToArray$12(program2.body, 1), stmt = _program$body[0];
        assertExpressionStatement(stmt);
        return stmt.expression;
      }
    };
    var program$2 = {
      code: function code3(str) {
        return str;
      },
      validate: function validate2() {
      },
      unwrap: function unwrap(ast3) {
        return ast3.program;
      }
    };
    var _excluded$32 = ["placeholderWhitelist", "placeholderPattern", "preserveComments", "syntacticPlaceholders"];
    function merge3(a, b2) {
      var _b$placeholderWhiteli = b2.placeholderWhitelist, placeholderWhitelist = _b$placeholderWhiteli === void 0 ? a.placeholderWhitelist : _b$placeholderWhiteli, _b$placeholderPattern = b2.placeholderPattern, placeholderPattern = _b$placeholderPattern === void 0 ? a.placeholderPattern : _b$placeholderPattern, _b$preserveComments = b2.preserveComments, preserveComments = _b$preserveComments === void 0 ? a.preserveComments : _b$preserveComments, _b$syntacticPlacehold = b2.syntacticPlaceholders, syntacticPlaceholders = _b$syntacticPlacehold === void 0 ? a.syntacticPlaceholders : _b$syntacticPlacehold;
      return {
        parser: Object.assign({}, a.parser, b2.parser),
        placeholderWhitelist,
        placeholderPattern,
        preserveComments,
        syntacticPlaceholders
      };
    }
    function validate$3(opts) {
      if (opts != null && typeof opts !== "object") {
        throw new Error("Unknown template options.");
      }
      var _ref3 = opts || {}, placeholderWhitelist = _ref3.placeholderWhitelist, placeholderPattern = _ref3.placeholderPattern, preserveComments = _ref3.preserveComments, syntacticPlaceholders = _ref3.syntacticPlaceholders, parser2 = _objectWithoutPropertiesLoose2(_ref3, _excluded$32);
      if (placeholderWhitelist != null && !(placeholderWhitelist instanceof Set)) {
        throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
      }
      if (placeholderPattern != null && !(placeholderPattern instanceof RegExp) && placeholderPattern !== false) {
        throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
      }
      if (preserveComments != null && typeof preserveComments !== "boolean") {
        throw new Error("'.preserveComments' must be a boolean, null, or undefined");
      }
      if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
        throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
      }
      if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
        throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
      }
      return {
        parser: parser2,
        placeholderWhitelist: placeholderWhitelist || void 0,
        placeholderPattern: placeholderPattern == null ? void 0 : placeholderPattern,
        preserveComments: preserveComments == null ? void 0 : preserveComments,
        syntacticPlaceholders: syntacticPlaceholders == null ? void 0 : syntacticPlaceholders
      };
    }
    function normalizeReplacements(replacements) {
      if (Array.isArray(replacements)) {
        return replacements.reduce(function(acc, replacement, i2) {
          acc["$" + i2] = replacement;
          return acc;
        }, {});
      } else if (typeof replacements === "object" || replacements == null) {
        return replacements || void 0;
      }
      throw new Error("Template replacements must be an array, object, null, or undefined");
    }
    var isCallExpression$2 = isCallExpression$7, isExpressionStatement$1 = isExpressionStatement$4, isFunction$12 = isFunction$32, isIdentifier$b = isIdentifier$i, isJSXIdentifier$1 = isJSXIdentifier$3, isNewExpression = isNewExpression$4, isPlaceholder = isPlaceholder$1, isStatement$1 = isStatement$7, isStringLiteral$5 = isStringLiteral$7, removePropertiesDeep = removePropertiesDeep$1, traverse$1 = traverse$2;
    var PATTERN = /^[_$A-Z0-9]+$/;
    function parseAndBuildMetadata(formatter, code3, opts) {
      var placeholderWhitelist = opts.placeholderWhitelist, placeholderPattern = opts.placeholderPattern, preserveComments = opts.preserveComments, syntacticPlaceholders = opts.syntacticPlaceholders;
      var ast3 = parseWithCodeFrame(code3, opts.parser, syntacticPlaceholders);
      removePropertiesDeep(ast3, {
        preserveComments
      });
      formatter.validate(ast3);
      var syntactic = {
        placeholders: [],
        placeholderNames: /* @__PURE__ */ new Set()
      };
      var legacy = {
        placeholders: [],
        placeholderNames: /* @__PURE__ */ new Set()
      };
      var isLegacyRef = {
        value: void 0
      };
      traverse$1(ast3, placeholderVisitorHandler, {
        syntactic,
        legacy,
        isLegacyRef,
        placeholderWhitelist,
        placeholderPattern,
        syntacticPlaceholders
      });
      return Object.assign({
        ast: ast3
      }, isLegacyRef.value ? legacy : syntactic);
    }
    function placeholderVisitorHandler(node2, ancestors, state) {
      var _state$placeholderWhi;
      var name2;
      if (isPlaceholder(node2)) {
        if (state.syntacticPlaceholders === false) {
          throw new Error("%%foo%%-style placeholders can't be used when '.syntacticPlaceholders' is false.");
        } else {
          name2 = node2.name.name;
          state.isLegacyRef.value = false;
        }
      } else if (state.isLegacyRef.value === false || state.syntacticPlaceholders) {
        return;
      } else if (isIdentifier$b(node2) || isJSXIdentifier$1(node2)) {
        name2 = node2.name;
        state.isLegacyRef.value = true;
      } else if (isStringLiteral$5(node2)) {
        name2 = node2.value;
        state.isLegacyRef.value = true;
      } else {
        return;
      }
      if (!state.isLegacyRef.value && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
        throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
      }
      if (state.isLegacyRef.value && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name2)) && !((_state$placeholderWhi = state.placeholderWhitelist) != null && _state$placeholderWhi.has(name2))) {
        return;
      }
      ancestors = ancestors.slice();
      var _ancestors = ancestors[ancestors.length - 1], parent = _ancestors.node, key2 = _ancestors.key;
      var type5;
      if (isStringLiteral$5(node2) || isPlaceholder(node2, {
        expectedNode: "StringLiteral"
      })) {
        type5 = "string";
      } else if (isNewExpression(parent) && key2 === "arguments" || isCallExpression$2(parent) && key2 === "arguments" || isFunction$12(parent) && key2 === "params") {
        type5 = "param";
      } else if (isExpressionStatement$1(parent) && !isPlaceholder(node2)) {
        type5 = "statement";
        ancestors = ancestors.slice(0, -1);
      } else if (isStatement$1(node2) && isPlaceholder(node2)) {
        type5 = "statement";
      } else {
        type5 = "other";
      }
      var _ref3 = state.isLegacyRef.value ? state.legacy : state.syntactic, placeholders2 = _ref3.placeholders, placeholderNames = _ref3.placeholderNames;
      placeholders2.push({
        name: name2,
        type: type5,
        resolve: function resolve2(ast3) {
          return resolveAncestors(ast3, ancestors);
        },
        isDuplicate: placeholderNames.has(name2)
      });
      placeholderNames.add(name2);
    }
    function resolveAncestors(ast3, ancestors) {
      var parent = ast3;
      for (var i2 = 0; i2 < ancestors.length - 1; i2++) {
        var _ancestors$i = ancestors[i2], _key = _ancestors$i.key, _index = _ancestors$i.index;
        if (_index === void 0) {
          parent = parent[_key];
        } else {
          parent = parent[_key][_index];
        }
      }
      var _ancestors2 = ancestors[ancestors.length - 1], key2 = _ancestors2.key, index3 = _ancestors2.index;
      return {
        parent,
        key: key2,
        index: index3
      };
    }
    function parseWithCodeFrame(code3, parserOpts, syntacticPlaceholders) {
      var plugins2 = (parserOpts.plugins || []).slice();
      if (syntacticPlaceholders !== false) {
        plugins2.push("placeholders");
      }
      parserOpts = Object.assign({
        allowReturnOutsideFunction: true,
        allowSuperOutsideMethod: true,
        sourceType: "module"
      }, parserOpts, {
        plugins: plugins2
      });
      try {
        return parse$5(code3, parserOpts);
      } catch (err) {
        var loc = err.loc;
        if (loc) {
          err.message += "\n" + codeFrameColumns(code3, {
            start: loc
          });
          err.code = "BABEL_TEMPLATE_PARSE_ERROR";
        }
        throw err;
      }
    }
    var blockStatement$4 = blockStatement$6, cloneNode$e = cloneNode$i, emptyStatement = emptyStatement$1, expressionStatement$7 = expressionStatement$a, identifier$d = identifier$j, isStatement = isStatement$7, isStringLiteral$4 = isStringLiteral$7, stringLiteral$7 = stringLiteral$8, validate$2 = validate$6;
    function populatePlaceholders(metadata, replacements) {
      var ast3 = cloneNode$e(metadata.ast);
      if (replacements) {
        metadata.placeholders.forEach(function(placeholder2) {
          if (!Object.prototype.hasOwnProperty.call(replacements, placeholder2.name)) {
            var placeholderName = placeholder2.name;
            throw new Error('Error: No substitution given for "' + placeholderName + `". If this is not meant to be a
            placeholder you may want to consider passing one of the following options to @babel/template:
            - { placeholderPattern: false, placeholderWhitelist: new Set(['` + placeholderName + "'])}\n            - { placeholderPattern: /^" + placeholderName + "$/ }");
          }
        });
        Object.keys(replacements).forEach(function(key2) {
          if (!metadata.placeholderNames.has(key2)) {
            throw new Error('Unknown substitution "' + key2 + '" given');
          }
        });
      }
      metadata.placeholders.slice().reverse().forEach(function(placeholder2) {
        try {
          applyReplacement(placeholder2, ast3, replacements && replacements[placeholder2.name] || null);
        } catch (e2) {
          e2.message = '@babel/template placeholder "' + placeholder2.name + '": ' + e2.message;
          throw e2;
        }
      });
      return ast3;
    }
    function applyReplacement(placeholder2, ast3, replacement) {
      if (placeholder2.isDuplicate) {
        if (Array.isArray(replacement)) {
          replacement = replacement.map(function(node2) {
            return cloneNode$e(node2);
          });
        } else if (typeof replacement === "object") {
          replacement = cloneNode$e(replacement);
        }
      }
      var _placeholder$resolve = placeholder2.resolve(ast3), parent = _placeholder$resolve.parent, key2 = _placeholder$resolve.key, index3 = _placeholder$resolve.index;
      if (placeholder2.type === "string") {
        if (typeof replacement === "string") {
          replacement = stringLiteral$7(replacement);
        }
        if (!replacement || !isStringLiteral$4(replacement)) {
          throw new Error("Expected string substitution");
        }
      } else if (placeholder2.type === "statement") {
        if (index3 === void 0) {
          if (!replacement) {
            replacement = emptyStatement();
          } else if (Array.isArray(replacement)) {
            replacement = blockStatement$4(replacement);
          } else if (typeof replacement === "string") {
            replacement = expressionStatement$7(identifier$d(replacement));
          } else if (!isStatement(replacement)) {
            replacement = expressionStatement$7(replacement);
          }
        } else {
          if (replacement && !Array.isArray(replacement)) {
            if (typeof replacement === "string") {
              replacement = identifier$d(replacement);
            }
            if (!isStatement(replacement)) {
              replacement = expressionStatement$7(replacement);
            }
          }
        }
      } else if (placeholder2.type === "param") {
        if (typeof replacement === "string") {
          replacement = identifier$d(replacement);
        }
        if (index3 === void 0)
          throw new Error("Assertion failure.");
      } else {
        if (typeof replacement === "string") {
          replacement = identifier$d(replacement);
        }
        if (Array.isArray(replacement)) {
          throw new Error("Cannot replace single expression with an array.");
        }
      }
      if (index3 === void 0) {
        validate$2(parent, key2, replacement);
        parent[key2] = replacement;
      } else {
        var items = parent[key2].slice();
        if (placeholder2.type === "statement" || placeholder2.type === "param") {
          if (replacement == null) {
            items.splice(index3, 1);
          } else if (Array.isArray(replacement)) {
            items.splice.apply(items, [index3, 1].concat(_toConsumableArray2(replacement)));
          } else {
            items[index3] = replacement;
          }
        } else {
          items[index3] = replacement;
        }
        validate$2(parent, key2, items);
        parent[key2] = items;
      }
    }
    function stringTemplate(formatter, code3, opts) {
      code3 = formatter.code(code3);
      var metadata;
      return function(arg) {
        var replacements = normalizeReplacements(arg);
        if (!metadata)
          metadata = parseAndBuildMetadata(formatter, code3, opts);
        return formatter.unwrap(populatePlaceholders(metadata, replacements));
      };
    }
    function literalTemplate(formatter, tpl, opts) {
      var _buildLiteralData = buildLiteralData(formatter, tpl, opts), metadata = _buildLiteralData.metadata, names2 = _buildLiteralData.names;
      return function(arg) {
        var defaultReplacements = {};
        arg.forEach(function(replacement, i2) {
          defaultReplacements[names2[i2]] = replacement;
        });
        return function(arg2) {
          var replacements = normalizeReplacements(arg2);
          if (replacements) {
            Object.keys(replacements).forEach(function(key2) {
              if (Object.prototype.hasOwnProperty.call(defaultReplacements, key2)) {
                throw new Error("Unexpected replacement overlap.");
              }
            });
          }
          return formatter.unwrap(populatePlaceholders(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
        };
      };
    }
    function buildLiteralData(formatter, tpl, opts) {
      var names2;
      var nameSet;
      var metadata;
      var prefix2 = "";
      do {
        prefix2 += "$";
        var result = buildTemplateCode(tpl, prefix2);
        names2 = result.names;
        nameSet = new Set(names2);
        metadata = parseAndBuildMetadata(formatter, formatter.code(result.code), {
          parser: opts.parser,
          placeholderWhitelist: new Set(result.names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
          placeholderPattern: opts.placeholderPattern,
          preserveComments: opts.preserveComments,
          syntacticPlaceholders: opts.syntacticPlaceholders
        });
      } while (metadata.placeholders.some(function(placeholder2) {
        return placeholder2.isDuplicate && nameSet.has(placeholder2.name);
      }));
      return {
        metadata,
        names: names2
      };
    }
    function buildTemplateCode(tpl, prefix2) {
      var names2 = [];
      var code3 = tpl[0];
      for (var i2 = 1; i2 < tpl.length; i2++) {
        var value = "" + prefix2 + (i2 - 1);
        names2.push(value);
        code3 += value + tpl[i2];
      }
      return {
        names: names2,
        code: code3
      };
    }
    var NO_PLACEHOLDER = validate$3({
      placeholderPattern: false
    });
    function createTemplateBuilder(formatter, defaultOpts) {
      var templateFnCache = /* @__PURE__ */ new WeakMap();
      var templateAstCache = /* @__PURE__ */ new WeakMap();
      var cachedOpts = defaultOpts || validate$3(null);
      return Object.assign(function(tpl) {
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }
        if (typeof tpl === "string") {
          if (args.length > 1)
            throw new Error("Unexpected extra params.");
          return extendedTrace(stringTemplate(formatter, tpl, merge3(cachedOpts, validate$3(args[0]))));
        } else if (Array.isArray(tpl)) {
          var builder2 = templateFnCache.get(tpl);
          if (!builder2) {
            builder2 = literalTemplate(formatter, tpl, cachedOpts);
            templateFnCache.set(tpl, builder2);
          }
          return extendedTrace(builder2(args));
        } else if (typeof tpl === "object" && tpl) {
          if (args.length > 0)
            throw new Error("Unexpected extra params.");
          return createTemplateBuilder(formatter, merge3(cachedOpts, validate$3(tpl)));
        }
        throw new Error("Unexpected template param " + typeof tpl);
      }, {
        ast: function ast3(tpl) {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            args[_key2 - 1] = arguments[_key2];
          }
          if (typeof tpl === "string") {
            if (args.length > 1)
              throw new Error("Unexpected extra params.");
            return stringTemplate(formatter, tpl, merge3(merge3(cachedOpts, validate$3(args[0])), NO_PLACEHOLDER))();
          } else if (Array.isArray(tpl)) {
            var builder2 = templateAstCache.get(tpl);
            if (!builder2) {
              builder2 = literalTemplate(formatter, tpl, merge3(cachedOpts, NO_PLACEHOLDER));
              templateAstCache.set(tpl, builder2);
            }
            return builder2(args)();
          }
          throw new Error("Unexpected template param " + typeof tpl);
        }
      });
    }
    function extendedTrace(fn) {
      var rootStack = "";
      try {
        throw new Error();
      } catch (error2) {
        if (error2.stack) {
          rootStack = error2.stack.split("\n").slice(3).join("\n");
        }
      }
      return function(arg) {
        try {
          return fn(arg);
        } catch (err) {
          err.stack += "\n    =============\n" + rootStack;
          throw err;
        }
      };
    }
    var smart = createTemplateBuilder(smart$1);
    var statement = createTemplateBuilder(statement$1);
    var statements = createTemplateBuilder(statements$1);
    var expression = createTemplateBuilder(expression$1);
    var program$1 = createTemplateBuilder(program$2);
    var template$2 = Object.assign(smart.bind(void 0), {
      smart,
      statement,
      statements,
      expression,
      program: program$1,
      ast: smart.ast
    });
    var NOT_LOCAL_BINDING = NOT_LOCAL_BINDING$2, cloneNode$d = cloneNode$i, identifier$c = identifier$j, isAssignmentExpression$1 = isAssignmentExpression$4, isAssignmentPattern$3 = isAssignmentPattern$5, isFunction2 = isFunction$32, isIdentifier$a = isIdentifier$i, isLiteral$3 = isLiteral$7, isNullLiteral = isNullLiteral$1, isObjectMethod$1 = isObjectMethod$2, isObjectProperty$3 = isObjectProperty$5, isRegExpLiteral = isRegExpLiteral$1, isRestElement$2 = isRestElement$3, isTemplateLiteral = isTemplateLiteral$2, isVariableDeclarator = isVariableDeclarator$2, toBindingIdentifierName = toBindingIdentifierName$1;
    function getFunctionArity(node2) {
      var count2 = node2.params.findIndex(function(param) {
        return isAssignmentPattern$3(param) || isRestElement$2(param);
      });
      return count2 === -1 ? node2.params.length : count2;
    }
    var buildPropertyMethodAssignmentWrapper = template$2("\n  (function (FUNCTION_KEY) {\n    function FUNCTION_ID() {\n      return FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    }\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
    var buildGeneratorPropertyMethodAssignmentWrapper = template$2("\n  (function (FUNCTION_KEY) {\n    function* FUNCTION_ID() {\n      return yield* FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    };\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
    var visitor$2 = {
      "ReferencedIdentifier|BindingIdentifier": function ReferencedIdentifierBindingIdentifier(path2, state) {
        if (path2.node.name !== state.name)
          return;
        var localDeclar = path2.scope.getBindingIdentifier(state.name);
        if (localDeclar !== state.outerDeclar)
          return;
        state.selfReference = true;
        path2.stop();
      }
    };
    function getNameFromLiteralId(id3) {
      if (isNullLiteral(id3)) {
        return "null";
      }
      if (isRegExpLiteral(id3)) {
        return "_" + id3.pattern + "_" + id3.flags;
      }
      if (isTemplateLiteral(id3)) {
        return id3.quasis.map(function(quasi) {
          return quasi.value.raw;
        }).join("");
      }
      if (id3.value !== void 0) {
        return id3.value + "";
      }
      return "";
    }
    function wrap$1(state, method5, id3, scope2) {
      if (state.selfReference) {
        if (scope2.hasBinding(id3.name) && !scope2.hasGlobal(id3.name)) {
          scope2.rename(id3.name);
        } else {
          if (!isFunction2(method5))
            return;
          var build2 = buildPropertyMethodAssignmentWrapper;
          if (method5.generator) {
            build2 = buildGeneratorPropertyMethodAssignmentWrapper;
          }
          var _template = build2({
            FUNCTION: method5,
            FUNCTION_ID: id3,
            FUNCTION_KEY: scope2.generateUidIdentifier(id3.name)
          }).expression;
          var params = _template.callee.body.body[0].params;
          for (var i2 = 0, len3 = getFunctionArity(method5); i2 < len3; i2++) {
            params.push(scope2.generateUidIdentifier("x"));
          }
          return _template;
        }
      }
      method5.id = id3;
      scope2.getProgramParent().references[id3.name] = true;
    }
    function visit$2(node2, name2, scope2) {
      var state = {
        selfAssignment: false,
        selfReference: false,
        outerDeclar: scope2.getBindingIdentifier(name2),
        references: [],
        name: name2
      };
      var binding2 = scope2.getOwnBinding(name2);
      if (binding2) {
        if (binding2.kind === "param") {
          state.selfReference = true;
        }
      } else if (state.outerDeclar || scope2.hasGlobal(name2)) {
        scope2.traverse(node2, visitor$2, state);
      }
      return state;
    }
    function nameFunction(_ref3, localBinding, supportUnicodeId) {
      var node2 = _ref3.node, parent = _ref3.parent, scope2 = _ref3.scope, id3 = _ref3.id;
      if (localBinding === void 0) {
        localBinding = false;
      }
      if (supportUnicodeId === void 0) {
        supportUnicodeId = false;
      }
      if (node2.id)
        return;
      if ((isObjectProperty$3(parent) || isObjectMethod$1(parent, {
        kind: "method"
      })) && (!parent.computed || isLiteral$3(parent.key))) {
        id3 = parent.key;
      } else if (isVariableDeclarator(parent)) {
        id3 = parent.id;
        if (isIdentifier$a(id3) && !localBinding) {
          var binding2 = scope2.parent.getBinding(id3.name);
          if (binding2 && binding2.constant && scope2.getBinding(id3.name) === binding2) {
            node2.id = cloneNode$d(id3);
            node2.id[NOT_LOCAL_BINDING] = true;
            return;
          }
        }
      } else if (isAssignmentExpression$1(parent, {
        operator: "="
      })) {
        id3 = parent.left;
      } else if (!id3) {
        return;
      }
      var name2;
      if (id3 && isLiteral$3(id3)) {
        name2 = getNameFromLiteralId(id3);
      } else if (id3 && isIdentifier$a(id3)) {
        name2 = id3.name;
      }
      if (name2 === void 0) {
        return;
      }
      if (!supportUnicodeId && isFunction2(node2) && /[\uD800-\uDFFF]/.test(name2)) {
        return;
      }
      name2 = toBindingIdentifierName(name2);
      id3 = identifier$c(name2);
      id3[NOT_LOCAL_BINDING] = true;
      var state = visit$2(node2, name2, scope2);
      return wrap$1(state, node2, id3, scope2) || node2;
    }
    var arrowFunctionExpression$2 = arrowFunctionExpression$4, assignmentExpression$9 = assignmentExpression$c, binaryExpression$3 = binaryExpression$4, blockStatement$3 = blockStatement$6, callExpression$b = callExpression$e, conditionalExpression$2 = conditionalExpression$3, expressionStatement$6 = expressionStatement$a, identifier$b = identifier$j, isIdentifier$9 = isIdentifier$i, jsxIdentifier$1 = jsxIdentifier$2, logicalExpression$2 = logicalExpression$3, LOGICAL_OPERATORS$2 = LOGICAL_OPERATORS$3, memberExpression$9 = memberExpression$b, metaProperty = metaProperty$1, numericLiteral$5 = numericLiteral$7, objectExpression$3 = objectExpression$4, restElement = restElement$1, returnStatement$1 = returnStatement$3, sequenceExpression$6 = sequenceExpression$7, spreadElement$1 = spreadElement$2, stringLiteral$6 = stringLiteral$8, _super = _super$1, thisExpression$3 = thisExpression$4, toExpression = toExpression$1, unaryExpression$4 = unaryExpression$6;
    function toComputedKey$2() {
      var key2;
      if (this.isMemberExpression()) {
        key2 = this.node.property;
      } else if (this.isProperty() || this.isMethod()) {
        key2 = this.node.key;
      } else {
        throw new ReferenceError("todo");
      }
      if (!this.node.computed) {
        if (isIdentifier$9(key2))
          key2 = stringLiteral$6(key2.name);
      }
      return key2;
    }
    function ensureBlock() {
      var body = this.get("body");
      var bodyNode = body.node;
      if (Array.isArray(body)) {
        throw new Error("Can't convert array path to a block statement");
      }
      if (!bodyNode) {
        throw new Error("Can't convert node without a body");
      }
      if (body.isBlockStatement()) {
        return bodyNode;
      }
      var statements2 = [];
      var stringPath = "body";
      var key2;
      var listKey;
      if (body.isStatement()) {
        listKey = "body";
        key2 = 0;
        statements2.push(body.node);
      } else {
        stringPath += ".body.0";
        if (this.isFunction()) {
          key2 = "argument";
          statements2.push(returnStatement$1(body.node));
        } else {
          key2 = "expression";
          statements2.push(expressionStatement$6(body.node));
        }
      }
      this.node.body = blockStatement$3(statements2);
      var parentPath = this.get(stringPath);
      body.setup(parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key2);
      return this.node;
    }
    function arrowFunctionToShadowed() {
      if (!this.isArrowFunctionExpression())
        return;
      this.arrowFunctionToExpression();
    }
    function unwrapFunctionEnvironment() {
      if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
        throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
      }
      hoistFunctionEnvironment(this);
    }
    function arrowFunctionToExpression(_temp) {
      var _ref3 = _temp === void 0 ? {} : _temp, _ref$allowInsertArrow = _ref3.allowInsertArrow, allowInsertArrow = _ref$allowInsertArrow === void 0 ? true : _ref$allowInsertArrow, _ref$specCompliant = _ref3.specCompliant, specCompliant = _ref$specCompliant === void 0 ? false : _ref$specCompliant, _ref$noNewArrows = _ref3.noNewArrows, noNewArrows = _ref$noNewArrows === void 0 ? !specCompliant : _ref$noNewArrows;
      if (!this.isArrowFunctionExpression()) {
        throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
      }
      var _hoistFunctionEnviron = hoistFunctionEnvironment(this, noNewArrows, allowInsertArrow), thisBinding = _hoistFunctionEnviron.thisBinding, fn = _hoistFunctionEnviron.fnPath;
      fn.ensureBlock();
      fn.node.type = "FunctionExpression";
      if (!noNewArrows) {
        var checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");
        if (checkBinding) {
          fn.parentPath.scope.push({
            id: checkBinding,
            init: objectExpression$3([])
          });
        }
        fn.get("body").unshiftContainer("body", expressionStatement$6(callExpression$b(this.hub.addHelper("newArrowCheck"), [thisExpression$3(), checkBinding ? identifier$b(checkBinding.name) : identifier$b(thisBinding)])));
        fn.replaceWith(callExpression$b(memberExpression$9(nameFunction(this, true) || fn.node, identifier$b("bind")), [checkBinding ? identifier$b(checkBinding.name) : thisExpression$3()]));
      }
    }
    var getSuperCallsVisitor = merge$12([{
      CallExpression: function CallExpression2(child, _ref22) {
        var allSuperCalls = _ref22.allSuperCalls;
        if (!child.get("callee").isSuper())
          return;
        allSuperCalls.push(child);
      }
    }, environmentVisitor]);
    function hoistFunctionEnvironment(fnPath, noNewArrows, allowInsertArrow) {
      if (noNewArrows === void 0) {
        noNewArrows = true;
      }
      if (allowInsertArrow === void 0) {
        allowInsertArrow = true;
      }
      var arrowParent;
      var thisEnvFn = fnPath.findParent(function(p2) {
        if (p2.isArrowFunctionExpression()) {
          var _arrowParent;
          (_arrowParent = arrowParent) != null ? _arrowParent : arrowParent = p2;
          return false;
        }
        return p2.isFunction() || p2.isProgram() || p2.isClassProperty({
          "static": false
        }) || p2.isClassPrivateProperty({
          "static": false
        });
      });
      var inConstructor = thisEnvFn.isClassMethod({
        kind: "constructor"
      });
      if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
        if (arrowParent) {
          thisEnvFn = arrowParent;
        } else if (allowInsertArrow) {
          fnPath.replaceWith(callExpression$b(arrowFunctionExpression$2([], toExpression(fnPath.node)), []));
          thisEnvFn = fnPath.get("callee");
          fnPath = thisEnvFn.get("body");
        } else {
          throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
        }
      }
      var _getScopeInformation = getScopeInformation(fnPath), thisPaths = _getScopeInformation.thisPaths, argumentsPaths = _getScopeInformation.argumentsPaths, newTargetPaths = _getScopeInformation.newTargetPaths, superProps = _getScopeInformation.superProps, superCalls = _getScopeInformation.superCalls;
      if (inConstructor && superCalls.length > 0) {
        if (!allowInsertArrow) {
          throw superCalls[0].buildCodeFrameError("Unable to handle nested super() usage in arrow");
        }
        var allSuperCalls = [];
        thisEnvFn.traverse(getSuperCallsVisitor, {
          allSuperCalls
        });
        var superBinding = getSuperBinding(thisEnvFn);
        allSuperCalls.forEach(function(superCall2) {
          var callee = identifier$b(superBinding);
          callee.loc = superCall2.node.callee.loc;
          superCall2.get("callee").replaceWith(callee);
        });
      }
      if (argumentsPaths.length > 0) {
        var argumentsBinding = getBinding(thisEnvFn, "arguments", function() {
          var args = function args2() {
            return identifier$b("arguments");
          };
          if (thisEnvFn.scope.path.isProgram()) {
            return conditionalExpression$2(binaryExpression$3("===", unaryExpression$4("typeof", args()), stringLiteral$6("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
          } else {
            return args();
          }
        });
        argumentsPaths.forEach(function(argumentsChild) {
          var argsRef = identifier$b(argumentsBinding);
          argsRef.loc = argumentsChild.node.loc;
          argumentsChild.replaceWith(argsRef);
        });
      }
      if (newTargetPaths.length > 0) {
        var newTargetBinding = getBinding(thisEnvFn, "newtarget", function() {
          return metaProperty(identifier$b("new"), identifier$b("target"));
        });
        newTargetPaths.forEach(function(targetChild) {
          var targetRef = identifier$b(newTargetBinding);
          targetRef.loc = targetChild.node.loc;
          targetChild.replaceWith(targetRef);
        });
      }
      if (superProps.length > 0) {
        if (!allowInsertArrow) {
          throw superProps[0].buildCodeFrameError("Unable to handle nested super.prop usage");
        }
        var flatSuperProps = superProps.reduce(function(acc, superProp) {
          return acc.concat(standardizeSuperProperty(superProp));
        }, []);
        flatSuperProps.forEach(function(superProp) {
          var key2 = superProp.node.computed ? "" : superProp.get("property").node.name;
          var isAssignment = superProp.parentPath.isAssignmentExpression({
            left: superProp.node
          });
          var isCall = superProp.parentPath.isCallExpression({
            callee: superProp.node
          });
          var superBinding2 = getSuperPropBinding(thisEnvFn, isAssignment, key2);
          var args = [];
          if (superProp.node.computed) {
            args.push(superProp.get("property").node);
          }
          if (isAssignment) {
            var value = superProp.parentPath.node.right;
            args.push(value);
          }
          var call3 = callExpression$b(identifier$b(superBinding2), args);
          if (isCall) {
            superProp.parentPath.unshiftContainer("arguments", thisExpression$3());
            superProp.replaceWith(memberExpression$9(call3, identifier$b("call")));
            thisPaths.push(superProp.parentPath.get("arguments.0"));
          } else if (isAssignment) {
            superProp.parentPath.replaceWith(call3);
          } else {
            superProp.replaceWith(call3);
          }
        });
      }
      var thisBinding;
      if (thisPaths.length > 0 || !noNewArrows) {
        thisBinding = getThisBinding(thisEnvFn, inConstructor);
        if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
          thisPaths.forEach(function(thisChild) {
            var thisRef = thisChild.isJSX() ? jsxIdentifier$1(thisBinding) : identifier$b(thisBinding);
            thisRef.loc = thisChild.node.loc;
            thisChild.replaceWith(thisRef);
          });
          if (!noNewArrows)
            thisBinding = null;
        }
      }
      return {
        thisBinding,
        fnPath
      };
    }
    function isLogicalOp(op) {
      return LOGICAL_OPERATORS$2.includes(op);
    }
    function standardizeSuperProperty(superProp) {
      if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
        var assignmentPath = superProp.parentPath;
        var op = assignmentPath.node.operator.slice(0, -1);
        var value = assignmentPath.node.right;
        var isLogicalAssignment = isLogicalOp(op);
        if (superProp.node.computed) {
          var tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
          var object4 = superProp.node.object;
          var property2 = superProp.node.property;
          assignmentPath.get("left").replaceWith(memberExpression$9(object4, assignmentExpression$9("=", tmp, property2), true));
          assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$9(object4, identifier$b(tmp.name), true), value));
        } else {
          var _object = superProp.node.object;
          var _property = superProp.node.property;
          assignmentPath.get("left").replaceWith(memberExpression$9(_object, _property));
          assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$9(_object, identifier$b(_property.name)), value));
        }
        if (isLogicalAssignment) {
          assignmentPath.replaceWith(logicalExpression$2(op, assignmentPath.node.left, assignmentPath.node.right));
        } else {
          assignmentPath.node.operator = "=";
        }
        return [assignmentPath.get("left"), assignmentPath.get("right").get("left")];
      } else if (superProp.parentPath.isUpdateExpression()) {
        var updateExpr = superProp.parentPath;
        var _tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
        var computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
        var parts = [assignmentExpression$9("=", _tmp, memberExpression$9(superProp.node.object, computedKey ? assignmentExpression$9("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)), assignmentExpression$9("=", memberExpression$9(superProp.node.object, computedKey ? identifier$b(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression$3(superProp.parentPath.node.operator[0], identifier$b(_tmp.name), numericLiteral$5(1)))];
        if (!superProp.parentPath.node.prefix) {
          parts.push(identifier$b(_tmp.name));
        }
        updateExpr.replaceWith(sequenceExpression$6(parts));
        var left = updateExpr.get("expressions.0.right");
        var right = updateExpr.get("expressions.1.left");
        return [left, right];
      }
      return [superProp];
      function rightExpression(op2, left2, right2) {
        if (op2 === "=") {
          return assignmentExpression$9("=", left2, right2);
        } else {
          return binaryExpression$3(op2, left2, right2);
        }
      }
    }
    function hasSuperClass(thisEnvFn) {
      return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
    }
    var assignSuperThisVisitor = merge$12([{
      CallExpression: function CallExpression2(child, _ref3) {
        var supers = _ref3.supers, thisBinding = _ref3.thisBinding;
        if (!child.get("callee").isSuper())
          return;
        if (supers.has(child.node))
          return;
        supers.add(child.node);
        child.replaceWithMultiple([child.node, assignmentExpression$9("=", identifier$b(thisBinding), identifier$b("this"))]);
      }
    }, environmentVisitor]);
    function getThisBinding(thisEnvFn, inConstructor) {
      return getBinding(thisEnvFn, "this", function(thisBinding) {
        if (!inConstructor || !hasSuperClass(thisEnvFn))
          return thisExpression$3();
        thisEnvFn.traverse(assignSuperThisVisitor, {
          supers: /* @__PURE__ */ new WeakSet(),
          thisBinding
        });
      });
    }
    function getSuperBinding(thisEnvFn) {
      return getBinding(thisEnvFn, "supercall", function() {
        var argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
        return arrowFunctionExpression$2([restElement(argsBinding)], callExpression$b(_super(), [spreadElement$1(identifier$b(argsBinding.name))]));
      });
    }
    function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
      var op = isAssignment ? "set" : "get";
      return getBinding(thisEnvFn, "superprop_" + op + ":" + (propName || ""), function() {
        var argsList = [];
        var fnBody;
        if (propName) {
          fnBody = memberExpression$9(_super(), identifier$b(propName));
        } else {
          var method5 = thisEnvFn.scope.generateUidIdentifier("prop");
          argsList.unshift(method5);
          fnBody = memberExpression$9(_super(), identifier$b(method5.name), true);
        }
        if (isAssignment) {
          var valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
          argsList.push(valueIdent);
          fnBody = assignmentExpression$9("=", fnBody, identifier$b(valueIdent.name));
        }
        return arrowFunctionExpression$2(argsList, fnBody);
      });
    }
    function getBinding(thisEnvFn, key2, init3) {
      var cacheKey = "binding:" + key2;
      var data3 = thisEnvFn.getData(cacheKey);
      if (!data3) {
        var id3 = thisEnvFn.scope.generateUidIdentifier(key2);
        data3 = id3.name;
        thisEnvFn.setData(cacheKey, data3);
        thisEnvFn.scope.push({
          id: id3,
          init: init3(data3)
        });
      }
      return data3;
    }
    var getScopeInformationVisitor = merge$12([{
      ThisExpression: function ThisExpression2(child, _ref42) {
        var thisPaths = _ref42.thisPaths;
        thisPaths.push(child);
      },
      JSXIdentifier: function JSXIdentifier2(child, _ref5) {
        var thisPaths = _ref5.thisPaths;
        if (child.node.name !== "this")
          return;
        if (!child.parentPath.isJSXMemberExpression({
          object: child.node
        }) && !child.parentPath.isJSXOpeningElement({
          name: child.node
        })) {
          return;
        }
        thisPaths.push(child);
      },
      CallExpression: function CallExpression2(child, _ref6) {
        var superCalls = _ref6.superCalls;
        if (child.get("callee").isSuper())
          superCalls.push(child);
      },
      MemberExpression: function MemberExpression2(child, _ref7) {
        var superProps = _ref7.superProps;
        if (child.get("object").isSuper())
          superProps.push(child);
      },
      Identifier: function Identifier2(child, _ref8) {
        var argumentsPaths = _ref8.argumentsPaths;
        if (!child.isReferencedIdentifier({
          name: "arguments"
        }))
          return;
        var curr = child.scope;
        do {
          if (curr.hasOwnBinding("arguments")) {
            curr.rename("arguments");
            return;
          }
          if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
            break;
          }
        } while (curr = curr.parent);
        argumentsPaths.push(child);
      },
      MetaProperty: function MetaProperty2(child, _ref9) {
        var newTargetPaths = _ref9.newTargetPaths;
        if (!child.get("meta").isIdentifier({
          name: "new"
        }))
          return;
        if (!child.get("property").isIdentifier({
          name: "target"
        }))
          return;
        newTargetPaths.push(child);
      }
    }, environmentVisitor]);
    function getScopeInformation(fnPath) {
      var thisPaths = [];
      var argumentsPaths = [];
      var newTargetPaths = [];
      var superProps = [];
      var superCalls = [];
      fnPath.traverse(getScopeInformationVisitor, {
        thisPaths,
        argumentsPaths,
        newTargetPaths,
        superProps,
        superCalls
      });
      return {
        thisPaths,
        argumentsPaths,
        newTargetPaths,
        superProps,
        superCalls
      };
    }
    var NodePath_conversion = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      toComputedKey: toComputedKey$2,
      ensureBlock,
      arrowFunctionToShadowed,
      unwrapFunctionEnvironment,
      arrowFunctionToExpression
    });
    var STATEMENT_OR_BLOCK_KEYS = STATEMENT_OR_BLOCK_KEYS$1, VISITOR_KEYS$3 = VISITOR_KEYS$7, isBlockStatement = isBlockStatement$2, isExpression$1 = isExpression$4, isIdentifier$8 = isIdentifier$i, isLiteral$2 = isLiteral$7, isStringLiteral$3 = isStringLiteral$7, isType = isType$2, _matchesPattern = matchesPattern$2;
    function matchesPattern(pattern5, allowPartial) {
      return _matchesPattern(this.node, pattern5, allowPartial);
    }
    function has$a(key2) {
      var val = this.node && this.node[key2];
      if (val && Array.isArray(val)) {
        return !!val.length;
      } else {
        return !!val;
      }
    }
    function isStatic() {
      return this.scope.isStatic(this.node);
    }
    var is = has$a;
    function isnt(key2) {
      return !this.has(key2);
    }
    function equals(key2, value) {
      return this.node[key2] === value;
    }
    function isNodeType(type5) {
      return isType(this.type, type5);
    }
    function canHaveVariableDeclarationOrExpression() {
      return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
    }
    function canSwapBetweenExpressionAndStatement(replacement) {
      if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
        return false;
      }
      if (this.isExpression()) {
        return isBlockStatement(replacement);
      } else if (this.isBlockStatement()) {
        return isExpression$1(replacement);
      }
      return false;
    }
    function isCompletionRecord(allowInsideFunction) {
      var path2 = this;
      var first = true;
      do {
        var container2 = path2.container;
        if (path2.isFunction() && !first) {
          return !!allowInsideFunction;
        }
        first = false;
        if (Array.isArray(container2) && path2.key !== container2.length - 1) {
          return false;
        }
      } while ((path2 = path2.parentPath) && !path2.isProgram());
      return true;
    }
    function isStatementOrBlock() {
      if (this.parentPath.isLabeledStatement() || isBlockStatement(this.container)) {
        return false;
      } else {
        return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
      }
    }
    function referencesImport(moduleSource, importName) {
      if (!this.isReferencedIdentifier()) {
        if (this.isJSXMemberExpression() && this.node.property.name === importName || (this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral$3(this.node.property, {
          value: importName
        }) : this.node.property.name === importName)) {
          var object4 = this.get("object");
          return object4.isReferencedIdentifier() && object4.referencesImport(moduleSource, "*");
        }
        return false;
      }
      var binding2 = this.scope.getBinding(this.node.name);
      if (!binding2 || binding2.kind !== "module")
        return false;
      var path2 = binding2.path;
      var parent = path2.parentPath;
      if (!parent.isImportDeclaration())
        return false;
      if (parent.node.source.value === moduleSource) {
        if (!importName)
          return true;
      } else {
        return false;
      }
      if (path2.isImportDefaultSpecifier() && importName === "default") {
        return true;
      }
      if (path2.isImportNamespaceSpecifier() && importName === "*") {
        return true;
      }
      if (path2.isImportSpecifier() && isIdentifier$8(path2.node.imported, {
        name: importName
      })) {
        return true;
      }
      return false;
    }
    function getSource$1() {
      var node2 = this.node;
      if (node2.end) {
        var code3 = this.hub.getCode();
        if (code3)
          return code3.slice(node2.start, node2.end);
      }
      return "";
    }
    function willIMaybeExecuteBefore(target) {
      return this._guessExecutionStatusRelativeTo(target) !== "after";
    }
    function getOuterFunction(path2) {
      return (path2.scope.getFunctionParent() || path2.scope.getProgramParent()).path;
    }
    function isExecutionUncertain(type5, key2) {
      switch (type5) {
        case "LogicalExpression":
          return key2 === "right";
        case "ConditionalExpression":
        case "IfStatement":
          return key2 === "consequent" || key2 === "alternate";
        case "WhileStatement":
        case "DoWhileStatement":
        case "ForInStatement":
        case "ForOfStatement":
          return key2 === "body";
        case "ForStatement":
          return key2 === "body" || key2 === "update";
        case "SwitchStatement":
          return key2 === "cases";
        case "TryStatement":
          return key2 === "handler";
        case "AssignmentPattern":
          return key2 === "right";
        case "OptionalMemberExpression":
          return key2 === "property";
        case "OptionalCallExpression":
          return key2 === "arguments";
        default:
          return false;
      }
    }
    function isExecutionUncertainInList(paths, maxIndex) {
      for (var i2 = 0; i2 < maxIndex; i2++) {
        var path2 = paths[i2];
        if (isExecutionUncertain(path2.parent.type, path2.parentKey)) {
          return true;
        }
      }
      return false;
    }
    function _guessExecutionStatusRelativeTo(target) {
      var funcParent = {
        "this": getOuterFunction(this),
        target: getOuterFunction(target)
      };
      if (funcParent.target.node !== funcParent["this"].node) {
        return this._guessExecutionStatusRelativeToDifferentFunctions(funcParent.target);
      }
      var paths = {
        target: target.getAncestry(),
        "this": this.getAncestry()
      };
      if (paths.target.indexOf(this) >= 0)
        return "after";
      if (paths["this"].indexOf(target) >= 0)
        return "before";
      var commonPath;
      var commonIndex = {
        target: 0,
        "this": 0
      };
      while (!commonPath && commonIndex["this"] < paths["this"].length) {
        var path2 = paths["this"][commonIndex["this"]];
        commonIndex.target = paths.target.indexOf(path2);
        if (commonIndex.target >= 0) {
          commonPath = path2;
        } else {
          commonIndex["this"]++;
        }
      }
      if (!commonPath) {
        throw new Error("Internal Babel error - The two compared nodes don't appear to belong to the same program.");
      }
      if (isExecutionUncertainInList(paths["this"], commonIndex["this"] - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
        return "unknown";
      }
      var divergence = {
        "this": paths["this"][commonIndex["this"] - 1],
        target: paths.target[commonIndex.target - 1]
      };
      if (divergence.target.listKey && divergence["this"].listKey && divergence.target.container === divergence["this"].container) {
        return divergence.target.key > divergence["this"].key ? "before" : "after";
      }
      var keys2 = VISITOR_KEYS$3[commonPath.type];
      var keyPosition = {
        "this": keys2.indexOf(divergence["this"].parentKey),
        target: keys2.indexOf(divergence.target.parentKey)
      };
      return keyPosition.target > keyPosition["this"] ? "before" : "after";
    }
    var executionOrderCheckedNodes = /* @__PURE__ */ new WeakSet();
    function _guessExecutionStatusRelativeToDifferentFunctions(target) {
      if (!target.isFunctionDeclaration() || target.parentPath.isExportDeclaration()) {
        return "unknown";
      }
      var binding2 = target.scope.getBinding(target.node.id.name);
      if (!binding2.references)
        return "before";
      var referencePaths = binding2.referencePaths;
      var allStatus;
      for (var _iterator2 = _createForOfIteratorHelperLoose(referencePaths), _step2; !(_step2 = _iterator2()).done; ) {
        var path2 = _step2.value;
        var childOfFunction = !!path2.find(function(path3) {
          return path3.node === target.node;
        });
        if (childOfFunction)
          continue;
        if (path2.key !== "callee" || !path2.parentPath.isCallExpression()) {
          return "unknown";
        }
        if (executionOrderCheckedNodes.has(path2.node))
          continue;
        executionOrderCheckedNodes.add(path2.node);
        var status = this._guessExecutionStatusRelativeTo(path2);
        executionOrderCheckedNodes["delete"](path2.node);
        if (allStatus && allStatus !== status) {
          return "unknown";
        } else {
          allStatus = status;
        }
      }
      return allStatus;
    }
    function resolve$4(dangerous, resolved) {
      return this._resolve(dangerous, resolved) || this;
    }
    function _resolve(dangerous, resolved) {
      if (resolved && resolved.indexOf(this) >= 0)
        return;
      resolved = resolved || [];
      resolved.push(this);
      if (this.isVariableDeclarator()) {
        if (this.get("id").isIdentifier()) {
          return this.get("init").resolve(dangerous, resolved);
        }
      } else if (this.isReferencedIdentifier()) {
        var binding2 = this.scope.getBinding(this.node.name);
        if (!binding2)
          return;
        if (!binding2.constant)
          return;
        if (binding2.kind === "module")
          return;
        if (binding2.path !== this) {
          var ret = binding2.path.resolve(dangerous, resolved);
          if (this.find(function(parent) {
            return parent.node === ret.node;
          }))
            return;
          return ret;
        }
      } else if (this.isTypeCastExpression()) {
        return this.get("expression").resolve(dangerous, resolved);
      } else if (dangerous && this.isMemberExpression()) {
        var targetKey = this.toComputedKey();
        if (!isLiteral$2(targetKey))
          return;
        var targetName = targetKey.value;
        var target = this.get("object").resolve(dangerous, resolved);
        if (target.isObjectExpression()) {
          var props = target.get("properties");
          for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done; ) {
            var prop2 = _step2.value;
            if (!prop2.isProperty())
              continue;
            var key2 = prop2.get("key");
            var match = prop2.isnt("computed") && key2.isIdentifier({
              name: targetName
            });
            match = match || key2.isLiteral({
              value: targetName
            });
            if (match)
              return prop2.get("value").resolve(dangerous, resolved);
          }
        } else if (target.isArrayExpression() && !isNaN(+targetName)) {
          var elems = target.get("elements");
          var elem = elems[targetName];
          if (elem)
            return elem.resolve(dangerous, resolved);
        }
      }
    }
    function isConstantExpression() {
      if (this.isIdentifier()) {
        var binding2 = this.scope.getBinding(this.node.name);
        if (!binding2)
          return false;
        return binding2.constant;
      }
      if (this.isLiteral()) {
        if (this.isRegExpLiteral()) {
          return false;
        }
        if (this.isTemplateLiteral()) {
          return this.get("expressions").every(function(expression2) {
            return expression2.isConstantExpression();
          });
        }
        return true;
      }
      if (this.isUnaryExpression()) {
        if (this.node.operator !== "void") {
          return false;
        }
        return this.get("argument").isConstantExpression();
      }
      if (this.isBinaryExpression()) {
        return this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
      }
      return false;
    }
    function isInStrictMode() {
      var start2 = this.isProgram() ? this : this.parentPath;
      var strictParent = start2.find(function(path2) {
        if (path2.isProgram({
          sourceType: "module"
        }))
          return true;
        if (path2.isClass())
          return true;
        if (!path2.isProgram() && !path2.isFunction())
          return false;
        if (path2.isArrowFunctionExpression() && !path2.get("body").isBlockStatement()) {
          return false;
        }
        var body = path2.isFunction() ? path2.node.body : path2.node;
        for (var _iterator3 = _createForOfIteratorHelperLoose(body.directives), _step3; !(_step3 = _iterator3()).done; ) {
          var directive2 = _step3.value;
          if (directive2.value.value === "use strict") {
            return true;
          }
        }
      });
      return !!strictParent;
    }
    var NodePath_introspection = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      matchesPattern,
      has: has$a,
      isStatic,
      is,
      isnt,
      equals,
      isNodeType,
      canHaveVariableDeclarationOrExpression,
      canSwapBetweenExpressionAndStatement,
      isCompletionRecord,
      isStatementOrBlock,
      referencesImport,
      getSource: getSource$1,
      willIMaybeExecuteBefore,
      _guessExecutionStatusRelativeTo,
      _guessExecutionStatusRelativeToDifferentFunctions,
      resolve: resolve$4,
      _resolve,
      isConstantExpression,
      isInStrictMode
    });
    function call2(key2) {
      var opts = this.opts;
      this.debug(key2);
      if (this.node) {
        if (this._call(opts[key2]))
          return true;
      }
      if (this.node) {
        return this._call(opts[this.node.type] && opts[this.node.type][key2]);
      }
      return false;
    }
    function _call(fns) {
      if (!fns)
        return false;
      for (var _iterator2 = _createForOfIteratorHelperLoose(fns), _step2; !(_step2 = _iterator2()).done; ) {
        var fn = _step2.value;
        if (!fn)
          continue;
        var node2 = this.node;
        if (!node2)
          return true;
        var ret = fn.call(this.state, this, this.state);
        if (ret && typeof ret === "object" && typeof ret.then === "function") {
          throw new Error("You appear to be using a plugin with an async traversal visitor, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
        }
        if (ret) {
          throw new Error("Unexpected return value from visitor method " + fn);
        }
        if (this.node !== node2)
          return true;
        if (this._traverseFlags > 0)
          return true;
      }
      return false;
    }
    function isDenylisted() {
      var _this$opts$denylist;
      var denylist = (_this$opts$denylist = this.opts.denylist) != null ? _this$opts$denylist : this.opts.blacklist;
      return denylist && denylist.indexOf(this.node.type) > -1;
    }
    function restoreContext(path2, context) {
      if (path2.context !== context) {
        path2.context = context;
        path2.state = context.state;
        path2.opts = context.opts;
      }
    }
    function visit$1() {
      if (!this.node) {
        return false;
      }
      if (this.isDenylisted()) {
        return false;
      }
      if (this.opts.shouldSkip && this.opts.shouldSkip(this)) {
        return false;
      }
      var currentContext = this.context;
      if (this.shouldSkip || this.call("enter")) {
        this.debug("Skip...");
        return this.shouldStop;
      }
      restoreContext(this, currentContext);
      this.debug("Recursing into...");
      this.shouldStop = traverseNode(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
      restoreContext(this, currentContext);
      this.call("exit");
      return this.shouldStop;
    }
    function skip() {
      this.shouldSkip = true;
    }
    function skipKey(key2) {
      if (this.skipKeys == null) {
        this.skipKeys = {};
      }
      this.skipKeys[key2] = true;
    }
    function stop2() {
      this._traverseFlags |= SHOULD_SKIP | SHOULD_STOP;
    }
    function setScope() {
      if (this.opts && this.opts.noScope)
        return;
      var path2 = this.parentPath;
      if (this.key === "key" && path2.isMethod())
        path2 = path2.parentPath;
      var target;
      while (path2 && !target) {
        if (path2.opts && path2.opts.noScope)
          return;
        target = path2.scope;
        path2 = path2.parentPath;
      }
      this.scope = this.getScope(target);
      if (this.scope)
        this.scope.init();
    }
    function setContext(context) {
      if (this.skipKeys != null) {
        this.skipKeys = {};
      }
      this._traverseFlags = 0;
      if (context) {
        this.context = context;
        this.state = context.state;
        this.opts = context.opts;
      }
      this.setScope();
      return this;
    }
    function resync() {
      if (this.removed)
        return;
      this._resyncParent();
      this._resyncList();
      this._resyncKey();
    }
    function _resyncParent() {
      if (this.parentPath) {
        this.parent = this.parentPath.node;
      }
    }
    function _resyncKey() {
      if (!this.container)
        return;
      if (this.node === this.container[this.key])
        return;
      if (Array.isArray(this.container)) {
        for (var i2 = 0; i2 < this.container.length; i2++) {
          if (this.container[i2] === this.node) {
            return this.setKey(i2);
          }
        }
      } else {
        for (var _i3 = 0, _Object$keys3 = Object.keys(this.container); _i3 < _Object$keys3.length; _i3++) {
          var key2 = _Object$keys3[_i3];
          if (this.container[key2] === this.node) {
            return this.setKey(key2);
          }
        }
      }
      this.key = null;
    }
    function _resyncList() {
      if (!this.parent || !this.inList)
        return;
      var newContainer = this.parent[this.listKey];
      if (this.container === newContainer)
        return;
      this.container = newContainer || null;
    }
    function _resyncRemoved() {
      if (this.key == null || !this.container || this.container[this.key] !== this.node) {
        this._markRemoved();
      }
    }
    function popContext() {
      this.contexts.pop();
      if (this.contexts.length > 0) {
        this.setContext(this.contexts[this.contexts.length - 1]);
      } else {
        this.setContext(void 0);
      }
    }
    function pushContext(context) {
      this.contexts.push(context);
      this.setContext(context);
    }
    function setup(parentPath, container2, listKey, key2) {
      this.listKey = listKey;
      this.container = container2;
      this.parentPath = parentPath || this.parentPath;
      this.setKey(key2);
    }
    function setKey(key2) {
      var _this$node;
      this.key = key2;
      this.node = this.container[this.key];
      this.type = (_this$node = this.node) == null ? void 0 : _this$node.type;
    }
    function requeue(pathToQueue) {
      if (pathToQueue === void 0) {
        pathToQueue = this;
      }
      if (pathToQueue.removed)
        return;
      var contexts = this.contexts;
      for (var _iterator2 = _createForOfIteratorHelperLoose(contexts), _step2; !(_step2 = _iterator2()).done; ) {
        var context = _step2.value;
        context.maybeQueue(pathToQueue);
      }
    }
    function _getQueueContexts() {
      var path2 = this;
      var contexts = this.contexts;
      while (!contexts.length) {
        path2 = path2.parentPath;
        if (!path2)
          break;
        contexts = path2.contexts;
      }
      return contexts;
    }
    var NodePath_context = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      call: call2,
      _call,
      isDenylisted,
      isBlacklisted: isDenylisted,
      visit: visit$1,
      skip,
      skipKey,
      stop: stop2,
      setScope,
      setContext,
      resync,
      _resyncParent,
      _resyncKey,
      _resyncList,
      _resyncRemoved,
      popContext,
      pushContext,
      setup,
      setKey,
      requeue,
      _getQueueContexts
    });
    var hooks = [function(self2, parent) {
      var removeParent = self2.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self2.key === "declaration" && parent.isExportDeclaration() || self2.key === "body" && parent.isLabeledStatement() || self2.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self2.key === "expression" && parent.isExpressionStatement();
      if (removeParent) {
        parent.remove();
        return true;
      }
    }, function(self2, parent) {
      if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
        parent.replaceWith(parent.node.expressions[0]);
        return true;
      }
    }, function(self2, parent) {
      if (parent.isBinary()) {
        if (self2.key === "left") {
          parent.replaceWith(parent.node.right);
        } else {
          parent.replaceWith(parent.node.left);
        }
        return true;
      }
    }, function(self2, parent) {
      if (parent.isIfStatement() && (self2.key === "consequent" || self2.key === "alternate") || self2.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
        self2.replaceWith({
          type: "BlockStatement",
          body: []
        });
        return true;
      }
    }];
    function remove() {
      var _this$opts;
      this._assertUnremoved();
      this.resync();
      if (!((_this$opts = this.opts) != null && _this$opts.noScope)) {
        this._removeFromScope();
      }
      if (this._callRemovalHooks()) {
        this._markRemoved();
        return;
      }
      this.shareCommentsWithSiblings();
      this._remove();
      this._markRemoved();
    }
    function _removeFromScope() {
      var _this = this;
      var bindings = this.getBindingIdentifiers();
      Object.keys(bindings).forEach(function(name2) {
        return _this.scope.removeBinding(name2);
      });
    }
    function _callRemovalHooks() {
      for (var _iterator2 = _createForOfIteratorHelperLoose(hooks), _step2; !(_step2 = _iterator2()).done; ) {
        var fn = _step2.value;
        if (fn(this, this.parentPath))
          return true;
      }
    }
    function _remove() {
      if (Array.isArray(this.container)) {
        this.container.splice(this.key, 1);
        this.updateSiblingKeys(this.key, -1);
      } else {
        this._replaceWith(null);
      }
    }
    function _markRemoved() {
      this._traverseFlags |= SHOULD_SKIP | REMOVED;
      if (this.parent)
        path$2.get(this.parent)["delete"](this.node);
      this.node = null;
    }
    function _assertUnremoved() {
      if (this.removed) {
        throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
      }
    }
    var NodePath_removal = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      remove,
      _removeFromScope,
      _callRemovalHooks,
      _remove,
      _markRemoved,
      _assertUnremoved
    });
    var react$1 = react$3;
    var cloneNode$c = cloneNode$i, jsxExpressionContainer = jsxExpressionContainer$1, variableDeclaration$4 = variableDeclaration$7, variableDeclarator$4 = variableDeclarator$7;
    var referenceVisitor$1 = {
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        if (path2.isJSXIdentifier() && react$1.isCompatTag(path2.node.name) && !path2.parentPath.isJSXMemberExpression()) {
          return;
        }
        if (path2.node.name === "this") {
          var scope2 = path2.scope;
          do {
            if (scope2.path.isFunction() && !scope2.path.isArrowFunctionExpression()) {
              break;
            }
          } while (scope2 = scope2.parent);
          if (scope2)
            state.breakOnScopePaths.push(scope2.path);
        }
        var binding2 = path2.scope.getBinding(path2.node.name);
        if (!binding2)
          return;
        for (var _iterator2 = _createForOfIteratorHelperLoose(binding2.constantViolations), _step2; !(_step2 = _iterator2()).done; ) {
          var violation = _step2.value;
          if (violation.scope !== binding2.path.scope) {
            state.mutableBinding = true;
            path2.stop();
            return;
          }
        }
        if (binding2 !== state.scope.getBinding(path2.node.name))
          return;
        state.bindings[path2.node.name] = binding2;
      }
    };
    var PathHoister = function() {
      function PathHoister2(path2, scope2) {
        this.breakOnScopePaths = void 0;
        this.bindings = void 0;
        this.mutableBinding = void 0;
        this.scopes = void 0;
        this.scope = void 0;
        this.path = void 0;
        this.attachAfter = void 0;
        this.breakOnScopePaths = [];
        this.bindings = {};
        this.mutableBinding = false;
        this.scopes = [];
        this.scope = scope2;
        this.path = path2;
        this.attachAfter = false;
      }
      var _proto = PathHoister2.prototype;
      _proto.isCompatibleScope = function isCompatibleScope(scope2) {
        for (var _i3 = 0, _Object$keys3 = Object.keys(this.bindings); _i3 < _Object$keys3.length; _i3++) {
          var key2 = _Object$keys3[_i3];
          var binding2 = this.bindings[key2];
          if (!scope2.bindingIdentifierEquals(key2, binding2.identifier)) {
            return false;
          }
        }
        return true;
      };
      _proto.getCompatibleScopes = function getCompatibleScopes() {
        var scope2 = this.path.scope;
        do {
          if (this.isCompatibleScope(scope2)) {
            this.scopes.push(scope2);
          } else {
            break;
          }
          if (this.breakOnScopePaths.indexOf(scope2.path) >= 0) {
            break;
          }
        } while (scope2 = scope2.parent);
      };
      _proto.getAttachmentPath = function getAttachmentPath() {
        var path2 = this._getAttachmentPath();
        if (!path2)
          return;
        var targetScope = path2.scope;
        if (targetScope.path === path2) {
          targetScope = path2.scope.parent;
        }
        if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
          for (var _i22 = 0, _Object$keys22 = Object.keys(this.bindings); _i22 < _Object$keys22.length; _i22++) {
            var name2 = _Object$keys22[_i22];
            if (!targetScope.hasOwnBinding(name2))
              continue;
            var binding2 = this.bindings[name2];
            if (binding2.kind === "param" || binding2.path.parentKey === "params") {
              continue;
            }
            var bindingParentPath = this.getAttachmentParentForPath(binding2.path);
            if (bindingParentPath.key >= path2.key) {
              this.attachAfter = true;
              path2 = binding2.path;
              for (var _iterator2 = _createForOfIteratorHelperLoose(binding2.constantViolations), _step2; !(_step2 = _iterator2()).done; ) {
                var violationPath = _step2.value;
                if (this.getAttachmentParentForPath(violationPath).key > path2.key) {
                  path2 = violationPath;
                }
              }
            }
          }
        }
        return path2;
      };
      _proto._getAttachmentPath = function _getAttachmentPath() {
        var scopes = this.scopes;
        var scope2 = scopes.pop();
        if (!scope2)
          return;
        if (scope2.path.isFunction()) {
          if (this.hasOwnParamBindings(scope2)) {
            if (this.scope === scope2)
              return;
            var bodies = scope2.path.get("body").get("body");
            for (var i2 = 0; i2 < bodies.length; i2++) {
              if (bodies[i2].node._blockHoist)
                continue;
              return bodies[i2];
            }
          } else {
            return this.getNextScopeAttachmentParent();
          }
        } else if (scope2.path.isProgram()) {
          return this.getNextScopeAttachmentParent();
        }
      };
      _proto.getNextScopeAttachmentParent = function getNextScopeAttachmentParent() {
        var scope2 = this.scopes.pop();
        if (scope2)
          return this.getAttachmentParentForPath(scope2.path);
      };
      _proto.getAttachmentParentForPath = function getAttachmentParentForPath(path2) {
        do {
          if (!path2.parentPath || Array.isArray(path2.container) && path2.isStatement()) {
            return path2;
          }
        } while (path2 = path2.parentPath);
      };
      _proto.hasOwnParamBindings = function hasOwnParamBindings(scope2) {
        for (var _i3 = 0, _Object$keys3 = Object.keys(this.bindings); _i3 < _Object$keys3.length; _i3++) {
          var name2 = _Object$keys3[_i3];
          if (!scope2.hasOwnBinding(name2))
            continue;
          var binding2 = this.bindings[name2];
          if (binding2.kind === "param" && binding2.constant)
            return true;
        }
        return false;
      };
      _proto.run = function run2() {
        this.path.traverse(referenceVisitor$1, this);
        if (this.mutableBinding)
          return;
        this.getCompatibleScopes();
        var attachTo = this.getAttachmentPath();
        if (!attachTo)
          return;
        if (attachTo.getFunctionParent() === this.path.getFunctionParent())
          return;
        var uid2 = attachTo.scope.generateUidIdentifier("ref");
        var declarator = variableDeclarator$4(uid2, this.path.node);
        var insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
        var _attachTo$insertFn = attachTo[insertFn]([attachTo.isVariableDeclarator() ? declarator : variableDeclaration$4("var", [declarator])]), _attachTo$insertFn2 = _slicedToArray$12(_attachTo$insertFn, 1), attached = _attachTo$insertFn2[0];
        var parent = this.path.parentPath;
        if (parent.isJSXElement() && this.path.container === parent.node.children) {
          uid2 = jsxExpressionContainer(uid2);
        }
        this.path.replaceWith(cloneNode$c(uid2));
        return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
      };
      return _createClass2(PathHoister2);
    }();
    var arrowFunctionExpression$1 = arrowFunctionExpression$4, assertExpression = assertExpression$1, assignmentExpression$8 = assignmentExpression$c, blockStatement$2 = blockStatement$6, callExpression$a = callExpression$e, cloneNode$b = cloneNode$i, expressionStatement$5 = expressionStatement$a, isAssignmentExpression = isAssignmentExpression$4, isCallExpression$1 = isCallExpression$7, isExpression = isExpression$4, isIdentifier$7 = isIdentifier$i, isSequenceExpression = isSequenceExpression$2, isSuper$1 = isSuper$3, thisExpression$2 = thisExpression$4;
    function insertBefore2(nodes_) {
      this._assertUnremoved();
      var nodes2 = this._verifyNodeList(nodes_);
      var parentPath = this.parentPath;
      if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || parentPath.isExportNamedDeclaration() || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
        return parentPath.insertBefore(nodes2);
      } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
        if (this.node)
          nodes2.push(this.node);
        return this.replaceExpressionWithStatements(nodes2);
      } else if (Array.isArray(this.container)) {
        return this._containerInsertBefore(nodes2);
      } else if (this.isStatementOrBlock()) {
        var node2 = this.node;
        var shouldInsertCurrentNode = node2 && (!this.isExpressionStatement() || node2.expression != null);
        this.replaceWith(blockStatement$2(shouldInsertCurrentNode ? [node2] : []));
        return this.unshiftContainer("body", nodes2);
      } else {
        throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
      }
    }
    function _containerInsert(from2, nodes2) {
      var _this$container;
      this.updateSiblingKeys(from2, nodes2.length);
      var paths = [];
      (_this$container = this.container).splice.apply(_this$container, [from2, 0].concat(_toConsumableArray2(nodes2)));
      for (var i2 = 0; i2 < nodes2.length; i2++) {
        var to = from2 + i2;
        var path2 = this.getSibling(to);
        paths.push(path2);
        if (this.context && this.context.queue) {
          path2.pushContext(this.context);
        }
      }
      var contexts = this._getQueueContexts();
      for (var _i3 = 0, _paths = paths; _i3 < _paths.length; _i3++) {
        var _path = _paths[_i3];
        _path.setScope();
        _path.debug("Inserted.");
        for (var _iterator2 = _createForOfIteratorHelperLoose(contexts), _step2; !(_step2 = _iterator2()).done; ) {
          var context = _step2.value;
          context.maybeQueue(_path, true);
        }
      }
      return paths;
    }
    function _containerInsertBefore(nodes2) {
      return this._containerInsert(this.key, nodes2);
    }
    function _containerInsertAfter(nodes2) {
      return this._containerInsert(this.key + 1, nodes2);
    }
    var last = function last2(arr) {
      return arr[arr.length - 1];
    };
    function isHiddenInSequenceExpression(path2) {
      return isSequenceExpression(path2.parent) && (last(path2.parent.expressions) !== path2.node || isHiddenInSequenceExpression(path2.parentPath));
    }
    function isAlmostConstantAssignment(node2, scope2) {
      if (!isAssignmentExpression(node2) || !isIdentifier$7(node2.left)) {
        return false;
      }
      var blockScope = scope2.getBlockParent();
      return blockScope.hasOwnBinding(node2.left.name) && blockScope.getOwnBinding(node2.left.name).constantViolations.length <= 1;
    }
    function insertAfter(nodes_) {
      this._assertUnremoved();
      if (this.isSequenceExpression()) {
        return last(this.get("expressions")).insertAfter(nodes_);
      }
      var nodes2 = this._verifyNodeList(nodes_);
      var parentPath = this.parentPath;
      if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || parentPath.isExportNamedDeclaration() || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
        return parentPath.insertAfter(nodes2.map(function(node3) {
          return isExpression(node3) ? expressionStatement$5(node3) : node3;
        }));
      } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
        if (this.node) {
          var node2 = this.node;
          var scope2 = this.scope;
          if (scope2.path.isPattern()) {
            assertExpression(node2);
            this.replaceWith(callExpression$a(arrowFunctionExpression$1([], node2), []));
            this.get("callee.body").insertAfter(nodes2);
            return [this];
          }
          if (isHiddenInSequenceExpression(this)) {
            nodes2.unshift(node2);
          } else if (isCallExpression$1(node2) && isSuper$1(node2.callee)) {
            nodes2.unshift(node2);
            nodes2.push(thisExpression$2());
          } else if (isAlmostConstantAssignment(node2, scope2)) {
            nodes2.unshift(node2);
            nodes2.push(cloneNode$b(node2.left));
          } else if (scope2.isPure(node2, true)) {
            nodes2.push(node2);
          } else {
            if (parentPath.isMethod({
              computed: true,
              key: node2
            })) {
              scope2 = scope2.parent;
            }
            var temp = scope2.generateDeclaredUidIdentifier();
            nodes2.unshift(expressionStatement$5(assignmentExpression$8("=", cloneNode$b(temp), node2)));
            nodes2.push(expressionStatement$5(cloneNode$b(temp)));
          }
        }
        return this.replaceExpressionWithStatements(nodes2);
      } else if (Array.isArray(this.container)) {
        return this._containerInsertAfter(nodes2);
      } else if (this.isStatementOrBlock()) {
        var _node = this.node;
        var shouldInsertCurrentNode = _node && (!this.isExpressionStatement() || _node.expression != null);
        this.replaceWith(blockStatement$2(shouldInsertCurrentNode ? [_node] : []));
        return this.pushContainer("body", nodes2);
      } else {
        throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
      }
    }
    function updateSiblingKeys(fromIndex, incrementBy) {
      if (!this.parent)
        return;
      var paths = path$2.get(this.parent);
      for (var _iterator2 = _createForOfIteratorHelperLoose(paths), _step2; !(_step2 = _iterator2()).done; ) {
        var _step2$value = _slicedToArray$12(_step2.value, 2), path2 = _step2$value[1];
        if (path2.key >= fromIndex) {
          path2.key += incrementBy;
        }
      }
    }
    function _verifyNodeList(nodes2) {
      if (!nodes2) {
        return [];
      }
      if (!Array.isArray(nodes2)) {
        nodes2 = [nodes2];
      }
      for (var i2 = 0; i2 < nodes2.length; i2++) {
        var node2 = nodes2[i2];
        var msg2 = void 0;
        if (!node2) {
          msg2 = "has falsy node";
        } else if (typeof node2 !== "object") {
          msg2 = "contains a non-object node";
        } else if (!node2.type) {
          msg2 = "without a type";
        } else if (node2 instanceof NodePath) {
          msg2 = "has a NodePath when it expected a raw object";
        }
        if (msg2) {
          var type5 = Array.isArray(node2) ? "array" : typeof node2;
          throw new Error("Node list " + msg2 + " with the index of " + i2 + " and type of " + type5);
        }
      }
      return nodes2;
    }
    function unshiftContainer(listKey, nodes2) {
      this._assertUnremoved();
      nodes2 = this._verifyNodeList(nodes2);
      var path2 = NodePath.get({
        parentPath: this,
        parent: this.node,
        container: this.node[listKey],
        listKey,
        key: 0
      }).setContext(this.context);
      return path2._containerInsertBefore(nodes2);
    }
    function pushContainer(listKey, nodes2) {
      this._assertUnremoved();
      var verifiedNodes = this._verifyNodeList(nodes2);
      var container2 = this.node[listKey];
      var path2 = NodePath.get({
        parentPath: this,
        parent: this.node,
        container: container2,
        listKey,
        key: container2.length
      }).setContext(this.context);
      return path2.replaceWithMultiple(verifiedNodes);
    }
    function hoist$3(scope2) {
      if (scope2 === void 0) {
        scope2 = this.scope;
      }
      var hoister = new PathHoister(this, scope2);
      return hoister.run();
    }
    var NodePath_modification = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      insertBefore: insertBefore2,
      _containerInsert,
      _containerInsertBefore,
      _containerInsertAfter,
      insertAfter,
      updateSiblingKeys,
      _verifyNodeList,
      unshiftContainer,
      pushContainer,
      hoist: hoist$3
    });
    var _getBindingIdentifiers = getBindingIdentifiers$2, _getOuterBindingIdentifiers = getOuterBindingIdentifiers$2, isDeclaration = isDeclaration$1, numericLiteral$4 = numericLiteral$7, unaryExpression$3 = unaryExpression$6;
    var NORMAL_COMPLETION = 0;
    var BREAK_COMPLETION = 1;
    function NormalCompletion(path2) {
      return {
        type: NORMAL_COMPLETION,
        path: path2
      };
    }
    function BreakCompletion(path2) {
      return {
        type: BREAK_COMPLETION,
        path: path2
      };
    }
    function getOpposite() {
      if (this.key === "left") {
        return this.getSibling("right");
      } else if (this.key === "right") {
        return this.getSibling("left");
      }
      return null;
    }
    function addCompletionRecords(path2, records, context) {
      if (path2) {
        records.push.apply(records, _toConsumableArray2(_getCompletionRecords(path2, context)));
      }
      return records;
    }
    function completionRecordForSwitch(cases, records, context) {
      var lastNormalCompletions = [];
      for (var i2 = 0; i2 < cases.length; i2++) {
        var casePath = cases[i2];
        var caseCompletions = _getCompletionRecords(casePath, context);
        var normalCompletions = [];
        var breakCompletions = [];
        for (var _iterator2 = _createForOfIteratorHelperLoose(caseCompletions), _step2; !(_step2 = _iterator2()).done; ) {
          var c2 = _step2.value;
          if (c2.type === NORMAL_COMPLETION) {
            normalCompletions.push(c2);
          }
          if (c2.type === BREAK_COMPLETION) {
            breakCompletions.push(c2);
          }
        }
        if (normalCompletions.length) {
          lastNormalCompletions = normalCompletions;
        }
        records.push.apply(records, breakCompletions);
      }
      records.push.apply(records, _toConsumableArray2(lastNormalCompletions));
      return records;
    }
    function normalCompletionToBreak(completions) {
      completions.forEach(function(c2) {
        c2.type = BREAK_COMPLETION;
      });
    }
    function replaceBreakStatementInBreakCompletion(completions, reachable) {
      completions.forEach(function(c2) {
        if (c2.path.isBreakStatement({
          label: null
        })) {
          if (reachable) {
            c2.path.replaceWith(unaryExpression$3("void", numericLiteral$4(0)));
          } else {
            c2.path.remove();
          }
        }
      });
    }
    function getStatementListCompletion(paths, context) {
      var completions = [];
      if (context.canHaveBreak) {
        var lastNormalCompletions = [];
        for (var i2 = 0; i2 < paths.length; i2++) {
          var path2 = paths[i2];
          var newContext = Object.assign({}, context, {
            inCaseClause: false
          });
          if (path2.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
            newContext.shouldPopulateBreak = true;
          } else {
            newContext.shouldPopulateBreak = false;
          }
          var statementCompletions = _getCompletionRecords(path2, newContext);
          if (statementCompletions.length > 0 && statementCompletions.every(function(c3) {
            return c3.type === BREAK_COMPLETION;
          })) {
            if (lastNormalCompletions.length > 0 && statementCompletions.every(function(c3) {
              return c3.path.isBreakStatement({
                label: null
              });
            })) {
              normalCompletionToBreak(lastNormalCompletions);
              completions.push.apply(completions, _toConsumableArray2(lastNormalCompletions));
              if (lastNormalCompletions.some(function(c3) {
                return c3.path.isDeclaration();
              })) {
                completions.push.apply(completions, _toConsumableArray2(statementCompletions));
                replaceBreakStatementInBreakCompletion(statementCompletions, true);
              }
              replaceBreakStatementInBreakCompletion(statementCompletions, false);
            } else {
              completions.push.apply(completions, _toConsumableArray2(statementCompletions));
              if (!context.shouldPopulateBreak) {
                replaceBreakStatementInBreakCompletion(statementCompletions, true);
              }
            }
            break;
          }
          if (i2 === paths.length - 1) {
            completions.push.apply(completions, _toConsumableArray2(statementCompletions));
          } else {
            lastNormalCompletions = [];
            for (var _i3 = 0; _i3 < statementCompletions.length; _i3++) {
              var c2 = statementCompletions[_i3];
              if (c2.type === BREAK_COMPLETION) {
                completions.push(c2);
              }
              if (c2.type === NORMAL_COMPLETION) {
                lastNormalCompletions.push(c2);
              }
            }
          }
        }
      } else if (paths.length) {
        for (var _i22 = paths.length - 1; _i22 >= 0; _i22--) {
          var pathCompletions = _getCompletionRecords(paths[_i22], context);
          if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
            completions.push.apply(completions, _toConsumableArray2(pathCompletions));
            break;
          }
        }
      }
      return completions;
    }
    function _getCompletionRecords(path2, context) {
      var records = [];
      if (path2.isIfStatement()) {
        records = addCompletionRecords(path2.get("consequent"), records, context);
        records = addCompletionRecords(path2.get("alternate"), records, context);
      } else if (path2.isDoExpression() || path2.isFor() || path2.isWhile() || path2.isLabeledStatement()) {
        return addCompletionRecords(path2.get("body"), records, context);
      } else if (path2.isProgram() || path2.isBlockStatement()) {
        return getStatementListCompletion(path2.get("body"), context);
      } else if (path2.isFunction()) {
        return _getCompletionRecords(path2.get("body"), context);
      } else if (path2.isTryStatement()) {
        records = addCompletionRecords(path2.get("block"), records, context);
        records = addCompletionRecords(path2.get("handler"), records, context);
      } else if (path2.isCatchClause()) {
        return addCompletionRecords(path2.get("body"), records, context);
      } else if (path2.isSwitchStatement()) {
        return completionRecordForSwitch(path2.get("cases"), records, context);
      } else if (path2.isSwitchCase()) {
        return getStatementListCompletion(path2.get("consequent"), {
          canHaveBreak: true,
          shouldPopulateBreak: false,
          inCaseClause: true
        });
      } else if (path2.isBreakStatement()) {
        records.push(BreakCompletion(path2));
      } else {
        records.push(NormalCompletion(path2));
      }
      return records;
    }
    function getCompletionRecords() {
      var records = _getCompletionRecords(this, {
        canHaveBreak: false,
        shouldPopulateBreak: false,
        inCaseClause: false
      });
      return records.map(function(r2) {
        return r2.path;
      });
    }
    function getSibling(key2) {
      return NodePath.get({
        parentPath: this.parentPath,
        parent: this.parent,
        container: this.container,
        listKey: this.listKey,
        key: key2
      }).setContext(this.context);
    }
    function getPrevSibling() {
      return this.getSibling(this.key - 1);
    }
    function getNextSibling() {
      return this.getSibling(this.key + 1);
    }
    function getAllNextSiblings() {
      var _key = this.key;
      var sibling = this.getSibling(++_key);
      var siblings = [];
      while (sibling.node) {
        siblings.push(sibling);
        sibling = this.getSibling(++_key);
      }
      return siblings;
    }
    function getAllPrevSiblings() {
      var _key = this.key;
      var sibling = this.getSibling(--_key);
      var siblings = [];
      while (sibling.node) {
        siblings.push(sibling);
        sibling = this.getSibling(--_key);
      }
      return siblings;
    }
    function get$2(key2, context) {
      if (context === void 0) {
        context = true;
      }
      if (context === true)
        context = this.context;
      var parts = key2.split(".");
      if (parts.length === 1) {
        return this._getKey(key2, context);
      } else {
        return this._getPattern(parts, context);
      }
    }
    function _getKey(key2, context) {
      var _this = this;
      var node2 = this.node;
      var container2 = node2[key2];
      if (Array.isArray(container2)) {
        return container2.map(function(_, i2) {
          return NodePath.get({
            listKey: key2,
            parentPath: _this,
            parent: node2,
            container: container2,
            key: i2
          }).setContext(context);
        });
      } else {
        return NodePath.get({
          parentPath: this,
          parent: node2,
          container: node2,
          key: key2
        }).setContext(context);
      }
    }
    function _getPattern(parts, context) {
      var path2 = this;
      for (var _iterator2 = _createForOfIteratorHelperLoose(parts), _step2; !(_step2 = _iterator2()).done; ) {
        var part = _step2.value;
        if (part === ".") {
          path2 = path2.parentPath;
        } else {
          if (Array.isArray(path2)) {
            path2 = path2[part];
          } else {
            path2 = path2.get(part, context);
          }
        }
      }
      return path2;
    }
    function getBindingIdentifiers(duplicates) {
      return _getBindingIdentifiers(this.node, duplicates);
    }
    function getOuterBindingIdentifiers$1(duplicates) {
      return _getOuterBindingIdentifiers(this.node, duplicates);
    }
    function getBindingIdentifierPaths(duplicates, outerOnly) {
      if (duplicates === void 0) {
        duplicates = false;
      }
      if (outerOnly === void 0) {
        outerOnly = false;
      }
      var path2 = this;
      var search = [path2];
      var ids2 = /* @__PURE__ */ Object.create(null);
      while (search.length) {
        var id3 = search.shift();
        if (!id3)
          continue;
        if (!id3.node)
          continue;
        var keys2 = _getBindingIdentifiers.keys[id3.node.type];
        if (id3.isIdentifier()) {
          if (duplicates) {
            var _ids = ids2[id3.node.name] = ids2[id3.node.name] || [];
            _ids.push(id3);
          } else {
            ids2[id3.node.name] = id3;
          }
          continue;
        }
        if (id3.isExportDeclaration()) {
          var declaration = id3.get("declaration");
          if (isDeclaration(declaration)) {
            search.push(declaration);
          }
          continue;
        }
        if (outerOnly) {
          if (id3.isFunctionDeclaration()) {
            search.push(id3.get("id"));
            continue;
          }
          if (id3.isFunctionExpression()) {
            continue;
          }
        }
        if (keys2) {
          for (var i2 = 0; i2 < keys2.length; i2++) {
            var _key2 = keys2[i2];
            var child = id3.get(_key2);
            if (Array.isArray(child)) {
              search.push.apply(search, _toConsumableArray2(child));
            } else if (child.node) {
              search.push(child);
            }
          }
        }
      }
      return ids2;
    }
    function getOuterBindingIdentifierPaths(duplicates) {
      return this.getBindingIdentifierPaths(duplicates, true);
    }
    var NodePath_family = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      getOpposite,
      getCompletionRecords,
      getSibling,
      getPrevSibling,
      getNextSibling,
      getAllNextSiblings,
      getAllPrevSiblings,
      get: get$2,
      _getKey,
      _getPattern,
      getBindingIdentifiers,
      getOuterBindingIdentifiers: getOuterBindingIdentifiers$1,
      getBindingIdentifierPaths,
      getOuterBindingIdentifierPaths
    });
    var _addComment = addComment$2, _addComments = addComments$1;
    function shareCommentsWithSiblings() {
      if (typeof this.key === "string")
        return;
      var node2 = this.node;
      if (!node2)
        return;
      var trailing = node2.trailingComments;
      var leading = node2.leadingComments;
      if (!trailing && !leading)
        return;
      var prev = this.getSibling(this.key - 1);
      var next = this.getSibling(this.key + 1);
      var hasPrev = Boolean(prev.node);
      var hasNext = Boolean(next.node);
      if (hasPrev && !hasNext) {
        prev.addComments("trailing", trailing);
      } else if (hasNext && !hasPrev) {
        next.addComments("leading", leading);
      }
    }
    function addComment$1(type5, content, line) {
      _addComment(this.node, type5, content, line);
    }
    function addComments(type5, comments) {
      _addComments(this.node, type5, comments);
    }
    var NodePath_comments = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      shareCommentsWithSiblings,
      addComment: addComment$1,
      addComments
    });
    var validate$1 = validate$6;
    var _debug = buildDebug("babel");
    var REMOVED = 1 << 0;
    var SHOULD_STOP = 1 << 1;
    var SHOULD_SKIP = 1 << 2;
    var NodePath = function() {
      function NodePath2(hub, parent) {
        this.contexts = [];
        this.state = null;
        this.opts = null;
        this._traverseFlags = 0;
        this.skipKeys = null;
        this.parentPath = null;
        this.container = null;
        this.listKey = null;
        this.key = null;
        this.node = null;
        this.type = null;
        this.parent = parent;
        this.hub = hub;
        this.data = null;
        this.context = null;
        this.scope = null;
      }
      NodePath2.get = function get3(_ref3) {
        var hub = _ref3.hub, parentPath = _ref3.parentPath, parent = _ref3.parent, container2 = _ref3.container, listKey = _ref3.listKey, key2 = _ref3.key;
        if (!hub && parentPath) {
          hub = parentPath.hub;
        }
        if (!parent) {
          throw new Error("To get a node path the parent needs to exist");
        }
        var targetNode = container2[key2];
        var paths = path$2.get(parent);
        if (!paths) {
          paths = /* @__PURE__ */ new Map();
          path$2.set(parent, paths);
        }
        var path2 = paths.get(targetNode);
        if (!path2) {
          path2 = new NodePath2(hub, parent);
          if (targetNode)
            paths.set(targetNode, path2);
        }
        path2.setup(parentPath, container2, listKey, key2);
        return path2;
      };
      var _proto = NodePath2.prototype;
      _proto.getScope = function getScope(scope2) {
        return this.isScope() ? new Scope$1(this) : scope2;
      };
      _proto.setData = function setData(key2, val) {
        if (this.data == null) {
          this.data = /* @__PURE__ */ Object.create(null);
        }
        return this.data[key2] = val;
      };
      _proto.getData = function getData(key2, def) {
        if (this.data == null) {
          this.data = /* @__PURE__ */ Object.create(null);
        }
        var val = this.data[key2];
        if (val === void 0 && def !== void 0)
          val = this.data[key2] = def;
        return val;
      };
      _proto.hasNode = function hasNode() {
        return this.node != null;
      };
      _proto.buildCodeFrameError = function buildCodeFrameError(msg2, Error2) {
        if (Error2 === void 0) {
          Error2 = SyntaxError;
        }
        return this.hub.buildError(this.node, msg2, Error2);
      };
      _proto.traverse = function traverse$12(visitor2, state) {
        traverse(this.node, visitor2, this.scope, state, this);
      };
      _proto.set = function set3(key2, node2) {
        validate$1(this.node, key2, node2);
        this.node[key2] = node2;
      };
      _proto.getPathLocation = function getPathLocation() {
        var parts = [];
        var path2 = this;
        do {
          var key2 = path2.key;
          if (path2.inList)
            key2 = path2.listKey + "[" + key2 + "]";
          parts.unshift(key2);
        } while (path2 = path2.parentPath);
        return parts.join(".");
      };
      _proto.debug = function debug2(message) {
        if (!_debug.enabled)
          return;
        _debug(this.getPathLocation() + " " + this.type + ": " + message);
      };
      _proto.toString = function toString3() {
        return generate$12(this.node).code;
      };
      _createClass2(NodePath2, [{
        key: "inList",
        get: function get3() {
          return !!this.listKey;
        },
        set: function set3(inList) {
          if (!inList) {
            this.listKey = null;
          }
        }
      }, {
        key: "parentKey",
        get: function get3() {
          return this.listKey || this.key;
        }
      }, {
        key: "shouldSkip",
        get: function get3() {
          return !!(this._traverseFlags & SHOULD_SKIP);
        },
        set: function set3(v22) {
          if (v22) {
            this._traverseFlags |= SHOULD_SKIP;
          } else {
            this._traverseFlags &= ~SHOULD_SKIP;
          }
        }
      }, {
        key: "shouldStop",
        get: function get3() {
          return !!(this._traverseFlags & SHOULD_STOP);
        },
        set: function set3(v22) {
          if (v22) {
            this._traverseFlags |= SHOULD_STOP;
          } else {
            this._traverseFlags &= ~SHOULD_STOP;
          }
        }
      }, {
        key: "removed",
        get: function get3() {
          return !!(this._traverseFlags & REMOVED);
        },
        set: function set3(v22) {
          if (v22) {
            this._traverseFlags |= REMOVED;
          } else {
            this._traverseFlags &= ~REMOVED;
          }
        }
      }]);
      return NodePath2;
    }();
    Object.assign(NodePath.prototype, NodePath_ancestry, NodePath_inference, NodePath_replacement, NodePath_evaluation, NodePath_conversion, NodePath_introspection, NodePath_context, NodePath_removal, NodePath_modification, NodePath_family, NodePath_comments);
    var _loop2 = function _loop22() {
      var type5 = _step.value;
      var typeKey = "is" + type5;
      var fn = t$a[typeKey];
      NodePath.prototype[typeKey] = function(opts) {
        return fn(this.node, opts);
      };
      NodePath.prototype["assert" + type5] = function(opts) {
        if (!fn(this.node, opts)) {
          throw new TypeError("Expected node path of type " + type5);
        }
      };
    };
    for (var _iterator = _createForOfIteratorHelperLoose(TYPES$1), _step; !(_step = _iterator()).done; ) {
      _loop2();
    }
    var _loop = function _loop3() {
      var type5 = _Object$keys$1[_i$1];
      if (type5[0] === "_")
        return "continue";
      if (TYPES$1.indexOf(type5) < 0)
        TYPES$1.push(type5);
      var virtualType = virtualTypes[type5];
      NodePath.prototype["is" + type5] = function(opts) {
        return virtualType.checkPath(this, opts);
      };
    };
    for (var _i$1 = 0, _Object$keys$1 = Object.keys(virtualTypes); _i$1 < _Object$keys$1.length; _i$1++) {
      var _ret = _loop();
      if (_ret === "continue")
        continue;
    }
    var VISITOR_KEYS$2 = VISITOR_KEYS$7;
    var TraversalContext = function() {
      function TraversalContext2(scope2, opts, state, parentPath) {
        this.queue = null;
        this.priorityQueue = null;
        this.parentPath = parentPath;
        this.scope = scope2;
        this.state = state;
        this.opts = opts;
      }
      var _proto = TraversalContext2.prototype;
      _proto.shouldVisit = function shouldVisit(node2) {
        var opts = this.opts;
        if (opts.enter || opts.exit)
          return true;
        if (opts[node2.type])
          return true;
        var keys2 = VISITOR_KEYS$2[node2.type];
        if (!(keys2 != null && keys2.length))
          return false;
        for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
          var key2 = _step2.value;
          if (node2[key2])
            return true;
        }
        return false;
      };
      _proto.create = function create2(node2, obj, key2, listKey) {
        return NodePath.get({
          parentPath: this.parentPath,
          parent: node2,
          container: obj,
          key: key2,
          listKey
        });
      };
      _proto.maybeQueue = function maybeQueue(path2, notPriority) {
        if (this.queue) {
          if (notPriority) {
            this.queue.push(path2);
          } else {
            this.priorityQueue.push(path2);
          }
        }
      };
      _proto.visitMultiple = function visitMultiple(container2, parent, listKey) {
        if (container2.length === 0)
          return false;
        var queue2 = [];
        for (var key2 = 0; key2 < container2.length; key2++) {
          var node2 = container2[key2];
          if (node2 && this.shouldVisit(node2)) {
            queue2.push(this.create(parent, container2, key2, listKey));
          }
        }
        return this.visitQueue(queue2);
      };
      _proto.visitSingle = function visitSingle(node2, key2) {
        if (this.shouldVisit(node2[key2])) {
          return this.visitQueue([this.create(node2, node2, key2)]);
        } else {
          return false;
        }
      };
      _proto.visitQueue = function visitQueue(queue2) {
        this.queue = queue2;
        this.priorityQueue = [];
        var visited = /* @__PURE__ */ new WeakSet();
        var stop3 = false;
        for (var _iterator2 = _createForOfIteratorHelperLoose(queue2), _step2; !(_step2 = _iterator2()).done; ) {
          var path2 = _step2.value;
          path2.resync();
          if (path2.contexts.length === 0 || path2.contexts[path2.contexts.length - 1] !== this) {
            path2.pushContext(this);
          }
          if (path2.key === null)
            continue;
          var node2 = path2.node;
          if (visited.has(node2))
            continue;
          if (node2)
            visited.add(node2);
          if (path2.visit()) {
            stop3 = true;
            break;
          }
          if (this.priorityQueue.length) {
            stop3 = this.visitQueue(this.priorityQueue);
            this.priorityQueue = [];
            this.queue = queue2;
            if (stop3)
              break;
          }
        }
        for (var _iterator3 = _createForOfIteratorHelperLoose(queue2), _step3; !(_step3 = _iterator3()).done; ) {
          var _path = _step3.value;
          _path.popContext();
        }
        this.queue = null;
        return stop3;
      };
      _proto.visit = function visit2(node2, key2) {
        var nodes2 = node2[key2];
        if (!nodes2)
          return false;
        if (Array.isArray(nodes2)) {
          return this.visitMultiple(nodes2, node2, key2);
        } else {
          return this.visitSingle(node2, key2);
        }
      };
      return _createClass2(TraversalContext2);
    }();
    var VISITOR_KEYS$1 = VISITOR_KEYS$7;
    function traverseNode(node2, opts, scope2, state, path2, skipKeys) {
      var keys2 = VISITOR_KEYS$1[node2.type];
      if (!keys2)
        return false;
      var context = new TraversalContext(scope2, opts, state, path2);
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        if (skipKeys && skipKeys[key2])
          continue;
        if (context.visit(node2, key2)) {
          return true;
        }
      }
      return false;
    }
    (function() {
      function Hub() {
      }
      var _proto = Hub.prototype;
      _proto.getCode = function getCode() {
      };
      _proto.getScope = function getScope() {
      };
      _proto.addHelper = function addHelper() {
        throw new Error("Helpers are not supported by the default hub.");
      };
      _proto.buildError = function buildError(node2, msg2, Error2) {
        if (Error2 === void 0) {
          Error2 = TypeError;
        }
        return new Error2(msg2);
      };
      return _createClass2(Hub);
    })();
    var VISITOR_KEYS = VISITOR_KEYS$7, removeProperties = removeProperties$1, traverseFast$1 = traverseFast$2;
    function traverse(parent, opts, scope2, state, parentPath) {
      if (opts === void 0) {
        opts = {};
      }
      if (!parent)
        return;
      if (!opts.noScope && !scope2) {
        if (parent.type !== "Program" && parent.type !== "File") {
          throw new Error("You must pass a scope and parentPath unless traversing a Program/File. " + ("Instead of that you tried to traverse a " + parent.type + " node without ") + "passing scope and parentPath.");
        }
      }
      if (!VISITOR_KEYS[parent.type]) {
        return;
      }
      explode$1(opts);
      traverseNode(parent, opts, scope2, state, parentPath);
    }
    traverse.visitors = visitors;
    traverse.verify = verify;
    traverse.explode = explode$1;
    traverse.cheap = function(node2, enter) {
      return traverseFast$1(node2, enter);
    };
    traverse.node = function(node2, opts, scope2, state, path2, skipKeys) {
      traverseNode(node2, opts, scope2, state, path2, skipKeys);
    };
    traverse.clearNode = function(node2, opts) {
      removeProperties(node2, opts);
      path$2["delete"](node2);
    };
    traverse.removeProperties = function(tree, opts) {
      traverseFast$1(tree, traverse.clearNode, opts);
      return tree;
    };
    function hasDenylistedType(path2, state) {
      if (path2.node.type === state.type) {
        state.has = true;
        path2.stop();
      }
    }
    traverse.hasType = function(tree, type5, denylistTypes) {
      if (denylistTypes != null && denylistTypes.includes(tree.type))
        return false;
      if (tree.type === type5)
        return true;
      var state = {
        has: false,
        type: type5
      };
      traverse(tree, {
        noScope: true,
        denylist: denylistTypes,
        enter: hasDenylistedType
      }, null, state);
      return state.has;
    };
    traverse.cache = cache$1;
    function helper$3(minVersion2, source) {
      return Object.freeze({
        minVersion: minVersion2,
        ast: function ast3() {
          return template$2.program.ast(source);
        }
      });
    }
    var generated = Object.freeze({
      applyDecs: helper$3("7.17.8", 'function createMetadataMethodsForProperty(metadataMap,kind,property,decoratorFinishedRef){return{getMetadata:function(key){assertNotFinished(decoratorFinishedRef,"getMetadata"),assertMetadataKey(key);var metadataForKey=metadataMap[key];if(void 0!==metadataForKey)if(1===kind){var pub=metadataForKey.public;if(void 0!==pub)return pub[property]}else if(2===kind){var priv=metadataForKey.private;if(void 0!==priv)return priv.get(property)}else if(Object.hasOwnProperty.call(metadataForKey,"constructor"))return metadataForKey.constructor},setMetadata:function(key,value){assertNotFinished(decoratorFinishedRef,"setMetadata"),assertMetadataKey(key);var metadataForKey=metadataMap[key];if(void 0===metadataForKey&&(metadataForKey=metadataMap[key]={}),1===kind){var pub=metadataForKey.public;void 0===pub&&(pub=metadataForKey.public={}),pub[property]=value}else if(2===kind){var priv=metadataForKey.priv;void 0===priv&&(priv=metadataForKey.private=new Map),priv.set(property,value)}else metadataForKey.constructor=value}}}function convertMetadataMapToFinal(obj,metadataMap){var parentMetadataMap=obj[Symbol.metadata||Symbol.for("Symbol.metadata")],metadataKeys=Object.getOwnPropertySymbols(metadataMap);if(0!==metadataKeys.length){for(var i=0;i<metadataKeys.length;i++){var key=metadataKeys[i],metaForKey=metadataMap[key],parentMetaForKey=parentMetadataMap?parentMetadataMap[key]:null,pub=metaForKey.public,parentPub=parentMetaForKey?parentMetaForKey.public:null;pub&&parentPub&&Object.setPrototypeOf(pub,parentPub);var priv=metaForKey.private;if(priv){var privArr=Array.from(priv.values()),parentPriv=parentMetaForKey?parentMetaForKey.private:null;parentPriv&&(privArr=privArr.concat(parentPriv)),metaForKey.private=privArr}parentMetaForKey&&Object.setPrototypeOf(metaForKey,parentMetaForKey)}parentMetadataMap&&Object.setPrototypeOf(metadataMap,parentMetadataMap),obj[Symbol.metadata||Symbol.for("Symbol.metadata")]=metadataMap}}function createAddInitializerMethod(initializers,decoratorFinishedRef){return function(initializer){assertNotFinished(decoratorFinishedRef,"addInitializer"),assertCallable(initializer,"An initializer"),initializers.push(initializer)}}function memberDec(dec,name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value){var kindStr;switch(kind){case 1:kindStr="accessor";break;case 2:kindStr="method";break;case 3:kindStr="getter";break;case 4:kindStr="setter";break;default:kindStr="field"}var metadataKind,metadataName,ctx={kind:kindStr,name:isPrivate?"#"+name:name,isStatic:isStatic,isPrivate:isPrivate},decoratorFinishedRef={v:!1};if(0!==kind&&(ctx.addInitializer=createAddInitializerMethod(initializers,decoratorFinishedRef)),isPrivate){metadataKind=2,metadataName=Symbol(name);var access={};0===kind?(access.get=desc.get,access.set=desc.set):2===kind?access.get=function(){return desc.value}:(1!==kind&&3!==kind||(access.get=function(){return desc.get.call(this)}),1!==kind&&4!==kind||(access.set=function(v){desc.set.call(this,v)})),ctx.access=access}else metadataKind=1,metadataName=name;try{return dec(value,Object.assign(ctx,createMetadataMethodsForProperty(metadataMap,metadataKind,metadataName,decoratorFinishedRef)))}finally{decoratorFinishedRef.v=!0}}function assertNotFinished(decoratorFinishedRef,fnName){if(decoratorFinishedRef.v)throw new Error("attempted to call "+fnName+" after decoration was finished")}function assertMetadataKey(key){if("symbol"!=typeof key)throw new TypeError("Metadata keys must be symbols, received: "+key)}function assertCallable(fn,hint){if("function"!=typeof fn)throw new TypeError(hint+" must be a function")}function assertValidReturnValue(kind,value){var type=typeof value;if(1===kind){if("object"!==type||null===value)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==value.get&&assertCallable(value.get,"accessor.get"),void 0!==value.set&&assertCallable(value.set,"accessor.set"),void 0!==value.init&&assertCallable(value.init,"accessor.init"),void 0!==value.initializer&&assertCallable(value.initializer,"accessor.initializer")}else if("function"!==type){var hint;throw hint=0===kind?"field":10===kind?"class":"method",new TypeError(hint+" decorators must return a function or void 0")}}function getInit(desc){var initializer;return null==(initializer=desc.init)&&(initializer=desc.initializer)&&"undefined"!=typeof console&&console.warn(".initializer has been renamed to .init as of March 2022"),initializer}function applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers){var desc,initializer,value,newValue,get,set,decs=decInfo[0];if(isPrivate?desc=0===kind||1===kind?{get:decInfo[3],set:decInfo[4]}:3===kind?{get:decInfo[3]}:4===kind?{set:decInfo[3]}:{value:decInfo[3]}:0!==kind&&(desc=Object.getOwnPropertyDescriptor(base,name)),1===kind?value={get:desc.get,set:desc.set}:2===kind?value=desc.value:3===kind?value=desc.get:4===kind&&(value=desc.set),"function"==typeof decs)void 0!==(newValue=memberDec(decs,name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value))&&(assertValidReturnValue(kind,newValue),0===kind?initializer=newValue:1===kind?(initializer=getInit(newValue),get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue);else for(var i=decs.length-1;i>=0;i--){var newInit;if(void 0!==(newValue=memberDec(decs[i],name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value)))assertValidReturnValue(kind,newValue),0===kind?newInit=newValue:1===kind?(newInit=getInit(newValue),get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue,void 0!==newInit&&(void 0===initializer?initializer=newInit:"function"==typeof initializer?initializer=[initializer,newInit]:initializer.push(newInit))}if(0===kind||1===kind){if(void 0===initializer)initializer=function(instance,init){return init};else if("function"!=typeof initializer){var ownInitializers=initializer;initializer=function(instance,init){for(var value=init,i=0;i<ownInitializers.length;i++)value=ownInitializers[i].call(instance,value);return value}}else{var originalInitializer=initializer;initializer=function(instance,init){return originalInitializer.call(instance,init)}}ret.push(initializer)}0!==kind&&(1===kind?(desc.get=value.get,desc.set=value.set):2===kind?desc.value=value:3===kind?desc.get=value:4===kind&&(desc.set=value),isPrivate?1===kind?(ret.push((function(instance,args){return value.get.call(instance,args)})),ret.push((function(instance,args){return value.set.call(instance,args)}))):2===kind?ret.push(value):ret.push((function(instance,args){return value.call(instance,args)})):Object.defineProperty(base,name,desc))}function applyMemberDecs(ret,Class,protoMetadataMap,staticMetadataMap,decInfos){for(var protoInitializers,staticInitializers,existingProtoNonFields=new Map,existingStaticNonFields=new Map,i=0;i<decInfos.length;i++){var decInfo=decInfos[i];if(Array.isArray(decInfo)){var base,metadataMap,initializers,kind=decInfo[1],name=decInfo[2],isPrivate=decInfo.length>3,isStatic=kind>=5;if(isStatic?(base=Class,metadataMap=staticMetadataMap,0!==(kind-=5)&&(initializers=staticInitializers=staticInitializers||[])):(base=Class.prototype,metadataMap=protoMetadataMap,0!==kind&&(initializers=protoInitializers=protoInitializers||[])),0!==kind&&!isPrivate){var existingNonFields=isStatic?existingStaticNonFields:existingProtoNonFields,existingKind=existingNonFields.get(name)||0;if(!0===existingKind||3===existingKind&&4!==kind||4===existingKind&&3!==kind)throw new Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+name);!existingKind&&kind>2?existingNonFields.set(name,kind):existingNonFields.set(name,!0)}applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers)}}pushInitializers(ret,protoInitializers),pushInitializers(ret,staticInitializers)}function pushInitializers(ret,initializers){initializers&&ret.push((function(instance){for(var i=0;i<initializers.length;i++)initializers[i].call(instance);return instance}))}function applyClassDecs(ret,targetClass,metadataMap,classDecs){if(classDecs.length>0){for(var initializers=[],newClass=targetClass,name=targetClass.name,i=classDecs.length-1;i>=0;i--){var decoratorFinishedRef={v:!1};try{var ctx=Object.assign({kind:"class",name:name,addInitializer:createAddInitializerMethod(initializers,decoratorFinishedRef)},createMetadataMethodsForProperty(metadataMap,0,name,decoratorFinishedRef)),nextNewClass=classDecs[i](newClass,ctx)}finally{decoratorFinishedRef.v=!0}void 0!==nextNewClass&&(assertValidReturnValue(10,nextNewClass),newClass=nextNewClass)}ret.push(newClass,(function(){for(var i=0;i<initializers.length;i++)initializers[i].call(newClass)}))}}export default function applyDecs(targetClass,memberDecs,classDecs){var ret=[],staticMetadataMap={},protoMetadataMap={};return applyMemberDecs(ret,targetClass,protoMetadataMap,staticMetadataMap,memberDecs),convertMetadataMapToFinal(targetClass.prototype,protoMetadataMap),applyClassDecs(ret,targetClass,staticMetadataMap,classDecs),convertMetadataMapToFinal(targetClass,staticMetadataMap),ret}'),
      asyncIterator: helper$3("7.15.9", 'export default function _asyncIterator(iterable){var method,async,sync,retry=2;for("undefined"!=typeof Symbol&&(async=Symbol.asyncIterator,sync=Symbol.iterator);retry--;){if(async&&null!=(method=iterable[async]))return method.call(iterable);if(sync&&null!=(method=iterable[sync]))return new AsyncFromSyncIterator(method.call(iterable));async="@@asyncIterator",sync="@@iterator"}throw new TypeError("Object is not async iterable")}function AsyncFromSyncIterator(s){function AsyncFromSyncIteratorContinuation(r){if(Object(r)!==r)return Promise.reject(new TypeError(r+" is not an object."));var done=r.done;return Promise.resolve(r.value).then((function(value){return{value:value,done:done}}))}return AsyncFromSyncIterator=function(s){this.s=s,this.n=s.next},AsyncFromSyncIterator.prototype={s:null,n:null,next:function(){return AsyncFromSyncIteratorContinuation(this.n.apply(this.s,arguments))},return:function(value){var ret=this.s.return;return void 0===ret?Promise.resolve({value:value,done:!0}):AsyncFromSyncIteratorContinuation(ret.apply(this.s,arguments))},throw:function(value){var thr=this.s.return;return void 0===thr?Promise.reject(value):AsyncFromSyncIteratorContinuation(thr.apply(this.s,arguments))}},new AsyncFromSyncIterator(s)}'),
      jsx: helper$3("7.0.0-beta.0", 'var REACT_ELEMENT_TYPE;export default function _createRawReactElement(type,props,key,children){REACT_ELEMENT_TYPE||(REACT_ELEMENT_TYPE="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103);var defaultProps=type&&type.defaultProps,childrenLength=arguments.length-3;if(props||0===childrenLength||(props={children:void 0}),1===childrenLength)props.children=children;else if(childrenLength>1){for(var childArray=new Array(childrenLength),i=0;i<childrenLength;i++)childArray[i]=arguments[i+3];props.children=childArray}if(props&&defaultProps)for(var propName in defaultProps)void 0===props[propName]&&(props[propName]=defaultProps[propName]);else props||(props=defaultProps||{});return{$$typeof:REACT_ELEMENT_TYPE,type:type,key:void 0===key?null:""+key,ref:null,props:props,_owner:null}}'),
      objectSpread2: helper$3("7.5.0", 'import defineProperty from"defineProperty";function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}export default function _objectSpread2(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}'),
      "typeof": helper$3("7.0.0-beta.0", 'export default function _typeof(obj){"@babel/helpers - typeof";return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj},_typeof(obj)}'),
      wrapRegExp: helper$3("7.2.6", 'import setPrototypeOf from"setPrototypeOf";import inherits from"inherits";export default function _wrapRegExp(){_wrapRegExp=function(re,groups){return new BabelRegExp(re,void 0,groups)};var _super=RegExp.prototype,_groups=new WeakMap;function BabelRegExp(re,flags,groups){var _this=new RegExp(re,flags);return _groups.set(_this,groups||_groups.get(re)),setPrototypeOf(_this,BabelRegExp.prototype)}function buildGroups(result,re){var g=_groups.get(re);return Object.keys(g).reduce((function(groups,name){return groups[name]=result[g[name]],groups}),Object.create(null))}return inherits(BabelRegExp,RegExp),BabelRegExp.prototype.exec=function(str){var result=_super.exec.call(this,str);return result&&(result.groups=buildGroups(result,this)),result},BabelRegExp.prototype[Symbol.replace]=function(str,substitution){if("string"==typeof substitution){var groups=_groups.get(this);return _super[Symbol.replace].call(this,str,substitution.replace(/\\$<([^>]+)>/g,(function(_,name){return"$"+groups[name]})))}if("function"==typeof substitution){var _this=this;return _super[Symbol.replace].call(this,str,(function(){var args=arguments;return"object"!=typeof args[args.length-1]&&(args=[].slice.call(args)).push(buildGroups(args,_this)),substitution.apply(this,args)}))}return _super[Symbol.replace].call(this,str,substitution)},_wrapRegExp.apply(this,arguments)}')
    });
    var _templateObject$o, _templateObject2$b, _templateObject3$a, _templateObject4$6, _templateObject5$4, _templateObject6$4, _templateObject7$3, _templateObject8$2, _templateObject9$2, _templateObject10$2, _templateObject11$2, _templateObject12$2, _templateObject13$2, _templateObject14$1, _templateObject15$1, _templateObject16$1, _templateObject17$1, _templateObject18$1, _templateObject19$1, _templateObject20, _templateObject21, _templateObject22, _templateObject23, _templateObject24, _templateObject25, _templateObject26, _templateObject27, _templateObject28, _templateObject29, _templateObject30, _templateObject31, _templateObject32, _templateObject33, _templateObject34, _templateObject35, _templateObject36, _templateObject37, _templateObject38, _templateObject39, _templateObject40, _templateObject41, _templateObject42, _templateObject43, _templateObject44, _templateObject45, _templateObject46, _templateObject47, _templateObject48, _templateObject49, _templateObject50, _templateObject51, _templateObject52, _templateObject53, _templateObject54, _templateObject55, _templateObject56, _templateObject57, _templateObject58, _templateObject59, _templateObject60, _templateObject61, _templateObject62, _templateObject63, _templateObject64, _templateObject65, _templateObject66, _templateObject67, _templateObject68, _templateObject69, _templateObject70, _templateObject71, _templateObject72, _templateObject73, _templateObject74, _templateObject75, _templateObject76, _templateObject77, _templateObject78, _templateObject79, _templateObject80, _templateObject81, _templateObject82, _templateObject83, _templateObject84, _templateObject85, _templateObject86, _templateObject87;
    var helpers$1 = Object.assign({
      __proto__: null
    }, generated);
    var helper$2 = function helper2(minVersion2) {
      return function(tpl) {
        return {
          minVersion: minVersion2,
          ast: function ast3() {
            return template$2.program.ast(tpl);
          }
        };
      };
    };
    helpers$1.AwaitValue = helper$2("7.0.0-beta.0")(_templateObject$o || (_templateObject$o = _taggedTemplateLiteralLoose(["\n  export default function _AwaitValue(value) {\n    this.wrapped = value;\n  }\n"])));
    helpers$1.AsyncGenerator = helper$2("7.0.0-beta.0")(_templateObject2$b || (_templateObject2$b = _taggedTemplateLiteralLoose(['\n  import AwaitValue from "AwaitValue";\n\n  export default function AsyncGenerator(gen) {\n    var front, back;\n\n    function send(key, arg) {\n      return new Promise(function (resolve, reject) {\n        var request = {\n          key: key,\n          arg: arg,\n          resolve: resolve,\n          reject: reject,\n          next: null,\n        };\n\n        if (back) {\n          back = back.next = request;\n        } else {\n          front = back = request;\n          resume(key, arg);\n        }\n      });\n    }\n\n    function resume(key, arg) {\n      try {\n        var result = gen[key](arg)\n        var value = result.value;\n        var wrappedAwait = value instanceof AwaitValue;\n\n        Promise.resolve(wrappedAwait ? value.wrapped : value).then(\n          function (arg) {\n            if (wrappedAwait) {\n              resume(key === "return" ? "return" : "next", arg);\n              return\n            }\n\n            settle(result.done ? "return" : "normal", arg);\n          },\n          function (err) { resume("throw", err); });\n      } catch (err) {\n        settle("throw", err);\n      }\n    }\n\n    function settle(type, value) {\n      switch (type) {\n        case "return":\n          front.resolve({ value: value, done: true });\n          break;\n        case "throw":\n          front.reject(value);\n          break;\n        default:\n          front.resolve({ value: value, done: false });\n          break;\n      }\n\n      front = front.next;\n      if (front) {\n        resume(front.key, front.arg);\n      } else {\n        back = null;\n      }\n    }\n\n    this._invoke = send;\n\n    // Hide "return" method if generator return is not supported\n    if (typeof gen.return !== "function") {\n      this.return = undefined;\n    }\n  }\n\n  AsyncGenerator.prototype[typeof Symbol === "function" && Symbol.asyncIterator || "@@asyncIterator"] = function () { return this; };\n\n  AsyncGenerator.prototype.next = function (arg) { return this._invoke("next", arg); };\n  AsyncGenerator.prototype.throw = function (arg) { return this._invoke("throw", arg); };\n  AsyncGenerator.prototype.return = function (arg) { return this._invoke("return", arg); };\n'])));
    helpers$1.wrapAsyncGenerator = helper$2("7.0.0-beta.0")(_templateObject3$a || (_templateObject3$a = _taggedTemplateLiteralLoose(['\n  import AsyncGenerator from "AsyncGenerator";\n\n  export default function _wrapAsyncGenerator(fn) {\n    return function () {\n      return new AsyncGenerator(fn.apply(this, arguments));\n    };\n  }\n'])));
    helpers$1.awaitAsyncGenerator = helper$2("7.0.0-beta.0")(_templateObject4$6 || (_templateObject4$6 = _taggedTemplateLiteralLoose(['\n  import AwaitValue from "AwaitValue";\n\n  export default function _awaitAsyncGenerator(value) {\n    return new AwaitValue(value);\n  }\n'])));
    helpers$1.asyncGeneratorDelegate = helper$2("7.0.0-beta.0")(_templateObject5$4 || (_templateObject5$4 = _taggedTemplateLiteralLoose(['\n  export default function _asyncGeneratorDelegate(inner, awaitWrap) {\n    var iter = {}, waiting = false;\n\n    function pump(key, value) {\n      waiting = true;\n      value = new Promise(function (resolve) { resolve(inner[key](value)); });\n      return { done: false, value: awaitWrap(value) };\n    };\n\n    iter[typeof Symbol !== "undefined" && Symbol.iterator || "@@iterator"] = function () { return this; };\n\n    iter.next = function (value) {\n      if (waiting) {\n        waiting = false;\n        return value;\n      }\n      return pump("next", value);\n    };\n\n    if (typeof inner.throw === "function") {\n      iter.throw = function (value) {\n        if (waiting) {\n          waiting = false;\n          throw value;\n        }\n        return pump("throw", value);\n      };\n    }\n\n    if (typeof inner.return === "function") {\n      iter.return = function (value) {\n        if (waiting) {\n          waiting = false;\n          return value;\n        }\n        return pump("return", value);\n      };\n    }\n\n    return iter;\n  }\n'])));
    helpers$1.asyncToGenerator = helper$2("7.0.0-beta.0")(_templateObject6$4 || (_templateObject6$4 = _taggedTemplateLiteralLoose(['\n  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {\n    try {\n      var info = gen[key](arg);\n      var value = info.value;\n    } catch (error) {\n      reject(error);\n      return;\n    }\n\n    if (info.done) {\n      resolve(value);\n    } else {\n      Promise.resolve(value).then(_next, _throw);\n    }\n  }\n\n  export default function _asyncToGenerator(fn) {\n    return function () {\n      var self = this, args = arguments;\n      return new Promise(function (resolve, reject) {\n        var gen = fn.apply(self, args);\n        function _next(value) {\n          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);\n        }\n        function _throw(err) {\n          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);\n        }\n\n        _next(undefined);\n      });\n    };\n  }\n'])));
    helpers$1.classCallCheck = helper$2("7.0.0-beta.0")(_templateObject7$3 || (_templateObject7$3 = _taggedTemplateLiteralLoose(['\n  export default function _classCallCheck(instance, Constructor) {\n    if (!(instance instanceof Constructor)) {\n      throw new TypeError("Cannot call a class as a function");\n    }\n  }\n'])));
    helpers$1.createClass = helper$2("7.0.0-beta.0")(_templateObject8$2 || (_templateObject8$2 = _taggedTemplateLiteralLoose(['\n  function _defineProperties(target, props) {\n    for (var i = 0; i < props.length; i ++) {\n      var descriptor = props[i];\n      descriptor.enumerable = descriptor.enumerable || false;\n      descriptor.configurable = true;\n      if ("value" in descriptor) descriptor.writable = true;\n      Object.defineProperty(target, descriptor.key, descriptor);\n    }\n  }\n\n  export default function _createClass(Constructor, protoProps, staticProps) {\n    if (protoProps) _defineProperties(Constructor.prototype, protoProps);\n    if (staticProps) _defineProperties(Constructor, staticProps);\n    Object.defineProperty(Constructor, "prototype", { writable: false });\n    return Constructor;\n  }\n'])));
    helpers$1.defineEnumerableProperties = helper$2("7.0.0-beta.0")(_templateObject9$2 || (_templateObject9$2 = _taggedTemplateLiteralLoose([`
  export default function _defineEnumerableProperties(obj, descs) {
    for (var key in descs) {
      var desc = descs[key];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, key, desc);
    }

    // Symbols are not enumerated over by for-in loops. If native
    // Symbols are available, fetch all of the descs object's own
    // symbol properties and define them on our target object too.
    if (Object.getOwnPropertySymbols) {
      var objectSymbols = Object.getOwnPropertySymbols(descs);
      for (var i = 0; i < objectSymbols.length; i++) {
        var sym = objectSymbols[i];
        var desc = descs[sym];
        desc.configurable = desc.enumerable = true;
        if ("value" in desc) desc.writable = true;
        Object.defineProperty(obj, sym, desc);
      }
    }
    return obj;
  }
`])));
    helpers$1.defaults = helper$2("7.0.0-beta.0")(_templateObject10$2 || (_templateObject10$2 = _taggedTemplateLiteralLoose(["\n  export default function _defaults(obj, defaults) {\n    var keys = Object.getOwnPropertyNames(defaults);\n    for (var i = 0; i < keys.length; i++) {\n      var key = keys[i];\n      var value = Object.getOwnPropertyDescriptor(defaults, key);\n      if (value && value.configurable && obj[key] === undefined) {\n        Object.defineProperty(obj, key, value);\n      }\n    }\n    return obj;\n  }\n"])));
    helpers$1.defineProperty = helper$2("7.0.0-beta.0")(_templateObject11$2 || (_templateObject11$2 = _taggedTemplateLiteralLoose(["\n  export default function _defineProperty(obj, key, value) {\n    // Shortcircuit the slow defineProperty path when possible.\n    // We are trying to avoid issues where setters defined on the\n    // prototype cause side effects under the fast path of simple\n    // assignment. By checking for existence of the property with\n    // the in operator, we can optimize most of this overhead away.\n    if (key in obj) {\n      Object.defineProperty(obj, key, {\n        value: value,\n        enumerable: true,\n        configurable: true,\n        writable: true\n      });\n    } else {\n      obj[key] = value;\n    }\n    return obj;\n  }\n"])));
    helpers$1["extends"] = helper$2("7.0.0-beta.0")(_templateObject12$2 || (_templateObject12$2 = _taggedTemplateLiteralLoose(["\n  export default function _extends() {\n    _extends = Object.assign || function (target) {\n      for (var i = 1; i < arguments.length; i++) {\n        var source = arguments[i];\n        for (var key in source) {\n          if (Object.prototype.hasOwnProperty.call(source, key)) {\n            target[key] = source[key];\n          }\n        }\n      }\n      return target;\n    };\n\n    return _extends.apply(this, arguments);\n  }\n"])));
    helpers$1.objectSpread = helper$2("7.0.0-beta.0")(_templateObject13$2 || (_templateObject13$2 = _taggedTemplateLiteralLoose([`
  import defineProperty from "defineProperty";

  export default function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = (arguments[i] != null) ? Object(arguments[i]) : {};
      var ownKeys = Object.keys(source);
      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function(sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }
      ownKeys.forEach(function(key) {
        defineProperty(target, key, source[key]);
      });
    }
    return target;
  }
`])));
    helpers$1.inherits = helper$2("7.0.0-beta.0")(_templateObject14$1 || (_templateObject14$1 = _taggedTemplateLiteralLoose([`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    // We can't use defineProperty to set the prototype in a single step because it
    // doesn't work in Chrome <= 36. https://github.com/babel/babel/issues/14056
    // V8 bug: https://bugs.chromium.org/p/v8/issues/detail?id=3334
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", { writable: false });
    if (superClass) setPrototypeOf(subClass, superClass);
  }
`])));
    helpers$1.inheritsLoose = helper$2("7.0.0-beta.0")(_templateObject15$1 || (_templateObject15$1 = _taggedTemplateLiteralLoose(['\n  import setPrototypeOf from "setPrototypeOf";\n\n  export default function _inheritsLoose(subClass, superClass) {\n    subClass.prototype = Object.create(superClass.prototype);\n    subClass.prototype.constructor = subClass;\n    setPrototypeOf(subClass, superClass);\n  }\n'])));
    helpers$1.getPrototypeOf = helper$2("7.0.0-beta.0")(_templateObject16$1 || (_templateObject16$1 = _taggedTemplateLiteralLoose(["\n  export default function _getPrototypeOf(o) {\n    _getPrototypeOf = Object.setPrototypeOf\n      ? Object.getPrototypeOf\n      : function _getPrototypeOf(o) {\n          return o.__proto__ || Object.getPrototypeOf(o);\n        };\n    return _getPrototypeOf(o);\n  }\n"])));
    helpers$1.setPrototypeOf = helper$2("7.0.0-beta.0")(_templateObject17$1 || (_templateObject17$1 = _taggedTemplateLiteralLoose(["\n  export default function _setPrototypeOf(o, p) {\n    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {\n      o.__proto__ = p;\n      return o;\n    };\n    return _setPrototypeOf(o, p);\n  }\n"])));
    helpers$1.isNativeReflectConstruct = helper$2("7.9.0")(_templateObject18$1 || (_templateObject18$1 = _taggedTemplateLiteralLoose([`
  export default function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;

    // core-js@3
    if (Reflect.construct.sham) return false;

    // Proxy can't be polyfilled. Every browser implemented
    // proxies before or at the same time as Reflect.construct,
    // so if they support Proxy they also support Reflect.construct.
    if (typeof Proxy === "function") return true;

    // Since Reflect.construct can't be properly polyfilled, some
    // implementations (e.g. core-js@2) don't set the correct internal slots.
    // Those polyfills don't allow us to subclass built-ins, so we need to
    // use our fallback implementation.
    try {
      // If the internal slots aren't set, this throws an error similar to
      //   TypeError: this is not a Boolean object.

      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
      return true;
    } catch (e) {
      return false;
    }
  }
`])));
    helpers$1.construct = helper$2("7.0.0-beta.0")(_templateObject19$1 || (_templateObject19$1 = _taggedTemplateLiteralLoose([`
  import setPrototypeOf from "setPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";

  export default function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      // NOTE: If Parent !== Class, the correct __proto__ is set *after*
      //       calling the constructor.
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }
    // Avoid issues with Class being present but undefined when it wasn't
    // present in the original call.
    return _construct.apply(null, arguments);
  }
`])));
    helpers$1.isNativeFunction = helper$2("7.0.0-beta.0")(_templateObject20 || (_templateObject20 = _taggedTemplateLiteralLoose(['\n  export default function _isNativeFunction(fn) {\n    // Note: This function returns "true" for core-js functions.\n    return Function.toString.call(fn).indexOf("[native code]") !== -1;\n  }\n'])));
    helpers$1.wrapNativeSuper = helper$2("7.0.0-beta.0")(_templateObject21 || (_templateObject21 = _taggedTemplateLiteralLoose(['\n  import getPrototypeOf from "getPrototypeOf";\n  import setPrototypeOf from "setPrototypeOf";\n  import isNativeFunction from "isNativeFunction";\n  import construct from "construct";\n\n  export default function _wrapNativeSuper(Class) {\n    var _cache = typeof Map === "function" ? new Map() : undefined;\n\n    _wrapNativeSuper = function _wrapNativeSuper(Class) {\n      if (Class === null || !isNativeFunction(Class)) return Class;\n      if (typeof Class !== "function") {\n        throw new TypeError("Super expression must either be null or a function");\n      }\n      if (typeof _cache !== "undefined") {\n        if (_cache.has(Class)) return _cache.get(Class);\n        _cache.set(Class, Wrapper);\n      }\n      function Wrapper() {\n        return construct(Class, arguments, getPrototypeOf(this).constructor)\n      }\n      Wrapper.prototype = Object.create(Class.prototype, {\n        constructor: {\n          value: Wrapper,\n          enumerable: false,\n          writable: true,\n          configurable: true,\n        }\n      });\n\n      return setPrototypeOf(Wrapper, Class);\n    }\n\n    return _wrapNativeSuper(Class)\n  }\n'])));
    helpers$1["instanceof"] = helper$2("7.0.0-beta.0")(_templateObject22 || (_templateObject22 = _taggedTemplateLiteralLoose(['\n  export default function _instanceof(left, right) {\n    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {\n      return !!right[Symbol.hasInstance](left);\n    } else {\n      return left instanceof right;\n    }\n  }\n'])));
    helpers$1.interopRequireDefault = helper$2("7.0.0-beta.0")(_templateObject23 || (_templateObject23 = _taggedTemplateLiteralLoose(["\n  export default function _interopRequireDefault(obj) {\n    return obj && obj.__esModule ? obj : { default: obj };\n  }\n"])));
    helpers$1.interopRequireWildcard = helper$2("7.14.0")(_templateObject24 || (_templateObject24 = _taggedTemplateLiteralLoose(['\n  function _getRequireWildcardCache(nodeInterop) {\n    if (typeof WeakMap !== "function") return null;\n\n    var cacheBabelInterop = new WeakMap();\n    var cacheNodeInterop = new WeakMap();\n    return (_getRequireWildcardCache = function (nodeInterop) {\n      return nodeInterop ? cacheNodeInterop : cacheBabelInterop;\n    })(nodeInterop);\n  }\n\n  export default function _interopRequireWildcard(obj, nodeInterop) {\n    if (!nodeInterop && obj && obj.__esModule) {\n      return obj;\n    }\n\n    if (obj === null || (typeof obj !== "object" && typeof obj !== "function")) {\n      return { default: obj }\n    }\n\n    var cache = _getRequireWildcardCache(nodeInterop);\n    if (cache && cache.has(obj)) {\n      return cache.get(obj);\n    }\n\n    var newObj = {};\n    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;\n    for (var key in obj) {\n      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {\n        var desc = hasPropertyDescriptor\n          ? Object.getOwnPropertyDescriptor(obj, key)\n          : null;\n        if (desc && (desc.get || desc.set)) {\n          Object.defineProperty(newObj, key, desc);\n        } else {\n          newObj[key] = obj[key];\n        }\n      }\n    }\n    newObj.default = obj;\n    if (cache) {\n      cache.set(obj, newObj);\n    }\n    return newObj;\n  }\n'])));
    helpers$1.newArrowCheck = helper$2("7.0.0-beta.0")(_templateObject25 || (_templateObject25 = _taggedTemplateLiteralLoose(['\n  export default function _newArrowCheck(innerThis, boundThis) {\n    if (innerThis !== boundThis) {\n      throw new TypeError("Cannot instantiate an arrow function");\n    }\n  }\n'])));
    helpers$1.objectDestructuringEmpty = helper$2("7.0.0-beta.0")(_templateObject26 || (_templateObject26 = _taggedTemplateLiteralLoose(['\n  export default function _objectDestructuringEmpty(obj) {\n    if (obj == null) throw new TypeError("Cannot destructure undefined");\n  }\n'])));
    helpers$1.objectWithoutPropertiesLoose = helper$2("7.0.0-beta.0")(_templateObject27 || (_templateObject27 = _taggedTemplateLiteralLoose(["\n  export default function _objectWithoutPropertiesLoose(source, excluded) {\n    if (source == null) return {};\n\n    var target = {};\n    var sourceKeys = Object.keys(source);\n    var key, i;\n\n    for (i = 0; i < sourceKeys.length; i++) {\n      key = sourceKeys[i];\n      if (excluded.indexOf(key) >= 0) continue;\n      target[key] = source[key];\n    }\n\n    return target;\n  }\n"])));
    helpers$1.objectWithoutProperties = helper$2("7.0.0-beta.0")(_templateObject28 || (_templateObject28 = _taggedTemplateLiteralLoose(['\n  import objectWithoutPropertiesLoose from "objectWithoutPropertiesLoose";\n\n  export default function _objectWithoutProperties(source, excluded) {\n    if (source == null) return {};\n\n    var target = objectWithoutPropertiesLoose(source, excluded);\n    var key, i;\n\n    if (Object.getOwnPropertySymbols) {\n      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);\n      for (i = 0; i < sourceSymbolKeys.length; i++) {\n        key = sourceSymbolKeys[i];\n        if (excluded.indexOf(key) >= 0) continue;\n        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;\n        target[key] = source[key];\n      }\n    }\n\n    return target;\n  }\n'])));
    helpers$1.assertThisInitialized = helper$2("7.0.0-beta.0")(_templateObject29 || (_templateObject29 = _taggedTemplateLiteralLoose([`
  export default function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
`])));
    helpers$1.possibleConstructorReturn = helper$2("7.0.0-beta.0")(_templateObject30 || (_templateObject30 = _taggedTemplateLiteralLoose(['\n  import assertThisInitialized from "assertThisInitialized";\n\n  export default function _possibleConstructorReturn(self, call) {\n    if (call && (typeof call === "object" || typeof call === "function")) {\n      return call;\n    } else if (call !== void 0) {\n      throw new TypeError("Derived constructors may only return object or undefined");\n    }\n\n    return assertThisInitialized(self);\n  }\n'])));
    helpers$1.createSuper = helper$2("7.9.0")(_templateObject31 || (_templateObject31 = _taggedTemplateLiteralLoose([`
  import getPrototypeOf from "getPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";
  import possibleConstructorReturn from "possibleConstructorReturn";

  export default function _createSuper(Derived) {
    var hasNativeReflectConstruct = isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = getPrototypeOf(Derived), result;
      if (hasNativeReflectConstruct) {
        // NOTE: This doesn't work if this.__proto__.constructor has been modified.
        var NewTarget = getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return possibleConstructorReturn(this, result);
    }
  }
 `])));
    helpers$1.superPropBase = helper$2("7.0.0-beta.0")(_templateObject32 || (_templateObject32 = _taggedTemplateLiteralLoose([`
  import getPrototypeOf from "getPrototypeOf";

  export default function _superPropBase(object, property) {
    // Yes, this throws if object is null to being with, that's on purpose.
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = getPrototypeOf(object);
      if (object === null) break;
    }
    return object;
  }
`])));
    helpers$1.get = helper$2("7.0.0-beta.0")(_templateObject33 || (_templateObject33 = _taggedTemplateLiteralLoose(['\n  import superPropBase from "superPropBase";\n\n  export default function _get() {\n    if (typeof Reflect !== "undefined" && Reflect.get) {\n      _get = Reflect.get;\n    } else {\n      _get = function _get(target, property, receiver) {\n        var base = superPropBase(target, property);\n\n        if (!base) return;\n\n        var desc = Object.getOwnPropertyDescriptor(base, property);\n        if (desc.get) {\n          // STEP 3. If receiver is not present, then set receiver to target.\n          return desc.get.call(arguments.length < 3 ? target : receiver);\n        }\n\n        return desc.value;\n      };\n    }\n    return _get.apply(this, arguments);\n  }\n'])));
    helpers$1.set = helper$2("7.0.0-beta.0")(_templateObject34 || (_templateObject34 = _taggedTemplateLiteralLoose([`
  import superPropBase from "superPropBase";
  import defineProperty from "defineProperty";

  function set(target, property, value, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.set) {
      set = Reflect.set;
    } else {
      set = function set(target, property, value, receiver) {
        var base = superPropBase(target, property);
        var desc;

        if (base) {
          desc = Object.getOwnPropertyDescriptor(base, property);
          if (desc.set) {
            desc.set.call(receiver, value);
            return true;
          } else if (!desc.writable) {
            // Both getter and non-writable fall into this.
            return false;
          }
        }

        // Without a super that defines the property, spec boils down to
        // "define on receiver" for some reason.
        desc = Object.getOwnPropertyDescriptor(receiver, property);
        if (desc) {
          if (!desc.writable) {
            // Setter, getter, and non-writable fall into this.
            return false;
          }

          desc.value = value;
          Object.defineProperty(receiver, property, desc);
        } else {
          // Avoid setters that may be defined on Sub's prototype, but not on
          // the instance.
          defineProperty(receiver, property, value);
        }

        return true;
      };
    }

    return set(target, property, value, receiver);
  }

  export default function _set(target, property, value, receiver, isStrict) {
    var s = set(target, property, value, receiver || target);
    if (!s && isStrict) {
      throw new Error('failed to set property');
    }

    return value;
  }
`])));
    helpers$1.taggedTemplateLiteral = helper$2("7.0.0-beta.0")(_templateObject35 || (_templateObject35 = _taggedTemplateLiteralLoose(["\n  export default function _taggedTemplateLiteral(strings, raw) {\n    if (!raw) { raw = strings.slice(0); }\n    return Object.freeze(Object.defineProperties(strings, {\n        raw: { value: Object.freeze(raw) }\n    }));\n  }\n"])));
    helpers$1.taggedTemplateLiteralLoose = helper$2("7.0.0-beta.0")(_templateObject36 || (_templateObject36 = _taggedTemplateLiteralLoose(["\n  export default function _taggedTemplateLiteralLoose(strings, raw) {\n    if (!raw) { raw = strings.slice(0); }\n    strings.raw = raw;\n    return strings;\n  }\n"])));
    helpers$1.readOnlyError = helper$2("7.0.0-beta.0")(_templateObject37 || (_templateObject37 = _taggedTemplateLiteralLoose(['\n  export default function _readOnlyError(name) {\n    throw new TypeError("\\"" + name + "\\" is read-only");\n  }\n'], ['\n  export default function _readOnlyError(name) {\n    throw new TypeError("\\\\"" + name + "\\\\" is read-only");\n  }\n'])));
    helpers$1.writeOnlyError = helper$2("7.12.13")(_templateObject38 || (_templateObject38 = _taggedTemplateLiteralLoose(['\n  export default function _writeOnlyError(name) {\n    throw new TypeError("\\"" + name + "\\" is write-only");\n  }\n'], ['\n  export default function _writeOnlyError(name) {\n    throw new TypeError("\\\\"" + name + "\\\\" is write-only");\n  }\n'])));
    helpers$1.classNameTDZError = helper$2("7.0.0-beta.0")(_templateObject39 || (_templateObject39 = _taggedTemplateLiteralLoose(['\n  export default function _classNameTDZError(name) {\n    throw new Error("Class \\"" + name + "\\" cannot be referenced in computed property keys.");\n  }\n'], ['\n  export default function _classNameTDZError(name) {\n    throw new Error("Class \\\\"" + name + "\\\\" cannot be referenced in computed property keys.");\n  }\n'])));
    helpers$1.temporalUndefined = helper$2("7.0.0-beta.0")(_templateObject40 || (_templateObject40 = _taggedTemplateLiteralLoose(["\n  // This function isn't mean to be called, but to be used as a reference.\n  // We can't use a normal object because it isn't hoisted.\n  export default function _temporalUndefined() {}\n"])));
    helpers$1.tdz = helper$2("7.5.5")(_templateObject41 || (_templateObject41 = _taggedTemplateLiteralLoose(['\n  export default function _tdzError(name) {\n    throw new ReferenceError(name + " is not defined - temporal dead zone");\n  }\n'])));
    helpers$1.temporalRef = helper$2("7.0.0-beta.0")(_templateObject42 || (_templateObject42 = _taggedTemplateLiteralLoose(['\n  import undef from "temporalUndefined";\n  import err from "tdz";\n\n  export default function _temporalRef(val, name) {\n    return val === undef ? err(name) : val;\n  }\n'])));
    helpers$1.slicedToArray = helper$2("7.0.0-beta.0")(_templateObject43 || (_templateObject43 = _taggedTemplateLiteralLoose(['\n  import arrayWithHoles from "arrayWithHoles";\n  import iterableToArrayLimit from "iterableToArrayLimit";\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n  import nonIterableRest from "nonIterableRest";\n\n  export default function _slicedToArray(arr, i) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArrayLimit(arr, i) ||\n      unsupportedIterableToArray(arr, i) ||\n      nonIterableRest()\n    );\n  }\n'])));
    helpers$1.slicedToArrayLoose = helper$2("7.0.0-beta.0")(_templateObject44 || (_templateObject44 = _taggedTemplateLiteralLoose(['\n  import arrayWithHoles from "arrayWithHoles";\n  import iterableToArrayLimitLoose from "iterableToArrayLimitLoose";\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n  import nonIterableRest from "nonIterableRest";\n\n  export default function _slicedToArrayLoose(arr, i) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArrayLimitLoose(arr, i) ||\n      unsupportedIterableToArray(arr, i) ||\n      nonIterableRest()\n    );\n  }\n'])));
    helpers$1.toArray = helper$2("7.0.0-beta.0")(_templateObject45 || (_templateObject45 = _taggedTemplateLiteralLoose(['\n  import arrayWithHoles from "arrayWithHoles";\n  import iterableToArray from "iterableToArray";\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n  import nonIterableRest from "nonIterableRest";\n\n  export default function _toArray(arr) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArray(arr) ||\n      unsupportedIterableToArray(arr) ||\n      nonIterableRest()\n    );\n  }\n'])));
    helpers$1.toConsumableArray = helper$2("7.0.0-beta.0")(_templateObject46 || (_templateObject46 = _taggedTemplateLiteralLoose(['\n  import arrayWithoutHoles from "arrayWithoutHoles";\n  import iterableToArray from "iterableToArray";\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n  import nonIterableSpread from "nonIterableSpread";\n\n  export default function _toConsumableArray(arr) {\n    return (\n      arrayWithoutHoles(arr) ||\n      iterableToArray(arr) ||\n      unsupportedIterableToArray(arr) ||\n      nonIterableSpread()\n    );\n  }\n'])));
    helpers$1.arrayWithoutHoles = helper$2("7.0.0-beta.0")(_templateObject47 || (_templateObject47 = _taggedTemplateLiteralLoose(['\n  import arrayLikeToArray from "arrayLikeToArray";\n\n  export default function _arrayWithoutHoles(arr) {\n    if (Array.isArray(arr)) return arrayLikeToArray(arr);\n  }\n'])));
    helpers$1.arrayWithHoles = helper$2("7.0.0-beta.0")(_templateObject48 || (_templateObject48 = _taggedTemplateLiteralLoose(["\n  export default function _arrayWithHoles(arr) {\n    if (Array.isArray(arr)) return arr;\n  }\n"])));
    helpers$1.maybeArrayLike = helper$2("7.9.0")(_templateObject49 || (_templateObject49 = _taggedTemplateLiteralLoose(['\n  import arrayLikeToArray from "arrayLikeToArray";\n\n  export default function _maybeArrayLike(next, arr, i) {\n    if (arr && !Array.isArray(arr) && typeof arr.length === "number") {\n      var len = arr.length;\n      return arrayLikeToArray(arr, i !== void 0 && i < len ? i : len);\n    }\n    return next(arr, i);\n  }\n'])));
    helpers$1.iterableToArray = helper$2("7.0.0-beta.0")(_templateObject50 || (_templateObject50 = _taggedTemplateLiteralLoose(['\n  export default function _iterableToArray(iter) {\n    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);\n  }\n'])));
    helpers$1.iterableToArrayLimit = helper$2("7.0.0-beta.0")(_templateObject51 || (_templateObject51 = _taggedTemplateLiteralLoose(['\n  export default function _iterableToArrayLimit(arr, i) {\n    // this is an expanded form of `for...of` that properly supports abrupt completions of\n    // iterators etc. variable names have been minimised to reduce the size of this massive\n    // helper. sometimes spec compliance is annoying :(\n    //\n    // _n = _iteratorNormalCompletion\n    // _d = _didIteratorError\n    // _e = _iteratorError\n    // _i = _iterator\n    // _s = _step\n\n    var _i = arr == null ? null : (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);\n    if (_i == null) return;\n\n    var _arr = [];\n    var _n = true;\n    var _d = false;\n    var _s, _e;\n    try {\n      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {\n        _arr.push(_s.value);\n        if (i && _arr.length === i) break;\n      }\n    } catch (err) {\n      _d = true;\n      _e = err;\n    } finally {\n      try {\n        if (!_n && _i["return"] != null) _i["return"]();\n      } finally {\n        if (_d) throw _e;\n      }\n    }\n    return _arr;\n  }\n'], ['\n  export default function _iterableToArrayLimit(arr, i) {\n    // this is an expanded form of \\`for...of\\` that properly supports abrupt completions of\n    // iterators etc. variable names have been minimised to reduce the size of this massive\n    // helper. sometimes spec compliance is annoying :(\n    //\n    // _n = _iteratorNormalCompletion\n    // _d = _didIteratorError\n    // _e = _iteratorError\n    // _i = _iterator\n    // _s = _step\n\n    var _i = arr == null ? null : (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);\n    if (_i == null) return;\n\n    var _arr = [];\n    var _n = true;\n    var _d = false;\n    var _s, _e;\n    try {\n      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {\n        _arr.push(_s.value);\n        if (i && _arr.length === i) break;\n      }\n    } catch (err) {\n      _d = true;\n      _e = err;\n    } finally {\n      try {\n        if (!_n && _i["return"] != null) _i["return"]();\n      } finally {\n        if (_d) throw _e;\n      }\n    }\n    return _arr;\n  }\n'])));
    helpers$1.iterableToArrayLimitLoose = helper$2("7.0.0-beta.0")(_templateObject52 || (_templateObject52 = _taggedTemplateLiteralLoose(['\n  export default function _iterableToArrayLimitLoose(arr, i) {\n    var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);\n    if (_i == null) return;\n\n    var _arr = [];\n    for (_i = _i.call(arr), _step; !(_step = _i.next()).done;) {\n      _arr.push(_step.value);\n      if (i && _arr.length === i) break;\n    }\n    return _arr;\n  }\n'])));
    helpers$1.unsupportedIterableToArray = helper$2("7.9.0")(_templateObject53 || (_templateObject53 = _taggedTemplateLiteralLoose(['\n  import arrayLikeToArray from "arrayLikeToArray";\n\n  export default function _unsupportedIterableToArray(o, minLen) {\n    if (!o) return;\n    if (typeof o === "string") return arrayLikeToArray(o, minLen);\n    var n = Object.prototype.toString.call(o).slice(8, -1);\n    if (n === "Object" && o.constructor) n = o.constructor.name;\n    if (n === "Map" || n === "Set") return Array.from(o);\n    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))\n      return arrayLikeToArray(o, minLen);\n  }\n'])));
    helpers$1.arrayLikeToArray = helper$2("7.9.0")(_templateObject54 || (_templateObject54 = _taggedTemplateLiteralLoose(["\n  export default function _arrayLikeToArray(arr, len) {\n    if (len == null || len > arr.length) len = arr.length;\n    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];\n    return arr2;\n  }\n"])));
    helpers$1.nonIterableSpread = helper$2("7.0.0-beta.0")(_templateObject55 || (_templateObject55 = _taggedTemplateLiteralLoose(['\n  export default function _nonIterableSpread() {\n    throw new TypeError(\n      "Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."\n    );\n  }\n'], ['\n  export default function _nonIterableSpread() {\n    throw new TypeError(\n      "Invalid attempt to spread non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."\n    );\n  }\n'])));
    helpers$1.nonIterableRest = helper$2("7.0.0-beta.0")(_templateObject56 || (_templateObject56 = _taggedTemplateLiteralLoose(['\n  export default function _nonIterableRest() {\n    throw new TypeError(\n      "Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."\n    );\n  }\n'], ['\n  export default function _nonIterableRest() {\n    throw new TypeError(\n      "Invalid attempt to destructure non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."\n    );\n  }\n'])));
    helpers$1.createForOfIteratorHelper = helper$2("7.9.0")(_templateObject57 || (_templateObject57 = _taggedTemplateLiteralLoose(['\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n\n  // s: start (create the iterator)\n  // n: next\n  // e: error (called whenever something throws)\n  // f: finish (always called at the end)\n\n  export default function _createForOfIteratorHelper(o, allowArrayLike) {\n    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];\n\n    if (!it) {\n      // Fallback for engines without symbol support\n      if (\n        Array.isArray(o) ||\n        (it = unsupportedIterableToArray(o)) ||\n        (allowArrayLike && o && typeof o.length === "number")\n      ) {\n        if (it) o = it;\n        var i = 0;\n        var F = function(){};\n        return {\n          s: F,\n          n: function() {\n            if (i >= o.length) return { done: true };\n            return { done: false, value: o[i++] };\n          },\n          e: function(e) { throw e; },\n          f: F,\n        };\n      }\n\n      throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");\n    }\n\n    var normalCompletion = true, didErr = false, err;\n\n    return {\n      s: function() {\n        it = it.call(o);\n      },\n      n: function() {\n        var step = it.next();\n        normalCompletion = step.done;\n        return step;\n      },\n      e: function(e) {\n        didErr = true;\n        err = e;\n      },\n      f: function() {\n        try {\n          if (!normalCompletion && it.return != null) it.return();\n        } finally {\n          if (didErr) throw err;\n        }\n      }\n    };\n  }\n'], ['\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n\n  // s: start (create the iterator)\n  // n: next\n  // e: error (called whenever something throws)\n  // f: finish (always called at the end)\n\n  export default function _createForOfIteratorHelper(o, allowArrayLike) {\n    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];\n\n    if (!it) {\n      // Fallback for engines without symbol support\n      if (\n        Array.isArray(o) ||\n        (it = unsupportedIterableToArray(o)) ||\n        (allowArrayLike && o && typeof o.length === "number")\n      ) {\n        if (it) o = it;\n        var i = 0;\n        var F = function(){};\n        return {\n          s: F,\n          n: function() {\n            if (i >= o.length) return { done: true };\n            return { done: false, value: o[i++] };\n          },\n          e: function(e) { throw e; },\n          f: F,\n        };\n      }\n\n      throw new TypeError("Invalid attempt to iterate non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");\n    }\n\n    var normalCompletion = true, didErr = false, err;\n\n    return {\n      s: function() {\n        it = it.call(o);\n      },\n      n: function() {\n        var step = it.next();\n        normalCompletion = step.done;\n        return step;\n      },\n      e: function(e) {\n        didErr = true;\n        err = e;\n      },\n      f: function() {\n        try {\n          if (!normalCompletion && it.return != null) it.return();\n        } finally {\n          if (didErr) throw err;\n        }\n      }\n    };\n  }\n'])));
    helpers$1.createForOfIteratorHelperLoose = helper$2("7.9.0")(_templateObject58 || (_templateObject58 = _taggedTemplateLiteralLoose(['\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n\n  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {\n    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];\n\n    if (it) return (it = it.call(o)).next.bind(it);\n\n    // Fallback for engines without symbol support\n    if (\n      Array.isArray(o) ||\n      (it = unsupportedIterableToArray(o)) ||\n      (allowArrayLike && o && typeof o.length === "number")\n    ) {\n      if (it) o = it;\n      var i = 0;\n      return function() {\n        if (i >= o.length) return { done: true };\n        return { done: false, value: o[i++] };\n      }\n    }\n\n    throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");\n  }\n'], ['\n  import unsupportedIterableToArray from "unsupportedIterableToArray";\n\n  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {\n    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];\n\n    if (it) return (it = it.call(o)).next.bind(it);\n\n    // Fallback for engines without symbol support\n    if (\n      Array.isArray(o) ||\n      (it = unsupportedIterableToArray(o)) ||\n      (allowArrayLike && o && typeof o.length === "number")\n    ) {\n      if (it) o = it;\n      var i = 0;\n      return function() {\n        if (i >= o.length) return { done: true };\n        return { done: false, value: o[i++] };\n      }\n    }\n\n    throw new TypeError("Invalid attempt to iterate non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");\n  }\n'])));
    helpers$1.skipFirstGeneratorNext = helper$2("7.0.0-beta.0")(_templateObject59 || (_templateObject59 = _taggedTemplateLiteralLoose(["\n  export default function _skipFirstGeneratorNext(fn) {\n    return function () {\n      var it = fn.apply(this, arguments);\n      it.next();\n      return it;\n    }\n  }\n"])));
    helpers$1.toPrimitive = helper$2("7.1.5")(_templateObject60 || (_templateObject60 = _taggedTemplateLiteralLoose(['\n  export default function _toPrimitive(\n    input,\n    hint /*: "default" | "string" | "number" | void */\n  ) {\n    if (typeof input !== "object" || input === null) return input;\n    var prim = input[Symbol.toPrimitive];\n    if (prim !== undefined) {\n      var res = prim.call(input, hint || "default");\n      if (typeof res !== "object") return res;\n      throw new TypeError("@@toPrimitive must return a primitive value.");\n    }\n    return (hint === "string" ? String : Number)(input);\n  }\n'])));
    helpers$1.toPropertyKey = helper$2("7.1.5")(_templateObject61 || (_templateObject61 = _taggedTemplateLiteralLoose(['\n  import toPrimitive from "toPrimitive";\n\n  export default function _toPropertyKey(arg) {\n    var key = toPrimitive(arg, "string");\n    return typeof key === "symbol" ? key : String(key);\n  }\n'])));
    helpers$1.initializerWarningHelper = helper$2("7.0.0-beta.0")(_templateObject62 || (_templateObject62 = _taggedTemplateLiteralLoose(["\n    export default function _initializerWarningHelper(descriptor, context){\n        throw new Error(\n          'Decorating class property failed. Please ensure that ' +\n          'proposal-class-properties is enabled and runs after the decorators transform.'\n        );\n    }\n"])));
    helpers$1.initializerDefineProperty = helper$2("7.0.0-beta.0")(_templateObject63 || (_templateObject63 = _taggedTemplateLiteralLoose(["\n    export default function _initializerDefineProperty(target, property, descriptor, context){\n        if (!descriptor) return;\n\n        Object.defineProperty(target, property, {\n            enumerable: descriptor.enumerable,\n            configurable: descriptor.configurable,\n            writable: descriptor.writable,\n            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0,\n        });\n    }\n"])));
    helpers$1.applyDecoratedDescriptor = helper$2("7.0.0-beta.0")(_templateObject64 || (_templateObject64 = _taggedTemplateLiteralLoose(["\n    export default function _applyDecoratedDescriptor(target, property, decorators, descriptor, context){\n        var desc = {};\n        Object.keys(descriptor).forEach(function(key){\n            desc[key] = descriptor[key];\n        });\n        desc.enumerable = !!desc.enumerable;\n        desc.configurable = !!desc.configurable;\n        if ('value' in desc || desc.initializer){\n            desc.writable = true;\n        }\n\n        desc = decorators.slice().reverse().reduce(function(desc, decorator){\n            return decorator(target, property, desc) || desc;\n        }, desc);\n\n        if (context && desc.initializer !== void 0){\n            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;\n            desc.initializer = undefined;\n        }\n\n        if (desc.initializer === void 0){\n            Object.defineProperty(target, property, desc);\n            desc = null;\n        }\n\n        return desc;\n    }\n"])));
    helpers$1.classPrivateFieldLooseKey = helper$2("7.0.0-beta.0")(_templateObject65 || (_templateObject65 = _taggedTemplateLiteralLoose(['\n  var id = 0;\n  export default function _classPrivateFieldKey(name) {\n    return "__private_" + (id++) + "_" + name;\n  }\n'])));
    helpers$1.classPrivateFieldLooseBase = helper$2("7.0.0-beta.0")(_templateObject66 || (_templateObject66 = _taggedTemplateLiteralLoose(['\n  export default function _classPrivateFieldBase(receiver, privateKey) {\n    if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {\n      throw new TypeError("attempted to use private field on non-instance");\n    }\n    return receiver;\n  }\n'])));
    helpers$1.classPrivateFieldGet = helper$2("7.0.0-beta.0")(_templateObject67 || (_templateObject67 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorGet from "classApplyDescriptorGet";\n  import classExtractFieldDescriptor from "classExtractFieldDescriptor";\n  export default function _classPrivateFieldGet(receiver, privateMap) {\n    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "get");\n    return classApplyDescriptorGet(receiver, descriptor);\n  }\n'])));
    helpers$1.classPrivateFieldSet = helper$2("7.0.0-beta.0")(_templateObject68 || (_templateObject68 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorSet from "classApplyDescriptorSet";\n  import classExtractFieldDescriptor from "classExtractFieldDescriptor";\n  export default function _classPrivateFieldSet(receiver, privateMap, value) {\n    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");\n    classApplyDescriptorSet(receiver, descriptor, value);\n    return value;\n  }\n'])));
    helpers$1.classPrivateFieldDestructureSet = helper$2("7.4.4")(_templateObject69 || (_templateObject69 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";\n  import classExtractFieldDescriptor from "classExtractFieldDescriptor";\n  export default function _classPrivateFieldDestructureSet(receiver, privateMap) {\n    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");\n    return classApplyDescriptorDestructureSet(receiver, descriptor);\n  }\n'])));
    helpers$1.classExtractFieldDescriptor = helper$2("7.13.10")(_templateObject70 || (_templateObject70 = _taggedTemplateLiteralLoose(['\n  export default function _classExtractFieldDescriptor(receiver, privateMap, action) {\n    if (!privateMap.has(receiver)) {\n      throw new TypeError("attempted to " + action + " private field on non-instance");\n    }\n    return privateMap.get(receiver);\n  }\n'])));
    helpers$1.classStaticPrivateFieldSpecGet = helper$2("7.0.2")(_templateObject71 || (_templateObject71 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorGet from "classApplyDescriptorGet";\n  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";\n  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";\n  export default function _classStaticPrivateFieldSpecGet(receiver, classConstructor, descriptor) {\n    classCheckPrivateStaticAccess(receiver, classConstructor);\n    classCheckPrivateStaticFieldDescriptor(descriptor, "get");\n    return classApplyDescriptorGet(receiver, descriptor);\n  }\n'])));
    helpers$1.classStaticPrivateFieldSpecSet = helper$2("7.0.2")(_templateObject72 || (_templateObject72 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorSet from "classApplyDescriptorSet";\n  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";\n  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";\n  export default function _classStaticPrivateFieldSpecSet(receiver, classConstructor, descriptor, value) {\n    classCheckPrivateStaticAccess(receiver, classConstructor);\n    classCheckPrivateStaticFieldDescriptor(descriptor, "set");\n    classApplyDescriptorSet(receiver, descriptor, value);\n    return value;\n  }\n'])));
    helpers$1.classStaticPrivateMethodGet = helper$2("7.3.2")(_templateObject73 || (_templateObject73 = _taggedTemplateLiteralLoose(['\n  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";\n  export default function _classStaticPrivateMethodGet(receiver, classConstructor, method) {\n    classCheckPrivateStaticAccess(receiver, classConstructor);\n    return method;\n  }\n'])));
    helpers$1.classStaticPrivateMethodSet = helper$2("7.3.2")(_templateObject74 || (_templateObject74 = _taggedTemplateLiteralLoose(['\n  export default function _classStaticPrivateMethodSet() {\n    throw new TypeError("attempted to set read only static private field");\n  }\n'])));
    helpers$1.classApplyDescriptorGet = helper$2("7.13.10")(_templateObject75 || (_templateObject75 = _taggedTemplateLiteralLoose(["\n  export default function _classApplyDescriptorGet(receiver, descriptor) {\n    if (descriptor.get) {\n      return descriptor.get.call(receiver);\n    }\n    return descriptor.value;\n  }\n"])));
    helpers$1.classApplyDescriptorSet = helper$2("7.13.10")(_templateObject76 || (_templateObject76 = _taggedTemplateLiteralLoose(['\n  export default function _classApplyDescriptorSet(receiver, descriptor, value) {\n    if (descriptor.set) {\n      descriptor.set.call(receiver, value);\n    } else {\n      if (!descriptor.writable) {\n        // This should only throw in strict mode, but class bodies are\n        // always strict and private fields can only be used inside\n        // class bodies.\n        throw new TypeError("attempted to set read only private field");\n      }\n      descriptor.value = value;\n    }\n  }\n'])));
    helpers$1.classApplyDescriptorDestructureSet = helper$2("7.13.10")(_templateObject77 || (_templateObject77 = _taggedTemplateLiteralLoose(['\n  export default function _classApplyDescriptorDestructureSet(receiver, descriptor) {\n    if (descriptor.set) {\n      if (!("__destrObj" in descriptor)) {\n        descriptor.__destrObj = {\n          set value(v) {\n            descriptor.set.call(receiver, v)\n          },\n        };\n      }\n      return descriptor.__destrObj;\n    } else {\n      if (!descriptor.writable) {\n        // This should only throw in strict mode, but class bodies are\n        // always strict and private fields can only be used inside\n        // class bodies.\n        throw new TypeError("attempted to set read only private field");\n      }\n\n      return descriptor;\n    }\n  }\n'])));
    helpers$1.classStaticPrivateFieldDestructureSet = helper$2("7.13.10")(_templateObject78 || (_templateObject78 = _taggedTemplateLiteralLoose(['\n  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";\n  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";\n  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";\n  export default function _classStaticPrivateFieldDestructureSet(receiver, classConstructor, descriptor) {\n    classCheckPrivateStaticAccess(receiver, classConstructor);\n    classCheckPrivateStaticFieldDescriptor(descriptor, "set");\n    return classApplyDescriptorDestructureSet(receiver, descriptor);\n  }\n'])));
    helpers$1.classCheckPrivateStaticAccess = helper$2("7.13.10")(_templateObject79 || (_templateObject79 = _taggedTemplateLiteralLoose(['\n  export default function _classCheckPrivateStaticAccess(receiver, classConstructor) {\n    if (receiver !== classConstructor) {\n      throw new TypeError("Private static access of wrong provenance");\n    }\n  }\n'])));
    helpers$1.classCheckPrivateStaticFieldDescriptor = helper$2("7.13.10")(_templateObject80 || (_templateObject80 = _taggedTemplateLiteralLoose(['\n  export default function _classCheckPrivateStaticFieldDescriptor(descriptor, action) {\n    if (descriptor === undefined) {\n      throw new TypeError("attempted to " + action + " private static field before its declaration");\n    }\n  }\n'])));
    helpers$1.decorate = helper$2("7.1.5")(_templateObject81 || (_templateObject81 = _taggedTemplateLiteralLoose([`
  import toArray from "toArray";
  import toPropertyKey from "toPropertyKey";

  // These comments are stripped by @babel/template
  /*::
  type PropertyDescriptor =
    | {
        value: any,
        writable: boolean,
        configurable: boolean,
        enumerable: boolean,
      }
    | {
        get?: () => any,
        set?: (v: any) => void,
        configurable: boolean,
        enumerable: boolean,
      };

  type FieldDescriptor ={
    writable: boolean,
    configurable: boolean,
    enumerable: boolean,
  };

  type Placement = "static" | "prototype" | "own";
  type Key = string | symbol; // PrivateName is not supported yet.

  type ElementDescriptor =
    | {
        kind: "method",
        key: Key,
        placement: Placement,
        descriptor: PropertyDescriptor
      }
    | {
        kind: "field",
        key: Key,
        placement: Placement,
        descriptor: FieldDescriptor,
        initializer?: () => any,
      };

  // This is exposed to the user code
  type ElementObjectInput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
  };

  // This is exposed to the user code
  type ElementObjectOutput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
    extras?: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  // This is exposed to the user code
  type ClassObject = {
    [@@toStringTag]?: "Descriptor",
    kind: "class",
    elements: ElementDescriptor[],
  };

  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;
  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;
  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;

  // Only used by Babel in the transform output, not part of the spec.
  type ElementDefinition =
    | {
        kind: "method",
        value: any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
      }
    | {
        kind: "field",
        value: () => any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
    };

  declare function ClassFactory<C>(initialize: (instance: C) => void): {
    F: Class<C>,
    d: ElementDefinition[]
  }

  */

  /*::
  // Various combinations with/without extras and with one or many finishers

  type ElementFinisherExtras = {
    element: ElementDescriptor,
    finisher?: ClassFinisher,
    extras?: ElementDescriptor[],
  };

  type ElementFinishersExtras = {
    element: ElementDescriptor,
    finishers: ClassFinisher[],
    extras: ElementDescriptor[],
  };

  type ElementsFinisher = {
    elements: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  type ElementsFinishers = {
    elements: ElementDescriptor[],
    finishers: ClassFinisher[],
  };

  */

  /*::

  type Placements = {
    static: Key[],
    prototype: Key[],
    own: Key[],
  };

  */

  // ClassDefinitionEvaluation (Steps 26-*)
  export default function _decorate(
    decorators /*: ClassDecorator[] */,
    factory /*: ClassFactory */,
    superClass /*: ?Class<*> */,
    mixins /*: ?Array<Function> */,
  ) /*: Class<*> */ {
    var api = _getDecoratorsApi();
    if (mixins) {
      for (var i = 0; i < mixins.length; i++) {
        api = mixins[i](api);
      }
    }

    var r = factory(function initialize(O) {
      api.initializeInstanceElements(O, decorated.elements);
    }, superClass);
    var decorated = api.decorateClass(
      _coalesceClassElements(r.d.map(_createElementDescriptor)),
      decorators,
    );

    api.initializeClassElements(r.F, decorated.elements);

    return api.runClassFinishers(r.F, decorated.finishers);
  }

  function _getDecoratorsApi() {
    _getDecoratorsApi = function() {
      return api;
    };

    var api = {
      elementsDefinitionOrder: [["method"], ["field"]],

      // InitializeInstanceElements
      initializeInstanceElements: function(
        /*::<C>*/ O /*: C */,
        elements /*: ElementDescriptor[] */,
      ) {
        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            if (element.kind === kind && element.placement === "own") {
              this.defineClassElement(O, element);
            }
          }, this);
        }, this);
      },

      // InitializeClassElements
      initializeClassElements: function(
        /*::<C>*/ F /*: Class<C> */,
        elements /*: ElementDescriptor[] */,
      ) {
        var proto = F.prototype;

        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            var placement = element.placement;
            if (
              element.kind === kind &&
              (placement === "static" || placement === "prototype")
            ) {
              var receiver = placement === "static" ? F : proto;
              this.defineClassElement(receiver, element);
            }
          }, this);
        }, this);
      },

      // DefineClassElement
      defineClassElement: function(
        /*::<C>*/ receiver /*: C | Class<C> */,
        element /*: ElementDescriptor */,
      ) {
        var descriptor /*: PropertyDescriptor */ = element.descriptor;
        if (element.kind === "field") {
          var initializer = element.initializer;
          descriptor = {
            enumerable: descriptor.enumerable,
            writable: descriptor.writable,
            configurable: descriptor.configurable,
            value: initializer === void 0 ? void 0 : initializer.call(receiver),
          };
        }
        Object.defineProperty(receiver, element.key, descriptor);
      },

      // DecorateClass
      decorateClass: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var newElements /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];
        var placements /*: Placements */ = {
          static: [],
          prototype: [],
          own: [],
        };

        elements.forEach(function(element /*: ElementDescriptor */) {
          this.addElementPlacement(element, placements);
        }, this);

        elements.forEach(function(element /*: ElementDescriptor */) {
          if (!_hasDecorators(element)) return newElements.push(element);

          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(
            element,
            placements,
          );
          newElements.push(elementFinishersExtras.element);
          newElements.push.apply(newElements, elementFinishersExtras.extras);
          finishers.push.apply(finishers, elementFinishersExtras.finishers);
        }, this);

        if (!decorators) {
          return { elements: newElements, finishers: finishers };
        }

        var result /*: ElementsFinishers */ = this.decorateConstructor(
          newElements,
          decorators,
        );
        finishers.push.apply(finishers, result.finishers);
        result.finishers = finishers;

        return result;
      },

      // AddElementPlacement
      addElementPlacement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
        silent /*: boolean */,
      ) {
        var keys = placements[element.placement];
        if (!silent && keys.indexOf(element.key) !== -1) {
          throw new TypeError("Duplicated element (" + element.key + ")");
        }
        keys.push(element.key);
      },

      // DecorateElement
      decorateElement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
      ) /*: ElementFinishersExtras */ {
        var extras /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];

        for (
          var decorators = element.decorators, i = decorators.length - 1;
          i >= 0;
          i--
        ) {
          // (inlined) RemoveElementPlacement
          var keys = placements[element.placement];
          keys.splice(keys.indexOf(element.key), 1);

          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(
            element,
          );
          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(
            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||
              elementObject,
          );

          element = elementFinisherExtras.element;
          this.addElementPlacement(element, placements);

          if (elementFinisherExtras.finisher) {
            finishers.push(elementFinisherExtras.finisher);
          }

          var newExtras /*: ElementDescriptor[] | void */ =
            elementFinisherExtras.extras;
          if (newExtras) {
            for (var j = 0; j < newExtras.length; j++) {
              this.addElementPlacement(newExtras[j], placements);
            }
            extras.push.apply(extras, newExtras);
          }
        }

        return { element: element, finishers: finishers, extras: extras };
      },

      // DecorateConstructor
      decorateConstructor: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var finishers /*: ClassFinisher[] */ = [];

        for (var i = decorators.length - 1; i >= 0; i--) {
          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);
          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(
            (0, decorators[i])(obj) /*: ClassObject */ || obj,
          );

          if (elementsAndFinisher.finisher !== undefined) {
            finishers.push(elementsAndFinisher.finisher);
          }

          if (elementsAndFinisher.elements !== undefined) {
            elements = elementsAndFinisher.elements;

            for (var j = 0; j < elements.length - 1; j++) {
              for (var k = j + 1; k < elements.length; k++) {
                if (
                  elements[j].key === elements[k].key &&
                  elements[j].placement === elements[k].placement
                ) {
                  throw new TypeError(
                    "Duplicated element (" + elements[j].key + ")",
                  );
                }
              }
            }
          }
        }

        return { elements: elements, finishers: finishers };
      },

      // FromElementDescriptor
      fromElementDescriptor: function(
        element /*: ElementDescriptor */,
      ) /*: ElementObject */ {
        var obj /*: ElementObject */ = {
          kind: element.kind,
          key: element.key,
          placement: element.placement,
          descriptor: element.descriptor,
        };

        var desc = {
          value: "Descriptor",
          configurable: true,
        };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        if (element.kind === "field") obj.initializer = element.initializer;

        return obj;
      },

      // ToElementDescriptors
      toElementDescriptors: function(
        elementObjects /*: ElementObject[] */,
      ) /*: ElementDescriptor[] */ {
        if (elementObjects === undefined) return;
        return toArray(elementObjects).map(function(elementObject) {
          var element = this.toElementDescriptor(elementObject);
          this.disallowProperty(elementObject, "finisher", "An element descriptor");
          this.disallowProperty(elementObject, "extras", "An element descriptor");
          return element;
        }, this);
      },

      // ToElementDescriptor
      toElementDescriptor: function(
        elementObject /*: ElementObject */,
      ) /*: ElementDescriptor */ {
        var kind = String(elementObject.kind);
        if (kind !== "method" && kind !== "field") {
          throw new TypeError(
            'An element descriptor\\'s .kind property must be either "method" or' +
              ' "field", but a decorator created an element descriptor with' +
              ' .kind "' +
              kind +
              '"',
          );
        }

        var key = toPropertyKey(elementObject.key);

        var placement = String(elementObject.placement);
        if (
          placement !== "static" &&
          placement !== "prototype" &&
          placement !== "own"
        ) {
          throw new TypeError(
            'An element descriptor\\'s .placement property must be one of "static",' +
              ' "prototype" or "own", but a decorator created an element descriptor' +
              ' with .placement "' +
              placement +
              '"',
          );
        }

        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;

        this.disallowProperty(elementObject, "elements", "An element descriptor");

        var element /*: ElementDescriptor */ = {
          kind: kind,
          key: key,
          placement: placement,
          descriptor: Object.assign({}, descriptor),
        };

        if (kind !== "field") {
          this.disallowProperty(elementObject, "initializer", "A method descriptor");
        } else {
          this.disallowProperty(
            descriptor,
            "get",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "set",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "value",
            "The property descriptor of a field descriptor",
          );

          element.initializer = elementObject.initializer;
        }

        return element;
      },

      toElementFinisherExtras: function(
        elementObject /*: ElementObject */,
      ) /*: ElementFinisherExtras */ {
        var element /*: ElementDescriptor */ = this.toElementDescriptor(
          elementObject,
        );
        var finisher /*: ClassFinisher */ = _optionalCallableProperty(
          elementObject,
          "finisher",
        );
        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(
          elementObject.extras,
        );

        return { element: element, finisher: finisher, extras: extras };
      },

      // FromClassDescriptor
      fromClassDescriptor: function(
        elements /*: ElementDescriptor[] */,
      ) /*: ClassObject */ {
        var obj = {
          kind: "class",
          elements: elements.map(this.fromElementDescriptor, this),
        };

        var desc = { value: "Descriptor", configurable: true };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        return obj;
      },

      // ToClassDescriptor
      toClassDescriptor: function(
        obj /*: ClassObject */,
      ) /*: ElementsFinisher */ {
        var kind = String(obj.kind);
        if (kind !== "class") {
          throw new TypeError(
            'A class descriptor\\'s .kind property must be "class", but a decorator' +
              ' created a class descriptor with .kind "' +
              kind +
              '"',
          );
        }

        this.disallowProperty(obj, "key", "A class descriptor");
        this.disallowProperty(obj, "placement", "A class descriptor");
        this.disallowProperty(obj, "descriptor", "A class descriptor");
        this.disallowProperty(obj, "initializer", "A class descriptor");
        this.disallowProperty(obj, "extras", "A class descriptor");

        var finisher = _optionalCallableProperty(obj, "finisher");
        var elements = this.toElementDescriptors(obj.elements);

        return { elements: elements, finisher: finisher };
      },

      // RunClassFinishers
      runClassFinishers: function(
        constructor /*: Class<*> */,
        finishers /*: ClassFinisher[] */,
      ) /*: Class<*> */ {
        for (var i = 0; i < finishers.length; i++) {
          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);
          if (newConstructor !== undefined) {
            // NOTE: This should check if IsConstructor(newConstructor) is false.
            if (typeof newConstructor !== "function") {
              throw new TypeError("Finishers must return a constructor.");
            }
            constructor = newConstructor;
          }
        }
        return constructor;
      },

      disallowProperty: function(obj, name, objectType) {
        if (obj[name] !== undefined) {
          throw new TypeError(objectType + " can't have a ." + name + " property.");
        }
      }
    };

    return api;
  }

  // ClassElementEvaluation
  function _createElementDescriptor(
    def /*: ElementDefinition */,
  ) /*: ElementDescriptor */ {
    var key = toPropertyKey(def.key);

    var descriptor /*: PropertyDescriptor */;
    if (def.kind === "method") {
      descriptor = {
        value: def.value,
        writable: true,
        configurable: true,
        enumerable: false,
      };
    } else if (def.kind === "get") {
      descriptor = { get: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "set") {
      descriptor = { set: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "field") {
      descriptor = { configurable: true, writable: true, enumerable: true };
    }

    var element /*: ElementDescriptor */ = {
      kind: def.kind === "field" ? "field" : "method",
      key: key,
      placement: def.static
        ? "static"
        : def.kind === "field"
        ? "own"
        : "prototype",
      descriptor: descriptor,
    };
    if (def.decorators) element.decorators = def.decorators;
    if (def.kind === "field") element.initializer = def.value;

    return element;
  }

  // CoalesceGetterSetter
  function _coalesceGetterSetter(
    element /*: ElementDescriptor */,
    other /*: ElementDescriptor */,
  ) {
    if (element.descriptor.get !== undefined) {
      other.descriptor.get = element.descriptor.get;
    } else {
      other.descriptor.set = element.descriptor.set;
    }
  }

  // CoalesceClassElements
  function _coalesceClassElements(
    elements /*: ElementDescriptor[] */,
  ) /*: ElementDescriptor[] */ {
    var newElements /*: ElementDescriptor[] */ = [];

    var isSameElement = function(
      other /*: ElementDescriptor */,
    ) /*: boolean */ {
      return (
        other.kind === "method" &&
        other.key === element.key &&
        other.placement === element.placement
      );
    };

    for (var i = 0; i < elements.length; i++) {
      var element /*: ElementDescriptor */ = elements[i];
      var other /*: ElementDescriptor */;

      if (
        element.kind === "method" &&
        (other = newElements.find(isSameElement))
      ) {
        if (
          _isDataDescriptor(element.descriptor) ||
          _isDataDescriptor(other.descriptor)
        ) {
          if (_hasDecorators(element) || _hasDecorators(other)) {
            throw new ReferenceError(
              "Duplicated methods (" + element.key + ") can't be decorated.",
            );
          }
          other.descriptor = element.descriptor;
        } else {
          if (_hasDecorators(element)) {
            if (_hasDecorators(other)) {
              throw new ReferenceError(
                "Decorators can't be placed on different accessors with for " +
                  "the same property (" +
                  element.key +
                  ").",
              );
            }
            other.decorators = element.decorators;
          }
          _coalesceGetterSetter(element, other);
        }
      } else {
        newElements.push(element);
      }
    }

    return newElements;
  }

  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {
    return element.decorators && element.decorators.length;
  }

  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {
    return (
      desc !== undefined &&
      !(desc.value === undefined && desc.writable === undefined)
    );
  }

  function _optionalCallableProperty /*::<T>*/(
    obj /*: T */,
    name /*: $Keys<T> */,
  ) /*: ?Function */ {
    var value = obj[name];
    if (value !== undefined && typeof value !== "function") {
      throw new TypeError("Expected '" + name + "' to be a function");
    }
    return value;
  }

`], [`
  import toArray from "toArray";
  import toPropertyKey from "toPropertyKey";

  // These comments are stripped by @babel/template
  /*::
  type PropertyDescriptor =
    | {
        value: any,
        writable: boolean,
        configurable: boolean,
        enumerable: boolean,
      }
    | {
        get?: () => any,
        set?: (v: any) => void,
        configurable: boolean,
        enumerable: boolean,
      };

  type FieldDescriptor ={
    writable: boolean,
    configurable: boolean,
    enumerable: boolean,
  };

  type Placement = "static" | "prototype" | "own";
  type Key = string | symbol; // PrivateName is not supported yet.

  type ElementDescriptor =
    | {
        kind: "method",
        key: Key,
        placement: Placement,
        descriptor: PropertyDescriptor
      }
    | {
        kind: "field",
        key: Key,
        placement: Placement,
        descriptor: FieldDescriptor,
        initializer?: () => any,
      };

  // This is exposed to the user code
  type ElementObjectInput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
  };

  // This is exposed to the user code
  type ElementObjectOutput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
    extras?: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  // This is exposed to the user code
  type ClassObject = {
    [@@toStringTag]?: "Descriptor",
    kind: "class",
    elements: ElementDescriptor[],
  };

  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;
  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;
  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;

  // Only used by Babel in the transform output, not part of the spec.
  type ElementDefinition =
    | {
        kind: "method",
        value: any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
      }
    | {
        kind: "field",
        value: () => any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
    };

  declare function ClassFactory<C>(initialize: (instance: C) => void): {
    F: Class<C>,
    d: ElementDefinition[]
  }

  */

  /*::
  // Various combinations with/without extras and with one or many finishers

  type ElementFinisherExtras = {
    element: ElementDescriptor,
    finisher?: ClassFinisher,
    extras?: ElementDescriptor[],
  };

  type ElementFinishersExtras = {
    element: ElementDescriptor,
    finishers: ClassFinisher[],
    extras: ElementDescriptor[],
  };

  type ElementsFinisher = {
    elements: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  type ElementsFinishers = {
    elements: ElementDescriptor[],
    finishers: ClassFinisher[],
  };

  */

  /*::

  type Placements = {
    static: Key[],
    prototype: Key[],
    own: Key[],
  };

  */

  // ClassDefinitionEvaluation (Steps 26-*)
  export default function _decorate(
    decorators /*: ClassDecorator[] */,
    factory /*: ClassFactory */,
    superClass /*: ?Class<*> */,
    mixins /*: ?Array<Function> */,
  ) /*: Class<*> */ {
    var api = _getDecoratorsApi();
    if (mixins) {
      for (var i = 0; i < mixins.length; i++) {
        api = mixins[i](api);
      }
    }

    var r = factory(function initialize(O) {
      api.initializeInstanceElements(O, decorated.elements);
    }, superClass);
    var decorated = api.decorateClass(
      _coalesceClassElements(r.d.map(_createElementDescriptor)),
      decorators,
    );

    api.initializeClassElements(r.F, decorated.elements);

    return api.runClassFinishers(r.F, decorated.finishers);
  }

  function _getDecoratorsApi() {
    _getDecoratorsApi = function() {
      return api;
    };

    var api = {
      elementsDefinitionOrder: [["method"], ["field"]],

      // InitializeInstanceElements
      initializeInstanceElements: function(
        /*::<C>*/ O /*: C */,
        elements /*: ElementDescriptor[] */,
      ) {
        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            if (element.kind === kind && element.placement === "own") {
              this.defineClassElement(O, element);
            }
          }, this);
        }, this);
      },

      // InitializeClassElements
      initializeClassElements: function(
        /*::<C>*/ F /*: Class<C> */,
        elements /*: ElementDescriptor[] */,
      ) {
        var proto = F.prototype;

        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            var placement = element.placement;
            if (
              element.kind === kind &&
              (placement === "static" || placement === "prototype")
            ) {
              var receiver = placement === "static" ? F : proto;
              this.defineClassElement(receiver, element);
            }
          }, this);
        }, this);
      },

      // DefineClassElement
      defineClassElement: function(
        /*::<C>*/ receiver /*: C | Class<C> */,
        element /*: ElementDescriptor */,
      ) {
        var descriptor /*: PropertyDescriptor */ = element.descriptor;
        if (element.kind === "field") {
          var initializer = element.initializer;
          descriptor = {
            enumerable: descriptor.enumerable,
            writable: descriptor.writable,
            configurable: descriptor.configurable,
            value: initializer === void 0 ? void 0 : initializer.call(receiver),
          };
        }
        Object.defineProperty(receiver, element.key, descriptor);
      },

      // DecorateClass
      decorateClass: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var newElements /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];
        var placements /*: Placements */ = {
          static: [],
          prototype: [],
          own: [],
        };

        elements.forEach(function(element /*: ElementDescriptor */) {
          this.addElementPlacement(element, placements);
        }, this);

        elements.forEach(function(element /*: ElementDescriptor */) {
          if (!_hasDecorators(element)) return newElements.push(element);

          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(
            element,
            placements,
          );
          newElements.push(elementFinishersExtras.element);
          newElements.push.apply(newElements, elementFinishersExtras.extras);
          finishers.push.apply(finishers, elementFinishersExtras.finishers);
        }, this);

        if (!decorators) {
          return { elements: newElements, finishers: finishers };
        }

        var result /*: ElementsFinishers */ = this.decorateConstructor(
          newElements,
          decorators,
        );
        finishers.push.apply(finishers, result.finishers);
        result.finishers = finishers;

        return result;
      },

      // AddElementPlacement
      addElementPlacement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
        silent /*: boolean */,
      ) {
        var keys = placements[element.placement];
        if (!silent && keys.indexOf(element.key) !== -1) {
          throw new TypeError("Duplicated element (" + element.key + ")");
        }
        keys.push(element.key);
      },

      // DecorateElement
      decorateElement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
      ) /*: ElementFinishersExtras */ {
        var extras /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];

        for (
          var decorators = element.decorators, i = decorators.length - 1;
          i >= 0;
          i--
        ) {
          // (inlined) RemoveElementPlacement
          var keys = placements[element.placement];
          keys.splice(keys.indexOf(element.key), 1);

          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(
            element,
          );
          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(
            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||
              elementObject,
          );

          element = elementFinisherExtras.element;
          this.addElementPlacement(element, placements);

          if (elementFinisherExtras.finisher) {
            finishers.push(elementFinisherExtras.finisher);
          }

          var newExtras /*: ElementDescriptor[] | void */ =
            elementFinisherExtras.extras;
          if (newExtras) {
            for (var j = 0; j < newExtras.length; j++) {
              this.addElementPlacement(newExtras[j], placements);
            }
            extras.push.apply(extras, newExtras);
          }
        }

        return { element: element, finishers: finishers, extras: extras };
      },

      // DecorateConstructor
      decorateConstructor: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var finishers /*: ClassFinisher[] */ = [];

        for (var i = decorators.length - 1; i >= 0; i--) {
          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);
          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(
            (0, decorators[i])(obj) /*: ClassObject */ || obj,
          );

          if (elementsAndFinisher.finisher !== undefined) {
            finishers.push(elementsAndFinisher.finisher);
          }

          if (elementsAndFinisher.elements !== undefined) {
            elements = elementsAndFinisher.elements;

            for (var j = 0; j < elements.length - 1; j++) {
              for (var k = j + 1; k < elements.length; k++) {
                if (
                  elements[j].key === elements[k].key &&
                  elements[j].placement === elements[k].placement
                ) {
                  throw new TypeError(
                    "Duplicated element (" + elements[j].key + ")",
                  );
                }
              }
            }
          }
        }

        return { elements: elements, finishers: finishers };
      },

      // FromElementDescriptor
      fromElementDescriptor: function(
        element /*: ElementDescriptor */,
      ) /*: ElementObject */ {
        var obj /*: ElementObject */ = {
          kind: element.kind,
          key: element.key,
          placement: element.placement,
          descriptor: element.descriptor,
        };

        var desc = {
          value: "Descriptor",
          configurable: true,
        };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        if (element.kind === "field") obj.initializer = element.initializer;

        return obj;
      },

      // ToElementDescriptors
      toElementDescriptors: function(
        elementObjects /*: ElementObject[] */,
      ) /*: ElementDescriptor[] */ {
        if (elementObjects === undefined) return;
        return toArray(elementObjects).map(function(elementObject) {
          var element = this.toElementDescriptor(elementObject);
          this.disallowProperty(elementObject, "finisher", "An element descriptor");
          this.disallowProperty(elementObject, "extras", "An element descriptor");
          return element;
        }, this);
      },

      // ToElementDescriptor
      toElementDescriptor: function(
        elementObject /*: ElementObject */,
      ) /*: ElementDescriptor */ {
        var kind = String(elementObject.kind);
        if (kind !== "method" && kind !== "field") {
          throw new TypeError(
            'An element descriptor\\\\'s .kind property must be either "method" or' +
              ' "field", but a decorator created an element descriptor with' +
              ' .kind "' +
              kind +
              '"',
          );
        }

        var key = toPropertyKey(elementObject.key);

        var placement = String(elementObject.placement);
        if (
          placement !== "static" &&
          placement !== "prototype" &&
          placement !== "own"
        ) {
          throw new TypeError(
            'An element descriptor\\\\'s .placement property must be one of "static",' +
              ' "prototype" or "own", but a decorator created an element descriptor' +
              ' with .placement "' +
              placement +
              '"',
          );
        }

        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;

        this.disallowProperty(elementObject, "elements", "An element descriptor");

        var element /*: ElementDescriptor */ = {
          kind: kind,
          key: key,
          placement: placement,
          descriptor: Object.assign({}, descriptor),
        };

        if (kind !== "field") {
          this.disallowProperty(elementObject, "initializer", "A method descriptor");
        } else {
          this.disallowProperty(
            descriptor,
            "get",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "set",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "value",
            "The property descriptor of a field descriptor",
          );

          element.initializer = elementObject.initializer;
        }

        return element;
      },

      toElementFinisherExtras: function(
        elementObject /*: ElementObject */,
      ) /*: ElementFinisherExtras */ {
        var element /*: ElementDescriptor */ = this.toElementDescriptor(
          elementObject,
        );
        var finisher /*: ClassFinisher */ = _optionalCallableProperty(
          elementObject,
          "finisher",
        );
        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(
          elementObject.extras,
        );

        return { element: element, finisher: finisher, extras: extras };
      },

      // FromClassDescriptor
      fromClassDescriptor: function(
        elements /*: ElementDescriptor[] */,
      ) /*: ClassObject */ {
        var obj = {
          kind: "class",
          elements: elements.map(this.fromElementDescriptor, this),
        };

        var desc = { value: "Descriptor", configurable: true };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        return obj;
      },

      // ToClassDescriptor
      toClassDescriptor: function(
        obj /*: ClassObject */,
      ) /*: ElementsFinisher */ {
        var kind = String(obj.kind);
        if (kind !== "class") {
          throw new TypeError(
            'A class descriptor\\\\'s .kind property must be "class", but a decorator' +
              ' created a class descriptor with .kind "' +
              kind +
              '"',
          );
        }

        this.disallowProperty(obj, "key", "A class descriptor");
        this.disallowProperty(obj, "placement", "A class descriptor");
        this.disallowProperty(obj, "descriptor", "A class descriptor");
        this.disallowProperty(obj, "initializer", "A class descriptor");
        this.disallowProperty(obj, "extras", "A class descriptor");

        var finisher = _optionalCallableProperty(obj, "finisher");
        var elements = this.toElementDescriptors(obj.elements);

        return { elements: elements, finisher: finisher };
      },

      // RunClassFinishers
      runClassFinishers: function(
        constructor /*: Class<*> */,
        finishers /*: ClassFinisher[] */,
      ) /*: Class<*> */ {
        for (var i = 0; i < finishers.length; i++) {
          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);
          if (newConstructor !== undefined) {
            // NOTE: This should check if IsConstructor(newConstructor) is false.
            if (typeof newConstructor !== "function") {
              throw new TypeError("Finishers must return a constructor.");
            }
            constructor = newConstructor;
          }
        }
        return constructor;
      },

      disallowProperty: function(obj, name, objectType) {
        if (obj[name] !== undefined) {
          throw new TypeError(objectType + " can't have a ." + name + " property.");
        }
      }
    };

    return api;
  }

  // ClassElementEvaluation
  function _createElementDescriptor(
    def /*: ElementDefinition */,
  ) /*: ElementDescriptor */ {
    var key = toPropertyKey(def.key);

    var descriptor /*: PropertyDescriptor */;
    if (def.kind === "method") {
      descriptor = {
        value: def.value,
        writable: true,
        configurable: true,
        enumerable: false,
      };
    } else if (def.kind === "get") {
      descriptor = { get: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "set") {
      descriptor = { set: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "field") {
      descriptor = { configurable: true, writable: true, enumerable: true };
    }

    var element /*: ElementDescriptor */ = {
      kind: def.kind === "field" ? "field" : "method",
      key: key,
      placement: def.static
        ? "static"
        : def.kind === "field"
        ? "own"
        : "prototype",
      descriptor: descriptor,
    };
    if (def.decorators) element.decorators = def.decorators;
    if (def.kind === "field") element.initializer = def.value;

    return element;
  }

  // CoalesceGetterSetter
  function _coalesceGetterSetter(
    element /*: ElementDescriptor */,
    other /*: ElementDescriptor */,
  ) {
    if (element.descriptor.get !== undefined) {
      other.descriptor.get = element.descriptor.get;
    } else {
      other.descriptor.set = element.descriptor.set;
    }
  }

  // CoalesceClassElements
  function _coalesceClassElements(
    elements /*: ElementDescriptor[] */,
  ) /*: ElementDescriptor[] */ {
    var newElements /*: ElementDescriptor[] */ = [];

    var isSameElement = function(
      other /*: ElementDescriptor */,
    ) /*: boolean */ {
      return (
        other.kind === "method" &&
        other.key === element.key &&
        other.placement === element.placement
      );
    };

    for (var i = 0; i < elements.length; i++) {
      var element /*: ElementDescriptor */ = elements[i];
      var other /*: ElementDescriptor */;

      if (
        element.kind === "method" &&
        (other = newElements.find(isSameElement))
      ) {
        if (
          _isDataDescriptor(element.descriptor) ||
          _isDataDescriptor(other.descriptor)
        ) {
          if (_hasDecorators(element) || _hasDecorators(other)) {
            throw new ReferenceError(
              "Duplicated methods (" + element.key + ") can't be decorated.",
            );
          }
          other.descriptor = element.descriptor;
        } else {
          if (_hasDecorators(element)) {
            if (_hasDecorators(other)) {
              throw new ReferenceError(
                "Decorators can't be placed on different accessors with for " +
                  "the same property (" +
                  element.key +
                  ").",
              );
            }
            other.decorators = element.decorators;
          }
          _coalesceGetterSetter(element, other);
        }
      } else {
        newElements.push(element);
      }
    }

    return newElements;
  }

  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {
    return element.decorators && element.decorators.length;
  }

  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {
    return (
      desc !== undefined &&
      !(desc.value === undefined && desc.writable === undefined)
    );
  }

  function _optionalCallableProperty /*::<T>*/(
    obj /*: T */,
    name /*: $Keys<T> */,
  ) /*: ?Function */ {
    var value = obj[name];
    if (value !== undefined && typeof value !== "function") {
      throw new TypeError("Expected '" + name + "' to be a function");
    }
    return value;
  }

`])));
    helpers$1.classPrivateMethodGet = helper$2("7.1.6")(_templateObject82 || (_templateObject82 = _taggedTemplateLiteralLoose(['\n  export default function _classPrivateMethodGet(receiver, privateSet, fn) {\n    if (!privateSet.has(receiver)) {\n      throw new TypeError("attempted to get private field on non-instance");\n    }\n    return fn;\n  }\n'])));
    helpers$1.checkPrivateRedeclaration = helper$2("7.14.1")(_templateObject83 || (_templateObject83 = _taggedTemplateLiteralLoose(['\n  export default function _checkPrivateRedeclaration(obj, privateCollection) {\n    if (privateCollection.has(obj)) {\n      throw new TypeError("Cannot initialize the same private elements twice on an object");\n    }\n  }\n'])));
    helpers$1.classPrivateFieldInitSpec = helper$2("7.14.1")(_templateObject84 || (_templateObject84 = _taggedTemplateLiteralLoose(['\n  import checkPrivateRedeclaration from "checkPrivateRedeclaration";\n\n  export default function _classPrivateFieldInitSpec(obj, privateMap, value) {\n    checkPrivateRedeclaration(obj, privateMap);\n    privateMap.set(obj, value);\n  }\n'])));
    helpers$1.classPrivateMethodInitSpec = helper$2("7.14.1")(_templateObject85 || (_templateObject85 = _taggedTemplateLiteralLoose(['\n  import checkPrivateRedeclaration from "checkPrivateRedeclaration";\n\n  export default function _classPrivateMethodInitSpec(obj, privateSet) {\n    checkPrivateRedeclaration(obj, privateSet);\n    privateSet.add(obj);\n  }\n'])));
    {
      helpers$1.classPrivateMethodSet = helper$2("7.1.6")(_templateObject86 || (_templateObject86 = _taggedTemplateLiteralLoose(['\n    export default function _classPrivateMethodSet() {\n      throw new TypeError("attempted to reassign private method");\n    }\n  '])));
    }
    helpers$1.identity = helper$2("7.17.0")(_templateObject87 || (_templateObject87 = _taggedTemplateLiteralLoose(["\n  export default function _identity(x) {\n    return x;\n  }\n"])));
    var assignmentExpression$7 = assignmentExpression$c, cloneNode$a = cloneNode$i, expressionStatement$4 = expressionStatement$a, file$1 = file$2, identifier$a = identifier$j;
    function makePath2(path2) {
      var parts = [];
      for (; path2.parentPath; path2 = path2.parentPath) {
        parts.push(path2.key);
        if (path2.inList)
          parts.push(path2.listKey);
      }
      return parts.reverse().join(".");
    }
    var FileClass = void 0;
    function getHelperMetadata(file2) {
      var globals2 = /* @__PURE__ */ new Set();
      var localBindingNames = /* @__PURE__ */ new Set();
      var dependencies2 = /* @__PURE__ */ new Map();
      var exportName;
      var exportPath;
      var exportBindingAssignments = [];
      var importPaths = [];
      var importBindingsReferences = [];
      var dependencyVisitor = {
        ImportDeclaration: function ImportDeclaration2(child) {
          var name2 = child.node.source.value;
          if (!helpers$1[name2]) {
            throw child.buildCodeFrameError("Unknown helper " + name2);
          }
          if (child.get("specifiers").length !== 1 || !child.get("specifiers.0").isImportDefaultSpecifier()) {
            throw child.buildCodeFrameError("Helpers can only import a default value");
          }
          var bindingIdentifier = child.node.specifiers[0].local;
          dependencies2.set(bindingIdentifier, name2);
          importPaths.push(makePath2(child));
        },
        ExportDefaultDeclaration: function ExportDefaultDeclaration2(child) {
          var decl = child.get("declaration");
          if (!decl.isFunctionDeclaration() || !decl.node.id) {
            throw decl.buildCodeFrameError("Helpers can only export named function declarations");
          }
          exportName = decl.node.id.name;
          exportPath = makePath2(child);
        },
        ExportAllDeclaration: function ExportAllDeclaration2(child) {
          throw child.buildCodeFrameError("Helpers can only export default");
        },
        ExportNamedDeclaration: function ExportNamedDeclaration2(child) {
          throw child.buildCodeFrameError("Helpers can only export default");
        },
        Statement: function Statement2(child) {
          if (child.isModuleDeclaration())
            return;
          child.skip();
        }
      };
      var referenceVisitor2 = {
        Program: function Program2(path2) {
          var bindings = path2.scope.getAllBindings();
          Object.keys(bindings).forEach(function(name2) {
            if (name2 === exportName)
              return;
            if (dependencies2.has(bindings[name2].identifier))
              return;
            localBindingNames.add(name2);
          });
        },
        ReferencedIdentifier: function ReferencedIdentifier2(child) {
          var name2 = child.node.name;
          var binding2 = child.scope.getBinding(name2);
          if (!binding2) {
            globals2.add(name2);
          } else if (dependencies2.has(binding2.identifier)) {
            importBindingsReferences.push(makePath2(child));
          }
        },
        AssignmentExpression: function AssignmentExpression2(child) {
          var left = child.get("left");
          if (!(exportName in left.getBindingIdentifiers()))
            return;
          if (!left.isIdentifier()) {
            throw left.buildCodeFrameError("Only simple assignments to exports are allowed in helpers");
          }
          var binding2 = child.scope.getBinding(exportName);
          if (binding2 != null && binding2.scope.path.isProgram()) {
            exportBindingAssignments.push(makePath2(child));
          }
        }
      };
      traverse(file2.ast, dependencyVisitor, file2.scope);
      traverse(file2.ast, referenceVisitor2, file2.scope);
      if (!exportPath)
        throw new Error("Helpers must have a default export.");
      exportBindingAssignments.reverse();
      return {
        globals: Array.from(globals2),
        localBindingNames: Array.from(localBindingNames),
        dependencies: dependencies2,
        exportBindingAssignments,
        exportPath,
        exportName,
        importBindingsReferences,
        importPaths
      };
    }
    function permuteHelperAST(file2, metadata, id3, localBindings, getDependency) {
      if (localBindings && !id3) {
        throw new Error("Unexpected local bindings for module-based helpers.");
      }
      if (!id3)
        return;
      var localBindingNames = metadata.localBindingNames, dependencies2 = metadata.dependencies, exportBindingAssignments = metadata.exportBindingAssignments, exportPath = metadata.exportPath, exportName = metadata.exportName, importBindingsReferences = metadata.importBindingsReferences, importPaths = metadata.importPaths;
      var dependenciesRefs = {};
      dependencies2.forEach(function(name2, id4) {
        dependenciesRefs[id4.name] = typeof getDependency === "function" && getDependency(name2) || id4;
      });
      var toRename = {};
      var bindings = new Set(localBindings || []);
      localBindingNames.forEach(function(name2) {
        var newName = name2;
        while (bindings.has(newName)) {
          newName = "_" + newName;
        }
        if (newName !== name2)
          toRename[name2] = newName;
      });
      if (id3.type === "Identifier" && exportName !== id3.name) {
        toRename[exportName] = id3.name;
      }
      var path2 = file2.path;
      var exp = path2.get(exportPath);
      var imps = importPaths.map(function(p2) {
        return path2.get(p2);
      });
      var impsBindingRefs = importBindingsReferences.map(function(p2) {
        return path2.get(p2);
      });
      var decl = exp.get("declaration");
      if (id3.type === "Identifier") {
        exp.replaceWith(decl);
      } else if (id3.type === "MemberExpression") {
        exportBindingAssignments.forEach(function(assignPath) {
          var assign = path2.get(assignPath);
          assign.replaceWith(assignmentExpression$7("=", id3, assign.node));
        });
        exp.replaceWith(decl);
        path2.pushContainer("body", expressionStatement$4(assignmentExpression$7("=", id3, identifier$a(exportName))));
      } else {
        throw new Error("Unexpected helper format.");
      }
      Object.keys(toRename).forEach(function(name2) {
        path2.scope.rename(name2, toRename[name2]);
      });
      for (var _iterator2 = _createForOfIteratorHelperLoose(imps), _step2; !(_step2 = _iterator2()).done; ) {
        var _path = _step2.value;
        _path.remove();
      }
      for (var _iterator22 = _createForOfIteratorHelperLoose(impsBindingRefs), _step22; !(_step22 = _iterator22()).done; ) {
        var _path2 = _step22.value;
        var node2 = cloneNode$a(dependenciesRefs[_path2.node.name]);
        _path2.replaceWith(node2);
      }
    }
    var helperData = /* @__PURE__ */ Object.create(null);
    function loadHelper(name2) {
      if (!helperData[name2]) {
        var helper2 = helpers$1[name2];
        if (!helper2) {
          throw Object.assign(new ReferenceError("Unknown helper " + name2), {
            code: "BABEL_HELPER_UNKNOWN",
            helper: name2
          });
        }
        var fn = function fn2() {
          {
            if (!FileClass) {
              var fakeFile = {
                ast: file$1(helper2.ast()),
                path: null
              };
              traverse(fakeFile.ast, {
                Program: function Program2(path2) {
                  return (fakeFile.path = path2).stop();
                }
              });
              return fakeFile;
            }
          }
          return new FileClass({
            filename: "babel-helper://" + name2
          }, {
            ast: file$1(helper2.ast()),
            code: "[internal Babel helper code]",
            inputMap: null
          });
        };
        var metadata = null;
        helperData[name2] = {
          minVersion: helper2.minVersion,
          build: function build2(getDependency, id3, localBindings) {
            var file2 = fn();
            metadata || (metadata = getHelperMetadata(file2));
            permuteHelperAST(file2, metadata, id3, localBindings, getDependency);
            return {
              nodes: file2.ast.program.body,
              globals: metadata.globals
            };
          },
          getDependencies: function getDependencies3() {
            metadata || (metadata = getHelperMetadata(fn()));
            return Array.from(metadata.dependencies.values());
          }
        };
      }
      return helperData[name2];
    }
    function get$12(name2, getDependency, id3, localBindings) {
      return loadHelper(name2).build(getDependency, id3, localBindings);
    }
    function minVersion(name2) {
      return loadHelper(name2).minVersion;
    }
    function getDependencies2(name2) {
      return loadHelper(name2).getDependencies();
    }
    function ensure(name2, newFileClass) {
      FileClass || (FileClass = newFileClass);
      loadHelper(name2);
    }
    var list = Object.keys(helpers$1).map(function(name2) {
      return name2.replace(/^_/, "");
    });
    var assert$1 = { exports: {} };
    /*
    object-assign
    (c) Sindre Sorhus
    @license MIT
    */
    var getOwnPropertySymbols2 = Object.getOwnPropertySymbols;
    var hasOwnProperty$12 = Object.prototype.hasOwnProperty;
    var propIsEnumerable2 = Object.prototype.propertyIsEnumerable;
    function toObject2(val) {
      if (val === null || val === void 0) {
        throw new TypeError("Object.assign cannot be called with null or undefined");
      }
      return Object(val);
    }
    function shouldUseNative2() {
      try {
        if (!Object.assign) {
          return false;
        }
        var test1 = new String("abc");
        test1[5] = "de";
        if (Object.getOwnPropertyNames(test1)[0] === "5") {
          return false;
        }
        var test2 = {};
        for (var i2 = 0; i2 < 10; i2++) {
          test2["_" + String.fromCharCode(i2)] = i2;
        }
        var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
          return test2[n2];
        });
        if (order2.join("") !== "0123456789") {
          return false;
        }
        var test3 = {};
        "abcdefghijklmnopqrst".split("").forEach(function(letter) {
          test3[letter] = letter;
        });
        if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
          return false;
        }
        return true;
      } catch (err) {
        return false;
      }
    }
    var objectAssign$1 = shouldUseNative2() ? Object.assign : function(target, source) {
      var from2;
      var to = toObject2(target);
      var symbols;
      for (var s = 1; s < arguments.length; s++) {
        from2 = Object(arguments[s]);
        for (var key2 in from2) {
          if (hasOwnProperty$12.call(from2, key2)) {
            to[key2] = from2[key2];
          }
        }
        if (getOwnPropertySymbols2) {
          symbols = getOwnPropertySymbols2(from2);
          for (var i2 = 0; i2 < symbols.length; i2++) {
            if (propIsEnumerable2.call(from2, symbols[i2])) {
              to[symbols[i2]] = from2[symbols[i2]];
            }
          }
        }
      }
      return to;
    };
    var util$32 = {};
    var isBufferBrowser = function isBuffer3(arg) {
      return arg && typeof arg === "object" && typeof arg.copy === "function" && typeof arg.fill === "function" && typeof arg.readUInt8 === "function";
    };
    var inherits_browser = { exports: {} };
    if (typeof Object.create === "function") {
      inherits_browser.exports = function inherits3(ctor, superCtor) {
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      };
    } else {
      inherits_browser.exports = function inherits3(ctor, superCtor) {
        ctor.super_ = superCtor;
        var TempCtor = function TempCtor2() {
        };
        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      };
    }
    (function(exports3) {
      var formatRegExp2 = /%[sdj%]/g;
      exports3.format = function(f2) {
        if (!isString2(f2)) {
          var objects = [];
          for (var i2 = 0; i2 < arguments.length; i2++) {
            objects.push(inspect2(arguments[i2]));
          }
          return objects.join(" ");
        }
        var i2 = 1;
        var args = arguments;
        var len3 = args.length;
        var str = String(f2).replace(formatRegExp2, function(x3) {
          if (x3 === "%%")
            return "%";
          if (i2 >= len3)
            return x3;
          switch (x3) {
            case "%s":
              return String(args[i2++]);
            case "%d":
              return Number(args[i2++]);
            case "%j":
              try {
                return JSON.stringify(args[i2++]);
              } catch (_) {
                return "[Circular]";
              }
            default:
              return x3;
          }
        });
        for (var x2 = args[i2]; i2 < len3; x2 = args[++i2]) {
          if (isNull(x2) || !isObject2(x2)) {
            str += " " + x2;
          } else {
            str += " " + inspect2(x2);
          }
        }
        return str;
      };
      exports3.deprecate = function(fn, msg2) {
        if (isUndefined(commonjsGlobal$1.process)) {
          return function() {
            return exports3.deprecate(fn, msg2).apply(this, arguments);
          };
        }
        if (browser$1$1.noDeprecation === true) {
          return fn;
        }
        var warned2 = false;
        function deprecated() {
          if (!warned2) {
            if (browser$1$1.throwDeprecation) {
              throw new Error(msg2);
            } else if (browser$1$1.traceDeprecation) {
              console.trace(msg2);
            } else {
              console.error(msg2);
            }
            warned2 = true;
          }
          return fn.apply(this, arguments);
        }
        return deprecated;
      };
      var debugs = {};
      var debugEnviron;
      exports3.debuglog = function(set3) {
        if (isUndefined(debugEnviron))
          debugEnviron = browser$1$1.env.NODE_DEBUG || "";
        set3 = set3.toUpperCase();
        if (!debugs[set3]) {
          if (new RegExp("\\b" + set3 + "\\b", "i").test(debugEnviron)) {
            var pid = browser$1$1.pid;
            debugs[set3] = function() {
              var msg2 = exports3.format.apply(exports3, arguments);
              console.error("%s %d: %s", set3, pid, msg2);
            };
          } else {
            debugs[set3] = function() {
            };
          }
        }
        return debugs[set3];
      };
      function inspect2(obj, opts) {
        var ctx = {
          seen: [],
          stylize: stylizeNoColor
        };
        if (arguments.length >= 3)
          ctx.depth = arguments[2];
        if (arguments.length >= 4)
          ctx.colors = arguments[3];
        if (isBoolean(opts)) {
          ctx.showHidden = opts;
        } else if (opts) {
          exports3._extend(ctx, opts);
        }
        if (isUndefined(ctx.showHidden))
          ctx.showHidden = false;
        if (isUndefined(ctx.depth))
          ctx.depth = 2;
        if (isUndefined(ctx.colors))
          ctx.colors = false;
        if (isUndefined(ctx.customInspect))
          ctx.customInspect = true;
        if (ctx.colors)
          ctx.stylize = stylizeWithColor;
        return formatValue(ctx, obj, ctx.depth);
      }
      exports3.inspect = inspect2;
      inspect2.colors = {
        "bold": [1, 22],
        "italic": [3, 23],
        "underline": [4, 24],
        "inverse": [7, 27],
        "white": [37, 39],
        "grey": [90, 39],
        "black": [30, 39],
        "blue": [34, 39],
        "cyan": [36, 39],
        "green": [32, 39],
        "magenta": [35, 39],
        "red": [31, 39],
        "yellow": [33, 39]
      };
      inspect2.styles = {
        "special": "cyan",
        "number": "yellow",
        "boolean": "yellow",
        "undefined": "grey",
        "null": "bold",
        "string": "green",
        "date": "magenta",
        "regexp": "red"
      };
      function stylizeWithColor(str, styleType) {
        var style2 = inspect2.styles[styleType];
        if (style2) {
          return "\x1B[" + inspect2.colors[style2][0] + "m" + str + "\x1B[" + inspect2.colors[style2][1] + "m";
        } else {
          return str;
        }
      }
      function stylizeNoColor(str, styleType) {
        return str;
      }
      function arrayToHash(array4) {
        var hash = {};
        array4.forEach(function(val, idx) {
          hash[val] = true;
        });
        return hash;
      }
      function formatValue(ctx, value, recurseTimes) {
        if (ctx.customInspect && value && isFunction3(value.inspect) && value.inspect !== exports3.inspect && !(value.constructor && value.constructor.prototype === value)) {
          var ret = value.inspect(recurseTimes, ctx);
          if (!isString2(ret)) {
            ret = formatValue(ctx, ret, recurseTimes);
          }
          return ret;
        }
        var primitive = formatPrimitive(ctx, value);
        if (primitive) {
          return primitive;
        }
        var keys2 = Object.keys(value);
        var visibleKeys = arrayToHash(keys2);
        if (ctx.showHidden) {
          keys2 = Object.getOwnPropertyNames(value);
        }
        if (isError(value) && (keys2.indexOf("message") >= 0 || keys2.indexOf("description") >= 0)) {
          return formatError(value);
        }
        if (keys2.length === 0) {
          if (isFunction3(value)) {
            var name2 = value.name ? ": " + value.name : "";
            return ctx.stylize("[Function" + name2 + "]", "special");
          }
          if (isRegExp3(value)) {
            return ctx.stylize(RegExp.prototype.toString.call(value), "regexp");
          }
          if (isDate(value)) {
            return ctx.stylize(Date.prototype.toString.call(value), "date");
          }
          if (isError(value)) {
            return formatError(value);
          }
        }
        var base2 = "", array4 = false, braces = ["{", "}"];
        if (isArray3(value)) {
          array4 = true;
          braces = ["[", "]"];
        }
        if (isFunction3(value)) {
          var n2 = value.name ? ": " + value.name : "";
          base2 = " [Function" + n2 + "]";
        }
        if (isRegExp3(value)) {
          base2 = " " + RegExp.prototype.toString.call(value);
        }
        if (isDate(value)) {
          base2 = " " + Date.prototype.toUTCString.call(value);
        }
        if (isError(value)) {
          base2 = " " + formatError(value);
        }
        if (keys2.length === 0 && (!array4 || value.length == 0)) {
          return braces[0] + base2 + braces[1];
        }
        if (recurseTimes < 0) {
          if (isRegExp3(value)) {
            return ctx.stylize(RegExp.prototype.toString.call(value), "regexp");
          } else {
            return ctx.stylize("[Object]", "special");
          }
        }
        ctx.seen.push(value);
        var output;
        if (array4) {
          output = formatArray(ctx, value, recurseTimes, visibleKeys, keys2);
        } else {
          output = keys2.map(function(key2) {
            return formatProperty(ctx, value, recurseTimes, visibleKeys, key2, array4);
          });
        }
        ctx.seen.pop();
        return reduceToSingleString(output, base2, braces);
      }
      function formatPrimitive(ctx, value) {
        if (isUndefined(value))
          return ctx.stylize("undefined", "undefined");
        if (isString2(value)) {
          var simple = "'" + JSON.stringify(value).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
          return ctx.stylize(simple, "string");
        }
        if (isNumber2(value))
          return ctx.stylize("" + value, "number");
        if (isBoolean(value))
          return ctx.stylize("" + value, "boolean");
        if (isNull(value))
          return ctx.stylize("null", "null");
      }
      function formatError(value) {
        return "[" + Error.prototype.toString.call(value) + "]";
      }
      function formatArray(ctx, value, recurseTimes, visibleKeys, keys2) {
        var output = [];
        for (var i2 = 0, l2 = value.length; i2 < l2; ++i2) {
          if (hasOwnProperty2(value, String(i2))) {
            output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, String(i2), true));
          } else {
            output.push("");
          }
        }
        keys2.forEach(function(key2) {
          if (!key2.match(/^\d+$/)) {
            output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, key2, true));
          }
        });
        return output;
      }
      function formatProperty(ctx, value, recurseTimes, visibleKeys, key2, array4) {
        var name2, str, desc;
        desc = Object.getOwnPropertyDescriptor(value, key2) || {
          value: value[key2]
        };
        if (desc.get) {
          if (desc.set) {
            str = ctx.stylize("[Getter/Setter]", "special");
          } else {
            str = ctx.stylize("[Getter]", "special");
          }
        } else {
          if (desc.set) {
            str = ctx.stylize("[Setter]", "special");
          }
        }
        if (!hasOwnProperty2(visibleKeys, key2)) {
          name2 = "[" + key2 + "]";
        }
        if (!str) {
          if (ctx.seen.indexOf(desc.value) < 0) {
            if (isNull(recurseTimes)) {
              str = formatValue(ctx, desc.value, null);
            } else {
              str = formatValue(ctx, desc.value, recurseTimes - 1);
            }
            if (str.indexOf("\n") > -1) {
              if (array4) {
                str = str.split("\n").map(function(line) {
                  return "  " + line;
                }).join("\n").substr(2);
              } else {
                str = "\n" + str.split("\n").map(function(line) {
                  return "   " + line;
                }).join("\n");
              }
            }
          } else {
            str = ctx.stylize("[Circular]", "special");
          }
        }
        if (isUndefined(name2)) {
          if (array4 && key2.match(/^\d+$/)) {
            return str;
          }
          name2 = JSON.stringify("" + key2);
          if (name2.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
            name2 = name2.substr(1, name2.length - 2);
            name2 = ctx.stylize(name2, "name");
          } else {
            name2 = name2.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
            name2 = ctx.stylize(name2, "string");
          }
        }
        return name2 + ": " + str;
      }
      function reduceToSingleString(output, base2, braces) {
        var length = output.reduce(function(prev, cur) {
          if (cur.indexOf("\n") >= 0)
            ;
          return prev + cur.replace(/\u001b\[\d\d?m/g, "").length + 1;
        }, 0);
        if (length > 60) {
          return braces[0] + (base2 === "" ? "" : base2 + "\n ") + " " + output.join(",\n  ") + " " + braces[1];
        }
        return braces[0] + base2 + " " + output.join(", ") + " " + braces[1];
      }
      function isArray3(ar) {
        return Array.isArray(ar);
      }
      exports3.isArray = isArray3;
      function isBoolean(arg) {
        return typeof arg === "boolean";
      }
      exports3.isBoolean = isBoolean;
      function isNull(arg) {
        return arg === null;
      }
      exports3.isNull = isNull;
      function isNullOrUndefined(arg) {
        return arg == null;
      }
      exports3.isNullOrUndefined = isNullOrUndefined;
      function isNumber2(arg) {
        return typeof arg === "number";
      }
      exports3.isNumber = isNumber2;
      function isString2(arg) {
        return typeof arg === "string";
      }
      exports3.isString = isString2;
      function isSymbol(arg) {
        return typeof arg === "symbol";
      }
      exports3.isSymbol = isSymbol;
      function isUndefined(arg) {
        return arg === void 0;
      }
      exports3.isUndefined = isUndefined;
      function isRegExp3(re3) {
        return isObject2(re3) && objectToString3(re3) === "[object RegExp]";
      }
      exports3.isRegExp = isRegExp3;
      function isObject2(arg) {
        return typeof arg === "object" && arg !== null;
      }
      exports3.isObject = isObject2;
      function isDate(d2) {
        return isObject2(d2) && objectToString3(d2) === "[object Date]";
      }
      exports3.isDate = isDate;
      function isError(e2) {
        return isObject2(e2) && (objectToString3(e2) === "[object Error]" || e2 instanceof Error);
      }
      exports3.isError = isError;
      function isFunction3(arg) {
        return typeof arg === "function";
      }
      exports3.isFunction = isFunction3;
      function isPrimitive2(arg) {
        return arg === null || typeof arg === "boolean" || typeof arg === "number" || typeof arg === "string" || typeof arg === "symbol" || typeof arg === "undefined";
      }
      exports3.isPrimitive = isPrimitive2;
      exports3.isBuffer = isBufferBrowser;
      function objectToString3(o) {
        return Object.prototype.toString.call(o);
      }
      function pad3(n2) {
        return n2 < 10 ? "0" + n2.toString(10) : n2.toString(10);
      }
      var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
      function timestamp() {
        var d2 = new Date();
        var time = [pad3(d2.getHours()), pad3(d2.getMinutes()), pad3(d2.getSeconds())].join(":");
        return [d2.getDate(), months[d2.getMonth()], time].join(" ");
      }
      exports3.log = function() {
        console.log("%s - %s", timestamp(), exports3.format.apply(exports3, arguments));
      };
      exports3.inherits = inherits_browser.exports;
      exports3._extend = function(origin, add2) {
        if (!add2 || !isObject2(add2))
          return origin;
        var keys2 = Object.keys(add2);
        var i2 = keys2.length;
        while (i2--) {
          origin[keys2[i2]] = add2[keys2[i2]];
        }
        return origin;
      };
      function hasOwnProperty2(obj, prop2) {
        return Object.prototype.hasOwnProperty.call(obj, prop2);
      }
    })(util$32);
    var objectAssign2 = objectAssign$1;
    /*!
     * The buffer module from node.js, for the browser.
     *
     * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
     * @license  MIT
     */
    function compare$a(a, b2) {
      if (a === b2) {
        return 0;
      }
      var x2 = a.length;
      var y2 = b2.length;
      for (var i2 = 0, len3 = Math.min(x2, y2); i2 < len3; ++i2) {
        if (a[i2] !== b2[i2]) {
          x2 = a[i2];
          y2 = b2[i2];
          break;
        }
      }
      if (x2 < y2) {
        return -1;
      }
      if (y2 < x2) {
        return 1;
      }
      return 0;
    }
    function isBuffer2(b2) {
      if (commonjsGlobal$1.Buffer && typeof commonjsGlobal$1.Buffer.isBuffer === "function") {
        return commonjsGlobal$1.Buffer.isBuffer(b2);
      }
      return !!(b2 != null && b2._isBuffer);
    }
    var util$22 = util$32;
    var hasOwn2 = Object.prototype.hasOwnProperty;
    var pSlice = Array.prototype.slice;
    var functionsHaveNames = function() {
      return function foo() {
      }.name === "foo";
    }();
    function pToString(obj) {
      return Object.prototype.toString.call(obj);
    }
    function isView(arrbuf) {
      if (isBuffer2(arrbuf)) {
        return false;
      }
      if (typeof commonjsGlobal$1.ArrayBuffer !== "function") {
        return false;
      }
      if (typeof ArrayBuffer.isView === "function") {
        return ArrayBuffer.isView(arrbuf);
      }
      if (!arrbuf) {
        return false;
      }
      if (arrbuf instanceof DataView) {
        return true;
      }
      if (arrbuf.buffer && arrbuf.buffer instanceof ArrayBuffer) {
        return true;
      }
      return false;
    }
    var assert2 = assert$1.exports = ok2;
    var regex = /\s*function\s+([^\(\s]*)\s*/;
    function getName$1(func) {
      if (!util$22.isFunction(func)) {
        return;
      }
      if (functionsHaveNames) {
        return func.name;
      }
      var str = func.toString();
      var match = str.match(regex);
      return match && match[1];
    }
    assert2.AssertionError = function AssertionError(options) {
      this.name = "AssertionError";
      this.actual = options.actual;
      this.expected = options.expected;
      this.operator = options.operator;
      if (options.message) {
        this.message = options.message;
        this.generatedMessage = false;
      } else {
        this.message = getMessage(this);
        this.generatedMessage = true;
      }
      var stackStartFunction = options.stackStartFunction || fail;
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, stackStartFunction);
      } else {
        var err = new Error();
        if (err.stack) {
          var out2 = err.stack;
          var fn_name = getName$1(stackStartFunction);
          var idx = out2.indexOf("\n" + fn_name);
          if (idx >= 0) {
            var next_line = out2.indexOf("\n", idx + 1);
            out2 = out2.substring(next_line + 1);
          }
          this.stack = out2;
        }
      }
    };
    util$22.inherits(assert2.AssertionError, Error);
    function truncate(s, n2) {
      if (typeof s === "string") {
        return s.length < n2 ? s : s.slice(0, n2);
      } else {
        return s;
      }
    }
    function inspect(something) {
      if (functionsHaveNames || !util$22.isFunction(something)) {
        return util$22.inspect(something);
      }
      var rawname = getName$1(something);
      var name2 = rawname ? ": " + rawname : "";
      return "[Function" + name2 + "]";
    }
    function getMessage(self2) {
      return truncate(inspect(self2.actual), 128) + " " + self2.operator + " " + truncate(inspect(self2.expected), 128);
    }
    function fail(actual, expected, message, operator, stackStartFunction) {
      throw new assert2.AssertionError({
        message,
        actual,
        expected,
        operator,
        stackStartFunction
      });
    }
    assert2.fail = fail;
    function ok2(value, message) {
      if (!value)
        fail(value, true, message, "==", assert2.ok);
    }
    assert2.ok = ok2;
    assert2.equal = function equal(actual, expected, message) {
      if (actual != expected)
        fail(actual, expected, message, "==", assert2.equal);
    };
    assert2.notEqual = function notEqual(actual, expected, message) {
      if (actual == expected) {
        fail(actual, expected, message, "!=", assert2.notEqual);
      }
    };
    assert2.deepEqual = function deepEqual(actual, expected, message) {
      if (!_deepEqual(actual, expected, false)) {
        fail(actual, expected, message, "deepEqual", assert2.deepEqual);
      }
    };
    assert2.deepStrictEqual = function deepStrictEqual(actual, expected, message) {
      if (!_deepEqual(actual, expected, true)) {
        fail(actual, expected, message, "deepStrictEqual", assert2.deepStrictEqual);
      }
    };
    function _deepEqual(actual, expected, strict2, memos) {
      if (actual === expected) {
        return true;
      } else if (isBuffer2(actual) && isBuffer2(expected)) {
        return compare$a(actual, expected) === 0;
      } else if (util$22.isDate(actual) && util$22.isDate(expected)) {
        return actual.getTime() === expected.getTime();
      } else if (util$22.isRegExp(actual) && util$22.isRegExp(expected)) {
        return actual.source === expected.source && actual.global === expected.global && actual.multiline === expected.multiline && actual.lastIndex === expected.lastIndex && actual.ignoreCase === expected.ignoreCase;
      } else if ((actual === null || typeof actual !== "object") && (expected === null || typeof expected !== "object")) {
        return strict2 ? actual === expected : actual == expected;
      } else if (isView(actual) && isView(expected) && pToString(actual) === pToString(expected) && !(actual instanceof Float32Array || actual instanceof Float64Array)) {
        return compare$a(new Uint8Array(actual.buffer), new Uint8Array(expected.buffer)) === 0;
      } else if (isBuffer2(actual) !== isBuffer2(expected)) {
        return false;
      } else {
        memos = memos || {
          actual: [],
          expected: []
        };
        var actualIndex = memos.actual.indexOf(actual);
        if (actualIndex !== -1) {
          if (actualIndex === memos.expected.indexOf(expected)) {
            return true;
          }
        }
        memos.actual.push(actual);
        memos.expected.push(expected);
        return objEquiv(actual, expected, strict2, memos);
      }
    }
    function isArguments2(object4) {
      return Object.prototype.toString.call(object4) == "[object Arguments]";
    }
    function objEquiv(a, b2, strict2, actualVisitedObjects) {
      if (a === null || a === void 0 || b2 === null || b2 === void 0)
        return false;
      if (util$22.isPrimitive(a) || util$22.isPrimitive(b2))
        return a === b2;
      if (strict2 && Object.getPrototypeOf(a) !== Object.getPrototypeOf(b2))
        return false;
      var aIsArgs = isArguments2(a);
      var bIsArgs = isArguments2(b2);
      if (aIsArgs && !bIsArgs || !aIsArgs && bIsArgs)
        return false;
      if (aIsArgs) {
        a = pSlice.call(a);
        b2 = pSlice.call(b2);
        return _deepEqual(a, b2, strict2);
      }
      var ka2 = objectKeys(a);
      var kb2 = objectKeys(b2);
      var key2, i2;
      if (ka2.length !== kb2.length)
        return false;
      ka2.sort();
      kb2.sort();
      for (i2 = ka2.length - 1; i2 >= 0; i2--) {
        if (ka2[i2] !== kb2[i2])
          return false;
      }
      for (i2 = ka2.length - 1; i2 >= 0; i2--) {
        key2 = ka2[i2];
        if (!_deepEqual(a[key2], b2[key2], strict2, actualVisitedObjects))
          return false;
      }
      return true;
    }
    assert2.notDeepEqual = function notDeepEqual(actual, expected, message) {
      if (_deepEqual(actual, expected, false)) {
        fail(actual, expected, message, "notDeepEqual", assert2.notDeepEqual);
      }
    };
    assert2.notDeepStrictEqual = notDeepStrictEqual;
    function notDeepStrictEqual(actual, expected, message) {
      if (_deepEqual(actual, expected, true)) {
        fail(actual, expected, message, "notDeepStrictEqual", notDeepStrictEqual);
      }
    }
    assert2.strictEqual = function strictEqual(actual, expected, message) {
      if (actual !== expected) {
        fail(actual, expected, message, "===", assert2.strictEqual);
      }
    };
    assert2.notStrictEqual = function notStrictEqual(actual, expected, message) {
      if (actual === expected) {
        fail(actual, expected, message, "!==", assert2.notStrictEqual);
      }
    };
    function expectedException(actual, expected) {
      if (!actual || !expected) {
        return false;
      }
      if (Object.prototype.toString.call(expected) == "[object RegExp]") {
        return expected.test(actual);
      }
      try {
        if (actual instanceof expected) {
          return true;
        }
      } catch (e2) {
      }
      if (Error.isPrototypeOf(expected)) {
        return false;
      }
      return expected.call({}, actual) === true;
    }
    function _tryBlock(block) {
      var error2;
      try {
        block();
      } catch (e2) {
        error2 = e2;
      }
      return error2;
    }
    function _throws(shouldThrow, block, expected, message) {
      var actual;
      if (typeof block !== "function") {
        throw new TypeError('"block" argument must be a function');
      }
      if (typeof expected === "string") {
        message = expected;
        expected = null;
      }
      actual = _tryBlock(block);
      message = (expected && expected.name ? " (" + expected.name + ")." : ".") + (message ? " " + message : ".");
      if (shouldThrow && !actual) {
        fail(actual, expected, "Missing expected exception" + message);
      }
      var userProvidedMessage = typeof message === "string";
      var isUnwantedException = !shouldThrow && util$22.isError(actual);
      var isUnexpectedException = !shouldThrow && actual && !expected;
      if (isUnwantedException && userProvidedMessage && expectedException(actual, expected) || isUnexpectedException) {
        fail(actual, expected, "Got unwanted exception" + message);
      }
      if (shouldThrow && actual && expected && !expectedException(actual, expected) || !shouldThrow && actual) {
        throw actual;
      }
    }
    assert2["throws"] = function(block, error2, message) {
      _throws(true, block, error2, message);
    };
    assert2.doesNotThrow = function(block, error2, message) {
      _throws(false, block, error2, message);
    };
    assert2.ifError = function(err) {
      if (err)
        throw err;
    };
    function strict(value, message) {
      if (!value)
        fail(value, true, message, "==", strict);
    }
    assert2.strict = objectAssign2(strict, assert2, {
      equal: assert2.strictEqual,
      deepEqual: assert2.deepStrictEqual,
      notEqual: assert2.notStrictEqual,
      notDeepEqual: assert2.notDeepStrictEqual
    });
    assert2.strict.strict = assert2.strict;
    var objectKeys = Object.keys || function(obj) {
      var keys2 = [];
      for (var key2 in obj) {
        if (hasOwn2.call(obj, key2))
          keys2.push(key2);
      }
      return keys2;
    };
    var callExpression$9 = callExpression$e, cloneNode$9 = cloneNode$i, expressionStatement$3 = expressionStatement$a, identifier$9 = identifier$j, importDeclaration = importDeclaration$1, importDefaultSpecifier = importDefaultSpecifier$1, importNamespaceSpecifier = importNamespaceSpecifier$1, importSpecifier = importSpecifier$1, memberExpression$8 = memberExpression$b, stringLiteral$5 = stringLiteral$8, variableDeclaration$3 = variableDeclaration$7, variableDeclarator$3 = variableDeclarator$7;
    var ImportBuilder = function() {
      function ImportBuilder2(importedSource, scope2, hub) {
        this._statements = [];
        this._resultName = null;
        this._scope = null;
        this._hub = null;
        this._importedSource = void 0;
        this._scope = scope2;
        this._hub = hub;
        this._importedSource = importedSource;
      }
      var _proto = ImportBuilder2.prototype;
      _proto.done = function done() {
        return {
          statements: this._statements,
          resultName: this._resultName
        };
      };
      _proto["import"] = function _import2() {
        this._statements.push(importDeclaration([], stringLiteral$5(this._importedSource)));
        return this;
      };
      _proto.require = function require2() {
        this._statements.push(expressionStatement$3(callExpression$9(identifier$9("require"), [stringLiteral$5(this._importedSource)])));
        return this;
      };
      _proto.namespace = function namespace(name2) {
        if (name2 === void 0) {
          name2 = "namespace";
        }
        var local = this._scope.generateUidIdentifier(name2);
        var statement2 = this._statements[this._statements.length - 1];
        assert$1.exports(statement2.type === "ImportDeclaration");
        assert$1.exports(statement2.specifiers.length === 0);
        statement2.specifiers = [importNamespaceSpecifier(local)];
        this._resultName = cloneNode$9(local);
        return this;
      };
      _proto["default"] = function _default3(name2) {
        name2 = this._scope.generateUidIdentifier(name2);
        var statement2 = this._statements[this._statements.length - 1];
        assert$1.exports(statement2.type === "ImportDeclaration");
        assert$1.exports(statement2.specifiers.length === 0);
        statement2.specifiers = [importDefaultSpecifier(name2)];
        this._resultName = cloneNode$9(name2);
        return this;
      };
      _proto.named = function named(name2, importName) {
        if (importName === "default")
          return this["default"](name2);
        name2 = this._scope.generateUidIdentifier(name2);
        var statement2 = this._statements[this._statements.length - 1];
        assert$1.exports(statement2.type === "ImportDeclaration");
        assert$1.exports(statement2.specifiers.length === 0);
        statement2.specifiers = [importSpecifier(name2, identifier$9(importName))];
        this._resultName = cloneNode$9(name2);
        return this;
      };
      _proto["var"] = function _var(name2) {
        name2 = this._scope.generateUidIdentifier(name2);
        var statement2 = this._statements[this._statements.length - 1];
        if (statement2.type !== "ExpressionStatement") {
          assert$1.exports(this._resultName);
          statement2 = expressionStatement$3(this._resultName);
          this._statements.push(statement2);
        }
        this._statements[this._statements.length - 1] = variableDeclaration$3("var", [variableDeclarator$3(name2, statement2.expression)]);
        this._resultName = cloneNode$9(name2);
        return this;
      };
      _proto.defaultInterop = function defaultInterop() {
        return this._interop(this._hub.addHelper("interopRequireDefault"));
      };
      _proto.wildcardInterop = function wildcardInterop() {
        return this._interop(this._hub.addHelper("interopRequireWildcard"));
      };
      _proto._interop = function _interop(callee) {
        var statement2 = this._statements[this._statements.length - 1];
        if (statement2.type === "ExpressionStatement") {
          statement2.expression = callExpression$9(callee, [statement2.expression]);
        } else if (statement2.type === "VariableDeclaration") {
          assert$1.exports(statement2.declarations.length === 1);
          statement2.declarations[0].init = callExpression$9(callee, [statement2.declarations[0].init]);
        } else {
          assert$1.exports.fail("Unexpected type.");
        }
        return this;
      };
      _proto.prop = function prop2(name2) {
        var statement2 = this._statements[this._statements.length - 1];
        if (statement2.type === "ExpressionStatement") {
          statement2.expression = memberExpression$8(statement2.expression, identifier$9(name2));
        } else if (statement2.type === "VariableDeclaration") {
          assert$1.exports(statement2.declarations.length === 1);
          statement2.declarations[0].init = memberExpression$8(statement2.declarations[0].init, identifier$9(name2));
        } else {
          assert$1.exports.fail("Unexpected type:" + statement2.type);
        }
        return this;
      };
      _proto.read = function read2(name2) {
        this._resultName = memberExpression$8(this._resultName, identifier$9(name2));
      };
      return _createClass2(ImportBuilder2);
    }();
    function isModule(path2) {
      var sourceType = path2.node.sourceType;
      if (sourceType !== "module" && sourceType !== "script") {
        throw path2.buildCodeFrameError('Unknown sourceType "' + sourceType + '", cannot transform.');
      }
      return path2.node.sourceType === "module";
    }
    var numericLiteral$3 = numericLiteral$7, sequenceExpression$5 = sequenceExpression$7;
    var ImportInjector = function() {
      function ImportInjector2(path2, importedSource, opts) {
        this._defaultOpts = {
          importedSource: null,
          importedType: "commonjs",
          importedInterop: "babel",
          importingInterop: "babel",
          ensureLiveReference: false,
          ensureNoContext: false,
          importPosition: "before"
        };
        var programPath = path2.find(function(p2) {
          return p2.isProgram();
        });
        this._programPath = programPath;
        this._programScope = programPath.scope;
        this._hub = programPath.hub;
        this._defaultOpts = this._applyDefaults(importedSource, opts, true);
      }
      var _proto = ImportInjector2.prototype;
      _proto.addDefault = function addDefault2(importedSourceIn, opts) {
        return this.addNamed("default", importedSourceIn, opts);
      };
      _proto.addNamed = function addNamed2(importName, importedSourceIn, opts) {
        assert$1.exports(typeof importName === "string");
        return this._generateImport(this._applyDefaults(importedSourceIn, opts), importName);
      };
      _proto.addNamespace = function addNamespace2(importedSourceIn, opts) {
        return this._generateImport(this._applyDefaults(importedSourceIn, opts), null);
      };
      _proto.addSideEffect = function addSideEffect(importedSourceIn, opts) {
        return this._generateImport(this._applyDefaults(importedSourceIn, opts), false);
      };
      _proto._applyDefaults = function _applyDefaults(importedSource, opts, isInit) {
        if (isInit === void 0) {
          isInit = false;
        }
        var optsList = [];
        if (typeof importedSource === "string") {
          optsList.push({
            importedSource
          });
          optsList.push(opts);
        } else {
          assert$1.exports(!opts, "Unexpected secondary arguments.");
          optsList.push(importedSource);
        }
        var newOpts = Object.assign({}, this._defaultOpts);
        var _loop3 = function _loop4() {
          var opts2 = _optsList[_i3];
          if (!opts2)
            return "continue";
          Object.keys(newOpts).forEach(function(key2) {
            if (opts2[key2] !== void 0)
              newOpts[key2] = opts2[key2];
          });
          if (!isInit) {
            if (opts2.nameHint !== void 0)
              newOpts.nameHint = opts2.nameHint;
            if (opts2.blockHoist !== void 0)
              newOpts.blockHoist = opts2.blockHoist;
          }
        };
        for (var _i3 = 0, _optsList = optsList; _i3 < _optsList.length; _i3++) {
          var _ret2 = _loop3();
          if (_ret2 === "continue")
            continue;
        }
        return newOpts;
      };
      _proto._generateImport = function _generateImport(opts, importName) {
        var isDefault = importName === "default";
        var isNamed = !!importName && !isDefault;
        var isNamespace = importName === null;
        var importedSource = opts.importedSource, importedType = opts.importedType, importedInterop = opts.importedInterop, importingInterop = opts.importingInterop, ensureLiveReference = opts.ensureLiveReference, ensureNoContext = opts.ensureNoContext, nameHint = opts.nameHint, importPosition = opts.importPosition, blockHoist = opts.blockHoist;
        var name2 = nameHint || importName;
        var isMod = isModule(this._programPath);
        var isModuleForNode = isMod && importingInterop === "node";
        var isModuleForBabel = isMod && importingInterop === "babel";
        if (importPosition === "after" && !isMod) {
          throw new Error('"importPosition": "after" is only supported in modules');
        }
        var builder2 = new ImportBuilder(importedSource, this._programScope, this._hub);
        if (importedType === "es6") {
          if (!isModuleForNode && !isModuleForBabel) {
            throw new Error("Cannot import an ES6 module from CommonJS");
          }
          builder2["import"]();
          if (isNamespace) {
            builder2.namespace(nameHint || importedSource);
          } else if (isDefault || isNamed) {
            builder2.named(name2, importName);
          }
        } else if (importedType !== "commonjs") {
          throw new Error('Unexpected interopType "' + importedType + '"');
        } else if (importedInterop === "babel") {
          if (isModuleForNode) {
            name2 = name2 !== "default" ? name2 : importedSource;
            var es6Default = importedSource + "$es6Default";
            builder2["import"]();
            if (isNamespace) {
              builder2["default"](es6Default)["var"](name2 || importedSource).wildcardInterop();
            } else if (isDefault) {
              if (ensureLiveReference) {
                builder2["default"](es6Default)["var"](name2 || importedSource).defaultInterop().read("default");
              } else {
                builder2["default"](es6Default)["var"](name2).defaultInterop().prop(importName);
              }
            } else if (isNamed) {
              builder2["default"](es6Default).read(importName);
            }
          } else if (isModuleForBabel) {
            builder2["import"]();
            if (isNamespace) {
              builder2.namespace(name2 || importedSource);
            } else if (isDefault || isNamed) {
              builder2.named(name2, importName);
            }
          } else {
            builder2.require();
            if (isNamespace) {
              builder2["var"](name2 || importedSource).wildcardInterop();
            } else if ((isDefault || isNamed) && ensureLiveReference) {
              if (isDefault) {
                name2 = name2 !== "default" ? name2 : importedSource;
                builder2["var"](name2).read(importName);
                builder2.defaultInterop();
              } else {
                builder2["var"](importedSource).read(importName);
              }
            } else if (isDefault) {
              builder2["var"](name2).defaultInterop().prop(importName);
            } else if (isNamed) {
              builder2["var"](name2).prop(importName);
            }
          }
        } else if (importedInterop === "compiled") {
          if (isModuleForNode) {
            builder2["import"]();
            if (isNamespace) {
              builder2["default"](name2 || importedSource);
            } else if (isDefault || isNamed) {
              builder2["default"](importedSource).read(name2);
            }
          } else if (isModuleForBabel) {
            builder2["import"]();
            if (isNamespace) {
              builder2.namespace(name2 || importedSource);
            } else if (isDefault || isNamed) {
              builder2.named(name2, importName);
            }
          } else {
            builder2.require();
            if (isNamespace) {
              builder2["var"](name2 || importedSource);
            } else if (isDefault || isNamed) {
              if (ensureLiveReference) {
                builder2["var"](importedSource).read(name2);
              } else {
                builder2.prop(importName)["var"](name2);
              }
            }
          }
        } else if (importedInterop === "uncompiled") {
          if (isDefault && ensureLiveReference) {
            throw new Error("No live reference for commonjs default");
          }
          if (isModuleForNode) {
            builder2["import"]();
            if (isNamespace) {
              builder2["default"](name2 || importedSource);
            } else if (isDefault) {
              builder2["default"](name2);
            } else if (isNamed) {
              builder2["default"](importedSource).read(name2);
            }
          } else if (isModuleForBabel) {
            builder2["import"]();
            if (isNamespace) {
              builder2["default"](name2 || importedSource);
            } else if (isDefault) {
              builder2["default"](name2);
            } else if (isNamed) {
              builder2.named(name2, importName);
            }
          } else {
            builder2.require();
            if (isNamespace) {
              builder2["var"](name2 || importedSource);
            } else if (isDefault) {
              builder2["var"](name2);
            } else if (isNamed) {
              if (ensureLiveReference) {
                builder2["var"](importedSource).read(name2);
              } else {
                builder2["var"](name2).prop(importName);
              }
            }
          }
        } else {
          throw new Error('Unknown importedInterop "' + importedInterop + '".');
        }
        var _builder$done = builder2.done(), statements2 = _builder$done.statements, resultName = _builder$done.resultName;
        this._insertStatements(statements2, importPosition, blockHoist);
        if ((isDefault || isNamed) && ensureNoContext && resultName.type !== "Identifier") {
          return sequenceExpression$5([numericLiteral$3(0), resultName]);
        }
        return resultName;
      };
      _proto._insertStatements = function _insertStatements(statements2, importPosition, blockHoist) {
        if (importPosition === void 0) {
          importPosition = "before";
        }
        if (blockHoist === void 0) {
          blockHoist = 3;
        }
        var body = this._programPath.get("body");
        if (importPosition === "after") {
          for (var i2 = body.length - 1; i2 >= 0; i2--) {
            if (body[i2].isImportDeclaration()) {
              body[i2].insertAfter(statements2);
              return;
            }
          }
        } else {
          statements2.forEach(function(node2) {
            node2._blockHoist = blockHoist;
          });
          var targetPath = body.find(function(p2) {
            var val = p2.node._blockHoist;
            return Number.isFinite(val) && val < 4;
          });
          if (targetPath) {
            targetPath.insertBefore(statements2);
            return;
          }
        }
        this._programPath.unshiftContainer("body", statements2);
      };
      return _createClass2(ImportInjector2);
    }();
    function addDefault(path2, importedSource, opts) {
      return new ImportInjector(path2).addDefault(importedSource, opts);
    }
    function addNamed(path2, name2, importedSource, opts) {
      return new ImportInjector(path2).addNamed(name2, importedSource, opts);
    }
    function addNamespace(path2, importedSource, opts) {
      return new ImportInjector(path2).addNamespace(importedSource, opts);
    }
    var numericLiteral$2 = numericLiteral$7, unaryExpression$2 = unaryExpression$6;
    function rewriteThis(programPath) {
      traverse(programPath.node, Object.assign({}, rewriteThisVisitor, {
        noScope: true
      }));
    }
    var rewriteThisVisitor = traverse.visitors.merge([environmentVisitor, {
      ThisExpression: function(_ThisExpression) {
        function ThisExpression2(_x) {
          return _ThisExpression.apply(this, arguments);
        }
        ThisExpression2.toString = function() {
          return _ThisExpression.toString();
        };
        return ThisExpression2;
      }(function(path2) {
        path2.replaceWith(unaryExpression$2("void", numericLiteral$2(0), true));
      })
    }]);
    var LOGICAL_OPERATORS$1 = LOGICAL_OPERATORS$3, assignmentExpression$6 = assignmentExpression$c, binaryExpression$2 = binaryExpression$4, cloneNode$8 = cloneNode$i, identifier$8 = identifier$j, logicalExpression$1 = logicalExpression$3, numericLiteral$1 = numericLiteral$7, sequenceExpression$4 = sequenceExpression$7, unaryExpression$1 = unaryExpression$6;
    function simplifyAccess(path2, bindingNames, includeUpdateExpression) {
      if (includeUpdateExpression === void 0) {
        includeUpdateExpression = true;
      }
      path2.traverse(simpleAssignmentVisitor, {
        scope: path2.scope,
        bindingNames,
        seen: /* @__PURE__ */ new WeakSet(),
        includeUpdateExpression
      });
    }
    var simpleAssignmentVisitor = {
      UpdateExpression: {
        exit: function exit(path2) {
          var scope2 = this.scope, bindingNames = this.bindingNames, includeUpdateExpression = this.includeUpdateExpression;
          if (!includeUpdateExpression) {
            return;
          }
          var arg = path2.get("argument");
          if (!arg.isIdentifier())
            return;
          var localName = arg.node.name;
          if (!bindingNames.has(localName))
            return;
          if (scope2.getBinding(localName) !== path2.scope.getBinding(localName)) {
            return;
          }
          if (path2.parentPath.isExpressionStatement() && !path2.isCompletionRecord()) {
            var operator = path2.node.operator == "++" ? "+=" : "-=";
            path2.replaceWith(assignmentExpression$6(operator, arg.node, numericLiteral$1(1)));
          } else if (path2.node.prefix) {
            path2.replaceWith(assignmentExpression$6("=", identifier$8(localName), binaryExpression$2(path2.node.operator[0], unaryExpression$1("+", arg.node), numericLiteral$1(1))));
          } else {
            var old = path2.scope.generateUidIdentifierBasedOnNode(arg.node, "old");
            var varName = old.name;
            path2.scope.push({
              id: old
            });
            var binary = binaryExpression$2(path2.node.operator[0], identifier$8(varName), numericLiteral$1(1));
            path2.replaceWith(sequenceExpression$4([assignmentExpression$6("=", identifier$8(varName), unaryExpression$1("+", arg.node)), assignmentExpression$6("=", cloneNode$8(arg.node), binary), identifier$8(varName)]));
          }
        }
      },
      AssignmentExpression: {
        exit: function exit(path2) {
          var scope2 = this.scope, seen = this.seen, bindingNames = this.bindingNames;
          if (path2.node.operator === "=")
            return;
          if (seen.has(path2.node))
            return;
          seen.add(path2.node);
          var left = path2.get("left");
          if (!left.isIdentifier())
            return;
          var localName = left.node.name;
          if (!bindingNames.has(localName))
            return;
          if (scope2.getBinding(localName) !== path2.scope.getBinding(localName)) {
            return;
          }
          var operator = path2.node.operator.slice(0, -1);
          if (LOGICAL_OPERATORS$1.includes(operator)) {
            path2.replaceWith(logicalExpression$1(operator, path2.node.left, assignmentExpression$6("=", cloneNode$8(path2.node.left), path2.node.right)));
          } else {
            path2.node.right = binaryExpression$2(operator, cloneNode$8(path2.node.left), path2.node.right);
            path2.node.operator = "=";
          }
        }
      }
    };
    var _templateObject$n;
    var assignmentExpression$5 = assignmentExpression$c, callExpression$8 = callExpression$e, cloneNode$7 = cloneNode$i, expressionStatement$2 = expressionStatement$a, getOuterBindingIdentifiers = getOuterBindingIdentifiers$2, identifier$7 = identifier$j, isMemberExpression$2 = isMemberExpression$8, isVariableDeclaration = isVariableDeclaration$3, jsxIdentifier = jsxIdentifier$2, jsxMemberExpression = jsxMemberExpression$1, memberExpression$7 = memberExpression$b, numericLiteral = numericLiteral$7, sequenceExpression$3 = sequenceExpression$7, stringLiteral$4 = stringLiteral$8, variableDeclaration$2 = variableDeclaration$7, variableDeclarator$2 = variableDeclarator$7;
    function isInType$1(path2) {
      do {
        switch (path2.parent.type) {
          case "TSTypeAnnotation":
          case "TSTypeAliasDeclaration":
          case "TSTypeReference":
          case "TypeAnnotation":
          case "TypeAlias":
            return true;
          case "ExportSpecifier":
            return path2.parentPath.parent.exportKind === "type";
          default:
            if (path2.parentPath.isStatement() || path2.parentPath.isExpression()) {
              return false;
            }
        }
      } while (path2 = path2.parentPath);
    }
    function rewriteLiveReferences(programPath, metadata) {
      var imported = /* @__PURE__ */ new Map();
      var exported = /* @__PURE__ */ new Map();
      var requeueInParent = function requeueInParent2(path2) {
        programPath.requeue(path2);
      };
      for (var _iterator2 = _createForOfIteratorHelperLoose(metadata.source), _step2; !(_step2 = _iterator2()).done; ) {
        var _step$value = _slicedToArray$12(_step2.value, 2), source = _step$value[0], data3 = _step$value[1];
        for (var _iterator3 = _createForOfIteratorHelperLoose(data3.imports), _step3; !(_step3 = _iterator3()).done; ) {
          var _step3$value = _slicedToArray$12(_step3.value, 2), localName = _step3$value[0], importName = _step3$value[1];
          imported.set(localName, [source, importName, null]);
        }
        for (var _iterator4 = _createForOfIteratorHelperLoose(data3.importsNamespace), _step4; !(_step4 = _iterator4()).done; ) {
          var _localName = _step4.value;
          imported.set(_localName, [source, null, _localName]);
        }
      }
      for (var _iterator22 = _createForOfIteratorHelperLoose(metadata.local), _step22; !(_step22 = _iterator22()).done; ) {
        var _exportMeta;
        var _step2$value = _slicedToArray$12(_step22.value, 2), local = _step2$value[0], _data = _step2$value[1];
        var exportMeta = exported.get(local);
        if (!exportMeta) {
          exportMeta = [];
          exported.set(local, exportMeta);
        }
        (_exportMeta = exportMeta).push.apply(_exportMeta, _toConsumableArray2(_data.names));
      }
      var rewriteBindingInitVisitorState = {
        metadata,
        requeueInParent,
        scope: programPath.scope,
        exported
      };
      programPath.traverse(rewriteBindingInitVisitor, rewriteBindingInitVisitorState);
      simplifyAccess(programPath, new Set([].concat(_toConsumableArray2(Array.from(imported.keys())), _toConsumableArray2(Array.from(exported.keys())))), false);
      var rewriteReferencesVisitorState = {
        seen: /* @__PURE__ */ new WeakSet(),
        metadata,
        requeueInParent,
        scope: programPath.scope,
        imported,
        exported,
        buildImportReference: function buildImportReference(_ref3, identNode) {
          var _ref22 = _slicedToArray$12(_ref3, 3), source2 = _ref22[0], importName2 = _ref22[1], localName2 = _ref22[2];
          var meta2 = metadata.source.get(source2);
          if (localName2) {
            if (meta2.lazy)
              identNode = callExpression$8(identNode, []);
            return identNode;
          }
          var namespace = identifier$7(meta2.name);
          if (meta2.lazy)
            namespace = callExpression$8(namespace, []);
          if (importName2 === "default" && meta2.interop === "node-default") {
            return namespace;
          }
          var computed = metadata.stringSpecifiers.has(importName2);
          return memberExpression$7(namespace, computed ? stringLiteral$4(importName2) : identifier$7(importName2), computed);
        }
      };
      programPath.traverse(rewriteReferencesVisitor, rewriteReferencesVisitorState);
    }
    var rewriteBindingInitVisitor = {
      Scope: function Scope4(path2) {
        path2.skip();
      },
      ClassDeclaration: function ClassDeclaration2(path2) {
        var requeueInParent = this.requeueInParent, exported = this.exported, metadata = this.metadata;
        var id3 = path2.node.id;
        if (!id3)
          throw new Error("Expected class to have a name");
        var localName = id3.name;
        var exportNames = exported.get(localName) || [];
        if (exportNames.length > 0) {
          var statement2 = expressionStatement$2(buildBindingExportAssignmentExpression(metadata, exportNames, identifier$7(localName)));
          statement2._blockHoist = path2.node._blockHoist;
          requeueInParent(path2.insertAfter(statement2)[0]);
        }
      },
      VariableDeclaration: function VariableDeclaration2(path2) {
        var requeueInParent = this.requeueInParent, exported = this.exported, metadata = this.metadata;
        Object.keys(path2.getOuterBindingIdentifiers()).forEach(function(localName) {
          var exportNames = exported.get(localName) || [];
          if (exportNames.length > 0) {
            var statement2 = expressionStatement$2(buildBindingExportAssignmentExpression(metadata, exportNames, identifier$7(localName)));
            statement2._blockHoist = path2.node._blockHoist;
            requeueInParent(path2.insertAfter(statement2)[0]);
          }
        });
      }
    };
    var buildBindingExportAssignmentExpression = function buildBindingExportAssignmentExpression2(metadata, exportNames, localExpr) {
      return (exportNames || []).reduce(function(expr, exportName) {
        var stringSpecifiers = metadata.stringSpecifiers;
        var computed = stringSpecifiers.has(exportName);
        return assignmentExpression$5("=", memberExpression$7(identifier$7(metadata.exportName), computed ? stringLiteral$4(exportName) : identifier$7(exportName), computed), expr);
      }, localExpr);
    };
    var buildImportThrow = function buildImportThrow2(localName) {
      return template$2.expression.ast(_templateObject$n || (_templateObject$n = _taggedTemplateLiteralLoose([`
    (function() {
      throw new Error('"' + '`, `' + '" is read-only.');
    })()
  `])), localName);
    };
    var rewriteReferencesVisitor = {
      ReferencedIdentifier: function ReferencedIdentifier2(path2) {
        var seen = this.seen, buildImportReference = this.buildImportReference, scope2 = this.scope, imported = this.imported, requeueInParent = this.requeueInParent;
        if (seen.has(path2.node))
          return;
        seen.add(path2.node);
        var localName = path2.node.name;
        var importData = imported.get(localName);
        if (importData) {
          if (isInType$1(path2)) {
            throw path2.buildCodeFrameError('Cannot transform the imported binding "' + localName + `" since it's also used in a type annotation. Please strip type annotations using @babel/preset-typescript or @babel/preset-flow.`);
          }
          var localBinding = path2.scope.getBinding(localName);
          var rootBinding = scope2.getBinding(localName);
          if (rootBinding !== localBinding)
            return;
          var ref2 = buildImportReference(importData, path2.node);
          ref2.loc = path2.node.loc;
          if ((path2.parentPath.isCallExpression({
            callee: path2.node
          }) || path2.parentPath.isOptionalCallExpression({
            callee: path2.node
          }) || path2.parentPath.isTaggedTemplateExpression({
            tag: path2.node
          })) && isMemberExpression$2(ref2)) {
            path2.replaceWith(sequenceExpression$3([numericLiteral(0), ref2]));
          } else if (path2.isJSXIdentifier() && isMemberExpression$2(ref2)) {
            var object4 = ref2.object, property2 = ref2.property;
            path2.replaceWith(jsxMemberExpression(jsxIdentifier(object4.name), jsxIdentifier(property2.name)));
          } else {
            path2.replaceWith(ref2);
          }
          requeueInParent(path2);
          path2.skip();
        }
      },
      UpdateExpression: function UpdateExpression2(path2) {
        var scope2 = this.scope, seen = this.seen, imported = this.imported, exported = this.exported, requeueInParent = this.requeueInParent, buildImportReference = this.buildImportReference;
        if (seen.has(path2.node))
          return;
        seen.add(path2.node);
        var arg = path2.get("argument");
        if (arg.isMemberExpression())
          return;
        var update2 = path2.node;
        if (arg.isIdentifier()) {
          var localName = arg.node.name;
          if (scope2.getBinding(localName) !== path2.scope.getBinding(localName)) {
            return;
          }
          var exportedNames = exported.get(localName);
          var importData = imported.get(localName);
          if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
            if (importData) {
              path2.replaceWith(assignmentExpression$5(update2.operator[0] + "=", buildImportReference(importData, arg.node), buildImportThrow(localName)));
            } else if (update2.prefix) {
              path2.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, cloneNode$7(update2)));
            } else {
              var ref2 = scope2.generateDeclaredUidIdentifier(localName);
              path2.replaceWith(sequenceExpression$3([assignmentExpression$5("=", cloneNode$7(ref2), cloneNode$7(update2)), buildBindingExportAssignmentExpression(this.metadata, exportedNames, identifier$7(localName)), cloneNode$7(ref2)]));
            }
          }
        }
        requeueInParent(path2);
        path2.skip();
      },
      AssignmentExpression: {
        exit: function exit(path2) {
          var _this = this;
          var scope2 = this.scope, seen = this.seen, imported = this.imported, exported = this.exported, requeueInParent = this.requeueInParent, buildImportReference = this.buildImportReference;
          if (seen.has(path2.node))
            return;
          seen.add(path2.node);
          var left = path2.get("left");
          if (left.isMemberExpression())
            return;
          if (left.isIdentifier()) {
            var localName = left.node.name;
            if (scope2.getBinding(localName) !== path2.scope.getBinding(localName)) {
              return;
            }
            var exportedNames = exported.get(localName);
            var importData = imported.get(localName);
            if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
              assert$1.exports(path2.node.operator === "=", "Path was not simplified");
              var assignment = path2.node;
              if (importData) {
                assignment.left = buildImportReference(importData, assignment.left);
                assignment.right = sequenceExpression$3([assignment.right, buildImportThrow(localName)]);
              }
              path2.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, assignment));
              requeueInParent(path2);
            }
          } else {
            var ids2 = left.getOuterBindingIdentifiers();
            var programScopeIds = Object.keys(ids2).filter(function(localName2) {
              return scope2.getBinding(localName2) === path2.scope.getBinding(localName2);
            });
            var id3 = programScopeIds.find(function(localName2) {
              return imported.has(localName2);
            });
            if (id3) {
              path2.node.right = sequenceExpression$3([path2.node.right, buildImportThrow(id3)]);
            }
            var items = [];
            programScopeIds.forEach(function(localName2) {
              var exportedNames2 = exported.get(localName2) || [];
              if (exportedNames2.length > 0) {
                items.push(buildBindingExportAssignmentExpression(_this.metadata, exportedNames2, identifier$7(localName2)));
              }
            });
            if (items.length > 0) {
              var node2 = sequenceExpression$3(items);
              if (path2.parentPath.isExpressionStatement()) {
                node2 = expressionStatement$2(node2);
                node2._blockHoist = path2.parentPath.node._blockHoist;
              }
              var statement2 = path2.insertAfter(node2)[0];
              requeueInParent(statement2);
            }
          }
        }
      },
      "ForOfStatement|ForInStatement": function ForOfStatementForInStatement(path2) {
        var scope2 = path2.scope, node2 = path2.node;
        var left = node2.left;
        var exported = this.exported, imported = this.imported, programScope = this.scope;
        if (!isVariableDeclaration(left)) {
          var didTransformExport = false, importConstViolationName;
          var loopBodyScope = path2.get("body").scope;
          for (var _i3 = 0, _Object$keys3 = Object.keys(getOuterBindingIdentifiers(left)); _i3 < _Object$keys3.length; _i3++) {
            var name2 = _Object$keys3[_i3];
            if (programScope.getBinding(name2) === scope2.getBinding(name2)) {
              if (exported.has(name2)) {
                didTransformExport = true;
                if (loopBodyScope.hasOwnBinding(name2)) {
                  loopBodyScope.rename(name2);
                }
              }
              if (imported.has(name2) && !importConstViolationName) {
                importConstViolationName = name2;
              }
            }
          }
          if (!didTransformExport && !importConstViolationName) {
            return;
          }
          path2.ensureBlock();
          var bodyPath = path2.get("body");
          var newLoopId = scope2.generateUidIdentifierBasedOnNode(left);
          path2.get("left").replaceWith(variableDeclaration$2("let", [variableDeclarator$2(cloneNode$7(newLoopId))]));
          scope2.registerDeclaration(path2.get("left"));
          if (didTransformExport) {
            bodyPath.unshiftContainer("body", expressionStatement$2(assignmentExpression$5("=", left, newLoopId)));
          }
          if (importConstViolationName) {
            bodyPath.unshiftContainer("body", expressionStatement$2(buildImportThrow(importConstViolationName)));
          }
        }
      }
    };
    function normalizeArray(parts, allowAboveRoot) {
      var up = 0;
      for (var i2 = parts.length - 1; i2 >= 0; i2--) {
        var last2 = parts[i2];
        if (last2 === ".") {
          parts.splice(i2, 1);
        } else if (last2 === "..") {
          parts.splice(i2, 1);
          up++;
        } else if (up) {
          parts.splice(i2, 1);
          up--;
        }
      }
      if (allowAboveRoot) {
        for (; up--; up) {
          parts.unshift("..");
        }
      }
      return parts;
    }
    var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
    var splitPath = function(filename) {
      return splitPathRe.exec(filename).slice(1);
    };
    function resolve$3() {
      var resolvedPath = "", resolvedAbsolute = false;
      for (var i2 = arguments.length - 1; i2 >= -1 && !resolvedAbsolute; i2--) {
        var path2 = i2 >= 0 ? arguments[i2] : "/";
        if (typeof path2 !== "string") {
          throw new TypeError("Arguments to path.resolve must be strings");
        } else if (!path2) {
          continue;
        }
        resolvedPath = path2 + "/" + resolvedPath;
        resolvedAbsolute = path2.charAt(0) === "/";
      }
      resolvedPath = normalizeArray(filter2(resolvedPath.split("/"), function(p2) {
        return !!p2;
      }), !resolvedAbsolute).join("/");
      return (resolvedAbsolute ? "/" : "") + resolvedPath || ".";
    }
    function normalize$22(path2) {
      var isPathAbsolute = isAbsolute(path2), trailingSlash = substr(path2, -1) === "/";
      path2 = normalizeArray(filter2(path2.split("/"), function(p2) {
        return !!p2;
      }), !isPathAbsolute).join("/");
      if (!path2 && !isPathAbsolute) {
        path2 = ".";
      }
      if (path2 && trailingSlash) {
        path2 += "/";
      }
      return (isPathAbsolute ? "/" : "") + path2;
    }
    function isAbsolute(path2) {
      return path2.charAt(0) === "/";
    }
    function join() {
      var paths = Array.prototype.slice.call(arguments, 0);
      return normalize$22(filter2(paths, function(p2, index3) {
        if (typeof p2 !== "string") {
          throw new TypeError("Arguments to path.join must be strings");
        }
        return p2;
      }).join("/"));
    }
    function relative(from2, to) {
      from2 = resolve$3(from2).substr(1);
      to = resolve$3(to).substr(1);
      function trim2(arr) {
        var start2 = 0;
        for (; start2 < arr.length; start2++) {
          if (arr[start2] !== "")
            break;
        }
        var end2 = arr.length - 1;
        for (; end2 >= 0; end2--) {
          if (arr[end2] !== "")
            break;
        }
        if (start2 > end2)
          return [];
        return arr.slice(start2, end2 - start2 + 1);
      }
      var fromParts = trim2(from2.split("/"));
      var toParts = trim2(to.split("/"));
      var length = Math.min(fromParts.length, toParts.length);
      var samePartsLength = length;
      for (var i2 = 0; i2 < length; i2++) {
        if (fromParts[i2] !== toParts[i2]) {
          samePartsLength = i2;
          break;
        }
      }
      var outputParts = [];
      for (var i2 = samePartsLength; i2 < fromParts.length; i2++) {
        outputParts.push("..");
      }
      outputParts = outputParts.concat(toParts.slice(samePartsLength));
      return outputParts.join("/");
    }
    var sep$1 = "/";
    var delimiter = ":";
    function dirname(path2) {
      var result = splitPath(path2), root2 = result[0], dir3 = result[1];
      if (!root2 && !dir3) {
        return ".";
      }
      if (dir3) {
        dir3 = dir3.substr(0, dir3.length - 1);
      }
      return root2 + dir3;
    }
    function basename(path2, ext) {
      var f2 = splitPath(path2)[2];
      if (ext && f2.substr(-1 * ext.length) === ext) {
        f2 = f2.substr(0, f2.length - ext.length);
      }
      return f2;
    }
    function extname(path2) {
      return splitPath(path2)[3];
    }
    var path$1 = {
      extname,
      basename,
      dirname,
      sep: sep$1,
      delimiter,
      relative,
      join,
      isAbsolute,
      normalize: normalize$22,
      resolve: resolve$3
    };
    function filter2(xs, f2) {
      if (xs.filter)
        return xs.filter(f2);
      var res2 = [];
      for (var i2 = 0; i2 < xs.length; i2++) {
        if (f2(xs[i2], i2, xs))
          res2.push(xs[i2]);
      }
      return res2;
    }
    var substr = "ab".substr(-1) === "b" ? function(str, start2, len3) {
      return str.substr(start2, len3);
    } : function(str, start2, len3) {
      if (start2 < 0)
        start2 = str.length + start2;
      return str.substr(start2, len3);
    };
    var _polyfillNode_path = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      resolve: resolve$3,
      normalize: normalize$22,
      isAbsolute,
      join,
      relative,
      sep: sep$1,
      delimiter,
      dirname,
      basename,
      extname,
      "default": path$1
    });
    function hasExports(metadata) {
      return metadata.hasExports;
    }
    function isSideEffectImport(source) {
      return source.imports.size === 0 && source.importsNamespace.size === 0 && source.reexports.size === 0 && source.reexportNamespace.size === 0 && !source.reexportAll;
    }
    function validateImportInteropOption(importInterop) {
      if (typeof importInterop !== "function" && importInterop !== "none" && importInterop !== "babel" && importInterop !== "node") {
        throw new Error('.importInterop must be one of "none", "babel", "node", or a function returning one of those values (received ' + importInterop + ").");
      }
      return importInterop;
    }
    function resolveImportInterop(importInterop, source) {
      if (typeof importInterop === "function") {
        return validateImportInteropOption(importInterop(source));
      }
      return importInterop;
    }
    function normalizeModuleAndLoadMetadata(programPath, exportName, _ref3) {
      var importInterop = _ref3.importInterop, _ref$initializeReexpo = _ref3.initializeReexports, initializeReexports = _ref$initializeReexpo === void 0 ? false : _ref$initializeReexpo, _ref$lazy = _ref3.lazy, lazy = _ref$lazy === void 0 ? false : _ref$lazy, _ref$esNamespaceOnly = _ref3.esNamespaceOnly, esNamespaceOnly = _ref$esNamespaceOnly === void 0 ? false : _ref$esNamespaceOnly;
      if (!exportName) {
        exportName = programPath.scope.generateUidIdentifier("exports").name;
      }
      var stringSpecifiers = /* @__PURE__ */ new Set();
      nameAnonymousExports(programPath);
      var _getModuleMetadata = getModuleMetadata(programPath, {
        initializeReexports,
        lazy
      }, stringSpecifiers), local = _getModuleMetadata.local, source = _getModuleMetadata.source, hasExports2 = _getModuleMetadata.hasExports;
      removeModuleDeclarations(programPath);
      for (var _iterator2 = _createForOfIteratorHelperLoose(source), _step2; !(_step2 = _iterator2()).done; ) {
        var _step$value = _slicedToArray$12(_step2.value, 2), metadata = _step$value[1];
        if (metadata.importsNamespace.size > 0) {
          metadata.name = metadata.importsNamespace.values().next().value;
        }
        var resolvedInterop = resolveImportInterop(importInterop, metadata.source);
        if (resolvedInterop === "none") {
          metadata.interop = "none";
        } else if (resolvedInterop === "node" && metadata.interop === "namespace") {
          metadata.interop = "node-namespace";
        } else if (resolvedInterop === "node" && metadata.interop === "default") {
          metadata.interop = "node-default";
        } else if (esNamespaceOnly && metadata.interop === "namespace") {
          metadata.interop = "default";
        }
      }
      return {
        exportName,
        exportNameListName: null,
        hasExports: hasExports2,
        local,
        source,
        stringSpecifiers
      };
    }
    function getExportSpecifierName$1(path2, stringSpecifiers) {
      if (path2.isIdentifier()) {
        return path2.node.name;
      } else if (path2.isStringLiteral()) {
        var stringValue = path2.node.value;
        if (!isIdentifierName(stringValue)) {
          stringSpecifiers.add(stringValue);
        }
        return stringValue;
      } else {
        throw new Error("Expected export specifier to be either Identifier or StringLiteral, got " + path2.node.type);
      }
    }
    function assertExportSpecifier(path2) {
      if (path2.isExportSpecifier()) {
        return;
      } else if (path2.isExportNamespaceSpecifier()) {
        throw path2.buildCodeFrameError("Export namespace should be first transformed by `@babel/plugin-proposal-export-namespace-from`.");
      } else {
        throw path2.buildCodeFrameError("Unexpected export specifier type");
      }
    }
    function getModuleMetadata(programPath, _ref22, stringSpecifiers) {
      var lazy = _ref22.lazy, initializeReexports = _ref22.initializeReexports;
      var localData = getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers);
      var sourceData = /* @__PURE__ */ new Map();
      var getData = function getData2(sourceNode2) {
        var source2 = sourceNode2.value;
        var data3 = sourceData.get(source2);
        if (!data3) {
          data3 = {
            name: programPath.scope.generateUidIdentifier(basename(source2, extname(source2))).name,
            interop: "none",
            loc: null,
            imports: /* @__PURE__ */ new Map(),
            importsNamespace: /* @__PURE__ */ new Set(),
            reexports: /* @__PURE__ */ new Map(),
            reexportNamespace: /* @__PURE__ */ new Set(),
            reexportAll: null,
            lazy: false,
            source: source2
          };
          sourceData.set(source2, data3);
        }
        return data3;
      };
      var hasExports2 = false;
      programPath.get("body").forEach(function(child) {
        if (child.isImportDeclaration()) {
          var data3 = getData(child.node.source);
          if (!data3.loc)
            data3.loc = child.node.loc;
          child.get("specifiers").forEach(function(spec) {
            if (spec.isImportDefaultSpecifier()) {
              var localName = spec.get("local").node.name;
              data3.imports.set(localName, "default");
              var reexport = localData.get(localName);
              if (reexport) {
                localData["delete"](localName);
                reexport.names.forEach(function(name2) {
                  data3.reexports.set(name2, "default");
                });
              }
            } else if (spec.isImportNamespaceSpecifier()) {
              var _localName = spec.get("local").node.name;
              data3.importsNamespace.add(_localName);
              var _reexport = localData.get(_localName);
              if (_reexport) {
                localData["delete"](_localName);
                _reexport.names.forEach(function(name2) {
                  data3.reexportNamespace.add(name2);
                });
              }
            } else if (spec.isImportSpecifier()) {
              var importName2 = getExportSpecifierName$1(spec.get("imported"), stringSpecifiers);
              var _localName2 = spec.get("local").node.name;
              data3.imports.set(_localName2, importName2);
              var _reexport2 = localData.get(_localName2);
              if (_reexport2) {
                localData["delete"](_localName2);
                _reexport2.names.forEach(function(name2) {
                  data3.reexports.set(name2, importName2);
                });
              }
            }
          });
        } else if (child.isExportAllDeclaration()) {
          hasExports2 = true;
          var _data = getData(child.node.source);
          if (!_data.loc)
            _data.loc = child.node.loc;
          _data.reexportAll = {
            loc: child.node.loc
          };
        } else if (child.isExportNamedDeclaration() && child.node.source) {
          hasExports2 = true;
          var _data2 = getData(child.node.source);
          if (!_data2.loc)
            _data2.loc = child.node.loc;
          child.get("specifiers").forEach(function(spec) {
            assertExportSpecifier(spec);
            var importName2 = getExportSpecifierName$1(spec.get("local"), stringSpecifiers);
            var exportName = getExportSpecifierName$1(spec.get("exported"), stringSpecifiers);
            _data2.reexports.set(exportName, importName2);
            if (exportName === "__esModule") {
              throw spec.get("exported").buildCodeFrameError('Illegal export "__esModule".');
            }
          });
        } else if (child.isExportNamedDeclaration() || child.isExportDefaultDeclaration()) {
          hasExports2 = true;
        }
      });
      for (var _iterator2 = _createForOfIteratorHelperLoose(sourceData.values()), _step2; !(_step2 = _iterator2()).done; ) {
        var metadata = _step2.value;
        var needsDefault = false;
        var needsNamed = false;
        if (metadata.importsNamespace.size > 0) {
          needsDefault = true;
          needsNamed = true;
        }
        if (metadata.reexportAll) {
          needsNamed = true;
        }
        for (var _iterator4 = _createForOfIteratorHelperLoose(metadata.imports.values()), _step4; !(_step4 = _iterator4()).done; ) {
          var importName = _step4.value;
          if (importName === "default")
            needsDefault = true;
          else
            needsNamed = true;
        }
        for (var _iterator5 = _createForOfIteratorHelperLoose(metadata.reexports.values()), _step5; !(_step5 = _iterator5()).done; ) {
          var _importName = _step5.value;
          if (_importName === "default")
            needsDefault = true;
          else
            needsNamed = true;
        }
        if (needsDefault && needsNamed) {
          metadata.interop = "namespace";
        } else if (needsDefault) {
          metadata.interop = "default";
        }
      }
      for (var _iterator3 = _createForOfIteratorHelperLoose(sourceData), _step3; !(_step3 = _iterator3()).done; ) {
        var _step3$value = _slicedToArray$12(_step3.value, 2), source = _step3$value[0], _metadata = _step3$value[1];
        if (lazy !== false && !(isSideEffectImport(_metadata) || _metadata.reexportAll)) {
          if (lazy === true) {
            _metadata.lazy = !/\./.test(source);
          } else if (Array.isArray(lazy)) {
            _metadata.lazy = lazy.indexOf(source) !== -1;
          } else if (typeof lazy === "function") {
            _metadata.lazy = lazy(source);
          } else {
            throw new Error(".lazy must be a boolean, string array, or function");
          }
        }
      }
      return {
        hasExports: hasExports2,
        local: localData,
        source: sourceData
      };
    }
    function getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers) {
      var bindingKindLookup = /* @__PURE__ */ new Map();
      programPath.get("body").forEach(function(child) {
        var kind;
        if (child.isImportDeclaration()) {
          kind = "import";
        } else {
          if (child.isExportDefaultDeclaration())
            child = child.get("declaration");
          if (child.isExportNamedDeclaration()) {
            if (child.node.declaration) {
              child = child.get("declaration");
            } else if (initializeReexports && child.node.source && child.get("source").isStringLiteral()) {
              child.get("specifiers").forEach(function(spec) {
                assertExportSpecifier(spec);
                bindingKindLookup.set(spec.get("local").node.name, "block");
              });
              return;
            }
          }
          if (child.isFunctionDeclaration()) {
            kind = "hoisted";
          } else if (child.isClassDeclaration()) {
            kind = "block";
          } else if (child.isVariableDeclaration({
            kind: "var"
          })) {
            kind = "var";
          } else if (child.isVariableDeclaration()) {
            kind = "block";
          } else {
            return;
          }
        }
        Object.keys(child.getOuterBindingIdentifiers()).forEach(function(name2) {
          bindingKindLookup.set(name2, kind);
        });
      });
      var localMetadata = /* @__PURE__ */ new Map();
      var getLocalMetadata = function getLocalMetadata2(idPath) {
        var localName = idPath.node.name;
        var metadata = localMetadata.get(localName);
        if (!metadata) {
          var kind = bindingKindLookup.get(localName);
          if (kind === void 0) {
            throw idPath.buildCodeFrameError('Exporting local "' + localName + '", which is not declared.');
          }
          metadata = {
            names: [],
            kind
          };
          localMetadata.set(localName, metadata);
        }
        return metadata;
      };
      programPath.get("body").forEach(function(child) {
        if (child.isExportNamedDeclaration() && (initializeReexports || !child.node.source)) {
          if (child.node.declaration) {
            var declaration = child.get("declaration");
            var ids2 = declaration.getOuterBindingIdentifierPaths();
            Object.keys(ids2).forEach(function(name2) {
              if (name2 === "__esModule") {
                throw declaration.buildCodeFrameError('Illegal export "__esModule".');
              }
              getLocalMetadata(ids2[name2]).names.push(name2);
            });
          } else {
            child.get("specifiers").forEach(function(spec) {
              var local = spec.get("local");
              var exported = spec.get("exported");
              var localMetadata2 = getLocalMetadata(local);
              var exportName = getExportSpecifierName$1(exported, stringSpecifiers);
              if (exportName === "__esModule") {
                throw exported.buildCodeFrameError('Illegal export "__esModule".');
              }
              localMetadata2.names.push(exportName);
            });
          }
        } else if (child.isExportDefaultDeclaration()) {
          var _declaration = child.get("declaration");
          if (_declaration.isFunctionDeclaration() || _declaration.isClassDeclaration()) {
            getLocalMetadata(_declaration.get("id")).names.push("default");
          } else {
            throw _declaration.buildCodeFrameError("Unexpected default expression export.");
          }
        }
      });
      return localMetadata;
    }
    function nameAnonymousExports(programPath) {
      programPath.get("body").forEach(function(child) {
        if (!child.isExportDefaultDeclaration())
          return;
        splitExportDeclaration(child);
      });
    }
    function removeModuleDeclarations(programPath) {
      programPath.get("body").forEach(function(child) {
        if (child.isImportDeclaration()) {
          child.remove();
        } else if (child.isExportNamedDeclaration()) {
          if (child.node.declaration) {
            child.node.declaration._blockHoist = child.node._blockHoist;
            child.replaceWith(child.node.declaration);
          } else {
            child.remove();
          }
        } else if (child.isExportDefaultDeclaration()) {
          var declaration = child.get("declaration");
          if (declaration.isFunctionDeclaration() || declaration.isClassDeclaration()) {
            declaration._blockHoist = child.node._blockHoist;
            child.replaceWith(declaration);
          } else {
            throw declaration.buildCodeFrameError("Unexpected default expression export.");
          }
        } else if (child.isExportAllDeclaration()) {
          child.remove();
        }
      });
    }
    {
      var originalGetModuleName = getModuleName;
      getModuleName = function getModuleName2(rootOpts, pluginOpts) {
        var _pluginOpts$moduleId, _pluginOpts$moduleIds, _pluginOpts$getModule, _pluginOpts$moduleRoo;
        return originalGetModuleName(rootOpts, {
          moduleId: (_pluginOpts$moduleId = pluginOpts.moduleId) != null ? _pluginOpts$moduleId : rootOpts.moduleId,
          moduleIds: (_pluginOpts$moduleIds = pluginOpts.moduleIds) != null ? _pluginOpts$moduleIds : rootOpts.moduleIds,
          getModuleId: (_pluginOpts$getModule = pluginOpts.getModuleId) != null ? _pluginOpts$getModule : rootOpts.getModuleId,
          moduleRoot: (_pluginOpts$moduleRoo = pluginOpts.moduleRoot) != null ? _pluginOpts$moduleRoo : rootOpts.moduleRoot
        });
      };
    }
    function getModuleName(rootOpts, pluginOpts) {
      var filename = rootOpts.filename, _rootOpts$filenameRel = rootOpts.filenameRelative, filenameRelative = _rootOpts$filenameRel === void 0 ? filename : _rootOpts$filenameRel, _rootOpts$sourceRoot = rootOpts.sourceRoot, sourceRoot = _rootOpts$sourceRoot === void 0 ? pluginOpts.moduleRoot : _rootOpts$sourceRoot;
      var moduleId = pluginOpts.moduleId, _pluginOpts$moduleIds2 = pluginOpts.moduleIds, moduleIds = _pluginOpts$moduleIds2 === void 0 ? !!moduleId : _pluginOpts$moduleIds2, getModuleId = pluginOpts.getModuleId, _pluginOpts$moduleRoo2 = pluginOpts.moduleRoot, moduleRoot = _pluginOpts$moduleRoo2 === void 0 ? sourceRoot : _pluginOpts$moduleRoo2;
      if (!moduleIds)
        return null;
      if (moduleId != null && !getModuleId) {
        return moduleId;
      }
      var moduleName = moduleRoot != null ? moduleRoot + "/" : "";
      if (filenameRelative) {
        var sourceRootReplacer = sourceRoot != null ? new RegExp("^" + sourceRoot + "/?") : "";
        moduleName += filenameRelative.replace(sourceRootReplacer, "").replace(/\.(\w*?)$/, "");
      }
      moduleName = moduleName.replace(/\\/g, "/");
      if (getModuleId) {
        return getModuleId(moduleName) || moduleName;
      } else {
        return moduleName;
      }
    }
    var _templateObject$m, _templateObject2$a, _templateObject3$9, _templateObject4$5, _templateObject5$3, _templateObject6$3, _templateObject7$2, _templateObject8$1, _templateObject9$1, _templateObject10$1, _templateObject11$1, _templateObject12$1, _templateObject13$1;
    var booleanLiteral$4 = booleanLiteral$5, callExpression$7 = callExpression$e, cloneNode$6 = cloneNode$i, directive = directive$1, directiveLiteral = directiveLiteral$1, expressionStatement$1 = expressionStatement$a, identifier$6 = identifier$j, isIdentifier$6 = isIdentifier$i, memberExpression$6 = memberExpression$b, stringLiteral$3 = stringLiteral$8, valueToNode = valueToNode$1, variableDeclaration$1 = variableDeclaration$7, variableDeclarator$1 = variableDeclarator$7;
    function rewriteModuleStatementsAndPrepareHeader(path2, _ref3) {
      var loose = _ref3.loose, exportName = _ref3.exportName, strict2 = _ref3.strict, allowTopLevelThis = _ref3.allowTopLevelThis, strictMode = _ref3.strictMode, noInterop = _ref3.noInterop, _ref$importInterop = _ref3.importInterop, importInterop = _ref$importInterop === void 0 ? noInterop ? "none" : "babel" : _ref$importInterop, lazy = _ref3.lazy, esNamespaceOnly = _ref3.esNamespaceOnly, _ref$constantReexport = _ref3.constantReexports, constantReexports = _ref$constantReexport === void 0 ? loose : _ref$constantReexport, _ref$enumerableModule = _ref3.enumerableModuleMeta, enumerableModuleMeta = _ref$enumerableModule === void 0 ? loose : _ref$enumerableModule, noIncompleteNsImportDetection = _ref3.noIncompleteNsImportDetection;
      validateImportInteropOption(importInterop);
      assert$1.exports(isModule(path2), "Cannot process module statements in a script");
      path2.node.sourceType = "script";
      var meta2 = normalizeModuleAndLoadMetadata(path2, exportName, {
        importInterop,
        initializeReexports: constantReexports,
        lazy,
        esNamespaceOnly
      });
      if (!allowTopLevelThis) {
        rewriteThis(path2);
      }
      rewriteLiveReferences(path2, meta2);
      if (strictMode !== false) {
        var hasStrict = path2.node.directives.some(function(directive2) {
          return directive2.value.value === "use strict";
        });
        if (!hasStrict) {
          path2.unshiftContainer("directives", directive(directiveLiteral("use strict")));
        }
      }
      var headers = [];
      if (hasExports(meta2) && !strict2) {
        headers.push(buildESModuleHeader(meta2, enumerableModuleMeta));
      }
      var nameList = buildExportNameListDeclaration(path2, meta2);
      if (nameList) {
        meta2.exportNameListName = nameList.name;
        headers.push(nameList.statement);
      }
      headers.push.apply(headers, _toConsumableArray2(buildExportInitializationStatements(path2, meta2, constantReexports, noIncompleteNsImportDetection)));
      return {
        meta: meta2,
        headers
      };
    }
    function ensureStatementsHoisted(statements2) {
      statements2.forEach(function(header) {
        header._blockHoist = 3;
      });
    }
    function wrapInterop(programPath, expr, type5) {
      if (type5 === "none") {
        return null;
      }
      if (type5 === "node-namespace") {
        return callExpression$7(programPath.hub.addHelper("interopRequireWildcard"), [expr, booleanLiteral$4(true)]);
      } else if (type5 === "node-default") {
        return null;
      }
      var helper2;
      if (type5 === "default") {
        helper2 = "interopRequireDefault";
      } else if (type5 === "namespace") {
        helper2 = "interopRequireWildcard";
      } else {
        throw new Error("Unknown interop: " + type5);
      }
      return callExpression$7(programPath.hub.addHelper(helper2), [expr]);
    }
    function buildNamespaceInitStatements(metadata, sourceMetadata, constantReexports) {
      if (constantReexports === void 0) {
        constantReexports = false;
      }
      var statements2 = [];
      var srcNamespace = identifier$6(sourceMetadata.name);
      if (sourceMetadata.lazy)
        srcNamespace = callExpression$7(srcNamespace, []);
      for (var _iterator2 = _createForOfIteratorHelperLoose(sourceMetadata.importsNamespace), _step2; !(_step2 = _iterator2()).done; ) {
        var localName = _step2.value;
        if (localName === sourceMetadata.name)
          continue;
        statements2.push(template$2.statement(_templateObject$m || (_templateObject$m = _taggedTemplateLiteralLoose(["var NAME = SOURCE;"])))({
          NAME: localName,
          SOURCE: cloneNode$6(srcNamespace)
        }));
      }
      if (constantReexports) {
        statements2.push.apply(statements2, _toConsumableArray2(buildReexportsFromMeta(metadata, sourceMetadata, true)));
      }
      for (var _iterator22 = _createForOfIteratorHelperLoose(sourceMetadata.reexportNamespace), _step22; !(_step22 = _iterator22()).done; ) {
        var exportName = _step22.value;
        statements2.push((sourceMetadata.lazy ? template$2.statement(_templateObject2$a || (_templateObject2$a = _taggedTemplateLiteralLoose(['\n            Object.defineProperty(EXPORTS, "NAME", {\n              enumerable: true,\n              get: function() {\n                return NAMESPACE;\n              }\n            });\n          ']))) : template$2.statement(_templateObject3$9 || (_templateObject3$9 = _taggedTemplateLiteralLoose(["EXPORTS.NAME = NAMESPACE;"]))))({
          EXPORTS: metadata.exportName,
          NAME: exportName,
          NAMESPACE: cloneNode$6(srcNamespace)
        }));
      }
      if (sourceMetadata.reexportAll) {
        var statement2 = buildNamespaceReexport(metadata, cloneNode$6(srcNamespace), constantReexports);
        statement2.loc = sourceMetadata.reexportAll.loc;
        statements2.push(statement2);
      }
      return statements2;
    }
    var ReexportTemplate = {
      constant: template$2.statement(_templateObject4$5 || (_templateObject4$5 = _taggedTemplateLiteralLoose(["EXPORTS.EXPORT_NAME = NAMESPACE_IMPORT;"]))),
      constantComputed: template$2.statement(_templateObject5$3 || (_templateObject5$3 = _taggedTemplateLiteralLoose(['EXPORTS["EXPORT_NAME"] = NAMESPACE_IMPORT;']))),
      spec: template$2.statement(_templateObject6$3 || (_templateObject6$3 = _taggedTemplateLiteralLoose(['\n    Object.defineProperty(EXPORTS, "EXPORT_NAME", {\n      enumerable: true,\n      get: function() {\n        return NAMESPACE_IMPORT;\n      },\n    });\n    '])))
    };
    var buildReexportsFromMeta = function buildReexportsFromMeta2(meta2, metadata, constantReexports) {
      var namespace = metadata.lazy ? callExpression$7(identifier$6(metadata.name), []) : identifier$6(metadata.name);
      var stringSpecifiers = meta2.stringSpecifiers;
      return Array.from(metadata.reexports, function(_ref22) {
        var _ref3 = _slicedToArray$12(_ref22, 2), exportName = _ref3[0], importName = _ref3[1];
        var NAMESPACE_IMPORT = cloneNode$6(namespace);
        if (importName === "default" && metadata.interop === "node-default")
          ;
        else if (stringSpecifiers.has(importName)) {
          NAMESPACE_IMPORT = memberExpression$6(NAMESPACE_IMPORT, stringLiteral$3(importName), true);
        } else {
          NAMESPACE_IMPORT = memberExpression$6(NAMESPACE_IMPORT, identifier$6(importName));
        }
        var astNodes = {
          EXPORTS: meta2.exportName,
          EXPORT_NAME: exportName,
          NAMESPACE_IMPORT
        };
        if (constantReexports || isIdentifier$6(NAMESPACE_IMPORT)) {
          if (stringSpecifiers.has(exportName)) {
            return ReexportTemplate.constantComputed(astNodes);
          } else {
            return ReexportTemplate.constant(astNodes);
          }
        } else {
          return ReexportTemplate.spec(astNodes);
        }
      });
    };
    function buildESModuleHeader(metadata, enumerableModuleMeta) {
      if (enumerableModuleMeta === void 0) {
        enumerableModuleMeta = false;
      }
      return (enumerableModuleMeta ? template$2.statement(_templateObject7$2 || (_templateObject7$2 = _taggedTemplateLiteralLoose(["\n        EXPORTS.__esModule = true;\n      "]))) : template$2.statement(_templateObject8$1 || (_templateObject8$1 = _taggedTemplateLiteralLoose(['\n        Object.defineProperty(EXPORTS, "__esModule", {\n          value: true,\n        });\n      ']))))({
        EXPORTS: metadata.exportName
      });
    }
    function buildNamespaceReexport(metadata, namespace, constantReexports) {
      return (constantReexports ? template$2.statement(_templateObject9$1 || (_templateObject9$1 = _taggedTemplateLiteralLoose(['\n        Object.keys(NAMESPACE).forEach(function(key) {\n          if (key === "default" || key === "__esModule") return;\n          VERIFY_NAME_LIST;\n          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;\n\n          EXPORTS[key] = NAMESPACE[key];\n        });\n      ']))) : template$2.statement(_templateObject10$1 || (_templateObject10$1 = _taggedTemplateLiteralLoose(['\n        Object.keys(NAMESPACE).forEach(function(key) {\n          if (key === "default" || key === "__esModule") return;\n          VERIFY_NAME_LIST;\n          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;\n\n          Object.defineProperty(EXPORTS, key, {\n            enumerable: true,\n            get: function() {\n              return NAMESPACE[key];\n            },\n          });\n        });\n    ']))))({
        NAMESPACE: namespace,
        EXPORTS: metadata.exportName,
        VERIFY_NAME_LIST: metadata.exportNameListName ? template$2(_templateObject11$1 || (_templateObject11$1 = _taggedTemplateLiteralLoose(["\n            if (Object.prototype.hasOwnProperty.call(EXPORTS_LIST, key)) return;\n          "])))({
          EXPORTS_LIST: metadata.exportNameListName
        }) : null
      });
    }
    function buildExportNameListDeclaration(programPath, metadata) {
      var exportedVars = /* @__PURE__ */ Object.create(null);
      for (var _iterator3 = _createForOfIteratorHelperLoose(metadata.local.values()), _step3; !(_step3 = _iterator3()).done; ) {
        var data3 = _step3.value;
        for (var _iterator5 = _createForOfIteratorHelperLoose(data3.names), _step5; !(_step5 = _iterator5()).done; ) {
          var _name = _step5.value;
          exportedVars[_name] = true;
        }
      }
      var hasReexport = false;
      for (var _iterator4 = _createForOfIteratorHelperLoose(metadata.source.values()), _step4; !(_step4 = _iterator4()).done; ) {
        var _data = _step4.value;
        for (var _iterator6 = _createForOfIteratorHelperLoose(_data.reexports.keys()), _step6; !(_step6 = _iterator6()).done; ) {
          var exportName = _step6.value;
          exportedVars[exportName] = true;
        }
        for (var _iterator7 = _createForOfIteratorHelperLoose(_data.reexportNamespace), _step7; !(_step7 = _iterator7()).done; ) {
          var _exportName = _step7.value;
          exportedVars[_exportName] = true;
        }
        hasReexport = hasReexport || !!_data.reexportAll;
      }
      if (!hasReexport || Object.keys(exportedVars).length === 0)
        return null;
      var name2 = programPath.scope.generateUidIdentifier("exportNames");
      delete exportedVars["default"];
      return {
        name: name2.name,
        statement: variableDeclaration$1("var", [variableDeclarator$1(name2, valueToNode(exportedVars))])
      };
    }
    function buildExportInitializationStatements(programPath, metadata, constantReexports, noIncompleteNsImportDetection) {
      if (constantReexports === void 0) {
        constantReexports = false;
      }
      if (noIncompleteNsImportDetection === void 0) {
        noIncompleteNsImportDetection = false;
      }
      var initStatements = [];
      for (var _iterator8 = _createForOfIteratorHelperLoose(metadata.local), _step8; !(_step8 = _iterator8()).done; ) {
        var _step8$value = _slicedToArray$12(_step8.value, 2), localName = _step8$value[0], data3 = _step8$value[1];
        if (data3.kind === "import")
          ;
        else if (data3.kind === "hoisted") {
          initStatements.push([data3.names[0], buildInitStatement(metadata, data3.names, identifier$6(localName))]);
        } else if (!noIncompleteNsImportDetection) {
          for (var _iterator11 = _createForOfIteratorHelperLoose(data3.names), _step11; !(_step11 = _iterator11()).done; ) {
            var _exportName2 = _step11.value;
            initStatements.push([_exportName2, null]);
          }
        }
      }
      for (var _iterator9 = _createForOfIteratorHelperLoose(metadata.source.values()), _step9; !(_step9 = _iterator9()).done; ) {
        var _data2 = _step9.value;
        if (!constantReexports) {
          var reexportsStatements = buildReexportsFromMeta(metadata, _data2, false);
          var reexports = _toConsumableArray2(_data2.reexports.keys());
          for (var _i3 = 0; _i3 < reexportsStatements.length; _i3++) {
            initStatements.push([reexports[_i3], reexportsStatements[_i3]]);
          }
        }
        if (!noIncompleteNsImportDetection) {
          for (var _iterator12 = _createForOfIteratorHelperLoose(_data2.reexportNamespace), _step12; !(_step12 = _iterator12()).done; ) {
            var _exportName3 = _step12.value;
            initStatements.push([_exportName3, null]);
          }
        }
      }
      initStatements.sort(function(_ref42, _ref5) {
        var _ref6 = _slicedToArray$12(_ref42, 1), a = _ref6[0];
        var _ref7 = _slicedToArray$12(_ref5, 1), b2 = _ref7[0];
        if (a < b2)
          return -1;
        if (b2 < a)
          return 1;
        return 0;
      });
      var results = [];
      if (noIncompleteNsImportDetection) {
        for (var _iterator10 = _createForOfIteratorHelperLoose(initStatements), _step10; !(_step10 = _iterator10()).done; ) {
          var _step10$value = _slicedToArray$12(_step10.value, 2), initStatement = _step10$value[1];
          results.push(initStatement);
        }
      } else {
        var chunkSize = 100;
        for (var i2 = 0; i2 < initStatements.length; i2 += chunkSize) {
          var uninitializedExportNames = [];
          for (var j = 0; j < chunkSize && i2 + j < initStatements.length; j++) {
            var _initStatements = _slicedToArray$12(initStatements[i2 + j], 2), exportName = _initStatements[0], _initStatement = _initStatements[1];
            if (_initStatement !== null) {
              if (uninitializedExportNames.length > 0) {
                results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
                uninitializedExportNames = [];
              }
              results.push(_initStatement);
            } else {
              uninitializedExportNames.push(exportName);
            }
          }
          if (uninitializedExportNames.length > 0) {
            results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
          }
        }
      }
      return results;
    }
    var InitTemplate = {
      computed: template$2.expression(_templateObject12$1 || (_templateObject12$1 = _taggedTemplateLiteralLoose(['EXPORTS["NAME"] = VALUE']))),
      "default": template$2.expression(_templateObject13$1 || (_templateObject13$1 = _taggedTemplateLiteralLoose(["EXPORTS.NAME = VALUE"])))
    };
    function buildInitStatement(metadata, exportNames, initExpr) {
      var stringSpecifiers = metadata.stringSpecifiers, EXPORTS = metadata.exportName;
      return expressionStatement$1(exportNames.reduce(function(acc, exportName) {
        var params = {
          EXPORTS,
          NAME: exportName,
          VALUE: acc
        };
        if (stringSpecifiers.has(exportName)) {
          return InitTemplate.computed(params);
        } else {
          return InitTemplate["default"](params);
        }
      }, initExpr));
    }
    var semver$b = { exports: {} };
    var hasRequiredSemver;
    function requireSemver() {
      if (hasRequiredSemver)
        return semver$b.exports;
      hasRequiredSemver = 1;
      (function(module2, exports3) {
        exports3 = module2.exports = SemVer2;
        var debug2;
        if (typeof browser$1$1 === "object" && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
          debug2 = function debug3() {
            var args = Array.prototype.slice.call(arguments, 0);
            args.unshift("SEMVER");
            console.log.apply(console, args);
          };
        } else {
          debug2 = function debug3() {
          };
        }
        exports3.SEMVER_SPEC_VERSION = "2.0.0";
        var MAX_LENGTH2 = 256;
        var MAX_SAFE_INTEGER3 = Number.MAX_SAFE_INTEGER || 9007199254740991;
        var MAX_SAFE_COMPONENT_LENGTH2 = 16;
        var re3 = exports3.re = [];
        var src2 = exports3.src = [];
        var t3 = exports3.tokens = {};
        var R2 = 0;
        function tok(n2) {
          t3[n2] = R2++;
        }
        tok("NUMERICIDENTIFIER");
        src2[t3.NUMERICIDENTIFIER] = "0|[1-9]\\d*";
        tok("NUMERICIDENTIFIERLOOSE");
        src2[t3.NUMERICIDENTIFIERLOOSE] = "[0-9]+";
        tok("NONNUMERICIDENTIFIER");
        src2[t3.NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
        tok("MAINVERSION");
        src2[t3.MAINVERSION] = "(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")";
        tok("MAINVERSIONLOOSE");
        src2[t3.MAINVERSIONLOOSE] = "(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")";
        tok("PRERELEASEIDENTIFIER");
        src2[t3.PRERELEASEIDENTIFIER] = "(?:" + src2[t3.NUMERICIDENTIFIER] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
        tok("PRERELEASEIDENTIFIERLOOSE");
        src2[t3.PRERELEASEIDENTIFIERLOOSE] = "(?:" + src2[t3.NUMERICIDENTIFIERLOOSE] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
        tok("PRERELEASE");
        src2[t3.PRERELEASE] = "(?:-(" + src2[t3.PRERELEASEIDENTIFIER] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIER] + ")*))";
        tok("PRERELEASELOOSE");
        src2[t3.PRERELEASELOOSE] = "(?:-?(" + src2[t3.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIERLOOSE] + ")*))";
        tok("BUILDIDENTIFIER");
        src2[t3.BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
        tok("BUILD");
        src2[t3.BUILD] = "(?:\\+(" + src2[t3.BUILDIDENTIFIER] + "(?:\\." + src2[t3.BUILDIDENTIFIER] + ")*))";
        tok("FULL");
        tok("FULLPLAIN");
        src2[t3.FULLPLAIN] = "v?" + src2[t3.MAINVERSION] + src2[t3.PRERELEASE] + "?" + src2[t3.BUILD] + "?";
        src2[t3.FULL] = "^" + src2[t3.FULLPLAIN] + "$";
        tok("LOOSEPLAIN");
        src2[t3.LOOSEPLAIN] = "[v=\\s]*" + src2[t3.MAINVERSIONLOOSE] + src2[t3.PRERELEASELOOSE] + "?" + src2[t3.BUILD] + "?";
        tok("LOOSE");
        src2[t3.LOOSE] = "^" + src2[t3.LOOSEPLAIN] + "$";
        tok("GTLT");
        src2[t3.GTLT] = "((?:<|>)?=?)";
        tok("XRANGEIDENTIFIERLOOSE");
        src2[t3.XRANGEIDENTIFIERLOOSE] = src2[t3.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
        tok("XRANGEIDENTIFIER");
        src2[t3.XRANGEIDENTIFIER] = src2[t3.NUMERICIDENTIFIER] + "|x|X|\\*";
        tok("XRANGEPLAIN");
        src2[t3.XRANGEPLAIN] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:" + src2[t3.PRERELEASE] + ")?" + src2[t3.BUILD] + "?)?)?";
        tok("XRANGEPLAINLOOSE");
        src2[t3.XRANGEPLAINLOOSE] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:" + src2[t3.PRERELEASELOOSE] + ")?" + src2[t3.BUILD] + "?)?)?";
        tok("XRANGE");
        src2[t3.XRANGE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAIN] + "$";
        tok("XRANGELOOSE");
        src2[t3.XRANGELOOSE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAINLOOSE] + "$";
        tok("COERCE");
        src2[t3.COERCE] = "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:$|[^\\d])";
        tok("COERCERTL");
        re3[t3.COERCERTL] = new RegExp(src2[t3.COERCE], "g");
        tok("LONETILDE");
        src2[t3.LONETILDE] = "(?:~>?)";
        tok("TILDETRIM");
        src2[t3.TILDETRIM] = "(\\s*)" + src2[t3.LONETILDE] + "\\s+";
        re3[t3.TILDETRIM] = new RegExp(src2[t3.TILDETRIM], "g");
        var tildeTrimReplace = "$1~";
        tok("TILDE");
        src2[t3.TILDE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAIN] + "$";
        tok("TILDELOOSE");
        src2[t3.TILDELOOSE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAINLOOSE] + "$";
        tok("LONECARET");
        src2[t3.LONECARET] = "(?:\\^)";
        tok("CARETTRIM");
        src2[t3.CARETTRIM] = "(\\s*)" + src2[t3.LONECARET] + "\\s+";
        re3[t3.CARETTRIM] = new RegExp(src2[t3.CARETTRIM], "g");
        var caretTrimReplace = "$1^";
        tok("CARET");
        src2[t3.CARET] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAIN] + "$";
        tok("CARETLOOSE");
        src2[t3.CARETLOOSE] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAINLOOSE] + "$";
        tok("COMPARATORLOOSE");
        src2[t3.COMPARATORLOOSE] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + ")$|^$";
        tok("COMPARATOR");
        src2[t3.COMPARATOR] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.FULLPLAIN] + ")$|^$";
        tok("COMPARATORTRIM");
        src2[t3.COMPARATORTRIM] = "(\\s*)" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + "|" + src2[t3.XRANGEPLAIN] + ")";
        re3[t3.COMPARATORTRIM] = new RegExp(src2[t3.COMPARATORTRIM], "g");
        var comparatorTrimReplace = "$1$2$3";
        tok("HYPHENRANGE");
        src2[t3.HYPHENRANGE] = "^\\s*(" + src2[t3.XRANGEPLAIN] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAIN] + ")\\s*$";
        tok("HYPHENRANGELOOSE");
        src2[t3.HYPHENRANGELOOSE] = "^\\s*(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s*$";
        tok("STAR");
        src2[t3.STAR] = "(<|>)?=?\\s*\\*";
        for (var i2 = 0; i2 < R2; i2++) {
          debug2(i2, src2[i2]);
          if (!re3[i2]) {
            re3[i2] = new RegExp(src2[i2]);
          }
        }
        exports3.parse = parse5;
        function parse5(version3, options) {
          if (!options || typeof options !== "object") {
            options = {
              loose: !!options,
              includePrerelease: false
            };
          }
          if (version3 instanceof SemVer2) {
            return version3;
          }
          if (typeof version3 !== "string") {
            return null;
          }
          if (version3.length > MAX_LENGTH2) {
            return null;
          }
          var r2 = options.loose ? re3[t3.LOOSE] : re3[t3.FULL];
          if (!r2.test(version3)) {
            return null;
          }
          try {
            return new SemVer2(version3, options);
          } catch (er) {
            return null;
          }
        }
        exports3.valid = valid;
        function valid(version3, options) {
          var v22 = parse5(version3, options);
          return v22 ? v22.version : null;
        }
        exports3.clean = clean;
        function clean(version3, options) {
          var s = parse5(version3.trim().replace(/^[=v]+/, ""), options);
          return s ? s.version : null;
        }
        exports3.SemVer = SemVer2;
        function SemVer2(version3, options) {
          if (!options || typeof options !== "object") {
            options = {
              loose: !!options,
              includePrerelease: false
            };
          }
          if (version3 instanceof SemVer2) {
            if (version3.loose === options.loose) {
              return version3;
            } else {
              version3 = version3.version;
            }
          } else if (typeof version3 !== "string") {
            throw new TypeError("Invalid Version: " + version3);
          }
          if (version3.length > MAX_LENGTH2) {
            throw new TypeError("version is longer than " + MAX_LENGTH2 + " characters");
          }
          if (!(this instanceof SemVer2)) {
            return new SemVer2(version3, options);
          }
          debug2("SemVer", version3, options);
          this.options = options;
          this.loose = !!options.loose;
          var m2 = version3.trim().match(options.loose ? re3[t3.LOOSE] : re3[t3.FULL]);
          if (!m2) {
            throw new TypeError("Invalid Version: " + version3);
          }
          this.raw = version3;
          this.major = +m2[1];
          this.minor = +m2[2];
          this.patch = +m2[3];
          if (this.major > MAX_SAFE_INTEGER3 || this.major < 0) {
            throw new TypeError("Invalid major version");
          }
          if (this.minor > MAX_SAFE_INTEGER3 || this.minor < 0) {
            throw new TypeError("Invalid minor version");
          }
          if (this.patch > MAX_SAFE_INTEGER3 || this.patch < 0) {
            throw new TypeError("Invalid patch version");
          }
          if (!m2[4]) {
            this.prerelease = [];
          } else {
            this.prerelease = m2[4].split(".").map(function(id3) {
              if (/^[0-9]+$/.test(id3)) {
                var num = +id3;
                if (num >= 0 && num < MAX_SAFE_INTEGER3) {
                  return num;
                }
              }
              return id3;
            });
          }
          this.build = m2[5] ? m2[5].split(".") : [];
          this.format();
        }
        SemVer2.prototype.format = function() {
          this.version = this.major + "." + this.minor + "." + this.patch;
          if (this.prerelease.length) {
            this.version += "-" + this.prerelease.join(".");
          }
          return this.version;
        };
        SemVer2.prototype.toString = function() {
          return this.version;
        };
        SemVer2.prototype.compare = function(other) {
          debug2("SemVer.compare", this.version, this.options, other);
          if (!(other instanceof SemVer2)) {
            other = new SemVer2(other, this.options);
          }
          return this.compareMain(other) || this.comparePre(other);
        };
        SemVer2.prototype.compareMain = function(other) {
          if (!(other instanceof SemVer2)) {
            other = new SemVer2(other, this.options);
          }
          return compareIdentifiers2(this.major, other.major) || compareIdentifiers2(this.minor, other.minor) || compareIdentifiers2(this.patch, other.patch);
        };
        SemVer2.prototype.comparePre = function(other) {
          if (!(other instanceof SemVer2)) {
            other = new SemVer2(other, this.options);
          }
          if (this.prerelease.length && !other.prerelease.length) {
            return -1;
          } else if (!this.prerelease.length && other.prerelease.length) {
            return 1;
          } else if (!this.prerelease.length && !other.prerelease.length) {
            return 0;
          }
          var i3 = 0;
          do {
            var a = this.prerelease[i3];
            var b2 = other.prerelease[i3];
            debug2("prerelease compare", i3, a, b2);
            if (a === void 0 && b2 === void 0) {
              return 0;
            } else if (b2 === void 0) {
              return 1;
            } else if (a === void 0) {
              return -1;
            } else if (a === b2) {
              continue;
            } else {
              return compareIdentifiers2(a, b2);
            }
          } while (++i3);
        };
        SemVer2.prototype.compareBuild = function(other) {
          if (!(other instanceof SemVer2)) {
            other = new SemVer2(other, this.options);
          }
          var i3 = 0;
          do {
            var a = this.build[i3];
            var b2 = other.build[i3];
            debug2("prerelease compare", i3, a, b2);
            if (a === void 0 && b2 === void 0) {
              return 0;
            } else if (b2 === void 0) {
              return 1;
            } else if (a === void 0) {
              return -1;
            } else if (a === b2) {
              continue;
            } else {
              return compareIdentifiers2(a, b2);
            }
          } while (++i3);
        };
        SemVer2.prototype.inc = function(release3, identifier2) {
          switch (release3) {
            case "premajor":
              this.prerelease.length = 0;
              this.patch = 0;
              this.minor = 0;
              this.major++;
              this.inc("pre", identifier2);
              break;
            case "preminor":
              this.prerelease.length = 0;
              this.patch = 0;
              this.minor++;
              this.inc("pre", identifier2);
              break;
            case "prepatch":
              this.prerelease.length = 0;
              this.inc("patch", identifier2);
              this.inc("pre", identifier2);
              break;
            case "prerelease":
              if (this.prerelease.length === 0) {
                this.inc("patch", identifier2);
              }
              this.inc("pre", identifier2);
              break;
            case "major":
              if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
                this.major++;
              }
              this.minor = 0;
              this.patch = 0;
              this.prerelease = [];
              break;
            case "minor":
              if (this.patch !== 0 || this.prerelease.length === 0) {
                this.minor++;
              }
              this.patch = 0;
              this.prerelease = [];
              break;
            case "patch":
              if (this.prerelease.length === 0) {
                this.patch++;
              }
              this.prerelease = [];
              break;
            case "pre":
              if (this.prerelease.length === 0) {
                this.prerelease = [0];
              } else {
                var i3 = this.prerelease.length;
                while (--i3 >= 0) {
                  if (typeof this.prerelease[i3] === "number") {
                    this.prerelease[i3]++;
                    i3 = -2;
                  }
                }
                if (i3 === -1) {
                  this.prerelease.push(0);
                }
              }
              if (identifier2) {
                if (this.prerelease[0] === identifier2) {
                  if (isNaN(this.prerelease[1])) {
                    this.prerelease = [identifier2, 0];
                  }
                } else {
                  this.prerelease = [identifier2, 0];
                }
              }
              break;
            default:
              throw new Error("invalid increment argument: " + release3);
          }
          this.format();
          this.raw = this.version;
          return this;
        };
        exports3.inc = inc;
        function inc(version3, release3, loose, identifier2) {
          if (typeof loose === "string") {
            identifier2 = loose;
            loose = void 0;
          }
          try {
            return new SemVer2(version3, loose).inc(release3, identifier2).version;
          } catch (er) {
            return null;
          }
        }
        exports3.diff = diff;
        function diff(version1, version22) {
          if (eq3(version1, version22)) {
            return null;
          } else {
            var v110 = parse5(version1);
            var v22 = parse5(version22);
            var prefix2 = "";
            if (v110.prerelease.length || v22.prerelease.length) {
              prefix2 = "pre";
              var defaultResult = "prerelease";
            }
            for (var key2 in v110) {
              if (key2 === "major" || key2 === "minor" || key2 === "patch") {
                if (v110[key2] !== v22[key2]) {
                  return prefix2 + key2;
                }
              }
            }
            return defaultResult;
          }
        }
        exports3.compareIdentifiers = compareIdentifiers2;
        var numeric2 = /^[0-9]+$/;
        function compareIdentifiers2(a, b2) {
          var anum = numeric2.test(a);
          var bnum = numeric2.test(b2);
          if (anum && bnum) {
            a = +a;
            b2 = +b2;
          }
          return a === b2 ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b2 ? -1 : 1;
        }
        exports3.rcompareIdentifiers = rcompareIdentifiers2;
        function rcompareIdentifiers2(a, b2) {
          return compareIdentifiers2(b2, a);
        }
        exports3.major = major;
        function major(a, loose) {
          return new SemVer2(a, loose).major;
        }
        exports3.minor = minor;
        function minor(a, loose) {
          return new SemVer2(a, loose).minor;
        }
        exports3.patch = patch2;
        function patch2(a, loose) {
          return new SemVer2(a, loose).patch;
        }
        exports3.compare = compare3;
        function compare3(a, b2, loose) {
          return new SemVer2(a, loose).compare(new SemVer2(b2, loose));
        }
        exports3.compareLoose = compareLoose;
        function compareLoose(a, b2) {
          return compare3(a, b2, true);
        }
        exports3.compareBuild = compareBuild;
        function compareBuild(a, b2, loose) {
          var versionA = new SemVer2(a, loose);
          var versionB = new SemVer2(b2, loose);
          return versionA.compare(versionB) || versionA.compareBuild(versionB);
        }
        exports3.rcompare = rcompare;
        function rcompare(a, b2, loose) {
          return compare3(b2, a, loose);
        }
        exports3.sort = sort2;
        function sort2(list2, loose) {
          return list2.sort(function(a, b2) {
            return exports3.compareBuild(a, b2, loose);
          });
        }
        exports3.rsort = rsort;
        function rsort(list2, loose) {
          return list2.sort(function(a, b2) {
            return exports3.compareBuild(b2, a, loose);
          });
        }
        exports3.gt = gt2;
        function gt2(a, b2, loose) {
          return compare3(a, b2, loose) > 0;
        }
        exports3.lt = lt3;
        function lt3(a, b2, loose) {
          return compare3(a, b2, loose) < 0;
        }
        exports3.eq = eq3;
        function eq3(a, b2, loose) {
          return compare3(a, b2, loose) === 0;
        }
        exports3.neq = neq2;
        function neq2(a, b2, loose) {
          return compare3(a, b2, loose) !== 0;
        }
        exports3.gte = gte2;
        function gte2(a, b2, loose) {
          return compare3(a, b2, loose) >= 0;
        }
        exports3.lte = lte2;
        function lte2(a, b2, loose) {
          return compare3(a, b2, loose) <= 0;
        }
        exports3.cmp = cmp2;
        function cmp2(a, op, b2, loose) {
          switch (op) {
            case "===":
              if (typeof a === "object")
                a = a.version;
              if (typeof b2 === "object")
                b2 = b2.version;
              return a === b2;
            case "!==":
              if (typeof a === "object")
                a = a.version;
              if (typeof b2 === "object")
                b2 = b2.version;
              return a !== b2;
            case "":
            case "=":
            case "==":
              return eq3(a, b2, loose);
            case "!=":
              return neq2(a, b2, loose);
            case ">":
              return gt2(a, b2, loose);
            case ">=":
              return gte2(a, b2, loose);
            case "<":
              return lt3(a, b2, loose);
            case "<=":
              return lte2(a, b2, loose);
            default:
              throw new TypeError("Invalid operator: " + op);
          }
        }
        exports3.Comparator = Comparator;
        function Comparator(comp, options) {
          if (!options || typeof options !== "object") {
            options = {
              loose: !!options,
              includePrerelease: false
            };
          }
          if (comp instanceof Comparator) {
            if (comp.loose === !!options.loose) {
              return comp;
            } else {
              comp = comp.value;
            }
          }
          if (!(this instanceof Comparator)) {
            return new Comparator(comp, options);
          }
          debug2("comparator", comp, options);
          this.options = options;
          this.loose = !!options.loose;
          this.parse(comp);
          if (this.semver === ANY) {
            this.value = "";
          } else {
            this.value = this.operator + this.semver.version;
          }
          debug2("comp", this);
        }
        var ANY = {};
        Comparator.prototype.parse = function(comp) {
          var r2 = this.options.loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
          var m2 = comp.match(r2);
          if (!m2) {
            throw new TypeError("Invalid comparator: " + comp);
          }
          this.operator = m2[1] !== void 0 ? m2[1] : "";
          if (this.operator === "=") {
            this.operator = "";
          }
          if (!m2[2]) {
            this.semver = ANY;
          } else {
            this.semver = new SemVer2(m2[2], this.options.loose);
          }
        };
        Comparator.prototype.toString = function() {
          return this.value;
        };
        Comparator.prototype.test = function(version3) {
          debug2("Comparator.test", version3, this.options.loose);
          if (this.semver === ANY || version3 === ANY) {
            return true;
          }
          if (typeof version3 === "string") {
            try {
              version3 = new SemVer2(version3, this.options);
            } catch (er) {
              return false;
            }
          }
          return cmp2(version3, this.operator, this.semver, this.options);
        };
        Comparator.prototype.intersects = function(comp, options) {
          if (!(comp instanceof Comparator)) {
            throw new TypeError("a Comparator is required");
          }
          if (!options || typeof options !== "object") {
            options = {
              loose: !!options,
              includePrerelease: false
            };
          }
          var rangeTmp;
          if (this.operator === "") {
            if (this.value === "") {
              return true;
            }
            rangeTmp = new Range(comp.value, options);
            return satisfies(this.value, rangeTmp, options);
          } else if (comp.operator === "") {
            if (comp.value === "") {
              return true;
            }
            rangeTmp = new Range(this.value, options);
            return satisfies(comp.semver, rangeTmp, options);
          }
          var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
          var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
          var sameSemVer = this.semver.version === comp.semver.version;
          var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
          var oppositeDirectionsLessThan = cmp2(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
          var oppositeDirectionsGreaterThan = cmp2(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
          return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
        };
        exports3.Range = Range;
        function Range(range3, options) {
          if (!options || typeof options !== "object") {
            options = {
              loose: !!options,
              includePrerelease: false
            };
          }
          if (range3 instanceof Range) {
            if (range3.loose === !!options.loose && range3.includePrerelease === !!options.includePrerelease) {
              return range3;
            } else {
              return new Range(range3.raw, options);
            }
          }
          if (range3 instanceof Comparator) {
            return new Range(range3.value, options);
          }
          if (!(this instanceof Range)) {
            return new Range(range3, options);
          }
          this.options = options;
          this.loose = !!options.loose;
          this.includePrerelease = !!options.includePrerelease;
          this.raw = range3;
          this.set = range3.split(/\s*\|\|\s*/).map(function(range4) {
            return this.parseRange(range4.trim());
          }, this).filter(function(c2) {
            return c2.length;
          });
          if (!this.set.length) {
            throw new TypeError("Invalid SemVer Range: " + range3);
          }
          this.format();
        }
        Range.prototype.format = function() {
          this.range = this.set.map(function(comps) {
            return comps.join(" ").trim();
          }).join("||").trim();
          return this.range;
        };
        Range.prototype.toString = function() {
          return this.range;
        };
        Range.prototype.parseRange = function(range3) {
          var loose = this.options.loose;
          range3 = range3.trim();
          var hr = loose ? re3[t3.HYPHENRANGELOOSE] : re3[t3.HYPHENRANGE];
          range3 = range3.replace(hr, hyphenReplace);
          debug2("hyphen replace", range3);
          range3 = range3.replace(re3[t3.COMPARATORTRIM], comparatorTrimReplace);
          debug2("comparator trim", range3, re3[t3.COMPARATORTRIM]);
          range3 = range3.replace(re3[t3.TILDETRIM], tildeTrimReplace);
          range3 = range3.replace(re3[t3.CARETTRIM], caretTrimReplace);
          range3 = range3.split(/\s+/).join(" ");
          var compRe = loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
          var set3 = range3.split(" ").map(function(comp) {
            return parseComparator(comp, this.options);
          }, this).join(" ").split(/\s+/);
          if (this.options.loose) {
            set3 = set3.filter(function(comp) {
              return !!comp.match(compRe);
            });
          }
          set3 = set3.map(function(comp) {
            return new Comparator(comp, this.options);
          }, this);
          return set3;
        };
        Range.prototype.intersects = function(range3, options) {
          if (!(range3 instanceof Range)) {
            throw new TypeError("a Range is required");
          }
          return this.set.some(function(thisComparators) {
            return isSatisfiable(thisComparators, options) && range3.set.some(function(rangeComparators) {
              return isSatisfiable(rangeComparators, options) && thisComparators.every(function(thisComparator) {
                return rangeComparators.every(function(rangeComparator) {
                  return thisComparator.intersects(rangeComparator, options);
                });
              });
            });
          });
        };
        function isSatisfiable(comparators, options) {
          var result = true;
          var remainingComparators = comparators.slice();
          var testComparator = remainingComparators.pop();
          while (result && remainingComparators.length) {
            result = remainingComparators.every(function(otherComparator) {
              return testComparator.intersects(otherComparator, options);
            });
            testComparator = remainingComparators.pop();
          }
          return result;
        }
        exports3.toComparators = toComparators;
        function toComparators(range3, options) {
          return new Range(range3, options).set.map(function(comp) {
            return comp.map(function(c2) {
              return c2.value;
            }).join(" ").trim().split(" ");
          });
        }
        function parseComparator(comp, options) {
          debug2("comp", comp, options);
          comp = replaceCarets(comp, options);
          debug2("caret", comp);
          comp = replaceTildes(comp, options);
          debug2("tildes", comp);
          comp = replaceXRanges(comp, options);
          debug2("xrange", comp);
          comp = replaceStars(comp, options);
          debug2("stars", comp);
          return comp;
        }
        function isX(id3) {
          return !id3 || id3.toLowerCase() === "x" || id3 === "*";
        }
        function replaceTildes(comp, options) {
          return comp.trim().split(/\s+/).map(function(comp2) {
            return replaceTilde(comp2, options);
          }).join(" ");
        }
        function replaceTilde(comp, options) {
          var r2 = options.loose ? re3[t3.TILDELOOSE] : re3[t3.TILDE];
          return comp.replace(r2, function(_, M2, m2, p2, pr) {
            debug2("tilde", comp, _, M2, m2, p2, pr);
            var ret;
            if (isX(M2)) {
              ret = "";
            } else if (isX(m2)) {
              ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
            } else if (isX(p2)) {
              ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
            } else if (pr) {
              debug2("replaceTilde pr", pr);
              ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
            } else {
              ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
            }
            debug2("tilde return", ret);
            return ret;
          });
        }
        function replaceCarets(comp, options) {
          return comp.trim().split(/\s+/).map(function(comp2) {
            return replaceCaret(comp2, options);
          }).join(" ");
        }
        function replaceCaret(comp, options) {
          debug2("caret", comp, options);
          var r2 = options.loose ? re3[t3.CARETLOOSE] : re3[t3.CARET];
          return comp.replace(r2, function(_, M2, m2, p2, pr) {
            debug2("caret", comp, _, M2, m2, p2, pr);
            var ret;
            if (isX(M2)) {
              ret = "";
            } else if (isX(m2)) {
              ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
            } else if (isX(p2)) {
              if (M2 === "0") {
                ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
              } else {
                ret = ">=" + M2 + "." + m2 + ".0 <" + (+M2 + 1) + ".0.0";
              }
            } else if (pr) {
              debug2("replaceCaret pr", pr);
              if (M2 === "0") {
                if (m2 === "0") {
                  ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + m2 + "." + (+p2 + 1);
                } else {
                  ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
                }
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + (+M2 + 1) + ".0.0";
              }
            } else {
              debug2("no pr");
              if (M2 === "0") {
                if (m2 === "0") {
                  ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + m2 + "." + (+p2 + 1);
                } else {
                  ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
                }
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + (+M2 + 1) + ".0.0";
              }
            }
            debug2("caret return", ret);
            return ret;
          });
        }
        function replaceXRanges(comp, options) {
          debug2("replaceXRanges", comp, options);
          return comp.split(/\s+/).map(function(comp2) {
            return replaceXRange(comp2, options);
          }).join(" ");
        }
        function replaceXRange(comp, options) {
          comp = comp.trim();
          var r2 = options.loose ? re3[t3.XRANGELOOSE] : re3[t3.XRANGE];
          return comp.replace(r2, function(ret, gtlt, M2, m2, p2, pr) {
            debug2("xRange", comp, ret, gtlt, M2, m2, p2, pr);
            var xM = isX(M2);
            var xm = xM || isX(m2);
            var xp = xm || isX(p2);
            var anyX = xp;
            if (gtlt === "=" && anyX) {
              gtlt = "";
            }
            pr = options.includePrerelease ? "-0" : "";
            if (xM) {
              if (gtlt === ">" || gtlt === "<") {
                ret = "<0.0.0-0";
              } else {
                ret = "*";
              }
            } else if (gtlt && anyX) {
              if (xm) {
                m2 = 0;
              }
              p2 = 0;
              if (gtlt === ">") {
                gtlt = ">=";
                if (xm) {
                  M2 = +M2 + 1;
                  m2 = 0;
                  p2 = 0;
                } else {
                  m2 = +m2 + 1;
                  p2 = 0;
                }
              } else if (gtlt === "<=") {
                gtlt = "<";
                if (xm) {
                  M2 = +M2 + 1;
                } else {
                  m2 = +m2 + 1;
                }
              }
              ret = gtlt + M2 + "." + m2 + "." + p2 + pr;
            } else if (xm) {
              ret = ">=" + M2 + ".0.0" + pr + " <" + (+M2 + 1) + ".0.0" + pr;
            } else if (xp) {
              ret = ">=" + M2 + "." + m2 + ".0" + pr + " <" + M2 + "." + (+m2 + 1) + ".0" + pr;
            }
            debug2("xRange return", ret);
            return ret;
          });
        }
        function replaceStars(comp, options) {
          debug2("replaceStars", comp, options);
          return comp.trim().replace(re3[t3.STAR], "");
        }
        function hyphenReplace($0, from2, fM, fm, fp, fpr, fb2, to, tM, tm, tp, tpr, tb2) {
          if (isX(fM)) {
            from2 = "";
          } else if (isX(fm)) {
            from2 = ">=" + fM + ".0.0";
          } else if (isX(fp)) {
            from2 = ">=" + fM + "." + fm + ".0";
          } else {
            from2 = ">=" + from2;
          }
          if (isX(tM)) {
            to = "";
          } else if (isX(tm)) {
            to = "<" + (+tM + 1) + ".0.0";
          } else if (isX(tp)) {
            to = "<" + tM + "." + (+tm + 1) + ".0";
          } else if (tpr) {
            to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
          } else {
            to = "<=" + to;
          }
          return (from2 + " " + to).trim();
        }
        Range.prototype.test = function(version3) {
          if (!version3) {
            return false;
          }
          if (typeof version3 === "string") {
            try {
              version3 = new SemVer2(version3, this.options);
            } catch (er) {
              return false;
            }
          }
          for (var i3 = 0; i3 < this.set.length; i3++) {
            if (testSet(this.set[i3], version3, this.options)) {
              return true;
            }
          }
          return false;
        };
        function testSet(set3, version3, options) {
          for (var i3 = 0; i3 < set3.length; i3++) {
            if (!set3[i3].test(version3)) {
              return false;
            }
          }
          if (version3.prerelease.length && !options.includePrerelease) {
            for (i3 = 0; i3 < set3.length; i3++) {
              debug2(set3[i3].semver);
              if (set3[i3].semver === ANY) {
                continue;
              }
              if (set3[i3].semver.prerelease.length > 0) {
                var allowed = set3[i3].semver;
                if (allowed.major === version3.major && allowed.minor === version3.minor && allowed.patch === version3.patch) {
                  return true;
                }
              }
            }
            return false;
          }
          return true;
        }
        exports3.satisfies = satisfies;
        function satisfies(version3, range3, options) {
          try {
            range3 = new Range(range3, options);
          } catch (er) {
            return false;
          }
          return range3.test(version3);
        }
        exports3.maxSatisfying = maxSatisfying;
        function maxSatisfying(versions2, range3, options) {
          var max3 = null;
          var maxSV = null;
          try {
            var rangeObj = new Range(range3, options);
          } catch (er) {
            return null;
          }
          versions2.forEach(function(v22) {
            if (rangeObj.test(v22)) {
              if (!max3 || maxSV.compare(v22) === -1) {
                max3 = v22;
                maxSV = new SemVer2(max3, options);
              }
            }
          });
          return max3;
        }
        exports3.minSatisfying = minSatisfying;
        function minSatisfying(versions2, range3, options) {
          var min4 = null;
          var minSV = null;
          try {
            var rangeObj = new Range(range3, options);
          } catch (er) {
            return null;
          }
          versions2.forEach(function(v22) {
            if (rangeObj.test(v22)) {
              if (!min4 || minSV.compare(v22) === 1) {
                min4 = v22;
                minSV = new SemVer2(min4, options);
              }
            }
          });
          return min4;
        }
        exports3.minVersion = minVersion2;
        function minVersion2(range3, loose) {
          range3 = new Range(range3, loose);
          var minver = new SemVer2("0.0.0");
          if (range3.test(minver)) {
            return minver;
          }
          minver = new SemVer2("0.0.0-0");
          if (range3.test(minver)) {
            return minver;
          }
          minver = null;
          for (var i3 = 0; i3 < range3.set.length; ++i3) {
            var comparators = range3.set[i3];
            comparators.forEach(function(comparator) {
              var compver = new SemVer2(comparator.semver.version);
              switch (comparator.operator) {
                case ">":
                  if (compver.prerelease.length === 0) {
                    compver.patch++;
                  } else {
                    compver.prerelease.push(0);
                  }
                  compver.raw = compver.format();
                case "":
                case ">=":
                  if (!minver || gt2(minver, compver)) {
                    minver = compver;
                  }
                  break;
                case "<":
                case "<=":
                  break;
                default:
                  throw new Error("Unexpected operation: " + comparator.operator);
              }
            });
          }
          if (minver && range3.test(minver)) {
            return minver;
          }
          return null;
        }
        exports3.validRange = validRange;
        function validRange(range3, options) {
          try {
            return new Range(range3, options).range || "*";
          } catch (er) {
            return null;
          }
        }
        exports3.ltr = ltr;
        function ltr(version3, range3, options) {
          return outside(version3, range3, "<", options);
        }
        exports3.gtr = gtr;
        function gtr(version3, range3, options) {
          return outside(version3, range3, ">", options);
        }
        exports3.outside = outside;
        function outside(version3, range3, hilo, options) {
          version3 = new SemVer2(version3, options);
          range3 = new Range(range3, options);
          var gtfn, ltefn, ltfn, comp, ecomp;
          switch (hilo) {
            case ">":
              gtfn = gt2;
              ltefn = lte2;
              ltfn = lt3;
              comp = ">";
              ecomp = ">=";
              break;
            case "<":
              gtfn = lt3;
              ltefn = gte2;
              ltfn = gt2;
              comp = "<";
              ecomp = "<=";
              break;
            default:
              throw new TypeError('Must provide a hilo val of "<" or ">"');
          }
          if (satisfies(version3, range3, options)) {
            return false;
          }
          for (var i3 = 0; i3 < range3.set.length; ++i3) {
            var comparators = range3.set[i3];
            var high = null;
            var low = null;
            comparators.forEach(function(comparator) {
              if (comparator.semver === ANY) {
                comparator = new Comparator(">=0.0.0");
              }
              high = high || comparator;
              low = low || comparator;
              if (gtfn(comparator.semver, high.semver, options)) {
                high = comparator;
              } else if (ltfn(comparator.semver, low.semver, options)) {
                low = comparator;
              }
            });
            if (high.operator === comp || high.operator === ecomp) {
              return false;
            }
            if ((!low.operator || low.operator === comp) && ltefn(version3, low.semver)) {
              return false;
            } else if (low.operator === ecomp && ltfn(version3, low.semver)) {
              return false;
            }
          }
          return true;
        }
        exports3.prerelease = prerelease;
        function prerelease(version3, options) {
          var parsed = parse5(version3, options);
          return parsed && parsed.prerelease.length ? parsed.prerelease : null;
        }
        exports3.intersects = intersects;
        function intersects(r1, r2, options) {
          r1 = new Range(r1, options);
          r2 = new Range(r2, options);
          return r1.intersects(r2);
        }
        exports3.coerce = coerce2;
        function coerce2(version3, options) {
          if (version3 instanceof SemVer2) {
            return version3;
          }
          if (typeof version3 === "number") {
            version3 = String(version3);
          }
          if (typeof version3 !== "string") {
            return null;
          }
          options = options || {};
          var match = null;
          if (!options.rtl) {
            match = version3.match(re3[t3.COERCE]);
          } else {
            var next;
            while ((next = re3[t3.COERCERTL].exec(version3)) && (!match || match.index + match[0].length !== version3.length)) {
              if (!match || next.index + next[0].length !== match.index + match[0].length) {
                match = next;
              }
              re3[t3.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
            }
            re3[t3.COERCERTL].lastIndex = -1;
          }
          if (match === null) {
            return null;
          }
          return parse5(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
        }
      })(semver$b, semver$b.exports);
      return semver$b.exports;
    }
    var semver$a = requireSemver();
    var cloneNode$5 = cloneNode$i, interpreterDirective = interpreterDirective$1;
    var errorVisitor = {
      enter: function enter(path2, state) {
        var loc = path2.node.loc;
        if (loc) {
          state.loc = loc;
          path2.stop();
        }
      }
    };
    var File = function() {
      function File2(options, _ref3) {
        var _this = this;
        var code3 = _ref3.code, ast3 = _ref3.ast, inputMap = _ref3.inputMap;
        this._map = /* @__PURE__ */ new Map();
        this.opts = void 0;
        this.declarations = {};
        this.path = null;
        this.ast = {};
        this.scope = void 0;
        this.metadata = {};
        this.code = "";
        this.inputMap = null;
        this.hub = {
          file: this,
          getCode: function getCode() {
            return _this.code;
          },
          getScope: function getScope() {
            return _this.scope;
          },
          addHelper: this.addHelper.bind(this),
          buildError: this.buildCodeFrameError.bind(this)
        };
        this.opts = options;
        this.code = code3;
        this.ast = ast3;
        this.inputMap = inputMap;
        this.path = NodePath.get({
          hub: this.hub,
          parentPath: null,
          parent: this.ast,
          container: this.ast,
          key: "program"
        }).setContext();
        this.scope = this.path.scope;
      }
      var _proto = File2.prototype;
      _proto.set = function set3(key2, val) {
        if (key2 === "helpersNamespace") {
          throw new Error("Babel 7.0.0-beta.56 has dropped support for the 'helpersNamespace' utility.If you are using @babel/plugin-external-helpers you will need to use a newer version than the one you currently have installed. If you have your own implementation, you'll want to explore using 'helperGenerator' alongside 'file.availableHelper()'.");
        }
        this._map.set(key2, val);
      };
      _proto.get = function get3(key2) {
        return this._map.get(key2);
      };
      _proto.has = function has3(key2) {
        return this._map.has(key2);
      };
      _proto.getModuleName = function getModuleName$1() {
        return getModuleName(this.opts, this.opts);
      };
      _proto.addImport = function addImport() {
        throw new Error("This API has been removed. If you're looking for this functionality in Babel 7, you should import the '@babel/helper-module-imports' module and use the functions exposed  from that module, such as 'addNamed' or 'addDefault'.");
      };
      _proto.availableHelper = function availableHelper(name2, versionRange) {
        var minVersion$1;
        try {
          minVersion$1 = minVersion(name2);
        } catch (err) {
          if (err.code !== "BABEL_HELPER_UNKNOWN")
            throw err;
          return false;
        }
        if (typeof versionRange !== "string")
          return true;
        if (semver$a.valid(versionRange))
          versionRange = "^" + versionRange;
        return !semver$a.intersects("<" + minVersion$1, versionRange) && !semver$a.intersects(">=8.0.0", versionRange);
      };
      _proto.addHelper = function addHelper(name2) {
        var _this2 = this;
        var declar = this.declarations[name2];
        if (declar)
          return cloneNode$5(declar);
        var generator = this.get("helperGenerator");
        if (generator) {
          var res2 = generator(name2);
          if (res2)
            return res2;
        }
        ensure(name2, File2);
        var uid2 = this.declarations[name2] = this.scope.generateUidIdentifier(name2);
        var dependencies2 = {};
        for (var _iterator2 = _createForOfIteratorHelperLoose(getDependencies2(name2)), _step2; !(_step2 = _iterator2()).done; ) {
          var dep = _step2.value;
          dependencies2[dep] = this.addHelper(dep);
        }
        var _helpers$get = get$12(name2, function(dep2) {
          return dependencies2[dep2];
        }, uid2, Object.keys(this.scope.getAllBindings())), nodes2 = _helpers$get.nodes, globals2 = _helpers$get.globals;
        globals2.forEach(function(name3) {
          if (_this2.path.scope.hasBinding(name3, true)) {
            _this2.path.scope.rename(name3);
          }
        });
        nodes2.forEach(function(node2) {
          node2._compact = true;
        });
        this.path.unshiftContainer("body", nodes2);
        this.path.get("body").forEach(function(path2) {
          if (nodes2.indexOf(path2.node) === -1)
            return;
          if (path2.isVariableDeclaration())
            _this2.scope.registerDeclaration(path2);
        });
        return uid2;
      };
      _proto.addTemplateObject = function addTemplateObject() {
        throw new Error("This function has been moved into the template literal transform itself.");
      };
      _proto.buildCodeFrameError = function buildCodeFrameError(node2, msg2, _Error) {
        if (_Error === void 0) {
          _Error = SyntaxError;
        }
        var loc = node2 && (node2.loc || node2._loc);
        if (!loc && node2) {
          var state = {
            loc: null
          };
          traverse(node2, errorVisitor, this.scope, state);
          loc = state.loc;
          var txt = "This is an error on an internal node. Probably an internal error.";
          if (loc)
            txt += " Location has been estimated.";
          msg2 += " (" + txt + ")";
        }
        if (loc) {
          var _this$opts$highlightC = this.opts.highlightCode, highlightCode = _this$opts$highlightC === void 0 ? true : _this$opts$highlightC;
          msg2 += "\n" + codeFrameColumns(this.code, {
            start: {
              line: loc.start.line,
              column: loc.start.column + 1
            },
            end: loc.end && loc.start.line === loc.end.line ? {
              line: loc.end.line,
              column: loc.end.column + 1
            } : void 0
          }, {
            highlightCode
          });
        }
        return new _Error(msg2);
      };
      _createClass2(File2, [{
        key: "shebang",
        get: function get3() {
          var interpreter = this.path.node.interpreter;
          return interpreter ? interpreter.value : "";
        },
        set: function set3(value) {
          if (value) {
            this.path.get("interpreter").replaceWith(interpreterDirective(value));
          } else {
            this.path.get("interpreter").remove();
          }
        }
      }]);
      return File2;
    }();
    var _templateObject$l;
    var arrayExpression$1 = arrayExpression$2, assignmentExpression$4 = assignmentExpression$c, binaryExpression$1 = binaryExpression$4, blockStatement$1 = blockStatement$6, callExpression$6 = callExpression$e, cloneNode$4 = cloneNode$i, conditionalExpression$1 = conditionalExpression$3, exportNamedDeclaration = exportNamedDeclaration$2, exportSpecifier = exportSpecifier$2, expressionStatement = expressionStatement$a, functionExpression$2 = functionExpression$3, identifier$5 = identifier$j, memberExpression$5 = memberExpression$b, objectExpression$2 = objectExpression$4, program = program$3, stringLiteral$2 = stringLiteral$8, unaryExpression = unaryExpression$6, variableDeclaration = variableDeclaration$7, variableDeclarator = variableDeclarator$7;
    var buildUmdWrapper = function buildUmdWrapper2(replacements) {
      return template$2.statement(_templateObject$l || (_templateObject$l = _taggedTemplateLiteralLoose(['\n    (function (root, factory) {\n      if (typeof define === "function" && define.amd) {\n        define(AMD_ARGUMENTS, factory);\n      } else if (typeof exports === "object") {\n        factory(COMMON_ARGUMENTS);\n      } else {\n        factory(BROWSER_ARGUMENTS);\n      }\n    })(UMD_ROOT, function (FACTORY_PARAMETERS) {\n      FACTORY_BODY\n    });\n  '])))(replacements);
    };
    function buildGlobal(allowlist) {
      var namespace = identifier$5("babelHelpers");
      var body = [];
      var container2 = functionExpression$2(null, [identifier$5("global")], blockStatement$1(body));
      var tree = program([expressionStatement(callExpression$6(container2, [conditionalExpression$1(binaryExpression$1("===", unaryExpression("typeof", identifier$5("global")), stringLiteral$2("undefined")), identifier$5("self"), identifier$5("global"))]))]);
      body.push(variableDeclaration("var", [variableDeclarator(namespace, assignmentExpression$4("=", memberExpression$5(identifier$5("global"), namespace), objectExpression$2([])))]));
      buildHelpers(body, namespace, allowlist);
      return tree;
    }
    function buildModule(allowlist) {
      var body = [];
      var refs = buildHelpers(body, null, allowlist);
      body.unshift(exportNamedDeclaration(null, Object.keys(refs).map(function(name2) {
        return exportSpecifier(cloneNode$4(refs[name2]), identifier$5(name2));
      })));
      return program(body, [], "module");
    }
    function buildUmd(allowlist) {
      var namespace = identifier$5("babelHelpers");
      var body = [];
      body.push(variableDeclaration("var", [variableDeclarator(namespace, identifier$5("global"))]));
      buildHelpers(body, namespace, allowlist);
      return program([buildUmdWrapper({
        FACTORY_PARAMETERS: identifier$5("global"),
        BROWSER_ARGUMENTS: assignmentExpression$4("=", memberExpression$5(identifier$5("root"), namespace), objectExpression$2([])),
        COMMON_ARGUMENTS: identifier$5("exports"),
        AMD_ARGUMENTS: arrayExpression$1([stringLiteral$2("exports")]),
        FACTORY_BODY: body,
        UMD_ROOT: identifier$5("this")
      })]);
    }
    function buildVar(allowlist) {
      var namespace = identifier$5("babelHelpers");
      var body = [];
      body.push(variableDeclaration("var", [variableDeclarator(namespace, objectExpression$2([]))]));
      var tree = program(body);
      buildHelpers(body, namespace, allowlist);
      body.push(expressionStatement(namespace));
      return tree;
    }
    function buildHelpers(body, namespace, allowlist) {
      var getHelperReference = function getHelperReference2(name2) {
        return namespace ? memberExpression$5(namespace, identifier$5(name2)) : identifier$5("_" + name2);
      };
      var refs = {};
      list.forEach(function(name2) {
        if (allowlist && allowlist.indexOf(name2) < 0)
          return;
        var ref2 = refs[name2] = getHelperReference(name2);
        ensure(name2, File);
        var _helpers$get = get$12(name2, getHelperReference, ref2), nodes2 = _helpers$get.nodes;
        body.push.apply(body, _toConsumableArray2(nodes2));
      });
      return refs;
    }
    function babelBuildExternalHelpers(allowlist, outputType) {
      if (outputType === void 0) {
        outputType = "global";
      }
      var tree;
      var build2 = {
        global: buildGlobal,
        module: buildModule,
        umd: buildUmd,
        "var": buildVar
      }[outputType];
      if (build2) {
        tree = build2(allowlist);
      } else {
        throw new Error("Unsupported output type " + outputType);
      }
      return generate$12(tree).code;
    }
    var _marked$9 = regenerator2.mark(findPackageData), _marked2$5 = regenerator2.mark(findRelativeConfig), _marked3$3 = regenerator2.mark(findRootConfig), _marked4$2 = regenerator2.mark(loadConfig$1), _marked5$2 = regenerator2.mark(resolveShowConfigPath);
    function findConfigUpwards(rootDir) {
      return null;
    }
    function findPackageData(filepath) {
      return regenerator2.wrap(function findPackageData$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", {
                filepath,
                directories: [],
                pkg: null,
                isPackage: false
              });
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$9);
    }
    function findRelativeConfig(pkgData, envName, caller) {
      return regenerator2.wrap(function findRelativeConfig$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", {
                config: null,
                ignore: null
              });
            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _marked2$5);
    }
    function findRootConfig(dirname2, envName, caller) {
      return regenerator2.wrap(function findRootConfig$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt("return", null);
            case 1:
            case "end":
              return _context3.stop();
          }
        }
      }, _marked3$3);
    }
    function loadConfig$1(name2, dirname2, envName, caller) {
      return regenerator2.wrap(function loadConfig$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              throw new Error("Cannot load " + name2 + " relative to " + dirname2 + " in a browser");
            case 1:
            case "end":
              return _context4.stop();
          }
        }
      }, _marked4$2);
    }
    function resolveShowConfigPath(dirname2) {
      return regenerator2.wrap(function resolveShowConfigPath$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              return _context5.abrupt("return", null);
            case 1:
            case "end":
              return _context5.stop();
          }
        }
      }, _marked5$2);
    }
    var ROOT_CONFIG_FILENAMES = [];
    function resolvePlugin(name2, dirname2) {
      return null;
    }
    function resolvePreset(name2, dirname2) {
      return null;
    }
    function loadPlugin(name2, dirname2) {
      throw new Error("Cannot load plugin " + name2 + " relative to " + dirname2 + " in a browser");
    }
    function loadPreset(name2, dirname2) {
      throw new Error("Cannot load preset " + name2 + " relative to " + dirname2 + " in a browser");
    }
    function getEnv(defaultValue) {
      if (defaultValue === void 0) {
        defaultValue = "development";
      }
      return browser$1$1.env.BABEL_ENV || void 0 || defaultValue;
    }
    var GENSYNC_START = Symbol["for"]("gensync:v1:start");
    var GENSYNC_SUSPEND = Symbol["for"]("gensync:v1:suspend");
    var GENSYNC_EXPECTED_START = "GENSYNC_EXPECTED_START";
    var GENSYNC_EXPECTED_SUSPEND = "GENSYNC_EXPECTED_SUSPEND";
    var GENSYNC_OPTIONS_ERROR = "GENSYNC_OPTIONS_ERROR";
    var GENSYNC_RACE_NONEMPTY = "GENSYNC_RACE_NONEMPTY";
    var GENSYNC_ERRBACK_NO_CALLBACK = "GENSYNC_ERRBACK_NO_CALLBACK";
    var gensync = Object.assign(function gensync2(optsOrFn) {
      var genFn = optsOrFn;
      if (typeof optsOrFn !== "function") {
        genFn = newGenerator(optsOrFn);
      } else {
        genFn = wrapGenerator(optsOrFn);
      }
      return Object.assign(genFn, makeFunctionAPI(genFn));
    }, {
      all: buildOperation({
        name: "all",
        arity: 1,
        sync: function sync(args) {
          var items = Array.from(args[0]);
          return items.map(function(item) {
            return evaluateSync(item);
          });
        },
        async: function async(args, resolve2, reject) {
          var items = Array.from(args[0]);
          if (items.length === 0) {
            Promise.resolve().then(function() {
              return resolve2([]);
            });
            return;
          }
          var count2 = 0;
          var results = items.map(function() {
            return void 0;
          });
          items.forEach(function(item, i2) {
            evaluateAsync(item, function(val) {
              results[i2] = val;
              count2 += 1;
              if (count2 === results.length)
                resolve2(results);
            }, reject);
          });
        }
      }),
      race: buildOperation({
        name: "race",
        arity: 1,
        sync: function sync(args) {
          var items = Array.from(args[0]);
          if (items.length === 0) {
            throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
          }
          return evaluateSync(items[0]);
        },
        async: function async(args, resolve2, reject) {
          var items = Array.from(args[0]);
          if (items.length === 0) {
            throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
          }
          for (var _i3 = 0, _items = items; _i3 < _items.length; _i3++) {
            var item = _items[_i3];
            evaluateAsync(item, resolve2, reject);
          }
        }
      })
    });
    function makeFunctionAPI(genFn) {
      var fns = {
        sync: function sync() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          return evaluateSync(genFn.apply(this, args));
        },
        async: function async() {
          var _this = this;
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }
          return new Promise(function(resolve2, reject) {
            evaluateAsync(genFn.apply(_this, args), resolve2, reject);
          });
        },
        errback: function errback() {
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }
          var cb2 = args.pop();
          if (typeof cb2 !== "function") {
            throw makeError("Asynchronous function called without callback", GENSYNC_ERRBACK_NO_CALLBACK);
          }
          var gen;
          try {
            gen = genFn.apply(this, args);
          } catch (err) {
            cb2(err);
            return;
          }
          evaluateAsync(gen, function(val) {
            return cb2(void 0, val);
          }, function(err) {
            return cb2(err);
          });
        }
      };
      return fns;
    }
    function assertTypeof(type5, name2, value, allowUndefined) {
      if (typeof value === type5 || allowUndefined && typeof value === "undefined") {
        return;
      }
      var msg2;
      if (allowUndefined) {
        msg2 = "Expected opts." + name2 + " to be either a " + type5 + ", or undefined.";
      } else {
        msg2 = "Expected opts." + name2 + " to be a " + type5 + ".";
      }
      throw makeError(msg2, GENSYNC_OPTIONS_ERROR);
    }
    function makeError(msg2, code3) {
      return Object.assign(new Error(msg2), {
        code: code3
      });
    }
    function newGenerator(_ref3) {
      var name2 = _ref3.name, arity = _ref3.arity, _sync = _ref3.sync, _async = _ref3.async, errback = _ref3.errback;
      assertTypeof("string", "name", name2, true);
      assertTypeof("number", "arity", arity, true);
      assertTypeof("function", "sync", _sync);
      assertTypeof("function", "async", _async, true);
      assertTypeof("function", "errback", errback, true);
      if (_async && errback) {
        throw makeError("Expected one of either opts.async or opts.errback, but got _both_.", GENSYNC_OPTIONS_ERROR);
      }
      if (typeof name2 !== "string") {
        var fnName;
        if (errback && errback.name && errback.name !== "errback") {
          fnName = errback.name;
        }
        if (_async && _async.name && _async.name !== "async") {
          fnName = _async.name.replace(/Async$/, "");
        }
        if (_sync && _sync.name && _sync.name !== "sync") {
          fnName = _sync.name.replace(/Sync$/, "");
        }
        if (typeof fnName === "string") {
          name2 = fnName;
        }
      }
      if (typeof arity !== "number") {
        arity = _sync.length;
      }
      return buildOperation({
        name: name2,
        arity,
        sync: function sync(args) {
          return _sync.apply(this, args);
        },
        async: function async(args, resolve2, reject) {
          if (_async) {
            _async.apply(this, args).then(resolve2, reject);
          } else if (errback) {
            errback.call.apply(errback, [this].concat(_toConsumableArray2(args), [function(err, value) {
              if (err == null)
                resolve2(value);
              else
                reject(err);
            }]));
          } else {
            resolve2(_sync.apply(this, args));
          }
        }
      });
    }
    function wrapGenerator(genFn) {
      return setFunctionMetadata(genFn.name, genFn.length, function() {
        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }
        return genFn.apply(this, args);
      });
    }
    function buildOperation(_ref22) {
      var name2 = _ref22.name, arity = _ref22.arity, sync = _ref22.sync, async = _ref22.async;
      return setFunctionMetadata(name2, arity, regenerator2.mark(function _callee() {
        var resume, _len5, args, _key5, res2, result, _args = arguments;
        return regenerator2.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return GENSYNC_START;
              case 2:
                resume = _context.sent;
                for (_len5 = _args.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
                  args[_key5] = _args[_key5];
                }
                if (resume) {
                  _context.next = 7;
                  break;
                }
                res2 = sync.call(this, args);
                return _context.abrupt("return", res2);
              case 7:
                try {
                  async.call(this, args, function(value) {
                    if (result)
                      return;
                    result = {
                      value
                    };
                    resume();
                  }, function(err) {
                    if (result)
                      return;
                    result = {
                      err
                    };
                    resume();
                  });
                } catch (err) {
                  result = {
                    err
                  };
                  resume();
                }
                _context.next = 10;
                return GENSYNC_SUSPEND;
              case 10:
                if (!result.hasOwnProperty("err")) {
                  _context.next = 12;
                  break;
                }
                throw result.err;
              case 12:
                return _context.abrupt("return", result.value);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
    function evaluateSync(gen) {
      var value;
      while (!(_gen$next = gen.next(), value = _gen$next.value, _gen$next).done) {
        var _gen$next;
        assertStart(value, gen);
      }
      return value;
    }
    function evaluateAsync(gen, resolve2, reject) {
      (function step() {
        try {
          var value;
          var _loop3 = function _loop4() {
            assertStart(value, gen);
            var sync = true;
            var didSyncResume = false;
            var out2 = gen.next(function() {
              if (sync) {
                didSyncResume = true;
              } else {
                step();
              }
            });
            sync = false;
            assertSuspend(out2, gen);
            if (!didSyncResume) {
              return {
                v: void 0
              };
            }
          };
          while (!(_gen$next2 = gen.next(), value = _gen$next2.value, _gen$next2).done) {
            var _gen$next2;
            var _ret2 = _loop3();
            if (typeof _ret2 === "object")
              return _ret2.v;
          }
          return resolve2(value);
        } catch (err) {
          return reject(err);
        }
      })();
    }
    function assertStart(value, gen) {
      if (value === GENSYNC_START)
        return;
      throwError2(gen, makeError("Got unexpected yielded value in gensync generator: " + JSON.stringify(value) + ". Did you perhaps mean to use 'yield*' instead of 'yield'?", GENSYNC_EXPECTED_START));
    }
    function assertSuspend(_ref3, gen) {
      var value = _ref3.value, done = _ref3.done;
      if (!done && value === GENSYNC_SUSPEND)
        return;
      throwError2(gen, makeError(done ? "Unexpected generator completion. If you get this, it is probably a gensync bug." : "Expected GENSYNC_SUSPEND, got " + JSON.stringify(value) + ". If you get this, it is probably a gensync bug.", GENSYNC_EXPECTED_SUSPEND));
    }
    function throwError2(gen, err) {
      if (gen["throw"])
        gen["throw"](err);
      throw err;
    }
    function setFunctionMetadata(name2, arity, fn) {
      if (typeof name2 === "string") {
        var nameDesc = Object.getOwnPropertyDescriptor(fn, "name");
        if (!nameDesc || nameDesc.configurable) {
          Object.defineProperty(fn, "name", Object.assign(nameDesc || {}, {
            configurable: true,
            value: name2
          }));
        }
      }
      if (typeof arity === "number") {
        var lengthDesc = Object.getOwnPropertyDescriptor(fn, "length");
        if (!lengthDesc || lengthDesc.configurable) {
          Object.defineProperty(fn, "length", Object.assign(lengthDesc || {}, {
            configurable: true,
            value: arity
          }));
        }
      }
      return fn;
    }
    var id2 = function id3(x2) {
      return x2;
    };
    var runGenerator = gensync(regenerator2.mark(function _callee(item) {
      return regenerator2.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(item, "t0", 1);
            case 1:
              return _context.abrupt("return", _context.t0);
            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    var isAsync = gensync({
      sync: function sync() {
        return false;
      },
      errback: function errback(cb2) {
        return cb2(null, true);
      }
    });
    function maybeAsync(fn, message) {
      return gensync({
        sync: function sync() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          var result = fn.apply(this, args);
          if (isThenable$1(result))
            throw new Error(message);
          return result;
        },
        async: function async() {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }
          return Promise.resolve(fn.apply(this, args));
        }
      });
    }
    var withKind = gensync({
      sync: function sync(cb2) {
        return cb2("sync");
      },
      async: function async(cb2) {
        return cb2("async");
      }
    });
    function forwardAsync(action, cb2) {
      var g2 = gensync(action);
      return withKind(function(kind) {
        var adapted = g2[kind];
        return cb2(adapted);
      });
    }
    var onFirstPause = gensync({
      name: "onFirstPause",
      arity: 2,
      sync: function sync(item) {
        return runGenerator.sync(item);
      },
      errback: function errback(item, firstPause, cb2) {
        var completed = false;
        runGenerator.errback(item, function(err, value) {
          completed = true;
          cb2(err, value);
        });
        if (!completed) {
          firstPause();
        }
      }
    });
    var waitFor = gensync({
      sync: id2,
      async: id2
    });
    function isThenable$1(val) {
      return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
    }
    function mergeOptions(target, source) {
      for (var _i3 = 0, _Object$keys3 = Object.keys(source); _i3 < _Object$keys3.length; _i3++) {
        var k2 = _Object$keys3[_i3];
        if ((k2 === "parserOpts" || k2 === "generatorOpts" || k2 === "assumptions") && source[k2]) {
          var parserOpts = source[k2];
          var targetObj = target[k2] || (target[k2] = {});
          mergeDefaultFields(targetObj, parserOpts);
        } else {
          var val = source[k2];
          if (val !== void 0)
            target[k2] = val;
        }
      }
    }
    function mergeDefaultFields(target, source) {
      for (var _i22 = 0, _Object$keys22 = Object.keys(source); _i22 < _Object$keys22.length; _i22++) {
        var k2 = _Object$keys22[_i22];
        var val = source[k2];
        if (val !== void 0)
          target[k2] = val;
      }
    }
    function isIterableIterator(value) {
      return !!value && typeof value.next === "function" && typeof value[Symbol.iterator] === "function";
    }
    function finalize(deepArr) {
      return Object.freeze(deepArr);
    }
    function flattenToSet(arr) {
      var result = /* @__PURE__ */ new Set();
      var stack = [arr];
      while (stack.length > 0) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(stack.pop()), _step2; !(_step2 = _iterator2()).done; ) {
          var el = _step2.value;
          if (Array.isArray(el))
            stack.push(el);
          else
            result.add(el);
        }
      }
      return result;
    }
    var Plugin$1 = _createClass2(function Plugin2(plugin2, options, key2, externalDependencies) {
      if (externalDependencies === void 0) {
        externalDependencies = finalize([]);
      }
      this.key = void 0;
      this.manipulateOptions = void 0;
      this.post = void 0;
      this.pre = void 0;
      this.visitor = void 0;
      this.parserOverride = void 0;
      this.generatorOverride = void 0;
      this.options = void 0;
      this.externalDependencies = void 0;
      this.key = plugin2.name || key2;
      this.manipulateOptions = plugin2.manipulateOptions;
      this.post = plugin2.post;
      this.pre = plugin2.pre;
      this.visitor = plugin2.visitor || {};
      this.parserOverride = plugin2.parserOverride;
      this.generatorOverride = plugin2.generatorOverride;
      this.options = options;
      this.externalDependencies = externalDependencies;
    });
    var _marked$8 = regenerator2.mark(genTrue), _marked2$4 = regenerator2.mark(getCachedValue), _marked3$2 = regenerator2.mark(getCachedValueOrWait);
    var synchronize = function synchronize2(gen) {
      return gensync(gen).sync;
    };
    function genTrue() {
      return regenerator2.wrap(function genTrue$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", true);
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$8);
    }
    function makeWeakCache(handler) {
      return makeCachedFunction(WeakMap, handler);
    }
    function makeWeakCacheSync(handler) {
      return synchronize(makeWeakCache(handler));
    }
    function makeStrongCache(handler) {
      return makeCachedFunction(Map, handler);
    }
    function makeStrongCacheSync(handler) {
      return synchronize(makeStrongCache(handler));
    }
    function makeCachedFunction(CallCache, handler) {
      var callCacheSync = new CallCache();
      var callCacheAsync = new CallCache();
      var futureCache = new CallCache();
      return regenerator2.mark(function cachedFunction(arg, data3) {
        var asyncContext, callCache, cached2, cache2, handlerResult, finishLock, value, gen;
        return regenerator2.wrap(function cachedFunction$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.delegateYield(isAsync(), "t0", 1);
              case 1:
                asyncContext = _context2.t0;
                callCache = asyncContext ? callCacheAsync : callCacheSync;
                return _context2.delegateYield(getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data3), "t1", 4);
              case 4:
                cached2 = _context2.t1;
                if (!cached2.valid) {
                  _context2.next = 7;
                  break;
                }
                return _context2.abrupt("return", cached2.value);
              case 7:
                cache2 = new CacheConfigurator(data3);
                handlerResult = handler(arg, cache2);
                if (!isIterableIterator(handlerResult)) {
                  _context2.next = 15;
                  break;
                }
                gen = handlerResult;
                return _context2.delegateYield(onFirstPause(gen, function() {
                  finishLock = setupAsyncLocks(cache2, futureCache, arg);
                }), "t2", 12);
              case 12:
                value = _context2.t2;
                _context2.next = 16;
                break;
              case 15:
                value = handlerResult;
              case 16:
                updateFunctionCache(callCache, cache2, arg, value);
                if (finishLock) {
                  futureCache["delete"](arg);
                  finishLock.release(value);
                }
                return _context2.abrupt("return", value);
              case 19:
              case "end":
                return _context2.stop();
            }
          }
        }, cachedFunction);
      });
    }
    function getCachedValue(cache2, arg, data3) {
      var cachedValue, _iterator2, _step2, _step$value, _value, valid;
      return regenerator2.wrap(function getCachedValue$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              cachedValue = cache2.get(arg);
              if (!cachedValue) {
                _context3.next = 10;
                break;
              }
              _iterator2 = _createForOfIteratorHelperLoose(cachedValue);
            case 3:
              if ((_step2 = _iterator2()).done) {
                _context3.next = 10;
                break;
              }
              _step$value = _step2.value, _value = _step$value.value, valid = _step$value.valid;
              return _context3.delegateYield(valid(data3), "t0", 6);
            case 6:
              if (!_context3.t0) {
                _context3.next = 8;
                break;
              }
              return _context3.abrupt("return", {
                valid: true,
                value: _value
              });
            case 8:
              _context3.next = 3;
              break;
            case 10:
              return _context3.abrupt("return", {
                valid: false,
                value: null
              });
            case 11:
            case "end":
              return _context3.stop();
          }
        }
      }, _marked2$4);
    }
    function getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data3) {
      var cached2, _cached, _value2;
      return regenerator2.wrap(function getCachedValueOrWait$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.delegateYield(getCachedValue(callCache, arg, data3), "t0", 1);
            case 1:
              cached2 = _context4.t0;
              if (!cached2.valid) {
                _context4.next = 4;
                break;
              }
              return _context4.abrupt("return", cached2);
            case 4:
              if (!asyncContext) {
                _context4.next = 11;
                break;
              }
              return _context4.delegateYield(getCachedValue(futureCache, arg, data3), "t1", 6);
            case 6:
              _cached = _context4.t1;
              if (!_cached.valid) {
                _context4.next = 11;
                break;
              }
              return _context4.delegateYield(waitFor(_cached.value.promise), "t2", 9);
            case 9:
              _value2 = _context4.t2;
              return _context4.abrupt("return", {
                valid: true,
                value: _value2
              });
            case 11:
              return _context4.abrupt("return", {
                valid: false,
                value: null
              });
            case 12:
            case "end":
              return _context4.stop();
          }
        }
      }, _marked3$2);
    }
    function setupAsyncLocks(config3, futureCache, arg) {
      var finishLock = new Lock();
      updateFunctionCache(futureCache, config3, arg, finishLock);
      return finishLock;
    }
    function updateFunctionCache(cache2, config3, arg, value) {
      if (!config3.configured())
        config3.forever();
      var cachedValue = cache2.get(arg);
      config3.deactivate();
      switch (config3.mode()) {
        case "forever":
          cachedValue = [{
            value,
            valid: genTrue
          }];
          cache2.set(arg, cachedValue);
          break;
        case "invalidate":
          cachedValue = [{
            value,
            valid: config3.validator()
          }];
          cache2.set(arg, cachedValue);
          break;
        case "valid":
          if (cachedValue) {
            cachedValue.push({
              value,
              valid: config3.validator()
            });
          } else {
            cachedValue = [{
              value,
              valid: config3.validator()
            }];
            cache2.set(arg, cachedValue);
          }
      }
    }
    var CacheConfigurator = function() {
      function CacheConfigurator2(data3) {
        this._active = true;
        this._never = false;
        this._forever = false;
        this._invalidate = false;
        this._configured = false;
        this._pairs = [];
        this._data = void 0;
        this._data = data3;
      }
      var _proto = CacheConfigurator2.prototype;
      _proto.simple = function simple() {
        return makeSimpleConfigurator(this);
      };
      _proto.mode = function mode() {
        if (this._never)
          return "never";
        if (this._forever)
          return "forever";
        if (this._invalidate)
          return "invalidate";
        return "valid";
      };
      _proto.forever = function forever() {
        if (!this._active) {
          throw new Error("Cannot change caching after evaluation has completed.");
        }
        if (this._never) {
          throw new Error("Caching has already been configured with .never()");
        }
        this._forever = true;
        this._configured = true;
      };
      _proto.never = function never() {
        if (!this._active) {
          throw new Error("Cannot change caching after evaluation has completed.");
        }
        if (this._forever) {
          throw new Error("Caching has already been configured with .forever()");
        }
        this._never = true;
        this._configured = true;
      };
      _proto.using = function using(handler) {
        var _this = this;
        if (!this._active) {
          throw new Error("Cannot change caching after evaluation has completed.");
        }
        if (this._never || this._forever) {
          throw new Error("Caching has already been configured with .never or .forever()");
        }
        this._configured = true;
        var key2 = handler(this._data);
        var fn = maybeAsync(handler, "You appear to be using an async cache handler, but Babel has been called synchronously");
        if (isThenable$1(key2)) {
          return key2.then(function(key3) {
            _this._pairs.push([key3, fn]);
            return key3;
          });
        }
        this._pairs.push([key2, fn]);
        return key2;
      };
      _proto.invalidate = function invalidate(handler) {
        this._invalidate = true;
        return this.using(handler);
      };
      _proto.validator = function validator() {
        var pairs = this._pairs;
        return regenerator2.mark(function _callee(data3) {
          var _iterator2, _step2, _step2$value, key2, fn;
          return regenerator2.wrap(function _callee$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _iterator2 = _createForOfIteratorHelperLoose(pairs);
                case 1:
                  if ((_step2 = _iterator2()).done) {
                    _context5.next = 10;
                    break;
                  }
                  _step2$value = _slicedToArray$12(_step2.value, 2), key2 = _step2$value[0], fn = _step2$value[1];
                  _context5.t0 = key2;
                  return _context5.delegateYield(fn(data3), "t1", 5);
                case 5:
                  _context5.t2 = _context5.t1;
                  if (!(_context5.t0 !== _context5.t2)) {
                    _context5.next = 8;
                    break;
                  }
                  return _context5.abrupt("return", false);
                case 8:
                  _context5.next = 1;
                  break;
                case 10:
                  return _context5.abrupt("return", true);
                case 11:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee);
        });
      };
      _proto.deactivate = function deactivate() {
        this._active = false;
      };
      _proto.configured = function configured() {
        return this._configured;
      };
      return _createClass2(CacheConfigurator2);
    }();
    function makeSimpleConfigurator(cache2) {
      function cacheFn(val) {
        if (typeof val === "boolean") {
          if (val)
            cache2.forever();
          else
            cache2.never();
          return;
        }
        return cache2.using(function() {
          return assertSimpleType(val());
        });
      }
      cacheFn.forever = function() {
        return cache2.forever();
      };
      cacheFn.never = function() {
        return cache2.never();
      };
      cacheFn.using = function(cb2) {
        return cache2.using(function() {
          return assertSimpleType(cb2());
        });
      };
      cacheFn.invalidate = function(cb2) {
        return cache2.invalidate(function() {
          return assertSimpleType(cb2());
        });
      };
      return cacheFn;
    }
    function assertSimpleType(value) {
      if (isThenable$1(value)) {
        throw new Error("You appear to be using an async cache handler, which your current version of Babel does not support. We may add support for this in the future, but if you're on the most recent version of @babel/core and still seeing this error, then you'll need to synchronously handle your caching logic.");
      }
      if (value != null && typeof value !== "string" && typeof value !== "boolean" && typeof value !== "number") {
        throw new Error("Cache keys must be either string, boolean, number, null, or undefined.");
      }
      return value;
    }
    var Lock = function() {
      function Lock2() {
        var _this2 = this;
        this.released = false;
        this.promise = void 0;
        this._resolve = void 0;
        this.promise = new Promise(function(resolve2) {
          _this2._resolve = resolve2;
        });
      }
      var _proto2 = Lock2.prototype;
      _proto2.release = function release3(value) {
        this.released = true;
        this._resolve(value);
      };
      return _createClass2(Lock2);
    }();
    var require$$0$9 = [
      {
        name: "nodejs",
        version: "0.2.0",
        date: "2011-08-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.3.0",
        date: "2011-08-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.4.0",
        date: "2011-08-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.5.0",
        date: "2011-08-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.6.0",
        date: "2011-11-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.7.0",
        date: "2012-01-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.8.0",
        date: "2012-06-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.9.0",
        date: "2012-07-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.10.0",
        date: "2013-03-11",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.11.0",
        date: "2013-03-28",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "0.12.0",
        date: "2015-02-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "4.0.0",
        date: "2015-09-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "4.1.0",
        date: "2015-09-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "4.2.0",
        date: "2015-10-12",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.3.0",
        date: "2016-02-09",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.4.0",
        date: "2016-03-08",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.5.0",
        date: "2016-08-16",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.6.0",
        date: "2016-09-27",
        lts: "Argon",
        security: true
      },
      {
        name: "nodejs",
        version: "4.7.0",
        date: "2016-12-06",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.8.0",
        date: "2017-02-21",
        lts: "Argon",
        security: false
      },
      {
        name: "nodejs",
        version: "4.9.0",
        date: "2018-03-28",
        lts: "Argon",
        security: true
      },
      {
        name: "nodejs",
        version: "5.0.0",
        date: "2015-10-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.1.0",
        date: "2015-11-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.2.0",
        date: "2015-12-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.3.0",
        date: "2015-12-15",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.4.0",
        date: "2016-01-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.5.0",
        date: "2016-01-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.6.0",
        date: "2016-02-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.7.0",
        date: "2016-02-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.8.0",
        date: "2016-03-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.9.0",
        date: "2016-03-16",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.10.0",
        date: "2016-04-01",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.11.0",
        date: "2016-04-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "5.12.0",
        date: "2016-06-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.0.0",
        date: "2016-04-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.1.0",
        date: "2016-05-05",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.2.0",
        date: "2016-05-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.3.0",
        date: "2016-07-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.4.0",
        date: "2016-08-12",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.5.0",
        date: "2016-08-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.6.0",
        date: "2016-09-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.7.0",
        date: "2016-09-27",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "6.8.0",
        date: "2016-10-12",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "6.9.0",
        date: "2016-10-18",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.10.0",
        date: "2017-02-21",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.11.0",
        date: "2017-06-06",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.12.0",
        date: "2017-11-06",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.13.0",
        date: "2018-02-10",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.14.0",
        date: "2018-03-28",
        lts: "Boron",
        security: true
      },
      {
        name: "nodejs",
        version: "6.15.0",
        date: "2018-11-27",
        lts: "Boron",
        security: true
      },
      {
        name: "nodejs",
        version: "6.16.0",
        date: "2018-12-26",
        lts: "Boron",
        security: false
      },
      {
        name: "nodejs",
        version: "6.17.0",
        date: "2019-02-28",
        lts: "Boron",
        security: true
      },
      {
        name: "nodejs",
        version: "7.0.0",
        date: "2016-10-25",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.1.0",
        date: "2016-11-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.2.0",
        date: "2016-11-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.3.0",
        date: "2016-12-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.4.0",
        date: "2017-01-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.5.0",
        date: "2017-01-31",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.6.0",
        date: "2017-02-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.7.0",
        date: "2017-02-28",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.8.0",
        date: "2017-03-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.9.0",
        date: "2017-04-11",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "7.10.0",
        date: "2017-05-02",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.0.0",
        date: "2017-05-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.1.0",
        date: "2017-06-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.2.0",
        date: "2017-07-19",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.3.0",
        date: "2017-08-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.4.0",
        date: "2017-08-15",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.5.0",
        date: "2017-09-12",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.6.0",
        date: "2017-09-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.7.0",
        date: "2017-10-11",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.8.0",
        date: "2017-10-24",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "8.9.0",
        date: "2017-10-31",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.10.0",
        date: "2018-03-06",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.11.0",
        date: "2018-03-28",
        lts: "Carbon",
        security: true
      },
      {
        name: "nodejs",
        version: "8.12.0",
        date: "2018-09-10",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.13.0",
        date: "2018-11-20",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.14.0",
        date: "2018-11-27",
        lts: "Carbon",
        security: true
      },
      {
        name: "nodejs",
        version: "8.15.0",
        date: "2018-12-26",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.16.0",
        date: "2019-04-16",
        lts: "Carbon",
        security: false
      },
      {
        name: "nodejs",
        version: "8.17.0",
        date: "2019-12-17",
        lts: "Carbon",
        security: true
      },
      {
        name: "nodejs",
        version: "9.0.0",
        date: "2017-10-31",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.1.0",
        date: "2017-11-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.2.0",
        date: "2017-11-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.3.0",
        date: "2017-12-12",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.4.0",
        date: "2018-01-10",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.5.0",
        date: "2018-01-31",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.6.0",
        date: "2018-02-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.7.0",
        date: "2018-03-01",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.8.0",
        date: "2018-03-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.9.0",
        date: "2018-03-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "9.10.0",
        date: "2018-03-28",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "9.11.0",
        date: "2018-04-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.0.0",
        date: "2018-04-24",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.1.0",
        date: "2018-05-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.2.0",
        date: "2018-05-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.3.0",
        date: "2018-05-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.4.0",
        date: "2018-06-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.5.0",
        date: "2018-06-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.6.0",
        date: "2018-07-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.7.0",
        date: "2018-07-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.8.0",
        date: "2018-08-01",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.9.0",
        date: "2018-08-15",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.10.0",
        date: "2018-09-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.11.0",
        date: "2018-09-19",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.12.0",
        date: "2018-10-10",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "10.13.0",
        date: "2018-10-30",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.14.0",
        date: "2018-11-27",
        lts: "Dubnium",
        security: true
      },
      {
        name: "nodejs",
        version: "10.15.0",
        date: "2018-12-26",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.16.0",
        date: "2019-05-28",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.17.0",
        date: "2019-10-22",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.18.0",
        date: "2019-12-17",
        lts: "Dubnium",
        security: true
      },
      {
        name: "nodejs",
        version: "10.19.0",
        date: "2020-02-05",
        lts: "Dubnium",
        security: true
      },
      {
        name: "nodejs",
        version: "10.20.0",
        date: "2020-03-26",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.21.0",
        date: "2020-06-02",
        lts: "Dubnium",
        security: true
      },
      {
        name: "nodejs",
        version: "10.22.0",
        date: "2020-07-21",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.23.0",
        date: "2020-10-27",
        lts: "Dubnium",
        security: false
      },
      {
        name: "nodejs",
        version: "10.24.0",
        date: "2021-02-23",
        lts: "Dubnium",
        security: true
      },
      {
        name: "nodejs",
        version: "11.0.0",
        date: "2018-10-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.1.0",
        date: "2018-10-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.2.0",
        date: "2018-11-15",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.3.0",
        date: "2018-11-27",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "11.4.0",
        date: "2018-12-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.5.0",
        date: "2018-12-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.6.0",
        date: "2018-12-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.7.0",
        date: "2019-01-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.8.0",
        date: "2019-01-24",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.9.0",
        date: "2019-01-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.10.0",
        date: "2019-02-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.11.0",
        date: "2019-03-05",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.12.0",
        date: "2019-03-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.13.0",
        date: "2019-03-28",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.14.0",
        date: "2019-04-10",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "11.15.0",
        date: "2019-04-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.0.0",
        date: "2019-04-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.1.0",
        date: "2019-04-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.2.0",
        date: "2019-05-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.3.0",
        date: "2019-05-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.4.0",
        date: "2019-06-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.5.0",
        date: "2019-06-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.6.0",
        date: "2019-07-03",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.7.0",
        date: "2019-07-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.8.0",
        date: "2019-08-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.9.0",
        date: "2019-08-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.10.0",
        date: "2019-09-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.11.0",
        date: "2019-09-25",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.12.0",
        date: "2019-10-11",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "12.13.0",
        date: "2019-10-21",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "12.14.0",
        date: "2019-12-17",
        lts: "Erbium",
        security: true
      },
      {
        name: "nodejs",
        version: "12.15.0",
        date: "2020-02-05",
        lts: "Erbium",
        security: true
      },
      {
        name: "nodejs",
        version: "12.16.0",
        date: "2020-02-11",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "12.17.0",
        date: "2020-05-26",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "12.18.0",
        date: "2020-06-02",
        lts: "Erbium",
        security: true
      },
      {
        name: "nodejs",
        version: "12.19.0",
        date: "2020-10-06",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "12.20.0",
        date: "2020-11-24",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "12.21.0",
        date: "2021-02-23",
        lts: "Erbium",
        security: true
      },
      {
        name: "nodejs",
        version: "12.22.0",
        date: "2021-03-30",
        lts: "Erbium",
        security: false
      },
      {
        name: "nodejs",
        version: "13.0.0",
        date: "2019-10-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.1.0",
        date: "2019-11-05",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.2.0",
        date: "2019-11-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.3.0",
        date: "2019-12-03",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.4.0",
        date: "2019-12-17",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "13.5.0",
        date: "2019-12-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.6.0",
        date: "2020-01-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.7.0",
        date: "2020-01-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.8.0",
        date: "2020-02-05",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "13.9.0",
        date: "2020-02-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.10.0",
        date: "2020-03-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.11.0",
        date: "2020-03-12",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.12.0",
        date: "2020-03-26",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.13.0",
        date: "2020-04-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "13.14.0",
        date: "2020-04-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.0.0",
        date: "2020-04-21",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.1.0",
        date: "2020-04-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.2.0",
        date: "2020-05-05",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.3.0",
        date: "2020-05-19",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.4.0",
        date: "2020-06-02",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "14.5.0",
        date: "2020-06-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.6.0",
        date: "2020-07-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.7.0",
        date: "2020-07-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.8.0",
        date: "2020-08-11",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.9.0",
        date: "2020-08-27",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.10.0",
        date: "2020-09-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.11.0",
        date: "2020-09-15",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "14.12.0",
        date: "2020-09-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.13.0",
        date: "2020-09-29",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.14.0",
        date: "2020-10-15",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "14.15.0",
        date: "2020-10-27",
        lts: "Fermium",
        security: false
      },
      {
        name: "nodejs",
        version: "14.16.0",
        date: "2021-02-23",
        lts: "Fermium",
        security: true
      },
      {
        name: "nodejs",
        version: "14.17.0",
        date: "2021-05-11",
        lts: "Fermium",
        security: false
      },
      {
        name: "nodejs",
        version: "14.18.0",
        date: "2021-09-28",
        lts: "Fermium",
        security: false
      },
      {
        name: "nodejs",
        version: "14.19.0",
        date: "2022-02-01",
        lts: "Fermium",
        security: false
      },
      {
        name: "nodejs",
        version: "15.0.0",
        date: "2020-10-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.1.0",
        date: "2020-11-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.2.0",
        date: "2020-11-10",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.3.0",
        date: "2020-11-24",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.4.0",
        date: "2020-12-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.5.0",
        date: "2020-12-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.6.0",
        date: "2021-01-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.7.0",
        date: "2021-01-25",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.8.0",
        date: "2021-02-02",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.9.0",
        date: "2021-02-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.10.0",
        date: "2021-02-23",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "15.11.0",
        date: "2021-03-03",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.12.0",
        date: "2021-03-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.13.0",
        date: "2021-03-31",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "15.14.0",
        date: "2021-04-06",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.0.0",
        date: "2021-04-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.1.0",
        date: "2021-05-04",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.2.0",
        date: "2021-05-19",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.3.0",
        date: "2021-06-03",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.4.0",
        date: "2021-06-23",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.5.0",
        date: "2021-07-14",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.6.0",
        date: "2021-07-29",
        lts: false,
        security: true
      },
      {
        name: "nodejs",
        version: "16.7.0",
        date: "2021-08-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.8.0",
        date: "2021-08-25",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.9.0",
        date: "2021-09-07",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.10.0",
        date: "2021-09-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.11.0",
        date: "2021-10-08",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.12.0",
        date: "2021-10-20",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "16.13.0",
        date: "2021-10-26",
        lts: "Gallium",
        security: false
      },
      {
        name: "nodejs",
        version: "16.14.0",
        date: "2022-02-08",
        lts: "Gallium",
        security: false
      },
      {
        name: "nodejs",
        version: "17.0.0",
        date: "2021-10-19",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.1.0",
        date: "2021-11-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.2.0",
        date: "2021-11-30",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.3.0",
        date: "2021-12-17",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.4.0",
        date: "2022-01-18",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.5.0",
        date: "2022-02-10",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.6.0",
        date: "2022-02-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.7.0",
        date: "2022-03-09",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.8.0",
        date: "2022-03-22",
        lts: false,
        security: false
      },
      {
        name: "nodejs",
        version: "17.9.0",
        date: "2022-04-07",
        lts: false,
        security: false
      }
    ];
    var agents$2 = {};
    var browsers$2 = {};
    var browsers$1 = {
      A: "ie",
      B: "edge",
      C: "firefox",
      D: "chrome",
      E: "safari",
      F: "opera",
      G: "ios_saf",
      H: "op_mini",
      I: "android",
      J: "bb",
      K: "op_mob",
      L: "and_chr",
      M: "and_ff",
      N: "ie_mob",
      O: "and_uc",
      P: "samsung",
      Q: "and_qq",
      R: "baidu",
      S: "kaios"
    };
    browsers$2.browsers = browsers$1;
    var browserVersions$1 = {};
    var browserVersions = {
      "0": "34",
      "1": "35",
      "2": "36",
      "3": "37",
      "4": "38",
      "5": "39",
      "6": "40",
      "7": "41",
      "8": "42",
      "9": "43",
      A: "10",
      B: "11",
      C: "12",
      D: "7",
      E: "8",
      F: "9",
      G: "15",
      H: "100",
      I: "4",
      J: "6",
      K: "13",
      L: "14",
      M: "16",
      N: "17",
      O: "18",
      P: "79",
      Q: "80",
      R: "81",
      S: "83",
      T: "99",
      U: "64",
      V: "84",
      W: "85",
      X: "86",
      Y: "87",
      Z: "88",
      a: "89",
      b: "90",
      c: "91",
      d: "92",
      e: "93",
      f: "94",
      g: "95",
      h: "96",
      i: "97",
      j: "98",
      k: "5",
      l: "19",
      m: "20",
      n: "21",
      o: "22",
      p: "23",
      q: "24",
      r: "25",
      s: "26",
      t: "27",
      u: "28",
      v: "29",
      w: "30",
      x: "31",
      y: "32",
      z: "33",
      AB: "44",
      BB: "45",
      CB: "46",
      DB: "47",
      EB: "48",
      FB: "49",
      GB: "50",
      HB: "51",
      IB: "52",
      JB: "53",
      KB: "54",
      LB: "55",
      MB: "56",
      NB: "57",
      OB: "58",
      PB: "60",
      QB: "62",
      RB: "63",
      SB: "65",
      TB: "66",
      UB: "67",
      VB: "68",
      WB: "69",
      XB: "70",
      YB: "71",
      ZB: "72",
      aB: "73",
      bB: "74",
      cB: "75",
      dB: "76",
      eB: "77",
      fB: "78",
      gB: "11.1",
      hB: "12.1",
      iB: "3",
      jB: "59",
      kB: "61",
      lB: "82",
      mB: "101",
      nB: "3.2",
      oB: "10.1",
      pB: "15.2-15.3",
      qB: "15.4",
      rB: "11.5",
      sB: "4.2-4.3",
      tB: "5.5",
      uB: "2",
      vB: "3.5",
      wB: "3.6",
      xB: "102",
      yB: "103",
      zB: "3.1",
      "0B": "5.1",
      "1B": "6.1",
      "2B": "7.1",
      "3B": "9.1",
      "4B": "13.1",
      "5B": "14.1",
      "6B": "15.1",
      "7B": "TP",
      "8B": "9.5-9.6",
      "9B": "10.0-10.1",
      AC: "10.5",
      BC: "10.6",
      CC: "11.6",
      DC: "4.0-4.1",
      EC: "5.0-5.1",
      FC: "6.0-6.1",
      GC: "7.0-7.1",
      HC: "8.1-8.4",
      IC: "9.0-9.2",
      JC: "9.3",
      KC: "10.0-10.2",
      LC: "10.3",
      MC: "11.0-11.2",
      NC: "11.3-11.4",
      OC: "12.0-12.1",
      PC: "12.2-12.5",
      QC: "13.0-13.1",
      RC: "13.2",
      SC: "13.3",
      TC: "13.4-13.7",
      UC: "14.0-14.4",
      VC: "14.5-14.8",
      WC: "15.0-15.1",
      XC: "all",
      YC: "2.1",
      ZC: "2.2",
      aC: "2.3",
      bC: "4.1",
      cC: "4.4",
      dC: "4.4.3-4.4.4",
      eC: "12.12",
      fC: "5.0-5.4",
      gC: "6.2-6.4",
      hC: "7.2-7.4",
      iC: "8.2",
      jC: "9.2",
      kC: "11.1-11.2",
      lC: "12.0",
      mC: "13.0",
      nC: "14.0",
      oC: "15.0",
      pC: "16.0",
      qC: "10.4",
      rC: "7.12",
      sC: "2.5"
    };
    browserVersions$1.browserVersions = browserVersions;
    var agents$1 = {
      A: {
        A: {
          J: 0.0131217,
          D: 621152e-8,
          E: 0.0289618,
          F: 0.0579235,
          A: 0.0144809,
          B: 0.557514,
          tB: 9298e-6
        },
        B: "ms",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "tB", "J", "D", "E", "F", "A", "B", "", "", ""],
        E: "IE",
        F: {
          tB: 962323200,
          J: 998870400,
          D: 1161129600,
          E: 1237420800,
          F: 1300060800,
          A: 1346716800,
          B: 1381968e3
        }
      },
      B: {
        A: {
          C: 4118e-6,
          K: 4267e-6,
          L: 4268e-6,
          G: 0.04118,
          M: 4118e-6,
          N: 8236e-6,
          O: 0.024708,
          P: 0,
          Q: 4298e-6,
          R: 944e-5,
          S: 4043e-6,
          V: 4118e-6,
          W: 4118e-6,
          X: 4118e-6,
          Y: 8236e-6,
          Z: 4318e-6,
          a: 4118e-6,
          b: 4118e-6,
          c: 4118e-6,
          d: 0.012354,
          e: 4118e-6,
          f: 8236e-6,
          g: 0.012354,
          h: 0.024708,
          i: 0.06177,
          j: 0.765948,
          T: 3.03908,
          H: 0
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "C", "K", "L", "G", "M", "N", "O", "P", "Q", "R", "S", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "T", "H", "", "", ""],
        E: "Edge",
        F: {
          C: 1438128e3,
          K: 1447286400,
          L: 1470096e3,
          G: 1491868800,
          M: 1508198400,
          N: 1525046400,
          O: 1542067200,
          P: 1579046400,
          Q: 1581033600,
          R: 1586736e3,
          S: 1590019200,
          V: 1594857600,
          W: 1598486400,
          X: 1602201600,
          Y: 1605830400,
          Z: 161136e4,
          a: 1614816e3,
          b: 1618358400,
          c: 1622073600,
          d: 1626912e3,
          e: 1630627200,
          f: 1632441600,
          g: 1634774400,
          h: 1637539200,
          i: 1641427200,
          j: 1643932800,
          T: 1646265600,
          H: 1649635200
        },
        D: {
          C: "ms",
          K: "ms",
          L: "ms",
          G: "ms",
          M: "ms",
          N: "ms",
          O: "ms"
        }
      },
      C: {
        A: {
          "0": 4707e-6,
          "1": 9076e-6,
          "2": 8236e-6,
          "3": 4783e-6,
          "4": 4271e-6,
          "5": 4783e-6,
          "6": 487e-5,
          "7": 5029e-6,
          "8": 47e-4,
          "9": 0.049416,
          uB: 4118e-6,
          iB: 4271e-6,
          I: 0.016472,
          k: 4879e-6,
          J: 0.020136,
          D: 5725e-6,
          E: 4525e-6,
          F: 533e-5,
          A: 4283e-6,
          B: 4318e-6,
          C: 4471e-6,
          K: 4486e-6,
          L: 453e-5,
          G: 8322e-6,
          M: 4417e-6,
          N: 4425e-6,
          O: 4161e-6,
          l: 4443e-6,
          m: 4283e-6,
          n: 8322e-6,
          o: 0.013698,
          p: 4161e-6,
          q: 8786e-6,
          r: 4118e-6,
          s: 4317e-6,
          t: 4393e-6,
          u: 4418e-6,
          v: 8834e-6,
          w: 8322e-6,
          x: 8928e-6,
          y: 4471e-6,
          z: 9284e-6,
          AB: 8236e-6,
          BB: 4356e-6,
          CB: 4525e-6,
          DB: 4293e-6,
          EB: 4118e-6,
          FB: 4538e-6,
          GB: 8282e-6,
          HB: 0.012354,
          IB: 0.070006,
          JB: 8236e-6,
          KB: 8236e-6,
          LB: 0.012354,
          MB: 0.012354,
          NB: 8236e-6,
          OB: 4356e-6,
          jB: 8236e-6,
          PB: 8236e-6,
          kB: 4356e-6,
          QB: 4425e-6,
          RB: 8322e-6,
          U: 415e-5,
          SB: 4267e-6,
          TB: 4118e-6,
          UB: 4267e-6,
          VB: 8236e-6,
          WB: 415e-5,
          XB: 4293e-6,
          YB: 4425e-6,
          ZB: 4118e-6,
          aB: 415e-5,
          bB: 415e-5,
          cB: 4318e-6,
          dB: 4356e-6,
          eB: 4118e-6,
          fB: 0.053534,
          P: 8236e-6,
          Q: 8236e-6,
          R: 0.012354,
          lB: 4118e-6,
          S: 4118e-6,
          V: 8236e-6,
          W: 4268e-6,
          X: 4118e-6,
          Y: 0.012354,
          Z: 0.012354,
          a: 0.012354,
          b: 0.02059,
          c: 0.098832,
          d: 8236e-6,
          e: 0.012354,
          f: 0.04118,
          g: 0.04118,
          h: 0.037062,
          i: 0.856544,
          j: 1.47424,
          T: 0.016472,
          H: 0,
          mB: 0,
          vB: 8786e-6,
          wB: 487e-5
        },
        B: "moz",
        C: ["uB", "iB", "vB", "wB", "I", "k", "J", "D", "E", "F", "A", "B", "C", "K", "L", "G", "M", "N", "O", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "jB", "PB", "kB", "QB", "RB", "U", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "P", "Q", "R", "lB", "S", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "T", "H", "mB", ""],
        E: "Firefox",
        F: {
          "0": 1417392e3,
          "1": 1421107200,
          "2": 1424736e3,
          "3": 1428278400,
          "4": 1431475200,
          "5": 1435881600,
          "6": 1439251200,
          "7": 144288e4,
          "8": 1446508800,
          "9": 1450137600,
          uB: 1161648e3,
          iB: 1213660800,
          vB: 124632e4,
          wB: 1264032e3,
          I: 1300752e3,
          k: 1308614400,
          J: 1313452800,
          D: 1317081600,
          E: 1317081600,
          F: 1320710400,
          A: 1324339200,
          B: 1327968e3,
          C: 1331596800,
          K: 1335225600,
          L: 1338854400,
          G: 1342483200,
          M: 1346112e3,
          N: 1349740800,
          O: 1353628800,
          l: 1357603200,
          m: 1361232e3,
          n: 1364860800,
          o: 1368489600,
          p: 1372118400,
          q: 1375747200,
          r: 1379376e3,
          s: 1386633600,
          t: 1391472e3,
          u: 1395100800,
          v: 1398729600,
          w: 1402358400,
          x: 1405987200,
          y: 1409616e3,
          z: 1413244800,
          AB: 1453852800,
          BB: 1457395200,
          CB: 1461628800,
          DB: 1465257600,
          EB: 1470096e3,
          FB: 1474329600,
          GB: 1479168e3,
          HB: 1485216e3,
          IB: 1488844800,
          JB: 149256e4,
          KB: 1497312e3,
          LB: 1502150400,
          MB: 1506556800,
          NB: 1510617600,
          OB: 1516665600,
          jB: 1520985600,
          PB: 1525824e3,
          kB: 1529971200,
          QB: 1536105600,
          RB: 1540252800,
          U: 1544486400,
          SB: 154872e4,
          TB: 1552953600,
          UB: 1558396800,
          VB: 1562630400,
          WB: 1567468800,
          XB: 1571788800,
          YB: 1575331200,
          ZB: 1578355200,
          aB: 1581379200,
          bB: 1583798400,
          cB: 1586304e3,
          dB: 1588636800,
          eB: 1591056e3,
          fB: 1593475200,
          P: 1595894400,
          Q: 1598313600,
          R: 1600732800,
          lB: 1603152e3,
          S: 1605571200,
          V: 1607990400,
          W: 1611619200,
          X: 1614038400,
          Y: 1616457600,
          Z: 1618790400,
          a: 1622505600,
          b: 1626134400,
          c: 1628553600,
          d: 1630972800,
          e: 1633392e3,
          f: 1635811200,
          g: 1638835200,
          h: 1641859200,
          i: 1644364800,
          j: 1646697600,
          T: 1649116800,
          H: null,
          mB: null
        }
      },
      D: {
        A: {
          "0": 8236e-6,
          "1": 0.012354,
          "2": 4335e-6,
          "3": 4464e-6,
          "4": 0.02059,
          "5": 4464e-6,
          "6": 0.016472,
          "7": 4118e-6,
          "8": 4118e-6,
          "9": 0.012354,
          I: 4706e-6,
          k: 4879e-6,
          J: 4879e-6,
          D: 5591e-6,
          E: 5591e-6,
          F: 5591e-6,
          A: 4534e-6,
          B: 4464e-6,
          C: 0.010424,
          K: 83e-4,
          L: 4706e-6,
          G: 0.015087,
          M: 4393e-6,
          N: 4393e-6,
          O: 8652e-6,
          l: 8322e-6,
          m: 4393e-6,
          n: 4317e-6,
          o: 8236e-6,
          p: 8786e-6,
          q: 8236e-6,
          r: 4461e-6,
          s: 4141e-6,
          t: 4326e-6,
          u: 47e-4,
          v: 4538e-6,
          w: 8322e-6,
          x: 8596e-6,
          y: 4566e-6,
          z: 4118e-6,
          AB: 4465e-6,
          BB: 4118e-6,
          CB: 8236e-6,
          DB: 0.012354,
          EB: 0.024708,
          FB: 0.070006,
          GB: 4293e-6,
          HB: 0.012354,
          IB: 8236e-6,
          JB: 0.012354,
          KB: 8236e-6,
          LB: 0.012354,
          MB: 0.045298,
          NB: 8236e-6,
          OB: 8236e-6,
          jB: 8236e-6,
          PB: 0.016472,
          kB: 0.016472,
          QB: 0.012354,
          RB: 0.012354,
          U: 0.012354,
          SB: 0.016472,
          TB: 0.024708,
          UB: 0.012354,
          VB: 8236e-6,
          WB: 0.057652,
          XB: 0.032944,
          YB: 0.016472,
          ZB: 0.057652,
          aB: 8236e-6,
          bB: 0.02059,
          cB: 0.049416,
          dB: 0.065888,
          eB: 0.016472,
          fB: 0.04118,
          P: 0.189428,
          Q: 0.053534,
          R: 0.037062,
          S: 0.10295,
          V: 0.065888,
          W: 0.065888,
          X: 0.070006,
          Y: 0.111186,
          Z: 0.028826,
          a: 0.057652,
          b: 0.045298,
          c: 0.107068,
          d: 0.094714,
          e: 0.304732,
          f: 0.127658,
          g: 0.065888,
          h: 0.32944,
          i: 0.506514,
          j: 5.45223,
          T: 17.5468,
          H: 0.172956,
          mB: 0.02059,
          xB: 4118e-6,
          yB: 0
        },
        B: "webkit",
        C: ["", "", "", "", "I", "k", "J", "D", "E", "F", "A", "B", "C", "K", "L", "G", "M", "N", "O", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "jB", "PB", "kB", "QB", "RB", "U", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "P", "Q", "R", "S", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "T", "H", "mB", "xB", "yB"],
        E: "Chrome",
        F: {
          "0": 1397001600,
          "1": 1400544e3,
          "2": 1405468800,
          "3": 1409011200,
          "4": 141264e4,
          "5": 1416268800,
          "6": 1421798400,
          "7": 1425513600,
          "8": 1429401600,
          "9": 143208e4,
          I: 1264377600,
          k: 1274745600,
          J: 1283385600,
          D: 1287619200,
          E: 1291248e3,
          F: 1296777600,
          A: 1299542400,
          B: 1303862400,
          C: 1307404800,
          K: 1312243200,
          L: 1316131200,
          G: 1316131200,
          M: 1319500800,
          N: 1323734400,
          O: 1328659200,
          l: 1332892800,
          m: 133704e4,
          n: 1340668800,
          o: 1343692800,
          p: 1348531200,
          q: 1352246400,
          r: 1357862400,
          s: 1361404800,
          t: 1364428800,
          u: 1369094400,
          v: 1374105600,
          w: 1376956800,
          x: 1384214400,
          y: 1389657600,
          z: 1392940800,
          AB: 1437523200,
          BB: 1441152e3,
          CB: 1444780800,
          DB: 1449014400,
          EB: 1453248e3,
          FB: 1456963200,
          GB: 1460592e3,
          HB: 1464134400,
          IB: 1469059200,
          JB: 1472601600,
          KB: 1476230400,
          LB: 1480550400,
          MB: 1485302400,
          NB: 1489017600,
          OB: 149256e4,
          jB: 1496707200,
          PB: 1500940800,
          kB: 1504569600,
          QB: 1508198400,
          RB: 1512518400,
          U: 1516752e3,
          SB: 1520294400,
          TB: 1523923200,
          UB: 1527552e3,
          VB: 1532390400,
          WB: 1536019200,
          XB: 1539648e3,
          YB: 1543968e3,
          ZB: 154872e4,
          aB: 1552348800,
          bB: 1555977600,
          cB: 1559606400,
          dB: 1564444800,
          eB: 1568073600,
          fB: 1571702400,
          P: 1575936e3,
          Q: 1580860800,
          R: 1586304e3,
          S: 1589846400,
          V: 1594684800,
          W: 1598313600,
          X: 1601942400,
          Y: 1605571200,
          Z: 1611014400,
          a: 1614556800,
          b: 1618272e3,
          c: 1621987200,
          d: 1626739200,
          e: 1630368e3,
          f: 1632268800,
          g: 1634601600,
          h: 1637020800,
          i: 1641340800,
          j: 1643673600,
          T: 1646092800,
          H: 1648512e3,
          mB: null,
          xB: null,
          yB: null
        }
      },
      E: {
        A: {
          I: 0,
          k: 8322e-6,
          J: 4656e-6,
          D: 4465e-6,
          E: 4356e-6,
          F: 4891e-6,
          A: 4425e-6,
          B: 4318e-6,
          C: 4118e-6,
          K: 0.045298,
          L: 0.2059,
          G: 0.098832,
          zB: 0,
          nB: 8692e-6,
          "0B": 8236e-6,
          "1B": 456e-5,
          "2B": 4283e-6,
          "3B": 0.016472,
          oB: 0.012354,
          gB: 0.028826,
          hB: 0.057652,
          "4B": 0.461216,
          "5B": 0.687706,
          "6B": 0.2059,
          pB: 0.24708,
          qB: 0.168838,
          "7B": 0
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "zB", "nB", "I", "k", "0B", "J", "1B", "D", "2B", "E", "F", "3B", "A", "oB", "B", "gB", "C", "hB", "K", "4B", "L", "5B", "G", "6B", "pB", "qB", "7B", "", ""],
        E: "Safari",
        F: {
          zB: 1205798400,
          nB: 1226534400,
          I: 1244419200,
          k: 1275868800,
          "0B": 131112e4,
          J: 1343174400,
          "1B": 13824e5,
          D: 13824e5,
          "2B": 1410998400,
          E: 1413417600,
          F: 1443657600,
          "3B": 1458518400,
          A: 1474329600,
          oB: 1490572800,
          B: 1505779200,
          gB: 1522281600,
          C: 1537142400,
          hB: 1553472e3,
          K: 1568851200,
          "4B": 1585008e3,
          L: 1600214400,
          "5B": 1619395200,
          G: 1632096e3,
          "6B": 1635292800,
          pB: 1639353600,
          qB: 1647216e3,
          "7B": null
        }
      },
      F: {
        A: {
          "0": 9758e-6,
          "1": 4879e-6,
          "2": 4118e-6,
          "3": 4283e-6,
          "4": 4367e-6,
          "5": 4534e-6,
          "6": 8236e-6,
          "7": 4227e-6,
          "8": 4418e-6,
          "9": 4161e-6,
          F: 82e-4,
          B: 0.016581,
          C: 4317e-6,
          G: 685e-5,
          M: 685e-5,
          N: 685e-5,
          O: 5014e-6,
          l: 6015e-6,
          m: 4879e-6,
          n: 6597e-6,
          o: 6597e-6,
          p: 0.013434,
          q: 6702e-6,
          r: 6015e-6,
          s: 5595e-6,
          t: 4393e-6,
          u: 4118e-6,
          v: 4879e-6,
          w: 4879e-6,
          x: 4118e-6,
          y: 5152e-6,
          z: 5014e-6,
          AB: 4227e-6,
          BB: 4725e-6,
          CB: 8236e-6,
          DB: 8942e-6,
          EB: 4707e-6,
          FB: 4827e-6,
          GB: 4707e-6,
          HB: 4707e-6,
          IB: 4326e-6,
          JB: 8922e-6,
          KB: 0.014349,
          LB: 4425e-6,
          MB: 472e-5,
          NB: 4425e-6,
          OB: 4425e-6,
          PB: 472e-5,
          QB: 4532e-6,
          RB: 4566e-6,
          U: 0.02283,
          SB: 867e-5,
          TB: 4656e-6,
          UB: 4642e-6,
          VB: 4118e-6,
          WB: 944e-5,
          XB: 4293e-6,
          YB: 4293e-6,
          ZB: 4298e-6,
          aB: 0.096692,
          bB: 4201e-6,
          cB: 4141e-6,
          dB: 4257e-6,
          eB: 8236e-6,
          fB: 8236e-6,
          P: 8236e-6,
          Q: 8236e-6,
          R: 8514e-6,
          lB: 0.012354,
          S: 0.28826,
          "8B": 685e-5,
          "9B": 0,
          AC: 8392e-6,
          BC: 4706e-6,
          gB: 6229e-6,
          rB: 4879e-6,
          CC: 8786e-6,
          hB: 472e-5
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "F", "8B", "9B", "AC", "BC", "B", "gB", "rB", "CC", "C", "hB", "G", "M", "N", "O", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "PB", "QB", "RB", "U", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "P", "Q", "R", "lB", "S", "", "", ""],
        E: "Opera",
        F: {
          "0": 1449100800,
          "1": 1454371200,
          "2": 1457308800,
          "3": 146232e4,
          "4": 1465344e3,
          "5": 1470096e3,
          "6": 1474329600,
          "7": 1477267200,
          "8": 1481587200,
          "9": 1486425600,
          F: 1150761600,
          "8B": 1223424e3,
          "9B": 1251763200,
          AC: 1267488e3,
          BC: 1277942400,
          B: 1292457600,
          gB: 1302566400,
          rB: 1309219200,
          CC: 1323129600,
          C: 1323129600,
          hB: 1352073600,
          G: 1372723200,
          M: 1377561600,
          N: 1381104e3,
          O: 1386288e3,
          l: 1390867200,
          m: 1393891200,
          n: 1399334400,
          o: 1401753600,
          p: 1405987200,
          q: 1409616e3,
          r: 1413331200,
          s: 1417132800,
          t: 1422316800,
          u: 1425945600,
          v: 1430179200,
          w: 1433808e3,
          x: 1438646400,
          y: 1442448e3,
          z: 1445904e3,
          AB: 1490054400,
          BB: 1494374400,
          CB: 1498003200,
          DB: 1502236800,
          EB: 1506470400,
          FB: 1510099200,
          GB: 1515024e3,
          HB: 1517961600,
          IB: 1521676800,
          JB: 1525910400,
          KB: 1530144e3,
          LB: 1534982400,
          MB: 1537833600,
          NB: 1543363200,
          OB: 1548201600,
          PB: 1554768e3,
          QB: 1561593600,
          RB: 1566259200,
          U: 1570406400,
          SB: 1573689600,
          TB: 1578441600,
          UB: 1583971200,
          VB: 1587513600,
          WB: 1592956800,
          XB: 1595894400,
          YB: 1600128e3,
          ZB: 1603238400,
          aB: 161352e4,
          bB: 1612224e3,
          cB: 1616544e3,
          dB: 1619568e3,
          eB: 1623715200,
          fB: 1627948800,
          P: 1631577600,
          Q: 1633392e3,
          R: 1635984e3,
          lB: 1638403200,
          S: 1642550400
        },
        D: {
          F: "o",
          B: "o",
          C: "o",
          "8B": "o",
          "9B": "o",
          AC: "o",
          BC: "o",
          gB: "o",
          rB: "o",
          CC: "o",
          hB: "o"
        }
      },
      G: {
        A: {
          E: 0,
          nB: 0,
          DC: 0,
          sB: 291884e-8,
          EC: 437827e-8,
          FC: 0.0612957,
          GC: 0.0175131,
          HC: 729711e-8,
          IC: 0.0175131,
          JC: 0.0817276,
          KC: 0.0248102,
          LC: 0.0948624,
          MC: 0.0539986,
          NC: 0.0350261,
          OC: 0.0350261,
          PC: 0.553121,
          QC: 0.0306479,
          RC: 0.0131348,
          SC: 0.0700523,
          TC: 0.218913,
          UC: 0.680091,
          VC: 2.07092,
          WC: 0.963218,
          pB: 8.72442,
          qB: 0.828952
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "nB", "DC", "sB", "EC", "FC", "GC", "E", "HC", "IC", "JC", "KC", "LC", "MC", "NC", "OC", "PC", "QC", "RC", "SC", "TC", "UC", "VC", "WC", "pB", "qB", "", "", ""],
        E: "Safari on iOS",
        F: {
          nB: 1270252800,
          DC: 1283904e3,
          sB: 1299628800,
          EC: 1331078400,
          FC: 1359331200,
          GC: 1394409600,
          E: 1410912e3,
          HC: 1413763200,
          IC: 1442361600,
          JC: 1458518400,
          KC: 1473724800,
          LC: 1490572800,
          MC: 1505779200,
          NC: 1522281600,
          OC: 1537142400,
          PC: 1553472e3,
          QC: 1568851200,
          RC: 1572220800,
          SC: 1580169600,
          TC: 1585008e3,
          UC: 1600214400,
          VC: 1619395200,
          WC: 1632096e3,
          pB: 1639353600,
          qB: 1647216e3
        }
      },
      H: {
        A: {
          XC: 1.03595
        },
        B: "o",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "XC", "", "", ""],
        E: "Opera Mini",
        F: {
          XC: 1426464e3
        }
      },
      I: {
        A: {
          iB: 0,
          I: 0.0150411,
          H: 0,
          YC: 0,
          ZC: 0,
          aC: 0,
          bC: 0.0150411,
          sB: 0.0639246,
          cC: 0,
          dC: 0.270739
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "YC", "ZC", "aC", "iB", "I", "bC", "sB", "cC", "dC", "H", "", "", ""],
        E: "Android Browser",
        F: {
          YC: 1256515200,
          ZC: 1274313600,
          aC: 1291593600,
          iB: 1298332800,
          I: 1318896e3,
          bC: 1341792e3,
          sB: 1374624e3,
          cC: 1386547200,
          dC: 1401667200,
          H: 1648425600
        }
      },
      J: {
        A: {
          D: 0,
          A: 0
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "D", "A", "", "", ""],
        E: "Blackberry Browser",
        F: {
          D: 1325376e3,
          A: 1359504e3
        }
      },
      K: {
        A: {
          A: 0,
          B: 0,
          C: 0,
          U: 0.0111391,
          gB: 0,
          rB: 0,
          hB: 0
        },
        B: "o",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "gB", "rB", "C", "hB", "U", "", "", ""],
        E: "Opera Mobile",
        F: {
          A: 1287100800,
          B: 1300752e3,
          gB: 1314835200,
          rB: 1318291200,
          C: 1330300800,
          hB: 1349740800,
          U: 1613433600
        },
        D: {
          U: "webkit"
        }
      },
      L: {
        A: {
          H: 38.4736
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "H", "", "", ""],
        E: "Chrome for Android",
        F: {
          H: 1648684800
        }
      },
      M: {
        A: {
          T: 0.29415
        },
        B: "moz",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "T", "", "", ""],
        E: "Firefox for Android",
        F: {
          T: 1649116800
        }
      },
      N: {
        A: {
          A: 0.0115934,
          B: 0.022664
        },
        B: "ms",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "", "", ""],
        E: "IE Mobile",
        F: {
          A: 1340150400,
          B: 1353456e3
        }
      },
      O: {
        A: {
          eC: 0.829503
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "eC", "", "", ""],
        E: "UC Browser for Android",
        F: {
          eC: 1471392e3
        },
        D: {
          eC: "webkit"
        }
      },
      P: {
        A: {
          I: 0.21861,
          fC: 0.0103543,
          gC: 0.010304,
          hC: 0.0832799,
          iC: 0.0103584,
          jC: 0.02082,
          oB: 0.0105043,
          kC: 0.0520499,
          lC: 0.03123,
          mC: 0.1041,
          nC: 0.12492,
          oC: 0.11451,
          pC: 2.1861
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "I", "fC", "gC", "hC", "iC", "jC", "oB", "kC", "lC", "mC", "nC", "oC", "pC", "", "", ""],
        E: "Samsung Internet",
        F: {
          I: 1461024e3,
          fC: 1481846400,
          gC: 1509408e3,
          hC: 1528329600,
          iC: 1546128e3,
          jC: 1554163200,
          oB: 1567900800,
          kC: 1582588800,
          lC: 1593475200,
          mC: 1605657600,
          nC: 1618531200,
          oC: 1629072e3,
          pC: 1640736e3
        }
      },
      Q: {
        A: {
          qC: 0.164724
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "qC", "", "", ""],
        E: "QQ Browser",
        F: {
          qC: 1589846400
        }
      },
      R: {
        A: {
          rC: 0
        },
        B: "webkit",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "rC", "", "", ""],
        E: "Baidu Browser",
        F: {
          rC: 1491004800
        }
      },
      S: {
        A: {
          sC: 0.082362
        },
        B: "moz",
        C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "sC", "", "", ""],
        E: "KaiOS Browser",
        F: {
          sC: 1527811200
        }
      }
    };
    var browsers = browsers$2.browsers;
    var versions$1 = browserVersions$1.browserVersions;
    var agentsData = agents$1;
    function unpackBrowserVersions(versionsData) {
      return Object.keys(versionsData).reduce(function(usage2, version3) {
        usage2[versions$1[version3]] = versionsData[version3];
        return usage2;
      }, {});
    }
    agents$2.agents = Object.keys(agentsData).reduce(function(map2, key2) {
      var versionsData = agentsData[key2];
      map2[browsers[key2]] = Object.keys(versionsData).reduce(function(data3, entry2) {
        if (entry2 === "A") {
          data3.usage_global = unpackBrowserVersions(versionsData[entry2]);
        } else if (entry2 === "C") {
          data3.versions = versionsData[entry2].reduce(function(list2, version3) {
            if (version3 === "") {
              list2.push(null);
            } else {
              list2.push(versions$1[version3]);
            }
            return list2;
          }, []);
        } else if (entry2 === "D") {
          data3.prefix_exceptions = unpackBrowserVersions(versionsData[entry2]);
        } else if (entry2 === "E") {
          data3.browser = versionsData[entry2];
        } else if (entry2 === "F") {
          data3.release_date = Object.keys(versionsData[entry2]).reduce(function(map22, key22) {
            map22[versions$1[key22]] = versionsData[entry2][key22];
            return map22;
          }, {});
        } else {
          data3.prefix = versionsData[entry2];
        }
        return data3;
      }, {});
      return map2;
    }, {});
    var v4 = {
      start: "2015-09-08",
      lts: "2015-10-12",
      maintenance: "2017-04-01",
      end: "2018-04-30",
      codename: "Argon"
    };
    var v5 = {
      start: "2015-10-29",
      maintenance: "2016-04-30",
      end: "2016-06-30"
    };
    var v6 = {
      start: "2016-04-26",
      lts: "2016-10-18",
      maintenance: "2018-04-30",
      end: "2019-04-30",
      codename: "Boron"
    };
    var v7 = {
      start: "2016-10-25",
      maintenance: "2017-04-30",
      end: "2017-06-30"
    };
    var v8 = {
      start: "2017-05-30",
      lts: "2017-10-31",
      maintenance: "2019-01-01",
      end: "2019-12-31",
      codename: "Carbon"
    };
    var v9 = {
      start: "2017-10-01",
      maintenance: "2018-04-01",
      end: "2018-06-30"
    };
    var v10 = {
      start: "2018-04-24",
      lts: "2018-10-30",
      maintenance: "2020-05-19",
      end: "2021-04-30",
      codename: "Dubnium"
    };
    var v11 = {
      start: "2018-10-23",
      maintenance: "2019-04-22",
      end: "2019-06-01"
    };
    var v12 = {
      start: "2019-04-23",
      lts: "2019-10-21",
      maintenance: "2020-11-30",
      end: "2022-04-30",
      codename: "Erbium"
    };
    var v13 = {
      start: "2019-10-22",
      maintenance: "2020-04-01",
      end: "2020-06-01"
    };
    var v14 = {
      start: "2020-04-21",
      lts: "2020-10-27",
      maintenance: "2021-10-19",
      end: "2023-04-30",
      codename: "Fermium"
    };
    var v15 = {
      start: "2020-10-20",
      maintenance: "2021-04-01",
      end: "2021-06-01"
    };
    var v16 = {
      start: "2021-04-20",
      lts: "2021-10-26",
      maintenance: "2022-10-18",
      end: "2024-04-30",
      codename: "Gallium"
    };
    var v17 = {
      start: "2021-10-19",
      maintenance: "2022-04-01",
      end: "2022-06-01"
    };
    var v18 = {
      start: "2022-04-19",
      lts: "2022-10-25",
      maintenance: "2023-10-18",
      end: "2025-04-30",
      codename: ""
    };
    var v19 = {
      start: "2022-10-18",
      maintenance: "2023-04-01",
      end: "2023-06-01"
    };
    var v20 = {
      start: "2023-04-18",
      lts: "2023-10-24",
      maintenance: "2024-10-22",
      end: "2026-04-30",
      codename: ""
    };
    var require$$2$1 = {
      "v0.8": {
        start: "2012-06-25",
        end: "2014-07-31"
      },
      "v0.10": {
        start: "2013-03-11",
        end: "2016-10-31"
      },
      "v0.12": {
        start: "2015-02-06",
        end: "2016-12-31"
      },
      v4,
      v5,
      v6,
      v7,
      v8,
      v9,
      v10,
      v11,
      v12,
      v13,
      v14,
      v15,
      v16,
      v17,
      v18,
      v19,
      v20
    };
    var _nodeResolve_empty = {};
    var _nodeResolve_empty$1 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      "default": _nodeResolve_empty
    });
    var require$$0$8 = /* @__PURE__ */ getAugmentedNamespace(_nodeResolve_empty$1);
    var versions = {
      "0.20": "39",
      "0.21": "41",
      "0.22": "41",
      "0.23": "41",
      "0.24": "41",
      "0.25": "42",
      "0.26": "42",
      "0.27": "43",
      "0.28": "43",
      "0.29": "43",
      "0.30": "44",
      "0.31": "45",
      "0.32": "45",
      "0.33": "45",
      "0.34": "45",
      "0.35": "45",
      "0.36": "47",
      "0.37": "49",
      "1.0": "49",
      "1.1": "50",
      "1.2": "51",
      "1.3": "52",
      "1.4": "53",
      "1.5": "54",
      "1.6": "56",
      "1.7": "58",
      "1.8": "59",
      "2.0": "61",
      "2.1": "61",
      "3.0": "66",
      "3.1": "66",
      "4.0": "69",
      "4.1": "69",
      "4.2": "69",
      "5.0": "73",
      "6.0": "76",
      "6.1": "76",
      "7.0": "78",
      "7.1": "78",
      "7.2": "78",
      "7.3": "78",
      "8.0": "80",
      "8.1": "80",
      "8.2": "80",
      "8.3": "80",
      "8.4": "80",
      "8.5": "80",
      "9.0": "83",
      "9.1": "83",
      "9.2": "83",
      "9.3": "83",
      "9.4": "83",
      "10.0": "85",
      "10.1": "85",
      "10.2": "85",
      "10.3": "85",
      "10.4": "85",
      "11.0": "87",
      "11.1": "87",
      "11.2": "87",
      "11.3": "87",
      "11.4": "87",
      "11.5": "87",
      "12.0": "89",
      "12.1": "89",
      "12.2": "89",
      "13.0": "91",
      "13.1": "91",
      "13.2": "91",
      "13.3": "91",
      "13.4": "91",
      "13.5": "91",
      "13.6": "91",
      "14.0": "93",
      "14.1": "93",
      "14.2": "93",
      "15.0": "94",
      "15.1": "94",
      "15.2": "94",
      "15.3": "94",
      "15.4": "94",
      "15.5": "94",
      "16.0": "96",
      "16.1": "96",
      "16.2": "96",
      "17.0": "98",
      "17.1": "98",
      "17.2": "98",
      "17.3": "98",
      "17.4": "98",
      "18.0": "100",
      "19.0": "102"
    };
    function BrowserslistError$2(message) {
      this.name = "BrowserslistError";
      this.message = message;
      this.browserslist = true;
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, BrowserslistError$2);
      }
    }
    BrowserslistError$2.prototype = Error.prototype;
    var error = BrowserslistError$2;
    var BrowserslistError$1 = error;
    function noop2() {
    }
    var browser = {
      loadQueries: function loadQueries() {
        throw new BrowserslistError$1("Sharable configs are not supported in client-side build of Browserslist");
      },
      getStat: function getStat(opts) {
        return opts.stats;
      },
      loadConfig: function loadConfig2(opts) {
        if (opts.config) {
          throw new BrowserslistError$1("Browserslist config are not supported in client-side build");
        }
      },
      loadCountry: function loadCountry() {
        throw new BrowserslistError$1("Country statistics are not supported in client-side build of Browserslist");
      },
      loadFeature: function loadFeature() {
        throw new BrowserslistError$1("Supports queries are not available in client-side build of Browserslist");
      },
      currentNode: function currentNode(resolve2, context) {
        return resolve2(["maintained node versions"], context)[0];
      },
      parseConfig: noop2,
      readConfig: noop2,
      findConfig: noop2,
      clearCaches: noop2,
      oldDataWarning: noop2
    };
    var jsReleases = require$$0$9;
    var agents = agents$2.agents;
    var jsEOL = require$$2$1;
    var path = require$$0$8;
    var e2c = versions;
    var BrowserslistError = error;
    var env2 = browser;
    var YEAR = 365.259641 * 24 * 60 * 60 * 1e3;
    var ANDROID_EVERGREEN_FIRST = 37;
    var QUERY_OR = 1;
    var QUERY_AND = 2;
    function isVersionsMatch(versionA, versionB) {
      return (versionA + ".").indexOf(versionB + ".") === 0;
    }
    function isEolReleased(name2) {
      var version3 = name2.slice(1);
      return browserslist.nodeVersions.some(function(i2) {
        return isVersionsMatch(i2, version3);
      });
    }
    function normalize$12(versions2) {
      return versions2.filter(function(version3) {
        return typeof version3 === "string";
      });
    }
    function normalizeElectron(version3) {
      var versionToUse = version3;
      if (version3.split(".").length === 3) {
        versionToUse = version3.split(".").slice(0, -1).join(".");
      }
      return versionToUse;
    }
    function nameMapper(name2) {
      return function mapName(version3) {
        return name2 + " " + version3;
      };
    }
    function getMajor(version3) {
      return parseInt(version3.split(".")[0]);
    }
    function getMajorVersions(released, number4) {
      if (released.length === 0)
        return [];
      var majorVersions = uniq(released.map(getMajor));
      var minimum = majorVersions[majorVersions.length - number4];
      if (!minimum) {
        return released;
      }
      var selected = [];
      for (var i2 = released.length - 1; i2 >= 0; i2--) {
        if (minimum > getMajor(released[i2]))
          break;
        selected.unshift(released[i2]);
      }
      return selected;
    }
    function uniq(array4) {
      var filtered = [];
      for (var i2 = 0; i2 < array4.length; i2++) {
        if (filtered.indexOf(array4[i2]) === -1)
          filtered.push(array4[i2]);
      }
      return filtered;
    }
    function fillUsage(result, name2, data3) {
      for (var i2 in data3) {
        result[name2 + " " + i2] = data3[i2];
      }
    }
    function generateFilter(sign, version3) {
      version3 = parseFloat(version3);
      if (sign === ">") {
        return function(v22) {
          return parseFloat(v22) > version3;
        };
      } else if (sign === ">=") {
        return function(v22) {
          return parseFloat(v22) >= version3;
        };
      } else if (sign === "<") {
        return function(v22) {
          return parseFloat(v22) < version3;
        };
      } else {
        return function(v22) {
          return parseFloat(v22) <= version3;
        };
      }
    }
    function generateSemverFilter(sign, version3) {
      version3 = version3.split(".").map(parseSimpleInt);
      version3[1] = version3[1] || 0;
      version3[2] = version3[2] || 0;
      if (sign === ">") {
        return function(v22) {
          v22 = v22.split(".").map(parseSimpleInt);
          return compareSemver(v22, version3) > 0;
        };
      } else if (sign === ">=") {
        return function(v22) {
          v22 = v22.split(".").map(parseSimpleInt);
          return compareSemver(v22, version3) >= 0;
        };
      } else if (sign === "<") {
        return function(v22) {
          v22 = v22.split(".").map(parseSimpleInt);
          return compareSemver(version3, v22) > 0;
        };
      } else {
        return function(v22) {
          v22 = v22.split(".").map(parseSimpleInt);
          return compareSemver(version3, v22) >= 0;
        };
      }
    }
    function parseSimpleInt(x2) {
      return parseInt(x2);
    }
    function compare$9(a, b2) {
      if (a < b2)
        return -1;
      if (a > b2)
        return 1;
      return 0;
    }
    function compareSemver(a, b2) {
      return compare$9(parseInt(a[0]), parseInt(b2[0])) || compare$9(parseInt(a[1] || "0"), parseInt(b2[1] || "0")) || compare$9(parseInt(a[2] || "0"), parseInt(b2[2] || "0"));
    }
    function semverFilterLoose(operator, range3) {
      range3 = range3.split(".").map(parseSimpleInt);
      if (typeof range3[1] === "undefined") {
        range3[1] = "x";
      }
      switch (operator) {
        case "<=":
          return function(version3) {
            version3 = version3.split(".").map(parseSimpleInt);
            return compareSemverLoose(version3, range3) <= 0;
          };
        case ">=":
        default:
          return function(version3) {
            version3 = version3.split(".").map(parseSimpleInt);
            return compareSemverLoose(version3, range3) >= 0;
          };
      }
    }
    function compareSemverLoose(version3, range3) {
      if (version3[0] !== range3[0]) {
        return version3[0] < range3[0] ? -1 : 1;
      }
      if (range3[1] === "x") {
        return 0;
      }
      if (version3[1] !== range3[1]) {
        return version3[1] < range3[1] ? -1 : 1;
      }
      return 0;
    }
    function resolveVersion(data3, version3) {
      if (data3.versions.indexOf(version3) !== -1) {
        return version3;
      } else if (browserslist.versionAliases[data3.name][version3]) {
        return browserslist.versionAliases[data3.name][version3];
      } else {
        return false;
      }
    }
    function normalizeVersion(data3, version3) {
      var resolved = resolveVersion(data3, version3);
      if (resolved) {
        return resolved;
      } else if (data3.versions.length === 1) {
        return data3.versions[0];
      } else {
        return false;
      }
    }
    function filterByYear(since, context) {
      since = since / 1e3;
      return Object.keys(agents).reduce(function(selected, name2) {
        var data3 = byName(name2, context);
        if (!data3)
          return selected;
        var versions2 = Object.keys(data3.releaseDate).filter(function(v22) {
          var date4 = data3.releaseDate[v22];
          return date4 !== null && date4 >= since;
        });
        return selected.concat(versions2.map(nameMapper(data3.name)));
      }, []);
    }
    function cloneData(data3) {
      return {
        name: data3.name,
        versions: data3.versions,
        released: data3.released,
        releaseDate: data3.releaseDate
      };
    }
    function mapVersions(data3, map2) {
      data3.versions = data3.versions.map(function(i3) {
        return map2[i3] || i3;
      });
      data3.released = data3.versions.map(function(i3) {
        return map2[i3] || i3;
      });
      var fixedDate = {};
      for (var i2 in data3.releaseDate) {
        fixedDate[map2[i2] || i2] = data3.releaseDate[i2];
      }
      data3.releaseDate = fixedDate;
      return data3;
    }
    function byName(name2, context) {
      name2 = name2.toLowerCase();
      name2 = browserslist.aliases[name2] || name2;
      if (context.mobileToDesktop && browserslist.desktopNames[name2]) {
        var desktop = browserslist.data[browserslist.desktopNames[name2]];
        if (name2 === "android") {
          return normalizeAndroidData(cloneData(browserslist.data[name2]), desktop);
        } else {
          var cloned = cloneData(desktop);
          cloned.name = name2;
          if (name2 === "op_mob") {
            cloned = mapVersions(cloned, {
              "10.0-10.1": "10"
            });
          }
          return cloned;
        }
      }
      return browserslist.data[name2];
    }
    function normalizeAndroidVersions(androidVersions, chromeVersions) {
      var firstEvergreen = ANDROID_EVERGREEN_FIRST;
      var last2 = chromeVersions[chromeVersions.length - 1];
      return androidVersions.filter(function(version3) {
        return /^(?:[2-4]\.|[34]$)/.test(version3);
      }).concat(chromeVersions.slice(firstEvergreen - last2 - 1));
    }
    function normalizeAndroidData(android, chrome) {
      android.released = normalizeAndroidVersions(android.released, chrome.released);
      android.versions = normalizeAndroidVersions(android.versions, chrome.versions);
      return android;
    }
    function checkName(name2, context) {
      var data3 = byName(name2, context);
      if (!data3)
        throw new BrowserslistError("Unknown browser " + name2);
      return data3;
    }
    function unknownQuery(query) {
      return new BrowserslistError("Unknown browser query `" + query + "`. Maybe you are using old Browserslist or made typo in query.");
    }
    function filterAndroid(list2, versions2, context) {
      if (context.mobileToDesktop)
        return list2;
      var released = browserslist.data.android.released;
      var last2 = released[released.length - 1];
      var diff = last2 - ANDROID_EVERGREEN_FIRST - versions2;
      if (diff > 0) {
        return list2.slice(-1);
      } else {
        return list2.slice(diff - 1);
      }
    }
    function resolve$2(queries, context) {
      if (Array.isArray(queries)) {
        queries = flatten$1(queries.map(parse$4));
      } else {
        queries = parse$4(queries);
      }
      return queries.reduce(function(result, query, index3) {
        var selection = query.queryString;
        var isExclude = selection.indexOf("not ") === 0;
        if (isExclude) {
          if (index3 === 0) {
            throw new BrowserslistError("Write any browsers query (for instance, `defaults`) before `" + selection + "`");
          }
          selection = selection.slice(4);
        }
        for (var i2 = 0; i2 < QUERIES.length; i2++) {
          var type5 = QUERIES[i2];
          var match = selection.match(type5.regexp);
          if (match) {
            var args = [context].concat(match.slice(1));
            var array4 = type5.select.apply(browserslist, args).map(function(j) {
              var parts = j.split(" ");
              if (parts[1] === "0") {
                return parts[0] + " " + byName(parts[0], context).versions[0];
              } else {
                return j;
              }
            });
            switch (query.type) {
              case QUERY_AND:
                if (isExclude) {
                  return result.filter(function(j) {
                    return array4.indexOf(j) === -1;
                  });
                } else {
                  return result.filter(function(j) {
                    return array4.indexOf(j) !== -1;
                  });
                }
              case QUERY_OR:
              default:
                if (isExclude) {
                  var filter3 = {};
                  array4.forEach(function(j) {
                    filter3[j] = true;
                  });
                  return result.filter(function(j) {
                    return !filter3[j];
                  });
                }
                return result.concat(array4);
            }
          }
        }
        throw unknownQuery(selection);
      }, []);
    }
    var cache = {};
    function browserslist(queries, opts) {
      if (typeof opts === "undefined")
        opts = {};
      if (typeof opts.path === "undefined") {
        opts.path = path.resolve ? path.resolve(".") : ".";
      }
      if (typeof queries === "undefined" || queries === null) {
        var config3 = browserslist.loadConfig(opts);
        if (config3) {
          queries = config3;
        } else {
          queries = browserslist.defaults;
        }
      }
      if (!(typeof queries === "string" || Array.isArray(queries))) {
        throw new BrowserslistError("Browser queries must be an array or string. Got " + typeof queries + ".");
      }
      var context = {
        ignoreUnknownVersions: opts.ignoreUnknownVersions,
        dangerousExtend: opts.dangerousExtend,
        mobileToDesktop: opts.mobileToDesktop,
        path: opts.path,
        env: opts.env
      };
      env2.oldDataWarning(browserslist.data);
      var stats = env2.getStat(opts, browserslist.data);
      if (stats) {
        context.customUsage = {};
        for (var browser2 in stats) {
          fillUsage(context.customUsage, browser2, stats[browser2]);
        }
      }
      var cacheKey = JSON.stringify([queries, context]);
      if (cache[cacheKey])
        return cache[cacheKey];
      var result = uniq(resolve$2(queries, context)).sort(function(name1, name2) {
        name1 = name1.split(" ");
        name2 = name2.split(" ");
        if (name1[0] === name2[0]) {
          var version1 = name1[1].split("-")[0];
          var version22 = name2[1].split("-")[0];
          return compareSemver(version22.split("."), version1.split("."));
        } else {
          return compare$9(name1[0], name2[0]);
        }
      });
      if (!browser$1$1.env.BROWSERSLIST_DISABLE_CACHE) {
        cache[cacheKey] = result;
      }
      return result;
    }
    function parse$4(queries) {
      var qs = [];
      do {
        queries = doMatch(queries, qs);
      } while (queries);
      return qs;
    }
    function doMatch(string3, qs) {
      var or = /^(?:,\s*|\s+or\s+)(.*)/i;
      var and = /^\s+and\s+(.*)/i;
      return find2(string3, function(parsed, n2, max3) {
        if (and.test(parsed)) {
          qs.unshift({
            type: QUERY_AND,
            queryString: parsed.match(and)[1]
          });
          return true;
        } else if (or.test(parsed)) {
          qs.unshift({
            type: QUERY_OR,
            queryString: parsed.match(or)[1]
          });
          return true;
        } else if (n2 === max3) {
          qs.unshift({
            type: QUERY_OR,
            queryString: parsed.trim()
          });
          return true;
        }
        return false;
      });
    }
    function find2(string3, predicate) {
      for (var n2 = 1, max3 = string3.length; n2 <= max3; n2++) {
        var parsed = string3.substr(-n2, n2);
        if (predicate(parsed, n2, max3)) {
          return string3.slice(0, -n2);
        }
      }
      return "";
    }
    function flatten$1(array4) {
      if (!Array.isArray(array4))
        return [array4];
      return array4.reduce(function(a, b2) {
        return a.concat(flatten$1(b2));
      }, []);
    }
    browserslist.cache = {};
    browserslist.data = {};
    browserslist.usage = {
      global: {},
      custom: null
    };
    browserslist.defaults = ["> 0.5%", "last 2 versions", "Firefox ESR", "not dead"];
    browserslist.aliases = {
      fx: "firefox",
      ff: "firefox",
      ios: "ios_saf",
      explorer: "ie",
      blackberry: "bb",
      explorermobile: "ie_mob",
      operamini: "op_mini",
      operamobile: "op_mob",
      chromeandroid: "and_chr",
      firefoxandroid: "and_ff",
      ucandroid: "and_uc",
      qqandroid: "and_qq"
    };
    browserslist.desktopNames = {
      and_chr: "chrome",
      and_ff: "firefox",
      ie_mob: "ie",
      op_mob: "opera",
      android: "chrome"
    };
    browserslist.versionAliases = {};
    browserslist.clearCaches = env2.clearCaches;
    browserslist.parseConfig = env2.parseConfig;
    browserslist.readConfig = env2.readConfig;
    browserslist.findConfig = env2.findConfig;
    browserslist.loadConfig = env2.loadConfig;
    browserslist.coverage = function(browsers2, stats) {
      var data3;
      if (typeof stats === "undefined") {
        data3 = browserslist.usage.global;
      } else if (stats === "my stats") {
        var opts = {};
        opts.path = path.resolve ? path.resolve(".") : ".";
        var customStats = env2.getStat(opts);
        if (!customStats) {
          throw new BrowserslistError("Custom usage statistics was not provided");
        }
        data3 = {};
        for (var browser2 in customStats) {
          fillUsage(data3, browser2, customStats[browser2]);
        }
      } else if (typeof stats === "string") {
        if (stats.length > 2) {
          stats = stats.toLowerCase();
        } else {
          stats = stats.toUpperCase();
        }
        env2.loadCountry(browserslist.usage, stats, browserslist.data);
        data3 = browserslist.usage[stats];
      } else {
        if ("dataByBrowser" in stats) {
          stats = stats.dataByBrowser;
        }
        data3 = {};
        for (var name2 in stats) {
          for (var version3 in stats[name2]) {
            data3[name2 + " " + version3] = stats[name2][version3];
          }
        }
      }
      return browsers2.reduce(function(all2, i2) {
        var usage2 = data3[i2];
        if (usage2 === void 0) {
          usage2 = data3[i2.replace(/ \S+$/, " 0")];
        }
        return all2 + (usage2 || 0);
      }, 0);
    };
    function nodeQuery(context, version3) {
      var matched = browserslist.nodeVersions.filter(function(i2) {
        return isVersionsMatch(i2, version3);
      });
      if (matched.length === 0) {
        if (context.ignoreUnknownVersions) {
          return [];
        } else {
          throw new BrowserslistError("Unknown version " + version3 + " of Node.js");
        }
      }
      return ["node " + matched[matched.length - 1]];
    }
    function sinceQuery(context, year, month, date4) {
      year = parseInt(year);
      month = parseInt(month || "01") - 1;
      date4 = parseInt(date4 || "01");
      return filterByYear(Date.UTC(year, month, date4, 0, 0, 0), context);
    }
    function coverQuery(context, coverage, statMode) {
      coverage = parseFloat(coverage);
      var usage2 = browserslist.usage.global;
      if (statMode) {
        if (statMode.match(/^my\s+stats$/i)) {
          if (!context.customUsage) {
            throw new BrowserslistError("Custom usage statistics was not provided");
          }
          usage2 = context.customUsage;
        } else {
          var place;
          if (statMode.length === 2) {
            place = statMode.toUpperCase();
          } else {
            place = statMode.toLowerCase();
          }
          env2.loadCountry(browserslist.usage, place, browserslist.data);
          usage2 = browserslist.usage[place];
        }
      }
      var versions2 = Object.keys(usage2).sort(function(a, b2) {
        return usage2[b2] - usage2[a];
      });
      var coveraged = 0;
      var result = [];
      var version3;
      for (var i2 = 0; i2 < versions2.length; i2++) {
        version3 = versions2[i2];
        if (usage2[version3] === 0)
          break;
        coveraged += usage2[version3];
        result.push(version3);
        if (coveraged >= coverage)
          break;
      }
      return result;
    }
    var QUERIES = [{
      regexp: /^last\s+(\d+)\s+major\s+versions?$/i,
      select: function select(context, versions2) {
        return Object.keys(agents).reduce(function(selected, name2) {
          var data3 = byName(name2, context);
          if (!data3)
            return selected;
          var list2 = getMajorVersions(data3.released, versions2);
          list2 = list2.map(nameMapper(data3.name));
          if (data3.name === "android") {
            list2 = filterAndroid(list2, versions2, context);
          }
          return selected.concat(list2);
        }, []);
      }
    }, {
      regexp: /^last\s+(\d+)\s+versions?$/i,
      select: function select(context, versions2) {
        return Object.keys(agents).reduce(function(selected, name2) {
          var data3 = byName(name2, context);
          if (!data3)
            return selected;
          var list2 = data3.released.slice(-versions2);
          list2 = list2.map(nameMapper(data3.name));
          if (data3.name === "android") {
            list2 = filterAndroid(list2, versions2, context);
          }
          return selected.concat(list2);
        }, []);
      }
    }, {
      regexp: /^last\s+(\d+)\s+electron\s+major\s+versions?$/i,
      select: function select(context, versions2) {
        var validVersions = getMajorVersions(Object.keys(e2c), versions2);
        return validVersions.map(function(i2) {
          return "chrome " + e2c[i2];
        });
      }
    }, {
      regexp: /^last\s+(\d+)\s+node\s+major\s+versions?$/i,
      select: function select(context, versions2) {
        return getMajorVersions(browserslist.nodeVersions, versions2).map(function(version3) {
          return "node " + version3;
        });
      }
    }, {
      regexp: /^last\s+(\d+)\s+(\w+)\s+major\s+versions?$/i,
      select: function select(context, versions2, name2) {
        var data3 = checkName(name2, context);
        var validVersions = getMajorVersions(data3.released, versions2);
        var list2 = validVersions.map(nameMapper(data3.name));
        if (data3.name === "android") {
          list2 = filterAndroid(list2, versions2, context);
        }
        return list2;
      }
    }, {
      regexp: /^last\s+(\d+)\s+electron\s+versions?$/i,
      select: function select(context, versions2) {
        return Object.keys(e2c).slice(-versions2).map(function(i2) {
          return "chrome " + e2c[i2];
        });
      }
    }, {
      regexp: /^last\s+(\d+)\s+node\s+versions?$/i,
      select: function select(context, versions2) {
        return browserslist.nodeVersions.slice(-versions2).map(function(version3) {
          return "node " + version3;
        });
      }
    }, {
      regexp: /^last\s+(\d+)\s+(\w+)\s+versions?$/i,
      select: function select(context, versions2, name2) {
        var data3 = checkName(name2, context);
        var list2 = data3.released.slice(-versions2).map(nameMapper(data3.name));
        if (data3.name === "android") {
          list2 = filterAndroid(list2, versions2, context);
        }
        return list2;
      }
    }, {
      regexp: /^unreleased\s+versions$/i,
      select: function select(context) {
        return Object.keys(agents).reduce(function(selected, name2) {
          var data3 = byName(name2, context);
          if (!data3)
            return selected;
          var list2 = data3.versions.filter(function(v22) {
            return data3.released.indexOf(v22) === -1;
          });
          list2 = list2.map(nameMapper(data3.name));
          return selected.concat(list2);
        }, []);
      }
    }, {
      regexp: /^unreleased\s+electron\s+versions?$/i,
      select: function select() {
        return [];
      }
    }, {
      regexp: /^unreleased\s+(\w+)\s+versions?$/i,
      select: function select(context, name2) {
        var data3 = checkName(name2, context);
        return data3.versions.filter(function(v22) {
          return data3.released.indexOf(v22) === -1;
        }).map(nameMapper(data3.name));
      }
    }, {
      regexp: /^last\s+(\d*.?\d+)\s+years?$/i,
      select: function select(context, years) {
        return filterByYear(Date.now() - YEAR * years, context);
      }
    }, {
      regexp: /^since (\d+)$/i,
      select: sinceQuery
    }, {
      regexp: /^since (\d+)-(\d+)$/i,
      select: sinceQuery
    }, {
      regexp: /^since (\d+)-(\d+)-(\d+)$/i,
      select: sinceQuery
    }, {
      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%$/,
      select: function select(context, sign, popularity) {
        popularity = parseFloat(popularity);
        var usage2 = browserslist.usage.global;
        return Object.keys(usage2).reduce(function(result, version3) {
          if (sign === ">") {
            if (usage2[version3] > popularity) {
              result.push(version3);
            }
          } else if (sign === "<") {
            if (usage2[version3] < popularity) {
              result.push(version3);
            }
          } else if (sign === "<=") {
            if (usage2[version3] <= popularity) {
              result.push(version3);
            }
          } else if (usage2[version3] >= popularity) {
            result.push(version3);
          }
          return result;
        }, []);
      }
    }, {
      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+my\s+stats$/,
      select: function select(context, sign, popularity) {
        popularity = parseFloat(popularity);
        if (!context.customUsage) {
          throw new BrowserslistError("Custom usage statistics was not provided");
        }
        var usage2 = context.customUsage;
        return Object.keys(usage2).reduce(function(result, version3) {
          var percentage = usage2[version3];
          if (percentage == null) {
            return result;
          }
          if (sign === ">") {
            if (percentage > popularity) {
              result.push(version3);
            }
          } else if (sign === "<") {
            if (percentage < popularity) {
              result.push(version3);
            }
          } else if (sign === "<=") {
            if (percentage <= popularity) {
              result.push(version3);
            }
          } else if (percentage >= popularity) {
            result.push(version3);
          }
          return result;
        }, []);
      }
    }, {
      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+(\S+)\s+stats$/,
      select: function select(context, sign, popularity, name2) {
        popularity = parseFloat(popularity);
        var stats = env2.loadStat(context, name2, browserslist.data);
        if (stats) {
          context.customUsage = {};
          for (var browser2 in stats) {
            fillUsage(context.customUsage, browser2, stats[browser2]);
          }
        }
        if (!context.customUsage) {
          throw new BrowserslistError("Custom usage statistics was not provided");
        }
        var usage2 = context.customUsage;
        return Object.keys(usage2).reduce(function(result, version3) {
          var percentage = usage2[version3];
          if (percentage == null) {
            return result;
          }
          if (sign === ">") {
            if (percentage > popularity) {
              result.push(version3);
            }
          } else if (sign === "<") {
            if (percentage < popularity) {
              result.push(version3);
            }
          } else if (sign === "<=") {
            if (percentage <= popularity) {
              result.push(version3);
            }
          } else if (percentage >= popularity) {
            result.push(version3);
          }
          return result;
        }, []);
      }
    }, {
      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+((alt-)?\w\w)$/,
      select: function select(context, sign, popularity, place) {
        popularity = parseFloat(popularity);
        if (place.length === 2) {
          place = place.toUpperCase();
        } else {
          place = place.toLowerCase();
        }
        env2.loadCountry(browserslist.usage, place, browserslist.data);
        var usage2 = browserslist.usage[place];
        return Object.keys(usage2).reduce(function(result, version3) {
          var percentage = usage2[version3];
          if (percentage == null) {
            return result;
          }
          if (sign === ">") {
            if (percentage > popularity) {
              result.push(version3);
            }
          } else if (sign === "<") {
            if (percentage < popularity) {
              result.push(version3);
            }
          } else if (sign === "<=") {
            if (percentage <= popularity) {
              result.push(version3);
            }
          } else if (percentage >= popularity) {
            result.push(version3);
          }
          return result;
        }, []);
      }
    }, {
      regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%$/i,
      select: coverQuery
    }, {
      regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%\s+in\s+(my\s+stats|(alt-)?\w\w)$/i,
      select: coverQuery
    }, {
      regexp: /^supports\s+([\w-]+)$/,
      select: function select(context, feature) {
        env2.loadFeature(browserslist.cache, feature);
        var features2 = browserslist.cache[feature];
        return Object.keys(features2).reduce(function(result, version3) {
          var flags = features2[version3];
          if (flags.indexOf("y") >= 0 || flags.indexOf("a") >= 0) {
            result.push(version3);
          }
          return result;
        }, []);
      }
    }, {
      regexp: /^electron\s+([\d.]+)\s*-\s*([\d.]+)$/i,
      select: function select(context, from2, to) {
        var fromToUse = normalizeElectron(from2);
        var toToUse = normalizeElectron(to);
        if (!e2c[fromToUse]) {
          throw new BrowserslistError("Unknown version " + from2 + " of electron");
        }
        if (!e2c[toToUse]) {
          throw new BrowserslistError("Unknown version " + to + " of electron");
        }
        from2 = parseFloat(from2);
        to = parseFloat(to);
        return Object.keys(e2c).filter(function(i2) {
          var parsed = parseFloat(i2);
          return parsed >= from2 && parsed <= to;
        }).map(function(i2) {
          return "chrome " + e2c[i2];
        });
      }
    }, {
      regexp: /^node\s+([\d.]+)\s*-\s*([\d.]+)$/i,
      select: function select(context, from2, to) {
        return browserslist.nodeVersions.filter(semverFilterLoose(">=", from2)).filter(semverFilterLoose("<=", to)).map(function(v22) {
          return "node " + v22;
        });
      }
    }, {
      regexp: /^(\w+)\s+([\d.]+)\s*-\s*([\d.]+)$/i,
      select: function select(context, name2, from2, to) {
        var data3 = checkName(name2, context);
        from2 = parseFloat(normalizeVersion(data3, from2) || from2);
        to = parseFloat(normalizeVersion(data3, to) || to);
        function filter3(v22) {
          var parsed = parseFloat(v22);
          return parsed >= from2 && parsed <= to;
        }
        return data3.released.filter(filter3).map(nameMapper(data3.name));
      }
    }, {
      regexp: /^electron\s*(>=?|<=?)\s*([\d.]+)$/i,
      select: function select(context, sign, version3) {
        var versionToUse = normalizeElectron(version3);
        return Object.keys(e2c).filter(generateFilter(sign, versionToUse)).map(function(i2) {
          return "chrome " + e2c[i2];
        });
      }
    }, {
      regexp: /^node\s*(>=?|<=?)\s*([\d.]+)$/i,
      select: function select(context, sign, version3) {
        return browserslist.nodeVersions.filter(generateSemverFilter(sign, version3)).map(function(v22) {
          return "node " + v22;
        });
      }
    }, {
      regexp: /^(\w+)\s*(>=?|<=?)\s*([\d.]+)$/,
      select: function select(context, name2, sign, version3) {
        var data3 = checkName(name2, context);
        var alias2 = browserslist.versionAliases[data3.name][version3];
        if (alias2) {
          version3 = alias2;
        }
        return data3.released.filter(generateFilter(sign, version3)).map(function(v22) {
          return data3.name + " " + v22;
        });
      }
    }, {
      regexp: /^(firefox|ff|fx)\s+esr$/i,
      select: function select() {
        return ["firefox 91"];
      }
    }, {
      regexp: /(operamini|op_mini)\s+all/i,
      select: function select() {
        return ["op_mini all"];
      }
    }, {
      regexp: /^electron\s+([\d.]+)$/i,
      select: function select(context, version3) {
        var versionToUse = normalizeElectron(version3);
        var chrome = e2c[versionToUse];
        if (!chrome) {
          throw new BrowserslistError("Unknown version " + version3 + " of electron");
        }
        return ["chrome " + chrome];
      }
    }, {
      regexp: /^node\s+(\d+)$/i,
      select: nodeQuery
    }, {
      regexp: /^node\s+(\d+\.\d+)$/i,
      select: nodeQuery
    }, {
      regexp: /^node\s+(\d+\.\d+\.\d+)$/i,
      select: nodeQuery
    }, {
      regexp: /^current\s+node$/i,
      select: function select(context) {
        return [env2.currentNode(resolve$2, context)];
      }
    }, {
      regexp: /^maintained\s+node\s+versions$/i,
      select: function select(context) {
        var now = Date.now();
        var queries = Object.keys(jsEOL).filter(function(key2) {
          return now < Date.parse(jsEOL[key2].end) && now > Date.parse(jsEOL[key2].start) && isEolReleased(key2);
        }).map(function(key2) {
          return "node " + key2.slice(1);
        });
        return resolve$2(queries, context);
      }
    }, {
      regexp: /^phantomjs\s+1.9$/i,
      select: function select() {
        return ["safari 5"];
      }
    }, {
      regexp: /^phantomjs\s+2.1$/i,
      select: function select() {
        return ["safari 6"];
      }
    }, {
      regexp: /^(\w+)\s+(tp|[\d.]+)$/i,
      select: function select(context, name2, version3) {
        if (/^tp$/i.test(version3))
          version3 = "TP";
        var data3 = checkName(name2, context);
        var alias2 = normalizeVersion(data3, version3);
        if (alias2) {
          version3 = alias2;
        } else {
          if (version3.indexOf(".") === -1) {
            alias2 = version3 + ".0";
          } else {
            alias2 = version3.replace(/\.0$/, "");
          }
          alias2 = normalizeVersion(data3, alias2);
          if (alias2) {
            version3 = alias2;
          } else if (context.ignoreUnknownVersions) {
            return [];
          } else {
            throw new BrowserslistError("Unknown version " + version3 + " of " + name2);
          }
        }
        return [data3.name + " " + version3];
      }
    }, {
      regexp: /^browserslist config$/i,
      select: function select(context) {
        return browserslist(void 0, context);
      }
    }, {
      regexp: /^extends (.+)$/i,
      select: function select(context, name2) {
        return resolve$2(env2.loadQueries(context, name2), context);
      }
    }, {
      regexp: /^defaults$/i,
      select: function select(context) {
        return resolve$2(browserslist.defaults, context);
      }
    }, {
      regexp: /^dead$/i,
      select: function select(context) {
        var dead = ["ie <= 10", "ie_mob <= 11", "bb <= 10", "op_mob <= 12.1", "samsung 4"];
        return resolve$2(dead, context);
      }
    }, {
      regexp: /^(\w+)$/i,
      select: function select(context, name2) {
        if (byName(name2, context)) {
          throw new BrowserslistError("Specify versions in Browserslist query for browser " + name2);
        } else {
          throw unknownQuery(name2);
        }
      }
    }];
    (function() {
      for (var name2 in agents) {
        var browser2 = agents[name2];
        browserslist.data[name2] = {
          name: name2,
          versions: normalize$12(agents[name2].versions),
          released: normalize$12(agents[name2].versions.slice(0, -3)),
          releaseDate: agents[name2].release_date
        };
        fillUsage(browserslist.usage.global, name2, browser2.usage_global);
        browserslist.versionAliases[name2] = {};
        for (var i2 = 0; i2 < browser2.versions.length; i2++) {
          var full = browser2.versions[i2];
          if (!full)
            continue;
          if (full.indexOf("-") !== -1) {
            var interval = full.split("-");
            for (var j = 0; j < interval.length; j++) {
              browserslist.versionAliases[name2][interval[j]] = full;
            }
          }
        }
      }
      browserslist.versionAliases.op_mob["59"] = "58";
      browserslist.nodeVersions = jsReleases.map(function(release3) {
        return release3.version;
      });
    })();
    var browserslist_1 = browserslist;
    var min3 = Math.min;
    function levenshtein(a, b2) {
      var t3 = [], u = [], i2, j;
      var m2 = a.length, n2 = b2.length;
      if (!m2) {
        return n2;
      }
      if (!n2) {
        return m2;
      }
      for (j = 0; j <= n2; j++) {
        t3[j] = j;
      }
      for (i2 = 1; i2 <= m2; i2++) {
        for (u = [i2], j = 1; j <= n2; j++) {
          u[j] = a[i2 - 1] === b2[j - 1] ? t3[j - 1] : min3(t3[j - 1], t3[j], u[j - 1]) + 1;
        }
        t3 = u;
      }
      return u[n2];
    }
    function findSuggestion(str, arr) {
      var distances = arr.map(function(el) {
        return levenshtein(el, str);
      });
      return arr[distances.indexOf(min3.apply(void 0, _toConsumableArray2(distances)))];
    }
    var OptionValidator = function() {
      function OptionValidator2(descriptor) {
        this.descriptor = descriptor;
      }
      var _proto = OptionValidator2.prototype;
      _proto.validateTopLevelOptions = function validateTopLevelOptions(options, TopLevelOptionShape) {
        var validOptionNames = Object.keys(TopLevelOptionShape);
        for (var _i3 = 0, _Object$keys3 = Object.keys(options); _i3 < _Object$keys3.length; _i3++) {
          var option = _Object$keys3[_i3];
          if (!validOptionNames.includes(option)) {
            throw new Error(this.formatMessage("'" + option + "' is not a valid top-level option.\n- Did you mean '" + findSuggestion(option, validOptionNames) + "'?"));
          }
        }
      };
      _proto.validateBooleanOption = function validateBooleanOption(name2, value, defaultValue) {
        if (value === void 0) {
          return defaultValue;
        } else {
          this.invariant(typeof value === "boolean", "'" + name2 + "' option must be a boolean.");
        }
        return value;
      };
      _proto.validateStringOption = function validateStringOption(name2, value, defaultValue) {
        if (value === void 0) {
          return defaultValue;
        } else {
          this.invariant(typeof value === "string", "'" + name2 + "' option must be a string.");
        }
        return value;
      };
      _proto.invariant = function invariant(condition, message) {
        if (!condition) {
          throw new Error(this.formatMessage(message));
        }
      };
      _proto.formatMessage = function formatMessage(message) {
        return this.descriptor + ": " + message;
      };
      return _createClass2(OptionValidator2);
    }();
    var require$$0$7 = {
      "es6.module": {
        chrome: "61",
        and_chr: "61",
        edge: "16",
        firefox: "60",
        and_ff: "60",
        node: "13.2.0",
        opera: "48",
        op_mob: "48",
        safari: "10.1",
        ios: "10.3",
        samsung: "8.2",
        android: "61",
        electron: "2.0",
        ios_saf: "10.3"
      }
    };
    var nativeModules = require$$0$7;
    var semver$9 = requireSemver();
    var unreleasedLabels = {
      safari: "tp"
    };
    var browserNameMap = {
      and_chr: "chrome",
      and_ff: "firefox",
      android: "android",
      chrome: "chrome",
      edge: "edge",
      firefox: "firefox",
      ie: "ie",
      ie_mob: "ie",
      ios_saf: "ios",
      node: "node",
      op_mob: "opera",
      opera: "opera",
      safari: "safari",
      samsung: "samsung"
    };
    var versionRegExp = /^(\d+|\d+.\d+)$/;
    var v$3 = new OptionValidator("@babel/helper-compilation-targets");
    function semverMin(first, second) {
      return first && semver$9.lt(first, second) ? first : second;
    }
    function semverify(version3) {
      if (typeof version3 === "string" && semver$9.valid(version3)) {
        return version3;
      }
      v$3.invariant(typeof version3 === "number" || typeof version3 === "string" && versionRegExp.test(version3), "'" + version3 + "' is not a valid version");
      var split2 = version3.toString().split(".");
      while (split2.length < 3) {
        split2.push("0");
      }
      return split2.join(".");
    }
    function isUnreleasedVersion(version3, env3) {
      var unreleasedLabel = unreleasedLabels[env3];
      return !!unreleasedLabel && unreleasedLabel === version3.toString().toLowerCase();
    }
    function getLowestUnreleased(a, b2, env3) {
      var unreleasedLabel = unreleasedLabels[env3];
      var hasUnreleased = [a, b2].some(function(item) {
        return item === unreleasedLabel;
      });
      if (hasUnreleased) {
        return a === hasUnreleased ? b2 : a || b2;
      }
      return semverMin(a, b2);
    }
    function getHighestUnreleased(a, b2, env3) {
      return getLowestUnreleased(a, b2, env3) === a ? b2 : a;
    }
    function getLowestImplementedVersion(plugin2, environment) {
      var result = plugin2[environment];
      if (!result && environment === "android") {
        return plugin2.chrome;
      }
      return result;
    }
    var TargetNames = {
      node: "node",
      chrome: "chrome",
      opera: "opera",
      edge: "edge",
      firefox: "firefox",
      safari: "safari",
      ie: "ie",
      ios: "ios",
      android: "android",
      electron: "electron",
      samsung: "samsung",
      rhino: "rhino"
    };
    function prettifyVersion(version3) {
      if (typeof version3 !== "string") {
        return version3;
      }
      var parts = [semver$9.major(version3)];
      var minor = semver$9.minor(version3);
      var patch2 = semver$9.patch(version3);
      if (minor || patch2) {
        parts.push(minor);
      }
      if (patch2) {
        parts.push(patch2);
      }
      return parts.join(".");
    }
    function prettifyTargets(targets) {
      return Object.keys(targets).reduce(function(results, target) {
        var value = targets[target];
        var unreleasedLabel = unreleasedLabels[target];
        if (typeof value === "string" && unreleasedLabel !== value) {
          value = prettifyVersion(value);
        }
        results[target] = value;
        return results;
      }, {});
    }
    function getInclusionReasons(item, targetVersions, list2) {
      var minVersions2 = list2[item] || {};
      return Object.keys(targetVersions).reduce(function(result, env3) {
        var minVersion2 = getLowestImplementedVersion(minVersions2, env3);
        var targetVersion = targetVersions[env3];
        if (!minVersion2) {
          result[env3] = prettifyVersion(targetVersion);
        } else {
          var minIsUnreleased = isUnreleasedVersion(minVersion2, env3);
          var targetIsUnreleased = isUnreleasedVersion(targetVersion, env3);
          if (!targetIsUnreleased && (minIsUnreleased || semver$9.lt(targetVersion.toString(), semverify(minVersion2)))) {
            result[env3] = prettifyVersion(targetVersion);
          }
        }
        return result;
      }, {});
    }
    var require$$0$6 = {
      "proposal-class-static-block": {
        chrome: "94",
        opera: "80",
        edge: "94",
        firefox: "93",
        node: "16.11",
        electron: "15.0"
      },
      "proposal-private-property-in-object": {
        chrome: "91",
        opera: "77",
        edge: "91",
        firefox: "90",
        safari: "15",
        node: "16.9",
        ios: "15",
        electron: "13.0"
      },
      "proposal-class-properties": {
        chrome: "74",
        opera: "62",
        edge: "79",
        firefox: "90",
        safari: "14.1",
        node: "12",
        ios: "15",
        samsung: "11",
        electron: "6.0"
      },
      "proposal-private-methods": {
        chrome: "84",
        opera: "70",
        edge: "84",
        firefox: "90",
        safari: "15",
        node: "14.6",
        ios: "15",
        samsung: "14",
        electron: "10.0"
      },
      "proposal-numeric-separator": {
        chrome: "75",
        opera: "62",
        edge: "79",
        firefox: "70",
        safari: "13",
        node: "12.5",
        ios: "13",
        samsung: "11",
        rhino: "1.7.14",
        electron: "6.0"
      },
      "proposal-logical-assignment-operators": {
        chrome: "85",
        opera: "71",
        edge: "85",
        firefox: "79",
        safari: "14",
        node: "15",
        ios: "14",
        samsung: "14",
        electron: "10.0"
      },
      "proposal-nullish-coalescing-operator": {
        chrome: "80",
        opera: "67",
        edge: "80",
        firefox: "72",
        safari: "13.1",
        node: "14",
        ios: "13.4",
        samsung: "13",
        electron: "8.0"
      },
      "proposal-optional-chaining": {
        chrome: "91",
        opera: "77",
        edge: "91",
        firefox: "74",
        safari: "13.1",
        node: "16.9",
        ios: "13.4",
        electron: "13.0"
      },
      "proposal-json-strings": {
        chrome: "66",
        opera: "53",
        edge: "79",
        firefox: "62",
        safari: "12",
        node: "10",
        ios: "12",
        samsung: "9",
        rhino: "1.7.14",
        electron: "3.0"
      },
      "proposal-optional-catch-binding": {
        chrome: "66",
        opera: "53",
        edge: "79",
        firefox: "58",
        safari: "11.1",
        node: "10",
        ios: "11.3",
        samsung: "9",
        electron: "3.0"
      },
      "transform-parameters": {
        chrome: "49",
        opera: "36",
        edge: "18",
        firefox: "53",
        node: "6",
        samsung: "5",
        electron: "0.37"
      },
      "proposal-async-generator-functions": {
        chrome: "63",
        opera: "50",
        edge: "79",
        firefox: "57",
        safari: "12",
        node: "10",
        ios: "12",
        samsung: "8",
        electron: "3.0"
      },
      "proposal-object-rest-spread": {
        chrome: "60",
        opera: "47",
        edge: "79",
        firefox: "55",
        safari: "11.1",
        node: "8.3",
        ios: "11.3",
        samsung: "8",
        electron: "2.0"
      },
      "transform-dotall-regex": {
        chrome: "62",
        opera: "49",
        edge: "79",
        firefox: "78",
        safari: "11.1",
        node: "8.10",
        ios: "11.3",
        samsung: "8",
        electron: "3.0"
      },
      "proposal-unicode-property-regex": {
        chrome: "64",
        opera: "51",
        edge: "79",
        firefox: "78",
        safari: "11.1",
        node: "10",
        ios: "11.3",
        samsung: "9",
        electron: "3.0"
      },
      "transform-named-capturing-groups-regex": {
        chrome: "64",
        opera: "51",
        edge: "79",
        firefox: "78",
        safari: "11.1",
        node: "10",
        ios: "11.3",
        samsung: "9",
        electron: "3.0"
      },
      "transform-async-to-generator": {
        chrome: "55",
        opera: "42",
        edge: "15",
        firefox: "52",
        safari: "11",
        node: "7.6",
        ios: "11",
        samsung: "6",
        electron: "1.6"
      },
      "transform-exponentiation-operator": {
        chrome: "52",
        opera: "39",
        edge: "14",
        firefox: "52",
        safari: "10.1",
        node: "7",
        ios: "10.3",
        samsung: "6",
        rhino: "1.7.14",
        electron: "1.3"
      },
      "transform-template-literals": {
        chrome: "41",
        opera: "28",
        edge: "13",
        firefox: "34",
        safari: "13",
        node: "4",
        ios: "13",
        samsung: "3.4",
        electron: "0.21"
      },
      "transform-literals": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "53",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        electron: "0.30"
      },
      "transform-function-name": {
        chrome: "51",
        opera: "38",
        edge: "79",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "transform-arrow-functions": {
        chrome: "47",
        opera: "34",
        edge: "13",
        firefox: "43",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.36"
      },
      "transform-block-scoped-functions": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "46",
        safari: "10",
        node: "4",
        ie: "11",
        ios: "10",
        samsung: "3.4",
        electron: "0.21"
      },
      "transform-classes": {
        chrome: "46",
        opera: "33",
        edge: "13",
        firefox: "45",
        safari: "10",
        node: "5",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "transform-object-super": {
        chrome: "46",
        opera: "33",
        edge: "13",
        firefox: "45",
        safari: "10",
        node: "5",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "transform-shorthand-properties": {
        chrome: "43",
        opera: "30",
        edge: "12",
        firefox: "33",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.14",
        electron: "0.27"
      },
      "transform-duplicate-keys": {
        chrome: "42",
        opera: "29",
        edge: "12",
        firefox: "34",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        electron: "0.25"
      },
      "transform-computed-properties": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "34",
        safari: "7.1",
        node: "4",
        ios: "8",
        samsung: "4",
        electron: "0.30"
      },
      "transform-for-of": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "transform-sticky-regex": {
        chrome: "49",
        opera: "36",
        edge: "13",
        firefox: "3",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "transform-unicode-escapes": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "53",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        electron: "0.30"
      },
      "transform-unicode-regex": {
        chrome: "50",
        opera: "37",
        edge: "13",
        firefox: "46",
        safari: "12",
        node: "6",
        ios: "12",
        samsung: "5",
        electron: "1.1"
      },
      "transform-spread": {
        chrome: "46",
        opera: "33",
        edge: "13",
        firefox: "45",
        safari: "10",
        node: "5",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "transform-destructuring": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "transform-block-scoping": {
        chrome: "49",
        opera: "36",
        edge: "14",
        firefox: "51",
        safari: "11",
        node: "6",
        ios: "11",
        samsung: "5",
        electron: "0.37"
      },
      "transform-typeof-symbol": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "36",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "transform-new-target": {
        chrome: "46",
        opera: "33",
        edge: "14",
        firefox: "41",
        safari: "10",
        node: "5",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "transform-regenerator": {
        chrome: "50",
        opera: "37",
        edge: "13",
        firefox: "53",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "1.1"
      },
      "transform-member-expression-literals": {
        chrome: "7",
        opera: "12",
        edge: "12",
        firefox: "2",
        safari: "5.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "transform-property-literals": {
        chrome: "7",
        opera: "12",
        edge: "12",
        firefox: "2",
        safari: "5.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "transform-reserved-words": {
        chrome: "13",
        opera: "10.50",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4.4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "proposal-export-namespace-from": {
        chrome: "72",
        and_chr: "72",
        edge: "79",
        firefox: "80",
        and_ff: "80",
        node: "13.2",
        opera: "60",
        op_mob: "51",
        samsung: "11.0",
        android: "72",
        electron: "5.0"
      }
    };
    var plugins = require$$0$6;
    function targetsSupported(target, support) {
      var targetEnvironments = Object.keys(target);
      if (targetEnvironments.length === 0) {
        return false;
      }
      var unsupportedEnvironments = targetEnvironments.filter(function(environment) {
        var lowestImplementedVersion = getLowestImplementedVersion(support, environment);
        if (!lowestImplementedVersion) {
          return true;
        }
        var lowestTargetedVersion = target[environment];
        if (isUnreleasedVersion(lowestTargetedVersion, environment)) {
          return false;
        }
        if (isUnreleasedVersion(lowestImplementedVersion, environment)) {
          return true;
        }
        if (!semver$9.valid(lowestTargetedVersion.toString())) {
          throw new Error('Invalid version passed for target "' + environment + '": "' + lowestTargetedVersion + '". Versions must be in semver format (major.minor.patch)');
        }
        return semver$9.gt(semverify(lowestImplementedVersion), lowestTargetedVersion.toString());
      });
      return unsupportedEnvironments.length === 0;
    }
    function isRequired(name2, targets, _temp) {
      var _ref3 = _temp === void 0 ? {} : _temp, _ref$compatData = _ref3.compatData, compatData = _ref$compatData === void 0 ? plugins : _ref$compatData, includes = _ref3.includes, excludes = _ref3.excludes;
      if (excludes != null && excludes.has(name2))
        return false;
      if (includes != null && includes.has(name2))
        return true;
      return !targetsSupported(targets, compatData[name2]);
    }
    function filterItems(list2, includes, excludes, targets, defaultIncludes, defaultExcludes, pluginSyntaxMap2) {
      var result = /* @__PURE__ */ new Set();
      var options = {
        compatData: list2,
        includes,
        excludes
      };
      for (var item in list2) {
        if (isRequired(item, targets, options)) {
          result.add(item);
        } else if (pluginSyntaxMap2) {
          var shippedProposalsSyntax = pluginSyntaxMap2.get(item);
          if (shippedProposalsSyntax) {
            result.add(shippedProposalsSyntax);
          }
        }
      }
      if (defaultIncludes) {
        defaultIncludes.forEach(function(item2) {
          return !excludes.has(item2) && result.add(item2);
        });
      }
      if (defaultExcludes) {
        defaultExcludes.forEach(function(item2) {
          return !includes.has(item2) && result["delete"](item2);
        });
      }
      return result;
    }
    var ESM_SUPPORT = nativeModules["es6.module"];
    var v$2 = new OptionValidator("@babel/helper-compilation-targets");
    function validateTargetNames(targets) {
      var validTargets = Object.keys(TargetNames);
      for (var _i3 = 0, _Object$keys3 = Object.keys(targets); _i3 < _Object$keys3.length; _i3++) {
        var target = _Object$keys3[_i3];
        if (!(target in TargetNames)) {
          throw new Error(v$2.formatMessage("'" + target + "' is not a valid target\n- Did you mean '" + findSuggestion(target, validTargets) + "'?"));
        }
      }
      return targets;
    }
    function isBrowsersQueryValid(browsers2) {
      return typeof browsers2 === "string" || Array.isArray(browsers2) && browsers2.every(function(b2) {
        return typeof b2 === "string";
      });
    }
    function validateBrowsers(browsers2) {
      v$2.invariant(browsers2 === void 0 || isBrowsersQueryValid(browsers2), "'" + String(browsers2) + "' is not a valid browserslist query");
      return browsers2;
    }
    function getLowestVersions(browsers2) {
      return browsers2.reduce(function(all2, browser2) {
        var _browser$split = browser2.split(" "), _browser$split2 = _slicedToArray$12(_browser$split, 2), browserName = _browser$split2[0], browserVersion = _browser$split2[1];
        var normalizedBrowserName = browserNameMap[browserName];
        if (!normalizedBrowserName) {
          return all2;
        }
        try {
          var splitVersion = browserVersion.split("-")[0].toLowerCase();
          var isSplitUnreleased = isUnreleasedVersion(splitVersion, browserName);
          if (!all2[normalizedBrowserName]) {
            all2[normalizedBrowserName] = isSplitUnreleased ? splitVersion : semverify(splitVersion);
            return all2;
          }
          var version3 = all2[normalizedBrowserName];
          var isUnreleased = isUnreleasedVersion(version3, browserName);
          if (isUnreleased && isSplitUnreleased) {
            all2[normalizedBrowserName] = getLowestUnreleased(version3, splitVersion, browserName);
          } else if (isUnreleased) {
            all2[normalizedBrowserName] = semverify(splitVersion);
          } else if (!isUnreleased && !isSplitUnreleased) {
            var parsedBrowserVersion = semverify(splitVersion);
            all2[normalizedBrowserName] = semverMin(version3, parsedBrowserVersion);
          }
        } catch (e2) {
        }
        return all2;
      }, {});
    }
    function outputDecimalWarning(decimalTargets) {
      if (!decimalTargets.length) {
        return;
      }
      console.warn("Warning, the following targets are using a decimal version:\n");
      decimalTargets.forEach(function(_ref3) {
        var target = _ref3.target, value = _ref3.value;
        return console.warn("  " + target + ": " + value);
      });
      console.warn("\nWe recommend using a string for minor/patch versions to avoid numbers like 6.10\ngetting parsed as 6.1, which can lead to unexpected behavior.\n");
    }
    function semverifyTarget(target, value) {
      try {
        return semverify(value);
      } catch (error2) {
        throw new Error(v$2.formatMessage("'" + value + "' is not a valid value for 'targets." + target + "'."));
      }
    }
    var targetParserMap = {
      __default: function __default(target, value) {
        var version3 = isUnreleasedVersion(value, target) ? value.toLowerCase() : semverifyTarget(target, value);
        return [target, version3];
      },
      node: function node2(target, value) {
        var parsed = value === true || value === "current" ? browser$1$1.versions.node : semverifyTarget(target, value);
        return [target, parsed];
      }
    };
    function generateTargets(inputTargets) {
      var input = Object.assign({}, inputTargets);
      delete input.esmodules;
      delete input.browsers;
      return input;
    }
    function resolveTargets$1(queries, env3) {
      var resolved = browserslist_1(queries, {
        mobileToDesktop: true,
        env: env3
      });
      return getLowestVersions(resolved);
    }
    function getTargets$2(inputTargets, options) {
      var _browsers, _browsers2;
      if (inputTargets === void 0) {
        inputTargets = {};
      }
      if (options === void 0) {
        options = {};
      }
      var _inputTargets = inputTargets, browsers2 = _inputTargets.browsers, esmodules = _inputTargets.esmodules;
      var _options = options, _options$configPath = _options.configPath, configPath = _options$configPath === void 0 ? "." : _options$configPath;
      validateBrowsers(browsers2);
      var input = generateTargets(inputTargets);
      var targets = validateTargetNames(input);
      var shouldParseBrowsers = !!browsers2;
      var hasTargets = shouldParseBrowsers || Object.keys(targets).length > 0;
      var shouldSearchForConfig = !options.ignoreBrowserslistConfig && !hasTargets;
      if (!browsers2 && shouldSearchForConfig) {
        browsers2 = browserslist_1.loadConfig({
          config: options.configFile,
          path: configPath,
          env: options.browserslistEnv
        });
        if (browsers2 == null) {
          {
            browsers2 = [];
          }
        }
      }
      if (esmodules && (esmodules !== "intersect" || !((_browsers = browsers2) != null && _browsers.length))) {
        browsers2 = Object.keys(ESM_SUPPORT).map(function(browser3) {
          return browser3 + " >= " + ESM_SUPPORT[browser3];
        }).join(", ");
        esmodules = false;
      }
      if ((_browsers2 = browsers2) != null && _browsers2.length) {
        var queryBrowsers = resolveTargets$1(browsers2, options.browserslistEnv);
        if (esmodules === "intersect") {
          for (var _i22 = 0, _Object$keys22 = Object.keys(queryBrowsers); _i22 < _Object$keys22.length; _i22++) {
            var browser2 = _Object$keys22[_i22];
            var version3 = queryBrowsers[browser2];
            if (ESM_SUPPORT[browser2]) {
              queryBrowsers[browser2] = getHighestUnreleased(version3, semverify(ESM_SUPPORT[browser2]), browser2);
            } else {
              delete queryBrowsers[browser2];
            }
          }
        }
        targets = Object.assign(queryBrowsers, targets);
      }
      var result = {};
      var decimalWarnings = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(Object.keys(targets).sort()), _step2; !(_step2 = _iterator2()).done; ) {
        var _targetParserMap$targ;
        var target = _step2.value;
        var value = targets[target];
        if (typeof value === "number" && value % 1 !== 0) {
          decimalWarnings.push({
            target,
            value
          });
        }
        var parser2 = (_targetParserMap$targ = targetParserMap[target]) != null ? _targetParserMap$targ : targetParserMap.__default;
        var _parser = parser2(target, value), _parser2 = _slicedToArray$12(_parser, 2), parsedTarget = _parser2[0], parsedValue = _parser2[1];
        if (parsedValue) {
          result[parsedTarget] = parsedValue;
        }
      }
      outputDecimalWarning(decimalWarnings);
      return result;
    }
    function resolveBrowserslistConfigFile(browserslistConfigFile, configFilePath) {
      return void 0;
    }
    function resolveTargets(options, root2) {
      var targets = options.targets;
      if (typeof targets === "string" || Array.isArray(targets)) {
        targets = {
          browsers: targets
        };
      }
      if (targets && targets.esmodules) {
        targets = Object.assign({}, targets, {
          esmodules: "intersect"
        });
      }
      return getTargets$2(targets, {
        ignoreBrowserslistConfig: true,
        browserslistEnv: options.browserslistEnv
      });
    }
    var _marked$7 = regenerator2.mark(handlerOf), _marked2$3 = regenerator2.mark(createPresetDescriptors), _marked3$1 = regenerator2.mark(createPluginDescriptors), _marked4$1 = regenerator2.mark(createDescriptors), _marked5$1 = regenerator2.mark(createDescriptor);
    function isEqualDescriptor(a, b2) {
      return a.name === b2.name && a.value === b2.value && a.options === b2.options && a.dirname === b2.dirname && a.alias === b2.alias && a.ownPass === b2.ownPass && (a.file && a.file.request) === (b2.file && b2.file.request) && (a.file && a.file.resolved) === (b2.file && b2.file.resolved);
    }
    function handlerOf(value) {
      return regenerator2.wrap(function handlerOf$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", value);
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$7);
    }
    function optionsWithResolvedBrowserslistConfigFile(options, dirname2) {
      if (typeof options.browserslistConfigFile === "string") {
        options.browserslistConfigFile = resolveBrowserslistConfigFile(options.browserslistConfigFile);
      }
      return options;
    }
    function createCachedDescriptors(dirname2, options, alias2) {
      var plugins2 = options.plugins, presets = options.presets, passPerPreset = options.passPerPreset;
      return {
        options: optionsWithResolvedBrowserslistConfigFile(options),
        plugins: plugins2 ? function() {
          return createCachedPluginDescriptors(plugins2, dirname2)(alias2);
        } : function() {
          return handlerOf([]);
        },
        presets: presets ? function() {
          return createCachedPresetDescriptors(presets, dirname2)(alias2)(!!passPerPreset);
        } : function() {
          return handlerOf([]);
        }
      };
    }
    function createUncachedDescriptors(dirname2, options, alias2) {
      var _plugins;
      var _presets;
      return {
        options: optionsWithResolvedBrowserslistConfigFile(options),
        plugins: regenerator2.mark(function plugins2() {
          return regenerator2.wrap(function plugins$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (_plugins) {
                    _context2.next = 3;
                    break;
                  }
                  return _context2.delegateYield(createPluginDescriptors(options.plugins || [], dirname2, alias2), "t0", 2);
                case 2:
                  _plugins = _context2.t0;
                case 3:
                  return _context2.abrupt("return", _plugins);
                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, plugins2);
        }),
        presets: regenerator2.mark(function presets() {
          return regenerator2.wrap(function presets$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (_presets) {
                    _context3.next = 3;
                    break;
                  }
                  return _context3.delegateYield(createPresetDescriptors(options.presets || [], dirname2, alias2, !!options.passPerPreset), "t0", 2);
                case 2:
                  _presets = _context3.t0;
                case 3:
                  return _context3.abrupt("return", _presets);
                case 4:
                case "end":
                  return _context3.stop();
              }
            }
          }, presets);
        })
      };
    }
    var PRESET_DESCRIPTOR_CACHE = /* @__PURE__ */ new WeakMap();
    var createCachedPresetDescriptors = makeWeakCacheSync(function(items, cache2) {
      var dirname2 = cache2.using(function(dir3) {
        return dir3;
      });
      return makeStrongCacheSync(function(alias2) {
        return makeStrongCache(regenerator2.mark(function _callee(passPerPreset) {
          var descriptors;
          return regenerator2.wrap(function _callee$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  return _context4.delegateYield(createPresetDescriptors(items, dirname2, alias2, passPerPreset), "t0", 1);
                case 1:
                  descriptors = _context4.t0;
                  return _context4.abrupt("return", descriptors.map(function(desc) {
                    return loadCachedDescriptor(PRESET_DESCRIPTOR_CACHE, desc);
                  }));
                case 3:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee);
        }));
      });
    });
    var PLUGIN_DESCRIPTOR_CACHE = /* @__PURE__ */ new WeakMap();
    var createCachedPluginDescriptors = makeWeakCacheSync(function(items, cache2) {
      var dirname2 = cache2.using(function(dir3) {
        return dir3;
      });
      return makeStrongCache(regenerator2.mark(function _callee2(alias2) {
        var descriptors;
        return regenerator2.wrap(function _callee2$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.delegateYield(createPluginDescriptors(items, dirname2, alias2), "t0", 1);
              case 1:
                descriptors = _context5.t0;
                return _context5.abrupt("return", descriptors.map(function(desc) {
                  return loadCachedDescriptor(PLUGIN_DESCRIPTOR_CACHE, desc);
                }));
              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee2);
      }));
    });
    var DEFAULT_OPTIONS = {};
    function loadCachedDescriptor(cache2, desc) {
      var value = desc.value, _desc$options = desc.options, options = _desc$options === void 0 ? DEFAULT_OPTIONS : _desc$options;
      if (options === false)
        return desc;
      var cacheByOptions = cache2.get(value);
      if (!cacheByOptions) {
        cacheByOptions = /* @__PURE__ */ new WeakMap();
        cache2.set(value, cacheByOptions);
      }
      var possibilities = cacheByOptions.get(options);
      if (!possibilities) {
        possibilities = [];
        cacheByOptions.set(options, possibilities);
      }
      if (possibilities.indexOf(desc) === -1) {
        var matches = possibilities.filter(function(possibility) {
          return isEqualDescriptor(possibility, desc);
        });
        if (matches.length > 0) {
          return matches[0];
        }
        possibilities.push(desc);
      }
      return desc;
    }
    function createPresetDescriptors(items, dirname2, alias2, passPerPreset) {
      return regenerator2.wrap(function createPresetDescriptors$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              return _context6.delegateYield(createDescriptors("preset", items, dirname2, alias2, passPerPreset), "t0", 1);
            case 1:
              return _context6.abrupt("return", _context6.t0);
            case 2:
            case "end":
              return _context6.stop();
          }
        }
      }, _marked2$3);
    }
    function createPluginDescriptors(items, dirname2, alias2) {
      return regenerator2.wrap(function createPluginDescriptors$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              return _context7.delegateYield(createDescriptors("plugin", items, dirname2, alias2), "t0", 1);
            case 1:
              return _context7.abrupt("return", _context7.t0);
            case 2:
            case "end":
              return _context7.stop();
          }
        }
      }, _marked3$1);
    }
    function createDescriptors(type5, items, dirname2, alias2, ownPass) {
      var descriptors;
      return regenerator2.wrap(function createDescriptors$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              return _context8.delegateYield(gensync.all(items.map(function(item, index3) {
                return createDescriptor(item, dirname2, {
                  type: type5,
                  alias: alias2 + "$" + index3,
                  ownPass: !!ownPass
                });
              })), "t0", 1);
            case 1:
              descriptors = _context8.t0;
              assertNoDuplicates(descriptors);
              return _context8.abrupt("return", descriptors);
            case 4:
            case "end":
              return _context8.stop();
          }
        }
      }, _marked4$1);
    }
    function createDescriptor(pair, dirname2, _ref3) {
      var type5, alias2, ownPass, desc, name2, options, value, _value, _value2, _value3, _value4, file2, filepath, resolver, request, _yield$resolver;
      return regenerator2.wrap(function createDescriptor$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              type5 = _ref3.type, alias2 = _ref3.alias, ownPass = _ref3.ownPass;
              desc = getItemDescriptor(pair);
              if (!desc) {
                _context9.next = 4;
                break;
              }
              return _context9.abrupt("return", desc);
            case 4:
              value = pair;
              if (Array.isArray(value)) {
                if (value.length === 3) {
                  _value = value;
                  _value2 = _slicedToArray$12(_value, 3);
                  value = _value2[0];
                  options = _value2[1];
                  name2 = _value2[2];
                } else {
                  _value3 = value;
                  _value4 = _slicedToArray$12(_value3, 2);
                  value = _value4[0];
                  options = _value4[1];
                }
              }
              file2 = void 0;
              filepath = null;
              if (!(typeof value === "string")) {
                _context9.next = 18;
                break;
              }
              if (!(typeof type5 !== "string")) {
                _context9.next = 11;
                break;
              }
              throw new Error("To resolve a string-based item, the type of item must be given");
            case 11:
              resolver = type5 === "plugin" ? loadPlugin : loadPreset;
              request = value;
              return _context9.delegateYield(resolver(value, dirname2), "t0", 14);
            case 14:
              _yield$resolver = _context9.t0;
              filepath = _yield$resolver.filepath;
              value = _yield$resolver.value;
              file2 = {
                request,
                resolved: filepath
              };
            case 18:
              if (value) {
                _context9.next = 20;
                break;
              }
              throw new Error("Unexpected falsy value: " + String(value));
            case 20:
              if (!(typeof value === "object" && value.__esModule)) {
                _context9.next = 26;
                break;
              }
              if (!value["default"]) {
                _context9.next = 25;
                break;
              }
              value = value["default"];
              _context9.next = 26;
              break;
            case 25:
              throw new Error("Must export a default export when using ES6 modules.");
            case 26:
              if (!(typeof value !== "object" && typeof value !== "function")) {
                _context9.next = 28;
                break;
              }
              throw new Error("Unsupported format: " + typeof value + ". Expected an object or a function.");
            case 28:
              if (!(filepath !== null && typeof value === "object" && value)) {
                _context9.next = 30;
                break;
              }
              throw new Error("Plugin/Preset files are not allowed to export objects, only functions. In " + filepath);
            case 30:
              return _context9.abrupt("return", {
                name: name2,
                alias: filepath || alias2,
                value,
                options,
                dirname: dirname2,
                ownPass,
                file: file2
              });
            case 31:
            case "end":
              return _context9.stop();
          }
        }
      }, _marked5$1);
    }
    function assertNoDuplicates(items) {
      var map2 = /* @__PURE__ */ new Map();
      var _loop3 = function _loop4() {
        var item = _step2.value;
        if (typeof item.value !== "function")
          return "continue";
        var nameMap = map2.get(item.value);
        if (!nameMap) {
          nameMap = /* @__PURE__ */ new Set();
          map2.set(item.value, nameMap);
        }
        if (nameMap.has(item.name)) {
          var conflicts = items.filter(function(i2) {
            return i2.value === item.value;
          });
          throw new Error(["Duplicate plugin/preset detected.", "If you'd like to use two separate instances of a plugin,", "they need separate names, e.g.", "", "  plugins: [", "    ['some-plugin', {}],", "    ['some-plugin', {}, 'some unique name'],", "  ]", "", "Duplicates detected are:", "" + JSON.stringify(conflicts, null, 2)].join("\n"));
        }
        nameMap.add(item.name);
      };
      for (var _iterator2 = _createForOfIteratorHelperLoose(items), _step2; !(_step2 = _iterator2()).done; ) {
        var _ret2 = _loop3();
        if (_ret2 === "continue")
          continue;
      }
    }
    var _marked$6 = regenerator2.mark(createConfigItem$1);
    function createItemFromDescriptor(desc) {
      return new ConfigItem(desc);
    }
    function createConfigItem$1(value, _temp) {
      var _ref3, _ref$dirname, dirname2, type5, descriptor;
      return regenerator2.wrap(function createConfigItem$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _ref3 = _temp === void 0 ? {} : _temp, _ref$dirname = _ref3.dirname, dirname2 = _ref$dirname === void 0 ? "." : _ref$dirname, type5 = _ref3.type;
              return _context.delegateYield(createDescriptor(value, path$1.resolve(dirname2), {
                type: type5,
                alias: "programmatic item"
              }), "t0", 2);
            case 2:
              descriptor = _context.t0;
              return _context.abrupt("return", createItemFromDescriptor(descriptor));
            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$6);
    }
    function getItemDescriptor(item) {
      if (item != null && item[CONFIG_ITEM_BRAND]) {
        return item._descriptor;
      }
      return void 0;
    }
    var CONFIG_ITEM_BRAND = Symbol["for"]("@babel/core@7 - ConfigItem");
    var ConfigItem = _createClass2(function ConfigItem2(descriptor) {
      this._descriptor = void 0;
      this[CONFIG_ITEM_BRAND] = true;
      this.value = void 0;
      this.options = void 0;
      this.dirname = void 0;
      this.name = void 0;
      this.file = void 0;
      this._descriptor = descriptor;
      Object.defineProperty(this, "_descriptor", {
        enumerable: false
      });
      Object.defineProperty(this, CONFIG_ITEM_BRAND, {
        enumerable: false
      });
      this.value = this._descriptor.value;
      this.options = this._descriptor.options;
      this.dirname = this._descriptor.dirname;
      this.name = this._descriptor.name;
      this.file = this._descriptor.file ? {
        request: this._descriptor.file.request,
        resolved: this._descriptor.file.resolved
      } : void 0;
      Object.freeze(this);
    });
    Object.freeze(ConfigItem.prototype);
    var removed = {
      auxiliaryComment: {
        message: "Use `auxiliaryCommentBefore` or `auxiliaryCommentAfter`"
      },
      blacklist: {
        message: "Put the specific transforms you want in the `plugins` option"
      },
      breakConfig: {
        message: "This is not a necessary option in Babel 6"
      },
      experimental: {
        message: "Put the specific transforms you want in the `plugins` option"
      },
      externalHelpers: {
        message: "Use the `external-helpers` plugin instead. Check out http://babeljs.io/docs/plugins/external-helpers/"
      },
      extra: {
        message: ""
      },
      jsxPragma: {
        message: "use the `pragma` option in the `react-jsx` plugin. Check out http://babeljs.io/docs/plugins/transform-react-jsx/"
      },
      loose: {
        message: "Specify the `loose` option for the relevant plugin you are using or use a preset that sets the option."
      },
      metadataUsedHelpers: {
        message: "Not required anymore as this is enabled by default"
      },
      modules: {
        message: "Use the corresponding module transform plugin in the `plugins` option. Check out http://babeljs.io/docs/plugins/#modules"
      },
      nonStandard: {
        message: "Use the `react-jsx` and `flow-strip-types` plugins to support JSX and Flow. Also check out the react preset http://babeljs.io/docs/plugins/preset-react/"
      },
      optional: {
        message: "Put the specific transforms you want in the `plugins` option"
      },
      sourceMapName: {
        message: "The `sourceMapName` option has been removed because it makes more sense for the tooling that calls Babel to assign `map.file` themselves."
      },
      stage: {
        message: "Check out the corresponding stage-x presets http://babeljs.io/docs/plugins/#presets"
      },
      whitelist: {
        message: "Put the specific transforms you want in the `plugins` option"
      },
      resolveModuleSource: {
        version: 6,
        message: "Use `babel-plugin-module-resolver@3`'s 'resolvePath' options"
      },
      metadata: {
        version: 6,
        message: "Generated plugin metadata is always included in the output result"
      },
      sourceMapTarget: {
        version: 6,
        message: "The `sourceMapTarget` option has been removed because it makes more sense for the tooling that calls Babel to assign `map.file` themselves."
      }
    };
    function msg(loc) {
      switch (loc.type) {
        case "root":
          return "";
        case "env":
          return msg(loc.parent) + '.env["' + loc.name + '"]';
        case "overrides":
          return msg(loc.parent) + ".overrides[" + loc.index + "]";
        case "option":
          return msg(loc.parent) + "." + loc.name;
        case "access":
          return msg(loc.parent) + "[" + JSON.stringify(loc.name) + "]";
        default:
          throw new Error("Assertion failure: Unknown type " + loc.type);
      }
    }
    function access(loc, name2) {
      return {
        type: "access",
        name: name2,
        parent: loc
      };
    }
    function assertRootMode(loc, value) {
      if (value !== void 0 && value !== "root" && value !== "upward" && value !== "upward-optional") {
        throw new Error(msg(loc) + ' must be a "root", "upward", "upward-optional" or undefined');
      }
      return value;
    }
    function assertSourceMaps(loc, value) {
      if (value !== void 0 && typeof value !== "boolean" && value !== "inline" && value !== "both") {
        throw new Error(msg(loc) + ' must be a boolean, "inline", "both", or undefined');
      }
      return value;
    }
    function assertCompact(loc, value) {
      if (value !== void 0 && typeof value !== "boolean" && value !== "auto") {
        throw new Error(msg(loc) + ' must be a boolean, "auto", or undefined');
      }
      return value;
    }
    function assertSourceType(loc, value) {
      if (value !== void 0 && value !== "module" && value !== "script" && value !== "unambiguous") {
        throw new Error(msg(loc) + ' must be "module", "script", "unambiguous", or undefined');
      }
      return value;
    }
    function assertCallerMetadata(loc, value) {
      var obj = assertObject(loc, value);
      if (obj) {
        if (typeof obj.name !== "string") {
          throw new Error(msg(loc) + ' set but does not contain "name" property string');
        }
        for (var _i3 = 0, _Object$keys3 = Object.keys(obj); _i3 < _Object$keys3.length; _i3++) {
          var prop2 = _Object$keys3[_i3];
          var propLoc = access(loc, prop2);
          var _value = obj[prop2];
          if (_value != null && typeof _value !== "boolean" && typeof _value !== "string" && typeof _value !== "number") {
            throw new Error(msg(propLoc) + " must be null, undefined, a boolean, a string, or a number.");
          }
        }
      }
      return value;
    }
    function assertInputSourceMap(loc, value) {
      if (value !== void 0 && typeof value !== "boolean" && (typeof value !== "object" || !value)) {
        throw new Error(msg(loc) + " must be a boolean, object, or undefined");
      }
      return value;
    }
    function assertString(loc, value) {
      if (value !== void 0 && typeof value !== "string") {
        throw new Error(msg(loc) + " must be a string, or undefined");
      }
      return value;
    }
    function assertFunction(loc, value) {
      if (value !== void 0 && typeof value !== "function") {
        throw new Error(msg(loc) + " must be a function, or undefined");
      }
      return value;
    }
    function assertBoolean(loc, value) {
      if (value !== void 0 && typeof value !== "boolean") {
        throw new Error(msg(loc) + " must be a boolean, or undefined");
      }
      return value;
    }
    function assertObject(loc, value) {
      if (value !== void 0 && (typeof value !== "object" || Array.isArray(value) || !value)) {
        throw new Error(msg(loc) + " must be an object, or undefined");
      }
      return value;
    }
    function assertArray(loc, value) {
      if (value != null && !Array.isArray(value)) {
        throw new Error(msg(loc) + " must be an array, or undefined");
      }
      return value;
    }
    function assertIgnoreList(loc, value) {
      var arr = assertArray(loc, value);
      if (arr) {
        arr.forEach(function(item, i2) {
          return assertIgnoreItem(access(loc, i2), item);
        });
      }
      return arr;
    }
    function assertIgnoreItem(loc, value) {
      if (typeof value !== "string" && typeof value !== "function" && !(value instanceof RegExp)) {
        throw new Error(msg(loc) + " must be an array of string/Function/RegExp values, or undefined");
      }
      return value;
    }
    function assertConfigApplicableTest(loc, value) {
      if (value === void 0)
        return value;
      if (Array.isArray(value)) {
        value.forEach(function(item, i2) {
          if (!checkValidTest(item)) {
            throw new Error(msg(access(loc, i2)) + " must be a string/Function/RegExp.");
          }
        });
      } else if (!checkValidTest(value)) {
        throw new Error(msg(loc) + " must be a string/Function/RegExp, or an array of those");
      }
      return value;
    }
    function checkValidTest(value) {
      return typeof value === "string" || typeof value === "function" || value instanceof RegExp;
    }
    function assertConfigFileSearch(loc, value) {
      if (value !== void 0 && typeof value !== "boolean" && typeof value !== "string") {
        throw new Error(msg(loc) + " must be a undefined, a boolean, a string, " + ("got " + JSON.stringify(value)));
      }
      return value;
    }
    function assertBabelrcSearch(loc, value) {
      if (value === void 0 || typeof value === "boolean")
        return value;
      if (Array.isArray(value)) {
        value.forEach(function(item, i2) {
          if (!checkValidTest(item)) {
            throw new Error(msg(access(loc, i2)) + " must be a string/Function/RegExp.");
          }
        });
      } else if (!checkValidTest(value)) {
        throw new Error(msg(loc) + " must be a undefined, a boolean, a string/Function/RegExp " + ("or an array of those, got " + JSON.stringify(value)));
      }
      return value;
    }
    function assertPluginList(loc, value) {
      var arr = assertArray(loc, value);
      if (arr) {
        arr.forEach(function(item, i2) {
          return assertPluginItem(access(loc, i2), item);
        });
      }
      return arr;
    }
    function assertPluginItem(loc, value) {
      if (Array.isArray(value)) {
        if (value.length === 0) {
          throw new Error(msg(loc) + " must include an object");
        }
        if (value.length > 3) {
          throw new Error(msg(loc) + " may only be a two-tuple or three-tuple");
        }
        assertPluginTarget(access(loc, 0), value[0]);
        if (value.length > 1) {
          var opts = value[1];
          if (opts !== void 0 && opts !== false && (typeof opts !== "object" || Array.isArray(opts) || opts === null)) {
            throw new Error(msg(access(loc, 1)) + " must be an object, false, or undefined");
          }
        }
        if (value.length === 3) {
          var _name = value[2];
          if (_name !== void 0 && typeof _name !== "string") {
            throw new Error(msg(access(loc, 2)) + " must be a string, or undefined");
          }
        }
      } else {
        assertPluginTarget(loc, value);
      }
      return value;
    }
    function assertPluginTarget(loc, value) {
      if ((typeof value !== "object" || !value) && typeof value !== "string" && typeof value !== "function") {
        throw new Error(msg(loc) + " must be a string, object, function");
      }
      return value;
    }
    function assertTargets(loc, value) {
      if (isBrowsersQueryValid(value))
        return value;
      if (typeof value !== "object" || !value || Array.isArray(value)) {
        throw new Error(msg(loc) + " must be a string, an array of strings or an object");
      }
      var browsersLoc = access(loc, "browsers");
      var esmodulesLoc = access(loc, "esmodules");
      assertBrowsersList(browsersLoc, value.browsers);
      assertBoolean(esmodulesLoc, value.esmodules);
      for (var _i22 = 0, _Object$keys22 = Object.keys(value); _i22 < _Object$keys22.length; _i22++) {
        var _key = _Object$keys22[_i22];
        var val = value[_key];
        var subLoc = access(loc, _key);
        if (_key === "esmodules")
          assertBoolean(subLoc, val);
        else if (_key === "browsers")
          assertBrowsersList(subLoc, val);
        else if (!Object.hasOwnProperty.call(TargetNames, _key)) {
          var validTargets = Object.keys(TargetNames).join(", ");
          throw new Error(msg(subLoc) + " is not a valid target. Supported targets are " + validTargets);
        } else
          assertBrowserVersion(subLoc, val);
      }
      return value;
    }
    function assertBrowsersList(loc, value) {
      if (value !== void 0 && !isBrowsersQueryValid(value)) {
        throw new Error(msg(loc) + " must be undefined, a string or an array of strings");
      }
    }
    function assertBrowserVersion(loc, value) {
      if (typeof value === "number" && Math.round(value) === value)
        return;
      if (typeof value === "string")
        return;
      throw new Error(msg(loc) + " must be a string or an integer number");
    }
    function assertAssumptions(loc, value) {
      if (value === void 0)
        return;
      if (typeof value !== "object" || value === null) {
        throw new Error(msg(loc) + " must be an object or undefined.");
      }
      var root2 = loc;
      do {
        root2 = root2.parent;
      } while (root2.type !== "root");
      var inPreset = root2.source === "preset";
      for (var _i3 = 0, _Object$keys3 = Object.keys(value); _i3 < _Object$keys3.length; _i3++) {
        var _name2 = _Object$keys3[_i3];
        var subLoc = access(loc, _name2);
        if (!assumptionsNames.has(_name2)) {
          throw new Error(msg(subLoc) + " is not a supported assumption.");
        }
        if (typeof value[_name2] !== "boolean") {
          throw new Error(msg(subLoc) + " must be a boolean.");
        }
        if (inPreset && value[_name2] === false) {
          throw new Error(msg(subLoc) + " cannot be set to 'false' inside presets.");
        }
      }
      return value;
    }
    var ROOT_VALIDATORS = {
      cwd: assertString,
      root: assertString,
      rootMode: assertRootMode,
      configFile: assertConfigFileSearch,
      caller: assertCallerMetadata,
      filename: assertString,
      filenameRelative: assertString,
      code: assertBoolean,
      ast: assertBoolean,
      cloneInputAst: assertBoolean,
      envName: assertString
    };
    var BABELRC_VALIDATORS = {
      babelrc: assertBoolean,
      babelrcRoots: assertBabelrcSearch
    };
    var NONPRESET_VALIDATORS = {
      "extends": assertString,
      ignore: assertIgnoreList,
      only: assertIgnoreList,
      targets: assertTargets,
      browserslistConfigFile: assertConfigFileSearch,
      browserslistEnv: assertString
    };
    var COMMON_VALIDATORS = {
      inputSourceMap: assertInputSourceMap,
      presets: assertPluginList,
      plugins: assertPluginList,
      passPerPreset: assertBoolean,
      assumptions: assertAssumptions,
      env: assertEnvSet,
      overrides: assertOverridesList,
      test: assertConfigApplicableTest,
      include: assertConfigApplicableTest,
      exclude: assertConfigApplicableTest,
      retainLines: assertBoolean,
      comments: assertBoolean,
      shouldPrintComment: assertFunction,
      compact: assertCompact,
      minified: assertBoolean,
      auxiliaryCommentBefore: assertString,
      auxiliaryCommentAfter: assertString,
      sourceType: assertSourceType,
      wrapPluginVisitorMethod: assertFunction,
      highlightCode: assertBoolean,
      sourceMaps: assertSourceMaps,
      sourceMap: assertSourceMaps,
      sourceFileName: assertString,
      sourceRoot: assertString,
      parserOpts: assertObject,
      generatorOpts: assertObject
    };
    {
      Object.assign(COMMON_VALIDATORS, {
        getModuleId: assertFunction,
        moduleRoot: assertString,
        moduleIds: assertBoolean,
        moduleId: assertString
      });
    }
    var assumptionsNames = /* @__PURE__ */ new Set(["arrayLikeIsIterable", "constantReexports", "constantSuper", "enumerableModuleMeta", "ignoreFunctionLength", "ignoreToPrimitiveHint", "iterableIsArray", "mutableTemplateObject", "noClassCalls", "noDocumentAll", "noIncompleteNsImportDetection", "noNewArrows", "objectRestNoSymbols", "privateFieldsAsProperties", "pureGetters", "setClassMethods", "setComputedProperties", "setPublicClassFields", "setSpreadProperties", "skipForOfIteratorClosing", "superIsCallableConstructor"]);
    function getSource(loc) {
      return loc.type === "root" ? loc.source : getSource(loc.parent);
    }
    function validate(type5, opts) {
      return validateNested({
        type: "root",
        source: type5
      }, opts);
    }
    function validateNested(loc, opts) {
      var type5 = getSource(loc);
      assertNoDuplicateSourcemap(opts);
      Object.keys(opts).forEach(function(key2) {
        var optLoc = {
          type: "option",
          name: key2,
          parent: loc
        };
        if (type5 === "preset" && NONPRESET_VALIDATORS[key2]) {
          throw new Error(msg(optLoc) + " is not allowed in preset options");
        }
        if (type5 !== "arguments" && ROOT_VALIDATORS[key2]) {
          throw new Error(msg(optLoc) + " is only allowed in root programmatic options");
        }
        if (type5 !== "arguments" && type5 !== "configfile" && BABELRC_VALIDATORS[key2]) {
          if (type5 === "babelrcfile" || type5 === "extendsfile") {
            throw new Error(msg(optLoc) + ' is not allowed in .babelrc or "extends"ed files, only in root programmatic options, or babel.config.js/config file options');
          }
          throw new Error(msg(optLoc) + " is only allowed in root programmatic options, or babel.config.js/config file options");
        }
        var validator = COMMON_VALIDATORS[key2] || NONPRESET_VALIDATORS[key2] || BABELRC_VALIDATORS[key2] || ROOT_VALIDATORS[key2] || throwUnknownError;
        validator(optLoc, opts[key2]);
      });
      return opts;
    }
    function throwUnknownError(loc) {
      var key2 = loc.name;
      if (removed[key2]) {
        var _removed$key = removed[key2], message = _removed$key.message, _removed$key$version = _removed$key.version, version3 = _removed$key$version === void 0 ? 5 : _removed$key$version;
        throw new Error("Using removed Babel " + version3 + " option: " + msg(loc) + " - " + message);
      } else {
        var unknownOptErr = new Error("Unknown option: " + msg(loc) + ". Check out https://babeljs.io/docs/en/babel-core/#options for more information about options.");
        unknownOptErr.code = "BABEL_UNKNOWN_OPTION";
        throw unknownOptErr;
      }
    }
    function has$9(obj, key2) {
      return Object.prototype.hasOwnProperty.call(obj, key2);
    }
    function assertNoDuplicateSourcemap(opts) {
      if (has$9(opts, "sourceMap") && has$9(opts, "sourceMaps")) {
        throw new Error(".sourceMap is an alias for .sourceMaps, cannot use both");
      }
    }
    function assertEnvSet(loc, value) {
      if (loc.parent.type === "env") {
        throw new Error(msg(loc) + " is not allowed inside of another .env block");
      }
      var parent = loc.parent;
      var obj = assertObject(loc, value);
      if (obj) {
        for (var _i3 = 0, _Object$keys3 = Object.keys(obj); _i3 < _Object$keys3.length; _i3++) {
          var envName = _Object$keys3[_i3];
          var env3 = assertObject(access(loc, envName), obj[envName]);
          if (!env3)
            continue;
          var envLoc = {
            type: "env",
            name: envName,
            parent
          };
          validateNested(envLoc, env3);
        }
      }
      return obj;
    }
    function assertOverridesList(loc, value) {
      if (loc.parent.type === "env") {
        throw new Error(msg(loc) + " is not allowed inside an .env block");
      }
      if (loc.parent.type === "overrides") {
        throw new Error(msg(loc) + " is not allowed inside an .overrides block");
      }
      var parent = loc.parent;
      var arr = assertArray(loc, value);
      if (arr) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(arr.entries()), _step2; !(_step2 = _iterator2()).done; ) {
          var _step$value = _slicedToArray$12(_step2.value, 2), index3 = _step$value[0], item = _step$value[1];
          var objLoc = access(loc, index3);
          var env3 = assertObject(objLoc, item);
          if (!env3)
            throw new Error(msg(objLoc) + " must be an object");
          var overridesLoc = {
            type: "overrides",
            index: index3,
            parent
          };
          validateNested(overridesLoc, env3);
        }
      }
      return arr;
    }
    function checkNoUnwrappedItemOptionPairs(items, index3, type5, e2) {
      if (index3 === 0)
        return;
      var lastItem = items[index3 - 1];
      var thisItem = items[index3];
      if (lastItem.file && lastItem.options === void 0 && typeof thisItem.value === "object") {
        e2.message += "\n- Maybe you meant to use\n" + ('"' + type5 + 's": [\n  ["' + lastItem.file.request + '", ' + JSON.stringify(thisItem.value, void 0, 2) + "]\n]\n") + ("To be a valid " + type5 + ", its name and options should be wrapped in a pair of brackets");
      }
    }
    var sep = "\\" + path$1.sep;
    var endSep = "(?:" + sep + "|$)";
    var substitution = "[^" + sep + "]+";
    var starPat = "(?:" + substitution + sep + ")";
    var starPatLast = "(?:" + substitution + endSep + ")";
    var starStarPat = starPat + "*?";
    var starStarPatLast = starPat + "*?" + starPatLast + "?";
    function escapeRegExp(string3) {
      return string3.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&");
    }
    function pathToPattern(pattern5, dirname2) {
      var parts = path$1.resolve(dirname2, pattern5).split(path$1.sep);
      return new RegExp(["^"].concat(_toConsumableArray2(parts.map(function(part, i2) {
        var last2 = i2 === parts.length - 1;
        if (part === "**")
          return last2 ? starStarPatLast : starStarPat;
        if (part === "*")
          return last2 ? starPatLast : starPat;
        if (part.indexOf("*.") === 0) {
          return substitution + escapeRegExp(part.slice(1)) + (last2 ? endSep : sep);
        }
        return escapeRegExp(part) + (last2 ? endSep : sep);
      }))).join(""));
    }
    var ChainFormatter = {
      Programmatic: 0,
      Config: 1
    };
    var Formatter = {
      title: function title2(type5, callerName, filepath) {
        var title3 = "";
        if (type5 === ChainFormatter.Programmatic) {
          title3 = "programmatic options";
          if (callerName) {
            title3 += " from " + callerName;
          }
        } else {
          title3 = "config " + filepath;
        }
        return title3;
      },
      loc: function loc(index3, envName) {
        var loc2 = "";
        if (index3 != null) {
          loc2 += ".overrides[" + index3 + "]";
        }
        if (envName != null) {
          loc2 += '.env["' + envName + '"]';
        }
        return loc2;
      },
      optionsAndDescriptors: regenerator2.mark(function optionsAndDescriptors(opt) {
        var content, pluginDescriptors, presetDescriptors;
        return regenerator2.wrap(function optionsAndDescriptors$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                content = Object.assign({}, opt.options);
                delete content.overrides;
                delete content.env;
                _context.t0 = _toConsumableArray2;
                return _context.delegateYield(opt.plugins(), "t1", 5);
              case 5:
                _context.t2 = _context.t1;
                pluginDescriptors = (0, _context.t0)(_context.t2);
                if (pluginDescriptors.length) {
                  content.plugins = pluginDescriptors.map(function(d2) {
                    return descriptorToConfig(d2);
                  });
                }
                _context.t3 = _toConsumableArray2;
                return _context.delegateYield(opt.presets(), "t4", 10);
              case 10:
                _context.t5 = _context.t4;
                presetDescriptors = (0, _context.t3)(_context.t5);
                if (presetDescriptors.length) {
                  content.presets = _toConsumableArray2(presetDescriptors).map(function(d2) {
                    return descriptorToConfig(d2);
                  });
                }
                return _context.abrupt("return", JSON.stringify(content, void 0, 2));
              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, optionsAndDescriptors);
      })
    };
    function descriptorToConfig(d2) {
      var _d$file;
      var name2 = (_d$file = d2.file) == null ? void 0 : _d$file.request;
      if (name2 == null) {
        if (typeof d2.value === "object") {
          name2 = d2.value;
        } else if (typeof d2.value === "function") {
          name2 = "[Function: " + d2.value.toString().slice(0, 50) + " ... ]";
        }
      }
      if (name2 == null) {
        name2 = "[Unknown]";
      }
      if (d2.options === void 0) {
        return name2;
      } else if (d2.name == null) {
        return [name2, d2.options];
      } else {
        return [name2, d2.options, d2.name];
      }
    }
    var ConfigPrinter = function() {
      function ConfigPrinter2() {
        this._stack = [];
      }
      var _proto = ConfigPrinter2.prototype;
      _proto.configure = function configure(enabled, type5, _ref3) {
        var _this = this;
        var callerName = _ref3.callerName, filepath = _ref3.filepath;
        if (!enabled)
          return function() {
          };
        return function(content, index3, envName) {
          _this._stack.push({
            type: type5,
            callerName,
            filepath,
            content,
            index: index3,
            envName
          });
        };
      };
      ConfigPrinter2.format = regenerator2.mark(function format2(config3) {
        var title2, loc, content;
        return regenerator2.wrap(function format$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                title2 = Formatter.title(config3.type, config3.callerName, config3.filepath);
                loc = Formatter.loc(config3.index, config3.envName);
                if (loc)
                  title2 += " " + loc;
                return _context2.delegateYield(Formatter.optionsAndDescriptors(config3.content), "t0", 4);
              case 4:
                content = _context2.t0;
                return _context2.abrupt("return", title2 + "\n" + content);
              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, format2);
      });
      _proto.output = regenerator2.mark(function output() {
        var configs;
        return regenerator2.wrap(function output$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(this._stack.length === 0)) {
                  _context3.next = 2;
                  break;
                }
                return _context3.abrupt("return", "");
              case 2:
                return _context3.delegateYield(gensync.all(this._stack.map(function(s) {
                  return ConfigPrinter2.format(s);
                })), "t0", 3);
              case 3:
                configs = _context3.t0;
                return _context3.abrupt("return", configs.join("\n\n"));
              case 5:
              case "end":
                return _context3.stop();
            }
          }
        }, output, this);
      });
      return _createClass2(ConfigPrinter2);
    }();
    var _marked$5 = regenerator2.mark(buildPresetChain), _marked2$2 = regenerator2.mark(buildRootChain), _marked3 = regenerator2.mark(loadFileChain), _marked4 = regenerator2.mark(mergeExtendsChain), _marked5 = regenerator2.mark(mergeChainOpts);
    var debug$3 = buildDebug("babel:config:config-chain");
    function buildPresetChain(arg, context) {
      var chain2;
      return regenerator2.wrap(function buildPresetChain$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(buildPresetChainWalker(arg, context), "t0", 1);
            case 1:
              chain2 = _context.t0;
              if (chain2) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", null);
            case 4:
              return _context.abrupt("return", {
                plugins: dedupDescriptors(chain2.plugins),
                presets: dedupDescriptors(chain2.presets),
                options: chain2.options.map(function(o) {
                  return normalizeOptions$5(o);
                }),
                files: /* @__PURE__ */ new Set()
              });
            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$5);
    }
    var buildPresetChainWalker = makeChainWalker({
      root: function root2(preset) {
        return loadPresetDescriptors(preset);
      },
      env: function env3(preset, envName) {
        return loadPresetEnvDescriptors(preset)(envName);
      },
      overrides: function overrides(preset, index3) {
        return loadPresetOverridesDescriptors(preset)(index3);
      },
      overridesEnv: function overridesEnv(preset, index3, envName) {
        return loadPresetOverridesEnvDescriptors(preset)(index3)(envName);
      },
      createLogger: function createLogger() {
        return function() {
        };
      }
    });
    var loadPresetDescriptors = makeWeakCacheSync(function(preset) {
      return buildRootDescriptors(preset, preset.alias, createUncachedDescriptors);
    });
    var loadPresetEnvDescriptors = makeWeakCacheSync(function(preset) {
      return makeStrongCacheSync(function(envName) {
        return buildEnvDescriptors(preset, preset.alias, createUncachedDescriptors, envName);
      });
    });
    var loadPresetOverridesDescriptors = makeWeakCacheSync(function(preset) {
      return makeStrongCacheSync(function(index3) {
        return buildOverrideDescriptors(preset, preset.alias, createUncachedDescriptors, index3);
      });
    });
    var loadPresetOverridesEnvDescriptors = makeWeakCacheSync(function(preset) {
      return makeStrongCacheSync(function(index3) {
        return makeStrongCacheSync(function(envName) {
          return buildOverrideEnvDescriptors(preset, preset.alias, createUncachedDescriptors, index3, envName);
        });
      });
    });
    function buildRootChain(opts, context) {
      var configReport, babelRcReport, programmaticLogger, programmaticChain, programmaticReport, configFile, babelrc, babelrcRoots, babelrcRootsDirectory, configFileChain, configFileLogger, validatedFile, result, ignoreFile, babelrcFile, isIgnored, fileChain, pkgData, _yield$findRelativeCo, _validatedFile, babelrcLogger, _result, chain2;
      return regenerator2.wrap(function buildRootChain$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              programmaticLogger = new ConfigPrinter();
              return _context2.delegateYield(loadProgrammaticChain({
                options: opts,
                dirname: context.cwd
              }, context, void 0, programmaticLogger), "t0", 2);
            case 2:
              programmaticChain = _context2.t0;
              if (programmaticChain) {
                _context2.next = 5;
                break;
              }
              return _context2.abrupt("return", null);
            case 5:
              return _context2.delegateYield(programmaticLogger.output(), "t1", 6);
            case 6:
              programmaticReport = _context2.t1;
              if (!(typeof opts.configFile === "string")) {
                _context2.next = 12;
                break;
              }
              return _context2.delegateYield(loadConfig$1(opts.configFile, context.cwd, context.envName, context.caller), "t2", 9);
            case 9:
              configFile = _context2.t2;
              _context2.next = 15;
              break;
            case 12:
              if (!(opts.configFile !== false)) {
                _context2.next = 15;
                break;
              }
              return _context2.delegateYield(findRootConfig(context.root, context.envName, context.caller), "t3", 14);
            case 14:
              configFile = _context2.t3;
            case 15:
              babelrc = opts.babelrc, babelrcRoots = opts.babelrcRoots;
              babelrcRootsDirectory = context.cwd;
              configFileChain = emptyChain();
              configFileLogger = new ConfigPrinter();
              if (!configFile) {
                _context2.next = 30;
                break;
              }
              validatedFile = validateConfigFile(configFile);
              return _context2.delegateYield(loadFileChain(validatedFile, context, void 0, configFileLogger), "t4", 22);
            case 22:
              result = _context2.t4;
              if (result) {
                _context2.next = 25;
                break;
              }
              return _context2.abrupt("return", null);
            case 25:
              return _context2.delegateYield(configFileLogger.output(), "t5", 26);
            case 26:
              configReport = _context2.t5;
              if (babelrc === void 0) {
                babelrc = validatedFile.options.babelrc;
              }
              if (babelrcRoots === void 0) {
                babelrcRootsDirectory = validatedFile.dirname;
                babelrcRoots = validatedFile.options.babelrcRoots;
              }
              mergeChain(configFileChain, result);
            case 30:
              isIgnored = false;
              fileChain = emptyChain();
              if (!((babelrc === true || babelrc === void 0) && typeof context.filename === "string")) {
                _context2.next = 55;
                break;
              }
              return _context2.delegateYield(findPackageData(context.filename), "t6", 34);
            case 34:
              pkgData = _context2.t6;
              if (!(pkgData && babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory))) {
                _context2.next = 55;
                break;
              }
              return _context2.delegateYield(findRelativeConfig(pkgData, context.envName, context.caller), "t7", 37);
            case 37:
              _yield$findRelativeCo = _context2.t7;
              ignoreFile = _yield$findRelativeCo.ignore;
              babelrcFile = _yield$findRelativeCo.config;
              if (ignoreFile) {
                fileChain.files.add(ignoreFile.filepath);
              }
              if (ignoreFile && shouldIgnore(context, ignoreFile.ignore, null, ignoreFile.dirname)) {
                isIgnored = true;
              }
              if (!(babelrcFile && !isIgnored)) {
                _context2.next = 54;
                break;
              }
              _validatedFile = validateBabelrcFile(babelrcFile);
              babelrcLogger = new ConfigPrinter();
              return _context2.delegateYield(loadFileChain(_validatedFile, context, void 0, babelrcLogger), "t8", 46);
            case 46:
              _result = _context2.t8;
              if (_result) {
                _context2.next = 51;
                break;
              }
              isIgnored = true;
              _context2.next = 54;
              break;
            case 51:
              return _context2.delegateYield(babelrcLogger.output(), "t9", 52);
            case 52:
              babelRcReport = _context2.t9;
              mergeChain(fileChain, _result);
            case 54:
              if (babelrcFile && isIgnored) {
                fileChain.files.add(babelrcFile.filepath);
              }
            case 55:
              if (context.showConfig) {
                console.log('Babel configs on "' + context.filename + '" (ascending priority):\n' + [configReport, babelRcReport, programmaticReport].filter(function(x2) {
                  return !!x2;
                }).join("\n\n") + "\n-----End Babel configs-----");
              }
              chain2 = mergeChain(mergeChain(mergeChain(emptyChain(), configFileChain), fileChain), programmaticChain);
              return _context2.abrupt("return", {
                plugins: isIgnored ? [] : dedupDescriptors(chain2.plugins),
                presets: isIgnored ? [] : dedupDescriptors(chain2.presets),
                options: isIgnored ? [] : chain2.options.map(function(o) {
                  return normalizeOptions$5(o);
                }),
                fileHandling: isIgnored ? "ignored" : "transpile",
                ignore: ignoreFile || void 0,
                babelrc: babelrcFile || void 0,
                config: configFile || void 0,
                files: chain2.files
              });
            case 58:
            case "end":
              return _context2.stop();
          }
        }
      }, _marked2$2);
    }
    function babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory) {
      if (typeof babelrcRoots === "boolean")
        return babelrcRoots;
      var absoluteRoot = context.root;
      if (babelrcRoots === void 0) {
        return pkgData.directories.indexOf(absoluteRoot) !== -1;
      }
      var babelrcPatterns = babelrcRoots;
      if (!Array.isArray(babelrcPatterns)) {
        babelrcPatterns = [babelrcPatterns];
      }
      babelrcPatterns = babelrcPatterns.map(function(pat) {
        return typeof pat === "string" ? path$1.resolve(babelrcRootsDirectory, pat) : pat;
      });
      if (babelrcPatterns.length === 1 && babelrcPatterns[0] === absoluteRoot) {
        return pkgData.directories.indexOf(absoluteRoot) !== -1;
      }
      return babelrcPatterns.some(function(pat) {
        if (typeof pat === "string") {
          pat = pathToPattern(pat, babelrcRootsDirectory);
        }
        return pkgData.directories.some(function(directory) {
          return matchPattern(pat, babelrcRootsDirectory, directory, context);
        });
      });
    }
    var validateConfigFile = makeWeakCacheSync(function(file2) {
      return {
        filepath: file2.filepath,
        dirname: file2.dirname,
        options: validate("configfile", file2.options)
      };
    });
    var validateBabelrcFile = makeWeakCacheSync(function(file2) {
      return {
        filepath: file2.filepath,
        dirname: file2.dirname,
        options: validate("babelrcfile", file2.options)
      };
    });
    var validateExtendFile = makeWeakCacheSync(function(file2) {
      return {
        filepath: file2.filepath,
        dirname: file2.dirname,
        options: validate("extendsfile", file2.options)
      };
    });
    var loadProgrammaticChain = makeChainWalker({
      root: function root2(input) {
        return buildRootDescriptors(input, "base", createCachedDescriptors);
      },
      env: function env3(input, envName) {
        return buildEnvDescriptors(input, "base", createCachedDescriptors, envName);
      },
      overrides: function overrides(input, index3) {
        return buildOverrideDescriptors(input, "base", createCachedDescriptors, index3);
      },
      overridesEnv: function overridesEnv(input, index3, envName) {
        return buildOverrideEnvDescriptors(input, "base", createCachedDescriptors, index3, envName);
      },
      createLogger: function createLogger(input, context, baseLogger) {
        return buildProgrammaticLogger(input, context, baseLogger);
      }
    });
    var loadFileChainWalker = makeChainWalker({
      root: function root2(file2) {
        return loadFileDescriptors(file2);
      },
      env: function env3(file2, envName) {
        return loadFileEnvDescriptors(file2)(envName);
      },
      overrides: function overrides(file2, index3) {
        return loadFileOverridesDescriptors(file2)(index3);
      },
      overridesEnv: function overridesEnv(file2, index3, envName) {
        return loadFileOverridesEnvDescriptors(file2)(index3)(envName);
      },
      createLogger: function createLogger(file2, context, baseLogger) {
        return buildFileLogger(file2.filepath, context, baseLogger);
      }
    });
    function loadFileChain(input, context, files2, baseLogger) {
      var chain2;
      return regenerator2.wrap(function loadFileChain$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.delegateYield(loadFileChainWalker(input, context, files2, baseLogger), "t0", 1);
            case 1:
              chain2 = _context3.t0;
              if (chain2) {
                chain2.files.add(input.filepath);
              }
              return _context3.abrupt("return", chain2);
            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _marked3);
    }
    var loadFileDescriptors = makeWeakCacheSync(function(file2) {
      return buildRootDescriptors(file2, file2.filepath, createUncachedDescriptors);
    });
    var loadFileEnvDescriptors = makeWeakCacheSync(function(file2) {
      return makeStrongCacheSync(function(envName) {
        return buildEnvDescriptors(file2, file2.filepath, createUncachedDescriptors, envName);
      });
    });
    var loadFileOverridesDescriptors = makeWeakCacheSync(function(file2) {
      return makeStrongCacheSync(function(index3) {
        return buildOverrideDescriptors(file2, file2.filepath, createUncachedDescriptors, index3);
      });
    });
    var loadFileOverridesEnvDescriptors = makeWeakCacheSync(function(file2) {
      return makeStrongCacheSync(function(index3) {
        return makeStrongCacheSync(function(envName) {
          return buildOverrideEnvDescriptors(file2, file2.filepath, createUncachedDescriptors, index3, envName);
        });
      });
    });
    function buildFileLogger(filepath, context, baseLogger) {
      if (!baseLogger) {
        return function() {
        };
      }
      return baseLogger.configure(context.showConfig, ChainFormatter.Config, {
        filepath
      });
    }
    function buildRootDescriptors(_ref3, alias2, descriptors) {
      var dirname2 = _ref3.dirname, options = _ref3.options;
      return descriptors(dirname2, options, alias2);
    }
    function buildProgrammaticLogger(_, context, baseLogger) {
      var _context$caller;
      if (!baseLogger) {
        return function() {
        };
      }
      return baseLogger.configure(context.showConfig, ChainFormatter.Programmatic, {
        callerName: (_context$caller = context.caller) == null ? void 0 : _context$caller.name
      });
    }
    function buildEnvDescriptors(_ref22, alias2, descriptors, envName) {
      var dirname2 = _ref22.dirname, options = _ref22.options;
      var opts = options.env && options.env[envName];
      return opts ? descriptors(dirname2, opts, alias2 + '.env["' + envName + '"]') : null;
    }
    function buildOverrideDescriptors(_ref3, alias2, descriptors, index3) {
      var dirname2 = _ref3.dirname, options = _ref3.options;
      var opts = options.overrides && options.overrides[index3];
      if (!opts)
        throw new Error("Assertion failure - missing override");
      return descriptors(dirname2, opts, alias2 + ".overrides[" + index3 + "]");
    }
    function buildOverrideEnvDescriptors(_ref42, alias2, descriptors, index3, envName) {
      var dirname2 = _ref42.dirname, options = _ref42.options;
      var override = options.overrides && options.overrides[index3];
      if (!override)
        throw new Error("Assertion failure - missing override");
      var opts = override.env && override.env[envName];
      return opts ? descriptors(dirname2, opts, alias2 + ".overrides[" + index3 + '].env["' + envName + '"]') : null;
    }
    function makeChainWalker(_ref5) {
      var root2 = _ref5.root, env3 = _ref5.env, overrides = _ref5.overrides, overridesEnv = _ref5.overridesEnv, createLogger = _ref5.createLogger;
      return regenerator2.mark(function _callee(input, context, files2, baseLogger) {
        var dirname2, flattenedConfigs, rootOpts, envOpts, chain2, logger, _i3, _flattenedConfigs, _flattenedConfigs$_i, config3, _index, envName;
        return regenerator2.wrap(function _callee$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (files2 === void 0) {
                  files2 = /* @__PURE__ */ new Set();
                }
                dirname2 = input.dirname;
                flattenedConfigs = [];
                rootOpts = root2(input);
                if (configIsApplicable(rootOpts, dirname2, context)) {
                  flattenedConfigs.push({
                    config: rootOpts,
                    envName: void 0,
                    index: void 0
                  });
                  envOpts = env3(input, context.envName);
                  if (envOpts && configIsApplicable(envOpts, dirname2, context)) {
                    flattenedConfigs.push({
                      config: envOpts,
                      envName: context.envName,
                      index: void 0
                    });
                  }
                  (rootOpts.options.overrides || []).forEach(function(_, index3) {
                    var overrideOps = overrides(input, index3);
                    if (configIsApplicable(overrideOps, dirname2, context)) {
                      flattenedConfigs.push({
                        config: overrideOps,
                        index: index3,
                        envName: void 0
                      });
                      var overrideEnvOpts = overridesEnv(input, index3, context.envName);
                      if (overrideEnvOpts && configIsApplicable(overrideEnvOpts, dirname2, context)) {
                        flattenedConfigs.push({
                          config: overrideEnvOpts,
                          index: index3,
                          envName: context.envName
                        });
                      }
                    }
                  });
                }
                if (!flattenedConfigs.some(function(_ref6) {
                  var _ref6$config$options = _ref6.config.options, ignore = _ref6$config$options.ignore, only = _ref6$config$options.only;
                  return shouldIgnore(context, ignore, only, dirname2);
                })) {
                  _context4.next = 7;
                  break;
                }
                return _context4.abrupt("return", null);
              case 7:
                chain2 = emptyChain();
                logger = createLogger(input, context, baseLogger);
                _i3 = 0, _flattenedConfigs = flattenedConfigs;
              case 10:
                if (!(_i3 < _flattenedConfigs.length)) {
                  _context4.next = 20;
                  break;
                }
                _flattenedConfigs$_i = _flattenedConfigs[_i3], config3 = _flattenedConfigs$_i.config, _index = _flattenedConfigs$_i.index, envName = _flattenedConfigs$_i.envName;
                return _context4.delegateYield(mergeExtendsChain(chain2, config3.options, dirname2, context, files2, baseLogger), "t0", 13);
              case 13:
                if (_context4.t0) {
                  _context4.next = 15;
                  break;
                }
                return _context4.abrupt("return", null);
              case 15:
                logger(config3, _index, envName);
                return _context4.delegateYield(mergeChainOpts(chain2, config3), "t1", 17);
              case 17:
                _i3++;
                _context4.next = 10;
                break;
              case 20:
                return _context4.abrupt("return", chain2);
              case 21:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee);
      });
    }
    function mergeExtendsChain(chain2, opts, dirname2, context, files2, baseLogger) {
      var file2, fileChain;
      return regenerator2.wrap(function mergeExtendsChain$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (!(opts["extends"] === void 0)) {
                _context5.next = 2;
                break;
              }
              return _context5.abrupt("return", true);
            case 2:
              return _context5.delegateYield(loadConfig$1(opts["extends"], dirname2, context.envName, context.caller), "t0", 3);
            case 3:
              file2 = _context5.t0;
              if (!files2.has(file2)) {
                _context5.next = 6;
                break;
              }
              throw new Error("Configuration cycle detected loading " + file2.filepath + ".\nFile already loaded following the config chain:\n" + Array.from(files2, function(file3) {
                return " - " + file3.filepath;
              }).join("\n"));
            case 6:
              files2.add(file2);
              return _context5.delegateYield(loadFileChain(validateExtendFile(file2), context, files2, baseLogger), "t1", 8);
            case 8:
              fileChain = _context5.t1;
              files2["delete"](file2);
              if (fileChain) {
                _context5.next = 12;
                break;
              }
              return _context5.abrupt("return", false);
            case 12:
              mergeChain(chain2, fileChain);
              return _context5.abrupt("return", true);
            case 14:
            case "end":
              return _context5.stop();
          }
        }
      }, _marked4);
    }
    function mergeChain(target, source) {
      var _target$options, _target$plugins, _target$presets;
      (_target$options = target.options).push.apply(_target$options, _toConsumableArray2(source.options));
      (_target$plugins = target.plugins).push.apply(_target$plugins, _toConsumableArray2(source.plugins));
      (_target$presets = target.presets).push.apply(_target$presets, _toConsumableArray2(source.presets));
      for (var _iterator2 = _createForOfIteratorHelperLoose(source.files), _step2; !(_step2 = _iterator2()).done; ) {
        var file2 = _step2.value;
        target.files.add(file2);
      }
      return target;
    }
    function mergeChainOpts(target, _ref7) {
      var _target$plugins2, _target$presets2;
      var options, plugins2, presets;
      return regenerator2.wrap(function mergeChainOpts$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              options = _ref7.options, plugins2 = _ref7.plugins, presets = _ref7.presets;
              target.options.push(options);
              _context6.t0 = (_target$plugins2 = target.plugins).push;
              _context6.t1 = _target$plugins2;
              _context6.t2 = _toConsumableArray2;
              return _context6.delegateYield(plugins2(), "t3", 6);
            case 6:
              _context6.t4 = _context6.t3;
              _context6.t5 = (0, _context6.t2)(_context6.t4);
              _context6.t0.apply.call(_context6.t0, _context6.t1, _context6.t5);
              _context6.t6 = (_target$presets2 = target.presets).push;
              _context6.t7 = _target$presets2;
              _context6.t8 = _toConsumableArray2;
              return _context6.delegateYield(presets(), "t9", 13);
            case 13:
              _context6.t10 = _context6.t9;
              _context6.t11 = (0, _context6.t8)(_context6.t10);
              _context6.t6.apply.call(_context6.t6, _context6.t7, _context6.t11);
              return _context6.abrupt("return", target);
            case 17:
            case "end":
              return _context6.stop();
          }
        }
      }, _marked5);
    }
    function emptyChain() {
      return {
        options: [],
        presets: [],
        plugins: [],
        files: /* @__PURE__ */ new Set()
      };
    }
    function normalizeOptions$5(opts) {
      var options = Object.assign({}, opts);
      delete options["extends"];
      delete options.env;
      delete options.overrides;
      delete options.plugins;
      delete options.presets;
      delete options.passPerPreset;
      delete options.ignore;
      delete options.only;
      delete options.test;
      delete options.include;
      delete options.exclude;
      if (Object.prototype.hasOwnProperty.call(options, "sourceMap")) {
        options.sourceMaps = options.sourceMap;
        delete options.sourceMap;
      }
      return options;
    }
    function dedupDescriptors(items) {
      var map2 = /* @__PURE__ */ new Map();
      var descriptors = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(items), _step2; !(_step2 = _iterator2()).done; ) {
        var item = _step2.value;
        if (typeof item.value === "function") {
          var fnKey = item.value;
          var nameMap = map2.get(fnKey);
          if (!nameMap) {
            nameMap = /* @__PURE__ */ new Map();
            map2.set(fnKey, nameMap);
          }
          var desc = nameMap.get(item.name);
          if (!desc) {
            desc = {
              value: item
            };
            descriptors.push(desc);
            if (!item.ownPass)
              nameMap.set(item.name, desc);
          } else {
            desc.value = item;
          }
        } else {
          descriptors.push({
            value: item
          });
        }
      }
      return descriptors.reduce(function(acc, desc2) {
        acc.push(desc2.value);
        return acc;
      }, []);
    }
    function configIsApplicable(_ref8, dirname2, context) {
      var options = _ref8.options;
      return (options.test === void 0 || configFieldIsApplicable(context, options.test, dirname2)) && (options.include === void 0 || configFieldIsApplicable(context, options.include, dirname2)) && (options.exclude === void 0 || !configFieldIsApplicable(context, options.exclude, dirname2));
    }
    function configFieldIsApplicable(context, test, dirname2) {
      var patterns = Array.isArray(test) ? test : [test];
      return matchesPatterns(context, patterns, dirname2);
    }
    function ignoreListReplacer(_key, value) {
      if (value instanceof RegExp) {
        return String(value);
      }
      return value;
    }
    function shouldIgnore(context, ignore, only, dirname2) {
      if (ignore && matchesPatterns(context, ignore, dirname2)) {
        var _context$filename;
        var message = 'No config is applied to "' + ((_context$filename = context.filename) != null ? _context$filename : "(unknown)") + '" because it matches one of `ignore: ' + JSON.stringify(ignore, ignoreListReplacer) + '` from "' + dirname2 + '"';
        debug$3(message);
        if (context.showConfig) {
          console.log(message);
        }
        return true;
      }
      if (only && !matchesPatterns(context, only, dirname2)) {
        var _context$filename2;
        var _message = 'No config is applied to "' + ((_context$filename2 = context.filename) != null ? _context$filename2 : "(unknown)") + '" because it fails to match one of `only: ' + JSON.stringify(only, ignoreListReplacer) + '` from "' + dirname2 + '"';
        debug$3(_message);
        if (context.showConfig) {
          console.log(_message);
        }
        return true;
      }
      return false;
    }
    function matchesPatterns(context, patterns, dirname2) {
      return patterns.some(function(pattern5) {
        return matchPattern(pattern5, dirname2, context.filename, context);
      });
    }
    function matchPattern(pattern5, dirname2, pathToTest, context) {
      if (typeof pattern5 === "function") {
        return !!pattern5(pathToTest, {
          dirname: dirname2,
          envName: context.envName,
          caller: context.caller
        });
      }
      if (typeof pathToTest !== "string") {
        throw new Error("Configuration contains string/RegExp pattern, but no filename was passed to Babel");
      }
      if (typeof pattern5 === "string") {
        pattern5 = pathToPattern(pattern5, dirname2);
      }
      return pattern5.test(pathToTest);
    }
    var VALIDATORS = {
      name: assertString,
      manipulateOptions: assertFunction,
      pre: assertFunction,
      post: assertFunction,
      inherits: assertFunction,
      visitor: assertVisitorMap,
      parserOverride: assertFunction,
      generatorOverride: assertFunction
    };
    function assertVisitorMap(loc, value) {
      var obj = assertObject(loc, value);
      if (obj) {
        Object.keys(obj).forEach(function(prop2) {
          return assertVisitorHandler(prop2, obj[prop2]);
        });
        if (obj.enter || obj.exit) {
          throw new Error(msg(loc) + ' cannot contain catch-all "enter" or "exit" handlers. Please target individual nodes.');
        }
      }
      return obj;
    }
    function assertVisitorHandler(key2, value) {
      if (value && typeof value === "object") {
        Object.keys(value).forEach(function(handler) {
          if (handler !== "enter" && handler !== "exit") {
            throw new Error('.visitor["' + key2 + '"] may only have .enter and/or .exit handlers.');
          }
        });
      } else if (typeof value !== "function") {
        throw new Error('.visitor["' + key2 + '"] must be a function');
      }
      return value;
    }
    function validatePluginObject(obj) {
      var rootPath = {
        type: "root",
        source: "plugin"
      };
      Object.keys(obj).forEach(function(key2) {
        var validator = VALIDATORS[key2];
        if (validator) {
          var optLoc = {
            type: "option",
            name: key2,
            parent: rootPath
          };
          validator(optLoc, obj[key2]);
        } else {
          var invalidPluginPropertyError = new Error("." + key2 + " is not a valid Plugin property");
          invalidPluginPropertyError.code = "BABEL_UNKNOWN_PLUGIN_PROPERTY";
          throw invalidPluginPropertyError;
        }
      });
      return obj;
    }
    function makeConfigAPI(cache2) {
      var env3 = function env4(value) {
        return cache2.using(function(data3) {
          if (typeof value === "undefined")
            return data3.envName;
          if (typeof value === "function") {
            return assertSimpleType(value(data3.envName));
          }
          if (!Array.isArray(value))
            value = [value];
          return value.some(function(entry2) {
            if (typeof entry2 !== "string") {
              throw new Error("Unexpected non-string value");
            }
            return entry2 === data3.envName;
          });
        });
      };
      var caller = function caller2(cb2) {
        return cache2.using(function(data3) {
          return assertSimpleType(cb2(data3.caller));
        });
      };
      return {
        version: version$3,
        cache: cache2.simple(),
        env: env3,
        async: function async() {
          return false;
        },
        caller,
        assertVersion
      };
    }
    function makePresetAPI(cache2, externalDependencies) {
      var targets = function targets2() {
        return JSON.parse(cache2.using(function(data3) {
          return JSON.stringify(data3.targets);
        }));
      };
      var addExternalDependency = function addExternalDependency2(ref2) {
        externalDependencies.push(ref2);
      };
      return Object.assign({}, makeConfigAPI(cache2), {
        targets,
        addExternalDependency
      });
    }
    function makePluginAPI(cache2, externalDependencies) {
      var assumption = function assumption2(name2) {
        return cache2.using(function(data3) {
          return data3.assumptions[name2];
        });
      };
      return Object.assign({}, makePresetAPI(cache2, externalDependencies), {
        assumption
      });
    }
    function assertVersion(range3) {
      if (typeof range3 === "number") {
        if (!Number.isInteger(range3)) {
          throw new Error("Expected string or integer value.");
        }
        range3 = "^" + range3 + ".0.0-0";
      }
      if (typeof range3 !== "string") {
        throw new Error("Expected string or integer value.");
      }
      if (semver$a.satisfies(version$3, range3))
        return;
      var limit = Error.stackTraceLimit;
      if (typeof limit === "number" && limit < 25) {
        Error.stackTraceLimit = 25;
      }
      var err = new Error('Requires Babel "' + range3 + '", but was loaded with "' + version$3 + `". If you are sure you have a compatible version of @babel/core, it is likely that something in your build process is loading the wrong version. Inspect the stack trace of this error to look for the first entry that doesn't mention "@babel/core" or "babel-core" to see what is calling Babel.`);
      if (typeof limit === "number") {
        Error.stackTraceLimit = limit;
      }
      throw Object.assign(err, {
        code: "BABEL_VERSION_UNSUPPORTED",
        version: version$3,
        range: range3
      });
    }
    var _excluded$22 = ["showIgnoredFiles"];
    var _marked$4 = regenerator2.mark(loadPrivatePartialConfig);
    function resolveRootMode(rootDir, rootMode) {
      switch (rootMode) {
        case "root":
          return rootDir;
        case "upward-optional": {
          var upwardRootDir = findConfigUpwards();
          return upwardRootDir === null ? rootDir : upwardRootDir;
        }
        case "upward": {
          var _upwardRootDir = findConfigUpwards();
          if (_upwardRootDir !== null)
            return _upwardRootDir;
          throw Object.assign(new Error('Babel was run with rootMode:"upward" but a root could not ' + ('be found when searching upward from "' + rootDir + '".\n') + "One of the following config files must be in the directory tree: " + ('"' + ROOT_CONFIG_FILENAMES.join(", ") + '".')), {
            code: "BABEL_ROOT_NOT_FOUND",
            dirname: rootDir
          });
        }
        default:
          throw new Error("Assertion failure - unknown rootMode value.");
      }
    }
    function loadPrivatePartialConfig(inputOpts) {
      var args, _args$envName, envName, _args$cwd, cwd2, _args$root, rootDir, _args$rootMode, rootMode, caller, _args$cloneInputAst, cloneInputAst, absoluteCwd, absoluteRootDir, filename, showConfigPath, context, configChain, merged, options;
      return regenerator2.wrap(function loadPrivatePartialConfig$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(inputOpts != null && (typeof inputOpts !== "object" || Array.isArray(inputOpts)))) {
                _context.next = 2;
                break;
              }
              throw new Error("Babel options must be an object, null, or undefined");
            case 2:
              args = inputOpts ? validate("arguments", inputOpts) : {};
              _args$envName = args.envName, envName = _args$envName === void 0 ? getEnv() : _args$envName, _args$cwd = args.cwd, cwd2 = _args$cwd === void 0 ? "." : _args$cwd, _args$root = args.root, rootDir = _args$root === void 0 ? "." : _args$root, _args$rootMode = args.rootMode, rootMode = _args$rootMode === void 0 ? "root" : _args$rootMode, caller = args.caller, _args$cloneInputAst = args.cloneInputAst, cloneInputAst = _args$cloneInputAst === void 0 ? true : _args$cloneInputAst;
              absoluteCwd = path$1.resolve(cwd2);
              absoluteRootDir = resolveRootMode(path$1.resolve(absoluteCwd, rootDir), rootMode);
              filename = typeof args.filename === "string" ? path$1.resolve(cwd2, args.filename) : void 0;
              return _context.delegateYield(resolveShowConfigPath(), "t0", 8);
            case 8:
              showConfigPath = _context.t0;
              context = {
                filename,
                cwd: absoluteCwd,
                root: absoluteRootDir,
                envName,
                caller,
                showConfig: showConfigPath === filename
              };
              return _context.delegateYield(buildRootChain(args, context), "t1", 11);
            case 11:
              configChain = _context.t1;
              if (configChain) {
                _context.next = 14;
                break;
              }
              return _context.abrupt("return", null);
            case 14:
              merged = {
                assumptions: {}
              };
              configChain.options.forEach(function(opts) {
                mergeOptions(merged, opts);
              });
              options = Object.assign({}, merged, {
                targets: resolveTargets(merged),
                cloneInputAst,
                babelrc: false,
                configFile: false,
                browserslistConfigFile: false,
                passPerPreset: false,
                envName: context.envName,
                cwd: context.cwd,
                root: context.root,
                rootMode: "root",
                filename: typeof context.filename === "string" ? context.filename : void 0,
                plugins: configChain.plugins.map(function(descriptor) {
                  return createItemFromDescriptor(descriptor);
                }),
                presets: configChain.presets.map(function(descriptor) {
                  return createItemFromDescriptor(descriptor);
                })
              });
              return _context.abrupt("return", {
                options,
                context,
                fileHandling: configChain.fileHandling,
                ignore: configChain.ignore,
                babelrc: configChain.babelrc,
                config: configChain.config,
                files: configChain.files
              });
            case 18:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$4);
    }
    var loadPartialConfig$1 = gensync(regenerator2.mark(function _callee(opts) {
      var showIgnoredFiles, _opts, result, options, babelrc, ignore, config3, fileHandling, files2;
      return regenerator2.wrap(function _callee$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              showIgnoredFiles = false;
              if (typeof opts === "object" && opts !== null && !Array.isArray(opts)) {
                _opts = opts;
                showIgnoredFiles = _opts.showIgnoredFiles;
                opts = _objectWithoutPropertiesLoose2(_opts, _excluded$22);
              }
              return _context2.delegateYield(loadPrivatePartialConfig(opts), "t0", 3);
            case 3:
              result = _context2.t0;
              if (result) {
                _context2.next = 6;
                break;
              }
              return _context2.abrupt("return", null);
            case 6:
              options = result.options, babelrc = result.babelrc, ignore = result.ignore, config3 = result.config, fileHandling = result.fileHandling, files2 = result.files;
              if (!(fileHandling === "ignored" && !showIgnoredFiles)) {
                _context2.next = 9;
                break;
              }
              return _context2.abrupt("return", null);
            case 9:
              (options.plugins || []).forEach(function(item) {
                if (item.value instanceof Plugin$1) {
                  throw new Error("Passing cached plugin instances is not supported in babel.loadPartialConfig()");
                }
              });
              return _context2.abrupt("return", new PartialConfig(options, babelrc ? babelrc.filepath : void 0, ignore ? ignore.filepath : void 0, config3 ? config3.filepath : void 0, fileHandling, files2));
            case 11:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee);
    }));
    var PartialConfig = function() {
      function PartialConfig2(options, babelrc, ignore, config3, fileHandling, files2) {
        this.options = void 0;
        this.babelrc = void 0;
        this.babelignore = void 0;
        this.config = void 0;
        this.fileHandling = void 0;
        this.files = void 0;
        this.options = options;
        this.babelignore = ignore;
        this.babelrc = babelrc;
        this.config = config3;
        this.fileHandling = fileHandling;
        this.files = files2;
        Object.freeze(this);
      }
      var _proto = PartialConfig2.prototype;
      _proto.hasFilesystemConfig = function hasFilesystemConfig() {
        return this.babelrc !== void 0 || this.config !== void 0;
      };
      return _createClass2(PartialConfig2);
    }();
    Object.freeze(PartialConfig.prototype);
    var _marked$3 = regenerator2.mark(loadPluginDescriptor), _marked2$1 = regenerator2.mark(loadPresetDescriptor);
    var loadConfig = gensync(regenerator2.mark(function loadFullConfig(inputOpts) {
      var _opts$assumptions;
      var result, options, context, fileHandling, optionDefaults, plugins2, presets, presetContext, toDescriptor, presetsDescriptors, initialPluginsDescriptors, pluginDescriptorsByPass, passes, externalDependencies, ignored, opts, pluginContext;
      return regenerator2.wrap(function loadFullConfig$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.delegateYield(loadPrivatePartialConfig(inputOpts), "t0", 1);
            case 1:
              result = _context3.t0;
              if (result) {
                _context3.next = 4;
                break;
              }
              return _context3.abrupt("return", null);
            case 4:
              options = result.options, context = result.context, fileHandling = result.fileHandling;
              if (!(fileHandling === "ignored")) {
                _context3.next = 7;
                break;
              }
              return _context3.abrupt("return", null);
            case 7:
              optionDefaults = {};
              plugins2 = options.plugins, presets = options.presets;
              if (!(!plugins2 || !presets)) {
                _context3.next = 11;
                break;
              }
              throw new Error("Assertion failure - plugins and presets exist");
            case 11:
              presetContext = Object.assign({}, context, {
                targets: options.targets
              });
              toDescriptor = function toDescriptor2(item) {
                var desc = getItemDescriptor(item);
                if (!desc) {
                  throw new Error("Assertion failure - must be config item");
                }
                return desc;
              };
              presetsDescriptors = presets.map(toDescriptor);
              initialPluginsDescriptors = plugins2.map(toDescriptor);
              pluginDescriptorsByPass = [[]];
              passes = [];
              externalDependencies = [];
              return _context3.delegateYield(enhanceError(context, regenerator2.mark(function recursePresetDescriptors(rawPresets, pluginDescriptorsPass) {
                var presets2, i2, descriptor, preset, _iterator2, _step2, _step$value, _preset, pass, _ignored;
                return regenerator2.wrap(function recursePresetDescriptors$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        presets2 = [];
                        i2 = 0;
                      case 2:
                        if (!(i2 < rawPresets.length)) {
                          _context.next = 19;
                          break;
                        }
                        descriptor = rawPresets[i2];
                        if (!(descriptor.options !== false)) {
                          _context.next = 16;
                          break;
                        }
                        _context.prev = 5;
                        return _context.delegateYield(loadPresetDescriptor(descriptor, presetContext), "t0", 7);
                      case 7:
                        preset = _context.t0;
                        _context.next = 14;
                        break;
                      case 10:
                        _context.prev = 10;
                        _context.t1 = _context["catch"](5);
                        if (_context.t1.code === "BABEL_UNKNOWN_OPTION") {
                          checkNoUnwrappedItemOptionPairs(rawPresets, i2, "preset", _context.t1);
                        }
                        throw _context.t1;
                      case 14:
                        externalDependencies.push(preset.externalDependencies);
                        if (descriptor.ownPass) {
                          presets2.push({
                            preset: preset.chain,
                            pass: []
                          });
                        } else {
                          presets2.unshift({
                            preset: preset.chain,
                            pass: pluginDescriptorsPass
                          });
                        }
                      case 16:
                        i2++;
                        _context.next = 2;
                        break;
                      case 19:
                        if (!(presets2.length > 0)) {
                          _context.next = 34;
                          break;
                        }
                        pluginDescriptorsByPass.splice.apply(pluginDescriptorsByPass, [1, 0].concat(_toConsumableArray2(presets2.map(function(o) {
                          return o.pass;
                        }).filter(function(p2) {
                          return p2 !== pluginDescriptorsPass;
                        }))));
                        _iterator2 = _createForOfIteratorHelperLoose(presets2);
                      case 22:
                        if ((_step2 = _iterator2()).done) {
                          _context.next = 34;
                          break;
                        }
                        _step$value = _step2.value, _preset = _step$value.preset, pass = _step$value.pass;
                        if (_preset) {
                          _context.next = 26;
                          break;
                        }
                        return _context.abrupt("return", true);
                      case 26:
                        pass.push.apply(pass, _toConsumableArray2(_preset.plugins));
                        return _context.delegateYield(recursePresetDescriptors(_preset.presets, pass), "t2", 28);
                      case 28:
                        _ignored = _context.t2;
                        if (!_ignored) {
                          _context.next = 31;
                          break;
                        }
                        return _context.abrupt("return", true);
                      case 31:
                        _preset.options.forEach(function(opts2) {
                          mergeOptions(optionDefaults, opts2);
                        });
                      case 32:
                        _context.next = 22;
                        break;
                      case 34:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, recursePresetDescriptors, null, [[5, 10]]);
              }))(presetsDescriptors, pluginDescriptorsByPass[0]), "t1", 19);
            case 19:
              ignored = _context3.t1;
              if (!ignored) {
                _context3.next = 22;
                break;
              }
              return _context3.abrupt("return", null);
            case 22:
              opts = optionDefaults;
              mergeOptions(opts, options);
              pluginContext = Object.assign({}, presetContext, {
                assumptions: (_opts$assumptions = opts.assumptions) != null ? _opts$assumptions : {}
              });
              return _context3.delegateYield(enhanceError(context, regenerator2.mark(function loadPluginDescriptors() {
                var _pluginDescriptorsByP;
                var _iterator2, _step2, descs, pass, i2, descriptor, plugin2;
                return regenerator2.wrap(function loadPluginDescriptors$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        (_pluginDescriptorsByP = pluginDescriptorsByPass[0]).unshift.apply(_pluginDescriptorsByP, _toConsumableArray2(initialPluginsDescriptors));
                        _iterator2 = _createForOfIteratorHelperLoose(pluginDescriptorsByPass);
                      case 2:
                        if ((_step2 = _iterator2()).done) {
                          _context2.next = 26;
                          break;
                        }
                        descs = _step2.value;
                        pass = [];
                        passes.push(pass);
                        i2 = 0;
                      case 7:
                        if (!(i2 < descs.length)) {
                          _context2.next = 24;
                          break;
                        }
                        descriptor = descs[i2];
                        if (!(descriptor.options !== false)) {
                          _context2.next = 21;
                          break;
                        }
                        _context2.prev = 10;
                        return _context2.delegateYield(loadPluginDescriptor(descriptor, pluginContext), "t0", 12);
                      case 12:
                        plugin2 = _context2.t0;
                        _context2.next = 19;
                        break;
                      case 15:
                        _context2.prev = 15;
                        _context2.t1 = _context2["catch"](10);
                        if (_context2.t1.code === "BABEL_UNKNOWN_PLUGIN_PROPERTY") {
                          checkNoUnwrappedItemOptionPairs(descs, i2, "plugin", _context2.t1);
                        }
                        throw _context2.t1;
                      case 19:
                        pass.push(plugin2);
                        externalDependencies.push(plugin2.externalDependencies);
                      case 21:
                        i2++;
                        _context2.next = 7;
                        break;
                      case 24:
                        _context2.next = 2;
                        break;
                      case 26:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, loadPluginDescriptors, null, [[10, 15]]);
              }))(), "t2", 26);
            case 26:
              opts.plugins = passes[0];
              opts.presets = passes.slice(1).filter(function(plugins3) {
                return plugins3.length > 0;
              }).map(function(plugins3) {
                return {
                  plugins: plugins3
                };
              });
              opts.passPerPreset = opts.presets.length > 0;
              return _context3.abrupt("return", {
                options: opts,
                passes,
                externalDependencies: finalize(externalDependencies)
              });
            case 30:
            case "end":
              return _context3.stop();
          }
        }
      }, loadFullConfig);
    }));
    function enhanceError(context, fn) {
      return regenerator2.mark(function _callee(arg1, arg2) {
        return regenerator2.wrap(function _callee$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.prev = 0;
                return _context4.delegateYield(fn(arg1, arg2), "t0", 2);
              case 2:
                return _context4.abrupt("return", _context4.t0);
              case 5:
                _context4.prev = 5;
                _context4.t1 = _context4["catch"](0);
                if (!/^\[BABEL\]/.test(_context4.t1.message)) {
                  _context4.t1.message = "[BABEL] " + (context.filename || "unknown") + ": " + _context4.t1.message;
                }
                throw _context4.t1;
              case 9:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee, null, [[0, 5]]);
      });
    }
    var makeDescriptorLoader = function makeDescriptorLoader2(apiFactory) {
      return makeWeakCache(regenerator2.mark(function _callee2(_ref3, cache2) {
        var value, options, dirname2, alias2, externalDependencies, item, factory, api, error2;
        return regenerator2.wrap(function _callee2$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                value = _ref3.value, options = _ref3.options, dirname2 = _ref3.dirname, alias2 = _ref3.alias;
                if (!(options === false)) {
                  _context5.next = 3;
                  break;
                }
                throw new Error("Assertion failure");
              case 3:
                options = options || {};
                externalDependencies = [];
                item = value;
                if (!(typeof value === "function")) {
                  _context5.next = 18;
                  break;
                }
                factory = maybeAsync(value, "You appear to be using an async plugin/preset, but Babel has been called synchronously");
                api = Object.assign({}, babel2, apiFactory(cache2, externalDependencies));
                _context5.prev = 9;
                return _context5.delegateYield(factory(api, options, dirname2), "t0", 11);
              case 11:
                item = _context5.t0;
                _context5.next = 18;
                break;
              case 14:
                _context5.prev = 14;
                _context5.t1 = _context5["catch"](9);
                if (alias2) {
                  _context5.t1.message += " (While processing: " + JSON.stringify(alias2) + ")";
                }
                throw _context5.t1;
              case 18:
                if (!(!item || typeof item !== "object")) {
                  _context5.next = 20;
                  break;
                }
                throw new Error("Plugin/Preset did not return an object.");
              case 20:
                if (!isThenable$1(item)) {
                  _context5.next = 23;
                  break;
                }
                return _context5.delegateYield([], "t2", 22);
              case 22:
                throw new Error(`You appear to be using a promise as a plugin, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version. As an alternative, you can prefix the promise with "await". ` + ("(While processing: " + JSON.stringify(alias2) + ")"));
              case 23:
                if (!(externalDependencies.length > 0 && (!cache2.configured() || cache2.mode() === "forever"))) {
                  _context5.next = 28;
                  break;
                }
                error2 = "A plugin/preset has external untracked dependencies " + ("(" + externalDependencies[0] + "), but the cache ");
                if (!cache2.configured()) {
                  error2 += "has not been configured to be invalidated when the external dependencies change. ";
                } else {
                  error2 += " has been configured to never be invalidated. ";
                }
                error2 += "Plugins/presets should configure their cache to be invalidated when the external dependencies change, for example using `api.cache.invalidate(() => statSync(filepath).mtimeMs)` or `api.cache.never()`\n" + ("(While processing: " + JSON.stringify(alias2) + ")");
                throw new Error(error2);
              case 28:
                return _context5.abrupt("return", {
                  value: item,
                  options,
                  dirname: dirname2,
                  alias: alias2,
                  externalDependencies: finalize(externalDependencies)
                });
              case 29:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee2, null, [[9, 14]]);
      }));
    };
    var pluginDescriptorLoader = makeDescriptorLoader(makePluginAPI);
    var presetDescriptorLoader = makeDescriptorLoader(makePresetAPI);
    function loadPluginDescriptor(descriptor, context) {
      return regenerator2.wrap(function loadPluginDescriptor$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              if (!(descriptor.value instanceof Plugin$1)) {
                _context6.next = 4;
                break;
              }
              if (!descriptor.options) {
                _context6.next = 3;
                break;
              }
              throw new Error("Passed options to an existing Plugin instance will not work.");
            case 3:
              return _context6.abrupt("return", descriptor.value);
            case 4:
              _context6.t0 = instantiatePlugin;
              return _context6.delegateYield(pluginDescriptorLoader(descriptor, context), "t1", 6);
            case 6:
              _context6.t2 = _context6.t1;
              _context6.t3 = context;
              return _context6.delegateYield((0, _context6.t0)(_context6.t2, _context6.t3), "t4", 9);
            case 9:
              return _context6.abrupt("return", _context6.t4);
            case 10:
            case "end":
              return _context6.stop();
          }
        }
      }, _marked$3);
    }
    var instantiatePlugin = makeWeakCache(regenerator2.mark(function _callee3(_ref22, cache2) {
      var value, options, dirname2, alias2, externalDependencies, pluginObj, plugin2, inheritsDescriptor, inherits3;
      return regenerator2.wrap(function _callee3$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              value = _ref22.value, options = _ref22.options, dirname2 = _ref22.dirname, alias2 = _ref22.alias, externalDependencies = _ref22.externalDependencies;
              pluginObj = validatePluginObject(value);
              plugin2 = Object.assign({}, pluginObj);
              if (plugin2.visitor) {
                plugin2.visitor = traverse.explode(Object.assign({}, plugin2.visitor));
              }
              if (!plugin2.inherits) {
                _context7.next = 13;
                break;
              }
              inheritsDescriptor = {
                name: void 0,
                alias: alias2 + "$inherits",
                value: plugin2.inherits,
                options,
                dirname: dirname2
              };
              return _context7.delegateYield(forwardAsync(loadPluginDescriptor, function(run2) {
                return cache2.invalidate(function(data3) {
                  return run2(inheritsDescriptor, data3);
                });
              }), "t0", 7);
            case 7:
              inherits3 = _context7.t0;
              plugin2.pre = chain(inherits3.pre, plugin2.pre);
              plugin2.post = chain(inherits3.post, plugin2.post);
              plugin2.manipulateOptions = chain(inherits3.manipulateOptions, plugin2.manipulateOptions);
              plugin2.visitor = traverse.visitors.merge([inherits3.visitor || {}, plugin2.visitor || {}]);
              if (inherits3.externalDependencies.length > 0) {
                if (externalDependencies.length === 0) {
                  externalDependencies = inherits3.externalDependencies;
                } else {
                  externalDependencies = finalize([externalDependencies, inherits3.externalDependencies]);
                }
              }
            case 13:
              return _context7.abrupt("return", new Plugin$1(plugin2, options, alias2, externalDependencies));
            case 14:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee3);
    }));
    var validateIfOptionNeedsFilename = function validateIfOptionNeedsFilename2(options, descriptor) {
      if (options.test || options.include || options.exclude) {
        var formattedPresetName = descriptor.name ? '"' + descriptor.name + '"' : "/* your preset */";
        throw new Error(["Preset " + formattedPresetName + " requires a filename to be set when babel is called directly,", "```", "babel.transform(code, { filename: 'file.ts', presets: [" + formattedPresetName + "] });", "```", "See https://babeljs.io/docs/en/options#filename for more information."].join("\n"));
      }
    };
    var validatePreset = function validatePreset2(preset, context, descriptor) {
      if (!context.filename) {
        var options = preset.options;
        validateIfOptionNeedsFilename(options, descriptor);
        if (options.overrides) {
          options.overrides.forEach(function(overrideOptions) {
            return validateIfOptionNeedsFilename(overrideOptions, descriptor);
          });
        }
      }
    };
    function loadPresetDescriptor(descriptor, context) {
      var preset;
      return regenerator2.wrap(function loadPresetDescriptor$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.t0 = instantiatePreset;
              return _context8.delegateYield(presetDescriptorLoader(descriptor, context), "t1", 2);
            case 2:
              _context8.t2 = _context8.t1;
              preset = (0, _context8.t0)(_context8.t2);
              validatePreset(preset, context, descriptor);
              return _context8.delegateYield(buildPresetChain(preset, context), "t3", 6);
            case 6:
              _context8.t4 = _context8.t3;
              _context8.t5 = preset.externalDependencies;
              return _context8.abrupt("return", {
                chain: _context8.t4,
                externalDependencies: _context8.t5
              });
            case 9:
            case "end":
              return _context8.stop();
          }
        }
      }, _marked2$1);
    }
    var instantiatePreset = makeWeakCacheSync(function(_ref3) {
      var value = _ref3.value, dirname2 = _ref3.dirname, alias2 = _ref3.alias, externalDependencies = _ref3.externalDependencies;
      return {
        options: validate("preset", value),
        alias: alias2,
        dirname: dirname2,
        externalDependencies
      };
    });
    function chain(a, b2) {
      var fns = [a, b2].filter(Boolean);
      if (fns.length <= 1)
        return fns[0];
      return function() {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        for (var _iterator3 = _createForOfIteratorHelperLoose(fns), _step3; !(_step3 = _iterator3()).done; ) {
          var fn = _step3.value;
          fn.apply(this, args);
        }
      };
    }
    var loadOptionsRunner = gensync(regenerator2.mark(function _callee(opts) {
      var _config$options;
      var config3;
      return regenerator2.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(loadConfig(opts), "t0", 1);
            case 1:
              config3 = _context.t0;
              return _context.abrupt("return", (_config$options = config3 == null ? void 0 : config3.options) != null ? _config$options : null);
            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    var createConfigItemRunner = gensync(createConfigItem$1);
    var maybeErrback = function maybeErrback2(runner) {
      return function(opts, callback) {
        if (callback === void 0 && typeof opts === "function") {
          callback = opts;
          opts = void 0;
        }
        return callback ? runner.errback(opts, callback) : runner.sync(opts);
      };
    };
    var loadPartialConfig = maybeErrback(loadPartialConfig$1);
    var loadPartialConfigSync = loadPartialConfig$1.sync;
    var loadPartialConfigAsync = loadPartialConfig$1.async;
    var loadOptions = maybeErrback(loadOptionsRunner);
    var loadOptionsSync = loadOptionsRunner.sync;
    var loadOptionsAsync = loadOptionsRunner.async;
    var createConfigItemSync = createConfigItemRunner.sync;
    var createConfigItemAsync = createConfigItemRunner.async;
    function createConfigItem(target, options, callback) {
      if (callback !== void 0) {
        return createConfigItemRunner.errback(target, options, callback);
      } else if (typeof options === "function") {
        return createConfigItemRunner.errback(target, void 0, callback);
      } else {
        return createConfigItemRunner.sync(target, options);
      }
    }
    var PluginPass = function() {
      function PluginPass2(file2, key2, options) {
        this._map = /* @__PURE__ */ new Map();
        this.key = void 0;
        this.file = void 0;
        this.opts = void 0;
        this.cwd = void 0;
        this.filename = void 0;
        this.key = key2;
        this.file = file2;
        this.opts = options || {};
        this.cwd = file2.opts.cwd;
        this.filename = file2.opts.filename;
      }
      var _proto = PluginPass2.prototype;
      _proto.set = function set3(key2, val) {
        this._map.set(key2, val);
      };
      _proto.get = function get3(key2) {
        return this._map.get(key2);
      };
      _proto.availableHelper = function availableHelper(name2, versionRange) {
        return this.file.availableHelper(name2, versionRange);
      };
      _proto.addHelper = function addHelper(name2) {
        return this.file.addHelper(name2);
      };
      _proto.addImport = function addImport() {
        return this.file.addImport();
      };
      _proto.buildCodeFrameError = function buildCodeFrameError(node2, msg2, _Error) {
        return this.file.buildCodeFrameError(node2, msg2, _Error);
      };
      return _createClass2(PluginPass2);
    }();
    {
      PluginPass.prototype.getModuleName = function getModuleName2() {
        return this.file.getModuleName();
      };
    }
    var LOADED_PLUGIN;
    function loadBlockHoistPlugin() {
      if (!LOADED_PLUGIN) {
        LOADED_PLUGIN = new Plugin$1(Object.assign({}, blockHoistPlugin, {
          visitor: traverse.explode(blockHoistPlugin.visitor)
        }), {});
      }
      return LOADED_PLUGIN;
    }
    function priority(bodyNode) {
      var priority2 = bodyNode == null ? void 0 : bodyNode._blockHoist;
      if (priority2 == null)
        return 1;
      if (priority2 === true)
        return 2;
      return priority2;
    }
    function stableSort(body) {
      var buckets = /* @__PURE__ */ Object.create(null);
      for (var i2 = 0; i2 < body.length; i2++) {
        var n2 = body[i2];
        var p2 = priority(n2);
        var bucket = buckets[p2] || (buckets[p2] = []);
        bucket.push(n2);
      }
      var keys2 = Object.keys(buckets).map(function(k2) {
        return +k2;
      }).sort(function(a, b2) {
        return b2 - a;
      });
      var index3 = 0;
      for (var _iterator2 = _createForOfIteratorHelperLoose(keys2), _step2; !(_step2 = _iterator2()).done; ) {
        var key2 = _step2.value;
        var _bucket = buckets[key2];
        for (var _iterator22 = _createForOfIteratorHelperLoose(_bucket), _step22; !(_step22 = _iterator22()).done; ) {
          var _n = _step22.value;
          body[index3++] = _n;
        }
      }
      return body;
    }
    var blockHoistPlugin = {
      name: "internal.blockHoist",
      visitor: {
        Block: {
          exit: function exit(_ref3) {
            var node2 = _ref3.node;
            var body = node2.body;
            var max3 = Math.pow(2, 30) - 1;
            var hasChange = false;
            for (var i2 = 0; i2 < body.length; i2++) {
              var n2 = body[i2];
              var p2 = priority(n2);
              if (p2 > max3) {
                hasChange = true;
                break;
              }
              max3 = p2;
            }
            if (!hasChange)
              return;
            node2.body = stableSort(body.slice());
          }
        }
      }
    };
    function normalizeOptions$4(config3) {
      var _config$options = config3.options, filename = _config$options.filename, cwd2 = _config$options.cwd, _config$options$filen = _config$options.filenameRelative, filenameRelative = _config$options$filen === void 0 ? typeof filename === "string" ? path$1.relative(cwd2, filename) : "unknown" : _config$options$filen, _config$options$sourc = _config$options.sourceType, sourceType = _config$options$sourc === void 0 ? "module" : _config$options$sourc, inputSourceMap = _config$options.inputSourceMap, _config$options$sourc2 = _config$options.sourceMaps, sourceMaps = _config$options$sourc2 === void 0 ? !!inputSourceMap : _config$options$sourc2, _config$options$sourc3 = _config$options.sourceRoot, sourceRoot = _config$options$sourc3 === void 0 ? config3.options.moduleRoot : _config$options$sourc3, _config$options$sourc4 = _config$options.sourceFileName, sourceFileName = _config$options$sourc4 === void 0 ? path$1.basename(filenameRelative) : _config$options$sourc4, _config$options$comme = _config$options.comments, comments = _config$options$comme === void 0 ? true : _config$options$comme, _config$options$compa = _config$options.compact, compact = _config$options$compa === void 0 ? "auto" : _config$options$compa;
      var opts = config3.options;
      var options = Object.assign({}, opts, {
        parserOpts: Object.assign({
          sourceType: path$1.extname(filenameRelative) === ".mjs" ? "module" : sourceType,
          sourceFileName: filename,
          plugins: []
        }, opts.parserOpts),
        generatorOpts: Object.assign({
          filename,
          auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
          auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
          retainLines: opts.retainLines,
          comments,
          shouldPrintComment: opts.shouldPrintComment,
          compact,
          minified: opts.minified,
          sourceMaps,
          sourceRoot,
          sourceFileName
        }, opts.generatorOpts)
      });
      for (var _iterator2 = _createForOfIteratorHelperLoose(config3.passes), _step2; !(_step2 = _iterator2()).done; ) {
        var plugins2 = _step2.value;
        for (var _iterator22 = _createForOfIteratorHelperLoose(plugins2), _step22; !(_step22 = _iterator22()).done; ) {
          var plugin2 = _step22.value;
          if (plugin2.manipulateOptions) {
            plugin2.manipulateOptions(options, options.parserOpts);
          }
        }
      }
      return options;
    }
    var fs = {};
    var convertSourceMap = {};
    var require$$1$1 = /* @__PURE__ */ getAugmentedNamespace(_polyfillNode_path);
    var safeBuffer = { exports: {} };
    var buffer = {};
    var base64Js = {};
    base64Js.byteLength = byteLength;
    base64Js.toByteArray = toByteArray;
    base64Js.fromByteArray = fromByteArray;
    var lookup = [];
    var revLookup = [];
    var Arr = typeof Uint8Array !== "undefined" ? Uint8Array : Array;
    var code2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    for (var i = 0, len2 = code2.length; i < len2; ++i) {
      lookup[i] = code2[i];
      revLookup[code2.charCodeAt(i)] = i;
    }
    revLookup["-".charCodeAt(0)] = 62;
    revLookup["_".charCodeAt(0)] = 63;
    function getLens(b64) {
      var len3 = b64.length;
      if (len3 % 4 > 0) {
        throw new Error("Invalid string. Length must be a multiple of 4");
      }
      var validLen = b64.indexOf("=");
      if (validLen === -1)
        validLen = len3;
      var placeHoldersLen = validLen === len3 ? 0 : 4 - validLen % 4;
      return [validLen, placeHoldersLen];
    }
    function byteLength(b64) {
      var lens = getLens(b64);
      var validLen = lens[0];
      var placeHoldersLen = lens[1];
      return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
    }
    function _byteLength(b64, validLen, placeHoldersLen) {
      return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
    }
    function toByteArray(b64) {
      var tmp;
      var lens = getLens(b64);
      var validLen = lens[0];
      var placeHoldersLen = lens[1];
      var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen));
      var curByte = 0;
      var len3 = placeHoldersLen > 0 ? validLen - 4 : validLen;
      var i2;
      for (i2 = 0; i2 < len3; i2 += 4) {
        tmp = revLookup[b64.charCodeAt(i2)] << 18 | revLookup[b64.charCodeAt(i2 + 1)] << 12 | revLookup[b64.charCodeAt(i2 + 2)] << 6 | revLookup[b64.charCodeAt(i2 + 3)];
        arr[curByte++] = tmp >> 16 & 255;
        arr[curByte++] = tmp >> 8 & 255;
        arr[curByte++] = tmp & 255;
      }
      if (placeHoldersLen === 2) {
        tmp = revLookup[b64.charCodeAt(i2)] << 2 | revLookup[b64.charCodeAt(i2 + 1)] >> 4;
        arr[curByte++] = tmp & 255;
      }
      if (placeHoldersLen === 1) {
        tmp = revLookup[b64.charCodeAt(i2)] << 10 | revLookup[b64.charCodeAt(i2 + 1)] << 4 | revLookup[b64.charCodeAt(i2 + 2)] >> 2;
        arr[curByte++] = tmp >> 8 & 255;
        arr[curByte++] = tmp & 255;
      }
      return arr;
    }
    function tripletToBase64(num) {
      return lookup[num >> 18 & 63] + lookup[num >> 12 & 63] + lookup[num >> 6 & 63] + lookup[num & 63];
    }
    function encodeChunk(uint8, start2, end2) {
      var tmp;
      var output = [];
      for (var i2 = start2; i2 < end2; i2 += 3) {
        tmp = (uint8[i2] << 16 & 16711680) + (uint8[i2 + 1] << 8 & 65280) + (uint8[i2 + 2] & 255);
        output.push(tripletToBase64(tmp));
      }
      return output.join("");
    }
    function fromByteArray(uint8) {
      var tmp;
      var len3 = uint8.length;
      var extraBytes = len3 % 3;
      var parts = [];
      var maxChunkLength = 16383;
      for (var i2 = 0, len22 = len3 - extraBytes; i2 < len22; i2 += maxChunkLength) {
        parts.push(encodeChunk(uint8, i2, i2 + maxChunkLength > len22 ? len22 : i2 + maxChunkLength));
      }
      if (extraBytes === 1) {
        tmp = uint8[len3 - 1];
        parts.push(lookup[tmp >> 2] + lookup[tmp << 4 & 63] + "==");
      } else if (extraBytes === 2) {
        tmp = (uint8[len3 - 2] << 8) + uint8[len3 - 1];
        parts.push(lookup[tmp >> 10] + lookup[tmp >> 4 & 63] + lookup[tmp << 2 & 63] + "=");
      }
      return parts.join("");
    }
    var ieee754 = {};
    ieee754.read = function(buffer2, offset3, isLE, mLen, nBytes) {
      var e2, m2;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var nBits = -7;
      var i2 = isLE ? nBytes - 1 : 0;
      var d2 = isLE ? -1 : 1;
      var s = buffer2[offset3 + i2];
      i2 += d2;
      e2 = s & (1 << -nBits) - 1;
      s >>= -nBits;
      nBits += eLen;
      for (; nBits > 0; e2 = e2 * 256 + buffer2[offset3 + i2], i2 += d2, nBits -= 8) {
      }
      m2 = e2 & (1 << -nBits) - 1;
      e2 >>= -nBits;
      nBits += mLen;
      for (; nBits > 0; m2 = m2 * 256 + buffer2[offset3 + i2], i2 += d2, nBits -= 8) {
      }
      if (e2 === 0) {
        e2 = 1 - eBias;
      } else if (e2 === eMax) {
        return m2 ? NaN : (s ? -1 : 1) * Infinity;
      } else {
        m2 = m2 + Math.pow(2, mLen);
        e2 = e2 - eBias;
      }
      return (s ? -1 : 1) * m2 * Math.pow(2, e2 - mLen);
    };
    ieee754.write = function(buffer2, value, offset3, isLE, mLen, nBytes) {
      var e2, m2, c2;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var rt2 = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
      var i2 = isLE ? 0 : nBytes - 1;
      var d2 = isLE ? 1 : -1;
      var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
      value = Math.abs(value);
      if (isNaN(value) || value === Infinity) {
        m2 = isNaN(value) ? 1 : 0;
        e2 = eMax;
      } else {
        e2 = Math.floor(Math.log(value) / Math.LN2);
        if (value * (c2 = Math.pow(2, -e2)) < 1) {
          e2--;
          c2 *= 2;
        }
        if (e2 + eBias >= 1) {
          value += rt2 / c2;
        } else {
          value += rt2 * Math.pow(2, 1 - eBias);
        }
        if (value * c2 >= 2) {
          e2++;
          c2 /= 2;
        }
        if (e2 + eBias >= eMax) {
          m2 = 0;
          e2 = eMax;
        } else if (e2 + eBias >= 1) {
          m2 = (value * c2 - 1) * Math.pow(2, mLen);
          e2 = e2 + eBias;
        } else {
          m2 = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
          e2 = 0;
        }
      }
      for (; mLen >= 8; buffer2[offset3 + i2] = m2 & 255, i2 += d2, m2 /= 256, mLen -= 8) {
      }
      e2 = e2 << mLen | m2;
      eLen += mLen;
      for (; eLen > 0; buffer2[offset3 + i2] = e2 & 255, i2 += d2, e2 /= 256, eLen -= 8) {
      }
      buffer2[offset3 + i2 - d2] |= s * 128;
    };
    /*!
     * The buffer module from node.js, for the browser.
     *
     * @author   Feross Aboukhadijeh <https://feross.org>
     * @license  MIT
     */
    (function(exports3) {
      var base642 = base64Js;
      var ieee754$1 = ieee754;
      exports3.Buffer = Buffer3;
      exports3.SlowBuffer = SlowBuffer;
      exports3.INSPECT_MAX_BYTES = 50;
      var K_MAX_LENGTH = 2147483647;
      exports3.kMaxLength = K_MAX_LENGTH;
      Buffer3.TYPED_ARRAY_SUPPORT = typedArraySupport();
      if (!Buffer3.TYPED_ARRAY_SUPPORT && typeof console !== "undefined" && typeof console.error === "function") {
        console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support.");
      }
      function typedArraySupport() {
        try {
          var arr = new Uint8Array(1);
          arr.__proto__ = {
            __proto__: Uint8Array.prototype,
            foo: function foo() {
              return 42;
            }
          };
          return arr.foo() === 42;
        } catch (e2) {
          return false;
        }
      }
      Object.defineProperty(Buffer3.prototype, "parent", {
        enumerable: true,
        get: function get3() {
          if (!Buffer3.isBuffer(this))
            return void 0;
          return this.buffer;
        }
      });
      Object.defineProperty(Buffer3.prototype, "offset", {
        enumerable: true,
        get: function get3() {
          if (!Buffer3.isBuffer(this))
            return void 0;
          return this.byteOffset;
        }
      });
      function createBuffer2(length) {
        if (length > K_MAX_LENGTH) {
          throw new RangeError('The value "' + length + '" is invalid for option "size"');
        }
        var buf = new Uint8Array(length);
        buf.__proto__ = Buffer3.prototype;
        return buf;
      }
      function Buffer3(arg, encodingOrOffset, length) {
        if (typeof arg === "number") {
          if (typeof encodingOrOffset === "string") {
            throw new TypeError('The "string" argument must be of type string. Received type number');
          }
          return allocUnsafe2(arg);
        }
        return from2(arg, encodingOrOffset, length);
      }
      if (typeof Symbol !== "undefined" && Symbol.species != null && Buffer3[Symbol.species] === Buffer3) {
        Object.defineProperty(Buffer3, Symbol.species, {
          value: null,
          configurable: true,
          enumerable: false,
          writable: false
        });
      }
      Buffer3.poolSize = 8192;
      function from2(value, encodingOrOffset, length) {
        if (typeof value === "string") {
          return fromString2(value, encodingOrOffset);
        }
        if (ArrayBuffer.isView(value)) {
          return fromArrayLike2(value);
        }
        if (value == null) {
          throw TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof value);
        }
        if (isInstance(value, ArrayBuffer) || value && isInstance(value.buffer, ArrayBuffer)) {
          return fromArrayBuffer2(value, encodingOrOffset, length);
        }
        if (typeof value === "number") {
          throw new TypeError('The "value" argument must not be of type number. Received type number');
        }
        var valueOf = value.valueOf && value.valueOf();
        if (valueOf != null && valueOf !== value) {
          return Buffer3.from(valueOf, encodingOrOffset, length);
        }
        var b2 = fromObject2(value);
        if (b2)
          return b2;
        if (typeof Symbol !== "undefined" && Symbol.toPrimitive != null && typeof value[Symbol.toPrimitive] === "function") {
          return Buffer3.from(value[Symbol.toPrimitive]("string"), encodingOrOffset, length);
        }
        throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof value);
      }
      Buffer3.from = function(value, encodingOrOffset, length) {
        return from2(value, encodingOrOffset, length);
      };
      Buffer3.prototype.__proto__ = Uint8Array.prototype;
      Buffer3.__proto__ = Uint8Array;
      function assertSize2(size) {
        if (typeof size !== "number") {
          throw new TypeError('"size" argument must be of type number');
        } else if (size < 0) {
          throw new RangeError('The value "' + size + '" is invalid for option "size"');
        }
      }
      function alloc2(size, fill, encoding) {
        assertSize2(size);
        if (size <= 0) {
          return createBuffer2(size);
        }
        if (fill !== void 0) {
          return typeof encoding === "string" ? createBuffer2(size).fill(fill, encoding) : createBuffer2(size).fill(fill);
        }
        return createBuffer2(size);
      }
      Buffer3.alloc = function(size, fill, encoding) {
        return alloc2(size, fill, encoding);
      };
      function allocUnsafe2(size) {
        assertSize2(size);
        return createBuffer2(size < 0 ? 0 : checked2(size) | 0);
      }
      Buffer3.allocUnsafe = function(size) {
        return allocUnsafe2(size);
      };
      Buffer3.allocUnsafeSlow = function(size) {
        return allocUnsafe2(size);
      };
      function fromString2(string3, encoding) {
        if (typeof encoding !== "string" || encoding === "") {
          encoding = "utf8";
        }
        if (!Buffer3.isEncoding(encoding)) {
          throw new TypeError("Unknown encoding: " + encoding);
        }
        var length = byteLength2(string3, encoding) | 0;
        var buf = createBuffer2(length);
        var actual = buf.write(string3, encoding);
        if (actual !== length) {
          buf = buf.slice(0, actual);
        }
        return buf;
      }
      function fromArrayLike2(array4) {
        var length = array4.length < 0 ? 0 : checked2(array4.length) | 0;
        var buf = createBuffer2(length);
        for (var i2 = 0; i2 < length; i2 += 1) {
          buf[i2] = array4[i2] & 255;
        }
        return buf;
      }
      function fromArrayBuffer2(array4, byteOffset, length) {
        if (byteOffset < 0 || array4.byteLength < byteOffset) {
          throw new RangeError('"offset" is outside of buffer bounds');
        }
        if (array4.byteLength < byteOffset + (length || 0)) {
          throw new RangeError('"length" is outside of buffer bounds');
        }
        var buf;
        if (byteOffset === void 0 && length === void 0) {
          buf = new Uint8Array(array4);
        } else if (length === void 0) {
          buf = new Uint8Array(array4, byteOffset);
        } else {
          buf = new Uint8Array(array4, byteOffset, length);
        }
        buf.__proto__ = Buffer3.prototype;
        return buf;
      }
      function fromObject2(obj) {
        if (Buffer3.isBuffer(obj)) {
          var len3 = checked2(obj.length) | 0;
          var buf = createBuffer2(len3);
          if (buf.length === 0) {
            return buf;
          }
          obj.copy(buf, 0, 0, len3);
          return buf;
        }
        if (obj.length !== void 0) {
          if (typeof obj.length !== "number" || numberIsNaN(obj.length)) {
            return createBuffer2(0);
          }
          return fromArrayLike2(obj);
        }
        if (obj.type === "Buffer" && Array.isArray(obj.data)) {
          return fromArrayLike2(obj.data);
        }
      }
      function checked2(length) {
        if (length >= K_MAX_LENGTH) {
          throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + K_MAX_LENGTH.toString(16) + " bytes");
        }
        return length | 0;
      }
      function SlowBuffer(length) {
        if (+length != length) {
          length = 0;
        }
        return Buffer3.alloc(+length);
      }
      Buffer3.isBuffer = function isBuffer3(b2) {
        return b2 != null && b2._isBuffer === true && b2 !== Buffer3.prototype;
      };
      Buffer3.compare = function compare3(a, b2) {
        if (isInstance(a, Uint8Array))
          a = Buffer3.from(a, a.offset, a.byteLength);
        if (isInstance(b2, Uint8Array))
          b2 = Buffer3.from(b2, b2.offset, b2.byteLength);
        if (!Buffer3.isBuffer(a) || !Buffer3.isBuffer(b2)) {
          throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
        }
        if (a === b2)
          return 0;
        var x2 = a.length;
        var y2 = b2.length;
        for (var i2 = 0, len3 = Math.min(x2, y2); i2 < len3; ++i2) {
          if (a[i2] !== b2[i2]) {
            x2 = a[i2];
            y2 = b2[i2];
            break;
          }
        }
        if (x2 < y2)
          return -1;
        if (y2 < x2)
          return 1;
        return 0;
      };
      Buffer3.isEncoding = function isEncoding(encoding) {
        switch (String(encoding).toLowerCase()) {
          case "hex":
          case "utf8":
          case "utf-8":
          case "ascii":
          case "latin1":
          case "binary":
          case "base64":
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return true;
          default:
            return false;
        }
      };
      Buffer3.concat = function concat(list2, length) {
        if (!Array.isArray(list2)) {
          throw new TypeError('"list" argument must be an Array of Buffers');
        }
        if (list2.length === 0) {
          return Buffer3.alloc(0);
        }
        var i2;
        if (length === void 0) {
          length = 0;
          for (i2 = 0; i2 < list2.length; ++i2) {
            length += list2[i2].length;
          }
        }
        var buffer2 = Buffer3.allocUnsafe(length);
        var pos = 0;
        for (i2 = 0; i2 < list2.length; ++i2) {
          var buf = list2[i2];
          if (isInstance(buf, Uint8Array)) {
            buf = Buffer3.from(buf);
          }
          if (!Buffer3.isBuffer(buf)) {
            throw new TypeError('"list" argument must be an Array of Buffers');
          }
          buf.copy(buffer2, pos);
          pos += buf.length;
        }
        return buffer2;
      };
      function byteLength2(string3, encoding) {
        if (Buffer3.isBuffer(string3)) {
          return string3.length;
        }
        if (ArrayBuffer.isView(string3) || isInstance(string3, ArrayBuffer)) {
          return string3.byteLength;
        }
        if (typeof string3 !== "string") {
          throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type ' + typeof string3);
        }
        var len3 = string3.length;
        var mustMatch = arguments.length > 2 && arguments[2] === true;
        if (!mustMatch && len3 === 0)
          return 0;
        var loweredCase = false;
        for (; ; ) {
          switch (encoding) {
            case "ascii":
            case "latin1":
            case "binary":
              return len3;
            case "utf8":
            case "utf-8":
              return utf8ToBytes2(string3).length;
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
              return len3 * 2;
            case "hex":
              return len3 >>> 1;
            case "base64":
              return base64ToBytes2(string3).length;
            default:
              if (loweredCase) {
                return mustMatch ? -1 : utf8ToBytes2(string3).length;
              }
              encoding = ("" + encoding).toLowerCase();
              loweredCase = true;
          }
        }
      }
      Buffer3.byteLength = byteLength2;
      function slowToString2(encoding, start2, end2) {
        var loweredCase = false;
        if (start2 === void 0 || start2 < 0) {
          start2 = 0;
        }
        if (start2 > this.length) {
          return "";
        }
        if (end2 === void 0 || end2 > this.length) {
          end2 = this.length;
        }
        if (end2 <= 0) {
          return "";
        }
        end2 >>>= 0;
        start2 >>>= 0;
        if (end2 <= start2) {
          return "";
        }
        if (!encoding)
          encoding = "utf8";
        while (true) {
          switch (encoding) {
            case "hex":
              return hexSlice2(this, start2, end2);
            case "utf8":
            case "utf-8":
              return utf8Slice2(this, start2, end2);
            case "ascii":
              return asciiSlice2(this, start2, end2);
            case "latin1":
            case "binary":
              return latin1Slice2(this, start2, end2);
            case "base64":
              return base64Slice2(this, start2, end2);
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
              return utf16leSlice2(this, start2, end2);
            default:
              if (loweredCase)
                throw new TypeError("Unknown encoding: " + encoding);
              encoding = (encoding + "").toLowerCase();
              loweredCase = true;
          }
        }
      }
      Buffer3.prototype._isBuffer = true;
      function swap3(b2, n2, m2) {
        var i2 = b2[n2];
        b2[n2] = b2[m2];
        b2[m2] = i2;
      }
      Buffer3.prototype.swap16 = function swap16() {
        var len3 = this.length;
        if (len3 % 2 !== 0) {
          throw new RangeError("Buffer size must be a multiple of 16-bits");
        }
        for (var i2 = 0; i2 < len3; i2 += 2) {
          swap3(this, i2, i2 + 1);
        }
        return this;
      };
      Buffer3.prototype.swap32 = function swap32() {
        var len3 = this.length;
        if (len3 % 4 !== 0) {
          throw new RangeError("Buffer size must be a multiple of 32-bits");
        }
        for (var i2 = 0; i2 < len3; i2 += 4) {
          swap3(this, i2, i2 + 3);
          swap3(this, i2 + 1, i2 + 2);
        }
        return this;
      };
      Buffer3.prototype.swap64 = function swap64() {
        var len3 = this.length;
        if (len3 % 8 !== 0) {
          throw new RangeError("Buffer size must be a multiple of 64-bits");
        }
        for (var i2 = 0; i2 < len3; i2 += 8) {
          swap3(this, i2, i2 + 7);
          swap3(this, i2 + 1, i2 + 6);
          swap3(this, i2 + 2, i2 + 5);
          swap3(this, i2 + 3, i2 + 4);
        }
        return this;
      };
      Buffer3.prototype.toString = function toString3() {
        var length = this.length;
        if (length === 0)
          return "";
        if (arguments.length === 0)
          return utf8Slice2(this, 0, length);
        return slowToString2.apply(this, arguments);
      };
      Buffer3.prototype.toLocaleString = Buffer3.prototype.toString;
      Buffer3.prototype.equals = function equals2(b2) {
        if (!Buffer3.isBuffer(b2))
          throw new TypeError("Argument must be a Buffer");
        if (this === b2)
          return true;
        return Buffer3.compare(this, b2) === 0;
      };
      Buffer3.prototype.inspect = function inspect2() {
        var str = "";
        var max3 = exports3.INSPECT_MAX_BYTES;
        str = this.toString("hex", 0, max3).replace(/(.{2})/g, "$1 ").trim();
        if (this.length > max3)
          str += " ... ";
        return "<Buffer " + str + ">";
      };
      Buffer3.prototype.compare = function compare3(target, start2, end2, thisStart, thisEnd) {
        if (isInstance(target, Uint8Array)) {
          target = Buffer3.from(target, target.offset, target.byteLength);
        }
        if (!Buffer3.isBuffer(target)) {
          throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type ' + typeof target);
        }
        if (start2 === void 0) {
          start2 = 0;
        }
        if (end2 === void 0) {
          end2 = target ? target.length : 0;
        }
        if (thisStart === void 0) {
          thisStart = 0;
        }
        if (thisEnd === void 0) {
          thisEnd = this.length;
        }
        if (start2 < 0 || end2 > target.length || thisStart < 0 || thisEnd > this.length) {
          throw new RangeError("out of range index");
        }
        if (thisStart >= thisEnd && start2 >= end2) {
          return 0;
        }
        if (thisStart >= thisEnd) {
          return -1;
        }
        if (start2 >= end2) {
          return 1;
        }
        start2 >>>= 0;
        end2 >>>= 0;
        thisStart >>>= 0;
        thisEnd >>>= 0;
        if (this === target)
          return 0;
        var x2 = thisEnd - thisStart;
        var y2 = end2 - start2;
        var len3 = Math.min(x2, y2);
        var thisCopy = this.slice(thisStart, thisEnd);
        var targetCopy = target.slice(start2, end2);
        for (var i2 = 0; i2 < len3; ++i2) {
          if (thisCopy[i2] !== targetCopy[i2]) {
            x2 = thisCopy[i2];
            y2 = targetCopy[i2];
            break;
          }
        }
        if (x2 < y2)
          return -1;
        if (y2 < x2)
          return 1;
        return 0;
      };
      function bidirectionalIndexOf2(buffer2, val, byteOffset, encoding, dir3) {
        if (buffer2.length === 0)
          return -1;
        if (typeof byteOffset === "string") {
          encoding = byteOffset;
          byteOffset = 0;
        } else if (byteOffset > 2147483647) {
          byteOffset = 2147483647;
        } else if (byteOffset < -2147483648) {
          byteOffset = -2147483648;
        }
        byteOffset = +byteOffset;
        if (numberIsNaN(byteOffset)) {
          byteOffset = dir3 ? 0 : buffer2.length - 1;
        }
        if (byteOffset < 0)
          byteOffset = buffer2.length + byteOffset;
        if (byteOffset >= buffer2.length) {
          if (dir3)
            return -1;
          else
            byteOffset = buffer2.length - 1;
        } else if (byteOffset < 0) {
          if (dir3)
            byteOffset = 0;
          else
            return -1;
        }
        if (typeof val === "string") {
          val = Buffer3.from(val, encoding);
        }
        if (Buffer3.isBuffer(val)) {
          if (val.length === 0) {
            return -1;
          }
          return arrayIndexOf2(buffer2, val, byteOffset, encoding, dir3);
        } else if (typeof val === "number") {
          val = val & 255;
          if (typeof Uint8Array.prototype.indexOf === "function") {
            if (dir3) {
              return Uint8Array.prototype.indexOf.call(buffer2, val, byteOffset);
            } else {
              return Uint8Array.prototype.lastIndexOf.call(buffer2, val, byteOffset);
            }
          }
          return arrayIndexOf2(buffer2, [val], byteOffset, encoding, dir3);
        }
        throw new TypeError("val must be string, number or Buffer");
      }
      function arrayIndexOf2(arr, val, byteOffset, encoding, dir3) {
        var indexSize = 1;
        var arrLength = arr.length;
        var valLength = val.length;
        if (encoding !== void 0) {
          encoding = String(encoding).toLowerCase();
          if (encoding === "ucs2" || encoding === "ucs-2" || encoding === "utf16le" || encoding === "utf-16le") {
            if (arr.length < 2 || val.length < 2) {
              return -1;
            }
            indexSize = 2;
            arrLength /= 2;
            valLength /= 2;
            byteOffset /= 2;
          }
        }
        function read2(buf, i3) {
          if (indexSize === 1) {
            return buf[i3];
          } else {
            return buf.readUInt16BE(i3 * indexSize);
          }
        }
        var i2;
        if (dir3) {
          var foundIndex = -1;
          for (i2 = byteOffset; i2 < arrLength; i2++) {
            if (read2(arr, i2) === read2(val, foundIndex === -1 ? 0 : i2 - foundIndex)) {
              if (foundIndex === -1)
                foundIndex = i2;
              if (i2 - foundIndex + 1 === valLength)
                return foundIndex * indexSize;
            } else {
              if (foundIndex !== -1)
                i2 -= i2 - foundIndex;
              foundIndex = -1;
            }
          }
        } else {
          if (byteOffset + valLength > arrLength)
            byteOffset = arrLength - valLength;
          for (i2 = byteOffset; i2 >= 0; i2--) {
            var found = true;
            for (var j = 0; j < valLength; j++) {
              if (read2(arr, i2 + j) !== read2(val, j)) {
                found = false;
                break;
              }
            }
            if (found)
              return i2;
          }
        }
        return -1;
      }
      Buffer3.prototype.includes = function includes(val, byteOffset, encoding) {
        return this.indexOf(val, byteOffset, encoding) !== -1;
      };
      Buffer3.prototype.indexOf = function indexOf2(val, byteOffset, encoding) {
        return bidirectionalIndexOf2(this, val, byteOffset, encoding, true);
      };
      Buffer3.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
        return bidirectionalIndexOf2(this, val, byteOffset, encoding, false);
      };
      function hexWrite2(buf, string3, offset3, length) {
        offset3 = Number(offset3) || 0;
        var remaining = buf.length - offset3;
        if (!length) {
          length = remaining;
        } else {
          length = Number(length);
          if (length > remaining) {
            length = remaining;
          }
        }
        var strLen = string3.length;
        if (length > strLen / 2) {
          length = strLen / 2;
        }
        for (var i2 = 0; i2 < length; ++i2) {
          var parsed = parseInt(string3.substr(i2 * 2, 2), 16);
          if (numberIsNaN(parsed))
            return i2;
          buf[offset3 + i2] = parsed;
        }
        return i2;
      }
      function utf8Write2(buf, string3, offset3, length) {
        return blitBuffer2(utf8ToBytes2(string3, buf.length - offset3), buf, offset3, length);
      }
      function asciiWrite2(buf, string3, offset3, length) {
        return blitBuffer2(asciiToBytes2(string3), buf, offset3, length);
      }
      function latin1Write2(buf, string3, offset3, length) {
        return asciiWrite2(buf, string3, offset3, length);
      }
      function base64Write2(buf, string3, offset3, length) {
        return blitBuffer2(base64ToBytes2(string3), buf, offset3, length);
      }
      function ucs2Write2(buf, string3, offset3, length) {
        return blitBuffer2(utf16leToBytes2(string3, buf.length - offset3), buf, offset3, length);
      }
      Buffer3.prototype.write = function write2(string3, offset3, length, encoding) {
        if (offset3 === void 0) {
          encoding = "utf8";
          length = this.length;
          offset3 = 0;
        } else if (length === void 0 && typeof offset3 === "string") {
          encoding = offset3;
          length = this.length;
          offset3 = 0;
        } else if (isFinite(offset3)) {
          offset3 = offset3 >>> 0;
          if (isFinite(length)) {
            length = length >>> 0;
            if (encoding === void 0)
              encoding = "utf8";
          } else {
            encoding = length;
            length = void 0;
          }
        } else {
          throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");
        }
        var remaining = this.length - offset3;
        if (length === void 0 || length > remaining)
          length = remaining;
        if (string3.length > 0 && (length < 0 || offset3 < 0) || offset3 > this.length) {
          throw new RangeError("Attempt to write outside buffer bounds");
        }
        if (!encoding)
          encoding = "utf8";
        var loweredCase = false;
        for (; ; ) {
          switch (encoding) {
            case "hex":
              return hexWrite2(this, string3, offset3, length);
            case "utf8":
            case "utf-8":
              return utf8Write2(this, string3, offset3, length);
            case "ascii":
              return asciiWrite2(this, string3, offset3, length);
            case "latin1":
            case "binary":
              return latin1Write2(this, string3, offset3, length);
            case "base64":
              return base64Write2(this, string3, offset3, length);
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
              return ucs2Write2(this, string3, offset3, length);
            default:
              if (loweredCase)
                throw new TypeError("Unknown encoding: " + encoding);
              encoding = ("" + encoding).toLowerCase();
              loweredCase = true;
          }
        }
      };
      Buffer3.prototype.toJSON = function toJSON() {
        return {
          type: "Buffer",
          data: Array.prototype.slice.call(this._arr || this, 0)
        };
      };
      function base64Slice2(buf, start2, end2) {
        if (start2 === 0 && end2 === buf.length) {
          return base642.fromByteArray(buf);
        } else {
          return base642.fromByteArray(buf.slice(start2, end2));
        }
      }
      function utf8Slice2(buf, start2, end2) {
        end2 = Math.min(buf.length, end2);
        var res2 = [];
        var i2 = start2;
        while (i2 < end2) {
          var firstByte = buf[i2];
          var codePoint = null;
          var bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
          if (i2 + bytesPerSequence <= end2) {
            var secondByte, thirdByte, fourthByte, tempCodePoint;
            switch (bytesPerSequence) {
              case 1:
                if (firstByte < 128) {
                  codePoint = firstByte;
                }
                break;
              case 2:
                secondByte = buf[i2 + 1];
                if ((secondByte & 192) === 128) {
                  tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
                  if (tempCodePoint > 127) {
                    codePoint = tempCodePoint;
                  }
                }
                break;
              case 3:
                secondByte = buf[i2 + 1];
                thirdByte = buf[i2 + 2];
                if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
                  tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
                  if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
                    codePoint = tempCodePoint;
                  }
                }
                break;
              case 4:
                secondByte = buf[i2 + 1];
                thirdByte = buf[i2 + 2];
                fourthByte = buf[i2 + 3];
                if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
                  tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
                  if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
                    codePoint = tempCodePoint;
                  }
                }
            }
          }
          if (codePoint === null) {
            codePoint = 65533;
            bytesPerSequence = 1;
          } else if (codePoint > 65535) {
            codePoint -= 65536;
            res2.push(codePoint >>> 10 & 1023 | 55296);
            codePoint = 56320 | codePoint & 1023;
          }
          res2.push(codePoint);
          i2 += bytesPerSequence;
        }
        return decodeCodePointsArray2(res2);
      }
      var MAX_ARGUMENTS_LENGTH2 = 4096;
      function decodeCodePointsArray2(codePoints) {
        var len3 = codePoints.length;
        if (len3 <= MAX_ARGUMENTS_LENGTH2) {
          return String.fromCharCode.apply(String, codePoints);
        }
        var res2 = "";
        var i2 = 0;
        while (i2 < len3) {
          res2 += String.fromCharCode.apply(String, codePoints.slice(i2, i2 += MAX_ARGUMENTS_LENGTH2));
        }
        return res2;
      }
      function asciiSlice2(buf, start2, end2) {
        var ret = "";
        end2 = Math.min(buf.length, end2);
        for (var i2 = start2; i2 < end2; ++i2) {
          ret += String.fromCharCode(buf[i2] & 127);
        }
        return ret;
      }
      function latin1Slice2(buf, start2, end2) {
        var ret = "";
        end2 = Math.min(buf.length, end2);
        for (var i2 = start2; i2 < end2; ++i2) {
          ret += String.fromCharCode(buf[i2]);
        }
        return ret;
      }
      function hexSlice2(buf, start2, end2) {
        var len3 = buf.length;
        if (!start2 || start2 < 0)
          start2 = 0;
        if (!end2 || end2 < 0 || end2 > len3)
          end2 = len3;
        var out2 = "";
        for (var i2 = start2; i2 < end2; ++i2) {
          out2 += toHex3(buf[i2]);
        }
        return out2;
      }
      function utf16leSlice2(buf, start2, end2) {
        var bytes = buf.slice(start2, end2);
        var res2 = "";
        for (var i2 = 0; i2 < bytes.length; i2 += 2) {
          res2 += String.fromCharCode(bytes[i2] + bytes[i2 + 1] * 256);
        }
        return res2;
      }
      Buffer3.prototype.slice = function slice2(start2, end2) {
        var len3 = this.length;
        start2 = ~~start2;
        end2 = end2 === void 0 ? len3 : ~~end2;
        if (start2 < 0) {
          start2 += len3;
          if (start2 < 0)
            start2 = 0;
        } else if (start2 > len3) {
          start2 = len3;
        }
        if (end2 < 0) {
          end2 += len3;
          if (end2 < 0)
            end2 = 0;
        } else if (end2 > len3) {
          end2 = len3;
        }
        if (end2 < start2)
          end2 = start2;
        var newBuf = this.subarray(start2, end2);
        newBuf.__proto__ = Buffer3.prototype;
        return newBuf;
      };
      function checkOffset2(offset3, ext, length) {
        if (offset3 % 1 !== 0 || offset3 < 0)
          throw new RangeError("offset is not uint");
        if (offset3 + ext > length)
          throw new RangeError("Trying to access beyond buffer length");
      }
      Buffer3.prototype.readUIntLE = function readUIntLE(offset3, byteLength3, noAssert) {
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, byteLength3, this.length);
        var val = this[offset3];
        var mul2 = 1;
        var i2 = 0;
        while (++i2 < byteLength3 && (mul2 *= 256)) {
          val += this[offset3 + i2] * mul2;
        }
        return val;
      };
      Buffer3.prototype.readUIntBE = function readUIntBE(offset3, byteLength3, noAssert) {
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert) {
          checkOffset2(offset3, byteLength3, this.length);
        }
        var val = this[offset3 + --byteLength3];
        var mul2 = 1;
        while (byteLength3 > 0 && (mul2 *= 256)) {
          val += this[offset3 + --byteLength3] * mul2;
        }
        return val;
      };
      Buffer3.prototype.readUInt8 = function readUInt8(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 1, this.length);
        return this[offset3];
      };
      Buffer3.prototype.readUInt16LE = function readUInt16LE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 2, this.length);
        return this[offset3] | this[offset3 + 1] << 8;
      };
      Buffer3.prototype.readUInt16BE = function readUInt16BE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 2, this.length);
        return this[offset3] << 8 | this[offset3 + 1];
      };
      Buffer3.prototype.readUInt32LE = function readUInt32LE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return (this[offset3] | this[offset3 + 1] << 8 | this[offset3 + 2] << 16) + this[offset3 + 3] * 16777216;
      };
      Buffer3.prototype.readUInt32BE = function readUInt32BE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return this[offset3] * 16777216 + (this[offset3 + 1] << 16 | this[offset3 + 2] << 8 | this[offset3 + 3]);
      };
      Buffer3.prototype.readIntLE = function readIntLE(offset3, byteLength3, noAssert) {
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, byteLength3, this.length);
        var val = this[offset3];
        var mul2 = 1;
        var i2 = 0;
        while (++i2 < byteLength3 && (mul2 *= 256)) {
          val += this[offset3 + i2] * mul2;
        }
        mul2 *= 128;
        if (val >= mul2)
          val -= Math.pow(2, 8 * byteLength3);
        return val;
      };
      Buffer3.prototype.readIntBE = function readIntBE(offset3, byteLength3, noAssert) {
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, byteLength3, this.length);
        var i2 = byteLength3;
        var mul2 = 1;
        var val = this[offset3 + --i2];
        while (i2 > 0 && (mul2 *= 256)) {
          val += this[offset3 + --i2] * mul2;
        }
        mul2 *= 128;
        if (val >= mul2)
          val -= Math.pow(2, 8 * byteLength3);
        return val;
      };
      Buffer3.prototype.readInt8 = function readInt8(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 1, this.length);
        if (!(this[offset3] & 128))
          return this[offset3];
        return (255 - this[offset3] + 1) * -1;
      };
      Buffer3.prototype.readInt16LE = function readInt16LE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 2, this.length);
        var val = this[offset3] | this[offset3 + 1] << 8;
        return val & 32768 ? val | 4294901760 : val;
      };
      Buffer3.prototype.readInt16BE = function readInt16BE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 2, this.length);
        var val = this[offset3 + 1] | this[offset3] << 8;
        return val & 32768 ? val | 4294901760 : val;
      };
      Buffer3.prototype.readInt32LE = function readInt32LE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return this[offset3] | this[offset3 + 1] << 8 | this[offset3 + 2] << 16 | this[offset3 + 3] << 24;
      };
      Buffer3.prototype.readInt32BE = function readInt32BE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return this[offset3] << 24 | this[offset3 + 1] << 16 | this[offset3 + 2] << 8 | this[offset3 + 3];
      };
      Buffer3.prototype.readFloatLE = function readFloatLE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return ieee754$1.read(this, offset3, true, 23, 4);
      };
      Buffer3.prototype.readFloatBE = function readFloatBE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 4, this.length);
        return ieee754$1.read(this, offset3, false, 23, 4);
      };
      Buffer3.prototype.readDoubleLE = function readDoubleLE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 8, this.length);
        return ieee754$1.read(this, offset3, true, 52, 8);
      };
      Buffer3.prototype.readDoubleBE = function readDoubleBE(offset3, noAssert) {
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkOffset2(offset3, 8, this.length);
        return ieee754$1.read(this, offset3, false, 52, 8);
      };
      function checkInt2(buf, value, offset3, ext, max3, min4) {
        if (!Buffer3.isBuffer(buf))
          throw new TypeError('"buffer" argument must be a Buffer instance');
        if (value > max3 || value < min4)
          throw new RangeError('"value" argument is out of bounds');
        if (offset3 + ext > buf.length)
          throw new RangeError("Index out of range");
      }
      Buffer3.prototype.writeUIntLE = function writeUIntLE(value, offset3, byteLength3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert) {
          var maxBytes = Math.pow(2, 8 * byteLength3) - 1;
          checkInt2(this, value, offset3, byteLength3, maxBytes, 0);
        }
        var mul2 = 1;
        var i2 = 0;
        this[offset3] = value & 255;
        while (++i2 < byteLength3 && (mul2 *= 256)) {
          this[offset3 + i2] = value / mul2 & 255;
        }
        return offset3 + byteLength3;
      };
      Buffer3.prototype.writeUIntBE = function writeUIntBE(value, offset3, byteLength3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        byteLength3 = byteLength3 >>> 0;
        if (!noAssert) {
          var maxBytes = Math.pow(2, 8 * byteLength3) - 1;
          checkInt2(this, value, offset3, byteLength3, maxBytes, 0);
        }
        var i2 = byteLength3 - 1;
        var mul2 = 1;
        this[offset3 + i2] = value & 255;
        while (--i2 >= 0 && (mul2 *= 256)) {
          this[offset3 + i2] = value / mul2 & 255;
        }
        return offset3 + byteLength3;
      };
      Buffer3.prototype.writeUInt8 = function writeUInt8(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 1, 255, 0);
        this[offset3] = value & 255;
        return offset3 + 1;
      };
      Buffer3.prototype.writeUInt16LE = function writeUInt16LE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 2, 65535, 0);
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
        return offset3 + 2;
      };
      Buffer3.prototype.writeUInt16BE = function writeUInt16BE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 2, 65535, 0);
        this[offset3] = value >>> 8;
        this[offset3 + 1] = value & 255;
        return offset3 + 2;
      };
      Buffer3.prototype.writeUInt32LE = function writeUInt32LE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 4, 4294967295, 0);
        this[offset3 + 3] = value >>> 24;
        this[offset3 + 2] = value >>> 16;
        this[offset3 + 1] = value >>> 8;
        this[offset3] = value & 255;
        return offset3 + 4;
      };
      Buffer3.prototype.writeUInt32BE = function writeUInt32BE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 4, 4294967295, 0);
        this[offset3] = value >>> 24;
        this[offset3 + 1] = value >>> 16;
        this[offset3 + 2] = value >>> 8;
        this[offset3 + 3] = value & 255;
        return offset3 + 4;
      };
      Buffer3.prototype.writeIntLE = function writeIntLE(value, offset3, byteLength3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert) {
          var limit = Math.pow(2, 8 * byteLength3 - 1);
          checkInt2(this, value, offset3, byteLength3, limit - 1, -limit);
        }
        var i2 = 0;
        var mul2 = 1;
        var sub2 = 0;
        this[offset3] = value & 255;
        while (++i2 < byteLength3 && (mul2 *= 256)) {
          if (value < 0 && sub2 === 0 && this[offset3 + i2 - 1] !== 0) {
            sub2 = 1;
          }
          this[offset3 + i2] = (value / mul2 >> 0) - sub2 & 255;
        }
        return offset3 + byteLength3;
      };
      Buffer3.prototype.writeIntBE = function writeIntBE(value, offset3, byteLength3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert) {
          var limit = Math.pow(2, 8 * byteLength3 - 1);
          checkInt2(this, value, offset3, byteLength3, limit - 1, -limit);
        }
        var i2 = byteLength3 - 1;
        var mul2 = 1;
        var sub2 = 0;
        this[offset3 + i2] = value & 255;
        while (--i2 >= 0 && (mul2 *= 256)) {
          if (value < 0 && sub2 === 0 && this[offset3 + i2 + 1] !== 0) {
            sub2 = 1;
          }
          this[offset3 + i2] = (value / mul2 >> 0) - sub2 & 255;
        }
        return offset3 + byteLength3;
      };
      Buffer3.prototype.writeInt8 = function writeInt8(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 1, 127, -128);
        if (value < 0)
          value = 255 + value + 1;
        this[offset3] = value & 255;
        return offset3 + 1;
      };
      Buffer3.prototype.writeInt16LE = function writeInt16LE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 2, 32767, -32768);
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
        return offset3 + 2;
      };
      Buffer3.prototype.writeInt16BE = function writeInt16BE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 2, 32767, -32768);
        this[offset3] = value >>> 8;
        this[offset3 + 1] = value & 255;
        return offset3 + 2;
      };
      Buffer3.prototype.writeInt32LE = function writeInt32LE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 4, 2147483647, -2147483648);
        this[offset3] = value & 255;
        this[offset3 + 1] = value >>> 8;
        this[offset3 + 2] = value >>> 16;
        this[offset3 + 3] = value >>> 24;
        return offset3 + 4;
      };
      Buffer3.prototype.writeInt32BE = function writeInt32BE(value, offset3, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert)
          checkInt2(this, value, offset3, 4, 2147483647, -2147483648);
        if (value < 0)
          value = 4294967295 + value + 1;
        this[offset3] = value >>> 24;
        this[offset3 + 1] = value >>> 16;
        this[offset3 + 2] = value >>> 8;
        this[offset3 + 3] = value & 255;
        return offset3 + 4;
      };
      function checkIEEE7542(buf, value, offset3, ext, max3, min4) {
        if (offset3 + ext > buf.length)
          throw new RangeError("Index out of range");
        if (offset3 < 0)
          throw new RangeError("Index out of range");
      }
      function writeFloat2(buf, value, offset3, littleEndian, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert) {
          checkIEEE7542(buf, value, offset3, 4);
        }
        ieee754$1.write(buf, value, offset3, littleEndian, 23, 4);
        return offset3 + 4;
      }
      Buffer3.prototype.writeFloatLE = function writeFloatLE(value, offset3, noAssert) {
        return writeFloat2(this, value, offset3, true, noAssert);
      };
      Buffer3.prototype.writeFloatBE = function writeFloatBE(value, offset3, noAssert) {
        return writeFloat2(this, value, offset3, false, noAssert);
      };
      function writeDouble2(buf, value, offset3, littleEndian, noAssert) {
        value = +value;
        offset3 = offset3 >>> 0;
        if (!noAssert) {
          checkIEEE7542(buf, value, offset3, 8);
        }
        ieee754$1.write(buf, value, offset3, littleEndian, 52, 8);
        return offset3 + 8;
      }
      Buffer3.prototype.writeDoubleLE = function writeDoubleLE(value, offset3, noAssert) {
        return writeDouble2(this, value, offset3, true, noAssert);
      };
      Buffer3.prototype.writeDoubleBE = function writeDoubleBE(value, offset3, noAssert) {
        return writeDouble2(this, value, offset3, false, noAssert);
      };
      Buffer3.prototype.copy = function copy2(target, targetStart, start2, end2) {
        if (!Buffer3.isBuffer(target))
          throw new TypeError("argument should be a Buffer");
        if (!start2)
          start2 = 0;
        if (!end2 && end2 !== 0)
          end2 = this.length;
        if (targetStart >= target.length)
          targetStart = target.length;
        if (!targetStart)
          targetStart = 0;
        if (end2 > 0 && end2 < start2)
          end2 = start2;
        if (end2 === start2)
          return 0;
        if (target.length === 0 || this.length === 0)
          return 0;
        if (targetStart < 0) {
          throw new RangeError("targetStart out of bounds");
        }
        if (start2 < 0 || start2 >= this.length)
          throw new RangeError("Index out of range");
        if (end2 < 0)
          throw new RangeError("sourceEnd out of bounds");
        if (end2 > this.length)
          end2 = this.length;
        if (target.length - targetStart < end2 - start2) {
          end2 = target.length - targetStart + start2;
        }
        var len3 = end2 - start2;
        if (this === target && typeof Uint8Array.prototype.copyWithin === "function") {
          this.copyWithin(targetStart, start2, end2);
        } else if (this === target && start2 < targetStart && targetStart < end2) {
          for (var i2 = len3 - 1; i2 >= 0; --i2) {
            target[i2 + targetStart] = this[i2 + start2];
          }
        } else {
          Uint8Array.prototype.set.call(target, this.subarray(start2, end2), targetStart);
        }
        return len3;
      };
      Buffer3.prototype.fill = function fill(val, start2, end2, encoding) {
        if (typeof val === "string") {
          if (typeof start2 === "string") {
            encoding = start2;
            start2 = 0;
            end2 = this.length;
          } else if (typeof end2 === "string") {
            encoding = end2;
            end2 = this.length;
          }
          if (encoding !== void 0 && typeof encoding !== "string") {
            throw new TypeError("encoding must be a string");
          }
          if (typeof encoding === "string" && !Buffer3.isEncoding(encoding)) {
            throw new TypeError("Unknown encoding: " + encoding);
          }
          if (val.length === 1) {
            var code3 = val.charCodeAt(0);
            if (encoding === "utf8" && code3 < 128 || encoding === "latin1") {
              val = code3;
            }
          }
        } else if (typeof val === "number") {
          val = val & 255;
        }
        if (start2 < 0 || this.length < start2 || this.length < end2) {
          throw new RangeError("Out of range index");
        }
        if (end2 <= start2) {
          return this;
        }
        start2 = start2 >>> 0;
        end2 = end2 === void 0 ? this.length : end2 >>> 0;
        if (!val)
          val = 0;
        var i2;
        if (typeof val === "number") {
          for (i2 = start2; i2 < end2; ++i2) {
            this[i2] = val;
          }
        } else {
          var bytes = Buffer3.isBuffer(val) ? val : Buffer3.from(val, encoding);
          var len3 = bytes.length;
          if (len3 === 0) {
            throw new TypeError('The value "' + val + '" is invalid for argument "value"');
          }
          for (i2 = 0; i2 < end2 - start2; ++i2) {
            this[i2 + start2] = bytes[i2 % len3];
          }
        }
        return this;
      };
      var INVALID_BASE64_RE2 = /[^+/0-9A-Za-z-_]/g;
      function base64clean2(str) {
        str = str.split("=")[0];
        str = str.trim().replace(INVALID_BASE64_RE2, "");
        if (str.length < 2)
          return "";
        while (str.length % 4 !== 0) {
          str = str + "=";
        }
        return str;
      }
      function toHex3(n2) {
        if (n2 < 16)
          return "0" + n2.toString(16);
        return n2.toString(16);
      }
      function utf8ToBytes2(string3, units) {
        units = units || Infinity;
        var codePoint;
        var length = string3.length;
        var leadSurrogate = null;
        var bytes = [];
        for (var i2 = 0; i2 < length; ++i2) {
          codePoint = string3.charCodeAt(i2);
          if (codePoint > 55295 && codePoint < 57344) {
            if (!leadSurrogate) {
              if (codePoint > 56319) {
                if ((units -= 3) > -1)
                  bytes.push(239, 191, 189);
                continue;
              } else if (i2 + 1 === length) {
                if ((units -= 3) > -1)
                  bytes.push(239, 191, 189);
                continue;
              }
              leadSurrogate = codePoint;
              continue;
            }
            if (codePoint < 56320) {
              if ((units -= 3) > -1)
                bytes.push(239, 191, 189);
              leadSurrogate = codePoint;
              continue;
            }
            codePoint = (leadSurrogate - 55296 << 10 | codePoint - 56320) + 65536;
          } else if (leadSurrogate) {
            if ((units -= 3) > -1)
              bytes.push(239, 191, 189);
          }
          leadSurrogate = null;
          if (codePoint < 128) {
            if ((units -= 1) < 0)
              break;
            bytes.push(codePoint);
          } else if (codePoint < 2048) {
            if ((units -= 2) < 0)
              break;
            bytes.push(codePoint >> 6 | 192, codePoint & 63 | 128);
          } else if (codePoint < 65536) {
            if ((units -= 3) < 0)
              break;
            bytes.push(codePoint >> 12 | 224, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
          } else if (codePoint < 1114112) {
            if ((units -= 4) < 0)
              break;
            bytes.push(codePoint >> 18 | 240, codePoint >> 12 & 63 | 128, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
          } else {
            throw new Error("Invalid code point");
          }
        }
        return bytes;
      }
      function asciiToBytes2(str) {
        var byteArray = [];
        for (var i2 = 0; i2 < str.length; ++i2) {
          byteArray.push(str.charCodeAt(i2) & 255);
        }
        return byteArray;
      }
      function utf16leToBytes2(str, units) {
        var c2, hi2, lo;
        var byteArray = [];
        for (var i2 = 0; i2 < str.length; ++i2) {
          if ((units -= 2) < 0)
            break;
          c2 = str.charCodeAt(i2);
          hi2 = c2 >> 8;
          lo = c2 % 256;
          byteArray.push(lo);
          byteArray.push(hi2);
        }
        return byteArray;
      }
      function base64ToBytes2(str) {
        return base642.toByteArray(base64clean2(str));
      }
      function blitBuffer2(src2, dst, offset3, length) {
        for (var i2 = 0; i2 < length; ++i2) {
          if (i2 + offset3 >= dst.length || i2 >= src2.length)
            break;
          dst[i2 + offset3] = src2[i2];
        }
        return i2;
      }
      function isInstance(obj, type5) {
        return obj instanceof type5 || obj != null && obj.constructor != null && obj.constructor.name != null && obj.constructor.name === type5.name;
      }
      function numberIsNaN(obj) {
        return obj !== obj;
      }
    })(buffer);
    (function(module2, exports3) {
      var buffer$1 = buffer;
      var Buffer3 = buffer$1.Buffer;
      function copyProps(src2, dst) {
        for (var key2 in src2) {
          dst[key2] = src2[key2];
        }
      }
      if (Buffer3.from && Buffer3.alloc && Buffer3.allocUnsafe && Buffer3.allocUnsafeSlow) {
        module2.exports = buffer$1;
      } else {
        copyProps(buffer$1, exports3);
        exports3.Buffer = SafeBuffer;
      }
      function SafeBuffer(arg, encodingOrOffset, length) {
        return Buffer3(arg, encodingOrOffset, length);
      }
      copyProps(Buffer3, SafeBuffer);
      SafeBuffer.from = function(arg, encodingOrOffset, length) {
        if (typeof arg === "number") {
          throw new TypeError("Argument must not be a number");
        }
        return Buffer3(arg, encodingOrOffset, length);
      };
      SafeBuffer.alloc = function(size, fill, encoding) {
        if (typeof size !== "number") {
          throw new TypeError("Argument must be a number");
        }
        var buf = Buffer3(size);
        if (fill !== void 0) {
          if (typeof encoding === "string") {
            buf.fill(fill, encoding);
          } else {
            buf.fill(fill);
          }
        } else {
          buf.fill(0);
        }
        return buf;
      };
      SafeBuffer.allocUnsafe = function(size) {
        if (typeof size !== "number") {
          throw new TypeError("Argument must be a number");
        }
        return Buffer3(size);
      };
      SafeBuffer.allocUnsafeSlow = function(size) {
        if (typeof size !== "number") {
          throw new TypeError("Argument must be a number");
        }
        return buffer$1.SlowBuffer(size);
      };
    })(safeBuffer, safeBuffer.exports);
    (function(exports3) {
      var fs2 = require$$0$8;
      var path2 = require$$1$1;
      var SafeBuffer = safeBuffer.exports;
      Object.defineProperty(exports3, "commentRegex", {
        get: function getCommentRegex() {
          return /^\s*\/(?:\/|\*)[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/mg;
        }
      });
      Object.defineProperty(exports3, "mapFileCommentRegex", {
        get: function getMapFileCommentRegex() {
          return /(?:\/\/[@#][ \t]+sourceMappingURL=([^\s'"`]+?)[ \t]*$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^\*]+?)[ \t]*(?:\*\/){1}[ \t]*$)/mg;
        }
      });
      function decodeBase64(base642) {
        return SafeBuffer.Buffer.from(base642, "base64").toString();
      }
      function stripComment(sm) {
        return sm.split(",").pop();
      }
      function readFromFileMap(sm, dir3) {
        var r2 = exports3.mapFileCommentRegex.exec(sm);
        var filename = r2[1] || r2[2];
        var filepath = path2.resolve(dir3, filename);
        try {
          return fs2.readFileSync(filepath, "utf8");
        } catch (e2) {
          throw new Error("An error occurred while trying to read the map file at " + filepath + "\n" + e2);
        }
      }
      function Converter(sm, opts) {
        opts = opts || {};
        if (opts.isFileComment)
          sm = readFromFileMap(sm, opts.commentFileDir);
        if (opts.hasComment)
          sm = stripComment(sm);
        if (opts.isEncoded)
          sm = decodeBase64(sm);
        if (opts.isJSON || opts.isEncoded)
          sm = JSON.parse(sm);
        this.sourcemap = sm;
      }
      Converter.prototype.toJSON = function(space) {
        return JSON.stringify(this.sourcemap, null, space);
      };
      Converter.prototype.toBase64 = function() {
        var json = this.toJSON();
        return SafeBuffer.Buffer.from(json, "utf8").toString("base64");
      };
      Converter.prototype.toComment = function(options) {
        var base642 = this.toBase64();
        var data3 = "sourceMappingURL=data:application/json;charset=utf-8;base64," + base642;
        return options && options.multiline ? "/*# " + data3 + " */" : "//# " + data3;
      };
      Converter.prototype.toObject = function() {
        return JSON.parse(this.toJSON());
      };
      Converter.prototype.addProperty = function(key2, value) {
        if (this.sourcemap.hasOwnProperty(key2))
          throw new Error('property "' + key2 + '" already exists on the sourcemap, use set property instead');
        return this.setProperty(key2, value);
      };
      Converter.prototype.setProperty = function(key2, value) {
        this.sourcemap[key2] = value;
        return this;
      };
      Converter.prototype.getProperty = function(key2) {
        return this.sourcemap[key2];
      };
      exports3.fromObject = function(obj) {
        return new Converter(obj);
      };
      exports3.fromJSON = function(json) {
        return new Converter(json, {
          isJSON: true
        });
      };
      exports3.fromBase64 = function(base642) {
        return new Converter(base642, {
          isEncoded: true
        });
      };
      exports3.fromComment = function(comment) {
        comment = comment.replace(/^\/\*/g, "//").replace(/\*\/$/g, "");
        return new Converter(comment, {
          isEncoded: true,
          hasComment: true
        });
      };
      exports3.fromMapFileComment = function(comment, dir3) {
        return new Converter(comment, {
          commentFileDir: dir3,
          isFileComment: true,
          isJSON: true
        });
      };
      exports3.fromSource = function(content) {
        var m2 = content.match(exports3.commentRegex);
        return m2 ? exports3.fromComment(m2.pop()) : null;
      };
      exports3.fromMapFileSource = function(content, dir3) {
        var m2 = content.match(exports3.mapFileCommentRegex);
        return m2 ? exports3.fromMapFileComment(m2.pop(), dir3) : null;
      };
      exports3.removeComments = function(src2) {
        return src2.replace(exports3.commentRegex, "");
      };
      exports3.removeMapFileComments = function(src2) {
        return src2.replace(exports3.mapFileCommentRegex, "");
      };
      exports3.generateMapFileComment = function(file2, options) {
        var data3 = "sourceMappingURL=" + file2;
        return options && options.multiline ? "/*# " + data3 + " */" : "//# " + data3;
      };
    })(convertSourceMap);
    var pluginNameMap = {
      asyncDoExpressions: {
        syntax: {
          name: "@babel/plugin-syntax-async-do-expressions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-do-expressions"
        }
      },
      classProperties: {
        syntax: {
          name: "@babel/plugin-syntax-class-properties",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
        },
        transform: {
          name: "@babel/plugin-proposal-class-properties",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-class-properties"
        }
      },
      classPrivateProperties: {
        syntax: {
          name: "@babel/plugin-syntax-class-properties",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
        },
        transform: {
          name: "@babel/plugin-proposal-class-properties",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-class-properties"
        }
      },
      classPrivateMethods: {
        syntax: {
          name: "@babel/plugin-syntax-class-properties",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
        },
        transform: {
          name: "@babel/plugin-proposal-private-methods",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-private-methods"
        }
      },
      classStaticBlock: {
        syntax: {
          name: "@babel/plugin-syntax-class-static-block",
          url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-syntax-class-static-block"
        },
        transform: {
          name: "@babel/plugin-proposal-class-static-block",
          url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-proposal-class-static-block"
        }
      },
      decimal: {
        syntax: {
          name: "@babel/plugin-syntax-decimal",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decimal"
        }
      },
      decorators: {
        syntax: {
          name: "@babel/plugin-syntax-decorators",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decorators"
        },
        transform: {
          name: "@babel/plugin-proposal-decorators",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-decorators"
        }
      },
      doExpressions: {
        syntax: {
          name: "@babel/plugin-syntax-do-expressions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-do-expressions"
        },
        transform: {
          name: "@babel/plugin-proposal-do-expressions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-do-expressions"
        }
      },
      dynamicImport: {
        syntax: {
          name: "@babel/plugin-syntax-dynamic-import",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-dynamic-import"
        }
      },
      exportDefaultFrom: {
        syntax: {
          name: "@babel/plugin-syntax-export-default-from",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-default-from"
        },
        transform: {
          name: "@babel/plugin-proposal-export-default-from",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-export-default-from"
        }
      },
      exportNamespaceFrom: {
        syntax: {
          name: "@babel/plugin-syntax-export-namespace-from",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-namespace-from"
        },
        transform: {
          name: "@babel/plugin-proposal-export-namespace-from",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-export-namespace-from"
        }
      },
      flow: {
        syntax: {
          name: "@babel/plugin-syntax-flow",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-flow"
        },
        transform: {
          name: "@babel/preset-flow",
          url: "https://github.com/babel/babel/tree/main/packages/babel-preset-flow"
        }
      },
      functionBind: {
        syntax: {
          name: "@babel/plugin-syntax-function-bind",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-bind"
        },
        transform: {
          name: "@babel/plugin-proposal-function-bind",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-bind"
        }
      },
      functionSent: {
        syntax: {
          name: "@babel/plugin-syntax-function-sent",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-sent"
        },
        transform: {
          name: "@babel/plugin-proposal-function-sent",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-sent"
        }
      },
      importMeta: {
        syntax: {
          name: "@babel/plugin-syntax-import-meta",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-meta"
        }
      },
      jsx: {
        syntax: {
          name: "@babel/plugin-syntax-jsx",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-jsx"
        },
        transform: {
          name: "@babel/preset-react",
          url: "https://github.com/babel/babel/tree/main/packages/babel-preset-react"
        }
      },
      importAssertions: {
        syntax: {
          name: "@babel/plugin-syntax-import-assertions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-assertions"
        }
      },
      moduleStringNames: {
        syntax: {
          name: "@babel/plugin-syntax-module-string-names",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-module-string-names"
        }
      },
      numericSeparator: {
        syntax: {
          name: "@babel/plugin-syntax-numeric-separator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-numeric-separator"
        },
        transform: {
          name: "@babel/plugin-proposal-numeric-separator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-numeric-separator"
        }
      },
      optionalChaining: {
        syntax: {
          name: "@babel/plugin-syntax-optional-chaining",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-chaining"
        },
        transform: {
          name: "@babel/plugin-proposal-optional-chaining",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-optional-chaining"
        }
      },
      pipelineOperator: {
        syntax: {
          name: "@babel/plugin-syntax-pipeline-operator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-pipeline-operator"
        },
        transform: {
          name: "@babel/plugin-proposal-pipeline-operator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-pipeline-operator"
        }
      },
      privateIn: {
        syntax: {
          name: "@babel/plugin-syntax-private-property-in-object",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-private-property-in-object"
        },
        transform: {
          name: "@babel/plugin-proposal-private-property-in-object",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-private-property-in-object"
        }
      },
      recordAndTuple: {
        syntax: {
          name: "@babel/plugin-syntax-record-and-tuple",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-record-and-tuple"
        }
      },
      regexpUnicodeSets: {
        syntax: {
          name: "@babel/plugin-syntax-unicode-sets-regex",
          url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-syntax-unicode-sets-regex/README.md"
        },
        transform: {
          name: "@babel/plugin-proposal-unicode-sets-regex",
          url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-proposalunicode-sets-regex/README.md"
        }
      },
      throwExpressions: {
        syntax: {
          name: "@babel/plugin-syntax-throw-expressions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-throw-expressions"
        },
        transform: {
          name: "@babel/plugin-proposal-throw-expressions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-throw-expressions"
        }
      },
      typescript: {
        syntax: {
          name: "@babel/plugin-syntax-typescript",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-typescript"
        },
        transform: {
          name: "@babel/preset-typescript",
          url: "https://github.com/babel/babel/tree/main/packages/babel-preset-typescript"
        }
      },
      asyncGenerators: {
        syntax: {
          name: "@babel/plugin-syntax-async-generators",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-generators"
        },
        transform: {
          name: "@babel/plugin-proposal-async-generator-functions",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-async-generator-functions"
        }
      },
      logicalAssignment: {
        syntax: {
          name: "@babel/plugin-syntax-logical-assignment-operators",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-logical-assignment-operators"
        },
        transform: {
          name: "@babel/plugin-proposal-logical-assignment-operators",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-logical-assignment-operators"
        }
      },
      nullishCoalescingOperator: {
        syntax: {
          name: "@babel/plugin-syntax-nullish-coalescing-operator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-nullish-coalescing-operator"
        },
        transform: {
          name: "@babel/plugin-proposal-nullish-coalescing-operator",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-nullish-coalescing-opearator"
        }
      },
      objectRestSpread: {
        syntax: {
          name: "@babel/plugin-syntax-object-rest-spread",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-object-rest-spread"
        },
        transform: {
          name: "@babel/plugin-proposal-object-rest-spread",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-object-rest-spread"
        }
      },
      optionalCatchBinding: {
        syntax: {
          name: "@babel/plugin-syntax-optional-catch-binding",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-catch-binding"
        },
        transform: {
          name: "@babel/plugin-proposal-optional-catch-binding",
          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-optional-catch-binding"
        }
      }
    };
    pluginNameMap.privateIn.syntax = pluginNameMap.privateIn.transform;
    var getNameURLCombination = function getNameURLCombination2(_ref3) {
      var name2 = _ref3.name, url2 = _ref3.url;
      return name2 + " (" + url2 + ")";
    };
    function generateMissingPluginMessage(missingPluginName, loc, codeFrame) {
      var helpMessage = "Support for the experimental syntax '" + missingPluginName + "' isn't currently enabled " + ("(" + loc.line + ":" + (loc.column + 1) + "):\n\n") + codeFrame;
      var pluginInfo = pluginNameMap[missingPluginName];
      if (pluginInfo) {
        var syntaxPlugin = pluginInfo.syntax, transformPlugin = pluginInfo.transform;
        if (syntaxPlugin) {
          var syntaxPluginInfo = getNameURLCombination(syntaxPlugin);
          if (transformPlugin) {
            var transformPluginInfo = getNameURLCombination(transformPlugin);
            var sectionType = transformPlugin.name.startsWith("@babel/plugin") ? "plugins" : "presets";
            helpMessage += "\n\nAdd " + transformPluginInfo + " to the '" + sectionType + "' section of your Babel config to enable transformation.\nIf you want to leave it as-is, add " + syntaxPluginInfo + " to the 'plugins' section to enable parsing.";
          } else {
            helpMessage += "\n\nAdd " + syntaxPluginInfo + " to the 'plugins' section of your Babel config to enable parsing.";
          }
        }
      }
      return helpMessage;
    }
    var _marked$2 = regenerator2.mark(parser$1);
    function parser$1(pluginPasses, _ref3, code3) {
      var parserOpts, _ref$highlightCode, highlightCode, _ref$filename, filename, results, _iterator2, _step2, plugins2, _iterator22, _step22, plugin2, parserOverride, ast3, loc, missingPlugin, codeFrame;
      return regenerator2.wrap(function parser$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              parserOpts = _ref3.parserOpts, _ref$highlightCode = _ref3.highlightCode, highlightCode = _ref$highlightCode === void 0 ? true : _ref$highlightCode, _ref$filename = _ref3.filename, filename = _ref$filename === void 0 ? "unknown" : _ref$filename;
              _context.prev = 1;
              results = [];
              for (_iterator2 = _createForOfIteratorHelperLoose(pluginPasses); !(_step2 = _iterator2()).done; ) {
                plugins2 = _step2.value;
                for (_iterator22 = _createForOfIteratorHelperLoose(plugins2); !(_step22 = _iterator22()).done; ) {
                  plugin2 = _step22.value;
                  parserOverride = plugin2.parserOverride;
                  if (parserOverride) {
                    ast3 = parserOverride(code3, parserOpts, parse$5);
                    if (ast3 !== void 0)
                      results.push(ast3);
                  }
                }
              }
              if (!(results.length === 0)) {
                _context.next = 8;
                break;
              }
              return _context.abrupt("return", parse$5(code3, parserOpts));
            case 8:
              if (!(results.length === 1)) {
                _context.next = 13;
                break;
              }
              return _context.delegateYield([], "t0", 10);
            case 10:
              if (!(typeof results[0].then === "function")) {
                _context.next = 12;
                break;
              }
              throw new Error("You appear to be using an async parser plugin, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
            case 12:
              return _context.abrupt("return", results[0]);
            case 13:
              throw new Error("More than one plugin attempted to override parsing.");
            case 16:
              _context.prev = 16;
              _context.t1 = _context["catch"](1);
              if (_context.t1.code === "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED") {
                _context.t1.message += "\nConsider renaming the file to '.mjs', or setting sourceType:module or sourceType:unambiguous in your Babel config for this file.";
              }
              loc = _context.t1.loc, missingPlugin = _context.t1.missingPlugin;
              if (loc) {
                codeFrame = codeFrameColumns(code3, {
                  start: {
                    line: loc.line,
                    column: loc.column + 1
                  }
                }, {
                  highlightCode
                });
                if (missingPlugin) {
                  _context.t1.message = filename + ": " + generateMissingPluginMessage(missingPlugin[0], loc, codeFrame);
                } else {
                  _context.t1.message = filename + ": " + _context.t1.message + "\n\n" + codeFrame;
                }
                _context.t1.code = "BABEL_PARSE_ERROR";
              }
              throw _context.t1;
            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$2, null, [[1, 16]]);
    }
    var serialized = "$$ babel internal serialized type" + Math.random();
    function serialize(key2, value) {
      var _ref3;
      if (typeof value !== "bigint")
        return value;
      return _ref3 = {}, _ref3[serialized] = "BigInt", _ref3.value = value.toString(), _ref3;
    }
    function revive(key2, value) {
      if (!value || typeof value !== "object")
        return value;
      if (value[serialized] !== "BigInt")
        return value;
      return BigInt(value.value);
    }
    function cloneDeep(value) {
      return JSON.parse(JSON.stringify(value, serialize), revive);
    }
    var _marked$1 = regenerator2.mark(normalizeFile);
    var file = file$2, traverseFast = traverseFast$2;
    var debug$2 = buildDebug("babel:transform:file");
    var LARGE_INPUT_SOURCEMAP_THRESHOLD = 1e6;
    function normalizeFile(pluginPasses, options, code3, ast3) {
      var inputMap, lastComment, _lastComment, match, inputMapContent;
      return regenerator2.wrap(function normalizeFile$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              code3 = "" + (code3 || "");
              if (!ast3) {
                _context.next = 11;
                break;
              }
              if (!(ast3.type === "Program")) {
                _context.next = 6;
                break;
              }
              ast3 = file(ast3, [], []);
              _context.next = 8;
              break;
            case 6:
              if (!(ast3.type !== "File")) {
                _context.next = 8;
                break;
              }
              throw new Error("AST root must be a Program or File node");
            case 8:
              if (options.cloneInputAst) {
                ast3 = cloneDeep(ast3);
              }
              _context.next = 13;
              break;
            case 11:
              return _context.delegateYield(parser$1(pluginPasses, options, code3), "t0", 12);
            case 12:
              ast3 = _context.t0;
            case 13:
              inputMap = null;
              if (options.inputSourceMap !== false) {
                if (typeof options.inputSourceMap === "object") {
                  inputMap = convertSourceMap.fromObject(options.inputSourceMap);
                }
                if (!inputMap) {
                  lastComment = extractComments(INLINE_SOURCEMAP_REGEX, ast3);
                  if (lastComment) {
                    try {
                      inputMap = convertSourceMap.fromComment(lastComment);
                    } catch (err) {
                      debug$2("discarding unknown inline input sourcemap", err);
                    }
                  }
                }
                if (!inputMap) {
                  _lastComment = extractComments(EXTERNAL_SOURCEMAP_REGEX, ast3);
                  if (typeof options.filename === "string" && _lastComment) {
                    try {
                      match = EXTERNAL_SOURCEMAP_REGEX.exec(_lastComment);
                      inputMapContent = fs.readFileSync(path$1.resolve(path$1.dirname(options.filename), match[1]));
                      if (inputMapContent.length > LARGE_INPUT_SOURCEMAP_THRESHOLD) {
                        debug$2("skip merging input map > 1 MB");
                      } else {
                        inputMap = convertSourceMap.fromJSON(inputMapContent);
                      }
                    } catch (err) {
                      debug$2("discarding unknown file input sourcemap", err);
                    }
                  } else if (_lastComment) {
                    debug$2("discarding un-loadable file input sourcemap");
                  }
                }
              }
              return _context.abrupt("return", new File(options, {
                code: code3,
                ast: ast3,
                inputMap
              }));
            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _marked$1);
    }
    var INLINE_SOURCEMAP_REGEX = /^[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/;
    var EXTERNAL_SOURCEMAP_REGEX = /^[@#][ \t]+sourceMappingURL=([^\s'"`]+)[ \t]*$/;
    function extractCommentsFromList(regex2, comments, lastComment) {
      if (comments) {
        comments = comments.filter(function(_ref3) {
          var value = _ref3.value;
          if (regex2.test(value)) {
            lastComment = value;
            return false;
          }
          return true;
        });
      }
      return [comments, lastComment];
    }
    function extractComments(regex2, ast3) {
      var lastComment = null;
      traverseFast(ast3, function(node2) {
        var _extractCommentsFromL = extractCommentsFromList(regex2, node2.leadingComments, lastComment);
        var _extractCommentsFromL2 = _slicedToArray$12(_extractCommentsFromL, 2);
        node2.leadingComments = _extractCommentsFromL2[0];
        lastComment = _extractCommentsFromL2[1];
        var _extractCommentsFromL3 = extractCommentsFromList(regex2, node2.innerComments, lastComment);
        var _extractCommentsFromL4 = _slicedToArray$12(_extractCommentsFromL3, 2);
        node2.innerComments = _extractCommentsFromL4[0];
        lastComment = _extractCommentsFromL4[1];
        var _extractCommentsFromL5 = extractCommentsFromList(regex2, node2.trailingComments, lastComment);
        var _extractCommentsFromL6 = _slicedToArray$12(_extractCommentsFromL5, 2);
        node2.trailingComments = _extractCommentsFromL6[0];
        lastComment = _extractCommentsFromL6[1];
      });
      return lastComment;
    }
    var traceMapping_umd = { exports: {} };
    var resolveUri_umd = { exports: {} };
    var hasRequiredResolveUri_umd;
    function requireResolveUri_umd() {
      if (hasRequiredResolveUri_umd)
        return resolveUri_umd.exports;
      hasRequiredResolveUri_umd = 1;
      (function(module2, exports3) {
        (function(global2, factory) {
          module2.exports = factory();
        })(commonjsGlobal$1, function() {
          var schemeRegex = /^[\w+.-]+:\/\//;
          var urlRegex2 = /^([\w+.-]+:)\/\/([^@]*@)?([^:/]*)(:\d+)?(\/[^#?]*)?/;
          function isAbsoluteUrl(input) {
            return schemeRegex.test(input);
          }
          function isSchemeRelativeUrl(input) {
            return input.startsWith("//");
          }
          function isAbsolutePath(input) {
            return input.startsWith("/");
          }
          function parseAbsoluteUrl(input) {
            var match = urlRegex2.exec(input);
            return {
              scheme: match[1],
              user: match[2] || "",
              host: match[3],
              port: match[4] || "",
              path: match[5] || "/",
              relativePath: false
            };
          }
          function parseUrl(input) {
            if (isSchemeRelativeUrl(input)) {
              var url2 = parseAbsoluteUrl("http:" + input);
              url2.scheme = "";
              return url2;
            }
            if (isAbsolutePath(input)) {
              var _url = parseAbsoluteUrl("http://foo.com" + input);
              _url.scheme = "";
              _url.host = "";
              return _url;
            }
            if (!isAbsoluteUrl(input)) {
              var _url2 = parseAbsoluteUrl("http://foo.com/" + input);
              _url2.scheme = "";
              _url2.host = "";
              _url2.relativePath = true;
              return _url2;
            }
            return parseAbsoluteUrl(input);
          }
          function stripPathFilename(path2) {
            if (path2.endsWith("/.."))
              return path2;
            var index3 = path2.lastIndexOf("/");
            return path2.slice(0, index3 + 1);
          }
          function mergePaths(url2, base2) {
            if (!url2.relativePath)
              return;
            normalizePath(base2);
            if (url2.path === "/") {
              url2.path = base2.path;
            } else {
              url2.path = stripPathFilename(base2.path) + url2.path;
            }
            url2.relativePath = base2.relativePath;
          }
          function normalizePath(url2) {
            var relativePath = url2.relativePath;
            var pieces = url2.path.split("/");
            var pointer = 1;
            var positive = 0;
            var addTrailingSlash = false;
            for (var i2 = 1; i2 < pieces.length; i2++) {
              var piece = pieces[i2];
              if (!piece) {
                addTrailingSlash = true;
                continue;
              }
              addTrailingSlash = false;
              if (piece === ".")
                continue;
              if (piece === "..") {
                if (positive) {
                  addTrailingSlash = true;
                  positive--;
                  pointer--;
                } else if (relativePath) {
                  pieces[pointer++] = piece;
                }
                continue;
              }
              pieces[pointer++] = piece;
              positive++;
            }
            var path2 = "";
            for (var _i3 = 1; _i3 < pointer; _i3++) {
              path2 += "/" + pieces[_i3];
            }
            if (!path2 || addTrailingSlash && !path2.endsWith("/..")) {
              path2 += "/";
            }
            url2.path = path2;
          }
          function resolve2(input, base2) {
            if (!input && !base2)
              return "";
            var url2 = parseUrl(input);
            if (base2 && !url2.scheme) {
              var baseUrl = parseUrl(base2);
              url2.scheme = baseUrl.scheme;
              if (!url2.host || baseUrl.scheme === "file:") {
                url2.user = baseUrl.user;
                url2.host = baseUrl.host;
                url2.port = baseUrl.port;
              }
              mergePaths(url2, baseUrl);
            }
            normalizePath(url2);
            if (url2.relativePath) {
              var path2 = url2.path.slice(1);
              if (!path2)
                return ".";
              var keepRelative = (base2 || input).startsWith(".");
              return !keepRelative || path2.startsWith(".") ? path2 : "./" + path2;
            }
            if (!url2.scheme && !url2.host)
              return url2.path;
            return url2.scheme + "//" + url2.user + url2.host + url2.port + url2.path;
          }
          return resolve2;
        });
      })(resolveUri_umd);
      return resolveUri_umd.exports;
    }
    (function(module2, exports3) {
      (function(global2, factory) {
        factory(exports3, requireSourcemapCodec_umd(), requireResolveUri_umd());
      })(commonjsGlobal$1, function(exports4, sourcemapCodec, resolveUri) {
        function _interopDefaultLegacy(e2) {
          return e2 && typeof e2 === "object" && "default" in e2 ? e2 : {
            "default": e2
          };
        }
        var resolveUri__default = _interopDefaultLegacy(resolveUri);
        function resolve2(input, base2) {
          if (base2 && !base2.endsWith("/"))
            base2 += "/";
          return resolveUri__default["default"](input, base2);
        }
        function stripFilename(path2) {
          if (!path2)
            return "";
          var index3 = path2.lastIndexOf("/");
          return path2.slice(0, index3 + 1);
        }
        var COLUMN = 0;
        var SOURCES_INDEX = 1;
        var SOURCE_LINE = 2;
        var SOURCE_COLUMN = 3;
        var NAMES_INDEX = 4;
        var REV_GENERATED_LINE = 1;
        var REV_GENERATED_COLUMN = 2;
        function maybeSort(mappings2, owned) {
          var unsortedIndex = nextUnsortedSegmentLine(mappings2, 0);
          if (unsortedIndex === mappings2.length)
            return mappings2;
          if (!owned)
            mappings2 = mappings2.slice();
          for (var i2 = unsortedIndex; i2 < mappings2.length; i2 = nextUnsortedSegmentLine(mappings2, i2 + 1)) {
            mappings2[i2] = sortSegments(mappings2[i2], owned);
          }
          return mappings2;
        }
        function nextUnsortedSegmentLine(mappings2, start2) {
          for (var i2 = start2; i2 < mappings2.length; i2++) {
            if (!isSorted(mappings2[i2]))
              return i2;
          }
          return mappings2.length;
        }
        function isSorted(line) {
          for (var j = 1; j < line.length; j++) {
            if (line[j][COLUMN] < line[j - 1][COLUMN]) {
              return false;
            }
          }
          return true;
        }
        function sortSegments(line, owned) {
          if (!owned)
            line = line.slice();
          return line.sort(sortComparator);
        }
        function sortComparator(a, b2) {
          return a[COLUMN] - b2[COLUMN];
        }
        var found = false;
        function binarySearch2(haystack, needle, low, high) {
          while (low <= high) {
            var mid = low + (high - low >> 1);
            var cmp2 = haystack[mid][COLUMN] - needle;
            if (cmp2 === 0) {
              found = true;
              return mid;
            }
            if (cmp2 < 0) {
              low = mid + 1;
            } else {
              high = mid - 1;
            }
          }
          found = false;
          return low - 1;
        }
        function upperBound(haystack, needle, index3) {
          for (var i2 = index3 + 1; i2 < haystack.length; i2++, index3++) {
            if (haystack[i2][COLUMN] !== needle)
              break;
          }
          return index3;
        }
        function lowerBound(haystack, needle, index3) {
          for (var i2 = index3 - 1; i2 >= 0; i2--, index3--) {
            if (haystack[i2][COLUMN] !== needle)
              break;
          }
          return index3;
        }
        function memoizedState() {
          return {
            lastKey: -1,
            lastNeedle: -1,
            lastIndex: -1
          };
        }
        function memoizedBinarySearch(haystack, needle, state, key2) {
          var lastKey = state.lastKey, lastNeedle = state.lastNeedle, lastIndex = state.lastIndex;
          var low = 0;
          var high = haystack.length - 1;
          if (key2 === lastKey) {
            if (needle === lastNeedle) {
              found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
              return lastIndex;
            }
            if (needle >= lastNeedle) {
              low = lastIndex === -1 ? 0 : lastIndex;
            } else {
              high = lastIndex;
            }
          }
          state.lastKey = key2;
          state.lastNeedle = needle;
          return state.lastIndex = binarySearch2(haystack, needle, low, high);
        }
        function buildBySources(decoded, memos) {
          var sources = memos.map(buildNullArray);
          for (var i2 = 0; i2 < decoded.length; i2++) {
            var line = decoded[i2];
            for (var j = 0; j < line.length; j++) {
              var seg = line[j];
              if (seg.length === 1)
                continue;
              var sourceIndex = seg[SOURCES_INDEX];
              var sourceLine = seg[SOURCE_LINE];
              var sourceColumn = seg[SOURCE_COLUMN];
              var originalSource = sources[sourceIndex];
              var originalLine = originalSource[sourceLine] || (originalSource[sourceLine] = []);
              var memo = memos[sourceIndex];
              var index3 = upperBound(originalLine, sourceColumn, memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine));
              insert(originalLine, memo.lastIndex = index3 + 1, [sourceColumn, i2, seg[COLUMN]]);
            }
          }
          return sources;
        }
        function insert(array4, index3, value) {
          for (var i2 = array4.length; i2 > index3; i2--) {
            array4[i2] = array4[i2 - 1];
          }
          array4[index3] = value;
        }
        function buildNullArray() {
          return {
            __proto__: null
          };
        }
        var AnyMap = function AnyMap2(map2, mapUrl) {
          var parsed = typeof map2 === "string" ? JSON.parse(map2) : map2;
          if (!("sections" in parsed))
            return new TraceMap(parsed, mapUrl);
          var mappings2 = [];
          var sources = [];
          var sourcesContent = [];
          var names2 = [];
          var sections = parsed.sections;
          var i2 = 0;
          for (; i2 < sections.length - 1; i2++) {
            var no = sections[i2 + 1].offset;
            addSection(sections[i2], mapUrl, mappings2, sources, sourcesContent, names2, no.line, no.column);
          }
          if (sections.length > 0) {
            addSection(sections[i2], mapUrl, mappings2, sources, sourcesContent, names2, -1, -1);
          }
          var joined = {
            version: 3,
            file: parsed.file,
            names: names2,
            sources,
            sourcesContent,
            mappings: mappings2
          };
          return exports4.presortedDecodedMap(joined);
        };
        function addSection(section, mapUrl, mappings2, sources, sourcesContent, names2, stopLine, stopColumn) {
          var offset3 = section.offset, map2 = section.map;
          var lineOffset = offset3.line, columnOffset = offset3.column;
          for (var i2 = mappings2.length; i2 <= lineOffset; i2++) {
            mappings2.push([]);
          }
          var trace = AnyMap(map2, mapUrl);
          var sourcesOffset = sources.length;
          var namesOffset = names2.length;
          var decoded = exports4.decodedMappings(trace);
          var resolvedSources = trace.resolvedSources;
          append(sources, resolvedSources);
          append(sourcesContent, trace.sourcesContent || fillSourcesContent(resolvedSources.length));
          append(names2, trace.names);
          var len3 = stopLine === -1 ? decoded.length : Math.min(decoded.length, stopLine + 1);
          for (var _i3 = 0; _i3 < len3; _i3++) {
            var line = decoded[_i3];
            var out2 = _i3 === 0 ? mappings2[lineOffset] : mappings2[lineOffset + _i3] = [];
            var cOffset = _i3 === 0 ? columnOffset : 0;
            for (var j = 0; j < line.length; j++) {
              var seg = line[j];
              var column = cOffset + seg[COLUMN];
              if (_i3 === stopLine && column >= stopColumn)
                break;
              if (seg.length === 1) {
                out2.push([column]);
                continue;
              }
              var sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
              var sourceLine = seg[SOURCE_LINE];
              var sourceColumn = seg[SOURCE_COLUMN];
              if (seg.length === 4) {
                out2.push([column, sourcesIndex, sourceLine, sourceColumn]);
                continue;
              }
              out2.push([column, sourcesIndex, sourceLine, sourceColumn, namesOffset + seg[NAMES_INDEX]]);
            }
          }
        }
        function append(arr, other) {
          for (var i2 = 0; i2 < other.length; i2++) {
            arr.push(other[i2]);
          }
        }
        function fillSourcesContent(len3) {
          var sourcesContent = [];
          for (var i2 = 0; i2 < len3; i2++) {
            sourcesContent[i2] = null;
          }
          return sourcesContent;
        }
        var INVALID_ORIGINAL_MAPPING = Object.freeze({
          source: null,
          line: null,
          column: null,
          name: null
        });
        var INVALID_GENERATED_MAPPING = Object.freeze({
          line: null,
          column: null
        });
        var LINE_GTR_ZERO = "`line` must be greater than 0 (lines start at line 1)";
        var COL_GTR_EQ_ZERO = "`column` must be greater than or equal to 0 (columns start at column 0)";
        var LEAST_UPPER_BOUND = -1;
        var GREATEST_LOWER_BOUND = 1;
        exports4.encodedMappings = void 0;
        exports4.decodedMappings = void 0;
        exports4.traceSegment = void 0;
        exports4.originalPositionFor = void 0;
        exports4.generatedPositionFor = void 0;
        exports4.eachMapping = void 0;
        exports4.presortedDecodedMap = void 0;
        exports4.decodedMap = void 0;
        exports4.encodedMap = void 0;
        var TraceMap = _createClass2(function TraceMap2(map2, mapUrl) {
          this._decodedMemo = memoizedState();
          this._bySources = void 0;
          this._bySourceMemos = void 0;
          var isString2 = typeof map2 === "string";
          var parsed = isString2 ? JSON.parse(map2) : map2;
          var version3 = parsed.version, file2 = parsed.file, names2 = parsed.names, sourceRoot = parsed.sourceRoot, sources = parsed.sources, sourcesContent = parsed.sourcesContent;
          this.version = version3;
          this.file = file2;
          this.names = names2;
          this.sourceRoot = sourceRoot;
          this.sources = sources;
          this.sourcesContent = sourcesContent;
          if (sourceRoot || mapUrl) {
            var from2 = resolve2(sourceRoot || "", stripFilename(mapUrl));
            this.resolvedSources = sources.map(function(s) {
              return resolve2(s || "", from2);
            });
          } else {
            this.resolvedSources = sources.map(function(s) {
              return s || "";
            });
          }
          var mappings2 = parsed.mappings;
          if (typeof mappings2 === "string") {
            this._encoded = mappings2;
            this._decoded = void 0;
          } else {
            this._encoded = void 0;
            this._decoded = maybeSort(mappings2, isString2);
          }
        });
        (function() {
          exports4.encodedMappings = function(map2) {
            var _a2;
            return (_a2 = map2._encoded) !== null && _a2 !== void 0 ? _a2 : map2._encoded = sourcemapCodec.encode(map2._decoded);
          };
          exports4.decodedMappings = function(map2) {
            return map2._decoded || (map2._decoded = sourcemapCodec.decode(map2._encoded));
          };
          exports4.traceSegment = function(map2, line, column) {
            var decoded = exports4.decodedMappings(map2);
            if (line >= decoded.length)
              return null;
            return traceSegmentInternal(decoded[line], map2._decodedMemo, line, column, GREATEST_LOWER_BOUND);
          };
          exports4.originalPositionFor = function(map2, _ref3) {
            var line = _ref3.line, column = _ref3.column, bias = _ref3.bias;
            line--;
            if (line < 0)
              throw new Error(LINE_GTR_ZERO);
            if (column < 0)
              throw new Error(COL_GTR_EQ_ZERO);
            var decoded = exports4.decodedMappings(map2);
            if (line >= decoded.length)
              return INVALID_ORIGINAL_MAPPING;
            var segment = traceSegmentInternal(decoded[line], map2._decodedMemo, line, column, bias || GREATEST_LOWER_BOUND);
            if (segment == null)
              return INVALID_ORIGINAL_MAPPING;
            if (segment.length == 1)
              return INVALID_ORIGINAL_MAPPING;
            var names2 = map2.names, resolvedSources = map2.resolvedSources;
            return {
              source: resolvedSources[segment[SOURCES_INDEX]],
              line: segment[SOURCE_LINE] + 1,
              column: segment[SOURCE_COLUMN],
              name: segment.length === 5 ? names2[segment[NAMES_INDEX]] : null
            };
          };
          exports4.generatedPositionFor = function(map2, _ref22) {
            var source = _ref22.source, line = _ref22.line, column = _ref22.column, bias = _ref22.bias;
            line--;
            if (line < 0)
              throw new Error(LINE_GTR_ZERO);
            if (column < 0)
              throw new Error(COL_GTR_EQ_ZERO);
            var sources = map2.sources, resolvedSources = map2.resolvedSources;
            var sourceIndex = sources.indexOf(source);
            if (sourceIndex === -1)
              sourceIndex = resolvedSources.indexOf(source);
            if (sourceIndex === -1)
              return INVALID_GENERATED_MAPPING;
            var generated2 = map2._bySources || (map2._bySources = buildBySources(exports4.decodedMappings(map2), map2._bySourceMemos = sources.map(memoizedState)));
            var memos = map2._bySourceMemos;
            var segments = generated2[sourceIndex][line];
            if (segments == null)
              return INVALID_GENERATED_MAPPING;
            var segment = traceSegmentInternal(segments, memos[sourceIndex], line, column, bias || GREATEST_LOWER_BOUND);
            if (segment == null)
              return INVALID_GENERATED_MAPPING;
            return {
              line: segment[REV_GENERATED_LINE] + 1,
              column: segment[REV_GENERATED_COLUMN]
            };
          };
          exports4.eachMapping = function(map2, cb2) {
            var decoded = exports4.decodedMappings(map2);
            var names2 = map2.names, resolvedSources = map2.resolvedSources;
            for (var i2 = 0; i2 < decoded.length; i2++) {
              var line = decoded[i2];
              for (var j = 0; j < line.length; j++) {
                var seg = line[j];
                var generatedLine = i2 + 1;
                var generatedColumn = seg[0];
                var source = null;
                var originalLine = null;
                var originalColumn = null;
                var name2 = null;
                if (seg.length !== 1) {
                  source = resolvedSources[seg[1]];
                  originalLine = seg[2] + 1;
                  originalColumn = seg[3];
                }
                if (seg.length === 5)
                  name2 = names2[seg[4]];
                cb2({
                  generatedLine,
                  generatedColumn,
                  source,
                  originalLine,
                  originalColumn,
                  name: name2
                });
              }
            }
          };
          exports4.presortedDecodedMap = function(map2, mapUrl) {
            var clone4 = Object.assign({}, map2);
            clone4.mappings = [];
            var tracer = new TraceMap(clone4, mapUrl);
            tracer._decoded = map2.mappings;
            return tracer;
          };
          exports4.decodedMap = function(map2) {
            return {
              version: 3,
              file: map2.file,
              names: map2.names,
              sourceRoot: map2.sourceRoot,
              sources: map2.sources,
              sourcesContent: map2.sourcesContent,
              mappings: exports4.decodedMappings(map2)
            };
          };
          exports4.encodedMap = function(map2) {
            return {
              version: 3,
              file: map2.file,
              names: map2.names,
              sourceRoot: map2.sourceRoot,
              sources: map2.sources,
              sourcesContent: map2.sourcesContent,
              mappings: exports4.encodedMappings(map2)
            };
          };
        })();
        function traceSegmentInternal(segments, memo, line, column, bias) {
          var index3 = memoizedBinarySearch(segments, column, memo, line);
          if (found) {
            index3 = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(segments, column, index3);
          } else if (bias === LEAST_UPPER_BOUND)
            index3++;
          if (index3 === -1 || index3 === segments.length)
            return null;
          return segments[index3];
        }
        exports4.AnyMap = AnyMap;
        exports4.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
        exports4.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
        exports4.TraceMap = TraceMap;
        Object.defineProperty(exports4, "__esModule", {
          value: true
        });
      });
    })(traceMapping_umd, traceMapping_umd.exports);
    var OriginalSource = function() {
      function OriginalSource2(source, content) {
        this.source = source;
        this.content = content;
      }
      var _proto = OriginalSource2.prototype;
      _proto.originalPositionFor = function originalPositionFor(line, column, name2) {
        return {
          column,
          line,
          name: name2,
          source: this.source,
          content: this.content
        };
      };
      return _createClass2(OriginalSource2);
    }();
    var put;
    var FastStringArray = _createClass2(function FastStringArray2() {
      this.indexes = /* @__PURE__ */ Object.create(null);
      this.array = [];
    });
    (function() {
      put = function put2(strarr, key2) {
        var array4 = strarr.array, indexes = strarr.indexes;
        var index3 = indexes[key2];
        if (index3 === void 0) {
          index3 = indexes[key2] = array4.length;
          array4.push(key2);
        }
        return index3;
      };
    })();
    var INVALID_MAPPING = void 0;
    var SOURCELESS_MAPPING = null;
    var traceMappings;
    var SourceMapTree = function() {
      function SourceMapTree2(map2, sources) {
        this.map = map2;
        this.sources = sources;
      }
      var _proto2 = SourceMapTree2.prototype;
      _proto2.originalPositionFor = function originalPositionFor(line, column, name2) {
        var segment = traceMapping_umd.exports.traceSegment(this.map, line, column);
        if (segment == null)
          return INVALID_MAPPING;
        if (segment.length === 1)
          return SOURCELESS_MAPPING;
        var source = this.sources[segment[1]];
        return source.originalPositionFor(segment[2], segment[3], segment.length === 5 ? this.map.names[segment[4]] : name2);
      };
      return _createClass2(SourceMapTree2);
    }();
    (function() {
      traceMappings = function traceMappings2(tree) {
        var mappings2 = [];
        var names2 = new FastStringArray();
        var sources = new FastStringArray();
        var sourcesContent = [];
        var rootSources = tree.sources, map2 = tree.map;
        var rootNames = map2.names;
        var rootMappings = traceMapping_umd.exports.decodedMappings(map2);
        var lastLineWithSegment = -1;
        for (var i2 = 0; i2 < rootMappings.length; i2++) {
          var segments = rootMappings[i2];
          var tracedSegments = [];
          var lastSourcesIndex = -1;
          var lastSourceLine = -1;
          var lastSourceColumn = -1;
          for (var j = 0; j < segments.length; j++) {
            var segment = segments[j];
            var traced = SOURCELESS_MAPPING;
            if (segment.length !== 1) {
              var _source = rootSources[segment[1]];
              traced = _source.originalPositionFor(segment[2], segment[3], segment.length === 5 ? rootNames[segment[4]] : "");
              if (traced === INVALID_MAPPING)
                continue;
            }
            var genCol = segment[0];
            if (traced === SOURCELESS_MAPPING) {
              if (lastSourcesIndex === -1) {
                continue;
              }
              lastSourcesIndex = lastSourceLine = lastSourceColumn = -1;
              tracedSegments.push([genCol]);
              continue;
            }
            var _traced = traced, column = _traced.column, line = _traced.line, name2 = _traced.name, content = _traced.content, source = _traced.source;
            var sourcesIndex = put(sources, source);
            sourcesContent[sourcesIndex] = content;
            if (lastSourcesIndex === sourcesIndex && lastSourceLine === line && lastSourceColumn === column) {
              continue;
            }
            lastLineWithSegment = i2;
            lastSourcesIndex = sourcesIndex;
            lastSourceLine = line;
            lastSourceColumn = column;
            tracedSegments.push(name2 ? [genCol, sourcesIndex, line, column, put(names2, name2)] : [genCol, sourcesIndex, line, column]);
          }
          mappings2.push(tracedSegments);
        }
        if (mappings2.length > lastLineWithSegment + 1) {
          mappings2.length = lastLineWithSegment + 1;
        }
        return traceMapping_umd.exports.presortedDecodedMap(Object.assign({}, tree.map, {
          mappings: mappings2,
          sourceRoot: void 0,
          names: names2.array,
          sources: sources.array,
          sourcesContent
        }));
      };
    })();
    function asArray(value) {
      if (Array.isArray(value))
        return value;
      return [value];
    }
    function buildSourceMapTree(input, loader2) {
      var maps = asArray(input).map(function(m2) {
        return new traceMapping_umd.exports.TraceMap(m2, "");
      });
      var map2 = maps.pop();
      for (var i2 = 0; i2 < maps.length; i2++) {
        if (maps[i2].sources.length > 1) {
          throw new Error("Transformation map " + i2 + " must have exactly one source file.\nDid you specify these with the most recent transformation maps first?");
        }
      }
      var tree = build$1(map2, "", loader2);
      for (var _i3 = maps.length - 1; _i3 >= 0; _i3--) {
        tree = new SourceMapTree(maps[_i3], [tree]);
      }
      return tree;
    }
    function build$1(map2, importer, loader2) {
      var resolvedSources = map2.resolvedSources, sourcesContent = map2.sourcesContent;
      var children = resolvedSources.map(function(sourceFile, i2) {
        var ctx = {
          importer,
          source: sourceFile || "",
          content: void 0
        };
        var sourceMap2 = loader2(ctx.source, ctx);
        var source = ctx.source, content = ctx.content;
        if (!sourceMap2) {
          var sourceContent = content !== void 0 ? content : sourcesContent ? sourcesContent[i2] : null;
          return new OriginalSource(source, sourceContent);
        }
        return build$1(new traceMapping_umd.exports.TraceMap(sourceMap2, source), source, loader2);
      });
      return new SourceMapTree(map2, children);
    }
    var SourceMap = function() {
      function SourceMap2(map2, options) {
        this.version = 3;
        this.file = map2.file;
        this.mappings = options.decodedMappings ? traceMapping_umd.exports.decodedMappings(map2) : traceMapping_umd.exports.encodedMappings(map2);
        this.names = map2.names;
        this.sourceRoot = map2.sourceRoot;
        this.sources = map2.sources;
        if (!options.excludeContent && "sourcesContent" in map2) {
          this.sourcesContent = map2.sourcesContent;
        }
      }
      var _proto3 = SourceMap2.prototype;
      _proto3.toString = function toString3() {
        return JSON.stringify(this);
      };
      return _createClass2(SourceMap2);
    }();
    function remapping(input, loader2, options) {
      var opts = typeof options === "object" ? options : {
        excludeContent: !!options,
        decodedMappings: false
      };
      var tree = buildSourceMapTree(input, loader2);
      return new SourceMap(traceMappings(tree), opts);
    }
    function mergeSourceMap(inputMap, map2, sourceFileName) {
      var source = sourceFileName.replace(/\\/g, "/");
      var found = false;
      var result = remapping(rootless(map2), function(s, ctx) {
        if (s === source && !found) {
          found = true;
          ctx.source = "";
          return rootless(inputMap);
        }
        return null;
      });
      if (typeof inputMap.sourceRoot === "string") {
        result.sourceRoot = inputMap.sourceRoot;
      }
      return Object.assign({}, result);
    }
    function rootless(map2) {
      return Object.assign({}, map2, {
        sourceRoot: null
      });
    }
    function generateCode(pluginPasses, file2) {
      var opts = file2.opts, ast3 = file2.ast, code3 = file2.code, inputMap = file2.inputMap;
      var generatorOpts = opts.generatorOpts;
      var results = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(pluginPasses), _step2; !(_step2 = _iterator2()).done; ) {
        var plugins2 = _step2.value;
        for (var _iterator22 = _createForOfIteratorHelperLoose(plugins2), _step22; !(_step22 = _iterator22()).done; ) {
          var plugin2 = _step22.value;
          var generatorOverride = plugin2.generatorOverride;
          if (generatorOverride) {
            var _result2 = generatorOverride(ast3, generatorOpts, code3, generate$12);
            if (_result2 !== void 0)
              results.push(_result2);
          }
        }
      }
      var result;
      if (results.length === 0) {
        result = generate$12(ast3, generatorOpts, code3);
      } else if (results.length === 1) {
        result = results[0];
        if (typeof result.then === "function") {
          throw new Error("You appear to be using an async codegen plugin, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
        }
      } else {
        throw new Error("More than one plugin attempted to override codegen.");
      }
      var _result = result, outputCode = _result.code, _result$decodedMap = _result.decodedMap, outputMap = _result$decodedMap === void 0 ? result.map : _result$decodedMap;
      if (outputMap) {
        if (inputMap) {
          outputMap = mergeSourceMap(inputMap.toObject(), outputMap, generatorOpts.sourceFileName);
        } else {
          outputMap = result.map;
        }
      }
      if (opts.sourceMaps === "inline" || opts.sourceMaps === "both") {
        outputCode += "\n" + convertSourceMap.fromObject(outputMap).toComment();
      }
      if (opts.sourceMaps === "inline") {
        outputMap = null;
      }
      return {
        outputCode,
        outputMap
      };
    }
    var _marked = regenerator2.mark(run$1), _marked2 = regenerator2.mark(transformFile$1);
    function run$1(config3, code3, ast3) {
      var file2, opts, _opts$filename, outputCode, outputMap, _generateCode, _opts$filename2;
      return regenerator2.wrap(function run$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(normalizeFile(config3.passes, normalizeOptions$4(config3), code3, ast3), "t0", 1);
            case 1:
              file2 = _context.t0;
              opts = file2.opts;
              _context.prev = 3;
              return _context.delegateYield(transformFile$1(file2, config3.passes), "t1", 5);
            case 5:
              _context.next = 12;
              break;
            case 7:
              _context.prev = 7;
              _context.t2 = _context["catch"](3);
              _context.t2.message = ((_opts$filename = opts.filename) != null ? _opts$filename : "unknown") + ": " + _context.t2.message;
              if (!_context.t2.code) {
                _context.t2.code = "BABEL_TRANSFORM_ERROR";
              }
              throw _context.t2;
            case 12:
              _context.prev = 12;
              if (opts.code !== false) {
                _generateCode = generateCode(config3.passes, file2);
                outputCode = _generateCode.outputCode;
                outputMap = _generateCode.outputMap;
              }
              _context.next = 21;
              break;
            case 16:
              _context.prev = 16;
              _context.t3 = _context["catch"](12);
              _context.t3.message = ((_opts$filename2 = opts.filename) != null ? _opts$filename2 : "unknown") + ": " + _context.t3.message;
              if (!_context.t3.code) {
                _context.t3.code = "BABEL_GENERATE_ERROR";
              }
              throw _context.t3;
            case 21:
              return _context.abrupt("return", {
                metadata: file2.metadata,
                options: opts,
                ast: opts.ast === true ? file2.ast : null,
                code: outputCode === void 0 ? null : outputCode,
                map: outputMap === void 0 ? null : outputMap,
                sourceType: file2.ast.program.sourceType,
                externalDependencies: flattenToSet(config3.externalDependencies)
              });
            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _marked, null, [[3, 7], [12, 16]]);
    }
    function transformFile$1(file2, pluginPasses) {
      var _iterator2, _step2, pluginPairs, passPairs, passes, visitors2, _iterator22, _step22, _plugin2, _pass2, _i3, _passPairs, _passPairs$_i, plugin2, pass, fn, result, visitor2, _i22, _passPairs2, _passPairs2$_i, _plugin3, _pass, _fn, _result;
      return regenerator2.wrap(function transformFile$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _iterator2 = _createForOfIteratorHelperLoose(pluginPasses);
            case 1:
              if ((_step2 = _iterator2()).done) {
                _context2.next = 35;
                break;
              }
              pluginPairs = _step2.value;
              passPairs = [];
              passes = [];
              visitors2 = [];
              for (_iterator22 = _createForOfIteratorHelperLoose(pluginPairs.concat([loadBlockHoistPlugin()])); !(_step22 = _iterator22()).done; ) {
                _plugin2 = _step22.value;
                _pass2 = new PluginPass(file2, _plugin2.key, _plugin2.options);
                passPairs.push([_plugin2, _pass2]);
                passes.push(_pass2);
                visitors2.push(_plugin2.visitor);
              }
              _i3 = 0, _passPairs = passPairs;
            case 8:
              if (!(_i3 < _passPairs.length)) {
                _context2.next = 19;
                break;
              }
              _passPairs$_i = _slicedToArray$12(_passPairs[_i3], 2), plugin2 = _passPairs$_i[0], pass = _passPairs$_i[1];
              fn = plugin2.pre;
              if (!fn) {
                _context2.next = 16;
                break;
              }
              result = fn.call(pass, file2);
              return _context2.delegateYield([], "t0", 14);
            case 14:
              if (!isThenable(result)) {
                _context2.next = 16;
                break;
              }
              throw new Error("You appear to be using an plugin with an async .pre, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
            case 16:
              _i3++;
              _context2.next = 8;
              break;
            case 19:
              visitor2 = traverse.visitors.merge(visitors2, passes, file2.opts.wrapPluginVisitorMethod);
              traverse(file2.ast, visitor2, file2.scope);
              _i22 = 0, _passPairs2 = passPairs;
            case 22:
              if (!(_i22 < _passPairs2.length)) {
                _context2.next = 33;
                break;
              }
              _passPairs2$_i = _slicedToArray$12(_passPairs2[_i22], 2), _plugin3 = _passPairs2$_i[0], _pass = _passPairs2$_i[1];
              _fn = _plugin3.post;
              if (!_fn) {
                _context2.next = 30;
                break;
              }
              _result = _fn.call(_pass, file2);
              return _context2.delegateYield([], "t1", 28);
            case 28:
              if (!isThenable(_result)) {
                _context2.next = 30;
                break;
              }
              throw new Error("You appear to be using an plugin with an async .post, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
            case 30:
              _i22++;
              _context2.next = 22;
              break;
            case 33:
              _context2.next = 1;
              break;
            case 35:
            case "end":
              return _context2.stop();
          }
        }
      }, _marked2);
    }
    function isThenable(val) {
      return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
    }
    var transformRunner = gensync(regenerator2.mark(function transform3(code3, opts) {
      var config3;
      return regenerator2.wrap(function transform$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(loadConfig(opts), "t0", 1);
            case 1:
              config3 = _context.t0;
              if (!(config3 === null)) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", null);
            case 4:
              return _context.delegateYield(run$1(config3, code3), "t1", 5);
            case 5:
              return _context.abrupt("return", _context.t1);
            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, transform3);
    }));
    var transform$3 = function transform3(code3, opts, callback) {
      if (typeof opts === "function") {
        callback = opts;
        opts = void 0;
      }
      if (callback === void 0)
        return transformRunner.sync(code3, opts);
      transformRunner.errback(code3, opts, callback);
    };
    var transformSync = transformRunner.sync;
    var transformAsync = transformRunner.async;
    var transformFile = function transformFile2(filename, opts, callback) {
      if (typeof opts === "function") {
        callback = opts;
      }
      callback(new Error("Transforming files is not supported in browsers"), null);
    };
    function transformFileSync() {
      throw new Error("Transforming files is not supported in browsers");
    }
    function transformFileAsync() {
      return Promise.reject(new Error("Transforming files is not supported in browsers"));
    }
    var transformFromAstRunner = gensync(regenerator2.mark(function _callee(ast3, code3, opts) {
      var config3;
      return regenerator2.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(loadConfig(opts), "t0", 1);
            case 1:
              config3 = _context.t0;
              if (!(config3 === null)) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", null);
            case 4:
              if (ast3) {
                _context.next = 6;
                break;
              }
              throw new Error("No AST given");
            case 6:
              return _context.delegateYield(run$1(config3, code3, ast3), "t1", 7);
            case 7:
              return _context.abrupt("return", _context.t1);
            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    var transformFromAst$1 = function transformFromAst2(ast3, code3, opts, callback) {
      if (typeof opts === "function") {
        callback = opts;
        opts = void 0;
      }
      if (callback === void 0) {
        return transformFromAstRunner.sync(ast3, code3, opts);
      }
      transformFromAstRunner.errback(ast3, code3, opts, callback);
    };
    var transformFromAstSync = transformFromAstRunner.sync;
    var transformFromAstAsync = transformFromAstRunner.async;
    var parseRunner = gensync(regenerator2.mark(function parse5(code3, opts) {
      var config3;
      return regenerator2.wrap(function parse$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.delegateYield(loadConfig(opts), "t0", 1);
            case 1:
              config3 = _context.t0;
              if (!(config3 === null)) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", null);
            case 4:
              return _context.delegateYield(parser$1(config3.passes, normalizeOptions$4(config3), code3), "t1", 5);
            case 5:
              return _context.abrupt("return", _context.t1);
            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, parse5);
    }));
    var parse$3 = function parse5(code3, opts, callback) {
      if (typeof opts === "function") {
        callback = opts;
        opts = void 0;
      }
      if (callback === void 0)
        return parseRunner.sync(code3, opts);
      parseRunner.errback(code3, opts, callback);
    };
    var parseSync = parseRunner.sync;
    var parseAsync = parseRunner.async;
    var version$3 = "7.17.10";
    var DEFAULT_EXTENSIONS = Object.freeze([".js", ".jsx", ".es6", ".es", ".mjs", ".cjs"]);
    var OptionManager2 = function() {
      function OptionManager3() {
      }
      var _proto = OptionManager3.prototype;
      _proto.init = function init3(opts) {
        return loadOptions(opts);
      };
      return _createClass2(OptionManager3);
    }();
    function Plugin(alias2) {
      throw new Error("The (" + alias2 + ") Babel 5 plugin is being run with an unsupported Babel version.");
    }
    function declare(builder2) {
      return function(api, options, dirname2) {
        var _clonedApi2;
        var clonedApi;
        for (var _i3 = 0, _Object$keys3 = Object.keys(apiPolyfills); _i3 < _Object$keys3.length; _i3++) {
          var _clonedApi;
          var name2 = _Object$keys3[_i3];
          if (api[name2])
            continue;
          clonedApi = (_clonedApi = clonedApi) != null ? _clonedApi : copyApiObject(api);
          clonedApi[name2] = apiPolyfills[name2](clonedApi);
        }
        return builder2((_clonedApi2 = clonedApi) != null ? _clonedApi2 : api, options || {}, dirname2);
      };
    }
    var apiPolyfills = {
      assertVersion: function assertVersion2(api) {
        return function(range3) {
          throwVersionError(range3, api.version);
        };
      },
      targets: function targets() {
        return function() {
          return {};
        };
      },
      assumption: function assumption() {
        return function() {
        };
      }
    };
    function copyApiObject(api) {
      var proto2 = null;
      if (typeof api.version === "string" && /^7\./.test(api.version)) {
        proto2 = Object.getPrototypeOf(api);
        if (proto2 && (!has$8(proto2, "version") || !has$8(proto2, "transform") || !has$8(proto2, "template") || !has$8(proto2, "types"))) {
          proto2 = null;
        }
      }
      return Object.assign({}, proto2, api);
    }
    function has$8(obj, key2) {
      return Object.prototype.hasOwnProperty.call(obj, key2);
    }
    function throwVersionError(range3, version3) {
      if (typeof range3 === "number") {
        if (!Number.isInteger(range3)) {
          throw new Error("Expected string or integer value.");
        }
        range3 = "^" + range3 + ".0.0-0";
      }
      if (typeof range3 !== "string") {
        throw new Error("Expected string or integer value.");
      }
      var limit = Error.stackTraceLimit;
      if (typeof limit === "number" && limit < 25) {
        Error.stackTraceLimit = 25;
      }
      var err;
      if (version3.slice(0, 2) === "7.") {
        err = new Error('Requires Babel "^7.0.0-beta.41", but was loaded with "' + version3 + `". You'll need to update your @babel/core version.`);
      } else {
        err = new Error('Requires Babel "' + range3 + '", but was loaded with "' + version3 + `". If you are sure you have a compatible version of @babel/core, it is likely that something in your build process is loading the wrong version. Inspect the stack trace of this error to look for the first entry that doesn't mention "@babel/core" or "babel-core" to see what is calling Babel.`);
      }
      if (typeof limit === "number") {
        Error.stackTraceLimit = limit;
      }
      throw Object.assign(err, {
        code: "BABEL_VERSION_UNSUPPORTED",
        version: version3,
        range: range3
      });
    }
    var src = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      declare
    });
    var externalHelpers = declare(function(api, options) {
      api.assertVersion(7);
      var _options$helperVersio = options.helperVersion, helperVersion = _options$helperVersio === void 0 ? "7.0.0-beta.0" : _options$helperVersio, _options$whitelist = options.whitelist, whitelist = _options$whitelist === void 0 ? false : _options$whitelist;
      if (whitelist !== false && (!Array.isArray(whitelist) || whitelist.some(function(w2) {
        return typeof w2 !== "string";
      }))) {
        throw new Error(".whitelist must be undefined, false, or an array of strings");
      }
      var helperWhitelist = whitelist ? new Set(whitelist) : null;
      return {
        name: "external-helpers",
        pre: function pre(file2) {
          file2.set("helperGenerator", function(name2) {
            if (file2.availableHelper && !file2.availableHelper(name2, helperVersion)) {
              return;
            }
            if (helperWhitelist && !helperWhitelist.has(name2))
              return;
            return memberExpression$b(identifier$j("babelHelpers"), identifier$j(name2));
          });
        }
      };
    });
    var lib$x = {};
    var require$$0$5 = /* @__PURE__ */ getAugmentedNamespace(src);
    Object.defineProperty(lib$x, "__esModule", {
      value: true
    });
    lib$x["default"] = void 0;
    var _helperPluginUtils$w = require$$0$5;
    var _default$w = (0, _helperPluginUtils$w.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-async-generators",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("asyncGenerators");
        }
      };
    });
    lib$x["default"] = _default$w;
    var lib$w = {};
    Object.defineProperty(lib$w, "__esModule", {
      value: true
    });
    lib$w["default"] = void 0;
    var _helperPluginUtils$v = require$$0$5;
    var _default$v = (0, _helperPluginUtils$v.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-class-properties",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classProperties", "classPrivateProperties", "classPrivateMethods");
        }
      };
    });
    lib$w["default"] = _default$v;
    var lib$v = {};
    Object.defineProperty(lib$v, "__esModule", {
      value: true
    });
    lib$v["default"] = void 0;
    var _helperPluginUtils$u = require$$0$5;
    var _default$u = (0, _helperPluginUtils$u.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-class-static-block",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classStaticBlock");
        }
      };
    });
    lib$v["default"] = _default$u;
    var syntaxDecimal = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-decimal",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("decimal");
        }
      };
    });
    var syntaxDecorators = declare(function(api, options) {
      api.assertVersion(7);
      var legacy = options.legacy, _options$version = options.version, version3 = _options$version === void 0 ? legacy ? "legacy" : "2018-09" : _options$version, _options$decoratorsBe = options.decoratorsBeforeExport, decoratorsBeforeExport = _options$decoratorsBe === void 0 ? version3 === "2021-12" ? false : void 0 : _options$decoratorsBe;
      if (version3 !== "2021-12" && version3 !== "2018-09" && version3 !== "legacy") {
        throw new Error("Unsupported decorators version: " + version3);
      }
      if (legacy !== void 0) {
        if (typeof legacy !== "boolean") {
          throw new Error(".legacy must be a boolean.");
        }
        if (options.version !== void 0) {
          throw new Error("You can either use the .legacy or the .version option, not both.");
        }
      }
      if (decoratorsBeforeExport === void 0) {
        if (version3 === "2018-09") {
          throw new Error("The decorators plugin, when .version is '2018-09' or not specified, requires a 'decoratorsBeforeExport' option, whose value must be a boolean.");
        }
      } else {
        if (version3 === "legacy") {
          throw new Error("'decoratorsBeforeExport' can't be used with legacy decorators.");
        }
        if (typeof decoratorsBeforeExport !== "boolean") {
          throw new Error("'decoratorsBeforeExport' must be a boolean.");
        }
      }
      return {
        name: "syntax-decorators",
        manipulateOptions: function manipulateOptions(_ref3, parserOpts) {
          var generatorOpts = _ref3.generatorOpts;
          if (version3 === "legacy") {
            parserOpts.plugins.push("decorators-legacy");
          } else if (version3 === "2018-09") {
            parserOpts.plugins.push(["decorators", {
              decoratorsBeforeExport
            }]);
            generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
          } else {
            parserOpts.plugins.push(["decorators", {
              decoratorsBeforeExport
            }], "decoratorAutoAccessors");
            generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
          }
        }
      };
    });
    var syntaxDestructuringPrivate = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-destructuring-private",
        manipulateOptions: function manipulateOptions(_, parserOpts) {
          parserOpts.plugins.push("destructuringPrivate");
        }
      };
    });
    var syntaxDoExpressions = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-do-expressions",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("doExpressions");
        }
      };
    });
    var syntaxExportDefaultFrom = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-export-default-from",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("exportDefaultFrom");
        }
      };
    });
    var syntaxFlow = declare(function(api, options) {
      api.assertVersion(7);
      var all2 = options.all, enums = options.enums;
      if (typeof all2 !== "boolean" && typeof all2 !== "undefined") {
        throw new Error(".all must be a boolean, or undefined");
      }
      if (typeof enums !== "boolean" && typeof enums !== "undefined") {
        throw new Error(".enums must be a boolean, or undefined");
      }
      return {
        name: "syntax-flow",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          if (parserOpts.plugins.some(function(p2) {
            return (Array.isArray(p2) ? p2[0] : p2) === "typescript";
          })) {
            return;
          }
          parserOpts.plugins.push(["flow", {
            all: all2,
            enums
          }]);
        }
      };
    });
    var syntaxFunctionBind = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-function-bind",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("functionBind");
        }
      };
    });
    var syntaxFunctionSent = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-function-sent",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("functionSent");
        }
      };
    });
    var syntaxModuleBlocks = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-module-blocks",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("moduleBlocks");
        }
      };
    });
    var lib$u = {};
    Object.defineProperty(lib$u, "__esModule", {
      value: true
    });
    lib$u["default"] = void 0;
    var _helperPluginUtils$t = require$$0$5;
    var _default$t = (0, _helperPluginUtils$t.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-import-meta",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("importMeta");
        }
      };
    });
    lib$u["default"] = _default$t;
    var syntaxJsx = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-jsx",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          if (parserOpts.plugins.some(function(p2) {
            return (Array.isArray(p2) ? p2[0] : p2) === "typescript";
          })) {
            return;
          }
          parserOpts.plugins.push("jsx");
        }
      };
    });
    var syntaxImportAssertions = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-import-assertions",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push(["importAssertions"]);
        }
      };
    });
    var lib$t = {};
    Object.defineProperty(lib$t, "__esModule", {
      value: true
    });
    lib$t["default"] = void 0;
    var _helperPluginUtils$s = require$$0$5;
    var _default$s = (0, _helperPluginUtils$s.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-object-rest-spread",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("objectRestSpread");
        }
      };
    });
    lib$t["default"] = _default$s;
    var lib$s = {};
    Object.defineProperty(lib$s, "__esModule", {
      value: true
    });
    lib$s["default"] = void 0;
    var _helperPluginUtils$r = require$$0$5;
    var _default$r = (0, _helperPluginUtils$r.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-optional-catch-binding",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("optionalCatchBinding");
        }
      };
    });
    lib$s["default"] = _default$r;
    var PIPELINE_PROPOSALS = ["minimal", "fsharp", "hack", "smart"];
    var TOPIC_TOKENS = ["^^", "@@", "^", "%", "#"];
    var documentationURL = "https://babeljs.io/docs/en/babel-plugin-proposal-pipeline-operator";
    var syntaxPipelineOperator = declare(function(api, _ref3) {
      var proposal = _ref3.proposal, topicToken = _ref3.topicToken;
      api.assertVersion(7);
      if (typeof proposal !== "string" || !PIPELINE_PROPOSALS.includes(proposal)) {
        var proposalList = PIPELINE_PROPOSALS.map(function(p2) {
          return '"' + p2 + '"';
        }).join(", ");
        throw new Error('The pipeline plugin requires a "proposal" option. "proposal" must be one of: ' + proposalList + ". See <" + documentationURL + ">.");
      }
      if (proposal === "hack" && !TOPIC_TOKENS.includes(topicToken)) {
        var topicTokenList = TOPIC_TOKENS.map(function(t3) {
          return '"' + t3 + '"';
        }).join(", ");
        throw new Error('The pipeline plugin in "proposal": "hack" mode also requires a "topicToken" option. "topicToken" must be one of: ' + topicTokenList + ". See <" + documentationURL + ">.");
      }
      return {
        name: "syntax-pipeline-operator",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push(["pipelineOperator", {
            proposal,
            topicToken
          }]);
          opts.generatorOpts.topicToken = topicToken;
        }
      };
    });
    var syntaxRecordAndTuple = declare(function(api, options) {
      api.assertVersion(7);
      return {
        name: "syntax-record-and-tuple",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          opts.generatorOpts.recordAndTupleSyntaxType = options.syntaxType;
          parserOpts.plugins.push(["recordAndTuple", {
            syntaxType: options.syntaxType
          }]);
        }
      };
    });
    var lib$r = {};
    Object.defineProperty(lib$r, "__esModule", {
      value: true
    });
    lib$r["default"] = void 0;
    var _helperPluginUtils$q = require$$0$5;
    var _default$q = (0, _helperPluginUtils$q.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-top-level-await",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("topLevelAwait");
        }
      };
    });
    lib$r["default"] = _default$q;
    function removePlugin(plugins2, name2) {
      var indices = [];
      plugins2.forEach(function(plugin2, i3) {
        var n2 = Array.isArray(plugin2) ? plugin2[0] : plugin2;
        if (n2 === name2) {
          indices.unshift(i3);
        }
      });
      for (var _i3 = 0, _indices = indices; _i3 < _indices.length; _i3++) {
        var i2 = _indices[_i3];
        plugins2.splice(i2, 1);
      }
    }
    var syntaxTypescript = declare(function(api, _ref3) {
      var isTSX = _ref3.isTSX, disallowAmbiguousJSXLike = _ref3.disallowAmbiguousJSXLike;
      api.assertVersion(7);
      return {
        name: "syntax-typescript",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          var plugins2 = parserOpts.plugins;
          removePlugin(plugins2, "flow");
          removePlugin(plugins2, "jsx");
          plugins2.push(["typescript", {
            disallowAmbiguousJSXLike
          }], "classProperties");
          {
            plugins2.push("objectRestSpread");
          }
          if (isTSX) {
            plugins2.push("jsx");
          }
        }
      };
    });
    var blockStatement = blockStatement$6, callExpression$5 = callExpression$e, functionExpression$1 = functionExpression$3, isAssignmentPattern$2 = isAssignmentPattern$5, isRestElement$1 = isRestElement$3, returnStatement = returnStatement$3;
    var buildAnonymousExpressionWrapper = template$2.expression("\n  (function () {\n    var REF = FUNCTION;\n    return function NAME(PARAMS) {\n      return REF.apply(this, arguments);\n    };\n  })()\n");
    var buildNamedExpressionWrapper = template$2.expression("\n  (function () {\n    var REF = FUNCTION;\n    function NAME(PARAMS) {\n      return REF.apply(this, arguments);\n    }\n    return NAME;\n  })()\n");
    var buildDeclarationWrapper = template$2("\n  function NAME(PARAMS) { return REF.apply(this, arguments); }\n  function REF() {\n    REF = FUNCTION;\n    return REF.apply(this, arguments);\n  }\n");
    function classOrObjectMethod(path2, callId) {
      var node2 = path2.node;
      var body = node2.body;
      var container2 = functionExpression$1(null, [], blockStatement(body.body), true);
      body.body = [returnStatement(callExpression$5(callExpression$5(callId, [container2]), []))];
      node2.async = false;
      node2.generator = false;
      path2.get("body.body.0.argument.callee.arguments.0").unwrapFunctionEnvironment();
    }
    function plainFunction(path2, callId, noNewArrows, ignoreFunctionLength) {
      var node2 = path2.node;
      var isDeclaration2 = path2.isFunctionDeclaration();
      var functionId = node2.id;
      var wrapper = isDeclaration2 ? buildDeclarationWrapper : functionId ? buildNamedExpressionWrapper : buildAnonymousExpressionWrapper;
      if (path2.isArrowFunctionExpression()) {
        path2.arrowFunctionToExpression({
          noNewArrows
        });
      }
      node2.id = null;
      if (isDeclaration2) {
        node2.type = "FunctionExpression";
      }
      var built = callExpression$5(callId, [node2]);
      var params = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(node2.params), _step2; !(_step2 = _iterator2()).done; ) {
        var param = _step2.value;
        if (isAssignmentPattern$2(param) || isRestElement$1(param)) {
          break;
        }
        params.push(path2.scope.generateUidIdentifier("x"));
      }
      var container2 = wrapper({
        NAME: functionId || null,
        REF: path2.scope.generateUidIdentifier(functionId ? functionId.name : "ref"),
        FUNCTION: built,
        PARAMS: params
      });
      if (isDeclaration2) {
        path2.replaceWith(container2[0]);
        path2.insertAfter(container2[1]);
      } else {
        var retFunction = container2.callee.body.body[1].argument;
        if (!functionId) {
          nameFunction({
            node: retFunction,
            parent: path2.parent,
            scope: path2.scope
          });
        }
        if (!retFunction || retFunction.id || !ignoreFunctionLength && params.length) {
          path2.replaceWith(container2);
        } else {
          path2.replaceWith(built);
        }
      }
    }
    function wrapFunction(path2, callId, noNewArrows, ignoreFunctionLength) {
      if (noNewArrows === void 0) {
        noNewArrows = true;
      }
      if (ignoreFunctionLength === void 0) {
        ignoreFunctionLength = false;
      }
      if (path2.isMethod()) {
        classOrObjectMethod(path2, callId);
      } else {
        plainFunction(path2, callId, noNewArrows, ignoreFunctionLength);
      }
    }
    var addComment = addComment$2;
    var PURE_ANNOTATION = "#__PURE__";
    var isPureAnnotated = function isPureAnnotated2(_ref3) {
      var leadingComments = _ref3.leadingComments;
      return !!leadingComments && leadingComments.some(function(comment) {
        return /[@#]__PURE__/.test(comment.value);
      });
    };
    function annotateAsPure(pathOrNode) {
      var node2 = pathOrNode["node"] || pathOrNode;
      if (isPureAnnotated(node2)) {
        return;
      }
      addComment(node2, "leading", PURE_ANNOTATION);
    }
    var callExpression$4 = callExpression$e, cloneNode$3 = cloneNode$i, isIdentifier$5 = isIdentifier$i, isThisExpression = isThisExpression$2, yieldExpression = yieldExpression$2;
    var awaitVisitor$1 = {
      Function: function Function2(path2) {
        path2.skip();
      },
      AwaitExpression: function AwaitExpression2(path2, _ref3) {
        var wrapAwait = _ref3.wrapAwait;
        var argument = path2.get("argument");
        path2.replaceWith(yieldExpression(wrapAwait ? callExpression$4(cloneNode$3(wrapAwait), [argument.node]) : argument.node));
      }
    };
    function remapAsyncToGenerator(path2, helpers2, noNewArrows, ignoreFunctionLength) {
      path2.traverse(awaitVisitor$1, {
        wrapAwait: helpers2.wrapAwait
      });
      var isIIFE = checkIsIIFE(path2);
      path2.node.async = false;
      path2.node.generator = true;
      wrapFunction(path2, cloneNode$3(helpers2.wrapAsync), noNewArrows, ignoreFunctionLength);
      var isProperty2 = path2.isObjectMethod() || path2.isClassMethod() || path2.parentPath.isObjectProperty() || path2.parentPath.isClassProperty();
      if (!isProperty2 && !isIIFE && path2.isExpression()) {
        annotateAsPure(path2);
      }
      function checkIsIIFE(path3) {
        if (path3.parentPath.isCallExpression({
          callee: path3.node
        })) {
          return true;
        }
        var parentPath = path3.parentPath;
        if (parentPath.isMemberExpression() && isIdentifier$5(parentPath.node.property, {
          name: "bind"
        })) {
          var bindCall = parentPath.parentPath;
          return bindCall.isCallExpression() && bindCall.node.arguments.length === 1 && isThisExpression(bindCall.node.arguments[0]) && bindCall.parentPath.isCallExpression({
            callee: bindCall.node
          });
        }
        return false;
      }
    }
    var lib$q = {};
    Object.defineProperty(lib$q, "__esModule", {
      value: true
    });
    lib$q["default"] = void 0;
    var _helperPluginUtils$p = require$$0$5;
    var _default$p = (0, _helperPluginUtils$p.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-async-generators",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("asyncGenerators");
        }
      };
    });
    lib$q["default"] = _default$p;
    var buildForAwait = template$2("\n  async function wrapper() {\n    var ITERATOR_ABRUPT_COMPLETION = false;\n    var ITERATOR_HAD_ERROR_KEY = false;\n    var ITERATOR_ERROR_KEY;\n    try {\n      for (\n        var ITERATOR_KEY = GET_ITERATOR(OBJECT), STEP_KEY;\n        ITERATOR_ABRUPT_COMPLETION = !(STEP_KEY = await ITERATOR_KEY.next()).done;\n        ITERATOR_ABRUPT_COMPLETION = false\n      ) {\n      }\n    } catch (err) {\n      ITERATOR_HAD_ERROR_KEY = true;\n      ITERATOR_ERROR_KEY = err;\n    } finally {\n      try {\n        if (ITERATOR_ABRUPT_COMPLETION && ITERATOR_KEY.return != null) {\n          await ITERATOR_KEY.return();\n        }\n      } finally {\n        if (ITERATOR_HAD_ERROR_KEY) {\n          throw ITERATOR_ERROR_KEY;\n        }\n      }\n    }\n  }\n");
    function rewriteForAwait(path2, _ref3) {
      var getAsyncIterator = _ref3.getAsyncIterator;
      var node2 = path2.node, scope2 = path2.scope, parent = path2.parent;
      var stepKey = scope2.generateUidIdentifier("step");
      var stepValue = memberExpression$b(stepKey, identifier$j("value"));
      var left = node2.left;
      var declar;
      if (isIdentifier$i(left) || isPattern2(left) || isMemberExpression$8(left)) {
        declar = expressionStatement$a(assignmentExpression$c("=", left, stepValue));
      } else if (isVariableDeclaration$3(left)) {
        declar = variableDeclaration$7(left.kind, [variableDeclarator$7(left.declarations[0].id, stepValue)]);
      }
      var template2 = buildForAwait({
        ITERATOR_HAD_ERROR_KEY: scope2.generateUidIdentifier("didIteratorError"),
        ITERATOR_ABRUPT_COMPLETION: scope2.generateUidIdentifier("iteratorAbruptCompletion"),
        ITERATOR_ERROR_KEY: scope2.generateUidIdentifier("iteratorError"),
        ITERATOR_KEY: scope2.generateUidIdentifier("iterator"),
        GET_ITERATOR: getAsyncIterator,
        OBJECT: node2.right,
        STEP_KEY: cloneNode$i(stepKey)
      });
      template2 = template2.body.body;
      var isLabeledParent = isLabeledStatement(parent);
      var tryBody = template2[3].block.body;
      var loop = tryBody[0];
      if (isLabeledParent) {
        tryBody[0] = labeledStatement(parent.label, loop);
      }
      return {
        replaceParent: isLabeledParent,
        node: template2,
        declar,
        loop
      };
    }
    var _proposalAsyncGeneratorFunctions = declare(function(api) {
      api.assertVersion(7);
      var yieldStarVisitor = {
        Function: function Function2(path2) {
          path2.skip();
        },
        YieldExpression: function YieldExpression2(_ref3, state) {
          var node2 = _ref3.node;
          if (!node2.delegate)
            return;
          var callee = state.addHelper("asyncGeneratorDelegate");
          node2.argument = callExpression$e(callee, [callExpression$e(state.addHelper("asyncIterator"), [node2.argument]), state.addHelper("awaitAsyncGenerator")]);
        }
      };
      var forAwaitVisitor = {
        Function: function Function2(path2) {
          path2.skip();
        },
        ForOfStatement: function ForOfStatement2(path2, _ref22) {
          var _block$body;
          var file2 = _ref22.file;
          var node2 = path2.node;
          if (!node2["await"])
            return;
          var build2 = rewriteForAwait(path2, {
            getAsyncIterator: file2.addHelper("asyncIterator")
          });
          var declar = build2.declar, loop = build2.loop;
          var block = loop.body;
          path2.ensureBlock();
          if (declar) {
            block.body.push(declar);
          }
          (_block$body = block.body).push.apply(_block$body, _toConsumableArray2(node2.body.body));
          inherits$1(loop, node2);
          inherits$1(loop.body, node2.body);
          if (build2.replaceParent) {
            path2.parentPath.replaceWithMultiple(build2.node);
          } else {
            path2.replaceWithMultiple(build2.node);
          }
        }
      };
      var visitor2 = {
        Function: function Function2(path2, state) {
          if (!path2.node.async)
            return;
          path2.traverse(forAwaitVisitor, state);
          if (!path2.node.generator)
            return;
          path2.traverse(yieldStarVisitor, state);
          remapAsyncToGenerator(path2, {
            wrapAsync: state.addHelper("wrapAsyncGenerator"),
            wrapAwait: state.addHelper("awaitAsyncGenerator")
          });
        }
      };
      return {
        name: "proposal-async-generator-functions",
        inherits: lib$q["default"],
        visitor: {
          Program: function Program2(path2, state) {
            path2.traverse(visitor2, state);
          }
        }
      };
    });
    function willPathCastToBoolean$1(path2) {
      var maybeWrapped = path2;
      var node2 = maybeWrapped.node, parentPath = maybeWrapped.parentPath;
      if (parentPath.isLogicalExpression()) {
        var _parentPath$node = parentPath.node, operator = _parentPath$node.operator, right = _parentPath$node.right;
        if (operator === "&&" || operator === "||" || operator === "??" && node2 === right) {
          return willPathCastToBoolean$1(parentPath);
        }
      }
      if (parentPath.isSequenceExpression()) {
        var expressions = parentPath.node.expressions;
        if (expressions[expressions.length - 1] === node2) {
          return willPathCastToBoolean$1(parentPath);
        } else {
          return true;
        }
      }
      return parentPath.isConditional({
        test: node2
      }) || parentPath.isUnaryExpression({
        operator: "!"
      }) || parentPath.isLoop({
        test: node2
      });
    }
    var LOGICAL_OPERATORS = LOGICAL_OPERATORS$3, arrowFunctionExpression = arrowFunctionExpression$4, assignmentExpression$3 = assignmentExpression$c, binaryExpression = binaryExpression$4, booleanLiteral$3 = booleanLiteral$5, callExpression$3 = callExpression$e, cloneNode$2 = cloneNode$i, conditionalExpression = conditionalExpression$3, identifier$4 = identifier$j, isMemberExpression$1 = isMemberExpression$8, isOptionalCallExpression = isOptionalCallExpression$3, isOptionalMemberExpression = isOptionalMemberExpression$3, isUpdateExpression = isUpdateExpression$1, logicalExpression = logicalExpression$3, memberExpression$4 = memberExpression$b, nullLiteral$1 = nullLiteral$2, optionalCallExpression$1 = optionalCallExpression$2, optionalMemberExpression$1 = optionalMemberExpression$2, sequenceExpression$2 = sequenceExpression$7, updateExpression = updateExpression$1;
    var AssignmentMemoiser = function() {
      function AssignmentMemoiser2() {
        this._map = void 0;
        this._map = /* @__PURE__ */ new WeakMap();
      }
      var _proto = AssignmentMemoiser2.prototype;
      _proto.has = function has3(key2) {
        return this._map.has(key2);
      };
      _proto.get = function get3(key2) {
        if (!this.has(key2))
          return;
        var record = this._map.get(key2);
        var value = record.value;
        record.count--;
        if (record.count === 0) {
          return assignmentExpression$3("=", value, key2);
        }
        return value;
      };
      _proto.set = function set3(key2, value, count2) {
        return this._map.set(key2, {
          count: count2,
          value
        });
      };
      return _createClass2(AssignmentMemoiser2);
    }();
    function toNonOptional(path2, base2) {
      var node2 = path2.node;
      if (isOptionalMemberExpression(node2)) {
        return memberExpression$4(base2, node2.property, node2.computed);
      }
      if (path2.isOptionalCallExpression()) {
        var callee = path2.get("callee");
        if (path2.node.optional && callee.isOptionalMemberExpression()) {
          var object4 = callee.node.object;
          var context = path2.scope.maybeGenerateMemoised(object4) || object4;
          callee.get("object").replaceWith(assignmentExpression$3("=", context, object4));
          return callExpression$3(memberExpression$4(base2, identifier$4("call")), [context].concat(_toConsumableArray2(path2.node.arguments)));
        }
        return callExpression$3(base2, path2.node.arguments);
      }
      return path2.node;
    }
    function isInDetachedTree(path2) {
      while (path2) {
        if (path2.isProgram())
          break;
        var _path = path2, parentPath = _path.parentPath, container2 = _path.container, listKey = _path.listKey;
        var parentNode2 = parentPath.node;
        if (listKey) {
          if (container2 !== parentNode2[listKey])
            return true;
        } else {
          if (container2 !== parentNode2)
            return true;
        }
        path2 = parentPath;
      }
      return false;
    }
    var handle = {
      memoise: function memoise() {
      },
      handle: function handle2(member, noDocumentAll) {
        var node2 = member.node, parent = member.parent, parentPath = member.parentPath, scope2 = member.scope;
        if (member.isOptionalMemberExpression()) {
          if (isInDetachedTree(member))
            return;
          var endPath = member.find(function(_ref3) {
            var node3 = _ref3.node, parent2 = _ref3.parent;
            if (isOptionalMemberExpression(parent2)) {
              return parent2.optional || parent2.object !== node3;
            }
            if (isOptionalCallExpression(parent2)) {
              return node3 !== member.node && parent2.optional || parent2.callee !== node3;
            }
            return true;
          });
          if (scope2.path.isPattern()) {
            endPath.replaceWith(callExpression$3(arrowFunctionExpression([], endPath.node), []));
            return;
          }
          var willEndPathCastToBoolean = willPathCastToBoolean$1(endPath);
          var rootParentPath = endPath.parentPath;
          if (rootParentPath.isUpdateExpression({
            argument: node2
          }) || rootParentPath.isAssignmentExpression({
            left: node2
          })) {
            throw member.buildCodeFrameError("can't handle assignment");
          }
          var isDeleteOperation = rootParentPath.isUnaryExpression({
            operator: "delete"
          });
          if (isDeleteOperation && endPath.isOptionalMemberExpression() && endPath.get("property").isPrivateName()) {
            throw member.buildCodeFrameError("can't delete a private class element");
          }
          var startingOptional = member;
          for (; ; ) {
            if (startingOptional.isOptionalMemberExpression()) {
              if (startingOptional.node.optional)
                break;
              startingOptional = startingOptional.get("object");
              continue;
            } else if (startingOptional.isOptionalCallExpression()) {
              if (startingOptional.node.optional)
                break;
              startingOptional = startingOptional.get("callee");
              continue;
            }
            throw new Error("Internal error: unexpected " + startingOptional.node.type);
          }
          var startingProp = startingOptional.isOptionalMemberExpression() ? "object" : "callee";
          var startingNode = startingOptional.node[startingProp];
          var baseNeedsMemoised = scope2.maybeGenerateMemoised(startingNode);
          var baseRef = baseNeedsMemoised != null ? baseNeedsMemoised : startingNode;
          var parentIsOptionalCall = parentPath.isOptionalCallExpression({
            callee: node2
          });
          var isOptionalCall = function isOptionalCall2(parent2) {
            return parentIsOptionalCall;
          };
          var parentIsCall = parentPath.isCallExpression({
            callee: node2
          });
          startingOptional.replaceWith(toNonOptional(startingOptional, baseRef));
          if (isOptionalCall(parent)) {
            if (parent.optional) {
              parentPath.replaceWith(this.optionalCall(member, parent.arguments));
            } else {
              parentPath.replaceWith(this.call(member, parent.arguments));
            }
          } else if (parentIsCall) {
            member.replaceWith(this.boundGet(member));
          } else {
            member.replaceWith(this.get(member));
          }
          var regular = member.node;
          for (var current2 = member; current2 !== endPath; ) {
            var _parentPath = current2.parentPath;
            if (_parentPath === endPath && isOptionalCall(parent) && parent.optional) {
              regular = _parentPath.node;
              break;
            }
            regular = toNonOptional(_parentPath, regular);
            current2 = _parentPath;
          }
          var context;
          var endParentPath = endPath.parentPath;
          if (isMemberExpression$1(regular) && endParentPath.isOptionalCallExpression({
            callee: endPath.node,
            optional: true
          })) {
            var _regular = regular, object4 = _regular.object;
            context = member.scope.maybeGenerateMemoised(object4);
            if (context) {
              regular.object = assignmentExpression$3("=", context, object4);
            }
          }
          var replacementPath = endPath;
          if (isDeleteOperation) {
            replacementPath = endParentPath;
            regular = endParentPath.node;
          }
          var baseMemoised = baseNeedsMemoised ? assignmentExpression$3("=", cloneNode$2(baseRef), cloneNode$2(startingNode)) : cloneNode$2(baseRef);
          if (willEndPathCastToBoolean) {
            var nonNullishCheck;
            if (noDocumentAll) {
              nonNullishCheck = binaryExpression("!=", baseMemoised, nullLiteral$1());
            } else {
              nonNullishCheck = logicalExpression("&&", binaryExpression("!==", baseMemoised, nullLiteral$1()), binaryExpression("!==", cloneNode$2(baseRef), scope2.buildUndefinedNode()));
            }
            replacementPath.replaceWith(logicalExpression("&&", nonNullishCheck, regular));
          } else {
            var nullishCheck;
            if (noDocumentAll) {
              nullishCheck = binaryExpression("==", baseMemoised, nullLiteral$1());
            } else {
              nullishCheck = logicalExpression("||", binaryExpression("===", baseMemoised, nullLiteral$1()), binaryExpression("===", cloneNode$2(baseRef), scope2.buildUndefinedNode()));
            }
            replacementPath.replaceWith(conditionalExpression(nullishCheck, isDeleteOperation ? booleanLiteral$3(true) : scope2.buildUndefinedNode(), regular));
          }
          if (context) {
            var endParent = endParentPath.node;
            endParentPath.replaceWith(optionalCallExpression$1(optionalMemberExpression$1(endParent.callee, identifier$4("call"), false, true), [cloneNode$2(context)].concat(_toConsumableArray2(endParent.arguments)), false));
          }
          return;
        }
        if (isUpdateExpression(parent, {
          argument: node2
        })) {
          if (this.simpleSet) {
            member.replaceWith(this.simpleSet(member));
            return;
          }
          var operator = parent.operator, prefix2 = parent.prefix;
          this.memoise(member, 2);
          var ref2 = scope2.generateUidIdentifierBasedOnNode(node2);
          scope2.push({
            id: ref2
          });
          var seq = [assignmentExpression$3("=", cloneNode$2(ref2), this.get(member))];
          if (prefix2) {
            seq.push(updateExpression(operator, cloneNode$2(ref2), prefix2));
            var _value = sequenceExpression$2(seq);
            parentPath.replaceWith(this.set(member, _value));
            return;
          } else {
            var ref22 = scope2.generateUidIdentifierBasedOnNode(node2);
            scope2.push({
              id: ref22
            });
            seq.push(assignmentExpression$3("=", cloneNode$2(ref22), updateExpression(operator, cloneNode$2(ref2), prefix2)), cloneNode$2(ref2));
            var _value2 = sequenceExpression$2(seq);
            parentPath.replaceWith(sequenceExpression$2([this.set(member, _value2), cloneNode$2(ref22)]));
            return;
          }
        }
        if (parentPath.isAssignmentExpression({
          left: node2
        })) {
          if (this.simpleSet) {
            member.replaceWith(this.simpleSet(member));
            return;
          }
          var _parentPath$node = parentPath.node, _operator = _parentPath$node.operator, _value3 = _parentPath$node.right;
          if (_operator === "=") {
            parentPath.replaceWith(this.set(member, _value3));
          } else {
            var operatorTrunc = _operator.slice(0, -1);
            if (LOGICAL_OPERATORS.includes(operatorTrunc)) {
              this.memoise(member, 1);
              parentPath.replaceWith(logicalExpression(operatorTrunc, this.get(member), this.set(member, _value3)));
            } else {
              this.memoise(member, 2);
              parentPath.replaceWith(this.set(member, binaryExpression(operatorTrunc, this.get(member), _value3)));
            }
          }
          return;
        }
        if (parentPath.isCallExpression({
          callee: node2
        })) {
          parentPath.replaceWith(this.call(member, parentPath.node.arguments));
          return;
        }
        if (parentPath.isOptionalCallExpression({
          callee: node2
        })) {
          if (scope2.path.isPattern()) {
            parentPath.replaceWith(callExpression$3(arrowFunctionExpression([], parentPath.node), []));
            return;
          }
          parentPath.replaceWith(this.optionalCall(member, parentPath.node.arguments));
          return;
        }
        if (parentPath.isForXStatement({
          left: node2
        }) || parentPath.isObjectProperty({
          value: node2
        }) && parentPath.parentPath.isObjectPattern() || parentPath.isAssignmentPattern({
          left: node2
        }) && parentPath.parentPath.isObjectProperty({
          value: parent
        }) && parentPath.parentPath.parentPath.isObjectPattern() || parentPath.isArrayPattern() || parentPath.isAssignmentPattern({
          left: node2
        }) && parentPath.parentPath.isArrayPattern() || parentPath.isRestElement()) {
          member.replaceWith(this.destructureSet(member));
          return;
        }
        if (parentPath.isTaggedTemplateExpression()) {
          member.replaceWith(this.boundGet(member));
        } else {
          member.replaceWith(this.get(member));
        }
      }
    };
    function memberExpressionToFunctions(path2, visitor2, state) {
      path2.traverse(visitor2, Object.assign({}, handle, state, {
        memoiser: new AssignmentMemoiser()
      }));
    }
    var callExpression$2 = callExpression$e, identifier$3 = identifier$j, isIdentifier$4 = isIdentifier$i, isSpreadElement = isSpreadElement$1, memberExpression$3 = memberExpression$b, optionalCallExpression = optionalCallExpression$2, optionalMemberExpression = optionalMemberExpression$2;
    function optimiseCallExpression(callee, thisNode, args, optional) {
      if (args.length === 1 && isSpreadElement(args[0]) && isIdentifier$4(args[0].argument, {
        name: "arguments"
      })) {
        if (optional) {
          return optionalCallExpression(optionalMemberExpression(callee, identifier$3("apply"), false, true), [thisNode, args[0].argument], false);
        }
        return callExpression$2(memberExpression$3(callee, identifier$3("apply")), [thisNode, args[0].argument]);
      } else {
        if (optional) {
          return optionalCallExpression(optionalMemberExpression(callee, identifier$3("call"), false, true), [thisNode].concat(_toConsumableArray2(args)), false);
        }
        return callExpression$2(memberExpression$3(callee, identifier$3("call")), [thisNode].concat(_toConsumableArray2(args)));
      }
    }
    var assignmentExpression$2 = assignmentExpression$c, booleanLiteral$2 = booleanLiteral$5, callExpression$1 = callExpression$e, cloneNode$1 = cloneNode$i, identifier$2 = identifier$j, memberExpression$2 = memberExpression$b, sequenceExpression$1 = sequenceExpression$7, stringLiteral$1 = stringLiteral$8, thisExpression$1 = thisExpression$4;
    function getPrototypeOfExpression(objectRef, isStatic2, file2, isPrivateMethod) {
      objectRef = cloneNode$1(objectRef);
      var targetRef = isStatic2 || isPrivateMethod ? objectRef : memberExpression$2(objectRef, identifier$2("prototype"));
      return callExpression$1(file2.addHelper("getPrototypeOf"), [targetRef]);
    }
    var visitor$1 = traverse.visitors.merge([environmentVisitor, {
      Super: function Super2(path2, state) {
        var node2 = path2.node, parentPath = path2.parentPath;
        if (!parentPath.isMemberExpression({
          object: node2
        }))
          return;
        state.handle(parentPath);
      }
    }]);
    var unshadowSuperBindingVisitor = traverse.visitors.merge([environmentVisitor, {
      Scopable: function Scopable(path2, _ref3) {
        var refName = _ref3.refName;
        var binding2 = path2.scope.getOwnBinding(refName);
        if (binding2 && binding2.identifier.name === refName) {
          path2.scope.rename(refName);
        }
      }
    }]);
    var specHandlers = {
      memoise: function memoise(superMember, count2) {
        var scope2 = superMember.scope, node2 = superMember.node;
        var computed = node2.computed, property2 = node2.property;
        if (!computed) {
          return;
        }
        var memo = scope2.maybeGenerateMemoised(property2);
        if (!memo) {
          return;
        }
        this.memoiser.set(property2, memo, count2);
      },
      prop: function prop2(superMember) {
        var _superMember$node = superMember.node, computed = _superMember$node.computed, property2 = _superMember$node.property;
        if (this.memoiser.has(property2)) {
          return cloneNode$1(this.memoiser.get(property2));
        }
        if (computed) {
          return cloneNode$1(property2);
        }
        return stringLiteral$1(property2.name);
      },
      get: function get3(superMember) {
        return this._get(superMember, this._getThisRefs());
      },
      _get: function _get(superMember, thisRefs) {
        var proto2 = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
        return callExpression$1(this.file.addHelper("get"), [thisRefs.memo ? sequenceExpression$1([thisRefs.memo, proto2]) : proto2, this.prop(superMember), thisRefs["this"]]);
      },
      _getThisRefs: function _getThisRefs() {
        if (!this.isDerivedConstructor) {
          return {
            "this": thisExpression$1()
          };
        }
        var thisRef = this.scope.generateDeclaredUidIdentifier("thisSuper");
        return {
          memo: assignmentExpression$2("=", thisRef, thisExpression$1()),
          "this": cloneNode$1(thisRef)
        };
      },
      set: function set3(superMember, value) {
        var thisRefs = this._getThisRefs();
        var proto2 = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
        return callExpression$1(this.file.addHelper("set"), [thisRefs.memo ? sequenceExpression$1([thisRefs.memo, proto2]) : proto2, this.prop(superMember), value, thisRefs["this"], booleanLiteral$2(superMember.isInStrictMode())]);
      },
      destructureSet: function destructureSet(superMember) {
        throw superMember.buildCodeFrameError("Destructuring to a super field is not supported yet.");
      },
      call: function call3(superMember, args) {
        var thisRefs = this._getThisRefs();
        return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode$1(thisRefs["this"]), args, false);
      },
      optionalCall: function optionalCall(superMember, args) {
        var thisRefs = this._getThisRefs();
        return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode$1(thisRefs["this"]), args, true);
      }
    };
    var looseHandlers = Object.assign({}, specHandlers, {
      prop: function prop2(superMember) {
        var property2 = superMember.node.property;
        if (this.memoiser.has(property2)) {
          return cloneNode$1(this.memoiser.get(property2));
        }
        return cloneNode$1(property2);
      },
      get: function get3(superMember) {
        var isStatic2 = this.isStatic, getSuperRef = this.getSuperRef;
        var computed = superMember.node.computed;
        var prop2 = this.prop(superMember);
        var object4;
        if (isStatic2) {
          var _getSuperRef;
          object4 = (_getSuperRef = getSuperRef()) != null ? _getSuperRef : memberExpression$2(identifier$2("Function"), identifier$2("prototype"));
        } else {
          var _getSuperRef2;
          object4 = memberExpression$2((_getSuperRef2 = getSuperRef()) != null ? _getSuperRef2 : identifier$2("Object"), identifier$2("prototype"));
        }
        return memberExpression$2(object4, prop2, computed);
      },
      set: function set3(superMember, value) {
        var computed = superMember.node.computed;
        var prop2 = this.prop(superMember);
        return assignmentExpression$2("=", memberExpression$2(thisExpression$1(), prop2, computed), value);
      },
      destructureSet: function destructureSet(superMember) {
        var computed = superMember.node.computed;
        var prop2 = this.prop(superMember);
        return memberExpression$2(thisExpression$1(), prop2, computed);
      },
      call: function call3(superMember, args) {
        return optimiseCallExpression(this.get(superMember), thisExpression$1(), args, false);
      },
      optionalCall: function optionalCall(superMember, args) {
        return optimiseCallExpression(this.get(superMember), thisExpression$1(), args, true);
      }
    });
    var ReplaceSupers = function() {
      function ReplaceSupers2(opts) {
        var _opts$constantSuper;
        var path2 = opts.methodPath;
        this.methodPath = path2;
        this.isDerivedConstructor = path2.isClassMethod({
          kind: "constructor"
        }) && !!opts.superRef;
        this.isStatic = path2.isObjectMethod() || path2.node["static"] || (path2.isStaticBlock == null ? void 0 : path2.isStaticBlock());
        this.isPrivateMethod = path2.isPrivate() && path2.isMethod();
        this.file = opts.file;
        this.constantSuper = (_opts$constantSuper = opts.constantSuper) != null ? _opts$constantSuper : opts.isLoose;
        this.opts = opts;
      }
      var _proto = ReplaceSupers2.prototype;
      _proto.getObjectRef = function getObjectRef() {
        return cloneNode$1(this.opts.objectRef || this.opts.getObjectRef());
      };
      _proto.getSuperRef = function getSuperRef() {
        if (this.opts.superRef)
          return cloneNode$1(this.opts.superRef);
        if (this.opts.getSuperRef)
          return cloneNode$1(this.opts.getSuperRef());
      };
      _proto.replace = function replace() {
        if (this.opts.refToPreserve) {
          this.methodPath.traverse(unshadowSuperBindingVisitor, {
            refName: this.opts.refToPreserve.name
          });
        }
        var handler = this.constantSuper ? looseHandlers : specHandlers;
        memberExpressionToFunctions(this.methodPath, visitor$1, Object.assign({
          file: this.file,
          scope: this.methodPath.scope,
          isDerivedConstructor: this.isDerivedConstructor,
          isStatic: this.isStatic,
          isPrivateMethod: this.isPrivateMethod,
          getObjectRef: this.getObjectRef.bind(this),
          getSuperRef: this.getSuperRef.bind(this),
          boundGet: handler.get
        }, handler));
      };
      return _createClass2(ReplaceSupers2);
    }();
    function assertFieldTransformed(path2) {
      if (path2.node.declare) {
        throw path2.buildCodeFrameError("TypeScript 'declare' fields must first be transformed by @babel/plugin-transform-typescript.\nIf you have already enabled that plugin (or '@babel/preset-typescript'), make sure that it runs before any plugin related to additional class features:\n - @babel/plugin-proposal-class-properties\n - @babel/plugin-proposal-private-methods\n - @babel/plugin-proposal-decorators");
      }
    }
    var _templateObject$k, _templateObject2$9, _templateObject3$8, _templateObject4$4, _templateObject5$2, _templateObject6$2, _templateObject7$1, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19;
    function buildPrivateNamesMap(props) {
      var privateNamesMap = /* @__PURE__ */ new Map();
      for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done; ) {
        var prop2 = _step2.value;
        if (prop2.isPrivate()) {
          var name2 = prop2.node.key.id.name;
          var update2 = privateNamesMap.has(name2) ? privateNamesMap.get(name2) : {
            id: prop2.scope.generateUidIdentifier(name2),
            "static": prop2.node["static"],
            method: !prop2.isProperty()
          };
          if (prop2.isClassPrivateMethod()) {
            if (prop2.node.kind === "get") {
              update2.getId = prop2.scope.generateUidIdentifier("get_" + name2);
            } else if (prop2.node.kind === "set") {
              update2.setId = prop2.scope.generateUidIdentifier("set_" + name2);
            } else if (prop2.node.kind === "method") {
              update2.methodId = prop2.scope.generateUidIdentifier(name2);
            }
          }
          privateNamesMap.set(name2, update2);
        }
      }
      return privateNamesMap;
    }
    function buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties, state) {
      var initNodes = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(privateNamesMap), _step2; !(_step2 = _iterator2()).done; ) {
        var _step2$value = _slicedToArray$12(_step2.value, 2), name2 = _step2$value[0], value = _step2$value[1];
        var isStatic2 = value["static"], isMethod2 = value.method, getId2 = value.getId, setId = value.setId;
        var isAccessor2 = getId2 || setId;
        var id3 = cloneNode$i(value.id);
        var init3 = void 0;
        if (privateFieldsAsProperties) {
          init3 = callExpression$e(state.addHelper("classPrivateFieldLooseKey"), [stringLiteral$8(name2)]);
        } else if (!isStatic2) {
          init3 = newExpression(identifier$j(!isMethod2 || isAccessor2 ? "WeakMap" : "WeakSet"), []);
        }
        if (init3) {
          annotateAsPure(init3);
          initNodes.push(template$2.statement.ast(_templateObject$k || (_templateObject$k = _taggedTemplateLiteralLoose(["var ", " = ", ""])), id3, init3));
        }
      }
      return initNodes;
    }
    function privateNameVisitorFactory(visitor2) {
      var privateNameVisitor2 = Object.assign({}, visitor2, {
        Class: function Class(path2) {
          var privateNamesMap = this.privateNamesMap;
          var body = path2.get("body.body");
          var visiblePrivateNames = new Map(privateNamesMap);
          var redeclared = [];
          for (var _iterator3 = _createForOfIteratorHelperLoose(body), _step3; !(_step3 = _iterator3()).done; ) {
            var prop2 = _step3.value;
            if (!prop2.isPrivate())
              continue;
            var name2 = prop2.node.key.id.name;
            visiblePrivateNames["delete"](name2);
            redeclared.push(name2);
          }
          if (!redeclared.length) {
            return;
          }
          path2.get("body").traverse(nestedVisitor, Object.assign({}, this, {
            redeclared
          }));
          path2.traverse(privateNameVisitor2, Object.assign({}, this, {
            privateNamesMap: visiblePrivateNames
          }));
          path2.skipKey("body");
        }
      });
      var nestedVisitor = traverse.visitors.merge([Object.assign({}, visitor2), environmentVisitor]);
      return privateNameVisitor2;
    }
    var privateNameVisitor = privateNameVisitorFactory({
      PrivateName: function PrivateName2(path2, _ref3) {
        var noDocumentAll = _ref3.noDocumentAll;
        var privateNamesMap = this.privateNamesMap, redeclared = this.redeclared;
        var node2 = path2.node, parentPath = path2.parentPath;
        if (!parentPath.isMemberExpression({
          property: node2
        }) && !parentPath.isOptionalMemberExpression({
          property: node2
        })) {
          return;
        }
        var name2 = node2.id.name;
        if (!privateNamesMap.has(name2))
          return;
        if (redeclared && redeclared.includes(name2))
          return;
        this.handle(parentPath, noDocumentAll);
      }
    });
    function unshadow(name2, scope2, innerBinding) {
      while ((_scope = scope2) != null && _scope.hasBinding(name2) && !scope2.bindingIdentifierEquals(name2, innerBinding)) {
        var _scope;
        scope2.rename(name2);
        scope2 = scope2.parent;
      }
    }
    var privateInVisitor = privateNameVisitorFactory({
      BinaryExpression: function BinaryExpression2(path2) {
        var _path$node = path2.node, operator = _path$node.operator, left = _path$node.left, right = _path$node.right;
        if (operator !== "in")
          return;
        if (!isPrivateName$2(left))
          return;
        var privateFieldsAsProperties = this.privateFieldsAsProperties, privateNamesMap = this.privateNamesMap, redeclared = this.redeclared;
        var name2 = left.id.name;
        if (!privateNamesMap.has(name2))
          return;
        if (redeclared && redeclared.includes(name2))
          return;
        unshadow(this.classRef.name, path2.scope, this.innerBinding);
        if (privateFieldsAsProperties) {
          var _privateNamesMap$get = privateNamesMap.get(name2), _id = _privateNamesMap$get.id;
          path2.replaceWith(template$2.expression.ast(_templateObject2$9 || (_templateObject2$9 = _taggedTemplateLiteralLoose(["\n        Object.prototype.hasOwnProperty.call(", ", ", ")\n      "])), right, cloneNode$i(_id)));
          return;
        }
        var _privateNamesMap$get2 = privateNamesMap.get(name2), id3 = _privateNamesMap$get2.id, isStatic2 = _privateNamesMap$get2["static"];
        if (isStatic2) {
          path2.replaceWith(template$2.expression.ast(_templateObject3$8 || (_templateObject3$8 = _taggedTemplateLiteralLoose(["", " === ", ""])), right, this.classRef));
          return;
        }
        path2.replaceWith(template$2.expression.ast(_templateObject4$4 || (_templateObject4$4 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), cloneNode$i(id3), right));
      }
    });
    var privateNameHandlerSpec = {
      memoise: function memoise(member, count2) {
        var scope2 = member.scope;
        var object4 = member.node.object;
        var memo = scope2.maybeGenerateMemoised(object4);
        if (!memo) {
          return;
        }
        this.memoiser.set(object4, memo, count2);
      },
      receiver: function receiver(member) {
        var object4 = member.node.object;
        if (this.memoiser.has(object4)) {
          return cloneNode$i(this.memoiser.get(object4));
        }
        return cloneNode$i(object4);
      },
      get: function get3(member) {
        var classRef = this.classRef, privateNamesMap = this.privateNamesMap, file2 = this.file, innerBinding = this.innerBinding;
        var name2 = member.node.property.id.name;
        var _privateNamesMap$get3 = privateNamesMap.get(name2), id3 = _privateNamesMap$get3.id, isStatic2 = _privateNamesMap$get3["static"], isMethod2 = _privateNamesMap$get3.method, methodId = _privateNamesMap$get3.methodId, getId2 = _privateNamesMap$get3.getId, setId = _privateNamesMap$get3.setId;
        var isAccessor2 = getId2 || setId;
        if (isStatic2) {
          var helperName = isMethod2 && !isAccessor2 ? "classStaticPrivateMethodGet" : "classStaticPrivateFieldSpecGet";
          unshadow(classRef.name, member.scope, innerBinding);
          return callExpression$e(file2.addHelper(helperName), [this.receiver(member), cloneNode$i(classRef), cloneNode$i(id3)]);
        }
        if (isMethod2) {
          if (isAccessor2) {
            if (!getId2 && setId) {
              if (file2.availableHelper("writeOnlyError")) {
                return sequenceExpression$7([this.receiver(member), callExpression$e(file2.addHelper("writeOnlyError"), [stringLiteral$8("#" + name2)])]);
              }
              console.warn("@babel/helpers is outdated, update it to silence this warning.");
            }
            return callExpression$e(file2.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$i(id3)]);
          }
          return callExpression$e(file2.addHelper("classPrivateMethodGet"), [this.receiver(member), cloneNode$i(id3), cloneNode$i(methodId)]);
        }
        return callExpression$e(file2.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$i(id3)]);
      },
      boundGet: function boundGet(member) {
        this.memoise(member, 1);
        return callExpression$e(memberExpression$b(this.get(member), identifier$j("bind")), [this.receiver(member)]);
      },
      set: function set3(member, value) {
        var classRef = this.classRef, privateNamesMap = this.privateNamesMap, file2 = this.file;
        var name2 = member.node.property.id.name;
        var _privateNamesMap$get4 = privateNamesMap.get(name2), id3 = _privateNamesMap$get4.id, isStatic2 = _privateNamesMap$get4["static"], isMethod2 = _privateNamesMap$get4.method, setId = _privateNamesMap$get4.setId, getId2 = _privateNamesMap$get4.getId;
        var isAccessor2 = getId2 || setId;
        if (isStatic2) {
          var helperName = isMethod2 && !isAccessor2 ? "classStaticPrivateMethodSet" : "classStaticPrivateFieldSpecSet";
          return callExpression$e(file2.addHelper(helperName), [this.receiver(member), cloneNode$i(classRef), cloneNode$i(id3), value]);
        }
        if (isMethod2) {
          if (setId) {
            return callExpression$e(file2.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$i(id3), value]);
          }
          return sequenceExpression$7([this.receiver(member), value, callExpression$e(file2.addHelper("readOnlyError"), [stringLiteral$8("#" + name2)])]);
        }
        return callExpression$e(file2.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$i(id3), value]);
      },
      destructureSet: function destructureSet(member) {
        var classRef = this.classRef, privateNamesMap = this.privateNamesMap, file2 = this.file;
        var name2 = member.node.property.id.name;
        var _privateNamesMap$get5 = privateNamesMap.get(name2), id3 = _privateNamesMap$get5.id, isStatic2 = _privateNamesMap$get5["static"];
        if (isStatic2) {
          try {
            var helper2 = file2.addHelper("classStaticPrivateFieldDestructureSet");
          } catch (_unused) {
            throw new Error("Babel can not transpile `[C.#p] = [0]` with @babel/helpers < 7.13.10, \nplease update @babel/helpers to the latest version.");
          }
          return memberExpression$b(callExpression$e(helper2, [this.receiver(member), cloneNode$i(classRef), cloneNode$i(id3)]), identifier$j("value"));
        }
        return memberExpression$b(callExpression$e(file2.addHelper("classPrivateFieldDestructureSet"), [this.receiver(member), cloneNode$i(id3)]), identifier$j("value"));
      },
      call: function call3(member, args) {
        this.memoise(member, 1);
        return optimiseCallExpression(this.get(member), this.receiver(member), args, false);
      },
      optionalCall: function optionalCall(member, args) {
        this.memoise(member, 1);
        return optimiseCallExpression(this.get(member), this.receiver(member), args, true);
      }
    };
    var privateNameHandlerLoose = {
      get: function get3(member) {
        var privateNamesMap = this.privateNamesMap, file2 = this.file;
        var object4 = member.node.object;
        var name2 = member.node.property.id.name;
        return template$2.expression(_templateObject5$2 || (_templateObject5$2 = _taggedTemplateLiteralLoose(["BASE(REF, PROP)[PROP]"])))({
          BASE: file2.addHelper("classPrivateFieldLooseBase"),
          REF: cloneNode$i(object4),
          PROP: cloneNode$i(privateNamesMap.get(name2).id)
        });
      },
      set: function set3() {
        throw new Error("private name handler with loose = true don't need set()");
      },
      boundGet: function boundGet(member) {
        return callExpression$e(memberExpression$b(this.get(member), identifier$j("bind")), [cloneNode$i(member.node.object)]);
      },
      simpleSet: function simpleSet(member) {
        return this.get(member);
      },
      destructureSet: function destructureSet(member) {
        return this.get(member);
      },
      call: function call3(member, args) {
        return callExpression$e(this.get(member), args);
      },
      optionalCall: function optionalCall(member, args) {
        return optionalCallExpression$2(this.get(member), args, true);
      }
    };
    function transformPrivateNamesUsage(ref2, path2, privateNamesMap, _ref22, state) {
      var privateFieldsAsProperties = _ref22.privateFieldsAsProperties, noDocumentAll = _ref22.noDocumentAll, innerBinding = _ref22.innerBinding;
      if (!privateNamesMap.size)
        return;
      var body = path2.get("body");
      var handler = privateFieldsAsProperties ? privateNameHandlerLoose : privateNameHandlerSpec;
      memberExpressionToFunctions(body, privateNameVisitor, Object.assign({
        privateNamesMap,
        classRef: ref2,
        file: state
      }, handler, {
        noDocumentAll,
        innerBinding
      }));
      body.traverse(privateInVisitor, {
        privateNamesMap,
        classRef: ref2,
        file: state,
        privateFieldsAsProperties,
        innerBinding
      });
    }
    function buildPrivateFieldInitLoose(ref2, prop2, privateNamesMap) {
      var _privateNamesMap$get6 = privateNamesMap.get(prop2.node.key.id.name), id3 = _privateNamesMap$get6.id;
      var value = prop2.node.value || prop2.scope.buildUndefinedNode();
      return template$2.statement.ast(_templateObject6$2 || (_templateObject6$2 = _taggedTemplateLiteralLoose(["\n    Object.defineProperty(", ", ", ", {\n      // configurable is false by default\n      // enumerable is false by default\n      writable: true,\n      value: ", "\n    });\n  "])), ref2, cloneNode$i(id3), value);
    }
    function buildPrivateInstanceFieldInitSpec(ref2, prop2, privateNamesMap, state) {
      var _privateNamesMap$get7 = privateNamesMap.get(prop2.node.key.id.name), id3 = _privateNamesMap$get7.id;
      var value = prop2.node.value || prop2.scope.buildUndefinedNode();
      {
        if (!state.availableHelper("classPrivateFieldInitSpec")) {
          return template$2.statement.ast(_templateObject7$1 || (_templateObject7$1 = _taggedTemplateLiteralLoose(["", ".set(", ", {\n        // configurable is always false for private elements\n        // enumerable is always false for private elements\n        writable: true,\n        value: ", ",\n      })"])), cloneNode$i(id3), ref2, value);
        }
      }
      var helper2 = state.addHelper("classPrivateFieldInitSpec");
      return template$2.statement.ast(_templateObject8 || (_templateObject8 = _taggedTemplateLiteralLoose(["", "(\n    ", ",\n    ", ",\n    {\n      writable: true,\n      value: ", "\n    },\n  )"])), helper2, thisExpression$4(), cloneNode$i(id3), value);
    }
    function buildPrivateStaticFieldInitSpec(prop2, privateNamesMap) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var id3 = privateName2.id, getId2 = privateName2.getId, setId = privateName2.setId, initAdded = privateName2.initAdded;
      var isAccessor2 = getId2 || setId;
      if (!prop2.isProperty() && (initAdded || !isAccessor2))
        return;
      if (isAccessor2) {
        privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
          initAdded: true
        }));
        return template$2.statement.ast(_templateObject9 || (_templateObject9 = _taggedTemplateLiteralLoose(["\n      var ", " = {\n        // configurable is false by default\n        // enumerable is false by default\n        // writable is false by default\n        get: ", ",\n        set: ", "\n      }\n    "])), cloneNode$i(id3), getId2 ? getId2.name : prop2.scope.buildUndefinedNode(), setId ? setId.name : prop2.scope.buildUndefinedNode());
      }
      var value = prop2.node.value || prop2.scope.buildUndefinedNode();
      return template$2.statement.ast(_templateObject10 || (_templateObject10 = _taggedTemplateLiteralLoose(["\n    var ", " = {\n      // configurable is false by default\n      // enumerable is false by default\n      writable: true,\n      value: ", "\n    };\n  "])), cloneNode$i(id3), value);
    }
    function buildPrivateMethodInitLoose(ref2, prop2, privateNamesMap) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var methodId = privateName2.methodId, id3 = privateName2.id, getId2 = privateName2.getId, setId = privateName2.setId, initAdded = privateName2.initAdded;
      if (initAdded)
        return;
      if (methodId) {
        return template$2.statement.ast(_templateObject11 || (_templateObject11 = _taggedTemplateLiteralLoose(["\n        Object.defineProperty(", ", ", ", {\n          // configurable is false by default\n          // enumerable is false by default\n          // writable is false by default\n          value: ", "\n        });\n      "])), ref2, id3, methodId.name);
      }
      var isAccessor2 = getId2 || setId;
      if (isAccessor2) {
        privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
          initAdded: true
        }));
        return template$2.statement.ast(_templateObject12 || (_templateObject12 = _taggedTemplateLiteralLoose(["\n      Object.defineProperty(", ", ", ", {\n        // configurable is false by default\n        // enumerable is false by default\n        // writable is false by default\n        get: ", ",\n        set: ", "\n      });\n    "])), ref2, id3, getId2 ? getId2.name : prop2.scope.buildUndefinedNode(), setId ? setId.name : prop2.scope.buildUndefinedNode());
      }
    }
    function buildPrivateInstanceMethodInitSpec(ref2, prop2, privateNamesMap, state) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var getId2 = privateName2.getId, setId = privateName2.setId, initAdded = privateName2.initAdded;
      if (initAdded)
        return;
      var isAccessor2 = getId2 || setId;
      if (isAccessor2) {
        return buildPrivateAccessorInitialization(ref2, prop2, privateNamesMap, state);
      }
      return buildPrivateInstanceMethodInitalization(ref2, prop2, privateNamesMap, state);
    }
    function buildPrivateAccessorInitialization(ref2, prop2, privateNamesMap, state) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var id3 = privateName2.id, getId2 = privateName2.getId, setId = privateName2.setId;
      privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
        initAdded: true
      }));
      {
        if (!state.availableHelper("classPrivateFieldInitSpec")) {
          return template$2.statement.ast(_templateObject13 || (_templateObject13 = _taggedTemplateLiteralLoose(["\n      ", ".set(", ", {\n        get: ", ",\n        set: ", "\n      });\n    "])), id3, ref2, getId2 ? getId2.name : prop2.scope.buildUndefinedNode(), setId ? setId.name : prop2.scope.buildUndefinedNode());
        }
      }
      var helper2 = state.addHelper("classPrivateFieldInitSpec");
      return template$2.statement.ast(_templateObject14 || (_templateObject14 = _taggedTemplateLiteralLoose(["", "(\n    ", ",\n    ", ",\n    {\n      get: ", ",\n      set: ", "\n    },\n  )"])), helper2, thisExpression$4(), cloneNode$i(id3), getId2 ? getId2.name : prop2.scope.buildUndefinedNode(), setId ? setId.name : prop2.scope.buildUndefinedNode());
    }
    function buildPrivateInstanceMethodInitalization(ref2, prop2, privateNamesMap, state) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var id3 = privateName2.id;
      {
        if (!state.availableHelper("classPrivateMethodInitSpec")) {
          return template$2.statement.ast(_templateObject15 || (_templateObject15 = _taggedTemplateLiteralLoose(["", ".add(", ")"])), id3, ref2);
        }
      }
      var helper2 = state.addHelper("classPrivateMethodInitSpec");
      return template$2.statement.ast(_templateObject16 || (_templateObject16 = _taggedTemplateLiteralLoose(["", "(\n    ", ",\n    ", "\n  )"])), helper2, thisExpression$4(), cloneNode$i(id3));
    }
    function buildPublicFieldInitLoose(ref2, prop2) {
      var _prop$node = prop2.node, key2 = _prop$node.key, computed = _prop$node.computed;
      var value = prop2.node.value || prop2.scope.buildUndefinedNode();
      return expressionStatement$a(assignmentExpression$c("=", memberExpression$b(ref2, key2, computed || isLiteral$7(key2)), value));
    }
    function buildPublicFieldInitSpec(ref2, prop2, state) {
      var _prop$node2 = prop2.node, key2 = _prop$node2.key, computed = _prop$node2.computed;
      var value = prop2.node.value || prop2.scope.buildUndefinedNode();
      return expressionStatement$a(callExpression$e(state.addHelper("defineProperty"), [ref2, computed || isLiteral$7(key2) ? key2 : stringLiteral$8(key2.name), value]));
    }
    function buildPrivateStaticMethodInitLoose(ref2, prop2, state, privateNamesMap) {
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var id3 = privateName2.id, methodId = privateName2.methodId, getId2 = privateName2.getId, setId = privateName2.setId, initAdded = privateName2.initAdded;
      if (initAdded)
        return;
      var isAccessor2 = getId2 || setId;
      if (isAccessor2) {
        privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
          initAdded: true
        }));
        return template$2.statement.ast(_templateObject17 || (_templateObject17 = _taggedTemplateLiteralLoose(["\n      Object.defineProperty(", ", ", ", {\n        // configurable is false by default\n        // enumerable is false by default\n        // writable is false by default\n        get: ", ",\n        set: ", "\n      })\n    "])), ref2, id3, getId2 ? getId2.name : prop2.scope.buildUndefinedNode(), setId ? setId.name : prop2.scope.buildUndefinedNode());
      }
      return template$2.statement.ast(_templateObject18 || (_templateObject18 = _taggedTemplateLiteralLoose(["\n    Object.defineProperty(", ", ", ", {\n      // configurable is false by default\n      // enumerable is false by default\n      // writable is false by default\n      value: ", "\n    });\n  "])), ref2, id3, methodId.name);
    }
    function buildPrivateMethodDeclaration(prop2, privateNamesMap, privateFieldsAsProperties) {
      if (privateFieldsAsProperties === void 0) {
        privateFieldsAsProperties = false;
      }
      var privateName2 = privateNamesMap.get(prop2.node.key.id.name);
      var id3 = privateName2.id, methodId = privateName2.methodId, getId2 = privateName2.getId, setId = privateName2.setId, getterDeclared = privateName2.getterDeclared, setterDeclared = privateName2.setterDeclared, isStatic2 = privateName2["static"];
      var _prop$node3 = prop2.node, params = _prop$node3.params, body = _prop$node3.body, generator = _prop$node3.generator, async = _prop$node3.async;
      var isGetter = getId2 && !getterDeclared && params.length === 0;
      var isSetter = setId && !setterDeclared && params.length > 0;
      var declId = methodId;
      if (isGetter) {
        privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
          getterDeclared: true
        }));
        declId = getId2;
      } else if (isSetter) {
        privateNamesMap.set(prop2.node.key.id.name, Object.assign({}, privateName2, {
          setterDeclared: true
        }));
        declId = setId;
      } else if (isStatic2 && !privateFieldsAsProperties) {
        declId = id3;
      }
      return functionDeclaration(cloneNode$i(declId), params, body, generator, async);
    }
    var thisContextVisitor = traverse.visitors.merge([{
      ThisExpression: function ThisExpression2(path2, state) {
        state.needsClassRef = true;
        path2.replaceWith(cloneNode$i(state.classRef));
      },
      MetaProperty: function(_MetaProperty) {
        function MetaProperty2(_x) {
          return _MetaProperty.apply(this, arguments);
        }
        MetaProperty2.toString = function() {
          return _MetaProperty.toString();
        };
        return MetaProperty2;
      }(function(path2) {
        var meta2 = path2.get("meta");
        var property2 = path2.get("property");
        var scope2 = path2.scope;
        if (meta2.isIdentifier({
          name: "new"
        }) && property2.isIdentifier({
          name: "target"
        })) {
          path2.replaceWith(scope2.buildUndefinedNode());
        }
      })
    }, environmentVisitor]);
    var innerReferencesVisitor = {
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        if (path2.scope.bindingIdentifierEquals(path2.node.name, state.innerBinding)) {
          state.needsClassRef = true;
          path2.node.name = state.classRef.name;
        }
      }
    };
    function replaceThisContext(path2, ref2, getSuperRef, file2, isStaticBlock$1, constantSuper, innerBindingRef) {
      var _state$classRef;
      var state = {
        classRef: ref2,
        needsClassRef: false,
        innerBinding: innerBindingRef
      };
      var replacer = new ReplaceSupers({
        methodPath: path2,
        constantSuper,
        file: file2,
        refToPreserve: ref2,
        getSuperRef,
        getObjectRef: function getObjectRef() {
          state.needsClassRef = true;
          return isStaticBlock != null && isStaticBlock(path2.node) || path2.node["static"] ? ref2 : memberExpression$b(ref2, identifier$j("prototype"));
        }
      });
      replacer.replace();
      if (isStaticBlock$1 || path2.isProperty()) {
        path2.traverse(thisContextVisitor, state);
      }
      if ((_state$classRef = state.classRef) != null && _state$classRef.name && state.classRef.name !== (innerBindingRef == null ? void 0 : innerBindingRef.name)) {
        path2.traverse(innerReferencesVisitor, state);
      }
      return state.needsClassRef;
    }
    function isNameOrLength(_ref3) {
      var key2 = _ref3.key, computed = _ref3.computed;
      if (key2.type === "Identifier") {
        return !computed && (key2.name === "name" || key2.name === "length");
      }
      if (key2.type === "StringLiteral") {
        return key2.value === "name" || key2.value === "length";
      }
      return false;
    }
    function buildFieldsInitNodes(ref2, superRef, props, privateNamesMap, state, setPublicClassFields, privateFieldsAsProperties, constantSuper, innerBindingRef) {
      var needsClassRef = false;
      var injectSuperRef;
      var staticNodes = [];
      var instanceNodes = [];
      var pureStaticNodes = [];
      var getSuperRef = isIdentifier$i(superRef) ? function() {
        return superRef;
      } : function() {
        var _injectSuperRef;
        (_injectSuperRef = injectSuperRef) != null ? _injectSuperRef : injectSuperRef = props[0].scope.generateUidIdentifierBasedOnNode(superRef);
        return injectSuperRef;
      };
      for (var _iterator4 = _createForOfIteratorHelperLoose(props), _step4; !(_step4 = _iterator4()).done; ) {
        var prop2 = _step4.value;
        prop2.isClassProperty() && assertFieldTransformed(prop2);
        var isStatic2 = !(isStaticBlock != null && isStaticBlock(prop2.node)) && prop2.node["static"];
        var isInstance = !isStatic2;
        var isPrivate2 = prop2.isPrivate();
        var isPublic = !isPrivate2;
        var isField = prop2.isProperty();
        var isMethod2 = !isField;
        var isStaticBlock$1 = prop2.isStaticBlock == null ? void 0 : prop2.isStaticBlock();
        if (isStatic2 || isMethod2 && isPrivate2 || isStaticBlock$1) {
          var replaced = replaceThisContext(prop2, ref2, getSuperRef, state, isStaticBlock$1, constantSuper, innerBindingRef);
          needsClassRef = needsClassRef || replaced;
        }
        switch (true) {
          case isStaticBlock$1: {
            var blockBody = prop2.node.body;
            if (blockBody.length === 1 && isExpressionStatement$4(blockBody[0])) {
              staticNodes.push(blockBody[0]);
            } else {
              staticNodes.push(template$2.statement.ast(_templateObject19 || (_templateObject19 = _taggedTemplateLiteralLoose(["(() => { ", " })()"])), blockBody));
            }
            break;
          }
          case (isStatic2 && isPrivate2 && isField && privateFieldsAsProperties):
            needsClassRef = true;
            staticNodes.push(buildPrivateFieldInitLoose(cloneNode$i(ref2), prop2, privateNamesMap));
            break;
          case (isStatic2 && isPrivate2 && isField && !privateFieldsAsProperties):
            needsClassRef = true;
            staticNodes.push(buildPrivateStaticFieldInitSpec(prop2, privateNamesMap));
            break;
          case (isStatic2 && isPublic && isField && setPublicClassFields):
            if (!isNameOrLength(prop2.node)) {
              needsClassRef = true;
              staticNodes.push(buildPublicFieldInitLoose(cloneNode$i(ref2), prop2));
              break;
            }
          case (isStatic2 && isPublic && isField && !setPublicClassFields):
            needsClassRef = true;
            staticNodes.push(buildPublicFieldInitSpec(cloneNode$i(ref2), prop2, state));
            break;
          case (isInstance && isPrivate2 && isField && privateFieldsAsProperties):
            instanceNodes.push(buildPrivateFieldInitLoose(thisExpression$4(), prop2, privateNamesMap));
            break;
          case (isInstance && isPrivate2 && isField && !privateFieldsAsProperties):
            instanceNodes.push(buildPrivateInstanceFieldInitSpec(thisExpression$4(), prop2, privateNamesMap, state));
            break;
          case (isInstance && isPrivate2 && isMethod2 && privateFieldsAsProperties):
            instanceNodes.unshift(buildPrivateMethodInitLoose(thisExpression$4(), prop2, privateNamesMap));
            pureStaticNodes.push(buildPrivateMethodDeclaration(prop2, privateNamesMap, privateFieldsAsProperties));
            break;
          case (isInstance && isPrivate2 && isMethod2 && !privateFieldsAsProperties):
            instanceNodes.unshift(buildPrivateInstanceMethodInitSpec(thisExpression$4(), prop2, privateNamesMap, state));
            pureStaticNodes.push(buildPrivateMethodDeclaration(prop2, privateNamesMap, privateFieldsAsProperties));
            break;
          case (isStatic2 && isPrivate2 && isMethod2 && !privateFieldsAsProperties):
            needsClassRef = true;
            staticNodes.unshift(buildPrivateStaticFieldInitSpec(prop2, privateNamesMap));
            pureStaticNodes.push(buildPrivateMethodDeclaration(prop2, privateNamesMap, privateFieldsAsProperties));
            break;
          case (isStatic2 && isPrivate2 && isMethod2 && privateFieldsAsProperties):
            needsClassRef = true;
            staticNodes.unshift(buildPrivateStaticMethodInitLoose(cloneNode$i(ref2), prop2, state, privateNamesMap));
            pureStaticNodes.push(buildPrivateMethodDeclaration(prop2, privateNamesMap, privateFieldsAsProperties));
            break;
          case (isInstance && isPublic && isField && setPublicClassFields):
            instanceNodes.push(buildPublicFieldInitLoose(thisExpression$4(), prop2));
            break;
          case (isInstance && isPublic && isField && !setPublicClassFields):
            instanceNodes.push(buildPublicFieldInitSpec(thisExpression$4(), prop2, state));
            break;
          default:
            throw new Error("Unreachable.");
        }
      }
      return {
        staticNodes: staticNodes.filter(Boolean),
        instanceNodes: instanceNodes.filter(Boolean),
        pureStaticNodes: pureStaticNodes.filter(Boolean),
        wrapClass: function wrapClass(path2) {
          for (var _iterator5 = _createForOfIteratorHelperLoose(props), _step5; !(_step5 = _iterator5()).done; ) {
            var prop3 = _step5.value;
            prop3.remove();
          }
          if (injectSuperRef) {
            path2.scope.push({
              id: cloneNode$i(injectSuperRef)
            });
            path2.set("superClass", assignmentExpression$c("=", injectSuperRef, path2.node.superClass));
          }
          if (!needsClassRef)
            return path2;
          if (path2.isClassExpression()) {
            path2.scope.push({
              id: ref2
            });
            path2.replaceWith(assignmentExpression$c("=", cloneNode$i(ref2), path2.node));
          } else if (!path2.node.id) {
            path2.node.id = ref2;
          }
          return path2;
        }
      };
    }
    var _templateObject$j, _templateObject2$8, _templateObject3$7, _templateObject4$3;
    function hasOwnDecorators(node2) {
      return !!(node2.decorators && node2.decorators.length);
    }
    function hasDecorators(node2) {
      return hasOwnDecorators(node2) || node2.body.body.some(hasOwnDecorators);
    }
    function prop(key2, value) {
      if (!value)
        return null;
      return objectProperty$2(identifier$j(key2), value);
    }
    function method4(key2, body) {
      return objectMethod("method", identifier$j(key2), [], blockStatement$6(body));
    }
    function takeDecorators(node2) {
      var result;
      if (node2.decorators && node2.decorators.length > 0) {
        result = arrayExpression$2(node2.decorators.map(function(decorator2) {
          return decorator2.expression;
        }));
      }
      node2.decorators = void 0;
      return result;
    }
    function getKey2(node2) {
      if (node2.computed) {
        return node2.key;
      } else if (isIdentifier$i(node2.key)) {
        return stringLiteral$8(node2.key.name);
      } else {
        return stringLiteral$8(String(node2.key.value));
      }
    }
    function extractElementDescriptor(classRef, superRef, path2) {
      var node2 = path2.node, scope2 = path2.scope;
      var isMethod2 = path2.isClassMethod();
      if (path2.isPrivate()) {
        throw path2.buildCodeFrameError("Private " + (isMethod2 ? "methods" : "fields") + " in decorated classes are not supported yet.");
      }
      new ReplaceSupers({
        methodPath: path2,
        objectRef: classRef,
        superRef,
        file: this,
        refToPreserve: classRef
      }).replace();
      var properties = [prop("kind", stringLiteral$8(isClassMethod$1(node2) ? node2.kind : "field")), prop("decorators", takeDecorators(node2)), prop("static", !(isStaticBlock != null && isStaticBlock(node2)) && node2["static"] && booleanLiteral$5(true)), prop("key", getKey2(node2))].filter(Boolean);
      if (isClassMethod$1(node2)) {
        var id3 = node2.computed ? null : node2.key;
        toExpression$1(node2);
        properties.push(prop("value", nameFunction({
          node: node2,
          id: id3,
          scope: scope2
        }) || node2));
      } else if (isClassProperty(node2) && node2.value) {
        properties.push(method4("value", template$2.statements.ast(_templateObject$j || (_templateObject$j = _taggedTemplateLiteralLoose(["return ", ""])), node2.value)));
      } else {
        properties.push(prop("value", scope2.buildUndefinedNode()));
      }
      path2.remove();
      return objectExpression$4(properties);
    }
    function addDecorateHelper(file2) {
      try {
        return file2.addHelper("decorate");
      } catch (err) {
        if (err.code === "BABEL_HELPER_UNKNOWN") {
          err.message += "\n  '@babel/plugin-transform-decorators' in non-legacy mode requires '@babel/core' version ^7.0.2 and you appear to be using an older version.";
        }
        throw err;
      }
    }
    function buildDecoratedClass(ref2, path2, elements, file2) {
      var node2 = path2.node, scope2 = path2.scope;
      var initializeId = scope2.generateUidIdentifier("initialize");
      var isDeclaration2 = node2.id && path2.isDeclaration();
      var isStrict2 = path2.isInStrictMode();
      var superClass = node2.superClass;
      node2.type = "ClassDeclaration";
      if (!node2.id)
        node2.id = cloneNode$i(ref2);
      var superId;
      if (superClass) {
        superId = scope2.generateUidIdentifierBasedOnNode(node2.superClass, "super");
        node2.superClass = superId;
      }
      var classDecorators = takeDecorators(node2);
      var definitions = arrayExpression$2(elements.filter(function(element) {
        return !element.node["abstract"];
      }).map(extractElementDescriptor.bind(file2, node2.id, superId)));
      var wrapperCall = template$2.expression.ast(_templateObject2$8 || (_templateObject2$8 = _taggedTemplateLiteralLoose(["\n    ", "(\n      ", ",\n      function (", ", ", ") {\n        ", "\n        return { F: ", ", d: ", " };\n      },\n      ", "\n    )\n  "])), addDecorateHelper(file2), classDecorators || nullLiteral$2(), initializeId, superClass ? cloneNode$i(superId) : null, node2, cloneNode$i(node2.id), definitions, superClass);
      if (!isStrict2) {
        wrapperCall.arguments[1].body.directives.push(directive$1(directiveLiteral$1("use strict")));
      }
      var replacement = wrapperCall;
      var classPathDesc = "arguments.1.body.body.0";
      if (isDeclaration2) {
        replacement = template$2.statement.ast(_templateObject3$7 || (_templateObject3$7 = _taggedTemplateLiteralLoose(["let ", " = ", ""])), ref2, wrapperCall);
        classPathDesc = "declarations.0.init." + classPathDesc;
      }
      return {
        instanceNodes: [template$2.statement.ast(_templateObject4$3 || (_templateObject4$3 = _taggedTemplateLiteralLoose(["", "(this)"])), cloneNode$i(initializeId))],
        wrapClass: function wrapClass(path3) {
          path3.replaceWith(replacement);
          return path3.get(classPathDesc);
        }
      };
    }
    var _templateObject$i;
    var findBareSupers = traverse.visitors.merge([{
      Super: function(_Super) {
        function Super2(_x) {
          return _Super.apply(this, arguments);
        }
        Super2.toString = function() {
          return _Super.toString();
        };
        return Super2;
      }(function(path2) {
        var node2 = path2.node, parentPath = path2.parentPath;
        if (parentPath.isCallExpression({
          callee: node2
        })) {
          this.push(parentPath);
        }
      })
    }, environmentVisitor]);
    var referenceVisitor = {
      "TSTypeAnnotation|TypeAnnotation": function TSTypeAnnotationTypeAnnotation(path2) {
        path2.skip();
      },
      ReferencedIdentifier: function ReferencedIdentifier2(path2) {
        if (this.scope.hasOwnBinding(path2.node.name)) {
          this.scope.rename(path2.node.name);
          path2.skip();
        }
      }
    };
    function handleClassTDZ(path2, state) {
      if (state.classBinding && state.classBinding === path2.scope.getBinding(path2.node.name)) {
        var classNameTDZError = state.file.addHelper("classNameTDZError");
        var throwNode = callExpression$e(classNameTDZError, [stringLiteral$8(path2.node.name)]);
        path2.replaceWith(sequenceExpression$7([throwNode, path2.node]));
        path2.skip();
      }
    }
    var classFieldDefinitionEvaluationTDZVisitor = {
      ReferencedIdentifier: handleClassTDZ
    };
    function injectInitialization(path2, constructor, nodes2, renamer) {
      if (!nodes2.length)
        return;
      var isDerived = !!path2.node.superClass;
      if (!constructor) {
        var newConstructor = classMethod("constructor", identifier$j("constructor"), [], blockStatement$6([]));
        if (isDerived) {
          newConstructor.params = [restElement$1(identifier$j("args"))];
          newConstructor.body.body.push(template$2.statement.ast(_templateObject$i || (_templateObject$i = _taggedTemplateLiteralLoose(["super(...args)"]))));
        }
        var _ref3 = path2.get("body").unshiftContainer("body", newConstructor);
        var _ref22 = _slicedToArray$12(_ref3, 1);
        constructor = _ref22[0];
      }
      if (renamer) {
        renamer(referenceVisitor, {
          scope: constructor.scope
        });
      }
      if (isDerived) {
        var bareSupers = [];
        constructor.traverse(findBareSupers, bareSupers);
        var isFirst = true;
        for (var _i3 = 0, _bareSupers = bareSupers; _i3 < _bareSupers.length; _i3++) {
          var bareSuper = _bareSupers[_i3];
          if (isFirst) {
            bareSuper.insertAfter(nodes2);
            isFirst = false;
          } else {
            bareSuper.insertAfter(nodes2.map(function(n2) {
              return cloneNode$i(n2);
            }));
          }
        }
      } else {
        constructor.get("body").unshiftContainer("body", nodes2);
      }
    }
    function extractComputedKeys(ref2, path2, computedPaths, file2) {
      var declarations = [];
      var state = {
        classBinding: path2.node.id && path2.scope.getBinding(path2.node.id.name),
        file: file2
      };
      for (var _iterator2 = _createForOfIteratorHelperLoose(computedPaths), _step2; !(_step2 = _iterator2()).done; ) {
        var computedPath = _step2.value;
        var computedKey = computedPath.get("key");
        if (computedKey.isReferencedIdentifier()) {
          handleClassTDZ(computedKey, state);
        } else {
          computedKey.traverse(classFieldDefinitionEvaluationTDZVisitor, state);
        }
        var computedNode = computedPath.node;
        if (!computedKey.isConstantExpression()) {
          var ident = path2.scope.generateUidIdentifierBasedOnNode(computedNode.key);
          path2.scope.push({
            id: ident,
            kind: "let"
          });
          declarations.push(expressionStatement$a(assignmentExpression$c("=", cloneNode$i(ident), computedNode.key)));
          computedNode.key = cloneNode$i(ident);
        }
      }
      return declarations;
    }
    var FEATURES$1 = Object.freeze({
      fields: 1 << 1,
      privateMethods: 1 << 2,
      decorators: 1 << 3,
      privateIn: 1 << 4,
      staticBlocks: 1 << 5
    });
    var featuresSameLoose = /* @__PURE__ */ new Map([[FEATURES$1.fields, "@babel/plugin-proposal-class-properties"], [FEATURES$1.privateMethods, "@babel/plugin-proposal-private-methods"], [FEATURES$1.privateIn, "@babel/plugin-proposal-private-property-in-object"]]);
    var featuresKey$1 = "@babel/plugin-class-features/featuresKey";
    var looseKey = "@babel/plugin-class-features/looseKey";
    var looseLowPriorityKey = "@babel/plugin-class-features/looseLowPriorityKey/#__internal__@babel/preset-env__please-overwrite-loose-instead-of-throwing";
    function enableFeature$1(file2, feature, loose) {
      if (!hasFeature$1(file2, feature) || canIgnoreLoose(file2, feature)) {
        file2.set(featuresKey$1, file2.get(featuresKey$1) | feature);
        if (loose === "#__internal__@babel/preset-env__prefer-true-but-false-is-ok-if-it-prevents-an-error") {
          setLoose(file2, feature, true);
          file2.set(looseLowPriorityKey, file2.get(looseLowPriorityKey) | feature);
        } else if (loose === "#__internal__@babel/preset-env__prefer-false-but-true-is-ok-if-it-prevents-an-error") {
          setLoose(file2, feature, false);
          file2.set(looseLowPriorityKey, file2.get(looseLowPriorityKey) | feature);
        } else {
          setLoose(file2, feature, loose);
        }
      }
      var resolvedLoose;
      var higherPriorityPluginName;
      for (var _iterator2 = _createForOfIteratorHelperLoose(featuresSameLoose), _step2; !(_step2 = _iterator2()).done; ) {
        var _step$value = _slicedToArray$12(_step2.value, 2), _mask = _step$value[0], _name = _step$value[1];
        if (!hasFeature$1(file2, _mask))
          continue;
        var _loose = isLoose(file2, _mask);
        if (canIgnoreLoose(file2, _mask)) {
          continue;
        } else if (resolvedLoose === !_loose) {
          throw new Error("'loose' mode configuration must be the same for @babel/plugin-proposal-class-properties, @babel/plugin-proposal-private-methods and @babel/plugin-proposal-private-property-in-object (when they are enabled).");
        } else {
          resolvedLoose = _loose;
          higherPriorityPluginName = _name;
        }
      }
      if (resolvedLoose !== void 0) {
        for (var _iterator22 = _createForOfIteratorHelperLoose(featuresSameLoose), _step22; !(_step22 = _iterator22()).done; ) {
          var _step2$value = _slicedToArray$12(_step22.value, 2), mask = _step2$value[0], name2 = _step2$value[1];
          if (hasFeature$1(file2, mask) && isLoose(file2, mask) !== resolvedLoose) {
            setLoose(file2, mask, resolvedLoose);
            console.warn('Though the "loose" option was set to "' + !resolvedLoose + '" in your @babel/preset-env ' + ("config, it will not be used for " + name2 + ' since the "loose" mode option was set to ') + ('"' + resolvedLoose + '" for ' + higherPriorityPluginName + '.\nThe "loose" option must be the ') + "same for @babel/plugin-proposal-class-properties, @babel/plugin-proposal-private-methods and @babel/plugin-proposal-private-property-in-object (when they are enabled): you can silence this warning by explicitly adding\n" + ('	["' + name2 + '", { "loose": ' + resolvedLoose + " }]\n") + 'to the "plugins" section of your Babel config.');
          }
        }
      }
    }
    function hasFeature$1(file2, feature) {
      return !!(file2.get(featuresKey$1) & feature);
    }
    function isLoose(file2, feature) {
      return !!(file2.get(looseKey) & feature);
    }
    function setLoose(file2, feature, loose) {
      if (loose)
        file2.set(looseKey, file2.get(looseKey) | feature);
      else
        file2.set(looseKey, file2.get(looseKey) & ~feature);
      file2.set(looseLowPriorityKey, file2.get(looseLowPriorityKey) & ~feature);
    }
    function canIgnoreLoose(file2, feature) {
      return !!(file2.get(looseLowPriorityKey) & feature);
    }
    function shouldTransform$2(path2, file2) {
      var decoratorPath = null;
      var publicFieldPath = null;
      var privateFieldPath = null;
      var privateMethodPath = null;
      var staticBlockPath = null;
      if (hasOwnDecorators(path2.node)) {
        decoratorPath = path2.get("decorators.0");
      }
      for (var _iterator3 = _createForOfIteratorHelperLoose(path2.get("body.body")), _step3; !(_step3 = _iterator3()).done; ) {
        var el = _step3.value;
        if (!decoratorPath && hasOwnDecorators(el.node)) {
          decoratorPath = el.get("decorators.0");
        }
        if (!publicFieldPath && el.isClassProperty()) {
          publicFieldPath = el;
        }
        if (!privateFieldPath && el.isClassPrivateProperty()) {
          privateFieldPath = el;
        }
        if (!privateMethodPath && el.isClassPrivateMethod != null && el.isClassPrivateMethod()) {
          privateMethodPath = el;
        }
        if (!staticBlockPath && el.isStaticBlock != null && el.isStaticBlock()) {
          staticBlockPath = el;
        }
      }
      if (decoratorPath && privateFieldPath) {
        throw privateFieldPath.buildCodeFrameError("Private fields in decorated classes are not supported yet.");
      }
      if (decoratorPath && privateMethodPath) {
        throw privateMethodPath.buildCodeFrameError("Private methods in decorated classes are not supported yet.");
      }
      if (decoratorPath && !hasFeature$1(file2, FEATURES$1.decorators)) {
        throw path2.buildCodeFrameError('Decorators are not enabled.\nIf you are using ["@babel/plugin-proposal-decorators", { "legacy": true }], make sure it comes *before* "@babel/plugin-proposal-class-properties" and enable loose mode, like so:\n	["@babel/plugin-proposal-decorators", { "legacy": true }]\n	["@babel/plugin-proposal-class-properties", { "loose": true }]');
      }
      if (privateMethodPath && !hasFeature$1(file2, FEATURES$1.privateMethods)) {
        throw privateMethodPath.buildCodeFrameError("Class private methods are not enabled. Please add `@babel/plugin-proposal-private-method` to your configuration.");
      }
      if ((publicFieldPath || privateFieldPath) && !hasFeature$1(file2, FEATURES$1.fields) && !hasFeature$1(file2, FEATURES$1.privateMethods)) {
        throw path2.buildCodeFrameError("Class fields are not enabled. Please add `@babel/plugin-proposal-class-properties` to your configuration.");
      }
      if (staticBlockPath && !hasFeature$1(file2, FEATURES$1.staticBlocks)) {
        throw path2.buildCodeFrameError("Static class blocks are not enabled. Please add `@babel/plugin-proposal-class-static-block` to your configuration.");
      }
      if (decoratorPath || privateMethodPath || staticBlockPath) {
        return true;
      }
      if ((publicFieldPath || privateFieldPath) && hasFeature$1(file2, FEATURES$1.fields)) {
        return true;
      }
      return false;
    }
    var version$2 = "7.17.9".split(".").reduce(function(v22, x2) {
      return v22 * 1e5 + +x2;
    }, 0);
    var versionKey$1 = "@babel/plugin-class-features/version";
    function createClassFeaturePlugin(_ref3) {
      var name2 = _ref3.name, feature = _ref3.feature, loose = _ref3.loose, manipulateOptions = _ref3.manipulateOptions, _ref$api = _ref3.api, api = _ref$api === void 0 ? {
        assumption: function assumption() {
          return void 0;
        }
      } : _ref$api, inherits3 = _ref3.inherits;
      var setPublicClassFields = api.assumption("setPublicClassFields");
      var privateFieldsAsProperties = api.assumption("privateFieldsAsProperties");
      var constantSuper = api.assumption("constantSuper");
      var noDocumentAll = api.assumption("noDocumentAll");
      if (loose === true) {
        var explicit = [];
        if (setPublicClassFields !== void 0) {
          explicit.push('"setPublicClassFields"');
        }
        if (privateFieldsAsProperties !== void 0) {
          explicit.push('"privateFieldsAsProperties"');
        }
        if (explicit.length !== 0) {
          console.warn("[" + name2 + ']: You are using the "loose: true" option and you are' + (" explicitly setting a value for the " + explicit.join(" and ")) + (" assumption" + (explicit.length > 1 ? "s" : "") + '. The "loose" option') + ` can cause incompatibilities with the other class features plugins, so it's recommended that you replace it with the following top-level option:
	"assumptions": {
		"setPublicClassFields": true,
		"privateFieldsAsProperties": true
	}`);
        }
      }
      return {
        name: name2,
        manipulateOptions,
        inherits: inherits3,
        pre: function pre() {
          enableFeature$1(this.file, feature, loose);
          if (!this.file.get(versionKey$1) || this.file.get(versionKey$1) < version$2) {
            this.file.set(versionKey$1, version$2);
          }
        },
        visitor: {
          Class: function(_Class) {
            function Class(_x, _x2) {
              return _Class.apply(this, arguments);
            }
            Class.toString = function() {
              return _Class.toString();
            };
            return Class;
          }(function(path2, state) {
            if (this.file.get(versionKey$1) !== version$2)
              return;
            if (!shouldTransform$2(path2, this.file))
              return;
            if (path2.isClassDeclaration())
              assertFieldTransformed(path2);
            var loose2 = isLoose(this.file, feature);
            var constructor;
            var isDecorated = hasDecorators(path2.node);
            var props = [];
            var elements = [];
            var computedPaths = [];
            var privateNames = /* @__PURE__ */ new Set();
            var body = path2.get("body");
            for (var _iterator2 = _createForOfIteratorHelperLoose(body.get("body")), _step2; !(_step2 = _iterator2()).done; ) {
              var _path = _step2.value;
              if ((_path.isClassProperty() || _path.isClassMethod()) && _path.node.computed) {
                computedPaths.push(_path);
              }
              if (_path.isPrivate()) {
                var _name = _path.node.key.id.name;
                var getName3 = "get " + _name;
                var setName = "set " + _name;
                if (_path.isClassPrivateMethod()) {
                  if (_path.node.kind === "get") {
                    if (privateNames.has(getName3) || privateNames.has(_name) && !privateNames.has(setName)) {
                      throw _path.buildCodeFrameError("Duplicate private field");
                    }
                    privateNames.add(getName3).add(_name);
                  } else if (_path.node.kind === "set") {
                    if (privateNames.has(setName) || privateNames.has(_name) && !privateNames.has(getName3)) {
                      throw _path.buildCodeFrameError("Duplicate private field");
                    }
                    privateNames.add(setName).add(_name);
                  }
                } else {
                  if (privateNames.has(_name) && !privateNames.has(getName3) && !privateNames.has(setName) || privateNames.has(_name) && (privateNames.has(getName3) || privateNames.has(setName))) {
                    throw _path.buildCodeFrameError("Duplicate private field");
                  }
                  privateNames.add(_name);
                }
              }
              if (_path.isClassMethod({
                kind: "constructor"
              })) {
                constructor = _path;
              } else {
                elements.push(_path);
                if (_path.isProperty() || _path.isPrivate() || _path.isStaticBlock != null && _path.isStaticBlock()) {
                  props.push(_path);
                }
              }
            }
            if (!props.length && !isDecorated)
              return;
            var innerBinding = path2.node.id;
            var ref2;
            if (!innerBinding || path2.isClassExpression()) {
              nameFunction(path2);
              ref2 = path2.scope.generateUidIdentifier("class");
            } else {
              ref2 = cloneNode$i(path2.node.id);
            }
            var privateNamesMap = buildPrivateNamesMap(props);
            var privateNamesNodes = buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties != null ? privateFieldsAsProperties : loose2, state);
            transformPrivateNamesUsage(ref2, path2, privateNamesMap, {
              privateFieldsAsProperties: privateFieldsAsProperties != null ? privateFieldsAsProperties : loose2,
              noDocumentAll,
              innerBinding
            }, state);
            var keysNodes, staticNodes, instanceNodes, pureStaticNodes, wrapClass;
            if (isDecorated) {
              staticNodes = pureStaticNodes = keysNodes = [];
              var _buildDecoratedClass = buildDecoratedClass(ref2, path2, elements, this.file);
              instanceNodes = _buildDecoratedClass.instanceNodes;
              wrapClass = _buildDecoratedClass.wrapClass;
            } else {
              keysNodes = extractComputedKeys(ref2, path2, computedPaths, this.file);
              var _buildFieldsInitNodes = buildFieldsInitNodes(ref2, path2.node.superClass, props, privateNamesMap, state, setPublicClassFields != null ? setPublicClassFields : loose2, privateFieldsAsProperties != null ? privateFieldsAsProperties : loose2, constantSuper != null ? constantSuper : loose2, innerBinding);
              staticNodes = _buildFieldsInitNodes.staticNodes;
              pureStaticNodes = _buildFieldsInitNodes.pureStaticNodes;
              instanceNodes = _buildFieldsInitNodes.instanceNodes;
              wrapClass = _buildFieldsInitNodes.wrapClass;
            }
            if (instanceNodes.length > 0) {
              injectInitialization(path2, constructor, instanceNodes, function(referenceVisitor2, state2) {
                if (isDecorated)
                  return;
                for (var _iterator22 = _createForOfIteratorHelperLoose(props), _step22; !(_step22 = _iterator22()).done; ) {
                  var prop2 = _step22.value;
                  if (isStaticBlock != null && isStaticBlock(prop2.node) || prop2.node["static"])
                    continue;
                  prop2.traverse(referenceVisitor2, state2);
                }
              });
            }
            var wrappedPath = wrapClass(path2);
            wrappedPath.insertBefore([].concat(_toConsumableArray2(privateNamesNodes), _toConsumableArray2(keysNodes)));
            if (staticNodes.length > 0) {
              wrappedPath.insertAfter(staticNodes);
            }
            if (pureStaticNodes.length > 0) {
              wrappedPath.find(function(parent) {
                return parent.isStatement() || parent.isDeclaration();
              }).insertAfter(pureStaticNodes);
            }
          }),
          ExportDefaultDeclaration: function(_ExportDefaultDeclaration) {
            function ExportDefaultDeclaration2(_x3) {
              return _ExportDefaultDeclaration.apply(this, arguments);
            }
            ExportDefaultDeclaration2.toString = function() {
              return _ExportDefaultDeclaration.toString();
            };
            return ExportDefaultDeclaration2;
          }(function(path2) {
            if (this.file.get(versionKey$1) !== version$2)
              return;
            var decl = path2.get("declaration");
            if (decl.isClassDeclaration() && hasDecorators(decl.node)) {
              if (decl.node.id) {
                splitExportDeclaration(path2);
              } else {
                decl.node.type = "ClassExpression";
              }
            }
          })
        }
      };
    }
    var _proposalClassProperties = declare(function(api, options) {
      api.assertVersion(7);
      return createClassFeaturePlugin({
        name: "proposal-class-properties",
        api,
        feature: FEATURES$1.fields,
        loose: options.loose,
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classProperties", "classPrivateProperties");
        }
      });
    });
    var lib$p = {};
    Object.defineProperty(lib$p, "__esModule", {
      value: true
    });
    lib$p["default"] = void 0;
    var _helperPluginUtils$o = require$$0$5;
    var _default$o = (0, _helperPluginUtils$o.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-class-static-block",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classStaticBlock");
        }
      };
    });
    lib$p["default"] = _default$o;
    var _templateObject$h;
    function generateUid(scope2, denyList) {
      var name2 = "";
      var uid2;
      var i2 = 1;
      do {
        uid2 = scope2._generateUid(name2, i2);
        i2++;
      } while (denyList.has(uid2));
      return uid2;
    }
    var _proposalClassStaticBlock = declare(function(_ref3) {
      var t3 = _ref3.types, template2 = _ref3.template, assertVersion2 = _ref3.assertVersion;
      assertVersion2("^7.12.0");
      return {
        name: "proposal-class-static-block",
        inherits: lib$p["default"],
        pre: function pre() {
          enableFeature$1(this.file, FEATURES$1.staticBlocks, false);
        },
        visitor: {
          ClassBody: function(_ClassBody) {
            function ClassBody2(_x) {
              return _ClassBody.apply(this, arguments);
            }
            ClassBody2.toString = function() {
              return _ClassBody.toString();
            };
            return ClassBody2;
          }(function(classBody2) {
            var scope2 = classBody2.scope;
            var privateNames = /* @__PURE__ */ new Set();
            var body = classBody2.get("body");
            for (var _iterator2 = _createForOfIteratorHelperLoose(body), _step2; !(_step2 = _iterator2()).done; ) {
              var path2 = _step2.value;
              if (path2.isPrivate()) {
                privateNames.add(path2.get("key.id").node.name);
              }
            }
            for (var _iterator22 = _createForOfIteratorHelperLoose(body), _step22; !(_step22 = _iterator22()).done; ) {
              var _path = _step22.value;
              if (!_path.isStaticBlock())
                continue;
              var staticBlockPrivateId = generateUid(scope2, privateNames);
              privateNames.add(staticBlockPrivateId);
              var staticBlockRef = t3.privateName(t3.identifier(staticBlockPrivateId));
              var replacement = void 0;
              var blockBody = _path.node.body;
              if (blockBody.length === 1 && t3.isExpressionStatement(blockBody[0])) {
                replacement = blockBody[0].expression;
              } else {
                replacement = template2.expression.ast(_templateObject$h || (_templateObject$h = _taggedTemplateLiteralLoose(["(() => { ", " })()"])), blockBody);
              }
              _path.replaceWith(t3.classPrivateProperty(staticBlockRef, replacement, [], true));
            }
          })
        }
      };
    });
    var buildClassDecorator = template$2("\n  DECORATOR(CLASS_REF = INNER) || CLASS_REF;\n");
    var buildClassPrototype = template$2("\n  CLASS_REF.prototype;\n");
    var buildGetDescriptor = template$2("\n    Object.getOwnPropertyDescriptor(TARGET, PROPERTY);\n");
    var buildGetObjectInitializer = template$2("\n    (TEMP = Object.getOwnPropertyDescriptor(TARGET, PROPERTY), (TEMP = TEMP ? TEMP.value : undefined), {\n        enumerable: true,\n        configurable: true,\n        writable: true,\n        initializer: function(){\n            return TEMP;\n        }\n    })\n");
    var WARNING_CALLS = /* @__PURE__ */ new WeakSet();
    function applyEnsureOrdering(path2) {
      var decorators = (path2.isClass() ? [path2].concat(path2.get("body.body")) : path2.get("properties")).reduce(function(acc, prop2) {
        return acc.concat(prop2.node.decorators || []);
      }, []);
      var identDecorators = decorators.filter(function(decorator2) {
        return !isIdentifier$i(decorator2.expression);
      });
      if (identDecorators.length === 0)
        return;
      return sequenceExpression$7(identDecorators.map(function(decorator2) {
        var expression2 = decorator2.expression;
        var id3 = decorator2.expression = path2.scope.generateDeclaredUidIdentifier("dec");
        return assignmentExpression$c("=", id3, expression2);
      }).concat([path2.node]));
    }
    function applyClassDecorators(classPath) {
      if (!hasClassDecorators(classPath.node))
        return;
      var decorators = classPath.node.decorators || [];
      classPath.node.decorators = null;
      var name2 = classPath.scope.generateDeclaredUidIdentifier("class");
      return decorators.map(function(dec) {
        return dec.expression;
      }).reverse().reduce(function(acc, decorator2) {
        return buildClassDecorator({
          CLASS_REF: cloneNode$i(name2),
          DECORATOR: cloneNode$i(decorator2),
          INNER: acc
        }).expression;
      }, classPath.node);
    }
    function hasClassDecorators(classNode) {
      return !!(classNode.decorators && classNode.decorators.length);
    }
    function applyMethodDecorators(path2, state) {
      if (!hasMethodDecorators(path2.node.body.body))
        return;
      return applyTargetDecorators(path2, state, path2.node.body.body);
    }
    function hasMethodDecorators(body) {
      return body.some(function(node2) {
        var _node$decorators;
        return (_node$decorators = node2.decorators) == null ? void 0 : _node$decorators.length;
      });
    }
    function applyObjectDecorators(path2, state) {
      if (!hasMethodDecorators(path2.node.properties))
        return;
      return applyTargetDecorators(path2, state, path2.node.properties);
    }
    function applyTargetDecorators(path2, state, decoratedProps) {
      var name2 = path2.scope.generateDeclaredUidIdentifier(path2.isClass() ? "class" : "obj");
      var exprs = decoratedProps.reduce(function(acc, node2) {
        var decorators = node2.decorators || [];
        node2.decorators = null;
        if (decorators.length === 0)
          return acc;
        if (node2.computed) {
          throw path2.buildCodeFrameError("Computed method/property decorators are not yet supported.");
        }
        var property2 = isLiteral$7(node2.key) ? node2.key : stringLiteral$8(node2.key.name);
        var target = path2.isClass() && !node2["static"] ? buildClassPrototype({
          CLASS_REF: name2
        }).expression : name2;
        if (isClassProperty(node2, {
          "static": false
        })) {
          var descriptor = path2.scope.generateDeclaredUidIdentifier("descriptor");
          var initializer = node2.value ? functionExpression$3(null, [], blockStatement$6([returnStatement$3(node2.value)])) : nullLiteral$2();
          node2.value = callExpression$e(state.addHelper("initializerWarningHelper"), [descriptor, thisExpression$4()]);
          WARNING_CALLS.add(node2.value);
          acc.push(assignmentExpression$c("=", cloneNode$i(descriptor), callExpression$e(state.addHelper("applyDecoratedDescriptor"), [cloneNode$i(target), cloneNode$i(property2), arrayExpression$2(decorators.map(function(dec) {
            return cloneNode$i(dec.expression);
          })), objectExpression$4([objectProperty$2(identifier$j("configurable"), booleanLiteral$5(true)), objectProperty$2(identifier$j("enumerable"), booleanLiteral$5(true)), objectProperty$2(identifier$j("writable"), booleanLiteral$5(true)), objectProperty$2(identifier$j("initializer"), initializer)])])));
        } else {
          acc.push(callExpression$e(state.addHelper("applyDecoratedDescriptor"), [cloneNode$i(target), cloneNode$i(property2), arrayExpression$2(decorators.map(function(dec) {
            return cloneNode$i(dec.expression);
          })), isObjectProperty$5(node2) || isClassProperty(node2, {
            "static": true
          }) ? buildGetObjectInitializer({
            TEMP: path2.scope.generateDeclaredUidIdentifier("init"),
            TARGET: cloneNode$i(target),
            PROPERTY: cloneNode$i(property2)
          }).expression : buildGetDescriptor({
            TARGET: cloneNode$i(target),
            PROPERTY: cloneNode$i(property2)
          }).expression, cloneNode$i(target)]));
        }
        return acc;
      }, []);
      return sequenceExpression$7([assignmentExpression$c("=", cloneNode$i(name2), path2.node), sequenceExpression$7(exprs), cloneNode$i(name2)]);
    }
    function decoratedClassToExpression(_ref3) {
      var node2 = _ref3.node, scope2 = _ref3.scope;
      if (!hasClassDecorators(node2) && !hasMethodDecorators(node2.body.body)) {
        return;
      }
      var ref2 = node2.id ? cloneNode$i(node2.id) : scope2.generateUidIdentifier("class");
      return variableDeclaration$7("let", [variableDeclarator$7(ref2, toExpression$1(node2))]);
    }
    var legacyVisitor = {
      ExportDefaultDeclaration: function ExportDefaultDeclaration2(path2) {
        var decl = path2.get("declaration");
        if (!decl.isClassDeclaration())
          return;
        var replacement = decoratedClassToExpression(decl);
        if (replacement) {
          var _path$replaceWithMult = path2.replaceWithMultiple([replacement, exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$i(replacement.declarations[0].id), identifier$j("default"))])]), _path$replaceWithMult2 = _slicedToArray$12(_path$replaceWithMult, 1), varDeclPath = _path$replaceWithMult2[0];
          if (!decl.node.id) {
            path2.scope.registerDeclaration(varDeclPath);
          }
        }
      },
      ClassDeclaration: function ClassDeclaration2(path2) {
        var replacement = decoratedClassToExpression(path2);
        if (replacement) {
          path2.replaceWith(replacement);
        }
      },
      ClassExpression: function ClassExpression2(path2, state) {
        var decoratedClass = applyEnsureOrdering(path2) || applyClassDecorators(path2) || applyMethodDecorators(path2, state);
        if (decoratedClass)
          path2.replaceWith(decoratedClass);
      },
      ObjectExpression: function ObjectExpression2(path2, state) {
        var decoratedObject = applyEnsureOrdering(path2) || applyObjectDecorators(path2, state);
        if (decoratedObject)
          path2.replaceWith(decoratedObject);
      },
      AssignmentExpression: function AssignmentExpression2(path2, state) {
        if (!WARNING_CALLS.has(path2.node.right))
          return;
        path2.replaceWith(callExpression$e(state.addHelper("initializerDefineProperty"), [cloneNode$i(path2.get("left.object").node), stringLiteral$8(path2.get("left.property").node.name || path2.get("left.property").node.value), cloneNode$i(path2.get("right.arguments")[0].node), cloneNode$i(path2.get("right.arguments")[1].node)]));
      },
      CallExpression: function CallExpression2(path2, state) {
        if (path2.node.arguments.length !== 3)
          return;
        if (!WARNING_CALLS.has(path2.node.arguments[2]))
          return;
        if (path2.node.callee.name !== state.addHelper("defineProperty").name) {
          return;
        }
        path2.replaceWith(callExpression$e(state.addHelper("initializerDefineProperty"), [cloneNode$i(path2.get("arguments")[0].node), cloneNode$i(path2.get("arguments")[1].node), cloneNode$i(path2.get("arguments.2.arguments")[0].node), cloneNode$i(path2.get("arguments.2.arguments")[1].node)]));
      }
    };
    var _templateObject$g;
    function incrementId(id3, idx) {
      if (idx === void 0) {
        idx = id3.length - 1;
      }
      if (idx === -1) {
        id3.unshift(65);
        return;
      }
      var current2 = id3[idx];
      if (current2 === 90) {
        id3[idx] = 97;
      } else if (current2 === 122) {
        id3[idx] = 65;
        incrementId(id3, idx - 1);
      } else {
        id3[idx] = current2 + 1;
      }
    }
    function createPrivateUidGeneratorForClass(classPath) {
      var currentPrivateId = [];
      var privateNames = /* @__PURE__ */ new Set();
      classPath.traverse({
        PrivateName: function PrivateName2(path2) {
          privateNames.add(path2.node.id.name);
        }
      });
      return function() {
        var reifiedId;
        do {
          incrementId(currentPrivateId);
          reifiedId = String.fromCharCode.apply(String, currentPrivateId);
        } while (privateNames.has(reifiedId));
        return privateName(identifier$j(reifiedId));
      };
    }
    function createLazyPrivateUidGeneratorForClass(classPath) {
      var generator;
      return function() {
        if (!generator) {
          generator = createPrivateUidGeneratorForClass(classPath);
        }
        return generator();
      };
    }
    function replaceClassWithVar(path2) {
      if (path2.type === "ClassDeclaration") {
        var varId = path2.scope.generateUidIdentifierBasedOnNode(path2.node.id);
        var classId = identifier$j(path2.node.id.name);
        path2.scope.rename(classId.name, varId.name);
        path2.insertBefore(variableDeclaration$7("let", [variableDeclarator$7(varId)]));
        path2.get("id").replaceWith(classId);
        return [cloneNode$i(varId), path2];
      } else {
        var className;
        var _varId;
        if (path2.node.id) {
          className = path2.node.id.name;
          _varId = path2.scope.parent.generateDeclaredUidIdentifier(className);
          path2.scope.rename(className, _varId.name);
        } else if (path2.parentPath.node.type === "VariableDeclarator" && path2.parentPath.node.id.type === "Identifier") {
          className = path2.parentPath.node.id.name;
          _varId = path2.scope.parent.generateDeclaredUidIdentifier(className);
        } else {
          _varId = path2.scope.parent.generateDeclaredUidIdentifier("decorated_class");
        }
        var newClassExpr = classExpression(className && identifier$j(className), path2.node.superClass, path2.node.body);
        var _path$replaceWith = path2.replaceWith(sequenceExpression$7([newClassExpr, _varId])), _path$replaceWith2 = _slicedToArray$12(_path$replaceWith, 1), newPath = _path$replaceWith2[0];
        return [cloneNode$i(_varId), newPath.get("expressions.0")];
      }
    }
    function generateClassProperty(key2, value, isStatic2) {
      if (key2.type === "PrivateName") {
        return classPrivateProperty(key2, value, void 0, isStatic2);
      } else {
        return classProperty(key2, value, void 0, void 0, isStatic2);
      }
    }
    function addProxyAccessorsFor(element, originalKey, targetKey, isComputed) {
      if (isComputed === void 0) {
        isComputed = false;
      }
      var isStatic2 = element.node["static"];
      var getterBody = blockStatement$6([returnStatement$3(memberExpression$b(thisExpression$4(), cloneNode$i(targetKey)))]);
      var setterBody = blockStatement$6([expressionStatement$a(assignmentExpression$c("=", memberExpression$b(thisExpression$4(), cloneNode$i(targetKey)), identifier$j("v")))]);
      var getter, setter;
      if (originalKey.type === "PrivateName") {
        getter = classPrivateMethod("get", cloneNode$i(originalKey), [], getterBody, isStatic2);
        setter = classPrivateMethod("set", cloneNode$i(originalKey), [identifier$j("v")], setterBody, isStatic2);
      } else {
        getter = classMethod("get", cloneNode$i(originalKey), [], getterBody, isComputed, isStatic2);
        setter = classMethod("set", cloneNode$i(originalKey), [identifier$j("v")], setterBody, isComputed, isStatic2);
      }
      element.insertAfter(setter);
      element.insertAfter(getter);
    }
    function extractProxyAccessorsFor(targetKey) {
      return [functionExpression$3(void 0, [], blockStatement$6([returnStatement$3(memberExpression$b(thisExpression$4(), cloneNode$i(targetKey)))])), functionExpression$3(void 0, [identifier$j("value")], blockStatement$6([expressionStatement$a(assignmentExpression$c("=", memberExpression$b(thisExpression$4(), cloneNode$i(targetKey)), identifier$j("value")))]))];
    }
    var FIELD = 0;
    var ACCESSOR = 1;
    var METHOD = 2;
    var GETTER = 3;
    var SETTER = 4;
    var STATIC = 5;
    function getElementKind(element) {
      switch (element.node.type) {
        case "ClassProperty":
        case "ClassPrivateProperty":
          return FIELD;
        case "ClassAccessorProperty":
          return ACCESSOR;
        case "ClassMethod":
        case "ClassPrivateMethod":
          if (element.node.kind === "get") {
            return GETTER;
          } else if (element.node.kind === "set") {
            return SETTER;
          } else {
            return METHOD;
          }
      }
    }
    function isDecoratorInfo(info) {
      return "decorators" in info;
    }
    function filteredOrderedDecoratorInfo(info) {
      var filtered = info.filter(isDecoratorInfo);
      return [].concat(_toConsumableArray2(filtered.filter(function(el) {
        return el.isStatic && el.kind >= ACCESSOR && el.kind <= SETTER;
      })), _toConsumableArray2(filtered.filter(function(el) {
        return !el.isStatic && el.kind >= ACCESSOR && el.kind <= SETTER;
      })), _toConsumableArray2(filtered.filter(function(el) {
        return el.isStatic && el.kind === FIELD;
      })), _toConsumableArray2(filtered.filter(function(el) {
        return !el.isStatic && el.kind === FIELD;
      })));
    }
    function generateDecorationExprs(info) {
      return arrayExpression$2(filteredOrderedDecoratorInfo(info).map(function(el) {
        var decs = el.decorators.length > 1 ? arrayExpression$2(el.decorators) : el.decorators[0];
        var kind = el.isStatic ? el.kind + STATIC : el.kind;
        var decInfo = [decs, numericLiteral$7(kind), el.name];
        var privateMethods = el.privateMethods;
        if (Array.isArray(privateMethods)) {
          decInfo.push.apply(decInfo, _toConsumableArray2(privateMethods));
        } else if (privateMethods) {
          decInfo.push(privateMethods);
        }
        return arrayExpression$2(decInfo);
      }));
    }
    function extractElementLocalAssignments(decorationInfo) {
      var localIds = [];
      for (var _iterator2 = _createForOfIteratorHelperLoose(filteredOrderedDecoratorInfo(decorationInfo)), _step2; !(_step2 = _iterator2()).done; ) {
        var el = _step2.value;
        var locals = el.locals;
        if (Array.isArray(locals)) {
          localIds.push.apply(localIds, _toConsumableArray2(locals));
        } else if (locals !== void 0) {
          localIds.push(locals);
        }
      }
      return localIds;
    }
    function addCallAccessorsFor(element, key2, getId2, setId) {
      element.insertAfter(classPrivateMethod("get", cloneNode$i(key2), [], blockStatement$6([returnStatement$3(callExpression$e(cloneNode$i(getId2), [thisExpression$4()]))])));
      element.insertAfter(classPrivateMethod("set", cloneNode$i(key2), [identifier$j("v")], blockStatement$6([expressionStatement$a(callExpression$e(cloneNode$i(setId), [thisExpression$4(), identifier$j("v")]))])));
    }
    function isNotTsParameter(node2) {
      return node2.type !== "TSParameterProperty";
    }
    function movePrivateAccessor(element, key2, methodLocalVar, isStatic2) {
      var params;
      var block;
      if (element.node.kind === "set") {
        params = [identifier$j("v")];
        block = [expressionStatement$a(callExpression$e(methodLocalVar, [thisExpression$4(), identifier$j("v")]))];
      } else {
        params = [];
        block = [returnStatement$3(callExpression$e(methodLocalVar, [thisExpression$4()]))];
      }
      element.replaceWith(classPrivateMethod(element.node.kind, cloneNode$i(key2), params, blockStatement$6(block), isStatic2));
    }
    function isClassDecoratableElementPath(path2) {
      var type5 = path2.type;
      return type5 !== "TSDeclareMethod" && type5 !== "TSIndexSignature" && type5 !== "StaticBlock";
    }
    function staticBlockToIIFE(block) {
      return callExpression$e(arrowFunctionExpression$4([], blockStatement$6(block.body)), []);
    }
    function maybeSequenceExpression(exprs) {
      if (exprs.length === 0)
        return unaryExpression$6("void", numericLiteral$7(0));
      if (exprs.length === 1)
        return exprs[0];
      return sequenceExpression$7(exprs);
    }
    function transformClass$1(path2, state, constantSuper) {
      var body = path2.get("body.body");
      var classDecorators = path2.node.decorators;
      var hasElementDecorators = false;
      var generateClassPrivateUid = createLazyPrivateUidGeneratorForClass(path2);
      for (var _iterator2 = _createForOfIteratorHelperLoose(body), _step2; !(_step2 = _iterator2()).done; ) {
        var _element = _step2.value;
        if (!isClassDecoratableElementPath(_element)) {
          continue;
        }
        if (_element.node.decorators && _element.node.decorators.length > 0) {
          hasElementDecorators = true;
        } else if (_element.node.type === "ClassAccessorProperty") {
          var _element$node = _element.node, _key = _element$node.key, _value2 = _element$node.value, _isStatic = _element$node["static"];
          var _newId = generateClassPrivateUid();
          var valueNode = _value2 ? cloneNode$i(_value2) : void 0;
          var _newField = generateClassProperty(_newId, valueNode, _isStatic);
          var _element$replaceWith3 = _element.replaceWith(_newField), _element$replaceWith4 = _slicedToArray$12(_element$replaceWith3, 1), _newPath = _element$replaceWith4[0];
          addProxyAccessorsFor(_newPath, _key, _newId, _element.node.computed);
        }
      }
      if (!classDecorators && !hasElementDecorators)
        return;
      var elementDecoratorInfo = [];
      var firstFieldPath;
      var constructorPath;
      var requiresProtoInit = false;
      var requiresStaticInit = false;
      var decoratedPrivateMethods = /* @__PURE__ */ new Set();
      var protoInitLocal, staticInitLocal, classInitLocal, classLocal;
      var assignments = [];
      var scopeParent = path2.scope.parent;
      var memoiseExpression = function memoiseExpression2(expression2, hint) {
        var localEvaluatedId = scopeParent.generateDeclaredUidIdentifier(hint);
        assignments.push(assignmentExpression$c("=", localEvaluatedId, expression2));
        return cloneNode$i(localEvaluatedId);
      };
      if (classDecorators) {
        classInitLocal = scopeParent.generateDeclaredUidIdentifier("initClass");
        var _replaceClassWithVar = replaceClassWithVar(path2), _replaceClassWithVar2 = _slicedToArray$12(_replaceClassWithVar, 2), localId = _replaceClassWithVar2[0], classPath = _replaceClassWithVar2[1];
        path2 = classPath;
        classLocal = localId;
        path2.node.decorators = null;
        for (var _iterator3 = _createForOfIteratorHelperLoose(classDecorators), _step3; !(_step3 = _iterator3()).done; ) {
          var classDecorator = _step3.value;
          if (!scopeParent.isStatic(classDecorator.expression)) {
            classDecorator.expression = memoiseExpression(classDecorator.expression, "dec");
          }
        }
      } else {
        if (!path2.node.id) {
          path2.node.id = path2.scope.generateUidIdentifier("Class");
        }
        classLocal = cloneNode$i(path2.node.id);
      }
      if (hasElementDecorators) {
        for (var _iterator4 = _createForOfIteratorHelperLoose(body), _step4; !(_step4 = _iterator4()).done; ) {
          var element = _step4.value;
          if (!isClassDecoratableElementPath(element)) {
            continue;
          }
          var node2 = element.node;
          var decorators = element.get("decorators");
          var hasDecorators2 = Array.isArray(decorators) && decorators.length > 0;
          if (hasDecorators2) {
            for (var _iterator5 = _createForOfIteratorHelperLoose(decorators), _step5; !(_step5 = _iterator5()).done; ) {
              var decoratorPath = _step5.value;
              if (!scopeParent.isStatic(decoratorPath.node.expression)) {
                decoratorPath.node.expression = memoiseExpression(decoratorPath.node.expression, "dec");
              }
            }
          }
          var isComputed = "computed" in element.node && element.node.computed === true;
          if (isComputed) {
            if (!scopeParent.isStatic(node2.key)) {
              node2.key = memoiseExpression(node2.key, "computedKey");
            }
          }
          var kind = getElementKind(element);
          var key2 = node2.key;
          var isPrivate2 = key2.type === "PrivateName";
          var isStatic2 = !!element.node["static"];
          var name2 = "computedKey";
          if (isPrivate2) {
            name2 = key2.id.name;
          } else if (!isComputed && key2.type === "Identifier") {
            name2 = key2.name;
          }
          if (element.isClassMethod({
            kind: "constructor"
          })) {
            constructorPath = element;
          }
          if (hasDecorators2) {
            var _locals = void 0;
            var privateMethods = void 0;
            if (kind === ACCESSOR) {
              var _ref3 = element.node, value = _ref3.value;
              var params = [thisExpression$4()];
              if (value) {
                params.push(cloneNode$i(value));
              }
              var newId = generateClassPrivateUid();
              var newFieldInitId = element.scope.parent.generateDeclaredUidIdentifier("init_" + name2);
              var newValue = callExpression$e(cloneNode$i(newFieldInitId), params);
              var newField = generateClassProperty(newId, newValue, isStatic2);
              var _element$replaceWith = element.replaceWith(newField), _element$replaceWith2 = _slicedToArray$12(_element$replaceWith, 1), newPath = _element$replaceWith2[0];
              if (isPrivate2) {
                privateMethods = extractProxyAccessorsFor(newId);
                var getId2 = newPath.scope.parent.generateDeclaredUidIdentifier("get_" + name2);
                var setId = newPath.scope.parent.generateDeclaredUidIdentifier("set_" + name2);
                addCallAccessorsFor(newPath, key2, getId2, setId);
                _locals = [newFieldInitId, getId2, setId];
              } else {
                addProxyAccessorsFor(newPath, key2, newId, isComputed);
                _locals = newFieldInitId;
              }
            } else if (kind === FIELD) {
              var initId = element.scope.parent.generateDeclaredUidIdentifier("init_" + name2);
              var valuePath = element.get("value");
              valuePath.replaceWith(callExpression$e(cloneNode$i(initId), [thisExpression$4(), valuePath.node].filter(function(v22) {
                return v22;
              })));
              _locals = initId;
              if (isPrivate2) {
                privateMethods = extractProxyAccessorsFor(key2);
              }
            } else if (isPrivate2) {
              _locals = element.scope.parent.generateDeclaredUidIdentifier("call_" + name2);
              var replaceSupers = new ReplaceSupers({
                constantSuper,
                methodPath: element,
                objectRef: classLocal,
                superRef: path2.node.superClass,
                file: state,
                refToPreserve: classLocal
              });
              replaceSupers.replace();
              var _ref22 = element.node, _params2 = _ref22.params, _body = _ref22.body, isAsync2 = _ref22.async;
              privateMethods = functionExpression$3(void 0, _params2.filter(isNotTsParameter), _body, isAsync2);
              if (kind === GETTER || kind === SETTER) {
                movePrivateAccessor(element, cloneNode$i(key2), cloneNode$i(_locals), isStatic2);
              } else {
                var _node = element.node;
                path2.node.body.body.unshift(classPrivateProperty(key2, cloneNode$i(_locals), [], _node["static"]));
                decoratedPrivateMethods.add(key2.id.name);
                element.remove();
              }
            }
            var nameExpr = void 0;
            if (isComputed) {
              nameExpr = cloneNode$i(key2);
            } else if (key2.type === "PrivateName") {
              nameExpr = stringLiteral$8(key2.id.name);
            } else if (key2.type === "Identifier") {
              nameExpr = stringLiteral$8(key2.name);
            } else {
              nameExpr = cloneNode$i(key2);
            }
            elementDecoratorInfo.push({
              kind,
              decorators: decorators.map(function(d2) {
                return d2.node.expression;
              }),
              name: nameExpr,
              isStatic: isStatic2,
              privateMethods,
              locals: _locals
            });
            if (kind !== FIELD) {
              if (isStatic2) {
                requiresStaticInit = true;
              } else {
                requiresProtoInit = true;
              }
            }
            if (element.node) {
              element.node.decorators = null;
            }
            if (!firstFieldPath && (kind === FIELD || kind === ACCESSOR)) {
              firstFieldPath = element;
            }
          }
        }
      }
      var elementDecorations = generateDecorationExprs(elementDecoratorInfo);
      var classDecorations = arrayExpression$2((classDecorators || []).map(function(d2) {
        return d2.expression;
      }));
      var locals = extractElementLocalAssignments(elementDecoratorInfo);
      if (requiresProtoInit) {
        protoInitLocal = scopeParent.generateDeclaredUidIdentifier("initProto");
        locals.push(protoInitLocal);
        var protoInitCall = callExpression$e(cloneNode$i(protoInitLocal), [thisExpression$4()]);
        if (firstFieldPath) {
          var _value = firstFieldPath.get("value");
          var _body2 = [protoInitCall];
          if (_value.node) {
            _body2.push(_value.node);
          }
          _value.replaceWith(sequenceExpression$7(_body2));
        } else if (constructorPath) {
          if (path2.node.superClass) {
            path2.traverse({
              CallExpression: {
                exit: function exit(path3) {
                  if (!path3.get("callee").isSuper())
                    return;
                  path3.replaceWith(callExpression$e(cloneNode$i(protoInitLocal), [path3.node]));
                  path3.skip();
                }
              }
            });
          } else {
            constructorPath.node.body.body.unshift(expressionStatement$a(protoInitCall));
          }
        } else {
          var _body3 = [expressionStatement$a(protoInitCall)];
          if (path2.node.superClass) {
            _body3.unshift(expressionStatement$a(callExpression$e(_super$1(), [spreadElement$2(identifier$j("args"))])));
          }
          path2.node.body.body.unshift(classMethod("constructor", identifier$j("constructor"), [restElement$1(identifier$j("args"))], blockStatement$6(_body3)));
        }
      }
      if (requiresStaticInit) {
        staticInitLocal = scopeParent.generateDeclaredUidIdentifier("initStatic");
        locals.push(staticInitLocal);
      }
      if (decoratedPrivateMethods.size > 0) {
        path2.traverse({
          PrivateName: function PrivateName2(path3) {
            if (!decoratedPrivateMethods.has(path3.node.id.name))
              return;
            var parentPath = path3.parentPath;
            var parentParentPath = parentPath.parentPath;
            if (parentParentPath.node.type === "AssignmentExpression" && parentParentPath.node.left === parentPath.node || parentParentPath.node.type === "UpdateExpression" || parentParentPath.node.type === "RestElement" || parentParentPath.node.type === "ArrayPattern" || parentParentPath.node.type === "ObjectProperty" && parentParentPath.node.value === parentPath.node && parentParentPath.parentPath.type === "ObjectPattern" || parentParentPath.node.type === "ForOfStatement" && parentParentPath.node.left === parentPath.node) {
              throw path3.buildCodeFrameError('Decorated private methods are not updatable, but "#' + path3.node.id.name + '" is updated via this expression.');
            }
          }
        });
      }
      var classInitInjected = false;
      var classInitCall = classInitLocal && callExpression$e(cloneNode$i(classInitLocal), []);
      var originalClass = path2.node;
      if (classDecorators) {
        locals.push(classLocal, classInitLocal);
        var statics = [];
        var staticBlocks = [];
        path2.get("body.body").forEach(function(element2) {
          if (element2.isStaticBlock()) {
            staticBlocks.push(element2.node);
            element2.remove();
            return;
          }
          var isProperty2 = element2.isClassProperty() || element2.isClassPrivateProperty();
          if ((isProperty2 || element2.isClassPrivateMethod()) && element2.node["static"]) {
            if (isProperty2 && staticBlocks.length > 0) {
              var allValues = staticBlocks.map(staticBlockToIIFE);
              if (element2.node.value)
                allValues.push(element2.node.value);
              element2.node.value = maybeSequenceExpression(allValues);
              staticBlocks = [];
            }
            element2.node["static"] = false;
            statics.push(element2.node);
            element2.remove();
          }
        });
        if (statics.length > 0 || staticBlocks.length > 0) {
          var staticsClass = template$2.expression.ast(_templateObject$g || (_templateObject$g = _taggedTemplateLiteralLoose(["\n        class extends ", " {}\n      "])), state.addHelper("identity"));
          staticsClass.body.body = [staticBlock$1([toStatement(path2.node, false)])].concat(statics);
          var constructorBody = [];
          var newExpr = newExpression(staticsClass, []);
          if (staticBlocks.length > 0) {
            constructorBody.push.apply(constructorBody, _toConsumableArray2(staticBlocks.map(staticBlockToIIFE)));
          }
          if (classInitCall) {
            classInitInjected = true;
            constructorBody.push(classInitCall);
          }
          if (constructorBody.length > 0) {
            constructorBody.unshift(callExpression$e(_super$1(), [cloneNode$i(classLocal)]));
            staticsClass.body.body.push(classMethod("constructor", identifier$j("constructor"), [], blockStatement$6([expressionStatement$a(sequenceExpression$7(constructorBody))])));
          } else {
            newExpr.arguments.push(cloneNode$i(classLocal));
          }
          path2.replaceWith(newExpr);
        }
      }
      if (!classInitInjected && classInitCall) {
        path2.node.body.body.push(staticBlock$1([expressionStatement$a(classInitCall)]));
      }
      originalClass.body.body.unshift(staticBlock$1([expressionStatement$a(assignmentExpression$c("=", arrayPattern(locals), callExpression$e(state.addHelper("applyDecs"), [thisExpression$4(), elementDecorations, classDecorations]))), requiresStaticInit && expressionStatement$a(callExpression$e(cloneNode$i(staticInitLocal), [thisExpression$4()]))].filter(Boolean)));
      path2.insertBefore(assignments.map(function(expr) {
        return expressionStatement$a(expr);
      }));
      path2.scope.crawl();
      return path2;
    }
    function transformer2021_12(_ref3, _ref42) {
      var _assumption;
      var assertVersion2 = _ref3.assertVersion, assumption = _ref3.assumption;
      var loose = _ref42.loose;
      assertVersion2("^7.16.0");
      var VISITED = /* @__PURE__ */ new WeakSet();
      var constantSuper = (_assumption = assumption("constantSuper")) != null ? _assumption : loose;
      return {
        name: "proposal-decorators",
        inherits: syntaxDecorators,
        visitor: {
          "ExportNamedDeclaration|ExportDefaultDeclaration": function ExportNamedDeclarationExportDefaultDeclaration(path2) {
            var _declaration$decorato;
            var declaration = path2.node.declaration;
            if ((declaration == null ? void 0 : declaration.type) === "ClassDeclaration" && ((_declaration$decorato = declaration.decorators) == null ? void 0 : _declaration$decorato.length) > 0) {
              splitExportDeclaration(path2);
            }
          },
          Class: function(_Class) {
            function Class(_x, _x2) {
              return _Class.apply(this, arguments);
            }
            Class.toString = function() {
              return _Class.toString();
            };
            return Class;
          }(function(path2, state) {
            if (VISITED.has(path2))
              return;
            var newPath = transformClass$1(path2, state, constantSuper);
            if (newPath)
              VISITED.add(newPath);
          })
        }
      };
    }
    var proposalDecorators = declare(function(api, options) {
      api.assertVersion(7);
      var legacy = options.legacy, version3 = options.version;
      if (legacy || version3 === "legacy") {
        return {
          name: "proposal-decorators",
          inherits: syntaxDecorators,
          visitor: legacyVisitor
        };
      } else if (version3 === "2021-12") {
        return transformer2021_12(api, options);
      } else {
        return createClassFeaturePlugin({
          name: "proposal-decorators",
          api,
          feature: FEATURES$1.decorators,
          inherits: syntaxDecorators
        });
      }
    });
    var proposalDoExpressions = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-do-expressions",
        inherits: syntaxDoExpressions,
        visitor: {
          DoExpression: {
            exit: function exit(path2) {
              var node2 = path2.node;
              if (node2.async) {
                return;
              }
              var body = node2.body.body;
              if (body.length) {
                path2.replaceExpressionWithStatements(body);
              } else {
                path2.replaceWith(path2.scope.buildUndefinedNode());
              }
            }
          }
        }
      };
    });
    var lib$o = {};
    Object.defineProperty(lib$o, "__esModule", {
      value: true
    });
    lib$o["default"] = void 0;
    var _helperPluginUtils$n = require$$0$5;
    var _default$n = (0, _helperPluginUtils$n.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-dynamic-import",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("dynamicImport");
        }
      };
    });
    lib$o["default"] = _default$n;
    var SUPPORTED_MODULES = ["commonjs", "amd", "systemjs"];
    var MODULES_NOT_FOUND = "@babel/plugin-proposal-dynamic-import depends on a modules\ntransform plugin. Supported plugins are:\n - @babel/plugin-transform-modules-commonjs ^7.4.0\n - @babel/plugin-transform-modules-amd ^7.4.0\n - @babel/plugin-transform-modules-systemjs ^7.4.0\n\nIf you are using Webpack or Rollup and thus don't want\nBabel to transpile your imports and exports, you can use\nthe @babel/plugin-syntax-dynamic-import plugin and let your\nbundler handle dynamic imports.\n";
    var _proposalDynamicImport = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-dynamic-import",
        inherits: lib$o["default"],
        pre: function pre() {
          this.file.set("@babel/plugin-proposal-dynamic-import", "7.16.7");
        },
        visitor: {
          Program: function Program2() {
            var modules2 = this.file.get("@babel/plugin-transform-modules-*");
            if (!SUPPORTED_MODULES.includes(modules2)) {
              throw new Error(MODULES_NOT_FOUND);
            }
          }
        }
      };
    });
    var proposalExportDefaultFrom = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-export-default-from",
        inherits: syntaxExportDefaultFrom,
        visitor: {
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var specifiers = node2.specifiers;
            if (!isExportDefaultSpecifier$1(specifiers[0]))
              return;
            var specifier = specifiers.shift();
            var exported = specifier.exported;
            var uid2 = scope2.generateUidIdentifier(exported.name);
            var nodes2 = [importDeclaration$1([importDefaultSpecifier$1(uid2)], cloneNode$i(node2.source)), exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$i(uid2), exported)])];
            if (specifiers.length >= 1) {
              nodes2.push(node2);
            }
            var _path$replaceWithMult = path2.replaceWithMultiple(nodes2), _path$replaceWithMult2 = _slicedToArray$12(_path$replaceWithMult, 1), importDeclaration2 = _path$replaceWithMult2[0];
            path2.scope.registerDeclaration(importDeclaration2);
          }
        }
      };
    });
    var lib$n = {};
    Object.defineProperty(lib$n, "__esModule", {
      value: true
    });
    lib$n["default"] = void 0;
    var _helperPluginUtils$m = require$$0$5;
    var _default$m = (0, _helperPluginUtils$m.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-export-namespace-from",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("exportNamespaceFrom");
        }
      };
    });
    lib$n["default"] = _default$m;
    var _proposalExportNamespaceFrom = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-export-namespace-from",
        inherits: lib$n["default"],
        visitor: {
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2) {
            var _exported$name;
            var node2 = path2.node, scope2 = path2.scope;
            var specifiers = node2.specifiers;
            var index3 = isExportDefaultSpecifier$1(specifiers[0]) ? 1 : 0;
            if (!isExportNamespaceSpecifier$1(specifiers[index3]))
              return;
            var nodes2 = [];
            if (index3 === 1) {
              nodes2.push(exportNamedDeclaration$2(null, [specifiers.shift()], node2.source));
            }
            var specifier = specifiers.shift();
            var exported = specifier.exported;
            var uid2 = scope2.generateUidIdentifier((_exported$name = exported.name) != null ? _exported$name : exported.value);
            nodes2.push(importDeclaration$1([importNamespaceSpecifier$1(uid2)], cloneNode$i(node2.source)), exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$i(uid2), exported)]));
            if (node2.specifiers.length >= 1) {
              nodes2.push(node2);
            }
            var _path$replaceWithMult = path2.replaceWithMultiple(nodes2), _path$replaceWithMult2 = _slicedToArray$12(_path$replaceWithMult, 1), importDeclaration2 = _path$replaceWithMult2[0];
            path2.scope.registerDeclaration(importDeclaration2);
          }
        }
      };
    });
    var proposalFunctionBind = declare(function(api) {
      api.assertVersion(7);
      function getTempId(scope2) {
        var id3 = scope2.path.getData("functionBind");
        if (id3)
          return cloneNode$i(id3);
        id3 = scope2.generateDeclaredUidIdentifier("context");
        return scope2.path.setData("functionBind", id3);
      }
      function getStaticContext(bind2, scope2) {
        var object4 = bind2.object || bind2.callee.object;
        return scope2.isStatic(object4) && (isSuper$3(object4) ? thisExpression$4() : object4);
      }
      function inferBindContext(bind2, scope2) {
        var staticContext = getStaticContext(bind2, scope2);
        if (staticContext)
          return cloneNode$i(staticContext);
        var tempId = getTempId(scope2);
        if (bind2.object) {
          bind2.callee = sequenceExpression$7([assignmentExpression$c("=", tempId, bind2.object), bind2.callee]);
        } else {
          bind2.callee.object = assignmentExpression$c("=", tempId, bind2.callee.object);
        }
        return cloneNode$i(tempId);
      }
      return {
        name: "proposal-function-bind",
        inherits: syntaxFunctionBind,
        visitor: {
          CallExpression: function CallExpression2(_ref3) {
            var node2 = _ref3.node, scope2 = _ref3.scope;
            var bind2 = node2.callee;
            if (!isBindExpression(bind2))
              return;
            var context = inferBindContext(bind2, scope2);
            node2.callee = memberExpression$b(bind2.callee, identifier$j("call"));
            node2.arguments.unshift(context);
          },
          BindExpression: function BindExpression2(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var context = inferBindContext(node2, scope2);
            path2.replaceWith(callExpression$e(memberExpression$b(node2.callee, identifier$j("bind")), [context]));
          }
        }
      };
    });
    var proposalFunctionSent = declare(function(api) {
      api.assertVersion(7);
      var isFunctionSent = function isFunctionSent2(node2) {
        return isIdentifier$i(node2.meta, {
          name: "function"
        }) && isIdentifier$i(node2.property, {
          name: "sent"
        });
      };
      var hasBeenReplaced = function hasBeenReplaced2(node2, sentId) {
        return isAssignmentExpression$4(node2) && isIdentifier$i(node2.left, {
          name: sentId
        });
      };
      var yieldVisitor = {
        Function: function Function2(path2) {
          path2.skip();
        },
        YieldExpression: function YieldExpression2(path2) {
          if (!hasBeenReplaced(path2.parent, this.sentId)) {
            path2.replaceWith(assignmentExpression$c("=", identifier$j(this.sentId), path2.node));
          }
        },
        MetaProperty: function MetaProperty2(path2) {
          if (isFunctionSent(path2.node)) {
            path2.replaceWith(identifier$j(this.sentId));
          }
        }
      };
      return {
        name: "proposal-function-sent",
        inherits: syntaxFunctionSent,
        visitor: {
          MetaProperty: function MetaProperty2(path2, state) {
            if (!isFunctionSent(path2.node))
              return;
            var fnPath = path2.getFunctionParent();
            if (!fnPath.node.generator) {
              throw new Error("Parent generator function not found");
            }
            var sentId = path2.scope.generateUid("function.sent");
            fnPath.traverse(yieldVisitor, {
              sentId
            });
            fnPath.node.body.body.unshift(variableDeclaration$7("let", [variableDeclarator$7(identifier$j(sentId), yieldExpression$2())]));
            wrapFunction(fnPath, state.addHelper("skipFirstGeneratorNext"));
          }
        }
      };
    });
    var lib$m = {};
    Object.defineProperty(lib$m, "__esModule", {
      value: true
    });
    lib$m["default"] = void 0;
    var _helperPluginUtils$l = require$$0$5;
    var _default$l = (0, _helperPluginUtils$l.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-json-strings",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("jsonStrings");
        }
      };
    });
    lib$m["default"] = _default$l;
    var _proposalJsonStrings = declare(function(api) {
      api.assertVersion(7);
      var regex2 = /(\\*)([\u2028\u2029])/g;
      function replace(match, escapes, separator) {
        var isEscaped = escapes.length % 2 === 1;
        if (isEscaped)
          return match;
        return escapes + "\\u" + separator.charCodeAt(0).toString(16);
      }
      return {
        name: "proposal-json-strings",
        inherits: lib$m["default"],
        visitor: {
          "DirectiveLiteral|StringLiteral": function DirectiveLiteralStringLiteral(_ref3) {
            var node2 = _ref3.node;
            var extra = node2.extra;
            if (!(extra != null && extra.raw))
              return;
            extra.raw = extra.raw.replace(regex2, replace);
          }
        }
      };
    });
    var lib$l = {};
    Object.defineProperty(lib$l, "__esModule", {
      value: true
    });
    lib$l["default"] = void 0;
    var _helperPluginUtils$k = require$$0$5;
    var _default$k = (0, _helperPluginUtils$k.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-logical-assignment-operators",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("logicalAssignment");
        }
      };
    });
    lib$l["default"] = _default$k;
    var _proposalLogicalAssignmentOperators = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-logical-assignment-operators",
        inherits: lib$l["default"],
        visitor: {
          AssignmentExpression: function AssignmentExpression2(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var operator = node2.operator, left = node2.left, right = node2.right;
            var operatorTrunc = operator.slice(0, -1);
            if (!LOGICAL_OPERATORS$3.includes(operatorTrunc)) {
              return;
            }
            var lhs = cloneNode$i(left);
            if (isMemberExpression$8(left)) {
              var object4 = left.object, property2 = left.property, computed = left.computed;
              var memo = scope2.maybeGenerateMemoised(object4);
              if (memo) {
                left.object = memo;
                lhs.object = assignmentExpression$c("=", cloneNode$i(memo), object4);
              }
              if (computed) {
                var _memo = scope2.maybeGenerateMemoised(property2);
                if (_memo) {
                  left.property = _memo;
                  lhs.property = assignmentExpression$c("=", cloneNode$i(_memo), property2);
                }
              }
            }
            path2.replaceWith(logicalExpression$3(operatorTrunc, lhs, assignmentExpression$c("=", left, right)));
          }
        }
      };
    });
    var lib$k = {};
    Object.defineProperty(lib$k, "__esModule", {
      value: true
    });
    lib$k["default"] = void 0;
    var _helperPluginUtils$j = require$$0$5;
    var _default$j = (0, _helperPluginUtils$j.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-nullish-coalescing-operator",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("nullishCoalescingOperator");
        }
      };
    });
    lib$k["default"] = _default$j;
    var _templateObject$f;
    var _proposalNullishCoalescingOperator = declare(function(api, _ref3) {
      var _api$assumption;
      var _ref$loose = _ref3.loose, loose = _ref$loose === void 0 ? false : _ref$loose;
      api.assertVersion(7);
      var noDocumentAll = (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : loose;
      return {
        name: "proposal-nullish-coalescing-operator",
        inherits: lib$k["default"],
        visitor: {
          LogicalExpression: function LogicalExpression2(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            if (node2.operator !== "??") {
              return;
            }
            var ref2;
            var assignment;
            if (scope2.isStatic(node2.left)) {
              ref2 = node2.left;
              assignment = cloneNode$i(node2.left);
            } else if (scope2.path.isPattern()) {
              path2.replaceWith(template$2.ast(_templateObject$f || (_templateObject$f = _taggedTemplateLiteralLoose(["(() => ", ")()"])), path2.node));
              return;
            } else {
              ref2 = scope2.generateUidIdentifierBasedOnNode(node2.left);
              scope2.push({
                id: cloneNode$i(ref2)
              });
              assignment = assignmentExpression$c("=", ref2, node2.left);
            }
            path2.replaceWith(conditionalExpression$3(noDocumentAll ? binaryExpression$4("!=", assignment, nullLiteral$2()) : logicalExpression$3("&&", binaryExpression$4("!==", assignment, nullLiteral$2()), binaryExpression$4("!==", cloneNode$i(ref2), scope2.buildUndefinedNode())), cloneNode$i(ref2), node2.right));
          }
        }
      };
    });
    var lib$j = {};
    Object.defineProperty(lib$j, "__esModule", {
      value: true
    });
    lib$j["default"] = void 0;
    var _helperPluginUtils$i = require$$0$5;
    var _default$i = (0, _helperPluginUtils$i.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-numeric-separator",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("numericSeparator");
        }
      };
    });
    lib$j["default"] = _default$i;
    function remover(_ref3) {
      var _extra$raw;
      var node2 = _ref3.node;
      var extra = node2.extra;
      if (extra != null && (_extra$raw = extra.raw) != null && _extra$raw.includes("_")) {
        extra.raw = extra.raw.replace(/_/g, "");
      }
    }
    var _proposalNumericSeparator = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-numeric-separator",
        inherits: lib$j["default"],
        visitor: {
          NumericLiteral: remover,
          BigIntLiteral: remover
        }
      };
    });
    var lib$i = {};
    Object.defineProperty(lib$i, "__esModule", {
      value: true
    });
    lib$i["default"] = void 0;
    var _helperPluginUtils$h = require$$0$5;
    var _default$h = (0, _helperPluginUtils$h.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-object-rest-spread",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("objectRestSpread");
        }
      };
    });
    lib$i["default"] = _default$h;
    var buildDefaultParam = template$2("\n  let VARIABLE_NAME =\n    arguments.length > ARGUMENT_KEY && arguments[ARGUMENT_KEY] !== undefined ?\n      arguments[ARGUMENT_KEY]\n    :\n      DEFAULT_VALUE;\n");
    var buildLooseDefaultParam = template$2("\n  if (ASSIGNMENT_IDENTIFIER === UNDEFINED) {\n    ASSIGNMENT_IDENTIFIER = DEFAULT_VALUE;\n  }\n");
    var buildLooseDestructuredDefaultParam = template$2("\n  let ASSIGNMENT_IDENTIFIER = PARAMETER_NAME === UNDEFINED ? DEFAULT_VALUE : PARAMETER_NAME ;\n");
    var buildSafeArgumentsAccess = template$2("\n  let $0 = arguments.length > $1 ? arguments[$1] : undefined;\n");
    var iifeVisitor = {
      "ReferencedIdentifier|BindingIdentifier": function ReferencedIdentifierBindingIdentifier(path2, state) {
        var scope2 = path2.scope, node2 = path2.node;
        var name2 = node2.name;
        if (name2 === "eval" || scope2.getBinding(name2) === state.scope.parent.getBinding(name2) && state.scope.hasOwnBinding(name2)) {
          state.needsOuterBinding = true;
          path2.stop();
        }
      },
      "TypeAnnotation|TSTypeAnnotation|TypeParameterDeclaration|TSTypeParameterDeclaration": function TypeAnnotationTSTypeAnnotationTypeParameterDeclarationTSTypeParameterDeclaration(path2) {
        return path2.skip();
      }
    };
    function convertFunctionParams(path2, ignoreFunctionLength, shouldTransformParam, replaceRestElement) {
      var params = path2.get("params");
      var isSimpleParameterList = params.every(function(param2) {
        return param2.isIdentifier();
      });
      if (isSimpleParameterList)
        return false;
      var node2 = path2.node, scope2 = path2.scope;
      var state = {
        stop: false,
        needsOuterBinding: false,
        scope: scope2
      };
      var body = [];
      var shadowedParams = /* @__PURE__ */ new Set();
      for (var _iterator2 = _createForOfIteratorHelperLoose(params), _step2; !(_step2 = _iterator2()).done; ) {
        var _param2 = _step2.value;
        for (var _i3 = 0, _Object$keys3 = Object.keys(_param2.getBindingIdentifiers()); _i3 < _Object$keys3.length; _i3++) {
          var _scope$bindings$name;
          var name2 = _Object$keys3[_i3];
          var constantViolations = (_scope$bindings$name = scope2.bindings[name2]) == null ? void 0 : _scope$bindings$name.constantViolations;
          if (constantViolations) {
            for (var _iterator4 = _createForOfIteratorHelperLoose(constantViolations), _step4; !(_step4 = _iterator4()).done; ) {
              var redeclarator = _step4.value;
              var _node = redeclarator.node;
              switch (_node.type) {
                case "VariableDeclarator": {
                  if (_node.init === null) {
                    var declaration = redeclarator.parentPath;
                    if (!declaration.parentPath.isFor() || declaration.parentPath.get("body") === declaration) {
                      redeclarator.remove();
                      break;
                    }
                  }
                  shadowedParams.add(name2);
                  break;
                }
                case "FunctionDeclaration":
                  shadowedParams.add(name2);
                  break;
              }
            }
          }
        }
      }
      if (shadowedParams.size === 0) {
        for (var _iterator22 = _createForOfIteratorHelperLoose(params), _step22; !(_step22 = _iterator22()).done; ) {
          var param = _step22.value;
          if (!param.isIdentifier())
            param.traverse(iifeVisitor, state);
          if (state.needsOuterBinding)
            break;
        }
      }
      var firstOptionalIndex = null;
      for (var i2 = 0; i2 < params.length; i2++) {
        var _param3 = params[i2];
        if (shouldTransformParam && !shouldTransformParam(i2)) {
          continue;
        }
        var transformedRestNodes = [];
        if (replaceRestElement) {
          replaceRestElement(_param3.parentPath, _param3, transformedRestNodes);
        }
        var paramIsAssignmentPattern = _param3.isAssignmentPattern();
        if (paramIsAssignmentPattern && (ignoreFunctionLength || node2.kind === "set")) {
          var left = _param3.get("left");
          var right = _param3.get("right");
          var undefinedNode = scope2.buildUndefinedNode();
          if (left.isIdentifier()) {
            body.push(buildLooseDefaultParam({
              ASSIGNMENT_IDENTIFIER: cloneNode$i(left.node),
              DEFAULT_VALUE: right.node,
              UNDEFINED: undefinedNode
            }));
            _param3.replaceWith(left.node);
          } else if (left.isObjectPattern() || left.isArrayPattern()) {
            var paramName = scope2.generateUidIdentifier();
            body.push(buildLooseDestructuredDefaultParam({
              ASSIGNMENT_IDENTIFIER: left.node,
              DEFAULT_VALUE: right.node,
              PARAMETER_NAME: cloneNode$i(paramName),
              UNDEFINED: undefinedNode
            }));
            _param3.replaceWith(paramName);
          }
        } else if (paramIsAssignmentPattern) {
          if (firstOptionalIndex === null)
            firstOptionalIndex = i2;
          var _left = _param3.get("left");
          var _right = _param3.get("right");
          var defNode = buildDefaultParam({
            VARIABLE_NAME: _left.node,
            DEFAULT_VALUE: _right.node,
            ARGUMENT_KEY: numericLiteral$7(i2)
          });
          body.push(defNode);
        } else if (firstOptionalIndex !== null) {
          var _defNode = buildSafeArgumentsAccess([_param3.node, numericLiteral$7(i2)]);
          body.push(_defNode);
        } else if (_param3.isObjectPattern() || _param3.isArrayPattern()) {
          var uid2 = path2.scope.generateUidIdentifier("ref");
          var _defNode2 = variableDeclaration$7("let", [variableDeclarator$7(_param3.node, uid2)]);
          body.push(_defNode2);
          _param3.replaceWith(cloneNode$i(uid2));
        }
        if (transformedRestNodes) {
          for (var _iterator3 = _createForOfIteratorHelperLoose(transformedRestNodes), _step3; !(_step3 = _iterator3()).done; ) {
            var transformedNode = _step3.value;
            body.push(transformedNode);
          }
        }
      }
      if (firstOptionalIndex !== null) {
        node2.params = node2.params.slice(0, firstOptionalIndex);
      }
      path2.ensureBlock();
      if (state.needsOuterBinding || shadowedParams.size > 0) {
        body.push(buildScopeIIFE(shadowedParams, path2.get("body").node));
        path2.set("body", blockStatement$6(body));
        var bodyPath = path2.get("body.body");
        var arrowPath = bodyPath[bodyPath.length - 1].get("argument.callee");
        arrowPath.arrowFunctionToExpression();
        arrowPath.node.generator = path2.node.generator;
        arrowPath.node.async = path2.node.async;
        path2.node.generator = false;
      } else {
        path2.get("body").unshiftContainer("body", body);
      }
      return true;
    }
    function buildScopeIIFE(shadowedParams, body) {
      var args = [];
      var params = [];
      for (var _iterator5 = _createForOfIteratorHelperLoose(shadowedParams), _step5; !(_step5 = _iterator5()).done; ) {
        var name2 = _step5.value;
        args.push(identifier$j(name2));
        params.push(identifier$j(name2));
      }
      return returnStatement$3(callExpression$e(arrowFunctionExpression$4(params, body), args));
    }
    var buildRest = template$2("\n  for (var LEN = ARGUMENTS.length,\n           ARRAY = new Array(ARRAY_LEN),\n           KEY = START;\n       KEY < LEN;\n       KEY++) {\n    ARRAY[ARRAY_KEY] = ARGUMENTS[KEY];\n  }\n");
    var restIndex = template$2("\n  (INDEX < OFFSET || ARGUMENTS.length <= INDEX) ? undefined : ARGUMENTS[INDEX]\n");
    var restIndexImpure = template$2("\n  REF = INDEX, (REF < OFFSET || ARGUMENTS.length <= REF) ? undefined : ARGUMENTS[REF]\n");
    var restLength = template$2("\n  ARGUMENTS.length <= OFFSET ? 0 : ARGUMENTS.length - OFFSET\n");
    function referencesRest(path2, state) {
      if (path2.node.name === state.name) {
        return path2.scope.bindingIdentifierEquals(state.name, state.outerBinding);
      }
      return false;
    }
    var memberExpressionOptimisationVisitor = {
      Scope: function Scope4(path2, state) {
        if (!path2.scope.bindingIdentifierEquals(state.name, state.outerBinding)) {
          path2.skip();
        }
      },
      Flow: function Flow2(path2) {
        if (path2.isTypeCastExpression())
          return;
        path2.skip();
      },
      Function: function Function2(path2, state) {
        var oldNoOptimise = state.noOptimise;
        state.noOptimise = true;
        path2.traverse(memberExpressionOptimisationVisitor, state);
        state.noOptimise = oldNoOptimise;
        path2.skip();
      },
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        var node2 = path2.node;
        if (node2.name === "arguments") {
          state.deopted = true;
        }
        if (!referencesRest(path2, state))
          return;
        if (state.noOptimise) {
          state.deopted = true;
        } else {
          var parentPath = path2.parentPath;
          if (parentPath.listKey === "params" && parentPath.key < state.offset) {
            return;
          }
          if (parentPath.isMemberExpression({
            object: node2
          })) {
            var grandparentPath = parentPath.parentPath;
            var argsOptEligible = !state.deopted && !(grandparentPath.isAssignmentExpression() && parentPath.node === grandparentPath.node.left || grandparentPath.isLVal() || grandparentPath.isForXStatement() || grandparentPath.isUpdateExpression() || grandparentPath.isUnaryExpression({
              operator: "delete"
            }) || (grandparentPath.isCallExpression() || grandparentPath.isNewExpression()) && parentPath.node === grandparentPath.node.callee);
            if (argsOptEligible) {
              if (parentPath.node.computed) {
                if (parentPath.get("property").isBaseType("number")) {
                  state.candidates.push({
                    cause: "indexGetter",
                    path: path2
                  });
                  return;
                }
              } else if (parentPath.node.property.name === "length") {
                state.candidates.push({
                  cause: "lengthGetter",
                  path: path2
                });
                return;
              }
            }
          }
          if (state.offset === 0 && parentPath.isSpreadElement()) {
            var call3 = parentPath.parentPath;
            if (call3.isCallExpression() && call3.node.arguments.length === 1) {
              state.candidates.push({
                cause: "argSpread",
                path: path2
              });
              return;
            }
          }
          state.references.push(path2);
        }
      },
      BindingIdentifier: function BindingIdentifier2(path2, state) {
        if (referencesRest(path2, state)) {
          state.deopted = true;
        }
      }
    };
    function getParamsCount(node2) {
      var count2 = node2.params.length;
      if (count2 > 0 && isIdentifier$i(node2.params[0], {
        name: "this"
      })) {
        count2 -= 1;
      }
      return count2;
    }
    function hasRest(node2) {
      var length = node2.params.length;
      return length > 0 && isRestElement$3(node2.params[length - 1]);
    }
    function optimiseIndexGetter(path2, argsId, offset3) {
      var offsetLiteral = numericLiteral$7(offset3);
      var index3;
      if (isNumericLiteral(path2.parent.property)) {
        index3 = numericLiteral$7(path2.parent.property.value + offset3);
      } else if (offset3 === 0) {
        index3 = path2.parent.property;
      } else {
        index3 = binaryExpression$4("+", path2.parent.property, cloneNode$i(offsetLiteral));
      }
      var scope2 = path2.scope;
      if (!scope2.isPure(index3)) {
        var temp = scope2.generateUidIdentifierBasedOnNode(index3);
        scope2.push({
          id: temp,
          kind: "var"
        });
        path2.parentPath.replaceWith(restIndexImpure({
          ARGUMENTS: argsId,
          OFFSET: offsetLiteral,
          INDEX: index3,
          REF: cloneNode$i(temp)
        }));
      } else {
        var parentPath = path2.parentPath;
        parentPath.replaceWith(restIndex({
          ARGUMENTS: argsId,
          OFFSET: offsetLiteral,
          INDEX: index3
        }));
        var offsetTestPath = parentPath.get("test").get("left");
        var valRes = offsetTestPath.evaluate();
        if (valRes.confident) {
          if (valRes.value === true) {
            parentPath.replaceWith(parentPath.scope.buildUndefinedNode());
          } else {
            parentPath.get("test").replaceWith(parentPath.get("test").get("right"));
          }
        }
      }
    }
    function optimiseLengthGetter(path2, argsId, offset3) {
      if (offset3) {
        path2.parentPath.replaceWith(restLength({
          ARGUMENTS: argsId,
          OFFSET: numericLiteral$7(offset3)
        }));
      } else {
        path2.replaceWith(argsId);
      }
    }
    function convertFunctionRest(path2) {
      var _state$references;
      var node2 = path2.node, scope2 = path2.scope;
      if (!hasRest(node2))
        return false;
      var rest = node2.params.pop().argument;
      if (rest.name === "arguments")
        scope2.rename(rest.name);
      var argsId = identifier$j("arguments");
      if (isPattern2(rest)) {
        var pattern5 = rest;
        rest = scope2.generateUidIdentifier("ref");
        var declar = variableDeclaration$7("let", [variableDeclarator$7(pattern5, rest)]);
        node2.body.body.unshift(declar);
      }
      var paramsCount = getParamsCount(node2);
      var state = {
        references: [],
        offset: paramsCount,
        argumentsNode: argsId,
        outerBinding: scope2.getBindingIdentifier(rest.name),
        candidates: [],
        name: rest.name,
        deopted: false
      };
      path2.traverse(memberExpressionOptimisationVisitor, state);
      if (!state.deopted && !state.references.length) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(state.candidates), _step2; !(_step2 = _iterator2()).done; ) {
          var _step$value = _step2.value, _path = _step$value.path, cause = _step$value.cause;
          var clonedArgsId = cloneNode$i(argsId);
          switch (cause) {
            case "indexGetter":
              optimiseIndexGetter(_path, clonedArgsId, state.offset);
              break;
            case "lengthGetter":
              optimiseLengthGetter(_path, clonedArgsId, state.offset);
              break;
            default:
              _path.replaceWith(clonedArgsId);
          }
        }
        return true;
      }
      (_state$references = state.references).push.apply(_state$references, _toConsumableArray2(state.candidates.map(function(_ref3) {
        var path3 = _ref3.path;
        return path3;
      })));
      var start2 = numericLiteral$7(paramsCount);
      var key2 = scope2.generateUidIdentifier("key");
      var len3 = scope2.generateUidIdentifier("len");
      var arrKey, arrLen;
      if (paramsCount) {
        arrKey = binaryExpression$4("-", cloneNode$i(key2), cloneNode$i(start2));
        arrLen = conditionalExpression$3(binaryExpression$4(">", cloneNode$i(len3), cloneNode$i(start2)), binaryExpression$4("-", cloneNode$i(len3), cloneNode$i(start2)), numericLiteral$7(0));
      } else {
        arrKey = identifier$j(key2.name);
        arrLen = identifier$j(len3.name);
      }
      var loop = buildRest({
        ARGUMENTS: argsId,
        ARRAY_KEY: arrKey,
        ARRAY_LEN: arrLen,
        START: start2,
        ARRAY: rest,
        KEY: key2,
        LEN: len3
      });
      if (state.deopted) {
        node2.body.body.unshift(loop);
      } else {
        var target = path2.getEarliestCommonAncestorFrom(state.references).getStatementParent();
        target.findParent(function(path3) {
          if (path3.isLoop()) {
            target = path3;
          } else {
            return path3.isFunction();
          }
        });
        target.insertBefore(loop);
      }
      return true;
    }
    var _transformParameters = declare(function(api, options) {
      var _api$assumption;
      api.assertVersion(7);
      var ignoreFunctionLength = (_api$assumption = api.assumption("ignoreFunctionLength")) != null ? _api$assumption : options.loose;
      var noNewArrows = api.assumption("noNewArrows");
      return {
        name: "transform-parameters",
        visitor: {
          Function: function Function2(path2) {
            if (path2.isArrowFunctionExpression() && path2.get("params").some(function(param) {
              return param.isRestElement() || param.isAssignmentPattern();
            })) {
              path2.arrowFunctionToExpression({
                noNewArrows
              });
              if (!path2.isFunctionExpression())
                return;
            }
            var convertedRest = convertFunctionRest(path2);
            var convertedParams = convertFunctionParams(path2, ignoreFunctionLength);
            if (convertedRest || convertedParams) {
              path2.scope.crawl();
            }
          }
        }
      };
    });
    var require$$0$4 = {
      "es6.array.copy-within": {
        chrome: "45",
        opera: "32",
        edge: "12",
        firefox: "32",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.31"
      },
      "es6.array.every": {
        chrome: "5",
        opera: "10.10",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.fill": {
        chrome: "45",
        opera: "32",
        edge: "12",
        firefox: "31",
        safari: "7.1",
        node: "4",
        ios: "8",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.31"
      },
      "es6.array.filter": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.array.find": {
        chrome: "45",
        opera: "32",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "4",
        ios: "8",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.31"
      },
      "es6.array.find-index": {
        chrome: "45",
        opera: "32",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "4",
        ios: "8",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.31"
      },
      "es7.array.flat-map": {
        chrome: "69",
        opera: "56",
        edge: "79",
        firefox: "62",
        safari: "12",
        node: "11",
        ios: "12",
        samsung: "10",
        electron: "4.0"
      },
      "es6.array.for-each": {
        chrome: "5",
        opera: "10.10",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.from": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "36",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es7.array.includes": {
        chrome: "47",
        opera: "34",
        edge: "14",
        firefox: "43",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "es6.array.index-of": {
        chrome: "5",
        opera: "10.10",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.is-array": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "4",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.iterator": {
        chrome: "66",
        opera: "53",
        edge: "12",
        firefox: "60",
        safari: "9",
        node: "10",
        ios: "9",
        samsung: "9",
        rhino: "1.7.13",
        electron: "3.0"
      },
      "es6.array.last-index-of": {
        chrome: "5",
        opera: "10.10",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.map": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.array.of": {
        chrome: "45",
        opera: "32",
        edge: "12",
        firefox: "25",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.31"
      },
      "es6.array.reduce": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "3",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.reduce-right": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "3",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.slice": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.array.some": {
        chrome: "5",
        opera: "10.10",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.array.sort": {
        chrome: "63",
        opera: "50",
        edge: "12",
        firefox: "5",
        safari: "12",
        node: "10",
        ie: "9",
        ios: "12",
        samsung: "8",
        rhino: "1.7.13",
        electron: "3.0"
      },
      "es6.array.species": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.date.now": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "2",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.date.to-iso-string": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "3.5",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.date.to-json": {
        chrome: "5",
        opera: "12.10",
        edge: "12",
        firefox: "4",
        safari: "10",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "10",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.date.to-primitive": {
        chrome: "47",
        opera: "34",
        edge: "15",
        firefox: "44",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.36"
      },
      "es6.date.to-string": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "2",
        safari: "3.1",
        node: "0.10",
        ie: "10",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.function.bind": {
        chrome: "7",
        opera: "12",
        edge: "12",
        firefox: "4",
        safari: "5.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.function.has-instance": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "50",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.function.name": {
        chrome: "5",
        opera: "10.50",
        edge: "14",
        firefox: "2",
        safari: "4",
        node: "0.10",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.map": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.math.acosh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.asinh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.atanh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.cbrt": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.clz32": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "31",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.cosh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.expm1": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.fround": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "26",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.hypot": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "27",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.imul": {
        chrome: "30",
        opera: "17",
        edge: "12",
        firefox: "23",
        safari: "7",
        node: "0.12",
        android: "4.4",
        ios: "7",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.log1p": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.log10": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.log2": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.sign": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.sinh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.tanh": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.math.trunc": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "25",
        safari: "7.1",
        node: "0.12",
        ios: "8",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.constructor": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "36",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.number.epsilon": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "25",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.number.is-finite": {
        chrome: "19",
        opera: "15",
        edge: "12",
        firefox: "16",
        safari: "9",
        node: "0.12",
        android: "4.1",
        ios: "9",
        samsung: "1.5",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.is-integer": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "16",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.is-nan": {
        chrome: "19",
        opera: "15",
        edge: "12",
        firefox: "15",
        safari: "9",
        node: "0.12",
        android: "4.1",
        ios: "9",
        samsung: "1.5",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.is-safe-integer": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "32",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.max-safe-integer": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "31",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.min-safe-integer": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "31",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.number.parse-float": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "25",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.number.parse-int": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "25",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "2",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.object.assign": {
        chrome: "49",
        opera: "36",
        edge: "13",
        firefox: "36",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.object.create": {
        chrome: "5",
        opera: "12",
        edge: "12",
        firefox: "4",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es7.object.define-getter": {
        chrome: "62",
        opera: "49",
        edge: "16",
        firefox: "48",
        safari: "9",
        node: "8.10",
        ios: "9",
        samsung: "8",
        electron: "3.0"
      },
      "es7.object.define-setter": {
        chrome: "62",
        opera: "49",
        edge: "16",
        firefox: "48",
        safari: "9",
        node: "8.10",
        ios: "9",
        samsung: "8",
        electron: "3.0"
      },
      "es6.object.define-property": {
        chrome: "5",
        opera: "12",
        edge: "12",
        firefox: "4",
        safari: "5.1",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.object.define-properties": {
        chrome: "5",
        opera: "12",
        edge: "12",
        firefox: "4",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es7.object.entries": {
        chrome: "54",
        opera: "41",
        edge: "14",
        firefox: "47",
        safari: "10.1",
        node: "7",
        ios: "10.3",
        samsung: "6",
        rhino: "1.7.14",
        electron: "1.4"
      },
      "es6.object.freeze": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.get-own-property-descriptor": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es7.object.get-own-property-descriptors": {
        chrome: "54",
        opera: "41",
        edge: "15",
        firefox: "50",
        safari: "10.1",
        node: "7",
        ios: "10.3",
        samsung: "6",
        electron: "1.4"
      },
      "es6.object.get-own-property-names": {
        chrome: "40",
        opera: "27",
        edge: "12",
        firefox: "33",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.object.get-prototype-of": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es7.object.lookup-getter": {
        chrome: "62",
        opera: "49",
        edge: "79",
        firefox: "36",
        safari: "9",
        node: "8.10",
        ios: "9",
        samsung: "8",
        electron: "3.0"
      },
      "es7.object.lookup-setter": {
        chrome: "62",
        opera: "49",
        edge: "79",
        firefox: "36",
        safari: "9",
        node: "8.10",
        ios: "9",
        samsung: "8",
        electron: "3.0"
      },
      "es6.object.prevent-extensions": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.to-string": {
        chrome: "57",
        opera: "44",
        edge: "15",
        firefox: "51",
        safari: "10",
        node: "8",
        ios: "10",
        samsung: "7",
        electron: "1.7"
      },
      "es6.object.is": {
        chrome: "19",
        opera: "15",
        edge: "12",
        firefox: "22",
        safari: "9",
        node: "0.12",
        android: "4.1",
        ios: "9",
        samsung: "1.5",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.object.is-frozen": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.is-sealed": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.is-extensible": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.keys": {
        chrome: "40",
        opera: "27",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.object.seal": {
        chrome: "44",
        opera: "31",
        edge: "12",
        firefox: "35",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "4",
        rhino: "1.7.13",
        electron: "0.30"
      },
      "es6.object.set-prototype-of": {
        chrome: "34",
        opera: "21",
        edge: "12",
        firefox: "31",
        safari: "9",
        node: "0.12",
        ie: "11",
        ios: "9",
        samsung: "2",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es7.object.values": {
        chrome: "54",
        opera: "41",
        edge: "14",
        firefox: "47",
        safari: "10.1",
        node: "7",
        ios: "10.3",
        samsung: "6",
        rhino: "1.7.14",
        electron: "1.4"
      },
      "es6.promise": {
        chrome: "51",
        opera: "38",
        edge: "14",
        firefox: "45",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es7.promise.finally": {
        chrome: "63",
        opera: "50",
        edge: "18",
        firefox: "58",
        safari: "11.1",
        node: "10",
        ios: "11.3",
        samsung: "8",
        electron: "3.0"
      },
      "es6.reflect.apply": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.construct": {
        chrome: "49",
        opera: "36",
        edge: "13",
        firefox: "49",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.define-property": {
        chrome: "49",
        opera: "36",
        edge: "13",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.delete-property": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.get": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.get-own-property-descriptor": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.get-prototype-of": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.has": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.is-extensible": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.own-keys": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.prevent-extensions": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.set": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.reflect.set-prototype-of": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "42",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "es6.regexp.constructor": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "40",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "1.1"
      },
      "es6.regexp.flags": {
        chrome: "49",
        opera: "36",
        edge: "79",
        firefox: "37",
        safari: "9",
        node: "6",
        ios: "9",
        samsung: "5",
        electron: "0.37"
      },
      "es6.regexp.match": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "49",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        rhino: "1.7.13",
        electron: "1.1"
      },
      "es6.regexp.replace": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "49",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "1.1"
      },
      "es6.regexp.split": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "49",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "1.1"
      },
      "es6.regexp.search": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "49",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        rhino: "1.7.13",
        electron: "1.1"
      },
      "es6.regexp.to-string": {
        chrome: "50",
        opera: "37",
        edge: "79",
        firefox: "39",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "1.1"
      },
      "es6.set": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.symbol": {
        chrome: "51",
        opera: "38",
        edge: "79",
        firefox: "51",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es7.symbol.async-iterator": {
        chrome: "63",
        opera: "50",
        edge: "79",
        firefox: "57",
        safari: "12",
        node: "10",
        ios: "12",
        samsung: "8",
        electron: "3.0"
      },
      "es6.string.anchor": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.big": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.blink": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.bold": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.code-point-at": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "29",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.ends-with": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "29",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.fixed": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.fontcolor": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.fontsize": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.from-code-point": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "29",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.includes": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "40",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.italics": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.iterator": {
        chrome: "38",
        opera: "25",
        edge: "12",
        firefox: "36",
        safari: "9",
        node: "0.12",
        ios: "9",
        samsung: "3",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.string.link": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es7.string.pad-start": {
        chrome: "57",
        opera: "44",
        edge: "15",
        firefox: "48",
        safari: "10",
        node: "8",
        ios: "10",
        samsung: "7",
        rhino: "1.7.13",
        electron: "1.7"
      },
      "es7.string.pad-end": {
        chrome: "57",
        opera: "44",
        edge: "15",
        firefox: "48",
        safari: "10",
        node: "8",
        ios: "10",
        samsung: "7",
        rhino: "1.7.13",
        electron: "1.7"
      },
      "es6.string.raw": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "34",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.14",
        electron: "0.21"
      },
      "es6.string.repeat": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "24",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.small": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.starts-with": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "29",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        rhino: "1.7.13",
        electron: "0.21"
      },
      "es6.string.strike": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.sub": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.sup": {
        chrome: "5",
        opera: "15",
        edge: "12",
        firefox: "17",
        safari: "6",
        node: "0.10",
        android: "4",
        ios: "7",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.14",
        electron: "0.20"
      },
      "es6.string.trim": {
        chrome: "5",
        opera: "10.50",
        edge: "12",
        firefox: "3.5",
        safari: "4",
        node: "0.10",
        ie: "9",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es7.string.trim-left": {
        chrome: "66",
        opera: "53",
        edge: "79",
        firefox: "61",
        safari: "12",
        node: "10",
        ios: "12",
        samsung: "9",
        rhino: "1.7.13",
        electron: "3.0"
      },
      "es7.string.trim-right": {
        chrome: "66",
        opera: "53",
        edge: "79",
        firefox: "61",
        safari: "12",
        node: "10",
        ios: "12",
        samsung: "9",
        rhino: "1.7.13",
        electron: "3.0"
      },
      "es6.typed.array-buffer": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.data-view": {
        chrome: "5",
        opera: "12",
        edge: "12",
        firefox: "15",
        safari: "5.1",
        node: "0.10",
        ie: "10",
        android: "4",
        ios: "6",
        phantom: "2",
        samsung: "1",
        rhino: "1.7.13",
        electron: "0.20"
      },
      "es6.typed.int8-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.uint8-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.uint8-clamped-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.int16-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.uint16-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.int32-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.uint32-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.float32-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.typed.float64-array": {
        chrome: "51",
        opera: "38",
        edge: "13",
        firefox: "48",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "es6.weak-map": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "9",
        node: "6.5",
        ios: "9",
        samsung: "5",
        electron: "1.2"
      },
      "es6.weak-set": {
        chrome: "51",
        opera: "38",
        edge: "15",
        firefox: "53",
        safari: "9",
        node: "6.5",
        ios: "9",
        samsung: "5",
        electron: "1.2"
      }
    };
    var corejs2BuiltIns = require$$0$4;
    var isObjectProperty$2 = isObjectProperty$5, isArrayPattern = isArrayPattern$1, isObjectPattern = isObjectPattern$2, isAssignmentPattern$1 = isAssignmentPattern$5, isRestElement = isRestElement$3, isIdentifier$3 = isIdentifier$i;
    function shouldStoreRHSInTemporaryVariable(node2) {
      if (isArrayPattern(node2)) {
        var nonNullElements = node2.elements.filter(function(element) {
          return element !== null;
        });
        if (nonNullElements.length > 1)
          return true;
        else
          return shouldStoreRHSInTemporaryVariable(nonNullElements[0]);
      } else if (isObjectPattern(node2)) {
        var properties = node2.properties;
        if (properties.length > 1)
          return true;
        else if (properties.length === 0)
          return false;
        else {
          var firstProperty = properties[0];
          if (isObjectProperty$2(firstProperty)) {
            return shouldStoreRHSInTemporaryVariable(firstProperty.value);
          } else {
            return shouldStoreRHSInTemporaryVariable(firstProperty);
          }
        }
      } else if (isAssignmentPattern$1(node2)) {
        return shouldStoreRHSInTemporaryVariable(node2.left);
      } else if (isRestElement(node2)) {
        if (isIdentifier$3(node2.argument))
          return true;
        return shouldStoreRHSInTemporaryVariable(node2.argument);
      } else {
        return false;
      }
    }
    var isAssignmentPattern = isAssignmentPattern$5, isObjectProperty$1 = isObjectProperty$5;
    {
      var node = identifier$j("a");
      var property = objectProperty$2(identifier$j("key"), node);
      var pattern4 = objectPattern([property]);
      var ZERO_REFS = isReferenced$2(node, property, pattern4) ? 1 : 0;
    }
    var _proposalObjectRestSpread = declare(function(api, opts) {
      var _api$assumption, _api$assumption2, _api$assumption3, _api$assumption4;
      api.assertVersion(7);
      var targets = api.targets();
      var supportsObjectAssign = !isRequired("es6.object.assign", targets, {
        compatData: corejs2BuiltIns
      });
      var _opts$useBuiltIns = opts.useBuiltIns, useBuiltIns = _opts$useBuiltIns === void 0 ? supportsObjectAssign : _opts$useBuiltIns, _opts$loose = opts.loose, loose = _opts$loose === void 0 ? false : _opts$loose;
      if (typeof loose !== "boolean") {
        throw new Error(".loose must be a boolean, or undefined");
      }
      var ignoreFunctionLength = (_api$assumption = api.assumption("ignoreFunctionLength")) != null ? _api$assumption : loose;
      var objectRestNoSymbols = (_api$assumption2 = api.assumption("objectRestNoSymbols")) != null ? _api$assumption2 : loose;
      var pureGetters = (_api$assumption3 = api.assumption("pureGetters")) != null ? _api$assumption3 : loose;
      var setSpreadProperties = (_api$assumption4 = api.assumption("setSpreadProperties")) != null ? _api$assumption4 : loose;
      function getExtendsHelper(file2) {
        return useBuiltIns ? memberExpression$b(identifier$j("Object"), identifier$j("assign")) : file2.addHelper("extends");
      }
      function hasRestElement(path2) {
        var foundRestElement = false;
        visitRestElements(path2, function(restElement2) {
          foundRestElement = true;
          restElement2.stop();
        });
        return foundRestElement;
      }
      function hasObjectPatternRestElement(path2) {
        var foundRestElement = false;
        visitRestElements(path2, function(restElement2) {
          if (restElement2.parentPath.isObjectPattern()) {
            foundRestElement = true;
            restElement2.stop();
          }
        });
        return foundRestElement;
      }
      function visitRestElements(path2, visitor2) {
        path2.traverse({
          Expression: function Expression2(path3) {
            var parent = path3.parent, key2 = path3.key;
            if (isAssignmentPattern(parent) && key2 === "right" || isObjectProperty$1(parent) && parent.computed && key2 === "key") {
              path3.skip();
            }
          },
          RestElement: visitor2
        });
      }
      function hasSpread(node2) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(node2.properties), _step2; !(_step2 = _iterator2()).done; ) {
          var prop2 = _step2.value;
          if (isSpreadElement$1(prop2)) {
            return true;
          }
        }
        return false;
      }
      function extractNormalizedKeys(node2) {
        var props = node2.properties;
        var keys2 = [];
        var allLiteral = true;
        var hasTemplateLiteral = false;
        for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done; ) {
          var prop2 = _step2.value;
          if (isIdentifier$i(prop2.key) && !prop2.computed) {
            keys2.push(stringLiteral$8(prop2.key.name));
          } else if (isTemplateLiteral$2(prop2.key)) {
            keys2.push(cloneNode$i(prop2.key));
            hasTemplateLiteral = true;
          } else if (isLiteral$7(prop2.key)) {
            keys2.push(stringLiteral$8(String(prop2.key.value)));
          } else {
            keys2.push(cloneNode$i(prop2.key));
            allLiteral = false;
          }
        }
        return {
          keys: keys2,
          allLiteral,
          hasTemplateLiteral
        };
      }
      function replaceImpureComputedKeys(properties, scope2) {
        var impureComputedPropertyDeclarators = [];
        for (var _iterator3 = _createForOfIteratorHelperLoose(properties), _step3; !(_step3 = _iterator3()).done; ) {
          var propPath = _step3.value;
          var key2 = propPath.get("key");
          if (propPath.node.computed && !key2.isPure()) {
            var name2 = scope2.generateUidBasedOnNode(key2.node);
            var declarator = variableDeclarator$7(identifier$j(name2), key2.node);
            impureComputedPropertyDeclarators.push(declarator);
            key2.replaceWith(identifier$j(name2));
          }
        }
        return impureComputedPropertyDeclarators;
      }
      function removeUnusedExcludedKeys(path2) {
        var bindings = path2.getOuterBindingIdentifierPaths();
        Object.keys(bindings).forEach(function(bindingName) {
          var bindingParentPath = bindings[bindingName].parentPath;
          if (path2.scope.getBinding(bindingName).references > ZERO_REFS || !bindingParentPath.isObjectProperty()) {
            return;
          }
          bindingParentPath.remove();
        });
      }
      function createObjectRest(path2, file2, objRef) {
        var props = path2.get("properties");
        var last2 = props[props.length - 1];
        assertRestElement(last2.node);
        var restElement2 = cloneNode$i(last2.node);
        last2.remove();
        var impureComputedPropertyDeclarators = replaceImpureComputedKeys(path2.get("properties"), path2.scope);
        var _extractNormalizedKey = extractNormalizedKeys(path2.node), keys2 = _extractNormalizedKey.keys, allLiteral = _extractNormalizedKey.allLiteral, hasTemplateLiteral = _extractNormalizedKey.hasTemplateLiteral;
        if (keys2.length === 0) {
          return [impureComputedPropertyDeclarators, restElement2.argument, callExpression$e(getExtendsHelper(file2), [objectExpression$4([]), cloneNode$i(objRef)])];
        }
        var keyExpression;
        if (!allLiteral) {
          keyExpression = callExpression$e(memberExpression$b(arrayExpression$2(keys2), identifier$j("map")), [file2.addHelper("toPropertyKey")]);
        } else {
          keyExpression = arrayExpression$2(keys2);
          if (!hasTemplateLiteral && !isProgram$2(path2.scope.block)) {
            var program2 = path2.findParent(function(path3) {
              return path3.isProgram();
            });
            var id3 = path2.scope.generateUidIdentifier("excluded");
            program2.scope.push({
              id: id3,
              init: keyExpression,
              kind: "const"
            });
            keyExpression = cloneNode$i(id3);
          }
        }
        return [impureComputedPropertyDeclarators, restElement2.argument, callExpression$e(file2.addHelper("objectWithoutProperties" + (objectRestNoSymbols ? "Loose" : "")), [cloneNode$i(objRef), keyExpression])];
      }
      function replaceRestElement(parentPath, paramPath, container2) {
        if (paramPath.isAssignmentPattern()) {
          replaceRestElement(parentPath, paramPath.get("left"), container2);
          return;
        }
        if (paramPath.isArrayPattern() && hasRestElement(paramPath)) {
          var elements = paramPath.get("elements");
          for (var i2 = 0; i2 < elements.length; i2++) {
            replaceRestElement(parentPath, elements[i2], container2);
          }
        }
        if (paramPath.isObjectPattern() && hasRestElement(paramPath)) {
          var uid2 = parentPath.scope.generateUidIdentifier("ref");
          var declar = variableDeclaration$7("let", [variableDeclarator$7(paramPath.node, uid2)]);
          if (container2) {
            container2.push(declar);
          } else {
            parentPath.ensureBlock();
            parentPath.get("body").unshiftContainer("body", declar);
          }
          paramPath.replaceWith(cloneNode$i(uid2));
        }
      }
      return {
        name: "proposal-object-rest-spread",
        inherits: lib$i["default"],
        visitor: {
          Function: function Function2(path2) {
            var params = path2.get("params");
            var paramsWithRestElement = /* @__PURE__ */ new Set();
            var idsInRestParams = /* @__PURE__ */ new Set();
            for (var _i3 = 0; _i3 < params.length; ++_i3) {
              var param = params[_i3];
              if (hasRestElement(param)) {
                paramsWithRestElement.add(_i3);
                for (var _i22 = 0, _Object$keys3 = Object.keys(param.getBindingIdentifiers()); _i22 < _Object$keys3.length; _i22++) {
                  var name2 = _Object$keys3[_i22];
                  idsInRestParams.add(name2);
                }
              }
            }
            var idInRest = false;
            var IdentifierHandler = function IdentifierHandler2(path3, functionScope) {
              var name3 = path3.node.name;
              if (path3.scope.getBinding(name3) === functionScope.getBinding(name3) && idsInRestParams.has(name3)) {
                idInRest = true;
                path3.stop();
              }
            };
            var i2;
            for (i2 = 0; i2 < params.length && !idInRest; ++i2) {
              var _param2 = params[i2];
              if (!paramsWithRestElement.has(i2)) {
                if (_param2.isReferencedIdentifier() || _param2.isBindingIdentifier()) {
                  IdentifierHandler(path2, path2.scope);
                } else {
                  _param2.traverse({
                    "Scope|TypeAnnotation|TSTypeAnnotation": function ScopeTypeAnnotationTSTypeAnnotation(path3) {
                      return path3.skip();
                    },
                    "ReferencedIdentifier|BindingIdentifier": IdentifierHandler
                  }, path2.scope);
                }
              }
            }
            if (!idInRest) {
              for (var _i32 = 0; _i32 < params.length; ++_i32) {
                var _param22 = params[_i32];
                if (paramsWithRestElement.has(_i32)) {
                  replaceRestElement(path2, _param22);
                }
              }
            } else {
              var shouldTransformParam = function shouldTransformParam2(idx) {
                return idx >= i2 - 1 || paramsWithRestElement.has(idx);
              };
              convertFunctionParams(path2, ignoreFunctionLength, shouldTransformParam, replaceRestElement);
            }
          },
          VariableDeclarator: function(_VariableDeclarator) {
            function VariableDeclarator2(_x, _x2) {
              return _VariableDeclarator.apply(this, arguments);
            }
            VariableDeclarator2.toString = function() {
              return _VariableDeclarator.toString();
            };
            return VariableDeclarator2;
          }(function(path2, file2) {
            if (!path2.get("id").isObjectPattern()) {
              return;
            }
            var insertionPath = path2;
            var originalPath = path2;
            visitRestElements(path2.get("id"), function(path3) {
              if (!path3.parentPath.isObjectPattern()) {
                return;
              }
              if (shouldStoreRHSInTemporaryVariable(originalPath.node.id) && !isIdentifier$i(originalPath.node.init)) {
                var initRef = path3.scope.generateUidIdentifierBasedOnNode(originalPath.node.init, "ref");
                originalPath.insertBefore(variableDeclarator$7(initRef, originalPath.node.init));
                originalPath.replaceWith(variableDeclarator$7(originalPath.node.id, cloneNode$i(initRef)));
                return;
              }
              var ref2 = originalPath.node.init;
              var refPropertyPath = [];
              var kind;
              path3.findParent(function(path4) {
                if (path4.isObjectProperty()) {
                  refPropertyPath.unshift(path4);
                } else if (path4.isVariableDeclarator()) {
                  kind = path4.parentPath.node.kind;
                  return true;
                }
              });
              var impureObjRefComputedDeclarators = replaceImpureComputedKeys(refPropertyPath, path3.scope);
              refPropertyPath.forEach(function(prop2) {
                var node2 = prop2.node;
                ref2 = memberExpression$b(ref2, cloneNode$i(node2.key), node2.computed || isLiteral$7(node2.key));
              });
              var objectPatternPath = path3.findParent(function(path4) {
                return path4.isObjectPattern();
              });
              var _createObjectRest = createObjectRest(objectPatternPath, file2, ref2), _createObjectRest2 = _slicedToArray$12(_createObjectRest, 3), impureComputedPropertyDeclarators = _createObjectRest2[0], argument = _createObjectRest2[1], callExpression2 = _createObjectRest2[2];
              if (pureGetters) {
                removeUnusedExcludedKeys(objectPatternPath);
              }
              assertIdentifier(argument);
              insertionPath.insertBefore(impureComputedPropertyDeclarators);
              insertionPath.insertBefore(impureObjRefComputedDeclarators);
              insertionPath = insertionPath.insertAfter(variableDeclarator$7(argument, callExpression2))[0];
              path3.scope.registerBinding(kind, insertionPath);
              if (objectPatternPath.node.properties.length === 0) {
                objectPatternPath.findParent(function(path4) {
                  return path4.isObjectProperty() || path4.isVariableDeclarator();
                }).remove();
              }
            });
          }),
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2) {
            var declaration = path2.get("declaration");
            if (!declaration.isVariableDeclaration())
              return;
            var hasRest2 = declaration.get("declarations").some(function(path3) {
              return hasObjectPatternRestElement(path3.get("id"));
            });
            if (!hasRest2)
              return;
            var specifiers = [];
            for (var _i4 = 0, _Object$keys22 = Object.keys(path2.getOuterBindingIdentifiers(true)); _i4 < _Object$keys22.length; _i4++) {
              var name2 = _Object$keys22[_i4];
              specifiers.push(exportSpecifier$2(identifier$j(name2), identifier$j(name2)));
            }
            path2.replaceWith(declaration.node);
            path2.insertAfter(exportNamedDeclaration$2(null, specifiers));
          },
          CatchClause: function CatchClause2(path2) {
            var paramPath = path2.get("param");
            replaceRestElement(path2, paramPath);
          },
          AssignmentExpression: function AssignmentExpression2(path2, file2) {
            var leftPath = path2.get("left");
            if (leftPath.isObjectPattern() && hasRestElement(leftPath)) {
              var nodes2 = [];
              var refName = path2.scope.generateUidBasedOnNode(path2.node.right, "ref");
              nodes2.push(variableDeclaration$7("var", [variableDeclarator$7(identifier$j(refName), path2.node.right)]));
              var _createObjectRest3 = createObjectRest(leftPath, file2, identifier$j(refName)), _createObjectRest4 = _slicedToArray$12(_createObjectRest3, 3), impureComputedPropertyDeclarators = _createObjectRest4[0], argument = _createObjectRest4[1], callExpression2 = _createObjectRest4[2];
              if (impureComputedPropertyDeclarators.length > 0) {
                nodes2.push(variableDeclaration$7("var", impureComputedPropertyDeclarators));
              }
              var nodeWithoutSpread = cloneNode$i(path2.node);
              nodeWithoutSpread.right = identifier$j(refName);
              nodes2.push(expressionStatement$a(nodeWithoutSpread));
              nodes2.push(toStatement(assignmentExpression$c("=", argument, callExpression2)));
              nodes2.push(expressionStatement$a(identifier$j(refName)));
              path2.replaceWithMultiple(nodes2);
            }
          },
          ForXStatement: function ForXStatement(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var leftPath = path2.get("left");
            var left = node2.left;
            if (!hasObjectPatternRestElement(leftPath)) {
              return;
            }
            if (!isVariableDeclaration$3(left)) {
              var temp = scope2.generateUidIdentifier("ref");
              node2.left = variableDeclaration$7("var", [variableDeclarator$7(temp)]);
              path2.ensureBlock();
              var body = node2.body;
              if (body.body.length === 0 && path2.isCompletionRecord()) {
                body.body.unshift(expressionStatement$a(scope2.buildUndefinedNode()));
              }
              body.body.unshift(expressionStatement$a(assignmentExpression$c("=", left, cloneNode$i(temp))));
            } else {
              var _pattern = left.declarations[0].id;
              var key2 = scope2.generateUidIdentifier("ref");
              node2.left = variableDeclaration$7(left.kind, [variableDeclarator$7(key2, null)]);
              path2.ensureBlock();
              var _body = node2.body;
              _body.body.unshift(variableDeclaration$7(node2.left.kind, [variableDeclarator$7(_pattern, cloneNode$i(key2))]));
            }
          },
          ArrayPattern: function ArrayPattern(path2) {
            var objectPatterns = [];
            visitRestElements(path2, function(path3) {
              if (!path3.parentPath.isObjectPattern()) {
                return;
              }
              var objectPattern2 = path3.parentPath;
              var uid2 = path3.scope.generateUidIdentifier("ref");
              objectPatterns.push(variableDeclarator$7(objectPattern2.node, uid2));
              objectPattern2.replaceWith(cloneNode$i(uid2));
              path3.skip();
            });
            if (objectPatterns.length > 0) {
              var statementPath = path2.getStatementParent();
              var statementNode = statementPath.node;
              var kind = statementNode.type === "VariableDeclaration" ? statementNode.kind : "var";
              statementPath.insertAfter(variableDeclaration$7(kind, objectPatterns));
            }
          },
          ObjectExpression: function ObjectExpression2(path2, file2) {
            if (!hasSpread(path2.node))
              return;
            var helper2;
            if (setSpreadProperties) {
              helper2 = getExtendsHelper(file2);
            } else {
              try {
                helper2 = file2.addHelper("objectSpread2");
              } catch (_unused) {
                this.file.declarations["objectSpread2"] = null;
                helper2 = file2.addHelper("objectSpread");
              }
            }
            var exp = null;
            var props = [];
            function make() {
              var hadProps = props.length > 0;
              var obj = objectExpression$4(props);
              props = [];
              if (!exp) {
                exp = callExpression$e(helper2, [obj]);
                return;
              }
              if (pureGetters) {
                if (hadProps) {
                  exp.arguments.push(obj);
                }
                return;
              }
              exp = callExpression$e(cloneNode$i(helper2), [exp].concat(_toConsumableArray2(hadProps ? [objectExpression$4([]), obj] : [])));
            }
            for (var _iterator4 = _createForOfIteratorHelperLoose(path2.node.properties), _step4; !(_step4 = _iterator4()).done; ) {
              var prop2 = _step4.value;
              if (isSpreadElement$1(prop2)) {
                make();
                exp.arguments.push(prop2.argument);
              } else {
                props.push(prop2);
              }
            }
            if (props.length)
              make();
            path2.replaceWith(exp);
          }
        }
      };
    });
    var lib$h = {};
    Object.defineProperty(lib$h, "__esModule", {
      value: true
    });
    lib$h["default"] = void 0;
    var _helperPluginUtils$g = require$$0$5;
    var _default$g = (0, _helperPluginUtils$g.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-optional-catch-binding",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("optionalCatchBinding");
        }
      };
    });
    lib$h["default"] = _default$g;
    var _proposalOptionalCatchBinding = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-optional-catch-binding",
        inherits: lib$h["default"],
        visitor: {
          CatchClause: function CatchClause2(path2) {
            if (!path2.node.param) {
              var uid2 = path2.scope.generateUidIdentifier("unused");
              var paramPath = path2.get("param");
              paramPath.replaceWith(uid2);
            }
          }
        }
      };
    });
    var lib$g = {};
    Object.defineProperty(lib$g, "__esModule", {
      value: true
    });
    lib$g["default"] = void 0;
    var _helperPluginUtils$f = require$$0$5;
    var _default$f = (0, _helperPluginUtils$f.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-optional-chaining",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("optionalChaining");
        }
      };
    });
    lib$g["default"] = _default$f;
    var isParenthesizedExpression = isParenthesizedExpression$1, isTSAsExpression = isTSAsExpression$2, isTSNonNullExpression = isTSNonNullExpression$2, isTSTypeAssertion = isTSTypeAssertion$2, isTypeCastExpression = isTypeCastExpression$1;
    function isTransparentExprWrapper(node2) {
      return isTSAsExpression(node2) || isTSTypeAssertion(node2) || isTSNonNullExpression(node2) || isTypeCastExpression(node2) || isParenthesizedExpression(node2);
    }
    function skipTransparentExprWrappers(path2) {
      while (isTransparentExprWrapper(path2.node)) {
        path2 = path2.get("expression");
      }
      return path2;
    }
    function skipTransparentExprWrapperNodes(node2) {
      while (isTransparentExprWrapper(node2)) {
        node2 = node2.expression;
      }
      return node2;
    }
    function willPathCastToBoolean(path2) {
      var maybeWrapped = findOutermostTransparentParent(path2);
      var node2 = maybeWrapped.node, parentPath = maybeWrapped.parentPath;
      if (parentPath.isLogicalExpression()) {
        var _parentPath$node = parentPath.node, operator = _parentPath$node.operator, right = _parentPath$node.right;
        if (operator === "&&" || operator === "||" || operator === "??" && node2 === right) {
          return willPathCastToBoolean(parentPath);
        }
      }
      if (parentPath.isSequenceExpression()) {
        var expressions = parentPath.node.expressions;
        if (expressions[expressions.length - 1] === node2) {
          return willPathCastToBoolean(parentPath);
        } else {
          return true;
        }
      }
      return parentPath.isConditional({
        test: node2
      }) || parentPath.isUnaryExpression({
        operator: "!"
      }) || parentPath.isLoop({
        test: node2
      });
    }
    function findOutermostTransparentParent(path2) {
      var maybeWrapped = path2;
      path2.findParent(function(p2) {
        if (!isTransparentExprWrapper(p2.node))
          return true;
        maybeWrapped = p2;
      });
      return maybeWrapped;
    }
    var _templateObject$e, _templateObject2$7, _templateObject3$6, _templateObject4$2, _templateObject5$1, _templateObject6$1, _templateObject7;
    var ast2 = template$2.expression.ast;
    function isSimpleMemberExpression(expression2) {
      expression2 = skipTransparentExprWrapperNodes(expression2);
      return isIdentifier$i(expression2) || isSuper$3(expression2) || isMemberExpression$8(expression2) && !expression2.computed && isSimpleMemberExpression(expression2.object);
    }
    function needsMemoize(path2) {
      var optionalPath = path2;
      var scope2 = path2.scope;
      while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
        var _optionalPath = optionalPath, node2 = _optionalPath.node;
        var childKey = optionalPath.isOptionalMemberExpression() ? "object" : "callee";
        var childPath = skipTransparentExprWrappers(optionalPath.get(childKey));
        if (node2.optional) {
          return !scope2.isStatic(childPath.node);
        }
        optionalPath = childPath;
      }
    }
    function transform$2(path2, _ref3) {
      var pureGetters = _ref3.pureGetters, noDocumentAll = _ref3.noDocumentAll;
      var scope2 = path2.scope;
      var maybeWrapped = findOutermostTransparentParent(path2);
      var parentPath = maybeWrapped.parentPath;
      var willReplacementCastToBoolean = willPathCastToBoolean(maybeWrapped);
      var isDeleteOperation = false;
      var parentIsCall = parentPath.isCallExpression({
        callee: maybeWrapped.node
      }) && path2.isOptionalMemberExpression();
      var optionals = [];
      var optionalPath = path2;
      if (scope2.path.isPattern() && needsMemoize(optionalPath)) {
        path2.replaceWith(template$2.ast(_templateObject$e || (_templateObject$e = _taggedTemplateLiteralLoose(["(() => ", ")()"])), path2.node));
        return;
      }
      while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
        var _optionalPath2 = optionalPath, node2 = _optionalPath2.node;
        if (node2.optional) {
          optionals.push(node2);
        }
        if (optionalPath.isOptionalMemberExpression()) {
          optionalPath.node.type = "MemberExpression";
          optionalPath = skipTransparentExprWrappers(optionalPath.get("object"));
        } else if (optionalPath.isOptionalCallExpression()) {
          optionalPath.node.type = "CallExpression";
          optionalPath = skipTransparentExprWrappers(optionalPath.get("callee"));
        }
      }
      var replacementPath = path2;
      if (parentPath.isUnaryExpression({
        operator: "delete"
      })) {
        replacementPath = parentPath;
        isDeleteOperation = true;
      }
      for (var i2 = optionals.length - 1; i2 >= 0; i2--) {
        var _node = optionals[i2];
        var isCall = isCallExpression$7(_node);
        var replaceKey = isCall ? "callee" : "object";
        var chainWithTypes = _node[replaceKey];
        var chain2 = skipTransparentExprWrapperNodes(chainWithTypes);
        var ref2 = void 0;
        var check = void 0;
        if (isCall && isIdentifier$i(chain2, {
          name: "eval"
        })) {
          check = ref2 = chain2;
          _node[replaceKey] = sequenceExpression$7([numericLiteral$7(0), ref2]);
        } else if (pureGetters && isCall && isSimpleMemberExpression(chain2)) {
          check = ref2 = chainWithTypes;
        } else {
          ref2 = scope2.maybeGenerateMemoised(chain2);
          if (ref2) {
            check = assignmentExpression$c("=", cloneNode$i(ref2), chainWithTypes);
            _node[replaceKey] = ref2;
          } else {
            check = ref2 = chainWithTypes;
          }
        }
        if (isCall && isMemberExpression$8(chain2)) {
          if (pureGetters && isSimpleMemberExpression(chain2)) {
            _node.callee = chainWithTypes;
          } else {
            var object4 = chain2.object;
            var context = scope2.maybeGenerateMemoised(object4);
            if (context) {
              chain2.object = assignmentExpression$c("=", context, object4);
            } else if (isSuper$3(object4)) {
              context = thisExpression$4();
            } else {
              context = object4;
            }
            _node.arguments.unshift(cloneNode$i(context));
            _node.callee = memberExpression$b(_node.callee, identifier$j("call"));
          }
        }
        var replacement = replacementPath.node;
        if (i2 === 0 && parentIsCall) {
          var _baseRef;
          var _object = skipTransparentExprWrapperNodes(replacement.object);
          var baseRef = void 0;
          if (!pureGetters || !isSimpleMemberExpression(_object)) {
            baseRef = scope2.maybeGenerateMemoised(_object);
            if (baseRef) {
              replacement.object = assignmentExpression$c("=", baseRef, _object);
            }
          }
          replacement = callExpression$e(memberExpression$b(replacement, identifier$j("bind")), [cloneNode$i((_baseRef = baseRef) != null ? _baseRef : _object)]);
        }
        if (willReplacementCastToBoolean) {
          var nonNullishCheck = noDocumentAll ? ast2(_templateObject2$7 || (_templateObject2$7 = _taggedTemplateLiteralLoose(["", " != null"])), cloneNode$i(check)) : ast2(_templateObject3$6 || (_templateObject3$6 = _taggedTemplateLiteralLoose(["\n            ", " !== null && ", " !== void 0"])), cloneNode$i(check), cloneNode$i(ref2));
          replacementPath.replaceWith(logicalExpression$3("&&", nonNullishCheck, replacement));
          replacementPath = skipTransparentExprWrappers(replacementPath.get("right"));
        } else {
          var nullishCheck = noDocumentAll ? ast2(_templateObject4$2 || (_templateObject4$2 = _taggedTemplateLiteralLoose(["", " == null"])), cloneNode$i(check)) : ast2(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteralLoose(["\n            ", " === null || ", " === void 0"])), cloneNode$i(check), cloneNode$i(ref2));
          var returnValue = isDeleteOperation ? ast2(_templateObject6$1 || (_templateObject6$1 = _taggedTemplateLiteralLoose(["true"]))) : ast2(_templateObject7 || (_templateObject7 = _taggedTemplateLiteralLoose(["void 0"])));
          replacementPath.replaceWith(conditionalExpression$3(nullishCheck, returnValue, replacement));
          replacementPath = skipTransparentExprWrappers(replacementPath.get("alternate"));
        }
      }
    }
    var _proposalOptionalChaining = declare(function(api, options) {
      var _api$assumption, _api$assumption2;
      api.assertVersion(7);
      var _options$loose = options.loose, loose = _options$loose === void 0 ? false : _options$loose;
      var noDocumentAll = (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : loose;
      var pureGetters = (_api$assumption2 = api.assumption("pureGetters")) != null ? _api$assumption2 : loose;
      return {
        name: "proposal-optional-chaining",
        inherits: lib$g["default"],
        visitor: {
          "OptionalCallExpression|OptionalMemberExpression": function OptionalCallExpressionOptionalMemberExpression(path2) {
            transform$2(path2, {
              noDocumentAll,
              pureGetters
            });
          }
        }
      };
    });
    var buildOptimizedSequenceExpression = function buildOptimizedSequenceExpression2(_ref3) {
      var call3 = _ref3.call, path2 = _ref3.path, placeholder2 = _ref3.placeholder;
      var calledExpression = call3.callee;
      var pipelineLeft = path2.node.left;
      var assign = assignmentExpression$c("=", cloneNode$i(placeholder2), pipelineLeft);
      var optimizeArrow = isArrowFunctionExpression$1(calledExpression) && isExpression$4(calledExpression.body) && !calledExpression.async && !calledExpression.generator;
      var param;
      if (optimizeArrow) {
        var params = calledExpression.params;
        if (params.length === 1 && isIdentifier$i(params[0])) {
          param = params[0];
        } else if (params.length > 0) {
          optimizeArrow = false;
        }
      } else if (isIdentifier$i(calledExpression, {
        name: "eval"
      })) {
        var evalSequence = sequenceExpression$7([numericLiteral$7(0), calledExpression]);
        call3.callee = evalSequence;
        path2.scope.push({
          id: cloneNode$i(placeholder2)
        });
        return sequenceExpression$7([assign, call3]);
      }
      if (optimizeArrow && !param) {
        return sequenceExpression$7([pipelineLeft, calledExpression.body]);
      }
      path2.scope.push({
        id: cloneNode$i(placeholder2)
      });
      if (param) {
        path2.get("right").scope.rename(param.name, placeholder2.name);
        return sequenceExpression$7([assign, calledExpression.body]);
      }
      return sequenceExpression$7([assign, call3]);
    };
    var minimalVisitor = {
      BinaryExpression: function BinaryExpression2(path2) {
        var scope2 = path2.scope, node2 = path2.node;
        var operator = node2.operator, left = node2.left, right = node2.right;
        if (operator !== "|>")
          return;
        var placeholder2 = scope2.generateUidIdentifierBasedOnNode(left);
        var call3 = callExpression$e(right, [cloneNode$i(placeholder2)]);
        path2.replaceWith(buildOptimizedSequenceExpression({
          placeholder: placeholder2,
          call: call3,
          path: path2
        }));
      }
    };
    var topicReferenceVisitor = {
      exit: function exit(path2, state) {
        if (path2.isTopicReference()) {
          state.topicReferences.push(path2);
        } else {
          if (state.topicReferences.length === 0 && !state.sideEffectsBeforeFirstTopicReference && !path2.isPure()) {
            state.sideEffectsBeforeFirstTopicReference = true;
          }
        }
      },
      "ClassBody|Function": function ClassBodyFunction(_, state) {
        if (state.topicReferences.length === 0) {
          state.sideEffectsBeforeFirstTopicReference = true;
        }
      }
    };
    var hackVisitor = {
      BinaryExpression: {
        exit: function exit(path2) {
          var scope2 = path2.scope, node2 = path2.node;
          if (node2.operator !== "|>") {
            return;
          }
          var pipeBodyPath = path2.get("right");
          if (pipeBodyPath.node.type === "TopicReference") {
            path2.replaceWith(node2.left);
            return;
          }
          var visitorState = {
            topicReferences: [],
            sideEffectsBeforeFirstTopicReference: pipeBodyPath.isFunction()
          };
          pipeBodyPath.traverse(topicReferenceVisitor, visitorState);
          if (visitorState.topicReferences.length === 1 && (!visitorState.sideEffectsBeforeFirstTopicReference || path2.scope.isPure(node2.left, true))) {
            visitorState.topicReferences[0].replaceWith(node2.left);
            path2.replaceWith(node2.right);
            return;
          }
          var topicVariable = scope2.generateUidIdentifierBasedOnNode(node2);
          scope2.push({
            id: topicVariable
          });
          visitorState.topicReferences.forEach(function(path3) {
            return path3.replaceWith(cloneNode$i(topicVariable));
          });
          path2.replaceWith(sequenceExpression$7([assignmentExpression$c("=", cloneNode$i(topicVariable), node2.left), node2.right]));
        }
      }
    };
    var fsharpVisitor = {
      BinaryExpression: function BinaryExpression2(path2) {
        var scope2 = path2.scope, node2 = path2.node;
        var operator = node2.operator, left = node2.left, right = node2.right;
        if (operator !== "|>")
          return;
        var placeholder2 = scope2.generateUidIdentifierBasedOnNode(left);
        var call3 = right.type === "AwaitExpression" ? awaitExpression$1(cloneNode$i(placeholder2)) : callExpression$e(right, [cloneNode$i(placeholder2)]);
        var sequence = buildOptimizedSequenceExpression({
          placeholder: placeholder2,
          call: call3,
          path: path2
        });
        path2.replaceWith(sequence);
      }
    };
    var updateTopicReferenceVisitor = {
      PipelinePrimaryTopicReference: function PipelinePrimaryTopicReference2(path2) {
        path2.replaceWith(cloneNode$i(this.topicId));
      },
      PipelineTopicExpression: function PipelineTopicExpression2(path2) {
        path2.skip();
      }
    };
    var smartVisitor = {
      BinaryExpression: function BinaryExpression2(path2) {
        var scope2 = path2.scope;
        var node2 = path2.node;
        var operator = node2.operator, left = node2.left, right = node2.right;
        if (operator !== "|>")
          return;
        var placeholder2 = scope2.generateUidIdentifierBasedOnNode(left);
        scope2.push({
          id: placeholder2
        });
        var call3;
        if (isPipelineTopicExpression(right)) {
          path2.get("right").traverse(updateTopicReferenceVisitor, {
            topicId: placeholder2
          });
          call3 = right.expression;
        } else {
          var callee = right.callee;
          if (isIdentifier$i(callee, {
            name: "eval"
          })) {
            callee = sequenceExpression$7([numericLiteral$7(0), callee]);
          }
          call3 = callExpression$e(callee, [cloneNode$i(placeholder2)]);
        }
        path2.replaceWith(sequenceExpression$7([assignmentExpression$c("=", cloneNode$i(placeholder2), left), call3]));
      }
    };
    var visitorsPerProposal = {
      minimal: minimalVisitor,
      hack: hackVisitor,
      fsharp: fsharpVisitor,
      smart: smartVisitor
    };
    var proposalPipelineOperator = declare(function(api, options) {
      api.assertVersion(7);
      var proposal = options.proposal;
      if (proposal === "smart") {
        console.warn('The smart-mix pipe operator is deprecated. Use "proposal": "hack" instead.');
      }
      return {
        name: "proposal-pipeline-operator",
        inherits: syntaxPipelineOperator,
        visitor: visitorsPerProposal[options.proposal]
      };
    });
    var _proposalPrivateMethods = declare(function(api, options) {
      api.assertVersion(7);
      return createClassFeaturePlugin({
        name: "proposal-private-methods",
        api,
        feature: FEATURES$1.privateMethods,
        loose: options.loose,
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classPrivateMethods");
        }
      });
    });
    var lib$f = {};
    Object.defineProperty(lib$f, "__esModule", {
      value: true
    });
    lib$f["default"] = void 0;
    var _helperPluginUtils$e = require$$0$5;
    var _default$e = (0, _helperPluginUtils$e.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-private-property-in-object",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("privateIn");
        }
      };
    });
    lib$f["default"] = _default$e;
    var _templateObject$d, _templateObject2$6, _templateObject3$5, _templateObject4$1, _templateObject5, _templateObject6;
    var _proposalPrivatePropertyInObject = declare(function(_ref3, _ref22) {
      var assertVersion2 = _ref3.assertVersion, t3 = _ref3.types, template2 = _ref3.template;
      var loose = _ref22.loose;
      assertVersion2(7);
      var classWeakSets = /* @__PURE__ */ new WeakMap();
      var fieldsWeakSets = /* @__PURE__ */ new WeakMap();
      function unshadow2(name2, targetScope, scope2) {
        while (scope2 !== targetScope) {
          if (scope2.hasOwnBinding(name2))
            scope2.rename(name2);
          scope2 = scope2.parent;
        }
      }
      function injectToFieldInit(fieldPath, expr, before) {
        if (before === void 0) {
          before = false;
        }
        if (fieldPath.node.value) {
          if (before) {
            fieldPath.get("value").insertBefore(expr);
          } else {
            fieldPath.get("value").insertAfter(expr);
          }
        } else {
          fieldPath.set("value", t3.unaryExpression("void", expr));
        }
      }
      function injectInitialization$1(classPath, init3) {
        var firstFieldPath;
        var consturctorPath;
        for (var _iterator2 = _createForOfIteratorHelperLoose(classPath.get("body.body")), _step2; !(_step2 = _iterator2()).done; ) {
          var el = _step2.value;
          if ((el.isClassProperty() || el.isClassPrivateProperty()) && !el.node["static"]) {
            firstFieldPath = el;
            break;
          }
          if (!consturctorPath && el.isClassMethod({
            kind: "constructor"
          })) {
            consturctorPath = el;
          }
        }
        if (firstFieldPath) {
          injectToFieldInit(firstFieldPath, init3, true);
        } else {
          injectInitialization(classPath, consturctorPath, [t3.expressionStatement(init3)]);
        }
      }
      function getWeakSetId(weakSets, outerClass, reference, name2, inject) {
        if (name2 === void 0) {
          name2 = "";
        }
        var id3 = classWeakSets.get(reference.node);
        if (!id3) {
          id3 = outerClass.scope.generateUidIdentifier((name2 || "") + " brandCheck");
          classWeakSets.set(reference.node, id3);
          inject(reference, template2.expression.ast(_templateObject$d || (_templateObject$d = _taggedTemplateLiteralLoose(["", ".add(this)"])), t3.cloneNode(id3)));
          var newExpr = t3.newExpression(t3.identifier("WeakSet"), []);
          annotateAsPure(newExpr);
          outerClass.insertBefore(template2.ast(_templateObject2$6 || (_templateObject2$6 = _taggedTemplateLiteralLoose(["var ", " = ", ""])), id3, newExpr));
        }
        return t3.cloneNode(id3);
      }
      return {
        name: "proposal-private-property-in-object",
        inherits: lib$f["default"],
        pre: function pre() {
          enableFeature$1(this.file, FEATURES$1.privateIn, loose);
        },
        visitor: {
          BinaryExpression: function BinaryExpression2(path2) {
            var node2 = path2.node;
            if (node2.operator !== "in")
              return;
            if (!t3.isPrivateName(node2.left))
              return;
            var name2 = node2.left.id.name;
            var privateElement;
            var outerClass = path2.findParent(function(path3) {
              if (!path3.isClass())
                return false;
              privateElement = path3.get("body.body").find(function(_ref32) {
                var node3 = _ref32.node;
                return t3.isPrivate(node3) && node3.key.id.name === name2;
              });
              return !!privateElement;
            });
            if (outerClass.parentPath.scope.path.isPattern()) {
              outerClass.replaceWith(template2.ast(_templateObject3$5 || (_templateObject3$5 = _taggedTemplateLiteralLoose(["(() => ", ")()"])), outerClass.node));
              return;
            }
            if (privateElement.isMethod()) {
              if (privateElement.node["static"]) {
                if (outerClass.node.id) {
                  unshadow2(outerClass.node.id.name, outerClass.scope, path2.scope);
                } else {
                  outerClass.set("id", path2.scope.generateUidIdentifier("class"));
                }
                path2.replaceWith(template2.expression.ast(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteralLoose(["\n                ", " === ", "\n              "])), t3.cloneNode(outerClass.node.id), path2.node.right));
              } else {
                var _outerClass$node$id;
                var id3 = getWeakSetId(classWeakSets, outerClass, outerClass, (_outerClass$node$id = outerClass.node.id) == null ? void 0 : _outerClass$node$id.name, injectInitialization$1);
                path2.replaceWith(template2.expression.ast(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), id3, path2.node.right));
              }
            } else {
              var _id = getWeakSetId(fieldsWeakSets, outerClass, privateElement, privateElement.node.key.id.name, injectToFieldInit);
              path2.replaceWith(template2.expression.ast(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), _id, path2.node.right));
            }
          }
        }
      };
    });
    var syntaxThrowExpressions = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-throw-expressions",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("throwExpressions");
        }
      };
    });
    var proposalThrowExpressions = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "proposal-throw-expressions",
        inherits: syntaxThrowExpressions,
        visitor: {
          UnaryExpression: function UnaryExpression2(path2) {
            var _path$node = path2.node, operator = _path$node.operator, argument = _path$node.argument;
            if (operator !== "throw")
              return;
            var arrow = functionExpression$3(null, [identifier$j("e")], blockStatement$6([throwStatement(identifier$j("e"))]));
            path2.replaceWith(callExpression$e(arrow, [argument]));
          }
        }
      };
    });
    var Alphabetic = {};
    var regenerate$2 = { exports: {} };
    (function(module2, exports3) {
      (function(root2) {
        var freeExports = exports3;
        var freeModule = module2 && module2.exports == freeExports && module2;
        var freeGlobal2 = typeof commonjsGlobal$1 == "object" && commonjsGlobal$1;
        if (freeGlobal2.global === freeGlobal2 || freeGlobal2.window === freeGlobal2) {
          root2 = freeGlobal2;
        }
        var ERRORS = {
          "rangeOrder": "A range\u2019s `stop` value must be greater than or equal to the `start` value.",
          "codePointRange": "Invalid code point value. Code points range from U+000000 to U+10FFFF."
        };
        var HIGH_SURROGATE_MIN = 55296;
        var HIGH_SURROGATE_MAX = 56319;
        var LOW_SURROGATE_MIN = 56320;
        var LOW_SURROGATE_MAX = 57343;
        var regexNull = /\\x00([^0123456789]|$)/g;
        var object4 = {};
        var hasOwnProperty2 = object4.hasOwnProperty;
        var extend3 = function extend4(destination, source) {
          var key2;
          for (key2 in source) {
            if (hasOwnProperty2.call(source, key2)) {
              destination[key2] = source[key2];
            }
          }
          return destination;
        };
        var forEach = function forEach2(array4, callback) {
          var index3 = -1;
          var length = array4.length;
          while (++index3 < length) {
            callback(array4[index3], index3);
          }
        };
        var toString3 = object4.toString;
        var isArray3 = function isArray4(value) {
          return toString3.call(value) == "[object Array]";
        };
        var isNumber2 = function isNumber3(value) {
          return typeof value == "number" || toString3.call(value) == "[object Number]";
        };
        var zeroes = "0000";
        var pad3 = function pad4(number4, totalCharacters) {
          var string3 = String(number4);
          return string3.length < totalCharacters ? (zeroes + string3).slice(-totalCharacters) : string3;
        };
        var hex2 = function hex3(number4) {
          return Number(number4).toString(16).toUpperCase();
        };
        var slice2 = [].slice;
        var dataFromCodePoints = function dataFromCodePoints2(codePoints) {
          var index3 = -1;
          var length = codePoints.length;
          var max3 = length - 1;
          var result = [];
          var isStart = true;
          var tmp;
          var previous = 0;
          while (++index3 < length) {
            tmp = codePoints[index3];
            if (isStart) {
              result.push(tmp);
              previous = tmp;
              isStart = false;
            } else {
              if (tmp == previous + 1) {
                if (index3 != max3) {
                  previous = tmp;
                  continue;
                } else {
                  isStart = true;
                  result.push(tmp + 1);
                }
              } else {
                result.push(previous + 1, tmp);
                previous = tmp;
              }
            }
          }
          if (!isStart) {
            result.push(tmp + 1);
          }
          return result;
        };
        var dataRemove = function dataRemove2(data3, codePoint) {
          var index3 = 0;
          var start2;
          var end2;
          var length = data3.length;
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1];
            if (codePoint >= start2 && codePoint < end2) {
              if (codePoint == start2) {
                if (end2 == start2 + 1) {
                  data3.splice(index3, 2);
                  return data3;
                } else {
                  data3[index3] = codePoint + 1;
                  return data3;
                }
              } else if (codePoint == end2 - 1) {
                data3[index3 + 1] = codePoint;
                return data3;
              } else {
                data3.splice(index3, 2, start2, codePoint, codePoint + 1, end2);
                return data3;
              }
            }
            index3 += 2;
          }
          return data3;
        };
        var dataRemoveRange = function dataRemoveRange2(data3, rangeStart, rangeEnd) {
          if (rangeEnd < rangeStart) {
            throw Error(ERRORS.rangeOrder);
          }
          var index3 = 0;
          var start2;
          var end2;
          while (index3 < data3.length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1] - 1;
            if (start2 > rangeEnd) {
              return data3;
            }
            if (rangeStart <= start2 && rangeEnd >= end2) {
              data3.splice(index3, 2);
              continue;
            }
            if (rangeStart >= start2 && rangeEnd < end2) {
              if (rangeStart == start2) {
                data3[index3] = rangeEnd + 1;
                data3[index3 + 1] = end2 + 1;
                return data3;
              }
              data3.splice(index3, 2, start2, rangeStart, rangeEnd + 1, end2 + 1);
              return data3;
            }
            if (rangeStart >= start2 && rangeStart <= end2) {
              data3[index3 + 1] = rangeStart;
            } else if (rangeEnd >= start2 && rangeEnd <= end2) {
              data3[index3] = rangeEnd + 1;
              return data3;
            }
            index3 += 2;
          }
          return data3;
        };
        var dataAdd = function dataAdd2(data3, codePoint) {
          var index3 = 0;
          var start2;
          var end2;
          var lastIndex = null;
          var length = data3.length;
          if (codePoint < 0 || codePoint > 1114111) {
            throw RangeError(ERRORS.codePointRange);
          }
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1];
            if (codePoint >= start2 && codePoint < end2) {
              return data3;
            }
            if (codePoint == start2 - 1) {
              data3[index3] = codePoint;
              return data3;
            }
            if (start2 > codePoint) {
              data3.splice(lastIndex != null ? lastIndex + 2 : 0, 0, codePoint, codePoint + 1);
              return data3;
            }
            if (codePoint == end2) {
              if (codePoint + 1 == data3[index3 + 2]) {
                data3.splice(index3, 4, start2, data3[index3 + 3]);
                return data3;
              }
              data3[index3 + 1] = codePoint + 1;
              return data3;
            }
            lastIndex = index3;
            index3 += 2;
          }
          data3.push(codePoint, codePoint + 1);
          return data3;
        };
        var dataAddData = function dataAddData2(dataA, dataB) {
          var index3 = 0;
          var start2;
          var end2;
          var data3 = dataA.slice();
          var length = dataB.length;
          while (index3 < length) {
            start2 = dataB[index3];
            end2 = dataB[index3 + 1] - 1;
            if (start2 == end2) {
              data3 = dataAdd(data3, start2);
            } else {
              data3 = dataAddRange(data3, start2, end2);
            }
            index3 += 2;
          }
          return data3;
        };
        var dataRemoveData = function dataRemoveData2(dataA, dataB) {
          var index3 = 0;
          var start2;
          var end2;
          var data3 = dataA.slice();
          var length = dataB.length;
          while (index3 < length) {
            start2 = dataB[index3];
            end2 = dataB[index3 + 1] - 1;
            if (start2 == end2) {
              data3 = dataRemove(data3, start2);
            } else {
              data3 = dataRemoveRange(data3, start2, end2);
            }
            index3 += 2;
          }
          return data3;
        };
        var dataAddRange = function dataAddRange2(data3, rangeStart, rangeEnd) {
          if (rangeEnd < rangeStart) {
            throw Error(ERRORS.rangeOrder);
          }
          if (rangeStart < 0 || rangeStart > 1114111 || rangeEnd < 0 || rangeEnd > 1114111) {
            throw RangeError(ERRORS.codePointRange);
          }
          var index3 = 0;
          var start2;
          var end2;
          var added = false;
          var length = data3.length;
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1];
            if (added) {
              if (start2 == rangeEnd + 1) {
                data3.splice(index3 - 1, 2);
                return data3;
              }
              if (start2 > rangeEnd) {
                return data3;
              }
              if (start2 >= rangeStart && start2 <= rangeEnd) {
                if (end2 > rangeStart && end2 - 1 <= rangeEnd) {
                  data3.splice(index3, 2);
                  index3 -= 2;
                } else {
                  data3.splice(index3 - 1, 2);
                  index3 -= 2;
                }
              }
            } else if (start2 == rangeEnd + 1 || start2 == rangeEnd) {
              data3[index3] = rangeStart;
              return data3;
            } else if (start2 > rangeEnd) {
              data3.splice(index3, 0, rangeStart, rangeEnd + 1);
              return data3;
            } else if (rangeStart >= start2 && rangeStart < end2 && rangeEnd + 1 <= end2) {
              return data3;
            } else if (rangeStart >= start2 && rangeStart < end2 || end2 == rangeStart) {
              data3[index3 + 1] = rangeEnd + 1;
              added = true;
            } else if (rangeStart <= start2 && rangeEnd + 1 >= end2) {
              data3[index3] = rangeStart;
              data3[index3 + 1] = rangeEnd + 1;
              added = true;
            }
            index3 += 2;
          }
          if (!added) {
            data3.push(rangeStart, rangeEnd + 1);
          }
          return data3;
        };
        var dataContains = function dataContains2(data3, codePoint) {
          var index3 = 0;
          var length = data3.length;
          var start2 = data3[index3];
          var end2 = data3[length - 1];
          if (length >= 2) {
            if (codePoint < start2 || codePoint > end2) {
              return false;
            }
          }
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1];
            if (codePoint >= start2 && codePoint < end2) {
              return true;
            }
            index3 += 2;
          }
          return false;
        };
        var dataIntersection = function dataIntersection2(data3, codePoints) {
          var index3 = 0;
          var length = codePoints.length;
          var codePoint;
          var result = [];
          while (index3 < length) {
            codePoint = codePoints[index3];
            if (dataContains(data3, codePoint)) {
              result.push(codePoint);
            }
            ++index3;
          }
          return dataFromCodePoints(result);
        };
        var dataIsEmpty = function dataIsEmpty2(data3) {
          return !data3.length;
        };
        var dataIsSingleton = function dataIsSingleton2(data3) {
          return data3.length == 2 && data3[0] + 1 == data3[1];
        };
        var dataToArray2 = function dataToArray3(data3) {
          var index3 = 0;
          var start2;
          var end2;
          var result = [];
          var length = data3.length;
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1];
            while (start2 < end2) {
              result.push(start2);
              ++start2;
            }
            index3 += 2;
          }
          return result;
        };
        var floor = Math.floor;
        var highSurrogate = function highSurrogate2(codePoint) {
          return parseInt(floor((codePoint - 65536) / 1024) + HIGH_SURROGATE_MIN, 10);
        };
        var lowSurrogate = function lowSurrogate2(codePoint) {
          return parseInt((codePoint - 65536) % 1024 + LOW_SURROGATE_MIN, 10);
        };
        var stringFromCharCode = String.fromCharCode;
        var codePointToString2 = function codePointToString3(codePoint) {
          var string3;
          if (codePoint == 9) {
            string3 = "\\t";
          } else if (codePoint == 10) {
            string3 = "\\n";
          } else if (codePoint == 12) {
            string3 = "\\f";
          } else if (codePoint == 13) {
            string3 = "\\r";
          } else if (codePoint == 45) {
            string3 = "\\x2D";
          } else if (codePoint == 92) {
            string3 = "\\\\";
          } else if (codePoint == 36 || codePoint >= 40 && codePoint <= 43 || codePoint == 46 || codePoint == 47 || codePoint == 63 || codePoint >= 91 && codePoint <= 94 || codePoint >= 123 && codePoint <= 125) {
            string3 = "\\" + stringFromCharCode(codePoint);
          } else if (codePoint >= 32 && codePoint <= 126) {
            string3 = stringFromCharCode(codePoint);
          } else if (codePoint <= 255) {
            string3 = "\\x" + pad3(hex2(codePoint), 2);
          } else {
            string3 = "\\u" + pad3(hex2(codePoint), 4);
          }
          return string3;
        };
        var codePointToStringUnicode = function codePointToStringUnicode2(codePoint) {
          if (codePoint <= 65535) {
            return codePointToString2(codePoint);
          }
          return "\\u{" + codePoint.toString(16).toUpperCase() + "}";
        };
        var symbolToCodePoint = function symbolToCodePoint2(symbol) {
          var length = symbol.length;
          var first = symbol.charCodeAt(0);
          var second;
          if (first >= HIGH_SURROGATE_MIN && first <= HIGH_SURROGATE_MAX && length > 1) {
            second = symbol.charCodeAt(1);
            return (first - HIGH_SURROGATE_MIN) * 1024 + second - LOW_SURROGATE_MIN + 65536;
          }
          return first;
        };
        var createBMPCharacterClasses = function createBMPCharacterClasses2(data3) {
          var result = "";
          var index3 = 0;
          var start2;
          var end2;
          var length = data3.length;
          if (dataIsSingleton(data3)) {
            return codePointToString2(data3[0]);
          }
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1] - 1;
            if (start2 == end2) {
              result += codePointToString2(start2);
            } else if (start2 + 1 == end2) {
              result += codePointToString2(start2) + codePointToString2(end2);
            } else {
              result += codePointToString2(start2) + "-" + codePointToString2(end2);
            }
            index3 += 2;
          }
          return "[" + result + "]";
        };
        var createUnicodeCharacterClasses = function createUnicodeCharacterClasses2(data3) {
          var result = "";
          var index3 = 0;
          var start2;
          var end2;
          var length = data3.length;
          if (dataIsSingleton(data3)) {
            return codePointToStringUnicode(data3[0]);
          }
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1] - 1;
            if (start2 == end2) {
              result += codePointToStringUnicode(start2);
            } else if (start2 + 1 == end2) {
              result += codePointToStringUnicode(start2) + codePointToStringUnicode(end2);
            } else {
              result += codePointToStringUnicode(start2) + "-" + codePointToStringUnicode(end2);
            }
            index3 += 2;
          }
          return "[" + result + "]";
        };
        var splitAtBMP = function splitAtBMP2(data3) {
          var loneHighSurrogates = [];
          var loneLowSurrogates = [];
          var bmp = [];
          var astral = [];
          var index3 = 0;
          var start2;
          var end2;
          var length = data3.length;
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1] - 1;
            if (start2 < HIGH_SURROGATE_MIN) {
              if (end2 < HIGH_SURROGATE_MIN) {
                bmp.push(start2, end2 + 1);
              }
              if (end2 >= HIGH_SURROGATE_MIN && end2 <= HIGH_SURROGATE_MAX) {
                bmp.push(start2, HIGH_SURROGATE_MIN);
                loneHighSurrogates.push(HIGH_SURROGATE_MIN, end2 + 1);
              }
              if (end2 >= LOW_SURROGATE_MIN && end2 <= LOW_SURROGATE_MAX) {
                bmp.push(start2, HIGH_SURROGATE_MIN);
                loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
                loneLowSurrogates.push(LOW_SURROGATE_MIN, end2 + 1);
              }
              if (end2 > LOW_SURROGATE_MAX) {
                bmp.push(start2, HIGH_SURROGATE_MIN);
                loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
                loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);
                if (end2 <= 65535) {
                  bmp.push(LOW_SURROGATE_MAX + 1, end2 + 1);
                } else {
                  bmp.push(LOW_SURROGATE_MAX + 1, 65535 + 1);
                  astral.push(65535 + 1, end2 + 1);
                }
              }
            } else if (start2 >= HIGH_SURROGATE_MIN && start2 <= HIGH_SURROGATE_MAX) {
              if (end2 >= HIGH_SURROGATE_MIN && end2 <= HIGH_SURROGATE_MAX) {
                loneHighSurrogates.push(start2, end2 + 1);
              }
              if (end2 >= LOW_SURROGATE_MIN && end2 <= LOW_SURROGATE_MAX) {
                loneHighSurrogates.push(start2, HIGH_SURROGATE_MAX + 1);
                loneLowSurrogates.push(LOW_SURROGATE_MIN, end2 + 1);
              }
              if (end2 > LOW_SURROGATE_MAX) {
                loneHighSurrogates.push(start2, HIGH_SURROGATE_MAX + 1);
                loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);
                if (end2 <= 65535) {
                  bmp.push(LOW_SURROGATE_MAX + 1, end2 + 1);
                } else {
                  bmp.push(LOW_SURROGATE_MAX + 1, 65535 + 1);
                  astral.push(65535 + 1, end2 + 1);
                }
              }
            } else if (start2 >= LOW_SURROGATE_MIN && start2 <= LOW_SURROGATE_MAX) {
              if (end2 >= LOW_SURROGATE_MIN && end2 <= LOW_SURROGATE_MAX) {
                loneLowSurrogates.push(start2, end2 + 1);
              }
              if (end2 > LOW_SURROGATE_MAX) {
                loneLowSurrogates.push(start2, LOW_SURROGATE_MAX + 1);
                if (end2 <= 65535) {
                  bmp.push(LOW_SURROGATE_MAX + 1, end2 + 1);
                } else {
                  bmp.push(LOW_SURROGATE_MAX + 1, 65535 + 1);
                  astral.push(65535 + 1, end2 + 1);
                }
              }
            } else if (start2 > LOW_SURROGATE_MAX && start2 <= 65535) {
              if (end2 <= 65535) {
                bmp.push(start2, end2 + 1);
              } else {
                bmp.push(start2, 65535 + 1);
                astral.push(65535 + 1, end2 + 1);
              }
            } else {
              astral.push(start2, end2 + 1);
            }
            index3 += 2;
          }
          return {
            "loneHighSurrogates": loneHighSurrogates,
            "loneLowSurrogates": loneLowSurrogates,
            "bmp": bmp,
            "astral": astral
          };
        };
        var optimizeSurrogateMappings = function optimizeSurrogateMappings2(surrogateMappings) {
          var result = [];
          var tmpLow = [];
          var addLow = false;
          var mapping;
          var nextMapping;
          var highSurrogates;
          var lowSurrogates;
          var nextHighSurrogates;
          var nextLowSurrogates;
          var index3 = -1;
          var length = surrogateMappings.length;
          while (++index3 < length) {
            mapping = surrogateMappings[index3];
            nextMapping = surrogateMappings[index3 + 1];
            if (!nextMapping) {
              result.push(mapping);
              continue;
            }
            highSurrogates = mapping[0];
            lowSurrogates = mapping[1];
            nextHighSurrogates = nextMapping[0];
            nextLowSurrogates = nextMapping[1];
            tmpLow = lowSurrogates;
            while (nextHighSurrogates && highSurrogates[0] == nextHighSurrogates[0] && highSurrogates[1] == nextHighSurrogates[1]) {
              if (dataIsSingleton(nextLowSurrogates)) {
                tmpLow = dataAdd(tmpLow, nextLowSurrogates[0]);
              } else {
                tmpLow = dataAddRange(tmpLow, nextLowSurrogates[0], nextLowSurrogates[1] - 1);
              }
              ++index3;
              mapping = surrogateMappings[index3];
              highSurrogates = mapping[0];
              lowSurrogates = mapping[1];
              nextMapping = surrogateMappings[index3 + 1];
              nextHighSurrogates = nextMapping && nextMapping[0];
              nextLowSurrogates = nextMapping && nextMapping[1];
              addLow = true;
            }
            result.push([highSurrogates, addLow ? tmpLow : lowSurrogates]);
            addLow = false;
          }
          return optimizeByLowSurrogates(result);
        };
        var optimizeByLowSurrogates = function optimizeByLowSurrogates2(surrogateMappings) {
          if (surrogateMappings.length == 1) {
            return surrogateMappings;
          }
          var index3 = -1;
          var innerIndex = -1;
          while (++index3 < surrogateMappings.length) {
            var mapping = surrogateMappings[index3];
            var lowSurrogates = mapping[1];
            var lowSurrogateStart = lowSurrogates[0];
            var lowSurrogateEnd = lowSurrogates[1];
            innerIndex = index3;
            while (++innerIndex < surrogateMappings.length) {
              var otherMapping = surrogateMappings[innerIndex];
              var otherLowSurrogates = otherMapping[1];
              var otherLowSurrogateStart = otherLowSurrogates[0];
              var otherLowSurrogateEnd = otherLowSurrogates[1];
              if (lowSurrogateStart == otherLowSurrogateStart && lowSurrogateEnd == otherLowSurrogateEnd && otherLowSurrogates.length === 2) {
                if (dataIsSingleton(otherMapping[0])) {
                  mapping[0] = dataAdd(mapping[0], otherMapping[0][0]);
                } else {
                  mapping[0] = dataAddRange(mapping[0], otherMapping[0][0], otherMapping[0][1] - 1);
                }
                surrogateMappings.splice(innerIndex, 1);
                --innerIndex;
              }
            }
          }
          return surrogateMappings;
        };
        var surrogateSet = function surrogateSet2(data3) {
          if (!data3.length) {
            return [];
          }
          var index3 = 0;
          var start2;
          var end2;
          var startHigh;
          var startLow;
          var endHigh;
          var endLow;
          var surrogateMappings = [];
          var length = data3.length;
          while (index3 < length) {
            start2 = data3[index3];
            end2 = data3[index3 + 1] - 1;
            startHigh = highSurrogate(start2);
            startLow = lowSurrogate(start2);
            endHigh = highSurrogate(end2);
            endLow = lowSurrogate(end2);
            var startsWithLowestLowSurrogate = startLow == LOW_SURROGATE_MIN;
            var endsWithHighestLowSurrogate = endLow == LOW_SURROGATE_MAX;
            var complete = false;
            if (startHigh == endHigh || startsWithLowestLowSurrogate && endsWithHighestLowSurrogate) {
              surrogateMappings.push([[startHigh, endHigh + 1], [startLow, endLow + 1]]);
              complete = true;
            } else {
              surrogateMappings.push([[startHigh, startHigh + 1], [startLow, LOW_SURROGATE_MAX + 1]]);
            }
            if (!complete && startHigh + 1 < endHigh) {
              if (endsWithHighestLowSurrogate) {
                surrogateMappings.push([[startHigh + 1, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
                complete = true;
              } else {
                surrogateMappings.push([[startHigh + 1, endHigh], [LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1]]);
              }
            }
            if (!complete) {
              surrogateMappings.push([[endHigh, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
            }
            index3 += 2;
          }
          return optimizeSurrogateMappings(surrogateMappings);
        };
        var createSurrogateCharacterClasses = function createSurrogateCharacterClasses2(surrogateMappings) {
          var result = [];
          forEach(surrogateMappings, function(surrogateMapping) {
            var highSurrogates = surrogateMapping[0];
            var lowSurrogates = surrogateMapping[1];
            result.push(createBMPCharacterClasses(highSurrogates) + createBMPCharacterClasses(lowSurrogates));
          });
          return result.join("|");
        };
        var createCharacterClassesFromData = function createCharacterClassesFromData2(data3, bmpOnly, hasUnicodeFlag) {
          if (hasUnicodeFlag) {
            return createUnicodeCharacterClasses(data3);
          }
          var result = [];
          var parts = splitAtBMP(data3);
          var loneHighSurrogates = parts.loneHighSurrogates;
          var loneLowSurrogates = parts.loneLowSurrogates;
          var bmp = parts.bmp;
          var astral = parts.astral;
          var hasLoneHighSurrogates = !dataIsEmpty(loneHighSurrogates);
          var hasLoneLowSurrogates = !dataIsEmpty(loneLowSurrogates);
          var surrogateMappings = surrogateSet(astral);
          if (bmpOnly) {
            bmp = dataAddData(bmp, loneHighSurrogates);
            hasLoneHighSurrogates = false;
            bmp = dataAddData(bmp, loneLowSurrogates);
            hasLoneLowSurrogates = false;
          }
          if (!dataIsEmpty(bmp)) {
            result.push(createBMPCharacterClasses(bmp));
          }
          if (surrogateMappings.length) {
            result.push(createSurrogateCharacterClasses(surrogateMappings));
          }
          if (hasLoneHighSurrogates) {
            result.push(createBMPCharacterClasses(loneHighSurrogates) + "(?![\\uDC00-\\uDFFF])");
          }
          if (hasLoneLowSurrogates) {
            result.push("(?:[^\\uD800-\\uDBFF]|^)" + createBMPCharacterClasses(loneLowSurrogates));
          }
          return result.join("|");
        };
        var regenerate2 = function regenerate3(value) {
          if (arguments.length > 1) {
            value = slice2.call(arguments);
          }
          if (this instanceof regenerate3) {
            this.data = [];
            return value ? this.add(value) : this;
          }
          return new regenerate3().add(value);
        };
        regenerate2.version = "1.4.2";
        var proto2 = regenerate2.prototype;
        extend3(proto2, {
          "add": function add2(value) {
            var $this = this;
            if (value == null) {
              return $this;
            }
            if (value instanceof regenerate2) {
              $this.data = dataAddData($this.data, value.data);
              return $this;
            }
            if (arguments.length > 1) {
              value = slice2.call(arguments);
            }
            if (isArray3(value)) {
              forEach(value, function(item) {
                $this.add(item);
              });
              return $this;
            }
            $this.data = dataAdd($this.data, isNumber2(value) ? value : symbolToCodePoint(value));
            return $this;
          },
          "remove": function remove2(value) {
            var $this = this;
            if (value == null) {
              return $this;
            }
            if (value instanceof regenerate2) {
              $this.data = dataRemoveData($this.data, value.data);
              return $this;
            }
            if (arguments.length > 1) {
              value = slice2.call(arguments);
            }
            if (isArray3(value)) {
              forEach(value, function(item) {
                $this.remove(item);
              });
              return $this;
            }
            $this.data = dataRemove($this.data, isNumber2(value) ? value : symbolToCodePoint(value));
            return $this;
          },
          "addRange": function addRange(start2, end2) {
            var $this = this;
            $this.data = dataAddRange($this.data, isNumber2(start2) ? start2 : symbolToCodePoint(start2), isNumber2(end2) ? end2 : symbolToCodePoint(end2));
            return $this;
          },
          "removeRange": function removeRange(start2, end2) {
            var $this = this;
            var startCodePoint = isNumber2(start2) ? start2 : symbolToCodePoint(start2);
            var endCodePoint = isNumber2(end2) ? end2 : symbolToCodePoint(end2);
            $this.data = dataRemoveRange($this.data, startCodePoint, endCodePoint);
            return $this;
          },
          "intersection": function intersection2(argument) {
            var $this = this;
            var array4 = argument instanceof regenerate2 ? dataToArray2(argument.data) : argument;
            $this.data = dataIntersection($this.data, array4);
            return $this;
          },
          "contains": function contains2(codePoint) {
            return dataContains(this.data, isNumber2(codePoint) ? codePoint : symbolToCodePoint(codePoint));
          },
          "clone": function clone4() {
            var set3 = new regenerate2();
            set3.data = this.data.slice(0);
            return set3;
          },
          "toString": function toString4(options) {
            var result = createCharacterClassesFromData(this.data, options ? options.bmpOnly : false, options ? options.hasUnicodeFlag : false);
            if (!result) {
              return "[]";
            }
            return result.replace(regexNull, "\\0$1");
          },
          "toRegExp": function toRegExp(flags) {
            var pattern5 = this.toString(flags && flags.indexOf("u") != -1 ? {
              "hasUnicodeFlag": true
            } : null);
            return RegExp(pattern5, flags || "");
          },
          "valueOf": function valueOf() {
            return dataToArray2(this.data);
          }
        });
        proto2.toArray = proto2.valueOf;
        if (freeExports && !freeExports.nodeType) {
          if (freeModule) {
            freeModule.exports = regenerate2;
          } else {
            freeExports.regenerate = regenerate2;
          }
        } else {
          root2.regenerate = regenerate2;
        }
      })(commonjsGlobal$1);
    })(regenerate$2, regenerate$2.exports);
    var hasRequiredAlphabetic;
    function requireAlphabetic() {
      if (hasRequiredAlphabetic)
        return Alphabetic;
      hasRequiredAlphabetic = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 748, 750, 837, 895, 902, 908, 1369, 1471, 1479, 1791, 2042, 2482, 2510, 2519, 2556, 2641, 2654, 2768, 2929, 2972, 3024, 3031, 3165, 3406, 3517, 3542, 3661, 3716, 3749, 3782, 3789, 3840, 4152, 4295, 4301, 4696, 4800, 6103, 6108, 6823, 7418, 8025, 8027, 8029, 8126, 8305, 8319, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 11823, 42963, 43205, 43259, 43471, 43712, 43714, 64318, 67592, 67644, 69415, 69826, 70006, 70106, 70108, 70199, 70206, 70280, 70480, 70487, 70855, 71232, 71236, 71352, 71945, 72161, 72349, 72768, 73018, 73027, 73112, 73648, 94179, 113822, 119970, 119995, 120134, 123214, 125255, 125259, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(880, 884).addRange(886, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1456, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1488, 1514).addRange(1519, 1522).addRange(1552, 1562).addRange(1568, 1623).addRange(1625, 1631).addRange(1646, 1747).addRange(1749, 1756).addRange(1761, 1768).addRange(1773, 1775).addRange(1786, 1788).addRange(1808, 1855).addRange(1869, 1969).addRange(1994, 2026).addRange(2036, 2037).addRange(2048, 2071).addRange(2074, 2092).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2208, 2249).addRange(2260, 2271).addRange(2275, 2281).addRange(2288, 2363).addRange(2365, 2380).addRange(2382, 2384).addRange(2389, 2403).addRange(2417, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472);
      set3.addRange(2474, 2480).addRange(2486, 2489).addRange(2493, 2500).addRange(2503, 2504).addRange(2507, 2508).addRange(2524, 2525).addRange(2527, 2531).addRange(2544, 2545).addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2636).addRange(2649, 2652).addRange(2672, 2677).addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2749, 2757).addRange(2759, 2761).addRange(2763, 2764).addRange(2784, 2787).addRange(2809, 2812).addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2877, 2884).addRange(2887, 2888).addRange(2891, 2892).addRange(2902, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970);
      set3.addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3020).addRange(3072, 3075).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3133, 3140).addRange(3142, 3144).addRange(3146, 3148).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3200, 3203).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3261, 3268).addRange(3270, 3272).addRange(3274, 3276).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3313, 3314).addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3389, 3396).addRange(3398, 3400).addRange(3402, 3404).addRange(3412, 3415).addRange(3423, 3427).addRange(3450, 3455).addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3570, 3571).addRange(3585, 3642).addRange(3648, 3654).addRange(3713, 3714);
      set3.addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3769).addRange(3771, 3773).addRange(3776, 3780).addRange(3804, 3807).addRange(3904, 3911).addRange(3913, 3948).addRange(3953, 3969).addRange(3976, 3991).addRange(3993, 4028).addRange(4096, 4150).addRange(4155, 4159).addRange(4176, 4239).addRange(4250, 4253).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5870, 5880).addRange(5888, 5907).addRange(5919, 5939).addRange(5952, 5971).addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003).addRange(6016, 6067).addRange(6070, 6088).addRange(6176, 6264).addRange(6272, 6314).addRange(6320, 6389).addRange(6400, 6430);
      set3.addRange(6432, 6443).addRange(6448, 6456).addRange(6480, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6656, 6683).addRange(6688, 6750).addRange(6753, 6772).addRange(6847, 6848).addRange(6860, 6862).addRange(6912, 6963).addRange(6965, 6979).addRange(6981, 6988).addRange(7040, 7081).addRange(7084, 7087).addRange(7098, 7141).addRange(7143, 7153).addRange(7168, 7222).addRange(7245, 7247).addRange(7258, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7414).addRange(7424, 7615).addRange(7655, 7668).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8336, 8348).addRange(8458, 8467).addRange(8473, 8477).addRange(8490, 8493).addRange(8495, 8505).addRange(8508, 8511).addRange(8517, 8521);
      set3.addRange(8544, 8584).addRange(9398, 9449).addRange(11264, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(11568, 11623).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(11744, 11775).addRange(12293, 12295).addRange(12321, 12329).addRange(12337, 12341).addRange(12344, 12348).addRange(12353, 12438).addRange(12445, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42527).addRange(42538, 42539).addRange(42560, 42606).addRange(42612, 42619).addRange(42623, 42735).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43013).addRange(43015, 43047).addRange(43072, 43123).addRange(43136, 43203).addRange(43250, 43255).addRange(43261, 43263).addRange(43274, 43306).addRange(43312, 43346);
      set3.addRange(43360, 43388).addRange(43392, 43442).addRange(43444, 43455).addRange(43488, 43503).addRange(43514, 43518).addRange(43520, 43574).addRange(43584, 43597).addRange(43616, 43638).addRange(43642, 43710).addRange(43739, 43741).addRange(43744, 43759).addRange(43762, 43765).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44010).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64285, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65019).addRange(65136, 65140).addRange(65142, 65276).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613);
      set3.addRange(65616, 65629).addRange(65664, 65786).addRange(65856, 65908).addRange(66176, 66204).addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66378).addRange(66384, 66426).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66513, 66517).addRange(66560, 66717).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023).addRange(68030, 68031).addRange(68096, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295);
      set3.addRange(68297, 68324).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680).addRange(68736, 68786).addRange(68800, 68850).addRange(68864, 68903).addRange(69248, 69289).addRange(69291, 69292).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69445).addRange(69488, 69505).addRange(69552, 69572).addRange(69600, 69622).addRange(69632, 69701).addRange(69745, 69749).addRange(69762, 69816).addRange(69840, 69864).addRange(69888, 69938).addRange(69956, 69959).addRange(69968, 70002).addRange(70016, 70079).addRange(70081, 70084).addRange(70094, 70095).addRange(70144, 70161).addRange(70163, 70196).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70376).addRange(70400, 70403).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70461, 70468).addRange(70471, 70472).addRange(70475, 70476).addRange(70493, 70499).addRange(70656, 70721).addRange(70723, 70725).addRange(70727, 70730).addRange(70751, 70753).addRange(70784, 70849).addRange(70852, 70853);
      set3.addRange(71040, 71093).addRange(71096, 71102).addRange(71128, 71133).addRange(71168, 71230).addRange(71296, 71349).addRange(71424, 71450).addRange(71453, 71466).addRange(71488, 71494).addRange(71680, 71736).addRange(71840, 71903).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 71996).addRange(71999, 72002).addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72159).addRange(72163, 72164).addRange(72192, 72242).addRange(72245, 72254).addRange(72272, 72343).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72766).addRange(72818, 72847).addRange(72850, 72871).addRange(72873, 72886).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73025).addRange(73030, 73031).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73110).addRange(73440, 73462).addRange(73728, 74649).addRange(74752, 74862).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766);
      set3.addRange(92784, 92862).addRange(92880, 92909).addRange(92928, 92975).addRange(92992, 92995).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111).addRange(94176, 94177).addRange(94192, 94193).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744);
      set3.addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122654).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123136, 123180).addRange(123191, 123197).addRange(123536, 123565).addRange(123584, 123627).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125184, 125251).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(127280, 127305).addRange(127312, 127337).addRange(127344, 127369).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Alphabetic.characters = set3;
      return Alphabetic;
    }
    var Any = {};
    var hasRequiredAny;
    function requireAny() {
      if (hasRequiredAny)
        return Any;
      hasRequiredAny = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(0, 1114111);
      Any.characters = set3;
      return Any;
    }
    var ASCII_Hex_Digit = {};
    var hasRequiredASCII_Hex_Digit;
    function requireASCII_Hex_Digit() {
      if (hasRequiredASCII_Hex_Digit)
        return ASCII_Hex_Digit;
      hasRequiredASCII_Hex_Digit = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(48, 57).addRange(65, 70).addRange(97, 102);
      ASCII_Hex_Digit.characters = set3;
      return ASCII_Hex_Digit;
    }
    var ASCII = {};
    var hasRequiredASCII;
    function requireASCII() {
      if (hasRequiredASCII)
        return ASCII;
      hasRequiredASCII = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(0, 127);
      ASCII.characters = set3;
      return ASCII;
    }
    var Assigned = {};
    var hasRequiredAssigned;
    function requireAssigned() {
      if (hasRequiredAssigned)
        return Assigned;
      hasRequiredAssigned = 1;
      var set3 = regenerate$2.exports(908, 2142, 2482, 2519, 2620, 2641, 2654, 2768, 2972, 3024, 3031, 3165, 3517, 3530, 3542, 3716, 3749, 3782, 4295, 4301, 4696, 4800, 6464, 8025, 8027, 8029, 11559, 11565, 42963, 64318, 64975, 65279, 65952, 67592, 67644, 67903, 69837, 70280, 70480, 70487, 71945, 73018, 73648, 119970, 119995, 120134, 123647, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590, 129008, 917505);
      set3.addRange(0, 887).addRange(890, 895).addRange(900, 906).addRange(910, 929).addRange(931, 1327).addRange(1329, 1366).addRange(1369, 1418).addRange(1421, 1423).addRange(1425, 1479).addRange(1488, 1514).addRange(1519, 1524).addRange(1536, 1805).addRange(1807, 1866).addRange(1869, 1969).addRange(1984, 2042).addRange(2045, 2093).addRange(2096, 2110).addRange(2112, 2139).addRange(2144, 2154).addRange(2160, 2190).addRange(2192, 2193).addRange(2200, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2492, 2500).addRange(2503, 2504).addRange(2507, 2510).addRange(2524, 2525).addRange(2527, 2531).addRange(2534, 2558).addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2649, 2652).addRange(2662, 2678).addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736);
      set3.addRange(2738, 2739).addRange(2741, 2745).addRange(2748, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2784, 2787).addRange(2790, 2801).addRange(2809, 2815).addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2876, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2918, 2935).addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021).addRange(3046, 3066).addRange(3072, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3132, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3174, 3183).addRange(3191, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257);
      set3.addRange(3260, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3302, 3311).addRange(3313, 3314).addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3396).addRange(3398, 3400).addRange(3402, 3407).addRange(3412, 3427).addRange(3430, 3455).addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3558, 3567).addRange(3570, 3572).addRange(3585, 3642).addRange(3647, 3675).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3773).addRange(3776, 3780).addRange(3784, 3789).addRange(3792, 3801).addRange(3804, 3807).addRange(3840, 3911).addRange(3913, 3948).addRange(3953, 3991).addRange(3993, 4028).addRange(4030, 4044).addRange(4046, 4058).addRange(4096, 4293).addRange(4304, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805);
      set3.addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4957, 4988).addRange(4992, 5017).addRange(5024, 5109).addRange(5112, 5117).addRange(5120, 5788).addRange(5792, 5880).addRange(5888, 5909).addRange(5919, 5942).addRange(5952, 5971).addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003).addRange(6016, 6109).addRange(6112, 6121).addRange(6128, 6137).addRange(6144, 6169).addRange(6176, 6264).addRange(6272, 6314).addRange(6320, 6389).addRange(6400, 6430).addRange(6432, 6443).addRange(6448, 6459).addRange(6468, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6622, 6683).addRange(6686, 6750).addRange(6752, 6780).addRange(6783, 6793).addRange(6800, 6809).addRange(6816, 6829).addRange(6832, 6862).addRange(6912, 6988).addRange(6992, 7038).addRange(7040, 7155).addRange(7164, 7223).addRange(7227, 7241).addRange(7245, 7304).addRange(7312, 7354).addRange(7357, 7367).addRange(7376, 7418).addRange(7424, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013);
      set3.addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8132).addRange(8134, 8147).addRange(8150, 8155).addRange(8157, 8175).addRange(8178, 8180).addRange(8182, 8190).addRange(8192, 8292).addRange(8294, 8305).addRange(8308, 8334).addRange(8336, 8348).addRange(8352, 8384).addRange(8400, 8432).addRange(8448, 8587).addRange(8592, 9254).addRange(9280, 9290).addRange(9312, 11123).addRange(11126, 11157).addRange(11159, 11507).addRange(11513, 11557).addRange(11568, 11623).addRange(11631, 11632).addRange(11647, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(11744, 11869).addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12272, 12283).addRange(12288, 12351).addRange(12353, 12438).addRange(12441, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12688, 12771).addRange(12784, 12830).addRange(12832, 42124).addRange(42128, 42182).addRange(42192, 42539).addRange(42560, 42743).addRange(42752, 42954).addRange(42960, 42961);
      set3.addRange(42965, 42969).addRange(42994, 43052).addRange(43056, 43065).addRange(43072, 43127).addRange(43136, 43205).addRange(43214, 43225).addRange(43232, 43347).addRange(43359, 43388).addRange(43392, 43469).addRange(43471, 43481).addRange(43486, 43518).addRange(43520, 43574).addRange(43584, 43597).addRange(43600, 43609).addRange(43612, 43714).addRange(43739, 43766).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43883).addRange(43888, 44013).addRange(44016, 44025).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(55296, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64285, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64450).addRange(64467, 64911).addRange(64914, 64967).addRange(65008, 65049).addRange(65056, 65106).addRange(65108, 65126).addRange(65128, 65131).addRange(65136, 65140).addRange(65142, 65276).addRange(65281, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65504, 65510).addRange(65512, 65518);
      set3.addRange(65529, 65533).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65792, 65794).addRange(65799, 65843).addRange(65847, 65934).addRange(65936, 65948).addRange(66e3, 66045).addRange(66176, 66204).addRange(66208, 66256).addRange(66272, 66299).addRange(66304, 66339).addRange(66349, 66378).addRange(66384, 66426).addRange(66432, 66461).addRange(66463, 66499).addRange(66504, 66517).addRange(66560, 66717).addRange(66720, 66729).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66927, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67671, 67742).addRange(67751, 67759).addRange(67808, 67826).addRange(67828, 67829).addRange(67835, 67867);
      set3.addRange(67871, 67897).addRange(67968, 68023).addRange(68028, 68047).addRange(68050, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68152, 68154).addRange(68159, 68168).addRange(68176, 68184).addRange(68192, 68255).addRange(68288, 68326).addRange(68331, 68342).addRange(68352, 68405).addRange(68409, 68437).addRange(68440, 68466).addRange(68472, 68497).addRange(68505, 68508).addRange(68521, 68527).addRange(68608, 68680).addRange(68736, 68786).addRange(68800, 68850).addRange(68858, 68903).addRange(68912, 68921).addRange(69216, 69246).addRange(69248, 69289).addRange(69291, 69293).addRange(69296, 69297).addRange(69376, 69415).addRange(69424, 69465).addRange(69488, 69513).addRange(69552, 69579).addRange(69600, 69622).addRange(69632, 69709).addRange(69714, 69749).addRange(69759, 69826).addRange(69840, 69864).addRange(69872, 69881).addRange(69888, 69940).addRange(69942, 69959).addRange(69968, 70006).addRange(70016, 70111).addRange(70113, 70132).addRange(70144, 70161).addRange(70163, 70206).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70313).addRange(70320, 70378);
      set3.addRange(70384, 70393).addRange(70400, 70403).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70459, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70502, 70508).addRange(70512, 70516).addRange(70656, 70747).addRange(70749, 70753).addRange(70784, 70855).addRange(70864, 70873).addRange(71040, 71093).addRange(71096, 71133).addRange(71168, 71236).addRange(71248, 71257).addRange(71264, 71276).addRange(71296, 71353).addRange(71360, 71369).addRange(71424, 71450).addRange(71453, 71467).addRange(71472, 71494).addRange(71680, 71739).addRange(71840, 71922).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 72006).addRange(72016, 72025).addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72164).addRange(72192, 72263).addRange(72272, 72354).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72773).addRange(72784, 72812).addRange(72816, 72847).addRange(72850, 72871).addRange(72873, 72886).addRange(72960, 72966);
      set3.addRange(72968, 72969).addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73031).addRange(73040, 73049).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73112).addRange(73120, 73129).addRange(73440, 73464).addRange(73664, 73713).addRange(73727, 74649).addRange(74752, 74862).addRange(74864, 74868).addRange(74880, 75075).addRange(77712, 77810).addRange(77824, 78894).addRange(78896, 78904).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92768, 92777).addRange(92782, 92862).addRange(92864, 92873).addRange(92880, 92909).addRange(92912, 92917).addRange(92928, 92997).addRange(93008, 93017).addRange(93019, 93025).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93850).addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111).addRange(94176, 94180).addRange(94192, 94193).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788);
      set3.addRange(113792, 113800).addRange(113808, 113817).addRange(113820, 113827).addRange(118528, 118573).addRange(118576, 118598).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119274).addRange(119296, 119365).addRange(119520, 119539).addRange(119552, 119638).addRange(119648, 119672).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 121483).addRange(121499, 121503).addRange(121505, 121519).addRange(122624, 122654).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123136, 123180).addRange(123184, 123197).addRange(123200, 123209).addRange(123214, 123215).addRange(123536, 123566).addRange(123584, 123641).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125127, 125142);
      set3.addRange(125184, 125259).addRange(125264, 125273).addRange(125278, 125279).addRange(126065, 126132).addRange(126209, 126269).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(126704, 126705).addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127232, 127405).addRange(127462, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(127584, 127589).addRange(127744, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984).addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660);
      set3.addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994).addRange(130032, 130041).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546).addRange(917536, 917631).addRange(917760, 917999).addRange(983040, 1048573).addRange(1048576, 1114109);
      Assigned.characters = set3;
      return Assigned;
    }
    var Bidi_Control = {};
    var hasRequiredBidi_Control;
    function requireBidi_Control() {
      if (hasRequiredBidi_Control)
        return Bidi_Control;
      hasRequiredBidi_Control = 1;
      var set3 = regenerate$2.exports(1564);
      set3.addRange(8206, 8207).addRange(8234, 8238).addRange(8294, 8297);
      Bidi_Control.characters = set3;
      return Bidi_Control;
    }
    var Bidi_Mirrored = {};
    var hasRequiredBidi_Mirrored;
    function requireBidi_Mirrored() {
      if (hasRequiredBidi_Mirrored)
        return Bidi_Mirrored;
      hasRequiredBidi_Mirrored = 1;
      var set3 = regenerate$2.exports(60, 62, 91, 93, 123, 125, 171, 187, 8512, 8721, 8740, 8742, 8761, 8802, 8856, 10176, 10680, 10697, 10721, 10788, 10790, 10793, 10972, 10974, 10995, 11005, 11262, 65308, 65310, 65339, 65341, 65371, 65373, 120539, 120597, 120655, 120713, 120771);
      set3.addRange(40, 41).addRange(3898, 3901).addRange(5787, 5788).addRange(8249, 8250).addRange(8261, 8262).addRange(8317, 8318).addRange(8333, 8334).addRange(8705, 8708).addRange(8712, 8717).addRange(8725, 8726).addRange(8730, 8733).addRange(8735, 8738).addRange(8747, 8755).addRange(8763, 8780).addRange(8786, 8789).addRange(8799, 8800).addRange(8804, 8811).addRange(8814, 8844).addRange(8847, 8850).addRange(8866, 8867).addRange(8870, 8888).addRange(8894, 8895).addRange(8905, 8909).addRange(8912, 8913).addRange(8918, 8941).addRange(8944, 8959).addRange(8968, 8971).addRange(8992, 8993).addRange(9001, 9002).addRange(10088, 10101).addRange(10179, 10182).addRange(10184, 10185).addRange(10187, 10189).addRange(10195, 10198).addRange(10204, 10206).addRange(10210, 10223).addRange(10627, 10648).addRange(10651, 10656).addRange(10658, 10671).addRange(10688, 10693).addRange(10702, 10706).addRange(10708, 10709).addRange(10712, 10716).addRange(10723, 10725).addRange(10728, 10729).addRange(10740, 10745).addRange(10748, 10749).addRange(10762, 10780).addRange(10782, 10785).addRange(10795, 10798).addRange(10804, 10805);
      set3.addRange(10812, 10814).addRange(10839, 10840).addRange(10852, 10853).addRange(10858, 10861).addRange(10863, 10864).addRange(10867, 10868).addRange(10873, 10915).addRange(10918, 10925).addRange(10927, 10966).addRange(10978, 10982).addRange(10988, 10990).addRange(10999, 11003).addRange(11778, 11781).addRange(11785, 11786).addRange(11788, 11789).addRange(11804, 11805).addRange(11808, 11817).addRange(11861, 11868).addRange(12296, 12305).addRange(12308, 12315).addRange(65113, 65118).addRange(65124, 65125).addRange(65288, 65289).addRange(65375, 65376).addRange(65378, 65379);
      Bidi_Mirrored.characters = set3;
      return Bidi_Mirrored;
    }
    var Case_Ignorable = {};
    var hasRequiredCase_Ignorable;
    function requireCase_Ignorable() {
      if (hasRequiredCase_Ignorable)
        return Case_Ignorable;
      hasRequiredCase_Ignorable = 1;
      var set3 = regenerate$2.exports(39, 46, 58, 94, 96, 168, 173, 175, 180, 890, 903, 1369, 1375, 1471, 1479, 1524, 1564, 1600, 1648, 1807, 1809, 2042, 2045, 2184, 2362, 2364, 2381, 2417, 2433, 2492, 2509, 2558, 2620, 2641, 2677, 2748, 2765, 2817, 2876, 2879, 2893, 2946, 3008, 3021, 3072, 3076, 3132, 3201, 3260, 3263, 3270, 3405, 3457, 3530, 3542, 3633, 3761, 3782, 3893, 3895, 3897, 4038, 4226, 4237, 4253, 4348, 6086, 6103, 6109, 6211, 6313, 6450, 6683, 6742, 6752, 6754, 6783, 6823, 6964, 6972, 6978, 7142, 7149, 7405, 7412, 7544, 8125, 8228, 8231, 8305, 8319, 11631, 11647, 11823, 12293, 12347, 40981, 42508, 42623, 42864, 43010, 43014, 43019, 43052, 43263, 43443, 43471, 43587, 43596, 43632, 43644, 43696, 43713, 43741, 43766, 44005, 44008, 44013, 64286, 65043, 65106, 65109, 65279, 65287, 65294, 65306, 65342, 65344, 65392, 65507, 66045, 66272, 68159, 69633, 69744, 69821, 69826, 69837, 70003, 70095, 70196, 70206, 70367, 70464, 70726, 70750, 70842, 71229, 71339, 71341, 71351, 71998, 72003, 72160, 72263, 72767, 73018, 73031, 73109, 73111, 94031, 121461, 121476, 123566, 917505);
      set3.addRange(183, 184).addRange(688, 879).addRange(884, 885).addRange(900, 901).addRange(1155, 1161).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1536, 1541).addRange(1552, 1562).addRange(1611, 1631).addRange(1750, 1757).addRange(1759, 1768).addRange(1770, 1773).addRange(1840, 1866).addRange(1958, 1968).addRange(2027, 2037).addRange(2070, 2093).addRange(2137, 2139).addRange(2192, 2193).addRange(2200, 2207).addRange(2249, 2306).addRange(2369, 2376).addRange(2385, 2391).addRange(2402, 2403).addRange(2497, 2500).addRange(2530, 2531).addRange(2561, 2562).addRange(2625, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2672, 2673).addRange(2689, 2690).addRange(2753, 2757).addRange(2759, 2760).addRange(2786, 2787).addRange(2810, 2815).addRange(2881, 2884).addRange(2901, 2902).addRange(2914, 2915).addRange(3134, 3136).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3170, 3171).addRange(3276, 3277).addRange(3298, 3299).addRange(3328, 3329).addRange(3387, 3388).addRange(3393, 3396).addRange(3426, 3427);
      set3.addRange(3538, 3540).addRange(3636, 3642).addRange(3654, 3662).addRange(3764, 3772).addRange(3784, 3789).addRange(3864, 3865).addRange(3953, 3966).addRange(3968, 3972).addRange(3974, 3975).addRange(3981, 3991).addRange(3993, 4028).addRange(4141, 4144).addRange(4146, 4151).addRange(4153, 4154).addRange(4157, 4158).addRange(4184, 4185).addRange(4190, 4192).addRange(4209, 4212).addRange(4229, 4230).addRange(4957, 4959).addRange(5906, 5908).addRange(5938, 5939).addRange(5970, 5971).addRange(6002, 6003).addRange(6068, 6069).addRange(6071, 6077).addRange(6089, 6099).addRange(6155, 6159).addRange(6277, 6278).addRange(6432, 6434).addRange(6439, 6440).addRange(6457, 6459).addRange(6679, 6680).addRange(6744, 6750).addRange(6757, 6764).addRange(6771, 6780).addRange(6832, 6862).addRange(6912, 6915).addRange(6966, 6970).addRange(7019, 7027).addRange(7040, 7041).addRange(7074, 7077).addRange(7080, 7081).addRange(7083, 7085).addRange(7144, 7145).addRange(7151, 7153).addRange(7212, 7219).addRange(7222, 7223).addRange(7288, 7293).addRange(7376, 7378).addRange(7380, 7392);
      set3.addRange(7394, 7400).addRange(7416, 7417).addRange(7468, 7530).addRange(7579, 7679).addRange(8127, 8129).addRange(8141, 8143).addRange(8157, 8159).addRange(8173, 8175).addRange(8189, 8190).addRange(8203, 8207).addRange(8216, 8217).addRange(8234, 8238).addRange(8288, 8292).addRange(8294, 8303).addRange(8336, 8348).addRange(8400, 8432).addRange(11388, 11389).addRange(11503, 11505).addRange(11744, 11775).addRange(12330, 12333).addRange(12337, 12341).addRange(12441, 12446).addRange(12540, 12542).addRange(42232, 42237).addRange(42607, 42610).addRange(42612, 42621).addRange(42652, 42655).addRange(42736, 42737).addRange(42752, 42785).addRange(42888, 42890).addRange(42994, 42996).addRange(43e3, 43001).addRange(43045, 43046).addRange(43204, 43205).addRange(43232, 43249).addRange(43302, 43309).addRange(43335, 43345).addRange(43392, 43394).addRange(43446, 43449).addRange(43452, 43453).addRange(43493, 43494).addRange(43561, 43566).addRange(43569, 43570).addRange(43573, 43574).addRange(43698, 43700).addRange(43703, 43704).addRange(43710, 43711).addRange(43756, 43757).addRange(43763, 43764).addRange(43867, 43871).addRange(43881, 43883);
      set3.addRange(64434, 64450).addRange(65024, 65039).addRange(65056, 65071).addRange(65438, 65439).addRange(65529, 65531).addRange(66422, 66426).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(68097, 68099).addRange(68101, 68102).addRange(68108, 68111).addRange(68152, 68154).addRange(68325, 68326).addRange(68900, 68903).addRange(69291, 69292).addRange(69446, 69456).addRange(69506, 69509).addRange(69688, 69702).addRange(69747, 69748).addRange(69759, 69761).addRange(69811, 69814).addRange(69817, 69818).addRange(69888, 69890).addRange(69927, 69931).addRange(69933, 69940).addRange(70016, 70017).addRange(70070, 70078).addRange(70089, 70092).addRange(70191, 70193).addRange(70198, 70199).addRange(70371, 70378).addRange(70400, 70401).addRange(70459, 70460).addRange(70502, 70508).addRange(70512, 70516).addRange(70712, 70719).addRange(70722, 70724).addRange(70835, 70840).addRange(70847, 70848).addRange(70850, 70851).addRange(71090, 71093).addRange(71100, 71101).addRange(71103, 71104).addRange(71132, 71133).addRange(71219, 71226).addRange(71231, 71232).addRange(71344, 71349).addRange(71453, 71455).addRange(71458, 71461).addRange(71463, 71467);
      set3.addRange(71727, 71735).addRange(71737, 71738).addRange(71995, 71996).addRange(72148, 72151).addRange(72154, 72155).addRange(72193, 72202).addRange(72243, 72248).addRange(72251, 72254).addRange(72273, 72278).addRange(72281, 72283).addRange(72330, 72342).addRange(72344, 72345).addRange(72752, 72758).addRange(72760, 72765).addRange(72850, 72871).addRange(72874, 72880).addRange(72882, 72883).addRange(72885, 72886).addRange(73009, 73014).addRange(73020, 73021).addRange(73023, 73029).addRange(73104, 73105).addRange(73459, 73460).addRange(78896, 78904).addRange(92912, 92916).addRange(92976, 92982).addRange(92992, 92995).addRange(94095, 94111).addRange(94176, 94177).addRange(94179, 94180).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(113821, 113822).addRange(113824, 113827).addRange(118528, 118573).addRange(118576, 118598).addRange(119143, 119145).addRange(119155, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922);
      set3.addRange(123184, 123197).addRange(123628, 123631).addRange(125136, 125142).addRange(125252, 125259).addRange(127995, 127999).addRange(917536, 917631).addRange(917760, 917999);
      Case_Ignorable.characters = set3;
      return Case_Ignorable;
    }
    var Cased = {};
    var hasRequiredCased;
    function requireCased() {
      if (hasRequiredCased)
        return Cased;
      hasRequiredCased = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 837, 895, 902, 908, 4295, 4301, 8025, 8027, 8029, 8126, 8305, 8319, 8450, 8455, 8469, 8484, 8486, 8488, 8505, 8526, 11559, 11565, 42963, 67456, 119970, 119995, 120134);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 442).addRange(444, 447).addRange(452, 659).addRange(661, 696).addRange(704, 705).addRange(736, 740).addRange(880, 883).addRange(886, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(4256, 4293).addRange(4304, 4346).addRange(4349, 4351).addRange(5024, 5109).addRange(5112, 5117).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7424, 7615).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8336, 8348).addRange(8458, 8467).addRange(8473, 8477).addRange(8490, 8493).addRange(8495, 8500).addRange(8508, 8511).addRange(8517, 8521);
      set3.addRange(8544, 8575).addRange(8579, 8580).addRange(9398, 9449).addRange(11264, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(42560, 42605).addRange(42624, 42653).addRange(42786, 42887).addRange(42891, 42894).addRange(42896, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42997, 42998).addRange(43e3, 43002).addRange(43824, 43866).addRange(43868, 43880).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65313, 65338).addRange(65345, 65370).addRange(66560, 66639).addRange(66736, 66771).addRange(66776, 66811).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67459, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(68736, 68786).addRange(68800, 68850).addRange(71840, 71903).addRange(93760, 93823).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084);
      set3.addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122633).addRange(122635, 122654).addRange(125184, 125251).addRange(127280, 127305).addRange(127312, 127337).addRange(127344, 127369);
      Cased.characters = set3;
      return Cased;
    }
    var Changes_When_Casefolded = {};
    var hasRequiredChanges_When_Casefolded;
    function requireChanges_When_Casefolded() {
      if (hasRequiredChanges_When_Casefolded)
        return Changes_When_Casefolded;
      hasRequiredChanges_When_Casefolded = 1;
      var set3 = regenerate$2.exports(181, 256, 258, 260, 262, 264, 266, 268, 270, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 306, 308, 310, 313, 315, 317, 319, 321, 323, 325, 327, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 379, 381, 383, 388, 418, 420, 425, 428, 437, 444, 461, 463, 465, 467, 469, 471, 473, 475, 478, 480, 482, 484, 486, 488, 490, 492, 494, 500, 506, 508, 510, 512, 514, 516, 518, 520, 522, 524, 526, 528, 530, 532, 534, 536, 538, 540, 542, 544, 546, 548, 550, 552, 554, 556, 558, 560, 562, 577, 584, 586, 588, 590, 837, 880, 882, 886, 895, 902, 908, 962, 984, 986, 988, 990, 992, 994, 996, 998, 1e3, 1002, 1004, 1006, 1015, 1120, 1122, 1124, 1126, 1128, 1130, 1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 1148, 1150, 1152, 1162, 1164, 1166, 1168, 1170, 1172, 1174, 1176, 1178, 1180, 1182, 1184, 1186, 1188, 1190, 1192, 1194, 1196, 1198, 1200, 1202, 1204, 1206, 1208, 1210, 1212, 1214, 1219, 1221, 1223, 1225, 1227, 1229, 1232, 1234, 1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1324, 1326, 1415, 4295, 4301, 7680, 7682, 7684, 7686, 7688, 7690, 7692, 7694, 7696, 7698, 7700, 7702, 7704, 7706, 7708, 7710, 7712, 7714, 7716, 7718, 7720, 7722, 7724, 7726, 7728, 7730, 7732, 7734, 7736, 7738, 7740, 7742, 7744, 7746, 7748, 7750, 7752, 7754, 7756, 7758, 7760, 7762, 7764, 7766, 7768, 7770, 7772, 7774, 7776, 7778, 7780, 7782, 7784, 7786, 7788, 7790, 7792, 7794, 7796, 7798, 7800, 7802, 7804, 7806, 7808, 7810, 7812, 7814, 7816, 7818, 7820, 7822, 7824, 7826, 7828, 7838, 7840, 7842, 7844, 7846, 7848, 7850, 7852, 7854, 7856, 7858, 7860, 7862, 7864, 7866, 7868, 7870, 7872, 7874, 7876, 7878, 7880, 7882, 7884, 7886, 7888, 7890, 7892, 7894, 7896, 7898, 7900, 7902, 7904, 7906, 7908, 7910, 7912, 7914, 7916, 7918, 7920, 7922, 7924, 7926, 7928, 7930, 7932, 7934, 8025, 8027, 8029, 8031, 8486, 8498, 8579, 11360, 11367, 11369, 11371, 11378, 11381, 11394, 11396, 11398, 11400, 11402, 11404, 11406, 11408, 11410, 11412, 11414, 11416, 11418, 11420, 11422, 11424, 11426, 11428, 11430, 11432, 11434, 11436, 11438, 11440, 11442, 11444, 11446, 11448, 11450, 11452, 11454, 11456, 11458, 11460, 11462, 11464, 11466, 11468, 11470, 11472, 11474, 11476, 11478, 11480, 11482, 11484, 11486, 11488, 11490, 11499, 11501, 11506, 42560, 42562, 42564, 42566, 42568, 42570, 42572, 42574, 42576, 42578, 42580, 42582, 42584, 42586, 42588, 42590, 42592, 42594, 42596, 42598, 42600, 42602, 42604, 42624, 42626, 42628, 42630, 42632, 42634, 42636, 42638, 42640, 42642, 42644, 42646, 42648, 42650, 42786, 42788, 42790, 42792, 42794, 42796, 42798, 42802, 42804, 42806, 42808, 42810, 42812, 42814, 42816, 42818, 42820, 42822, 42824, 42826, 42828, 42830, 42832, 42834, 42836, 42838, 42840, 42842, 42844, 42846, 42848, 42850, 42852, 42854, 42856, 42858, 42860, 42862, 42873, 42875, 42880, 42882, 42884, 42886, 42891, 42893, 42896, 42898, 42902, 42904, 42906, 42908, 42910, 42912, 42914, 42916, 42918, 42920, 42934, 42936, 42938, 42940, 42942, 42944, 42946, 42953, 42960, 42966, 42968, 42997);
      set3.addRange(65, 90).addRange(192, 214).addRange(216, 223).addRange(329, 330).addRange(376, 377).addRange(385, 386).addRange(390, 391).addRange(393, 395).addRange(398, 401).addRange(403, 404).addRange(406, 408).addRange(412, 413).addRange(415, 416).addRange(422, 423).addRange(430, 431).addRange(433, 435).addRange(439, 440).addRange(452, 453).addRange(455, 456).addRange(458, 459).addRange(497, 498).addRange(502, 504).addRange(570, 571).addRange(573, 574).addRange(579, 582).addRange(904, 906).addRange(910, 911).addRange(913, 929).addRange(931, 939).addRange(975, 977).addRange(981, 982).addRange(1008, 1009).addRange(1012, 1013).addRange(1017, 1018).addRange(1021, 1071).addRange(1216, 1217).addRange(1329, 1366).addRange(4256, 4293).addRange(5112, 5117).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7834, 7835).addRange(7944, 7951).addRange(7960, 7965).addRange(7976, 7983).addRange(7992, 7999).addRange(8008, 8013).addRange(8040, 8047).addRange(8064, 8111).addRange(8114, 8116);
      set3.addRange(8119, 8124).addRange(8130, 8132).addRange(8135, 8140).addRange(8152, 8155).addRange(8168, 8172).addRange(8178, 8180).addRange(8183, 8188).addRange(8490, 8491).addRange(8544, 8559).addRange(9398, 9423).addRange(11264, 11311).addRange(11362, 11364).addRange(11373, 11376).addRange(11390, 11392).addRange(42877, 42878).addRange(42922, 42926).addRange(42928, 42932).addRange(42948, 42951).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65313, 65338).addRange(66560, 66599).addRange(66736, 66771).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(68736, 68786).addRange(71840, 71871).addRange(93760, 93791).addRange(125184, 125217);
      Changes_When_Casefolded.characters = set3;
      return Changes_When_Casefolded;
    }
    var Changes_When_Casemapped = {};
    var hasRequiredChanges_When_Casemapped;
    function requireChanges_When_Casemapped() {
      if (hasRequiredChanges_When_Casemapped)
        return Changes_When_Casemapped;
      hasRequiredChanges_When_Casemapped = 1;
      var set3 = regenerate$2.exports(181, 447, 601, 611, 623, 629, 637, 640, 658, 837, 895, 902, 908, 4295, 4301, 7545, 7549, 7566, 7838, 8025, 8027, 8029, 8126, 8486, 8498, 8526, 11559, 11565, 43859);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 311).addRange(313, 396).addRange(398, 410).addRange(412, 425).addRange(428, 441).addRange(444, 445).addRange(452, 544).addRange(546, 563).addRange(570, 596).addRange(598, 599).addRange(603, 604).addRange(608, 609).addRange(613, 614).addRange(616, 620).addRange(625, 626).addRange(642, 643).addRange(647, 652).addRange(669, 670).addRange(880, 883).addRange(886, 887).addRange(891, 893).addRange(904, 906).addRange(910, 929).addRange(931, 977).addRange(981, 1013).addRange(1015, 1019).addRange(1021, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1377, 1415).addRange(4256, 4293).addRange(4304, 4346).addRange(4349, 4351).addRange(5024, 5109).addRange(5112, 5117).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7680, 7835).addRange(7840, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124);
      set3.addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8490, 8491).addRange(8544, 8575).addRange(8579, 8580).addRange(9398, 9449).addRange(11264, 11376).addRange(11378, 11379).addRange(11381, 11382).addRange(11390, 11491).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(42560, 42605).addRange(42624, 42651).addRange(42786, 42799).addRange(42802, 42863).addRange(42873, 42887).addRange(42891, 42893).addRange(42896, 42900).addRange(42902, 42926).addRange(42928, 42954).addRange(42960, 42961).addRange(42966, 42969).addRange(42997, 42998).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65313, 65338).addRange(65345, 65370).addRange(66560, 66639).addRange(66736, 66771).addRange(66776, 66811).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(68736, 68786).addRange(68800, 68850).addRange(71840, 71903).addRange(93760, 93823).addRange(125184, 125251);
      Changes_When_Casemapped.characters = set3;
      return Changes_When_Casemapped;
    }
    var Changes_When_Lowercased = {};
    var hasRequiredChanges_When_Lowercased;
    function requireChanges_When_Lowercased() {
      if (hasRequiredChanges_When_Lowercased)
        return Changes_When_Lowercased;
      hasRequiredChanges_When_Lowercased = 1;
      var set3 = regenerate$2.exports(256, 258, 260, 262, 264, 266, 268, 270, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 306, 308, 310, 313, 315, 317, 319, 321, 323, 325, 327, 330, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 379, 381, 388, 418, 420, 425, 428, 437, 444, 461, 463, 465, 467, 469, 471, 473, 475, 478, 480, 482, 484, 486, 488, 490, 492, 494, 500, 506, 508, 510, 512, 514, 516, 518, 520, 522, 524, 526, 528, 530, 532, 534, 536, 538, 540, 542, 544, 546, 548, 550, 552, 554, 556, 558, 560, 562, 577, 584, 586, 588, 590, 880, 882, 886, 895, 902, 908, 975, 984, 986, 988, 990, 992, 994, 996, 998, 1e3, 1002, 1004, 1006, 1012, 1015, 1120, 1122, 1124, 1126, 1128, 1130, 1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 1148, 1150, 1152, 1162, 1164, 1166, 1168, 1170, 1172, 1174, 1176, 1178, 1180, 1182, 1184, 1186, 1188, 1190, 1192, 1194, 1196, 1198, 1200, 1202, 1204, 1206, 1208, 1210, 1212, 1214, 1219, 1221, 1223, 1225, 1227, 1229, 1232, 1234, 1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1324, 1326, 4295, 4301, 7680, 7682, 7684, 7686, 7688, 7690, 7692, 7694, 7696, 7698, 7700, 7702, 7704, 7706, 7708, 7710, 7712, 7714, 7716, 7718, 7720, 7722, 7724, 7726, 7728, 7730, 7732, 7734, 7736, 7738, 7740, 7742, 7744, 7746, 7748, 7750, 7752, 7754, 7756, 7758, 7760, 7762, 7764, 7766, 7768, 7770, 7772, 7774, 7776, 7778, 7780, 7782, 7784, 7786, 7788, 7790, 7792, 7794, 7796, 7798, 7800, 7802, 7804, 7806, 7808, 7810, 7812, 7814, 7816, 7818, 7820, 7822, 7824, 7826, 7828, 7838, 7840, 7842, 7844, 7846, 7848, 7850, 7852, 7854, 7856, 7858, 7860, 7862, 7864, 7866, 7868, 7870, 7872, 7874, 7876, 7878, 7880, 7882, 7884, 7886, 7888, 7890, 7892, 7894, 7896, 7898, 7900, 7902, 7904, 7906, 7908, 7910, 7912, 7914, 7916, 7918, 7920, 7922, 7924, 7926, 7928, 7930, 7932, 7934, 8025, 8027, 8029, 8031, 8486, 8498, 8579, 11360, 11367, 11369, 11371, 11378, 11381, 11394, 11396, 11398, 11400, 11402, 11404, 11406, 11408, 11410, 11412, 11414, 11416, 11418, 11420, 11422, 11424, 11426, 11428, 11430, 11432, 11434, 11436, 11438, 11440, 11442, 11444, 11446, 11448, 11450, 11452, 11454, 11456, 11458, 11460, 11462, 11464, 11466, 11468, 11470, 11472, 11474, 11476, 11478, 11480, 11482, 11484, 11486, 11488, 11490, 11499, 11501, 11506, 42560, 42562, 42564, 42566, 42568, 42570, 42572, 42574, 42576, 42578, 42580, 42582, 42584, 42586, 42588, 42590, 42592, 42594, 42596, 42598, 42600, 42602, 42604, 42624, 42626, 42628, 42630, 42632, 42634, 42636, 42638, 42640, 42642, 42644, 42646, 42648, 42650, 42786, 42788, 42790, 42792, 42794, 42796, 42798, 42802, 42804, 42806, 42808, 42810, 42812, 42814, 42816, 42818, 42820, 42822, 42824, 42826, 42828, 42830, 42832, 42834, 42836, 42838, 42840, 42842, 42844, 42846, 42848, 42850, 42852, 42854, 42856, 42858, 42860, 42862, 42873, 42875, 42880, 42882, 42884, 42886, 42891, 42893, 42896, 42898, 42902, 42904, 42906, 42908, 42910, 42912, 42914, 42916, 42918, 42920, 42934, 42936, 42938, 42940, 42942, 42944, 42946, 42953, 42960, 42966, 42968, 42997);
      set3.addRange(65, 90).addRange(192, 214).addRange(216, 222).addRange(376, 377).addRange(385, 386).addRange(390, 391).addRange(393, 395).addRange(398, 401).addRange(403, 404).addRange(406, 408).addRange(412, 413).addRange(415, 416).addRange(422, 423).addRange(430, 431).addRange(433, 435).addRange(439, 440).addRange(452, 453).addRange(455, 456).addRange(458, 459).addRange(497, 498).addRange(502, 504).addRange(570, 571).addRange(573, 574).addRange(579, 582).addRange(904, 906).addRange(910, 911).addRange(913, 929).addRange(931, 939).addRange(1017, 1018).addRange(1021, 1071).addRange(1216, 1217).addRange(1329, 1366).addRange(4256, 4293).addRange(5024, 5109).addRange(7312, 7354).addRange(7357, 7359).addRange(7944, 7951).addRange(7960, 7965).addRange(7976, 7983).addRange(7992, 7999).addRange(8008, 8013).addRange(8040, 8047).addRange(8072, 8079).addRange(8088, 8095).addRange(8104, 8111).addRange(8120, 8124).addRange(8136, 8140).addRange(8152, 8155).addRange(8168, 8172).addRange(8184, 8188).addRange(8490, 8491);
      set3.addRange(8544, 8559).addRange(9398, 9423).addRange(11264, 11311).addRange(11362, 11364).addRange(11373, 11376).addRange(11390, 11392).addRange(42877, 42878).addRange(42922, 42926).addRange(42928, 42932).addRange(42948, 42951).addRange(65313, 65338).addRange(66560, 66599).addRange(66736, 66771).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(68736, 68786).addRange(71840, 71871).addRange(93760, 93791).addRange(125184, 125217);
      Changes_When_Lowercased.characters = set3;
      return Changes_When_Lowercased;
    }
    var Changes_When_NFKC_Casefolded = {};
    var hasRequiredChanges_When_NFKC_Casefolded;
    function requireChanges_When_NFKC_Casefolded() {
      if (hasRequiredChanges_When_NFKC_Casefolded)
        return Changes_When_NFKC_Casefolded;
      hasRequiredChanges_When_NFKC_Casefolded = 1;
      var set3 = regenerate$2.exports(160, 168, 170, 173, 175, 256, 258, 260, 262, 264, 266, 268, 270, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 310, 313, 315, 317, 323, 325, 327, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 379, 381, 383, 388, 418, 420, 425, 428, 437, 444, 463, 465, 467, 469, 471, 473, 475, 478, 480, 482, 484, 486, 488, 490, 492, 494, 506, 508, 510, 512, 514, 516, 518, 520, 522, 524, 526, 528, 530, 532, 534, 536, 538, 540, 542, 544, 546, 548, 550, 552, 554, 556, 558, 560, 562, 577, 584, 586, 588, 590, 847, 880, 882, 884, 886, 890, 908, 962, 984, 986, 988, 990, 992, 994, 996, 998, 1e3, 1002, 1004, 1006, 1015, 1120, 1122, 1124, 1126, 1128, 1130, 1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 1148, 1150, 1152, 1162, 1164, 1166, 1168, 1170, 1172, 1174, 1176, 1178, 1180, 1182, 1184, 1186, 1188, 1190, 1192, 1194, 1196, 1198, 1200, 1202, 1204, 1206, 1208, 1210, 1212, 1214, 1219, 1221, 1223, 1225, 1227, 1229, 1232, 1234, 1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1324, 1326, 1415, 1564, 2527, 2611, 2614, 2654, 3635, 3763, 3852, 3907, 3917, 3922, 3927, 3932, 3945, 3955, 3969, 3987, 3997, 4002, 4007, 4012, 4025, 4295, 4301, 4348, 7544, 7680, 7682, 7684, 7686, 7688, 7690, 7692, 7694, 7696, 7698, 7700, 7702, 7704, 7706, 7708, 7710, 7712, 7714, 7716, 7718, 7720, 7722, 7724, 7726, 7728, 7730, 7732, 7734, 7736, 7738, 7740, 7742, 7744, 7746, 7748, 7750, 7752, 7754, 7756, 7758, 7760, 7762, 7764, 7766, 7768, 7770, 7772, 7774, 7776, 7778, 7780, 7782, 7784, 7786, 7788, 7790, 7792, 7794, 7796, 7798, 7800, 7802, 7804, 7806, 7808, 7810, 7812, 7814, 7816, 7818, 7820, 7822, 7824, 7826, 7828, 7838, 7840, 7842, 7844, 7846, 7848, 7850, 7852, 7854, 7856, 7858, 7860, 7862, 7864, 7866, 7868, 7870, 7872, 7874, 7876, 7878, 7880, 7882, 7884, 7886, 7888, 7890, 7892, 7894, 7896, 7898, 7900, 7902, 7904, 7906, 7908, 7910, 7912, 7914, 7916, 7918, 7920, 7922, 7924, 7926, 7928, 7930, 7932, 7934, 8025, 8027, 8029, 8031, 8049, 8051, 8053, 8055, 8057, 8059, 8061, 8147, 8163, 8209, 8215, 8252, 8254, 8279, 8360, 8484, 8486, 8488, 8579, 8585, 10764, 10972, 11360, 11367, 11369, 11371, 11378, 11381, 11394, 11396, 11398, 11400, 11402, 11404, 11406, 11408, 11410, 11412, 11414, 11416, 11418, 11420, 11422, 11424, 11426, 11428, 11430, 11432, 11434, 11436, 11438, 11440, 11442, 11444, 11446, 11448, 11450, 11452, 11454, 11456, 11458, 11460, 11462, 11464, 11466, 11468, 11470, 11472, 11474, 11476, 11478, 11480, 11482, 11484, 11486, 11488, 11490, 11499, 11501, 11506, 11631, 11935, 12019, 12288, 12342, 12447, 12543, 42560, 42562, 42564, 42566, 42568, 42570, 42572, 42574, 42576, 42578, 42580, 42582, 42584, 42586, 42588, 42590, 42592, 42594, 42596, 42598, 42600, 42602, 42604, 42624, 42626, 42628, 42630, 42632, 42634, 42636, 42638, 42640, 42642, 42644, 42646, 42648, 42650, 42786, 42788, 42790, 42792, 42794, 42796, 42798, 42802, 42804, 42806, 42808, 42810, 42812, 42814, 42816, 42818, 42820, 42822, 42824, 42826, 42828, 42830, 42832, 42834, 42836, 42838, 42840, 42842, 42844, 42846, 42848, 42850, 42852, 42854, 42856, 42858, 42860, 42862, 42864, 42873, 42875, 42880, 42882, 42884, 42886, 42891, 42893, 42896, 42898, 42902, 42904, 42906, 42908, 42910, 42912, 42914, 42916, 42918, 42920, 42934, 42936, 42938, 42940, 42942, 42944, 42946, 42953, 42960, 42966, 42968, 43881, 64016, 64018, 64032, 64034, 64285, 64318, 65140, 65279, 119970, 119995, 120134, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590, 127376);
      set3.addRange(65, 90).addRange(178, 181).addRange(184, 186).addRange(188, 190).addRange(192, 214).addRange(216, 223).addRange(306, 308).addRange(319, 321).addRange(329, 330).addRange(376, 377).addRange(385, 386).addRange(390, 391).addRange(393, 395).addRange(398, 401).addRange(403, 404).addRange(406, 408).addRange(412, 413).addRange(415, 416).addRange(422, 423).addRange(430, 431).addRange(433, 435).addRange(439, 440).addRange(452, 461).addRange(497, 500).addRange(502, 504).addRange(570, 571).addRange(573, 574).addRange(579, 582).addRange(688, 696).addRange(728, 733).addRange(736, 740).addRange(832, 833).addRange(835, 837).addRange(894, 895).addRange(900, 906).addRange(910, 911).addRange(913, 929).addRange(931, 939).addRange(975, 982).addRange(1008, 1010).addRange(1012, 1013).addRange(1017, 1018).addRange(1021, 1071).addRange(1216, 1217).addRange(1329, 1366).addRange(1653, 1656).addRange(2392, 2399).addRange(2524, 2525).addRange(2649, 2651).addRange(2908, 2909).addRange(3804, 3805);
      set3.addRange(3957, 3961).addRange(4256, 4293).addRange(4447, 4448).addRange(5112, 5117).addRange(6068, 6069).addRange(6155, 6159).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7468, 7470).addRange(7472, 7482).addRange(7484, 7501).addRange(7503, 7530).addRange(7579, 7615).addRange(7834, 7835).addRange(7944, 7951).addRange(7960, 7965).addRange(7976, 7983).addRange(7992, 7999).addRange(8008, 8013).addRange(8040, 8047).addRange(8064, 8111).addRange(8114, 8116).addRange(8119, 8132).addRange(8135, 8143).addRange(8152, 8155).addRange(8157, 8159).addRange(8168, 8175).addRange(8178, 8180).addRange(8183, 8190).addRange(8192, 8207).addRange(8228, 8230).addRange(8234, 8239).addRange(8243, 8244).addRange(8246, 8247).addRange(8263, 8265).addRange(8287, 8305).addRange(8308, 8334).addRange(8336, 8348).addRange(8448, 8451).addRange(8453, 8455).addRange(8457, 8467).addRange(8469, 8470).addRange(8473, 8477).addRange(8480, 8482).addRange(8490, 8493).addRange(8495, 8505).addRange(8507, 8512).addRange(8517, 8521).addRange(8528, 8575).addRange(8748, 8749);
      set3.addRange(8751, 8752).addRange(9001, 9002).addRange(9312, 9450).addRange(10868, 10870).addRange(11264, 11311).addRange(11362, 11364).addRange(11373, 11376).addRange(11388, 11392).addRange(12032, 12245).addRange(12344, 12346).addRange(12443, 12444).addRange(12593, 12686).addRange(12690, 12703).addRange(12800, 12830).addRange(12832, 12871).addRange(12880, 12926).addRange(12928, 13311).addRange(42652, 42653).addRange(42877, 42878).addRange(42922, 42926).addRange(42928, 42932).addRange(42948, 42951).addRange(42994, 42997).addRange(43e3, 43001).addRange(43868, 43871).addRange(43888, 43967).addRange(63744, 64013).addRange(64021, 64030).addRange(64037, 64038).addRange(64042, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64287, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65020).addRange(65024, 65049).addRange(65072, 65092).addRange(65095, 65106).addRange(65108, 65126).addRange(65128, 65131).addRange(65136, 65138).addRange(65142, 65276).addRange(65281, 65470).addRange(65474, 65479);
      set3.addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65504, 65510).addRange(65512, 65518).addRange(65520, 65528).addRange(66560, 66599).addRange(66736, 66771).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(67457, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(68736, 68786).addRange(71840, 71871).addRange(93760, 93791).addRange(113824, 113827).addRange(119134, 119140).addRange(119155, 119162).addRange(119227, 119232).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 120831).addRange(125184, 125217).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578);
      set3.addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(127232, 127242).addRange(127248, 127278).addRange(127280, 127311).addRange(127338, 127340).addRange(127488, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(130032, 130041).addRange(194560, 195101).addRange(917504, 921599);
      Changes_When_NFKC_Casefolded.characters = set3;
      return Changes_When_NFKC_Casefolded;
    }
    var Changes_When_Titlecased = {};
    var hasRequiredChanges_When_Titlecased;
    function requireChanges_When_Titlecased() {
      if (hasRequiredChanges_When_Titlecased)
        return Changes_When_Titlecased;
      hasRequiredChanges_When_Titlecased = 1;
      var set3 = regenerate$2.exports(181, 257, 259, 261, 263, 265, 267, 269, 271, 273, 275, 277, 279, 281, 283, 285, 287, 289, 291, 293, 295, 297, 299, 301, 303, 305, 307, 309, 311, 314, 316, 318, 320, 322, 324, 326, 331, 333, 335, 337, 339, 341, 343, 345, 347, 349, 351, 353, 355, 357, 359, 361, 363, 365, 367, 369, 371, 373, 375, 378, 380, 387, 389, 392, 396, 402, 405, 414, 417, 419, 421, 424, 429, 432, 436, 438, 441, 445, 447, 452, 460, 462, 464, 466, 468, 470, 472, 474, 479, 481, 483, 485, 487, 489, 491, 493, 499, 501, 505, 507, 509, 511, 513, 515, 517, 519, 521, 523, 525, 527, 529, 531, 533, 535, 537, 539, 541, 543, 547, 549, 551, 553, 555, 557, 559, 561, 563, 572, 578, 583, 585, 587, 589, 601, 611, 623, 629, 637, 640, 658, 837, 881, 883, 887, 912, 985, 987, 989, 991, 993, 995, 997, 999, 1001, 1003, 1005, 1013, 1016, 1019, 1121, 1123, 1125, 1127, 1129, 1131, 1133, 1135, 1137, 1139, 1141, 1143, 1145, 1147, 1149, 1151, 1153, 1163, 1165, 1167, 1169, 1171, 1173, 1175, 1177, 1179, 1181, 1183, 1185, 1187, 1189, 1191, 1193, 1195, 1197, 1199, 1201, 1203, 1205, 1207, 1209, 1211, 1213, 1215, 1218, 1220, 1222, 1224, 1226, 1228, 1233, 1235, 1237, 1239, 1241, 1243, 1245, 1247, 1249, 1251, 1253, 1255, 1257, 1259, 1261, 1263, 1265, 1267, 1269, 1271, 1273, 1275, 1277, 1279, 1281, 1283, 1285, 1287, 1289, 1291, 1293, 1295, 1297, 1299, 1301, 1303, 1305, 1307, 1309, 1311, 1313, 1315, 1317, 1319, 1321, 1323, 1325, 1327, 7545, 7549, 7566, 7681, 7683, 7685, 7687, 7689, 7691, 7693, 7695, 7697, 7699, 7701, 7703, 7705, 7707, 7709, 7711, 7713, 7715, 7717, 7719, 7721, 7723, 7725, 7727, 7729, 7731, 7733, 7735, 7737, 7739, 7741, 7743, 7745, 7747, 7749, 7751, 7753, 7755, 7757, 7759, 7761, 7763, 7765, 7767, 7769, 7771, 7773, 7775, 7777, 7779, 7781, 7783, 7785, 7787, 7789, 7791, 7793, 7795, 7797, 7799, 7801, 7803, 7805, 7807, 7809, 7811, 7813, 7815, 7817, 7819, 7821, 7823, 7825, 7827, 7841, 7843, 7845, 7847, 7849, 7851, 7853, 7855, 7857, 7859, 7861, 7863, 7865, 7867, 7869, 7871, 7873, 7875, 7877, 7879, 7881, 7883, 7885, 7887, 7889, 7891, 7893, 7895, 7897, 7899, 7901, 7903, 7905, 7907, 7909, 7911, 7913, 7915, 7917, 7919, 7921, 7923, 7925, 7927, 7929, 7931, 7933, 8126, 8526, 8580, 11361, 11368, 11370, 11372, 11379, 11382, 11393, 11395, 11397, 11399, 11401, 11403, 11405, 11407, 11409, 11411, 11413, 11415, 11417, 11419, 11421, 11423, 11425, 11427, 11429, 11431, 11433, 11435, 11437, 11439, 11441, 11443, 11445, 11447, 11449, 11451, 11453, 11455, 11457, 11459, 11461, 11463, 11465, 11467, 11469, 11471, 11473, 11475, 11477, 11479, 11481, 11483, 11485, 11487, 11489, 11491, 11500, 11502, 11507, 11559, 11565, 42561, 42563, 42565, 42567, 42569, 42571, 42573, 42575, 42577, 42579, 42581, 42583, 42585, 42587, 42589, 42591, 42593, 42595, 42597, 42599, 42601, 42603, 42605, 42625, 42627, 42629, 42631, 42633, 42635, 42637, 42639, 42641, 42643, 42645, 42647, 42649, 42651, 42787, 42789, 42791, 42793, 42795, 42797, 42799, 42803, 42805, 42807, 42809, 42811, 42813, 42815, 42817, 42819, 42821, 42823, 42825, 42827, 42829, 42831, 42833, 42835, 42837, 42839, 42841, 42843, 42845, 42847, 42849, 42851, 42853, 42855, 42857, 42859, 42861, 42863, 42874, 42876, 42879, 42881, 42883, 42885, 42887, 42892, 42897, 42903, 42905, 42907, 42909, 42911, 42913, 42915, 42917, 42919, 42921, 42933, 42935, 42937, 42939, 42941, 42943, 42945, 42947, 42952, 42954, 42961, 42967, 42969, 42998, 43859);
      set3.addRange(97, 122).addRange(223, 246).addRange(248, 255).addRange(328, 329).addRange(382, 384).addRange(409, 410).addRange(454, 455).addRange(457, 458).addRange(476, 477).addRange(495, 497).addRange(575, 576).addRange(591, 596).addRange(598, 599).addRange(603, 604).addRange(608, 609).addRange(613, 614).addRange(616, 620).addRange(625, 626).addRange(642, 643).addRange(647, 652).addRange(669, 670).addRange(891, 893).addRange(940, 974).addRange(976, 977).addRange(981, 983).addRange(1007, 1011).addRange(1072, 1119).addRange(1230, 1231).addRange(1377, 1415).addRange(5112, 5117).addRange(7296, 7304).addRange(7829, 7835).addRange(7935, 7943).addRange(7952, 7957).addRange(7968, 7975).addRange(7984, 7991).addRange(8e3, 8005).addRange(8016, 8023).addRange(8032, 8039).addRange(8048, 8061).addRange(8064, 8071).addRange(8080, 8087).addRange(8096, 8103).addRange(8112, 8116).addRange(8118, 8119).addRange(8130, 8132).addRange(8134, 8135).addRange(8144, 8147).addRange(8150, 8151).addRange(8160, 8167).addRange(8178, 8180);
      set3.addRange(8182, 8183).addRange(8560, 8575).addRange(9424, 9449).addRange(11312, 11359).addRange(11365, 11366).addRange(11520, 11557).addRange(42899, 42900).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65345, 65370).addRange(66600, 66639).addRange(66776, 66811).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(68800, 68850).addRange(71872, 71903).addRange(93792, 93823).addRange(125218, 125251);
      Changes_When_Titlecased.characters = set3;
      return Changes_When_Titlecased;
    }
    var Changes_When_Uppercased = {};
    var hasRequiredChanges_When_Uppercased;
    function requireChanges_When_Uppercased() {
      if (hasRequiredChanges_When_Uppercased)
        return Changes_When_Uppercased;
      hasRequiredChanges_When_Uppercased = 1;
      var set3 = regenerate$2.exports(181, 257, 259, 261, 263, 265, 267, 269, 271, 273, 275, 277, 279, 281, 283, 285, 287, 289, 291, 293, 295, 297, 299, 301, 303, 305, 307, 309, 311, 314, 316, 318, 320, 322, 324, 326, 331, 333, 335, 337, 339, 341, 343, 345, 347, 349, 351, 353, 355, 357, 359, 361, 363, 365, 367, 369, 371, 373, 375, 378, 380, 387, 389, 392, 396, 402, 405, 414, 417, 419, 421, 424, 429, 432, 436, 438, 441, 445, 447, 462, 464, 466, 468, 470, 472, 474, 479, 481, 483, 485, 487, 489, 491, 493, 501, 505, 507, 509, 511, 513, 515, 517, 519, 521, 523, 525, 527, 529, 531, 533, 535, 537, 539, 541, 543, 547, 549, 551, 553, 555, 557, 559, 561, 563, 572, 578, 583, 585, 587, 589, 601, 611, 623, 629, 637, 640, 658, 837, 881, 883, 887, 912, 985, 987, 989, 991, 993, 995, 997, 999, 1001, 1003, 1005, 1013, 1016, 1019, 1121, 1123, 1125, 1127, 1129, 1131, 1133, 1135, 1137, 1139, 1141, 1143, 1145, 1147, 1149, 1151, 1153, 1163, 1165, 1167, 1169, 1171, 1173, 1175, 1177, 1179, 1181, 1183, 1185, 1187, 1189, 1191, 1193, 1195, 1197, 1199, 1201, 1203, 1205, 1207, 1209, 1211, 1213, 1215, 1218, 1220, 1222, 1224, 1226, 1228, 1233, 1235, 1237, 1239, 1241, 1243, 1245, 1247, 1249, 1251, 1253, 1255, 1257, 1259, 1261, 1263, 1265, 1267, 1269, 1271, 1273, 1275, 1277, 1279, 1281, 1283, 1285, 1287, 1289, 1291, 1293, 1295, 1297, 1299, 1301, 1303, 1305, 1307, 1309, 1311, 1313, 1315, 1317, 1319, 1321, 1323, 1325, 1327, 7545, 7549, 7566, 7681, 7683, 7685, 7687, 7689, 7691, 7693, 7695, 7697, 7699, 7701, 7703, 7705, 7707, 7709, 7711, 7713, 7715, 7717, 7719, 7721, 7723, 7725, 7727, 7729, 7731, 7733, 7735, 7737, 7739, 7741, 7743, 7745, 7747, 7749, 7751, 7753, 7755, 7757, 7759, 7761, 7763, 7765, 7767, 7769, 7771, 7773, 7775, 7777, 7779, 7781, 7783, 7785, 7787, 7789, 7791, 7793, 7795, 7797, 7799, 7801, 7803, 7805, 7807, 7809, 7811, 7813, 7815, 7817, 7819, 7821, 7823, 7825, 7827, 7841, 7843, 7845, 7847, 7849, 7851, 7853, 7855, 7857, 7859, 7861, 7863, 7865, 7867, 7869, 7871, 7873, 7875, 7877, 7879, 7881, 7883, 7885, 7887, 7889, 7891, 7893, 7895, 7897, 7899, 7901, 7903, 7905, 7907, 7909, 7911, 7913, 7915, 7917, 7919, 7921, 7923, 7925, 7927, 7929, 7931, 7933, 8124, 8126, 8140, 8188, 8526, 8580, 11361, 11368, 11370, 11372, 11379, 11382, 11393, 11395, 11397, 11399, 11401, 11403, 11405, 11407, 11409, 11411, 11413, 11415, 11417, 11419, 11421, 11423, 11425, 11427, 11429, 11431, 11433, 11435, 11437, 11439, 11441, 11443, 11445, 11447, 11449, 11451, 11453, 11455, 11457, 11459, 11461, 11463, 11465, 11467, 11469, 11471, 11473, 11475, 11477, 11479, 11481, 11483, 11485, 11487, 11489, 11491, 11500, 11502, 11507, 11559, 11565, 42561, 42563, 42565, 42567, 42569, 42571, 42573, 42575, 42577, 42579, 42581, 42583, 42585, 42587, 42589, 42591, 42593, 42595, 42597, 42599, 42601, 42603, 42605, 42625, 42627, 42629, 42631, 42633, 42635, 42637, 42639, 42641, 42643, 42645, 42647, 42649, 42651, 42787, 42789, 42791, 42793, 42795, 42797, 42799, 42803, 42805, 42807, 42809, 42811, 42813, 42815, 42817, 42819, 42821, 42823, 42825, 42827, 42829, 42831, 42833, 42835, 42837, 42839, 42841, 42843, 42845, 42847, 42849, 42851, 42853, 42855, 42857, 42859, 42861, 42863, 42874, 42876, 42879, 42881, 42883, 42885, 42887, 42892, 42897, 42903, 42905, 42907, 42909, 42911, 42913, 42915, 42917, 42919, 42921, 42933, 42935, 42937, 42939, 42941, 42943, 42945, 42947, 42952, 42954, 42961, 42967, 42969, 42998, 43859);
      set3.addRange(97, 122).addRange(223, 246).addRange(248, 255).addRange(328, 329).addRange(382, 384).addRange(409, 410).addRange(453, 454).addRange(456, 457).addRange(459, 460).addRange(476, 477).addRange(495, 496).addRange(498, 499).addRange(575, 576).addRange(591, 596).addRange(598, 599).addRange(603, 604).addRange(608, 609).addRange(613, 614).addRange(616, 620).addRange(625, 626).addRange(642, 643).addRange(647, 652).addRange(669, 670).addRange(891, 893).addRange(940, 974).addRange(976, 977).addRange(981, 983).addRange(1007, 1011).addRange(1072, 1119).addRange(1230, 1231).addRange(1377, 1415).addRange(4304, 4346).addRange(4349, 4351).addRange(5112, 5117).addRange(7296, 7304).addRange(7829, 7835).addRange(7935, 7943).addRange(7952, 7957).addRange(7968, 7975).addRange(7984, 7991).addRange(8e3, 8005).addRange(8016, 8023).addRange(8032, 8039).addRange(8048, 8061).addRange(8064, 8116).addRange(8118, 8119).addRange(8130, 8132).addRange(8134, 8135).addRange(8144, 8147).addRange(8150, 8151).addRange(8160, 8167);
      set3.addRange(8178, 8180).addRange(8182, 8183).addRange(8560, 8575).addRange(9424, 9449).addRange(11312, 11359).addRange(11365, 11366).addRange(11520, 11557).addRange(42899, 42900).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65345, 65370).addRange(66600, 66639).addRange(66776, 66811).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(68800, 68850).addRange(71872, 71903).addRange(93792, 93823).addRange(125218, 125251);
      Changes_When_Uppercased.characters = set3;
      return Changes_When_Uppercased;
    }
    var Dash = {};
    var hasRequiredDash;
    function requireDash() {
      if (hasRequiredDash)
        return Dash;
      hasRequiredDash = 1;
      var set3 = regenerate$2.exports(45, 1418, 1470, 5120, 6150, 8275, 8315, 8331, 8722, 11799, 11802, 11840, 11869, 12316, 12336, 12448, 65112, 65123, 65293, 69293);
      set3.addRange(8208, 8213).addRange(11834, 11835).addRange(65073, 65074);
      Dash.characters = set3;
      return Dash;
    }
    var Default_Ignorable_Code_Point = {};
    var hasRequiredDefault_Ignorable_Code_Point;
    function requireDefault_Ignorable_Code_Point() {
      if (hasRequiredDefault_Ignorable_Code_Point)
        return Default_Ignorable_Code_Point;
      hasRequiredDefault_Ignorable_Code_Point = 1;
      var set3 = regenerate$2.exports(173, 847, 1564, 12644, 65279, 65440);
      set3.addRange(4447, 4448).addRange(6068, 6069).addRange(6155, 6159).addRange(8203, 8207).addRange(8234, 8238).addRange(8288, 8303).addRange(65024, 65039).addRange(65520, 65528).addRange(113824, 113827).addRange(119155, 119162).addRange(917504, 921599);
      Default_Ignorable_Code_Point.characters = set3;
      return Default_Ignorable_Code_Point;
    }
    var Deprecated = {};
    var hasRequiredDeprecated;
    function requireDeprecated() {
      if (hasRequiredDeprecated)
        return Deprecated;
      hasRequiredDeprecated = 1;
      var set3 = regenerate$2.exports(329, 1651, 3959, 3961, 917505);
      set3.addRange(6051, 6052).addRange(8298, 8303).addRange(9001, 9002);
      Deprecated.characters = set3;
      return Deprecated;
    }
    var Diacritic = {};
    var hasRequiredDiacritic;
    function requireDiacritic() {
      if (hasRequiredDiacritic)
        return Diacritic;
      hasRequiredDiacritic = 1;
      var set3 = regenerate$2.exports(94, 96, 168, 175, 180, 890, 1369, 1471, 1476, 2364, 2381, 2417, 2492, 2509, 2620, 2637, 2748, 2765, 2876, 2893, 2901, 3021, 3132, 3149, 3260, 3277, 3405, 3530, 3662, 3770, 3893, 3895, 3897, 4038, 4151, 4239, 6109, 6783, 6964, 6980, 7405, 7412, 8125, 11823, 12540, 42607, 42623, 43204, 43347, 43443, 43456, 43493, 43766, 64286, 65342, 65344, 65392, 65507, 66272, 69702, 69744, 70003, 70080, 70460, 70477, 70722, 70726, 71231, 71467, 72003, 72160, 72244, 72263, 72345, 72767, 73026, 73111, 123566);
      set3.addRange(183, 184).addRange(688, 846).addRange(848, 855).addRange(861, 866).addRange(884, 885).addRange(900, 901).addRange(1155, 1159).addRange(1425, 1441).addRange(1443, 1469).addRange(1473, 1474).addRange(1611, 1618).addRange(1623, 1624).addRange(1759, 1760).addRange(1765, 1766).addRange(1770, 1772).addRange(1840, 1866).addRange(1958, 1968).addRange(2027, 2037).addRange(2072, 2073).addRange(2200, 2207).addRange(2249, 2258).addRange(2275, 2302).addRange(2385, 2388).addRange(2813, 2815).addRange(3387, 3388).addRange(3655, 3660).addRange(3784, 3788).addRange(3864, 3865).addRange(3902, 3903).addRange(3970, 3972).addRange(3974, 3975).addRange(4153, 4154).addRange(4195, 4196).addRange(4201, 4205).addRange(4231, 4237).addRange(4250, 4251).addRange(4957, 4959).addRange(5908, 5909).addRange(6089, 6099).addRange(6457, 6459).addRange(6773, 6780).addRange(6832, 6846).addRange(6849, 6859).addRange(7019, 7027).addRange(7082, 7083).addRange(7222, 7223).addRange(7288, 7293).addRange(7376, 7400).addRange(7415, 7417).addRange(7468, 7530).addRange(7620, 7631);
      set3.addRange(7669, 7679).addRange(8127, 8129).addRange(8141, 8143).addRange(8157, 8159).addRange(8173, 8175).addRange(8189, 8190).addRange(11503, 11505).addRange(12330, 12335).addRange(12441, 12444).addRange(42620, 42621).addRange(42652, 42653).addRange(42736, 42737).addRange(42752, 42785).addRange(42888, 42890).addRange(43e3, 43001).addRange(43232, 43249).addRange(43307, 43310).addRange(43643, 43645).addRange(43711, 43714).addRange(43867, 43871).addRange(43881, 43883).addRange(44012, 44013).addRange(65056, 65071).addRange(65438, 65439).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(68325, 68326).addRange(68898, 68903).addRange(69446, 69456).addRange(69506, 69509).addRange(69817, 69818).addRange(69939, 69940).addRange(70090, 70092).addRange(70197, 70198).addRange(70377, 70378).addRange(70502, 70508).addRange(70512, 70516).addRange(70850, 70851).addRange(71103, 71104).addRange(71350, 71351).addRange(71737, 71738).addRange(71997, 71998).addRange(73028, 73029).addRange(92912, 92916).addRange(92976, 92982).addRange(94095, 94111).addRange(94192, 94193).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590);
      set3.addRange(118528, 118573).addRange(118576, 118598).addRange(119143, 119145).addRange(119149, 119154).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(123184, 123190).addRange(123628, 123631).addRange(125136, 125142).addRange(125252, 125254).addRange(125256, 125258);
      Diacritic.characters = set3;
      return Diacritic;
    }
    var Emoji_Component = {};
    var hasRequiredEmoji_Component;
    function requireEmoji_Component() {
      if (hasRequiredEmoji_Component)
        return Emoji_Component;
      hasRequiredEmoji_Component = 1;
      var set3 = regenerate$2.exports(35, 42, 8205, 8419, 65039);
      set3.addRange(48, 57).addRange(127462, 127487).addRange(127995, 127999).addRange(129456, 129459).addRange(917536, 917631);
      Emoji_Component.characters = set3;
      return Emoji_Component;
    }
    var Emoji_Modifier_Base = {};
    var hasRequiredEmoji_Modifier_Base;
    function requireEmoji_Modifier_Base() {
      if (hasRequiredEmoji_Modifier_Base)
        return Emoji_Modifier_Base;
      hasRequiredEmoji_Modifier_Base = 1;
      var set3 = regenerate$2.exports(9757, 9977, 127877, 127943, 128124, 128143, 128145, 128170, 128378, 128400, 128675, 128704, 128716, 129292, 129295, 129318, 129399, 129467);
      set3.addRange(9994, 9997).addRange(127938, 127940).addRange(127946, 127948).addRange(128066, 128067).addRange(128070, 128080).addRange(128102, 128120).addRange(128129, 128131).addRange(128133, 128135).addRange(128372, 128373).addRange(128405, 128406).addRange(128581, 128583).addRange(128587, 128591).addRange(128692, 128694).addRange(129304, 129311).addRange(129328, 129337).addRange(129340, 129342).addRange(129461, 129462).addRange(129464, 129465).addRange(129485, 129487).addRange(129489, 129501).addRange(129731, 129733).addRange(129776, 129782);
      Emoji_Modifier_Base.characters = set3;
      return Emoji_Modifier_Base;
    }
    var Emoji_Modifier = {};
    var hasRequiredEmoji_Modifier;
    function requireEmoji_Modifier() {
      if (hasRequiredEmoji_Modifier)
        return Emoji_Modifier;
      hasRequiredEmoji_Modifier = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(127995, 127999);
      Emoji_Modifier.characters = set3;
      return Emoji_Modifier;
    }
    var Emoji_Presentation = {};
    var hasRequiredEmoji_Presentation;
    function requireEmoji_Presentation() {
      if (hasRequiredEmoji_Presentation)
        return Emoji_Presentation;
      hasRequiredEmoji_Presentation = 1;
      var set3 = regenerate$2.exports(9200, 9203, 9855, 9875, 9889, 9934, 9940, 9962, 9973, 9978, 9981, 9989, 10024, 10060, 10062, 10071, 10160, 10175, 11088, 11093, 126980, 127183, 127374, 127489, 127514, 127535, 127988, 128064, 128378, 128420, 128716, 129008);
      set3.addRange(8986, 8987).addRange(9193, 9196).addRange(9725, 9726).addRange(9748, 9749).addRange(9800, 9811).addRange(9898, 9899).addRange(9917, 9918).addRange(9924, 9925).addRange(9970, 9971).addRange(9994, 9995).addRange(10067, 10069).addRange(10133, 10135).addRange(11035, 11036).addRange(127377, 127386).addRange(127462, 127487).addRange(127538, 127542).addRange(127544, 127546).addRange(127568, 127569).addRange(127744, 127776).addRange(127789, 127797).addRange(127799, 127868).addRange(127870, 127891).addRange(127904, 127946).addRange(127951, 127955).addRange(127968, 127984).addRange(127992, 128062).addRange(128066, 128252).addRange(128255, 128317).addRange(128331, 128334).addRange(128336, 128359).addRange(128405, 128406).addRange(128507, 128591).addRange(128640, 128709).addRange(128720, 128722).addRange(128725, 128727).addRange(128733, 128735).addRange(128747, 128748).addRange(128756, 128764).addRange(128992, 129003).addRange(129292, 129338).addRange(129340, 129349).addRange(129351, 129535).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782);
      Emoji_Presentation.characters = set3;
      return Emoji_Presentation;
    }
    var Emoji = {};
    var hasRequiredEmoji;
    function requireEmoji() {
      if (hasRequiredEmoji)
        return Emoji;
      hasRequiredEmoji = 1;
      var set3 = regenerate$2.exports(35, 42, 169, 174, 8252, 8265, 8482, 8505, 9e3, 9167, 9410, 9654, 9664, 9742, 9745, 9752, 9757, 9760, 9766, 9770, 9792, 9794, 9827, 9832, 9851, 9881, 9895, 9928, 9937, 9981, 9986, 9989, 9999, 10002, 10004, 10006, 10013, 10017, 10024, 10052, 10055, 10060, 10062, 10071, 10145, 10160, 10175, 11088, 11093, 12336, 12349, 12951, 12953, 126980, 127183, 127374, 127514, 127535, 128391, 128400, 128424, 128444, 128481, 128483, 128488, 128495, 128499, 128745, 128752, 129008);
      set3.addRange(48, 57).addRange(8596, 8601).addRange(8617, 8618).addRange(8986, 8987).addRange(9193, 9203).addRange(9208, 9210).addRange(9642, 9643).addRange(9723, 9726).addRange(9728, 9732).addRange(9748, 9749).addRange(9762, 9763).addRange(9774, 9775).addRange(9784, 9786).addRange(9800, 9811).addRange(9823, 9824).addRange(9829, 9830).addRange(9854, 9855).addRange(9874, 9879).addRange(9883, 9884).addRange(9888, 9889).addRange(9898, 9899).addRange(9904, 9905).addRange(9917, 9918).addRange(9924, 9925).addRange(9934, 9935).addRange(9939, 9940).addRange(9961, 9962).addRange(9968, 9973).addRange(9975, 9978).addRange(9992, 9997).addRange(10035, 10036).addRange(10067, 10069).addRange(10083, 10084).addRange(10133, 10135).addRange(10548, 10549).addRange(11013, 11015).addRange(11035, 11036).addRange(127344, 127345).addRange(127358, 127359).addRange(127377, 127386).addRange(127462, 127487).addRange(127489, 127490).addRange(127538, 127546).addRange(127568, 127569).addRange(127744, 127777).addRange(127780, 127891).addRange(127894, 127895).addRange(127897, 127899).addRange(127902, 127984).addRange(127987, 127989).addRange(127991, 128253);
      set3.addRange(128255, 128317).addRange(128329, 128334).addRange(128336, 128359).addRange(128367, 128368).addRange(128371, 128378).addRange(128394, 128397).addRange(128405, 128406).addRange(128420, 128421).addRange(128433, 128434).addRange(128450, 128452).addRange(128465, 128467).addRange(128476, 128478).addRange(128506, 128591).addRange(128640, 128709).addRange(128715, 128722).addRange(128725, 128727).addRange(128733, 128741).addRange(128747, 128748).addRange(128755, 128764).addRange(128992, 129003).addRange(129292, 129338).addRange(129340, 129349).addRange(129351, 129535).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782);
      Emoji.characters = set3;
      return Emoji;
    }
    var Extended_Pictographic = {};
    var hasRequiredExtended_Pictographic;
    function requireExtended_Pictographic() {
      if (hasRequiredExtended_Pictographic)
        return Extended_Pictographic;
      hasRequiredExtended_Pictographic = 1;
      var set3 = regenerate$2.exports(169, 174, 8252, 8265, 8482, 8505, 9e3, 9096, 9167, 9410, 9654, 9664, 10004, 10006, 10013, 10017, 10024, 10052, 10055, 10060, 10062, 10071, 10145, 10160, 10175, 11088, 11093, 12336, 12349, 12951, 12953, 127279, 127374, 127514, 127535);
      set3.addRange(8596, 8601).addRange(8617, 8618).addRange(8986, 8987).addRange(9193, 9203).addRange(9208, 9210).addRange(9642, 9643).addRange(9723, 9726).addRange(9728, 9733).addRange(9735, 9746).addRange(9748, 9861).addRange(9872, 9989).addRange(9992, 10002).addRange(10035, 10036).addRange(10067, 10069).addRange(10083, 10087).addRange(10133, 10135).addRange(10548, 10549).addRange(11013, 11015).addRange(11035, 11036).addRange(126976, 127231).addRange(127245, 127247).addRange(127340, 127345).addRange(127358, 127359).addRange(127377, 127386).addRange(127405, 127461).addRange(127489, 127503).addRange(127538, 127546).addRange(127548, 127551).addRange(127561, 127994).addRange(128e3, 128317).addRange(128326, 128591).addRange(128640, 128767).addRange(128884, 128895).addRange(128981, 129023).addRange(129036, 129039).addRange(129096, 129103).addRange(129114, 129119).addRange(129160, 129167).addRange(129198, 129279).addRange(129292, 129338).addRange(129340, 129349).addRange(129351, 129791).addRange(130048, 131069);
      Extended_Pictographic.characters = set3;
      return Extended_Pictographic;
    }
    var Extender = {};
    var hasRequiredExtender;
    function requireExtender() {
      if (hasRequiredExtender)
        return Extender;
      hasRequiredExtender = 1;
      var set3 = regenerate$2.exports(183, 1600, 2042, 2901, 3654, 3782, 6154, 6211, 6823, 7222, 7291, 12293, 40981, 42508, 43471, 43494, 43632, 43741, 65392, 70493, 72344, 94179);
      set3.addRange(720, 721).addRange(12337, 12341).addRange(12445, 12446).addRange(12540, 12542).addRange(43763, 43764).addRange(67457, 67458).addRange(71110, 71112).addRange(92994, 92995).addRange(94176, 94177).addRange(123196, 123197).addRange(125252, 125254);
      Extender.characters = set3;
      return Extender;
    }
    var Grapheme_Base = {};
    var hasRequiredGrapheme_Base;
    function requireGrapheme_Base() {
      if (hasRequiredGrapheme_Base)
        return Grapheme_Base;
      hasRequiredGrapheme_Base = 1;
      var set3 = regenerate$2.exports(908, 1470, 1472, 1475, 1478, 1563, 1758, 1769, 1808, 1969, 2074, 2084, 2088, 2142, 2363, 2482, 2493, 2510, 2563, 2654, 2678, 2691, 2761, 2768, 2809, 2877, 2880, 2947, 2972, 3007, 3024, 3133, 3165, 3389, 3517, 3716, 3749, 3773, 3782, 3894, 3896, 3967, 3973, 4145, 4152, 4295, 4301, 4696, 4800, 5909, 6070, 6314, 6464, 6743, 6753, 6971, 7082, 7143, 7150, 7379, 7393, 7418, 8025, 8027, 8029, 11559, 11565, 42611, 42963, 43597, 43697, 43712, 43714, 64285, 64318, 64975, 65952, 67592, 67644, 67903, 69293, 69632, 69749, 69932, 70197, 70280, 70461, 70463, 70480, 70725, 70749, 70841, 70846, 70849, 71102, 71230, 71340, 71350, 71462, 71736, 71739, 71945, 71997, 72192, 72272, 72343, 72766, 72873, 72881, 72884, 73030, 73110, 73112, 73648, 92917, 113820, 113823, 119142, 119365, 119970, 119995, 120134, 123647, 125259, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590, 129008);
      set3.addRange(32, 126).addRange(160, 172).addRange(174, 767).addRange(880, 887).addRange(890, 895).addRange(900, 906).addRange(910, 929).addRange(931, 1154).addRange(1162, 1327).addRange(1329, 1366).addRange(1369, 1418).addRange(1421, 1423).addRange(1488, 1514).addRange(1519, 1524).addRange(1542, 1551).addRange(1565, 1610).addRange(1632, 1647).addRange(1649, 1749).addRange(1765, 1766).addRange(1774, 1805).addRange(1810, 1839).addRange(1869, 1957).addRange(1984, 2026).addRange(2036, 2042).addRange(2046, 2069).addRange(2096, 2110).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2190).addRange(2208, 2249).addRange(2307, 2361).addRange(2365, 2368).addRange(2377, 2380).addRange(2382, 2384).addRange(2392, 2401).addRange(2404, 2432).addRange(2434, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2495, 2496).addRange(2503, 2504).addRange(2507, 2508).addRange(2524, 2525).addRange(2527, 2529).addRange(2534, 2557).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600);
      set3.addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2624).addRange(2649, 2652).addRange(2662, 2671).addRange(2674, 2676).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2749, 2752).addRange(2763, 2764).addRange(2784, 2785).addRange(2790, 2801).addRange(2818, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2887, 2888).addRange(2891, 2892).addRange(2908, 2909).addRange(2911, 2913).addRange(2918, 2935).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3009, 3010).addRange(3014, 3016).addRange(3018, 3020).addRange(3046, 3066).addRange(3073, 3075).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3137, 3140).addRange(3160, 3162).addRange(3168, 3169).addRange(3174, 3183);
      set3.addRange(3191, 3200).addRange(3202, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3261, 3262).addRange(3264, 3265).addRange(3267, 3268).addRange(3271, 3272).addRange(3274, 3275).addRange(3293, 3294).addRange(3296, 3297).addRange(3302, 3311).addRange(3313, 3314).addRange(3330, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3391, 3392).addRange(3398, 3400).addRange(3402, 3404).addRange(3406, 3407).addRange(3412, 3414).addRange(3416, 3425).addRange(3430, 3455).addRange(3458, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3536, 3537).addRange(3544, 3550).addRange(3558, 3567).addRange(3570, 3572).addRange(3585, 3632).addRange(3634, 3635).addRange(3647, 3654).addRange(3663, 3675).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3760).addRange(3762, 3763).addRange(3776, 3780).addRange(3792, 3801).addRange(3804, 3807).addRange(3840, 3863).addRange(3866, 3892).addRange(3898, 3911).addRange(3913, 3948).addRange(3976, 3980);
      set3.addRange(4030, 4037).addRange(4039, 4044).addRange(4046, 4058).addRange(4096, 4140).addRange(4155, 4156).addRange(4159, 4183).addRange(4186, 4189).addRange(4193, 4208).addRange(4213, 4225).addRange(4227, 4228).addRange(4231, 4236).addRange(4238, 4252).addRange(4254, 4293).addRange(4304, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4960, 4988).addRange(4992, 5017).addRange(5024, 5109).addRange(5112, 5117).addRange(5120, 5788).addRange(5792, 5880).addRange(5888, 5905).addRange(5919, 5937).addRange(5940, 5942).addRange(5952, 5969).addRange(5984, 5996).addRange(5998, 6e3).addRange(6016, 6067).addRange(6078, 6085).addRange(6087, 6088).addRange(6100, 6108).addRange(6112, 6121).addRange(6128, 6137).addRange(6144, 6154).addRange(6160, 6169).addRange(6176, 6264).addRange(6272, 6276).addRange(6279, 6312).addRange(6320, 6389);
      set3.addRange(6400, 6430).addRange(6435, 6438).addRange(6441, 6443).addRange(6448, 6449).addRange(6451, 6456).addRange(6468, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6622, 6678).addRange(6681, 6682).addRange(6686, 6741).addRange(6755, 6756).addRange(6765, 6770).addRange(6784, 6793).addRange(6800, 6809).addRange(6816, 6829).addRange(6916, 6963).addRange(6973, 6977).addRange(6979, 6988).addRange(6992, 7018).addRange(7028, 7038).addRange(7042, 7073).addRange(7078, 7079).addRange(7086, 7141).addRange(7146, 7148).addRange(7154, 7155).addRange(7164, 7211).addRange(7220, 7221).addRange(7227, 7241).addRange(7245, 7304).addRange(7312, 7354).addRange(7357, 7367).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7415).addRange(7424, 7615).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8132).addRange(8134, 8147).addRange(8150, 8155).addRange(8157, 8175).addRange(8178, 8180).addRange(8182, 8190);
      set3.addRange(8192, 8202).addRange(8208, 8231).addRange(8239, 8287).addRange(8304, 8305).addRange(8308, 8334).addRange(8336, 8348).addRange(8352, 8384).addRange(8448, 8587).addRange(8592, 9254).addRange(9280, 9290).addRange(9312, 11123).addRange(11126, 11157).addRange(11159, 11502).addRange(11506, 11507).addRange(11513, 11557).addRange(11568, 11623).addRange(11631, 11632).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(11776, 11869).addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12272, 12283).addRange(12288, 12329).addRange(12336, 12351).addRange(12353, 12438).addRange(12443, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12688, 12771).addRange(12784, 12830).addRange(12832, 42124).addRange(42128, 42182).addRange(42192, 42539).addRange(42560, 42606).addRange(42622, 42653).addRange(42656, 42735).addRange(42738, 42743).addRange(42752, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43009).addRange(43011, 43013);
      set3.addRange(43015, 43018).addRange(43020, 43044).addRange(43047, 43051).addRange(43056, 43065).addRange(43072, 43127).addRange(43136, 43203).addRange(43214, 43225).addRange(43250, 43262).addRange(43264, 43301).addRange(43310, 43334).addRange(43346, 43347).addRange(43359, 43388).addRange(43395, 43442).addRange(43444, 43445).addRange(43450, 43451).addRange(43454, 43469).addRange(43471, 43481).addRange(43486, 43492).addRange(43494, 43518).addRange(43520, 43560).addRange(43567, 43568).addRange(43571, 43572).addRange(43584, 43586).addRange(43588, 43595).addRange(43600, 43609).addRange(43612, 43643).addRange(43645, 43695).addRange(43701, 43702).addRange(43705, 43709).addRange(43739, 43755).addRange(43758, 43765).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43883).addRange(43888, 44004).addRange(44006, 44007).addRange(44009, 44012).addRange(44016, 44025).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64287, 64310).addRange(64312, 64316).addRange(64320, 64321);
      set3.addRange(64323, 64324).addRange(64326, 64450).addRange(64467, 64911).addRange(64914, 64967).addRange(65008, 65023).addRange(65040, 65049).addRange(65072, 65106).addRange(65108, 65126).addRange(65128, 65131).addRange(65136, 65140).addRange(65142, 65276).addRange(65281, 65437).addRange(65440, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65504, 65510).addRange(65512, 65518).addRange(65532, 65533).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65792, 65794).addRange(65799, 65843).addRange(65847, 65934).addRange(65936, 65948).addRange(66e3, 66044).addRange(66176, 66204).addRange(66208, 66256).addRange(66273, 66299).addRange(66304, 66339).addRange(66349, 66378).addRange(66384, 66421).addRange(66432, 66461).addRange(66463, 66499).addRange(66504, 66517).addRange(66560, 66717).addRange(66720, 66729).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66927, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965);
      set3.addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67671, 67742).addRange(67751, 67759).addRange(67808, 67826).addRange(67828, 67829).addRange(67835, 67867).addRange(67871, 67897).addRange(67968, 68023).addRange(68028, 68047).addRange(68050, 68096).addRange(68112, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68160, 68168).addRange(68176, 68184).addRange(68192, 68255).addRange(68288, 68324).addRange(68331, 68342).addRange(68352, 68405).addRange(68409, 68437).addRange(68440, 68466).addRange(68472, 68497).addRange(68505, 68508).addRange(68521, 68527).addRange(68608, 68680).addRange(68736, 68786).addRange(68800, 68850).addRange(68858, 68899).addRange(68912, 68921).addRange(69216, 69246).addRange(69248, 69289).addRange(69296, 69297).addRange(69376, 69415).addRange(69424, 69445).addRange(69457, 69465).addRange(69488, 69505).addRange(69510, 69513).addRange(69552, 69579);
      set3.addRange(69600, 69622).addRange(69634, 69687).addRange(69703, 69709).addRange(69714, 69743).addRange(69745, 69746).addRange(69762, 69810).addRange(69815, 69816).addRange(69819, 69820).addRange(69822, 69825).addRange(69840, 69864).addRange(69872, 69881).addRange(69891, 69926).addRange(69942, 69959).addRange(69968, 70002).addRange(70004, 70006).addRange(70018, 70069).addRange(70079, 70088).addRange(70093, 70094).addRange(70096, 70111).addRange(70113, 70132).addRange(70144, 70161).addRange(70163, 70190).addRange(70194, 70195).addRange(70200, 70205).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70313).addRange(70320, 70366).addRange(70368, 70370).addRange(70384, 70393).addRange(70402, 70403).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70465, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70656, 70711).addRange(70720, 70721).addRange(70727, 70747).addRange(70751, 70753).addRange(70784, 70831).addRange(70833, 70834).addRange(70843, 70844).addRange(70852, 70855).addRange(70864, 70873);
      set3.addRange(71040, 71086).addRange(71088, 71089).addRange(71096, 71099).addRange(71105, 71131).addRange(71168, 71218).addRange(71227, 71228).addRange(71233, 71236).addRange(71248, 71257).addRange(71264, 71276).addRange(71296, 71338).addRange(71342, 71343).addRange(71352, 71353).addRange(71360, 71369).addRange(71424, 71450).addRange(71456, 71457).addRange(71472, 71494).addRange(71680, 71726).addRange(71840, 71922).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71983).addRange(71985, 71989).addRange(71991, 71992).addRange(71999, 72002).addRange(72004, 72006).addRange(72016, 72025).addRange(72096, 72103).addRange(72106, 72147).addRange(72156, 72159).addRange(72161, 72164).addRange(72203, 72242).addRange(72249, 72250).addRange(72255, 72262).addRange(72279, 72280).addRange(72284, 72329).addRange(72346, 72354).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72751).addRange(72768, 72773).addRange(72784, 72812).addRange(72816, 72847).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73008).addRange(73040, 73049).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73107, 73108);
      set3.addRange(73120, 73129).addRange(73440, 73458).addRange(73461, 73464).addRange(73664, 73713).addRange(73727, 74649).addRange(74752, 74862).addRange(74864, 74868).addRange(74880, 75075).addRange(77712, 77810).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92768, 92777).addRange(92782, 92862).addRange(92864, 92873).addRange(92880, 92909).addRange(92928, 92975).addRange(92983, 92997).addRange(93008, 93017).addRange(93019, 93025).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93850).addRange(93952, 94026).addRange(94032, 94087).addRange(94099, 94111).addRange(94176, 94179).addRange(94192, 94193).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119140).addRange(119146, 119149).addRange(119171, 119172).addRange(119180, 119209).addRange(119214, 119274);
      set3.addRange(119296, 119361).addRange(119520, 119539).addRange(119552, 119638).addRange(119648, 119672).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 121343).addRange(121399, 121402).addRange(121453, 121460).addRange(121462, 121475).addRange(121477, 121483).addRange(122624, 122654).addRange(123136, 123180).addRange(123191, 123197).addRange(123200, 123209).addRange(123214, 123215).addRange(123536, 123565).addRange(123584, 123627).addRange(123632, 123641).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125127, 125135).addRange(125184, 125251).addRange(125264, 125273).addRange(125278, 125279).addRange(126065, 126132).addRange(126209, 126269).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543);
      set3.addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(126704, 126705).addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127232, 127405).addRange(127462, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(127584, 127589).addRange(127744, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984).addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994).addRange(130032, 130041).addRange(131072, 173791);
      set3.addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Grapheme_Base.characters = set3;
      return Grapheme_Base;
    }
    var Grapheme_Extend = {};
    var hasRequiredGrapheme_Extend;
    function requireGrapheme_Extend() {
      if (hasRequiredGrapheme_Extend)
        return Grapheme_Extend;
      hasRequiredGrapheme_Extend = 1;
      var set3 = regenerate$2.exports(1471, 1479, 1648, 1809, 2045, 2362, 2364, 2381, 2433, 2492, 2494, 2509, 2519, 2558, 2620, 2641, 2677, 2748, 2765, 2817, 2876, 2893, 2946, 3006, 3008, 3021, 3031, 3072, 3076, 3132, 3201, 3260, 3263, 3266, 3270, 3390, 3405, 3415, 3457, 3530, 3535, 3542, 3551, 3633, 3761, 3893, 3895, 3897, 4038, 4226, 4237, 4253, 6086, 6109, 6159, 6313, 6450, 6683, 6742, 6752, 6754, 6783, 6972, 6978, 7142, 7149, 7405, 7412, 8204, 11647, 43010, 43014, 43019, 43052, 43263, 43443, 43493, 43587, 43596, 43644, 43696, 43713, 43766, 44005, 44008, 44013, 64286, 66045, 66272, 68159, 69633, 69744, 69826, 70003, 70095, 70196, 70206, 70367, 70462, 70464, 70487, 70726, 70750, 70832, 70842, 70845, 71087, 71229, 71339, 71341, 71351, 71984, 71998, 72003, 72160, 72263, 72767, 73018, 73031, 73109, 73111, 94031, 94180, 119141, 121461, 121476, 123566);
      set3.addRange(768, 879).addRange(1155, 1161).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1552, 1562).addRange(1611, 1631).addRange(1750, 1756).addRange(1759, 1764).addRange(1767, 1768).addRange(1770, 1773).addRange(1840, 1866).addRange(1958, 1968).addRange(2027, 2035).addRange(2070, 2073).addRange(2075, 2083).addRange(2085, 2087).addRange(2089, 2093).addRange(2137, 2139).addRange(2200, 2207).addRange(2250, 2273).addRange(2275, 2306).addRange(2369, 2376).addRange(2385, 2391).addRange(2402, 2403).addRange(2497, 2500).addRange(2530, 2531).addRange(2561, 2562).addRange(2625, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2672, 2673).addRange(2689, 2690).addRange(2753, 2757).addRange(2759, 2760).addRange(2786, 2787).addRange(2810, 2815).addRange(2878, 2879).addRange(2881, 2884).addRange(2901, 2903).addRange(2914, 2915).addRange(3134, 3136).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3170, 3171).addRange(3276, 3277).addRange(3285, 3286).addRange(3298, 3299).addRange(3328, 3329).addRange(3387, 3388);
      set3.addRange(3393, 3396).addRange(3426, 3427).addRange(3538, 3540).addRange(3636, 3642).addRange(3655, 3662).addRange(3764, 3772).addRange(3784, 3789).addRange(3864, 3865).addRange(3953, 3966).addRange(3968, 3972).addRange(3974, 3975).addRange(3981, 3991).addRange(3993, 4028).addRange(4141, 4144).addRange(4146, 4151).addRange(4153, 4154).addRange(4157, 4158).addRange(4184, 4185).addRange(4190, 4192).addRange(4209, 4212).addRange(4229, 4230).addRange(4957, 4959).addRange(5906, 5908).addRange(5938, 5939).addRange(5970, 5971).addRange(6002, 6003).addRange(6068, 6069).addRange(6071, 6077).addRange(6089, 6099).addRange(6155, 6157).addRange(6277, 6278).addRange(6432, 6434).addRange(6439, 6440).addRange(6457, 6459).addRange(6679, 6680).addRange(6744, 6750).addRange(6757, 6764).addRange(6771, 6780).addRange(6832, 6862).addRange(6912, 6915).addRange(6964, 6970).addRange(7019, 7027).addRange(7040, 7041).addRange(7074, 7077).addRange(7080, 7081).addRange(7083, 7085).addRange(7144, 7145).addRange(7151, 7153).addRange(7212, 7219).addRange(7222, 7223).addRange(7376, 7378);
      set3.addRange(7380, 7392).addRange(7394, 7400).addRange(7416, 7417).addRange(7616, 7679).addRange(8400, 8432).addRange(11503, 11505).addRange(11744, 11775).addRange(12330, 12335).addRange(12441, 12442).addRange(42607, 42610).addRange(42612, 42621).addRange(42654, 42655).addRange(42736, 42737).addRange(43045, 43046).addRange(43204, 43205).addRange(43232, 43249).addRange(43302, 43309).addRange(43335, 43345).addRange(43392, 43394).addRange(43446, 43449).addRange(43452, 43453).addRange(43561, 43566).addRange(43569, 43570).addRange(43573, 43574).addRange(43698, 43700).addRange(43703, 43704).addRange(43710, 43711).addRange(43756, 43757).addRange(65024, 65039).addRange(65056, 65071).addRange(65438, 65439).addRange(66422, 66426).addRange(68097, 68099).addRange(68101, 68102).addRange(68108, 68111).addRange(68152, 68154).addRange(68325, 68326).addRange(68900, 68903).addRange(69291, 69292).addRange(69446, 69456).addRange(69506, 69509).addRange(69688, 69702).addRange(69747, 69748).addRange(69759, 69761).addRange(69811, 69814).addRange(69817, 69818).addRange(69888, 69890).addRange(69927, 69931).addRange(69933, 69940).addRange(70016, 70017).addRange(70070, 70078);
      set3.addRange(70089, 70092).addRange(70191, 70193).addRange(70198, 70199).addRange(70371, 70378).addRange(70400, 70401).addRange(70459, 70460).addRange(70502, 70508).addRange(70512, 70516).addRange(70712, 70719).addRange(70722, 70724).addRange(70835, 70840).addRange(70847, 70848).addRange(70850, 70851).addRange(71090, 71093).addRange(71100, 71101).addRange(71103, 71104).addRange(71132, 71133).addRange(71219, 71226).addRange(71231, 71232).addRange(71344, 71349).addRange(71453, 71455).addRange(71458, 71461).addRange(71463, 71467).addRange(71727, 71735).addRange(71737, 71738).addRange(71995, 71996).addRange(72148, 72151).addRange(72154, 72155).addRange(72193, 72202).addRange(72243, 72248).addRange(72251, 72254).addRange(72273, 72278).addRange(72281, 72283).addRange(72330, 72342).addRange(72344, 72345).addRange(72752, 72758).addRange(72760, 72765).addRange(72850, 72871).addRange(72874, 72880).addRange(72882, 72883).addRange(72885, 72886).addRange(73009, 73014).addRange(73020, 73021).addRange(73023, 73029).addRange(73104, 73105).addRange(73459, 73460).addRange(92912, 92916).addRange(92976, 92982).addRange(94095, 94098).addRange(113821, 113822).addRange(118528, 118573);
      set3.addRange(118576, 118598).addRange(119143, 119145).addRange(119150, 119154).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123184, 123190).addRange(123628, 123631).addRange(125136, 125142).addRange(125252, 125258).addRange(917536, 917631).addRange(917760, 917999);
      Grapheme_Extend.characters = set3;
      return Grapheme_Extend;
    }
    var Hex_Digit = {};
    var hasRequiredHex_Digit;
    function requireHex_Digit() {
      if (hasRequiredHex_Digit)
        return Hex_Digit;
      hasRequiredHex_Digit = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(48, 57).addRange(65, 70).addRange(97, 102).addRange(65296, 65305).addRange(65313, 65318).addRange(65345, 65350);
      Hex_Digit.characters = set3;
      return Hex_Digit;
    }
    var ID_Continue = {};
    var hasRequiredID_Continue;
    function requireID_Continue() {
      if (hasRequiredID_Continue)
        return ID_Continue;
      hasRequiredID_Continue = 1;
      var set3 = regenerate$2.exports(95, 170, 181, 183, 186, 748, 750, 895, 908, 1369, 1471, 1479, 1791, 2042, 2045, 2482, 2519, 2556, 2558, 2620, 2641, 2654, 2768, 2929, 2972, 3024, 3031, 3165, 3517, 3530, 3542, 3716, 3749, 3782, 3840, 3893, 3895, 3897, 4038, 4295, 4301, 4696, 4800, 6103, 6823, 8025, 8027, 8029, 8126, 8276, 8305, 8319, 8417, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 42963, 43052, 43259, 64318, 65343, 66045, 66272, 67592, 67644, 68159, 69415, 69826, 70006, 70108, 70206, 70280, 70480, 70487, 70855, 71236, 71945, 72263, 72349, 73018, 73648, 119970, 119995, 120134, 121461, 121476, 123214, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(48, 57).addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(768, 884).addRange(886, 887).addRange(890, 893).addRange(902, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1155, 1159).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1488, 1514).addRange(1519, 1522).addRange(1552, 1562).addRange(1568, 1641).addRange(1646, 1747).addRange(1749, 1756).addRange(1759, 1768).addRange(1770, 1788).addRange(1808, 1866).addRange(1869, 1969).addRange(1984, 2037).addRange(2048, 2093).addRange(2112, 2139).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2200, 2273).addRange(2275, 2403).addRange(2406, 2415).addRange(2417, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2492, 2500).addRange(2503, 2504).addRange(2507, 2510).addRange(2524, 2525);
      set3.addRange(2527, 2531).addRange(2534, 2545).addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2649, 2652).addRange(2662, 2677).addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2748, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2784, 2787).addRange(2790, 2799).addRange(2809, 2815).addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2876, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2918, 2927).addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001);
      set3.addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021).addRange(3046, 3055).addRange(3072, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3132, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3174, 3183).addRange(3200, 3203).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3260, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3302, 3311).addRange(3313, 3314).addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3396).addRange(3398, 3400).addRange(3402, 3406).addRange(3412, 3415).addRange(3423, 3427).addRange(3430, 3439).addRange(3450, 3455).addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3558, 3567).addRange(3570, 3571).addRange(3585, 3642).addRange(3648, 3662).addRange(3664, 3673).addRange(3713, 3714);
      set3.addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3773).addRange(3776, 3780).addRange(3784, 3789).addRange(3792, 3801).addRange(3804, 3807).addRange(3864, 3865).addRange(3872, 3881).addRange(3902, 3911).addRange(3913, 3948).addRange(3953, 3972).addRange(3974, 3991).addRange(3993, 4028).addRange(4096, 4169).addRange(4176, 4253).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4957, 4959).addRange(4969, 4977).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5870, 5880).addRange(5888, 5909).addRange(5919, 5940).addRange(5952, 5971).addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003).addRange(6016, 6099).addRange(6108, 6109).addRange(6112, 6121);
      set3.addRange(6155, 6157).addRange(6159, 6169).addRange(6176, 6264).addRange(6272, 6314).addRange(6320, 6389).addRange(6400, 6430).addRange(6432, 6443).addRange(6448, 6459).addRange(6470, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6656, 6683).addRange(6688, 6750).addRange(6752, 6780).addRange(6783, 6793).addRange(6800, 6809).addRange(6832, 6845).addRange(6847, 6862).addRange(6912, 6988).addRange(6992, 7001).addRange(7019, 7027).addRange(7040, 7155).addRange(7168, 7223).addRange(7232, 7241).addRange(7245, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7376, 7378).addRange(7380, 7418).addRange(7424, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8255, 8256).addRange(8336, 8348).addRange(8400, 8412).addRange(8421, 8432);
      set3.addRange(8458, 8467).addRange(8472, 8477).addRange(8490, 8505).addRange(8508, 8511).addRange(8517, 8521).addRange(8544, 8584).addRange(11264, 11492).addRange(11499, 11507).addRange(11520, 11557).addRange(11568, 11623).addRange(11647, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(11744, 11775).addRange(12293, 12295).addRange(12321, 12335).addRange(12337, 12341).addRange(12344, 12348).addRange(12353, 12438).addRange(12441, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42539).addRange(42560, 42607).addRange(42612, 42621).addRange(42623, 42737).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43047).addRange(43072, 43123).addRange(43136, 43205).addRange(43216, 43225).addRange(43232, 43255).addRange(43261, 43309);
      set3.addRange(43312, 43347).addRange(43360, 43388).addRange(43392, 43456).addRange(43471, 43481).addRange(43488, 43518).addRange(43520, 43574).addRange(43584, 43597).addRange(43600, 43609).addRange(43616, 43638).addRange(43642, 43714).addRange(43739, 43741).addRange(43744, 43759).addRange(43762, 43766).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44010).addRange(44012, 44013).addRange(44016, 44025).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64285, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65019).addRange(65024, 65039).addRange(65056, 65071).addRange(65075, 65076).addRange(65101, 65103).addRange(65136, 65140).addRange(65142, 65276).addRange(65296, 65305).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65470).addRange(65474, 65479);
      set3.addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65856, 65908).addRange(66176, 66204).addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66378).addRange(66384, 66426).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66513, 66517).addRange(66560, 66717).addRange(66720, 66729).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023);
      set3.addRange(68030, 68031).addRange(68096, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68152, 68154).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68326).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680).addRange(68736, 68786).addRange(68800, 68850).addRange(68864, 68903).addRange(68912, 68921).addRange(69248, 69289).addRange(69291, 69292).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69456).addRange(69488, 69509).addRange(69552, 69572).addRange(69600, 69622).addRange(69632, 69702).addRange(69734, 69749).addRange(69759, 69818).addRange(69840, 69864).addRange(69872, 69881).addRange(69888, 69940).addRange(69942, 69951).addRange(69956, 69959).addRange(69968, 70003).addRange(70016, 70084).addRange(70089, 70092).addRange(70094, 70106).addRange(70144, 70161).addRange(70163, 70199).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70378).addRange(70384, 70393).addRange(70400, 70403).addRange(70405, 70412).addRange(70415, 70416);
      set3.addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70459, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70502, 70508).addRange(70512, 70516).addRange(70656, 70730).addRange(70736, 70745).addRange(70750, 70753).addRange(70784, 70853).addRange(70864, 70873).addRange(71040, 71093).addRange(71096, 71104).addRange(71128, 71133).addRange(71168, 71232).addRange(71248, 71257).addRange(71296, 71352).addRange(71360, 71369).addRange(71424, 71450).addRange(71453, 71467).addRange(71472, 71481).addRange(71488, 71494).addRange(71680, 71738).addRange(71840, 71913).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 72003).addRange(72016, 72025).addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72161).addRange(72163, 72164).addRange(72192, 72254).addRange(72272, 72345).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72768).addRange(72784, 72793).addRange(72818, 72847).addRange(72850, 72871).addRange(72873, 72886).addRange(72960, 72966).addRange(72968, 72969);
      set3.addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73031).addRange(73040, 73049).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73112).addRange(73120, 73129).addRange(73440, 73462).addRange(73728, 74649).addRange(74752, 74862).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92768, 92777).addRange(92784, 92862).addRange(92864, 92873).addRange(92880, 92909).addRange(92912, 92916).addRange(92928, 92982).addRange(92992, 92995).addRange(93008, 93017).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111).addRange(94176, 94177).addRange(94179, 94180).addRange(94192, 94193).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(113821, 113822);
      set3.addRange(118528, 118573).addRange(118576, 118598).addRange(119141, 119145).addRange(119149, 119154).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(120782, 120831).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122624, 122654).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123136, 123180).addRange(123184, 123197).addRange(123200, 123209).addRange(123536, 123566).addRange(123584, 123641);
      set3.addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125136, 125142).addRange(125184, 125259).addRange(125264, 125273).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(130032, 130041).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546).addRange(917760, 917999);
      ID_Continue.characters = set3;
      return ID_Continue;
    }
    var ID_Start = {};
    var hasRequiredID_Start;
    function requireID_Start() {
      if (hasRequiredID_Start)
        return ID_Start;
      hasRequiredID_Start = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 748, 750, 895, 902, 908, 1369, 1749, 1791, 1808, 1969, 2042, 2074, 2084, 2088, 2365, 2384, 2482, 2493, 2510, 2556, 2654, 2749, 2768, 2809, 2877, 2929, 2947, 2972, 3024, 3133, 3165, 3200, 3261, 3389, 3406, 3517, 3716, 3749, 3773, 3782, 3840, 4159, 4193, 4238, 4295, 4301, 4696, 4800, 6103, 6108, 6314, 6823, 7418, 8025, 8027, 8029, 8126, 8305, 8319, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 42963, 43259, 43471, 43642, 43697, 43712, 43714, 64285, 64318, 67592, 67644, 68096, 69415, 69749, 69956, 69959, 70006, 70106, 70108, 70280, 70461, 70480, 70855, 71236, 71352, 71945, 71999, 72001, 72161, 72163, 72192, 72250, 72272, 72349, 72768, 73030, 73112, 73648, 94032, 94179, 119970, 119995, 120134, 123214, 125259, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(880, 884).addRange(886, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1488, 1514).addRange(1519, 1522).addRange(1568, 1610).addRange(1646, 1647).addRange(1649, 1747).addRange(1765, 1766).addRange(1774, 1775).addRange(1786, 1788).addRange(1810, 1839).addRange(1869, 1957).addRange(1994, 2026).addRange(2036, 2037).addRange(2048, 2069).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2208, 2249).addRange(2308, 2361).addRange(2392, 2401).addRange(2417, 2432).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2524, 2525).addRange(2527, 2529).addRange(2544, 2545).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611);
      set3.addRange(2613, 2614).addRange(2616, 2617).addRange(2649, 2652).addRange(2674, 2676).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2784, 2785).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2908, 2909).addRange(2911, 2913).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3160, 3162).addRange(3168, 3169).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3293, 3294).addRange(3296, 3297).addRange(3313, 3314).addRange(3332, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3412, 3414).addRange(3423, 3425).addRange(3450, 3455).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526);
      set3.addRange(3585, 3632).addRange(3634, 3635).addRange(3648, 3654).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3760).addRange(3762, 3763).addRange(3776, 3780).addRange(3804, 3807).addRange(3904, 3911).addRange(3913, 3948).addRange(3976, 3980).addRange(4096, 4138).addRange(4176, 4181).addRange(4186, 4189).addRange(4197, 4198).addRange(4206, 4208).addRange(4213, 4225).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5870, 5880).addRange(5888, 5905).addRange(5919, 5937).addRange(5952, 5969).addRange(5984, 5996).addRange(5998, 6e3).addRange(6016, 6067).addRange(6176, 6264).addRange(6272, 6312);
      set3.addRange(6320, 6389).addRange(6400, 6430).addRange(6480, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6656, 6678).addRange(6688, 6740).addRange(6917, 6963).addRange(6981, 6988).addRange(7043, 7072).addRange(7086, 7087).addRange(7098, 7141).addRange(7168, 7203).addRange(7245, 7247).addRange(7258, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7414).addRange(7424, 7615).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8336, 8348).addRange(8458, 8467).addRange(8472, 8477).addRange(8490, 8505).addRange(8508, 8511).addRange(8517, 8521).addRange(8544, 8584).addRange(11264, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(11568, 11623).addRange(11648, 11670);
      set3.addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(12293, 12295).addRange(12321, 12329).addRange(12337, 12341).addRange(12344, 12348).addRange(12353, 12438).addRange(12443, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42527).addRange(42538, 42539).addRange(42560, 42606).addRange(42623, 42653).addRange(42656, 42735).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43009).addRange(43011, 43013).addRange(43015, 43018).addRange(43020, 43042).addRange(43072, 43123).addRange(43138, 43187).addRange(43250, 43255).addRange(43261, 43262).addRange(43274, 43301).addRange(43312, 43334).addRange(43360, 43388).addRange(43396, 43442).addRange(43488, 43492).addRange(43494, 43503).addRange(43514, 43518).addRange(43520, 43560).addRange(43584, 43586);
      set3.addRange(43588, 43595).addRange(43616, 43638).addRange(43646, 43695).addRange(43701, 43702).addRange(43705, 43709).addRange(43739, 43741).addRange(43744, 43754).addRange(43762, 43764).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44002).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64287, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65019).addRange(65136, 65140).addRange(65142, 65276).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65856, 65908).addRange(66176, 66204);
      set3.addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66378).addRange(66384, 66421).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66513, 66517).addRange(66560, 66717).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023).addRange(68030, 68031).addRange(68112, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68324).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680);
      set3.addRange(68736, 68786).addRange(68800, 68850).addRange(68864, 68899).addRange(69248, 69289).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69445).addRange(69488, 69505).addRange(69552, 69572).addRange(69600, 69622).addRange(69635, 69687).addRange(69745, 69746).addRange(69763, 69807).addRange(69840, 69864).addRange(69891, 69926).addRange(69968, 70002).addRange(70019, 70066).addRange(70081, 70084).addRange(70144, 70161).addRange(70163, 70187).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70366).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70493, 70497).addRange(70656, 70708).addRange(70727, 70730).addRange(70751, 70753).addRange(70784, 70831).addRange(70852, 70853).addRange(71040, 71086).addRange(71128, 71131).addRange(71168, 71215).addRange(71296, 71338).addRange(71424, 71450).addRange(71488, 71494).addRange(71680, 71723).addRange(71840, 71903).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71983).addRange(72096, 72103).addRange(72106, 72144);
      set3.addRange(72203, 72242).addRange(72284, 72329).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72750).addRange(72818, 72847).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73008).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73097).addRange(73440, 73458).addRange(73728, 74649).addRange(74752, 74862).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92784, 92862).addRange(92880, 92909).addRange(92928, 92975).addRange(92992, 92995).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94099, 94111).addRange(94176, 94177).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993);
      set3.addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122654).addRange(123136, 123180).addRange(123191, 123197).addRange(123536, 123565).addRange(123584, 123627).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125184, 125251).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(131072, 173791).addRange(173824, 177976);
      set3.addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      ID_Start.characters = set3;
      return ID_Start;
    }
    var Ideographic = {};
    var hasRequiredIdeographic;
    function requireIdeographic() {
      if (hasRequiredIdeographic)
        return Ideographic;
      hasRequiredIdeographic = 1;
      var set3 = regenerate$2.exports(94180);
      set3.addRange(12294, 12295).addRange(12321, 12329).addRange(12344, 12346).addRange(13312, 19903).addRange(19968, 40959).addRange(63744, 64109).addRange(64112, 64217).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110960, 111355).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Ideographic.characters = set3;
      return Ideographic;
    }
    var IDS_Binary_Operator = {};
    var hasRequiredIDS_Binary_Operator;
    function requireIDS_Binary_Operator() {
      if (hasRequiredIDS_Binary_Operator)
        return IDS_Binary_Operator;
      hasRequiredIDS_Binary_Operator = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(12272, 12273).addRange(12276, 12283);
      IDS_Binary_Operator.characters = set3;
      return IDS_Binary_Operator;
    }
    var IDS_Trinary_Operator = {};
    var hasRequiredIDS_Trinary_Operator;
    function requireIDS_Trinary_Operator() {
      if (hasRequiredIDS_Trinary_Operator)
        return IDS_Trinary_Operator;
      hasRequiredIDS_Trinary_Operator = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(12274, 12275);
      IDS_Trinary_Operator.characters = set3;
      return IDS_Trinary_Operator;
    }
    var Join_Control = {};
    var hasRequiredJoin_Control;
    function requireJoin_Control() {
      if (hasRequiredJoin_Control)
        return Join_Control;
      hasRequiredJoin_Control = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(8204, 8205);
      Join_Control.characters = set3;
      return Join_Control;
    }
    var Logical_Order_Exception = {};
    var hasRequiredLogical_Order_Exception;
    function requireLogical_Order_Exception() {
      if (hasRequiredLogical_Order_Exception)
        return Logical_Order_Exception;
      hasRequiredLogical_Order_Exception = 1;
      var set3 = regenerate$2.exports(6586, 43705);
      set3.addRange(3648, 3652).addRange(3776, 3780).addRange(6581, 6583).addRange(43701, 43702).addRange(43707, 43708);
      Logical_Order_Exception.characters = set3;
      return Logical_Order_Exception;
    }
    var Lowercase = {};
    var hasRequiredLowercase;
    function requireLowercase() {
      if (hasRequiredLowercase)
        return Lowercase;
      hasRequiredLowercase = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 257, 259, 261, 263, 265, 267, 269, 271, 273, 275, 277, 279, 281, 283, 285, 287, 289, 291, 293, 295, 297, 299, 301, 303, 305, 307, 309, 314, 316, 318, 320, 322, 324, 326, 331, 333, 335, 337, 339, 341, 343, 345, 347, 349, 351, 353, 355, 357, 359, 361, 363, 365, 367, 369, 371, 373, 375, 378, 380, 387, 389, 392, 402, 405, 414, 417, 419, 421, 424, 429, 432, 436, 438, 454, 457, 460, 462, 464, 466, 468, 470, 472, 474, 479, 481, 483, 485, 487, 489, 491, 493, 499, 501, 505, 507, 509, 511, 513, 515, 517, 519, 521, 523, 525, 527, 529, 531, 533, 535, 537, 539, 541, 543, 545, 547, 549, 551, 553, 555, 557, 559, 561, 572, 578, 583, 585, 587, 589, 837, 881, 883, 887, 912, 985, 987, 989, 991, 993, 995, 997, 999, 1001, 1003, 1005, 1013, 1016, 1121, 1123, 1125, 1127, 1129, 1131, 1133, 1135, 1137, 1139, 1141, 1143, 1145, 1147, 1149, 1151, 1153, 1163, 1165, 1167, 1169, 1171, 1173, 1175, 1177, 1179, 1181, 1183, 1185, 1187, 1189, 1191, 1193, 1195, 1197, 1199, 1201, 1203, 1205, 1207, 1209, 1211, 1213, 1215, 1218, 1220, 1222, 1224, 1226, 1228, 1233, 1235, 1237, 1239, 1241, 1243, 1245, 1247, 1249, 1251, 1253, 1255, 1257, 1259, 1261, 1263, 1265, 1267, 1269, 1271, 1273, 1275, 1277, 1279, 1281, 1283, 1285, 1287, 1289, 1291, 1293, 1295, 1297, 1299, 1301, 1303, 1305, 1307, 1309, 1311, 1313, 1315, 1317, 1319, 1321, 1323, 1325, 1327, 7681, 7683, 7685, 7687, 7689, 7691, 7693, 7695, 7697, 7699, 7701, 7703, 7705, 7707, 7709, 7711, 7713, 7715, 7717, 7719, 7721, 7723, 7725, 7727, 7729, 7731, 7733, 7735, 7737, 7739, 7741, 7743, 7745, 7747, 7749, 7751, 7753, 7755, 7757, 7759, 7761, 7763, 7765, 7767, 7769, 7771, 7773, 7775, 7777, 7779, 7781, 7783, 7785, 7787, 7789, 7791, 7793, 7795, 7797, 7799, 7801, 7803, 7805, 7807, 7809, 7811, 7813, 7815, 7817, 7819, 7821, 7823, 7825, 7827, 7839, 7841, 7843, 7845, 7847, 7849, 7851, 7853, 7855, 7857, 7859, 7861, 7863, 7865, 7867, 7869, 7871, 7873, 7875, 7877, 7879, 7881, 7883, 7885, 7887, 7889, 7891, 7893, 7895, 7897, 7899, 7901, 7903, 7905, 7907, 7909, 7911, 7913, 7915, 7917, 7919, 7921, 7923, 7925, 7927, 7929, 7931, 7933, 8126, 8305, 8319, 8458, 8467, 8495, 8500, 8505, 8526, 8580, 11361, 11368, 11370, 11372, 11377, 11393, 11395, 11397, 11399, 11401, 11403, 11405, 11407, 11409, 11411, 11413, 11415, 11417, 11419, 11421, 11423, 11425, 11427, 11429, 11431, 11433, 11435, 11437, 11439, 11441, 11443, 11445, 11447, 11449, 11451, 11453, 11455, 11457, 11459, 11461, 11463, 11465, 11467, 11469, 11471, 11473, 11475, 11477, 11479, 11481, 11483, 11485, 11487, 11489, 11500, 11502, 11507, 11559, 11565, 42561, 42563, 42565, 42567, 42569, 42571, 42573, 42575, 42577, 42579, 42581, 42583, 42585, 42587, 42589, 42591, 42593, 42595, 42597, 42599, 42601, 42603, 42605, 42625, 42627, 42629, 42631, 42633, 42635, 42637, 42639, 42641, 42643, 42645, 42647, 42649, 42787, 42789, 42791, 42793, 42795, 42797, 42803, 42805, 42807, 42809, 42811, 42813, 42815, 42817, 42819, 42821, 42823, 42825, 42827, 42829, 42831, 42833, 42835, 42837, 42839, 42841, 42843, 42845, 42847, 42849, 42851, 42853, 42855, 42857, 42859, 42861, 42874, 42876, 42879, 42881, 42883, 42885, 42887, 42892, 42894, 42897, 42903, 42905, 42907, 42909, 42911, 42913, 42915, 42917, 42919, 42921, 42927, 42933, 42935, 42937, 42939, 42941, 42943, 42945, 42947, 42952, 42954, 42961, 42963, 42965, 42967, 42969, 42998, 67456, 119995, 120779);
      set3.addRange(97, 122).addRange(223, 246).addRange(248, 255).addRange(311, 312).addRange(328, 329).addRange(382, 384).addRange(396, 397).addRange(409, 411).addRange(426, 427).addRange(441, 442).addRange(445, 447).addRange(476, 477).addRange(495, 496).addRange(563, 569).addRange(575, 576).addRange(591, 659).addRange(661, 696).addRange(704, 705).addRange(736, 740).addRange(890, 893).addRange(940, 974).addRange(976, 977).addRange(981, 983).addRange(1007, 1011).addRange(1019, 1020).addRange(1072, 1119).addRange(1230, 1231).addRange(1376, 1416).addRange(4304, 4346).addRange(4349, 4351).addRange(5112, 5117).addRange(7296, 7304).addRange(7424, 7615).addRange(7829, 7837).addRange(7935, 7943).addRange(7952, 7957).addRange(7968, 7975).addRange(7984, 7991).addRange(8e3, 8005).addRange(8016, 8023).addRange(8032, 8039).addRange(8048, 8061).addRange(8064, 8071).addRange(8080, 8087).addRange(8096, 8103).addRange(8112, 8116).addRange(8118, 8119).addRange(8130, 8132).addRange(8134, 8135).addRange(8144, 8147).addRange(8150, 8151);
      set3.addRange(8160, 8167).addRange(8178, 8180).addRange(8182, 8183).addRange(8336, 8348).addRange(8462, 8463).addRange(8508, 8509).addRange(8518, 8521).addRange(8560, 8575).addRange(9424, 9449).addRange(11312, 11359).addRange(11365, 11366).addRange(11379, 11380).addRange(11382, 11389).addRange(11491, 11492).addRange(11520, 11557).addRange(42651, 42653).addRange(42799, 42801).addRange(42863, 42872).addRange(42899, 42901).addRange(43e3, 43002).addRange(43824, 43866).addRange(43868, 43880).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65345, 65370).addRange(66600, 66639).addRange(66776, 66811).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67459, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(68800, 68850).addRange(71872, 71903).addRange(93792, 93823).addRange(119834, 119859).addRange(119886, 119892).addRange(119894, 119911).addRange(119938, 119963).addRange(119990, 119993).addRange(119997, 120003).addRange(120005, 120015).addRange(120042, 120067).addRange(120094, 120119).addRange(120146, 120171).addRange(120198, 120223).addRange(120250, 120275).addRange(120302, 120327);
      set3.addRange(120354, 120379).addRange(120406, 120431).addRange(120458, 120485).addRange(120514, 120538).addRange(120540, 120545).addRange(120572, 120596).addRange(120598, 120603).addRange(120630, 120654).addRange(120656, 120661).addRange(120688, 120712).addRange(120714, 120719).addRange(120746, 120770).addRange(120772, 120777).addRange(122624, 122633).addRange(122635, 122654).addRange(125218, 125251);
      Lowercase.characters = set3;
      return Lowercase;
    }
    var _Math = {};
    var hasRequired_Math;
    function require_Math() {
      if (hasRequired_Math)
        return _Math;
      hasRequired_Math = 1;
      var set3 = regenerate$2.exports(43, 94, 124, 126, 172, 177, 215, 247, 981, 8214, 8256, 8260, 8274, 8417, 8450, 8455, 8469, 8484, 8523, 8669, 9084, 9143, 9168, 9698, 9700, 9792, 9794, 64297, 65128, 65291, 65340, 65342, 65372, 65374, 65506, 119970, 119995, 120134, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(60, 62).addRange(976, 978).addRange(1008, 1009).addRange(1012, 1014).addRange(1542, 1544).addRange(8242, 8244).addRange(8289, 8292).addRange(8314, 8318).addRange(8330, 8334).addRange(8400, 8412).addRange(8421, 8422).addRange(8427, 8431).addRange(8458, 8467).addRange(8472, 8477).addRange(8488, 8489).addRange(8492, 8493).addRange(8495, 8497).addRange(8499, 8504).addRange(8508, 8521).addRange(8592, 8615).addRange(8617, 8622).addRange(8624, 8625).addRange(8630, 8631).addRange(8636, 8667).addRange(8676, 8677).addRange(8692, 8959).addRange(8968, 8971).addRange(8992, 8993).addRange(9115, 9141).addRange(9180, 9186).addRange(9632, 9633).addRange(9646, 9655).addRange(9660, 9665).addRange(9670, 9671).addRange(9674, 9675).addRange(9679, 9683).addRange(9703, 9708).addRange(9720, 9727).addRange(9733, 9734).addRange(9824, 9827).addRange(9837, 9839).addRange(10176, 10239).addRange(10496, 11007).addRange(11056, 11076).addRange(11079, 11084).addRange(65121, 65126).addRange(65308, 65310).addRange(65513, 65516).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967);
      set3.addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 120831).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(126704, 126705);
      _Math.characters = set3;
      return _Math;
    }
    var Noncharacter_Code_Point = {};
    var hasRequiredNoncharacter_Code_Point;
    function requireNoncharacter_Code_Point() {
      if (hasRequiredNoncharacter_Code_Point)
        return Noncharacter_Code_Point;
      hasRequiredNoncharacter_Code_Point = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(64976, 65007).addRange(65534, 65535).addRange(131070, 131071).addRange(196606, 196607).addRange(262142, 262143).addRange(327678, 327679).addRange(393214, 393215).addRange(458750, 458751).addRange(524286, 524287).addRange(589822, 589823).addRange(655358, 655359).addRange(720894, 720895).addRange(786430, 786431).addRange(851966, 851967).addRange(917502, 917503).addRange(983038, 983039).addRange(1048574, 1048575).addRange(1114110, 1114111);
      Noncharacter_Code_Point.characters = set3;
      return Noncharacter_Code_Point;
    }
    var Pattern_Syntax = {};
    var hasRequiredPattern_Syntax;
    function requirePattern_Syntax() {
      if (hasRequiredPattern_Syntax)
        return Pattern_Syntax;
      hasRequiredPattern_Syntax = 1;
      var set3 = regenerate$2.exports(96, 169, 174, 182, 187, 191, 215, 247, 12336);
      set3.addRange(33, 47).addRange(58, 64).addRange(91, 94).addRange(123, 126).addRange(161, 167).addRange(171, 172).addRange(176, 177).addRange(8208, 8231).addRange(8240, 8254).addRange(8257, 8275).addRange(8277, 8286).addRange(8592, 9311).addRange(9472, 10101).addRange(10132, 11263).addRange(11776, 11903).addRange(12289, 12291).addRange(12296, 12320).addRange(64830, 64831).addRange(65093, 65094);
      Pattern_Syntax.characters = set3;
      return Pattern_Syntax;
    }
    var Pattern_White_Space = {};
    var hasRequiredPattern_White_Space;
    function requirePattern_White_Space() {
      if (hasRequiredPattern_White_Space)
        return Pattern_White_Space;
      hasRequiredPattern_White_Space = 1;
      var set3 = regenerate$2.exports(32, 133);
      set3.addRange(9, 13).addRange(8206, 8207).addRange(8232, 8233);
      Pattern_White_Space.characters = set3;
      return Pattern_White_Space;
    }
    var Quotation_Mark = {};
    var hasRequiredQuotation_Mark;
    function requireQuotation_Mark() {
      if (hasRequiredQuotation_Mark)
        return Quotation_Mark;
      hasRequiredQuotation_Mark = 1;
      var set3 = regenerate$2.exports(34, 39, 171, 187, 11842, 65282, 65287);
      set3.addRange(8216, 8223).addRange(8249, 8250).addRange(12300, 12303).addRange(12317, 12319).addRange(65089, 65092).addRange(65378, 65379);
      Quotation_Mark.characters = set3;
      return Quotation_Mark;
    }
    var Radical = {};
    var hasRequiredRadical;
    function requireRadical() {
      if (hasRequiredRadical)
        return Radical;
      hasRequiredRadical = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245);
      Radical.characters = set3;
      return Radical;
    }
    var Regional_Indicator = {};
    var hasRequiredRegional_Indicator;
    function requireRegional_Indicator() {
      if (hasRequiredRegional_Indicator)
        return Regional_Indicator;
      hasRequiredRegional_Indicator = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(127462, 127487);
      Regional_Indicator.characters = set3;
      return Regional_Indicator;
    }
    var Sentence_Terminal = {};
    var hasRequiredSentence_Terminal;
    function requireSentence_Terminal() {
      if (hasRequiredSentence_Terminal)
        return Sentence_Terminal;
      hasRequiredSentence_Terminal = 1;
      var set3 = regenerate$2.exports(33, 46, 63, 1417, 1748, 2041, 2103, 2105, 4962, 5742, 6147, 6153, 11822, 11836, 12290, 42239, 42739, 42743, 43311, 44011, 65106, 65281, 65294, 65311, 65377, 70093, 70313, 72004, 72006, 92917, 92996, 93848, 113823, 121480);
      set3.addRange(1565, 1567).addRange(1792, 1794).addRange(2109, 2110).addRange(2404, 2405).addRange(4170, 4171).addRange(4967, 4968).addRange(5941, 5942).addRange(6468, 6469).addRange(6824, 6827).addRange(7002, 7003).addRange(7006, 7007).addRange(7037, 7038).addRange(7227, 7228).addRange(7294, 7295).addRange(8252, 8253).addRange(8263, 8265).addRange(11859, 11860).addRange(42510, 42511).addRange(43126, 43127).addRange(43214, 43215).addRange(43464, 43465).addRange(43613, 43615).addRange(43760, 43761).addRange(65110, 65111).addRange(68182, 68183).addRange(69461, 69465).addRange(69510, 69513).addRange(69703, 69704).addRange(69822, 69825).addRange(69953, 69955).addRange(70085, 70086).addRange(70110, 70111).addRange(70200, 70201).addRange(70203, 70204).addRange(70731, 70732).addRange(71106, 71107).addRange(71113, 71127).addRange(71233, 71234).addRange(71484, 71486).addRange(72258, 72259).addRange(72347, 72348).addRange(72769, 72770).addRange(73463, 73464).addRange(92782, 92783).addRange(92983, 92984);
      Sentence_Terminal.characters = set3;
      return Sentence_Terminal;
    }
    var Soft_Dotted = {};
    var hasRequiredSoft_Dotted;
    function requireSoft_Dotted() {
      if (hasRequiredSoft_Dotted)
        return Soft_Dotted;
      hasRequiredSoft_Dotted = 1;
      var set3 = regenerate$2.exports(303, 585, 616, 669, 690, 1011, 1110, 1112, 7522, 7574, 7588, 7592, 7725, 7883, 8305, 11388, 122650);
      set3.addRange(105, 106).addRange(8520, 8521).addRange(119842, 119843).addRange(119894, 119895).addRange(119946, 119947).addRange(119998, 119999).addRange(120050, 120051).addRange(120102, 120103).addRange(120154, 120155).addRange(120206, 120207).addRange(120258, 120259).addRange(120310, 120311).addRange(120362, 120363).addRange(120414, 120415).addRange(120466, 120467);
      Soft_Dotted.characters = set3;
      return Soft_Dotted;
    }
    var Terminal_Punctuation = {};
    var hasRequiredTerminal_Punctuation;
    function requireTerminal_Punctuation() {
      if (hasRequiredTerminal_Punctuation)
        return Terminal_Punctuation;
      hasRequiredTerminal_Punctuation = 1;
      var set3 = regenerate$2.exports(33, 44, 46, 63, 894, 903, 1417, 1475, 1548, 1563, 1748, 1804, 2142, 3848, 5742, 6106, 11822, 11836, 11841, 11852, 43311, 43743, 44011, 65281, 65292, 65294, 65311, 65377, 65380, 66463, 66512, 67671, 67871, 70093, 70313, 72004, 72006, 72817, 92917, 92996, 113823);
      set3.addRange(58, 59).addRange(1565, 1567).addRange(1792, 1802).addRange(2040, 2041).addRange(2096, 2110).addRange(2404, 2405).addRange(3674, 3675).addRange(3853, 3858).addRange(4170, 4171).addRange(4961, 4968).addRange(5867, 5869).addRange(5941, 5942).addRange(6100, 6102).addRange(6146, 6149).addRange(6152, 6153).addRange(6468, 6469).addRange(6824, 6827).addRange(7002, 7003).addRange(7005, 7007).addRange(7037, 7038).addRange(7227, 7231).addRange(7294, 7295).addRange(8252, 8253).addRange(8263, 8265).addRange(11854, 11855).addRange(11859, 11860).addRange(12289, 12290).addRange(42238, 42239).addRange(42509, 42511).addRange(42739, 42743).addRange(43126, 43127).addRange(43214, 43215).addRange(43463, 43465).addRange(43613, 43615).addRange(43760, 43761).addRange(65104, 65106).addRange(65108, 65111).addRange(65306, 65307).addRange(68182, 68183).addRange(68336, 68341).addRange(68410, 68415).addRange(68505, 68508).addRange(69461, 69465).addRange(69510, 69513).addRange(69703, 69709).addRange(69822, 69825).addRange(69953, 69955).addRange(70085, 70086).addRange(70110, 70111).addRange(70200, 70204).addRange(70731, 70733);
      set3.addRange(70746, 70747).addRange(71106, 71109).addRange(71113, 71127).addRange(71233, 71234).addRange(71484, 71486).addRange(72258, 72259).addRange(72347, 72348).addRange(72353, 72354).addRange(72769, 72771).addRange(73463, 73464).addRange(74864, 74868).addRange(92782, 92783).addRange(92983, 92985).addRange(93847, 93848).addRange(121479, 121482);
      Terminal_Punctuation.characters = set3;
      return Terminal_Punctuation;
    }
    var Unified_Ideograph = {};
    var hasRequiredUnified_Ideograph;
    function requireUnified_Ideograph() {
      if (hasRequiredUnified_Ideograph)
        return Unified_Ideograph;
      hasRequiredUnified_Ideograph = 1;
      var set3 = regenerate$2.exports(64017, 64031, 64033);
      set3.addRange(13312, 19903).addRange(19968, 40959).addRange(64014, 64015).addRange(64019, 64020).addRange(64035, 64036).addRange(64039, 64041).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(196608, 201546);
      Unified_Ideograph.characters = set3;
      return Unified_Ideograph;
    }
    var Uppercase = {};
    var hasRequiredUppercase;
    function requireUppercase() {
      if (hasRequiredUppercase)
        return Uppercase;
      hasRequiredUppercase = 1;
      var set3 = regenerate$2.exports(256, 258, 260, 262, 264, 266, 268, 270, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 306, 308, 310, 313, 315, 317, 319, 321, 323, 325, 327, 330, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 379, 381, 388, 418, 420, 425, 428, 437, 444, 452, 455, 458, 461, 463, 465, 467, 469, 471, 473, 475, 478, 480, 482, 484, 486, 488, 490, 492, 494, 497, 500, 506, 508, 510, 512, 514, 516, 518, 520, 522, 524, 526, 528, 530, 532, 534, 536, 538, 540, 542, 544, 546, 548, 550, 552, 554, 556, 558, 560, 562, 577, 584, 586, 588, 590, 880, 882, 886, 895, 902, 908, 975, 984, 986, 988, 990, 992, 994, 996, 998, 1e3, 1002, 1004, 1006, 1012, 1015, 1120, 1122, 1124, 1126, 1128, 1130, 1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 1148, 1150, 1152, 1162, 1164, 1166, 1168, 1170, 1172, 1174, 1176, 1178, 1180, 1182, 1184, 1186, 1188, 1190, 1192, 1194, 1196, 1198, 1200, 1202, 1204, 1206, 1208, 1210, 1212, 1214, 1219, 1221, 1223, 1225, 1227, 1229, 1232, 1234, 1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1324, 1326, 4295, 4301, 7680, 7682, 7684, 7686, 7688, 7690, 7692, 7694, 7696, 7698, 7700, 7702, 7704, 7706, 7708, 7710, 7712, 7714, 7716, 7718, 7720, 7722, 7724, 7726, 7728, 7730, 7732, 7734, 7736, 7738, 7740, 7742, 7744, 7746, 7748, 7750, 7752, 7754, 7756, 7758, 7760, 7762, 7764, 7766, 7768, 7770, 7772, 7774, 7776, 7778, 7780, 7782, 7784, 7786, 7788, 7790, 7792, 7794, 7796, 7798, 7800, 7802, 7804, 7806, 7808, 7810, 7812, 7814, 7816, 7818, 7820, 7822, 7824, 7826, 7828, 7838, 7840, 7842, 7844, 7846, 7848, 7850, 7852, 7854, 7856, 7858, 7860, 7862, 7864, 7866, 7868, 7870, 7872, 7874, 7876, 7878, 7880, 7882, 7884, 7886, 7888, 7890, 7892, 7894, 7896, 7898, 7900, 7902, 7904, 7906, 7908, 7910, 7912, 7914, 7916, 7918, 7920, 7922, 7924, 7926, 7928, 7930, 7932, 7934, 8025, 8027, 8029, 8031, 8450, 8455, 8469, 8484, 8486, 8488, 8517, 8579, 11360, 11367, 11369, 11371, 11378, 11381, 11394, 11396, 11398, 11400, 11402, 11404, 11406, 11408, 11410, 11412, 11414, 11416, 11418, 11420, 11422, 11424, 11426, 11428, 11430, 11432, 11434, 11436, 11438, 11440, 11442, 11444, 11446, 11448, 11450, 11452, 11454, 11456, 11458, 11460, 11462, 11464, 11466, 11468, 11470, 11472, 11474, 11476, 11478, 11480, 11482, 11484, 11486, 11488, 11490, 11499, 11501, 11506, 42560, 42562, 42564, 42566, 42568, 42570, 42572, 42574, 42576, 42578, 42580, 42582, 42584, 42586, 42588, 42590, 42592, 42594, 42596, 42598, 42600, 42602, 42604, 42624, 42626, 42628, 42630, 42632, 42634, 42636, 42638, 42640, 42642, 42644, 42646, 42648, 42650, 42786, 42788, 42790, 42792, 42794, 42796, 42798, 42802, 42804, 42806, 42808, 42810, 42812, 42814, 42816, 42818, 42820, 42822, 42824, 42826, 42828, 42830, 42832, 42834, 42836, 42838, 42840, 42842, 42844, 42846, 42848, 42850, 42852, 42854, 42856, 42858, 42860, 42862, 42873, 42875, 42880, 42882, 42884, 42886, 42891, 42893, 42896, 42898, 42902, 42904, 42906, 42908, 42910, 42912, 42914, 42916, 42918, 42920, 42934, 42936, 42938, 42940, 42942, 42944, 42946, 42953, 42960, 42966, 42968, 42997, 119964, 119970, 120134, 120778);
      set3.addRange(65, 90).addRange(192, 214).addRange(216, 222).addRange(376, 377).addRange(385, 386).addRange(390, 391).addRange(393, 395).addRange(398, 401).addRange(403, 404).addRange(406, 408).addRange(412, 413).addRange(415, 416).addRange(422, 423).addRange(430, 431).addRange(433, 435).addRange(439, 440).addRange(502, 504).addRange(570, 571).addRange(573, 574).addRange(579, 582).addRange(904, 906).addRange(910, 911).addRange(913, 929).addRange(931, 939).addRange(978, 980).addRange(1017, 1018).addRange(1021, 1071).addRange(1216, 1217).addRange(1329, 1366).addRange(4256, 4293).addRange(5024, 5109).addRange(7312, 7354).addRange(7357, 7359).addRange(7944, 7951).addRange(7960, 7965).addRange(7976, 7983).addRange(7992, 7999).addRange(8008, 8013).addRange(8040, 8047).addRange(8120, 8123).addRange(8136, 8139).addRange(8152, 8155).addRange(8168, 8172).addRange(8184, 8187).addRange(8459, 8461).addRange(8464, 8466).addRange(8473, 8477).addRange(8490, 8493).addRange(8496, 8499).addRange(8510, 8511).addRange(8544, 8559);
      set3.addRange(9398, 9423).addRange(11264, 11311).addRange(11362, 11364).addRange(11373, 11376).addRange(11390, 11392).addRange(42877, 42878).addRange(42922, 42926).addRange(42928, 42932).addRange(42948, 42951).addRange(65313, 65338).addRange(66560, 66599).addRange(66736, 66771).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(68736, 68786).addRange(71840, 71871).addRange(93760, 93791).addRange(119808, 119833).addRange(119860, 119885).addRange(119912, 119937).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119989).addRange(120016, 120041).addRange(120068, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120120, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120172, 120197).addRange(120224, 120249).addRange(120276, 120301).addRange(120328, 120353).addRange(120380, 120405).addRange(120432, 120457).addRange(120488, 120512).addRange(120546, 120570).addRange(120604, 120628).addRange(120662, 120686).addRange(120720, 120744).addRange(125184, 125217).addRange(127280, 127305).addRange(127312, 127337).addRange(127344, 127369);
      Uppercase.characters = set3;
      return Uppercase;
    }
    var Variation_Selector = {};
    var hasRequiredVariation_Selector;
    function requireVariation_Selector() {
      if (hasRequiredVariation_Selector)
        return Variation_Selector;
      hasRequiredVariation_Selector = 1;
      var set3 = regenerate$2.exports(6159);
      set3.addRange(6155, 6157).addRange(65024, 65039).addRange(917760, 917999);
      Variation_Selector.characters = set3;
      return Variation_Selector;
    }
    var White_Space = {};
    var hasRequiredWhite_Space;
    function requireWhite_Space() {
      if (hasRequiredWhite_Space)
        return White_Space;
      hasRequiredWhite_Space = 1;
      var set3 = regenerate$2.exports(32, 133, 160, 5760, 8239, 8287, 12288);
      set3.addRange(9, 13).addRange(8192, 8202).addRange(8232, 8233);
      White_Space.characters = set3;
      return White_Space;
    }
    var XID_Continue = {};
    var hasRequiredXID_Continue;
    function requireXID_Continue() {
      if (hasRequiredXID_Continue)
        return XID_Continue;
      hasRequiredXID_Continue = 1;
      var set3 = regenerate$2.exports(95, 170, 181, 183, 186, 748, 750, 895, 908, 1369, 1471, 1479, 1791, 2042, 2045, 2482, 2519, 2556, 2558, 2620, 2641, 2654, 2768, 2929, 2972, 3024, 3031, 3165, 3517, 3530, 3542, 3716, 3749, 3782, 3840, 3893, 3895, 3897, 4038, 4295, 4301, 4696, 4800, 6103, 6823, 8025, 8027, 8029, 8126, 8276, 8305, 8319, 8417, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 42963, 43052, 43259, 64318, 65137, 65139, 65143, 65145, 65147, 65149, 65343, 66045, 66272, 67592, 67644, 68159, 69415, 69826, 70006, 70108, 70206, 70280, 70480, 70487, 70855, 71236, 71945, 72263, 72349, 73018, 73648, 119970, 119995, 120134, 121461, 121476, 123214, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(48, 57).addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(768, 884).addRange(886, 887).addRange(891, 893).addRange(902, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1155, 1159).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1488, 1514).addRange(1519, 1522).addRange(1552, 1562).addRange(1568, 1641).addRange(1646, 1747).addRange(1749, 1756).addRange(1759, 1768).addRange(1770, 1788).addRange(1808, 1866).addRange(1869, 1969).addRange(1984, 2037).addRange(2048, 2093).addRange(2112, 2139).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2200, 2273).addRange(2275, 2403).addRange(2406, 2415).addRange(2417, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2492, 2500).addRange(2503, 2504).addRange(2507, 2510).addRange(2524, 2525);
      set3.addRange(2527, 2531).addRange(2534, 2545).addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2649, 2652).addRange(2662, 2677).addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2748, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2784, 2787).addRange(2790, 2799).addRange(2809, 2815).addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2876, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2918, 2927).addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001);
      set3.addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021).addRange(3046, 3055).addRange(3072, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3132, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3174, 3183).addRange(3200, 3203).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3260, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3302, 3311).addRange(3313, 3314).addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3396).addRange(3398, 3400).addRange(3402, 3406).addRange(3412, 3415).addRange(3423, 3427).addRange(3430, 3439).addRange(3450, 3455).addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3558, 3567).addRange(3570, 3571).addRange(3585, 3642).addRange(3648, 3662).addRange(3664, 3673).addRange(3713, 3714);
      set3.addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3773).addRange(3776, 3780).addRange(3784, 3789).addRange(3792, 3801).addRange(3804, 3807).addRange(3864, 3865).addRange(3872, 3881).addRange(3902, 3911).addRange(3913, 3948).addRange(3953, 3972).addRange(3974, 3991).addRange(3993, 4028).addRange(4096, 4169).addRange(4176, 4253).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4957, 4959).addRange(4969, 4977).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5870, 5880).addRange(5888, 5909).addRange(5919, 5940).addRange(5952, 5971).addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003).addRange(6016, 6099).addRange(6108, 6109).addRange(6112, 6121);
      set3.addRange(6155, 6157).addRange(6159, 6169).addRange(6176, 6264).addRange(6272, 6314).addRange(6320, 6389).addRange(6400, 6430).addRange(6432, 6443).addRange(6448, 6459).addRange(6470, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6656, 6683).addRange(6688, 6750).addRange(6752, 6780).addRange(6783, 6793).addRange(6800, 6809).addRange(6832, 6845).addRange(6847, 6862).addRange(6912, 6988).addRange(6992, 7001).addRange(7019, 7027).addRange(7040, 7155).addRange(7168, 7223).addRange(7232, 7241).addRange(7245, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7376, 7378).addRange(7380, 7418).addRange(7424, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8255, 8256).addRange(8336, 8348).addRange(8400, 8412).addRange(8421, 8432);
      set3.addRange(8458, 8467).addRange(8472, 8477).addRange(8490, 8505).addRange(8508, 8511).addRange(8517, 8521).addRange(8544, 8584).addRange(11264, 11492).addRange(11499, 11507).addRange(11520, 11557).addRange(11568, 11623).addRange(11647, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(11744, 11775).addRange(12293, 12295).addRange(12321, 12335).addRange(12337, 12341).addRange(12344, 12348).addRange(12353, 12438).addRange(12441, 12442).addRange(12445, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42539).addRange(42560, 42607).addRange(42612, 42621).addRange(42623, 42737).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43047).addRange(43072, 43123).addRange(43136, 43205).addRange(43216, 43225).addRange(43232, 43255);
      set3.addRange(43261, 43309).addRange(43312, 43347).addRange(43360, 43388).addRange(43392, 43456).addRange(43471, 43481).addRange(43488, 43518).addRange(43520, 43574).addRange(43584, 43597).addRange(43600, 43609).addRange(43616, 43638).addRange(43642, 43714).addRange(43739, 43741).addRange(43744, 43759).addRange(43762, 43766).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44010).addRange(44012, 44013).addRange(44016, 44025).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64285, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64605).addRange(64612, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65017).addRange(65024, 65039).addRange(65056, 65071).addRange(65075, 65076).addRange(65101, 65103).addRange(65151, 65276).addRange(65296, 65305).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65470);
      set3.addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65856, 65908).addRange(66176, 66204).addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66378).addRange(66384, 66426).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66513, 66517).addRange(66560, 66717).addRange(66720, 66729).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897);
      set3.addRange(67968, 68023).addRange(68030, 68031).addRange(68096, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68152, 68154).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68326).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680).addRange(68736, 68786).addRange(68800, 68850).addRange(68864, 68903).addRange(68912, 68921).addRange(69248, 69289).addRange(69291, 69292).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69456).addRange(69488, 69509).addRange(69552, 69572).addRange(69600, 69622).addRange(69632, 69702).addRange(69734, 69749).addRange(69759, 69818).addRange(69840, 69864).addRange(69872, 69881).addRange(69888, 69940).addRange(69942, 69951).addRange(69956, 69959).addRange(69968, 70003).addRange(70016, 70084).addRange(70089, 70092).addRange(70094, 70106).addRange(70144, 70161).addRange(70163, 70199).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70378).addRange(70384, 70393).addRange(70400, 70403).addRange(70405, 70412);
      set3.addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70459, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70502, 70508).addRange(70512, 70516).addRange(70656, 70730).addRange(70736, 70745).addRange(70750, 70753).addRange(70784, 70853).addRange(70864, 70873).addRange(71040, 71093).addRange(71096, 71104).addRange(71128, 71133).addRange(71168, 71232).addRange(71248, 71257).addRange(71296, 71352).addRange(71360, 71369).addRange(71424, 71450).addRange(71453, 71467).addRange(71472, 71481).addRange(71488, 71494).addRange(71680, 71738).addRange(71840, 71913).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 72003).addRange(72016, 72025).addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72161).addRange(72163, 72164).addRange(72192, 72254).addRange(72272, 72345).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72768).addRange(72784, 72793).addRange(72818, 72847).addRange(72850, 72871).addRange(72873, 72886).addRange(72960, 72966);
      set3.addRange(72968, 72969).addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73031).addRange(73040, 73049).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73112).addRange(73120, 73129).addRange(73440, 73462).addRange(73728, 74649).addRange(74752, 74862).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92768, 92777).addRange(92784, 92862).addRange(92864, 92873).addRange(92880, 92909).addRange(92912, 92916).addRange(92928, 92982).addRange(92992, 92995).addRange(93008, 93017).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111).addRange(94176, 94177).addRange(94179, 94180).addRange(94192, 94193).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817);
      set3.addRange(113821, 113822).addRange(118528, 118573).addRange(118576, 118598).addRange(119141, 119145).addRange(119149, 119154).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(120782, 120831).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122624, 122654).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123136, 123180).addRange(123184, 123197).addRange(123200, 123209).addRange(123536, 123566);
      set3.addRange(123584, 123641).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125136, 125142).addRange(125184, 125259).addRange(125264, 125273).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(130032, 130041).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546).addRange(917760, 917999);
      XID_Continue.characters = set3;
      return XID_Continue;
    }
    var XID_Start = {};
    var hasRequiredXID_Start;
    function requireXID_Start() {
      if (hasRequiredXID_Start)
        return XID_Start;
      hasRequiredXID_Start = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 748, 750, 895, 902, 908, 1369, 1749, 1791, 1808, 1969, 2042, 2074, 2084, 2088, 2365, 2384, 2482, 2493, 2510, 2556, 2654, 2749, 2768, 2809, 2877, 2929, 2947, 2972, 3024, 3133, 3165, 3200, 3261, 3389, 3406, 3517, 3634, 3716, 3749, 3762, 3773, 3782, 3840, 4159, 4193, 4238, 4295, 4301, 4696, 4800, 6103, 6108, 6314, 6823, 7418, 8025, 8027, 8029, 8126, 8305, 8319, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 42963, 43259, 43471, 43642, 43697, 43712, 43714, 64285, 64318, 65137, 65139, 65143, 65145, 65147, 65149, 67592, 67644, 68096, 69415, 69749, 69956, 69959, 70006, 70106, 70108, 70280, 70461, 70480, 70855, 71236, 71352, 71945, 71999, 72001, 72161, 72163, 72192, 72250, 72272, 72349, 72768, 73030, 73112, 73648, 94032, 94179, 119970, 119995, 120134, 123214, 125259, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(880, 884).addRange(886, 887).addRange(891, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1488, 1514).addRange(1519, 1522).addRange(1568, 1610).addRange(1646, 1647).addRange(1649, 1747).addRange(1765, 1766).addRange(1774, 1775).addRange(1786, 1788).addRange(1810, 1839).addRange(1869, 1957).addRange(1994, 2026).addRange(2036, 2037).addRange(2048, 2069).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2208, 2249).addRange(2308, 2361).addRange(2392, 2401).addRange(2417, 2432).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2524, 2525).addRange(2527, 2529).addRange(2544, 2545).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611);
      set3.addRange(2613, 2614).addRange(2616, 2617).addRange(2649, 2652).addRange(2674, 2676).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2784, 2785).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2908, 2909).addRange(2911, 2913).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3160, 3162).addRange(3168, 3169).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3293, 3294).addRange(3296, 3297).addRange(3313, 3314).addRange(3332, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3412, 3414).addRange(3423, 3425).addRange(3450, 3455).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526);
      set3.addRange(3585, 3632).addRange(3648, 3654).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3760).addRange(3776, 3780).addRange(3804, 3807).addRange(3904, 3911).addRange(3913, 3948).addRange(3976, 3980).addRange(4096, 4138).addRange(4176, 4181).addRange(4186, 4189).addRange(4197, 4198).addRange(4206, 4208).addRange(4213, 4225).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5870, 5880).addRange(5888, 5905).addRange(5919, 5937).addRange(5952, 5969).addRange(5984, 5996).addRange(5998, 6e3).addRange(6016, 6067).addRange(6176, 6264).addRange(6272, 6312).addRange(6320, 6389).addRange(6400, 6430);
      set3.addRange(6480, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6656, 6678).addRange(6688, 6740).addRange(6917, 6963).addRange(6981, 6988).addRange(7043, 7072).addRange(7086, 7087).addRange(7098, 7141).addRange(7168, 7203).addRange(7245, 7247).addRange(7258, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7414).addRange(7424, 7615).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8336, 8348).addRange(8458, 8467).addRange(8472, 8477).addRange(8490, 8505).addRange(8508, 8511).addRange(8517, 8521).addRange(8544, 8584).addRange(11264, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(11568, 11623).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694);
      set3.addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(12293, 12295).addRange(12321, 12329).addRange(12337, 12341).addRange(12344, 12348).addRange(12353, 12438).addRange(12445, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42527).addRange(42538, 42539).addRange(42560, 42606).addRange(42623, 42653).addRange(42656, 42735).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43009).addRange(43011, 43013).addRange(43015, 43018).addRange(43020, 43042).addRange(43072, 43123).addRange(43138, 43187).addRange(43250, 43255).addRange(43261, 43262).addRange(43274, 43301).addRange(43312, 43334).addRange(43360, 43388).addRange(43396, 43442).addRange(43488, 43492).addRange(43494, 43503).addRange(43514, 43518).addRange(43520, 43560).addRange(43584, 43586).addRange(43588, 43595).addRange(43616, 43638);
      set3.addRange(43646, 43695).addRange(43701, 43702).addRange(43705, 43709).addRange(43739, 43741).addRange(43744, 43754).addRange(43762, 43764).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44002).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64287, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64605).addRange(64612, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65017).addRange(65151, 65276).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65437).addRange(65440, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65856, 65908).addRange(66176, 66204).addRange(66208, 66256);
      set3.addRange(66304, 66335).addRange(66349, 66378).addRange(66384, 66421).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66513, 66517).addRange(66560, 66717).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023).addRange(68030, 68031).addRange(68112, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68324).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680).addRange(68736, 68786);
      set3.addRange(68800, 68850).addRange(68864, 68899).addRange(69248, 69289).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69445).addRange(69488, 69505).addRange(69552, 69572).addRange(69600, 69622).addRange(69635, 69687).addRange(69745, 69746).addRange(69763, 69807).addRange(69840, 69864).addRange(69891, 69926).addRange(69968, 70002).addRange(70019, 70066).addRange(70081, 70084).addRange(70144, 70161).addRange(70163, 70187).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70366).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70493, 70497).addRange(70656, 70708).addRange(70727, 70730).addRange(70751, 70753).addRange(70784, 70831).addRange(70852, 70853).addRange(71040, 71086).addRange(71128, 71131).addRange(71168, 71215).addRange(71296, 71338).addRange(71424, 71450).addRange(71488, 71494).addRange(71680, 71723).addRange(71840, 71903).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71983).addRange(72096, 72103).addRange(72106, 72144).addRange(72203, 72242);
      set3.addRange(72284, 72329).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72750).addRange(72818, 72847).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73008).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73097).addRange(73440, 73458).addRange(73728, 74649).addRange(74752, 74862).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92784, 92862).addRange(92880, 92909).addRange(92928, 92975).addRange(92992, 92995).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94099, 94111).addRange(94176, 94177).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003);
      set3.addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122654).addRange(123136, 123180).addRange(123191, 123197).addRange(123536, 123565).addRange(123584, 123627).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125184, 125251).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205);
      set3.addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      XID_Start.characters = set3;
      return XID_Start;
    }
    var Cased_Letter = {};
    var hasRequiredCased_Letter;
    function requireCased_Letter() {
      if (hasRequiredCased_Letter)
        return Cased_Letter;
      hasRequiredCased_Letter = 1;
      var set3 = regenerate$2.exports(181, 895, 902, 908, 4295, 4301, 8025, 8027, 8029, 8126, 8450, 8455, 8469, 8484, 8486, 8488, 8505, 8526, 11559, 11565, 42963, 43002, 119970, 119995, 120134);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 442).addRange(444, 447).addRange(452, 659).addRange(661, 687).addRange(880, 883).addRange(886, 887).addRange(891, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(4256, 4293).addRange(4304, 4346).addRange(4349, 4351).addRange(5024, 5109).addRange(5112, 5117).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7424, 7467).addRange(7531, 7543).addRange(7545, 7578).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8458, 8467).addRange(8473, 8477).addRange(8490, 8493).addRange(8495, 8500).addRange(8508, 8511).addRange(8517, 8521).addRange(8579, 8580);
      set3.addRange(11264, 11387).addRange(11390, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557).addRange(42560, 42605).addRange(42624, 42651).addRange(42786, 42863).addRange(42865, 42887).addRange(42891, 42894).addRange(42896, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42997, 42998).addRange(43824, 43866).addRange(43872, 43880).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65313, 65338).addRange(65345, 65370).addRange(66560, 66639).addRange(66736, 66771).addRange(66776, 66811).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(68736, 68786).addRange(68800, 68850).addRange(71840, 71903).addRange(93760, 93823).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144);
      set3.addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122633).addRange(122635, 122654).addRange(125184, 125251);
      Cased_Letter.characters = set3;
      return Cased_Letter;
    }
    var Close_Punctuation = {};
    var hasRequiredClose_Punctuation;
    function requireClose_Punctuation() {
      if (hasRequiredClose_Punctuation)
        return Close_Punctuation;
      hasRequiredClose_Punctuation = 1;
      var set3 = regenerate$2.exports(41, 93, 125, 3899, 3901, 5788, 8262, 8318, 8334, 8969, 8971, 9002, 10089, 10091, 10093, 10095, 10097, 10099, 10101, 10182, 10215, 10217, 10219, 10221, 10223, 10628, 10630, 10632, 10634, 10636, 10638, 10640, 10642, 10644, 10646, 10648, 10713, 10715, 10749, 11811, 11813, 11815, 11817, 11862, 11864, 11866, 11868, 12297, 12299, 12301, 12303, 12305, 12309, 12311, 12313, 12315, 64830, 65048, 65078, 65080, 65082, 65084, 65086, 65088, 65090, 65092, 65096, 65114, 65116, 65118, 65289, 65341, 65373, 65376, 65379);
      set3.addRange(12318, 12319);
      Close_Punctuation.characters = set3;
      return Close_Punctuation;
    }
    var Connector_Punctuation = {};
    var hasRequiredConnector_Punctuation;
    function requireConnector_Punctuation() {
      if (hasRequiredConnector_Punctuation)
        return Connector_Punctuation;
      hasRequiredConnector_Punctuation = 1;
      var set3 = regenerate$2.exports(95, 8276, 65343);
      set3.addRange(8255, 8256).addRange(65075, 65076).addRange(65101, 65103);
      Connector_Punctuation.characters = set3;
      return Connector_Punctuation;
    }
    var Control = {};
    var hasRequiredControl;
    function requireControl() {
      if (hasRequiredControl)
        return Control;
      hasRequiredControl = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(0, 31).addRange(127, 159);
      Control.characters = set3;
      return Control;
    }
    var Currency_Symbol = {};
    var hasRequiredCurrency_Symbol;
    function requireCurrency_Symbol() {
      if (hasRequiredCurrency_Symbol)
        return Currency_Symbol;
      hasRequiredCurrency_Symbol = 1;
      var set3 = regenerate$2.exports(36, 1423, 1547, 2555, 2801, 3065, 3647, 6107, 43064, 65020, 65129, 65284, 123647, 126128);
      set3.addRange(162, 165).addRange(2046, 2047).addRange(2546, 2547).addRange(8352, 8384).addRange(65504, 65505).addRange(65509, 65510).addRange(73693, 73696);
      Currency_Symbol.characters = set3;
      return Currency_Symbol;
    }
    var Dash_Punctuation = {};
    var hasRequiredDash_Punctuation;
    function requireDash_Punctuation() {
      if (hasRequiredDash_Punctuation)
        return Dash_Punctuation;
      hasRequiredDash_Punctuation = 1;
      var set3 = regenerate$2.exports(45, 1418, 1470, 5120, 6150, 11799, 11802, 11840, 11869, 12316, 12336, 12448, 65112, 65123, 65293, 69293);
      set3.addRange(8208, 8213).addRange(11834, 11835).addRange(65073, 65074);
      Dash_Punctuation.characters = set3;
      return Dash_Punctuation;
    }
    var Decimal_Number = {};
    var hasRequiredDecimal_Number;
    function requireDecimal_Number() {
      if (hasRequiredDecimal_Number)
        return Decimal_Number;
      hasRequiredDecimal_Number = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(48, 57).addRange(1632, 1641).addRange(1776, 1785).addRange(1984, 1993).addRange(2406, 2415).addRange(2534, 2543).addRange(2662, 2671).addRange(2790, 2799).addRange(2918, 2927).addRange(3046, 3055).addRange(3174, 3183).addRange(3302, 3311).addRange(3430, 3439).addRange(3558, 3567).addRange(3664, 3673).addRange(3792, 3801).addRange(3872, 3881).addRange(4160, 4169).addRange(4240, 4249).addRange(6112, 6121).addRange(6160, 6169).addRange(6470, 6479).addRange(6608, 6617).addRange(6784, 6793).addRange(6800, 6809).addRange(6992, 7001).addRange(7088, 7097).addRange(7232, 7241).addRange(7248, 7257).addRange(42528, 42537).addRange(43216, 43225).addRange(43264, 43273).addRange(43472, 43481).addRange(43504, 43513).addRange(43600, 43609).addRange(44016, 44025).addRange(65296, 65305).addRange(66720, 66729).addRange(68912, 68921).addRange(69734, 69743).addRange(69872, 69881).addRange(69942, 69951).addRange(70096, 70105).addRange(70384, 70393).addRange(70736, 70745).addRange(70864, 70873).addRange(71248, 71257).addRange(71360, 71369).addRange(71472, 71481).addRange(71904, 71913).addRange(72016, 72025);
      set3.addRange(72784, 72793).addRange(73040, 73049).addRange(73120, 73129).addRange(92768, 92777).addRange(92864, 92873).addRange(93008, 93017).addRange(120782, 120831).addRange(123200, 123209).addRange(123632, 123641).addRange(125264, 125273).addRange(130032, 130041);
      Decimal_Number.characters = set3;
      return Decimal_Number;
    }
    var Enclosing_Mark = {};
    var hasRequiredEnclosing_Mark;
    function requireEnclosing_Mark() {
      if (hasRequiredEnclosing_Mark)
        return Enclosing_Mark;
      hasRequiredEnclosing_Mark = 1;
      var set3 = regenerate$2.exports(6846);
      set3.addRange(1160, 1161).addRange(8413, 8416).addRange(8418, 8420).addRange(42608, 42610);
      Enclosing_Mark.characters = set3;
      return Enclosing_Mark;
    }
    var Final_Punctuation = {};
    var hasRequiredFinal_Punctuation;
    function requireFinal_Punctuation() {
      if (hasRequiredFinal_Punctuation)
        return Final_Punctuation;
      hasRequiredFinal_Punctuation = 1;
      var set3 = regenerate$2.exports(187, 8217, 8221, 8250, 11779, 11781, 11786, 11789, 11805, 11809);
      Final_Punctuation.characters = set3;
      return Final_Punctuation;
    }
    var Format = {};
    var hasRequiredFormat;
    function requireFormat() {
      if (hasRequiredFormat)
        return Format;
      hasRequiredFormat = 1;
      var set3 = regenerate$2.exports(173, 1564, 1757, 1807, 2274, 6158, 65279, 69821, 69837, 917505);
      set3.addRange(1536, 1541).addRange(2192, 2193).addRange(8203, 8207).addRange(8234, 8238).addRange(8288, 8292).addRange(8294, 8303).addRange(65529, 65531).addRange(78896, 78904).addRange(113824, 113827).addRange(119155, 119162).addRange(917536, 917631);
      Format.characters = set3;
      return Format;
    }
    var Initial_Punctuation = {};
    var hasRequiredInitial_Punctuation;
    function requireInitial_Punctuation() {
      if (hasRequiredInitial_Punctuation)
        return Initial_Punctuation;
      hasRequiredInitial_Punctuation = 1;
      var set3 = regenerate$2.exports(171, 8216, 8223, 8249, 11778, 11780, 11785, 11788, 11804, 11808);
      set3.addRange(8219, 8220);
      Initial_Punctuation.characters = set3;
      return Initial_Punctuation;
    }
    var Letter_Number = {};
    var hasRequiredLetter_Number;
    function requireLetter_Number() {
      if (hasRequiredLetter_Number)
        return Letter_Number;
      hasRequiredLetter_Number = 1;
      var set3 = regenerate$2.exports(12295, 66369, 66378);
      set3.addRange(5870, 5872).addRange(8544, 8578).addRange(8581, 8584).addRange(12321, 12329).addRange(12344, 12346).addRange(42726, 42735).addRange(65856, 65908).addRange(66513, 66517).addRange(74752, 74862);
      Letter_Number.characters = set3;
      return Letter_Number;
    }
    var Letter = {};
    var hasRequiredLetter;
    function requireLetter() {
      if (hasRequiredLetter)
        return Letter;
      hasRequiredLetter = 1;
      var set3 = regenerate$2.exports(170, 181, 186, 748, 750, 895, 902, 908, 1369, 1749, 1791, 1808, 1969, 2042, 2074, 2084, 2088, 2365, 2384, 2482, 2493, 2510, 2556, 2654, 2749, 2768, 2809, 2877, 2929, 2947, 2972, 3024, 3133, 3165, 3200, 3261, 3389, 3406, 3517, 3716, 3749, 3773, 3782, 3840, 4159, 4193, 4238, 4295, 4301, 4696, 4800, 6103, 6108, 6314, 6823, 7418, 8025, 8027, 8029, 8126, 8305, 8319, 8450, 8455, 8469, 8484, 8486, 8488, 8526, 11559, 11565, 11631, 11823, 42963, 43259, 43471, 43642, 43697, 43712, 43714, 64285, 64318, 67592, 67644, 68096, 69415, 69749, 69956, 69959, 70006, 70106, 70108, 70280, 70461, 70480, 70855, 71236, 71352, 71945, 71999, 72001, 72161, 72163, 72192, 72250, 72272, 72349, 72768, 73030, 73112, 73648, 94032, 94179, 119970, 119995, 120134, 123214, 125259, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 705).addRange(710, 721).addRange(736, 740).addRange(880, 884).addRange(886, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 1013).addRange(1015, 1153).addRange(1162, 1327).addRange(1329, 1366).addRange(1376, 1416).addRange(1488, 1514).addRange(1519, 1522).addRange(1568, 1610).addRange(1646, 1647).addRange(1649, 1747).addRange(1765, 1766).addRange(1774, 1775).addRange(1786, 1788).addRange(1810, 1839).addRange(1869, 1957).addRange(1994, 2026).addRange(2036, 2037).addRange(2048, 2069).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2208, 2249).addRange(2308, 2361).addRange(2392, 2401).addRange(2417, 2432).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2524, 2525).addRange(2527, 2529).addRange(2544, 2545).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611);
      set3.addRange(2613, 2614).addRange(2616, 2617).addRange(2649, 2652).addRange(2674, 2676).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2784, 2785).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2908, 2909).addRange(2911, 2913).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3160, 3162).addRange(3168, 3169).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3293, 3294).addRange(3296, 3297).addRange(3313, 3314).addRange(3332, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3412, 3414).addRange(3423, 3425).addRange(3450, 3455).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526);
      set3.addRange(3585, 3632).addRange(3634, 3635).addRange(3648, 3654).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3760).addRange(3762, 3763).addRange(3776, 3780).addRange(3804, 3807).addRange(3904, 3911).addRange(3913, 3948).addRange(3976, 3980).addRange(4096, 4138).addRange(4176, 4181).addRange(4186, 4189).addRange(4197, 4198).addRange(4206, 4208).addRange(4213, 4225).addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4992, 5007).addRange(5024, 5109).addRange(5112, 5117).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5873, 5880).addRange(5888, 5905).addRange(5919, 5937).addRange(5952, 5969).addRange(5984, 5996).addRange(5998, 6e3).addRange(6016, 6067).addRange(6176, 6264).addRange(6272, 6276);
      set3.addRange(6279, 6312).addRange(6320, 6389).addRange(6400, 6430).addRange(6480, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6656, 6678).addRange(6688, 6740).addRange(6917, 6963).addRange(6981, 6988).addRange(7043, 7072).addRange(7086, 7087).addRange(7098, 7141).addRange(7168, 7203).addRange(7245, 7247).addRange(7258, 7293).addRange(7296, 7304).addRange(7312, 7354).addRange(7357, 7359).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7414).addRange(7424, 7615).addRange(7680, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8124).addRange(8130, 8132).addRange(8134, 8140).addRange(8144, 8147).addRange(8150, 8155).addRange(8160, 8172).addRange(8178, 8180).addRange(8182, 8188).addRange(8336, 8348).addRange(8458, 8467).addRange(8473, 8477).addRange(8490, 8493).addRange(8495, 8505).addRange(8508, 8511).addRange(8517, 8521).addRange(8579, 8580).addRange(11264, 11492).addRange(11499, 11502).addRange(11506, 11507).addRange(11520, 11557);
      set3.addRange(11568, 11623).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(12293, 12294).addRange(12337, 12341).addRange(12347, 12348).addRange(12353, 12438).addRange(12445, 12447).addRange(12449, 12538).addRange(12540, 12543).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 42124).addRange(42192, 42237).addRange(42240, 42508).addRange(42512, 42527).addRange(42538, 42539).addRange(42560, 42606).addRange(42623, 42653).addRange(42656, 42725).addRange(42775, 42783).addRange(42786, 42888).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43009).addRange(43011, 43013).addRange(43015, 43018).addRange(43020, 43042).addRange(43072, 43123).addRange(43138, 43187).addRange(43250, 43255).addRange(43261, 43262).addRange(43274, 43301).addRange(43312, 43334).addRange(43360, 43388).addRange(43396, 43442).addRange(43488, 43492).addRange(43494, 43503).addRange(43514, 43518).addRange(43520, 43560);
      set3.addRange(43584, 43586).addRange(43588, 43595).addRange(43616, 43638).addRange(43646, 43695).addRange(43701, 43702).addRange(43705, 43709).addRange(43739, 43741).addRange(43744, 43754).addRange(43762, 43764).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43824, 43866).addRange(43868, 43881).addRange(43888, 44002).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64256, 64262).addRange(64275, 64279).addRange(64287, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65019).addRange(65136, 65140).addRange(65142, 65276).addRange(65313, 65338).addRange(65345, 65370).addRange(65382, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(66176, 66204);
      set3.addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66368).addRange(66370, 66377).addRange(66384, 66421).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66560, 66717).addRange(66736, 66771).addRange(66776, 66811).addRange(66816, 66855).addRange(66864, 66915).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023).addRange(68030, 68031).addRange(68112, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68324).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680);
      set3.addRange(68736, 68786).addRange(68800, 68850).addRange(68864, 68899).addRange(69248, 69289).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69445).addRange(69488, 69505).addRange(69552, 69572).addRange(69600, 69622).addRange(69635, 69687).addRange(69745, 69746).addRange(69763, 69807).addRange(69840, 69864).addRange(69891, 69926).addRange(69968, 70002).addRange(70019, 70066).addRange(70081, 70084).addRange(70144, 70161).addRange(70163, 70187).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70366).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70493, 70497).addRange(70656, 70708).addRange(70727, 70730).addRange(70751, 70753).addRange(70784, 70831).addRange(70852, 70853).addRange(71040, 71086).addRange(71128, 71131).addRange(71168, 71215).addRange(71296, 71338).addRange(71424, 71450).addRange(71488, 71494).addRange(71680, 71723).addRange(71840, 71903).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71983).addRange(72096, 72103).addRange(72106, 72144);
      set3.addRange(72203, 72242).addRange(72284, 72329).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72750).addRange(72818, 72847).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73008).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73097).addRange(73440, 73458).addRange(73728, 74649).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92784, 92862).addRange(92880, 92909).addRange(92928, 92975).addRange(92992, 92995).addRange(93027, 93047).addRange(93053, 93071).addRange(93760, 93823).addRange(93952, 94026).addRange(94099, 94111).addRange(94176, 94177).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110592, 110882).addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003);
      set3.addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120512).addRange(120514, 120538).addRange(120540, 120570).addRange(120572, 120596).addRange(120598, 120628).addRange(120630, 120654).addRange(120656, 120686).addRange(120688, 120712).addRange(120714, 120744).addRange(120746, 120770).addRange(120772, 120779).addRange(122624, 122654).addRange(123136, 123180).addRange(123191, 123197).addRange(123536, 123565).addRange(123584, 123627).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(125184, 125251).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205);
      set3.addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Letter.characters = set3;
      return Letter;
    }
    var Line_Separator = {};
    var hasRequiredLine_Separator;
    function requireLine_Separator() {
      if (hasRequiredLine_Separator)
        return Line_Separator;
      hasRequiredLine_Separator = 1;
      var set3 = regenerate$2.exports(8232);
      Line_Separator.characters = set3;
      return Line_Separator;
    }
    var Lowercase_Letter = {};
    var hasRequiredLowercase_Letter;
    function requireLowercase_Letter() {
      if (hasRequiredLowercase_Letter)
        return Lowercase_Letter;
      hasRequiredLowercase_Letter = 1;
      var set3 = regenerate$2.exports(181, 257, 259, 261, 263, 265, 267, 269, 271, 273, 275, 277, 279, 281, 283, 285, 287, 289, 291, 293, 295, 297, 299, 301, 303, 305, 307, 309, 314, 316, 318, 320, 322, 324, 326, 331, 333, 335, 337, 339, 341, 343, 345, 347, 349, 351, 353, 355, 357, 359, 361, 363, 365, 367, 369, 371, 373, 375, 378, 380, 387, 389, 392, 402, 405, 414, 417, 419, 421, 424, 429, 432, 436, 438, 454, 457, 460, 462, 464, 466, 468, 470, 472, 474, 479, 481, 483, 485, 487, 489, 491, 493, 499, 501, 505, 507, 509, 511, 513, 515, 517, 519, 521, 523, 525, 527, 529, 531, 533, 535, 537, 539, 541, 543, 545, 547, 549, 551, 553, 555, 557, 559, 561, 572, 578, 583, 585, 587, 589, 881, 883, 887, 912, 985, 987, 989, 991, 993, 995, 997, 999, 1001, 1003, 1005, 1013, 1016, 1121, 1123, 1125, 1127, 1129, 1131, 1133, 1135, 1137, 1139, 1141, 1143, 1145, 1147, 1149, 1151, 1153, 1163, 1165, 1167, 1169, 1171, 1173, 1175, 1177, 1179, 1181, 1183, 1185, 1187, 1189, 1191, 1193, 1195, 1197, 1199, 1201, 1203, 1205, 1207, 1209, 1211, 1213, 1215, 1218, 1220, 1222, 1224, 1226, 1228, 1233, 1235, 1237, 1239, 1241, 1243, 1245, 1247, 1249, 1251, 1253, 1255, 1257, 1259, 1261, 1263, 1265, 1267, 1269, 1271, 1273, 1275, 1277, 1279, 1281, 1283, 1285, 1287, 1289, 1291, 1293, 1295, 1297, 1299, 1301, 1303, 1305, 1307, 1309, 1311, 1313, 1315, 1317, 1319, 1321, 1323, 1325, 1327, 7681, 7683, 7685, 7687, 7689, 7691, 7693, 7695, 7697, 7699, 7701, 7703, 7705, 7707, 7709, 7711, 7713, 7715, 7717, 7719, 7721, 7723, 7725, 7727, 7729, 7731, 7733, 7735, 7737, 7739, 7741, 7743, 7745, 7747, 7749, 7751, 7753, 7755, 7757, 7759, 7761, 7763, 7765, 7767, 7769, 7771, 7773, 7775, 7777, 7779, 7781, 7783, 7785, 7787, 7789, 7791, 7793, 7795, 7797, 7799, 7801, 7803, 7805, 7807, 7809, 7811, 7813, 7815, 7817, 7819, 7821, 7823, 7825, 7827, 7839, 7841, 7843, 7845, 7847, 7849, 7851, 7853, 7855, 7857, 7859, 7861, 7863, 7865, 7867, 7869, 7871, 7873, 7875, 7877, 7879, 7881, 7883, 7885, 7887, 7889, 7891, 7893, 7895, 7897, 7899, 7901, 7903, 7905, 7907, 7909, 7911, 7913, 7915, 7917, 7919, 7921, 7923, 7925, 7927, 7929, 7931, 7933, 8126, 8458, 8467, 8495, 8500, 8505, 8526, 8580, 11361, 11368, 11370, 11372, 11377, 11393, 11395, 11397, 11399, 11401, 11403, 11405, 11407, 11409, 11411, 11413, 11415, 11417, 11419, 11421, 11423, 11425, 11427, 11429, 11431, 11433, 11435, 11437, 11439, 11441, 11443, 11445, 11447, 11449, 11451, 11453, 11455, 11457, 11459, 11461, 11463, 11465, 11467, 11469, 11471, 11473, 11475, 11477, 11479, 11481, 11483, 11485, 11487, 11489, 11500, 11502, 11507, 11559, 11565, 42561, 42563, 42565, 42567, 42569, 42571, 42573, 42575, 42577, 42579, 42581, 42583, 42585, 42587, 42589, 42591, 42593, 42595, 42597, 42599, 42601, 42603, 42605, 42625, 42627, 42629, 42631, 42633, 42635, 42637, 42639, 42641, 42643, 42645, 42647, 42649, 42651, 42787, 42789, 42791, 42793, 42795, 42797, 42803, 42805, 42807, 42809, 42811, 42813, 42815, 42817, 42819, 42821, 42823, 42825, 42827, 42829, 42831, 42833, 42835, 42837, 42839, 42841, 42843, 42845, 42847, 42849, 42851, 42853, 42855, 42857, 42859, 42861, 42863, 42874, 42876, 42879, 42881, 42883, 42885, 42887, 42892, 42894, 42897, 42903, 42905, 42907, 42909, 42911, 42913, 42915, 42917, 42919, 42921, 42927, 42933, 42935, 42937, 42939, 42941, 42943, 42945, 42947, 42952, 42954, 42961, 42963, 42965, 42967, 42969, 42998, 43002, 119995, 120779);
      set3.addRange(97, 122).addRange(223, 246).addRange(248, 255).addRange(311, 312).addRange(328, 329).addRange(382, 384).addRange(396, 397).addRange(409, 411).addRange(426, 427).addRange(441, 442).addRange(445, 447).addRange(476, 477).addRange(495, 496).addRange(563, 569).addRange(575, 576).addRange(591, 659).addRange(661, 687).addRange(891, 893).addRange(940, 974).addRange(976, 977).addRange(981, 983).addRange(1007, 1011).addRange(1019, 1020).addRange(1072, 1119).addRange(1230, 1231).addRange(1376, 1416).addRange(4304, 4346).addRange(4349, 4351).addRange(5112, 5117).addRange(7296, 7304).addRange(7424, 7467).addRange(7531, 7543).addRange(7545, 7578).addRange(7829, 7837).addRange(7935, 7943).addRange(7952, 7957).addRange(7968, 7975).addRange(7984, 7991).addRange(8e3, 8005).addRange(8016, 8023).addRange(8032, 8039).addRange(8048, 8061).addRange(8064, 8071).addRange(8080, 8087).addRange(8096, 8103).addRange(8112, 8116).addRange(8118, 8119).addRange(8130, 8132).addRange(8134, 8135).addRange(8144, 8147).addRange(8150, 8151);
      set3.addRange(8160, 8167).addRange(8178, 8180).addRange(8182, 8183).addRange(8462, 8463).addRange(8508, 8509).addRange(8518, 8521).addRange(11312, 11359).addRange(11365, 11366).addRange(11379, 11380).addRange(11382, 11387).addRange(11491, 11492).addRange(11520, 11557).addRange(42799, 42801).addRange(42865, 42872).addRange(42899, 42901).addRange(43824, 43866).addRange(43872, 43880).addRange(43888, 43967).addRange(64256, 64262).addRange(64275, 64279).addRange(65345, 65370).addRange(66600, 66639).addRange(66776, 66811).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004).addRange(68800, 68850).addRange(71872, 71903).addRange(93792, 93823).addRange(119834, 119859).addRange(119886, 119892).addRange(119894, 119911).addRange(119938, 119963).addRange(119990, 119993).addRange(119997, 120003).addRange(120005, 120015).addRange(120042, 120067).addRange(120094, 120119).addRange(120146, 120171).addRange(120198, 120223).addRange(120250, 120275).addRange(120302, 120327).addRange(120354, 120379).addRange(120406, 120431).addRange(120458, 120485).addRange(120514, 120538).addRange(120540, 120545).addRange(120572, 120596).addRange(120598, 120603).addRange(120630, 120654);
      set3.addRange(120656, 120661).addRange(120688, 120712).addRange(120714, 120719).addRange(120746, 120770).addRange(120772, 120777).addRange(122624, 122633).addRange(122635, 122654).addRange(125218, 125251);
      Lowercase_Letter.characters = set3;
      return Lowercase_Letter;
    }
    var Mark = {};
    var hasRequiredMark;
    function requireMark() {
      if (hasRequiredMark)
        return Mark;
      hasRequiredMark = 1;
      var set3 = regenerate$2.exports(1471, 1479, 1648, 1809, 2045, 2492, 2519, 2558, 2620, 2641, 2677, 2748, 2876, 2946, 3031, 3132, 3260, 3415, 3530, 3542, 3633, 3761, 3893, 3895, 3897, 4038, 4239, 6109, 6159, 6313, 6783, 7405, 7412, 11647, 43010, 43014, 43019, 43052, 43263, 43493, 43587, 43696, 43713, 64286, 66045, 66272, 68159, 69744, 69826, 70003, 70206, 70487, 70750, 72e3, 72164, 72263, 73018, 73031, 94031, 94180, 121461, 121476, 123566);
      set3.addRange(768, 879).addRange(1155, 1161).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1552, 1562).addRange(1611, 1631).addRange(1750, 1756).addRange(1759, 1764).addRange(1767, 1768).addRange(1770, 1773).addRange(1840, 1866).addRange(1958, 1968).addRange(2027, 2035).addRange(2070, 2073).addRange(2075, 2083).addRange(2085, 2087).addRange(2089, 2093).addRange(2137, 2139).addRange(2200, 2207).addRange(2250, 2273).addRange(2275, 2307).addRange(2362, 2364).addRange(2366, 2383).addRange(2385, 2391).addRange(2402, 2403).addRange(2433, 2435).addRange(2494, 2500).addRange(2503, 2504).addRange(2507, 2509).addRange(2530, 2531).addRange(2561, 2563).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2672, 2673).addRange(2689, 2691).addRange(2750, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2786, 2787).addRange(2810, 2815).addRange(2817, 2819).addRange(2878, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2914, 2915).addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021);
      set3.addRange(3072, 3076).addRange(3134, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3170, 3171).addRange(3201, 3203).addRange(3262, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3298, 3299).addRange(3328, 3331).addRange(3387, 3388).addRange(3390, 3396).addRange(3398, 3400).addRange(3402, 3405).addRange(3426, 3427).addRange(3457, 3459).addRange(3535, 3540).addRange(3544, 3551).addRange(3570, 3571).addRange(3636, 3642).addRange(3655, 3662).addRange(3764, 3772).addRange(3784, 3789).addRange(3864, 3865).addRange(3902, 3903).addRange(3953, 3972).addRange(3974, 3975).addRange(3981, 3991).addRange(3993, 4028).addRange(4139, 4158).addRange(4182, 4185).addRange(4190, 4192).addRange(4194, 4196).addRange(4199, 4205).addRange(4209, 4212).addRange(4226, 4237).addRange(4250, 4253).addRange(4957, 4959).addRange(5906, 5909).addRange(5938, 5940).addRange(5970, 5971).addRange(6002, 6003).addRange(6068, 6099).addRange(6155, 6157).addRange(6277, 6278).addRange(6432, 6443).addRange(6448, 6459).addRange(6679, 6683);
      set3.addRange(6741, 6750).addRange(6752, 6780).addRange(6832, 6862).addRange(6912, 6916).addRange(6964, 6980).addRange(7019, 7027).addRange(7040, 7042).addRange(7073, 7085).addRange(7142, 7155).addRange(7204, 7223).addRange(7376, 7378).addRange(7380, 7400).addRange(7415, 7417).addRange(7616, 7679).addRange(8400, 8432).addRange(11503, 11505).addRange(11744, 11775).addRange(12330, 12335).addRange(12441, 12442).addRange(42607, 42610).addRange(42612, 42621).addRange(42654, 42655).addRange(42736, 42737).addRange(43043, 43047).addRange(43136, 43137).addRange(43188, 43205).addRange(43232, 43249).addRange(43302, 43309).addRange(43335, 43347).addRange(43392, 43395).addRange(43443, 43456).addRange(43561, 43574).addRange(43596, 43597).addRange(43643, 43645).addRange(43698, 43700).addRange(43703, 43704).addRange(43710, 43711).addRange(43755, 43759).addRange(43765, 43766).addRange(44003, 44010).addRange(44012, 44013).addRange(65024, 65039).addRange(65056, 65071).addRange(66422, 66426).addRange(68097, 68099).addRange(68101, 68102).addRange(68108, 68111).addRange(68152, 68154).addRange(68325, 68326).addRange(68900, 68903).addRange(69291, 69292);
      set3.addRange(69446, 69456).addRange(69506, 69509).addRange(69632, 69634).addRange(69688, 69702).addRange(69747, 69748).addRange(69759, 69762).addRange(69808, 69818).addRange(69888, 69890).addRange(69927, 69940).addRange(69957, 69958).addRange(70016, 70018).addRange(70067, 70080).addRange(70089, 70092).addRange(70094, 70095).addRange(70188, 70199).addRange(70367, 70378).addRange(70400, 70403).addRange(70459, 70460).addRange(70462, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70498, 70499).addRange(70502, 70508).addRange(70512, 70516).addRange(70709, 70726).addRange(70832, 70851).addRange(71087, 71093).addRange(71096, 71104).addRange(71132, 71133).addRange(71216, 71232).addRange(71339, 71351).addRange(71453, 71467).addRange(71724, 71738).addRange(71984, 71989).addRange(71991, 71992).addRange(71995, 71998).addRange(72002, 72003).addRange(72145, 72151).addRange(72154, 72160).addRange(72193, 72202).addRange(72243, 72249).addRange(72251, 72254).addRange(72273, 72283).addRange(72330, 72345).addRange(72751, 72758).addRange(72760, 72767).addRange(72850, 72871).addRange(72873, 72886).addRange(73009, 73014).addRange(73020, 73021).addRange(73023, 73029);
      set3.addRange(73098, 73102).addRange(73104, 73105).addRange(73107, 73111).addRange(73459, 73462).addRange(92912, 92916).addRange(92976, 92982).addRange(94033, 94087).addRange(94095, 94098).addRange(94192, 94193).addRange(113821, 113822).addRange(118528, 118573).addRange(118576, 118598).addRange(119141, 119145).addRange(119149, 119154).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123184, 123190).addRange(123628, 123631).addRange(125136, 125142).addRange(125252, 125258).addRange(917760, 917999);
      Mark.characters = set3;
      return Mark;
    }
    var Math_Symbol = {};
    var hasRequiredMath_Symbol;
    function requireMath_Symbol() {
      if (hasRequiredMath_Symbol)
        return Math_Symbol;
      hasRequiredMath_Symbol = 1;
      var set3 = regenerate$2.exports(43, 124, 126, 172, 177, 215, 247, 1014, 8260, 8274, 8472, 8523, 8608, 8611, 8614, 8622, 8658, 8660, 9084, 9655, 9665, 9839, 64297, 65122, 65291, 65372, 65374, 65506, 120513, 120539, 120571, 120597, 120629, 120655, 120687, 120713, 120745, 120771);
      set3.addRange(60, 62).addRange(1542, 1544).addRange(8314, 8316).addRange(8330, 8332).addRange(8512, 8516).addRange(8592, 8596).addRange(8602, 8603).addRange(8654, 8655).addRange(8692, 8959).addRange(8992, 8993).addRange(9115, 9139).addRange(9180, 9185).addRange(9720, 9727).addRange(10176, 10180).addRange(10183, 10213).addRange(10224, 10239).addRange(10496, 10626).addRange(10649, 10711).addRange(10716, 10747).addRange(10750, 11007).addRange(11056, 11076).addRange(11079, 11084).addRange(65124, 65126).addRange(65308, 65310).addRange(65513, 65516).addRange(126704, 126705);
      Math_Symbol.characters = set3;
      return Math_Symbol;
    }
    var Modifier_Letter = {};
    var hasRequiredModifier_Letter;
    function requireModifier_Letter() {
      if (hasRequiredModifier_Letter)
        return Modifier_Letter;
      hasRequiredModifier_Letter = 1;
      var set3 = regenerate$2.exports(748, 750, 884, 890, 1369, 1600, 2042, 2074, 2084, 2088, 2249, 2417, 3654, 3782, 4348, 6103, 6211, 6823, 7544, 8305, 8319, 11631, 11823, 12293, 12347, 40981, 42508, 42623, 42864, 42888, 43471, 43494, 43632, 43741, 43881, 65392, 94179, 125259);
      set3.addRange(688, 705).addRange(710, 721).addRange(736, 740).addRange(1765, 1766).addRange(2036, 2037).addRange(7288, 7293).addRange(7468, 7530).addRange(7579, 7615).addRange(8336, 8348).addRange(11388, 11389).addRange(12337, 12341).addRange(12445, 12446).addRange(12540, 12542).addRange(42232, 42237).addRange(42652, 42653).addRange(42775, 42783).addRange(42994, 42996).addRange(43e3, 43001).addRange(43763, 43764).addRange(43868, 43871).addRange(65438, 65439).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(92992, 92995).addRange(94099, 94111).addRange(94176, 94177).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(123191, 123197);
      Modifier_Letter.characters = set3;
      return Modifier_Letter;
    }
    var Modifier_Symbol = {};
    var hasRequiredModifier_Symbol;
    function requireModifier_Symbol() {
      if (hasRequiredModifier_Symbol)
        return Modifier_Symbol;
      hasRequiredModifier_Symbol = 1;
      var set3 = regenerate$2.exports(94, 96, 168, 175, 180, 184, 749, 885, 2184, 8125, 43867, 65342, 65344, 65507);
      set3.addRange(706, 709).addRange(722, 735).addRange(741, 747).addRange(751, 767).addRange(900, 901).addRange(8127, 8129).addRange(8141, 8143).addRange(8157, 8159).addRange(8173, 8175).addRange(8189, 8190).addRange(12443, 12444).addRange(42752, 42774).addRange(42784, 42785).addRange(42889, 42890).addRange(43882, 43883).addRange(64434, 64450).addRange(127995, 127999);
      Modifier_Symbol.characters = set3;
      return Modifier_Symbol;
    }
    var Nonspacing_Mark = {};
    var hasRequiredNonspacing_Mark;
    function requireNonspacing_Mark() {
      if (hasRequiredNonspacing_Mark)
        return Nonspacing_Mark;
      hasRequiredNonspacing_Mark = 1;
      var set3 = regenerate$2.exports(1471, 1479, 1648, 1809, 2045, 2362, 2364, 2381, 2433, 2492, 2509, 2558, 2620, 2641, 2677, 2748, 2765, 2817, 2876, 2879, 2893, 2946, 3008, 3021, 3072, 3076, 3132, 3201, 3260, 3263, 3270, 3405, 3457, 3530, 3542, 3633, 3761, 3893, 3895, 3897, 4038, 4226, 4237, 4253, 6086, 6109, 6159, 6313, 6450, 6683, 6742, 6752, 6754, 6783, 6964, 6972, 6978, 7142, 7149, 7405, 7412, 8417, 11647, 42607, 43010, 43014, 43019, 43052, 43263, 43443, 43493, 43587, 43596, 43644, 43696, 43713, 43766, 44005, 44008, 44013, 64286, 66045, 66272, 68159, 69633, 69744, 69826, 70003, 70095, 70196, 70206, 70367, 70464, 70726, 70750, 70842, 71229, 71339, 71341, 71351, 71998, 72003, 72160, 72263, 72767, 73018, 73031, 73109, 73111, 94031, 94180, 121461, 121476, 123566);
      set3.addRange(768, 879).addRange(1155, 1159).addRange(1425, 1469).addRange(1473, 1474).addRange(1476, 1477).addRange(1552, 1562).addRange(1611, 1631).addRange(1750, 1756).addRange(1759, 1764).addRange(1767, 1768).addRange(1770, 1773).addRange(1840, 1866).addRange(1958, 1968).addRange(2027, 2035).addRange(2070, 2073).addRange(2075, 2083).addRange(2085, 2087).addRange(2089, 2093).addRange(2137, 2139).addRange(2200, 2207).addRange(2250, 2273).addRange(2275, 2306).addRange(2369, 2376).addRange(2385, 2391).addRange(2402, 2403).addRange(2497, 2500).addRange(2530, 2531).addRange(2561, 2562).addRange(2625, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2672, 2673).addRange(2689, 2690).addRange(2753, 2757).addRange(2759, 2760).addRange(2786, 2787).addRange(2810, 2815).addRange(2881, 2884).addRange(2901, 2902).addRange(2914, 2915).addRange(3134, 3136).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3170, 3171).addRange(3276, 3277).addRange(3298, 3299).addRange(3328, 3329).addRange(3387, 3388).addRange(3393, 3396).addRange(3426, 3427);
      set3.addRange(3538, 3540).addRange(3636, 3642).addRange(3655, 3662).addRange(3764, 3772).addRange(3784, 3789).addRange(3864, 3865).addRange(3953, 3966).addRange(3968, 3972).addRange(3974, 3975).addRange(3981, 3991).addRange(3993, 4028).addRange(4141, 4144).addRange(4146, 4151).addRange(4153, 4154).addRange(4157, 4158).addRange(4184, 4185).addRange(4190, 4192).addRange(4209, 4212).addRange(4229, 4230).addRange(4957, 4959).addRange(5906, 5908).addRange(5938, 5939).addRange(5970, 5971).addRange(6002, 6003).addRange(6068, 6069).addRange(6071, 6077).addRange(6089, 6099).addRange(6155, 6157).addRange(6277, 6278).addRange(6432, 6434).addRange(6439, 6440).addRange(6457, 6459).addRange(6679, 6680).addRange(6744, 6750).addRange(6757, 6764).addRange(6771, 6780).addRange(6832, 6845).addRange(6847, 6862).addRange(6912, 6915).addRange(6966, 6970).addRange(7019, 7027).addRange(7040, 7041).addRange(7074, 7077).addRange(7080, 7081).addRange(7083, 7085).addRange(7144, 7145).addRange(7151, 7153).addRange(7212, 7219).addRange(7222, 7223).addRange(7376, 7378).addRange(7380, 7392);
      set3.addRange(7394, 7400).addRange(7416, 7417).addRange(7616, 7679).addRange(8400, 8412).addRange(8421, 8432).addRange(11503, 11505).addRange(11744, 11775).addRange(12330, 12333).addRange(12441, 12442).addRange(42612, 42621).addRange(42654, 42655).addRange(42736, 42737).addRange(43045, 43046).addRange(43204, 43205).addRange(43232, 43249).addRange(43302, 43309).addRange(43335, 43345).addRange(43392, 43394).addRange(43446, 43449).addRange(43452, 43453).addRange(43561, 43566).addRange(43569, 43570).addRange(43573, 43574).addRange(43698, 43700).addRange(43703, 43704).addRange(43710, 43711).addRange(43756, 43757).addRange(65024, 65039).addRange(65056, 65071).addRange(66422, 66426).addRange(68097, 68099).addRange(68101, 68102).addRange(68108, 68111).addRange(68152, 68154).addRange(68325, 68326).addRange(68900, 68903).addRange(69291, 69292).addRange(69446, 69456).addRange(69506, 69509).addRange(69688, 69702).addRange(69747, 69748).addRange(69759, 69761).addRange(69811, 69814).addRange(69817, 69818).addRange(69888, 69890).addRange(69927, 69931).addRange(69933, 69940).addRange(70016, 70017).addRange(70070, 70078).addRange(70089, 70092).addRange(70191, 70193);
      set3.addRange(70198, 70199).addRange(70371, 70378).addRange(70400, 70401).addRange(70459, 70460).addRange(70502, 70508).addRange(70512, 70516).addRange(70712, 70719).addRange(70722, 70724).addRange(70835, 70840).addRange(70847, 70848).addRange(70850, 70851).addRange(71090, 71093).addRange(71100, 71101).addRange(71103, 71104).addRange(71132, 71133).addRange(71219, 71226).addRange(71231, 71232).addRange(71344, 71349).addRange(71453, 71455).addRange(71458, 71461).addRange(71463, 71467).addRange(71727, 71735).addRange(71737, 71738).addRange(71995, 71996).addRange(72148, 72151).addRange(72154, 72155).addRange(72193, 72202).addRange(72243, 72248).addRange(72251, 72254).addRange(72273, 72278).addRange(72281, 72283).addRange(72330, 72342).addRange(72344, 72345).addRange(72752, 72758).addRange(72760, 72765).addRange(72850, 72871).addRange(72874, 72880).addRange(72882, 72883).addRange(72885, 72886).addRange(73009, 73014).addRange(73020, 73021).addRange(73023, 73029).addRange(73104, 73105).addRange(73459, 73460).addRange(92912, 92916).addRange(92976, 92982).addRange(94095, 94098).addRange(113821, 113822).addRange(118528, 118573).addRange(118576, 118598).addRange(119143, 119145);
      set3.addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(119362, 119364).addRange(121344, 121398).addRange(121403, 121452).addRange(121499, 121503).addRange(121505, 121519).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922).addRange(123184, 123190).addRange(123628, 123631).addRange(125136, 125142).addRange(125252, 125258).addRange(917760, 917999);
      Nonspacing_Mark.characters = set3;
      return Nonspacing_Mark;
    }
    var _Number = {};
    var hasRequired_Number;
    function require_Number() {
      if (hasRequired_Number)
        return _Number;
      hasRequired_Number = 1;
      var set3 = regenerate$2.exports(185, 8304, 11517, 12295, 66369, 66378);
      set3.addRange(48, 57).addRange(178, 179).addRange(188, 190).addRange(1632, 1641).addRange(1776, 1785).addRange(1984, 1993).addRange(2406, 2415).addRange(2534, 2543).addRange(2548, 2553).addRange(2662, 2671).addRange(2790, 2799).addRange(2918, 2927).addRange(2930, 2935).addRange(3046, 3058).addRange(3174, 3183).addRange(3192, 3198).addRange(3302, 3311).addRange(3416, 3422).addRange(3430, 3448).addRange(3558, 3567).addRange(3664, 3673).addRange(3792, 3801).addRange(3872, 3891).addRange(4160, 4169).addRange(4240, 4249).addRange(4969, 4988).addRange(5870, 5872).addRange(6112, 6121).addRange(6128, 6137).addRange(6160, 6169).addRange(6470, 6479).addRange(6608, 6618).addRange(6784, 6793).addRange(6800, 6809).addRange(6992, 7001).addRange(7088, 7097).addRange(7232, 7241).addRange(7248, 7257).addRange(8308, 8313).addRange(8320, 8329).addRange(8528, 8578).addRange(8581, 8585).addRange(9312, 9371).addRange(9450, 9471).addRange(10102, 10131).addRange(12321, 12329).addRange(12344, 12346).addRange(12690, 12693).addRange(12832, 12841).addRange(12872, 12879).addRange(12881, 12895);
      set3.addRange(12928, 12937).addRange(12977, 12991).addRange(42528, 42537).addRange(42726, 42735).addRange(43056, 43061).addRange(43216, 43225).addRange(43264, 43273).addRange(43472, 43481).addRange(43504, 43513).addRange(43600, 43609).addRange(44016, 44025).addRange(65296, 65305).addRange(65799, 65843).addRange(65856, 65912).addRange(65930, 65931).addRange(66273, 66299).addRange(66336, 66339).addRange(66513, 66517).addRange(66720, 66729).addRange(67672, 67679).addRange(67705, 67711).addRange(67751, 67759).addRange(67835, 67839).addRange(67862, 67867).addRange(68028, 68029).addRange(68032, 68047).addRange(68050, 68095).addRange(68160, 68168).addRange(68221, 68222).addRange(68253, 68255).addRange(68331, 68335).addRange(68440, 68447).addRange(68472, 68479).addRange(68521, 68527).addRange(68858, 68863).addRange(68912, 68921).addRange(69216, 69246).addRange(69405, 69414).addRange(69457, 69460).addRange(69573, 69579).addRange(69714, 69743).addRange(69872, 69881).addRange(69942, 69951).addRange(70096, 70105).addRange(70113, 70132).addRange(70384, 70393).addRange(70736, 70745).addRange(70864, 70873).addRange(71248, 71257).addRange(71360, 71369).addRange(71472, 71483);
      set3.addRange(71904, 71922).addRange(72016, 72025).addRange(72784, 72812).addRange(73040, 73049).addRange(73120, 73129).addRange(73664, 73684).addRange(74752, 74862).addRange(92768, 92777).addRange(92864, 92873).addRange(93008, 93017).addRange(93019, 93025).addRange(93824, 93846).addRange(119520, 119539).addRange(119648, 119672).addRange(120782, 120831).addRange(123200, 123209).addRange(123632, 123641).addRange(125127, 125135).addRange(125264, 125273).addRange(126065, 126123).addRange(126125, 126127).addRange(126129, 126132).addRange(126209, 126253).addRange(126255, 126269).addRange(127232, 127244).addRange(130032, 130041);
      _Number.characters = set3;
      return _Number;
    }
    var Open_Punctuation = {};
    var hasRequiredOpen_Punctuation;
    function requireOpen_Punctuation() {
      if (hasRequiredOpen_Punctuation)
        return Open_Punctuation;
      hasRequiredOpen_Punctuation = 1;
      var set3 = regenerate$2.exports(40, 91, 123, 3898, 3900, 5787, 8218, 8222, 8261, 8317, 8333, 8968, 8970, 9001, 10088, 10090, 10092, 10094, 10096, 10098, 10100, 10181, 10214, 10216, 10218, 10220, 10222, 10627, 10629, 10631, 10633, 10635, 10637, 10639, 10641, 10643, 10645, 10647, 10712, 10714, 10748, 11810, 11812, 11814, 11816, 11842, 11861, 11863, 11865, 11867, 12296, 12298, 12300, 12302, 12304, 12308, 12310, 12312, 12314, 12317, 64831, 65047, 65077, 65079, 65081, 65083, 65085, 65087, 65089, 65091, 65095, 65113, 65115, 65117, 65288, 65339, 65371, 65375, 65378);
      Open_Punctuation.characters = set3;
      return Open_Punctuation;
    }
    var Other_Letter = {};
    var hasRequiredOther_Letter;
    function requireOther_Letter() {
      if (hasRequiredOther_Letter)
        return Other_Letter;
      hasRequiredOther_Letter = 1;
      var set3 = regenerate$2.exports(170, 186, 443, 660, 1749, 1791, 1808, 1969, 2365, 2384, 2482, 2493, 2510, 2556, 2654, 2749, 2768, 2809, 2877, 2929, 2947, 2972, 3024, 3133, 3165, 3200, 3261, 3389, 3406, 3517, 3716, 3749, 3773, 3840, 4159, 4193, 4238, 4696, 4800, 6108, 6314, 7418, 12294, 12348, 12447, 12543, 42606, 42895, 42999, 43259, 43642, 43697, 43712, 43714, 43762, 64285, 64318, 67592, 67644, 68096, 69415, 69749, 69956, 69959, 70006, 70106, 70108, 70280, 70461, 70480, 70855, 71236, 71352, 71945, 71999, 72001, 72161, 72163, 72192, 72250, 72272, 72349, 72768, 73030, 73112, 73648, 94032, 122634, 123214, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(448, 451).addRange(1488, 1514).addRange(1519, 1522).addRange(1568, 1599).addRange(1601, 1610).addRange(1646, 1647).addRange(1649, 1747).addRange(1774, 1775).addRange(1786, 1788).addRange(1810, 1839).addRange(1869, 1957).addRange(1994, 2026).addRange(2048, 2069).addRange(2112, 2136).addRange(2144, 2154).addRange(2160, 2183).addRange(2185, 2190).addRange(2208, 2248).addRange(2308, 2361).addRange(2392, 2401).addRange(2418, 2432).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2524, 2525).addRange(2527, 2529).addRange(2544, 2545).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2649, 2652).addRange(2674, 2676).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2784, 2785).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873);
      set3.addRange(2908, 2909).addRange(2911, 2913).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3077, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3160, 3162).addRange(3168, 3169).addRange(3205, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3293, 3294).addRange(3296, 3297).addRange(3313, 3314).addRange(3332, 3340).addRange(3342, 3344).addRange(3346, 3386).addRange(3412, 3414).addRange(3423, 3425).addRange(3450, 3455).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3585, 3632).addRange(3634, 3635).addRange(3648, 3653).addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3760).addRange(3762, 3763).addRange(3776, 3780).addRange(3804, 3807).addRange(3904, 3911).addRange(3913, 3948).addRange(3976, 3980).addRange(4096, 4138).addRange(4176, 4181).addRange(4186, 4189).addRange(4197, 4198);
      set3.addRange(4206, 4208).addRange(4213, 4225).addRange(4352, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4992, 5007).addRange(5121, 5740).addRange(5743, 5759).addRange(5761, 5786).addRange(5792, 5866).addRange(5873, 5880).addRange(5888, 5905).addRange(5919, 5937).addRange(5952, 5969).addRange(5984, 5996).addRange(5998, 6e3).addRange(6016, 6067).addRange(6176, 6210).addRange(6212, 6264).addRange(6272, 6276).addRange(6279, 6312).addRange(6320, 6389).addRange(6400, 6430).addRange(6480, 6509).addRange(6512, 6516).addRange(6528, 6571).addRange(6576, 6601).addRange(6656, 6678).addRange(6688, 6740).addRange(6917, 6963).addRange(6981, 6988).addRange(7043, 7072).addRange(7086, 7087).addRange(7098, 7141).addRange(7168, 7203).addRange(7245, 7247).addRange(7258, 7287).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7414);
      set3.addRange(8501, 8504).addRange(11568, 11623).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(12353, 12438).addRange(12449, 12538).addRange(12549, 12591).addRange(12593, 12686).addRange(12704, 12735).addRange(12784, 12799).addRange(13312, 19903).addRange(19968, 40980).addRange(40982, 42124).addRange(42192, 42231).addRange(42240, 42507).addRange(42512, 42527).addRange(42538, 42539).addRange(42656, 42725).addRange(43003, 43009).addRange(43011, 43013).addRange(43015, 43018).addRange(43020, 43042).addRange(43072, 43123).addRange(43138, 43187).addRange(43250, 43255).addRange(43261, 43262).addRange(43274, 43301).addRange(43312, 43334).addRange(43360, 43388).addRange(43396, 43442).addRange(43488, 43492).addRange(43495, 43503).addRange(43514, 43518).addRange(43520, 43560).addRange(43584, 43586).addRange(43588, 43595).addRange(43616, 43631).addRange(43633, 43638).addRange(43646, 43695).addRange(43701, 43702).addRange(43705, 43709).addRange(43739, 43740).addRange(43744, 43754).addRange(43777, 43782);
      set3.addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(43968, 44002).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(63744, 64109).addRange(64112, 64217).addRange(64287, 64296).addRange(64298, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64433).addRange(64467, 64829).addRange(64848, 64911).addRange(64914, 64967).addRange(65008, 65019).addRange(65136, 65140).addRange(65142, 65276).addRange(65382, 65391).addRange(65393, 65437).addRange(65440, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500).addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(66176, 66204).addRange(66208, 66256).addRange(66304, 66335).addRange(66349, 66368).addRange(66370, 66377).addRange(66384, 66421).addRange(66432, 66461).addRange(66464, 66499).addRange(66504, 66511).addRange(66640, 66717).addRange(66816, 66855).addRange(66864, 66915).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431);
      set3.addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640).addRange(67647, 67669).addRange(67680, 67702).addRange(67712, 67742).addRange(67808, 67826).addRange(67828, 67829).addRange(67840, 67861).addRange(67872, 67897).addRange(67968, 68023).addRange(68030, 68031).addRange(68112, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68192, 68220).addRange(68224, 68252).addRange(68288, 68295).addRange(68297, 68324).addRange(68352, 68405).addRange(68416, 68437).addRange(68448, 68466).addRange(68480, 68497).addRange(68608, 68680).addRange(68864, 68899).addRange(69248, 69289).addRange(69296, 69297).addRange(69376, 69404).addRange(69424, 69445).addRange(69488, 69505).addRange(69552, 69572).addRange(69600, 69622).addRange(69635, 69687).addRange(69745, 69746).addRange(69763, 69807).addRange(69840, 69864).addRange(69891, 69926).addRange(69968, 70002).addRange(70019, 70066).addRange(70081, 70084).addRange(70144, 70161).addRange(70163, 70187).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70312).addRange(70320, 70366).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448);
      set3.addRange(70450, 70451).addRange(70453, 70457).addRange(70493, 70497).addRange(70656, 70708).addRange(70727, 70730).addRange(70751, 70753).addRange(70784, 70831).addRange(70852, 70853).addRange(71040, 71086).addRange(71128, 71131).addRange(71168, 71215).addRange(71296, 71338).addRange(71424, 71450).addRange(71488, 71494).addRange(71680, 71723).addRange(71935, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71983).addRange(72096, 72103).addRange(72106, 72144).addRange(72203, 72242).addRange(72284, 72329).addRange(72368, 72440).addRange(72704, 72712).addRange(72714, 72750).addRange(72818, 72847).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73008).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73097).addRange(73440, 73458).addRange(73728, 74649).addRange(74880, 75075).addRange(77712, 77808).addRange(77824, 78894).addRange(82944, 83526).addRange(92160, 92728).addRange(92736, 92766).addRange(92784, 92862).addRange(92880, 92909).addRange(92928, 92975).addRange(93027, 93047).addRange(93053, 93071).addRange(93952, 94026).addRange(94208, 100343).addRange(100352, 101589).addRange(101632, 101640).addRange(110592, 110882);
      set3.addRange(110928, 110930).addRange(110948, 110951).addRange(110960, 111355).addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(123136, 123180).addRange(123536, 123565).addRange(123584, 123627).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926).addRange(124928, 125124).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Other_Letter.characters = set3;
      return Other_Letter;
    }
    var Other_Number = {};
    var hasRequiredOther_Number;
    function requireOther_Number() {
      if (hasRequiredOther_Number)
        return Other_Number;
      hasRequiredOther_Number = 1;
      var set3 = regenerate$2.exports(185, 6618, 8304, 8585, 11517);
      set3.addRange(178, 179).addRange(188, 190).addRange(2548, 2553).addRange(2930, 2935).addRange(3056, 3058).addRange(3192, 3198).addRange(3416, 3422).addRange(3440, 3448).addRange(3882, 3891).addRange(4969, 4988).addRange(6128, 6137).addRange(8308, 8313).addRange(8320, 8329).addRange(8528, 8543).addRange(9312, 9371).addRange(9450, 9471).addRange(10102, 10131).addRange(12690, 12693).addRange(12832, 12841).addRange(12872, 12879).addRange(12881, 12895).addRange(12928, 12937).addRange(12977, 12991).addRange(43056, 43061).addRange(65799, 65843).addRange(65909, 65912).addRange(65930, 65931).addRange(66273, 66299).addRange(66336, 66339).addRange(67672, 67679).addRange(67705, 67711).addRange(67751, 67759).addRange(67835, 67839).addRange(67862, 67867).addRange(68028, 68029).addRange(68032, 68047).addRange(68050, 68095).addRange(68160, 68168).addRange(68221, 68222).addRange(68253, 68255).addRange(68331, 68335).addRange(68440, 68447).addRange(68472, 68479).addRange(68521, 68527).addRange(68858, 68863).addRange(69216, 69246).addRange(69405, 69414).addRange(69457, 69460).addRange(69573, 69579).addRange(69714, 69733).addRange(70113, 70132);
      set3.addRange(71482, 71483).addRange(71914, 71922).addRange(72794, 72812).addRange(73664, 73684).addRange(93019, 93025).addRange(93824, 93846).addRange(119520, 119539).addRange(119648, 119672).addRange(125127, 125135).addRange(126065, 126123).addRange(126125, 126127).addRange(126129, 126132).addRange(126209, 126253).addRange(126255, 126269).addRange(127232, 127244);
      Other_Number.characters = set3;
      return Other_Number;
    }
    var Other_Punctuation = {};
    var hasRequiredOther_Punctuation;
    function requireOther_Punctuation() {
      if (hasRequiredOther_Punctuation)
        return Other_Punctuation;
      hasRequiredOther_Punctuation = 1;
      var set3 = regenerate$2.exports(42, 44, 92, 161, 167, 191, 894, 903, 1417, 1472, 1475, 1478, 1563, 1748, 2142, 2416, 2557, 2678, 2800, 3191, 3204, 3572, 3663, 3860, 3973, 4347, 5742, 7379, 8275, 11632, 11787, 11803, 11841, 12349, 12539, 42611, 42622, 43260, 43359, 44011, 65049, 65072, 65128, 65290, 65292, 65340, 65377, 66463, 66512, 66927, 67671, 67871, 67903, 68223, 70093, 70107, 70313, 70749, 70854, 71353, 71739, 72162, 73727, 92917, 92996, 94178, 113823);
      set3.addRange(33, 35).addRange(37, 39).addRange(46, 47).addRange(58, 59).addRange(63, 64).addRange(182, 183).addRange(1370, 1375).addRange(1523, 1524).addRange(1545, 1546).addRange(1548, 1549).addRange(1565, 1567).addRange(1642, 1645).addRange(1792, 1805).addRange(2039, 2041).addRange(2096, 2110).addRange(2404, 2405).addRange(3674, 3675).addRange(3844, 3858).addRange(4048, 4052).addRange(4057, 4058).addRange(4170, 4175).addRange(4960, 4968).addRange(5867, 5869).addRange(5941, 5942).addRange(6100, 6102).addRange(6104, 6106).addRange(6144, 6149).addRange(6151, 6154).addRange(6468, 6469).addRange(6686, 6687).addRange(6816, 6822).addRange(6824, 6829).addRange(7002, 7008).addRange(7037, 7038).addRange(7164, 7167).addRange(7227, 7231).addRange(7294, 7295).addRange(7360, 7367).addRange(8214, 8215).addRange(8224, 8231).addRange(8240, 8248).addRange(8251, 8254).addRange(8257, 8259).addRange(8263, 8273).addRange(8277, 8286).addRange(11513, 11516).addRange(11518, 11519).addRange(11776, 11777).addRange(11782, 11784).addRange(11790, 11798).addRange(11800, 11801);
      set3.addRange(11806, 11807).addRange(11818, 11822).addRange(11824, 11833).addRange(11836, 11839).addRange(11843, 11855).addRange(11858, 11860).addRange(12289, 12291).addRange(42238, 42239).addRange(42509, 42511).addRange(42738, 42743).addRange(43124, 43127).addRange(43214, 43215).addRange(43256, 43258).addRange(43310, 43311).addRange(43457, 43469).addRange(43486, 43487).addRange(43612, 43615).addRange(43742, 43743).addRange(43760, 43761).addRange(65040, 65046).addRange(65093, 65094).addRange(65097, 65100).addRange(65104, 65106).addRange(65108, 65111).addRange(65119, 65121).addRange(65130, 65131).addRange(65281, 65283).addRange(65285, 65287).addRange(65294, 65295).addRange(65306, 65307).addRange(65311, 65312).addRange(65380, 65381).addRange(65792, 65794).addRange(68176, 68184).addRange(68336, 68342).addRange(68409, 68415).addRange(68505, 68508).addRange(69461, 69465).addRange(69510, 69513).addRange(69703, 69709).addRange(69819, 69820).addRange(69822, 69825).addRange(69952, 69955).addRange(70004, 70005).addRange(70085, 70088).addRange(70109, 70111).addRange(70200, 70205).addRange(70731, 70735).addRange(70746, 70747).addRange(71105, 71127).addRange(71233, 71235);
      set3.addRange(71264, 71276).addRange(71484, 71486).addRange(72004, 72006).addRange(72255, 72262).addRange(72346, 72348).addRange(72350, 72354).addRange(72769, 72773).addRange(72816, 72817).addRange(73463, 73464).addRange(74864, 74868).addRange(77809, 77810).addRange(92782, 92783).addRange(92983, 92987).addRange(93847, 93850).addRange(121479, 121483).addRange(125278, 125279);
      Other_Punctuation.characters = set3;
      return Other_Punctuation;
    }
    var Other_Symbol = {};
    var hasRequiredOther_Symbol;
    function requireOther_Symbol() {
      if (hasRequiredOther_Symbol)
        return Other_Symbol;
      hasRequiredOther_Symbol = 1;
      var set3 = regenerate$2.exports(166, 169, 174, 176, 1154, 1758, 1769, 2038, 2554, 2928, 3066, 3199, 3407, 3449, 3859, 3892, 3894, 3896, 5741, 6464, 8468, 8485, 8487, 8489, 8494, 8522, 8527, 8659, 12292, 12320, 12880, 43065, 64975, 65508, 65512, 65952, 68296, 71487, 92997, 113820, 119365, 123215, 126124, 126254, 129008);
      set3.addRange(1421, 1422).addRange(1550, 1551).addRange(1789, 1790).addRange(3059, 3064).addRange(3841, 3843).addRange(3861, 3863).addRange(3866, 3871).addRange(4030, 4037).addRange(4039, 4044).addRange(4046, 4047).addRange(4053, 4056).addRange(4254, 4255).addRange(5008, 5017).addRange(6622, 6655).addRange(7009, 7018).addRange(7028, 7036).addRange(8448, 8449).addRange(8451, 8454).addRange(8456, 8457).addRange(8470, 8471).addRange(8478, 8483).addRange(8506, 8507).addRange(8524, 8525).addRange(8586, 8587).addRange(8597, 8601).addRange(8604, 8607).addRange(8609, 8610).addRange(8612, 8613).addRange(8615, 8621).addRange(8623, 8653).addRange(8656, 8657).addRange(8661, 8691).addRange(8960, 8967).addRange(8972, 8991).addRange(8994, 9e3).addRange(9003, 9083).addRange(9085, 9114).addRange(9140, 9179).addRange(9186, 9254).addRange(9280, 9290).addRange(9372, 9449).addRange(9472, 9654).addRange(9656, 9664).addRange(9666, 9719).addRange(9728, 9838).addRange(9840, 10087).addRange(10132, 10175).addRange(10240, 10495).addRange(11008, 11055).addRange(11077, 11078).addRange(11085, 11123);
      set3.addRange(11126, 11157).addRange(11159, 11263).addRange(11493, 11498).addRange(11856, 11857).addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12272, 12283).addRange(12306, 12307).addRange(12342, 12343).addRange(12350, 12351).addRange(12688, 12689).addRange(12694, 12703).addRange(12736, 12771).addRange(12800, 12830).addRange(12842, 12871).addRange(12896, 12927).addRange(12938, 12976).addRange(12992, 13311).addRange(19904, 19967).addRange(42128, 42182).addRange(43048, 43051).addRange(43062, 43063).addRange(43639, 43641).addRange(64832, 64847).addRange(65021, 65023).addRange(65517, 65518).addRange(65532, 65533).addRange(65847, 65855).addRange(65913, 65929).addRange(65932, 65934).addRange(65936, 65948).addRange(66e3, 66044).addRange(67703, 67704).addRange(73685, 73692).addRange(73697, 73713).addRange(92988, 92991).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119140).addRange(119146, 119148).addRange(119171, 119172).addRange(119180, 119209).addRange(119214, 119274).addRange(119296, 119361).addRange(119552, 119638).addRange(120832, 121343).addRange(121399, 121402).addRange(121453, 121460).addRange(121462, 121475);
      set3.addRange(121477, 121478).addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127245, 127405).addRange(127462, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(127584, 127589).addRange(127744, 127994).addRange(128e3, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984).addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994);
      Other_Symbol.characters = set3;
      return Other_Symbol;
    }
    var Other = {};
    var hasRequiredOther;
    function requireOther() {
      if (hasRequiredOther)
        return Other;
      hasRequiredOther = 1;
      var set3 = regenerate$2.exports(173, 907, 909, 930, 1328, 1424, 1564, 1757, 2111, 2143, 2274, 2436, 2473, 2481, 2526, 2564, 2601, 2609, 2612, 2615, 2621, 2653, 2692, 2702, 2706, 2729, 2737, 2740, 2758, 2762, 2816, 2820, 2857, 2865, 2868, 2910, 2948, 2961, 2971, 2973, 3017, 3085, 3089, 3113, 3141, 3145, 3159, 3213, 3217, 3241, 3252, 3269, 3273, 3295, 3312, 3341, 3345, 3397, 3401, 3456, 3460, 3506, 3516, 3541, 3543, 3715, 3717, 3723, 3748, 3750, 3781, 3783, 3912, 3992, 4029, 4045, 4294, 4681, 4695, 4697, 4745, 4785, 4799, 4801, 4823, 4881, 5997, 6001, 6158, 6431, 6751, 7039, 8024, 8026, 8028, 8030, 8117, 8133, 8156, 8181, 8191, 8335, 11158, 11558, 11687, 11695, 11703, 11711, 11719, 11727, 11735, 11743, 11930, 12352, 12592, 12687, 12831, 42962, 42964, 43470, 43519, 43815, 43823, 64311, 64317, 64319, 64322, 64325, 65107, 65127, 65141, 65511, 65548, 65575, 65595, 65598, 65935, 66462, 66939, 66955, 66963, 66966, 66978, 66994, 67002, 67462, 67505, 67593, 67638, 67670, 67827, 68100, 68116, 68120, 69247, 69290, 69821, 69941, 70112, 70162, 70279, 70281, 70286, 70302, 70404, 70441, 70449, 70452, 70458, 70748, 71956, 71959, 71990, 72713, 72759, 72872, 72967, 72970, 73019, 73022, 73062, 73065, 73103, 73106, 74863, 92767, 92863, 93018, 93026, 110580, 110588, 110591, 119893, 119965, 119981, 119994, 119996, 120004, 120070, 120085, 120093, 120122, 120127, 120133, 120145, 121504, 122887, 122914, 122917, 124903, 124908, 124911, 124927, 126468, 126496, 126499, 126504, 126515, 126520, 126522, 126536, 126538, 126540, 126544, 126547, 126552, 126554, 126556, 126558, 126560, 126563, 126571, 126579, 126584, 126589, 126591, 126602, 126628, 126634, 127168, 127184, 129939);
      set3.addRange(0, 31).addRange(127, 159).addRange(888, 889).addRange(896, 899).addRange(1367, 1368).addRange(1419, 1420).addRange(1480, 1487).addRange(1515, 1518).addRange(1525, 1541).addRange(1806, 1807).addRange(1867, 1868).addRange(1970, 1983).addRange(2043, 2044).addRange(2094, 2095).addRange(2140, 2141).addRange(2155, 2159).addRange(2191, 2199).addRange(2445, 2446).addRange(2449, 2450).addRange(2483, 2485).addRange(2490, 2491).addRange(2501, 2502).addRange(2505, 2506).addRange(2511, 2518).addRange(2520, 2523).addRange(2532, 2533).addRange(2559, 2560).addRange(2571, 2574).addRange(2577, 2578).addRange(2618, 2619).addRange(2627, 2630).addRange(2633, 2634).addRange(2638, 2640).addRange(2642, 2648).addRange(2655, 2661).addRange(2679, 2688).addRange(2746, 2747).addRange(2766, 2767).addRange(2769, 2783).addRange(2788, 2789).addRange(2802, 2808).addRange(2829, 2830).addRange(2833, 2834).addRange(2874, 2875).addRange(2885, 2886).addRange(2889, 2890).addRange(2894, 2900).addRange(2904, 2907).addRange(2916, 2917).addRange(2936, 2945).addRange(2955, 2957);
      set3.addRange(2966, 2968).addRange(2976, 2978).addRange(2981, 2983).addRange(2987, 2989).addRange(3002, 3005).addRange(3011, 3013).addRange(3022, 3023).addRange(3025, 3030).addRange(3032, 3045).addRange(3067, 3071).addRange(3130, 3131).addRange(3150, 3156).addRange(3163, 3164).addRange(3166, 3167).addRange(3172, 3173).addRange(3184, 3190).addRange(3258, 3259).addRange(3278, 3284).addRange(3287, 3292).addRange(3300, 3301).addRange(3315, 3327).addRange(3408, 3411).addRange(3428, 3429).addRange(3479, 3481).addRange(3518, 3519).addRange(3527, 3529).addRange(3531, 3534).addRange(3552, 3557).addRange(3568, 3569).addRange(3573, 3584).addRange(3643, 3646).addRange(3676, 3712).addRange(3774, 3775).addRange(3790, 3791).addRange(3802, 3803).addRange(3808, 3839).addRange(3949, 3952).addRange(4059, 4095).addRange(4296, 4300).addRange(4302, 4303).addRange(4686, 4687).addRange(4702, 4703).addRange(4750, 4751).addRange(4790, 4791).addRange(4806, 4807).addRange(4886, 4887).addRange(4955, 4956).addRange(4989, 4991).addRange(5018, 5023).addRange(5110, 5111).addRange(5118, 5119);
      set3.addRange(5789, 5791).addRange(5881, 5887).addRange(5910, 5918).addRange(5943, 5951).addRange(5972, 5983).addRange(6004, 6015).addRange(6110, 6111).addRange(6122, 6127).addRange(6138, 6143).addRange(6170, 6175).addRange(6265, 6271).addRange(6315, 6319).addRange(6390, 6399).addRange(6444, 6447).addRange(6460, 6463).addRange(6465, 6467).addRange(6510, 6511).addRange(6517, 6527).addRange(6572, 6575).addRange(6602, 6607).addRange(6619, 6621).addRange(6684, 6685).addRange(6781, 6782).addRange(6794, 6799).addRange(6810, 6815).addRange(6830, 6831).addRange(6863, 6911).addRange(6989, 6991).addRange(7156, 7163).addRange(7224, 7226).addRange(7242, 7244).addRange(7305, 7311).addRange(7355, 7356).addRange(7368, 7375).addRange(7419, 7423).addRange(7958, 7959).addRange(7966, 7967).addRange(8006, 8007).addRange(8014, 8015).addRange(8062, 8063).addRange(8148, 8149).addRange(8176, 8177).addRange(8203, 8207).addRange(8234, 8238).addRange(8288, 8303).addRange(8306, 8307).addRange(8349, 8351).addRange(8385, 8399).addRange(8433, 8447).addRange(8588, 8591).addRange(9255, 9279);
      set3.addRange(9291, 9311).addRange(11124, 11125).addRange(11508, 11512).addRange(11560, 11564).addRange(11566, 11567).addRange(11624, 11630).addRange(11633, 11646).addRange(11671, 11679).addRange(11870, 11903).addRange(12020, 12031).addRange(12246, 12271).addRange(12284, 12287).addRange(12439, 12440).addRange(12544, 12548).addRange(12772, 12783).addRange(42125, 42127).addRange(42183, 42191).addRange(42540, 42559).addRange(42744, 42751).addRange(42955, 42959).addRange(42970, 42993).addRange(43053, 43055).addRange(43066, 43071).addRange(43128, 43135).addRange(43206, 43213).addRange(43226, 43231).addRange(43348, 43358).addRange(43389, 43391).addRange(43482, 43485).addRange(43575, 43583).addRange(43598, 43599).addRange(43610, 43611).addRange(43715, 43738).addRange(43767, 43776).addRange(43783, 43784).addRange(43791, 43792).addRange(43799, 43807).addRange(43884, 43887).addRange(44014, 44015).addRange(44026, 44031).addRange(55204, 55215).addRange(55239, 55242).addRange(55292, 63743).addRange(64110, 64111).addRange(64218, 64255).addRange(64263, 64274).addRange(64280, 64284).addRange(64451, 64466).addRange(64912, 64913).addRange(64968, 64974).addRange(64976, 65007);
      set3.addRange(65050, 65055).addRange(65132, 65135).addRange(65277, 65280).addRange(65471, 65473).addRange(65480, 65481).addRange(65488, 65489).addRange(65496, 65497).addRange(65501, 65503).addRange(65519, 65531).addRange(65534, 65535).addRange(65614, 65615).addRange(65630, 65663).addRange(65787, 65791).addRange(65795, 65798).addRange(65844, 65846).addRange(65949, 65951).addRange(65953, 65999).addRange(66046, 66175).addRange(66205, 66207).addRange(66257, 66271).addRange(66300, 66303).addRange(66340, 66348).addRange(66379, 66383).addRange(66427, 66431).addRange(66500, 66503).addRange(66518, 66559).addRange(66718, 66719).addRange(66730, 66735).addRange(66772, 66775).addRange(66812, 66815).addRange(66856, 66863).addRange(66916, 66926).addRange(67005, 67071).addRange(67383, 67391).addRange(67414, 67423).addRange(67432, 67455).addRange(67515, 67583).addRange(67590, 67591).addRange(67641, 67643).addRange(67645, 67646).addRange(67743, 67750).addRange(67760, 67807).addRange(67830, 67834).addRange(67868, 67870).addRange(67898, 67902).addRange(67904, 67967).addRange(68024, 68027).addRange(68048, 68049).addRange(68103, 68107).addRange(68150, 68151).addRange(68155, 68158);
      set3.addRange(68169, 68175).addRange(68185, 68191).addRange(68256, 68287).addRange(68327, 68330).addRange(68343, 68351).addRange(68406, 68408).addRange(68438, 68439).addRange(68467, 68471).addRange(68498, 68504).addRange(68509, 68520).addRange(68528, 68607).addRange(68681, 68735).addRange(68787, 68799).addRange(68851, 68857).addRange(68904, 68911).addRange(68922, 69215).addRange(69294, 69295).addRange(69298, 69375).addRange(69416, 69423).addRange(69466, 69487).addRange(69514, 69551).addRange(69580, 69599).addRange(69623, 69631).addRange(69710, 69713).addRange(69750, 69758).addRange(69827, 69839).addRange(69865, 69871).addRange(69882, 69887).addRange(69960, 69967).addRange(70007, 70015).addRange(70133, 70143).addRange(70207, 70271).addRange(70314, 70319).addRange(70379, 70383).addRange(70394, 70399).addRange(70413, 70414).addRange(70417, 70418).addRange(70469, 70470).addRange(70473, 70474).addRange(70478, 70479).addRange(70481, 70486).addRange(70488, 70492).addRange(70500, 70501).addRange(70509, 70511).addRange(70517, 70655).addRange(70754, 70783).addRange(70856, 70863).addRange(70874, 71039).addRange(71094, 71095).addRange(71134, 71167).addRange(71237, 71247);
      set3.addRange(71258, 71263).addRange(71277, 71295).addRange(71354, 71359).addRange(71370, 71423).addRange(71451, 71452).addRange(71468, 71471).addRange(71495, 71679).addRange(71740, 71839).addRange(71923, 71934).addRange(71943, 71944).addRange(71946, 71947).addRange(71993, 71994).addRange(72007, 72015).addRange(72026, 72095).addRange(72104, 72105).addRange(72152, 72153).addRange(72165, 72191).addRange(72264, 72271).addRange(72355, 72367).addRange(72441, 72703).addRange(72774, 72783).addRange(72813, 72815).addRange(72848, 72849).addRange(72887, 72959).addRange(73015, 73017).addRange(73032, 73039).addRange(73050, 73055).addRange(73113, 73119).addRange(73130, 73439).addRange(73465, 73647).addRange(73649, 73663).addRange(73714, 73726).addRange(74650, 74751).addRange(74869, 74879).addRange(75076, 77711).addRange(77811, 77823).addRange(78895, 82943).addRange(83527, 92159).addRange(92729, 92735).addRange(92778, 92781).addRange(92874, 92879).addRange(92910, 92911).addRange(92918, 92927).addRange(92998, 93007).addRange(93048, 93052).addRange(93072, 93759).addRange(93851, 93951).addRange(94027, 94030).addRange(94088, 94094).addRange(94112, 94175).addRange(94181, 94191);
      set3.addRange(94194, 94207).addRange(100344, 100351).addRange(101590, 101631).addRange(101641, 110575).addRange(110883, 110927).addRange(110931, 110947).addRange(110952, 110959).addRange(111356, 113663).addRange(113771, 113775).addRange(113789, 113791).addRange(113801, 113807).addRange(113818, 113819).addRange(113824, 118527).addRange(118574, 118575).addRange(118599, 118607).addRange(118724, 118783).addRange(119030, 119039).addRange(119079, 119080).addRange(119155, 119162).addRange(119275, 119295).addRange(119366, 119519).addRange(119540, 119551).addRange(119639, 119647).addRange(119673, 119807).addRange(119968, 119969).addRange(119971, 119972).addRange(119975, 119976).addRange(120075, 120076).addRange(120135, 120137).addRange(120486, 120487).addRange(120780, 120781).addRange(121484, 121498).addRange(121520, 122623).addRange(122655, 122879).addRange(122905, 122906).addRange(122923, 123135).addRange(123181, 123183).addRange(123198, 123199).addRange(123210, 123213).addRange(123216, 123535).addRange(123567, 123583).addRange(123642, 123646).addRange(123648, 124895).addRange(125125, 125126).addRange(125143, 125183).addRange(125260, 125263).addRange(125274, 125277).addRange(125280, 126064).addRange(126133, 126208).addRange(126270, 126463).addRange(126501, 126502);
      set3.addRange(126524, 126529).addRange(126531, 126534).addRange(126549, 126550).addRange(126565, 126566).addRange(126620, 126624).addRange(126652, 126703).addRange(126706, 126975).addRange(127020, 127023).addRange(127124, 127135).addRange(127151, 127152).addRange(127222, 127231).addRange(127406, 127461).addRange(127491, 127503).addRange(127548, 127551).addRange(127561, 127567).addRange(127570, 127583).addRange(127590, 127743).addRange(128728, 128732).addRange(128749, 128751).addRange(128765, 128767).addRange(128884, 128895).addRange(128985, 128991).addRange(129004, 129007).addRange(129009, 129023).addRange(129036, 129039).addRange(129096, 129103).addRange(129114, 129119).addRange(129160, 129167).addRange(129198, 129199).addRange(129202, 129279).addRange(129620, 129631).addRange(129646, 129647).addRange(129653, 129655).addRange(129661, 129663).addRange(129671, 129679).addRange(129709, 129711).addRange(129723, 129727).addRange(129734, 129743).addRange(129754, 129759).addRange(129768, 129775).addRange(129783, 129791).addRange(129995, 130031).addRange(130042, 131071).addRange(173792, 173823).addRange(177977, 177983).addRange(178206, 178207).addRange(183970, 183983).addRange(191457, 194559).addRange(195102, 196607).addRange(201547, 917759).addRange(918e3, 1114111);
      Other.characters = set3;
      return Other;
    }
    var Paragraph_Separator = {};
    var hasRequiredParagraph_Separator;
    function requireParagraph_Separator() {
      if (hasRequiredParagraph_Separator)
        return Paragraph_Separator;
      hasRequiredParagraph_Separator = 1;
      var set3 = regenerate$2.exports(8233);
      Paragraph_Separator.characters = set3;
      return Paragraph_Separator;
    }
    var Private_Use = {};
    var hasRequiredPrivate_Use;
    function requirePrivate_Use() {
      if (hasRequiredPrivate_Use)
        return Private_Use;
      hasRequiredPrivate_Use = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(57344, 63743).addRange(983040, 1048573).addRange(1048576, 1114109);
      Private_Use.characters = set3;
      return Private_Use;
    }
    var Punctuation = {};
    var hasRequiredPunctuation;
    function requirePunctuation() {
      if (hasRequiredPunctuation)
        return Punctuation;
      hasRequiredPunctuation = 1;
      var set3 = regenerate$2.exports(95, 123, 125, 161, 167, 171, 187, 191, 894, 903, 1470, 1472, 1475, 1478, 1563, 1748, 2142, 2416, 2557, 2678, 2800, 3191, 3204, 3572, 3663, 3860, 3973, 4347, 5120, 5742, 7379, 11632, 12336, 12349, 12448, 12539, 42611, 42622, 43260, 43359, 44011, 65123, 65128, 65343, 65371, 65373, 66463, 66512, 66927, 67671, 67871, 67903, 68223, 69293, 70093, 70107, 70313, 70749, 70854, 71353, 71739, 72162, 73727, 92917, 92996, 94178, 113823);
      set3.addRange(33, 35).addRange(37, 42).addRange(44, 47).addRange(58, 59).addRange(63, 64).addRange(91, 93).addRange(182, 183).addRange(1370, 1375).addRange(1417, 1418).addRange(1523, 1524).addRange(1545, 1546).addRange(1548, 1549).addRange(1565, 1567).addRange(1642, 1645).addRange(1792, 1805).addRange(2039, 2041).addRange(2096, 2110).addRange(2404, 2405).addRange(3674, 3675).addRange(3844, 3858).addRange(3898, 3901).addRange(4048, 4052).addRange(4057, 4058).addRange(4170, 4175).addRange(4960, 4968).addRange(5787, 5788).addRange(5867, 5869).addRange(5941, 5942).addRange(6100, 6102).addRange(6104, 6106).addRange(6144, 6154).addRange(6468, 6469).addRange(6686, 6687).addRange(6816, 6822).addRange(6824, 6829).addRange(7002, 7008).addRange(7037, 7038).addRange(7164, 7167).addRange(7227, 7231).addRange(7294, 7295).addRange(7360, 7367).addRange(8208, 8231).addRange(8240, 8259).addRange(8261, 8273).addRange(8275, 8286).addRange(8317, 8318).addRange(8333, 8334).addRange(8968, 8971).addRange(9001, 9002).addRange(10088, 10101).addRange(10181, 10182);
      set3.addRange(10214, 10223).addRange(10627, 10648).addRange(10712, 10715).addRange(10748, 10749).addRange(11513, 11516).addRange(11518, 11519).addRange(11776, 11822).addRange(11824, 11855).addRange(11858, 11869).addRange(12289, 12291).addRange(12296, 12305).addRange(12308, 12319).addRange(42238, 42239).addRange(42509, 42511).addRange(42738, 42743).addRange(43124, 43127).addRange(43214, 43215).addRange(43256, 43258).addRange(43310, 43311).addRange(43457, 43469).addRange(43486, 43487).addRange(43612, 43615).addRange(43742, 43743).addRange(43760, 43761).addRange(64830, 64831).addRange(65040, 65049).addRange(65072, 65106).addRange(65108, 65121).addRange(65130, 65131).addRange(65281, 65283).addRange(65285, 65290).addRange(65292, 65295).addRange(65306, 65307).addRange(65311, 65312).addRange(65339, 65341).addRange(65375, 65381).addRange(65792, 65794).addRange(68176, 68184).addRange(68336, 68342).addRange(68409, 68415).addRange(68505, 68508).addRange(69461, 69465).addRange(69510, 69513).addRange(69703, 69709).addRange(69819, 69820).addRange(69822, 69825).addRange(69952, 69955).addRange(70004, 70005).addRange(70085, 70088).addRange(70109, 70111).addRange(70200, 70205);
      set3.addRange(70731, 70735).addRange(70746, 70747).addRange(71105, 71127).addRange(71233, 71235).addRange(71264, 71276).addRange(71484, 71486).addRange(72004, 72006).addRange(72255, 72262).addRange(72346, 72348).addRange(72350, 72354).addRange(72769, 72773).addRange(72816, 72817).addRange(73463, 73464).addRange(74864, 74868).addRange(77809, 77810).addRange(92782, 92783).addRange(92983, 92987).addRange(93847, 93850).addRange(121479, 121483).addRange(125278, 125279);
      Punctuation.characters = set3;
      return Punctuation;
    }
    var Separator = {};
    var hasRequiredSeparator;
    function requireSeparator() {
      if (hasRequiredSeparator)
        return Separator;
      hasRequiredSeparator = 1;
      var set3 = regenerate$2.exports(32, 160, 5760, 8239, 8287, 12288);
      set3.addRange(8192, 8202).addRange(8232, 8233);
      Separator.characters = set3;
      return Separator;
    }
    var Space_Separator = {};
    var hasRequiredSpace_Separator;
    function requireSpace_Separator() {
      if (hasRequiredSpace_Separator)
        return Space_Separator;
      hasRequiredSpace_Separator = 1;
      var set3 = regenerate$2.exports(32, 160, 5760, 8239, 8287, 12288);
      set3.addRange(8192, 8202);
      Space_Separator.characters = set3;
      return Space_Separator;
    }
    var Spacing_Mark = {};
    var hasRequiredSpacing_Mark;
    function requireSpacing_Mark() {
      if (hasRequiredSpacing_Mark)
        return Spacing_Mark;
      hasRequiredSpacing_Mark = 1;
      var set3 = regenerate$2.exports(2307, 2363, 2519, 2563, 2691, 2761, 2878, 2880, 2903, 3031, 3262, 3415, 3967, 4145, 4152, 4239, 5909, 5940, 6070, 6741, 6743, 6753, 6916, 6965, 6971, 7042, 7073, 7082, 7143, 7150, 7393, 7415, 43047, 43395, 43597, 43643, 43645, 43755, 43765, 44012, 69632, 69634, 69762, 69932, 70018, 70094, 70197, 70487, 70725, 70841, 70849, 71102, 71230, 71340, 71350, 71462, 71736, 71997, 72e3, 72002, 72164, 72249, 72343, 72751, 72766, 72873, 72881, 72884, 73110);
      set3.addRange(2366, 2368).addRange(2377, 2380).addRange(2382, 2383).addRange(2434, 2435).addRange(2494, 2496).addRange(2503, 2504).addRange(2507, 2508).addRange(2622, 2624).addRange(2750, 2752).addRange(2763, 2764).addRange(2818, 2819).addRange(2887, 2888).addRange(2891, 2892).addRange(3006, 3007).addRange(3009, 3010).addRange(3014, 3016).addRange(3018, 3020).addRange(3073, 3075).addRange(3137, 3140).addRange(3202, 3203).addRange(3264, 3268).addRange(3271, 3272).addRange(3274, 3275).addRange(3285, 3286).addRange(3330, 3331).addRange(3390, 3392).addRange(3398, 3400).addRange(3402, 3404).addRange(3458, 3459).addRange(3535, 3537).addRange(3544, 3551).addRange(3570, 3571).addRange(3902, 3903).addRange(4139, 4140).addRange(4155, 4156).addRange(4182, 4183).addRange(4194, 4196).addRange(4199, 4205).addRange(4227, 4228).addRange(4231, 4236).addRange(4250, 4252).addRange(6078, 6085).addRange(6087, 6088).addRange(6435, 6438).addRange(6441, 6443).addRange(6448, 6449).addRange(6451, 6456).addRange(6681, 6682).addRange(6755, 6756).addRange(6765, 6770).addRange(6973, 6977);
      set3.addRange(6979, 6980).addRange(7078, 7079).addRange(7146, 7148).addRange(7154, 7155).addRange(7204, 7211).addRange(7220, 7221).addRange(12334, 12335).addRange(43043, 43044).addRange(43136, 43137).addRange(43188, 43203).addRange(43346, 43347).addRange(43444, 43445).addRange(43450, 43451).addRange(43454, 43456).addRange(43567, 43568).addRange(43571, 43572).addRange(43758, 43759).addRange(44003, 44004).addRange(44006, 44007).addRange(44009, 44010).addRange(69808, 69810).addRange(69815, 69816).addRange(69957, 69958).addRange(70067, 70069).addRange(70079, 70080).addRange(70188, 70190).addRange(70194, 70195).addRange(70368, 70370).addRange(70402, 70403).addRange(70462, 70463).addRange(70465, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70498, 70499).addRange(70709, 70711).addRange(70720, 70721).addRange(70832, 70834).addRange(70843, 70846).addRange(71087, 71089).addRange(71096, 71099).addRange(71216, 71218).addRange(71227, 71228).addRange(71342, 71343).addRange(71456, 71457).addRange(71724, 71726).addRange(71984, 71989).addRange(71991, 71992).addRange(72145, 72147).addRange(72156, 72159).addRange(72279, 72280).addRange(73098, 73102);
      set3.addRange(73107, 73108).addRange(73461, 73462).addRange(94033, 94087).addRange(94192, 94193).addRange(119141, 119142).addRange(119149, 119154);
      Spacing_Mark.characters = set3;
      return Spacing_Mark;
    }
    var Surrogate = {};
    var hasRequiredSurrogate;
    function requireSurrogate() {
      if (hasRequiredSurrogate)
        return Surrogate;
      hasRequiredSurrogate = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(55296, 57343);
      Surrogate.characters = set3;
      return Surrogate;
    }
    var _Symbol2 = {};
    var hasRequired_Symbol;
    function require_Symbol() {
      if (hasRequired_Symbol)
        return _Symbol2;
      hasRequired_Symbol = 1;
      var set3 = regenerate$2.exports(36, 43, 94, 96, 124, 126, 172, 180, 184, 215, 247, 749, 885, 1014, 1154, 1547, 1758, 1769, 2038, 2184, 2801, 2928, 3199, 3407, 3449, 3647, 3859, 3892, 3894, 3896, 5741, 6107, 6464, 8125, 8260, 8274, 8468, 8485, 8487, 8489, 8494, 8527, 12292, 12320, 12880, 43867, 64297, 64975, 65122, 65129, 65284, 65291, 65342, 65344, 65372, 65374, 65952, 68296, 71487, 92997, 113820, 119365, 120513, 120539, 120571, 120597, 120629, 120655, 120687, 120713, 120745, 120771, 123215, 123647, 126124, 126128, 126254, 129008);
      set3.addRange(60, 62).addRange(162, 166).addRange(168, 169).addRange(174, 177).addRange(706, 709).addRange(722, 735).addRange(741, 747).addRange(751, 767).addRange(900, 901).addRange(1421, 1423).addRange(1542, 1544).addRange(1550, 1551).addRange(1789, 1790).addRange(2046, 2047).addRange(2546, 2547).addRange(2554, 2555).addRange(3059, 3066).addRange(3841, 3843).addRange(3861, 3863).addRange(3866, 3871).addRange(4030, 4037).addRange(4039, 4044).addRange(4046, 4047).addRange(4053, 4056).addRange(4254, 4255).addRange(5008, 5017).addRange(6622, 6655).addRange(7009, 7018).addRange(7028, 7036).addRange(8127, 8129).addRange(8141, 8143).addRange(8157, 8159).addRange(8173, 8175).addRange(8189, 8190).addRange(8314, 8316).addRange(8330, 8332).addRange(8352, 8384).addRange(8448, 8449).addRange(8451, 8454).addRange(8456, 8457).addRange(8470, 8472).addRange(8478, 8483).addRange(8506, 8507).addRange(8512, 8516).addRange(8522, 8525).addRange(8586, 8587).addRange(8592, 8967).addRange(8972, 9e3).addRange(9003, 9254).addRange(9280, 9290).addRange(9372, 9449);
      set3.addRange(9472, 10087).addRange(10132, 10180).addRange(10183, 10213).addRange(10224, 10626).addRange(10649, 10711).addRange(10716, 10747).addRange(10750, 11123).addRange(11126, 11157).addRange(11159, 11263).addRange(11493, 11498).addRange(11856, 11857).addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12272, 12283).addRange(12306, 12307).addRange(12342, 12343).addRange(12350, 12351).addRange(12443, 12444).addRange(12688, 12689).addRange(12694, 12703).addRange(12736, 12771).addRange(12800, 12830).addRange(12842, 12871).addRange(12896, 12927).addRange(12938, 12976).addRange(12992, 13311).addRange(19904, 19967).addRange(42128, 42182).addRange(42752, 42774).addRange(42784, 42785).addRange(42889, 42890).addRange(43048, 43051).addRange(43062, 43065).addRange(43639, 43641).addRange(43882, 43883).addRange(64434, 64450).addRange(64832, 64847).addRange(65020, 65023).addRange(65124, 65126).addRange(65308, 65310).addRange(65504, 65510).addRange(65512, 65518).addRange(65532, 65533).addRange(65847, 65855).addRange(65913, 65929).addRange(65932, 65934).addRange(65936, 65948).addRange(66e3, 66044).addRange(67703, 67704).addRange(73685, 73713);
      set3.addRange(92988, 92991).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119140).addRange(119146, 119148).addRange(119171, 119172).addRange(119180, 119209).addRange(119214, 119274).addRange(119296, 119361).addRange(119552, 119638).addRange(120832, 121343).addRange(121399, 121402).addRange(121453, 121460).addRange(121462, 121475).addRange(121477, 121478).addRange(126704, 126705).addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127245, 127405).addRange(127462, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(127584, 127589).addRange(127744, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984).addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767);
      set3.addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994);
      _Symbol2.characters = set3;
      return _Symbol2;
    }
    var Titlecase_Letter = {};
    var hasRequiredTitlecase_Letter;
    function requireTitlecase_Letter() {
      if (hasRequiredTitlecase_Letter)
        return Titlecase_Letter;
      hasRequiredTitlecase_Letter = 1;
      var set3 = regenerate$2.exports(453, 456, 459, 498, 8124, 8140, 8188);
      set3.addRange(8072, 8079).addRange(8088, 8095).addRange(8104, 8111);
      Titlecase_Letter.characters = set3;
      return Titlecase_Letter;
    }
    var Unassigned = {};
    var hasRequiredUnassigned;
    function requireUnassigned() {
      if (hasRequiredUnassigned)
        return Unassigned;
      hasRequiredUnassigned = 1;
      var set3 = regenerate$2.exports(907, 909, 930, 1328, 1424, 1806, 2111, 2143, 2191, 2436, 2473, 2481, 2526, 2564, 2601, 2609, 2612, 2615, 2621, 2653, 2692, 2702, 2706, 2729, 2737, 2740, 2758, 2762, 2816, 2820, 2857, 2865, 2868, 2910, 2948, 2961, 2971, 2973, 3017, 3085, 3089, 3113, 3141, 3145, 3159, 3213, 3217, 3241, 3252, 3269, 3273, 3295, 3312, 3341, 3345, 3397, 3401, 3456, 3460, 3506, 3516, 3541, 3543, 3715, 3717, 3723, 3748, 3750, 3781, 3783, 3912, 3992, 4029, 4045, 4294, 4681, 4695, 4697, 4745, 4785, 4799, 4801, 4823, 4881, 5997, 6001, 6431, 6751, 7039, 8024, 8026, 8028, 8030, 8117, 8133, 8156, 8181, 8191, 8293, 8335, 11158, 11558, 11687, 11695, 11703, 11711, 11719, 11727, 11735, 11743, 11930, 12352, 12592, 12687, 12831, 42962, 42964, 43470, 43519, 43815, 43823, 64311, 64317, 64319, 64322, 64325, 65107, 65127, 65141, 65280, 65511, 65548, 65575, 65595, 65598, 65935, 66462, 66939, 66955, 66963, 66966, 66978, 66994, 67002, 67462, 67505, 67593, 67638, 67670, 67827, 68100, 68116, 68120, 69247, 69290, 69941, 70112, 70162, 70279, 70281, 70286, 70302, 70404, 70441, 70449, 70452, 70458, 70748, 71956, 71959, 71990, 72713, 72759, 72872, 72967, 72970, 73019, 73022, 73062, 73065, 73103, 73106, 74863, 78895, 92767, 92863, 93018, 93026, 110580, 110588, 110591, 119893, 119965, 119981, 119994, 119996, 120004, 120070, 120085, 120093, 120122, 120127, 120133, 120145, 121504, 122887, 122914, 122917, 124903, 124908, 124911, 124927, 126468, 126496, 126499, 126504, 126515, 126520, 126522, 126536, 126538, 126540, 126544, 126547, 126552, 126554, 126556, 126558, 126560, 126563, 126571, 126579, 126584, 126589, 126591, 126602, 126628, 126634, 127168, 127184, 129939);
      set3.addRange(888, 889).addRange(896, 899).addRange(1367, 1368).addRange(1419, 1420).addRange(1480, 1487).addRange(1515, 1518).addRange(1525, 1535).addRange(1867, 1868).addRange(1970, 1983).addRange(2043, 2044).addRange(2094, 2095).addRange(2140, 2141).addRange(2155, 2159).addRange(2194, 2199).addRange(2445, 2446).addRange(2449, 2450).addRange(2483, 2485).addRange(2490, 2491).addRange(2501, 2502).addRange(2505, 2506).addRange(2511, 2518).addRange(2520, 2523).addRange(2532, 2533).addRange(2559, 2560).addRange(2571, 2574).addRange(2577, 2578).addRange(2618, 2619).addRange(2627, 2630).addRange(2633, 2634).addRange(2638, 2640).addRange(2642, 2648).addRange(2655, 2661).addRange(2679, 2688).addRange(2746, 2747).addRange(2766, 2767).addRange(2769, 2783).addRange(2788, 2789).addRange(2802, 2808).addRange(2829, 2830).addRange(2833, 2834).addRange(2874, 2875).addRange(2885, 2886).addRange(2889, 2890).addRange(2894, 2900).addRange(2904, 2907).addRange(2916, 2917).addRange(2936, 2945).addRange(2955, 2957).addRange(2966, 2968).addRange(2976, 2978).addRange(2981, 2983);
      set3.addRange(2987, 2989).addRange(3002, 3005).addRange(3011, 3013).addRange(3022, 3023).addRange(3025, 3030).addRange(3032, 3045).addRange(3067, 3071).addRange(3130, 3131).addRange(3150, 3156).addRange(3163, 3164).addRange(3166, 3167).addRange(3172, 3173).addRange(3184, 3190).addRange(3258, 3259).addRange(3278, 3284).addRange(3287, 3292).addRange(3300, 3301).addRange(3315, 3327).addRange(3408, 3411).addRange(3428, 3429).addRange(3479, 3481).addRange(3518, 3519).addRange(3527, 3529).addRange(3531, 3534).addRange(3552, 3557).addRange(3568, 3569).addRange(3573, 3584).addRange(3643, 3646).addRange(3676, 3712).addRange(3774, 3775).addRange(3790, 3791).addRange(3802, 3803).addRange(3808, 3839).addRange(3949, 3952).addRange(4059, 4095).addRange(4296, 4300).addRange(4302, 4303).addRange(4686, 4687).addRange(4702, 4703).addRange(4750, 4751).addRange(4790, 4791).addRange(4806, 4807).addRange(4886, 4887).addRange(4955, 4956).addRange(4989, 4991).addRange(5018, 5023).addRange(5110, 5111).addRange(5118, 5119).addRange(5789, 5791).addRange(5881, 5887).addRange(5910, 5918);
      set3.addRange(5943, 5951).addRange(5972, 5983).addRange(6004, 6015).addRange(6110, 6111).addRange(6122, 6127).addRange(6138, 6143).addRange(6170, 6175).addRange(6265, 6271).addRange(6315, 6319).addRange(6390, 6399).addRange(6444, 6447).addRange(6460, 6463).addRange(6465, 6467).addRange(6510, 6511).addRange(6517, 6527).addRange(6572, 6575).addRange(6602, 6607).addRange(6619, 6621).addRange(6684, 6685).addRange(6781, 6782).addRange(6794, 6799).addRange(6810, 6815).addRange(6830, 6831).addRange(6863, 6911).addRange(6989, 6991).addRange(7156, 7163).addRange(7224, 7226).addRange(7242, 7244).addRange(7305, 7311).addRange(7355, 7356).addRange(7368, 7375).addRange(7419, 7423).addRange(7958, 7959).addRange(7966, 7967).addRange(8006, 8007).addRange(8014, 8015).addRange(8062, 8063).addRange(8148, 8149).addRange(8176, 8177).addRange(8306, 8307).addRange(8349, 8351).addRange(8385, 8399).addRange(8433, 8447).addRange(8588, 8591).addRange(9255, 9279).addRange(9291, 9311).addRange(11124, 11125).addRange(11508, 11512).addRange(11560, 11564).addRange(11566, 11567).addRange(11624, 11630);
      set3.addRange(11633, 11646).addRange(11671, 11679).addRange(11870, 11903).addRange(12020, 12031).addRange(12246, 12271).addRange(12284, 12287).addRange(12439, 12440).addRange(12544, 12548).addRange(12772, 12783).addRange(42125, 42127).addRange(42183, 42191).addRange(42540, 42559).addRange(42744, 42751).addRange(42955, 42959).addRange(42970, 42993).addRange(43053, 43055).addRange(43066, 43071).addRange(43128, 43135).addRange(43206, 43213).addRange(43226, 43231).addRange(43348, 43358).addRange(43389, 43391).addRange(43482, 43485).addRange(43575, 43583).addRange(43598, 43599).addRange(43610, 43611).addRange(43715, 43738).addRange(43767, 43776).addRange(43783, 43784).addRange(43791, 43792).addRange(43799, 43807).addRange(43884, 43887).addRange(44014, 44015).addRange(44026, 44031).addRange(55204, 55215).addRange(55239, 55242).addRange(55292, 55295).addRange(64110, 64111).addRange(64218, 64255).addRange(64263, 64274).addRange(64280, 64284).addRange(64451, 64466).addRange(64912, 64913).addRange(64968, 64974).addRange(64976, 65007).addRange(65050, 65055).addRange(65132, 65135).addRange(65277, 65278).addRange(65471, 65473).addRange(65480, 65481).addRange(65488, 65489);
      set3.addRange(65496, 65497).addRange(65501, 65503).addRange(65519, 65528).addRange(65534, 65535).addRange(65614, 65615).addRange(65630, 65663).addRange(65787, 65791).addRange(65795, 65798).addRange(65844, 65846).addRange(65949, 65951).addRange(65953, 65999).addRange(66046, 66175).addRange(66205, 66207).addRange(66257, 66271).addRange(66300, 66303).addRange(66340, 66348).addRange(66379, 66383).addRange(66427, 66431).addRange(66500, 66503).addRange(66518, 66559).addRange(66718, 66719).addRange(66730, 66735).addRange(66772, 66775).addRange(66812, 66815).addRange(66856, 66863).addRange(66916, 66926).addRange(67005, 67071).addRange(67383, 67391).addRange(67414, 67423).addRange(67432, 67455).addRange(67515, 67583).addRange(67590, 67591).addRange(67641, 67643).addRange(67645, 67646).addRange(67743, 67750).addRange(67760, 67807).addRange(67830, 67834).addRange(67868, 67870).addRange(67898, 67902).addRange(67904, 67967).addRange(68024, 68027).addRange(68048, 68049).addRange(68103, 68107).addRange(68150, 68151).addRange(68155, 68158).addRange(68169, 68175).addRange(68185, 68191).addRange(68256, 68287).addRange(68327, 68330).addRange(68343, 68351).addRange(68406, 68408);
      set3.addRange(68438, 68439).addRange(68467, 68471).addRange(68498, 68504).addRange(68509, 68520).addRange(68528, 68607).addRange(68681, 68735).addRange(68787, 68799).addRange(68851, 68857).addRange(68904, 68911).addRange(68922, 69215).addRange(69294, 69295).addRange(69298, 69375).addRange(69416, 69423).addRange(69466, 69487).addRange(69514, 69551).addRange(69580, 69599).addRange(69623, 69631).addRange(69710, 69713).addRange(69750, 69758).addRange(69827, 69836).addRange(69838, 69839).addRange(69865, 69871).addRange(69882, 69887).addRange(69960, 69967).addRange(70007, 70015).addRange(70133, 70143).addRange(70207, 70271).addRange(70314, 70319).addRange(70379, 70383).addRange(70394, 70399).addRange(70413, 70414).addRange(70417, 70418).addRange(70469, 70470).addRange(70473, 70474).addRange(70478, 70479).addRange(70481, 70486).addRange(70488, 70492).addRange(70500, 70501).addRange(70509, 70511).addRange(70517, 70655).addRange(70754, 70783).addRange(70856, 70863).addRange(70874, 71039).addRange(71094, 71095).addRange(71134, 71167).addRange(71237, 71247).addRange(71258, 71263).addRange(71277, 71295).addRange(71354, 71359).addRange(71370, 71423).addRange(71451, 71452);
      set3.addRange(71468, 71471).addRange(71495, 71679).addRange(71740, 71839).addRange(71923, 71934).addRange(71943, 71944).addRange(71946, 71947).addRange(71993, 71994).addRange(72007, 72015).addRange(72026, 72095).addRange(72104, 72105).addRange(72152, 72153).addRange(72165, 72191).addRange(72264, 72271).addRange(72355, 72367).addRange(72441, 72703).addRange(72774, 72783).addRange(72813, 72815).addRange(72848, 72849).addRange(72887, 72959).addRange(73015, 73017).addRange(73032, 73039).addRange(73050, 73055).addRange(73113, 73119).addRange(73130, 73439).addRange(73465, 73647).addRange(73649, 73663).addRange(73714, 73726).addRange(74650, 74751).addRange(74869, 74879).addRange(75076, 77711).addRange(77811, 77823).addRange(78905, 82943).addRange(83527, 92159).addRange(92729, 92735).addRange(92778, 92781).addRange(92874, 92879).addRange(92910, 92911).addRange(92918, 92927).addRange(92998, 93007).addRange(93048, 93052).addRange(93072, 93759).addRange(93851, 93951).addRange(94027, 94030).addRange(94088, 94094).addRange(94112, 94175).addRange(94181, 94191).addRange(94194, 94207).addRange(100344, 100351).addRange(101590, 101631).addRange(101641, 110575).addRange(110883, 110927);
      set3.addRange(110931, 110947).addRange(110952, 110959).addRange(111356, 113663).addRange(113771, 113775).addRange(113789, 113791).addRange(113801, 113807).addRange(113818, 113819).addRange(113828, 118527).addRange(118574, 118575).addRange(118599, 118607).addRange(118724, 118783).addRange(119030, 119039).addRange(119079, 119080).addRange(119275, 119295).addRange(119366, 119519).addRange(119540, 119551).addRange(119639, 119647).addRange(119673, 119807).addRange(119968, 119969).addRange(119971, 119972).addRange(119975, 119976).addRange(120075, 120076).addRange(120135, 120137).addRange(120486, 120487).addRange(120780, 120781).addRange(121484, 121498).addRange(121520, 122623).addRange(122655, 122879).addRange(122905, 122906).addRange(122923, 123135).addRange(123181, 123183).addRange(123198, 123199).addRange(123210, 123213).addRange(123216, 123535).addRange(123567, 123583).addRange(123642, 123646).addRange(123648, 124895).addRange(125125, 125126).addRange(125143, 125183).addRange(125260, 125263).addRange(125274, 125277).addRange(125280, 126064).addRange(126133, 126208).addRange(126270, 126463).addRange(126501, 126502).addRange(126524, 126529).addRange(126531, 126534).addRange(126549, 126550).addRange(126565, 126566).addRange(126620, 126624).addRange(126652, 126703);
      set3.addRange(126706, 126975).addRange(127020, 127023).addRange(127124, 127135).addRange(127151, 127152).addRange(127222, 127231).addRange(127406, 127461).addRange(127491, 127503).addRange(127548, 127551).addRange(127561, 127567).addRange(127570, 127583).addRange(127590, 127743).addRange(128728, 128732).addRange(128749, 128751).addRange(128765, 128767).addRange(128884, 128895).addRange(128985, 128991).addRange(129004, 129007).addRange(129009, 129023).addRange(129036, 129039).addRange(129096, 129103).addRange(129114, 129119).addRange(129160, 129167).addRange(129198, 129199).addRange(129202, 129279).addRange(129620, 129631).addRange(129646, 129647).addRange(129653, 129655).addRange(129661, 129663).addRange(129671, 129679).addRange(129709, 129711).addRange(129723, 129727).addRange(129734, 129743).addRange(129754, 129759).addRange(129768, 129775).addRange(129783, 129791).addRange(129995, 130031).addRange(130042, 131071).addRange(173792, 173823).addRange(177977, 177983).addRange(178206, 178207).addRange(183970, 183983).addRange(191457, 194559).addRange(195102, 196607).addRange(201547, 917504).addRange(917506, 917535).addRange(917632, 917759).addRange(918e3, 983039).addRange(1048574, 1048575).addRange(1114110, 1114111);
      Unassigned.characters = set3;
      return Unassigned;
    }
    var Uppercase_Letter = {};
    var hasRequiredUppercase_Letter;
    function requireUppercase_Letter() {
      if (hasRequiredUppercase_Letter)
        return Uppercase_Letter;
      hasRequiredUppercase_Letter = 1;
      var set3 = regenerate$2.exports(256, 258, 260, 262, 264, 266, 268, 270, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 306, 308, 310, 313, 315, 317, 319, 321, 323, 325, 327, 330, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 379, 381, 388, 418, 420, 425, 428, 437, 444, 452, 455, 458, 461, 463, 465, 467, 469, 471, 473, 475, 478, 480, 482, 484, 486, 488, 490, 492, 494, 497, 500, 506, 508, 510, 512, 514, 516, 518, 520, 522, 524, 526, 528, 530, 532, 534, 536, 538, 540, 542, 544, 546, 548, 550, 552, 554, 556, 558, 560, 562, 577, 584, 586, 588, 590, 880, 882, 886, 895, 902, 908, 975, 984, 986, 988, 990, 992, 994, 996, 998, 1e3, 1002, 1004, 1006, 1012, 1015, 1120, 1122, 1124, 1126, 1128, 1130, 1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 1148, 1150, 1152, 1162, 1164, 1166, 1168, 1170, 1172, 1174, 1176, 1178, 1180, 1182, 1184, 1186, 1188, 1190, 1192, 1194, 1196, 1198, 1200, 1202, 1204, 1206, 1208, 1210, 1212, 1214, 1219, 1221, 1223, 1225, 1227, 1229, 1232, 1234, 1236, 1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 1318, 1320, 1322, 1324, 1326, 4295, 4301, 7680, 7682, 7684, 7686, 7688, 7690, 7692, 7694, 7696, 7698, 7700, 7702, 7704, 7706, 7708, 7710, 7712, 7714, 7716, 7718, 7720, 7722, 7724, 7726, 7728, 7730, 7732, 7734, 7736, 7738, 7740, 7742, 7744, 7746, 7748, 7750, 7752, 7754, 7756, 7758, 7760, 7762, 7764, 7766, 7768, 7770, 7772, 7774, 7776, 7778, 7780, 7782, 7784, 7786, 7788, 7790, 7792, 7794, 7796, 7798, 7800, 7802, 7804, 7806, 7808, 7810, 7812, 7814, 7816, 7818, 7820, 7822, 7824, 7826, 7828, 7838, 7840, 7842, 7844, 7846, 7848, 7850, 7852, 7854, 7856, 7858, 7860, 7862, 7864, 7866, 7868, 7870, 7872, 7874, 7876, 7878, 7880, 7882, 7884, 7886, 7888, 7890, 7892, 7894, 7896, 7898, 7900, 7902, 7904, 7906, 7908, 7910, 7912, 7914, 7916, 7918, 7920, 7922, 7924, 7926, 7928, 7930, 7932, 7934, 8025, 8027, 8029, 8031, 8450, 8455, 8469, 8484, 8486, 8488, 8517, 8579, 11360, 11367, 11369, 11371, 11378, 11381, 11394, 11396, 11398, 11400, 11402, 11404, 11406, 11408, 11410, 11412, 11414, 11416, 11418, 11420, 11422, 11424, 11426, 11428, 11430, 11432, 11434, 11436, 11438, 11440, 11442, 11444, 11446, 11448, 11450, 11452, 11454, 11456, 11458, 11460, 11462, 11464, 11466, 11468, 11470, 11472, 11474, 11476, 11478, 11480, 11482, 11484, 11486, 11488, 11490, 11499, 11501, 11506, 42560, 42562, 42564, 42566, 42568, 42570, 42572, 42574, 42576, 42578, 42580, 42582, 42584, 42586, 42588, 42590, 42592, 42594, 42596, 42598, 42600, 42602, 42604, 42624, 42626, 42628, 42630, 42632, 42634, 42636, 42638, 42640, 42642, 42644, 42646, 42648, 42650, 42786, 42788, 42790, 42792, 42794, 42796, 42798, 42802, 42804, 42806, 42808, 42810, 42812, 42814, 42816, 42818, 42820, 42822, 42824, 42826, 42828, 42830, 42832, 42834, 42836, 42838, 42840, 42842, 42844, 42846, 42848, 42850, 42852, 42854, 42856, 42858, 42860, 42862, 42873, 42875, 42880, 42882, 42884, 42886, 42891, 42893, 42896, 42898, 42902, 42904, 42906, 42908, 42910, 42912, 42914, 42916, 42918, 42920, 42934, 42936, 42938, 42940, 42942, 42944, 42946, 42953, 42960, 42966, 42968, 42997, 119964, 119970, 120134, 120778);
      set3.addRange(65, 90).addRange(192, 214).addRange(216, 222).addRange(376, 377).addRange(385, 386).addRange(390, 391).addRange(393, 395).addRange(398, 401).addRange(403, 404).addRange(406, 408).addRange(412, 413).addRange(415, 416).addRange(422, 423).addRange(430, 431).addRange(433, 435).addRange(439, 440).addRange(502, 504).addRange(570, 571).addRange(573, 574).addRange(579, 582).addRange(904, 906).addRange(910, 911).addRange(913, 929).addRange(931, 939).addRange(978, 980).addRange(1017, 1018).addRange(1021, 1071).addRange(1216, 1217).addRange(1329, 1366).addRange(4256, 4293).addRange(5024, 5109).addRange(7312, 7354).addRange(7357, 7359).addRange(7944, 7951).addRange(7960, 7965).addRange(7976, 7983).addRange(7992, 7999).addRange(8008, 8013).addRange(8040, 8047).addRange(8120, 8123).addRange(8136, 8139).addRange(8152, 8155).addRange(8168, 8172).addRange(8184, 8187).addRange(8459, 8461).addRange(8464, 8466).addRange(8473, 8477).addRange(8490, 8493).addRange(8496, 8499).addRange(8510, 8511).addRange(11264, 11311);
      set3.addRange(11362, 11364).addRange(11373, 11376).addRange(11390, 11392).addRange(42877, 42878).addRange(42922, 42926).addRange(42928, 42932).addRange(42948, 42951).addRange(65313, 65338).addRange(66560, 66599).addRange(66736, 66771).addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(68736, 68786).addRange(71840, 71871).addRange(93760, 93791).addRange(119808, 119833).addRange(119860, 119885).addRange(119912, 119937).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119989).addRange(120016, 120041).addRange(120068, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120120, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120172, 120197).addRange(120224, 120249).addRange(120276, 120301).addRange(120328, 120353).addRange(120380, 120405).addRange(120432, 120457).addRange(120488, 120512).addRange(120546, 120570).addRange(120604, 120628).addRange(120662, 120686).addRange(120720, 120744).addRange(125184, 125217);
      Uppercase_Letter.characters = set3;
      return Uppercase_Letter;
    }
    var regenerateUnicodeProperties;
    var hasRequiredRegenerateUnicodeProperties;
    function requireRegenerateUnicodeProperties() {
      if (hasRequiredRegenerateUnicodeProperties)
        return regenerateUnicodeProperties;
      hasRequiredRegenerateUnicodeProperties = 1;
      regenerateUnicodeProperties = /* @__PURE__ */ new Map([["General_Category", ["Cased_Letter", "Close_Punctuation", "Connector_Punctuation", "Control", "Currency_Symbol", "Dash_Punctuation", "Decimal_Number", "Enclosing_Mark", "Final_Punctuation", "Format", "Initial_Punctuation", "Letter", "Letter_Number", "Line_Separator", "Lowercase_Letter", "Mark", "Math_Symbol", "Modifier_Letter", "Modifier_Symbol", "Nonspacing_Mark", "Number", "Open_Punctuation", "Other", "Other_Letter", "Other_Number", "Other_Punctuation", "Other_Symbol", "Paragraph_Separator", "Private_Use", "Punctuation", "Separator", "Space_Separator", "Spacing_Mark", "Surrogate", "Symbol", "Titlecase_Letter", "Unassigned", "Uppercase_Letter"]], ["Script", ["Adlam", "Ahom", "Anatolian_Hieroglyphs", "Arabic", "Armenian", "Avestan", "Balinese", "Bamum", "Bassa_Vah", "Batak", "Bengali", "Bhaiksuki", "Bopomofo", "Brahmi", "Braille", "Buginese", "Buhid", "Canadian_Aboriginal", "Carian", "Caucasian_Albanian", "Chakma", "Cham", "Cherokee", "Chorasmian", "Common", "Coptic", "Cuneiform", "Cypriot", "Cypro_Minoan", "Cyrillic", "Deseret", "Devanagari", "Dives_Akuru", "Dogra", "Duployan", "Egyptian_Hieroglyphs", "Elbasan", "Elymaic", "Ethiopic", "Georgian", "Glagolitic", "Gothic", "Grantha", "Greek", "Gujarati", "Gunjala_Gondi", "Gurmukhi", "Han", "Hangul", "Hanifi_Rohingya", "Hanunoo", "Hatran", "Hebrew", "Hiragana", "Imperial_Aramaic", "Inherited", "Inscriptional_Pahlavi", "Inscriptional_Parthian", "Javanese", "Kaithi", "Kannada", "Katakana", "Kayah_Li", "Kharoshthi", "Khitan_Small_Script", "Khmer", "Khojki", "Khudawadi", "Lao", "Latin", "Lepcha", "Limbu", "Linear_A", "Linear_B", "Lisu", "Lycian", "Lydian", "Mahajani", "Makasar", "Malayalam", "Mandaic", "Manichaean", "Marchen", "Masaram_Gondi", "Medefaidrin", "Meetei_Mayek", "Mende_Kikakui", "Meroitic_Cursive", "Meroitic_Hieroglyphs", "Miao", "Modi", "Mongolian", "Mro", "Multani", "Myanmar", "Nabataean", "Nandinagari", "New_Tai_Lue", "Newa", "Nko", "Nushu", "Nyiakeng_Puachue_Hmong", "Ogham", "Ol_Chiki", "Old_Hungarian", "Old_Italic", "Old_North_Arabian", "Old_Permic", "Old_Persian", "Old_Sogdian", "Old_South_Arabian", "Old_Turkic", "Old_Uyghur", "Oriya", "Osage", "Osmanya", "Pahawh_Hmong", "Palmyrene", "Pau_Cin_Hau", "Phags_Pa", "Phoenician", "Psalter_Pahlavi", "Rejang", "Runic", "Samaritan", "Saurashtra", "Sharada", "Shavian", "Siddham", "SignWriting", "Sinhala", "Sogdian", "Sora_Sompeng", "Soyombo", "Sundanese", "Syloti_Nagri", "Syriac", "Tagalog", "Tagbanwa", "Tai_Le", "Tai_Tham", "Tai_Viet", "Takri", "Tamil", "Tangsa", "Tangut", "Telugu", "Thaana", "Thai", "Tibetan", "Tifinagh", "Tirhuta", "Toto", "Ugaritic", "Vai", "Vithkuqi", "Wancho", "Warang_Citi", "Yezidi", "Yi", "Zanabazar_Square"]], ["Script_Extensions", ["Adlam", "Ahom", "Anatolian_Hieroglyphs", "Arabic", "Armenian", "Avestan", "Balinese", "Bamum", "Bassa_Vah", "Batak", "Bengali", "Bhaiksuki", "Bopomofo", "Brahmi", "Braille", "Buginese", "Buhid", "Canadian_Aboriginal", "Carian", "Caucasian_Albanian", "Chakma", "Cham", "Cherokee", "Chorasmian", "Common", "Coptic", "Cuneiform", "Cypriot", "Cypro_Minoan", "Cyrillic", "Deseret", "Devanagari", "Dives_Akuru", "Dogra", "Duployan", "Egyptian_Hieroglyphs", "Elbasan", "Elymaic", "Ethiopic", "Georgian", "Glagolitic", "Gothic", "Grantha", "Greek", "Gujarati", "Gunjala_Gondi", "Gurmukhi", "Han", "Hangul", "Hanifi_Rohingya", "Hanunoo", "Hatran", "Hebrew", "Hiragana", "Imperial_Aramaic", "Inherited", "Inscriptional_Pahlavi", "Inscriptional_Parthian", "Javanese", "Kaithi", "Kannada", "Katakana", "Kayah_Li", "Kharoshthi", "Khitan_Small_Script", "Khmer", "Khojki", "Khudawadi", "Lao", "Latin", "Lepcha", "Limbu", "Linear_A", "Linear_B", "Lisu", "Lycian", "Lydian", "Mahajani", "Makasar", "Malayalam", "Mandaic", "Manichaean", "Marchen", "Masaram_Gondi", "Medefaidrin", "Meetei_Mayek", "Mende_Kikakui", "Meroitic_Cursive", "Meroitic_Hieroglyphs", "Miao", "Modi", "Mongolian", "Mro", "Multani", "Myanmar", "Nabataean", "Nandinagari", "New_Tai_Lue", "Newa", "Nko", "Nushu", "Nyiakeng_Puachue_Hmong", "Ogham", "Ol_Chiki", "Old_Hungarian", "Old_Italic", "Old_North_Arabian", "Old_Permic", "Old_Persian", "Old_Sogdian", "Old_South_Arabian", "Old_Turkic", "Old_Uyghur", "Oriya", "Osage", "Osmanya", "Pahawh_Hmong", "Palmyrene", "Pau_Cin_Hau", "Phags_Pa", "Phoenician", "Psalter_Pahlavi", "Rejang", "Runic", "Samaritan", "Saurashtra", "Sharada", "Shavian", "Siddham", "SignWriting", "Sinhala", "Sogdian", "Sora_Sompeng", "Soyombo", "Sundanese", "Syloti_Nagri", "Syriac", "Tagalog", "Tagbanwa", "Tai_Le", "Tai_Tham", "Tai_Viet", "Takri", "Tamil", "Tangsa", "Tangut", "Telugu", "Thaana", "Thai", "Tibetan", "Tifinagh", "Tirhuta", "Toto", "Ugaritic", "Vai", "Vithkuqi", "Wancho", "Warang_Citi", "Yezidi", "Yi", "Zanabazar_Square"]], ["Binary_Property", ["ASCII", "ASCII_Hex_Digit", "Alphabetic", "Any", "Assigned", "Bidi_Control", "Bidi_Mirrored", "Case_Ignorable", "Cased", "Changes_When_Casefolded", "Changes_When_Casemapped", "Changes_When_Lowercased", "Changes_When_NFKC_Casefolded", "Changes_When_Titlecased", "Changes_When_Uppercased", "Dash", "Default_Ignorable_Code_Point", "Deprecated", "Diacritic", "Emoji", "Emoji_Component", "Emoji_Modifier", "Emoji_Modifier_Base", "Emoji_Presentation", "Extended_Pictographic", "Extender", "Grapheme_Base", "Grapheme_Extend", "Hex_Digit", "IDS_Binary_Operator", "IDS_Trinary_Operator", "ID_Continue", "ID_Start", "Ideographic", "Join_Control", "Logical_Order_Exception", "Lowercase", "Math", "Noncharacter_Code_Point", "Pattern_Syntax", "Pattern_White_Space", "Quotation_Mark", "Radical", "Regional_Indicator", "Sentence_Terminal", "Soft_Dotted", "Terminal_Punctuation", "Unified_Ideograph", "Uppercase", "Variation_Selector", "White_Space", "XID_Continue", "XID_Start"]], ["Property_of_Strings", ["Basic_Emoji", "Emoji_Keycap_Sequence", "RGI_Emoji", "RGI_Emoji_Flag_Sequence", "RGI_Emoji_Modifier_Sequence", "RGI_Emoji_Tag_Sequence", "RGI_Emoji_ZWJ_Sequence"]]]);
      return regenerateUnicodeProperties;
    }
    var Basic_Emoji = {};
    var hasRequiredBasic_Emoji;
    function requireBasic_Emoji() {
      if (hasRequiredBasic_Emoji)
        return Basic_Emoji;
      hasRequiredBasic_Emoji = 1;
      var set3 = regenerate$2.exports(9200, 9203, 9855, 9875, 9889, 9934, 9940, 9962, 9973, 9978, 9981, 9989, 10024, 10060, 10062, 10071, 10160, 10175, 11088, 11093, 126980, 127183, 127374, 127489, 127514, 127535, 127988, 128064, 128378, 128420, 128716, 129008);
      set3.addRange(8986, 8987).addRange(9193, 9196).addRange(9725, 9726).addRange(9748, 9749).addRange(9800, 9811).addRange(9898, 9899).addRange(9917, 9918).addRange(9924, 9925).addRange(9970, 9971).addRange(9994, 9995).addRange(10067, 10069).addRange(10133, 10135).addRange(11035, 11036).addRange(127377, 127386).addRange(127538, 127542).addRange(127544, 127546).addRange(127568, 127569).addRange(127744, 127776).addRange(127789, 127797).addRange(127799, 127868).addRange(127870, 127891).addRange(127904, 127946).addRange(127951, 127955).addRange(127968, 127984).addRange(127992, 128062).addRange(128066, 128252).addRange(128255, 128317).addRange(128331, 128334).addRange(128336, 128359).addRange(128405, 128406).addRange(128507, 128591).addRange(128640, 128709).addRange(128720, 128722).addRange(128725, 128727).addRange(128733, 128735).addRange(128747, 128748).addRange(128756, 128764).addRange(128992, 129003).addRange(129292, 129338).addRange(129340, 129349).addRange(129351, 129535).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782);
      Basic_Emoji.characters = set3;
      Basic_Emoji.strings = ["\xA9\uFE0F", "\xAE\uFE0F", "\u203C\uFE0F", "\u2049\uFE0F", "\u2122\uFE0F", "\u2139\uFE0F", "\u2194\uFE0F", "\u2195\uFE0F", "\u2196\uFE0F", "\u2197\uFE0F", "\u2198\uFE0F", "\u2199\uFE0F", "\u21A9\uFE0F", "\u21AA\uFE0F", "\u2328\uFE0F", "\u23CF\uFE0F", "\u23ED\uFE0F", "\u23EE\uFE0F", "\u23EF\uFE0F", "\u23F1\uFE0F", "\u23F2\uFE0F", "\u23F8\uFE0F", "\u23F9\uFE0F", "\u23FA\uFE0F", "\u24C2\uFE0F", "\u25AA\uFE0F", "\u25AB\uFE0F", "\u25B6\uFE0F", "\u25C0\uFE0F", "\u25FB\uFE0F", "\u25FC\uFE0F", "\u2600\uFE0F", "\u2601\uFE0F", "\u2602\uFE0F", "\u2603\uFE0F", "\u2604\uFE0F", "\u260E\uFE0F", "\u2611\uFE0F", "\u2618\uFE0F", "\u261D\uFE0F", "\u2620\uFE0F", "\u2622\uFE0F", "\u2623\uFE0F", "\u2626\uFE0F", "\u262A\uFE0F", "\u262E\uFE0F", "\u262F\uFE0F", "\u2638\uFE0F", "\u2639\uFE0F", "\u263A\uFE0F", "\u2640\uFE0F", "\u2642\uFE0F", "\u265F\uFE0F", "\u2660\uFE0F", "\u2663\uFE0F", "\u2665\uFE0F", "\u2666\uFE0F", "\u2668\uFE0F", "\u267B\uFE0F", "\u267E\uFE0F", "\u2692\uFE0F", "\u2694\uFE0F", "\u2695\uFE0F", "\u2696\uFE0F", "\u2697\uFE0F", "\u2699\uFE0F", "\u269B\uFE0F", "\u269C\uFE0F", "\u26A0\uFE0F", "\u26A7\uFE0F", "\u26B0\uFE0F", "\u26B1\uFE0F", "\u26C8\uFE0F", "\u26CF\uFE0F", "\u26D1\uFE0F", "\u26D3\uFE0F", "\u26E9\uFE0F", "\u26F0\uFE0F", "\u26F1\uFE0F", "\u26F4\uFE0F", "\u26F7\uFE0F", "\u26F8\uFE0F", "\u26F9\uFE0F", "\u2702\uFE0F", "\u2708\uFE0F", "\u2709\uFE0F", "\u270C\uFE0F", "\u270D\uFE0F", "\u270F\uFE0F", "\u2712\uFE0F", "\u2714\uFE0F", "\u2716\uFE0F", "\u271D\uFE0F", "\u2721\uFE0F", "\u2733\uFE0F", "\u2734\uFE0F", "\u2744\uFE0F", "\u2747\uFE0F", "\u2763\uFE0F", "\u2764\uFE0F", "\u27A1\uFE0F", "\u2934\uFE0F", "\u2935\uFE0F", "\u2B05\uFE0F", "\u2B06\uFE0F", "\u2B07\uFE0F", "\u3030\uFE0F", "\u303D\uFE0F", "\u3297\uFE0F", "\u3299\uFE0F", "\u{1F170}\uFE0F", "\u{1F171}\uFE0F", "\u{1F17E}\uFE0F", "\u{1F17F}\uFE0F", "\u{1F202}\uFE0F", "\u{1F237}\uFE0F", "\u{1F321}\uFE0F", "\u{1F324}\uFE0F", "\u{1F325}\uFE0F", "\u{1F326}\uFE0F", "\u{1F327}\uFE0F", "\u{1F328}\uFE0F", "\u{1F329}\uFE0F", "\u{1F32A}\uFE0F", "\u{1F32B}\uFE0F", "\u{1F32C}\uFE0F", "\u{1F336}\uFE0F", "\u{1F37D}\uFE0F", "\u{1F396}\uFE0F", "\u{1F397}\uFE0F", "\u{1F399}\uFE0F", "\u{1F39A}\uFE0F", "\u{1F39B}\uFE0F", "\u{1F39E}\uFE0F", "\u{1F39F}\uFE0F", "\u{1F3CB}\uFE0F", "\u{1F3CC}\uFE0F", "\u{1F3CD}\uFE0F", "\u{1F3CE}\uFE0F", "\u{1F3D4}\uFE0F", "\u{1F3D5}\uFE0F", "\u{1F3D6}\uFE0F", "\u{1F3D7}\uFE0F", "\u{1F3D8}\uFE0F", "\u{1F3D9}\uFE0F", "\u{1F3DA}\uFE0F", "\u{1F3DB}\uFE0F", "\u{1F3DC}\uFE0F", "\u{1F3DD}\uFE0F", "\u{1F3DE}\uFE0F", "\u{1F3DF}\uFE0F", "\u{1F3F3}\uFE0F", "\u{1F3F5}\uFE0F", "\u{1F3F7}\uFE0F", "\u{1F43F}\uFE0F", "\u{1F441}\uFE0F", "\u{1F4FD}\uFE0F", "\u{1F549}\uFE0F", "\u{1F54A}\uFE0F", "\u{1F56F}\uFE0F", "\u{1F570}\uFE0F", "\u{1F573}\uFE0F", "\u{1F574}\uFE0F", "\u{1F575}\uFE0F", "\u{1F576}\uFE0F", "\u{1F577}\uFE0F", "\u{1F578}\uFE0F", "\u{1F579}\uFE0F", "\u{1F587}\uFE0F", "\u{1F58A}\uFE0F", "\u{1F58B}\uFE0F", "\u{1F58C}\uFE0F", "\u{1F58D}\uFE0F", "\u{1F590}\uFE0F", "\u{1F5A5}\uFE0F", "\u{1F5A8}\uFE0F", "\u{1F5B1}\uFE0F", "\u{1F5B2}\uFE0F", "\u{1F5BC}\uFE0F", "\u{1F5C2}\uFE0F", "\u{1F5C3}\uFE0F", "\u{1F5C4}\uFE0F", "\u{1F5D1}\uFE0F", "\u{1F5D2}\uFE0F", "\u{1F5D3}\uFE0F", "\u{1F5DC}\uFE0F", "\u{1F5DD}\uFE0F", "\u{1F5DE}\uFE0F", "\u{1F5E1}\uFE0F", "\u{1F5E3}\uFE0F", "\u{1F5E8}\uFE0F", "\u{1F5EF}\uFE0F", "\u{1F5F3}\uFE0F", "\u{1F5FA}\uFE0F", "\u{1F6CB}\uFE0F", "\u{1F6CD}\uFE0F", "\u{1F6CE}\uFE0F", "\u{1F6CF}\uFE0F", "\u{1F6E0}\uFE0F", "\u{1F6E1}\uFE0F", "\u{1F6E2}\uFE0F", "\u{1F6E3}\uFE0F", "\u{1F6E4}\uFE0F", "\u{1F6E5}\uFE0F", "\u{1F6E9}\uFE0F", "\u{1F6F0}\uFE0F", "\u{1F6F3}\uFE0F"];
      return Basic_Emoji;
    }
    var Emoji_Keycap_Sequence = {};
    var hasRequiredEmoji_Keycap_Sequence;
    function requireEmoji_Keycap_Sequence() {
      if (hasRequiredEmoji_Keycap_Sequence)
        return Emoji_Keycap_Sequence;
      hasRequiredEmoji_Keycap_Sequence = 1;
      var set3 = regenerate$2.exports();
      Emoji_Keycap_Sequence.characters = set3;
      Emoji_Keycap_Sequence.strings = ["#\uFE0F\u20E3", "*\uFE0F\u20E3", "0\uFE0F\u20E3", "1\uFE0F\u20E3", "2\uFE0F\u20E3", "3\uFE0F\u20E3", "4\uFE0F\u20E3", "5\uFE0F\u20E3", "6\uFE0F\u20E3", "7\uFE0F\u20E3", "8\uFE0F\u20E3", "9\uFE0F\u20E3"];
      return Emoji_Keycap_Sequence;
    }
    var RGI_Emoji_Flag_Sequence = {};
    var hasRequiredRGI_Emoji_Flag_Sequence;
    function requireRGI_Emoji_Flag_Sequence() {
      if (hasRequiredRGI_Emoji_Flag_Sequence)
        return RGI_Emoji_Flag_Sequence;
      hasRequiredRGI_Emoji_Flag_Sequence = 1;
      var set3 = regenerate$2.exports();
      RGI_Emoji_Flag_Sequence.characters = set3;
      RGI_Emoji_Flag_Sequence.strings = ["\u{1F1E6}\u{1F1E8}", "\u{1F1E6}\u{1F1E9}", "\u{1F1E6}\u{1F1EA}", "\u{1F1E6}\u{1F1EB}", "\u{1F1E6}\u{1F1EC}", "\u{1F1E6}\u{1F1EE}", "\u{1F1E6}\u{1F1F1}", "\u{1F1E6}\u{1F1F2}", "\u{1F1E6}\u{1F1F4}", "\u{1F1E6}\u{1F1F6}", "\u{1F1E6}\u{1F1F7}", "\u{1F1E6}\u{1F1F8}", "\u{1F1E6}\u{1F1F9}", "\u{1F1E6}\u{1F1FA}", "\u{1F1E6}\u{1F1FC}", "\u{1F1E6}\u{1F1FD}", "\u{1F1E6}\u{1F1FF}", "\u{1F1E7}\u{1F1E6}", "\u{1F1E7}\u{1F1E7}", "\u{1F1E7}\u{1F1E9}", "\u{1F1E7}\u{1F1EA}", "\u{1F1E7}\u{1F1EB}", "\u{1F1E7}\u{1F1EC}", "\u{1F1E7}\u{1F1ED}", "\u{1F1E7}\u{1F1EE}", "\u{1F1E7}\u{1F1EF}", "\u{1F1E7}\u{1F1F1}", "\u{1F1E7}\u{1F1F2}", "\u{1F1E7}\u{1F1F3}", "\u{1F1E7}\u{1F1F4}", "\u{1F1E7}\u{1F1F6}", "\u{1F1E7}\u{1F1F7}", "\u{1F1E7}\u{1F1F8}", "\u{1F1E7}\u{1F1F9}", "\u{1F1E7}\u{1F1FB}", "\u{1F1E7}\u{1F1FC}", "\u{1F1E7}\u{1F1FE}", "\u{1F1E7}\u{1F1FF}", "\u{1F1E8}\u{1F1E6}", "\u{1F1E8}\u{1F1E8}", "\u{1F1E8}\u{1F1E9}", "\u{1F1E8}\u{1F1EB}", "\u{1F1E8}\u{1F1EC}", "\u{1F1E8}\u{1F1ED}", "\u{1F1E8}\u{1F1EE}", "\u{1F1E8}\u{1F1F0}", "\u{1F1E8}\u{1F1F1}", "\u{1F1E8}\u{1F1F2}", "\u{1F1E8}\u{1F1F3}", "\u{1F1E8}\u{1F1F4}", "\u{1F1E8}\u{1F1F5}", "\u{1F1E8}\u{1F1F7}", "\u{1F1E8}\u{1F1FA}", "\u{1F1E8}\u{1F1FB}", "\u{1F1E8}\u{1F1FC}", "\u{1F1E8}\u{1F1FD}", "\u{1F1E8}\u{1F1FE}", "\u{1F1E8}\u{1F1FF}", "\u{1F1E9}\u{1F1EA}", "\u{1F1E9}\u{1F1EC}", "\u{1F1E9}\u{1F1EF}", "\u{1F1E9}\u{1F1F0}", "\u{1F1E9}\u{1F1F2}", "\u{1F1E9}\u{1F1F4}", "\u{1F1E9}\u{1F1FF}", "\u{1F1EA}\u{1F1E6}", "\u{1F1EA}\u{1F1E8}", "\u{1F1EA}\u{1F1EA}", "\u{1F1EA}\u{1F1EC}", "\u{1F1EA}\u{1F1ED}", "\u{1F1EA}\u{1F1F7}", "\u{1F1EA}\u{1F1F8}", "\u{1F1EA}\u{1F1F9}", "\u{1F1EA}\u{1F1FA}", "\u{1F1EB}\u{1F1EE}", "\u{1F1EB}\u{1F1EF}", "\u{1F1EB}\u{1F1F0}", "\u{1F1EB}\u{1F1F2}", "\u{1F1EB}\u{1F1F4}", "\u{1F1EB}\u{1F1F7}", "\u{1F1EC}\u{1F1E6}", "\u{1F1EC}\u{1F1E7}", "\u{1F1EC}\u{1F1E9}", "\u{1F1EC}\u{1F1EA}", "\u{1F1EC}\u{1F1EB}", "\u{1F1EC}\u{1F1EC}", "\u{1F1EC}\u{1F1ED}", "\u{1F1EC}\u{1F1EE}", "\u{1F1EC}\u{1F1F1}", "\u{1F1EC}\u{1F1F2}", "\u{1F1EC}\u{1F1F3}", "\u{1F1EC}\u{1F1F5}", "\u{1F1EC}\u{1F1F6}", "\u{1F1EC}\u{1F1F7}", "\u{1F1EC}\u{1F1F8}", "\u{1F1EC}\u{1F1F9}", "\u{1F1EC}\u{1F1FA}", "\u{1F1EC}\u{1F1FC}", "\u{1F1EC}\u{1F1FE}", "\u{1F1ED}\u{1F1F0}", "\u{1F1ED}\u{1F1F2}", "\u{1F1ED}\u{1F1F3}", "\u{1F1ED}\u{1F1F7}", "\u{1F1ED}\u{1F1F9}", "\u{1F1ED}\u{1F1FA}", "\u{1F1EE}\u{1F1E8}", "\u{1F1EE}\u{1F1E9}", "\u{1F1EE}\u{1F1EA}", "\u{1F1EE}\u{1F1F1}", "\u{1F1EE}\u{1F1F2}", "\u{1F1EE}\u{1F1F3}", "\u{1F1EE}\u{1F1F4}", "\u{1F1EE}\u{1F1F6}", "\u{1F1EE}\u{1F1F7}", "\u{1F1EE}\u{1F1F8}", "\u{1F1EE}\u{1F1F9}", "\u{1F1EF}\u{1F1EA}", "\u{1F1EF}\u{1F1F2}", "\u{1F1EF}\u{1F1F4}", "\u{1F1EF}\u{1F1F5}", "\u{1F1F0}\u{1F1EA}", "\u{1F1F0}\u{1F1EC}", "\u{1F1F0}\u{1F1ED}", "\u{1F1F0}\u{1F1EE}", "\u{1F1F0}\u{1F1F2}", "\u{1F1F0}\u{1F1F3}", "\u{1F1F0}\u{1F1F5}", "\u{1F1F0}\u{1F1F7}", "\u{1F1F0}\u{1F1FC}", "\u{1F1F0}\u{1F1FE}", "\u{1F1F0}\u{1F1FF}", "\u{1F1F1}\u{1F1E6}", "\u{1F1F1}\u{1F1E7}", "\u{1F1F1}\u{1F1E8}", "\u{1F1F1}\u{1F1EE}", "\u{1F1F1}\u{1F1F0}", "\u{1F1F1}\u{1F1F7}", "\u{1F1F1}\u{1F1F8}", "\u{1F1F1}\u{1F1F9}", "\u{1F1F1}\u{1F1FA}", "\u{1F1F1}\u{1F1FB}", "\u{1F1F1}\u{1F1FE}", "\u{1F1F2}\u{1F1E6}", "\u{1F1F2}\u{1F1E8}", "\u{1F1F2}\u{1F1E9}", "\u{1F1F2}\u{1F1EA}", "\u{1F1F2}\u{1F1EB}", "\u{1F1F2}\u{1F1EC}", "\u{1F1F2}\u{1F1ED}", "\u{1F1F2}\u{1F1F0}", "\u{1F1F2}\u{1F1F1}", "\u{1F1F2}\u{1F1F2}", "\u{1F1F2}\u{1F1F3}", "\u{1F1F2}\u{1F1F4}", "\u{1F1F2}\u{1F1F5}", "\u{1F1F2}\u{1F1F6}", "\u{1F1F2}\u{1F1F7}", "\u{1F1F2}\u{1F1F8}", "\u{1F1F2}\u{1F1F9}", "\u{1F1F2}\u{1F1FA}", "\u{1F1F2}\u{1F1FB}", "\u{1F1F2}\u{1F1FC}", "\u{1F1F2}\u{1F1FD}", "\u{1F1F2}\u{1F1FE}", "\u{1F1F2}\u{1F1FF}", "\u{1F1F3}\u{1F1E6}", "\u{1F1F3}\u{1F1E8}", "\u{1F1F3}\u{1F1EA}", "\u{1F1F3}\u{1F1EB}", "\u{1F1F3}\u{1F1EC}", "\u{1F1F3}\u{1F1EE}", "\u{1F1F3}\u{1F1F1}", "\u{1F1F3}\u{1F1F4}", "\u{1F1F3}\u{1F1F5}", "\u{1F1F3}\u{1F1F7}", "\u{1F1F3}\u{1F1FA}", "\u{1F1F3}\u{1F1FF}", "\u{1F1F4}\u{1F1F2}", "\u{1F1F5}\u{1F1E6}", "\u{1F1F5}\u{1F1EA}", "\u{1F1F5}\u{1F1EB}", "\u{1F1F5}\u{1F1EC}", "\u{1F1F5}\u{1F1ED}", "\u{1F1F5}\u{1F1F0}", "\u{1F1F5}\u{1F1F1}", "\u{1F1F5}\u{1F1F2}", "\u{1F1F5}\u{1F1F3}", "\u{1F1F5}\u{1F1F7}", "\u{1F1F5}\u{1F1F8}", "\u{1F1F5}\u{1F1F9}", "\u{1F1F5}\u{1F1FC}", "\u{1F1F5}\u{1F1FE}", "\u{1F1F6}\u{1F1E6}", "\u{1F1F7}\u{1F1EA}", "\u{1F1F7}\u{1F1F4}", "\u{1F1F7}\u{1F1F8}", "\u{1F1F7}\u{1F1FA}", "\u{1F1F7}\u{1F1FC}", "\u{1F1F8}\u{1F1E6}", "\u{1F1F8}\u{1F1E7}", "\u{1F1F8}\u{1F1E8}", "\u{1F1F8}\u{1F1E9}", "\u{1F1F8}\u{1F1EA}", "\u{1F1F8}\u{1F1EC}", "\u{1F1F8}\u{1F1ED}", "\u{1F1F8}\u{1F1EE}", "\u{1F1F8}\u{1F1EF}", "\u{1F1F8}\u{1F1F0}", "\u{1F1F8}\u{1F1F1}", "\u{1F1F8}\u{1F1F2}", "\u{1F1F8}\u{1F1F3}", "\u{1F1F8}\u{1F1F4}", "\u{1F1F8}\u{1F1F7}", "\u{1F1F8}\u{1F1F8}", "\u{1F1F8}\u{1F1F9}", "\u{1F1F8}\u{1F1FB}", "\u{1F1F8}\u{1F1FD}", "\u{1F1F8}\u{1F1FE}", "\u{1F1F8}\u{1F1FF}", "\u{1F1F9}\u{1F1E6}", "\u{1F1F9}\u{1F1E8}", "\u{1F1F9}\u{1F1E9}", "\u{1F1F9}\u{1F1EB}", "\u{1F1F9}\u{1F1EC}", "\u{1F1F9}\u{1F1ED}", "\u{1F1F9}\u{1F1EF}", "\u{1F1F9}\u{1F1F0}", "\u{1F1F9}\u{1F1F1}", "\u{1F1F9}\u{1F1F2}", "\u{1F1F9}\u{1F1F3}", "\u{1F1F9}\u{1F1F4}", "\u{1F1F9}\u{1F1F7}", "\u{1F1F9}\u{1F1F9}", "\u{1F1F9}\u{1F1FB}", "\u{1F1F9}\u{1F1FC}", "\u{1F1F9}\u{1F1FF}", "\u{1F1FA}\u{1F1E6}", "\u{1F1FA}\u{1F1EC}", "\u{1F1FA}\u{1F1F2}", "\u{1F1FA}\u{1F1F3}", "\u{1F1FA}\u{1F1F8}", "\u{1F1FA}\u{1F1FE}", "\u{1F1FA}\u{1F1FF}", "\u{1F1FB}\u{1F1E6}", "\u{1F1FB}\u{1F1E8}", "\u{1F1FB}\u{1F1EA}", "\u{1F1FB}\u{1F1EC}", "\u{1F1FB}\u{1F1EE}", "\u{1F1FB}\u{1F1F3}", "\u{1F1FB}\u{1F1FA}", "\u{1F1FC}\u{1F1EB}", "\u{1F1FC}\u{1F1F8}", "\u{1F1FD}\u{1F1F0}", "\u{1F1FE}\u{1F1EA}", "\u{1F1FE}\u{1F1F9}", "\u{1F1FF}\u{1F1E6}", "\u{1F1FF}\u{1F1F2}", "\u{1F1FF}\u{1F1FC}"];
      return RGI_Emoji_Flag_Sequence;
    }
    var RGI_Emoji_Modifier_Sequence = {};
    var hasRequiredRGI_Emoji_Modifier_Sequence;
    function requireRGI_Emoji_Modifier_Sequence() {
      if (hasRequiredRGI_Emoji_Modifier_Sequence)
        return RGI_Emoji_Modifier_Sequence;
      hasRequiredRGI_Emoji_Modifier_Sequence = 1;
      var set3 = regenerate$2.exports();
      RGI_Emoji_Modifier_Sequence.characters = set3;
      RGI_Emoji_Modifier_Sequence.strings = ["\u261D\u{1F3FB}", "\u261D\u{1F3FC}", "\u261D\u{1F3FD}", "\u261D\u{1F3FE}", "\u261D\u{1F3FF}", "\u26F9\u{1F3FB}", "\u26F9\u{1F3FC}", "\u26F9\u{1F3FD}", "\u26F9\u{1F3FE}", "\u26F9\u{1F3FF}", "\u270A\u{1F3FB}", "\u270A\u{1F3FC}", "\u270A\u{1F3FD}", "\u270A\u{1F3FE}", "\u270A\u{1F3FF}", "\u270B\u{1F3FB}", "\u270B\u{1F3FC}", "\u270B\u{1F3FD}", "\u270B\u{1F3FE}", "\u270B\u{1F3FF}", "\u270C\u{1F3FB}", "\u270C\u{1F3FC}", "\u270C\u{1F3FD}", "\u270C\u{1F3FE}", "\u270C\u{1F3FF}", "\u270D\u{1F3FB}", "\u270D\u{1F3FC}", "\u270D\u{1F3FD}", "\u270D\u{1F3FE}", "\u270D\u{1F3FF}", "\u{1F385}\u{1F3FB}", "\u{1F385}\u{1F3FC}", "\u{1F385}\u{1F3FD}", "\u{1F385}\u{1F3FE}", "\u{1F385}\u{1F3FF}", "\u{1F3C2}\u{1F3FB}", "\u{1F3C2}\u{1F3FC}", "\u{1F3C2}\u{1F3FD}", "\u{1F3C2}\u{1F3FE}", "\u{1F3C2}\u{1F3FF}", "\u{1F3C3}\u{1F3FB}", "\u{1F3C3}\u{1F3FC}", "\u{1F3C3}\u{1F3FD}", "\u{1F3C3}\u{1F3FE}", "\u{1F3C3}\u{1F3FF}", "\u{1F3C4}\u{1F3FB}", "\u{1F3C4}\u{1F3FC}", "\u{1F3C4}\u{1F3FD}", "\u{1F3C4}\u{1F3FE}", "\u{1F3C4}\u{1F3FF}", "\u{1F3C7}\u{1F3FB}", "\u{1F3C7}\u{1F3FC}", "\u{1F3C7}\u{1F3FD}", "\u{1F3C7}\u{1F3FE}", "\u{1F3C7}\u{1F3FF}", "\u{1F3CA}\u{1F3FB}", "\u{1F3CA}\u{1F3FC}", "\u{1F3CA}\u{1F3FD}", "\u{1F3CA}\u{1F3FE}", "\u{1F3CA}\u{1F3FF}", "\u{1F3CB}\u{1F3FB}", "\u{1F3CB}\u{1F3FC}", "\u{1F3CB}\u{1F3FD}", "\u{1F3CB}\u{1F3FE}", "\u{1F3CB}\u{1F3FF}", "\u{1F3CC}\u{1F3FB}", "\u{1F3CC}\u{1F3FC}", "\u{1F3CC}\u{1F3FD}", "\u{1F3CC}\u{1F3FE}", "\u{1F3CC}\u{1F3FF}", "\u{1F442}\u{1F3FB}", "\u{1F442}\u{1F3FC}", "\u{1F442}\u{1F3FD}", "\u{1F442}\u{1F3FE}", "\u{1F442}\u{1F3FF}", "\u{1F443}\u{1F3FB}", "\u{1F443}\u{1F3FC}", "\u{1F443}\u{1F3FD}", "\u{1F443}\u{1F3FE}", "\u{1F443}\u{1F3FF}", "\u{1F446}\u{1F3FB}", "\u{1F446}\u{1F3FC}", "\u{1F446}\u{1F3FD}", "\u{1F446}\u{1F3FE}", "\u{1F446}\u{1F3FF}", "\u{1F447}\u{1F3FB}", "\u{1F447}\u{1F3FC}", "\u{1F447}\u{1F3FD}", "\u{1F447}\u{1F3FE}", "\u{1F447}\u{1F3FF}", "\u{1F448}\u{1F3FB}", "\u{1F448}\u{1F3FC}", "\u{1F448}\u{1F3FD}", "\u{1F448}\u{1F3FE}", "\u{1F448}\u{1F3FF}", "\u{1F449}\u{1F3FB}", "\u{1F449}\u{1F3FC}", "\u{1F449}\u{1F3FD}", "\u{1F449}\u{1F3FE}", "\u{1F449}\u{1F3FF}", "\u{1F44A}\u{1F3FB}", "\u{1F44A}\u{1F3FC}", "\u{1F44A}\u{1F3FD}", "\u{1F44A}\u{1F3FE}", "\u{1F44A}\u{1F3FF}", "\u{1F44B}\u{1F3FB}", "\u{1F44B}\u{1F3FC}", "\u{1F44B}\u{1F3FD}", "\u{1F44B}\u{1F3FE}", "\u{1F44B}\u{1F3FF}", "\u{1F44C}\u{1F3FB}", "\u{1F44C}\u{1F3FC}", "\u{1F44C}\u{1F3FD}", "\u{1F44C}\u{1F3FE}", "\u{1F44C}\u{1F3FF}", "\u{1F44D}\u{1F3FB}", "\u{1F44D}\u{1F3FC}", "\u{1F44D}\u{1F3FD}", "\u{1F44D}\u{1F3FE}", "\u{1F44D}\u{1F3FF}", "\u{1F44E}\u{1F3FB}", "\u{1F44E}\u{1F3FC}", "\u{1F44E}\u{1F3FD}", "\u{1F44E}\u{1F3FE}", "\u{1F44E}\u{1F3FF}", "\u{1F44F}\u{1F3FB}", "\u{1F44F}\u{1F3FC}", "\u{1F44F}\u{1F3FD}", "\u{1F44F}\u{1F3FE}", "\u{1F44F}\u{1F3FF}", "\u{1F450}\u{1F3FB}", "\u{1F450}\u{1F3FC}", "\u{1F450}\u{1F3FD}", "\u{1F450}\u{1F3FE}", "\u{1F450}\u{1F3FF}", "\u{1F466}\u{1F3FB}", "\u{1F466}\u{1F3FC}", "\u{1F466}\u{1F3FD}", "\u{1F466}\u{1F3FE}", "\u{1F466}\u{1F3FF}", "\u{1F467}\u{1F3FB}", "\u{1F467}\u{1F3FC}", "\u{1F467}\u{1F3FD}", "\u{1F467}\u{1F3FE}", "\u{1F467}\u{1F3FF}", "\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}", "\u{1F46B}\u{1F3FB}", "\u{1F46B}\u{1F3FC}", "\u{1F46B}\u{1F3FD}", "\u{1F46B}\u{1F3FE}", "\u{1F46B}\u{1F3FF}", "\u{1F46C}\u{1F3FB}", "\u{1F46C}\u{1F3FC}", "\u{1F46C}\u{1F3FD}", "\u{1F46C}\u{1F3FE}", "\u{1F46C}\u{1F3FF}", "\u{1F46D}\u{1F3FB}", "\u{1F46D}\u{1F3FC}", "\u{1F46D}\u{1F3FD}", "\u{1F46D}\u{1F3FE}", "\u{1F46D}\u{1F3FF}", "\u{1F46E}\u{1F3FB}", "\u{1F46E}\u{1F3FC}", "\u{1F46E}\u{1F3FD}", "\u{1F46E}\u{1F3FE}", "\u{1F46E}\u{1F3FF}", "\u{1F470}\u{1F3FB}", "\u{1F470}\u{1F3FC}", "\u{1F470}\u{1F3FD}", "\u{1F470}\u{1F3FE}", "\u{1F470}\u{1F3FF}", "\u{1F471}\u{1F3FB}", "\u{1F471}\u{1F3FC}", "\u{1F471}\u{1F3FD}", "\u{1F471}\u{1F3FE}", "\u{1F471}\u{1F3FF}", "\u{1F472}\u{1F3FB}", "\u{1F472}\u{1F3FC}", "\u{1F472}\u{1F3FD}", "\u{1F472}\u{1F3FE}", "\u{1F472}\u{1F3FF}", "\u{1F473}\u{1F3FB}", "\u{1F473}\u{1F3FC}", "\u{1F473}\u{1F3FD}", "\u{1F473}\u{1F3FE}", "\u{1F473}\u{1F3FF}", "\u{1F474}\u{1F3FB}", "\u{1F474}\u{1F3FC}", "\u{1F474}\u{1F3FD}", "\u{1F474}\u{1F3FE}", "\u{1F474}\u{1F3FF}", "\u{1F475}\u{1F3FB}", "\u{1F475}\u{1F3FC}", "\u{1F475}\u{1F3FD}", "\u{1F475}\u{1F3FE}", "\u{1F475}\u{1F3FF}", "\u{1F476}\u{1F3FB}", "\u{1F476}\u{1F3FC}", "\u{1F476}\u{1F3FD}", "\u{1F476}\u{1F3FE}", "\u{1F476}\u{1F3FF}", "\u{1F477}\u{1F3FB}", "\u{1F477}\u{1F3FC}", "\u{1F477}\u{1F3FD}", "\u{1F477}\u{1F3FE}", "\u{1F477}\u{1F3FF}", "\u{1F478}\u{1F3FB}", "\u{1F478}\u{1F3FC}", "\u{1F478}\u{1F3FD}", "\u{1F478}\u{1F3FE}", "\u{1F478}\u{1F3FF}", "\u{1F47C}\u{1F3FB}", "\u{1F47C}\u{1F3FC}", "\u{1F47C}\u{1F3FD}", "\u{1F47C}\u{1F3FE}", "\u{1F47C}\u{1F3FF}", "\u{1F481}\u{1F3FB}", "\u{1F481}\u{1F3FC}", "\u{1F481}\u{1F3FD}", "\u{1F481}\u{1F3FE}", "\u{1F481}\u{1F3FF}", "\u{1F482}\u{1F3FB}", "\u{1F482}\u{1F3FC}", "\u{1F482}\u{1F3FD}", "\u{1F482}\u{1F3FE}", "\u{1F482}\u{1F3FF}", "\u{1F483}\u{1F3FB}", "\u{1F483}\u{1F3FC}", "\u{1F483}\u{1F3FD}", "\u{1F483}\u{1F3FE}", "\u{1F483}\u{1F3FF}", "\u{1F485}\u{1F3FB}", "\u{1F485}\u{1F3FC}", "\u{1F485}\u{1F3FD}", "\u{1F485}\u{1F3FE}", "\u{1F485}\u{1F3FF}", "\u{1F486}\u{1F3FB}", "\u{1F486}\u{1F3FC}", "\u{1F486}\u{1F3FD}", "\u{1F486}\u{1F3FE}", "\u{1F486}\u{1F3FF}", "\u{1F487}\u{1F3FB}", "\u{1F487}\u{1F3FC}", "\u{1F487}\u{1F3FD}", "\u{1F487}\u{1F3FE}", "\u{1F487}\u{1F3FF}", "\u{1F48F}\u{1F3FB}", "\u{1F48F}\u{1F3FC}", "\u{1F48F}\u{1F3FD}", "\u{1F48F}\u{1F3FE}", "\u{1F48F}\u{1F3FF}", "\u{1F491}\u{1F3FB}", "\u{1F491}\u{1F3FC}", "\u{1F491}\u{1F3FD}", "\u{1F491}\u{1F3FE}", "\u{1F491}\u{1F3FF}", "\u{1F4AA}\u{1F3FB}", "\u{1F4AA}\u{1F3FC}", "\u{1F4AA}\u{1F3FD}", "\u{1F4AA}\u{1F3FE}", "\u{1F4AA}\u{1F3FF}", "\u{1F574}\u{1F3FB}", "\u{1F574}\u{1F3FC}", "\u{1F574}\u{1F3FD}", "\u{1F574}\u{1F3FE}", "\u{1F574}\u{1F3FF}", "\u{1F575}\u{1F3FB}", "\u{1F575}\u{1F3FC}", "\u{1F575}\u{1F3FD}", "\u{1F575}\u{1F3FE}", "\u{1F575}\u{1F3FF}", "\u{1F57A}\u{1F3FB}", "\u{1F57A}\u{1F3FC}", "\u{1F57A}\u{1F3FD}", "\u{1F57A}\u{1F3FE}", "\u{1F57A}\u{1F3FF}", "\u{1F590}\u{1F3FB}", "\u{1F590}\u{1F3FC}", "\u{1F590}\u{1F3FD}", "\u{1F590}\u{1F3FE}", "\u{1F590}\u{1F3FF}", "\u{1F595}\u{1F3FB}", "\u{1F595}\u{1F3FC}", "\u{1F595}\u{1F3FD}", "\u{1F595}\u{1F3FE}", "\u{1F595}\u{1F3FF}", "\u{1F596}\u{1F3FB}", "\u{1F596}\u{1F3FC}", "\u{1F596}\u{1F3FD}", "\u{1F596}\u{1F3FE}", "\u{1F596}\u{1F3FF}", "\u{1F645}\u{1F3FB}", "\u{1F645}\u{1F3FC}", "\u{1F645}\u{1F3FD}", "\u{1F645}\u{1F3FE}", "\u{1F645}\u{1F3FF}", "\u{1F646}\u{1F3FB}", "\u{1F646}\u{1F3FC}", "\u{1F646}\u{1F3FD}", "\u{1F646}\u{1F3FE}", "\u{1F646}\u{1F3FF}", "\u{1F647}\u{1F3FB}", "\u{1F647}\u{1F3FC}", "\u{1F647}\u{1F3FD}", "\u{1F647}\u{1F3FE}", "\u{1F647}\u{1F3FF}", "\u{1F64B}\u{1F3FB}", "\u{1F64B}\u{1F3FC}", "\u{1F64B}\u{1F3FD}", "\u{1F64B}\u{1F3FE}", "\u{1F64B}\u{1F3FF}", "\u{1F64C}\u{1F3FB}", "\u{1F64C}\u{1F3FC}", "\u{1F64C}\u{1F3FD}", "\u{1F64C}\u{1F3FE}", "\u{1F64C}\u{1F3FF}", "\u{1F64D}\u{1F3FB}", "\u{1F64D}\u{1F3FC}", "\u{1F64D}\u{1F3FD}", "\u{1F64D}\u{1F3FE}", "\u{1F64D}\u{1F3FF}", "\u{1F64E}\u{1F3FB}", "\u{1F64E}\u{1F3FC}", "\u{1F64E}\u{1F3FD}", "\u{1F64E}\u{1F3FE}", "\u{1F64E}\u{1F3FF}", "\u{1F64F}\u{1F3FB}", "\u{1F64F}\u{1F3FC}", "\u{1F64F}\u{1F3FD}", "\u{1F64F}\u{1F3FE}", "\u{1F64F}\u{1F3FF}", "\u{1F6A3}\u{1F3FB}", "\u{1F6A3}\u{1F3FC}", "\u{1F6A3}\u{1F3FD}", "\u{1F6A3}\u{1F3FE}", "\u{1F6A3}\u{1F3FF}", "\u{1F6B4}\u{1F3FB}", "\u{1F6B4}\u{1F3FC}", "\u{1F6B4}\u{1F3FD}", "\u{1F6B4}\u{1F3FE}", "\u{1F6B4}\u{1F3FF}", "\u{1F6B5}\u{1F3FB}", "\u{1F6B5}\u{1F3FC}", "\u{1F6B5}\u{1F3FD}", "\u{1F6B5}\u{1F3FE}", "\u{1F6B5}\u{1F3FF}", "\u{1F6B6}\u{1F3FB}", "\u{1F6B6}\u{1F3FC}", "\u{1F6B6}\u{1F3FD}", "\u{1F6B6}\u{1F3FE}", "\u{1F6B6}\u{1F3FF}", "\u{1F6C0}\u{1F3FB}", "\u{1F6C0}\u{1F3FC}", "\u{1F6C0}\u{1F3FD}", "\u{1F6C0}\u{1F3FE}", "\u{1F6C0}\u{1F3FF}", "\u{1F6CC}\u{1F3FB}", "\u{1F6CC}\u{1F3FC}", "\u{1F6CC}\u{1F3FD}", "\u{1F6CC}\u{1F3FE}", "\u{1F6CC}\u{1F3FF}", "\u{1F90C}\u{1F3FB}", "\u{1F90C}\u{1F3FC}", "\u{1F90C}\u{1F3FD}", "\u{1F90C}\u{1F3FE}", "\u{1F90C}\u{1F3FF}", "\u{1F90F}\u{1F3FB}", "\u{1F90F}\u{1F3FC}", "\u{1F90F}\u{1F3FD}", "\u{1F90F}\u{1F3FE}", "\u{1F90F}\u{1F3FF}", "\u{1F918}\u{1F3FB}", "\u{1F918}\u{1F3FC}", "\u{1F918}\u{1F3FD}", "\u{1F918}\u{1F3FE}", "\u{1F918}\u{1F3FF}", "\u{1F919}\u{1F3FB}", "\u{1F919}\u{1F3FC}", "\u{1F919}\u{1F3FD}", "\u{1F919}\u{1F3FE}", "\u{1F919}\u{1F3FF}", "\u{1F91A}\u{1F3FB}", "\u{1F91A}\u{1F3FC}", "\u{1F91A}\u{1F3FD}", "\u{1F91A}\u{1F3FE}", "\u{1F91A}\u{1F3FF}", "\u{1F91B}\u{1F3FB}", "\u{1F91B}\u{1F3FC}", "\u{1F91B}\u{1F3FD}", "\u{1F91B}\u{1F3FE}", "\u{1F91B}\u{1F3FF}", "\u{1F91C}\u{1F3FB}", "\u{1F91C}\u{1F3FC}", "\u{1F91C}\u{1F3FD}", "\u{1F91C}\u{1F3FE}", "\u{1F91C}\u{1F3FF}", "\u{1F91D}\u{1F3FB}", "\u{1F91D}\u{1F3FC}", "\u{1F91D}\u{1F3FD}", "\u{1F91D}\u{1F3FE}", "\u{1F91D}\u{1F3FF}", "\u{1F91E}\u{1F3FB}", "\u{1F91E}\u{1F3FC}", "\u{1F91E}\u{1F3FD}", "\u{1F91E}\u{1F3FE}", "\u{1F91E}\u{1F3FF}", "\u{1F91F}\u{1F3FB}", "\u{1F91F}\u{1F3FC}", "\u{1F91F}\u{1F3FD}", "\u{1F91F}\u{1F3FE}", "\u{1F91F}\u{1F3FF}", "\u{1F926}\u{1F3FB}", "\u{1F926}\u{1F3FC}", "\u{1F926}\u{1F3FD}", "\u{1F926}\u{1F3FE}", "\u{1F926}\u{1F3FF}", "\u{1F930}\u{1F3FB}", "\u{1F930}\u{1F3FC}", "\u{1F930}\u{1F3FD}", "\u{1F930}\u{1F3FE}", "\u{1F930}\u{1F3FF}", "\u{1F931}\u{1F3FB}", "\u{1F931}\u{1F3FC}", "\u{1F931}\u{1F3FD}", "\u{1F931}\u{1F3FE}", "\u{1F931}\u{1F3FF}", "\u{1F932}\u{1F3FB}", "\u{1F932}\u{1F3FC}", "\u{1F932}\u{1F3FD}", "\u{1F932}\u{1F3FE}", "\u{1F932}\u{1F3FF}", "\u{1F933}\u{1F3FB}", "\u{1F933}\u{1F3FC}", "\u{1F933}\u{1F3FD}", "\u{1F933}\u{1F3FE}", "\u{1F933}\u{1F3FF}", "\u{1F934}\u{1F3FB}", "\u{1F934}\u{1F3FC}", "\u{1F934}\u{1F3FD}", "\u{1F934}\u{1F3FE}", "\u{1F934}\u{1F3FF}", "\u{1F935}\u{1F3FB}", "\u{1F935}\u{1F3FC}", "\u{1F935}\u{1F3FD}", "\u{1F935}\u{1F3FE}", "\u{1F935}\u{1F3FF}", "\u{1F936}\u{1F3FB}", "\u{1F936}\u{1F3FC}", "\u{1F936}\u{1F3FD}", "\u{1F936}\u{1F3FE}", "\u{1F936}\u{1F3FF}", "\u{1F937}\u{1F3FB}", "\u{1F937}\u{1F3FC}", "\u{1F937}\u{1F3FD}", "\u{1F937}\u{1F3FE}", "\u{1F937}\u{1F3FF}", "\u{1F938}\u{1F3FB}", "\u{1F938}\u{1F3FC}", "\u{1F938}\u{1F3FD}", "\u{1F938}\u{1F3FE}", "\u{1F938}\u{1F3FF}", "\u{1F939}\u{1F3FB}", "\u{1F939}\u{1F3FC}", "\u{1F939}\u{1F3FD}", "\u{1F939}\u{1F3FE}", "\u{1F939}\u{1F3FF}", "\u{1F93D}\u{1F3FB}", "\u{1F93D}\u{1F3FC}", "\u{1F93D}\u{1F3FD}", "\u{1F93D}\u{1F3FE}", "\u{1F93D}\u{1F3FF}", "\u{1F93E}\u{1F3FB}", "\u{1F93E}\u{1F3FC}", "\u{1F93E}\u{1F3FD}", "\u{1F93E}\u{1F3FE}", "\u{1F93E}\u{1F3FF}", "\u{1F977}\u{1F3FB}", "\u{1F977}\u{1F3FC}", "\u{1F977}\u{1F3FD}", "\u{1F977}\u{1F3FE}", "\u{1F977}\u{1F3FF}", "\u{1F9B5}\u{1F3FB}", "\u{1F9B5}\u{1F3FC}", "\u{1F9B5}\u{1F3FD}", "\u{1F9B5}\u{1F3FE}", "\u{1F9B5}\u{1F3FF}", "\u{1F9B6}\u{1F3FB}", "\u{1F9B6}\u{1F3FC}", "\u{1F9B6}\u{1F3FD}", "\u{1F9B6}\u{1F3FE}", "\u{1F9B6}\u{1F3FF}", "\u{1F9B8}\u{1F3FB}", "\u{1F9B8}\u{1F3FC}", "\u{1F9B8}\u{1F3FD}", "\u{1F9B8}\u{1F3FE}", "\u{1F9B8}\u{1F3FF}", "\u{1F9B9}\u{1F3FB}", "\u{1F9B9}\u{1F3FC}", "\u{1F9B9}\u{1F3FD}", "\u{1F9B9}\u{1F3FE}", "\u{1F9B9}\u{1F3FF}", "\u{1F9BB}\u{1F3FB}", "\u{1F9BB}\u{1F3FC}", "\u{1F9BB}\u{1F3FD}", "\u{1F9BB}\u{1F3FE}", "\u{1F9BB}\u{1F3FF}", "\u{1F9CD}\u{1F3FB}", "\u{1F9CD}\u{1F3FC}", "\u{1F9CD}\u{1F3FD}", "\u{1F9CD}\u{1F3FE}", "\u{1F9CD}\u{1F3FF}", "\u{1F9CE}\u{1F3FB}", "\u{1F9CE}\u{1F3FC}", "\u{1F9CE}\u{1F3FD}", "\u{1F9CE}\u{1F3FE}", "\u{1F9CE}\u{1F3FF}", "\u{1F9CF}\u{1F3FB}", "\u{1F9CF}\u{1F3FC}", "\u{1F9CF}\u{1F3FD}", "\u{1F9CF}\u{1F3FE}", "\u{1F9CF}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}", "\u{1F9D2}\u{1F3FB}", "\u{1F9D2}\u{1F3FC}", "\u{1F9D2}\u{1F3FD}", "\u{1F9D2}\u{1F3FE}", "\u{1F9D2}\u{1F3FF}", "\u{1F9D3}\u{1F3FB}", "\u{1F9D3}\u{1F3FC}", "\u{1F9D3}\u{1F3FD}", "\u{1F9D3}\u{1F3FE}", "\u{1F9D3}\u{1F3FF}", "\u{1F9D4}\u{1F3FB}", "\u{1F9D4}\u{1F3FC}", "\u{1F9D4}\u{1F3FD}", "\u{1F9D4}\u{1F3FE}", "\u{1F9D4}\u{1F3FF}", "\u{1F9D5}\u{1F3FB}", "\u{1F9D5}\u{1F3FC}", "\u{1F9D5}\u{1F3FD}", "\u{1F9D5}\u{1F3FE}", "\u{1F9D5}\u{1F3FF}", "\u{1F9D6}\u{1F3FB}", "\u{1F9D6}\u{1F3FC}", "\u{1F9D6}\u{1F3FD}", "\u{1F9D6}\u{1F3FE}", "\u{1F9D6}\u{1F3FF}", "\u{1F9D7}\u{1F3FB}", "\u{1F9D7}\u{1F3FC}", "\u{1F9D7}\u{1F3FD}", "\u{1F9D7}\u{1F3FE}", "\u{1F9D7}\u{1F3FF}", "\u{1F9D8}\u{1F3FB}", "\u{1F9D8}\u{1F3FC}", "\u{1F9D8}\u{1F3FD}", "\u{1F9D8}\u{1F3FE}", "\u{1F9D8}\u{1F3FF}", "\u{1F9D9}\u{1F3FB}", "\u{1F9D9}\u{1F3FC}", "\u{1F9D9}\u{1F3FD}", "\u{1F9D9}\u{1F3FE}", "\u{1F9D9}\u{1F3FF}", "\u{1F9DA}\u{1F3FB}", "\u{1F9DA}\u{1F3FC}", "\u{1F9DA}\u{1F3FD}", "\u{1F9DA}\u{1F3FE}", "\u{1F9DA}\u{1F3FF}", "\u{1F9DB}\u{1F3FB}", "\u{1F9DB}\u{1F3FC}", "\u{1F9DB}\u{1F3FD}", "\u{1F9DB}\u{1F3FE}", "\u{1F9DB}\u{1F3FF}", "\u{1F9DC}\u{1F3FB}", "\u{1F9DC}\u{1F3FC}", "\u{1F9DC}\u{1F3FD}", "\u{1F9DC}\u{1F3FE}", "\u{1F9DC}\u{1F3FF}", "\u{1F9DD}\u{1F3FB}", "\u{1F9DD}\u{1F3FC}", "\u{1F9DD}\u{1F3FD}", "\u{1F9DD}\u{1F3FE}", "\u{1F9DD}\u{1F3FF}", "\u{1FAC3}\u{1F3FB}", "\u{1FAC3}\u{1F3FC}", "\u{1FAC3}\u{1F3FD}", "\u{1FAC3}\u{1F3FE}", "\u{1FAC3}\u{1F3FF}", "\u{1FAC4}\u{1F3FB}", "\u{1FAC4}\u{1F3FC}", "\u{1FAC4}\u{1F3FD}", "\u{1FAC4}\u{1F3FE}", "\u{1FAC4}\u{1F3FF}", "\u{1FAC5}\u{1F3FB}", "\u{1FAC5}\u{1F3FC}", "\u{1FAC5}\u{1F3FD}", "\u{1FAC5}\u{1F3FE}", "\u{1FAC5}\u{1F3FF}", "\u{1FAF0}\u{1F3FB}", "\u{1FAF0}\u{1F3FC}", "\u{1FAF0}\u{1F3FD}", "\u{1FAF0}\u{1F3FE}", "\u{1FAF0}\u{1F3FF}", "\u{1FAF1}\u{1F3FB}", "\u{1FAF1}\u{1F3FC}", "\u{1FAF1}\u{1F3FD}", "\u{1FAF1}\u{1F3FE}", "\u{1FAF1}\u{1F3FF}", "\u{1FAF2}\u{1F3FB}", "\u{1FAF2}\u{1F3FC}", "\u{1FAF2}\u{1F3FD}", "\u{1FAF2}\u{1F3FE}", "\u{1FAF2}\u{1F3FF}", "\u{1FAF3}\u{1F3FB}", "\u{1FAF3}\u{1F3FC}", "\u{1FAF3}\u{1F3FD}", "\u{1FAF3}\u{1F3FE}", "\u{1FAF3}\u{1F3FF}", "\u{1FAF4}\u{1F3FB}", "\u{1FAF4}\u{1F3FC}", "\u{1FAF4}\u{1F3FD}", "\u{1FAF4}\u{1F3FE}", "\u{1FAF4}\u{1F3FF}", "\u{1FAF5}\u{1F3FB}", "\u{1FAF5}\u{1F3FC}", "\u{1FAF5}\u{1F3FD}", "\u{1FAF5}\u{1F3FE}", "\u{1FAF5}\u{1F3FF}", "\u{1FAF6}\u{1F3FB}", "\u{1FAF6}\u{1F3FC}", "\u{1FAF6}\u{1F3FD}", "\u{1FAF6}\u{1F3FE}", "\u{1FAF6}\u{1F3FF}"];
      return RGI_Emoji_Modifier_Sequence;
    }
    var RGI_Emoji_Tag_Sequence = {};
    var hasRequiredRGI_Emoji_Tag_Sequence;
    function requireRGI_Emoji_Tag_Sequence() {
      if (hasRequiredRGI_Emoji_Tag_Sequence)
        return RGI_Emoji_Tag_Sequence;
      hasRequiredRGI_Emoji_Tag_Sequence = 1;
      var set3 = regenerate$2.exports();
      RGI_Emoji_Tag_Sequence.characters = set3;
      RGI_Emoji_Tag_Sequence.strings = ["\u{1F3F4}\u{E0067}\u{E0062}\u{E0065}\u{E006E}\u{E0067}\u{E007F}", "\u{1F3F4}\u{E0067}\u{E0062}\u{E0073}\u{E0063}\u{E0074}\u{E007F}", "\u{1F3F4}\u{E0067}\u{E0062}\u{E0077}\u{E006C}\u{E0073}\u{E007F}"];
      return RGI_Emoji_Tag_Sequence;
    }
    var RGI_Emoji_ZWJ_Sequence = {};
    var hasRequiredRGI_Emoji_ZWJ_Sequence;
    function requireRGI_Emoji_ZWJ_Sequence() {
      if (hasRequiredRGI_Emoji_ZWJ_Sequence)
        return RGI_Emoji_ZWJ_Sequence;
      hasRequiredRGI_Emoji_ZWJ_Sequence = 1;
      var set3 = regenerate$2.exports();
      RGI_Emoji_ZWJ_Sequence.characters = set3;
      RGI_Emoji_ZWJ_Sequence.strings = ["\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F468}", "\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}", "\u{1F468}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F468}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F469}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}", "\u{1F469}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F9D1}\u200D\u{1F91D}\u200D\u{1F9D1}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FE}", "\u{1F468}\u200D\u2695\uFE0F", "\u{1F468}\u200D\u2696\uFE0F", "\u{1F468}\u200D\u2708\uFE0F", "\u{1F468}\u200D\u{1F33E}", "\u{1F468}\u200D\u{1F373}", "\u{1F468}\u200D\u{1F37C}", "\u{1F468}\u200D\u{1F393}", "\u{1F468}\u200D\u{1F3A4}", "\u{1F468}\u200D\u{1F3A8}", "\u{1F468}\u200D\u{1F3EB}", "\u{1F468}\u200D\u{1F3ED}", "\u{1F468}\u200D\u{1F4BB}", "\u{1F468}\u200D\u{1F4BC}", "\u{1F468}\u200D\u{1F527}", "\u{1F468}\u200D\u{1F52C}", "\u{1F468}\u200D\u{1F680}", "\u{1F468}\u200D\u{1F692}", "\u{1F468}\u200D\u{1F9AF}", "\u{1F468}\u200D\u{1F9BC}", "\u{1F468}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u{1F33E}", "\u{1F468}\u{1F3FB}\u200D\u{1F373}", "\u{1F468}\u{1F3FB}\u200D\u{1F37C}", "\u{1F468}\u{1F3FB}\u200D\u{1F393}", "\u{1F468}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FB}\u200D\u{1F527}", "\u{1F468}\u{1F3FB}\u200D\u{1F52C}", "\u{1F468}\u{1F3FB}\u200D\u{1F680}", "\u{1F468}\u{1F3FB}\u200D\u{1F692}", "\u{1F468}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u{1F33E}", "\u{1F468}\u{1F3FC}\u200D\u{1F373}", "\u{1F468}\u{1F3FC}\u200D\u{1F37C}", "\u{1F468}\u{1F3FC}\u200D\u{1F393}", "\u{1F468}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FC}\u200D\u{1F527}", "\u{1F468}\u{1F3FC}\u200D\u{1F52C}", "\u{1F468}\u{1F3FC}\u200D\u{1F680}", "\u{1F468}\u{1F3FC}\u200D\u{1F692}", "\u{1F468}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u{1F33E}", "\u{1F468}\u{1F3FD}\u200D\u{1F373}", "\u{1F468}\u{1F3FD}\u200D\u{1F37C}", "\u{1F468}\u{1F3FD}\u200D\u{1F393}", "\u{1F468}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FD}\u200D\u{1F527}", "\u{1F468}\u{1F3FD}\u200D\u{1F52C}", "\u{1F468}\u{1F3FD}\u200D\u{1F680}", "\u{1F468}\u{1F3FD}\u200D\u{1F692}", "\u{1F468}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u{1F33E}", "\u{1F468}\u{1F3FE}\u200D\u{1F373}", "\u{1F468}\u{1F3FE}\u200D\u{1F37C}", "\u{1F468}\u{1F3FE}\u200D\u{1F393}", "\u{1F468}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FE}\u200D\u{1F527}", "\u{1F468}\u{1F3FE}\u200D\u{1F52C}", "\u{1F468}\u{1F3FE}\u200D\u{1F680}", "\u{1F468}\u{1F3FE}\u200D\u{1F692}", "\u{1F468}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u{1F33E}", "\u{1F468}\u{1F3FF}\u200D\u{1F373}", "\u{1F468}\u{1F3FF}\u200D\u{1F37C}", "\u{1F468}\u{1F3FF}\u200D\u{1F393}", "\u{1F468}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FF}\u200D\u{1F527}", "\u{1F468}\u{1F3FF}\u200D\u{1F52C}", "\u{1F468}\u{1F3FF}\u200D\u{1F680}", "\u{1F468}\u{1F3FF}\u200D\u{1F692}", "\u{1F468}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FF}\u200D\u{1F9BD}", "\u{1F469}\u200D\u2695\uFE0F", "\u{1F469}\u200D\u2696\uFE0F", "\u{1F469}\u200D\u2708\uFE0F", "\u{1F469}\u200D\u{1F33E}", "\u{1F469}\u200D\u{1F373}", "\u{1F469}\u200D\u{1F37C}", "\u{1F469}\u200D\u{1F393}", "\u{1F469}\u200D\u{1F3A4}", "\u{1F469}\u200D\u{1F3A8}", "\u{1F469}\u200D\u{1F3EB}", "\u{1F469}\u200D\u{1F3ED}", "\u{1F469}\u200D\u{1F4BB}", "\u{1F469}\u200D\u{1F4BC}", "\u{1F469}\u200D\u{1F527}", "\u{1F469}\u200D\u{1F52C}", "\u{1F469}\u200D\u{1F680}", "\u{1F469}\u200D\u{1F692}", "\u{1F469}\u200D\u{1F9AF}", "\u{1F469}\u200D\u{1F9BC}", "\u{1F469}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u{1F33E}", "\u{1F469}\u{1F3FB}\u200D\u{1F373}", "\u{1F469}\u{1F3FB}\u200D\u{1F37C}", "\u{1F469}\u{1F3FB}\u200D\u{1F393}", "\u{1F469}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FB}\u200D\u{1F527}", "\u{1F469}\u{1F3FB}\u200D\u{1F52C}", "\u{1F469}\u{1F3FB}\u200D\u{1F680}", "\u{1F469}\u{1F3FB}\u200D\u{1F692}", "\u{1F469}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u{1F33E}", "\u{1F469}\u{1F3FC}\u200D\u{1F373}", "\u{1F469}\u{1F3FC}\u200D\u{1F37C}", "\u{1F469}\u{1F3FC}\u200D\u{1F393}", "\u{1F469}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FC}\u200D\u{1F527}", "\u{1F469}\u{1F3FC}\u200D\u{1F52C}", "\u{1F469}\u{1F3FC}\u200D\u{1F680}", "\u{1F469}\u{1F3FC}\u200D\u{1F692}", "\u{1F469}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u{1F33E}", "\u{1F469}\u{1F3FD}\u200D\u{1F373}", "\u{1F469}\u{1F3FD}\u200D\u{1F37C}", "\u{1F469}\u{1F3FD}\u200D\u{1F393}", "\u{1F469}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FD}\u200D\u{1F527}", "\u{1F469}\u{1F3FD}\u200D\u{1F52C}", "\u{1F469}\u{1F3FD}\u200D\u{1F680}", "\u{1F469}\u{1F3FD}\u200D\u{1F692}", "\u{1F469}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u{1F33E}", "\u{1F469}\u{1F3FE}\u200D\u{1F373}", "\u{1F469}\u{1F3FE}\u200D\u{1F37C}", "\u{1F469}\u{1F3FE}\u200D\u{1F393}", "\u{1F469}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FE}\u200D\u{1F527}", "\u{1F469}\u{1F3FE}\u200D\u{1F52C}", "\u{1F469}\u{1F3FE}\u200D\u{1F680}", "\u{1F469}\u{1F3FE}\u200D\u{1F692}", "\u{1F469}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u{1F33E}", "\u{1F469}\u{1F3FF}\u200D\u{1F373}", "\u{1F469}\u{1F3FF}\u200D\u{1F37C}", "\u{1F469}\u{1F3FF}\u200D\u{1F393}", "\u{1F469}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FF}\u200D\u{1F527}", "\u{1F469}\u{1F3FF}\u200D\u{1F52C}", "\u{1F469}\u{1F3FF}\u200D\u{1F680}", "\u{1F469}\u{1F3FF}\u200D\u{1F692}", "\u{1F469}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FF}\u200D\u{1F9BD}", "\u{1F9D1}\u200D\u2695\uFE0F", "\u{1F9D1}\u200D\u2696\uFE0F", "\u{1F9D1}\u200D\u2708\uFE0F", "\u{1F9D1}\u200D\u{1F33E}", "\u{1F9D1}\u200D\u{1F373}", "\u{1F9D1}\u200D\u{1F37C}", "\u{1F9D1}\u200D\u{1F393}", "\u{1F9D1}\u200D\u{1F3A4}", "\u{1F9D1}\u200D\u{1F3A8}", "\u{1F9D1}\u200D\u{1F3EB}", "\u{1F9D1}\u200D\u{1F3ED}", "\u{1F9D1}\u200D\u{1F4BB}", "\u{1F9D1}\u200D\u{1F4BC}", "\u{1F9D1}\u200D\u{1F527}", "\u{1F9D1}\u200D\u{1F52C}", "\u{1F9D1}\u200D\u{1F680}", "\u{1F9D1}\u200D\u{1F692}", "\u{1F9D1}\u200D\u{1F9AF}", "\u{1F9D1}\u200D\u{1F9BC}", "\u{1F9D1}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9BD}", "\u26F9\u{1F3FB}\u200D\u2640\uFE0F", "\u26F9\u{1F3FB}\u200D\u2642\uFE0F", "\u26F9\u{1F3FC}\u200D\u2640\uFE0F", "\u26F9\u{1F3FC}\u200D\u2642\uFE0F", "\u26F9\u{1F3FD}\u200D\u2640\uFE0F", "\u26F9\u{1F3FD}\u200D\u2642\uFE0F", "\u26F9\u{1F3FE}\u200D\u2640\uFE0F", "\u26F9\u{1F3FE}\u200D\u2642\uFE0F", "\u26F9\u{1F3FF}\u200D\u2640\uFE0F", "\u26F9\u{1F3FF}\u200D\u2642\uFE0F", "\u26F9\uFE0F\u200D\u2640\uFE0F", "\u26F9\uFE0F\u200D\u2642\uFE0F", "\u{1F3C3}\u200D\u2640\uFE0F", "\u{1F3C3}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3C4}\u200D\u2640\uFE0F", "\u{1F3C4}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CA}\u200D\u2640\uFE0F", "\u{1F3CA}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CB}\uFE0F\u200D\u2640\uFE0F", "\u{1F3CB}\uFE0F\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CC}\uFE0F\u200D\u2640\uFE0F", "\u{1F3CC}\uFE0F\u200D\u2642\uFE0F", "\u{1F46E}\u200D\u2640\uFE0F", "\u{1F46E}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F46F}\u200D\u2640\uFE0F", "\u{1F46F}\u200D\u2642\uFE0F", "\u{1F470}\u200D\u2640\uFE0F", "\u{1F470}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F471}\u200D\u2640\uFE0F", "\u{1F471}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F473}\u200D\u2640\uFE0F", "\u{1F473}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F477}\u200D\u2640\uFE0F", "\u{1F477}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F481}\u200D\u2640\uFE0F", "\u{1F481}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F482}\u200D\u2640\uFE0F", "\u{1F482}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F486}\u200D\u2640\uFE0F", "\u{1F486}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F487}\u200D\u2640\uFE0F", "\u{1F487}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F575}\uFE0F\u200D\u2640\uFE0F", "\u{1F575}\uFE0F\u200D\u2642\uFE0F", "\u{1F645}\u200D\u2640\uFE0F", "\u{1F645}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F646}\u200D\u2640\uFE0F", "\u{1F646}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F647}\u200D\u2640\uFE0F", "\u{1F647}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64B}\u200D\u2640\uFE0F", "\u{1F64B}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64D}\u200D\u2640\uFE0F", "\u{1F64D}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64E}\u200D\u2640\uFE0F", "\u{1F64E}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6A3}\u200D\u2640\uFE0F", "\u{1F6A3}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B4}\u200D\u2640\uFE0F", "\u{1F6B4}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B5}\u200D\u2640\uFE0F", "\u{1F6B5}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B6}\u200D\u2640\uFE0F", "\u{1F6B6}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F926}\u200D\u2640\uFE0F", "\u{1F926}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F935}\u200D\u2640\uFE0F", "\u{1F935}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F937}\u200D\u2640\uFE0F", "\u{1F937}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F938}\u200D\u2640\uFE0F", "\u{1F938}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F939}\u200D\u2640\uFE0F", "\u{1F939}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F93C}\u200D\u2640\uFE0F", "\u{1F93C}\u200D\u2642\uFE0F", "\u{1F93D}\u200D\u2640\uFE0F", "\u{1F93D}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F93E}\u200D\u2640\uFE0F", "\u{1F93E}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9B8}\u200D\u2640\uFE0F", "\u{1F9B8}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9B9}\u200D\u2640\uFE0F", "\u{1F9B9}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9CD}\u200D\u2640\uFE0F", "\u{1F9CD}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9CE}\u200D\u2640\uFE0F", "\u{1F9CE}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9CF}\u200D\u2640\uFE0F", "\u{1F9CF}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D4}\u200D\u2640\uFE0F", "\u{1F9D4}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D6}\u200D\u2640\uFE0F", "\u{1F9D6}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D7}\u200D\u2640\uFE0F", "\u{1F9D7}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D8}\u200D\u2640\uFE0F", "\u{1F9D8}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D9}\u200D\u2640\uFE0F", "\u{1F9D9}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DA}\u200D\u2640\uFE0F", "\u{1F9DA}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DB}\u200D\u2640\uFE0F", "\u{1F9DB}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DC}\u200D\u2640\uFE0F", "\u{1F9DC}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DD}\u200D\u2640\uFE0F", "\u{1F9DD}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DE}\u200D\u2640\uFE0F", "\u{1F9DE}\u200D\u2642\uFE0F", "\u{1F9DF}\u200D\u2640\uFE0F", "\u{1F9DF}\u200D\u2642\uFE0F", "\u{1F468}\u200D\u{1F9B0}", "\u{1F468}\u200D\u{1F9B1}", "\u{1F468}\u200D\u{1F9B2}", "\u{1F468}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B3}", "\u{1F469}\u200D\u{1F9B0}", "\u{1F469}\u200D\u{1F9B1}", "\u{1F469}\u200D\u{1F9B2}", "\u{1F469}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B3}", "\u{1F9D1}\u200D\u{1F9B0}", "\u{1F9D1}\u200D\u{1F9B1}", "\u{1F9D1}\u200D\u{1F9B2}", "\u{1F9D1}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B3}", "\u2764\uFE0F\u200D\u{1F525}", "\u2764\uFE0F\u200D\u{1FA79}", "\u{1F3F3}\uFE0F\u200D\u26A7\uFE0F", "\u{1F3F3}\uFE0F\u200D\u{1F308}", "\u{1F3F4}\u200D\u2620\uFE0F", "\u{1F408}\u200D\u2B1B", "\u{1F415}\u200D\u{1F9BA}", "\u{1F43B}\u200D\u2744\uFE0F", "\u{1F441}\uFE0F\u200D\u{1F5E8}\uFE0F", "\u{1F62E}\u200D\u{1F4A8}", "\u{1F635}\u200D\u{1F4AB}", "\u{1F636}\u200D\u{1F32B}\uFE0F", "\u{1F9D1}\u200D\u{1F384}"];
      return RGI_Emoji_ZWJ_Sequence;
    }
    var RGI_Emoji = {};
    var hasRequiredRGI_Emoji;
    function requireRGI_Emoji() {
      if (hasRequiredRGI_Emoji)
        return RGI_Emoji;
      hasRequiredRGI_Emoji = 1;
      var set3 = regenerate$2.exports(9200, 9203, 9855, 9875, 9889, 9934, 9940, 9962, 9973, 9978, 9981, 9989, 10024, 10060, 10062, 10071, 10160, 10175, 11088, 11093, 126980, 127183, 127374, 127489, 127514, 127535, 127988, 128064, 128378, 128420, 128716, 129008);
      set3.addRange(8986, 8987).addRange(9193, 9196).addRange(9725, 9726).addRange(9748, 9749).addRange(9800, 9811).addRange(9898, 9899).addRange(9917, 9918).addRange(9924, 9925).addRange(9970, 9971).addRange(9994, 9995).addRange(10067, 10069).addRange(10133, 10135).addRange(11035, 11036).addRange(127377, 127386).addRange(127538, 127542).addRange(127544, 127546).addRange(127568, 127569).addRange(127744, 127776).addRange(127789, 127797).addRange(127799, 127868).addRange(127870, 127891).addRange(127904, 127946).addRange(127951, 127955).addRange(127968, 127984).addRange(127992, 128062).addRange(128066, 128252).addRange(128255, 128317).addRange(128331, 128334).addRange(128336, 128359).addRange(128405, 128406).addRange(128507, 128591).addRange(128640, 128709).addRange(128720, 128722).addRange(128725, 128727).addRange(128733, 128735).addRange(128747, 128748).addRange(128756, 128764).addRange(128992, 129003).addRange(129292, 129338).addRange(129340, 129349).addRange(129351, 129535).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782);
      RGI_Emoji.characters = set3;
      RGI_Emoji.strings = ["#\uFE0F\u20E3", "*\uFE0F\u20E3", "0\uFE0F\u20E3", "1\uFE0F\u20E3", "2\uFE0F\u20E3", "3\uFE0F\u20E3", "4\uFE0F\u20E3", "5\uFE0F\u20E3", "6\uFE0F\u20E3", "7\uFE0F\u20E3", "8\uFE0F\u20E3", "9\uFE0F\u20E3", "\xA9\uFE0F", "\xAE\uFE0F", "\u203C\uFE0F", "\u2049\uFE0F", "\u2122\uFE0F", "\u2139\uFE0F", "\u2194\uFE0F", "\u2195\uFE0F", "\u2196\uFE0F", "\u2197\uFE0F", "\u2198\uFE0F", "\u2199\uFE0F", "\u21A9\uFE0F", "\u21AA\uFE0F", "\u2328\uFE0F", "\u23CF\uFE0F", "\u23ED\uFE0F", "\u23EE\uFE0F", "\u23EF\uFE0F", "\u23F1\uFE0F", "\u23F2\uFE0F", "\u23F8\uFE0F", "\u23F9\uFE0F", "\u23FA\uFE0F", "\u24C2\uFE0F", "\u25AA\uFE0F", "\u25AB\uFE0F", "\u25B6\uFE0F", "\u25C0\uFE0F", "\u25FB\uFE0F", "\u25FC\uFE0F", "\u2600\uFE0F", "\u2601\uFE0F", "\u2602\uFE0F", "\u2603\uFE0F", "\u2604\uFE0F", "\u260E\uFE0F", "\u2611\uFE0F", "\u2618\uFE0F", "\u261D\u{1F3FB}", "\u261D\u{1F3FC}", "\u261D\u{1F3FD}", "\u261D\u{1F3FE}", "\u261D\u{1F3FF}", "\u261D\uFE0F", "\u2620\uFE0F", "\u2622\uFE0F", "\u2623\uFE0F", "\u2626\uFE0F", "\u262A\uFE0F", "\u262E\uFE0F", "\u262F\uFE0F", "\u2638\uFE0F", "\u2639\uFE0F", "\u263A\uFE0F", "\u2640\uFE0F", "\u2642\uFE0F", "\u265F\uFE0F", "\u2660\uFE0F", "\u2663\uFE0F", "\u2665\uFE0F", "\u2666\uFE0F", "\u2668\uFE0F", "\u267B\uFE0F", "\u267E\uFE0F", "\u2692\uFE0F", "\u2694\uFE0F", "\u2695\uFE0F", "\u2696\uFE0F", "\u2697\uFE0F", "\u2699\uFE0F", "\u269B\uFE0F", "\u269C\uFE0F", "\u26A0\uFE0F", "\u26A7\uFE0F", "\u26B0\uFE0F", "\u26B1\uFE0F", "\u26C8\uFE0F", "\u26CF\uFE0F", "\u26D1\uFE0F", "\u26D3\uFE0F", "\u26E9\uFE0F", "\u26F0\uFE0F", "\u26F1\uFE0F", "\u26F4\uFE0F", "\u26F7\uFE0F", "\u26F8\uFE0F", "\u26F9\u{1F3FB}", "\u26F9\u{1F3FB}\u200D\u2640\uFE0F", "\u26F9\u{1F3FB}\u200D\u2642\uFE0F", "\u26F9\u{1F3FC}", "\u26F9\u{1F3FC}\u200D\u2640\uFE0F", "\u26F9\u{1F3FC}\u200D\u2642\uFE0F", "\u26F9\u{1F3FD}", "\u26F9\u{1F3FD}\u200D\u2640\uFE0F", "\u26F9\u{1F3FD}\u200D\u2642\uFE0F", "\u26F9\u{1F3FE}", "\u26F9\u{1F3FE}\u200D\u2640\uFE0F", "\u26F9\u{1F3FE}\u200D\u2642\uFE0F", "\u26F9\u{1F3FF}", "\u26F9\u{1F3FF}\u200D\u2640\uFE0F", "\u26F9\u{1F3FF}\u200D\u2642\uFE0F", "\u26F9\uFE0F", "\u26F9\uFE0F\u200D\u2640\uFE0F", "\u26F9\uFE0F\u200D\u2642\uFE0F", "\u2702\uFE0F", "\u2708\uFE0F", "\u2709\uFE0F", "\u270A\u{1F3FB}", "\u270A\u{1F3FC}", "\u270A\u{1F3FD}", "\u270A\u{1F3FE}", "\u270A\u{1F3FF}", "\u270B\u{1F3FB}", "\u270B\u{1F3FC}", "\u270B\u{1F3FD}", "\u270B\u{1F3FE}", "\u270B\u{1F3FF}", "\u270C\u{1F3FB}", "\u270C\u{1F3FC}", "\u270C\u{1F3FD}", "\u270C\u{1F3FE}", "\u270C\u{1F3FF}", "\u270C\uFE0F", "\u270D\u{1F3FB}", "\u270D\u{1F3FC}", "\u270D\u{1F3FD}", "\u270D\u{1F3FE}", "\u270D\u{1F3FF}", "\u270D\uFE0F", "\u270F\uFE0F", "\u2712\uFE0F", "\u2714\uFE0F", "\u2716\uFE0F", "\u271D\uFE0F", "\u2721\uFE0F", "\u2733\uFE0F", "\u2734\uFE0F", "\u2744\uFE0F", "\u2747\uFE0F", "\u2763\uFE0F", "\u2764\uFE0F", "\u2764\uFE0F\u200D\u{1F525}", "\u2764\uFE0F\u200D\u{1FA79}", "\u27A1\uFE0F", "\u2934\uFE0F", "\u2935\uFE0F", "\u2B05\uFE0F", "\u2B06\uFE0F", "\u2B07\uFE0F", "\u3030\uFE0F", "\u303D\uFE0F", "\u3297\uFE0F", "\u3299\uFE0F", "\u{1F170}\uFE0F", "\u{1F171}\uFE0F", "\u{1F17E}\uFE0F", "\u{1F17F}\uFE0F", "\u{1F1E6}\u{1F1E8}", "\u{1F1E6}\u{1F1E9}", "\u{1F1E6}\u{1F1EA}", "\u{1F1E6}\u{1F1EB}", "\u{1F1E6}\u{1F1EC}", "\u{1F1E6}\u{1F1EE}", "\u{1F1E6}\u{1F1F1}", "\u{1F1E6}\u{1F1F2}", "\u{1F1E6}\u{1F1F4}", "\u{1F1E6}\u{1F1F6}", "\u{1F1E6}\u{1F1F7}", "\u{1F1E6}\u{1F1F8}", "\u{1F1E6}\u{1F1F9}", "\u{1F1E6}\u{1F1FA}", "\u{1F1E6}\u{1F1FC}", "\u{1F1E6}\u{1F1FD}", "\u{1F1E6}\u{1F1FF}", "\u{1F1E7}\u{1F1E6}", "\u{1F1E7}\u{1F1E7}", "\u{1F1E7}\u{1F1E9}", "\u{1F1E7}\u{1F1EA}", "\u{1F1E7}\u{1F1EB}", "\u{1F1E7}\u{1F1EC}", "\u{1F1E7}\u{1F1ED}", "\u{1F1E7}\u{1F1EE}", "\u{1F1E7}\u{1F1EF}", "\u{1F1E7}\u{1F1F1}", "\u{1F1E7}\u{1F1F2}", "\u{1F1E7}\u{1F1F3}", "\u{1F1E7}\u{1F1F4}", "\u{1F1E7}\u{1F1F6}", "\u{1F1E7}\u{1F1F7}", "\u{1F1E7}\u{1F1F8}", "\u{1F1E7}\u{1F1F9}", "\u{1F1E7}\u{1F1FB}", "\u{1F1E7}\u{1F1FC}", "\u{1F1E7}\u{1F1FE}", "\u{1F1E7}\u{1F1FF}", "\u{1F1E8}\u{1F1E6}", "\u{1F1E8}\u{1F1E8}", "\u{1F1E8}\u{1F1E9}", "\u{1F1E8}\u{1F1EB}", "\u{1F1E8}\u{1F1EC}", "\u{1F1E8}\u{1F1ED}", "\u{1F1E8}\u{1F1EE}", "\u{1F1E8}\u{1F1F0}", "\u{1F1E8}\u{1F1F1}", "\u{1F1E8}\u{1F1F2}", "\u{1F1E8}\u{1F1F3}", "\u{1F1E8}\u{1F1F4}", "\u{1F1E8}\u{1F1F5}", "\u{1F1E8}\u{1F1F7}", "\u{1F1E8}\u{1F1FA}", "\u{1F1E8}\u{1F1FB}", "\u{1F1E8}\u{1F1FC}", "\u{1F1E8}\u{1F1FD}", "\u{1F1E8}\u{1F1FE}", "\u{1F1E8}\u{1F1FF}", "\u{1F1E9}\u{1F1EA}", "\u{1F1E9}\u{1F1EC}", "\u{1F1E9}\u{1F1EF}", "\u{1F1E9}\u{1F1F0}", "\u{1F1E9}\u{1F1F2}", "\u{1F1E9}\u{1F1F4}", "\u{1F1E9}\u{1F1FF}", "\u{1F1EA}\u{1F1E6}", "\u{1F1EA}\u{1F1E8}", "\u{1F1EA}\u{1F1EA}", "\u{1F1EA}\u{1F1EC}", "\u{1F1EA}\u{1F1ED}", "\u{1F1EA}\u{1F1F7}", "\u{1F1EA}\u{1F1F8}", "\u{1F1EA}\u{1F1F9}", "\u{1F1EA}\u{1F1FA}", "\u{1F1EB}\u{1F1EE}", "\u{1F1EB}\u{1F1EF}", "\u{1F1EB}\u{1F1F0}", "\u{1F1EB}\u{1F1F2}", "\u{1F1EB}\u{1F1F4}", "\u{1F1EB}\u{1F1F7}", "\u{1F1EC}\u{1F1E6}", "\u{1F1EC}\u{1F1E7}", "\u{1F1EC}\u{1F1E9}", "\u{1F1EC}\u{1F1EA}", "\u{1F1EC}\u{1F1EB}", "\u{1F1EC}\u{1F1EC}", "\u{1F1EC}\u{1F1ED}", "\u{1F1EC}\u{1F1EE}", "\u{1F1EC}\u{1F1F1}", "\u{1F1EC}\u{1F1F2}", "\u{1F1EC}\u{1F1F3}", "\u{1F1EC}\u{1F1F5}", "\u{1F1EC}\u{1F1F6}", "\u{1F1EC}\u{1F1F7}", "\u{1F1EC}\u{1F1F8}", "\u{1F1EC}\u{1F1F9}", "\u{1F1EC}\u{1F1FA}", "\u{1F1EC}\u{1F1FC}", "\u{1F1EC}\u{1F1FE}", "\u{1F1ED}\u{1F1F0}", "\u{1F1ED}\u{1F1F2}", "\u{1F1ED}\u{1F1F3}", "\u{1F1ED}\u{1F1F7}", "\u{1F1ED}\u{1F1F9}", "\u{1F1ED}\u{1F1FA}", "\u{1F1EE}\u{1F1E8}", "\u{1F1EE}\u{1F1E9}", "\u{1F1EE}\u{1F1EA}", "\u{1F1EE}\u{1F1F1}", "\u{1F1EE}\u{1F1F2}", "\u{1F1EE}\u{1F1F3}", "\u{1F1EE}\u{1F1F4}", "\u{1F1EE}\u{1F1F6}", "\u{1F1EE}\u{1F1F7}", "\u{1F1EE}\u{1F1F8}", "\u{1F1EE}\u{1F1F9}", "\u{1F1EF}\u{1F1EA}", "\u{1F1EF}\u{1F1F2}", "\u{1F1EF}\u{1F1F4}", "\u{1F1EF}\u{1F1F5}", "\u{1F1F0}\u{1F1EA}", "\u{1F1F0}\u{1F1EC}", "\u{1F1F0}\u{1F1ED}", "\u{1F1F0}\u{1F1EE}", "\u{1F1F0}\u{1F1F2}", "\u{1F1F0}\u{1F1F3}", "\u{1F1F0}\u{1F1F5}", "\u{1F1F0}\u{1F1F7}", "\u{1F1F0}\u{1F1FC}", "\u{1F1F0}\u{1F1FE}", "\u{1F1F0}\u{1F1FF}", "\u{1F1F1}\u{1F1E6}", "\u{1F1F1}\u{1F1E7}", "\u{1F1F1}\u{1F1E8}", "\u{1F1F1}\u{1F1EE}", "\u{1F1F1}\u{1F1F0}", "\u{1F1F1}\u{1F1F7}", "\u{1F1F1}\u{1F1F8}", "\u{1F1F1}\u{1F1F9}", "\u{1F1F1}\u{1F1FA}", "\u{1F1F1}\u{1F1FB}", "\u{1F1F1}\u{1F1FE}", "\u{1F1F2}\u{1F1E6}", "\u{1F1F2}\u{1F1E8}", "\u{1F1F2}\u{1F1E9}", "\u{1F1F2}\u{1F1EA}", "\u{1F1F2}\u{1F1EB}", "\u{1F1F2}\u{1F1EC}", "\u{1F1F2}\u{1F1ED}", "\u{1F1F2}\u{1F1F0}", "\u{1F1F2}\u{1F1F1}", "\u{1F1F2}\u{1F1F2}", "\u{1F1F2}\u{1F1F3}", "\u{1F1F2}\u{1F1F4}", "\u{1F1F2}\u{1F1F5}", "\u{1F1F2}\u{1F1F6}", "\u{1F1F2}\u{1F1F7}", "\u{1F1F2}\u{1F1F8}", "\u{1F1F2}\u{1F1F9}", "\u{1F1F2}\u{1F1FA}", "\u{1F1F2}\u{1F1FB}", "\u{1F1F2}\u{1F1FC}", "\u{1F1F2}\u{1F1FD}", "\u{1F1F2}\u{1F1FE}", "\u{1F1F2}\u{1F1FF}", "\u{1F1F3}\u{1F1E6}", "\u{1F1F3}\u{1F1E8}", "\u{1F1F3}\u{1F1EA}", "\u{1F1F3}\u{1F1EB}", "\u{1F1F3}\u{1F1EC}", "\u{1F1F3}\u{1F1EE}", "\u{1F1F3}\u{1F1F1}", "\u{1F1F3}\u{1F1F4}", "\u{1F1F3}\u{1F1F5}", "\u{1F1F3}\u{1F1F7}", "\u{1F1F3}\u{1F1FA}", "\u{1F1F3}\u{1F1FF}", "\u{1F1F4}\u{1F1F2}", "\u{1F1F5}\u{1F1E6}", "\u{1F1F5}\u{1F1EA}", "\u{1F1F5}\u{1F1EB}", "\u{1F1F5}\u{1F1EC}", "\u{1F1F5}\u{1F1ED}", "\u{1F1F5}\u{1F1F0}", "\u{1F1F5}\u{1F1F1}", "\u{1F1F5}\u{1F1F2}", "\u{1F1F5}\u{1F1F3}", "\u{1F1F5}\u{1F1F7}", "\u{1F1F5}\u{1F1F8}", "\u{1F1F5}\u{1F1F9}", "\u{1F1F5}\u{1F1FC}", "\u{1F1F5}\u{1F1FE}", "\u{1F1F6}\u{1F1E6}", "\u{1F1F7}\u{1F1EA}", "\u{1F1F7}\u{1F1F4}", "\u{1F1F7}\u{1F1F8}", "\u{1F1F7}\u{1F1FA}", "\u{1F1F7}\u{1F1FC}", "\u{1F1F8}\u{1F1E6}", "\u{1F1F8}\u{1F1E7}", "\u{1F1F8}\u{1F1E8}", "\u{1F1F8}\u{1F1E9}", "\u{1F1F8}\u{1F1EA}", "\u{1F1F8}\u{1F1EC}", "\u{1F1F8}\u{1F1ED}", "\u{1F1F8}\u{1F1EE}", "\u{1F1F8}\u{1F1EF}", "\u{1F1F8}\u{1F1F0}", "\u{1F1F8}\u{1F1F1}", "\u{1F1F8}\u{1F1F2}", "\u{1F1F8}\u{1F1F3}", "\u{1F1F8}\u{1F1F4}", "\u{1F1F8}\u{1F1F7}", "\u{1F1F8}\u{1F1F8}", "\u{1F1F8}\u{1F1F9}", "\u{1F1F8}\u{1F1FB}", "\u{1F1F8}\u{1F1FD}", "\u{1F1F8}\u{1F1FE}", "\u{1F1F8}\u{1F1FF}", "\u{1F1F9}\u{1F1E6}", "\u{1F1F9}\u{1F1E8}", "\u{1F1F9}\u{1F1E9}", "\u{1F1F9}\u{1F1EB}", "\u{1F1F9}\u{1F1EC}", "\u{1F1F9}\u{1F1ED}", "\u{1F1F9}\u{1F1EF}", "\u{1F1F9}\u{1F1F0}", "\u{1F1F9}\u{1F1F1}", "\u{1F1F9}\u{1F1F2}", "\u{1F1F9}\u{1F1F3}", "\u{1F1F9}\u{1F1F4}", "\u{1F1F9}\u{1F1F7}", "\u{1F1F9}\u{1F1F9}", "\u{1F1F9}\u{1F1FB}", "\u{1F1F9}\u{1F1FC}", "\u{1F1F9}\u{1F1FF}", "\u{1F1FA}\u{1F1E6}", "\u{1F1FA}\u{1F1EC}", "\u{1F1FA}\u{1F1F2}", "\u{1F1FA}\u{1F1F3}", "\u{1F1FA}\u{1F1F8}", "\u{1F1FA}\u{1F1FE}", "\u{1F1FA}\u{1F1FF}", "\u{1F1FB}\u{1F1E6}", "\u{1F1FB}\u{1F1E8}", "\u{1F1FB}\u{1F1EA}", "\u{1F1FB}\u{1F1EC}", "\u{1F1FB}\u{1F1EE}", "\u{1F1FB}\u{1F1F3}", "\u{1F1FB}\u{1F1FA}", "\u{1F1FC}\u{1F1EB}", "\u{1F1FC}\u{1F1F8}", "\u{1F1FD}\u{1F1F0}", "\u{1F1FE}\u{1F1EA}", "\u{1F1FE}\u{1F1F9}", "\u{1F1FF}\u{1F1E6}", "\u{1F1FF}\u{1F1F2}", "\u{1F1FF}\u{1F1FC}", "\u{1F202}\uFE0F", "\u{1F237}\uFE0F", "\u{1F321}\uFE0F", "\u{1F324}\uFE0F", "\u{1F325}\uFE0F", "\u{1F326}\uFE0F", "\u{1F327}\uFE0F", "\u{1F328}\uFE0F", "\u{1F329}\uFE0F", "\u{1F32A}\uFE0F", "\u{1F32B}\uFE0F", "\u{1F32C}\uFE0F", "\u{1F336}\uFE0F", "\u{1F37D}\uFE0F", "\u{1F385}\u{1F3FB}", "\u{1F385}\u{1F3FC}", "\u{1F385}\u{1F3FD}", "\u{1F385}\u{1F3FE}", "\u{1F385}\u{1F3FF}", "\u{1F396}\uFE0F", "\u{1F397}\uFE0F", "\u{1F399}\uFE0F", "\u{1F39A}\uFE0F", "\u{1F39B}\uFE0F", "\u{1F39E}\uFE0F", "\u{1F39F}\uFE0F", "\u{1F3C2}\u{1F3FB}", "\u{1F3C2}\u{1F3FC}", "\u{1F3C2}\u{1F3FD}", "\u{1F3C2}\u{1F3FE}", "\u{1F3C2}\u{1F3FF}", "\u{1F3C3}\u200D\u2640\uFE0F", "\u{1F3C3}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FB}", "\u{1F3C3}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FC}", "\u{1F3C3}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FD}", "\u{1F3C3}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FE}", "\u{1F3C3}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3C3}\u{1F3FF}", "\u{1F3C3}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3C3}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3C4}\u200D\u2640\uFE0F", "\u{1F3C4}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FB}", "\u{1F3C4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FC}", "\u{1F3C4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FD}", "\u{1F3C4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FE}", "\u{1F3C4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3C4}\u{1F3FF}", "\u{1F3C4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3C4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3C7}\u{1F3FB}", "\u{1F3C7}\u{1F3FC}", "\u{1F3C7}\u{1F3FD}", "\u{1F3C7}\u{1F3FE}", "\u{1F3C7}\u{1F3FF}", "\u{1F3CA}\u200D\u2640\uFE0F", "\u{1F3CA}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FB}", "\u{1F3CA}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FC}", "\u{1F3CA}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FD}", "\u{1F3CA}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FE}", "\u{1F3CA}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CA}\u{1F3FF}", "\u{1F3CA}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CA}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FB}", "\u{1F3CB}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FC}", "\u{1F3CB}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FD}", "\u{1F3CB}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FE}", "\u{1F3CB}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CB}\u{1F3FF}", "\u{1F3CB}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CB}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CB}\uFE0F", "\u{1F3CB}\uFE0F\u200D\u2640\uFE0F", "\u{1F3CB}\uFE0F\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FB}", "\u{1F3CC}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FC}", "\u{1F3CC}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FD}", "\u{1F3CC}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FE}", "\u{1F3CC}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F3CC}\u{1F3FF}", "\u{1F3CC}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F3CC}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F3CC}\uFE0F", "\u{1F3CC}\uFE0F\u200D\u2640\uFE0F", "\u{1F3CC}\uFE0F\u200D\u2642\uFE0F", "\u{1F3CD}\uFE0F", "\u{1F3CE}\uFE0F", "\u{1F3D4}\uFE0F", "\u{1F3D5}\uFE0F", "\u{1F3D6}\uFE0F", "\u{1F3D7}\uFE0F", "\u{1F3D8}\uFE0F", "\u{1F3D9}\uFE0F", "\u{1F3DA}\uFE0F", "\u{1F3DB}\uFE0F", "\u{1F3DC}\uFE0F", "\u{1F3DD}\uFE0F", "\u{1F3DE}\uFE0F", "\u{1F3DF}\uFE0F", "\u{1F3F3}\uFE0F", "\u{1F3F3}\uFE0F\u200D\u26A7\uFE0F", "\u{1F3F3}\uFE0F\u200D\u{1F308}", "\u{1F3F4}\u200D\u2620\uFE0F", "\u{1F3F4}\u{E0067}\u{E0062}\u{E0065}\u{E006E}\u{E0067}\u{E007F}", "\u{1F3F4}\u{E0067}\u{E0062}\u{E0073}\u{E0063}\u{E0074}\u{E007F}", "\u{1F3F4}\u{E0067}\u{E0062}\u{E0077}\u{E006C}\u{E0073}\u{E007F}", "\u{1F3F5}\uFE0F", "\u{1F3F7}\uFE0F", "\u{1F408}\u200D\u2B1B", "\u{1F415}\u200D\u{1F9BA}", "\u{1F43B}\u200D\u2744\uFE0F", "\u{1F43F}\uFE0F", "\u{1F441}\uFE0F", "\u{1F441}\uFE0F\u200D\u{1F5E8}\uFE0F", "\u{1F442}\u{1F3FB}", "\u{1F442}\u{1F3FC}", "\u{1F442}\u{1F3FD}", "\u{1F442}\u{1F3FE}", "\u{1F442}\u{1F3FF}", "\u{1F443}\u{1F3FB}", "\u{1F443}\u{1F3FC}", "\u{1F443}\u{1F3FD}", "\u{1F443}\u{1F3FE}", "\u{1F443}\u{1F3FF}", "\u{1F446}\u{1F3FB}", "\u{1F446}\u{1F3FC}", "\u{1F446}\u{1F3FD}", "\u{1F446}\u{1F3FE}", "\u{1F446}\u{1F3FF}", "\u{1F447}\u{1F3FB}", "\u{1F447}\u{1F3FC}", "\u{1F447}\u{1F3FD}", "\u{1F447}\u{1F3FE}", "\u{1F447}\u{1F3FF}", "\u{1F448}\u{1F3FB}", "\u{1F448}\u{1F3FC}", "\u{1F448}\u{1F3FD}", "\u{1F448}\u{1F3FE}", "\u{1F448}\u{1F3FF}", "\u{1F449}\u{1F3FB}", "\u{1F449}\u{1F3FC}", "\u{1F449}\u{1F3FD}", "\u{1F449}\u{1F3FE}", "\u{1F449}\u{1F3FF}", "\u{1F44A}\u{1F3FB}", "\u{1F44A}\u{1F3FC}", "\u{1F44A}\u{1F3FD}", "\u{1F44A}\u{1F3FE}", "\u{1F44A}\u{1F3FF}", "\u{1F44B}\u{1F3FB}", "\u{1F44B}\u{1F3FC}", "\u{1F44B}\u{1F3FD}", "\u{1F44B}\u{1F3FE}", "\u{1F44B}\u{1F3FF}", "\u{1F44C}\u{1F3FB}", "\u{1F44C}\u{1F3FC}", "\u{1F44C}\u{1F3FD}", "\u{1F44C}\u{1F3FE}", "\u{1F44C}\u{1F3FF}", "\u{1F44D}\u{1F3FB}", "\u{1F44D}\u{1F3FC}", "\u{1F44D}\u{1F3FD}", "\u{1F44D}\u{1F3FE}", "\u{1F44D}\u{1F3FF}", "\u{1F44E}\u{1F3FB}", "\u{1F44E}\u{1F3FC}", "\u{1F44E}\u{1F3FD}", "\u{1F44E}\u{1F3FE}", "\u{1F44E}\u{1F3FF}", "\u{1F44F}\u{1F3FB}", "\u{1F44F}\u{1F3FC}", "\u{1F44F}\u{1F3FD}", "\u{1F44F}\u{1F3FE}", "\u{1F44F}\u{1F3FF}", "\u{1F450}\u{1F3FB}", "\u{1F450}\u{1F3FC}", "\u{1F450}\u{1F3FD}", "\u{1F450}\u{1F3FE}", "\u{1F450}\u{1F3FF}", "\u{1F466}\u{1F3FB}", "\u{1F466}\u{1F3FC}", "\u{1F466}\u{1F3FD}", "\u{1F466}\u{1F3FE}", "\u{1F466}\u{1F3FF}", "\u{1F467}\u{1F3FB}", "\u{1F467}\u{1F3FC}", "\u{1F467}\u{1F3FD}", "\u{1F467}\u{1F3FE}", "\u{1F467}\u{1F3FF}", "\u{1F468}\u200D\u2695\uFE0F", "\u{1F468}\u200D\u2696\uFE0F", "\u{1F468}\u200D\u2708\uFE0F", "\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F468}", "\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}", "\u{1F468}\u200D\u{1F33E}", "\u{1F468}\u200D\u{1F373}", "\u{1F468}\u200D\u{1F37C}", "\u{1F468}\u200D\u{1F393}", "\u{1F468}\u200D\u{1F3A4}", "\u{1F468}\u200D\u{1F3A8}", "\u{1F468}\u200D\u{1F3EB}", "\u{1F468}\u200D\u{1F3ED}", "\u{1F468}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F468}\u200D\u{1F4BB}", "\u{1F468}\u200D\u{1F4BC}", "\u{1F468}\u200D\u{1F527}", "\u{1F468}\u200D\u{1F52C}", "\u{1F468}\u200D\u{1F680}", "\u{1F468}\u200D\u{1F692}", "\u{1F468}\u200D\u{1F9AF}", "\u{1F468}\u200D\u{1F9B0}", "\u{1F468}\u200D\u{1F9B1}", "\u{1F468}\u200D\u{1F9B2}", "\u{1F468}\u200D\u{1F9B3}", "\u{1F468}\u200D\u{1F9BC}", "\u{1F468}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FB}\u200D\u{1F33E}", "\u{1F468}\u{1F3FB}\u200D\u{1F373}", "\u{1F468}\u{1F3FB}\u200D\u{1F37C}", "\u{1F468}\u{1F3FB}\u200D\u{1F393}", "\u{1F468}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FB}\u200D\u{1F527}", "\u{1F468}\u{1F3FB}\u200D\u{1F52C}", "\u{1F468}\u{1F3FB}\u200D\u{1F680}", "\u{1F468}\u{1F3FB}\u200D\u{1F692}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u{1F33E}", "\u{1F468}\u{1F3FC}\u200D\u{1F373}", "\u{1F468}\u{1F3FC}\u200D\u{1F37C}", "\u{1F468}\u{1F3FC}\u200D\u{1F393}", "\u{1F468}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FC}\u200D\u{1F527}", "\u{1F468}\u{1F3FC}\u200D\u{1F52C}", "\u{1F468}\u{1F3FC}\u200D\u{1F680}", "\u{1F468}\u{1F3FC}\u200D\u{1F692}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u{1F33E}", "\u{1F468}\u{1F3FD}\u200D\u{1F373}", "\u{1F468}\u{1F3FD}\u200D\u{1F37C}", "\u{1F468}\u{1F3FD}\u200D\u{1F393}", "\u{1F468}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FD}\u200D\u{1F527}", "\u{1F468}\u{1F3FD}\u200D\u{1F52C}", "\u{1F468}\u{1F3FD}\u200D\u{1F680}", "\u{1F468}\u{1F3FD}\u200D\u{1F692}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u{1F33E}", "\u{1F468}\u{1F3FE}\u200D\u{1F373}", "\u{1F468}\u{1F3FE}\u200D\u{1F37C}", "\u{1F468}\u{1F3FE}\u200D\u{1F393}", "\u{1F468}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FE}\u200D\u{1F527}", "\u{1F468}\u{1F3FE}\u200D\u{1F52C}", "\u{1F468}\u{1F3FE}\u200D\u{1F680}", "\u{1F468}\u{1F3FE}\u200D\u{1F692}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F468}\u{1F3FF}\u200D\u{1F33E}", "\u{1F468}\u{1F3FF}\u200D\u{1F373}", "\u{1F468}\u{1F3FF}\u200D\u{1F37C}", "\u{1F468}\u{1F3FF}\u200D\u{1F393}", "\u{1F468}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F468}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F468}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F468}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F468}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F468}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F468}\u{1F3FF}\u200D\u{1F527}", "\u{1F468}\u{1F3FF}\u200D\u{1F52C}", "\u{1F468}\u{1F3FF}\u200D\u{1F680}", "\u{1F468}\u{1F3FF}\u200D\u{1F692}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F468}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F468}\u{1F3FF}\u200D\u{1F9B3}", "\u{1F468}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F468}\u{1F3FF}\u200D\u{1F9BD}", "\u{1F469}\u200D\u2695\uFE0F", "\u{1F469}\u200D\u2696\uFE0F", "\u{1F469}\u200D\u2708\uFE0F", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F468}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F469}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}", "\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}", "\u{1F469}\u200D\u{1F33E}", "\u{1F469}\u200D\u{1F373}", "\u{1F469}\u200D\u{1F37C}", "\u{1F469}\u200D\u{1F393}", "\u{1F469}\u200D\u{1F3A4}", "\u{1F469}\u200D\u{1F3A8}", "\u{1F469}\u200D\u{1F3EB}", "\u{1F469}\u200D\u{1F3ED}", "\u{1F469}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}", "\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}", "\u{1F469}\u200D\u{1F4BB}", "\u{1F469}\u200D\u{1F4BC}", "\u{1F469}\u200D\u{1F527}", "\u{1F469}\u200D\u{1F52C}", "\u{1F469}\u200D\u{1F680}", "\u{1F469}\u200D\u{1F692}", "\u{1F469}\u200D\u{1F9AF}", "\u{1F469}\u200D\u{1F9B0}", "\u{1F469}\u200D\u{1F9B1}", "\u{1F469}\u200D\u{1F9B2}", "\u{1F469}\u200D\u{1F9B3}", "\u{1F469}\u200D\u{1F9BC}", "\u{1F469}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u{1F33E}", "\u{1F469}\u{1F3FB}\u200D\u{1F373}", "\u{1F469}\u{1F3FB}\u200D\u{1F37C}", "\u{1F469}\u{1F3FB}\u200D\u{1F393}", "\u{1F469}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FB}\u200D\u{1F527}", "\u{1F469}\u{1F3FB}\u200D\u{1F52C}", "\u{1F469}\u{1F3FB}\u200D\u{1F680}", "\u{1F469}\u{1F3FB}\u200D\u{1F692}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u{1F33E}", "\u{1F469}\u{1F3FC}\u200D\u{1F373}", "\u{1F469}\u{1F3FC}\u200D\u{1F37C}", "\u{1F469}\u{1F3FC}\u200D\u{1F393}", "\u{1F469}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FC}\u200D\u{1F527}", "\u{1F469}\u{1F3FC}\u200D\u{1F52C}", "\u{1F469}\u{1F3FC}\u200D\u{1F680}", "\u{1F469}\u{1F3FC}\u200D\u{1F692}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u{1F33E}", "\u{1F469}\u{1F3FD}\u200D\u{1F373}", "\u{1F469}\u{1F3FD}\u200D\u{1F37C}", "\u{1F469}\u{1F3FD}\u200D\u{1F393}", "\u{1F469}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FD}\u200D\u{1F527}", "\u{1F469}\u{1F3FD}\u200D\u{1F52C}", "\u{1F469}\u{1F3FD}\u200D\u{1F680}", "\u{1F469}\u{1F3FD}\u200D\u{1F692}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u{1F33E}", "\u{1F469}\u{1F3FE}\u200D\u{1F373}", "\u{1F469}\u{1F3FE}\u200D\u{1F37C}", "\u{1F469}\u{1F3FE}\u200D\u{1F393}", "\u{1F469}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FE}\u200D\u{1F527}", "\u{1F469}\u{1F3FE}\u200D\u{1F52C}", "\u{1F469}\u{1F3FE}\u200D\u{1F680}", "\u{1F469}\u{1F3FE}\u200D\u{1F692}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}", "\u{1F469}\u{1F3FF}\u200D\u{1F33E}", "\u{1F469}\u{1F3FF}\u200D\u{1F373}", "\u{1F469}\u{1F3FF}\u200D\u{1F37C}", "\u{1F469}\u{1F3FF}\u200D\u{1F393}", "\u{1F469}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F469}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F469}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F469}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F469}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F469}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F469}\u{1F3FF}\u200D\u{1F527}", "\u{1F469}\u{1F3FF}\u200D\u{1F52C}", "\u{1F469}\u{1F3FF}\u200D\u{1F680}", "\u{1F469}\u{1F3FF}\u200D\u{1F692}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}", "\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}", "\u{1F469}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F469}\u{1F3FF}\u200D\u{1F9B3}", "\u{1F469}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F469}\u{1F3FF}\u200D\u{1F9BD}", "\u{1F46B}\u{1F3FB}", "\u{1F46B}\u{1F3FC}", "\u{1F46B}\u{1F3FD}", "\u{1F46B}\u{1F3FE}", "\u{1F46B}\u{1F3FF}", "\u{1F46C}\u{1F3FB}", "\u{1F46C}\u{1F3FC}", "\u{1F46C}\u{1F3FD}", "\u{1F46C}\u{1F3FE}", "\u{1F46C}\u{1F3FF}", "\u{1F46D}\u{1F3FB}", "\u{1F46D}\u{1F3FC}", "\u{1F46D}\u{1F3FD}", "\u{1F46D}\u{1F3FE}", "\u{1F46D}\u{1F3FF}", "\u{1F46E}\u200D\u2640\uFE0F", "\u{1F46E}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FB}", "\u{1F46E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FC}", "\u{1F46E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FD}", "\u{1F46E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FE}", "\u{1F46E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F46E}\u{1F3FF}", "\u{1F46E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F46E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F46F}\u200D\u2640\uFE0F", "\u{1F46F}\u200D\u2642\uFE0F", "\u{1F470}\u200D\u2640\uFE0F", "\u{1F470}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FB}", "\u{1F470}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FC}", "\u{1F470}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FD}", "\u{1F470}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FE}", "\u{1F470}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F470}\u{1F3FF}", "\u{1F470}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F470}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F471}\u200D\u2640\uFE0F", "\u{1F471}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FB}", "\u{1F471}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FC}", "\u{1F471}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FD}", "\u{1F471}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FE}", "\u{1F471}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F471}\u{1F3FF}", "\u{1F471}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F471}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F472}\u{1F3FB}", "\u{1F472}\u{1F3FC}", "\u{1F472}\u{1F3FD}", "\u{1F472}\u{1F3FE}", "\u{1F472}\u{1F3FF}", "\u{1F473}\u200D\u2640\uFE0F", "\u{1F473}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FB}", "\u{1F473}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FC}", "\u{1F473}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FD}", "\u{1F473}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FE}", "\u{1F473}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F473}\u{1F3FF}", "\u{1F473}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F473}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F474}\u{1F3FB}", "\u{1F474}\u{1F3FC}", "\u{1F474}\u{1F3FD}", "\u{1F474}\u{1F3FE}", "\u{1F474}\u{1F3FF}", "\u{1F475}\u{1F3FB}", "\u{1F475}\u{1F3FC}", "\u{1F475}\u{1F3FD}", "\u{1F475}\u{1F3FE}", "\u{1F475}\u{1F3FF}", "\u{1F476}\u{1F3FB}", "\u{1F476}\u{1F3FC}", "\u{1F476}\u{1F3FD}", "\u{1F476}\u{1F3FE}", "\u{1F476}\u{1F3FF}", "\u{1F477}\u200D\u2640\uFE0F", "\u{1F477}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FB}", "\u{1F477}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FC}", "\u{1F477}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FD}", "\u{1F477}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FE}", "\u{1F477}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F477}\u{1F3FF}", "\u{1F477}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F477}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F478}\u{1F3FB}", "\u{1F478}\u{1F3FC}", "\u{1F478}\u{1F3FD}", "\u{1F478}\u{1F3FE}", "\u{1F478}\u{1F3FF}", "\u{1F47C}\u{1F3FB}", "\u{1F47C}\u{1F3FC}", "\u{1F47C}\u{1F3FD}", "\u{1F47C}\u{1F3FE}", "\u{1F47C}\u{1F3FF}", "\u{1F481}\u200D\u2640\uFE0F", "\u{1F481}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FB}", "\u{1F481}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FC}", "\u{1F481}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FD}", "\u{1F481}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FE}", "\u{1F481}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F481}\u{1F3FF}", "\u{1F481}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F481}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F482}\u200D\u2640\uFE0F", "\u{1F482}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FB}", "\u{1F482}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FC}", "\u{1F482}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FD}", "\u{1F482}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FE}", "\u{1F482}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F482}\u{1F3FF}", "\u{1F482}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F482}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F483}\u{1F3FB}", "\u{1F483}\u{1F3FC}", "\u{1F483}\u{1F3FD}", "\u{1F483}\u{1F3FE}", "\u{1F483}\u{1F3FF}", "\u{1F485}\u{1F3FB}", "\u{1F485}\u{1F3FC}", "\u{1F485}\u{1F3FD}", "\u{1F485}\u{1F3FE}", "\u{1F485}\u{1F3FF}", "\u{1F486}\u200D\u2640\uFE0F", "\u{1F486}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FB}", "\u{1F486}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FC}", "\u{1F486}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FD}", "\u{1F486}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FE}", "\u{1F486}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F486}\u{1F3FF}", "\u{1F486}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F486}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F487}\u200D\u2640\uFE0F", "\u{1F487}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FB}", "\u{1F487}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FC}", "\u{1F487}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FD}", "\u{1F487}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FE}", "\u{1F487}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F487}\u{1F3FF}", "\u{1F487}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F487}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F48F}\u{1F3FB}", "\u{1F48F}\u{1F3FC}", "\u{1F48F}\u{1F3FD}", "\u{1F48F}\u{1F3FE}", "\u{1F48F}\u{1F3FF}", "\u{1F491}\u{1F3FB}", "\u{1F491}\u{1F3FC}", "\u{1F491}\u{1F3FD}", "\u{1F491}\u{1F3FE}", "\u{1F491}\u{1F3FF}", "\u{1F4AA}\u{1F3FB}", "\u{1F4AA}\u{1F3FC}", "\u{1F4AA}\u{1F3FD}", "\u{1F4AA}\u{1F3FE}", "\u{1F4AA}\u{1F3FF}", "\u{1F4FD}\uFE0F", "\u{1F549}\uFE0F", "\u{1F54A}\uFE0F", "\u{1F56F}\uFE0F", "\u{1F570}\uFE0F", "\u{1F573}\uFE0F", "\u{1F574}\u{1F3FB}", "\u{1F574}\u{1F3FC}", "\u{1F574}\u{1F3FD}", "\u{1F574}\u{1F3FE}", "\u{1F574}\u{1F3FF}", "\u{1F574}\uFE0F", "\u{1F575}\u{1F3FB}", "\u{1F575}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FC}", "\u{1F575}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FD}", "\u{1F575}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FE}", "\u{1F575}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F575}\u{1F3FF}", "\u{1F575}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F575}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F575}\uFE0F", "\u{1F575}\uFE0F\u200D\u2640\uFE0F", "\u{1F575}\uFE0F\u200D\u2642\uFE0F", "\u{1F576}\uFE0F", "\u{1F577}\uFE0F", "\u{1F578}\uFE0F", "\u{1F579}\uFE0F", "\u{1F57A}\u{1F3FB}", "\u{1F57A}\u{1F3FC}", "\u{1F57A}\u{1F3FD}", "\u{1F57A}\u{1F3FE}", "\u{1F57A}\u{1F3FF}", "\u{1F587}\uFE0F", "\u{1F58A}\uFE0F", "\u{1F58B}\uFE0F", "\u{1F58C}\uFE0F", "\u{1F58D}\uFE0F", "\u{1F590}\u{1F3FB}", "\u{1F590}\u{1F3FC}", "\u{1F590}\u{1F3FD}", "\u{1F590}\u{1F3FE}", "\u{1F590}\u{1F3FF}", "\u{1F590}\uFE0F", "\u{1F595}\u{1F3FB}", "\u{1F595}\u{1F3FC}", "\u{1F595}\u{1F3FD}", "\u{1F595}\u{1F3FE}", "\u{1F595}\u{1F3FF}", "\u{1F596}\u{1F3FB}", "\u{1F596}\u{1F3FC}", "\u{1F596}\u{1F3FD}", "\u{1F596}\u{1F3FE}", "\u{1F596}\u{1F3FF}", "\u{1F5A5}\uFE0F", "\u{1F5A8}\uFE0F", "\u{1F5B1}\uFE0F", "\u{1F5B2}\uFE0F", "\u{1F5BC}\uFE0F", "\u{1F5C2}\uFE0F", "\u{1F5C3}\uFE0F", "\u{1F5C4}\uFE0F", "\u{1F5D1}\uFE0F", "\u{1F5D2}\uFE0F", "\u{1F5D3}\uFE0F", "\u{1F5DC}\uFE0F", "\u{1F5DD}\uFE0F", "\u{1F5DE}\uFE0F", "\u{1F5E1}\uFE0F", "\u{1F5E3}\uFE0F", "\u{1F5E8}\uFE0F", "\u{1F5EF}\uFE0F", "\u{1F5F3}\uFE0F", "\u{1F5FA}\uFE0F", "\u{1F62E}\u200D\u{1F4A8}", "\u{1F635}\u200D\u{1F4AB}", "\u{1F636}\u200D\u{1F32B}\uFE0F", "\u{1F645}\u200D\u2640\uFE0F", "\u{1F645}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FB}", "\u{1F645}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FC}", "\u{1F645}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FD}", "\u{1F645}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FE}", "\u{1F645}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F645}\u{1F3FF}", "\u{1F645}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F645}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F646}\u200D\u2640\uFE0F", "\u{1F646}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FB}", "\u{1F646}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FC}", "\u{1F646}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FD}", "\u{1F646}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FE}", "\u{1F646}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F646}\u{1F3FF}", "\u{1F646}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F646}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F647}\u200D\u2640\uFE0F", "\u{1F647}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FB}", "\u{1F647}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FC}", "\u{1F647}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FD}", "\u{1F647}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FE}", "\u{1F647}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F647}\u{1F3FF}", "\u{1F647}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F647}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64B}\u200D\u2640\uFE0F", "\u{1F64B}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FB}", "\u{1F64B}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FC}", "\u{1F64B}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FD}", "\u{1F64B}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FE}", "\u{1F64B}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64B}\u{1F3FF}", "\u{1F64B}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64B}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64C}\u{1F3FB}", "\u{1F64C}\u{1F3FC}", "\u{1F64C}\u{1F3FD}", "\u{1F64C}\u{1F3FE}", "\u{1F64C}\u{1F3FF}", "\u{1F64D}\u200D\u2640\uFE0F", "\u{1F64D}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FB}", "\u{1F64D}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FC}", "\u{1F64D}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FD}", "\u{1F64D}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FE}", "\u{1F64D}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64D}\u{1F3FF}", "\u{1F64D}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64D}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64E}\u200D\u2640\uFE0F", "\u{1F64E}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FB}", "\u{1F64E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FC}", "\u{1F64E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FD}", "\u{1F64E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FE}", "\u{1F64E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F64E}\u{1F3FF}", "\u{1F64E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F64E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F64F}\u{1F3FB}", "\u{1F64F}\u{1F3FC}", "\u{1F64F}\u{1F3FD}", "\u{1F64F}\u{1F3FE}", "\u{1F64F}\u{1F3FF}", "\u{1F6A3}\u200D\u2640\uFE0F", "\u{1F6A3}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FB}", "\u{1F6A3}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FC}", "\u{1F6A3}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FD}", "\u{1F6A3}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FE}", "\u{1F6A3}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6A3}\u{1F3FF}", "\u{1F6A3}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6A3}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B4}\u200D\u2640\uFE0F", "\u{1F6B4}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FB}", "\u{1F6B4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FC}", "\u{1F6B4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FD}", "\u{1F6B4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FE}", "\u{1F6B4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B4}\u{1F3FF}", "\u{1F6B4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B5}\u200D\u2640\uFE0F", "\u{1F6B5}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FB}", "\u{1F6B5}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FC}", "\u{1F6B5}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FD}", "\u{1F6B5}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FE}", "\u{1F6B5}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B5}\u{1F3FF}", "\u{1F6B5}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B5}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6B6}\u200D\u2640\uFE0F", "\u{1F6B6}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FB}", "\u{1F6B6}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FC}", "\u{1F6B6}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FD}", "\u{1F6B6}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FE}", "\u{1F6B6}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F6B6}\u{1F3FF}", "\u{1F6B6}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F6B6}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F6C0}\u{1F3FB}", "\u{1F6C0}\u{1F3FC}", "\u{1F6C0}\u{1F3FD}", "\u{1F6C0}\u{1F3FE}", "\u{1F6C0}\u{1F3FF}", "\u{1F6CB}\uFE0F", "\u{1F6CC}\u{1F3FB}", "\u{1F6CC}\u{1F3FC}", "\u{1F6CC}\u{1F3FD}", "\u{1F6CC}\u{1F3FE}", "\u{1F6CC}\u{1F3FF}", "\u{1F6CD}\uFE0F", "\u{1F6CE}\uFE0F", "\u{1F6CF}\uFE0F", "\u{1F6E0}\uFE0F", "\u{1F6E1}\uFE0F", "\u{1F6E2}\uFE0F", "\u{1F6E3}\uFE0F", "\u{1F6E4}\uFE0F", "\u{1F6E5}\uFE0F", "\u{1F6E9}\uFE0F", "\u{1F6F0}\uFE0F", "\u{1F6F3}\uFE0F", "\u{1F90C}\u{1F3FB}", "\u{1F90C}\u{1F3FC}", "\u{1F90C}\u{1F3FD}", "\u{1F90C}\u{1F3FE}", "\u{1F90C}\u{1F3FF}", "\u{1F90F}\u{1F3FB}", "\u{1F90F}\u{1F3FC}", "\u{1F90F}\u{1F3FD}", "\u{1F90F}\u{1F3FE}", "\u{1F90F}\u{1F3FF}", "\u{1F918}\u{1F3FB}", "\u{1F918}\u{1F3FC}", "\u{1F918}\u{1F3FD}", "\u{1F918}\u{1F3FE}", "\u{1F918}\u{1F3FF}", "\u{1F919}\u{1F3FB}", "\u{1F919}\u{1F3FC}", "\u{1F919}\u{1F3FD}", "\u{1F919}\u{1F3FE}", "\u{1F919}\u{1F3FF}", "\u{1F91A}\u{1F3FB}", "\u{1F91A}\u{1F3FC}", "\u{1F91A}\u{1F3FD}", "\u{1F91A}\u{1F3FE}", "\u{1F91A}\u{1F3FF}", "\u{1F91B}\u{1F3FB}", "\u{1F91B}\u{1F3FC}", "\u{1F91B}\u{1F3FD}", "\u{1F91B}\u{1F3FE}", "\u{1F91B}\u{1F3FF}", "\u{1F91C}\u{1F3FB}", "\u{1F91C}\u{1F3FC}", "\u{1F91C}\u{1F3FD}", "\u{1F91C}\u{1F3FE}", "\u{1F91C}\u{1F3FF}", "\u{1F91D}\u{1F3FB}", "\u{1F91D}\u{1F3FC}", "\u{1F91D}\u{1F3FD}", "\u{1F91D}\u{1F3FE}", "\u{1F91D}\u{1F3FF}", "\u{1F91E}\u{1F3FB}", "\u{1F91E}\u{1F3FC}", "\u{1F91E}\u{1F3FD}", "\u{1F91E}\u{1F3FE}", "\u{1F91E}\u{1F3FF}", "\u{1F91F}\u{1F3FB}", "\u{1F91F}\u{1F3FC}", "\u{1F91F}\u{1F3FD}", "\u{1F91F}\u{1F3FE}", "\u{1F91F}\u{1F3FF}", "\u{1F926}\u200D\u2640\uFE0F", "\u{1F926}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FB}", "\u{1F926}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FC}", "\u{1F926}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FD}", "\u{1F926}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FE}", "\u{1F926}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F926}\u{1F3FF}", "\u{1F926}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F926}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F930}\u{1F3FB}", "\u{1F930}\u{1F3FC}", "\u{1F930}\u{1F3FD}", "\u{1F930}\u{1F3FE}", "\u{1F930}\u{1F3FF}", "\u{1F931}\u{1F3FB}", "\u{1F931}\u{1F3FC}", "\u{1F931}\u{1F3FD}", "\u{1F931}\u{1F3FE}", "\u{1F931}\u{1F3FF}", "\u{1F932}\u{1F3FB}", "\u{1F932}\u{1F3FC}", "\u{1F932}\u{1F3FD}", "\u{1F932}\u{1F3FE}", "\u{1F932}\u{1F3FF}", "\u{1F933}\u{1F3FB}", "\u{1F933}\u{1F3FC}", "\u{1F933}\u{1F3FD}", "\u{1F933}\u{1F3FE}", "\u{1F933}\u{1F3FF}", "\u{1F934}\u{1F3FB}", "\u{1F934}\u{1F3FC}", "\u{1F934}\u{1F3FD}", "\u{1F934}\u{1F3FE}", "\u{1F934}\u{1F3FF}", "\u{1F935}\u200D\u2640\uFE0F", "\u{1F935}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FB}", "\u{1F935}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FC}", "\u{1F935}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FD}", "\u{1F935}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FE}", "\u{1F935}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F935}\u{1F3FF}", "\u{1F935}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F935}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F936}\u{1F3FB}", "\u{1F936}\u{1F3FC}", "\u{1F936}\u{1F3FD}", "\u{1F936}\u{1F3FE}", "\u{1F936}\u{1F3FF}", "\u{1F937}\u200D\u2640\uFE0F", "\u{1F937}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FB}", "\u{1F937}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FC}", "\u{1F937}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FD}", "\u{1F937}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FE}", "\u{1F937}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F937}\u{1F3FF}", "\u{1F937}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F937}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F938}\u200D\u2640\uFE0F", "\u{1F938}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FB}", "\u{1F938}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FC}", "\u{1F938}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FD}", "\u{1F938}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FE}", "\u{1F938}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F938}\u{1F3FF}", "\u{1F938}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F938}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F939}\u200D\u2640\uFE0F", "\u{1F939}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FB}", "\u{1F939}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FC}", "\u{1F939}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FD}", "\u{1F939}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FE}", "\u{1F939}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F939}\u{1F3FF}", "\u{1F939}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F939}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F93C}\u200D\u2640\uFE0F", "\u{1F93C}\u200D\u2642\uFE0F", "\u{1F93D}\u200D\u2640\uFE0F", "\u{1F93D}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FB}", "\u{1F93D}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FC}", "\u{1F93D}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FD}", "\u{1F93D}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FE}", "\u{1F93D}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F93D}\u{1F3FF}", "\u{1F93D}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F93D}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F93E}\u200D\u2640\uFE0F", "\u{1F93E}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FB}", "\u{1F93E}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FC}", "\u{1F93E}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FD}", "\u{1F93E}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FE}", "\u{1F93E}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F93E}\u{1F3FF}", "\u{1F93E}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F93E}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F977}\u{1F3FB}", "\u{1F977}\u{1F3FC}", "\u{1F977}\u{1F3FD}", "\u{1F977}\u{1F3FE}", "\u{1F977}\u{1F3FF}", "\u{1F9B5}\u{1F3FB}", "\u{1F9B5}\u{1F3FC}", "\u{1F9B5}\u{1F3FD}", "\u{1F9B5}\u{1F3FE}", "\u{1F9B5}\u{1F3FF}", "\u{1F9B6}\u{1F3FB}", "\u{1F9B6}\u{1F3FC}", "\u{1F9B6}\u{1F3FD}", "\u{1F9B6}\u{1F3FE}", "\u{1F9B6}\u{1F3FF}", "\u{1F9B8}\u200D\u2640\uFE0F", "\u{1F9B8}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FB}", "\u{1F9B8}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FC}", "\u{1F9B8}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FD}", "\u{1F9B8}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FE}", "\u{1F9B8}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9B8}\u{1F3FF}", "\u{1F9B8}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9B8}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9B9}\u200D\u2640\uFE0F", "\u{1F9B9}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FB}", "\u{1F9B9}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FC}", "\u{1F9B9}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FD}", "\u{1F9B9}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FE}", "\u{1F9B9}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9B9}\u{1F3FF}", "\u{1F9B9}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9B9}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9BB}\u{1F3FB}", "\u{1F9BB}\u{1F3FC}", "\u{1F9BB}\u{1F3FD}", "\u{1F9BB}\u{1F3FE}", "\u{1F9BB}\u{1F3FF}", "\u{1F9CD}\u200D\u2640\uFE0F", "\u{1F9CD}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FB}", "\u{1F9CD}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FC}", "\u{1F9CD}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FD}", "\u{1F9CD}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FE}", "\u{1F9CD}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CD}\u{1F3FF}", "\u{1F9CD}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CD}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9CE}\u200D\u2640\uFE0F", "\u{1F9CE}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FB}", "\u{1F9CE}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FC}", "\u{1F9CE}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FD}", "\u{1F9CE}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FE}", "\u{1F9CE}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CE}\u{1F3FF}", "\u{1F9CE}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CE}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9CF}\u200D\u2640\uFE0F", "\u{1F9CF}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FB}", "\u{1F9CF}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FC}", "\u{1F9CF}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FD}", "\u{1F9CF}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FE}", "\u{1F9CF}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9CF}\u{1F3FF}", "\u{1F9CF}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9CF}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D1}\u200D\u2695\uFE0F", "\u{1F9D1}\u200D\u2696\uFE0F", "\u{1F9D1}\u200D\u2708\uFE0F", "\u{1F9D1}\u200D\u{1F33E}", "\u{1F9D1}\u200D\u{1F373}", "\u{1F9D1}\u200D\u{1F37C}", "\u{1F9D1}\u200D\u{1F384}", "\u{1F9D1}\u200D\u{1F393}", "\u{1F9D1}\u200D\u{1F3A4}", "\u{1F9D1}\u200D\u{1F3A8}", "\u{1F9D1}\u200D\u{1F3EB}", "\u{1F9D1}\u200D\u{1F3ED}", "\u{1F9D1}\u200D\u{1F4BB}", "\u{1F9D1}\u200D\u{1F4BC}", "\u{1F9D1}\u200D\u{1F527}", "\u{1F9D1}\u200D\u{1F52C}", "\u{1F9D1}\u200D\u{1F680}", "\u{1F9D1}\u200D\u{1F692}", "\u{1F9D1}\u200D\u{1F91D}\u200D\u{1F9D1}", "\u{1F9D1}\u200D\u{1F9AF}", "\u{1F9D1}\u200D\u{1F9B0}", "\u{1F9D1}\u200D\u{1F9B1}", "\u{1F9D1}\u200D\u{1F9B2}", "\u{1F9D1}\u200D\u{1F9B3}", "\u{1F9D1}\u200D\u{1F9BC}", "\u{1F9D1}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FB}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FB}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FC}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FC}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FD}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FD}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FE}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FE}\u200D\u{1F9BD}", "\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FF}\u200D\u2695\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u2696\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u2708\uFE0F", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F33E}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F373}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F37C}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F384}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F393}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3A4}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3A8}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3EB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F3ED}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F4BB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F4BC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F527}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F52C}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F680}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F692}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9AF}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B0}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B1}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B2}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9B3}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9BC}", "\u{1F9D1}\u{1F3FF}\u200D\u{1F9BD}", "\u{1F9D2}\u{1F3FB}", "\u{1F9D2}\u{1F3FC}", "\u{1F9D2}\u{1F3FD}", "\u{1F9D2}\u{1F3FE}", "\u{1F9D2}\u{1F3FF}", "\u{1F9D3}\u{1F3FB}", "\u{1F9D3}\u{1F3FC}", "\u{1F9D3}\u{1F3FD}", "\u{1F9D3}\u{1F3FE}", "\u{1F9D3}\u{1F3FF}", "\u{1F9D4}\u200D\u2640\uFE0F", "\u{1F9D4}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FB}", "\u{1F9D4}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FC}", "\u{1F9D4}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FD}", "\u{1F9D4}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FE}", "\u{1F9D4}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D4}\u{1F3FF}", "\u{1F9D4}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D4}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D5}\u{1F3FB}", "\u{1F9D5}\u{1F3FC}", "\u{1F9D5}\u{1F3FD}", "\u{1F9D5}\u{1F3FE}", "\u{1F9D5}\u{1F3FF}", "\u{1F9D6}\u200D\u2640\uFE0F", "\u{1F9D6}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FB}", "\u{1F9D6}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FC}", "\u{1F9D6}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FD}", "\u{1F9D6}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FE}", "\u{1F9D6}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D6}\u{1F3FF}", "\u{1F9D6}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D6}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D7}\u200D\u2640\uFE0F", "\u{1F9D7}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FB}", "\u{1F9D7}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FC}", "\u{1F9D7}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FD}", "\u{1F9D7}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FE}", "\u{1F9D7}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D7}\u{1F3FF}", "\u{1F9D7}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D7}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D8}\u200D\u2640\uFE0F", "\u{1F9D8}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FB}", "\u{1F9D8}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FC}", "\u{1F9D8}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FD}", "\u{1F9D8}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FE}", "\u{1F9D8}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D8}\u{1F3FF}", "\u{1F9D8}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D8}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9D9}\u200D\u2640\uFE0F", "\u{1F9D9}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FB}", "\u{1F9D9}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FC}", "\u{1F9D9}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FD}", "\u{1F9D9}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FE}", "\u{1F9D9}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9D9}\u{1F3FF}", "\u{1F9D9}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9D9}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DA}\u200D\u2640\uFE0F", "\u{1F9DA}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FB}", "\u{1F9DA}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FC}", "\u{1F9DA}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FD}", "\u{1F9DA}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FE}", "\u{1F9DA}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DA}\u{1F3FF}", "\u{1F9DA}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DA}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DB}\u200D\u2640\uFE0F", "\u{1F9DB}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FB}", "\u{1F9DB}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FC}", "\u{1F9DB}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FD}", "\u{1F9DB}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FE}", "\u{1F9DB}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DB}\u{1F3FF}", "\u{1F9DB}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DB}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DC}\u200D\u2640\uFE0F", "\u{1F9DC}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FB}", "\u{1F9DC}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FC}", "\u{1F9DC}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FD}", "\u{1F9DC}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FE}", "\u{1F9DC}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DC}\u{1F3FF}", "\u{1F9DC}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DC}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DD}\u200D\u2640\uFE0F", "\u{1F9DD}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FB}", "\u{1F9DD}\u{1F3FB}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FB}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FC}", "\u{1F9DD}\u{1F3FC}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FC}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FD}", "\u{1F9DD}\u{1F3FD}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FD}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FE}", "\u{1F9DD}\u{1F3FE}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FE}\u200D\u2642\uFE0F", "\u{1F9DD}\u{1F3FF}", "\u{1F9DD}\u{1F3FF}\u200D\u2640\uFE0F", "\u{1F9DD}\u{1F3FF}\u200D\u2642\uFE0F", "\u{1F9DE}\u200D\u2640\uFE0F", "\u{1F9DE}\u200D\u2642\uFE0F", "\u{1F9DF}\u200D\u2640\uFE0F", "\u{1F9DF}\u200D\u2642\uFE0F", "\u{1FAC3}\u{1F3FB}", "\u{1FAC3}\u{1F3FC}", "\u{1FAC3}\u{1F3FD}", "\u{1FAC3}\u{1F3FE}", "\u{1FAC3}\u{1F3FF}", "\u{1FAC4}\u{1F3FB}", "\u{1FAC4}\u{1F3FC}", "\u{1FAC4}\u{1F3FD}", "\u{1FAC4}\u{1F3FE}", "\u{1FAC4}\u{1F3FF}", "\u{1FAC5}\u{1F3FB}", "\u{1FAC5}\u{1F3FC}", "\u{1FAC5}\u{1F3FD}", "\u{1FAC5}\u{1F3FE}", "\u{1FAC5}\u{1F3FF}", "\u{1FAF0}\u{1F3FB}", "\u{1FAF0}\u{1F3FC}", "\u{1FAF0}\u{1F3FD}", "\u{1FAF0}\u{1F3FE}", "\u{1FAF0}\u{1F3FF}", "\u{1FAF1}\u{1F3FB}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FC}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FD}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FE}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FF}", "\u{1FAF1}\u{1F3FF}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FB}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FC}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FD}", "\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FE}", "\u{1FAF2}\u{1F3FB}", "\u{1FAF2}\u{1F3FC}", "\u{1FAF2}\u{1F3FD}", "\u{1FAF2}\u{1F3FE}", "\u{1FAF2}\u{1F3FF}", "\u{1FAF3}\u{1F3FB}", "\u{1FAF3}\u{1F3FC}", "\u{1FAF3}\u{1F3FD}", "\u{1FAF3}\u{1F3FE}", "\u{1FAF3}\u{1F3FF}", "\u{1FAF4}\u{1F3FB}", "\u{1FAF4}\u{1F3FC}", "\u{1FAF4}\u{1F3FD}", "\u{1FAF4}\u{1F3FE}", "\u{1FAF4}\u{1F3FF}", "\u{1FAF5}\u{1F3FB}", "\u{1FAF5}\u{1F3FC}", "\u{1FAF5}\u{1F3FD}", "\u{1FAF5}\u{1F3FE}", "\u{1FAF5}\u{1F3FF}", "\u{1FAF6}\u{1F3FB}", "\u{1FAF6}\u{1F3FC}", "\u{1FAF6}\u{1F3FD}", "\u{1FAF6}\u{1F3FE}", "\u{1FAF6}\u{1F3FF}"];
      return RGI_Emoji;
    }
    var Adlam$1 = {};
    var hasRequiredAdlam$1;
    function requireAdlam$1() {
      if (hasRequiredAdlam$1)
        return Adlam$1;
      hasRequiredAdlam$1 = 1;
      var set3 = regenerate$2.exports(1567, 1600);
      set3.addRange(125184, 125259).addRange(125264, 125273).addRange(125278, 125279);
      Adlam$1.characters = set3;
      return Adlam$1;
    }
    var Ahom$1 = {};
    var hasRequiredAhom$1;
    function requireAhom$1() {
      if (hasRequiredAhom$1)
        return Ahom$1;
      hasRequiredAhom$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71424, 71450).addRange(71453, 71467).addRange(71472, 71494);
      Ahom$1.characters = set3;
      return Ahom$1;
    }
    var Anatolian_Hieroglyphs$1 = {};
    var hasRequiredAnatolian_Hieroglyphs$1;
    function requireAnatolian_Hieroglyphs$1() {
      if (hasRequiredAnatolian_Hieroglyphs$1)
        return Anatolian_Hieroglyphs$1;
      hasRequiredAnatolian_Hieroglyphs$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(82944, 83526);
      Anatolian_Hieroglyphs$1.characters = set3;
      return Anatolian_Hieroglyphs$1;
    }
    var Arabic$1 = {};
    var hasRequiredArabic$1;
    function requireArabic$1() {
      if (hasRequiredArabic$1)
        return Arabic$1;
      hasRequiredArabic$1 = 1;
      var set3 = regenerate$2.exports(64975, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(1536, 1540).addRange(1542, 1756).addRange(1758, 1791).addRange(1872, 1919).addRange(2160, 2190).addRange(2192, 2193).addRange(2200, 2273).addRange(2275, 2303).addRange(64336, 64450).addRange(64467, 64911).addRange(64914, 64967).addRange(65008, 65023).addRange(65136, 65140).addRange(65142, 65276).addRange(66272, 66299).addRange(69216, 69246).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(126704, 126705);
      Arabic$1.characters = set3;
      return Arabic$1;
    }
    var Armenian$1 = {};
    var hasRequiredArmenian$1;
    function requireArmenian$1() {
      if (hasRequiredArmenian$1)
        return Armenian$1;
      hasRequiredArmenian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(1329, 1366).addRange(1369, 1418).addRange(1421, 1423).addRange(64275, 64279);
      Armenian$1.characters = set3;
      return Armenian$1;
    }
    var Avestan$1 = {};
    var hasRequiredAvestan$1;
    function requireAvestan$1() {
      if (hasRequiredAvestan$1)
        return Avestan$1;
      hasRequiredAvestan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68352, 68405).addRange(68409, 68415);
      Avestan$1.characters = set3;
      return Avestan$1;
    }
    var Balinese$1 = {};
    var hasRequiredBalinese$1;
    function requireBalinese$1() {
      if (hasRequiredBalinese$1)
        return Balinese$1;
      hasRequiredBalinese$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6912, 6988).addRange(6992, 7038);
      Balinese$1.characters = set3;
      return Balinese$1;
    }
    var Bamum$1 = {};
    var hasRequiredBamum$1;
    function requireBamum$1() {
      if (hasRequiredBamum$1)
        return Bamum$1;
      hasRequiredBamum$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(42656, 42743).addRange(92160, 92728);
      Bamum$1.characters = set3;
      return Bamum$1;
    }
    var Bassa_Vah$1 = {};
    var hasRequiredBassa_Vah$1;
    function requireBassa_Vah$1() {
      if (hasRequiredBassa_Vah$1)
        return Bassa_Vah$1;
      hasRequiredBassa_Vah$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92880, 92909).addRange(92912, 92917);
      Bassa_Vah$1.characters = set3;
      return Bassa_Vah$1;
    }
    var Batak$1 = {};
    var hasRequiredBatak$1;
    function requireBatak$1() {
      if (hasRequiredBatak$1)
        return Batak$1;
      hasRequiredBatak$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7104, 7155).addRange(7164, 7167);
      Batak$1.characters = set3;
      return Batak$1;
    }
    var Bengali$1 = {};
    var hasRequiredBengali$1;
    function requireBengali$1() {
      if (hasRequiredBengali$1)
        return Bengali$1;
      hasRequiredBengali$1 = 1;
      var set3 = regenerate$2.exports(2482, 2519, 7376, 7378, 7384, 7393, 7402, 7405, 7410, 43249);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(2432, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2492, 2500).addRange(2503, 2504).addRange(2507, 2510).addRange(2524, 2525).addRange(2527, 2531).addRange(2534, 2558).addRange(7381, 7382).addRange(7413, 7415);
      Bengali$1.characters = set3;
      return Bengali$1;
    }
    var Bhaiksuki$1 = {};
    var hasRequiredBhaiksuki$1;
    function requireBhaiksuki$1() {
      if (hasRequiredBhaiksuki$1)
        return Bhaiksuki$1;
      hasRequiredBhaiksuki$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72773).addRange(72784, 72812);
      Bhaiksuki$1.characters = set3;
      return Bhaiksuki$1;
    }
    var Bopomofo$1 = {};
    var hasRequiredBopomofo$1;
    function requireBopomofo$1() {
      if (hasRequiredBopomofo$1)
        return Bopomofo$1;
      hasRequiredBopomofo$1 = 1;
      var set3 = regenerate$2.exports(12336, 12343, 12539);
      set3.addRange(746, 747).addRange(12289, 12291).addRange(12296, 12305).addRange(12307, 12319).addRange(12330, 12333).addRange(12549, 12591).addRange(12704, 12735).addRange(65093, 65094).addRange(65377, 65381);
      Bopomofo$1.characters = set3;
      return Bopomofo$1;
    }
    var Brahmi$1 = {};
    var hasRequiredBrahmi$1;
    function requireBrahmi$1() {
      if (hasRequiredBrahmi$1)
        return Brahmi$1;
      hasRequiredBrahmi$1 = 1;
      var set3 = regenerate$2.exports(69759);
      set3.addRange(69632, 69709).addRange(69714, 69749);
      Brahmi$1.characters = set3;
      return Brahmi$1;
    }
    var Braille$1 = {};
    var hasRequiredBraille$1;
    function requireBraille$1() {
      if (hasRequiredBraille$1)
        return Braille$1;
      hasRequiredBraille$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(10240, 10495);
      Braille$1.characters = set3;
      return Braille$1;
    }
    var Buginese$1 = {};
    var hasRequiredBuginese$1;
    function requireBuginese$1() {
      if (hasRequiredBuginese$1)
        return Buginese$1;
      hasRequiredBuginese$1 = 1;
      var set3 = regenerate$2.exports(43471);
      set3.addRange(6656, 6683).addRange(6686, 6687);
      Buginese$1.characters = set3;
      return Buginese$1;
    }
    var Buhid$1 = {};
    var hasRequiredBuhid$1;
    function requireBuhid$1() {
      if (hasRequiredBuhid$1)
        return Buhid$1;
      hasRequiredBuhid$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5941, 5942).addRange(5952, 5971);
      Buhid$1.characters = set3;
      return Buhid$1;
    }
    var Canadian_Aboriginal$1 = {};
    var hasRequiredCanadian_Aboriginal$1;
    function requireCanadian_Aboriginal$1() {
      if (hasRequiredCanadian_Aboriginal$1)
        return Canadian_Aboriginal$1;
      hasRequiredCanadian_Aboriginal$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5120, 5759).addRange(6320, 6389).addRange(72368, 72383);
      Canadian_Aboriginal$1.characters = set3;
      return Canadian_Aboriginal$1;
    }
    var Carian$1 = {};
    var hasRequiredCarian$1;
    function requireCarian$1() {
      if (hasRequiredCarian$1)
        return Carian$1;
      hasRequiredCarian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66208, 66256);
      Carian$1.characters = set3;
      return Carian$1;
    }
    var Caucasian_Albanian$1 = {};
    var hasRequiredCaucasian_Albanian$1;
    function requireCaucasian_Albanian$1() {
      if (hasRequiredCaucasian_Albanian$1)
        return Caucasian_Albanian$1;
      hasRequiredCaucasian_Albanian$1 = 1;
      var set3 = regenerate$2.exports(66927);
      set3.addRange(66864, 66915);
      Caucasian_Albanian$1.characters = set3;
      return Caucasian_Albanian$1;
    }
    var Chakma$1 = {};
    var hasRequiredChakma$1;
    function requireChakma$1() {
      if (hasRequiredChakma$1)
        return Chakma$1;
      hasRequiredChakma$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2534, 2543).addRange(4160, 4169).addRange(69888, 69940).addRange(69942, 69959);
      Chakma$1.characters = set3;
      return Chakma$1;
    }
    var Cham$1 = {};
    var hasRequiredCham$1;
    function requireCham$1() {
      if (hasRequiredCham$1)
        return Cham$1;
      hasRequiredCham$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43520, 43574).addRange(43584, 43597).addRange(43600, 43609).addRange(43612, 43615);
      Cham$1.characters = set3;
      return Cham$1;
    }
    var Cherokee$1 = {};
    var hasRequiredCherokee$1;
    function requireCherokee$1() {
      if (hasRequiredCherokee$1)
        return Cherokee$1;
      hasRequiredCherokee$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5024, 5109).addRange(5112, 5117).addRange(43888, 43967);
      Cherokee$1.characters = set3;
      return Cherokee$1;
    }
    var Chorasmian$1 = {};
    var hasRequiredChorasmian$1;
    function requireChorasmian$1() {
      if (hasRequiredChorasmian$1)
        return Chorasmian$1;
      hasRequiredChorasmian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69552, 69579);
      Chorasmian$1.characters = set3;
      return Chorasmian$1;
    }
    var Common$1 = {};
    var hasRequiredCommon$1;
    function requireCommon$1() {
      if (hasRequiredCommon$1)
        return Common$1;
      hasRequiredCommon$1 = 1;
      var set3 = regenerate$2.exports(215, 247, 884, 894, 901, 903, 1541, 1757, 2274, 3647, 12288, 12292, 12306, 12320, 12342, 12927, 13311, 43867, 65279, 119970, 119995, 120134, 129008, 917505);
      set3.addRange(0, 64).addRange(91, 96).addRange(123, 169).addRange(171, 185).addRange(187, 191).addRange(697, 735).addRange(741, 745).addRange(748, 767).addRange(4053, 4056).addRange(5867, 5869).addRange(8192, 8203).addRange(8206, 8238).addRange(8240, 8292).addRange(8294, 8304).addRange(8308, 8318).addRange(8320, 8334).addRange(8352, 8384).addRange(8448, 8485).addRange(8487, 8489).addRange(8492, 8497).addRange(8499, 8525).addRange(8527, 8543).addRange(8585, 8587).addRange(8592, 9254).addRange(9280, 9290).addRange(9312, 10239).addRange(10496, 11123).addRange(11126, 11157).addRange(11159, 11263).addRange(11776, 11842).addRange(11844, 11869).addRange(12272, 12283).addRange(12872, 12895).addRange(12977, 12991).addRange(13004, 13007).addRange(13169, 13178).addRange(13184, 13279).addRange(19904, 19967).addRange(42760, 42785).addRange(42888, 42890).addRange(43882, 43883).addRange(65040, 65049).addRange(65072, 65092).addRange(65095, 65106).addRange(65108, 65126).addRange(65128, 65131).addRange(65281, 65312).addRange(65339, 65344).addRange(65371, 65376).addRange(65504, 65510).addRange(65512, 65518);
      set3.addRange(65529, 65533).addRange(65936, 65948).addRange(66e3, 66044).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119142).addRange(119146, 119162).addRange(119171, 119172).addRange(119180, 119209).addRange(119214, 119274).addRange(119520, 119539).addRange(119552, 119638).addRange(119666, 119672).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 120831).addRange(126065, 126132).addRange(126209, 126269).addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127232, 127405).addRange(127462, 127487).addRange(127489, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127584, 127589).addRange(127744, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984);
      set3.addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994).addRange(130032, 130041).addRange(917536, 917631);
      Common$1.characters = set3;
      return Common$1;
    }
    var Coptic$1 = {};
    var hasRequiredCoptic$1;
    function requireCoptic$1() {
      if (hasRequiredCoptic$1)
        return Coptic$1;
      hasRequiredCoptic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(994, 1007).addRange(11392, 11507).addRange(11513, 11519).addRange(66272, 66299);
      Coptic$1.characters = set3;
      return Coptic$1;
    }
    var Cuneiform$1 = {};
    var hasRequiredCuneiform$1;
    function requireCuneiform$1() {
      if (hasRequiredCuneiform$1)
        return Cuneiform$1;
      hasRequiredCuneiform$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(73728, 74649).addRange(74752, 74862).addRange(74864, 74868).addRange(74880, 75075);
      Cuneiform$1.characters = set3;
      return Cuneiform$1;
    }
    var Cypriot$1 = {};
    var hasRequiredCypriot$1;
    function requireCypriot$1() {
      if (hasRequiredCypriot$1)
        return Cypriot$1;
      hasRequiredCypriot$1 = 1;
      var set3 = regenerate$2.exports(67592, 67644, 67647);
      set3.addRange(65792, 65794).addRange(65799, 65843).addRange(65847, 65855).addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640);
      Cypriot$1.characters = set3;
      return Cypriot$1;
    }
    var Cypro_Minoan$1 = {};
    var hasRequiredCypro_Minoan$1;
    function requireCypro_Minoan$1() {
      if (hasRequiredCypro_Minoan$1)
        return Cypro_Minoan$1;
      hasRequiredCypro_Minoan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(65792, 65793).addRange(77712, 77810);
      Cypro_Minoan$1.characters = set3;
      return Cypro_Minoan$1;
    }
    var Cyrillic$1 = {};
    var hasRequiredCyrillic$1;
    function requireCyrillic$1() {
      if (hasRequiredCyrillic$1)
        return Cyrillic$1;
      hasRequiredCyrillic$1 = 1;
      var set3 = regenerate$2.exports(7467, 7544, 7672, 11843);
      set3.addRange(1024, 1327).addRange(7296, 7304).addRange(11744, 11775).addRange(42560, 42655).addRange(65070, 65071);
      Cyrillic$1.characters = set3;
      return Cyrillic$1;
    }
    var Deseret$1 = {};
    var hasRequiredDeseret$1;
    function requireDeseret$1() {
      if (hasRequiredDeseret$1)
        return Deseret$1;
      hasRequiredDeseret$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66560, 66639);
      Deseret$1.characters = set3;
      return Deseret$1;
    }
    var Devanagari$1 = {};
    var hasRequiredDevanagari$1;
    function requireDevanagari$1() {
      if (hasRequiredDevanagari$1)
        return Devanagari$1;
      hasRequiredDevanagari$1 = 1;
      var set3 = regenerate$2.exports(8432);
      set3.addRange(2304, 2386).addRange(2389, 2431).addRange(7376, 7414).addRange(7416, 7417).addRange(43056, 43065).addRange(43232, 43263);
      Devanagari$1.characters = set3;
      return Devanagari$1;
    }
    var Dives_Akuru$1 = {};
    var hasRequiredDives_Akuru$1;
    function requireDives_Akuru$1() {
      if (hasRequiredDives_Akuru$1)
        return Dives_Akuru$1;
      hasRequiredDives_Akuru$1 = 1;
      var set3 = regenerate$2.exports(71945);
      set3.addRange(71936, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 72006).addRange(72016, 72025);
      Dives_Akuru$1.characters = set3;
      return Dives_Akuru$1;
    }
    var Dogra$1 = {};
    var hasRequiredDogra$1;
    function requireDogra$1() {
      if (hasRequiredDogra$1)
        return Dogra$1;
      hasRequiredDogra$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2415).addRange(43056, 43065).addRange(71680, 71739);
      Dogra$1.characters = set3;
      return Dogra$1;
    }
    var Duployan$1 = {};
    var hasRequiredDuployan$1;
    function requireDuployan$1() {
      if (hasRequiredDuployan$1)
        return Duployan$1;
      hasRequiredDuployan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(113820, 113827);
      Duployan$1.characters = set3;
      return Duployan$1;
    }
    var Egyptian_Hieroglyphs$1 = {};
    var hasRequiredEgyptian_Hieroglyphs$1;
    function requireEgyptian_Hieroglyphs$1() {
      if (hasRequiredEgyptian_Hieroglyphs$1)
        return Egyptian_Hieroglyphs$1;
      hasRequiredEgyptian_Hieroglyphs$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(77824, 78894).addRange(78896, 78904);
      Egyptian_Hieroglyphs$1.characters = set3;
      return Egyptian_Hieroglyphs$1;
    }
    var Elbasan$1 = {};
    var hasRequiredElbasan$1;
    function requireElbasan$1() {
      if (hasRequiredElbasan$1)
        return Elbasan$1;
      hasRequiredElbasan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66816, 66855);
      Elbasan$1.characters = set3;
      return Elbasan$1;
    }
    var Elymaic$1 = {};
    var hasRequiredElymaic$1;
    function requireElymaic$1() {
      if (hasRequiredElymaic$1)
        return Elymaic$1;
      hasRequiredElymaic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69600, 69622);
      Elymaic$1.characters = set3;
      return Elymaic$1;
    }
    var Ethiopic$1 = {};
    var hasRequiredEthiopic$1;
    function requireEthiopic$1() {
      if (hasRequiredEthiopic$1)
        return Ethiopic$1;
      hasRequiredEthiopic$1 = 1;
      var set3 = regenerate$2.exports(4696, 4800);
      set3.addRange(4608, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4957, 4988).addRange(4992, 5017).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926);
      Ethiopic$1.characters = set3;
      return Ethiopic$1;
    }
    var Georgian$1 = {};
    var hasRequiredGeorgian$1;
    function requireGeorgian$1() {
      if (hasRequiredGeorgian$1)
        return Georgian$1;
      hasRequiredGeorgian$1 = 1;
      var set3 = regenerate$2.exports(4295, 4301, 11559, 11565);
      set3.addRange(4256, 4293).addRange(4304, 4351).addRange(7312, 7354).addRange(7357, 7359).addRange(11520, 11557);
      Georgian$1.characters = set3;
      return Georgian$1;
    }
    var Glagolitic$1 = {};
    var hasRequiredGlagolitic$1;
    function requireGlagolitic$1() {
      if (hasRequiredGlagolitic$1)
        return Glagolitic$1;
      hasRequiredGlagolitic$1 = 1;
      var set3 = regenerate$2.exports(1156, 1159, 11843, 42607);
      set3.addRange(11264, 11359).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922);
      Glagolitic$1.characters = set3;
      return Glagolitic$1;
    }
    var Gothic$1 = {};
    var hasRequiredGothic$1;
    function requireGothic$1() {
      if (hasRequiredGothic$1)
        return Gothic$1;
      hasRequiredGothic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66352, 66378);
      Gothic$1.characters = set3;
      return Gothic$1;
    }
    var Grantha$1 = {};
    var hasRequiredGrantha$1;
    function requireGrantha$1() {
      if (hasRequiredGrantha$1)
        return Grantha$1;
      hasRequiredGrantha$1 = 1;
      var set3 = regenerate$2.exports(7376, 8432, 70480, 70487, 73683);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(3046, 3059).addRange(7378, 7379).addRange(7410, 7412).addRange(7416, 7417).addRange(70400, 70403).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70459, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70502, 70508).addRange(70512, 70516).addRange(73680, 73681);
      Grantha$1.characters = set3;
      return Grantha$1;
    }
    var Greek$1 = {};
    var hasRequiredGreek$1;
    function requireGreek$1() {
      if (hasRequiredGreek$1)
        return Greek$1;
      hasRequiredGreek$1 = 1;
      var set3 = regenerate$2.exports(834, 837, 895, 900, 902, 908, 8025, 8027, 8029, 8486, 43877, 65952);
      set3.addRange(880, 883).addRange(885, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 993).addRange(1008, 1023).addRange(7462, 7466).addRange(7517, 7521).addRange(7526, 7530).addRange(7615, 7617).addRange(7936, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8132).addRange(8134, 8147).addRange(8150, 8155).addRange(8157, 8175).addRange(8178, 8180).addRange(8182, 8190).addRange(65856, 65934).addRange(119296, 119365);
      Greek$1.characters = set3;
      return Greek$1;
    }
    var Gujarati$1 = {};
    var hasRequiredGujarati$1;
    function requireGujarati$1() {
      if (hasRequiredGujarati$1)
        return Gujarati$1;
      hasRequiredGujarati$1 = 1;
      var set3 = regenerate$2.exports(2768);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2748, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2784, 2787).addRange(2790, 2801).addRange(2809, 2815).addRange(43056, 43065);
      Gujarati$1.characters = set3;
      return Gujarati$1;
    }
    var Gunjala_Gondi$1 = {};
    var hasRequiredGunjala_Gondi$1;
    function requireGunjala_Gondi$1() {
      if (hasRequiredGunjala_Gondi$1)
        return Gunjala_Gondi$1;
      hasRequiredGunjala_Gondi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2405).addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73112).addRange(73120, 73129);
      Gunjala_Gondi$1.characters = set3;
      return Gunjala_Gondi$1;
    }
    var Gurmukhi$1 = {};
    var hasRequiredGurmukhi$1;
    function requireGurmukhi$1() {
      if (hasRequiredGurmukhi$1)
        return Gurmukhi$1;
      hasRequiredGurmukhi$1 = 1;
      var set3 = regenerate$2.exports(2620, 2641, 2654);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2649, 2652).addRange(2662, 2678).addRange(43056, 43065);
      Gurmukhi$1.characters = set3;
      return Gurmukhi$1;
    }
    var Han$1 = {};
    var hasRequiredHan$1;
    function requireHan$1() {
      if (hasRequiredHan$1)
        return Han$1;
      hasRequiredHan$1 = 1;
      var set3 = regenerate$2.exports(12336, 12539, 13055);
      set3.addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12289, 12291).addRange(12293, 12305).addRange(12307, 12319).addRange(12321, 12333).addRange(12343, 12351).addRange(12688, 12703).addRange(12736, 12771).addRange(12832, 12871).addRange(12928, 12976).addRange(12992, 13003).addRange(13144, 13168).addRange(13179, 13183).addRange(13280, 13310).addRange(13312, 19903).addRange(19968, 40959).addRange(42752, 42759).addRange(63744, 64109).addRange(64112, 64217).addRange(65093, 65094).addRange(65377, 65381).addRange(94178, 94179).addRange(94192, 94193).addRange(119648, 119665).addRange(127568, 127569).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Han$1.characters = set3;
      return Han$1;
    }
    var Hangul$1 = {};
    var hasRequiredHangul$1;
    function requireHangul$1() {
      if (hasRequiredHangul$1)
        return Hangul$1;
      hasRequiredHangul$1 = 1;
      var set3 = regenerate$2.exports(12343, 12539);
      set3.addRange(4352, 4607).addRange(12289, 12291).addRange(12296, 12305).addRange(12307, 12319).addRange(12334, 12336).addRange(12593, 12686).addRange(12800, 12830).addRange(12896, 12926).addRange(43360, 43388).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(65093, 65094).addRange(65377, 65381).addRange(65440, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500);
      Hangul$1.characters = set3;
      return Hangul$1;
    }
    var Hanifi_Rohingya$1 = {};
    var hasRequiredHanifi_Rohingya$1;
    function requireHanifi_Rohingya$1() {
      if (hasRequiredHanifi_Rohingya$1)
        return Hanifi_Rohingya$1;
      hasRequiredHanifi_Rohingya$1 = 1;
      var set3 = regenerate$2.exports(1548, 1563, 1567, 1600, 1748);
      set3.addRange(68864, 68903).addRange(68912, 68921);
      Hanifi_Rohingya$1.characters = set3;
      return Hanifi_Rohingya$1;
    }
    var Hanunoo$1 = {};
    var hasRequiredHanunoo$1;
    function requireHanunoo$1() {
      if (hasRequiredHanunoo$1)
        return Hanunoo$1;
      hasRequiredHanunoo$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5920, 5942);
      Hanunoo$1.characters = set3;
      return Hanunoo$1;
    }
    var Hatran$1 = {};
    var hasRequiredHatran$1;
    function requireHatran$1() {
      if (hasRequiredHatran$1)
        return Hatran$1;
      hasRequiredHatran$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67808, 67826).addRange(67828, 67829).addRange(67835, 67839);
      Hatran$1.characters = set3;
      return Hatran$1;
    }
    var Hebrew$1 = {};
    var hasRequiredHebrew$1;
    function requireHebrew$1() {
      if (hasRequiredHebrew$1)
        return Hebrew$1;
      hasRequiredHebrew$1 = 1;
      var set3 = regenerate$2.exports(64318);
      set3.addRange(1425, 1479).addRange(1488, 1514).addRange(1519, 1524).addRange(64285, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64335);
      Hebrew$1.characters = set3;
      return Hebrew$1;
    }
    var Hiragana$1 = {};
    var hasRequiredHiragana$1;
    function requireHiragana$1() {
      if (hasRequiredHiragana$1)
        return Hiragana$1;
      hasRequiredHiragana$1 = 1;
      var set3 = regenerate$2.exports(12343, 65392, 127488);
      set3.addRange(12289, 12291).addRange(12296, 12305).addRange(12307, 12319).addRange(12336, 12341).addRange(12348, 12349).addRange(12353, 12438).addRange(12441, 12448).addRange(12539, 12540).addRange(65093, 65094).addRange(65377, 65381).addRange(65438, 65439).addRange(110593, 110879).addRange(110928, 110930);
      Hiragana$1.characters = set3;
      return Hiragana$1;
    }
    var Imperial_Aramaic$1 = {};
    var hasRequiredImperial_Aramaic$1;
    function requireImperial_Aramaic$1() {
      if (hasRequiredImperial_Aramaic$1)
        return Imperial_Aramaic$1;
      hasRequiredImperial_Aramaic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67648, 67669).addRange(67671, 67679);
      Imperial_Aramaic$1.characters = set3;
      return Imperial_Aramaic$1;
    }
    var Inherited$1 = {};
    var hasRequiredInherited$1;
    function requireInherited$1() {
      if (hasRequiredInherited$1)
        return Inherited$1;
      hasRequiredInherited$1 = 1;
      var set3 = regenerate$2.exports(7673, 66045);
      set3.addRange(768, 833).addRange(835, 836).addRange(838, 866).addRange(2387, 2388).addRange(6832, 6862).addRange(7618, 7671).addRange(7675, 7679).addRange(8204, 8205).addRange(8400, 8431).addRange(65024, 65039).addRange(65056, 65069).addRange(118528, 118573).addRange(118576, 118598).addRange(119143, 119145).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(917760, 917999);
      Inherited$1.characters = set3;
      return Inherited$1;
    }
    var Inscriptional_Pahlavi$1 = {};
    var hasRequiredInscriptional_Pahlavi$1;
    function requireInscriptional_Pahlavi$1() {
      if (hasRequiredInscriptional_Pahlavi$1)
        return Inscriptional_Pahlavi$1;
      hasRequiredInscriptional_Pahlavi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68448, 68466).addRange(68472, 68479);
      Inscriptional_Pahlavi$1.characters = set3;
      return Inscriptional_Pahlavi$1;
    }
    var Inscriptional_Parthian$1 = {};
    var hasRequiredInscriptional_Parthian$1;
    function requireInscriptional_Parthian$1() {
      if (hasRequiredInscriptional_Parthian$1)
        return Inscriptional_Parthian$1;
      hasRequiredInscriptional_Parthian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68416, 68437).addRange(68440, 68447);
      Inscriptional_Parthian$1.characters = set3;
      return Inscriptional_Parthian$1;
    }
    var Javanese$1 = {};
    var hasRequiredJavanese$1;
    function requireJavanese$1() {
      if (hasRequiredJavanese$1)
        return Javanese$1;
      hasRequiredJavanese$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43392, 43469).addRange(43471, 43481).addRange(43486, 43487);
      Javanese$1.characters = set3;
      return Javanese$1;
    }
    var Kaithi$1 = {};
    var hasRequiredKaithi$1;
    function requireKaithi$1() {
      if (hasRequiredKaithi$1)
        return Kaithi$1;
      hasRequiredKaithi$1 = 1;
      var set3 = regenerate$2.exports(69837);
      set3.addRange(2406, 2415).addRange(43056, 43065).addRange(69760, 69826);
      Kaithi$1.characters = set3;
      return Kaithi$1;
    }
    var Kannada$1 = {};
    var hasRequiredKannada$1;
    function requireKannada$1() {
      if (hasRequiredKannada$1)
        return Kannada$1;
      hasRequiredKannada$1 = 1;
      var set3 = regenerate$2.exports(7376, 7378, 7386, 7410, 7412);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(3200, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3260, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3302, 3311).addRange(3313, 3314).addRange(43056, 43061);
      Kannada$1.characters = set3;
      return Kannada$1;
    }
    var Katakana$1 = {};
    var hasRequiredKatakana$1;
    function requireKatakana$1() {
      if (hasRequiredKatakana$1)
        return Katakana$1;
      hasRequiredKatakana$1 = 1;
      var set3 = regenerate$2.exports(12343, 110592);
      set3.addRange(12289, 12291).addRange(12296, 12305).addRange(12307, 12319).addRange(12336, 12341).addRange(12348, 12349).addRange(12441, 12444).addRange(12448, 12543).addRange(12784, 12799).addRange(13008, 13054).addRange(13056, 13143).addRange(65093, 65094).addRange(65377, 65439).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110880, 110882).addRange(110948, 110951);
      Katakana$1.characters = set3;
      return Katakana$1;
    }
    var Kayah_Li$1 = {};
    var hasRequiredKayah_Li$1;
    function requireKayah_Li$1() {
      if (hasRequiredKayah_Li$1)
        return Kayah_Li$1;
      hasRequiredKayah_Li$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43264, 43311);
      Kayah_Li$1.characters = set3;
      return Kayah_Li$1;
    }
    var Kharoshthi$1 = {};
    var hasRequiredKharoshthi$1;
    function requireKharoshthi$1() {
      if (hasRequiredKharoshthi$1)
        return Kharoshthi$1;
      hasRequiredKharoshthi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68096, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68152, 68154).addRange(68159, 68168).addRange(68176, 68184);
      Kharoshthi$1.characters = set3;
      return Kharoshthi$1;
    }
    var Khitan_Small_Script$1 = {};
    var hasRequiredKhitan_Small_Script$1;
    function requireKhitan_Small_Script$1() {
      if (hasRequiredKhitan_Small_Script$1)
        return Khitan_Small_Script$1;
      hasRequiredKhitan_Small_Script$1 = 1;
      var set3 = regenerate$2.exports(94180);
      set3.addRange(101120, 101589);
      Khitan_Small_Script$1.characters = set3;
      return Khitan_Small_Script$1;
    }
    var Khmer$1 = {};
    var hasRequiredKhmer$1;
    function requireKhmer$1() {
      if (hasRequiredKhmer$1)
        return Khmer$1;
      hasRequiredKhmer$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6016, 6109).addRange(6112, 6121).addRange(6128, 6137).addRange(6624, 6655);
      Khmer$1.characters = set3;
      return Khmer$1;
    }
    var Khojki$1 = {};
    var hasRequiredKhojki$1;
    function requireKhojki$1() {
      if (hasRequiredKhojki$1)
        return Khojki$1;
      hasRequiredKhojki$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2790, 2799).addRange(43056, 43065).addRange(70144, 70161).addRange(70163, 70206);
      Khojki$1.characters = set3;
      return Khojki$1;
    }
    var Khudawadi$1 = {};
    var hasRequiredKhudawadi$1;
    function requireKhudawadi$1() {
      if (hasRequiredKhudawadi$1)
        return Khudawadi$1;
      hasRequiredKhudawadi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2405).addRange(43056, 43065).addRange(70320, 70378).addRange(70384, 70393);
      Khudawadi$1.characters = set3;
      return Khudawadi$1;
    }
    var Lao$1 = {};
    var hasRequiredLao$1;
    function requireLao$1() {
      if (hasRequiredLao$1)
        return Lao$1;
      hasRequiredLao$1 = 1;
      var set3 = regenerate$2.exports(3716, 3749, 3782);
      set3.addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3773).addRange(3776, 3780).addRange(3784, 3789).addRange(3792, 3801).addRange(3804, 3807);
      Lao$1.characters = set3;
      return Lao$1;
    }
    var Latin$1 = {};
    var hasRequiredLatin$1;
    function requireLatin$1() {
      if (hasRequiredLatin$1)
        return Latin$1;
      hasRequiredLatin$1 = 1;
      var set3 = regenerate$2.exports(170, 186, 4347, 8239, 8305, 8319, 8432, 8498, 8526, 42963, 43310);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 696).addRange(736, 740).addRange(867, 879).addRange(1157, 1158).addRange(2385, 2386).addRange(7424, 7461).addRange(7468, 7516).addRange(7522, 7525).addRange(7531, 7543).addRange(7545, 7614).addRange(7680, 7935).addRange(8336, 8348).addRange(8490, 8491).addRange(8544, 8584).addRange(11360, 11391).addRange(42752, 42759).addRange(42786, 42887).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43007).addRange(43824, 43866).addRange(43868, 43876).addRange(43878, 43881).addRange(64256, 64262).addRange(65313, 65338).addRange(65345, 65370).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(122624, 122654);
      Latin$1.characters = set3;
      return Latin$1;
    }
    var Lepcha$1 = {};
    var hasRequiredLepcha$1;
    function requireLepcha$1() {
      if (hasRequiredLepcha$1)
        return Lepcha$1;
      hasRequiredLepcha$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7168, 7223).addRange(7227, 7241).addRange(7245, 7247);
      Lepcha$1.characters = set3;
      return Lepcha$1;
    }
    var Limbu$1 = {};
    var hasRequiredLimbu$1;
    function requireLimbu$1() {
      if (hasRequiredLimbu$1)
        return Limbu$1;
      hasRequiredLimbu$1 = 1;
      var set3 = regenerate$2.exports(2405, 6464);
      set3.addRange(6400, 6430).addRange(6432, 6443).addRange(6448, 6459).addRange(6468, 6479);
      Limbu$1.characters = set3;
      return Limbu$1;
    }
    var Linear_A$1 = {};
    var hasRequiredLinear_A$1;
    function requireLinear_A$1() {
      if (hasRequiredLinear_A$1)
        return Linear_A$1;
      hasRequiredLinear_A$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(65799, 65843).addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431);
      Linear_A$1.characters = set3;
      return Linear_A$1;
    }
    var Linear_B$1 = {};
    var hasRequiredLinear_B$1;
    function requireLinear_B$1() {
      if (hasRequiredLinear_B$1)
        return Linear_B$1;
      hasRequiredLinear_B$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786).addRange(65792, 65794).addRange(65799, 65843).addRange(65847, 65855);
      Linear_B$1.characters = set3;
      return Linear_B$1;
    }
    var Lisu$1 = {};
    var hasRequiredLisu$1;
    function requireLisu$1() {
      if (hasRequiredLisu$1)
        return Lisu$1;
      hasRequiredLisu$1 = 1;
      var set3 = regenerate$2.exports(73648);
      set3.addRange(42192, 42239);
      Lisu$1.characters = set3;
      return Lisu$1;
    }
    var Lycian$1 = {};
    var hasRequiredLycian$1;
    function requireLycian$1() {
      if (hasRequiredLycian$1)
        return Lycian$1;
      hasRequiredLycian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66176, 66204);
      Lycian$1.characters = set3;
      return Lycian$1;
    }
    var Lydian$1 = {};
    var hasRequiredLydian$1;
    function requireLydian$1() {
      if (hasRequiredLydian$1)
        return Lydian$1;
      hasRequiredLydian$1 = 1;
      var set3 = regenerate$2.exports(67903);
      set3.addRange(67872, 67897);
      Lydian$1.characters = set3;
      return Lydian$1;
    }
    var Mahajani$1 = {};
    var hasRequiredMahajani$1;
    function requireMahajani$1() {
      if (hasRequiredMahajani$1)
        return Mahajani$1;
      hasRequiredMahajani$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2415).addRange(43056, 43065).addRange(69968, 70006);
      Mahajani$1.characters = set3;
      return Mahajani$1;
    }
    var Makasar$1 = {};
    var hasRequiredMakasar$1;
    function requireMakasar$1() {
      if (hasRequiredMakasar$1)
        return Makasar$1;
      hasRequiredMakasar$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(73440, 73464);
      Makasar$1.characters = set3;
      return Makasar$1;
    }
    var Malayalam$1 = {};
    var hasRequiredMalayalam$1;
    function requireMalayalam$1() {
      if (hasRequiredMalayalam$1)
        return Malayalam$1;
      hasRequiredMalayalam$1 = 1;
      var set3 = regenerate$2.exports(7386);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3396).addRange(3398, 3400).addRange(3402, 3407).addRange(3412, 3427).addRange(3430, 3455).addRange(43056, 43058);
      Malayalam$1.characters = set3;
      return Malayalam$1;
    }
    var Mandaic$1 = {};
    var hasRequiredMandaic$1;
    function requireMandaic$1() {
      if (hasRequiredMandaic$1)
        return Mandaic$1;
      hasRequiredMandaic$1 = 1;
      var set3 = regenerate$2.exports(1600, 2142);
      set3.addRange(2112, 2139);
      Mandaic$1.characters = set3;
      return Mandaic$1;
    }
    var Manichaean$1 = {};
    var hasRequiredManichaean$1;
    function requireManichaean$1() {
      if (hasRequiredManichaean$1)
        return Manichaean$1;
      hasRequiredManichaean$1 = 1;
      var set3 = regenerate$2.exports(1600);
      set3.addRange(68288, 68326).addRange(68331, 68342);
      Manichaean$1.characters = set3;
      return Manichaean$1;
    }
    var Marchen$1 = {};
    var hasRequiredMarchen$1;
    function requireMarchen$1() {
      if (hasRequiredMarchen$1)
        return Marchen$1;
      hasRequiredMarchen$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72816, 72847).addRange(72850, 72871).addRange(72873, 72886);
      Marchen$1.characters = set3;
      return Marchen$1;
    }
    var Masaram_Gondi$1 = {};
    var hasRequiredMasaram_Gondi$1;
    function requireMasaram_Gondi$1() {
      if (hasRequiredMasaram_Gondi$1)
        return Masaram_Gondi$1;
      hasRequiredMasaram_Gondi$1 = 1;
      var set3 = regenerate$2.exports(73018);
      set3.addRange(2404, 2405).addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73031).addRange(73040, 73049);
      Masaram_Gondi$1.characters = set3;
      return Masaram_Gondi$1;
    }
    var Medefaidrin$1 = {};
    var hasRequiredMedefaidrin$1;
    function requireMedefaidrin$1() {
      if (hasRequiredMedefaidrin$1)
        return Medefaidrin$1;
      hasRequiredMedefaidrin$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(93760, 93850);
      Medefaidrin$1.characters = set3;
      return Medefaidrin$1;
    }
    var Meetei_Mayek$1 = {};
    var hasRequiredMeetei_Mayek$1;
    function requireMeetei_Mayek$1() {
      if (hasRequiredMeetei_Mayek$1)
        return Meetei_Mayek$1;
      hasRequiredMeetei_Mayek$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43744, 43766).addRange(43968, 44013).addRange(44016, 44025);
      Meetei_Mayek$1.characters = set3;
      return Meetei_Mayek$1;
    }
    var Mende_Kikakui$1 = {};
    var hasRequiredMende_Kikakui$1;
    function requireMende_Kikakui$1() {
      if (hasRequiredMende_Kikakui$1)
        return Mende_Kikakui$1;
      hasRequiredMende_Kikakui$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(124928, 125124).addRange(125127, 125142);
      Mende_Kikakui$1.characters = set3;
      return Mende_Kikakui$1;
    }
    var Meroitic_Cursive$1 = {};
    var hasRequiredMeroitic_Cursive$1;
    function requireMeroitic_Cursive$1() {
      if (hasRequiredMeroitic_Cursive$1)
        return Meroitic_Cursive$1;
      hasRequiredMeroitic_Cursive$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68e3, 68023).addRange(68028, 68047).addRange(68050, 68095);
      Meroitic_Cursive$1.characters = set3;
      return Meroitic_Cursive$1;
    }
    var Meroitic_Hieroglyphs$1 = {};
    var hasRequiredMeroitic_Hieroglyphs$1;
    function requireMeroitic_Hieroglyphs$1() {
      if (hasRequiredMeroitic_Hieroglyphs$1)
        return Meroitic_Hieroglyphs$1;
      hasRequiredMeroitic_Hieroglyphs$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67968, 67999);
      Meroitic_Hieroglyphs$1.characters = set3;
      return Meroitic_Hieroglyphs$1;
    }
    var Miao$1 = {};
    var hasRequiredMiao$1;
    function requireMiao$1() {
      if (hasRequiredMiao$1)
        return Miao$1;
      hasRequiredMiao$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111);
      Miao$1.characters = set3;
      return Miao$1;
    }
    var Modi$1 = {};
    var hasRequiredModi$1;
    function requireModi$1() {
      if (hasRequiredModi$1)
        return Modi$1;
      hasRequiredModi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43056, 43065).addRange(71168, 71236).addRange(71248, 71257);
      Modi$1.characters = set3;
      return Modi$1;
    }
    var Mongolian$1 = {};
    var hasRequiredMongolian$1;
    function requireMongolian$1() {
      if (hasRequiredMongolian$1)
        return Mongolian$1;
      hasRequiredMongolian$1 = 1;
      var set3 = regenerate$2.exports(8239);
      set3.addRange(6144, 6169).addRange(6176, 6264).addRange(6272, 6314).addRange(71264, 71276);
      Mongolian$1.characters = set3;
      return Mongolian$1;
    }
    var Mro$1 = {};
    var hasRequiredMro$1;
    function requireMro$1() {
      if (hasRequiredMro$1)
        return Mro$1;
      hasRequiredMro$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92736, 92766).addRange(92768, 92777).addRange(92782, 92783);
      Mro$1.characters = set3;
      return Mro$1;
    }
    var Multani$1 = {};
    var hasRequiredMultani$1;
    function requireMultani$1() {
      if (hasRequiredMultani$1)
        return Multani$1;
      hasRequiredMultani$1 = 1;
      var set3 = regenerate$2.exports(70280);
      set3.addRange(2662, 2671).addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70313);
      Multani$1.characters = set3;
      return Multani$1;
    }
    var Myanmar$1 = {};
    var hasRequiredMyanmar$1;
    function requireMyanmar$1() {
      if (hasRequiredMyanmar$1)
        return Myanmar$1;
      hasRequiredMyanmar$1 = 1;
      var set3 = regenerate$2.exports(43310);
      set3.addRange(4096, 4255).addRange(43488, 43518).addRange(43616, 43647);
      Myanmar$1.characters = set3;
      return Myanmar$1;
    }
    var Nabataean$1 = {};
    var hasRequiredNabataean$1;
    function requireNabataean$1() {
      if (hasRequiredNabataean$1)
        return Nabataean$1;
      hasRequiredNabataean$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67712, 67742).addRange(67751, 67759);
      Nabataean$1.characters = set3;
      return Nabataean$1;
    }
    var Nandinagari$1 = {};
    var hasRequiredNandinagari$1;
    function requireNandinagari$1() {
      if (hasRequiredNandinagari$1)
        return Nandinagari$1;
      hasRequiredNandinagari$1 = 1;
      var set3 = regenerate$2.exports(7401, 7410, 7418);
      set3.addRange(2404, 2405).addRange(3302, 3311).addRange(43056, 43061).addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72164);
      Nandinagari$1.characters = set3;
      return Nandinagari$1;
    }
    var New_Tai_Lue$1 = {};
    var hasRequiredNew_Tai_Lue$1;
    function requireNew_Tai_Lue$1() {
      if (hasRequiredNew_Tai_Lue$1)
        return New_Tai_Lue$1;
      hasRequiredNew_Tai_Lue$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6622, 6623);
      New_Tai_Lue$1.characters = set3;
      return New_Tai_Lue$1;
    }
    var Newa$1 = {};
    var hasRequiredNewa$1;
    function requireNewa$1() {
      if (hasRequiredNewa$1)
        return Newa$1;
      hasRequiredNewa$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70656, 70747).addRange(70749, 70753);
      Newa$1.characters = set3;
      return Newa$1;
    }
    var Nko$1 = {};
    var hasRequiredNko$1;
    function requireNko$1() {
      if (hasRequiredNko$1)
        return Nko$1;
      hasRequiredNko$1 = 1;
      var set3 = regenerate$2.exports(1548, 1563, 1567);
      set3.addRange(1984, 2042).addRange(2045, 2047).addRange(64830, 64831);
      Nko$1.characters = set3;
      return Nko$1;
    }
    var Nushu$1 = {};
    var hasRequiredNushu$1;
    function requireNushu$1() {
      if (hasRequiredNushu$1)
        return Nushu$1;
      hasRequiredNushu$1 = 1;
      var set3 = regenerate$2.exports(94177);
      set3.addRange(110960, 111355);
      Nushu$1.characters = set3;
      return Nushu$1;
    }
    var Nyiakeng_Puachue_Hmong$1 = {};
    var hasRequiredNyiakeng_Puachue_Hmong$1;
    function requireNyiakeng_Puachue_Hmong$1() {
      if (hasRequiredNyiakeng_Puachue_Hmong$1)
        return Nyiakeng_Puachue_Hmong$1;
      hasRequiredNyiakeng_Puachue_Hmong$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(123136, 123180).addRange(123184, 123197).addRange(123200, 123209).addRange(123214, 123215);
      Nyiakeng_Puachue_Hmong$1.characters = set3;
      return Nyiakeng_Puachue_Hmong$1;
    }
    var Ogham$1 = {};
    var hasRequiredOgham$1;
    function requireOgham$1() {
      if (hasRequiredOgham$1)
        return Ogham$1;
      hasRequiredOgham$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5760, 5788);
      Ogham$1.characters = set3;
      return Ogham$1;
    }
    var Ol_Chiki$1 = {};
    var hasRequiredOl_Chiki$1;
    function requireOl_Chiki$1() {
      if (hasRequiredOl_Chiki$1)
        return Ol_Chiki$1;
      hasRequiredOl_Chiki$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7248, 7295);
      Ol_Chiki$1.characters = set3;
      return Ol_Chiki$1;
    }
    var Old_Hungarian$1 = {};
    var hasRequiredOld_Hungarian$1;
    function requireOld_Hungarian$1() {
      if (hasRequiredOld_Hungarian$1)
        return Old_Hungarian$1;
      hasRequiredOld_Hungarian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68736, 68786).addRange(68800, 68850).addRange(68858, 68863);
      Old_Hungarian$1.characters = set3;
      return Old_Hungarian$1;
    }
    var Old_Italic$1 = {};
    var hasRequiredOld_Italic$1;
    function requireOld_Italic$1() {
      if (hasRequiredOld_Italic$1)
        return Old_Italic$1;
      hasRequiredOld_Italic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66304, 66339).addRange(66349, 66351);
      Old_Italic$1.characters = set3;
      return Old_Italic$1;
    }
    var Old_North_Arabian$1 = {};
    var hasRequiredOld_North_Arabian$1;
    function requireOld_North_Arabian$1() {
      if (hasRequiredOld_North_Arabian$1)
        return Old_North_Arabian$1;
      hasRequiredOld_North_Arabian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68224, 68255);
      Old_North_Arabian$1.characters = set3;
      return Old_North_Arabian$1;
    }
    var Old_Permic$1 = {};
    var hasRequiredOld_Permic$1;
    function requireOld_Permic$1() {
      if (hasRequiredOld_Permic$1)
        return Old_Permic$1;
      hasRequiredOld_Permic$1 = 1;
      var set3 = regenerate$2.exports(1155);
      set3.addRange(66384, 66426);
      Old_Permic$1.characters = set3;
      return Old_Permic$1;
    }
    var Old_Persian$1 = {};
    var hasRequiredOld_Persian$1;
    function requireOld_Persian$1() {
      if (hasRequiredOld_Persian$1)
        return Old_Persian$1;
      hasRequiredOld_Persian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66464, 66499).addRange(66504, 66517);
      Old_Persian$1.characters = set3;
      return Old_Persian$1;
    }
    var Old_Sogdian$1 = {};
    var hasRequiredOld_Sogdian$1;
    function requireOld_Sogdian$1() {
      if (hasRequiredOld_Sogdian$1)
        return Old_Sogdian$1;
      hasRequiredOld_Sogdian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69376, 69415);
      Old_Sogdian$1.characters = set3;
      return Old_Sogdian$1;
    }
    var Old_South_Arabian$1 = {};
    var hasRequiredOld_South_Arabian$1;
    function requireOld_South_Arabian$1() {
      if (hasRequiredOld_South_Arabian$1)
        return Old_South_Arabian$1;
      hasRequiredOld_South_Arabian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68192, 68223);
      Old_South_Arabian$1.characters = set3;
      return Old_South_Arabian$1;
    }
    var Old_Turkic$1 = {};
    var hasRequiredOld_Turkic$1;
    function requireOld_Turkic$1() {
      if (hasRequiredOld_Turkic$1)
        return Old_Turkic$1;
      hasRequiredOld_Turkic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68608, 68680);
      Old_Turkic$1.characters = set3;
      return Old_Turkic$1;
    }
    var Old_Uyghur$1 = {};
    var hasRequiredOld_Uyghur$1;
    function requireOld_Uyghur$1() {
      if (hasRequiredOld_Uyghur$1)
        return Old_Uyghur$1;
      hasRequiredOld_Uyghur$1 = 1;
      var set3 = regenerate$2.exports(1600, 68338);
      set3.addRange(69488, 69513);
      Old_Uyghur$1.characters = set3;
      return Old_Uyghur$1;
    }
    var Oriya$1 = {};
    var hasRequiredOriya$1;
    function requireOriya$1() {
      if (hasRequiredOriya$1)
        return Oriya$1;
      hasRequiredOriya$1 = 1;
      var set3 = regenerate$2.exports(7386, 7410);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2876, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2918, 2935);
      Oriya$1.characters = set3;
      return Oriya$1;
    }
    var Osage$1 = {};
    var hasRequiredOsage$1;
    function requireOsage$1() {
      if (hasRequiredOsage$1)
        return Osage$1;
      hasRequiredOsage$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66736, 66771).addRange(66776, 66811);
      Osage$1.characters = set3;
      return Osage$1;
    }
    var Osmanya$1 = {};
    var hasRequiredOsmanya$1;
    function requireOsmanya$1() {
      if (hasRequiredOsmanya$1)
        return Osmanya$1;
      hasRequiredOsmanya$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66688, 66717).addRange(66720, 66729);
      Osmanya$1.characters = set3;
      return Osmanya$1;
    }
    var Pahawh_Hmong$1 = {};
    var hasRequiredPahawh_Hmong$1;
    function requirePahawh_Hmong$1() {
      if (hasRequiredPahawh_Hmong$1)
        return Pahawh_Hmong$1;
      hasRequiredPahawh_Hmong$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92928, 92997).addRange(93008, 93017).addRange(93019, 93025).addRange(93027, 93047).addRange(93053, 93071);
      Pahawh_Hmong$1.characters = set3;
      return Pahawh_Hmong$1;
    }
    var Palmyrene$1 = {};
    var hasRequiredPalmyrene$1;
    function requirePalmyrene$1() {
      if (hasRequiredPalmyrene$1)
        return Palmyrene$1;
      hasRequiredPalmyrene$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67680, 67711);
      Palmyrene$1.characters = set3;
      return Palmyrene$1;
    }
    var Pau_Cin_Hau$1 = {};
    var hasRequiredPau_Cin_Hau$1;
    function requirePau_Cin_Hau$1() {
      if (hasRequiredPau_Cin_Hau$1)
        return Pau_Cin_Hau$1;
      hasRequiredPau_Cin_Hau$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72384, 72440);
      Pau_Cin_Hau$1.characters = set3;
      return Pau_Cin_Hau$1;
    }
    var Phags_Pa$1 = {};
    var hasRequiredPhags_Pa$1;
    function requirePhags_Pa$1() {
      if (hasRequiredPhags_Pa$1)
        return Phags_Pa$1;
      hasRequiredPhags_Pa$1 = 1;
      var set3 = regenerate$2.exports(6149);
      set3.addRange(6146, 6147).addRange(43072, 43127);
      Phags_Pa$1.characters = set3;
      return Phags_Pa$1;
    }
    var Phoenician$1 = {};
    var hasRequiredPhoenician$1;
    function requirePhoenician$1() {
      if (hasRequiredPhoenician$1)
        return Phoenician$1;
      hasRequiredPhoenician$1 = 1;
      var set3 = regenerate$2.exports(67871);
      set3.addRange(67840, 67867);
      Phoenician$1.characters = set3;
      return Phoenician$1;
    }
    var Psalter_Pahlavi$1 = {};
    var hasRequiredPsalter_Pahlavi$1;
    function requirePsalter_Pahlavi$1() {
      if (hasRequiredPsalter_Pahlavi$1)
        return Psalter_Pahlavi$1;
      hasRequiredPsalter_Pahlavi$1 = 1;
      var set3 = regenerate$2.exports(1600);
      set3.addRange(68480, 68497).addRange(68505, 68508).addRange(68521, 68527);
      Psalter_Pahlavi$1.characters = set3;
      return Psalter_Pahlavi$1;
    }
    var Rejang$1 = {};
    var hasRequiredRejang$1;
    function requireRejang$1() {
      if (hasRequiredRejang$1)
        return Rejang$1;
      hasRequiredRejang$1 = 1;
      var set3 = regenerate$2.exports(43359);
      set3.addRange(43312, 43347);
      Rejang$1.characters = set3;
      return Rejang$1;
    }
    var Runic$1 = {};
    var hasRequiredRunic$1;
    function requireRunic$1() {
      if (hasRequiredRunic$1)
        return Runic$1;
      hasRequiredRunic$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5792, 5866).addRange(5870, 5880);
      Runic$1.characters = set3;
      return Runic$1;
    }
    var Samaritan$1 = {};
    var hasRequiredSamaritan$1;
    function requireSamaritan$1() {
      if (hasRequiredSamaritan$1)
        return Samaritan$1;
      hasRequiredSamaritan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2048, 2093).addRange(2096, 2110);
      Samaritan$1.characters = set3;
      return Samaritan$1;
    }
    var Saurashtra$1 = {};
    var hasRequiredSaurashtra$1;
    function requireSaurashtra$1() {
      if (hasRequiredSaurashtra$1)
        return Saurashtra$1;
      hasRequiredSaurashtra$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43136, 43205).addRange(43214, 43225);
      Saurashtra$1.characters = set3;
      return Saurashtra$1;
    }
    var Sharada$1 = {};
    var hasRequiredSharada$1;
    function requireSharada$1() {
      if (hasRequiredSharada$1)
        return Sharada$1;
      hasRequiredSharada$1 = 1;
      var set3 = regenerate$2.exports(2385, 7383, 7385, 7392);
      set3.addRange(7388, 7389).addRange(70016, 70111);
      Sharada$1.characters = set3;
      return Sharada$1;
    }
    var Shavian$1 = {};
    var hasRequiredShavian$1;
    function requireShavian$1() {
      if (hasRequiredShavian$1)
        return Shavian$1;
      hasRequiredShavian$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66640, 66687);
      Shavian$1.characters = set3;
      return Shavian$1;
    }
    var Siddham$1 = {};
    var hasRequiredSiddham$1;
    function requireSiddham$1() {
      if (hasRequiredSiddham$1)
        return Siddham$1;
      hasRequiredSiddham$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71040, 71093).addRange(71096, 71133);
      Siddham$1.characters = set3;
      return Siddham$1;
    }
    var SignWriting$1 = {};
    var hasRequiredSignWriting$1;
    function requireSignWriting$1() {
      if (hasRequiredSignWriting$1)
        return SignWriting$1;
      hasRequiredSignWriting$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(120832, 121483).addRange(121499, 121503).addRange(121505, 121519);
      SignWriting$1.characters = set3;
      return SignWriting$1;
    }
    var Sinhala$1 = {};
    var hasRequiredSinhala$1;
    function requireSinhala$1() {
      if (hasRequiredSinhala$1)
        return Sinhala$1;
      hasRequiredSinhala$1 = 1;
      var set3 = regenerate$2.exports(3517, 3530, 3542);
      set3.addRange(2404, 2405).addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3558, 3567).addRange(3570, 3572).addRange(70113, 70132);
      Sinhala$1.characters = set3;
      return Sinhala$1;
    }
    var Sogdian$1 = {};
    var hasRequiredSogdian$1;
    function requireSogdian$1() {
      if (hasRequiredSogdian$1)
        return Sogdian$1;
      hasRequiredSogdian$1 = 1;
      var set3 = regenerate$2.exports(1600);
      set3.addRange(69424, 69465);
      Sogdian$1.characters = set3;
      return Sogdian$1;
    }
    var Sora_Sompeng$1 = {};
    var hasRequiredSora_Sompeng$1;
    function requireSora_Sompeng$1() {
      if (hasRequiredSora_Sompeng$1)
        return Sora_Sompeng$1;
      hasRequiredSora_Sompeng$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69840, 69864).addRange(69872, 69881);
      Sora_Sompeng$1.characters = set3;
      return Sora_Sompeng$1;
    }
    var Soyombo$1 = {};
    var hasRequiredSoyombo$1;
    function requireSoyombo$1() {
      if (hasRequiredSoyombo$1)
        return Soyombo$1;
      hasRequiredSoyombo$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72272, 72354);
      Soyombo$1.characters = set3;
      return Soyombo$1;
    }
    var Sundanese$1 = {};
    var hasRequiredSundanese$1;
    function requireSundanese$1() {
      if (hasRequiredSundanese$1)
        return Sundanese$1;
      hasRequiredSundanese$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7040, 7103).addRange(7360, 7367);
      Sundanese$1.characters = set3;
      return Sundanese$1;
    }
    var Syloti_Nagri$1 = {};
    var hasRequiredSyloti_Nagri$1;
    function requireSyloti_Nagri$1() {
      if (hasRequiredSyloti_Nagri$1)
        return Syloti_Nagri$1;
      hasRequiredSyloti_Nagri$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2405).addRange(2534, 2543).addRange(43008, 43052);
      Syloti_Nagri$1.characters = set3;
      return Syloti_Nagri$1;
    }
    var Syriac$1 = {};
    var hasRequiredSyriac$1;
    function requireSyriac$1() {
      if (hasRequiredSyriac$1)
        return Syriac$1;
      hasRequiredSyriac$1 = 1;
      var set3 = regenerate$2.exports(1548, 1567, 1600, 1648, 7672, 7674);
      set3.addRange(1563, 1564).addRange(1611, 1621).addRange(1792, 1805).addRange(1807, 1866).addRange(1869, 1871).addRange(2144, 2154);
      Syriac$1.characters = set3;
      return Syriac$1;
    }
    var Tagalog$1 = {};
    var hasRequiredTagalog$1;
    function requireTagalog$1() {
      if (hasRequiredTagalog$1)
        return Tagalog$1;
      hasRequiredTagalog$1 = 1;
      var set3 = regenerate$2.exports(5919);
      set3.addRange(5888, 5909).addRange(5941, 5942);
      Tagalog$1.characters = set3;
      return Tagalog$1;
    }
    var Tagbanwa$1 = {};
    var hasRequiredTagbanwa$1;
    function requireTagbanwa$1() {
      if (hasRequiredTagbanwa$1)
        return Tagbanwa$1;
      hasRequiredTagbanwa$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5941, 5942).addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003);
      Tagbanwa$1.characters = set3;
      return Tagbanwa$1;
    }
    var Tai_Le$1 = {};
    var hasRequiredTai_Le$1;
    function requireTai_Le$1() {
      if (hasRequiredTai_Le$1)
        return Tai_Le$1;
      hasRequiredTai_Le$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(4160, 4169).addRange(6480, 6509).addRange(6512, 6516);
      Tai_Le$1.characters = set3;
      return Tai_Le$1;
    }
    var Tai_Tham$1 = {};
    var hasRequiredTai_Tham$1;
    function requireTai_Tham$1() {
      if (hasRequiredTai_Tham$1)
        return Tai_Tham$1;
      hasRequiredTai_Tham$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6688, 6750).addRange(6752, 6780).addRange(6783, 6793).addRange(6800, 6809).addRange(6816, 6829);
      Tai_Tham$1.characters = set3;
      return Tai_Tham$1;
    }
    var Tai_Viet$1 = {};
    var hasRequiredTai_Viet$1;
    function requireTai_Viet$1() {
      if (hasRequiredTai_Viet$1)
        return Tai_Viet$1;
      hasRequiredTai_Viet$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43648, 43714).addRange(43739, 43743);
      Tai_Viet$1.characters = set3;
      return Tai_Viet$1;
    }
    var Takri$1 = {};
    var hasRequiredTakri$1;
    function requireTakri$1() {
      if (hasRequiredTakri$1)
        return Takri$1;
      hasRequiredTakri$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2404, 2405).addRange(43056, 43065).addRange(71296, 71353).addRange(71360, 71369);
      Takri$1.characters = set3;
      return Takri$1;
    }
    var Tamil$1 = {};
    var hasRequiredTamil$1;
    function requireTamil$1() {
      if (hasRequiredTamil$1)
        return Tamil$1;
      hasRequiredTamil$1 = 1;
      var set3 = regenerate$2.exports(2972, 3024, 3031, 7386, 43251, 70401, 70403, 73727);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021).addRange(3046, 3066).addRange(70459, 70460).addRange(73664, 73713);
      Tamil$1.characters = set3;
      return Tamil$1;
    }
    var Tangsa$1 = {};
    var hasRequiredTangsa$1;
    function requireTangsa$1() {
      if (hasRequiredTangsa$1)
        return Tangsa$1;
      hasRequiredTangsa$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92784, 92862).addRange(92864, 92873);
      Tangsa$1.characters = set3;
      return Tangsa$1;
    }
    var Tangut$1 = {};
    var hasRequiredTangut$1;
    function requireTangut$1() {
      if (hasRequiredTangut$1)
        return Tangut$1;
      hasRequiredTangut$1 = 1;
      var set3 = regenerate$2.exports(94176);
      set3.addRange(94208, 100343).addRange(100352, 101119).addRange(101632, 101640);
      Tangut$1.characters = set3;
      return Tangut$1;
    }
    var Telugu$1 = {};
    var hasRequiredTelugu$1;
    function requireTelugu$1() {
      if (hasRequiredTelugu$1)
        return Telugu$1;
      hasRequiredTelugu$1 = 1;
      var set3 = regenerate$2.exports(3165, 7386, 7410);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(3072, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3132, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3174, 3183).addRange(3191, 3199);
      Telugu$1.characters = set3;
      return Telugu$1;
    }
    var Thaana$1 = {};
    var hasRequiredThaana$1;
    function requireThaana$1() {
      if (hasRequiredThaana$1)
        return Thaana$1;
      hasRequiredThaana$1 = 1;
      var set3 = regenerate$2.exports(1548, 1567, 65010, 65021);
      set3.addRange(1563, 1564).addRange(1632, 1641).addRange(1920, 1969);
      Thaana$1.characters = set3;
      return Thaana$1;
    }
    var Thai$1 = {};
    var hasRequiredThai$1;
    function requireThai$1() {
      if (hasRequiredThai$1)
        return Thai$1;
      hasRequiredThai$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3585, 3642).addRange(3648, 3675);
      Thai$1.characters = set3;
      return Thai$1;
    }
    var Tibetan$1 = {};
    var hasRequiredTibetan$1;
    function requireTibetan$1() {
      if (hasRequiredTibetan$1)
        return Tibetan$1;
      hasRequiredTibetan$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3840, 3911).addRange(3913, 3948).addRange(3953, 3991).addRange(3993, 4028).addRange(4030, 4044).addRange(4046, 4052).addRange(4057, 4058);
      Tibetan$1.characters = set3;
      return Tibetan$1;
    }
    var Tifinagh$1 = {};
    var hasRequiredTifinagh$1;
    function requireTifinagh$1() {
      if (hasRequiredTifinagh$1)
        return Tifinagh$1;
      hasRequiredTifinagh$1 = 1;
      var set3 = regenerate$2.exports(11647);
      set3.addRange(11568, 11623).addRange(11631, 11632);
      Tifinagh$1.characters = set3;
      return Tifinagh$1;
    }
    var Tirhuta$1 = {};
    var hasRequiredTirhuta$1;
    function requireTirhuta$1() {
      if (hasRequiredTirhuta$1)
        return Tirhuta$1;
      hasRequiredTirhuta$1 = 1;
      var set3 = regenerate$2.exports(7410);
      set3.addRange(2385, 2386).addRange(2404, 2405).addRange(43056, 43065).addRange(70784, 70855).addRange(70864, 70873);
      Tirhuta$1.characters = set3;
      return Tirhuta$1;
    }
    var Toto$1 = {};
    var hasRequiredToto$1;
    function requireToto$1() {
      if (hasRequiredToto$1)
        return Toto$1;
      hasRequiredToto$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(123536, 123566);
      Toto$1.characters = set3;
      return Toto$1;
    }
    var Ugaritic$1 = {};
    var hasRequiredUgaritic$1;
    function requireUgaritic$1() {
      if (hasRequiredUgaritic$1)
        return Ugaritic$1;
      hasRequiredUgaritic$1 = 1;
      var set3 = regenerate$2.exports(66463);
      set3.addRange(66432, 66461);
      Ugaritic$1.characters = set3;
      return Ugaritic$1;
    }
    var Vai$1 = {};
    var hasRequiredVai$1;
    function requireVai$1() {
      if (hasRequiredVai$1)
        return Vai$1;
      hasRequiredVai$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(42240, 42539);
      Vai$1.characters = set3;
      return Vai$1;
    }
    var Vithkuqi$1 = {};
    var hasRequiredVithkuqi$1;
    function requireVithkuqi$1() {
      if (hasRequiredVithkuqi$1)
        return Vithkuqi$1;
      hasRequiredVithkuqi$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004);
      Vithkuqi$1.characters = set3;
      return Vithkuqi$1;
    }
    var Wancho$1 = {};
    var hasRequiredWancho$1;
    function requireWancho$1() {
      if (hasRequiredWancho$1)
        return Wancho$1;
      hasRequiredWancho$1 = 1;
      var set3 = regenerate$2.exports(123647);
      set3.addRange(123584, 123641);
      Wancho$1.characters = set3;
      return Wancho$1;
    }
    var Warang_Citi$1 = {};
    var hasRequiredWarang_Citi$1;
    function requireWarang_Citi$1() {
      if (hasRequiredWarang_Citi$1)
        return Warang_Citi$1;
      hasRequiredWarang_Citi$1 = 1;
      var set3 = regenerate$2.exports(71935);
      set3.addRange(71840, 71922);
      Warang_Citi$1.characters = set3;
      return Warang_Citi$1;
    }
    var Yezidi$1 = {};
    var hasRequiredYezidi$1;
    function requireYezidi$1() {
      if (hasRequiredYezidi$1)
        return Yezidi$1;
      hasRequiredYezidi$1 = 1;
      var set3 = regenerate$2.exports(1548, 1563, 1567);
      set3.addRange(1632, 1641).addRange(69248, 69289).addRange(69291, 69293).addRange(69296, 69297);
      Yezidi$1.characters = set3;
      return Yezidi$1;
    }
    var Yi$1 = {};
    var hasRequiredYi$1;
    function requireYi$1() {
      if (hasRequiredYi$1)
        return Yi$1;
      hasRequiredYi$1 = 1;
      var set3 = regenerate$2.exports(12539);
      set3.addRange(12289, 12290).addRange(12296, 12305).addRange(12308, 12315).addRange(40960, 42124).addRange(42128, 42182).addRange(65377, 65381);
      Yi$1.characters = set3;
      return Yi$1;
    }
    var Zanabazar_Square$1 = {};
    var hasRequiredZanabazar_Square$1;
    function requireZanabazar_Square$1() {
      if (hasRequiredZanabazar_Square$1)
        return Zanabazar_Square$1;
      hasRequiredZanabazar_Square$1 = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72192, 72263);
      Zanabazar_Square$1.characters = set3;
      return Zanabazar_Square$1;
    }
    var Adlam = {};
    var hasRequiredAdlam;
    function requireAdlam() {
      if (hasRequiredAdlam)
        return Adlam;
      hasRequiredAdlam = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(125184, 125259).addRange(125264, 125273).addRange(125278, 125279);
      Adlam.characters = set3;
      return Adlam;
    }
    var Ahom = {};
    var hasRequiredAhom;
    function requireAhom() {
      if (hasRequiredAhom)
        return Ahom;
      hasRequiredAhom = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71424, 71450).addRange(71453, 71467).addRange(71472, 71494);
      Ahom.characters = set3;
      return Ahom;
    }
    var Anatolian_Hieroglyphs = {};
    var hasRequiredAnatolian_Hieroglyphs;
    function requireAnatolian_Hieroglyphs() {
      if (hasRequiredAnatolian_Hieroglyphs)
        return Anatolian_Hieroglyphs;
      hasRequiredAnatolian_Hieroglyphs = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(82944, 83526);
      Anatolian_Hieroglyphs.characters = set3;
      return Anatolian_Hieroglyphs;
    }
    var Arabic = {};
    var hasRequiredArabic;
    function requireArabic() {
      if (hasRequiredArabic)
        return Arabic;
      hasRequiredArabic = 1;
      var set3 = regenerate$2.exports(64975, 126500, 126503, 126521, 126523, 126530, 126535, 126537, 126539, 126548, 126551, 126553, 126555, 126557, 126559, 126564, 126590);
      set3.addRange(1536, 1540).addRange(1542, 1547).addRange(1549, 1562).addRange(1564, 1566).addRange(1568, 1599).addRange(1601, 1610).addRange(1622, 1647).addRange(1649, 1756).addRange(1758, 1791).addRange(1872, 1919).addRange(2160, 2190).addRange(2192, 2193).addRange(2200, 2273).addRange(2275, 2303).addRange(64336, 64450).addRange(64467, 64829).addRange(64832, 64911).addRange(64914, 64967).addRange(65008, 65023).addRange(65136, 65140).addRange(65142, 65276).addRange(69216, 69246).addRange(126464, 126467).addRange(126469, 126495).addRange(126497, 126498).addRange(126505, 126514).addRange(126516, 126519).addRange(126541, 126543).addRange(126545, 126546).addRange(126561, 126562).addRange(126567, 126570).addRange(126572, 126578).addRange(126580, 126583).addRange(126585, 126588).addRange(126592, 126601).addRange(126603, 126619).addRange(126625, 126627).addRange(126629, 126633).addRange(126635, 126651).addRange(126704, 126705);
      Arabic.characters = set3;
      return Arabic;
    }
    var Armenian = {};
    var hasRequiredArmenian;
    function requireArmenian() {
      if (hasRequiredArmenian)
        return Armenian;
      hasRequiredArmenian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(1329, 1366).addRange(1369, 1418).addRange(1421, 1423).addRange(64275, 64279);
      Armenian.characters = set3;
      return Armenian;
    }
    var Avestan = {};
    var hasRequiredAvestan;
    function requireAvestan() {
      if (hasRequiredAvestan)
        return Avestan;
      hasRequiredAvestan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68352, 68405).addRange(68409, 68415);
      Avestan.characters = set3;
      return Avestan;
    }
    var Balinese = {};
    var hasRequiredBalinese;
    function requireBalinese() {
      if (hasRequiredBalinese)
        return Balinese;
      hasRequiredBalinese = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6912, 6988).addRange(6992, 7038);
      Balinese.characters = set3;
      return Balinese;
    }
    var Bamum = {};
    var hasRequiredBamum;
    function requireBamum() {
      if (hasRequiredBamum)
        return Bamum;
      hasRequiredBamum = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(42656, 42743).addRange(92160, 92728);
      Bamum.characters = set3;
      return Bamum;
    }
    var Bassa_Vah = {};
    var hasRequiredBassa_Vah;
    function requireBassa_Vah() {
      if (hasRequiredBassa_Vah)
        return Bassa_Vah;
      hasRequiredBassa_Vah = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92880, 92909).addRange(92912, 92917);
      Bassa_Vah.characters = set3;
      return Bassa_Vah;
    }
    var Batak = {};
    var hasRequiredBatak;
    function requireBatak() {
      if (hasRequiredBatak)
        return Batak;
      hasRequiredBatak = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7104, 7155).addRange(7164, 7167);
      Batak.characters = set3;
      return Batak;
    }
    var Bengali = {};
    var hasRequiredBengali;
    function requireBengali() {
      if (hasRequiredBengali)
        return Bengali;
      hasRequiredBengali = 1;
      var set3 = regenerate$2.exports(2482, 2519);
      set3.addRange(2432, 2435).addRange(2437, 2444).addRange(2447, 2448).addRange(2451, 2472).addRange(2474, 2480).addRange(2486, 2489).addRange(2492, 2500).addRange(2503, 2504).addRange(2507, 2510).addRange(2524, 2525).addRange(2527, 2531).addRange(2534, 2558);
      Bengali.characters = set3;
      return Bengali;
    }
    var Bhaiksuki = {};
    var hasRequiredBhaiksuki;
    function requireBhaiksuki() {
      if (hasRequiredBhaiksuki)
        return Bhaiksuki;
      hasRequiredBhaiksuki = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72704, 72712).addRange(72714, 72758).addRange(72760, 72773).addRange(72784, 72812);
      Bhaiksuki.characters = set3;
      return Bhaiksuki;
    }
    var Bopomofo = {};
    var hasRequiredBopomofo;
    function requireBopomofo() {
      if (hasRequiredBopomofo)
        return Bopomofo;
      hasRequiredBopomofo = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(746, 747).addRange(12549, 12591).addRange(12704, 12735);
      Bopomofo.characters = set3;
      return Bopomofo;
    }
    var Brahmi = {};
    var hasRequiredBrahmi;
    function requireBrahmi() {
      if (hasRequiredBrahmi)
        return Brahmi;
      hasRequiredBrahmi = 1;
      var set3 = regenerate$2.exports(69759);
      set3.addRange(69632, 69709).addRange(69714, 69749);
      Brahmi.characters = set3;
      return Brahmi;
    }
    var Braille = {};
    var hasRequiredBraille;
    function requireBraille() {
      if (hasRequiredBraille)
        return Braille;
      hasRequiredBraille = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(10240, 10495);
      Braille.characters = set3;
      return Braille;
    }
    var Buginese = {};
    var hasRequiredBuginese;
    function requireBuginese() {
      if (hasRequiredBuginese)
        return Buginese;
      hasRequiredBuginese = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6656, 6683).addRange(6686, 6687);
      Buginese.characters = set3;
      return Buginese;
    }
    var Buhid = {};
    var hasRequiredBuhid;
    function requireBuhid() {
      if (hasRequiredBuhid)
        return Buhid;
      hasRequiredBuhid = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5952, 5971);
      Buhid.characters = set3;
      return Buhid;
    }
    var Canadian_Aboriginal = {};
    var hasRequiredCanadian_Aboriginal;
    function requireCanadian_Aboriginal() {
      if (hasRequiredCanadian_Aboriginal)
        return Canadian_Aboriginal;
      hasRequiredCanadian_Aboriginal = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5120, 5759).addRange(6320, 6389).addRange(72368, 72383);
      Canadian_Aboriginal.characters = set3;
      return Canadian_Aboriginal;
    }
    var Carian = {};
    var hasRequiredCarian;
    function requireCarian() {
      if (hasRequiredCarian)
        return Carian;
      hasRequiredCarian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66208, 66256);
      Carian.characters = set3;
      return Carian;
    }
    var Caucasian_Albanian = {};
    var hasRequiredCaucasian_Albanian;
    function requireCaucasian_Albanian() {
      if (hasRequiredCaucasian_Albanian)
        return Caucasian_Albanian;
      hasRequiredCaucasian_Albanian = 1;
      var set3 = regenerate$2.exports(66927);
      set3.addRange(66864, 66915);
      Caucasian_Albanian.characters = set3;
      return Caucasian_Albanian;
    }
    var Chakma = {};
    var hasRequiredChakma;
    function requireChakma() {
      if (hasRequiredChakma)
        return Chakma;
      hasRequiredChakma = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69888, 69940).addRange(69942, 69959);
      Chakma.characters = set3;
      return Chakma;
    }
    var Cham = {};
    var hasRequiredCham;
    function requireCham() {
      if (hasRequiredCham)
        return Cham;
      hasRequiredCham = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43520, 43574).addRange(43584, 43597).addRange(43600, 43609).addRange(43612, 43615);
      Cham.characters = set3;
      return Cham;
    }
    var Cherokee = {};
    var hasRequiredCherokee;
    function requireCherokee() {
      if (hasRequiredCherokee)
        return Cherokee;
      hasRequiredCherokee = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5024, 5109).addRange(5112, 5117).addRange(43888, 43967);
      Cherokee.characters = set3;
      return Cherokee;
    }
    var Chorasmian = {};
    var hasRequiredChorasmian;
    function requireChorasmian() {
      if (hasRequiredChorasmian)
        return Chorasmian;
      hasRequiredChorasmian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69552, 69579);
      Chorasmian.characters = set3;
      return Chorasmian;
    }
    var Common = {};
    var hasRequiredCommon;
    function requireCommon() {
      if (hasRequiredCommon)
        return Common;
      hasRequiredCommon = 1;
      var set3 = regenerate$2.exports(215, 247, 884, 894, 901, 903, 1541, 1548, 1563, 1567, 1600, 1757, 2274, 3647, 4347, 6149, 7379, 7393, 7418, 12294, 12448, 13055, 43310, 43471, 43867, 65279, 65392, 119970, 119995, 120134, 129008, 917505);
      set3.addRange(0, 64).addRange(91, 96).addRange(123, 169).addRange(171, 185).addRange(187, 191).addRange(697, 735).addRange(741, 745).addRange(748, 767).addRange(2404, 2405).addRange(4053, 4056).addRange(5867, 5869).addRange(5941, 5942).addRange(6146, 6147).addRange(7401, 7404).addRange(7406, 7411).addRange(7413, 7415).addRange(8192, 8203).addRange(8206, 8292).addRange(8294, 8304).addRange(8308, 8318).addRange(8320, 8334).addRange(8352, 8384).addRange(8448, 8485).addRange(8487, 8489).addRange(8492, 8497).addRange(8499, 8525).addRange(8527, 8543).addRange(8585, 8587).addRange(8592, 9254).addRange(9280, 9290).addRange(9312, 10239).addRange(10496, 11123).addRange(11126, 11157).addRange(11159, 11263).addRange(11776, 11869).addRange(12272, 12283).addRange(12288, 12292).addRange(12296, 12320).addRange(12336, 12343).addRange(12348, 12351).addRange(12443, 12444).addRange(12539, 12540).addRange(12688, 12703).addRange(12736, 12771).addRange(12832, 12895).addRange(12927, 13007).addRange(13144, 13311).addRange(19904, 19967).addRange(42752, 42785).addRange(42888, 42890).addRange(43056, 43065);
      set3.addRange(43882, 43883).addRange(64830, 64831).addRange(65040, 65049).addRange(65072, 65106).addRange(65108, 65126).addRange(65128, 65131).addRange(65281, 65312).addRange(65339, 65344).addRange(65371, 65381).addRange(65438, 65439).addRange(65504, 65510).addRange(65512, 65518).addRange(65529, 65533).addRange(65792, 65794).addRange(65799, 65843).addRange(65847, 65855).addRange(65936, 65948).addRange(66e3, 66044).addRange(66273, 66299).addRange(113824, 113827).addRange(118608, 118723).addRange(118784, 119029).addRange(119040, 119078).addRange(119081, 119142).addRange(119146, 119162).addRange(119171, 119172).addRange(119180, 119209).addRange(119214, 119274).addRange(119520, 119539).addRange(119552, 119638).addRange(119648, 119672).addRange(119808, 119892).addRange(119894, 119964).addRange(119966, 119967).addRange(119973, 119974).addRange(119977, 119980).addRange(119982, 119993).addRange(119997, 120003).addRange(120005, 120069).addRange(120071, 120074).addRange(120077, 120084).addRange(120086, 120092).addRange(120094, 120121).addRange(120123, 120126).addRange(120128, 120132).addRange(120138, 120144).addRange(120146, 120485).addRange(120488, 120779).addRange(120782, 120831).addRange(126065, 126132).addRange(126209, 126269);
      set3.addRange(126976, 127019).addRange(127024, 127123).addRange(127136, 127150).addRange(127153, 127167).addRange(127169, 127183).addRange(127185, 127221).addRange(127232, 127405).addRange(127462, 127487).addRange(127489, 127490).addRange(127504, 127547).addRange(127552, 127560).addRange(127568, 127569).addRange(127584, 127589).addRange(127744, 128727).addRange(128733, 128748).addRange(128752, 128764).addRange(128768, 128883).addRange(128896, 128984).addRange(128992, 129003).addRange(129024, 129035).addRange(129040, 129095).addRange(129104, 129113).addRange(129120, 129159).addRange(129168, 129197).addRange(129200, 129201).addRange(129280, 129619).addRange(129632, 129645).addRange(129648, 129652).addRange(129656, 129660).addRange(129664, 129670).addRange(129680, 129708).addRange(129712, 129722).addRange(129728, 129733).addRange(129744, 129753).addRange(129760, 129767).addRange(129776, 129782).addRange(129792, 129938).addRange(129940, 129994).addRange(130032, 130041).addRange(917536, 917631);
      Common.characters = set3;
      return Common;
    }
    var Coptic = {};
    var hasRequiredCoptic;
    function requireCoptic() {
      if (hasRequiredCoptic)
        return Coptic;
      hasRequiredCoptic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(994, 1007).addRange(11392, 11507).addRange(11513, 11519);
      Coptic.characters = set3;
      return Coptic;
    }
    var Cuneiform = {};
    var hasRequiredCuneiform;
    function requireCuneiform() {
      if (hasRequiredCuneiform)
        return Cuneiform;
      hasRequiredCuneiform = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(73728, 74649).addRange(74752, 74862).addRange(74864, 74868).addRange(74880, 75075);
      Cuneiform.characters = set3;
      return Cuneiform;
    }
    var Cypriot = {};
    var hasRequiredCypriot;
    function requireCypriot() {
      if (hasRequiredCypriot)
        return Cypriot;
      hasRequiredCypriot = 1;
      var set3 = regenerate$2.exports(67592, 67644, 67647);
      set3.addRange(67584, 67589).addRange(67594, 67637).addRange(67639, 67640);
      Cypriot.characters = set3;
      return Cypriot;
    }
    var Cypro_Minoan = {};
    var hasRequiredCypro_Minoan;
    function requireCypro_Minoan() {
      if (hasRequiredCypro_Minoan)
        return Cypro_Minoan;
      hasRequiredCypro_Minoan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(77712, 77810);
      Cypro_Minoan.characters = set3;
      return Cypro_Minoan;
    }
    var Cyrillic = {};
    var hasRequiredCyrillic;
    function requireCyrillic() {
      if (hasRequiredCyrillic)
        return Cyrillic;
      hasRequiredCyrillic = 1;
      var set3 = regenerate$2.exports(7467, 7544);
      set3.addRange(1024, 1156).addRange(1159, 1327).addRange(7296, 7304).addRange(11744, 11775).addRange(42560, 42655).addRange(65070, 65071);
      Cyrillic.characters = set3;
      return Cyrillic;
    }
    var Deseret = {};
    var hasRequiredDeseret;
    function requireDeseret() {
      if (hasRequiredDeseret)
        return Deseret;
      hasRequiredDeseret = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66560, 66639);
      Deseret.characters = set3;
      return Deseret;
    }
    var Devanagari = {};
    var hasRequiredDevanagari;
    function requireDevanagari() {
      if (hasRequiredDevanagari)
        return Devanagari;
      hasRequiredDevanagari = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2304, 2384).addRange(2389, 2403).addRange(2406, 2431).addRange(43232, 43263);
      Devanagari.characters = set3;
      return Devanagari;
    }
    var Dives_Akuru = {};
    var hasRequiredDives_Akuru;
    function requireDives_Akuru() {
      if (hasRequiredDives_Akuru)
        return Dives_Akuru;
      hasRequiredDives_Akuru = 1;
      var set3 = regenerate$2.exports(71945);
      set3.addRange(71936, 71942).addRange(71948, 71955).addRange(71957, 71958).addRange(71960, 71989).addRange(71991, 71992).addRange(71995, 72006).addRange(72016, 72025);
      Dives_Akuru.characters = set3;
      return Dives_Akuru;
    }
    var Dogra = {};
    var hasRequiredDogra;
    function requireDogra() {
      if (hasRequiredDogra)
        return Dogra;
      hasRequiredDogra = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71680, 71739);
      Dogra.characters = set3;
      return Dogra;
    }
    var Duployan = {};
    var hasRequiredDuployan;
    function requireDuployan() {
      if (hasRequiredDuployan)
        return Duployan;
      hasRequiredDuployan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(113664, 113770).addRange(113776, 113788).addRange(113792, 113800).addRange(113808, 113817).addRange(113820, 113823);
      Duployan.characters = set3;
      return Duployan;
    }
    var Egyptian_Hieroglyphs = {};
    var hasRequiredEgyptian_Hieroglyphs;
    function requireEgyptian_Hieroglyphs() {
      if (hasRequiredEgyptian_Hieroglyphs)
        return Egyptian_Hieroglyphs;
      hasRequiredEgyptian_Hieroglyphs = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(77824, 78894).addRange(78896, 78904);
      Egyptian_Hieroglyphs.characters = set3;
      return Egyptian_Hieroglyphs;
    }
    var Elbasan = {};
    var hasRequiredElbasan;
    function requireElbasan() {
      if (hasRequiredElbasan)
        return Elbasan;
      hasRequiredElbasan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66816, 66855);
      Elbasan.characters = set3;
      return Elbasan;
    }
    var Elymaic = {};
    var hasRequiredElymaic;
    function requireElymaic() {
      if (hasRequiredElymaic)
        return Elymaic;
      hasRequiredElymaic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69600, 69622);
      Elymaic.characters = set3;
      return Elymaic;
    }
    var Ethiopic = {};
    var hasRequiredEthiopic;
    function requireEthiopic() {
      if (hasRequiredEthiopic)
        return Ethiopic;
      hasRequiredEthiopic = 1;
      var set3 = regenerate$2.exports(4696, 4800);
      set3.addRange(4608, 4680).addRange(4682, 4685).addRange(4688, 4694).addRange(4698, 4701).addRange(4704, 4744).addRange(4746, 4749).addRange(4752, 4784).addRange(4786, 4789).addRange(4792, 4798).addRange(4802, 4805).addRange(4808, 4822).addRange(4824, 4880).addRange(4882, 4885).addRange(4888, 4954).addRange(4957, 4988).addRange(4992, 5017).addRange(11648, 11670).addRange(11680, 11686).addRange(11688, 11694).addRange(11696, 11702).addRange(11704, 11710).addRange(11712, 11718).addRange(11720, 11726).addRange(11728, 11734).addRange(11736, 11742).addRange(43777, 43782).addRange(43785, 43790).addRange(43793, 43798).addRange(43808, 43814).addRange(43816, 43822).addRange(124896, 124902).addRange(124904, 124907).addRange(124909, 124910).addRange(124912, 124926);
      Ethiopic.characters = set3;
      return Ethiopic;
    }
    var Georgian = {};
    var hasRequiredGeorgian;
    function requireGeorgian() {
      if (hasRequiredGeorgian)
        return Georgian;
      hasRequiredGeorgian = 1;
      var set3 = regenerate$2.exports(4295, 4301, 11559, 11565);
      set3.addRange(4256, 4293).addRange(4304, 4346).addRange(4348, 4351).addRange(7312, 7354).addRange(7357, 7359).addRange(11520, 11557);
      Georgian.characters = set3;
      return Georgian;
    }
    var Glagolitic = {};
    var hasRequiredGlagolitic;
    function requireGlagolitic() {
      if (hasRequiredGlagolitic)
        return Glagolitic;
      hasRequiredGlagolitic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(11264, 11359).addRange(122880, 122886).addRange(122888, 122904).addRange(122907, 122913).addRange(122915, 122916).addRange(122918, 122922);
      Glagolitic.characters = set3;
      return Glagolitic;
    }
    var Gothic = {};
    var hasRequiredGothic;
    function requireGothic() {
      if (hasRequiredGothic)
        return Gothic;
      hasRequiredGothic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66352, 66378);
      Gothic.characters = set3;
      return Gothic;
    }
    var Grantha = {};
    var hasRequiredGrantha;
    function requireGrantha() {
      if (hasRequiredGrantha)
        return Grantha;
      hasRequiredGrantha = 1;
      var set3 = regenerate$2.exports(70480, 70487);
      set3.addRange(70400, 70403).addRange(70405, 70412).addRange(70415, 70416).addRange(70419, 70440).addRange(70442, 70448).addRange(70450, 70451).addRange(70453, 70457).addRange(70460, 70468).addRange(70471, 70472).addRange(70475, 70477).addRange(70493, 70499).addRange(70502, 70508).addRange(70512, 70516);
      Grantha.characters = set3;
      return Grantha;
    }
    var Greek = {};
    var hasRequiredGreek;
    function requireGreek() {
      if (hasRequiredGreek)
        return Greek;
      hasRequiredGreek = 1;
      var set3 = regenerate$2.exports(895, 900, 902, 908, 7615, 8025, 8027, 8029, 8486, 43877, 65952);
      set3.addRange(880, 883).addRange(885, 887).addRange(890, 893).addRange(904, 906).addRange(910, 929).addRange(931, 993).addRange(1008, 1023).addRange(7462, 7466).addRange(7517, 7521).addRange(7526, 7530).addRange(7936, 7957).addRange(7960, 7965).addRange(7968, 8005).addRange(8008, 8013).addRange(8016, 8023).addRange(8031, 8061).addRange(8064, 8116).addRange(8118, 8132).addRange(8134, 8147).addRange(8150, 8155).addRange(8157, 8175).addRange(8178, 8180).addRange(8182, 8190).addRange(65856, 65934).addRange(119296, 119365);
      Greek.characters = set3;
      return Greek;
    }
    var Gujarati = {};
    var hasRequiredGujarati;
    function requireGujarati() {
      if (hasRequiredGujarati)
        return Gujarati;
      hasRequiredGujarati = 1;
      var set3 = regenerate$2.exports(2768);
      set3.addRange(2689, 2691).addRange(2693, 2701).addRange(2703, 2705).addRange(2707, 2728).addRange(2730, 2736).addRange(2738, 2739).addRange(2741, 2745).addRange(2748, 2757).addRange(2759, 2761).addRange(2763, 2765).addRange(2784, 2787).addRange(2790, 2801).addRange(2809, 2815);
      Gujarati.characters = set3;
      return Gujarati;
    }
    var Gunjala_Gondi = {};
    var hasRequiredGunjala_Gondi;
    function requireGunjala_Gondi() {
      if (hasRequiredGunjala_Gondi)
        return Gunjala_Gondi;
      hasRequiredGunjala_Gondi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(73056, 73061).addRange(73063, 73064).addRange(73066, 73102).addRange(73104, 73105).addRange(73107, 73112).addRange(73120, 73129);
      Gunjala_Gondi.characters = set3;
      return Gunjala_Gondi;
    }
    var Gurmukhi = {};
    var hasRequiredGurmukhi;
    function requireGurmukhi() {
      if (hasRequiredGurmukhi)
        return Gurmukhi;
      hasRequiredGurmukhi = 1;
      var set3 = regenerate$2.exports(2620, 2641, 2654);
      set3.addRange(2561, 2563).addRange(2565, 2570).addRange(2575, 2576).addRange(2579, 2600).addRange(2602, 2608).addRange(2610, 2611).addRange(2613, 2614).addRange(2616, 2617).addRange(2622, 2626).addRange(2631, 2632).addRange(2635, 2637).addRange(2649, 2652).addRange(2662, 2678);
      Gurmukhi.characters = set3;
      return Gurmukhi;
    }
    var Han = {};
    var hasRequiredHan;
    function requireHan() {
      if (hasRequiredHan)
        return Han;
      hasRequiredHan = 1;
      var set3 = regenerate$2.exports(12293, 12295);
      set3.addRange(11904, 11929).addRange(11931, 12019).addRange(12032, 12245).addRange(12321, 12329).addRange(12344, 12347).addRange(13312, 19903).addRange(19968, 40959).addRange(63744, 64109).addRange(64112, 64217).addRange(94178, 94179).addRange(94192, 94193).addRange(131072, 173791).addRange(173824, 177976).addRange(177984, 178205).addRange(178208, 183969).addRange(183984, 191456).addRange(194560, 195101).addRange(196608, 201546);
      Han.characters = set3;
      return Han;
    }
    var Hangul = {};
    var hasRequiredHangul;
    function requireHangul() {
      if (hasRequiredHangul)
        return Hangul;
      hasRequiredHangul = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(4352, 4607).addRange(12334, 12335).addRange(12593, 12686).addRange(12800, 12830).addRange(12896, 12926).addRange(43360, 43388).addRange(44032, 55203).addRange(55216, 55238).addRange(55243, 55291).addRange(65440, 65470).addRange(65474, 65479).addRange(65482, 65487).addRange(65490, 65495).addRange(65498, 65500);
      Hangul.characters = set3;
      return Hangul;
    }
    var Hanifi_Rohingya = {};
    var hasRequiredHanifi_Rohingya;
    function requireHanifi_Rohingya() {
      if (hasRequiredHanifi_Rohingya)
        return Hanifi_Rohingya;
      hasRequiredHanifi_Rohingya = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68864, 68903).addRange(68912, 68921);
      Hanifi_Rohingya.characters = set3;
      return Hanifi_Rohingya;
    }
    var Hanunoo = {};
    var hasRequiredHanunoo;
    function requireHanunoo() {
      if (hasRequiredHanunoo)
        return Hanunoo;
      hasRequiredHanunoo = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5920, 5940);
      Hanunoo.characters = set3;
      return Hanunoo;
    }
    var Hatran = {};
    var hasRequiredHatran;
    function requireHatran() {
      if (hasRequiredHatran)
        return Hatran;
      hasRequiredHatran = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67808, 67826).addRange(67828, 67829).addRange(67835, 67839);
      Hatran.characters = set3;
      return Hatran;
    }
    var Hebrew = {};
    var hasRequiredHebrew;
    function requireHebrew() {
      if (hasRequiredHebrew)
        return Hebrew;
      hasRequiredHebrew = 1;
      var set3 = regenerate$2.exports(64318);
      set3.addRange(1425, 1479).addRange(1488, 1514).addRange(1519, 1524).addRange(64285, 64310).addRange(64312, 64316).addRange(64320, 64321).addRange(64323, 64324).addRange(64326, 64335);
      Hebrew.characters = set3;
      return Hebrew;
    }
    var Hiragana = {};
    var hasRequiredHiragana;
    function requireHiragana() {
      if (hasRequiredHiragana)
        return Hiragana;
      hasRequiredHiragana = 1;
      var set3 = regenerate$2.exports(127488);
      set3.addRange(12353, 12438).addRange(12445, 12447).addRange(110593, 110879).addRange(110928, 110930);
      Hiragana.characters = set3;
      return Hiragana;
    }
    var Imperial_Aramaic = {};
    var hasRequiredImperial_Aramaic;
    function requireImperial_Aramaic() {
      if (hasRequiredImperial_Aramaic)
        return Imperial_Aramaic;
      hasRequiredImperial_Aramaic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67648, 67669).addRange(67671, 67679);
      Imperial_Aramaic.characters = set3;
      return Imperial_Aramaic;
    }
    var Inherited = {};
    var hasRequiredInherited;
    function requireInherited() {
      if (hasRequiredInherited)
        return Inherited;
      hasRequiredInherited = 1;
      var set3 = regenerate$2.exports(1648, 7405, 7412, 66045, 66272, 70459);
      set3.addRange(768, 879).addRange(1157, 1158).addRange(1611, 1621).addRange(2385, 2388).addRange(6832, 6862).addRange(7376, 7378).addRange(7380, 7392).addRange(7394, 7400).addRange(7416, 7417).addRange(7616, 7679).addRange(8204, 8205).addRange(8400, 8432).addRange(12330, 12333).addRange(12441, 12442).addRange(65024, 65039).addRange(65056, 65069).addRange(118528, 118573).addRange(118576, 118598).addRange(119143, 119145).addRange(119163, 119170).addRange(119173, 119179).addRange(119210, 119213).addRange(917760, 917999);
      Inherited.characters = set3;
      return Inherited;
    }
    var Inscriptional_Pahlavi = {};
    var hasRequiredInscriptional_Pahlavi;
    function requireInscriptional_Pahlavi() {
      if (hasRequiredInscriptional_Pahlavi)
        return Inscriptional_Pahlavi;
      hasRequiredInscriptional_Pahlavi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68448, 68466).addRange(68472, 68479);
      Inscriptional_Pahlavi.characters = set3;
      return Inscriptional_Pahlavi;
    }
    var Inscriptional_Parthian = {};
    var hasRequiredInscriptional_Parthian;
    function requireInscriptional_Parthian() {
      if (hasRequiredInscriptional_Parthian)
        return Inscriptional_Parthian;
      hasRequiredInscriptional_Parthian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68416, 68437).addRange(68440, 68447);
      Inscriptional_Parthian.characters = set3;
      return Inscriptional_Parthian;
    }
    var Javanese = {};
    var hasRequiredJavanese;
    function requireJavanese() {
      if (hasRequiredJavanese)
        return Javanese;
      hasRequiredJavanese = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43392, 43469).addRange(43472, 43481).addRange(43486, 43487);
      Javanese.characters = set3;
      return Javanese;
    }
    var Kaithi = {};
    var hasRequiredKaithi;
    function requireKaithi() {
      if (hasRequiredKaithi)
        return Kaithi;
      hasRequiredKaithi = 1;
      var set3 = regenerate$2.exports(69837);
      set3.addRange(69760, 69826);
      Kaithi.characters = set3;
      return Kaithi;
    }
    var Kannada = {};
    var hasRequiredKannada;
    function requireKannada() {
      if (hasRequiredKannada)
        return Kannada;
      hasRequiredKannada = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3200, 3212).addRange(3214, 3216).addRange(3218, 3240).addRange(3242, 3251).addRange(3253, 3257).addRange(3260, 3268).addRange(3270, 3272).addRange(3274, 3277).addRange(3285, 3286).addRange(3293, 3294).addRange(3296, 3299).addRange(3302, 3311).addRange(3313, 3314);
      Kannada.characters = set3;
      return Kannada;
    }
    var Katakana = {};
    var hasRequiredKatakana;
    function requireKatakana() {
      if (hasRequiredKatakana)
        return Katakana;
      hasRequiredKatakana = 1;
      var set3 = regenerate$2.exports(110592);
      set3.addRange(12449, 12538).addRange(12541, 12543).addRange(12784, 12799).addRange(13008, 13054).addRange(13056, 13143).addRange(65382, 65391).addRange(65393, 65437).addRange(110576, 110579).addRange(110581, 110587).addRange(110589, 110590).addRange(110880, 110882).addRange(110948, 110951);
      Katakana.characters = set3;
      return Katakana;
    }
    var Kayah_Li = {};
    var hasRequiredKayah_Li;
    function requireKayah_Li() {
      if (hasRequiredKayah_Li)
        return Kayah_Li;
      hasRequiredKayah_Li = 1;
      var set3 = regenerate$2.exports(43311);
      set3.addRange(43264, 43309);
      Kayah_Li.characters = set3;
      return Kayah_Li;
    }
    var Kharoshthi = {};
    var hasRequiredKharoshthi;
    function requireKharoshthi() {
      if (hasRequiredKharoshthi)
        return Kharoshthi;
      hasRequiredKharoshthi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68096, 68099).addRange(68101, 68102).addRange(68108, 68115).addRange(68117, 68119).addRange(68121, 68149).addRange(68152, 68154).addRange(68159, 68168).addRange(68176, 68184);
      Kharoshthi.characters = set3;
      return Kharoshthi;
    }
    var Khitan_Small_Script = {};
    var hasRequiredKhitan_Small_Script;
    function requireKhitan_Small_Script() {
      if (hasRequiredKhitan_Small_Script)
        return Khitan_Small_Script;
      hasRequiredKhitan_Small_Script = 1;
      var set3 = regenerate$2.exports(94180);
      set3.addRange(101120, 101589);
      Khitan_Small_Script.characters = set3;
      return Khitan_Small_Script;
    }
    var Khmer = {};
    var hasRequiredKhmer;
    function requireKhmer() {
      if (hasRequiredKhmer)
        return Khmer;
      hasRequiredKhmer = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6016, 6109).addRange(6112, 6121).addRange(6128, 6137).addRange(6624, 6655);
      Khmer.characters = set3;
      return Khmer;
    }
    var Khojki = {};
    var hasRequiredKhojki;
    function requireKhojki() {
      if (hasRequiredKhojki)
        return Khojki;
      hasRequiredKhojki = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70144, 70161).addRange(70163, 70206);
      Khojki.characters = set3;
      return Khojki;
    }
    var Khudawadi = {};
    var hasRequiredKhudawadi;
    function requireKhudawadi() {
      if (hasRequiredKhudawadi)
        return Khudawadi;
      hasRequiredKhudawadi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70320, 70378).addRange(70384, 70393);
      Khudawadi.characters = set3;
      return Khudawadi;
    }
    var Lao = {};
    var hasRequiredLao;
    function requireLao() {
      if (hasRequiredLao)
        return Lao;
      hasRequiredLao = 1;
      var set3 = regenerate$2.exports(3716, 3749, 3782);
      set3.addRange(3713, 3714).addRange(3718, 3722).addRange(3724, 3747).addRange(3751, 3773).addRange(3776, 3780).addRange(3784, 3789).addRange(3792, 3801).addRange(3804, 3807);
      Lao.characters = set3;
      return Lao;
    }
    var Latin = {};
    var hasRequiredLatin;
    function requireLatin() {
      if (hasRequiredLatin)
        return Latin;
      hasRequiredLatin = 1;
      var set3 = regenerate$2.exports(170, 186, 8305, 8319, 8498, 8526, 42963);
      set3.addRange(65, 90).addRange(97, 122).addRange(192, 214).addRange(216, 246).addRange(248, 696).addRange(736, 740).addRange(7424, 7461).addRange(7468, 7516).addRange(7522, 7525).addRange(7531, 7543).addRange(7545, 7614).addRange(7680, 7935).addRange(8336, 8348).addRange(8490, 8491).addRange(8544, 8584).addRange(11360, 11391).addRange(42786, 42887).addRange(42891, 42954).addRange(42960, 42961).addRange(42965, 42969).addRange(42994, 43007).addRange(43824, 43866).addRange(43868, 43876).addRange(43878, 43881).addRange(64256, 64262).addRange(65313, 65338).addRange(65345, 65370).addRange(67456, 67461).addRange(67463, 67504).addRange(67506, 67514).addRange(122624, 122654);
      Latin.characters = set3;
      return Latin;
    }
    var Lepcha = {};
    var hasRequiredLepcha;
    function requireLepcha() {
      if (hasRequiredLepcha)
        return Lepcha;
      hasRequiredLepcha = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7168, 7223).addRange(7227, 7241).addRange(7245, 7247);
      Lepcha.characters = set3;
      return Lepcha;
    }
    var Limbu = {};
    var hasRequiredLimbu;
    function requireLimbu() {
      if (hasRequiredLimbu)
        return Limbu;
      hasRequiredLimbu = 1;
      var set3 = regenerate$2.exports(6464);
      set3.addRange(6400, 6430).addRange(6432, 6443).addRange(6448, 6459).addRange(6468, 6479);
      Limbu.characters = set3;
      return Limbu;
    }
    var Linear_A = {};
    var hasRequiredLinear_A;
    function requireLinear_A() {
      if (hasRequiredLinear_A)
        return Linear_A;
      hasRequiredLinear_A = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67072, 67382).addRange(67392, 67413).addRange(67424, 67431);
      Linear_A.characters = set3;
      return Linear_A;
    }
    var Linear_B = {};
    var hasRequiredLinear_B;
    function requireLinear_B() {
      if (hasRequiredLinear_B)
        return Linear_B;
      hasRequiredLinear_B = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(65536, 65547).addRange(65549, 65574).addRange(65576, 65594).addRange(65596, 65597).addRange(65599, 65613).addRange(65616, 65629).addRange(65664, 65786);
      Linear_B.characters = set3;
      return Linear_B;
    }
    var Lisu = {};
    var hasRequiredLisu;
    function requireLisu() {
      if (hasRequiredLisu)
        return Lisu;
      hasRequiredLisu = 1;
      var set3 = regenerate$2.exports(73648);
      set3.addRange(42192, 42239);
      Lisu.characters = set3;
      return Lisu;
    }
    var Lycian = {};
    var hasRequiredLycian;
    function requireLycian() {
      if (hasRequiredLycian)
        return Lycian;
      hasRequiredLycian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66176, 66204);
      Lycian.characters = set3;
      return Lycian;
    }
    var Lydian = {};
    var hasRequiredLydian;
    function requireLydian() {
      if (hasRequiredLydian)
        return Lydian;
      hasRequiredLydian = 1;
      var set3 = regenerate$2.exports(67903);
      set3.addRange(67872, 67897);
      Lydian.characters = set3;
      return Lydian;
    }
    var Mahajani = {};
    var hasRequiredMahajani;
    function requireMahajani() {
      if (hasRequiredMahajani)
        return Mahajani;
      hasRequiredMahajani = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69968, 70006);
      Mahajani.characters = set3;
      return Mahajani;
    }
    var Makasar = {};
    var hasRequiredMakasar;
    function requireMakasar() {
      if (hasRequiredMakasar)
        return Makasar;
      hasRequiredMakasar = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(73440, 73464);
      Makasar.characters = set3;
      return Makasar;
    }
    var Malayalam = {};
    var hasRequiredMalayalam;
    function requireMalayalam() {
      if (hasRequiredMalayalam)
        return Malayalam;
      hasRequiredMalayalam = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3328, 3340).addRange(3342, 3344).addRange(3346, 3396).addRange(3398, 3400).addRange(3402, 3407).addRange(3412, 3427).addRange(3430, 3455);
      Malayalam.characters = set3;
      return Malayalam;
    }
    var Mandaic = {};
    var hasRequiredMandaic;
    function requireMandaic() {
      if (hasRequiredMandaic)
        return Mandaic;
      hasRequiredMandaic = 1;
      var set3 = regenerate$2.exports(2142);
      set3.addRange(2112, 2139);
      Mandaic.characters = set3;
      return Mandaic;
    }
    var Manichaean = {};
    var hasRequiredManichaean;
    function requireManichaean() {
      if (hasRequiredManichaean)
        return Manichaean;
      hasRequiredManichaean = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68288, 68326).addRange(68331, 68342);
      Manichaean.characters = set3;
      return Manichaean;
    }
    var Marchen = {};
    var hasRequiredMarchen;
    function requireMarchen() {
      if (hasRequiredMarchen)
        return Marchen;
      hasRequiredMarchen = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72816, 72847).addRange(72850, 72871).addRange(72873, 72886);
      Marchen.characters = set3;
      return Marchen;
    }
    var Masaram_Gondi = {};
    var hasRequiredMasaram_Gondi;
    function requireMasaram_Gondi() {
      if (hasRequiredMasaram_Gondi)
        return Masaram_Gondi;
      hasRequiredMasaram_Gondi = 1;
      var set3 = regenerate$2.exports(73018);
      set3.addRange(72960, 72966).addRange(72968, 72969).addRange(72971, 73014).addRange(73020, 73021).addRange(73023, 73031).addRange(73040, 73049);
      Masaram_Gondi.characters = set3;
      return Masaram_Gondi;
    }
    var Medefaidrin = {};
    var hasRequiredMedefaidrin;
    function requireMedefaidrin() {
      if (hasRequiredMedefaidrin)
        return Medefaidrin;
      hasRequiredMedefaidrin = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(93760, 93850);
      Medefaidrin.characters = set3;
      return Medefaidrin;
    }
    var Meetei_Mayek = {};
    var hasRequiredMeetei_Mayek;
    function requireMeetei_Mayek() {
      if (hasRequiredMeetei_Mayek)
        return Meetei_Mayek;
      hasRequiredMeetei_Mayek = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43744, 43766).addRange(43968, 44013).addRange(44016, 44025);
      Meetei_Mayek.characters = set3;
      return Meetei_Mayek;
    }
    var Mende_Kikakui = {};
    var hasRequiredMende_Kikakui;
    function requireMende_Kikakui() {
      if (hasRequiredMende_Kikakui)
        return Mende_Kikakui;
      hasRequiredMende_Kikakui = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(124928, 125124).addRange(125127, 125142);
      Mende_Kikakui.characters = set3;
      return Mende_Kikakui;
    }
    var Meroitic_Cursive = {};
    var hasRequiredMeroitic_Cursive;
    function requireMeroitic_Cursive() {
      if (hasRequiredMeroitic_Cursive)
        return Meroitic_Cursive;
      hasRequiredMeroitic_Cursive = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68e3, 68023).addRange(68028, 68047).addRange(68050, 68095);
      Meroitic_Cursive.characters = set3;
      return Meroitic_Cursive;
    }
    var Meroitic_Hieroglyphs = {};
    var hasRequiredMeroitic_Hieroglyphs;
    function requireMeroitic_Hieroglyphs() {
      if (hasRequiredMeroitic_Hieroglyphs)
        return Meroitic_Hieroglyphs;
      hasRequiredMeroitic_Hieroglyphs = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67968, 67999);
      Meroitic_Hieroglyphs.characters = set3;
      return Meroitic_Hieroglyphs;
    }
    var Miao = {};
    var hasRequiredMiao;
    function requireMiao() {
      if (hasRequiredMiao)
        return Miao;
      hasRequiredMiao = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(93952, 94026).addRange(94031, 94087).addRange(94095, 94111);
      Miao.characters = set3;
      return Miao;
    }
    var Modi = {};
    var hasRequiredModi;
    function requireModi() {
      if (hasRequiredModi)
        return Modi;
      hasRequiredModi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71168, 71236).addRange(71248, 71257);
      Modi.characters = set3;
      return Modi;
    }
    var Mongolian = {};
    var hasRequiredMongolian;
    function requireMongolian() {
      if (hasRequiredMongolian)
        return Mongolian;
      hasRequiredMongolian = 1;
      var set3 = regenerate$2.exports(6148);
      set3.addRange(6144, 6145).addRange(6150, 6169).addRange(6176, 6264).addRange(6272, 6314).addRange(71264, 71276);
      Mongolian.characters = set3;
      return Mongolian;
    }
    var Mro = {};
    var hasRequiredMro;
    function requireMro() {
      if (hasRequiredMro)
        return Mro;
      hasRequiredMro = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92736, 92766).addRange(92768, 92777).addRange(92782, 92783);
      Mro.characters = set3;
      return Mro;
    }
    var Multani = {};
    var hasRequiredMultani;
    function requireMultani() {
      if (hasRequiredMultani)
        return Multani;
      hasRequiredMultani = 1;
      var set3 = regenerate$2.exports(70280);
      set3.addRange(70272, 70278).addRange(70282, 70285).addRange(70287, 70301).addRange(70303, 70313);
      Multani.characters = set3;
      return Multani;
    }
    var Myanmar = {};
    var hasRequiredMyanmar;
    function requireMyanmar() {
      if (hasRequiredMyanmar)
        return Myanmar;
      hasRequiredMyanmar = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(4096, 4255).addRange(43488, 43518).addRange(43616, 43647);
      Myanmar.characters = set3;
      return Myanmar;
    }
    var Nabataean = {};
    var hasRequiredNabataean;
    function requireNabataean() {
      if (hasRequiredNabataean)
        return Nabataean;
      hasRequiredNabataean = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67712, 67742).addRange(67751, 67759);
      Nabataean.characters = set3;
      return Nabataean;
    }
    var Nandinagari = {};
    var hasRequiredNandinagari;
    function requireNandinagari() {
      if (hasRequiredNandinagari)
        return Nandinagari;
      hasRequiredNandinagari = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72096, 72103).addRange(72106, 72151).addRange(72154, 72164);
      Nandinagari.characters = set3;
      return Nandinagari;
    }
    var New_Tai_Lue = {};
    var hasRequiredNew_Tai_Lue;
    function requireNew_Tai_Lue() {
      if (hasRequiredNew_Tai_Lue)
        return New_Tai_Lue;
      hasRequiredNew_Tai_Lue = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6528, 6571).addRange(6576, 6601).addRange(6608, 6618).addRange(6622, 6623);
      New_Tai_Lue.characters = set3;
      return New_Tai_Lue;
    }
    var Newa = {};
    var hasRequiredNewa;
    function requireNewa() {
      if (hasRequiredNewa)
        return Newa;
      hasRequiredNewa = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70656, 70747).addRange(70749, 70753);
      Newa.characters = set3;
      return Newa;
    }
    var Nko = {};
    var hasRequiredNko;
    function requireNko() {
      if (hasRequiredNko)
        return Nko;
      hasRequiredNko = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(1984, 2042).addRange(2045, 2047);
      Nko.characters = set3;
      return Nko;
    }
    var Nushu = {};
    var hasRequiredNushu;
    function requireNushu() {
      if (hasRequiredNushu)
        return Nushu;
      hasRequiredNushu = 1;
      var set3 = regenerate$2.exports(94177);
      set3.addRange(110960, 111355);
      Nushu.characters = set3;
      return Nushu;
    }
    var Nyiakeng_Puachue_Hmong = {};
    var hasRequiredNyiakeng_Puachue_Hmong;
    function requireNyiakeng_Puachue_Hmong() {
      if (hasRequiredNyiakeng_Puachue_Hmong)
        return Nyiakeng_Puachue_Hmong;
      hasRequiredNyiakeng_Puachue_Hmong = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(123136, 123180).addRange(123184, 123197).addRange(123200, 123209).addRange(123214, 123215);
      Nyiakeng_Puachue_Hmong.characters = set3;
      return Nyiakeng_Puachue_Hmong;
    }
    var Ogham = {};
    var hasRequiredOgham;
    function requireOgham() {
      if (hasRequiredOgham)
        return Ogham;
      hasRequiredOgham = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5760, 5788);
      Ogham.characters = set3;
      return Ogham;
    }
    var Ol_Chiki = {};
    var hasRequiredOl_Chiki;
    function requireOl_Chiki() {
      if (hasRequiredOl_Chiki)
        return Ol_Chiki;
      hasRequiredOl_Chiki = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7248, 7295);
      Ol_Chiki.characters = set3;
      return Ol_Chiki;
    }
    var Old_Hungarian = {};
    var hasRequiredOld_Hungarian;
    function requireOld_Hungarian() {
      if (hasRequiredOld_Hungarian)
        return Old_Hungarian;
      hasRequiredOld_Hungarian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68736, 68786).addRange(68800, 68850).addRange(68858, 68863);
      Old_Hungarian.characters = set3;
      return Old_Hungarian;
    }
    var Old_Italic = {};
    var hasRequiredOld_Italic;
    function requireOld_Italic() {
      if (hasRequiredOld_Italic)
        return Old_Italic;
      hasRequiredOld_Italic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66304, 66339).addRange(66349, 66351);
      Old_Italic.characters = set3;
      return Old_Italic;
    }
    var Old_North_Arabian = {};
    var hasRequiredOld_North_Arabian;
    function requireOld_North_Arabian() {
      if (hasRequiredOld_North_Arabian)
        return Old_North_Arabian;
      hasRequiredOld_North_Arabian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68224, 68255);
      Old_North_Arabian.characters = set3;
      return Old_North_Arabian;
    }
    var Old_Permic = {};
    var hasRequiredOld_Permic;
    function requireOld_Permic() {
      if (hasRequiredOld_Permic)
        return Old_Permic;
      hasRequiredOld_Permic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66384, 66426);
      Old_Permic.characters = set3;
      return Old_Permic;
    }
    var Old_Persian = {};
    var hasRequiredOld_Persian;
    function requireOld_Persian() {
      if (hasRequiredOld_Persian)
        return Old_Persian;
      hasRequiredOld_Persian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66464, 66499).addRange(66504, 66517);
      Old_Persian.characters = set3;
      return Old_Persian;
    }
    var Old_Sogdian = {};
    var hasRequiredOld_Sogdian;
    function requireOld_Sogdian() {
      if (hasRequiredOld_Sogdian)
        return Old_Sogdian;
      hasRequiredOld_Sogdian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69376, 69415);
      Old_Sogdian.characters = set3;
      return Old_Sogdian;
    }
    var Old_South_Arabian = {};
    var hasRequiredOld_South_Arabian;
    function requireOld_South_Arabian() {
      if (hasRequiredOld_South_Arabian)
        return Old_South_Arabian;
      hasRequiredOld_South_Arabian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68192, 68223);
      Old_South_Arabian.characters = set3;
      return Old_South_Arabian;
    }
    var Old_Turkic = {};
    var hasRequiredOld_Turkic;
    function requireOld_Turkic() {
      if (hasRequiredOld_Turkic)
        return Old_Turkic;
      hasRequiredOld_Turkic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68608, 68680);
      Old_Turkic.characters = set3;
      return Old_Turkic;
    }
    var Old_Uyghur = {};
    var hasRequiredOld_Uyghur;
    function requireOld_Uyghur() {
      if (hasRequiredOld_Uyghur)
        return Old_Uyghur;
      hasRequiredOld_Uyghur = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69488, 69513);
      Old_Uyghur.characters = set3;
      return Old_Uyghur;
    }
    var Oriya = {};
    var hasRequiredOriya;
    function requireOriya() {
      if (hasRequiredOriya)
        return Oriya;
      hasRequiredOriya = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2817, 2819).addRange(2821, 2828).addRange(2831, 2832).addRange(2835, 2856).addRange(2858, 2864).addRange(2866, 2867).addRange(2869, 2873).addRange(2876, 2884).addRange(2887, 2888).addRange(2891, 2893).addRange(2901, 2903).addRange(2908, 2909).addRange(2911, 2915).addRange(2918, 2935);
      Oriya.characters = set3;
      return Oriya;
    }
    var Osage = {};
    var hasRequiredOsage;
    function requireOsage() {
      if (hasRequiredOsage)
        return Osage;
      hasRequiredOsage = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66736, 66771).addRange(66776, 66811);
      Osage.characters = set3;
      return Osage;
    }
    var Osmanya = {};
    var hasRequiredOsmanya;
    function requireOsmanya() {
      if (hasRequiredOsmanya)
        return Osmanya;
      hasRequiredOsmanya = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66688, 66717).addRange(66720, 66729);
      Osmanya.characters = set3;
      return Osmanya;
    }
    var Pahawh_Hmong = {};
    var hasRequiredPahawh_Hmong;
    function requirePahawh_Hmong() {
      if (hasRequiredPahawh_Hmong)
        return Pahawh_Hmong;
      hasRequiredPahawh_Hmong = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92928, 92997).addRange(93008, 93017).addRange(93019, 93025).addRange(93027, 93047).addRange(93053, 93071);
      Pahawh_Hmong.characters = set3;
      return Pahawh_Hmong;
    }
    var Palmyrene = {};
    var hasRequiredPalmyrene;
    function requirePalmyrene() {
      if (hasRequiredPalmyrene)
        return Palmyrene;
      hasRequiredPalmyrene = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(67680, 67711);
      Palmyrene.characters = set3;
      return Palmyrene;
    }
    var Pau_Cin_Hau = {};
    var hasRequiredPau_Cin_Hau;
    function requirePau_Cin_Hau() {
      if (hasRequiredPau_Cin_Hau)
        return Pau_Cin_Hau;
      hasRequiredPau_Cin_Hau = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72384, 72440);
      Pau_Cin_Hau.characters = set3;
      return Pau_Cin_Hau;
    }
    var Phags_Pa = {};
    var hasRequiredPhags_Pa;
    function requirePhags_Pa() {
      if (hasRequiredPhags_Pa)
        return Phags_Pa;
      hasRequiredPhags_Pa = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43072, 43127);
      Phags_Pa.characters = set3;
      return Phags_Pa;
    }
    var Phoenician = {};
    var hasRequiredPhoenician;
    function requirePhoenician() {
      if (hasRequiredPhoenician)
        return Phoenician;
      hasRequiredPhoenician = 1;
      var set3 = regenerate$2.exports(67871);
      set3.addRange(67840, 67867);
      Phoenician.characters = set3;
      return Phoenician;
    }
    var Psalter_Pahlavi = {};
    var hasRequiredPsalter_Pahlavi;
    function requirePsalter_Pahlavi() {
      if (hasRequiredPsalter_Pahlavi)
        return Psalter_Pahlavi;
      hasRequiredPsalter_Pahlavi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(68480, 68497).addRange(68505, 68508).addRange(68521, 68527);
      Psalter_Pahlavi.characters = set3;
      return Psalter_Pahlavi;
    }
    var Rejang = {};
    var hasRequiredRejang;
    function requireRejang() {
      if (hasRequiredRejang)
        return Rejang;
      hasRequiredRejang = 1;
      var set3 = regenerate$2.exports(43359);
      set3.addRange(43312, 43347);
      Rejang.characters = set3;
      return Rejang;
    }
    var Runic = {};
    var hasRequiredRunic;
    function requireRunic() {
      if (hasRequiredRunic)
        return Runic;
      hasRequiredRunic = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5792, 5866).addRange(5870, 5880);
      Runic.characters = set3;
      return Runic;
    }
    var Samaritan = {};
    var hasRequiredSamaritan;
    function requireSamaritan() {
      if (hasRequiredSamaritan)
        return Samaritan;
      hasRequiredSamaritan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(2048, 2093).addRange(2096, 2110);
      Samaritan.characters = set3;
      return Samaritan;
    }
    var Saurashtra = {};
    var hasRequiredSaurashtra;
    function requireSaurashtra() {
      if (hasRequiredSaurashtra)
        return Saurashtra;
      hasRequiredSaurashtra = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43136, 43205).addRange(43214, 43225);
      Saurashtra.characters = set3;
      return Saurashtra;
    }
    var Sharada = {};
    var hasRequiredSharada;
    function requireSharada() {
      if (hasRequiredSharada)
        return Sharada;
      hasRequiredSharada = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70016, 70111);
      Sharada.characters = set3;
      return Sharada;
    }
    var Shavian = {};
    var hasRequiredShavian;
    function requireShavian() {
      if (hasRequiredShavian)
        return Shavian;
      hasRequiredShavian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66640, 66687);
      Shavian.characters = set3;
      return Shavian;
    }
    var Siddham = {};
    var hasRequiredSiddham;
    function requireSiddham() {
      if (hasRequiredSiddham)
        return Siddham;
      hasRequiredSiddham = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71040, 71093).addRange(71096, 71133);
      Siddham.characters = set3;
      return Siddham;
    }
    var SignWriting = {};
    var hasRequiredSignWriting;
    function requireSignWriting() {
      if (hasRequiredSignWriting)
        return SignWriting;
      hasRequiredSignWriting = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(120832, 121483).addRange(121499, 121503).addRange(121505, 121519);
      SignWriting.characters = set3;
      return SignWriting;
    }
    var Sinhala = {};
    var hasRequiredSinhala;
    function requireSinhala() {
      if (hasRequiredSinhala)
        return Sinhala;
      hasRequiredSinhala = 1;
      var set3 = regenerate$2.exports(3517, 3530, 3542);
      set3.addRange(3457, 3459).addRange(3461, 3478).addRange(3482, 3505).addRange(3507, 3515).addRange(3520, 3526).addRange(3535, 3540).addRange(3544, 3551).addRange(3558, 3567).addRange(3570, 3572).addRange(70113, 70132);
      Sinhala.characters = set3;
      return Sinhala;
    }
    var Sogdian = {};
    var hasRequiredSogdian;
    function requireSogdian() {
      if (hasRequiredSogdian)
        return Sogdian;
      hasRequiredSogdian = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69424, 69465);
      Sogdian.characters = set3;
      return Sogdian;
    }
    var Sora_Sompeng = {};
    var hasRequiredSora_Sompeng;
    function requireSora_Sompeng() {
      if (hasRequiredSora_Sompeng)
        return Sora_Sompeng;
      hasRequiredSora_Sompeng = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69840, 69864).addRange(69872, 69881);
      Sora_Sompeng.characters = set3;
      return Sora_Sompeng;
    }
    var Soyombo = {};
    var hasRequiredSoyombo;
    function requireSoyombo() {
      if (hasRequiredSoyombo)
        return Soyombo;
      hasRequiredSoyombo = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72272, 72354);
      Soyombo.characters = set3;
      return Soyombo;
    }
    var Sundanese = {};
    var hasRequiredSundanese;
    function requireSundanese() {
      if (hasRequiredSundanese)
        return Sundanese;
      hasRequiredSundanese = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(7040, 7103).addRange(7360, 7367);
      Sundanese.characters = set3;
      return Sundanese;
    }
    var Syloti_Nagri = {};
    var hasRequiredSyloti_Nagri;
    function requireSyloti_Nagri() {
      if (hasRequiredSyloti_Nagri)
        return Syloti_Nagri;
      hasRequiredSyloti_Nagri = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43008, 43052);
      Syloti_Nagri.characters = set3;
      return Syloti_Nagri;
    }
    var Syriac = {};
    var hasRequiredSyriac;
    function requireSyriac() {
      if (hasRequiredSyriac)
        return Syriac;
      hasRequiredSyriac = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(1792, 1805).addRange(1807, 1866).addRange(1869, 1871).addRange(2144, 2154);
      Syriac.characters = set3;
      return Syriac;
    }
    var Tagalog = {};
    var hasRequiredTagalog;
    function requireTagalog() {
      if (hasRequiredTagalog)
        return Tagalog;
      hasRequiredTagalog = 1;
      var set3 = regenerate$2.exports(5919);
      set3.addRange(5888, 5909);
      Tagalog.characters = set3;
      return Tagalog;
    }
    var Tagbanwa = {};
    var hasRequiredTagbanwa;
    function requireTagbanwa() {
      if (hasRequiredTagbanwa)
        return Tagbanwa;
      hasRequiredTagbanwa = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(5984, 5996).addRange(5998, 6e3).addRange(6002, 6003);
      Tagbanwa.characters = set3;
      return Tagbanwa;
    }
    var Tai_Le = {};
    var hasRequiredTai_Le;
    function requireTai_Le() {
      if (hasRequiredTai_Le)
        return Tai_Le;
      hasRequiredTai_Le = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6480, 6509).addRange(6512, 6516);
      Tai_Le.characters = set3;
      return Tai_Le;
    }
    var Tai_Tham = {};
    var hasRequiredTai_Tham;
    function requireTai_Tham() {
      if (hasRequiredTai_Tham)
        return Tai_Tham;
      hasRequiredTai_Tham = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(6688, 6750).addRange(6752, 6780).addRange(6783, 6793).addRange(6800, 6809).addRange(6816, 6829);
      Tai_Tham.characters = set3;
      return Tai_Tham;
    }
    var Tai_Viet = {};
    var hasRequiredTai_Viet;
    function requireTai_Viet() {
      if (hasRequiredTai_Viet)
        return Tai_Viet;
      hasRequiredTai_Viet = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(43648, 43714).addRange(43739, 43743);
      Tai_Viet.characters = set3;
      return Tai_Viet;
    }
    var Takri = {};
    var hasRequiredTakri;
    function requireTakri() {
      if (hasRequiredTakri)
        return Takri;
      hasRequiredTakri = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(71296, 71353).addRange(71360, 71369);
      Takri.characters = set3;
      return Takri;
    }
    var Tamil = {};
    var hasRequiredTamil;
    function requireTamil() {
      if (hasRequiredTamil)
        return Tamil;
      hasRequiredTamil = 1;
      var set3 = regenerate$2.exports(2972, 3024, 3031, 73727);
      set3.addRange(2946, 2947).addRange(2949, 2954).addRange(2958, 2960).addRange(2962, 2965).addRange(2969, 2970).addRange(2974, 2975).addRange(2979, 2980).addRange(2984, 2986).addRange(2990, 3001).addRange(3006, 3010).addRange(3014, 3016).addRange(3018, 3021).addRange(3046, 3066).addRange(73664, 73713);
      Tamil.characters = set3;
      return Tamil;
    }
    var Tangsa = {};
    var hasRequiredTangsa;
    function requireTangsa() {
      if (hasRequiredTangsa)
        return Tangsa;
      hasRequiredTangsa = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(92784, 92862).addRange(92864, 92873);
      Tangsa.characters = set3;
      return Tangsa;
    }
    var Tangut = {};
    var hasRequiredTangut;
    function requireTangut() {
      if (hasRequiredTangut)
        return Tangut;
      hasRequiredTangut = 1;
      var set3 = regenerate$2.exports(94176);
      set3.addRange(94208, 100343).addRange(100352, 101119).addRange(101632, 101640);
      Tangut.characters = set3;
      return Tangut;
    }
    var Telugu = {};
    var hasRequiredTelugu;
    function requireTelugu() {
      if (hasRequiredTelugu)
        return Telugu;
      hasRequiredTelugu = 1;
      var set3 = regenerate$2.exports(3165);
      set3.addRange(3072, 3084).addRange(3086, 3088).addRange(3090, 3112).addRange(3114, 3129).addRange(3132, 3140).addRange(3142, 3144).addRange(3146, 3149).addRange(3157, 3158).addRange(3160, 3162).addRange(3168, 3171).addRange(3174, 3183).addRange(3191, 3199);
      Telugu.characters = set3;
      return Telugu;
    }
    var Thaana = {};
    var hasRequiredThaana;
    function requireThaana() {
      if (hasRequiredThaana)
        return Thaana;
      hasRequiredThaana = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(1920, 1969);
      Thaana.characters = set3;
      return Thaana;
    }
    var Thai = {};
    var hasRequiredThai;
    function requireThai() {
      if (hasRequiredThai)
        return Thai;
      hasRequiredThai = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3585, 3642).addRange(3648, 3675);
      Thai.characters = set3;
      return Thai;
    }
    var Tibetan = {};
    var hasRequiredTibetan;
    function requireTibetan() {
      if (hasRequiredTibetan)
        return Tibetan;
      hasRequiredTibetan = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(3840, 3911).addRange(3913, 3948).addRange(3953, 3991).addRange(3993, 4028).addRange(4030, 4044).addRange(4046, 4052).addRange(4057, 4058);
      Tibetan.characters = set3;
      return Tibetan;
    }
    var Tifinagh = {};
    var hasRequiredTifinagh;
    function requireTifinagh() {
      if (hasRequiredTifinagh)
        return Tifinagh;
      hasRequiredTifinagh = 1;
      var set3 = regenerate$2.exports(11647);
      set3.addRange(11568, 11623).addRange(11631, 11632);
      Tifinagh.characters = set3;
      return Tifinagh;
    }
    var Tirhuta = {};
    var hasRequiredTirhuta;
    function requireTirhuta() {
      if (hasRequiredTirhuta)
        return Tirhuta;
      hasRequiredTirhuta = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(70784, 70855).addRange(70864, 70873);
      Tirhuta.characters = set3;
      return Tirhuta;
    }
    var Toto = {};
    var hasRequiredToto;
    function requireToto() {
      if (hasRequiredToto)
        return Toto;
      hasRequiredToto = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(123536, 123566);
      Toto.characters = set3;
      return Toto;
    }
    var Ugaritic = {};
    var hasRequiredUgaritic;
    function requireUgaritic() {
      if (hasRequiredUgaritic)
        return Ugaritic;
      hasRequiredUgaritic = 1;
      var set3 = regenerate$2.exports(66463);
      set3.addRange(66432, 66461);
      Ugaritic.characters = set3;
      return Ugaritic;
    }
    var Vai = {};
    var hasRequiredVai;
    function requireVai() {
      if (hasRequiredVai)
        return Vai;
      hasRequiredVai = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(42240, 42539);
      Vai.characters = set3;
      return Vai;
    }
    var Vithkuqi = {};
    var hasRequiredVithkuqi;
    function requireVithkuqi() {
      if (hasRequiredVithkuqi)
        return Vithkuqi;
      hasRequiredVithkuqi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(66928, 66938).addRange(66940, 66954).addRange(66956, 66962).addRange(66964, 66965).addRange(66967, 66977).addRange(66979, 66993).addRange(66995, 67001).addRange(67003, 67004);
      Vithkuqi.characters = set3;
      return Vithkuqi;
    }
    var Wancho = {};
    var hasRequiredWancho;
    function requireWancho() {
      if (hasRequiredWancho)
        return Wancho;
      hasRequiredWancho = 1;
      var set3 = regenerate$2.exports(123647);
      set3.addRange(123584, 123641);
      Wancho.characters = set3;
      return Wancho;
    }
    var Warang_Citi = {};
    var hasRequiredWarang_Citi;
    function requireWarang_Citi() {
      if (hasRequiredWarang_Citi)
        return Warang_Citi;
      hasRequiredWarang_Citi = 1;
      var set3 = regenerate$2.exports(71935);
      set3.addRange(71840, 71922);
      Warang_Citi.characters = set3;
      return Warang_Citi;
    }
    var Yezidi = {};
    var hasRequiredYezidi;
    function requireYezidi() {
      if (hasRequiredYezidi)
        return Yezidi;
      hasRequiredYezidi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(69248, 69289).addRange(69291, 69293).addRange(69296, 69297);
      Yezidi.characters = set3;
      return Yezidi;
    }
    var Yi2 = {};
    var hasRequiredYi;
    function requireYi() {
      if (hasRequiredYi)
        return Yi2;
      hasRequiredYi = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(40960, 42124).addRange(42128, 42182);
      Yi2.characters = set3;
      return Yi2;
    }
    var Zanabazar_Square = {};
    var hasRequiredZanabazar_Square;
    function requireZanabazar_Square() {
      if (hasRequiredZanabazar_Square)
        return Zanabazar_Square;
      hasRequiredZanabazar_Square = 1;
      var set3 = regenerate$2.exports();
      set3.addRange(72192, 72263);
      Zanabazar_Square.characters = set3;
      return Zanabazar_Square;
    }
    var unicodeVersion;
    var hasRequiredUnicodeVersion;
    function requireUnicodeVersion() {
      if (hasRequiredUnicodeVersion)
        return unicodeVersion;
      hasRequiredUnicodeVersion = 1;
      unicodeVersion = "14.0.0";
      return unicodeVersion;
    }
    var dynamicModules;
    function getDynamicModules() {
      return dynamicModules || (dynamicModules = {
        "/node_modules/regenerate-unicode-properties/Binary_Property/Alphabetic.js": requireAlphabetic,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Any.js": requireAny,
        "/node_modules/regenerate-unicode-properties/Binary_Property/ASCII_Hex_Digit.js": requireASCII_Hex_Digit,
        "/node_modules/regenerate-unicode-properties/Binary_Property/ASCII.js": requireASCII,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Assigned.js": requireAssigned,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Control.js": requireBidi_Control,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Mirrored.js": requireBidi_Mirrored,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Case_Ignorable.js": requireCase_Ignorable,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Cased.js": requireCased,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casefolded.js": requireChanges_When_Casefolded,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casemapped.js": requireChanges_When_Casemapped,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Lowercased.js": requireChanges_When_Lowercased,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_NFKC_Casefolded.js": requireChanges_When_NFKC_Casefolded,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Titlecased.js": requireChanges_When_Titlecased,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Uppercased.js": requireChanges_When_Uppercased,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Dash.js": requireDash,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Default_Ignorable_Code_Point.js": requireDefault_Ignorable_Code_Point,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Deprecated.js": requireDeprecated,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Diacritic.js": requireDiacritic,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Component.js": requireEmoji_Component,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier_Base.js": requireEmoji_Modifier_Base,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier.js": requireEmoji_Modifier,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Presentation.js": requireEmoji_Presentation,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Emoji.js": requireEmoji,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Extended_Pictographic.js": requireExtended_Pictographic,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Extender.js": requireExtender,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Base.js": requireGrapheme_Base,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Extend.js": requireGrapheme_Extend,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Hex_Digit.js": requireHex_Digit,
        "/node_modules/regenerate-unicode-properties/Binary_Property/ID_Continue.js": requireID_Continue,
        "/node_modules/regenerate-unicode-properties/Binary_Property/ID_Start.js": requireID_Start,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Ideographic.js": requireIdeographic,
        "/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Binary_Operator.js": requireIDS_Binary_Operator,
        "/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Trinary_Operator.js": requireIDS_Trinary_Operator,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Join_Control.js": requireJoin_Control,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Logical_Order_Exception.js": requireLogical_Order_Exception,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Lowercase.js": requireLowercase,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Math.js": require_Math,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Noncharacter_Code_Point.js": requireNoncharacter_Code_Point,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_Syntax.js": requirePattern_Syntax,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_White_Space.js": requirePattern_White_Space,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Quotation_Mark.js": requireQuotation_Mark,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Radical.js": requireRadical,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Regional_Indicator.js": requireRegional_Indicator,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Sentence_Terminal.js": requireSentence_Terminal,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Soft_Dotted.js": requireSoft_Dotted,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Terminal_Punctuation.js": requireTerminal_Punctuation,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Unified_Ideograph.js": requireUnified_Ideograph,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Uppercase.js": requireUppercase,
        "/node_modules/regenerate-unicode-properties/Binary_Property/Variation_Selector.js": requireVariation_Selector,
        "/node_modules/regenerate-unicode-properties/Binary_Property/White_Space.js": requireWhite_Space,
        "/node_modules/regenerate-unicode-properties/Binary_Property/XID_Continue.js": requireXID_Continue,
        "/node_modules/regenerate-unicode-properties/Binary_Property/XID_Start.js": requireXID_Start,
        "/node_modules/regenerate-unicode-properties/General_Category/Cased_Letter.js": requireCased_Letter,
        "/node_modules/regenerate-unicode-properties/General_Category/Close_Punctuation.js": requireClose_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Connector_Punctuation.js": requireConnector_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Control.js": requireControl,
        "/node_modules/regenerate-unicode-properties/General_Category/Currency_Symbol.js": requireCurrency_Symbol,
        "/node_modules/regenerate-unicode-properties/General_Category/Dash_Punctuation.js": requireDash_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Decimal_Number.js": requireDecimal_Number,
        "/node_modules/regenerate-unicode-properties/General_Category/Enclosing_Mark.js": requireEnclosing_Mark,
        "/node_modules/regenerate-unicode-properties/General_Category/Final_Punctuation.js": requireFinal_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Format.js": requireFormat,
        "/node_modules/regenerate-unicode-properties/General_Category/Initial_Punctuation.js": requireInitial_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Letter_Number.js": requireLetter_Number,
        "/node_modules/regenerate-unicode-properties/General_Category/Letter.js": requireLetter,
        "/node_modules/regenerate-unicode-properties/General_Category/Line_Separator.js": requireLine_Separator,
        "/node_modules/regenerate-unicode-properties/General_Category/Lowercase_Letter.js": requireLowercase_Letter,
        "/node_modules/regenerate-unicode-properties/General_Category/Mark.js": requireMark,
        "/node_modules/regenerate-unicode-properties/General_Category/Math_Symbol.js": requireMath_Symbol,
        "/node_modules/regenerate-unicode-properties/General_Category/Modifier_Letter.js": requireModifier_Letter,
        "/node_modules/regenerate-unicode-properties/General_Category/Modifier_Symbol.js": requireModifier_Symbol,
        "/node_modules/regenerate-unicode-properties/General_Category/Nonspacing_Mark.js": requireNonspacing_Mark,
        "/node_modules/regenerate-unicode-properties/General_Category/Number.js": require_Number,
        "/node_modules/regenerate-unicode-properties/General_Category/Open_Punctuation.js": requireOpen_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Other_Letter.js": requireOther_Letter,
        "/node_modules/regenerate-unicode-properties/General_Category/Other_Number.js": requireOther_Number,
        "/node_modules/regenerate-unicode-properties/General_Category/Other_Punctuation.js": requireOther_Punctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Other_Symbol.js": requireOther_Symbol,
        "/node_modules/regenerate-unicode-properties/General_Category/Other.js": requireOther,
        "/node_modules/regenerate-unicode-properties/General_Category/Paragraph_Separator.js": requireParagraph_Separator,
        "/node_modules/regenerate-unicode-properties/General_Category/Private_Use.js": requirePrivate_Use,
        "/node_modules/regenerate-unicode-properties/General_Category/Punctuation.js": requirePunctuation,
        "/node_modules/regenerate-unicode-properties/General_Category/Separator.js": requireSeparator,
        "/node_modules/regenerate-unicode-properties/General_Category/Space_Separator.js": requireSpace_Separator,
        "/node_modules/regenerate-unicode-properties/General_Category/Spacing_Mark.js": requireSpacing_Mark,
        "/node_modules/regenerate-unicode-properties/General_Category/Surrogate.js": requireSurrogate,
        "/node_modules/regenerate-unicode-properties/General_Category/Symbol.js": require_Symbol,
        "/node_modules/regenerate-unicode-properties/General_Category/Titlecase_Letter.js": requireTitlecase_Letter,
        "/node_modules/regenerate-unicode-properties/General_Category/Unassigned.js": requireUnassigned,
        "/node_modules/regenerate-unicode-properties/General_Category/Uppercase_Letter.js": requireUppercase_Letter,
        "/node_modules/regenerate-unicode-properties/index.js": requireRegenerateUnicodeProperties,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/Basic_Emoji.js": requireBasic_Emoji,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/Emoji_Keycap_Sequence.js": requireEmoji_Keycap_Sequence,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Flag_Sequence.js": requireRGI_Emoji_Flag_Sequence,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Modifier_Sequence.js": requireRGI_Emoji_Modifier_Sequence,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Tag_Sequence.js": requireRGI_Emoji_Tag_Sequence,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_ZWJ_Sequence.js": requireRGI_Emoji_ZWJ_Sequence,
        "/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji.js": requireRGI_Emoji,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Adlam.js": requireAdlam$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Ahom.js": requireAhom$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Anatolian_Hieroglyphs.js": requireAnatolian_Hieroglyphs$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Arabic.js": requireArabic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Armenian.js": requireArmenian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Avestan.js": requireAvestan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Balinese.js": requireBalinese$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Bamum.js": requireBamum$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Bassa_Vah.js": requireBassa_Vah$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Batak.js": requireBatak$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Bengali.js": requireBengali$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Bhaiksuki.js": requireBhaiksuki$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Bopomofo.js": requireBopomofo$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Brahmi.js": requireBrahmi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Braille.js": requireBraille$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Buginese.js": requireBuginese$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Buhid.js": requireBuhid$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Canadian_Aboriginal.js": requireCanadian_Aboriginal$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Carian.js": requireCarian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Caucasian_Albanian.js": requireCaucasian_Albanian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Chakma.js": requireChakma$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cham.js": requireCham$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cherokee.js": requireCherokee$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Chorasmian.js": requireChorasmian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Common.js": requireCommon$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Coptic.js": requireCoptic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cuneiform.js": requireCuneiform$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cypriot.js": requireCypriot$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cypro_Minoan.js": requireCypro_Minoan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Cyrillic.js": requireCyrillic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Deseret.js": requireDeseret$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Devanagari.js": requireDevanagari$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Dives_Akuru.js": requireDives_Akuru$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Dogra.js": requireDogra$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Duployan.js": requireDuployan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Egyptian_Hieroglyphs.js": requireEgyptian_Hieroglyphs$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Elbasan.js": requireElbasan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Elymaic.js": requireElymaic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Ethiopic.js": requireEthiopic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Georgian.js": requireGeorgian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Glagolitic.js": requireGlagolitic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Gothic.js": requireGothic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Grantha.js": requireGrantha$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Greek.js": requireGreek$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Gujarati.js": requireGujarati$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Gunjala_Gondi.js": requireGunjala_Gondi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Gurmukhi.js": requireGurmukhi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Han.js": requireHan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hangul.js": requireHangul$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hanifi_Rohingya.js": requireHanifi_Rohingya$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hanunoo.js": requireHanunoo$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hatran.js": requireHatran$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hebrew.js": requireHebrew$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Hiragana.js": requireHiragana$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Imperial_Aramaic.js": requireImperial_Aramaic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Inherited.js": requireInherited$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Pahlavi.js": requireInscriptional_Pahlavi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Parthian.js": requireInscriptional_Parthian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Javanese.js": requireJavanese$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Kaithi.js": requireKaithi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Kannada.js": requireKannada$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Katakana.js": requireKatakana$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Kayah_Li.js": requireKayah_Li$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Kharoshthi.js": requireKharoshthi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Khitan_Small_Script.js": requireKhitan_Small_Script$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Khmer.js": requireKhmer$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Khojki.js": requireKhojki$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Khudawadi.js": requireKhudawadi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Lao.js": requireLao$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Latin.js": requireLatin$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Lepcha.js": requireLepcha$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Limbu.js": requireLimbu$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_A.js": requireLinear_A$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_B.js": requireLinear_B$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Lisu.js": requireLisu$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Lycian.js": requireLycian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Lydian.js": requireLydian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Mahajani.js": requireMahajani$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Makasar.js": requireMakasar$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Malayalam.js": requireMalayalam$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Mandaic.js": requireMandaic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Manichaean.js": requireManichaean$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Marchen.js": requireMarchen$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Masaram_Gondi.js": requireMasaram_Gondi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Medefaidrin.js": requireMedefaidrin$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Meetei_Mayek.js": requireMeetei_Mayek$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Mende_Kikakui.js": requireMende_Kikakui$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Cursive.js": requireMeroitic_Cursive$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Hieroglyphs.js": requireMeroitic_Hieroglyphs$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Miao.js": requireMiao$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Modi.js": requireModi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Mongolian.js": requireMongolian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Mro.js": requireMro$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Multani.js": requireMultani$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Myanmar.js": requireMyanmar$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Nabataean.js": requireNabataean$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Nandinagari.js": requireNandinagari$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/New_Tai_Lue.js": requireNew_Tai_Lue$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Newa.js": requireNewa$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Nko.js": requireNko$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Nushu.js": requireNushu$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Nyiakeng_Puachue_Hmong.js": requireNyiakeng_Puachue_Hmong$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Ogham.js": requireOgham$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Ol_Chiki.js": requireOl_Chiki$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Hungarian.js": requireOld_Hungarian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Italic.js": requireOld_Italic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_North_Arabian.js": requireOld_North_Arabian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Permic.js": requireOld_Permic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Persian.js": requireOld_Persian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Sogdian.js": requireOld_Sogdian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_South_Arabian.js": requireOld_South_Arabian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Turkic.js": requireOld_Turkic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Uyghur.js": requireOld_Uyghur$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Oriya.js": requireOriya$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Osage.js": requireOsage$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Osmanya.js": requireOsmanya$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Pahawh_Hmong.js": requirePahawh_Hmong$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Palmyrene.js": requirePalmyrene$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Pau_Cin_Hau.js": requirePau_Cin_Hau$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Phags_Pa.js": requirePhags_Pa$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Phoenician.js": requirePhoenician$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Psalter_Pahlavi.js": requirePsalter_Pahlavi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Rejang.js": requireRejang$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Runic.js": requireRunic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Samaritan.js": requireSamaritan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Saurashtra.js": requireSaurashtra$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Sharada.js": requireSharada$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Shavian.js": requireShavian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Siddham.js": requireSiddham$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/SignWriting.js": requireSignWriting$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Sinhala.js": requireSinhala$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Sogdian.js": requireSogdian$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Sora_Sompeng.js": requireSora_Sompeng$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Soyombo.js": requireSoyombo$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Sundanese.js": requireSundanese$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Syloti_Nagri.js": requireSyloti_Nagri$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Syriac.js": requireSyriac$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tagalog.js": requireTagalog$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tagbanwa.js": requireTagbanwa$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Le.js": requireTai_Le$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Tham.js": requireTai_Tham$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Viet.js": requireTai_Viet$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Takri.js": requireTakri$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tamil.js": requireTamil$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tangsa.js": requireTangsa$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tangut.js": requireTangut$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Telugu.js": requireTelugu$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Thaana.js": requireThaana$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Thai.js": requireThai$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tibetan.js": requireTibetan$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tifinagh.js": requireTifinagh$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Tirhuta.js": requireTirhuta$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Toto.js": requireToto$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Ugaritic.js": requireUgaritic$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Vai.js": requireVai$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Vithkuqi.js": requireVithkuqi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Wancho.js": requireWancho$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Warang_Citi.js": requireWarang_Citi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Yezidi.js": requireYezidi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Yi.js": requireYi$1,
        "/node_modules/regenerate-unicode-properties/Script_Extensions/Zanabazar_Square.js": requireZanabazar_Square$1,
        "/node_modules/regenerate-unicode-properties/Script/Adlam.js": requireAdlam,
        "/node_modules/regenerate-unicode-properties/Script/Ahom.js": requireAhom,
        "/node_modules/regenerate-unicode-properties/Script/Anatolian_Hieroglyphs.js": requireAnatolian_Hieroglyphs,
        "/node_modules/regenerate-unicode-properties/Script/Arabic.js": requireArabic,
        "/node_modules/regenerate-unicode-properties/Script/Armenian.js": requireArmenian,
        "/node_modules/regenerate-unicode-properties/Script/Avestan.js": requireAvestan,
        "/node_modules/regenerate-unicode-properties/Script/Balinese.js": requireBalinese,
        "/node_modules/regenerate-unicode-properties/Script/Bamum.js": requireBamum,
        "/node_modules/regenerate-unicode-properties/Script/Bassa_Vah.js": requireBassa_Vah,
        "/node_modules/regenerate-unicode-properties/Script/Batak.js": requireBatak,
        "/node_modules/regenerate-unicode-properties/Script/Bengali.js": requireBengali,
        "/node_modules/regenerate-unicode-properties/Script/Bhaiksuki.js": requireBhaiksuki,
        "/node_modules/regenerate-unicode-properties/Script/Bopomofo.js": requireBopomofo,
        "/node_modules/regenerate-unicode-properties/Script/Brahmi.js": requireBrahmi,
        "/node_modules/regenerate-unicode-properties/Script/Braille.js": requireBraille,
        "/node_modules/regenerate-unicode-properties/Script/Buginese.js": requireBuginese,
        "/node_modules/regenerate-unicode-properties/Script/Buhid.js": requireBuhid,
        "/node_modules/regenerate-unicode-properties/Script/Canadian_Aboriginal.js": requireCanadian_Aboriginal,
        "/node_modules/regenerate-unicode-properties/Script/Carian.js": requireCarian,
        "/node_modules/regenerate-unicode-properties/Script/Caucasian_Albanian.js": requireCaucasian_Albanian,
        "/node_modules/regenerate-unicode-properties/Script/Chakma.js": requireChakma,
        "/node_modules/regenerate-unicode-properties/Script/Cham.js": requireCham,
        "/node_modules/regenerate-unicode-properties/Script/Cherokee.js": requireCherokee,
        "/node_modules/regenerate-unicode-properties/Script/Chorasmian.js": requireChorasmian,
        "/node_modules/regenerate-unicode-properties/Script/Common.js": requireCommon,
        "/node_modules/regenerate-unicode-properties/Script/Coptic.js": requireCoptic,
        "/node_modules/regenerate-unicode-properties/Script/Cuneiform.js": requireCuneiform,
        "/node_modules/regenerate-unicode-properties/Script/Cypriot.js": requireCypriot,
        "/node_modules/regenerate-unicode-properties/Script/Cypro_Minoan.js": requireCypro_Minoan,
        "/node_modules/regenerate-unicode-properties/Script/Cyrillic.js": requireCyrillic,
        "/node_modules/regenerate-unicode-properties/Script/Deseret.js": requireDeseret,
        "/node_modules/regenerate-unicode-properties/Script/Devanagari.js": requireDevanagari,
        "/node_modules/regenerate-unicode-properties/Script/Dives_Akuru.js": requireDives_Akuru,
        "/node_modules/regenerate-unicode-properties/Script/Dogra.js": requireDogra,
        "/node_modules/regenerate-unicode-properties/Script/Duployan.js": requireDuployan,
        "/node_modules/regenerate-unicode-properties/Script/Egyptian_Hieroglyphs.js": requireEgyptian_Hieroglyphs,
        "/node_modules/regenerate-unicode-properties/Script/Elbasan.js": requireElbasan,
        "/node_modules/regenerate-unicode-properties/Script/Elymaic.js": requireElymaic,
        "/node_modules/regenerate-unicode-properties/Script/Ethiopic.js": requireEthiopic,
        "/node_modules/regenerate-unicode-properties/Script/Georgian.js": requireGeorgian,
        "/node_modules/regenerate-unicode-properties/Script/Glagolitic.js": requireGlagolitic,
        "/node_modules/regenerate-unicode-properties/Script/Gothic.js": requireGothic,
        "/node_modules/regenerate-unicode-properties/Script/Grantha.js": requireGrantha,
        "/node_modules/regenerate-unicode-properties/Script/Greek.js": requireGreek,
        "/node_modules/regenerate-unicode-properties/Script/Gujarati.js": requireGujarati,
        "/node_modules/regenerate-unicode-properties/Script/Gunjala_Gondi.js": requireGunjala_Gondi,
        "/node_modules/regenerate-unicode-properties/Script/Gurmukhi.js": requireGurmukhi,
        "/node_modules/regenerate-unicode-properties/Script/Han.js": requireHan,
        "/node_modules/regenerate-unicode-properties/Script/Hangul.js": requireHangul,
        "/node_modules/regenerate-unicode-properties/Script/Hanifi_Rohingya.js": requireHanifi_Rohingya,
        "/node_modules/regenerate-unicode-properties/Script/Hanunoo.js": requireHanunoo,
        "/node_modules/regenerate-unicode-properties/Script/Hatran.js": requireHatran,
        "/node_modules/regenerate-unicode-properties/Script/Hebrew.js": requireHebrew,
        "/node_modules/regenerate-unicode-properties/Script/Hiragana.js": requireHiragana,
        "/node_modules/regenerate-unicode-properties/Script/Imperial_Aramaic.js": requireImperial_Aramaic,
        "/node_modules/regenerate-unicode-properties/Script/Inherited.js": requireInherited,
        "/node_modules/regenerate-unicode-properties/Script/Inscriptional_Pahlavi.js": requireInscriptional_Pahlavi,
        "/node_modules/regenerate-unicode-properties/Script/Inscriptional_Parthian.js": requireInscriptional_Parthian,
        "/node_modules/regenerate-unicode-properties/Script/Javanese.js": requireJavanese,
        "/node_modules/regenerate-unicode-properties/Script/Kaithi.js": requireKaithi,
        "/node_modules/regenerate-unicode-properties/Script/Kannada.js": requireKannada,
        "/node_modules/regenerate-unicode-properties/Script/Katakana.js": requireKatakana,
        "/node_modules/regenerate-unicode-properties/Script/Kayah_Li.js": requireKayah_Li,
        "/node_modules/regenerate-unicode-properties/Script/Kharoshthi.js": requireKharoshthi,
        "/node_modules/regenerate-unicode-properties/Script/Khitan_Small_Script.js": requireKhitan_Small_Script,
        "/node_modules/regenerate-unicode-properties/Script/Khmer.js": requireKhmer,
        "/node_modules/regenerate-unicode-properties/Script/Khojki.js": requireKhojki,
        "/node_modules/regenerate-unicode-properties/Script/Khudawadi.js": requireKhudawadi,
        "/node_modules/regenerate-unicode-properties/Script/Lao.js": requireLao,
        "/node_modules/regenerate-unicode-properties/Script/Latin.js": requireLatin,
        "/node_modules/regenerate-unicode-properties/Script/Lepcha.js": requireLepcha,
        "/node_modules/regenerate-unicode-properties/Script/Limbu.js": requireLimbu,
        "/node_modules/regenerate-unicode-properties/Script/Linear_A.js": requireLinear_A,
        "/node_modules/regenerate-unicode-properties/Script/Linear_B.js": requireLinear_B,
        "/node_modules/regenerate-unicode-properties/Script/Lisu.js": requireLisu,
        "/node_modules/regenerate-unicode-properties/Script/Lycian.js": requireLycian,
        "/node_modules/regenerate-unicode-properties/Script/Lydian.js": requireLydian,
        "/node_modules/regenerate-unicode-properties/Script/Mahajani.js": requireMahajani,
        "/node_modules/regenerate-unicode-properties/Script/Makasar.js": requireMakasar,
        "/node_modules/regenerate-unicode-properties/Script/Malayalam.js": requireMalayalam,
        "/node_modules/regenerate-unicode-properties/Script/Mandaic.js": requireMandaic,
        "/node_modules/regenerate-unicode-properties/Script/Manichaean.js": requireManichaean,
        "/node_modules/regenerate-unicode-properties/Script/Marchen.js": requireMarchen,
        "/node_modules/regenerate-unicode-properties/Script/Masaram_Gondi.js": requireMasaram_Gondi,
        "/node_modules/regenerate-unicode-properties/Script/Medefaidrin.js": requireMedefaidrin,
        "/node_modules/regenerate-unicode-properties/Script/Meetei_Mayek.js": requireMeetei_Mayek,
        "/node_modules/regenerate-unicode-properties/Script/Mende_Kikakui.js": requireMende_Kikakui,
        "/node_modules/regenerate-unicode-properties/Script/Meroitic_Cursive.js": requireMeroitic_Cursive,
        "/node_modules/regenerate-unicode-properties/Script/Meroitic_Hieroglyphs.js": requireMeroitic_Hieroglyphs,
        "/node_modules/regenerate-unicode-properties/Script/Miao.js": requireMiao,
        "/node_modules/regenerate-unicode-properties/Script/Modi.js": requireModi,
        "/node_modules/regenerate-unicode-properties/Script/Mongolian.js": requireMongolian,
        "/node_modules/regenerate-unicode-properties/Script/Mro.js": requireMro,
        "/node_modules/regenerate-unicode-properties/Script/Multani.js": requireMultani,
        "/node_modules/regenerate-unicode-properties/Script/Myanmar.js": requireMyanmar,
        "/node_modules/regenerate-unicode-properties/Script/Nabataean.js": requireNabataean,
        "/node_modules/regenerate-unicode-properties/Script/Nandinagari.js": requireNandinagari,
        "/node_modules/regenerate-unicode-properties/Script/New_Tai_Lue.js": requireNew_Tai_Lue,
        "/node_modules/regenerate-unicode-properties/Script/Newa.js": requireNewa,
        "/node_modules/regenerate-unicode-properties/Script/Nko.js": requireNko,
        "/node_modules/regenerate-unicode-properties/Script/Nushu.js": requireNushu,
        "/node_modules/regenerate-unicode-properties/Script/Nyiakeng_Puachue_Hmong.js": requireNyiakeng_Puachue_Hmong,
        "/node_modules/regenerate-unicode-properties/Script/Ogham.js": requireOgham,
        "/node_modules/regenerate-unicode-properties/Script/Ol_Chiki.js": requireOl_Chiki,
        "/node_modules/regenerate-unicode-properties/Script/Old_Hungarian.js": requireOld_Hungarian,
        "/node_modules/regenerate-unicode-properties/Script/Old_Italic.js": requireOld_Italic,
        "/node_modules/regenerate-unicode-properties/Script/Old_North_Arabian.js": requireOld_North_Arabian,
        "/node_modules/regenerate-unicode-properties/Script/Old_Permic.js": requireOld_Permic,
        "/node_modules/regenerate-unicode-properties/Script/Old_Persian.js": requireOld_Persian,
        "/node_modules/regenerate-unicode-properties/Script/Old_Sogdian.js": requireOld_Sogdian,
        "/node_modules/regenerate-unicode-properties/Script/Old_South_Arabian.js": requireOld_South_Arabian,
        "/node_modules/regenerate-unicode-properties/Script/Old_Turkic.js": requireOld_Turkic,
        "/node_modules/regenerate-unicode-properties/Script/Old_Uyghur.js": requireOld_Uyghur,
        "/node_modules/regenerate-unicode-properties/Script/Oriya.js": requireOriya,
        "/node_modules/regenerate-unicode-properties/Script/Osage.js": requireOsage,
        "/node_modules/regenerate-unicode-properties/Script/Osmanya.js": requireOsmanya,
        "/node_modules/regenerate-unicode-properties/Script/Pahawh_Hmong.js": requirePahawh_Hmong,
        "/node_modules/regenerate-unicode-properties/Script/Palmyrene.js": requirePalmyrene,
        "/node_modules/regenerate-unicode-properties/Script/Pau_Cin_Hau.js": requirePau_Cin_Hau,
        "/node_modules/regenerate-unicode-properties/Script/Phags_Pa.js": requirePhags_Pa,
        "/node_modules/regenerate-unicode-properties/Script/Phoenician.js": requirePhoenician,
        "/node_modules/regenerate-unicode-properties/Script/Psalter_Pahlavi.js": requirePsalter_Pahlavi,
        "/node_modules/regenerate-unicode-properties/Script/Rejang.js": requireRejang,
        "/node_modules/regenerate-unicode-properties/Script/Runic.js": requireRunic,
        "/node_modules/regenerate-unicode-properties/Script/Samaritan.js": requireSamaritan,
        "/node_modules/regenerate-unicode-properties/Script/Saurashtra.js": requireSaurashtra,
        "/node_modules/regenerate-unicode-properties/Script/Sharada.js": requireSharada,
        "/node_modules/regenerate-unicode-properties/Script/Shavian.js": requireShavian,
        "/node_modules/regenerate-unicode-properties/Script/Siddham.js": requireSiddham,
        "/node_modules/regenerate-unicode-properties/Script/SignWriting.js": requireSignWriting,
        "/node_modules/regenerate-unicode-properties/Script/Sinhala.js": requireSinhala,
        "/node_modules/regenerate-unicode-properties/Script/Sogdian.js": requireSogdian,
        "/node_modules/regenerate-unicode-properties/Script/Sora_Sompeng.js": requireSora_Sompeng,
        "/node_modules/regenerate-unicode-properties/Script/Soyombo.js": requireSoyombo,
        "/node_modules/regenerate-unicode-properties/Script/Sundanese.js": requireSundanese,
        "/node_modules/regenerate-unicode-properties/Script/Syloti_Nagri.js": requireSyloti_Nagri,
        "/node_modules/regenerate-unicode-properties/Script/Syriac.js": requireSyriac,
        "/node_modules/regenerate-unicode-properties/Script/Tagalog.js": requireTagalog,
        "/node_modules/regenerate-unicode-properties/Script/Tagbanwa.js": requireTagbanwa,
        "/node_modules/regenerate-unicode-properties/Script/Tai_Le.js": requireTai_Le,
        "/node_modules/regenerate-unicode-properties/Script/Tai_Tham.js": requireTai_Tham,
        "/node_modules/regenerate-unicode-properties/Script/Tai_Viet.js": requireTai_Viet,
        "/node_modules/regenerate-unicode-properties/Script/Takri.js": requireTakri,
        "/node_modules/regenerate-unicode-properties/Script/Tamil.js": requireTamil,
        "/node_modules/regenerate-unicode-properties/Script/Tangsa.js": requireTangsa,
        "/node_modules/regenerate-unicode-properties/Script/Tangut.js": requireTangut,
        "/node_modules/regenerate-unicode-properties/Script/Telugu.js": requireTelugu,
        "/node_modules/regenerate-unicode-properties/Script/Thaana.js": requireThaana,
        "/node_modules/regenerate-unicode-properties/Script/Thai.js": requireThai,
        "/node_modules/regenerate-unicode-properties/Script/Tibetan.js": requireTibetan,
        "/node_modules/regenerate-unicode-properties/Script/Tifinagh.js": requireTifinagh,
        "/node_modules/regenerate-unicode-properties/Script/Tirhuta.js": requireTirhuta,
        "/node_modules/regenerate-unicode-properties/Script/Toto.js": requireToto,
        "/node_modules/regenerate-unicode-properties/Script/Ugaritic.js": requireUgaritic,
        "/node_modules/regenerate-unicode-properties/Script/Vai.js": requireVai,
        "/node_modules/regenerate-unicode-properties/Script/Vithkuqi.js": requireVithkuqi,
        "/node_modules/regenerate-unicode-properties/Script/Wancho.js": requireWancho,
        "/node_modules/regenerate-unicode-properties/Script/Warang_Citi.js": requireWarang_Citi,
        "/node_modules/regenerate-unicode-properties/Script/Yezidi.js": requireYezidi,
        "/node_modules/regenerate-unicode-properties/Script/Yi.js": requireYi,
        "/node_modules/regenerate-unicode-properties/Script/Zanabazar_Square.js": requireZanabazar_Square,
        "/node_modules/regenerate-unicode-properties/unicode-version.js": requireUnicodeVersion
      });
    }
    function createCommonjsRequire(originalModuleDir) {
      function handleRequire(path2) {
        var resolvedPath = commonjsResolve(path2, originalModuleDir);
        if (resolvedPath !== null) {
          return getDynamicModules()[resolvedPath]();
        }
        throw new Error('Could not dynamically require "' + path2 + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
      }
      handleRequire.resolve = function(path2) {
        var resolvedPath = commonjsResolve(path2, originalModuleDir);
        if (resolvedPath !== null) {
          return resolvedPath;
        }
        return require.resolve(path2);
      };
      return handleRequire;
    }
    function commonjsResolve(path2, originalModuleDir) {
      var shouldTryNodeModules = isPossibleNodeModulesPath(path2);
      path2 = normalize2(path2);
      var relPath;
      if (path2[0] === "/") {
        originalModuleDir = "";
      }
      var modules2 = getDynamicModules();
      var checkedExtensions = ["", ".js", ".json"];
      while (true) {
        if (!shouldTryNodeModules) {
          relPath = normalize2(originalModuleDir + "/" + path2);
        } else {
          relPath = normalize2(originalModuleDir + "/node_modules/" + path2);
        }
        if (relPath.endsWith("/..")) {
          break;
        }
        for (var extensionIndex = 0; extensionIndex < checkedExtensions.length; extensionIndex++) {
          var resolvedPath = relPath + checkedExtensions[extensionIndex];
          if (modules2[resolvedPath]) {
            return resolvedPath;
          }
        }
        if (!shouldTryNodeModules)
          break;
        var nextDir = normalize2(originalModuleDir + "/..");
        if (nextDir === originalModuleDir)
          break;
        originalModuleDir = nextDir;
      }
      return null;
    }
    function isPossibleNodeModulesPath(modulePath) {
      var c0 = modulePath[0];
      if (c0 === "/" || c0 === "\\")
        return false;
      var c1 = modulePath[1], c2 = modulePath[2];
      if (c0 === "." && (!c1 || c1 === "/" || c1 === "\\") || c0 === "." && c1 === "." && (!c2 || c2 === "/" || c2 === "\\"))
        return false;
      if (c1 === ":" && (c2 === "/" || c2 === "\\"))
        return false;
      return true;
    }
    function normalize2(path2) {
      path2 = path2.replace(/\\/g, "/");
      var parts = path2.split("/");
      var slashed = parts[0] === "";
      for (var i2 = 1; i2 < parts.length; i2++) {
        if (parts[i2] === "." || parts[i2] === "") {
          parts.splice(i2--, 1);
        }
      }
      for (var i2 = 1; i2 < parts.length; i2++) {
        if (parts[i2] !== "..")
          continue;
        if (i2 > 0 && parts[i2 - 1] !== ".." && parts[i2 - 1] !== ".") {
          parts.splice(--i2, 2);
          i2--;
        }
      }
      path2 = parts.join("/");
      if (slashed && path2[0] !== "/")
        path2 = "/" + path2;
      else if (path2.length === 0)
        path2 = ".";
      return path2;
    }
    var regjsgen = { exports: {} };
    (function(module2, exports3) {
      (function() {
        var objectTypes = {
          "function": true,
          "object": true
        };
        var root2 = objectTypes[typeof window] && window || this;
        var freeExports = exports3 && !exports3.nodeType && exports3;
        var hasFreeModule = module2 && !module2.nodeType;
        var freeGlobal2 = freeExports && hasFreeModule && typeof commonjsGlobal$1 == "object" && commonjsGlobal$1;
        if (freeGlobal2 && (freeGlobal2.global === freeGlobal2 || freeGlobal2.window === freeGlobal2 || freeGlobal2.self === freeGlobal2)) {
          root2 = freeGlobal2;
        }
        var hasOwnProperty2 = Object.prototype.hasOwnProperty;
        function fromCodePoint() {
          var codePoint = Number(arguments[0]);
          if (!isFinite(codePoint) || codePoint < 0 || codePoint > 1114111 || Math.floor(codePoint) != codePoint) {
            throw RangeError("Invalid code point: " + codePoint);
          }
          if (codePoint <= 65535) {
            return String.fromCharCode(codePoint);
          } else {
            codePoint -= 65536;
            var highSurrogate = (codePoint >> 10) + 55296;
            var lowSurrogate = codePoint % 1024 + 56320;
            return String.fromCharCode(highSurrogate, lowSurrogate);
          }
        }
        var assertTypeRegexMap = {};
        function assertType(type5, expected) {
          if (expected.indexOf("|") == -1) {
            if (type5 == expected) {
              return;
            }
            throw Error("Invalid node type: " + type5 + "; expected type: " + expected);
          }
          expected = hasOwnProperty2.call(assertTypeRegexMap, expected) ? assertTypeRegexMap[expected] : assertTypeRegexMap[expected] = RegExp("^(?:" + expected + ")$");
          if (expected.test(type5)) {
            return;
          }
          throw Error("Invalid node type: " + type5 + "; expected types: " + expected);
        }
        function generate3(node2) {
          var type5 = node2.type;
          if (hasOwnProperty2.call(generators, type5)) {
            return generators[type5](node2);
          }
          throw Error("Invalid node type: " + type5);
        }
        function generateSequence(generator, terms, separator) {
          var i2 = -1, length = terms.length, result = "", term;
          while (++i2 < length) {
            term = terms[i2];
            if (separator && i2 > 0)
              result += separator;
            if (i2 + 1 < length && terms[i2].type == "value" && terms[i2].kind == "null" && terms[i2 + 1].type == "value" && terms[i2 + 1].kind == "symbol" && terms[i2 + 1].codePoint >= 48 && terms[i2 + 1].codePoint <= 57) {
              result += "\\000";
              continue;
            }
            result += generator(term);
          }
          return result;
        }
        function generateAlternative(node2) {
          assertType(node2.type, "alternative");
          return generateSequence(generateTerm, node2.body);
        }
        function generateAnchor(node2) {
          assertType(node2.type, "anchor");
          switch (node2.kind) {
            case "start":
              return "^";
            case "end":
              return "$";
            case "boundary":
              return "\\b";
            case "not-boundary":
              return "\\B";
            default:
              throw Error("Invalid assertion");
          }
        }
        function generateAtom(node2) {
          assertType(node2.type, "anchor|characterClass|characterClassEscape|dot|group|reference|value");
          return generate3(node2);
        }
        function generateCharacterClass(node2) {
          assertType(node2.type, "characterClass");
          var kind = node2.kind;
          var separator = kind === "intersection" ? "&&" : kind === "subtraction" ? "--" : "";
          return "[" + (node2.negative ? "^" : "") + generateSequence(generateClassAtom, node2.body, separator) + "]";
        }
        function generateCharacterClassEscape(node2) {
          assertType(node2.type, "characterClassEscape");
          return "\\" + node2.value;
        }
        function generateCharacterClassRange(node2) {
          assertType(node2.type, "characterClassRange");
          var min4 = node2.min, max3 = node2.max;
          if (min4.type == "characterClassRange" || max3.type == "characterClassRange") {
            throw Error("Invalid character class range");
          }
          return generateClassAtom(min4) + "-" + generateClassAtom(max3);
        }
        function generateClassAtom(node2) {
          assertType(node2.type, "anchor|characterClass|characterClassEscape|characterClassRange|dot|value|unicodePropertyEscape|classStrings");
          return generate3(node2);
        }
        function generateClassStrings(node2) {
          assertType(node2.type, "classStrings");
          return "(" + generateSequence(generateClassString, node2.strings, "|") + ")";
        }
        function generateClassString(node2) {
          assertType(node2.type, "classString");
          return generateSequence(generate3, node2.characters);
        }
        function generateDisjunction(node2) {
          assertType(node2.type, "disjunction");
          return generateSequence(generate3, node2.body, "|");
        }
        function generateDot(node2) {
          assertType(node2.type, "dot");
          return ".";
        }
        function generateGroup(node2) {
          assertType(node2.type, "group");
          var result = "";
          switch (node2.behavior) {
            case "normal":
              if (node2.name) {
                result += "?<" + generateIdentifier(node2.name) + ">";
              }
              break;
            case "ignore":
              result += "?:";
              break;
            case "lookahead":
              result += "?=";
              break;
            case "negativeLookahead":
              result += "?!";
              break;
            case "lookbehind":
              result += "?<=";
              break;
            case "negativeLookbehind":
              result += "?<!";
              break;
            default:
              throw Error("Invalid behaviour: " + node2.behaviour);
          }
          result += generateSequence(generate3, node2.body);
          return "(" + result + ")";
        }
        function generateIdentifier(node2) {
          assertType(node2.type, "identifier");
          return node2.value;
        }
        function generateQuantifier(node2) {
          assertType(node2.type, "quantifier");
          var quantifier = "", min4 = node2.min, max3 = node2.max;
          if (max3 == null) {
            if (min4 == 0) {
              quantifier = "*";
            } else if (min4 == 1) {
              quantifier = "+";
            } else {
              quantifier = "{" + min4 + ",}";
            }
          } else if (min4 == max3) {
            quantifier = "{" + min4 + "}";
          } else if (min4 == 0 && max3 == 1) {
            quantifier = "?";
          } else {
            quantifier = "{" + min4 + "," + max3 + "}";
          }
          if (!node2.greedy) {
            quantifier += "?";
          }
          return generateAtom(node2.body[0]) + quantifier;
        }
        function generateReference(node2) {
          assertType(node2.type, "reference");
          if (node2.matchIndex) {
            return "\\" + node2.matchIndex;
          }
          if (node2.name) {
            return "\\k<" + generateIdentifier(node2.name) + ">";
          }
          throw new Error("Unknown reference type");
        }
        function generateTerm(node2) {
          assertType(node2.type, "anchor|characterClass|characterClassEscape|empty|group|quantifier|reference|unicodePropertyEscape|value|dot");
          return generate3(node2);
        }
        function generateUnicodePropertyEscape(node2) {
          assertType(node2.type, "unicodePropertyEscape");
          return "\\" + (node2.negative ? "P" : "p") + "{" + node2.value + "}";
        }
        function generateValue(node2) {
          assertType(node2.type, "value");
          var kind = node2.kind, codePoint = node2.codePoint;
          if (typeof codePoint != "number") {
            throw new Error("Invalid code point: " + codePoint);
          }
          switch (kind) {
            case "controlLetter":
              return "\\c" + fromCodePoint(codePoint + 64);
            case "hexadecimalEscape":
              return "\\x" + ("00" + codePoint.toString(16).toUpperCase()).slice(-2);
            case "identifier":
              return "\\" + fromCodePoint(codePoint);
            case "null":
              return "\\" + codePoint;
            case "octal":
              return "\\" + ("000" + codePoint.toString(8)).slice(-3);
            case "singleEscape":
              switch (codePoint) {
                case 8:
                  return "\\b";
                case 9:
                  return "\\t";
                case 10:
                  return "\\n";
                case 11:
                  return "\\v";
                case 12:
                  return "\\f";
                case 13:
                  return "\\r";
                case 45:
                  return "\\-";
                default:
                  throw Error("Invalid code point: " + codePoint);
              }
            case "symbol":
              return fromCodePoint(codePoint);
            case "unicodeEscape":
              return "\\u" + ("0000" + codePoint.toString(16).toUpperCase()).slice(-4);
            case "unicodeCodePointEscape":
              return "\\u{" + codePoint.toString(16).toUpperCase() + "}";
            default:
              throw Error("Unsupported node kind: " + kind);
          }
        }
        var generators = {
          "alternative": generateAlternative,
          "anchor": generateAnchor,
          "characterClass": generateCharacterClass,
          "characterClassEscape": generateCharacterClassEscape,
          "characterClassRange": generateCharacterClassRange,
          "classStrings": generateClassStrings,
          "disjunction": generateDisjunction,
          "dot": generateDot,
          "group": generateGroup,
          "quantifier": generateQuantifier,
          "reference": generateReference,
          "unicodePropertyEscape": generateUnicodePropertyEscape,
          "value": generateValue
        };
        var regjsgen2 = {
          "generate": generate3
        };
        if (freeExports && hasFreeModule) {
          freeExports.generate = generate3;
        } else {
          root2.regjsgen = regjsgen2;
        }
      }).call(commonjsGlobal$1);
    })(regjsgen, regjsgen.exports);
    var parser = { exports: {} };
    (function(module2) {
      (function() {
        var fromCodePoint = String.fromCodePoint || function() {
          var stringFromCharCode = String.fromCharCode;
          var floor = Math.floor;
          return function fromCodePoint2() {
            var MAX_SIZE = 16384;
            var codeUnits = [];
            var highSurrogate;
            var lowSurrogate;
            var index3 = -1;
            var length = arguments.length;
            if (!length) {
              return "";
            }
            var result = "";
            while (++index3 < length) {
              var codePoint = Number(arguments[index3]);
              if (!isFinite(codePoint) || codePoint < 0 || codePoint > 1114111 || floor(codePoint) != codePoint) {
                throw RangeError("Invalid code point: " + codePoint);
              }
              if (codePoint <= 65535) {
                codeUnits.push(codePoint);
              } else {
                codePoint -= 65536;
                highSurrogate = (codePoint >> 10) + 55296;
                lowSurrogate = codePoint % 1024 + 56320;
                codeUnits.push(highSurrogate, lowSurrogate);
              }
              if (index3 + 1 == length || codeUnits.length > MAX_SIZE) {
                result += stringFromCharCode.apply(null, codeUnits);
                codeUnits.length = 0;
              }
            }
            return result;
          };
        }();
        function parse5(str, flags, features2) {
          if (!features2) {
            features2 = {};
          }
          function addRaw(node2) {
            node2.raw = str.substring(node2.range[0], node2.range[1]);
            return node2;
          }
          function updateRawStart(node2, start2) {
            node2.range[0] = start2;
            return addRaw(node2);
          }
          function createAnchor(kind, rawLength) {
            return addRaw({
              type: "anchor",
              kind,
              range: [pos - rawLength, pos]
            });
          }
          function createValue(kind, codePoint, from2, to) {
            return addRaw({
              type: "value",
              kind,
              codePoint,
              range: [from2, to]
            });
          }
          function createEscaped(kind, codePoint, value, fromOffset) {
            fromOffset = fromOffset || 0;
            return createValue(kind, codePoint, pos - (value.length + fromOffset), pos);
          }
          function createCharacter(matches) {
            var _char = matches[0];
            var first = _char.charCodeAt(0);
            if (isUnicodeMode) {
              var second;
              if (_char.length === 1 && first >= 55296 && first <= 56319) {
                second = lookahead2().charCodeAt(0);
                if (second >= 56320 && second <= 57343) {
                  pos++;
                  return createValue("symbol", (first - 55296) * 1024 + second - 56320 + 65536, pos - 2, pos);
                }
              }
            }
            return createValue("symbol", first, pos - 1, pos);
          }
          function createDisjunction(alternatives, from2, to) {
            return addRaw({
              type: "disjunction",
              body: alternatives,
              range: [from2, to]
            });
          }
          function createDot() {
            return addRaw({
              type: "dot",
              range: [pos - 1, pos]
            });
          }
          function createCharacterClassEscape(value) {
            return addRaw({
              type: "characterClassEscape",
              value,
              range: [pos - 2, pos]
            });
          }
          function createReference(matchIndex) {
            return addRaw({
              type: "reference",
              matchIndex: parseInt(matchIndex, 10),
              range: [pos - 1 - matchIndex.length, pos]
            });
          }
          function createNamedReference(name2) {
            return addRaw({
              type: "reference",
              name: name2,
              range: [name2.range[0] - 3, pos]
            });
          }
          function createGroup(behavior, disjunction, from2, to) {
            return addRaw({
              type: "group",
              behavior,
              body: disjunction,
              range: [from2, to]
            });
          }
          function createQuantifier(min4, max3, from2, to) {
            if (to == null) {
              from2 = pos - 1;
              to = pos;
            }
            return addRaw({
              type: "quantifier",
              min: min4,
              max: max3,
              greedy: true,
              body: null,
              range: [from2, to]
            });
          }
          function createAlternative(terms, from2, to) {
            return addRaw({
              type: "alternative",
              body: terms,
              range: [from2, to]
            });
          }
          function createCharacterClass(contents, negative, from2, to) {
            return addRaw({
              type: "characterClass",
              kind: contents.kind,
              body: contents.body,
              negative,
              range: [from2, to]
            });
          }
          function createClassRange(min4, max3, from2, to) {
            if (min4.codePoint > max3.codePoint) {
              bail("invalid range in character class", min4.raw + "-" + max3.raw, from2, to);
            }
            return addRaw({
              type: "characterClassRange",
              min: min4,
              max: max3,
              range: [from2, to]
            });
          }
          function createClassStrings(strings, from2, to) {
            return addRaw({
              type: "classStrings",
              strings,
              range: [from2, to]
            });
          }
          function createClassString(characters, from2, to) {
            return addRaw({
              type: "classString",
              characters,
              range: [from2, to]
            });
          }
          function flattenBody(body) {
            if (body.type === "alternative") {
              return body.body;
            } else {
              return [body];
            }
          }
          function incr(amount) {
            amount = amount || 1;
            var res2 = str.substring(pos, pos + amount);
            pos += amount || 1;
            return res2;
          }
          function skip2(value) {
            if (!match(value)) {
              bail("character", value);
            }
          }
          function match(value) {
            if (str.indexOf(value, pos) === pos) {
              return incr(value.length);
            }
          }
          function lookahead2() {
            return str[pos];
          }
          function current2(value) {
            return str.indexOf(value, pos) === pos;
          }
          function next(value) {
            return str[pos + 1] === value;
          }
          function matchReg(regExp) {
            var subStr = str.substring(pos);
            var res2 = subStr.match(regExp);
            if (res2) {
              res2.range = [];
              res2.range[0] = pos;
              incr(res2[0].length);
              res2.range[1] = pos;
            }
            return res2;
          }
          function parseDisjunction() {
            var res2 = [], from2 = pos;
            res2.push(parseAlternative());
            while (match("|")) {
              res2.push(parseAlternative());
            }
            if (res2.length === 1) {
              return res2[0];
            }
            return createDisjunction(res2, from2, pos);
          }
          function parseAlternative() {
            var res2 = [], from2 = pos;
            var term;
            while (term = parseTerm()) {
              res2.push(term);
            }
            if (res2.length === 1) {
              return res2[0];
            }
            return createAlternative(res2, from2, pos);
          }
          function parseTerm() {
            if (pos >= str.length || current2("|") || current2(")")) {
              return null;
            }
            var anchor = parseAnchor();
            if (anchor) {
              return anchor;
            }
            var atom = parseAtomAndExtendedAtom();
            if (!atom) {
              var pos_backup = pos;
              var quantifier = parseQuantifier() || false;
              if (quantifier) {
                pos = pos_backup;
                bail("Expected atom");
              }
              if (!isUnicodeMode && (res = matchReg(/^{/))) {
                atom = createCharacter(res);
              } else {
                bail("Expected atom");
              }
            }
            var quantifier = parseQuantifier() || false;
            if (quantifier) {
              quantifier.body = flattenBody(atom);
              updateRawStart(quantifier, atom.range[0]);
              return quantifier;
            }
            return atom;
          }
          function parseGroup(matchA, typeA, matchB, typeB) {
            var type5 = null, from2 = pos;
            if (match(matchA)) {
              type5 = typeA;
            } else if (match(matchB)) {
              type5 = typeB;
            } else {
              return false;
            }
            return finishGroup(type5, from2);
          }
          function finishGroup(type5, from2) {
            var body = parseDisjunction();
            if (!body) {
              bail("Expected disjunction");
            }
            skip2(")");
            var group = createGroup(type5, flattenBody(body), from2, pos);
            if (type5 == "normal") {
              if (firstIteration) {
                closedCaptureCounter++;
              }
            }
            return group;
          }
          function parseAnchor() {
            if (match("^")) {
              return createAnchor("start", 1);
            } else if (match("$")) {
              return createAnchor("end", 1);
            } else if (match("\\b")) {
              return createAnchor("boundary", 2);
            } else if (match("\\B")) {
              return createAnchor("not-boundary", 2);
            } else {
              return parseGroup("(?=", "lookahead", "(?!", "negativeLookahead");
            }
          }
          function parseQuantifier() {
            var res2, from2 = pos;
            var quantifier;
            var min4, max3;
            if (match("*")) {
              quantifier = createQuantifier(0);
            } else if (match("+")) {
              quantifier = createQuantifier(1);
            } else if (match("?")) {
              quantifier = createQuantifier(0, 1);
            } else if (res2 = matchReg(/^\{([0-9]+)\}/)) {
              min4 = parseInt(res2[1], 10);
              quantifier = createQuantifier(min4, min4, res2.range[0], res2.range[1]);
            } else if (res2 = matchReg(/^\{([0-9]+),\}/)) {
              min4 = parseInt(res2[1], 10);
              quantifier = createQuantifier(min4, void 0, res2.range[0], res2.range[1]);
            } else if (res2 = matchReg(/^\{([0-9]+),([0-9]+)\}/)) {
              min4 = parseInt(res2[1], 10);
              max3 = parseInt(res2[2], 10);
              if (min4 > max3) {
                bail("numbers out of order in {} quantifier", "", from2, pos);
              }
              quantifier = createQuantifier(min4, max3, res2.range[0], res2.range[1]);
            }
            if (min4 && !Number.isSafeInteger(min4) || max3 && !Number.isSafeInteger(max3)) {
              bail("iterations outside JS safe integer range in quantifier", "", from2, pos);
            }
            if (quantifier) {
              if (match("?")) {
                quantifier.greedy = false;
                quantifier.range[1] += 1;
              }
            }
            return quantifier;
          }
          function parseAtomAndExtendedAtom() {
            var res2;
            if (res2 = matchReg(/^[^^$\\.*+?()[\]{}|]/)) {
              return createCharacter(res2);
            } else if (!isUnicodeMode && (res2 = matchReg(/^(?:]|})/))) {
              return createCharacter(res2);
            } else if (match(".")) {
              return createDot();
            } else if (match("\\")) {
              res2 = parseAtomEscape();
              if (!res2) {
                if (!isUnicodeMode && lookahead2() == "c") {
                  return createValue("symbol", 92, pos - 1, pos);
                }
                bail("atomEscape");
              }
              return res2;
            } else if (res2 = parseCharacterClass()) {
              return res2;
            } else if (features2.lookbehind && (res2 = parseGroup("(?<=", "lookbehind", "(?<!", "negativeLookbehind"))) {
              return res2;
            } else if (features2.namedGroups && match("(?<")) {
              var name2 = parseIdentifier();
              skip2(">");
              var group = finishGroup("normal", name2.range[0] - 3);
              group.name = name2;
              return group;
            } else {
              return parseGroup("(?:", "ignore", "(", "normal");
            }
          }
          function parseUnicodeSurrogatePairEscape(firstEscape) {
            if (isUnicodeMode) {
              var first, second;
              if (firstEscape.kind == "unicodeEscape" && (first = firstEscape.codePoint) >= 55296 && first <= 56319 && current2("\\") && next("u")) {
                var prevPos = pos;
                pos++;
                var secondEscape = parseClassEscape();
                if (secondEscape.kind == "unicodeEscape" && (second = secondEscape.codePoint) >= 56320 && second <= 57343) {
                  firstEscape.range[1] = secondEscape.range[1];
                  firstEscape.codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
                  firstEscape.type = "value";
                  firstEscape.kind = "unicodeCodePointEscape";
                  addRaw(firstEscape);
                } else {
                  pos = prevPos;
                }
              }
            }
            return firstEscape;
          }
          function parseClassEscape() {
            return parseAtomEscape(true);
          }
          function parseAtomEscape(insideCharacterClass) {
            var res2, from2 = pos;
            res2 = parseDecimalEscape(insideCharacterClass) || parseNamedReference();
            if (res2) {
              return res2;
            }
            if (insideCharacterClass) {
              if (match("b")) {
                return createEscaped("singleEscape", 8, "\\b");
              } else if (match("B")) {
                bail("\\B not possible inside of CharacterClass", "", from2);
              } else if (!isUnicodeMode && (res2 = matchReg(/^c([0-9])/))) {
                return createEscaped("controlLetter", res2[1] + 16, res2[1], 2);
              } else if (!isUnicodeMode && (res2 = matchReg(/^c_/))) {
                return createEscaped("controlLetter", 31, "_", 2);
              }
              if (isUnicodeMode && match("-")) {
                return createEscaped("singleEscape", 45, "\\-");
              }
            }
            res2 = parseCharacterClassEscape() || parseCharacterEscape();
            return res2;
          }
          function parseDecimalEscape(insideCharacterClass) {
            var res2, match2, from2 = pos;
            if (res2 = matchReg(/^(?!0)\d+/)) {
              match2 = res2[0];
              var refIdx = parseInt(res2[0], 10);
              if (refIdx <= closedCaptureCounter && !insideCharacterClass) {
                return createReference(res2[0]);
              } else {
                backrefDenied.push(refIdx);
                if (firstIteration) {
                  shouldReparse = true;
                } else {
                  bailOctalEscapeIfUnicode(from2, pos);
                }
                incr(-res2[0].length);
                if (res2 = matchReg(/^[0-7]{1,3}/)) {
                  return createEscaped("octal", parseInt(res2[0], 8), res2[0], 1);
                } else {
                  res2 = createCharacter(matchReg(/^[89]/));
                  return updateRawStart(res2, res2.range[0] - 1);
                }
              }
            } else if (res2 = matchReg(/^[0-7]{1,3}/)) {
              match2 = res2[0];
              if (match2 !== "0") {
                bailOctalEscapeIfUnicode(from2, pos);
              }
              if (/^0{1,3}$/.test(match2)) {
                return createEscaped("null", 0, "0", match2.length);
              } else {
                return createEscaped("octal", parseInt(match2, 8), match2, 1);
              }
            }
            return false;
          }
          function bailOctalEscapeIfUnicode(from2, pos2) {
            if (isUnicodeMode) {
              bail("Invalid decimal escape in unicode mode", null, from2, pos2);
            }
          }
          function parseCharacterClassEscape() {
            var res2;
            if (res2 = matchReg(/^[dDsSwW]/)) {
              return createCharacterClassEscape(res2[0]);
            } else if (features2.unicodePropertyEscape && isUnicodeMode && (res2 = matchReg(/^([pP])\{([^\}]+)\}/))) {
              return addRaw({
                type: "unicodePropertyEscape",
                negative: res2[1] === "P",
                value: res2[2],
                range: [res2.range[0] - 1, res2.range[1]],
                raw: res2[0]
              });
            } else if (features2.unicodeSet && hasUnicodeSetFlag && match("q{")) {
              return parseClassStrings();
            }
            return false;
          }
          function parseNamedReference() {
            if (features2.namedGroups && matchReg(/^k<(?=.*?>)/)) {
              var name2 = parseIdentifier();
              skip2(">");
              return createNamedReference(name2);
            }
          }
          function parseRegExpUnicodeEscapeSequence() {
            var res2;
            if (res2 = matchReg(/^u([0-9a-fA-F]{4})/)) {
              return parseUnicodeSurrogatePairEscape(createEscaped("unicodeEscape", parseInt(res2[1], 16), res2[1], 2));
            } else if (isUnicodeMode && (res2 = matchReg(/^u\{([0-9a-fA-F]+)\}/))) {
              return createEscaped("unicodeCodePointEscape", parseInt(res2[1], 16), res2[1], 4);
            }
          }
          function parseCharacterEscape() {
            var res2;
            var from2 = pos;
            if (res2 = matchReg(/^[fnrtv]/)) {
              var codePoint = 0;
              switch (res2[0]) {
                case "t":
                  codePoint = 9;
                  break;
                case "n":
                  codePoint = 10;
                  break;
                case "v":
                  codePoint = 11;
                  break;
                case "f":
                  codePoint = 12;
                  break;
                case "r":
                  codePoint = 13;
                  break;
              }
              return createEscaped("singleEscape", codePoint, "\\" + res2[0]);
            } else if (res2 = matchReg(/^c([a-zA-Z])/)) {
              return createEscaped("controlLetter", res2[1].charCodeAt(0) % 32, res2[1], 2);
            } else if (res2 = matchReg(/^x([0-9a-fA-F]{2})/)) {
              return createEscaped("hexadecimalEscape", parseInt(res2[1], 16), res2[1], 2);
            } else if (res2 = parseRegExpUnicodeEscapeSequence()) {
              if (!res2 || res2.codePoint > 1114111) {
                bail("Invalid escape sequence", null, from2, pos);
              }
              return res2;
            } else {
              return parseIdentityEscape();
            }
          }
          function parseIdentifierAtom(check) {
            var ch2 = lookahead2();
            var from2 = pos;
            if (ch2 === "\\") {
              incr();
              var esc = parseRegExpUnicodeEscapeSequence();
              if (!esc || !check(esc.codePoint)) {
                bail("Invalid escape sequence", null, from2, pos);
              }
              return fromCodePoint(esc.codePoint);
            }
            var code3 = ch2.charCodeAt(0);
            if (code3 >= 55296 && code3 <= 56319) {
              ch2 += str[pos + 1];
              var second = ch2.charCodeAt(1);
              if (second >= 56320 && second <= 57343) {
                code3 = (code3 - 55296) * 1024 + second - 56320 + 65536;
              }
            }
            if (!check(code3))
              return;
            incr();
            if (code3 > 65535)
              incr();
            return ch2;
          }
          function parseIdentifier() {
            var start2 = pos;
            var res2 = parseIdentifierAtom(isIdentifierStart3);
            if (!res2) {
              bail("Invalid identifier");
            }
            var ch2;
            while (ch2 = parseIdentifierAtom(isIdentifierPart)) {
              res2 += ch2;
            }
            return addRaw({
              type: "identifier",
              value: res2,
              range: [start2, pos]
            });
          }
          function isIdentifierStart3(ch2) {
            var NonAsciiIdentifierStart = /[\$A-Z_a-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEF\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7B9\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDD00-\uDD23\uDF00-\uDF1C\uDF27\uDF30-\uDF45]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD44\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF1A]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDEE0-\uDEF2]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE7F\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFF1]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
            return ch2 === 36 || ch2 === 95 || ch2 >= 65 && ch2 <= 90 || ch2 >= 97 && ch2 <= 122 || ch2 >= 128 && NonAsciiIdentifierStart.test(fromCodePoint(ch2));
          }
          function isIdentifierPart(ch2) {
            var NonAsciiIdentifierPartOnly = /[0-9_\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08D3-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DF9\u1DFB-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD801[\uDCA0-\uDCA9]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD803[\uDD24-\uDD27\uDD30-\uDD39\uDF46-\uDF50]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC66-\uDC6F\uDC7F-\uDC82\uDCB0-\uDCBA\uDCF0-\uDCF9\uDD00-\uDD02\uDD27-\uDD34\uDD36-\uDD3F\uDD45\uDD46\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDDC9-\uDDCC\uDDD0-\uDDD9\uDE2C-\uDE37\uDE3E\uDEDF-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF3B\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC35-\uDC46\uDC50-\uDC59\uDC5E\uDCB0-\uDCC3\uDCD0-\uDCD9\uDDAF-\uDDB5\uDDB8-\uDDC0\uDDDC\uDDDD\uDE30-\uDE40\uDE50-\uDE59\uDEAB-\uDEB7\uDEC0-\uDEC9\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDC2C-\uDC3A\uDCE0-\uDCE9\uDE01-\uDE0A\uDE33-\uDE39\uDE3B-\uDE3E\uDE47\uDE51-\uDE5B\uDE8A-\uDE99]|\uD807[\uDC2F-\uDC36\uDC38-\uDC3F\uDC50-\uDC59\uDC92-\uDCA7\uDCA9-\uDCB6\uDD31-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD45\uDD47\uDD50-\uDD59\uDD8A-\uDD8E\uDD90\uDD91\uDD93-\uDD97\uDDA0-\uDDA9\uDEF3-\uDEF6]|\uD81A[\uDE60-\uDE69\uDEF0-\uDEF4\uDF30-\uDF36\uDF50-\uDF59]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDCD0-\uDCD6\uDD44-\uDD4A\uDD50-\uDD59]|\uDB40[\uDD00-\uDDEF]/;
            return isIdentifierStart3(ch2) || ch2 >= 48 && ch2 <= 57 || ch2 >= 128 && NonAsciiIdentifierPartOnly.test(fromCodePoint(ch2));
          }
          function parseIdentityEscape() {
            var tmp;
            var l2 = lookahead2();
            if (isUnicodeMode && /[\^\$\.\*\+\?\(\)\\\[\]\{\}\|\/]/.test(l2) || !isUnicodeMode && l2 !== "c") {
              if (l2 === "k" && features2.lookbehind) {
                return null;
              }
              tmp = incr();
              return createEscaped("identifier", tmp.charCodeAt(0), tmp, 1);
            }
            return null;
          }
          function parseCharacterClass() {
            var res2, from2 = pos;
            if (res2 = matchReg(/^\[\^/)) {
              res2 = parseClassRanges();
              skip2("]");
              return createCharacterClass(res2, true, from2, pos);
            } else if (match("[")) {
              res2 = parseClassRanges();
              skip2("]");
              return createCharacterClass(res2, false, from2, pos);
            }
            return null;
          }
          function parseClassRanges() {
            var res2;
            if (current2("]")) {
              return {
                kind: "union",
                body: []
              };
            } else if (hasUnicodeSetFlag) {
              return parseClassContents();
            } else {
              res2 = parseNonemptyClassRanges();
              if (!res2) {
                bail("nonEmptyClassRanges");
              }
              return {
                kind: "union",
                body: res2
              };
            }
          }
          function parseHelperClassRanges(atom) {
            var from2, to, res2, atomTo, dash;
            if (current2("-") && !next("]")) {
              from2 = atom.range[0];
              dash = createCharacter(match("-"));
              atomTo = parseClassAtom();
              if (!atomTo) {
                bail("classAtom");
              }
              to = pos;
              var classRanges = parseClassRanges();
              if (!classRanges) {
                bail("classRanges");
              }
              if (!("codePoint" in atom) || !("codePoint" in atomTo)) {
                if (!isUnicodeMode) {
                  res2 = [atom, dash, atomTo];
                } else {
                  bail("invalid character class");
                }
              } else {
                res2 = [createClassRange(atom, atomTo, from2, to)];
              }
              if (classRanges.type === "empty") {
                return res2;
              }
              return res2.concat(classRanges.body);
            }
            res2 = parseNonemptyClassRangesNoDash();
            if (!res2) {
              bail("nonEmptyClassRangesNoDash");
            }
            return [atom].concat(res2);
          }
          function parseNonemptyClassRanges() {
            var atom = parseClassAtom();
            if (!atom) {
              bail("classAtom");
            }
            if (current2("]")) {
              return [atom];
            }
            return parseHelperClassRanges(atom);
          }
          function parseNonemptyClassRangesNoDash() {
            var res2 = parseClassAtom();
            if (!res2) {
              bail("classAtom");
            }
            if (current2("]")) {
              return res2;
            }
            return parseHelperClassRanges(res2);
          }
          function parseClassAtom() {
            if (match("-")) {
              return createCharacter("-");
            } else {
              return parseClassAtomNoDash();
            }
          }
          function parseClassAtomNoDash() {
            var res2;
            if (res2 = matchReg(/^[^\\\]-]/)) {
              return createCharacter(res2[0]);
            } else if (match("\\")) {
              res2 = parseClassEscape();
              if (!res2) {
                bail("classEscape");
              }
              return parseUnicodeSurrogatePairEscape(res2);
            }
          }
          function parseClassContents() {
            var body = [];
            var kind;
            var operand = parseClassOperand(true);
            body.push(operand);
            if (operand.type === "classRange") {
              kind = "union";
            } else if (current2("&")) {
              kind = "intersection";
            } else if (current2("-")) {
              kind = "subtraction";
            } else {
              kind = "union";
            }
            while (!current2("]")) {
              if (kind === "intersection") {
                skip2("&");
                skip2("&");
                if (current2("&")) {
                  bail("&& cannot be followed by &. Wrap it in brackets: &&[&].");
                }
              } else if (kind === "subtraction") {
                skip2("-");
                skip2("-");
              }
              operand = parseClassOperand(kind === "union");
              body.push(operand);
            }
            return {
              kind,
              body
            };
          }
          function parseClassOperand(allowRanges) {
            var from2 = pos;
            var start2, res2;
            if (match("\\")) {
              if (res2 = parseClassEscape()) {
                start2 = res2;
              } else if (res2 = parseClassCharacterEscapedHelper()) {
                return res2;
              } else {
                bail("Invalid escape", "\\" + lookahead2(), from2);
              }
            } else if (res2 = parseClassCharacterUnescapedHelper()) {
              start2 = res2;
            } else if (res2 = parseCharacterClass()) {
              return res2;
            } else {
              bail("Invalid character", lookahead2());
            }
            if (allowRanges && current2("-") && !next("-")) {
              skip2("-");
              if (res2 = parseClassCharacter()) {
                return createClassRange(start2, res2, from2, pos);
              }
              bail("Invalid range end", lookahead2());
            }
            return start2;
          }
          function parseClassCharacter() {
            if (match("\\")) {
              if (res = parseClassCharacterEscapedHelper()) {
                return res;
              } else {
                bail("Invalid escape", "\\" + lookahead2(), from);
              }
            }
            return parseClassCharacterUnescapedHelper();
          }
          function parseClassCharacterUnescapedHelper() {
            var res2;
            if (res2 = matchReg(/^[^()[\]{}/\-\\|]/)) {
              return createCharacter(res2);
            }
          }
          function parseClassCharacterEscapedHelper() {
            if (match("b")) {
              return createEscaped("singleEscape", 8, "\\b");
            } else if (match("B")) {
              bail("\\B not possible inside of ClassContents", "", pos - 2);
            } else if (res = matchReg(/^[&\-!#%,:;<=>@_`~]/)) {
              return createEscaped("identifier", res[0].codePointAt(0), res[0]);
            } else if (res = parseCharacterEscape()) {
              return res;
            } else {
              return null;
            }
          }
          function parseClassStrings() {
            var from2 = pos - 3;
            var res2 = [];
            do {
              res2.push(parseClassString());
            } while (match("|"));
            skip2("}");
            return createClassStrings(res2, from2, pos);
          }
          function parseClassString() {
            var res2 = [], from2 = pos;
            var _char2;
            while (_char2 = parseClassCharacter()) {
              res2.push(_char2);
            }
            return createClassString(res2, from2, pos);
          }
          function bail(message, details, from2, to) {
            from2 = from2 == null ? pos : from2;
            to = to == null ? from2 : to;
            var contextStart = Math.max(0, from2 - 10);
            var contextEnd = Math.min(to + 10, str.length);
            var context = "    " + str.substring(contextStart, contextEnd);
            var pointer = "    " + new Array(from2 - contextStart + 1).join(" ") + "^";
            throw SyntaxError(message + " at position " + from2 + (details ? ": " + details : "") + "\n" + context + "\n" + pointer);
          }
          var backrefDenied = [];
          var closedCaptureCounter = 0;
          var firstIteration = true;
          var shouldReparse = false;
          var hasUnicodeFlag = (flags || "").indexOf("u") !== -1;
          var hasUnicodeSetFlag = (flags || "").indexOf("v") !== -1;
          var isUnicodeMode = hasUnicodeFlag || hasUnicodeSetFlag;
          var pos = 0;
          if (hasUnicodeSetFlag && !features2.unicodeSet) {
            throw new Error('The "v" flag is only supported when the .unicodeSet option is enabled.');
          }
          if (hasUnicodeFlag && hasUnicodeSetFlag) {
            throw new Error('The "u" and "v" flags are mutually exclusive.');
          }
          str = String(str);
          if (str === "") {
            str = "(?:)";
          }
          var result = parseDisjunction();
          if (result.range[1] !== str.length) {
            bail("Could not parse entire input - got stuck", "", result.range[1]);
          }
          shouldReparse = shouldReparse || backrefDenied.some(function(ref2) {
            return ref2 <= closedCaptureCounter;
          });
          if (shouldReparse) {
            pos = 0;
            firstIteration = false;
            return parseDisjunction();
          }
          return result;
        }
        var regjsparser = {
          parse: parse5
        };
        if (module2.exports) {
          module2.exports = regjsparser;
        } else {
          window.regjsparser = regjsparser;
        }
      })();
    })(parser);
    var unicodeCanonicalPropertyNamesEcmascript = /* @__PURE__ */ new Set(["General_Category", "Script", "Script_Extensions", "Alphabetic", "Any", "ASCII", "ASCII_Hex_Digit", "Assigned", "Bidi_Control", "Bidi_Mirrored", "Case_Ignorable", "Cased", "Changes_When_Casefolded", "Changes_When_Casemapped", "Changes_When_Lowercased", "Changes_When_NFKC_Casefolded", "Changes_When_Titlecased", "Changes_When_Uppercased", "Dash", "Default_Ignorable_Code_Point", "Deprecated", "Diacritic", "Emoji", "Emoji_Component", "Emoji_Modifier", "Emoji_Modifier_Base", "Emoji_Presentation", "Extended_Pictographic", "Extender", "Grapheme_Base", "Grapheme_Extend", "Hex_Digit", "ID_Continue", "ID_Start", "Ideographic", "IDS_Binary_Operator", "IDS_Trinary_Operator", "Join_Control", "Logical_Order_Exception", "Lowercase", "Math", "Noncharacter_Code_Point", "Pattern_Syntax", "Pattern_White_Space", "Quotation_Mark", "Radical", "Regional_Indicator", "Sentence_Terminal", "Soft_Dotted", "Terminal_Punctuation", "Unified_Ideograph", "Uppercase", "Variation_Selector", "White_Space", "XID_Continue", "XID_Start"]);
    var unicodePropertyAliasesEcmascript = /* @__PURE__ */ new Map([["scx", "Script_Extensions"], ["sc", "Script"], ["gc", "General_Category"], ["AHex", "ASCII_Hex_Digit"], ["Alpha", "Alphabetic"], ["Bidi_C", "Bidi_Control"], ["Bidi_M", "Bidi_Mirrored"], ["Cased", "Cased"], ["CI", "Case_Ignorable"], ["CWCF", "Changes_When_Casefolded"], ["CWCM", "Changes_When_Casemapped"], ["CWKCF", "Changes_When_NFKC_Casefolded"], ["CWL", "Changes_When_Lowercased"], ["CWT", "Changes_When_Titlecased"], ["CWU", "Changes_When_Uppercased"], ["Dash", "Dash"], ["Dep", "Deprecated"], ["DI", "Default_Ignorable_Code_Point"], ["Dia", "Diacritic"], ["EBase", "Emoji_Modifier_Base"], ["EComp", "Emoji_Component"], ["EMod", "Emoji_Modifier"], ["Emoji", "Emoji"], ["EPres", "Emoji_Presentation"], ["Ext", "Extender"], ["ExtPict", "Extended_Pictographic"], ["Gr_Base", "Grapheme_Base"], ["Gr_Ext", "Grapheme_Extend"], ["Hex", "Hex_Digit"], ["IDC", "ID_Continue"], ["Ideo", "Ideographic"], ["IDS", "ID_Start"], ["IDSB", "IDS_Binary_Operator"], ["IDST", "IDS_Trinary_Operator"], ["Join_C", "Join_Control"], ["LOE", "Logical_Order_Exception"], ["Lower", "Lowercase"], ["Math", "Math"], ["NChar", "Noncharacter_Code_Point"], ["Pat_Syn", "Pattern_Syntax"], ["Pat_WS", "Pattern_White_Space"], ["QMark", "Quotation_Mark"], ["Radical", "Radical"], ["RI", "Regional_Indicator"], ["SD", "Soft_Dotted"], ["STerm", "Sentence_Terminal"], ["Term", "Terminal_Punctuation"], ["UIdeo", "Unified_Ideograph"], ["Upper", "Uppercase"], ["VS", "Variation_Selector"], ["WSpace", "White_Space"], ["space", "White_Space"], ["XIDC", "XID_Continue"], ["XIDS", "XID_Start"]]);
    var canonicalProperties = unicodeCanonicalPropertyNamesEcmascript;
    var propertyAliases = unicodePropertyAliasesEcmascript;
    var matchProperty = function matchProperty2(property2) {
      if (canonicalProperties.has(property2)) {
        return property2;
      }
      if (propertyAliases.has(property2)) {
        return propertyAliases.get(property2);
      }
      throw new Error("Unknown property: " + property2);
    };
    var unicodeMatchPropertyEcmascript = matchProperty;
    var mappings = /* @__PURE__ */ new Map([["General_Category", /* @__PURE__ */ new Map([["C", "Other"], ["Cc", "Control"], ["cntrl", "Control"], ["Cf", "Format"], ["Cn", "Unassigned"], ["Co", "Private_Use"], ["Cs", "Surrogate"], ["L", "Letter"], ["LC", "Cased_Letter"], ["Ll", "Lowercase_Letter"], ["Lm", "Modifier_Letter"], ["Lo", "Other_Letter"], ["Lt", "Titlecase_Letter"], ["Lu", "Uppercase_Letter"], ["M", "Mark"], ["Combining_Mark", "Mark"], ["Mc", "Spacing_Mark"], ["Me", "Enclosing_Mark"], ["Mn", "Nonspacing_Mark"], ["N", "Number"], ["Nd", "Decimal_Number"], ["digit", "Decimal_Number"], ["Nl", "Letter_Number"], ["No", "Other_Number"], ["P", "Punctuation"], ["punct", "Punctuation"], ["Pc", "Connector_Punctuation"], ["Pd", "Dash_Punctuation"], ["Pe", "Close_Punctuation"], ["Pf", "Final_Punctuation"], ["Pi", "Initial_Punctuation"], ["Po", "Other_Punctuation"], ["Ps", "Open_Punctuation"], ["S", "Symbol"], ["Sc", "Currency_Symbol"], ["Sk", "Modifier_Symbol"], ["Sm", "Math_Symbol"], ["So", "Other_Symbol"], ["Z", "Separator"], ["Zl", "Line_Separator"], ["Zp", "Paragraph_Separator"], ["Zs", "Space_Separator"], ["Other", "Other"], ["Control", "Control"], ["Format", "Format"], ["Unassigned", "Unassigned"], ["Private_Use", "Private_Use"], ["Surrogate", "Surrogate"], ["Letter", "Letter"], ["Cased_Letter", "Cased_Letter"], ["Lowercase_Letter", "Lowercase_Letter"], ["Modifier_Letter", "Modifier_Letter"], ["Other_Letter", "Other_Letter"], ["Titlecase_Letter", "Titlecase_Letter"], ["Uppercase_Letter", "Uppercase_Letter"], ["Mark", "Mark"], ["Spacing_Mark", "Spacing_Mark"], ["Enclosing_Mark", "Enclosing_Mark"], ["Nonspacing_Mark", "Nonspacing_Mark"], ["Number", "Number"], ["Decimal_Number", "Decimal_Number"], ["Letter_Number", "Letter_Number"], ["Other_Number", "Other_Number"], ["Punctuation", "Punctuation"], ["Connector_Punctuation", "Connector_Punctuation"], ["Dash_Punctuation", "Dash_Punctuation"], ["Close_Punctuation", "Close_Punctuation"], ["Final_Punctuation", "Final_Punctuation"], ["Initial_Punctuation", "Initial_Punctuation"], ["Other_Punctuation", "Other_Punctuation"], ["Open_Punctuation", "Open_Punctuation"], ["Symbol", "Symbol"], ["Currency_Symbol", "Currency_Symbol"], ["Modifier_Symbol", "Modifier_Symbol"], ["Math_Symbol", "Math_Symbol"], ["Other_Symbol", "Other_Symbol"], ["Separator", "Separator"], ["Line_Separator", "Line_Separator"], ["Paragraph_Separator", "Paragraph_Separator"], ["Space_Separator", "Space_Separator"]])], ["Script", /* @__PURE__ */ new Map([["Adlm", "Adlam"], ["Aghb", "Caucasian_Albanian"], ["Ahom", "Ahom"], ["Arab", "Arabic"], ["Armi", "Imperial_Aramaic"], ["Armn", "Armenian"], ["Avst", "Avestan"], ["Bali", "Balinese"], ["Bamu", "Bamum"], ["Bass", "Bassa_Vah"], ["Batk", "Batak"], ["Beng", "Bengali"], ["Bhks", "Bhaiksuki"], ["Bopo", "Bopomofo"], ["Brah", "Brahmi"], ["Brai", "Braille"], ["Bugi", "Buginese"], ["Buhd", "Buhid"], ["Cakm", "Chakma"], ["Cans", "Canadian_Aboriginal"], ["Cari", "Carian"], ["Cham", "Cham"], ["Cher", "Cherokee"], ["Chrs", "Chorasmian"], ["Copt", "Coptic"], ["Qaac", "Coptic"], ["Cpmn", "Cypro_Minoan"], ["Cprt", "Cypriot"], ["Cyrl", "Cyrillic"], ["Deva", "Devanagari"], ["Diak", "Dives_Akuru"], ["Dogr", "Dogra"], ["Dsrt", "Deseret"], ["Dupl", "Duployan"], ["Egyp", "Egyptian_Hieroglyphs"], ["Elba", "Elbasan"], ["Elym", "Elymaic"], ["Ethi", "Ethiopic"], ["Geor", "Georgian"], ["Glag", "Glagolitic"], ["Gong", "Gunjala_Gondi"], ["Gonm", "Masaram_Gondi"], ["Goth", "Gothic"], ["Gran", "Grantha"], ["Grek", "Greek"], ["Gujr", "Gujarati"], ["Guru", "Gurmukhi"], ["Hang", "Hangul"], ["Hani", "Han"], ["Hano", "Hanunoo"], ["Hatr", "Hatran"], ["Hebr", "Hebrew"], ["Hira", "Hiragana"], ["Hluw", "Anatolian_Hieroglyphs"], ["Hmng", "Pahawh_Hmong"], ["Hmnp", "Nyiakeng_Puachue_Hmong"], ["Hrkt", "Katakana_Or_Hiragana"], ["Hung", "Old_Hungarian"], ["Ital", "Old_Italic"], ["Java", "Javanese"], ["Kali", "Kayah_Li"], ["Kana", "Katakana"], ["Khar", "Kharoshthi"], ["Khmr", "Khmer"], ["Khoj", "Khojki"], ["Kits", "Khitan_Small_Script"], ["Knda", "Kannada"], ["Kthi", "Kaithi"], ["Lana", "Tai_Tham"], ["Laoo", "Lao"], ["Latn", "Latin"], ["Lepc", "Lepcha"], ["Limb", "Limbu"], ["Lina", "Linear_A"], ["Linb", "Linear_B"], ["Lisu", "Lisu"], ["Lyci", "Lycian"], ["Lydi", "Lydian"], ["Mahj", "Mahajani"], ["Maka", "Makasar"], ["Mand", "Mandaic"], ["Mani", "Manichaean"], ["Marc", "Marchen"], ["Medf", "Medefaidrin"], ["Mend", "Mende_Kikakui"], ["Merc", "Meroitic_Cursive"], ["Mero", "Meroitic_Hieroglyphs"], ["Mlym", "Malayalam"], ["Modi", "Modi"], ["Mong", "Mongolian"], ["Mroo", "Mro"], ["Mtei", "Meetei_Mayek"], ["Mult", "Multani"], ["Mymr", "Myanmar"], ["Nand", "Nandinagari"], ["Narb", "Old_North_Arabian"], ["Nbat", "Nabataean"], ["Newa", "Newa"], ["Nkoo", "Nko"], ["Nshu", "Nushu"], ["Ogam", "Ogham"], ["Olck", "Ol_Chiki"], ["Orkh", "Old_Turkic"], ["Orya", "Oriya"], ["Osge", "Osage"], ["Osma", "Osmanya"], ["Ougr", "Old_Uyghur"], ["Palm", "Palmyrene"], ["Pauc", "Pau_Cin_Hau"], ["Perm", "Old_Permic"], ["Phag", "Phags_Pa"], ["Phli", "Inscriptional_Pahlavi"], ["Phlp", "Psalter_Pahlavi"], ["Phnx", "Phoenician"], ["Plrd", "Miao"], ["Prti", "Inscriptional_Parthian"], ["Rjng", "Rejang"], ["Rohg", "Hanifi_Rohingya"], ["Runr", "Runic"], ["Samr", "Samaritan"], ["Sarb", "Old_South_Arabian"], ["Saur", "Saurashtra"], ["Sgnw", "SignWriting"], ["Shaw", "Shavian"], ["Shrd", "Sharada"], ["Sidd", "Siddham"], ["Sind", "Khudawadi"], ["Sinh", "Sinhala"], ["Sogd", "Sogdian"], ["Sogo", "Old_Sogdian"], ["Sora", "Sora_Sompeng"], ["Soyo", "Soyombo"], ["Sund", "Sundanese"], ["Sylo", "Syloti_Nagri"], ["Syrc", "Syriac"], ["Tagb", "Tagbanwa"], ["Takr", "Takri"], ["Tale", "Tai_Le"], ["Talu", "New_Tai_Lue"], ["Taml", "Tamil"], ["Tang", "Tangut"], ["Tavt", "Tai_Viet"], ["Telu", "Telugu"], ["Tfng", "Tifinagh"], ["Tglg", "Tagalog"], ["Thaa", "Thaana"], ["Thai", "Thai"], ["Tibt", "Tibetan"], ["Tirh", "Tirhuta"], ["Tnsa", "Tangsa"], ["Toto", "Toto"], ["Ugar", "Ugaritic"], ["Vaii", "Vai"], ["Vith", "Vithkuqi"], ["Wara", "Warang_Citi"], ["Wcho", "Wancho"], ["Xpeo", "Old_Persian"], ["Xsux", "Cuneiform"], ["Yezi", "Yezidi"], ["Yiii", "Yi"], ["Zanb", "Zanabazar_Square"], ["Zinh", "Inherited"], ["Qaai", "Inherited"], ["Zyyy", "Common"], ["Zzzz", "Unknown"], ["Adlam", "Adlam"], ["Caucasian_Albanian", "Caucasian_Albanian"], ["Arabic", "Arabic"], ["Imperial_Aramaic", "Imperial_Aramaic"], ["Armenian", "Armenian"], ["Avestan", "Avestan"], ["Balinese", "Balinese"], ["Bamum", "Bamum"], ["Bassa_Vah", "Bassa_Vah"], ["Batak", "Batak"], ["Bengali", "Bengali"], ["Bhaiksuki", "Bhaiksuki"], ["Bopomofo", "Bopomofo"], ["Brahmi", "Brahmi"], ["Braille", "Braille"], ["Buginese", "Buginese"], ["Buhid", "Buhid"], ["Chakma", "Chakma"], ["Canadian_Aboriginal", "Canadian_Aboriginal"], ["Carian", "Carian"], ["Cherokee", "Cherokee"], ["Chorasmian", "Chorasmian"], ["Coptic", "Coptic"], ["Cypro_Minoan", "Cypro_Minoan"], ["Cypriot", "Cypriot"], ["Cyrillic", "Cyrillic"], ["Devanagari", "Devanagari"], ["Dives_Akuru", "Dives_Akuru"], ["Dogra", "Dogra"], ["Deseret", "Deseret"], ["Duployan", "Duployan"], ["Egyptian_Hieroglyphs", "Egyptian_Hieroglyphs"], ["Elbasan", "Elbasan"], ["Elymaic", "Elymaic"], ["Ethiopic", "Ethiopic"], ["Georgian", "Georgian"], ["Glagolitic", "Glagolitic"], ["Gunjala_Gondi", "Gunjala_Gondi"], ["Masaram_Gondi", "Masaram_Gondi"], ["Gothic", "Gothic"], ["Grantha", "Grantha"], ["Greek", "Greek"], ["Gujarati", "Gujarati"], ["Gurmukhi", "Gurmukhi"], ["Hangul", "Hangul"], ["Han", "Han"], ["Hanunoo", "Hanunoo"], ["Hatran", "Hatran"], ["Hebrew", "Hebrew"], ["Hiragana", "Hiragana"], ["Anatolian_Hieroglyphs", "Anatolian_Hieroglyphs"], ["Pahawh_Hmong", "Pahawh_Hmong"], ["Nyiakeng_Puachue_Hmong", "Nyiakeng_Puachue_Hmong"], ["Katakana_Or_Hiragana", "Katakana_Or_Hiragana"], ["Old_Hungarian", "Old_Hungarian"], ["Old_Italic", "Old_Italic"], ["Javanese", "Javanese"], ["Kayah_Li", "Kayah_Li"], ["Katakana", "Katakana"], ["Kharoshthi", "Kharoshthi"], ["Khmer", "Khmer"], ["Khojki", "Khojki"], ["Khitan_Small_Script", "Khitan_Small_Script"], ["Kannada", "Kannada"], ["Kaithi", "Kaithi"], ["Tai_Tham", "Tai_Tham"], ["Lao", "Lao"], ["Latin", "Latin"], ["Lepcha", "Lepcha"], ["Limbu", "Limbu"], ["Linear_A", "Linear_A"], ["Linear_B", "Linear_B"], ["Lycian", "Lycian"], ["Lydian", "Lydian"], ["Mahajani", "Mahajani"], ["Makasar", "Makasar"], ["Mandaic", "Mandaic"], ["Manichaean", "Manichaean"], ["Marchen", "Marchen"], ["Medefaidrin", "Medefaidrin"], ["Mende_Kikakui", "Mende_Kikakui"], ["Meroitic_Cursive", "Meroitic_Cursive"], ["Meroitic_Hieroglyphs", "Meroitic_Hieroglyphs"], ["Malayalam", "Malayalam"], ["Mongolian", "Mongolian"], ["Mro", "Mro"], ["Meetei_Mayek", "Meetei_Mayek"], ["Multani", "Multani"], ["Myanmar", "Myanmar"], ["Nandinagari", "Nandinagari"], ["Old_North_Arabian", "Old_North_Arabian"], ["Nabataean", "Nabataean"], ["Nko", "Nko"], ["Nushu", "Nushu"], ["Ogham", "Ogham"], ["Ol_Chiki", "Ol_Chiki"], ["Old_Turkic", "Old_Turkic"], ["Oriya", "Oriya"], ["Osage", "Osage"], ["Osmanya", "Osmanya"], ["Old_Uyghur", "Old_Uyghur"], ["Palmyrene", "Palmyrene"], ["Pau_Cin_Hau", "Pau_Cin_Hau"], ["Old_Permic", "Old_Permic"], ["Phags_Pa", "Phags_Pa"], ["Inscriptional_Pahlavi", "Inscriptional_Pahlavi"], ["Psalter_Pahlavi", "Psalter_Pahlavi"], ["Phoenician", "Phoenician"], ["Miao", "Miao"], ["Inscriptional_Parthian", "Inscriptional_Parthian"], ["Rejang", "Rejang"], ["Hanifi_Rohingya", "Hanifi_Rohingya"], ["Runic", "Runic"], ["Samaritan", "Samaritan"], ["Old_South_Arabian", "Old_South_Arabian"], ["Saurashtra", "Saurashtra"], ["SignWriting", "SignWriting"], ["Shavian", "Shavian"], ["Sharada", "Sharada"], ["Siddham", "Siddham"], ["Khudawadi", "Khudawadi"], ["Sinhala", "Sinhala"], ["Sogdian", "Sogdian"], ["Old_Sogdian", "Old_Sogdian"], ["Sora_Sompeng", "Sora_Sompeng"], ["Soyombo", "Soyombo"], ["Sundanese", "Sundanese"], ["Syloti_Nagri", "Syloti_Nagri"], ["Syriac", "Syriac"], ["Tagbanwa", "Tagbanwa"], ["Takri", "Takri"], ["Tai_Le", "Tai_Le"], ["New_Tai_Lue", "New_Tai_Lue"], ["Tamil", "Tamil"], ["Tangut", "Tangut"], ["Tai_Viet", "Tai_Viet"], ["Telugu", "Telugu"], ["Tifinagh", "Tifinagh"], ["Tagalog", "Tagalog"], ["Thaana", "Thaana"], ["Tibetan", "Tibetan"], ["Tirhuta", "Tirhuta"], ["Tangsa", "Tangsa"], ["Ugaritic", "Ugaritic"], ["Vai", "Vai"], ["Vithkuqi", "Vithkuqi"], ["Warang_Citi", "Warang_Citi"], ["Wancho", "Wancho"], ["Old_Persian", "Old_Persian"], ["Cuneiform", "Cuneiform"], ["Yezidi", "Yezidi"], ["Yi", "Yi"], ["Zanabazar_Square", "Zanabazar_Square"], ["Inherited", "Inherited"], ["Common", "Common"], ["Unknown", "Unknown"]])], ["Script_Extensions", /* @__PURE__ */ new Map([["Adlm", "Adlam"], ["Aghb", "Caucasian_Albanian"], ["Ahom", "Ahom"], ["Arab", "Arabic"], ["Armi", "Imperial_Aramaic"], ["Armn", "Armenian"], ["Avst", "Avestan"], ["Bali", "Balinese"], ["Bamu", "Bamum"], ["Bass", "Bassa_Vah"], ["Batk", "Batak"], ["Beng", "Bengali"], ["Bhks", "Bhaiksuki"], ["Bopo", "Bopomofo"], ["Brah", "Brahmi"], ["Brai", "Braille"], ["Bugi", "Buginese"], ["Buhd", "Buhid"], ["Cakm", "Chakma"], ["Cans", "Canadian_Aboriginal"], ["Cari", "Carian"], ["Cham", "Cham"], ["Cher", "Cherokee"], ["Chrs", "Chorasmian"], ["Copt", "Coptic"], ["Qaac", "Coptic"], ["Cpmn", "Cypro_Minoan"], ["Cprt", "Cypriot"], ["Cyrl", "Cyrillic"], ["Deva", "Devanagari"], ["Diak", "Dives_Akuru"], ["Dogr", "Dogra"], ["Dsrt", "Deseret"], ["Dupl", "Duployan"], ["Egyp", "Egyptian_Hieroglyphs"], ["Elba", "Elbasan"], ["Elym", "Elymaic"], ["Ethi", "Ethiopic"], ["Geor", "Georgian"], ["Glag", "Glagolitic"], ["Gong", "Gunjala_Gondi"], ["Gonm", "Masaram_Gondi"], ["Goth", "Gothic"], ["Gran", "Grantha"], ["Grek", "Greek"], ["Gujr", "Gujarati"], ["Guru", "Gurmukhi"], ["Hang", "Hangul"], ["Hani", "Han"], ["Hano", "Hanunoo"], ["Hatr", "Hatran"], ["Hebr", "Hebrew"], ["Hira", "Hiragana"], ["Hluw", "Anatolian_Hieroglyphs"], ["Hmng", "Pahawh_Hmong"], ["Hmnp", "Nyiakeng_Puachue_Hmong"], ["Hrkt", "Katakana_Or_Hiragana"], ["Hung", "Old_Hungarian"], ["Ital", "Old_Italic"], ["Java", "Javanese"], ["Kali", "Kayah_Li"], ["Kana", "Katakana"], ["Khar", "Kharoshthi"], ["Khmr", "Khmer"], ["Khoj", "Khojki"], ["Kits", "Khitan_Small_Script"], ["Knda", "Kannada"], ["Kthi", "Kaithi"], ["Lana", "Tai_Tham"], ["Laoo", "Lao"], ["Latn", "Latin"], ["Lepc", "Lepcha"], ["Limb", "Limbu"], ["Lina", "Linear_A"], ["Linb", "Linear_B"], ["Lisu", "Lisu"], ["Lyci", "Lycian"], ["Lydi", "Lydian"], ["Mahj", "Mahajani"], ["Maka", "Makasar"], ["Mand", "Mandaic"], ["Mani", "Manichaean"], ["Marc", "Marchen"], ["Medf", "Medefaidrin"], ["Mend", "Mende_Kikakui"], ["Merc", "Meroitic_Cursive"], ["Mero", "Meroitic_Hieroglyphs"], ["Mlym", "Malayalam"], ["Modi", "Modi"], ["Mong", "Mongolian"], ["Mroo", "Mro"], ["Mtei", "Meetei_Mayek"], ["Mult", "Multani"], ["Mymr", "Myanmar"], ["Nand", "Nandinagari"], ["Narb", "Old_North_Arabian"], ["Nbat", "Nabataean"], ["Newa", "Newa"], ["Nkoo", "Nko"], ["Nshu", "Nushu"], ["Ogam", "Ogham"], ["Olck", "Ol_Chiki"], ["Orkh", "Old_Turkic"], ["Orya", "Oriya"], ["Osge", "Osage"], ["Osma", "Osmanya"], ["Ougr", "Old_Uyghur"], ["Palm", "Palmyrene"], ["Pauc", "Pau_Cin_Hau"], ["Perm", "Old_Permic"], ["Phag", "Phags_Pa"], ["Phli", "Inscriptional_Pahlavi"], ["Phlp", "Psalter_Pahlavi"], ["Phnx", "Phoenician"], ["Plrd", "Miao"], ["Prti", "Inscriptional_Parthian"], ["Rjng", "Rejang"], ["Rohg", "Hanifi_Rohingya"], ["Runr", "Runic"], ["Samr", "Samaritan"], ["Sarb", "Old_South_Arabian"], ["Saur", "Saurashtra"], ["Sgnw", "SignWriting"], ["Shaw", "Shavian"], ["Shrd", "Sharada"], ["Sidd", "Siddham"], ["Sind", "Khudawadi"], ["Sinh", "Sinhala"], ["Sogd", "Sogdian"], ["Sogo", "Old_Sogdian"], ["Sora", "Sora_Sompeng"], ["Soyo", "Soyombo"], ["Sund", "Sundanese"], ["Sylo", "Syloti_Nagri"], ["Syrc", "Syriac"], ["Tagb", "Tagbanwa"], ["Takr", "Takri"], ["Tale", "Tai_Le"], ["Talu", "New_Tai_Lue"], ["Taml", "Tamil"], ["Tang", "Tangut"], ["Tavt", "Tai_Viet"], ["Telu", "Telugu"], ["Tfng", "Tifinagh"], ["Tglg", "Tagalog"], ["Thaa", "Thaana"], ["Thai", "Thai"], ["Tibt", "Tibetan"], ["Tirh", "Tirhuta"], ["Tnsa", "Tangsa"], ["Toto", "Toto"], ["Ugar", "Ugaritic"], ["Vaii", "Vai"], ["Vith", "Vithkuqi"], ["Wara", "Warang_Citi"], ["Wcho", "Wancho"], ["Xpeo", "Old_Persian"], ["Xsux", "Cuneiform"], ["Yezi", "Yezidi"], ["Yiii", "Yi"], ["Zanb", "Zanabazar_Square"], ["Zinh", "Inherited"], ["Qaai", "Inherited"], ["Zyyy", "Common"], ["Zzzz", "Unknown"], ["Adlam", "Adlam"], ["Caucasian_Albanian", "Caucasian_Albanian"], ["Arabic", "Arabic"], ["Imperial_Aramaic", "Imperial_Aramaic"], ["Armenian", "Armenian"], ["Avestan", "Avestan"], ["Balinese", "Balinese"], ["Bamum", "Bamum"], ["Bassa_Vah", "Bassa_Vah"], ["Batak", "Batak"], ["Bengali", "Bengali"], ["Bhaiksuki", "Bhaiksuki"], ["Bopomofo", "Bopomofo"], ["Brahmi", "Brahmi"], ["Braille", "Braille"], ["Buginese", "Buginese"], ["Buhid", "Buhid"], ["Chakma", "Chakma"], ["Canadian_Aboriginal", "Canadian_Aboriginal"], ["Carian", "Carian"], ["Cherokee", "Cherokee"], ["Chorasmian", "Chorasmian"], ["Coptic", "Coptic"], ["Cypro_Minoan", "Cypro_Minoan"], ["Cypriot", "Cypriot"], ["Cyrillic", "Cyrillic"], ["Devanagari", "Devanagari"], ["Dives_Akuru", "Dives_Akuru"], ["Dogra", "Dogra"], ["Deseret", "Deseret"], ["Duployan", "Duployan"], ["Egyptian_Hieroglyphs", "Egyptian_Hieroglyphs"], ["Elbasan", "Elbasan"], ["Elymaic", "Elymaic"], ["Ethiopic", "Ethiopic"], ["Georgian", "Georgian"], ["Glagolitic", "Glagolitic"], ["Gunjala_Gondi", "Gunjala_Gondi"], ["Masaram_Gondi", "Masaram_Gondi"], ["Gothic", "Gothic"], ["Grantha", "Grantha"], ["Greek", "Greek"], ["Gujarati", "Gujarati"], ["Gurmukhi", "Gurmukhi"], ["Hangul", "Hangul"], ["Han", "Han"], ["Hanunoo", "Hanunoo"], ["Hatran", "Hatran"], ["Hebrew", "Hebrew"], ["Hiragana", "Hiragana"], ["Anatolian_Hieroglyphs", "Anatolian_Hieroglyphs"], ["Pahawh_Hmong", "Pahawh_Hmong"], ["Nyiakeng_Puachue_Hmong", "Nyiakeng_Puachue_Hmong"], ["Katakana_Or_Hiragana", "Katakana_Or_Hiragana"], ["Old_Hungarian", "Old_Hungarian"], ["Old_Italic", "Old_Italic"], ["Javanese", "Javanese"], ["Kayah_Li", "Kayah_Li"], ["Katakana", "Katakana"], ["Kharoshthi", "Kharoshthi"], ["Khmer", "Khmer"], ["Khojki", "Khojki"], ["Khitan_Small_Script", "Khitan_Small_Script"], ["Kannada", "Kannada"], ["Kaithi", "Kaithi"], ["Tai_Tham", "Tai_Tham"], ["Lao", "Lao"], ["Latin", "Latin"], ["Lepcha", "Lepcha"], ["Limbu", "Limbu"], ["Linear_A", "Linear_A"], ["Linear_B", "Linear_B"], ["Lycian", "Lycian"], ["Lydian", "Lydian"], ["Mahajani", "Mahajani"], ["Makasar", "Makasar"], ["Mandaic", "Mandaic"], ["Manichaean", "Manichaean"], ["Marchen", "Marchen"], ["Medefaidrin", "Medefaidrin"], ["Mende_Kikakui", "Mende_Kikakui"], ["Meroitic_Cursive", "Meroitic_Cursive"], ["Meroitic_Hieroglyphs", "Meroitic_Hieroglyphs"], ["Malayalam", "Malayalam"], ["Mongolian", "Mongolian"], ["Mro", "Mro"], ["Meetei_Mayek", "Meetei_Mayek"], ["Multani", "Multani"], ["Myanmar", "Myanmar"], ["Nandinagari", "Nandinagari"], ["Old_North_Arabian", "Old_North_Arabian"], ["Nabataean", "Nabataean"], ["Nko", "Nko"], ["Nushu", "Nushu"], ["Ogham", "Ogham"], ["Ol_Chiki", "Ol_Chiki"], ["Old_Turkic", "Old_Turkic"], ["Oriya", "Oriya"], ["Osage", "Osage"], ["Osmanya", "Osmanya"], ["Old_Uyghur", "Old_Uyghur"], ["Palmyrene", "Palmyrene"], ["Pau_Cin_Hau", "Pau_Cin_Hau"], ["Old_Permic", "Old_Permic"], ["Phags_Pa", "Phags_Pa"], ["Inscriptional_Pahlavi", "Inscriptional_Pahlavi"], ["Psalter_Pahlavi", "Psalter_Pahlavi"], ["Phoenician", "Phoenician"], ["Miao", "Miao"], ["Inscriptional_Parthian", "Inscriptional_Parthian"], ["Rejang", "Rejang"], ["Hanifi_Rohingya", "Hanifi_Rohingya"], ["Runic", "Runic"], ["Samaritan", "Samaritan"], ["Old_South_Arabian", "Old_South_Arabian"], ["Saurashtra", "Saurashtra"], ["SignWriting", "SignWriting"], ["Shavian", "Shavian"], ["Sharada", "Sharada"], ["Siddham", "Siddham"], ["Khudawadi", "Khudawadi"], ["Sinhala", "Sinhala"], ["Sogdian", "Sogdian"], ["Old_Sogdian", "Old_Sogdian"], ["Sora_Sompeng", "Sora_Sompeng"], ["Soyombo", "Soyombo"], ["Sundanese", "Sundanese"], ["Syloti_Nagri", "Syloti_Nagri"], ["Syriac", "Syriac"], ["Tagbanwa", "Tagbanwa"], ["Takri", "Takri"], ["Tai_Le", "Tai_Le"], ["New_Tai_Lue", "New_Tai_Lue"], ["Tamil", "Tamil"], ["Tangut", "Tangut"], ["Tai_Viet", "Tai_Viet"], ["Telugu", "Telugu"], ["Tifinagh", "Tifinagh"], ["Tagalog", "Tagalog"], ["Thaana", "Thaana"], ["Tibetan", "Tibetan"], ["Tirhuta", "Tirhuta"], ["Tangsa", "Tangsa"], ["Ugaritic", "Ugaritic"], ["Vai", "Vai"], ["Vithkuqi", "Vithkuqi"], ["Warang_Citi", "Warang_Citi"], ["Wancho", "Wancho"], ["Old_Persian", "Old_Persian"], ["Cuneiform", "Cuneiform"], ["Yezidi", "Yezidi"], ["Yi", "Yi"], ["Zanabazar_Square", "Zanabazar_Square"], ["Inherited", "Inherited"], ["Common", "Common"], ["Unknown", "Unknown"]])]]);
    var propertyToValueAliases = mappings;
    var matchPropertyValue = function matchPropertyValue2(property2, value) {
      var aliasToValue = propertyToValueAliases.get(property2);
      if (!aliasToValue) {
        throw new Error("Unknown property `" + property2 + "`.");
      }
      var canonicalValue = aliasToValue.get(value);
      if (canonicalValue) {
        return canonicalValue;
      }
      throw new Error("Unknown value `" + value + "` for property `" + property2 + "`.");
    };
    var unicodeMatchPropertyValueEcmascript = matchPropertyValue;
    var iuMappings$1 = /* @__PURE__ */ new Map([[75, 8490], [83, 383], [107, 8490], [115, 383], [181, 924], [197, 8491], [223, 7838], [229, 8491], [383, 83], [452, 453], [453, 452], [455, 456], [456, 455], [458, 459], [459, 458], [497, 498], [498, 497], [837, 8126], [914, 976], [917, 1013], [920, 1012], [921, 8126], [922, 1008], [924, 181], [928, 982], [929, 1009], [931, 962], [934, 981], [937, 8486], [952, 1012], [962, 931], [969, 8486], [976, 914], [977, 1012], [981, 934], [982, 928], [1008, 922], [1009, 929], [1012, [920, 977, 952]], [1013, 917], [1042, 7296], [1044, 7297], [1054, 7298], [1057, 7299], [1058, 7301], [1066, 7302], [1122, 7303], [7296, 1042], [7297, 1044], [7298, 1054], [7299, 1057], [7300, 7301], [7301, [1058, 7300]], [7302, 1066], [7303, 1122], [7304, 42570], [7776, 7835], [7835, 7776], [7838, 223], [8064, 8072], [8065, 8073], [8066, 8074], [8067, 8075], [8068, 8076], [8069, 8077], [8070, 8078], [8071, 8079], [8072, 8064], [8073, 8065], [8074, 8066], [8075, 8067], [8076, 8068], [8077, 8069], [8078, 8070], [8079, 8071], [8080, 8088], [8081, 8089], [8082, 8090], [8083, 8091], [8084, 8092], [8085, 8093], [8086, 8094], [8087, 8095], [8088, 8080], [8089, 8081], [8090, 8082], [8091, 8083], [8092, 8084], [8093, 8085], [8094, 8086], [8095, 8087], [8096, 8104], [8097, 8105], [8098, 8106], [8099, 8107], [8100, 8108], [8101, 8109], [8102, 8110], [8103, 8111], [8104, 8096], [8105, 8097], [8106, 8098], [8107, 8099], [8108, 8100], [8109, 8101], [8110, 8102], [8111, 8103], [8115, 8124], [8124, 8115], [8126, [837, 921]], [8131, 8140], [8140, 8131], [8179, 8188], [8188, 8179], [8486, [937, 969]], [8490, 75], [8491, [197, 229]], [11311, 11359], [11359, 11311], [42570, 7304], [42944, 42945], [42945, 42944], [42960, 42961], [42961, 42960], [42966, 42967], [42967, 42966], [42968, 42969], [42969, 42968], [66560, 66600], [66561, 66601], [66562, 66602], [66563, 66603], [66564, 66604], [66565, 66605], [66566, 66606], [66567, 66607], [66568, 66608], [66569, 66609], [66570, 66610], [66571, 66611], [66572, 66612], [66573, 66613], [66574, 66614], [66575, 66615], [66576, 66616], [66577, 66617], [66578, 66618], [66579, 66619], [66580, 66620], [66581, 66621], [66582, 66622], [66583, 66623], [66584, 66624], [66585, 66625], [66586, 66626], [66587, 66627], [66588, 66628], [66589, 66629], [66590, 66630], [66591, 66631], [66592, 66632], [66593, 66633], [66594, 66634], [66595, 66635], [66596, 66636], [66597, 66637], [66598, 66638], [66599, 66639], [66600, 66560], [66601, 66561], [66602, 66562], [66603, 66563], [66604, 66564], [66605, 66565], [66606, 66566], [66607, 66567], [66608, 66568], [66609, 66569], [66610, 66570], [66611, 66571], [66612, 66572], [66613, 66573], [66614, 66574], [66615, 66575], [66616, 66576], [66617, 66577], [66618, 66578], [66619, 66579], [66620, 66580], [66621, 66581], [66622, 66582], [66623, 66583], [66624, 66584], [66625, 66585], [66626, 66586], [66627, 66587], [66628, 66588], [66629, 66589], [66630, 66590], [66631, 66591], [66632, 66592], [66633, 66593], [66634, 66594], [66635, 66595], [66636, 66596], [66637, 66597], [66638, 66598], [66639, 66599], [66736, 66776], [66737, 66777], [66738, 66778], [66739, 66779], [66740, 66780], [66741, 66781], [66742, 66782], [66743, 66783], [66744, 66784], [66745, 66785], [66746, 66786], [66747, 66787], [66748, 66788], [66749, 66789], [66750, 66790], [66751, 66791], [66752, 66792], [66753, 66793], [66754, 66794], [66755, 66795], [66756, 66796], [66757, 66797], [66758, 66798], [66759, 66799], [66760, 66800], [66761, 66801], [66762, 66802], [66763, 66803], [66764, 66804], [66765, 66805], [66766, 66806], [66767, 66807], [66768, 66808], [66769, 66809], [66770, 66810], [66771, 66811], [66776, 66736], [66777, 66737], [66778, 66738], [66779, 66739], [66780, 66740], [66781, 66741], [66782, 66742], [66783, 66743], [66784, 66744], [66785, 66745], [66786, 66746], [66787, 66747], [66788, 66748], [66789, 66749], [66790, 66750], [66791, 66751], [66792, 66752], [66793, 66753], [66794, 66754], [66795, 66755], [66796, 66756], [66797, 66757], [66798, 66758], [66799, 66759], [66800, 66760], [66801, 66761], [66802, 66762], [66803, 66763], [66804, 66764], [66805, 66765], [66806, 66766], [66807, 66767], [66808, 66768], [66809, 66769], [66810, 66770], [66811, 66771], [66928, 66967], [66929, 66968], [66930, 66969], [66931, 66970], [66932, 66971], [66933, 66972], [66934, 66973], [66935, 66974], [66936, 66975], [66937, 66976], [66938, 66977], [66940, 66979], [66941, 66980], [66942, 66981], [66943, 66982], [66944, 66983], [66945, 66984], [66946, 66985], [66947, 66986], [66948, 66987], [66949, 66988], [66950, 66989], [66951, 66990], [66952, 66991], [66953, 66992], [66954, 66993], [66956, 66995], [66957, 66996], [66958, 66997], [66959, 66998], [66960, 66999], [66961, 67e3], [66962, 67001], [66964, 67003], [66965, 67004], [66967, 66928], [66968, 66929], [66969, 66930], [66970, 66931], [66971, 66932], [66972, 66933], [66973, 66934], [66974, 66935], [66975, 66936], [66976, 66937], [66977, 66938], [66979, 66940], [66980, 66941], [66981, 66942], [66982, 66943], [66983, 66944], [66984, 66945], [66985, 66946], [66986, 66947], [66987, 66948], [66988, 66949], [66989, 66950], [66990, 66951], [66991, 66952], [66992, 66953], [66993, 66954], [66995, 66956], [66996, 66957], [66997, 66958], [66998, 66959], [66999, 66960], [67e3, 66961], [67001, 66962], [67003, 66964], [67004, 66965], [68736, 68800], [68737, 68801], [68738, 68802], [68739, 68803], [68740, 68804], [68741, 68805], [68742, 68806], [68743, 68807], [68744, 68808], [68745, 68809], [68746, 68810], [68747, 68811], [68748, 68812], [68749, 68813], [68750, 68814], [68751, 68815], [68752, 68816], [68753, 68817], [68754, 68818], [68755, 68819], [68756, 68820], [68757, 68821], [68758, 68822], [68759, 68823], [68760, 68824], [68761, 68825], [68762, 68826], [68763, 68827], [68764, 68828], [68765, 68829], [68766, 68830], [68767, 68831], [68768, 68832], [68769, 68833], [68770, 68834], [68771, 68835], [68772, 68836], [68773, 68837], [68774, 68838], [68775, 68839], [68776, 68840], [68777, 68841], [68778, 68842], [68779, 68843], [68780, 68844], [68781, 68845], [68782, 68846], [68783, 68847], [68784, 68848], [68785, 68849], [68786, 68850], [68800, 68736], [68801, 68737], [68802, 68738], [68803, 68739], [68804, 68740], [68805, 68741], [68806, 68742], [68807, 68743], [68808, 68744], [68809, 68745], [68810, 68746], [68811, 68747], [68812, 68748], [68813, 68749], [68814, 68750], [68815, 68751], [68816, 68752], [68817, 68753], [68818, 68754], [68819, 68755], [68820, 68756], [68821, 68757], [68822, 68758], [68823, 68759], [68824, 68760], [68825, 68761], [68826, 68762], [68827, 68763], [68828, 68764], [68829, 68765], [68830, 68766], [68831, 68767], [68832, 68768], [68833, 68769], [68834, 68770], [68835, 68771], [68836, 68772], [68837, 68773], [68838, 68774], [68839, 68775], [68840, 68776], [68841, 68777], [68842, 68778], [68843, 68779], [68844, 68780], [68845, 68781], [68846, 68782], [68847, 68783], [68848, 68784], [68849, 68785], [68850, 68786], [71840, 71872], [71841, 71873], [71842, 71874], [71843, 71875], [71844, 71876], [71845, 71877], [71846, 71878], [71847, 71879], [71848, 71880], [71849, 71881], [71850, 71882], [71851, 71883], [71852, 71884], [71853, 71885], [71854, 71886], [71855, 71887], [71856, 71888], [71857, 71889], [71858, 71890], [71859, 71891], [71860, 71892], [71861, 71893], [71862, 71894], [71863, 71895], [71864, 71896], [71865, 71897], [71866, 71898], [71867, 71899], [71868, 71900], [71869, 71901], [71870, 71902], [71871, 71903], [71872, 71840], [71873, 71841], [71874, 71842], [71875, 71843], [71876, 71844], [71877, 71845], [71878, 71846], [71879, 71847], [71880, 71848], [71881, 71849], [71882, 71850], [71883, 71851], [71884, 71852], [71885, 71853], [71886, 71854], [71887, 71855], [71888, 71856], [71889, 71857], [71890, 71858], [71891, 71859], [71892, 71860], [71893, 71861], [71894, 71862], [71895, 71863], [71896, 71864], [71897, 71865], [71898, 71866], [71899, 71867], [71900, 71868], [71901, 71869], [71902, 71870], [71903, 71871], [93760, 93792], [93761, 93793], [93762, 93794], [93763, 93795], [93764, 93796], [93765, 93797], [93766, 93798], [93767, 93799], [93768, 93800], [93769, 93801], [93770, 93802], [93771, 93803], [93772, 93804], [93773, 93805], [93774, 93806], [93775, 93807], [93776, 93808], [93777, 93809], [93778, 93810], [93779, 93811], [93780, 93812], [93781, 93813], [93782, 93814], [93783, 93815], [93784, 93816], [93785, 93817], [93786, 93818], [93787, 93819], [93788, 93820], [93789, 93821], [93790, 93822], [93791, 93823], [93792, 93760], [93793, 93761], [93794, 93762], [93795, 93763], [93796, 93764], [93797, 93765], [93798, 93766], [93799, 93767], [93800, 93768], [93801, 93769], [93802, 93770], [93803, 93771], [93804, 93772], [93805, 93773], [93806, 93774], [93807, 93775], [93808, 93776], [93809, 93777], [93810, 93778], [93811, 93779], [93812, 93780], [93813, 93781], [93814, 93782], [93815, 93783], [93816, 93784], [93817, 93785], [93818, 93786], [93819, 93787], [93820, 93788], [93821, 93789], [93822, 93790], [93823, 93791], [125184, 125218], [125185, 125219], [125186, 125220], [125187, 125221], [125188, 125222], [125189, 125223], [125190, 125224], [125191, 125225], [125192, 125226], [125193, 125227], [125194, 125228], [125195, 125229], [125196, 125230], [125197, 125231], [125198, 125232], [125199, 125233], [125200, 125234], [125201, 125235], [125202, 125236], [125203, 125237], [125204, 125238], [125205, 125239], [125206, 125240], [125207, 125241], [125208, 125242], [125209, 125243], [125210, 125244], [125211, 125245], [125212, 125246], [125213, 125247], [125214, 125248], [125215, 125249], [125216, 125250], [125217, 125251], [125218, 125184], [125219, 125185], [125220, 125186], [125221, 125187], [125222, 125188], [125223, 125189], [125224, 125190], [125225, 125191], [125226, 125192], [125227, 125193], [125228, 125194], [125229, 125195], [125230, 125196], [125231, 125197], [125232, 125198], [125233, 125199], [125234, 125200], [125235, 125201], [125236, 125202], [125237, 125203], [125238, 125204], [125239, 125205], [125240, 125206], [125241, 125207], [125242, 125208], [125243, 125209], [125244, 125210], [125245, 125211], [125246, 125212], [125247, 125213], [125248, 125214], [125249, 125215], [125250, 125216], [125251, 125217]]);
    var characterClassEscapeSets = {};
    var regenerate$1 = regenerate$2.exports;
    characterClassEscapeSets.REGULAR = /* @__PURE__ */ new Map([["d", regenerate$1().addRange(48, 57)], ["D", regenerate$1().addRange(0, 47).addRange(58, 65535)], ["s", regenerate$1(32, 160, 5760, 8239, 8287, 12288, 65279).addRange(9, 13).addRange(8192, 8202).addRange(8232, 8233)], ["S", regenerate$1().addRange(0, 8).addRange(14, 31).addRange(33, 159).addRange(161, 5759).addRange(5761, 8191).addRange(8203, 8231).addRange(8234, 8238).addRange(8240, 8286).addRange(8288, 12287).addRange(12289, 65278).addRange(65280, 65535)], ["w", regenerate$1(95).addRange(48, 57).addRange(65, 90).addRange(97, 122)], ["W", regenerate$1(96).addRange(0, 47).addRange(58, 64).addRange(91, 94).addRange(123, 65535)]]);
    characterClassEscapeSets.UNICODE = /* @__PURE__ */ new Map([["d", regenerate$1().addRange(48, 57)], ["D", regenerate$1().addRange(0, 47).addRange(58, 1114111)], ["s", regenerate$1(32, 160, 5760, 8239, 8287, 12288, 65279).addRange(9, 13).addRange(8192, 8202).addRange(8232, 8233)], ["S", regenerate$1().addRange(0, 8).addRange(14, 31).addRange(33, 159).addRange(161, 5759).addRange(5761, 8191).addRange(8203, 8231).addRange(8234, 8238).addRange(8240, 8286).addRange(8288, 12287).addRange(12289, 65278).addRange(65280, 1114111)], ["w", regenerate$1(95).addRange(48, 57).addRange(65, 90).addRange(97, 122)], ["W", regenerate$1(96).addRange(0, 47).addRange(58, 64).addRange(91, 94).addRange(123, 1114111)]]);
    characterClassEscapeSets.UNICODE_IGNORE_CASE = /* @__PURE__ */ new Map([["d", regenerate$1().addRange(48, 57)], ["D", regenerate$1().addRange(0, 47).addRange(58, 1114111)], ["s", regenerate$1(32, 160, 5760, 8239, 8287, 12288, 65279).addRange(9, 13).addRange(8192, 8202).addRange(8232, 8233)], ["S", regenerate$1().addRange(0, 8).addRange(14, 31).addRange(33, 159).addRange(161, 5759).addRange(5761, 8191).addRange(8203, 8231).addRange(8234, 8238).addRange(8240, 8286).addRange(8288, 12287).addRange(12289, 65278).addRange(65280, 1114111)], ["w", regenerate$1(95, 383, 8490).addRange(48, 57).addRange(65, 90).addRange(97, 122)], ["W", regenerate$1(96).addRange(0, 47).addRange(58, 64).addRange(91, 94).addRange(123, 382).addRange(384, 8489).addRange(8491, 1114111)]]);
    var generate2 = regjsgen.exports.generate;
    var parse$2 = parser.exports.parse;
    var regenerate = regenerate$2.exports;
    var unicodeMatchProperty = unicodeMatchPropertyEcmascript;
    var unicodeMatchPropertyValue = unicodeMatchPropertyValueEcmascript;
    var iuMappings = iuMappings$1;
    var ESCAPE_SETS = characterClassEscapeSets;
    var UNICODE_SET = regenerate().addRange(0, 1114111);
    var DOT_SET_UNICODE = UNICODE_SET.clone().remove(10, 13, 8232, 8233);
    var getCharacterClassEscapeSet = function getCharacterClassEscapeSet2(character, unicode, ignoreCase) {
      if (unicode) {
        if (ignoreCase) {
          return ESCAPE_SETS.UNICODE_IGNORE_CASE.get(character);
        }
        return ESCAPE_SETS.UNICODE.get(character);
      }
      return ESCAPE_SETS.REGULAR.get(character);
    };
    var getUnicodeDotSet = function getUnicodeDotSet2(dotAll) {
      return dotAll ? UNICODE_SET : DOT_SET_UNICODE;
    };
    var getUnicodePropertyValueSet = function getUnicodePropertyValueSet2(property2, value) {
      var path2 = value ? property2 + "/" + value : "Binary_Property/" + property2;
      try {
        return createCommonjsRequire("/node_modules/regexpu-core")("regenerate-unicode-properties/" + path2 + ".js");
      } catch (exception) {
        throw new Error("Failed to recognize value `" + value + "` for property " + ("`" + property2 + "`."));
      }
    };
    var handleLoneUnicodePropertyNameOrValue = function handleLoneUnicodePropertyNameOrValue2(value) {
      try {
        var _property = "General_Category";
        var category = unicodeMatchPropertyValue(_property, value);
        return getUnicodePropertyValueSet(_property, category);
      } catch (exception) {
      }
      try {
        return getUnicodePropertyValueSet("Property_of_Strings", value);
      } catch (exception) {
      }
      var property2 = unicodeMatchProperty(value);
      return getUnicodePropertyValueSet(property2);
    };
    var getUnicodePropertyEscapeSet = function getUnicodePropertyEscapeSet2(value, isNegative) {
      var parts = value.split("=");
      var firstPart = parts[0];
      var set3;
      if (parts.length == 1) {
        set3 = handleLoneUnicodePropertyNameOrValue(firstPart);
      } else {
        var property2 = unicodeMatchProperty(firstPart);
        var _value = unicodeMatchPropertyValue(property2, parts[1]);
        set3 = getUnicodePropertyValueSet(property2, _value);
      }
      if (isNegative) {
        if (set3.strings) {
          throw new Error("Cannot negate Unicode property of strings");
        }
        return {
          characters: UNICODE_SET.clone().remove(set3.characters),
          strings: /* @__PURE__ */ new Set()
        };
      }
      return {
        characters: set3.characters.clone(),
        strings: new Set(set3.strings || [])
      };
    };
    var getUnicodePropertyEscapeCharacterClassData = function getUnicodePropertyEscapeCharacterClassData2(property2, isNegative) {
      var set3 = getUnicodePropertyEscapeSet(property2, isNegative);
      var data3 = getCharacterClassEmptyData();
      data3.singleChars = set3.characters;
      if (set3.strings.size > 0) {
        data3.longStrings = set3.strings;
        data3.maybeIncludesStrings = true;
      }
      return data3;
    };
    regenerate.prototype.iuAddRange = function(min4, max3) {
      var $this = this;
      do {
        var folded = caseFold(min4);
        if (folded) {
          $this.add(folded);
        }
      } while (++min4 <= max3);
      return $this;
    };
    regenerate.prototype.iuRemoveRange = function(min4, max3) {
      var $this = this;
      do {
        var folded = caseFold(min4);
        if (folded) {
          $this.remove(folded);
        }
      } while (++min4 <= max3);
      return $this;
    };
    var update = function update2(item, pattern5) {
      var tree = parse$2(pattern5, config2.useUnicodeFlag ? "u" : "");
      switch (tree.type) {
        case "characterClass":
        case "group":
        case "value":
          break;
        default:
          tree = wrap(tree, pattern5);
      }
      Object.assign(item, tree);
    };
    var wrap = function wrap2(tree, pattern5) {
      return {
        "type": "group",
        "behavior": "ignore",
        "body": [tree],
        "raw": "(?:" + pattern5 + ")"
      };
    };
    var caseFold = function caseFold2(codePoint) {
      return iuMappings.get(codePoint) || false;
    };
    var buildHandler = function buildHandler2(action) {
      switch (action) {
        case "union":
          return {
            single: function single(data3, cp) {
              data3.singleChars.add(cp);
            },
            regSet: function regSet2(data3, set22) {
              data3.singleChars.add(set22);
            },
            range: function range3(data3, start2, end2) {
              data3.singleChars.addRange(start2, end2);
            },
            iuRange: function iuRange(data3, start2, end2) {
              data3.singleChars.iuAddRange(start2, end2);
            },
            nested: function nested(data3, nestedData) {
              data3.singleChars.add(nestedData.singleChars);
              for (var _iterator2 = _createForOfIteratorHelperLoose(nestedData.longStrings), _step2; !(_step2 = _iterator2()).done; ) {
                var str = _step2.value;
                data3.longStrings.add(str);
              }
              if (nestedData.maybeIncludesStrings)
                data3.maybeIncludesStrings = true;
            }
          };
        case "union-negative": {
          var regSet = function regSet2(data3, set22) {
            data3.singleChars = UNICODE_SET.clone().remove(set22).add(data3.singleChars);
          };
          return {
            single: function single(data3, cp) {
              var unicode = UNICODE_SET.clone();
              data3.singleChars = data3.singleChars.contains(cp) ? unicode : unicode.remove(cp);
            },
            regSet,
            range: function range3(data3, start2, end2) {
              data3.singleChars = UNICODE_SET.clone().removeRange(start2, end2).add(data3.singleChars);
            },
            iuRange: function iuRange(data3, start2, end2) {
              data3.singleChars = UNICODE_SET.clone().iuRemoveRange(start2, end2).add(data3.singleChars);
            },
            nested: function nested(data3, nestedData) {
              regSet(data3, nestedData.singleChars);
              if (nestedData.maybeIncludesStrings)
                throw new Error("ASSERTION ERROR");
            }
          };
        }
        case "intersection": {
          var _regSet = function _regSet3(data3, set22) {
            if (data3.first)
              data3.singleChars = set22;
            else
              data3.singleChars.intersection(set22);
          };
          return {
            single: function single(data3, cp) {
              data3.singleChars = data3.first || data3.singleChars.contains(cp) ? regenerate(cp) : regenerate();
              data3.longStrings.clear();
              data3.maybeIncludesStrings = false;
            },
            regSet: function regSet2(data3, set3) {
              _regSet(data3, set3);
              data3.longStrings.clear();
              data3.maybeIncludesStrings = false;
            },
            range: function range3(data3, start2, end2) {
              if (data3.first)
                data3.singleChars.addRange(start2, end2);
              else
                data3.singleChars.intersection(regenerate().addRange(start2, end2));
              data3.longStrings.clear();
              data3.maybeIncludesStrings = false;
            },
            iuRange: function iuRange(data3, start2, end2) {
              if (data3.first)
                data3.singleChars.iuAddRange(start2, end2);
              else
                data3.singleChars.intersection(regenerate().iuAddRange(start2, end2));
              data3.longStrings.clear();
              data3.maybeIncludesStrings = false;
            },
            nested: function nested(data3, nestedData) {
              _regSet(data3, nestedData.singleChars);
              if (data3.first) {
                data3.longStrings = nestedData.longStrings;
                data3.maybeIncludesStrings = nestedData.maybeIncludesStrings;
              } else {
                for (var _iterator2 = _createForOfIteratorHelperLoose(data3.longStrings), _step2; !(_step2 = _iterator2()).done; ) {
                  var str = _step2.value;
                  if (!nestedData.longStrings.has(str))
                    data3.longStrings["delete"](str);
                }
                if (!nestedData.maybeIncludesStrings)
                  data3.maybeIncludesStrings = false;
              }
            }
          };
        }
        case "subtraction": {
          var _regSet2 = function _regSet22(data3, set22) {
            if (data3.first)
              data3.singleChars.add(set22);
            else
              data3.singleChars.remove(set22);
          };
          return {
            single: function single(data3, cp) {
              if (data3.first)
                data3.singleChars.add(cp);
              else
                data3.singleChars.remove(cp);
            },
            regSet: _regSet2,
            range: function range3(data3, start2, end2) {
              if (data3.first)
                data3.singleChars.addRange(start2, end2);
              else
                data3.singleChars.removeRange(start2, end2);
            },
            iuRange: function iuRange(data3, start2, end2) {
              if (data3.first)
                data3.singleChars.iuAddRange(start2, end2);
              else
                data3.singleChars.iuRemoveRange(start2, end2);
            },
            nested: function nested(data3, nestedData) {
              _regSet2(data3, nestedData.singleChars);
              if (data3.first) {
                data3.longStrings = nestedData.longStrings;
                data3.maybeIncludesStrings = nestedData.maybeIncludesStrings;
              } else {
                for (var _iterator3 = _createForOfIteratorHelperLoose(data3.longStrings), _step3; !(_step3 = _iterator3()).done; ) {
                  var str = _step3.value;
                  if (nestedData.longStrings.has(str))
                    data3.longStrings["delete"](str);
                }
              }
            }
          };
        }
        default:
          throw new Error("Unknown set action: " + characterClassItem.kind);
      }
    };
    var getCharacterClassEmptyData = function getCharacterClassEmptyData2() {
      return {
        transformed: config2.transform.unicodeFlag,
        singleChars: regenerate(),
        longStrings: /* @__PURE__ */ new Set(),
        hasEmptyString: false,
        first: true,
        maybeIncludesStrings: false
      };
    };
    var maybeFold = function maybeFold2(codePoint) {
      if (config2.flags.ignoreCase && config2.transform.unicodeFlag) {
        var folded = caseFold(codePoint);
        if (folded) {
          return [codePoint, folded];
        }
      }
      return [codePoint];
    };
    var computeClassStrings = function computeClassStrings2(classStrings, regenerateOptions) {
      var data3 = getCharacterClassEmptyData();
      for (var _iterator4 = _createForOfIteratorHelperLoose(classStrings.strings), _step4; !(_step4 = _iterator4()).done; ) {
        var string3 = _step4.value;
        if (string3.characters.length === 1) {
          maybeFold(string3.characters[0].codePoint).forEach(function(cp) {
            data3.singleChars.add(cp);
          });
        } else {
          var stringifiedString = void 0;
          if (config2.flags.ignoreCase && config2.transform.unicodeFlag) {
            stringifiedString = "";
            for (var _iterator5 = _createForOfIteratorHelperLoose(string3.characters), _step5; !(_step5 = _iterator5()).done; ) {
              var ch2 = _step5.value;
              var set3 = regenerate(ch2.codePoint);
              var folded = caseFold(ch2.codePoint);
              if (folded)
                set3.add(folded);
              stringifiedString += set3.toString(regenerateOptions);
            }
          } else {
            stringifiedString = string3.characters.map(function(ch3) {
              return generate2(ch3);
            }).join("");
          }
          data3.longStrings.add(stringifiedString);
          data3.maybeIncludesStrings = true;
        }
      }
      return data3;
    };
    var computeCharacterClass = function computeCharacterClass2(characterClassItem2, regenerateOptions) {
      var data3 = getCharacterClassEmptyData();
      var handlePositive;
      var handleNegative;
      switch (characterClassItem2.kind) {
        case "union":
          handlePositive = buildHandler("union");
          handleNegative = buildHandler("union-negative");
          break;
        case "intersection":
          handlePositive = buildHandler("intersection");
          handleNegative = buildHandler("subtraction");
          break;
        case "subtraction":
          handlePositive = buildHandler("subtraction");
          handleNegative = buildHandler("intersection");
          break;
        default:
          throw new Error("Unknown character class kind: " + characterClassItem2.kind);
      }
      for (var _iterator6 = _createForOfIteratorHelperLoose(characterClassItem2.body), _step6; !(_step6 = _iterator6()).done; ) {
        var item = _step6.value;
        switch (item.type) {
          case "value":
            maybeFold(item.codePoint).forEach(function(cp) {
              handlePositive.single(data3, cp);
            });
            break;
          case "characterClassRange":
            var min4 = item.min.codePoint;
            var max3 = item.max.codePoint;
            handlePositive.range(data3, min4, max3);
            if (config2.flags.ignoreCase && config2.transform.unicodeFlag) {
              handlePositive.iuRange(data3, min4, max3);
            }
            break;
          case "characterClassEscape":
            handlePositive.regSet(data3, getCharacterClassEscapeSet(item.value, config2.flags.unicode, config2.flags.ignoreCase));
            break;
          case "unicodePropertyEscape":
            var nestedData = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);
            handlePositive.nested(data3, nestedData);
            data3.transformed = data3.transformed || config2.transform.unicodePropertyEscapes || config2.transform.unicodeSetsFlag && nestedData.maybeIncludesStrings;
            break;
          case "characterClass":
            var handler = item.negative ? handleNegative : handlePositive;
            var res2 = computeCharacterClass2(item, regenerateOptions);
            handler.nested(data3, res2);
            data3.transformed = true;
            break;
          case "classStrings":
            handlePositive.nested(data3, computeClassStrings(item, regenerateOptions));
            data3.transformed = true;
            break;
          default:
            throw new Error("Unknown term type: " + item.type);
        }
        data3.first = false;
      }
      if (characterClassItem2.negative && data3.maybeIncludesStrings) {
        throw new SyntaxError("Cannot negate set containing strings");
      }
      return data3;
    };
    var processCharacterClass = function processCharacterClass2(characterClassItem2, regenerateOptions, computed) {
      if (computed === void 0) {
        computed = computeCharacterClass(characterClassItem2, regenerateOptions);
      }
      var negative = characterClassItem2.negative;
      var _computed = computed, singleChars = _computed.singleChars, transformed = _computed.transformed, longStrings = _computed.longStrings;
      if (transformed) {
        var setStr = singleChars.toString(regenerateOptions);
        if (negative) {
          if (config2.useUnicodeFlag) {
            update(characterClassItem2, "[^" + (setStr[0] === "[" ? setStr.slice(1, -1) : setStr) + "]");
          } else {
            update(characterClassItem2, "(?!" + setStr + ")[\\s\\S]");
          }
        } else {
          var hasEmptyString = longStrings.has("");
          var pieces = Array.from(longStrings).sort(function(a, b2) {
            return b2.length - a.length;
          });
          if (setStr !== "[]" || longStrings.size === 0) {
            pieces.splice(pieces.length - (hasEmptyString ? 1 : 0), 0, setStr);
          }
          update(characterClassItem2, pieces.join("|"));
        }
      }
      return characterClassItem2;
    };
    var updateNamedReference = function updateNamedReference2(item, index3) {
      delete item.name;
      item.matchIndex = index3;
    };
    var assertNoUnmatchedReferences = function assertNoUnmatchedReferences2(groups) {
      var unmatchedReferencesNames = Object.keys(groups.unmatchedReferences);
      if (unmatchedReferencesNames.length > 0) {
        throw new Error("Unknown group names: " + unmatchedReferencesNames);
      }
    };
    var processTerm = function processTerm2(item, regenerateOptions, groups) {
      switch (item.type) {
        case "dot":
          if (config2.transform.unicodeFlag) {
            update(item, getUnicodeDotSet(config2.flags.dotAll).toString(regenerateOptions));
          } else if (config2.transform.dotAllFlag) {
            update(item, "[\\s\\S]");
          }
          break;
        case "characterClass":
          item = processCharacterClass(item, regenerateOptions);
          break;
        case "unicodePropertyEscape":
          var data3 = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);
          if (data3.maybeIncludesStrings) {
            if (!config2.flags.unicodeSets) {
              throw new Error("Properties of strings are only supported when using the unicodeSets (v) flag.");
            }
            if (config2.transform.unicodeSetsFlag) {
              data3.transformed = true;
              item = processCharacterClass(item, regenerateOptions, data3);
            }
          } else if (config2.transform.unicodePropertyEscapes) {
            update(item, data3.singleChars.toString(regenerateOptions));
          }
          break;
        case "characterClassEscape":
          if (config2.transform.unicodeFlag) {
            update(item, getCharacterClassEscapeSet(item.value, true, config2.flags.ignoreCase).toString(regenerateOptions));
          }
          break;
        case "group":
          if (item.behavior == "normal") {
            groups.lastIndex++;
          }
          if (item.name && config2.transform.namedGroups) {
            var name2 = item.name.value;
            if (groups.names[name2]) {
              throw new Error("Multiple groups with the same name (" + name2 + ") are not allowed.");
            }
            var index3 = groups.lastIndex;
            delete item.name;
            groups.names[name2] = index3;
            if (groups.onNamedGroup) {
              groups.onNamedGroup.call(null, name2, index3);
            }
            if (groups.unmatchedReferences[name2]) {
              groups.unmatchedReferences[name2].forEach(function(reference) {
                updateNamedReference(reference, index3);
              });
              delete groups.unmatchedReferences[name2];
            }
          }
        case "alternative":
        case "disjunction":
        case "quantifier":
          item.body = item.body.map(function(term) {
            return processTerm2(term, regenerateOptions, groups);
          });
          break;
        case "value":
          var codePoint = item.codePoint;
          var set3 = regenerate(codePoint);
          if (config2.flags.ignoreCase && config2.transform.unicodeFlag) {
            var folded = caseFold(codePoint);
            if (folded) {
              set3.add(folded);
            }
          }
          update(item, set3.toString(regenerateOptions));
          break;
        case "reference":
          if (item.name) {
            var _name = item.name.value;
            var _index = groups.names[_name];
            if (_index) {
              updateNamedReference(item, _index);
              break;
            }
            if (!groups.unmatchedReferences[_name]) {
              groups.unmatchedReferences[_name] = [];
            }
            groups.unmatchedReferences[_name].push(item);
          }
          break;
        case "anchor":
        case "empty":
        case "group":
          break;
        default:
          throw new Error("Unknown term type: " + item.type);
      }
      return item;
    };
    var config2 = {
      "flags": {
        "ignoreCase": false,
        "unicode": false,
        "unicodeSets": false,
        "dotAll": false
      },
      "transform": {
        "dotAllFlag": false,
        "unicodeFlag": false,
        "unicodeSetsFlag": false,
        "unicodePropertyEscapes": false,
        "namedGroups": false
      },
      get useUnicodeFlag() {
        return (this.flags.unicode || this.flags.unicodeSets) && !this.transform.unicodeFlag;
      }
    };
    var validateOptions = function validateOptions2(options) {
      if (!options)
        return;
      for (var _i3 = 0, _Object$keys3 = Object.keys(options); _i3 < _Object$keys3.length; _i3++) {
        var key2 = _Object$keys3[_i3];
        var value = options[key2];
        switch (key2) {
          case "dotAllFlag":
          case "unicodeFlag":
          case "unicodePropertyEscapes":
          case "namedGroups":
            if (value != null && value !== false && value !== "transform") {
              throw new Error("." + key2 + " must be false (default) or 'transform'.");
            }
            break;
          case "unicodeSetsFlag":
            if (value != null && value !== false && value !== "parse" && value !== "transform") {
              throw new Error("." + key2 + " must be false (default), 'parse' or 'transform'.");
            }
            break;
          case "onNamedGroup":
            if (value != null && typeof value !== "function") {
              throw new Error(".onNamedGroup must be a function.");
            }
            break;
          default:
            throw new Error("." + key2 + " is not a valid regexpu-core option.");
        }
      }
    };
    var hasFlag = function hasFlag2(flags, flag) {
      return flags ? flags.includes(flag) : false;
    };
    var transform$1 = function transform3(options, name2) {
      return options ? options[name2] === "transform" : false;
    };
    var rewritePattern = function rewritePattern2(pattern5, flags, options) {
      validateOptions(options);
      config2.flags.unicode = hasFlag(flags, "u");
      config2.flags.unicodeSets = hasFlag(flags, "v");
      config2.flags.ignoreCase = hasFlag(flags, "i");
      config2.flags.dotAll = hasFlag(flags, "s");
      config2.transform.dotAllFlag = config2.flags.dotAll && transform$1(options, "dotAllFlag");
      config2.transform.unicodeFlag = (config2.flags.unicode || config2.flags.unicodeSets) && transform$1(options, "unicodeFlag");
      config2.transform.unicodeSetsFlag = config2.flags.unicodeSets && transform$1(options, "unicodeSetsFlag");
      config2.transform.unicodePropertyEscapes = config2.flags.unicode && (transform$1(options, "unicodeFlag") || transform$1(options, "unicodePropertyEscapes"));
      config2.transform.namedGroups = transform$1(options, "namedGroups");
      var regjsparserFeatures = {
        "unicodeSet": Boolean(options && options.unicodeSetsFlag),
        "unicodePropertyEscape": true,
        "namedGroups": true,
        "lookbehind": true
      };
      var regenerateOptions = {
        "hasUnicodeFlag": config2.useUnicodeFlag,
        "bmpOnly": !config2.flags.unicode
      };
      var groups = {
        "onNamedGroup": options && options.onNamedGroup,
        "lastIndex": 0,
        "names": /* @__PURE__ */ Object.create(null),
        "unmatchedReferences": /* @__PURE__ */ Object.create(null)
      };
      var tree = parse$2(pattern5, flags, regjsparserFeatures);
      processTerm(tree, regenerateOptions, groups);
      assertNoUnmatchedReferences(groups);
      return generate2(tree);
    };
    var rewritePattern_1 = rewritePattern;
    var FEATURES = Object.freeze({
      unicodeFlag: 1 << 0,
      dotAllFlag: 1 << 1,
      unicodePropertyEscape: 1 << 2,
      namedCaptureGroups: 1 << 3,
      unicodeSetsFlag_syntax: 1 << 4,
      unicodeSetsFlag: 1 << 5
    });
    var featuresKey = "@babel/plugin-regexp-features/featuresKey";
    var runtimeKey = "@babel/plugin-regexp-features/runtimeKey";
    function enableFeature(features2, feature) {
      return features2 | feature;
    }
    function hasFeature(features2, feature) {
      return !!(features2 & feature);
    }
    function generateRegexpuOptions(toTransform) {
      var feat = function feat2(name2, ok3) {
        if (ok3 === void 0) {
          ok3 = "transform";
        }
        return hasFeature(toTransform, FEATURES[name2]) ? ok3 : false;
      };
      return {
        unicodeFlag: feat("unicodeFlag"),
        unicodeSetsFlag: feat("unicodeSetsFlag") || feat("unicodeSetsFlag_syntax", "parse"),
        dotAllFlag: feat("dotAllFlag"),
        unicodePropertyEscapes: feat("unicodePropertyEscape"),
        namedGroups: feat("namedCaptureGroups"),
        onNamedGroup: function onNamedGroup() {
        }
      };
    }
    function canSkipRegexpu(node2, options) {
      var flags = node2.flags, pattern5 = node2.pattern;
      if (flags.includes("v")) {
        if (options.unicodeSetsFlag === "transform")
          return false;
      }
      if (flags.includes("u")) {
        if (options.unicodeFlag === "transform")
          return false;
        if (options.unicodePropertyEscapes === "transform" && /\\[pP]{/.test(pattern5)) {
          return false;
        }
      }
      if (flags.includes("s")) {
        if (options.dotAllFlag === "transform")
          return false;
      }
      if (options.namedGroups === "transform" && /\(\?<(?![=!])/.test(pattern5)) {
        return false;
      }
      return true;
    }
    function transformFlags(regexpuOptions, flags) {
      if (regexpuOptions.unicodeSetsFlag === "transform") {
        flags = flags.replace("v", "u");
      }
      if (regexpuOptions.unicodeFlag === "transform") {
        flags = flags.replace("u", "");
      }
      if (regexpuOptions.dotAllFlag === "transform") {
        flags = flags.replace("s", "");
      }
      return flags;
    }
    var version$12 = "7.17.0".split(".").reduce(function(v22, x2) {
      return v22 * 1e5 + +x2;
    }, 0);
    var versionKey = "@babel/plugin-regexp-features/version";
    function createRegExpFeaturePlugin(_ref3) {
      var name2 = _ref3.name, feature = _ref3.feature, _ref$options = _ref3.options, options = _ref$options === void 0 ? {} : _ref$options, _ref$manipulateOption = _ref3.manipulateOptions, manipulateOptions = _ref$manipulateOption === void 0 ? function() {
      } : _ref$manipulateOption;
      return {
        name: name2,
        manipulateOptions,
        pre: function pre() {
          var _file$get;
          var file2 = this.file;
          var features2 = (_file$get = file2.get(featuresKey)) != null ? _file$get : 0;
          var newFeatures = enableFeature(features2, FEATURES[feature]);
          var useUnicodeFlag = options.useUnicodeFlag, _options$runtime = options.runtime, runtime3 = _options$runtime === void 0 ? true : _options$runtime;
          if (useUnicodeFlag === false) {
            newFeatures = enableFeature(newFeatures, FEATURES.unicodeFlag);
          }
          if (newFeatures !== features2) {
            file2.set(featuresKey, newFeatures);
          }
          if (!runtime3) {
            file2.set(runtimeKey, false);
          }
          if (!file2.has(versionKey) || file2.get(versionKey) < version$12) {
            file2.set(versionKey, version$12);
          }
        },
        visitor: {
          RegExpLiteral: function RegExpLiteral2(path2) {
            var _file$get2;
            var node2 = path2.node;
            var file2 = this.file;
            var features2 = file2.get(featuresKey);
            var runtime3 = (_file$get2 = file2.get(runtimeKey)) != null ? _file$get2 : true;
            var regexpuOptions = generateRegexpuOptions(features2);
            if (canSkipRegexpu(node2, regexpuOptions))
              return;
            var namedCaptureGroups = {};
            if (regexpuOptions.namedGroups === "transform") {
              regexpuOptions.onNamedGroup = function(name3, index3) {
                namedCaptureGroups[name3] = index3;
              };
            }
            node2.pattern = rewritePattern_1(node2.pattern, node2.flags, regexpuOptions);
            if (regexpuOptions.namedGroups === "transform" && Object.keys(namedCaptureGroups).length > 0 && runtime3 && !isRegExpTest(path2)) {
              var call3 = callExpression$e(this.addHelper("wrapRegExp"), [node2, valueToNode$1(namedCaptureGroups)]);
              annotateAsPure(call3);
              path2.replaceWith(call3);
            }
            node2.flags = transformFlags(regexpuOptions, node2.flags);
          }
        }
      };
    }
    function isRegExpTest(path2) {
      return path2.parentPath.isMemberExpression({
        object: path2.node,
        computed: false
      }) && path2.parentPath.get("property").isIdentifier({
        name: "test"
      });
    }
    var _proposalUnicodePropertyRegex = declare(function(api, options) {
      api.assertVersion(7);
      var _options$useUnicodeFl = options.useUnicodeFlag, useUnicodeFlag = _options$useUnicodeFl === void 0 ? true : _options$useUnicodeFl;
      if (typeof useUnicodeFlag !== "boolean") {
        throw new Error(".useUnicodeFlag must be a boolean, or undefined");
      }
      return createRegExpFeaturePlugin({
        name: "proposal-unicode-property-regex",
        feature: "unicodePropertyEscape",
        options: {
          useUnicodeFlag
        }
      });
    });
    var _transformAsyncToGenerator = declare(function(api, options) {
      api.assertVersion(7);
      var method5 = options.method, module2 = options.module;
      var noNewArrows = api.assumption("noNewArrows");
      var ignoreFunctionLength = api.assumption("ignoreFunctionLength");
      if (method5 && module2) {
        return {
          name: "transform-async-to-generator",
          visitor: {
            Function: function Function2(path2, state) {
              if (!path2.node.async || path2.node.generator)
                return;
              var wrapAsync = state.methodWrapper;
              if (wrapAsync) {
                wrapAsync = cloneNode$i(wrapAsync);
              } else {
                wrapAsync = state.methodWrapper = addNamed(path2, method5, module2);
              }
              remapAsyncToGenerator(path2, {
                wrapAsync
              }, noNewArrows, ignoreFunctionLength);
            }
          }
        };
      }
      return {
        name: "transform-async-to-generator",
        visitor: {
          Function: function Function2(path2, state) {
            if (!path2.node.async || path2.node.generator)
              return;
            remapAsyncToGenerator(path2, {
              wrapAsync: state.addHelper("asyncToGenerator")
            }, noNewArrows, ignoreFunctionLength);
          }
        }
      };
    });
    var _transformArrowFunctions = declare(function(api, options) {
      var _api$assumption;
      api.assertVersion(7);
      var noNewArrows = (_api$assumption = api.assumption("noNewArrows")) != null ? _api$assumption : !options.spec;
      return {
        name: "transform-arrow-functions",
        visitor: {
          ArrowFunctionExpression: function(_ArrowFunctionExpression) {
            function ArrowFunctionExpression2(_x) {
              return _ArrowFunctionExpression.apply(this, arguments);
            }
            ArrowFunctionExpression2.toString = function() {
              return _ArrowFunctionExpression.toString();
            };
            return ArrowFunctionExpression2;
          }(function(path2) {
            if (!path2.isArrowFunctionExpression())
              return;
            path2.arrowFunctionToExpression({
              allowInsertArrow: false,
              noNewArrows,
              specCompliant: !noNewArrows
            });
          })
        }
      };
    });
    var _transformBlockScopedFunctions = declare(function(api) {
      api.assertVersion(7);
      function statementList(key2, path2) {
        var paths = path2.get(key2);
        for (var _iterator2 = _createForOfIteratorHelperLoose(paths), _step2; !(_step2 = _iterator2()).done; ) {
          var _path = _step2.value;
          var func = _path.node;
          if (!_path.isFunctionDeclaration())
            continue;
          var declar = variableDeclaration$7("let", [variableDeclarator$7(func.id, toExpression$1(func))]);
          declar._blockHoist = 2;
          func.id = null;
          _path.replaceWith(declar);
        }
      }
      return {
        name: "transform-block-scoped-functions",
        visitor: {
          BlockStatement: function BlockStatement2(path2) {
            var node2 = path2.node, parent = path2.parent;
            if (isFunction$32(parent, {
              body: node2
            }) || isExportDeclaration$2(parent)) {
              return;
            }
            statementList("body", path2);
          },
          SwitchCase: function SwitchCase2(path2) {
            statementList("consequent", path2);
          }
        }
      };
    });
    var _templateObject$c;
    function getTDZStatus(refPath, bindingPath) {
      var executionStatus = bindingPath._guessExecutionStatusRelativeTo(refPath);
      if (executionStatus === "before") {
        return "outside";
      } else if (executionStatus === "after") {
        return "inside";
      } else {
        return "maybe";
      }
    }
    function buildTDZAssert(node2, state) {
      return callExpression$e(state.addHelper("temporalRef"), [node2, stringLiteral$8(node2.name)]);
    }
    function isReference(node2, scope2, state) {
      var declared = state.letReferences.get(node2.name);
      if (!declared)
        return false;
      return scope2.getBindingIdentifier(node2.name) === declared;
    }
    var visitedMaybeTDZNodes = /* @__PURE__ */ new WeakSet();
    var visitor = {
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        if (!state.tdzEnabled)
          return;
        var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
        if (path2.parentPath.isFor({
          left: node2
        }))
          return;
        if (!isReference(node2, scope2, state))
          return;
        var bindingPath = scope2.getBinding(node2.name).path;
        if (bindingPath.isFunctionDeclaration())
          return;
        var status = getTDZStatus(path2, bindingPath);
        if (status === "outside")
          return;
        if (status === "maybe") {
          if (visitedMaybeTDZNodes.has(node2)) {
            return;
          }
          visitedMaybeTDZNodes.add(node2);
          var assert3 = buildTDZAssert(node2, state);
          bindingPath.parent._tdzThis = true;
          if (path2.parentPath.isUpdateExpression()) {
            if (parent._ignoreBlockScopingTDZ)
              return;
            path2.parentPath.replaceWith(sequenceExpression$7([assert3, parent]));
          } else {
            path2.replaceWith(assert3);
          }
        } else if (status === "inside") {
          path2.replaceWith(template$2.ast(_templateObject$c || (_templateObject$c = _taggedTemplateLiteralLoose(["", '("', '")'])), state.addHelper("tdz"), node2.name));
        }
      },
      AssignmentExpression: {
        exit: function exit(path2, state) {
          if (!state.tdzEnabled)
            return;
          var node2 = path2.node;
          if (node2._ignoreBlockScopingTDZ)
            return;
          var nodes2 = [];
          var ids2 = path2.getBindingIdentifiers();
          for (var _i3 = 0, _Object$keys3 = Object.keys(ids2); _i3 < _Object$keys3.length; _i3++) {
            var _name = _Object$keys3[_i3];
            var id3 = ids2[_name];
            if (isReference(id3, path2.scope, state)) {
              nodes2.push(id3);
            }
          }
          if (nodes2.length) {
            node2._ignoreBlockScopingTDZ = true;
            nodes2.push(node2);
            path2.replaceWithMultiple(nodes2.map(function(n2) {
              return expressionStatement$a(n2);
            }));
          }
        }
      }
    };
    var DONE = /* @__PURE__ */ new WeakSet();
    var _transformBlockScoping = declare(function(api, opts) {
      api.assertVersion(7);
      var _opts$throwIfClosureR = opts.throwIfClosureRequired, throwIfClosureRequired = _opts$throwIfClosureR === void 0 ? false : _opts$throwIfClosureR, _opts$tdz = opts.tdz, tdzEnabled = _opts$tdz === void 0 ? false : _opts$tdz;
      if (typeof throwIfClosureRequired !== "boolean") {
        throw new Error(".throwIfClosureRequired must be a boolean, or undefined");
      }
      if (typeof tdzEnabled !== "boolean") {
        throw new Error(".tdz must be a boolean, or undefined");
      }
      return {
        name: "transform-block-scoping",
        visitor: {
          VariableDeclaration: function VariableDeclaration2(path2) {
            var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
            if (!isBlockScoped(node2))
              return;
            convertBlockScopedToVar(path2, null, parent, scope2, true);
            if (node2._tdzThis) {
              var nodes2 = [node2];
              for (var i2 = 0; i2 < node2.declarations.length; i2++) {
                var decl = node2.declarations[i2];
                var assign = assignmentExpression$c("=", cloneNode$i(decl.id), decl.init || scope2.buildUndefinedNode());
                assign._ignoreBlockScopingTDZ = true;
                nodes2.push(expressionStatement$a(assign));
                decl.init = this.addHelper("temporalUndefined");
              }
              node2._blockHoist = 2;
              if (path2.isCompletionRecord()) {
                nodes2.push(expressionStatement$a(scope2.buildUndefinedNode()));
              }
              path2.replaceWithMultiple(nodes2);
            }
          },
          Loop: function Loop(path2, state) {
            var parent = path2.parent, scope2 = path2.scope;
            path2.ensureBlock();
            var blockScoping = new BlockScoping(path2, path2.get("body"), parent, scope2, throwIfClosureRequired, tdzEnabled, state);
            var replace = blockScoping.run();
            if (replace)
              path2.replaceWith(replace);
          },
          CatchClause: function CatchClause2(path2, state) {
            var parent = path2.parent, scope2 = path2.scope;
            var blockScoping = new BlockScoping(null, path2.get("body"), parent, scope2, throwIfClosureRequired, tdzEnabled, state);
            blockScoping.run();
          },
          "BlockStatement|SwitchStatement|Program": function BlockStatementSwitchStatementProgram(path2, state) {
            if (!ignoreBlock(path2)) {
              var blockScoping = new BlockScoping(null, path2, path2.parent, path2.scope, throwIfClosureRequired, tdzEnabled, state);
              blockScoping.run();
            }
          }
        }
      };
    });
    function ignoreBlock(path2) {
      return isLoop$1(path2.parent) || isCatchClause(path2.parent);
    }
    var buildRetCheck = template$2('\n  if (typeof RETURN === "object") return RETURN.v;\n');
    function isBlockScoped(node2) {
      if (!isVariableDeclaration$3(node2))
        return false;
      if (node2[BLOCK_SCOPED_SYMBOL])
        return true;
      if (node2.kind !== "let" && node2.kind !== "const")
        return false;
      return true;
    }
    function isInLoop(path2) {
      var loopOrFunctionParent = path2.find(function(path3) {
        return path3.isLoop() || path3.isFunction();
      });
      return loopOrFunctionParent == null ? void 0 : loopOrFunctionParent.isLoop();
    }
    function convertBlockScopedToVar(path2, node2, parent, scope2, moveBindingsToParent) {
      if (moveBindingsToParent === void 0) {
        moveBindingsToParent = false;
      }
      if (!node2) {
        node2 = path2.node;
      }
      if (isInLoop(path2) && !isFor$2(parent)) {
        for (var i2 = 0; i2 < node2.declarations.length; i2++) {
          var declar = node2.declarations[i2];
          declar.init = declar.init || scope2.buildUndefinedNode();
        }
      }
      node2[BLOCK_SCOPED_SYMBOL] = true;
      node2.kind = "var";
      if (moveBindingsToParent) {
        var parentScope = scope2.getFunctionParent() || scope2.getProgramParent();
        for (var _i3 = 0, _Object$keys3 = Object.keys(path2.getBindingIdentifiers()); _i3 < _Object$keys3.length; _i3++) {
          var _name = _Object$keys3[_i3];
          var binding2 = scope2.getOwnBinding(_name);
          if (binding2)
            binding2.kind = "var";
          scope2.moveBindingTo(_name, parentScope);
        }
      }
    }
    function isVar(node2) {
      return isVariableDeclaration$3(node2, {
        kind: "var"
      }) && !isBlockScoped(node2);
    }
    var letReferenceBlockVisitor = traverse.visitors.merge([{
      Loop: {
        enter: function enter(path2, state) {
          state.loopDepth++;
        },
        exit: function exit(path2, state) {
          state.loopDepth--;
        }
      },
      FunctionParent: function FunctionParent(path2, state) {
        if (state.loopDepth > 0) {
          path2.traverse(letReferenceFunctionVisitor, state);
        } else {
          path2.traverse(visitor, state);
        }
        return path2.skip();
      }
    }, visitor]);
    var letReferenceFunctionVisitor = traverse.visitors.merge([{
      ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
        var ref2 = state.letReferences.get(path2.node.name);
        if (!ref2)
          return;
        var localBinding = path2.scope.getBindingIdentifier(path2.node.name);
        if (localBinding && localBinding !== ref2)
          return;
        state.closurify = true;
      }
    }, visitor]);
    var hoistVarDeclarationsVisitor = {
      enter: function enter(path2, self2) {
        if (path2.isForStatement()) {
          var node2 = path2.node;
          if (isVar(node2.init)) {
            var nodes2 = self2.pushDeclar(node2.init);
            if (nodes2.length === 1) {
              node2.init = nodes2[0];
            } else {
              node2.init = sequenceExpression$7(nodes2);
            }
          }
        } else if (path2.isForInStatement() || path2.isForOfStatement()) {
          var _node = path2.node;
          if (isVar(_node.left)) {
            self2.pushDeclar(_node.left);
            _node.left = _node.left.declarations[0].id;
          }
        } else if (isVar(path2.node)) {
          path2.replaceWithMultiple(self2.pushDeclar(path2.node).map(function(expr) {
            return expressionStatement$a(expr);
          }));
        } else if (path2.isFunction()) {
          return path2.skip();
        }
      }
    };
    var loopLabelVisitor = {
      LabeledStatement: function LabeledStatement2(_ref3, state) {
        var node2 = _ref3.node;
        state.innerLabels.push(node2.label.name);
      }
    };
    var continuationVisitor = {
      enter: function enter(path2, state) {
        if (path2.isAssignmentExpression() || path2.isUpdateExpression()) {
          for (var _i22 = 0, _Object$keys22 = Object.keys(path2.getBindingIdentifiers()); _i22 < _Object$keys22.length; _i22++) {
            var _name2 = _Object$keys22[_i22];
            if (state.outsideReferences.get(_name2) !== path2.scope.getBindingIdentifier(_name2)) {
              continue;
            }
            state.reassignments[_name2] = true;
          }
        } else if (path2.isReturnStatement()) {
          state.returnStatements.push(path2);
        }
      }
    };
    function loopNodeTo(node2) {
      if (isBreakStatement(node2)) {
        return "break";
      } else if (isContinueStatement(node2)) {
        return "continue";
      }
    }
    var loopVisitor = {
      Loop: function Loop(path2, state) {
        var oldIgnoreLabeless = state.ignoreLabeless;
        state.ignoreLabeless = true;
        path2.traverse(loopVisitor, state);
        state.ignoreLabeless = oldIgnoreLabeless;
        path2.skip();
      },
      Function: function Function2(path2) {
        path2.skip();
      },
      SwitchCase: function SwitchCase2(path2, state) {
        var oldInSwitchCase = state.inSwitchCase;
        state.inSwitchCase = true;
        path2.traverse(loopVisitor, state);
        state.inSwitchCase = oldInSwitchCase;
        path2.skip();
      },
      "BreakStatement|ContinueStatement|ReturnStatement": function BreakStatementContinueStatementReturnStatement(path2, state) {
        var node2 = path2.node, scope2 = path2.scope;
        if (node2[this.LOOP_IGNORE])
          return;
        var replace;
        var loopText = loopNodeTo(node2);
        if (loopText) {
          if (isReturnStatement$1(node2)) {
            throw new Error("Internal error: unexpected return statement with `loopText`");
          }
          if (node2.label) {
            if (state.innerLabels.indexOf(node2.label.name) >= 0) {
              return;
            }
            loopText = loopText + "|" + node2.label.name;
          } else {
            if (state.ignoreLabeless)
              return;
            if (isBreakStatement(node2) && state.inSwitchCase)
              return;
          }
          state.hasBreakContinue = true;
          state.map[loopText] = node2;
          replace = stringLiteral$8(loopText);
        }
        if (isReturnStatement$1(node2)) {
          state.hasReturn = true;
          replace = objectExpression$4([objectProperty$2(identifier$j("v"), node2.argument || scope2.buildUndefinedNode())]);
        }
        if (replace) {
          replace = returnStatement$3(replace);
          replace[this.LOOP_IGNORE] = true;
          path2.skip();
          path2.replaceWith(inherits$1(replace, node2));
        }
      }
    };
    function isStrict(path2) {
      return !!path2.find(function(_ref22) {
        var node2 = _ref22.node;
        if (isProgram$2(node2)) {
          if (node2.sourceType === "module")
            return true;
        } else if (!isBlockStatement$2(node2))
          return false;
        return node2.directives.some(function(directive2) {
          return directive2.value.value === "use strict";
        });
      });
    }
    var BlockScoping = function() {
      function BlockScoping2(loopPath, blockPath, parent, scope2, throwIfClosureRequired, tdzEnabled, state) {
        this.parent = void 0;
        this.state = void 0;
        this.scope = void 0;
        this.throwIfClosureRequired = void 0;
        this.tdzEnabled = void 0;
        this.blockPath = void 0;
        this.block = void 0;
        this.outsideLetReferences = void 0;
        this.hasLetReferences = void 0;
        this.letReferences = void 0;
        this.body = void 0;
        this.loopParent = void 0;
        this.loopLabel = void 0;
        this.loopPath = void 0;
        this.loop = void 0;
        this.has = void 0;
        this.parent = parent;
        this.scope = scope2;
        this.state = state;
        this.throwIfClosureRequired = throwIfClosureRequired;
        this.tdzEnabled = tdzEnabled;
        this.blockPath = blockPath;
        this.block = blockPath.node;
        this.outsideLetReferences = /* @__PURE__ */ new Map();
        this.hasLetReferences = false;
        this.letReferences = /* @__PURE__ */ new Map();
        this.body = [];
        if (loopPath) {
          this.loopParent = loopPath.parent;
          this.loopLabel = isLabeledStatement(this.loopParent) && this.loopParent.label;
          this.loopPath = loopPath;
          this.loop = loopPath.node;
        }
      }
      var _proto = BlockScoping2.prototype;
      _proto.run = function run2() {
        var block = this.block;
        if (DONE.has(block))
          return;
        DONE.add(block);
        var needsClosure = this.getLetReferences();
        this.checkConstants();
        if (isFunction$32(this.parent) || isProgram$2(this.block)) {
          this.updateScopeInfo();
          return;
        }
        if (!this.hasLetReferences)
          return;
        if (needsClosure) {
          this.wrapClosure();
        } else {
          this.remap();
        }
        this.updateScopeInfo(needsClosure);
        if (this.loopLabel && !isLabeledStatement(this.loopParent)) {
          return labeledStatement(this.loopLabel, this.loop);
        }
      };
      _proto.checkConstants = function checkConstants() {
        var scope2 = this.scope;
        var state = this.state;
        for (var _i3 = 0, _Object$keys3 = Object.keys(scope2.bindings); _i3 < _Object$keys3.length; _i3++) {
          var _name3 = _Object$keys3[_i3];
          var binding2 = scope2.bindings[_name3];
          if (binding2.kind !== "const")
            continue;
          for (var _iterator2 = _createForOfIteratorHelperLoose(binding2.constantViolations), _step2; !(_step2 = _iterator2()).done; ) {
            var violation = _step2.value;
            var readOnlyError = state.addHelper("readOnlyError");
            var throwNode = callExpression$e(readOnlyError, [stringLiteral$8(_name3)]);
            if (violation.isAssignmentExpression()) {
              var operator = violation.node.operator;
              if (operator === "=") {
                violation.replaceWith(sequenceExpression$7([violation.get("right").node, throwNode]));
              } else if (["&&=", "||=", "??="].includes(operator)) {
                violation.replaceWith(logicalExpression$3(operator.slice(0, -1), violation.get("left").node, sequenceExpression$7([violation.get("right").node, throwNode])));
              } else {
                violation.replaceWith(sequenceExpression$7([binaryExpression$4(operator.slice(0, -1), violation.get("left").node, violation.get("right").node), throwNode]));
              }
            } else if (violation.isUpdateExpression()) {
              violation.replaceWith(sequenceExpression$7([unaryExpression$6("+", violation.get("argument").node), throwNode]));
            } else if (violation.isForXStatement()) {
              violation.ensureBlock();
              violation.get("left").replaceWith(variableDeclaration$7("var", [variableDeclarator$7(violation.scope.generateUidIdentifier(_name3))]));
              violation.node.body.body.unshift(expressionStatement$a(throwNode));
            }
          }
        }
      };
      _proto.updateScopeInfo = function updateScopeInfo(wrappedInClosure) {
        var blockScope = this.blockPath.scope;
        var parentScope = blockScope.getFunctionParent() || blockScope.getProgramParent();
        var letRefs = this.letReferences;
        for (var _iterator2 = _createForOfIteratorHelperLoose(letRefs.keys()), _step2; !(_step2 = _iterator2()).done; ) {
          var key2 = _step2.value;
          var ref2 = letRefs.get(key2);
          var binding2 = blockScope.getBinding(ref2.name);
          if (!binding2)
            continue;
          if (binding2.kind === "let" || binding2.kind === "const") {
            binding2.kind = "var";
            if (wrappedInClosure) {
              if (blockScope.hasOwnBinding(ref2.name)) {
                blockScope.removeBinding(ref2.name);
              }
            } else {
              blockScope.moveBindingTo(ref2.name, parentScope);
            }
          }
        }
      };
      _proto.remap = function remap() {
        var letRefs = this.letReferences;
        var outsideLetRefs = this.outsideLetReferences;
        var scope2 = this.scope;
        var blockPathScope = this.blockPath.scope;
        for (var _iterator3 = _createForOfIteratorHelperLoose(letRefs.keys()), _step3; !(_step3 = _iterator3()).done; ) {
          var key2 = _step3.value;
          var ref2 = letRefs.get(key2);
          if (scope2.parentHasBinding(key2) || scope2.hasGlobal(key2)) {
            var binding2 = scope2.getOwnBinding(key2);
            if (binding2) {
              var parentBinding = scope2.parent.getOwnBinding(key2);
              if (binding2.kind === "hoisted" && !binding2.path.node.async && !binding2.path.node.generator && (!parentBinding || isVar(parentBinding.path.parent)) && !isStrict(binding2.path.parentPath)) {
                continue;
              }
              scope2.rename(ref2.name);
            }
            if (blockPathScope.hasOwnBinding(key2)) {
              blockPathScope.rename(ref2.name);
            }
          }
        }
        for (var _iterator4 = _createForOfIteratorHelperLoose(outsideLetRefs.keys()), _step4; !(_step4 = _iterator4()).done; ) {
          var _key = _step4.value;
          var _ref3 = letRefs.get(_key);
          if (isInLoop(this.blockPath) && blockPathScope.hasOwnBinding(_key)) {
            blockPathScope.rename(_ref3.name);
          }
        }
      };
      _proto.wrapClosure = function wrapClosure() {
        if (this.throwIfClosureRequired) {
          throw this.blockPath.buildCodeFrameError("Compiling let/const in this block would add a closure (throwIfClosureRequired).");
        }
        var block = this.block;
        var outsideRefs = this.outsideLetReferences;
        if (this.loop) {
          for (var _i4 = 0, _Array$from = Array.from(outsideRefs.keys()); _i4 < _Array$from.length; _i4++) {
            var _name4 = _Array$from[_i4];
            var id3 = outsideRefs.get(_name4);
            if (this.scope.hasGlobal(id3.name) || this.scope.parentHasBinding(id3.name)) {
              outsideRefs["delete"](id3.name);
              this.letReferences["delete"](id3.name);
              this.scope.rename(id3.name);
              this.letReferences.set(id3.name, id3);
              outsideRefs.set(id3.name, id3);
            }
          }
        }
        this.has = this.checkLoop();
        this.hoistVarDeclarations();
        var args = Array.from(outsideRefs.values(), function(node2) {
          return cloneNode$i(node2);
        });
        var params = args.map(function(id4) {
          return cloneNode$i(id4);
        });
        var isSwitch = this.blockPath.isSwitchStatement();
        var fn = functionExpression$3(null, params, blockStatement$6(isSwitch ? [block] : block.body));
        this.addContinuations(fn);
        var call3 = callExpression$e(nullLiteral$2(), args);
        var basePath = ".callee";
        var hasYield = traverse.hasType(fn.body, "YieldExpression", FUNCTION_TYPES$1);
        if (hasYield) {
          fn.generator = true;
          call3 = yieldExpression$2(call3, true);
          basePath = ".argument" + basePath;
        }
        var hasAsync = traverse.hasType(fn.body, "AwaitExpression", FUNCTION_TYPES$1);
        if (hasAsync) {
          fn.async = true;
          call3 = awaitExpression$1(call3);
          basePath = ".argument" + basePath;
        }
        var placeholderPath;
        var index3;
        if (this.has.hasReturn || this.has.hasBreakContinue) {
          var ret = this.scope.generateUid("ret");
          this.body.push(variableDeclaration$7("var", [variableDeclarator$7(identifier$j(ret), call3)]));
          placeholderPath = "declarations.0.init" + basePath;
          index3 = this.body.length - 1;
          this.buildHas(ret);
        } else {
          this.body.push(expressionStatement$a(call3));
          placeholderPath = "expression" + basePath;
          index3 = this.body.length - 1;
        }
        var callPath;
        if (isSwitch) {
          var _this$blockPath = this.blockPath, parentPath = _this$blockPath.parentPath, listKey = _this$blockPath.listKey, key2 = _this$blockPath.key;
          this.blockPath.replaceWithMultiple(this.body);
          callPath = parentPath.get(listKey)[key2 + index3];
        } else {
          block.body = this.body;
          callPath = this.blockPath.get("body")[index3];
        }
        var placeholder2 = callPath.get(placeholderPath);
        var fnPath;
        if (this.loop) {
          var loopId = this.scope.generateUid("loop");
          var p2 = this.loopPath.insertBefore(variableDeclaration$7("var", [variableDeclarator$7(identifier$j(loopId), fn)]));
          placeholder2.replaceWith(identifier$j(loopId));
          fnPath = p2[0].get("declarations.0.init");
        } else {
          placeholder2.replaceWith(fn);
          fnPath = placeholder2;
        }
        fnPath.unwrapFunctionEnvironment();
      };
      _proto.addContinuations = function addContinuations(fn) {
        var _this = this;
        var state = {
          reassignments: {},
          returnStatements: [],
          outsideReferences: this.outsideLetReferences
        };
        this.scope.traverse(fn, continuationVisitor, state);
        var _loop3 = function _loop4(i3) {
          var param = fn.params[i3];
          if (!state.reassignments[param.name])
            return "continue";
          var paramName = param.name;
          var newParamName = _this.scope.generateUid(param.name);
          fn.params[i3] = identifier$j(newParamName);
          _this.scope.rename(paramName, newParamName, fn);
          state.returnStatements.forEach(function(returnStatement2) {
            returnStatement2.insertBefore(expressionStatement$a(assignmentExpression$c("=", identifier$j(paramName), identifier$j(newParamName))));
          });
          fn.body.body.push(expressionStatement$a(assignmentExpression$c("=", identifier$j(paramName), identifier$j(newParamName))));
        };
        for (var i2 = 0; i2 < fn.params.length; i2++) {
          var _ret2 = _loop3(i2);
          if (_ret2 === "continue")
            continue;
        }
      };
      _proto.getLetReferences = function getLetReferences() {
        var _this2 = this;
        var block = this.block;
        var declarators = [];
        if (this.loop) {
          var init3 = this.loop.left || this.loop.init;
          if (isBlockScoped(init3)) {
            declarators.push(init3);
            var names2 = getBindingIdentifiers$2(init3);
            for (var _i5 = 0, _Object$keys4 = Object.keys(names2); _i5 < _Object$keys4.length; _i5++) {
              var _name5 = _Object$keys4[_i5];
              this.outsideLetReferences.set(_name5, names2[_name5]);
            }
          }
        }
        var addDeclarationsFromChild = function addDeclarationsFromChild2(path2, node2) {
          node2 = node2 || path2.node;
          if (isClassDeclaration$3(node2) || isFunctionDeclaration$1(node2) || isBlockScoped(node2)) {
            if (isBlockScoped(node2)) {
              convertBlockScopedToVar(path2, node2, block, _this2.scope);
            }
            if (node2.declarations) {
              for (var i3 = 0; i3 < node2.declarations.length; i3++) {
                declarators.push(node2.declarations[i3]);
              }
            } else {
              declarators.push(node2);
            }
          }
          if (isLabeledStatement(node2)) {
            addDeclarationsFromChild2(path2.get("body"), node2.body);
          }
        };
        if (block.body) {
          var declarPaths = this.blockPath.get("body");
          for (var i2 = 0; i2 < block.body.length; i2++) {
            addDeclarationsFromChild(declarPaths[i2]);
          }
        }
        if (block.cases) {
          var _declarPaths = this.blockPath.get("cases");
          for (var _i6 = 0; _i6 < block.cases.length; _i6++) {
            var consequents = block.cases[_i6].consequent;
            for (var j = 0; j < consequents.length; j++) {
              var declar = consequents[j];
              addDeclarationsFromChild(_declarPaths[_i6], declar);
            }
          }
        }
        for (var _i7 = 0; _i7 < declarators.length; _i7++) {
          var _declar = declarators[_i7];
          var keys2 = getBindingIdentifiers$2(_declar, false, true);
          for (var _i8 = 0, _Object$keys5 = Object.keys(keys2); _i8 < _Object$keys5.length; _i8++) {
            var key2 = _Object$keys5[_i8];
            this.letReferences.set(key2, keys2[key2]);
          }
          this.hasLetReferences = true;
        }
        if (!this.hasLetReferences)
          return;
        var state = {
          letReferences: this.letReferences,
          closurify: false,
          loopDepth: 0,
          tdzEnabled: this.tdzEnabled,
          addHelper: function addHelper(name2) {
            return _this2.state.addHelper(name2);
          }
        };
        if (isInLoop(this.blockPath)) {
          state.loopDepth++;
        }
        this.blockPath.traverse(letReferenceBlockVisitor, state);
        return state.closurify;
      };
      _proto.checkLoop = function checkLoop() {
        var state = {
          hasBreakContinue: false,
          ignoreLabeless: false,
          inSwitchCase: false,
          innerLabels: [],
          hasReturn: false,
          isLoop: !!this.loop,
          map: {},
          LOOP_IGNORE: Symbol()
        };
        this.blockPath.traverse(loopLabelVisitor, state);
        this.blockPath.traverse(loopVisitor, state);
        return state;
      };
      _proto.hoistVarDeclarations = function hoistVarDeclarations() {
        this.blockPath.traverse(hoistVarDeclarationsVisitor, this);
      };
      _proto.pushDeclar = function pushDeclar(node2) {
        var declars = [];
        var names2 = getBindingIdentifiers$2(node2);
        for (var _i9 = 0, _Object$keys6 = Object.keys(names2); _i9 < _Object$keys6.length; _i9++) {
          var _name6 = _Object$keys6[_i9];
          declars.push(variableDeclarator$7(names2[_name6]));
        }
        this.body.push(variableDeclaration$7(node2.kind, declars));
        var replace = [];
        for (var i2 = 0; i2 < node2.declarations.length; i2++) {
          var declar = node2.declarations[i2];
          if (!declar.init)
            continue;
          var expr = assignmentExpression$c("=", cloneNode$i(declar.id), cloneNode$i(declar.init));
          replace.push(inherits$1(expr, declar));
        }
        return replace;
      };
      _proto.buildHas = function buildHas(ret) {
        var body = this.body;
        var has3 = this.has;
        if (has3.hasBreakContinue) {
          for (var _i10 = 0, _Object$keys7 = Object.keys(has3.map); _i10 < _Object$keys7.length; _i10++) {
            var key2 = _Object$keys7[_i10];
            body.push(ifStatement(binaryExpression$4("===", identifier$j(ret), stringLiteral$8(key2)), has3.map[key2]));
          }
        }
        if (has3.hasReturn) {
          body.push(buildRetCheck({
            RETURN: identifier$j(ret)
          }));
        }
      };
      return _createClass2(BlockScoping2);
    }();
    var _templateObject$b;
    var helperIDs = /* @__PURE__ */ new WeakMap();
    function addCreateSuperHelper(file2) {
      if (helperIDs.has(file2)) {
        return (cloneNode$i || clone3)(helperIDs.get(file2));
      }
      try {
        return file2.addHelper("createSuper");
      } catch (_unused) {
      }
      var id3 = file2.scope.generateUidIdentifier("createSuper");
      helperIDs.set(file2, id3);
      var fn = helper$1({
        CREATE_SUPER: id3,
        GET_PROTOTYPE_OF: file2.addHelper("getPrototypeOf"),
        POSSIBLE_CONSTRUCTOR_RETURN: file2.addHelper("possibleConstructorReturn")
      });
      file2.path.unshiftContainer("body", [fn]);
      file2.scope.registerDeclaration(file2.path.get("body.0"));
      return cloneNode$i(id3);
    }
    var helper$1 = template$2.statement(_templateObject$b || (_templateObject$b = _taggedTemplateLiteralLoose([`
  function CREATE_SUPER(Derived) {
    function isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct) return false;

      // core-js@3
      if (Reflect.construct.sham) return false;

      // Proxy can't be polyfilled. Every browser implemented
      // proxies before or at the same time as Reflect.construct,
      // so if they support Proxy they also support Reflect.construct.
      if (typeof Proxy === "function") return true;

      // Since Reflect.construct can't be properly polyfilled, some
      // implementations (e.g. core-js@2) don't set the correct internal slots.
      // Those polyfills don't allow us to subclass built-ins, so we need to
      // use our fallback implementation.
      try {
        // If the internal slots aren't set, this throws an error similar to
        //   TypeError: this is not a Date object.
        Date.prototype.toString.call(Reflect.construct(Date, [], function() {}));
        return true;
      } catch (e) {
        return false;
      }
    }

    return function () {
      var Super = GET_PROTOTYPE_OF(Derived), result;
      if (isNativeReflectConstruct()) {
        // NOTE: This doesn't work if this.__proto__.constructor has been modified.
        var NewTarget = GET_PROTOTYPE_OF(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return POSSIBLE_CONSTRUCTOR_RETURN(this, result);
    }
  }
`])));
    var _templateObject$a;
    function buildConstructor(classRef, constructorBody, node2) {
      var func = functionDeclaration(cloneNode$i(classRef), [], constructorBody);
      inherits$1(func, node2);
      return func;
    }
    function transformClass(path2, file2, builtinClasses2, isLoose2, assumptions) {
      var classState = {
        parent: void 0,
        scope: void 0,
        node: void 0,
        path: void 0,
        file: void 0,
        classId: void 0,
        classRef: void 0,
        superFnId: void 0,
        superName: void 0,
        superReturns: [],
        isDerived: false,
        extendsNative: false,
        construct: void 0,
        constructorBody: void 0,
        userConstructor: void 0,
        userConstructorPath: void 0,
        hasConstructor: false,
        staticPropBody: [],
        body: [],
        superThises: [],
        pushedConstructor: false,
        pushedInherits: false,
        pushedCreateClass: false,
        protoAlias: null,
        isLoose: false,
        dynamicKeys: /* @__PURE__ */ new Map(),
        methods: {
          instance: {
            hasComputed: false,
            list: [],
            map: /* @__PURE__ */ new Map()
          },
          "static": {
            hasComputed: false,
            list: [],
            map: /* @__PURE__ */ new Map()
          }
        }
      };
      var setState2 = function setState3(newState) {
        Object.assign(classState, newState);
      };
      var findThisesVisitor = traverse.visitors.merge([environmentVisitor, {
        ThisExpression: function ThisExpression2(path3) {
          classState.superThises.push(path3);
        }
      }]);
      function createClassHelper(args) {
        return callExpression$e(classState.file.addHelper("createClass"), args);
      }
      function maybeCreateConstructor() {
        var hasConstructor = false;
        var paths = classState.path.get("body.body");
        for (var _iterator2 = _createForOfIteratorHelperLoose(paths), _step2; !(_step2 = _iterator2()).done; ) {
          var _path = _step2.value;
          hasConstructor = _path.equals("kind", "constructor");
          if (hasConstructor)
            break;
        }
        if (hasConstructor)
          return;
        var params, body;
        if (classState.isDerived) {
          var _constructor = template$2.expression.ast(_templateObject$a || (_templateObject$a = _taggedTemplateLiteralLoose(["\n        (function () {\n          super(...arguments);\n        })\n      "])));
          params = _constructor.params;
          body = _constructor.body;
        } else {
          params = [];
          body = blockStatement$6([]);
        }
        classState.path.get("body").unshiftContainer("body", classMethod("constructor", identifier$j("constructor"), params, body));
      }
      function buildBody() {
        maybeCreateConstructor();
        pushBody();
        verifyConstructor();
        if (classState.userConstructor) {
          var _constructorBody$body;
          var constructorBody = classState.constructorBody, userConstructor = classState.userConstructor, construct = classState.construct;
          (_constructorBody$body = constructorBody.body).push.apply(_constructorBody$body, _toConsumableArray2(userConstructor.body.body));
          inherits$1(construct, userConstructor);
          inherits$1(constructorBody, userConstructor.body);
        }
        pushDescriptors();
      }
      function pushBody() {
        var classBodyPaths = classState.path.get("body.body");
        for (var _iterator2 = _createForOfIteratorHelperLoose(classBodyPaths), _step2; !(_step2 = _iterator2()).done; ) {
          var _path2 = _step2.value;
          var node2 = _path2.node;
          if (_path2.isClassProperty()) {
            throw _path2.buildCodeFrameError("Missing class properties transform.");
          }
          if (node2.decorators) {
            throw _path2.buildCodeFrameError("Method has decorators, put the decorator plugin before the classes one.");
          }
          if (isClassMethod$1(node2)) {
            (function() {
              var isConstructor = node2.kind === "constructor";
              var replaceSupers = new ReplaceSupers({
                methodPath: _path2,
                objectRef: classState.classRef,
                superRef: classState.superName,
                constantSuper: assumptions.constantSuper,
                file: classState.file,
                refToPreserve: classState.classRef
              });
              replaceSupers.replace();
              var superReturns = [];
              _path2.traverse(traverse.visitors.merge([environmentVisitor, {
                ReturnStatement: function ReturnStatement2(path3) {
                  if (!path3.getFunctionParent().isArrowFunctionExpression()) {
                    superReturns.push(path3);
                  }
                }
              }]));
              if (isConstructor) {
                pushConstructor(superReturns, node2, _path2);
              } else {
                pushMethod(node2, _path2);
              }
            })();
          }
        }
      }
      function pushDescriptors() {
        pushInheritsToBody();
        var body = classState.body;
        var props = {
          instance: null,
          "static": null
        };
        for (var _i3 = 0, _arr = ["static", "instance"]; _i3 < _arr.length; _i3++) {
          var placement = _arr[_i3];
          if (classState.methods[placement].list.length) {
            props[placement] = classState.methods[placement].list.map(function(desc) {
              var obj = objectExpression$4([objectProperty$2(identifier$j("key"), desc.key)]);
              for (var _i22 = 0, _arr2 = ["get", "set", "value"]; _i22 < _arr2.length; _i22++) {
                var kind = _arr2[_i22];
                if (desc[kind] != null) {
                  obj.properties.push(objectProperty$2(identifier$j(kind), desc[kind]));
                }
              }
              return obj;
            });
          }
        }
        if (props.instance || props["static"]) {
          var args = [cloneNode$i(classState.classRef), props.instance ? arrayExpression$2(props.instance) : nullLiteral$2(), props["static"] ? arrayExpression$2(props["static"]) : nullLiteral$2()];
          var lastNonNullIndex = 0;
          for (var i2 = 0; i2 < args.length; i2++) {
            if (!isNullLiteral$1(args[i2]))
              lastNonNullIndex = i2;
          }
          args = args.slice(0, lastNonNullIndex + 1);
          body.push(expressionStatement$a(createClassHelper(args)));
          classState.pushedCreateClass = true;
        }
      }
      function wrapSuperCall(bareSuper, superRef, thisRef, body) {
        var bareSuperNode = bareSuper.node;
        var call3;
        if (assumptions.superIsCallableConstructor) {
          bareSuperNode.arguments.unshift(thisExpression$4());
          if (bareSuperNode.arguments.length === 2 && isSpreadElement$1(bareSuperNode.arguments[1]) && isIdentifier$i(bareSuperNode.arguments[1].argument, {
            name: "arguments"
          })) {
            bareSuperNode.arguments[1] = bareSuperNode.arguments[1].argument;
            bareSuperNode.callee = memberExpression$b(cloneNode$i(superRef), identifier$j("apply"));
          } else {
            bareSuperNode.callee = memberExpression$b(cloneNode$i(superRef), identifier$j("call"));
          }
          call3 = logicalExpression$3("||", bareSuperNode, thisExpression$4());
        } else {
          call3 = optimiseCallExpression(cloneNode$i(classState.superFnId), thisExpression$4(), bareSuperNode.arguments, false);
        }
        if (bareSuper.parentPath.isExpressionStatement() && bareSuper.parentPath.container === body.node.body && body.node.body.length - 1 === bareSuper.parentPath.key) {
          if (classState.superThises.length) {
            call3 = assignmentExpression$c("=", thisRef(), call3);
          }
          bareSuper.parentPath.replaceWith(returnStatement$3(call3));
        } else {
          bareSuper.replaceWith(assignmentExpression$c("=", thisRef(), call3));
        }
      }
      function verifyConstructor() {
        if (!classState.isDerived)
          return;
        var path3 = classState.userConstructorPath;
        var body = path3.get("body");
        path3.traverse(findThisesVisitor);
        var _thisRef = function thisRef() {
          var ref2 = path3.scope.generateDeclaredUidIdentifier("this");
          _thisRef = function thisRef2() {
            return cloneNode$i(ref2);
          };
          return ref2;
        };
        for (var _iterator3 = _createForOfIteratorHelperLoose(classState.superThises), _step3; !(_step3 = _iterator3()).done; ) {
          var thisPath = _step3.value;
          var node2 = thisPath.node, parentPath = thisPath.parentPath;
          if (parentPath.isMemberExpression({
            object: node2
          })) {
            thisPath.replaceWith(_thisRef());
            continue;
          }
          thisPath.replaceWith(callExpression$e(classState.file.addHelper("assertThisInitialized"), [_thisRef()]));
        }
        var bareSupers = /* @__PURE__ */ new Set();
        path3.traverse(traverse.visitors.merge([environmentVisitor, {
          Super: function Super2(path4) {
            var node3 = path4.node, parentPath2 = path4.parentPath;
            if (parentPath2.isCallExpression({
              callee: node3
            })) {
              bareSupers.add(parentPath2);
            }
          }
        }]));
        var guaranteedSuperBeforeFinish = !!bareSupers.size;
        for (var _iterator4 = _createForOfIteratorHelperLoose(bareSupers), _step4; !(_step4 = _iterator4()).done; ) {
          var bareSuper = _step4.value;
          wrapSuperCall(bareSuper, classState.superName, _thisRef, body);
          if (guaranteedSuperBeforeFinish) {
            bareSuper.find(function(parentPath2) {
              if (parentPath2 === path3) {
                return true;
              }
              if (parentPath2.isLoop() || parentPath2.isConditional() || parentPath2.isArrowFunctionExpression()) {
                guaranteedSuperBeforeFinish = false;
                return true;
              }
            });
          }
        }
        var wrapReturn;
        if (classState.isLoose) {
          wrapReturn = function wrapReturn2(returnArg) {
            var thisExpr = callExpression$e(classState.file.addHelper("assertThisInitialized"), [_thisRef()]);
            return returnArg ? logicalExpression$3("||", returnArg, thisExpr) : thisExpr;
          };
        } else {
          wrapReturn = function wrapReturn2(returnArg) {
            return callExpression$e(classState.file.addHelper("possibleConstructorReturn"), [_thisRef()].concat(returnArg || []));
          };
        }
        var bodyPaths = body.get("body");
        if (!bodyPaths.length || !bodyPaths.pop().isReturnStatement()) {
          body.pushContainer("body", returnStatement$3(guaranteedSuperBeforeFinish ? _thisRef() : wrapReturn()));
        }
        for (var _iterator5 = _createForOfIteratorHelperLoose(classState.superReturns), _step5; !(_step5 = _iterator5()).done; ) {
          var returnPath = _step5.value;
          returnPath.get("argument").replaceWith(wrapReturn(returnPath.node.argument));
        }
      }
      function pushMethod(node2, path3) {
        var scope2 = path3 ? path3.scope : classState.scope;
        if (node2.kind === "method") {
          if (processMethod(node2, scope2))
            return;
        }
        var placement = node2["static"] ? "static" : "instance";
        var methods = classState.methods[placement];
        var descKey = node2.kind === "method" ? "value" : node2.kind;
        var key2 = isNumericLiteral(node2.key) || isBigIntLiteral(node2.key) ? stringLiteral$8(String(node2.key.value)) : toComputedKey$3(node2);
        var fn = toExpression$1(node2);
        if (isStringLiteral$7(key2)) {
          if (node2.kind === "method") {
            fn = nameFunction({
              id: key2,
              node: node2,
              scope: scope2
            });
          }
        } else {
          methods.hasComputed = true;
        }
        var descriptor;
        if (!methods.hasComputed && methods.map.has(key2.value)) {
          descriptor = methods.map.get(key2.value);
          descriptor[descKey] = fn;
          if (descKey === "value") {
            descriptor.get = null;
            descriptor.set = null;
          } else {
            descriptor.value = null;
          }
        } else {
          var _descriptor;
          descriptor = (_descriptor = {
            key: key2
          }, _descriptor[descKey] = fn, _descriptor);
          methods.list.push(descriptor);
          if (!methods.hasComputed) {
            methods.map.set(key2.value, descriptor);
          }
        }
      }
      function processMethod(node2, scope2) {
        if (assumptions.setClassMethods && !node2.decorators) {
          var classRef = classState.classRef;
          if (!node2["static"]) {
            insertProtoAliasOnce();
            classRef = classState.protoAlias;
          }
          var methodName = memberExpression$b(cloneNode$i(classRef), node2.key, node2.computed || isLiteral$7(node2.key));
          var func = functionExpression$3(null, node2.params, node2.body, node2.generator, node2.async);
          inherits$1(func, node2);
          var key2 = toComputedKey$3(node2, node2.key);
          if (isStringLiteral$7(key2)) {
            func = nameFunction({
              node: func,
              id: key2,
              scope: scope2
            });
          }
          var expr = expressionStatement$a(assignmentExpression$c("=", methodName, func));
          inheritsComments$2(expr, node2);
          classState.body.push(expr);
          return true;
        }
        return false;
      }
      function insertProtoAliasOnce() {
        if (classState.protoAlias === null) {
          setState2({
            protoAlias: classState.scope.generateUidIdentifier("proto")
          });
          var classProto = memberExpression$b(classState.classRef, identifier$j("prototype"));
          var protoDeclaration = variableDeclaration$7("var", [variableDeclarator$7(classState.protoAlias, classProto)]);
          classState.body.push(protoDeclaration);
        }
      }
      function pushConstructor(superReturns, method5, path3) {
        setState2({
          userConstructorPath: path3,
          userConstructor: method5,
          hasConstructor: true,
          superReturns
        });
        var construct = classState.construct;
        inheritsComments$2(construct, method5);
        construct.params = method5.params;
        inherits$1(construct.body, method5.body);
        construct.body.directives = method5.body.directives;
        pushConstructorToBody();
      }
      function pushConstructorToBody() {
        if (classState.pushedConstructor)
          return;
        classState.pushedConstructor = true;
        if (classState.hasInstanceDescriptors || classState.hasStaticDescriptors) {
          pushDescriptors();
        }
        classState.body.push(classState.construct);
        pushInheritsToBody();
      }
      function pushInheritsToBody() {
        if (!classState.isDerived || classState.pushedInherits)
          return;
        var superFnId = path2.scope.generateUidIdentifier("super");
        setState2({
          pushedInherits: true,
          superFnId
        });
        if (!assumptions.superIsCallableConstructor) {
          classState.body.unshift(variableDeclaration$7("var", [variableDeclarator$7(superFnId, callExpression$e(addCreateSuperHelper(classState.file), [cloneNode$i(classState.classRef)]))]));
        }
        classState.body.unshift(expressionStatement$a(callExpression$e(classState.file.addHelper(classState.isLoose ? "inheritsLoose" : "inherits"), [cloneNode$i(classState.classRef), cloneNode$i(classState.superName)])));
      }
      function extractDynamicKeys() {
        var _ref3 = classState, dynamicKeys = _ref3.dynamicKeys, node2 = _ref3.node, scope2 = _ref3.scope;
        for (var _iterator6 = _createForOfIteratorHelperLoose(node2.body.body), _step6; !(_step6 = _iterator6()).done; ) {
          var elem = _step6.value;
          if (!isClassMethod$1(elem) || !elem.computed)
            continue;
          if (scope2.isPure(elem.key, true))
            continue;
          var id3 = scope2.generateUidIdentifierBasedOnNode(elem.key);
          dynamicKeys.set(id3.name, elem.key);
          elem.key = id3;
        }
      }
      function setupClosureParamsArgs() {
        var superName = classState.superName, dynamicKeys = classState.dynamicKeys;
        var closureParams = [];
        var closureArgs = [];
        if (classState.isDerived) {
          var arg = cloneNode$i(superName);
          if (classState.extendsNative) {
            arg = callExpression$e(classState.file.addHelper("wrapNativeSuper"), [arg]);
            annotateAsPure(arg);
          }
          var param = classState.scope.generateUidIdentifierBasedOnNode(superName);
          closureParams.push(param);
          closureArgs.push(arg);
          setState2({
            superName: cloneNode$i(param)
          });
        }
        for (var _iterator7 = _createForOfIteratorHelperLoose(dynamicKeys), _step7; !(_step7 = _iterator7()).done; ) {
          var _step7$value = _slicedToArray$12(_step7.value, 2), name2 = _step7$value[0], value = _step7$value[1];
          closureParams.push(identifier$j(name2));
          closureArgs.push(value);
        }
        return {
          closureParams,
          closureArgs
        };
      }
      function classTransformer(path3, file3, builtinClasses3, isLoose3) {
        setState2({
          parent: path3.parent,
          scope: path3.scope,
          node: path3.node,
          path: path3,
          file: file3,
          isLoose: isLoose3
        });
        setState2({
          classId: classState.node.id,
          classRef: classState.node.id ? identifier$j(classState.node.id.name) : classState.scope.generateUidIdentifier("class"),
          superName: classState.node.superClass,
          isDerived: !!classState.node.superClass,
          constructorBody: blockStatement$6([])
        });
        setState2({
          extendsNative: classState.isDerived && builtinClasses3.has(classState.superName.name) && !classState.scope.hasBinding(classState.superName.name, true)
        });
        var classRef = classState.classRef, node2 = classState.node, constructorBody = classState.constructorBody;
        setState2({
          construct: buildConstructor(classRef, constructorBody, node2)
        });
        extractDynamicKeys();
        var body = classState.body;
        var _setupClosureParamsAr = setupClosureParamsArgs(), closureParams = _setupClosureParamsAr.closureParams, closureArgs = _setupClosureParamsAr.closureArgs;
        buildBody();
        if (!assumptions.noClassCalls) {
          constructorBody.body.unshift(expressionStatement$a(callExpression$e(classState.file.addHelper("classCallCheck"), [thisExpression$4(), cloneNode$i(classState.classRef)])));
        }
        body.push.apply(body, _toConsumableArray2(classState.staticPropBody.map(function(fn) {
          return fn(cloneNode$i(classState.classRef));
        })));
        var isStrict2 = path3.isInStrictMode();
        var constructorOnly = classState.classId && body.length === 1;
        if (constructorOnly && !isStrict2) {
          for (var _iterator8 = _createForOfIteratorHelperLoose(classState.construct.params), _step8; !(_step8 = _iterator8()).done; ) {
            var param = _step8.value;
            if (!isIdentifier$i(param)) {
              constructorOnly = false;
              break;
            }
          }
        }
        var directives = constructorOnly ? body[0].body.directives : [];
        if (!isStrict2) {
          directives.push(directive$1(directiveLiteral$1("use strict")));
        }
        if (constructorOnly) {
          var expr = toExpression$1(body[0]);
          return classState.isLoose ? expr : createClassHelper([expr]);
        }
        var returnArg = cloneNode$i(classState.classRef);
        if (!classState.pushedCreateClass && !classState.isLoose) {
          returnArg = createClassHelper([returnArg]);
        }
        body.push(returnStatement$3(returnArg));
        var container2 = arrowFunctionExpression$4(closureParams, blockStatement$6(body, directives));
        return callExpression$e(container2, closureArgs);
      }
      return classTransformer(path2, file2, builtinClasses2, isLoose2);
    }
    var getBuiltinClasses = function getBuiltinClasses2(category) {
      return Object.keys(globals[category]).filter(function(name2) {
        return /^[A-Z]/.test(name2);
      });
    };
    var builtinClasses = new Set([].concat(_toConsumableArray2(getBuiltinClasses("builtin")), _toConsumableArray2(getBuiltinClasses("browser"))));
    var _transformClasses = declare(function(api, options) {
      var _api$assumption, _api$assumption2, _api$assumption3, _api$assumption4;
      api.assertVersion(7);
      var loose = options.loose;
      var setClassMethods = (_api$assumption = api.assumption("setClassMethods")) != null ? _api$assumption : options.loose;
      var constantSuper = (_api$assumption2 = api.assumption("constantSuper")) != null ? _api$assumption2 : options.loose;
      var superIsCallableConstructor = (_api$assumption3 = api.assumption("superIsCallableConstructor")) != null ? _api$assumption3 : options.loose;
      var noClassCalls = (_api$assumption4 = api.assumption("noClassCalls")) != null ? _api$assumption4 : options.loose;
      var VISITED = Symbol();
      return {
        name: "transform-classes",
        visitor: {
          ExportDefaultDeclaration: function ExportDefaultDeclaration2(path2) {
            if (!path2.get("declaration").isClassDeclaration())
              return;
            splitExportDeclaration(path2);
          },
          ClassDeclaration: function ClassDeclaration2(path2) {
            var node2 = path2.node;
            var ref2 = node2.id || path2.scope.generateUidIdentifier("class");
            path2.replaceWith(variableDeclaration$7("let", [variableDeclarator$7(ref2, toExpression$1(node2))]));
          },
          ClassExpression: function ClassExpression2(path2, state) {
            var node2 = path2.node;
            if (node2[VISITED])
              return;
            var inferred = nameFunction(path2);
            if (inferred && inferred !== node2) {
              path2.replaceWith(inferred);
              return;
            }
            node2[VISITED] = true;
            path2.replaceWith(transformClass(path2, state.file, builtinClasses, loose, {
              setClassMethods,
              constantSuper,
              superIsCallableConstructor,
              noClassCalls
            }));
            if (path2.isCallExpression()) {
              annotateAsPure(path2);
              var callee = path2.get("callee");
              if (callee.isArrowFunctionExpression()) {
                callee.arrowFunctionToExpression();
              }
            }
          }
        }
      };
    });
    var _transformComputedProperties = declare(function(api, options) {
      var _api$assumption;
      api.assertVersion(7);
      var setComputedProperties = (_api$assumption = api.assumption("setComputedProperties")) != null ? _api$assumption : options.loose;
      var pushComputedProps = setComputedProperties ? pushComputedPropsLoose2 : pushComputedPropsSpec2;
      var buildMutatorMapAssign = template$2("\n    MUTATOR_MAP_REF[KEY] = MUTATOR_MAP_REF[KEY] || {};\n    MUTATOR_MAP_REF[KEY].KIND = VALUE;\n  ");
      function getValue2(prop2) {
        if (isObjectProperty$5(prop2)) {
          return prop2.value;
        } else if (isObjectMethod$2(prop2)) {
          return functionExpression$3(null, prop2.params, prop2.body, prop2.generator, prop2.async);
        }
      }
      function pushAssign(objId, prop2, body) {
        if (prop2.kind === "get" && prop2.kind === "set") {
          pushMutatorDefine(objId, prop2);
        } else {
          body.push(expressionStatement$a(assignmentExpression$c("=", memberExpression$b(cloneNode$i(objId), prop2.key, prop2.computed || isLiteral$7(prop2.key)), getValue2(prop2))));
        }
      }
      function pushMutatorDefine(_ref3, prop2) {
        var body = _ref3.body, getMutatorId = _ref3.getMutatorId, scope2 = _ref3.scope;
        var key2 = !prop2.computed && isIdentifier$i(prop2.key) ? stringLiteral$8(prop2.key.name) : prop2.key;
        var maybeMemoise = scope2.maybeGenerateMemoised(key2);
        if (maybeMemoise) {
          body.push(expressionStatement$a(assignmentExpression$c("=", maybeMemoise, key2)));
          key2 = maybeMemoise;
        }
        body.push.apply(body, _toConsumableArray2(buildMutatorMapAssign({
          MUTATOR_MAP_REF: getMutatorId(),
          KEY: cloneNode$i(key2),
          VALUE: getValue2(prop2),
          KIND: identifier$j(prop2.kind)
        })));
      }
      function pushComputedPropsLoose2(info) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(info.computedProps), _step2; !(_step2 = _iterator2()).done; ) {
          var prop2 = _step2.value;
          if (prop2.kind === "get" || prop2.kind === "set") {
            pushMutatorDefine(info, prop2);
          } else {
            pushAssign(cloneNode$i(info.objId), prop2, info.body);
          }
        }
      }
      function pushComputedPropsSpec2(info) {
        var objId = info.objId, body = info.body, computedProps = info.computedProps, state = info.state;
        for (var _iterator2 = _createForOfIteratorHelperLoose(computedProps), _step2; !(_step2 = _iterator2()).done; ) {
          var prop2 = _step2.value;
          var key2 = toComputedKey$3(prop2);
          if (prop2.kind === "get" || prop2.kind === "set") {
            pushMutatorDefine(info, prop2);
          } else {
            if (computedProps.length === 1) {
              return callExpression$e(state.addHelper("defineProperty"), [info.initPropExpression, key2, getValue2(prop2)]);
            } else {
              body.push(expressionStatement$a(callExpression$e(state.addHelper("defineProperty"), [cloneNode$i(objId), key2, getValue2(prop2)])));
            }
          }
        }
      }
      return {
        name: "transform-computed-properties",
        visitor: {
          ObjectExpression: {
            exit: function exit(path2, state) {
              var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
              var hasComputed = false;
              for (var _iterator3 = _createForOfIteratorHelperLoose(node2.properties), _step3; !(_step3 = _iterator3()).done; ) {
                var prop2 = _step3.value;
                hasComputed = prop2.computed === true;
                if (hasComputed)
                  break;
              }
              if (!hasComputed)
                return;
              var initProps2 = [];
              var computedProps = [];
              var foundComputed = false;
              for (var _iterator4 = _createForOfIteratorHelperLoose(node2.properties), _step4; !(_step4 = _iterator4()).done; ) {
                var _prop = _step4.value;
                if (_prop.computed) {
                  foundComputed = true;
                }
                if (foundComputed) {
                  computedProps.push(_prop);
                } else {
                  initProps2.push(_prop);
                }
              }
              var objId = scope2.generateUidIdentifierBasedOnNode(parent);
              var initPropExpression = objectExpression$4(initProps2);
              var body = [];
              body.push(variableDeclaration$7("var", [variableDeclarator$7(objId, initPropExpression)]));
              var mutatorRef;
              var getMutatorId = function getMutatorId2() {
                if (!mutatorRef) {
                  mutatorRef = scope2.generateUidIdentifier("mutatorMap");
                  body.push(variableDeclaration$7("var", [variableDeclarator$7(mutatorRef, objectExpression$4([]))]));
                }
                return cloneNode$i(mutatorRef);
              };
              var single = pushComputedProps({
                scope: scope2,
                objId,
                body,
                computedProps,
                initPropExpression,
                getMutatorId,
                state
              });
              if (mutatorRef) {
                body.push(expressionStatement$a(callExpression$e(state.addHelper("defineEnumerableProperties"), [cloneNode$i(objId), cloneNode$i(mutatorRef)])));
              }
              if (single) {
                path2.replaceWith(single);
              } else {
                body.push(expressionStatement$a(cloneNode$i(objId)));
                path2.replaceWithMultiple(body);
              }
            }
          }
        }
      };
    });
    function hasArrayRest(pattern5) {
      return pattern5.elements.some(function(elem) {
        return isRestElement$3(elem);
      });
    }
    function hasObjectRest(pattern5) {
      return pattern5.properties.some(function(prop2) {
        return isRestElement$3(prop2);
      });
    }
    var STOP_TRAVERSAL = {};
    var arrayUnpackVisitor = function arrayUnpackVisitor2(node2, ancestors, state) {
      if (!ancestors.length) {
        return;
      }
      if (isIdentifier$i(node2) && isReferenced$2(node2, ancestors[ancestors.length - 1].node) && state.bindings[node2.name]) {
        state.deopt = true;
        throw STOP_TRAVERSAL;
      }
    };
    var DestructuringTransformer = function() {
      function DestructuringTransformer2(opts) {
        this.blockHoist = void 0;
        this.operator = void 0;
        this.arrayRefSet = void 0;
        this.nodes = void 0;
        this.scope = void 0;
        this.kind = void 0;
        this.iterableIsArray = void 0;
        this.arrayLikeIsIterable = void 0;
        this.objectRestNoSymbols = void 0;
        this.useBuiltIns = void 0;
        this.addHelper = void 0;
        this.blockHoist = opts.blockHoist;
        this.operator = opts.operator;
        this.arrayRefSet = /* @__PURE__ */ new Set();
        this.nodes = opts.nodes || [];
        this.scope = opts.scope;
        this.kind = opts.kind;
        this.iterableIsArray = opts.iterableIsArray;
        this.arrayLikeIsIterable = opts.arrayLikeIsIterable;
        this.objectRestNoSymbols = opts.objectRestNoSymbols;
        this.useBuiltIns = opts.useBuiltIns;
        this.addHelper = opts.addHelper;
      }
      var _proto = DestructuringTransformer2.prototype;
      _proto.getExtendsHelper = function getExtendsHelper() {
        return this.useBuiltIns ? memberExpression$b(identifier$j("Object"), identifier$j("assign")) : this.addHelper("extends");
      };
      _proto.buildVariableAssignment = function buildVariableAssignment(id3, init3) {
        var op = this.operator;
        if (isMemberExpression$8(id3))
          op = "=";
        var node2;
        if (op) {
          node2 = expressionStatement$a(assignmentExpression$c(op, id3, cloneNode$i(init3) || this.scope.buildUndefinedNode()));
        } else {
          var nodeInit;
          if (this.kind === "const" && init3 === null) {
            nodeInit = this.scope.buildUndefinedNode();
          } else {
            nodeInit = cloneNode$i(init3);
          }
          node2 = variableDeclaration$7(this.kind, [variableDeclarator$7(id3, nodeInit)]);
        }
        node2._blockHoist = this.blockHoist;
        return node2;
      };
      _proto.buildVariableDeclaration = function buildVariableDeclaration(id3, init3) {
        var declar = variableDeclaration$7("var", [variableDeclarator$7(cloneNode$i(id3), cloneNode$i(init3))]);
        declar._blockHoist = this.blockHoist;
        return declar;
      };
      _proto.push = function push3(id3, _init) {
        var init3 = cloneNode$i(_init);
        if (isObjectPattern$2(id3)) {
          this.pushObjectPattern(id3, init3);
        } else if (isArrayPattern$1(id3)) {
          this.pushArrayPattern(id3, init3);
        } else if (isAssignmentPattern$5(id3)) {
          this.pushAssignmentPattern(id3, init3);
        } else {
          this.nodes.push(this.buildVariableAssignment(id3, init3));
        }
      };
      _proto.toArray = function toArray2(node2, count2) {
        if (this.iterableIsArray || isIdentifier$i(node2) && this.arrayRefSet.has(node2.name)) {
          return node2;
        } else {
          return this.scope.toArray(node2, count2, this.arrayLikeIsIterable);
        }
      };
      _proto.pushAssignmentPattern = function pushAssignmentPattern(_ref3, valueRef) {
        var left = _ref3.left, right = _ref3.right;
        if (valueRef === null) {
          this.push(left, right);
          return;
        }
        var tempId = this.scope.generateUidIdentifierBasedOnNode(valueRef);
        this.nodes.push(this.buildVariableDeclaration(tempId, valueRef));
        var tempConditional = conditionalExpression$3(binaryExpression$4("===", cloneNode$i(tempId), this.scope.buildUndefinedNode()), right, cloneNode$i(tempId));
        if (isPattern2(left)) {
          var patternId;
          var node2;
          if (this.kind === "const" || this.kind === "let") {
            patternId = this.scope.generateUidIdentifier(tempId.name);
            node2 = this.buildVariableDeclaration(patternId, tempConditional);
          } else {
            patternId = tempId;
            node2 = expressionStatement$a(assignmentExpression$c("=", cloneNode$i(tempId), tempConditional));
          }
          this.nodes.push(node2);
          this.push(left, patternId);
        } else {
          this.nodes.push(this.buildVariableAssignment(left, tempConditional));
        }
      };
      _proto.pushObjectRest = function pushObjectRest(pattern5, objRef, spreadProp, spreadPropIndex) {
        var _this = this;
        var value = buildObjectExcludingKeys(pattern5.properties.slice(0, spreadPropIndex), objRef, this.scope, function(name2) {
          return _this.addHelper(name2);
        }, this.objectRestNoSymbols, this.useBuiltIns);
        this.nodes.push(this.buildVariableAssignment(spreadProp.argument, value));
      };
      _proto.pushObjectProperty = function pushObjectProperty(prop2, propRef) {
        if (isLiteral$7(prop2.key))
          prop2.computed = true;
        var pattern5 = prop2.value;
        var objRef = memberExpression$b(cloneNode$i(propRef), prop2.key, prop2.computed);
        if (isPattern2(pattern5)) {
          this.push(pattern5, objRef);
        } else {
          this.nodes.push(this.buildVariableAssignment(pattern5, objRef));
        }
      };
      _proto.pushObjectPattern = function pushObjectPattern(pattern5, objRef) {
        if (!pattern5.properties.length || objRef === null) {
          this.nodes.push(expressionStatement$a(callExpression$e(this.addHelper("objectDestructuringEmpty"), objRef !== null ? [objRef] : [])));
          return;
        }
        if (pattern5.properties.length > 1 && !this.scope.isStatic(objRef)) {
          var temp = this.scope.generateUidIdentifierBasedOnNode(objRef);
          this.nodes.push(this.buildVariableDeclaration(temp, objRef));
          objRef = temp;
        }
        if (hasObjectRest(pattern5)) {
          var copiedPattern;
          for (var i2 = 0; i2 < pattern5.properties.length; i2++) {
            var prop2 = pattern5.properties[i2];
            if (isRestElement$3(prop2)) {
              break;
            }
            var key2 = prop2.key;
            if (prop2.computed && !this.scope.isPure(key2)) {
              var name2 = this.scope.generateUidIdentifierBasedOnNode(key2);
              this.nodes.push(this.buildVariableDeclaration(name2, key2));
              if (!copiedPattern) {
                copiedPattern = pattern5 = Object.assign({}, pattern5, {
                  properties: pattern5.properties.slice()
                });
              }
              copiedPattern.properties[i2] = Object.assign({}, copiedPattern.properties[i2], {
                key: name2
              });
            }
          }
        }
        for (var _i3 = 0; _i3 < pattern5.properties.length; _i3++) {
          var _prop = pattern5.properties[_i3];
          if (isRestElement$3(_prop)) {
            this.pushObjectRest(pattern5, objRef, _prop, _i3);
          } else {
            this.pushObjectProperty(_prop, objRef);
          }
        }
      };
      _proto.canUnpackArrayPattern = function canUnpackArrayPattern(pattern5, arr) {
        if (!isArrayExpression$2(arr))
          return false;
        if (pattern5.elements.length > arr.elements.length)
          return;
        if (pattern5.elements.length < arr.elements.length && !hasArrayRest(pattern5)) {
          return false;
        }
        for (var _iterator2 = _createForOfIteratorHelperLoose(pattern5.elements), _step2; !(_step2 = _iterator2()).done; ) {
          var elem = _step2.value;
          if (!elem)
            return false;
          if (isMemberExpression$8(elem))
            return false;
        }
        for (var _iterator22 = _createForOfIteratorHelperLoose(arr.elements), _step22; !(_step22 = _iterator22()).done; ) {
          var _elem = _step22.value;
          if (isSpreadElement$1(_elem))
            return false;
          if (isCallExpression$7(_elem))
            return false;
          if (isMemberExpression$8(_elem))
            return false;
        }
        var bindings = getBindingIdentifiers$2(pattern5);
        var state = {
          deopt: false,
          bindings
        };
        try {
          traverse$2(arr, arrayUnpackVisitor, state);
        } catch (e2) {
          if (e2 !== STOP_TRAVERSAL)
            throw e2;
        }
        return !state.deopt;
      };
      _proto.pushUnpackedArrayPattern = function pushUnpackedArrayPattern(pattern5, arr) {
        for (var i2 = 0; i2 < pattern5.elements.length; i2++) {
          var elem = pattern5.elements[i2];
          if (isRestElement$3(elem)) {
            this.push(elem.argument, arrayExpression$2(arr.elements.slice(i2)));
          } else {
            this.push(elem, arr.elements[i2]);
          }
        }
      };
      _proto.pushArrayPattern = function pushArrayPattern(pattern5, arrayRef) {
        if (arrayRef === null) {
          this.nodes.push(expressionStatement$a(callExpression$e(this.addHelper("objectDestructuringEmpty"), [])));
          return;
        }
        if (!pattern5.elements)
          return;
        if (this.canUnpackArrayPattern(pattern5, arrayRef)) {
          return this.pushUnpackedArrayPattern(pattern5, arrayRef);
        }
        var count2 = !hasArrayRest(pattern5) && pattern5.elements.length;
        var toArray2 = this.toArray(arrayRef, count2);
        if (isIdentifier$i(toArray2)) {
          arrayRef = toArray2;
        } else {
          arrayRef = this.scope.generateUidIdentifierBasedOnNode(arrayRef);
          this.arrayRefSet.add(arrayRef.name);
          this.nodes.push(this.buildVariableDeclaration(arrayRef, toArray2));
        }
        for (var i2 = 0; i2 < pattern5.elements.length; i2++) {
          var elem = pattern5.elements[i2];
          if (!elem)
            continue;
          var elemRef = void 0;
          if (isRestElement$3(elem)) {
            elemRef = this.toArray(arrayRef);
            elemRef = callExpression$e(memberExpression$b(elemRef, identifier$j("slice")), [numericLiteral$7(i2)]);
            this.push(elem.argument, elemRef);
          } else {
            elemRef = memberExpression$b(arrayRef, numericLiteral$7(i2), true);
            this.push(elem, elemRef);
          }
        }
      };
      _proto.init = function init3(pattern5, ref2) {
        if (!isArrayExpression$2(ref2) && !isMemberExpression$8(ref2)) {
          var memo = this.scope.maybeGenerateMemoised(ref2, true);
          if (memo) {
            this.nodes.push(this.buildVariableDeclaration(memo, cloneNode$i(ref2)));
            ref2 = memo;
          }
        }
        this.push(pattern5, ref2);
        return this.nodes;
      };
      return _createClass2(DestructuringTransformer2);
    }();
    function buildObjectExcludingKeys(excludedKeys, objRef, scope2, addHelper, objectRestNoSymbols, useBuiltIns) {
      var keys2 = [];
      var allLiteral = true;
      var hasTemplateLiteral = false;
      for (var i2 = 0; i2 < excludedKeys.length; i2++) {
        var prop2 = excludedKeys[i2];
        var key2 = prop2.key;
        if (isIdentifier$i(key2) && !prop2.computed) {
          keys2.push(stringLiteral$8(key2.name));
        } else if (isTemplateLiteral$2(key2)) {
          keys2.push(cloneNode$i(key2));
          hasTemplateLiteral = true;
        } else if (isLiteral$7(key2)) {
          keys2.push(stringLiteral$8(String(key2.value)));
        } else if (isPrivateName$2(key2))
          ;
        else {
          keys2.push(cloneNode$i(key2));
          allLiteral = false;
        }
      }
      var value;
      if (keys2.length === 0) {
        var extendsHelper = useBuiltIns ? memberExpression$b(identifier$j("Object"), identifier$j("assign")) : addHelper("extends");
        value = callExpression$e(extendsHelper, [objectExpression$4([]), cloneNode$i(objRef)]);
      } else {
        var keyExpression = arrayExpression$2(keys2);
        if (!allLiteral) {
          keyExpression = callExpression$e(memberExpression$b(keyExpression, identifier$j("map")), [addHelper("toPropertyKey")]);
        } else if (!hasTemplateLiteral && !isProgram$2(scope2.block)) {
          var programScope = scope2.getProgramParent();
          var id3 = programScope.generateUidIdentifier("excluded");
          programScope.push({
            id: id3,
            init: keyExpression,
            kind: "const"
          });
          keyExpression = cloneNode$i(id3);
        }
        value = callExpression$e(addHelper("objectWithoutProperties" + (objectRestNoSymbols ? "Loose" : "")), [cloneNode$i(objRef), keyExpression]);
      }
      return value;
    }
    function convertVariableDeclaration(path2, addHelper, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns) {
      var node2 = path2.node, scope2 = path2.scope;
      var nodeKind = node2.kind;
      var nodeLoc = node2.loc;
      var nodes2 = [];
      for (var i2 = 0; i2 < node2.declarations.length; i2++) {
        var declar = node2.declarations[i2];
        var patternId = declar.init;
        var pattern5 = declar.id;
        var destructuring = new DestructuringTransformer({
          blockHoist: node2._blockHoist,
          nodes: nodes2,
          scope: scope2,
          kind: node2.kind,
          iterableIsArray,
          arrayLikeIsIterable,
          useBuiltIns,
          objectRestNoSymbols,
          addHelper
        });
        if (isPattern2(pattern5)) {
          destructuring.init(pattern5, patternId);
          if (+i2 !== node2.declarations.length - 1) {
            inherits$1(nodes2[nodes2.length - 1], declar);
          }
        } else {
          nodes2.push(inherits$1(destructuring.buildVariableAssignment(pattern5, patternId), declar));
        }
      }
      var tail = null;
      var nodesOut = [];
      for (var _i22 = 0, _nodes = nodes2; _i22 < _nodes.length; _i22++) {
        var _node = _nodes[_i22];
        if (tail !== null && isVariableDeclaration$3(_node)) {
          var _tail$declarations;
          (_tail$declarations = tail.declarations).push.apply(_tail$declarations, _toConsumableArray2(_node.declarations));
        } else {
          _node.kind = nodeKind;
          if (!_node.loc) {
            _node.loc = nodeLoc;
          }
          nodesOut.push(_node);
          tail = isVariableDeclaration$3(_node) ? _node : null;
        }
      }
      for (var _i3 = 0, _nodesOut = nodesOut; _i3 < _nodesOut.length; _i3++) {
        var nodeOut = _nodesOut[_i3];
        if (!nodeOut.declarations)
          continue;
        for (var _iterator3 = _createForOfIteratorHelperLoose(nodeOut.declarations), _step3; !(_step3 = _iterator3()).done; ) {
          var declaration = _step3.value;
          var name2 = declaration.id.name;
          if (scope2.bindings[name2]) {
            scope2.bindings[name2].kind = nodeOut.kind;
          }
        }
      }
      if (nodesOut.length === 1) {
        path2.replaceWith(nodesOut[0]);
      } else {
        path2.replaceWithMultiple(nodesOut);
      }
    }
    function convertAssignmentExpression(path2, addHelper, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns) {
      var node2 = path2.node, scope2 = path2.scope;
      var nodes2 = [];
      var destructuring = new DestructuringTransformer({
        operator: node2.operator,
        scope: scope2,
        nodes: nodes2,
        arrayLikeIsIterable,
        iterableIsArray,
        objectRestNoSymbols,
        useBuiltIns,
        addHelper
      });
      var ref2;
      if (path2.isCompletionRecord() || !path2.parentPath.isExpressionStatement()) {
        ref2 = scope2.generateUidIdentifierBasedOnNode(node2.right, "ref");
        nodes2.push(variableDeclaration$7("var", [variableDeclarator$7(ref2, node2.right)]));
        if (isArrayExpression$2(node2.right)) {
          destructuring.arrayRefSet.add(ref2.name);
        }
      }
      destructuring.init(node2.left, ref2 || node2.right);
      if (ref2) {
        if (path2.parentPath.isArrowFunctionExpression()) {
          path2.replaceWith(blockStatement$6([]));
          nodes2.push(returnStatement$3(cloneNode$i(ref2)));
        } else {
          nodes2.push(expressionStatement$a(cloneNode$i(ref2)));
        }
      }
      path2.replaceWithMultiple(nodes2);
      path2.scope.crawl();
    }
    function variableDeclarationHasPattern(node2) {
      for (var _iterator2 = _createForOfIteratorHelperLoose(node2.declarations), _step2; !(_step2 = _iterator2()).done; ) {
        var declar = _step2.value;
        if (isPattern2(declar.id)) {
          return true;
        }
      }
      return false;
    }
    var _transformDestructuring = declare(function(api, options) {
      var _api$assumption, _options$allowArrayLi, _api$assumption2;
      api.assertVersion(7);
      var _options$useBuiltIns = options.useBuiltIns, useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns;
      var iterableIsArray = (_api$assumption = api.assumption("iterableIsArray")) != null ? _api$assumption : options.loose;
      var arrayLikeIsIterable = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable");
      var objectRestNoSymbols = (_api$assumption2 = api.assumption("objectRestNoSymbols")) != null ? _api$assumption2 : options.loose;
      return {
        name: "transform-destructuring",
        visitor: {
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2) {
            var declaration = path2.get("declaration");
            if (!declaration.isVariableDeclaration())
              return;
            if (!variableDeclarationHasPattern(declaration.node))
              return;
            var specifiers = [];
            for (var _i3 = 0, _Object$keys3 = Object.keys(path2.getOuterBindingIdentifiers()); _i3 < _Object$keys3.length; _i3++) {
              var name2 = _Object$keys3[_i3];
              specifiers.push(exportSpecifier$2(identifier$j(name2), identifier$j(name2)));
            }
            path2.replaceWith(declaration.node);
            path2.insertAfter(exportNamedDeclaration$2(null, specifiers));
          },
          ForXStatement: function ForXStatement(path2) {
            var _this = this;
            var node2 = path2.node, scope2 = path2.scope;
            var left = node2.left;
            if (isPattern2(left)) {
              var temp = scope2.generateUidIdentifier("ref");
              node2.left = variableDeclaration$7("var", [variableDeclarator$7(temp)]);
              path2.ensureBlock();
              var statementBody = node2.body.body;
              if (statementBody.length === 0 && path2.isCompletionRecord()) {
                statementBody.unshift(expressionStatement$a(scope2.buildUndefinedNode()));
              }
              statementBody.unshift(expressionStatement$a(assignmentExpression$c("=", left, temp)));
              return;
            }
            if (!isVariableDeclaration$3(left))
              return;
            var pattern5 = left.declarations[0].id;
            if (!isPattern2(pattern5))
              return;
            var key2 = scope2.generateUidIdentifier("ref");
            node2.left = variableDeclaration$7(left.kind, [variableDeclarator$7(key2, null)]);
            var nodes2 = [];
            var destructuring = new DestructuringTransformer({
              kind: left.kind,
              scope: scope2,
              nodes: nodes2,
              arrayLikeIsIterable,
              iterableIsArray,
              objectRestNoSymbols,
              useBuiltIns,
              addHelper: function addHelper(name2) {
                return _this.addHelper(name2);
              }
            });
            destructuring.init(pattern5, key2);
            path2.ensureBlock();
            var block = node2.body;
            block.body = nodes2.concat(block.body);
          },
          CatchClause: function CatchClause2(_ref3) {
            var _this2 = this;
            var node2 = _ref3.node, scope2 = _ref3.scope;
            var pattern5 = node2.param;
            if (!isPattern2(pattern5))
              return;
            var ref2 = scope2.generateUidIdentifier("ref");
            node2.param = ref2;
            var nodes2 = [];
            var destructuring = new DestructuringTransformer({
              kind: "let",
              scope: scope2,
              nodes: nodes2,
              arrayLikeIsIterable,
              iterableIsArray,
              objectRestNoSymbols,
              useBuiltIns,
              addHelper: function addHelper(name2) {
                return _this2.addHelper(name2);
              }
            });
            destructuring.init(pattern5, ref2);
            node2.body.body = nodes2.concat(node2.body.body);
          },
          AssignmentExpression: function AssignmentExpression2(path2, state) {
            if (!isPattern2(path2.node.left))
              return;
            convertAssignmentExpression(path2, function(name2) {
              return state.addHelper(name2);
            }, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns);
          },
          VariableDeclaration: function VariableDeclaration2(path2, state) {
            var node2 = path2.node, parent = path2.parent;
            if (isForXStatement$1(parent))
              return;
            if (!parent || !path2.container)
              return;
            if (!variableDeclarationHasPattern(node2))
              return;
            convertVariableDeclaration(path2, function(name2) {
              return state.addHelper(name2);
            }, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns);
          }
        }
      };
    });
    var _transformDotallRegex = declare(function(api) {
      api.assertVersion(7);
      return createRegExpFeaturePlugin({
        name: "transform-dotall-regex",
        feature: "dotAllFlag"
      });
    });
    function getName2(key2) {
      if (isIdentifier$i(key2)) {
        return key2.name;
      }
      return key2.value.toString();
    }
    var _transformDuplicateKeys = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-duplicate-keys",
        visitor: {
          ObjectExpression: function ObjectExpression2(path2) {
            var node2 = path2.node;
            var plainProps = node2.properties.filter(function(prop3) {
              return !isSpreadElement$1(prop3) && !prop3.computed;
            });
            var alreadySeenData = /* @__PURE__ */ Object.create(null);
            var alreadySeenGetters = /* @__PURE__ */ Object.create(null);
            var alreadySeenSetters = /* @__PURE__ */ Object.create(null);
            for (var _iterator2 = _createForOfIteratorHelperLoose(plainProps), _step2; !(_step2 = _iterator2()).done; ) {
              var prop2 = _step2.value;
              var name2 = getName2(prop2.key);
              var isDuplicate = false;
              switch (prop2.kind) {
                case "get":
                  if (alreadySeenData[name2] || alreadySeenGetters[name2]) {
                    isDuplicate = true;
                  }
                  alreadySeenGetters[name2] = true;
                  break;
                case "set":
                  if (alreadySeenData[name2] || alreadySeenSetters[name2]) {
                    isDuplicate = true;
                  }
                  alreadySeenSetters[name2] = true;
                  break;
                default:
                  if (alreadySeenData[name2] || alreadySeenGetters[name2] || alreadySeenSetters[name2]) {
                    isDuplicate = true;
                  }
                  alreadySeenData[name2] = true;
              }
              if (isDuplicate) {
                prop2.computed = true;
                prop2.key = stringLiteral$8(name2);
              }
            }
          }
        }
      };
    });
    var assignmentExpression$1 = assignmentExpression$c, cloneNode = cloneNode$i, isIdentifier$2 = isIdentifier$i, isLiteral$1 = isLiteral$7, isMemberExpression = isMemberExpression$8, isPrivateName = isPrivateName$2, isPureish = isPureish$2, isSuper = isSuper$3, memberExpression$1 = memberExpression$b, toComputedKey$1 = toComputedKey$3;
    function getObjRef(node2, nodes2, scope2) {
      var ref2;
      if (isIdentifier$2(node2)) {
        if (scope2.hasBinding(node2.name)) {
          return node2;
        } else {
          ref2 = node2;
        }
      } else if (isMemberExpression(node2)) {
        ref2 = node2.object;
        if (isSuper(ref2) || isIdentifier$2(ref2) && scope2.hasBinding(ref2.name)) {
          return ref2;
        }
      } else {
        throw new Error("We can't explode this node type " + node2["type"]);
      }
      var temp = scope2.generateUidIdentifierBasedOnNode(ref2);
      scope2.push({
        id: temp
      });
      nodes2.push(assignmentExpression$1("=", cloneNode(temp), cloneNode(ref2)));
      return temp;
    }
    function getPropRef(node2, nodes2, scope2) {
      var prop2 = node2.property;
      if (isPrivateName(prop2)) {
        throw new Error("We can't generate property ref for private name, please install `@babel/plugin-proposal-class-properties`");
      }
      var key2 = toComputedKey$1(node2, prop2);
      if (isLiteral$1(key2) && isPureish(key2))
        return key2;
      var temp = scope2.generateUidIdentifierBasedOnNode(prop2);
      scope2.push({
        id: temp
      });
      nodes2.push(assignmentExpression$1("=", cloneNode(temp), cloneNode(prop2)));
      return temp;
    }
    function explode(node2, nodes2, file2, scope2, allowedSingleIdent) {
      var obj;
      if (isIdentifier$2(node2) && allowedSingleIdent) {
        obj = node2;
      } else {
        obj = getObjRef(node2, nodes2, scope2);
      }
      var ref2, uid2;
      if (isIdentifier$2(node2)) {
        ref2 = cloneNode(node2);
        uid2 = obj;
      } else {
        var prop2 = getPropRef(node2, nodes2, scope2);
        var computed = node2.computed || isLiteral$1(prop2);
        uid2 = memberExpression$1(cloneNode(obj), cloneNode(prop2), computed);
        ref2 = memberExpression$1(cloneNode(obj), cloneNode(prop2), computed);
      }
      return {
        uid: uid2,
        ref: ref2
      };
    }
    var assignmentExpression = assignmentExpression$c, sequenceExpression = sequenceExpression$7;
    function build(opts) {
      var build2 = opts.build, operator = opts.operator;
      var visitor2 = {
        AssignmentExpression: function AssignmentExpression2(path2) {
          var node2 = path2.node, scope2 = path2.scope;
          if (node2.operator !== operator + "=")
            return;
          var nodes2 = [];
          var exploded = explode(node2.left, nodes2, this, scope2);
          nodes2.push(assignmentExpression("=", exploded.ref, build2(exploded.uid, node2.right)));
          path2.replaceWith(sequenceExpression(nodes2));
        },
        BinaryExpression: function BinaryExpression2(path2) {
          var node2 = path2.node;
          if (node2.operator === operator) {
            path2.replaceWith(build2(node2.left, node2.right));
          }
        }
      };
      return visitor2;
    }
    var transformExponentialOperator = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-exponentiation-operator",
        visitor: build({
          operator: "**",
          build: function build2(left, right) {
            return callExpression$e(memberExpression$b(identifier$j("Math"), identifier$j("pow")), [left, right]);
          }
        })
      };
    });
    var transformFlowComments = declare(function(api) {
      api.assertVersion(7);
      function commentFromString(comment) {
        return typeof comment === "string" ? {
          type: "CommentBlock",
          value: comment
        } : comment;
      }
      function attachComment(_ref3) {
        var _toPath;
        var ofPath = _ref3.ofPath, toPath = _ref3.toPath, _ref$where = _ref3.where, where = _ref$where === void 0 ? "trailing" : _ref$where, _ref$optional = _ref3.optional, optional = _ref$optional === void 0 ? false : _ref$optional, _ref$comments = _ref3.comments, comments = _ref$comments === void 0 ? generateComment(ofPath, optional) : _ref$comments, _ref$keepType = _ref3.keepType, keepType = _ref$keepType === void 0 ? false : _ref$keepType;
        if (!((_toPath = toPath) != null && _toPath.node)) {
          toPath = ofPath.getPrevSibling();
          where = "trailing";
        }
        if (!toPath.node) {
          toPath = ofPath.getNextSibling();
          where = "leading";
        }
        if (!toPath.node) {
          toPath = ofPath.parentPath;
          where = "inner";
        }
        if (!Array.isArray(comments)) {
          comments = [comments];
        }
        comments = comments.map(commentFromString);
        if (!keepType && ofPath != null && ofPath.node) {
          var node2 = ofPath.node;
          var parent = ofPath.parentPath;
          var prev = ofPath.getPrevSibling();
          var next = ofPath.getNextSibling();
          var isSingleChild = !(prev.node || next.node);
          var leading = node2.leadingComments;
          var trailing = node2.trailingComments;
          if (isSingleChild && leading) {
            parent.addComments("inner", leading);
          }
          toPath.addComments(where, comments);
          ofPath.remove();
          if (isSingleChild && trailing) {
            parent.addComments("inner", trailing);
          }
        } else {
          toPath.addComments(where, comments);
        }
      }
      function wrapInFlowComment(path2) {
        attachComment({
          ofPath: path2,
          comments: generateComment(path2, path2.parent.optional)
        });
      }
      function generateComment(path2, optional) {
        var comment = path2.getSource().replace(/\*-\//g, "*-ESCAPED/").replace(/\*\//g, "*-/");
        if (optional)
          comment = "?" + comment;
        if (comment[0] !== ":")
          comment = ":: " + comment;
        return comment;
      }
      function isTypeImport(importKind) {
        return importKind === "type" || importKind === "typeof";
      }
      return {
        name: "transform-flow-comments",
        inherits: syntaxFlow,
        visitor: {
          TypeCastExpression: function TypeCastExpression2(path2) {
            var node2 = path2.node;
            attachComment({
              ofPath: path2.get("typeAnnotation"),
              toPath: path2.get("expression"),
              keepType: true
            });
            path2.replaceWith(parenthesizedExpression(node2.expression));
          },
          Identifier: function Identifier2(path2) {
            if (path2.parentPath.isFlow())
              return;
            var node2 = path2.node;
            if (node2.typeAnnotation) {
              attachComment({
                ofPath: path2.get("typeAnnotation"),
                toPath: path2,
                optional: node2.optional || node2.typeAnnotation.optional
              });
              if (node2.optional) {
                node2.optional = false;
              }
            } else if (node2.optional) {
              attachComment({
                toPath: path2,
                comments: ":: ?"
              });
              node2.optional = false;
            }
          },
          AssignmentPattern: {
            exit: function exit(_ref22) {
              var node2 = _ref22.node;
              var left = node2.left;
              if (left.optional) {
                left.optional = false;
              }
            }
          },
          Function: function Function2(path2) {
            if (path2.isDeclareFunction())
              return;
            var node2 = path2.node;
            if (node2.typeParameters) {
              attachComment({
                ofPath: path2.get("typeParameters"),
                toPath: path2.get("id"),
                optional: node2.typeParameters.optional
              });
            }
            if (node2.returnType) {
              attachComment({
                ofPath: path2.get("returnType"),
                toPath: path2.get("body"),
                where: "leading",
                optional: node2.returnType.typeAnnotation.optional
              });
            }
          },
          ClassProperty: function ClassProperty2(path2) {
            var node2 = path2.node;
            if (!node2.value) {
              wrapInFlowComment(path2);
            } else if (node2.typeAnnotation) {
              attachComment({
                ofPath: path2.get("typeAnnotation"),
                toPath: path2.get("key"),
                optional: node2.typeAnnotation.optional
              });
            }
          },
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2) {
            var node2 = path2.node;
            if (node2.exportKind !== "type" && !isFlow$1(node2.declaration)) {
              return;
            }
            wrapInFlowComment(path2);
          },
          ImportDeclaration: function ImportDeclaration2(path2) {
            var node2 = path2.node;
            if (isTypeImport(node2.importKind)) {
              wrapInFlowComment(path2);
              return;
            }
            var typeSpecifiers = node2.specifiers.filter(function(specifier) {
              return isTypeImport(specifier.importKind);
            });
            var nonTypeSpecifiers = node2.specifiers.filter(function(specifier) {
              return !isTypeImport(specifier.importKind);
            });
            node2.specifiers = nonTypeSpecifiers;
            if (typeSpecifiers.length > 0) {
              var typeImportNode = cloneNode$i(node2);
              typeImportNode.specifiers = typeSpecifiers;
              var comment = ":: " + generate$12(typeImportNode).code;
              if (nonTypeSpecifiers.length > 0) {
                attachComment({
                  toPath: path2,
                  comments: comment
                });
              } else {
                attachComment({
                  ofPath: path2,
                  comments: comment
                });
              }
            }
          },
          ObjectPattern: function ObjectPattern(path2) {
            var node2 = path2.node;
            if (node2.typeAnnotation) {
              attachComment({
                ofPath: path2.get("typeAnnotation"),
                toPath: path2,
                optional: node2.optional || node2.typeAnnotation.optional
              });
            }
          },
          Flow: function Flow2(path2) {
            wrapInFlowComment(path2);
          },
          Class: function Class(path2) {
            var node2 = path2.node;
            var comments = [];
            if (node2.typeParameters) {
              var typeParameters = path2.get("typeParameters");
              comments.push(generateComment(typeParameters, node2.typeParameters.optional));
              var trailingComments = node2.typeParameters.trailingComments;
              if (trailingComments) {
                var _comments;
                (_comments = comments).push.apply(_comments, _toConsumableArray2(trailingComments));
              }
              typeParameters.remove();
            }
            if (node2.superClass) {
              if (comments.length > 0) {
                attachComment({
                  toPath: path2.get("id"),
                  comments
                });
                comments = [];
              }
              if (node2.superTypeParameters) {
                var superTypeParameters = path2.get("superTypeParameters");
                comments.push(generateComment(superTypeParameters, superTypeParameters.node.optional));
                superTypeParameters.remove();
              }
            }
            if (node2["implements"]) {
              var impls = path2.get("implements");
              var comment = "implements " + impls.map(function(impl) {
                return generateComment(impl).replace(/^:: /, "");
              }).join(", ");
              delete node2["implements"];
              if (comments.length === 1) {
                comments[0] += " " + comment;
              } else {
                comments.push(":: " + comment);
              }
            }
            if (comments.length > 0) {
              attachComment({
                toPath: path2.get("body"),
                where: "leading",
                comments
              });
            }
          }
        }
      };
    });
    var transformFlowStripTypes = declare(function(api, opts) {
      api.assertVersion(7);
      var FLOW_DIRECTIVE = /(@flow(\s+(strict(-local)?|weak))?|@noflow)/;
      var skipStrip = false;
      var _opts$requireDirectiv = opts.requireDirective, requireDirective = _opts$requireDirectiv === void 0 ? false : _opts$requireDirectiv;
      {
        var _opts$allowDeclareFie = opts.allowDeclareFields, allowDeclareFields = _opts$allowDeclareFie === void 0 ? false : _opts$allowDeclareFie;
      }
      return {
        name: "transform-flow-strip-types",
        inherits: syntaxFlow,
        visitor: {
          Program: function Program2(path2, _ref3) {
            var comments = _ref3.file.ast.comments;
            skipStrip = false;
            var directiveFound = false;
            if (comments) {
              for (var _iterator2 = _createForOfIteratorHelperLoose(comments), _step2; !(_step2 = _iterator2()).done; ) {
                var comment = _step2.value;
                if (FLOW_DIRECTIVE.test(comment.value)) {
                  directiveFound = true;
                  comment.value = comment.value.replace(FLOW_DIRECTIVE, "");
                  if (!comment.value.replace(/\*/g, "").trim()) {
                    comment.ignore = true;
                  }
                }
              }
            }
            if (!directiveFound && requireDirective) {
              skipStrip = true;
            }
          },
          ImportDeclaration: function ImportDeclaration2(path2) {
            if (skipStrip)
              return;
            if (!path2.node.specifiers.length)
              return;
            var typeCount = 0;
            path2.node.specifiers.forEach(function(_ref22) {
              var importKind = _ref22.importKind;
              if (importKind === "type" || importKind === "typeof") {
                typeCount++;
              }
            });
            if (typeCount === path2.node.specifiers.length) {
              path2.remove();
            }
          },
          Flow: function Flow2(path2) {
            if (skipStrip) {
              throw path2.buildCodeFrameError("A @flow directive is required when using Flow annotations with the `requireDirective` option.");
            }
            path2.remove();
          },
          ClassPrivateProperty: function ClassPrivateProperty2(path2) {
            if (skipStrip)
              return;
            path2.node.typeAnnotation = null;
          },
          Class: function Class(path2) {
            if (skipStrip)
              return;
            path2.node["implements"] = null;
            path2.get("body.body").forEach(function(child) {
              if (child.isClassProperty()) {
                var node2 = child.node;
                {
                  if (!allowDeclareFields && node2.declare) {
                    throw child.buildCodeFrameError("The 'declare' modifier is only allowed when the 'allowDeclareFields' option of @babel/plugin-transform-flow-strip-types or @babel/preset-flow is enabled.");
                  }
                }
                if (node2.declare) {
                  child.remove();
                } else {
                  {
                    if (!allowDeclareFields && !node2.value && !node2.decorators) {
                      child.remove();
                      return;
                    }
                  }
                  node2.variance = null;
                  node2.typeAnnotation = null;
                }
              }
            });
          },
          AssignmentPattern: function AssignmentPattern2(_ref3) {
            var node2 = _ref3.node;
            if (skipStrip)
              return;
            node2.left.optional = false;
          },
          Function: function Function2(_ref42) {
            var node2 = _ref42.node;
            if (skipStrip)
              return;
            if (node2.params.length > 0 && node2.params[0].type === "Identifier" && node2.params[0].name === "this") {
              node2.params.shift();
            }
            for (var i2 = 0; i2 < node2.params.length; i2++) {
              var param = node2.params[i2];
              param.optional = false;
              if (param.type === "AssignmentPattern") {
                param.left.optional = false;
              }
            }
            node2.predicate = null;
          },
          TypeCastExpression: function TypeCastExpression2(path2) {
            if (skipStrip)
              return;
            var node2 = path2.node;
            do {
              node2 = node2.expression;
            } while (isTypeCastExpression$1(node2));
            path2.replaceWith(node2);
          },
          CallExpression: function CallExpression2(_ref5) {
            var node2 = _ref5.node;
            if (skipStrip)
              return;
            node2.typeArguments = null;
          },
          OptionalCallExpression: function OptionalCallExpression2(_ref6) {
            var node2 = _ref6.node;
            if (skipStrip)
              return;
            node2.typeArguments = null;
          },
          NewExpression: function NewExpression2(_ref7) {
            var node2 = _ref7.node;
            if (skipStrip)
              return;
            node2.typeArguments = null;
          }
        }
      };
    });
    function transformWithoutHelper(loose, path2, state) {
      var _block$body;
      var pushComputedProps = loose ? pushComputedPropsLoose : pushComputedPropsSpec;
      var node2 = path2.node;
      var build2 = pushComputedProps(path2, state);
      var declar = build2.declar;
      var loop = build2.loop;
      var block = loop.body;
      path2.ensureBlock();
      if (declar) {
        block.body.push(declar);
      }
      (_block$body = block.body).push.apply(_block$body, _toConsumableArray2(node2.body.body));
      inherits$1(loop, node2);
      inherits$1(loop.body, node2.body);
      if (build2.replaceParent) {
        path2.parentPath.replaceWithMultiple(build2.node);
        path2.remove();
      } else {
        path2.replaceWithMultiple(build2.node);
      }
    }
    var buildForOfLoose = template$2("\n  for (var LOOP_OBJECT = OBJECT,\n          IS_ARRAY = Array.isArray(LOOP_OBJECT),\n          INDEX = 0,\n          LOOP_OBJECT = IS_ARRAY ? LOOP_OBJECT : LOOP_OBJECT[Symbol.iterator]();;) {\n    INTERMEDIATE;\n    if (IS_ARRAY) {\n      if (INDEX >= LOOP_OBJECT.length) break;\n      ID = LOOP_OBJECT[INDEX++];\n    } else {\n      INDEX = LOOP_OBJECT.next();\n      if (INDEX.done) break;\n      ID = INDEX.value;\n    }\n  }\n");
    var buildForOf = template$2("\n  var ITERATOR_COMPLETION = true;\n  var ITERATOR_HAD_ERROR_KEY = false;\n  var ITERATOR_ERROR_KEY = undefined;\n  try {\n    for (\n      var ITERATOR_KEY = OBJECT[Symbol.iterator](), STEP_KEY;\n      !(ITERATOR_COMPLETION = (STEP_KEY = ITERATOR_KEY.next()).done);\n      ITERATOR_COMPLETION = true\n    ) {}\n  } catch (err) {\n    ITERATOR_HAD_ERROR_KEY = true;\n    ITERATOR_ERROR_KEY = err;\n  } finally {\n    try {\n      if (!ITERATOR_COMPLETION && ITERATOR_KEY.return != null) {\n        ITERATOR_KEY.return();\n      }\n    } finally {\n      if (ITERATOR_HAD_ERROR_KEY) {\n        throw ITERATOR_ERROR_KEY;\n      }\n    }\n  }\n");
    function pushComputedPropsLoose(path2, file2) {
      var node2 = path2.node, scope2 = path2.scope, parent = path2.parent;
      var left = node2.left;
      var declar, id3, intermediate;
      if (isIdentifier$i(left) || isPattern2(left) || isMemberExpression$8(left)) {
        id3 = left;
        intermediate = null;
      } else if (isVariableDeclaration$3(left)) {
        id3 = scope2.generateUidIdentifier("ref");
        declar = variableDeclaration$7(left.kind, [variableDeclarator$7(left.declarations[0].id, identifier$j(id3.name))]);
        intermediate = variableDeclaration$7("var", [variableDeclarator$7(identifier$j(id3.name))]);
      } else {
        throw file2.buildCodeFrameError(left, "Unknown node type " + left.type + " in ForStatement");
      }
      var iteratorKey = scope2.generateUidIdentifier("iterator");
      var isArrayKey = scope2.generateUidIdentifier("isArray");
      var loop = buildForOfLoose({
        LOOP_OBJECT: iteratorKey,
        IS_ARRAY: isArrayKey,
        OBJECT: node2.right,
        INDEX: scope2.generateUidIdentifier("i"),
        ID: id3,
        INTERMEDIATE: intermediate
      });
      var isLabeledParent = isLabeledStatement(parent);
      var labeled;
      if (isLabeledParent) {
        labeled = labeledStatement(parent.label, loop);
      }
      return {
        replaceParent: isLabeledParent,
        declar,
        node: labeled || loop,
        loop
      };
    }
    function pushComputedPropsSpec(path2, file2) {
      var node2 = path2.node, scope2 = path2.scope, parent = path2.parent;
      var left = node2.left;
      var declar;
      var stepKey = scope2.generateUid("step");
      var stepValue = memberExpression$b(identifier$j(stepKey), identifier$j("value"));
      if (isIdentifier$i(left) || isPattern2(left) || isMemberExpression$8(left)) {
        declar = expressionStatement$a(assignmentExpression$c("=", left, stepValue));
      } else if (isVariableDeclaration$3(left)) {
        declar = variableDeclaration$7(left.kind, [variableDeclarator$7(left.declarations[0].id, stepValue)]);
      } else {
        throw file2.buildCodeFrameError(left, "Unknown node type " + left.type + " in ForStatement");
      }
      var template2 = buildForOf({
        ITERATOR_HAD_ERROR_KEY: scope2.generateUidIdentifier("didIteratorError"),
        ITERATOR_COMPLETION: scope2.generateUidIdentifier("iteratorNormalCompletion"),
        ITERATOR_ERROR_KEY: scope2.generateUidIdentifier("iteratorError"),
        ITERATOR_KEY: scope2.generateUidIdentifier("iterator"),
        STEP_KEY: identifier$j(stepKey),
        OBJECT: node2.right
      });
      var isLabeledParent = isLabeledStatement(parent);
      var tryBody = template2[3].block.body;
      var loop = tryBody[0];
      if (isLabeledParent) {
        tryBody[0] = labeledStatement(parent.label, loop);
      }
      return {
        replaceParent: isLabeledParent,
        declar,
        loop,
        node: template2
      };
    }
    var _templateObject$9, _templateObject2$5, _templateObject3$4;
    var _transformForOf = declare(function(api, options) {
      var _options$assumeArray, _options$allowArrayLi, _api$assumption;
      api.assertVersion(7);
      {
        var assumeArray = options.assumeArray, allowArrayLike = options.allowArrayLike, loose = options.loose;
        if (loose === true && assumeArray === true) {
          throw new Error("The loose and assumeArray options cannot be used together in @babel/plugin-transform-for-of");
        }
        if (assumeArray === true && allowArrayLike === true) {
          throw new Error("The assumeArray and allowArrayLike options cannot be used together in @babel/plugin-transform-for-of");
        }
        if (allowArrayLike && /^7\.\d\./.test(api.version)) {
          throw new Error("The allowArrayLike is only supported when using @babel/core@^7.10.0");
        }
      }
      var iterableIsArray = (_options$assumeArray = options.assumeArray) != null ? _options$assumeArray : !options.loose && api.assumption("iterableIsArray");
      var arrayLikeIsIterable = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable");
      var skipteratorClosing = (_api$assumption = api.assumption("skipForOfIteratorClosing")) != null ? _api$assumption : options.loose;
      if (iterableIsArray && arrayLikeIsIterable) {
        throw new Error('The "iterableIsArray" and "arrayLikeIsIterable" assumptions are not compatible.');
      }
      if (iterableIsArray) {
        return {
          name: "transform-for-of",
          visitor: {
            ForOfStatement: function ForOfStatement2(path2) {
              var scope2 = path2.scope;
              var _path$node = path2.node, left = _path$node.left, right = _path$node.right, isAwait = _path$node["await"];
              if (isAwait) {
                return;
              }
              var i2 = scope2.generateUidIdentifier("i");
              var array4 = scope2.maybeGenerateMemoised(right, true);
              var inits = [variableDeclarator$7(i2, numericLiteral$7(0))];
              if (array4) {
                inits.push(variableDeclarator$7(array4, right));
              } else {
                array4 = right;
              }
              var item = memberExpression$b(cloneNode$i(array4), cloneNode$i(i2), true);
              var assignment;
              if (isVariableDeclaration$3(left)) {
                assignment = left;
                assignment.declarations[0].init = item;
              } else {
                assignment = expressionStatement$a(assignmentExpression$c("=", left, item));
              }
              var blockBody;
              var body = path2.get("body");
              if (body.isBlockStatement() && Object.keys(path2.getBindingIdentifiers()).some(function(id3) {
                return body.scope.hasOwnBinding(id3);
              })) {
                blockBody = blockStatement$6([assignment, body.node]);
              } else {
                blockBody = toBlock(body.node);
                blockBody.body.unshift(assignment);
              }
              path2.replaceWith(forStatement(variableDeclaration$7("let", inits), binaryExpression$4("<", cloneNode$i(i2), memberExpression$b(cloneNode$i(array4), identifier$j("length"))), updateExpression$1("++", cloneNode$i(i2)), blockBody));
            }
          }
        };
      }
      var buildForOfArray = template$2(_templateObject$9 || (_templateObject$9 = _taggedTemplateLiteralLoose(["\n    for (var KEY = 0, NAME = ARR; KEY < NAME.length; KEY++) BODY;\n  "])));
      var buildForOfNoIteratorClosing = template$2.statements(_templateObject2$5 || (_templateObject2$5 = _taggedTemplateLiteralLoose(["\n    for (var ITERATOR_HELPER = CREATE_ITERATOR_HELPER(OBJECT, ARRAY_LIKE_IS_ITERABLE), STEP_KEY;\n        !(STEP_KEY = ITERATOR_HELPER()).done;) BODY;\n  "])));
      var buildForOf2 = template$2.statements(_templateObject3$4 || (_templateObject3$4 = _taggedTemplateLiteralLoose(["\n    var ITERATOR_HELPER = CREATE_ITERATOR_HELPER(OBJECT, ARRAY_LIKE_IS_ITERABLE), STEP_KEY;\n    try {\n      for (ITERATOR_HELPER.s(); !(STEP_KEY = ITERATOR_HELPER.n()).done;) BODY;\n    } catch (err) {\n      ITERATOR_HELPER.e(err);\n    } finally {\n      ITERATOR_HELPER.f();\n    }\n  "])));
      var builder2 = skipteratorClosing ? {
        build: buildForOfNoIteratorClosing,
        helper: "createForOfIteratorHelperLoose",
        getContainer: function getContainer2(nodes2) {
          return nodes2;
        }
      } : {
        build: buildForOf2,
        helper: "createForOfIteratorHelper",
        getContainer: function getContainer2(nodes2) {
          return nodes2[1].block.body;
        }
      };
      function _ForOfStatementArray(path2) {
        var node2 = path2.node, scope2 = path2.scope;
        var right = scope2.generateUidIdentifierBasedOnNode(node2.right, "arr");
        var iterationKey = scope2.generateUidIdentifier("i");
        var loop = buildForOfArray({
          BODY: node2.body,
          KEY: iterationKey,
          NAME: right,
          ARR: node2.right
        });
        inherits$1(loop, node2);
        ensureBlock$1(loop);
        var iterationValue = memberExpression$b(cloneNode$i(right), cloneNode$i(iterationKey), true);
        var left = node2.left;
        if (isVariableDeclaration$3(left)) {
          left.declarations[0].init = iterationValue;
          loop.body.body.unshift(left);
        } else {
          loop.body.body.unshift(expressionStatement$a(assignmentExpression$c("=", left, iterationValue)));
        }
        return loop;
      }
      return {
        name: "transform-for-of",
        visitor: {
          ForOfStatement: function ForOfStatement2(path2, state) {
            var right = path2.get("right");
            if (right.isArrayExpression() || right.isGenericType("Array") || isArrayTypeAnnotation$1(right.getTypeAnnotation())) {
              path2.replaceWith(_ForOfStatementArray(path2));
              return;
            }
            if (!state.availableHelper(builder2.helper)) {
              transformWithoutHelper(skipteratorClosing, path2, state);
              return;
            }
            var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
            var left = node2.left;
            var declar;
            var stepKey = scope2.generateUid("step");
            var stepValue = memberExpression$b(identifier$j(stepKey), identifier$j("value"));
            if (isVariableDeclaration$3(left)) {
              declar = variableDeclaration$7(left.kind, [variableDeclarator$7(left.declarations[0].id, stepValue)]);
            } else {
              declar = expressionStatement$a(assignmentExpression$c("=", left, stepValue));
            }
            path2.ensureBlock();
            node2.body.body.unshift(declar);
            var nodes2 = builder2.build({
              CREATE_ITERATOR_HELPER: state.addHelper(builder2.helper),
              ITERATOR_HELPER: scope2.generateUidIdentifier("iterator"),
              ARRAY_LIKE_IS_ITERABLE: arrayLikeIsIterable ? booleanLiteral$5(true) : null,
              STEP_KEY: identifier$j(stepKey),
              OBJECT: node2.right,
              BODY: node2.body
            });
            var container2 = builder2.getContainer(nodes2);
            inherits$1(container2[0], node2);
            inherits$1(container2[0].body, node2.body);
            if (isLabeledStatement(parent)) {
              container2[0] = labeledStatement(parent.label, container2[0]);
              path2.parentPath.replaceWithMultiple(nodes2);
              path2.skip();
            } else {
              path2.replaceWithMultiple(nodes2);
            }
          }
        }
      };
    });
    var _transformFunctionName = declare(function(api) {
      api.assertVersion(7);
      var supportUnicodeId = !isRequired("transform-unicode-escapes", api.targets());
      return {
        name: "transform-function-name",
        visitor: {
          FunctionExpression: {
            exit: function exit(path2) {
              if (path2.key !== "value" && !path2.parentPath.isObjectProperty()) {
                var replacement = nameFunction(path2);
                if (replacement)
                  path2.replaceWith(replacement);
              }
            }
          },
          ObjectProperty: function ObjectProperty2(path2) {
            var value = path2.get("value");
            if (value.isFunction()) {
              var newNode = nameFunction(value, false, supportUnicodeId);
              if (newNode)
                value.replaceWith(newNode);
            }
          }
        }
      };
    });
    var transformInstanceof = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-instanceof",
        visitor: {
          BinaryExpression: function BinaryExpression2(path2) {
            var node2 = path2.node;
            if (node2.operator === "instanceof") {
              var helper2 = this.addHelper("instanceof");
              var isUnderHelper = path2.findParent(function(path3) {
                return path3.isVariableDeclarator() && path3.node.id === helper2 || path3.isFunctionDeclaration() && path3.node.id && path3.node.id.name === helper2.name;
              });
              if (isUnderHelper) {
                return;
              } else {
                path2.replaceWith(callExpression$e(helper2, [node2.left, node2.right]));
              }
            }
          }
        }
      };
    });
    var transformJscript = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-jscript",
        visitor: {
          FunctionExpression: {
            exit: function exit(path2) {
              var node2 = path2.node;
              if (!node2.id)
                return;
              path2.replaceWith(callExpression$e(functionExpression$3(null, [], blockStatement$6([toStatement(node2), returnStatement$3(cloneNode$i(node2.id))])), []));
            }
          }
        }
      };
    });
    var _transformLiterals = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-literals",
        visitor: {
          NumericLiteral: function NumericLiteral2(_ref3) {
            var node2 = _ref3.node;
            if (node2.extra && /^0[ob]/i.test(node2.extra.raw)) {
              node2.extra = void 0;
            }
          },
          StringLiteral: function StringLiteral2(_ref22) {
            var node2 = _ref22.node;
            if (node2.extra && /\\[u]/gi.test(node2.extra.raw)) {
              node2.extra = void 0;
            }
          }
        }
      };
    });
    var _transformMemberExpressionLiterals = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-member-expression-literals",
        visitor: {
          MemberExpression: {
            exit: function exit(_ref3) {
              var node2 = _ref3.node;
              var prop2 = node2.property;
              if (!node2.computed && isIdentifier$i(prop2) && !isValidES3Identifier(prop2.name)) {
                node2.property = stringLiteral$8(prop2.name);
                node2.computed = true;
              }
            }
          }
        }
      };
    });
    var utils$12 = {};
    Object.defineProperty(utils$12, "__esModule", {
      value: true
    });
    var _slicedToArray2 = function() {
      function sliceIterator(arr, i2) {
        var _arr = [];
        var _n = true;
        var _d = false;
        var _e = void 0;
        try {
          for (var _i3 = arr[Symbol.iterator](), _s; !(_n = (_s = _i3.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i2 && _arr.length === i2)
              break;
          }
        } catch (err) {
          _d = true;
          _e = err;
        } finally {
          try {
            if (!_n && _i3["return"])
              _i3["return"]();
          } finally {
            if (_d)
              throw _e;
          }
        }
        return _arr;
      }
      return function(arr, i2) {
        if (Array.isArray(arr)) {
          return arr;
        } else if (Symbol.iterator in Object(arr)) {
          return sliceIterator(arr, i2);
        } else {
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        }
      };
    }();
    utils$12.getImportSource = getImportSource$3;
    utils$12.createDynamicImportTransform = createDynamicImportTransform;
    function getImportSource$3(t3, callNode) {
      var importArguments = callNode.arguments;
      var _importArguments = _slicedToArray2(importArguments, 1), importPath = _importArguments[0];
      var isString2 = t3.isStringLiteral(importPath) || t3.isTemplateLiteral(importPath);
      if (isString2) {
        t3.removeComments(importPath);
        return importPath;
      }
      return t3.templateLiteral([t3.templateElement({
        raw: "",
        cooked: ""
      }), t3.templateElement({
        raw: "",
        cooked: ""
      }, true)], importArguments);
    }
    function createDynamicImportTransform(_ref3) {
      var template2 = _ref3.template, t3 = _ref3.types;
      var builders2 = {
        "static": {
          interop: template2("Promise.resolve().then(() => INTEROP(require(SOURCE)))"),
          noInterop: template2("Promise.resolve().then(() => require(SOURCE))")
        },
        dynamic: {
          interop: template2("Promise.resolve(SOURCE).then(s => INTEROP(require(s)))"),
          noInterop: template2("Promise.resolve(SOURCE).then(s => require(s))")
        }
      };
      var visited = typeof WeakSet === "function" && /* @__PURE__ */ new WeakSet();
      var isString2 = function isString3(node2) {
        return t3.isStringLiteral(node2) || t3.isTemplateLiteral(node2) && node2.expressions.length === 0;
      };
      return function(context, path2) {
        if (visited) {
          if (visited.has(path2)) {
            return;
          }
          visited.add(path2);
        }
        var SOURCE = getImportSource$3(t3, path2.parent);
        var builder2 = isString2(SOURCE) ? builders2["static"] : builders2.dynamic;
        var newImport = context.opts.noInterop ? builder2.noInterop({
          SOURCE
        }) : builder2.interop({
          SOURCE,
          INTEROP: context.addHelper("interopRequireWildcard")
        });
        path2.parentPath.replaceWith(newImport);
      };
    }
    var utils2 = utils$12;
    var _templateObject$8;
    var buildWrapper$1 = template$2("\n  define(MODULE_NAME, AMD_ARGUMENTS, function(IMPORT_NAMES) {\n  })\n");
    var buildAnonymousWrapper = template$2('\n  define(["require"], function(REQUIRE) {\n  })\n');
    function injectWrapper(path2, wrapper) {
      var _path$node = path2.node, body = _path$node.body, directives = _path$node.directives;
      path2.node.directives = [];
      path2.node.body = [];
      var amdWrapper = path2.pushContainer("body", wrapper)[0];
      var amdFactory = amdWrapper.get("expression.arguments").filter(function(arg) {
        return arg.isFunctionExpression();
      })[0].get("body");
      amdFactory.pushContainer("directives", directives);
      amdFactory.pushContainer("body", body);
    }
    var _transformModulesAmd = declare(function(api, options) {
      var _api$assumption, _api$assumption2;
      api.assertVersion(7);
      var allowTopLevelThis = options.allowTopLevelThis, strict2 = options.strict, strictMode = options.strictMode, importInterop = options.importInterop, noInterop = options.noInterop;
      var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : options.loose;
      var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : options.loose;
      return {
        name: "transform-modules-amd",
        pre: function pre() {
          this.file.set("@babel/plugin-transform-modules-*", "amd");
        },
        visitor: {
          CallExpression: function CallExpression2(path2, state) {
            if (!this.file.has("@babel/plugin-proposal-dynamic-import"))
              return;
            if (!path2.get("callee").isImport())
              return;
            var requireId = state.requireId, resolveId2 = state.resolveId, rejectId = state.rejectId;
            if (!requireId) {
              requireId = path2.scope.generateUidIdentifier("require");
              state.requireId = requireId;
            }
            if (!resolveId2 || !rejectId) {
              resolveId2 = path2.scope.generateUidIdentifier("resolve");
              rejectId = path2.scope.generateUidIdentifier("reject");
              state.resolveId = resolveId2;
              state.rejectId = rejectId;
            }
            var result = identifier$j("imported");
            if (!noInterop)
              result = wrapInterop(path2, result, "namespace");
            path2.replaceWith(template$2.expression.ast(_templateObject$8 || (_templateObject$8 = _taggedTemplateLiteralLoose(["\n            new Promise((", ", ", ") =>\n              ", "(\n                [", "],\n                imported => ", "(", "),\n                ", "\n              )\n            )"])), resolveId2, rejectId, requireId, utils2.getImportSource(t$a, path2.node), cloneNode$i(resolveId2), result, cloneNode$i(rejectId)));
          },
          Program: {
            exit: function exit(path2, _ref3) {
              var requireId = _ref3.requireId;
              if (!isModule(path2)) {
                if (requireId) {
                  injectWrapper(path2, buildAnonymousWrapper({
                    REQUIRE: cloneNode$i(requireId)
                  }));
                }
                return;
              }
              var amdArgs = [];
              var importNames = [];
              if (requireId) {
                amdArgs.push(stringLiteral$8("require"));
                importNames.push(cloneNode$i(requireId));
              }
              var moduleName = getModuleName(this.file.opts, options);
              if (moduleName)
                moduleName = stringLiteral$8(moduleName);
              var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path2, {
                enumerableModuleMeta,
                constantReexports,
                strict: strict2,
                strictMode,
                allowTopLevelThis,
                importInterop,
                noInterop
              }), meta2 = _rewriteModuleStateme.meta, headers = _rewriteModuleStateme.headers;
              if (hasExports(meta2)) {
                amdArgs.push(stringLiteral$8("exports"));
                importNames.push(identifier$j(meta2.exportName));
              }
              for (var _iterator2 = _createForOfIteratorHelperLoose(meta2.source), _step2; !(_step2 = _iterator2()).done; ) {
                var _step$value = _slicedToArray$12(_step2.value, 2), source = _step$value[0], metadata = _step$value[1];
                amdArgs.push(stringLiteral$8(source));
                importNames.push(identifier$j(metadata.name));
                if (!isSideEffectImport(metadata)) {
                  var interop = wrapInterop(path2, identifier$j(metadata.name), metadata.interop);
                  if (interop) {
                    var header = expressionStatement$a(assignmentExpression$c("=", identifier$j(metadata.name), interop));
                    header.loc = metadata.loc;
                    headers.push(header);
                  }
                }
                headers.push.apply(headers, _toConsumableArray2(buildNamespaceInitStatements(meta2, metadata, constantReexports)));
              }
              ensureStatementsHoisted(headers);
              path2.unshiftContainer("body", headers);
              injectWrapper(path2, buildWrapper$1({
                MODULE_NAME: moduleName,
                AMD_ARGUMENTS: arrayExpression$2(amdArgs),
                IMPORT_NAMES: importNames
              }));
            }
          }
        }
      };
    });
    var _templateObject$7, _templateObject2$4, _templateObject3$3;
    var _transformModulesCommonjs = declare(function(api, options) {
      var _api$assumption, _api$assumption2, _api$assumption3;
      api.assertVersion(7);
      var transformImportCall = utils2.createDynamicImportTransform(api);
      var _options$strictNamesp = options.strictNamespace, strictNamespace = _options$strictNamesp === void 0 ? false : _options$strictNamesp, _options$mjsStrictNam = options.mjsStrictNamespace, mjsStrictNamespace = _options$mjsStrictNam === void 0 ? strictNamespace : _options$mjsStrictNam, allowTopLevelThis = options.allowTopLevelThis, strict2 = options.strict, strictMode = options.strictMode, noInterop = options.noInterop, importInterop = options.importInterop, _options$lazy = options.lazy, lazy = _options$lazy === void 0 ? false : _options$lazy, _options$allowCommonJ = options.allowCommonJSExports, allowCommonJSExports = _options$allowCommonJ === void 0 ? true : _options$allowCommonJ;
      var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : options.loose;
      var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : options.loose;
      var noIncompleteNsImportDetection = (_api$assumption3 = api.assumption("noIncompleteNsImportDetection")) != null ? _api$assumption3 : false;
      if (typeof lazy !== "boolean" && typeof lazy !== "function" && (!Array.isArray(lazy) || !lazy.every(function(item) {
        return typeof item === "string";
      }))) {
        throw new Error(".lazy must be a boolean, array of strings, or a function");
      }
      if (typeof strictNamespace !== "boolean") {
        throw new Error(".strictNamespace must be a boolean, or undefined");
      }
      if (typeof mjsStrictNamespace !== "boolean") {
        throw new Error(".mjsStrictNamespace must be a boolean, or undefined");
      }
      var getAssertion = function getAssertion2(localName) {
        return template$2.expression.ast(_templateObject$7 || (_templateObject$7 = _taggedTemplateLiteralLoose([`
    (function(){
      throw new Error(
        "The CommonJS '" + "`, `" + "' variable is not available in ES6 modules." +
        "Consider setting setting sourceType:script or sourceType:unambiguous in your " +
        "Babel config for this file.");
    })()
  `])), localName);
      };
      var moduleExportsVisitor = {
        ReferencedIdentifier: function ReferencedIdentifier2(path2) {
          var localName = path2.node.name;
          if (localName !== "module" && localName !== "exports")
            return;
          var localBinding = path2.scope.getBinding(localName);
          var rootBinding = this.scope.getBinding(localName);
          if (rootBinding !== localBinding || path2.parentPath.isObjectProperty({
            value: path2.node
          }) && path2.parentPath.parentPath.isObjectPattern() || path2.parentPath.isAssignmentExpression({
            left: path2.node
          }) || path2.isAssignmentExpression({
            left: path2.node
          })) {
            return;
          }
          path2.replaceWith(getAssertion(localName));
        },
        UpdateExpression: function UpdateExpression2(path2) {
          var arg = path2.get("argument");
          var localName = arg.node.name;
          if (localName !== "module" && localName !== "exports")
            return;
          var localBinding = path2.scope.getBinding(localName);
          var rootBinding = this.scope.getBinding(localName);
          if (rootBinding !== localBinding)
            return;
          path2.replaceWith(assignmentExpression$c(path2.node.operator[0] + "=", arg.node, getAssertion(localName)));
        },
        AssignmentExpression: function AssignmentExpression2(path2) {
          var _this = this;
          var left = path2.get("left");
          if (left.isIdentifier()) {
            var localName = path2.node.name;
            if (localName !== "module" && localName !== "exports")
              return;
            var localBinding = path2.scope.getBinding(localName);
            var rootBinding = this.scope.getBinding(localName);
            if (rootBinding !== localBinding)
              return;
            var right = path2.get("right");
            right.replaceWith(sequenceExpression$7([right.node, getAssertion(localName)]));
          } else if (left.isPattern()) {
            var ids2 = left.getOuterBindingIdentifiers();
            var _localName = Object.keys(ids2).filter(function(localName2) {
              if (localName2 !== "module" && localName2 !== "exports")
                return false;
              return _this.scope.getBinding(localName2) === path2.scope.getBinding(localName2);
            })[0];
            if (_localName) {
              var _right = path2.get("right");
              _right.replaceWith(sequenceExpression$7([_right.node, getAssertion(_localName)]));
            }
          }
        }
      };
      return {
        name: "transform-modules-commonjs",
        pre: function pre() {
          this.file.set("@babel/plugin-transform-modules-*", "commonjs");
        },
        visitor: {
          CallExpression: function CallExpression2(path2) {
            if (!this.file.has("@babel/plugin-proposal-dynamic-import"))
              return;
            if (!path2.get("callee").isImport())
              return;
            var scope2 = path2.scope;
            do {
              scope2.rename("require");
            } while (scope2 = scope2.parent);
            transformImportCall(this, path2.get("callee"));
          },
          Program: {
            exit: function exit(path2, state) {
              if (!isModule(path2))
                return;
              path2.scope.rename("exports");
              path2.scope.rename("module");
              path2.scope.rename("require");
              path2.scope.rename("__filename");
              path2.scope.rename("__dirname");
              if (!allowCommonJSExports) {
                simplifyAccess(path2, /* @__PURE__ */ new Set(["module", "exports"]), false);
                path2.traverse(moduleExportsVisitor, {
                  scope: path2.scope
                });
              }
              var moduleName = getModuleName(this.file.opts, options);
              if (moduleName)
                moduleName = stringLiteral$8(moduleName);
              var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path2, {
                exportName: "exports",
                constantReexports,
                enumerableModuleMeta,
                strict: strict2,
                strictMode,
                allowTopLevelThis,
                noInterop,
                importInterop,
                lazy,
                esNamespaceOnly: typeof state.filename === "string" && /\.mjs$/.test(state.filename) ? mjsStrictNamespace : strictNamespace,
                noIncompleteNsImportDetection
              }), meta2 = _rewriteModuleStateme.meta, headers = _rewriteModuleStateme.headers;
              for (var _iterator2 = _createForOfIteratorHelperLoose(meta2.source), _step2; !(_step2 = _iterator2()).done; ) {
                var _step$value = _slicedToArray$12(_step2.value, 2), source = _step$value[0], metadata = _step$value[1];
                var loadExpr = callExpression$e(identifier$j("require"), [stringLiteral$8(source)]);
                var header = void 0;
                if (isSideEffectImport(metadata)) {
                  if (metadata.lazy)
                    throw new Error("Assertion failure");
                  header = expressionStatement$a(loadExpr);
                } else {
                  var init3 = wrapInterop(path2, loadExpr, metadata.interop) || loadExpr;
                  if (metadata.lazy) {
                    header = template$2.ast(_templateObject2$4 || (_templateObject2$4 = _taggedTemplateLiteralLoose(["\n                  function ", "() {\n                    const data = ", ";\n                    ", " = function(){ return data; };\n                    return data;\n                  }\n                "])), metadata.name, init3, metadata.name);
                  } else {
                    header = template$2.ast(_templateObject3$3 || (_templateObject3$3 = _taggedTemplateLiteralLoose(["\n                  var ", " = ", ";\n                "])), metadata.name, init3);
                  }
                }
                header.loc = metadata.loc;
                headers.push(header);
                headers.push.apply(headers, _toConsumableArray2(buildNamespaceInitStatements(meta2, metadata, constantReexports)));
              }
              ensureStatementsHoisted(headers);
              path2.unshiftContainer("body", headers);
              path2.get("body").forEach(function(path3) {
                if (headers.indexOf(path3.node) === -1)
                  return;
                if (path3.isVariableDeclaration()) {
                  path3.scope.registerDeclaration(path3);
                }
              });
            }
          }
        }
      };
    });
    var buildTemplate = template$2.statement('\n  SYSTEM_REGISTER(MODULE_NAME, SOURCES, function (EXPORT_IDENTIFIER, CONTEXT_IDENTIFIER) {\n    "use strict";\n    BEFORE_BODY;\n    return {\n      setters: SETTERS,\n      execute: EXECUTE,\n    };\n  });\n');
    var buildExportAll = template$2.statement('\n  for (var KEY in TARGET) {\n    if (KEY !== "default" && KEY !== "__esModule") EXPORT_OBJ[KEY] = TARGET[KEY];\n  }\n');
    var MISSING_PLUGIN_WARNING = "WARNING: Dynamic import() transformation must be enabled using the\n         @babel/plugin-proposal-dynamic-import plugin. Babel 8 will\n         no longer transform import() without using that plugin.\n";
    function getExportSpecifierName(node2, stringSpecifiers) {
      if (node2.type === "Identifier") {
        return node2.name;
      } else if (node2.type === "StringLiteral") {
        var stringValue = node2.value;
        if (!isIdentifierName(stringValue)) {
          stringSpecifiers.add(stringValue);
        }
        return stringValue;
      } else {
        throw new Error("Expected export specifier to be either Identifier or StringLiteral, got " + node2.type);
      }
    }
    function constructExportCall(path2, exportIdent, exportNames, exportValues, exportStarTarget, stringSpecifiers) {
      var statements2 = [];
      if (!exportStarTarget) {
        if (exportNames.length === 1) {
          statements2.push(expressionStatement$a(callExpression$e(exportIdent, [stringLiteral$8(exportNames[0]), exportValues[0]])));
        } else {
          var objectProperties = [];
          for (var i2 = 0; i2 < exportNames.length; i2++) {
            var exportName = exportNames[i2];
            var exportValue = exportValues[i2];
            objectProperties.push(objectProperty$2(stringSpecifiers.has(exportName) ? stringLiteral$8(exportName) : identifier$j(exportName), exportValue));
          }
          statements2.push(expressionStatement$a(callExpression$e(exportIdent, [objectExpression$4(objectProperties)])));
        }
      } else {
        var exportObj = path2.scope.generateUid("exportObj");
        statements2.push(variableDeclaration$7("var", [variableDeclarator$7(identifier$j(exportObj), objectExpression$4([]))]));
        statements2.push(buildExportAll({
          KEY: path2.scope.generateUidIdentifier("key"),
          EXPORT_OBJ: identifier$j(exportObj),
          TARGET: exportStarTarget
        }));
        for (var _i3 = 0; _i3 < exportNames.length; _i3++) {
          var _exportName = exportNames[_i3];
          var _exportValue = exportValues[_i3];
          statements2.push(expressionStatement$a(assignmentExpression$c("=", memberExpression$b(identifier$j(exportObj), identifier$j(_exportName)), _exportValue)));
        }
        statements2.push(expressionStatement$a(callExpression$e(exportIdent, [identifier$j(exportObj)])));
      }
      return statements2;
    }
    var _transformModulesSystemjs = declare(function(api, options) {
      api.assertVersion(7);
      var _options$systemGlobal = options.systemGlobal, systemGlobal = _options$systemGlobal === void 0 ? "System" : _options$systemGlobal, _options$allowTopLeve = options.allowTopLevelThis, allowTopLevelThis = _options$allowTopLeve === void 0 ? false : _options$allowTopLeve;
      var IGNORE_REASSIGNMENT_SYMBOL = Symbol();
      var reassignmentVisitor = {
        "AssignmentExpression|UpdateExpression": function AssignmentExpressionUpdateExpression(path2) {
          if (path2.node[IGNORE_REASSIGNMENT_SYMBOL])
            return;
          path2.node[IGNORE_REASSIGNMENT_SYMBOL] = true;
          var arg = path2.get(path2.isAssignmentExpression() ? "left" : "argument");
          if (arg.isObjectPattern() || arg.isArrayPattern()) {
            var exprs = [path2.node];
            for (var _i22 = 0, _Object$keys3 = Object.keys(arg.getBindingIdentifiers()); _i22 < _Object$keys3.length; _i22++) {
              var _name = _Object$keys3[_i22];
              if (this.scope.getBinding(_name) !== path2.scope.getBinding(_name)) {
                return;
              }
              var _exportedNames = this.exports[_name];
              if (!_exportedNames)
                return;
              for (var _iterator2 = _createForOfIteratorHelperLoose(_exportedNames), _step2; !(_step2 = _iterator2()).done; ) {
                var exportedName = _step2.value;
                exprs.push(this.buildCall(exportedName, identifier$j(_name)).expression);
              }
            }
            path2.replaceWith(sequenceExpression$7(exprs));
            return;
          }
          if (!arg.isIdentifier())
            return;
          var name2 = arg.node.name;
          if (this.scope.getBinding(name2) !== path2.scope.getBinding(name2))
            return;
          var exportedNames = this.exports[name2];
          if (!exportedNames)
            return;
          var node2 = path2.node;
          var isPostUpdateExpression = path2.isUpdateExpression({
            prefix: false
          });
          if (isPostUpdateExpression) {
            node2 = binaryExpression$4(node2.operator[0], unaryExpression$6("+", cloneNode$i(node2.argument)), numericLiteral$7(1));
          }
          for (var _iterator22 = _createForOfIteratorHelperLoose(exportedNames), _step22; !(_step22 = _iterator22()).done; ) {
            var _exportedName = _step22.value;
            node2 = this.buildCall(_exportedName, node2).expression;
          }
          if (isPostUpdateExpression) {
            node2 = sequenceExpression$7([node2, path2.node]);
          }
          path2.replaceWith(node2);
        }
      };
      return {
        name: "transform-modules-systemjs",
        pre: function pre() {
          this.file.set("@babel/plugin-transform-modules-*", "systemjs");
        },
        visitor: {
          CallExpression: function CallExpression2(path2, state) {
            if (isImport(path2.node.callee)) {
              if (!this.file.has("@babel/plugin-proposal-dynamic-import")) {
                {
                  console.warn(MISSING_PLUGIN_WARNING);
                }
              }
              path2.replaceWith(callExpression$e(memberExpression$b(identifier$j(state.contextIdent), identifier$j("import")), [utils2.getImportSource(t$a, path2.node)]));
            }
          },
          MetaProperty: function MetaProperty2(path2, state) {
            if (path2.node.meta.name === "import" && path2.node.property.name === "meta") {
              path2.replaceWith(memberExpression$b(identifier$j(state.contextIdent), identifier$j("meta")));
            }
          },
          ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
            if (path2.node.name === "__moduleName" && !path2.scope.hasBinding("__moduleName")) {
              path2.replaceWith(memberExpression$b(identifier$j(state.contextIdent), identifier$j("id")));
            }
          },
          Program: {
            enter: function enter(path2, state) {
              state.contextIdent = path2.scope.generateUid("context");
              state.stringSpecifiers = /* @__PURE__ */ new Set();
              if (!allowTopLevelThis) {
                rewriteThis(path2);
              }
            },
            exit: function exit(path2, state) {
              var scope2 = path2.scope;
              var exportIdent = scope2.generateUid("export");
              var contextIdent = state.contextIdent, stringSpecifiers = state.stringSpecifiers;
              var exportMap = /* @__PURE__ */ Object.create(null);
              var modules2 = [];
              var beforeBody = [];
              var setters = [];
              var sources = [];
              var variableIds = [];
              var removedPaths = [];
              function addExportName(key2, val) {
                exportMap[key2] = exportMap[key2] || [];
                exportMap[key2].push(val);
              }
              function pushModule(source2, key2, specifiers2) {
                var module2;
                modules2.forEach(function(m2) {
                  if (m2.key === source2) {
                    module2 = m2;
                  }
                });
                if (!module2) {
                  modules2.push(module2 = {
                    key: source2,
                    imports: [],
                    exports: []
                  });
                }
                module2[key2] = module2[key2].concat(specifiers2);
              }
              function buildExportCall(name3, val) {
                return expressionStatement$a(callExpression$e(identifier$j(exportIdent), [stringLiteral$8(name3), val]));
              }
              var exportNames = [];
              var exportValues = [];
              var body = path2.get("body");
              for (var _iterator3 = _createForOfIteratorHelperLoose(body), _step3; !(_step3 = _iterator3()).done; ) {
                var _path2 = _step3.value;
                if (_path2.isFunctionDeclaration()) {
                  beforeBody.push(_path2.node);
                  removedPaths.push(_path2);
                } else if (_path2.isClassDeclaration()) {
                  variableIds.push(cloneNode$i(_path2.node.id));
                  _path2.replaceWith(expressionStatement$a(assignmentExpression$c("=", cloneNode$i(_path2.node.id), toExpression$1(_path2.node))));
                } else if (_path2.isVariableDeclaration()) {
                  _path2.node.kind = "var";
                } else if (_path2.isImportDeclaration()) {
                  var source = _path2.node.source.value;
                  pushModule(source, "imports", _path2.node.specifiers);
                  for (var _i4 = 0, _Object$keys22 = Object.keys(_path2.getBindingIdentifiers()); _i4 < _Object$keys22.length; _i4++) {
                    var name2 = _Object$keys22[_i4];
                    scope2.removeBinding(name2);
                    variableIds.push(identifier$j(name2));
                  }
                  _path2.remove();
                } else if (_path2.isExportAllDeclaration()) {
                  pushModule(_path2.node.source.value, "exports", _path2.node);
                  _path2.remove();
                } else if (_path2.isExportDefaultDeclaration()) {
                  var declar = _path2.get("declaration");
                  if (declar.isClassDeclaration()) {
                    var id3 = declar.node.id;
                    if (id3) {
                      exportNames.push("default");
                      exportValues.push(scope2.buildUndefinedNode());
                      variableIds.push(cloneNode$i(id3));
                      addExportName(id3.name, "default");
                      _path2.replaceWith(expressionStatement$a(assignmentExpression$c("=", cloneNode$i(id3), toExpression$1(declar.node))));
                    } else {
                      exportNames.push("default");
                      exportValues.push(toExpression$1(declar.node));
                      removedPaths.push(_path2);
                    }
                  } else if (declar.isFunctionDeclaration()) {
                    var _id = declar.node.id;
                    if (_id) {
                      beforeBody.push(declar.node);
                      exportNames.push("default");
                      exportValues.push(cloneNode$i(_id));
                      addExportName(_id.name, "default");
                    } else {
                      exportNames.push("default");
                      exportValues.push(toExpression$1(declar.node));
                    }
                    removedPaths.push(_path2);
                  } else {
                    _path2.replaceWith(buildExportCall("default", declar.node));
                  }
                } else if (_path2.isExportNamedDeclaration()) {
                  var _declar = _path2.get("declaration");
                  if (_declar.node) {
                    _path2.replaceWith(_declar);
                    if (_declar.isFunction()) {
                      var node2 = _declar.node;
                      var _name2 = node2.id.name;
                      addExportName(_name2, _name2);
                      beforeBody.push(node2);
                      exportNames.push(_name2);
                      exportValues.push(cloneNode$i(node2.id));
                      removedPaths.push(_path2);
                    } else if (_declar.isClass()) {
                      var _name3 = _declar.node.id.name;
                      exportNames.push(_name3);
                      exportValues.push(scope2.buildUndefinedNode());
                      variableIds.push(cloneNode$i(_declar.node.id));
                      _path2.replaceWith(expressionStatement$a(assignmentExpression$c("=", cloneNode$i(_declar.node.id), toExpression$1(_declar.node))));
                      addExportName(_name3, _name3);
                    } else {
                      if (_declar.isVariableDeclaration()) {
                        _declar.node.kind = "var";
                      }
                      for (var _i5 = 0, _Object$keys3 = Object.keys(_declar.getBindingIdentifiers()); _i5 < _Object$keys3.length; _i5++) {
                        var _name4 = _Object$keys3[_i5];
                        addExportName(_name4, _name4);
                      }
                    }
                  } else {
                    var specifiers = _path2.node.specifiers;
                    if (specifiers != null && specifiers.length) {
                      if (_path2.node.source) {
                        pushModule(_path2.node.source.value, "exports", specifiers);
                        _path2.remove();
                      } else {
                        var nodes2 = [];
                        for (var _iterator7 = _createForOfIteratorHelperLoose(specifiers), _step7; !(_step7 = _iterator7()).done; ) {
                          var specifier = _step7.value;
                          var local = specifier.local, exported = specifier.exported;
                          var binding2 = scope2.getBinding(local.name);
                          var exportedName = getExportSpecifierName(exported, stringSpecifiers);
                          if (binding2 && isFunctionDeclaration$1(binding2.path.node)) {
                            exportNames.push(exportedName);
                            exportValues.push(cloneNode$i(local));
                          } else if (!binding2) {
                            nodes2.push(buildExportCall(exportedName, local));
                          }
                          addExportName(local.name, exportedName);
                        }
                        _path2.replaceWithMultiple(nodes2);
                      }
                    } else {
                      _path2.remove();
                    }
                  }
                }
              }
              modules2.forEach(function(specifiers2) {
                var setterBody = [];
                var target = scope2.generateUid(specifiers2.key);
                for (var _iterator4 = _createForOfIteratorHelperLoose(specifiers2.imports), _step4; !(_step4 = _iterator4()).done; ) {
                  var specifier2 = _step4.value;
                  if (isImportNamespaceSpecifier$1(specifier2)) {
                    setterBody.push(expressionStatement$a(assignmentExpression$c("=", specifier2.local, identifier$j(target))));
                  } else if (isImportDefaultSpecifier$1(specifier2)) {
                    specifier2 = importSpecifier$1(specifier2.local, identifier$j("default"));
                  }
                  if (isImportSpecifier$1(specifier2)) {
                    var _specifier = specifier2, imported = _specifier.imported;
                    setterBody.push(expressionStatement$a(assignmentExpression$c("=", specifier2.local, memberExpression$b(identifier$j(target), specifier2.imported, imported.type === "StringLiteral"))));
                  }
                }
                if (specifiers2.exports.length) {
                  var _exportNames = [];
                  var _exportValues = [];
                  var hasExportStar = false;
                  for (var _iterator5 = _createForOfIteratorHelperLoose(specifiers2.exports), _step5; !(_step5 = _iterator5()).done; ) {
                    var node3 = _step5.value;
                    if (isExportAllDeclaration$1(node3)) {
                      hasExportStar = true;
                    } else if (isExportSpecifier(node3)) {
                      var exportedName2 = getExportSpecifierName(node3.exported, stringSpecifiers);
                      _exportNames.push(exportedName2);
                      _exportValues.push(memberExpression$b(identifier$j(target), node3.local, isStringLiteral$7(node3.local)));
                    } else
                      ;
                  }
                  setterBody.push.apply(setterBody, _toConsumableArray2(constructExportCall(path2, identifier$j(exportIdent), _exportNames, _exportValues, hasExportStar ? identifier$j(target) : null, stringSpecifiers)));
                }
                sources.push(stringLiteral$8(specifiers2.key));
                setters.push(functionExpression$3(null, [identifier$j(target)], blockStatement$6(setterBody)));
              });
              var moduleName = getModuleName(this.file.opts, options);
              if (moduleName)
                moduleName = stringLiteral$8(moduleName);
              hoistVariables(path2, function(id4, name3, hasInit) {
                variableIds.push(id4);
                if (!hasInit && name3 in exportMap) {
                  for (var _iterator6 = _createForOfIteratorHelperLoose(exportMap[name3]), _step6; !(_step6 = _iterator6()).done; ) {
                    var exported2 = _step6.value;
                    exportNames.push(exported2);
                    exportValues.push(scope2.buildUndefinedNode());
                  }
                }
              });
              if (variableIds.length) {
                beforeBody.unshift(variableDeclaration$7("var", variableIds.map(function(id4) {
                  return variableDeclarator$7(id4);
                })));
              }
              if (exportNames.length) {
                beforeBody.push.apply(beforeBody, _toConsumableArray2(constructExportCall(path2, identifier$j(exportIdent), exportNames, exportValues, null, stringSpecifiers)));
              }
              path2.traverse(reassignmentVisitor, {
                exports: exportMap,
                buildCall: buildExportCall,
                scope: scope2
              });
              for (var _i3 = 0, _removedPaths = removedPaths; _i3 < _removedPaths.length; _i3++) {
                var _path = _removedPaths[_i3];
                _path.remove();
              }
              var hasTLA = false;
              path2.traverse({
                AwaitExpression: function AwaitExpression2(path3) {
                  hasTLA = true;
                  path3.stop();
                },
                Function: function Function2(path3) {
                  path3.skip();
                },
                noScope: true
              });
              path2.node.body = [buildTemplate({
                SYSTEM_REGISTER: memberExpression$b(identifier$j(systemGlobal), identifier$j("register")),
                BEFORE_BODY: beforeBody,
                MODULE_NAME: moduleName,
                SETTERS: arrayExpression$2(setters),
                EXECUTE: functionExpression$3(null, [], blockStatement$6(path2.node.body), false, hasTLA),
                SOURCES: arrayExpression$2(sources),
                EXPORT_IDENTIFIER: identifier$j(exportIdent),
                CONTEXT_IDENTIFIER: identifier$j(contextIdent)
              })];
            }
          }
        }
      };
    });
    var buildPrerequisiteAssignment = template$2("\n  GLOBAL_REFERENCE = GLOBAL_REFERENCE || {}\n");
    var buildWrapper = template$2('\n  (function (global, factory) {\n    if (typeof define === "function" && define.amd) {\n      define(MODULE_NAME, AMD_ARGUMENTS, factory);\n    } else if (typeof exports !== "undefined") {\n      factory(COMMONJS_ARGUMENTS);\n    } else {\n      var mod = { exports: {} };\n      factory(BROWSER_ARGUMENTS);\n\n      GLOBAL_TO_ASSIGN;\n    }\n  })(\n    typeof globalThis !== "undefined" ? globalThis\n      : typeof self !== "undefined" ? self\n      : this,\n    function(IMPORT_NAMES) {\n  })\n');
    var _transformModulesUmd = declare(function(api, options) {
      var _api$assumption, _api$assumption2;
      api.assertVersion(7);
      var globals2 = options.globals, exactGlobals = options.exactGlobals, allowTopLevelThis = options.allowTopLevelThis, strict2 = options.strict, strictMode = options.strictMode, noInterop = options.noInterop, importInterop = options.importInterop;
      var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : options.loose;
      var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : options.loose;
      function buildBrowserInit(browserGlobals, exactGlobals2, filename, moduleName) {
        var moduleNameOrBasename = moduleName ? moduleName.value : basename(filename, extname(filename));
        var globalToAssign = memberExpression$b(identifier$j("global"), identifier$j(toIdentifier$1(moduleNameOrBasename)));
        var initAssignments = [];
        if (exactGlobals2) {
          var globalName = browserGlobals[moduleNameOrBasename];
          if (globalName) {
            initAssignments = [];
            var members = globalName.split(".");
            globalToAssign = members.slice(1).reduce(function(accum, curr) {
              initAssignments.push(buildPrerequisiteAssignment({
                GLOBAL_REFERENCE: cloneNode$i(accum)
              }));
              return memberExpression$b(accum, identifier$j(curr));
            }, memberExpression$b(identifier$j("global"), identifier$j(members[0])));
          }
        }
        initAssignments.push(expressionStatement$a(assignmentExpression$c("=", globalToAssign, memberExpression$b(identifier$j("mod"), identifier$j("exports")))));
        return initAssignments;
      }
      function buildBrowserArg(browserGlobals, exactGlobals2, source) {
        var memberExpression2;
        if (exactGlobals2) {
          var globalRef = browserGlobals[source];
          if (globalRef) {
            memberExpression2 = globalRef.split(".").reduce(function(accum, curr) {
              return memberExpression$b(accum, identifier$j(curr));
            }, identifier$j("global"));
          } else {
            memberExpression2 = memberExpression$b(identifier$j("global"), identifier$j(toIdentifier$1(source)));
          }
        } else {
          var requireName = basename(source, extname(source));
          var globalName = browserGlobals[requireName] || requireName;
          memberExpression2 = memberExpression$b(identifier$j("global"), identifier$j(toIdentifier$1(globalName)));
        }
        return memberExpression2;
      }
      return {
        name: "transform-modules-umd",
        visitor: {
          Program: {
            exit: function exit(path2) {
              if (!isModule(path2))
                return;
              var browserGlobals = globals2 || {};
              var moduleName = getModuleName(this.file.opts, options);
              if (moduleName)
                moduleName = stringLiteral$8(moduleName);
              var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path2, {
                constantReexports,
                enumerableModuleMeta,
                strict: strict2,
                strictMode,
                allowTopLevelThis,
                noInterop,
                importInterop
              }), meta2 = _rewriteModuleStateme.meta, headers = _rewriteModuleStateme.headers;
              var amdArgs = [];
              var commonjsArgs = [];
              var browserArgs = [];
              var importNames = [];
              if (hasExports(meta2)) {
                amdArgs.push(stringLiteral$8("exports"));
                commonjsArgs.push(identifier$j("exports"));
                browserArgs.push(memberExpression$b(identifier$j("mod"), identifier$j("exports")));
                importNames.push(identifier$j(meta2.exportName));
              }
              for (var _iterator2 = _createForOfIteratorHelperLoose(meta2.source), _step2; !(_step2 = _iterator2()).done; ) {
                var _step$value = _slicedToArray$12(_step2.value, 2), source = _step$value[0], metadata = _step$value[1];
                amdArgs.push(stringLiteral$8(source));
                commonjsArgs.push(callExpression$e(identifier$j("require"), [stringLiteral$8(source)]));
                browserArgs.push(buildBrowserArg(browserGlobals, exactGlobals, source));
                importNames.push(identifier$j(metadata.name));
                if (!isSideEffectImport(metadata)) {
                  var interop = wrapInterop(path2, identifier$j(metadata.name), metadata.interop);
                  if (interop) {
                    var header = expressionStatement$a(assignmentExpression$c("=", identifier$j(metadata.name), interop));
                    header.loc = meta2.loc;
                    headers.push(header);
                  }
                }
                headers.push.apply(headers, _toConsumableArray2(buildNamespaceInitStatements(meta2, metadata, constantReexports)));
              }
              ensureStatementsHoisted(headers);
              path2.unshiftContainer("body", headers);
              var _path$node = path2.node, body = _path$node.body, directives = _path$node.directives;
              path2.node.directives = [];
              path2.node.body = [];
              var umdWrapper = path2.pushContainer("body", [buildWrapper({
                MODULE_NAME: moduleName,
                AMD_ARGUMENTS: arrayExpression$2(amdArgs),
                COMMONJS_ARGUMENTS: commonjsArgs,
                BROWSER_ARGUMENTS: browserArgs,
                IMPORT_NAMES: importNames,
                GLOBAL_TO_ASSIGN: buildBrowserInit(browserGlobals, exactGlobals, this.filename || "unknown", moduleName)
              })])[0];
              var umdFactory = umdWrapper.get("expression.arguments")[1].get("body");
              umdFactory.pushContainer("directives", directives);
              umdFactory.pushContainer("body", body);
            }
          }
        }
      };
    });
    function _transformNamedCapturingGroupsRegex(core, options) {
      var _options$runtime = options.runtime, runtime3 = _options$runtime === void 0 ? true : _options$runtime;
      if (typeof runtime3 !== "boolean") {
        throw new Error("The 'runtime' option must be boolean");
      }
      return createRegExpFeaturePlugin({
        name: "transform-named-capturing-groups-regex",
        feature: "namedCaptureGroups",
        options: {
          runtime: runtime3
        }
      });
    }
    var _transformNewTarget = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-new-target",
        visitor: {
          MetaProperty: function MetaProperty2(path2) {
            var meta2 = path2.get("meta");
            var property2 = path2.get("property");
            var scope2 = path2.scope;
            if (meta2.isIdentifier({
              name: "new"
            }) && property2.isIdentifier({
              name: "target"
            })) {
              var func = path2.findParent(function(path3) {
                if (path3.isClass())
                  return true;
                if (path3.isFunction() && !path3.isArrowFunctionExpression()) {
                  if (path3.isClassMethod({
                    kind: "constructor"
                  })) {
                    return false;
                  }
                  return true;
                }
                return false;
              });
              if (!func) {
                throw path2.buildCodeFrameError("new.target must be under a (non-arrow) function or a class.");
              }
              var node2 = func.node;
              if (!node2.id) {
                if (func.isMethod()) {
                  path2.replaceWith(scope2.buildUndefinedNode());
                  return;
                }
                node2.id = scope2.generateUidIdentifier("target");
              }
              var _constructor = memberExpression$b(thisExpression$4(), identifier$j("constructor"));
              if (func.isClass()) {
                path2.replaceWith(_constructor);
                return;
              }
              path2.replaceWith(conditionalExpression$3(binaryExpression$4("instanceof", thisExpression$4(), cloneNode$i(node2.id)), _constructor, scope2.buildUndefinedNode()));
            }
          }
        }
      };
    });
    var transformObjectAssign = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-object-assign",
        visitor: {
          CallExpression: function CallExpression2(path2, file2) {
            if (path2.get("callee").matchesPattern("Object.assign")) {
              path2.node.callee = file2.addHelper("extends");
            }
          }
        }
      };
    });
    function replacePropertySuper(path2, getObjectRef, file2) {
      var replaceSupers = new ReplaceSupers({
        getObjectRef,
        methodPath: path2,
        file: file2
      });
      replaceSupers.replace();
    }
    var _transformObjectSuper = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-object-super",
        visitor: {
          ObjectExpression: function ObjectExpression2(path2, state) {
            var objectRef;
            var getObjectRef = function getObjectRef2() {
              return objectRef = objectRef || path2.scope.generateUidIdentifier("obj");
            };
            path2.get("properties").forEach(function(propPath) {
              if (!propPath.isMethod())
                return;
              replacePropertySuper(propPath, getObjectRef, state);
            });
            if (objectRef) {
              path2.scope.push({
                id: cloneNode$i(objectRef)
              });
              path2.replaceWith(assignmentExpression$c("=", cloneNode$i(objectRef), path2.node));
            }
          }
        }
      };
    });
    var transformObjectSetPrototypeOfToAssign = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-object-set-prototype-of-to-assign",
        visitor: {
          CallExpression: function CallExpression2(path2, file2) {
            if (path2.get("callee").matchesPattern("Object.setPrototypeOf")) {
              path2.node.callee = file2.addHelper("defaults");
            }
          }
        }
      };
    });
    var _transformPropertyLiterals = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-property-literals",
        visitor: {
          ObjectProperty: {
            exit: function exit(_ref3) {
              var node2 = _ref3.node;
              var key2 = node2.key;
              if (!node2.computed && isIdentifier$i(key2) && !isValidES3Identifier(key2.name)) {
                node2.key = stringLiteral$8(key2.name);
              }
            }
          }
        }
      };
    });
    var arrayExpression = arrayExpression$2, booleanLiteral$1 = booleanLiteral$5, functionExpression = functionExpression$3, identifier$1 = identifier$j, inheritsComments = inheritsComments$2, isClassMethod = isClassMethod$1, isFunctionExpression = isFunctionExpression$1, isObjectMethod = isObjectMethod$2, isObjectProperty = isObjectProperty$5, isProperty = isProperty$2, isStringLiteral$2 = isStringLiteral$7, objectExpression$1 = objectExpression$4, objectProperty$1 = objectProperty$2, removeComments = removeComments$2, toComputedKey = toComputedKey$3, toKeyAlias = toKeyAlias$1;
    function toKind(node2) {
      if (isClassMethod(node2) || isObjectMethod(node2)) {
        if (node2.kind === "get" || node2.kind === "set") {
          return node2.kind;
        }
      }
      return "value";
    }
    var has$7 = Function.prototype.call.bind(Object.prototype.hasOwnProperty);
    function push2(mutatorMap, node2, kind, file2, scope2) {
      var alias2 = toKeyAlias(node2);
      var map2 = {};
      if (has$7(mutatorMap, alias2))
        map2 = mutatorMap[alias2];
      mutatorMap[alias2] = map2;
      map2._inherits = map2._inherits || [];
      map2._inherits.push(node2);
      map2._key = node2.key;
      if (node2.computed) {
        map2._computed = true;
      }
      if (node2.decorators) {
        var _decorators$elements;
        var decorators = map2.decorators = map2.decorators || arrayExpression([]);
        (_decorators$elements = decorators.elements).push.apply(_decorators$elements, _toConsumableArray2(node2.decorators.map(function(dec) {
          return dec.expression;
        }).reverse()));
      }
      if (map2.value || map2.initializer) {
        throw file2.buildCodeFrameError(node2, "Key conflict with sibling node");
      }
      var key2, value;
      if (isObjectProperty(node2) || isObjectMethod(node2) || isClassMethod(node2)) {
        key2 = toComputedKey(node2, node2.key);
      }
      if (isProperty(node2)) {
        value = node2.value;
      } else if (isObjectMethod(node2) || isClassMethod(node2)) {
        value = functionExpression(null, node2.params, node2.body, node2.generator, node2.async);
        value.returnType = node2.returnType;
      }
      var inheritedKind = toKind(node2);
      if (!kind || inheritedKind !== "value") {
        kind = inheritedKind;
      }
      if (scope2 && isStringLiteral$2(key2) && (kind === "value" || kind === "initializer") && isFunctionExpression(value)) {
        value = nameFunction({
          id: key2,
          node: value,
          scope: scope2
        });
      }
      if (value) {
        inheritsComments(value, node2);
        map2[kind] = value;
      }
      return map2;
    }
    function toClassObject(mutatorMap) {
      var objExpr = objectExpression$1([]);
      Object.keys(mutatorMap).forEach(function(mutatorMapKey) {
        var map2 = mutatorMap[mutatorMapKey];
        var mapNode = objectExpression$1([]);
        var propNode = objectProperty$1(map2._key, mapNode, map2._computed);
        Object.keys(map2).forEach(function(key2) {
          var node2 = map2[key2];
          if (key2[0] === "_")
            return;
          var prop2 = objectProperty$1(identifier$1(key2), node2);
          inheritsComments(prop2, node2);
          removeComments(node2);
          mapNode.properties.push(prop2);
        });
        objExpr.properties.push(propNode);
      });
      return objExpr;
    }
    function toDefineObject(mutatorMap) {
      Object.keys(mutatorMap).forEach(function(key2) {
        var map2 = mutatorMap[key2];
        if (map2.value)
          map2.writable = booleanLiteral$1(true);
        map2.configurable = booleanLiteral$1(true);
        map2.enumerable = booleanLiteral$1(true);
      });
      return toClassObject(mutatorMap);
    }
    var transformPropertyMutators = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-property-mutators",
        visitor: {
          ObjectExpression: function ObjectExpression2(path2, file2) {
            var node2 = path2.node;
            var hasAny = false;
            for (var _iterator2 = _createForOfIteratorHelperLoose(node2.properties), _step2; !(_step2 = _iterator2()).done; ) {
              var prop2 = _step2.value;
              if (prop2.kind === "get" || prop2.kind === "set") {
                hasAny = true;
                break;
              }
            }
            if (!hasAny)
              return;
            var mutatorMap = {};
            node2.properties = node2.properties.filter(function(prop3) {
              if (!prop3.computed && (prop3.kind === "get" || prop3.kind === "set")) {
                push2(mutatorMap, prop3, null, file2);
                return false;
              } else {
                return true;
              }
            });
            path2.replaceWith(callExpression$e(memberExpression$b(identifier$j("Object"), identifier$j("defineProperties")), [node2, toDefineObject(mutatorMap)]));
          }
        }
      };
    });
    var transformProtoToAssign = declare(function(api) {
      api.assertVersion(7);
      function isProtoKey(node2) {
        return isLiteral$7(toComputedKey$3(node2, node2.key), {
          value: "__proto__"
        });
      }
      function isProtoAssignmentExpression(node2) {
        var left = node2.left;
        return isMemberExpression$8(left) && isLiteral$7(toComputedKey$3(left, left.property), {
          value: "__proto__"
        });
      }
      function buildDefaultsCallExpression(expr, ref2, file2) {
        return expressionStatement$a(callExpression$e(file2.addHelper("defaults"), [ref2, expr.right]));
      }
      return {
        name: "transform-proto-to-assign",
        visitor: {
          AssignmentExpression: function AssignmentExpression2(path2, file2) {
            if (!isProtoAssignmentExpression(path2.node))
              return;
            var nodes2 = [];
            var left = path2.node.left.object;
            var temp = path2.scope.maybeGenerateMemoised(left);
            if (temp) {
              nodes2.push(expressionStatement$a(assignmentExpression$c("=", temp, left)));
            }
            nodes2.push(buildDefaultsCallExpression(path2.node, cloneNode$i(temp || left), file2));
            if (temp)
              nodes2.push(cloneNode$i(temp));
            path2.replaceWithMultiple(nodes2);
          },
          ExpressionStatement: function ExpressionStatement2(path2, file2) {
            var expr = path2.node.expression;
            if (!isAssignmentExpression$4(expr, {
              operator: "="
            }))
              return;
            if (isProtoAssignmentExpression(expr)) {
              path2.replaceWith(buildDefaultsCallExpression(expr, expr.left.object, file2));
            }
          },
          ObjectExpression: function ObjectExpression2(path2, file2) {
            var proto2;
            var node2 = path2.node;
            var properties = node2.properties;
            for (var i2 = 0; i2 < properties.length; i2++) {
              var prop2 = properties[i2];
              if (isProtoKey(prop2)) {
                proto2 = prop2.value;
                properties.splice(i2, 1);
                break;
              }
            }
            if (proto2) {
              var args = [objectExpression$4([]), proto2];
              if (node2.properties.length)
                args.push(node2);
              path2.replaceWith(callExpression$e(file2.addHelper("extends"), args));
            }
          }
        }
      };
    });
    var _templateObject$6;
    var transformReactConstantElements = declare(function(api, options) {
      api.assertVersion(7);
      var allowMutablePropsOnTags = options.allowMutablePropsOnTags;
      if (allowMutablePropsOnTags != null && !Array.isArray(allowMutablePropsOnTags)) {
        throw new Error(".allowMutablePropsOnTags must be an array, null, or undefined.");
      }
      var HOISTED = /* @__PURE__ */ new WeakMap();
      function declares(node2, scope2) {
        if (isJSXIdentifier$3(node2, {
          name: "this"
        }) || isJSXIdentifier$3(node2, {
          name: "arguments"
        }) || isJSXIdentifier$3(node2, {
          name: "super"
        }) || isJSXIdentifier$3(node2, {
          name: "new"
        })) {
          var path2 = scope2.path;
          return path2.isFunctionParent() && !path2.isArrowFunctionExpression();
        }
        return scope2.hasOwnBinding(node2.name);
      }
      function isHoistingScope(_ref3) {
        var path2 = _ref3.path;
        return path2.isFunctionParent() || path2.isLoop() || path2.isProgram();
      }
      function getHoistingScope(scope2) {
        while (!isHoistingScope(scope2)) {
          scope2 = scope2.parent;
        }
        return scope2;
      }
      var immutabilityVisitor = {
        enter: function enter(path2, state) {
          var stop3 = function stop4() {
            state.isImmutable = false;
            path2.stop();
          };
          var skip2 = function skip3() {
            path2.skip();
          };
          if (path2.isJSXClosingElement())
            return skip2();
          if (path2.isJSXIdentifier({
            name: "ref"
          }) && path2.parentPath.isJSXAttribute({
            name: path2.node
          })) {
            return stop3();
          }
          if (path2.isJSXIdentifier() || path2.isJSXMemberExpression() || path2.isJSXNamespacedName() || path2.isImmutable()) {
            return;
          }
          if (path2.isIdentifier()) {
            var binding2 = path2.scope.getBinding(path2.node.name);
            if (binding2 && binding2.constant)
              return;
          }
          var mutablePropsAllowed = state.mutablePropsAllowed;
          if (mutablePropsAllowed && path2.isFunction()) {
            path2.traverse(targetScopeVisitor, state);
            return skip2();
          }
          if (!path2.isPure())
            return stop3();
          var expressionResult = path2.evaluate();
          if (expressionResult.confident) {
            var value = expressionResult.value;
            if (mutablePropsAllowed || value === null || typeof value !== "object" && typeof value !== "function") {
              return skip2();
            }
          } else if (isIdentifier$i(expressionResult.deopt)) {
            return;
          }
          stop3();
        }
      };
      var targetScopeVisitor = {
        ReferencedIdentifier: function ReferencedIdentifier2(path2, state) {
          var node2 = path2.node;
          var scope2 = path2.scope;
          while (scope2 !== state.jsxScope) {
            if (declares(node2, scope2))
              return;
            scope2 = scope2.parent;
          }
          while (scope2) {
            if (scope2 === state.targetScope)
              return;
            if (declares(node2, scope2))
              break;
            scope2 = scope2.parent;
          }
          state.targetScope = getHoistingScope(scope2);
        }
      };
      var hoistingVisitor = Object.assign({}, immutabilityVisitor, targetScopeVisitor);
      return {
        name: "transform-react-constant-elements",
        visitor: {
          JSXElement: function JSXElement2(path2) {
            var _jsxScope;
            if (HOISTED.has(path2.node))
              return;
            HOISTED.set(path2.node, path2.scope);
            var name2 = path2.node.openingElement.name;
            var mutablePropsAllowed = false;
            if (allowMutablePropsOnTags != null) {
              var lastSegment = name2;
              while (isJSXMemberExpression$2(lastSegment)) {
                lastSegment = lastSegment.property;
              }
              var elementName = lastSegment.name;
              mutablePropsAllowed = allowMutablePropsOnTags.includes(elementName);
            }
            var jsxScope;
            var current2 = path2;
            while (!jsxScope && current2.parentPath.isJSX()) {
              current2 = current2.parentPath;
              jsxScope = HOISTED.get(current2.node);
            }
            (_jsxScope = jsxScope) != null ? _jsxScope : jsxScope = getHoistingScope(path2.scope);
            var visitorState = {
              isImmutable: true,
              mutablePropsAllowed,
              jsxScope,
              targetScope: path2.scope.getProgramParent()
            };
            path2.traverse(hoistingVisitor, visitorState);
            if (!visitorState.isImmutable)
              return;
            var targetScope = visitorState.targetScope;
            HOISTED.set(path2.node, targetScope);
            if (targetScope === jsxScope)
              return;
            var id3 = path2.scope.generateUidBasedOnNode(name2);
            targetScope.push({
              id: identifier$j(id3)
            });
            var replacement = template$2.expression.ast(_templateObject$6 || (_templateObject$6 = _taggedTemplateLiteralLoose(["\n          ", " || (", " = ", ")\n        "])), identifier$j(id3), identifier$j(id3), path2.node);
            if (path2.parentPath.isJSXElement() || path2.parentPath.isJSXAttribute()) {
              replacement = jsxExpressionContainer$1(replacement);
            }
            path2.replaceWith(replacement);
          }
        }
      };
    });
    var transformReactDisplayName = declare(function(api) {
      api.assertVersion(7);
      function addDisplayName(id3, call3) {
        var props = call3.arguments[0].properties;
        var safe = true;
        for (var i2 = 0; i2 < props.length; i2++) {
          var prop2 = props[i2];
          var key2 = toComputedKey$3(prop2);
          if (isLiteral$7(key2, {
            value: "displayName"
          })) {
            safe = false;
            break;
          }
        }
        if (safe) {
          props.unshift(objectProperty$2(identifier$j("displayName"), stringLiteral$8(id3)));
        }
      }
      var isCreateClassCallExpression = buildMatchMemberExpression$1("React.createClass");
      var isCreateClassAddon = function isCreateClassAddon2(callee) {
        return callee.name === "createReactClass";
      };
      function isCreateClass(node2) {
        if (!node2 || !isCallExpression$7(node2))
          return false;
        if (!isCreateClassCallExpression(node2.callee) && !isCreateClassAddon(node2.callee)) {
          return false;
        }
        var args = node2.arguments;
        if (args.length !== 1)
          return false;
        var first = args[0];
        if (!isObjectExpression$3(first))
          return false;
        return true;
      }
      return {
        name: "transform-react-display-name",
        visitor: {
          ExportDefaultDeclaration: function ExportDefaultDeclaration2(_ref3, state) {
            var node2 = _ref3.node;
            if (isCreateClass(node2.declaration)) {
              var filename = state.filename || "unknown";
              var displayName = path$1.basename(filename, path$1.extname(filename));
              if (displayName === "index") {
                displayName = path$1.basename(path$1.dirname(filename));
              }
              addDisplayName(displayName, node2.declaration);
            }
          },
          CallExpression: function CallExpression2(path2) {
            var node2 = path2.node;
            if (!isCreateClass(node2))
              return;
            var id3;
            path2.find(function(path3) {
              if (path3.isAssignmentExpression()) {
                id3 = path3.node.left;
              } else if (path3.isObjectProperty()) {
                id3 = path3.node.key;
              } else if (path3.isVariableDeclarator()) {
                id3 = path3.node.id;
              } else if (path3.isStatement()) {
                return true;
              }
              if (id3)
                return true;
            });
            if (!id3)
              return;
            if (isMemberExpression$8(id3)) {
              id3 = id3.property;
            }
            if (isIdentifier$i(id3)) {
              addDisplayName(id3.name, node2);
            }
          }
        }
      };
    });
    var booleanLiteral = booleanLiteral$5, callExpression = callExpression$e, identifier = identifier$j, inherits2 = inherits$1, isIdentifier$1 = isIdentifier$i, isJSXExpressionContainer = isJSXExpressionContainer$1, isJSXIdentifier = isJSXIdentifier$3, isJSXMemberExpression = isJSXMemberExpression$2, isJSXNamespacedName = isJSXNamespacedName$1, isJSXSpreadAttribute = isJSXSpreadAttribute$1, isLiteral = isLiteral$7, isObjectExpression = isObjectExpression$3, isReferenced = isReferenced$2, isStringLiteral$1 = isStringLiteral$7, isValidIdentifier = isValidIdentifier$1, memberExpression = memberExpression$b, nullLiteral = nullLiteral$2, objectExpression = objectExpression$4, objectProperty = objectProperty$2, react = react$3, spreadElement = spreadElement$2, stringLiteral = stringLiteral$8, thisExpression = thisExpression$4;
    function helper(opts) {
      var visitor2 = {};
      visitor2.JSXNamespacedName = function(path2) {
        if (opts.throwIfNamespace) {
          throw path2.buildCodeFrameError("Namespace tags are not supported by default. React's JSX doesn't support namespace tags. You can set `throwIfNamespace: false` to bypass this warning.");
        }
      };
      visitor2.JSXSpreadChild = function(path2) {
        throw path2.buildCodeFrameError("Spread children are not supported in React.");
      };
      visitor2.JSXElement = {
        exit: function exit(path2, file2) {
          var callExpr = buildElementCall(path2, file2);
          if (callExpr) {
            path2.replaceWith(inherits2(callExpr, path2.node));
          }
        }
      };
      visitor2.JSXFragment = {
        exit: function exit(path2, file2) {
          if (opts.compat) {
            throw path2.buildCodeFrameError("Fragment tags are only supported in React 16 and up.");
          }
          var callExpr = buildFragmentCall(path2, file2);
          if (callExpr) {
            path2.replaceWith(inherits2(callExpr, path2.node));
          }
        }
      };
      return visitor2;
      function convertJSXIdentifier(node2, parent) {
        if (isJSXIdentifier(node2)) {
          if (node2.name === "this" && isReferenced(node2, parent)) {
            return thisExpression();
          } else if (isValidIdentifier(node2.name, false)) {
            node2.type = "Identifier";
          } else {
            return stringLiteral(node2.name);
          }
        } else if (isJSXMemberExpression(node2)) {
          return memberExpression(convertJSXIdentifier(node2.object, node2), convertJSXIdentifier(node2.property, node2));
        } else if (isJSXNamespacedName(node2)) {
          return stringLiteral(node2.namespace.name + ":" + node2.name.name);
        }
        return node2;
      }
      function convertAttributeValue(node2) {
        if (isJSXExpressionContainer(node2)) {
          return node2.expression;
        } else {
          return node2;
        }
      }
      function convertAttribute(node2) {
        var value = convertAttributeValue(node2.value || booleanLiteral(true));
        if (isJSXSpreadAttribute(node2)) {
          return spreadElement(node2.argument);
        }
        if (isStringLiteral$1(value) && !isJSXExpressionContainer(node2.value)) {
          var _value$extra;
          value.value = value.value.replace(/\n\s+/g, " ");
          (_value$extra = value.extra) == null ? true : delete _value$extra.raw;
        }
        if (isJSXNamespacedName(node2.name)) {
          node2.name = stringLiteral(node2.name.namespace.name + ":" + node2.name.name.name);
        } else if (isValidIdentifier(node2.name.name, false)) {
          node2.name.type = "Identifier";
        } else {
          node2.name = stringLiteral(node2.name.name);
        }
        return inherits2(objectProperty(node2.name, value), node2);
      }
      function buildElementCall(path2, file2) {
        if (opts.filter && !opts.filter(path2.node, file2))
          return;
        var openingPath = path2.get("openingElement");
        openingPath.parent.children = react.buildChildren(openingPath.parent);
        var tagExpr = convertJSXIdentifier(openingPath.node.name, openingPath.node);
        var args = [];
        var tagName;
        if (isIdentifier$1(tagExpr)) {
          tagName = tagExpr.name;
        } else if (isLiteral(tagExpr)) {
          tagName = tagExpr.value;
        }
        var state = {
          tagExpr,
          tagName,
          args,
          pure: false
        };
        if (opts.pre) {
          opts.pre(state, file2);
        }
        var attribs = openingPath.node.attributes;
        if (attribs.length) {
          {
            attribs = buildOpeningElementAttributes(attribs, file2);
          }
        } else {
          attribs = nullLiteral();
        }
        args.push.apply(args, [attribs].concat(_toConsumableArray2(path2.node.children)));
        if (opts.post) {
          opts.post(state, file2);
        }
        var call3 = state.call || callExpression(state.callee, args);
        if (state.pure)
          annotateAsPure(call3);
        return call3;
      }
      function pushProps(_props, objs) {
        if (!_props.length)
          return _props;
        objs.push(objectExpression(_props));
        return [];
      }
      function buildOpeningElementAttributes(attribs, file2) {
        var _props = [];
        var objs = [];
        var _file$opts$useSpread = file2.opts.useSpread, useSpread = _file$opts$useSpread === void 0 ? false : _file$opts$useSpread;
        if (typeof useSpread !== "boolean") {
          throw new Error("transform-react-jsx currently only accepts a boolean option for useSpread (defaults to false)");
        }
        var useBuiltIns = file2.opts.useBuiltIns || false;
        if (typeof useBuiltIns !== "boolean") {
          throw new Error("transform-react-jsx currently only accepts a boolean option for useBuiltIns (defaults to false)");
        }
        if (useSpread && useBuiltIns) {
          throw new Error("transform-react-jsx currently only accepts useBuiltIns or useSpread but not both");
        }
        if (useSpread) {
          var props = attribs.map(convertAttribute);
          return objectExpression(props);
        }
        while (attribs.length) {
          var prop2 = attribs.shift();
          if (isJSXSpreadAttribute(prop2)) {
            _props = pushProps(_props, objs);
            objs.push(prop2.argument);
          } else {
            _props.push(convertAttribute(prop2));
          }
        }
        pushProps(_props, objs);
        if (objs.length === 1) {
          attribs = objs[0];
        } else {
          if (!isObjectExpression(objs[0])) {
            objs.unshift(objectExpression([]));
          }
          var helper2 = useBuiltIns ? memberExpression(identifier("Object"), identifier("assign")) : file2.addHelper("extends");
          attribs = callExpression(helper2, objs);
        }
        return attribs;
      }
      function buildFragmentCall(path2, file2) {
        if (opts.filter && !opts.filter(path2.node, file2))
          return;
        var openingPath = path2.get("openingElement");
        openingPath.parent.children = react.buildChildren(openingPath.parent);
        var args = [];
        var tagName = null;
        var tagExpr = file2.get("jsxFragIdentifier")();
        var state = {
          tagExpr,
          tagName,
          args,
          pure: false
        };
        if (opts.pre) {
          opts.pre(state, file2);
        }
        args.push.apply(args, [nullLiteral()].concat(_toConsumableArray2(path2.node.children)));
        if (opts.post) {
          opts.post(state, file2);
        }
        file2.set("usedFragment", true);
        var call3 = state.call || callExpression(state.callee, args);
        if (state.pure)
          annotateAsPure(call3);
        return call3;
      }
    }
    var transformReactInlineElements = declare(function(api) {
      api.assertVersion(7);
      function hasRefOrSpread(attrs) {
        for (var i2 = 0; i2 < attrs.length; i2++) {
          var attr = attrs[i2];
          if (isJSXSpreadAttribute$1(attr))
            return true;
          if (isJSXAttributeOfName(attr, "ref"))
            return true;
        }
        return false;
      }
      function isJSXAttributeOfName(attr, name2) {
        return isJSXAttribute(attr) && isJSXIdentifier$3(attr.name, {
          name: name2
        });
      }
      var visitor2 = helper({
        filter: function filter3(node2) {
          return node2.openingElement && !hasRefOrSpread(node2.openingElement.attributes);
        },
        pre: function pre(state) {
          var tagName = state.tagName;
          var args = state.args;
          if (react$3.isCompatTag(tagName)) {
            args.push(stringLiteral$8(tagName));
          } else {
            args.push(state.tagExpr);
          }
        },
        post: function post(state, pass) {
          state.callee = pass.addHelper("jsx");
          var props = state.args[1];
          var hasKey = false;
          if (isObjectExpression$3(props)) {
            var keyIndex = props.properties.findIndex(function(prop2) {
              return isIdentifier$i(prop2.key, {
                name: "key"
              });
            });
            if (keyIndex > -1) {
              state.args.splice(2, 0, props.properties[keyIndex].value);
              props.properties.splice(keyIndex, 1);
              hasKey = true;
            }
          } else if (isNullLiteral$1(props)) {
            state.args.splice(1, 1, objectExpression$4([]));
          }
          if (!hasKey && state.args.length > 2) {
            state.args.splice(2, 0, unaryExpression$6("void", numericLiteral$7(0)));
          }
          state.pure = true;
        }
      });
      return {
        name: "transform-react-inline-elements",
        visitor: visitor2
      };
    });
    var DEFAULT = {
      importSource: "react",
      runtime: "automatic",
      pragma: "React.createElement",
      pragmaFrag: "React.Fragment"
    };
    var JSX_SOURCE_ANNOTATION_REGEX = /^\s*\*?\s*@jsxImportSource\s+([^\s]+)\s*$/m;
    var JSX_RUNTIME_ANNOTATION_REGEX = /^\s*\*?\s*@jsxRuntime\s+([^\s]+)\s*$/m;
    var JSX_ANNOTATION_REGEX = /^\s*\*?\s*@jsx\s+([^\s]+)\s*$/m;
    var JSX_FRAG_ANNOTATION_REGEX = /^\s*\*?\s*@jsxFrag\s+([^\s]+)\s*$/m;
    var get2 = function get3(pass, name2) {
      return pass.get("@babel/plugin-react-jsx/" + name2);
    };
    var set2 = function set3(pass, name2, v22) {
      return pass.set("@babel/plugin-react-jsx/" + name2, v22);
    };
    function createPlugin(_ref3) {
      var name2 = _ref3.name, development = _ref3.development;
      return declare(function(api, options) {
        var PURE_ANNOTATION2 = options.pure, _options$throwIfNames = options.throwIfNamespace, throwIfNamespace = _options$throwIfNames === void 0 ? true : _options$throwIfNames, filter3 = options.filter, _options$runtime = options.runtime, RUNTIME_DEFAULT = _options$runtime === void 0 ? development ? "automatic" : "classic" : _options$runtime, _options$importSource = options.importSource, IMPORT_SOURCE_DEFAULT = _options$importSource === void 0 ? DEFAULT.importSource : _options$importSource, _options$pragma = options.pragma, PRAGMA_DEFAULT = _options$pragma === void 0 ? DEFAULT.pragma : _options$pragma, _options$pragmaFrag = options.pragmaFrag, PRAGMA_FRAG_DEFAULT = _options$pragmaFrag === void 0 ? DEFAULT.pragmaFrag : _options$pragmaFrag;
        {
          var _options$useSpread = options.useSpread, useSpread = _options$useSpread === void 0 ? false : _options$useSpread, _options$useBuiltIns = options.useBuiltIns, useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns;
          if (RUNTIME_DEFAULT === "classic") {
            if (typeof useSpread !== "boolean") {
              throw new Error("transform-react-jsx currently only accepts a boolean option for useSpread (defaults to false)");
            }
            if (typeof useBuiltIns !== "boolean") {
              throw new Error("transform-react-jsx currently only accepts a boolean option for useBuiltIns (defaults to false)");
            }
            if (useSpread && useBuiltIns) {
              throw new Error("transform-react-jsx currently only accepts useBuiltIns or useSpread but not both");
            }
          }
        }
        var injectMetaPropertiesVisitor = {
          JSXOpeningElement: function JSXOpeningElement2(path2, state) {
            var attributes = [];
            if (isThisAllowed2(path2.scope)) {
              attributes.push(jsxAttribute(jsxIdentifier$2("__self"), jsxExpressionContainer$1(thisExpression$4())));
            }
            attributes.push(jsxAttribute(jsxIdentifier$2("__source"), jsxExpressionContainer$1(makeSource(path2, state))));
            path2.pushContainer("attributes", attributes);
          }
        };
        return {
          name: name2,
          inherits: syntaxJsx,
          visitor: {
            JSXNamespacedName: function JSXNamespacedName2(path2) {
              if (throwIfNamespace) {
                throw path2.buildCodeFrameError("Namespace tags are not supported by default. React's JSX doesn't support namespace tags. You can set `throwIfNamespace: false` to bypass this warning.");
              }
            },
            JSXSpreadChild: function JSXSpreadChild2(path2) {
              throw path2.buildCodeFrameError("Spread children are not supported in React.");
            },
            Program: {
              enter: function enter(path2, state) {
                var file2 = state.file;
                var runtime3 = RUNTIME_DEFAULT;
                var source = IMPORT_SOURCE_DEFAULT;
                var pragma = PRAGMA_DEFAULT;
                var pragmaFrag = PRAGMA_FRAG_DEFAULT;
                var sourceSet = !!options.importSource;
                var pragmaSet = !!options.pragma;
                var pragmaFragSet = !!options.pragmaFrag;
                if (file2.ast.comments) {
                  for (var _iterator2 = _createForOfIteratorHelperLoose(file2.ast.comments), _step2; !(_step2 = _iterator2()).done; ) {
                    var comment = _step2.value;
                    var sourceMatches = JSX_SOURCE_ANNOTATION_REGEX.exec(comment.value);
                    if (sourceMatches) {
                      source = sourceMatches[1];
                      sourceSet = true;
                    }
                    var runtimeMatches = JSX_RUNTIME_ANNOTATION_REGEX.exec(comment.value);
                    if (runtimeMatches) {
                      runtime3 = runtimeMatches[1];
                    }
                    var jsxMatches = JSX_ANNOTATION_REGEX.exec(comment.value);
                    if (jsxMatches) {
                      pragma = jsxMatches[1];
                      pragmaSet = true;
                    }
                    var jsxFragMatches = JSX_FRAG_ANNOTATION_REGEX.exec(comment.value);
                    if (jsxFragMatches) {
                      pragmaFrag = jsxFragMatches[1];
                      pragmaFragSet = true;
                    }
                  }
                }
                set2(state, "runtime", runtime3);
                if (runtime3 === "classic") {
                  if (sourceSet) {
                    throw path2.buildCodeFrameError("importSource cannot be set when runtime is classic.");
                  }
                  var createElement2 = toMemberExpression(pragma);
                  var fragment = toMemberExpression(pragmaFrag);
                  set2(state, "id/createElement", function() {
                    return cloneNode$i(createElement2);
                  });
                  set2(state, "id/fragment", function() {
                    return cloneNode$i(fragment);
                  });
                  set2(state, "defaultPure", pragma === DEFAULT.pragma);
                } else if (runtime3 === "automatic") {
                  if (pragmaSet || pragmaFragSet) {
                    throw path2.buildCodeFrameError("pragma and pragmaFrag cannot be set when runtime is automatic.");
                  }
                  var define2 = function define3(name3, id3) {
                    return set2(state, name3, createImportLazily(state, path2, id3, source));
                  };
                  define2("id/jsx", development ? "jsxDEV" : "jsx");
                  define2("id/jsxs", development ? "jsxDEV" : "jsxs");
                  define2("id/createElement", "createElement");
                  define2("id/fragment", "Fragment");
                  set2(state, "defaultPure", source === DEFAULT.importSource);
                } else {
                  throw path2.buildCodeFrameError('Runtime must be either "classic" or "automatic".');
                }
                if (development) {
                  path2.traverse(injectMetaPropertiesVisitor, state);
                }
              }
            },
            JSXElement: {
              exit: function exit(path2, file2) {
                var callExpr;
                if (get2(file2, "runtime") === "classic" || shouldUseCreateElement(path2)) {
                  callExpr = buildCreateElementCall(path2, file2);
                } else {
                  callExpr = buildJSXElementCall(path2, file2);
                }
                path2.replaceWith(inherits$1(callExpr, path2.node));
              }
            },
            JSXFragment: {
              exit: function exit(path2, file2) {
                var callExpr;
                if (get2(file2, "runtime") === "classic") {
                  callExpr = buildCreateElementFragmentCall(path2, file2);
                } else {
                  callExpr = buildJSXFragmentCall(path2, file2);
                }
                path2.replaceWith(inherits$1(callExpr, path2.node));
              }
            },
            JSXAttribute: function JSXAttribute2(path2) {
              if (isJSXElement(path2.node.value)) {
                path2.node.value = jsxExpressionContainer$1(path2.node.value);
              }
            }
          }
        };
        function isDerivedClass2(classPath) {
          return classPath.node.superClass !== null;
        }
        function isThisAllowed2(scope2) {
          do {
            var _scope = scope2, path2 = _scope.path;
            if (path2.isFunctionParent() && !path2.isArrowFunctionExpression()) {
              if (!path2.isMethod()) {
                return true;
              }
              if (path2.node.kind !== "constructor") {
                return true;
              }
              return !isDerivedClass2(path2.parentPath.parentPath);
            }
            if (path2.isTSModuleBlock()) {
              return false;
            }
          } while (scope2 = scope2.parent);
          return true;
        }
        function call3(pass, name3, args) {
          var node2 = callExpression$e(get2(pass, "id/" + name3)(), args);
          if (PURE_ANNOTATION2 != null ? PURE_ANNOTATION2 : get2(pass, "defaultPure"))
            annotateAsPure(node2);
          return node2;
        }
        function shouldUseCreateElement(path2) {
          var openingPath = path2.get("openingElement");
          var attributes = openingPath.node.attributes;
          var seenPropsSpread = false;
          for (var i2 = 0; i2 < attributes.length; i2++) {
            var attr = attributes[i2];
            if (seenPropsSpread && isJSXAttribute(attr) && attr.name.name === "key") {
              return true;
            } else if (isJSXSpreadAttribute$1(attr)) {
              seenPropsSpread = true;
            }
          }
          return false;
        }
        function convertJSXIdentifier(node2, parent) {
          if (isJSXIdentifier$3(node2)) {
            if (node2.name === "this" && isReferenced$2(node2, parent)) {
              return thisExpression$4();
            } else if (isValidIdentifier$1(node2.name, false)) {
              node2.type = "Identifier";
            } else {
              return stringLiteral$8(node2.name);
            }
          } else if (isJSXMemberExpression$2(node2)) {
            return memberExpression$b(convertJSXIdentifier(node2.object, node2), convertJSXIdentifier(node2.property, node2));
          } else if (isJSXNamespacedName$1(node2)) {
            return stringLiteral$8(node2.namespace.name + ":" + node2.name.name);
          }
          return node2;
        }
        function convertAttributeValue(node2) {
          if (isJSXExpressionContainer$1(node2)) {
            return node2.expression;
          } else {
            return node2;
          }
        }
        function accumulateAttribute(array4, attribute) {
          if (isJSXSpreadAttribute$1(attribute.node)) {
            var arg = attribute.node.argument;
            if (isObjectExpression$3(arg)) {
              array4.push.apply(array4, _toConsumableArray2(arg.properties));
            } else {
              array4.push(spreadElement$2(arg));
            }
            return array4;
          }
          var value = convertAttributeValue(attribute.node.name.name !== "key" ? attribute.node.value || booleanLiteral$5(true) : attribute.node.value);
          if (attribute.node.name.name === "key" && value === null) {
            throw attribute.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
          }
          if (isStringLiteral$7(value) && !isJSXExpressionContainer$1(attribute.node.value)) {
            var _value$extra;
            value.value = value.value.replace(/\n\s+/g, " ");
            (_value$extra = value.extra) == null ? true : delete _value$extra.raw;
          }
          if (isJSXNamespacedName$1(attribute.node.name)) {
            attribute.node.name = stringLiteral$8(attribute.node.name.namespace.name + ":" + attribute.node.name.name.name);
          } else if (isValidIdentifier$1(attribute.node.name.name, false)) {
            attribute.node.name.type = "Identifier";
          } else {
            attribute.node.name = stringLiteral$8(attribute.node.name.name);
          }
          array4.push(inherits$1(objectProperty$2(attribute.node.name, value), attribute.node));
          return array4;
        }
        function buildChildrenProperty(children) {
          var childrenNode;
          if (children.length === 1) {
            childrenNode = children[0];
          } else if (children.length > 1) {
            childrenNode = arrayExpression$2(children);
          } else {
            return void 0;
          }
          return objectProperty$2(identifier$j("children"), childrenNode);
        }
        function buildJSXElementCall(path2, file2) {
          var openingPath = path2.get("openingElement");
          var args = [getTag2(openingPath)];
          var attribsArray = [];
          var extracted = /* @__PURE__ */ Object.create(null);
          for (var _iterator2 = _createForOfIteratorHelperLoose(openingPath.get("attributes")), _step2; !(_step2 = _iterator2()).done; ) {
            var attr = _step2.value;
            if (attr.isJSXAttribute() && isJSXIdentifier$3(attr.node.name)) {
              var _name = attr.node.name.name;
              switch (_name) {
                case "__source":
                case "__self":
                  if (extracted[_name])
                    throw sourceSelfError(path2, _name);
                case "key": {
                  var keyValue = convertAttributeValue(attr.node.value);
                  if (keyValue === null) {
                    throw attr.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
                  }
                  extracted[_name] = keyValue;
                  break;
                }
                default:
                  attribsArray.push(attr);
              }
            } else {
              attribsArray.push(attr);
            }
          }
          var children = react$3.buildChildren(path2.node);
          var attribs;
          if (attribsArray.length || children.length) {
            attribs = buildJSXOpeningElementAttributes(attribsArray, children);
          } else {
            attribs = objectExpression$4([]);
          }
          args.push(attribs);
          if (development) {
            var _extracted$key, _extracted$__source, _extracted$__self;
            args.push((_extracted$key = extracted.key) != null ? _extracted$key : path2.scope.buildUndefinedNode(), booleanLiteral$5(children.length > 1), (_extracted$__source = extracted.__source) != null ? _extracted$__source : path2.scope.buildUndefinedNode(), (_extracted$__self = extracted.__self) != null ? _extracted$__self : path2.scope.buildUndefinedNode());
          } else if (extracted.key !== void 0) {
            args.push(extracted.key);
          }
          return call3(file2, children.length > 1 ? "jsxs" : "jsx", args);
        }
        function buildJSXOpeningElementAttributes(attribs, children) {
          var props = attribs.reduce(accumulateAttribute, []);
          if ((children == null ? void 0 : children.length) > 0) {
            props.push(buildChildrenProperty(children));
          }
          return objectExpression$4(props);
        }
        function buildJSXFragmentCall(path2, file2) {
          var args = [get2(file2, "id/fragment")()];
          var children = react$3.buildChildren(path2.node);
          args.push(objectExpression$4(children.length > 0 ? [buildChildrenProperty(children)] : []));
          if (development) {
            args.push(path2.scope.buildUndefinedNode(), booleanLiteral$5(children.length > 1));
          }
          return call3(file2, children.length > 1 ? "jsxs" : "jsx", args);
        }
        function buildCreateElementFragmentCall(path2, file2) {
          if (filter3 && !filter3(path2.node, file2))
            return;
          return call3(file2, "createElement", [get2(file2, "id/fragment")(), nullLiteral$2()].concat(_toConsumableArray2(react$3.buildChildren(path2.node))));
        }
        function buildCreateElementCall(path2, file2) {
          var openingPath = path2.get("openingElement");
          return call3(file2, "createElement", [getTag2(openingPath), buildCreateElementOpeningElementAttributes(file2, path2, openingPath.get("attributes"))].concat(_toConsumableArray2(react$3.buildChildren(path2.node))));
        }
        function getTag2(openingPath) {
          var tagExpr = convertJSXIdentifier(openingPath.node.name, openingPath.node);
          var tagName;
          if (isIdentifier$i(tagExpr)) {
            tagName = tagExpr.name;
          } else if (isLiteral$7(tagExpr)) {
            tagName = tagExpr.value;
          }
          if (react$3.isCompatTag(tagName)) {
            return stringLiteral$8(tagName);
          } else {
            return tagExpr;
          }
        }
        function buildCreateElementOpeningElementAttributes(file2, path2, attribs) {
          var runtime3 = get2(file2, "runtime");
          {
            if (runtime3 !== "automatic") {
              var objs = [];
              var _props = attribs.reduce(accumulateAttribute, []);
              if (!useSpread) {
                var start2 = 0;
                _props.forEach(function(prop2, i2) {
                  if (isSpreadElement$1(prop2)) {
                    if (i2 > start2) {
                      objs.push(objectExpression$4(_props.slice(start2, i2)));
                    }
                    objs.push(prop2.argument);
                    start2 = i2 + 1;
                  }
                });
                if (_props.length > start2) {
                  objs.push(objectExpression$4(_props.slice(start2)));
                }
              } else if (_props.length) {
                objs.push(objectExpression$4(_props));
              }
              if (!objs.length) {
                return nullLiteral$2();
              }
              if (objs.length === 1) {
                return objs[0];
              }
              if (!isObjectExpression$3(objs[0])) {
                objs.unshift(objectExpression$4([]));
              }
              var helper2 = useBuiltIns ? memberExpression$b(identifier$j("Object"), identifier$j("assign")) : file2.addHelper("extends");
              return callExpression$e(helper2, objs);
            }
          }
          var props = [];
          var found = /* @__PURE__ */ Object.create(null);
          for (var _iterator3 = _createForOfIteratorHelperLoose(attribs), _step3; !(_step3 = _iterator3()).done; ) {
            var attr = _step3.value;
            var _name2 = isJSXAttribute(attr) && isJSXIdentifier$3(attr.name) && attr.name.name;
            if (runtime3 === "automatic" && (_name2 === "__source" || _name2 === "__self")) {
              if (found[_name2])
                throw sourceSelfError(path2, _name2);
              found[_name2] = true;
            }
            accumulateAttribute(props, attr);
          }
          return props.length === 1 && isSpreadElement$1(props[0]) ? props[0].argument : props.length > 0 ? objectExpression$4(props) : nullLiteral$2();
        }
      });
      function getSource2(source, importName) {
        switch (importName) {
          case "Fragment":
            return source + "/" + (development ? "jsx-dev-runtime" : "jsx-runtime");
          case "jsxDEV":
            return source + "/jsx-dev-runtime";
          case "jsx":
          case "jsxs":
            return source + "/jsx-runtime";
          case "createElement":
            return source;
        }
      }
      function createImportLazily(pass, path2, importName, source) {
        return function() {
          var actualSource = getSource2(source, importName);
          if (isModule(path2)) {
            var reference = get2(pass, "imports/" + importName);
            if (reference)
              return cloneNode$i(reference);
            reference = addNamed(path2, importName, actualSource, {
              importedInterop: "uncompiled",
              importPosition: "after"
            });
            set2(pass, "imports/" + importName, reference);
            return reference;
          } else {
            var _reference = get2(pass, "requires/" + actualSource);
            if (_reference) {
              _reference = cloneNode$i(_reference);
            } else {
              _reference = addNamespace(path2, actualSource, {
                importedInterop: "uncompiled"
              });
              set2(pass, "requires/" + actualSource, _reference);
            }
            return memberExpression$b(_reference, identifier$j(importName));
          }
        };
      }
    }
    function toMemberExpression(id3) {
      return id3.split(".").map(function(name2) {
        return identifier$j(name2);
      }).reduce(function(object4, property2) {
        return memberExpression$b(object4, property2);
      });
    }
    function makeSource(path2, state) {
      var location = path2.node.loc;
      if (!location) {
        return path2.scope.buildUndefinedNode();
      }
      if (!state.fileNameIdentifier) {
        var _state$filename = state.filename, filename = _state$filename === void 0 ? "" : _state$filename;
        var fileNameIdentifier = path2.scope.generateUidIdentifier("_jsxFileName");
        var scope2 = path2.hub.getScope();
        if (scope2) {
          scope2.push({
            id: fileNameIdentifier,
            init: stringLiteral$8(filename)
          });
        }
        state.fileNameIdentifier = fileNameIdentifier;
      }
      return makeTrace(cloneNode$i(state.fileNameIdentifier), location.start.line, location.start.column);
    }
    function makeTrace(fileNameIdentifier, lineNumber, column0Based) {
      var fileLineLiteral = lineNumber != null ? numericLiteral$7(lineNumber) : nullLiteral$2();
      var fileColumnLiteral = column0Based != null ? numericLiteral$7(column0Based + 1) : nullLiteral$2();
      var fileNameProperty = objectProperty$2(identifier$j("fileName"), fileNameIdentifier);
      var lineNumberProperty = objectProperty$2(identifier$j("lineNumber"), fileLineLiteral);
      var columnNumberProperty = objectProperty$2(identifier$j("columnNumber"), fileColumnLiteral);
      return objectExpression$4([fileNameProperty, lineNumberProperty, columnNumberProperty]);
    }
    function sourceSelfError(path2, name2) {
      var pluginName = "transform-react-jsx-" + name2.slice(2);
      return path2.buildCodeFrameError("Duplicate " + name2 + " prop found. You are most likely using the deprecated " + pluginName + " Babel plugin. Both __source and __self are automatically set when using the automatic runtime. Please remove transform-react-jsx-source and transform-react-jsx-self from your Babel config.");
    }
    var transformReactJSX = createPlugin({
      name: "transform-react-jsx",
      development: false
    });
    var transformReactJsxCompat = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-react-jsx-compat",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("jsx");
        },
        visitor: helper({
          pre: function pre(state) {
            state.callee = state.tagExpr;
          },
          post: function post(state) {
            if (react$3.isCompatTag(state.tagName)) {
              state.call = callExpression$e(memberExpression$b(memberExpression$b(identifier$j("React"), identifier$j("DOM")), state.tagExpr, isLiteral$7(state.tagExpr)), state.args);
            }
          },
          compat: true
        })
      };
    });
    var transformReactJSXDevelopment = createPlugin({
      name: "transform-react-jsx/development",
      development: true
    });
    var TRACE_ID$1 = "__self";
    function getThisFunctionParent(path2) {
      var scope2 = path2.scope;
      do {
        if (scope2.path.isFunctionParent() && !scope2.path.isArrowFunctionExpression()) {
          return scope2.path;
        }
      } while (scope2 = scope2.parent);
      return null;
    }
    function isDerivedClass(classPath) {
      return classPath.node.superClass !== null;
    }
    function isThisAllowed(path2) {
      var parentMethodOrFunction = getThisFunctionParent(path2);
      if (parentMethodOrFunction === null) {
        return true;
      }
      if (!parentMethodOrFunction.isMethod()) {
        return true;
      }
      if (parentMethodOrFunction.node.kind !== "constructor") {
        return true;
      }
      return !isDerivedClass(parentMethodOrFunction.parentPath.parentPath);
    }
    var transformReactJsxSelf = declare(function(api) {
      api.assertVersion(7);
      var visitor2 = {
        JSXOpeningElement: function JSXOpeningElement2(path2) {
          if (!isThisAllowed(path2)) {
            return;
          }
          var node2 = path2.node;
          var id3 = jsxIdentifier$2(TRACE_ID$1);
          var trace = thisExpression$4();
          node2.attributes.push(jsxAttribute(id3, jsxExpressionContainer$1(trace)));
        }
      };
      return {
        name: "transform-react-jsx-self",
        visitor: {
          Program: function Program2(path2) {
            path2.traverse(visitor2);
          }
        }
      };
    });
    var TRACE_ID = "__source";
    var FILE_NAME_VAR = "_jsxFileName";
    var transformReactJsxSource = declare(function(api) {
      api.assertVersion(7);
      function makeTrace2(fileNameIdentifier, lineNumber, column0Based) {
        var fileLineLiteral = lineNumber != null ? numericLiteral$7(lineNumber) : nullLiteral$2();
        var fileColumnLiteral = column0Based != null ? numericLiteral$7(column0Based + 1) : nullLiteral$2();
        var fileNameProperty = objectProperty$2(identifier$j("fileName"), fileNameIdentifier);
        var lineNumberProperty = objectProperty$2(identifier$j("lineNumber"), fileLineLiteral);
        var columnNumberProperty = objectProperty$2(identifier$j("columnNumber"), fileColumnLiteral);
        return objectExpression$4([fileNameProperty, lineNumberProperty, columnNumberProperty]);
      }
      var visitor2 = {
        JSXOpeningElement: function JSXOpeningElement2(path2, state) {
          var id3 = jsxIdentifier$2(TRACE_ID);
          var location = path2.container.openingElement.loc;
          if (!location) {
            return;
          }
          var attributes = path2.container.openingElement.attributes;
          for (var i2 = 0; i2 < attributes.length; i2++) {
            var name2 = attributes[i2].name;
            if ((name2 == null ? void 0 : name2.name) === TRACE_ID) {
              return;
            }
          }
          if (!state.fileNameIdentifier) {
            var fileName = state.filename || "";
            var fileNameIdentifier = path2.scope.generateUidIdentifier(FILE_NAME_VAR);
            var scope2 = path2.hub.getScope();
            if (scope2) {
              scope2.push({
                id: fileNameIdentifier,
                init: stringLiteral$8(fileName)
              });
            }
            state.fileNameIdentifier = fileNameIdentifier;
          }
          var trace = makeTrace2(cloneNode$i(state.fileNameIdentifier), location.start.line, location.start.column);
          attributes.push(jsxAttribute(id3, jsxExpressionContainer$1(trace)));
        }
      };
      return {
        name: "transform-react-jsx-source",
        visitor: visitor2
      };
    });
    var lib$e = {};
    var visit = {};
    var interopRequireDefault = { exports: {} };
    (function(module2) {
      function _interopRequireDefault2(obj) {
        return obj && obj.__esModule ? obj : {
          "default": obj
        };
      }
      module2.exports = _interopRequireDefault2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
    })(interopRequireDefault);
    var hoist$2 = {};
    var util$12 = {};
    var hasRequiredUtil;
    function requireUtil() {
      if (hasRequiredUtil)
        return util$12;
      hasRequiredUtil = 1;
      util$12.__esModule = true;
      util$12.wrapWithTypes = wrapWithTypes;
      util$12.getTypes = getTypes;
      util$12.runtimeProperty = runtimeProperty;
      util$12.isReference = isReference2;
      util$12.replaceWithOrRemove = replaceWithOrRemove;
      var currentTypes = null;
      function wrapWithTypes(types3, fn) {
        return function() {
          var oldTypes = currentTypes;
          currentTypes = types3;
          try {
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }
            return fn.apply(this, args);
          } finally {
            currentTypes = oldTypes;
          }
        };
      }
      function getTypes() {
        return currentTypes;
      }
      function runtimeProperty(name2) {
        var t3 = getTypes();
        return t3.memberExpression(t3.identifier("regeneratorRuntime"), t3.identifier(name2), false);
      }
      function isReference2(path2) {
        return path2.isReferenced() || path2.parentPath.isAssignmentExpression({
          left: path2.node
        });
      }
      function replaceWithOrRemove(path2, replacement) {
        if (replacement) {
          path2.replaceWith(replacement);
        } else {
          path2.remove();
        }
      }
      return util$12;
    }
    var hasRequiredHoist;
    function requireHoist() {
      if (hasRequiredHoist)
        return hoist$2;
      hasRequiredHoist = 1;
      var util3 = _interopRequireWildcard2(requireUtil());
      function _getRequireWildcardCache2(nodeInterop) {
        if (typeof WeakMap !== "function")
          return null;
        var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
        var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
        return (_getRequireWildcardCache2 = function _getRequireWildcardCache3(nodeInterop2) {
          return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
        })(nodeInterop);
      }
      function _interopRequireWildcard2(obj, nodeInterop) {
        if (!nodeInterop && obj && obj.__esModule) {
          return obj;
        }
        if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
          return {
            "default": obj
          };
        }
        var cache2 = _getRequireWildcardCache2(nodeInterop);
        if (cache2 && cache2.has(obj)) {
          return cache2.get(obj);
        }
        var newObj = {};
        var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var key2 in obj) {
          if (key2 !== "default" && Object.prototype.hasOwnProperty.call(obj, key2)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key2) : null;
            if (desc && (desc.get || desc.set)) {
              Object.defineProperty(newObj, key2, desc);
            } else {
              newObj[key2] = obj[key2];
            }
          }
        }
        newObj["default"] = obj;
        if (cache2) {
          cache2.set(obj, newObj);
        }
        return newObj;
      }
      var hasOwn3 = Object.prototype.hasOwnProperty;
      hoist$2.hoist = function(funPath) {
        var t3 = util3.getTypes();
        t3.assertFunction(funPath.node);
        var vars = {};
        function varDeclToExpr(_ref3, includeIdentifiers) {
          var vdec = _ref3.node, scope2 = _ref3.scope;
          t3.assertVariableDeclaration(vdec);
          var exprs = [];
          vdec.declarations.forEach(function(dec) {
            vars[dec.id.name] = t3.identifier(dec.id.name);
            scope2.removeBinding(dec.id.name);
            if (dec.init) {
              exprs.push(t3.assignmentExpression("=", dec.id, dec.init));
            } else if (includeIdentifiers) {
              exprs.push(dec.id);
            }
          });
          if (exprs.length === 0)
            return null;
          if (exprs.length === 1)
            return exprs[0];
          return t3.sequenceExpression(exprs);
        }
        funPath.get("body").traverse({
          VariableDeclaration: {
            exit: function exit(path2) {
              var expr = varDeclToExpr(path2, false);
              if (expr === null) {
                path2.remove();
              } else {
                util3.replaceWithOrRemove(path2, t3.expressionStatement(expr));
              }
              path2.skip();
            }
          },
          ForStatement: function ForStatement2(path2) {
            var init3 = path2.get("init");
            if (init3.isVariableDeclaration()) {
              util3.replaceWithOrRemove(init3, varDeclToExpr(init3, false));
            }
          },
          ForXStatement: function ForXStatement(path2) {
            var left = path2.get("left");
            if (left.isVariableDeclaration()) {
              util3.replaceWithOrRemove(left, varDeclToExpr(left, true));
            }
          },
          FunctionDeclaration: function FunctionDeclaration(path2) {
            var node2 = path2.node;
            vars[node2.id.name] = node2.id;
            var assignment = t3.expressionStatement(t3.assignmentExpression("=", t3.clone(node2.id), t3.functionExpression(path2.scope.generateUidIdentifierBasedOnNode(node2), node2.params, node2.body, node2.generator, node2.expression)));
            if (path2.parentPath.isBlockStatement()) {
              path2.parentPath.unshiftContainer("body", assignment);
              path2.remove();
            } else {
              util3.replaceWithOrRemove(path2, assignment);
            }
            path2.scope.removeBinding(node2.id.name);
            path2.skip();
          },
          FunctionExpression: function FunctionExpression2(path2) {
            path2.skip();
          },
          ArrowFunctionExpression: function ArrowFunctionExpression2(path2) {
            path2.skip();
          }
        });
        var paramNames = {};
        funPath.get("params").forEach(function(paramPath) {
          var param = paramPath.node;
          if (t3.isIdentifier(param)) {
            paramNames[param.name] = param;
          }
        });
        var declarations = [];
        Object.keys(vars).forEach(function(name2) {
          if (!hasOwn3.call(paramNames, name2)) {
            declarations.push(t3.variableDeclarator(vars[name2], null));
          }
        });
        if (declarations.length === 0) {
          return null;
        }
        return t3.variableDeclaration("var", declarations);
      };
      return hoist$2;
    }
    var emit = {};
    var leap = {};
    var hasRequiredLeap;
    function requireLeap() {
      if (hasRequiredLeap)
        return leap;
      hasRequiredLeap = 1;
      var _interopRequireDefault2 = interopRequireDefault.exports;
      var _assert2 = _interopRequireDefault2(assert$1.exports);
      var _emit2 = requireEmit();
      var _util = util$32;
      var _util2 = requireUtil();
      function Entry2() {
        _assert2["default"].ok(this instanceof Entry2);
      }
      function FunctionEntry(returnLoc) {
        Entry2.call(this);
        (0, _util2.getTypes)().assertLiteral(returnLoc);
        this.returnLoc = returnLoc;
      }
      (0, _util.inherits)(FunctionEntry, Entry2);
      leap.FunctionEntry = FunctionEntry;
      function LoopEntry(breakLoc, continueLoc, label) {
        Entry2.call(this);
        var t3 = (0, _util2.getTypes)();
        t3.assertLiteral(breakLoc);
        t3.assertLiteral(continueLoc);
        if (label) {
          t3.assertIdentifier(label);
        } else {
          label = null;
        }
        this.breakLoc = breakLoc;
        this.continueLoc = continueLoc;
        this.label = label;
      }
      (0, _util.inherits)(LoopEntry, Entry2);
      leap.LoopEntry = LoopEntry;
      function SwitchEntry(breakLoc) {
        Entry2.call(this);
        (0, _util2.getTypes)().assertLiteral(breakLoc);
        this.breakLoc = breakLoc;
      }
      (0, _util.inherits)(SwitchEntry, Entry2);
      leap.SwitchEntry = SwitchEntry;
      function TryEntry(firstLoc, catchEntry, finallyEntry) {
        Entry2.call(this);
        var t3 = (0, _util2.getTypes)();
        t3.assertLiteral(firstLoc);
        if (catchEntry) {
          _assert2["default"].ok(catchEntry instanceof CatchEntry);
        } else {
          catchEntry = null;
        }
        if (finallyEntry) {
          _assert2["default"].ok(finallyEntry instanceof FinallyEntry);
        } else {
          finallyEntry = null;
        }
        _assert2["default"].ok(catchEntry || finallyEntry);
        this.firstLoc = firstLoc;
        this.catchEntry = catchEntry;
        this.finallyEntry = finallyEntry;
      }
      (0, _util.inherits)(TryEntry, Entry2);
      leap.TryEntry = TryEntry;
      function CatchEntry(firstLoc, paramId) {
        Entry2.call(this);
        var t3 = (0, _util2.getTypes)();
        t3.assertLiteral(firstLoc);
        t3.assertIdentifier(paramId);
        this.firstLoc = firstLoc;
        this.paramId = paramId;
      }
      (0, _util.inherits)(CatchEntry, Entry2);
      leap.CatchEntry = CatchEntry;
      function FinallyEntry(firstLoc, afterLoc) {
        Entry2.call(this);
        var t3 = (0, _util2.getTypes)();
        t3.assertLiteral(firstLoc);
        t3.assertLiteral(afterLoc);
        this.firstLoc = firstLoc;
        this.afterLoc = afterLoc;
      }
      (0, _util.inherits)(FinallyEntry, Entry2);
      leap.FinallyEntry = FinallyEntry;
      function LabeledEntry(breakLoc, label) {
        Entry2.call(this);
        var t3 = (0, _util2.getTypes)();
        t3.assertLiteral(breakLoc);
        t3.assertIdentifier(label);
        this.breakLoc = breakLoc;
        this.label = label;
      }
      (0, _util.inherits)(LabeledEntry, Entry2);
      leap.LabeledEntry = LabeledEntry;
      function LeapManager(emitter) {
        _assert2["default"].ok(this instanceof LeapManager);
        _assert2["default"].ok(emitter instanceof _emit2.Emitter);
        this.emitter = emitter;
        this.entryStack = [new FunctionEntry(emitter.finalLoc)];
      }
      var LMp = LeapManager.prototype;
      leap.LeapManager = LeapManager;
      LMp.withEntry = function(entry2, callback) {
        _assert2["default"].ok(entry2 instanceof Entry2);
        this.entryStack.push(entry2);
        try {
          callback.call(this.emitter);
        } finally {
          var popped = this.entryStack.pop();
          _assert2["default"].strictEqual(popped, entry2);
        }
      };
      LMp._findLeapLocation = function(property2, label) {
        for (var i2 = this.entryStack.length - 1; i2 >= 0; --i2) {
          var entry2 = this.entryStack[i2];
          var loc = entry2[property2];
          if (loc) {
            if (label) {
              if (entry2.label && entry2.label.name === label.name) {
                return loc;
              }
            } else if (entry2 instanceof LabeledEntry)
              ;
            else {
              return loc;
            }
          }
        }
        return null;
      };
      LMp.getBreakLoc = function(label) {
        return this._findLeapLocation("breakLoc", label);
      };
      LMp.getContinueLoc = function(label) {
        return this._findLeapLocation("continueLoc", label);
      };
      return leap;
    }
    var meta = {};
    var hasRequiredMeta;
    function requireMeta() {
      if (hasRequiredMeta)
        return meta;
      hasRequiredMeta = 1;
      var _interopRequireDefault2 = interopRequireDefault.exports;
      var _assert2 = _interopRequireDefault2(assert$1.exports);
      var _util = requireUtil();
      var mMap = /* @__PURE__ */ new WeakMap();
      function m2(node2) {
        if (!mMap.has(node2)) {
          mMap.set(node2, {});
        }
        return mMap.get(node2);
      }
      var hasOwn3 = Object.prototype.hasOwnProperty;
      function makePredicate(propertyName, knownTypes) {
        function onlyChildren(node2) {
          var t3 = (0, _util.getTypes)();
          t3.assertNode(node2);
          var result = false;
          function check(child2) {
            if (result)
              ;
            else if (Array.isArray(child2)) {
              child2.some(check);
            } else if (t3.isNode(child2)) {
              _assert2["default"].strictEqual(result, false);
              result = predicate(child2);
            }
            return result;
          }
          var keys2 = t3.VISITOR_KEYS[node2.type];
          if (keys2) {
            for (var i2 = 0; i2 < keys2.length; i2++) {
              var key2 = keys2[i2];
              var child = node2[key2];
              check(child);
            }
          }
          return result;
        }
        function predicate(node2) {
          (0, _util.getTypes)().assertNode(node2);
          var meta2 = m2(node2);
          if (hasOwn3.call(meta2, propertyName))
            return meta2[propertyName];
          if (hasOwn3.call(opaqueTypes, node2.type))
            return meta2[propertyName] = false;
          if (hasOwn3.call(knownTypes, node2.type))
            return meta2[propertyName] = true;
          return meta2[propertyName] = onlyChildren(node2);
        }
        predicate.onlyChildren = onlyChildren;
        return predicate;
      }
      var opaqueTypes = {
        FunctionExpression: true,
        ArrowFunctionExpression: true
      };
      var sideEffectTypes = {
        CallExpression: true,
        ForInStatement: true,
        UnaryExpression: true,
        BinaryExpression: true,
        AssignmentExpression: true,
        UpdateExpression: true,
        NewExpression: true
      };
      var leapTypes = {
        YieldExpression: true,
        BreakStatement: true,
        ContinueStatement: true,
        ReturnStatement: true,
        ThrowStatement: true
      };
      for (var type5 in leapTypes) {
        if (hasOwn3.call(leapTypes, type5)) {
          sideEffectTypes[type5] = leapTypes[type5];
        }
      }
      meta.hasSideEffects = makePredicate("hasSideEffects", sideEffectTypes);
      meta.containsLeap = makePredicate("containsLeap", leapTypes);
      return meta;
    }
    var hasRequiredEmit;
    function requireEmit() {
      if (hasRequiredEmit)
        return emit;
      hasRequiredEmit = 1;
      var _interopRequireDefault2 = interopRequireDefault.exports;
      var _assert2 = _interopRequireDefault2(assert$1.exports);
      var leap2 = _interopRequireWildcard2(requireLeap());
      var meta2 = _interopRequireWildcard2(requireMeta());
      var util3 = _interopRequireWildcard2(requireUtil());
      function _getRequireWildcardCache2(nodeInterop) {
        if (typeof WeakMap !== "function")
          return null;
        var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
        var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
        return (_getRequireWildcardCache2 = function _getRequireWildcardCache3(nodeInterop2) {
          return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
        })(nodeInterop);
      }
      function _interopRequireWildcard2(obj, nodeInterop) {
        if (!nodeInterop && obj && obj.__esModule) {
          return obj;
        }
        if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
          return {
            "default": obj
          };
        }
        var cache2 = _getRequireWildcardCache2(nodeInterop);
        if (cache2 && cache2.has(obj)) {
          return cache2.get(obj);
        }
        var newObj = {};
        var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var key2 in obj) {
          if (key2 !== "default" && Object.prototype.hasOwnProperty.call(obj, key2)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key2) : null;
            if (desc && (desc.get || desc.set)) {
              Object.defineProperty(newObj, key2, desc);
            } else {
              newObj[key2] = obj[key2];
            }
          }
        }
        newObj["default"] = obj;
        if (cache2) {
          cache2.set(obj, newObj);
        }
        return newObj;
      }
      var hasOwn3 = Object.prototype.hasOwnProperty;
      function Emitter(contextId) {
        _assert2["default"].ok(this instanceof Emitter);
        util3.getTypes().assertIdentifier(contextId);
        this.nextTempId = 0;
        this.contextId = contextId;
        this.listing = [];
        this.marked = [true];
        this.insertedLocs = /* @__PURE__ */ new Set();
        this.finalLoc = this.loc();
        this.tryEntries = [];
        this.leapManager = new leap2.LeapManager(this);
      }
      var Ep = Emitter.prototype;
      emit.Emitter = Emitter;
      Ep.loc = function() {
        var l2 = util3.getTypes().numericLiteral(-1);
        this.insertedLocs.add(l2);
        return l2;
      };
      Ep.getInsertedLocs = function() {
        return this.insertedLocs;
      };
      Ep.getContextId = function() {
        return util3.getTypes().clone(this.contextId);
      };
      Ep.mark = function(loc) {
        util3.getTypes().assertLiteral(loc);
        var index3 = this.listing.length;
        if (loc.value === -1) {
          loc.value = index3;
        } else {
          _assert2["default"].strictEqual(loc.value, index3);
        }
        this.marked[index3] = true;
        return loc;
      };
      Ep.emit = function(node2) {
        var t3 = util3.getTypes();
        if (t3.isExpression(node2)) {
          node2 = t3.expressionStatement(node2);
        }
        t3.assertStatement(node2);
        this.listing.push(node2);
      };
      Ep.emitAssign = function(lhs, rhs) {
        this.emit(this.assign(lhs, rhs));
        return lhs;
      };
      Ep.assign = function(lhs, rhs) {
        var t3 = util3.getTypes();
        return t3.expressionStatement(t3.assignmentExpression("=", t3.cloneDeep(lhs), rhs));
      };
      Ep.contextProperty = function(name2, computed) {
        var t3 = util3.getTypes();
        return t3.memberExpression(this.getContextId(), computed ? t3.stringLiteral(name2) : t3.identifier(name2), !!computed);
      };
      Ep.stop = function(rval) {
        if (rval) {
          this.setReturnValue(rval);
        }
        this.jump(this.finalLoc);
      };
      Ep.setReturnValue = function(valuePath) {
        util3.getTypes().assertExpression(valuePath.value);
        this.emitAssign(this.contextProperty("rval"), this.explodeExpression(valuePath));
      };
      Ep.clearPendingException = function(tryLoc, assignee) {
        var t3 = util3.getTypes();
        t3.assertLiteral(tryLoc);
        var catchCall = t3.callExpression(this.contextProperty("catch", true), [t3.clone(tryLoc)]);
        if (assignee) {
          this.emitAssign(assignee, catchCall);
        } else {
          this.emit(catchCall);
        }
      };
      Ep.jump = function(toLoc) {
        this.emitAssign(this.contextProperty("next"), toLoc);
        this.emit(util3.getTypes().breakStatement());
      };
      Ep.jumpIf = function(test, toLoc) {
        var t3 = util3.getTypes();
        t3.assertExpression(test);
        t3.assertLiteral(toLoc);
        this.emit(t3.ifStatement(test, t3.blockStatement([this.assign(this.contextProperty("next"), toLoc), t3.breakStatement()])));
      };
      Ep.jumpIfNot = function(test, toLoc) {
        var t3 = util3.getTypes();
        t3.assertExpression(test);
        t3.assertLiteral(toLoc);
        var negatedTest;
        if (t3.isUnaryExpression(test) && test.operator === "!") {
          negatedTest = test.argument;
        } else {
          negatedTest = t3.unaryExpression("!", test);
        }
        this.emit(t3.ifStatement(negatedTest, t3.blockStatement([this.assign(this.contextProperty("next"), toLoc), t3.breakStatement()])));
      };
      Ep.makeTempVar = function() {
        return this.contextProperty("t" + this.nextTempId++);
      };
      Ep.getContextFunction = function(id3) {
        var t3 = util3.getTypes();
        return t3.functionExpression(id3 || null, [this.getContextId()], t3.blockStatement([this.getDispatchLoop()]), false, false);
      };
      Ep.getDispatchLoop = function() {
        var self2 = this;
        var t3 = util3.getTypes();
        var cases = [];
        var current2;
        var alreadyEnded = false;
        self2.listing.forEach(function(stmt, i2) {
          if (self2.marked.hasOwnProperty(i2)) {
            cases.push(t3.switchCase(t3.numericLiteral(i2), current2 = []));
            alreadyEnded = false;
          }
          if (!alreadyEnded) {
            current2.push(stmt);
            if (t3.isCompletionStatement(stmt))
              alreadyEnded = true;
          }
        });
        this.finalLoc.value = this.listing.length;
        cases.push(t3.switchCase(this.finalLoc, []), t3.switchCase(t3.stringLiteral("end"), [t3.returnStatement(t3.callExpression(this.contextProperty("stop"), []))]));
        return t3.whileStatement(t3.numericLiteral(1), t3.switchStatement(t3.assignmentExpression("=", this.contextProperty("prev"), this.contextProperty("next")), cases));
      };
      Ep.getTryLocsList = function() {
        if (this.tryEntries.length === 0) {
          return null;
        }
        var t3 = util3.getTypes();
        var lastLocValue = 0;
        return t3.arrayExpression(this.tryEntries.map(function(tryEntry) {
          var thisLocValue = tryEntry.firstLoc.value;
          _assert2["default"].ok(thisLocValue >= lastLocValue, "try entries out of order");
          lastLocValue = thisLocValue;
          var ce2 = tryEntry.catchEntry;
          var fe2 = tryEntry.finallyEntry;
          var locs = [tryEntry.firstLoc, ce2 ? ce2.firstLoc : null];
          if (fe2) {
            locs[2] = fe2.firstLoc;
            locs[3] = fe2.afterLoc;
          }
          return t3.arrayExpression(locs.map(function(loc) {
            return loc && t3.clone(loc);
          }));
        }));
      };
      Ep.explode = function(path2, ignoreResult) {
        var t3 = util3.getTypes();
        var node2 = path2.node;
        var self2 = this;
        t3.assertNode(node2);
        if (t3.isDeclaration(node2))
          throw getDeclError(node2);
        if (t3.isStatement(node2))
          return self2.explodeStatement(path2);
        if (t3.isExpression(node2))
          return self2.explodeExpression(path2, ignoreResult);
        switch (node2.type) {
          case "Program":
            return path2.get("body").map(self2.explodeStatement, self2);
          case "VariableDeclarator":
            throw getDeclError(node2);
          case "Property":
          case "SwitchCase":
          case "CatchClause":
            throw new Error(node2.type + " nodes should be handled by their parents");
          default:
            throw new Error("unknown Node of type " + JSON.stringify(node2.type));
        }
      };
      function getDeclError(node2) {
        return new Error("all declarations should have been transformed into assignments before the Exploder began its work: " + JSON.stringify(node2));
      }
      Ep.explodeStatement = function(path2, labelId) {
        var t3 = util3.getTypes();
        var stmt = path2.node;
        var self2 = this;
        var before, after, head;
        t3.assertStatement(stmt);
        if (labelId) {
          t3.assertIdentifier(labelId);
        } else {
          labelId = null;
        }
        if (t3.isBlockStatement(stmt)) {
          path2.get("body").forEach(function(path3) {
            self2.explodeStatement(path3);
          });
          return;
        }
        if (!meta2.containsLeap(stmt)) {
          self2.emit(stmt);
          return;
        }
        switch (stmt.type) {
          case "ExpressionStatement":
            self2.explodeExpression(path2.get("expression"), true);
            break;
          case "LabeledStatement":
            after = this.loc();
            self2.leapManager.withEntry(new leap2.LabeledEntry(after, stmt.label), function() {
              self2.explodeStatement(path2.get("body"), stmt.label);
            });
            self2.mark(after);
            break;
          case "WhileStatement":
            before = this.loc();
            after = this.loc();
            self2.mark(before);
            self2.jumpIfNot(self2.explodeExpression(path2.get("test")), after);
            self2.leapManager.withEntry(new leap2.LoopEntry(after, before, labelId), function() {
              self2.explodeStatement(path2.get("body"));
            });
            self2.jump(before);
            self2.mark(after);
            break;
          case "DoWhileStatement":
            var first = this.loc();
            var test = this.loc();
            after = this.loc();
            self2.mark(first);
            self2.leapManager.withEntry(new leap2.LoopEntry(after, test, labelId), function() {
              self2.explode(path2.get("body"));
            });
            self2.mark(test);
            self2.jumpIf(self2.explodeExpression(path2.get("test")), first);
            self2.mark(after);
            break;
          case "ForStatement":
            head = this.loc();
            var update2 = this.loc();
            after = this.loc();
            if (stmt.init) {
              self2.explode(path2.get("init"), true);
            }
            self2.mark(head);
            if (stmt.test) {
              self2.jumpIfNot(self2.explodeExpression(path2.get("test")), after);
            }
            self2.leapManager.withEntry(new leap2.LoopEntry(after, update2, labelId), function() {
              self2.explodeStatement(path2.get("body"));
            });
            self2.mark(update2);
            if (stmt.update) {
              self2.explode(path2.get("update"), true);
            }
            self2.jump(head);
            self2.mark(after);
            break;
          case "TypeCastExpression":
            return self2.explodeExpression(path2.get("expression"));
          case "ForInStatement":
            head = this.loc();
            after = this.loc();
            var keyIterNextFn = self2.makeTempVar();
            self2.emitAssign(keyIterNextFn, t3.callExpression(util3.runtimeProperty("keys"), [self2.explodeExpression(path2.get("right"))]));
            self2.mark(head);
            var keyInfoTmpVar = self2.makeTempVar();
            self2.jumpIf(t3.memberExpression(t3.assignmentExpression("=", keyInfoTmpVar, t3.callExpression(t3.cloneDeep(keyIterNextFn), [])), t3.identifier("done"), false), after);
            self2.emitAssign(stmt.left, t3.memberExpression(t3.cloneDeep(keyInfoTmpVar), t3.identifier("value"), false));
            self2.leapManager.withEntry(new leap2.LoopEntry(after, head, labelId), function() {
              self2.explodeStatement(path2.get("body"));
            });
            self2.jump(head);
            self2.mark(after);
            break;
          case "BreakStatement":
            self2.emitAbruptCompletion({
              type: "break",
              target: self2.leapManager.getBreakLoc(stmt.label)
            });
            break;
          case "ContinueStatement":
            self2.emitAbruptCompletion({
              type: "continue",
              target: self2.leapManager.getContinueLoc(stmt.label)
            });
            break;
          case "SwitchStatement":
            var disc = self2.emitAssign(self2.makeTempVar(), self2.explodeExpression(path2.get("discriminant")));
            after = this.loc();
            var defaultLoc = this.loc();
            var condition = defaultLoc;
            var caseLocs = [];
            var cases = stmt.cases || [];
            for (var i2 = cases.length - 1; i2 >= 0; --i2) {
              var c2 = cases[i2];
              t3.assertSwitchCase(c2);
              if (c2.test) {
                condition = t3.conditionalExpression(t3.binaryExpression("===", t3.cloneDeep(disc), c2.test), caseLocs[i2] = this.loc(), condition);
              } else {
                caseLocs[i2] = defaultLoc;
              }
            }
            var discriminant = path2.get("discriminant");
            util3.replaceWithOrRemove(discriminant, condition);
            self2.jump(self2.explodeExpression(discriminant));
            self2.leapManager.withEntry(new leap2.SwitchEntry(after), function() {
              path2.get("cases").forEach(function(casePath) {
                var i3 = casePath.key;
                self2.mark(caseLocs[i3]);
                casePath.get("consequent").forEach(function(path3) {
                  self2.explodeStatement(path3);
                });
              });
            });
            self2.mark(after);
            if (defaultLoc.value === -1) {
              self2.mark(defaultLoc);
              _assert2["default"].strictEqual(after.value, defaultLoc.value);
            }
            break;
          case "IfStatement":
            var elseLoc = stmt.alternate && this.loc();
            after = this.loc();
            self2.jumpIfNot(self2.explodeExpression(path2.get("test")), elseLoc || after);
            self2.explodeStatement(path2.get("consequent"));
            if (elseLoc) {
              self2.jump(after);
              self2.mark(elseLoc);
              self2.explodeStatement(path2.get("alternate"));
            }
            self2.mark(after);
            break;
          case "ReturnStatement":
            self2.emitAbruptCompletion({
              type: "return",
              value: self2.explodeExpression(path2.get("argument"))
            });
            break;
          case "WithStatement":
            throw new Error("WithStatement not supported in generator functions.");
          case "TryStatement":
            after = this.loc();
            var handler = stmt.handler;
            var catchLoc = handler && this.loc();
            var catchEntry = catchLoc && new leap2.CatchEntry(catchLoc, handler.param);
            var finallyLoc = stmt.finalizer && this.loc();
            var finallyEntry = finallyLoc && new leap2.FinallyEntry(finallyLoc, after);
            var tryEntry = new leap2.TryEntry(self2.getUnmarkedCurrentLoc(), catchEntry, finallyEntry);
            self2.tryEntries.push(tryEntry);
            self2.updateContextPrevLoc(tryEntry.firstLoc);
            self2.leapManager.withEntry(tryEntry, function() {
              self2.explodeStatement(path2.get("block"));
              if (catchLoc) {
                if (finallyLoc) {
                  self2.jump(finallyLoc);
                } else {
                  self2.jump(after);
                }
                self2.updateContextPrevLoc(self2.mark(catchLoc));
                var bodyPath = path2.get("handler.body");
                var safeParam = self2.makeTempVar();
                self2.clearPendingException(tryEntry.firstLoc, safeParam);
                bodyPath.traverse(catchParamVisitor, {
                  getSafeParam: function getSafeParam() {
                    return t3.cloneDeep(safeParam);
                  },
                  catchParamName: handler.param.name
                });
                self2.leapManager.withEntry(catchEntry, function() {
                  self2.explodeStatement(bodyPath);
                });
              }
              if (finallyLoc) {
                self2.updateContextPrevLoc(self2.mark(finallyLoc));
                self2.leapManager.withEntry(finallyEntry, function() {
                  self2.explodeStatement(path2.get("finalizer"));
                });
                self2.emit(t3.returnStatement(t3.callExpression(self2.contextProperty("finish"), [finallyEntry.firstLoc])));
              }
            });
            self2.mark(after);
            break;
          case "ThrowStatement":
            self2.emit(t3.throwStatement(self2.explodeExpression(path2.get("argument"))));
            break;
          case "ClassDeclaration":
            self2.emit(self2.explodeClass(path2));
            break;
          default:
            throw new Error("unknown Statement of type " + JSON.stringify(stmt.type));
        }
      };
      var catchParamVisitor = {
        Identifier: function Identifier2(path2, state) {
          if (path2.node.name === state.catchParamName && util3.isReference(path2)) {
            util3.replaceWithOrRemove(path2, state.getSafeParam());
          }
        },
        Scope: function Scope4(path2, state) {
          if (path2.scope.hasOwnBinding(state.catchParamName)) {
            path2.skip();
          }
        }
      };
      Ep.emitAbruptCompletion = function(record) {
        if (!isValidCompletion(record)) {
          _assert2["default"].ok(false, "invalid completion record: " + JSON.stringify(record));
        }
        _assert2["default"].notStrictEqual(record.type, "normal", "normal completions are not abrupt");
        var t3 = util3.getTypes();
        var abruptArgs = [t3.stringLiteral(record.type)];
        if (record.type === "break" || record.type === "continue") {
          t3.assertLiteral(record.target);
          abruptArgs[1] = this.insertedLocs.has(record.target) ? record.target : t3.cloneDeep(record.target);
        } else if (record.type === "return" || record.type === "throw") {
          if (record.value) {
            t3.assertExpression(record.value);
            abruptArgs[1] = this.insertedLocs.has(record.value) ? record.value : t3.cloneDeep(record.value);
          }
        }
        this.emit(t3.returnStatement(t3.callExpression(this.contextProperty("abrupt"), abruptArgs)));
      };
      function isValidCompletion(record) {
        var type5 = record.type;
        if (type5 === "normal") {
          return !hasOwn3.call(record, "target");
        }
        if (type5 === "break" || type5 === "continue") {
          return !hasOwn3.call(record, "value") && util3.getTypes().isLiteral(record.target);
        }
        if (type5 === "return" || type5 === "throw") {
          return hasOwn3.call(record, "value") && !hasOwn3.call(record, "target");
        }
        return false;
      }
      Ep.getUnmarkedCurrentLoc = function() {
        return util3.getTypes().numericLiteral(this.listing.length);
      };
      Ep.updateContextPrevLoc = function(loc) {
        var t3 = util3.getTypes();
        if (loc) {
          t3.assertLiteral(loc);
          if (loc.value === -1) {
            loc.value = this.listing.length;
          } else {
            _assert2["default"].strictEqual(loc.value, this.listing.length);
          }
        } else {
          loc = this.getUnmarkedCurrentLoc();
        }
        this.emitAssign(this.contextProperty("prev"), loc);
      };
      Ep.explodeViaTempVar = function(tempVar, childPath, hasLeapingChildren, ignoreChildResult) {
        _assert2["default"].ok(!ignoreChildResult || !tempVar, "Ignoring the result of a child expression but forcing it to be assigned to a temporary variable?");
        var t3 = util3.getTypes();
        var result = this.explodeExpression(childPath, ignoreChildResult);
        if (ignoreChildResult)
          ;
        else if (tempVar || hasLeapingChildren && !t3.isLiteral(result)) {
          result = this.emitAssign(tempVar || this.makeTempVar(), result);
        }
        return result;
      };
      Ep.explodeExpression = function(path2, ignoreResult) {
        var t3 = util3.getTypes();
        var expr = path2.node;
        if (expr) {
          t3.assertExpression(expr);
        } else {
          return expr;
        }
        var self2 = this;
        var result;
        var after;
        function finish(expr2) {
          t3.assertExpression(expr2);
          if (ignoreResult) {
            self2.emit(expr2);
          }
          return expr2;
        }
        if (!meta2.containsLeap(expr)) {
          return finish(expr);
        }
        var hasLeapingChildren = meta2.containsLeap.onlyChildren(expr);
        switch (expr.type) {
          case "MemberExpression":
            return finish(t3.memberExpression(self2.explodeExpression(path2.get("object")), expr.computed ? self2.explodeViaTempVar(null, path2.get("property"), hasLeapingChildren) : expr.property, expr.computed));
          case "CallExpression":
            var calleePath = path2.get("callee");
            var argsPath = path2.get("arguments");
            var newCallee;
            var newArgs;
            var hasLeapingArgs = argsPath.some(function(argPath) {
              return meta2.containsLeap(argPath.node);
            });
            var injectFirstArg = null;
            if (t3.isMemberExpression(calleePath.node)) {
              if (hasLeapingArgs) {
                var newObject = self2.explodeViaTempVar(self2.makeTempVar(), calleePath.get("object"), hasLeapingChildren);
                var newProperty = calleePath.node.computed ? self2.explodeViaTempVar(null, calleePath.get("property"), hasLeapingChildren) : calleePath.node.property;
                injectFirstArg = newObject;
                newCallee = t3.memberExpression(t3.memberExpression(t3.cloneDeep(newObject), newProperty, calleePath.node.computed), t3.identifier("call"), false);
              } else {
                newCallee = self2.explodeExpression(calleePath);
              }
            } else {
              newCallee = self2.explodeViaTempVar(null, calleePath, hasLeapingChildren);
              if (t3.isMemberExpression(newCallee)) {
                newCallee = t3.sequenceExpression([t3.numericLiteral(0), t3.cloneDeep(newCallee)]);
              }
            }
            if (hasLeapingArgs) {
              newArgs = argsPath.map(function(argPath) {
                return self2.explodeViaTempVar(null, argPath, hasLeapingChildren);
              });
              if (injectFirstArg)
                newArgs.unshift(injectFirstArg);
              newArgs = newArgs.map(function(arg2) {
                return t3.cloneDeep(arg2);
              });
            } else {
              newArgs = path2.node.arguments;
            }
            return finish(t3.callExpression(newCallee, newArgs));
          case "NewExpression":
            return finish(t3.newExpression(self2.explodeViaTempVar(null, path2.get("callee"), hasLeapingChildren), path2.get("arguments").map(function(argPath) {
              return self2.explodeViaTempVar(null, argPath, hasLeapingChildren);
            })));
          case "ObjectExpression":
            return finish(t3.objectExpression(path2.get("properties").map(function(propPath) {
              if (propPath.isObjectProperty()) {
                return t3.objectProperty(propPath.node.key, self2.explodeViaTempVar(null, propPath.get("value"), hasLeapingChildren), propPath.node.computed);
              } else {
                return propPath.node;
              }
            })));
          case "ArrayExpression":
            return finish(t3.arrayExpression(path2.get("elements").map(function(elemPath) {
              if (elemPath.isSpreadElement()) {
                return t3.spreadElement(self2.explodeViaTempVar(null, elemPath.get("argument"), hasLeapingChildren));
              } else {
                return self2.explodeViaTempVar(null, elemPath, hasLeapingChildren);
              }
            })));
          case "SequenceExpression":
            var lastIndex = expr.expressions.length - 1;
            path2.get("expressions").forEach(function(exprPath) {
              if (exprPath.key === lastIndex) {
                result = self2.explodeExpression(exprPath, ignoreResult);
              } else {
                self2.explodeExpression(exprPath, true);
              }
            });
            return result;
          case "LogicalExpression":
            after = this.loc();
            if (!ignoreResult) {
              result = self2.makeTempVar();
            }
            var left = self2.explodeViaTempVar(result, path2.get("left"), hasLeapingChildren);
            if (expr.operator === "&&") {
              self2.jumpIfNot(left, after);
            } else {
              _assert2["default"].strictEqual(expr.operator, "||");
              self2.jumpIf(left, after);
            }
            self2.explodeViaTempVar(result, path2.get("right"), hasLeapingChildren, ignoreResult);
            self2.mark(after);
            return result;
          case "ConditionalExpression":
            var elseLoc = this.loc();
            after = this.loc();
            var test = self2.explodeExpression(path2.get("test"));
            self2.jumpIfNot(test, elseLoc);
            if (!ignoreResult) {
              result = self2.makeTempVar();
            }
            self2.explodeViaTempVar(result, path2.get("consequent"), hasLeapingChildren, ignoreResult);
            self2.jump(after);
            self2.mark(elseLoc);
            self2.explodeViaTempVar(result, path2.get("alternate"), hasLeapingChildren, ignoreResult);
            self2.mark(after);
            return result;
          case "UnaryExpression":
            return finish(t3.unaryExpression(expr.operator, self2.explodeExpression(path2.get("argument")), !!expr.prefix));
          case "BinaryExpression":
            return finish(t3.binaryExpression(expr.operator, self2.explodeViaTempVar(null, path2.get("left"), hasLeapingChildren), self2.explodeViaTempVar(null, path2.get("right"), hasLeapingChildren)));
          case "AssignmentExpression":
            if (expr.operator === "=") {
              return finish(t3.assignmentExpression(expr.operator, self2.explodeExpression(path2.get("left")), self2.explodeExpression(path2.get("right"))));
            }
            var lhs = self2.explodeExpression(path2.get("left"));
            var temp = self2.emitAssign(self2.makeTempVar(), lhs);
            return finish(t3.assignmentExpression("=", t3.cloneDeep(lhs), t3.assignmentExpression(expr.operator, t3.cloneDeep(temp), self2.explodeExpression(path2.get("right")))));
          case "UpdateExpression":
            return finish(t3.updateExpression(expr.operator, self2.explodeExpression(path2.get("argument")), expr.prefix));
          case "YieldExpression":
            after = this.loc();
            var arg = expr.argument && self2.explodeExpression(path2.get("argument"));
            if (arg && expr.delegate) {
              var _result = self2.makeTempVar();
              var _ret2 = t3.returnStatement(t3.callExpression(self2.contextProperty("delegateYield"), [arg, t3.stringLiteral(_result.property.name), after]));
              _ret2.loc = expr.loc;
              self2.emit(_ret2);
              self2.mark(after);
              return _result;
            }
            self2.emitAssign(self2.contextProperty("next"), after);
            var ret = t3.returnStatement(t3.cloneDeep(arg) || null);
            ret.loc = expr.loc;
            self2.emit(ret);
            self2.mark(after);
            return self2.contextProperty("sent");
          case "ClassExpression":
            return finish(self2.explodeClass(path2));
          default:
            throw new Error("unknown Expression of type " + JSON.stringify(expr.type));
        }
      };
      Ep.explodeClass = function(path2) {
        var explodingChildren = [];
        if (path2.node.superClass) {
          explodingChildren.push(path2.get("superClass"));
        }
        path2.get("body.body").forEach(function(member) {
          if (member.node.computed) {
            explodingChildren.push(member.get("key"));
          }
        });
        var hasLeapingChildren = explodingChildren.some(function(child2) {
          return meta2.containsLeap(child2);
        });
        for (var i2 = 0; i2 < explodingChildren.length; i2++) {
          var child = explodingChildren[i2];
          var isLast = i2 === explodingChildren.length - 1;
          if (isLast) {
            child.replaceWith(this.explodeExpression(child));
          } else {
            child.replaceWith(this.explodeViaTempVar(null, child, hasLeapingChildren));
          }
        }
        return path2.node;
      };
      return emit;
    }
    var replaceShorthandObjectMethod = {};
    var hasRequiredReplaceShorthandObjectMethod;
    function requireReplaceShorthandObjectMethod() {
      if (hasRequiredReplaceShorthandObjectMethod)
        return replaceShorthandObjectMethod;
      hasRequiredReplaceShorthandObjectMethod = 1;
      (function(exports3) {
        exports3.__esModule = true;
        exports3["default"] = replaceShorthandObjectMethod2;
        var util3 = _interopRequireWildcard2(requireUtil());
        function _getRequireWildcardCache2(nodeInterop) {
          if (typeof WeakMap !== "function")
            return null;
          var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
          var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
          return (_getRequireWildcardCache2 = function _getRequireWildcardCache3(nodeInterop2) {
            return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
          })(nodeInterop);
        }
        function _interopRequireWildcard2(obj, nodeInterop) {
          if (!nodeInterop && obj && obj.__esModule) {
            return obj;
          }
          if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
            return {
              "default": obj
            };
          }
          var cache2 = _getRequireWildcardCache2(nodeInterop);
          if (cache2 && cache2.has(obj)) {
            return cache2.get(obj);
          }
          var newObj = {};
          var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
          for (var key2 in obj) {
            if (key2 !== "default" && Object.prototype.hasOwnProperty.call(obj, key2)) {
              var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key2) : null;
              if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key2, desc);
              } else {
                newObj[key2] = obj[key2];
              }
            }
          }
          newObj["default"] = obj;
          if (cache2) {
            cache2.set(obj, newObj);
          }
          return newObj;
        }
        function replaceShorthandObjectMethod2(path2) {
          var t3 = util3.getTypes();
          if (!path2.node || !t3.isFunction(path2.node)) {
            throw new Error("replaceShorthandObjectMethod can only be called on Function AST node paths.");
          }
          if (!t3.isObjectMethod(path2.node)) {
            return path2;
          }
          if (!path2.node.generator) {
            return path2;
          }
          var parameters = path2.node.params.map(function(param) {
            return t3.cloneDeep(param);
          });
          var functionExpression2 = t3.functionExpression(null, parameters, t3.cloneDeep(path2.node.body), path2.node.generator, path2.node.async);
          util3.replaceWithOrRemove(path2, t3.objectProperty(t3.cloneDeep(path2.node.key), functionExpression2, path2.node.computed, false));
          return path2.get("value");
        }
      })(replaceShorthandObjectMethod);
      return replaceShorthandObjectMethod;
    }
    var _interopRequireDefault = interopRequireDefault.exports;
    var _assert = _interopRequireDefault(assert$1.exports);
    var _hoist = requireHoist();
    var _emit = requireEmit();
    var _replaceShorthandObjectMethod = _interopRequireDefault(requireReplaceShorthandObjectMethod());
    var util2 = _interopRequireWildcard(requireUtil());
    function _getRequireWildcardCache(nodeInterop) {
      if (typeof WeakMap !== "function")
        return null;
      var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
      var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
      return (_getRequireWildcardCache = function _getRequireWildcardCache2(nodeInterop2) {
        return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
      })(nodeInterop);
    }
    function _interopRequireWildcard(obj, nodeInterop) {
      if (!nodeInterop && obj && obj.__esModule) {
        return obj;
      }
      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
          "default": obj
        };
      }
      var cache2 = _getRequireWildcardCache(nodeInterop);
      if (cache2 && cache2.has(obj)) {
        return cache2.get(obj);
      }
      var newObj = {};
      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
      for (var key2 in obj) {
        if (key2 !== "default" && Object.prototype.hasOwnProperty.call(obj, key2)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key2) : null;
          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key2, desc);
          } else {
            newObj[key2] = obj[key2];
          }
        }
      }
      newObj["default"] = obj;
      if (cache2) {
        cache2.set(obj, newObj);
      }
      return newObj;
    }
    visit.getVisitor = function(_ref3) {
      var t3 = _ref3.types;
      return {
        Method: function Method(path2, state) {
          var node2 = path2.node;
          if (!shouldRegenerate(node2, state))
            return;
          var container2 = t3.functionExpression(null, [], t3.cloneNode(node2.body, false), node2.generator, node2.async);
          path2.get("body").set("body", [t3.returnStatement(t3.callExpression(container2, []))]);
          node2.async = false;
          node2.generator = false;
          path2.get("body.body.0.argument.callee").unwrapFunctionEnvironment();
        },
        Function: {
          exit: util2.wrapWithTypes(t3, function(path2, state) {
            var node2 = path2.node;
            if (!shouldRegenerate(node2, state))
              return;
            path2 = (0, _replaceShorthandObjectMethod["default"])(path2);
            node2 = path2.node;
            var contextId = path2.scope.generateUidIdentifier("context");
            var argsId = path2.scope.generateUidIdentifier("args");
            path2.ensureBlock();
            var bodyBlockPath = path2.get("body");
            if (node2.async) {
              bodyBlockPath.traverse(awaitVisitor);
            }
            bodyBlockPath.traverse(functionSentVisitor, {
              context: contextId
            });
            var outerBody = [];
            var innerBody = [];
            bodyBlockPath.get("body").forEach(function(childPath) {
              var node3 = childPath.node;
              if (t3.isExpressionStatement(node3) && t3.isStringLiteral(node3.expression)) {
                outerBody.push(node3);
              } else if (node3 && node3._blockHoist != null) {
                outerBody.push(node3);
              } else {
                innerBody.push(node3);
              }
            });
            if (outerBody.length > 0) {
              bodyBlockPath.node.body = innerBody;
            }
            var outerFnExpr = getOuterFnExpr(path2);
            t3.assertIdentifier(node2.id);
            var innerFnId = t3.identifier(node2.id.name + "$");
            var vars = (0, _hoist.hoist)(path2);
            var context = {
              usesThis: false,
              usesArguments: false,
              getArgsId: function getArgsId() {
                return t3.clone(argsId);
              }
            };
            path2.traverse(argumentsThisVisitor, context);
            if (context.usesArguments) {
              vars = vars || t3.variableDeclaration("var", []);
              vars.declarations.push(t3.variableDeclarator(t3.clone(argsId), t3.identifier("arguments")));
            }
            var emitter = new _emit.Emitter(contextId);
            emitter.explode(path2.get("body"));
            if (vars && vars.declarations.length > 0) {
              outerBody.push(vars);
            }
            var wrapArgs = [emitter.getContextFunction(innerFnId)];
            var tryLocsList = emitter.getTryLocsList();
            if (node2.generator) {
              wrapArgs.push(outerFnExpr);
            } else if (context.usesThis || tryLocsList || node2.async) {
              wrapArgs.push(t3.nullLiteral());
            }
            if (context.usesThis) {
              wrapArgs.push(t3.thisExpression());
            } else if (tryLocsList || node2.async) {
              wrapArgs.push(t3.nullLiteral());
            }
            if (tryLocsList) {
              wrapArgs.push(tryLocsList);
            } else if (node2.async) {
              wrapArgs.push(t3.nullLiteral());
            }
            if (node2.async) {
              var currentScope = path2.scope;
              do {
                if (currentScope.hasOwnBinding("Promise"))
                  currentScope.rename("Promise");
              } while (currentScope = currentScope.parent);
              wrapArgs.push(t3.identifier("Promise"));
            }
            var wrapCall = t3.callExpression(util2.runtimeProperty(node2.async ? "async" : "wrap"), wrapArgs);
            outerBody.push(t3.returnStatement(wrapCall));
            node2.body = t3.blockStatement(outerBody);
            path2.get("body.body").forEach(function(p2) {
              return p2.scope.registerDeclaration(p2);
            });
            var oldDirectives = bodyBlockPath.node.directives;
            if (oldDirectives) {
              node2.body.directives = oldDirectives;
            }
            var wasGeneratorFunction = node2.generator;
            if (wasGeneratorFunction) {
              node2.generator = false;
            }
            if (node2.async) {
              node2.async = false;
            }
            if (wasGeneratorFunction && t3.isExpression(node2)) {
              util2.replaceWithOrRemove(path2, t3.callExpression(util2.runtimeProperty("mark"), [node2]));
              path2.addComment("leading", "#__PURE__");
            }
            var insertedLocs = emitter.getInsertedLocs();
            path2.traverse({
              NumericLiteral: function NumericLiteral2(path3) {
                if (!insertedLocs.has(path3.node)) {
                  return;
                }
                path3.replaceWith(t3.numericLiteral(path3.node.value));
              }
            });
            path2.requeue();
          })
        }
      };
    };
    function shouldRegenerate(node2, state) {
      if (node2.generator) {
        if (node2.async) {
          return state.opts.asyncGenerators !== false;
        } else {
          return state.opts.generators !== false;
        }
      } else if (node2.async) {
        return state.opts.async !== false;
      } else {
        return false;
      }
    }
    function getOuterFnExpr(funPath) {
      var t3 = util2.getTypes();
      var node2 = funPath.node;
      t3.assertFunction(node2);
      if (!node2.id) {
        node2.id = funPath.scope.parent.generateUidIdentifier("callee");
      }
      if (node2.generator && t3.isFunctionDeclaration(node2)) {
        return getMarkedFunctionId(funPath);
      }
      return t3.clone(node2.id);
    }
    var markInfo = /* @__PURE__ */ new WeakMap();
    function getMarkInfo(node2) {
      if (!markInfo.has(node2)) {
        markInfo.set(node2, {});
      }
      return markInfo.get(node2);
    }
    function getMarkedFunctionId(funPath) {
      var t3 = util2.getTypes();
      var node2 = funPath.node;
      t3.assertIdentifier(node2.id);
      var blockPath = funPath.findParent(function(path2) {
        return path2.isProgram() || path2.isBlockStatement();
      });
      if (!blockPath) {
        return node2.id;
      }
      var block = blockPath.node;
      _assert["default"].ok(Array.isArray(block.body));
      var info = getMarkInfo(block);
      if (!info.decl) {
        info.decl = t3.variableDeclaration("var", []);
        blockPath.unshiftContainer("body", info.decl);
        info.declPath = blockPath.get("body.0");
      }
      _assert["default"].strictEqual(info.declPath.node, info.decl);
      var markedId = blockPath.scope.generateUidIdentifier("marked");
      var markCallExp = t3.callExpression(util2.runtimeProperty("mark"), [t3.clone(node2.id)]);
      var index3 = info.decl.declarations.push(t3.variableDeclarator(markedId, markCallExp)) - 1;
      var markCallExpPath = info.declPath.get("declarations." + index3 + ".init");
      _assert["default"].strictEqual(markCallExpPath.node, markCallExp);
      markCallExpPath.addComment("leading", "#__PURE__");
      return t3.clone(markedId);
    }
    var argumentsThisVisitor = {
      "FunctionExpression|FunctionDeclaration|Method": function FunctionExpressionFunctionDeclarationMethod(path2) {
        path2.skip();
      },
      Identifier: function Identifier2(path2, state) {
        if (path2.node.name === "arguments" && util2.isReference(path2)) {
          util2.replaceWithOrRemove(path2, state.getArgsId());
          state.usesArguments = true;
        }
      },
      ThisExpression: function ThisExpression2(path2, state) {
        state.usesThis = true;
      }
    };
    var functionSentVisitor = {
      MetaProperty: function MetaProperty2(path2) {
        var node2 = path2.node;
        if (node2.meta.name === "function" && node2.property.name === "sent") {
          var t3 = util2.getTypes();
          util2.replaceWithOrRemove(path2, t3.memberExpression(t3.clone(this.context), t3.identifier("_sent")));
        }
      }
    };
    var awaitVisitor = {
      Function: function Function2(path2) {
        path2.skip();
      },
      AwaitExpression: function AwaitExpression2(path2) {
        var t3 = util2.getTypes();
        var argument = path2.node.argument;
        util2.replaceWithOrRemove(path2, t3.yieldExpression(t3.callExpression(util2.runtimeProperty("awrap"), [argument]), false));
      }
    };
    (function(exports3) {
      exports3.__esModule = true;
      exports3["default"] = _default3;
      var _visit = visit;
      function _default3(context) {
        var plugin2 = {
          visitor: (0, _visit.getVisitor)(context)
        };
        var version3 = context && context.version;
        if (version3 && parseInt(version3, 10) >= 7) {
          plugin2.name = "regenerator-transform";
        }
        return plugin2;
      }
    })(lib$e);
    var _transformRegenerator = lib$e["default"];
    var _transformReservedWords = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-reserved-words",
        visitor: {
          "BindingIdentifier|ReferencedIdentifier": function BindingIdentifierReferencedIdentifier(path2) {
            if (!isValidES3Identifier(path2.node.name)) {
              path2.scope.rename(path2.node.name);
            }
          }
        }
      };
    });
    var semver$8 = requireSemver();
    function hasMinVersion$2(minVersion2, runtimeVersion) {
      if (!runtimeVersion)
        return true;
      if (semver$8.valid(runtimeVersion))
        runtimeVersion = "^" + runtimeVersion;
      return !semver$8.intersects("<" + minVersion2, runtimeVersion) && !semver$8.intersects(">=8.0.0", runtimeVersion);
    }
    function getRuntimePath(moduleName, dirname2, absoluteRuntime) {
      if (absoluteRuntime === false)
        return moduleName;
      resolveFSPath();
    }
    function resolveFSPath() {
      throw new Error("The 'absoluteRuntime' option is not supported when using @babel/standalone.");
    }
    var semver$7 = { exports: {} };
    (function(module2, exports3) {
      exports3 = module2.exports = SemVer2;
      var debug2;
      if (typeof browser$1$1 === "object" && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
        debug2 = function debug3() {
          var args = Array.prototype.slice.call(arguments, 0);
          args.unshift("SEMVER");
          console.log.apply(console, args);
        };
      } else {
        debug2 = function debug3() {
        };
      }
      exports3.SEMVER_SPEC_VERSION = "2.0.0";
      var MAX_LENGTH2 = 256;
      var MAX_SAFE_INTEGER3 = Number.MAX_SAFE_INTEGER || 9007199254740991;
      var MAX_SAFE_COMPONENT_LENGTH2 = 16;
      var re3 = exports3.re = [];
      var src2 = exports3.src = [];
      var t3 = exports3.tokens = {};
      var R2 = 0;
      function tok(n2) {
        t3[n2] = R2++;
      }
      tok("NUMERICIDENTIFIER");
      src2[t3.NUMERICIDENTIFIER] = "0|[1-9]\\d*";
      tok("NUMERICIDENTIFIERLOOSE");
      src2[t3.NUMERICIDENTIFIERLOOSE] = "[0-9]+";
      tok("NONNUMERICIDENTIFIER");
      src2[t3.NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
      tok("MAINVERSION");
      src2[t3.MAINVERSION] = "(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")";
      tok("MAINVERSIONLOOSE");
      src2[t3.MAINVERSIONLOOSE] = "(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")";
      tok("PRERELEASEIDENTIFIER");
      src2[t3.PRERELEASEIDENTIFIER] = "(?:" + src2[t3.NUMERICIDENTIFIER] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
      tok("PRERELEASEIDENTIFIERLOOSE");
      src2[t3.PRERELEASEIDENTIFIERLOOSE] = "(?:" + src2[t3.NUMERICIDENTIFIERLOOSE] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
      tok("PRERELEASE");
      src2[t3.PRERELEASE] = "(?:-(" + src2[t3.PRERELEASEIDENTIFIER] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIER] + ")*))";
      tok("PRERELEASELOOSE");
      src2[t3.PRERELEASELOOSE] = "(?:-?(" + src2[t3.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIERLOOSE] + ")*))";
      tok("BUILDIDENTIFIER");
      src2[t3.BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
      tok("BUILD");
      src2[t3.BUILD] = "(?:\\+(" + src2[t3.BUILDIDENTIFIER] + "(?:\\." + src2[t3.BUILDIDENTIFIER] + ")*))";
      tok("FULL");
      tok("FULLPLAIN");
      src2[t3.FULLPLAIN] = "v?" + src2[t3.MAINVERSION] + src2[t3.PRERELEASE] + "?" + src2[t3.BUILD] + "?";
      src2[t3.FULL] = "^" + src2[t3.FULLPLAIN] + "$";
      tok("LOOSEPLAIN");
      src2[t3.LOOSEPLAIN] = "[v=\\s]*" + src2[t3.MAINVERSIONLOOSE] + src2[t3.PRERELEASELOOSE] + "?" + src2[t3.BUILD] + "?";
      tok("LOOSE");
      src2[t3.LOOSE] = "^" + src2[t3.LOOSEPLAIN] + "$";
      tok("GTLT");
      src2[t3.GTLT] = "((?:<|>)?=?)";
      tok("XRANGEIDENTIFIERLOOSE");
      src2[t3.XRANGEIDENTIFIERLOOSE] = src2[t3.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
      tok("XRANGEIDENTIFIER");
      src2[t3.XRANGEIDENTIFIER] = src2[t3.NUMERICIDENTIFIER] + "|x|X|\\*";
      tok("XRANGEPLAIN");
      src2[t3.XRANGEPLAIN] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:" + src2[t3.PRERELEASE] + ")?" + src2[t3.BUILD] + "?)?)?";
      tok("XRANGEPLAINLOOSE");
      src2[t3.XRANGEPLAINLOOSE] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:" + src2[t3.PRERELEASELOOSE] + ")?" + src2[t3.BUILD] + "?)?)?";
      tok("XRANGE");
      src2[t3.XRANGE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAIN] + "$";
      tok("XRANGELOOSE");
      src2[t3.XRANGELOOSE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("COERCE");
      src2[t3.COERCE] = "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:$|[^\\d])";
      tok("COERCERTL");
      re3[t3.COERCERTL] = new RegExp(src2[t3.COERCE], "g");
      tok("LONETILDE");
      src2[t3.LONETILDE] = "(?:~>?)";
      tok("TILDETRIM");
      src2[t3.TILDETRIM] = "(\\s*)" + src2[t3.LONETILDE] + "\\s+";
      re3[t3.TILDETRIM] = new RegExp(src2[t3.TILDETRIM], "g");
      var tildeTrimReplace = "$1~";
      tok("TILDE");
      src2[t3.TILDE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAIN] + "$";
      tok("TILDELOOSE");
      src2[t3.TILDELOOSE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("LONECARET");
      src2[t3.LONECARET] = "(?:\\^)";
      tok("CARETTRIM");
      src2[t3.CARETTRIM] = "(\\s*)" + src2[t3.LONECARET] + "\\s+";
      re3[t3.CARETTRIM] = new RegExp(src2[t3.CARETTRIM], "g");
      var caretTrimReplace = "$1^";
      tok("CARET");
      src2[t3.CARET] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAIN] + "$";
      tok("CARETLOOSE");
      src2[t3.CARETLOOSE] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("COMPARATORLOOSE");
      src2[t3.COMPARATORLOOSE] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + ")$|^$";
      tok("COMPARATOR");
      src2[t3.COMPARATOR] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.FULLPLAIN] + ")$|^$";
      tok("COMPARATORTRIM");
      src2[t3.COMPARATORTRIM] = "(\\s*)" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + "|" + src2[t3.XRANGEPLAIN] + ")";
      re3[t3.COMPARATORTRIM] = new RegExp(src2[t3.COMPARATORTRIM], "g");
      var comparatorTrimReplace = "$1$2$3";
      tok("HYPHENRANGE");
      src2[t3.HYPHENRANGE] = "^\\s*(" + src2[t3.XRANGEPLAIN] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAIN] + ")\\s*$";
      tok("HYPHENRANGELOOSE");
      src2[t3.HYPHENRANGELOOSE] = "^\\s*(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s*$";
      tok("STAR");
      src2[t3.STAR] = "(<|>)?=?\\s*\\*";
      for (var i2 = 0; i2 < R2; i2++) {
        debug2(i2, src2[i2]);
        if (!re3[i2]) {
          re3[i2] = new RegExp(src2[i2]);
        }
      }
      exports3.parse = parse5;
      function parse5(version3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (version3 instanceof SemVer2) {
          return version3;
        }
        if (typeof version3 !== "string") {
          return null;
        }
        if (version3.length > MAX_LENGTH2) {
          return null;
        }
        var r2 = options.loose ? re3[t3.LOOSE] : re3[t3.FULL];
        if (!r2.test(version3)) {
          return null;
        }
        try {
          return new SemVer2(version3, options);
        } catch (er) {
          return null;
        }
      }
      exports3.valid = valid;
      function valid(version3, options) {
        var v22 = parse5(version3, options);
        return v22 ? v22.version : null;
      }
      exports3.clean = clean;
      function clean(version3, options) {
        var s = parse5(version3.trim().replace(/^[=v]+/, ""), options);
        return s ? s.version : null;
      }
      exports3.SemVer = SemVer2;
      function SemVer2(version3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (version3 instanceof SemVer2) {
          if (version3.loose === options.loose) {
            return version3;
          } else {
            version3 = version3.version;
          }
        } else if (typeof version3 !== "string") {
          throw new TypeError("Invalid Version: " + version3);
        }
        if (version3.length > MAX_LENGTH2) {
          throw new TypeError("version is longer than " + MAX_LENGTH2 + " characters");
        }
        if (!(this instanceof SemVer2)) {
          return new SemVer2(version3, options);
        }
        debug2("SemVer", version3, options);
        this.options = options;
        this.loose = !!options.loose;
        var m2 = version3.trim().match(options.loose ? re3[t3.LOOSE] : re3[t3.FULL]);
        if (!m2) {
          throw new TypeError("Invalid Version: " + version3);
        }
        this.raw = version3;
        this.major = +m2[1];
        this.minor = +m2[2];
        this.patch = +m2[3];
        if (this.major > MAX_SAFE_INTEGER3 || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER3 || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER3 || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m2[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m2[4].split(".").map(function(id3) {
            if (/^[0-9]+$/.test(id3)) {
              var num = +id3;
              if (num >= 0 && num < MAX_SAFE_INTEGER3) {
                return num;
              }
            }
            return id3;
          });
        }
        this.build = m2[5] ? m2[5].split(".") : [];
        this.format();
      }
      SemVer2.prototype.format = function() {
        this.version = this.major + "." + this.minor + "." + this.patch;
        if (this.prerelease.length) {
          this.version += "-" + this.prerelease.join(".");
        }
        return this.version;
      };
      SemVer2.prototype.toString = function() {
        return this.version;
      };
      SemVer2.prototype.compare = function(other) {
        debug2("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        return this.compareMain(other) || this.comparePre(other);
      };
      SemVer2.prototype.compareMain = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        return compareIdentifiers2(this.major, other.major) || compareIdentifiers2(this.minor, other.minor) || compareIdentifiers2(this.patch, other.patch);
      };
      SemVer2.prototype.comparePre = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        var i3 = 0;
        do {
          var a = this.prerelease[i3];
          var b2 = other.prerelease[i3];
          debug2("prerelease compare", i3, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers2(a, b2);
          }
        } while (++i3);
      };
      SemVer2.prototype.compareBuild = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        var i3 = 0;
        do {
          var a = this.build[i3];
          var b2 = other.build[i3];
          debug2("prerelease compare", i3, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers2(a, b2);
          }
        } while (++i3);
      };
      SemVer2.prototype.inc = function(release3, identifier2) {
        switch (release3) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier2);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier2);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier2);
            this.inc("pre", identifier2);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier2);
            }
            this.inc("pre", identifier2);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre":
            if (this.prerelease.length === 0) {
              this.prerelease = [0];
            } else {
              var i3 = this.prerelease.length;
              while (--i3 >= 0) {
                if (typeof this.prerelease[i3] === "number") {
                  this.prerelease[i3]++;
                  i3 = -2;
                }
              }
              if (i3 === -1) {
                this.prerelease.push(0);
              }
            }
            if (identifier2) {
              if (this.prerelease[0] === identifier2) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = [identifier2, 0];
                }
              } else {
                this.prerelease = [identifier2, 0];
              }
            }
            break;
          default:
            throw new Error("invalid increment argument: " + release3);
        }
        this.format();
        this.raw = this.version;
        return this;
      };
      exports3.inc = inc;
      function inc(version3, release3, loose, identifier2) {
        if (typeof loose === "string") {
          identifier2 = loose;
          loose = void 0;
        }
        try {
          return new SemVer2(version3, loose).inc(release3, identifier2).version;
        } catch (er) {
          return null;
        }
      }
      exports3.diff = diff;
      function diff(version1, version22) {
        if (eq3(version1, version22)) {
          return null;
        } else {
          var v110 = parse5(version1);
          var v22 = parse5(version22);
          var prefix2 = "";
          if (v110.prerelease.length || v22.prerelease.length) {
            prefix2 = "pre";
            var defaultResult = "prerelease";
          }
          for (var key2 in v110) {
            if (key2 === "major" || key2 === "minor" || key2 === "patch") {
              if (v110[key2] !== v22[key2]) {
                return prefix2 + key2;
              }
            }
          }
          return defaultResult;
        }
      }
      exports3.compareIdentifiers = compareIdentifiers2;
      var numeric2 = /^[0-9]+$/;
      function compareIdentifiers2(a, b2) {
        var anum = numeric2.test(a);
        var bnum = numeric2.test(b2);
        if (anum && bnum) {
          a = +a;
          b2 = +b2;
        }
        return a === b2 ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b2 ? -1 : 1;
      }
      exports3.rcompareIdentifiers = rcompareIdentifiers2;
      function rcompareIdentifiers2(a, b2) {
        return compareIdentifiers2(b2, a);
      }
      exports3.major = major;
      function major(a, loose) {
        return new SemVer2(a, loose).major;
      }
      exports3.minor = minor;
      function minor(a, loose) {
        return new SemVer2(a, loose).minor;
      }
      exports3.patch = patch2;
      function patch2(a, loose) {
        return new SemVer2(a, loose).patch;
      }
      exports3.compare = compare3;
      function compare3(a, b2, loose) {
        return new SemVer2(a, loose).compare(new SemVer2(b2, loose));
      }
      exports3.compareLoose = compareLoose;
      function compareLoose(a, b2) {
        return compare3(a, b2, true);
      }
      exports3.compareBuild = compareBuild;
      function compareBuild(a, b2, loose) {
        var versionA = new SemVer2(a, loose);
        var versionB = new SemVer2(b2, loose);
        return versionA.compare(versionB) || versionA.compareBuild(versionB);
      }
      exports3.rcompare = rcompare;
      function rcompare(a, b2, loose) {
        return compare3(b2, a, loose);
      }
      exports3.sort = sort2;
      function sort2(list2, loose) {
        return list2.sort(function(a, b2) {
          return exports3.compareBuild(a, b2, loose);
        });
      }
      exports3.rsort = rsort;
      function rsort(list2, loose) {
        return list2.sort(function(a, b2) {
          return exports3.compareBuild(b2, a, loose);
        });
      }
      exports3.gt = gt2;
      function gt2(a, b2, loose) {
        return compare3(a, b2, loose) > 0;
      }
      exports3.lt = lt3;
      function lt3(a, b2, loose) {
        return compare3(a, b2, loose) < 0;
      }
      exports3.eq = eq3;
      function eq3(a, b2, loose) {
        return compare3(a, b2, loose) === 0;
      }
      exports3.neq = neq2;
      function neq2(a, b2, loose) {
        return compare3(a, b2, loose) !== 0;
      }
      exports3.gte = gte2;
      function gte2(a, b2, loose) {
        return compare3(a, b2, loose) >= 0;
      }
      exports3.lte = lte2;
      function lte2(a, b2, loose) {
        return compare3(a, b2, loose) <= 0;
      }
      exports3.cmp = cmp2;
      function cmp2(a, op, b2, loose) {
        switch (op) {
          case "===":
            if (typeof a === "object")
              a = a.version;
            if (typeof b2 === "object")
              b2 = b2.version;
            return a === b2;
          case "!==":
            if (typeof a === "object")
              a = a.version;
            if (typeof b2 === "object")
              b2 = b2.version;
            return a !== b2;
          case "":
          case "=":
          case "==":
            return eq3(a, b2, loose);
          case "!=":
            return neq2(a, b2, loose);
          case ">":
            return gt2(a, b2, loose);
          case ">=":
            return gte2(a, b2, loose);
          case "<":
            return lt3(a, b2, loose);
          case "<=":
            return lte2(a, b2, loose);
          default:
            throw new TypeError("Invalid operator: " + op);
        }
      }
      exports3.Comparator = Comparator;
      function Comparator(comp, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (comp instanceof Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        if (!(this instanceof Comparator)) {
          return new Comparator(comp, options);
        }
        debug2("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug2("comp", this);
      }
      var ANY = {};
      Comparator.prototype.parse = function(comp) {
        var r2 = this.options.loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
        var m2 = comp.match(r2);
        if (!m2) {
          throw new TypeError("Invalid comparator: " + comp);
        }
        this.operator = m2[1] !== void 0 ? m2[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m2[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer2(m2[2], this.options.loose);
        }
      };
      Comparator.prototype.toString = function() {
        return this.value;
      };
      Comparator.prototype.test = function(version3) {
        debug2("Comparator.test", version3, this.options.loose);
        if (this.semver === ANY || version3 === ANY) {
          return true;
        }
        if (typeof version3 === "string") {
          try {
            version3 = new SemVer2(version3, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp2(version3, this.operator, this.semver, this.options);
      };
      Comparator.prototype.intersects = function(comp, options) {
        if (!(comp instanceof Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        var rangeTmp;
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          rangeTmp = new Range(comp.value, options);
          return satisfies(this.value, rangeTmp, options);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          rangeTmp = new Range(this.value, options);
          return satisfies(comp.semver, rangeTmp, options);
        }
        var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
        var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
        var sameSemVer = this.semver.version === comp.semver.version;
        var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
        var oppositeDirectionsLessThan = cmp2(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
        var oppositeDirectionsGreaterThan = cmp2(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
      };
      exports3.Range = Range;
      function Range(range3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (range3 instanceof Range) {
          if (range3.loose === !!options.loose && range3.includePrerelease === !!options.includePrerelease) {
            return range3;
          } else {
            return new Range(range3.raw, options);
          }
        }
        if (range3 instanceof Comparator) {
          return new Range(range3.value, options);
        }
        if (!(this instanceof Range)) {
          return new Range(range3, options);
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range3;
        this.set = range3.split(/\s*\|\|\s*/).map(function(range4) {
          return this.parseRange(range4.trim());
        }, this).filter(function(c2) {
          return c2.length;
        });
        if (!this.set.length) {
          throw new TypeError("Invalid SemVer Range: " + range3);
        }
        this.format();
      }
      Range.prototype.format = function() {
        this.range = this.set.map(function(comps) {
          return comps.join(" ").trim();
        }).join("||").trim();
        return this.range;
      };
      Range.prototype.toString = function() {
        return this.range;
      };
      Range.prototype.parseRange = function(range3) {
        var loose = this.options.loose;
        range3 = range3.trim();
        var hr = loose ? re3[t3.HYPHENRANGELOOSE] : re3[t3.HYPHENRANGE];
        range3 = range3.replace(hr, hyphenReplace);
        debug2("hyphen replace", range3);
        range3 = range3.replace(re3[t3.COMPARATORTRIM], comparatorTrimReplace);
        debug2("comparator trim", range3, re3[t3.COMPARATORTRIM]);
        range3 = range3.replace(re3[t3.TILDETRIM], tildeTrimReplace);
        range3 = range3.replace(re3[t3.CARETTRIM], caretTrimReplace);
        range3 = range3.split(/\s+/).join(" ");
        var compRe = loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
        var set3 = range3.split(" ").map(function(comp) {
          return parseComparator(comp, this.options);
        }, this).join(" ").split(/\s+/);
        if (this.options.loose) {
          set3 = set3.filter(function(comp) {
            return !!comp.match(compRe);
          });
        }
        set3 = set3.map(function(comp) {
          return new Comparator(comp, this.options);
        }, this);
        return set3;
      };
      Range.prototype.intersects = function(range3, options) {
        if (!(range3 instanceof Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some(function(thisComparators) {
          return isSatisfiable(thisComparators, options) && range3.set.some(function(rangeComparators) {
            return isSatisfiable(rangeComparators, options) && thisComparators.every(function(thisComparator) {
              return rangeComparators.every(function(rangeComparator) {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      };
      function isSatisfiable(comparators, options) {
        var result = true;
        var remainingComparators = comparators.slice();
        var testComparator = remainingComparators.pop();
        while (result && remainingComparators.length) {
          result = remainingComparators.every(function(otherComparator) {
            return testComparator.intersects(otherComparator, options);
          });
          testComparator = remainingComparators.pop();
        }
        return result;
      }
      exports3.toComparators = toComparators;
      function toComparators(range3, options) {
        return new Range(range3, options).set.map(function(comp) {
          return comp.map(function(c2) {
            return c2.value;
          }).join(" ").trim().split(" ");
        });
      }
      function parseComparator(comp, options) {
        debug2("comp", comp, options);
        comp = replaceCarets(comp, options);
        debug2("caret", comp);
        comp = replaceTildes(comp, options);
        debug2("tildes", comp);
        comp = replaceXRanges(comp, options);
        debug2("xrange", comp);
        comp = replaceStars(comp, options);
        debug2("stars", comp);
        return comp;
      }
      function isX(id3) {
        return !id3 || id3.toLowerCase() === "x" || id3 === "*";
      }
      function replaceTildes(comp, options) {
        return comp.trim().split(/\s+/).map(function(comp2) {
          return replaceTilde(comp2, options);
        }).join(" ");
      }
      function replaceTilde(comp, options) {
        var r2 = options.loose ? re3[t3.TILDELOOSE] : re3[t3.TILDE];
        return comp.replace(r2, function(_, M2, m2, p2, pr) {
          debug2("tilde", comp, _, M2, m2, p2, pr);
          var ret;
          if (isX(M2)) {
            ret = "";
          } else if (isX(m2)) {
            ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
          } else if (isX(p2)) {
            ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
          } else if (pr) {
            debug2("replaceTilde pr", pr);
            ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
          } else {
            ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
          }
          debug2("tilde return", ret);
          return ret;
        });
      }
      function replaceCarets(comp, options) {
        return comp.trim().split(/\s+/).map(function(comp2) {
          return replaceCaret(comp2, options);
        }).join(" ");
      }
      function replaceCaret(comp, options) {
        debug2("caret", comp, options);
        var r2 = options.loose ? re3[t3.CARETLOOSE] : re3[t3.CARET];
        return comp.replace(r2, function(_, M2, m2, p2, pr) {
          debug2("caret", comp, _, M2, m2, p2, pr);
          var ret;
          if (isX(M2)) {
            ret = "";
          } else if (isX(m2)) {
            ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
          } else if (isX(p2)) {
            if (M2 === "0") {
              ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
            } else {
              ret = ">=" + M2 + "." + m2 + ".0 <" + (+M2 + 1) + ".0.0";
            }
          } else if (pr) {
            debug2("replaceCaret pr", pr);
            if (M2 === "0") {
              if (m2 === "0") {
                ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + m2 + "." + (+p2 + 1);
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
              }
            } else {
              ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + (+M2 + 1) + ".0.0";
            }
          } else {
            debug2("no pr");
            if (M2 === "0") {
              if (m2 === "0") {
                ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + m2 + "." + (+p2 + 1);
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
              }
            } else {
              ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + (+M2 + 1) + ".0.0";
            }
          }
          debug2("caret return", ret);
          return ret;
        });
      }
      function replaceXRanges(comp, options) {
        debug2("replaceXRanges", comp, options);
        return comp.split(/\s+/).map(function(comp2) {
          return replaceXRange(comp2, options);
        }).join(" ");
      }
      function replaceXRange(comp, options) {
        comp = comp.trim();
        var r2 = options.loose ? re3[t3.XRANGELOOSE] : re3[t3.XRANGE];
        return comp.replace(r2, function(ret, gtlt, M2, m2, p2, pr) {
          debug2("xRange", comp, ret, gtlt, M2, m2, p2, pr);
          var xM = isX(M2);
          var xm = xM || isX(m2);
          var xp = xm || isX(p2);
          var anyX = xp;
          if (gtlt === "=" && anyX) {
            gtlt = "";
          }
          pr = options.includePrerelease ? "-0" : "";
          if (xM) {
            if (gtlt === ">" || gtlt === "<") {
              ret = "<0.0.0-0";
            } else {
              ret = "*";
            }
          } else if (gtlt && anyX) {
            if (xm) {
              m2 = 0;
            }
            p2 = 0;
            if (gtlt === ">") {
              gtlt = ">=";
              if (xm) {
                M2 = +M2 + 1;
                m2 = 0;
                p2 = 0;
              } else {
                m2 = +m2 + 1;
                p2 = 0;
              }
            } else if (gtlt === "<=") {
              gtlt = "<";
              if (xm) {
                M2 = +M2 + 1;
              } else {
                m2 = +m2 + 1;
              }
            }
            ret = gtlt + M2 + "." + m2 + "." + p2 + pr;
          } else if (xm) {
            ret = ">=" + M2 + ".0.0" + pr + " <" + (+M2 + 1) + ".0.0" + pr;
          } else if (xp) {
            ret = ">=" + M2 + "." + m2 + ".0" + pr + " <" + M2 + "." + (+m2 + 1) + ".0" + pr;
          }
          debug2("xRange return", ret);
          return ret;
        });
      }
      function replaceStars(comp, options) {
        debug2("replaceStars", comp, options);
        return comp.trim().replace(re3[t3.STAR], "");
      }
      function hyphenReplace($0, from2, fM, fm, fp, fpr, fb2, to, tM, tm, tp, tpr, tb2) {
        if (isX(fM)) {
          from2 = "";
        } else if (isX(fm)) {
          from2 = ">=" + fM + ".0.0";
        } else if (isX(fp)) {
          from2 = ">=" + fM + "." + fm + ".0";
        } else {
          from2 = ">=" + from2;
        }
        if (isX(tM)) {
          to = "";
        } else if (isX(tm)) {
          to = "<" + (+tM + 1) + ".0.0";
        } else if (isX(tp)) {
          to = "<" + tM + "." + (+tm + 1) + ".0";
        } else if (tpr) {
          to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
        } else {
          to = "<=" + to;
        }
        return (from2 + " " + to).trim();
      }
      Range.prototype.test = function(version3) {
        if (!version3) {
          return false;
        }
        if (typeof version3 === "string") {
          try {
            version3 = new SemVer2(version3, this.options);
          } catch (er) {
            return false;
          }
        }
        for (var i3 = 0; i3 < this.set.length; i3++) {
          if (testSet(this.set[i3], version3, this.options)) {
            return true;
          }
        }
        return false;
      };
      function testSet(set3, version3, options) {
        for (var i3 = 0; i3 < set3.length; i3++) {
          if (!set3[i3].test(version3)) {
            return false;
          }
        }
        if (version3.prerelease.length && !options.includePrerelease) {
          for (i3 = 0; i3 < set3.length; i3++) {
            debug2(set3[i3].semver);
            if (set3[i3].semver === ANY) {
              continue;
            }
            if (set3[i3].semver.prerelease.length > 0) {
              var allowed = set3[i3].semver;
              if (allowed.major === version3.major && allowed.minor === version3.minor && allowed.patch === version3.patch) {
                return true;
              }
            }
          }
          return false;
        }
        return true;
      }
      exports3.satisfies = satisfies;
      function satisfies(version3, range3, options) {
        try {
          range3 = new Range(range3, options);
        } catch (er) {
          return false;
        }
        return range3.test(version3);
      }
      exports3.maxSatisfying = maxSatisfying;
      function maxSatisfying(versions2, range3, options) {
        var max3 = null;
        var maxSV = null;
        try {
          var rangeObj = new Range(range3, options);
        } catch (er) {
          return null;
        }
        versions2.forEach(function(v22) {
          if (rangeObj.test(v22)) {
            if (!max3 || maxSV.compare(v22) === -1) {
              max3 = v22;
              maxSV = new SemVer2(max3, options);
            }
          }
        });
        return max3;
      }
      exports3.minSatisfying = minSatisfying;
      function minSatisfying(versions2, range3, options) {
        var min4 = null;
        var minSV = null;
        try {
          var rangeObj = new Range(range3, options);
        } catch (er) {
          return null;
        }
        versions2.forEach(function(v22) {
          if (rangeObj.test(v22)) {
            if (!min4 || minSV.compare(v22) === 1) {
              min4 = v22;
              minSV = new SemVer2(min4, options);
            }
          }
        });
        return min4;
      }
      exports3.minVersion = minVersion2;
      function minVersion2(range3, loose) {
        range3 = new Range(range3, loose);
        var minver = new SemVer2("0.0.0");
        if (range3.test(minver)) {
          return minver;
        }
        minver = new SemVer2("0.0.0-0");
        if (range3.test(minver)) {
          return minver;
        }
        minver = null;
        for (var i3 = 0; i3 < range3.set.length; ++i3) {
          var comparators = range3.set[i3];
          comparators.forEach(function(comparator) {
            var compver = new SemVer2(comparator.semver.version);
            switch (comparator.operator) {
              case ">":
                if (compver.prerelease.length === 0) {
                  compver.patch++;
                } else {
                  compver.prerelease.push(0);
                }
                compver.raw = compver.format();
              case "":
              case ">=":
                if (!minver || gt2(minver, compver)) {
                  minver = compver;
                }
                break;
              case "<":
              case "<=":
                break;
              default:
                throw new Error("Unexpected operation: " + comparator.operator);
            }
          });
        }
        if (minver && range3.test(minver)) {
          return minver;
        }
        return null;
      }
      exports3.validRange = validRange;
      function validRange(range3, options) {
        try {
          return new Range(range3, options).range || "*";
        } catch (er) {
          return null;
        }
      }
      exports3.ltr = ltr;
      function ltr(version3, range3, options) {
        return outside(version3, range3, "<", options);
      }
      exports3.gtr = gtr;
      function gtr(version3, range3, options) {
        return outside(version3, range3, ">", options);
      }
      exports3.outside = outside;
      function outside(version3, range3, hilo, options) {
        version3 = new SemVer2(version3, options);
        range3 = new Range(range3, options);
        var gtfn, ltefn, ltfn, comp, ecomp;
        switch (hilo) {
          case ">":
            gtfn = gt2;
            ltefn = lte2;
            ltfn = lt3;
            comp = ">";
            ecomp = ">=";
            break;
          case "<":
            gtfn = lt3;
            ltefn = gte2;
            ltfn = gt2;
            comp = "<";
            ecomp = "<=";
            break;
          default:
            throw new TypeError('Must provide a hilo val of "<" or ">"');
        }
        if (satisfies(version3, range3, options)) {
          return false;
        }
        for (var i3 = 0; i3 < range3.set.length; ++i3) {
          var comparators = range3.set[i3];
          var high = null;
          var low = null;
          comparators.forEach(function(comparator) {
            if (comparator.semver === ANY) {
              comparator = new Comparator(">=0.0.0");
            }
            high = high || comparator;
            low = low || comparator;
            if (gtfn(comparator.semver, high.semver, options)) {
              high = comparator;
            } else if (ltfn(comparator.semver, low.semver, options)) {
              low = comparator;
            }
          });
          if (high.operator === comp || high.operator === ecomp) {
            return false;
          }
          if ((!low.operator || low.operator === comp) && ltefn(version3, low.semver)) {
            return false;
          } else if (low.operator === ecomp && ltfn(version3, low.semver)) {
            return false;
          }
        }
        return true;
      }
      exports3.prerelease = prerelease;
      function prerelease(version3, options) {
        var parsed = parse5(version3, options);
        return parsed && parsed.prerelease.length ? parsed.prerelease : null;
      }
      exports3.intersects = intersects;
      function intersects(r1, r2, options) {
        r1 = new Range(r1, options);
        r2 = new Range(r2, options);
        return r1.intersects(r2);
      }
      exports3.coerce = coerce2;
      function coerce2(version3, options) {
        if (version3 instanceof SemVer2) {
          return version3;
        }
        if (typeof version3 === "number") {
          version3 = String(version3);
        }
        if (typeof version3 !== "string") {
          return null;
        }
        options = options || {};
        var match = null;
        if (!options.rtl) {
          match = version3.match(re3[t3.COERCE]);
        } else {
          var next;
          while ((next = re3[t3.COERCERTL].exec(version3)) && (!match || match.index + match[0].length !== version3.length)) {
            if (!match || next.index + next[0].length !== match.index + match[0].length) {
              match = next;
            }
            re3[t3.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
          }
          re3[t3.COERCERTL].lastIndex = -1;
        }
        if (match === null) {
          return null;
        }
        return parse5(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
      }
    })(semver$7, semver$7.exports);
    var semver$6 = semver$7.exports;
    var _excluded$12 = ["method", "targets", "ignoreBrowserslistConfig", "configPath", "debug", "shouldInjectPolyfill", "absoluteImports"];
    var _templateObject$5, _templateObject2$3, _templateObject3$2;
    var _ref$5 = babel2, t$1$3 = _ref$5.types, template$1 = _ref$5.template;
    function intersection$3(a, b2) {
      var result = /* @__PURE__ */ new Set();
      a.forEach(function(v22) {
        return b2.has(v22) && result.add(v22);
      });
      return result;
    }
    function has$1$1(object4, key2) {
      return Object.prototype.hasOwnProperty.call(object4, key2);
    }
    function getType$1(target) {
      return Object.prototype.toString.call(target).slice(8, -1);
    }
    function resolveId$1(path2) {
      if (path2.isIdentifier() && !path2.scope.hasBinding(path2.node.name, true)) {
        return path2.node.name;
      }
      var _path$evaluate = path2.evaluate(), deopt2 = _path$evaluate.deopt;
      if (deopt2 && deopt2.isIdentifier()) {
        return deopt2.node.name;
      }
    }
    function resolveKey$1(path2, computed) {
      if (computed === void 0) {
        computed = false;
      }
      var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
      if (path2.isStringLiteral())
        return node2.value;
      var name2 = node2.name;
      var isIdentifier2 = path2.isIdentifier();
      if (isIdentifier2 && !(computed || parent.computed))
        return name2;
      if (computed && path2.isMemberExpression() && path2.get("object").isIdentifier({
        name: "Symbol"
      }) && !scope2.hasBinding("Symbol", true)) {
        var sym = resolveKey$1(path2.get("property"), path2.node.computed);
        if (sym)
          return "Symbol." + sym;
      }
      if (!isIdentifier2 || scope2.hasBinding(name2, true)) {
        var _path$evaluate2 = path2.evaluate(), value = _path$evaluate2.value;
        if (typeof value === "string")
          return value;
      }
    }
    function resolveSource$1(obj) {
      if (obj.isMemberExpression() && obj.get("property").isIdentifier({
        name: "prototype"
      })) {
        var _id = resolveId$1(obj.get("object"));
        if (_id) {
          return {
            id: _id,
            placement: "prototype"
          };
        }
        return {
          id: null,
          placement: null
        };
      }
      var id3 = resolveId$1(obj);
      if (id3) {
        return {
          id: id3,
          placement: "static"
        };
      }
      var _obj$evaluate = obj.evaluate(), value = _obj$evaluate.value;
      if (value !== void 0) {
        return {
          id: getType$1(value),
          placement: "prototype"
        };
      } else if (obj.isRegExpLiteral()) {
        return {
          id: "RegExp",
          placement: "prototype"
        };
      } else if (obj.isFunction()) {
        return {
          id: "Function",
          placement: "prototype"
        };
      }
      return {
        id: null,
        placement: null
      };
    }
    function getImportSource$2(_ref22) {
      var node2 = _ref22.node;
      if (node2.specifiers.length === 0)
        return node2.source.value;
    }
    function getRequireSource$2(_ref3) {
      var node2 = _ref3.node;
      if (!t$1$3.isExpressionStatement(node2))
        return;
      var expression2 = node2.expression;
      var isRequire = t$1$3.isCallExpression(expression2) && t$1$3.isIdentifier(expression2.callee) && expression2.callee.name === "require" && expression2.arguments.length === 1 && t$1$3.isStringLiteral(expression2.arguments[0]);
      if (isRequire)
        return expression2.arguments[0].value;
    }
    function hoist$1(node2) {
      node2._blockHoist = 3;
      return node2;
    }
    function createUtilsGetter$1(cache2) {
      return function(path2) {
        var prog = path2.findParent(function(p2) {
          return p2.isProgram();
        });
        return {
          injectGlobalImport: function injectGlobalImport(url2) {
            cache2.storeAnonymous(prog, url2, function(isScript, source) {
              return isScript ? template$1.statement.ast(_templateObject$5 || (_templateObject$5 = _taggedTemplateLiteralLoose(["require(", ")"])), source) : t$1$3.importDeclaration([], source);
            });
          },
          injectNamedImport: function injectNamedImport(url2, name2, hint) {
            if (hint === void 0) {
              hint = name2;
            }
            return cache2.storeNamed(prog, url2, name2, function(isScript, source, name3) {
              var id3 = prog.scope.generateUidIdentifier(hint);
              return {
                node: isScript ? hoist$1(template$1.statement.ast(_templateObject2$3 || (_templateObject2$3 = _taggedTemplateLiteralLoose(["\n                  var ", " = require(", ").", "\n                "])), id3, source, name3)) : t$1$3.importDeclaration([t$1$3.importSpecifier(id3, name3)], source),
                name: id3.name
              };
            });
          },
          injectDefaultImport: function injectDefaultImport(url2, hint) {
            if (hint === void 0) {
              hint = url2;
            }
            return cache2.storeNamed(prog, url2, "default", function(isScript, source) {
              var id3 = prog.scope.generateUidIdentifier(hint);
              return {
                node: isScript ? hoist$1(template$1.statement.ast(_templateObject3$2 || (_templateObject3$2 = _taggedTemplateLiteralLoose(["var ", " = require(", ")"])), id3, source)) : t$1$3.importDeclaration([t$1$3.importDefaultSpecifier(id3)], source),
                name: id3.name
              };
            });
          }
        };
      };
    }
    var _ref4$1 = babel2, t$9 = _ref4$1.types;
    var ImportsCache$1 = function() {
      function ImportsCache2(resolver) {
        this._imports = /* @__PURE__ */ new WeakMap();
        this._anonymousImports = /* @__PURE__ */ new WeakMap();
        this._lastImports = /* @__PURE__ */ new WeakMap();
        this._resolver = resolver;
      }
      var _proto = ImportsCache2.prototype;
      _proto.storeAnonymous = function storeAnonymous(programPath, url2, getVal) {
        var key2 = this._normalizeKey(programPath, url2);
        var imports = this._ensure(this._anonymousImports, programPath, Set);
        if (imports.has(key2))
          return;
        var node2 = getVal(programPath.node.sourceType === "script", t$9.stringLiteral(this._resolver(url2)));
        imports.add(key2);
        this._injectImport(programPath, node2);
      };
      _proto.storeNamed = function storeNamed(programPath, url2, name2, getVal) {
        var key2 = this._normalizeKey(programPath, url2, name2);
        var imports = this._ensure(this._imports, programPath, Map);
        if (!imports.has(key2)) {
          var _getVal = getVal(programPath.node.sourceType === "script", t$9.stringLiteral(this._resolver(url2)), t$9.identifier(name2)), node2 = _getVal.node, id3 = _getVal.name;
          imports.set(key2, id3);
          this._injectImport(programPath, node2);
        }
        return t$9.identifier(imports.get(key2));
      };
      _proto._injectImport = function _injectImport(programPath, node2) {
        var lastImport = this._lastImports.get(programPath);
        if (lastImport && lastImport.node && lastImport.parent === programPath.node && lastImport.container === programPath.node.body) {
          lastImport = lastImport.insertAfter(node2);
        } else {
          lastImport = programPath.unshiftContainer("body", node2);
        }
        lastImport = lastImport[lastImport.length - 1];
        this._lastImports.set(programPath, lastImport);
      };
      _proto._ensure = function _ensure(map2, programPath, Collection2) {
        var collection = map2.get(programPath);
        if (!collection) {
          collection = new Collection2();
          map2.set(programPath, collection);
        }
        return collection;
      };
      _proto._normalizeKey = function _normalizeKey(programPath, url2, name2) {
        if (name2 === void 0) {
          name2 = "";
        }
        var sourceType = programPath.node.sourceType;
        return (name2 && sourceType) + "::" + url2 + "::" + name2;
      };
      return _createClass2(ImportsCache2);
    }();
    var presetEnvSilentDebugHeader$1 = "#__secret_key__@babel/preset-env__don't_log_debug_header_and_resolved_targets";
    function stringifyTargetsMultiline$1(targets) {
      return JSON.stringify(prettifyTargets(targets), null, 2);
    }
    function patternToRegExp$1(pattern5) {
      if (pattern5 instanceof RegExp)
        return pattern5;
      try {
        return new RegExp("^" + pattern5 + "$");
      } catch (_unused) {
        return null;
      }
    }
    function buildUnusedError$1(label, unused) {
      if (!unused.length)
        return "";
      return '  - The following "' + label + `" patterns didn't match any polyfill:
` + unused.map(function(original) {
        return "    " + String(original) + "\n";
      }).join("");
    }
    function buldDuplicatesError$1(duplicates) {
      if (!duplicates.size)
        return "";
      return '  - The following polyfills were matched both by "include" and "exclude" patterns:\n' + Array.from(duplicates, function(name2) {
        return "    " + name2 + "\n";
      }).join("");
    }
    function validateIncludeExclude$1(provider, polyfills, includePatterns, excludePatterns) {
      var current2;
      var filter3 = function filter4(pattern5) {
        var regexp4 = patternToRegExp$1(pattern5);
        if (!regexp4)
          return false;
        var matched = false;
        for (var _iterator2 = _createForOfIteratorHelperLoose(polyfills), _step2; !(_step2 = _iterator2()).done; ) {
          var polyfill = _step2.value;
          if (regexp4.test(polyfill)) {
            matched = true;
            current2.add(polyfill);
          }
        }
        return !matched;
      };
      var include = current2 = /* @__PURE__ */ new Set();
      var unusedInclude = Array.from(includePatterns).filter(filter3);
      var exclude = current2 = /* @__PURE__ */ new Set();
      var unusedExclude = Array.from(excludePatterns).filter(filter3);
      var duplicates = intersection$3(include, exclude);
      if (duplicates.size > 0 || unusedInclude.length > 0 || unusedExclude.length > 0) {
        throw new Error('Error while validating the "' + provider + '" provider options:\n' + buildUnusedError$1("include", unusedInclude) + buildUnusedError$1("exclude", unusedExclude) + buldDuplicatesError$1(duplicates));
      }
      return {
        include,
        exclude
      };
    }
    function applyMissingDependenciesDefaults$1(options, babelApi) {
      var _options$missingDepen = options.missingDependencies, missingDependencies = _options$missingDepen === void 0 ? {} : _options$missingDepen;
      if (missingDependencies === false)
        return false;
      var caller = babelApi.caller(function(caller2) {
        return caller2 == null ? void 0 : caller2.name;
      });
      var _missingDependencies$ = missingDependencies.log, log = _missingDependencies$ === void 0 ? "deferred" : _missingDependencies$, _missingDependencies$2 = missingDependencies.inject, inject = _missingDependencies$2 === void 0 ? caller === "rollup-plugin-babel" ? "throw" : "import" : _missingDependencies$2, _missingDependencies$3 = missingDependencies.all, all2 = _missingDependencies$3 === void 0 ? false : _missingDependencies$3;
      return {
        log,
        inject,
        all: all2
      };
    }
    var usage$1 = function usage2(callProvider) {
      function property2(object4, key2, placement, path2) {
        return callProvider({
          kind: "property",
          object: object4,
          key: key2,
          placement
        }, path2);
      }
      return {
        ReferencedIdentifier: function ReferencedIdentifier2(path2) {
          var name2 = path2.node.name, scope2 = path2.scope;
          if (scope2.getBindingIdentifier(name2))
            return;
          callProvider({
            kind: "global",
            name: name2
          }, path2);
        },
        MemberExpression: function MemberExpression2(path2) {
          var key2 = resolveKey$1(path2.get("property"), path2.node.computed);
          if (!key2 || key2 === "prototype")
            return;
          var object4 = path2.get("object");
          var binding2 = object4.scope.getBinding(object4.node.name);
          if (binding2 && binding2.path.isImportNamespaceSpecifier())
            return;
          var source = resolveSource$1(object4);
          return property2(source.id, key2, source.placement, path2);
        },
        ObjectPattern: function ObjectPattern(path2) {
          var parentPath = path2.parentPath, parent = path2.parent;
          var obj;
          if (parentPath.isVariableDeclarator()) {
            obj = parentPath.get("init");
          } else if (parentPath.isAssignmentExpression()) {
            obj = parentPath.get("right");
          } else if (parentPath.isFunction()) {
            var grand = parentPath.parentPath;
            if (grand.isCallExpression() || grand.isNewExpression()) {
              if (grand.node.callee === parent) {
                obj = grand.get("arguments")[path2.key];
              }
            }
          }
          var id3 = null;
          var placement = null;
          if (obj) {
            var _resolveSource = resolveSource$1(obj);
            id3 = _resolveSource.id;
            placement = _resolveSource.placement;
          }
          for (var _iterator2 = _createForOfIteratorHelperLoose(path2.get("properties")), _step2; !(_step2 = _iterator2()).done; ) {
            var prop2 = _step2.value;
            if (prop2.isObjectProperty()) {
              var key2 = resolveKey$1(prop2.get("key"));
              if (key2)
                property2(id3, key2, placement, prop2);
            }
          }
        },
        BinaryExpression: function BinaryExpression2(path2) {
          if (path2.node.operator !== "in")
            return;
          var source = resolveSource$1(path2.get("right"));
          var key2 = resolveKey$1(path2.get("left"), true);
          if (!key2)
            return;
          callProvider({
            kind: "in",
            object: source.id,
            key: key2,
            placement: source.placement
          }, path2);
        }
      };
    };
    var entry$1 = function entry2(callProvider) {
      return {
        ImportDeclaration: function ImportDeclaration2(path2) {
          var source = getImportSource$2(path2);
          if (!source)
            return;
          callProvider({
            kind: "import",
            source
          }, path2);
        },
        Program: function Program2(path2) {
          path2.get("body").forEach(function(bodyPath) {
            var source = getRequireSource$2(bodyPath);
            if (!source)
              return;
            callProvider({
              kind: "import",
              source
            }, bodyPath);
          });
        }
      };
    };
    function resolve$1(dirname2, moduleName, absoluteImports) {
      if (absoluteImports === false)
        return moduleName;
      throw new Error('"absoluteImports" is not supported in bundles prepared for the browser.');
    }
    function has$6(basedir, name2) {
      return true;
    }
    function logMissing$1(missingDeps) {
    }
    function laterLogMissing$1(missingDeps) {
    }
    var PossibleGlobalObjects$1 = /* @__PURE__ */ new Set(["global", "globalThis", "self", "window"]);
    function createMetaResolver$1(polyfills) {
      var staticP = polyfills["static"], instanceP = polyfills.instance, globalP = polyfills.global;
      return function(meta2) {
        if (meta2.kind === "global" && globalP && has$1$1(globalP, meta2.name)) {
          return {
            kind: "global",
            desc: globalP[meta2.name],
            name: meta2.name
          };
        }
        if (meta2.kind === "property" || meta2.kind === "in") {
          var placement = meta2.placement, object4 = meta2.object, key2 = meta2.key;
          if (object4 && placement === "static") {
            if (globalP && PossibleGlobalObjects$1.has(object4) && has$1$1(globalP, key2)) {
              return {
                kind: "global",
                desc: globalP[key2],
                name: key2
              };
            }
            if (staticP && has$1$1(staticP, object4) && has$1$1(staticP[object4], key2)) {
              return {
                kind: "static",
                desc: staticP[object4][key2],
                name: object4 + "$" + key2
              };
            }
          }
          if (instanceP && has$1$1(instanceP, key2)) {
            return {
              kind: "instance",
              desc: instanceP[key2],
              name: "" + key2
            };
          }
        }
      };
    }
    var getTargets$1 = getTargets$2["default"] || getTargets$2;
    function resolveOptions$1(options, babelApi) {
      var method5 = options.method, targetsOption = options.targets, ignoreBrowserslistConfig = options.ignoreBrowserslistConfig, configPath = options.configPath, debug2 = options.debug, shouldInjectPolyfill = options.shouldInjectPolyfill, absoluteImports = options.absoluteImports, providerOptions = _objectWithoutProperties2(options, _excluded$12);
      var methodName;
      if (method5 === "usage-global")
        methodName = "usageGlobal";
      else if (method5 === "entry-global")
        methodName = "entryGlobal";
      else if (method5 === "usage-pure")
        methodName = "usagePure";
      else if (typeof method5 !== "string") {
        throw new Error(".method must be a string");
      } else {
        throw new Error('.method must be one of "entry-global", "usage-global"' + (' or "usage-pure" (received ' + JSON.stringify(method5) + ")"));
      }
      if (typeof shouldInjectPolyfill === "function") {
        if (options.include || options.exclude) {
          throw new Error(".include and .exclude are not supported when using the .shouldInjectPolyfill function.");
        }
      } else if (shouldInjectPolyfill != null) {
        throw new Error(".shouldInjectPolyfill must be a function, or undefined" + (" (received " + JSON.stringify(shouldInjectPolyfill) + ")"));
      }
      if (absoluteImports != null && typeof absoluteImports !== "boolean" && typeof absoluteImports !== "string") {
        throw new Error(".absoluteImports must be a boolean, a string, or undefined" + (" (received " + JSON.stringify(absoluteImports) + ")"));
      }
      var targets;
      if (targetsOption || configPath || ignoreBrowserslistConfig) {
        var targetsObj = typeof targetsOption === "string" || Array.isArray(targetsOption) ? {
          browsers: targetsOption
        } : targetsOption;
        targets = getTargets$1(targetsObj, {
          ignoreBrowserslistConfig,
          configPath
        });
      } else {
        targets = babelApi.targets();
      }
      return {
        method: method5,
        methodName,
        targets,
        absoluteImports: absoluteImports != null ? absoluteImports : false,
        shouldInjectPolyfill,
        debug: !!debug2,
        providerOptions
      };
    }
    function instantiateProvider$1(factory, options, missingDependencies, dirname2, debugLog, babelApi) {
      var _resolveOptions = resolveOptions$1(options, babelApi), method5 = _resolveOptions.method, methodName = _resolveOptions.methodName, targets = _resolveOptions.targets, _debug2 = _resolveOptions.debug, _shouldInjectPolyfill = _resolveOptions.shouldInjectPolyfill, providerOptions = _resolveOptions.providerOptions, absoluteImports = _resolveOptions.absoluteImports;
      var getUtils = createUtilsGetter$1(new ImportsCache$1(function(moduleName) {
        return resolve$1(dirname2, moduleName, absoluteImports);
      }));
      var include, exclude;
      var polyfillsSupport;
      var polyfillsNames;
      var filterPolyfills;
      var depsCache = /* @__PURE__ */ new Map();
      var api = {
        babel: babelApi,
        getUtils,
        method: options.method,
        targets,
        createMetaResolver: createMetaResolver$1,
        shouldInjectPolyfill: function shouldInjectPolyfill(name2) {
          if (polyfillsNames === void 0) {
            throw new Error("Internal error in the " + factory.name + " provider: shouldInjectPolyfill() can't be called during initialization.");
          }
          if (!polyfillsNames.has(name2)) {
            console.warn("Internal error in the " + provider.name + " provider: " + ('unknown polyfill "' + name2 + '".'));
          }
          if (filterPolyfills && !filterPolyfills(name2))
            return false;
          var shouldInject = isRequired(name2, targets, {
            compatData: polyfillsSupport,
            includes: include,
            excludes: exclude
          });
          if (_shouldInjectPolyfill) {
            shouldInject = _shouldInjectPolyfill(name2, shouldInject);
            if (typeof shouldInject !== "boolean") {
              throw new Error(".shouldInjectPolyfill must return a boolean.");
            }
          }
          return shouldInject;
        },
        debug: function debug2(name2) {
          debugLog().found = true;
          if (!_debug2 || !name2)
            return;
          if (debugLog().polyfills.has(provider.name))
            return;
          debugLog().polyfills.set(name2, polyfillsSupport && name2 && polyfillsSupport[name2]);
        },
        assertDependency: function assertDependency(name2, version3) {
          if (version3 === void 0) {
            version3 = "*";
          }
          if (missingDependencies === false)
            return;
          if (absoluteImports) {
            return;
          }
          var dep = version3 === "*" ? name2 : name2 + "@^" + version3;
          var found = missingDependencies.all ? false : mapGetOr$1(depsCache, name2 + " :: " + dirname2, function() {
            return has$6();
          });
          if (!found) {
            debugLog().missingDeps.add(dep);
          }
        }
      };
      var provider = factory(api, providerOptions, dirname2);
      if (typeof provider[methodName] !== "function") {
        throw new Error('The "' + (provider.name || factory.name) + `" provider doesn't ` + ('support the "' + method5 + '" polyfilling method.'));
      }
      if (Array.isArray(provider.polyfills)) {
        polyfillsNames = new Set(provider.polyfills);
        filterPolyfills = provider.filterPolyfills;
      } else if (provider.polyfills) {
        polyfillsNames = new Set(Object.keys(provider.polyfills));
        polyfillsSupport = provider.polyfills;
        filterPolyfills = provider.filterPolyfills;
      } else {
        polyfillsNames = /* @__PURE__ */ new Set();
      }
      var _validateIncludeExclu = validateIncludeExclude$1(provider.name || factory.name, polyfillsNames, providerOptions.include || [], providerOptions.exclude || []);
      include = _validateIncludeExclu.include;
      exclude = _validateIncludeExclu.exclude;
      return {
        debug: _debug2,
        method: method5,
        targets,
        provider,
        callProvider: function callProvider(payload, path2) {
          var utils3 = getUtils(path2);
          provider[methodName](payload, utils3, path2);
        }
      };
    }
    function definePolyfillProvider$1(factory) {
      return declare(function(babelApi, options, dirname2) {
        babelApi.assertVersion(7);
        var traverse2 = babelApi.traverse;
        var debugLog;
        var missingDependencies = applyMissingDependenciesDefaults$1(options, babelApi);
        var _instantiateProvider = instantiateProvider$1(factory, options, missingDependencies, dirname2, function() {
          return debugLog;
        }, babelApi), debug2 = _instantiateProvider.debug, method5 = _instantiateProvider.method, targets = _instantiateProvider.targets, provider = _instantiateProvider.provider, callProvider = _instantiateProvider.callProvider;
        var createVisitor = method5 === "entry-global" ? entry$1 : usage$1;
        var visitor2 = provider.visitor ? traverse2.visitors.merge([createVisitor(callProvider), provider.visitor]) : createVisitor(callProvider);
        if (debug2 && debug2 !== presetEnvSilentDebugHeader$1) {
          console.log(provider.name + ": `DEBUG` option");
          console.log("\nUsing targets: " + stringifyTargetsMultiline$1(targets));
          console.log("\nUsing polyfills with `" + method5 + "` method:");
        }
        return {
          name: "inject-polyfills",
          visitor: visitor2,
          pre: function pre() {
            var _provider$pre;
            debugLog = {
              polyfills: /* @__PURE__ */ new Map(),
              found: false,
              providers: /* @__PURE__ */ new Set(),
              missingDeps: /* @__PURE__ */ new Set()
            };
            (_provider$pre = provider.pre) == null ? void 0 : _provider$pre.apply(this, arguments);
          },
          post: function post() {
            var _provider$post;
            (_provider$post = provider.post) == null ? void 0 : _provider$post.apply(this, arguments);
            if (missingDependencies !== false) {
              if (missingDependencies.log === "per-file") {
                logMissing$1(debugLog.missingDeps);
              } else {
                laterLogMissing$1(debugLog.missingDeps);
              }
            }
            if (!debug2)
              return;
            if (this.filename)
              console.log("\n[" + this.filename + "]");
            if (debugLog.polyfills.size === 0) {
              console.log(method5 === "entry-global" ? debugLog.found ? "Based on your targets, the " + provider.name + " polyfill did not add any polyfill." : "The entry point for the " + provider.name + " polyfill has not been found." : "Based on your code and targets, the " + provider.name + " polyfill did not add any polyfill.");
              return;
            }
            if (method5 === "entry-global") {
              console.log("The " + provider.name + " polyfill entry has been replaced with the following polyfills:");
            } else {
              console.log("The " + provider.name + " polyfill added the following polyfills:");
            }
            for (var _iterator3 = _createForOfIteratorHelperLoose(debugLog.polyfills), _step3; !(_step3 = _iterator3()).done; ) {
              var _step3$value = _slicedToArray$12(_step3.value, 2), name2 = _step3$value[0], support = _step3$value[1];
              if (support) {
                var filteredTargets = getInclusionReasons(name2, targets, support);
                var formattedTargets = JSON.stringify(filteredTargets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
                console.log("  " + name2 + " " + formattedTargets);
              } else {
                console.log("  " + name2);
              }
            }
          }
        };
      });
    }
    function mapGetOr$1(map2, key2, getDefault) {
      var val = map2.get(key2);
      if (val === void 0) {
        val = getDefault();
        map2.set(key2, val);
      }
      return val;
    }
    var define$3 = function define2(name2, pure, global2, meta2) {
      if (global2 === void 0) {
        global2 = [];
      }
      return {
        name: name2,
        pure,
        global: global2,
        meta: meta2
      };
    };
    var pureAndGlobal$1 = function pureAndGlobal2(pure, global2, minRuntimeVersion) {
      if (minRuntimeVersion === void 0) {
        minRuntimeVersion = null;
      }
      return define$3(global2[0], pure, global2, {
        minRuntimeVersion
      });
    };
    var globalOnly$1 = function globalOnly2(global2) {
      return define$3(global2[0], null, global2);
    };
    var pureOnly$1 = function pureOnly2(pure, name2) {
      return define$3(name2, pure, []);
    };
    var ArrayNatureIterators$3 = ["es6.object.to-string", "es6.array.iterator", "web.dom.iterable"];
    var CommonIterators$3 = ["es6.string.iterator"].concat(ArrayNatureIterators$3);
    var PromiseDependencies$3 = ["es6.object.to-string", "es6.promise"];
    var BuiltIns$3 = {
      DataView: globalOnly$1(["es6.typed.data-view"]),
      Float32Array: globalOnly$1(["es6.typed.float32-array"]),
      Float64Array: globalOnly$1(["es6.typed.float64-array"]),
      Int8Array: globalOnly$1(["es6.typed.int8-array"]),
      Int16Array: globalOnly$1(["es6.typed.int16-array"]),
      Int32Array: globalOnly$1(["es6.typed.int32-array"]),
      Map: pureAndGlobal$1("map", ["es6.map"].concat(_toConsumableArray2(CommonIterators$3))),
      Number: globalOnly$1(["es6.number.constructor"]),
      Promise: pureAndGlobal$1("promise", PromiseDependencies$3),
      RegExp: globalOnly$1(["es6.regexp.constructor"]),
      Set: pureAndGlobal$1("set", ["es6.set"].concat(_toConsumableArray2(CommonIterators$3))),
      Symbol: pureAndGlobal$1("symbol", ["es6.symbol"]),
      Uint8Array: globalOnly$1(["es6.typed.uint8-array"]),
      Uint8ClampedArray: globalOnly$1(["es6.typed.uint8-clamped-array"]),
      Uint16Array: globalOnly$1(["es6.typed.uint16-array"]),
      Uint32Array: globalOnly$1(["es6.typed.uint32-array"]),
      WeakMap: pureAndGlobal$1("weak-map", ["es6.weak-map"].concat(_toConsumableArray2(CommonIterators$3))),
      WeakSet: pureAndGlobal$1("weak-set", ["es6.weak-set"].concat(_toConsumableArray2(CommonIterators$3))),
      setImmediate: pureOnly$1("set-immediate", "web.immediate"),
      clearImmediate: pureOnly$1("clear-immediate", "web.immediate"),
      parseFloat: pureOnly$1("parse-float", "es6.parse-float"),
      parseInt: pureOnly$1("parse-int", "es6.parse-int")
    };
    var InstanceProperties$3 = {
      __defineGetter__: globalOnly$1(["es7.object.define-getter"]),
      __defineSetter__: globalOnly$1(["es7.object.define-setter"]),
      __lookupGetter__: globalOnly$1(["es7.object.lookup-getter"]),
      __lookupSetter__: globalOnly$1(["es7.object.lookup-setter"]),
      anchor: globalOnly$1(["es6.string.anchor"]),
      big: globalOnly$1(["es6.string.big"]),
      bind: globalOnly$1(["es6.function.bind"]),
      blink: globalOnly$1(["es6.string.blink"]),
      bold: globalOnly$1(["es6.string.bold"]),
      codePointAt: globalOnly$1(["es6.string.code-point-at"]),
      copyWithin: globalOnly$1(["es6.array.copy-within"]),
      endsWith: globalOnly$1(["es6.string.ends-with"]),
      entries: globalOnly$1(ArrayNatureIterators$3),
      every: globalOnly$1(["es6.array.every"]),
      fill: globalOnly$1(["es6.array.fill"]),
      filter: globalOnly$1(["es6.array.filter"]),
      "finally": globalOnly$1(["es7.promise.finally"].concat(PromiseDependencies$3)),
      find: globalOnly$1(["es6.array.find"]),
      findIndex: globalOnly$1(["es6.array.find-index"]),
      fixed: globalOnly$1(["es6.string.fixed"]),
      flags: globalOnly$1(["es6.regexp.flags"]),
      flatMap: globalOnly$1(["es7.array.flat-map"]),
      fontcolor: globalOnly$1(["es6.string.fontcolor"]),
      fontsize: globalOnly$1(["es6.string.fontsize"]),
      forEach: globalOnly$1(["es6.array.for-each"]),
      includes: globalOnly$1(["es6.string.includes", "es7.array.includes"]),
      indexOf: globalOnly$1(["es6.array.index-of"]),
      italics: globalOnly$1(["es6.string.italics"]),
      keys: globalOnly$1(ArrayNatureIterators$3),
      lastIndexOf: globalOnly$1(["es6.array.last-index-of"]),
      link: globalOnly$1(["es6.string.link"]),
      map: globalOnly$1(["es6.array.map"]),
      match: globalOnly$1(["es6.regexp.match"]),
      name: globalOnly$1(["es6.function.name"]),
      padStart: globalOnly$1(["es7.string.pad-start"]),
      padEnd: globalOnly$1(["es7.string.pad-end"]),
      reduce: globalOnly$1(["es6.array.reduce"]),
      reduceRight: globalOnly$1(["es6.array.reduce-right"]),
      repeat: globalOnly$1(["es6.string.repeat"]),
      replace: globalOnly$1(["es6.regexp.replace"]),
      search: globalOnly$1(["es6.regexp.search"]),
      small: globalOnly$1(["es6.string.small"]),
      some: globalOnly$1(["es6.array.some"]),
      sort: globalOnly$1(["es6.array.sort"]),
      split: globalOnly$1(["es6.regexp.split"]),
      startsWith: globalOnly$1(["es6.string.starts-with"]),
      strike: globalOnly$1(["es6.string.strike"]),
      sub: globalOnly$1(["es6.string.sub"]),
      sup: globalOnly$1(["es6.string.sup"]),
      toISOString: globalOnly$1(["es6.date.to-iso-string"]),
      toJSON: globalOnly$1(["es6.date.to-json"]),
      toString: globalOnly$1(["es6.object.to-string", "es6.date.to-string", "es6.regexp.to-string"]),
      trim: globalOnly$1(["es6.string.trim"]),
      trimEnd: globalOnly$1(["es7.string.trim-right"]),
      trimLeft: globalOnly$1(["es7.string.trim-left"]),
      trimRight: globalOnly$1(["es7.string.trim-right"]),
      trimStart: globalOnly$1(["es7.string.trim-left"]),
      values: globalOnly$1(ArrayNatureIterators$3)
    };
    if ("es6.array.slice" in corejs2BuiltIns) {
      InstanceProperties$3.slice = globalOnly$1(["es6.array.slice"]);
    }
    var StaticProperties$3 = {
      Array: {
        from: pureAndGlobal$1("array/from", ["es6.symbol", "es6.array.from"].concat(_toConsumableArray2(CommonIterators$3))),
        isArray: pureAndGlobal$1("array/is-array", ["es6.array.is-array"]),
        of: pureAndGlobal$1("array/of", ["es6.array.of"])
      },
      Date: {
        now: pureAndGlobal$1("date/now", ["es6.date.now"])
      },
      JSON: {
        stringify: pureOnly$1("json/stringify", "es6.symbol")
      },
      Math: {
        acosh: pureAndGlobal$1("math/acosh", ["es6.math.acosh"], "7.0.1"),
        asinh: pureAndGlobal$1("math/asinh", ["es6.math.asinh"], "7.0.1"),
        atanh: pureAndGlobal$1("math/atanh", ["es6.math.atanh"], "7.0.1"),
        cbrt: pureAndGlobal$1("math/cbrt", ["es6.math.cbrt"], "7.0.1"),
        clz32: pureAndGlobal$1("math/clz32", ["es6.math.clz32"], "7.0.1"),
        cosh: pureAndGlobal$1("math/cosh", ["es6.math.cosh"], "7.0.1"),
        expm1: pureAndGlobal$1("math/expm1", ["es6.math.expm1"], "7.0.1"),
        fround: pureAndGlobal$1("math/fround", ["es6.math.fround"], "7.0.1"),
        hypot: pureAndGlobal$1("math/hypot", ["es6.math.hypot"], "7.0.1"),
        imul: pureAndGlobal$1("math/imul", ["es6.math.imul"], "7.0.1"),
        log1p: pureAndGlobal$1("math/log1p", ["es6.math.log1p"], "7.0.1"),
        log10: pureAndGlobal$1("math/log10", ["es6.math.log10"], "7.0.1"),
        log2: pureAndGlobal$1("math/log2", ["es6.math.log2"], "7.0.1"),
        sign: pureAndGlobal$1("math/sign", ["es6.math.sign"], "7.0.1"),
        sinh: pureAndGlobal$1("math/sinh", ["es6.math.sinh"], "7.0.1"),
        tanh: pureAndGlobal$1("math/tanh", ["es6.math.tanh"], "7.0.1"),
        trunc: pureAndGlobal$1("math/trunc", ["es6.math.trunc"], "7.0.1")
      },
      Number: {
        EPSILON: pureAndGlobal$1("number/epsilon", ["es6.number.epsilon"]),
        MIN_SAFE_INTEGER: pureAndGlobal$1("number/min-safe-integer", ["es6.number.min-safe-integer"]),
        MAX_SAFE_INTEGER: pureAndGlobal$1("number/max-safe-integer", ["es6.number.max-safe-integer"]),
        isFinite: pureAndGlobal$1("number/is-finite", ["es6.number.is-finite"]),
        isInteger: pureAndGlobal$1("number/is-integer", ["es6.number.is-integer"]),
        isSafeInteger: pureAndGlobal$1("number/is-safe-integer", ["es6.number.is-safe-integer"]),
        isNaN: pureAndGlobal$1("number/is-nan", ["es6.number.is-nan"]),
        parseFloat: pureAndGlobal$1("number/parse-float", ["es6.number.parse-float"]),
        parseInt: pureAndGlobal$1("number/parse-int", ["es6.number.parse-int"])
      },
      Object: {
        assign: pureAndGlobal$1("object/assign", ["es6.object.assign"]),
        create: pureAndGlobal$1("object/create", ["es6.object.create"]),
        defineProperties: pureAndGlobal$1("object/define-properties", ["es6.object.define-properties"]),
        defineProperty: pureAndGlobal$1("object/define-property", ["es6.object.define-property"]),
        entries: pureAndGlobal$1("object/entries", ["es7.object.entries"]),
        freeze: pureAndGlobal$1("object/freeze", ["es6.object.freeze"]),
        getOwnPropertyDescriptor: pureAndGlobal$1("object/get-own-property-descriptor", ["es6.object.get-own-property-descriptor"]),
        getOwnPropertyDescriptors: pureAndGlobal$1("object/get-own-property-descriptors", ["es7.object.get-own-property-descriptors"]),
        getOwnPropertyNames: pureAndGlobal$1("object/get-own-property-names", ["es6.object.get-own-property-names"]),
        getOwnPropertySymbols: pureAndGlobal$1("object/get-own-property-symbols", ["es6.symbol"]),
        getPrototypeOf: pureAndGlobal$1("object/get-prototype-of", ["es6.object.get-prototype-of"]),
        is: pureAndGlobal$1("object/is", ["es6.object.is"]),
        isExtensible: pureAndGlobal$1("object/is-extensible", ["es6.object.is-extensible"]),
        isFrozen: pureAndGlobal$1("object/is-frozen", ["es6.object.is-frozen"]),
        isSealed: pureAndGlobal$1("object/is-sealed", ["es6.object.is-sealed"]),
        keys: pureAndGlobal$1("object/keys", ["es6.object.keys"]),
        preventExtensions: pureAndGlobal$1("object/prevent-extensions", ["es6.object.prevent-extensions"]),
        seal: pureAndGlobal$1("object/seal", ["es6.object.seal"]),
        setPrototypeOf: pureAndGlobal$1("object/set-prototype-of", ["es6.object.set-prototype-of"]),
        values: pureAndGlobal$1("object/values", ["es7.object.values"])
      },
      Promise: {
        all: globalOnly$1(CommonIterators$3),
        race: globalOnly$1(CommonIterators$3)
      },
      Reflect: {
        apply: pureAndGlobal$1("reflect/apply", ["es6.reflect.apply"]),
        construct: pureAndGlobal$1("reflect/construct", ["es6.reflect.construct"]),
        defineProperty: pureAndGlobal$1("reflect/define-property", ["es6.reflect.define-property"]),
        deleteProperty: pureAndGlobal$1("reflect/delete-property", ["es6.reflect.delete-property"]),
        get: pureAndGlobal$1("reflect/get", ["es6.reflect.get"]),
        getOwnPropertyDescriptor: pureAndGlobal$1("reflect/get-own-property-descriptor", ["es6.reflect.get-own-property-descriptor"]),
        getPrototypeOf: pureAndGlobal$1("reflect/get-prototype-of", ["es6.reflect.get-prototype-of"]),
        has: pureAndGlobal$1("reflect/has", ["es6.reflect.has"]),
        isExtensible: pureAndGlobal$1("reflect/is-extensible", ["es6.reflect.is-extensible"]),
        ownKeys: pureAndGlobal$1("reflect/own-keys", ["es6.reflect.own-keys"]),
        preventExtensions: pureAndGlobal$1("reflect/prevent-extensions", ["es6.reflect.prevent-extensions"]),
        set: pureAndGlobal$1("reflect/set", ["es6.reflect.set"]),
        setPrototypeOf: pureAndGlobal$1("reflect/set-prototype-of", ["es6.reflect.set-prototype-of"])
      },
      String: {
        at: pureOnly$1("string/at", "es7.string.at"),
        fromCodePoint: pureAndGlobal$1("string/from-code-point", ["es6.string.from-code-point"]),
        raw: pureAndGlobal$1("string/raw", ["es6.string.raw"])
      },
      Symbol: {
        asyncIterator: globalOnly$1(["es6.symbol", "es7.symbol.async-iterator"]),
        "for": pureOnly$1("symbol/for", "es6.symbol"),
        hasInstance: pureOnly$1("symbol/has-instance", "es6.symbol"),
        isConcatSpreadable: pureOnly$1("symbol/is-concat-spreadable", "es6.symbol"),
        iterator: define$3("es6.symbol", "symbol/iterator", CommonIterators$3),
        keyFor: pureOnly$1("symbol/key-for", "es6.symbol"),
        match: pureAndGlobal$1("symbol/match", ["es6.regexp.match"]),
        replace: pureOnly$1("symbol/replace", "es6.symbol"),
        search: pureOnly$1("symbol/search", "es6.symbol"),
        species: pureOnly$1("symbol/species", "es6.symbol"),
        split: pureOnly$1("symbol/split", "es6.symbol"),
        toPrimitive: pureOnly$1("symbol/to-primitive", "es6.symbol"),
        toStringTag: pureOnly$1("symbol/to-string-tag", "es6.symbol"),
        unscopables: pureOnly$1("symbol/unscopables", "es6.symbol")
      }
    };
    var webPolyfills$1 = {
      "web.timers": {},
      "web.immediate": {},
      "web.dom.iterable": {}
    };
    var purePolyfills$1 = {
      "es6.parse-float": {},
      "es6.parse-int": {},
      "es7.string.at": {}
    };
    function addPlatformSpecificPolyfills$1(targets, method5, polyfills) {
      var targetNames = Object.keys(targets);
      var isAnyTarget = !targetNames.length;
      var isWebTarget = targetNames.some(function(name2) {
        return name2 !== "node";
      });
      return Object.assign(Object.assign(Object.assign({}, polyfills), method5 === "usage-pure" ? purePolyfills$1 : null), isAnyTarget || isWebTarget ? webPolyfills$1 : null);
    }
    function hasMinVersion$1(minVersion2, runtimeVersion) {
      if (!runtimeVersion || !minVersion2)
        return true;
      if (semver$6.valid(runtimeVersion))
        runtimeVersion = "^" + runtimeVersion;
      return !semver$6.intersects("<" + minVersion2, runtimeVersion) && !semver$6.intersects(">=8.0.0", runtimeVersion);
    }
    var _ref$4 = babel2, t$8 = _ref$4.types;
    var presetEnvCompat$1 = "#__secret_key__@babel/preset-env__compatibility";
    var runtimeCompat$5 = "#__secret_key__@babel/runtime__compatibility";
    var has$5 = Function.call.bind(Object.hasOwnProperty);
    var index$52 = definePolyfillProvider$1(function(api, _ref22) {
      var _ref2$presetEnvCompat = _ref22[presetEnvCompat$1];
      _ref2$presetEnvCompat = _ref2$presetEnvCompat === void 0 ? {} : _ref2$presetEnvCompat;
      var entryInjectRegenerator = _ref2$presetEnvCompat.entryInjectRegenerator, _ref2$runtimeCompat = _ref22[runtimeCompat$5];
      _ref2$runtimeCompat = _ref2$runtimeCompat === void 0 ? {} : _ref2$runtimeCompat;
      var useBabelRuntime = _ref2$runtimeCompat.useBabelRuntime, runtimeVersion = _ref2$runtimeCompat.runtimeVersion, _ref2$runtimeCompat$e = _ref2$runtimeCompat.ext, ext = _ref2$runtimeCompat$e === void 0 ? ".js" : _ref2$runtimeCompat$e;
      var resolve2 = api.createMetaResolver({
        global: BuiltIns$3,
        "static": StaticProperties$3,
        instance: InstanceProperties$3
      });
      var debug2 = api.debug, shouldInjectPolyfill = api.shouldInjectPolyfill, method5 = api.method;
      var polyfills = addPlatformSpecificPolyfills$1(api.targets, method5, corejs2BuiltIns);
      var coreJSBase = useBabelRuntime ? useBabelRuntime + "/core-js" : method5 === "usage-pure" ? "core-js/library/fn" : "core-js/modules";
      function inject(name2, utils3) {
        if (typeof name2 === "string") {
          if (has$5(polyfills, name2) && shouldInjectPolyfill(name2)) {
            debug2(name2);
            utils3.injectGlobalImport(coreJSBase + "/" + name2 + ".js");
          }
          return;
        }
        name2.forEach(function(name3) {
          return inject(name3, utils3);
        });
      }
      function maybeInjectPure(desc, hint, utils3) {
        var pure = desc.pure, meta2 = desc.meta, name2 = desc.name;
        if (!pure || !shouldInjectPolyfill(name2))
          return;
        if (runtimeVersion && meta2 && meta2.minRuntimeVersion && !hasMinVersion$1(meta2 && meta2.minRuntimeVersion, runtimeVersion)) {
          return;
        }
        return utils3.injectDefaultImport(coreJSBase + "/" + pure + ext, hint);
      }
      return {
        name: "corejs2",
        polyfills,
        entryGlobal: function entryGlobal(meta2, utils3, path2) {
          if (meta2.kind === "import" && meta2.source === "core-js") {
            debug2(null);
            inject(Object.keys(polyfills), utils3);
            if (entryInjectRegenerator) {
              utils3.injectGlobalImport("regenerator-runtime/runtime.js");
            }
            path2.remove();
          }
        },
        usageGlobal: function usageGlobal(meta2, utils3) {
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var deps = resolved.desc.global;
          if (resolved.kind !== "global" && meta2.object && meta2.placement === "prototype") {
            var low = meta2.object.toLowerCase();
            deps = deps.filter(function(m2) {
              return m2.includes(low);
            });
          }
          inject(deps, utils3);
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (meta2.kind === "in") {
            if (meta2.key === "Symbol.iterator") {
              path2.replaceWith(t$8.callExpression(utils3.injectDefaultImport(coreJSBase + "/is-iterable" + ext, "isIterable"), [path2.node.right]));
            }
            return;
          }
          if (path2.parentPath.isUnaryExpression({
            operator: "delete"
          }))
            return;
          if (meta2.kind === "property") {
            if (!path2.isMemberExpression())
              return;
            if (!path2.isReferenced())
              return;
            if (meta2.key === "Symbol.iterator" && shouldInjectPolyfill("es6.symbol") && path2.parentPath.isCallExpression({
              callee: path2.node
            }) && path2.parent.arguments.length === 0) {
              path2.parentPath.replaceWith(t$8.callExpression(utils3.injectDefaultImport(coreJSBase + "/get-iterator" + ext, "getIterator"), [path2.node.object]));
              path2.skip();
              return;
            }
          }
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var id3 = maybeInjectPure(resolved.desc, resolved.name, utils3);
          if (id3)
            path2.replaceWith(id3);
        },
        visitor: method5 === "usage-global" && {
          YieldExpression: function YieldExpression2(path2) {
            if (path2.node.delegate) {
              inject("web.dom.iterable", api.getUtils(path2));
            }
          },
          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path2) {
            CommonIterators$3.forEach(function(name2) {
              return inject(name2, api.getUtils(path2));
            });
          }
        }
      };
    });
    var require$$0$3 = {
      "es.symbol": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "51",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.description": {
        android: "70",
        chrome: "70",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "63",
        ios: "12.2",
        node: "11.0",
        opera: "57",
        opera_mobile: "49",
        safari: "12.1",
        samsung: "10.0"
      },
      "es.symbol.async-iterator": {
        android: "63",
        chrome: "63",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "55",
        ios: "12.0",
        node: "10.0",
        opera: "50",
        opera_mobile: "46",
        safari: "12.0",
        samsung: "8.0"
      },
      "es.symbol.has-instance": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "15",
        electron: "1.1",
        firefox: "49",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.is-concat-spreadable": {
        android: "48",
        chrome: "48",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "48",
        ios: "10.0",
        node: "6.0",
        opera: "35",
        opera_mobile: "35",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.iterator": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "36",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.symbol.match": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "74",
        electron: "1.1",
        firefox: "40",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.match-all": {
        android: "73",
        chrome: "73",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "67",
        ios: "13.0",
        node: "12.0",
        opera: "60",
        opera_mobile: "52",
        safari: "13",
        samsung: "11.0"
      },
      "es.symbol.replace": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "74",
        electron: "1.1",
        firefox: "49",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.search": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "74",
        electron: "1.1",
        firefox: "49",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.species": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "41",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.split": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "74",
        electron: "1.1",
        firefox: "49",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.to-primitive": {
        android: "47",
        chrome: "47",
        deno: "1.0",
        edge: "15",
        electron: "0.36",
        firefox: "44",
        ios: "10.0",
        node: "6.0",
        opera: "34",
        opera_mobile: "34",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.to-string-tag": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "51",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.symbol.unscopables": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "48",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.error.cause": {
        android: "94",
        chrome: "94",
        deno: "1.14",
        edge: "94",
        electron: "15.0",
        firefox: "91",
        ios: "15.0",
        node: "16.11",
        opera: "80",
        opera_mobile: "66",
        safari: "15.0",
        samsung: "17.0"
      },
      "es.error.to-string": {
        android: "4.4.3",
        chrome: "33",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "11",
        ie: "9",
        ios: "9.0",
        node: "0.11.13",
        opera: "20",
        opera_mobile: "20",
        rhino: "1.7.14",
        safari: "8.0",
        samsung: "2.0"
      },
      "es.aggregate-error": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "79",
        ios: "14.0",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "14.0",
        samsung: "14.0"
      },
      "es.aggregate-error.cause": {
        android: "94",
        chrome: "94",
        deno: "1.14",
        edge: "94",
        electron: "15.0",
        firefox: "91",
        ios: "15.0",
        node: "16.11",
        opera: "80",
        opera_mobile: "66",
        safari: "15.0",
        samsung: "17.0"
      },
      "es.array.at": {
        android: "92",
        chrome: "92",
        deno: "1.12",
        edge: "92",
        electron: "14.0",
        firefox: "90",
        ios: "15.4",
        node: "16.6",
        opera: "78",
        opera_mobile: "65",
        safari: "15.4",
        samsung: "16.0"
      },
      "es.array.concat": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "48",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.copy-within": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "12",
        electron: "0.31",
        firefox: "48",
        ios: "9.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.every": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.array.fill": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "12",
        electron: "0.31",
        firefox: "48",
        ios: "9.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.filter": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "48",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.find": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "48",
        ios: "9.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.find-index": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "48",
        ios: "9.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.flat": {
        android: "69",
        chrome: "69",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "62",
        ios: "12.0",
        node: "11.0",
        opera: "56",
        opera_mobile: "48",
        safari: "12.0",
        samsung: "10.0"
      },
      "es.array.flat-map": {
        android: "69",
        chrome: "69",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "62",
        ios: "12.0",
        node: "11.0",
        opera: "56",
        opera_mobile: "48",
        safari: "12.0",
        samsung: "10.0"
      },
      "es.array.for-each": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.array.from": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "53",
        ios: "9.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.includes": {
        android: "53",
        chrome: "53",
        deno: "1.0",
        edge: "14",
        electron: "1.4",
        firefox: "48",
        ios: "10.0",
        node: "7.0",
        opera: "40",
        opera_mobile: "40",
        safari: "10.0",
        samsung: "6.0"
      },
      "es.array.index-of": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "12",
        electron: "1.2",
        firefox: "47",
        ie: "9",
        ios: "8.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "5.0"
      },
      "es.array.is-array": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "3.2",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "4.0",
        samsung: "1.0"
      },
      "es.array.iterator": {
        android: "66",
        chrome: "66",
        deno: "1.0",
        edge: "15",
        electron: "3.0",
        firefox: "60",
        ios: "10.0",
        node: "10.0",
        opera: "53",
        opera_mobile: "47",
        safari: "10.0",
        samsung: "9.0"
      },
      "es.array.join": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "4",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.array.last-index-of": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "12",
        electron: "1.2",
        firefox: "47",
        ie: "9",
        ios: "8.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "5.0"
      },
      "es.array.map": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "50",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.of": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "25",
        ios: "9.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.array.reduce": {
        android: "83",
        chrome: "83",
        deno: "1.0",
        edge: "12",
        electron: "9.0",
        firefox: "4",
        ie: "9",
        ios: "8.0",
        node: "6.0",
        opera: "69",
        opera_mobile: "59",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "13.0"
      },
      "es.array.reduce-right": {
        android: "83",
        chrome: "83",
        deno: "1.0",
        edge: "12",
        electron: "9.0",
        firefox: "4",
        ie: "9",
        ios: "8.0",
        node: "6.0",
        opera: "69",
        opera_mobile: "59",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "13.0"
      },
      "es.array.reverse": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "5.5",
        ios: "12.2",
        node: "0.0.3",
        opera: "10.50",
        opera_mobile: "10.50",
        rhino: "1.7.13",
        safari: "12.0.2",
        samsung: "1.0"
      },
      "es.array.slice": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "48",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.some": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.array.sort": {
        android: "70",
        chrome: "70",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "4",
        ios: "12.0",
        node: "11.0",
        opera: "57",
        opera_mobile: "49",
        safari: "12.0",
        samsung: "10.0"
      },
      "es.array.species": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "48",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.splice": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "49",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.array.unscopables.flat": {
        android: "73",
        chrome: "73",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "67",
        ios: "13.0",
        node: "12.0",
        opera: "60",
        opera_mobile: "52",
        safari: "13",
        samsung: "11.0"
      },
      "es.array.unscopables.flat-map": {
        android: "73",
        chrome: "73",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "67",
        ios: "13.0",
        node: "12.0",
        opera: "60",
        opera_mobile: "52",
        safari: "13",
        samsung: "11.0"
      },
      "es.array-buffer.constructor": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "14",
        electron: "0.20",
        firefox: "44",
        ios: "12.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        safari: "12.0",
        samsung: "1.5"
      },
      "es.array-buffer.is-view": {
        android: "4.4.3",
        chrome: "32",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "29",
        ie: "11",
        ios: "8.0",
        node: "0.11.9",
        opera: "19",
        opera_mobile: "19",
        rhino: "1.7.14",
        safari: "7.1",
        samsung: "2.0"
      },
      "es.array-buffer.slice": {
        android: "4.4.3",
        chrome: "31",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "46",
        ie: "11",
        ios: "12.2",
        node: "0.11.8",
        opera: "18",
        opera_mobile: "18",
        rhino: "1.7.13",
        safari: "12.1",
        samsung: "2.0"
      },
      "es.data-view": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "15",
        ie: "10",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.date.get-year": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "9",
        ios: "1.0",
        node: "0.0.3",
        opera: "3",
        opera_mobile: "3",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.date.now": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ie: "9",
        ios: "3.2",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "4.0",
        samsung: "1.0"
      },
      "es.date.set-year": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "3",
        ios: "1.0",
        node: "0.0.3",
        opera: "3",
        opera_mobile: "3",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.date.to-gmt-string": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "3",
        ios: "1.0",
        node: "0.0.3",
        opera: "3",
        opera_mobile: "3",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.date.to-iso-string": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "7",
        ie: "9",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.date.to-json": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "10.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "1.5"
      },
      "es.date.to-primitive": {
        android: "47",
        chrome: "47",
        deno: "1.0",
        edge: "15",
        electron: "0.36",
        firefox: "44",
        ios: "10.0",
        node: "6.0",
        opera: "34",
        opera_mobile: "34",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.date.to-string": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ie: "9",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.escape": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "3",
        ios: "1.0",
        node: "0.0.3",
        opera: "3",
        opera_mobile: "3",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.function.bind": {
        android: "3.0",
        chrome: "7",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "5.1",
        node: "0.1.101",
        opera: "12",
        opera_mobile: "12",
        phantom: "2.0",
        rhino: "1.7.13",
        safari: "5.1",
        samsung: "1.0"
      },
      "es.function.has-instance": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "50",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.function.name": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "3.2",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "4.0",
        samsung: "1.0"
      },
      "es.global-this": {
        android: "71",
        chrome: "71",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "65",
        ios: "12.2",
        node: "12.0",
        opera: "58",
        opera_mobile: "50",
        rhino: "1.7.14",
        safari: "12.1",
        samsung: "10.0"
      },
      "es.json.stringify": {
        android: "72",
        chrome: "72",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "64",
        ios: "12.2",
        node: "12.0",
        opera: "59",
        opera_mobile: "51",
        safari: "12.1",
        samsung: "11.0"
      },
      "es.json.to-string-tag": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "15",
        electron: "1.1",
        firefox: "51",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.map": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "53",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.math.acosh": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "13",
        electron: "1.4",
        firefox: "25",
        ios: "8.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "7.1",
        samsung: "6.0"
      },
      "es.math.asinh": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.atanh": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.cbrt": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.clz32": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "31",
        ios: "9.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.0"
      },
      "es.math.cosh": {
        android: "39",
        chrome: "39",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "1.0",
        opera: "26",
        opera_mobile: "26",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.4"
      },
      "es.math.expm1": {
        android: "39",
        chrome: "39",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "46",
        ios: "8.0",
        node: "1.0",
        opera: "26",
        opera_mobile: "26",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.4"
      },
      "es.math.fround": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "26",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.hypot": {
        android: "78",
        chrome: "78",
        deno: "1.0",
        edge: "12",
        electron: "7.0",
        firefox: "27",
        ios: "8.0",
        node: "13.0",
        opera: "65",
        opera_mobile: "56",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "12.0"
      },
      "es.math.imul": {
        android: "4.4",
        chrome: "28",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "20",
        ios: "9.0",
        node: "0.11.1",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "1.5"
      },
      "es.math.log10": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.log1p": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.log2": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.sign": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "9.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.0"
      },
      "es.math.sinh": {
        android: "39",
        chrome: "39",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "1.0",
        opera: "26",
        opera_mobile: "26",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.4"
      },
      "es.math.tanh": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.math.to-string-tag": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "15",
        electron: "1.1",
        firefox: "51",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.math.trunc": {
        android: "38",
        chrome: "38",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "8.0",
        node: "0.11.15",
        opera: "25",
        opera_mobile: "25",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.number.constructor": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "46",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.number.epsilon": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "25",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.14",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.number.is-finite": {
        android: "4.1",
        chrome: "19",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "16",
        ios: "9.0",
        node: "0.7.3",
        opera: "15",
        opera_mobile: "15",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "1.5"
      },
      "es.number.is-integer": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "16",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.number.is-nan": {
        android: "4.1",
        chrome: "19",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "15",
        ios: "9.0",
        node: "0.7.3",
        opera: "15",
        opera_mobile: "15",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "1.5"
      },
      "es.number.is-safe-integer": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "32",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.number.max-safe-integer": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "31",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.number.min-safe-integer": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "31",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.number.parse-float": {
        android: "37",
        chrome: "35",
        deno: "1.0",
        edge: "74",
        electron: "0.20",
        firefox: "39",
        ios: "11.0",
        node: "0.11.13",
        opera: "22",
        opera_mobile: "22",
        rhino: "1.7.14",
        safari: "11.0",
        samsung: "3.0"
      },
      "es.number.parse-int": {
        android: "37",
        chrome: "35",
        deno: "1.0",
        edge: "74",
        electron: "0.20",
        firefox: "39",
        ios: "9.0",
        node: "0.11.13",
        opera: "22",
        opera_mobile: "22",
        rhino: "1.7.14",
        safari: "9.0",
        samsung: "3.0"
      },
      "es.number.to-exponential": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "18",
        electron: "1.2",
        firefox: "87",
        ios: "11.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.14",
        safari: "11",
        samsung: "5.0"
      },
      "es.number.to-fixed": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "74",
        electron: "0.20",
        firefox: "4",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.number.to-precision": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "8",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.object.assign": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "74",
        electron: "0.37",
        firefox: "36",
        ios: "9.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "9.0",
        samsung: "5.0"
      },
      "es.object.create": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "3.2",
        node: "0.1.27",
        opera: "12",
        opera_mobile: "12",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "4.0",
        samsung: "1.0"
      },
      "es.object.define-getter": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "16",
        electron: "3.0",
        firefox: "48",
        ios: "8.0",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "8.0"
      },
      "es.object.define-properties": {
        android: "37",
        chrome: "37",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "5.1",
        node: "0.11.15",
        opera: "12",
        opera_mobile: "12",
        phantom: "2.0",
        rhino: "1.7.13",
        safari: "5.1",
        samsung: "3.0"
      },
      "es.object.define-property": {
        android: "37",
        chrome: "37",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "4",
        ie: "9",
        ios: "5.1",
        node: "0.11.15",
        opera: "12",
        opera_mobile: "12",
        phantom: "2.0",
        rhino: "1.7.13",
        safari: "5.1",
        samsung: "3.0"
      },
      "es.object.define-setter": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "16",
        electron: "3.0",
        firefox: "48",
        ios: "8.0",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "8.0"
      },
      "es.object.entries": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "14",
        electron: "1.4",
        firefox: "47",
        ios: "10.3",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        rhino: "1.7.14",
        safari: "10.1",
        samsung: "6.0"
      },
      "es.object.freeze": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.from-entries": {
        android: "73",
        chrome: "73",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "63",
        ios: "12.2",
        node: "12.0",
        opera: "60",
        opera_mobile: "52",
        rhino: "1.7.14",
        safari: "12.1",
        samsung: "11.0"
      },
      "es.object.get-own-property-descriptor": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.get-own-property-descriptors": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "50",
        ios: "10.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "10.0",
        samsung: "6.0"
      },
      "es.object.get-own-property-names": {
        android: "40",
        chrome: "40",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "34",
        ios: "9.0",
        node: "1.0",
        opera: "27",
        opera_mobile: "27",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.object.get-prototype-of": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.has-own": {
        android: "93",
        chrome: "93",
        deno: "1.13",
        edge: "93",
        electron: "14.0",
        firefox: "92",
        ios: "15.4",
        node: "16.9",
        opera: "79",
        opera_mobile: "66",
        safari: "15.4",
        samsung: "17.0"
      },
      "es.object.is": {
        android: "4.1",
        chrome: "19",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "22",
        ios: "9.0",
        node: "0.7.3",
        opera: "15",
        opera_mobile: "15",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "1.5"
      },
      "es.object.is-extensible": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.is-frozen": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.is-sealed": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.keys": {
        android: "40",
        chrome: "40",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "35",
        ios: "9.0",
        node: "1.0",
        opera: "27",
        opera_mobile: "27",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.object.lookup-getter": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "16",
        electron: "3.0",
        firefox: "48",
        ios: "8.0",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "8.0"
      },
      "es.object.lookup-setter": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "16",
        electron: "3.0",
        firefox: "48",
        ios: "8.0",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "8.0"
      },
      "es.object.prevent-extensions": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.seal": {
        android: "44",
        chrome: "44",
        deno: "1.0",
        edge: "13",
        electron: "0.30",
        firefox: "35",
        ios: "9.0",
        node: "3.0",
        opera: "31",
        opera_mobile: "31",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "4.0"
      },
      "es.object.set-prototype-of": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "31",
        ie: "11",
        ios: "9.0",
        node: "0.11.13",
        opera: "21",
        opera_mobile: "21",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "2.0"
      },
      "es.object.to-string": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "51",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.object.values": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "14",
        electron: "1.4",
        firefox: "47",
        ios: "10.3",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        rhino: "1.7.14",
        safari: "10.1",
        samsung: "6.0"
      },
      "es.parse-float": {
        android: "37",
        chrome: "35",
        deno: "1.0",
        edge: "74",
        electron: "0.20",
        firefox: "8",
        ie: "8",
        ios: "8.0",
        node: "0.11.13",
        opera: "22",
        opera_mobile: "22",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.parse-int": {
        android: "37",
        chrome: "35",
        deno: "1.0",
        edge: "74",
        electron: "0.20",
        firefox: "21",
        ie: "9",
        ios: "8.0",
        node: "0.11.13",
        opera: "22",
        opera_mobile: "22",
        rhino: "1.7.13",
        safari: "7.1",
        samsung: "3.0"
      },
      "es.promise": {
        android: "67",
        chrome: "67",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "69",
        ios: "11.0",
        node: "10.4",
        opera: "54",
        opera_mobile: "48",
        safari: "11.0",
        samsung: "9.0"
      },
      "es.promise.all-settled": {
        android: "76",
        chrome: "76",
        deno: "1.0",
        edge: "76",
        electron: "6.0",
        firefox: "71",
        ios: "13.0",
        node: "12.9",
        opera: "63",
        opera_mobile: "54",
        safari: "13",
        samsung: "12.0"
      },
      "es.promise.any": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "79",
        ios: "14.0",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "14.0",
        samsung: "14.0"
      },
      "es.promise.finally": {
        android: "67",
        chrome: "67",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "69",
        ios: "13.2.3",
        node: "10.4",
        opera: "54",
        opera_mobile: "48",
        safari: "13.0.3",
        samsung: "9.0"
      },
      "es.reflect.apply": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.construct": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "15",
        electron: "0.37",
        firefox: "44",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.define-property": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "13",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.delete-property": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.get": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.get-own-property-descriptor": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.get-prototype-of": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.has": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.is-extensible": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.own-keys": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.prevent-extensions": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.set": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "74",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.set-prototype-of": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "12",
        electron: "0.37",
        firefox: "42",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.reflect.to-string-tag": {
        android: "86",
        chrome: "86",
        deno: "1.3",
        edge: "86",
        electron: "11.0",
        firefox: "82",
        ios: "14.0",
        node: "15.0",
        opera: "72",
        opera_mobile: "61",
        safari: "14.0",
        samsung: "14.0"
      },
      "es.regexp.constructor": {
        android: "64",
        chrome: "64",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "78",
        ios: "11.3",
        node: "10.0",
        opera: "51",
        opera_mobile: "47",
        safari: "11.1",
        samsung: "9.0"
      },
      "es.regexp.dot-all": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "78",
        ios: "11.3",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        safari: "11.1",
        samsung: "8.0"
      },
      "es.regexp.exec": {
        android: "64",
        chrome: "64",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "78",
        ios: "11.3",
        node: "10.0",
        opera: "51",
        opera_mobile: "47",
        safari: "11.1",
        samsung: "9.0"
      },
      "es.regexp.flags": {
        android: "62",
        chrome: "62",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "78",
        ios: "11.3",
        node: "8.10",
        opera: "49",
        opera_mobile: "46",
        safari: "11.1",
        samsung: "8.0"
      },
      "es.regexp.sticky": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "13",
        electron: "0.37",
        firefox: "3",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.regexp.test": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "46",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.regexp.to-string": {
        android: "50",
        chrome: "50",
        deno: "1.0",
        edge: "74",
        electron: "1.1",
        firefox: "46",
        ios: "10.0",
        node: "6.0",
        opera: "37",
        opera_mobile: "37",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.set": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "53",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.at-alternative": {
        android: "92",
        chrome: "92",
        deno: "1.12",
        edge: "92",
        electron: "14.0",
        firefox: "90",
        ios: "15.4",
        node: "16.6",
        opera: "78",
        opera_mobile: "65",
        safari: "15.4",
        samsung: "16.0"
      },
      "es.string.code-point-at": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "29",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.string.ends-with": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "40",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.from-code-point": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "29",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.string.includes": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "40",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.iterator": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "36",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.string.match": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "49",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.match-all": {
        android: "80",
        chrome: "80",
        deno: "1.0",
        edge: "80",
        electron: "8.0",
        firefox: "73",
        ios: "13.4",
        node: "14.0",
        opera: "67",
        opera_mobile: "57",
        safari: "13.1",
        samsung: "13.0"
      },
      "es.string.pad-end": {
        android: "57",
        chrome: "57",
        deno: "1.0",
        edge: "15",
        electron: "1.7",
        firefox: "48",
        ios: "11.0",
        node: "8.0",
        opera: "44",
        opera_mobile: "43",
        rhino: "1.7.13",
        safari: "11.0",
        samsung: "7.0"
      },
      "es.string.pad-start": {
        android: "57",
        chrome: "57",
        deno: "1.0",
        edge: "15",
        electron: "1.7",
        firefox: "48",
        ios: "11.0",
        node: "8.0",
        opera: "44",
        opera_mobile: "43",
        rhino: "1.7.13",
        safari: "11.0",
        samsung: "7.0"
      },
      "es.string.raw": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "34",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.14",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.string.repeat": {
        android: "41",
        chrome: "41",
        deno: "1.0",
        edge: "13",
        electron: "0.21",
        firefox: "24",
        ios: "9.0",
        node: "1.0",
        opera: "28",
        opera_mobile: "28",
        rhino: "1.7.13",
        safari: "9.0",
        samsung: "3.4"
      },
      "es.string.replace": {
        android: "64",
        chrome: "64",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "78",
        ios: "14.0",
        node: "10.0",
        opera: "51",
        opera_mobile: "47",
        safari: "14.0",
        samsung: "9.0"
      },
      "es.string.replace-all": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "77",
        ios: "13.4",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "13.1",
        samsung: "14.0"
      },
      "es.string.search": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "49",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.split": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "74",
        electron: "1.4",
        firefox: "49",
        ios: "10.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "10.0",
        samsung: "6.0"
      },
      "es.string.starts-with": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "74",
        electron: "1.2",
        firefox: "40",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.string.substr": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "9",
        ios: "1.0",
        node: "0.0.3",
        opera: "4",
        opera_mobile: "4",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.string.trim": {
        android: "59",
        chrome: "59",
        deno: "1.0",
        edge: "15",
        electron: "1.8",
        firefox: "52",
        ios: "12.2",
        node: "8.3",
        opera: "46",
        opera_mobile: "43",
        rhino: "1.7.13",
        safari: "12.1",
        samsung: "7.0"
      },
      "es.string.trim-end": {
        android: "66",
        chrome: "66",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "61",
        ios: "12.2",
        node: "10.0",
        opera: "53",
        opera_mobile: "47",
        safari: "12.1",
        samsung: "9.0"
      },
      "es.string.trim-start": {
        android: "66",
        chrome: "66",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "61",
        ios: "12.0",
        node: "10.0",
        opera: "53",
        opera_mobile: "47",
        safari: "12.0",
        samsung: "9.0"
      },
      "es.string.anchor": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "17",
        ios: "6.0",
        node: "0.1.27",
        opera: "15",
        opera_mobile: "15",
        phantom: "2.0",
        rhino: "1.7.14",
        safari: "6.0",
        samsung: "1.0"
      },
      "es.string.big": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.blink": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.bold": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.fixed": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.fontcolor": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "17",
        ios: "6.0",
        node: "0.1.27",
        opera: "15",
        opera_mobile: "15",
        phantom: "2.0",
        rhino: "1.7.14",
        safari: "6.0",
        samsung: "1.0"
      },
      "es.string.fontsize": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "17",
        ios: "6.0",
        node: "0.1.27",
        opera: "15",
        opera_mobile: "15",
        phantom: "2.0",
        rhino: "1.7.14",
        safari: "6.0",
        samsung: "1.0"
      },
      "es.string.italics": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.link": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "17",
        ios: "6.0",
        node: "0.1.27",
        opera: "15",
        opera_mobile: "15",
        phantom: "2.0",
        rhino: "1.7.14",
        safari: "6.0",
        samsung: "1.0"
      },
      "es.string.small": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.strike": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.sub": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.string.sup": {
        android: "3.0",
        chrome: "5",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "2",
        ios: "2.0",
        node: "0.1.27",
        opera: "10.50",
        opera_mobile: "10.50",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "3.1",
        samsung: "1.0"
      },
      "es.typed-array.float32-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.float64-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.int8-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.int16-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.int32-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.uint8-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.uint8-clamped-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.uint16-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.uint32-array": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.at": {
        android: "92",
        chrome: "92",
        deno: "1.12",
        edge: "92",
        electron: "14.0",
        firefox: "90",
        ios: "15.4",
        node: "16.6",
        opera: "78",
        opera_mobile: "65",
        safari: "15.4",
        samsung: "16.0"
      },
      "es.typed-array.copy-within": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "34",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.every": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.fill": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.filter": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "38",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.find": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.find-index": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.for-each": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "38",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.from": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.includes": {
        android: "49",
        chrome: "49",
        deno: "1.0",
        edge: "14",
        electron: "0.37",
        firefox: "43",
        ios: "10.0",
        node: "6.0",
        opera: "36",
        opera_mobile: "36",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.index-of": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.iterator": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "37",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.join": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.last-index-of": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.map": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "38",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.of": {
        android: "54",
        chrome: "54",
        deno: "1.0",
        edge: "15",
        electron: "1.4",
        firefox: "55",
        ios: "14.0",
        node: "7.0",
        opera: "41",
        opera_mobile: "41",
        safari: "14.0",
        samsung: "6.0"
      },
      "es.typed-array.reduce": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.reduce-right": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.reverse": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.set": {
        android: "95",
        chrome: "95",
        deno: "1.15",
        edge: "95",
        electron: "16.0",
        firefox: "54",
        ios: "14.5",
        node: "17.0",
        opera: "81",
        opera_mobile: "67",
        safari: "14.1",
        samsung: "17.0"
      },
      "es.typed-array.slice": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "38",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.some": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "13",
        electron: "0.31",
        firefox: "37",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.sort": {
        android: "74",
        chrome: "74",
        deno: "1.0",
        edge: "74",
        electron: "6.0",
        firefox: "67",
        ios: "14.5",
        node: "12.0",
        opera: "61",
        opera_mobile: "53",
        safari: "14.1",
        samsung: "11.0"
      },
      "es.typed-array.subarray": {
        android: "4.4",
        chrome: "26",
        deno: "1.0",
        edge: "13",
        electron: "0.20",
        firefox: "15",
        ios: "8.0",
        node: "0.11.0",
        opera: "16",
        opera_mobile: "16",
        rhino: "1.7.14",
        safari: "7.1",
        samsung: "1.5"
      },
      "es.typed-array.to-locale-string": {
        android: "45",
        chrome: "45",
        deno: "1.0",
        edge: "74",
        electron: "0.31",
        firefox: "51",
        ios: "10.0",
        node: "4.0",
        opera: "32",
        opera_mobile: "32",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.typed-array.to-string": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "13",
        electron: "1.2",
        firefox: "51",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.unescape": {
        android: "3.0",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "3",
        ios: "1.0",
        node: "0.0.3",
        opera: "3",
        opera_mobile: "3",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1",
        samsung: "1.0"
      },
      "es.weak-map": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "53",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "es.weak-set": {
        android: "51",
        chrome: "51",
        deno: "1.0",
        edge: "15",
        electron: "1.2",
        firefox: "53",
        ios: "10.0",
        node: "6.5",
        opera: "38",
        opera_mobile: "38",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "5.0"
      },
      "esnext.aggregate-error": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "79",
        ios: "14.0",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "14.0",
        samsung: "14.0"
      },
      "esnext.array.from-async": {},
      "esnext.array.at": {
        android: "92",
        chrome: "92",
        deno: "1.12",
        edge: "92",
        electron: "14.0",
        firefox: "90",
        ios: "15.4",
        node: "16.6",
        opera: "78",
        opera_mobile: "65",
        safari: "15.4",
        samsung: "16.0"
      },
      "esnext.array.filter-out": {},
      "esnext.array.filter-reject": {},
      "esnext.array.find-last": {
        android: "97",
        chrome: "97",
        deno: "1.16",
        edge: "97",
        electron: "17.0",
        ios: "15.4",
        node: "18.0",
        opera: "83",
        opera_mobile: "68",
        safari: "15.4"
      },
      "esnext.array.find-last-index": {
        android: "97",
        chrome: "97",
        deno: "1.16",
        edge: "97",
        electron: "17.0",
        ios: "15.4",
        node: "18.0",
        opera: "83",
        opera_mobile: "68",
        safari: "15.4"
      },
      "esnext.array.group-by": {},
      "esnext.array.group-by-to-map": {},
      "esnext.array.is-template-object": {},
      "esnext.array.last-index": {},
      "esnext.array.last-item": {},
      "esnext.array.to-reversed": {},
      "esnext.array.to-sorted": {},
      "esnext.array.to-spliced": {},
      "esnext.array.unique-by": {},
      "esnext.array.with": {},
      "esnext.async-iterator.constructor": {},
      "esnext.async-iterator.as-indexed-pairs": {},
      "esnext.async-iterator.drop": {},
      "esnext.async-iterator.every": {},
      "esnext.async-iterator.filter": {},
      "esnext.async-iterator.find": {},
      "esnext.async-iterator.flat-map": {},
      "esnext.async-iterator.for-each": {},
      "esnext.async-iterator.from": {},
      "esnext.async-iterator.map": {},
      "esnext.async-iterator.reduce": {},
      "esnext.async-iterator.some": {},
      "esnext.async-iterator.take": {},
      "esnext.async-iterator.to-array": {},
      "esnext.bigint.range": {},
      "esnext.composite-key": {},
      "esnext.composite-symbol": {},
      "esnext.function.is-callable": {},
      "esnext.function.is-constructor": {},
      "esnext.function.un-this": {},
      "esnext.global-this": {
        android: "71",
        chrome: "71",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "65",
        ios: "12.2",
        node: "12.0",
        opera: "58",
        opera_mobile: "50",
        rhino: "1.7.14",
        safari: "12.1",
        samsung: "10.0"
      },
      "esnext.iterator.constructor": {},
      "esnext.iterator.as-indexed-pairs": {},
      "esnext.iterator.drop": {},
      "esnext.iterator.every": {},
      "esnext.iterator.filter": {},
      "esnext.iterator.find": {},
      "esnext.iterator.flat-map": {},
      "esnext.iterator.for-each": {},
      "esnext.iterator.from": {},
      "esnext.iterator.map": {},
      "esnext.iterator.reduce": {},
      "esnext.iterator.some": {},
      "esnext.iterator.take": {},
      "esnext.iterator.to-array": {},
      "esnext.iterator.to-async": {},
      "esnext.map.delete-all": {},
      "esnext.map.emplace": {},
      "esnext.map.every": {},
      "esnext.map.filter": {},
      "esnext.map.find": {},
      "esnext.map.find-key": {},
      "esnext.map.from": {},
      "esnext.map.group-by": {},
      "esnext.map.includes": {},
      "esnext.map.key-by": {},
      "esnext.map.key-of": {},
      "esnext.map.map-keys": {},
      "esnext.map.map-values": {},
      "esnext.map.merge": {},
      "esnext.map.of": {},
      "esnext.map.reduce": {},
      "esnext.map.some": {},
      "esnext.map.update": {},
      "esnext.map.update-or-insert": {},
      "esnext.map.upsert": {},
      "esnext.math.clamp": {},
      "esnext.math.deg-per-rad": {},
      "esnext.math.degrees": {},
      "esnext.math.fscale": {},
      "esnext.math.iaddh": {},
      "esnext.math.imulh": {},
      "esnext.math.isubh": {},
      "esnext.math.rad-per-deg": {},
      "esnext.math.radians": {},
      "esnext.math.scale": {},
      "esnext.math.seeded-prng": {},
      "esnext.math.signbit": {},
      "esnext.math.umulh": {},
      "esnext.number.from-string": {},
      "esnext.number.range": {},
      "esnext.object.has-own": {
        android: "93",
        chrome: "93",
        deno: "1.13",
        edge: "93",
        electron: "14.0",
        firefox: "92",
        ios: "15.4",
        node: "16.9",
        opera: "79",
        opera_mobile: "66",
        safari: "15.4",
        samsung: "17.0"
      },
      "esnext.object.iterate-entries": {},
      "esnext.object.iterate-keys": {},
      "esnext.object.iterate-values": {},
      "esnext.observable": {},
      "esnext.promise.all-settled": {
        android: "76",
        chrome: "76",
        deno: "1.0",
        edge: "76",
        electron: "6.0",
        firefox: "71",
        ios: "13.0",
        node: "12.9",
        opera: "63",
        opera_mobile: "54",
        safari: "13",
        samsung: "12.0"
      },
      "esnext.promise.any": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "79",
        ios: "14.0",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "14.0",
        samsung: "14.0"
      },
      "esnext.promise.try": {},
      "esnext.reflect.define-metadata": {},
      "esnext.reflect.delete-metadata": {},
      "esnext.reflect.get-metadata": {},
      "esnext.reflect.get-metadata-keys": {},
      "esnext.reflect.get-own-metadata": {},
      "esnext.reflect.get-own-metadata-keys": {},
      "esnext.reflect.has-metadata": {},
      "esnext.reflect.has-own-metadata": {},
      "esnext.reflect.metadata": {},
      "esnext.set.add-all": {},
      "esnext.set.delete-all": {},
      "esnext.set.difference": {},
      "esnext.set.every": {},
      "esnext.set.filter": {},
      "esnext.set.find": {},
      "esnext.set.from": {},
      "esnext.set.intersection": {},
      "esnext.set.is-disjoint-from": {},
      "esnext.set.is-subset-of": {},
      "esnext.set.is-superset-of": {},
      "esnext.set.join": {},
      "esnext.set.map": {},
      "esnext.set.of": {},
      "esnext.set.reduce": {},
      "esnext.set.some": {},
      "esnext.set.symmetric-difference": {},
      "esnext.set.union": {},
      "esnext.string.at": {},
      "esnext.string.cooked": {},
      "esnext.string.code-points": {},
      "esnext.string.match-all": {
        android: "80",
        chrome: "80",
        deno: "1.0",
        edge: "80",
        electron: "8.0",
        firefox: "73",
        ios: "13.4",
        node: "14.0",
        opera: "67",
        opera_mobile: "57",
        safari: "13.1",
        samsung: "13.0"
      },
      "esnext.string.replace-all": {
        android: "85",
        chrome: "85",
        deno: "1.2",
        edge: "85",
        electron: "10.0",
        firefox: "77",
        ios: "13.4",
        node: "15.0",
        opera: "71",
        opera_mobile: "60",
        safari: "13.1",
        samsung: "14.0"
      },
      "esnext.symbol.async-dispose": {},
      "esnext.symbol.dispose": {},
      "esnext.symbol.matcher": {},
      "esnext.symbol.metadata": {},
      "esnext.symbol.observable": {},
      "esnext.symbol.pattern-match": {},
      "esnext.symbol.replace-all": {},
      "esnext.typed-array.from-async": {},
      "esnext.typed-array.at": {
        android: "92",
        chrome: "92",
        deno: "1.12",
        edge: "92",
        electron: "14.0",
        firefox: "90",
        ios: "15.4",
        node: "16.6",
        opera: "78",
        opera_mobile: "65",
        safari: "15.4",
        samsung: "16.0"
      },
      "esnext.typed-array.filter-out": {},
      "esnext.typed-array.filter-reject": {},
      "esnext.typed-array.find-last": {
        android: "97",
        chrome: "97",
        deno: "1.16",
        edge: "97",
        electron: "17.0",
        ios: "15.4",
        node: "18.0",
        opera: "83",
        opera_mobile: "68",
        safari: "15.4"
      },
      "esnext.typed-array.find-last-index": {
        android: "97",
        chrome: "97",
        deno: "1.16",
        edge: "97",
        electron: "17.0",
        ios: "15.4",
        node: "18.0",
        opera: "83",
        opera_mobile: "68",
        safari: "15.4"
      },
      "esnext.typed-array.group-by": {},
      "esnext.typed-array.to-reversed": {},
      "esnext.typed-array.to-sorted": {},
      "esnext.typed-array.to-spliced": {},
      "esnext.typed-array.unique-by": {},
      "esnext.typed-array.with": {},
      "esnext.weak-map.delete-all": {},
      "esnext.weak-map.from": {},
      "esnext.weak-map.of": {},
      "esnext.weak-map.emplace": {},
      "esnext.weak-map.upsert": {},
      "esnext.weak-set.add-all": {},
      "esnext.weak-set.delete-all": {},
      "esnext.weak-set.from": {},
      "esnext.weak-set.of": {},
      "web.atob": {
        android: "37",
        chrome: "34",
        deno: "1.0",
        edge: "16",
        electron: "0.20",
        firefox: "27",
        ios: "10.3",
        node: "18.0",
        opera: "10.5",
        opera_mobile: "10.5",
        safari: "10.1",
        samsung: "2.0"
      },
      "web.btoa": {
        android: "3.0",
        chrome: "4",
        deno: "1.0",
        edge: "16",
        electron: "0.20",
        firefox: "27",
        ios: "1.0",
        node: "17.5",
        opera: "10.5",
        opera_mobile: "10.5",
        phantom: "1.9",
        safari: "3.0",
        samsung: "1.0"
      },
      "web.dom-collections.for-each": {
        android: "58",
        chrome: "58",
        deno: "1.0",
        edge: "16",
        electron: "1.7",
        firefox: "50",
        ios: "10.0",
        node: "0.0.1",
        opera: "45",
        opera_mobile: "43",
        rhino: "1.7.13",
        safari: "10.0",
        samsung: "7.0"
      },
      "web.dom-collections.iterator": {
        android: "66",
        chrome: "66",
        deno: "1.0",
        edge: "74",
        electron: "3.0",
        firefox: "60",
        ios: "13.4",
        node: "0.0.1",
        opera: "53",
        opera_mobile: "47",
        rhino: "1.7.13",
        safari: "13.1",
        samsung: "9.0"
      },
      "web.dom-exception.constructor": {
        android: "46",
        chrome: "46",
        deno: "1.7",
        edge: "74",
        electron: "0.36",
        firefox: "37",
        ios: "11.3",
        node: "17.0",
        opera: "33",
        opera_mobile: "33",
        safari: "11.1",
        samsung: "5.0"
      },
      "web.dom-exception.stack": {
        deno: "1.15",
        firefox: "37",
        node: "17.0"
      },
      "web.dom-exception.to-string-tag": {
        android: "49",
        chrome: "49",
        deno: "1.7",
        edge: "74",
        electron: "0.37",
        firefox: "51",
        ios: "11.3",
        node: "17.0",
        opera: "36",
        opera_mobile: "36",
        safari: "11.1",
        samsung: "5.0"
      },
      "web.immediate": {
        ie: "10",
        node: "0.9.1"
      },
      "web.queue-microtask": {
        android: "71",
        chrome: "71",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "69",
        ios: "12.2",
        node: "12.0",
        opera: "58",
        opera_mobile: "50",
        safari: "12.1",
        samsung: "10.0"
      },
      "web.structured-clone": {},
      "web.timers": {
        android: "1.5",
        chrome: "1",
        deno: "1.0",
        edge: "12",
        electron: "0.20",
        firefox: "1",
        ie: "10",
        ios: "1.0",
        node: "0.0.1",
        opera: "7",
        opera_mobile: "7",
        phantom: "1.9",
        rhino: "1.7.13",
        safari: "1.0",
        samsung: "1.0"
      },
      "web.url": {
        android: "67",
        chrome: "67",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "57",
        ios: "14.0",
        node: "10.0",
        opera: "54",
        opera_mobile: "48",
        safari: "14.0",
        samsung: "9.0"
      },
      "web.url.to-json": {
        android: "71",
        chrome: "71",
        deno: "1.0",
        edge: "74",
        electron: "5.0",
        firefox: "57",
        ios: "14.0",
        node: "10.0",
        opera: "58",
        opera_mobile: "50",
        safari: "14.0",
        samsung: "10.0"
      },
      "web.url-search-params": {
        android: "67",
        chrome: "67",
        deno: "1.0",
        edge: "74",
        electron: "4.0",
        firefox: "57",
        ios: "14.0",
        node: "10.0",
        opera: "54",
        opera_mobile: "48",
        safari: "14.0",
        samsung: "9.0"
      }
    };
    var data$1 = require$$0$3;
    var debug$1 = typeof browser$1$1 === "object" && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG) ? function() {
      var _console;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return (_console = console).error.apply(_console, ["SEMVER"].concat(args));
    } : function() {
    };
    var debug_1 = debug$1;
    var SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH$2 = 256;
    var MAX_SAFE_INTEGER$12 = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var constants = {
      SEMVER_SPEC_VERSION,
      MAX_LENGTH: MAX_LENGTH$2,
      MAX_SAFE_INTEGER: MAX_SAFE_INTEGER$12,
      MAX_SAFE_COMPONENT_LENGTH
    };
    var re$3 = { exports: {} };
    (function(module2, exports3) {
      var MAX_SAFE_COMPONENT_LENGTH2 = constants.MAX_SAFE_COMPONENT_LENGTH;
      var debug2 = debug_1;
      exports3 = module2.exports = {};
      var re3 = exports3.re = [];
      var src2 = exports3.src = [];
      var t3 = exports3.t = {};
      var R2 = 0;
      var createToken2 = function createToken3(name2, value, isGlobal) {
        var index3 = R2++;
        debug2(index3, value);
        t3[name2] = index3;
        src2[index3] = value;
        re3[index3] = new RegExp(value, isGlobal ? "g" : void 0);
      };
      createToken2("NUMERICIDENTIFIER", "0|[1-9]\\d*");
      createToken2("NUMERICIDENTIFIERLOOSE", "[0-9]+");
      createToken2("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
      createToken2("MAINVERSION", "(" + src2[t3.NUMERICIDENTIFIER] + ")\\." + ("(" + src2[t3.NUMERICIDENTIFIER] + ")\\.") + ("(" + src2[t3.NUMERICIDENTIFIER] + ")"));
      createToken2("MAINVERSIONLOOSE", "(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\." + ("(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.") + ("(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")"));
      createToken2("PRERELEASEIDENTIFIER", "(?:" + src2[t3.NUMERICIDENTIFIER] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")");
      createToken2("PRERELEASEIDENTIFIERLOOSE", "(?:" + src2[t3.NUMERICIDENTIFIERLOOSE] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")");
      createToken2("PRERELEASE", "(?:-(" + src2[t3.PRERELEASEIDENTIFIER] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIER] + ")*))");
      createToken2("PRERELEASELOOSE", "(?:-?(" + src2[t3.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIERLOOSE] + ")*))");
      createToken2("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
      createToken2("BUILD", "(?:\\+(" + src2[t3.BUILDIDENTIFIER] + "(?:\\." + src2[t3.BUILDIDENTIFIER] + ")*))");
      createToken2("FULLPLAIN", "v?" + src2[t3.MAINVERSION] + src2[t3.PRERELEASE] + "?" + src2[t3.BUILD] + "?");
      createToken2("FULL", "^" + src2[t3.FULLPLAIN] + "$");
      createToken2("LOOSEPLAIN", "[v=\\s]*" + src2[t3.MAINVERSIONLOOSE] + src2[t3.PRERELEASELOOSE] + "?" + src2[t3.BUILD] + "?");
      createToken2("LOOSE", "^" + src2[t3.LOOSEPLAIN] + "$");
      createToken2("GTLT", "((?:<|>)?=?)");
      createToken2("XRANGEIDENTIFIERLOOSE", src2[t3.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*");
      createToken2("XRANGEIDENTIFIER", src2[t3.NUMERICIDENTIFIER] + "|x|X|\\*");
      createToken2("XRANGEPLAIN", "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIER] + ")" + ("(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")") + ("(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")") + ("(?:" + src2[t3.PRERELEASE] + ")?" + src2[t3.BUILD] + "?") + ")?)?");
      createToken2("XRANGEPLAINLOOSE", "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")" + ("(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")") + ("(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")") + ("(?:" + src2[t3.PRERELEASELOOSE] + ")?" + src2[t3.BUILD] + "?") + ")?)?");
      createToken2("XRANGE", "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAIN] + "$");
      createToken2("XRANGELOOSE", "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAINLOOSE] + "$");
      createToken2("COERCE", "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "})" + ("(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?") + ("(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?") + "(?:$|[^\\d])");
      createToken2("COERCERTL", src2[t3.COERCE], true);
      createToken2("LONETILDE", "(?:~>?)");
      createToken2("TILDETRIM", "(\\s*)" + src2[t3.LONETILDE] + "\\s+", true);
      exports3.tildeTrimReplace = "$1~";
      createToken2("TILDE", "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAIN] + "$");
      createToken2("TILDELOOSE", "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAINLOOSE] + "$");
      createToken2("LONECARET", "(?:\\^)");
      createToken2("CARETTRIM", "(\\s*)" + src2[t3.LONECARET] + "\\s+", true);
      exports3.caretTrimReplace = "$1^";
      createToken2("CARET", "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAIN] + "$");
      createToken2("CARETLOOSE", "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAINLOOSE] + "$");
      createToken2("COMPARATORLOOSE", "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + ")$|^$");
      createToken2("COMPARATOR", "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.FULLPLAIN] + ")$|^$");
      createToken2("COMPARATORTRIM", "(\\s*)" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + "|" + src2[t3.XRANGEPLAIN] + ")", true);
      exports3.comparatorTrimReplace = "$1$2$3";
      createToken2("HYPHENRANGE", "^\\s*(" + src2[t3.XRANGEPLAIN] + ")\\s+-\\s+" + ("(" + src2[t3.XRANGEPLAIN] + ")") + "\\s*$");
      createToken2("HYPHENRANGELOOSE", "^\\s*(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s+-\\s+" + ("(" + src2[t3.XRANGEPLAINLOOSE] + ")") + "\\s*$");
      createToken2("STAR", "(<|>)?=?\\s*\\*");
    })(re$3, re$3.exports);
    var numeric = /^[0-9]+$/;
    var compareIdentifiers$1 = function compareIdentifiers2(a, b2) {
      var anum = numeric.test(a);
      var bnum = numeric.test(b2);
      if (anum && bnum) {
        a = +a;
        b2 = +b2;
      }
      return a === b2 ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b2 ? -1 : 1;
    };
    var rcompareIdentifiers = function rcompareIdentifiers2(a, b2) {
      return compareIdentifiers$1(b2, a);
    };
    var identifiers = {
      compareIdentifiers: compareIdentifiers$1,
      rcompareIdentifiers
    };
    var debug = debug_1;
    var MAX_LENGTH$1 = constants.MAX_LENGTH, MAX_SAFE_INTEGER2 = constants.MAX_SAFE_INTEGER;
    var re$2 = re$3.exports.re, t$7 = re$3.exports.t;
    var compareIdentifiers = identifiers.compareIdentifiers;
    var SemVer$3 = function() {
      function SemVer2(version3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (version3 instanceof SemVer2) {
          if (version3.loose === !!options.loose && version3.includePrerelease === !!options.includePrerelease) {
            return version3;
          } else {
            version3 = version3.version;
          }
        } else if (typeof version3 !== "string") {
          throw new TypeError("Invalid Version: " + version3);
        }
        if (version3.length > MAX_LENGTH$1) {
          throw new TypeError("version is longer than " + MAX_LENGTH$1 + " characters");
        }
        debug("SemVer", version3, options);
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        var m2 = version3.trim().match(options.loose ? re$2[t$7.LOOSE] : re$2[t$7.FULL]);
        if (!m2) {
          throw new TypeError("Invalid Version: " + version3);
        }
        this.raw = version3;
        this.major = +m2[1];
        this.minor = +m2[2];
        this.patch = +m2[3];
        if (this.major > MAX_SAFE_INTEGER2 || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER2 || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER2 || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m2[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m2[4].split(".").map(function(id3) {
            if (/^[0-9]+$/.test(id3)) {
              var num = +id3;
              if (num >= 0 && num < MAX_SAFE_INTEGER2) {
                return num;
              }
            }
            return id3;
          });
        }
        this.build = m2[5] ? m2[5].split(".") : [];
        this.format();
      }
      var _proto = SemVer2.prototype;
      _proto.format = function format2() {
        this.version = this.major + "." + this.minor + "." + this.patch;
        if (this.prerelease.length) {
          this.version += "-" + this.prerelease.join(".");
        }
        return this.version;
      };
      _proto.toString = function toString3() {
        return this.version;
      };
      _proto.compare = function compare3(other) {
        debug("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof SemVer2)) {
          if (typeof other === "string" && other === this.version) {
            return 0;
          }
          other = new SemVer2(other, this.options);
        }
        if (other.version === this.version) {
          return 0;
        }
        return this.compareMain(other) || this.comparePre(other);
      };
      _proto.compareMain = function compareMain(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      };
      _proto.comparePre = function comparePre(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        var i2 = 0;
        do {
          var a = this.prerelease[i2];
          var b2 = other.prerelease[i2];
          debug("prerelease compare", i2, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers(a, b2);
          }
        } while (++i2);
      };
      _proto.compareBuild = function compareBuild(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        var i2 = 0;
        do {
          var a = this.build[i2];
          var b2 = other.build[i2];
          debug("prerelease compare", i2, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers(a, b2);
          }
        } while (++i2);
      };
      _proto.inc = function inc(release3, identifier2) {
        switch (release3) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier2);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier2);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier2);
            this.inc("pre", identifier2);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier2);
            }
            this.inc("pre", identifier2);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre":
            if (this.prerelease.length === 0) {
              this.prerelease = [0];
            } else {
              var i2 = this.prerelease.length;
              while (--i2 >= 0) {
                if (typeof this.prerelease[i2] === "number") {
                  this.prerelease[i2]++;
                  i2 = -2;
                }
              }
              if (i2 === -1) {
                this.prerelease.push(0);
              }
            }
            if (identifier2) {
              if (this.prerelease[0] === identifier2) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = [identifier2, 0];
                }
              } else {
                this.prerelease = [identifier2, 0];
              }
            }
            break;
          default:
            throw new Error("invalid increment argument: " + release3);
        }
        this.format();
        this.raw = this.version;
        return this;
      };
      return _createClass2(SemVer2);
    }();
    var semver$5 = SemVer$3;
    var SemVer$2 = semver$5;
    var compare$8 = function compare3(a, b2, loose) {
      return new SemVer$2(a, loose).compare(new SemVer$2(b2, loose));
    };
    var compare_1 = compare$8;
    var compare$7 = compare_1;
    var eq$12 = function eq3(a, b2, loose) {
      return compare$7(a, b2, loose) === 0;
    };
    var eq_12 = eq$12;
    var compare$6 = compare_1;
    var neq$1 = function neq2(a, b2, loose) {
      return compare$6(a, b2, loose) !== 0;
    };
    var neq_1 = neq$1;
    var compare$5 = compare_1;
    var gt$1 = function gt2(a, b2, loose) {
      return compare$5(a, b2, loose) > 0;
    };
    var gt_1 = gt$1;
    var compare$4 = compare_1;
    var gte$1 = function gte2(a, b2, loose) {
      return compare$4(a, b2, loose) >= 0;
    };
    var gte_1 = gte$1;
    var compare$3 = compare_1;
    var lt$1 = function lt3(a, b2, loose) {
      return compare$3(a, b2, loose) < 0;
    };
    var lt_1 = lt$1;
    var compare$2 = compare_1;
    var lte$1 = function lte2(a, b2, loose) {
      return compare$2(a, b2, loose) <= 0;
    };
    var lte_1 = lte$1;
    var eq2 = eq_12;
    var neq = neq_1;
    var gt = gt_1;
    var gte = gte_1;
    var lt2 = lt_1;
    var lte = lte_1;
    var cmp$1 = function cmp2(a, op, b2, loose) {
      switch (op) {
        case "===":
          if (typeof a === "object")
            a = a.version;
          if (typeof b2 === "object")
            b2 = b2.version;
          return a === b2;
        case "!==":
          if (typeof a === "object")
            a = a.version;
          if (typeof b2 === "object")
            b2 = b2.version;
          return a !== b2;
        case "":
        case "=":
        case "==":
          return eq2(a, b2, loose);
        case "!=":
          return neq(a, b2, loose);
        case ">":
          return gt(a, b2, loose);
        case ">=":
          return gte(a, b2, loose);
        case "<":
          return lt2(a, b2, loose);
        case "<=":
          return lte(a, b2, loose);
        default:
          throw new TypeError("Invalid operator: " + op);
      }
    };
    var cmp_1 = cmp$1;
    var MAX_LENGTH = constants.MAX_LENGTH;
    var re$1 = re$3.exports.re, t$6 = re$3.exports.t;
    var SemVer$1 = semver$5;
    var parse$12 = function parse5(version3, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version3 instanceof SemVer$1) {
        return version3;
      }
      if (typeof version3 !== "string") {
        return null;
      }
      if (version3.length > MAX_LENGTH) {
        return null;
      }
      var r2 = options.loose ? re$1[t$6.LOOSE] : re$1[t$6.FULL];
      if (!r2.test(version3)) {
        return null;
      }
      try {
        return new SemVer$1(version3, options);
      } catch (er) {
        return null;
      }
    };
    var parse_1 = parse$12;
    var SemVer = semver$5;
    var parse4 = parse_1;
    var re2 = re$3.exports.re, t$5 = re$3.exports.t;
    var coerce = function coerce2(version3, options) {
      if (version3 instanceof SemVer) {
        return version3;
      }
      if (typeof version3 === "number") {
        version3 = String(version3);
      }
      if (typeof version3 !== "string") {
        return null;
      }
      options = options || {};
      var match = null;
      if (!options.rtl) {
        match = version3.match(re2[t$5.COERCE]);
      } else {
        var next;
        while ((next = re2[t$5.COERCERTL].exec(version3)) && (!match || match.index + match[0].length !== version3.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          re2[t$5.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
        }
        re2[t$5.COERCERTL].lastIndex = -1;
      }
      if (match === null)
        return null;
      return parse4(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
    };
    var coerce_1 = coerce;
    var cmp = cmp_1;
    var semver$4 = coerce_1;
    var has$4 = Function.call.bind({}.hasOwnProperty);
    function compare$1(a, operator, b2) {
      return cmp(semver$4(a), operator, semver$4(b2));
    }
    function filterOutStabilizedProposals(modules2) {
      var modulesSet = new Set(modules2);
      for (var _iterator2 = _createForOfIteratorHelperLoose(modulesSet), _step2; !(_step2 = _iterator2()).done; ) {
        var $module = _step2.value;
        if ($module.startsWith("esnext.") && modulesSet.has($module.replace(/^esnext\./, "es."))) {
          modulesSet["delete"]($module);
        }
      }
      return _toConsumableArray2(modulesSet);
    }
    function intersection$2(list2, order) {
      var set3 = list2 instanceof Set ? list2 : new Set(list2);
      return order.filter(function(name2) {
        return set3.has(name2);
      });
    }
    function sortObjectByKey(object4, fn) {
      return Object.keys(object4).sort(fn).reduce(function(memo, key2) {
        memo[key2] = object4[key2];
        return memo;
      }, {});
    }
    var helpers = {
      compare: compare$1,
      filterOutStabilizedProposals,
      has: has$4,
      intersection: intersection$2,
      semver: semver$4,
      sortObjectByKey
    };
    var require$$1 = {
      "3.0": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.now",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.to-string",
        "es.set",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.weak-map",
        "es.weak-set",
        "esnext.aggregate-error",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.global-this",
        "esnext.map.delete-all",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.dispose",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.immediate",
        "web.queue-microtask",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "3.1": [
        "es.string.match-all",
        "es.symbol.match-all",
        "esnext.symbol.replace-all"
      ],
      "3.2": [
        "es.promise.all-settled",
        "esnext.array.is-template-object",
        "esnext.map.update-or-insert",
        "esnext.symbol.async-dispose"
      ],
      "3.3": [
        "es.global-this",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.map.upsert",
        "esnext.weak-map.upsert"
      ],
      "3.4": [
        "es.json.stringify"
      ],
      "3.5": [
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values"
      ],
      "3.6": [
        "es.regexp.sticky",
        "es.regexp.test"
      ],
      "3.7": [
        "es.aggregate-error",
        "es.promise.any",
        "es.reflect.to-string-tag",
        "es.string.replace-all",
        "esnext.map.emplace",
        "esnext.weak-map.emplace"
      ],
      "3.8": [
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.unique-by",
        "esnext.bigint.range",
        "esnext.number.range",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out"
      ],
      "3.9": [
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.unique-by"
      ],
      "3.11": [
        "esnext.object.has-own"
      ],
      "3.12": [
        "esnext.symbol.matcher",
        "esnext.symbol.metadata"
      ],
      "3.15": [
        "es.date.get-year",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.escape",
        "es.regexp.dot-all",
        "es.string.substr",
        "es.unescape"
      ],
      "3.16": [
        "esnext.array.filter-reject",
        "esnext.array.group-by",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.group-by"
      ],
      "3.17": [
        "es.array.at",
        "es.object.has-own",
        "es.string.at-alternative",
        "es.typed-array.at"
      ],
      "3.18": [
        "esnext.array.from-async",
        "esnext.typed-array.from-async"
      ],
      "3.20": [
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error.cause",
        "es.number.to-exponential",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.iterator.to-async",
        "esnext.string.cooked",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.structured-clone"
      ],
      "3.21": [
        "web.atob",
        "web.btoa"
      ]
    };
    var require$$2 = [
      "es.symbol",
      "es.symbol.description",
      "es.symbol.async-iterator",
      "es.symbol.has-instance",
      "es.symbol.is-concat-spreadable",
      "es.symbol.iterator",
      "es.symbol.match",
      "es.symbol.match-all",
      "es.symbol.replace",
      "es.symbol.search",
      "es.symbol.species",
      "es.symbol.split",
      "es.symbol.to-primitive",
      "es.symbol.to-string-tag",
      "es.symbol.unscopables",
      "es.error.cause",
      "es.error.to-string",
      "es.aggregate-error",
      "es.aggregate-error.cause",
      "es.array.at",
      "es.array.concat",
      "es.array.copy-within",
      "es.array.every",
      "es.array.fill",
      "es.array.filter",
      "es.array.find",
      "es.array.find-index",
      "es.array.flat",
      "es.array.flat-map",
      "es.array.for-each",
      "es.array.from",
      "es.array.includes",
      "es.array.index-of",
      "es.array.is-array",
      "es.array.iterator",
      "es.array.join",
      "es.array.last-index-of",
      "es.array.map",
      "es.array.of",
      "es.array.reduce",
      "es.array.reduce-right",
      "es.array.reverse",
      "es.array.slice",
      "es.array.some",
      "es.array.sort",
      "es.array.species",
      "es.array.splice",
      "es.array.unscopables.flat",
      "es.array.unscopables.flat-map",
      "es.array-buffer.constructor",
      "es.array-buffer.is-view",
      "es.array-buffer.slice",
      "es.data-view",
      "es.date.get-year",
      "es.date.now",
      "es.date.set-year",
      "es.date.to-gmt-string",
      "es.date.to-iso-string",
      "es.date.to-json",
      "es.date.to-primitive",
      "es.date.to-string",
      "es.escape",
      "es.function.bind",
      "es.function.has-instance",
      "es.function.name",
      "es.global-this",
      "es.json.stringify",
      "es.json.to-string-tag",
      "es.map",
      "es.math.acosh",
      "es.math.asinh",
      "es.math.atanh",
      "es.math.cbrt",
      "es.math.clz32",
      "es.math.cosh",
      "es.math.expm1",
      "es.math.fround",
      "es.math.hypot",
      "es.math.imul",
      "es.math.log10",
      "es.math.log1p",
      "es.math.log2",
      "es.math.sign",
      "es.math.sinh",
      "es.math.tanh",
      "es.math.to-string-tag",
      "es.math.trunc",
      "es.number.constructor",
      "es.number.epsilon",
      "es.number.is-finite",
      "es.number.is-integer",
      "es.number.is-nan",
      "es.number.is-safe-integer",
      "es.number.max-safe-integer",
      "es.number.min-safe-integer",
      "es.number.parse-float",
      "es.number.parse-int",
      "es.number.to-exponential",
      "es.number.to-fixed",
      "es.number.to-precision",
      "es.object.assign",
      "es.object.create",
      "es.object.define-getter",
      "es.object.define-properties",
      "es.object.define-property",
      "es.object.define-setter",
      "es.object.entries",
      "es.object.freeze",
      "es.object.from-entries",
      "es.object.get-own-property-descriptor",
      "es.object.get-own-property-descriptors",
      "es.object.get-own-property-names",
      "es.object.get-prototype-of",
      "es.object.has-own",
      "es.object.is",
      "es.object.is-extensible",
      "es.object.is-frozen",
      "es.object.is-sealed",
      "es.object.keys",
      "es.object.lookup-getter",
      "es.object.lookup-setter",
      "es.object.prevent-extensions",
      "es.object.seal",
      "es.object.set-prototype-of",
      "es.object.to-string",
      "es.object.values",
      "es.parse-float",
      "es.parse-int",
      "es.promise",
      "es.promise.all-settled",
      "es.promise.any",
      "es.promise.finally",
      "es.reflect.apply",
      "es.reflect.construct",
      "es.reflect.define-property",
      "es.reflect.delete-property",
      "es.reflect.get",
      "es.reflect.get-own-property-descriptor",
      "es.reflect.get-prototype-of",
      "es.reflect.has",
      "es.reflect.is-extensible",
      "es.reflect.own-keys",
      "es.reflect.prevent-extensions",
      "es.reflect.set",
      "es.reflect.set-prototype-of",
      "es.reflect.to-string-tag",
      "es.regexp.constructor",
      "es.regexp.dot-all",
      "es.regexp.exec",
      "es.regexp.flags",
      "es.regexp.sticky",
      "es.regexp.test",
      "es.regexp.to-string",
      "es.set",
      "es.string.at-alternative",
      "es.string.code-point-at",
      "es.string.ends-with",
      "es.string.from-code-point",
      "es.string.includes",
      "es.string.iterator",
      "es.string.match",
      "es.string.match-all",
      "es.string.pad-end",
      "es.string.pad-start",
      "es.string.raw",
      "es.string.repeat",
      "es.string.replace",
      "es.string.replace-all",
      "es.string.search",
      "es.string.split",
      "es.string.starts-with",
      "es.string.substr",
      "es.string.trim",
      "es.string.trim-end",
      "es.string.trim-start",
      "es.string.anchor",
      "es.string.big",
      "es.string.blink",
      "es.string.bold",
      "es.string.fixed",
      "es.string.fontcolor",
      "es.string.fontsize",
      "es.string.italics",
      "es.string.link",
      "es.string.small",
      "es.string.strike",
      "es.string.sub",
      "es.string.sup",
      "es.typed-array.float32-array",
      "es.typed-array.float64-array",
      "es.typed-array.int8-array",
      "es.typed-array.int16-array",
      "es.typed-array.int32-array",
      "es.typed-array.uint8-array",
      "es.typed-array.uint8-clamped-array",
      "es.typed-array.uint16-array",
      "es.typed-array.uint32-array",
      "es.typed-array.at",
      "es.typed-array.copy-within",
      "es.typed-array.every",
      "es.typed-array.fill",
      "es.typed-array.filter",
      "es.typed-array.find",
      "es.typed-array.find-index",
      "es.typed-array.for-each",
      "es.typed-array.from",
      "es.typed-array.includes",
      "es.typed-array.index-of",
      "es.typed-array.iterator",
      "es.typed-array.join",
      "es.typed-array.last-index-of",
      "es.typed-array.map",
      "es.typed-array.of",
      "es.typed-array.reduce",
      "es.typed-array.reduce-right",
      "es.typed-array.reverse",
      "es.typed-array.set",
      "es.typed-array.slice",
      "es.typed-array.some",
      "es.typed-array.sort",
      "es.typed-array.subarray",
      "es.typed-array.to-locale-string",
      "es.typed-array.to-string",
      "es.unescape",
      "es.weak-map",
      "es.weak-set",
      "esnext.aggregate-error",
      "esnext.array.from-async",
      "esnext.array.at",
      "esnext.array.filter-out",
      "esnext.array.filter-reject",
      "esnext.array.find-last",
      "esnext.array.find-last-index",
      "esnext.array.group-by",
      "esnext.array.group-by-to-map",
      "esnext.array.is-template-object",
      "esnext.array.last-index",
      "esnext.array.last-item",
      "esnext.array.to-reversed",
      "esnext.array.to-sorted",
      "esnext.array.to-spliced",
      "esnext.array.unique-by",
      "esnext.array.with",
      "esnext.async-iterator.constructor",
      "esnext.async-iterator.as-indexed-pairs",
      "esnext.async-iterator.drop",
      "esnext.async-iterator.every",
      "esnext.async-iterator.filter",
      "esnext.async-iterator.find",
      "esnext.async-iterator.flat-map",
      "esnext.async-iterator.for-each",
      "esnext.async-iterator.from",
      "esnext.async-iterator.map",
      "esnext.async-iterator.reduce",
      "esnext.async-iterator.some",
      "esnext.async-iterator.take",
      "esnext.async-iterator.to-array",
      "esnext.bigint.range",
      "esnext.composite-key",
      "esnext.composite-symbol",
      "esnext.function.is-callable",
      "esnext.function.is-constructor",
      "esnext.function.un-this",
      "esnext.global-this",
      "esnext.iterator.constructor",
      "esnext.iterator.as-indexed-pairs",
      "esnext.iterator.drop",
      "esnext.iterator.every",
      "esnext.iterator.filter",
      "esnext.iterator.find",
      "esnext.iterator.flat-map",
      "esnext.iterator.for-each",
      "esnext.iterator.from",
      "esnext.iterator.map",
      "esnext.iterator.reduce",
      "esnext.iterator.some",
      "esnext.iterator.take",
      "esnext.iterator.to-array",
      "esnext.iterator.to-async",
      "esnext.map.delete-all",
      "esnext.map.emplace",
      "esnext.map.every",
      "esnext.map.filter",
      "esnext.map.find",
      "esnext.map.find-key",
      "esnext.map.from",
      "esnext.map.group-by",
      "esnext.map.includes",
      "esnext.map.key-by",
      "esnext.map.key-of",
      "esnext.map.map-keys",
      "esnext.map.map-values",
      "esnext.map.merge",
      "esnext.map.of",
      "esnext.map.reduce",
      "esnext.map.some",
      "esnext.map.update",
      "esnext.map.update-or-insert",
      "esnext.map.upsert",
      "esnext.math.clamp",
      "esnext.math.deg-per-rad",
      "esnext.math.degrees",
      "esnext.math.fscale",
      "esnext.math.iaddh",
      "esnext.math.imulh",
      "esnext.math.isubh",
      "esnext.math.rad-per-deg",
      "esnext.math.radians",
      "esnext.math.scale",
      "esnext.math.seeded-prng",
      "esnext.math.signbit",
      "esnext.math.umulh",
      "esnext.number.from-string",
      "esnext.number.range",
      "esnext.object.has-own",
      "esnext.object.iterate-entries",
      "esnext.object.iterate-keys",
      "esnext.object.iterate-values",
      "esnext.observable",
      "esnext.promise.all-settled",
      "esnext.promise.any",
      "esnext.promise.try",
      "esnext.reflect.define-metadata",
      "esnext.reflect.delete-metadata",
      "esnext.reflect.get-metadata",
      "esnext.reflect.get-metadata-keys",
      "esnext.reflect.get-own-metadata",
      "esnext.reflect.get-own-metadata-keys",
      "esnext.reflect.has-metadata",
      "esnext.reflect.has-own-metadata",
      "esnext.reflect.metadata",
      "esnext.set.add-all",
      "esnext.set.delete-all",
      "esnext.set.difference",
      "esnext.set.every",
      "esnext.set.filter",
      "esnext.set.find",
      "esnext.set.from",
      "esnext.set.intersection",
      "esnext.set.is-disjoint-from",
      "esnext.set.is-subset-of",
      "esnext.set.is-superset-of",
      "esnext.set.join",
      "esnext.set.map",
      "esnext.set.of",
      "esnext.set.reduce",
      "esnext.set.some",
      "esnext.set.symmetric-difference",
      "esnext.set.union",
      "esnext.string.at",
      "esnext.string.cooked",
      "esnext.string.code-points",
      "esnext.string.match-all",
      "esnext.string.replace-all",
      "esnext.symbol.async-dispose",
      "esnext.symbol.dispose",
      "esnext.symbol.matcher",
      "esnext.symbol.metadata",
      "esnext.symbol.observable",
      "esnext.symbol.pattern-match",
      "esnext.symbol.replace-all",
      "esnext.typed-array.from-async",
      "esnext.typed-array.at",
      "esnext.typed-array.filter-out",
      "esnext.typed-array.filter-reject",
      "esnext.typed-array.find-last",
      "esnext.typed-array.find-last-index",
      "esnext.typed-array.group-by",
      "esnext.typed-array.to-reversed",
      "esnext.typed-array.to-sorted",
      "esnext.typed-array.to-spliced",
      "esnext.typed-array.unique-by",
      "esnext.typed-array.with",
      "esnext.weak-map.delete-all",
      "esnext.weak-map.from",
      "esnext.weak-map.of",
      "esnext.weak-map.emplace",
      "esnext.weak-map.upsert",
      "esnext.weak-set.add-all",
      "esnext.weak-set.delete-all",
      "esnext.weak-set.from",
      "esnext.weak-set.of",
      "web.atob",
      "web.btoa",
      "web.dom-collections.for-each",
      "web.dom-collections.iterator",
      "web.dom-exception.constructor",
      "web.dom-exception.stack",
      "web.dom-exception.to-string-tag",
      "web.immediate",
      "web.queue-microtask",
      "web.structured-clone",
      "web.timers",
      "web.url",
      "web.url.to-json",
      "web.url-search-params"
    ];
    var compare2 = helpers.compare, intersection$1 = helpers.intersection, semver$3 = helpers.semver;
    var modulesByVersions = require$$1;
    var modules = require$$2;
    var getModulesListForTargetVersion$2 = function getModulesListForTargetVersion2(raw) {
      var corejs = semver$3(raw);
      if (corejs.major !== 3) {
        throw RangeError("This version of `core-js-compat` works only with `core-js@3`.");
      }
      var result = [];
      for (var _i3 = 0, _Object$keys3 = Object.keys(modulesByVersions); _i3 < _Object$keys3.length; _i3++) {
        var version3 = _Object$keys3[_i3];
        if (compare2(version3, "<=", corejs)) {
          result.push.apply(result, _toConsumableArray2(modulesByVersions[version3]));
        }
      }
      return intersection$1(result, modules);
    };
    var getModulesListForTargetVersion$1 = getModulesListForTargetVersion$2;
    var require$$0$2 = {
      "core-js": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/actual": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set",
        "esnext.aggregate-error",
        "esnext.array.at",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with",
        "esnext.global-this",
        "esnext.object.has-own",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.typed-array.at",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with",
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/actual/aggregate-error": [
        "es.error.cause",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.iterator",
        "es.string.iterator",
        "esnext.aggregate-error",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/array": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "es.string.iterator",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with"
      ],
      "core-js/actual/array-buffer": [
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/actual/array-buffer/constructor": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/actual/array-buffer/is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/actual/array-buffer/slice": [
        "es.array-buffer.slice"
      ],
      "core-js/actual/array/at": [
        "es.array.at"
      ],
      "core-js/actual/array/concat": [
        "es.array.concat"
      ],
      "core-js/actual/array/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/actual/array/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/every": [
        "es.array.every"
      ],
      "core-js/actual/array/fill": [
        "es.array.fill"
      ],
      "core-js/actual/array/filter": [
        "es.array.filter"
      ],
      "core-js/actual/array/find": [
        "es.array.find"
      ],
      "core-js/actual/array/find-index": [
        "es.array.find-index"
      ],
      "core-js/actual/array/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/actual/array/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/actual/array/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/actual/array/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/actual/array/for-each": [
        "es.array.for-each"
      ],
      "core-js/actual/array/from": [
        "es.array.from",
        "es.string.iterator"
      ],
      "core-js/actual/array/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/actual/array/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/actual/array/includes": [
        "es.array.includes"
      ],
      "core-js/actual/array/index-of": [
        "es.array.index-of"
      ],
      "core-js/actual/array/is-array": [
        "es.array.is-array"
      ],
      "core-js/actual/array/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/join": [
        "es.array.join"
      ],
      "core-js/actual/array/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/actual/array/map": [
        "es.array.map"
      ],
      "core-js/actual/array/of": [
        "es.array.of"
      ],
      "core-js/actual/array/reduce": [
        "es.array.reduce"
      ],
      "core-js/actual/array/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/actual/array/reverse": [
        "es.array.reverse"
      ],
      "core-js/actual/array/slice": [
        "es.array.slice"
      ],
      "core-js/actual/array/some": [
        "es.array.some"
      ],
      "core-js/actual/array/sort": [
        "es.array.sort"
      ],
      "core-js/actual/array/splice": [
        "es.array.splice"
      ],
      "core-js/actual/array/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/actual/array/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/actual/array/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/actual/array/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/virtual": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.includes",
        "es.array.index-of",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with"
      ],
      "core-js/actual/array/virtual/at": [
        "es.array.at"
      ],
      "core-js/actual/array/virtual/concat": [
        "es.array.concat"
      ],
      "core-js/actual/array/virtual/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/actual/array/virtual/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/virtual/every": [
        "es.array.every"
      ],
      "core-js/actual/array/virtual/fill": [
        "es.array.fill"
      ],
      "core-js/actual/array/virtual/filter": [
        "es.array.filter"
      ],
      "core-js/actual/array/virtual/find": [
        "es.array.find"
      ],
      "core-js/actual/array/virtual/find-index": [
        "es.array.find-index"
      ],
      "core-js/actual/array/virtual/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/actual/array/virtual/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/actual/array/virtual/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/actual/array/virtual/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/actual/array/virtual/for-each": [
        "es.array.for-each"
      ],
      "core-js/actual/array/virtual/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/actual/array/virtual/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/actual/array/virtual/includes": [
        "es.array.includes"
      ],
      "core-js/actual/array/virtual/index-of": [
        "es.array.index-of"
      ],
      "core-js/actual/array/virtual/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/virtual/join": [
        "es.array.join"
      ],
      "core-js/actual/array/virtual/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/virtual/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/actual/array/virtual/map": [
        "es.array.map"
      ],
      "core-js/actual/array/virtual/reduce": [
        "es.array.reduce"
      ],
      "core-js/actual/array/virtual/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/actual/array/virtual/reverse": [
        "es.array.reverse"
      ],
      "core-js/actual/array/virtual/slice": [
        "es.array.slice"
      ],
      "core-js/actual/array/virtual/some": [
        "es.array.some"
      ],
      "core-js/actual/array/virtual/sort": [
        "es.array.sort"
      ],
      "core-js/actual/array/virtual/splice": [
        "es.array.splice"
      ],
      "core-js/actual/array/virtual/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/actual/array/virtual/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/actual/array/virtual/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/actual/array/virtual/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/actual/array/virtual/with": [
        "esnext.array.with"
      ],
      "core-js/actual/array/with": [
        "esnext.array.with"
      ],
      "core-js/actual/atob": [
        "es.error.to-string",
        "es.object.to-string",
        "web.atob",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/actual/btoa": [
        "es.error.to-string",
        "es.object.to-string",
        "web.btoa",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/actual/clear-immediate": [
        "web.immediate"
      ],
      "core-js/actual/data-view": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.data-view",
        "es.object.to-string"
      ],
      "core-js/actual/date": [
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string"
      ],
      "core-js/actual/date/get-year": [
        "es.date.get-year"
      ],
      "core-js/actual/date/now": [
        "es.date.now"
      ],
      "core-js/actual/date/set-year": [
        "es.date.set-year"
      ],
      "core-js/actual/date/to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/actual/date/to-iso-string": [
        "es.date.to-iso-string",
        "es.date.to-json"
      ],
      "core-js/actual/date/to-json": [
        "es.date.to-json"
      ],
      "core-js/actual/date/to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/actual/date/to-string": [
        "es.date.to-string"
      ],
      "core-js/actual/dom-collections": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/dom-collections/for-each": [
        "web.dom-collections.for-each"
      ],
      "core-js/actual/dom-collections/iterator": [
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/dom-exception": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/actual/dom-exception/constructor": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack"
      ],
      "core-js/actual/dom-exception/to-string-tag": [
        "web.dom-exception.to-string-tag"
      ],
      "core-js/actual/error": [
        "es.error.cause",
        "es.error.to-string"
      ],
      "core-js/actual/error/constructor": [
        "es.error.cause"
      ],
      "core-js/actual/error/to-string": [
        "es.error.to-string"
      ],
      "core-js/actual/escape": [
        "es.escape"
      ],
      "core-js/actual/function": [
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name"
      ],
      "core-js/actual/function/bind": [
        "es.function.bind"
      ],
      "core-js/actual/function/has-instance": [
        "es.function.has-instance"
      ],
      "core-js/actual/function/name": [
        "es.function.name"
      ],
      "core-js/actual/function/virtual": [
        "es.function.bind"
      ],
      "core-js/actual/function/virtual/bind": [
        "es.function.bind"
      ],
      "core-js/actual/get-iterator": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/get-iterator-method": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/global-this": [
        "es.global-this"
      ],
      "core-js/actual/instance/at": [
        "es.array.at",
        "es.string.at-alternative"
      ],
      "core-js/actual/instance/bind": [
        "es.function.bind"
      ],
      "core-js/actual/instance/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/actual/instance/concat": [
        "es.array.concat"
      ],
      "core-js/actual/instance/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/actual/instance/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/actual/instance/entries": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/instance/every": [
        "es.array.every"
      ],
      "core-js/actual/instance/fill": [
        "es.array.fill"
      ],
      "core-js/actual/instance/filter": [
        "es.array.filter"
      ],
      "core-js/actual/instance/find": [
        "es.array.find"
      ],
      "core-js/actual/instance/find-index": [
        "es.array.find-index"
      ],
      "core-js/actual/instance/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/actual/instance/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/actual/instance/flags": [
        "es.regexp.flags"
      ],
      "core-js/actual/instance/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/actual/instance/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/actual/instance/for-each": [
        "es.array.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/instance/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/actual/instance/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/actual/instance/includes": [
        "es.array.includes",
        "es.string.includes"
      ],
      "core-js/actual/instance/index-of": [
        "es.array.index-of"
      ],
      "core-js/actual/instance/keys": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/instance/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/actual/instance/map": [
        "es.array.map"
      ],
      "core-js/actual/instance/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/actual/instance/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/actual/instance/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/actual/instance/reduce": [
        "es.array.reduce"
      ],
      "core-js/actual/instance/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/actual/instance/repeat": [
        "es.string.repeat"
      ],
      "core-js/actual/instance/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/actual/instance/reverse": [
        "es.array.reverse"
      ],
      "core-js/actual/instance/slice": [
        "es.array.slice"
      ],
      "core-js/actual/instance/some": [
        "es.array.some"
      ],
      "core-js/actual/instance/sort": [
        "es.array.sort"
      ],
      "core-js/actual/instance/splice": [
        "es.array.splice"
      ],
      "core-js/actual/instance/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/actual/instance/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/actual/instance/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/actual/instance/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/actual/instance/trim": [
        "es.string.trim"
      ],
      "core-js/actual/instance/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/actual/instance/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/actual/instance/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/actual/instance/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/actual/instance/values": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/instance/with": [
        "esnext.array.with"
      ],
      "core-js/actual/is-iterable": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/json": [
        "es.json.stringify",
        "es.json.to-string-tag"
      ],
      "core-js/actual/json/stringify": [
        "es.json.stringify"
      ],
      "core-js/actual/json/to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/actual/map": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/math": [
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc"
      ],
      "core-js/actual/math/acosh": [
        "es.math.acosh"
      ],
      "core-js/actual/math/asinh": [
        "es.math.asinh"
      ],
      "core-js/actual/math/atanh": [
        "es.math.atanh"
      ],
      "core-js/actual/math/cbrt": [
        "es.math.cbrt"
      ],
      "core-js/actual/math/clz32": [
        "es.math.clz32"
      ],
      "core-js/actual/math/cosh": [
        "es.math.cosh"
      ],
      "core-js/actual/math/expm1": [
        "es.math.expm1"
      ],
      "core-js/actual/math/fround": [
        "es.math.fround"
      ],
      "core-js/actual/math/hypot": [
        "es.math.hypot"
      ],
      "core-js/actual/math/imul": [
        "es.math.imul"
      ],
      "core-js/actual/math/log10": [
        "es.math.log10"
      ],
      "core-js/actual/math/log1p": [
        "es.math.log1p"
      ],
      "core-js/actual/math/log2": [
        "es.math.log2"
      ],
      "core-js/actual/math/sign": [
        "es.math.sign"
      ],
      "core-js/actual/math/sinh": [
        "es.math.sinh"
      ],
      "core-js/actual/math/tanh": [
        "es.math.tanh"
      ],
      "core-js/actual/math/to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/actual/math/trunc": [
        "es.math.trunc"
      ],
      "core-js/actual/number": [
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/actual/number/constructor": [
        "es.number.constructor"
      ],
      "core-js/actual/number/epsilon": [
        "es.number.epsilon"
      ],
      "core-js/actual/number/is-finite": [
        "es.number.is-finite"
      ],
      "core-js/actual/number/is-integer": [
        "es.number.is-integer"
      ],
      "core-js/actual/number/is-nan": [
        "es.number.is-nan"
      ],
      "core-js/actual/number/is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/actual/number/max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/actual/number/min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/actual/number/parse-float": [
        "es.number.parse-float"
      ],
      "core-js/actual/number/parse-int": [
        "es.number.parse-int"
      ],
      "core-js/actual/number/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/actual/number/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/actual/number/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/actual/number/virtual": [
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/actual/number/virtual/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/actual/number/virtual/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/actual/number/virtual/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/actual/object": [
        "es.symbol",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.reflect.to-string-tag",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/object/assign": [
        "es.object.assign"
      ],
      "core-js/actual/object/create": [
        "es.object.create"
      ],
      "core-js/actual/object/define-getter": [
        "es.object.define-getter"
      ],
      "core-js/actual/object/define-properties": [
        "es.object.define-properties"
      ],
      "core-js/actual/object/define-property": [
        "es.object.define-property"
      ],
      "core-js/actual/object/define-setter": [
        "es.object.define-setter"
      ],
      "core-js/actual/object/entries": [
        "es.object.entries"
      ],
      "core-js/actual/object/freeze": [
        "es.object.freeze"
      ],
      "core-js/actual/object/from-entries": [
        "es.array.iterator",
        "es.object.from-entries",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/object/get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/actual/object/get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/actual/object/get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/actual/object/get-own-property-symbols": [
        "es.symbol"
      ],
      "core-js/actual/object/get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/actual/object/has-own": [
        "es.object.has-own"
      ],
      "core-js/actual/object/is": [
        "es.object.is"
      ],
      "core-js/actual/object/is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/actual/object/is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/actual/object/is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/actual/object/keys": [
        "es.object.keys"
      ],
      "core-js/actual/object/lookup-getter": [
        "es.object.lookup-setter"
      ],
      "core-js/actual/object/lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/actual/object/prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/actual/object/seal": [
        "es.object.seal"
      ],
      "core-js/actual/object/set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/actual/object/to-string": [
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/actual/object/values": [
        "es.object.values"
      ],
      "core-js/actual/parse-float": [
        "es.parse-float"
      ],
      "core-js/actual/parse-int": [
        "es.parse-int"
      ],
      "core-js/actual/promise": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/promise/all-settled": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/promise/any": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.any",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/promise/finally": [
        "es.object.to-string",
        "es.promise",
        "es.promise.finally"
      ],
      "core-js/actual/queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/actual/reflect": [
        "es.object.to-string",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag"
      ],
      "core-js/actual/reflect/apply": [
        "es.reflect.apply"
      ],
      "core-js/actual/reflect/construct": [
        "es.reflect.construct"
      ],
      "core-js/actual/reflect/define-property": [
        "es.reflect.define-property"
      ],
      "core-js/actual/reflect/delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/actual/reflect/get": [
        "es.reflect.get"
      ],
      "core-js/actual/reflect/get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/actual/reflect/get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/actual/reflect/has": [
        "es.reflect.has"
      ],
      "core-js/actual/reflect/is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/actual/reflect/own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/actual/reflect/prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/actual/reflect/set": [
        "es.reflect.set"
      ],
      "core-js/actual/reflect/set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/actual/reflect/to-string-tag": [
        "es.reflect.to-string-tag"
      ],
      "core-js/actual/regexp": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.string.match",
        "es.string.replace",
        "es.string.search",
        "es.string.split"
      ],
      "core-js/actual/regexp/constructor": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/actual/regexp/dot-all": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec"
      ],
      "core-js/actual/regexp/flags": [
        "es.regexp.flags"
      ],
      "core-js/actual/regexp/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/actual/regexp/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/actual/regexp/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/actual/regexp/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/actual/regexp/sticky": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/actual/regexp/test": [
        "es.regexp.exec",
        "es.regexp.test"
      ],
      "core-js/actual/regexp/to-string": [
        "es.regexp.to-string"
      ],
      "core-js/actual/set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.set",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/set-immediate": [
        "web.immediate"
      ],
      "core-js/actual/set-interval": [
        "web.timers"
      ],
      "core-js/actual/set-timeout": [
        "web.timers"
      ],
      "core-js/actual/string": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/actual/string/anchor": [
        "es.string.anchor"
      ],
      "core-js/actual/string/at": [
        "es.string.at-alternative"
      ],
      "core-js/actual/string/big": [
        "es.string.big"
      ],
      "core-js/actual/string/blink": [
        "es.string.blink"
      ],
      "core-js/actual/string/bold": [
        "es.string.bold"
      ],
      "core-js/actual/string/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/actual/string/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/actual/string/fixed": [
        "es.string.fixed"
      ],
      "core-js/actual/string/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/actual/string/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/actual/string/from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/actual/string/includes": [
        "es.string.includes"
      ],
      "core-js/actual/string/italics": [
        "es.string.italics"
      ],
      "core-js/actual/string/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/actual/string/link": [
        "es.string.link"
      ],
      "core-js/actual/string/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/actual/string/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/actual/string/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/actual/string/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/actual/string/raw": [
        "es.string.raw"
      ],
      "core-js/actual/string/repeat": [
        "es.string.repeat"
      ],
      "core-js/actual/string/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/actual/string/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/actual/string/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/actual/string/small": [
        "es.string.small"
      ],
      "core-js/actual/string/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/actual/string/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/actual/string/strike": [
        "es.string.strike"
      ],
      "core-js/actual/string/sub": [
        "es.string.sub"
      ],
      "core-js/actual/string/substr": [
        "es.string.substr"
      ],
      "core-js/actual/string/sup": [
        "es.string.sup"
      ],
      "core-js/actual/string/trim": [
        "es.string.trim"
      ],
      "core-js/actual/string/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/actual/string/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/actual/string/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/actual/string/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/actual/string/virtual": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/actual/string/virtual/anchor": [
        "es.string.anchor"
      ],
      "core-js/actual/string/virtual/at": [
        "es.string.at-alternative"
      ],
      "core-js/actual/string/virtual/big": [
        "es.string.big"
      ],
      "core-js/actual/string/virtual/blink": [
        "es.string.blink"
      ],
      "core-js/actual/string/virtual/bold": [
        "es.string.bold"
      ],
      "core-js/actual/string/virtual/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/actual/string/virtual/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/actual/string/virtual/fixed": [
        "es.string.fixed"
      ],
      "core-js/actual/string/virtual/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/actual/string/virtual/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/actual/string/virtual/includes": [
        "es.string.includes"
      ],
      "core-js/actual/string/virtual/italics": [
        "es.string.italics"
      ],
      "core-js/actual/string/virtual/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/actual/string/virtual/link": [
        "es.string.link"
      ],
      "core-js/actual/string/virtual/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/actual/string/virtual/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/actual/string/virtual/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/actual/string/virtual/repeat": [
        "es.string.repeat"
      ],
      "core-js/actual/string/virtual/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/actual/string/virtual/small": [
        "es.string.small"
      ],
      "core-js/actual/string/virtual/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/actual/string/virtual/strike": [
        "es.string.strike"
      ],
      "core-js/actual/string/virtual/sub": [
        "es.string.sub"
      ],
      "core-js/actual/string/virtual/substr": [
        "es.string.substr"
      ],
      "core-js/actual/string/virtual/sup": [
        "es.string.sup"
      ],
      "core-js/actual/string/virtual/trim": [
        "es.string.trim"
      ],
      "core-js/actual/string/virtual/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/actual/string/virtual/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/actual/string/virtual/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/actual/string/virtual/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/actual/structured-clone": [
        "es.error.to-string",
        "es.array.iterator",
        "es.map",
        "es.object.keys",
        "es.object.to-string",
        "es.set",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.structured-clone"
      ],
      "core-js/actual/symbol": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/symbol/async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/actual/symbol/description": [
        "es.symbol.description"
      ],
      "core-js/actual/symbol/for": [
        "es.symbol"
      ],
      "core-js/actual/symbol/has-instance": [
        "es.symbol.has-instance",
        "es.function.has-instance"
      ],
      "core-js/actual/symbol/is-concat-spreadable": [
        "es.symbol.is-concat-spreadable",
        "es.array.concat"
      ],
      "core-js/actual/symbol/iterator": [
        "es.symbol.iterator",
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/symbol/key-for": [
        "es.symbol"
      ],
      "core-js/actual/symbol/match": [
        "es.symbol.match",
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/actual/symbol/match-all": [
        "es.symbol.match-all",
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/actual/symbol/replace": [
        "es.symbol.replace",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/actual/symbol/search": [
        "es.symbol.search",
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/actual/symbol/species": [
        "es.symbol.species"
      ],
      "core-js/actual/symbol/split": [
        "es.symbol.split",
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/actual/symbol/to-primitive": [
        "es.symbol.to-primitive",
        "es.date.to-primitive"
      ],
      "core-js/actual/symbol/to-string-tag": [
        "es.symbol.to-string-tag",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/actual/symbol/unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/actual/typed-array": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/at": [
        "es.typed-array.every"
      ],
      "core-js/actual/typed-array/copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/actual/typed-array/entries": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/actual/typed-array/every": [
        "es.typed-array.every"
      ],
      "core-js/actual/typed-array/fill": [
        "es.typed-array.fill"
      ],
      "core-js/actual/typed-array/filter": [
        "es.typed-array.filter"
      ],
      "core-js/actual/typed-array/find": [
        "es.typed-array.find"
      ],
      "core-js/actual/typed-array/find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/actual/typed-array/find-last": [
        "esnext.typed-array.find-last"
      ],
      "core-js/actual/typed-array/find-last-index": [
        "esnext.typed-array.find-last-index"
      ],
      "core-js/actual/typed-array/float32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/float64-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float64-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/actual/typed-array/from": [
        "es.typed-array.from"
      ],
      "core-js/actual/typed-array/includes": [
        "es.typed-array.includes"
      ],
      "core-js/actual/typed-array/index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/actual/typed-array/int16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/int32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/int8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/iterator": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/actual/typed-array/join": [
        "es.typed-array.join"
      ],
      "core-js/actual/typed-array/keys": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/actual/typed-array/last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/actual/typed-array/map": [
        "es.typed-array.map"
      ],
      "core-js/actual/typed-array/methods": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/of": [
        "es.typed-array.of"
      ],
      "core-js/actual/typed-array/reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/actual/typed-array/reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/actual/typed-array/reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/actual/typed-array/set": [
        "es.typed-array.set"
      ],
      "core-js/actual/typed-array/slice": [
        "es.typed-array.slice"
      ],
      "core-js/actual/typed-array/some": [
        "es.typed-array.some"
      ],
      "core-js/actual/typed-array/sort": [
        "es.typed-array.sort"
      ],
      "core-js/actual/typed-array/subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/actual/typed-array/to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/actual/typed-array/to-reversed": [
        "esnext.typed-array.to-reversed"
      ],
      "core-js/actual/typed-array/to-sorted": [
        "es.typed-array.sort",
        "esnext.typed-array.to-sorted"
      ],
      "core-js/actual/typed-array/to-spliced": [
        "esnext.typed-array.to-spliced"
      ],
      "core-js/actual/typed-array/to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/actual/typed-array/uint16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/uint32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/uint8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/uint8-clamped-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/actual/typed-array/values": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/actual/typed-array/with": [
        "esnext.typed-array.with"
      ],
      "core-js/actual/unescape": [
        "es.unescape"
      ],
      "core-js/actual/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/actual/url-search-params": [
        "web.dom-collections.iterator",
        "web.url-search-params"
      ],
      "core-js/actual/url/to-json": [
        "web.url.to-json"
      ],
      "core-js/actual/weak-map": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-map",
        "web.dom-collections.iterator"
      ],
      "core-js/actual/weak-set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-set",
        "web.dom-collections.iterator"
      ],
      "core-js/es": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set"
      ],
      "core-js/es/aggregate-error": [
        "es.error.cause",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.iterator",
        "es.string.iterator"
      ],
      "core-js/es/array": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/es/array-buffer": [
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/es/array-buffer/constructor": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/es/array-buffer/is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/es/array-buffer/slice": [
        "es.array-buffer.slice"
      ],
      "core-js/es/array/at": [
        "es.array.at"
      ],
      "core-js/es/array/concat": [
        "es.array.concat"
      ],
      "core-js/es/array/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/es/array/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/every": [
        "es.array.every"
      ],
      "core-js/es/array/fill": [
        "es.array.fill"
      ],
      "core-js/es/array/filter": [
        "es.array.filter"
      ],
      "core-js/es/array/find": [
        "es.array.find"
      ],
      "core-js/es/array/find-index": [
        "es.array.find-index"
      ],
      "core-js/es/array/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/es/array/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/es/array/for-each": [
        "es.array.for-each"
      ],
      "core-js/es/array/from": [
        "es.array.from",
        "es.string.iterator"
      ],
      "core-js/es/array/includes": [
        "es.array.includes"
      ],
      "core-js/es/array/index-of": [
        "es.array.index-of"
      ],
      "core-js/es/array/is-array": [
        "es.array.is-array"
      ],
      "core-js/es/array/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/join": [
        "es.array.join"
      ],
      "core-js/es/array/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/es/array/map": [
        "es.array.map"
      ],
      "core-js/es/array/of": [
        "es.array.of"
      ],
      "core-js/es/array/reduce": [
        "es.array.reduce"
      ],
      "core-js/es/array/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/es/array/reverse": [
        "es.array.reverse"
      ],
      "core-js/es/array/slice": [
        "es.array.slice"
      ],
      "core-js/es/array/some": [
        "es.array.some"
      ],
      "core-js/es/array/sort": [
        "es.array.sort"
      ],
      "core-js/es/array/splice": [
        "es.array.splice"
      ],
      "core-js/es/array/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/virtual": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.includes",
        "es.array.index-of",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.object.to-string"
      ],
      "core-js/es/array/virtual/at": [
        "es.array.at"
      ],
      "core-js/es/array/virtual/concat": [
        "es.array.concat"
      ],
      "core-js/es/array/virtual/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/es/array/virtual/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/virtual/every": [
        "es.array.every"
      ],
      "core-js/es/array/virtual/fill": [
        "es.array.fill"
      ],
      "core-js/es/array/virtual/filter": [
        "es.array.filter"
      ],
      "core-js/es/array/virtual/find": [
        "es.array.find"
      ],
      "core-js/es/array/virtual/find-index": [
        "es.array.find-index"
      ],
      "core-js/es/array/virtual/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/es/array/virtual/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/es/array/virtual/for-each": [
        "es.array.for-each"
      ],
      "core-js/es/array/virtual/includes": [
        "es.array.includes"
      ],
      "core-js/es/array/virtual/index-of": [
        "es.array.index-of"
      ],
      "core-js/es/array/virtual/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/virtual/join": [
        "es.array.join"
      ],
      "core-js/es/array/virtual/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/array/virtual/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/es/array/virtual/map": [
        "es.array.map"
      ],
      "core-js/es/array/virtual/reduce": [
        "es.array.reduce"
      ],
      "core-js/es/array/virtual/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/es/array/virtual/reverse": [
        "es.array.reverse"
      ],
      "core-js/es/array/virtual/slice": [
        "es.array.slice"
      ],
      "core-js/es/array/virtual/some": [
        "es.array.some"
      ],
      "core-js/es/array/virtual/sort": [
        "es.array.sort"
      ],
      "core-js/es/array/virtual/splice": [
        "es.array.splice"
      ],
      "core-js/es/array/virtual/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/data-view": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.data-view",
        "es.object.to-string"
      ],
      "core-js/es/date": [
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string"
      ],
      "core-js/es/date/get-year": [
        "es.date.get-year"
      ],
      "core-js/es/date/now": [
        "es.date.now"
      ],
      "core-js/es/date/set-year": [
        "es.date.set-year"
      ],
      "core-js/es/date/to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/es/date/to-iso-string": [
        "es.date.to-iso-string",
        "es.date.to-json"
      ],
      "core-js/es/date/to-json": [
        "es.date.to-json"
      ],
      "core-js/es/date/to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/es/date/to-string": [
        "es.date.to-string"
      ],
      "core-js/es/error": [
        "es.error.cause",
        "es.error.to-string"
      ],
      "core-js/es/error/constructor": [
        "es.error.cause"
      ],
      "core-js/es/error/to-string": [
        "es.error.to-string"
      ],
      "core-js/es/escape": [
        "es.escape"
      ],
      "core-js/es/function": [
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name"
      ],
      "core-js/es/function/bind": [
        "es.function.bind"
      ],
      "core-js/es/function/has-instance": [
        "es.function.has-instance"
      ],
      "core-js/es/function/name": [
        "es.function.name"
      ],
      "core-js/es/function/virtual": [
        "es.function.bind"
      ],
      "core-js/es/function/virtual/bind": [
        "es.function.bind"
      ],
      "core-js/es/get-iterator": [
        "es.array.iterator",
        "es.string.iterator"
      ],
      "core-js/es/get-iterator-method": [
        "es.array.iterator",
        "es.string.iterator"
      ],
      "core-js/es/global-this": [
        "es.global-this"
      ],
      "core-js/es/instance/at": [
        "es.array.at",
        "es.string.at-alternative"
      ],
      "core-js/es/instance/bind": [
        "es.function.bind"
      ],
      "core-js/es/instance/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/es/instance/concat": [
        "es.array.concat"
      ],
      "core-js/es/instance/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/es/instance/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/es/instance/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/instance/every": [
        "es.array.every"
      ],
      "core-js/es/instance/fill": [
        "es.array.fill"
      ],
      "core-js/es/instance/filter": [
        "es.array.filter"
      ],
      "core-js/es/instance/find": [
        "es.array.find"
      ],
      "core-js/es/instance/find-index": [
        "es.array.find-index"
      ],
      "core-js/es/instance/flags": [
        "es.regexp.flags"
      ],
      "core-js/es/instance/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/es/instance/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/es/instance/for-each": [
        "es.array.for-each"
      ],
      "core-js/es/instance/includes": [
        "es.array.includes",
        "es.string.includes"
      ],
      "core-js/es/instance/index-of": [
        "es.array.index-of"
      ],
      "core-js/es/instance/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/instance/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/es/instance/map": [
        "es.array.map"
      ],
      "core-js/es/instance/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/es/instance/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/es/instance/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/es/instance/reduce": [
        "es.array.reduce"
      ],
      "core-js/es/instance/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/es/instance/repeat": [
        "es.string.repeat"
      ],
      "core-js/es/instance/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/es/instance/reverse": [
        "es.array.reverse"
      ],
      "core-js/es/instance/slice": [
        "es.array.slice"
      ],
      "core-js/es/instance/some": [
        "es.array.some"
      ],
      "core-js/es/instance/sort": [
        "es.array.sort"
      ],
      "core-js/es/instance/splice": [
        "es.array.splice"
      ],
      "core-js/es/instance/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/es/instance/trim": [
        "es.string.trim"
      ],
      "core-js/es/instance/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/es/instance/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/es/instance/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/es/instance/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/es/instance/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/es/is-iterable": [
        "es.array.iterator",
        "es.string.iterator"
      ],
      "core-js/es/json": [
        "es.json.stringify",
        "es.json.to-string-tag"
      ],
      "core-js/es/json/stringify": [
        "es.json.stringify"
      ],
      "core-js/es/json/to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/es/map": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/es/math": [
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc"
      ],
      "core-js/es/math/acosh": [
        "es.math.acosh"
      ],
      "core-js/es/math/asinh": [
        "es.math.asinh"
      ],
      "core-js/es/math/atanh": [
        "es.math.atanh"
      ],
      "core-js/es/math/cbrt": [
        "es.math.cbrt"
      ],
      "core-js/es/math/clz32": [
        "es.math.clz32"
      ],
      "core-js/es/math/cosh": [
        "es.math.cosh"
      ],
      "core-js/es/math/expm1": [
        "es.math.expm1"
      ],
      "core-js/es/math/fround": [
        "es.math.fround"
      ],
      "core-js/es/math/hypot": [
        "es.math.hypot"
      ],
      "core-js/es/math/imul": [
        "es.math.imul"
      ],
      "core-js/es/math/log10": [
        "es.math.log10"
      ],
      "core-js/es/math/log1p": [
        "es.math.log1p"
      ],
      "core-js/es/math/log2": [
        "es.math.log2"
      ],
      "core-js/es/math/sign": [
        "es.math.sign"
      ],
      "core-js/es/math/sinh": [
        "es.math.sinh"
      ],
      "core-js/es/math/tanh": [
        "es.math.tanh"
      ],
      "core-js/es/math/to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/es/math/trunc": [
        "es.math.trunc"
      ],
      "core-js/es/number": [
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/es/number/constructor": [
        "es.number.constructor"
      ],
      "core-js/es/number/epsilon": [
        "es.number.epsilon"
      ],
      "core-js/es/number/is-finite": [
        "es.number.is-finite"
      ],
      "core-js/es/number/is-integer": [
        "es.number.is-integer"
      ],
      "core-js/es/number/is-nan": [
        "es.number.is-nan"
      ],
      "core-js/es/number/is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/es/number/max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/es/number/min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/es/number/parse-float": [
        "es.number.parse-float"
      ],
      "core-js/es/number/parse-int": [
        "es.number.parse-int"
      ],
      "core-js/es/number/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/es/number/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/es/number/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/es/number/virtual": [
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/es/number/virtual/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/es/number/virtual/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/es/number/virtual/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/es/object": [
        "es.symbol",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/object/assign": [
        "es.object.assign"
      ],
      "core-js/es/object/create": [
        "es.object.create"
      ],
      "core-js/es/object/define-getter": [
        "es.object.define-getter"
      ],
      "core-js/es/object/define-properties": [
        "es.object.define-properties"
      ],
      "core-js/es/object/define-property": [
        "es.object.define-property"
      ],
      "core-js/es/object/define-setter": [
        "es.object.define-setter"
      ],
      "core-js/es/object/entries": [
        "es.object.entries"
      ],
      "core-js/es/object/freeze": [
        "es.object.freeze"
      ],
      "core-js/es/object/from-entries": [
        "es.array.iterator",
        "es.object.from-entries"
      ],
      "core-js/es/object/get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/es/object/get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/es/object/get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/es/object/get-own-property-symbols": [
        "es.symbol"
      ],
      "core-js/es/object/get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/es/object/has-own": [
        "es.object.has-own"
      ],
      "core-js/es/object/is": [
        "es.object.is"
      ],
      "core-js/es/object/is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/es/object/is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/es/object/is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/es/object/keys": [
        "es.object.keys"
      ],
      "core-js/es/object/lookup-getter": [
        "es.object.lookup-setter"
      ],
      "core-js/es/object/lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/es/object/prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/es/object/seal": [
        "es.object.seal"
      ],
      "core-js/es/object/set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/es/object/to-string": [
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/object/values": [
        "es.object.values"
      ],
      "core-js/es/parse-float": [
        "es.parse-float"
      ],
      "core-js/es/parse-int": [
        "es.parse-int"
      ],
      "core-js/es/promise": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.string.iterator"
      ],
      "core-js/es/promise/all-settled": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.string.iterator"
      ],
      "core-js/es/promise/any": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.any",
        "es.string.iterator"
      ],
      "core-js/es/promise/finally": [
        "es.object.to-string",
        "es.promise",
        "es.promise.finally"
      ],
      "core-js/es/reflect": [
        "es.object.to-string",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/reflect/apply": [
        "es.reflect.apply"
      ],
      "core-js/es/reflect/construct": [
        "es.reflect.construct"
      ],
      "core-js/es/reflect/define-property": [
        "es.reflect.define-property"
      ],
      "core-js/es/reflect/delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/es/reflect/get": [
        "es.reflect.get"
      ],
      "core-js/es/reflect/get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/es/reflect/get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/es/reflect/has": [
        "es.reflect.has"
      ],
      "core-js/es/reflect/is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/es/reflect/own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/es/reflect/prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/es/reflect/set": [
        "es.reflect.set"
      ],
      "core-js/es/reflect/set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/es/reflect/to-string-tag": [
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/regexp": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.string.match",
        "es.string.replace",
        "es.string.search",
        "es.string.split"
      ],
      "core-js/es/regexp/constructor": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/es/regexp/dot-all": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec"
      ],
      "core-js/es/regexp/flags": [
        "es.regexp.flags"
      ],
      "core-js/es/regexp/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/es/regexp/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/es/regexp/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/es/regexp/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/es/regexp/sticky": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/es/regexp/test": [
        "es.regexp.exec",
        "es.regexp.test"
      ],
      "core-js/es/regexp/to-string": [
        "es.regexp.to-string"
      ],
      "core-js/es/set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.set",
        "es.string.iterator"
      ],
      "core-js/es/string": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/es/string/anchor": [
        "es.string.anchor"
      ],
      "core-js/es/string/at": [
        "es.string.at-alternative"
      ],
      "core-js/es/string/big": [
        "es.string.big"
      ],
      "core-js/es/string/blink": [
        "es.string.blink"
      ],
      "core-js/es/string/bold": [
        "es.string.bold"
      ],
      "core-js/es/string/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/es/string/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/es/string/fixed": [
        "es.string.fixed"
      ],
      "core-js/es/string/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/es/string/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/es/string/from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/es/string/includes": [
        "es.string.includes"
      ],
      "core-js/es/string/italics": [
        "es.string.italics"
      ],
      "core-js/es/string/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/es/string/link": [
        "es.string.link"
      ],
      "core-js/es/string/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/es/string/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/es/string/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/es/string/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/es/string/raw": [
        "es.string.raw"
      ],
      "core-js/es/string/repeat": [
        "es.string.repeat"
      ],
      "core-js/es/string/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/es/string/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/es/string/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/es/string/small": [
        "es.string.small"
      ],
      "core-js/es/string/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/es/string/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/es/string/strike": [
        "es.string.strike"
      ],
      "core-js/es/string/sub": [
        "es.string.sub"
      ],
      "core-js/es/string/substr": [
        "es.string.substr"
      ],
      "core-js/es/string/sup": [
        "es.string.sup"
      ],
      "core-js/es/string/trim": [
        "es.string.trim"
      ],
      "core-js/es/string/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/es/string/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/es/string/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/es/string/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/es/string/virtual": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/es/string/virtual/anchor": [
        "es.string.anchor"
      ],
      "core-js/es/string/virtual/at": [
        "es.string.at-alternative"
      ],
      "core-js/es/string/virtual/big": [
        "es.string.big"
      ],
      "core-js/es/string/virtual/blink": [
        "es.string.blink"
      ],
      "core-js/es/string/virtual/bold": [
        "es.string.bold"
      ],
      "core-js/es/string/virtual/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/es/string/virtual/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/es/string/virtual/fixed": [
        "es.string.fixed"
      ],
      "core-js/es/string/virtual/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/es/string/virtual/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/es/string/virtual/includes": [
        "es.string.includes"
      ],
      "core-js/es/string/virtual/italics": [
        "es.string.italics"
      ],
      "core-js/es/string/virtual/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/es/string/virtual/link": [
        "es.string.link"
      ],
      "core-js/es/string/virtual/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/es/string/virtual/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/es/string/virtual/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/es/string/virtual/repeat": [
        "es.string.repeat"
      ],
      "core-js/es/string/virtual/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/es/string/virtual/small": [
        "es.string.small"
      ],
      "core-js/es/string/virtual/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/es/string/virtual/strike": [
        "es.string.strike"
      ],
      "core-js/es/string/virtual/sub": [
        "es.string.sub"
      ],
      "core-js/es/string/virtual/substr": [
        "es.string.substr"
      ],
      "core-js/es/string/virtual/sup": [
        "es.string.sup"
      ],
      "core-js/es/string/virtual/trim": [
        "es.string.trim"
      ],
      "core-js/es/string/virtual/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/es/string/virtual/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/es/string/virtual/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/es/string/virtual/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/es/symbol": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/symbol/async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/es/symbol/description": [
        "es.symbol.description"
      ],
      "core-js/es/symbol/for": [
        "es.symbol"
      ],
      "core-js/es/symbol/has-instance": [
        "es.symbol.has-instance",
        "es.function.has-instance"
      ],
      "core-js/es/symbol/is-concat-spreadable": [
        "es.symbol.is-concat-spreadable",
        "es.array.concat"
      ],
      "core-js/es/symbol/iterator": [
        "es.symbol.iterator",
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/es/symbol/key-for": [
        "es.symbol"
      ],
      "core-js/es/symbol/match": [
        "es.symbol.match",
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/es/symbol/match-all": [
        "es.symbol.match-all",
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/es/symbol/replace": [
        "es.symbol.replace",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/es/symbol/search": [
        "es.symbol.search",
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/es/symbol/species": [
        "es.symbol.species"
      ],
      "core-js/es/symbol/split": [
        "es.symbol.split",
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/es/symbol/to-primitive": [
        "es.symbol.to-primitive",
        "es.date.to-primitive"
      ],
      "core-js/es/symbol/to-string-tag": [
        "es.symbol.to-string-tag",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/es/symbol/unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/es/typed-array": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/at": [
        "es.typed-array.at"
      ],
      "core-js/es/typed-array/copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/es/typed-array/entries": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/es/typed-array/every": [
        "es.typed-array.every"
      ],
      "core-js/es/typed-array/fill": [
        "es.typed-array.fill"
      ],
      "core-js/es/typed-array/filter": [
        "es.typed-array.filter"
      ],
      "core-js/es/typed-array/find": [
        "es.typed-array.find"
      ],
      "core-js/es/typed-array/find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/es/typed-array/float32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/float64-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float64-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/es/typed-array/from": [
        "es.typed-array.from"
      ],
      "core-js/es/typed-array/includes": [
        "es.typed-array.includes"
      ],
      "core-js/es/typed-array/index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/es/typed-array/int16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/int32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/int8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/iterator": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/es/typed-array/join": [
        "es.typed-array.join"
      ],
      "core-js/es/typed-array/keys": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/es/typed-array/last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/es/typed-array/map": [
        "es.typed-array.map"
      ],
      "core-js/es/typed-array/methods": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/of": [
        "es.typed-array.of"
      ],
      "core-js/es/typed-array/reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/es/typed-array/reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/es/typed-array/reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/es/typed-array/set": [
        "es.typed-array.set"
      ],
      "core-js/es/typed-array/slice": [
        "es.typed-array.slice"
      ],
      "core-js/es/typed-array/some": [
        "es.typed-array.some"
      ],
      "core-js/es/typed-array/sort": [
        "es.typed-array.sort"
      ],
      "core-js/es/typed-array/subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/es/typed-array/to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/es/typed-array/to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/uint16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/uint32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/uint8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/uint8-clamped-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/es/typed-array/values": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/es/unescape": [
        "es.unescape"
      ],
      "core-js/es/weak-map": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-map"
      ],
      "core-js/es/weak-set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-set"
      ],
      "core-js/features": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/features/aggregate-error": [
        "es.error.cause",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.iterator",
        "es.string.iterator",
        "esnext.aggregate-error",
        "web.dom-collections.iterator"
      ],
      "core-js/features/array": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with"
      ],
      "core-js/features/array-buffer": [
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/features/array-buffer/constructor": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/features/array-buffer/is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/features/array-buffer/slice": [
        "es.array-buffer.slice"
      ],
      "core-js/features/array/at": [
        "es.array.at",
        "esnext.array.at"
      ],
      "core-js/features/array/concat": [
        "es.array.concat"
      ],
      "core-js/features/array/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/features/array/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/every": [
        "es.array.every"
      ],
      "core-js/features/array/fill": [
        "es.array.fill"
      ],
      "core-js/features/array/filter": [
        "es.array.filter"
      ],
      "core-js/features/array/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/features/array/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/features/array/find": [
        "es.array.find"
      ],
      "core-js/features/array/find-index": [
        "es.array.find-index"
      ],
      "core-js/features/array/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/features/array/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/features/array/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/features/array/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/features/array/for-each": [
        "es.array.for-each"
      ],
      "core-js/features/array/from": [
        "es.array.from",
        "es.string.iterator"
      ],
      "core-js/features/array/from-async": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.array.from-async"
      ],
      "core-js/features/array/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/features/array/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/features/array/includes": [
        "es.array.includes"
      ],
      "core-js/features/array/index-of": [
        "es.array.index-of"
      ],
      "core-js/features/array/is-array": [
        "es.array.is-array"
      ],
      "core-js/features/array/is-template-object": [
        "esnext.array.is-template-object"
      ],
      "core-js/features/array/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/join": [
        "es.array.join"
      ],
      "core-js/features/array/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/last-index": [
        "esnext.array.last-index"
      ],
      "core-js/features/array/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/features/array/last-item": [
        "esnext.array.last-item"
      ],
      "core-js/features/array/map": [
        "es.array.map"
      ],
      "core-js/features/array/of": [
        "es.array.of"
      ],
      "core-js/features/array/reduce": [
        "es.array.reduce"
      ],
      "core-js/features/array/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/features/array/reverse": [
        "es.array.reverse"
      ],
      "core-js/features/array/slice": [
        "es.array.slice"
      ],
      "core-js/features/array/some": [
        "es.array.some"
      ],
      "core-js/features/array/sort": [
        "es.array.sort"
      ],
      "core-js/features/array/splice": [
        "es.array.splice"
      ],
      "core-js/features/array/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/features/array/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/features/array/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/features/array/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/features/array/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/virtual": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.includes",
        "es.array.index-of",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with"
      ],
      "core-js/features/array/virtual/at": [
        "es.array.at",
        "esnext.array.at"
      ],
      "core-js/features/array/virtual/concat": [
        "es.array.concat"
      ],
      "core-js/features/array/virtual/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/features/array/virtual/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/virtual/every": [
        "es.array.every"
      ],
      "core-js/features/array/virtual/fill": [
        "es.array.fill"
      ],
      "core-js/features/array/virtual/filter": [
        "es.array.filter"
      ],
      "core-js/features/array/virtual/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/features/array/virtual/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/features/array/virtual/find": [
        "es.array.find"
      ],
      "core-js/features/array/virtual/find-index": [
        "es.array.find-index"
      ],
      "core-js/features/array/virtual/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/features/array/virtual/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/features/array/virtual/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/features/array/virtual/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/features/array/virtual/for-each": [
        "es.array.for-each"
      ],
      "core-js/features/array/virtual/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/features/array/virtual/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/features/array/virtual/includes": [
        "es.array.includes"
      ],
      "core-js/features/array/virtual/index-of": [
        "es.array.index-of"
      ],
      "core-js/features/array/virtual/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/virtual/join": [
        "es.array.join"
      ],
      "core-js/features/array/virtual/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/virtual/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/features/array/virtual/map": [
        "es.array.map"
      ],
      "core-js/features/array/virtual/reduce": [
        "es.array.reduce"
      ],
      "core-js/features/array/virtual/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/features/array/virtual/reverse": [
        "es.array.reverse"
      ],
      "core-js/features/array/virtual/slice": [
        "es.array.slice"
      ],
      "core-js/features/array/virtual/some": [
        "es.array.some"
      ],
      "core-js/features/array/virtual/sort": [
        "es.array.sort"
      ],
      "core-js/features/array/virtual/splice": [
        "es.array.splice"
      ],
      "core-js/features/array/virtual/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/features/array/virtual/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/features/array/virtual/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/features/array/virtual/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/features/array/virtual/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/features/array/virtual/with": [
        "esnext.array.with"
      ],
      "core-js/features/array/with": [
        "esnext.array.with"
      ],
      "core-js/features/async-iterator": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "web.dom-collections.iterator"
      ],
      "core-js/features/async-iterator/as-indexed-pairs": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs"
      ],
      "core-js/features/async-iterator/drop": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.drop"
      ],
      "core-js/features/async-iterator/every": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.every"
      ],
      "core-js/features/async-iterator/filter": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.filter"
      ],
      "core-js/features/async-iterator/find": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.find"
      ],
      "core-js/features/async-iterator/flat-map": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.flat-map"
      ],
      "core-js/features/async-iterator/for-each": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.for-each"
      ],
      "core-js/features/async-iterator/from": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/async-iterator/map": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.map"
      ],
      "core-js/features/async-iterator/reduce": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.reduce"
      ],
      "core-js/features/async-iterator/some": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.some"
      ],
      "core-js/features/async-iterator/take": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.take"
      ],
      "core-js/features/async-iterator/to-array": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.to-array"
      ],
      "core-js/features/atob": [
        "es.error.to-string",
        "es.object.to-string",
        "web.atob",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/features/bigint": [
        "es.object.to-string",
        "esnext.bigint.range"
      ],
      "core-js/features/bigint/range": [
        "es.object.to-string",
        "esnext.bigint.range"
      ],
      "core-js/features/btoa": [
        "es.error.to-string",
        "es.object.to-string",
        "web.btoa",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/features/clear-immediate": [
        "web.immediate"
      ],
      "core-js/features/composite-key": [
        "esnext.composite-key"
      ],
      "core-js/features/composite-symbol": [
        "es.symbol",
        "esnext.composite-symbol"
      ],
      "core-js/features/data-view": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.data-view",
        "es.object.to-string"
      ],
      "core-js/features/date": [
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string"
      ],
      "core-js/features/date/get-year": [
        "es.date.get-year"
      ],
      "core-js/features/date/now": [
        "es.date.now"
      ],
      "core-js/features/date/set-year": [
        "es.date.set-year"
      ],
      "core-js/features/date/to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/features/date/to-iso-string": [
        "es.date.to-iso-string",
        "es.date.to-json"
      ],
      "core-js/features/date/to-json": [
        "es.date.to-json"
      ],
      "core-js/features/date/to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/features/date/to-string": [
        "es.date.to-string"
      ],
      "core-js/features/dom-collections": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/features/dom-collections/for-each": [
        "web.dom-collections.for-each"
      ],
      "core-js/features/dom-collections/iterator": [
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/features/dom-exception": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/features/dom-exception/constructor": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack"
      ],
      "core-js/features/dom-exception/to-string-tag": [
        "web.dom-exception.to-string-tag"
      ],
      "core-js/features/error": [
        "es.error.cause",
        "es.error.to-string"
      ],
      "core-js/features/error/constructor": [
        "es.error.cause"
      ],
      "core-js/features/error/to-string": [
        "es.error.to-string"
      ],
      "core-js/features/escape": [
        "es.escape"
      ],
      "core-js/features/function": [
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this"
      ],
      "core-js/features/function/bind": [
        "es.function.bind"
      ],
      "core-js/features/function/has-instance": [
        "es.function.has-instance"
      ],
      "core-js/features/function/is-callable": [
        "esnext.function.is-callable"
      ],
      "core-js/features/function/is-constructor": [
        "esnext.function.is-constructor"
      ],
      "core-js/features/function/name": [
        "es.function.name"
      ],
      "core-js/features/function/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/features/function/virtual": [
        "es.function.bind",
        "esnext.function.un-this"
      ],
      "core-js/features/function/virtual/bind": [
        "es.function.bind"
      ],
      "core-js/features/function/virtual/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/features/get-iterator": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/features/get-iterator-method": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/features/global-this": [
        "es.global-this",
        "esnext.global-this"
      ],
      "core-js/features/instance/at": [
        "es.array.at",
        "es.string.at-alternative",
        "esnext.array.at",
        "esnext.string.at"
      ],
      "core-js/features/instance/bind": [
        "es.function.bind"
      ],
      "core-js/features/instance/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/features/instance/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/features/instance/concat": [
        "es.array.concat"
      ],
      "core-js/features/instance/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/features/instance/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/features/instance/entries": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/features/instance/every": [
        "es.array.every"
      ],
      "core-js/features/instance/fill": [
        "es.array.fill"
      ],
      "core-js/features/instance/filter": [
        "es.array.filter"
      ],
      "core-js/features/instance/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/features/instance/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/features/instance/find": [
        "es.array.find"
      ],
      "core-js/features/instance/find-index": [
        "es.array.find-index"
      ],
      "core-js/features/instance/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/features/instance/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/features/instance/flags": [
        "es.regexp.flags"
      ],
      "core-js/features/instance/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/features/instance/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/features/instance/for-each": [
        "es.array.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/features/instance/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/features/instance/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/features/instance/includes": [
        "es.array.includes",
        "es.string.includes"
      ],
      "core-js/features/instance/index-of": [
        "es.array.index-of"
      ],
      "core-js/features/instance/keys": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/features/instance/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/features/instance/map": [
        "es.array.map"
      ],
      "core-js/features/instance/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/features/instance/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/features/instance/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/features/instance/reduce": [
        "es.array.reduce"
      ],
      "core-js/features/instance/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/features/instance/repeat": [
        "es.string.repeat"
      ],
      "core-js/features/instance/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/features/instance/reverse": [
        "es.array.reverse"
      ],
      "core-js/features/instance/slice": [
        "es.array.slice"
      ],
      "core-js/features/instance/some": [
        "es.array.some"
      ],
      "core-js/features/instance/sort": [
        "es.array.sort"
      ],
      "core-js/features/instance/splice": [
        "es.array.splice"
      ],
      "core-js/features/instance/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/features/instance/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/features/instance/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/features/instance/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/features/instance/trim": [
        "es.string.trim"
      ],
      "core-js/features/instance/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/features/instance/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/features/instance/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/features/instance/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/features/instance/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/features/instance/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/features/instance/values": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/features/instance/with": [
        "esnext.array.with"
      ],
      "core-js/features/is-iterable": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/features/iterator": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "web.dom-collections.iterator"
      ],
      "core-js/features/iterator/as-indexed-pairs": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs"
      ],
      "core-js/features/iterator/drop": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.drop"
      ],
      "core-js/features/iterator/every": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.every"
      ],
      "core-js/features/iterator/filter": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.filter"
      ],
      "core-js/features/iterator/find": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.find"
      ],
      "core-js/features/iterator/flat-map": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.flat-map"
      ],
      "core-js/features/iterator/for-each": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.for-each"
      ],
      "core-js/features/iterator/from": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "esnext.iterator.constructor",
        "esnext.iterator.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/iterator/map": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.map"
      ],
      "core-js/features/iterator/reduce": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.reduce"
      ],
      "core-js/features/iterator/some": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.some"
      ],
      "core-js/features/iterator/take": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.take"
      ],
      "core-js/features/iterator/to-array": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.to-array"
      ],
      "core-js/features/iterator/to-async": [
        "es.object.to-string",
        "es.promise",
        "esnext.iterator.constructor",
        "esnext.iterator.to-async"
      ],
      "core-js/features/json": [
        "es.json.stringify",
        "es.json.to-string-tag"
      ],
      "core-js/features/json/stringify": [
        "es.json.stringify"
      ],
      "core-js/features/json/to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/features/map": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.string.iterator",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "web.dom-collections.iterator"
      ],
      "core-js/features/map/delete-all": [
        "es.map",
        "esnext.map.delete-all"
      ],
      "core-js/features/map/emplace": [
        "es.map",
        "esnext.map.emplace"
      ],
      "core-js/features/map/every": [
        "es.map",
        "esnext.map.every"
      ],
      "core-js/features/map/filter": [
        "es.map",
        "esnext.map.filter"
      ],
      "core-js/features/map/find": [
        "es.map",
        "esnext.map.find"
      ],
      "core-js/features/map/find-key": [
        "es.map",
        "esnext.map.find-key"
      ],
      "core-js/features/map/from": [
        "es.array.iterator",
        "es.map",
        "es.string.iterator",
        "esnext.map.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/map/group-by": [
        "es.map",
        "esnext.map.group-by"
      ],
      "core-js/features/map/includes": [
        "es.map",
        "esnext.map.includes"
      ],
      "core-js/features/map/key-by": [
        "es.map",
        "esnext.map.key-by"
      ],
      "core-js/features/map/key-of": [
        "es.map",
        "esnext.map.key-of"
      ],
      "core-js/features/map/map-keys": [
        "es.map",
        "esnext.map.map-keys"
      ],
      "core-js/features/map/map-values": [
        "es.map",
        "esnext.map.map-values"
      ],
      "core-js/features/map/merge": [
        "es.map",
        "esnext.map.merge"
      ],
      "core-js/features/map/of": [
        "es.array.iterator",
        "es.map",
        "esnext.map.of"
      ],
      "core-js/features/map/reduce": [
        "es.map",
        "esnext.map.reduce"
      ],
      "core-js/features/map/some": [
        "es.map",
        "esnext.map.some"
      ],
      "core-js/features/map/update": [
        "es.map",
        "esnext.map.update"
      ],
      "core-js/features/map/update-or-insert": [
        "es.map",
        "esnext.map.update-or-insert"
      ],
      "core-js/features/map/upsert": [
        "es.map",
        "esnext.map.upsert"
      ],
      "core-js/features/math": [
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh"
      ],
      "core-js/features/math/acosh": [
        "es.math.acosh"
      ],
      "core-js/features/math/asinh": [
        "es.math.asinh"
      ],
      "core-js/features/math/atanh": [
        "es.math.atanh"
      ],
      "core-js/features/math/cbrt": [
        "es.math.cbrt"
      ],
      "core-js/features/math/clamp": [
        "esnext.math.clamp"
      ],
      "core-js/features/math/clz32": [
        "es.math.clz32"
      ],
      "core-js/features/math/cosh": [
        "es.math.cosh"
      ],
      "core-js/features/math/deg-per-rad": [
        "esnext.math.deg-per-rad"
      ],
      "core-js/features/math/degrees": [
        "esnext.math.degrees"
      ],
      "core-js/features/math/expm1": [
        "es.math.expm1"
      ],
      "core-js/features/math/fround": [
        "es.math.fround"
      ],
      "core-js/features/math/fscale": [
        "esnext.math.fscale"
      ],
      "core-js/features/math/hypot": [
        "es.math.hypot"
      ],
      "core-js/features/math/iaddh": [
        "esnext.math.iaddh"
      ],
      "core-js/features/math/imul": [
        "es.math.imul"
      ],
      "core-js/features/math/imulh": [
        "esnext.math.imulh"
      ],
      "core-js/features/math/isubh": [
        "esnext.math.isubh"
      ],
      "core-js/features/math/log10": [
        "es.math.log10"
      ],
      "core-js/features/math/log1p": [
        "es.math.log1p"
      ],
      "core-js/features/math/log2": [
        "es.math.log2"
      ],
      "core-js/features/math/rad-per-deg": [
        "esnext.math.rad-per-deg"
      ],
      "core-js/features/math/radians": [
        "esnext.math.radians"
      ],
      "core-js/features/math/scale": [
        "esnext.math.scale"
      ],
      "core-js/features/math/seeded-prng": [
        "esnext.math.seeded-prng"
      ],
      "core-js/features/math/sign": [
        "es.math.sign"
      ],
      "core-js/features/math/signbit": [
        "esnext.math.signbit"
      ],
      "core-js/features/math/sinh": [
        "es.math.sinh"
      ],
      "core-js/features/math/tanh": [
        "es.math.tanh"
      ],
      "core-js/features/math/to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/features/math/trunc": [
        "es.math.trunc"
      ],
      "core-js/features/math/umulh": [
        "esnext.math.umulh"
      ],
      "core-js/features/number": [
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.to-string",
        "esnext.number.from-string",
        "esnext.number.range"
      ],
      "core-js/features/number/constructor": [
        "es.number.constructor"
      ],
      "core-js/features/number/epsilon": [
        "es.number.epsilon"
      ],
      "core-js/features/number/from-string": [
        "esnext.number.from-string"
      ],
      "core-js/features/number/is-finite": [
        "es.number.is-finite"
      ],
      "core-js/features/number/is-integer": [
        "es.number.is-integer"
      ],
      "core-js/features/number/is-nan": [
        "es.number.is-nan"
      ],
      "core-js/features/number/is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/features/number/max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/features/number/min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/features/number/parse-float": [
        "es.number.parse-float"
      ],
      "core-js/features/number/parse-int": [
        "es.number.parse-int"
      ],
      "core-js/features/number/range": [
        "es.object.to-string",
        "esnext.number.range"
      ],
      "core-js/features/number/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/features/number/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/features/number/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/features/number/virtual": [
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/features/number/virtual/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/features/number/virtual/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/features/number/virtual/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/features/object": [
        "es.symbol",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.reflect.to-string-tag",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "web.dom-collections.iterator"
      ],
      "core-js/features/object/assign": [
        "es.object.assign"
      ],
      "core-js/features/object/create": [
        "es.object.create"
      ],
      "core-js/features/object/define-getter": [
        "es.object.define-getter"
      ],
      "core-js/features/object/define-properties": [
        "es.object.define-properties"
      ],
      "core-js/features/object/define-property": [
        "es.object.define-property"
      ],
      "core-js/features/object/define-setter": [
        "es.object.define-setter"
      ],
      "core-js/features/object/entries": [
        "es.object.entries"
      ],
      "core-js/features/object/freeze": [
        "es.object.freeze"
      ],
      "core-js/features/object/from-entries": [
        "es.array.iterator",
        "es.object.from-entries",
        "web.dom-collections.iterator"
      ],
      "core-js/features/object/get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/features/object/get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/features/object/get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/features/object/get-own-property-symbols": [
        "es.symbol"
      ],
      "core-js/features/object/get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/features/object/has-own": [
        "es.object.has-own",
        "esnext.object.has-own"
      ],
      "core-js/features/object/is": [
        "es.object.is"
      ],
      "core-js/features/object/is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/features/object/is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/features/object/is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/features/object/iterate-entries": [
        "esnext.object.iterate-entries"
      ],
      "core-js/features/object/iterate-keys": [
        "esnext.object.iterate-keys"
      ],
      "core-js/features/object/iterate-values": [
        "esnext.object.iterate-values"
      ],
      "core-js/features/object/keys": [
        "es.object.keys"
      ],
      "core-js/features/object/lookup-getter": [
        "es.object.lookup-setter"
      ],
      "core-js/features/object/lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/features/object/prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/features/object/seal": [
        "es.object.seal"
      ],
      "core-js/features/object/set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/features/object/to-string": [
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/features/object/values": [
        "es.object.values"
      ],
      "core-js/features/observable": [
        "es.object.to-string",
        "es.string.iterator",
        "esnext.observable",
        "esnext.symbol.observable",
        "web.dom-collections.iterator"
      ],
      "core-js/features/parse-float": [
        "es.parse-float"
      ],
      "core-js/features/parse-int": [
        "es.parse-int"
      ],
      "core-js/features/promise": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.string.iterator",
        "esnext.aggregate-error",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "web.dom-collections.iterator"
      ],
      "core-js/features/promise/all-settled": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.string.iterator",
        "esnext.promise.all-settled",
        "web.dom-collections.iterator"
      ],
      "core-js/features/promise/any": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.any",
        "es.string.iterator",
        "esnext.aggregate-error",
        "esnext.promise.any",
        "web.dom-collections.iterator"
      ],
      "core-js/features/promise/finally": [
        "es.object.to-string",
        "es.promise",
        "es.promise.finally"
      ],
      "core-js/features/promise/try": [
        "es.promise",
        "esnext.promise.try"
      ],
      "core-js/features/queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/features/reflect": [
        "es.object.to-string",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata"
      ],
      "core-js/features/reflect/apply": [
        "es.reflect.apply"
      ],
      "core-js/features/reflect/construct": [
        "es.reflect.construct"
      ],
      "core-js/features/reflect/define-metadata": [
        "esnext.reflect.define-metadata"
      ],
      "core-js/features/reflect/define-property": [
        "es.reflect.define-property"
      ],
      "core-js/features/reflect/delete-metadata": [
        "esnext.reflect.delete-metadata"
      ],
      "core-js/features/reflect/delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/features/reflect/get": [
        "es.reflect.get"
      ],
      "core-js/features/reflect/get-metadata": [
        "esnext.reflect.get-metadata"
      ],
      "core-js/features/reflect/get-metadata-keys": [
        "esnext.reflect.get-metadata-keys"
      ],
      "core-js/features/reflect/get-own-metadata": [
        "esnext.reflect.get-own-metadata"
      ],
      "core-js/features/reflect/get-own-metadata-keys": [
        "esnext.reflect.get-own-metadata-keys"
      ],
      "core-js/features/reflect/get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/features/reflect/get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/features/reflect/has": [
        "es.reflect.has"
      ],
      "core-js/features/reflect/has-metadata": [
        "esnext.reflect.has-metadata"
      ],
      "core-js/features/reflect/has-own-metadata": [
        "esnext.reflect.has-own-metadata"
      ],
      "core-js/features/reflect/is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/features/reflect/metadata": [
        "esnext.reflect.metadata"
      ],
      "core-js/features/reflect/own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/features/reflect/prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/features/reflect/set": [
        "es.reflect.set"
      ],
      "core-js/features/reflect/set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/features/reflect/to-string-tag": [
        "es.reflect.to-string-tag"
      ],
      "core-js/features/regexp": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.string.match",
        "es.string.replace",
        "es.string.search",
        "es.string.split"
      ],
      "core-js/features/regexp/constructor": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/features/regexp/dot-all": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec"
      ],
      "core-js/features/regexp/flags": [
        "es.regexp.flags"
      ],
      "core-js/features/regexp/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/features/regexp/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/features/regexp/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/features/regexp/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/features/regexp/sticky": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/features/regexp/test": [
        "es.regexp.exec",
        "es.regexp.test"
      ],
      "core-js/features/regexp/to-string": [
        "es.regexp.to-string"
      ],
      "core-js/features/set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.set",
        "es.string.iterator",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set-immediate": [
        "web.immediate"
      ],
      "core-js/features/set-interval": [
        "web.timers"
      ],
      "core-js/features/set-timeout": [
        "web.timers"
      ],
      "core-js/features/set/add-all": [
        "es.set",
        "esnext.set.add-all"
      ],
      "core-js/features/set/delete-all": [
        "es.set",
        "esnext.set.delete-all"
      ],
      "core-js/features/set/difference": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.difference",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/every": [
        "es.set",
        "esnext.set.every"
      ],
      "core-js/features/set/filter": [
        "es.set",
        "esnext.set.filter"
      ],
      "core-js/features/set/find": [
        "es.set",
        "esnext.set.find"
      ],
      "core-js/features/set/from": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/intersection": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.intersection",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/is-disjoint-from": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-disjoint-from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/is-subset-of": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-subset-of",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/is-superset-of": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-superset-of",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/join": [
        "es.set",
        "esnext.set.join"
      ],
      "core-js/features/set/map": [
        "es.set",
        "esnext.set.map"
      ],
      "core-js/features/set/of": [
        "es.array.iterator",
        "es.set",
        "esnext.set.of"
      ],
      "core-js/features/set/reduce": [
        "es.set",
        "esnext.set.reduce"
      ],
      "core-js/features/set/some": [
        "es.set",
        "esnext.set.some"
      ],
      "core-js/features/set/symmetric-difference": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.symmetric-difference",
        "web.dom-collections.iterator"
      ],
      "core-js/features/set/union": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.union",
        "web.dom-collections.iterator"
      ],
      "core-js/features/string": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all"
      ],
      "core-js/features/string/anchor": [
        "es.string.anchor"
      ],
      "core-js/features/string/at": [
        "es.string.at-alternative",
        "esnext.string.at"
      ],
      "core-js/features/string/big": [
        "es.string.big"
      ],
      "core-js/features/string/blink": [
        "es.string.blink"
      ],
      "core-js/features/string/bold": [
        "es.string.bold"
      ],
      "core-js/features/string/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/features/string/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/features/string/cooked": [
        "esnext.string.cooked"
      ],
      "core-js/features/string/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/features/string/fixed": [
        "es.string.fixed"
      ],
      "core-js/features/string/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/features/string/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/features/string/from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/features/string/includes": [
        "es.string.includes"
      ],
      "core-js/features/string/italics": [
        "es.string.italics"
      ],
      "core-js/features/string/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/features/string/link": [
        "es.string.link"
      ],
      "core-js/features/string/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/features/string/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/features/string/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/features/string/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/features/string/raw": [
        "es.string.raw"
      ],
      "core-js/features/string/repeat": [
        "es.string.repeat"
      ],
      "core-js/features/string/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/features/string/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all",
        "esnext.string.replace-all"
      ],
      "core-js/features/string/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/features/string/small": [
        "es.string.small"
      ],
      "core-js/features/string/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/features/string/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/features/string/strike": [
        "es.string.strike"
      ],
      "core-js/features/string/sub": [
        "es.string.sub"
      ],
      "core-js/features/string/substr": [
        "es.string.substr"
      ],
      "core-js/features/string/sup": [
        "es.string.sup"
      ],
      "core-js/features/string/trim": [
        "es.string.trim"
      ],
      "core-js/features/string/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/features/string/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/features/string/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/features/string/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/features/string/virtual": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "esnext.string.at",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all"
      ],
      "core-js/features/string/virtual/anchor": [
        "es.string.anchor"
      ],
      "core-js/features/string/virtual/at": [
        "es.string.at-alternative",
        "esnext.string.at"
      ],
      "core-js/features/string/virtual/big": [
        "es.string.big"
      ],
      "core-js/features/string/virtual/blink": [
        "es.string.blink"
      ],
      "core-js/features/string/virtual/bold": [
        "es.string.bold"
      ],
      "core-js/features/string/virtual/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/features/string/virtual/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/features/string/virtual/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/features/string/virtual/fixed": [
        "es.string.fixed"
      ],
      "core-js/features/string/virtual/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/features/string/virtual/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/features/string/virtual/includes": [
        "es.string.includes"
      ],
      "core-js/features/string/virtual/italics": [
        "es.string.italics"
      ],
      "core-js/features/string/virtual/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/features/string/virtual/link": [
        "es.string.link"
      ],
      "core-js/features/string/virtual/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/features/string/virtual/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/features/string/virtual/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/features/string/virtual/repeat": [
        "es.string.repeat"
      ],
      "core-js/features/string/virtual/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all",
        "esnext.string.replace-all"
      ],
      "core-js/features/string/virtual/small": [
        "es.string.small"
      ],
      "core-js/features/string/virtual/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/features/string/virtual/strike": [
        "es.string.strike"
      ],
      "core-js/features/string/virtual/sub": [
        "es.string.sub"
      ],
      "core-js/features/string/virtual/substr": [
        "es.string.substr"
      ],
      "core-js/features/string/virtual/sup": [
        "es.string.sup"
      ],
      "core-js/features/string/virtual/trim": [
        "es.string.trim"
      ],
      "core-js/features/string/virtual/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/features/string/virtual/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/features/string/virtual/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/features/string/virtual/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/features/structured-clone": [
        "es.error.to-string",
        "es.array.iterator",
        "es.map",
        "es.object.keys",
        "es.object.to-string",
        "es.set",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.structured-clone"
      ],
      "core-js/features/symbol": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "web.dom-collections.iterator"
      ],
      "core-js/features/symbol/async-dispose": [
        "esnext.symbol.async-dispose"
      ],
      "core-js/features/symbol/async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/features/symbol/description": [
        "es.symbol.description"
      ],
      "core-js/features/symbol/dispose": [
        "esnext.symbol.dispose"
      ],
      "core-js/features/symbol/for": [
        "es.symbol"
      ],
      "core-js/features/symbol/has-instance": [
        "es.symbol.has-instance",
        "es.function.has-instance"
      ],
      "core-js/features/symbol/is-concat-spreadable": [
        "es.symbol.is-concat-spreadable",
        "es.array.concat"
      ],
      "core-js/features/symbol/iterator": [
        "es.symbol.iterator",
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/features/symbol/key-for": [
        "es.symbol"
      ],
      "core-js/features/symbol/match": [
        "es.symbol.match",
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/features/symbol/match-all": [
        "es.symbol.match-all",
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/features/symbol/matcher": [
        "esnext.symbol.matcher"
      ],
      "core-js/features/symbol/metadata": [
        "esnext.symbol.metadata"
      ],
      "core-js/features/symbol/observable": [
        "esnext.symbol.observable"
      ],
      "core-js/features/symbol/pattern-match": [
        "esnext.symbol.pattern-match"
      ],
      "core-js/features/symbol/replace": [
        "es.symbol.replace",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/features/symbol/replace-all": [
        "esnext.symbol.replace-all"
      ],
      "core-js/features/symbol/search": [
        "es.symbol.search",
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/features/symbol/species": [
        "es.symbol.species"
      ],
      "core-js/features/symbol/split": [
        "es.symbol.split",
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/features/symbol/to-primitive": [
        "es.symbol.to-primitive",
        "es.date.to-primitive"
      ],
      "core-js/features/symbol/to-string-tag": [
        "es.symbol.to-string-tag",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/features/symbol/unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/features/typed-array": [
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/at": [
        "es.typed-array.every",
        "esnext.typed-array.at"
      ],
      "core-js/features/typed-array/copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/features/typed-array/entries": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/features/typed-array/every": [
        "es.typed-array.every"
      ],
      "core-js/features/typed-array/fill": [
        "es.typed-array.fill"
      ],
      "core-js/features/typed-array/filter": [
        "es.typed-array.filter"
      ],
      "core-js/features/typed-array/filter-out": [
        "esnext.typed-array.filter-out"
      ],
      "core-js/features/typed-array/filter-reject": [
        "esnext.typed-array.filter-reject"
      ],
      "core-js/features/typed-array/find": [
        "es.typed-array.find"
      ],
      "core-js/features/typed-array/find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/features/typed-array/find-last": [
        "esnext.typed-array.find-last"
      ],
      "core-js/features/typed-array/find-last-index": [
        "esnext.typed-array.find-last-index"
      ],
      "core-js/features/typed-array/float32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/float64-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float64-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/features/typed-array/from": [
        "es.typed-array.from"
      ],
      "core-js/features/typed-array/from-async": [
        "esnext.typed-array.from-async"
      ],
      "core-js/features/typed-array/group-by": [
        "esnext.typed-array.group-by"
      ],
      "core-js/features/typed-array/includes": [
        "es.typed-array.includes"
      ],
      "core-js/features/typed-array/index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/features/typed-array/int16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/int32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/int8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/iterator": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/features/typed-array/join": [
        "es.typed-array.join"
      ],
      "core-js/features/typed-array/keys": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/features/typed-array/last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/features/typed-array/map": [
        "es.typed-array.map"
      ],
      "core-js/features/typed-array/methods": [
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/of": [
        "es.typed-array.of"
      ],
      "core-js/features/typed-array/reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/features/typed-array/reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/features/typed-array/reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/features/typed-array/set": [
        "es.typed-array.set"
      ],
      "core-js/features/typed-array/slice": [
        "es.typed-array.slice"
      ],
      "core-js/features/typed-array/some": [
        "es.typed-array.some"
      ],
      "core-js/features/typed-array/sort": [
        "es.typed-array.sort"
      ],
      "core-js/features/typed-array/subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/features/typed-array/to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/features/typed-array/to-reversed": [
        "esnext.typed-array.to-reversed"
      ],
      "core-js/features/typed-array/to-sorted": [
        "es.typed-array.sort",
        "esnext.typed-array.to-sorted"
      ],
      "core-js/features/typed-array/to-spliced": [
        "esnext.typed-array.to-spliced"
      ],
      "core-js/features/typed-array/to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/features/typed-array/uint16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/uint32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/uint8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/uint8-clamped-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/features/typed-array/unique-by": [
        "es.map",
        "esnext.typed-array.unique-by"
      ],
      "core-js/features/typed-array/values": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/features/typed-array/with": [
        "esnext.typed-array.with"
      ],
      "core-js/features/unescape": [
        "es.unescape"
      ],
      "core-js/features/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/features/url-search-params": [
        "web.dom-collections.iterator",
        "web.url-search-params"
      ],
      "core-js/features/url/to-json": [
        "web.url.to-json"
      ],
      "core-js/features/weak-map": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "es.weak-map",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "web.dom-collections.iterator"
      ],
      "core-js/features/weak-map/delete-all": [
        "es.weak-map",
        "esnext.weak-map.delete-all"
      ],
      "core-js/features/weak-map/emplace": [
        "es.weak-map",
        "esnext.weak-map.emplace"
      ],
      "core-js/features/weak-map/from": [
        "es.array.iterator",
        "es.string.iterator",
        "es.weak-map",
        "esnext.weak-map.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/weak-map/of": [
        "es.array.iterator",
        "es.weak-map",
        "esnext.weak-map.of"
      ],
      "core-js/features/weak-map/upsert": [
        "es.weak-map",
        "esnext.weak-map.upsert"
      ],
      "core-js/features/weak-set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "es.weak-set",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.dom-collections.iterator"
      ],
      "core-js/features/weak-set/add-all": [
        "es.weak-set",
        "esnext.weak-set.add-all"
      ],
      "core-js/features/weak-set/delete-all": [
        "es.weak-set",
        "esnext.weak-set.delete-all"
      ],
      "core-js/features/weak-set/from": [
        "es.array.iterator",
        "es.string.iterator",
        "es.weak-set",
        "esnext.weak-set.from",
        "web.dom-collections.iterator"
      ],
      "core-js/features/weak-set/of": [
        "es.array.iterator",
        "es.weak-set",
        "esnext.weak-set.of"
      ],
      "core-js/full": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/full/aggregate-error": [
        "es.error.cause",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.iterator",
        "es.string.iterator",
        "esnext.aggregate-error",
        "web.dom-collections.iterator"
      ],
      "core-js/full/array": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with"
      ],
      "core-js/full/array-buffer": [
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/full/array-buffer/constructor": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/full/array-buffer/is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/full/array-buffer/slice": [
        "es.array-buffer.slice"
      ],
      "core-js/full/array/at": [
        "es.array.at",
        "esnext.array.at"
      ],
      "core-js/full/array/concat": [
        "es.array.concat"
      ],
      "core-js/full/array/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/full/array/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/every": [
        "es.array.every"
      ],
      "core-js/full/array/fill": [
        "es.array.fill"
      ],
      "core-js/full/array/filter": [
        "es.array.filter"
      ],
      "core-js/full/array/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/full/array/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/full/array/find": [
        "es.array.find"
      ],
      "core-js/full/array/find-index": [
        "es.array.find-index"
      ],
      "core-js/full/array/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/full/array/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/full/array/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/full/array/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/full/array/for-each": [
        "es.array.for-each"
      ],
      "core-js/full/array/from": [
        "es.array.from",
        "es.string.iterator"
      ],
      "core-js/full/array/from-async": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.array.from-async"
      ],
      "core-js/full/array/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/full/array/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/full/array/includes": [
        "es.array.includes"
      ],
      "core-js/full/array/index-of": [
        "es.array.index-of"
      ],
      "core-js/full/array/is-array": [
        "es.array.is-array"
      ],
      "core-js/full/array/is-template-object": [
        "esnext.array.is-template-object"
      ],
      "core-js/full/array/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/join": [
        "es.array.join"
      ],
      "core-js/full/array/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/last-index": [
        "esnext.array.last-index"
      ],
      "core-js/full/array/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/full/array/last-item": [
        "esnext.array.last-item"
      ],
      "core-js/full/array/map": [
        "es.array.map"
      ],
      "core-js/full/array/of": [
        "es.array.of"
      ],
      "core-js/full/array/reduce": [
        "es.array.reduce"
      ],
      "core-js/full/array/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/full/array/reverse": [
        "es.array.reverse"
      ],
      "core-js/full/array/slice": [
        "es.array.slice"
      ],
      "core-js/full/array/some": [
        "es.array.some"
      ],
      "core-js/full/array/sort": [
        "es.array.sort"
      ],
      "core-js/full/array/splice": [
        "es.array.splice"
      ],
      "core-js/full/array/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/full/array/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/full/array/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/full/array/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/full/array/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/virtual": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.includes",
        "es.array.index-of",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.map",
        "es.object.to-string",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with"
      ],
      "core-js/full/array/virtual/at": [
        "es.array.at",
        "esnext.array.at"
      ],
      "core-js/full/array/virtual/concat": [
        "es.array.concat"
      ],
      "core-js/full/array/virtual/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/full/array/virtual/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/virtual/every": [
        "es.array.every"
      ],
      "core-js/full/array/virtual/fill": [
        "es.array.fill"
      ],
      "core-js/full/array/virtual/filter": [
        "es.array.filter"
      ],
      "core-js/full/array/virtual/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/full/array/virtual/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/full/array/virtual/find": [
        "es.array.find"
      ],
      "core-js/full/array/virtual/find-index": [
        "es.array.find-index"
      ],
      "core-js/full/array/virtual/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/full/array/virtual/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/full/array/virtual/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/full/array/virtual/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/full/array/virtual/for-each": [
        "es.array.for-each"
      ],
      "core-js/full/array/virtual/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/full/array/virtual/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/full/array/virtual/includes": [
        "es.array.includes"
      ],
      "core-js/full/array/virtual/index-of": [
        "es.array.index-of"
      ],
      "core-js/full/array/virtual/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/virtual/join": [
        "es.array.join"
      ],
      "core-js/full/array/virtual/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/virtual/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/full/array/virtual/map": [
        "es.array.map"
      ],
      "core-js/full/array/virtual/reduce": [
        "es.array.reduce"
      ],
      "core-js/full/array/virtual/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/full/array/virtual/reverse": [
        "es.array.reverse"
      ],
      "core-js/full/array/virtual/slice": [
        "es.array.slice"
      ],
      "core-js/full/array/virtual/some": [
        "es.array.some"
      ],
      "core-js/full/array/virtual/sort": [
        "es.array.sort"
      ],
      "core-js/full/array/virtual/splice": [
        "es.array.splice"
      ],
      "core-js/full/array/virtual/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/full/array/virtual/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/full/array/virtual/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/full/array/virtual/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/full/array/virtual/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/full/array/virtual/with": [
        "esnext.array.with"
      ],
      "core-js/full/array/with": [
        "esnext.array.with"
      ],
      "core-js/full/async-iterator": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "web.dom-collections.iterator"
      ],
      "core-js/full/async-iterator/as-indexed-pairs": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs"
      ],
      "core-js/full/async-iterator/drop": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.drop"
      ],
      "core-js/full/async-iterator/every": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.every"
      ],
      "core-js/full/async-iterator/filter": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.filter"
      ],
      "core-js/full/async-iterator/find": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.find"
      ],
      "core-js/full/async-iterator/flat-map": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.flat-map"
      ],
      "core-js/full/async-iterator/for-each": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.for-each"
      ],
      "core-js/full/async-iterator/from": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/async-iterator/map": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.map"
      ],
      "core-js/full/async-iterator/reduce": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.reduce"
      ],
      "core-js/full/async-iterator/some": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.some"
      ],
      "core-js/full/async-iterator/take": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.take"
      ],
      "core-js/full/async-iterator/to-array": [
        "es.object.to-string",
        "es.promise",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.to-array"
      ],
      "core-js/full/atob": [
        "es.error.to-string",
        "es.object.to-string",
        "web.atob",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/full/bigint": [
        "es.object.to-string",
        "esnext.bigint.range"
      ],
      "core-js/full/bigint/range": [
        "es.object.to-string",
        "esnext.bigint.range"
      ],
      "core-js/full/btoa": [
        "es.error.to-string",
        "es.object.to-string",
        "web.btoa",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/full/clear-immediate": [
        "web.immediate"
      ],
      "core-js/full/composite-key": [
        "esnext.composite-key"
      ],
      "core-js/full/composite-symbol": [
        "es.symbol",
        "esnext.composite-symbol"
      ],
      "core-js/full/data-view": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.data-view",
        "es.object.to-string"
      ],
      "core-js/full/date": [
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string"
      ],
      "core-js/full/date/get-year": [
        "es.date.get-year"
      ],
      "core-js/full/date/now": [
        "es.date.now"
      ],
      "core-js/full/date/set-year": [
        "es.date.set-year"
      ],
      "core-js/full/date/to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/full/date/to-iso-string": [
        "es.date.to-iso-string",
        "es.date.to-json"
      ],
      "core-js/full/date/to-json": [
        "es.date.to-json"
      ],
      "core-js/full/date/to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/full/date/to-string": [
        "es.date.to-string"
      ],
      "core-js/full/dom-collections": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/full/dom-collections/for-each": [
        "web.dom-collections.for-each"
      ],
      "core-js/full/dom-collections/iterator": [
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/full/dom-exception": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/full/dom-exception/constructor": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack"
      ],
      "core-js/full/dom-exception/to-string-tag": [
        "web.dom-exception.to-string-tag"
      ],
      "core-js/full/error": [
        "es.error.cause",
        "es.error.to-string"
      ],
      "core-js/full/error/constructor": [
        "es.error.cause"
      ],
      "core-js/full/error/to-string": [
        "es.error.to-string"
      ],
      "core-js/full/escape": [
        "es.escape"
      ],
      "core-js/full/function": [
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this"
      ],
      "core-js/full/function/bind": [
        "es.function.bind"
      ],
      "core-js/full/function/has-instance": [
        "es.function.has-instance"
      ],
      "core-js/full/function/is-callable": [
        "esnext.function.is-callable"
      ],
      "core-js/full/function/is-constructor": [
        "esnext.function.is-constructor"
      ],
      "core-js/full/function/name": [
        "es.function.name"
      ],
      "core-js/full/function/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/full/function/virtual": [
        "es.function.bind",
        "esnext.function.un-this"
      ],
      "core-js/full/function/virtual/bind": [
        "es.function.bind"
      ],
      "core-js/full/function/virtual/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/full/get-iterator": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/full/get-iterator-method": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/full/global-this": [
        "es.global-this",
        "esnext.global-this"
      ],
      "core-js/full/instance/at": [
        "es.array.at",
        "es.string.at-alternative",
        "esnext.array.at",
        "esnext.string.at"
      ],
      "core-js/full/instance/bind": [
        "es.function.bind"
      ],
      "core-js/full/instance/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/full/instance/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/full/instance/concat": [
        "es.array.concat"
      ],
      "core-js/full/instance/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/full/instance/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/full/instance/entries": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/full/instance/every": [
        "es.array.every"
      ],
      "core-js/full/instance/fill": [
        "es.array.fill"
      ],
      "core-js/full/instance/filter": [
        "es.array.filter"
      ],
      "core-js/full/instance/filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/full/instance/filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/full/instance/find": [
        "es.array.find"
      ],
      "core-js/full/instance/find-index": [
        "es.array.find-index"
      ],
      "core-js/full/instance/find-last": [
        "esnext.array.find-last"
      ],
      "core-js/full/instance/find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/full/instance/flags": [
        "es.regexp.flags"
      ],
      "core-js/full/instance/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/full/instance/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/full/instance/for-each": [
        "es.array.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/full/instance/group-by": [
        "esnext.array.group-by"
      ],
      "core-js/full/instance/group-by-to-map": [
        "es.map",
        "es.object.to-string",
        "esnext.array.group-by-to-map"
      ],
      "core-js/full/instance/includes": [
        "es.array.includes",
        "es.string.includes"
      ],
      "core-js/full/instance/index-of": [
        "es.array.index-of"
      ],
      "core-js/full/instance/keys": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/full/instance/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/full/instance/map": [
        "es.array.map"
      ],
      "core-js/full/instance/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/full/instance/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/full/instance/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/full/instance/reduce": [
        "es.array.reduce"
      ],
      "core-js/full/instance/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/full/instance/repeat": [
        "es.string.repeat"
      ],
      "core-js/full/instance/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/full/instance/reverse": [
        "es.array.reverse"
      ],
      "core-js/full/instance/slice": [
        "es.array.slice"
      ],
      "core-js/full/instance/some": [
        "es.array.some"
      ],
      "core-js/full/instance/sort": [
        "es.array.sort"
      ],
      "core-js/full/instance/splice": [
        "es.array.splice"
      ],
      "core-js/full/instance/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/full/instance/to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/full/instance/to-sorted": [
        "es.array.sort",
        "esnext.array.to-sorted"
      ],
      "core-js/full/instance/to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/full/instance/trim": [
        "es.string.trim"
      ],
      "core-js/full/instance/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/full/instance/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/full/instance/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/full/instance/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/full/instance/un-this": [
        "esnext.function.un-this"
      ],
      "core-js/full/instance/unique-by": [
        "es.map",
        "esnext.array.unique-by"
      ],
      "core-js/full/instance/values": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/full/instance/with": [
        "esnext.array.with"
      ],
      "core-js/full/is-iterable": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/full/iterator": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "web.dom-collections.iterator"
      ],
      "core-js/full/iterator/as-indexed-pairs": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs"
      ],
      "core-js/full/iterator/drop": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.drop"
      ],
      "core-js/full/iterator/every": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.every"
      ],
      "core-js/full/iterator/filter": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.filter"
      ],
      "core-js/full/iterator/find": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.find"
      ],
      "core-js/full/iterator/flat-map": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.flat-map"
      ],
      "core-js/full/iterator/for-each": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.for-each"
      ],
      "core-js/full/iterator/from": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "esnext.iterator.constructor",
        "esnext.iterator.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/iterator/map": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.map"
      ],
      "core-js/full/iterator/reduce": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.reduce"
      ],
      "core-js/full/iterator/some": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.some"
      ],
      "core-js/full/iterator/take": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.take"
      ],
      "core-js/full/iterator/to-array": [
        "es.object.to-string",
        "esnext.iterator.constructor",
        "esnext.iterator.to-array"
      ],
      "core-js/full/iterator/to-async": [
        "es.object.to-string",
        "es.promise",
        "esnext.iterator.constructor",
        "esnext.iterator.to-async"
      ],
      "core-js/full/json": [
        "es.json.stringify",
        "es.json.to-string-tag"
      ],
      "core-js/full/json/stringify": [
        "es.json.stringify"
      ],
      "core-js/full/json/to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/full/map": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.string.iterator",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "web.dom-collections.iterator"
      ],
      "core-js/full/map/delete-all": [
        "es.map",
        "esnext.map.delete-all"
      ],
      "core-js/full/map/emplace": [
        "es.map",
        "esnext.map.emplace"
      ],
      "core-js/full/map/every": [
        "es.map",
        "esnext.map.every"
      ],
      "core-js/full/map/filter": [
        "es.map",
        "esnext.map.filter"
      ],
      "core-js/full/map/find": [
        "es.map",
        "esnext.map.find"
      ],
      "core-js/full/map/find-key": [
        "es.map",
        "esnext.map.find-key"
      ],
      "core-js/full/map/from": [
        "es.array.iterator",
        "es.map",
        "es.string.iterator",
        "esnext.map.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/map/group-by": [
        "es.map",
        "esnext.map.group-by"
      ],
      "core-js/full/map/includes": [
        "es.map",
        "esnext.map.includes"
      ],
      "core-js/full/map/key-by": [
        "es.map",
        "esnext.map.key-by"
      ],
      "core-js/full/map/key-of": [
        "es.map",
        "esnext.map.key-of"
      ],
      "core-js/full/map/map-keys": [
        "es.map",
        "esnext.map.map-keys"
      ],
      "core-js/full/map/map-values": [
        "es.map",
        "esnext.map.map-values"
      ],
      "core-js/full/map/merge": [
        "es.map",
        "esnext.map.merge"
      ],
      "core-js/full/map/of": [
        "es.array.iterator",
        "es.map",
        "esnext.map.of"
      ],
      "core-js/full/map/reduce": [
        "es.map",
        "esnext.map.reduce"
      ],
      "core-js/full/map/some": [
        "es.map",
        "esnext.map.some"
      ],
      "core-js/full/map/update": [
        "es.map",
        "esnext.map.update"
      ],
      "core-js/full/map/update-or-insert": [
        "es.map",
        "esnext.map.update-or-insert"
      ],
      "core-js/full/map/upsert": [
        "es.map",
        "esnext.map.upsert"
      ],
      "core-js/full/math": [
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh"
      ],
      "core-js/full/math/acosh": [
        "es.math.acosh"
      ],
      "core-js/full/math/asinh": [
        "es.math.asinh"
      ],
      "core-js/full/math/atanh": [
        "es.math.atanh"
      ],
      "core-js/full/math/cbrt": [
        "es.math.cbrt"
      ],
      "core-js/full/math/clamp": [
        "esnext.math.clamp"
      ],
      "core-js/full/math/clz32": [
        "es.math.clz32"
      ],
      "core-js/full/math/cosh": [
        "es.math.cosh"
      ],
      "core-js/full/math/deg-per-rad": [
        "esnext.math.deg-per-rad"
      ],
      "core-js/full/math/degrees": [
        "esnext.math.degrees"
      ],
      "core-js/full/math/expm1": [
        "es.math.expm1"
      ],
      "core-js/full/math/fround": [
        "es.math.fround"
      ],
      "core-js/full/math/fscale": [
        "esnext.math.fscale"
      ],
      "core-js/full/math/hypot": [
        "es.math.hypot"
      ],
      "core-js/full/math/iaddh": [
        "esnext.math.iaddh"
      ],
      "core-js/full/math/imul": [
        "es.math.imul"
      ],
      "core-js/full/math/imulh": [
        "esnext.math.imulh"
      ],
      "core-js/full/math/isubh": [
        "esnext.math.isubh"
      ],
      "core-js/full/math/log10": [
        "es.math.log10"
      ],
      "core-js/full/math/log1p": [
        "es.math.log1p"
      ],
      "core-js/full/math/log2": [
        "es.math.log2"
      ],
      "core-js/full/math/rad-per-deg": [
        "esnext.math.rad-per-deg"
      ],
      "core-js/full/math/radians": [
        "esnext.math.radians"
      ],
      "core-js/full/math/scale": [
        "esnext.math.scale"
      ],
      "core-js/full/math/seeded-prng": [
        "esnext.math.seeded-prng"
      ],
      "core-js/full/math/sign": [
        "es.math.sign"
      ],
      "core-js/full/math/signbit": [
        "esnext.math.signbit"
      ],
      "core-js/full/math/sinh": [
        "es.math.sinh"
      ],
      "core-js/full/math/tanh": [
        "es.math.tanh"
      ],
      "core-js/full/math/to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/full/math/trunc": [
        "es.math.trunc"
      ],
      "core-js/full/math/umulh": [
        "esnext.math.umulh"
      ],
      "core-js/full/number": [
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.to-string",
        "esnext.number.from-string",
        "esnext.number.range"
      ],
      "core-js/full/number/constructor": [
        "es.number.constructor"
      ],
      "core-js/full/number/epsilon": [
        "es.number.epsilon"
      ],
      "core-js/full/number/from-string": [
        "esnext.number.from-string"
      ],
      "core-js/full/number/is-finite": [
        "es.number.is-finite"
      ],
      "core-js/full/number/is-integer": [
        "es.number.is-integer"
      ],
      "core-js/full/number/is-nan": [
        "es.number.is-nan"
      ],
      "core-js/full/number/is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/full/number/max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/full/number/min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/full/number/parse-float": [
        "es.number.parse-float"
      ],
      "core-js/full/number/parse-int": [
        "es.number.parse-int"
      ],
      "core-js/full/number/range": [
        "es.object.to-string",
        "esnext.number.range"
      ],
      "core-js/full/number/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/full/number/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/full/number/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/full/number/virtual": [
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/full/number/virtual/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/full/number/virtual/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/full/number/virtual/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/full/object": [
        "es.symbol",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.reflect.to-string-tag",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "web.dom-collections.iterator"
      ],
      "core-js/full/object/assign": [
        "es.object.assign"
      ],
      "core-js/full/object/create": [
        "es.object.create"
      ],
      "core-js/full/object/define-getter": [
        "es.object.define-getter"
      ],
      "core-js/full/object/define-properties": [
        "es.object.define-properties"
      ],
      "core-js/full/object/define-property": [
        "es.object.define-property"
      ],
      "core-js/full/object/define-setter": [
        "es.object.define-setter"
      ],
      "core-js/full/object/entries": [
        "es.object.entries"
      ],
      "core-js/full/object/freeze": [
        "es.object.freeze"
      ],
      "core-js/full/object/from-entries": [
        "es.array.iterator",
        "es.object.from-entries",
        "web.dom-collections.iterator"
      ],
      "core-js/full/object/get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/full/object/get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/full/object/get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/full/object/get-own-property-symbols": [
        "es.symbol"
      ],
      "core-js/full/object/get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/full/object/has-own": [
        "es.object.has-own",
        "esnext.object.has-own"
      ],
      "core-js/full/object/is": [
        "es.object.is"
      ],
      "core-js/full/object/is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/full/object/is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/full/object/is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/full/object/iterate-entries": [
        "esnext.object.iterate-entries"
      ],
      "core-js/full/object/iterate-keys": [
        "esnext.object.iterate-keys"
      ],
      "core-js/full/object/iterate-values": [
        "esnext.object.iterate-values"
      ],
      "core-js/full/object/keys": [
        "es.object.keys"
      ],
      "core-js/full/object/lookup-getter": [
        "es.object.lookup-setter"
      ],
      "core-js/full/object/lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/full/object/prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/full/object/seal": [
        "es.object.seal"
      ],
      "core-js/full/object/set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/full/object/to-string": [
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/full/object/values": [
        "es.object.values"
      ],
      "core-js/full/observable": [
        "es.object.to-string",
        "es.string.iterator",
        "esnext.observable",
        "esnext.symbol.observable",
        "web.dom-collections.iterator"
      ],
      "core-js/full/parse-float": [
        "es.parse-float"
      ],
      "core-js/full/parse-int": [
        "es.parse-int"
      ],
      "core-js/full/promise": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.string.iterator",
        "esnext.aggregate-error",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "web.dom-collections.iterator"
      ],
      "core-js/full/promise/all-settled": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.string.iterator",
        "esnext.promise.all-settled",
        "web.dom-collections.iterator"
      ],
      "core-js/full/promise/any": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.any",
        "es.string.iterator",
        "esnext.aggregate-error",
        "esnext.promise.any",
        "web.dom-collections.iterator"
      ],
      "core-js/full/promise/finally": [
        "es.object.to-string",
        "es.promise",
        "es.promise.finally"
      ],
      "core-js/full/promise/try": [
        "es.promise",
        "esnext.promise.try"
      ],
      "core-js/full/queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/full/reflect": [
        "es.object.to-string",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata"
      ],
      "core-js/full/reflect/apply": [
        "es.reflect.apply"
      ],
      "core-js/full/reflect/construct": [
        "es.reflect.construct"
      ],
      "core-js/full/reflect/define-metadata": [
        "esnext.reflect.define-metadata"
      ],
      "core-js/full/reflect/define-property": [
        "es.reflect.define-property"
      ],
      "core-js/full/reflect/delete-metadata": [
        "esnext.reflect.delete-metadata"
      ],
      "core-js/full/reflect/delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/full/reflect/get": [
        "es.reflect.get"
      ],
      "core-js/full/reflect/get-metadata": [
        "esnext.reflect.get-metadata"
      ],
      "core-js/full/reflect/get-metadata-keys": [
        "esnext.reflect.get-metadata-keys"
      ],
      "core-js/full/reflect/get-own-metadata": [
        "esnext.reflect.get-own-metadata"
      ],
      "core-js/full/reflect/get-own-metadata-keys": [
        "esnext.reflect.get-own-metadata-keys"
      ],
      "core-js/full/reflect/get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/full/reflect/get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/full/reflect/has": [
        "es.reflect.has"
      ],
      "core-js/full/reflect/has-metadata": [
        "esnext.reflect.has-metadata"
      ],
      "core-js/full/reflect/has-own-metadata": [
        "esnext.reflect.has-own-metadata"
      ],
      "core-js/full/reflect/is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/full/reflect/metadata": [
        "esnext.reflect.metadata"
      ],
      "core-js/full/reflect/own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/full/reflect/prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/full/reflect/set": [
        "es.reflect.set"
      ],
      "core-js/full/reflect/set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/full/reflect/to-string-tag": [
        "es.reflect.to-string-tag"
      ],
      "core-js/full/regexp": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.string.match",
        "es.string.replace",
        "es.string.search",
        "es.string.split"
      ],
      "core-js/full/regexp/constructor": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/full/regexp/dot-all": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec"
      ],
      "core-js/full/regexp/flags": [
        "es.regexp.flags"
      ],
      "core-js/full/regexp/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/full/regexp/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/full/regexp/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/full/regexp/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/full/regexp/sticky": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/full/regexp/test": [
        "es.regexp.exec",
        "es.regexp.test"
      ],
      "core-js/full/regexp/to-string": [
        "es.regexp.to-string"
      ],
      "core-js/full/set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.set",
        "es.string.iterator",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set-immediate": [
        "web.immediate"
      ],
      "core-js/full/set-interval": [
        "web.timers"
      ],
      "core-js/full/set-timeout": [
        "web.timers"
      ],
      "core-js/full/set/add-all": [
        "es.set",
        "esnext.set.add-all"
      ],
      "core-js/full/set/delete-all": [
        "es.set",
        "esnext.set.delete-all"
      ],
      "core-js/full/set/difference": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.difference",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/every": [
        "es.set",
        "esnext.set.every"
      ],
      "core-js/full/set/filter": [
        "es.set",
        "esnext.set.filter"
      ],
      "core-js/full/set/find": [
        "es.set",
        "esnext.set.find"
      ],
      "core-js/full/set/from": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/intersection": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.intersection",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/is-disjoint-from": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-disjoint-from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/is-subset-of": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-subset-of",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/is-superset-of": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.is-superset-of",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/join": [
        "es.set",
        "esnext.set.join"
      ],
      "core-js/full/set/map": [
        "es.set",
        "esnext.set.map"
      ],
      "core-js/full/set/of": [
        "es.array.iterator",
        "es.set",
        "esnext.set.of"
      ],
      "core-js/full/set/reduce": [
        "es.set",
        "esnext.set.reduce"
      ],
      "core-js/full/set/some": [
        "es.set",
        "esnext.set.some"
      ],
      "core-js/full/set/symmetric-difference": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.symmetric-difference",
        "web.dom-collections.iterator"
      ],
      "core-js/full/set/union": [
        "es.array.iterator",
        "es.set",
        "es.string.iterator",
        "esnext.set.union",
        "web.dom-collections.iterator"
      ],
      "core-js/full/string": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all"
      ],
      "core-js/full/string/anchor": [
        "es.string.anchor"
      ],
      "core-js/full/string/at": [
        "es.string.at-alternative",
        "esnext.string.at"
      ],
      "core-js/full/string/big": [
        "es.string.big"
      ],
      "core-js/full/string/blink": [
        "es.string.blink"
      ],
      "core-js/full/string/bold": [
        "es.string.bold"
      ],
      "core-js/full/string/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/full/string/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/full/string/cooked": [
        "esnext.string.cooked"
      ],
      "core-js/full/string/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/full/string/fixed": [
        "es.string.fixed"
      ],
      "core-js/full/string/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/full/string/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/full/string/from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/full/string/includes": [
        "es.string.includes"
      ],
      "core-js/full/string/italics": [
        "es.string.italics"
      ],
      "core-js/full/string/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/full/string/link": [
        "es.string.link"
      ],
      "core-js/full/string/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/full/string/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/full/string/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/full/string/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/full/string/raw": [
        "es.string.raw"
      ],
      "core-js/full/string/repeat": [
        "es.string.repeat"
      ],
      "core-js/full/string/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/full/string/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all",
        "esnext.string.replace-all"
      ],
      "core-js/full/string/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/full/string/small": [
        "es.string.small"
      ],
      "core-js/full/string/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/full/string/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/full/string/strike": [
        "es.string.strike"
      ],
      "core-js/full/string/sub": [
        "es.string.sub"
      ],
      "core-js/full/string/substr": [
        "es.string.substr"
      ],
      "core-js/full/string/sup": [
        "es.string.sup"
      ],
      "core-js/full/string/trim": [
        "es.string.trim"
      ],
      "core-js/full/string/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/full/string/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/full/string/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/full/string/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/full/string/virtual": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "esnext.string.at",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all"
      ],
      "core-js/full/string/virtual/anchor": [
        "es.string.anchor"
      ],
      "core-js/full/string/virtual/at": [
        "es.string.at-alternative",
        "esnext.string.at"
      ],
      "core-js/full/string/virtual/big": [
        "es.string.big"
      ],
      "core-js/full/string/virtual/blink": [
        "es.string.blink"
      ],
      "core-js/full/string/virtual/bold": [
        "es.string.bold"
      ],
      "core-js/full/string/virtual/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/full/string/virtual/code-points": [
        "es.object.to-string",
        "esnext.string.code-points"
      ],
      "core-js/full/string/virtual/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/full/string/virtual/fixed": [
        "es.string.fixed"
      ],
      "core-js/full/string/virtual/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/full/string/virtual/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/full/string/virtual/includes": [
        "es.string.includes"
      ],
      "core-js/full/string/virtual/italics": [
        "es.string.italics"
      ],
      "core-js/full/string/virtual/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/full/string/virtual/link": [
        "es.string.link"
      ],
      "core-js/full/string/virtual/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all",
        "esnext.string.match-all"
      ],
      "core-js/full/string/virtual/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/full/string/virtual/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/full/string/virtual/repeat": [
        "es.string.repeat"
      ],
      "core-js/full/string/virtual/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all",
        "esnext.string.replace-all"
      ],
      "core-js/full/string/virtual/small": [
        "es.string.small"
      ],
      "core-js/full/string/virtual/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/full/string/virtual/strike": [
        "es.string.strike"
      ],
      "core-js/full/string/virtual/sub": [
        "es.string.sub"
      ],
      "core-js/full/string/virtual/substr": [
        "es.string.substr"
      ],
      "core-js/full/string/virtual/sup": [
        "es.string.sup"
      ],
      "core-js/full/string/virtual/trim": [
        "es.string.trim"
      ],
      "core-js/full/string/virtual/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/full/string/virtual/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/full/string/virtual/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/full/string/virtual/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/full/structured-clone": [
        "es.error.to-string",
        "es.array.iterator",
        "es.map",
        "es.object.keys",
        "es.object.to-string",
        "es.set",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.structured-clone"
      ],
      "core-js/full/symbol": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "web.dom-collections.iterator"
      ],
      "core-js/full/symbol/async-dispose": [
        "esnext.symbol.async-dispose"
      ],
      "core-js/full/symbol/async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/full/symbol/description": [
        "es.symbol.description"
      ],
      "core-js/full/symbol/dispose": [
        "esnext.symbol.dispose"
      ],
      "core-js/full/symbol/for": [
        "es.symbol"
      ],
      "core-js/full/symbol/has-instance": [
        "es.symbol.has-instance",
        "es.function.has-instance"
      ],
      "core-js/full/symbol/is-concat-spreadable": [
        "es.symbol.is-concat-spreadable",
        "es.array.concat"
      ],
      "core-js/full/symbol/iterator": [
        "es.symbol.iterator",
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/full/symbol/key-for": [
        "es.symbol"
      ],
      "core-js/full/symbol/match": [
        "es.symbol.match",
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/full/symbol/match-all": [
        "es.symbol.match-all",
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/full/symbol/matcher": [
        "esnext.symbol.matcher"
      ],
      "core-js/full/symbol/metadata": [
        "esnext.symbol.metadata"
      ],
      "core-js/full/symbol/observable": [
        "esnext.symbol.observable"
      ],
      "core-js/full/symbol/pattern-match": [
        "esnext.symbol.pattern-match"
      ],
      "core-js/full/symbol/replace": [
        "es.symbol.replace",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/full/symbol/replace-all": [
        "esnext.symbol.replace-all"
      ],
      "core-js/full/symbol/search": [
        "es.symbol.search",
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/full/symbol/species": [
        "es.symbol.species"
      ],
      "core-js/full/symbol/split": [
        "es.symbol.split",
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/full/symbol/to-primitive": [
        "es.symbol.to-primitive",
        "es.date.to-primitive"
      ],
      "core-js/full/symbol/to-string-tag": [
        "es.symbol.to-string-tag",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/full/symbol/unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/full/typed-array": [
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/at": [
        "es.typed-array.every",
        "esnext.typed-array.at"
      ],
      "core-js/full/typed-array/copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/full/typed-array/entries": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/full/typed-array/every": [
        "es.typed-array.every"
      ],
      "core-js/full/typed-array/fill": [
        "es.typed-array.fill"
      ],
      "core-js/full/typed-array/filter": [
        "es.typed-array.filter"
      ],
      "core-js/full/typed-array/filter-out": [
        "esnext.typed-array.filter-out"
      ],
      "core-js/full/typed-array/filter-reject": [
        "esnext.typed-array.filter-reject"
      ],
      "core-js/full/typed-array/find": [
        "es.typed-array.find"
      ],
      "core-js/full/typed-array/find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/full/typed-array/find-last": [
        "esnext.typed-array.find-last"
      ],
      "core-js/full/typed-array/find-last-index": [
        "esnext.typed-array.find-last-index"
      ],
      "core-js/full/typed-array/float32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/float64-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.float64-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/full/typed-array/from": [
        "es.typed-array.from"
      ],
      "core-js/full/typed-array/from-async": [
        "esnext.typed-array.from-async"
      ],
      "core-js/full/typed-array/group-by": [
        "esnext.typed-array.group-by"
      ],
      "core-js/full/typed-array/includes": [
        "es.typed-array.includes"
      ],
      "core-js/full/typed-array/index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/full/typed-array/int16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/int32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/int8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.int8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/iterator": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/full/typed-array/join": [
        "es.typed-array.join"
      ],
      "core-js/full/typed-array/keys": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/full/typed-array/last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/full/typed-array/map": [
        "es.typed-array.map"
      ],
      "core-js/full/typed-array/methods": [
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/of": [
        "es.typed-array.of"
      ],
      "core-js/full/typed-array/reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/full/typed-array/reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/full/typed-array/reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/full/typed-array/set": [
        "es.typed-array.set"
      ],
      "core-js/full/typed-array/slice": [
        "es.typed-array.slice"
      ],
      "core-js/full/typed-array/some": [
        "es.typed-array.some"
      ],
      "core-js/full/typed-array/sort": [
        "es.typed-array.sort"
      ],
      "core-js/full/typed-array/subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/full/typed-array/to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/full/typed-array/to-reversed": [
        "esnext.typed-array.to-reversed"
      ],
      "core-js/full/typed-array/to-sorted": [
        "es.typed-array.sort",
        "esnext.typed-array.to-sorted"
      ],
      "core-js/full/typed-array/to-spliced": [
        "esnext.typed-array.to-spliced"
      ],
      "core-js/full/typed-array/to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/full/typed-array/uint16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/uint32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/uint8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/uint8-clamped-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.map",
        "es.object.to-string",
        "es.promise",
        "es.string.iterator",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with"
      ],
      "core-js/full/typed-array/unique-by": [
        "es.map",
        "esnext.typed-array.unique-by"
      ],
      "core-js/full/typed-array/values": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/full/typed-array/with": [
        "esnext.typed-array.with"
      ],
      "core-js/full/unescape": [
        "es.unescape"
      ],
      "core-js/full/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/full/url-search-params": [
        "web.dom-collections.iterator",
        "web.url-search-params"
      ],
      "core-js/full/url/to-json": [
        "web.url.to-json"
      ],
      "core-js/full/weak-map": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "es.weak-map",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "web.dom-collections.iterator"
      ],
      "core-js/full/weak-map/delete-all": [
        "es.weak-map",
        "esnext.weak-map.delete-all"
      ],
      "core-js/full/weak-map/emplace": [
        "es.weak-map",
        "esnext.weak-map.emplace"
      ],
      "core-js/full/weak-map/from": [
        "es.array.iterator",
        "es.string.iterator",
        "es.weak-map",
        "esnext.weak-map.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/weak-map/of": [
        "es.array.iterator",
        "es.weak-map",
        "esnext.weak-map.of"
      ],
      "core-js/full/weak-map/upsert": [
        "es.weak-map",
        "esnext.weak-map.upsert"
      ],
      "core-js/full/weak-set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "es.weak-set",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.dom-collections.iterator"
      ],
      "core-js/full/weak-set/add-all": [
        "es.weak-set",
        "esnext.weak-set.add-all"
      ],
      "core-js/full/weak-set/delete-all": [
        "es.weak-set",
        "esnext.weak-set.delete-all"
      ],
      "core-js/full/weak-set/from": [
        "es.array.iterator",
        "es.string.iterator",
        "es.weak-set",
        "esnext.weak-set.from",
        "web.dom-collections.iterator"
      ],
      "core-js/full/weak-set/of": [
        "es.array.iterator",
        "es.weak-set",
        "esnext.weak-set.of"
      ],
      "core-js/modules/es.aggregate-error": [
        "es.aggregate-error"
      ],
      "core-js/modules/es.aggregate-error.cause": [
        "es.aggregate-error.cause"
      ],
      "core-js/modules/es.aggregate-error.constructor": [
        "es.aggregate-error.constructor"
      ],
      "core-js/modules/es.array-buffer.constructor": [
        "es.array-buffer.constructor"
      ],
      "core-js/modules/es.array-buffer.is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/modules/es.array-buffer.slice": [
        "es.array-buffer.slice"
      ],
      "core-js/modules/es.array.at": [
        "es.array.at"
      ],
      "core-js/modules/es.array.concat": [
        "es.array.concat"
      ],
      "core-js/modules/es.array.copy-within": [
        "es.array.copy-within"
      ],
      "core-js/modules/es.array.every": [
        "es.array.every"
      ],
      "core-js/modules/es.array.fill": [
        "es.array.fill"
      ],
      "core-js/modules/es.array.filter": [
        "es.array.filter"
      ],
      "core-js/modules/es.array.find": [
        "es.array.find"
      ],
      "core-js/modules/es.array.find-index": [
        "es.array.find-index"
      ],
      "core-js/modules/es.array.flat": [
        "es.array.flat"
      ],
      "core-js/modules/es.array.flat-map": [
        "es.array.flat-map"
      ],
      "core-js/modules/es.array.for-each": [
        "es.array.for-each"
      ],
      "core-js/modules/es.array.from": [
        "es.array.from"
      ],
      "core-js/modules/es.array.includes": [
        "es.array.includes"
      ],
      "core-js/modules/es.array.index-of": [
        "es.array.index-of"
      ],
      "core-js/modules/es.array.is-array": [
        "es.array.is-array"
      ],
      "core-js/modules/es.array.iterator": [
        "es.array.iterator"
      ],
      "core-js/modules/es.array.join": [
        "es.array.join"
      ],
      "core-js/modules/es.array.last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/modules/es.array.map": [
        "es.array.map"
      ],
      "core-js/modules/es.array.of": [
        "es.array.of"
      ],
      "core-js/modules/es.array.reduce": [
        "es.array.reduce"
      ],
      "core-js/modules/es.array.reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/modules/es.array.reverse": [
        "es.array.reverse"
      ],
      "core-js/modules/es.array.slice": [
        "es.array.slice"
      ],
      "core-js/modules/es.array.some": [
        "es.array.some"
      ],
      "core-js/modules/es.array.sort": [
        "es.array.sort"
      ],
      "core-js/modules/es.array.species": [
        "es.array.species"
      ],
      "core-js/modules/es.array.splice": [
        "es.array.splice"
      ],
      "core-js/modules/es.array.unscopables.flat": [
        "es.array.unscopables.flat"
      ],
      "core-js/modules/es.array.unscopables.flat-map": [
        "es.array.unscopables.flat-map"
      ],
      "core-js/modules/es.data-view": [
        "es.data-view"
      ],
      "core-js/modules/es.data-view.constructor": [
        "es.data-view.constructor"
      ],
      "core-js/modules/es.date.get-year": [
        "es.date.get-year"
      ],
      "core-js/modules/es.date.now": [
        "es.date.now"
      ],
      "core-js/modules/es.date.set-year": [
        "es.date.set-year"
      ],
      "core-js/modules/es.date.to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/modules/es.date.to-iso-string": [
        "es.date.to-iso-string"
      ],
      "core-js/modules/es.date.to-json": [
        "es.date.to-json"
      ],
      "core-js/modules/es.date.to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/modules/es.date.to-string": [
        "es.date.to-string"
      ],
      "core-js/modules/es.error.cause": [
        "es.error.cause"
      ],
      "core-js/modules/es.error.to-string": [
        "es.error.to-string"
      ],
      "core-js/modules/es.escape": [
        "es.escape"
      ],
      "core-js/modules/es.function.bind": [
        "es.function.bind"
      ],
      "core-js/modules/es.function.has-instance": [
        "es.function.has-instance"
      ],
      "core-js/modules/es.function.name": [
        "es.function.name"
      ],
      "core-js/modules/es.global-this": [
        "es.global-this"
      ],
      "core-js/modules/es.json.stringify": [
        "es.json.stringify"
      ],
      "core-js/modules/es.json.to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/modules/es.map": [
        "es.map"
      ],
      "core-js/modules/es.map.constructor": [
        "es.map.constructor"
      ],
      "core-js/modules/es.math.acosh": [
        "es.math.acosh"
      ],
      "core-js/modules/es.math.asinh": [
        "es.math.asinh"
      ],
      "core-js/modules/es.math.atanh": [
        "es.math.atanh"
      ],
      "core-js/modules/es.math.cbrt": [
        "es.math.cbrt"
      ],
      "core-js/modules/es.math.clz32": [
        "es.math.clz32"
      ],
      "core-js/modules/es.math.cosh": [
        "es.math.cosh"
      ],
      "core-js/modules/es.math.expm1": [
        "es.math.expm1"
      ],
      "core-js/modules/es.math.fround": [
        "es.math.fround"
      ],
      "core-js/modules/es.math.hypot": [
        "es.math.hypot"
      ],
      "core-js/modules/es.math.imul": [
        "es.math.imul"
      ],
      "core-js/modules/es.math.log10": [
        "es.math.log10"
      ],
      "core-js/modules/es.math.log1p": [
        "es.math.log1p"
      ],
      "core-js/modules/es.math.log2": [
        "es.math.log2"
      ],
      "core-js/modules/es.math.sign": [
        "es.math.sign"
      ],
      "core-js/modules/es.math.sinh": [
        "es.math.sinh"
      ],
      "core-js/modules/es.math.tanh": [
        "es.math.tanh"
      ],
      "core-js/modules/es.math.to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/modules/es.math.trunc": [
        "es.math.trunc"
      ],
      "core-js/modules/es.number.constructor": [
        "es.number.constructor"
      ],
      "core-js/modules/es.number.epsilon": [
        "es.number.epsilon"
      ],
      "core-js/modules/es.number.is-finite": [
        "es.number.is-finite"
      ],
      "core-js/modules/es.number.is-integer": [
        "es.number.is-integer"
      ],
      "core-js/modules/es.number.is-nan": [
        "es.number.is-nan"
      ],
      "core-js/modules/es.number.is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/modules/es.number.max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/modules/es.number.min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/modules/es.number.parse-float": [
        "es.number.parse-float"
      ],
      "core-js/modules/es.number.parse-int": [
        "es.number.parse-int"
      ],
      "core-js/modules/es.number.to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/modules/es.number.to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/modules/es.number.to-precision": [
        "es.number.to-precision"
      ],
      "core-js/modules/es.object.assign": [
        "es.object.assign"
      ],
      "core-js/modules/es.object.create": [
        "es.object.create"
      ],
      "core-js/modules/es.object.define-getter": [
        "es.object.define-getter"
      ],
      "core-js/modules/es.object.define-properties": [
        "es.object.define-properties"
      ],
      "core-js/modules/es.object.define-property": [
        "es.object.define-property"
      ],
      "core-js/modules/es.object.define-setter": [
        "es.object.define-setter"
      ],
      "core-js/modules/es.object.entries": [
        "es.object.entries"
      ],
      "core-js/modules/es.object.freeze": [
        "es.object.freeze"
      ],
      "core-js/modules/es.object.from-entries": [
        "es.object.from-entries"
      ],
      "core-js/modules/es.object.get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/modules/es.object.get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/modules/es.object.get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/modules/es.object.get-own-property-symbols": [
        "es.object.get-own-property-symbols"
      ],
      "core-js/modules/es.object.get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/modules/es.object.has-own": [
        "es.object.has-own"
      ],
      "core-js/modules/es.object.is": [
        "es.object.is"
      ],
      "core-js/modules/es.object.is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/modules/es.object.is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/modules/es.object.is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/modules/es.object.keys": [
        "es.object.keys"
      ],
      "core-js/modules/es.object.lookup-getter": [
        "es.object.lookup-getter"
      ],
      "core-js/modules/es.object.lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/modules/es.object.prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/modules/es.object.seal": [
        "es.object.seal"
      ],
      "core-js/modules/es.object.set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/modules/es.object.to-string": [
        "es.object.to-string"
      ],
      "core-js/modules/es.object.values": [
        "es.object.values"
      ],
      "core-js/modules/es.parse-float": [
        "es.parse-float"
      ],
      "core-js/modules/es.parse-int": [
        "es.parse-int"
      ],
      "core-js/modules/es.promise": [
        "es.promise"
      ],
      "core-js/modules/es.promise.all": [
        "es.promise.all"
      ],
      "core-js/modules/es.promise.all-settled": [
        "es.promise.all-settled"
      ],
      "core-js/modules/es.promise.any": [
        "es.promise.any"
      ],
      "core-js/modules/es.promise.catch": [
        "es.promise.catch"
      ],
      "core-js/modules/es.promise.constructor": [
        "es.promise.constructor"
      ],
      "core-js/modules/es.promise.finally": [
        "es.promise.finally"
      ],
      "core-js/modules/es.promise.race": [
        "es.promise.race"
      ],
      "core-js/modules/es.promise.reject": [
        "es.promise.reject"
      ],
      "core-js/modules/es.promise.resolve": [
        "es.promise.resolve"
      ],
      "core-js/modules/es.reflect.apply": [
        "es.reflect.apply"
      ],
      "core-js/modules/es.reflect.construct": [
        "es.reflect.construct"
      ],
      "core-js/modules/es.reflect.define-property": [
        "es.reflect.define-property"
      ],
      "core-js/modules/es.reflect.delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/modules/es.reflect.get": [
        "es.reflect.get"
      ],
      "core-js/modules/es.reflect.get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/modules/es.reflect.get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/modules/es.reflect.has": [
        "es.reflect.has"
      ],
      "core-js/modules/es.reflect.is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/modules/es.reflect.own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/modules/es.reflect.prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/modules/es.reflect.set": [
        "es.reflect.set"
      ],
      "core-js/modules/es.reflect.set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/modules/es.reflect.to-string-tag": [
        "es.reflect.to-string-tag"
      ],
      "core-js/modules/es.regexp.constructor": [
        "es.regexp.constructor"
      ],
      "core-js/modules/es.regexp.dot-all": [
        "es.regexp.dot-all"
      ],
      "core-js/modules/es.regexp.exec": [
        "es.regexp.exec"
      ],
      "core-js/modules/es.regexp.flags": [
        "es.regexp.flags"
      ],
      "core-js/modules/es.regexp.sticky": [
        "es.regexp.sticky"
      ],
      "core-js/modules/es.regexp.test": [
        "es.regexp.test"
      ],
      "core-js/modules/es.regexp.to-string": [
        "es.regexp.to-string"
      ],
      "core-js/modules/es.set": [
        "es.set"
      ],
      "core-js/modules/es.set.constructor": [
        "es.set.constructor"
      ],
      "core-js/modules/es.string.anchor": [
        "es.string.anchor"
      ],
      "core-js/modules/es.string.at-alternative": [
        "es.string.at-alternative"
      ],
      "core-js/modules/es.string.big": [
        "es.string.big"
      ],
      "core-js/modules/es.string.blink": [
        "es.string.blink"
      ],
      "core-js/modules/es.string.bold": [
        "es.string.bold"
      ],
      "core-js/modules/es.string.code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/modules/es.string.ends-with": [
        "es.string.ends-with"
      ],
      "core-js/modules/es.string.fixed": [
        "es.string.fixed"
      ],
      "core-js/modules/es.string.fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/modules/es.string.fontsize": [
        "es.string.fontsize"
      ],
      "core-js/modules/es.string.from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/modules/es.string.includes": [
        "es.string.includes"
      ],
      "core-js/modules/es.string.italics": [
        "es.string.italics"
      ],
      "core-js/modules/es.string.iterator": [
        "es.string.iterator"
      ],
      "core-js/modules/es.string.link": [
        "es.string.link"
      ],
      "core-js/modules/es.string.match": [
        "es.string.match"
      ],
      "core-js/modules/es.string.match-all": [
        "es.string.match-all"
      ],
      "core-js/modules/es.string.pad-end": [
        "es.string.pad-end"
      ],
      "core-js/modules/es.string.pad-start": [
        "es.string.pad-start"
      ],
      "core-js/modules/es.string.raw": [
        "es.string.raw"
      ],
      "core-js/modules/es.string.repeat": [
        "es.string.repeat"
      ],
      "core-js/modules/es.string.replace": [
        "es.string.replace"
      ],
      "core-js/modules/es.string.replace-all": [
        "es.string.replace-all"
      ],
      "core-js/modules/es.string.search": [
        "es.string.search"
      ],
      "core-js/modules/es.string.small": [
        "es.string.small"
      ],
      "core-js/modules/es.string.split": [
        "es.string.split"
      ],
      "core-js/modules/es.string.starts-with": [
        "es.string.starts-with"
      ],
      "core-js/modules/es.string.strike": [
        "es.string.strike"
      ],
      "core-js/modules/es.string.sub": [
        "es.string.sub"
      ],
      "core-js/modules/es.string.substr": [
        "es.string.substr"
      ],
      "core-js/modules/es.string.sup": [
        "es.string.sup"
      ],
      "core-js/modules/es.string.trim": [
        "es.string.trim"
      ],
      "core-js/modules/es.string.trim-end": [
        "es.string.trim-end"
      ],
      "core-js/modules/es.string.trim-left": [
        "es.string.trim-left"
      ],
      "core-js/modules/es.string.trim-right": [
        "es.string.trim-right"
      ],
      "core-js/modules/es.string.trim-start": [
        "es.string.trim-start"
      ],
      "core-js/modules/es.symbol": [
        "es.symbol"
      ],
      "core-js/modules/es.symbol.async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/modules/es.symbol.constructor": [
        "es.symbol.constructor"
      ],
      "core-js/modules/es.symbol.description": [
        "es.symbol.description"
      ],
      "core-js/modules/es.symbol.for": [
        "es.symbol.for"
      ],
      "core-js/modules/es.symbol.has-instance": [
        "es.symbol.has-instance"
      ],
      "core-js/modules/es.symbol.is-concat-spreadable": [
        "es.symbol.is-concat-spreadable"
      ],
      "core-js/modules/es.symbol.iterator": [
        "es.symbol.iterator"
      ],
      "core-js/modules/es.symbol.key-for": [
        "es.symbol.key-for"
      ],
      "core-js/modules/es.symbol.match": [
        "es.symbol.match"
      ],
      "core-js/modules/es.symbol.match-all": [
        "es.symbol.match-all"
      ],
      "core-js/modules/es.symbol.replace": [
        "es.symbol.replace"
      ],
      "core-js/modules/es.symbol.search": [
        "es.symbol.search"
      ],
      "core-js/modules/es.symbol.species": [
        "es.symbol.species"
      ],
      "core-js/modules/es.symbol.split": [
        "es.symbol.split"
      ],
      "core-js/modules/es.symbol.to-primitive": [
        "es.symbol.to-primitive"
      ],
      "core-js/modules/es.symbol.to-string-tag": [
        "es.symbol.to-string-tag"
      ],
      "core-js/modules/es.symbol.unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/modules/es.typed-array.at": [
        "es.typed-array.at"
      ],
      "core-js/modules/es.typed-array.copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/modules/es.typed-array.every": [
        "es.typed-array.every"
      ],
      "core-js/modules/es.typed-array.fill": [
        "es.typed-array.fill"
      ],
      "core-js/modules/es.typed-array.filter": [
        "es.typed-array.filter"
      ],
      "core-js/modules/es.typed-array.find": [
        "es.typed-array.find"
      ],
      "core-js/modules/es.typed-array.find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/modules/es.typed-array.float32-array": [
        "es.typed-array.float32-array"
      ],
      "core-js/modules/es.typed-array.float64-array": [
        "es.typed-array.float64-array"
      ],
      "core-js/modules/es.typed-array.for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/modules/es.typed-array.from": [
        "es.typed-array.from"
      ],
      "core-js/modules/es.typed-array.includes": [
        "es.typed-array.includes"
      ],
      "core-js/modules/es.typed-array.index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/modules/es.typed-array.int16-array": [
        "es.typed-array.int16-array"
      ],
      "core-js/modules/es.typed-array.int32-array": [
        "es.typed-array.int32-array"
      ],
      "core-js/modules/es.typed-array.int8-array": [
        "es.typed-array.int8-array"
      ],
      "core-js/modules/es.typed-array.iterator": [
        "es.typed-array.iterator"
      ],
      "core-js/modules/es.typed-array.join": [
        "es.typed-array.join"
      ],
      "core-js/modules/es.typed-array.last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/modules/es.typed-array.map": [
        "es.typed-array.map"
      ],
      "core-js/modules/es.typed-array.of": [
        "es.typed-array.of"
      ],
      "core-js/modules/es.typed-array.reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/modules/es.typed-array.reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/modules/es.typed-array.reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/modules/es.typed-array.set": [
        "es.typed-array.set"
      ],
      "core-js/modules/es.typed-array.slice": [
        "es.typed-array.slice"
      ],
      "core-js/modules/es.typed-array.some": [
        "es.typed-array.some"
      ],
      "core-js/modules/es.typed-array.sort": [
        "es.typed-array.sort"
      ],
      "core-js/modules/es.typed-array.subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/modules/es.typed-array.to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/modules/es.typed-array.to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/modules/es.typed-array.uint16-array": [
        "es.typed-array.uint16-array"
      ],
      "core-js/modules/es.typed-array.uint32-array": [
        "es.typed-array.uint32-array"
      ],
      "core-js/modules/es.typed-array.uint8-array": [
        "es.typed-array.uint8-array"
      ],
      "core-js/modules/es.typed-array.uint8-clamped-array": [
        "es.typed-array.uint8-clamped-array"
      ],
      "core-js/modules/es.unescape": [
        "es.unescape"
      ],
      "core-js/modules/es.weak-map": [
        "es.weak-map"
      ],
      "core-js/modules/es.weak-map.constructor": [
        "es.weak-map.constructor"
      ],
      "core-js/modules/es.weak-set": [
        "es.weak-set"
      ],
      "core-js/modules/es.weak-set.constructor": [
        "es.weak-set.constructor"
      ],
      "core-js/modules/esnext.aggregate-error": [
        "esnext.aggregate-error"
      ],
      "core-js/modules/esnext.array.at": [
        "esnext.array.at"
      ],
      "core-js/modules/esnext.array.filter-out": [
        "esnext.array.filter-out"
      ],
      "core-js/modules/esnext.array.filter-reject": [
        "esnext.array.filter-reject"
      ],
      "core-js/modules/esnext.array.find-last": [
        "esnext.array.find-last"
      ],
      "core-js/modules/esnext.array.find-last-index": [
        "esnext.array.find-last-index"
      ],
      "core-js/modules/esnext.array.from-async": [
        "esnext.array.from-async"
      ],
      "core-js/modules/esnext.array.group-by": [
        "esnext.array.group-by"
      ],
      "core-js/modules/esnext.array.group-by-to-map": [
        "esnext.array.group-by-to-map"
      ],
      "core-js/modules/esnext.array.is-template-object": [
        "esnext.array.is-template-object"
      ],
      "core-js/modules/esnext.array.last-index": [
        "esnext.array.last-index"
      ],
      "core-js/modules/esnext.array.last-item": [
        "esnext.array.last-item"
      ],
      "core-js/modules/esnext.array.to-reversed": [
        "esnext.array.to-reversed"
      ],
      "core-js/modules/esnext.array.to-sorted": [
        "esnext.array.to-sorted"
      ],
      "core-js/modules/esnext.array.to-spliced": [
        "esnext.array.to-spliced"
      ],
      "core-js/modules/esnext.array.unique-by": [
        "esnext.array.unique-by"
      ],
      "core-js/modules/esnext.array.with": [
        "esnext.array.with"
      ],
      "core-js/modules/esnext.async-iterator.as-indexed-pairs": [
        "esnext.async-iterator.as-indexed-pairs"
      ],
      "core-js/modules/esnext.async-iterator.constructor": [
        "esnext.async-iterator.constructor"
      ],
      "core-js/modules/esnext.async-iterator.drop": [
        "esnext.async-iterator.drop"
      ],
      "core-js/modules/esnext.async-iterator.every": [
        "esnext.async-iterator.every"
      ],
      "core-js/modules/esnext.async-iterator.filter": [
        "esnext.async-iterator.filter"
      ],
      "core-js/modules/esnext.async-iterator.find": [
        "esnext.async-iterator.find"
      ],
      "core-js/modules/esnext.async-iterator.flat-map": [
        "esnext.async-iterator.flat-map"
      ],
      "core-js/modules/esnext.async-iterator.for-each": [
        "esnext.async-iterator.for-each"
      ],
      "core-js/modules/esnext.async-iterator.from": [
        "esnext.async-iterator.from"
      ],
      "core-js/modules/esnext.async-iterator.map": [
        "esnext.async-iterator.map"
      ],
      "core-js/modules/esnext.async-iterator.reduce": [
        "esnext.async-iterator.reduce"
      ],
      "core-js/modules/esnext.async-iterator.some": [
        "esnext.async-iterator.some"
      ],
      "core-js/modules/esnext.async-iterator.take": [
        "esnext.async-iterator.take"
      ],
      "core-js/modules/esnext.async-iterator.to-array": [
        "esnext.async-iterator.to-array"
      ],
      "core-js/modules/esnext.bigint.range": [
        "esnext.bigint.range"
      ],
      "core-js/modules/esnext.composite-key": [
        "esnext.composite-key"
      ],
      "core-js/modules/esnext.composite-symbol": [
        "esnext.composite-symbol"
      ],
      "core-js/modules/esnext.function.is-callable": [
        "esnext.function.is-callable"
      ],
      "core-js/modules/esnext.function.is-constructor": [
        "esnext.function.is-constructor"
      ],
      "core-js/modules/esnext.function.un-this": [
        "esnext.function.un-this"
      ],
      "core-js/modules/esnext.global-this": [
        "esnext.global-this"
      ],
      "core-js/modules/esnext.iterator.as-indexed-pairs": [
        "esnext.iterator.as-indexed-pairs"
      ],
      "core-js/modules/esnext.iterator.constructor": [
        "esnext.iterator.constructor"
      ],
      "core-js/modules/esnext.iterator.drop": [
        "esnext.iterator.drop"
      ],
      "core-js/modules/esnext.iterator.every": [
        "esnext.iterator.every"
      ],
      "core-js/modules/esnext.iterator.filter": [
        "esnext.iterator.filter"
      ],
      "core-js/modules/esnext.iterator.find": [
        "esnext.iterator.find"
      ],
      "core-js/modules/esnext.iterator.flat-map": [
        "esnext.iterator.flat-map"
      ],
      "core-js/modules/esnext.iterator.for-each": [
        "esnext.iterator.for-each"
      ],
      "core-js/modules/esnext.iterator.from": [
        "esnext.iterator.from"
      ],
      "core-js/modules/esnext.iterator.map": [
        "esnext.iterator.map"
      ],
      "core-js/modules/esnext.iterator.reduce": [
        "esnext.iterator.reduce"
      ],
      "core-js/modules/esnext.iterator.some": [
        "esnext.iterator.some"
      ],
      "core-js/modules/esnext.iterator.take": [
        "esnext.iterator.take"
      ],
      "core-js/modules/esnext.iterator.to-array": [
        "esnext.iterator.to-array"
      ],
      "core-js/modules/esnext.iterator.to-async": [
        "esnext.iterator.to-async"
      ],
      "core-js/modules/esnext.map.delete-all": [
        "esnext.map.delete-all"
      ],
      "core-js/modules/esnext.map.emplace": [
        "esnext.map.emplace"
      ],
      "core-js/modules/esnext.map.every": [
        "esnext.map.every"
      ],
      "core-js/modules/esnext.map.filter": [
        "esnext.map.filter"
      ],
      "core-js/modules/esnext.map.find": [
        "esnext.map.find"
      ],
      "core-js/modules/esnext.map.find-key": [
        "esnext.map.find-key"
      ],
      "core-js/modules/esnext.map.from": [
        "esnext.map.from"
      ],
      "core-js/modules/esnext.map.group-by": [
        "esnext.map.group-by"
      ],
      "core-js/modules/esnext.map.includes": [
        "esnext.map.includes"
      ],
      "core-js/modules/esnext.map.key-by": [
        "esnext.map.key-by"
      ],
      "core-js/modules/esnext.map.key-of": [
        "esnext.map.key-of"
      ],
      "core-js/modules/esnext.map.map-keys": [
        "esnext.map.map-keys"
      ],
      "core-js/modules/esnext.map.map-values": [
        "esnext.map.map-values"
      ],
      "core-js/modules/esnext.map.merge": [
        "esnext.map.merge"
      ],
      "core-js/modules/esnext.map.of": [
        "esnext.map.of"
      ],
      "core-js/modules/esnext.map.reduce": [
        "esnext.map.reduce"
      ],
      "core-js/modules/esnext.map.some": [
        "esnext.map.some"
      ],
      "core-js/modules/esnext.map.update": [
        "esnext.map.update"
      ],
      "core-js/modules/esnext.map.update-or-insert": [
        "esnext.map.update-or-insert"
      ],
      "core-js/modules/esnext.map.upsert": [
        "esnext.map.upsert"
      ],
      "core-js/modules/esnext.math.clamp": [
        "esnext.math.clamp"
      ],
      "core-js/modules/esnext.math.deg-per-rad": [
        "esnext.math.deg-per-rad"
      ],
      "core-js/modules/esnext.math.degrees": [
        "esnext.math.degrees"
      ],
      "core-js/modules/esnext.math.fscale": [
        "esnext.math.fscale"
      ],
      "core-js/modules/esnext.math.iaddh": [
        "esnext.math.iaddh"
      ],
      "core-js/modules/esnext.math.imulh": [
        "esnext.math.imulh"
      ],
      "core-js/modules/esnext.math.isubh": [
        "esnext.math.isubh"
      ],
      "core-js/modules/esnext.math.rad-per-deg": [
        "esnext.math.rad-per-deg"
      ],
      "core-js/modules/esnext.math.radians": [
        "esnext.math.radians"
      ],
      "core-js/modules/esnext.math.scale": [
        "esnext.math.scale"
      ],
      "core-js/modules/esnext.math.seeded-prng": [
        "esnext.math.seeded-prng"
      ],
      "core-js/modules/esnext.math.signbit": [
        "esnext.math.signbit"
      ],
      "core-js/modules/esnext.math.umulh": [
        "esnext.math.umulh"
      ],
      "core-js/modules/esnext.number.from-string": [
        "esnext.number.from-string"
      ],
      "core-js/modules/esnext.number.range": [
        "esnext.number.range"
      ],
      "core-js/modules/esnext.object.has-own": [
        "esnext.object.has-own"
      ],
      "core-js/modules/esnext.object.iterate-entries": [
        "esnext.object.iterate-entries"
      ],
      "core-js/modules/esnext.object.iterate-keys": [
        "esnext.object.iterate-keys"
      ],
      "core-js/modules/esnext.object.iterate-values": [
        "esnext.object.iterate-values"
      ],
      "core-js/modules/esnext.observable": [
        "esnext.observable"
      ],
      "core-js/modules/esnext.observable.constructor": [
        "esnext.observable.constructor"
      ],
      "core-js/modules/esnext.observable.from": [
        "esnext.observable.from"
      ],
      "core-js/modules/esnext.observable.of": [
        "esnext.observable.of"
      ],
      "core-js/modules/esnext.promise.all-settled": [
        "esnext.promise.all-settled"
      ],
      "core-js/modules/esnext.promise.any": [
        "esnext.promise.any"
      ],
      "core-js/modules/esnext.promise.try": [
        "esnext.promise.try"
      ],
      "core-js/modules/esnext.reflect.define-metadata": [
        "esnext.reflect.define-metadata"
      ],
      "core-js/modules/esnext.reflect.delete-metadata": [
        "esnext.reflect.delete-metadata"
      ],
      "core-js/modules/esnext.reflect.get-metadata": [
        "esnext.reflect.get-metadata"
      ],
      "core-js/modules/esnext.reflect.get-metadata-keys": [
        "esnext.reflect.get-metadata-keys"
      ],
      "core-js/modules/esnext.reflect.get-own-metadata": [
        "esnext.reflect.get-own-metadata"
      ],
      "core-js/modules/esnext.reflect.get-own-metadata-keys": [
        "esnext.reflect.get-own-metadata-keys"
      ],
      "core-js/modules/esnext.reflect.has-metadata": [
        "esnext.reflect.has-metadata"
      ],
      "core-js/modules/esnext.reflect.has-own-metadata": [
        "esnext.reflect.has-own-metadata"
      ],
      "core-js/modules/esnext.reflect.metadata": [
        "esnext.reflect.metadata"
      ],
      "core-js/modules/esnext.set.add-all": [
        "esnext.set.add-all"
      ],
      "core-js/modules/esnext.set.delete-all": [
        "esnext.set.delete-all"
      ],
      "core-js/modules/esnext.set.difference": [
        "esnext.set.difference"
      ],
      "core-js/modules/esnext.set.every": [
        "esnext.set.every"
      ],
      "core-js/modules/esnext.set.filter": [
        "esnext.set.filter"
      ],
      "core-js/modules/esnext.set.find": [
        "esnext.set.find"
      ],
      "core-js/modules/esnext.set.from": [
        "esnext.set.from"
      ],
      "core-js/modules/esnext.set.intersection": [
        "esnext.set.intersection"
      ],
      "core-js/modules/esnext.set.is-disjoint-from": [
        "esnext.set.is-disjoint-from"
      ],
      "core-js/modules/esnext.set.is-subset-of": [
        "esnext.set.is-subset-of"
      ],
      "core-js/modules/esnext.set.is-superset-of": [
        "esnext.set.is-superset-of"
      ],
      "core-js/modules/esnext.set.join": [
        "esnext.set.join"
      ],
      "core-js/modules/esnext.set.map": [
        "esnext.set.map"
      ],
      "core-js/modules/esnext.set.of": [
        "esnext.set.of"
      ],
      "core-js/modules/esnext.set.reduce": [
        "esnext.set.reduce"
      ],
      "core-js/modules/esnext.set.some": [
        "esnext.set.some"
      ],
      "core-js/modules/esnext.set.symmetric-difference": [
        "esnext.set.symmetric-difference"
      ],
      "core-js/modules/esnext.set.union": [
        "esnext.set.union"
      ],
      "core-js/modules/esnext.string.at": [
        "esnext.string.at"
      ],
      "core-js/modules/esnext.string.at-alternative": [
        "esnext.string.at-alternative"
      ],
      "core-js/modules/esnext.string.code-points": [
        "esnext.string.code-points"
      ],
      "core-js/modules/esnext.string.cooked": [
        "esnext.string.cooked"
      ],
      "core-js/modules/esnext.string.match-all": [
        "esnext.string.match-all"
      ],
      "core-js/modules/esnext.string.replace-all": [
        "esnext.string.replace-all"
      ],
      "core-js/modules/esnext.symbol.async-dispose": [
        "esnext.symbol.async-dispose"
      ],
      "core-js/modules/esnext.symbol.dispose": [
        "esnext.symbol.dispose"
      ],
      "core-js/modules/esnext.symbol.matcher": [
        "esnext.symbol.matcher"
      ],
      "core-js/modules/esnext.symbol.metadata": [
        "esnext.symbol.metadata"
      ],
      "core-js/modules/esnext.symbol.observable": [
        "esnext.symbol.observable"
      ],
      "core-js/modules/esnext.symbol.pattern-match": [
        "esnext.symbol.pattern-match"
      ],
      "core-js/modules/esnext.symbol.replace-all": [
        "esnext.symbol.replace-all"
      ],
      "core-js/modules/esnext.typed-array.at": [
        "esnext.typed-array.at"
      ],
      "core-js/modules/esnext.typed-array.filter-out": [
        "esnext.typed-array.filter-out"
      ],
      "core-js/modules/esnext.typed-array.filter-reject": [
        "esnext.typed-array.filter-reject"
      ],
      "core-js/modules/esnext.typed-array.find-last": [
        "esnext.typed-array.find-last"
      ],
      "core-js/modules/esnext.typed-array.find-last-index": [
        "esnext.typed-array.find-last-index"
      ],
      "core-js/modules/esnext.typed-array.from-async": [
        "esnext.typed-array.from-async"
      ],
      "core-js/modules/esnext.typed-array.group-by": [
        "esnext.typed-array.group-by"
      ],
      "core-js/modules/esnext.typed-array.to-reversed": [
        "esnext.typed-array.to-reversed"
      ],
      "core-js/modules/esnext.typed-array.to-sorted": [
        "esnext.typed-array.to-sorted"
      ],
      "core-js/modules/esnext.typed-array.to-spliced": [
        "esnext.typed-array.to-spliced"
      ],
      "core-js/modules/esnext.typed-array.unique-by": [
        "esnext.typed-array.unique-by"
      ],
      "core-js/modules/esnext.typed-array.with": [
        "esnext.typed-array.with"
      ],
      "core-js/modules/esnext.weak-map.delete-all": [
        "esnext.weak-map.delete-all"
      ],
      "core-js/modules/esnext.weak-map.emplace": [
        "esnext.weak-map.emplace"
      ],
      "core-js/modules/esnext.weak-map.from": [
        "esnext.weak-map.from"
      ],
      "core-js/modules/esnext.weak-map.of": [
        "esnext.weak-map.of"
      ],
      "core-js/modules/esnext.weak-map.upsert": [
        "esnext.weak-map.upsert"
      ],
      "core-js/modules/esnext.weak-set.add-all": [
        "esnext.weak-set.add-all"
      ],
      "core-js/modules/esnext.weak-set.delete-all": [
        "esnext.weak-set.delete-all"
      ],
      "core-js/modules/esnext.weak-set.from": [
        "esnext.weak-set.from"
      ],
      "core-js/modules/esnext.weak-set.of": [
        "esnext.weak-set.of"
      ],
      "core-js/modules/web.atob": [
        "web.atob"
      ],
      "core-js/modules/web.btoa": [
        "web.btoa"
      ],
      "core-js/modules/web.clear-immediate": [
        "web.clear-immediate"
      ],
      "core-js/modules/web.dom-collections.for-each": [
        "web.dom-collections.for-each"
      ],
      "core-js/modules/web.dom-collections.iterator": [
        "web.dom-collections.iterator"
      ],
      "core-js/modules/web.dom-exception.constructor": [
        "web.dom-exception.constructor"
      ],
      "core-js/modules/web.dom-exception.stack": [
        "web.dom-exception.stack"
      ],
      "core-js/modules/web.dom-exception.to-string-tag": [
        "web.dom-exception.to-string-tag"
      ],
      "core-js/modules/web.immediate": [
        "web.immediate"
      ],
      "core-js/modules/web.queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/modules/web.set-immediate": [
        "web.set-immediate"
      ],
      "core-js/modules/web.set-interval": [
        "web.set-interval"
      ],
      "core-js/modules/web.set-timeout": [
        "web.set-timeout"
      ],
      "core-js/modules/web.structured-clone": [
        "web.structured-clone"
      ],
      "core-js/modules/web.timers": [
        "web.timers"
      ],
      "core-js/modules/web.url": [
        "web.url"
      ],
      "core-js/modules/web.url-search-params": [
        "web.url-search-params"
      ],
      "core-js/modules/web.url-search-params.constructor": [
        "web.url-search-params.constructor"
      ],
      "core-js/modules/web.url.constructor": [
        "web.url.constructor"
      ],
      "core-js/modules/web.url.to-json": [
        "web.url.to-json"
      ],
      "core-js/proposals": [
        "es.map",
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/proposals/accessible-object-hasownproperty": [
        "esnext.object.has-own"
      ],
      "core-js/proposals/array-filtering": [
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject"
      ],
      "core-js/proposals/array-filtering-stage-1": [
        "esnext.array.filter-reject",
        "esnext.typed-array.filter-reject"
      ],
      "core-js/proposals/array-find-from-last": [
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index"
      ],
      "core-js/proposals/array-flat-map": [
        "es.array.flat",
        "es.array.flat-map",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map"
      ],
      "core-js/proposals/array-from-async": [
        "esnext.array.from-async",
        "esnext.typed-array.from-async"
      ],
      "core-js/proposals/array-from-async-stage-2": [
        "esnext.array.from-async"
      ],
      "core-js/proposals/array-grouping": [
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.typed-array.group-by"
      ],
      "core-js/proposals/array-grouping-stage-3": [
        "esnext.array.group-by",
        "esnext.array.group-by-to-map"
      ],
      "core-js/proposals/array-includes": [
        "es.array.includes",
        "es.typed-array.includes"
      ],
      "core-js/proposals/array-is-template-object": [
        "esnext.array.is-template-object"
      ],
      "core-js/proposals/array-last": [
        "esnext.array.last-index",
        "esnext.array.last-item"
      ],
      "core-js/proposals/array-unique": [
        "es.map",
        "esnext.array.unique-by",
        "esnext.typed-array.unique-by"
      ],
      "core-js/proposals/async-iteration": [
        "es.symbol.async-iterator"
      ],
      "core-js/proposals/change-array-by-copy": [
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/proposals/collection-methods": [
        "esnext.map.delete-all",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.weak-map.delete-all",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all"
      ],
      "core-js/proposals/collection-of-from": [
        "esnext.map.from",
        "esnext.map.of",
        "esnext.set.from",
        "esnext.set.of",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-set.from",
        "esnext.weak-set.of"
      ],
      "core-js/proposals/decorators": [
        "esnext.symbol.metadata"
      ],
      "core-js/proposals/efficient-64-bit-arithmetic": [
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.umulh"
      ],
      "core-js/proposals/error-cause": [
        "es.error.cause",
        "es.aggregate-error.cause"
      ],
      "core-js/proposals/function-is-callable-is-constructor": [
        "esnext.function.is-callable",
        "esnext.function.is-constructor"
      ],
      "core-js/proposals/function-un-this": [
        "esnext.function.un-this"
      ],
      "core-js/proposals/global-this": [
        "esnext.global-this"
      ],
      "core-js/proposals/iterator-helpers": [
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async"
      ],
      "core-js/proposals/keys-composition": [
        "esnext.composite-key",
        "esnext.composite-symbol"
      ],
      "core-js/proposals/map-update-or-insert": [
        "esnext.map.emplace",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert"
      ],
      "core-js/proposals/map-upsert": [
        "esnext.map.emplace",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert"
      ],
      "core-js/proposals/map-upsert-stage-2": [
        "esnext.map.emplace",
        "esnext.weak-map.emplace"
      ],
      "core-js/proposals/math-extensions": [
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale"
      ],
      "core-js/proposals/math-signbit": [
        "esnext.math.signbit"
      ],
      "core-js/proposals/number-from-string": [
        "esnext.number.from-string"
      ],
      "core-js/proposals/number-range": [
        "esnext.bigint.range",
        "esnext.number.range"
      ],
      "core-js/proposals/object-from-entries": [
        "es.object.from-entries"
      ],
      "core-js/proposals/object-getownpropertydescriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/proposals/object-iteration": [
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values"
      ],
      "core-js/proposals/object-values-entries": [
        "es.object.entries",
        "es.object.values"
      ],
      "core-js/proposals/observable": [
        "esnext.observable",
        "esnext.symbol.observable"
      ],
      "core-js/proposals/pattern-matching": [
        "esnext.symbol.matcher",
        "esnext.symbol.pattern-match"
      ],
      "core-js/proposals/promise-all-settled": [
        "esnext.promise.all-settled"
      ],
      "core-js/proposals/promise-any": [
        "esnext.aggregate-error",
        "esnext.promise.any"
      ],
      "core-js/proposals/promise-finally": [
        "es.promise.finally"
      ],
      "core-js/proposals/promise-try": [
        "esnext.promise.try"
      ],
      "core-js/proposals/reflect-metadata": [
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata"
      ],
      "core-js/proposals/regexp-dotall-flag": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags"
      ],
      "core-js/proposals/regexp-named-groups": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/proposals/relative-indexing-method": [
        "es.string.at-alternative",
        "esnext.array.at",
        "esnext.typed-array.at"
      ],
      "core-js/proposals/seeded-random": [
        "esnext.math.seeded-prng"
      ],
      "core-js/proposals/set-methods": [
        "esnext.set.difference",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.symmetric-difference",
        "esnext.set.union"
      ],
      "core-js/proposals/string-at": [
        "esnext.string.at"
      ],
      "core-js/proposals/string-code-points": [
        "esnext.string.code-points"
      ],
      "core-js/proposals/string-cooked": [
        "esnext.string.cooked"
      ],
      "core-js/proposals/string-left-right-trim": [
        "es.string.trim-end",
        "es.string.trim-start"
      ],
      "core-js/proposals/string-match-all": [
        "esnext.string.match-all"
      ],
      "core-js/proposals/string-padding": [
        "es.string.pad-end",
        "es.string.pad-start"
      ],
      "core-js/proposals/string-replace-all": [
        "esnext.string.replace-all",
        "esnext.symbol.replace-all"
      ],
      "core-js/proposals/string-replace-all-stage-4": [
        "esnext.string.replace-all"
      ],
      "core-js/proposals/symbol-description": [
        "es.symbol.description"
      ],
      "core-js/proposals/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/proposals/using-statement": [
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose"
      ],
      "core-js/proposals/well-formed-stringify": [
        "es.json.stringify"
      ],
      "core-js/stable": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.error.cause",
        "es.error.to-string",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.data-view",
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string",
        "es.escape",
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name",
        "es.global-this",
        "es.json.stringify",
        "es.json.to-string-tag",
        "es.map",
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc",
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.parse-float",
        "es.parse-int",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag",
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.set",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string",
        "es.unescape",
        "es.weak-map",
        "es.weak-set",
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/stable/aggregate-error": [
        "es.error.cause",
        "es.aggregate-error",
        "es.aggregate-error.cause",
        "es.array.iterator",
        "es.string.iterator",
        "esnext.aggregate-error",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/array": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.from",
        "es.array.includes",
        "es.array.index-of",
        "es.array.is-array",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.of",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/stable/array-buffer": [
        "es.array-buffer.constructor",
        "es.array-buffer.is-view",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/stable/array-buffer/constructor": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string"
      ],
      "core-js/stable/array-buffer/is-view": [
        "es.array-buffer.is-view"
      ],
      "core-js/stable/array-buffer/slice": [
        "es.array-buffer.slice"
      ],
      "core-js/stable/array/at": [
        "es.array.at"
      ],
      "core-js/stable/array/concat": [
        "es.array.concat"
      ],
      "core-js/stable/array/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/stable/array/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/every": [
        "es.array.every"
      ],
      "core-js/stable/array/fill": [
        "es.array.fill"
      ],
      "core-js/stable/array/filter": [
        "es.array.filter"
      ],
      "core-js/stable/array/find": [
        "es.array.find"
      ],
      "core-js/stable/array/find-index": [
        "es.array.find-index"
      ],
      "core-js/stable/array/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/stable/array/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/stable/array/for-each": [
        "es.array.for-each"
      ],
      "core-js/stable/array/from": [
        "es.array.from",
        "es.string.iterator"
      ],
      "core-js/stable/array/includes": [
        "es.array.includes"
      ],
      "core-js/stable/array/index-of": [
        "es.array.index-of"
      ],
      "core-js/stable/array/is-array": [
        "es.array.is-array"
      ],
      "core-js/stable/array/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/join": [
        "es.array.join"
      ],
      "core-js/stable/array/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/stable/array/map": [
        "es.array.map"
      ],
      "core-js/stable/array/of": [
        "es.array.of"
      ],
      "core-js/stable/array/reduce": [
        "es.array.reduce"
      ],
      "core-js/stable/array/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/stable/array/reverse": [
        "es.array.reverse"
      ],
      "core-js/stable/array/slice": [
        "es.array.slice"
      ],
      "core-js/stable/array/some": [
        "es.array.some"
      ],
      "core-js/stable/array/sort": [
        "es.array.sort"
      ],
      "core-js/stable/array/splice": [
        "es.array.splice"
      ],
      "core-js/stable/array/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/virtual": [
        "es.array.at",
        "es.array.concat",
        "es.array.copy-within",
        "es.array.every",
        "es.array.fill",
        "es.array.filter",
        "es.array.find",
        "es.array.find-index",
        "es.array.flat",
        "es.array.flat-map",
        "es.array.for-each",
        "es.array.includes",
        "es.array.index-of",
        "es.array.iterator",
        "es.array.join",
        "es.array.last-index-of",
        "es.array.map",
        "es.array.reduce",
        "es.array.reduce-right",
        "es.array.reverse",
        "es.array.slice",
        "es.array.some",
        "es.array.sort",
        "es.array.species",
        "es.array.splice",
        "es.array.unscopables.flat",
        "es.array.unscopables.flat-map",
        "es.object.to-string"
      ],
      "core-js/stable/array/virtual/at": [
        "es.array.at"
      ],
      "core-js/stable/array/virtual/concat": [
        "es.array.concat"
      ],
      "core-js/stable/array/virtual/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/stable/array/virtual/entries": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/virtual/every": [
        "es.array.every"
      ],
      "core-js/stable/array/virtual/fill": [
        "es.array.fill"
      ],
      "core-js/stable/array/virtual/filter": [
        "es.array.filter"
      ],
      "core-js/stable/array/virtual/find": [
        "es.array.find"
      ],
      "core-js/stable/array/virtual/find-index": [
        "es.array.find-index"
      ],
      "core-js/stable/array/virtual/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/stable/array/virtual/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/stable/array/virtual/for-each": [
        "es.array.for-each"
      ],
      "core-js/stable/array/virtual/includes": [
        "es.array.includes"
      ],
      "core-js/stable/array/virtual/index-of": [
        "es.array.index-of"
      ],
      "core-js/stable/array/virtual/iterator": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/virtual/join": [
        "es.array.join"
      ],
      "core-js/stable/array/virtual/keys": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/array/virtual/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/stable/array/virtual/map": [
        "es.array.map"
      ],
      "core-js/stable/array/virtual/reduce": [
        "es.array.reduce"
      ],
      "core-js/stable/array/virtual/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/stable/array/virtual/reverse": [
        "es.array.reverse"
      ],
      "core-js/stable/array/virtual/slice": [
        "es.array.slice"
      ],
      "core-js/stable/array/virtual/some": [
        "es.array.some"
      ],
      "core-js/stable/array/virtual/sort": [
        "es.array.sort"
      ],
      "core-js/stable/array/virtual/splice": [
        "es.array.splice"
      ],
      "core-js/stable/array/virtual/values": [
        "es.array.iterator",
        "es.object.to-string"
      ],
      "core-js/stable/atob": [
        "es.error.to-string",
        "es.object.to-string",
        "web.atob",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/stable/btoa": [
        "es.error.to-string",
        "es.object.to-string",
        "web.btoa",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/stable/clear-immediate": [
        "web.immediate"
      ],
      "core-js/stable/data-view": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.data-view",
        "es.object.to-string"
      ],
      "core-js/stable/date": [
        "es.date.get-year",
        "es.date.now",
        "es.date.set-year",
        "es.date.to-gmt-string",
        "es.date.to-iso-string",
        "es.date.to-json",
        "es.date.to-primitive",
        "es.date.to-string"
      ],
      "core-js/stable/date/get-year": [
        "es.date.get-year"
      ],
      "core-js/stable/date/now": [
        "es.date.now"
      ],
      "core-js/stable/date/set-year": [
        "es.date.set-year"
      ],
      "core-js/stable/date/to-gmt-string": [
        "es.date.to-gmt-string"
      ],
      "core-js/stable/date/to-iso-string": [
        "es.date.to-iso-string",
        "es.date.to-json"
      ],
      "core-js/stable/date/to-json": [
        "es.date.to-json"
      ],
      "core-js/stable/date/to-primitive": [
        "es.date.to-primitive"
      ],
      "core-js/stable/date/to-string": [
        "es.date.to-string"
      ],
      "core-js/stable/dom-collections": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/dom-collections/for-each": [
        "web.dom-collections.for-each"
      ],
      "core-js/stable/dom-collections/iterator": [
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/dom-exception": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/stable/dom-exception/constructor": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack"
      ],
      "core-js/stable/dom-exception/to-string-tag": [
        "web.dom-exception.to-string-tag"
      ],
      "core-js/stable/error": [
        "es.error.cause",
        "es.error.to-string"
      ],
      "core-js/stable/error/constructor": [
        "es.error.cause"
      ],
      "core-js/stable/error/to-string": [
        "es.error.to-string"
      ],
      "core-js/stable/escape": [
        "es.escape"
      ],
      "core-js/stable/function": [
        "es.function.bind",
        "es.function.has-instance",
        "es.function.name"
      ],
      "core-js/stable/function/bind": [
        "es.function.bind"
      ],
      "core-js/stable/function/has-instance": [
        "es.function.has-instance"
      ],
      "core-js/stable/function/name": [
        "es.function.name"
      ],
      "core-js/stable/function/virtual": [
        "es.function.bind"
      ],
      "core-js/stable/function/virtual/bind": [
        "es.function.bind"
      ],
      "core-js/stable/get-iterator": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/get-iterator-method": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/global-this": [
        "es.global-this"
      ],
      "core-js/stable/instance/at": [
        "es.array.at",
        "es.string.at-alternative"
      ],
      "core-js/stable/instance/bind": [
        "es.function.bind"
      ],
      "core-js/stable/instance/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/stable/instance/concat": [
        "es.array.concat"
      ],
      "core-js/stable/instance/copy-within": [
        "es.array.copy-within"
      ],
      "core-js/stable/instance/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/stable/instance/entries": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/instance/every": [
        "es.array.every"
      ],
      "core-js/stable/instance/fill": [
        "es.array.fill"
      ],
      "core-js/stable/instance/filter": [
        "es.array.filter"
      ],
      "core-js/stable/instance/find": [
        "es.array.find"
      ],
      "core-js/stable/instance/find-index": [
        "es.array.find-index"
      ],
      "core-js/stable/instance/flags": [
        "es.regexp.flags"
      ],
      "core-js/stable/instance/flat": [
        "es.array.flat",
        "es.array.unscopables.flat"
      ],
      "core-js/stable/instance/flat-map": [
        "es.array.flat-map",
        "es.array.unscopables.flat-map"
      ],
      "core-js/stable/instance/for-each": [
        "es.array.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/instance/includes": [
        "es.array.includes",
        "es.string.includes"
      ],
      "core-js/stable/instance/index-of": [
        "es.array.index-of"
      ],
      "core-js/stable/instance/keys": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/instance/last-index-of": [
        "es.array.last-index-of"
      ],
      "core-js/stable/instance/map": [
        "es.array.map"
      ],
      "core-js/stable/instance/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/stable/instance/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/stable/instance/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/stable/instance/reduce": [
        "es.array.reduce"
      ],
      "core-js/stable/instance/reduce-right": [
        "es.array.reduce-right"
      ],
      "core-js/stable/instance/repeat": [
        "es.string.repeat"
      ],
      "core-js/stable/instance/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/stable/instance/reverse": [
        "es.array.reverse"
      ],
      "core-js/stable/instance/slice": [
        "es.array.slice"
      ],
      "core-js/stable/instance/some": [
        "es.array.some"
      ],
      "core-js/stable/instance/sort": [
        "es.array.sort"
      ],
      "core-js/stable/instance/splice": [
        "es.array.splice"
      ],
      "core-js/stable/instance/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/stable/instance/trim": [
        "es.string.trim"
      ],
      "core-js/stable/instance/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/stable/instance/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/stable/instance/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/stable/instance/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/stable/instance/values": [
        "es.array.iterator",
        "es.object.to-string",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/is-iterable": [
        "es.array.iterator",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/json": [
        "es.json.stringify",
        "es.json.to-string-tag"
      ],
      "core-js/stable/json/stringify": [
        "es.json.stringify"
      ],
      "core-js/stable/json/to-string-tag": [
        "es.json.to-string-tag"
      ],
      "core-js/stable/map": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/math": [
        "es.math.acosh",
        "es.math.asinh",
        "es.math.atanh",
        "es.math.cbrt",
        "es.math.clz32",
        "es.math.cosh",
        "es.math.expm1",
        "es.math.fround",
        "es.math.hypot",
        "es.math.imul",
        "es.math.log10",
        "es.math.log1p",
        "es.math.log2",
        "es.math.sign",
        "es.math.sinh",
        "es.math.tanh",
        "es.math.to-string-tag",
        "es.math.trunc"
      ],
      "core-js/stable/math/acosh": [
        "es.math.acosh"
      ],
      "core-js/stable/math/asinh": [
        "es.math.asinh"
      ],
      "core-js/stable/math/atanh": [
        "es.math.atanh"
      ],
      "core-js/stable/math/cbrt": [
        "es.math.cbrt"
      ],
      "core-js/stable/math/clz32": [
        "es.math.clz32"
      ],
      "core-js/stable/math/cosh": [
        "es.math.cosh"
      ],
      "core-js/stable/math/expm1": [
        "es.math.expm1"
      ],
      "core-js/stable/math/fround": [
        "es.math.fround"
      ],
      "core-js/stable/math/hypot": [
        "es.math.hypot"
      ],
      "core-js/stable/math/imul": [
        "es.math.imul"
      ],
      "core-js/stable/math/log10": [
        "es.math.log10"
      ],
      "core-js/stable/math/log1p": [
        "es.math.log1p"
      ],
      "core-js/stable/math/log2": [
        "es.math.log2"
      ],
      "core-js/stable/math/sign": [
        "es.math.sign"
      ],
      "core-js/stable/math/sinh": [
        "es.math.sinh"
      ],
      "core-js/stable/math/tanh": [
        "es.math.tanh"
      ],
      "core-js/stable/math/to-string-tag": [
        "es.math.to-string-tag"
      ],
      "core-js/stable/math/trunc": [
        "es.math.trunc"
      ],
      "core-js/stable/number": [
        "es.number.constructor",
        "es.number.epsilon",
        "es.number.is-finite",
        "es.number.is-integer",
        "es.number.is-nan",
        "es.number.is-safe-integer",
        "es.number.max-safe-integer",
        "es.number.min-safe-integer",
        "es.number.parse-float",
        "es.number.parse-int",
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/stable/number/constructor": [
        "es.number.constructor"
      ],
      "core-js/stable/number/epsilon": [
        "es.number.epsilon"
      ],
      "core-js/stable/number/is-finite": [
        "es.number.is-finite"
      ],
      "core-js/stable/number/is-integer": [
        "es.number.is-integer"
      ],
      "core-js/stable/number/is-nan": [
        "es.number.is-nan"
      ],
      "core-js/stable/number/is-safe-integer": [
        "es.number.is-safe-integer"
      ],
      "core-js/stable/number/max-safe-integer": [
        "es.number.max-safe-integer"
      ],
      "core-js/stable/number/min-safe-integer": [
        "es.number.min-safe-integer"
      ],
      "core-js/stable/number/parse-float": [
        "es.number.parse-float"
      ],
      "core-js/stable/number/parse-int": [
        "es.number.parse-int"
      ],
      "core-js/stable/number/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/stable/number/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/stable/number/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/stable/number/virtual": [
        "es.number.to-exponential",
        "es.number.to-fixed",
        "es.number.to-precision"
      ],
      "core-js/stable/number/virtual/to-exponential": [
        "es.number.to-exponential"
      ],
      "core-js/stable/number/virtual/to-fixed": [
        "es.number.to-fixed"
      ],
      "core-js/stable/number/virtual/to-precision": [
        "es.number.to-precision"
      ],
      "core-js/stable/object": [
        "es.symbol",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.assign",
        "es.object.create",
        "es.object.define-getter",
        "es.object.define-properties",
        "es.object.define-property",
        "es.object.define-setter",
        "es.object.entries",
        "es.object.freeze",
        "es.object.from-entries",
        "es.object.get-own-property-descriptor",
        "es.object.get-own-property-descriptors",
        "es.object.get-own-property-names",
        "es.object.get-prototype-of",
        "es.object.has-own",
        "es.object.is",
        "es.object.is-extensible",
        "es.object.is-frozen",
        "es.object.is-sealed",
        "es.object.keys",
        "es.object.lookup-getter",
        "es.object.lookup-setter",
        "es.object.prevent-extensions",
        "es.object.seal",
        "es.object.set-prototype-of",
        "es.object.to-string",
        "es.object.values",
        "es.reflect.to-string-tag",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/object/assign": [
        "es.object.assign"
      ],
      "core-js/stable/object/create": [
        "es.object.create"
      ],
      "core-js/stable/object/define-getter": [
        "es.object.define-getter"
      ],
      "core-js/stable/object/define-properties": [
        "es.object.define-properties"
      ],
      "core-js/stable/object/define-property": [
        "es.object.define-property"
      ],
      "core-js/stable/object/define-setter": [
        "es.object.define-setter"
      ],
      "core-js/stable/object/entries": [
        "es.object.entries"
      ],
      "core-js/stable/object/freeze": [
        "es.object.freeze"
      ],
      "core-js/stable/object/from-entries": [
        "es.array.iterator",
        "es.object.from-entries",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/object/get-own-property-descriptor": [
        "es.object.get-own-property-descriptor"
      ],
      "core-js/stable/object/get-own-property-descriptors": [
        "es.object.get-own-property-descriptors"
      ],
      "core-js/stable/object/get-own-property-names": [
        "es.object.get-own-property-names"
      ],
      "core-js/stable/object/get-own-property-symbols": [
        "es.symbol"
      ],
      "core-js/stable/object/get-prototype-of": [
        "es.object.get-prototype-of"
      ],
      "core-js/stable/object/has-own": [
        "es.object.has-own"
      ],
      "core-js/stable/object/is": [
        "es.object.is"
      ],
      "core-js/stable/object/is-extensible": [
        "es.object.is-extensible"
      ],
      "core-js/stable/object/is-frozen": [
        "es.object.is-frozen"
      ],
      "core-js/stable/object/is-sealed": [
        "es.object.is-sealed"
      ],
      "core-js/stable/object/keys": [
        "es.object.keys"
      ],
      "core-js/stable/object/lookup-getter": [
        "es.object.lookup-setter"
      ],
      "core-js/stable/object/lookup-setter": [
        "es.object.lookup-setter"
      ],
      "core-js/stable/object/prevent-extensions": [
        "es.object.prevent-extensions"
      ],
      "core-js/stable/object/seal": [
        "es.object.seal"
      ],
      "core-js/stable/object/set-prototype-of": [
        "es.object.set-prototype-of"
      ],
      "core-js/stable/object/to-string": [
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/stable/object/values": [
        "es.object.values"
      ],
      "core-js/stable/parse-float": [
        "es.parse-float"
      ],
      "core-js/stable/parse-int": [
        "es.parse-int"
      ],
      "core-js/stable/promise": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.promise.any",
        "es.promise.finally",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/promise/all-settled": [
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.all-settled",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/promise/any": [
        "es.aggregate-error",
        "es.array.iterator",
        "es.object.to-string",
        "es.promise",
        "es.promise.any",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/promise/finally": [
        "es.object.to-string",
        "es.promise",
        "es.promise.finally"
      ],
      "core-js/stable/queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/stable/reflect": [
        "es.object.to-string",
        "es.reflect.apply",
        "es.reflect.construct",
        "es.reflect.define-property",
        "es.reflect.delete-property",
        "es.reflect.get",
        "es.reflect.get-own-property-descriptor",
        "es.reflect.get-prototype-of",
        "es.reflect.has",
        "es.reflect.is-extensible",
        "es.reflect.own-keys",
        "es.reflect.prevent-extensions",
        "es.reflect.set",
        "es.reflect.set-prototype-of",
        "es.reflect.to-string-tag"
      ],
      "core-js/stable/reflect/apply": [
        "es.reflect.apply"
      ],
      "core-js/stable/reflect/construct": [
        "es.reflect.construct"
      ],
      "core-js/stable/reflect/define-property": [
        "es.reflect.define-property"
      ],
      "core-js/stable/reflect/delete-property": [
        "es.reflect.delete-property"
      ],
      "core-js/stable/reflect/get": [
        "es.reflect.get"
      ],
      "core-js/stable/reflect/get-own-property-descriptor": [
        "es.reflect.get-own-property-descriptor"
      ],
      "core-js/stable/reflect/get-prototype-of": [
        "es.reflect.get-prototype-of"
      ],
      "core-js/stable/reflect/has": [
        "es.reflect.has"
      ],
      "core-js/stable/reflect/is-extensible": [
        "es.reflect.is-extensible"
      ],
      "core-js/stable/reflect/own-keys": [
        "es.reflect.own-keys"
      ],
      "core-js/stable/reflect/prevent-extensions": [
        "es.reflect.prevent-extensions"
      ],
      "core-js/stable/reflect/set": [
        "es.reflect.set"
      ],
      "core-js/stable/reflect/set-prototype-of": [
        "es.reflect.set-prototype-of"
      ],
      "core-js/stable/reflect/to-string-tag": [
        "es.reflect.to-string-tag"
      ],
      "core-js/stable/regexp": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.flags",
        "es.regexp.sticky",
        "es.regexp.test",
        "es.regexp.to-string",
        "es.string.match",
        "es.string.replace",
        "es.string.search",
        "es.string.split"
      ],
      "core-js/stable/regexp/constructor": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/stable/regexp/dot-all": [
        "es.regexp.constructor",
        "es.regexp.dot-all",
        "es.regexp.exec"
      ],
      "core-js/stable/regexp/flags": [
        "es.regexp.flags"
      ],
      "core-js/stable/regexp/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/stable/regexp/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/stable/regexp/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/stable/regexp/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/stable/regexp/sticky": [
        "es.regexp.constructor",
        "es.regexp.exec",
        "es.regexp.sticky"
      ],
      "core-js/stable/regexp/test": [
        "es.regexp.exec",
        "es.regexp.test"
      ],
      "core-js/stable/regexp/to-string": [
        "es.regexp.to-string"
      ],
      "core-js/stable/set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.set",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/set-immediate": [
        "web.immediate"
      ],
      "core-js/stable/set-interval": [
        "web.timers"
      ],
      "core-js/stable/set-timeout": [
        "web.timers"
      ],
      "core-js/stable/string": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.from-code-point",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.raw",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/stable/string/anchor": [
        "es.string.anchor"
      ],
      "core-js/stable/string/at": [
        "es.string.at-alternative"
      ],
      "core-js/stable/string/big": [
        "es.string.big"
      ],
      "core-js/stable/string/blink": [
        "es.string.blink"
      ],
      "core-js/stable/string/bold": [
        "es.string.bold"
      ],
      "core-js/stable/string/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/stable/string/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/stable/string/fixed": [
        "es.string.fixed"
      ],
      "core-js/stable/string/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/stable/string/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/stable/string/from-code-point": [
        "es.string.from-code-point"
      ],
      "core-js/stable/string/includes": [
        "es.string.includes"
      ],
      "core-js/stable/string/italics": [
        "es.string.italics"
      ],
      "core-js/stable/string/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/stable/string/link": [
        "es.string.link"
      ],
      "core-js/stable/string/match": [
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/stable/string/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/stable/string/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/stable/string/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/stable/string/raw": [
        "es.string.raw"
      ],
      "core-js/stable/string/repeat": [
        "es.string.repeat"
      ],
      "core-js/stable/string/replace": [
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/stable/string/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/stable/string/search": [
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/stable/string/small": [
        "es.string.small"
      ],
      "core-js/stable/string/split": [
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/stable/string/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/stable/string/strike": [
        "es.string.strike"
      ],
      "core-js/stable/string/sub": [
        "es.string.sub"
      ],
      "core-js/stable/string/substr": [
        "es.string.substr"
      ],
      "core-js/stable/string/sup": [
        "es.string.sup"
      ],
      "core-js/stable/string/trim": [
        "es.string.trim"
      ],
      "core-js/stable/string/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/stable/string/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/stable/string/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/stable/string/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/stable/string/virtual": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.at-alternative",
        "es.string.code-point-at",
        "es.string.ends-with",
        "es.string.includes",
        "es.string.iterator",
        "es.string.match",
        "es.string.match-all",
        "es.string.pad-end",
        "es.string.pad-start",
        "es.string.repeat",
        "es.string.replace",
        "es.string.replace-all",
        "es.string.search",
        "es.string.split",
        "es.string.starts-with",
        "es.string.substr",
        "es.string.trim",
        "es.string.trim-end",
        "es.string.trim-start",
        "es.string.anchor",
        "es.string.big",
        "es.string.blink",
        "es.string.bold",
        "es.string.fixed",
        "es.string.fontcolor",
        "es.string.fontsize",
        "es.string.italics",
        "es.string.link",
        "es.string.small",
        "es.string.strike",
        "es.string.sub",
        "es.string.sup"
      ],
      "core-js/stable/string/virtual/anchor": [
        "es.string.anchor"
      ],
      "core-js/stable/string/virtual/at": [
        "es.string.at-alternative"
      ],
      "core-js/stable/string/virtual/big": [
        "es.string.big"
      ],
      "core-js/stable/string/virtual/blink": [
        "es.string.blink"
      ],
      "core-js/stable/string/virtual/bold": [
        "es.string.bold"
      ],
      "core-js/stable/string/virtual/code-point-at": [
        "es.string.code-point-at"
      ],
      "core-js/stable/string/virtual/ends-with": [
        "es.string.ends-with"
      ],
      "core-js/stable/string/virtual/fixed": [
        "es.string.fixed"
      ],
      "core-js/stable/string/virtual/fontcolor": [
        "es.string.fontcolor"
      ],
      "core-js/stable/string/virtual/fontsize": [
        "es.string.fontsize"
      ],
      "core-js/stable/string/virtual/includes": [
        "es.string.includes"
      ],
      "core-js/stable/string/virtual/italics": [
        "es.string.italics"
      ],
      "core-js/stable/string/virtual/iterator": [
        "es.object.to-string",
        "es.string.iterator"
      ],
      "core-js/stable/string/virtual/link": [
        "es.string.link"
      ],
      "core-js/stable/string/virtual/match-all": [
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/stable/string/virtual/pad-end": [
        "es.string.pad-end"
      ],
      "core-js/stable/string/virtual/pad-start": [
        "es.string.pad-start"
      ],
      "core-js/stable/string/virtual/repeat": [
        "es.string.repeat"
      ],
      "core-js/stable/string/virtual/replace-all": [
        "es.regexp.exec",
        "es.string.replace",
        "es.string.replace-all"
      ],
      "core-js/stable/string/virtual/small": [
        "es.string.small"
      ],
      "core-js/stable/string/virtual/starts-with": [
        "es.string.starts-with"
      ],
      "core-js/stable/string/virtual/strike": [
        "es.string.strike"
      ],
      "core-js/stable/string/virtual/sub": [
        "es.string.sub"
      ],
      "core-js/stable/string/virtual/substr": [
        "es.string.substr"
      ],
      "core-js/stable/string/virtual/sup": [
        "es.string.sup"
      ],
      "core-js/stable/string/virtual/trim": [
        "es.string.trim"
      ],
      "core-js/stable/string/virtual/trim-end": [
        "es.string.trim-end"
      ],
      "core-js/stable/string/virtual/trim-left": [
        "es.string.trim-start"
      ],
      "core-js/stable/string/virtual/trim-right": [
        "es.string.trim-end"
      ],
      "core-js/stable/string/virtual/trim-start": [
        "es.string.trim-start"
      ],
      "core-js/stable/structured-clone": [
        "es.error.to-string",
        "es.array.iterator",
        "es.map",
        "es.object.keys",
        "es.object.to-string",
        "es.set",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.structured-clone"
      ],
      "core-js/stable/symbol": [
        "es.symbol",
        "es.symbol.description",
        "es.symbol.async-iterator",
        "es.symbol.has-instance",
        "es.symbol.is-concat-spreadable",
        "es.symbol.iterator",
        "es.symbol.match",
        "es.symbol.match-all",
        "es.symbol.replace",
        "es.symbol.search",
        "es.symbol.species",
        "es.symbol.split",
        "es.symbol.to-primitive",
        "es.symbol.to-string-tag",
        "es.symbol.unscopables",
        "es.array.concat",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/symbol/async-iterator": [
        "es.symbol.async-iterator"
      ],
      "core-js/stable/symbol/description": [
        "es.symbol.description"
      ],
      "core-js/stable/symbol/for": [
        "es.symbol"
      ],
      "core-js/stable/symbol/has-instance": [
        "es.symbol.has-instance",
        "es.function.has-instance"
      ],
      "core-js/stable/symbol/is-concat-spreadable": [
        "es.symbol.is-concat-spreadable",
        "es.array.concat"
      ],
      "core-js/stable/symbol/iterator": [
        "es.symbol.iterator",
        "es.array.iterator",
        "es.object.to-string",
        "es.string.iterator",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/symbol/key-for": [
        "es.symbol"
      ],
      "core-js/stable/symbol/match": [
        "es.symbol.match",
        "es.regexp.exec",
        "es.string.match"
      ],
      "core-js/stable/symbol/match-all": [
        "es.symbol.match-all",
        "es.object.to-string",
        "es.regexp.exec",
        "es.string.match-all"
      ],
      "core-js/stable/symbol/replace": [
        "es.symbol.replace",
        "es.regexp.exec",
        "es.string.replace"
      ],
      "core-js/stable/symbol/search": [
        "es.symbol.search",
        "es.regexp.exec",
        "es.string.search"
      ],
      "core-js/stable/symbol/species": [
        "es.symbol.species"
      ],
      "core-js/stable/symbol/split": [
        "es.symbol.split",
        "es.regexp.exec",
        "es.string.split"
      ],
      "core-js/stable/symbol/to-primitive": [
        "es.symbol.to-primitive",
        "es.date.to-primitive"
      ],
      "core-js/stable/symbol/to-string-tag": [
        "es.symbol.to-string-tag",
        "es.json.to-string-tag",
        "es.math.to-string-tag",
        "es.object.to-string",
        "es.reflect.to-string-tag"
      ],
      "core-js/stable/symbol/unscopables": [
        "es.symbol.unscopables"
      ],
      "core-js/stable/typed-array": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.float64-array",
        "es.typed-array.int8-array",
        "es.typed-array.int16-array",
        "es.typed-array.int32-array",
        "es.typed-array.uint8-array",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.uint16-array",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/at": [
        "es.typed-array.at"
      ],
      "core-js/stable/typed-array/copy-within": [
        "es.typed-array.copy-within"
      ],
      "core-js/stable/typed-array/entries": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/stable/typed-array/every": [
        "es.typed-array.every"
      ],
      "core-js/stable/typed-array/fill": [
        "es.typed-array.fill"
      ],
      "core-js/stable/typed-array/filter": [
        "es.typed-array.filter"
      ],
      "core-js/stable/typed-array/find": [
        "es.typed-array.find"
      ],
      "core-js/stable/typed-array/find-index": [
        "es.typed-array.find-index"
      ],
      "core-js/stable/typed-array/float32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/float64-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.float64-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/for-each": [
        "es.typed-array.for-each"
      ],
      "core-js/stable/typed-array/from": [
        "es.typed-array.from"
      ],
      "core-js/stable/typed-array/includes": [
        "es.typed-array.includes"
      ],
      "core-js/stable/typed-array/index-of": [
        "es.typed-array.index-of"
      ],
      "core-js/stable/typed-array/int16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/int32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/int8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.int8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/iterator": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/stable/typed-array/join": [
        "es.typed-array.join"
      ],
      "core-js/stable/typed-array/keys": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/stable/typed-array/last-index-of": [
        "es.typed-array.last-index-of"
      ],
      "core-js/stable/typed-array/map": [
        "es.typed-array.map"
      ],
      "core-js/stable/typed-array/methods": [
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/of": [
        "es.typed-array.of"
      ],
      "core-js/stable/typed-array/reduce": [
        "es.typed-array.reduce"
      ],
      "core-js/stable/typed-array/reduce-right": [
        "es.typed-array.reduce-right"
      ],
      "core-js/stable/typed-array/reverse": [
        "es.typed-array.reverse"
      ],
      "core-js/stable/typed-array/set": [
        "es.typed-array.set"
      ],
      "core-js/stable/typed-array/slice": [
        "es.typed-array.slice"
      ],
      "core-js/stable/typed-array/some": [
        "es.typed-array.some"
      ],
      "core-js/stable/typed-array/sort": [
        "es.typed-array.sort"
      ],
      "core-js/stable/typed-array/subarray": [
        "es.typed-array.subarray"
      ],
      "core-js/stable/typed-array/to-locale-string": [
        "es.typed-array.to-locale-string"
      ],
      "core-js/stable/typed-array/to-string": [
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/uint16-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint16-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/uint32-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint32-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/uint8-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/uint8-clamped-array": [
        "es.array-buffer.constructor",
        "es.array-buffer.slice",
        "es.object.to-string",
        "es.string.iterator",
        "es.typed-array.uint8-clamped-array",
        "es.typed-array.at",
        "es.typed-array.copy-within",
        "es.typed-array.every",
        "es.typed-array.fill",
        "es.typed-array.filter",
        "es.typed-array.find",
        "es.typed-array.find-index",
        "es.typed-array.for-each",
        "es.typed-array.from",
        "es.typed-array.includes",
        "es.typed-array.index-of",
        "es.typed-array.iterator",
        "es.typed-array.join",
        "es.typed-array.last-index-of",
        "es.typed-array.map",
        "es.typed-array.of",
        "es.typed-array.reduce",
        "es.typed-array.reduce-right",
        "es.typed-array.reverse",
        "es.typed-array.set",
        "es.typed-array.slice",
        "es.typed-array.some",
        "es.typed-array.sort",
        "es.typed-array.subarray",
        "es.typed-array.to-locale-string",
        "es.typed-array.to-string"
      ],
      "core-js/stable/typed-array/values": [
        "es.object.to-string",
        "es.typed-array.iterator"
      ],
      "core-js/stable/unescape": [
        "es.unescape"
      ],
      "core-js/stable/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/stable/url-search-params": [
        "web.dom-collections.iterator",
        "web.url-search-params"
      ],
      "core-js/stable/url/to-json": [
        "web.url.to-json"
      ],
      "core-js/stable/weak-map": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-map",
        "web.dom-collections.iterator"
      ],
      "core-js/stable/weak-set": [
        "es.array.iterator",
        "es.object.to-string",
        "es.weak-set",
        "web.dom-collections.iterator"
      ],
      "core-js/stage": [
        "es.map",
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/stage/0": [
        "es.map",
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/stage/1": [
        "es.map",
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of"
      ],
      "core-js/stage/2": [
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.emplace",
        "esnext.object.has-own",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.set.difference",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.metadata",
        "esnext.typed-array.at",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with",
        "esnext.weak-map.emplace"
      ],
      "core-js/stage/3": [
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.at",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.with",
        "esnext.global-this",
        "esnext.object.has-own",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.typed-array.at",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.with"
      ],
      "core-js/stage/4": [
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.at",
        "esnext.global-this",
        "esnext.object.has-own",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.typed-array.at"
      ],
      "core-js/stage/pre": [
        "es.map",
        "es.string.at-alternative",
        "esnext.aggregate-error",
        "esnext.array.from-async",
        "esnext.array.at",
        "esnext.array.filter-out",
        "esnext.array.filter-reject",
        "esnext.array.find-last",
        "esnext.array.find-last-index",
        "esnext.array.group-by",
        "esnext.array.group-by-to-map",
        "esnext.array.is-template-object",
        "esnext.array.last-index",
        "esnext.array.last-item",
        "esnext.array.to-reversed",
        "esnext.array.to-sorted",
        "esnext.array.to-spliced",
        "esnext.array.unique-by",
        "esnext.array.with",
        "esnext.async-iterator.constructor",
        "esnext.async-iterator.as-indexed-pairs",
        "esnext.async-iterator.drop",
        "esnext.async-iterator.every",
        "esnext.async-iterator.filter",
        "esnext.async-iterator.find",
        "esnext.async-iterator.flat-map",
        "esnext.async-iterator.for-each",
        "esnext.async-iterator.from",
        "esnext.async-iterator.map",
        "esnext.async-iterator.reduce",
        "esnext.async-iterator.some",
        "esnext.async-iterator.take",
        "esnext.async-iterator.to-array",
        "esnext.bigint.range",
        "esnext.composite-key",
        "esnext.composite-symbol",
        "esnext.function.is-callable",
        "esnext.function.is-constructor",
        "esnext.function.un-this",
        "esnext.global-this",
        "esnext.iterator.constructor",
        "esnext.iterator.as-indexed-pairs",
        "esnext.iterator.drop",
        "esnext.iterator.every",
        "esnext.iterator.filter",
        "esnext.iterator.find",
        "esnext.iterator.flat-map",
        "esnext.iterator.for-each",
        "esnext.iterator.from",
        "esnext.iterator.map",
        "esnext.iterator.reduce",
        "esnext.iterator.some",
        "esnext.iterator.take",
        "esnext.iterator.to-array",
        "esnext.iterator.to-async",
        "esnext.map.delete-all",
        "esnext.map.emplace",
        "esnext.map.every",
        "esnext.map.filter",
        "esnext.map.find",
        "esnext.map.find-key",
        "esnext.map.from",
        "esnext.map.group-by",
        "esnext.map.includes",
        "esnext.map.key-by",
        "esnext.map.key-of",
        "esnext.map.map-keys",
        "esnext.map.map-values",
        "esnext.map.merge",
        "esnext.map.of",
        "esnext.map.reduce",
        "esnext.map.some",
        "esnext.map.update",
        "esnext.map.update-or-insert",
        "esnext.map.upsert",
        "esnext.math.clamp",
        "esnext.math.deg-per-rad",
        "esnext.math.degrees",
        "esnext.math.fscale",
        "esnext.math.iaddh",
        "esnext.math.imulh",
        "esnext.math.isubh",
        "esnext.math.rad-per-deg",
        "esnext.math.radians",
        "esnext.math.scale",
        "esnext.math.seeded-prng",
        "esnext.math.signbit",
        "esnext.math.umulh",
        "esnext.number.from-string",
        "esnext.number.range",
        "esnext.object.has-own",
        "esnext.object.iterate-entries",
        "esnext.object.iterate-keys",
        "esnext.object.iterate-values",
        "esnext.observable",
        "esnext.promise.all-settled",
        "esnext.promise.any",
        "esnext.promise.try",
        "esnext.reflect.define-metadata",
        "esnext.reflect.delete-metadata",
        "esnext.reflect.get-metadata",
        "esnext.reflect.get-metadata-keys",
        "esnext.reflect.get-own-metadata",
        "esnext.reflect.get-own-metadata-keys",
        "esnext.reflect.has-metadata",
        "esnext.reflect.has-own-metadata",
        "esnext.reflect.metadata",
        "esnext.set.add-all",
        "esnext.set.delete-all",
        "esnext.set.difference",
        "esnext.set.every",
        "esnext.set.filter",
        "esnext.set.find",
        "esnext.set.from",
        "esnext.set.intersection",
        "esnext.set.is-disjoint-from",
        "esnext.set.is-subset-of",
        "esnext.set.is-superset-of",
        "esnext.set.join",
        "esnext.set.map",
        "esnext.set.of",
        "esnext.set.reduce",
        "esnext.set.some",
        "esnext.set.symmetric-difference",
        "esnext.set.union",
        "esnext.string.at",
        "esnext.string.cooked",
        "esnext.string.code-points",
        "esnext.string.match-all",
        "esnext.string.replace-all",
        "esnext.symbol.async-dispose",
        "esnext.symbol.dispose",
        "esnext.symbol.matcher",
        "esnext.symbol.metadata",
        "esnext.symbol.observable",
        "esnext.symbol.pattern-match",
        "esnext.symbol.replace-all",
        "esnext.typed-array.from-async",
        "esnext.typed-array.at",
        "esnext.typed-array.filter-out",
        "esnext.typed-array.filter-reject",
        "esnext.typed-array.find-last",
        "esnext.typed-array.find-last-index",
        "esnext.typed-array.group-by",
        "esnext.typed-array.to-reversed",
        "esnext.typed-array.to-sorted",
        "esnext.typed-array.to-spliced",
        "esnext.typed-array.unique-by",
        "esnext.typed-array.with",
        "esnext.weak-map.delete-all",
        "esnext.weak-map.from",
        "esnext.weak-map.of",
        "esnext.weak-map.emplace",
        "esnext.weak-map.upsert",
        "esnext.weak-set.add-all",
        "esnext.weak-set.delete-all",
        "esnext.weak-set.from",
        "esnext.weak-set.of",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/web": [
        "web.atob",
        "web.btoa",
        "web.dom-collections.for-each",
        "web.dom-collections.iterator",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag",
        "web.immediate",
        "web.queue-microtask",
        "web.structured-clone",
        "web.timers",
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/web/dom-collections": [
        "web.dom-collections.for-each",
        "web.dom-collections.iterator"
      ],
      "core-js/web/dom-exception": [
        "es.error.to-string",
        "web.dom-exception.constructor",
        "web.dom-exception.stack",
        "web.dom-exception.to-string-tag"
      ],
      "core-js/web/immediate": [
        "web.immediate"
      ],
      "core-js/web/queue-microtask": [
        "web.queue-microtask"
      ],
      "core-js/web/structured-clone": [
        "es.array.iterator",
        "es.map",
        "es.object.to-string",
        "es.set",
        "web.structured-clone"
      ],
      "core-js/web/timers": [
        "web.timers"
      ],
      "core-js/web/url": [
        "web.url",
        "web.url.to-json",
        "web.url-search-params"
      ],
      "core-js/web/url-search-params": [
        "web.url-search-params"
      ]
    };
    var entries$1 = require$$0$2;
    var corejs3ShippedProposalsList$1 = /* @__PURE__ */ new Set(["esnext.array.find-last", "esnext.array.find-last-index", "esnext.typed-array.find-last", "esnext.typed-array.find-last-index"]);
    var polyfillsOrder$1 = {};
    Object.keys(data$1).forEach(function(name2, index3) {
      polyfillsOrder$1[name2] = index3;
    });
    var define$2 = function define2(pure, global2, name2, exclude) {
      if (name2 === void 0) {
        name2 = global2[0];
      }
      return {
        name: name2,
        pure,
        global: global2.sort(function(a, b2) {
          return polyfillsOrder$1[a] - polyfillsOrder$1[b2];
        }),
        exclude
      };
    };
    var typed$1 = function typed2(name2) {
      return define$2(null, [name2].concat(TypedArrayDependencies$1));
    };
    var ArrayNatureIterators$2 = ["es.array.iterator", "web.dom-collections.iterator"];
    var CommonIterators$2 = ["es.string.iterator"].concat(ArrayNatureIterators$2);
    var ArrayNatureIteratorsWithTag$1 = ["es.object.to-string"].concat(ArrayNatureIterators$2);
    var CommonIteratorsWithTag$1 = ["es.object.to-string"].concat(_toConsumableArray2(CommonIterators$2));
    var ErrorDependencies$1 = ["es.error.cause", "es.error.to-string"];
    var TypedArrayDependencies$1 = ["es.typed-array.at", "es.typed-array.copy-within", "es.typed-array.every", "es.typed-array.fill", "es.typed-array.filter", "es.typed-array.find", "es.typed-array.find-index", "es.typed-array.for-each", "es.typed-array.includes", "es.typed-array.index-of", "es.typed-array.iterator", "es.typed-array.join", "es.typed-array.last-index-of", "es.typed-array.map", "es.typed-array.reduce", "es.typed-array.reduce-right", "es.typed-array.reverse", "es.typed-array.set", "es.typed-array.slice", "es.typed-array.some", "es.typed-array.sort", "es.typed-array.subarray", "es.typed-array.to-locale-string", "es.typed-array.to-string", "es.object.to-string", "es.array.iterator", "es.array-buffer.slice", "esnext.typed-array.filter-reject", "esnext.typed-array.find-last", "esnext.typed-array.find-last-index", "esnext.typed-array.group-by", "esnext.typed-array.to-reversed", "esnext.typed-array.to-sorted", "esnext.typed-array.to-spliced", "esnext.typed-array.unique-by", "esnext.typed-array.with"];
    var PromiseDependencies$2 = ["es.promise", "es.object.to-string"];
    var PromiseDependenciesWithIterators$1 = [].concat(PromiseDependencies$2, _toConsumableArray2(CommonIterators$2));
    var SymbolDependencies$1 = ["es.symbol", "es.symbol.description", "es.object.to-string"];
    var MapDependencies$1 = ["es.map", "esnext.map.delete-all", "esnext.map.emplace", "esnext.map.every", "esnext.map.filter", "esnext.map.find", "esnext.map.find-key", "esnext.map.includes", "esnext.map.key-of", "esnext.map.map-keys", "esnext.map.map-values", "esnext.map.merge", "esnext.map.reduce", "esnext.map.some", "esnext.map.update"].concat(_toConsumableArray2(CommonIteratorsWithTag$1));
    var SetDependencies$1 = ["es.set", "esnext.set.add-all", "esnext.set.delete-all", "esnext.set.difference", "esnext.set.every", "esnext.set.filter", "esnext.set.find", "esnext.set.intersection", "esnext.set.is-disjoint-from", "esnext.set.is-subset-of", "esnext.set.is-superset-of", "esnext.set.join", "esnext.set.map", "esnext.set.reduce", "esnext.set.some", "esnext.set.symmetric-difference", "esnext.set.union"].concat(_toConsumableArray2(CommonIteratorsWithTag$1));
    var WeakMapDependencies$1 = ["es.weak-map", "esnext.weak-map.delete-all", "esnext.weak-map.emplace"].concat(_toConsumableArray2(CommonIteratorsWithTag$1));
    var WeakSetDependencies$1 = ["es.weak-set", "esnext.weak-set.add-all", "esnext.weak-set.delete-all"].concat(_toConsumableArray2(CommonIteratorsWithTag$1));
    var DOMExceptionDependencies$1 = ["web.dom-exception.constructor", "web.dom-exception.stack", "web.dom-exception.to-string-tag", "es.error.to-string"];
    var URLSearchParamsDependencies$1 = ["web.url-search-params"].concat(_toConsumableArray2(CommonIteratorsWithTag$1));
    var AsyncIteratorDependencies$1 = ["esnext.async-iterator.constructor"].concat(PromiseDependencies$2);
    var AsyncIteratorProblemMethods$1 = ["esnext.async-iterator.every", "esnext.async-iterator.filter", "esnext.async-iterator.find", "esnext.async-iterator.flat-map", "esnext.async-iterator.for-each", "esnext.async-iterator.map", "esnext.async-iterator.reduce", "esnext.async-iterator.some"];
    var IteratorDependencies$1 = ["esnext.iterator.constructor", "es.object.to-string"];
    var TypedArrayStaticMethods$1 = {
      from: define$2(null, ["es.typed-array.from"]),
      fromAsync: define$2(null, ["esnext.typed-array.from-async"].concat(_toConsumableArray2(PromiseDependenciesWithIterators$1))),
      of: define$2(null, ["es.typed-array.of"])
    };
    var BuiltIns$2 = {
      AsyncIterator: define$2("async-iterator/index", AsyncIteratorDependencies$1),
      AggregateError: define$2("aggregate-error", ["es.aggregate-error"].concat(ErrorDependencies$1, _toConsumableArray2(CommonIteratorsWithTag$1), ["es.aggregate-error.cause"])),
      ArrayBuffer: define$2(null, ["es.array-buffer.constructor", "es.array-buffer.slice", "es.object.to-string"]),
      DataView: define$2(null, ["es.data-view", "es.array-buffer.slice", "es.object.to-string"]),
      Date: define$2(null, ["es.date.to-string"]),
      DOMException: define$2("dom-exception", DOMExceptionDependencies$1),
      Error: define$2(null, ErrorDependencies$1),
      EvalError: define$2(null, ErrorDependencies$1),
      Float32Array: typed$1("es.typed-array.float32-array"),
      Float64Array: typed$1("es.typed-array.float64-array"),
      Int8Array: typed$1("es.typed-array.int8-array"),
      Int16Array: typed$1("es.typed-array.int16-array"),
      Int32Array: typed$1("es.typed-array.int32-array"),
      Iterator: define$2("iterator/index", IteratorDependencies$1),
      Uint8Array: typed$1("es.typed-array.uint8-array"),
      Uint8ClampedArray: typed$1("es.typed-array.uint8-clamped-array"),
      Uint16Array: typed$1("es.typed-array.uint16-array"),
      Uint32Array: typed$1("es.typed-array.uint32-array"),
      Map: define$2("map/index", MapDependencies$1),
      Number: define$2(null, ["es.number.constructor"]),
      Observable: define$2("observable/index", ["esnext.observable", "esnext.symbol.observable", "es.object.to-string"].concat(_toConsumableArray2(CommonIteratorsWithTag$1))),
      Promise: define$2("promise/index", PromiseDependencies$2),
      RangeError: define$2(null, ErrorDependencies$1),
      ReferenceError: define$2(null, ErrorDependencies$1),
      Reflect: define$2(null, ["es.reflect.to-string-tag", "es.object.to-string"]),
      RegExp: define$2(null, ["es.regexp.constructor", "es.regexp.dot-all", "es.regexp.exec", "es.regexp.sticky", "es.regexp.to-string"]),
      Set: define$2("set/index", SetDependencies$1),
      Symbol: define$2("symbol/index", SymbolDependencies$1),
      SyntaxError: define$2(null, ErrorDependencies$1),
      TypeError: define$2(null, ErrorDependencies$1),
      URIError: define$2(null, ErrorDependencies$1),
      URL: define$2("url/index", ["web.url"].concat(_toConsumableArray2(URLSearchParamsDependencies$1))),
      URLSearchParams: define$2("url-search-params/index", URLSearchParamsDependencies$1),
      WeakMap: define$2("weak-map/index", WeakMapDependencies$1),
      WeakSet: define$2("weak-set/index", WeakSetDependencies$1),
      clearImmediate: define$2("clear-immediate", ["web.immediate"]),
      compositeKey: define$2("composite-key", ["esnext.composite-key"]),
      compositeSymbol: define$2("composite-symbol", ["esnext.composite-symbol"]),
      escape: define$2("escape", ["es.escape"]),
      fetch: define$2(null, PromiseDependencies$2),
      globalThis: define$2("global-this", ["es.global-this"]),
      parseFloat: define$2("parse-float", ["es.parse-float"]),
      parseInt: define$2("parse-int", ["es.parse-int"]),
      queueMicrotask: define$2("queue-microtask", ["web.queue-microtask"]),
      setImmediate: define$2("set-immediate", ["web.immediate"]),
      setInterval: define$2("set-interval", ["web.timers"]),
      setTimeout: define$2("set-timeout", ["web.timers"]),
      structuredClone: define$2("structured-clone", ["web.structured-clone"].concat(DOMExceptionDependencies$1, ["es.array.iterator", "es.object.keys", "es.object.to-string", "es.map", "es.set"])),
      unescape: define$2("unescape", ["es.unescape"])
    };
    var StaticProperties$2 = {
      AsyncIterator: {
        from: define$2("async-iterator/from", ["esnext.async-iterator.from"].concat(_toConsumableArray2(AsyncIteratorDependencies$1), AsyncIteratorProblemMethods$1, _toConsumableArray2(CommonIterators$2)))
      },
      Array: {
        from: define$2("array/from", ["es.array.from", "es.string.iterator"]),
        fromAsync: define$2("array/from-async", ["esnext.array.from-async"].concat(_toConsumableArray2(PromiseDependenciesWithIterators$1))),
        isArray: define$2("array/is-array", ["es.array.is-array"]),
        isTemplateObject: define$2("array/is-template-object", ["esnext.array.is-template-object"]),
        of: define$2("array/of", ["es.array.of"])
      },
      ArrayBuffer: {
        isView: define$2(null, ["es.array-buffer.is-view"])
      },
      BigInt: {
        range: define$2("bigint/range", ["esnext.bigint.range", "es.object.to-string"])
      },
      Date: {
        now: define$2("date/now", ["es.date.now"])
      },
      Function: {
        isCallable: define$2("function/is-callable", ["esnext.function.is-callable"]),
        isConstructor: define$2("function/is-constructor", ["esnext.function.is-constructor"])
      },
      Iterator: {
        from: define$2("iterator/from", ["esnext.iterator.from"].concat(IteratorDependencies$1, _toConsumableArray2(CommonIterators$2)))
      },
      JSON: {
        stringify: define$2("json/stringify", ["es.json.stringify"], "es.symbol")
      },
      Math: {
        DEG_PER_RAD: define$2("math/deg-per-rad", ["esnext.math.deg-per-rad"]),
        RAD_PER_DEG: define$2("math/rad-per-deg", ["esnext.math.rad-per-deg"]),
        acosh: define$2("math/acosh", ["es.math.acosh"]),
        asinh: define$2("math/asinh", ["es.math.asinh"]),
        atanh: define$2("math/atanh", ["es.math.atanh"]),
        cbrt: define$2("math/cbrt", ["es.math.cbrt"]),
        clamp: define$2("math/clamp", ["esnext.math.clamp"]),
        clz32: define$2("math/clz32", ["es.math.clz32"]),
        cosh: define$2("math/cosh", ["es.math.cosh"]),
        degrees: define$2("math/degrees", ["esnext.math.degrees"]),
        expm1: define$2("math/expm1", ["es.math.expm1"]),
        fround: define$2("math/fround", ["es.math.fround"]),
        fscale: define$2("math/fscale", ["esnext.math.fscale"]),
        hypot: define$2("math/hypot", ["es.math.hypot"]),
        iaddh: define$2("math/iaddh", ["esnext.math.iaddh"]),
        imul: define$2("math/imul", ["es.math.imul"]),
        imulh: define$2("math/imulh", ["esnext.math.imulh"]),
        isubh: define$2("math/isubh", ["esnext.math.isubh"]),
        log10: define$2("math/log10", ["es.math.log10"]),
        log1p: define$2("math/log1p", ["es.math.log1p"]),
        log2: define$2("math/log2", ["es.math.log2"]),
        radians: define$2("math/radians", ["esnext.math.radians"]),
        scale: define$2("math/scale", ["esnext.math.scale"]),
        seededPRNG: define$2("math/seeded-prng", ["esnext.math.seeded-prng"]),
        sign: define$2("math/sign", ["es.math.sign"]),
        signbit: define$2("math/signbit", ["esnext.math.signbit"]),
        sinh: define$2("math/sinh", ["es.math.sinh"]),
        tanh: define$2("math/tanh", ["es.math.tanh"]),
        trunc: define$2("math/trunc", ["es.math.trunc"]),
        umulh: define$2("math/umulh", ["esnext.math.umulh"])
      },
      Map: {
        from: define$2(null, ["esnext.map.from"].concat(_toConsumableArray2(MapDependencies$1))),
        groupBy: define$2(null, ["esnext.map.group-by"].concat(_toConsumableArray2(MapDependencies$1))),
        keyBy: define$2(null, ["esnext.map.key-by"].concat(_toConsumableArray2(MapDependencies$1))),
        of: define$2(null, ["esnext.map.of"].concat(_toConsumableArray2(MapDependencies$1)))
      },
      Number: {
        EPSILON: define$2("number/epsilon", ["es.number.epsilon"]),
        MAX_SAFE_INTEGER: define$2("number/max-safe-integer", ["es.number.max-safe-integer"]),
        MIN_SAFE_INTEGER: define$2("number/min-safe-integer", ["es.number.min-safe-integer"]),
        fromString: define$2("number/from-string", ["esnext.number.from-string"]),
        isFinite: define$2("number/is-finite", ["es.number.is-finite"]),
        isInteger: define$2("number/is-integer", ["es.number.is-integer"]),
        isNaN: define$2("number/is-nan", ["es.number.is-nan"]),
        isSafeInteger: define$2("number/is-safe-integer", ["es.number.is-safe-integer"]),
        parseFloat: define$2("number/parse-float", ["es.number.parse-float"]),
        parseInt: define$2("number/parse-int", ["es.number.parse-int"]),
        range: define$2("number/range", ["esnext.number.range", "es.object.to-string"])
      },
      Object: {
        assign: define$2("object/assign", ["es.object.assign"]),
        create: define$2("object/create", ["es.object.create"]),
        defineProperties: define$2("object/define-properties", ["es.object.define-properties"]),
        defineProperty: define$2("object/define-property", ["es.object.define-property"]),
        entries: define$2("object/entries", ["es.object.entries"]),
        freeze: define$2("object/freeze", ["es.object.freeze"]),
        fromEntries: define$2("object/from-entries", ["es.object.from-entries", "es.array.iterator"]),
        getOwnPropertyDescriptor: define$2("object/get-own-property-descriptor", ["es.object.get-own-property-descriptor"]),
        getOwnPropertyDescriptors: define$2("object/get-own-property-descriptors", ["es.object.get-own-property-descriptors"]),
        getOwnPropertyNames: define$2("object/get-own-property-names", ["es.object.get-own-property-names"]),
        getOwnPropertySymbols: define$2("object/get-own-property-symbols", ["es.symbol"]),
        getPrototypeOf: define$2("object/get-prototype-of", ["es.object.get-prototype-of"]),
        hasOwn: define$2("object/has-own", ["es.object.has-own"]),
        is: define$2("object/is", ["es.object.is"]),
        isExtensible: define$2("object/is-extensible", ["es.object.is-extensible"]),
        isFrozen: define$2("object/is-frozen", ["es.object.is-frozen"]),
        isSealed: define$2("object/is-sealed", ["es.object.is-sealed"]),
        keys: define$2("object/keys", ["es.object.keys"]),
        preventExtensions: define$2("object/prevent-extensions", ["es.object.prevent-extensions"]),
        seal: define$2("object/seal", ["es.object.seal"]),
        setPrototypeOf: define$2("object/set-prototype-of", ["es.object.set-prototype-of"]),
        values: define$2("object/values", ["es.object.values"])
      },
      Promise: {
        all: define$2(null, PromiseDependenciesWithIterators$1),
        allSettled: define$2(null, ["es.promise.all-settled"].concat(_toConsumableArray2(PromiseDependenciesWithIterators$1))),
        any: define$2(null, ["es.promise.any", "es.aggregate-error"].concat(_toConsumableArray2(PromiseDependenciesWithIterators$1))),
        race: define$2(null, PromiseDependenciesWithIterators$1),
        "try": define$2(null, ["esnext.promise.try"].concat(_toConsumableArray2(PromiseDependenciesWithIterators$1)))
      },
      Reflect: {
        apply: define$2("reflect/apply", ["es.reflect.apply"]),
        construct: define$2("reflect/construct", ["es.reflect.construct"]),
        defineMetadata: define$2("reflect/define-metadata", ["esnext.reflect.define-metadata"]),
        defineProperty: define$2("reflect/define-property", ["es.reflect.define-property"]),
        deleteMetadata: define$2("reflect/delete-metadata", ["esnext.reflect.delete-metadata"]),
        deleteProperty: define$2("reflect/delete-property", ["es.reflect.delete-property"]),
        get: define$2("reflect/get", ["es.reflect.get"]),
        getMetadata: define$2("reflect/get-metadata", ["esnext.reflect.get-metadata"]),
        getMetadataKeys: define$2("reflect/get-metadata-keys", ["esnext.reflect.get-metadata-keys"]),
        getOwnMetadata: define$2("reflect/get-own-metadata", ["esnext.reflect.get-own-metadata"]),
        getOwnMetadataKeys: define$2("reflect/get-own-metadata-keys", ["esnext.reflect.get-own-metadata-keys"]),
        getOwnPropertyDescriptor: define$2("reflect/get-own-property-descriptor", ["es.reflect.get-own-property-descriptor"]),
        getPrototypeOf: define$2("reflect/get-prototype-of", ["es.reflect.get-prototype-of"]),
        has: define$2("reflect/has", ["es.reflect.has"]),
        hasMetadata: define$2("reflect/has-metadata", ["esnext.reflect.has-metadata"]),
        hasOwnMetadata: define$2("reflect/has-own-metadata", ["esnext.reflect.has-own-metadata"]),
        isExtensible: define$2("reflect/is-extensible", ["es.reflect.is-extensible"]),
        metadata: define$2("reflect/metadata", ["esnext.reflect.metadata"]),
        ownKeys: define$2("reflect/own-keys", ["es.reflect.own-keys"]),
        preventExtensions: define$2("reflect/prevent-extensions", ["es.reflect.prevent-extensions"]),
        set: define$2("reflect/set", ["es.reflect.set"]),
        setPrototypeOf: define$2("reflect/set-prototype-of", ["es.reflect.set-prototype-of"])
      },
      Set: {
        from: define$2(null, ["esnext.set.from"].concat(_toConsumableArray2(SetDependencies$1))),
        of: define$2(null, ["esnext.set.of"].concat(_toConsumableArray2(SetDependencies$1)))
      },
      String: {
        cooked: define$2("string/cooked", ["esnext.string.cooked"]),
        fromCodePoint: define$2("string/from-code-point", ["es.string.from-code-point"]),
        raw: define$2("string/raw", ["es.string.raw"])
      },
      Symbol: {
        asyncDispose: define$2("symbol/async-dispose", ["esnext.symbol.async-dispose"]),
        asyncIterator: define$2("symbol/async-iterator", ["es.symbol.async-iterator"]),
        dispose: define$2("symbol/dispose", ["esnext.symbol.dispose"]),
        "for": define$2("symbol/for", [], "es.symbol"),
        hasInstance: define$2("symbol/has-instance", ["es.symbol.has-instance", "es.function.has-instance"]),
        isConcatSpreadable: define$2("symbol/is-concat-spreadable", ["es.symbol.is-concat-spreadable", "es.array.concat"]),
        iterator: define$2("symbol/iterator", ["es.symbol.iterator"].concat(_toConsumableArray2(CommonIteratorsWithTag$1))),
        keyFor: define$2("symbol/key-for", [], "es.symbol"),
        match: define$2("symbol/match", ["es.symbol.match", "es.string.match"]),
        matcher: define$2("symbol/matcher", ["esnext.symbol.matcher"]),
        matchAll: define$2("symbol/match-all", ["es.symbol.match-all", "es.string.match-all"]),
        metadata: define$2("symbol/metadata", ["esnext.symbol.metadata"]),
        observable: define$2("symbol/observable", ["esnext.symbol.observable"]),
        patternMatch: define$2("symbol/pattern-match", ["esnext.symbol.pattern-match"]),
        replace: define$2("symbol/replace", ["es.symbol.replace", "es.string.replace"]),
        search: define$2("symbol/search", ["es.symbol.search", "es.string.search"]),
        species: define$2("symbol/species", ["es.symbol.species", "es.array.species"]),
        split: define$2("symbol/split", ["es.symbol.split", "es.string.split"]),
        toPrimitive: define$2("symbol/to-primitive", ["es.symbol.to-primitive", "es.date.to-primitive"]),
        toStringTag: define$2("symbol/to-string-tag", ["es.symbol.to-string-tag", "es.object.to-string", "es.math.to-string-tag", "es.json.to-string-tag"]),
        unscopables: define$2("symbol/unscopables", ["es.symbol.unscopables"])
      },
      WeakMap: {
        from: define$2(null, ["esnext.weak-map.from"].concat(_toConsumableArray2(WeakMapDependencies$1))),
        of: define$2(null, ["esnext.weak-map.of"].concat(_toConsumableArray2(WeakMapDependencies$1)))
      },
      WeakSet: {
        from: define$2(null, ["esnext.weak-set.from"].concat(_toConsumableArray2(WeakSetDependencies$1))),
        of: define$2(null, ["esnext.weak-set.of"].concat(_toConsumableArray2(WeakSetDependencies$1)))
      },
      Int8Array: TypedArrayStaticMethods$1,
      Uint8Array: TypedArrayStaticMethods$1,
      Uint8ClampedArray: TypedArrayStaticMethods$1,
      Int16Array: TypedArrayStaticMethods$1,
      Uint16Array: TypedArrayStaticMethods$1,
      Int32Array: TypedArrayStaticMethods$1,
      Uint32Array: TypedArrayStaticMethods$1,
      Float32Array: TypedArrayStaticMethods$1,
      Float64Array: TypedArrayStaticMethods$1,
      WebAssembly: {
        CompileError: define$2(null, ErrorDependencies$1),
        LinkError: define$2(null, ErrorDependencies$1),
        RuntimeError: define$2(null, ErrorDependencies$1)
      }
    };
    var InstanceProperties$2 = {
      asIndexedPairs: define$2("instance/asIndexedPairs", ["esnext.async-iterator.as-indexed-pairs"].concat(_toConsumableArray2(AsyncIteratorDependencies$1), ["esnext.iterator.as-indexed-pairs"], IteratorDependencies$1)),
      at: define$2("instance/at", ["esnext.string.at", "es.string.at-alternative", "es.array.at"]),
      anchor: define$2(null, ["es.string.anchor"]),
      big: define$2(null, ["es.string.big"]),
      bind: define$2("instance/bind", ["es.function.bind"]),
      blink: define$2(null, ["es.string.blink"]),
      bold: define$2(null, ["es.string.bold"]),
      codePointAt: define$2("instance/code-point-at", ["es.string.code-point-at"]),
      codePoints: define$2("instance/code-points", ["esnext.string.code-points"]),
      concat: define$2("instance/concat", ["es.array.concat"], void 0, ["String"]),
      copyWithin: define$2("instance/copy-within", ["es.array.copy-within"]),
      description: define$2(null, ["es.symbol", "es.symbol.description"]),
      dotAll: define$2("instance/dot-all", ["es.regexp.dot-all"]),
      drop: define$2("instance/drop", ["esnext.async-iterator.drop"].concat(_toConsumableArray2(AsyncIteratorDependencies$1), ["esnext.iterator.drop"], IteratorDependencies$1)),
      emplace: define$2("instance/emplace", ["esnext.map.emplace", "esnext.weak-map.emplace"]),
      endsWith: define$2("instance/ends-with", ["es.string.ends-with"]),
      entries: define$2("instance/entries", ArrayNatureIteratorsWithTag$1),
      every: define$2("instance/every", ["es.array.every", "esnext.async-iterator.every", "esnext.iterator.every"].concat(IteratorDependencies$1)),
      exec: define$2(null, ["es.regexp.exec"]),
      fill: define$2("instance/fill", ["es.array.fill"]),
      filter: define$2("instance/filter", ["es.array.filter", "esnext.async-iterator.filter", "esnext.iterator.filter"].concat(IteratorDependencies$1)),
      filterReject: define$2("instance/filterReject", ["esnext.array.filter-reject"]),
      "finally": define$2(null, ["es.promise.finally"].concat(PromiseDependencies$2)),
      find: define$2("instance/find", ["es.array.find", "esnext.async-iterator.find", "esnext.iterator.find"].concat(IteratorDependencies$1)),
      findIndex: define$2("instance/find-index", ["es.array.find-index"]),
      findLast: define$2("instance/find-last", ["esnext.array.find-last"]),
      findLastIndex: define$2("instance/find-last-index", ["esnext.array.find-last-index"]),
      fixed: define$2(null, ["es.string.fixed"]),
      flags: define$2("instance/flags", ["es.regexp.flags"]),
      flatMap: define$2("instance/flat-map", ["es.array.flat-map", "es.array.unscopables.flat-map", "esnext.async-iterator.flat-map", "esnext.iterator.flat-map"].concat(IteratorDependencies$1)),
      flat: define$2("instance/flat", ["es.array.flat", "es.array.unscopables.flat"]),
      getYear: define$2(null, ["es.date.get-year"]),
      groupBy: define$2("instance/group-by", ["esnext.array.group-by"]),
      groupByToMap: define$2("instance/group-by-to-map", ["esnext.array.group-by-to-map", "es.map", "es.object.to-string"]),
      fontcolor: define$2(null, ["es.string.fontcolor"]),
      fontsize: define$2(null, ["es.string.fontsize"]),
      forEach: define$2("instance/for-each", ["es.array.for-each", "esnext.async-iterator.for-each", "esnext.iterator.for-each"].concat(IteratorDependencies$1, ["web.dom-collections.for-each"])),
      includes: define$2("instance/includes", ["es.array.includes", "es.string.includes"]),
      indexOf: define$2("instance/index-of", ["es.array.index-of"]),
      italic: define$2(null, ["es.string.italics"]),
      join: define$2(null, ["es.array.join"]),
      keys: define$2("instance/keys", ArrayNatureIteratorsWithTag$1),
      lastIndex: define$2(null, ["esnext.array.last-index"]),
      lastIndexOf: define$2("instance/last-index-of", ["es.array.last-index-of"]),
      lastItem: define$2(null, ["esnext.array.last-item"]),
      link: define$2(null, ["es.string.link"]),
      map: define$2("instance/map", ["es.array.map", "esnext.async-iterator.map", "esnext.iterator.map"]),
      match: define$2(null, ["es.string.match", "es.regexp.exec"]),
      matchAll: define$2("instance/match-all", ["es.string.match-all", "es.regexp.exec"]),
      name: define$2(null, ["es.function.name"]),
      padEnd: define$2("instance/pad-end", ["es.string.pad-end"]),
      padStart: define$2("instance/pad-start", ["es.string.pad-start"]),
      reduce: define$2("instance/reduce", ["es.array.reduce", "esnext.async-iterator.reduce", "esnext.iterator.reduce"].concat(IteratorDependencies$1)),
      reduceRight: define$2("instance/reduce-right", ["es.array.reduce-right"]),
      repeat: define$2("instance/repeat", ["es.string.repeat"]),
      replace: define$2(null, ["es.string.replace", "es.regexp.exec"]),
      replaceAll: define$2("instance/replace-all", ["es.string.replace-all", "es.string.replace", "es.regexp.exec"]),
      reverse: define$2("instance/reverse", ["es.array.reverse"]),
      search: define$2(null, ["es.string.search", "es.regexp.exec"]),
      setYear: define$2(null, ["es.date.set-year"]),
      slice: define$2("instance/slice", ["es.array.slice"]),
      small: define$2(null, ["es.string.small"]),
      some: define$2("instance/some", ["es.array.some", "esnext.async-iterator.some", "esnext.iterator.some"].concat(IteratorDependencies$1)),
      sort: define$2("instance/sort", ["es.array.sort"]),
      splice: define$2("instance/splice", ["es.array.splice"]),
      split: define$2(null, ["es.string.split", "es.regexp.exec"]),
      startsWith: define$2("instance/starts-with", ["es.string.starts-with"]),
      sticky: define$2("instance/sticky", ["es.regexp.sticky"]),
      strike: define$2(null, ["es.string.strike"]),
      sub: define$2(null, ["es.string.sub"]),
      substr: define$2(null, ["es.string.substr"]),
      sup: define$2(null, ["es.string.sup"]),
      take: define$2("instance/take", ["esnext.async-iterator.take"].concat(_toConsumableArray2(AsyncIteratorDependencies$1), ["esnext.iterator.take"], IteratorDependencies$1)),
      test: define$2("instance/test", ["es.regexp.test", "es.regexp.exec"]),
      toArray: define$2("instance/to-array", ["esnext.async-iterator.to-array"].concat(_toConsumableArray2(AsyncIteratorDependencies$1), ["esnext.iterator.to-array"], IteratorDependencies$1)),
      toAsync: define$2(null, ["esnext.iterator.to-async"].concat(IteratorDependencies$1, _toConsumableArray2(AsyncIteratorDependencies$1), AsyncIteratorProblemMethods$1)),
      toExponential: define$2(null, ["es.number.to-exponential"]),
      toFixed: define$2(null, ["es.number.to-fixed"]),
      toGMTString: define$2(null, ["es.date.to-gmt-string"]),
      toISOString: define$2(null, ["es.date.to-iso-string"]),
      toJSON: define$2(null, ["es.date.to-json", "web.url.to-json"]),
      toPrecision: define$2(null, ["es.number.to-precision"]),
      toReversed: define$2("instance/to-reversed", ["esnext.array.to-reversed"]),
      toSorted: define$2("instance/to-sorted", ["esnext.array.to-sorted", "es.array.sort"]),
      toSpliced: define$2("instance/to-reversed", ["esnext.array.to-spliced"]),
      toString: define$2(null, ["es.object.to-string", "es.error.to-string", "es.date.to-string", "es.regexp.to-string"]),
      trim: define$2("instance/trim", ["es.string.trim"]),
      trimEnd: define$2("instance/trim-end", ["es.string.trim-end"]),
      trimLeft: define$2("instance/trim-left", ["es.string.trim-start"]),
      trimRight: define$2("instance/trim-right", ["es.string.trim-end"]),
      trimStart: define$2("instance/trim-start", ["es.string.trim-start"]),
      uniqueBy: define$2("instance/unique-by", ["esnext.array.unique-by", "es.map"]),
      unThis: define$2("instance/un-this", ["esnext.function.un-this"]),
      values: define$2("instance/values", ArrayNatureIteratorsWithTag$1),
      "with": define$2("instance/with", ["esnext.array.with"]),
      __defineGetter__: define$2(null, ["es.object.define-getter"]),
      __defineSetter__: define$2(null, ["es.object.define-setter"]),
      __lookupGetter__: define$2(null, ["es.object.lookup-getter"]),
      __lookupSetter__: define$2(null, ["es.object.lookup-setter"])
    };
    var CommonInstanceDependencies$1 = /* @__PURE__ */ new Set(["es.object.to-string", "es.object.define-getter", "es.object.define-setter", "es.object.lookup-getter", "es.object.lookup-setter", "es.regexp.exec"]);
    var _ref$3 = babel2, t$1$2 = _ref$3.types;
    function callMethod$1(path2, id3) {
      var object4 = path2.node.object;
      var context1, context2;
      if (t$1$2.isIdentifier(object4)) {
        context1 = object4;
        context2 = t$1$2.cloneNode(object4);
      } else {
        context1 = path2.scope.generateDeclaredUidIdentifier("context");
        context2 = t$1$2.assignmentExpression("=", t$1$2.cloneNode(context1), object4);
      }
      path2.replaceWith(t$1$2.memberExpression(t$1$2.callExpression(id3, [context2]), t$1$2.identifier("call")));
      path2.parentPath.unshiftContainer("arguments", context1);
    }
    function isCoreJSSource$1(source) {
      if (typeof source === "string") {
        source = source.replace(/\\/g, "/").replace(/(\/(index)?)?(\.js)?$/i, "").toLowerCase();
      }
      return hasOwnProperty.call(entries$1, source) && entries$1[source];
    }
    function coreJSModule$1(name2) {
      return "core-js/modules/" + name2 + ".js";
    }
    function coreJSPureHelper$1(name2, useBabelRuntime, ext) {
      return useBabelRuntime ? useBabelRuntime + "/core-js/" + name2 + ext : "core-js-pure/features/" + name2 + ".js";
    }
    var _ref2$1 = babel2, t$4 = _ref2$1.types;
    var runtimeCompat$4 = "#__secret_key__@babel/runtime__compatibility";
    var esnextFallback$1 = function esnextFallback2(name2, cb2) {
      if (cb2(name2))
        return true;
      if (!name2.startsWith("es."))
        return false;
      var fallback = "esnext." + name2.slice(3);
      if (!data$1[fallback])
        return false;
      return cb2(fallback);
    };
    var index$42 = definePolyfillProvider$1(function(_ref3, _ref42) {
      var getUtils = _ref3.getUtils, method5 = _ref3.method, shouldInjectPolyfill = _ref3.shouldInjectPolyfill, createMetaResolver2 = _ref3.createMetaResolver, debug2 = _ref3.debug, babel3 = _ref3.babel;
      var _ref4$version = _ref42.version, version3 = _ref4$version === void 0 ? 3 : _ref4$version, proposals = _ref42.proposals, shippedProposals2 = _ref42.shippedProposals, _ref4$runtimeCompat = _ref42[runtimeCompat$4];
      _ref4$runtimeCompat = _ref4$runtimeCompat === void 0 ? {} : _ref4$runtimeCompat;
      var useBabelRuntime = _ref4$runtimeCompat.useBabelRuntime, _ref4$runtimeCompat$e = _ref4$runtimeCompat.ext, ext = _ref4$runtimeCompat$e === void 0 ? ".js" : _ref4$runtimeCompat$e;
      var isWebpack = babel3.caller(function(caller) {
        return (caller == null ? void 0 : caller.name) === "babel-loader";
      });
      var resolve2 = createMetaResolver2({
        global: BuiltIns$2,
        "static": StaticProperties$2,
        instance: InstanceProperties$2
      });
      var available = new Set(getModulesListForTargetVersion$1(version3));
      function getCoreJSPureBase(useProposalBase) {
        return useBabelRuntime ? useProposalBase ? useBabelRuntime + "/core-js" : useBabelRuntime + "/core-js-stable" : useProposalBase ? "core-js-pure/features" : "core-js-pure/stable";
      }
      function maybeInjectGlobalImpl(name2, utils3) {
        if (shouldInjectPolyfill(name2)) {
          debug2(name2);
          utils3.injectGlobalImport(coreJSModule$1(name2));
          return true;
        }
        return false;
      }
      function maybeInjectGlobal(names2, utils3, fallback) {
        if (fallback === void 0) {
          fallback = true;
        }
        for (var _iterator2 = _createForOfIteratorHelperLoose(names2), _step2; !(_step2 = _iterator2()).done; ) {
          var name2 = _step2.value;
          if (fallback) {
            esnextFallback$1(name2, function(name3) {
              return maybeInjectGlobalImpl(name3, utils3);
            });
          } else {
            maybeInjectGlobalImpl(name2, utils3);
          }
        }
      }
      function maybeInjectPure(desc, hint, utils3, object4) {
        if (desc.pure && !(object4 && desc.exclude && desc.exclude.includes(object4)) && esnextFallback$1(desc.name, shouldInjectPolyfill)) {
          var name2 = desc.name;
          var useProposalBase = false;
          if (proposals || shippedProposals2 && name2.startsWith("esnext.")) {
            useProposalBase = true;
          } else if (name2.startsWith("es.") && !available.has(name2)) {
            useProposalBase = true;
          }
          var coreJSPureBase = getCoreJSPureBase(useProposalBase);
          return utils3.injectDefaultImport(coreJSPureBase + "/" + desc.pure + ext, hint);
        }
      }
      function isFeatureStable(name2) {
        if (name2.startsWith("esnext.")) {
          var esName = "es." + name2.slice(7);
          return esName in data$1;
        }
        return true;
      }
      return {
        name: "corejs3",
        polyfills: data$1,
        filterPolyfills: function filterPolyfills(name2) {
          if (!available.has(name2))
            return false;
          if (proposals || method5 === "entry-global")
            return true;
          if (shippedProposals2 && corejs3ShippedProposalsList$1.has(name2)) {
            return true;
          }
          return isFeatureStable(name2);
        },
        entryGlobal: function entryGlobal(meta2, utils3, path2) {
          if (meta2.kind !== "import")
            return;
          var modules2 = isCoreJSSource$1(meta2.source);
          if (!modules2)
            return;
          if (modules2.length === 1 && meta2.source === coreJSModule$1(modules2[0]) && shouldInjectPolyfill(modules2[0])) {
            debug2(null);
            return;
          }
          maybeInjectGlobal(modules2, utils3, false);
          path2.remove();
        },
        usageGlobal: function usageGlobal(meta2, utils3) {
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var deps = resolved.desc.global;
          if (resolved.kind !== "global" && meta2.object && meta2.placement === "prototype") {
            var low = meta2.object.toLowerCase();
            deps = deps.filter(function(m2) {
              return m2.includes(low) || CommonInstanceDependencies$1.has(m2);
            });
          }
          maybeInjectGlobal(deps, utils3);
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (meta2.kind === "in") {
            if (meta2.key === "Symbol.iterator") {
              path2.replaceWith(t$4.callExpression(utils3.injectDefaultImport(coreJSPureHelper$1("is-iterable", useBabelRuntime, ext), "isIterable"), [path2.node.right]));
            }
            return;
          }
          if (path2.parentPath.isUnaryExpression({
            operator: "delete"
          }))
            return;
          var isCall;
          if (meta2.kind === "property") {
            if (!path2.isMemberExpression())
              return;
            if (!path2.isReferenced())
              return;
            isCall = path2.parentPath.isCallExpression({
              callee: path2.node
            });
            if (meta2.key === "Symbol.iterator") {
              if (!shouldInjectPolyfill("es.symbol.iterator"))
                return;
              if (isCall) {
                if (path2.parent.arguments.length === 0) {
                  path2.parentPath.replaceWith(t$4.callExpression(utils3.injectDefaultImport(coreJSPureHelper$1("get-iterator", useBabelRuntime, ext), "getIterator"), [path2.node.object]));
                  path2.skip();
                } else {
                  callMethod$1(path2, utils3.injectDefaultImport(coreJSPureHelper$1("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"));
                }
              } else {
                path2.replaceWith(t$4.callExpression(utils3.injectDefaultImport(coreJSPureHelper$1("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"), [path2.node.object]));
              }
              return;
            }
          }
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          if (useBabelRuntime && resolved.desc.pure && resolved.desc.pure.slice(-6) === "/index") {
            resolved = Object.assign(Object.assign({}, resolved), {}, {
              desc: Object.assign(Object.assign({}, resolved.desc), {}, {
                pure: resolved.desc.pure.slice(0, -6)
              })
            });
          }
          if (resolved.kind === "global") {
            var id3 = maybeInjectPure(resolved.desc, resolved.name, utils3);
            if (id3)
              path2.replaceWith(id3);
          } else if (resolved.kind === "static") {
            var _id = maybeInjectPure(resolved.desc, resolved.name, utils3, meta2.object);
            if (_id)
              path2.replaceWith(_id);
          } else if (resolved.kind === "instance") {
            var _id2 = maybeInjectPure(resolved.desc, resolved.name + "InstanceProperty", utils3, meta2.object);
            if (!_id2)
              return;
            if (isCall) {
              callMethod$1(path2, _id2);
            } else {
              path2.replaceWith(t$4.callExpression(_id2, [path2.node.object]));
            }
          }
        },
        visitor: method5 === "usage-global" && {
          CallExpression: function CallExpression2(path2) {
            if (path2.get("callee").isImport()) {
              var utils3 = getUtils(path2);
              if (isWebpack) {
                maybeInjectGlobal(PromiseDependenciesWithIterators$1, utils3);
              } else {
                maybeInjectGlobal(PromiseDependencies$2, utils3);
              }
            }
          },
          Function: function Function2(path2) {
            if (path2.node.async) {
              maybeInjectGlobal(PromiseDependencies$2, getUtils(path2));
            }
          },
          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path2) {
            maybeInjectGlobal(CommonIterators$2, getUtils(path2));
          },
          SpreadElement: function SpreadElement(path2) {
            if (!path2.parentPath.isObjectExpression()) {
              maybeInjectGlobal(CommonIterators$2, getUtils(path2));
            }
          },
          YieldExpression: function YieldExpression2(path2) {
            if (path2.node.delegate) {
              maybeInjectGlobal(CommonIterators$2, getUtils(path2));
            }
          }
        }
      };
    });
    var runtimeCompat$3 = "#__secret_key__@babel/runtime__compatibility";
    var index$32 = definePolyfillProvider$1(function(_ref3, options) {
      var debug2 = _ref3.debug;
      var _options$runtimeCompa = options[runtimeCompat$3];
      _options$runtimeCompa = _options$runtimeCompa === void 0 ? {} : _options$runtimeCompa;
      var useBabelRuntime = _options$runtimeCompa.useBabelRuntime;
      var pureName = useBabelRuntime ? useBabelRuntime + "/regenerator" : "regenerator-runtime";
      return {
        name: "regenerator",
        polyfills: ["regenerator-runtime"],
        usageGlobal: function usageGlobal(meta2, utils3) {
          if (isRegenerator$1(meta2)) {
            debug2("regenerator-runtime");
            utils3.injectGlobalImport("regenerator-runtime/runtime.js");
          }
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (isRegenerator$1(meta2)) {
            path2.replaceWith(utils3.injectDefaultImport(pureName, "regenerator-runtime"));
          }
        }
      };
    });
    var isRegenerator$1 = function isRegenerator2(meta2) {
      return meta2.kind === "global" && meta2.name === "regeneratorRuntime";
    };
    var pluginCorejs2 = index$52["default"] || index$52;
    var pluginCorejs3 = index$42["default"] || index$42;
    var pluginRegenerator$1 = index$32["default"] || index$32;
    var pluginsCompat = "#__secret_key__@babel/runtime__compatibility";
    function supportsStaticESM$1(caller) {
      return !!(caller != null && caller.supportsStaticESM);
    }
    var transformRuntime = declare(function(api, options, dirname2) {
      var _createCorejsPlgin, _createRegeneratorPlu, _createCorejsPlgin2, _createRegeneratorPlu2, _createRegeneratorPlu3;
      api.assertVersion(7);
      var corejs = options.corejs, _options$helpers = options.helpers, useRuntimeHelpers = _options$helpers === void 0 ? true : _options$helpers, _options$regenerator = options.regenerator, useRuntimeRegenerator = _options$regenerator === void 0 ? true : _options$regenerator, _options$useESModules = options.useESModules, useESModules = _options$useESModules === void 0 ? false : _options$useESModules, _options$version = options.version, runtimeVersion = _options$version === void 0 ? "7.0.0-beta.0" : _options$version, _options$absoluteRunt = options.absoluteRuntime, absoluteRuntime = _options$absoluteRunt === void 0 ? false : _options$absoluteRunt;
      var proposals = false;
      var rawVersion;
      if (typeof corejs === "object" && corejs !== null) {
        rawVersion = corejs.version;
        proposals = Boolean(corejs.proposals);
      } else {
        rawVersion = corejs;
      }
      var corejsVersion = rawVersion ? Number(rawVersion) : false;
      if (![false, 2, 3].includes(corejsVersion)) {
        throw new Error("The `core-js` version must be false, 2 or 3, but got " + JSON.stringify(rawVersion) + ".");
      }
      if (proposals && (!corejsVersion || corejsVersion < 3)) {
        throw new Error("The 'proposals' option is only supported when using 'corejs: 3'");
      }
      if (typeof useRuntimeRegenerator !== "boolean") {
        throw new Error("The 'regenerator' option must be undefined, or a boolean.");
      }
      if (typeof useRuntimeHelpers !== "boolean") {
        throw new Error("The 'helpers' option must be undefined, or a boolean.");
      }
      if (typeof useESModules !== "boolean" && useESModules !== "auto") {
        throw new Error("The 'useESModules' option must be undefined, or a boolean, or 'auto'.");
      }
      if (typeof absoluteRuntime !== "boolean" && typeof absoluteRuntime !== "string") {
        throw new Error("The 'absoluteRuntime' option must be undefined, a boolean, or a string.");
      }
      if (typeof runtimeVersion !== "string") {
        throw new Error("The 'version' option must be a version string.");
      }
      {
        var DUAL_MODE_RUNTIME = "7.13.0";
        var supportsCJSDefault = hasMinVersion$2(DUAL_MODE_RUNTIME, runtimeVersion);
      }
      function has3(obj, key2) {
        return Object.prototype.hasOwnProperty.call(obj, key2);
      }
      if (has3(options, "useBuiltIns")) {
        if (options.useBuiltIns) {
          throw new Error("The 'useBuiltIns' option has been removed. The @babel/runtime module now uses builtins by default.");
        } else {
          throw new Error("The 'useBuiltIns' option has been removed. Use the 'corejs'option to polyfill with `core-js` via @babel/runtime.");
        }
      }
      if (has3(options, "polyfill")) {
        if (options.polyfill === false) {
          throw new Error("The 'polyfill' option has been removed. The @babel/runtime module now skips polyfilling by default.");
        } else {
          throw new Error("The 'polyfill' option has been removed. Use the 'corejs'option to polyfill with `core-js` via @babel/runtime.");
        }
      }
      if (has3(options, "moduleName")) {
        throw new Error("The 'moduleName' option has been removed. @babel/transform-runtime no longer supports arbitrary runtimes. If you were using this to set an absolute path for Babel's standard runtimes, please use the 'absoluteRuntime' option.");
      }
      var esModules = useESModules === "auto" ? api.caller(supportsStaticESM$1) : useESModules;
      var injectCoreJS2 = corejsVersion === 2;
      var injectCoreJS3 = corejsVersion === 3;
      var moduleName = injectCoreJS3 ? "@babel/runtime-corejs3" : injectCoreJS2 ? "@babel/runtime-corejs2" : "@babel/runtime";
      var HEADER_HELPERS = ["interopRequireWildcard", "interopRequireDefault"];
      var modulePath = getRuntimePath(moduleName, dirname2, absoluteRuntime);
      function createCorejsPlgin(plugin2, options2, regeneratorPlugin) {
        return function(api2, _, filename) {
          return Object.assign({}, plugin2(api2, options2, filename), {
            inherits: regeneratorPlugin
          });
        };
      }
      function createRegeneratorPlugin(options2) {
        if (!useRuntimeRegenerator)
          return void 0;
        return function(api2, _, filename) {
          return pluginRegenerator$1(api2, options2, filename);
        };
      }
      return {
        name: "transform-runtime",
        inherits: injectCoreJS2 ? createCorejsPlgin(pluginCorejs2, (_createCorejsPlgin = {
          method: "usage-pure",
          absoluteImports: absoluteRuntime ? modulePath : false
        }, _createCorejsPlgin[pluginsCompat] = {
          runtimeVersion,
          useBabelRuntime: modulePath,
          ext: ""
        }, _createCorejsPlgin), createRegeneratorPlugin((_createRegeneratorPlu = {
          method: "usage-pure",
          absoluteImports: absoluteRuntime ? modulePath : false
        }, _createRegeneratorPlu[pluginsCompat] = {
          useBabelRuntime: modulePath
        }, _createRegeneratorPlu))) : injectCoreJS3 ? createCorejsPlgin(pluginCorejs3, (_createCorejsPlgin2 = {
          method: "usage-pure",
          version: 3,
          proposals,
          absoluteImports: absoluteRuntime ? modulePath : false
        }, _createCorejsPlgin2[pluginsCompat] = {
          useBabelRuntime: modulePath,
          ext: ""
        }, _createCorejsPlgin2), createRegeneratorPlugin((_createRegeneratorPlu2 = {
          method: "usage-pure",
          absoluteImports: absoluteRuntime ? modulePath : false
        }, _createRegeneratorPlu2[pluginsCompat] = {
          useBabelRuntime: modulePath
        }, _createRegeneratorPlu2))) : createRegeneratorPlugin((_createRegeneratorPlu3 = {
          method: "usage-pure",
          absoluteImports: absoluteRuntime ? modulePath : false
        }, _createRegeneratorPlu3[pluginsCompat] = {
          useBabelRuntime: modulePath
        }, _createRegeneratorPlu3)),
        pre: function pre(file2) {
          if (!useRuntimeHelpers)
            return;
          file2.set("helperGenerator", function(name2) {
            if (file2.availableHelper && !file2.availableHelper(name2, runtimeVersion)) {
              return;
            }
            var isInteropHelper = HEADER_HELPERS.indexOf(name2) !== -1;
            var blockHoist = isInteropHelper && !isModule(file2.path) ? 4 : void 0;
            var helpersDir = esModules && file2.path.node.sourceType === "module" ? "helpers/esm" : "helpers";
            var helperPath = modulePath + "/" + helpersDir + "/" + name2;
            if (absoluteRuntime)
              helperPath = resolveFSPath();
            return addDefaultImport(helperPath, name2, blockHoist, true);
          });
          var cache2 = /* @__PURE__ */ new Map();
          function addDefaultImport(source, nameHint, blockHoist, isHelper2) {
            if (isHelper2 === void 0) {
              isHelper2 = false;
            }
            var cacheKey = isModule(file2.path);
            var key2 = source + ":" + nameHint + ":" + (cacheKey || "");
            var cached2 = cache2.get(key2);
            if (cached2) {
              cached2 = cloneNode$i(cached2);
            } else {
              cached2 = addDefault(file2.path, source, {
                importedInterop: isHelper2 && supportsCJSDefault ? "compiled" : "uncompiled",
                nameHint,
                blockHoist
              });
              cache2.set(key2, cached2);
            }
            return cached2;
          }
        }
      };
    });
    var _transformShorthandProperties = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-shorthand-properties",
        visitor: {
          ObjectMethod: function ObjectMethod2(path2) {
            var node2 = path2.node;
            if (node2.kind === "method") {
              var func = functionExpression$3(null, node2.params, node2.body, node2.generator, node2.async);
              func.returnType = node2.returnType;
              var computedKey = toComputedKey$3(node2);
              if (isStringLiteral$7(computedKey, {
                value: "__proto__"
              })) {
                path2.replaceWith(objectProperty$2(computedKey, func, true));
              } else {
                path2.replaceWith(objectProperty$2(node2.key, func, node2.computed));
              }
            }
          },
          ObjectProperty: function ObjectProperty2(path2) {
            var node2 = path2.node;
            if (node2.shorthand) {
              var computedKey = toComputedKey$3(node2);
              if (isStringLiteral$7(computedKey, {
                value: "__proto__"
              })) {
                path2.replaceWith(objectProperty$2(computedKey, node2.value, true));
              } else {
                node2.shorthand = false;
              }
            }
          }
        }
      };
    });
    var _transformSpread = declare(function(api, options) {
      var _api$assumption, _options$allowArrayLi;
      api.assertVersion(7);
      var iterableIsArray = (_api$assumption = api.assumption("iterableIsArray")) != null ? _api$assumption : options.loose;
      var arrayLikeIsIterable = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable");
      function getSpreadLiteral(spread, scope2) {
        if (iterableIsArray && !isIdentifier$i(spread.argument, {
          name: "arguments"
        })) {
          return spread.argument;
        } else {
          return scope2.toArray(spread.argument, true, arrayLikeIsIterable);
        }
      }
      function hasHole(spread) {
        return spread.elements.some(function(el) {
          return el === null;
        });
      }
      function hasSpread(nodes2) {
        for (var i2 = 0; i2 < nodes2.length; i2++) {
          if (isSpreadElement$1(nodes2[i2])) {
            return true;
          }
        }
        return false;
      }
      function push3(_props, nodes2) {
        if (!_props.length)
          return _props;
        nodes2.push(arrayExpression$2(_props));
        return [];
      }
      function build2(props, scope2, file2) {
        var nodes2 = [];
        var _props = [];
        for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done; ) {
          var prop2 = _step2.value;
          if (isSpreadElement$1(prop2)) {
            _props = push3(_props, nodes2);
            var spreadLiteral = getSpreadLiteral(prop2, scope2);
            if (isArrayExpression$2(spreadLiteral) && hasHole(spreadLiteral)) {
              spreadLiteral = callExpression$e(file2.addHelper("arrayWithoutHoles"), [spreadLiteral]);
            }
            nodes2.push(spreadLiteral);
          } else {
            _props.push(prop2);
          }
        }
        push3(_props, nodes2);
        return nodes2;
      }
      return {
        name: "transform-spread",
        visitor: {
          ArrayExpression: function(_ArrayExpression) {
            function ArrayExpression2(_x) {
              return _ArrayExpression.apply(this, arguments);
            }
            ArrayExpression2.toString = function() {
              return _ArrayExpression.toString();
            };
            return ArrayExpression2;
          }(function(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var elements = node2.elements;
            if (!hasSpread(elements))
              return;
            var nodes2 = build2(elements, scope2, this);
            var first = nodes2[0];
            if (nodes2.length === 1 && first !== elements[0].argument) {
              path2.replaceWith(first);
              return;
            }
            if (!isArrayExpression$2(first)) {
              first = arrayExpression$2([]);
            } else {
              nodes2.shift();
            }
            path2.replaceWith(callExpression$e(memberExpression$b(first, identifier$j("concat")), nodes2));
          }),
          CallExpression: function(_CallExpression) {
            function CallExpression2(_x2) {
              return _CallExpression.apply(this, arguments);
            }
            CallExpression2.toString = function() {
              return _CallExpression.toString();
            };
            return CallExpression2;
          }(function(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            var args = node2.arguments;
            if (!hasSpread(args))
              return;
            var calleePath = skipTransparentExprWrappers(path2.get("callee"));
            if (calleePath.isSuper()) {
              throw path2.buildCodeFrameError("It's not possible to compile spread arguments in `super()` without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
            }
            var contextLiteral = scope2.buildUndefinedNode();
            node2.arguments = [];
            var nodes2;
            if (args.length === 1 && isIdentifier$i(args[0].argument, {
              name: "arguments"
            })) {
              nodes2 = [args[0].argument];
            } else {
              nodes2 = build2(args, scope2, this);
            }
            var first = nodes2.shift();
            if (nodes2.length) {
              node2.arguments.push(callExpression$e(memberExpression$b(first, identifier$j("concat")), nodes2));
            } else {
              node2.arguments.push(first);
            }
            var callee = calleePath.node;
            if (isMemberExpression$8(callee)) {
              var temp = scope2.maybeGenerateMemoised(callee.object);
              if (temp) {
                callee.object = assignmentExpression$c("=", temp, callee.object);
                contextLiteral = temp;
              } else {
                contextLiteral = cloneNode$i(callee.object);
              }
            }
            node2.callee = memberExpression$b(node2.callee, identifier$j("apply"));
            if (isSuper$3(contextLiteral)) {
              contextLiteral = thisExpression$4();
            }
            node2.arguments.unshift(cloneNode$i(contextLiteral));
          }),
          NewExpression: function(_NewExpression) {
            function NewExpression2(_x3) {
              return _NewExpression.apply(this, arguments);
            }
            NewExpression2.toString = function() {
              return _NewExpression.toString();
            };
            return NewExpression2;
          }(function(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            if (!hasSpread(node2.arguments))
              return;
            var nodes2 = build2(node2.arguments, scope2, this);
            var first = nodes2.shift();
            var args;
            if (nodes2.length) {
              args = callExpression$e(memberExpression$b(first, identifier$j("concat")), nodes2);
            } else {
              args = first;
            }
            path2.replaceWith(callExpression$e(path2.hub.addHelper("construct"), [node2.callee, args]));
          })
        }
      };
    });
    var _transformStickyRegex = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-sticky-regex",
        visitor: {
          RegExpLiteral: function RegExpLiteral2(path2) {
            var node2 = path2.node;
            if (!node2.flags.includes("y"))
              return;
            path2.replaceWith(newExpression(identifier$j("RegExp"), [stringLiteral$8(node2.pattern), stringLiteral$8(node2.flags)]));
          }
        }
      };
    });
    var transformStrictMode = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-strict-mode",
        visitor: {
          Program: function Program2(path2) {
            var node2 = path2.node;
            for (var _iterator2 = _createForOfIteratorHelperLoose(node2.directives), _step2; !(_step2 = _iterator2()).done; ) {
              var directive2 = _step2.value;
              if (directive2.value.value === "use strict")
                return;
            }
            path2.unshiftContainer("directives", directive$1(directiveLiteral$1("use strict")));
          }
        }
      };
    });
    var _templateObject$4;
    var _transformTemplateLiterals = declare(function(api, options) {
      var _api$assumption, _api$assumption2;
      api.assertVersion(7);
      var ignoreToPrimitiveHint = (_api$assumption = api.assumption("ignoreToPrimitiveHint")) != null ? _api$assumption : options.loose;
      var mutableTemplateObject = (_api$assumption2 = api.assumption("mutableTemplateObject")) != null ? _api$assumption2 : options.loose;
      var helperName = "taggedTemplateLiteral";
      if (mutableTemplateObject)
        helperName += "Loose";
      function buildConcatCallExpressions(items) {
        var avail = true;
        return items.reduce(function(left, right) {
          var canBeInserted = isLiteral$7(right);
          if (!canBeInserted && avail) {
            canBeInserted = true;
            avail = false;
          }
          if (canBeInserted && isCallExpression$7(left)) {
            left.arguments.push(right);
            return left;
          }
          return callExpression$e(memberExpression$b(left, identifier$j("concat")), [right]);
        });
      }
      return {
        name: "transform-template-literals",
        visitor: {
          TaggedTemplateExpression: function TaggedTemplateExpression2(path2) {
            var node2 = path2.node;
            var quasi = node2.quasi;
            var strings = [];
            var raws = [];
            var isStringsRawEqual = true;
            for (var _iterator2 = _createForOfIteratorHelperLoose(quasi.quasis), _step2; !(_step2 = _iterator2()).done; ) {
              var elem = _step2.value;
              var _elem$value = elem.value, raw = _elem$value.raw, cooked = _elem$value.cooked;
              var value = cooked == null ? path2.scope.buildUndefinedNode() : stringLiteral$8(cooked);
              strings.push(value);
              raws.push(stringLiteral$8(raw));
              if (raw !== cooked) {
                isStringsRawEqual = false;
              }
            }
            var helperArgs = [arrayExpression$2(strings)];
            if (!isStringsRawEqual) {
              helperArgs.push(arrayExpression$2(raws));
            }
            var tmp = path2.scope.generateUidIdentifier("templateObject");
            path2.scope.getProgramParent().push({
              id: cloneNode$i(tmp)
            });
            path2.replaceWith(callExpression$e(node2.tag, [template$2.expression.ast(_templateObject$4 || (_templateObject$4 = _taggedTemplateLiteralLoose(["\n              ", " || (\n                ", " = ", "(", ")\n              )\n            "])), cloneNode$i(tmp), tmp, this.addHelper(helperName), helperArgs)].concat(_toConsumableArray2(quasi.expressions))));
          },
          TemplateLiteral: function TemplateLiteral2(path2) {
            var nodes2 = [];
            var expressions = path2.get("expressions");
            var index3 = 0;
            for (var _iterator2 = _createForOfIteratorHelperLoose(path2.node.quasis), _step2; !(_step2 = _iterator2()).done; ) {
              var elem = _step2.value;
              if (elem.value.cooked) {
                nodes2.push(stringLiteral$8(elem.value.cooked));
              }
              if (index3 < expressions.length) {
                var expr = expressions[index3++];
                var node2 = expr.node;
                if (!isStringLiteral$7(node2, {
                  value: ""
                })) {
                  nodes2.push(node2);
                }
              }
            }
            if (!isStringLiteral$7(nodes2[0]) && !(ignoreToPrimitiveHint && isStringLiteral$7(nodes2[1]))) {
              nodes2.unshift(stringLiteral$8(""));
            }
            var root2 = nodes2[0];
            if (ignoreToPrimitiveHint) {
              for (var i2 = 1; i2 < nodes2.length; i2++) {
                root2 = binaryExpression$4("+", root2, nodes2[i2]);
              }
            } else if (nodes2.length > 1) {
              root2 = buildConcatCallExpressions(nodes2);
            }
            path2.replaceWith(root2);
          }
        }
      };
    });
    var _transformTypeofSymbol = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-typeof-symbol",
        visitor: {
          Scope: function Scope4(_ref3) {
            var scope2 = _ref3.scope;
            if (!scope2.getBinding("Symbol")) {
              return;
            }
            scope2.rename("Symbol");
          },
          UnaryExpression: function UnaryExpression2(path2) {
            var node2 = path2.node, parent = path2.parent;
            if (node2.operator !== "typeof")
              return;
            if (path2.parentPath.isBinaryExpression() && EQUALITY_BINARY_OPERATORS.indexOf(parent.operator) >= 0) {
              var opposite = path2.getOpposite();
              if (opposite.isLiteral() && opposite.node.value !== "symbol" && opposite.node.value !== "object") {
                return;
              }
            }
            var isUnderHelper = path2.findParent(function(path3) {
              if (path3.isFunction()) {
                var _path$get;
                return ((_path$get = path3.get("body.directives.0")) == null ? void 0 : _path$get.node.value.value) === "@babel/helpers - typeof";
              }
            });
            if (isUnderHelper)
              return;
            var helper2 = this.addHelper("typeof");
            isUnderHelper = path2.findParent(function(path3) {
              return path3.isVariableDeclarator() && path3.node.id === helper2 || path3.isFunctionDeclaration() && path3.node.id && path3.node.id.name === helper2.name;
            });
            if (isUnderHelper) {
              return;
            }
            var call3 = callExpression$e(helper2, [node2.argument]);
            var arg = path2.get("argument");
            if (arg.isIdentifier() && !path2.scope.hasBinding(arg.node.name, true)) {
              var unary = unaryExpression$6("typeof", cloneNode$i(node2.argument));
              path2.replaceWith(conditionalExpression$3(binaryExpression$4("===", unary, stringLiteral$8("undefined")), stringLiteral$8("undefined"), call3));
            } else {
              path2.replaceWith(call3);
            }
          }
        }
      };
    });
    function transpileEnum(path2, t3) {
      var node2 = path2.node;
      if (node2.declare) {
        path2.remove();
        return;
      }
      var name2 = node2.id.name;
      var fill = enumFill(path2, t3, node2.id);
      switch (path2.parent.type) {
        case "BlockStatement":
        case "ExportNamedDeclaration":
        case "Program": {
          path2.insertAfter(fill);
          if (seen(path2.parentPath)) {
            path2.remove();
          } else {
            var isGlobal = t3.isProgram(path2.parent);
            path2.scope.registerDeclaration(path2.replaceWith(makeVar(node2.id, t3, isGlobal ? "var" : "let"))[0]);
          }
          break;
        }
        default:
          throw new Error("Unexpected enum parent '" + path2.parent.type);
      }
      function seen(parentPath) {
        if (parentPath.isExportDeclaration()) {
          return seen(parentPath.parentPath);
        }
        if (parentPath.getData(name2)) {
          return true;
        } else {
          parentPath.setData(name2, true);
          return false;
        }
      }
    }
    function makeVar(id3, t3, kind) {
      return t3.variableDeclaration(kind, [t3.variableDeclarator(id3)]);
    }
    var buildEnumWrapper = template$2("\n  (function (ID) {\n    ASSIGNMENTS;\n  })(ID || (ID = {}));\n");
    var buildStringAssignment = template$2('\n  ENUM["NAME"] = VALUE;\n');
    var buildNumericAssignment = template$2('\n  ENUM[ENUM["NAME"] = VALUE] = "NAME";\n');
    var buildEnumMember = function buildEnumMember2(isString2, options) {
      return (isString2 ? buildStringAssignment : buildNumericAssignment)(options);
    };
    function enumFill(path2, t3, id3) {
      var x2 = translateEnumValues(path2, t3);
      var assignments = x2.map(function(_ref3) {
        var _ref22 = _slicedToArray$12(_ref3, 2), memberName = _ref22[0], memberValue = _ref22[1];
        return buildEnumMember(t3.isStringLiteral(memberValue), {
          ENUM: t3.cloneNode(id3),
          NAME: memberName,
          VALUE: memberValue
        });
      });
      return buildEnumWrapper({
        ID: t3.cloneNode(id3),
        ASSIGNMENTS: assignments
      });
    }
    function ReferencedIdentifier(expr, state) {
      var seen = state.seen, path2 = state.path, t3 = state.t;
      var name2 = expr.node.name;
      if (seen.has(name2) && !expr.scope.hasOwnBinding(name2)) {
        expr.replaceWith(t3.memberExpression(t3.cloneNode(path2.node.id), t3.cloneNode(expr.node)));
        expr.skip();
      }
    }
    var enumSelfReferenceVisitor = {
      ReferencedIdentifier
    };
    function translateEnumValues(path2, t3) {
      var seen = /* @__PURE__ */ new Map();
      var constValue = -1;
      var lastName;
      return path2.get("members").map(function(memberPath) {
        var member = memberPath.node;
        var name2 = t3.isIdentifier(member.id) ? member.id.name : member.id.value;
        var initializer = member.initializer;
        var value;
        if (initializer) {
          constValue = evaluate(initializer, seen);
          if (constValue !== void 0) {
            seen.set(name2, constValue);
            if (typeof constValue === "number") {
              value = t3.numericLiteral(constValue);
            } else {
              assert$1.exports(typeof constValue === "string");
              value = t3.stringLiteral(constValue);
            }
          } else {
            var initializerPath = memberPath.get("initializer");
            if (initializerPath.isReferencedIdentifier()) {
              ReferencedIdentifier(initializerPath, {
                t: t3,
                seen,
                path: path2
              });
            } else {
              initializerPath.traverse(enumSelfReferenceVisitor, {
                t: t3,
                seen,
                path: path2
              });
            }
            value = initializerPath.node;
            seen.set(name2, void 0);
          }
        } else if (typeof constValue === "number") {
          constValue += 1;
          value = t3.numericLiteral(constValue);
          seen.set(name2, constValue);
        } else if (typeof constValue === "string") {
          throw path2.buildCodeFrameError("Enum member must have initializer.");
        } else {
          var lastRef = t3.memberExpression(t3.cloneNode(path2.node.id), t3.stringLiteral(lastName), true);
          value = t3.binaryExpression("+", t3.numericLiteral(1), lastRef);
          seen.set(name2, void 0);
        }
        lastName = name2;
        return [name2, value];
      });
    }
    function evaluate(expr, seen) {
      return evalConstant(expr);
      function evalConstant(expr2) {
        switch (expr2.type) {
          case "StringLiteral":
            return expr2.value;
          case "UnaryExpression":
            return evalUnaryExpression(expr2);
          case "BinaryExpression":
            return evalBinaryExpression(expr2);
          case "NumericLiteral":
            return expr2.value;
          case "ParenthesizedExpression":
            return evalConstant(expr2.expression);
          case "Identifier":
            return seen.get(expr2.name);
          case "TemplateLiteral":
            if (expr2.quasis.length === 1) {
              return expr2.quasis[0].value.cooked;
            }
          default:
            return void 0;
        }
      }
      function evalUnaryExpression(_ref3) {
        var argument = _ref3.argument, operator = _ref3.operator;
        var value = evalConstant(argument);
        if (value === void 0) {
          return void 0;
        }
        switch (operator) {
          case "+":
            return value;
          case "-":
            return -value;
          case "~":
            return ~value;
          default:
            return void 0;
        }
      }
      function evalBinaryExpression(expr2) {
        var left = evalConstant(expr2.left);
        if (left === void 0) {
          return void 0;
        }
        var right = evalConstant(expr2.right);
        if (right === void 0) {
          return void 0;
        }
        switch (expr2.operator) {
          case "|":
            return left | right;
          case "&":
            return left & right;
          case ">>":
            return left >> right;
          case ">>>":
            return left >>> right;
          case "<<":
            return left << right;
          case "^":
            return left ^ right;
          case "*":
            return left * right;
          case "/":
            return left / right;
          case "+":
            return left + right;
          case "-":
            return left - right;
          case "%":
            return left % right;
          default:
            return void 0;
        }
      }
    }
    function transpileConstEnum(path2, t3) {
      var name2 = path2.node.id.name;
      var parentIsExport = path2.parentPath.isExportNamedDeclaration();
      var isExported = parentIsExport;
      if (!isExported && t3.isProgram(path2.parent)) {
        isExported = path2.parent.body.some(function(stmt) {
          return t3.isExportNamedDeclaration(stmt) && !stmt.source && stmt.specifiers.some(function(spec) {
            return t3.isExportSpecifier(spec) && spec.local.name === name2;
          });
        });
      }
      var entries2 = translateEnumValues(path2, t3);
      if (isExported) {
        var obj = t3.objectExpression(entries2.map(function(_ref3) {
          var _ref22 = _slicedToArray$12(_ref3, 2), name3 = _ref22[0], value = _ref22[1];
          return t3.objectProperty(t3.isValidIdentifier(name3) ? t3.identifier(name3) : t3.stringLiteral(name3), value);
        }));
        if (path2.scope.hasOwnBinding(name2)) {
          (parentIsExport ? path2.parentPath : path2).replaceWith(t3.expressionStatement(t3.callExpression(t3.memberExpression(t3.identifier("Object"), t3.identifier("assign")), [path2.node.id, obj])));
        } else {
          path2.replaceWith(t3.variableDeclaration("var", [t3.variableDeclarator(path2.node.id, obj)]));
          path2.scope.registerDeclaration(path2);
        }
        return;
      }
      var entriesMap = new Map(entries2);
      path2.scope.path.traverse({
        Scope: function Scope4(path3) {
          if (path3.scope.hasOwnBinding(name2))
            path3.skip();
        },
        MemberExpression: function MemberExpression2(path3) {
          if (!t3.isIdentifier(path3.node.object, {
            name: name2
          }))
            return;
          var key2;
          if (path3.node.computed) {
            if (t3.isStringLiteral(path3.node.property)) {
              key2 = path3.node.property.value;
            } else {
              return;
            }
          } else if (t3.isIdentifier(path3.node.property)) {
            key2 = path3.node.property.name;
          } else {
            return;
          }
          if (!entriesMap.has(key2))
            return;
          path3.replaceWith(t3.cloneNode(entriesMap.get(key2)));
        }
      });
      path2.remove();
    }
    var _templateObject$3, _templateObject2$2;
    function transpileNamespace(path2, t3, allowNamespaces) {
      if (path2.node.declare || path2.node.id.type === "StringLiteral") {
        path2.remove();
        return;
      }
      if (!allowNamespaces) {
        throw path2.hub.file.buildCodeFrameError(path2.node.id, "Namespace not marked type-only declare. Non-declarative namespaces are only supported experimentally in Babel. To enable and review caveats see: https://babeljs.io/docs/en/babel-plugin-transform-typescript");
      }
      var name2 = path2.node.id.name;
      var value = handleNested(path2, t3, t3.cloneDeep(path2.node));
      var bound = path2.scope.hasOwnBinding(name2);
      if (path2.parent.type === "ExportNamedDeclaration") {
        if (!bound) {
          path2.parentPath.insertAfter(value);
          path2.replaceWith(getDeclaration(t3, name2));
          path2.scope.registerDeclaration(path2.parentPath);
        } else {
          path2.parentPath.replaceWith(value);
        }
      } else if (bound) {
        path2.replaceWith(value);
      } else {
        path2.scope.registerDeclaration(path2.replaceWithMultiple([getDeclaration(t3, name2), value])[0]);
      }
    }
    function getDeclaration(t3, name2) {
      return t3.variableDeclaration("let", [t3.variableDeclarator(t3.identifier(name2))]);
    }
    function getMemberExpression(t3, name2, itemName) {
      return t3.memberExpression(t3.identifier(name2), t3.identifier(itemName));
    }
    function handleVariableDeclaration(node2, name2, hub) {
      if (node2.kind !== "const") {
        throw hub.file.buildCodeFrameError(node2, "Namespaces exporting non-const are not supported by Babel. Change to const or see: https://babeljs.io/docs/en/babel-plugin-transform-typescript");
      }
      var declarations = node2.declarations;
      if (declarations.every(function(declarator2) {
        return isIdentifier$i(declarator2.id);
      })) {
        for (var _iterator2 = _createForOfIteratorHelperLoose(declarations), _step2; !(_step2 = _iterator2()).done; ) {
          var declarator = _step2.value;
          declarator.init = assignmentExpression$c("=", getMemberExpression(t$a, name2, declarator.id.name), declarator.init);
        }
        return [node2];
      }
      var bindingIdentifiers = getBindingIdentifiers$2(node2);
      var assignments = [];
      for (var idName in bindingIdentifiers) {
        assignments.push(assignmentExpression$c("=", getMemberExpression(t$a, name2, idName), cloneNode$i(bindingIdentifiers[idName])));
      }
      return [node2, expressionStatement$a(sequenceExpression$7(assignments))];
    }
    function buildNestedAmbiendModuleError(path2, node2) {
      throw path2.hub.buildError(node2, "Ambient modules cannot be nested in other modules or namespaces.", Error);
    }
    function handleNested(path2, t3, node2, parentExport) {
      var names2 = /* @__PURE__ */ new Set();
      var realName = node2.id;
      t3.assertIdentifier(realName);
      var name2 = path2.scope.generateUid(realName.name);
      var namespaceTopLevel = t3.isTSModuleBlock(node2.body) ? node2.body.body : [t3.exportNamedDeclaration(node2.body)];
      for (var i2 = 0; i2 < namespaceTopLevel.length; i2++) {
        var subNode = namespaceTopLevel[i2];
        switch (subNode.type) {
          case "TSModuleDeclaration": {
            if (!t3.isIdentifier(subNode.id)) {
              throw buildNestedAmbiendModuleError(path2, subNode);
            }
            var transformed = handleNested(path2, t3, subNode);
            var moduleName = subNode.id.name;
            if (names2.has(moduleName)) {
              namespaceTopLevel[i2] = transformed;
            } else {
              names2.add(moduleName);
              namespaceTopLevel.splice(i2++, 1, getDeclaration(t3, moduleName), transformed);
            }
            continue;
          }
          case "TSEnumDeclaration":
          case "FunctionDeclaration":
          case "ClassDeclaration":
            names2.add(subNode.id.name);
            continue;
          case "VariableDeclaration": {
            for (var _name in t3.getBindingIdentifiers(subNode)) {
              names2.add(_name);
            }
            continue;
          }
          default:
            continue;
          case "ExportNamedDeclaration":
        }
        switch (subNode.declaration.type) {
          case "TSEnumDeclaration":
          case "FunctionDeclaration":
          case "ClassDeclaration": {
            var itemName = subNode.declaration.id.name;
            names2.add(itemName);
            namespaceTopLevel.splice(i2++, 1, subNode.declaration, t3.expressionStatement(t3.assignmentExpression("=", getMemberExpression(t3, name2, itemName), t3.identifier(itemName))));
            break;
          }
          case "VariableDeclaration": {
            var nodes2 = handleVariableDeclaration(subNode.declaration, name2, path2.hub);
            namespaceTopLevel.splice.apply(namespaceTopLevel, [i2, nodes2.length].concat(_toConsumableArray2(nodes2)));
            i2 += nodes2.length - 1;
            break;
          }
          case "TSModuleDeclaration": {
            if (!t3.isIdentifier(subNode.declaration.id)) {
              throw buildNestedAmbiendModuleError(path2, subNode.declaration);
            }
            var _transformed = handleNested(path2, t3, subNode.declaration, t3.identifier(name2));
            var _moduleName = subNode.declaration.id.name;
            if (names2.has(_moduleName)) {
              namespaceTopLevel[i2] = _transformed;
            } else {
              names2.add(_moduleName);
              namespaceTopLevel.splice(i2++, 1, getDeclaration(t3, _moduleName), _transformed);
            }
          }
        }
      }
      var fallthroughValue = t3.objectExpression([]);
      if (parentExport) {
        var memberExpr = t3.memberExpression(parentExport, realName);
        fallthroughValue = template$2.expression.ast(_templateObject$3 || (_templateObject$3 = _taggedTemplateLiteralLoose(["\n      ", " ||\n        (", " = ", ")\n    "])), t3.cloneNode(memberExpr), t3.cloneNode(memberExpr), fallthroughValue);
      }
      return template$2.statement.ast(_templateObject2$2 || (_templateObject2$2 = _taggedTemplateLiteralLoose(["\n    (function (", ") {\n      ", "\n    })(", " || (", " = ", "));\n  "])), t3.identifier(name2), namespaceTopLevel, realName, t3.cloneNode(realName), fallthroughValue);
    }
    var _templateObject$2;
    function isInType(path2) {
      switch (path2.parent.type) {
        case "TSTypeReference":
        case "TSQualifiedName":
        case "TSExpressionWithTypeArguments":
        case "TSTypeQuery":
          return true;
        case "ExportSpecifier":
          return path2.parentPath.parent.exportKind === "type";
        default:
          return false;
      }
    }
    var GLOBAL_TYPES = /* @__PURE__ */ new WeakMap();
    var NEEDS_EXPLICIT_ESM = /* @__PURE__ */ new WeakMap();
    var PARSED_PARAMS = /* @__PURE__ */ new WeakSet();
    function isGlobalType(path2, name2) {
      var program2 = path2.find(function(path3) {
        return path3.isProgram();
      }).node;
      if (path2.scope.hasOwnBinding(name2))
        return false;
      if (GLOBAL_TYPES.get(program2).has(name2))
        return true;
      console.warn('The exported identifier "' + name2 + `" is not declared in Babel's scope tracker
as a JavaScript value binding, and "@babel/plugin-transform-typescript"
never encountered it as a TypeScript type declaration.
It will be treated as a JavaScript value.

This problem is likely caused by another plugin injecting
` + ('"' + name2 + '" without registering it in the scope tracker. If you are the author\n') + ' of that plugin, please use "scope.registerDeclaration(declarationPath)".');
      return false;
    }
    function registerGlobalType(programNode, name2) {
      GLOBAL_TYPES.get(programNode).add(name2);
    }
    var transformTypeScript = declare(function(api, opts) {
      api.assertVersion(7);
      var JSX_PRAGMA_REGEX = /\*?\s*@jsx((?:Frag)?)\s+([^\s]+)/;
      var _opts$allowNamespaces = opts.allowNamespaces, allowNamespaces = _opts$allowNamespaces === void 0 ? true : _opts$allowNamespaces, _opts$jsxPragma = opts.jsxPragma, jsxPragma = _opts$jsxPragma === void 0 ? "React.createElement" : _opts$jsxPragma, _opts$jsxPragmaFrag = opts.jsxPragmaFrag, jsxPragmaFrag = _opts$jsxPragmaFrag === void 0 ? "React.Fragment" : _opts$jsxPragmaFrag, _opts$onlyRemoveTypeI = opts.onlyRemoveTypeImports, onlyRemoveTypeImports = _opts$onlyRemoveTypeI === void 0 ? false : _opts$onlyRemoveTypeI, _opts$optimizeConstEn = opts.optimizeConstEnums, optimizeConstEnums = _opts$optimizeConstEn === void 0 ? false : _opts$optimizeConstEn;
      {
        var _opts$allowDeclareFie = opts.allowDeclareFields, allowDeclareFields = _opts$allowDeclareFie === void 0 ? false : _opts$allowDeclareFie;
      }
      var classMemberVisitors = {
        field: function field(path2) {
          var node2 = path2.node;
          {
            if (!allowDeclareFields && node2.declare) {
              throw path2.buildCodeFrameError("The 'declare' modifier is only allowed when the 'allowDeclareFields' option of @babel/plugin-transform-typescript or @babel/preset-typescript is enabled.");
            }
          }
          if (node2.declare) {
            if (node2.value) {
              throw path2.buildCodeFrameError("Fields with the 'declare' modifier cannot be initialized here, but only in the constructor");
            }
            if (!node2.decorators) {
              path2.remove();
            }
          } else if (node2.definite) {
            if (node2.value) {
              throw path2.buildCodeFrameError("Definitely assigned fields cannot be initialized here, but only in the constructor");
            }
            {
              if (!allowDeclareFields && !node2.decorators) {
                path2.remove();
              }
            }
          } else {
            if (!allowDeclareFields && !node2.value && !node2.decorators && !isClassPrivateProperty(node2)) {
              path2.remove();
            }
          }
          if (node2.accessibility)
            node2.accessibility = null;
          if (node2["abstract"])
            node2["abstract"] = null;
          if (node2.readonly)
            node2.readonly = null;
          if (node2.optional)
            node2.optional = null;
          if (node2.typeAnnotation)
            node2.typeAnnotation = null;
          if (node2.definite)
            node2.definite = null;
          if (node2.declare)
            node2.declare = null;
          if (node2.override)
            node2.override = null;
        },
        method: function method5(_ref3) {
          var node2 = _ref3.node;
          if (node2.accessibility)
            node2.accessibility = null;
          if (node2["abstract"])
            node2["abstract"] = null;
          if (node2.optional)
            node2.optional = null;
          if (node2.override)
            node2.override = null;
        },
        constructor: function constructor(path2, classPath) {
          if (path2.node.accessibility)
            path2.node.accessibility = null;
          var parameterProperties = [];
          for (var _iterator2 = _createForOfIteratorHelperLoose(path2.node.params), _step2; !(_step2 = _iterator2()).done; ) {
            var param = _step2.value;
            if (param.type === "TSParameterProperty" && !PARSED_PARAMS.has(param.parameter)) {
              PARSED_PARAMS.add(param.parameter);
              parameterProperties.push(param.parameter);
            }
          }
          if (parameterProperties.length) {
            var assigns = parameterProperties.map(function(p2) {
              var id3;
              if (isIdentifier$i(p2)) {
                id3 = p2;
              } else if (isAssignmentPattern$5(p2) && isIdentifier$i(p2.left)) {
                id3 = p2.left;
              } else {
                throw path2.buildCodeFrameError("Parameter properties can not be destructuring patterns.");
              }
              return template$2.statement.ast(_templateObject$2 || (_templateObject$2 = _taggedTemplateLiteralLoose(["\n              this.", " = ", ""])), cloneNode$i(id3), cloneNode$i(id3));
            });
            injectInitialization(classPath, path2, assigns);
          }
        }
      };
      return {
        name: "transform-typescript",
        inherits: syntaxTypescript,
        visitor: {
          Pattern: visitPattern,
          Identifier: visitPattern,
          RestElement: visitPattern,
          Program: {
            enter: function enter(path2, state) {
              var file2 = state.file;
              var fileJsxPragma = null;
              var fileJsxPragmaFrag = null;
              var programNode = path2.node;
              if (!GLOBAL_TYPES.has(programNode)) {
                GLOBAL_TYPES.set(programNode, /* @__PURE__ */ new Set());
              }
              if (file2.ast.comments) {
                for (var _iterator2 = _createForOfIteratorHelperLoose(file2.ast.comments), _step2; !(_step2 = _iterator2()).done; ) {
                  var comment = _step2.value;
                  var jsxMatches = JSX_PRAGMA_REGEX.exec(comment.value);
                  if (jsxMatches) {
                    if (jsxMatches[1]) {
                      fileJsxPragmaFrag = jsxMatches[2];
                    } else {
                      fileJsxPragma = jsxMatches[2];
                    }
                  }
                }
              }
              var pragmaImportName = fileJsxPragma || jsxPragma;
              if (pragmaImportName) {
                var _pragmaImportName$spl = pragmaImportName.split(".");
                var _pragmaImportName$spl2 = _slicedToArray$12(_pragmaImportName$spl, 1);
                pragmaImportName = _pragmaImportName$spl2[0];
              }
              var pragmaFragImportName = fileJsxPragmaFrag || jsxPragmaFrag;
              if (pragmaFragImportName) {
                var _pragmaFragImportName = pragmaFragImportName.split(".");
                var _pragmaFragImportName2 = _slicedToArray$12(_pragmaFragImportName, 1);
                pragmaFragImportName = _pragmaFragImportName2[0];
              }
              for (var _iterator3 = _createForOfIteratorHelperLoose(path2.get("body")), _step3; !(_step3 = _iterator3()).done; ) {
                var stmt = _step3.value;
                if (stmt.isImportDeclaration()) {
                  var _ret2 = function() {
                    if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
                      NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
                    }
                    if (stmt.node.importKind === "type") {
                      for (var _iterator4 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step4; !(_step4 = _iterator4()).done; ) {
                        var specifier = _step4.value;
                        registerGlobalType(programNode, specifier.local.name);
                      }
                      stmt.remove();
                      return "continue";
                    }
                    var importsToRemove = /* @__PURE__ */ new Set();
                    var specifiersLength = stmt.node.specifiers.length;
                    var isAllSpecifiersElided = function isAllSpecifiersElided2() {
                      return specifiersLength > 0 && specifiersLength === importsToRemove.size;
                    };
                    for (var _iterator5 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step5; !(_step5 = _iterator5()).done; ) {
                      var _specifier2 = _step5.value;
                      if (_specifier2.type === "ImportSpecifier" && _specifier2.importKind === "type") {
                        registerGlobalType(programNode, _specifier2.local.name);
                        var _binding = stmt.scope.getBinding(_specifier2.local.name);
                        if (_binding) {
                          importsToRemove.add(_binding.path);
                        }
                      }
                    }
                    if (onlyRemoveTypeImports) {
                      NEEDS_EXPLICIT_ESM.set(path2.node, false);
                    } else {
                      if (stmt.node.specifiers.length === 0) {
                        NEEDS_EXPLICIT_ESM.set(path2.node, false);
                        return "continue";
                      }
                      for (var _iterator6 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step6; !(_step6 = _iterator6()).done; ) {
                        var _specifier = _step6.value;
                        var binding2 = stmt.scope.getBinding(_specifier.local.name);
                        if (binding2 && !importsToRemove.has(binding2.path)) {
                          if (isImportTypeOnly({
                            binding: binding2,
                            programPath: path2,
                            pragmaImportName,
                            pragmaFragImportName
                          })) {
                            importsToRemove.add(binding2.path);
                          } else {
                            NEEDS_EXPLICIT_ESM.set(path2.node, false);
                          }
                        }
                      }
                    }
                    if (isAllSpecifiersElided()) {
                      stmt.remove();
                    } else {
                      for (var _iterator7 = _createForOfIteratorHelperLoose(importsToRemove), _step7; !(_step7 = _iterator7()).done; ) {
                        var importPath = _step7.value;
                        importPath.remove();
                      }
                    }
                    return "continue";
                  }();
                  if (_ret2 === "continue")
                    continue;
                }
                if (stmt.isExportDeclaration()) {
                  stmt = stmt.get("declaration");
                }
                if (stmt.isVariableDeclaration({
                  declare: true
                })) {
                  for (var _i3 = 0, _Object$keys3 = Object.keys(stmt.getBindingIdentifiers()); _i3 < _Object$keys3.length; _i3++) {
                    var name2 = _Object$keys3[_i3];
                    registerGlobalType(programNode, name2);
                  }
                } else if (stmt.isTSTypeAliasDeclaration() || stmt.isTSDeclareFunction() && stmt.get("id").isIdentifier() || stmt.isTSInterfaceDeclaration() || stmt.isClassDeclaration({
                  declare: true
                }) || stmt.isTSEnumDeclaration({
                  declare: true
                }) || stmt.isTSModuleDeclaration({
                  declare: true
                }) && stmt.get("id").isIdentifier()) {
                  registerGlobalType(programNode, stmt.node.id.name);
                }
              }
            },
            exit: function exit(path2) {
              if (path2.node.sourceType === "module" && NEEDS_EXPLICIT_ESM.get(path2.node)) {
                path2.pushContainer("body", exportNamedDeclaration$2());
              }
            }
          },
          ExportNamedDeclaration: function ExportNamedDeclaration2(path2, state) {
            if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
              NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
            }
            if (path2.node.exportKind === "type") {
              path2.remove();
              return;
            }
            if (path2.node.source && path2.node.specifiers.length > 0 && path2.node.specifiers.every(function(specifier) {
              return specifier.type === "ExportSpecifier" && specifier.exportKind === "type";
            })) {
              path2.remove();
              return;
            }
            if (!path2.node.source && path2.node.specifiers.length > 0 && path2.node.specifiers.every(function(specifier) {
              return isExportSpecifier(specifier) && isGlobalType(path2, specifier.local.name);
            })) {
              path2.remove();
              return;
            }
            NEEDS_EXPLICIT_ESM.set(state.file.ast.program, false);
          },
          ExportSpecifier: function ExportSpecifier2(path2) {
            var parent = path2.parent;
            if (!parent.source && isGlobalType(path2, path2.node.local.name) || path2.node.exportKind === "type") {
              path2.remove();
            }
          },
          ExportDefaultDeclaration: function ExportDefaultDeclaration2(path2, state) {
            if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
              NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
            }
            if (isIdentifier$i(path2.node.declaration) && isGlobalType(path2, path2.node.declaration.name)) {
              path2.remove();
              return;
            }
            NEEDS_EXPLICIT_ESM.set(state.file.ast.program, false);
          },
          TSDeclareFunction: function TSDeclareFunction2(path2) {
            path2.remove();
          },
          TSDeclareMethod: function TSDeclareMethod2(path2) {
            path2.remove();
          },
          VariableDeclaration: function VariableDeclaration2(path2) {
            if (path2.node.declare) {
              path2.remove();
            }
          },
          VariableDeclarator: function VariableDeclarator2(_ref22) {
            var node2 = _ref22.node;
            if (node2.definite)
              node2.definite = null;
          },
          TSIndexSignature: function TSIndexSignature2(path2) {
            path2.remove();
          },
          ClassDeclaration: function ClassDeclaration2(path2) {
            var node2 = path2.node;
            if (node2.declare) {
              path2.remove();
              return;
            }
          },
          Class: function Class(path2) {
            var node2 = path2.node;
            if (node2.typeParameters)
              node2.typeParameters = null;
            if (node2.superTypeParameters)
              node2.superTypeParameters = null;
            if (node2["implements"])
              node2["implements"] = null;
            if (node2["abstract"])
              node2["abstract"] = null;
            path2.get("body.body").forEach(function(child) {
              if (child.isClassMethod() || child.isClassPrivateMethod()) {
                if (child.node.kind === "constructor") {
                  classMemberVisitors.constructor(child, path2);
                } else {
                  classMemberVisitors.method(child);
                }
              } else if (child.isClassProperty() || child.isClassPrivateProperty()) {
                classMemberVisitors.field(child);
              }
            });
          },
          Function: function Function2(path2) {
            var node2 = path2.node, scope2 = path2.scope;
            if (node2.typeParameters)
              node2.typeParameters = null;
            if (node2.returnType)
              node2.returnType = null;
            var params = node2.params;
            if (params.length > 0 && isIdentifier$i(params[0], {
              name: "this"
            })) {
              params.shift();
            }
            var paramsPath = path2.get("params");
            for (var _iterator8 = _createForOfIteratorHelperLoose(paramsPath), _step8; !(_step8 = _iterator8()).done; ) {
              var p2 = _step8.value;
              if (p2.type === "TSParameterProperty") {
                p2.replaceWith(p2.get("parameter"));
                scope2.registerBinding("param", p2);
              }
            }
          },
          TSModuleDeclaration: function TSModuleDeclaration2(path2) {
            transpileNamespace(path2, t$a, allowNamespaces);
          },
          TSInterfaceDeclaration: function TSInterfaceDeclaration2(path2) {
            path2.remove();
          },
          TSTypeAliasDeclaration: function TSTypeAliasDeclaration2(path2) {
            path2.remove();
          },
          TSEnumDeclaration: function TSEnumDeclaration2(path2) {
            if (optimizeConstEnums && path2.node["const"]) {
              transpileConstEnum(path2, t$a);
            } else {
              transpileEnum(path2, t$a);
            }
          },
          TSImportEqualsDeclaration: function(_TSImportEqualsDeclaration) {
            function TSImportEqualsDeclaration2(_x) {
              return _TSImportEqualsDeclaration.apply(this, arguments);
            }
            TSImportEqualsDeclaration2.toString = function() {
              return _TSImportEqualsDeclaration.toString();
            };
            return TSImportEqualsDeclaration2;
          }(function(path2) {
            if (isTSExternalModuleReference(path2.node.moduleReference)) {
              throw path2.buildCodeFrameError("`import " + path2.node.id.name + " = require('" + path2.node.moduleReference.expression.value + "')` is not supported by @babel/plugin-transform-typescript\nPlease consider using " + ("`import " + path2.node.id.name + " from '" + path2.node.moduleReference.expression.value + "';` alongside ") + "Typescript's --allowSyntheticDefaultImports option.");
            }
            path2.replaceWith(variableDeclaration$7("var", [variableDeclarator$7(path2.node.id, entityNameToExpr(path2.node.moduleReference))]));
          }),
          TSExportAssignment: function TSExportAssignment2(path2) {
            throw path2.buildCodeFrameError("`export =` is not supported by @babel/plugin-transform-typescript\nPlease consider using `export <value>;`.");
          },
          TSTypeAssertion: function TSTypeAssertion2(path2) {
            path2.replaceWith(path2.node.expression);
          },
          TSAsExpression: function TSAsExpression2(path2) {
            var node2 = path2.node;
            do {
              node2 = node2.expression;
            } while (isTSAsExpression$2(node2));
            path2.replaceWith(node2);
          },
          TSNonNullExpression: function TSNonNullExpression2(path2) {
            path2.replaceWith(path2.node.expression);
          },
          CallExpression: function CallExpression2(path2) {
            path2.node.typeParameters = null;
          },
          OptionalCallExpression: function OptionalCallExpression2(path2) {
            path2.node.typeParameters = null;
          },
          NewExpression: function NewExpression2(path2) {
            path2.node.typeParameters = null;
          },
          JSXOpeningElement: function JSXOpeningElement2(path2) {
            path2.node.typeParameters = null;
          },
          TaggedTemplateExpression: function TaggedTemplateExpression2(path2) {
            path2.node.typeParameters = null;
          }
        }
      };
      function entityNameToExpr(node2) {
        if (isTSQualifiedName(node2)) {
          return memberExpression$b(entityNameToExpr(node2.left), node2.right);
        }
        return node2;
      }
      function visitPattern(_ref3) {
        var node2 = _ref3.node;
        if (node2.typeAnnotation)
          node2.typeAnnotation = null;
        if (isIdentifier$i(node2) && node2.optional)
          node2.optional = null;
      }
      function isImportTypeOnly(_ref42) {
        var binding2 = _ref42.binding, programPath = _ref42.programPath, pragmaImportName = _ref42.pragmaImportName, pragmaFragImportName = _ref42.pragmaFragImportName;
        for (var _iterator9 = _createForOfIteratorHelperLoose(binding2.referencePaths), _step9; !(_step9 = _iterator9()).done; ) {
          var path2 = _step9.value;
          if (!isInType(path2)) {
            return false;
          }
        }
        if (binding2.identifier.name !== pragmaImportName && binding2.identifier.name !== pragmaFragImportName) {
          return true;
        }
        var sourceFileHasJsx = false;
        programPath.traverse({
          "JSXElement|JSXFragment": function JSXElementJSXFragment(path3) {
            sourceFileHasJsx = true;
            path3.stop();
          }
        });
        return !sourceFileHasJsx;
      }
    });
    var _transformUnicodeEscapes = declare(function(api) {
      api.assertVersion(7);
      var surrogate = /[\ud800-\udfff]/g;
      var unicodeEscape = /(\\+)u\{([0-9a-fA-F]+)\}/g;
      function escape(code3) {
        var str = code3.toString(16);
        while (str.length < 4) {
          str = "0" + str;
        }
        return "\\u" + str;
      }
      function replacer(match, backslashes, code3) {
        if (backslashes.length % 2 === 0) {
          return match;
        }
        var _char = String.fromCodePoint(parseInt(code3, 16));
        var escaped = backslashes.slice(0, -1) + escape(_char.charCodeAt(0));
        return _char.length === 1 ? escaped : escaped + escape(_char.charCodeAt(1));
      }
      function replaceUnicodeEscapes(str) {
        return str.replace(unicodeEscape, replacer);
      }
      function getUnicodeEscape(str) {
        var match;
        while (match = unicodeEscape.exec(str)) {
          if (match[1].length % 2 === 0)
            continue;
          unicodeEscape.lastIndex = 0;
          return match[0];
        }
        return null;
      }
      return {
        name: "transform-unicode-escapes",
        manipulateOptions: function manipulateOptions(_ref3) {
          var _generatorOpts$jsescO, _generatorOpts$jsescO2;
          var generatorOpts = _ref3.generatorOpts;
          if (!generatorOpts.jsescOption) {
            generatorOpts.jsescOption = {};
          }
          (_generatorOpts$jsescO2 = (_generatorOpts$jsescO = generatorOpts.jsescOption).minimal) != null ? _generatorOpts$jsescO2 : _generatorOpts$jsescO.minimal = false;
        },
        visitor: {
          Identifier: function Identifier2(path2) {
            var node2 = path2.node, key2 = path2.key;
            var name2 = node2.name;
            var replaced = name2.replace(surrogate, function(c2) {
              return "_u" + c2.charCodeAt(0).toString(16);
            });
            if (name2 === replaced)
              return;
            var str = inherits$1(stringLiteral$8(name2), node2);
            if (key2 === "key") {
              path2.replaceWith(str);
              return;
            }
            var parentPath = path2.parentPath, scope2 = path2.scope;
            if (parentPath.isMemberExpression({
              property: node2
            }) || parentPath.isOptionalMemberExpression({
              property: node2
            })) {
              parentPath.node.computed = true;
              path2.replaceWith(str);
              return;
            }
            var binding2 = scope2.getBinding(name2);
            if (binding2) {
              scope2.rename(name2, scope2.generateUid(replaced));
              return;
            }
            throw path2.buildCodeFrameError("Can't reference '" + name2 + "' as a bare identifier");
          },
          "StringLiteral|DirectiveLiteral": function StringLiteralDirectiveLiteral(path2) {
            var node2 = path2.node;
            var extra = node2.extra;
            if (extra != null && extra.raw)
              extra.raw = replaceUnicodeEscapes(extra.raw);
          },
          TemplateElement: function TemplateElement2(path2) {
            var node2 = path2.node, parentPath = path2.parentPath;
            var value = node2.value;
            var firstEscape = getUnicodeEscape(value.raw);
            if (!firstEscape)
              return;
            var grandParent = parentPath.parentPath;
            if (grandParent.isTaggedTemplateExpression()) {
              throw path2.buildCodeFrameError("Can't replace Unicode escape '" + firstEscape + "' inside tagged template literals. You can enable '@babel/plugin-transform-template-literals' to compile them to classic strings.");
            }
            value.raw = replaceUnicodeEscapes(value.raw);
          }
        }
      };
    });
    var _transformUnicodeRegex = declare(function(api) {
      api.assertVersion(7);
      return createRegExpFeaturePlugin({
        name: "transform-unicode-regex",
        feature: "unicodeFlag"
      });
    });
    var all = {
      "external-helpers": externalHelpers,
      "syntax-async-generators": lib$x,
      "syntax-class-properties": lib$w,
      "syntax-class-static-block": lib$v,
      "syntax-decimal": syntaxDecimal,
      "syntax-decorators": syntaxDecorators,
      "syntax-destructuring-private": syntaxDestructuringPrivate,
      "syntax-do-expressions": syntaxDoExpressions,
      "syntax-export-default-from": syntaxExportDefaultFrom,
      "syntax-flow": syntaxFlow,
      "syntax-function-bind": syntaxFunctionBind,
      "syntax-function-sent": syntaxFunctionSent,
      "syntax-module-blocks": syntaxModuleBlocks,
      "syntax-import-meta": lib$u,
      "syntax-jsx": syntaxJsx,
      "syntax-import-assertions": syntaxImportAssertions,
      "syntax-object-rest-spread": lib$t,
      "syntax-optional-catch-binding": lib$s,
      "syntax-pipeline-operator": syntaxPipelineOperator,
      "syntax-record-and-tuple": syntaxRecordAndTuple,
      "syntax-top-level-await": lib$r,
      "syntax-typescript": syntaxTypescript,
      "proposal-async-generator-functions": _proposalAsyncGeneratorFunctions,
      "proposal-class-properties": _proposalClassProperties,
      "proposal-class-static-block": _proposalClassStaticBlock,
      "proposal-decorators": proposalDecorators,
      "proposal-do-expressions": proposalDoExpressions,
      "proposal-dynamic-import": _proposalDynamicImport,
      "proposal-export-default-from": proposalExportDefaultFrom,
      "proposal-export-namespace-from": _proposalExportNamespaceFrom,
      "proposal-function-bind": proposalFunctionBind,
      "proposal-function-sent": proposalFunctionSent,
      "proposal-json-strings": _proposalJsonStrings,
      "proposal-logical-assignment-operators": _proposalLogicalAssignmentOperators,
      "proposal-nullish-coalescing-operator": _proposalNullishCoalescingOperator,
      "proposal-numeric-separator": _proposalNumericSeparator,
      "proposal-object-rest-spread": _proposalObjectRestSpread,
      "proposal-optional-catch-binding": _proposalOptionalCatchBinding,
      "proposal-optional-chaining": _proposalOptionalChaining,
      "proposal-pipeline-operator": proposalPipelineOperator,
      "proposal-private-methods": _proposalPrivateMethods,
      "proposal-private-property-in-object": _proposalPrivatePropertyInObject,
      "proposal-throw-expressions": proposalThrowExpressions,
      "proposal-unicode-property-regex": _proposalUnicodePropertyRegex,
      "transform-async-to-generator": _transformAsyncToGenerator,
      "transform-arrow-functions": _transformArrowFunctions,
      "transform-block-scoped-functions": _transformBlockScopedFunctions,
      "transform-block-scoping": _transformBlockScoping,
      "transform-classes": _transformClasses,
      "transform-computed-properties": _transformComputedProperties,
      "transform-destructuring": _transformDestructuring,
      "transform-dotall-regex": _transformDotallRegex,
      "transform-duplicate-keys": _transformDuplicateKeys,
      "transform-exponentiation-operator": transformExponentialOperator,
      "transform-flow-comments": transformFlowComments,
      "transform-flow-strip-types": transformFlowStripTypes,
      "transform-for-of": _transformForOf,
      "transform-function-name": _transformFunctionName,
      "transform-instanceof": transformInstanceof,
      "transform-jscript": transformJscript,
      "transform-literals": _transformLiterals,
      "transform-member-expression-literals": _transformMemberExpressionLiterals,
      "transform-modules-amd": _transformModulesAmd,
      "transform-modules-commonjs": _transformModulesCommonjs,
      "transform-modules-systemjs": _transformModulesSystemjs,
      "transform-modules-umd": _transformModulesUmd,
      "transform-named-capturing-groups-regex": _transformNamedCapturingGroupsRegex,
      "transform-new-target": _transformNewTarget,
      "transform-object-assign": transformObjectAssign,
      "transform-object-super": _transformObjectSuper,
      "transform-object-set-prototype-of-to-assign": transformObjectSetPrototypeOfToAssign,
      "transform-parameters": _transformParameters,
      "transform-property-literals": _transformPropertyLiterals,
      "transform-property-mutators": transformPropertyMutators,
      "transform-proto-to-assign": transformProtoToAssign,
      "transform-react-constant-elements": transformReactConstantElements,
      "transform-react-display-name": transformReactDisplayName,
      "transform-react-inline-elements": transformReactInlineElements,
      "transform-react-jsx": transformReactJSX,
      "transform-react-jsx-compat": transformReactJsxCompat,
      "transform-react-jsx-development": transformReactJSXDevelopment,
      "transform-react-jsx-self": transformReactJsxSelf,
      "transform-react-jsx-source": transformReactJsxSource,
      "transform-regenerator": _transformRegenerator,
      "transform-reserved-words": _transformReservedWords,
      "transform-runtime": transformRuntime,
      "transform-shorthand-properties": _transformShorthandProperties,
      "transform-spread": _transformSpread,
      "transform-sticky-regex": _transformStickyRegex,
      "transform-strict-mode": transformStrictMode,
      "transform-template-literals": _transformTemplateLiterals,
      "transform-typeof-symbol": _transformTypeofSymbol,
      "transform-typescript": transformTypeScript,
      "transform-unicode-escapes": _transformUnicodeEscapes,
      "transform-unicode-regex": _transformUnicodeRegex
    };
    var preset2015 = function(_, opts) {
      var loose = false;
      var modules2 = "commonjs";
      var spec = false;
      if (opts !== void 0) {
        if (opts.loose !== void 0)
          loose = opts.loose;
        if (opts.modules !== void 0)
          modules2 = opts.modules;
        if (opts.spec !== void 0)
          spec = opts.spec;
      }
      var optsLoose = {
        loose
      };
      return {
        plugins: [[_transformTemplateLiterals, {
          loose,
          spec
        }], _transformLiterals, _transformFunctionName, [_transformArrowFunctions, {
          spec
        }], _transformBlockScopedFunctions, [_transformClasses, optsLoose], _transformObjectSuper, _transformShorthandProperties, _transformDuplicateKeys, [_transformComputedProperties, optsLoose], [_transformForOf, optsLoose], _transformStickyRegex, _transformUnicodeEscapes, _transformUnicodeRegex, [_transformSpread, optsLoose], [_transformParameters, optsLoose], [_transformDestructuring, optsLoose], _transformBlockScoping, _transformTypeofSymbol, transformInstanceof, (modules2 === "commonjs" || modules2 === "cjs") && [_transformModulesCommonjs, optsLoose], modules2 === "systemjs" && [_transformModulesSystemjs, optsLoose], modules2 === "amd" && [_transformModulesAmd, optsLoose], modules2 === "umd" && [_transformModulesUmd, optsLoose], [_transformRegenerator, {
          async: false,
          asyncGenerators: false
        }]].filter(Boolean)
      };
    };
    var presetStage3 = function(_, _temp) {
      var _ref3 = _temp === void 0 ? {} : _temp, _ref$loose = _ref3.loose, loose = _ref$loose === void 0 ? false : _ref$loose;
      var plugins2 = [syntaxImportAssertions, _proposalClassStaticBlock];
      {
        plugins2.push(lib$u, lib$r, _proposalExportNamespaceFrom, _proposalLogicalAssignmentOperators, [_proposalOptionalChaining, {
          loose
        }], [_proposalNullishCoalescingOperator, {
          loose
        }], [_proposalClassProperties, {
          loose
        }], _proposalJsonStrings, _proposalNumericSeparator, [_proposalPrivateMethods, {
          loose
        }], _proposalPrivatePropertyInObject);
      }
      return {
        plugins: plugins2
      };
    };
    var presetStage2 = function(_, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var _opts = opts, _opts$loose = _opts.loose, loose = _opts$loose === void 0 ? false : _opts$loose, _opts$useBuiltIns = _opts.useBuiltIns, useBuiltIns = _opts$useBuiltIns === void 0 ? false : _opts$useBuiltIns, _opts$decoratorsLegac = _opts.decoratorsLegacy, decoratorsLegacy = _opts$decoratorsLegac === void 0 ? false : _opts$decoratorsLegac, _opts$decoratorsVersi = _opts.decoratorsVersion, decoratorsVersion = _opts$decoratorsVersi === void 0 ? "2018-09" : _opts$decoratorsVersi, decoratorsBeforeExport = _opts.decoratorsBeforeExport, _opts$pipelineProposa = _opts.pipelineProposal, pipelineProposal = _opts$pipelineProposa === void 0 ? "minimal" : _opts$pipelineProposa, _opts$pipelineTopicTo = _opts.pipelineTopicToken, pipelineTopicToken = _opts$pipelineTopicTo === void 0 ? "%" : _opts$pipelineTopicTo, _opts$recordAndTupleS = _opts.recordAndTupleSyntax, recordAndTupleSyntax = _opts$recordAndTupleS === void 0 ? "hash" : _opts$recordAndTupleS;
      return {
        presets: [[presetStage3, {
          loose,
          useBuiltIns
        }]],
        plugins: [[proposalDecorators, {
          version: decoratorsLegacy ? "legacy" : decoratorsVersion,
          decoratorsBeforeExport
        }], syntaxDestructuringPrivate, [proposalPipelineOperator, {
          proposal: pipelineProposal,
          topicToken: pipelineTopicToken
        }], proposalFunctionSent, proposalThrowExpressions, [syntaxRecordAndTuple, {
          syntaxType: recordAndTupleSyntax
        }], syntaxModuleBlocks]
      };
    };
    var presetStage1 = function(_, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var _opts = opts, _opts$loose = _opts.loose, loose = _opts$loose === void 0 ? false : _opts$loose, _opts$useBuiltIns = _opts.useBuiltIns, useBuiltIns = _opts$useBuiltIns === void 0 ? false : _opts$useBuiltIns, decoratorsLegacy = _opts.decoratorsLegacy, decoratorsVersion = _opts.decoratorsVersion, decoratorsBeforeExport = _opts.decoratorsBeforeExport, pipelineProposal = _opts.pipelineProposal, pipelineTopicToken = _opts.pipelineTopicToken, recordAndTupleSyntax = _opts.recordAndTupleSyntax;
      return {
        presets: [[presetStage2, {
          loose,
          useBuiltIns,
          decoratorsLegacy,
          decoratorsVersion,
          decoratorsBeforeExport,
          pipelineProposal,
          pipelineTopicToken,
          recordAndTupleSyntax
        }]],
        plugins: [syntaxDecimal, proposalExportDefaultFrom, proposalDoExpressions]
      };
    };
    var presetStage0 = function(_, opts) {
      if (opts === void 0) {
        opts = {};
      }
      var _opts = opts, _opts$loose = _opts.loose, loose = _opts$loose === void 0 ? false : _opts$loose, _opts$useBuiltIns = _opts.useBuiltIns, useBuiltIns = _opts$useBuiltIns === void 0 ? false : _opts$useBuiltIns, decoratorsLegacy = _opts.decoratorsLegacy, decoratorsVersion = _opts.decoratorsVersion, decoratorsBeforeExport = _opts.decoratorsBeforeExport, pipelineProposal = _opts.pipelineProposal, pipelineTopicToken = _opts.pipelineTopicToken, _opts$importAssertion = _opts.importAssertionsVersion, importAssertionsVersion = _opts$importAssertion === void 0 ? "september-2020" : _opts$importAssertion;
      return {
        presets: [[presetStage1, {
          loose,
          useBuiltIns,
          decoratorsLegacy,
          decoratorsVersion,
          decoratorsBeforeExport,
          pipelineProposal,
          pipelineTopicToken,
          importAssertionsVersion
        }]],
        plugins: [proposalFunctionBind]
      };
    };
    var semver$2 = requireSemver();
    var logPlugin = function logPlugin2(item, targetVersions, list2) {
      var filteredList = getInclusionReasons(item, targetVersions, list2);
      var support = list2[item];
      if (!support) {
        console.log("  " + item);
        return;
      }
      var formattedTargets = "{";
      var first = true;
      for (var _i3 = 0, _Object$keys3 = Object.keys(filteredList); _i3 < _Object$keys3.length; _i3++) {
        var target = _Object$keys3[_i3];
        if (!first)
          formattedTargets += ",";
        first = false;
        formattedTargets += " " + target;
        if (support[target])
          formattedTargets += " < " + support[target];
      }
      formattedTargets += " }";
      console.log("  " + item + " " + formattedTargets);
    };
    var defaultExcludesForLooseMode = ["transform-typeof-symbol"];
    function getOptionSpecificExcludesFor(_ref3) {
      var loose = _ref3.loose;
      return loose ? defaultExcludesForLooseMode : null;
    }
    var lib$d = {};
    Object.defineProperty(lib$d, "__esModule", {
      value: true
    });
    lib$d["default"] = void 0;
    var _helperPluginUtils$d = require$$0$5;
    var _default$d = (0, _helperPluginUtils$d.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-async-generators",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("asyncGenerators");
        }
      };
    });
    lib$d["default"] = _default$d;
    var lib$c = {};
    Object.defineProperty(lib$c, "__esModule", {
      value: true
    });
    lib$c["default"] = void 0;
    var _helperPluginUtils$c = require$$0$5;
    var _default$c = (0, _helperPluginUtils$c.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-class-properties",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classProperties", "classPrivateProperties", "classPrivateMethods");
        }
      };
    });
    lib$c["default"] = _default$c;
    var lib$b = {};
    Object.defineProperty(lib$b, "__esModule", {
      value: true
    });
    lib$b["default"] = void 0;
    var _helperPluginUtils$b = require$$0$5;
    var _default$b = (0, _helperPluginUtils$b.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-class-static-block",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("classStaticBlock");
        }
      };
    });
    lib$b["default"] = _default$b;
    var lib$a = {};
    Object.defineProperty(lib$a, "__esModule", {
      value: true
    });
    lib$a["default"] = void 0;
    var _helperPluginUtils$a = require$$0$5;
    var _default$a = (0, _helperPluginUtils$a.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-dynamic-import",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("dynamicImport");
        }
      };
    });
    lib$a["default"] = _default$a;
    var lib$9 = {};
    Object.defineProperty(lib$9, "__esModule", {
      value: true
    });
    lib$9["default"] = void 0;
    var _helperPluginUtils$9 = require$$0$5;
    var _default$9 = (0, _helperPluginUtils$9.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-export-namespace-from",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("exportNamespaceFrom");
        }
      };
    });
    lib$9["default"] = _default$9;
    var lib$8 = {};
    Object.defineProperty(lib$8, "__esModule", {
      value: true
    });
    lib$8["default"] = void 0;
    var _helperPluginUtils$8 = require$$0$5;
    var _default$8 = (0, _helperPluginUtils$8.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-json-strings",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("jsonStrings");
        }
      };
    });
    lib$8["default"] = _default$8;
    var lib$7 = {};
    Object.defineProperty(lib$7, "__esModule", {
      value: true
    });
    lib$7["default"] = void 0;
    var _helperPluginUtils$7 = require$$0$5;
    var _default$7 = (0, _helperPluginUtils$7.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-logical-assignment-operators",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("logicalAssignment");
        }
      };
    });
    lib$7["default"] = _default$7;
    var lib$6 = {};
    Object.defineProperty(lib$6, "__esModule", {
      value: true
    });
    lib$6["default"] = void 0;
    var _helperPluginUtils$6 = require$$0$5;
    var _default$6 = (0, _helperPluginUtils$6.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-nullish-coalescing-operator",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("nullishCoalescingOperator");
        }
      };
    });
    lib$6["default"] = _default$6;
    var lib$5 = {};
    Object.defineProperty(lib$5, "__esModule", {
      value: true
    });
    lib$5["default"] = void 0;
    var _helperPluginUtils$5 = require$$0$5;
    var _default$5 = (0, _helperPluginUtils$5.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-numeric-separator",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("numericSeparator");
        }
      };
    });
    lib$5["default"] = _default$5;
    var lib$4 = {};
    Object.defineProperty(lib$4, "__esModule", {
      value: true
    });
    lib$4["default"] = void 0;
    var _helperPluginUtils$4 = require$$0$5;
    var _default$4 = (0, _helperPluginUtils$4.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-object-rest-spread",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("objectRestSpread");
        }
      };
    });
    lib$4["default"] = _default$4;
    var lib$3 = {};
    Object.defineProperty(lib$3, "__esModule", {
      value: true
    });
    lib$3["default"] = void 0;
    var _helperPluginUtils$3 = require$$0$5;
    var _default$3 = (0, _helperPluginUtils$3.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-optional-catch-binding",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("optionalCatchBinding");
        }
      };
    });
    lib$3["default"] = _default$3;
    var lib$2 = {};
    Object.defineProperty(lib$2, "__esModule", {
      value: true
    });
    lib$2["default"] = void 0;
    var _helperPluginUtils$2 = require$$0$5;
    var _default$2 = (0, _helperPluginUtils$2.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-optional-chaining",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("optionalChaining");
        }
      };
    });
    lib$2["default"] = _default$2;
    var lib$1 = {};
    Object.defineProperty(lib$1, "__esModule", {
      value: true
    });
    lib$1["default"] = void 0;
    var _helperPluginUtils$1 = require$$0$5;
    var _default$1 = (0, _helperPluginUtils$1.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-private-property-in-object",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("privateIn");
        }
      };
    });
    lib$1["default"] = _default$1;
    var lib = {};
    Object.defineProperty(lib, "__esModule", {
      value: true
    });
    lib["default"] = void 0;
    var _helperPluginUtils = require$$0$5;
    var _default2 = (0, _helperPluginUtils.declare)(function(api) {
      api.assertVersion(7);
      return {
        name: "syntax-top-level-await",
        manipulateOptions: function manipulateOptions(opts, parserOpts) {
          parserOpts.plugins.push("topLevelAwait");
        }
      };
    });
    lib["default"] = _default2;
    var transformAsyncArrowsInClass = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = void 0;
      var OPTS = {
        allowInsertArrow: false,
        specCompliant: false
      };
      var _default3 = function _default4(_ref3) {
        var t3 = _ref3.types;
        return {
          name: "transform-async-arrows-in-class",
          visitor: {
            ArrowFunctionExpression: function ArrowFunctionExpression2(path2) {
              if (path2.node.async && path2.findParent(t3.isClassMethod)) {
                path2.arrowFunctionToExpression(OPTS);
              }
            }
          }
        };
      };
      exports3["default"] = _default3;
      module2.exports = exports3["default"];
    })(transformAsyncArrowsInClass, transformAsyncArrowsInClass.exports);
    var bugfixAsyncArrowsInClass = transformAsyncArrowsInClass.exports;
    var transformEdgeDefaultParameters = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = void 0;
      var _default3 = function _default4(_ref3) {
        var t3 = _ref3.types;
        var isArrowParent = function isArrowParent2(p2) {
          return p2.parentKey === "params" && p2.parentPath && t3.isArrowFunctionExpression(p2.parentPath);
        };
        return {
          name: "transform-edge-default-parameters",
          visitor: {
            AssignmentPattern: function AssignmentPattern2(path2) {
              var arrowArgParent = path2.find(isArrowParent);
              if (arrowArgParent && path2.parent.shorthand) {
                path2.parent.shorthand = false;
                (path2.parent.extra || {}).shorthand = false;
                path2.scope.rename(path2.parent.key.name);
              }
            }
          }
        };
      };
      exports3["default"] = _default3;
      module2.exports = exports3["default"];
    })(transformEdgeDefaultParameters, transformEdgeDefaultParameters.exports);
    var bugfixEdgeDefaultParameters = transformEdgeDefaultParameters.exports;
    var transformEdgeFunctionName = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = void 0;
      var _default3 = function _default4(_ref3) {
        var t3 = _ref3.types;
        return {
          name: "transform-edge-function-name",
          visitor: {
            FunctionExpression: {
              exit: function exit(path2) {
                if (!path2.node.id && t3.isIdentifier(path2.parent.id)) {
                  var id3 = t3.cloneNode(path2.parent.id);
                  var binding2 = path2.scope.getBinding(id3.name);
                  if (binding2 == null ? void 0 : binding2.constantViolations.length) {
                    path2.scope.rename(id3.name);
                  }
                  path2.node.id = id3;
                }
              }
            }
          }
        };
      };
      exports3["default"] = _default3;
      module2.exports = exports3["default"];
    })(transformEdgeFunctionName, transformEdgeFunctionName.exports);
    var bugfixEdgeFunctionName = transformEdgeFunctionName.exports;
    var transformTaggedTemplateCaching = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = void 0;
      var _default3 = function _default4(_ref3) {
        var t3 = _ref3.types;
        return {
          name: "transform-tagged-template-caching",
          visitor: {
            TaggedTemplateExpression: function TaggedTemplateExpression2(path2, state) {
              var processed = state.get("processed");
              if (!processed) {
                processed = /* @__PURE__ */ new WeakSet();
                state.set("processed", processed);
              }
              if (processed.has(path2.node))
                return path2.skip();
              var expressions = path2.node.quasi.expressions;
              var identity2 = state.get("identity");
              if (!identity2) {
                identity2 = path2.scope.getProgramParent().generateDeclaredUidIdentifier("_");
                state.set("identity", identity2);
                var binding2 = path2.scope.getBinding(identity2.name);
                binding2.path.get("init").replaceWith(t3.arrowFunctionExpression([t3.identifier("t")], t3.identifier("t")));
              }
              var template2 = t3.taggedTemplateExpression(t3.cloneNode(identity2), t3.templateLiteral(path2.node.quasi.quasis, expressions.map(function() {
                return t3.numericLiteral(0);
              })));
              processed.add(template2);
              var ident = path2.scope.getProgramParent().generateDeclaredUidIdentifier("t");
              path2.scope.getBinding(ident.name).path.parent.kind = "let";
              var inlineCache = t3.logicalExpression("||", ident, t3.assignmentExpression("=", t3.cloneNode(ident), template2));
              var node2 = t3.callExpression(path2.node.tag, [inlineCache].concat(_toConsumableArray2(expressions)));
              path2.replaceWith(node2);
            }
          }
        };
      };
      exports3["default"] = _default3;
      module2.exports = exports3["default"];
    })(transformTaggedTemplateCaching, transformTaggedTemplateCaching.exports);
    var bugfixTaggedTemplateCaching = transformTaggedTemplateCaching.exports;
    var transformSafariBlockShadowing = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = _default3;
      function _default3(_ref3) {
        var t3 = _ref3.types;
        return {
          name: "transform-safari-block-shadowing",
          visitor: {
            VariableDeclarator: function VariableDeclarator2(path2) {
              var kind = path2.parent.kind;
              if (kind !== "let" && kind !== "const")
                return;
              var block = path2.scope.block;
              if (t3.isFunction(block) || t3.isProgram(block))
                return;
              var bindings = t3.getOuterBindingIdentifiers(path2.node.id);
              for (var _i3 = 0, _Object$keys3 = Object.keys(bindings); _i3 < _Object$keys3.length; _i3++) {
                var name2 = _Object$keys3[_i3];
                var scope2 = path2.scope;
                if (!scope2.hasOwnBinding(name2))
                  continue;
                while (scope2 = scope2.parent) {
                  if (scope2.hasOwnBinding(name2)) {
                    path2.scope.rename(name2);
                    break;
                  }
                  if (t3.isFunction(scope2.block) || t3.isProgram(scope2.block)) {
                    break;
                  }
                }
              }
            }
          }
        };
      }
      module2.exports = exports3["default"];
    })(transformSafariBlockShadowing, transformSafariBlockShadowing.exports);
    var bugfixSafariBlockShadowing = transformSafariBlockShadowing.exports;
    var transformSafariForShadowing = { exports: {} };
    (function(module2, exports3) {
      exports3.__esModule = true;
      exports3["default"] = void 0;
      function handle2(declaration) {
        if (!declaration.isVariableDeclaration())
          return;
        var fn = declaration.getFunctionParent();
        var name2 = declaration.node.declarations[0].id.name;
        if (fn && fn.scope.hasOwnBinding(name2) && fn.scope.getOwnBinding(name2).kind === "param") {
          declaration.scope.rename(name2);
        }
      }
      var _default3 = function _default4() {
        return {
          name: "transform-safari-for-shadowing",
          visitor: {
            ForXStatement: function ForXStatement(path2) {
              handle2(path2.get("left"));
            },
            ForStatement: function ForStatement2(path2) {
              handle2(path2.get("init"));
            }
          }
        };
      };
      exports3["default"] = _default3;
      module2.exports = exports3["default"];
    })(transformSafariForShadowing, transformSafariForShadowing.exports);
    var bugfixSafariForShadowing = transformSafariForShadowing.exports;
    function shouldTransform$1(path2) {
      var node2 = path2.node;
      var functionId = node2.id;
      if (!functionId)
        return false;
      var name2 = functionId.name;
      var paramNameBinding = path2.scope.getOwnBinding(name2);
      if (paramNameBinding === void 0) {
        return false;
      }
      if (paramNameBinding.kind !== "param") {
        return false;
      }
      if (paramNameBinding.identifier === paramNameBinding.path.node) {
        return false;
      }
      return name2;
    }
    var bugfixSafariIdDestructuringCollisionInFunctionExpression = declare(function(api) {
      api.assertVersion("^7.16.0");
      return {
        name: "plugin-bugfix-safari-id-destructuring-collision-in-function-expression",
        visitor: {
          FunctionExpression: function FunctionExpression2(path2) {
            var name2 = shouldTransform$1(path2);
            if (name2) {
              var scope2 = path2.scope;
              var newParamName = scope2.generateUid(name2);
              scope2.rename(name2, newParamName);
            }
          }
        }
      };
    });
    function matchAffectedArguments(argumentNodes) {
      var spreadIndex = argumentNodes.findIndex(function(node2) {
        return isSpreadElement$1(node2);
      });
      return spreadIndex >= 0 && spreadIndex !== argumentNodes.length - 1;
    }
    function shouldTransform(path2) {
      var optionalPath = path2;
      var chains = [];
      while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
        var _optionalPath = optionalPath, node2 = _optionalPath.node;
        chains.push(node2);
        if (optionalPath.isOptionalMemberExpression()) {
          optionalPath = skipTransparentExprWrappers(optionalPath.get("object"));
        } else if (optionalPath.isOptionalCallExpression()) {
          optionalPath = skipTransparentExprWrappers(optionalPath.get("callee"));
        }
      }
      for (var i2 = 0; i2 < chains.length; i2++) {
        var _node = chains[i2];
        if (isOptionalCallExpression$3(_node) && matchAffectedArguments(_node.arguments)) {
          if (_node.optional) {
            return true;
          }
          var callee = chains[i2 + 1];
          if (isOptionalMemberExpression$3(callee, {
            optional: true
          })) {
            return true;
          }
        }
      }
      return false;
    }
    var bugfixV8SpreadParametersInOptionalChaining = declare(function(api) {
      api.assertVersion(7);
      var noDocumentAll = api.assumption("noDocumentAll");
      var pureGetters = api.assumption("pureGetters");
      return {
        name: "bugfix-v8-spread-parameters-in-optional-chaining",
        visitor: {
          "OptionalCallExpression|OptionalMemberExpression": function OptionalCallExpressionOptionalMemberExpression(path2) {
            if (shouldTransform(path2)) {
              transform$2(path2, {
                noDocumentAll,
                pureGetters
              });
            }
          }
        }
      };
    });
    var availablePlugins$1 = {
      "bugfix/transform-async-arrows-in-class": function bugfixTransformAsyncArrowsInClass() {
        return bugfixAsyncArrowsInClass;
      },
      "bugfix/transform-edge-default-parameters": function bugfixTransformEdgeDefaultParameters() {
        return bugfixEdgeDefaultParameters;
      },
      "bugfix/transform-edge-function-name": function bugfixTransformEdgeFunctionName() {
        return bugfixEdgeFunctionName;
      },
      "bugfix/transform-safari-block-shadowing": function bugfixTransformSafariBlockShadowing() {
        return bugfixSafariBlockShadowing;
      },
      "bugfix/transform-safari-for-shadowing": function bugfixTransformSafariForShadowing() {
        return bugfixSafariForShadowing;
      },
      "bugfix/transform-safari-id-destructuring-collision-in-function-expression": function bugfixTransformSafariIdDestructuringCollisionInFunctionExpression() {
        return bugfixSafariIdDestructuringCollisionInFunctionExpression;
      },
      "bugfix/transform-tagged-template-caching": function bugfixTransformTaggedTemplateCaching() {
        return bugfixTaggedTemplateCaching;
      },
      "bugfix/transform-v8-spread-parameters-in-optional-chaining": function bugfixTransformV8SpreadParametersInOptionalChaining() {
        return bugfixV8SpreadParametersInOptionalChaining;
      },
      "proposal-async-generator-functions": function proposalAsyncGeneratorFunctions() {
        return _proposalAsyncGeneratorFunctions;
      },
      "proposal-class-properties": function proposalClassProperties() {
        return _proposalClassProperties;
      },
      "proposal-class-static-block": function proposalClassStaticBlock() {
        return _proposalClassStaticBlock;
      },
      "proposal-dynamic-import": function proposalDynamicImport() {
        return _proposalDynamicImport;
      },
      "proposal-export-namespace-from": function proposalExportNamespaceFrom() {
        return _proposalExportNamespaceFrom;
      },
      "proposal-json-strings": function proposalJsonStrings() {
        return _proposalJsonStrings;
      },
      "proposal-logical-assignment-operators": function proposalLogicalAssignmentOperators() {
        return _proposalLogicalAssignmentOperators;
      },
      "proposal-nullish-coalescing-operator": function proposalNullishCoalescingOperator() {
        return _proposalNullishCoalescingOperator;
      },
      "proposal-numeric-separator": function proposalNumericSeparator() {
        return _proposalNumericSeparator;
      },
      "proposal-object-rest-spread": function proposalObjectRestSpread() {
        return _proposalObjectRestSpread;
      },
      "proposal-optional-catch-binding": function proposalOptionalCatchBinding() {
        return _proposalOptionalCatchBinding;
      },
      "proposal-optional-chaining": function proposalOptionalChaining() {
        return _proposalOptionalChaining;
      },
      "proposal-private-methods": function proposalPrivateMethods() {
        return _proposalPrivateMethods;
      },
      "proposal-private-property-in-object": function proposalPrivatePropertyInObject() {
        return _proposalPrivatePropertyInObject;
      },
      "proposal-unicode-property-regex": function proposalUnicodePropertyRegex() {
        return _proposalUnicodePropertyRegex;
      },
      "syntax-async-generators": function syntaxAsyncGenerators() {
        return lib$d;
      },
      "syntax-class-properties": function syntaxClassProperties() {
        return lib$c;
      },
      "syntax-class-static-block": function syntaxClassStaticBlock() {
        return lib$b;
      },
      "syntax-dynamic-import": function syntaxDynamicImport() {
        return lib$a;
      },
      "syntax-export-namespace-from": function syntaxExportNamespaceFrom() {
        return lib$9;
      },
      "syntax-json-strings": function syntaxJsonStrings() {
        return lib$8;
      },
      "syntax-logical-assignment-operators": function syntaxLogicalAssignmentOperators() {
        return lib$7;
      },
      "syntax-nullish-coalescing-operator": function syntaxNullishCoalescingOperator() {
        return lib$6;
      },
      "syntax-numeric-separator": function syntaxNumericSeparator() {
        return lib$5;
      },
      "syntax-object-rest-spread": function syntaxObjectRestSpread() {
        return lib$4;
      },
      "syntax-optional-catch-binding": function syntaxOptionalCatchBinding() {
        return lib$3;
      },
      "syntax-optional-chaining": function syntaxOptionalChaining() {
        return lib$2;
      },
      "syntax-private-property-in-object": function syntaxPrivatePropertyInObject() {
        return lib$1;
      },
      "syntax-top-level-await": function syntaxTopLevelAwait() {
        return lib;
      },
      "transform-arrow-functions": function transformArrowFunctions() {
        return _transformArrowFunctions;
      },
      "transform-async-to-generator": function transformAsyncToGenerator() {
        return _transformAsyncToGenerator;
      },
      "transform-block-scoped-functions": function transformBlockScopedFunctions() {
        return _transformBlockScopedFunctions;
      },
      "transform-block-scoping": function transformBlockScoping() {
        return _transformBlockScoping;
      },
      "transform-classes": function transformClasses() {
        return _transformClasses;
      },
      "transform-computed-properties": function transformComputedProperties() {
        return _transformComputedProperties;
      },
      "transform-destructuring": function transformDestructuring() {
        return _transformDestructuring;
      },
      "transform-dotall-regex": function transformDotallRegex() {
        return _transformDotallRegex;
      },
      "transform-duplicate-keys": function transformDuplicateKeys() {
        return _transformDuplicateKeys;
      },
      "transform-exponentiation-operator": function transformExponentiationOperator() {
        return transformExponentialOperator;
      },
      "transform-for-of": function transformForOf() {
        return _transformForOf;
      },
      "transform-function-name": function transformFunctionName() {
        return _transformFunctionName;
      },
      "transform-literals": function transformLiterals() {
        return _transformLiterals;
      },
      "transform-member-expression-literals": function transformMemberExpressionLiterals() {
        return _transformMemberExpressionLiterals;
      },
      "transform-modules-amd": function transformModulesAmd() {
        return _transformModulesAmd;
      },
      "transform-modules-commonjs": function transformModulesCommonjs() {
        return _transformModulesCommonjs;
      },
      "transform-modules-systemjs": function transformModulesSystemjs() {
        return _transformModulesSystemjs;
      },
      "transform-modules-umd": function transformModulesUmd() {
        return _transformModulesUmd;
      },
      "transform-named-capturing-groups-regex": function transformNamedCapturingGroupsRegex() {
        return _transformNamedCapturingGroupsRegex;
      },
      "transform-new-target": function transformNewTarget() {
        return _transformNewTarget;
      },
      "transform-object-super": function transformObjectSuper() {
        return _transformObjectSuper;
      },
      "transform-parameters": function transformParameters() {
        return _transformParameters;
      },
      "transform-property-literals": function transformPropertyLiterals() {
        return _transformPropertyLiterals;
      },
      "transform-regenerator": function transformRegenerator() {
        return _transformRegenerator;
      },
      "transform-reserved-words": function transformReservedWords() {
        return _transformReservedWords;
      },
      "transform-shorthand-properties": function transformShorthandProperties() {
        return _transformShorthandProperties;
      },
      "transform-spread": function transformSpread() {
        return _transformSpread;
      },
      "transform-sticky-regex": function transformStickyRegex() {
        return _transformStickyRegex;
      },
      "transform-template-literals": function transformTemplateLiterals() {
        return _transformTemplateLiterals;
      },
      "transform-typeof-symbol": function transformTypeofSymbol() {
        return _transformTypeofSymbol;
      },
      "transform-unicode-escapes": function transformUnicodeEscapes() {
        return _transformUnicodeEscapes;
      },
      "transform-unicode-regex": function transformUnicodeRegex() {
        return _transformUnicodeRegex;
      }
    };
    var minVersions = {
      "bugfix/transform-safari-id-destructuring-collision-in-function-expression": "7.16.0",
      "proposal-class-static-block": "7.12.0",
      "proposal-private-property-in-object": "7.10.0"
    };
    var has$3 = Function.call.bind(Object.hasOwnProperty);
    function removeUnnecessaryItems(items, overlapping) {
      items.forEach(function(item) {
        var _overlapping$item;
        (_overlapping$item = overlapping[item]) == null ? void 0 : _overlapping$item.forEach(function(name2) {
          return items["delete"](name2);
        });
      });
    }
    function removeUnsupportedItems(items, babelVersion) {
      items.forEach(function(item) {
        if (has$3(minVersions, item) && semver$2.lt(babelVersion, minVersions[item])) {
          items["delete"](item);
        }
      });
    }
    var moduleTransformations = {
      auto: "transform-modules-commonjs",
      amd: "transform-modules-amd",
      commonjs: "transform-modules-commonjs",
      cjs: "transform-modules-commonjs",
      systemjs: "transform-modules-systemjs",
      umd: "transform-modules-umd"
    };
    var require$$0$1 = {
      "bugfix/transform-async-arrows-in-class": {
        chrome: "55",
        opera: "42",
        edge: "15",
        firefox: "52",
        safari: "11",
        node: "7.6",
        ios: "11",
        samsung: "6",
        electron: "1.6"
      },
      "bugfix/transform-edge-default-parameters": {
        chrome: "49",
        opera: "36",
        edge: "18",
        firefox: "52",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "bugfix/transform-edge-function-name": {
        chrome: "51",
        opera: "38",
        edge: "79",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "bugfix/transform-safari-block-shadowing": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "44",
        safari: "11",
        node: "6",
        ie: "11",
        ios: "11",
        samsung: "5",
        electron: "0.37"
      },
      "bugfix/transform-safari-for-shadowing": {
        chrome: "49",
        opera: "36",
        edge: "12",
        firefox: "4",
        safari: "11",
        node: "6",
        ie: "11",
        ios: "11",
        samsung: "5",
        rhino: "1.7.13",
        electron: "0.37"
      },
      "bugfix/transform-safari-id-destructuring-collision-in-function-expression": {
        chrome: "49",
        opera: "36",
        edge: "14",
        firefox: "2",
        node: "6",
        samsung: "5",
        electron: "0.37"
      },
      "bugfix/transform-tagged-template-caching": {
        chrome: "41",
        opera: "28",
        edge: "12",
        firefox: "34",
        safari: "13",
        node: "4",
        ios: "13",
        samsung: "3.4",
        rhino: "1.7.14",
        electron: "0.21"
      },
      "bugfix/transform-v8-spread-parameters-in-optional-chaining": {
        chrome: "91",
        opera: "77",
        edge: "91",
        firefox: "74",
        safari: "13.1",
        node: "16.9",
        ios: "13.4",
        electron: "13.0"
      },
      "proposal-optional-chaining": {
        chrome: "80",
        opera: "67",
        edge: "80",
        firefox: "74",
        safari: "13.1",
        node: "14",
        ios: "13.4",
        samsung: "13",
        electron: "8.0"
      },
      "transform-parameters": {
        chrome: "49",
        opera: "36",
        edge: "15",
        firefox: "53",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      },
      "transform-async-to-generator": {
        chrome: "55",
        opera: "42",
        edge: "15",
        firefox: "52",
        safari: "10.1",
        node: "7.6",
        ios: "10.3",
        samsung: "6",
        electron: "1.6"
      },
      "transform-template-literals": {
        chrome: "41",
        opera: "28",
        edge: "13",
        firefox: "34",
        safari: "9",
        node: "4",
        ios: "9",
        samsung: "3.4",
        electron: "0.21"
      },
      "transform-function-name": {
        chrome: "51",
        opera: "38",
        edge: "14",
        firefox: "53",
        safari: "10",
        node: "6.5",
        ios: "10",
        samsung: "5",
        electron: "1.2"
      },
      "transform-block-scoping": {
        chrome: "49",
        opera: "36",
        edge: "14",
        firefox: "51",
        safari: "10",
        node: "6",
        ios: "10",
        samsung: "5",
        electron: "0.37"
      }
    };
    var pluginBugfixes = require$$0$1;
    var pluginsFiltered = {};
    var bugfixPluginsFiltered = {};
    for (var _i = 0, _Object$keys = Object.keys(plugins); _i < _Object$keys.length; _i++) {
      var plugin = _Object$keys[_i];
      if (Object.hasOwnProperty.call(availablePlugins$1, plugin)) {
        pluginsFiltered[plugin] = plugins[plugin];
      }
    }
    for (var _i2 = 0, _Object$keys2 = Object.keys(pluginBugfixes); _i2 < _Object$keys2.length; _i2++) {
      var _plugin = _Object$keys2[_i2];
      if (Object.hasOwnProperty.call(availablePlugins$1, _plugin)) {
        bugfixPluginsFiltered[_plugin] = pluginBugfixes[_plugin];
      }
    }
    var TopLevelOptions = {
      bugfixes: "bugfixes",
      configPath: "configPath",
      corejs: "corejs",
      debug: "debug",
      exclude: "exclude",
      forceAllTransforms: "forceAllTransforms",
      ignoreBrowserslistConfig: "ignoreBrowserslistConfig",
      include: "include",
      loose: "loose",
      modules: "modules",
      shippedProposals: "shippedProposals",
      spec: "spec",
      targets: "targets",
      useBuiltIns: "useBuiltIns",
      browserslistEnv: "browserslistEnv"
    };
    var ModulesOption = {
      "false": false,
      auto: "auto",
      amd: "amd",
      commonjs: "commonjs",
      cjs: "cjs",
      systemjs: "systemjs",
      umd: "umd"
    };
    var UseBuiltInsOption = {
      "false": false,
      entry: "entry",
      usage: "usage"
    };
    var corejs2DefaultWebIncludes = ["web.timers", "web.immediate", "web.dom.iterable"];
    var v$1 = new OptionValidator("@babel/preset-env");
    var allPluginsList = Object.keys(pluginsFiltered);
    var modulePlugins = ["proposal-dynamic-import"].concat(_toConsumableArray2(Object.keys(moduleTransformations).map(function(m2) {
      return moduleTransformations[m2];
    })));
    var getValidIncludesAndExcludes = function getValidIncludesAndExcludes2(type5, corejs) {
      return new Set([].concat(_toConsumableArray2(allPluginsList), _toConsumableArray2(type5 === "exclude" ? modulePlugins : []), _toConsumableArray2(corejs ? corejs == 2 ? [].concat(_toConsumableArray2(Object.keys(corejs2BuiltIns)), corejs2DefaultWebIncludes) : Object.keys(require$$0$3) : [])));
    };
    var pluginToRegExp = function pluginToRegExp2(plugin2) {
      if (plugin2 instanceof RegExp)
        return plugin2;
      try {
        return new RegExp("^" + normalizePluginName(plugin2) + "$");
      } catch (e2) {
        return null;
      }
    };
    var selectPlugins = function selectPlugins2(regexp4, type5, corejs) {
      return Array.from(getValidIncludesAndExcludes(type5, corejs)).filter(function(item) {
        return regexp4 instanceof RegExp && regexp4.test(item);
      });
    };
    var flatten = function flatten2(array4) {
      var _ref3;
      return (_ref3 = []).concat.apply(_ref3, _toConsumableArray2(array4));
    };
    var expandIncludesAndExcludes = function expandIncludesAndExcludes2(plugins2, type5, corejs) {
      if (plugins2 === void 0) {
        plugins2 = [];
      }
      if (plugins2.length === 0)
        return [];
      var selectedPlugins = plugins2.map(function(plugin2) {
        return selectPlugins(pluginToRegExp(plugin2), type5, corejs);
      });
      var invalidRegExpList = plugins2.filter(function(p2, i2) {
        return selectedPlugins[i2].length === 0;
      });
      v$1.invariant(invalidRegExpList.length === 0, "The plugins/built-ins '" + invalidRegExpList.join(", ") + "' passed to the '" + type5 + "' option are not\n    valid. Please check data/[plugin-features|built-in-features].js in babel-preset-env");
      return flatten(selectedPlugins);
    };
    var normalizePluginName = function normalizePluginName2(plugin2) {
      return plugin2.replace(/^(@babel\/|babel-)(plugin-)?/, "");
    };
    var checkDuplicateIncludeExcludes = function checkDuplicateIncludeExcludes2(include, exclude) {
      if (include === void 0) {
        include = [];
      }
      if (exclude === void 0) {
        exclude = [];
      }
      var duplicates = include.filter(function(opt) {
        return exclude.indexOf(opt) >= 0;
      });
      v$1.invariant(duplicates.length === 0, "The plugins/built-ins '" + duplicates.join(", ") + `' were found in both the "include" and
    "exclude" options.`);
    };
    var normalizeTargets = function normalizeTargets2(targets) {
      if (typeof targets === "string" || Array.isArray(targets)) {
        return {
          browsers: targets
        };
      }
      return Object.assign({}, targets);
    };
    var validateModulesOption = function validateModulesOption2(modulesOpt) {
      if (modulesOpt === void 0) {
        modulesOpt = ModulesOption.auto;
      }
      v$1.invariant(ModulesOption[modulesOpt.toString()] || modulesOpt === ModulesOption["false"], `The 'modules' option must be one of 
 - 'false' to indicate no module processing
 - a specific module type: 'commonjs', 'amd', 'umd', 'systemjs' - 'auto' (default) which will automatically select 'false' if the current
   process is known to support ES module syntax, or "commonjs" otherwise
`);
      return modulesOpt;
    };
    var validateUseBuiltInsOption = function validateUseBuiltInsOption2(builtInsOpt) {
      if (builtInsOpt === void 0) {
        builtInsOpt = false;
      }
      v$1.invariant(UseBuiltInsOption[builtInsOpt.toString()] || builtInsOpt === UseBuiltInsOption["false"], `The 'useBuiltIns' option must be either
    'false' (default) to indicate no polyfill,
    '"entry"' to indicate replacing the entry polyfill, or
    '"usage"' to import only used polyfills per file`);
      return builtInsOpt;
    };
    function normalizeCoreJSOption(corejs, useBuiltIns) {
      var proposals = false;
      var rawVersion;
      if (useBuiltIns && corejs === void 0) {
        rawVersion = 2;
        console.warn("\nWARNING (@babel/preset-env): We noticed you're using the `useBuiltIns` option without declaring a core-js version. Currently, we assume version 2.x when no version is passed. Since this default version will likely change in future versions of Babel, we recommend explicitly setting the core-js version you are using via the `corejs` option.\n\nYou should also be sure that the version you pass to the `corejs` option matches the version specified in your `package.json`'s `dependencies` section. If it doesn't, you need to run one of the following commands:\n\n  npm install --save core-js@2    npm install --save core-js@3\n  yarn add core-js@2              yarn add core-js@3\n\nMore info about useBuiltIns: https://babeljs.io/docs/en/babel-preset-env#usebuiltins\nMore info about core-js: https://babeljs.io/docs/en/babel-preset-env#corejs");
      } else if (typeof corejs === "object" && corejs !== null) {
        rawVersion = corejs.version;
        proposals = Boolean(corejs.proposals);
      } else {
        rawVersion = corejs;
      }
      var version3 = rawVersion ? semver$2.coerce(String(rawVersion)) : false;
      if (!useBuiltIns && version3) {
        console.warn("\nWARNING (@babel/preset-env): The `corejs` option only has an effect when the `useBuiltIns` option is not `false`\n");
      }
      if (useBuiltIns && (!version3 || version3.major < 2 || version3.major > 3)) {
        throw new RangeError("Invalid Option: The version passed to `corejs` is invalid. Currently, only core-js@2 and core-js@3 are supported.");
      }
      return {
        version: version3,
        proposals
      };
    }
    function normalizeOptions$3(opts) {
      v$1.validateTopLevelOptions(opts, TopLevelOptions);
      var useBuiltIns = validateUseBuiltInsOption(opts.useBuiltIns);
      var corejs = normalizeCoreJSOption(opts.corejs, useBuiltIns);
      var include = expandIncludesAndExcludes(opts.include, TopLevelOptions.include, !!corejs.version && corejs.version.major);
      var exclude = expandIncludesAndExcludes(opts.exclude, TopLevelOptions.exclude, !!corejs.version && corejs.version.major);
      checkDuplicateIncludeExcludes(include, exclude);
      return {
        bugfixes: v$1.validateBooleanOption(TopLevelOptions.bugfixes, opts.bugfixes, false),
        configPath: v$1.validateStringOption(TopLevelOptions.configPath, opts.configPath, browser$1$1.cwd()),
        corejs,
        debug: v$1.validateBooleanOption(TopLevelOptions.debug, opts.debug, false),
        include,
        exclude,
        forceAllTransforms: v$1.validateBooleanOption(TopLevelOptions.forceAllTransforms, opts.forceAllTransforms, false),
        ignoreBrowserslistConfig: v$1.validateBooleanOption(TopLevelOptions.ignoreBrowserslistConfig, opts.ignoreBrowserslistConfig, false),
        loose: v$1.validateBooleanOption(TopLevelOptions.loose, opts.loose),
        modules: validateModulesOption(opts.modules),
        shippedProposals: v$1.validateBooleanOption(TopLevelOptions.shippedProposals, opts.shippedProposals, false),
        spec: v$1.validateBooleanOption(TopLevelOptions.spec, opts.spec, false),
        targets: normalizeTargets(opts.targets),
        useBuiltIns,
        browserslistEnv: v$1.validateStringOption(TopLevelOptions.browserslistEnv, opts.browserslistEnv)
      };
    }
    var proposalPlugins = /* @__PURE__ */ new Set();
    var pluginSyntaxObject = {
      "proposal-async-generator-functions": "syntax-async-generators",
      "proposal-class-properties": "syntax-class-properties",
      "proposal-class-static-block": "syntax-class-static-block",
      "proposal-json-strings": "syntax-json-strings",
      "proposal-nullish-coalescing-operator": "syntax-nullish-coalescing-operator",
      "proposal-numeric-separator": "syntax-numeric-separator",
      "proposal-object-rest-spread": "syntax-object-rest-spread",
      "proposal-optional-catch-binding": "syntax-optional-catch-binding",
      "proposal-optional-chaining": "syntax-optional-chaining",
      "proposal-private-methods": "syntax-class-properties",
      "proposal-private-property-in-object": "syntax-private-property-in-object",
      "proposal-unicode-property-regex": null
    };
    var pluginSyntaxEntries = Object.keys(pluginSyntaxObject).map(function(key2) {
      return [key2, pluginSyntaxObject[key2]];
    });
    var pluginSyntaxMap = new Map(pluginSyntaxEntries);
    var shippedProposals = {
      pluginSyntaxMap,
      proposalPlugins
    };
    var require$$0 = {
      "transform-async-to-generator": [
        "bugfix/transform-async-arrows-in-class"
      ],
      "transform-parameters": [
        "bugfix/transform-edge-default-parameters",
        "bugfix/transform-safari-id-destructuring-collision-in-function-expression"
      ],
      "transform-function-name": [
        "bugfix/transform-edge-function-name"
      ],
      "transform-block-scoping": [
        "bugfix/transform-safari-block-shadowing",
        "bugfix/transform-safari-for-shadowing"
      ],
      "transform-template-literals": [
        "bugfix/transform-tagged-template-caching"
      ],
      "proposal-optional-chaining": [
        "bugfix/transform-v8-spread-parameters-in-optional-chaining"
      ]
    };
    var overlappingPlugins = require$$0;
    var isCallExpression = isCallExpression$7, isExpressionStatement = isExpressionStatement$4, isIdentifier = isIdentifier$i, isStringLiteral = isStringLiteral$7;
    function getImportSource$1(_ref3) {
      var node2 = _ref3.node;
      if (node2.specifiers.length === 0)
        return node2.source.value;
    }
    function getRequireSource$1(_ref22) {
      var node2 = _ref22.node;
      if (!isExpressionStatement(node2))
        return;
      var expression2 = node2.expression;
      if (isCallExpression(expression2) && isIdentifier(expression2.callee) && expression2.callee.name === "require" && expression2.arguments.length === 1 && isStringLiteral(expression2.arguments[0])) {
        return expression2.arguments[0].value;
      }
    }
    function isPolyfillSource(source) {
      return source === "@babel/polyfill" || source === "core-js";
    }
    function isRegeneratorSource(source) {
      return source === "regenerator-runtime/runtime" || source === "regenerator-runtime/runtime.js";
    }
    function removeRegeneratorEntryPlugin() {
      var visitor2 = {
        ImportDeclaration: function ImportDeclaration2(path2) {
          if (isRegeneratorSource(getImportSource$1(path2))) {
            this.regeneratorImportExcluded = true;
            path2.remove();
          }
        },
        Program: function Program2(path2) {
          var _this = this;
          path2.get("body").forEach(function(bodyPath) {
            if (isRegeneratorSource(getRequireSource$1(bodyPath))) {
              _this.regeneratorImportExcluded = true;
              bodyPath.remove();
            }
          });
        }
      };
      return {
        name: "preset-env/remove-regenerator",
        visitor: visitor2,
        pre: function pre() {
          this.regeneratorImportExcluded = false;
        },
        post: function post() {
          if (this.opts.debug && this.regeneratorImportExcluded) {
            var filename = this.file.opts.filename;
            if (browser$1$1.env.BABEL_ENV === "test") {
              filename = filename.replace(/\\/g, "/");
            }
            console.log("\n[" + filename + "] Based on your targets, regenerator-runtime import excluded.");
          }
        }
      };
    }
    var _templateObject$1, _templateObject2$1, _templateObject3$1, _templateObject4;
    var BABEL_POLYFILL_DEPRECATION = "\n  `@babel/polyfill` is deprecated. Please, use required parts of `core-js`\n  and `regenerator-runtime/runtime` separately";
    var NO_DIRECT_POLYFILL_IMPORT = "\n  When setting `useBuiltIns: 'usage'`, polyfills are automatically imported when needed.\n  Please remove the direct import of `SPECIFIER` or use `useBuiltIns: 'entry'` instead.";
    function legacyBabelPolyfillPlugin(_ref3, _ref22) {
      var template2 = _ref3.template;
      var regenerator3 = _ref22.regenerator, deprecated = _ref22.deprecated, usage2 = _ref22.usage;
      return {
        name: "preset-env/replace-babel-polyfill",
        visitor: {
          ImportDeclaration: function(_ImportDeclaration) {
            function ImportDeclaration2(_x) {
              return _ImportDeclaration.apply(this, arguments);
            }
            ImportDeclaration2.toString = function() {
              return _ImportDeclaration.toString();
            };
            return ImportDeclaration2;
          }(function(path2) {
            var src2 = getImportSource$1(path2);
            if (usage2 && isPolyfillSource(src2)) {
              console.warn(NO_DIRECT_POLYFILL_IMPORT.replace("SPECIFIER", src2));
              if (!deprecated)
                path2.remove();
            } else if (src2 === "@babel/polyfill") {
              if (deprecated) {
                console.warn(BABEL_POLYFILL_DEPRECATION);
              } else if (regenerator3) {
                path2.replaceWithMultiple(template2.ast(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteralLoose(['\n              import "core-js";\n              import "regenerator-runtime/runtime.js";\n            ']))));
              } else {
                path2.replaceWith(template2.ast(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteralLoose(['\n              import "core-js";\n            ']))));
              }
            }
          }),
          Program: function(_Program) {
            function Program2(_x2) {
              return _Program.apply(this, arguments);
            }
            Program2.toString = function() {
              return _Program.toString();
            };
            return Program2;
          }(function(path2) {
            path2.get("body").forEach(function(bodyPath) {
              var src2 = getRequireSource$1(bodyPath);
              if (usage2 && isPolyfillSource(src2)) {
                console.warn(NO_DIRECT_POLYFILL_IMPORT.replace("SPECIFIER", src2));
                if (!deprecated)
                  bodyPath.remove();
              } else if (src2 === "@babel/polyfill") {
                if (deprecated) {
                  console.warn(BABEL_POLYFILL_DEPRECATION);
                } else if (regenerator3) {
                  bodyPath.replaceWithMultiple(template2.ast(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteralLoose(['\n                require("core-js");\n                require("regenerator-runtime/runtime.js");\n              ']))));
                } else {
                  bodyPath.replaceWith(template2.ast(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(['\n                require("core-js");\n              ']))));
                }
              }
            });
          })
        }
      };
    }
    var semver$1 = { exports: {} };
    (function(module2, exports3) {
      exports3 = module2.exports = SemVer2;
      var debug2;
      if (typeof browser$1$1 === "object" && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
        debug2 = function debug3() {
          var args = Array.prototype.slice.call(arguments, 0);
          args.unshift("SEMVER");
          console.log.apply(console, args);
        };
      } else {
        debug2 = function debug3() {
        };
      }
      exports3.SEMVER_SPEC_VERSION = "2.0.0";
      var MAX_LENGTH2 = 256;
      var MAX_SAFE_INTEGER3 = Number.MAX_SAFE_INTEGER || 9007199254740991;
      var MAX_SAFE_COMPONENT_LENGTH2 = 16;
      var re3 = exports3.re = [];
      var src2 = exports3.src = [];
      var t3 = exports3.tokens = {};
      var R2 = 0;
      function tok(n2) {
        t3[n2] = R2++;
      }
      tok("NUMERICIDENTIFIER");
      src2[t3.NUMERICIDENTIFIER] = "0|[1-9]\\d*";
      tok("NUMERICIDENTIFIERLOOSE");
      src2[t3.NUMERICIDENTIFIERLOOSE] = "[0-9]+";
      tok("NONNUMERICIDENTIFIER");
      src2[t3.NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
      tok("MAINVERSION");
      src2[t3.MAINVERSION] = "(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")\\.(" + src2[t3.NUMERICIDENTIFIER] + ")";
      tok("MAINVERSIONLOOSE");
      src2[t3.MAINVERSIONLOOSE] = "(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src2[t3.NUMERICIDENTIFIERLOOSE] + ")";
      tok("PRERELEASEIDENTIFIER");
      src2[t3.PRERELEASEIDENTIFIER] = "(?:" + src2[t3.NUMERICIDENTIFIER] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
      tok("PRERELEASEIDENTIFIERLOOSE");
      src2[t3.PRERELEASEIDENTIFIERLOOSE] = "(?:" + src2[t3.NUMERICIDENTIFIERLOOSE] + "|" + src2[t3.NONNUMERICIDENTIFIER] + ")";
      tok("PRERELEASE");
      src2[t3.PRERELEASE] = "(?:-(" + src2[t3.PRERELEASEIDENTIFIER] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIER] + ")*))";
      tok("PRERELEASELOOSE");
      src2[t3.PRERELEASELOOSE] = "(?:-?(" + src2[t3.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src2[t3.PRERELEASEIDENTIFIERLOOSE] + ")*))";
      tok("BUILDIDENTIFIER");
      src2[t3.BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
      tok("BUILD");
      src2[t3.BUILD] = "(?:\\+(" + src2[t3.BUILDIDENTIFIER] + "(?:\\." + src2[t3.BUILDIDENTIFIER] + ")*))";
      tok("FULL");
      tok("FULLPLAIN");
      src2[t3.FULLPLAIN] = "v?" + src2[t3.MAINVERSION] + src2[t3.PRERELEASE] + "?" + src2[t3.BUILD] + "?";
      src2[t3.FULL] = "^" + src2[t3.FULLPLAIN] + "$";
      tok("LOOSEPLAIN");
      src2[t3.LOOSEPLAIN] = "[v=\\s]*" + src2[t3.MAINVERSIONLOOSE] + src2[t3.PRERELEASELOOSE] + "?" + src2[t3.BUILD] + "?";
      tok("LOOSE");
      src2[t3.LOOSE] = "^" + src2[t3.LOOSEPLAIN] + "$";
      tok("GTLT");
      src2[t3.GTLT] = "((?:<|>)?=?)";
      tok("XRANGEIDENTIFIERLOOSE");
      src2[t3.XRANGEIDENTIFIERLOOSE] = src2[t3.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
      tok("XRANGEIDENTIFIER");
      src2[t3.XRANGEIDENTIFIER] = src2[t3.NUMERICIDENTIFIER] + "|x|X|\\*";
      tok("XRANGEPLAIN");
      src2[t3.XRANGEPLAIN] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIER] + ")(?:" + src2[t3.PRERELEASE] + ")?" + src2[t3.BUILD] + "?)?)?";
      tok("XRANGEPLAINLOOSE");
      src2[t3.XRANGEPLAINLOOSE] = "[v=\\s]*(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src2[t3.XRANGEIDENTIFIERLOOSE] + ")(?:" + src2[t3.PRERELEASELOOSE] + ")?" + src2[t3.BUILD] + "?)?)?";
      tok("XRANGE");
      src2[t3.XRANGE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAIN] + "$";
      tok("XRANGELOOSE");
      src2[t3.XRANGELOOSE] = "^" + src2[t3.GTLT] + "\\s*" + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("COERCE");
      src2[t3.COERCE] = "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH2 + "}))?(?:$|[^\\d])";
      tok("COERCERTL");
      re3[t3.COERCERTL] = new RegExp(src2[t3.COERCE], "g");
      tok("LONETILDE");
      src2[t3.LONETILDE] = "(?:~>?)";
      tok("TILDETRIM");
      src2[t3.TILDETRIM] = "(\\s*)" + src2[t3.LONETILDE] + "\\s+";
      re3[t3.TILDETRIM] = new RegExp(src2[t3.TILDETRIM], "g");
      var tildeTrimReplace = "$1~";
      tok("TILDE");
      src2[t3.TILDE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAIN] + "$";
      tok("TILDELOOSE");
      src2[t3.TILDELOOSE] = "^" + src2[t3.LONETILDE] + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("LONECARET");
      src2[t3.LONECARET] = "(?:\\^)";
      tok("CARETTRIM");
      src2[t3.CARETTRIM] = "(\\s*)" + src2[t3.LONECARET] + "\\s+";
      re3[t3.CARETTRIM] = new RegExp(src2[t3.CARETTRIM], "g");
      var caretTrimReplace = "$1^";
      tok("CARET");
      src2[t3.CARET] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAIN] + "$";
      tok("CARETLOOSE");
      src2[t3.CARETLOOSE] = "^" + src2[t3.LONECARET] + src2[t3.XRANGEPLAINLOOSE] + "$";
      tok("COMPARATORLOOSE");
      src2[t3.COMPARATORLOOSE] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + ")$|^$";
      tok("COMPARATOR");
      src2[t3.COMPARATOR] = "^" + src2[t3.GTLT] + "\\s*(" + src2[t3.FULLPLAIN] + ")$|^$";
      tok("COMPARATORTRIM");
      src2[t3.COMPARATORTRIM] = "(\\s*)" + src2[t3.GTLT] + "\\s*(" + src2[t3.LOOSEPLAIN] + "|" + src2[t3.XRANGEPLAIN] + ")";
      re3[t3.COMPARATORTRIM] = new RegExp(src2[t3.COMPARATORTRIM], "g");
      var comparatorTrimReplace = "$1$2$3";
      tok("HYPHENRANGE");
      src2[t3.HYPHENRANGE] = "^\\s*(" + src2[t3.XRANGEPLAIN] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAIN] + ")\\s*$";
      tok("HYPHENRANGELOOSE");
      src2[t3.HYPHENRANGELOOSE] = "^\\s*(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src2[t3.XRANGEPLAINLOOSE] + ")\\s*$";
      tok("STAR");
      src2[t3.STAR] = "(<|>)?=?\\s*\\*";
      for (var i2 = 0; i2 < R2; i2++) {
        debug2(i2, src2[i2]);
        if (!re3[i2]) {
          re3[i2] = new RegExp(src2[i2]);
        }
      }
      exports3.parse = parse5;
      function parse5(version3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (version3 instanceof SemVer2) {
          return version3;
        }
        if (typeof version3 !== "string") {
          return null;
        }
        if (version3.length > MAX_LENGTH2) {
          return null;
        }
        var r2 = options.loose ? re3[t3.LOOSE] : re3[t3.FULL];
        if (!r2.test(version3)) {
          return null;
        }
        try {
          return new SemVer2(version3, options);
        } catch (er) {
          return null;
        }
      }
      exports3.valid = valid;
      function valid(version3, options) {
        var v22 = parse5(version3, options);
        return v22 ? v22.version : null;
      }
      exports3.clean = clean;
      function clean(version3, options) {
        var s = parse5(version3.trim().replace(/^[=v]+/, ""), options);
        return s ? s.version : null;
      }
      exports3.SemVer = SemVer2;
      function SemVer2(version3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (version3 instanceof SemVer2) {
          if (version3.loose === options.loose) {
            return version3;
          } else {
            version3 = version3.version;
          }
        } else if (typeof version3 !== "string") {
          throw new TypeError("Invalid Version: " + version3);
        }
        if (version3.length > MAX_LENGTH2) {
          throw new TypeError("version is longer than " + MAX_LENGTH2 + " characters");
        }
        if (!(this instanceof SemVer2)) {
          return new SemVer2(version3, options);
        }
        debug2("SemVer", version3, options);
        this.options = options;
        this.loose = !!options.loose;
        var m2 = version3.trim().match(options.loose ? re3[t3.LOOSE] : re3[t3.FULL]);
        if (!m2) {
          throw new TypeError("Invalid Version: " + version3);
        }
        this.raw = version3;
        this.major = +m2[1];
        this.minor = +m2[2];
        this.patch = +m2[3];
        if (this.major > MAX_SAFE_INTEGER3 || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER3 || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER3 || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m2[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m2[4].split(".").map(function(id3) {
            if (/^[0-9]+$/.test(id3)) {
              var num = +id3;
              if (num >= 0 && num < MAX_SAFE_INTEGER3) {
                return num;
              }
            }
            return id3;
          });
        }
        this.build = m2[5] ? m2[5].split(".") : [];
        this.format();
      }
      SemVer2.prototype.format = function() {
        this.version = this.major + "." + this.minor + "." + this.patch;
        if (this.prerelease.length) {
          this.version += "-" + this.prerelease.join(".");
        }
        return this.version;
      };
      SemVer2.prototype.toString = function() {
        return this.version;
      };
      SemVer2.prototype.compare = function(other) {
        debug2("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        return this.compareMain(other) || this.comparePre(other);
      };
      SemVer2.prototype.compareMain = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        return compareIdentifiers2(this.major, other.major) || compareIdentifiers2(this.minor, other.minor) || compareIdentifiers2(this.patch, other.patch);
      };
      SemVer2.prototype.comparePre = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        var i3 = 0;
        do {
          var a = this.prerelease[i3];
          var b2 = other.prerelease[i3];
          debug2("prerelease compare", i3, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers2(a, b2);
          }
        } while (++i3);
      };
      SemVer2.prototype.compareBuild = function(other) {
        if (!(other instanceof SemVer2)) {
          other = new SemVer2(other, this.options);
        }
        var i3 = 0;
        do {
          var a = this.build[i3];
          var b2 = other.build[i3];
          debug2("prerelease compare", i3, a, b2);
          if (a === void 0 && b2 === void 0) {
            return 0;
          } else if (b2 === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b2) {
            continue;
          } else {
            return compareIdentifiers2(a, b2);
          }
        } while (++i3);
      };
      SemVer2.prototype.inc = function(release3, identifier2) {
        switch (release3) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier2);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier2);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier2);
            this.inc("pre", identifier2);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier2);
            }
            this.inc("pre", identifier2);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre":
            if (this.prerelease.length === 0) {
              this.prerelease = [0];
            } else {
              var i3 = this.prerelease.length;
              while (--i3 >= 0) {
                if (typeof this.prerelease[i3] === "number") {
                  this.prerelease[i3]++;
                  i3 = -2;
                }
              }
              if (i3 === -1) {
                this.prerelease.push(0);
              }
            }
            if (identifier2) {
              if (this.prerelease[0] === identifier2) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = [identifier2, 0];
                }
              } else {
                this.prerelease = [identifier2, 0];
              }
            }
            break;
          default:
            throw new Error("invalid increment argument: " + release3);
        }
        this.format();
        this.raw = this.version;
        return this;
      };
      exports3.inc = inc;
      function inc(version3, release3, loose, identifier2) {
        if (typeof loose === "string") {
          identifier2 = loose;
          loose = void 0;
        }
        try {
          return new SemVer2(version3, loose).inc(release3, identifier2).version;
        } catch (er) {
          return null;
        }
      }
      exports3.diff = diff;
      function diff(version1, version22) {
        if (eq3(version1, version22)) {
          return null;
        } else {
          var v110 = parse5(version1);
          var v22 = parse5(version22);
          var prefix2 = "";
          if (v110.prerelease.length || v22.prerelease.length) {
            prefix2 = "pre";
            var defaultResult = "prerelease";
          }
          for (var key2 in v110) {
            if (key2 === "major" || key2 === "minor" || key2 === "patch") {
              if (v110[key2] !== v22[key2]) {
                return prefix2 + key2;
              }
            }
          }
          return defaultResult;
        }
      }
      exports3.compareIdentifiers = compareIdentifiers2;
      var numeric2 = /^[0-9]+$/;
      function compareIdentifiers2(a, b2) {
        var anum = numeric2.test(a);
        var bnum = numeric2.test(b2);
        if (anum && bnum) {
          a = +a;
          b2 = +b2;
        }
        return a === b2 ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b2 ? -1 : 1;
      }
      exports3.rcompareIdentifiers = rcompareIdentifiers2;
      function rcompareIdentifiers2(a, b2) {
        return compareIdentifiers2(b2, a);
      }
      exports3.major = major;
      function major(a, loose) {
        return new SemVer2(a, loose).major;
      }
      exports3.minor = minor;
      function minor(a, loose) {
        return new SemVer2(a, loose).minor;
      }
      exports3.patch = patch2;
      function patch2(a, loose) {
        return new SemVer2(a, loose).patch;
      }
      exports3.compare = compare3;
      function compare3(a, b2, loose) {
        return new SemVer2(a, loose).compare(new SemVer2(b2, loose));
      }
      exports3.compareLoose = compareLoose;
      function compareLoose(a, b2) {
        return compare3(a, b2, true);
      }
      exports3.compareBuild = compareBuild;
      function compareBuild(a, b2, loose) {
        var versionA = new SemVer2(a, loose);
        var versionB = new SemVer2(b2, loose);
        return versionA.compare(versionB) || versionA.compareBuild(versionB);
      }
      exports3.rcompare = rcompare;
      function rcompare(a, b2, loose) {
        return compare3(b2, a, loose);
      }
      exports3.sort = sort2;
      function sort2(list2, loose) {
        return list2.sort(function(a, b2) {
          return exports3.compareBuild(a, b2, loose);
        });
      }
      exports3.rsort = rsort;
      function rsort(list2, loose) {
        return list2.sort(function(a, b2) {
          return exports3.compareBuild(b2, a, loose);
        });
      }
      exports3.gt = gt2;
      function gt2(a, b2, loose) {
        return compare3(a, b2, loose) > 0;
      }
      exports3.lt = lt3;
      function lt3(a, b2, loose) {
        return compare3(a, b2, loose) < 0;
      }
      exports3.eq = eq3;
      function eq3(a, b2, loose) {
        return compare3(a, b2, loose) === 0;
      }
      exports3.neq = neq2;
      function neq2(a, b2, loose) {
        return compare3(a, b2, loose) !== 0;
      }
      exports3.gte = gte2;
      function gte2(a, b2, loose) {
        return compare3(a, b2, loose) >= 0;
      }
      exports3.lte = lte2;
      function lte2(a, b2, loose) {
        return compare3(a, b2, loose) <= 0;
      }
      exports3.cmp = cmp2;
      function cmp2(a, op, b2, loose) {
        switch (op) {
          case "===":
            if (typeof a === "object")
              a = a.version;
            if (typeof b2 === "object")
              b2 = b2.version;
            return a === b2;
          case "!==":
            if (typeof a === "object")
              a = a.version;
            if (typeof b2 === "object")
              b2 = b2.version;
            return a !== b2;
          case "":
          case "=":
          case "==":
            return eq3(a, b2, loose);
          case "!=":
            return neq2(a, b2, loose);
          case ">":
            return gt2(a, b2, loose);
          case ">=":
            return gte2(a, b2, loose);
          case "<":
            return lt3(a, b2, loose);
          case "<=":
            return lte2(a, b2, loose);
          default:
            throw new TypeError("Invalid operator: " + op);
        }
      }
      exports3.Comparator = Comparator;
      function Comparator(comp, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (comp instanceof Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        if (!(this instanceof Comparator)) {
          return new Comparator(comp, options);
        }
        debug2("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug2("comp", this);
      }
      var ANY = {};
      Comparator.prototype.parse = function(comp) {
        var r2 = this.options.loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
        var m2 = comp.match(r2);
        if (!m2) {
          throw new TypeError("Invalid comparator: " + comp);
        }
        this.operator = m2[1] !== void 0 ? m2[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m2[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer2(m2[2], this.options.loose);
        }
      };
      Comparator.prototype.toString = function() {
        return this.value;
      };
      Comparator.prototype.test = function(version3) {
        debug2("Comparator.test", version3, this.options.loose);
        if (this.semver === ANY || version3 === ANY) {
          return true;
        }
        if (typeof version3 === "string") {
          try {
            version3 = new SemVer2(version3, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp2(version3, this.operator, this.semver, this.options);
      };
      Comparator.prototype.intersects = function(comp, options) {
        if (!(comp instanceof Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        var rangeTmp;
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          rangeTmp = new Range(comp.value, options);
          return satisfies(this.value, rangeTmp, options);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          rangeTmp = new Range(this.value, options);
          return satisfies(comp.semver, rangeTmp, options);
        }
        var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
        var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
        var sameSemVer = this.semver.version === comp.semver.version;
        var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
        var oppositeDirectionsLessThan = cmp2(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
        var oppositeDirectionsGreaterThan = cmp2(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
      };
      exports3.Range = Range;
      function Range(range3, options) {
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (range3 instanceof Range) {
          if (range3.loose === !!options.loose && range3.includePrerelease === !!options.includePrerelease) {
            return range3;
          } else {
            return new Range(range3.raw, options);
          }
        }
        if (range3 instanceof Comparator) {
          return new Range(range3.value, options);
        }
        if (!(this instanceof Range)) {
          return new Range(range3, options);
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range3;
        this.set = range3.split(/\s*\|\|\s*/).map(function(range4) {
          return this.parseRange(range4.trim());
        }, this).filter(function(c2) {
          return c2.length;
        });
        if (!this.set.length) {
          throw new TypeError("Invalid SemVer Range: " + range3);
        }
        this.format();
      }
      Range.prototype.format = function() {
        this.range = this.set.map(function(comps) {
          return comps.join(" ").trim();
        }).join("||").trim();
        return this.range;
      };
      Range.prototype.toString = function() {
        return this.range;
      };
      Range.prototype.parseRange = function(range3) {
        var loose = this.options.loose;
        range3 = range3.trim();
        var hr = loose ? re3[t3.HYPHENRANGELOOSE] : re3[t3.HYPHENRANGE];
        range3 = range3.replace(hr, hyphenReplace);
        debug2("hyphen replace", range3);
        range3 = range3.replace(re3[t3.COMPARATORTRIM], comparatorTrimReplace);
        debug2("comparator trim", range3, re3[t3.COMPARATORTRIM]);
        range3 = range3.replace(re3[t3.TILDETRIM], tildeTrimReplace);
        range3 = range3.replace(re3[t3.CARETTRIM], caretTrimReplace);
        range3 = range3.split(/\s+/).join(" ");
        var compRe = loose ? re3[t3.COMPARATORLOOSE] : re3[t3.COMPARATOR];
        var set3 = range3.split(" ").map(function(comp) {
          return parseComparator(comp, this.options);
        }, this).join(" ").split(/\s+/);
        if (this.options.loose) {
          set3 = set3.filter(function(comp) {
            return !!comp.match(compRe);
          });
        }
        set3 = set3.map(function(comp) {
          return new Comparator(comp, this.options);
        }, this);
        return set3;
      };
      Range.prototype.intersects = function(range3, options) {
        if (!(range3 instanceof Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some(function(thisComparators) {
          return isSatisfiable(thisComparators, options) && range3.set.some(function(rangeComparators) {
            return isSatisfiable(rangeComparators, options) && thisComparators.every(function(thisComparator) {
              return rangeComparators.every(function(rangeComparator) {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      };
      function isSatisfiable(comparators, options) {
        var result = true;
        var remainingComparators = comparators.slice();
        var testComparator = remainingComparators.pop();
        while (result && remainingComparators.length) {
          result = remainingComparators.every(function(otherComparator) {
            return testComparator.intersects(otherComparator, options);
          });
          testComparator = remainingComparators.pop();
        }
        return result;
      }
      exports3.toComparators = toComparators;
      function toComparators(range3, options) {
        return new Range(range3, options).set.map(function(comp) {
          return comp.map(function(c2) {
            return c2.value;
          }).join(" ").trim().split(" ");
        });
      }
      function parseComparator(comp, options) {
        debug2("comp", comp, options);
        comp = replaceCarets(comp, options);
        debug2("caret", comp);
        comp = replaceTildes(comp, options);
        debug2("tildes", comp);
        comp = replaceXRanges(comp, options);
        debug2("xrange", comp);
        comp = replaceStars(comp, options);
        debug2("stars", comp);
        return comp;
      }
      function isX(id3) {
        return !id3 || id3.toLowerCase() === "x" || id3 === "*";
      }
      function replaceTildes(comp, options) {
        return comp.trim().split(/\s+/).map(function(comp2) {
          return replaceTilde(comp2, options);
        }).join(" ");
      }
      function replaceTilde(comp, options) {
        var r2 = options.loose ? re3[t3.TILDELOOSE] : re3[t3.TILDE];
        return comp.replace(r2, function(_, M2, m2, p2, pr) {
          debug2("tilde", comp, _, M2, m2, p2, pr);
          var ret;
          if (isX(M2)) {
            ret = "";
          } else if (isX(m2)) {
            ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
          } else if (isX(p2)) {
            ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
          } else if (pr) {
            debug2("replaceTilde pr", pr);
            ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
          } else {
            ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
          }
          debug2("tilde return", ret);
          return ret;
        });
      }
      function replaceCarets(comp, options) {
        return comp.trim().split(/\s+/).map(function(comp2) {
          return replaceCaret(comp2, options);
        }).join(" ");
      }
      function replaceCaret(comp, options) {
        debug2("caret", comp, options);
        var r2 = options.loose ? re3[t3.CARETLOOSE] : re3[t3.CARET];
        return comp.replace(r2, function(_, M2, m2, p2, pr) {
          debug2("caret", comp, _, M2, m2, p2, pr);
          var ret;
          if (isX(M2)) {
            ret = "";
          } else if (isX(m2)) {
            ret = ">=" + M2 + ".0.0 <" + (+M2 + 1) + ".0.0";
          } else if (isX(p2)) {
            if (M2 === "0") {
              ret = ">=" + M2 + "." + m2 + ".0 <" + M2 + "." + (+m2 + 1) + ".0";
            } else {
              ret = ">=" + M2 + "." + m2 + ".0 <" + (+M2 + 1) + ".0.0";
            }
          } else if (pr) {
            debug2("replaceCaret pr", pr);
            if (M2 === "0") {
              if (m2 === "0") {
                ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + m2 + "." + (+p2 + 1);
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + M2 + "." + (+m2 + 1) + ".0";
              }
            } else {
              ret = ">=" + M2 + "." + m2 + "." + p2 + "-" + pr + " <" + (+M2 + 1) + ".0.0";
            }
          } else {
            debug2("no pr");
            if (M2 === "0") {
              if (m2 === "0") {
                ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + m2 + "." + (+p2 + 1);
              } else {
                ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + M2 + "." + (+m2 + 1) + ".0";
              }
            } else {
              ret = ">=" + M2 + "." + m2 + "." + p2 + " <" + (+M2 + 1) + ".0.0";
            }
          }
          debug2("caret return", ret);
          return ret;
        });
      }
      function replaceXRanges(comp, options) {
        debug2("replaceXRanges", comp, options);
        return comp.split(/\s+/).map(function(comp2) {
          return replaceXRange(comp2, options);
        }).join(" ");
      }
      function replaceXRange(comp, options) {
        comp = comp.trim();
        var r2 = options.loose ? re3[t3.XRANGELOOSE] : re3[t3.XRANGE];
        return comp.replace(r2, function(ret, gtlt, M2, m2, p2, pr) {
          debug2("xRange", comp, ret, gtlt, M2, m2, p2, pr);
          var xM = isX(M2);
          var xm = xM || isX(m2);
          var xp = xm || isX(p2);
          var anyX = xp;
          if (gtlt === "=" && anyX) {
            gtlt = "";
          }
          pr = options.includePrerelease ? "-0" : "";
          if (xM) {
            if (gtlt === ">" || gtlt === "<") {
              ret = "<0.0.0-0";
            } else {
              ret = "*";
            }
          } else if (gtlt && anyX) {
            if (xm) {
              m2 = 0;
            }
            p2 = 0;
            if (gtlt === ">") {
              gtlt = ">=";
              if (xm) {
                M2 = +M2 + 1;
                m2 = 0;
                p2 = 0;
              } else {
                m2 = +m2 + 1;
                p2 = 0;
              }
            } else if (gtlt === "<=") {
              gtlt = "<";
              if (xm) {
                M2 = +M2 + 1;
              } else {
                m2 = +m2 + 1;
              }
            }
            ret = gtlt + M2 + "." + m2 + "." + p2 + pr;
          } else if (xm) {
            ret = ">=" + M2 + ".0.0" + pr + " <" + (+M2 + 1) + ".0.0" + pr;
          } else if (xp) {
            ret = ">=" + M2 + "." + m2 + ".0" + pr + " <" + M2 + "." + (+m2 + 1) + ".0" + pr;
          }
          debug2("xRange return", ret);
          return ret;
        });
      }
      function replaceStars(comp, options) {
        debug2("replaceStars", comp, options);
        return comp.trim().replace(re3[t3.STAR], "");
      }
      function hyphenReplace($0, from2, fM, fm, fp, fpr, fb2, to, tM, tm, tp, tpr, tb2) {
        if (isX(fM)) {
          from2 = "";
        } else if (isX(fm)) {
          from2 = ">=" + fM + ".0.0";
        } else if (isX(fp)) {
          from2 = ">=" + fM + "." + fm + ".0";
        } else {
          from2 = ">=" + from2;
        }
        if (isX(tM)) {
          to = "";
        } else if (isX(tm)) {
          to = "<" + (+tM + 1) + ".0.0";
        } else if (isX(tp)) {
          to = "<" + tM + "." + (+tm + 1) + ".0";
        } else if (tpr) {
          to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
        } else {
          to = "<=" + to;
        }
        return (from2 + " " + to).trim();
      }
      Range.prototype.test = function(version3) {
        if (!version3) {
          return false;
        }
        if (typeof version3 === "string") {
          try {
            version3 = new SemVer2(version3, this.options);
          } catch (er) {
            return false;
          }
        }
        for (var i3 = 0; i3 < this.set.length; i3++) {
          if (testSet(this.set[i3], version3, this.options)) {
            return true;
          }
        }
        return false;
      };
      function testSet(set3, version3, options) {
        for (var i3 = 0; i3 < set3.length; i3++) {
          if (!set3[i3].test(version3)) {
            return false;
          }
        }
        if (version3.prerelease.length && !options.includePrerelease) {
          for (i3 = 0; i3 < set3.length; i3++) {
            debug2(set3[i3].semver);
            if (set3[i3].semver === ANY) {
              continue;
            }
            if (set3[i3].semver.prerelease.length > 0) {
              var allowed = set3[i3].semver;
              if (allowed.major === version3.major && allowed.minor === version3.minor && allowed.patch === version3.patch) {
                return true;
              }
            }
          }
          return false;
        }
        return true;
      }
      exports3.satisfies = satisfies;
      function satisfies(version3, range3, options) {
        try {
          range3 = new Range(range3, options);
        } catch (er) {
          return false;
        }
        return range3.test(version3);
      }
      exports3.maxSatisfying = maxSatisfying;
      function maxSatisfying(versions2, range3, options) {
        var max3 = null;
        var maxSV = null;
        try {
          var rangeObj = new Range(range3, options);
        } catch (er) {
          return null;
        }
        versions2.forEach(function(v22) {
          if (rangeObj.test(v22)) {
            if (!max3 || maxSV.compare(v22) === -1) {
              max3 = v22;
              maxSV = new SemVer2(max3, options);
            }
          }
        });
        return max3;
      }
      exports3.minSatisfying = minSatisfying;
      function minSatisfying(versions2, range3, options) {
        var min4 = null;
        var minSV = null;
        try {
          var rangeObj = new Range(range3, options);
        } catch (er) {
          return null;
        }
        versions2.forEach(function(v22) {
          if (rangeObj.test(v22)) {
            if (!min4 || minSV.compare(v22) === 1) {
              min4 = v22;
              minSV = new SemVer2(min4, options);
            }
          }
        });
        return min4;
      }
      exports3.minVersion = minVersion2;
      function minVersion2(range3, loose) {
        range3 = new Range(range3, loose);
        var minver = new SemVer2("0.0.0");
        if (range3.test(minver)) {
          return minver;
        }
        minver = new SemVer2("0.0.0-0");
        if (range3.test(minver)) {
          return minver;
        }
        minver = null;
        for (var i3 = 0; i3 < range3.set.length; ++i3) {
          var comparators = range3.set[i3];
          comparators.forEach(function(comparator) {
            var compver = new SemVer2(comparator.semver.version);
            switch (comparator.operator) {
              case ">":
                if (compver.prerelease.length === 0) {
                  compver.patch++;
                } else {
                  compver.prerelease.push(0);
                }
                compver.raw = compver.format();
              case "":
              case ">=":
                if (!minver || gt2(minver, compver)) {
                  minver = compver;
                }
                break;
              case "<":
              case "<=":
                break;
              default:
                throw new Error("Unexpected operation: " + comparator.operator);
            }
          });
        }
        if (minver && range3.test(minver)) {
          return minver;
        }
        return null;
      }
      exports3.validRange = validRange;
      function validRange(range3, options) {
        try {
          return new Range(range3, options).range || "*";
        } catch (er) {
          return null;
        }
      }
      exports3.ltr = ltr;
      function ltr(version3, range3, options) {
        return outside(version3, range3, "<", options);
      }
      exports3.gtr = gtr;
      function gtr(version3, range3, options) {
        return outside(version3, range3, ">", options);
      }
      exports3.outside = outside;
      function outside(version3, range3, hilo, options) {
        version3 = new SemVer2(version3, options);
        range3 = new Range(range3, options);
        var gtfn, ltefn, ltfn, comp, ecomp;
        switch (hilo) {
          case ">":
            gtfn = gt2;
            ltefn = lte2;
            ltfn = lt3;
            comp = ">";
            ecomp = ">=";
            break;
          case "<":
            gtfn = lt3;
            ltefn = gte2;
            ltfn = gt2;
            comp = "<";
            ecomp = "<=";
            break;
          default:
            throw new TypeError('Must provide a hilo val of "<" or ">"');
        }
        if (satisfies(version3, range3, options)) {
          return false;
        }
        for (var i3 = 0; i3 < range3.set.length; ++i3) {
          var comparators = range3.set[i3];
          var high = null;
          var low = null;
          comparators.forEach(function(comparator) {
            if (comparator.semver === ANY) {
              comparator = new Comparator(">=0.0.0");
            }
            high = high || comparator;
            low = low || comparator;
            if (gtfn(comparator.semver, high.semver, options)) {
              high = comparator;
            } else if (ltfn(comparator.semver, low.semver, options)) {
              low = comparator;
            }
          });
          if (high.operator === comp || high.operator === ecomp) {
            return false;
          }
          if ((!low.operator || low.operator === comp) && ltefn(version3, low.semver)) {
            return false;
          } else if (low.operator === ecomp && ltfn(version3, low.semver)) {
            return false;
          }
        }
        return true;
      }
      exports3.prerelease = prerelease;
      function prerelease(version3, options) {
        var parsed = parse5(version3, options);
        return parsed && parsed.prerelease.length ? parsed.prerelease : null;
      }
      exports3.intersects = intersects;
      function intersects(r1, r2, options) {
        r1 = new Range(r1, options);
        r2 = new Range(r2, options);
        return r1.intersects(r2);
      }
      exports3.coerce = coerce2;
      function coerce2(version3, options) {
        if (version3 instanceof SemVer2) {
          return version3;
        }
        if (typeof version3 === "number") {
          version3 = String(version3);
        }
        if (typeof version3 !== "string") {
          return null;
        }
        options = options || {};
        var match = null;
        if (!options.rtl) {
          match = version3.match(re3[t3.COERCE]);
        } else {
          var next;
          while ((next = re3[t3.COERCERTL].exec(version3)) && (!match || match.index + match[0].length !== version3.length)) {
            if (!match || next.index + next[0].length !== match.index + match[0].length) {
              match = next;
            }
            re3[t3.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
          }
          re3[t3.COERCERTL].lastIndex = -1;
        }
        if (match === null) {
          return null;
        }
        return parse5(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
      }
    })(semver$1, semver$1.exports);
    var semver = semver$1.exports;
    var _excluded4 = ["method", "targets", "ignoreBrowserslistConfig", "configPath", "debug", "shouldInjectPolyfill", "absoluteImports"];
    var _templateObject, _templateObject2, _templateObject3;
    var _ref$2 = babel2, t$1$1 = _ref$2.types, template = _ref$2.template;
    function intersection(a, b2) {
      var result = /* @__PURE__ */ new Set();
      a.forEach(function(v22) {
        return b2.has(v22) && result.add(v22);
      });
      return result;
    }
    function has$12(object4, key2) {
      return Object.prototype.hasOwnProperty.call(object4, key2);
    }
    function getType(target) {
      return Object.prototype.toString.call(target).slice(8, -1);
    }
    function resolveId(path2) {
      if (path2.isIdentifier() && !path2.scope.hasBinding(path2.node.name, true)) {
        return path2.node.name;
      }
      var _path$evaluate = path2.evaluate(), deopt2 = _path$evaluate.deopt;
      if (deopt2 && deopt2.isIdentifier()) {
        return deopt2.node.name;
      }
    }
    function resolveKey(path2, computed) {
      if (computed === void 0) {
        computed = false;
      }
      var node2 = path2.node, parent = path2.parent, scope2 = path2.scope;
      if (path2.isStringLiteral())
        return node2.value;
      var name2 = node2.name;
      var isIdentifier2 = path2.isIdentifier();
      if (isIdentifier2 && !(computed || parent.computed))
        return name2;
      if (computed && path2.isMemberExpression() && path2.get("object").isIdentifier({
        name: "Symbol"
      }) && !scope2.hasBinding("Symbol", true)) {
        var sym = resolveKey(path2.get("property"), path2.node.computed);
        if (sym)
          return "Symbol." + sym;
      }
      if (!isIdentifier2 || scope2.hasBinding(name2, true)) {
        var _path$evaluate2 = path2.evaluate(), value = _path$evaluate2.value;
        if (typeof value === "string")
          return value;
      }
    }
    function resolveSource(obj) {
      if (obj.isMemberExpression() && obj.get("property").isIdentifier({
        name: "prototype"
      })) {
        var _id = resolveId(obj.get("object"));
        if (_id) {
          return {
            id: _id,
            placement: "prototype"
          };
        }
        return {
          id: null,
          placement: null
        };
      }
      var id3 = resolveId(obj);
      if (id3) {
        return {
          id: id3,
          placement: "static"
        };
      }
      var _obj$evaluate = obj.evaluate(), value = _obj$evaluate.value;
      if (value !== void 0) {
        return {
          id: getType(value),
          placement: "prototype"
        };
      } else if (obj.isRegExpLiteral()) {
        return {
          id: "RegExp",
          placement: "prototype"
        };
      } else if (obj.isFunction()) {
        return {
          id: "Function",
          placement: "prototype"
        };
      }
      return {
        id: null,
        placement: null
      };
    }
    function getImportSource(_ref22) {
      var node2 = _ref22.node;
      if (node2.specifiers.length === 0)
        return node2.source.value;
    }
    function getRequireSource(_ref3) {
      var node2 = _ref3.node;
      if (!t$1$1.isExpressionStatement(node2))
        return;
      var expression2 = node2.expression;
      var isRequire = t$1$1.isCallExpression(expression2) && t$1$1.isIdentifier(expression2.callee) && expression2.callee.name === "require" && expression2.arguments.length === 1 && t$1$1.isStringLiteral(expression2.arguments[0]);
      if (isRequire)
        return expression2.arguments[0].value;
    }
    function hoist(node2) {
      node2._blockHoist = 3;
      return node2;
    }
    function createUtilsGetter(cache2) {
      return function(path2) {
        var prog = path2.findParent(function(p2) {
          return p2.isProgram();
        });
        return {
          injectGlobalImport: function injectGlobalImport(url2) {
            cache2.storeAnonymous(prog, url2, function(isScript, source) {
              return isScript ? template.statement.ast(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["require(", ")"])), source) : t$1$1.importDeclaration([], source);
            });
          },
          injectNamedImport: function injectNamedImport(url2, name2, hint) {
            if (hint === void 0) {
              hint = name2;
            }
            return cache2.storeNamed(prog, url2, name2, function(isScript, source, name3) {
              var id3 = prog.scope.generateUidIdentifier(hint);
              return {
                node: isScript ? hoist(template.statement.ast(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n                  var ", " = require(", ").", "\n                "])), id3, source, name3)) : t$1$1.importDeclaration([t$1$1.importSpecifier(id3, name3)], source),
                name: id3.name
              };
            });
          },
          injectDefaultImport: function injectDefaultImport(url2, hint) {
            if (hint === void 0) {
              hint = url2;
            }
            return cache2.storeNamed(prog, url2, "default", function(isScript, source) {
              var id3 = prog.scope.generateUidIdentifier(hint);
              return {
                node: isScript ? hoist(template.statement.ast(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["var ", " = require(", ")"])), id3, source)) : t$1$1.importDeclaration([t$1$1.importDefaultSpecifier(id3)], source),
                name: id3.name
              };
            });
          }
        };
      };
    }
    var _ref4 = babel2, t$3 = _ref4.types;
    var ImportsCache = function() {
      function ImportsCache2(resolver) {
        this._imports = /* @__PURE__ */ new WeakMap();
        this._anonymousImports = /* @__PURE__ */ new WeakMap();
        this._lastImports = /* @__PURE__ */ new WeakMap();
        this._resolver = resolver;
      }
      var _proto = ImportsCache2.prototype;
      _proto.storeAnonymous = function storeAnonymous(programPath, url2, getVal) {
        var key2 = this._normalizeKey(programPath, url2);
        var imports = this._ensure(this._anonymousImports, programPath, Set);
        if (imports.has(key2))
          return;
        var node2 = getVal(programPath.node.sourceType === "script", t$3.stringLiteral(this._resolver(url2)));
        imports.add(key2);
        this._injectImport(programPath, node2);
      };
      _proto.storeNamed = function storeNamed(programPath, url2, name2, getVal) {
        var key2 = this._normalizeKey(programPath, url2, name2);
        var imports = this._ensure(this._imports, programPath, Map);
        if (!imports.has(key2)) {
          var _getVal = getVal(programPath.node.sourceType === "script", t$3.stringLiteral(this._resolver(url2)), t$3.identifier(name2)), node2 = _getVal.node, id3 = _getVal.name;
          imports.set(key2, id3);
          this._injectImport(programPath, node2);
        }
        return t$3.identifier(imports.get(key2));
      };
      _proto._injectImport = function _injectImport(programPath, node2) {
        var lastImport = this._lastImports.get(programPath);
        if (lastImport && lastImport.node && lastImport.parent === programPath.node && lastImport.container === programPath.node.body) {
          lastImport = lastImport.insertAfter(node2);
        } else {
          lastImport = programPath.unshiftContainer("body", node2);
        }
        lastImport = lastImport[lastImport.length - 1];
        this._lastImports.set(programPath, lastImport);
      };
      _proto._ensure = function _ensure(map2, programPath, Collection2) {
        var collection = map2.get(programPath);
        if (!collection) {
          collection = new Collection2();
          map2.set(programPath, collection);
        }
        return collection;
      };
      _proto._normalizeKey = function _normalizeKey(programPath, url2, name2) {
        if (name2 === void 0) {
          name2 = "";
        }
        var sourceType = programPath.node.sourceType;
        return (name2 && sourceType) + "::" + url2 + "::" + name2;
      };
      return _createClass2(ImportsCache2);
    }();
    var presetEnvSilentDebugHeader = "#__secret_key__@babel/preset-env__don't_log_debug_header_and_resolved_targets";
    function stringifyTargetsMultiline(targets) {
      return JSON.stringify(prettifyTargets(targets), null, 2);
    }
    function patternToRegExp(pattern5) {
      if (pattern5 instanceof RegExp)
        return pattern5;
      try {
        return new RegExp("^" + pattern5 + "$");
      } catch (_unused) {
        return null;
      }
    }
    function buildUnusedError(label, unused) {
      if (!unused.length)
        return "";
      return '  - The following "' + label + `" patterns didn't match any polyfill:
` + unused.map(function(original) {
        return "    " + String(original) + "\n";
      }).join("");
    }
    function buldDuplicatesError(duplicates) {
      if (!duplicates.size)
        return "";
      return '  - The following polyfills were matched both by "include" and "exclude" patterns:\n' + Array.from(duplicates, function(name2) {
        return "    " + name2 + "\n";
      }).join("");
    }
    function validateIncludeExclude(provider, polyfills, includePatterns, excludePatterns) {
      var current2;
      var filter3 = function filter4(pattern5) {
        var regexp4 = patternToRegExp(pattern5);
        if (!regexp4)
          return false;
        var matched = false;
        for (var _iterator2 = _createForOfIteratorHelperLoose(polyfills), _step2; !(_step2 = _iterator2()).done; ) {
          var polyfill = _step2.value;
          if (regexp4.test(polyfill)) {
            matched = true;
            current2.add(polyfill);
          }
        }
        return !matched;
      };
      var include = current2 = /* @__PURE__ */ new Set();
      var unusedInclude = Array.from(includePatterns).filter(filter3);
      var exclude = current2 = /* @__PURE__ */ new Set();
      var unusedExclude = Array.from(excludePatterns).filter(filter3);
      var duplicates = intersection(include, exclude);
      if (duplicates.size > 0 || unusedInclude.length > 0 || unusedExclude.length > 0) {
        throw new Error('Error while validating the "' + provider + '" provider options:\n' + buildUnusedError("include", unusedInclude) + buildUnusedError("exclude", unusedExclude) + buldDuplicatesError(duplicates));
      }
      return {
        include,
        exclude
      };
    }
    function applyMissingDependenciesDefaults(options, babelApi) {
      var _options$missingDepen = options.missingDependencies, missingDependencies = _options$missingDepen === void 0 ? {} : _options$missingDepen;
      if (missingDependencies === false)
        return false;
      var caller = babelApi.caller(function(caller2) {
        return caller2 == null ? void 0 : caller2.name;
      });
      var _missingDependencies$ = missingDependencies.log, log = _missingDependencies$ === void 0 ? "deferred" : _missingDependencies$, _missingDependencies$2 = missingDependencies.inject, inject = _missingDependencies$2 === void 0 ? caller === "rollup-plugin-babel" ? "throw" : "import" : _missingDependencies$2, _missingDependencies$3 = missingDependencies.all, all2 = _missingDependencies$3 === void 0 ? false : _missingDependencies$3;
      return {
        log,
        inject,
        all: all2
      };
    }
    var usage = function usage2(callProvider) {
      function property2(object4, key2, placement, path2) {
        return callProvider({
          kind: "property",
          object: object4,
          key: key2,
          placement
        }, path2);
      }
      return {
        ReferencedIdentifier: function ReferencedIdentifier2(path2) {
          var name2 = path2.node.name, scope2 = path2.scope;
          if (scope2.getBindingIdentifier(name2))
            return;
          callProvider({
            kind: "global",
            name: name2
          }, path2);
        },
        MemberExpression: function MemberExpression2(path2) {
          var key2 = resolveKey(path2.get("property"), path2.node.computed);
          if (!key2 || key2 === "prototype")
            return;
          var object4 = path2.get("object");
          var binding2 = object4.scope.getBinding(object4.node.name);
          if (binding2 && binding2.path.isImportNamespaceSpecifier())
            return;
          var source = resolveSource(object4);
          return property2(source.id, key2, source.placement, path2);
        },
        ObjectPattern: function ObjectPattern(path2) {
          var parentPath = path2.parentPath, parent = path2.parent;
          var obj;
          if (parentPath.isVariableDeclarator()) {
            obj = parentPath.get("init");
          } else if (parentPath.isAssignmentExpression()) {
            obj = parentPath.get("right");
          } else if (parentPath.isFunction()) {
            var grand = parentPath.parentPath;
            if (grand.isCallExpression() || grand.isNewExpression()) {
              if (grand.node.callee === parent) {
                obj = grand.get("arguments")[path2.key];
              }
            }
          }
          var id3 = null;
          var placement = null;
          if (obj) {
            var _resolveSource = resolveSource(obj);
            id3 = _resolveSource.id;
            placement = _resolveSource.placement;
          }
          for (var _iterator2 = _createForOfIteratorHelperLoose(path2.get("properties")), _step2; !(_step2 = _iterator2()).done; ) {
            var prop2 = _step2.value;
            if (prop2.isObjectProperty()) {
              var key2 = resolveKey(prop2.get("key"));
              if (key2)
                property2(id3, key2, placement, prop2);
            }
          }
        },
        BinaryExpression: function BinaryExpression2(path2) {
          if (path2.node.operator !== "in")
            return;
          var source = resolveSource(path2.get("right"));
          var key2 = resolveKey(path2.get("left"), true);
          if (!key2)
            return;
          callProvider({
            kind: "in",
            object: source.id,
            key: key2,
            placement: source.placement
          }, path2);
        }
      };
    };
    var entry = function entry2(callProvider) {
      return {
        ImportDeclaration: function ImportDeclaration2(path2) {
          var source = getImportSource(path2);
          if (!source)
            return;
          callProvider({
            kind: "import",
            source
          }, path2);
        },
        Program: function Program2(path2) {
          path2.get("body").forEach(function(bodyPath) {
            var source = getRequireSource(bodyPath);
            if (!source)
              return;
            callProvider({
              kind: "import",
              source
            }, bodyPath);
          });
        }
      };
    };
    function resolve(dirname2, moduleName, absoluteImports) {
      if (absoluteImports === false)
        return moduleName;
      throw new Error('"absoluteImports" is not supported in bundles prepared for the browser.');
    }
    function has$22(basedir, name2) {
      return true;
    }
    function logMissing(missingDeps) {
    }
    function laterLogMissing(missingDeps) {
    }
    var PossibleGlobalObjects = /* @__PURE__ */ new Set(["global", "globalThis", "self", "window"]);
    function createMetaResolver(polyfills) {
      var staticP = polyfills["static"], instanceP = polyfills.instance, globalP = polyfills.global;
      return function(meta2) {
        if (meta2.kind === "global" && globalP && has$12(globalP, meta2.name)) {
          return {
            kind: "global",
            desc: globalP[meta2.name],
            name: meta2.name
          };
        }
        if (meta2.kind === "property" || meta2.kind === "in") {
          var placement = meta2.placement, object4 = meta2.object, key2 = meta2.key;
          if (object4 && placement === "static") {
            if (globalP && PossibleGlobalObjects.has(object4) && has$12(globalP, key2)) {
              return {
                kind: "global",
                desc: globalP[key2],
                name: key2
              };
            }
            if (staticP && has$12(staticP, object4) && has$12(staticP[object4], key2)) {
              return {
                kind: "static",
                desc: staticP[object4][key2],
                name: object4 + "$" + key2
              };
            }
          }
          if (instanceP && has$12(instanceP, key2)) {
            return {
              kind: "instance",
              desc: instanceP[key2],
              name: "" + key2
            };
          }
        }
      };
    }
    var getTargets = getTargets$2["default"] || getTargets$2;
    function resolveOptions(options, babelApi) {
      var method5 = options.method, targetsOption = options.targets, ignoreBrowserslistConfig = options.ignoreBrowserslistConfig, configPath = options.configPath, debug2 = options.debug, shouldInjectPolyfill = options.shouldInjectPolyfill, absoluteImports = options.absoluteImports, providerOptions = _objectWithoutProperties2(options, _excluded4);
      var methodName;
      if (method5 === "usage-global")
        methodName = "usageGlobal";
      else if (method5 === "entry-global")
        methodName = "entryGlobal";
      else if (method5 === "usage-pure")
        methodName = "usagePure";
      else if (typeof method5 !== "string") {
        throw new Error(".method must be a string");
      } else {
        throw new Error('.method must be one of "entry-global", "usage-global"' + (' or "usage-pure" (received ' + JSON.stringify(method5) + ")"));
      }
      if (typeof shouldInjectPolyfill === "function") {
        if (options.include || options.exclude) {
          throw new Error(".include and .exclude are not supported when using the .shouldInjectPolyfill function.");
        }
      } else if (shouldInjectPolyfill != null) {
        throw new Error(".shouldInjectPolyfill must be a function, or undefined" + (" (received " + JSON.stringify(shouldInjectPolyfill) + ")"));
      }
      if (absoluteImports != null && typeof absoluteImports !== "boolean" && typeof absoluteImports !== "string") {
        throw new Error(".absoluteImports must be a boolean, a string, or undefined" + (" (received " + JSON.stringify(absoluteImports) + ")"));
      }
      var targets;
      if (targetsOption || configPath || ignoreBrowserslistConfig) {
        var targetsObj = typeof targetsOption === "string" || Array.isArray(targetsOption) ? {
          browsers: targetsOption
        } : targetsOption;
        targets = getTargets(targetsObj, {
          ignoreBrowserslistConfig,
          configPath
        });
      } else {
        targets = babelApi.targets();
      }
      return {
        method: method5,
        methodName,
        targets,
        absoluteImports: absoluteImports != null ? absoluteImports : false,
        shouldInjectPolyfill,
        debug: !!debug2,
        providerOptions
      };
    }
    function instantiateProvider(factory, options, missingDependencies, dirname2, debugLog, babelApi) {
      var _resolveOptions = resolveOptions(options, babelApi), method5 = _resolveOptions.method, methodName = _resolveOptions.methodName, targets = _resolveOptions.targets, _debug2 = _resolveOptions.debug, _shouldInjectPolyfill = _resolveOptions.shouldInjectPolyfill, providerOptions = _resolveOptions.providerOptions, absoluteImports = _resolveOptions.absoluteImports;
      var getUtils = createUtilsGetter(new ImportsCache(function(moduleName) {
        return resolve(dirname2, moduleName, absoluteImports);
      }));
      var include, exclude;
      var polyfillsSupport;
      var polyfillsNames;
      var filterPolyfills;
      var depsCache = /* @__PURE__ */ new Map();
      var api = {
        babel: babelApi,
        getUtils,
        method: options.method,
        targets,
        createMetaResolver,
        shouldInjectPolyfill: function shouldInjectPolyfill(name2) {
          if (polyfillsNames === void 0) {
            throw new Error("Internal error in the " + factory.name + " provider: shouldInjectPolyfill() can't be called during initialization.");
          }
          if (!polyfillsNames.has(name2)) {
            console.warn("Internal error in the " + provider.name + " provider: " + ('unknown polyfill "' + name2 + '".'));
          }
          if (filterPolyfills && !filterPolyfills(name2))
            return false;
          var shouldInject = isRequired(name2, targets, {
            compatData: polyfillsSupport,
            includes: include,
            excludes: exclude
          });
          if (_shouldInjectPolyfill) {
            shouldInject = _shouldInjectPolyfill(name2, shouldInject);
            if (typeof shouldInject !== "boolean") {
              throw new Error(".shouldInjectPolyfill must return a boolean.");
            }
          }
          return shouldInject;
        },
        debug: function debug2(name2) {
          debugLog().found = true;
          if (!_debug2 || !name2)
            return;
          if (debugLog().polyfills.has(provider.name))
            return;
          debugLog().polyfills.set(name2, polyfillsSupport && name2 && polyfillsSupport[name2]);
        },
        assertDependency: function assertDependency(name2, version3) {
          if (version3 === void 0) {
            version3 = "*";
          }
          if (missingDependencies === false)
            return;
          if (absoluteImports) {
            return;
          }
          var dep = version3 === "*" ? name2 : name2 + "@^" + version3;
          var found = missingDependencies.all ? false : mapGetOr(depsCache, name2 + " :: " + dirname2, function() {
            return has$22();
          });
          if (!found) {
            debugLog().missingDeps.add(dep);
          }
        }
      };
      var provider = factory(api, providerOptions, dirname2);
      if (typeof provider[methodName] !== "function") {
        throw new Error('The "' + (provider.name || factory.name) + `" provider doesn't ` + ('support the "' + method5 + '" polyfilling method.'));
      }
      if (Array.isArray(provider.polyfills)) {
        polyfillsNames = new Set(provider.polyfills);
        filterPolyfills = provider.filterPolyfills;
      } else if (provider.polyfills) {
        polyfillsNames = new Set(Object.keys(provider.polyfills));
        polyfillsSupport = provider.polyfills;
        filterPolyfills = provider.filterPolyfills;
      } else {
        polyfillsNames = /* @__PURE__ */ new Set();
      }
      var _validateIncludeExclu = validateIncludeExclude(provider.name || factory.name, polyfillsNames, providerOptions.include || [], providerOptions.exclude || []);
      include = _validateIncludeExclu.include;
      exclude = _validateIncludeExclu.exclude;
      return {
        debug: _debug2,
        method: method5,
        targets,
        provider,
        callProvider: function callProvider(payload, path2) {
          var utils3 = getUtils(path2);
          provider[methodName](payload, utils3, path2);
        }
      };
    }
    function definePolyfillProvider(factory) {
      return declare(function(babelApi, options, dirname2) {
        babelApi.assertVersion(7);
        var traverse2 = babelApi.traverse;
        var debugLog;
        var missingDependencies = applyMissingDependenciesDefaults(options, babelApi);
        var _instantiateProvider = instantiateProvider(factory, options, missingDependencies, dirname2, function() {
          return debugLog;
        }, babelApi), debug2 = _instantiateProvider.debug, method5 = _instantiateProvider.method, targets = _instantiateProvider.targets, provider = _instantiateProvider.provider, callProvider = _instantiateProvider.callProvider;
        var createVisitor = method5 === "entry-global" ? entry : usage;
        var visitor2 = provider.visitor ? traverse2.visitors.merge([createVisitor(callProvider), provider.visitor]) : createVisitor(callProvider);
        if (debug2 && debug2 !== presetEnvSilentDebugHeader) {
          console.log(provider.name + ": `DEBUG` option");
          console.log("\nUsing targets: " + stringifyTargetsMultiline(targets));
          console.log("\nUsing polyfills with `" + method5 + "` method:");
        }
        return {
          name: "inject-polyfills",
          visitor: visitor2,
          pre: function pre() {
            var _provider$pre;
            debugLog = {
              polyfills: /* @__PURE__ */ new Map(),
              found: false,
              providers: /* @__PURE__ */ new Set(),
              missingDeps: /* @__PURE__ */ new Set()
            };
            (_provider$pre = provider.pre) == null ? void 0 : _provider$pre.apply(this, arguments);
          },
          post: function post() {
            var _provider$post;
            (_provider$post = provider.post) == null ? void 0 : _provider$post.apply(this, arguments);
            if (missingDependencies !== false) {
              if (missingDependencies.log === "per-file") {
                logMissing(debugLog.missingDeps);
              } else {
                laterLogMissing(debugLog.missingDeps);
              }
            }
            if (!debug2)
              return;
            if (this.filename)
              console.log("\n[" + this.filename + "]");
            if (debugLog.polyfills.size === 0) {
              console.log(method5 === "entry-global" ? debugLog.found ? "Based on your targets, the " + provider.name + " polyfill did not add any polyfill." : "The entry point for the " + provider.name + " polyfill has not been found." : "Based on your code and targets, the " + provider.name + " polyfill did not add any polyfill.");
              return;
            }
            if (method5 === "entry-global") {
              console.log("The " + provider.name + " polyfill entry has been replaced with the following polyfills:");
            } else {
              console.log("The " + provider.name + " polyfill added the following polyfills:");
            }
            for (var _iterator3 = _createForOfIteratorHelperLoose(debugLog.polyfills), _step3; !(_step3 = _iterator3()).done; ) {
              var _step3$value = _slicedToArray$12(_step3.value, 2), name2 = _step3$value[0], support = _step3$value[1];
              if (support) {
                var filteredTargets = getInclusionReasons(name2, targets, support);
                var formattedTargets = JSON.stringify(filteredTargets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
                console.log("  " + name2 + " " + formattedTargets);
              } else {
                console.log("  " + name2);
              }
            }
          }
        };
      });
    }
    function mapGetOr(map2, key2, getDefault) {
      var val = map2.get(key2);
      if (val === void 0) {
        val = getDefault();
        map2.set(key2, val);
      }
      return val;
    }
    var define$1 = function define2(name2, pure, global2, meta2) {
      if (global2 === void 0) {
        global2 = [];
      }
      return {
        name: name2,
        pure,
        global: global2,
        meta: meta2
      };
    };
    var pureAndGlobal = function pureAndGlobal2(pure, global2, minRuntimeVersion) {
      if (minRuntimeVersion === void 0) {
        minRuntimeVersion = null;
      }
      return define$1(global2[0], pure, global2, {
        minRuntimeVersion
      });
    };
    var globalOnly = function globalOnly2(global2) {
      return define$1(global2[0], null, global2);
    };
    var pureOnly = function pureOnly2(pure, name2) {
      return define$1(name2, pure, []);
    };
    var ArrayNatureIterators$1 = ["es6.object.to-string", "es6.array.iterator", "web.dom.iterable"];
    var CommonIterators$1 = ["es6.string.iterator"].concat(ArrayNatureIterators$1);
    var PromiseDependencies$1 = ["es6.object.to-string", "es6.promise"];
    var BuiltIns$1 = {
      DataView: globalOnly(["es6.typed.data-view"]),
      Float32Array: globalOnly(["es6.typed.float32-array"]),
      Float64Array: globalOnly(["es6.typed.float64-array"]),
      Int8Array: globalOnly(["es6.typed.int8-array"]),
      Int16Array: globalOnly(["es6.typed.int16-array"]),
      Int32Array: globalOnly(["es6.typed.int32-array"]),
      Map: pureAndGlobal("map", ["es6.map"].concat(_toConsumableArray2(CommonIterators$1))),
      Number: globalOnly(["es6.number.constructor"]),
      Promise: pureAndGlobal("promise", PromiseDependencies$1),
      RegExp: globalOnly(["es6.regexp.constructor"]),
      Set: pureAndGlobal("set", ["es6.set"].concat(_toConsumableArray2(CommonIterators$1))),
      Symbol: pureAndGlobal("symbol", ["es6.symbol"]),
      Uint8Array: globalOnly(["es6.typed.uint8-array"]),
      Uint8ClampedArray: globalOnly(["es6.typed.uint8-clamped-array"]),
      Uint16Array: globalOnly(["es6.typed.uint16-array"]),
      Uint32Array: globalOnly(["es6.typed.uint32-array"]),
      WeakMap: pureAndGlobal("weak-map", ["es6.weak-map"].concat(_toConsumableArray2(CommonIterators$1))),
      WeakSet: pureAndGlobal("weak-set", ["es6.weak-set"].concat(_toConsumableArray2(CommonIterators$1))),
      setImmediate: pureOnly("set-immediate", "web.immediate"),
      clearImmediate: pureOnly("clear-immediate", "web.immediate"),
      parseFloat: pureOnly("parse-float", "es6.parse-float"),
      parseInt: pureOnly("parse-int", "es6.parse-int")
    };
    var InstanceProperties$1 = {
      __defineGetter__: globalOnly(["es7.object.define-getter"]),
      __defineSetter__: globalOnly(["es7.object.define-setter"]),
      __lookupGetter__: globalOnly(["es7.object.lookup-getter"]),
      __lookupSetter__: globalOnly(["es7.object.lookup-setter"]),
      anchor: globalOnly(["es6.string.anchor"]),
      big: globalOnly(["es6.string.big"]),
      bind: globalOnly(["es6.function.bind"]),
      blink: globalOnly(["es6.string.blink"]),
      bold: globalOnly(["es6.string.bold"]),
      codePointAt: globalOnly(["es6.string.code-point-at"]),
      copyWithin: globalOnly(["es6.array.copy-within"]),
      endsWith: globalOnly(["es6.string.ends-with"]),
      entries: globalOnly(ArrayNatureIterators$1),
      every: globalOnly(["es6.array.every"]),
      fill: globalOnly(["es6.array.fill"]),
      filter: globalOnly(["es6.array.filter"]),
      "finally": globalOnly(["es7.promise.finally"].concat(PromiseDependencies$1)),
      find: globalOnly(["es6.array.find"]),
      findIndex: globalOnly(["es6.array.find-index"]),
      fixed: globalOnly(["es6.string.fixed"]),
      flags: globalOnly(["es6.regexp.flags"]),
      flatMap: globalOnly(["es7.array.flat-map"]),
      fontcolor: globalOnly(["es6.string.fontcolor"]),
      fontsize: globalOnly(["es6.string.fontsize"]),
      forEach: globalOnly(["es6.array.for-each"]),
      includes: globalOnly(["es6.string.includes", "es7.array.includes"]),
      indexOf: globalOnly(["es6.array.index-of"]),
      italics: globalOnly(["es6.string.italics"]),
      keys: globalOnly(ArrayNatureIterators$1),
      lastIndexOf: globalOnly(["es6.array.last-index-of"]),
      link: globalOnly(["es6.string.link"]),
      map: globalOnly(["es6.array.map"]),
      match: globalOnly(["es6.regexp.match"]),
      name: globalOnly(["es6.function.name"]),
      padStart: globalOnly(["es7.string.pad-start"]),
      padEnd: globalOnly(["es7.string.pad-end"]),
      reduce: globalOnly(["es6.array.reduce"]),
      reduceRight: globalOnly(["es6.array.reduce-right"]),
      repeat: globalOnly(["es6.string.repeat"]),
      replace: globalOnly(["es6.regexp.replace"]),
      search: globalOnly(["es6.regexp.search"]),
      small: globalOnly(["es6.string.small"]),
      some: globalOnly(["es6.array.some"]),
      sort: globalOnly(["es6.array.sort"]),
      split: globalOnly(["es6.regexp.split"]),
      startsWith: globalOnly(["es6.string.starts-with"]),
      strike: globalOnly(["es6.string.strike"]),
      sub: globalOnly(["es6.string.sub"]),
      sup: globalOnly(["es6.string.sup"]),
      toISOString: globalOnly(["es6.date.to-iso-string"]),
      toJSON: globalOnly(["es6.date.to-json"]),
      toString: globalOnly(["es6.object.to-string", "es6.date.to-string", "es6.regexp.to-string"]),
      trim: globalOnly(["es6.string.trim"]),
      trimEnd: globalOnly(["es7.string.trim-right"]),
      trimLeft: globalOnly(["es7.string.trim-left"]),
      trimRight: globalOnly(["es7.string.trim-right"]),
      trimStart: globalOnly(["es7.string.trim-left"]),
      values: globalOnly(ArrayNatureIterators$1)
    };
    if ("es6.array.slice" in corejs2BuiltIns) {
      InstanceProperties$1.slice = globalOnly(["es6.array.slice"]);
    }
    var StaticProperties$1 = {
      Array: {
        from: pureAndGlobal("array/from", ["es6.symbol", "es6.array.from"].concat(_toConsumableArray2(CommonIterators$1))),
        isArray: pureAndGlobal("array/is-array", ["es6.array.is-array"]),
        of: pureAndGlobal("array/of", ["es6.array.of"])
      },
      Date: {
        now: pureAndGlobal("date/now", ["es6.date.now"])
      },
      JSON: {
        stringify: pureOnly("json/stringify", "es6.symbol")
      },
      Math: {
        acosh: pureAndGlobal("math/acosh", ["es6.math.acosh"], "7.0.1"),
        asinh: pureAndGlobal("math/asinh", ["es6.math.asinh"], "7.0.1"),
        atanh: pureAndGlobal("math/atanh", ["es6.math.atanh"], "7.0.1"),
        cbrt: pureAndGlobal("math/cbrt", ["es6.math.cbrt"], "7.0.1"),
        clz32: pureAndGlobal("math/clz32", ["es6.math.clz32"], "7.0.1"),
        cosh: pureAndGlobal("math/cosh", ["es6.math.cosh"], "7.0.1"),
        expm1: pureAndGlobal("math/expm1", ["es6.math.expm1"], "7.0.1"),
        fround: pureAndGlobal("math/fround", ["es6.math.fround"], "7.0.1"),
        hypot: pureAndGlobal("math/hypot", ["es6.math.hypot"], "7.0.1"),
        imul: pureAndGlobal("math/imul", ["es6.math.imul"], "7.0.1"),
        log1p: pureAndGlobal("math/log1p", ["es6.math.log1p"], "7.0.1"),
        log10: pureAndGlobal("math/log10", ["es6.math.log10"], "7.0.1"),
        log2: pureAndGlobal("math/log2", ["es6.math.log2"], "7.0.1"),
        sign: pureAndGlobal("math/sign", ["es6.math.sign"], "7.0.1"),
        sinh: pureAndGlobal("math/sinh", ["es6.math.sinh"], "7.0.1"),
        tanh: pureAndGlobal("math/tanh", ["es6.math.tanh"], "7.0.1"),
        trunc: pureAndGlobal("math/trunc", ["es6.math.trunc"], "7.0.1")
      },
      Number: {
        EPSILON: pureAndGlobal("number/epsilon", ["es6.number.epsilon"]),
        MIN_SAFE_INTEGER: pureAndGlobal("number/min-safe-integer", ["es6.number.min-safe-integer"]),
        MAX_SAFE_INTEGER: pureAndGlobal("number/max-safe-integer", ["es6.number.max-safe-integer"]),
        isFinite: pureAndGlobal("number/is-finite", ["es6.number.is-finite"]),
        isInteger: pureAndGlobal("number/is-integer", ["es6.number.is-integer"]),
        isSafeInteger: pureAndGlobal("number/is-safe-integer", ["es6.number.is-safe-integer"]),
        isNaN: pureAndGlobal("number/is-nan", ["es6.number.is-nan"]),
        parseFloat: pureAndGlobal("number/parse-float", ["es6.number.parse-float"]),
        parseInt: pureAndGlobal("number/parse-int", ["es6.number.parse-int"])
      },
      Object: {
        assign: pureAndGlobal("object/assign", ["es6.object.assign"]),
        create: pureAndGlobal("object/create", ["es6.object.create"]),
        defineProperties: pureAndGlobal("object/define-properties", ["es6.object.define-properties"]),
        defineProperty: pureAndGlobal("object/define-property", ["es6.object.define-property"]),
        entries: pureAndGlobal("object/entries", ["es7.object.entries"]),
        freeze: pureAndGlobal("object/freeze", ["es6.object.freeze"]),
        getOwnPropertyDescriptor: pureAndGlobal("object/get-own-property-descriptor", ["es6.object.get-own-property-descriptor"]),
        getOwnPropertyDescriptors: pureAndGlobal("object/get-own-property-descriptors", ["es7.object.get-own-property-descriptors"]),
        getOwnPropertyNames: pureAndGlobal("object/get-own-property-names", ["es6.object.get-own-property-names"]),
        getOwnPropertySymbols: pureAndGlobal("object/get-own-property-symbols", ["es6.symbol"]),
        getPrototypeOf: pureAndGlobal("object/get-prototype-of", ["es6.object.get-prototype-of"]),
        is: pureAndGlobal("object/is", ["es6.object.is"]),
        isExtensible: pureAndGlobal("object/is-extensible", ["es6.object.is-extensible"]),
        isFrozen: pureAndGlobal("object/is-frozen", ["es6.object.is-frozen"]),
        isSealed: pureAndGlobal("object/is-sealed", ["es6.object.is-sealed"]),
        keys: pureAndGlobal("object/keys", ["es6.object.keys"]),
        preventExtensions: pureAndGlobal("object/prevent-extensions", ["es6.object.prevent-extensions"]),
        seal: pureAndGlobal("object/seal", ["es6.object.seal"]),
        setPrototypeOf: pureAndGlobal("object/set-prototype-of", ["es6.object.set-prototype-of"]),
        values: pureAndGlobal("object/values", ["es7.object.values"])
      },
      Promise: {
        all: globalOnly(CommonIterators$1),
        race: globalOnly(CommonIterators$1)
      },
      Reflect: {
        apply: pureAndGlobal("reflect/apply", ["es6.reflect.apply"]),
        construct: pureAndGlobal("reflect/construct", ["es6.reflect.construct"]),
        defineProperty: pureAndGlobal("reflect/define-property", ["es6.reflect.define-property"]),
        deleteProperty: pureAndGlobal("reflect/delete-property", ["es6.reflect.delete-property"]),
        get: pureAndGlobal("reflect/get", ["es6.reflect.get"]),
        getOwnPropertyDescriptor: pureAndGlobal("reflect/get-own-property-descriptor", ["es6.reflect.get-own-property-descriptor"]),
        getPrototypeOf: pureAndGlobal("reflect/get-prototype-of", ["es6.reflect.get-prototype-of"]),
        has: pureAndGlobal("reflect/has", ["es6.reflect.has"]),
        isExtensible: pureAndGlobal("reflect/is-extensible", ["es6.reflect.is-extensible"]),
        ownKeys: pureAndGlobal("reflect/own-keys", ["es6.reflect.own-keys"]),
        preventExtensions: pureAndGlobal("reflect/prevent-extensions", ["es6.reflect.prevent-extensions"]),
        set: pureAndGlobal("reflect/set", ["es6.reflect.set"]),
        setPrototypeOf: pureAndGlobal("reflect/set-prototype-of", ["es6.reflect.set-prototype-of"])
      },
      String: {
        at: pureOnly("string/at", "es7.string.at"),
        fromCodePoint: pureAndGlobal("string/from-code-point", ["es6.string.from-code-point"]),
        raw: pureAndGlobal("string/raw", ["es6.string.raw"])
      },
      Symbol: {
        asyncIterator: globalOnly(["es6.symbol", "es7.symbol.async-iterator"]),
        "for": pureOnly("symbol/for", "es6.symbol"),
        hasInstance: pureOnly("symbol/has-instance", "es6.symbol"),
        isConcatSpreadable: pureOnly("symbol/is-concat-spreadable", "es6.symbol"),
        iterator: define$1("es6.symbol", "symbol/iterator", CommonIterators$1),
        keyFor: pureOnly("symbol/key-for", "es6.symbol"),
        match: pureAndGlobal("symbol/match", ["es6.regexp.match"]),
        replace: pureOnly("symbol/replace", "es6.symbol"),
        search: pureOnly("symbol/search", "es6.symbol"),
        species: pureOnly("symbol/species", "es6.symbol"),
        split: pureOnly("symbol/split", "es6.symbol"),
        toPrimitive: pureOnly("symbol/to-primitive", "es6.symbol"),
        toStringTag: pureOnly("symbol/to-string-tag", "es6.symbol"),
        unscopables: pureOnly("symbol/unscopables", "es6.symbol")
      }
    };
    var webPolyfills = {
      "web.timers": {},
      "web.immediate": {},
      "web.dom.iterable": {}
    };
    var purePolyfills = {
      "es6.parse-float": {},
      "es6.parse-int": {},
      "es7.string.at": {}
    };
    function addPlatformSpecificPolyfills(targets, method5, polyfills) {
      var targetNames = Object.keys(targets);
      var isAnyTarget = !targetNames.length;
      var isWebTarget = targetNames.some(function(name2) {
        return name2 !== "node";
      });
      return Object.assign(Object.assign(Object.assign({}, polyfills), method5 === "usage-pure" ? purePolyfills : null), isAnyTarget || isWebTarget ? webPolyfills : null);
    }
    function hasMinVersion(minVersion2, runtimeVersion) {
      if (!runtimeVersion || !minVersion2)
        return true;
      if (semver.valid(runtimeVersion))
        runtimeVersion = "^" + runtimeVersion;
      return !semver.intersects("<" + minVersion2, runtimeVersion) && !semver.intersects(">=8.0.0", runtimeVersion);
    }
    var _ref$1 = babel2, t$2 = _ref$1.types;
    var presetEnvCompat = "#__secret_key__@babel/preset-env__compatibility";
    var runtimeCompat$2 = "#__secret_key__@babel/runtime__compatibility";
    var has2 = Function.call.bind(Object.hasOwnProperty);
    var index$22 = definePolyfillProvider(function(api, _ref22) {
      var _ref2$presetEnvCompat = _ref22[presetEnvCompat];
      _ref2$presetEnvCompat = _ref2$presetEnvCompat === void 0 ? {} : _ref2$presetEnvCompat;
      var entryInjectRegenerator = _ref2$presetEnvCompat.entryInjectRegenerator, _ref2$runtimeCompat = _ref22[runtimeCompat$2];
      _ref2$runtimeCompat = _ref2$runtimeCompat === void 0 ? {} : _ref2$runtimeCompat;
      var useBabelRuntime = _ref2$runtimeCompat.useBabelRuntime, runtimeVersion = _ref2$runtimeCompat.runtimeVersion, _ref2$runtimeCompat$e = _ref2$runtimeCompat.ext, ext = _ref2$runtimeCompat$e === void 0 ? ".js" : _ref2$runtimeCompat$e;
      var resolve2 = api.createMetaResolver({
        global: BuiltIns$1,
        "static": StaticProperties$1,
        instance: InstanceProperties$1
      });
      var debug2 = api.debug, shouldInjectPolyfill = api.shouldInjectPolyfill, method5 = api.method;
      var polyfills = addPlatformSpecificPolyfills(api.targets, method5, corejs2BuiltIns);
      var coreJSBase = useBabelRuntime ? useBabelRuntime + "/core-js" : method5 === "usage-pure" ? "core-js/library/fn" : "core-js/modules";
      function inject(name2, utils3) {
        if (typeof name2 === "string") {
          if (has2(polyfills, name2) && shouldInjectPolyfill(name2)) {
            debug2(name2);
            utils3.injectGlobalImport(coreJSBase + "/" + name2 + ".js");
          }
          return;
        }
        name2.forEach(function(name3) {
          return inject(name3, utils3);
        });
      }
      function maybeInjectPure(desc, hint, utils3) {
        var pure = desc.pure, meta2 = desc.meta, name2 = desc.name;
        if (!pure || !shouldInjectPolyfill(name2))
          return;
        if (runtimeVersion && meta2 && meta2.minRuntimeVersion && !hasMinVersion(meta2 && meta2.minRuntimeVersion, runtimeVersion)) {
          return;
        }
        return utils3.injectDefaultImport(coreJSBase + "/" + pure + ext, hint);
      }
      return {
        name: "corejs2",
        polyfills,
        entryGlobal: function entryGlobal(meta2, utils3, path2) {
          if (meta2.kind === "import" && meta2.source === "core-js") {
            debug2(null);
            inject(Object.keys(polyfills), utils3);
            if (entryInjectRegenerator) {
              utils3.injectGlobalImport("regenerator-runtime/runtime.js");
            }
            path2.remove();
          }
        },
        usageGlobal: function usageGlobal(meta2, utils3) {
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var deps = resolved.desc.global;
          if (resolved.kind !== "global" && meta2.object && meta2.placement === "prototype") {
            var low = meta2.object.toLowerCase();
            deps = deps.filter(function(m2) {
              return m2.includes(low);
            });
          }
          inject(deps, utils3);
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (meta2.kind === "in") {
            if (meta2.key === "Symbol.iterator") {
              path2.replaceWith(t$2.callExpression(utils3.injectDefaultImport(coreJSBase + "/is-iterable" + ext, "isIterable"), [path2.node.right]));
            }
            return;
          }
          if (path2.parentPath.isUnaryExpression({
            operator: "delete"
          }))
            return;
          if (meta2.kind === "property") {
            if (!path2.isMemberExpression())
              return;
            if (!path2.isReferenced())
              return;
            if (meta2.key === "Symbol.iterator" && shouldInjectPolyfill("es6.symbol") && path2.parentPath.isCallExpression({
              callee: path2.node
            }) && path2.parent.arguments.length === 0) {
              path2.parentPath.replaceWith(t$2.callExpression(utils3.injectDefaultImport(coreJSBase + "/get-iterator" + ext, "getIterator"), [path2.node.object]));
              path2.skip();
              return;
            }
          }
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var id3 = maybeInjectPure(resolved.desc, resolved.name, utils3);
          if (id3)
            path2.replaceWith(id3);
        },
        visitor: method5 === "usage-global" && {
          YieldExpression: function YieldExpression2(path2) {
            if (path2.node.delegate) {
              inject("web.dom.iterable", api.getUtils(path2));
            }
          },
          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path2) {
            CommonIterators$1.forEach(function(name2) {
              return inject(name2, api.getUtils(path2));
            });
          }
        }
      };
    });
    var data2 = require$$0$3;
    var getModulesListForTargetVersion = getModulesListForTargetVersion$2;
    var entries = require$$0$2;
    var corejs3ShippedProposalsList = /* @__PURE__ */ new Set(["esnext.array.find-last", "esnext.array.find-last-index", "esnext.typed-array.find-last", "esnext.typed-array.find-last-index"]);
    var polyfillsOrder = {};
    Object.keys(data2).forEach(function(name2, index3) {
      polyfillsOrder[name2] = index3;
    });
    var define = function define2(pure, global2, name2, exclude) {
      if (name2 === void 0) {
        name2 = global2[0];
      }
      return {
        name: name2,
        pure,
        global: global2.sort(function(a, b2) {
          return polyfillsOrder[a] - polyfillsOrder[b2];
        }),
        exclude
      };
    };
    var typed = function typed2(name2) {
      return define(null, [name2].concat(TypedArrayDependencies));
    };
    var ArrayNatureIterators = ["es.array.iterator", "web.dom-collections.iterator"];
    var CommonIterators = ["es.string.iterator"].concat(ArrayNatureIterators);
    var ArrayNatureIteratorsWithTag = ["es.object.to-string"].concat(ArrayNatureIterators);
    var CommonIteratorsWithTag = ["es.object.to-string"].concat(_toConsumableArray2(CommonIterators));
    var ErrorDependencies = ["es.error.cause", "es.error.to-string"];
    var TypedArrayDependencies = ["es.typed-array.at", "es.typed-array.copy-within", "es.typed-array.every", "es.typed-array.fill", "es.typed-array.filter", "es.typed-array.find", "es.typed-array.find-index", "es.typed-array.for-each", "es.typed-array.includes", "es.typed-array.index-of", "es.typed-array.iterator", "es.typed-array.join", "es.typed-array.last-index-of", "es.typed-array.map", "es.typed-array.reduce", "es.typed-array.reduce-right", "es.typed-array.reverse", "es.typed-array.set", "es.typed-array.slice", "es.typed-array.some", "es.typed-array.sort", "es.typed-array.subarray", "es.typed-array.to-locale-string", "es.typed-array.to-string", "es.object.to-string", "es.array.iterator", "es.array-buffer.slice", "esnext.typed-array.filter-reject", "esnext.typed-array.find-last", "esnext.typed-array.find-last-index", "esnext.typed-array.group-by", "esnext.typed-array.to-reversed", "esnext.typed-array.to-sorted", "esnext.typed-array.to-spliced", "esnext.typed-array.unique-by", "esnext.typed-array.with"];
    var PromiseDependencies = ["es.promise", "es.object.to-string"];
    var PromiseDependenciesWithIterators = [].concat(PromiseDependencies, _toConsumableArray2(CommonIterators));
    var SymbolDependencies = ["es.symbol", "es.symbol.description", "es.object.to-string"];
    var MapDependencies = ["es.map", "esnext.map.delete-all", "esnext.map.emplace", "esnext.map.every", "esnext.map.filter", "esnext.map.find", "esnext.map.find-key", "esnext.map.includes", "esnext.map.key-of", "esnext.map.map-keys", "esnext.map.map-values", "esnext.map.merge", "esnext.map.reduce", "esnext.map.some", "esnext.map.update"].concat(_toConsumableArray2(CommonIteratorsWithTag));
    var SetDependencies = ["es.set", "esnext.set.add-all", "esnext.set.delete-all", "esnext.set.difference", "esnext.set.every", "esnext.set.filter", "esnext.set.find", "esnext.set.intersection", "esnext.set.is-disjoint-from", "esnext.set.is-subset-of", "esnext.set.is-superset-of", "esnext.set.join", "esnext.set.map", "esnext.set.reduce", "esnext.set.some", "esnext.set.symmetric-difference", "esnext.set.union"].concat(_toConsumableArray2(CommonIteratorsWithTag));
    var WeakMapDependencies = ["es.weak-map", "esnext.weak-map.delete-all", "esnext.weak-map.emplace"].concat(_toConsumableArray2(CommonIteratorsWithTag));
    var WeakSetDependencies = ["es.weak-set", "esnext.weak-set.add-all", "esnext.weak-set.delete-all"].concat(_toConsumableArray2(CommonIteratorsWithTag));
    var DOMExceptionDependencies = ["web.dom-exception.constructor", "web.dom-exception.stack", "web.dom-exception.to-string-tag", "es.error.to-string"];
    var URLSearchParamsDependencies = ["web.url-search-params"].concat(_toConsumableArray2(CommonIteratorsWithTag));
    var AsyncIteratorDependencies = ["esnext.async-iterator.constructor"].concat(PromiseDependencies);
    var AsyncIteratorProblemMethods = ["esnext.async-iterator.every", "esnext.async-iterator.filter", "esnext.async-iterator.find", "esnext.async-iterator.flat-map", "esnext.async-iterator.for-each", "esnext.async-iterator.map", "esnext.async-iterator.reduce", "esnext.async-iterator.some"];
    var IteratorDependencies = ["esnext.iterator.constructor", "es.object.to-string"];
    var TypedArrayStaticMethods = {
      from: define(null, ["es.typed-array.from"]),
      fromAsync: define(null, ["esnext.typed-array.from-async"].concat(_toConsumableArray2(PromiseDependenciesWithIterators))),
      of: define(null, ["es.typed-array.of"])
    };
    var BuiltIns = {
      AsyncIterator: define("async-iterator/index", AsyncIteratorDependencies),
      AggregateError: define("aggregate-error", ["es.aggregate-error"].concat(ErrorDependencies, _toConsumableArray2(CommonIteratorsWithTag), ["es.aggregate-error.cause"])),
      ArrayBuffer: define(null, ["es.array-buffer.constructor", "es.array-buffer.slice", "es.object.to-string"]),
      DataView: define(null, ["es.data-view", "es.array-buffer.slice", "es.object.to-string"]),
      Date: define(null, ["es.date.to-string"]),
      DOMException: define("dom-exception", DOMExceptionDependencies),
      Error: define(null, ErrorDependencies),
      EvalError: define(null, ErrorDependencies),
      Float32Array: typed("es.typed-array.float32-array"),
      Float64Array: typed("es.typed-array.float64-array"),
      Int8Array: typed("es.typed-array.int8-array"),
      Int16Array: typed("es.typed-array.int16-array"),
      Int32Array: typed("es.typed-array.int32-array"),
      Iterator: define("iterator/index", IteratorDependencies),
      Uint8Array: typed("es.typed-array.uint8-array"),
      Uint8ClampedArray: typed("es.typed-array.uint8-clamped-array"),
      Uint16Array: typed("es.typed-array.uint16-array"),
      Uint32Array: typed("es.typed-array.uint32-array"),
      Map: define("map/index", MapDependencies),
      Number: define(null, ["es.number.constructor"]),
      Observable: define("observable/index", ["esnext.observable", "esnext.symbol.observable", "es.object.to-string"].concat(_toConsumableArray2(CommonIteratorsWithTag))),
      Promise: define("promise/index", PromiseDependencies),
      RangeError: define(null, ErrorDependencies),
      ReferenceError: define(null, ErrorDependencies),
      Reflect: define(null, ["es.reflect.to-string-tag", "es.object.to-string"]),
      RegExp: define(null, ["es.regexp.constructor", "es.regexp.dot-all", "es.regexp.exec", "es.regexp.sticky", "es.regexp.to-string"]),
      Set: define("set/index", SetDependencies),
      Symbol: define("symbol/index", SymbolDependencies),
      SyntaxError: define(null, ErrorDependencies),
      TypeError: define(null, ErrorDependencies),
      URIError: define(null, ErrorDependencies),
      URL: define("url/index", ["web.url"].concat(_toConsumableArray2(URLSearchParamsDependencies))),
      URLSearchParams: define("url-search-params/index", URLSearchParamsDependencies),
      WeakMap: define("weak-map/index", WeakMapDependencies),
      WeakSet: define("weak-set/index", WeakSetDependencies),
      clearImmediate: define("clear-immediate", ["web.immediate"]),
      compositeKey: define("composite-key", ["esnext.composite-key"]),
      compositeSymbol: define("composite-symbol", ["esnext.composite-symbol"]),
      escape: define("escape", ["es.escape"]),
      fetch: define(null, PromiseDependencies),
      globalThis: define("global-this", ["es.global-this"]),
      parseFloat: define("parse-float", ["es.parse-float"]),
      parseInt: define("parse-int", ["es.parse-int"]),
      queueMicrotask: define("queue-microtask", ["web.queue-microtask"]),
      setImmediate: define("set-immediate", ["web.immediate"]),
      setInterval: define("set-interval", ["web.timers"]),
      setTimeout: define("set-timeout", ["web.timers"]),
      structuredClone: define("structured-clone", ["web.structured-clone"].concat(DOMExceptionDependencies, ["es.array.iterator", "es.object.keys", "es.object.to-string", "es.map", "es.set"])),
      unescape: define("unescape", ["es.unescape"])
    };
    var StaticProperties = {
      AsyncIterator: {
        from: define("async-iterator/from", ["esnext.async-iterator.from"].concat(_toConsumableArray2(AsyncIteratorDependencies), AsyncIteratorProblemMethods, _toConsumableArray2(CommonIterators)))
      },
      Array: {
        from: define("array/from", ["es.array.from", "es.string.iterator"]),
        fromAsync: define("array/from-async", ["esnext.array.from-async"].concat(_toConsumableArray2(PromiseDependenciesWithIterators))),
        isArray: define("array/is-array", ["es.array.is-array"]),
        isTemplateObject: define("array/is-template-object", ["esnext.array.is-template-object"]),
        of: define("array/of", ["es.array.of"])
      },
      ArrayBuffer: {
        isView: define(null, ["es.array-buffer.is-view"])
      },
      BigInt: {
        range: define("bigint/range", ["esnext.bigint.range", "es.object.to-string"])
      },
      Date: {
        now: define("date/now", ["es.date.now"])
      },
      Function: {
        isCallable: define("function/is-callable", ["esnext.function.is-callable"]),
        isConstructor: define("function/is-constructor", ["esnext.function.is-constructor"])
      },
      Iterator: {
        from: define("iterator/from", ["esnext.iterator.from"].concat(IteratorDependencies, _toConsumableArray2(CommonIterators)))
      },
      JSON: {
        stringify: define("json/stringify", ["es.json.stringify"], "es.symbol")
      },
      Math: {
        DEG_PER_RAD: define("math/deg-per-rad", ["esnext.math.deg-per-rad"]),
        RAD_PER_DEG: define("math/rad-per-deg", ["esnext.math.rad-per-deg"]),
        acosh: define("math/acosh", ["es.math.acosh"]),
        asinh: define("math/asinh", ["es.math.asinh"]),
        atanh: define("math/atanh", ["es.math.atanh"]),
        cbrt: define("math/cbrt", ["es.math.cbrt"]),
        clamp: define("math/clamp", ["esnext.math.clamp"]),
        clz32: define("math/clz32", ["es.math.clz32"]),
        cosh: define("math/cosh", ["es.math.cosh"]),
        degrees: define("math/degrees", ["esnext.math.degrees"]),
        expm1: define("math/expm1", ["es.math.expm1"]),
        fround: define("math/fround", ["es.math.fround"]),
        fscale: define("math/fscale", ["esnext.math.fscale"]),
        hypot: define("math/hypot", ["es.math.hypot"]),
        iaddh: define("math/iaddh", ["esnext.math.iaddh"]),
        imul: define("math/imul", ["es.math.imul"]),
        imulh: define("math/imulh", ["esnext.math.imulh"]),
        isubh: define("math/isubh", ["esnext.math.isubh"]),
        log10: define("math/log10", ["es.math.log10"]),
        log1p: define("math/log1p", ["es.math.log1p"]),
        log2: define("math/log2", ["es.math.log2"]),
        radians: define("math/radians", ["esnext.math.radians"]),
        scale: define("math/scale", ["esnext.math.scale"]),
        seededPRNG: define("math/seeded-prng", ["esnext.math.seeded-prng"]),
        sign: define("math/sign", ["es.math.sign"]),
        signbit: define("math/signbit", ["esnext.math.signbit"]),
        sinh: define("math/sinh", ["es.math.sinh"]),
        tanh: define("math/tanh", ["es.math.tanh"]),
        trunc: define("math/trunc", ["es.math.trunc"]),
        umulh: define("math/umulh", ["esnext.math.umulh"])
      },
      Map: {
        from: define(null, ["esnext.map.from"].concat(_toConsumableArray2(MapDependencies))),
        groupBy: define(null, ["esnext.map.group-by"].concat(_toConsumableArray2(MapDependencies))),
        keyBy: define(null, ["esnext.map.key-by"].concat(_toConsumableArray2(MapDependencies))),
        of: define(null, ["esnext.map.of"].concat(_toConsumableArray2(MapDependencies)))
      },
      Number: {
        EPSILON: define("number/epsilon", ["es.number.epsilon"]),
        MAX_SAFE_INTEGER: define("number/max-safe-integer", ["es.number.max-safe-integer"]),
        MIN_SAFE_INTEGER: define("number/min-safe-integer", ["es.number.min-safe-integer"]),
        fromString: define("number/from-string", ["esnext.number.from-string"]),
        isFinite: define("number/is-finite", ["es.number.is-finite"]),
        isInteger: define("number/is-integer", ["es.number.is-integer"]),
        isNaN: define("number/is-nan", ["es.number.is-nan"]),
        isSafeInteger: define("number/is-safe-integer", ["es.number.is-safe-integer"]),
        parseFloat: define("number/parse-float", ["es.number.parse-float"]),
        parseInt: define("number/parse-int", ["es.number.parse-int"]),
        range: define("number/range", ["esnext.number.range", "es.object.to-string"])
      },
      Object: {
        assign: define("object/assign", ["es.object.assign"]),
        create: define("object/create", ["es.object.create"]),
        defineProperties: define("object/define-properties", ["es.object.define-properties"]),
        defineProperty: define("object/define-property", ["es.object.define-property"]),
        entries: define("object/entries", ["es.object.entries"]),
        freeze: define("object/freeze", ["es.object.freeze"]),
        fromEntries: define("object/from-entries", ["es.object.from-entries", "es.array.iterator"]),
        getOwnPropertyDescriptor: define("object/get-own-property-descriptor", ["es.object.get-own-property-descriptor"]),
        getOwnPropertyDescriptors: define("object/get-own-property-descriptors", ["es.object.get-own-property-descriptors"]),
        getOwnPropertyNames: define("object/get-own-property-names", ["es.object.get-own-property-names"]),
        getOwnPropertySymbols: define("object/get-own-property-symbols", ["es.symbol"]),
        getPrototypeOf: define("object/get-prototype-of", ["es.object.get-prototype-of"]),
        hasOwn: define("object/has-own", ["es.object.has-own"]),
        is: define("object/is", ["es.object.is"]),
        isExtensible: define("object/is-extensible", ["es.object.is-extensible"]),
        isFrozen: define("object/is-frozen", ["es.object.is-frozen"]),
        isSealed: define("object/is-sealed", ["es.object.is-sealed"]),
        keys: define("object/keys", ["es.object.keys"]),
        preventExtensions: define("object/prevent-extensions", ["es.object.prevent-extensions"]),
        seal: define("object/seal", ["es.object.seal"]),
        setPrototypeOf: define("object/set-prototype-of", ["es.object.set-prototype-of"]),
        values: define("object/values", ["es.object.values"])
      },
      Promise: {
        all: define(null, PromiseDependenciesWithIterators),
        allSettled: define(null, ["es.promise.all-settled"].concat(_toConsumableArray2(PromiseDependenciesWithIterators))),
        any: define(null, ["es.promise.any", "es.aggregate-error"].concat(_toConsumableArray2(PromiseDependenciesWithIterators))),
        race: define(null, PromiseDependenciesWithIterators),
        "try": define(null, ["esnext.promise.try"].concat(_toConsumableArray2(PromiseDependenciesWithIterators)))
      },
      Reflect: {
        apply: define("reflect/apply", ["es.reflect.apply"]),
        construct: define("reflect/construct", ["es.reflect.construct"]),
        defineMetadata: define("reflect/define-metadata", ["esnext.reflect.define-metadata"]),
        defineProperty: define("reflect/define-property", ["es.reflect.define-property"]),
        deleteMetadata: define("reflect/delete-metadata", ["esnext.reflect.delete-metadata"]),
        deleteProperty: define("reflect/delete-property", ["es.reflect.delete-property"]),
        get: define("reflect/get", ["es.reflect.get"]),
        getMetadata: define("reflect/get-metadata", ["esnext.reflect.get-metadata"]),
        getMetadataKeys: define("reflect/get-metadata-keys", ["esnext.reflect.get-metadata-keys"]),
        getOwnMetadata: define("reflect/get-own-metadata", ["esnext.reflect.get-own-metadata"]),
        getOwnMetadataKeys: define("reflect/get-own-metadata-keys", ["esnext.reflect.get-own-metadata-keys"]),
        getOwnPropertyDescriptor: define("reflect/get-own-property-descriptor", ["es.reflect.get-own-property-descriptor"]),
        getPrototypeOf: define("reflect/get-prototype-of", ["es.reflect.get-prototype-of"]),
        has: define("reflect/has", ["es.reflect.has"]),
        hasMetadata: define("reflect/has-metadata", ["esnext.reflect.has-metadata"]),
        hasOwnMetadata: define("reflect/has-own-metadata", ["esnext.reflect.has-own-metadata"]),
        isExtensible: define("reflect/is-extensible", ["es.reflect.is-extensible"]),
        metadata: define("reflect/metadata", ["esnext.reflect.metadata"]),
        ownKeys: define("reflect/own-keys", ["es.reflect.own-keys"]),
        preventExtensions: define("reflect/prevent-extensions", ["es.reflect.prevent-extensions"]),
        set: define("reflect/set", ["es.reflect.set"]),
        setPrototypeOf: define("reflect/set-prototype-of", ["es.reflect.set-prototype-of"])
      },
      Set: {
        from: define(null, ["esnext.set.from"].concat(_toConsumableArray2(SetDependencies))),
        of: define(null, ["esnext.set.of"].concat(_toConsumableArray2(SetDependencies)))
      },
      String: {
        cooked: define("string/cooked", ["esnext.string.cooked"]),
        fromCodePoint: define("string/from-code-point", ["es.string.from-code-point"]),
        raw: define("string/raw", ["es.string.raw"])
      },
      Symbol: {
        asyncDispose: define("symbol/async-dispose", ["esnext.symbol.async-dispose"]),
        asyncIterator: define("symbol/async-iterator", ["es.symbol.async-iterator"]),
        dispose: define("symbol/dispose", ["esnext.symbol.dispose"]),
        "for": define("symbol/for", [], "es.symbol"),
        hasInstance: define("symbol/has-instance", ["es.symbol.has-instance", "es.function.has-instance"]),
        isConcatSpreadable: define("symbol/is-concat-spreadable", ["es.symbol.is-concat-spreadable", "es.array.concat"]),
        iterator: define("symbol/iterator", ["es.symbol.iterator"].concat(_toConsumableArray2(CommonIteratorsWithTag))),
        keyFor: define("symbol/key-for", [], "es.symbol"),
        match: define("symbol/match", ["es.symbol.match", "es.string.match"]),
        matcher: define("symbol/matcher", ["esnext.symbol.matcher"]),
        matchAll: define("symbol/match-all", ["es.symbol.match-all", "es.string.match-all"]),
        metadata: define("symbol/metadata", ["esnext.symbol.metadata"]),
        observable: define("symbol/observable", ["esnext.symbol.observable"]),
        patternMatch: define("symbol/pattern-match", ["esnext.symbol.pattern-match"]),
        replace: define("symbol/replace", ["es.symbol.replace", "es.string.replace"]),
        search: define("symbol/search", ["es.symbol.search", "es.string.search"]),
        species: define("symbol/species", ["es.symbol.species", "es.array.species"]),
        split: define("symbol/split", ["es.symbol.split", "es.string.split"]),
        toPrimitive: define("symbol/to-primitive", ["es.symbol.to-primitive", "es.date.to-primitive"]),
        toStringTag: define("symbol/to-string-tag", ["es.symbol.to-string-tag", "es.object.to-string", "es.math.to-string-tag", "es.json.to-string-tag"]),
        unscopables: define("symbol/unscopables", ["es.symbol.unscopables"])
      },
      WeakMap: {
        from: define(null, ["esnext.weak-map.from"].concat(_toConsumableArray2(WeakMapDependencies))),
        of: define(null, ["esnext.weak-map.of"].concat(_toConsumableArray2(WeakMapDependencies)))
      },
      WeakSet: {
        from: define(null, ["esnext.weak-set.from"].concat(_toConsumableArray2(WeakSetDependencies))),
        of: define(null, ["esnext.weak-set.of"].concat(_toConsumableArray2(WeakSetDependencies)))
      },
      Int8Array: TypedArrayStaticMethods,
      Uint8Array: TypedArrayStaticMethods,
      Uint8ClampedArray: TypedArrayStaticMethods,
      Int16Array: TypedArrayStaticMethods,
      Uint16Array: TypedArrayStaticMethods,
      Int32Array: TypedArrayStaticMethods,
      Uint32Array: TypedArrayStaticMethods,
      Float32Array: TypedArrayStaticMethods,
      Float64Array: TypedArrayStaticMethods,
      WebAssembly: {
        CompileError: define(null, ErrorDependencies),
        LinkError: define(null, ErrorDependencies),
        RuntimeError: define(null, ErrorDependencies)
      }
    };
    var InstanceProperties = {
      asIndexedPairs: define("instance/asIndexedPairs", ["esnext.async-iterator.as-indexed-pairs"].concat(_toConsumableArray2(AsyncIteratorDependencies), ["esnext.iterator.as-indexed-pairs"], IteratorDependencies)),
      at: define("instance/at", ["esnext.string.at", "es.string.at-alternative", "es.array.at"]),
      anchor: define(null, ["es.string.anchor"]),
      big: define(null, ["es.string.big"]),
      bind: define("instance/bind", ["es.function.bind"]),
      blink: define(null, ["es.string.blink"]),
      bold: define(null, ["es.string.bold"]),
      codePointAt: define("instance/code-point-at", ["es.string.code-point-at"]),
      codePoints: define("instance/code-points", ["esnext.string.code-points"]),
      concat: define("instance/concat", ["es.array.concat"], void 0, ["String"]),
      copyWithin: define("instance/copy-within", ["es.array.copy-within"]),
      description: define(null, ["es.symbol", "es.symbol.description"]),
      dotAll: define("instance/dot-all", ["es.regexp.dot-all"]),
      drop: define("instance/drop", ["esnext.async-iterator.drop"].concat(_toConsumableArray2(AsyncIteratorDependencies), ["esnext.iterator.drop"], IteratorDependencies)),
      emplace: define("instance/emplace", ["esnext.map.emplace", "esnext.weak-map.emplace"]),
      endsWith: define("instance/ends-with", ["es.string.ends-with"]),
      entries: define("instance/entries", ArrayNatureIteratorsWithTag),
      every: define("instance/every", ["es.array.every", "esnext.async-iterator.every", "esnext.iterator.every"].concat(IteratorDependencies)),
      exec: define(null, ["es.regexp.exec"]),
      fill: define("instance/fill", ["es.array.fill"]),
      filter: define("instance/filter", ["es.array.filter", "esnext.async-iterator.filter", "esnext.iterator.filter"].concat(IteratorDependencies)),
      filterReject: define("instance/filterReject", ["esnext.array.filter-reject"]),
      "finally": define(null, ["es.promise.finally"].concat(PromiseDependencies)),
      find: define("instance/find", ["es.array.find", "esnext.async-iterator.find", "esnext.iterator.find"].concat(IteratorDependencies)),
      findIndex: define("instance/find-index", ["es.array.find-index"]),
      findLast: define("instance/find-last", ["esnext.array.find-last"]),
      findLastIndex: define("instance/find-last-index", ["esnext.array.find-last-index"]),
      fixed: define(null, ["es.string.fixed"]),
      flags: define("instance/flags", ["es.regexp.flags"]),
      flatMap: define("instance/flat-map", ["es.array.flat-map", "es.array.unscopables.flat-map", "esnext.async-iterator.flat-map", "esnext.iterator.flat-map"].concat(IteratorDependencies)),
      flat: define("instance/flat", ["es.array.flat", "es.array.unscopables.flat"]),
      getYear: define(null, ["es.date.get-year"]),
      groupBy: define("instance/group-by", ["esnext.array.group-by"]),
      groupByToMap: define("instance/group-by-to-map", ["esnext.array.group-by-to-map", "es.map", "es.object.to-string"]),
      fontcolor: define(null, ["es.string.fontcolor"]),
      fontsize: define(null, ["es.string.fontsize"]),
      forEach: define("instance/for-each", ["es.array.for-each", "esnext.async-iterator.for-each", "esnext.iterator.for-each"].concat(IteratorDependencies, ["web.dom-collections.for-each"])),
      includes: define("instance/includes", ["es.array.includes", "es.string.includes"]),
      indexOf: define("instance/index-of", ["es.array.index-of"]),
      italic: define(null, ["es.string.italics"]),
      join: define(null, ["es.array.join"]),
      keys: define("instance/keys", ArrayNatureIteratorsWithTag),
      lastIndex: define(null, ["esnext.array.last-index"]),
      lastIndexOf: define("instance/last-index-of", ["es.array.last-index-of"]),
      lastItem: define(null, ["esnext.array.last-item"]),
      link: define(null, ["es.string.link"]),
      map: define("instance/map", ["es.array.map", "esnext.async-iterator.map", "esnext.iterator.map"]),
      match: define(null, ["es.string.match", "es.regexp.exec"]),
      matchAll: define("instance/match-all", ["es.string.match-all", "es.regexp.exec"]),
      name: define(null, ["es.function.name"]),
      padEnd: define("instance/pad-end", ["es.string.pad-end"]),
      padStart: define("instance/pad-start", ["es.string.pad-start"]),
      reduce: define("instance/reduce", ["es.array.reduce", "esnext.async-iterator.reduce", "esnext.iterator.reduce"].concat(IteratorDependencies)),
      reduceRight: define("instance/reduce-right", ["es.array.reduce-right"]),
      repeat: define("instance/repeat", ["es.string.repeat"]),
      replace: define(null, ["es.string.replace", "es.regexp.exec"]),
      replaceAll: define("instance/replace-all", ["es.string.replace-all", "es.string.replace", "es.regexp.exec"]),
      reverse: define("instance/reverse", ["es.array.reverse"]),
      search: define(null, ["es.string.search", "es.regexp.exec"]),
      setYear: define(null, ["es.date.set-year"]),
      slice: define("instance/slice", ["es.array.slice"]),
      small: define(null, ["es.string.small"]),
      some: define("instance/some", ["es.array.some", "esnext.async-iterator.some", "esnext.iterator.some"].concat(IteratorDependencies)),
      sort: define("instance/sort", ["es.array.sort"]),
      splice: define("instance/splice", ["es.array.splice"]),
      split: define(null, ["es.string.split", "es.regexp.exec"]),
      startsWith: define("instance/starts-with", ["es.string.starts-with"]),
      sticky: define("instance/sticky", ["es.regexp.sticky"]),
      strike: define(null, ["es.string.strike"]),
      sub: define(null, ["es.string.sub"]),
      substr: define(null, ["es.string.substr"]),
      sup: define(null, ["es.string.sup"]),
      take: define("instance/take", ["esnext.async-iterator.take"].concat(_toConsumableArray2(AsyncIteratorDependencies), ["esnext.iterator.take"], IteratorDependencies)),
      test: define("instance/test", ["es.regexp.test", "es.regexp.exec"]),
      toArray: define("instance/to-array", ["esnext.async-iterator.to-array"].concat(_toConsumableArray2(AsyncIteratorDependencies), ["esnext.iterator.to-array"], IteratorDependencies)),
      toAsync: define(null, ["esnext.iterator.to-async"].concat(IteratorDependencies, _toConsumableArray2(AsyncIteratorDependencies), AsyncIteratorProblemMethods)),
      toExponential: define(null, ["es.number.to-exponential"]),
      toFixed: define(null, ["es.number.to-fixed"]),
      toGMTString: define(null, ["es.date.to-gmt-string"]),
      toISOString: define(null, ["es.date.to-iso-string"]),
      toJSON: define(null, ["es.date.to-json", "web.url.to-json"]),
      toPrecision: define(null, ["es.number.to-precision"]),
      toReversed: define("instance/to-reversed", ["esnext.array.to-reversed"]),
      toSorted: define("instance/to-sorted", ["esnext.array.to-sorted", "es.array.sort"]),
      toSpliced: define("instance/to-reversed", ["esnext.array.to-spliced"]),
      toString: define(null, ["es.object.to-string", "es.error.to-string", "es.date.to-string", "es.regexp.to-string"]),
      trim: define("instance/trim", ["es.string.trim"]),
      trimEnd: define("instance/trim-end", ["es.string.trim-end"]),
      trimLeft: define("instance/trim-left", ["es.string.trim-start"]),
      trimRight: define("instance/trim-right", ["es.string.trim-end"]),
      trimStart: define("instance/trim-start", ["es.string.trim-start"]),
      uniqueBy: define("instance/unique-by", ["esnext.array.unique-by", "es.map"]),
      unThis: define("instance/un-this", ["esnext.function.un-this"]),
      values: define("instance/values", ArrayNatureIteratorsWithTag),
      "with": define("instance/with", ["esnext.array.with"]),
      __defineGetter__: define(null, ["es.object.define-getter"]),
      __defineSetter__: define(null, ["es.object.define-setter"]),
      __lookupGetter__: define(null, ["es.object.lookup-getter"]),
      __lookupSetter__: define(null, ["es.object.lookup-setter"])
    };
    var CommonInstanceDependencies = /* @__PURE__ */ new Set(["es.object.to-string", "es.object.define-getter", "es.object.define-setter", "es.object.lookup-getter", "es.object.lookup-setter", "es.regexp.exec"]);
    var _ref = babel2, t$1 = _ref.types;
    function callMethod(path2, id3) {
      var object4 = path2.node.object;
      var context1, context2;
      if (t$1.isIdentifier(object4)) {
        context1 = object4;
        context2 = t$1.cloneNode(object4);
      } else {
        context1 = path2.scope.generateDeclaredUidIdentifier("context");
        context2 = t$1.assignmentExpression("=", t$1.cloneNode(context1), object4);
      }
      path2.replaceWith(t$1.memberExpression(t$1.callExpression(id3, [context2]), t$1.identifier("call")));
      path2.parentPath.unshiftContainer("arguments", context1);
    }
    function isCoreJSSource(source) {
      if (typeof source === "string") {
        source = source.replace(/\\/g, "/").replace(/(\/(index)?)?(\.js)?$/i, "").toLowerCase();
      }
      return hasOwnProperty.call(entries, source) && entries[source];
    }
    function coreJSModule(name2) {
      return "core-js/modules/" + name2 + ".js";
    }
    function coreJSPureHelper(name2, useBabelRuntime, ext) {
      return useBabelRuntime ? useBabelRuntime + "/core-js/" + name2 + ext : "core-js-pure/features/" + name2 + ".js";
    }
    var _ref2 = babel2, t2 = _ref2.types;
    var runtimeCompat$1 = "#__secret_key__@babel/runtime__compatibility";
    var esnextFallback = function esnextFallback2(name2, cb2) {
      if (cb2(name2))
        return true;
      if (!name2.startsWith("es."))
        return false;
      var fallback = "esnext." + name2.slice(3);
      if (!data2[fallback])
        return false;
      return cb2(fallback);
    };
    var index$12 = definePolyfillProvider(function(_ref3, _ref42) {
      var getUtils = _ref3.getUtils, method5 = _ref3.method, shouldInjectPolyfill = _ref3.shouldInjectPolyfill, createMetaResolver2 = _ref3.createMetaResolver, debug2 = _ref3.debug, babel3 = _ref3.babel;
      var _ref4$version = _ref42.version, version3 = _ref4$version === void 0 ? 3 : _ref4$version, proposals = _ref42.proposals, shippedProposals2 = _ref42.shippedProposals, _ref4$runtimeCompat = _ref42[runtimeCompat$1];
      _ref4$runtimeCompat = _ref4$runtimeCompat === void 0 ? {} : _ref4$runtimeCompat;
      var useBabelRuntime = _ref4$runtimeCompat.useBabelRuntime, _ref4$runtimeCompat$e = _ref4$runtimeCompat.ext, ext = _ref4$runtimeCompat$e === void 0 ? ".js" : _ref4$runtimeCompat$e;
      var isWebpack = babel3.caller(function(caller) {
        return (caller == null ? void 0 : caller.name) === "babel-loader";
      });
      var resolve2 = createMetaResolver2({
        global: BuiltIns,
        "static": StaticProperties,
        instance: InstanceProperties
      });
      var available = new Set(getModulesListForTargetVersion(version3));
      function getCoreJSPureBase(useProposalBase) {
        return useBabelRuntime ? useProposalBase ? useBabelRuntime + "/core-js" : useBabelRuntime + "/core-js-stable" : useProposalBase ? "core-js-pure/features" : "core-js-pure/stable";
      }
      function maybeInjectGlobalImpl(name2, utils3) {
        if (shouldInjectPolyfill(name2)) {
          debug2(name2);
          utils3.injectGlobalImport(coreJSModule(name2));
          return true;
        }
        return false;
      }
      function maybeInjectGlobal(names2, utils3, fallback) {
        if (fallback === void 0) {
          fallback = true;
        }
        for (var _iterator2 = _createForOfIteratorHelperLoose(names2), _step2; !(_step2 = _iterator2()).done; ) {
          var name2 = _step2.value;
          if (fallback) {
            esnextFallback(name2, function(name3) {
              return maybeInjectGlobalImpl(name3, utils3);
            });
          } else {
            maybeInjectGlobalImpl(name2, utils3);
          }
        }
      }
      function maybeInjectPure(desc, hint, utils3, object4) {
        if (desc.pure && !(object4 && desc.exclude && desc.exclude.includes(object4)) && esnextFallback(desc.name, shouldInjectPolyfill)) {
          var name2 = desc.name;
          var useProposalBase = false;
          if (proposals || shippedProposals2 && name2.startsWith("esnext.")) {
            useProposalBase = true;
          } else if (name2.startsWith("es.") && !available.has(name2)) {
            useProposalBase = true;
          }
          var coreJSPureBase = getCoreJSPureBase(useProposalBase);
          return utils3.injectDefaultImport(coreJSPureBase + "/" + desc.pure + ext, hint);
        }
      }
      function isFeatureStable(name2) {
        if (name2.startsWith("esnext.")) {
          var esName = "es." + name2.slice(7);
          return esName in data2;
        }
        return true;
      }
      return {
        name: "corejs3",
        polyfills: data2,
        filterPolyfills: function filterPolyfills(name2) {
          if (!available.has(name2))
            return false;
          if (proposals || method5 === "entry-global")
            return true;
          if (shippedProposals2 && corejs3ShippedProposalsList.has(name2)) {
            return true;
          }
          return isFeatureStable(name2);
        },
        entryGlobal: function entryGlobal(meta2, utils3, path2) {
          if (meta2.kind !== "import")
            return;
          var modules2 = isCoreJSSource(meta2.source);
          if (!modules2)
            return;
          if (modules2.length === 1 && meta2.source === coreJSModule(modules2[0]) && shouldInjectPolyfill(modules2[0])) {
            debug2(null);
            return;
          }
          maybeInjectGlobal(modules2, utils3, false);
          path2.remove();
        },
        usageGlobal: function usageGlobal(meta2, utils3) {
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          var deps = resolved.desc.global;
          if (resolved.kind !== "global" && meta2.object && meta2.placement === "prototype") {
            var low = meta2.object.toLowerCase();
            deps = deps.filter(function(m2) {
              return m2.includes(low) || CommonInstanceDependencies.has(m2);
            });
          }
          maybeInjectGlobal(deps, utils3);
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (meta2.kind === "in") {
            if (meta2.key === "Symbol.iterator") {
              path2.replaceWith(t2.callExpression(utils3.injectDefaultImport(coreJSPureHelper("is-iterable", useBabelRuntime, ext), "isIterable"), [path2.node.right]));
            }
            return;
          }
          if (path2.parentPath.isUnaryExpression({
            operator: "delete"
          }))
            return;
          var isCall;
          if (meta2.kind === "property") {
            if (!path2.isMemberExpression())
              return;
            if (!path2.isReferenced())
              return;
            isCall = path2.parentPath.isCallExpression({
              callee: path2.node
            });
            if (meta2.key === "Symbol.iterator") {
              if (!shouldInjectPolyfill("es.symbol.iterator"))
                return;
              if (isCall) {
                if (path2.parent.arguments.length === 0) {
                  path2.parentPath.replaceWith(t2.callExpression(utils3.injectDefaultImport(coreJSPureHelper("get-iterator", useBabelRuntime, ext), "getIterator"), [path2.node.object]));
                  path2.skip();
                } else {
                  callMethod(path2, utils3.injectDefaultImport(coreJSPureHelper("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"));
                }
              } else {
                path2.replaceWith(t2.callExpression(utils3.injectDefaultImport(coreJSPureHelper("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"), [path2.node.object]));
              }
              return;
            }
          }
          var resolved = resolve2(meta2);
          if (!resolved)
            return;
          if (useBabelRuntime && resolved.desc.pure && resolved.desc.pure.slice(-6) === "/index") {
            resolved = Object.assign(Object.assign({}, resolved), {}, {
              desc: Object.assign(Object.assign({}, resolved.desc), {}, {
                pure: resolved.desc.pure.slice(0, -6)
              })
            });
          }
          if (resolved.kind === "global") {
            var id3 = maybeInjectPure(resolved.desc, resolved.name, utils3);
            if (id3)
              path2.replaceWith(id3);
          } else if (resolved.kind === "static") {
            var _id = maybeInjectPure(resolved.desc, resolved.name, utils3, meta2.object);
            if (_id)
              path2.replaceWith(_id);
          } else if (resolved.kind === "instance") {
            var _id2 = maybeInjectPure(resolved.desc, resolved.name + "InstanceProperty", utils3, meta2.object);
            if (!_id2)
              return;
            if (isCall) {
              callMethod(path2, _id2);
            } else {
              path2.replaceWith(t2.callExpression(_id2, [path2.node.object]));
            }
          }
        },
        visitor: method5 === "usage-global" && {
          CallExpression: function CallExpression2(path2) {
            if (path2.get("callee").isImport()) {
              var utils3 = getUtils(path2);
              if (isWebpack) {
                maybeInjectGlobal(PromiseDependenciesWithIterators, utils3);
              } else {
                maybeInjectGlobal(PromiseDependencies, utils3);
              }
            }
          },
          Function: function Function2(path2) {
            if (path2.node.async) {
              maybeInjectGlobal(PromiseDependencies, getUtils(path2));
            }
          },
          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path2) {
            maybeInjectGlobal(CommonIterators, getUtils(path2));
          },
          SpreadElement: function SpreadElement(path2) {
            if (!path2.parentPath.isObjectExpression()) {
              maybeInjectGlobal(CommonIterators, getUtils(path2));
            }
          },
          YieldExpression: function YieldExpression2(path2) {
            if (path2.node.delegate) {
              maybeInjectGlobal(CommonIterators, getUtils(path2));
            }
          }
        }
      };
    });
    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
    var index2 = definePolyfillProvider(function(_ref3, options) {
      var debug2 = _ref3.debug;
      var _options$runtimeCompa = options[runtimeCompat];
      _options$runtimeCompa = _options$runtimeCompa === void 0 ? {} : _options$runtimeCompa;
      var useBabelRuntime = _options$runtimeCompa.useBabelRuntime;
      var pureName = useBabelRuntime ? useBabelRuntime + "/regenerator" : "regenerator-runtime";
      return {
        name: "regenerator",
        polyfills: ["regenerator-runtime"],
        usageGlobal: function usageGlobal(meta2, utils3) {
          if (isRegenerator(meta2)) {
            debug2("regenerator-runtime");
            utils3.injectGlobalImport("regenerator-runtime/runtime.js");
          }
        },
        usagePure: function usagePure(meta2, utils3, path2) {
          if (isRegenerator(meta2)) {
            path2.replaceWith(utils3.injectDefaultImport(pureName, "regenerator-runtime"));
          }
        }
      };
    });
    var isRegenerator = function isRegenerator2(meta2) {
      return meta2.kind === "global" && meta2.name === "regeneratorRuntime";
    };
    var pluginCoreJS2 = index$22["default"] || index$22;
    var pluginCoreJS3 = index$12["default"] || index$12;
    var pluginRegenerator = index2["default"] || index2;
    function filterStageFromList(list2, stageList) {
      return Object.keys(list2).reduce(function(result, item) {
        if (!stageList.has(item)) {
          result[item] = list2[item];
        }
        return result;
      }, {});
    }
    var pluginLists = {
      withProposals: {
        withoutBugfixes: pluginsFiltered,
        withBugfixes: Object.assign({}, pluginsFiltered, bugfixPluginsFiltered)
      },
      withoutProposals: {
        withoutBugfixes: filterStageFromList(pluginsFiltered, shippedProposals.proposalPlugins),
        withBugfixes: filterStageFromList(Object.assign({}, pluginsFiltered, bugfixPluginsFiltered), shippedProposals.proposalPlugins)
      }
    };
    function getPluginList(proposals, bugfixes) {
      if (proposals) {
        if (bugfixes)
          return pluginLists.withProposals.withBugfixes;
        else
          return pluginLists.withProposals.withoutBugfixes;
      } else {
        if (bugfixes)
          return pluginLists.withoutProposals.withBugfixes;
        else
          return pluginLists.withoutProposals.withoutBugfixes;
      }
    }
    var getPlugin = function getPlugin2(pluginName) {
      var plugin2 = availablePlugins$1[pluginName]();
      if (!plugin2) {
        throw new Error('Could not find plugin "' + pluginName + '". Ensure there is an entry in ./available-plugins.js for it.');
      }
      return plugin2;
    };
    var transformIncludesAndExcludes = function transformIncludesAndExcludes2(opts) {
      return opts.reduce(function(result, opt) {
        var target = opt.match(/^(es|es6|es7|esnext|web)\./) ? "builtIns" : "plugins";
        result[target].add(opt);
        return result;
      }, {
        all: opts,
        plugins: /* @__PURE__ */ new Set(),
        builtIns: /* @__PURE__ */ new Set()
      });
    };
    var getModulesPluginNames = function getModulesPluginNames2(_ref3) {
      var modules2 = _ref3.modules, transformations = _ref3.transformations, shouldTransformESM = _ref3.shouldTransformESM, shouldTransformDynamicImport = _ref3.shouldTransformDynamicImport, shouldTransformExportNamespaceFrom = _ref3.shouldTransformExportNamespaceFrom, shouldParseTopLevelAwait = _ref3.shouldParseTopLevelAwait;
      var modulesPluginNames = [];
      if (modules2 !== false && transformations[modules2]) {
        if (shouldTransformESM) {
          modulesPluginNames.push(transformations[modules2]);
        }
        if (shouldTransformDynamicImport && shouldTransformESM && modules2 !== "umd") {
          modulesPluginNames.push("proposal-dynamic-import");
        } else {
          if (shouldTransformDynamicImport) {
            console.warn("Dynamic import can only be supported when transforming ES modules to AMD, CommonJS or SystemJS. Only the parser plugin will be enabled.");
          }
          modulesPluginNames.push("syntax-dynamic-import");
        }
      } else {
        modulesPluginNames.push("syntax-dynamic-import");
      }
      if (shouldTransformExportNamespaceFrom) {
        modulesPluginNames.push("proposal-export-namespace-from");
      } else {
        modulesPluginNames.push("syntax-export-namespace-from");
      }
      if (shouldParseTopLevelAwait) {
        modulesPluginNames.push("syntax-top-level-await");
      }
      return modulesPluginNames;
    };
    var getPolyfillPlugins = function getPolyfillPlugins2(_ref22) {
      var useBuiltIns = _ref22.useBuiltIns, corejs = _ref22.corejs, polyfillTargets = _ref22.polyfillTargets, include = _ref22.include, exclude = _ref22.exclude, proposals = _ref22.proposals, shippedProposals2 = _ref22.shippedProposals, regenerator3 = _ref22.regenerator, debug2 = _ref22.debug;
      var polyfillPlugins = [];
      if (useBuiltIns === "usage" || useBuiltIns === "entry") {
        var pluginOptions = {
          method: useBuiltIns + "-global",
          version: corejs ? corejs.toString() : void 0,
          targets: polyfillTargets,
          include,
          exclude,
          proposals,
          shippedProposals: shippedProposals2,
          debug: debug2
        };
        if (corejs) {
          if (useBuiltIns === "usage") {
            if (corejs.major === 2) {
              polyfillPlugins.push([pluginCoreJS2, pluginOptions], [legacyBabelPolyfillPlugin, {
                usage: true
              }]);
            } else {
              polyfillPlugins.push([pluginCoreJS3, pluginOptions], [legacyBabelPolyfillPlugin, {
                usage: true,
                deprecated: true
              }]);
            }
            if (regenerator3) {
              polyfillPlugins.push([pluginRegenerator, {
                method: "usage-global",
                debug: debug2
              }]);
            }
          } else {
            if (corejs.major === 2) {
              polyfillPlugins.push([legacyBabelPolyfillPlugin, {
                regenerator: regenerator3
              }], [pluginCoreJS2, pluginOptions]);
            } else {
              polyfillPlugins.push([pluginCoreJS3, pluginOptions], [legacyBabelPolyfillPlugin, {
                deprecated: true
              }]);
              if (!regenerator3) {
                polyfillPlugins.push([removeRegeneratorEntryPlugin, pluginOptions]);
              }
            }
          }
        }
      }
      return polyfillPlugins;
    };
    function getLocalTargets(optionsTargets, ignoreBrowserslistConfig, configPath, browserslistEnv) {
      if (optionsTargets != null && optionsTargets.esmodules && optionsTargets.browsers) {
        console.warn("\n@babel/preset-env: esmodules and browsers targets have been specified together.\n`browsers` target, `" + optionsTargets.browsers.toString() + "` will be ignored.\n");
      }
      return getTargets$2(optionsTargets, {
        ignoreBrowserslistConfig,
        configPath,
        browserslistEnv
      });
    }
    function supportsStaticESM(caller) {
      return !!(caller != null && caller.supportsStaticESM);
    }
    function supportsDynamicImport(caller) {
      return !!(caller != null && caller.supportsDynamicImport);
    }
    function supportsExportNamespaceFrom(caller) {
      return !!(caller != null && caller.supportsExportNamespaceFrom);
    }
    function supportsTopLevelAwait(caller) {
      return !!(caller != null && caller.supportsTopLevelAwait);
    }
    var presetEnv = declare(function(api, opts) {
      api.assertVersion(7);
      var babelTargets = api.targets();
      var _normalizeOptions = normalizeOptions$3(opts), bugfixes = _normalizeOptions.bugfixes, configPath = _normalizeOptions.configPath, debug2 = _normalizeOptions.debug, optionsExclude = _normalizeOptions.exclude, forceAllTransforms = _normalizeOptions.forceAllTransforms, ignoreBrowserslistConfig = _normalizeOptions.ignoreBrowserslistConfig, optionsInclude = _normalizeOptions.include, loose = _normalizeOptions.loose, modules2 = _normalizeOptions.modules, shippedProposals$1 = _normalizeOptions.shippedProposals, spec = _normalizeOptions.spec, optionsTargets = _normalizeOptions.targets, useBuiltIns = _normalizeOptions.useBuiltIns, _normalizeOptions$cor = _normalizeOptions.corejs, corejs = _normalizeOptions$cor.version, proposals = _normalizeOptions$cor.proposals, browserslistEnv = _normalizeOptions.browserslistEnv;
      var targets = babelTargets;
      if (semver$2.lt(api.version, "7.13.0") || opts.targets || opts.configPath || opts.browserslistEnv || opts.ignoreBrowserslistConfig) {
        {
          var hasUglifyTarget = false;
          if (optionsTargets != null && optionsTargets.uglify) {
            hasUglifyTarget = true;
            delete optionsTargets.uglify;
            console.warn("\nThe uglify target has been deprecated. Set the top level\noption `forceAllTransforms: true` instead.\n");
          }
        }
        targets = getLocalTargets(optionsTargets, ignoreBrowserslistConfig, configPath, browserslistEnv);
      }
      var transformTargets = forceAllTransforms || hasUglifyTarget ? {} : targets;
      var include = transformIncludesAndExcludes(optionsInclude);
      var exclude = transformIncludesAndExcludes(optionsExclude);
      var compatData = getPluginList(shippedProposals$1, bugfixes);
      var shouldSkipExportNamespaceFrom = modules2 === "auto" && (api.caller == null ? void 0 : api.caller(supportsExportNamespaceFrom)) || modules2 === false && !isRequired("proposal-export-namespace-from", transformTargets, {
        compatData,
        includes: include.plugins,
        excludes: exclude.plugins
      });
      var modulesPluginNames = getModulesPluginNames({
        modules: modules2,
        transformations: moduleTransformations,
        shouldTransformESM: modules2 !== "auto" || !(api.caller != null && api.caller(supportsStaticESM)),
        shouldTransformDynamicImport: modules2 !== "auto" || !(api.caller != null && api.caller(supportsDynamicImport)),
        shouldTransformExportNamespaceFrom: !shouldSkipExportNamespaceFrom,
        shouldParseTopLevelAwait: !api.caller || api.caller(supportsTopLevelAwait)
      });
      var pluginNames = filterItems(compatData, include.plugins, exclude.plugins, transformTargets, modulesPluginNames, getOptionSpecificExcludesFor({
        loose
      }), shippedProposals.pluginSyntaxMap);
      removeUnnecessaryItems(pluginNames, overlappingPlugins);
      removeUnsupportedItems(pluginNames, api.version);
      var polyfillPlugins = getPolyfillPlugins({
        useBuiltIns,
        corejs,
        polyfillTargets: targets,
        include: include.builtIns,
        exclude: exclude.builtIns,
        proposals,
        shippedProposals: shippedProposals$1,
        regenerator: pluginNames.has("transform-regenerator"),
        debug: debug2
      });
      var pluginUseBuiltIns = useBuiltIns !== false;
      var plugins2 = Array.from(pluginNames).map(function(pluginName) {
        if (pluginName === "proposal-class-properties" || pluginName === "proposal-private-methods" || pluginName === "proposal-private-property-in-object") {
          return [getPlugin(pluginName), {
            loose: loose ? "#__internal__@babel/preset-env__prefer-true-but-false-is-ok-if-it-prevents-an-error" : "#__internal__@babel/preset-env__prefer-false-but-true-is-ok-if-it-prevents-an-error"
          }];
        }
        return [getPlugin(pluginName), {
          spec,
          loose,
          useBuiltIns: pluginUseBuiltIns
        }];
      }).concat(polyfillPlugins);
      if (debug2) {
        console.log("@babel/preset-env: `DEBUG` option");
        console.log("\nUsing targets:");
        console.log(JSON.stringify(prettifyTargets(targets), null, 2));
        console.log("\nUsing modules transform: " + modules2.toString());
        console.log("\nUsing plugins:");
        pluginNames.forEach(function(pluginName) {
          logPlugin(pluginName, targets, compatData);
        });
        if (!useBuiltIns) {
          console.log("\nUsing polyfills: No polyfills were added, since the `useBuiltIns` option was not set.");
        }
      }
      return {
        plugins: plugins2
      };
    });
    new OptionValidator("@babel/preset-flow");
    function normalizeOptions$2(options) {
      if (options === void 0) {
        options = {};
      }
      var _options = options, all2 = _options.all;
      var _options2 = options, allowDeclareFields = _options2.allowDeclareFields;
      {
        return {
          all: all2,
          allowDeclareFields
        };
      }
    }
    var presetFlow = declare(function(api, opts) {
      api.assertVersion(7);
      var _normalizeOptions = normalizeOptions$2(opts), all2 = _normalizeOptions.all, allowDeclareFields = _normalizeOptions.allowDeclareFields;
      return {
        plugins: [[transformFlowStripTypes, {
          all: all2,
          allowDeclareFields
        }]]
      };
    });
    var PURE_CALLS = /* @__PURE__ */ new Map([["react", ["cloneElement", "createContext", "createElement", "createFactory", "createRef", "forwardRef", "isValidElement", "memo", "lazy"]], ["react-dom", ["createPortal"]]]);
    var transformReactPure = declare(function(api) {
      api.assertVersion(7);
      return {
        name: "transform-react-pure-annotations",
        visitor: {
          CallExpression: function CallExpression2(path2) {
            if (isReactCall(path2)) {
              annotateAsPure(path2);
            }
          }
        }
      };
    });
    function isReactCall(path2) {
      if (!isMemberExpression$8(path2.node.callee)) {
        var callee = path2.get("callee");
        for (var _iterator2 = _createForOfIteratorHelperLoose(PURE_CALLS), _step2; !(_step2 = _iterator2()).done; ) {
          var _step$value = _slicedToArray$12(_step2.value, 2), module2 = _step$value[0], methods = _step$value[1];
          for (var _iterator22 = _createForOfIteratorHelperLoose(methods), _step22; !(_step22 = _iterator22()).done; ) {
            var method5 = _step22.value;
            if (callee.referencesImport(module2, method5)) {
              return true;
            }
          }
        }
        return false;
      }
      for (var _iterator3 = _createForOfIteratorHelperLoose(PURE_CALLS), _step3; !(_step3 = _iterator3()).done; ) {
        var _step3$value = _slicedToArray$12(_step3.value, 2), _module = _step3$value[0], _methods = _step3$value[1];
        var object4 = path2.get("callee.object");
        if (object4.referencesImport(_module, "default") || object4.referencesImport(_module, "*")) {
          for (var _iterator4 = _createForOfIteratorHelperLoose(_methods), _step4; !(_step4 = _iterator4()).done; ) {
            var _method = _step4.value;
            if (isIdentifier$i(path2.node.callee.property, {
              name: _method
            })) {
              return true;
            }
          }
          return false;
        }
      }
      return false;
    }
    new OptionValidator("@babel/preset-react");
    function normalizeOptions$1(options) {
      if (options === void 0) {
        options = {};
      }
      {
        var _options = options, pragma = _options.pragma, pragmaFrag = _options.pragmaFrag;
        var _options2 = options, pure = _options2.pure, _options2$throwIfName = _options2.throwIfNamespace, throwIfNamespace = _options2$throwIfName === void 0 ? true : _options2$throwIfName, _options2$runtime = _options2.runtime, runtime3 = _options2$runtime === void 0 ? "classic" : _options2$runtime, importSource = _options2.importSource, useBuiltIns = _options2.useBuiltIns, useSpread = _options2.useSpread;
        if (runtime3 === "classic") {
          pragma = pragma || "React.createElement";
          pragmaFrag = pragmaFrag || "React.Fragment";
        }
        var development = !!options.development;
        return {
          development,
          importSource,
          pragma,
          pragmaFrag,
          pure,
          runtime: runtime3,
          throwIfNamespace,
          useBuiltIns,
          useSpread
        };
      }
    }
    var presetReact = declare(function(api, opts) {
      api.assertVersion(7);
      var _normalizeOptions = normalizeOptions$1(opts), development = _normalizeOptions.development, importSource = _normalizeOptions.importSource, pragma = _normalizeOptions.pragma, pragmaFrag = _normalizeOptions.pragmaFrag, pure = _normalizeOptions.pure, runtime3 = _normalizeOptions.runtime, throwIfNamespace = _normalizeOptions.throwIfNamespace;
      return {
        plugins: [[development ? transformReactJSXDevelopment : transformReactJSX, {
          importSource,
          pragma,
          pragmaFrag,
          runtime: runtime3,
          throwIfNamespace,
          pure,
          useBuiltIns: !!opts.useBuiltIns,
          useSpread: opts.useSpread
        }], transformReactDisplayName, pure !== false && transformReactPure].filter(Boolean)
      };
    });
    var v21 = new OptionValidator("@babel/preset-typescript");
    function normalizeOptions(options) {
      if (options === void 0) {
        options = {};
      }
      var _options = options, _options$allowNamespa = _options.allowNamespaces, allowNamespaces = _options$allowNamespa === void 0 ? true : _options$allowNamespa, jsxPragma = _options.jsxPragma, onlyRemoveTypeImports = _options.onlyRemoveTypeImports;
      var TopLevelOptions2 = {
        allExtensions: "allExtensions",
        allowNamespaces: "allowNamespaces",
        disallowAmbiguousJSXLike: "disallowAmbiguousJSXLike",
        isTSX: "isTSX",
        jsxPragma: "jsxPragma",
        jsxPragmaFrag: "jsxPragmaFrag",
        onlyRemoveTypeImports: "onlyRemoveTypeImports",
        optimizeConstEnums: "optimizeConstEnums"
      };
      var jsxPragmaFrag = v21.validateStringOption(TopLevelOptions2.jsxPragmaFrag, options.jsxPragmaFrag, "React.Fragment");
      var allExtensions = v21.validateBooleanOption(TopLevelOptions2.allExtensions, options.allExtensions, false);
      var isTSX = v21.validateBooleanOption(TopLevelOptions2.isTSX, options.isTSX, false);
      if (isTSX) {
        v21.invariant(allExtensions, "isTSX:true requires allExtensions:true");
      }
      var disallowAmbiguousJSXLike = v21.validateBooleanOption(TopLevelOptions2.disallowAmbiguousJSXLike, options.disallowAmbiguousJSXLike, false);
      if (disallowAmbiguousJSXLike) {
        v21.invariant(allExtensions, "disallowAmbiguousJSXLike:true requires allExtensions:true");
      }
      var optimizeConstEnums = v21.validateBooleanOption(TopLevelOptions2.optimizeConstEnums, options.optimizeConstEnums, false);
      return {
        allExtensions,
        allowNamespaces,
        disallowAmbiguousJSXLike,
        isTSX,
        jsxPragma,
        jsxPragmaFrag,
        onlyRemoveTypeImports,
        optimizeConstEnums
      };
    }
    var presetTypescript = declare(function(api, opts) {
      api.assertVersion(7);
      var _normalizeOptions = normalizeOptions(opts), allExtensions = _normalizeOptions.allExtensions, allowNamespaces = _normalizeOptions.allowNamespaces, disallowAmbiguousJSXLike = _normalizeOptions.disallowAmbiguousJSXLike, isTSX = _normalizeOptions.isTSX, jsxPragma = _normalizeOptions.jsxPragma, jsxPragmaFrag = _normalizeOptions.jsxPragmaFrag, onlyRemoveTypeImports = _normalizeOptions.onlyRemoveTypeImports, optimizeConstEnums = _normalizeOptions.optimizeConstEnums;
      var pluginOptions = function pluginOptions2(isTSX2, disallowAmbiguousJSXLike2) {
        return {
          allowDeclareFields: opts.allowDeclareFields,
          allowNamespaces,
          disallowAmbiguousJSXLike: disallowAmbiguousJSXLike2,
          isTSX: isTSX2,
          jsxPragma,
          jsxPragmaFrag,
          onlyRemoveTypeImports,
          optimizeConstEnums
        };
      };
      return {
        overrides: allExtensions ? [{
          plugins: [[transformTypeScript, pluginOptions(isTSX, disallowAmbiguousJSXLike)]]
        }] : [{
          test: /\.ts$/,
          plugins: [[transformTypeScript, pluginOptions(false, false)]]
        }, {
          test: /\.mts$/,
          sourceType: "module",
          plugins: [[transformTypeScript, pluginOptions(false, true)]]
        }, {
          test: /\.cts$/,
          sourceType: "script",
          plugins: [[transformTypeScript, pluginOptions(false, true)]]
        }, {
          test: /\.tsx$/,
          plugins: [[transformTypeScript, pluginOptions(true, false)]]
        }]
      };
    });
    var scriptTypes = ["text/jsx", "text/babel"];
    var headEl;
    var inlineScriptCount = 0;
    function transformCode(transformFn, script) {
      var source;
      if (script.url != null) {
        source = script.url;
      } else {
        source = "Inline Babel script";
        inlineScriptCount++;
        if (inlineScriptCount > 1) {
          source += " (" + inlineScriptCount + ")";
        }
      }
      return transformFn(script.content, buildBabelOptions(script, source)).code;
    }
    function buildBabelOptions(script, filename) {
      var presets = script.presets;
      if (!presets) {
        if (script.type === "module") {
          presets = ["react", ["env", {
            targets: {
              esmodules: true
            },
            modules: false
          }]];
        } else {
          presets = ["react", "env"];
        }
      }
      return {
        filename,
        presets,
        plugins: script.plugins || ["proposal-class-properties", "proposal-object-rest-spread", "transform-flow-strip-types"],
        sourceMaps: "inline",
        sourceFileName: filename
      };
    }
    function run(transformFn, script) {
      var scriptEl = document.createElement("script");
      if (script.type) {
        scriptEl.setAttribute("type", script.type);
      }
      scriptEl.text = transformCode(transformFn, script);
      headEl.appendChild(scriptEl);
    }
    function load(url2, successCallback, errorCallback) {
      var xhr = new XMLHttpRequest();
      xhr.open("GET", url2, true);
      if ("overrideMimeType" in xhr) {
        xhr.overrideMimeType("text/plain");
      }
      xhr.onreadystatechange = function() {
        if (xhr.readyState === 4) {
          if (xhr.status === 0 || xhr.status === 200) {
            successCallback(xhr.responseText);
          } else {
            errorCallback();
            throw new Error("Could not load " + url2);
          }
        }
      };
      return xhr.send(null);
    }
    function getPluginsOrPresetsFromScript(script, attributeName) {
      var rawValue = script.getAttribute(attributeName);
      if (rawValue === "") {
        return [];
      }
      if (!rawValue) {
        return null;
      }
      return rawValue.split(",").map(function(item) {
        return item.trim();
      });
    }
    function loadScripts(transformFn, scripts2) {
      var result = [];
      var count2 = scripts2.length;
      function check() {
        var script, i2;
        for (i2 = 0; i2 < count2; i2++) {
          script = result[i2];
          if (script.loaded && !script.executed) {
            script.executed = true;
            run(transformFn, script);
          } else if (!script.loaded && !script.error && !script.async) {
            break;
          }
        }
      }
      scripts2.forEach(function(script, i2) {
        var scriptData = {
          async: script.hasAttribute("async"),
          type: script.getAttribute("data-type"),
          error: false,
          executed: false,
          plugins: getPluginsOrPresetsFromScript(script, "data-plugins"),
          presets: getPluginsOrPresetsFromScript(script, "data-presets")
        };
        if (script.src) {
          result[i2] = Object.assign({}, scriptData, {
            content: null,
            loaded: false,
            url: script.src
          });
          load(script.src, function(content) {
            result[i2].loaded = true;
            result[i2].content = content;
            check();
          }, function() {
            result[i2].error = true;
            check();
          });
        } else {
          result[i2] = Object.assign({}, scriptData, {
            content: script.innerHTML,
            loaded: true,
            url: script.getAttribute("data-module") || null
          });
        }
      });
      check();
    }
    function runScripts(transformFn, scripts2) {
      headEl = document.getElementsByTagName("head")[0];
      if (!scripts2) {
        scripts2 = document.getElementsByTagName("script");
      }
      var jsxScripts = [];
      for (var i2 = 0; i2 < scripts2.length; i2++) {
        var script = scripts2.item(i2);
        var type5 = script.type.split(";")[0];
        if (scriptTypes.indexOf(type5) !== -1) {
          jsxScripts.push(script);
        }
      }
      if (jsxScripts.length === 0) {
        return;
      }
      console.warn("You are using the in-browser Babel transformer. Be sure to precompile your scripts for production - https://babeljs.io/docs/setup/");
      loadScripts(transformFn, jsxScripts);
    }
    var _window;
    var isArray2 = Array.isArray || function(arg) {
      return Object.prototype.toString.call(arg) === "[object Array]";
    };
    function loadBuiltin(builtinTable, name2) {
      if (isArray2(name2) && typeof name2[0] === "string") {
        if (Object.prototype.hasOwnProperty.call(builtinTable, name2[0])) {
          return [builtinTable[name2[0]]].concat(name2.slice(1));
        }
        return;
      } else if (typeof name2 === "string") {
        return builtinTable[name2];
      }
      return name2;
    }
    function processOptions(options) {
      var presets = (options.presets || []).map(function(presetName) {
        var preset = loadBuiltin(availablePresets, presetName);
        if (preset) {
          if (isArray2(preset) && typeof preset[0] === "object" && Object.prototype.hasOwnProperty.call(preset[0], "buildPreset")) {
            preset[0] = Object.assign({}, preset[0], {
              buildPreset: preset[0].buildPreset
            });
          }
        } else {
          throw new Error('Invalid preset specified in Babel options: "' + presetName + '"');
        }
        return preset;
      });
      var plugins2 = (options.plugins || []).map(function(pluginName) {
        var plugin2 = loadBuiltin(availablePlugins, pluginName);
        if (!plugin2) {
          throw new Error('Invalid plugin specified in Babel options: "' + pluginName + '"');
        }
        return plugin2;
      });
      return Object.assign({
        babelrc: false
      }, options, {
        presets,
        plugins: plugins2
      });
    }
    function transform2(code3, options) {
      return transform$3(code3, processOptions(options));
    }
    function transformFromAst(ast3, code3, options) {
      return transformFromAst$1(ast3, code3, processOptions(options));
    }
    var availablePlugins = {};
    var availablePresets = {};
    var buildExternalHelpers = babelBuildExternalHelpers;
    function registerPlugin(name2, plugin2) {
      if (Object.prototype.hasOwnProperty.call(availablePlugins, name2)) {
        console.warn('A plugin named "' + name2 + '" is already registered, it will be overridden');
      }
      availablePlugins[name2] = plugin2;
    }
    function registerPlugins(newPlugins) {
      Object.keys(newPlugins).forEach(function(name2) {
        return registerPlugin(name2, newPlugins[name2]);
      });
    }
    function registerPreset(name2, preset) {
      if (Object.prototype.hasOwnProperty.call(availablePresets, name2)) {
        if (name2 === "env") {
          console.warn("@babel/preset-env is now included in @babel/standalone, please remove @babel/preset-env-standalone");
        } else {
          console.warn('A preset named "' + name2 + '" is already registered, it will be overridden');
        }
      }
      availablePresets[name2] = preset;
    }
    function registerPresets(newPresets) {
      Object.keys(newPresets).forEach(function(name2) {
        return registerPreset(name2, newPresets[name2]);
      });
    }
    registerPlugins(all);
    registerPresets({
      env: presetEnv,
      es2015: preset2015,
      es2016: function es2016() {
        return {
          plugins: [availablePlugins["transform-exponentiation-operator"]]
        };
      },
      es2017: function es20172() {
        return {
          plugins: [availablePlugins["transform-async-to-generator"]]
        };
      },
      react: presetReact,
      "stage-0": presetStage0,
      "stage-1": presetStage1,
      "stage-2": presetStage2,
      "stage-3": presetStage3,
      "es2015-loose": {
        presets: [[preset2015, {
          loose: true
        }]]
      },
      "es2015-no-commonjs": {
        presets: [[preset2015, {
          modules: false
        }]]
      },
      typescript: presetTypescript,
      flow: presetFlow
    });
    var version2 = "7.17.11";
    function onDOMContentLoaded() {
      transformScriptTags();
    }
    if (typeof window !== "undefined" && (_window = window) != null && _window.addEventListener) {
      window.addEventListener("DOMContentLoaded", onDOMContentLoaded, false);
    }
    function transformScriptTags(scriptTags) {
      runScripts(transform2, scriptTags);
    }
    function disableScriptTags() {
      window.removeEventListener("DOMContentLoaded", onDOMContentLoaded);
    }
    exports2.availablePlugins = availablePlugins;
    exports2.availablePresets = availablePresets;
    exports2.buildExternalHelpers = buildExternalHelpers;
    exports2.disableScriptTags = disableScriptTags;
    exports2.registerPlugin = registerPlugin;
    exports2.registerPlugins = registerPlugins;
    exports2.registerPreset = registerPreset;
    exports2.registerPresets = registerPresets;
    exports2.transform = transform2;
    exports2.transformFromAst = transformFromAst;
    exports2.transformScriptTags = transformScriptTags;
    exports2.version = version2;
    Object.defineProperty(exports2, "__esModule", { value: true });
  });
})(babel, babel.exports);
function useCreateEditor({
  domElement,
  activeId,
  moduleResolver = (moduleName) => null
}) {
  const [currentChart, setCurrentChart] = useState();
  const chartListRef = useRef();
  const codeTemp = useRef();
  const { tool } = useInjection({});
  const event = useChartEventEmitter({ global: true });
  const render2 = (node) => {
    if (domElement)
      ReactDOM.render(node, domElement);
  };
  const require2 = (moduleName) => {
    return moduleResolver(moduleName);
  };
  const getWrapperFunction = (code2) => {
    try {
      const esCode = babel.exports.transform(code2, { presets: ["es2015", "react"] }).code;
      const ast2 = parse3(esCode, {
        sourceType: "module",
        ecmaVersion: 3
      });
      return new Function("React", "render", "require", "instance", escodegen.generate(ast2));
    } catch ({ message }) {
      throw new Error(`${message}`);
    }
  };
  const compile = (code2) => {
    return getWrapperFunction(code2);
  };
  const run = (code2) => {
    var _a2;
    (_a2 = compile == null ? void 0 : compile(code2)) == null ? void 0 : _a2(React__default, render2, require2, currentChart);
    codeTemp.current = code2;
  };
  const getCompiledCode = (code2) => {
    var _a2;
    return (_a2 = getWrapperFunction == null ? void 0 : getWrapperFunction(code2)) == null ? void 0 : _a2.toString();
  };
  useEffect(() => {
    var _a2, _b2;
    if ((_a2 = chartListRef.current) == null ? void 0 : _a2.length)
      setCurrentChart((_b2 = chartListRef.current) == null ? void 0 : _b2.find((item) => item.id === activeId));
  }, [activeId]);
  event.useSubscription("list", () => {
    var _a2, _b2;
    if (tool == null ? void 0 : tool.list().length) {
      chartListRef.current = tool == null ? void 0 : tool.list();
      setCurrentChart((_a2 = chartListRef.current) == null ? void 0 : _a2.find((item) => item.id === activeId));
      if (codeTemp.current)
        (_b2 = compile == null ? void 0 : compile(codeTemp.current)) == null ? void 0 : _b2(React__default, render2, require2, currentChart);
    }
  });
  return {
    compile,
    run,
    getCompiledCode
  };
}
function _extends$1() {
  _extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _defineProperty$3(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _setPrototypeOf$1(o, p2) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf$1(o, p2);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf$1(subClass, superClass);
}
function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf$1(o);
}
function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _typeof$1(obj) {
  "@babel/helpers - typeof";
  return _typeof$1 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$1(obj);
}
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
function _possibleConstructorReturn(self2, call2) {
  if (call2 && (_typeof$1(call2) === "object" || typeof call2 === "function")) {
    return call2;
  } else if (call2 !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
var classnames = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function(module) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames2() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames2.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString === Object.prototype.toString) {
            for (var key in arg) {
              if (hasOwn2.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          } else {
            classes.push(arg.toString());
          }
        }
      }
      return classes.join(" ");
    }
    if (module.exports) {
      classNames2.default = classNames2;
      module.exports = classNames2;
    } else {
      window.classNames = classNames2;
    }
  })();
})(classnames);
var classNames = classnames.exports;
function ownKeys$3(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
    })), keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2$3(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    i % 2 ? ownKeys$3(Object(source), true).forEach(function(key) {
      _defineProperty$3(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function omit(obj, fields) {
  var clone3 = _objectSpread2$3({}, obj);
  if (Array.isArray(fields)) {
    fields.forEach(function(key) {
      delete clone3[key];
    });
  }
  return clone3;
}
var reactIs = { exports: {} };
var reactIs_production_min = {};
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b = typeof Symbol === "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f$1 = b ? Symbol.for("react.strict_mode") : 60108, g$1 = b ? Symbol.for("react.profiler") : 60114, h$1 = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m$1 = b ? Symbol.for("react.concurrent_mode") : 60111, n$1 = b ? Symbol.for("react.forward_ref") : 60112, p$1 = b ? Symbol.for("react.suspense") : 60113, q$1 = b ? Symbol.for("react.suspense_list") : 60120, r = b ? Symbol.for("react.memo") : 60115, t = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y = b ? Symbol.for("react.scope") : 60119;
function z(a) {
  if (typeof a === "object" && a !== null) {
    var u = a.$$typeof;
    switch (u) {
      case c:
        switch (a = a.type, a) {
          case l:
          case m$1:
          case e:
          case g$1:
          case f$1:
          case p$1:
            return a;
          default:
            switch (a = a && a.$$typeof, a) {
              case k:
              case n$1:
              case t:
              case r:
              case h$1:
                return a;
              default:
                return u;
            }
        }
      case d:
        return u;
    }
  }
}
function A(a) {
  return z(a) === m$1;
}
reactIs_production_min.AsyncMode = l;
reactIs_production_min.ConcurrentMode = m$1;
reactIs_production_min.ContextConsumer = k;
reactIs_production_min.ContextProvider = h$1;
reactIs_production_min.Element = c;
reactIs_production_min.ForwardRef = n$1;
reactIs_production_min.Fragment = e;
reactIs_production_min.Lazy = t;
reactIs_production_min.Memo = r;
reactIs_production_min.Portal = d;
reactIs_production_min.Profiler = g$1;
reactIs_production_min.StrictMode = f$1;
reactIs_production_min.Suspense = p$1;
reactIs_production_min.isAsyncMode = function(a) {
  return A(a) || z(a) === l;
};
reactIs_production_min.isConcurrentMode = A;
reactIs_production_min.isContextConsumer = function(a) {
  return z(a) === k;
};
reactIs_production_min.isContextProvider = function(a) {
  return z(a) === h$1;
};
reactIs_production_min.isElement = function(a) {
  return typeof a === "object" && a !== null && a.$$typeof === c;
};
reactIs_production_min.isForwardRef = function(a) {
  return z(a) === n$1;
};
reactIs_production_min.isFragment = function(a) {
  return z(a) === e;
};
reactIs_production_min.isLazy = function(a) {
  return z(a) === t;
};
reactIs_production_min.isMemo = function(a) {
  return z(a) === r;
};
reactIs_production_min.isPortal = function(a) {
  return z(a) === d;
};
reactIs_production_min.isProfiler = function(a) {
  return z(a) === g$1;
};
reactIs_production_min.isStrictMode = function(a) {
  return z(a) === f$1;
};
reactIs_production_min.isSuspense = function(a) {
  return z(a) === p$1;
};
reactIs_production_min.isValidElementType = function(a) {
  return typeof a === "string" || typeof a === "function" || a === e || a === m$1 || a === g$1 || a === f$1 || a === p$1 || a === q$1 || typeof a === "object" && a !== null && (a.$$typeof === t || a.$$typeof === r || a.$$typeof === h$1 || a.$$typeof === k || a.$$typeof === n$1 || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y || a.$$typeof === v);
};
reactIs_production_min.typeOf = z;
{
  reactIs.exports = reactIs_production_min;
}
function toArray$1(children) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var ret = [];
  React__default.Children.forEach(children, function(child) {
    if ((child === void 0 || child === null) && !option.keepEmpty) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(toArray$1(child));
    } else if (reactIs.exports.isFragment(child) && child.props) {
      ret = ret.concat(toArray$1(child.props.children, option));
    } else {
      ret.push(child);
    }
  });
  return ret;
}
var warned = {};
function warning$2(valid, message) {
}
function call(method4, valid, message) {
  if (!valid && !warned[message]) {
    method4(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning$2, valid, message);
}
function useMemo(getValue2, condition, shouldUpdate) {
  var cacheRef = React.useRef({});
  if (!("value" in cacheRef.current) || shouldUpdate(cacheRef.current.condition, condition)) {
    cacheRef.current.value = getValue2();
    cacheRef.current.condition = condition;
  }
  return cacheRef.current.value;
}
function fillRef(ref2, node) {
  if (typeof ref2 === "function") {
    ref2(node);
  } else if (_typeof$1(ref2) === "object" && ref2 && "current" in ref2) {
    ref2.current = node;
  }
}
function composeRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  var refList = refs.filter(function(ref2) {
    return ref2;
  });
  if (refList.length <= 1) {
    return refList[0];
  }
  return function(node) {
    refs.forEach(function(ref2) {
      fillRef(ref2, node);
    });
  };
}
function supportRef(nodeOrComponent) {
  var _type$prototype, _nodeOrComponent$prot;
  var type4 = reactIs.exports.isMemo(nodeOrComponent) ? nodeOrComponent.type.type : nodeOrComponent.type;
  if (typeof type4 === "function" && !((_type$prototype = type4.prototype) === null || _type$prototype === void 0 ? void 0 : _type$prototype.render)) {
    return false;
  }
  if (typeof nodeOrComponent === "function" && !((_nodeOrComponent$prot = nodeOrComponent.prototype) === null || _nodeOrComponent$prot === void 0 ? void 0 : _nodeOrComponent$prot.render)) {
    return false;
  }
  return true;
}
function findDOMNode(node) {
  if (node instanceof HTMLElement) {
    return node;
  }
  return ReactDOM.findDOMNode(node);
}
var elementListeners = /* @__PURE__ */ new Map();
function onResize(entities) {
  entities.forEach(function(entity) {
    var _elementListeners$get;
    var target = entity.target;
    (_elementListeners$get = elementListeners.get(target)) === null || _elementListeners$get === void 0 ? void 0 : _elementListeners$get.forEach(function(listener) {
      return listener(target);
    });
  });
}
var resizeObserver = new index$9(onResize);
function observe(element, callback) {
  if (!elementListeners.has(element)) {
    elementListeners.set(element, /* @__PURE__ */ new Set());
    resizeObserver.observe(element);
  }
  elementListeners.get(element).add(callback);
}
function unobserve(element, callback) {
  if (elementListeners.has(element)) {
    elementListeners.get(element).delete(callback);
    if (!elementListeners.get(element).size) {
      resizeObserver.unobserve(element);
      elementListeners.delete(element);
    }
  }
}
var DomWrapper$1 = /* @__PURE__ */ function(_React$Component) {
  _inherits(DomWrapper2, _React$Component);
  var _super = _createSuper(DomWrapper2);
  function DomWrapper2() {
    _classCallCheck(this, DomWrapper2);
    return _super.apply(this, arguments);
  }
  _createClass(DomWrapper2, [{
    key: "render",
    value: function render2() {
      return this.props.children;
    }
  }]);
  return DomWrapper2;
}(React.Component);
var CollectionContext = /* @__PURE__ */ React.createContext(null);
function Collection(_ref) {
  var children = _ref.children, onBatchResize = _ref.onBatchResize;
  var resizeIdRef = React.useRef(0);
  var resizeInfosRef = React.useRef([]);
  var onCollectionResize = React.useContext(CollectionContext);
  var onResize2 = React.useCallback(function(size, element, data2) {
    resizeIdRef.current += 1;
    var currentId = resizeIdRef.current;
    resizeInfosRef.current.push({
      size,
      element,
      data: data2
    });
    Promise.resolve().then(function() {
      if (currentId === resizeIdRef.current) {
        onBatchResize === null || onBatchResize === void 0 ? void 0 : onBatchResize(resizeInfosRef.current);
        resizeInfosRef.current = [];
      }
    });
    onCollectionResize === null || onCollectionResize === void 0 ? void 0 : onCollectionResize(size, element, data2);
  }, [onBatchResize, onCollectionResize]);
  return /* @__PURE__ */ React.createElement(CollectionContext.Provider, {
    value: onResize2
  }, children);
}
function SingleObserver(props) {
  var children = props.children, disabled = props.disabled;
  var elementRef = React.useRef(null);
  var wrapperRef = React.useRef(null);
  var onCollectionResize = React.useContext(CollectionContext);
  var isRenderProps = typeof children === "function";
  var mergedChildren = isRenderProps ? children(elementRef) : children;
  var sizeRef = React.useRef({
    width: -1,
    height: -1,
    offsetWidth: -1,
    offsetHeight: -1
  });
  var canRef = !isRenderProps && /* @__PURE__ */ React.isValidElement(mergedChildren) && supportRef(mergedChildren);
  var originRef = canRef ? mergedChildren.ref : null;
  var mergedRef = React.useMemo(function() {
    return composeRef(originRef, elementRef);
  }, [originRef, elementRef]);
  var propsRef = React.useRef(props);
  propsRef.current = props;
  var onInternalResize = React.useCallback(function(target) {
    var _propsRef$current = propsRef.current, onResize2 = _propsRef$current.onResize, data2 = _propsRef$current.data;
    var _target$getBoundingCl = target.getBoundingClientRect(), width = _target$getBoundingCl.width, height = _target$getBoundingCl.height;
    var offsetWidth = target.offsetWidth, offsetHeight = target.offsetHeight;
    var fixedWidth = Math.floor(width);
    var fixedHeight = Math.floor(height);
    if (sizeRef.current.width !== fixedWidth || sizeRef.current.height !== fixedHeight || sizeRef.current.offsetWidth !== offsetWidth || sizeRef.current.offsetHeight !== offsetHeight) {
      var size = {
        width: fixedWidth,
        height: fixedHeight,
        offsetWidth,
        offsetHeight
      };
      sizeRef.current = size;
      var mergedOffsetWidth = offsetWidth === Math.round(width) ? width : offsetWidth;
      var mergedOffsetHeight = offsetHeight === Math.round(height) ? height : offsetHeight;
      var sizeInfo = _objectSpread2$3(_objectSpread2$3({}, size), {}, {
        offsetWidth: mergedOffsetWidth,
        offsetHeight: mergedOffsetHeight
      });
      onCollectionResize === null || onCollectionResize === void 0 ? void 0 : onCollectionResize(sizeInfo, target, data2);
      if (onResize2) {
        Promise.resolve().then(function() {
          onResize2(sizeInfo, target);
        });
      }
    }
  }, []);
  React.useEffect(function() {
    var currentElement = findDOMNode(elementRef.current) || findDOMNode(wrapperRef.current);
    if (currentElement && !disabled) {
      observe(currentElement, onInternalResize);
    }
    return function() {
      return unobserve(currentElement, onInternalResize);
    };
  }, [elementRef.current, disabled]);
  return /* @__PURE__ */ React.createElement(DomWrapper$1, {
    ref: wrapperRef
  }, canRef ? /* @__PURE__ */ React.cloneElement(mergedChildren, {
    ref: mergedRef
  }) : mergedChildren);
}
var INTERNAL_PREFIX_KEY = "rc-observer-key";
function ResizeObserver(props) {
  var children = props.children;
  var childNodes = typeof children === "function" ? [children] : toArray$1(children);
  return childNodes.map(function(child, index2) {
    var key = (child === null || child === void 0 ? void 0 : child.key) || "".concat(INTERNAL_PREFIX_KEY, "-").concat(index2);
    return /* @__PURE__ */ React.createElement(SingleObserver, _extends$1({}, props, {
      key
    }), child);
  });
}
ResizeObserver.Collection = Collection;
var IconContext = /* @__PURE__ */ createContext({});
var Context$1 = IconContext;
function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties$1(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose$1(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _arrayLikeToArray$1(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray$1(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _unsupportedIterableToArray$1(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$1(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray$1(o, minLen);
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray$1(arr) || _nonIterableSpread();
}
var HOOK_MARK = "RC_FORM_INTERNAL_HOOKS";
var warningFunc = function warningFunc2() {
  warningOnce(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
};
var Context = /* @__PURE__ */ React.createContext({
  getFieldValue: warningFunc,
  getFieldsValue: warningFunc,
  getFieldError: warningFunc,
  getFieldWarning: warningFunc,
  getFieldsError: warningFunc,
  isFieldsTouched: warningFunc,
  isFieldTouched: warningFunc,
  isFieldValidating: warningFunc,
  isFieldsValidating: warningFunc,
  resetFields: warningFunc,
  setFields: warningFunc,
  setFieldsValue: warningFunc,
  validateFields: warningFunc,
  submit: warningFunc,
  getInternalHooks: function getInternalHooks() {
    warningFunc();
    return {
      dispatch: warningFunc,
      initEntityValue: warningFunc,
      registerField: warningFunc,
      useSubscribe: warningFunc,
      setInitialValues: warningFunc,
      setCallbacks: warningFunc,
      getFields: warningFunc,
      setValidateMessages: warningFunc,
      setPreserve: warningFunc,
      getInitialValue: warningFunc
    };
  }
});
function toArray(value) {
  if (value === void 0 || value === null) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var runtime = { exports: {} };
(function(module) {
  var runtime2 = function(exports) {
    var Op = Object.prototype;
    var hasOwn2 = Op.hasOwnProperty;
    var undefined$1;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self2, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context2(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self2, context);
      return generator;
    }
    exports.wrap = wrap;
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }
    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};
    function Generator() {
    }
    function GeneratorFunction() {
    }
    function GeneratorFunctionPrototype() {
    }
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function() {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn2.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method4) {
        define(prototype, method4, function(arg) {
          return this._invoke(method4, arg);
        });
      });
    }
    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };
    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };
    exports.awrap = function(arg) {
      return { __await: arg };
    };
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method4, arg, resolve, reject) {
        var record = tryCatch(generator[method4], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value && typeof value === "object" && hasOwn2.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }
          return PromiseImpl.resolve(value).then(function(unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }
      var previousPromise;
      function enqueue(method4, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method4, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
      this._invoke = enqueue;
    }
    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function() {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;
    exports.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0)
        PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
        return result.done ? result.value : iter.next();
      });
    };
    function makeInvokeMethod(innerFn, self2, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method4, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }
        if (state === GenStateCompleted) {
          if (method4 === "throw") {
            throw arg;
          }
          return doneResult();
        }
        context.method = method4;
        context.arg = arg;
        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel)
                continue;
              return delegateResult;
            }
          }
          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }
            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }
          state = GenStateExecuting;
          var record = tryCatch(innerFn, self2, context);
          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;
            if (record.arg === ContinueSentinel) {
              continue;
            }
            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var method4 = delegate.iterator[context.method];
      if (method4 === undefined$1) {
        context.delegate = null;
        if (context.method === "throw") {
          if (delegate.iterator["return"]) {
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);
            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }
          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }
        return ContinueSentinel;
      }
      var record = tryCatch(method4, delegate.iterator, context.arg);
      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }
      var info = record.arg;
      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }
      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        return info;
      }
      context.delegate = null;
      return ContinueSentinel;
    }
    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator");
    define(Gp, iteratorSymbol, function() {
      return this;
    });
    define(Gp, "toString", function() {
      return "[object Generator]";
    });
    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };
      if (1 in locs) {
        entry.catchLoc = locs[1];
      }
      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }
      this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }
    function Context2(tryLocsList) {
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }
    exports.keys = function(object4) {
      var keys2 = [];
      for (var key in object4) {
        keys2.push(key);
      }
      keys2.reverse();
      return function next() {
        while (keys2.length) {
          var key2 = keys2.pop();
          if (key2 in object4) {
            next.value = key2;
            next.done = false;
            return next;
          }
        }
        next.done = true;
        return next;
      };
    };
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }
        if (typeof iterable.next === "function") {
          return iterable;
        }
        if (!isNaN(iterable.length)) {
          var i = -1, next = function next2() {
            while (++i < iterable.length) {
              if (hasOwn2.call(iterable, i)) {
                next2.value = iterable[i];
                next2.done = false;
                return next2;
              }
            }
            next2.value = undefined$1;
            next2.done = true;
            return next2;
          };
          return next.next = next;
        }
      }
      return { next: doneResult };
    }
    exports.values = values;
    function doneResult() {
      return { value: undefined$1, done: true };
    }
    Context2.prototype = {
      constructor: Context2,
      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);
        if (!skipTempReset) {
          for (var name2 in this) {
            if (name2.charAt(0) === "t" && hasOwn2.call(this, name2) && !isNaN(+name2.slice(1))) {
              this[name2] = undefined$1;
            }
          }
        }
      },
      stop: function() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }
        return this.rval;
      },
      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }
        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;
          if (caught) {
            context.method = "next";
            context.arg = undefined$1;
          }
          return !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;
          if (entry.tryLoc === "root") {
            return handle("end");
          }
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn2.call(entry, "catchLoc");
            var hasFinally = hasOwn2.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function(type4, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn2.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        if (finallyEntry && (type4 === "break" || type4 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }
        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type4;
        record.arg = arg;
        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }
        return this.complete(record);
      },
      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }
        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }
        return ContinueSentinel;
      },
      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName,
          nextLoc
        };
        if (this.method === "next") {
          this.arg = undefined$1;
        }
        return ContinueSentinel;
      }
    };
    return exports;
  }(module.exports);
  try {
    regeneratorRuntime = runtime2;
  } catch (accidentalStrictMode) {
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime2;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime2);
    }
  }
})(runtime);
var regenerator = runtime.exports;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var formatRegExp = /%[sdj%]/g;
var warning$1 = function warning() {
};
if (typeof process !== "undefined" && process.env && false) {
  warning$1 = function warning3(type4, errors) {
    if (typeof console !== "undefined" && console.warn && typeof ASYNC_VALIDATOR_NO_WARNING === "undefined") {
      if (errors.every(function(e2) {
        return typeof e2 === "string";
      })) {
        console.warn(type4, errors);
      }
    }
  };
}
function convertFieldsError(errors) {
  if (!errors || !errors.length)
    return null;
  var fields = {};
  errors.forEach(function(error) {
    var field = error.field;
    fields[field] = fields[field] || [];
    fields[field].push(error);
  });
  return fields;
}
function format(template) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var i = 0;
  var len2 = args.length;
  if (typeof template === "function") {
    return template.apply(null, args);
  }
  if (typeof template === "string") {
    var str = template.replace(formatRegExp, function(x2) {
      if (x2 === "%%") {
        return "%";
      }
      if (i >= len2) {
        return x2;
      }
      switch (x2) {
        case "%s":
          return String(args[i++]);
        case "%d":
          return Number(args[i++]);
        case "%j":
          try {
            return JSON.stringify(args[i++]);
          } catch (_) {
            return "[Circular]";
          }
          break;
        default:
          return x2;
      }
    });
    return str;
  }
  return template;
}
function isNativeStringType(type4) {
  return type4 === "string" || type4 === "url" || type4 === "hex" || type4 === "email" || type4 === "date" || type4 === "pattern";
}
function isEmptyValue(value, type4) {
  if (value === void 0 || value === null) {
    return true;
  }
  if (type4 === "array" && Array.isArray(value) && !value.length) {
    return true;
  }
  if (isNativeStringType(type4) && typeof value === "string" && !value) {
    return true;
  }
  return false;
}
function asyncParallelArray(arr, func, callback) {
  var results = [];
  var total = 0;
  var arrLength = arr.length;
  function count2(errors) {
    results.push.apply(results, errors || []);
    total++;
    if (total === arrLength) {
      callback(results);
    }
  }
  arr.forEach(function(a) {
    func(a, count2);
  });
}
function asyncSerialArray(arr, func, callback) {
  var index2 = 0;
  var arrLength = arr.length;
  function next(errors) {
    if (errors && errors.length) {
      callback(errors);
      return;
    }
    var original = index2;
    index2 = index2 + 1;
    if (original < arrLength) {
      func(arr[original], next);
    } else {
      callback([]);
    }
  }
  next([]);
}
function flattenObjArr(objArr) {
  var ret = [];
  Object.keys(objArr).forEach(function(k2) {
    ret.push.apply(ret, objArr[k2] || []);
  });
  return ret;
}
var AsyncValidationError = /* @__PURE__ */ function(_Error) {
  _inheritsLoose(AsyncValidationError2, _Error);
  function AsyncValidationError2(errors, fields) {
    var _this;
    _this = _Error.call(this, "Async Validation Error") || this;
    _this.errors = errors;
    _this.fields = fields;
    return _this;
  }
  return AsyncValidationError2;
}(/* @__PURE__ */ _wrapNativeSuper(Error));
function asyncMap(objArr, option, func, callback, source) {
  if (option.first) {
    var _pending = new Promise(function(resolve, reject) {
      var next = function next2(errors) {
        callback(errors);
        return errors.length ? reject(new AsyncValidationError(errors, convertFieldsError(errors))) : resolve(source);
      };
      var flattenArr = flattenObjArr(objArr);
      asyncSerialArray(flattenArr, func, next);
    });
    _pending["catch"](function(e2) {
      return e2;
    });
    return _pending;
  }
  var firstFields = option.firstFields === true ? Object.keys(objArr) : option.firstFields || [];
  var objArrKeys = Object.keys(objArr);
  var objArrLength = objArrKeys.length;
  var total = 0;
  var results = [];
  var pending = new Promise(function(resolve, reject) {
    var next = function next2(errors) {
      results.push.apply(results, errors);
      total++;
      if (total === objArrLength) {
        callback(results);
        return results.length ? reject(new AsyncValidationError(results, convertFieldsError(results))) : resolve(source);
      }
    };
    if (!objArrKeys.length) {
      callback(results);
      resolve(source);
    }
    objArrKeys.forEach(function(key) {
      var arr = objArr[key];
      if (firstFields.indexOf(key) !== -1) {
        asyncSerialArray(arr, func, next);
      } else {
        asyncParallelArray(arr, func, next);
      }
    });
  });
  pending["catch"](function(e2) {
    return e2;
  });
  return pending;
}
function isErrorObj(obj) {
  return !!(obj && obj.message !== void 0);
}
function getValue$2(value, path) {
  var v4 = value;
  for (var i = 0; i < path.length; i++) {
    if (v4 == void 0) {
      return v4;
    }
    v4 = v4[path[i]];
  }
  return v4;
}
function complementError(rule, source) {
  return function(oe2) {
    var fieldValue;
    if (rule.fullFields) {
      fieldValue = getValue$2(source, rule.fullFields);
    } else {
      fieldValue = source[oe2.field || rule.fullField];
    }
    if (isErrorObj(oe2)) {
      oe2.field = oe2.field || rule.fullField;
      oe2.fieldValue = fieldValue;
      return oe2;
    }
    return {
      message: typeof oe2 === "function" ? oe2() : oe2,
      fieldValue,
      field: oe2.field || rule.fullField
    };
  };
}
function deepMerge(target, source) {
  if (source) {
    for (var s in source) {
      if (source.hasOwnProperty(s)) {
        var value = source[s];
        if (typeof value === "object" && typeof target[s] === "object") {
          target[s] = _extends({}, target[s], value);
        } else {
          target[s] = value;
        }
      }
    }
  }
  return target;
}
var required$1 = function required(rule, value, source, errors, options, type4) {
  if (rule.required && (!source.hasOwnProperty(rule.field) || isEmptyValue(value, type4 || rule.type))) {
    errors.push(format(options.messages.required, rule.fullField));
  }
};
var whitespace = function whitespace2(rule, value, source, errors, options) {
  if (/^\s+$/.test(value) || value === "") {
    errors.push(format(options.messages.whitespace, rule.fullField));
  }
};
var pattern$2 = {
  email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/,
  url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"),
  hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i
};
var types = {
  integer: function integer(value) {
    return types.number(value) && parseInt(value, 10) === value;
  },
  "float": function float(value) {
    return types.number(value) && !types.integer(value);
  },
  array: function array(value) {
    return Array.isArray(value);
  },
  regexp: function regexp(value) {
    if (value instanceof RegExp) {
      return true;
    }
    try {
      return !!new RegExp(value);
    } catch (e2) {
      return false;
    }
  },
  date: function date(value) {
    return typeof value.getTime === "function" && typeof value.getMonth === "function" && typeof value.getYear === "function" && !isNaN(value.getTime());
  },
  number: function number(value) {
    if (isNaN(value)) {
      return false;
    }
    return typeof value === "number";
  },
  object: function object(value) {
    return typeof value === "object" && !types.array(value);
  },
  method: function method(value) {
    return typeof value === "function";
  },
  email: function email(value) {
    return typeof value === "string" && value.length <= 320 && !!value.match(pattern$2.email);
  },
  url: function url(value) {
    return typeof value === "string" && value.length <= 2048 && !!value.match(pattern$2.url);
  },
  hex: function hex(value) {
    return typeof value === "string" && !!value.match(pattern$2.hex);
  }
};
var type$1 = function type(rule, value, source, errors, options) {
  if (rule.required && value === void 0) {
    required$1(rule, value, source, errors, options);
    return;
  }
  var custom = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"];
  var ruleType = rule.type;
  if (custom.indexOf(ruleType) > -1) {
    if (!types[ruleType](value)) {
      errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
    }
  } else if (ruleType && typeof value !== rule.type) {
    errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
  }
};
var range = function range2(rule, value, source, errors, options) {
  var len2 = typeof rule.len === "number";
  var min3 = typeof rule.min === "number";
  var max3 = typeof rule.max === "number";
  var spRegexp = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
  var val = value;
  var key = null;
  var num = typeof value === "number";
  var str = typeof value === "string";
  var arr = Array.isArray(value);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = value.length;
  }
  if (str) {
    val = value.replace(spRegexp, "_").length;
  }
  if (len2) {
    if (val !== rule.len) {
      errors.push(format(options.messages[key].len, rule.fullField, rule.len));
    }
  } else if (min3 && !max3 && val < rule.min) {
    errors.push(format(options.messages[key].min, rule.fullField, rule.min));
  } else if (max3 && !min3 && val > rule.max) {
    errors.push(format(options.messages[key].max, rule.fullField, rule.max));
  } else if (min3 && max3 && (val < rule.min || val > rule.max)) {
    errors.push(format(options.messages[key].range, rule.fullField, rule.min, rule.max));
  }
};
var ENUM$1 = "enum";
var enumerable$1 = function enumerable(rule, value, source, errors, options) {
  rule[ENUM$1] = Array.isArray(rule[ENUM$1]) ? rule[ENUM$1] : [];
  if (rule[ENUM$1].indexOf(value) === -1) {
    errors.push(format(options.messages[ENUM$1], rule.fullField, rule[ENUM$1].join(", ")));
  }
};
var pattern$1 = function pattern(rule, value, source, errors, options) {
  if (rule.pattern) {
    if (rule.pattern instanceof RegExp) {
      rule.pattern.lastIndex = 0;
      if (!rule.pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    } else if (typeof rule.pattern === "string") {
      var _pattern = new RegExp(rule.pattern);
      if (!_pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    }
  }
};
var rules = {
  required: required$1,
  whitespace,
  type: type$1,
  range,
  "enum": enumerable$1,
  pattern: pattern$1
};
var string = function string2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "string");
    if (!isEmptyValue(value, "string")) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
      rules.pattern(rule, value, source, errors, options);
      if (rule.whitespace === true) {
        rules.whitespace(rule, value, source, errors, options);
      }
    }
  }
  callback(errors);
};
var method2 = function method3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var number2 = function number3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (value === "") {
      value = void 0;
    }
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var _boolean = function _boolean2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var regexp2 = function regexp3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var integer2 = function integer3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var floatFn = function floatFn2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var array2 = function array3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if ((value === void 0 || value === null) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "array");
    if (value !== void 0 && value !== null) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var object2 = function object3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var ENUM = "enum";
var enumerable2 = function enumerable3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules[ENUM](rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var pattern2 = function pattern3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "string")) {
      rules.pattern(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var date2 = function date3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "date") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "date")) {
      var dateObject;
      if (value instanceof Date) {
        dateObject = value;
      } else {
        dateObject = new Date(value);
      }
      rules.type(rule, dateObject, source, errors, options);
      if (dateObject) {
        rules.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
};
var required2 = function required3(rule, value, callback, source, options) {
  var errors = [];
  var type4 = Array.isArray(value) ? "array" : typeof value;
  rules.required(rule, value, source, errors, options, type4);
  callback(errors);
};
var type2 = function type3(rule, value, callback, source, options) {
  var ruleType = rule.type;
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, ruleType) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, ruleType);
    if (!isEmptyValue(value, ruleType)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var any = function any2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
  }
  callback(errors);
};
var validators$2 = {
  string,
  method: method2,
  number: number2,
  "boolean": _boolean,
  regexp: regexp2,
  integer: integer2,
  "float": floatFn,
  array: array2,
  object: object2,
  "enum": enumerable2,
  pattern: pattern2,
  date: date2,
  url: type2,
  hex: type2,
  email: type2,
  required: required2,
  any
};
function newMessages() {
  return {
    "default": "Validation error on field %s",
    required: "%s is required",
    "enum": "%s must be one of %s",
    whitespace: "%s cannot be empty",
    date: {
      format: "%s date %s is invalid for format %s",
      parse: "%s date could not be parsed, %s is invalid ",
      invalid: "%s date %s is invalid"
    },
    types: {
      string: "%s is not a %s",
      method: "%s is not a %s (function)",
      array: "%s is not an %s",
      object: "%s is not an %s",
      number: "%s is not a %s",
      date: "%s is not a %s",
      "boolean": "%s is not a %s",
      integer: "%s is not an %s",
      "float": "%s is not a %s",
      regexp: "%s is not a valid %s",
      email: "%s is not a valid %s",
      url: "%s is not a valid %s",
      hex: "%s is not a valid %s"
    },
    string: {
      len: "%s must be exactly %s characters",
      min: "%s must be at least %s characters",
      max: "%s cannot be longer than %s characters",
      range: "%s must be between %s and %s characters"
    },
    number: {
      len: "%s must equal %s",
      min: "%s cannot be less than %s",
      max: "%s cannot be greater than %s",
      range: "%s must be between %s and %s"
    },
    array: {
      len: "%s must be exactly %s in length",
      min: "%s cannot be less than %s in length",
      max: "%s cannot be greater than %s in length",
      range: "%s must be between %s and %s in length"
    },
    pattern: {
      mismatch: "%s value %s does not match pattern %s"
    },
    clone: function clone3() {
      var cloned = JSON.parse(JSON.stringify(this));
      cloned.clone = this.clone;
      return cloned;
    }
  };
}
var messages = newMessages();
var Schema = /* @__PURE__ */ function() {
  function Schema2(descriptor) {
    this.rules = null;
    this._messages = messages;
    this.define(descriptor);
  }
  var _proto = Schema2.prototype;
  _proto.define = function define(rules2) {
    var _this = this;
    if (!rules2) {
      throw new Error("Cannot configure a schema with no rules");
    }
    if (typeof rules2 !== "object" || Array.isArray(rules2)) {
      throw new Error("Rules must be an object");
    }
    this.rules = {};
    Object.keys(rules2).forEach(function(name2) {
      var item = rules2[name2];
      _this.rules[name2] = Array.isArray(item) ? item : [item];
    });
  };
  _proto.messages = function messages2(_messages) {
    if (_messages) {
      this._messages = deepMerge(newMessages(), _messages);
    }
    return this._messages;
  };
  _proto.validate = function validate(source_, o, oc2) {
    var _this2 = this;
    if (o === void 0) {
      o = {};
    }
    if (oc2 === void 0) {
      oc2 = function oc3() {
      };
    }
    var source = source_;
    var options = o;
    var callback = oc2;
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    if (!this.rules || Object.keys(this.rules).length === 0) {
      if (callback) {
        callback(null, source);
      }
      return Promise.resolve(source);
    }
    function complete(results) {
      var errors = [];
      var fields = {};
      function add2(e2) {
        if (Array.isArray(e2)) {
          var _errors;
          errors = (_errors = errors).concat.apply(_errors, e2);
        } else {
          errors.push(e2);
        }
      }
      for (var i = 0; i < results.length; i++) {
        add2(results[i]);
      }
      if (!errors.length) {
        callback(null, source);
      } else {
        fields = convertFieldsError(errors);
        callback(errors, fields);
      }
    }
    if (options.messages) {
      var messages$1 = this.messages();
      if (messages$1 === messages) {
        messages$1 = newMessages();
      }
      deepMerge(messages$1, options.messages);
      options.messages = messages$1;
    } else {
      options.messages = this.messages();
    }
    var series = {};
    var keys2 = options.keys || Object.keys(this.rules);
    keys2.forEach(function(z2) {
      var arr = _this2.rules[z2];
      var value = source[z2];
      arr.forEach(function(r2) {
        var rule = r2;
        if (typeof rule.transform === "function") {
          if (source === source_) {
            source = _extends({}, source);
          }
          value = source[z2] = rule.transform(value);
        }
        if (typeof rule === "function") {
          rule = {
            validator: rule
          };
        } else {
          rule = _extends({}, rule);
        }
        rule.validator = _this2.getValidationMethod(rule);
        if (!rule.validator) {
          return;
        }
        rule.field = z2;
        rule.fullField = rule.fullField || z2;
        rule.type = _this2.getType(rule);
        series[z2] = series[z2] || [];
        series[z2].push({
          rule,
          value,
          source,
          field: z2
        });
      });
    });
    var errorFields = {};
    return asyncMap(series, options, function(data2, doIt) {
      var rule = data2.rule;
      var deep = (rule.type === "object" || rule.type === "array") && (typeof rule.fields === "object" || typeof rule.defaultField === "object");
      deep = deep && (rule.required || !rule.required && data2.value);
      rule.field = data2.field;
      function addFullField(key, schema) {
        return _extends({}, schema, {
          fullField: rule.fullField + "." + key,
          fullFields: rule.fullFields ? [].concat(rule.fullFields, [key]) : [key]
        });
      }
      function cb2(e2) {
        if (e2 === void 0) {
          e2 = [];
        }
        var errorList = Array.isArray(e2) ? e2 : [e2];
        if (!options.suppressWarning && errorList.length) {
          Schema2.warning("async-validator:", errorList);
        }
        if (errorList.length && rule.message !== void 0) {
          errorList = [].concat(rule.message);
        }
        var filledErrors = errorList.map(complementError(rule, source));
        if (options.first && filledErrors.length) {
          errorFields[rule.field] = 1;
          return doIt(filledErrors);
        }
        if (!deep) {
          doIt(filledErrors);
        } else {
          if (rule.required && !data2.value) {
            if (rule.message !== void 0) {
              filledErrors = [].concat(rule.message).map(complementError(rule, source));
            } else if (options.error) {
              filledErrors = [options.error(rule, format(options.messages.required, rule.field))];
            }
            return doIt(filledErrors);
          }
          var fieldsSchema = {};
          if (rule.defaultField) {
            Object.keys(data2.value).map(function(key) {
              fieldsSchema[key] = rule.defaultField;
            });
          }
          fieldsSchema = _extends({}, fieldsSchema, data2.rule.fields);
          var paredFieldsSchema = {};
          Object.keys(fieldsSchema).forEach(function(field) {
            var fieldSchema = fieldsSchema[field];
            var fieldSchemaList = Array.isArray(fieldSchema) ? fieldSchema : [fieldSchema];
            paredFieldsSchema[field] = fieldSchemaList.map(addFullField.bind(null, field));
          });
          var schema = new Schema2(paredFieldsSchema);
          schema.messages(options.messages);
          if (data2.rule.options) {
            data2.rule.options.messages = options.messages;
            data2.rule.options.error = options.error;
          }
          schema.validate(data2.value, data2.rule.options || options, function(errs) {
            var finalErrors = [];
            if (filledErrors && filledErrors.length) {
              finalErrors.push.apply(finalErrors, filledErrors);
            }
            if (errs && errs.length) {
              finalErrors.push.apply(finalErrors, errs);
            }
            doIt(finalErrors.length ? finalErrors : null);
          });
        }
      }
      var res2;
      if (rule.asyncValidator) {
        res2 = rule.asyncValidator(rule, data2.value, cb2, data2.source, options);
      } else if (rule.validator) {
        res2 = rule.validator(rule, data2.value, cb2, data2.source, options);
        if (res2 === true) {
          cb2();
        } else if (res2 === false) {
          cb2(typeof rule.message === "function" ? rule.message(rule.fullField || rule.field) : rule.message || (rule.fullField || rule.field) + " fails");
        } else if (res2 instanceof Array) {
          cb2(res2);
        } else if (res2 instanceof Error) {
          cb2(res2.message);
        }
      }
      if (res2 && res2.then) {
        res2.then(function() {
          return cb2();
        }, function(e2) {
          return cb2(e2);
        });
      }
    }, function(results) {
      complete(results);
    }, source);
  };
  _proto.getType = function getType(rule) {
    if (rule.type === void 0 && rule.pattern instanceof RegExp) {
      rule.type = "pattern";
    }
    if (typeof rule.validator !== "function" && rule.type && !validators$2.hasOwnProperty(rule.type)) {
      throw new Error(format("Unknown rule type %s", rule.type));
    }
    return rule.type || "string";
  };
  _proto.getValidationMethod = function getValidationMethod(rule) {
    if (typeof rule.validator === "function") {
      return rule.validator;
    }
    var keys2 = Object.keys(rule);
    var messageIndex = keys2.indexOf("message");
    if (messageIndex !== -1) {
      keys2.splice(messageIndex, 1);
    }
    if (keys2.length === 1 && keys2[0] === "required") {
      return validators$2.required;
    }
    return validators$2[this.getType(rule)] || void 0;
  };
  return Schema2;
}();
Schema.register = function register2(type4, validator) {
  if (typeof validator !== "function") {
    throw new Error("Cannot register a validator by type, validator is not a function");
  }
  validators$2[type4] = validator;
};
Schema.warning = warning$1;
Schema.messages = messages;
Schema.validators = validators$2;
var typeTemplate$1 = "'${name}' is not a valid ${type}";
var defaultValidateMessages = {
  default: "Validation error on field '${name}'",
  required: "'${name}' is required",
  enum: "'${name}' must be one of [${enum}]",
  whitespace: "'${name}' cannot be empty",
  date: {
    format: "'${name}' is invalid for format date",
    parse: "'${name}' could not be parsed as date",
    invalid: "'${name}' is invalid date"
  },
  types: {
    string: typeTemplate$1,
    method: typeTemplate$1,
    array: typeTemplate$1,
    object: typeTemplate$1,
    number: typeTemplate$1,
    date: typeTemplate$1,
    boolean: typeTemplate$1,
    integer: typeTemplate$1,
    float: typeTemplate$1,
    regexp: typeTemplate$1,
    email: typeTemplate$1,
    url: typeTemplate$1,
    hex: typeTemplate$1
  },
  string: {
    len: "'${name}' must be exactly ${len} characters",
    min: "'${name}' must be at least ${min} characters",
    max: "'${name}' cannot be longer than ${max} characters",
    range: "'${name}' must be between ${min} and ${max} characters"
  },
  number: {
    len: "'${name}' must equal ${len}",
    min: "'${name}' cannot be less than ${min}",
    max: "'${name}' cannot be greater than ${max}",
    range: "'${name}' must be between ${min} and ${max}"
  },
  array: {
    len: "'${name}' must be exactly ${len} in length",
    min: "'${name}' cannot be less than ${min} in length",
    max: "'${name}' cannot be greater than ${max} in length",
    range: "'${name}' must be between ${min} and ${max} in length"
  },
  pattern: {
    mismatch: "'${name}' does not match pattern ${pattern}"
  }
};
function get(entity, path) {
  var current2 = entity;
  for (var i = 0; i < path.length; i += 1) {
    if (current2 === null || current2 === void 0) {
      return void 0;
    }
    current2 = current2[path[i]];
  }
  return current2;
}
function _arrayWithHoles$1(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _nonIterableRest$1() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toArray(arr) {
  return _arrayWithHoles$1(arr) || _iterableToArray(arr) || _unsupportedIterableToArray$1(arr) || _nonIterableRest$1();
}
function internalSet(entity, paths, value, removeIfUndefined) {
  if (!paths.length) {
    return value;
  }
  var _paths = _toArray(paths), path = _paths[0], restPath = _paths.slice(1);
  var clone3;
  if (!entity && typeof path === "number") {
    clone3 = [];
  } else if (Array.isArray(entity)) {
    clone3 = _toConsumableArray(entity);
  } else {
    clone3 = _objectSpread2$3({}, entity);
  }
  if (removeIfUndefined && value === void 0 && restPath.length === 1) {
    delete clone3[path][restPath[0]];
  } else {
    clone3[path] = internalSet(clone3[path], restPath, value, removeIfUndefined);
  }
  return clone3;
}
function set(entity, paths, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  if (paths.length && removeIfUndefined && value === void 0 && !get(entity, paths.slice(0, -1))) {
    return entity;
  }
  return internalSet(entity, paths, value, removeIfUndefined);
}
function getNamePath(path) {
  return toArray(path);
}
function getValue$1(store, namePath) {
  var value = get(store, namePath);
  return value;
}
function setValue(store, namePath, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  var newStore = set(store, namePath, value, removeIfUndefined);
  return newStore;
}
function cloneByNamePathList(store, namePathList) {
  var newStore = {};
  namePathList.forEach(function(namePath) {
    var value = getValue$1(store, namePath);
    newStore = setValue(newStore, namePath, value);
  });
  return newStore;
}
function containsNamePath(namePathList, namePath) {
  return namePathList && namePathList.some(function(path) {
    return matchNamePath(path, namePath);
  });
}
function isObject$2(obj) {
  return _typeof$1(obj) === "object" && obj !== null && Object.getPrototypeOf(obj) === Object.prototype;
}
function internalSetValues(store, values) {
  var newStore = Array.isArray(store) ? _toConsumableArray(store) : _objectSpread2$3({}, store);
  if (!values) {
    return newStore;
  }
  Object.keys(values).forEach(function(key) {
    var prevValue = newStore[key];
    var value = values[key];
    var recursive = isObject$2(prevValue) && isObject$2(value);
    newStore[key] = recursive ? internalSetValues(prevValue, value || {}) : value;
  });
  return newStore;
}
function setValues(store) {
  for (var _len = arguments.length, restValues = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    restValues[_key - 1] = arguments[_key];
  }
  return restValues.reduce(function(current2, newStore) {
    return internalSetValues(current2, newStore);
  }, store);
}
function matchNamePath(namePath, changedNamePath) {
  if (!namePath || !changedNamePath || namePath.length !== changedNamePath.length) {
    return false;
  }
  return namePath.every(function(nameUnit, i) {
    return changedNamePath[i] === nameUnit;
  });
}
function isSimilar(source, target) {
  if (source === target) {
    return true;
  }
  if (!source && target || source && !target) {
    return false;
  }
  if (!source || !target || _typeof$1(source) !== "object" || _typeof$1(target) !== "object") {
    return false;
  }
  var sourceKeys = Object.keys(source);
  var targetKeys = Object.keys(target);
  var keys2 = new Set([].concat(_toConsumableArray(sourceKeys), _toConsumableArray(targetKeys)));
  return _toConsumableArray(keys2).every(function(key) {
    var sourceValue = source[key];
    var targetValue = target[key];
    if (typeof sourceValue === "function" && typeof targetValue === "function") {
      return true;
    }
    return sourceValue === targetValue;
  });
}
function defaultGetValueFromEvent(valuePropName) {
  var event = arguments.length <= 1 ? void 0 : arguments[1];
  if (event && event.target && _typeof$1(event.target) === "object" && valuePropName in event.target) {
    return event.target[valuePropName];
  }
  return event;
}
function move(array4, moveIndex, toIndex) {
  var length = array4.length;
  if (moveIndex < 0 || moveIndex >= length || toIndex < 0 || toIndex >= length) {
    return array4;
  }
  var item = array4[moveIndex];
  var diff = moveIndex - toIndex;
  if (diff > 0) {
    return [].concat(_toConsumableArray(array4.slice(0, toIndex)), [item], _toConsumableArray(array4.slice(toIndex, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, length)));
  }
  if (diff < 0) {
    return [].concat(_toConsumableArray(array4.slice(0, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, toIndex + 1)), [item], _toConsumableArray(array4.slice(toIndex + 1, length)));
  }
  return array4;
}
var AsyncValidator = Schema;
function replaceMessage(template, kv) {
  return template.replace(/\$\{\w+\}/g, function(str) {
    var key = str.slice(2, -1);
    return kv[key];
  });
}
function validateRule(_x, _x2, _x3, _x4, _x5) {
  return _validateRule.apply(this, arguments);
}
function _validateRule() {
  _validateRule = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee2(name2, value, rule, options, messageVariables) {
    var cloneRule, subRuleField, validator, messages2, result, subResults, kv, fillVariableResult;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cloneRule = _objectSpread2$3({}, rule);
            delete cloneRule.ruleIndex;
            subRuleField = null;
            if (cloneRule && cloneRule.type === "array" && cloneRule.defaultField) {
              subRuleField = cloneRule.defaultField;
              delete cloneRule.defaultField;
            }
            validator = new AsyncValidator(_defineProperty$3({}, name2, [cloneRule]));
            messages2 = setValues({}, defaultValidateMessages, options.validateMessages);
            validator.messages(messages2);
            result = [];
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.resolve(validator.validate(_defineProperty$3({}, name2, value), _objectSpread2$3({}, options)));
          case 11:
            _context2.next = 16;
            break;
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            if (_context2.t0.errors) {
              result = _context2.t0.errors.map(function(_ref4, index2) {
                var message = _ref4.message;
                return /* @__PURE__ */ React.isValidElement(message) ? /* @__PURE__ */ React.cloneElement(message, {
                  key: "error_".concat(index2)
                }) : message;
              });
            } else {
              console.error(_context2.t0);
              result = [messages2.default];
            }
          case 16:
            if (!(!result.length && subRuleField)) {
              _context2.next = 21;
              break;
            }
            _context2.next = 19;
            return Promise.all(value.map(function(subValue, i) {
              return validateRule("".concat(name2, ".").concat(i), subValue, subRuleField, options, messageVariables);
            }));
          case 19:
            subResults = _context2.sent;
            return _context2.abrupt("return", subResults.reduce(function(prev, errors) {
              return [].concat(_toConsumableArray(prev), _toConsumableArray(errors));
            }, []));
          case 21:
            kv = _objectSpread2$3(_objectSpread2$3({}, rule), {}, {
              name: name2,
              enum: (rule.enum || []).join(", ")
            }, messageVariables);
            fillVariableResult = result.map(function(error) {
              if (typeof error === "string") {
                return replaceMessage(error, kv);
              }
              return error;
            });
            return _context2.abrupt("return", fillVariableResult);
          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13]]);
  }));
  return _validateRule.apply(this, arguments);
}
function validateRules(namePath, value, rules2, options, validateFirst, messageVariables) {
  var name2 = namePath.join(".");
  var filledRules = rules2.map(function(currentRule, ruleIndex) {
    var originValidatorFunc = currentRule.validator;
    var cloneRule = _objectSpread2$3(_objectSpread2$3({}, currentRule), {}, {
      ruleIndex
    });
    if (originValidatorFunc) {
      cloneRule.validator = function(rule, val, callback) {
        var hasPromise = false;
        var wrappedCallback = function wrappedCallback2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          Promise.resolve().then(function() {
            warningOnce(!hasPromise, "Your validator function has already return a promise. `callback` will be ignored.");
            if (!hasPromise) {
              callback.apply(void 0, args);
            }
          });
        };
        var promise = originValidatorFunc(rule, val, wrappedCallback);
        hasPromise = promise && typeof promise.then === "function" && typeof promise.catch === "function";
        warningOnce(hasPromise, "`callback` is deprecated. Please return a promise instead.");
        if (hasPromise) {
          promise.then(function() {
            callback();
          }).catch(function(err) {
            callback(err || " ");
          });
        }
      };
    }
    return cloneRule;
  }).sort(function(_ref, _ref2) {
    var w1 = _ref.warningOnly, i1 = _ref.ruleIndex;
    var w2 = _ref2.warningOnly, i2 = _ref2.ruleIndex;
    if (!!w1 === !!w2) {
      return i1 - i2;
    }
    if (w1) {
      return 1;
    }
    return -1;
  });
  var summaryPromise;
  if (validateFirst === true) {
    summaryPromise = new Promise(/* @__PURE__ */ function() {
      var _ref3 = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee(resolve, reject) {
        var i, rule, errors;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = 0;
              case 1:
                if (!(i < filledRules.length)) {
                  _context.next = 12;
                  break;
                }
                rule = filledRules[i];
                _context.next = 5;
                return validateRule(name2, value, rule, options, messageVariables);
              case 5:
                errors = _context.sent;
                if (!errors.length) {
                  _context.next = 9;
                  break;
                }
                reject([{
                  errors,
                  rule
                }]);
                return _context.abrupt("return");
              case 9:
                i += 1;
                _context.next = 1;
                break;
              case 12:
                resolve([]);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return function(_x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
  } else {
    var rulePromises = filledRules.map(function(rule) {
      return validateRule(name2, value, rule, options, messageVariables).then(function(errors) {
        return {
          errors,
          rule
        };
      });
    });
    summaryPromise = (validateFirst ? finishOnFirstFailed(rulePromises) : finishOnAllFailed(rulePromises)).then(function(errors) {
      return Promise.reject(errors);
    });
  }
  summaryPromise.catch(function(e2) {
    return e2;
  });
  return summaryPromise;
}
function finishOnAllFailed(_x8) {
  return _finishOnAllFailed.apply(this, arguments);
}
function _finishOnAllFailed() {
  _finishOnAllFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee3(rulePromises) {
    return regenerator.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", Promise.all(rulePromises).then(function(errorsList) {
              var _ref5;
              var errors = (_ref5 = []).concat.apply(_ref5, _toConsumableArray(errorsList));
              return errors;
            }));
          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _finishOnAllFailed.apply(this, arguments);
}
function finishOnFirstFailed(_x9) {
  return _finishOnFirstFailed.apply(this, arguments);
}
function _finishOnFirstFailed() {
  _finishOnFirstFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee4(rulePromises) {
    var count2;
    return regenerator.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            count2 = 0;
            return _context4.abrupt("return", new Promise(function(resolve) {
              rulePromises.forEach(function(promise) {
                promise.then(function(ruleError) {
                  if (ruleError.errors.length) {
                    resolve([ruleError]);
                  }
                  count2 += 1;
                  if (count2 === rulePromises.length) {
                    resolve([]);
                  }
                });
              });
            }));
          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _finishOnFirstFailed.apply(this, arguments);
}
var _excluded$k = ["name"];
var EMPTY_ERRORS = [];
function requireUpdate(shouldUpdate, prev, next, prevValue, nextValue, info) {
  if (typeof shouldUpdate === "function") {
    return shouldUpdate(prev, next, "source" in info ? {
      source: info.source
    } : {});
  }
  return prevValue !== nextValue;
}
var Field = /* @__PURE__ */ function(_React$Component) {
  _inherits(Field2, _React$Component);
  var _super = _createSuper(Field2);
  function Field2(props) {
    var _this;
    _classCallCheck(this, Field2);
    _this = _super.call(this, props);
    _this.state = {
      resetCount: 0
    };
    _this.cancelRegisterFunc = null;
    _this.mounted = false;
    _this.touched = false;
    _this.dirty = false;
    _this.validatePromise = null;
    _this.prevValidating = void 0;
    _this.errors = EMPTY_ERRORS;
    _this.warnings = EMPTY_ERRORS;
    _this.cancelRegister = function() {
      var _this$props = _this.props, preserve = _this$props.preserve, isListField = _this$props.isListField, name2 = _this$props.name;
      if (_this.cancelRegisterFunc) {
        _this.cancelRegisterFunc(isListField, preserve, getNamePath(name2));
      }
      _this.cancelRegisterFunc = null;
    };
    _this.getNamePath = function() {
      var _this$props2 = _this.props, name2 = _this$props2.name, fieldContext = _this$props2.fieldContext;
      var _fieldContext$prefixN = fieldContext.prefixName, prefixName = _fieldContext$prefixN === void 0 ? [] : _fieldContext$prefixN;
      return name2 !== void 0 ? [].concat(_toConsumableArray(prefixName), _toConsumableArray(name2)) : [];
    };
    _this.getRules = function() {
      var _this$props3 = _this.props, _this$props3$rules = _this$props3.rules, rules2 = _this$props3$rules === void 0 ? [] : _this$props3$rules, fieldContext = _this$props3.fieldContext;
      return rules2.map(function(rule) {
        if (typeof rule === "function") {
          return rule(fieldContext);
        }
        return rule;
      });
    };
    _this.refresh = function() {
      if (!_this.mounted)
        return;
      _this.setState(function(_ref) {
        var resetCount = _ref.resetCount;
        return {
          resetCount: resetCount + 1
        };
      });
    };
    _this.triggerMetaEvent = function(destroy) {
      var onMetaChange = _this.props.onMetaChange;
      onMetaChange === null || onMetaChange === void 0 ? void 0 : onMetaChange(_objectSpread2$3(_objectSpread2$3({}, _this.getMeta()), {}, {
        destroy
      }));
    };
    _this.onStoreChange = function(prevStore, namePathList, info) {
      var _this$props4 = _this.props, shouldUpdate = _this$props4.shouldUpdate, _this$props4$dependen = _this$props4.dependencies, dependencies2 = _this$props4$dependen === void 0 ? [] : _this$props4$dependen, onReset = _this$props4.onReset;
      var store = info.store;
      var namePath = _this.getNamePath();
      var prevValue = _this.getValue(prevStore);
      var curValue = _this.getValue(store);
      var namePathMatch = namePathList && containsNamePath(namePathList, namePath);
      if (info.type === "valueUpdate" && info.source === "external" && prevValue !== curValue) {
        _this.touched = true;
        _this.dirty = true;
        _this.validatePromise = null;
        _this.errors = EMPTY_ERRORS;
        _this.warnings = EMPTY_ERRORS;
        _this.triggerMetaEvent();
      }
      switch (info.type) {
        case "reset":
          if (!namePathList || namePathMatch) {
            _this.touched = false;
            _this.dirty = false;
            _this.validatePromise = null;
            _this.errors = EMPTY_ERRORS;
            _this.warnings = EMPTY_ERRORS;
            _this.triggerMetaEvent();
            onReset === null || onReset === void 0 ? void 0 : onReset();
            _this.refresh();
            return;
          }
          break;
        case "remove": {
          if (shouldUpdate) {
            _this.reRender();
            return;
          }
          break;
        }
        case "setField": {
          if (namePathMatch) {
            var data2 = info.data;
            if ("touched" in data2) {
              _this.touched = data2.touched;
            }
            if ("validating" in data2 && !("originRCField" in data2)) {
              _this.validatePromise = data2.validating ? Promise.resolve([]) : null;
            }
            if ("errors" in data2) {
              _this.errors = data2.errors || EMPTY_ERRORS;
            }
            if ("warnings" in data2) {
              _this.warnings = data2.warnings || EMPTY_ERRORS;
            }
            _this.dirty = true;
            _this.triggerMetaEvent();
            _this.reRender();
            return;
          }
          if (shouldUpdate && !namePath.length && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
        }
        case "dependenciesUpdate": {
          var dependencyList = dependencies2.map(getNamePath);
          if (dependencyList.some(function(dependency) {
            return containsNamePath(info.relatedFields, dependency);
          })) {
            _this.reRender();
            return;
          }
          break;
        }
        default:
          if (namePathMatch || (!dependencies2.length || namePath.length || shouldUpdate) && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
      }
      if (shouldUpdate === true) {
        _this.reRender();
      }
    };
    _this.validateRules = function(options) {
      var namePath = _this.getNamePath();
      var currentValue = _this.getValue();
      var rootPromise = Promise.resolve().then(function() {
        if (!_this.mounted) {
          return [];
        }
        var _this$props5 = _this.props, _this$props5$validate = _this$props5.validateFirst, validateFirst = _this$props5$validate === void 0 ? false : _this$props5$validate, messageVariables = _this$props5.messageVariables;
        var _ref2 = options || {}, triggerName = _ref2.triggerName;
        var filteredRules = _this.getRules();
        if (triggerName) {
          filteredRules = filteredRules.filter(function(rule) {
            var validateTrigger = rule.validateTrigger;
            if (!validateTrigger) {
              return true;
            }
            var triggerList = toArray(validateTrigger);
            return triggerList.includes(triggerName);
          });
        }
        var promise = validateRules(namePath, currentValue, filteredRules, options, validateFirst, messageVariables);
        promise.catch(function(e2) {
          return e2;
        }).then(function() {
          var ruleErrors = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : EMPTY_ERRORS;
          if (_this.validatePromise === rootPromise) {
            _this.validatePromise = null;
            var nextErrors = [];
            var nextWarnings = [];
            ruleErrors.forEach(function(_ref3) {
              var warningOnly = _ref3.rule.warningOnly, _ref3$errors = _ref3.errors, errors = _ref3$errors === void 0 ? EMPTY_ERRORS : _ref3$errors;
              if (warningOnly) {
                nextWarnings.push.apply(nextWarnings, _toConsumableArray(errors));
              } else {
                nextErrors.push.apply(nextErrors, _toConsumableArray(errors));
              }
            });
            _this.errors = nextErrors;
            _this.warnings = nextWarnings;
            _this.triggerMetaEvent();
            _this.reRender();
          }
        });
        return promise;
      });
      _this.validatePromise = rootPromise;
      _this.dirty = true;
      _this.errors = EMPTY_ERRORS;
      _this.warnings = EMPTY_ERRORS;
      _this.triggerMetaEvent();
      _this.reRender();
      return rootPromise;
    };
    _this.isFieldValidating = function() {
      return !!_this.validatePromise;
    };
    _this.isFieldTouched = function() {
      return _this.touched;
    };
    _this.isFieldDirty = function() {
      if (_this.dirty || _this.props.initialValue !== void 0) {
        return true;
      }
      var fieldContext = _this.props.fieldContext;
      var _fieldContext$getInte = fieldContext.getInternalHooks(HOOK_MARK), getInitialValue = _fieldContext$getInte.getInitialValue;
      if (getInitialValue(_this.getNamePath()) !== void 0) {
        return true;
      }
      return false;
    };
    _this.getErrors = function() {
      return _this.errors;
    };
    _this.getWarnings = function() {
      return _this.warnings;
    };
    _this.isListField = function() {
      return _this.props.isListField;
    };
    _this.isList = function() {
      return _this.props.isList;
    };
    _this.isPreserve = function() {
      return _this.props.preserve;
    };
    _this.getMeta = function() {
      _this.prevValidating = _this.isFieldValidating();
      var meta = {
        touched: _this.isFieldTouched(),
        validating: _this.prevValidating,
        errors: _this.errors,
        warnings: _this.warnings,
        name: _this.getNamePath()
      };
      return meta;
    };
    _this.getOnlyChild = function(children) {
      if (typeof children === "function") {
        var meta = _this.getMeta();
        return _objectSpread2$3(_objectSpread2$3({}, _this.getOnlyChild(children(_this.getControlled(), meta, _this.props.fieldContext))), {}, {
          isFunction: true
        });
      }
      var childList = toArray$1(children);
      if (childList.length !== 1 || !/* @__PURE__ */ React.isValidElement(childList[0])) {
        return {
          child: childList,
          isFunction: false
        };
      }
      return {
        child: childList[0],
        isFunction: false
      };
    };
    _this.getValue = function(store) {
      var getFieldsValue = _this.props.fieldContext.getFieldsValue;
      var namePath = _this.getNamePath();
      return getValue$1(store || getFieldsValue(true), namePath);
    };
    _this.getControlled = function() {
      var childProps = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      var _this$props6 = _this.props, trigger2 = _this$props6.trigger, validateTrigger = _this$props6.validateTrigger, getValueFromEvent = _this$props6.getValueFromEvent, normalize2 = _this$props6.normalize, valuePropName = _this$props6.valuePropName, getValueProps = _this$props6.getValueProps, fieldContext = _this$props6.fieldContext;
      var mergedValidateTrigger = validateTrigger !== void 0 ? validateTrigger : fieldContext.validateTrigger;
      var namePath = _this.getNamePath();
      var getInternalHooks3 = fieldContext.getInternalHooks, getFieldsValue = fieldContext.getFieldsValue;
      var _getInternalHooks = getInternalHooks3(HOOK_MARK), dispatch2 = _getInternalHooks.dispatch;
      var value = _this.getValue();
      var mergedGetValueProps = getValueProps || function(val) {
        return _defineProperty$3({}, valuePropName, val);
      };
      var originTriggerFunc = childProps[trigger2];
      var control = _objectSpread2$3(_objectSpread2$3({}, childProps), mergedGetValueProps(value));
      control[trigger2] = function() {
        _this.touched = true;
        _this.dirty = true;
        _this.triggerMetaEvent();
        var newValue;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        if (getValueFromEvent) {
          newValue = getValueFromEvent.apply(void 0, args);
        } else {
          newValue = defaultGetValueFromEvent.apply(void 0, [valuePropName].concat(args));
        }
        if (normalize2) {
          newValue = normalize2(newValue, value, getFieldsValue(true));
        }
        dispatch2({
          type: "updateValue",
          namePath,
          value: newValue
        });
        if (originTriggerFunc) {
          originTriggerFunc.apply(void 0, args);
        }
      };
      var validateTriggerList = toArray(mergedValidateTrigger || []);
      validateTriggerList.forEach(function(triggerName) {
        var originTrigger = control[triggerName];
        control[triggerName] = function() {
          if (originTrigger) {
            originTrigger.apply(void 0, arguments);
          }
          var rules2 = _this.props.rules;
          if (rules2 && rules2.length) {
            dispatch2({
              type: "validateField",
              namePath,
              triggerName
            });
          }
        };
      });
      return control;
    };
    if (props.fieldContext) {
      var getInternalHooks2 = props.fieldContext.getInternalHooks;
      var _getInternalHooks2 = getInternalHooks2(HOOK_MARK), initEntityValue = _getInternalHooks2.initEntityValue;
      initEntityValue(_assertThisInitialized(_this));
    }
    return _this;
  }
  _createClass(Field2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props7 = this.props, shouldUpdate = _this$props7.shouldUpdate, fieldContext = _this$props7.fieldContext;
      this.mounted = true;
      if (fieldContext) {
        var getInternalHooks2 = fieldContext.getInternalHooks;
        var _getInternalHooks3 = getInternalHooks2(HOOK_MARK), registerField = _getInternalHooks3.registerField;
        this.cancelRegisterFunc = registerField(this);
      }
      if (shouldUpdate === true) {
        this.reRender();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cancelRegister();
      this.triggerMetaEvent(true);
      this.mounted = false;
    }
  }, {
    key: "reRender",
    value: function reRender() {
      if (!this.mounted)
        return;
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render2() {
      var resetCount = this.state.resetCount;
      var children = this.props.children;
      var _this$getOnlyChild = this.getOnlyChild(children), child = _this$getOnlyChild.child, isFunction2 = _this$getOnlyChild.isFunction;
      var returnChildNode;
      if (isFunction2) {
        returnChildNode = child;
      } else if (/* @__PURE__ */ React.isValidElement(child)) {
        returnChildNode = /* @__PURE__ */ React.cloneElement(child, this.getControlled(child.props));
      } else {
        warningOnce(!child, "`children` of Field is not validate ReactElement.");
        returnChildNode = child;
      }
      return /* @__PURE__ */ React.createElement(React.Fragment, {
        key: resetCount
      }, returnChildNode);
    }
  }]);
  return Field2;
}(React.Component);
Field.contextType = Context;
Field.defaultProps = {
  trigger: "onChange",
  valuePropName: "value"
};
function WrapperField(_ref5) {
  var name2 = _ref5.name, restProps = _objectWithoutProperties$1(_ref5, _excluded$k);
  var fieldContext = React.useContext(Context);
  var namePath = name2 !== void 0 ? getNamePath(name2) : void 0;
  var key = "keep";
  if (!restProps.isListField) {
    key = "_".concat((namePath || []).join("_"));
  }
  return /* @__PURE__ */ React.createElement(Field, _extends$1({
    key,
    name: namePath
  }, restProps, {
    fieldContext
  }));
}
var ListContext = /* @__PURE__ */ React.createContext(null);
var List = function List2(_ref) {
  var name2 = _ref.name, initialValue = _ref.initialValue, children = _ref.children, rules2 = _ref.rules, validateTrigger = _ref.validateTrigger;
  var context = React.useContext(Context);
  var keyRef = React.useRef({
    keys: [],
    id: 0
  });
  var keyManager = keyRef.current;
  var prefixName = React.useMemo(function() {
    var parentPrefixName = getNamePath(context.prefixName) || [];
    return [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray(getNamePath(name2)));
  }, [context.prefixName, name2]);
  var fieldContext = React.useMemo(function() {
    return _objectSpread2$3(_objectSpread2$3({}, context), {}, {
      prefixName
    });
  }, [context, prefixName]);
  var listContext = React.useMemo(function() {
    return {
      getKey: function getKey2(namePath) {
        var len2 = prefixName.length;
        var pathName = namePath[len2];
        return [keyManager.keys[pathName], namePath.slice(len2 + 1)];
      }
    };
  }, [prefixName]);
  if (typeof children !== "function") {
    warningOnce(false, "Form.List only accepts function as children.");
    return null;
  }
  var shouldUpdate = function shouldUpdate2(prevValue, nextValue, _ref2) {
    var source = _ref2.source;
    if (source === "internal") {
      return false;
    }
    return prevValue !== nextValue;
  };
  return /* @__PURE__ */ React.createElement(ListContext.Provider, {
    value: listContext
  }, /* @__PURE__ */ React.createElement(Context.Provider, {
    value: fieldContext
  }, /* @__PURE__ */ React.createElement(WrapperField, {
    name: [],
    shouldUpdate,
    rules: rules2,
    validateTrigger,
    initialValue,
    isList: true
  }, function(_ref3, meta) {
    var _ref3$value = _ref3.value, value = _ref3$value === void 0 ? [] : _ref3$value, onChange3 = _ref3.onChange;
    var getFieldValue = context.getFieldValue;
    var getNewValue = function getNewValue2() {
      var values = getFieldValue(prefixName || []);
      return values || [];
    };
    var operations = {
      add: function add2(defaultValue, index2) {
        var newValue = getNewValue();
        if (index2 >= 0 && index2 <= newValue.length) {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys.slice(0, index2)), [keyManager.id], _toConsumableArray(keyManager.keys.slice(index2)));
          onChange3([].concat(_toConsumableArray(newValue.slice(0, index2)), [defaultValue], _toConsumableArray(newValue.slice(index2))));
        } else {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys), [keyManager.id]);
          onChange3([].concat(_toConsumableArray(newValue), [defaultValue]));
        }
        keyManager.id += 1;
      },
      remove: function remove(index2) {
        var newValue = getNewValue();
        var indexSet = new Set(Array.isArray(index2) ? index2 : [index2]);
        if (indexSet.size <= 0) {
          return;
        }
        keyManager.keys = keyManager.keys.filter(function(_, keysIndex) {
          return !indexSet.has(keysIndex);
        });
        onChange3(newValue.filter(function(_, valueIndex) {
          return !indexSet.has(valueIndex);
        }));
      },
      move: function move$1(from2, to) {
        if (from2 === to) {
          return;
        }
        var newValue = getNewValue();
        if (from2 < 0 || from2 >= newValue.length || to < 0 || to >= newValue.length) {
          return;
        }
        keyManager.keys = move(keyManager.keys, from2, to);
        onChange3(move(newValue, from2, to));
      }
    };
    var listValue = value || [];
    if (!Array.isArray(listValue)) {
      listValue = [];
    }
    return children(listValue.map(function(__, index2) {
      var key = keyManager.keys[index2];
      if (key === void 0) {
        keyManager.keys[index2] = keyManager.id;
        key = keyManager.keys[index2];
        keyManager.id += 1;
      }
      return {
        name: index2,
        key,
        isListField: true
      };
    }), operations, meta);
  })));
};
function _iterableToArrayLimit$1(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _slicedToArray$1(arr, i) {
  return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest$1();
}
function allPromiseFinish(promiseList) {
  var hasError = false;
  var count2 = promiseList.length;
  var results = [];
  if (!promiseList.length) {
    return Promise.resolve([]);
  }
  return new Promise(function(resolve, reject) {
    promiseList.forEach(function(promise, index2) {
      promise.catch(function(e2) {
        hasError = true;
        return e2;
      }).then(function(result) {
        count2 -= 1;
        results[index2] = result;
        if (count2 > 0) {
          return;
        }
        if (hasError) {
          reject(results);
        }
        resolve(results);
      });
    });
  });
}
var SPLIT = "__@field_split__";
function normalize(namePath) {
  return namePath.map(function(cell) {
    return "".concat(_typeof$1(cell), ":").concat(cell);
  }).join(SPLIT);
}
var NameMap = /* @__PURE__ */ function() {
  function NameMap2() {
    _classCallCheck(this, NameMap2);
    this.kvs = /* @__PURE__ */ new Map();
  }
  _createClass(NameMap2, [{
    key: "set",
    value: function set2(key, value) {
      this.kvs.set(normalize(key), value);
    }
  }, {
    key: "get",
    value: function get2(key) {
      return this.kvs.get(normalize(key));
    }
  }, {
    key: "update",
    value: function update(key, updater) {
      var origin = this.get(key);
      var next = updater(origin);
      if (!next) {
        this.delete(key);
      } else {
        this.set(key, next);
      }
    }
  }, {
    key: "delete",
    value: function _delete(key) {
      this.kvs.delete(normalize(key));
    }
  }, {
    key: "map",
    value: function map2(callback) {
      return _toConsumableArray(this.kvs.entries()).map(function(_ref) {
        var _ref2 = _slicedToArray$1(_ref, 2), key = _ref2[0], value = _ref2[1];
        var cells = key.split(SPLIT);
        return callback({
          key: cells.map(function(cell) {
            var _cell$match = cell.match(/^([^:]*):(.*)$/), _cell$match2 = _slicedToArray$1(_cell$match, 3), type4 = _cell$match2[1], unit = _cell$match2[2];
            return type4 === "number" ? Number(unit) : unit;
          }),
          value
        });
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      this.map(function(_ref3) {
        var key = _ref3.key, value = _ref3.value;
        json[key.join(".")] = value;
        return null;
      });
      return json;
    }
  }]);
  return NameMap2;
}();
var _excluded$j = ["name", "errors"];
var FormStore = /* @__PURE__ */ _createClass(function FormStore2(forceRootUpdate) {
  var _this = this;
  _classCallCheck(this, FormStore2);
  this.formHooked = false;
  this.forceRootUpdate = void 0;
  this.subscribable = true;
  this.store = {};
  this.fieldEntities = [];
  this.initialValues = {};
  this.callbacks = {};
  this.validateMessages = null;
  this.preserve = null;
  this.lastValidatePromise = null;
  this.getForm = function() {
    return {
      getFieldValue: _this.getFieldValue,
      getFieldsValue: _this.getFieldsValue,
      getFieldError: _this.getFieldError,
      getFieldWarning: _this.getFieldWarning,
      getFieldsError: _this.getFieldsError,
      isFieldsTouched: _this.isFieldsTouched,
      isFieldTouched: _this.isFieldTouched,
      isFieldValidating: _this.isFieldValidating,
      isFieldsValidating: _this.isFieldsValidating,
      resetFields: _this.resetFields,
      setFields: _this.setFields,
      setFieldsValue: _this.setFieldsValue,
      validateFields: _this.validateFields,
      submit: _this.submit,
      getInternalHooks: _this.getInternalHooks
    };
  };
  this.getInternalHooks = function(key) {
    if (key === HOOK_MARK) {
      _this.formHooked = true;
      return {
        dispatch: _this.dispatch,
        initEntityValue: _this.initEntityValue,
        registerField: _this.registerField,
        useSubscribe: _this.useSubscribe,
        setInitialValues: _this.setInitialValues,
        setCallbacks: _this.setCallbacks,
        setValidateMessages: _this.setValidateMessages,
        getFields: _this.getFields,
        setPreserve: _this.setPreserve,
        getInitialValue: _this.getInitialValue
      };
    }
    warningOnce(false, "`getInternalHooks` is internal usage. Should not call directly.");
    return null;
  };
  this.useSubscribe = function(subscribable) {
    _this.subscribable = subscribable;
  };
  this.setInitialValues = function(initialValues, init2) {
    _this.initialValues = initialValues || {};
    if (init2) {
      _this.store = setValues({}, initialValues, _this.store);
    }
  };
  this.getInitialValue = function(namePath) {
    return getValue$1(_this.initialValues, namePath);
  };
  this.setCallbacks = function(callbacks) {
    _this.callbacks = callbacks;
  };
  this.setValidateMessages = function(validateMessages) {
    _this.validateMessages = validateMessages;
  };
  this.setPreserve = function(preserve) {
    _this.preserve = preserve;
  };
  this.timeoutId = null;
  this.warningUnhooked = function() {
  };
  this.getFieldEntities = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    if (!pure) {
      return _this.fieldEntities;
    }
    return _this.fieldEntities.filter(function(field) {
      return field.getNamePath().length;
    });
  };
  this.getFieldsMap = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    var cache = new NameMap();
    _this.getFieldEntities(pure).forEach(function(field) {
      var namePath = field.getNamePath();
      cache.set(namePath, field);
    });
    return cache;
  };
  this.getFieldEntitiesForNamePathList = function(nameList) {
    if (!nameList) {
      return _this.getFieldEntities(true);
    }
    var cache = _this.getFieldsMap(true);
    return nameList.map(function(name2) {
      var namePath = getNamePath(name2);
      return cache.get(namePath) || {
        INVALIDATE_NAME_PATH: getNamePath(name2)
      };
    });
  };
  this.getFieldsValue = function(nameList, filterFunc) {
    _this.warningUnhooked();
    if (nameList === true && !filterFunc) {
      return _this.store;
    }
    var fieldEntities = _this.getFieldEntitiesForNamePathList(Array.isArray(nameList) ? nameList : null);
    var filteredNameList = [];
    fieldEntities.forEach(function(entity) {
      var _entity$isListField;
      var namePath = "INVALIDATE_NAME_PATH" in entity ? entity.INVALIDATE_NAME_PATH : entity.getNamePath();
      if (!nameList && ((_entity$isListField = entity.isListField) === null || _entity$isListField === void 0 ? void 0 : _entity$isListField.call(entity))) {
        return;
      }
      if (!filterFunc) {
        filteredNameList.push(namePath);
      } else {
        var meta = "getMeta" in entity ? entity.getMeta() : null;
        if (filterFunc(meta)) {
          filteredNameList.push(namePath);
        }
      }
    });
    return cloneByNamePathList(_this.store, filteredNameList.map(getNamePath));
  };
  this.getFieldValue = function(name2) {
    _this.warningUnhooked();
    var namePath = getNamePath(name2);
    return getValue$1(_this.store, namePath);
  };
  this.getFieldsError = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntitiesForNamePathList(nameList);
    return fieldEntities.map(function(entity, index2) {
      if (entity && !("INVALIDATE_NAME_PATH" in entity)) {
        return {
          name: entity.getNamePath(),
          errors: entity.getErrors(),
          warnings: entity.getWarnings()
        };
      }
      return {
        name: getNamePath(nameList[index2]),
        errors: [],
        warnings: []
      };
    });
  };
  this.getFieldError = function(name2) {
    _this.warningUnhooked();
    var namePath = getNamePath(name2);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.errors;
  };
  this.getFieldWarning = function(name2) {
    _this.warningUnhooked();
    var namePath = getNamePath(name2);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.warnings;
  };
  this.isFieldsTouched = function() {
    _this.warningUnhooked();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var arg0 = args[0], arg1 = args[1];
    var namePathList;
    var isAllFieldsTouched = false;
    if (args.length === 0) {
      namePathList = null;
    } else if (args.length === 1) {
      if (Array.isArray(arg0)) {
        namePathList = arg0.map(getNamePath);
        isAllFieldsTouched = false;
      } else {
        namePathList = null;
        isAllFieldsTouched = arg0;
      }
    } else {
      namePathList = arg0.map(getNamePath);
      isAllFieldsTouched = arg1;
    }
    var fieldEntities = _this.getFieldEntities(true);
    var isFieldTouched = function isFieldTouched2(field) {
      return field.isFieldTouched();
    };
    if (!namePathList) {
      return isAllFieldsTouched ? fieldEntities.every(isFieldTouched) : fieldEntities.some(isFieldTouched);
    }
    var map2 = new NameMap();
    namePathList.forEach(function(shortNamePath) {
      map2.set(shortNamePath, []);
    });
    fieldEntities.forEach(function(field) {
      var fieldNamePath = field.getNamePath();
      namePathList.forEach(function(shortNamePath) {
        if (shortNamePath.every(function(nameUnit, i) {
          return fieldNamePath[i] === nameUnit;
        })) {
          map2.update(shortNamePath, function(list) {
            return [].concat(_toConsumableArray(list), [field]);
          });
        }
      });
    });
    var isNamePathListTouched = function isNamePathListTouched2(entities) {
      return entities.some(isFieldTouched);
    };
    var namePathListEntities = map2.map(function(_ref) {
      var value = _ref.value;
      return value;
    });
    return isAllFieldsTouched ? namePathListEntities.every(isNamePathListTouched) : namePathListEntities.some(isNamePathListTouched);
  };
  this.isFieldTouched = function(name2) {
    _this.warningUnhooked();
    return _this.isFieldsTouched([name2]);
  };
  this.isFieldsValidating = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntities();
    if (!nameList) {
      return fieldEntities.some(function(testField) {
        return testField.isFieldValidating();
      });
    }
    var namePathList = nameList.map(getNamePath);
    return fieldEntities.some(function(testField) {
      var fieldNamePath = testField.getNamePath();
      return containsNamePath(namePathList, fieldNamePath) && testField.isFieldValidating();
    });
  };
  this.isFieldValidating = function(name2) {
    _this.warningUnhooked();
    return _this.isFieldsValidating([name2]);
  };
  this.resetWithFieldInitialValue = function() {
    var info = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var cache = new NameMap();
    var fieldEntities = _this.getFieldEntities(true);
    fieldEntities.forEach(function(field) {
      var initialValue = field.props.initialValue;
      var namePath = field.getNamePath();
      if (initialValue !== void 0) {
        var records = cache.get(namePath) || /* @__PURE__ */ new Set();
        records.add({
          entity: field,
          value: initialValue
        });
        cache.set(namePath, records);
      }
    });
    var resetWithFields = function resetWithFields2(entities) {
      entities.forEach(function(field) {
        var initialValue = field.props.initialValue;
        if (initialValue !== void 0) {
          var namePath = field.getNamePath();
          var formInitialValue = _this.getInitialValue(namePath);
          if (formInitialValue !== void 0) {
            warningOnce(false, "Form already set 'initialValues' with path '".concat(namePath.join("."), "'. Field can not overwrite it."));
          } else {
            var records = cache.get(namePath);
            if (records && records.size > 1) {
              warningOnce(false, "Multiple Field with path '".concat(namePath.join("."), "' set 'initialValue'. Can not decide which one to pick."));
            } else if (records) {
              var originValue = _this.getFieldValue(namePath);
              if (!info.skipExist || originValue === void 0) {
                _this.store = setValue(_this.store, namePath, _toConsumableArray(records)[0].value);
              }
            }
          }
        }
      });
    };
    var requiredFieldEntities;
    if (info.entities) {
      requiredFieldEntities = info.entities;
    } else if (info.namePathList) {
      requiredFieldEntities = [];
      info.namePathList.forEach(function(namePath) {
        var records = cache.get(namePath);
        if (records) {
          var _requiredFieldEntitie;
          (_requiredFieldEntitie = requiredFieldEntities).push.apply(_requiredFieldEntitie, _toConsumableArray(_toConsumableArray(records).map(function(r2) {
            return r2.entity;
          })));
        }
      });
    } else {
      requiredFieldEntities = fieldEntities;
    }
    resetWithFields(requiredFieldEntities);
  };
  this.resetFields = function(nameList) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (!nameList) {
      _this.store = setValues({}, _this.initialValues);
      _this.resetWithFieldInitialValue();
      _this.notifyObservers(prevStore, null, {
        type: "reset"
      });
      return;
    }
    var namePathList = nameList.map(getNamePath);
    namePathList.forEach(function(namePath) {
      var initialValue = _this.getInitialValue(namePath);
      _this.store = setValue(_this.store, namePath, initialValue);
    });
    _this.resetWithFieldInitialValue({
      namePathList
    });
    _this.notifyObservers(prevStore, namePathList, {
      type: "reset"
    });
  };
  this.setFields = function(fields) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    fields.forEach(function(fieldData) {
      var name2 = fieldData.name;
      fieldData.errors;
      var data2 = _objectWithoutProperties$1(fieldData, _excluded$j);
      var namePath = getNamePath(name2);
      if ("value" in data2) {
        _this.store = setValue(_this.store, namePath, data2.value);
      }
      _this.notifyObservers(prevStore, [namePath], {
        type: "setField",
        data: fieldData
      });
    });
  };
  this.getFields = function() {
    var entities = _this.getFieldEntities(true);
    var fields = entities.map(function(field) {
      var namePath = field.getNamePath();
      var meta = field.getMeta();
      var fieldData = _objectSpread2$3(_objectSpread2$3({}, meta), {}, {
        name: namePath,
        value: _this.getFieldValue(namePath)
      });
      Object.defineProperty(fieldData, "originRCField", {
        value: true
      });
      return fieldData;
    });
    return fields;
  };
  this.initEntityValue = function(entity) {
    var initialValue = entity.props.initialValue;
    if (initialValue !== void 0) {
      var namePath = entity.getNamePath();
      var prevValue = getValue$1(_this.store, namePath);
      if (prevValue === void 0) {
        _this.store = setValue(_this.store, namePath, initialValue);
      }
    }
  };
  this.registerField = function(entity) {
    _this.fieldEntities.push(entity);
    if (entity.props.initialValue !== void 0) {
      var prevStore = _this.store;
      _this.resetWithFieldInitialValue({
        entities: [entity],
        skipExist: true
      });
      _this.notifyObservers(prevStore, [entity.getNamePath()], {
        type: "valueUpdate",
        source: "internal"
      });
    }
    return function(isListField, preserve) {
      var subNamePath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
      _this.fieldEntities = _this.fieldEntities.filter(function(item) {
        return item !== entity;
      });
      var mergedPreserve = preserve !== void 0 ? preserve : _this.preserve;
      if (mergedPreserve === false && (!isListField || subNamePath.length > 1)) {
        var namePath = entity.getNamePath();
        var defaultValue = isListField ? void 0 : getValue$1(_this.initialValues, namePath);
        if (namePath.length && _this.getFieldValue(namePath) !== defaultValue && _this.fieldEntities.every(function(field) {
          return !matchNamePath(field.getNamePath(), namePath);
        })) {
          var _prevStore = _this.store;
          _this.store = setValue(_prevStore, namePath, defaultValue, true);
          _this.notifyObservers(_prevStore, [namePath], {
            type: "remove"
          });
          _this.triggerDependenciesUpdate(_prevStore, namePath);
        }
      }
    };
  };
  this.dispatch = function(action) {
    switch (action.type) {
      case "updateValue": {
        var namePath = action.namePath, value = action.value;
        _this.updateValue(namePath, value);
        break;
      }
      case "validateField": {
        var _namePath = action.namePath, triggerName = action.triggerName;
        _this.validateFields([_namePath], {
          triggerName
        });
        break;
      }
    }
  };
  this.notifyObservers = function(prevStore, namePathList, info) {
    if (_this.subscribable) {
      var mergedInfo = _objectSpread2$3(_objectSpread2$3({}, info), {}, {
        store: _this.getFieldsValue(true)
      });
      _this.getFieldEntities().forEach(function(_ref2) {
        var onStoreChange = _ref2.onStoreChange;
        onStoreChange(prevStore, namePathList, mergedInfo);
      });
    } else {
      _this.forceRootUpdate();
    }
  };
  this.triggerDependenciesUpdate = function(prevStore, namePath) {
    var childrenFields = _this.getDependencyChildrenFields(namePath);
    if (childrenFields.length) {
      _this.validateFields(childrenFields);
    }
    _this.notifyObservers(prevStore, childrenFields, {
      type: "dependenciesUpdate",
      relatedFields: [namePath].concat(_toConsumableArray(childrenFields))
    });
    return childrenFields;
  };
  this.updateValue = function(name2, value) {
    var namePath = getNamePath(name2);
    var prevStore = _this.store;
    _this.store = setValue(_this.store, namePath, value);
    _this.notifyObservers(prevStore, [namePath], {
      type: "valueUpdate",
      source: "internal"
    });
    var childrenFields = _this.triggerDependenciesUpdate(prevStore, namePath);
    var onValuesChange = _this.callbacks.onValuesChange;
    if (onValuesChange) {
      var changedValues = cloneByNamePathList(_this.store, [namePath]);
      onValuesChange(changedValues, _this.getFieldsValue());
    }
    _this.triggerOnFieldsChange([namePath].concat(_toConsumableArray(childrenFields)));
  };
  this.setFieldsValue = function(store) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (store) {
      _this.store = setValues(_this.store, store);
    }
    _this.notifyObservers(prevStore, null, {
      type: "valueUpdate",
      source: "external"
    });
  };
  this.getDependencyChildrenFields = function(rootNamePath) {
    var children = /* @__PURE__ */ new Set();
    var childrenFields = [];
    var dependencies2fields = new NameMap();
    _this.getFieldEntities().forEach(function(field) {
      var dependencies2 = field.props.dependencies;
      (dependencies2 || []).forEach(function(dependency) {
        var dependencyNamePath = getNamePath(dependency);
        dependencies2fields.update(dependencyNamePath, function() {
          var fields = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
          fields.add(field);
          return fields;
        });
      });
    });
    var fillChildren = function fillChildren2(namePath) {
      var fields = dependencies2fields.get(namePath) || /* @__PURE__ */ new Set();
      fields.forEach(function(field) {
        if (!children.has(field)) {
          children.add(field);
          var fieldNamePath = field.getNamePath();
          if (field.isFieldDirty() && fieldNamePath.length) {
            childrenFields.push(fieldNamePath);
            fillChildren2(fieldNamePath);
          }
        }
      });
    };
    fillChildren(rootNamePath);
    return childrenFields;
  };
  this.triggerOnFieldsChange = function(namePathList, filedErrors) {
    var onFieldsChange = _this.callbacks.onFieldsChange;
    if (onFieldsChange) {
      var fields = _this.getFields();
      if (filedErrors) {
        var cache = new NameMap();
        filedErrors.forEach(function(_ref3) {
          var name2 = _ref3.name, errors = _ref3.errors;
          cache.set(name2, errors);
        });
        fields.forEach(function(field) {
          field.errors = cache.get(field.name) || field.errors;
        });
      }
      var changedFields = fields.filter(function(_ref4) {
        var fieldName = _ref4.name;
        return containsNamePath(namePathList, fieldName);
      });
      onFieldsChange(changedFields, fields);
    }
  };
  this.validateFields = function(nameList, options) {
    _this.warningUnhooked();
    var provideNameList = !!nameList;
    var namePathList = provideNameList ? nameList.map(getNamePath) : [];
    var promiseList = [];
    _this.getFieldEntities(true).forEach(function(field) {
      if (!provideNameList) {
        namePathList.push(field.getNamePath());
      }
      if ((options === null || options === void 0 ? void 0 : options.recursive) && provideNameList) {
        var namePath = field.getNamePath();
        if (namePath.every(function(nameUnit, i) {
          return nameList[i] === nameUnit || nameList[i] === void 0;
        })) {
          namePathList.push(namePath);
        }
      }
      if (!field.props.rules || !field.props.rules.length) {
        return;
      }
      var fieldNamePath = field.getNamePath();
      if (!provideNameList || containsNamePath(namePathList, fieldNamePath)) {
        var promise = field.validateRules(_objectSpread2$3({
          validateMessages: _objectSpread2$3(_objectSpread2$3({}, defaultValidateMessages), _this.validateMessages)
        }, options));
        promiseList.push(promise.then(function() {
          return {
            name: fieldNamePath,
            errors: [],
            warnings: []
          };
        }).catch(function(ruleErrors) {
          var mergedErrors = [];
          var mergedWarnings = [];
          ruleErrors.forEach(function(_ref5) {
            var warningOnly = _ref5.rule.warningOnly, errors = _ref5.errors;
            if (warningOnly) {
              mergedWarnings.push.apply(mergedWarnings, _toConsumableArray(errors));
            } else {
              mergedErrors.push.apply(mergedErrors, _toConsumableArray(errors));
            }
          });
          if (mergedErrors.length) {
            return Promise.reject({
              name: fieldNamePath,
              errors: mergedErrors,
              warnings: mergedWarnings
            });
          }
          return {
            name: fieldNamePath,
            errors: mergedErrors,
            warnings: mergedWarnings
          };
        }));
      }
    });
    var summaryPromise = allPromiseFinish(promiseList);
    _this.lastValidatePromise = summaryPromise;
    summaryPromise.catch(function(results) {
      return results;
    }).then(function(results) {
      var resultNamePathList = results.map(function(_ref6) {
        var name2 = _ref6.name;
        return name2;
      });
      _this.notifyObservers(_this.store, resultNamePathList, {
        type: "validateFinish"
      });
      _this.triggerOnFieldsChange(resultNamePathList, results);
    });
    var returnPromise = summaryPromise.then(function() {
      if (_this.lastValidatePromise === summaryPromise) {
        return Promise.resolve(_this.getFieldsValue(namePathList));
      }
      return Promise.reject([]);
    }).catch(function(results) {
      var errorList = results.filter(function(result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: _this.getFieldsValue(namePathList),
        errorFields: errorList,
        outOfDate: _this.lastValidatePromise !== summaryPromise
      });
    });
    returnPromise.catch(function(e2) {
      return e2;
    });
    return returnPromise;
  };
  this.submit = function() {
    _this.warningUnhooked();
    _this.validateFields().then(function(values) {
      var onFinish = _this.callbacks.onFinish;
      if (onFinish) {
        try {
          onFinish(values);
        } catch (err) {
          console.error(err);
        }
      }
    }).catch(function(e2) {
      var onFinishFailed = _this.callbacks.onFinishFailed;
      if (onFinishFailed) {
        onFinishFailed(e2);
      }
    });
  };
  this.forceRootUpdate = forceRootUpdate;
});
function useForm(form) {
  var formRef = React.useRef();
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray$1(_React$useState, 2), forceUpdate = _React$useState2[1];
  if (!formRef.current) {
    if (form) {
      formRef.current = form;
    } else {
      var forceReRender = function forceReRender2() {
        forceUpdate({});
      };
      var formStore = new FormStore(forceReRender);
      formRef.current = formStore.getForm();
    }
  }
  return [formRef.current];
}
var FormContext = /* @__PURE__ */ React.createContext({
  triggerFormChange: function triggerFormChange() {
  },
  triggerFormFinish: function triggerFormFinish() {
  },
  registerForm: function registerForm() {
  },
  unregisterForm: function unregisterForm() {
  }
});
var FormProvider = function FormProvider2(_ref) {
  var validateMessages = _ref.validateMessages, onFormChange = _ref.onFormChange, onFormFinish = _ref.onFormFinish, children = _ref.children;
  var formContext = React.useContext(FormContext);
  var formsRef = React.useRef({});
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: _objectSpread2$3(_objectSpread2$3({}, formContext), {}, {
      validateMessages: _objectSpread2$3(_objectSpread2$3({}, formContext.validateMessages), validateMessages),
      triggerFormChange: function triggerFormChange2(name2, changedFields) {
        if (onFormChange) {
          onFormChange(name2, {
            changedFields,
            forms: formsRef.current
          });
        }
        formContext.triggerFormChange(name2, changedFields);
      },
      triggerFormFinish: function triggerFormFinish2(name2, values) {
        if (onFormFinish) {
          onFormFinish(name2, {
            values,
            forms: formsRef.current
          });
        }
        formContext.triggerFormFinish(name2, values);
      },
      registerForm: function registerForm2(name2, form) {
        if (name2) {
          formsRef.current = _objectSpread2$3(_objectSpread2$3({}, formsRef.current), {}, _defineProperty$3({}, name2, form));
        }
        formContext.registerForm(name2, form);
      },
      unregisterForm: function unregisterForm2(name2) {
        var newForms = _objectSpread2$3({}, formsRef.current);
        delete newForms[name2];
        formsRef.current = newForms;
        formContext.unregisterForm(name2);
      }
    })
  }, children);
};
var _excluded$i = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"];
var Form = function Form2(_ref, ref2) {
  var name2 = _ref.name, initialValues = _ref.initialValues, fields = _ref.fields, form = _ref.form, preserve = _ref.preserve, children = _ref.children, _ref$component = _ref.component, Component2 = _ref$component === void 0 ? "form" : _ref$component, validateMessages = _ref.validateMessages, _ref$validateTrigger = _ref.validateTrigger, validateTrigger = _ref$validateTrigger === void 0 ? "onChange" : _ref$validateTrigger, onValuesChange = _ref.onValuesChange, _onFieldsChange = _ref.onFieldsChange, _onFinish = _ref.onFinish, onFinishFailed = _ref.onFinishFailed, restProps = _objectWithoutProperties$1(_ref, _excluded$i);
  var formContext = React.useContext(FormContext);
  var _useForm = useForm(form), _useForm2 = _slicedToArray$1(_useForm, 1), formInstance = _useForm2[0];
  var _formInstance$getInte = formInstance.getInternalHooks(HOOK_MARK), useSubscribe = _formInstance$getInte.useSubscribe, setInitialValues = _formInstance$getInte.setInitialValues, setCallbacks = _formInstance$getInte.setCallbacks, setValidateMessages = _formInstance$getInte.setValidateMessages, setPreserve = _formInstance$getInte.setPreserve;
  React.useImperativeHandle(ref2, function() {
    return formInstance;
  });
  React.useEffect(function() {
    formContext.registerForm(name2, formInstance);
    return function() {
      formContext.unregisterForm(name2);
    };
  }, [formContext, formInstance, name2]);
  setValidateMessages(_objectSpread2$3(_objectSpread2$3({}, formContext.validateMessages), validateMessages));
  setCallbacks({
    onValuesChange,
    onFieldsChange: function onFieldsChange(changedFields) {
      formContext.triggerFormChange(name2, changedFields);
      if (_onFieldsChange) {
        for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          rest[_key - 1] = arguments[_key];
        }
        _onFieldsChange.apply(void 0, [changedFields].concat(rest));
      }
    },
    onFinish: function onFinish(values2) {
      formContext.triggerFormFinish(name2, values2);
      if (_onFinish) {
        _onFinish(values2);
      }
    },
    onFinishFailed
  });
  setPreserve(preserve);
  var mountRef = React.useRef(null);
  setInitialValues(initialValues, !mountRef.current);
  if (!mountRef.current) {
    mountRef.current = true;
  }
  var childrenNode = children;
  var childrenRenderProps = typeof children === "function";
  if (childrenRenderProps) {
    var values = formInstance.getFieldsValue(true);
    childrenNode = children(values, formInstance);
  }
  useSubscribe(!childrenRenderProps);
  var prevFieldsRef = React.useRef();
  React.useEffect(function() {
    if (!isSimilar(prevFieldsRef.current || [], fields || [])) {
      formInstance.setFields(fields || []);
    }
    prevFieldsRef.current = fields;
  }, [fields, formInstance]);
  var formContextValue = React.useMemo(function() {
    return _objectSpread2$3(_objectSpread2$3({}, formInstance), {}, {
      validateTrigger
    });
  }, [formInstance, validateTrigger]);
  var wrapperNode = /* @__PURE__ */ React.createElement(Context.Provider, {
    value: formContextValue
  }, childrenNode);
  if (Component2 === false) {
    return wrapperNode;
  }
  return /* @__PURE__ */ React.createElement(Component2, _extends$1({}, restProps, {
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      event.stopPropagation();
      formInstance.submit();
    },
    onReset: function onReset(event) {
      var _restProps$onReset;
      event.preventDefault();
      formInstance.resetFields();
      (_restProps$onReset = restProps.onReset) === null || _restProps$onReset === void 0 ? void 0 : _restProps$onReset.call(restProps, event);
    }
  }), wrapperNode);
};
var InternalForm = /* @__PURE__ */ React.forwardRef(Form);
var RefForm = InternalForm;
RefForm.FormProvider = FormProvider;
RefForm.Field = WrapperField;
RefForm.List = List;
RefForm.useForm = useForm;
var devWarning = function(valid, component, message) {
  warningOnce(valid, "[antd: ".concat(component, "] ").concat(message));
};
var enUS$1 = {
  items_per_page: "/ page",
  jump_to: "Go to",
  jump_to_confirm: "confirm",
  page: "Page",
  prev_page: "Previous Page",
  next_page: "Next Page",
  prev_5: "Previous 5 Pages",
  next_5: "Next 5 Pages",
  prev_3: "Previous 3 Pages",
  next_3: "Next 3 Pages",
  page_size: "Page Size"
};
var locale$2 = {
  locale: "en_US",
  today: "Today",
  now: "Now",
  backToToday: "Back to today",
  ok: "Ok",
  clear: "Clear",
  month: "Month",
  year: "Year",
  timeSelect: "select time",
  dateSelect: "select date",
  weekSelect: "Choose a week",
  monthSelect: "Choose a month",
  yearSelect: "Choose a year",
  decadeSelect: "Choose a decade",
  yearFormat: "YYYY",
  dateFormat: "M/D/YYYY",
  dayFormat: "D",
  dateTimeFormat: "M/D/YYYY HH:mm:ss",
  monthBeforeYear: true,
  previousMonth: "Previous month (PageUp)",
  nextMonth: "Next month (PageDown)",
  previousYear: "Last year (Control + left)",
  nextYear: "Next year (Control + right)",
  previousDecade: "Last decade",
  nextDecade: "Next decade",
  previousCentury: "Last century",
  nextCentury: "Next century"
};
var locale$1 = {
  placeholder: "Select time",
  rangePlaceholder: ["Start time", "End time"]
};
var TimePicker = locale$1;
var locale = {
  lang: _extends$1({
    placeholder: "Select date",
    yearPlaceholder: "Select year",
    quarterPlaceholder: "Select quarter",
    monthPlaceholder: "Select month",
    weekPlaceholder: "Select week",
    rangePlaceholder: ["Start date", "End date"],
    rangeYearPlaceholder: ["Start year", "End year"],
    rangeQuarterPlaceholder: ["Start quarter", "End quarter"],
    rangeMonthPlaceholder: ["Start month", "End month"],
    rangeWeekPlaceholder: ["Start week", "End week"]
  }, locale$2),
  timePickerLocale: _extends$1({}, TimePicker)
};
var enUS = locale;
var typeTemplate = "${label} is not a valid ${type}";
var localeValues = {
  locale: "en",
  Pagination: enUS$1,
  DatePicker: enUS,
  TimePicker,
  Calendar: enUS,
  global: {
    placeholder: "Please select"
  },
  Table: {
    filterTitle: "Filter menu",
    filterConfirm: "OK",
    filterReset: "Reset",
    filterEmptyText: "No filters",
    filterCheckall: "Select all items",
    filterSearchPlaceholder: "Search in filters",
    emptyText: "No data",
    selectAll: "Select current page",
    selectInvert: "Invert current page",
    selectNone: "Clear all data",
    selectionAll: "Select all data",
    sortTitle: "Sort",
    expand: "Expand row",
    collapse: "Collapse row",
    triggerDesc: "Click to sort descending",
    triggerAsc: "Click to sort ascending",
    cancelSort: "Click to cancel sorting"
  },
  Modal: {
    okText: "OK",
    cancelText: "Cancel",
    justOkText: "OK"
  },
  Popconfirm: {
    okText: "OK",
    cancelText: "Cancel"
  },
  Transfer: {
    titles: ["", ""],
    searchPlaceholder: "Search here",
    itemUnit: "item",
    itemsUnit: "items",
    remove: "Remove",
    selectCurrent: "Select current page",
    removeCurrent: "Remove current page",
    selectAll: "Select all data",
    removeAll: "Remove all data",
    selectInvert: "Invert current page"
  },
  Upload: {
    uploading: "Uploading...",
    removeFile: "Remove file",
    uploadError: "Upload error",
    previewFile: "Preview file",
    downloadFile: "Download file"
  },
  Empty: {
    description: "No Data"
  },
  Icon: {
    icon: "icon"
  },
  Text: {
    edit: "Edit",
    copy: "Copy",
    copied: "Copied",
    expand: "Expand"
  },
  PageHeader: {
    back: "Back"
  },
  Form: {
    optional: "(optional)",
    defaultValidateMessages: {
      "default": "Field validation error for ${label}",
      required: "Please enter ${label}",
      "enum": "${label} must be one of [${enum}]",
      whitespace: "${label} cannot be a blank character",
      date: {
        format: "${label} date format is invalid",
        parse: "${label} cannot be converted to a date",
        invalid: "${label} is an invalid date"
      },
      types: {
        string: typeTemplate,
        method: typeTemplate,
        array: typeTemplate,
        object: typeTemplate,
        number: typeTemplate,
        date: typeTemplate,
        "boolean": typeTemplate,
        integer: typeTemplate,
        "float": typeTemplate,
        regexp: typeTemplate,
        email: typeTemplate,
        url: typeTemplate,
        hex: typeTemplate
      },
      string: {
        len: "${label} must be ${len} characters",
        min: "${label} must be at least ${min} characters",
        max: "${label} must be up to ${max} characters",
        range: "${label} must be between ${min}-${max} characters"
      },
      number: {
        len: "${label} must be equal to ${len}",
        min: "${label} must be minimum ${min}",
        max: "${label} must be maximum ${max}",
        range: "${label} must be between ${min}-${max}"
      },
      array: {
        len: "Must be ${len} ${label}",
        min: "At least ${min} ${label}",
        max: "At most ${max} ${label}",
        range: "The amount of ${label} must be between ${min}-${max}"
      },
      pattern: {
        mismatch: "${label} does not match the pattern ${pattern}"
      }
    }
  },
  Image: {
    preview: "Preview"
  }
};
var defaultLocale = localeValues;
var LocaleContext = /* @__PURE__ */ createContext(void 0);
var LocaleContext$1 = LocaleContext;
var LocaleReceiver = /* @__PURE__ */ function(_React$Component) {
  _inherits(LocaleReceiver2, _React$Component);
  var _super = _createSuper(LocaleReceiver2);
  function LocaleReceiver2() {
    _classCallCheck(this, LocaleReceiver2);
    return _super.apply(this, arguments);
  }
  _createClass(LocaleReceiver2, [{
    key: "getLocale",
    value: function getLocale() {
      var _this$props = this.props, componentName = _this$props.componentName, defaultLocale$1 = _this$props.defaultLocale;
      var locale2 = defaultLocale$1 || defaultLocale[componentName !== null && componentName !== void 0 ? componentName : "global"];
      var antLocale = this.context;
      var localeFromContext = componentName && antLocale ? antLocale[componentName] : {};
      return _extends$1(_extends$1({}, locale2 instanceof Function ? locale2() : locale2), localeFromContext || {});
    }
  }, {
    key: "getLocaleCode",
    value: function getLocaleCode() {
      var antLocale = this.context;
      var localeCode = antLocale && antLocale.locale;
      if (antLocale && antLocale.exist && !localeCode) {
        return defaultLocale.locale;
      }
      return localeCode;
    }
  }, {
    key: "render",
    value: function render2() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    }
  }]);
  return LocaleReceiver2;
}(React.Component);
LocaleReceiver.defaultProps = {
  componentName: "global"
};
LocaleReceiver.contextType = LocaleContext$1;
var Empty$2 = function Empty() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-default");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "184",
    height: "152",
    viewBox: "0 0 184 152",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(24 31.67)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "67.797",
    cy: "106.89",
    rx: "67.797",
    ry: "12.668"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-1"),
    d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-2"),
    d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z",
    transform: "translate(13.56)"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-3"),
    d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-4"),
    d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z"
  })), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-5"),
    d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    transform: "translate(149.65 15.383)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    cx: "20.654",
    cy: "3.167",
    rx: "2.849",
    ry: "2.815"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z"
  }))));
};
var DefaultEmptyImg = Empty$2;
var Simple = function Simple2() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-simple");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "64",
    height: "41",
    viewBox: "0 0 64 41",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(0 1)",
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "32",
    cy: "33",
    rx: "32",
    ry: "7"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    fillRule: "nonzero"
  }, /* @__PURE__ */ React.createElement("path", {
    d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z",
    className: "".concat(prefixCls, "-path")
  }))));
};
var SimpleEmptyImg = Simple;
var __rest$b = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var defaultEmptyImg = /* @__PURE__ */ React.createElement(DefaultEmptyImg, null);
var simpleEmptyImg = /* @__PURE__ */ React.createElement(SimpleEmptyImg, null);
var Empty2 = function Empty3(_a2) {
  var className = _a2.className, customizePrefixCls = _a2.prefixCls, _a$image = _a2.image, image = _a$image === void 0 ? defaultEmptyImg : _a$image, description2 = _a2.description, children = _a2.children, imageStyle = _a2.imageStyle, restProps = __rest$b(_a2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  return /* @__PURE__ */ React.createElement(LocaleReceiver, {
    componentName: "Empty"
  }, function(locale2) {
    var _classNames;
    var prefixCls = getPrefixCls("empty", customizePrefixCls);
    var des = typeof description2 !== "undefined" ? description2 : locale2.description;
    var alt = typeof des === "string" ? des : "empty";
    var imageNode = null;
    if (typeof image === "string") {
      imageNode = /* @__PURE__ */ React.createElement("img", {
        alt,
        src: image
      });
    } else {
      imageNode = image;
    }
    return /* @__PURE__ */ React.createElement("div", _extends$1({
      className: classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-normal"), image === simpleEmptyImg), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className)
    }, restProps), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-image"),
      style: imageStyle
    }, imageNode), des && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-description")
    }, des), children && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, children));
  });
};
Empty2.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty2.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
var Empty$1 = Empty2;
var renderEmpty = function renderEmpty2(componentName) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var getPrefixCls = _ref.getPrefixCls;
    var prefix = getPrefixCls("empty");
    switch (componentName) {
      case "Table":
      case "List":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE
        });
      case "Select":
      case "TreeSelect":
      case "Cascader":
      case "Transfer":
      case "Mentions":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE,
          className: "".concat(prefix, "-small")
        });
      default:
        return /* @__PURE__ */ React.createElement(Empty$1, null);
    }
  });
};
var defaultRenderEmpty = renderEmpty;
var defaultGetPrefixCls = function defaultGetPrefixCls2(suffixCls, customizePrefixCls) {
  if (customizePrefixCls)
    return customizePrefixCls;
  return suffixCls ? "ant-".concat(suffixCls) : "ant";
};
var ConfigContext = /* @__PURE__ */ React.createContext({
  getPrefixCls: defaultGetPrefixCls,
  renderEmpty: defaultRenderEmpty
});
var ConfigConsumer = ConfigContext.Consumer;
var SizeContext = /* @__PURE__ */ React.createContext(void 0);
var SizeContext$1 = SizeContext;
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
function makePrefixMap(styleProp, eventName) {
  var prefixes = {};
  prefixes[styleProp.toLowerCase()] = eventName.toLowerCase();
  prefixes["Webkit".concat(styleProp)] = "webkit".concat(eventName);
  prefixes["Moz".concat(styleProp)] = "moz".concat(eventName);
  prefixes["ms".concat(styleProp)] = "MS".concat(eventName);
  prefixes["O".concat(styleProp)] = "o".concat(eventName.toLowerCase());
  return prefixes;
}
function getVendorPrefixes(domSupport, win) {
  var prefixes = {
    animationend: makePrefixMap("Animation", "AnimationEnd"),
    transitionend: makePrefixMap("Transition", "TransitionEnd")
  };
  if (domSupport) {
    if (!("AnimationEvent" in win)) {
      delete prefixes.animationend.animation;
    }
    if (!("TransitionEvent" in win)) {
      delete prefixes.transitionend.transition;
    }
  }
  return prefixes;
}
var vendorPrefixes = getVendorPrefixes(canUseDom(), typeof window !== "undefined" ? window : {});
var style = {};
if (canUseDom()) {
  var _document$createEleme = document.createElement("div");
  style = _document$createEleme.style;
}
var prefixedEventNames = {};
function getVendorPrefixedEventName(eventName) {
  if (prefixedEventNames[eventName]) {
    return prefixedEventNames[eventName];
  }
  var prefixMap = vendorPrefixes[eventName];
  if (prefixMap) {
    var stylePropList = Object.keys(prefixMap);
    var len2 = stylePropList.length;
    for (var i = 0; i < len2; i += 1) {
      var styleProp = stylePropList[i];
      if (Object.prototype.hasOwnProperty.call(prefixMap, styleProp) && styleProp in style) {
        prefixedEventNames[eventName] = prefixMap[styleProp];
        return prefixedEventNames[eventName];
      }
    }
  }
  return "";
}
var internalAnimationEndName = getVendorPrefixedEventName("animationend");
var internalTransitionEndName = getVendorPrefixedEventName("transitionend");
var supportTransition = !!(internalAnimationEndName && internalTransitionEndName);
var animationEndName = internalAnimationEndName || "animationend";
var transitionEndName = internalTransitionEndName || "transitionend";
function getTransitionName$1(transitionName, transitionType) {
  if (!transitionName)
    return null;
  if (_typeof$1(transitionName) === "object") {
    var type4 = transitionType.replace(/-\w/g, function(match) {
      return match[1].toUpperCase();
    });
    return transitionName[type4];
  }
  return "".concat(transitionName, "-").concat(transitionType);
}
var STATUS_NONE = "none";
var STATUS_APPEAR = "appear";
var STATUS_ENTER = "enter";
var STATUS_LEAVE = "leave";
var STEP_NONE = "none";
var STEP_PREPARE = "prepare";
var STEP_START = "start";
var STEP_ACTIVE = "active";
var STEP_ACTIVATED = "end";
function useMountStatus(defaultValue) {
  var destroyRef = useRef(false);
  var _useState = useState(defaultValue), _useState2 = _slicedToArray$1(_useState, 2), val = _useState2[0], setVal = _useState2[1];
  function setValue2(next) {
    if (!destroyRef.current) {
      setVal(next);
    }
  }
  useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  return [val, setValue2];
}
var useIsomorphicLayoutEffect = canUseDom() ? useLayoutEffect$1 : useEffect;
var raf = function raf2(callback) {
  return +setTimeout(callback, 16);
};
var caf = function caf2(num) {
  return clearTimeout(num);
};
if (typeof window !== "undefined" && "requestAnimationFrame" in window) {
  raf = function raf3(callback) {
    return window.requestAnimationFrame(callback);
  };
  caf = function caf3(handle) {
    return window.cancelAnimationFrame(handle);
  };
}
var rafUUID = 0;
var rafIds = /* @__PURE__ */ new Map();
function cleanup(id2) {
  rafIds.delete(id2);
}
function wrapperRaf$1(callback) {
  var times = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  rafUUID += 1;
  var id2 = rafUUID;
  function callRef(leftTimes) {
    if (leftTimes === 0) {
      cleanup(id2);
      callback();
    } else {
      var realId = raf(function() {
        callRef(leftTimes - 1);
      });
      rafIds.set(id2, realId);
    }
  }
  callRef(times);
  return id2;
}
wrapperRaf$1.cancel = function(id2) {
  var realId = rafIds.get(id2);
  cleanup(realId);
  return caf(realId);
};
var useNextFrame = function() {
  var nextFrameRef = React.useRef(null);
  function cancelNextFrame() {
    wrapperRaf$1.cancel(nextFrameRef.current);
  }
  function nextFrame(callback) {
    var delay = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 2;
    cancelNextFrame();
    var nextFrameId = wrapperRaf$1(function() {
      if (delay <= 1) {
        callback({
          isCanceled: function isCanceled() {
            return nextFrameId !== nextFrameRef.current;
          }
        });
      } else {
        nextFrame(callback, delay - 1);
      }
    });
    nextFrameRef.current = nextFrameId;
  }
  React.useEffect(function() {
    return function() {
      cancelNextFrame();
    };
  }, []);
  return [nextFrame, cancelNextFrame];
};
var STEP_QUEUE = [STEP_PREPARE, STEP_START, STEP_ACTIVE, STEP_ACTIVATED];
var SkipStep = false;
var DoStep = true;
function isActive(step) {
  return step === STEP_ACTIVE || step === STEP_ACTIVATED;
}
var useStepQueue = function(status, callback) {
  var _useState = useMountStatus(STEP_NONE), _useState2 = _slicedToArray$1(_useState, 2), step = _useState2[0], setStep = _useState2[1];
  var _useNextFrame = useNextFrame(), _useNextFrame2 = _slicedToArray$1(_useNextFrame, 2), nextFrame = _useNextFrame2[0], cancelNextFrame = _useNextFrame2[1];
  function startQueue() {
    setStep(STEP_PREPARE);
  }
  useIsomorphicLayoutEffect(function() {
    if (step !== STEP_NONE && step !== STEP_ACTIVATED) {
      var index2 = STEP_QUEUE.indexOf(step);
      var nextStep = STEP_QUEUE[index2 + 1];
      var result = callback(step);
      if (result === SkipStep) {
        setStep(nextStep);
      } else {
        nextFrame(function(info) {
          function doNext() {
            if (info.isCanceled())
              return;
            setStep(nextStep);
          }
          if (result === true) {
            doNext();
          } else {
            Promise.resolve(result).then(doNext);
          }
        });
      }
    }
  }, [status, step]);
  React.useEffect(function() {
    return function() {
      cancelNextFrame();
    };
  }, []);
  return [startQueue, step];
};
var useDomMotionEvents = function(callback) {
  var cacheElementRef = useRef();
  var callbackRef = useRef(callback);
  callbackRef.current = callback;
  var onInternalMotionEnd = React.useCallback(function(event) {
    callbackRef.current(event);
  }, []);
  function removeMotionEvents(element) {
    if (element) {
      element.removeEventListener(transitionEndName, onInternalMotionEnd);
      element.removeEventListener(animationEndName, onInternalMotionEnd);
    }
  }
  function patchMotionEvents(element) {
    if (cacheElementRef.current && cacheElementRef.current !== element) {
      removeMotionEvents(cacheElementRef.current);
    }
    if (element && element !== cacheElementRef.current) {
      element.addEventListener(transitionEndName, onInternalMotionEnd);
      element.addEventListener(animationEndName, onInternalMotionEnd);
      cacheElementRef.current = element;
    }
  }
  React.useEffect(function() {
    return function() {
      removeMotionEvents(cacheElementRef.current);
    };
  }, []);
  return [patchMotionEvents, removeMotionEvents];
};
function useStatus(supportMotion, visible, getElement2, _ref) {
  var _ref$motionEnter = _ref.motionEnter, motionEnter = _ref$motionEnter === void 0 ? true : _ref$motionEnter, _ref$motionAppear = _ref.motionAppear, motionAppear = _ref$motionAppear === void 0 ? true : _ref$motionAppear, _ref$motionLeave = _ref.motionLeave, motionLeave = _ref$motionLeave === void 0 ? true : _ref$motionLeave, motionDeadline = _ref.motionDeadline, motionLeaveImmediately = _ref.motionLeaveImmediately, onAppearPrepare = _ref.onAppearPrepare, onEnterPrepare = _ref.onEnterPrepare, onLeavePrepare = _ref.onLeavePrepare, onAppearStart = _ref.onAppearStart, onEnterStart = _ref.onEnterStart, onLeaveStart = _ref.onLeaveStart, onAppearActive = _ref.onAppearActive, onEnterActive = _ref.onEnterActive, onLeaveActive = _ref.onLeaveActive, onAppearEnd = _ref.onAppearEnd, onEnterEnd = _ref.onEnterEnd, onLeaveEnd = _ref.onLeaveEnd, onVisibleChanged = _ref.onVisibleChanged;
  var _useState = useMountStatus(), _useState2 = _slicedToArray$1(_useState, 2), asyncVisible = _useState2[0], setAsyncVisible = _useState2[1];
  var _useState3 = useMountStatus(STATUS_NONE), _useState4 = _slicedToArray$1(_useState3, 2), status = _useState4[0], setStatus = _useState4[1];
  var _useState5 = useMountStatus(null), _useState6 = _slicedToArray$1(_useState5, 2), style2 = _useState6[0], setStyle2 = _useState6[1];
  var mountedRef = useRef(false);
  var deadlineRef = useRef(null);
  var destroyedRef = useRef(false);
  var cacheElementRef = useRef(null);
  function getDomElement() {
    var element = getElement2();
    return element || cacheElementRef.current;
  }
  var activeRef = useRef(false);
  function onInternalMotionEnd(event) {
    var element = getDomElement();
    if (event && !event.deadline && event.target !== element) {
      return;
    }
    var canEnd;
    if (status === STATUS_APPEAR && activeRef.current) {
      canEnd = onAppearEnd === null || onAppearEnd === void 0 ? void 0 : onAppearEnd(element, event);
    } else if (status === STATUS_ENTER && activeRef.current) {
      canEnd = onEnterEnd === null || onEnterEnd === void 0 ? void 0 : onEnterEnd(element, event);
    } else if (status === STATUS_LEAVE && activeRef.current) {
      canEnd = onLeaveEnd === null || onLeaveEnd === void 0 ? void 0 : onLeaveEnd(element, event);
    }
    if (canEnd !== false && !destroyedRef.current) {
      setStatus(STATUS_NONE);
      setStyle2(null);
    }
  }
  var _useDomMotionEvents = useDomMotionEvents(onInternalMotionEnd), _useDomMotionEvents2 = _slicedToArray$1(_useDomMotionEvents, 1), patchMotionEvents = _useDomMotionEvents2[0];
  var eventHandlers = React.useMemo(function() {
    var _ref2, _ref3, _ref4;
    switch (status) {
      case STATUS_APPEAR:
        return _ref2 = {}, _defineProperty$3(_ref2, STEP_PREPARE, onAppearPrepare), _defineProperty$3(_ref2, STEP_START, onAppearStart), _defineProperty$3(_ref2, STEP_ACTIVE, onAppearActive), _ref2;
      case STATUS_ENTER:
        return _ref3 = {}, _defineProperty$3(_ref3, STEP_PREPARE, onEnterPrepare), _defineProperty$3(_ref3, STEP_START, onEnterStart), _defineProperty$3(_ref3, STEP_ACTIVE, onEnterActive), _ref3;
      case STATUS_LEAVE:
        return _ref4 = {}, _defineProperty$3(_ref4, STEP_PREPARE, onLeavePrepare), _defineProperty$3(_ref4, STEP_START, onLeaveStart), _defineProperty$3(_ref4, STEP_ACTIVE, onLeaveActive), _ref4;
      default:
        return {};
    }
  }, [status]);
  var _useStepQueue = useStepQueue(status, function(newStep) {
    if (newStep === STEP_PREPARE) {
      var onPrepare = eventHandlers[STEP_PREPARE];
      if (!onPrepare) {
        return SkipStep;
      }
      return onPrepare(getDomElement());
    }
    if (step in eventHandlers) {
      var _eventHandlers$step;
      setStyle2(((_eventHandlers$step = eventHandlers[step]) === null || _eventHandlers$step === void 0 ? void 0 : _eventHandlers$step.call(eventHandlers, getDomElement(), null)) || null);
    }
    if (step === STEP_ACTIVE) {
      patchMotionEvents(getDomElement());
      if (motionDeadline > 0) {
        clearTimeout(deadlineRef.current);
        deadlineRef.current = setTimeout(function() {
          onInternalMotionEnd({
            deadline: true
          });
        }, motionDeadline);
      }
    }
    return DoStep;
  }), _useStepQueue2 = _slicedToArray$1(_useStepQueue, 2), startStep = _useStepQueue2[0], step = _useStepQueue2[1];
  var active = isActive(step);
  activeRef.current = active;
  useIsomorphicLayoutEffect(function() {
    setAsyncVisible(visible);
    var isMounted = mountedRef.current;
    mountedRef.current = true;
    if (!supportMotion) {
      return;
    }
    var nextStatus;
    if (!isMounted && visible && motionAppear) {
      nextStatus = STATUS_APPEAR;
    }
    if (isMounted && visible && motionEnter) {
      nextStatus = STATUS_ENTER;
    }
    if (isMounted && !visible && motionLeave || !isMounted && motionLeaveImmediately && !visible && motionLeave) {
      nextStatus = STATUS_LEAVE;
    }
    if (nextStatus) {
      setStatus(nextStatus);
      startStep();
    }
  }, [visible]);
  useEffect(function() {
    if (status === STATUS_APPEAR && !motionAppear || status === STATUS_ENTER && !motionEnter || status === STATUS_LEAVE && !motionLeave) {
      setStatus(STATUS_NONE);
    }
  }, [motionAppear, motionEnter, motionLeave]);
  useEffect(function() {
    return function() {
      clearTimeout(deadlineRef.current);
      destroyedRef.current = true;
    };
  }, []);
  useEffect(function() {
    if (asyncVisible !== void 0 && status === STATUS_NONE) {
      onVisibleChanged === null || onVisibleChanged === void 0 ? void 0 : onVisibleChanged(asyncVisible);
    }
  }, [asyncVisible, status]);
  var mergedStyle = style2;
  if (eventHandlers[STEP_PREPARE] && step === STEP_START) {
    mergedStyle = _objectSpread2$3({
      transition: "none"
    }, mergedStyle);
  }
  return [status, step, mergedStyle, asyncVisible !== null && asyncVisible !== void 0 ? asyncVisible : visible];
}
var DomWrapper = /* @__PURE__ */ function(_React$Component) {
  _inherits(DomWrapper2, _React$Component);
  var _super = _createSuper(DomWrapper2);
  function DomWrapper2() {
    _classCallCheck(this, DomWrapper2);
    return _super.apply(this, arguments);
  }
  _createClass(DomWrapper2, [{
    key: "render",
    value: function render2() {
      return this.props.children;
    }
  }]);
  return DomWrapper2;
}(React.Component);
function genCSSMotion(config2) {
  var transitionSupport = config2;
  if (_typeof$1(config2) === "object") {
    transitionSupport = config2.transitionSupport;
  }
  function isSupportTransition(props) {
    return !!(props.motionName && transitionSupport);
  }
  var CSSMotion2 = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
    var _props$visible = props.visible, visible = _props$visible === void 0 ? true : _props$visible, _props$removeOnLeave = props.removeOnLeave, removeOnLeave = _props$removeOnLeave === void 0 ? true : _props$removeOnLeave, forceRender = props.forceRender, children = props.children, motionName = props.motionName, leavedClassName = props.leavedClassName, eventProps = props.eventProps;
    var supportMotion = isSupportTransition(props);
    var nodeRef = useRef();
    var wrapperNodeRef = useRef();
    function getDomElement() {
      try {
        return nodeRef.current instanceof HTMLElement ? nodeRef.current : findDOMNode(wrapperNodeRef.current);
      } catch (e2) {
        return null;
      }
    }
    var _useStatus = useStatus(supportMotion, visible, getDomElement, props), _useStatus2 = _slicedToArray$1(_useStatus, 4), status = _useStatus2[0], statusStep = _useStatus2[1], statusStyle = _useStatus2[2], mergedVisible = _useStatus2[3];
    var renderedRef = React.useRef(mergedVisible);
    if (mergedVisible) {
      renderedRef.current = true;
    }
    var setNodeRef = React.useCallback(function(node) {
      nodeRef.current = node;
      fillRef(ref2, node);
    }, []);
    var motionChildren;
    var mergedProps = _objectSpread2$3(_objectSpread2$3({}, eventProps), {}, {
      visible
    });
    if (!children) {
      motionChildren = null;
    } else if (status === STATUS_NONE || !isSupportTransition(props)) {
      if (mergedVisible) {
        motionChildren = children(_objectSpread2$3({}, mergedProps), setNodeRef);
      } else if (!removeOnLeave && renderedRef.current) {
        motionChildren = children(_objectSpread2$3(_objectSpread2$3({}, mergedProps), {}, {
          className: leavedClassName
        }), setNodeRef);
      } else if (forceRender) {
        motionChildren = children(_objectSpread2$3(_objectSpread2$3({}, mergedProps), {}, {
          style: {
            display: "none"
          }
        }), setNodeRef);
      } else {
        motionChildren = null;
      }
    } else {
      var _classNames;
      var statusSuffix;
      if (statusStep === STEP_PREPARE) {
        statusSuffix = "prepare";
      } else if (isActive(statusStep)) {
        statusSuffix = "active";
      } else if (statusStep === STEP_START) {
        statusSuffix = "start";
      }
      motionChildren = children(_objectSpread2$3(_objectSpread2$3({}, mergedProps), {}, {
        className: classNames(getTransitionName$1(motionName, status), (_classNames = {}, _defineProperty$3(_classNames, getTransitionName$1(motionName, "".concat(status, "-").concat(statusSuffix)), statusSuffix), _defineProperty$3(_classNames, motionName, typeof motionName === "string"), _classNames)),
        style: statusStyle
      }), setNodeRef);
    }
    return /* @__PURE__ */ React.createElement(DomWrapper, {
      ref: wrapperNodeRef
    }, motionChildren);
  });
  CSSMotion2.displayName = "CSSMotion";
  return CSSMotion2;
}
var CSSMotion = genCSSMotion(supportTransition);
var LoadingOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
var LoadingOutlinedSvg = LoadingOutlined$2;
function bound01(n2, max3) {
  if (isOnePointZero(n2)) {
    n2 = "100%";
  }
  var isPercent = isPercentage(n2);
  n2 = max3 === 360 ? n2 : Math.min(max3, Math.max(0, parseFloat(n2)));
  if (isPercent) {
    n2 = parseInt(String(n2 * max3), 10) / 100;
  }
  if (Math.abs(n2 - max3) < 1e-6) {
    return 1;
  }
  if (max3 === 360) {
    n2 = (n2 < 0 ? n2 % max3 + max3 : n2 % max3) / parseFloat(String(max3));
  } else {
    n2 = n2 % max3 / parseFloat(String(max3));
  }
  return n2;
}
function isOnePointZero(n2) {
  return typeof n2 === "string" && n2.indexOf(".") !== -1 && parseFloat(n2) === 1;
}
function isPercentage(n2) {
  return typeof n2 === "string" && n2.indexOf("%") !== -1;
}
function boundAlpha(a) {
  a = parseFloat(a);
  if (isNaN(a) || a < 0 || a > 1) {
    a = 1;
  }
  return a;
}
function convertToPercentage(n2) {
  if (n2 <= 1) {
    return Number(n2) * 100 + "%";
  }
  return n2;
}
function pad2(c2) {
  return c2.length === 1 ? "0" + c2 : String(c2);
}
function rgbToRgb(r2, g2, b2) {
  return {
    r: bound01(r2, 255) * 255,
    g: bound01(g2, 255) * 255,
    b: bound01(b2, 255) * 255
  };
}
function hue2rgb(p2, q2, t2) {
  if (t2 < 0) {
    t2 += 1;
  }
  if (t2 > 1) {
    t2 -= 1;
  }
  if (t2 < 1 / 6) {
    return p2 + (q2 - p2) * (6 * t2);
  }
  if (t2 < 1 / 2) {
    return q2;
  }
  if (t2 < 2 / 3) {
    return p2 + (q2 - p2) * (2 / 3 - t2) * 6;
  }
  return p2;
}
function hslToRgb(h, s, l2) {
  var r2;
  var g2;
  var b2;
  h = bound01(h, 360);
  s = bound01(s, 100);
  l2 = bound01(l2, 100);
  if (s === 0) {
    g2 = l2;
    b2 = l2;
    r2 = l2;
  } else {
    var q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    var p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h + 1 / 3);
    g2 = hue2rgb(p2, q2, h);
    b2 = hue2rgb(p2, q2, h - 1 / 3);
  }
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHsv(r2, g2, b2) {
  r2 = bound01(r2, 255);
  g2 = bound01(g2, 255);
  b2 = bound01(b2, 255);
  var max3 = Math.max(r2, g2, b2);
  var min3 = Math.min(r2, g2, b2);
  var h = 0;
  var v4 = max3;
  var d2 = max3 - min3;
  var s = max3 === 0 ? 0 : d2 / max3;
  if (max3 === min3) {
    h = 0;
  } else {
    switch (max3) {
      case r2:
        h = (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
        break;
      case g2:
        h = (b2 - r2) / d2 + 2;
        break;
      case b2:
        h = (r2 - g2) / d2 + 4;
        break;
    }
    h /= 6;
  }
  return { h, s, v: v4 };
}
function hsvToRgb(h, s, v4) {
  h = bound01(h, 360) * 6;
  s = bound01(s, 100);
  v4 = bound01(v4, 100);
  var i = Math.floor(h);
  var f2 = h - i;
  var p2 = v4 * (1 - s);
  var q2 = v4 * (1 - f2 * s);
  var t2 = v4 * (1 - (1 - f2) * s);
  var mod = i % 6;
  var r2 = [v4, q2, p2, p2, t2, v4][mod];
  var g2 = [t2, v4, v4, q2, p2, p2][mod];
  var b2 = [p2, p2, t2, v4, v4, q2][mod];
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHex(r2, g2, b2, allow3Char) {
  var hex2 = [
    pad2(Math.round(r2).toString(16)),
    pad2(Math.round(g2).toString(16)),
    pad2(Math.round(b2).toString(16))
  ];
  if (allow3Char && hex2[0].startsWith(hex2[0].charAt(1)) && hex2[1].startsWith(hex2[1].charAt(1)) && hex2[2].startsWith(hex2[2].charAt(1))) {
    return hex2[0].charAt(0) + hex2[1].charAt(0) + hex2[2].charAt(0);
  }
  return hex2.join("");
}
function convertHexToDecimal(h) {
  return parseIntFromHex(h) / 255;
}
function parseIntFromHex(val) {
  return parseInt(val, 16);
}
var names = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function inputToRGB(color) {
  var rgb = { r: 0, g: 0, b: 0 };
  var a = 1;
  var s = null;
  var v4 = null;
  var l2 = null;
  var ok2 = false;
  var format2 = false;
  if (typeof color === "string") {
    color = stringInputToObject(color);
  }
  if (typeof color === "object") {
    if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
      rgb = rgbToRgb(color.r, color.g, color.b);
      ok2 = true;
      format2 = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
      s = convertToPercentage(color.s);
      v4 = convertToPercentage(color.v);
      rgb = hsvToRgb(color.h, s, v4);
      ok2 = true;
      format2 = "hsv";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
      s = convertToPercentage(color.s);
      l2 = convertToPercentage(color.l);
      rgb = hslToRgb(color.h, s, l2);
      ok2 = true;
      format2 = "hsl";
    }
    if (Object.prototype.hasOwnProperty.call(color, "a")) {
      a = color.a;
    }
  }
  a = boundAlpha(a);
  return {
    ok: ok2,
    format: color.format || format2,
    r: Math.min(255, Math.max(rgb.r, 0)),
    g: Math.min(255, Math.max(rgb.g, 0)),
    b: Math.min(255, Math.max(rgb.b, 0)),
    a
  };
}
var CSS_INTEGER = "[-\\+]?\\d+%?";
var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
  CSS_UNIT: new RegExp(CSS_UNIT),
  rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
  rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
  hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
  hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
  hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
  hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function stringInputToObject(color) {
  color = color.trim().toLowerCase();
  if (color.length === 0) {
    return false;
  }
  var named = false;
  if (names[color]) {
    color = names[color];
    named = true;
  } else if (color === "transparent") {
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  }
  var match = matchers.rgb.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3] };
  }
  match = matchers.rgba.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3], a: match[4] };
  }
  match = matchers.hsl.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3] };
  }
  match = matchers.hsla.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3], a: match[4] };
  }
  match = matchers.hsv.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3] };
  }
  match = matchers.hsva.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3], a: match[4] };
  }
  match = matchers.hex8.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      a: convertHexToDecimal(match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex6.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      format: named ? "name" : "hex"
    };
  }
  match = matchers.hex4.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      a: convertHexToDecimal(match[4] + match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex3.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      format: named ? "name" : "hex"
    };
  }
  return false;
}
function isValidCSSUnit(color) {
  return Boolean(matchers.CSS_UNIT.exec(String(color)));
}
var hueStep = 2;
var saturationStep = 0.16;
var saturationStep2 = 0.05;
var brightnessStep1 = 0.05;
var brightnessStep2 = 0.15;
var lightColorCount = 5;
var darkColorCount = 4;
var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function toHsv(_ref) {
  var r2 = _ref.r, g2 = _ref.g, b2 = _ref.b;
  var hsv = rgbToHsv(r2, g2, b2);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
}
function toHex(_ref2) {
  var r2 = _ref2.r, g2 = _ref2.g, b2 = _ref2.b;
  return "#".concat(rgbToHex(r2, g2, b2, false));
}
function mix$1(rgb1, rgb2, amount) {
  var p2 = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p2 + rgb1.r,
    g: (rgb2.g - rgb1.g) * p2 + rgb1.g,
    b: (rgb2.b - rgb1.b) * p2 + rgb1.b
  };
  return rgb;
}
function getHue(hsv, i, light2) {
  var hue;
  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light2 ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light2 ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }
  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }
  return hue;
}
function getSaturation(hsv, i, light2) {
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }
  var saturation;
  if (light2) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  }
  if (saturation > 1) {
    saturation = 1;
  }
  if (light2 && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }
  if (saturation < 0.06) {
    saturation = 0.06;
  }
  return Number(saturation.toFixed(2));
}
function getValue(hsv, i, light2) {
  var value;
  if (light2) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }
  if (value > 1) {
    value = 1;
  }
  return Number(value.toFixed(2));
}
function generate$1(color) {
  var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);
  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue(hsv, i, true)
    }));
    patterns.push(colorString);
  }
  patterns.push(toHex(pColor));
  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);
    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue(_hsv, _i)
    }));
    patterns.push(_colorString);
  }
  if (opts.theme === "dark") {
    return darkColorMap.map(function(_ref3) {
      var index2 = _ref3.index, opacity = _ref3.opacity;
      var darkColorString = toHex(mix$1(inputToRGB(opts.backgroundColor || "#141414"), inputToRGB(patterns[index2]), opacity * 100));
      return darkColorString;
    });
  }
  return patterns;
}
var presetPrimaryColors = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function(key) {
  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5];
  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
    theme: "dark",
    backgroundColor: "#141414"
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
presetPalettes.red;
presetPalettes.volcano;
presetPalettes.gold;
presetPalettes.orange;
presetPalettes.yellow;
presetPalettes.lime;
presetPalettes.green;
presetPalettes.cyan;
presetPalettes.blue;
presetPalettes.geekblue;
presetPalettes.purple;
presetPalettes.magenta;
presetPalettes.grey;
var MARK_KEY = "rc-util-key";
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, mark = _ref.mark;
  if (mark) {
    return mark.startsWith("data-") ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector("head");
  return head || document.body;
}
function injectCSS(css2) {
  var _option$csp;
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var styleNode = document.createElement("style");
  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;
    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }
  styleNode.innerHTML = css2;
  var container2 = getContainer(option);
  var firstChild = container2.firstChild;
  if (option.prepend && container2.prepend) {
    container2.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    container2.insertBefore(styleNode, firstChild);
  } else {
    container2.appendChild(styleNode);
  }
  return styleNode;
}
var containerCache = /* @__PURE__ */ new Map();
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var container2 = getContainer(option);
  return Array.from(containerCache.get(container2).children).find(function(node) {
    return node.tagName === "STYLE" && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css2, key) {
  var option = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var container2 = getContainer(option);
  if (!containerCache.has(container2)) {
    var placeholderStyle = injectCSS("", option);
    var parentNode2 = placeholderStyle.parentNode;
    containerCache.set(container2, parentNode2);
    parentNode2.removeChild(placeholderStyle);
  }
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp3, _option$csp4;
    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;
      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }
    if (existNode.innerHTML !== css2) {
      existNode.innerHTML = css2;
    }
    return existNode;
  }
  var newNode = injectCSS(css2, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}
function warning2(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof$1(target) === "object" && typeof target.name === "string" && typeof target.theme === "string" && (_typeof$1(target.icon) === "object" || typeof target.icon === "function");
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return Object.keys(attrs).reduce(function(acc, key) {
    var val = attrs[key];
    switch (key) {
      case "class":
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2$3({
      key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function(child, index2) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
    }));
  }
  return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2$3(_objectSpread2$3({
    key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function(child, index2) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
  }));
}
function getSecondaryColor(primaryColor) {
  return generate$1(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var svgBaseProps = {
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  focusable: "false"
};
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles2() {
  var styleStr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : iconStyles;
  var _useContext = useContext(Context$1), csp = _useContext.csp;
  useEffect(function() {
    updateCSS(styleStr, "@ant-design-icons", {
      prepend: true,
      csp
    });
  }, []);
};
var _excluded$h = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: "#333",
  secondaryColor: "#E6E6E6",
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor, secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2$3({}, twoToneColorPalette);
}
var IconBase = function IconBase2(props) {
  var icon = props.icon, className = props.className, onClick = props.onClick, style2 = props.style, primaryColor = props.primaryColor, secondaryColor = props.secondaryColor, restProps = _objectWithoutProperties$1(props, _excluded$h);
  var colors2 = twoToneColorPalette;
  if (primaryColor) {
    colors2 = {
      primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles();
  warning2(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === "function") {
    target = _objectSpread2$3(_objectSpread2$3({}, target), {}, {
      icon: target.icon(colors2.primaryColor, colors2.secondaryColor)
    });
  }
  return generate(target.icon, "svg-".concat(target.name), _objectSpread2$3({
    className,
    onClick,
    style: style2,
    "data-icon": target.name,
    width: "1em",
    height: "1em",
    fill: "currentColor",
    "aria-hidden": "true"
  }, restProps));
};
IconBase.displayName = "IconReact";
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
var ReactIcon = IconBase;
function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray$1(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return ReactIcon.setTwoToneColors({
    primaryColor,
    secondaryColor
  });
}
function getTwoToneColor() {
  var colors2 = ReactIcon.getTwoToneColors();
  if (!colors2.calculated) {
    return colors2.primaryColor;
  }
  return [colors2.primaryColor, colors2.secondaryColor];
}
var _excluded$g = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
setTwoToneColor("#1890ff");
var Icon$3 = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var _classNames;
  var className = props.className, icon = props.icon, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, twoToneColor = props.twoToneColor, restProps = _objectWithoutProperties$1(props, _excluded$g);
  var _React$useContext = React.useContext(Context$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty$3(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === "loading"), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray$1(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return /* @__PURE__ */ React.createElement("span", _objectSpread2$3(_objectSpread2$3({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref: ref2,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), /* @__PURE__ */ React.createElement(ReactIcon, {
    icon,
    primaryColor,
    secondaryColor,
    style: svgStyle
  }));
});
Icon$3.displayName = "AntdIcon";
Icon$3.getTwoToneColor = getTwoToneColor;
Icon$3.setTwoToneColor = setTwoToneColor;
var AntdIcon = Icon$3;
var LoadingOutlined = function LoadingOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: LoadingOutlinedSvg
  }));
};
LoadingOutlined.displayName = "LoadingOutlined";
var LoadingOutlined$1 = /* @__PURE__ */ React.forwardRef(LoadingOutlined);
var CloseOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" } }] }, "name": "close", "theme": "outlined" };
var CloseOutlinedSvg = CloseOutlined$2;
var CloseOutlined = function CloseOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: CloseOutlinedSvg
  }));
};
CloseOutlined.displayName = "CloseOutlined";
var CloseOutlined$1 = /* @__PURE__ */ React.forwardRef(CloseOutlined);
function addEventListenerWrap(target, eventType, cb2, option) {
  var callback = ReactDOM.unstable_batchedUpdates ? function run(e2) {
    ReactDOM.unstable_batchedUpdates(cb2, e2);
  } : cb2;
  if (target.addEventListener) {
    target.addEventListener(eventType, callback, option);
  }
  return {
    remove: function remove() {
      if (target.removeEventListener) {
        target.removeEventListener(eventType, callback);
      }
    }
  };
}
function useControlledState(defaultStateValue, option) {
  var _ref = option || {}, defaultValue = _ref.defaultValue, value = _ref.value, onChange3 = _ref.onChange, postState = _ref.postState;
  var _React$useState = React.useState(function() {
    if (value !== void 0) {
      return value;
    }
    if (defaultValue !== void 0) {
      return typeof defaultValue === "function" ? defaultValue() : defaultValue;
    }
    return typeof defaultStateValue === "function" ? defaultStateValue() : defaultStateValue;
  }), _React$useState2 = _slicedToArray$1(_React$useState, 2), innerValue = _React$useState2[0], setInnerValue = _React$useState2[1];
  var mergedValue = value !== void 0 ? value : innerValue;
  if (postState) {
    mergedValue = postState(mergedValue);
  }
  var onChangeRef = React.useRef(onChange3);
  onChangeRef.current = onChange3;
  var triggerChange = React.useCallback(function(newValue) {
    setInnerValue(newValue);
    if (mergedValue !== newValue && onChangeRef.current) {
      onChangeRef.current(newValue, mergedValue);
    }
  }, [mergedValue, onChangeRef]);
  var firstRenderRef = React.useRef(true);
  React.useEffect(function() {
    if (firstRenderRef.current) {
      firstRenderRef.current = false;
      return;
    }
    if (value === void 0) {
      setInnerValue(value);
    }
  }, [value]);
  return [mergedValue, triggerChange];
}
var KeyCode = {
  MAC_ENTER: 3,
  BACKSPACE: 8,
  TAB: 9,
  NUM_CENTER: 12,
  ENTER: 13,
  SHIFT: 16,
  CTRL: 17,
  ALT: 18,
  PAUSE: 19,
  CAPS_LOCK: 20,
  ESC: 27,
  SPACE: 32,
  PAGE_UP: 33,
  PAGE_DOWN: 34,
  END: 35,
  HOME: 36,
  LEFT: 37,
  UP: 38,
  RIGHT: 39,
  DOWN: 40,
  PRINT_SCREEN: 44,
  INSERT: 45,
  DELETE: 46,
  ZERO: 48,
  ONE: 49,
  TWO: 50,
  THREE: 51,
  FOUR: 52,
  FIVE: 53,
  SIX: 54,
  SEVEN: 55,
  EIGHT: 56,
  NINE: 57,
  QUESTION_MARK: 63,
  A: 65,
  B: 66,
  C: 67,
  D: 68,
  E: 69,
  F: 70,
  G: 71,
  H: 72,
  I: 73,
  J: 74,
  K: 75,
  L: 76,
  M: 77,
  N: 78,
  O: 79,
  P: 80,
  Q: 81,
  R: 82,
  S: 83,
  T: 84,
  U: 85,
  V: 86,
  W: 87,
  X: 88,
  Y: 89,
  Z: 90,
  META: 91,
  WIN_KEY_RIGHT: 92,
  CONTEXT_MENU: 93,
  NUM_ZERO: 96,
  NUM_ONE: 97,
  NUM_TWO: 98,
  NUM_THREE: 99,
  NUM_FOUR: 100,
  NUM_FIVE: 101,
  NUM_SIX: 102,
  NUM_SEVEN: 103,
  NUM_EIGHT: 104,
  NUM_NINE: 105,
  NUM_MULTIPLY: 106,
  NUM_PLUS: 107,
  NUM_MINUS: 109,
  NUM_PERIOD: 110,
  NUM_DIVISION: 111,
  F1: 112,
  F2: 113,
  F3: 114,
  F4: 115,
  F5: 116,
  F6: 117,
  F7: 118,
  F8: 119,
  F9: 120,
  F10: 121,
  F11: 122,
  F12: 123,
  NUMLOCK: 144,
  SEMICOLON: 186,
  DASH: 189,
  EQUALS: 187,
  COMMA: 188,
  PERIOD: 190,
  SLASH: 191,
  APOSTROPHE: 192,
  SINGLE_QUOTE: 222,
  OPEN_SQUARE_BRACKET: 219,
  BACKSLASH: 220,
  CLOSE_SQUARE_BRACKET: 221,
  WIN_KEY: 224,
  MAC_FF_META: 224,
  WIN_IME: 229,
  isTextModifyingKeyEvent: function isTextModifyingKeyEvent(e2) {
    var keyCode = e2.keyCode;
    if (e2.altKey && !e2.ctrlKey || e2.metaKey || keyCode >= KeyCode.F1 && keyCode <= KeyCode.F12) {
      return false;
    }
    switch (keyCode) {
      case KeyCode.ALT:
      case KeyCode.CAPS_LOCK:
      case KeyCode.CONTEXT_MENU:
      case KeyCode.CTRL:
      case KeyCode.DOWN:
      case KeyCode.END:
      case KeyCode.ESC:
      case KeyCode.HOME:
      case KeyCode.INSERT:
      case KeyCode.LEFT:
      case KeyCode.MAC_FF_META:
      case KeyCode.META:
      case KeyCode.NUMLOCK:
      case KeyCode.NUM_CENTER:
      case KeyCode.PAGE_DOWN:
      case KeyCode.PAGE_UP:
      case KeyCode.PAUSE:
      case KeyCode.PRINT_SCREEN:
      case KeyCode.RIGHT:
      case KeyCode.SHIFT:
      case KeyCode.UP:
      case KeyCode.WIN_KEY:
      case KeyCode.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  },
  isCharacterKey: function isCharacterKey(keyCode) {
    if (keyCode >= KeyCode.ZERO && keyCode <= KeyCode.NINE) {
      return true;
    }
    if (keyCode >= KeyCode.NUM_ZERO && keyCode <= KeyCode.NUM_MULTIPLY) {
      return true;
    }
    if (keyCode >= KeyCode.A && keyCode <= KeyCode.Z) {
      return true;
    }
    if (window.navigator.userAgent.indexOf("WebKit") !== -1 && keyCode === 0) {
      return true;
    }
    switch (keyCode) {
      case KeyCode.SPACE:
      case KeyCode.QUESTION_MARK:
      case KeyCode.NUM_PLUS:
      case KeyCode.NUM_MINUS:
      case KeyCode.NUM_PERIOD:
      case KeyCode.NUM_DIVISION:
      case KeyCode.SEMICOLON:
      case KeyCode.DASH:
      case KeyCode.EQUALS:
      case KeyCode.COMMA:
      case KeyCode.PERIOD:
      case KeyCode.SLASH:
      case KeyCode.APOSTROPHE:
      case KeyCode.SINGLE_QUOTE:
      case KeyCode.OPEN_SQUARE_BRACKET:
      case KeyCode.BACKSLASH:
      case KeyCode.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  }
};
var isMobile = function() {
  if (typeof navigator === "undefined" || typeof window === "undefined") {
    return false;
  }
  var agent = navigator.userAgent || navigator.vendor || window.opera;
  if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(agent) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(agent === null || agent === void 0 ? void 0 : agent.substr(0, 4))) {
    return true;
  }
  return false;
};
var useLayoutEffect = canUseDom() ? React.useLayoutEffect : React.useEffect;
function contains(root2, n2) {
  if (!root2) {
    return false;
  }
  return root2.contains(n2);
}
var Portal = /* @__PURE__ */ forwardRef(function(props, ref2) {
  var didUpdate = props.didUpdate, getContainer2 = props.getContainer, children = props.children;
  var containerRef = useRef();
  useImperativeHandle(ref2, function() {
    return {};
  });
  var initRef = useRef(false);
  if (!initRef.current && canUseDom()) {
    containerRef.current = getContainer2();
    initRef.current = true;
  }
  useEffect(function() {
    didUpdate === null || didUpdate === void 0 ? void 0 : didUpdate(props);
  });
  useEffect(function() {
    return function() {
      var _containerRef$current, _containerRef$current2;
      (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : (_containerRef$current2 = _containerRef$current.parentNode) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.removeChild(containerRef.current);
    };
  }, []);
  return containerRef.current ? /* @__PURE__ */ ReactDOM.createPortal(children, containerRef.current) : null;
});
function isPointsEq(a1, a2, isAlignPoint) {
  if (isAlignPoint) {
    return a1[0] === a2[0];
  }
  return a1[0] === a2[0] && a1[1] === a2[1];
}
function getAlignFromPlacement(builtinPlacements, placementStr, align) {
  var baseAlign = builtinPlacements[placementStr] || {};
  return _objectSpread2$3(_objectSpread2$3({}, baseAlign), align);
}
function getAlignPopupClassName(builtinPlacements, prefixCls, align, isAlignPoint) {
  var points2 = align.points;
  var placements2 = Object.keys(builtinPlacements);
  for (var i = 0; i < placements2.length; i += 1) {
    var placement = placements2[i];
    if (isPointsEq(builtinPlacements[placement].points, points2, isAlignPoint)) {
      return "".concat(prefixCls, "-placement-").concat(placement);
    }
  }
  return "";
}
function getMotion$1(_ref) {
  var prefixCls = _ref.prefixCls, motion = _ref.motion, animation = _ref.animation, transitionName = _ref.transitionName;
  if (motion) {
    return motion;
  }
  if (animation) {
    return {
      motionName: "".concat(prefixCls, "-").concat(animation)
    };
  }
  if (transitionName) {
    return {
      motionName: transitionName
    };
  }
  return null;
}
function Mask(props) {
  var prefixCls = props.prefixCls, visible = props.visible, zIndex = props.zIndex, mask = props.mask, maskMotion = props.maskMotion, maskAnimation = props.maskAnimation, maskTransitionName = props.maskTransitionName;
  if (!mask) {
    return null;
  }
  var motion = {};
  if (maskMotion || maskTransitionName || maskAnimation) {
    motion = _objectSpread2$3({
      motionAppear: true
    }, getMotion$1({
      motion: maskMotion,
      prefixCls,
      transitionName: maskTransitionName,
      animation: maskAnimation
    }));
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({}, motion, {
    visible,
    removeOnLeave: true
  }), function(_ref) {
    var className = _ref.className;
    return /* @__PURE__ */ React.createElement("div", {
      style: {
        zIndex
      },
      className: classNames("".concat(prefixCls, "-mask"), className)
    });
  });
}
var isVisible = function(element) {
  if (!element) {
    return false;
  }
  if (element.offsetParent) {
    return true;
  }
  if (element.getBBox) {
    var box2 = element.getBBox();
    if (box2.width || box2.height) {
      return true;
    }
  }
  if (element.getBoundingClientRect) {
    var _box = element.getBoundingClientRect();
    if (_box.width || _box.height) {
      return true;
    }
  }
  return false;
};
function ownKeys$2(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    if (enumerableOnly) {
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
      });
    }
    keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2$2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys$2(Object(source), true).forEach(function(key) {
        _defineProperty$2(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys$2(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
function _typeof(obj) {
  "@babel/helpers - typeof";
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function(obj2) {
      return typeof obj2;
    };
  } else {
    _typeof = function(obj2) {
      return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    };
  }
  return _typeof(obj);
}
function _defineProperty$2(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
var vendorPrefix;
var jsCssMap = {
  Webkit: "-webkit-",
  Moz: "-moz-",
  ms: "-ms-",
  O: "-o-"
};
function getVendorPrefix() {
  if (vendorPrefix !== void 0) {
    return vendorPrefix;
  }
  vendorPrefix = "";
  var style2 = document.createElement("p").style;
  var testProp = "Transform";
  for (var key in jsCssMap) {
    if (key + testProp in style2) {
      vendorPrefix = key;
    }
  }
  return vendorPrefix;
}
function getTransitionName() {
  return getVendorPrefix() ? "".concat(getVendorPrefix(), "TransitionProperty") : "transitionProperty";
}
function getTransformName() {
  return getVendorPrefix() ? "".concat(getVendorPrefix(), "Transform") : "transform";
}
function setTransitionProperty(node, value) {
  var name2 = getTransitionName();
  if (name2) {
    node.style[name2] = value;
    if (name2 !== "transitionProperty") {
      node.style.transitionProperty = value;
    }
  }
}
function setTransform(node, value) {
  var name2 = getTransformName();
  if (name2) {
    node.style[name2] = value;
    if (name2 !== "transform") {
      node.style.transform = value;
    }
  }
}
function getTransitionProperty(node) {
  return node.style.transitionProperty || node.style[getTransitionName()];
}
function getTransformXY(node) {
  var style2 = window.getComputedStyle(node, null);
  var transform2 = style2.getPropertyValue("transform") || style2.getPropertyValue(getTransformName());
  if (transform2 && transform2 !== "none") {
    var matrix = transform2.replace(/[^0-9\-.,]/g, "").split(",");
    return {
      x: parseFloat(matrix[12] || matrix[4], 0),
      y: parseFloat(matrix[13] || matrix[5], 0)
    };
  }
  return {
    x: 0,
    y: 0
  };
}
var matrix2d = /matrix\((.*)\)/;
var matrix3d = /matrix3d\((.*)\)/;
function setTransformXY(node, xy) {
  var style2 = window.getComputedStyle(node, null);
  var transform2 = style2.getPropertyValue("transform") || style2.getPropertyValue(getTransformName());
  if (transform2 && transform2 !== "none") {
    var arr;
    var match2d = transform2.match(matrix2d);
    if (match2d) {
      match2d = match2d[1];
      arr = match2d.split(",").map(function(item) {
        return parseFloat(item, 10);
      });
      arr[4] = xy.x;
      arr[5] = xy.y;
      setTransform(node, "matrix(".concat(arr.join(","), ")"));
    } else {
      var match3d = transform2.match(matrix3d)[1];
      arr = match3d.split(",").map(function(item) {
        return parseFloat(item, 10);
      });
      arr[12] = xy.x;
      arr[13] = xy.y;
      setTransform(node, "matrix3d(".concat(arr.join(","), ")"));
    }
  } else {
    setTransform(node, "translateX(".concat(xy.x, "px) translateY(").concat(xy.y, "px) translateZ(0)"));
  }
}
var RE_NUM = /[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source;
var getComputedStyleX;
function forceRelayout(elem) {
  var originalStyle = elem.style.display;
  elem.style.display = "none";
  elem.offsetHeight;
  elem.style.display = originalStyle;
}
function css(el, name2, v4) {
  var value = v4;
  if (_typeof(name2) === "object") {
    for (var i in name2) {
      if (name2.hasOwnProperty(i)) {
        css(el, i, name2[i]);
      }
    }
    return void 0;
  }
  if (typeof value !== "undefined") {
    if (typeof value === "number") {
      value = "".concat(value, "px");
    }
    el.style[name2] = value;
    return void 0;
  }
  return getComputedStyleX(el, name2);
}
function getClientPosition(elem) {
  var box2;
  var x2;
  var y2;
  var doc = elem.ownerDocument;
  var body = doc.body;
  var docElem = doc && doc.documentElement;
  box2 = elem.getBoundingClientRect();
  x2 = box2.left;
  y2 = box2.top;
  x2 -= docElem.clientLeft || body.clientLeft || 0;
  y2 -= docElem.clientTop || body.clientTop || 0;
  return {
    left: x2,
    top: y2
  };
}
function getScroll(w2, top) {
  var ret = w2["page".concat(top ? "Y" : "X", "Offset")];
  var method4 = "scroll".concat(top ? "Top" : "Left");
  if (typeof ret !== "number") {
    var d2 = w2.document;
    ret = d2.documentElement[method4];
    if (typeof ret !== "number") {
      ret = d2.body[method4];
    }
  }
  return ret;
}
function getScrollLeft(w2) {
  return getScroll(w2);
}
function getScrollTop(w2) {
  return getScroll(w2, true);
}
function getOffset$1(el) {
  var pos = getClientPosition(el);
  var doc = el.ownerDocument;
  var w2 = doc.defaultView || doc.parentWindow;
  pos.left += getScrollLeft(w2);
  pos.top += getScrollTop(w2);
  return pos;
}
function isWindow(obj) {
  return obj !== null && obj !== void 0 && obj == obj.window;
}
function getDocument(node) {
  if (isWindow(node)) {
    return node.document;
  }
  if (node.nodeType === 9) {
    return node;
  }
  return node.ownerDocument;
}
function _getComputedStyle(elem, name2, cs) {
  var computedStyle = cs;
  var val = "";
  var d2 = getDocument(elem);
  computedStyle = computedStyle || d2.defaultView.getComputedStyle(elem, null);
  if (computedStyle) {
    val = computedStyle.getPropertyValue(name2) || computedStyle[name2];
  }
  return val;
}
var _RE_NUM_NO_PX = new RegExp("^(".concat(RE_NUM, ")(?!px)[a-z%]+$"), "i");
var RE_POS = /^(top|right|bottom|left)$/;
var CURRENT_STYLE = "currentStyle";
var RUNTIME_STYLE = "runtimeStyle";
var LEFT$1 = "left";
var PX = "px";
function _getComputedStyleIE(elem, name2) {
  var ret = elem[CURRENT_STYLE] && elem[CURRENT_STYLE][name2];
  if (_RE_NUM_NO_PX.test(ret) && !RE_POS.test(name2)) {
    var style2 = elem.style;
    var left = style2[LEFT$1];
    var rsLeft = elem[RUNTIME_STYLE][LEFT$1];
    elem[RUNTIME_STYLE][LEFT$1] = elem[CURRENT_STYLE][LEFT$1];
    style2[LEFT$1] = name2 === "fontSize" ? "1em" : ret || 0;
    ret = style2.pixelLeft + PX;
    style2[LEFT$1] = left;
    elem[RUNTIME_STYLE][LEFT$1] = rsLeft;
  }
  return ret === "" ? "auto" : ret;
}
if (typeof window !== "undefined") {
  getComputedStyleX = window.getComputedStyle ? _getComputedStyle : _getComputedStyleIE;
}
function getOffsetDirection(dir3, option) {
  if (dir3 === "left") {
    return option.useCssRight ? "right" : dir3;
  }
  return option.useCssBottom ? "bottom" : dir3;
}
function oppositeOffsetDirection(dir3) {
  if (dir3 === "left") {
    return "right";
  } else if (dir3 === "right") {
    return "left";
  } else if (dir3 === "top") {
    return "bottom";
  } else if (dir3 === "bottom") {
    return "top";
  }
}
function setLeftTop(elem, offset3, option) {
  if (css(elem, "position") === "static") {
    elem.style.position = "relative";
  }
  var presetH = -999;
  var presetV = -999;
  var horizontalProperty = getOffsetDirection("left", option);
  var verticalProperty = getOffsetDirection("top", option);
  var oppositeHorizontalProperty = oppositeOffsetDirection(horizontalProperty);
  var oppositeVerticalProperty = oppositeOffsetDirection(verticalProperty);
  if (horizontalProperty !== "left") {
    presetH = 999;
  }
  if (verticalProperty !== "top") {
    presetV = 999;
  }
  var originalTransition = "";
  var originalOffset = getOffset$1(elem);
  if ("left" in offset3 || "top" in offset3) {
    originalTransition = getTransitionProperty(elem) || "";
    setTransitionProperty(elem, "none");
  }
  if ("left" in offset3) {
    elem.style[oppositeHorizontalProperty] = "";
    elem.style[horizontalProperty] = "".concat(presetH, "px");
  }
  if ("top" in offset3) {
    elem.style[oppositeVerticalProperty] = "";
    elem.style[verticalProperty] = "".concat(presetV, "px");
  }
  forceRelayout(elem);
  var old = getOffset$1(elem);
  var originalStyle = {};
  for (var key in offset3) {
    if (offset3.hasOwnProperty(key)) {
      var dir3 = getOffsetDirection(key, option);
      var preset = key === "left" ? presetH : presetV;
      var off = originalOffset[key] - old[key];
      if (dir3 === key) {
        originalStyle[dir3] = preset + off;
      } else {
        originalStyle[dir3] = preset - off;
      }
    }
  }
  css(elem, originalStyle);
  forceRelayout(elem);
  if ("left" in offset3 || "top" in offset3) {
    setTransitionProperty(elem, originalTransition);
  }
  var ret = {};
  for (var _key in offset3) {
    if (offset3.hasOwnProperty(_key)) {
      var _dir = getOffsetDirection(_key, option);
      var _off = offset3[_key] - originalOffset[_key];
      if (_key === _dir) {
        ret[_dir] = originalStyle[_dir] + _off;
      } else {
        ret[_dir] = originalStyle[_dir] - _off;
      }
    }
  }
  css(elem, ret);
}
function setTransform$1(elem, offset3) {
  var originalOffset = getOffset$1(elem);
  var originalXY = getTransformXY(elem);
  var resultXY = {
    x: originalXY.x,
    y: originalXY.y
  };
  if ("left" in offset3) {
    resultXY.x = originalXY.x + offset3.left - originalOffset.left;
  }
  if ("top" in offset3) {
    resultXY.y = originalXY.y + offset3.top - originalOffset.top;
  }
  setTransformXY(elem, resultXY);
}
function setOffset(elem, offset3, option) {
  if (option.ignoreShake) {
    var oriOffset = getOffset$1(elem);
    var oLeft = oriOffset.left.toFixed(0);
    var oTop = oriOffset.top.toFixed(0);
    var tLeft = offset3.left.toFixed(0);
    var tTop = offset3.top.toFixed(0);
    if (oLeft === tLeft && oTop === tTop) {
      return;
    }
  }
  if (option.useCssRight || option.useCssBottom) {
    setLeftTop(elem, offset3, option);
  } else if (option.useCssTransform && getTransformName() in document.body.style) {
    setTransform$1(elem, offset3);
  } else {
    setLeftTop(elem, offset3, option);
  }
}
function each(arr, fn) {
  for (var i = 0; i < arr.length; i++) {
    fn(arr[i]);
  }
}
function isBorderBoxFn(elem) {
  return getComputedStyleX(elem, "boxSizing") === "border-box";
}
var BOX_MODELS = ["margin", "border", "padding"];
var CONTENT_INDEX = -1;
var PADDING_INDEX = 2;
var BORDER_INDEX = 1;
var MARGIN_INDEX = 0;
function swap(elem, options, callback) {
  var old = {};
  var style2 = elem.style;
  var name2;
  for (name2 in options) {
    if (options.hasOwnProperty(name2)) {
      old[name2] = style2[name2];
      style2[name2] = options[name2];
    }
  }
  callback.call(elem);
  for (name2 in options) {
    if (options.hasOwnProperty(name2)) {
      style2[name2] = old[name2];
    }
  }
}
function getPBMWidth(elem, props, which) {
  var value = 0;
  var prop;
  var j;
  var i;
  for (j = 0; j < props.length; j++) {
    prop = props[j];
    if (prop) {
      for (i = 0; i < which.length; i++) {
        var cssProp = void 0;
        if (prop === "border") {
          cssProp = "".concat(prop).concat(which[i], "Width");
        } else {
          cssProp = prop + which[i];
        }
        value += parseFloat(getComputedStyleX(elem, cssProp)) || 0;
      }
    }
  }
  return value;
}
var domUtils = {
  getParent: function getParent(element) {
    var parent = element;
    do {
      if (parent.nodeType === 11 && parent.host) {
        parent = parent.host;
      } else {
        parent = parent.parentNode;
      }
    } while (parent && parent.nodeType !== 1 && parent.nodeType !== 9);
    return parent;
  }
};
each(["Width", "Height"], function(name2) {
  domUtils["doc".concat(name2)] = function(refWin) {
    var d2 = refWin.document;
    return Math.max(d2.documentElement["scroll".concat(name2)], d2.body["scroll".concat(name2)], domUtils["viewport".concat(name2)](d2));
  };
  domUtils["viewport".concat(name2)] = function(win) {
    var prop = "client".concat(name2);
    var doc = win.document;
    var body = doc.body;
    var documentElement = doc.documentElement;
    var documentElementProp = documentElement[prop];
    return doc.compatMode === "CSS1Compat" && documentElementProp || body && body[prop] || documentElementProp;
  };
});
function getWH(elem, name2, ex) {
  var extra = ex;
  if (isWindow(elem)) {
    return name2 === "width" ? domUtils.viewportWidth(elem) : domUtils.viewportHeight(elem);
  } else if (elem.nodeType === 9) {
    return name2 === "width" ? domUtils.docWidth(elem) : domUtils.docHeight(elem);
  }
  var which = name2 === "width" ? ["Left", "Right"] : ["Top", "Bottom"];
  var borderBoxValue = name2 === "width" ? elem.getBoundingClientRect().width : elem.getBoundingClientRect().height;
  var isBorderBox = isBorderBoxFn(elem);
  var cssBoxValue = 0;
  if (borderBoxValue === null || borderBoxValue === void 0 || borderBoxValue <= 0) {
    borderBoxValue = void 0;
    cssBoxValue = getComputedStyleX(elem, name2);
    if (cssBoxValue === null || cssBoxValue === void 0 || Number(cssBoxValue) < 0) {
      cssBoxValue = elem.style[name2] || 0;
    }
    cssBoxValue = parseFloat(cssBoxValue) || 0;
  }
  if (extra === void 0) {
    extra = isBorderBox ? BORDER_INDEX : CONTENT_INDEX;
  }
  var borderBoxValueOrIsBorderBox = borderBoxValue !== void 0 || isBorderBox;
  var val = borderBoxValue || cssBoxValue;
  if (extra === CONTENT_INDEX) {
    if (borderBoxValueOrIsBorderBox) {
      return val - getPBMWidth(elem, ["border", "padding"], which);
    }
    return cssBoxValue;
  } else if (borderBoxValueOrIsBorderBox) {
    if (extra === BORDER_INDEX) {
      return val;
    }
    return val + (extra === PADDING_INDEX ? -getPBMWidth(elem, ["border"], which) : getPBMWidth(elem, ["margin"], which));
  }
  return cssBoxValue + getPBMWidth(elem, BOX_MODELS.slice(extra), which);
}
var cssShow = {
  position: "absolute",
  visibility: "hidden",
  display: "block"
};
function getWHIgnoreDisplay() {
  for (var _len = arguments.length, args = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
    args[_key2] = arguments[_key2];
  }
  var val;
  var elem = args[0];
  if (elem.offsetWidth !== 0) {
    val = getWH.apply(void 0, args);
  } else {
    swap(elem, cssShow, function() {
      val = getWH.apply(void 0, args);
    });
  }
  return val;
}
each(["width", "height"], function(name2) {
  var first = name2.charAt(0).toUpperCase() + name2.slice(1);
  domUtils["outer".concat(first)] = function(el, includeMargin) {
    return el && getWHIgnoreDisplay(el, name2, includeMargin ? MARGIN_INDEX : BORDER_INDEX);
  };
  var which = name2 === "width" ? ["Left", "Right"] : ["Top", "Bottom"];
  domUtils[name2] = function(elem, v4) {
    var val = v4;
    if (val !== void 0) {
      if (elem) {
        var isBorderBox = isBorderBoxFn(elem);
        if (isBorderBox) {
          val += getPBMWidth(elem, ["padding", "border"], which);
        }
        return css(elem, name2, val);
      }
      return void 0;
    }
    return elem && getWHIgnoreDisplay(elem, name2, CONTENT_INDEX);
  };
});
function mix(to, from2) {
  for (var i in from2) {
    if (from2.hasOwnProperty(i)) {
      to[i] = from2[i];
    }
  }
  return to;
}
var utils = {
  getWindow: function getWindow(node) {
    if (node && node.document && node.setTimeout) {
      return node;
    }
    var doc = node.ownerDocument || node;
    return doc.defaultView || doc.parentWindow;
  },
  getDocument,
  offset: function offset2(el, value, option) {
    if (typeof value !== "undefined") {
      setOffset(el, value, option || {});
    } else {
      return getOffset$1(el);
    }
  },
  isWindow,
  each,
  css,
  clone: function clone2(obj) {
    var i;
    var ret = {};
    for (i in obj) {
      if (obj.hasOwnProperty(i)) {
        ret[i] = obj[i];
      }
    }
    var overflow = obj.overflow;
    if (overflow) {
      for (i in obj) {
        if (obj.hasOwnProperty(i)) {
          ret.overflow[i] = obj.overflow[i];
        }
      }
    }
    return ret;
  },
  mix,
  getWindowScrollLeft: function getWindowScrollLeft(w2) {
    return getScrollLeft(w2);
  },
  getWindowScrollTop: function getWindowScrollTop(w2) {
    return getScrollTop(w2);
  },
  merge: function merge() {
    var ret = {};
    for (var i = 0; i < arguments.length; i++) {
      utils.mix(ret, i < 0 || arguments.length <= i ? void 0 : arguments[i]);
    }
    return ret;
  },
  viewportWidth: 0,
  viewportHeight: 0
};
mix(utils, domUtils);
var getParent$1 = utils.getParent;
function getOffsetParent(element) {
  if (utils.isWindow(element) || element.nodeType === 9) {
    return null;
  }
  var doc = utils.getDocument(element);
  var body = doc.body;
  var parent;
  var positionStyle = utils.css(element, "position");
  var skipStatic = positionStyle === "fixed" || positionStyle === "absolute";
  if (!skipStatic) {
    return element.nodeName.toLowerCase() === "html" ? null : getParent$1(element);
  }
  for (parent = getParent$1(element); parent && parent !== body && parent.nodeType !== 9; parent = getParent$1(parent)) {
    positionStyle = utils.css(parent, "position");
    if (positionStyle !== "static") {
      return parent;
    }
  }
  return null;
}
var getParent$1$1 = utils.getParent;
function isAncestorFixed(element) {
  if (utils.isWindow(element) || element.nodeType === 9) {
    return false;
  }
  var doc = utils.getDocument(element);
  var body = doc.body;
  var parent = null;
  for (parent = getParent$1$1(element); parent && parent !== body && parent !== doc; parent = getParent$1$1(parent)) {
    var positionStyle = utils.css(parent, "position");
    if (positionStyle === "fixed") {
      return true;
    }
  }
  return false;
}
function getVisibleRectForElement(element, alwaysByViewport) {
  var visibleRect = {
    left: 0,
    right: Infinity,
    top: 0,
    bottom: Infinity
  };
  var el = getOffsetParent(element);
  var doc = utils.getDocument(element);
  var win = doc.defaultView || doc.parentWindow;
  var body = doc.body;
  var documentElement = doc.documentElement;
  while (el) {
    if ((navigator.userAgent.indexOf("MSIE") === -1 || el.clientWidth !== 0) && el !== body && el !== documentElement && utils.css(el, "overflow") !== "visible") {
      var pos = utils.offset(el);
      pos.left += el.clientLeft;
      pos.top += el.clientTop;
      visibleRect.top = Math.max(visibleRect.top, pos.top);
      visibleRect.right = Math.min(visibleRect.right, pos.left + el.clientWidth);
      visibleRect.bottom = Math.min(visibleRect.bottom, pos.top + el.clientHeight);
      visibleRect.left = Math.max(visibleRect.left, pos.left);
    } else if (el === body || el === documentElement) {
      break;
    }
    el = getOffsetParent(el);
  }
  var originalPosition = null;
  if (!utils.isWindow(element) && element.nodeType !== 9) {
    originalPosition = element.style.position;
    var position2 = utils.css(element, "position");
    if (position2 === "absolute") {
      element.style.position = "fixed";
    }
  }
  var scrollX = utils.getWindowScrollLeft(win);
  var scrollY = utils.getWindowScrollTop(win);
  var viewportWidth = utils.viewportWidth(win);
  var viewportHeight = utils.viewportHeight(win);
  var documentWidth = documentElement.scrollWidth;
  var documentHeight = documentElement.scrollHeight;
  var bodyStyle = window.getComputedStyle(body);
  if (bodyStyle.overflowX === "hidden") {
    documentWidth = win.innerWidth;
  }
  if (bodyStyle.overflowY === "hidden") {
    documentHeight = win.innerHeight;
  }
  if (element.style) {
    element.style.position = originalPosition;
  }
  if (alwaysByViewport || isAncestorFixed(element)) {
    visibleRect.left = Math.max(visibleRect.left, scrollX);
    visibleRect.top = Math.max(visibleRect.top, scrollY);
    visibleRect.right = Math.min(visibleRect.right, scrollX + viewportWidth);
    visibleRect.bottom = Math.min(visibleRect.bottom, scrollY + viewportHeight);
  } else {
    var maxVisibleWidth = Math.max(documentWidth, scrollX + viewportWidth);
    visibleRect.right = Math.min(visibleRect.right, maxVisibleWidth);
    var maxVisibleHeight = Math.max(documentHeight, scrollY + viewportHeight);
    visibleRect.bottom = Math.min(visibleRect.bottom, maxVisibleHeight);
  }
  return visibleRect.top >= 0 && visibleRect.left >= 0 && visibleRect.bottom > visibleRect.top && visibleRect.right > visibleRect.left ? visibleRect : null;
}
function adjustForViewport(elFuturePos, elRegion, visibleRect, overflow) {
  var pos = utils.clone(elFuturePos);
  var size = {
    width: elRegion.width,
    height: elRegion.height
  };
  if (overflow.adjustX && pos.left < visibleRect.left) {
    pos.left = visibleRect.left;
  }
  if (overflow.resizeWidth && pos.left >= visibleRect.left && pos.left + size.width > visibleRect.right) {
    size.width -= pos.left + size.width - visibleRect.right;
  }
  if (overflow.adjustX && pos.left + size.width > visibleRect.right) {
    pos.left = Math.max(visibleRect.right - size.width, visibleRect.left);
  }
  if (overflow.adjustY && pos.top < visibleRect.top) {
    pos.top = visibleRect.top;
  }
  if (overflow.resizeHeight && pos.top >= visibleRect.top && pos.top + size.height > visibleRect.bottom) {
    size.height -= pos.top + size.height - visibleRect.bottom;
  }
  if (overflow.adjustY && pos.top + size.height > visibleRect.bottom) {
    pos.top = Math.max(visibleRect.bottom - size.height, visibleRect.top);
  }
  return utils.mix(pos, size);
}
function getRegion(node) {
  var offset3;
  var w2;
  var h;
  if (!utils.isWindow(node) && node.nodeType !== 9) {
    offset3 = utils.offset(node);
    w2 = utils.outerWidth(node);
    h = utils.outerHeight(node);
  } else {
    var win = utils.getWindow(node);
    offset3 = {
      left: utils.getWindowScrollLeft(win),
      top: utils.getWindowScrollTop(win)
    };
    w2 = utils.viewportWidth(win);
    h = utils.viewportHeight(win);
  }
  offset3.width = w2;
  offset3.height = h;
  return offset3;
}
function getAlignOffset(region, align) {
  var V2 = align.charAt(0);
  var H2 = align.charAt(1);
  var w2 = region.width;
  var h = region.height;
  var x2 = region.left;
  var y2 = region.top;
  if (V2 === "c") {
    y2 += h / 2;
  } else if (V2 === "b") {
    y2 += h;
  }
  if (H2 === "c") {
    x2 += w2 / 2;
  } else if (H2 === "r") {
    x2 += w2;
  }
  return {
    left: x2,
    top: y2
  };
}
function getElFuturePos(elRegion, refNodeRegion, points2, offset3, targetOffset2) {
  var p1 = getAlignOffset(refNodeRegion, points2[1]);
  var p2 = getAlignOffset(elRegion, points2[0]);
  var diff = [p2.left - p1.left, p2.top - p1.top];
  return {
    left: Math.round(elRegion.left - diff[0] + offset3[0] - targetOffset2[0]),
    top: Math.round(elRegion.top - diff[1] + offset3[1] - targetOffset2[1])
  };
}
function isFailX(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.left < visibleRect.left || elFuturePos.left + elRegion.width > visibleRect.right;
}
function isFailY(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.top < visibleRect.top || elFuturePos.top + elRegion.height > visibleRect.bottom;
}
function isCompleteFailX(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.left > visibleRect.right || elFuturePos.left + elRegion.width < visibleRect.left;
}
function isCompleteFailY(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.top > visibleRect.bottom || elFuturePos.top + elRegion.height < visibleRect.top;
}
function flip(points2, reg, map2) {
  var ret = [];
  utils.each(points2, function(p2) {
    ret.push(p2.replace(reg, function(m2) {
      return map2[m2];
    }));
  });
  return ret;
}
function flipOffset(offset3, index2) {
  offset3[index2] = -offset3[index2];
  return offset3;
}
function convertOffset(str, offsetLen) {
  var n2;
  if (/%$/.test(str)) {
    n2 = parseInt(str.substring(0, str.length - 1), 10) / 100 * offsetLen;
  } else {
    n2 = parseInt(str, 10);
  }
  return n2 || 0;
}
function normalizeOffset(offset3, el) {
  offset3[0] = convertOffset(offset3[0], el.width);
  offset3[1] = convertOffset(offset3[1], el.height);
}
function doAlign(el, tgtRegion, align, isTgtRegionVisible) {
  var points2 = align.points;
  var offset3 = align.offset || [0, 0];
  var targetOffset2 = align.targetOffset || [0, 0];
  var overflow = align.overflow;
  var source = align.source || el;
  offset3 = [].concat(offset3);
  targetOffset2 = [].concat(targetOffset2);
  overflow = overflow || {};
  var newOverflowCfg = {};
  var fail = 0;
  var alwaysByViewport = !!(overflow && overflow.alwaysByViewport);
  var visibleRect = getVisibleRectForElement(source, alwaysByViewport);
  var elRegion = getRegion(source);
  normalizeOffset(offset3, elRegion);
  normalizeOffset(targetOffset2, tgtRegion);
  var elFuturePos = getElFuturePos(elRegion, tgtRegion, points2, offset3, targetOffset2);
  var newElRegion = utils.merge(elRegion, elFuturePos);
  if (visibleRect && (overflow.adjustX || overflow.adjustY) && isTgtRegionVisible) {
    if (overflow.adjustX) {
      if (isFailX(elFuturePos, elRegion, visibleRect)) {
        var newPoints = flip(points2, /[lr]/gi, {
          l: "r",
          r: "l"
        });
        var newOffset = flipOffset(offset3, 0);
        var newTargetOffset = flipOffset(targetOffset2, 0);
        var newElFuturePos = getElFuturePos(elRegion, tgtRegion, newPoints, newOffset, newTargetOffset);
        if (!isCompleteFailX(newElFuturePos, elRegion, visibleRect)) {
          fail = 1;
          points2 = newPoints;
          offset3 = newOffset;
          targetOffset2 = newTargetOffset;
        }
      }
    }
    if (overflow.adjustY) {
      if (isFailY(elFuturePos, elRegion, visibleRect)) {
        var _newPoints = flip(points2, /[tb]/gi, {
          t: "b",
          b: "t"
        });
        var _newOffset = flipOffset(offset3, 1);
        var _newTargetOffset = flipOffset(targetOffset2, 1);
        var _newElFuturePos = getElFuturePos(elRegion, tgtRegion, _newPoints, _newOffset, _newTargetOffset);
        if (!isCompleteFailY(_newElFuturePos, elRegion, visibleRect)) {
          fail = 1;
          points2 = _newPoints;
          offset3 = _newOffset;
          targetOffset2 = _newTargetOffset;
        }
      }
    }
    if (fail) {
      elFuturePos = getElFuturePos(elRegion, tgtRegion, points2, offset3, targetOffset2);
      utils.mix(newElRegion, elFuturePos);
    }
    var isStillFailX = isFailX(elFuturePos, elRegion, visibleRect);
    var isStillFailY = isFailY(elFuturePos, elRegion, visibleRect);
    if (isStillFailX || isStillFailY) {
      var _newPoints2 = points2;
      if (isStillFailX) {
        _newPoints2 = flip(points2, /[lr]/gi, {
          l: "r",
          r: "l"
        });
      }
      if (isStillFailY) {
        _newPoints2 = flip(points2, /[tb]/gi, {
          t: "b",
          b: "t"
        });
      }
      points2 = _newPoints2;
      offset3 = align.offset || [0, 0];
      targetOffset2 = align.targetOffset || [0, 0];
    }
    newOverflowCfg.adjustX = overflow.adjustX && isStillFailX;
    newOverflowCfg.adjustY = overflow.adjustY && isStillFailY;
    if (newOverflowCfg.adjustX || newOverflowCfg.adjustY) {
      newElRegion = adjustForViewport(elFuturePos, elRegion, visibleRect, newOverflowCfg);
    }
  }
  if (newElRegion.width !== elRegion.width) {
    utils.css(source, "width", utils.width(source) + newElRegion.width - elRegion.width);
  }
  if (newElRegion.height !== elRegion.height) {
    utils.css(source, "height", utils.height(source) + newElRegion.height - elRegion.height);
  }
  utils.offset(source, {
    left: newElRegion.left,
    top: newElRegion.top
  }, {
    useCssRight: align.useCssRight,
    useCssBottom: align.useCssBottom,
    useCssTransform: align.useCssTransform,
    ignoreShake: align.ignoreShake
  });
  return {
    points: points2,
    offset: offset3,
    targetOffset: targetOffset2,
    overflow: newOverflowCfg
  };
}
function isOutOfVisibleRect(target, alwaysByViewport) {
  var visibleRect = getVisibleRectForElement(target, alwaysByViewport);
  var targetRegion = getRegion(target);
  return !visibleRect || targetRegion.left + targetRegion.width <= visibleRect.left || targetRegion.top + targetRegion.height <= visibleRect.top || targetRegion.left >= visibleRect.right || targetRegion.top >= visibleRect.bottom;
}
function alignElement(el, refNode, align) {
  var target = align.target || refNode;
  var refNodeRegion = getRegion(target);
  var isTargetNotOutOfVisible = !isOutOfVisibleRect(target, align.overflow && align.overflow.alwaysByViewport);
  return doAlign(el, refNodeRegion, align, isTargetNotOutOfVisible);
}
alignElement.__getOffsetParent = getOffsetParent;
alignElement.__getVisibleRectForElement = getVisibleRectForElement;
function alignPoint(el, tgtPoint, align) {
  var pageX;
  var pageY;
  var doc = utils.getDocument(el);
  var win = doc.defaultView || doc.parentWindow;
  var scrollX = utils.getWindowScrollLeft(win);
  var scrollY = utils.getWindowScrollTop(win);
  var viewportWidth = utils.viewportWidth(win);
  var viewportHeight = utils.viewportHeight(win);
  if ("pageX" in tgtPoint) {
    pageX = tgtPoint.pageX;
  } else {
    pageX = scrollX + tgtPoint.clientX;
  }
  if ("pageY" in tgtPoint) {
    pageY = tgtPoint.pageY;
  } else {
    pageY = scrollY + tgtPoint.clientY;
  }
  var tgtRegion = {
    left: pageX,
    top: pageY,
    width: 0,
    height: 0
  };
  var pointInView = pageX >= 0 && pageX <= scrollX + viewportWidth && pageY >= 0 && pageY <= scrollY + viewportHeight;
  var points2 = [align.points[0], "cc"];
  return doAlign(el, tgtRegion, _objectSpread2$2(_objectSpread2$2({}, align), {}, {
    points: points2
  }), pointInView);
}
function isSamePoint(prev, next) {
  if (prev === next)
    return true;
  if (!prev || !next)
    return false;
  if ("pageX" in next && "pageY" in next) {
    return prev.pageX === next.pageX && prev.pageY === next.pageY;
  }
  if ("clientX" in next && "clientY" in next) {
    return prev.clientX === next.clientX && prev.clientY === next.clientY;
  }
  return false;
}
function restoreFocus(activeElement, container2) {
  if (activeElement !== document.activeElement && contains(container2, activeElement) && typeof activeElement.focus === "function") {
    activeElement.focus();
  }
}
function monitorResize(element, callback) {
  var prevWidth = null;
  var prevHeight = null;
  function onResize2(_ref) {
    var _ref2 = _slicedToArray$1(_ref, 1), target = _ref2[0].target;
    if (!document.documentElement.contains(target))
      return;
    var _target$getBoundingCl = target.getBoundingClientRect(), width = _target$getBoundingCl.width, height = _target$getBoundingCl.height;
    var fixedWidth = Math.floor(width);
    var fixedHeight = Math.floor(height);
    if (prevWidth !== fixedWidth || prevHeight !== fixedHeight) {
      Promise.resolve().then(function() {
        callback({
          width: fixedWidth,
          height: fixedHeight
        });
      });
    }
    prevWidth = fixedWidth;
    prevHeight = fixedHeight;
  }
  var resizeObserver2 = new index$9(onResize2);
  if (element) {
    resizeObserver2.observe(element);
  }
  return function() {
    resizeObserver2.disconnect();
  };
}
var useBuffer = function(callback, buffer) {
  var calledRef = React__default.useRef(false);
  var timeoutRef = React__default.useRef(null);
  function cancelTrigger() {
    window.clearTimeout(timeoutRef.current);
  }
  function trigger2(force) {
    if (!calledRef.current || force === true) {
      if (callback() === false) {
        return;
      }
      calledRef.current = true;
      cancelTrigger();
      timeoutRef.current = window.setTimeout(function() {
        calledRef.current = false;
      }, buffer);
    } else {
      cancelTrigger();
      timeoutRef.current = window.setTimeout(function() {
        calledRef.current = false;
        trigger2();
      }, buffer);
    }
  }
  return [trigger2, function() {
    calledRef.current = false;
    cancelTrigger();
  }];
};
function getElement(func) {
  if (typeof func !== "function")
    return null;
  return func();
}
function getPoint(point) {
  if (_typeof$1(point) !== "object" || !point)
    return null;
  return point;
}
var Align = function Align2(_ref, ref2) {
  var children = _ref.children, disabled = _ref.disabled, target = _ref.target, align = _ref.align, onAlign = _ref.onAlign, monitorWindowResize = _ref.monitorWindowResize, _ref$monitorBufferTim = _ref.monitorBufferTime, monitorBufferTime = _ref$monitorBufferTim === void 0 ? 0 : _ref$monitorBufferTim;
  var cacheRef = React__default.useRef({});
  var nodeRef = React__default.useRef();
  var childNode = React__default.Children.only(children);
  var forceAlignPropsRef = React__default.useRef({});
  forceAlignPropsRef.current.disabled = disabled;
  forceAlignPropsRef.current.target = target;
  forceAlignPropsRef.current.align = align;
  forceAlignPropsRef.current.onAlign = onAlign;
  var _useBuffer = useBuffer(function() {
    var _forceAlignPropsRef$c = forceAlignPropsRef.current, latestDisabled = _forceAlignPropsRef$c.disabled, latestTarget = _forceAlignPropsRef$c.target, latestAlign = _forceAlignPropsRef$c.align, latestOnAlign = _forceAlignPropsRef$c.onAlign;
    if (!latestDisabled && latestTarget) {
      var source = nodeRef.current;
      var result;
      var element = getElement(latestTarget);
      var point = getPoint(latestTarget);
      cacheRef.current.element = element;
      cacheRef.current.point = point;
      cacheRef.current.align = latestAlign;
      var _document = document, activeElement = _document.activeElement;
      if (element && isVisible(element)) {
        result = alignElement(source, element, latestAlign);
      } else if (point) {
        result = alignPoint(source, point, latestAlign);
      }
      restoreFocus(activeElement, source);
      if (latestOnAlign && result) {
        latestOnAlign(source, result);
      }
      return true;
    }
    return false;
  }, monitorBufferTime), _useBuffer2 = _slicedToArray$1(_useBuffer, 2), _forceAlign = _useBuffer2[0], cancelForceAlign = _useBuffer2[1];
  var resizeMonitor = React__default.useRef({
    cancel: function cancel2() {
    }
  });
  var sourceResizeMonitor = React__default.useRef({
    cancel: function cancel2() {
    }
  });
  React__default.useEffect(function() {
    var element = getElement(target);
    var point = getPoint(target);
    if (nodeRef.current !== sourceResizeMonitor.current.element) {
      sourceResizeMonitor.current.cancel();
      sourceResizeMonitor.current.element = nodeRef.current;
      sourceResizeMonitor.current.cancel = monitorResize(nodeRef.current, _forceAlign);
    }
    if (cacheRef.current.element !== element || !isSamePoint(cacheRef.current.point, point) || !isEqual_1(cacheRef.current.align, align)) {
      _forceAlign();
      if (resizeMonitor.current.element !== element) {
        resizeMonitor.current.cancel();
        resizeMonitor.current.element = element;
        resizeMonitor.current.cancel = monitorResize(element, _forceAlign);
      }
    }
  });
  React__default.useEffect(function() {
    if (!disabled) {
      _forceAlign();
    } else {
      cancelForceAlign();
    }
  }, [disabled]);
  var winResizeRef = React__default.useRef(null);
  React__default.useEffect(function() {
    if (monitorWindowResize) {
      if (!winResizeRef.current) {
        winResizeRef.current = addEventListenerWrap(window, "resize", _forceAlign);
      }
    } else if (winResizeRef.current) {
      winResizeRef.current.remove();
      winResizeRef.current = null;
    }
  }, [monitorWindowResize]);
  React__default.useEffect(function() {
    return function() {
      resizeMonitor.current.cancel();
      sourceResizeMonitor.current.cancel();
      if (winResizeRef.current)
        winResizeRef.current.remove();
      cancelForceAlign();
    };
  }, []);
  React__default.useImperativeHandle(ref2, function() {
    return {
      forceAlign: function forceAlign() {
        return _forceAlign(true);
      }
    };
  });
  if (/* @__PURE__ */ React__default.isValidElement(childNode)) {
    childNode = /* @__PURE__ */ React__default.cloneElement(childNode, {
      ref: composeRef(childNode.ref, nodeRef)
    });
  }
  return childNode;
};
var RcAlign = /* @__PURE__ */ React__default.forwardRef(Align);
RcAlign.displayName = "Align";
var StatusQueue = ["measure", "align", null, "motion"];
var useVisibleStatus = function(visible, doMeasure) {
  var _useState = useState(null), _useState2 = _slicedToArray$1(_useState, 2), status = _useState2[0], setInternalStatus = _useState2[1];
  var rafRef = useRef();
  var destroyRef = useRef(false);
  function setStatus(nextStatus) {
    if (!destroyRef.current) {
      setInternalStatus(nextStatus);
    }
  }
  function cancelRaf() {
    wrapperRaf$1.cancel(rafRef.current);
  }
  function goNextStatus(callback) {
    cancelRaf();
    rafRef.current = wrapperRaf$1(function() {
      setStatus(function(prev) {
        switch (status) {
          case "align":
            return "motion";
          case "motion":
            return "stable";
        }
        return prev;
      });
      callback === null || callback === void 0 ? void 0 : callback();
    });
  }
  useEffect(function() {
    setStatus("measure");
  }, [visible]);
  useEffect(function() {
    switch (status) {
      case "measure":
        doMeasure();
        break;
    }
    if (status) {
      rafRef.current = wrapperRaf$1(/* @__PURE__ */ _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee() {
        var index2, nextStatus;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                index2 = StatusQueue.indexOf(status);
                nextStatus = StatusQueue[index2 + 1];
                if (nextStatus && index2 !== -1) {
                  setStatus(nextStatus);
                }
              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
    }
  }, [status]);
  useEffect(function() {
    return function() {
      destroyRef.current = true;
      cancelRaf();
    };
  }, []);
  return [status, goNextStatus];
};
var useStretchStyle = function(stretch) {
  var _React$useState = React.useState({
    width: 0,
    height: 0
  }), _React$useState2 = _slicedToArray$1(_React$useState, 2), targetSize = _React$useState2[0], setTargetSize = _React$useState2[1];
  function measureStretch(element) {
    setTargetSize({
      width: element.offsetWidth,
      height: element.offsetHeight
    });
  }
  var style2 = React.useMemo(function() {
    var sizeStyle = {};
    if (stretch) {
      var width = targetSize.width, height = targetSize.height;
      if (stretch.indexOf("height") !== -1 && height) {
        sizeStyle.height = height;
      } else if (stretch.indexOf("minHeight") !== -1 && height) {
        sizeStyle.minHeight = height;
      }
      if (stretch.indexOf("width") !== -1 && width) {
        sizeStyle.width = width;
      } else if (stretch.indexOf("minWidth") !== -1 && width) {
        sizeStyle.minWidth = width;
      }
    }
    return sizeStyle;
  }, [stretch, targetSize]);
  return [style2, measureStretch];
};
var PopupInner = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var visible = props.visible, prefixCls = props.prefixCls, className = props.className, style2 = props.style, children = props.children, zIndex = props.zIndex, stretch = props.stretch, destroyPopupOnHide = props.destroyPopupOnHide, forceRender = props.forceRender, align = props.align, point = props.point, getRootDomNode = props.getRootDomNode, getClassNameFromAlign = props.getClassNameFromAlign, onAlign = props.onAlign, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onMouseDown = props.onMouseDown, onTouchStart = props.onTouchStart;
  var alignRef = useRef();
  var elementRef = useRef();
  var _useState = useState(), _useState2 = _slicedToArray$1(_useState, 2), alignedClassName = _useState2[0], setAlignedClassName = _useState2[1];
  var _useStretchStyle = useStretchStyle(stretch), _useStretchStyle2 = _slicedToArray$1(_useStretchStyle, 2), stretchStyle = _useStretchStyle2[0], measureStretchStyle = _useStretchStyle2[1];
  function doMeasure() {
    if (stretch) {
      measureStretchStyle(getRootDomNode());
    }
  }
  var _useVisibleStatus = useVisibleStatus(visible, doMeasure), _useVisibleStatus2 = _slicedToArray$1(_useVisibleStatus, 2), status = _useVisibleStatus2[0], goNextStatus = _useVisibleStatus2[1];
  var prepareResolveRef = useRef();
  function getAlignTarget() {
    if (point) {
      return point;
    }
    return getRootDomNode;
  }
  function forceAlign() {
    var _alignRef$current;
    (_alignRef$current = alignRef.current) === null || _alignRef$current === void 0 ? void 0 : _alignRef$current.forceAlign();
  }
  function onInternalAlign(popupDomNode, matchAlign) {
    var nextAlignedClassName = getClassNameFromAlign(matchAlign);
    if (alignedClassName !== nextAlignedClassName) {
      setAlignedClassName(nextAlignedClassName);
    }
    if (status === "align") {
      if (alignedClassName !== nextAlignedClassName) {
        Promise.resolve().then(function() {
          forceAlign();
        });
      } else {
        goNextStatus(function() {
          var _prepareResolveRef$cu;
          (_prepareResolveRef$cu = prepareResolveRef.current) === null || _prepareResolveRef$cu === void 0 ? void 0 : _prepareResolveRef$cu.call(prepareResolveRef);
        });
      }
      onAlign === null || onAlign === void 0 ? void 0 : onAlign(popupDomNode, matchAlign);
    }
  }
  var motion = _objectSpread2$3({}, getMotion$1(props));
  ["onAppearEnd", "onEnterEnd", "onLeaveEnd"].forEach(function(eventName) {
    var originHandler = motion[eventName];
    motion[eventName] = function(element, event) {
      goNextStatus();
      return originHandler === null || originHandler === void 0 ? void 0 : originHandler(element, event);
    };
  });
  function onShowPrepare() {
    return new Promise(function(resolve) {
      prepareResolveRef.current = resolve;
    });
  }
  React.useEffect(function() {
    if (!motion.motionName && status === "motion") {
      goNextStatus();
    }
  }, [motion.motionName, status]);
  React.useImperativeHandle(ref2, function() {
    return {
      forceAlign,
      getElement: function getElement2() {
        return elementRef.current;
      }
    };
  });
  var mergedStyle = _objectSpread2$3(_objectSpread2$3({}, stretchStyle), {}, {
    zIndex,
    opacity: status === "motion" || status === "stable" || !visible ? void 0 : 0,
    pointerEvents: status === "stable" ? void 0 : "none"
  }, style2);
  var alignDisabled = true;
  if ((align === null || align === void 0 ? void 0 : align.points) && (status === "align" || status === "stable")) {
    alignDisabled = false;
  }
  var childNode = children;
  if (React.Children.count(children) > 1) {
    childNode = /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, children);
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible,
    ref: elementRef,
    leavedClassName: "".concat(prefixCls, "-hidden")
  }, motion, {
    onAppearPrepare: onShowPrepare,
    onEnterPrepare: onShowPrepare,
    removeOnLeave: destroyPopupOnHide,
    forceRender
  }), function(_ref, motionRef) {
    var motionClassName = _ref.className, motionStyle = _ref.style;
    var mergedClassName = classNames(prefixCls, className, alignedClassName, motionClassName);
    return /* @__PURE__ */ React.createElement(RcAlign, {
      target: getAlignTarget(),
      key: "popup",
      ref: alignRef,
      monitorWindowResize: true,
      disabled: alignDisabled,
      align,
      onAlign: onInternalAlign
    }, /* @__PURE__ */ React.createElement("div", {
      ref: motionRef,
      className: mergedClassName,
      onMouseEnter,
      onMouseLeave,
      onMouseDownCapture: onMouseDown,
      onTouchStartCapture: onTouchStart,
      style: _objectSpread2$3(_objectSpread2$3({}, motionStyle), mergedStyle)
    }, childNode));
  });
});
PopupInner.displayName = "PopupInner";
var MobilePopupInner = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var prefixCls = props.prefixCls, visible = props.visible, zIndex = props.zIndex, children = props.children, _props$mobile = props.mobile;
  _props$mobile = _props$mobile === void 0 ? {} : _props$mobile;
  var popupClassName = _props$mobile.popupClassName, popupStyle = _props$mobile.popupStyle, _props$mobile$popupMo = _props$mobile.popupMotion, popupMotion = _props$mobile$popupMo === void 0 ? {} : _props$mobile$popupMo, popupRender = _props$mobile.popupRender;
  var elementRef = React.useRef();
  React.useImperativeHandle(ref2, function() {
    return {
      forceAlign: function forceAlign() {
      },
      getElement: function getElement2() {
        return elementRef.current;
      }
    };
  });
  var mergedStyle = _objectSpread2$3({
    zIndex
  }, popupStyle);
  var childNode = children;
  if (React.Children.count(children) > 1) {
    childNode = /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, children);
  }
  if (popupRender) {
    childNode = popupRender(childNode);
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible,
    ref: elementRef,
    removeOnLeave: true
  }, popupMotion), function(_ref, motionRef) {
    var motionClassName = _ref.className, motionStyle = _ref.style;
    var mergedClassName = classNames(prefixCls, popupClassName, motionClassName);
    return /* @__PURE__ */ React.createElement("div", {
      ref: motionRef,
      className: mergedClassName,
      style: _objectSpread2$3(_objectSpread2$3({}, motionStyle), mergedStyle)
    }, childNode);
  });
});
MobilePopupInner.displayName = "MobilePopupInner";
var _excluded$f = ["visible", "mobile"];
var Popup = /* @__PURE__ */ React.forwardRef(function(_ref, ref2) {
  var visible = _ref.visible, mobile = _ref.mobile, props = _objectWithoutProperties$1(_ref, _excluded$f);
  var _useState = useState(visible), _useState2 = _slicedToArray$1(_useState, 2), innerVisible = _useState2[0], serInnerVisible = _useState2[1];
  var _useState3 = useState(false), _useState4 = _slicedToArray$1(_useState3, 2), inMobile = _useState4[0], setInMobile = _useState4[1];
  var cloneProps = _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    visible: innerVisible
  });
  useEffect(function() {
    serInnerVisible(visible);
    if (visible && mobile) {
      setInMobile(isMobile());
    }
  }, [visible, mobile]);
  var popupNode = inMobile ? /* @__PURE__ */ React.createElement(MobilePopupInner, _extends$1({}, cloneProps, {
    mobile,
    ref: ref2
  })) : /* @__PURE__ */ React.createElement(PopupInner, _extends$1({}, cloneProps, {
    ref: ref2
  }));
  return /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement(Mask, cloneProps), popupNode);
});
Popup.displayName = "Popup";
var TriggerContext = /* @__PURE__ */ React.createContext(null);
function noop() {
}
function returnEmptyString() {
  return "";
}
function returnDocument(element) {
  if (element) {
    return element.ownerDocument;
  }
  return window.document;
}
var ALL_HANDLERS = ["onClick", "onMouseDown", "onTouchStart", "onMouseEnter", "onMouseLeave", "onFocus", "onBlur", "onContextMenu"];
function generateTrigger(PortalComponent) {
  var Trigger2 = /* @__PURE__ */ function(_React$Component) {
    _inherits(Trigger3, _React$Component);
    var _super = _createSuper(Trigger3);
    function Trigger3(props) {
      var _this;
      _classCallCheck(this, Trigger3);
      _this = _super.call(this, props);
      _this.popupRef = /* @__PURE__ */ React.createRef();
      _this.triggerRef = /* @__PURE__ */ React.createRef();
      _this.attachId = void 0;
      _this.clickOutsideHandler = void 0;
      _this.touchOutsideHandler = void 0;
      _this.contextMenuOutsideHandler1 = void 0;
      _this.contextMenuOutsideHandler2 = void 0;
      _this.mouseDownTimeout = void 0;
      _this.focusTime = void 0;
      _this.preClickTime = void 0;
      _this.preTouchTime = void 0;
      _this.delayTimer = void 0;
      _this.hasPopupMouseDown = void 0;
      _this.onMouseEnter = function(e2) {
        var mouseEnterDelay = _this.props.mouseEnterDelay;
        _this.fireEvents("onMouseEnter", e2);
        _this.delaySetPopupVisible(true, mouseEnterDelay, mouseEnterDelay ? null : e2);
      };
      _this.onMouseMove = function(e2) {
        _this.fireEvents("onMouseMove", e2);
        _this.setPoint(e2);
      };
      _this.onMouseLeave = function(e2) {
        _this.fireEvents("onMouseLeave", e2);
        _this.delaySetPopupVisible(false, _this.props.mouseLeaveDelay);
      };
      _this.onPopupMouseEnter = function() {
        _this.clearDelayTimer();
      };
      _this.onPopupMouseLeave = function(e2) {
        var _this$popupRef$curren;
        if (e2.relatedTarget && !e2.relatedTarget.setTimeout && contains((_this$popupRef$curren = _this.popupRef.current) === null || _this$popupRef$curren === void 0 ? void 0 : _this$popupRef$curren.getElement(), e2.relatedTarget)) {
          return;
        }
        _this.delaySetPopupVisible(false, _this.props.mouseLeaveDelay);
      };
      _this.onFocus = function(e2) {
        _this.fireEvents("onFocus", e2);
        _this.clearDelayTimer();
        if (_this.isFocusToShow()) {
          _this.focusTime = Date.now();
          _this.delaySetPopupVisible(true, _this.props.focusDelay);
        }
      };
      _this.onMouseDown = function(e2) {
        _this.fireEvents("onMouseDown", e2);
        _this.preClickTime = Date.now();
      };
      _this.onTouchStart = function(e2) {
        _this.fireEvents("onTouchStart", e2);
        _this.preTouchTime = Date.now();
      };
      _this.onBlur = function(e2) {
        _this.fireEvents("onBlur", e2);
        _this.clearDelayTimer();
        if (_this.isBlurToHide()) {
          _this.delaySetPopupVisible(false, _this.props.blurDelay);
        }
      };
      _this.onContextMenu = function(e2) {
        e2.preventDefault();
        _this.fireEvents("onContextMenu", e2);
        _this.setPopupVisible(true, e2);
      };
      _this.onContextMenuClose = function() {
        if (_this.isContextMenuToShow()) {
          _this.close();
        }
      };
      _this.onClick = function(event) {
        _this.fireEvents("onClick", event);
        if (_this.focusTime) {
          var preTime;
          if (_this.preClickTime && _this.preTouchTime) {
            preTime = Math.min(_this.preClickTime, _this.preTouchTime);
          } else if (_this.preClickTime) {
            preTime = _this.preClickTime;
          } else if (_this.preTouchTime) {
            preTime = _this.preTouchTime;
          }
          if (Math.abs(preTime - _this.focusTime) < 20) {
            return;
          }
          _this.focusTime = 0;
        }
        _this.preClickTime = 0;
        _this.preTouchTime = 0;
        if (_this.isClickToShow() && (_this.isClickToHide() || _this.isBlurToHide()) && event && event.preventDefault) {
          event.preventDefault();
        }
        var nextVisible = !_this.state.popupVisible;
        if (_this.isClickToHide() && !nextVisible || nextVisible && _this.isClickToShow()) {
          _this.setPopupVisible(!_this.state.popupVisible, event);
        }
      };
      _this.onPopupMouseDown = function() {
        _this.hasPopupMouseDown = true;
        clearTimeout(_this.mouseDownTimeout);
        _this.mouseDownTimeout = window.setTimeout(function() {
          _this.hasPopupMouseDown = false;
        }, 0);
        if (_this.context) {
          var _this$context;
          (_this$context = _this.context).onPopupMouseDown.apply(_this$context, arguments);
        }
      };
      _this.onDocumentClick = function(event) {
        if (_this.props.mask && !_this.props.maskClosable) {
          return;
        }
        var target = event.target;
        var root2 = _this.getRootDomNode();
        var popupNode = _this.getPopupDomNode();
        if ((!contains(root2, target) || _this.isContextMenuOnly()) && !contains(popupNode, target) && !_this.hasPopupMouseDown) {
          _this.close();
        }
      };
      _this.getRootDomNode = function() {
        var getTriggerDOMNode = _this.props.getTriggerDOMNode;
        if (getTriggerDOMNode) {
          return getTriggerDOMNode(_this.triggerRef.current);
        }
        try {
          var domNode = findDOMNode(_this.triggerRef.current);
          if (domNode) {
            return domNode;
          }
        } catch (err) {
        }
        return ReactDOM.findDOMNode(_assertThisInitialized(_this));
      };
      _this.getPopupClassNameFromAlign = function(align) {
        var className = [];
        var _this$props = _this.props, popupPlacement = _this$props.popupPlacement, builtinPlacements = _this$props.builtinPlacements, prefixCls = _this$props.prefixCls, alignPoint2 = _this$props.alignPoint, getPopupClassNameFromAlign = _this$props.getPopupClassNameFromAlign;
        if (popupPlacement && builtinPlacements) {
          className.push(getAlignPopupClassName(builtinPlacements, prefixCls, align, alignPoint2));
        }
        if (getPopupClassNameFromAlign) {
          className.push(getPopupClassNameFromAlign(align));
        }
        return className.join(" ");
      };
      _this.getComponent = function() {
        var _this$props2 = _this.props, prefixCls = _this$props2.prefixCls, destroyPopupOnHide = _this$props2.destroyPopupOnHide, popupClassName = _this$props2.popupClassName, onPopupAlign = _this$props2.onPopupAlign, popupMotion = _this$props2.popupMotion, popupAnimation = _this$props2.popupAnimation, popupTransitionName = _this$props2.popupTransitionName, popupStyle = _this$props2.popupStyle, mask = _this$props2.mask, maskAnimation = _this$props2.maskAnimation, maskTransitionName = _this$props2.maskTransitionName, maskMotion = _this$props2.maskMotion, zIndex = _this$props2.zIndex, popup = _this$props2.popup, stretch = _this$props2.stretch, alignPoint2 = _this$props2.alignPoint, mobile = _this$props2.mobile, forceRender = _this$props2.forceRender;
        var _this$state = _this.state, popupVisible = _this$state.popupVisible, point = _this$state.point;
        var align = _this.getPopupAlign();
        var mouseProps = {};
        if (_this.isMouseEnterToShow()) {
          mouseProps.onMouseEnter = _this.onPopupMouseEnter;
        }
        if (_this.isMouseLeaveToHide()) {
          mouseProps.onMouseLeave = _this.onPopupMouseLeave;
        }
        mouseProps.onMouseDown = _this.onPopupMouseDown;
        mouseProps.onTouchStart = _this.onPopupMouseDown;
        return /* @__PURE__ */ React.createElement(Popup, _extends$1({
          prefixCls,
          destroyPopupOnHide,
          visible: popupVisible,
          point: alignPoint2 && point,
          className: popupClassName,
          align,
          onAlign: onPopupAlign,
          animation: popupAnimation,
          getClassNameFromAlign: _this.getPopupClassNameFromAlign
        }, mouseProps, {
          stretch,
          getRootDomNode: _this.getRootDomNode,
          style: popupStyle,
          mask,
          zIndex,
          transitionName: popupTransitionName,
          maskAnimation,
          maskTransitionName,
          maskMotion,
          ref: _this.popupRef,
          motion: popupMotion,
          mobile,
          forceRender
        }), typeof popup === "function" ? popup() : popup);
      };
      _this.attachParent = function(popupContainer) {
        wrapperRaf$1.cancel(_this.attachId);
        var _this$props3 = _this.props, getPopupContainer = _this$props3.getPopupContainer, getDocument2 = _this$props3.getDocument;
        var domNode = _this.getRootDomNode();
        var mountNode;
        if (!getPopupContainer) {
          mountNode = getDocument2(_this.getRootDomNode()).body;
        } else if (domNode || getPopupContainer.length === 0) {
          mountNode = getPopupContainer(domNode);
        }
        if (mountNode) {
          mountNode.appendChild(popupContainer);
        } else {
          _this.attachId = wrapperRaf$1(function() {
            _this.attachParent(popupContainer);
          });
        }
      };
      _this.getContainer = function() {
        var getDocument2 = _this.props.getDocument;
        var popupContainer = getDocument2(_this.getRootDomNode()).createElement("div");
        popupContainer.style.position = "absolute";
        popupContainer.style.top = "0";
        popupContainer.style.left = "0";
        popupContainer.style.width = "100%";
        _this.attachParent(popupContainer);
        return popupContainer;
      };
      _this.setPoint = function(point) {
        var alignPoint2 = _this.props.alignPoint;
        if (!alignPoint2 || !point)
          return;
        _this.setState({
          point: {
            pageX: point.pageX,
            pageY: point.pageY
          }
        });
      };
      _this.handlePortalUpdate = function() {
        if (_this.state.prevPopupVisible !== _this.state.popupVisible) {
          _this.props.afterPopupVisibleChange(_this.state.popupVisible);
        }
      };
      _this.triggerContextValue = {
        onPopupMouseDown: _this.onPopupMouseDown
      };
      var _popupVisible;
      if ("popupVisible" in props) {
        _popupVisible = !!props.popupVisible;
      } else {
        _popupVisible = !!props.defaultPopupVisible;
      }
      _this.state = {
        prevPopupVisible: _popupVisible,
        popupVisible: _popupVisible
      };
      ALL_HANDLERS.forEach(function(h) {
        _this["fire".concat(h)] = function(e2) {
          _this.fireEvents(h, e2);
        };
      });
      return _this;
    }
    _createClass(Trigger3, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.componentDidUpdate();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        var props = this.props;
        var state = this.state;
        if (state.popupVisible) {
          var currentDocument;
          if (!this.clickOutsideHandler && (this.isClickToHide() || this.isContextMenuToShow())) {
            currentDocument = props.getDocument(this.getRootDomNode());
            this.clickOutsideHandler = addEventListenerWrap(currentDocument, "mousedown", this.onDocumentClick);
          }
          if (!this.touchOutsideHandler) {
            currentDocument = currentDocument || props.getDocument(this.getRootDomNode());
            this.touchOutsideHandler = addEventListenerWrap(currentDocument, "touchstart", this.onDocumentClick);
          }
          if (!this.contextMenuOutsideHandler1 && this.isContextMenuToShow()) {
            currentDocument = currentDocument || props.getDocument(this.getRootDomNode());
            this.contextMenuOutsideHandler1 = addEventListenerWrap(currentDocument, "scroll", this.onContextMenuClose);
          }
          if (!this.contextMenuOutsideHandler2 && this.isContextMenuToShow()) {
            this.contextMenuOutsideHandler2 = addEventListenerWrap(window, "blur", this.onContextMenuClose);
          }
          return;
        }
        this.clearOutsideHandler();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.clearDelayTimer();
        this.clearOutsideHandler();
        clearTimeout(this.mouseDownTimeout);
        wrapperRaf$1.cancel(this.attachId);
      }
    }, {
      key: "getPopupDomNode",
      value: function getPopupDomNode() {
        var _this$popupRef$curren2;
        return ((_this$popupRef$curren2 = this.popupRef.current) === null || _this$popupRef$curren2 === void 0 ? void 0 : _this$popupRef$curren2.getElement()) || null;
      }
    }, {
      key: "getPopupAlign",
      value: function getPopupAlign() {
        var props = this.props;
        var popupPlacement = props.popupPlacement, popupAlign = props.popupAlign, builtinPlacements = props.builtinPlacements;
        if (popupPlacement && builtinPlacements) {
          return getAlignFromPlacement(builtinPlacements, popupPlacement, popupAlign);
        }
        return popupAlign;
      }
    }, {
      key: "setPopupVisible",
      value: function setPopupVisible(popupVisible, event) {
        var alignPoint2 = this.props.alignPoint;
        var prevPopupVisible = this.state.popupVisible;
        this.clearDelayTimer();
        if (prevPopupVisible !== popupVisible) {
          if (!("popupVisible" in this.props)) {
            this.setState({
              popupVisible,
              prevPopupVisible
            });
          }
          this.props.onPopupVisibleChange(popupVisible);
        }
        if (alignPoint2 && event && popupVisible) {
          this.setPoint(event);
        }
      }
    }, {
      key: "delaySetPopupVisible",
      value: function delaySetPopupVisible(visible, delayS, event) {
        var _this2 = this;
        var delay = delayS * 1e3;
        this.clearDelayTimer();
        if (delay) {
          var point = event ? {
            pageX: event.pageX,
            pageY: event.pageY
          } : null;
          this.delayTimer = window.setTimeout(function() {
            _this2.setPopupVisible(visible, point);
            _this2.clearDelayTimer();
          }, delay);
        } else {
          this.setPopupVisible(visible, event);
        }
      }
    }, {
      key: "clearDelayTimer",
      value: function clearDelayTimer() {
        if (this.delayTimer) {
          clearTimeout(this.delayTimer);
          this.delayTimer = null;
        }
      }
    }, {
      key: "clearOutsideHandler",
      value: function clearOutsideHandler() {
        if (this.clickOutsideHandler) {
          this.clickOutsideHandler.remove();
          this.clickOutsideHandler = null;
        }
        if (this.contextMenuOutsideHandler1) {
          this.contextMenuOutsideHandler1.remove();
          this.contextMenuOutsideHandler1 = null;
        }
        if (this.contextMenuOutsideHandler2) {
          this.contextMenuOutsideHandler2.remove();
          this.contextMenuOutsideHandler2 = null;
        }
        if (this.touchOutsideHandler) {
          this.touchOutsideHandler.remove();
          this.touchOutsideHandler = null;
        }
      }
    }, {
      key: "createTwoChains",
      value: function createTwoChains(event) {
        var childPros = this.props.children.props;
        var props = this.props;
        if (childPros[event] && props[event]) {
          return this["fire".concat(event)];
        }
        return childPros[event] || props[event];
      }
    }, {
      key: "isClickToShow",
      value: function isClickToShow() {
        var _this$props4 = this.props, action = _this$props4.action, showAction = _this$props4.showAction;
        return action.indexOf("click") !== -1 || showAction.indexOf("click") !== -1;
      }
    }, {
      key: "isContextMenuOnly",
      value: function isContextMenuOnly() {
        var action = this.props.action;
        return action === "contextMenu" || action.length === 1 && action[0] === "contextMenu";
      }
    }, {
      key: "isContextMenuToShow",
      value: function isContextMenuToShow() {
        var _this$props5 = this.props, action = _this$props5.action, showAction = _this$props5.showAction;
        return action.indexOf("contextMenu") !== -1 || showAction.indexOf("contextMenu") !== -1;
      }
    }, {
      key: "isClickToHide",
      value: function isClickToHide() {
        var _this$props6 = this.props, action = _this$props6.action, hideAction = _this$props6.hideAction;
        return action.indexOf("click") !== -1 || hideAction.indexOf("click") !== -1;
      }
    }, {
      key: "isMouseEnterToShow",
      value: function isMouseEnterToShow() {
        var _this$props7 = this.props, action = _this$props7.action, showAction = _this$props7.showAction;
        return action.indexOf("hover") !== -1 || showAction.indexOf("mouseEnter") !== -1;
      }
    }, {
      key: "isMouseLeaveToHide",
      value: function isMouseLeaveToHide() {
        var _this$props8 = this.props, action = _this$props8.action, hideAction = _this$props8.hideAction;
        return action.indexOf("hover") !== -1 || hideAction.indexOf("mouseLeave") !== -1;
      }
    }, {
      key: "isFocusToShow",
      value: function isFocusToShow() {
        var _this$props9 = this.props, action = _this$props9.action, showAction = _this$props9.showAction;
        return action.indexOf("focus") !== -1 || showAction.indexOf("focus") !== -1;
      }
    }, {
      key: "isBlurToHide",
      value: function isBlurToHide() {
        var _this$props10 = this.props, action = _this$props10.action, hideAction = _this$props10.hideAction;
        return action.indexOf("focus") !== -1 || hideAction.indexOf("blur") !== -1;
      }
    }, {
      key: "forcePopupAlign",
      value: function forcePopupAlign() {
        if (this.state.popupVisible) {
          var _this$popupRef$curren3;
          (_this$popupRef$curren3 = this.popupRef.current) === null || _this$popupRef$curren3 === void 0 ? void 0 : _this$popupRef$curren3.forceAlign();
        }
      }
    }, {
      key: "fireEvents",
      value: function fireEvents(type4, e2) {
        var childCallback = this.props.children.props[type4];
        if (childCallback) {
          childCallback(e2);
        }
        var callback = this.props[type4];
        if (callback) {
          callback(e2);
        }
      }
    }, {
      key: "close",
      value: function close() {
        this.setPopupVisible(false);
      }
    }, {
      key: "render",
      value: function render2() {
        var popupVisible = this.state.popupVisible;
        var _this$props11 = this.props, children = _this$props11.children, forceRender = _this$props11.forceRender, alignPoint2 = _this$props11.alignPoint, className = _this$props11.className, autoDestroy = _this$props11.autoDestroy;
        var child = React.Children.only(children);
        var newChildProps = {
          key: "trigger"
        };
        if (this.isContextMenuToShow()) {
          newChildProps.onContextMenu = this.onContextMenu;
        } else {
          newChildProps.onContextMenu = this.createTwoChains("onContextMenu");
        }
        if (this.isClickToHide() || this.isClickToShow()) {
          newChildProps.onClick = this.onClick;
          newChildProps.onMouseDown = this.onMouseDown;
          newChildProps.onTouchStart = this.onTouchStart;
        } else {
          newChildProps.onClick = this.createTwoChains("onClick");
          newChildProps.onMouseDown = this.createTwoChains("onMouseDown");
          newChildProps.onTouchStart = this.createTwoChains("onTouchStart");
        }
        if (this.isMouseEnterToShow()) {
          newChildProps.onMouseEnter = this.onMouseEnter;
          if (alignPoint2) {
            newChildProps.onMouseMove = this.onMouseMove;
          }
        } else {
          newChildProps.onMouseEnter = this.createTwoChains("onMouseEnter");
        }
        if (this.isMouseLeaveToHide()) {
          newChildProps.onMouseLeave = this.onMouseLeave;
        } else {
          newChildProps.onMouseLeave = this.createTwoChains("onMouseLeave");
        }
        if (this.isFocusToShow() || this.isBlurToHide()) {
          newChildProps.onFocus = this.onFocus;
          newChildProps.onBlur = this.onBlur;
        } else {
          newChildProps.onFocus = this.createTwoChains("onFocus");
          newChildProps.onBlur = this.createTwoChains("onBlur");
        }
        var childrenClassName = classNames(child && child.props && child.props.className, className);
        if (childrenClassName) {
          newChildProps.className = childrenClassName;
        }
        var cloneProps = _objectSpread2$3({}, newChildProps);
        if (supportRef(child)) {
          cloneProps.ref = composeRef(this.triggerRef, child.ref);
        }
        var trigger2 = /* @__PURE__ */ React.cloneElement(child, cloneProps);
        var portal;
        if (popupVisible || this.popupRef.current || forceRender) {
          portal = /* @__PURE__ */ React.createElement(PortalComponent, {
            key: "portal",
            getContainer: this.getContainer,
            didUpdate: this.handlePortalUpdate
          }, this.getComponent());
        }
        if (!popupVisible && autoDestroy) {
          portal = null;
        }
        return /* @__PURE__ */ React.createElement(TriggerContext.Provider, {
          value: this.triggerContextValue
        }, trigger2, portal);
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(_ref, prevState) {
        var popupVisible = _ref.popupVisible;
        var newState = {};
        if (popupVisible !== void 0 && prevState.popupVisible !== popupVisible) {
          newState.popupVisible = popupVisible;
          newState.prevPopupVisible = prevState.popupVisible;
        }
        return newState;
      }
    }]);
    return Trigger3;
  }(React.Component);
  Trigger2.contextType = TriggerContext;
  Trigger2.defaultProps = {
    prefixCls: "rc-trigger-popup",
    getPopupClassNameFromAlign: returnEmptyString,
    getDocument: returnDocument,
    onPopupVisibleChange: noop,
    afterPopupVisibleChange: noop,
    onPopupAlign: noop,
    popupClassName: "",
    mouseEnterDelay: 0,
    mouseLeaveDelay: 0.1,
    focusDelay: 0,
    blurDelay: 0.15,
    popupStyle: {},
    destroyPopupOnHide: false,
    popupAlign: {},
    defaultPopupVisible: false,
    mask: false,
    maskClosable: true,
    action: [],
    showAction: [],
    hideAction: [],
    autoDestroy: false
  };
  return Trigger2;
}
var Trigger = generateTrigger(Portal);
var _excluded$e = ["prefixCls", "invalidate", "item", "renderItem", "responsive", "registerSize", "itemKey", "className", "style", "children", "display", "order", "component"];
var UNDEFINED = void 0;
function InternalItem(props, ref2) {
  var prefixCls = props.prefixCls, invalidate = props.invalidate, item = props.item, renderItem = props.renderItem, responsive = props.responsive, registerSize = props.registerSize, itemKey = props.itemKey, className = props.className, style2 = props.style, children = props.children, display = props.display, order = props.order, _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, restProps = _objectWithoutProperties$1(props, _excluded$e);
  var mergedHidden = responsive && !display;
  function internalRegisterSize(width) {
    registerSize(itemKey, width);
  }
  React.useEffect(function() {
    return function() {
      internalRegisterSize(null);
    };
  }, []);
  var childNode = renderItem && item !== UNDEFINED ? renderItem(item) : children;
  var overflowStyle;
  if (!invalidate) {
    overflowStyle = {
      opacity: mergedHidden ? 0 : 1,
      height: mergedHidden ? 0 : UNDEFINED,
      overflowY: mergedHidden ? "hidden" : UNDEFINED,
      order: responsive ? order : UNDEFINED,
      pointerEvents: mergedHidden ? "none" : UNDEFINED,
      position: mergedHidden ? "absolute" : UNDEFINED
    };
  }
  var overflowProps = {};
  if (mergedHidden) {
    overflowProps["aria-hidden"] = true;
  }
  var itemNode = /* @__PURE__ */ React.createElement(Component2, _extends$1({
    className: classNames(!invalidate && prefixCls, className),
    style: _objectSpread2$3(_objectSpread2$3({}, overflowStyle), style2)
  }, overflowProps, restProps, {
    ref: ref2
  }), childNode);
  if (responsive) {
    itemNode = /* @__PURE__ */ React.createElement(ResizeObserver, {
      onResize: function onResize2(_ref) {
        var offsetWidth = _ref.offsetWidth;
        internalRegisterSize(offsetWidth);
      }
    }, itemNode);
  }
  return itemNode;
}
var Item$1 = /* @__PURE__ */ React.forwardRef(InternalItem);
Item$1.displayName = "Item";
function useBatchFrameState() {
  var _useState = useState({}), _useState2 = _slicedToArray$1(_useState, 2), forceUpdate = _useState2[1];
  var statesRef = useRef([]);
  var destroyRef = useRef(false);
  var walkingIndex = 0;
  var beforeFrameId = 0;
  useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  function createState(defaultValue) {
    var myIndex = walkingIndex;
    walkingIndex += 1;
    if (statesRef.current.length < myIndex + 1) {
      statesRef.current[myIndex] = defaultValue;
    }
    var value = statesRef.current[myIndex];
    function setValue2(val) {
      statesRef.current[myIndex] = typeof val === "function" ? val(statesRef.current[myIndex]) : val;
      wrapperRaf$1.cancel(beforeFrameId);
      beforeFrameId = wrapperRaf$1(function() {
        if (!destroyRef.current) {
          forceUpdate({});
        }
      });
    }
    return [value, setValue2];
  }
  return createState;
}
var _excluded$d = ["component"], _excluded2$4 = ["className"], _excluded3$1 = ["className"];
var InternalRawItem = function InternalRawItem2(props, ref2) {
  var context = React.useContext(OverflowContext);
  if (!context) {
    var _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, _restProps = _objectWithoutProperties$1(props, _excluded$d);
    return /* @__PURE__ */ React.createElement(Component2, _extends$1({}, _restProps, {
      ref: ref2
    }));
  }
  var contextClassName = context.className, restContext = _objectWithoutProperties$1(context, _excluded2$4);
  var className = props.className, restProps = _objectWithoutProperties$1(props, _excluded3$1);
  return /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
    value: null
  }, /* @__PURE__ */ React.createElement(Item$1, _extends$1({
    ref: ref2,
    className: classNames(contextClassName, className)
  }, restContext, restProps)));
};
var RawItem = /* @__PURE__ */ React.forwardRef(InternalRawItem);
RawItem.displayName = "RawItem";
var _excluded$c = ["prefixCls", "data", "renderItem", "renderRawItem", "itemKey", "itemWidth", "ssr", "style", "className", "maxCount", "renderRest", "renderRawRest", "suffix", "component", "itemComponent", "onVisibleChange"];
var OverflowContext = /* @__PURE__ */ React.createContext(null);
var RESPONSIVE = "responsive";
var INVALIDATE = "invalidate";
function defaultRenderRest(omittedItems) {
  return "+ ".concat(omittedItems.length, " ...");
}
function Overflow(props, ref2) {
  var _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-overflow" : _props$prefixCls, _props$data = props.data, data2 = _props$data === void 0 ? [] : _props$data, renderItem = props.renderItem, renderRawItem = props.renderRawItem, itemKey = props.itemKey, _props$itemWidth = props.itemWidth, itemWidth = _props$itemWidth === void 0 ? 10 : _props$itemWidth, ssr = props.ssr, style2 = props.style, className = props.className, maxCount = props.maxCount, renderRest = props.renderRest, renderRawRest = props.renderRawRest, suffix = props.suffix, _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, itemComponent = props.itemComponent, onVisibleChange = props.onVisibleChange, restProps = _objectWithoutProperties$1(props, _excluded$c);
  var createUseState = useBatchFrameState();
  var fullySSR = ssr === "full";
  var _createUseState = createUseState(null), _createUseState2 = _slicedToArray$1(_createUseState, 2), containerWidth = _createUseState2[0], setContainerWidth = _createUseState2[1];
  var mergedContainerWidth = containerWidth || 0;
  var _createUseState3 = createUseState(/* @__PURE__ */ new Map()), _createUseState4 = _slicedToArray$1(_createUseState3, 2), itemWidths = _createUseState4[0], setItemWidths = _createUseState4[1];
  var _createUseState5 = createUseState(0), _createUseState6 = _slicedToArray$1(_createUseState5, 2), prevRestWidth = _createUseState6[0], setPrevRestWidth = _createUseState6[1];
  var _createUseState7 = createUseState(0), _createUseState8 = _slicedToArray$1(_createUseState7, 2), restWidth = _createUseState8[0], setRestWidth = _createUseState8[1];
  var _createUseState9 = createUseState(0), _createUseState10 = _slicedToArray$1(_createUseState9, 2), suffixWidth = _createUseState10[0], setSuffixWidth = _createUseState10[1];
  var _useState = useState(null), _useState2 = _slicedToArray$1(_useState, 2), suffixFixedStart = _useState2[0], setSuffixFixedStart = _useState2[1];
  var _useState3 = useState(null), _useState4 = _slicedToArray$1(_useState3, 2), displayCount = _useState4[0], setDisplayCount = _useState4[1];
  var mergedDisplayCount = React.useMemo(function() {
    if (displayCount === null && fullySSR) {
      return Number.MAX_SAFE_INTEGER;
    }
    return displayCount || 0;
  }, [displayCount, containerWidth]);
  var _useState5 = useState(false), _useState6 = _slicedToArray$1(_useState5, 2), restReady = _useState6[0], setRestReady = _useState6[1];
  var itemPrefixCls = "".concat(prefixCls, "-item");
  var mergedRestWidth = Math.max(prevRestWidth, restWidth);
  var isResponsive = data2.length && maxCount === RESPONSIVE;
  var invalidate = maxCount === INVALIDATE;
  var showRest = isResponsive || typeof maxCount === "number" && data2.length > maxCount;
  var mergedData = useMemo$1(function() {
    var items = data2;
    if (isResponsive) {
      if (containerWidth === null && fullySSR) {
        items = data2;
      } else {
        items = data2.slice(0, Math.min(data2.length, mergedContainerWidth / itemWidth));
      }
    } else if (typeof maxCount === "number") {
      items = data2.slice(0, maxCount);
    }
    return items;
  }, [data2, itemWidth, containerWidth, maxCount, isResponsive]);
  var omittedItems = useMemo$1(function() {
    if (isResponsive) {
      return data2.slice(mergedDisplayCount + 1);
    }
    return data2.slice(mergedData.length);
  }, [data2, mergedData, isResponsive, mergedDisplayCount]);
  var getKey2 = useCallback(function(item, index2) {
    var _ref;
    if (typeof itemKey === "function") {
      return itemKey(item);
    }
    return (_ref = itemKey && (item === null || item === void 0 ? void 0 : item[itemKey])) !== null && _ref !== void 0 ? _ref : index2;
  }, [itemKey]);
  var mergedRenderItem = useCallback(renderItem || function(item) {
    return item;
  }, [renderItem]);
  function updateDisplayCount(count2, notReady) {
    setDisplayCount(count2);
    if (!notReady) {
      setRestReady(count2 < data2.length - 1);
      onVisibleChange === null || onVisibleChange === void 0 ? void 0 : onVisibleChange(count2);
    }
  }
  function onOverflowResize(_, element) {
    setContainerWidth(element.clientWidth);
  }
  function registerSize(key, width) {
    setItemWidths(function(origin) {
      var clone3 = new Map(origin);
      if (width === null) {
        clone3.delete(key);
      } else {
        clone3.set(key, width);
      }
      return clone3;
    });
  }
  function registerOverflowSize(_, width) {
    setRestWidth(width);
    setPrevRestWidth(restWidth);
  }
  function registerSuffixSize(_, width) {
    setSuffixWidth(width);
  }
  function getItemWidth(index2) {
    return itemWidths.get(getKey2(mergedData[index2], index2));
  }
  useLayoutEffect(function() {
    if (mergedContainerWidth && mergedRestWidth && mergedData) {
      var totalWidth = suffixWidth;
      var len2 = mergedData.length;
      var lastIndex = len2 - 1;
      if (!len2) {
        updateDisplayCount(0);
        setSuffixFixedStart(null);
        return;
      }
      for (var i = 0; i < len2; i += 1) {
        var currentItemWidth = getItemWidth(i);
        if (currentItemWidth === void 0) {
          updateDisplayCount(i - 1, true);
          break;
        }
        totalWidth += currentItemWidth;
        if (lastIndex === 0 && totalWidth <= mergedContainerWidth || i === lastIndex - 1 && totalWidth + getItemWidth(lastIndex) <= mergedContainerWidth) {
          updateDisplayCount(lastIndex);
          setSuffixFixedStart(null);
          break;
        } else if (totalWidth + mergedRestWidth > mergedContainerWidth) {
          updateDisplayCount(i - 1);
          setSuffixFixedStart(totalWidth - currentItemWidth - suffixWidth + restWidth);
          break;
        }
      }
      if (suffix && getItemWidth(0) + suffixWidth > mergedContainerWidth) {
        setSuffixFixedStart(null);
      }
    }
  }, [mergedContainerWidth, itemWidths, restWidth, suffixWidth, getKey2, mergedData]);
  var displayRest = restReady && !!omittedItems.length;
  var suffixStyle = {};
  if (suffixFixedStart !== null && isResponsive) {
    suffixStyle = {
      position: "absolute",
      left: suffixFixedStart,
      top: 0
    };
  }
  var itemSharedProps = {
    prefixCls: itemPrefixCls,
    responsive: isResponsive,
    component: itemComponent,
    invalidate
  };
  var internalRenderItemNode = renderRawItem ? function(item, index2) {
    var key = getKey2(item, index2);
    return /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
      key,
      value: _objectSpread2$3(_objectSpread2$3({}, itemSharedProps), {}, {
        order: index2,
        item,
        itemKey: key,
        registerSize,
        display: index2 <= mergedDisplayCount
      })
    }, renderRawItem(item, index2));
  } : function(item, index2) {
    var key = getKey2(item, index2);
    return /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, {
      order: index2,
      key,
      item,
      renderItem: mergedRenderItem,
      itemKey: key,
      registerSize,
      display: index2 <= mergedDisplayCount
    }));
  };
  var restNode;
  var restContextProps = {
    order: displayRest ? mergedDisplayCount : Number.MAX_SAFE_INTEGER,
    className: "".concat(itemPrefixCls, "-rest"),
    registerSize: registerOverflowSize,
    display: displayRest
  };
  if (!renderRawRest) {
    var mergedRenderRest = renderRest || defaultRenderRest;
    restNode = /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, restContextProps), typeof mergedRenderRest === "function" ? mergedRenderRest(omittedItems) : mergedRenderRest);
  } else if (renderRawRest) {
    restNode = /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
      value: _objectSpread2$3(_objectSpread2$3({}, itemSharedProps), restContextProps)
    }, renderRawRest(omittedItems));
  }
  var overflowNode = /* @__PURE__ */ React.createElement(Component2, _extends$1({
    className: classNames(!invalidate && prefixCls, className),
    style: style2,
    ref: ref2
  }, restProps), mergedData.map(internalRenderItemNode), showRest ? restNode : null, suffix && /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, {
    order: mergedDisplayCount,
    className: "".concat(itemPrefixCls, "-suffix"),
    registerSize: registerSuffixSize,
    display: true,
    style: suffixStyle
  }), suffix));
  if (isResponsive) {
    overflowNode = /* @__PURE__ */ React.createElement(ResizeObserver, {
      onResize: onOverflowResize
    }, overflowNode);
  }
  return overflowNode;
}
var ForwardOverflow = /* @__PURE__ */ React.forwardRef(Overflow);
ForwardOverflow.displayName = "Overflow";
ForwardOverflow.Item = RawItem;
ForwardOverflow.RESPONSIVE = RESPONSIVE;
ForwardOverflow.INVALIDATE = INVALIDATE;
var DownOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z" } }] }, "name": "down", "theme": "outlined" };
var DownOutlinedSvg = DownOutlined$2;
var DownOutlined = function DownOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: DownOutlinedSvg
  }));
};
DownOutlined.displayName = "DownOutlined";
var DownOutlined$1 = /* @__PURE__ */ React.forwardRef(DownOutlined);
var tuple = function tuple2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return args;
};
var isValidElement = React.isValidElement;
function replaceElement(element, replacement, props) {
  if (!isValidElement(element))
    return replacement;
  return /* @__PURE__ */ React.cloneElement(element, typeof props === "function" ? props(element.props || {}) : props);
}
function cloneElement(element, props) {
  return replaceElement(element, element, props);
}
function getDataOrAriaProps(props) {
  return Object.keys(props).reduce(function(prev, key) {
    if ((key.substr(0, 5) === "data-" || key.substr(0, 5) === "aria-" || key === "role") && key.substr(0, 7) !== "data-__") {
      prev[key] = props[key];
    }
    return prev;
  }, {});
}
var responsiveArray = ["xxl", "xl", "lg", "md", "sm", "xs"];
var responsiveMap = {
  xs: "(max-width: 575px)",
  sm: "(min-width: 576px)",
  md: "(min-width: 768px)",
  lg: "(min-width: 992px)",
  xl: "(min-width: 1200px)",
  xxl: "(min-width: 1600px)"
};
var subscribers = /* @__PURE__ */ new Map();
var subUid = -1;
var screens = {};
var responsiveObserve = {
  matchHandlers: {},
  dispatch: function dispatch(pointMap) {
    screens = pointMap;
    subscribers.forEach(function(func) {
      return func(screens);
    });
    return subscribers.size >= 1;
  },
  subscribe: function subscribe(func) {
    if (!subscribers.size)
      this.register();
    subUid += 1;
    subscribers.set(subUid, func);
    func(screens);
    return subUid;
  },
  unsubscribe: function unsubscribe(token) {
    subscribers["delete"](token);
    if (!subscribers.size)
      this.unregister();
  },
  unregister: function unregister2() {
    var _this = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var handler = _this.matchHandlers[matchMediaQuery];
      handler === null || handler === void 0 ? void 0 : handler.mql.removeListener(handler === null || handler === void 0 ? void 0 : handler.listener);
    });
    subscribers.clear();
  },
  register: function register3() {
    var _this2 = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var listener = function listener2(_ref) {
        var matches = _ref.matches;
        _this2.dispatch(_extends$1(_extends$1({}, screens), _defineProperty$3({}, screen, matches)));
      };
      var mql = window.matchMedia(matchMediaQuery);
      mql.addListener(listener);
      _this2.matchHandlers[matchMediaQuery] = {
        mql,
        listener
      };
      listener(mql);
    });
  }
};
var ResponsiveObserve = responsiveObserve;
function useForceUpdate() {
  var _React$useReducer = React.useReducer(function(x2) {
    return x2 + 1;
  }, 0), _React$useReducer2 = _slicedToArray$1(_React$useReducer, 2), forceUpdate = _React$useReducer2[1];
  return forceUpdate;
}
var autoAdjustOverflow$1 = {
  adjustX: 1,
  adjustY: 1
};
var targetOffset = [0, 0];
var placements$1 = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  topCenter: {
    points: ["bc", "tc"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  topRight: {
    points: ["br", "tr"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  },
  bottomCenter: {
    points: ["tc", "bc"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  },
  bottomRight: {
    points: ["tr", "br"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  }
};
var ESC$1 = KeyCode.ESC, TAB = KeyCode.TAB;
function useAccessibility$1(_ref) {
  var visible = _ref.visible, setTriggerVisible = _ref.setTriggerVisible, triggerRef = _ref.triggerRef, menuRef = _ref.menuRef, menuClassName = _ref.menuClassName, onVisibleChange = _ref.onVisibleChange;
  var handleCloseMenuAndReturnFocus = function handleCloseMenuAndReturnFocus2() {
    if (visible && triggerRef.current) {
      if (triggerRef.current.triggerRef.current) {
        triggerRef.current.triggerRef.current.focus();
      }
      setTriggerVisible(false);
      if (typeof onVisibleChange === "function") {
        onVisibleChange(false);
      }
    }
  };
  var handleKeyDown = function handleKeyDown2(event) {
    switch (event.keyCode) {
      case ESC$1:
        handleCloseMenuAndReturnFocus();
        break;
      case TAB:
        handleCloseMenuAndReturnFocus();
        break;
    }
  };
  var focusOpenedMenu = function focusOpenedMenu2() {
    if (menuRef.current) {
      var _menuRef$current$clas, _menuRef$current$quer, _menuRef$current;
      var menuList = ((_menuRef$current$clas = menuRef.current.className) === null || _menuRef$current$clas === void 0 ? void 0 : _menuRef$current$clas.includes(menuClassName)) ? menuRef.current : (_menuRef$current$quer = (_menuRef$current = menuRef.current).querySelector) === null || _menuRef$current$quer === void 0 ? void 0 : _menuRef$current$quer.call(_menuRef$current, menuClassName);
      if (menuList) {
        menuList["focus"]();
      }
    }
  };
  React.useEffect(function() {
    if (visible) {
      setTimeout(function() {
        focusOpenedMenu();
        window.addEventListener("keydown", handleKeyDown);
      }, 100);
      return function() {
        window.removeEventListener("keydown", handleKeyDown);
      };
    }
    return function() {
      return null;
    };
  }, [visible]);
  var returnFocus = function returnFocus2() {
    if (visible && triggerRef.current) {
      if (triggerRef.current.triggerRef.current) {
        setTimeout(function() {
          var _triggerRef$current, _triggerRef$current$t, _triggerRef$current$t2;
          (_triggerRef$current = triggerRef.current) === null || _triggerRef$current === void 0 ? void 0 : (_triggerRef$current$t = _triggerRef$current.triggerRef) === null || _triggerRef$current$t === void 0 ? void 0 : (_triggerRef$current$t2 = _triggerRef$current$t.current) === null || _triggerRef$current$t2 === void 0 ? void 0 : _triggerRef$current$t2.focus();
        }, 100);
      }
    }
  };
  return {
    returnFocus
  };
}
var _excluded$b = ["arrow", "prefixCls", "transitionName", "animation", "align", "placement", "placements", "getPopupContainer", "showAction", "hideAction", "overlayClassName", "overlayStyle", "visible", "trigger"];
function Dropdown(props, ref2) {
  var _props$arrow = props.arrow, arrow = _props$arrow === void 0 ? false : _props$arrow, _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-dropdown" : _props$prefixCls, transitionName = props.transitionName, animation = props.animation, align = props.align, _props$placement = props.placement, placement = _props$placement === void 0 ? "bottomLeft" : _props$placement, _props$placements = props.placements, placements2 = _props$placements === void 0 ? placements$1 : _props$placements, getPopupContainer = props.getPopupContainer, showAction = props.showAction, hideAction = props.hideAction, overlayClassName = props.overlayClassName, overlayStyle = props.overlayStyle, visible = props.visible, _props$trigger = props.trigger, trigger2 = _props$trigger === void 0 ? ["hover"] : _props$trigger, otherProps = _objectWithoutProperties$1(props, _excluded$b);
  var _React$useState = React.useState(), _React$useState2 = _slicedToArray$1(_React$useState, 2), triggerVisible = _React$useState2[0], setTriggerVisible = _React$useState2[1];
  var mergedVisible = "visible" in props ? visible : triggerVisible;
  var triggerRef = React.useRef(null);
  React.useImperativeHandle(ref2, function() {
    return triggerRef.current;
  });
  var menuRef = React.useRef(null);
  var menuClassName = "".concat(prefixCls, "-menu");
  var _useAccessibility = useAccessibility$1({
    visible: mergedVisible,
    setTriggerVisible,
    triggerRef,
    menuRef,
    menuClassName,
    onVisibleChange: props.onVisibleChange
  }), returnFocus = _useAccessibility.returnFocus;
  var getOverlayElement = function getOverlayElement2() {
    var overlay = props.overlay;
    var overlayElement;
    if (typeof overlay === "function") {
      overlayElement = overlay();
    } else {
      overlayElement = overlay;
    }
    return overlayElement;
  };
  var onClick = function onClick2(e2) {
    var onOverlayClick = props.onOverlayClick;
    var overlayProps = getOverlayElement().props;
    setTriggerVisible(false);
    if (onOverlayClick) {
      onOverlayClick(e2);
    }
    if (overlayProps.onClick) {
      overlayProps.onClick(e2);
    }
    returnFocus();
  };
  var onVisibleChange = function onVisibleChange2(newVisible) {
    var onVisibleChangeProp = props.onVisibleChange;
    setTriggerVisible(newVisible);
    if (typeof onVisibleChangeProp === "function") {
      onVisibleChangeProp(newVisible);
    }
  };
  var getMenuElement = function getMenuElement2() {
    var overlayElement = getOverlayElement();
    var extraOverlayProps = {
      prefixCls: menuClassName,
      onClick,
      ref: supportRef(overlayElement) ? menuRef : void 0
    };
    if (typeof overlayElement.type === "string") {
      delete extraOverlayProps.prefixCls;
    }
    return /* @__PURE__ */ React.createElement(React.Fragment, null, arrow && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-arrow")
    }), /* @__PURE__ */ React.cloneElement(overlayElement, extraOverlayProps));
  };
  var getMenuElementOrLambda = function getMenuElementOrLambda2() {
    var overlay = props.overlay;
    if (typeof overlay === "function") {
      return getMenuElement;
    }
    return getMenuElement();
  };
  var getMinOverlayWidthMatchTrigger = function getMinOverlayWidthMatchTrigger2() {
    var minOverlayWidthMatchTrigger = props.minOverlayWidthMatchTrigger, alignPoint2 = props.alignPoint;
    if ("minOverlayWidthMatchTrigger" in props) {
      return minOverlayWidthMatchTrigger;
    }
    return !alignPoint2;
  };
  var getOpenClassName = function getOpenClassName2() {
    var openClassName = props.openClassName;
    if (openClassName !== void 0) {
      return openClassName;
    }
    return "".concat(prefixCls, "-open");
  };
  var renderChildren = function renderChildren2() {
    var children = props.children;
    var childrenProps = children.props ? children.props : {};
    var childClassName = classNames(childrenProps.className, getOpenClassName());
    return mergedVisible && children ? /* @__PURE__ */ React.cloneElement(children, {
      className: childClassName
    }) : children;
  };
  var triggerHideAction = hideAction;
  if (!triggerHideAction && trigger2.indexOf("contextMenu") !== -1) {
    triggerHideAction = ["click"];
  }
  return /* @__PURE__ */ React.createElement(Trigger, _objectSpread2$3(_objectSpread2$3({
    builtinPlacements: placements2
  }, otherProps), {}, {
    prefixCls,
    ref: triggerRef,
    popupClassName: classNames(overlayClassName, _defineProperty$3({}, "".concat(prefixCls, "-show-arrow"), arrow)),
    popupStyle: overlayStyle,
    action: trigger2,
    showAction,
    hideAction: triggerHideAction || [],
    popupPlacement: placement,
    popupAlign: align,
    popupTransitionName: transitionName,
    popupAnimation: animation,
    popupVisible: mergedVisible,
    stretch: getMinOverlayWidthMatchTrigger() ? "minWidth" : "",
    popup: getMenuElementOrLambda(),
    onPopupVisibleChange: onVisibleChange,
    getPopupContainer
  }), renderChildren());
}
var Dropdown$1 = /* @__PURE__ */ React.forwardRef(Dropdown);
var RightOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M765.7 486.8L314.9 134.7A7.97 7.97 0 00302 141v77.3c0 4.9 2.3 9.6 6.1 12.6l360 281.1-360 281.1c-3.9 3-6.1 7.7-6.1 12.6V883c0 6.7 7.7 10.4 12.9 6.3l450.8-352.1a31.96 31.96 0 000-50.4z" } }] }, "name": "right", "theme": "outlined" };
var RightOutlinedSvg = RightOutlined$2;
var RightOutlined = function RightOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: RightOutlinedSvg
  }));
};
RightOutlined.displayName = "RightOutlined";
var RightOutlined$1 = /* @__PURE__ */ React.forwardRef(RightOutlined);
var EllipsisOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M176 511a56 56 0 10112 0 56 56 0 10-112 0zm280 0a56 56 0 10112 0 56 56 0 10-112 0zm280 0a56 56 0 10112 0 56 56 0 10-112 0z" } }] }, "name": "ellipsis", "theme": "outlined" };
var EllipsisOutlinedSvg = EllipsisOutlined$2;
var EllipsisOutlined = function EllipsisOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: EllipsisOutlinedSvg
  }));
};
EllipsisOutlined.displayName = "EllipsisOutlined";
var EllipsisOutlined$1 = /* @__PURE__ */ React.forwardRef(EllipsisOutlined);
var UnreachableException = /* @__PURE__ */ _createClass(function UnreachableException2(value) {
  _classCallCheck(this, UnreachableException2);
  this.error = new Error("unreachable case: ".concat(JSON.stringify(value)));
});
var __rest$a = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var ButtonGroup = function ButtonGroup2(props) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var _classNames;
    var getPrefixCls = _ref.getPrefixCls, direction = _ref.direction;
    var customizePrefixCls = props.prefixCls, size = props.size, className = props.className, others = __rest$a(props, ["prefixCls", "size", "className"]);
    var prefixCls = getPrefixCls("btn-group", customizePrefixCls);
    var sizeCls = "";
    switch (size) {
      case "large":
        sizeCls = "lg";
        break;
      case "small":
        sizeCls = "sm";
        break;
      case "middle":
      case void 0:
        break;
      default:
        console.warn(new UnreachableException(size).error);
    }
    var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(sizeCls), sizeCls), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
    return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
      className: classes
    }));
  });
};
var Group$1 = ButtonGroup;
var id = 0;
var ids = {};
function wrapperRaf(callback) {
  var delayFrames = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var myId = id++;
  var restFrames = delayFrames;
  function internalCallback() {
    restFrames -= 1;
    if (restFrames <= 0) {
      callback();
      delete ids[myId];
    } else {
      ids[myId] = wrapperRaf$1(internalCallback);
    }
  }
  ids[myId] = wrapperRaf$1(internalCallback);
  return myId;
}
wrapperRaf.cancel = function cancel(pid) {
  if (pid === void 0)
    return;
  wrapperRaf$1.cancel(ids[pid]);
  delete ids[pid];
};
wrapperRaf.ids = ids;
var styleForPseudo;
function isHidden(element) {
  return !element || element.offsetParent === null || element.hidden;
}
function isNotGrey(color) {
  var match = (color || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
  if (match && match[1] && match[2] && match[3]) {
    return !(match[1] === match[2] && match[2] === match[3]);
  }
  return true;
}
var Wave = /* @__PURE__ */ function(_React$Component) {
  _inherits(Wave2, _React$Component);
  var _super = _createSuper(Wave2);
  function Wave2() {
    var _this;
    _classCallCheck(this, Wave2);
    _this = _super.apply(this, arguments);
    _this.containerRef = /* @__PURE__ */ React.createRef();
    _this.animationStart = false;
    _this.destroyed = false;
    _this.onClick = function(node, waveColor) {
      var _a2, _b2;
      var _this$props = _this.props, insertExtraNode = _this$props.insertExtraNode, disabled = _this$props.disabled;
      if (disabled || !node || isHidden(node) || node.className.indexOf("-leave") >= 0) {
        return;
      }
      _this.extraNode = document.createElement("div");
      var _assertThisInitialize = _assertThisInitialized(_this), extraNode = _assertThisInitialize.extraNode;
      var getPrefixCls = _this.context.getPrefixCls;
      extraNode.className = "".concat(getPrefixCls(""), "-click-animating-node");
      var attributeName = _this.getAttributeName();
      node.setAttribute(attributeName, "true");
      if (waveColor && waveColor !== "#ffffff" && waveColor !== "rgb(255, 255, 255)" && isNotGrey(waveColor) && !/rgba\((?:\d*, ){3}0\)/.test(waveColor) && waveColor !== "transparent") {
        extraNode.style.borderColor = waveColor;
        var nodeRoot = ((_a2 = node.getRootNode) === null || _a2 === void 0 ? void 0 : _a2.call(node)) || node.ownerDocument;
        var nodeBody = nodeRoot instanceof Document ? nodeRoot.body : (_b2 = nodeRoot.firstChild) !== null && _b2 !== void 0 ? _b2 : nodeRoot;
        styleForPseudo = updateCSS("\n      [".concat(getPrefixCls(""), "-click-animating-without-extra-node='true']::after, .").concat(getPrefixCls(""), "-click-animating-node {\n        --antd-wave-shadow-color: ").concat(waveColor, ";\n      }"), "antd-wave", {
          csp: _this.csp,
          attachTo: nodeBody
        });
      }
      if (insertExtraNode) {
        node.appendChild(extraNode);
      }
      ["transition", "animation"].forEach(function(name2) {
        node.addEventListener("".concat(name2, "start"), _this.onTransitionStart);
        node.addEventListener("".concat(name2, "end"), _this.onTransitionEnd);
      });
    };
    _this.onTransitionStart = function(e2) {
      if (_this.destroyed) {
        return;
      }
      var node = _this.containerRef.current;
      if (!e2 || e2.target !== node || _this.animationStart) {
        return;
      }
      _this.resetEffect(node);
    };
    _this.onTransitionEnd = function(e2) {
      if (!e2 || e2.animationName !== "fadeEffect") {
        return;
      }
      _this.resetEffect(e2.target);
    };
    _this.bindAnimationEvent = function(node) {
      if (!node || !node.getAttribute || node.getAttribute("disabled") || node.className.indexOf("disabled") >= 0) {
        return;
      }
      var onClick = function onClick2(e2) {
        if (e2.target.tagName === "INPUT" || isHidden(e2.target)) {
          return;
        }
        _this.resetEffect(node);
        var waveColor = getComputedStyle(node).getPropertyValue("border-top-color") || getComputedStyle(node).getPropertyValue("border-color") || getComputedStyle(node).getPropertyValue("background-color");
        _this.clickWaveTimeoutId = window.setTimeout(function() {
          return _this.onClick(node, waveColor);
        }, 0);
        wrapperRaf.cancel(_this.animationStartId);
        _this.animationStart = true;
        _this.animationStartId = wrapperRaf(function() {
          _this.animationStart = false;
        }, 10);
      };
      node.addEventListener("click", onClick, true);
      return {
        cancel: function cancel2() {
          node.removeEventListener("click", onClick, true);
        }
      };
    };
    _this.renderWave = function(_ref) {
      var csp = _ref.csp;
      var children = _this.props.children;
      _this.csp = csp;
      if (!/* @__PURE__ */ React.isValidElement(children))
        return children;
      var ref2 = _this.containerRef;
      if (supportRef(children)) {
        ref2 = composeRef(children.ref, _this.containerRef);
      }
      return cloneElement(children, {
        ref: ref2
      });
    };
    return _this;
  }
  _createClass(Wave2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.containerRef.current;
      if (!node || node.nodeType !== 1) {
        return;
      }
      this.instance = this.bindAnimationEvent(node);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.instance) {
        this.instance.cancel();
      }
      if (this.clickWaveTimeoutId) {
        clearTimeout(this.clickWaveTimeoutId);
      }
      this.destroyed = true;
    }
  }, {
    key: "getAttributeName",
    value: function getAttributeName() {
      var getPrefixCls = this.context.getPrefixCls;
      var insertExtraNode = this.props.insertExtraNode;
      return insertExtraNode ? "".concat(getPrefixCls(""), "-click-animating") : "".concat(getPrefixCls(""), "-click-animating-without-extra-node");
    }
  }, {
    key: "resetEffect",
    value: function resetEffect(node) {
      var _this2 = this;
      if (!node || node === this.extraNode || !(node instanceof Element)) {
        return;
      }
      var insertExtraNode = this.props.insertExtraNode;
      var attributeName = this.getAttributeName();
      node.setAttribute(attributeName, "false");
      if (styleForPseudo) {
        styleForPseudo.innerHTML = "";
      }
      if (insertExtraNode && this.extraNode && node.contains(this.extraNode)) {
        node.removeChild(this.extraNode);
      }
      ["transition", "animation"].forEach(function(name2) {
        node.removeEventListener("".concat(name2, "start"), _this2.onTransitionStart);
        node.removeEventListener("".concat(name2, "end"), _this2.onTransitionEnd);
      });
    }
  }, {
    key: "render",
    value: function render2() {
      return /* @__PURE__ */ React.createElement(ConfigConsumer, null, this.renderWave);
    }
  }]);
  return Wave2;
}(React.Component);
Wave.contextType = ConfigContext;
var getCollapsedWidth = function getCollapsedWidth2() {
  return {
    width: 0,
    opacity: 0,
    transform: "scale(0)"
  };
};
var getRealWidth = function getRealWidth2(node) {
  return {
    width: node.scrollWidth,
    opacity: 1,
    transform: "scale(1)"
  };
};
var LoadingIcon = function LoadingIcon2(_ref) {
  var prefixCls = _ref.prefixCls, loading = _ref.loading, existIcon = _ref.existIcon;
  var visible = !!loading;
  if (existIcon) {
    return /* @__PURE__ */ React__default.createElement("span", {
      className: "".concat(prefixCls, "-loading-icon")
    }, /* @__PURE__ */ React__default.createElement(LoadingOutlined$1, null));
  }
  return /* @__PURE__ */ React__default.createElement(CSSMotion, {
    visible,
    motionName: "".concat(prefixCls, "-loading-icon-motion"),
    removeOnLeave: true,
    onAppearStart: getCollapsedWidth,
    onAppearActive: getRealWidth,
    onEnterStart: getCollapsedWidth,
    onEnterActive: getRealWidth,
    onLeaveStart: getRealWidth,
    onLeaveActive: getCollapsedWidth
  }, function(_ref2, ref2) {
    var className = _ref2.className, style2 = _ref2.style;
    return /* @__PURE__ */ React__default.createElement("span", {
      className: "".concat(prefixCls, "-loading-icon"),
      style: style2,
      ref: ref2
    }, /* @__PURE__ */ React__default.createElement(LoadingOutlined$1, {
      className
    }));
  });
};
var LoadingIcon$1 = LoadingIcon;
var __rest$9 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var rxTwoCNChar = /^[\u4e00-\u9fa5]{2}$/;
var isTwoCNChar = rxTwoCNChar.test.bind(rxTwoCNChar);
function isString(str) {
  return typeof str === "string";
}
function isUnborderedButtonType(type4) {
  return type4 === "text" || type4 === "link";
}
function isReactFragment(node) {
  return /* @__PURE__ */ React.isValidElement(node) && node.type === React.Fragment;
}
function insertSpace(child, needInserted) {
  if (child == null) {
    return;
  }
  var SPACE = needInserted ? " " : "";
  if (typeof child !== "string" && typeof child !== "number" && isString(child.type) && isTwoCNChar(child.props.children)) {
    return cloneElement(child, {
      children: child.props.children.split("").join(SPACE)
    });
  }
  if (typeof child === "string") {
    return isTwoCNChar(child) ? /* @__PURE__ */ React.createElement("span", null, child.split("").join(SPACE)) : /* @__PURE__ */ React.createElement("span", null, child);
  }
  if (isReactFragment(child)) {
    return /* @__PURE__ */ React.createElement("span", null, child);
  }
  return child;
}
function spaceChildren(children, needInserted) {
  var isPrevChildPure = false;
  var childList = [];
  React.Children.forEach(children, function(child) {
    var type4 = _typeof$1(child);
    var isCurrentChildPure = type4 === "string" || type4 === "number";
    if (isPrevChildPure && isCurrentChildPure) {
      var lastIndex = childList.length - 1;
      var lastChild = childList[lastIndex];
      childList[lastIndex] = "".concat(lastChild).concat(child);
    } else {
      childList.push(child);
    }
    isPrevChildPure = isCurrentChildPure;
  });
  return React.Children.map(childList, function(child) {
    return insertSpace(child, needInserted);
  });
}
tuple("default", "primary", "ghost", "dashed", "link", "text");
tuple("default", "circle", "round");
tuple("submit", "button", "reset");
var InternalButton = function InternalButton2(props, ref2) {
  var _classNames;
  var _props$loading = props.loading, loading = _props$loading === void 0 ? false : _props$loading, customizePrefixCls = props.prefixCls, _props$type = props.type, type4 = _props$type === void 0 ? "default" : _props$type, danger = props.danger, _props$shape = props.shape, shape = _props$shape === void 0 ? "default" : _props$shape, customizeSize = props.size, className = props.className, children = props.children, icon = props.icon, _props$ghost = props.ghost, ghost = _props$ghost === void 0 ? false : _props$ghost, _props$block = props.block, block = _props$block === void 0 ? false : _props$block, _props$htmlType = props.htmlType, htmlType = _props$htmlType === void 0 ? "button" : _props$htmlType, rest = __rest$9(props, ["loading", "prefixCls", "type", "danger", "shape", "size", "className", "children", "icon", "ghost", "block", "htmlType"]);
  var size = React.useContext(SizeContext$1);
  var _React$useState = React.useState(!!loading), _React$useState2 = _slicedToArray$1(_React$useState, 2), innerLoading = _React$useState2[0], setLoading = _React$useState2[1];
  var _React$useState3 = React.useState(false), _React$useState4 = _slicedToArray$1(_React$useState3, 2), hasTwoCNChar = _React$useState4[0], setHasTwoCNChar = _React$useState4[1];
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, autoInsertSpaceInButton = _React$useContext.autoInsertSpaceInButton, direction = _React$useContext.direction;
  var buttonRef = ref2 || /* @__PURE__ */ React.createRef();
  var isNeedInserted = function isNeedInserted2() {
    return React.Children.count(children) === 1 && !icon && !isUnborderedButtonType(type4);
  };
  var fixTwoCNChar = function fixTwoCNChar2() {
    if (!buttonRef || !buttonRef.current || autoInsertSpaceInButton === false) {
      return;
    }
    var buttonText = buttonRef.current.textContent;
    if (isNeedInserted() && isTwoCNChar(buttonText)) {
      if (!hasTwoCNChar) {
        setHasTwoCNChar(true);
      }
    } else if (hasTwoCNChar) {
      setHasTwoCNChar(false);
    }
  };
  var loadingOrDelay = _typeof$1(loading) === "object" && loading.delay ? loading.delay || true : !!loading;
  React.useEffect(function() {
    var delayTimer = null;
    if (typeof loadingOrDelay === "number") {
      delayTimer = window.setTimeout(function() {
        delayTimer = null;
        setLoading(loadingOrDelay);
      }, loadingOrDelay);
    } else {
      setLoading(loadingOrDelay);
    }
    return function() {
      if (delayTimer) {
        window.clearTimeout(delayTimer);
        delayTimer = null;
      }
    };
  }, [loadingOrDelay]);
  React.useEffect(fixTwoCNChar, [buttonRef]);
  var handleClick = function handleClick2(e2) {
    var onClick = props.onClick, disabled = props.disabled;
    if (innerLoading || disabled) {
      e2.preventDefault();
      return;
    }
    onClick === null || onClick === void 0 ? void 0 : onClick(e2);
  };
  devWarning(!(typeof icon === "string" && icon.length > 2), "Button", "`icon` is using ReactNode instead of string naming in v4. Please check `".concat(icon, "` at https://ant.design/components/icon"));
  devWarning(!(ghost && isUnborderedButtonType(type4)), "Button", "`link` or `text` button can't be a `ghost` button.");
  var prefixCls = getPrefixCls("btn", customizePrefixCls);
  var autoInsertSpace = autoInsertSpaceInButton !== false;
  var sizeClassNameMap = {
    large: "lg",
    small: "sm",
    middle: void 0
  };
  var sizeFullname = customizeSize || size;
  var sizeCls = sizeFullname ? sizeClassNameMap[sizeFullname] || "" : "";
  var iconType = innerLoading ? "loading" : icon;
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(shape), shape !== "default" && shape), _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(type4), type4), _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(sizeCls), sizeCls), _defineProperty$3(_classNames, "".concat(prefixCls, "-icon-only"), !children && children !== 0 && !!iconType), _defineProperty$3(_classNames, "".concat(prefixCls, "-background-ghost"), ghost && !isUnborderedButtonType(type4)), _defineProperty$3(_classNames, "".concat(prefixCls, "-loading"), innerLoading), _defineProperty$3(_classNames, "".concat(prefixCls, "-two-chinese-chars"), hasTwoCNChar && autoInsertSpace), _defineProperty$3(_classNames, "".concat(prefixCls, "-block"), block), _defineProperty$3(_classNames, "".concat(prefixCls, "-dangerous"), !!danger), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var iconNode = icon && !innerLoading ? icon : /* @__PURE__ */ React.createElement(LoadingIcon$1, {
    existIcon: !!icon,
    prefixCls,
    loading: !!innerLoading
  });
  var kids = children || children === 0 ? spaceChildren(children, isNeedInserted() && autoInsertSpace) : null;
  var linkButtonRestProps = omit(rest, ["navigate"]);
  if (linkButtonRestProps.href !== void 0) {
    return /* @__PURE__ */ React.createElement("a", _extends$1({}, linkButtonRestProps, {
      className: classes,
      onClick: handleClick,
      ref: buttonRef
    }), iconNode, kids);
  }
  var buttonNode = /* @__PURE__ */ React.createElement("button", _extends$1({}, rest, {
    type: htmlType,
    className: classes,
    onClick: handleClick,
    ref: buttonRef
  }), iconNode, kids);
  if (isUnborderedButtonType(type4)) {
    return buttonNode;
  }
  return /* @__PURE__ */ React.createElement(Wave, {
    disabled: !!innerLoading
  }, buttonNode);
};
var Button$1 = /* @__PURE__ */ React.forwardRef(InternalButton);
Button$1.displayName = "Button";
Button$1.Group = Group$1;
Button$1.__ANT_BUTTON = true;
var Button$2 = Button$1;
var shallowequal = function shallowEqual(objA, objB, compare2, compareContext) {
  var ret = compare2 ? compare2.call(compareContext, objA, objB) : void 0;
  if (ret !== void 0) {
    return !!ret;
  }
  if (objA === objB) {
    return true;
  }
  if (typeof objA !== "object" || !objA || typeof objB !== "object" || !objB) {
    return false;
  }
  var keysA = Object.keys(objA);
  var keysB = Object.keys(objB);
  if (keysA.length !== keysB.length) {
    return false;
  }
  var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);
  for (var idx = 0; idx < keysA.length; idx++) {
    var key = keysA[idx];
    if (!bHasOwnProperty(key)) {
      return false;
    }
    var valueA = objA[key];
    var valueB = objB[key];
    ret = compare2 ? compare2.call(compareContext, valueA, valueB, key) : void 0;
    if (ret === false || ret === void 0 && valueA !== valueB) {
      return false;
    }
  }
  return true;
};
var _excluded$a = ["children", "locked"];
var MenuContext = /* @__PURE__ */ React.createContext(null);
function mergeProps(origin, target) {
  var clone3 = _objectSpread2$3({}, origin);
  Object.keys(target).forEach(function(key) {
    var value = target[key];
    if (value !== void 0) {
      clone3[key] = value;
    }
  });
  return clone3;
}
function InheritableContextProvider(_ref) {
  var children = _ref.children, locked = _ref.locked, restProps = _objectWithoutProperties$1(_ref, _excluded$a);
  var context = React.useContext(MenuContext);
  var inheritableContext = useMemo(function() {
    return mergeProps(context, restProps);
  }, [context, restProps], function(prev, next) {
    return !locked && (prev[0] !== next[0] || !shallowequal(prev[1], next[1]));
  });
  return /* @__PURE__ */ React.createElement(MenuContext.Provider, {
    value: inheritableContext
  }, children);
}
function useActive(eventKey, disabled, onMouseEnter, onMouseLeave) {
  var _React$useContext = React.useContext(MenuContext), activeKey = _React$useContext.activeKey, onActive = _React$useContext.onActive, onInactive = _React$useContext.onInactive;
  var ret = {
    active: activeKey === eventKey
  };
  if (!disabled) {
    ret.onMouseEnter = function(domEvent) {
      onMouseEnter === null || onMouseEnter === void 0 ? void 0 : onMouseEnter({
        key: eventKey,
        domEvent
      });
      onActive(eventKey);
    };
    ret.onMouseLeave = function(domEvent) {
      onMouseLeave === null || onMouseLeave === void 0 ? void 0 : onMouseLeave({
        key: eventKey,
        domEvent
      });
      onInactive(eventKey);
    };
  }
  return ret;
}
var _excluded$9 = ["item"];
function warnItemProp(_ref) {
  var item = _ref.item, restInfo = _objectWithoutProperties$1(_ref, _excluded$9);
  Object.defineProperty(restInfo, "item", {
    get: function get2() {
      warningOnce(false, "`info.item` is deprecated since we will move to function component that not provides React Node instance in future.");
      return item;
    }
  });
  return restInfo;
}
function Icon$2(_ref) {
  var icon = _ref.icon, props = _ref.props, children = _ref.children;
  var iconNode;
  if (typeof icon === "function") {
    iconNode = /* @__PURE__ */ React.createElement(icon, _objectSpread2$3({}, props));
  } else {
    iconNode = icon;
  }
  return iconNode || children || null;
}
function useDirectionStyle(level) {
  var _React$useContext = React.useContext(MenuContext), mode = _React$useContext.mode, rtl = _React$useContext.rtl, inlineIndent = _React$useContext.inlineIndent;
  if (mode !== "inline") {
    return null;
  }
  var len2 = level;
  return rtl ? {
    paddingRight: len2 * inlineIndent
  } : {
    paddingLeft: len2 * inlineIndent
  };
}
var EmptyList = [];
var PathRegisterContext = /* @__PURE__ */ React.createContext(null);
function useMeasure() {
  return React.useContext(PathRegisterContext);
}
var PathTrackerContext = /* @__PURE__ */ React.createContext(EmptyList);
function useFullPath(eventKey) {
  var parentKeyPath = React.useContext(PathTrackerContext);
  return React.useMemo(function() {
    return eventKey !== void 0 ? [].concat(_toConsumableArray(parentKeyPath), [eventKey]) : parentKeyPath;
  }, [parentKeyPath, eventKey]);
}
var PathUserContext = /* @__PURE__ */ React.createContext(null);
var IdContext = /* @__PURE__ */ React.createContext(null);
function getMenuId(uuid2, eventKey) {
  if (uuid2 === void 0) {
    return null;
  }
  return "".concat(uuid2, "-").concat(eventKey);
}
function useMenuId(eventKey) {
  var id2 = React.useContext(IdContext);
  return getMenuId(id2, eventKey);
}
var PrivateContext = /* @__PURE__ */ React.createContext({});
var _excluded$8 = ["title", "attribute", "elementRef"], _excluded2$3 = ["style", "className", "eventKey", "warnKey", "disabled", "itemIcon", "children", "role", "onMouseEnter", "onMouseLeave", "onClick", "onKeyDown", "onFocus"], _excluded3 = ["active"];
var LegacyMenuItem = /* @__PURE__ */ function(_React$Component) {
  _inherits(LegacyMenuItem2, _React$Component);
  var _super = _createSuper(LegacyMenuItem2);
  function LegacyMenuItem2() {
    _classCallCheck(this, LegacyMenuItem2);
    return _super.apply(this, arguments);
  }
  _createClass(LegacyMenuItem2, [{
    key: "render",
    value: function render2() {
      var _this$props = this.props, title = _this$props.title, attribute = _this$props.attribute, elementRef = _this$props.elementRef, restProps = _objectWithoutProperties$1(_this$props, _excluded$8);
      var passedProps = omit(restProps, ["eventKey"]);
      warningOnce(!attribute, "`attribute` of Menu.Item is deprecated. Please pass attribute directly.");
      return /* @__PURE__ */ React.createElement(ForwardOverflow.Item, _extends$1({}, attribute, {
        title: typeof title === "string" ? title : void 0
      }, passedProps, {
        ref: elementRef
      }));
    }
  }]);
  return LegacyMenuItem2;
}(React.Component);
var InternalMenuItem = function InternalMenuItem2(props) {
  var _classNames;
  var style2 = props.style, className = props.className, eventKey = props.eventKey;
  props.warnKey;
  var disabled = props.disabled, itemIcon = props.itemIcon, children = props.children, role = props.role, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onClick = props.onClick, onKeyDown2 = props.onKeyDown, onFocus2 = props.onFocus, restProps = _objectWithoutProperties$1(props, _excluded2$3);
  var domDataId = useMenuId(eventKey);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, onItemClick = _React$useContext.onItemClick, contextDisabled = _React$useContext.disabled, overflowDisabled = _React$useContext.overflowDisabled, contextItemIcon = _React$useContext.itemIcon, selectedKeys = _React$useContext.selectedKeys, onActive = _React$useContext.onActive;
  var _React$useContext2 = React.useContext(PrivateContext), _internalRenderMenuItem = _React$useContext2._internalRenderMenuItem;
  var itemCls = "".concat(prefixCls, "-item");
  var legacyMenuItemRef = React.useRef();
  var elementRef = React.useRef();
  var mergedDisabled = contextDisabled || disabled;
  var connectedKeys = useFullPath(eventKey);
  var getEventInfo = function getEventInfo2(e2) {
    return {
      key: eventKey,
      keyPath: _toConsumableArray(connectedKeys).reverse(),
      item: legacyMenuItemRef.current,
      domEvent: e2
    };
  };
  var mergedItemIcon = itemIcon || contextItemIcon;
  var _useActive = useActive(eventKey, mergedDisabled, onMouseEnter, onMouseLeave), active = _useActive.active, activeProps = _objectWithoutProperties$1(_useActive, _excluded3);
  var selected = selectedKeys.includes(eventKey);
  var directionStyle = useDirectionStyle(connectedKeys.length);
  var onInternalClick = function onInternalClick2(e2) {
    if (mergedDisabled) {
      return;
    }
    var info = getEventInfo(e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    onItemClick(info);
  };
  var onInternalKeyDown = function onInternalKeyDown2(e2) {
    onKeyDown2 === null || onKeyDown2 === void 0 ? void 0 : onKeyDown2(e2);
    if (e2.which === KeyCode.ENTER) {
      var info = getEventInfo(e2);
      onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
      onItemClick(info);
    }
  };
  var onInternalFocus = function onInternalFocus2(e2) {
    onActive(eventKey);
    onFocus2 === null || onFocus2 === void 0 ? void 0 : onFocus2(e2);
  };
  var optionRoleProps = {};
  if (props.role === "option") {
    optionRoleProps["aria-selected"] = selected;
  }
  var renderNode2 = /* @__PURE__ */ React.createElement(LegacyMenuItem, _extends$1({
    ref: legacyMenuItemRef,
    elementRef,
    role: role === null ? "none" : role || "menuitem",
    tabIndex: disabled ? null : -1,
    "data-menu-id": overflowDisabled && domDataId ? null : domDataId
  }, restProps, activeProps, optionRoleProps, {
    component: "li",
    "aria-disabled": disabled,
    style: _objectSpread2$3(_objectSpread2$3({}, directionStyle), style2),
    className: classNames(itemCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(itemCls, "-active"), active), _defineProperty$3(_classNames, "".concat(itemCls, "-selected"), selected), _defineProperty$3(_classNames, "".concat(itemCls, "-disabled"), mergedDisabled), _classNames), className),
    onClick: onInternalClick,
    onKeyDown: onInternalKeyDown,
    onFocus: onInternalFocus
  }), children, /* @__PURE__ */ React.createElement(Icon$2, {
    props: _objectSpread2$3(_objectSpread2$3({}, props), {}, {
      isSelected: selected
    }),
    icon: mergedItemIcon
  }));
  if (_internalRenderMenuItem) {
    renderNode2 = _internalRenderMenuItem(renderNode2, props);
  }
  return renderNode2;
};
function MenuItem(props) {
  var eventKey = props.eventKey;
  var measure = useMeasure();
  var connectedKeyPath = useFullPath(eventKey);
  React.useEffect(function() {
    if (measure) {
      measure.registerPath(eventKey, connectedKeyPath);
      return function() {
        measure.unregisterPath(eventKey, connectedKeyPath);
      };
    }
  }, [connectedKeyPath]);
  if (measure) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(InternalMenuItem, props);
}
function parseChildren(children, keyPath) {
  return toArray$1(children).map(function(child, index2) {
    if (/* @__PURE__ */ React.isValidElement(child)) {
      var _child$props$eventKey, _child$props;
      var key = child.key;
      var eventKey = (_child$props$eventKey = (_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.eventKey) !== null && _child$props$eventKey !== void 0 ? _child$props$eventKey : key;
      var emptyKey = eventKey === null || eventKey === void 0;
      if (emptyKey) {
        eventKey = "tmp_key-".concat([].concat(_toConsumableArray(keyPath), [index2]).join("-"));
      }
      var cloneProps = {
        key: eventKey,
        eventKey
      };
      return /* @__PURE__ */ React.cloneElement(child, cloneProps);
    }
    return child;
  });
}
function useMemoCallback(func) {
  var funRef = React.useRef(func);
  funRef.current = func;
  var callback = React.useCallback(function() {
    var _funRef$current;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return (_funRef$current = funRef.current) === null || _funRef$current === void 0 ? void 0 : _funRef$current.call.apply(_funRef$current, [funRef].concat(args));
  }, []);
  return func ? callback : void 0;
}
var _excluded$7 = ["className", "children"];
var InternalSubMenuList = function InternalSubMenuList2(_ref, ref2) {
  var className = _ref.className, children = _ref.children, restProps = _objectWithoutProperties$1(_ref, _excluded$7);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, mode = _React$useContext.mode, rtl = _React$useContext.rtl;
  return /* @__PURE__ */ React.createElement("ul", _extends$1({
    className: classNames(prefixCls, rtl && "".concat(prefixCls, "-rtl"), "".concat(prefixCls, "-sub"), "".concat(prefixCls, "-").concat(mode === "inline" ? "inline" : "vertical"), className)
  }, restProps, {
    "data-menu-list": true,
    ref: ref2
  }), children);
};
var SubMenuList = /* @__PURE__ */ React.forwardRef(InternalSubMenuList);
SubMenuList.displayName = "SubMenuList";
var autoAdjustOverflow = {
  adjustX: 1,
  adjustY: 1
};
var placements = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow,
    offset: [0, -7]
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow,
    offset: [0, 7]
  },
  leftTop: {
    points: ["tr", "tl"],
    overflow: autoAdjustOverflow,
    offset: [-4, 0]
  },
  rightTop: {
    points: ["tl", "tr"],
    overflow: autoAdjustOverflow,
    offset: [4, 0]
  }
};
var placementsRtl = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow,
    offset: [0, -7]
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow,
    offset: [0, 7]
  },
  rightTop: {
    points: ["tr", "tl"],
    overflow: autoAdjustOverflow,
    offset: [-4, 0]
  },
  leftTop: {
    points: ["tl", "tr"],
    overflow: autoAdjustOverflow,
    offset: [4, 0]
  }
};
function getMotion(mode, motion, defaultMotions) {
  if (motion) {
    return motion;
  }
  if (defaultMotions) {
    return defaultMotions[mode] || defaultMotions.other;
  }
  return void 0;
}
var popupPlacementMap = {
  horizontal: "bottomLeft",
  vertical: "rightTop",
  "vertical-left": "rightTop",
  "vertical-right": "leftTop"
};
function PopupTrigger(_ref) {
  var prefixCls = _ref.prefixCls, visible = _ref.visible, children = _ref.children, popup = _ref.popup, popupClassName = _ref.popupClassName, popupOffset = _ref.popupOffset, disabled = _ref.disabled, mode = _ref.mode, onVisibleChange = _ref.onVisibleChange;
  var _React$useContext = React.useContext(MenuContext), getPopupContainer = _React$useContext.getPopupContainer, rtl = _React$useContext.rtl, subMenuOpenDelay = _React$useContext.subMenuOpenDelay, subMenuCloseDelay = _React$useContext.subMenuCloseDelay, builtinPlacements = _React$useContext.builtinPlacements, triggerSubMenuAction = _React$useContext.triggerSubMenuAction, forceSubMenuRender = _React$useContext.forceSubMenuRender, motion = _React$useContext.motion, defaultMotions = _React$useContext.defaultMotions;
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray$1(_React$useState, 2), innerVisible = _React$useState2[0], setInnerVisible = _React$useState2[1];
  var placement = rtl ? _objectSpread2$3(_objectSpread2$3({}, placementsRtl), builtinPlacements) : _objectSpread2$3(_objectSpread2$3({}, placements), builtinPlacements);
  var popupPlacement = popupPlacementMap[mode];
  var targetMotion = getMotion(mode, motion, defaultMotions);
  var mergedMotion = _objectSpread2$3(_objectSpread2$3({}, targetMotion), {}, {
    leavedClassName: "".concat(prefixCls, "-hidden"),
    removeOnLeave: false,
    motionAppear: true
  });
  var visibleRef = React.useRef();
  React.useEffect(function() {
    visibleRef.current = wrapperRaf$1(function() {
      setInnerVisible(visible);
    });
    return function() {
      wrapperRaf$1.cancel(visibleRef.current);
    };
  }, [visible]);
  return /* @__PURE__ */ React.createElement(Trigger, {
    prefixCls,
    popupClassName: classNames("".concat(prefixCls, "-popup"), _defineProperty$3({}, "".concat(prefixCls, "-rtl"), rtl), popupClassName),
    stretch: mode === "horizontal" ? "minWidth" : null,
    getPopupContainer,
    builtinPlacements: placement,
    popupPlacement,
    popupVisible: innerVisible,
    popup,
    popupAlign: popupOffset && {
      offset: popupOffset
    },
    action: disabled ? [] : [triggerSubMenuAction],
    mouseEnterDelay: subMenuOpenDelay,
    mouseLeaveDelay: subMenuCloseDelay,
    onPopupVisibleChange: onVisibleChange,
    forceRender: forceSubMenuRender,
    popupMotion: mergedMotion
  }, children);
}
function InlineSubMenuList(_ref) {
  var id2 = _ref.id, open = _ref.open, keyPath = _ref.keyPath, children = _ref.children;
  var fixedMode = "inline";
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, forceSubMenuRender = _React$useContext.forceSubMenuRender, motion = _React$useContext.motion, defaultMotions = _React$useContext.defaultMotions, mode = _React$useContext.mode;
  var sameModeRef = React.useRef(false);
  sameModeRef.current = mode === fixedMode;
  var _React$useState = React.useState(!sameModeRef.current), _React$useState2 = _slicedToArray$1(_React$useState, 2), destroy = _React$useState2[0], setDestroy = _React$useState2[1];
  var mergedOpen = sameModeRef.current ? open : false;
  React.useEffect(function() {
    if (sameModeRef.current) {
      setDestroy(false);
    }
  }, [mode]);
  var mergedMotion = _objectSpread2$3({}, getMotion(fixedMode, motion, defaultMotions));
  if (keyPath.length > 1) {
    mergedMotion.motionAppear = false;
  }
  var originOnVisibleChanged = mergedMotion.onVisibleChanged;
  mergedMotion.onVisibleChanged = function(newVisible) {
    if (!sameModeRef.current && !newVisible) {
      setDestroy(true);
    }
    return originOnVisibleChanged === null || originOnVisibleChanged === void 0 ? void 0 : originOnVisibleChanged(newVisible);
  };
  if (destroy) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    mode: fixedMode,
    locked: !sameModeRef.current
  }, /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible: mergedOpen
  }, mergedMotion, {
    forceRender: forceSubMenuRender,
    removeOnLeave: false,
    leavedClassName: "".concat(prefixCls, "-hidden")
  }), function(_ref2) {
    var motionClassName = _ref2.className, motionStyle = _ref2.style;
    return /* @__PURE__ */ React.createElement(SubMenuList, {
      id: id2,
      className: motionClassName,
      style: motionStyle
    }, children);
  }));
}
var _excluded$6 = ["style", "className", "title", "eventKey", "warnKey", "disabled", "internalPopupClose", "children", "itemIcon", "expandIcon", "popupClassName", "popupOffset", "onClick", "onMouseEnter", "onMouseLeave", "onTitleClick", "onTitleMouseEnter", "onTitleMouseLeave"], _excluded2$2 = ["active"];
var InternalSubMenu = function InternalSubMenu2(props) {
  var _classNames;
  var style2 = props.style, className = props.className, title = props.title, eventKey = props.eventKey;
  props.warnKey;
  var disabled = props.disabled, internalPopupClose = props.internalPopupClose, children = props.children, itemIcon = props.itemIcon, expandIcon = props.expandIcon, popupClassName = props.popupClassName, popupOffset = props.popupOffset, onClick = props.onClick, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onTitleClick = props.onTitleClick, onTitleMouseEnter = props.onTitleMouseEnter, onTitleMouseLeave = props.onTitleMouseLeave, restProps = _objectWithoutProperties$1(props, _excluded$6);
  var domDataId = useMenuId(eventKey);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, mode = _React$useContext.mode, openKeys = _React$useContext.openKeys, contextDisabled = _React$useContext.disabled, overflowDisabled = _React$useContext.overflowDisabled, activeKey = _React$useContext.activeKey, selectedKeys = _React$useContext.selectedKeys, contextItemIcon = _React$useContext.itemIcon, contextExpandIcon = _React$useContext.expandIcon, onItemClick = _React$useContext.onItemClick, onOpenChange = _React$useContext.onOpenChange, onActive = _React$useContext.onActive;
  var _React$useContext2 = React.useContext(PrivateContext), _internalRenderSubMenuItem = _React$useContext2._internalRenderSubMenuItem;
  var _React$useContext3 = React.useContext(PathUserContext), isSubPathKey = _React$useContext3.isSubPathKey;
  var connectedPath = useFullPath();
  var subMenuPrefixCls = "".concat(prefixCls, "-submenu");
  var mergedDisabled = contextDisabled || disabled;
  var elementRef = React.useRef();
  var popupRef = React.useRef();
  var mergedItemIcon = itemIcon || contextItemIcon;
  var mergedExpandIcon = expandIcon || contextExpandIcon;
  var originOpen = openKeys.includes(eventKey);
  var open = !overflowDisabled && originOpen;
  var childrenSelected = isSubPathKey(selectedKeys, eventKey);
  var _useActive = useActive(eventKey, mergedDisabled, onTitleMouseEnter, onTitleMouseLeave), active = _useActive.active, activeProps = _objectWithoutProperties$1(_useActive, _excluded2$2);
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray$1(_React$useState, 2), childrenActive = _React$useState2[0], setChildrenActive = _React$useState2[1];
  var triggerChildrenActive = function triggerChildrenActive2(newActive) {
    if (!mergedDisabled) {
      setChildrenActive(newActive);
    }
  };
  var onInternalMouseEnter = function onInternalMouseEnter2(domEvent) {
    triggerChildrenActive(true);
    onMouseEnter === null || onMouseEnter === void 0 ? void 0 : onMouseEnter({
      key: eventKey,
      domEvent
    });
  };
  var onInternalMouseLeave = function onInternalMouseLeave2(domEvent) {
    triggerChildrenActive(false);
    onMouseLeave === null || onMouseLeave === void 0 ? void 0 : onMouseLeave({
      key: eventKey,
      domEvent
    });
  };
  var mergedActive = React.useMemo(function() {
    if (active) {
      return active;
    }
    if (mode !== "inline") {
      return childrenActive || isSubPathKey([activeKey], eventKey);
    }
    return false;
  }, [mode, active, activeKey, childrenActive, eventKey, isSubPathKey]);
  var directionStyle = useDirectionStyle(connectedPath.length);
  var onInternalTitleClick = function onInternalTitleClick2(e2) {
    if (mergedDisabled) {
      return;
    }
    onTitleClick === null || onTitleClick === void 0 ? void 0 : onTitleClick({
      key: eventKey,
      domEvent: e2
    });
    if (mode === "inline") {
      onOpenChange(eventKey, !originOpen);
    }
  };
  var onMergedItemClick = useMemoCallback(function(info) {
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    onItemClick(info);
  });
  var onPopupVisibleChange = function onPopupVisibleChange2(newVisible) {
    if (mode !== "inline") {
      onOpenChange(eventKey, newVisible);
    }
  };
  var onInternalFocus = function onInternalFocus2() {
    onActive(eventKey);
  };
  var popupId = domDataId && "".concat(domDataId, "-popup");
  var titleNode = /* @__PURE__ */ React.createElement("div", _extends$1({
    role: "menuitem",
    style: directionStyle,
    className: "".concat(subMenuPrefixCls, "-title"),
    tabIndex: mergedDisabled ? null : -1,
    ref: elementRef,
    title: typeof title === "string" ? title : null,
    "data-menu-id": overflowDisabled && domDataId ? null : domDataId,
    "aria-expanded": open,
    "aria-haspopup": true,
    "aria-controls": popupId,
    "aria-disabled": mergedDisabled,
    onClick: onInternalTitleClick,
    onFocus: onInternalFocus
  }, activeProps), title, /* @__PURE__ */ React.createElement(Icon$2, {
    icon: mode !== "horizontal" ? mergedExpandIcon : null,
    props: _objectSpread2$3(_objectSpread2$3({}, props), {}, {
      isOpen: open,
      isSubMenu: true
    })
  }, /* @__PURE__ */ React.createElement("i", {
    className: "".concat(subMenuPrefixCls, "-arrow")
  })));
  var triggerModeRef = React.useRef(mode);
  if (mode !== "inline") {
    triggerModeRef.current = connectedPath.length > 1 ? "vertical" : mode;
  }
  if (!overflowDisabled) {
    var triggerMode = triggerModeRef.current;
    titleNode = /* @__PURE__ */ React.createElement(PopupTrigger, {
      mode: triggerMode,
      prefixCls: subMenuPrefixCls,
      visible: !internalPopupClose && open && mode !== "inline",
      popupClassName,
      popupOffset,
      popup: /* @__PURE__ */ React.createElement(InheritableContextProvider, {
        mode: triggerMode === "horizontal" ? "vertical" : triggerMode
      }, /* @__PURE__ */ React.createElement(SubMenuList, {
        id: popupId,
        ref: popupRef
      }, children)),
      disabled: mergedDisabled,
      onVisibleChange: onPopupVisibleChange
    }, titleNode);
  }
  var listNode = /* @__PURE__ */ React.createElement(ForwardOverflow.Item, _extends$1({
    role: "none"
  }, restProps, {
    component: "li",
    style: style2,
    className: classNames(subMenuPrefixCls, "".concat(subMenuPrefixCls, "-").concat(mode), className, (_classNames = {}, _defineProperty$3(_classNames, "".concat(subMenuPrefixCls, "-open"), open), _defineProperty$3(_classNames, "".concat(subMenuPrefixCls, "-active"), mergedActive), _defineProperty$3(_classNames, "".concat(subMenuPrefixCls, "-selected"), childrenSelected), _defineProperty$3(_classNames, "".concat(subMenuPrefixCls, "-disabled"), mergedDisabled), _classNames)),
    onMouseEnter: onInternalMouseEnter,
    onMouseLeave: onInternalMouseLeave
  }), titleNode, !overflowDisabled && /* @__PURE__ */ React.createElement(InlineSubMenuList, {
    id: popupId,
    open,
    keyPath: connectedPath
  }, children));
  if (_internalRenderSubMenuItem) {
    listNode = _internalRenderSubMenuItem(listNode, props);
  }
  return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    onItemClick: onMergedItemClick,
    mode: mode === "horizontal" ? "vertical" : mode,
    itemIcon: mergedItemIcon,
    expandIcon: mergedExpandIcon
  }, listNode);
};
function SubMenu(props) {
  var eventKey = props.eventKey, children = props.children;
  var connectedKeyPath = useFullPath(eventKey);
  var childList = parseChildren(children, connectedKeyPath);
  var measure = useMeasure();
  React.useEffect(function() {
    if (measure) {
      measure.registerPath(eventKey, connectedKeyPath);
      return function() {
        measure.unregisterPath(eventKey, connectedKeyPath);
      };
    }
  }, [connectedKeyPath]);
  var renderNode2;
  if (measure) {
    renderNode2 = childList;
  } else {
    renderNode2 = /* @__PURE__ */ React.createElement(InternalSubMenu, props, childList);
  }
  return /* @__PURE__ */ React.createElement(PathTrackerContext.Provider, {
    value: connectedKeyPath
  }, renderNode2);
}
function focusable(node) {
  var includePositive = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  if (isVisible(node)) {
    var nodeName = node.nodeName.toLowerCase();
    var isFocusableElement = ["input", "select", "textarea", "button"].includes(nodeName) || node.isContentEditable || nodeName === "a" && !!node.getAttribute("href");
    var tabIndexAttr = node.getAttribute("tabindex");
    var tabIndexNum = Number(tabIndexAttr);
    var tabIndex = null;
    if (tabIndexAttr && !Number.isNaN(tabIndexNum)) {
      tabIndex = tabIndexNum;
    } else if (isFocusableElement && tabIndex === null) {
      tabIndex = 0;
    }
    if (isFocusableElement && node.disabled) {
      tabIndex = null;
    }
    return tabIndex !== null && (tabIndex >= 0 || includePositive && tabIndex < 0);
  }
  return false;
}
function getFocusNodeList(node) {
  var includePositive = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var res2 = _toConsumableArray(node.querySelectorAll("*")).filter(function(child) {
    return focusable(child, includePositive);
  });
  if (focusable(node, includePositive)) {
    res2.unshift(node);
  }
  return res2;
}
var LEFT = KeyCode.LEFT, RIGHT = KeyCode.RIGHT, UP = KeyCode.UP, DOWN = KeyCode.DOWN, ENTER = KeyCode.ENTER, ESC = KeyCode.ESC, HOME = KeyCode.HOME, END = KeyCode.END;
var ArrowKeys = [UP, DOWN, LEFT, RIGHT];
function getOffset(mode, isRootLevel, isRtl, which) {
  var _inline, _horizontal, _vertical, _offsets$;
  var prev = "prev";
  var next = "next";
  var children = "children";
  var parent = "parent";
  if (mode === "inline" && which === ENTER) {
    return {
      inlineTrigger: true
    };
  }
  var inline = (_inline = {}, _defineProperty$3(_inline, UP, prev), _defineProperty$3(_inline, DOWN, next), _inline);
  var horizontal = (_horizontal = {}, _defineProperty$3(_horizontal, LEFT, isRtl ? next : prev), _defineProperty$3(_horizontal, RIGHT, isRtl ? prev : next), _defineProperty$3(_horizontal, DOWN, children), _defineProperty$3(_horizontal, ENTER, children), _horizontal);
  var vertical = (_vertical = {}, _defineProperty$3(_vertical, UP, prev), _defineProperty$3(_vertical, DOWN, next), _defineProperty$3(_vertical, ENTER, children), _defineProperty$3(_vertical, ESC, parent), _defineProperty$3(_vertical, LEFT, isRtl ? children : parent), _defineProperty$3(_vertical, RIGHT, isRtl ? parent : children), _vertical);
  var offsets = {
    inline,
    horizontal,
    vertical,
    inlineSub: inline,
    horizontalSub: vertical,
    verticalSub: vertical
  };
  var type4 = (_offsets$ = offsets["".concat(mode).concat(isRootLevel ? "" : "Sub")]) === null || _offsets$ === void 0 ? void 0 : _offsets$[which];
  switch (type4) {
    case prev:
      return {
        offset: -1,
        sibling: true
      };
    case next:
      return {
        offset: 1,
        sibling: true
      };
    case parent:
      return {
        offset: -1,
        sibling: false
      };
    case children:
      return {
        offset: 1,
        sibling: false
      };
    default:
      return null;
  }
}
function findContainerUL(element) {
  var current2 = element;
  while (current2) {
    if (current2.getAttribute("data-menu-list")) {
      return current2;
    }
    current2 = current2.parentElement;
  }
  return null;
}
function getFocusElement(activeElement, elements) {
  var current2 = activeElement || document.activeElement;
  while (current2) {
    if (elements.has(current2)) {
      return current2;
    }
    current2 = current2.parentElement;
  }
  return null;
}
function getFocusableElements(container2, elements) {
  var list = getFocusNodeList(container2, true);
  return list.filter(function(ele) {
    return elements.has(ele);
  });
}
function getNextFocusElement(parentQueryContainer, elements, focusMenuElement) {
  var offset3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1;
  if (!parentQueryContainer) {
    return null;
  }
  var sameLevelFocusableMenuElementList = getFocusableElements(parentQueryContainer, elements);
  var count2 = sameLevelFocusableMenuElementList.length;
  var focusIndex = sameLevelFocusableMenuElementList.findIndex(function(ele) {
    return focusMenuElement === ele;
  });
  if (offset3 < 0) {
    if (focusIndex === -1) {
      focusIndex = count2 - 1;
    } else {
      focusIndex -= 1;
    }
  } else if (offset3 > 0) {
    focusIndex += 1;
  }
  focusIndex = (focusIndex + count2) % count2;
  return sameLevelFocusableMenuElementList[focusIndex];
}
function useAccessibility(mode, activeKey, isRtl, id2, containerRef, getKeys, getKeyPath, triggerActiveKey, triggerAccessibilityOpen, originOnKeyDown) {
  var rafRef = React.useRef();
  var activeRef = React.useRef();
  activeRef.current = activeKey;
  var cleanRaf = function cleanRaf2() {
    wrapperRaf$1.cancel(rafRef.current);
  };
  React.useEffect(function() {
    return function() {
      cleanRaf();
    };
  }, []);
  return function(e2) {
    var which = e2.which;
    if ([].concat(ArrowKeys, [ENTER, ESC, HOME, END]).includes(which)) {
      var elements;
      var key2element;
      var element2key;
      var refreshElements = function refreshElements2() {
        elements = /* @__PURE__ */ new Set();
        key2element = /* @__PURE__ */ new Map();
        element2key = /* @__PURE__ */ new Map();
        var keys2 = getKeys();
        keys2.forEach(function(key) {
          var element = document.querySelector("[data-menu-id='".concat(getMenuId(id2, key), "']"));
          if (element) {
            elements.add(element);
            element2key.set(element, key);
            key2element.set(key, element);
          }
        });
        return elements;
      };
      refreshElements();
      var activeElement = key2element.get(activeKey);
      var focusMenuElement = getFocusElement(activeElement, elements);
      var focusMenuKey = element2key.get(focusMenuElement);
      var offsetObj = getOffset(mode, getKeyPath(focusMenuKey, true).length === 1, isRtl, which);
      if (!offsetObj && which !== HOME && which !== END) {
        return;
      }
      if (ArrowKeys.includes(which) || [HOME, END].includes(which)) {
        e2.preventDefault();
      }
      var tryFocus = function tryFocus2(menuElement) {
        if (menuElement) {
          var focusTargetElement = menuElement;
          var link = menuElement.querySelector("a");
          if (link === null || link === void 0 ? void 0 : link.getAttribute("href")) {
            focusTargetElement = link;
          }
          var targetKey = element2key.get(menuElement);
          triggerActiveKey(targetKey);
          cleanRaf();
          rafRef.current = wrapperRaf$1(function() {
            if (activeRef.current === targetKey) {
              focusTargetElement.focus();
            }
          });
        }
      };
      if ([HOME, END].includes(which) || offsetObj.sibling || !focusMenuElement) {
        var parentQueryContainer;
        if (!focusMenuElement || mode === "inline") {
          parentQueryContainer = containerRef.current;
        } else {
          parentQueryContainer = findContainerUL(focusMenuElement);
        }
        var targetElement;
        var focusableElements = getFocusableElements(parentQueryContainer, elements);
        if (which === HOME) {
          targetElement = focusableElements[0];
        } else if (which === END) {
          targetElement = focusableElements[focusableElements.length - 1];
        } else {
          targetElement = getNextFocusElement(parentQueryContainer, elements, focusMenuElement, offsetObj.offset);
        }
        tryFocus(targetElement);
      } else if (offsetObj.inlineTrigger) {
        triggerAccessibilityOpen(focusMenuKey);
      } else if (offsetObj.offset > 0) {
        triggerAccessibilityOpen(focusMenuKey, true);
        cleanRaf();
        rafRef.current = wrapperRaf$1(function() {
          refreshElements();
          var controlId = focusMenuElement.getAttribute("aria-controls");
          var subQueryContainer = document.getElementById(controlId);
          var targetElement2 = getNextFocusElement(subQueryContainer, elements);
          tryFocus(targetElement2);
        }, 5);
      } else if (offsetObj.offset < 0) {
        var keyPath = getKeyPath(focusMenuKey, true);
        var parentKey = keyPath[keyPath.length - 2];
        var parentMenuElement = key2element.get(parentKey);
        triggerAccessibilityOpen(parentKey, false);
        tryFocus(parentMenuElement);
      }
    }
    originOnKeyDown === null || originOnKeyDown === void 0 ? void 0 : originOnKeyDown(e2);
  };
}
var uniquePrefix = Math.random().toFixed(5).toString().slice(2);
var internalId = 0;
function useUUID(id2) {
  var _useMergedState = useControlledState(id2, {
    value: id2
  }), _useMergedState2 = _slicedToArray$1(_useMergedState, 2), uuid2 = _useMergedState2[0], setUUID = _useMergedState2[1];
  React.useEffect(function() {
    internalId += 1;
    var newId = "".concat(uniquePrefix, "-").concat(internalId);
    setUUID("rc-menu-uuid-".concat(newId));
  }, []);
  return uuid2;
}
function nextSlice(callback) {
  Promise.resolve().then(callback);
}
var PATH_SPLIT = "__RC_UTIL_PATH_SPLIT__";
var getPathStr = function getPathStr2(keyPath) {
  return keyPath.join(PATH_SPLIT);
};
var getPathKeys = function getPathKeys2(keyPathStr) {
  return keyPathStr.split(PATH_SPLIT);
};
var OVERFLOW_KEY = "rc-menu-more";
function useKeyRecords() {
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray$1(_React$useState, 2), internalForceUpdate = _React$useState2[1];
  var key2pathRef = useRef(/* @__PURE__ */ new Map());
  var path2keyRef = useRef(/* @__PURE__ */ new Map());
  var _React$useState3 = React.useState([]), _React$useState4 = _slicedToArray$1(_React$useState3, 2), overflowKeys = _React$useState4[0], setOverflowKeys = _React$useState4[1];
  var updateRef = useRef(0);
  var destroyRef = useRef(false);
  var forceUpdate = function forceUpdate2() {
    if (!destroyRef.current) {
      internalForceUpdate({});
    }
  };
  var registerPath = useCallback(function(key, keyPath) {
    var connectedPath = getPathStr(keyPath);
    path2keyRef.current.set(connectedPath, key);
    key2pathRef.current.set(key, connectedPath);
    updateRef.current += 1;
    var id2 = updateRef.current;
    nextSlice(function() {
      if (id2 === updateRef.current) {
        forceUpdate();
      }
    });
  }, []);
  var unregisterPath = useCallback(function(key, keyPath) {
    var connectedPath = getPathStr(keyPath);
    path2keyRef.current.delete(connectedPath);
    key2pathRef.current.delete(key);
  }, []);
  var refreshOverflowKeys = useCallback(function(keys2) {
    setOverflowKeys(keys2);
  }, []);
  var getKeyPath = useCallback(function(eventKey, includeOverflow) {
    var fullPath = key2pathRef.current.get(eventKey) || "";
    var keys2 = getPathKeys(fullPath);
    if (includeOverflow && overflowKeys.includes(keys2[0])) {
      keys2.unshift(OVERFLOW_KEY);
    }
    return keys2;
  }, [overflowKeys]);
  var isSubPathKey = useCallback(function(pathKeys, eventKey) {
    return pathKeys.some(function(pathKey) {
      var pathKeyList = getKeyPath(pathKey, true);
      return pathKeyList.includes(eventKey);
    });
  }, [getKeyPath]);
  var getKeys = function getKeys2() {
    var keys2 = _toConsumableArray(key2pathRef.current.keys());
    if (overflowKeys.length) {
      keys2.push(OVERFLOW_KEY);
    }
    return keys2;
  };
  var getSubPathKeys = useCallback(function(key) {
    var connectedPath = "".concat(key2pathRef.current.get(key)).concat(PATH_SPLIT);
    var pathKeys = /* @__PURE__ */ new Set();
    _toConsumableArray(path2keyRef.current.keys()).forEach(function(pathKey) {
      if (pathKey.startsWith(connectedPath)) {
        pathKeys.add(path2keyRef.current.get(pathKey));
      }
    });
    return pathKeys;
  }, []);
  React.useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  return {
    registerPath,
    unregisterPath,
    refreshOverflowKeys,
    isSubPathKey,
    getKeyPath,
    getKeys,
    getSubPathKeys
  };
}
var _excluded$5 = ["prefixCls", "style", "className", "tabIndex", "children", "direction", "id", "mode", "inlineCollapsed", "disabled", "disabledOverflow", "subMenuOpenDelay", "subMenuCloseDelay", "forceSubMenuRender", "defaultOpenKeys", "openKeys", "activeKey", "defaultActiveFirst", "selectable", "multiple", "defaultSelectedKeys", "selectedKeys", "onSelect", "onDeselect", "inlineIndent", "motion", "defaultMotions", "triggerSubMenuAction", "builtinPlacements", "itemIcon", "expandIcon", "overflowedIndicator", "overflowedIndicatorPopupClassName", "getPopupContainer", "onClick", "onOpenChange", "onKeyDown", "openAnimation", "openTransitionName", "_internalRenderMenuItem", "_internalRenderSubMenuItem"];
var EMPTY_LIST = [];
var Menu = function Menu2(props) {
  var _childList$, _classNames;
  var _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-menu" : _props$prefixCls, style2 = props.style, className = props.className, _props$tabIndex = props.tabIndex, tabIndex = _props$tabIndex === void 0 ? 0 : _props$tabIndex, children = props.children, direction = props.direction, id2 = props.id, _props$mode = props.mode, mode = _props$mode === void 0 ? "vertical" : _props$mode, inlineCollapsed = props.inlineCollapsed, disabled = props.disabled, disabledOverflow = props.disabledOverflow, _props$subMenuOpenDel = props.subMenuOpenDelay, subMenuOpenDelay = _props$subMenuOpenDel === void 0 ? 0.1 : _props$subMenuOpenDel, _props$subMenuCloseDe = props.subMenuCloseDelay, subMenuCloseDelay = _props$subMenuCloseDe === void 0 ? 0.1 : _props$subMenuCloseDe, forceSubMenuRender = props.forceSubMenuRender, defaultOpenKeys = props.defaultOpenKeys, openKeys = props.openKeys, activeKey = props.activeKey, defaultActiveFirst = props.defaultActiveFirst, _props$selectable = props.selectable, selectable = _props$selectable === void 0 ? true : _props$selectable, _props$multiple = props.multiple, multiple = _props$multiple === void 0 ? false : _props$multiple, defaultSelectedKeys = props.defaultSelectedKeys, selectedKeys = props.selectedKeys, onSelect = props.onSelect, onDeselect = props.onDeselect, _props$inlineIndent = props.inlineIndent, inlineIndent = _props$inlineIndent === void 0 ? 24 : _props$inlineIndent, motion = props.motion, defaultMotions = props.defaultMotions, _props$triggerSubMenu = props.triggerSubMenuAction, triggerSubMenuAction = _props$triggerSubMenu === void 0 ? "hover" : _props$triggerSubMenu, builtinPlacements = props.builtinPlacements, itemIcon = props.itemIcon, expandIcon = props.expandIcon, _props$overflowedIndi = props.overflowedIndicator, overflowedIndicator = _props$overflowedIndi === void 0 ? "..." : _props$overflowedIndi, overflowedIndicatorPopupClassName = props.overflowedIndicatorPopupClassName, getPopupContainer = props.getPopupContainer, onClick = props.onClick, onOpenChange = props.onOpenChange, onKeyDown2 = props.onKeyDown;
  props.openAnimation;
  props.openTransitionName;
  var _internalRenderMenuItem = props._internalRenderMenuItem, _internalRenderSubMenuItem = props._internalRenderSubMenuItem, restProps = _objectWithoutProperties$1(props, _excluded$5);
  var childList = parseChildren(children, EMPTY_LIST);
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray$1(_React$useState, 2), mounted = _React$useState2[0], setMounted = _React$useState2[1];
  var containerRef = React.useRef();
  var uuid2 = useUUID(id2);
  var isRtl = direction === "rtl";
  var _React$useMemo = React.useMemo(function() {
    if ((mode === "inline" || mode === "vertical") && inlineCollapsed) {
      return ["vertical", inlineCollapsed];
    }
    return [mode, false];
  }, [mode, inlineCollapsed]), _React$useMemo2 = _slicedToArray$1(_React$useMemo, 2), mergedMode = _React$useMemo2[0], mergedInlineCollapsed = _React$useMemo2[1];
  var _React$useState3 = React.useState(0), _React$useState4 = _slicedToArray$1(_React$useState3, 2), lastVisibleIndex = _React$useState4[0], setLastVisibleIndex = _React$useState4[1];
  var allVisible = lastVisibleIndex >= childList.length - 1 || mergedMode !== "horizontal" || disabledOverflow;
  var _useMergedState = useControlledState(defaultOpenKeys, {
    value: openKeys,
    postState: function postState(keys2) {
      return keys2 || EMPTY_LIST;
    }
  }), _useMergedState2 = _slicedToArray$1(_useMergedState, 2), mergedOpenKeys = _useMergedState2[0], setMergedOpenKeys = _useMergedState2[1];
  var triggerOpenKeys = function triggerOpenKeys2(keys2) {
    setMergedOpenKeys(keys2);
    onOpenChange === null || onOpenChange === void 0 ? void 0 : onOpenChange(keys2);
  };
  var _React$useState5 = React.useState(mergedOpenKeys), _React$useState6 = _slicedToArray$1(_React$useState5, 2), inlineCacheOpenKeys = _React$useState6[0], setInlineCacheOpenKeys = _React$useState6[1];
  var isInlineMode = mergedMode === "inline";
  var mountRef = React.useRef(false);
  React.useEffect(function() {
    if (isInlineMode) {
      setInlineCacheOpenKeys(mergedOpenKeys);
    }
  }, [mergedOpenKeys]);
  React.useEffect(function() {
    if (!mountRef.current) {
      mountRef.current = true;
      return;
    }
    if (isInlineMode) {
      setMergedOpenKeys(inlineCacheOpenKeys);
    } else {
      triggerOpenKeys(EMPTY_LIST);
    }
  }, [isInlineMode]);
  var _useKeyRecords = useKeyRecords(), registerPath = _useKeyRecords.registerPath, unregisterPath = _useKeyRecords.unregisterPath, refreshOverflowKeys = _useKeyRecords.refreshOverflowKeys, isSubPathKey = _useKeyRecords.isSubPathKey, getKeyPath = _useKeyRecords.getKeyPath, getKeys = _useKeyRecords.getKeys, getSubPathKeys = _useKeyRecords.getSubPathKeys;
  var registerPathContext = React.useMemo(function() {
    return {
      registerPath,
      unregisterPath
    };
  }, [registerPath, unregisterPath]);
  var pathUserContext = React.useMemo(function() {
    return {
      isSubPathKey
    };
  }, [isSubPathKey]);
  React.useEffect(function() {
    refreshOverflowKeys(allVisible ? EMPTY_LIST : childList.slice(lastVisibleIndex + 1).map(function(child) {
      return child.key;
    }));
  }, [lastVisibleIndex, allVisible]);
  var _useMergedState3 = useControlledState(activeKey || defaultActiveFirst && ((_childList$ = childList[0]) === null || _childList$ === void 0 ? void 0 : _childList$.key), {
    value: activeKey
  }), _useMergedState4 = _slicedToArray$1(_useMergedState3, 2), mergedActiveKey = _useMergedState4[0], setMergedActiveKey = _useMergedState4[1];
  var onActive = useMemoCallback(function(key) {
    setMergedActiveKey(key);
  });
  var onInactive = useMemoCallback(function() {
    setMergedActiveKey(void 0);
  });
  var _useMergedState5 = useControlledState(defaultSelectedKeys || [], {
    value: selectedKeys,
    postState: function postState(keys2) {
      if (Array.isArray(keys2)) {
        return keys2;
      }
      if (keys2 === null || keys2 === void 0) {
        return EMPTY_LIST;
      }
      return [keys2];
    }
  }), _useMergedState6 = _slicedToArray$1(_useMergedState5, 2), mergedSelectKeys = _useMergedState6[0], setMergedSelectKeys = _useMergedState6[1];
  var triggerSelection = function triggerSelection2(info) {
    if (selectable) {
      var targetKey = info.key;
      var exist = mergedSelectKeys.includes(targetKey);
      var newSelectKeys;
      if (multiple) {
        if (exist) {
          newSelectKeys = mergedSelectKeys.filter(function(key) {
            return key !== targetKey;
          });
        } else {
          newSelectKeys = [].concat(_toConsumableArray(mergedSelectKeys), [targetKey]);
        }
      } else {
        newSelectKeys = [targetKey];
      }
      setMergedSelectKeys(newSelectKeys);
      var selectInfo = _objectSpread2$3(_objectSpread2$3({}, info), {}, {
        selectedKeys: newSelectKeys
      });
      if (exist) {
        onDeselect === null || onDeselect === void 0 ? void 0 : onDeselect(selectInfo);
      } else {
        onSelect === null || onSelect === void 0 ? void 0 : onSelect(selectInfo);
      }
    }
    if (!multiple && mergedOpenKeys.length && mergedMode !== "inline") {
      triggerOpenKeys(EMPTY_LIST);
    }
  };
  var onInternalClick = useMemoCallback(function(info) {
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    triggerSelection(info);
  });
  var onInternalOpenChange = useMemoCallback(function(key, open) {
    var newOpenKeys = mergedOpenKeys.filter(function(k2) {
      return k2 !== key;
    });
    if (open) {
      newOpenKeys.push(key);
    } else if (mergedMode !== "inline") {
      var subPathKeys = getSubPathKeys(key);
      newOpenKeys = newOpenKeys.filter(function(k2) {
        return !subPathKeys.has(k2);
      });
    }
    if (!shallowequal(mergedOpenKeys, newOpenKeys)) {
      triggerOpenKeys(newOpenKeys);
    }
  });
  var getInternalPopupContainer = useMemoCallback(getPopupContainer);
  var triggerAccessibilityOpen = function triggerAccessibilityOpen2(key, open) {
    var nextOpen = open !== null && open !== void 0 ? open : !mergedOpenKeys.includes(key);
    onInternalOpenChange(key, nextOpen);
  };
  var onInternalKeyDown = useAccessibility(mergedMode, mergedActiveKey, isRtl, uuid2, containerRef, getKeys, getKeyPath, setMergedActiveKey, triggerAccessibilityOpen, onKeyDown2);
  React.useEffect(function() {
    setMounted(true);
  }, []);
  var privateContext = React.useMemo(function() {
    return {
      _internalRenderMenuItem,
      _internalRenderSubMenuItem
    };
  }, [_internalRenderMenuItem, _internalRenderSubMenuItem]);
  var wrappedChildList = mergedMode !== "horizontal" || disabledOverflow ? childList : childList.map(function(child, index2) {
    return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
      key: child.key,
      overflowDisabled: index2 > lastVisibleIndex
    }, child);
  });
  var container2 = /* @__PURE__ */ React.createElement(ForwardOverflow, _extends$1({
    id: id2,
    ref: containerRef,
    prefixCls: "".concat(prefixCls, "-overflow"),
    component: "ul",
    itemComponent: MenuItem,
    className: classNames(prefixCls, "".concat(prefixCls, "-root"), "".concat(prefixCls, "-").concat(mergedMode), className, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-inline-collapsed"), mergedInlineCollapsed), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), isRtl), _classNames)),
    dir: direction,
    style: style2,
    role: "menu",
    tabIndex,
    data: wrappedChildList,
    renderRawItem: function renderRawItem(node) {
      return node;
    },
    renderRawRest: function renderRawRest(omitItems) {
      var len2 = omitItems.length;
      var originOmitItems = len2 ? childList.slice(-len2) : null;
      return /* @__PURE__ */ React.createElement(SubMenu, {
        eventKey: OVERFLOW_KEY,
        title: overflowedIndicator,
        disabled: allVisible,
        internalPopupClose: len2 === 0,
        popupClassName: overflowedIndicatorPopupClassName
      }, originOmitItems);
    },
    maxCount: mergedMode !== "horizontal" || disabledOverflow ? ForwardOverflow.INVALIDATE : ForwardOverflow.RESPONSIVE,
    ssr: "full",
    "data-menu-list": true,
    onVisibleChange: function onVisibleChange(newLastIndex) {
      setLastVisibleIndex(newLastIndex);
    },
    onKeyDown: onInternalKeyDown
  }, restProps));
  return /* @__PURE__ */ React.createElement(PrivateContext.Provider, {
    value: privateContext
  }, /* @__PURE__ */ React.createElement(IdContext.Provider, {
    value: uuid2
  }, /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    prefixCls,
    mode: mergedMode,
    openKeys: mergedOpenKeys,
    rtl: isRtl,
    disabled,
    motion: mounted ? motion : null,
    defaultMotions: mounted ? defaultMotions : null,
    activeKey: mergedActiveKey,
    onActive,
    onInactive,
    selectedKeys: mergedSelectKeys,
    inlineIndent,
    subMenuOpenDelay,
    subMenuCloseDelay,
    forceSubMenuRender,
    builtinPlacements,
    triggerSubMenuAction,
    getPopupContainer: getInternalPopupContainer,
    itemIcon,
    expandIcon,
    onItemClick: onInternalClick,
    onOpenChange: onInternalOpenChange
  }, /* @__PURE__ */ React.createElement(PathUserContext.Provider, {
    value: pathUserContext
  }, container2), /* @__PURE__ */ React.createElement("div", {
    style: {
      display: "none"
    },
    "aria-hidden": true
  }, /* @__PURE__ */ React.createElement(PathRegisterContext.Provider, {
    value: registerPathContext
  }, childList)))));
};
var _excluded$4 = ["className", "title", "eventKey", "children"], _excluded2$1 = ["children"];
var InternalMenuItemGroup = function InternalMenuItemGroup2(_ref) {
  var className = _ref.className, title = _ref.title;
  _ref.eventKey;
  var children = _ref.children, restProps = _objectWithoutProperties$1(_ref, _excluded$4);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls;
  var groupPrefixCls = "".concat(prefixCls, "-item-group");
  return /* @__PURE__ */ React.createElement("li", _extends$1({}, restProps, {
    onClick: function onClick(e2) {
      return e2.stopPropagation();
    },
    className: classNames(groupPrefixCls, className)
  }), /* @__PURE__ */ React.createElement("div", {
    className: "".concat(groupPrefixCls, "-title"),
    title: typeof title === "string" ? title : void 0
  }, title), /* @__PURE__ */ React.createElement("ul", {
    className: "".concat(groupPrefixCls, "-list")
  }, children));
};
function MenuItemGroup(_ref2) {
  var children = _ref2.children, props = _objectWithoutProperties$1(_ref2, _excluded2$1);
  var connectedKeyPath = useFullPath(props.eventKey);
  var childList = parseChildren(children, connectedKeyPath);
  var measure = useMeasure();
  if (measure) {
    return childList;
  }
  return /* @__PURE__ */ React.createElement(InternalMenuItemGroup, omit(props, ["warnKey"]), childList);
}
function Divider$2(_ref) {
  var className = _ref.className, style2 = _ref.style;
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls;
  var measure = useMeasure();
  if (measure) {
    return null;
  }
  return /* @__PURE__ */ React.createElement("li", {
    className: classNames("".concat(prefixCls, "-item-divider"), className),
    style: style2
  });
}
var ExportMenu = Menu;
ExportMenu.Item = MenuItem;
ExportMenu.SubMenu = SubMenu;
ExportMenu.ItemGroup = MenuItemGroup;
ExportMenu.Divider = Divider$2;
var LeftOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M724 218.3V141c0-6.7-7.7-10.4-12.9-6.3L260.3 486.8a31.86 31.86 0 000 50.3l450.8 352.1c5.3 4.1 12.9.4 12.9-6.3v-77.3c0-4.9-2.3-9.6-6.1-12.6l-360-281 360-281.1c3.8-3 6.1-7.7 6.1-12.6z" } }] }, "name": "left", "theme": "outlined" };
var LeftOutlinedSvg = LeftOutlined$2;
var LeftOutlined = function LeftOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: LeftOutlinedSvg
  }));
};
LeftOutlined.displayName = "LeftOutlined";
var LeftOutlined$1 = /* @__PURE__ */ React.forwardRef(LeftOutlined);
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React__default, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c2, a, k2) {
  var b2, d2 = {}, e2 = null, l2 = null;
  k2 !== void 0 && (e2 = "" + k2);
  a.key !== void 0 && (e2 = "" + a.key);
  a.ref !== void 0 && (l2 = a.ref);
  for (b2 in a)
    n.call(a, b2) && !p.hasOwnProperty(b2) && (d2[b2] = a[b2]);
  if (c2 && c2.defaultProps)
    for (b2 in a = c2.defaultProps, a)
      d2[b2] === void 0 && (d2[b2] = a[b2]);
  return { $$typeof: g, type: c2, key: e2, ref: l2, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
var Checkbox = /* @__PURE__ */ function(_Component) {
  _inherits(Checkbox2, _Component);
  var _super = _createSuper(Checkbox2);
  function Checkbox2(props) {
    var _this;
    _classCallCheck(this, Checkbox2);
    _this = _super.call(this, props);
    _this.handleChange = function(e2) {
      var _this$props = _this.props, disabled = _this$props.disabled, onChange3 = _this$props.onChange;
      if (disabled) {
        return;
      }
      if (!("checked" in _this.props)) {
        _this.setState({
          checked: e2.target.checked
        });
      }
      if (onChange3) {
        onChange3({
          target: _objectSpread2$3(_objectSpread2$3({}, _this.props), {}, {
            checked: e2.target.checked
          }),
          stopPropagation: function stopPropagation() {
            e2.stopPropagation();
          },
          preventDefault: function preventDefault2() {
            e2.preventDefault();
          },
          nativeEvent: e2.nativeEvent
        });
      }
    };
    _this.saveInput = function(node) {
      _this.input = node;
    };
    var checked = "checked" in props ? props.checked : props.defaultChecked;
    _this.state = {
      checked
    };
    return _this;
  }
  _createClass(Checkbox2, [{
    key: "focus",
    value: function focus() {
      this.input.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: "render",
    value: function render2() {
      var _classNames;
      var _this$props2 = this.props, prefixCls = _this$props2.prefixCls, className = _this$props2.className, style2 = _this$props2.style, name2 = _this$props2.name, id2 = _this$props2.id, type4 = _this$props2.type, disabled = _this$props2.disabled, readOnly = _this$props2.readOnly, tabIndex = _this$props2.tabIndex, onClick = _this$props2.onClick, onFocus2 = _this$props2.onFocus, onBlur2 = _this$props2.onBlur, onKeyDown2 = _this$props2.onKeyDown, onKeyPress2 = _this$props2.onKeyPress, onKeyUp2 = _this$props2.onKeyUp, autoFocus = _this$props2.autoFocus, value = _this$props2.value, required4 = _this$props2.required, others = _objectWithoutProperties$1(_this$props2, ["prefixCls", "className", "style", "name", "id", "type", "disabled", "readOnly", "tabIndex", "onClick", "onFocus", "onBlur", "onKeyDown", "onKeyPress", "onKeyUp", "autoFocus", "value", "required"]);
      var globalProps = Object.keys(others).reduce(function(prev, key) {
        if (key.substr(0, 5) === "aria-" || key.substr(0, 5) === "data-" || key === "role") {
          prev[key] = others[key];
        }
        return prev;
      }, {});
      var checked = this.state.checked;
      var classString = classNames(prefixCls, className, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-checked"), checked), _defineProperty$3(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
      return /* @__PURE__ */ jsxs("span", {
        className: classString,
        style: style2,
        children: [/* @__PURE__ */ jsx("input", __spreadValues({
          name: name2,
          id: id2,
          type: type4,
          required: required4,
          readOnly,
          disabled,
          tabIndex,
          className: "".concat(prefixCls, "-input"),
          checked: !!checked,
          onClick,
          onFocus: onFocus2,
          onBlur: onBlur2,
          onKeyUp: onKeyUp2,
          onKeyDown: onKeyDown2,
          onKeyPress: onKeyPress2,
          onChange: this.handleChange,
          autoFocus,
          ref: this.saveInput,
          value
        }, globalProps)), /* @__PURE__ */ jsx("span", {
          className: "".concat(prefixCls, "-inner")
        })]
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if ("checked" in props) {
        return _objectSpread2$3(_objectSpread2$3({}, state), {}, {
          checked: props.checked
        });
      }
      return null;
    }
  }]);
  return Checkbox2;
}(Component);
Checkbox.defaultProps = {
  prefixCls: "rc-checkbox",
  className: "",
  style: {},
  type: "checkbox",
  defaultChecked: false,
  onFocus: function onFocus() {
  },
  onBlur: function onBlur() {
  },
  onChange: function onChange() {
  },
  onKeyDown: function onKeyDown() {
  },
  onKeyPress: function onKeyPress() {
  },
  onKeyUp: function onKeyUp() {
  }
};
var RadioGroupContext = /* @__PURE__ */ React.createContext(null);
var RadioGroupContextProvider = RadioGroupContext.Provider;
var RadioGroupContext$1 = RadioGroupContext;
var __rest$8 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var InternalRadio = function InternalRadio2(props, ref2) {
  var _classNames;
  var context = React.useContext(RadioGroupContext$1);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var innerRef = React.useRef();
  var mergedRef = composeRef(ref2, innerRef);
  React.useEffect(function() {
    devWarning(!("optionType" in props), "Radio", "`optionType` is only support in Radio.Group.");
  }, []);
  var onChange3 = function onChange4(e2) {
    var _a2, _b2;
    (_a2 = props.onChange) === null || _a2 === void 0 ? void 0 : _a2.call(props, e2);
    (_b2 = context === null || context === void 0 ? void 0 : context.onChange) === null || _b2 === void 0 ? void 0 : _b2.call(context, e2);
  };
  var customizePrefixCls = props.prefixCls, className = props.className, children = props.children, style2 = props.style, restProps = __rest$8(props, ["prefixCls", "className", "children", "style"]);
  var prefixCls = getPrefixCls("radio", customizePrefixCls);
  var radioProps = _extends$1({}, restProps);
  if (context) {
    radioProps.name = context.name;
    radioProps.onChange = onChange3;
    radioProps.checked = props.value === context.value;
    radioProps.disabled = props.disabled || context.disabled;
  }
  var wrapperClassString = classNames("".concat(prefixCls, "-wrapper"), (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-wrapper-checked"), radioProps.checked), _defineProperty$3(_classNames, "".concat(prefixCls, "-wrapper-disabled"), radioProps.disabled), _defineProperty$3(_classNames, "".concat(prefixCls, "-wrapper-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement("label", {
    className: wrapperClassString,
    style: style2,
    onMouseEnter: props.onMouseEnter,
    onMouseLeave: props.onMouseLeave
  }, /* @__PURE__ */ React.createElement(Checkbox, _extends$1({}, radioProps, {
    type: "radio",
    prefixCls,
    ref: mergedRef
  })), children !== void 0 ? /* @__PURE__ */ React.createElement("span", null, children) : null);
};
var Radio$2 = /* @__PURE__ */ React.forwardRef(InternalRadio);
Radio$2.displayName = "Radio";
var InternalRadio$1 = Radio$2;
var RadioGroup = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var _useMergedState = useControlledState(props.defaultValue, {
    value: props.value
  }), _useMergedState2 = _slicedToArray$1(_useMergedState, 2), value = _useMergedState2[0], setValue2 = _useMergedState2[1];
  var onRadioChange = function onRadioChange2(ev) {
    var lastValue = value;
    var val = ev.target.value;
    if (!("value" in props)) {
      setValue2(val);
    }
    var onChange3 = props.onChange;
    if (onChange3 && val !== lastValue) {
      onChange3(ev);
    }
  };
  var renderGroup = function renderGroup2() {
    var _classNames;
    var customizePrefixCls = props.prefixCls, _props$className = props.className, className = _props$className === void 0 ? "" : _props$className, options = props.options, optionType = props.optionType, _props$buttonStyle = props.buttonStyle, buttonStyle = _props$buttonStyle === void 0 ? "outline" : _props$buttonStyle, disabled = props.disabled, children = props.children, customizeSize = props.size, style2 = props.style, id2 = props.id, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave;
    var prefixCls = getPrefixCls("radio", customizePrefixCls);
    var groupPrefixCls = "".concat(prefixCls, "-group");
    var childrenToRender = children;
    if (options && options.length > 0) {
      var optionsPrefixCls = optionType === "button" ? "".concat(prefixCls, "-button") : prefixCls;
      childrenToRender = options.map(function(option) {
        if (typeof option === "string" || typeof option === "number") {
          return /* @__PURE__ */ React.createElement(InternalRadio$1, {
            key: option.toString(),
            prefixCls: optionsPrefixCls,
            disabled,
            value: option,
            checked: value === option
          }, option);
        }
        return /* @__PURE__ */ React.createElement(InternalRadio$1, {
          key: "radio-group-value-options-".concat(option.value),
          prefixCls: optionsPrefixCls,
          disabled: option.disabled || disabled,
          value: option.value,
          checked: value === option.value,
          style: option.style
        }, option.label);
      });
    }
    var mergedSize = customizeSize || size;
    var classString = classNames(groupPrefixCls, "".concat(groupPrefixCls, "-").concat(buttonStyle), (_classNames = {}, _defineProperty$3(_classNames, "".concat(groupPrefixCls, "-").concat(mergedSize), mergedSize), _defineProperty$3(_classNames, "".concat(groupPrefixCls, "-rtl"), direction === "rtl"), _classNames), className);
    return /* @__PURE__ */ React.createElement("div", _extends$1({}, getDataOrAriaProps(props), {
      className: classString,
      style: style2,
      onMouseEnter,
      onMouseLeave,
      id: id2,
      ref: ref2
    }), childrenToRender);
  };
  return /* @__PURE__ */ React.createElement(RadioGroupContextProvider, {
    value: {
      onChange: onRadioChange,
      value,
      disabled: props.disabled,
      name: props.name
    }
  }, renderGroup());
});
var Group = /* @__PURE__ */ React.memo(RadioGroup);
var __rest$7 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var RadioButton = function RadioButton2(props, ref2) {
  var radioGroupContext = React.useContext(RadioGroupContext$1);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var customizePrefixCls = props.prefixCls, radioProps = __rest$7(props, ["prefixCls"]);
  var prefixCls = getPrefixCls("radio-button", customizePrefixCls);
  if (radioGroupContext) {
    radioProps.checked = props.value === radioGroupContext.value;
    radioProps.disabled = props.disabled || radioGroupContext.disabled;
  }
  return /* @__PURE__ */ React.createElement(InternalRadio$1, _extends$1({
    prefixCls
  }, radioProps, {
    type: "radio",
    ref: ref2
  }));
};
var Button = /* @__PURE__ */ React.forwardRef(RadioButton);
var Radio = InternalRadio$1;
Radio.Button = Button;
Radio.Group = Group;
var Radio$1 = Radio;
function useRaf(callback) {
  var rafRef = useRef();
  var removedRef = useRef(false);
  function trigger2() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    if (!removedRef.current) {
      wrapperRaf$1.cancel(rafRef.current);
      rafRef.current = wrapperRaf$1(function() {
        callback.apply(void 0, args);
      });
    }
  }
  useEffect(function() {
    return function() {
      removedRef.current = true;
      wrapperRaf$1.cancel(rafRef.current);
    };
  }, []);
  return trigger2;
}
function useRafState(defaultState) {
  var batchRef = useRef([]);
  var _useState = useState({}), _useState2 = _slicedToArray$1(_useState, 2), forceUpdate = _useState2[1];
  var state = useRef(typeof defaultState === "function" ? defaultState() : defaultState);
  var flushUpdate = useRaf(function() {
    var current2 = state.current;
    batchRef.current.forEach(function(callback) {
      current2 = callback(current2);
    });
    batchRef.current = [];
    state.current = current2;
    forceUpdate({});
  });
  function updater(callback) {
    batchRef.current.push(callback);
    flushUpdate();
  }
  return [state.current, updater];
}
function TabNode(_ref, ref2) {
  var _classNames;
  var prefixCls = _ref.prefixCls, id2 = _ref.id, active = _ref.active, _ref$tab = _ref.tab, key = _ref$tab.key, tab = _ref$tab.tab, disabled = _ref$tab.disabled, closeIcon = _ref$tab.closeIcon, closable = _ref.closable, renderWrapper = _ref.renderWrapper, removeAriaLabel = _ref.removeAriaLabel, editable = _ref.editable, onClick = _ref.onClick, onRemove = _ref.onRemove, onFocus2 = _ref.onFocus, style2 = _ref.style;
  var tabPrefix = "".concat(prefixCls, "-tab");
  React.useEffect(function() {
    return onRemove;
  }, []);
  var removable = editable && closable !== false && !disabled;
  function onInternalClick(e2) {
    if (disabled) {
      return;
    }
    onClick(e2);
  }
  function onRemoveTab(event) {
    event.preventDefault();
    event.stopPropagation();
    editable.onEdit("remove", {
      key,
      event
    });
  }
  var node = /* @__PURE__ */ React.createElement("div", {
    key,
    ref: ref2,
    className: classNames(tabPrefix, (_classNames = {}, _defineProperty$3(_classNames, "".concat(tabPrefix, "-with-remove"), removable), _defineProperty$3(_classNames, "".concat(tabPrefix, "-active"), active), _defineProperty$3(_classNames, "".concat(tabPrefix, "-disabled"), disabled), _classNames)),
    style: style2,
    onClick: onInternalClick
  }, /* @__PURE__ */ React.createElement("div", {
    role: "tab",
    "aria-selected": active,
    id: id2 && "".concat(id2, "-tab-").concat(key),
    className: "".concat(tabPrefix, "-btn"),
    "aria-controls": id2 && "".concat(id2, "-panel-").concat(key),
    "aria-disabled": disabled,
    tabIndex: disabled ? null : 0,
    onClick: function onClick2(e2) {
      e2.stopPropagation();
      onInternalClick(e2);
    },
    onKeyDown: function onKeyDown2(e2) {
      if ([KeyCode.SPACE, KeyCode.ENTER].includes(e2.which)) {
        e2.preventDefault();
        onInternalClick(e2);
      }
    },
    onFocus: onFocus2
  }, tab), removable && /* @__PURE__ */ React.createElement("button", {
    type: "button",
    "aria-label": removeAriaLabel || "remove",
    tabIndex: 0,
    className: "".concat(tabPrefix, "-remove"),
    onClick: function onClick2(e2) {
      e2.stopPropagation();
      onRemoveTab(e2);
    }
  }, closeIcon || editable.removeIcon || "\xD7"));
  return renderWrapper ? renderWrapper(node) : node;
}
var TabNode$1 = /* @__PURE__ */ React.forwardRef(TabNode);
var DEFAULT_SIZE$1 = {
  width: 0,
  height: 0,
  left: 0,
  top: 0
};
function useOffsets(tabs, tabSizes, holderScrollWidth) {
  return useMemo$1(function() {
    var _tabs$;
    var map2 = /* @__PURE__ */ new Map();
    var lastOffset = tabSizes.get((_tabs$ = tabs[0]) === null || _tabs$ === void 0 ? void 0 : _tabs$.key) || DEFAULT_SIZE$1;
    var rightOffset = lastOffset.left + lastOffset.width;
    for (var i = 0; i < tabs.length; i += 1) {
      var key = tabs[i].key;
      var data2 = tabSizes.get(key);
      if (!data2) {
        var _tabs;
        data2 = tabSizes.get((_tabs = tabs[i - 1]) === null || _tabs === void 0 ? void 0 : _tabs.key) || DEFAULT_SIZE$1;
      }
      var entity = map2.get(key) || _objectSpread2$3({}, data2);
      entity.right = rightOffset - entity.left - entity.width;
      map2.set(key, entity);
    }
    return map2;
  }, [tabs.map(function(tab) {
    return tab.key;
  }).join("_"), tabSizes, holderScrollWidth]);
}
var DEFAULT_SIZE = {
  width: 0,
  height: 0,
  left: 0,
  top: 0,
  right: 0
};
function useVisibleRange(tabOffsets, containerSize, tabContentNodeSize, addNodeSize, _ref) {
  var tabs = _ref.tabs, tabPosition = _ref.tabPosition, rtl = _ref.rtl;
  var unit;
  var position2;
  var transformSize;
  if (["top", "bottom"].includes(tabPosition)) {
    unit = "width";
    position2 = rtl ? "right" : "left";
    transformSize = Math.abs(containerSize.left);
  } else {
    unit = "height";
    position2 = "top";
    transformSize = -containerSize.top;
  }
  var basicSize = containerSize[unit];
  var tabContentSize = tabContentNodeSize[unit];
  var addSize = addNodeSize[unit];
  var mergedBasicSize = basicSize;
  if (tabContentSize + addSize > basicSize && tabContentSize < basicSize) {
    mergedBasicSize = basicSize - addSize;
  }
  return useMemo$1(function() {
    if (!tabs.length) {
      return [0, 0];
    }
    var len2 = tabs.length;
    var endIndex = len2;
    for (var i = 0; i < len2; i += 1) {
      var offset3 = tabOffsets.get(tabs[i].key) || DEFAULT_SIZE;
      if (offset3[position2] + offset3[unit] > transformSize + mergedBasicSize) {
        endIndex = i - 1;
        break;
      }
    }
    var startIndex = 0;
    for (var _i = len2 - 1; _i >= 0; _i -= 1) {
      var _offset = tabOffsets.get(tabs[_i].key) || DEFAULT_SIZE;
      if (_offset[position2] < transformSize) {
        startIndex = _i + 1;
        break;
      }
    }
    return [startIndex, endIndex];
  }, [tabOffsets, transformSize, mergedBasicSize, tabPosition, tabs.map(function(tab) {
    return tab.key;
  }).join("_"), rtl]);
}
function AddButton(_ref, ref2) {
  var prefixCls = _ref.prefixCls, editable = _ref.editable, locale2 = _ref.locale, style2 = _ref.style;
  if (!editable || editable.showAdd === false) {
    return null;
  }
  return /* @__PURE__ */ React.createElement("button", {
    ref: ref2,
    type: "button",
    className: "".concat(prefixCls, "-nav-add"),
    style: style2,
    "aria-label": (locale2 === null || locale2 === void 0 ? void 0 : locale2.addAriaLabel) || "Add tab",
    onClick: function onClick(event) {
      editable.onEdit("add", {
        event
      });
    }
  }, editable.addIcon || "+");
}
var AddButton$1 = /* @__PURE__ */ React.forwardRef(AddButton);
function OperationNode(_ref, ref2) {
  var prefixCls = _ref.prefixCls, id2 = _ref.id, tabs = _ref.tabs, locale2 = _ref.locale, mobile = _ref.mobile, _ref$moreIcon = _ref.moreIcon, moreIcon = _ref$moreIcon === void 0 ? "More" : _ref$moreIcon, moreTransitionName = _ref.moreTransitionName, style2 = _ref.style, className = _ref.className, editable = _ref.editable, tabBarGutter = _ref.tabBarGutter, rtl = _ref.rtl, removeAriaLabel = _ref.removeAriaLabel, onTabClick = _ref.onTabClick;
  var _useState = useState(false), _useState2 = _slicedToArray$1(_useState, 2), open = _useState2[0], setOpen = _useState2[1];
  var _useState3 = useState(null), _useState4 = _slicedToArray$1(_useState3, 2), selectedKey = _useState4[0], setSelectedKey = _useState4[1];
  var popupId = "".concat(id2, "-more-popup");
  var dropdownPrefix = "".concat(prefixCls, "-dropdown");
  var selectedItemId = selectedKey !== null ? "".concat(popupId, "-").concat(selectedKey) : null;
  var dropdownAriaLabel = locale2 === null || locale2 === void 0 ? void 0 : locale2.dropdownAriaLabel;
  function onRemoveTab(event, key) {
    event.preventDefault();
    event.stopPropagation();
    editable.onEdit("remove", {
      key,
      event
    });
  }
  var menu = /* @__PURE__ */ React.createElement(ExportMenu, {
    onClick: function onClick(_ref2) {
      var key = _ref2.key, domEvent = _ref2.domEvent;
      onTabClick(key, domEvent);
      setOpen(false);
    },
    id: popupId,
    tabIndex: -1,
    role: "listbox",
    "aria-activedescendant": selectedItemId,
    selectedKeys: [selectedKey],
    "aria-label": dropdownAriaLabel !== void 0 ? dropdownAriaLabel : "expanded dropdown"
  }, tabs.map(function(tab) {
    var removable = editable && tab.closable !== false && !tab.disabled;
    return /* @__PURE__ */ React.createElement(MenuItem, {
      key: tab.key,
      id: "".concat(popupId, "-").concat(tab.key),
      role: "option",
      "aria-controls": id2 && "".concat(id2, "-panel-").concat(tab.key),
      disabled: tab.disabled
    }, /* @__PURE__ */ React.createElement("span", null, tab.tab), removable && /* @__PURE__ */ React.createElement("button", {
      type: "button",
      "aria-label": removeAriaLabel || "remove",
      tabIndex: 0,
      className: "".concat(dropdownPrefix, "-menu-item-remove"),
      onClick: function onClick(e2) {
        e2.stopPropagation();
        onRemoveTab(e2, tab.key);
      }
    }, tab.closeIcon || editable.removeIcon || "\xD7"));
  }));
  function selectOffset(offset3) {
    var enabledTabs = tabs.filter(function(tab2) {
      return !tab2.disabled;
    });
    var selectedIndex = enabledTabs.findIndex(function(tab2) {
      return tab2.key === selectedKey;
    }) || 0;
    var len2 = enabledTabs.length;
    for (var i = 0; i < len2; i += 1) {
      selectedIndex = (selectedIndex + offset3 + len2) % len2;
      var tab = enabledTabs[selectedIndex];
      if (!tab.disabled) {
        setSelectedKey(tab.key);
        return;
      }
    }
  }
  function onKeyDown2(e2) {
    var which = e2.which;
    if (!open) {
      if ([KeyCode.DOWN, KeyCode.SPACE, KeyCode.ENTER].includes(which)) {
        setOpen(true);
        e2.preventDefault();
      }
      return;
    }
    switch (which) {
      case KeyCode.UP:
        selectOffset(-1);
        e2.preventDefault();
        break;
      case KeyCode.DOWN:
        selectOffset(1);
        e2.preventDefault();
        break;
      case KeyCode.ESC:
        setOpen(false);
        break;
      case KeyCode.SPACE:
      case KeyCode.ENTER:
        if (selectedKey !== null)
          onTabClick(selectedKey, e2);
        break;
    }
  }
  useEffect(function() {
    var ele = document.getElementById(selectedItemId);
    if (ele && ele.scrollIntoView) {
      ele.scrollIntoView(false);
    }
  }, [selectedKey]);
  useEffect(function() {
    if (!open) {
      setSelectedKey(null);
    }
  }, [open]);
  var moreStyle = _defineProperty$3({}, rtl ? "marginRight" : "marginLeft", tabBarGutter);
  if (!tabs.length) {
    moreStyle.visibility = "hidden";
    moreStyle.order = 1;
  }
  var overlayClassName = classNames(_defineProperty$3({}, "".concat(dropdownPrefix, "-rtl"), rtl));
  var moreNode = mobile ? null : /* @__PURE__ */ React.createElement(Dropdown$1, {
    prefixCls: dropdownPrefix,
    overlay: menu,
    trigger: ["hover"],
    visible: open,
    transitionName: moreTransitionName,
    onVisibleChange: setOpen,
    overlayClassName,
    mouseEnterDelay: 0.1,
    mouseLeaveDelay: 0.1
  }, /* @__PURE__ */ React.createElement("button", {
    type: "button",
    className: "".concat(prefixCls, "-nav-more"),
    style: moreStyle,
    tabIndex: -1,
    "aria-hidden": "true",
    "aria-haspopup": "listbox",
    "aria-controls": popupId,
    id: "".concat(id2, "-more"),
    "aria-expanded": open,
    onKeyDown: onKeyDown2
  }, moreIcon));
  return /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-nav-operations"), className),
    style: style2,
    ref: ref2
  }, moreNode, /* @__PURE__ */ React.createElement(AddButton$1, {
    prefixCls,
    locale: locale2,
    editable
  }));
}
var OperationNode$1 = /* @__PURE__ */ React.memo(/* @__PURE__ */ React.forwardRef(OperationNode), function(_, next) {
  return next.tabMoving;
});
var TabContext = /* @__PURE__ */ createContext(null);
var MIN_SWIPE_DISTANCE = 0.1;
var STOP_SWIPE_DISTANCE = 0.01;
var REFRESH_INTERVAL = 20;
var SPEED_OFF_MULTIPLE = Math.pow(0.995, REFRESH_INTERVAL);
function useTouchMove(ref2, onOffset) {
  var _useState = useState(), _useState2 = _slicedToArray$1(_useState, 2), touchPosition = _useState2[0], setTouchPosition = _useState2[1];
  var _useState3 = useState(0), _useState4 = _slicedToArray$1(_useState3, 2), lastTimestamp = _useState4[0], setLastTimestamp = _useState4[1];
  var _useState5 = useState(0), _useState6 = _slicedToArray$1(_useState5, 2), lastTimeDiff = _useState6[0], setLastTimeDiff = _useState6[1];
  var _useState7 = useState(), _useState8 = _slicedToArray$1(_useState7, 2), lastOffset = _useState8[0], setLastOffset = _useState8[1];
  var motionRef = useRef();
  function onTouchStart(e2) {
    var _e$touches$ = e2.touches[0], screenX = _e$touches$.screenX, screenY = _e$touches$.screenY;
    setTouchPosition({
      x: screenX,
      y: screenY
    });
    window.clearInterval(motionRef.current);
  }
  function onTouchMove(e2) {
    if (!touchPosition)
      return;
    e2.preventDefault();
    var _e$touches$2 = e2.touches[0], screenX = _e$touches$2.screenX, screenY = _e$touches$2.screenY;
    setTouchPosition({
      x: screenX,
      y: screenY
    });
    var offsetX = screenX - touchPosition.x;
    var offsetY = screenY - touchPosition.y;
    onOffset(offsetX, offsetY);
    var now = Date.now();
    setLastTimestamp(now);
    setLastTimeDiff(now - lastTimestamp);
    setLastOffset({
      x: offsetX,
      y: offsetY
    });
  }
  function onTouchEnd() {
    if (!touchPosition)
      return;
    setTouchPosition(null);
    setLastOffset(null);
    if (lastOffset) {
      var distanceX = lastOffset.x / lastTimeDiff;
      var distanceY = lastOffset.y / lastTimeDiff;
      var absX = Math.abs(distanceX);
      var absY = Math.abs(distanceY);
      if (Math.max(absX, absY) < MIN_SWIPE_DISTANCE)
        return;
      var currentX = distanceX;
      var currentY = distanceY;
      motionRef.current = window.setInterval(function() {
        if (Math.abs(currentX) < STOP_SWIPE_DISTANCE && Math.abs(currentY) < STOP_SWIPE_DISTANCE) {
          window.clearInterval(motionRef.current);
          return;
        }
        currentX *= SPEED_OFF_MULTIPLE;
        currentY *= SPEED_OFF_MULTIPLE;
        onOffset(currentX * REFRESH_INTERVAL, currentY * REFRESH_INTERVAL);
      }, REFRESH_INTERVAL);
    }
  }
  var lastWheelDirectionRef = useRef();
  function onWheel(e2) {
    var deltaX = e2.deltaX, deltaY = e2.deltaY;
    var mixed = 0;
    var absX = Math.abs(deltaX);
    var absY = Math.abs(deltaY);
    if (absX === absY) {
      mixed = lastWheelDirectionRef.current === "x" ? deltaX : deltaY;
    } else if (absX > absY) {
      mixed = deltaX;
      lastWheelDirectionRef.current = "x";
    } else {
      mixed = deltaY;
      lastWheelDirectionRef.current = "y";
    }
    if (onOffset(-mixed, -mixed)) {
      e2.preventDefault();
    }
  }
  var touchEventsRef = useRef(null);
  touchEventsRef.current = {
    onTouchStart,
    onTouchMove,
    onTouchEnd,
    onWheel
  };
  React.useEffect(function() {
    function onProxyTouchStart(e2) {
      touchEventsRef.current.onTouchStart(e2);
    }
    function onProxyTouchMove(e2) {
      touchEventsRef.current.onTouchMove(e2);
    }
    function onProxyTouchEnd(e2) {
      touchEventsRef.current.onTouchEnd(e2);
    }
    function onProxyWheel(e2) {
      touchEventsRef.current.onWheel(e2);
    }
    document.addEventListener("touchmove", onProxyTouchMove, {
      passive: false
    });
    document.addEventListener("touchend", onProxyTouchEnd, {
      passive: false
    });
    ref2.current.addEventListener("touchstart", onProxyTouchStart, {
      passive: false
    });
    ref2.current.addEventListener("wheel", onProxyWheel);
    return function() {
      document.removeEventListener("touchmove", onProxyTouchMove);
      document.removeEventListener("touchend", onProxyTouchEnd);
    };
  }, []);
}
function useRefs() {
  var cacheRefs = useRef(/* @__PURE__ */ new Map());
  function getRef(key) {
    if (!cacheRefs.current.has(key)) {
      cacheRefs.current.set(key, /* @__PURE__ */ React.createRef());
    }
    return cacheRefs.current.get(key);
  }
  function removeRef(key) {
    cacheRefs.current.delete(key);
  }
  return [getRef, removeRef];
}
function useSyncState(defaultState, onChange3) {
  var stateRef = React.useRef(defaultState);
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray$1(_React$useState, 2), forceUpdate = _React$useState2[1];
  function setState2(updater) {
    var newValue = typeof updater === "function" ? updater(stateRef.current) : updater;
    if (newValue !== stateRef.current) {
      onChange3(newValue, stateRef.current);
    }
    stateRef.current = newValue;
    forceUpdate({});
  }
  return [stateRef.current, setState2];
}
var ExtraContent = function ExtraContent2(_ref) {
  var position2 = _ref.position, prefixCls = _ref.prefixCls, extra = _ref.extra;
  if (!extra)
    return null;
  var content;
  var assertExtra = {};
  if (extra && _typeof$1(extra) === "object" && !/* @__PURE__ */ React.isValidElement(extra)) {
    assertExtra = extra;
  } else {
    assertExtra.right = extra;
  }
  if (position2 === "right") {
    content = assertExtra.right;
  }
  if (position2 === "left") {
    content = assertExtra.left;
  }
  return content ? /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-extra-content")
  }, content) : null;
};
function TabNavList(props, ref2) {
  var _classNames;
  var _React$useContext = React.useContext(TabContext), prefixCls = _React$useContext.prefixCls, tabs = _React$useContext.tabs;
  var className = props.className, style2 = props.style, id2 = props.id, animated = props.animated, activeKey = props.activeKey, rtl = props.rtl, extra = props.extra, editable = props.editable, locale2 = props.locale, tabPosition = props.tabPosition, tabBarGutter = props.tabBarGutter, children = props.children, onTabClick = props.onTabClick, onTabScroll = props.onTabScroll;
  var tabsWrapperRef = useRef();
  var tabListRef = useRef();
  var operationsRef = useRef();
  var innerAddButtonRef = useRef();
  var _useRefs = useRefs(), _useRefs2 = _slicedToArray$1(_useRefs, 2), getBtnRef = _useRefs2[0], removeBtnRef = _useRefs2[1];
  var tabPositionTopOrBottom = tabPosition === "top" || tabPosition === "bottom";
  var _useSyncState = useSyncState(0, function(next, prev) {
    if (tabPositionTopOrBottom && onTabScroll) {
      onTabScroll({
        direction: next > prev ? "left" : "right"
      });
    }
  }), _useSyncState2 = _slicedToArray$1(_useSyncState, 2), transformLeft = _useSyncState2[0], setTransformLeft = _useSyncState2[1];
  var _useSyncState3 = useSyncState(0, function(next, prev) {
    if (!tabPositionTopOrBottom && onTabScroll) {
      onTabScroll({
        direction: next > prev ? "top" : "bottom"
      });
    }
  }), _useSyncState4 = _slicedToArray$1(_useSyncState3, 2), transformTop = _useSyncState4[0], setTransformTop = _useSyncState4[1];
  var _useState = useState(0), _useState2 = _slicedToArray$1(_useState, 2), wrapperScrollWidth = _useState2[0], setWrapperScrollWidth = _useState2[1];
  var _useState3 = useState(0), _useState4 = _slicedToArray$1(_useState3, 2), wrapperScrollHeight = _useState4[0], setWrapperScrollHeight = _useState4[1];
  var _useState5 = useState(null), _useState6 = _slicedToArray$1(_useState5, 2), wrapperWidth = _useState6[0], setWrapperWidth = _useState6[1];
  var _useState7 = useState(null), _useState8 = _slicedToArray$1(_useState7, 2), wrapperHeight = _useState8[0], setWrapperHeight = _useState8[1];
  var _useState9 = useState(0), _useState10 = _slicedToArray$1(_useState9, 2), addWidth = _useState10[0], setAddWidth = _useState10[1];
  var _useState11 = useState(0), _useState12 = _slicedToArray$1(_useState11, 2), addHeight = _useState12[0], setAddHeight = _useState12[1];
  var _useRafState = useRafState(/* @__PURE__ */ new Map()), _useRafState2 = _slicedToArray$1(_useRafState, 2), tabSizes = _useRafState2[0], setTabSizes = _useRafState2[1];
  var tabOffsets = useOffsets(tabs, tabSizes, wrapperScrollWidth);
  var operationsHiddenClassName = "".concat(prefixCls, "-nav-operations-hidden");
  var transformMin = 0;
  var transformMax = 0;
  if (!tabPositionTopOrBottom) {
    transformMin = Math.min(0, wrapperHeight - wrapperScrollHeight);
    transformMax = 0;
  } else if (rtl) {
    transformMin = 0;
    transformMax = Math.max(0, wrapperScrollWidth - wrapperWidth);
  } else {
    transformMin = Math.min(0, wrapperWidth - wrapperScrollWidth);
    transformMax = 0;
  }
  function alignInRange(value) {
    if (value < transformMin) {
      return transformMin;
    }
    if (value > transformMax) {
      return transformMax;
    }
    return value;
  }
  var touchMovingRef = useRef();
  var _useState13 = useState(), _useState14 = _slicedToArray$1(_useState13, 2), lockAnimation = _useState14[0], setLockAnimation = _useState14[1];
  function doLockAnimation() {
    setLockAnimation(Date.now());
  }
  function clearTouchMoving() {
    window.clearTimeout(touchMovingRef.current);
  }
  useTouchMove(tabsWrapperRef, function(offsetX, offsetY) {
    function doMove(setState2, offset3) {
      setState2(function(value) {
        var newValue = alignInRange(value + offset3);
        return newValue;
      });
    }
    if (tabPositionTopOrBottom) {
      if (wrapperWidth >= wrapperScrollWidth) {
        return false;
      }
      doMove(setTransformLeft, offsetX);
    } else {
      if (wrapperHeight >= wrapperScrollHeight) {
        return false;
      }
      doMove(setTransformTop, offsetY);
    }
    clearTouchMoving();
    doLockAnimation();
    return true;
  });
  useEffect(function() {
    clearTouchMoving();
    if (lockAnimation) {
      touchMovingRef.current = window.setTimeout(function() {
        setLockAnimation(0);
      }, 100);
    }
    return clearTouchMoving;
  }, [lockAnimation]);
  function scrollToTab() {
    var key = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : activeKey;
    var tabOffset = tabOffsets.get(key) || {
      width: 0,
      height: 0,
      left: 0,
      right: 0,
      top: 0
    };
    if (tabPositionTopOrBottom) {
      var newTransform = transformLeft;
      if (rtl) {
        if (tabOffset.right < transformLeft) {
          newTransform = tabOffset.right;
        } else if (tabOffset.right + tabOffset.width > transformLeft + wrapperWidth) {
          newTransform = tabOffset.right + tabOffset.width - wrapperWidth;
        }
      } else if (tabOffset.left < -transformLeft) {
        newTransform = -tabOffset.left;
      } else if (tabOffset.left + tabOffset.width > -transformLeft + wrapperWidth) {
        newTransform = -(tabOffset.left + tabOffset.width - wrapperWidth);
      }
      setTransformTop(0);
      setTransformLeft(alignInRange(newTransform));
    } else {
      var _newTransform = transformTop;
      if (tabOffset.top < -transformTop) {
        _newTransform = -tabOffset.top;
      } else if (tabOffset.top + tabOffset.height > -transformTop + wrapperHeight) {
        _newTransform = -(tabOffset.top + tabOffset.height - wrapperHeight);
      }
      setTransformLeft(0);
      setTransformTop(alignInRange(_newTransform));
    }
  }
  var _useVisibleRange = useVisibleRange(tabOffsets, {
    width: wrapperWidth,
    height: wrapperHeight,
    left: transformLeft,
    top: transformTop
  }, {
    width: wrapperScrollWidth,
    height: wrapperScrollHeight
  }, {
    width: addWidth,
    height: addHeight
  }, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    tabs
  })), _useVisibleRange2 = _slicedToArray$1(_useVisibleRange, 2), visibleStart = _useVisibleRange2[0], visibleEnd = _useVisibleRange2[1];
  var tabNodeStyle = {};
  if (tabPosition === "top" || tabPosition === "bottom") {
    tabNodeStyle[rtl ? "marginRight" : "marginLeft"] = tabBarGutter;
  } else {
    tabNodeStyle.marginTop = tabBarGutter;
  }
  var tabNodes = tabs.map(function(tab, i) {
    var key = tab.key;
    return /* @__PURE__ */ React.createElement(TabNode$1, {
      id: id2,
      prefixCls,
      key,
      tab,
      style: i === 0 ? void 0 : tabNodeStyle,
      closable: tab.closable,
      editable,
      active: key === activeKey,
      renderWrapper: children,
      removeAriaLabel: locale2 === null || locale2 === void 0 ? void 0 : locale2.removeAriaLabel,
      ref: getBtnRef(key),
      onClick: function onClick(e2) {
        onTabClick(key, e2);
      },
      onRemove: function onRemove() {
        removeBtnRef(key);
      },
      onFocus: function onFocus2() {
        scrollToTab(key);
        doLockAnimation();
        if (!tabsWrapperRef.current) {
          return;
        }
        if (!rtl) {
          tabsWrapperRef.current.scrollLeft = 0;
        }
        tabsWrapperRef.current.scrollTop = 0;
      }
    });
  });
  var onListHolderResize = useRaf(function() {
    var _tabsWrapperRef$curre, _tabsWrapperRef$curre2, _innerAddButtonRef$cu, _innerAddButtonRef$cu2, _tabListRef$current, _tabListRef$current2;
    var offsetWidth = ((_tabsWrapperRef$curre = tabsWrapperRef.current) === null || _tabsWrapperRef$curre === void 0 ? void 0 : _tabsWrapperRef$curre.offsetWidth) || 0;
    var offsetHeight = ((_tabsWrapperRef$curre2 = tabsWrapperRef.current) === null || _tabsWrapperRef$curre2 === void 0 ? void 0 : _tabsWrapperRef$curre2.offsetHeight) || 0;
    var newAddWidth = ((_innerAddButtonRef$cu = innerAddButtonRef.current) === null || _innerAddButtonRef$cu === void 0 ? void 0 : _innerAddButtonRef$cu.offsetWidth) || 0;
    var newAddHeight = ((_innerAddButtonRef$cu2 = innerAddButtonRef.current) === null || _innerAddButtonRef$cu2 === void 0 ? void 0 : _innerAddButtonRef$cu2.offsetHeight) || 0;
    setWrapperWidth(offsetWidth);
    setWrapperHeight(offsetHeight);
    setAddWidth(newAddWidth);
    setAddHeight(newAddHeight);
    var newWrapperScrollWidth = (((_tabListRef$current = tabListRef.current) === null || _tabListRef$current === void 0 ? void 0 : _tabListRef$current.offsetWidth) || 0) - newAddWidth;
    var newWrapperScrollHeight = (((_tabListRef$current2 = tabListRef.current) === null || _tabListRef$current2 === void 0 ? void 0 : _tabListRef$current2.offsetHeight) || 0) - newAddHeight;
    setWrapperScrollWidth(newWrapperScrollWidth);
    setWrapperScrollHeight(newWrapperScrollHeight);
    setTabSizes(function() {
      var newSizes = /* @__PURE__ */ new Map();
      tabs.forEach(function(_ref2) {
        var key = _ref2.key;
        var btnNode = getBtnRef(key).current;
        if (btnNode) {
          newSizes.set(key, {
            width: btnNode.offsetWidth,
            height: btnNode.offsetHeight,
            left: btnNode.offsetLeft,
            top: btnNode.offsetTop
          });
        }
      });
      return newSizes;
    });
  });
  var startHiddenTabs = tabs.slice(0, visibleStart);
  var endHiddenTabs = tabs.slice(visibleEnd + 1);
  var hiddenTabs = [].concat(_toConsumableArray(startHiddenTabs), _toConsumableArray(endHiddenTabs));
  var _useState15 = useState(), _useState16 = _slicedToArray$1(_useState15, 2), inkStyle = _useState16[0], setInkStyle = _useState16[1];
  var activeTabOffset = tabOffsets.get(activeKey);
  var inkBarRafRef = useRef();
  function cleanInkBarRaf() {
    wrapperRaf$1.cancel(inkBarRafRef.current);
  }
  useEffect(function() {
    var newInkStyle = {};
    if (activeTabOffset) {
      if (tabPositionTopOrBottom) {
        if (rtl) {
          newInkStyle.right = activeTabOffset.right;
        } else {
          newInkStyle.left = activeTabOffset.left;
        }
        newInkStyle.width = activeTabOffset.width;
      } else {
        newInkStyle.top = activeTabOffset.top;
        newInkStyle.height = activeTabOffset.height;
      }
    }
    cleanInkBarRaf();
    inkBarRafRef.current = wrapperRaf$1(function() {
      setInkStyle(newInkStyle);
    });
    return cleanInkBarRaf;
  }, [activeTabOffset, tabPositionTopOrBottom, rtl]);
  useEffect(function() {
    scrollToTab();
  }, [activeKey, activeTabOffset, tabOffsets, tabPositionTopOrBottom]);
  useEffect(function() {
    onListHolderResize();
  }, [rtl, tabBarGutter, activeKey, tabs.map(function(tab) {
    return tab.key;
  }).join("_")]);
  var hasDropdown = !!hiddenTabs.length;
  var wrapPrefix = "".concat(prefixCls, "-nav-wrap");
  var pingLeft;
  var pingRight;
  var pingTop;
  var pingBottom;
  if (tabPositionTopOrBottom) {
    if (rtl) {
      pingRight = transformLeft > 0;
      pingLeft = transformLeft + wrapperWidth < wrapperScrollWidth;
    } else {
      pingLeft = transformLeft < 0;
      pingRight = -transformLeft + wrapperWidth < wrapperScrollWidth;
    }
  } else {
    pingTop = transformTop < 0;
    pingBottom = -transformTop + wrapperHeight < wrapperScrollHeight;
  }
  return /* @__PURE__ */ React.createElement("div", {
    ref: ref2,
    role: "tablist",
    className: classNames("".concat(prefixCls, "-nav"), className),
    style: style2,
    onKeyDown: function onKeyDown2() {
      doLockAnimation();
    }
  }, /* @__PURE__ */ React.createElement(ExtraContent, {
    position: "left",
    extra,
    prefixCls
  }), /* @__PURE__ */ React.createElement(ResizeObserver, {
    onResize: onListHolderResize
  }, /* @__PURE__ */ React.createElement("div", {
    className: classNames(wrapPrefix, (_classNames = {}, _defineProperty$3(_classNames, "".concat(wrapPrefix, "-ping-left"), pingLeft), _defineProperty$3(_classNames, "".concat(wrapPrefix, "-ping-right"), pingRight), _defineProperty$3(_classNames, "".concat(wrapPrefix, "-ping-top"), pingTop), _defineProperty$3(_classNames, "".concat(wrapPrefix, "-ping-bottom"), pingBottom), _classNames)),
    ref: tabsWrapperRef
  }, /* @__PURE__ */ React.createElement(ResizeObserver, {
    onResize: onListHolderResize
  }, /* @__PURE__ */ React.createElement("div", {
    ref: tabListRef,
    className: "".concat(prefixCls, "-nav-list"),
    style: {
      transform: "translate(".concat(transformLeft, "px, ").concat(transformTop, "px)"),
      transition: lockAnimation ? "none" : void 0
    }
  }, tabNodes, /* @__PURE__ */ React.createElement(AddButton$1, {
    ref: innerAddButtonRef,
    prefixCls,
    locale: locale2,
    editable,
    style: _objectSpread2$3(_objectSpread2$3({}, tabNodes.length === 0 ? void 0 : tabNodeStyle), {}, {
      visibility: hasDropdown ? "hidden" : null
    })
  }), /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-ink-bar"), _defineProperty$3({}, "".concat(prefixCls, "-ink-bar-animated"), animated.inkBar)),
    style: inkStyle
  }))))), /* @__PURE__ */ React.createElement(OperationNode$1, _extends$1({}, props, {
    removeAriaLabel: locale2 === null || locale2 === void 0 ? void 0 : locale2.removeAriaLabel,
    ref: operationsRef,
    prefixCls,
    tabs: hiddenTabs,
    className: !hasDropdown && operationsHiddenClassName,
    tabMoving: !!lockAnimation
  })), /* @__PURE__ */ React.createElement(ExtraContent, {
    position: "right",
    extra,
    prefixCls
  }));
}
var TabNavList$1 = /* @__PURE__ */ React.forwardRef(TabNavList);
function TabPanelList(_ref) {
  var id2 = _ref.id, activeKey = _ref.activeKey, animated = _ref.animated, tabPosition = _ref.tabPosition, rtl = _ref.rtl, destroyInactiveTabPane = _ref.destroyInactiveTabPane;
  var _React$useContext = React.useContext(TabContext), prefixCls = _React$useContext.prefixCls, tabs = _React$useContext.tabs;
  var tabPaneAnimated = animated.tabPane;
  var activeIndex = tabs.findIndex(function(tab) {
    return tab.key === activeKey;
  });
  return /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-content-holder"))
  }, /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-content"), "".concat(prefixCls, "-content-").concat(tabPosition), _defineProperty$3({}, "".concat(prefixCls, "-content-animated"), tabPaneAnimated)),
    style: activeIndex && tabPaneAnimated ? _defineProperty$3({}, rtl ? "marginRight" : "marginLeft", "-".concat(activeIndex, "00%")) : null
  }, tabs.map(function(tab) {
    return /* @__PURE__ */ React.cloneElement(tab.node, {
      key: tab.key,
      prefixCls,
      tabKey: tab.key,
      id: id2,
      animated: tabPaneAnimated,
      active: tab.key === activeKey,
      destroyInactiveTabPane
    });
  })));
}
function TabPane$1(_ref) {
  var prefixCls = _ref.prefixCls, forceRender = _ref.forceRender, className = _ref.className, style2 = _ref.style, id2 = _ref.id, active = _ref.active, animated = _ref.animated, destroyInactiveTabPane = _ref.destroyInactiveTabPane, tabKey = _ref.tabKey, children = _ref.children;
  var _React$useState = React.useState(forceRender), _React$useState2 = _slicedToArray$1(_React$useState, 2), visited = _React$useState2[0], setVisited = _React$useState2[1];
  React.useEffect(function() {
    if (active) {
      setVisited(true);
    } else if (destroyInactiveTabPane) {
      setVisited(false);
    }
  }, [active, destroyInactiveTabPane]);
  var mergedStyle = {};
  if (!active) {
    if (animated) {
      mergedStyle.visibility = "hidden";
      mergedStyle.height = 0;
      mergedStyle.overflowY = "hidden";
    } else {
      mergedStyle.display = "none";
    }
  }
  return /* @__PURE__ */ React.createElement("div", {
    id: id2 && "".concat(id2, "-panel-").concat(tabKey),
    role: "tabpanel",
    tabIndex: active ? 0 : -1,
    "aria-labelledby": id2 && "".concat(id2, "-tab-").concat(tabKey),
    "aria-hidden": !active,
    style: _objectSpread2$3(_objectSpread2$3({}, mergedStyle), style2),
    className: classNames("".concat(prefixCls, "-tabpane"), active && "".concat(prefixCls, "-tabpane-active"), className)
  }, (active || visited || forceRender) && children);
}
var _excluded$3 = ["id", "prefixCls", "className", "children", "direction", "activeKey", "defaultActiveKey", "editable", "animated", "tabPosition", "tabBarGutter", "tabBarStyle", "tabBarExtraContent", "locale", "moreIcon", "moreTransitionName", "destroyInactiveTabPane", "renderTabBar", "onChange", "onTabClick", "onTabScroll"];
var uuid$1 = 0;
function parseTabList(children) {
  return toArray$1(children).map(function(node) {
    if (/* @__PURE__ */ React.isValidElement(node)) {
      var key = node.key !== void 0 ? String(node.key) : void 0;
      return _objectSpread2$3(_objectSpread2$3({
        key
      }, node.props), {}, {
        node
      });
    }
    return null;
  }).filter(function(tab) {
    return tab;
  });
}
function Tabs$1(_ref, ref2) {
  var _classNames;
  var id2 = _ref.id, _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-tabs" : _ref$prefixCls, className = _ref.className, children = _ref.children, direction = _ref.direction, activeKey = _ref.activeKey, defaultActiveKey = _ref.defaultActiveKey, editable = _ref.editable, _ref$animated = _ref.animated, animated = _ref$animated === void 0 ? {
    inkBar: true,
    tabPane: false
  } : _ref$animated, _ref$tabPosition = _ref.tabPosition, tabPosition = _ref$tabPosition === void 0 ? "top" : _ref$tabPosition, tabBarGutter = _ref.tabBarGutter, tabBarStyle = _ref.tabBarStyle, tabBarExtraContent = _ref.tabBarExtraContent, locale2 = _ref.locale, moreIcon = _ref.moreIcon, moreTransitionName = _ref.moreTransitionName, destroyInactiveTabPane = _ref.destroyInactiveTabPane, renderTabBar = _ref.renderTabBar, onChange3 = _ref.onChange, onTabClick = _ref.onTabClick, onTabScroll = _ref.onTabScroll, restProps = _objectWithoutProperties$1(_ref, _excluded$3);
  var tabs = parseTabList(children);
  var rtl = direction === "rtl";
  var mergedAnimated;
  if (animated === false) {
    mergedAnimated = {
      inkBar: false,
      tabPane: false
    };
  } else if (animated === true) {
    mergedAnimated = {
      inkBar: true,
      tabPane: true
    };
  } else {
    mergedAnimated = _objectSpread2$3({
      inkBar: true,
      tabPane: false
    }, _typeof$1(animated) === "object" ? animated : {});
  }
  var _useState = useState(false), _useState2 = _slicedToArray$1(_useState, 2), mobile = _useState2[0], setMobile = _useState2[1];
  useEffect(function() {
    setMobile(isMobile());
  }, []);
  var _useMergedState = useControlledState(function() {
    var _tabs$;
    return (_tabs$ = tabs[0]) === null || _tabs$ === void 0 ? void 0 : _tabs$.key;
  }, {
    value: activeKey,
    defaultValue: defaultActiveKey
  }), _useMergedState2 = _slicedToArray$1(_useMergedState, 2), mergedActiveKey = _useMergedState2[0], setMergedActiveKey = _useMergedState2[1];
  var _useState3 = useState(function() {
    return tabs.findIndex(function(tab) {
      return tab.key === mergedActiveKey;
    });
  }), _useState4 = _slicedToArray$1(_useState3, 2), activeIndex = _useState4[0], setActiveIndex = _useState4[1];
  useEffect(function() {
    var newActiveIndex = tabs.findIndex(function(tab) {
      return tab.key === mergedActiveKey;
    });
    if (newActiveIndex === -1) {
      var _tabs$newActiveIndex;
      newActiveIndex = Math.max(0, Math.min(activeIndex, tabs.length - 1));
      setMergedActiveKey((_tabs$newActiveIndex = tabs[newActiveIndex]) === null || _tabs$newActiveIndex === void 0 ? void 0 : _tabs$newActiveIndex.key);
    }
    setActiveIndex(newActiveIndex);
  }, [tabs.map(function(tab) {
    return tab.key;
  }).join("_"), mergedActiveKey, activeIndex]);
  var _useMergedState3 = useControlledState(null, {
    value: id2
  }), _useMergedState4 = _slicedToArray$1(_useMergedState3, 2), mergedId = _useMergedState4[0], setMergedId = _useMergedState4[1];
  var mergedTabPosition = tabPosition;
  if (mobile && !["left", "right"].includes(tabPosition)) {
    mergedTabPosition = "top";
  }
  useEffect(function() {
    if (!id2) {
      setMergedId("rc-tabs-".concat(uuid$1));
      uuid$1 += 1;
    }
  }, []);
  function onInternalTabClick(key, e2) {
    onTabClick === null || onTabClick === void 0 ? void 0 : onTabClick(key, e2);
    var isActiveChanged = key !== mergedActiveKey;
    setMergedActiveKey(key);
    if (isActiveChanged) {
      onChange3 === null || onChange3 === void 0 ? void 0 : onChange3(key);
    }
  }
  var sharedProps = {
    id: mergedId,
    activeKey: mergedActiveKey,
    animated: mergedAnimated,
    tabPosition: mergedTabPosition,
    rtl,
    mobile
  };
  var tabNavBar;
  var tabNavBarProps = _objectSpread2$3(_objectSpread2$3({}, sharedProps), {}, {
    editable,
    locale: locale2,
    moreIcon,
    moreTransitionName,
    tabBarGutter,
    onTabClick: onInternalTabClick,
    onTabScroll,
    extra: tabBarExtraContent,
    style: tabBarStyle,
    panes: children
  });
  if (renderTabBar) {
    tabNavBar = renderTabBar(tabNavBarProps, TabNavList$1);
  } else {
    tabNavBar = /* @__PURE__ */ React.createElement(TabNavList$1, tabNavBarProps);
  }
  return /* @__PURE__ */ React.createElement(TabContext.Provider, {
    value: {
      tabs,
      prefixCls
    }
  }, /* @__PURE__ */ React.createElement("div", _extends$1({
    ref: ref2,
    id: id2,
    className: classNames(prefixCls, "".concat(prefixCls, "-").concat(mergedTabPosition), (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-mobile"), mobile), _defineProperty$3(_classNames, "".concat(prefixCls, "-editable"), editable), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), rtl), _classNames), className)
  }, restProps), tabNavBar, /* @__PURE__ */ React.createElement(TabPanelList, _extends$1({
    destroyInactiveTabPane
  }, sharedProps, {
    animated: mergedAnimated
  }))));
}
var ForwardTabs = /* @__PURE__ */ React.forwardRef(Tabs$1);
ForwardTabs.TabPane = TabPane$1;
var PlusOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z" } }, { "tag": "path", "attrs": { "d": "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z" } }] }, "name": "plus", "theme": "outlined" };
var PlusOutlinedSvg = PlusOutlined$2;
var PlusOutlined = function PlusOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: PlusOutlinedSvg
  }));
};
PlusOutlined.displayName = "PlusOutlined";
var PlusOutlined$1 = /* @__PURE__ */ React.forwardRef(PlusOutlined);
var __rest$6 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function Tabs(_a2) {
  var type4 = _a2.type, className = _a2.className, propSize = _a2.size, _onEdit = _a2.onEdit, hideAdd = _a2.hideAdd, centered = _a2.centered, addIcon = _a2.addIcon, props = __rest$6(_a2, ["type", "className", "size", "onEdit", "hideAdd", "centered", "addIcon"]);
  var customizePrefixCls = props.prefixCls, _props$moreIcon = props.moreIcon, moreIcon = _props$moreIcon === void 0 ? /* @__PURE__ */ React.createElement(EllipsisOutlined$1, null) : _props$moreIcon;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var prefixCls = getPrefixCls("tabs", customizePrefixCls);
  var editable;
  if (type4 === "editable-card") {
    editable = {
      onEdit: function onEdit(editType, _ref) {
        var key = _ref.key, event = _ref.event;
        _onEdit === null || _onEdit === void 0 ? void 0 : _onEdit(editType === "add" ? event : key, editType);
      },
      removeIcon: /* @__PURE__ */ React.createElement(CloseOutlined$1, null),
      addIcon: addIcon || /* @__PURE__ */ React.createElement(PlusOutlined$1, null),
      showAdd: hideAdd !== true
    };
  }
  var rootPrefixCls = getPrefixCls();
  devWarning(!("onPrevClick" in props) && !("onNextClick" in props), "Tabs", "`onPrevClick` and `onNextClick` has been removed. Please use `onTabScroll` instead.");
  return /* @__PURE__ */ React.createElement(SizeContext$1.Consumer, null, function(contextSize) {
    var _classNames;
    var size = propSize !== void 0 ? propSize : contextSize;
    return /* @__PURE__ */ React.createElement(ForwardTabs, _extends$1({
      direction,
      moreTransitionName: "".concat(rootPrefixCls, "-slide-up")
    }, props, {
      className: classNames((_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(size), size), _defineProperty$3(_classNames, "".concat(prefixCls, "-card"), ["card", "editable-card"].includes(type4)), _defineProperty$3(_classNames, "".concat(prefixCls, "-editable-card"), type4 === "editable-card"), _defineProperty$3(_classNames, "".concat(prefixCls, "-centered"), centered), _classNames), className),
      editable,
      moreIcon,
      prefixCls
    }));
  });
}
Tabs.TabPane = TabPane$1;
var RowContext = /* @__PURE__ */ createContext({});
var RowContext$1 = RowContext;
var canUseDocElement = function canUseDocElement2() {
  return canUseDom() && window.document.documentElement;
};
var flexGapSupported;
var detectFlexGapSupported = function detectFlexGapSupported2() {
  if (!canUseDocElement()) {
    return false;
  }
  if (flexGapSupported !== void 0) {
    return flexGapSupported;
  }
  var flex = document.createElement("div");
  flex.style.display = "flex";
  flex.style.flexDirection = "column";
  flex.style.rowGap = "1px";
  flex.appendChild(document.createElement("div"));
  flex.appendChild(document.createElement("div"));
  document.body.appendChild(flex);
  flexGapSupported = flex.scrollHeight === 1;
  document.body.removeChild(flex);
  return flexGapSupported;
};
var useFlexGapSupport = function() {
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray$1(_React$useState, 2), flexible = _React$useState2[0], setFlexible = _React$useState2[1];
  React.useEffect(function() {
    setFlexible(detectFlexGapSupported());
  }, []);
  return flexible;
};
var __rest$5 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
tuple("top", "middle", "bottom", "stretch");
tuple("start", "end", "center", "space-around", "space-between");
var Row = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var _classNames;
  var customizePrefixCls = props.prefixCls, justify = props.justify, align = props.align, className = props.className, style2 = props.style, children = props.children, _props$gutter = props.gutter, gutter = _props$gutter === void 0 ? 0 : _props$gutter, wrap = props.wrap, others = __rest$5(props, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useState = React.useState({
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
    xxl: true
  }), _React$useState2 = _slicedToArray$1(_React$useState, 2), screens2 = _React$useState2[0], setScreens = _React$useState2[1];
  var supportFlexGap = useFlexGapSupport();
  var gutterRef = React.useRef(gutter);
  React.useEffect(function() {
    var token = ResponsiveObserve.subscribe(function(screen) {
      var currentGutter = gutterRef.current || 0;
      if (!Array.isArray(currentGutter) && _typeof$1(currentGutter) === "object" || Array.isArray(currentGutter) && (_typeof$1(currentGutter[0]) === "object" || _typeof$1(currentGutter[1]) === "object")) {
        setScreens(screen);
      }
    });
    return function() {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  var getGutter = function getGutter2() {
    var results = [0, 0];
    var normalizedGutter = Array.isArray(gutter) ? gutter : [gutter, 0];
    normalizedGutter.forEach(function(g2, index2) {
      if (_typeof$1(g2) === "object") {
        for (var i = 0; i < responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (screens2[breakpoint] && g2[breakpoint] !== void 0) {
            results[index2] = g2[breakpoint];
            break;
          }
        }
      } else {
        results[index2] = g2 || 0;
      }
    });
    return results;
  };
  var prefixCls = getPrefixCls("row", customizePrefixCls);
  var gutters = getGutter();
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-no-wrap"), wrap === false), _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(justify), justify), _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(align), align), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var rowStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / -2 : void 0;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / -2 : void 0;
  if (horizontalGutter) {
    rowStyle.marginLeft = horizontalGutter;
    rowStyle.marginRight = horizontalGutter;
  }
  if (supportFlexGap) {
    var _gutters = _slicedToArray$1(gutters, 2);
    rowStyle.rowGap = _gutters[1];
  } else if (verticalGutter) {
    rowStyle.marginTop = verticalGutter;
    rowStyle.marginBottom = verticalGutter;
  }
  var _gutters2 = _slicedToArray$1(gutters, 2), gutterH = _gutters2[0], gutterV = _gutters2[1];
  var rowContext = React.useMemo(function() {
    return {
      gutter: [gutterH, gutterV],
      wrap,
      supportFlexGap
    };
  }, [gutterH, gutterV, wrap, supportFlexGap]);
  return /* @__PURE__ */ React.createElement(RowContext$1.Provider, {
    value: rowContext
  }, /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    className: classes,
    style: _extends$1(_extends$1({}, rowStyle), style2),
    ref: ref2
  }), children));
});
Row.displayName = "Row";
var Row$1 = Row;
var __rest$4 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function parseFlex(flex) {
  if (typeof flex === "number") {
    return "".concat(flex, " ").concat(flex, " auto");
  }
  if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(flex)) {
    return "0 0 ".concat(flex);
  }
  return flex;
}
var sizes = ["xs", "sm", "md", "lg", "xl", "xxl"];
var Col = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useContext2 = React.useContext(RowContext$1), gutter = _React$useContext2.gutter, wrap = _React$useContext2.wrap, supportFlexGap = _React$useContext2.supportFlexGap;
  var customizePrefixCls = props.prefixCls, span = props.span, order = props.order, offset3 = props.offset, push2 = props.push, pull = props.pull, className = props.className, children = props.children, flex = props.flex, style2 = props.style, others = __rest$4(props, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]);
  var prefixCls = getPrefixCls("col", customizePrefixCls);
  var sizeClassObj = {};
  sizes.forEach(function(size) {
    var _extends2;
    var sizeProps = {};
    var propSize = props[size];
    if (typeof propSize === "number") {
      sizeProps.span = propSize;
    } else if (_typeof$1(propSize) === "object") {
      sizeProps = propSize || {};
    }
    delete others[size];
    sizeClassObj = _extends$1(_extends$1({}, sizeClassObj), (_extends2 = {}, _defineProperty$3(_extends2, "".concat(prefixCls, "-").concat(size, "-").concat(sizeProps.span), sizeProps.span !== void 0), _defineProperty$3(_extends2, "".concat(prefixCls, "-").concat(size, "-order-").concat(sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty$3(_extends2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty$3(_extends2, "".concat(prefixCls, "-").concat(size, "-push-").concat(sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty$3(_extends2, "".concat(prefixCls, "-").concat(size, "-pull-").concat(sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _defineProperty$3(_extends2, "".concat(prefixCls, "-rtl"), direction === "rtl"), _extends2));
  });
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-").concat(span), span !== void 0), _defineProperty$3(_classNames, "".concat(prefixCls, "-order-").concat(order), order), _defineProperty$3(_classNames, "".concat(prefixCls, "-offset-").concat(offset3), offset3), _defineProperty$3(_classNames, "".concat(prefixCls, "-push-").concat(push2), push2), _defineProperty$3(_classNames, "".concat(prefixCls, "-pull-").concat(pull), pull), _classNames), className, sizeClassObj);
  var mergedStyle = {};
  if (gutter && gutter[0] > 0) {
    var horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingLeft = horizontalGutter;
    mergedStyle.paddingRight = horizontalGutter;
  }
  if (gutter && gutter[1] > 0 && !supportFlexGap) {
    var verticalGutter = gutter[1] / 2;
    mergedStyle.paddingTop = verticalGutter;
    mergedStyle.paddingBottom = verticalGutter;
  }
  if (flex) {
    mergedStyle.flex = parseFlex(flex);
    if (wrap === false && !mergedStyle.minWidth) {
      mergedStyle.minWidth = 0;
    }
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    style: _extends$1(_extends$1({}, mergedStyle), style2),
    className: classes,
    ref: ref2
  }), children);
});
Col.displayName = "Col";
var Col$1 = Col;
var __rest$3 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Divider = function Divider2(props) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var customizePrefixCls = props.prefixCls, _props$type = props.type, type4 = _props$type === void 0 ? "horizontal" : _props$type, _props$orientation = props.orientation, orientation = _props$orientation === void 0 ? "center" : _props$orientation, orientationMargin = props.orientationMargin, className = props.className, children = props.children, dashed = props.dashed, plain = props.plain, restProps = __rest$3(props, ["prefixCls", "type", "orientation", "orientationMargin", "className", "children", "dashed", "plain"]);
  var prefixCls = getPrefixCls("divider", customizePrefixCls);
  var orientationPrefix = orientation.length > 0 ? "-".concat(orientation) : orientation;
  var hasChildren = !!children;
  var hasCustomMarginLeft = orientation === "left" && orientationMargin != null;
  var hasCustomMarginRight = orientation === "right" && orientationMargin != null;
  var classString = classNames(prefixCls, "".concat(prefixCls, "-").concat(type4), (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-with-text"), hasChildren), _defineProperty$3(_classNames, "".concat(prefixCls, "-with-text").concat(orientationPrefix), hasChildren), _defineProperty$3(_classNames, "".concat(prefixCls, "-dashed"), !!dashed), _defineProperty$3(_classNames, "".concat(prefixCls, "-plain"), !!plain), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _defineProperty$3(_classNames, "".concat(prefixCls, "-no-default-orientation-margin-left"), hasCustomMarginLeft), _defineProperty$3(_classNames, "".concat(prefixCls, "-no-default-orientation-margin-right"), hasCustomMarginRight), _classNames), className);
  var innerStyle = _extends$1(_extends$1({}, hasCustomMarginLeft && {
    marginLeft: orientationMargin
  }), hasCustomMarginRight && {
    marginRight: orientationMargin
  });
  return /* @__PURE__ */ React.createElement("div", _extends$1({
    className: classString
  }, restProps, {
    role: "separator"
  }), children && /* @__PURE__ */ React.createElement("span", {
    className: "".concat(prefixCls, "-inner-text"),
    style: innerStyle
  }, children));
};
var Divider$1 = Divider;
var cached;
function getScrollBarSize(fresh) {
  if (typeof document === "undefined") {
    return 0;
  }
  if (fresh || cached === void 0) {
    var inner2 = document.createElement("div");
    inner2.style.width = "100%";
    inner2.style.height = "200px";
    var outer = document.createElement("div");
    var outerStyle = outer.style;
    outerStyle.position = "absolute";
    outerStyle.top = "0";
    outerStyle.left = "0";
    outerStyle.pointerEvents = "none";
    outerStyle.visibility = "hidden";
    outerStyle.width = "200px";
    outerStyle.height = "150px";
    outerStyle.overflow = "hidden";
    outer.appendChild(inner2);
    document.body.appendChild(outer);
    var widthContained = inner2.offsetWidth;
    outer.style.overflow = "scroll";
    var widthScroll = inner2.offsetWidth;
    if (widthContained === widthScroll) {
      widthScroll = outer.clientWidth;
    }
    document.body.removeChild(outer);
    cached = widthContained - widthScroll;
  }
  return cached;
}
function setStyle(style2) {
  var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!style2) {
    return {};
  }
  var _options$element = options.element, element = _options$element === void 0 ? document.body : _options$element;
  var oldStyle = {};
  var styleKeys = Object.keys(style2);
  styleKeys.forEach(function(key) {
    oldStyle[key] = element.style[key];
  });
  styleKeys.forEach(function(key) {
    element.style[key] = style2[key];
  });
  return oldStyle;
}
function isBodyOverflowing() {
  return document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight) && window.innerWidth > document.body.offsetWidth;
}
var cacheStyle$1 = {};
var switchScrollingEffect = function(close) {
  if (!isBodyOverflowing() && !close) {
    return;
  }
  var scrollingEffectClassName2 = "ant-scrolling-effect";
  var scrollingEffectClassNameReg2 = new RegExp("".concat(scrollingEffectClassName2), "g");
  var bodyClassName = document.body.className;
  if (close) {
    if (!scrollingEffectClassNameReg2.test(bodyClassName))
      return;
    setStyle(cacheStyle$1);
    cacheStyle$1 = {};
    document.body.className = bodyClassName.replace(scrollingEffectClassNameReg2, "").trim();
    return;
  }
  var scrollBarSize = getScrollBarSize();
  if (scrollBarSize) {
    cacheStyle$1 = setStyle({
      position: "relative",
      width: "calc(100% - ".concat(scrollBarSize, "px)")
    });
    if (!scrollingEffectClassNameReg2.test(bodyClassName)) {
      var addClassName = "".concat(bodyClassName, " ").concat(scrollingEffectClassName2);
      document.body.className = addClassName.trim();
    }
  }
};
var locks = [];
var scrollingEffectClassName = "ant-scrolling-effect";
var scrollingEffectClassNameReg = new RegExp("".concat(scrollingEffectClassName), "g");
var uuid = 0;
var cacheStyle = /* @__PURE__ */ new Map();
var ScrollLocker = /* @__PURE__ */ _createClass(function ScrollLocker2(_options) {
  var _this = this;
  _classCallCheck(this, ScrollLocker2);
  this.lockTarget = void 0;
  this.options = void 0;
  this.getContainer = function() {
    var _this$options;
    return (_this$options = _this.options) === null || _this$options === void 0 ? void 0 : _this$options.container;
  };
  this.reLock = function(options) {
    var findLock = locks.find(function(_ref) {
      var target = _ref.target;
      return target === _this.lockTarget;
    });
    if (findLock) {
      _this.unLock();
    }
    _this.options = options;
    if (findLock) {
      findLock.options = options;
      _this.lock();
    }
  };
  this.lock = function() {
    var _this$options3;
    if (locks.some(function(_ref2) {
      var target = _ref2.target;
      return target === _this.lockTarget;
    })) {
      return;
    }
    if (locks.some(function(_ref3) {
      var _this$options2;
      var options = _ref3.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_this$options2 = _this.options) === null || _this$options2 === void 0 ? void 0 : _this$options2.container);
    })) {
      locks = [].concat(_toConsumableArray(locks), [{
        target: _this.lockTarget,
        options: _this.options
      }]);
      return;
    }
    var scrollBarSize = 0;
    var container2 = ((_this$options3 = _this.options) === null || _this$options3 === void 0 ? void 0 : _this$options3.container) || document.body;
    if (container2 === document.body && window.innerWidth - document.documentElement.clientWidth > 0 || container2.scrollHeight > container2.clientHeight) {
      scrollBarSize = getScrollBarSize();
    }
    var containerClassName = container2.className;
    if (locks.filter(function(_ref4) {
      var _this$options4;
      var options = _ref4.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_this$options4 = _this.options) === null || _this$options4 === void 0 ? void 0 : _this$options4.container);
    }).length === 0) {
      cacheStyle.set(container2, setStyle({
        width: scrollBarSize !== 0 ? "calc(100% - ".concat(scrollBarSize, "px)") : void 0,
        overflow: "hidden",
        overflowX: "hidden",
        overflowY: "hidden"
      }, {
        element: container2
      }));
    }
    if (!scrollingEffectClassNameReg.test(containerClassName)) {
      var addClassName = "".concat(containerClassName, " ").concat(scrollingEffectClassName);
      container2.className = addClassName.trim();
    }
    locks = [].concat(_toConsumableArray(locks), [{
      target: _this.lockTarget,
      options: _this.options
    }]);
  };
  this.unLock = function() {
    var _this$options5;
    var findLock = locks.find(function(_ref5) {
      var target = _ref5.target;
      return target === _this.lockTarget;
    });
    locks = locks.filter(function(_ref6) {
      var target = _ref6.target;
      return target !== _this.lockTarget;
    });
    if (!findLock || locks.some(function(_ref7) {
      var _findLock$options;
      var options = _ref7.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_findLock$options = findLock.options) === null || _findLock$options === void 0 ? void 0 : _findLock$options.container);
    })) {
      return;
    }
    var container2 = ((_this$options5 = _this.options) === null || _this$options5 === void 0 ? void 0 : _this$options5.container) || document.body;
    var containerClassName = container2.className;
    if (!scrollingEffectClassNameReg.test(containerClassName))
      return;
    setStyle(cacheStyle.get(container2), {
      element: container2
    });
    cacheStyle.delete(container2);
    container2.className = container2.className.replace(scrollingEffectClassNameReg, "").trim();
  };
  this.lockTarget = uuid++;
  this.options = _options;
});
var openCount = 0;
var supportDom = canUseDom();
var cacheOverflow = {};
var getParent2 = function getParent3(getContainer2) {
  if (!supportDom) {
    return null;
  }
  if (getContainer2) {
    if (typeof getContainer2 === "string") {
      return document.querySelectorAll(getContainer2)[0];
    }
    if (typeof getContainer2 === "function") {
      return getContainer2();
    }
    if (_typeof$1(getContainer2) === "object" && getContainer2 instanceof window.HTMLElement) {
      return getContainer2;
    }
  }
  return document.body;
};
var PortalWrapper = /* @__PURE__ */ function(_React$Component) {
  _inherits(PortalWrapper2, _React$Component);
  var _super = _createSuper(PortalWrapper2);
  function PortalWrapper2(props) {
    var _this;
    _classCallCheck(this, PortalWrapper2);
    _this = _super.call(this, props);
    _this.container = void 0;
    _this.componentRef = /* @__PURE__ */ React.createRef();
    _this.rafId = void 0;
    _this.scrollLocker = void 0;
    _this.renderComponent = void 0;
    _this.updateScrollLocker = function(prevProps) {
      var _ref = prevProps || {}, prevVisible = _ref.visible;
      var _this$props = _this.props, getContainer2 = _this$props.getContainer, visible = _this$props.visible;
      if (visible && visible !== prevVisible && supportDom && getParent2(getContainer2) !== _this.scrollLocker.getContainer()) {
        _this.scrollLocker.reLock({
          container: getParent2(getContainer2)
        });
      }
    };
    _this.updateOpenCount = function(prevProps) {
      var _ref2 = prevProps || {}, prevVisible = _ref2.visible, prevGetContainer = _ref2.getContainer;
      var _this$props2 = _this.props, visible = _this$props2.visible, getContainer2 = _this$props2.getContainer;
      if (visible !== prevVisible && supportDom && getParent2(getContainer2) === document.body) {
        if (visible && !prevVisible) {
          openCount += 1;
        } else if (prevProps) {
          openCount -= 1;
        }
      }
      var getContainerIsFunc = typeof getContainer2 === "function" && typeof prevGetContainer === "function";
      if (getContainerIsFunc ? getContainer2.toString() !== prevGetContainer.toString() : getContainer2 !== prevGetContainer) {
        _this.removeCurrentContainer();
      }
    };
    _this.attachToParent = function() {
      var force = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      if (force || _this.container && !_this.container.parentNode) {
        var parent = getParent2(_this.props.getContainer);
        if (parent) {
          parent.appendChild(_this.container);
          return true;
        }
        return false;
      }
      return true;
    };
    _this.getContainer = function() {
      if (!supportDom) {
        return null;
      }
      if (!_this.container) {
        _this.container = document.createElement("div");
        _this.attachToParent(true);
      }
      _this.setWrapperClassName();
      return _this.container;
    };
    _this.setWrapperClassName = function() {
      var wrapperClassName = _this.props.wrapperClassName;
      if (_this.container && wrapperClassName && wrapperClassName !== _this.container.className) {
        _this.container.className = wrapperClassName;
      }
    };
    _this.removeCurrentContainer = function() {
      var _this$container, _this$container$paren;
      (_this$container = _this.container) === null || _this$container === void 0 ? void 0 : (_this$container$paren = _this$container.parentNode) === null || _this$container$paren === void 0 ? void 0 : _this$container$paren.removeChild(_this.container);
    };
    _this.switchScrollingEffect = function() {
      if (openCount === 1 && !Object.keys(cacheOverflow).length) {
        switchScrollingEffect();
        cacheOverflow = setStyle({
          overflow: "hidden",
          overflowX: "hidden",
          overflowY: "hidden"
        });
      } else if (!openCount) {
        setStyle(cacheOverflow);
        cacheOverflow = {};
        switchScrollingEffect(true);
      }
    };
    _this.scrollLocker = new ScrollLocker({
      container: getParent2(props.getContainer)
    });
    return _this;
  }
  _createClass(PortalWrapper2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.updateOpenCount();
      if (!this.attachToParent()) {
        this.rafId = wrapperRaf$1(function() {
          _this2.forceUpdate();
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      this.updateOpenCount(prevProps);
      this.updateScrollLocker(prevProps);
      this.setWrapperClassName();
      this.attachToParent();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props3 = this.props, visible = _this$props3.visible, getContainer2 = _this$props3.getContainer;
      if (supportDom && getParent2(getContainer2) === document.body) {
        openCount = visible && openCount ? openCount - 1 : openCount;
      }
      this.removeCurrentContainer();
      wrapperRaf$1.cancel(this.rafId);
    }
  }, {
    key: "render",
    value: function render2() {
      var _this$props4 = this.props, children = _this$props4.children, forceRender = _this$props4.forceRender, visible = _this$props4.visible;
      var portal = null;
      var childProps = {
        getOpenCount: function getOpenCount() {
          return openCount;
        },
        getContainer: this.getContainer,
        switchScrollingEffect: this.switchScrollingEffect,
        scrollLocker: this.scrollLocker
      };
      if (forceRender || visible || this.componentRef.current) {
        portal = /* @__PURE__ */ React.createElement(Portal, {
          getContainer: this.getContainer,
          ref: this.componentRef
        }, children(childProps));
      }
      return portal;
    }
  }]);
  return PortalWrapper2;
}(React.Component);
function dataToArray(vars) {
  if (Array.isArray(vars)) {
    return vars;
  }
  return [vars];
}
var transitionEndObject = {
  transition: "transitionend",
  WebkitTransition: "webkitTransitionEnd",
  MozTransition: "transitionend",
  OTransition: "oTransitionEnd otransitionend"
};
var transitionStr = Object.keys(transitionEndObject).filter(function(key) {
  if (typeof document === "undefined") {
    return false;
  }
  var html = document.getElementsByTagName("html")[0];
  return key in (html ? html.style : {});
})[0];
var transitionEnd = transitionEndObject[transitionStr];
function addEventListener(target, eventType, callback, options) {
  if (target.addEventListener) {
    target.addEventListener(eventType, callback, options);
  } else if (target.attachEvent) {
    target.attachEvent("on".concat(eventType), callback);
  }
}
function removeEventListener(target, eventType, callback, options) {
  if (target.removeEventListener) {
    target.removeEventListener(eventType, callback, options);
  } else if (target.attachEvent) {
    target.detachEvent("on".concat(eventType), callback);
  }
}
function transformArguments(arg, cb2) {
  var result = typeof arg === "function" ? arg(cb2) : arg;
  if (Array.isArray(result)) {
    if (result.length === 2) {
      return result;
    }
    return [result[0], result[1]];
  }
  return [result];
}
var isNumeric = function isNumeric2(value) {
  return !isNaN(parseFloat(value)) && isFinite(value);
};
var windowIsUndefined = !(typeof window !== "undefined" && window.document && window.document.createElement);
var getTouchParentScroll = function getTouchParentScroll2(root2, currentTarget, differX, differY) {
  if (!currentTarget || currentTarget === document || currentTarget instanceof Document) {
    return false;
  }
  if (currentTarget === root2.parentNode) {
    return true;
  }
  var isY = Math.max(Math.abs(differX), Math.abs(differY)) === Math.abs(differY);
  var isX = Math.max(Math.abs(differX), Math.abs(differY)) === Math.abs(differX);
  var scrollY = currentTarget.scrollHeight - currentTarget.clientHeight;
  var scrollX = currentTarget.scrollWidth - currentTarget.clientWidth;
  var style2 = document.defaultView.getComputedStyle(currentTarget);
  var overflowY = style2.overflowY === "auto" || style2.overflowY === "scroll";
  var overflowX = style2.overflowX === "auto" || style2.overflowX === "scroll";
  var y2 = scrollY && overflowY;
  var x2 = scrollX && overflowX;
  if (isY && (!y2 || y2 && (currentTarget.scrollTop >= scrollY && differY < 0 || currentTarget.scrollTop <= 0 && differY > 0)) || isX && (!x2 || x2 && (currentTarget.scrollLeft >= scrollX && differX < 0 || currentTarget.scrollLeft <= 0 && differX > 0))) {
    return getTouchParentScroll2(root2, currentTarget.parentNode, differX, differY);
  }
  return false;
};
var _excluded$2 = ["className", "children", "style", "width", "height", "defaultOpen", "open", "prefixCls", "placement", "level", "levelMove", "ease", "duration", "getContainer", "handler", "onChange", "afterVisibleChange", "showMask", "maskClosable", "maskStyle", "onClose", "onHandleClick", "keyboard", "getOpenCount", "scrollLocker", "contentWrapperStyle"];
var currentDrawer = {};
var DrawerChild = /* @__PURE__ */ function(_React$Component) {
  _inherits(DrawerChild2, _React$Component);
  var _super = _createSuper(DrawerChild2);
  function DrawerChild2(props) {
    var _this;
    _classCallCheck(this, DrawerChild2);
    _this = _super.call(this, props);
    _this.levelDom = void 0;
    _this.dom = void 0;
    _this.contentWrapper = void 0;
    _this.contentDom = void 0;
    _this.maskDom = void 0;
    _this.handlerDom = void 0;
    _this.drawerId = void 0;
    _this.timeout = void 0;
    _this.passive = void 0;
    _this.startPos = void 0;
    _this.domFocus = function() {
      if (_this.dom) {
        _this.dom.focus();
      }
    };
    _this.removeStartHandler = function(e2) {
      if (e2.touches.length > 1) {
        _this.startPos = null;
        return;
      }
      _this.startPos = {
        x: e2.touches[0].clientX,
        y: e2.touches[0].clientY
      };
    };
    _this.removeMoveHandler = function(e2) {
      if (e2.changedTouches.length > 1 || !_this.startPos) {
        return;
      }
      var currentTarget = e2.currentTarget;
      var differX = e2.changedTouches[0].clientX - _this.startPos.x;
      var differY = e2.changedTouches[0].clientY - _this.startPos.y;
      if ((currentTarget === _this.maskDom || currentTarget === _this.handlerDom || currentTarget === _this.contentDom && getTouchParentScroll(currentTarget, e2.target, differX, differY)) && e2.cancelable) {
        e2.preventDefault();
      }
    };
    _this.transitionEnd = function(e2) {
      var dom = e2.target;
      removeEventListener(dom, transitionEnd, _this.transitionEnd);
      dom.style.transition = "";
    };
    _this.onKeyDown = function(e2) {
      if (e2.keyCode === KeyCode.ESC) {
        var onClose = _this.props.onClose;
        e2.stopPropagation();
        if (onClose) {
          onClose(e2);
        }
      }
    };
    _this.onWrapperTransitionEnd = function(e2) {
      var _this$props = _this.props, open = _this$props.open, afterVisibleChange2 = _this$props.afterVisibleChange;
      if (e2.target === _this.contentWrapper && e2.propertyName.match(/transform$/)) {
        _this.dom.style.transition = "";
        if (!open && _this.getCurrentDrawerSome()) {
          document.body.style.overflowX = "";
          if (_this.maskDom) {
            _this.maskDom.style.left = "";
            _this.maskDom.style.width = "";
          }
        }
        if (afterVisibleChange2) {
          afterVisibleChange2(!!open);
        }
      }
    };
    _this.openLevelTransition = function() {
      var _this$props2 = _this.props, open = _this$props2.open, width = _this$props2.width, height = _this$props2.height;
      var _this$getHorizontalBo = _this.getHorizontalBoolAndPlacementName(), isHorizontal = _this$getHorizontalBo.isHorizontal, placementName = _this$getHorizontalBo.placementName;
      var contentValue = _this.contentDom ? _this.contentDom.getBoundingClientRect()[isHorizontal ? "width" : "height"] : 0;
      var value = (isHorizontal ? width : height) || contentValue;
      _this.setLevelAndScrolling(open, placementName, value);
    };
    _this.setLevelTransform = function(open, placementName, value, right) {
      var _this$props3 = _this.props, placement = _this$props3.placement, levelMove = _this$props3.levelMove, duration = _this$props3.duration, ease = _this$props3.ease, showMask = _this$props3.showMask;
      _this.levelDom.forEach(function(dom) {
        dom.style.transition = "transform ".concat(duration, " ").concat(ease);
        addEventListener(dom, transitionEnd, _this.transitionEnd);
        var levelValue = open ? value : 0;
        if (levelMove) {
          var $levelMove = transformArguments(levelMove, {
            target: dom,
            open
          });
          levelValue = open ? $levelMove[0] : $levelMove[1] || 0;
        }
        var $value = typeof levelValue === "number" ? "".concat(levelValue, "px") : levelValue;
        var placementPos = placement === "left" || placement === "top" ? $value : "-".concat($value);
        placementPos = showMask && placement === "right" && right ? "calc(".concat(placementPos, " + ").concat(right, "px)") : placementPos;
        dom.style.transform = levelValue ? "".concat(placementName, "(").concat(placementPos, ")") : "";
      });
    };
    _this.setLevelAndScrolling = function(open, placementName, value) {
      var onChange3 = _this.props.onChange;
      if (!windowIsUndefined) {
        var right = document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight) && window.innerWidth > document.body.offsetWidth ? getScrollBarSize(true) : 0;
        _this.setLevelTransform(open, placementName, value, right);
        _this.toggleScrollingToDrawerAndBody(right);
      }
      if (onChange3) {
        onChange3(open);
      }
    };
    _this.toggleScrollingToDrawerAndBody = function(right) {
      var _this$props4 = _this.props, getContainer2 = _this$props4.getContainer, showMask = _this$props4.showMask, open = _this$props4.open;
      var container2 = getContainer2 && getContainer2();
      if (container2 && container2.parentNode === document.body && showMask) {
        var eventArray = ["touchstart"];
        var domArray = [document.body, _this.maskDom, _this.handlerDom, _this.contentDom];
        if (open && document.body.style.overflow !== "hidden") {
          if (right) {
            _this.addScrollingEffect(right);
          }
          document.body.style.touchAction = "none";
          domArray.forEach(function(item, i) {
            if (!item) {
              return;
            }
            addEventListener(item, eventArray[i] || "touchmove", i ? _this.removeMoveHandler : _this.removeStartHandler, _this.passive);
          });
        } else if (_this.getCurrentDrawerSome()) {
          document.body.style.touchAction = "";
          if (right) {
            _this.remScrollingEffect(right);
          }
          domArray.forEach(function(item, i) {
            if (!item) {
              return;
            }
            removeEventListener(item, eventArray[i] || "touchmove", i ? _this.removeMoveHandler : _this.removeStartHandler, _this.passive);
          });
        }
      }
    };
    _this.addScrollingEffect = function(right) {
      var _this$props5 = _this.props, placement = _this$props5.placement, duration = _this$props5.duration, ease = _this$props5.ease;
      var widthTransition = "width ".concat(duration, " ").concat(ease);
      var transformTransition = "transform ".concat(duration, " ").concat(ease);
      _this.dom.style.transition = "none";
      switch (placement) {
        case "right":
          _this.dom.style.transform = "translateX(-".concat(right, "px)");
          break;
        case "top":
        case "bottom":
          _this.dom.style.width = "calc(100% - ".concat(right, "px)");
          _this.dom.style.transform = "translateZ(0)";
          break;
      }
      clearTimeout(_this.timeout);
      _this.timeout = setTimeout(function() {
        if (_this.dom) {
          _this.dom.style.transition = "".concat(transformTransition, ",").concat(widthTransition);
          _this.dom.style.width = "";
          _this.dom.style.transform = "";
        }
      });
    };
    _this.remScrollingEffect = function(right) {
      var _this$props6 = _this.props, placement = _this$props6.placement, duration = _this$props6.duration, ease = _this$props6.ease;
      if (transitionStr) {
        document.body.style.overflowX = "hidden";
      }
      _this.dom.style.transition = "none";
      var heightTransition;
      var widthTransition = "width ".concat(duration, " ").concat(ease);
      var transformTransition = "transform ".concat(duration, " ").concat(ease);
      switch (placement) {
        case "left": {
          _this.dom.style.width = "100%";
          widthTransition = "width 0s ".concat(ease, " ").concat(duration);
          break;
        }
        case "right": {
          _this.dom.style.transform = "translateX(".concat(right, "px)");
          _this.dom.style.width = "100%";
          widthTransition = "width 0s ".concat(ease, " ").concat(duration);
          if (_this.maskDom) {
            _this.maskDom.style.left = "-".concat(right, "px");
            _this.maskDom.style.width = "calc(100% + ".concat(right, "px)");
          }
          break;
        }
        case "top":
        case "bottom": {
          _this.dom.style.width = "calc(100% + ".concat(right, "px)");
          _this.dom.style.height = "100%";
          _this.dom.style.transform = "translateZ(0)";
          heightTransition = "height 0s ".concat(ease, " ").concat(duration);
          break;
        }
      }
      clearTimeout(_this.timeout);
      _this.timeout = setTimeout(function() {
        if (_this.dom) {
          _this.dom.style.transition = "".concat(transformTransition, ",").concat(heightTransition ? "".concat(heightTransition, ",") : "").concat(widthTransition);
          _this.dom.style.transform = "";
          _this.dom.style.width = "";
          _this.dom.style.height = "";
        }
      });
    };
    _this.getCurrentDrawerSome = function() {
      return !Object.keys(currentDrawer).some(function(key) {
        return currentDrawer[key];
      });
    };
    _this.getLevelDom = function(_ref) {
      var level = _ref.level, getContainer2 = _ref.getContainer;
      if (windowIsUndefined) {
        return;
      }
      var container2 = getContainer2 && getContainer2();
      var parent = container2 ? container2.parentNode : null;
      _this.levelDom = [];
      if (level === "all") {
        var children = parent ? Array.prototype.slice.call(parent.children) : [];
        children.forEach(function(child) {
          if (child.nodeName !== "SCRIPT" && child.nodeName !== "STYLE" && child.nodeName !== "LINK" && child !== container2) {
            _this.levelDom.push(child);
          }
        });
      } else if (level) {
        dataToArray(level).forEach(function(key) {
          document.querySelectorAll(key).forEach(function(item) {
            _this.levelDom.push(item);
          });
        });
      }
    };
    _this.getHorizontalBoolAndPlacementName = function() {
      var placement = _this.props.placement;
      var isHorizontal = placement === "left" || placement === "right";
      var placementName = "translate".concat(isHorizontal ? "X" : "Y");
      return {
        isHorizontal,
        placementName
      };
    };
    _this.state = {
      _self: _assertThisInitialized(_this)
    };
    return _this;
  }
  _createClass(DrawerChild2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      if (!windowIsUndefined) {
        var passiveSupported = false;
        try {
          window.addEventListener("test", null, Object.defineProperty({}, "passive", {
            get: function get2() {
              passiveSupported = true;
              return null;
            }
          }));
        } catch (err) {
        }
        this.passive = passiveSupported ? {
          passive: false
        } : false;
      }
      var _this$props7 = this.props, open = _this$props7.open, getContainer2 = _this$props7.getContainer, showMask = _this$props7.showMask, autoFocus = _this$props7.autoFocus;
      var container2 = getContainer2 && getContainer2();
      this.drawerId = "drawer_id_".concat(Number((Date.now() + Math.random()).toString().replace(".", Math.round(Math.random() * 9).toString())).toString(16));
      this.getLevelDom(this.props);
      if (open) {
        if (container2 && container2.parentNode === document.body) {
          currentDrawer[this.drawerId] = open;
        }
        this.openLevelTransition();
        this.forceUpdate(function() {
          if (autoFocus) {
            _this2.domFocus();
          }
        });
        if (showMask) {
          var _this$props$scrollLoc;
          (_this$props$scrollLoc = this.props.scrollLocker) === null || _this$props$scrollLoc === void 0 ? void 0 : _this$props$scrollLoc.lock();
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props8 = this.props, open = _this$props8.open, getContainer2 = _this$props8.getContainer, scrollLocker = _this$props8.scrollLocker, showMask = _this$props8.showMask, autoFocus = _this$props8.autoFocus;
      var container2 = getContainer2 && getContainer2();
      if (open !== prevProps.open) {
        if (container2 && container2.parentNode === document.body) {
          currentDrawer[this.drawerId] = !!open;
        }
        this.openLevelTransition();
        if (open) {
          if (autoFocus) {
            this.domFocus();
          }
          if (showMask) {
            scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.lock();
          }
        } else {
          scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.unLock();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props9 = this.props, open = _this$props9.open, scrollLocker = _this$props9.scrollLocker;
      delete currentDrawer[this.drawerId];
      if (open) {
        this.setLevelTransform(false);
        document.body.style.touchAction = "";
      }
      scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.unLock();
    }
  }, {
    key: "render",
    value: function render2() {
      var _classnames, _this3 = this;
      var _this$props10 = this.props, className = _this$props10.className, children = _this$props10.children, style2 = _this$props10.style, width = _this$props10.width, height = _this$props10.height;
      _this$props10.defaultOpen;
      var $open = _this$props10.open, prefixCls = _this$props10.prefixCls, placement = _this$props10.placement;
      _this$props10.level;
      _this$props10.levelMove;
      _this$props10.ease;
      _this$props10.duration;
      _this$props10.getContainer;
      var handler = _this$props10.handler;
      _this$props10.onChange;
      _this$props10.afterVisibleChange;
      var showMask = _this$props10.showMask, maskClosable = _this$props10.maskClosable, maskStyle = _this$props10.maskStyle, onClose = _this$props10.onClose, onHandleClick = _this$props10.onHandleClick, keyboard = _this$props10.keyboard;
      _this$props10.getOpenCount;
      _this$props10.scrollLocker;
      var contentWrapperStyle = _this$props10.contentWrapperStyle, props = _objectWithoutProperties$1(_this$props10, _excluded$2);
      var open = this.dom ? $open : false;
      var wrapperClassName = classNames(prefixCls, (_classnames = {}, _defineProperty$3(_classnames, "".concat(prefixCls, "-").concat(placement), true), _defineProperty$3(_classnames, "".concat(prefixCls, "-open"), open), _defineProperty$3(_classnames, className || "", !!className), _defineProperty$3(_classnames, "no-mask", !showMask), _classnames));
      var _this$getHorizontalBo2 = this.getHorizontalBoolAndPlacementName(), placementName = _this$getHorizontalBo2.placementName;
      var placementPos = placement === "left" || placement === "top" ? "-100%" : "100%";
      var transform2 = open ? "" : "".concat(placementName, "(").concat(placementPos, ")");
      var handlerChildren = handler && /* @__PURE__ */ React.cloneElement(handler, {
        onClick: function onClick(e2) {
          if (handler.props.onClick) {
            handler.props.onClick();
          }
          if (onHandleClick) {
            onHandleClick(e2);
          }
        },
        ref: function ref2(c2) {
          _this3.handlerDom = c2;
        }
      });
      return /* @__PURE__ */ React.createElement("div", _extends$1({}, omit(props, ["switchScrollingEffect", "autoFocus"]), {
        tabIndex: -1,
        className: wrapperClassName,
        style: style2,
        ref: function ref2(c2) {
          _this3.dom = c2;
        },
        onKeyDown: open && keyboard ? this.onKeyDown : void 0,
        onTransitionEnd: this.onWrapperTransitionEnd
      }), showMask && /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-mask"),
        onClick: maskClosable ? onClose : void 0,
        style: maskStyle,
        ref: function ref2(c2) {
          _this3.maskDom = c2;
        }
      }), /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-content-wrapper"),
        style: _objectSpread2$3({
          transform: transform2,
          msTransform: transform2,
          width: isNumeric(width) ? "".concat(width, "px") : width,
          height: isNumeric(height) ? "".concat(height, "px") : height
        }, contentWrapperStyle),
        ref: function ref2(c2) {
          _this3.contentWrapper = c2;
        }
      }, /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-content"),
        ref: function ref2(c2) {
          _this3.contentDom = c2;
        }
      }, children), handlerChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, _ref2) {
      var prevProps = _ref2.prevProps, _self = _ref2._self;
      var nextState = {
        prevProps: props
      };
      if (prevProps !== void 0) {
        var placement = props.placement, level = props.level;
        if (placement !== prevProps.placement) {
          _self.contentDom = null;
        }
        if (level !== prevProps.level) {
          _self.getLevelDom(props);
        }
      }
      return nextState;
    }
  }]);
  return DrawerChild2;
}(React.Component);
var _excluded$1 = ["defaultOpen", "getContainer", "wrapperClassName", "forceRender", "handler"], _excluded2 = ["visible", "afterClose"];
var DrawerWrapper$1 = /* @__PURE__ */ function(_React$Component) {
  _inherits(DrawerWrapper2, _React$Component);
  var _super = _createSuper(DrawerWrapper2);
  function DrawerWrapper2(props) {
    var _this;
    _classCallCheck(this, DrawerWrapper2);
    _this = _super.call(this, props);
    _this.dom = void 0;
    _this.onHandleClick = function(e2) {
      var _this$props = _this.props, onHandleClick = _this$props.onHandleClick, $open = _this$props.open;
      if (onHandleClick) {
        onHandleClick(e2);
      }
      if (typeof $open === "undefined") {
        var open = _this.state.open;
        _this.setState({
          open: !open
        });
      }
    };
    _this.onClose = function(e2) {
      var _this$props2 = _this.props, onClose = _this$props2.onClose, open = _this$props2.open;
      if (onClose) {
        onClose(e2);
      }
      if (typeof open === "undefined") {
        _this.setState({
          open: false
        });
      }
    };
    var _open = typeof props.open !== "undefined" ? props.open : !!props.defaultOpen;
    _this.state = {
      open: _open
    };
    if ("onMaskClick" in props) {
      console.warn("`onMaskClick` are removed, please use `onClose` instead.");
    }
    return _this;
  }
  _createClass(DrawerWrapper2, [{
    key: "render",
    value: function render2() {
      var _this2 = this;
      var _this$props3 = this.props;
      _this$props3.defaultOpen;
      var getContainer2 = _this$props3.getContainer, wrapperClassName = _this$props3.wrapperClassName, forceRender = _this$props3.forceRender, handler = _this$props3.handler, props = _objectWithoutProperties$1(_this$props3, _excluded$1);
      var open = this.state.open;
      if (!getContainer2) {
        return /* @__PURE__ */ React.createElement("div", {
          className: wrapperClassName,
          ref: function ref2(c2) {
            _this2.dom = c2;
          }
        }, /* @__PURE__ */ React.createElement(DrawerChild, _extends$1({}, props, {
          open,
          handler,
          getContainer: function getContainer3() {
            return _this2.dom;
          },
          onClose: this.onClose,
          onHandleClick: this.onHandleClick
        })));
      }
      var $forceRender = !!handler || forceRender;
      return /* @__PURE__ */ React.createElement(PortalWrapper, {
        visible: open,
        forceRender: $forceRender,
        getContainer: getContainer2,
        wrapperClassName
      }, function(_ref) {
        var visible = _ref.visible, afterClose = _ref.afterClose, rest = _objectWithoutProperties$1(_ref, _excluded2);
        return /* @__PURE__ */ React.createElement(DrawerChild, _extends$1({}, props, rest, {
          open: visible !== void 0 ? visible : open,
          afterVisibleChange: afterClose !== void 0 ? afterClose : props.afterVisibleChange,
          handler,
          onClose: _this2.onClose,
          onHandleClick: _this2.onHandleClick
        }));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, _ref2) {
      var prevProps = _ref2.prevProps;
      var newState = {
        prevProps: props
      };
      if (typeof prevProps !== "undefined" && props.open !== prevProps.open) {
        newState.open = props.open;
      }
      return newState;
    }
  }]);
  return DrawerWrapper2;
}(React.Component);
DrawerWrapper$1.defaultProps = {
  prefixCls: "drawer",
  placement: "left",
  getContainer: "body",
  defaultOpen: false,
  level: "all",
  duration: ".3s",
  ease: "cubic-bezier(0.78, 0.14, 0.15, 0.86)",
  onChange: function onChange2() {
  },
  afterVisibleChange: function afterVisibleChange() {
  },
  handler: /* @__PURE__ */ React.createElement("div", {
    className: "drawer-handle"
  }, /* @__PURE__ */ React.createElement("i", {
    className: "drawer-handle-icon"
  })),
  showMask: true,
  maskClosable: true,
  maskStyle: {},
  wrapperClassName: "",
  className: "",
  keyboard: true,
  forceRender: false,
  autoFocus: true
};
var __rest$2 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var DrawerContext = /* @__PURE__ */ React.createContext(null);
tuple("top", "right", "bottom", "left");
tuple("default", "large");
var defaultPushState = {
  distance: 180
};
var Drawer = /* @__PURE__ */ React.forwardRef(function(_a2, ref2) {
  var width = _a2.width, height = _a2.height, _a$size = _a2.size, size = _a$size === void 0 ? "default" : _a$size, _a$closable = _a2.closable, closable = _a$closable === void 0 ? true : _a$closable, _a$placement = _a2.placement, placement = _a$placement === void 0 ? "right" : _a$placement, _a$maskClosable = _a2.maskClosable, maskClosable = _a$maskClosable === void 0 ? true : _a$maskClosable, _a$mask = _a2.mask, mask = _a$mask === void 0 ? true : _a$mask, _a$level = _a2.level, level = _a$level === void 0 ? null : _a$level, _a$keyboard = _a2.keyboard, keyboard = _a$keyboard === void 0 ? true : _a$keyboard, _a$push = _a2.push, _push = _a$push === void 0 ? defaultPushState : _a$push, _a$closeIcon = _a2.closeIcon, closeIcon = _a$closeIcon === void 0 ? /* @__PURE__ */ React.createElement(CloseOutlined$1, null) : _a$closeIcon, bodyStyle = _a2.bodyStyle, drawerStyle = _a2.drawerStyle, prefixCls = _a2.prefixCls, className = _a2.className, direction = _a2.direction, visible = _a2.visible, children = _a2.children, zIndex = _a2.zIndex, destroyOnClose = _a2.destroyOnClose, style2 = _a2.style, title = _a2.title, headerStyle = _a2.headerStyle, onClose = _a2.onClose, footer = _a2.footer, footerStyle = _a2.footerStyle, extra = _a2.extra, rest = __rest$2(_a2, ["width", "height", "size", "closable", "placement", "maskClosable", "mask", "level", "keyboard", "push", "closeIcon", "bodyStyle", "drawerStyle", "prefixCls", "className", "direction", "visible", "children", "zIndex", "destroyOnClose", "style", "title", "headerStyle", "onClose", "footer", "footerStyle", "extra"]);
  var forceUpdate = useForceUpdate();
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray$1(_React$useState, 2), internalPush = _React$useState2[0], setPush = _React$useState2[1];
  var parentDrawer = React.useContext(DrawerContext);
  var destroyClose = React.useRef(false);
  React.useEffect(function() {
    if (visible && parentDrawer) {
      parentDrawer.push();
    }
    return function() {
      if (parentDrawer) {
        parentDrawer.pull();
      }
    };
  }, []);
  React.useEffect(function() {
    if (parentDrawer) {
      if (visible) {
        parentDrawer.push();
      } else {
        parentDrawer.pull();
      }
    }
  }, [visible]);
  var operations = React.useMemo(function() {
    return {
      push: function push2() {
        if (_push) {
          setPush(true);
        }
      },
      pull: function pull() {
        if (_push) {
          setPush(false);
        }
      }
    };
  }, [_push]);
  React.useImperativeHandle(ref2, function() {
    return operations;
  }, [operations]);
  var isDestroyOnClose = destroyOnClose && !visible;
  var onDestroyTransitionEnd = function onDestroyTransitionEnd2() {
    if (!isDestroyOnClose) {
      return;
    }
    if (!visible) {
      destroyClose.current = true;
      forceUpdate();
    }
  };
  var getOffsetStyle = function getOffsetStyle2() {
    if (!visible && !mask) {
      return {};
    }
    var offsetStyle2 = {};
    if (placement === "left" || placement === "right") {
      var defaultWidth = size === "large" ? 736 : 378;
      offsetStyle2.width = typeof width === "undefined" ? defaultWidth : width;
    } else {
      var defaultHeight = size === "large" ? 736 : 378;
      offsetStyle2.height = typeof height === "undefined" ? defaultHeight : height;
    }
    return offsetStyle2;
  };
  var getRcDrawerStyle = function getRcDrawerStyle2() {
    var getPushTransform = function getPushTransform2(_placement) {
      var distance2;
      if (typeof _push === "boolean") {
        distance2 = _push ? defaultPushState.distance : 0;
      } else {
        distance2 = _push.distance;
      }
      distance2 = parseFloat(String(distance2 || 0));
      if (_placement === "left" || _placement === "right") {
        return "translateX(".concat(_placement === "left" ? distance2 : -distance2, "px)");
      }
      if (_placement === "top" || _placement === "bottom") {
        return "translateY(".concat(_placement === "top" ? distance2 : -distance2, "px)");
      }
    };
    var offsetStyle2 = mask ? {} : getOffsetStyle();
    return _extends$1(_extends$1({
      zIndex,
      transform: internalPush ? getPushTransform(placement) : void 0
    }, offsetStyle2), style2);
  };
  var closeIconNode = closable && /* @__PURE__ */ React.createElement("button", {
    type: "button",
    onClick: onClose,
    "aria-label": "Close",
    className: "".concat(prefixCls, "-close")
  }, closeIcon);
  function renderHeader() {
    if (!title && !closable) {
      return null;
    }
    return /* @__PURE__ */ React.createElement("div", {
      className: classNames("".concat(prefixCls, "-header"), _defineProperty$3({}, "".concat(prefixCls, "-header-close-only"), closable && !title && !extra)),
      style: headerStyle
    }, /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-header-title")
    }, closeIconNode, title && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-title")
    }, title)), extra && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-extra")
    }, extra));
  }
  function renderFooter() {
    if (!footer) {
      return null;
    }
    var footerClassName = "".concat(prefixCls, "-footer");
    return /* @__PURE__ */ React.createElement("div", {
      className: footerClassName,
      style: footerStyle
    }, footer);
  }
  var renderBody = function renderBody2() {
    if (destroyClose.current && !visible) {
      return null;
    }
    destroyClose.current = false;
    var containerStyle = {};
    if (isDestroyOnClose) {
      containerStyle.opacity = 0;
      containerStyle.transition = "opacity .3s";
    }
    return /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-wrapper-body"),
      style: _extends$1(_extends$1({}, containerStyle), drawerStyle),
      onTransitionEnd: onDestroyTransitionEnd
    }, renderHeader(), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-body"),
      style: bodyStyle
    }, children), renderFooter());
  };
  var drawerClassName = classNames(_defineProperty$3({
    "no-mask": !mask
  }, "".concat(prefixCls, "-rtl"), direction === "rtl"), className);
  var offsetStyle = mask ? getOffsetStyle() : {};
  return /* @__PURE__ */ React.createElement(DrawerContext.Provider, {
    value: operations
  }, /* @__PURE__ */ React.createElement(DrawerWrapper$1, _extends$1({
    handler: false
  }, _extends$1({
    placement,
    prefixCls,
    maskClosable,
    level,
    keyboard,
    children,
    onClose
  }, rest), offsetStyle, {
    open: visible,
    showMask: mask,
    style: getRcDrawerStyle(),
    className: drawerClassName
  }), renderBody()));
});
Drawer.displayName = "Drawer";
var DrawerWrapper = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var customizePrefixCls = props.prefixCls, customizeGetContainer = props.getContainer;
  var _React$useContext = React.useContext(ConfigContext), getPopupContainer = _React$useContext.getPopupContainer, getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var prefixCls = getPrefixCls("drawer", customizePrefixCls);
  var getContainer2 = customizeGetContainer === void 0 && getPopupContainer ? function() {
    return getPopupContainer(document.body);
  } : customizeGetContainer;
  return /* @__PURE__ */ React.createElement(Drawer, _extends$1({}, props, {
    ref: ref2,
    prefixCls,
    getContainer: getContainer2,
    direction
  }));
});
DrawerWrapper.displayName = "DrawerWrapper";
var Drawer$1 = DrawerWrapper;
var UpOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M890.5 755.3L537.9 269.2c-12.8-17.6-39-17.6-51.7 0L133.5 755.3A8 8 0 00140 768h75c5.1 0 9.9-2.5 12.9-6.6L512 369.8l284.1 391.6c3 4.1 7.8 6.6 12.9 6.6h75c6.5 0 10.3-7.4 6.5-12.7z" } }] }, "name": "up", "theme": "outlined" };
var UpOutlinedSvg = UpOutlined$2;
var UpOutlined = function UpOutlined2(props, ref2) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$3(_objectSpread2$3({}, props), {}, {
    ref: ref2,
    icon: UpOutlinedSvg
  }));
};
UpOutlined.displayName = "UpOutlined";
var UpOutlined$1 = /* @__PURE__ */ React.forwardRef(UpOutlined);
function Item(_ref) {
  var className = _ref.className, direction = _ref.direction, index2 = _ref.index, marginDirection = _ref.marginDirection, children = _ref.children, split2 = _ref.split, wrap = _ref.wrap;
  var _React$useContext = React.useContext(SpaceContext), horizontalSize = _React$useContext.horizontalSize, verticalSize = _React$useContext.verticalSize, latestIndex = _React$useContext.latestIndex, supportFlexGap = _React$useContext.supportFlexGap;
  var style2 = {};
  if (!supportFlexGap) {
    if (direction === "vertical") {
      if (index2 < latestIndex) {
        style2 = {
          marginBottom: horizontalSize / (split2 ? 2 : 1)
        };
      }
    } else {
      style2 = _extends$1(_extends$1({}, index2 < latestIndex && _defineProperty$3({}, marginDirection, horizontalSize / (split2 ? 2 : 1))), wrap && {
        paddingBottom: verticalSize
      });
    }
  }
  if (children === null || children === void 0) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement("div", {
    className,
    style: style2
  }, children), index2 < latestIndex && split2 && /* @__PURE__ */ React.createElement("span", {
    className: "".concat(className, "-split"),
    style: style2
  }, split2));
}
var __rest$1 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var SpaceContext = /* @__PURE__ */ React.createContext({
  latestIndex: 0,
  horizontalSize: 0,
  verticalSize: 0,
  supportFlexGap: false
});
var spaceSize = {
  small: 8,
  middle: 16,
  large: 24
};
function getNumberSize(size) {
  return typeof size === "string" ? spaceSize[size] : size || 0;
}
var Space = function Space2(props) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, space = _React$useContext.space, directionConfig = _React$useContext.direction;
  var _props$size = props.size, size = _props$size === void 0 ? (space === null || space === void 0 ? void 0 : space.size) || "small" : _props$size, align = props.align, className = props.className, children = props.children, _props$direction = props.direction, direction = _props$direction === void 0 ? "horizontal" : _props$direction, customizePrefixCls = props.prefixCls, split2 = props.split, style2 = props.style, _props$wrap = props.wrap, wrap = _props$wrap === void 0 ? false : _props$wrap, otherProps = __rest$1(props, ["size", "align", "className", "children", "direction", "prefixCls", "split", "style", "wrap"]);
  var supportFlexGap = useFlexGapSupport();
  var _React$useMemo = React.useMemo(function() {
    return (Array.isArray(size) ? size : [size, size]).map(function(item) {
      return getNumberSize(item);
    });
  }, [size]), _React$useMemo2 = _slicedToArray$1(_React$useMemo, 2), horizontalSize = _React$useMemo2[0], verticalSize = _React$useMemo2[1];
  var childNodes = toArray$1(children, {
    keepEmpty: true
  });
  var mergedAlign = align === void 0 && direction === "horizontal" ? "center" : align;
  var prefixCls = getPrefixCls("space", customizePrefixCls);
  var cn = classNames(prefixCls, "".concat(prefixCls, "-").concat(direction), (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), directionConfig === "rtl"), _defineProperty$3(_classNames, "".concat(prefixCls, "-align-").concat(mergedAlign), mergedAlign), _classNames), className);
  var itemClassName = "".concat(prefixCls, "-item");
  var marginDirection = directionConfig === "rtl" ? "marginLeft" : "marginRight";
  var latestIndex = 0;
  var nodes = childNodes.map(function(child, i) {
    if (child !== null && child !== void 0) {
      latestIndex = i;
    }
    var keyOfChild = child && child.key;
    return /* @__PURE__ */ React.createElement(Item, {
      className: itemClassName,
      key: "".concat(itemClassName, "-").concat(keyOfChild || i),
      direction,
      index: i,
      marginDirection,
      split: split2,
      wrap
    }, child);
  });
  var spaceContext = React.useMemo(function() {
    return {
      horizontalSize,
      verticalSize,
      latestIndex,
      supportFlexGap
    };
  }, [horizontalSize, verticalSize, latestIndex, supportFlexGap]);
  if (childNodes.length === 0) {
    return null;
  }
  var gapStyle = {};
  if (wrap) {
    gapStyle.flexWrap = "wrap";
    if (!supportFlexGap) {
      gapStyle.marginBottom = -verticalSize;
    }
  }
  if (supportFlexGap) {
    gapStyle.columnGap = horizontalSize;
    gapStyle.rowGap = verticalSize;
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({
    className: cn,
    style: _extends$1(_extends$1({}, gapStyle), style2)
  }, otherProps), /* @__PURE__ */ React.createElement(SpaceContext.Provider, {
    value: spaceContext
  }, nodes));
};
var Space$1 = Space;
var Switch$2 = React.forwardRef(function(_ref, ref2) {
  var _classNames;
  var _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-switch" : _ref$prefixCls, className = _ref.className, checked = _ref.checked, defaultChecked = _ref.defaultChecked, disabled = _ref.disabled, loadingIcon = _ref.loadingIcon, checkedChildren = _ref.checkedChildren, unCheckedChildren = _ref.unCheckedChildren, onClick = _ref.onClick, onChange3 = _ref.onChange, onKeyDown2 = _ref.onKeyDown, restProps = _objectWithoutProperties$1(_ref, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]);
  var _useMergedState = useControlledState(false, {
    value: checked,
    defaultValue: defaultChecked
  }), _useMergedState2 = _slicedToArray$1(_useMergedState, 2), innerChecked = _useMergedState2[0], setInnerChecked = _useMergedState2[1];
  function triggerChange(newChecked, event) {
    var mergedChecked = innerChecked;
    if (!disabled) {
      mergedChecked = newChecked;
      setInnerChecked(mergedChecked);
      onChange3 === null || onChange3 === void 0 ? void 0 : onChange3(mergedChecked, event);
    }
    return mergedChecked;
  }
  function onInternalKeyDown(e2) {
    if (e2.which === KeyCode.LEFT) {
      triggerChange(false, e2);
    } else if (e2.which === KeyCode.RIGHT) {
      triggerChange(true, e2);
    }
    onKeyDown2 === null || onKeyDown2 === void 0 ? void 0 : onKeyDown2(e2);
  }
  function onInternalClick(e2) {
    var ret = triggerChange(!innerChecked, e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(ret, e2);
  }
  var switchClassName = classNames(prefixCls, className, (_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-checked"), innerChecked), _defineProperty$3(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
  return React.createElement("button", Object.assign({}, restProps, {
    type: "button",
    role: "switch",
    "aria-checked": innerChecked,
    disabled,
    className: switchClassName,
    ref: ref2,
    onKeyDown: onInternalKeyDown,
    onClick: onInternalClick
  }), loadingIcon, React.createElement("span", {
    className: "".concat(prefixCls, "-inner")
  }, innerChecked ? checkedChildren : unCheckedChildren));
});
Switch$2.displayName = "Switch";
var __rest = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Switch = /* @__PURE__ */ React.forwardRef(function(_a2, ref2) {
  var _classNames;
  var customizePrefixCls = _a2.prefixCls, customizeSize = _a2.size, loading = _a2.loading, _a$className = _a2.className, className = _a$className === void 0 ? "" : _a$className, disabled = _a2.disabled, props = __rest(_a2, ["prefixCls", "size", "loading", "className", "disabled"]);
  devWarning("checked" in props || !("value" in props), "Switch", "`value` is not a valid prop, do you mean `checked`?");
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var prefixCls = getPrefixCls("switch", customizePrefixCls);
  var loadingIcon = /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-handle")
  }, loading && /* @__PURE__ */ React.createElement(LoadingOutlined$1, {
    className: "".concat(prefixCls, "-loading-icon")
  }));
  var classes = classNames((_classNames = {}, _defineProperty$3(_classNames, "".concat(prefixCls, "-small"), (customizeSize || size) === "small"), _defineProperty$3(_classNames, "".concat(prefixCls, "-loading"), loading), _defineProperty$3(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement(Wave, {
    insertExtraNode: true
  }, /* @__PURE__ */ React.createElement(Switch$2, _extends$1({}, props, {
    prefixCls,
    className: classes,
    disabled: disabled || loading,
    ref: ref2,
    loadingIcon
  })));
});
Switch.__ANT_SWITCH = true;
Switch.displayName = "Switch";
var Switch$1 = Switch;
var _default = "";
var index$8 = "";
var index$7 = "";
var index$6 = "";
var index$5 = "";
var index$4 = "";
var index$3 = "";
var index$2 = "";
var index$1 = "";
var _excluded = ["className", "component", "viewBox", "spin", "rotate", "tabIndex", "onClick", "children"];
var Icon = /* @__PURE__ */ React.forwardRef(function(props, ref2) {
  var className = props.className, Component2 = props.component, viewBox = props.viewBox, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, children = props.children, restProps = _objectWithoutProperties$1(props, _excluded);
  warning2(Boolean(Component2 || children), "Should have `component` prop or `children`.");
  useInsertStyles();
  var _React$useContext = React.useContext(Context$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, className);
  var svgClassString = classNames(_defineProperty$3({}, "".concat(prefixCls, "-spin"), !!spin));
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var innerSvgProps = _objectSpread2$3(_objectSpread2$3({}, svgBaseProps), {}, {
    className: svgClassString,
    style: svgStyle,
    viewBox
  });
  if (!viewBox) {
    delete innerSvgProps.viewBox;
  }
  var renderInnerNode = function renderInnerNode2() {
    if (Component2) {
      return /* @__PURE__ */ React.createElement(Component2, _objectSpread2$3({}, innerSvgProps), children);
    }
    if (children) {
      warning2(Boolean(viewBox) || React.Children.count(children) === 1 && /* @__PURE__ */ React.isValidElement(children) && React.Children.only(children).type === "use", "Make sure that you provide correct `viewBox` prop (default `0 0 1024 1024`) to the icon.");
      return /* @__PURE__ */ React.createElement("svg", _objectSpread2$3(_objectSpread2$3({}, innerSvgProps), {}, {
        viewBox
      }), children);
    }
    return null;
  };
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  return /* @__PURE__ */ React.createElement("span", _objectSpread2$3(_objectSpread2$3({
    role: "img"
  }, restProps), {}, {
    ref: ref2,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), renderInnerNode());
});
Icon.displayName = "AntdIcon";
var Icon$1 = Icon;
var main = { exports: {} };
(function(module, exports) {
  !function(e2, t2) {
    module.exports = t2(React__default);
  }(commonjsGlobal, function(e2) {
    return function(e3) {
      var t2 = {};
      function n2(a) {
        if (t2[a])
          return t2[a].exports;
        var r2 = t2[a] = { i: a, l: false, exports: {} };
        return e3[a].call(r2.exports, r2, r2.exports, n2), r2.l = true, r2.exports;
      }
      return n2.m = e3, n2.c = t2, n2.d = function(e4, t3, a) {
        n2.o(e4, t3) || Object.defineProperty(e4, t3, { enumerable: true, get: a });
      }, n2.r = function(e4) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e4, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e4, "__esModule", { value: true });
      }, n2.t = function(e4, t3) {
        if (1 & t3 && (e4 = n2(e4)), 8 & t3)
          return e4;
        if (4 & t3 && typeof e4 == "object" && e4 && e4.__esModule)
          return e4;
        var a = /* @__PURE__ */ Object.create(null);
        if (n2.r(a), Object.defineProperty(a, "default", { enumerable: true, value: e4 }), 2 & t3 && typeof e4 != "string")
          for (var r2 in e4)
            n2.d(a, r2, function(t4) {
              return e4[t4];
            }.bind(null, r2));
        return a;
      }, n2.n = function(e4) {
        var t3 = e4 && e4.__esModule ? function() {
          return e4.default;
        } : function() {
          return e4;
        };
        return n2.d(t3, "a", t3), t3;
      }, n2.o = function(e4, t3) {
        return Object.prototype.hasOwnProperty.call(e4, t3);
      }, n2.p = "", n2(n2.s = 48);
    }([function(t2, n2) {
      t2.exports = e2;
    }, function(e3, t2) {
      var n2 = e3.exports = { version: "2.6.12" };
      typeof __e == "number" && (__e = n2);
    }, function(e3, t2, n2) {
      var a = n2(26)("wks"), r2 = n2(17), o = n2(3).Symbol, i = typeof o == "function";
      (e3.exports = function(e4) {
        return a[e4] || (a[e4] = i && o[e4] || (i ? o : r2)("Symbol." + e4));
      }).store = a;
    }, function(e3, t2) {
      var n2 = e3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n2);
    }, function(e3, t2, n2) {
      e3.exports = !n2(8)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2) {
      var n2 = {}.hasOwnProperty;
      e3.exports = function(e4, t3) {
        return n2.call(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(16);
      e3.exports = n2(4) ? function(e4, t3, n3) {
        return a.f(e4, t3, r2(1, n3));
      } : function(e4, t3, n3) {
        return e4[t3] = n3, e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(35), o = n2(23), i = Object.defineProperty;
      t2.f = n2(4) ? Object.defineProperty : function(e4, t3, n3) {
        if (a(e4), t3 = o(t3, true), a(n3), r2)
          try {
            return i(e4, t3, n3);
          } catch (e5) {
          }
        if ("get" in n3 || "set" in n3)
          throw TypeError("Accessors not supported!");
        return "value" in n3 && (e4[t3] = n3.value), e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        try {
          return !!e4();
        } catch (e5) {
          return true;
        }
      };
    }, function(e3, t2, n2) {
      var a = n2(40), r2 = n2(22);
      e3.exports = function(e4) {
        return a(r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4) {
        if (!a(e4))
          throw TypeError(e4 + " is not an object!");
        return e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        return typeof e4 == "object" ? e4 !== null : typeof e4 == "function";
      };
    }, function(e3, t2) {
      e3.exports = {};
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27);
      e3.exports = Object.keys || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2) {
      e3.exports = true;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(53), i = n2(6), s = n2(5), c2 = function(e4, t3, n3) {
        var l2, u, f2, p2 = e4 & c2.F, d2 = e4 & c2.G, b2 = e4 & c2.S, h = e4 & c2.P, v4 = e4 & c2.B, m2 = e4 & c2.W, y2 = d2 ? r2 : r2[t3] || (r2[t3] = {}), g2 = y2.prototype, E = d2 ? a : b2 ? a[t3] : (a[t3] || {}).prototype;
        for (l2 in d2 && (n3 = t3), n3)
          (u = !p2 && E && E[l2] !== void 0) && s(y2, l2) || (f2 = u ? E[l2] : n3[l2], y2[l2] = d2 && typeof E[l2] != "function" ? n3[l2] : v4 && u ? o(f2, a) : m2 && E[l2] == f2 ? function(e5) {
            var t4 = function(t5, n4, a2) {
              if (this instanceof e5) {
                switch (arguments.length) {
                  case 0:
                    return new e5();
                  case 1:
                    return new e5(t5);
                  case 2:
                    return new e5(t5, n4);
                }
                return new e5(t5, n4, a2);
              }
              return e5.apply(this, arguments);
            };
            return t4.prototype = e5.prototype, t4;
          }(f2) : h && typeof f2 == "function" ? o(Function.call, f2) : f2, h && ((y2.virtual || (y2.virtual = {}))[l2] = f2, e4 & c2.R && g2 && !g2[l2] && i(g2, l2, f2)));
      };
      c2.F = 1, c2.G = 2, c2.S = 4, c2.P = 8, c2.B = 16, c2.W = 32, c2.U = 64, c2.R = 128, e3.exports = c2;
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { enumerable: !(1 & e4), configurable: !(2 & e4), writable: !(4 & e4), value: t3 };
      };
    }, function(e3, t2) {
      var n2 = 0, a = Math.random();
      e3.exports = function(e4) {
        return "Symbol(".concat(e4 === void 0 ? "" : e4, ")_", (++n2 + a).toString(36));
      };
    }, function(e3, t2, n2) {
      var a = n2(22);
      e3.exports = function(e4) {
        return Object(a(e4));
      };
    }, function(e3, t2) {
      t2.f = {}.propertyIsEnumerable;
    }, function(e3, t2, n2) {
      var a = n2(52)(true);
      n2(34)(String, "String", function(e4) {
        this._t = String(e4), this._i = 0;
      }, function() {
        var e4, t3 = this._t, n3 = this._i;
        return n3 >= t3.length ? { value: void 0, done: true } : (e4 = a(t3, n3), this._i += e4.length, { value: e4, done: false });
      });
    }, function(e3, t2) {
      var n2 = Math.ceil, a = Math.floor;
      e3.exports = function(e4) {
        return isNaN(e4 = +e4) ? 0 : (e4 > 0 ? a : n2)(e4);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (e4 == null)
          throw TypeError("Can't call method on  " + e4);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4, t3) {
        if (!a(e4))
          return e4;
        var n3, r2;
        if (t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (typeof (n3 = e4.valueOf) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (!t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e3, t2) {
      var n2 = {}.toString;
      e3.exports = function(e4) {
        return n2.call(e4).slice(8, -1);
      };
    }, function(e3, t2, n2) {
      var a = n2(26)("keys"), r2 = n2(17);
      e3.exports = function(e4) {
        return a[e4] || (a[e4] = r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(1), r2 = n2(3), o = r2["__core-js_shared__"] || (r2["__core-js_shared__"] = {});
      (e3.exports = function(e4, t3) {
        return o[e4] || (o[e4] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: a.version, mode: n2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, function(e3, t2) {
      e3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e3, t2, n2) {
      var a = n2(7).f, r2 = n2(5), o = n2(2)("toStringTag");
      e3.exports = function(e4, t3, n3) {
        e4 && !r2(e4 = n3 ? e4 : e4.prototype, o) && a(e4, o, { configurable: true, value: t3 });
      };
    }, function(e3, t2, n2) {
      n2(62);
      for (var a = n2(3), r2 = n2(6), o = n2(12), i = n2(2)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c2 = 0; c2 < s.length; c2++) {
        var l2 = s[c2], u = a[l2], f2 = u && u.prototype;
        f2 && !f2[i] && r2(f2, i, l2), o[l2] = o.Array;
      }
    }, function(e3, t2, n2) {
      t2.f = n2(2);
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(14), i = n2(30), s = n2(7).f;
      e3.exports = function(e4) {
        var t3 = r2.Symbol || (r2.Symbol = o ? {} : a.Symbol || {});
        e4.charAt(0) == "_" || e4 in t3 || s(t3, e4, { value: i.f(e4) });
      };
    }, function(e3, t2) {
      t2.f = Object.getOwnPropertySymbols;
    }, function(e3, t2) {
      e3.exports = function(e4, t3, n2) {
        return Math.min(Math.max(e4, t3), n2);
      };
    }, function(e3, t2, n2) {
      var a = n2(14), r2 = n2(15), o = n2(37), i = n2(6), s = n2(12), c2 = n2(55), l2 = n2(28), u = n2(61), f2 = n2(2)("iterator"), p2 = !([].keys && "next" in [].keys()), d2 = function() {
        return this;
      };
      e3.exports = function(e4, t3, n3, b2, h, v4, m2) {
        c2(n3, t3, b2);
        var y2, g2, E, j = function(e5) {
          if (!p2 && e5 in O2)
            return O2[e5];
          switch (e5) {
            case "keys":
            case "values":
              return function() {
                return new n3(this, e5);
              };
          }
          return function() {
            return new n3(this, e5);
          };
        }, x2 = t3 + " Iterator", _ = h == "values", k2 = false, O2 = e4.prototype, C = O2[f2] || O2["@@iterator"] || h && O2[h], S2 = C || j(h), w2 = h ? _ ? j("entries") : S2 : void 0, A2 = t3 == "Array" && O2.entries || C;
        if (A2 && (E = u(A2.call(new e4()))) !== Object.prototype && E.next && (l2(E, x2, true), a || typeof E[f2] == "function" || i(E, f2, d2)), _ && C && C.name !== "values" && (k2 = true, S2 = function() {
          return C.call(this);
        }), a && !m2 || !p2 && !k2 && O2[f2] || i(O2, f2, S2), s[t3] = S2, s[x2] = d2, h)
          if (y2 = { values: _ ? S2 : j("values"), keys: v4 ? S2 : j("keys"), entries: w2 }, m2)
            for (g2 in y2)
              g2 in O2 || o(O2, g2, y2[g2]);
          else
            r2(r2.P + r2.F * (p2 || k2), t3, y2);
        return y2;
      };
    }, function(e3, t2, n2) {
      e3.exports = !n2(4) && !n2(8)(function() {
        return Object.defineProperty(n2(36)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2, n2) {
      var a = n2(11), r2 = n2(3).document, o = a(r2) && a(r2.createElement);
      e3.exports = function(e4) {
        return o ? r2.createElement(e4) : {};
      };
    }, function(e3, t2, n2) {
      e3.exports = n2(6);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(56), o = n2(27), i = n2(25)("IE_PROTO"), s = function() {
      }, c2 = function() {
        var e4, t3 = n2(36)("iframe"), a2 = o.length;
        for (t3.style.display = "none", n2(60).appendChild(t3), t3.src = "javascript:", (e4 = t3.contentWindow.document).open(), e4.write("<script>document.F=Object<\/script>"), e4.close(), c2 = e4.F; a2--; )
          delete c2.prototype[o[a2]];
        return c2();
      };
      e3.exports = Object.create || function(e4, t3) {
        var n3;
        return e4 !== null ? (s.prototype = a(e4), n3 = new s(), s.prototype = null, n3[i] = e4) : n3 = c2(), t3 === void 0 ? n3 : r2(n3, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(9), o = n2(57)(false), i = n2(25)("IE_PROTO");
      e3.exports = function(e4, t3) {
        var n3, s = r2(e4), c2 = 0, l2 = [];
        for (n3 in s)
          n3 != i && a(s, n3) && l2.push(n3);
        for (; t3.length > c2; )
          a(s, n3 = t3[c2++]) && (~o(l2, n3) || l2.push(n3));
        return l2;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e4) {
        return a(e4) == "String" ? e4.split("") : Object(e4);
      };
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27).concat("length", "prototype");
      t2.f = Object.getOwnPropertyNames || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2, n2) {
      var a = n2(24), r2 = n2(2)("toStringTag"), o = a(function() {
        return arguments;
      }()) == "Arguments";
      e3.exports = function(e4) {
        var t3, n3, i;
        return e4 === void 0 ? "Undefined" : e4 === null ? "Null" : typeof (n3 = function(e5, t4) {
          try {
            return e5[t4];
          } catch (e6) {
          }
        }(t3 = Object(e4), r2)) == "string" ? n3 : o ? a(t3) : (i = a(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : i;
      };
    }, function(e3, t2) {
      var n2;
      n2 = function() {
        return this;
      }();
      try {
        n2 = n2 || new Function("return this")();
      } catch (e4) {
        typeof window == "object" && (n2 = window);
      }
      e3.exports = n2;
    }, function(e3, t2) {
      var n2 = /-?\d+(\.\d+)?%?/g;
      e3.exports = function(e4) {
        return e4.match(n2);
      };
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.getBase16Theme = t2.createStyling = t2.invertTheme = void 0;
      var a = d2(n2(49)), r2 = d2(n2(76)), o = d2(n2(81)), i = d2(n2(89)), s = d2(n2(93)), c2 = function(e4) {
        if (e4 && e4.__esModule)
          return e4;
        var t3 = {};
        if (e4 != null)
          for (var n3 in e4)
            Object.prototype.hasOwnProperty.call(e4, n3) && (t3[n3] = e4[n3]);
        return t3.default = e4, t3;
      }(n2(94)), l2 = d2(n2(132)), u = d2(n2(133)), f2 = d2(n2(138)), p2 = n2(139);
      function d2(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      var b2 = c2.default, h = (0, i.default)(b2), v4 = (0, f2.default)(u.default, p2.rgb2yuv, function(e4) {
        var t3, n3 = (0, o.default)(e4, 3), a2 = n3[0], r3 = n3[1], i2 = n3[2];
        return [(t3 = a2, t3 < 0.25 ? 1 : t3 < 0.5 ? 0.9 - t3 : 1.1 - t3), r3, i2];
      }, p2.yuv2rgb, l2.default), m2 = function(e4) {
        return function(t3) {
          return { className: [t3.className, e4.className].filter(Boolean).join(" "), style: (0, r2.default)({}, t3.style || {}, e4.style || {}) };
        };
      }, y2 = function(e4, t3) {
        var n3 = (0, i.default)(t3);
        for (var o2 in e4)
          n3.indexOf(o2) === -1 && n3.push(o2);
        return n3.reduce(function(n4, o3) {
          return n4[o3] = function(e5, t4) {
            if (e5 === void 0)
              return t4;
            if (t4 === void 0)
              return e5;
            var n5 = e5 === void 0 ? "undefined" : (0, a.default)(e5), o4 = t4 === void 0 ? "undefined" : (0, a.default)(t4);
            switch (n5) {
              case "string":
                switch (o4) {
                  case "string":
                    return [t4, e5].filter(Boolean).join(" ");
                  case "object":
                    return m2({ className: e5, style: t4 });
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ className: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "object":
                switch (o4) {
                  case "string":
                    return m2({ className: t4, style: e5 });
                  case "object":
                    return (0, r2.default)({}, t4, e5);
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ style: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "function":
                switch (o4) {
                  case "string":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ className: t4 })].concat(r3));
                    };
                  case "object":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ style: t4 })].concat(r3));
                    };
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [t4.apply(void 0, [n6].concat(r3))].concat(r3));
                    };
                }
            }
          }(e4[o3], t3[o3]), n4;
        }, {});
      }, g2 = function(e4, t3) {
        for (var n3 = arguments.length, o2 = Array(n3 > 2 ? n3 - 2 : 0), s2 = 2; s2 < n3; s2++)
          o2[s2 - 2] = arguments[s2];
        if (t3 === null)
          return e4;
        Array.isArray(t3) || (t3 = [t3]);
        var c3 = t3.map(function(t4) {
          return e4[t4];
        }).filter(Boolean), l3 = c3.reduce(function(e5, t4) {
          return typeof t4 == "string" ? e5.className = [e5.className, t4].filter(Boolean).join(" ") : (t4 === void 0 ? "undefined" : (0, a.default)(t4)) === "object" ? e5.style = (0, r2.default)({}, e5.style, t4) : typeof t4 == "function" && (e5 = (0, r2.default)({}, e5, t4.apply(void 0, [e5].concat(o2)))), e5;
        }, { className: "", style: {} });
        return l3.className || delete l3.className, (0, i.default)(l3.style).length === 0 && delete l3.style, l3;
      }, E = t2.invertTheme = function(e4) {
        return (0, i.default)(e4).reduce(function(t3, n3) {
          return t3[n3] = /^base/.test(n3) ? v4(e4[n3]) : n3 === "scheme" ? e4[n3] + ":inverted" : e4[n3], t3;
        }, {});
      }, j = (t2.createStyling = (0, s.default)(function(e4) {
        for (var t3 = arguments.length, n3 = Array(t3 > 3 ? t3 - 3 : 0), a2 = 3; a2 < t3; a2++)
          n3[a2 - 3] = arguments[a2];
        var o2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, c3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, l3 = o2.defaultBase16, u2 = l3 === void 0 ? b2 : l3, f3 = o2.base16Themes, p3 = f3 === void 0 ? null : f3, d3 = j(c3, p3);
        d3 && (c3 = (0, r2.default)({}, d3, c3));
        var v5 = h.reduce(function(e5, t4) {
          return e5[t4] = c3[t4] || u2[t4], e5;
        }, {}), m3 = (0, i.default)(c3).reduce(function(e5, t4) {
          return h.indexOf(t4) === -1 ? (e5[t4] = c3[t4], e5) : e5;
        }, {}), E2 = e4(v5), x2 = y2(m3, E2);
        return (0, s.default)(g2, 2).apply(void 0, [x2].concat(n3));
      }, 3), t2.getBase16Theme = function(e4, t3) {
        if (e4 && e4.extend && (e4 = e4.extend), typeof e4 == "string") {
          var n3 = e4.split(":"), a2 = (0, o.default)(n3, 2), r3 = a2[0], i2 = a2[1];
          e4 = (t3 || {})[r3] || c2[r3], i2 === "inverted" && (e4 = E(e4));
        }
        return e4 && e4.hasOwnProperty("base00") ? e4 : void 0;
      });
    }, function(e3, t2, n2) {
      var a, r2 = typeof Reflect == "object" ? Reflect : null, o = r2 && typeof r2.apply == "function" ? r2.apply : function(e4, t3, n3) {
        return Function.prototype.apply.call(e4, t3, n3);
      };
      a = r2 && typeof r2.ownKeys == "function" ? r2.ownKeys : Object.getOwnPropertySymbols ? function(e4) {
        return Object.getOwnPropertyNames(e4).concat(Object.getOwnPropertySymbols(e4));
      } : function(e4) {
        return Object.getOwnPropertyNames(e4);
      };
      var i = Number.isNaN || function(e4) {
        return e4 != e4;
      };
      function s() {
        s.init.call(this);
      }
      e3.exports = s, e3.exports.once = function(e4, t3) {
        return new Promise(function(n3, a2) {
          function r3() {
            o2 !== void 0 && e4.removeListener("error", o2), n3([].slice.call(arguments));
          }
          var o2;
          t3 !== "error" && (o2 = function(n4) {
            e4.removeListener(t3, r3), a2(n4);
          }, e4.once("error", o2)), e4.once(t3, r3);
        });
      }, s.EventEmitter = s, s.prototype._events = void 0, s.prototype._eventsCount = 0, s.prototype._maxListeners = void 0;
      var c2 = 10;
      function l2(e4) {
        if (typeof e4 != "function")
          throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e4);
      }
      function u(e4) {
        return e4._maxListeners === void 0 ? s.defaultMaxListeners : e4._maxListeners;
      }
      function f2(e4, t3, n3, a2) {
        var r3, o2, i2, s2;
        if (l2(n3), (o2 = e4._events) === void 0 ? (o2 = e4._events = /* @__PURE__ */ Object.create(null), e4._eventsCount = 0) : (o2.newListener !== void 0 && (e4.emit("newListener", t3, n3.listener ? n3.listener : n3), o2 = e4._events), i2 = o2[t3]), i2 === void 0)
          i2 = o2[t3] = n3, ++e4._eventsCount;
        else if (typeof i2 == "function" ? i2 = o2[t3] = a2 ? [n3, i2] : [i2, n3] : a2 ? i2.unshift(n3) : i2.push(n3), (r3 = u(e4)) > 0 && i2.length > r3 && !i2.warned) {
          i2.warned = true;
          var c3 = new Error("Possible EventEmitter memory leak detected. " + i2.length + " " + String(t3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
          c3.name = "MaxListenersExceededWarning", c3.emitter = e4, c3.type = t3, c3.count = i2.length, s2 = c3, console && console.warn && console.warn(s2);
        }
        return e4;
      }
      function p2() {
        if (!this.fired)
          return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
      }
      function d2(e4, t3, n3) {
        var a2 = { fired: false, wrapFn: void 0, target: e4, type: t3, listener: n3 }, r3 = p2.bind(a2);
        return r3.listener = n3, a2.wrapFn = r3, r3;
      }
      function b2(e4, t3, n3) {
        var a2 = e4._events;
        if (a2 === void 0)
          return [];
        var r3 = a2[t3];
        return r3 === void 0 ? [] : typeof r3 == "function" ? n3 ? [r3.listener || r3] : [r3] : n3 ? function(e5) {
          for (var t4 = new Array(e5.length), n4 = 0; n4 < t4.length; ++n4)
            t4[n4] = e5[n4].listener || e5[n4];
          return t4;
        }(r3) : v4(r3, r3.length);
      }
      function h(e4) {
        var t3 = this._events;
        if (t3 !== void 0) {
          var n3 = t3[e4];
          if (typeof n3 == "function")
            return 1;
          if (n3 !== void 0)
            return n3.length;
        }
        return 0;
      }
      function v4(e4, t3) {
        for (var n3 = new Array(t3), a2 = 0; a2 < t3; ++a2)
          n3[a2] = e4[a2];
        return n3;
      }
      Object.defineProperty(s, "defaultMaxListeners", { enumerable: true, get: function() {
        return c2;
      }, set: function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        c2 = e4;
      } }), s.init = function() {
        this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
      }, s.prototype.setMaxListeners = function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        return this._maxListeners = e4, this;
      }, s.prototype.getMaxListeners = function() {
        return u(this);
      }, s.prototype.emit = function(e4) {
        for (var t3 = [], n3 = 1; n3 < arguments.length; n3++)
          t3.push(arguments[n3]);
        var a2 = e4 === "error", r3 = this._events;
        if (r3 !== void 0)
          a2 = a2 && r3.error === void 0;
        else if (!a2)
          return false;
        if (a2) {
          var i2;
          if (t3.length > 0 && (i2 = t3[0]), i2 instanceof Error)
            throw i2;
          var s2 = new Error("Unhandled error." + (i2 ? " (" + i2.message + ")" : ""));
          throw s2.context = i2, s2;
        }
        var c3 = r3[e4];
        if (c3 === void 0)
          return false;
        if (typeof c3 == "function")
          o(c3, this, t3);
        else {
          var l3 = c3.length, u2 = v4(c3, l3);
          for (n3 = 0; n3 < l3; ++n3)
            o(u2[n3], this, t3);
        }
        return true;
      }, s.prototype.addListener = function(e4, t3) {
        return f2(this, e4, t3, false);
      }, s.prototype.on = s.prototype.addListener, s.prototype.prependListener = function(e4, t3) {
        return f2(this, e4, t3, true);
      }, s.prototype.once = function(e4, t3) {
        return l2(t3), this.on(e4, d2(this, e4, t3)), this;
      }, s.prototype.prependOnceListener = function(e4, t3) {
        return l2(t3), this.prependListener(e4, d2(this, e4, t3)), this;
      }, s.prototype.removeListener = function(e4, t3) {
        var n3, a2, r3, o2, i2;
        if (l2(t3), (a2 = this._events) === void 0)
          return this;
        if ((n3 = a2[e4]) === void 0)
          return this;
        if (n3 === t3 || n3.listener === t3)
          --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a2[e4], a2.removeListener && this.emit("removeListener", e4, n3.listener || t3));
        else if (typeof n3 != "function") {
          for (r3 = -1, o2 = n3.length - 1; o2 >= 0; o2--)
            if (n3[o2] === t3 || n3[o2].listener === t3) {
              i2 = n3[o2].listener, r3 = o2;
              break;
            }
          if (r3 < 0)
            return this;
          r3 === 0 ? n3.shift() : function(e5, t4) {
            for (; t4 + 1 < e5.length; t4++)
              e5[t4] = e5[t4 + 1];
            e5.pop();
          }(n3, r3), n3.length === 1 && (a2[e4] = n3[0]), a2.removeListener !== void 0 && this.emit("removeListener", e4, i2 || t3);
        }
        return this;
      }, s.prototype.off = s.prototype.removeListener, s.prototype.removeAllListeners = function(e4) {
        var t3, n3, a2;
        if ((n3 = this._events) === void 0)
          return this;
        if (n3.removeListener === void 0)
          return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : n3[e4] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete n3[e4]), this;
        if (arguments.length === 0) {
          var r3, o2 = Object.keys(n3);
          for (a2 = 0; a2 < o2.length; ++a2)
            (r3 = o2[a2]) !== "removeListener" && this.removeAllListeners(r3);
          return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
        }
        if (typeof (t3 = n3[e4]) == "function")
          this.removeListener(e4, t3);
        else if (t3 !== void 0)
          for (a2 = t3.length - 1; a2 >= 0; a2--)
            this.removeListener(e4, t3[a2]);
        return this;
      }, s.prototype.listeners = function(e4) {
        return b2(this, e4, true);
      }, s.prototype.rawListeners = function(e4) {
        return b2(this, e4, false);
      }, s.listenerCount = function(e4, t3) {
        return typeof e4.listenerCount == "function" ? e4.listenerCount(t3) : h.call(e4, t3);
      }, s.prototype.listenerCount = h, s.prototype.eventNames = function() {
        return this._eventsCount > 0 ? a(this._events) : [];
      };
    }, function(e3, t2, n2) {
      e3.exports.Dispatcher = n2(140);
    }, function(e3, t2, n2) {
      e3.exports = n2(142);
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = i(n2(50)), r2 = i(n2(65)), o = typeof r2.default == "function" && typeof a.default == "symbol" ? function(e4) {
        return typeof e4;
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : typeof e4;
      };
      function i(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = typeof r2.default == "function" && o(a.default) === "symbol" ? function(e4) {
        return e4 === void 0 ? "undefined" : o(e4);
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : e4 === void 0 ? "undefined" : o(e4);
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(51), __esModule: true };
    }, function(e3, t2, n2) {
      n2(20), n2(29), e3.exports = n2(30).f("iterator");
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = n2(22);
      e3.exports = function(e4) {
        return function(t3, n3) {
          var o, i, s = String(r2(t3)), c2 = a(n3), l2 = s.length;
          return c2 < 0 || c2 >= l2 ? e4 ? "" : void 0 : (o = s.charCodeAt(c2)) < 55296 || o > 56319 || c2 + 1 === l2 || (i = s.charCodeAt(c2 + 1)) < 56320 || i > 57343 ? e4 ? s.charAt(c2) : o : e4 ? s.slice(c2, c2 + 2) : i - 56320 + (o - 55296 << 10) + 65536;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(54);
      e3.exports = function(e4, t3, n3) {
        if (a(e4), t3 === void 0)
          return e4;
        switch (n3) {
          case 1:
            return function(n4) {
              return e4.call(t3, n4);
            };
          case 2:
            return function(n4, a2) {
              return e4.call(t3, n4, a2);
            };
          case 3:
            return function(n4, a2, r2) {
              return e4.call(t3, n4, a2, r2);
            };
        }
        return function() {
          return e4.apply(t3, arguments);
        };
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (typeof e4 != "function")
          throw TypeError(e4 + " is not a function!");
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(38), r2 = n2(16), o = n2(28), i = {};
      n2(6)(i, n2(2)("iterator"), function() {
        return this;
      }), e3.exports = function(e4, t3, n3) {
        e4.prototype = a(i, { next: r2(1, n3) }), o(e4, t3 + " Iterator");
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(10), o = n2(13);
      e3.exports = n2(4) ? Object.defineProperties : function(e4, t3) {
        r2(e4);
        for (var n3, i = o(t3), s = i.length, c2 = 0; s > c2; )
          a.f(e4, n3 = i[c2++], t3[n3]);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(58), o = n2(59);
      e3.exports = function(e4) {
        return function(t3, n3, i) {
          var s, c2 = a(t3), l2 = r2(c2.length), u = o(i, l2);
          if (e4 && n3 != n3) {
            for (; l2 > u; )
              if ((s = c2[u++]) != s)
                return true;
          } else
            for (; l2 > u; u++)
              if ((e4 || u in c2) && c2[u] === n3)
                return e4 || u || 0;
          return !e4 && -1;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.min;
      e3.exports = function(e4) {
        return e4 > 0 ? r2(a(e4), 9007199254740991) : 0;
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.max, o = Math.min;
      e3.exports = function(e4, t3) {
        return (e4 = a(e4)) < 0 ? r2(e4 + t3, 0) : o(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(3).document;
      e3.exports = a && a.documentElement;
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(18), o = n2(25)("IE_PROTO"), i = Object.prototype;
      e3.exports = Object.getPrototypeOf || function(e4) {
        return e4 = r2(e4), a(e4, o) ? e4[o] : typeof e4.constructor == "function" && e4 instanceof e4.constructor ? e4.constructor.prototype : e4 instanceof Object ? i : null;
      };
    }, function(e3, t2, n2) {
      var a = n2(63), r2 = n2(64), o = n2(12), i = n2(9);
      e3.exports = n2(34)(Array, "Array", function(e4, t3) {
        this._t = i(e4), this._i = 0, this._k = t3;
      }, function() {
        var e4 = this._t, t3 = this._k, n3 = this._i++;
        return !e4 || n3 >= e4.length ? (this._t = void 0, r2(1)) : r2(0, t3 == "keys" ? n3 : t3 == "values" ? e4[n3] : [n3, e4[n3]]);
      }, "values"), o.Arguments = o.Array, a("keys"), a("values"), a("entries");
    }, function(e3, t2) {
      e3.exports = function() {
      };
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { value: t3, done: !!e4 };
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(66), __esModule: true };
    }, function(e3, t2, n2) {
      n2(67), n2(73), n2(74), n2(75), e3.exports = n2(1).Symbol;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(5), o = n2(4), i = n2(15), s = n2(37), c2 = n2(68).KEY, l2 = n2(8), u = n2(26), f2 = n2(28), p2 = n2(17), d2 = n2(2), b2 = n2(30), h = n2(31), v4 = n2(69), m2 = n2(70), y2 = n2(10), g2 = n2(11), E = n2(18), j = n2(9), x2 = n2(23), _ = n2(16), k2 = n2(38), O2 = n2(71), C = n2(72), S2 = n2(32), w2 = n2(7), A2 = n2(13), M2 = C.f, P2 = w2.f, F2 = O2.f, D2 = a.Symbol, I2 = a.JSON, R2 = I2 && I2.stringify, L = d2("_hidden"), B2 = d2("toPrimitive"), N2 = {}.propertyIsEnumerable, z2 = u("symbol-registry"), T2 = u("symbols"), q2 = u("op-symbols"), V2 = Object.prototype, K = typeof D2 == "function" && !!S2.f, W2 = a.QObject, H2 = !W2 || !W2.prototype || !W2.prototype.findChild, U2 = o && l2(function() {
        return k2(P2({}, "a", { get: function() {
          return P2(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e4, t3, n3) {
        var a2 = M2(V2, t3);
        a2 && delete V2[t3], P2(e4, t3, n3), a2 && e4 !== V2 && P2(V2, t3, a2);
      } : P2, G2 = function(e4) {
        var t3 = T2[e4] = k2(D2.prototype);
        return t3._k = e4, t3;
      }, J = K && typeof D2.iterator == "symbol" ? function(e4) {
        return typeof e4 == "symbol";
      } : function(e4) {
        return e4 instanceof D2;
      }, Y2 = function(e4, t3, n3) {
        return e4 === V2 && Y2(q2, t3, n3), y2(e4), t3 = x2(t3, true), y2(n3), r2(T2, t3) ? (n3.enumerable ? (r2(e4, L) && e4[L][t3] && (e4[L][t3] = false), n3 = k2(n3, { enumerable: _(0, false) })) : (r2(e4, L) || P2(e4, L, _(1, {})), e4[L][t3] = true), U2(e4, t3, n3)) : P2(e4, t3, n3);
      }, $ = function(e4, t3) {
        y2(e4);
        for (var n3, a2 = v4(t3 = j(t3)), r3 = 0, o2 = a2.length; o2 > r3; )
          Y2(e4, n3 = a2[r3++], t3[n3]);
        return e4;
      }, Q = function(e4) {
        var t3 = N2.call(this, e4 = x2(e4, true));
        return !(this === V2 && r2(T2, e4) && !r2(q2, e4)) && (!(t3 || !r2(this, e4) || !r2(T2, e4) || r2(this, L) && this[L][e4]) || t3);
      }, Z2 = function(e4, t3) {
        if (e4 = j(e4), t3 = x2(t3, true), e4 !== V2 || !r2(T2, t3) || r2(q2, t3)) {
          var n3 = M2(e4, t3);
          return !n3 || !r2(T2, t3) || r2(e4, L) && e4[L][t3] || (n3.enumerable = true), n3;
        }
      }, X2 = function(e4) {
        for (var t3, n3 = F2(j(e4)), a2 = [], o2 = 0; n3.length > o2; )
          r2(T2, t3 = n3[o2++]) || t3 == L || t3 == c2 || a2.push(t3);
        return a2;
      }, ee2 = function(e4) {
        for (var t3, n3 = e4 === V2, a2 = F2(n3 ? q2 : j(e4)), o2 = [], i2 = 0; a2.length > i2; )
          !r2(T2, t3 = a2[i2++]) || n3 && !r2(V2, t3) || o2.push(T2[t3]);
        return o2;
      };
      K || (s((D2 = function() {
        if (this instanceof D2)
          throw TypeError("Symbol is not a constructor!");
        var e4 = p2(arguments.length > 0 ? arguments[0] : void 0), t3 = function(n3) {
          this === V2 && t3.call(q2, n3), r2(this, L) && r2(this[L], e4) && (this[L][e4] = false), U2(this, e4, _(1, n3));
        };
        return o && H2 && U2(V2, e4, { configurable: true, set: t3 }), G2(e4);
      }).prototype, "toString", function() {
        return this._k;
      }), C.f = Z2, w2.f = Y2, n2(41).f = O2.f = X2, n2(19).f = Q, S2.f = ee2, o && !n2(14) && s(V2, "propertyIsEnumerable", Q, true), b2.f = function(e4) {
        return G2(d2(e4));
      }), i(i.G + i.W + i.F * !K, { Symbol: D2 });
      for (var te2 = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ne2 = 0; te2.length > ne2; )
        d2(te2[ne2++]);
      for (var ae2 = A2(d2.store), re2 = 0; ae2.length > re2; )
        h(ae2[re2++]);
      i(i.S + i.F * !K, "Symbol", { for: function(e4) {
        return r2(z2, e4 += "") ? z2[e4] : z2[e4] = D2(e4);
      }, keyFor: function(e4) {
        if (!J(e4))
          throw TypeError(e4 + " is not a symbol!");
        for (var t3 in z2)
          if (z2[t3] === e4)
            return t3;
      }, useSetter: function() {
        H2 = true;
      }, useSimple: function() {
        H2 = false;
      } }), i(i.S + i.F * !K, "Object", { create: function(e4, t3) {
        return t3 === void 0 ? k2(e4) : $(k2(e4), t3);
      }, defineProperty: Y2, defineProperties: $, getOwnPropertyDescriptor: Z2, getOwnPropertyNames: X2, getOwnPropertySymbols: ee2 });
      var oe2 = l2(function() {
        S2.f(1);
      });
      i(i.S + i.F * oe2, "Object", { getOwnPropertySymbols: function(e4) {
        return S2.f(E(e4));
      } }), I2 && i(i.S + i.F * (!K || l2(function() {
        var e4 = D2();
        return R2([e4]) != "[null]" || R2({ a: e4 }) != "{}" || R2(Object(e4)) != "{}";
      })), "JSON", { stringify: function(e4) {
        for (var t3, n3, a2 = [e4], r3 = 1; arguments.length > r3; )
          a2.push(arguments[r3++]);
        if (n3 = t3 = a2[1], (g2(t3) || e4 !== void 0) && !J(e4))
          return m2(t3) || (t3 = function(e5, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e5, t4)), !J(t4))
              return t4;
          }), a2[1] = t3, R2.apply(I2, a2);
      } }), D2.prototype[B2] || n2(6)(D2.prototype, B2, D2.prototype.valueOf), f2(D2, "Symbol"), f2(Math, "Math", true), f2(a.JSON, "JSON", true);
    }, function(e3, t2, n2) {
      var a = n2(17)("meta"), r2 = n2(11), o = n2(5), i = n2(7).f, s = 0, c2 = Object.isExtensible || function() {
        return true;
      }, l2 = !n2(8)(function() {
        return c2(Object.preventExtensions({}));
      }), u = function(e4) {
        i(e4, a, { value: { i: "O" + ++s, w: {} } });
      }, f2 = e3.exports = { KEY: a, NEED: false, fastKey: function(e4, t3) {
        if (!r2(e4))
          return typeof e4 == "symbol" ? e4 : (typeof e4 == "string" ? "S" : "P") + e4;
        if (!o(e4, a)) {
          if (!c2(e4))
            return "F";
          if (!t3)
            return "E";
          u(e4);
        }
        return e4[a].i;
      }, getWeak: function(e4, t3) {
        if (!o(e4, a)) {
          if (!c2(e4))
            return true;
          if (!t3)
            return false;
          u(e4);
        }
        return e4[a].w;
      }, onFreeze: function(e4) {
        return l2 && f2.NEED && c2(e4) && !o(e4, a) && u(e4), e4;
      } };
    }, function(e3, t2, n2) {
      var a = n2(13), r2 = n2(32), o = n2(19);
      e3.exports = function(e4) {
        var t3 = a(e4), n3 = r2.f;
        if (n3)
          for (var i, s = n3(e4), c2 = o.f, l2 = 0; s.length > l2; )
            c2.call(e4, i = s[l2++]) && t3.push(i);
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Array.isArray || function(e4) {
        return a(e4) == "Array";
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(41).f, o = {}.toString, i = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      e3.exports.f = function(e4) {
        return i && o.call(e4) == "[object Window]" ? function(e5) {
          try {
            return r2(e5);
          } catch (e6) {
            return i.slice();
          }
        }(e4) : r2(a(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(19), r2 = n2(16), o = n2(9), i = n2(23), s = n2(5), c2 = n2(35), l2 = Object.getOwnPropertyDescriptor;
      t2.f = n2(4) ? l2 : function(e4, t3) {
        if (e4 = o(e4), t3 = i(t3, true), c2)
          try {
            return l2(e4, t3);
          } catch (e5) {
          }
        if (s(e4, t3))
          return r2(!a.f.call(e4, t3), e4[t3]);
      };
    }, function(e3, t2) {
    }, function(e3, t2, n2) {
      n2(31)("asyncIterator");
    }, function(e3, t2, n2) {
      n2(31)("observable");
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a, r2 = n2(77), o = (a = r2) && a.__esModule ? a : { default: a };
      t2.default = o.default || function(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3];
          for (var a2 in n3)
            Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
        }
        return e4;
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(78), __esModule: true };
    }, function(e3, t2, n2) {
      n2(79), e3.exports = n2(1).Object.assign;
    }, function(e3, t2, n2) {
      var a = n2(15);
      a(a.S + a.F, "Object", { assign: n2(80) });
    }, function(e3, t2, n2) {
      var a = n2(4), r2 = n2(13), o = n2(32), i = n2(19), s = n2(18), c2 = n2(40), l2 = Object.assign;
      e3.exports = !l2 || n2(8)(function() {
        var e4 = {}, t3 = {}, n3 = Symbol(), a2 = "abcdefghijklmnopqrst";
        return e4[n3] = 7, a2.split("").forEach(function(e5) {
          t3[e5] = e5;
        }), l2({}, e4)[n3] != 7 || Object.keys(l2({}, t3)).join("") != a2;
      }) ? function(e4, t3) {
        for (var n3 = s(e4), l3 = arguments.length, u = 1, f2 = o.f, p2 = i.f; l3 > u; )
          for (var d2, b2 = c2(arguments[u++]), h = f2 ? r2(b2).concat(f2(b2)) : r2(b2), v4 = h.length, m2 = 0; v4 > m2; )
            d2 = h[m2++], a && !p2.call(b2, d2) || (n3[d2] = b2[d2]);
        return n3;
      } : l2;
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = o(n2(82)), r2 = o(n2(85));
      function o(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = function(e4, t3) {
        if (Array.isArray(e4))
          return e4;
        if ((0, a.default)(Object(e4)))
          return function(e5, t4) {
            var n3 = [], a2 = true, o2 = false, i = void 0;
            try {
              for (var s, c2 = (0, r2.default)(e5); !(a2 = (s = c2.next()).done) && (n3.push(s.value), !t4 || n3.length !== t4); a2 = true)
                ;
            } catch (e6) {
              o2 = true, i = e6;
            } finally {
              try {
                !a2 && c2.return && c2.return();
              } finally {
                if (o2)
                  throw i;
              }
            }
            return n3;
          }(e4, t3);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(83), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(84);
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).isIterable = function(e4) {
        var t3 = Object(e4);
        return t3[r2] !== void 0 || "@@iterator" in t3 || o.hasOwnProperty(a(t3));
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(86), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(87);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(88);
      e3.exports = n2(1).getIterator = function(e4) {
        var t3 = r2(e4);
        if (typeof t3 != "function")
          throw TypeError(e4 + " is not iterable!");
        return a(t3.call(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).getIteratorMethod = function(e4) {
        if (e4 != null)
          return e4[r2] || e4["@@iterator"] || o[a(e4)];
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(90), __esModule: true };
    }, function(e3, t2, n2) {
      n2(91), e3.exports = n2(1).Object.keys;
    }, function(e3, t2, n2) {
      var a = n2(18), r2 = n2(13);
      n2(92)("keys", function() {
        return function(e4) {
          return r2(a(e4));
        };
      });
    }, function(e3, t2, n2) {
      var a = n2(15), r2 = n2(1), o = n2(8);
      e3.exports = function(e4, t3) {
        var n3 = (r2.Object || {})[e4] || Object[e4], i = {};
        i[e4] = t3(n3), a(a.S + a.F * o(function() {
          n3(1);
        }), "Object", i);
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], a = /^\s+|\s+$/g, r2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, o = /\{\n\/\* \[wrapped with (.+)\] \*/, i = /,? & /, s = /^[-+]0x[0-9a-f]+$/i, c2 = /^0b[01]+$/i, l2 = /^\[object .+?Constructor\]$/, u = /^0o[0-7]+$/i, f2 = /^(?:0|[1-9]\d*)$/, p2 = parseInt, d2 = typeof t3 == "object" && t3 && t3.Object === Object && t3, b2 = typeof self == "object" && self && self.Object === Object && self, h = d2 || b2 || Function("return this")();
        function v4(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function m2(e4, t4) {
          return !!(e4 ? e4.length : 0) && function(e5, t5, n4) {
            if (t5 != t5)
              return function(e6, t6, n5, a3) {
                var r4 = e6.length, o2 = n5 + (a3 ? 1 : -1);
                for (; a3 ? o2-- : ++o2 < r4; )
                  if (t6(e6[o2], o2, e6))
                    return o2;
                return -1;
              }(e5, y2, n4);
            var a2 = n4 - 1, r3 = e5.length;
            for (; ++a2 < r3; )
              if (e5[a2] === t5)
                return a2;
            return -1;
          }(e4, t4, 0) > -1;
        }
        function y2(e4) {
          return e4 != e4;
        }
        function g2(e4, t4) {
          for (var n4 = e4.length, a2 = 0; n4--; )
            e4[n4] === t4 && a2++;
          return a2;
        }
        function E(e4, t4) {
          for (var n4 = -1, a2 = e4.length, r3 = 0, o2 = []; ++n4 < a2; ) {
            var i2 = e4[n4];
            i2 !== t4 && i2 !== "__lodash_placeholder__" || (e4[n4] = "__lodash_placeholder__", o2[r3++] = n4);
          }
          return o2;
        }
        var j, x2, _, k2 = Function.prototype, O2 = Object.prototype, C = h["__core-js_shared__"], S2 = (j = /[^.]+$/.exec(C && C.keys && C.keys.IE_PROTO || "")) ? "Symbol(src)_1." + j : "", w2 = k2.toString, A2 = O2.hasOwnProperty, M2 = O2.toString, P2 = RegExp("^" + w2.call(A2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), F2 = Object.create, D2 = Math.max, I2 = Math.min, R2 = (x2 = H2(Object, "defineProperty"), (_ = H2.name) && _.length > 2 ? x2 : void 0);
        function L(e4) {
          return X2(e4) ? F2(e4) : {};
        }
        function B2(e4) {
          return !(!X2(e4) || function(e5) {
            return !!S2 && S2 in e5;
          }(e4)) && (function(e5) {
            var t4 = X2(e5) ? M2.call(e5) : "";
            return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
          }(e4) || function(e5) {
            var t4 = false;
            if (e5 != null && typeof e5.toString != "function")
              try {
                t4 = !!(e5 + "");
              } catch (e6) {
              }
            return t4;
          }(e4) ? P2 : l2).test(function(e5) {
            if (e5 != null) {
              try {
                return w2.call(e5);
              } catch (e6) {
              }
              try {
                return e5 + "";
              } catch (e6) {
              }
            }
            return "";
          }(e4));
        }
        function N2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = n4.length, s2 = -1, c3 = t4.length, l3 = D2(o2 - i2, 0), u2 = Array(c3 + l3), f3 = !a2; ++s2 < c3; )
            u2[s2] = t4[s2];
          for (; ++r3 < i2; )
            (f3 || r3 < o2) && (u2[n4[r3]] = e4[r3]);
          for (; l3--; )
            u2[s2++] = e4[r3++];
          return u2;
        }
        function z2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = -1, s2 = n4.length, c3 = -1, l3 = t4.length, u2 = D2(o2 - s2, 0), f3 = Array(u2 + l3), p3 = !a2; ++r3 < u2; )
            f3[r3] = e4[r3];
          for (var d3 = r3; ++c3 < l3; )
            f3[d3 + c3] = t4[c3];
          for (; ++i2 < s2; )
            (p3 || r3 < o2) && (f3[d3 + n4[i2]] = e4[r3++]);
          return f3;
        }
        function T2(e4) {
          return function() {
            var t4 = arguments;
            switch (t4.length) {
              case 0:
                return new e4();
              case 1:
                return new e4(t4[0]);
              case 2:
                return new e4(t4[0], t4[1]);
              case 3:
                return new e4(t4[0], t4[1], t4[2]);
              case 4:
                return new e4(t4[0], t4[1], t4[2], t4[3]);
              case 5:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4]);
              case 6:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5]);
              case 7:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5], t4[6]);
            }
            var n4 = L(e4.prototype), a2 = e4.apply(n4, t4);
            return X2(a2) ? a2 : n4;
          };
        }
        function q2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 128 & t4, f3 = 1 & t4, p3 = 2 & t4, d3 = 24 & t4, b3 = 512 & t4, v5 = p3 ? void 0 : T2(e4);
          return function m3() {
            for (var y3 = arguments.length, j2 = Array(y3), x3 = y3; x3--; )
              j2[x3] = arguments[x3];
            if (d3)
              var _2 = W2(m3), k3 = g2(j2, _2);
            if (a2 && (j2 = N2(j2, a2, r3, d3)), o2 && (j2 = z2(j2, o2, i2, d3)), y3 -= k3, d3 && y3 < l3) {
              var O3 = E(j2, _2);
              return V2(e4, t4, q2, m3.placeholder, n4, j2, O3, s2, c3, l3 - y3);
            }
            var C2 = f3 ? n4 : this, S3 = p3 ? C2[e4] : e4;
            return y3 = j2.length, s2 ? j2 = Y2(j2, s2) : b3 && y3 > 1 && j2.reverse(), u2 && c3 < y3 && (j2.length = c3), this && this !== h && this instanceof m3 && (S3 = v5 || T2(S3)), S3.apply(C2, j2);
          };
        }
        function V2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 8 & t4;
          t4 |= u2 ? 32 : 64, 4 & (t4 &= ~(u2 ? 64 : 32)) || (t4 &= -4);
          var f3 = n4(e4, t4, r3, u2 ? o2 : void 0, u2 ? i2 : void 0, u2 ? void 0 : o2, u2 ? void 0 : i2, s2, c3, l3);
          return f3.placeholder = a2, $(f3, e4, t4);
        }
        function K(e4, t4, n4, a2, r3, o2, i2, s2) {
          var c3 = 2 & t4;
          if (!c3 && typeof e4 != "function")
            throw new TypeError("Expected a function");
          var l3 = a2 ? a2.length : 0;
          if (l3 || (t4 &= -97, a2 = r3 = void 0), i2 = i2 === void 0 ? i2 : D2(te2(i2), 0), s2 = s2 === void 0 ? s2 : te2(s2), l3 -= r3 ? r3.length : 0, 64 & t4) {
            var u2 = a2, f3 = r3;
            a2 = r3 = void 0;
          }
          var p3 = [e4, t4, n4, a2, r3, u2, f3, o2, i2, s2];
          if (e4 = p3[0], t4 = p3[1], n4 = p3[2], a2 = p3[3], r3 = p3[4], !(s2 = p3[9] = p3[9] == null ? c3 ? 0 : e4.length : D2(p3[9] - l3, 0)) && 24 & t4 && (t4 &= -25), t4 && t4 != 1)
            d3 = t4 == 8 || t4 == 16 ? function(e5, t5, n5) {
              var a3 = T2(e5);
              return function r4() {
                for (var o3 = arguments.length, i3 = Array(o3), s3 = o3, c4 = W2(r4); s3--; )
                  i3[s3] = arguments[s3];
                var l4 = o3 < 3 && i3[0] !== c4 && i3[o3 - 1] !== c4 ? [] : E(i3, c4);
                if ((o3 -= l4.length) < n5)
                  return V2(e5, t5, q2, r4.placeholder, void 0, i3, l4, void 0, void 0, n5 - o3);
                var u3 = this && this !== h && this instanceof r4 ? a3 : e5;
                return v4(u3, this, i3);
              };
            }(e4, t4, s2) : t4 != 32 && t4 != 33 || r3.length ? q2.apply(void 0, p3) : function(e5, t5, n5, a3) {
              var r4 = 1 & t5, o3 = T2(e5);
              return function t6() {
                for (var i3 = -1, s3 = arguments.length, c4 = -1, l4 = a3.length, u3 = Array(l4 + s3), f4 = this && this !== h && this instanceof t6 ? o3 : e5; ++c4 < l4; )
                  u3[c4] = a3[c4];
                for (; s3--; )
                  u3[c4++] = arguments[++i3];
                return v4(f4, r4 ? n5 : this, u3);
              };
            }(e4, t4, n4, a2);
          else
            var d3 = function(e5, t5, n5) {
              var a3 = 1 & t5, r4 = T2(e5);
              return function t6() {
                var o3 = this && this !== h && this instanceof t6 ? r4 : e5;
                return o3.apply(a3 ? n5 : this, arguments);
              };
            }(e4, t4, n4);
          return $(d3, e4, t4);
        }
        function W2(e4) {
          return e4.placeholder;
        }
        function H2(e4, t4) {
          var n4 = function(e5, t5) {
            return e5 == null ? void 0 : e5[t5];
          }(e4, t4);
          return B2(n4) ? n4 : void 0;
        }
        function U2(e4) {
          var t4 = e4.match(o);
          return t4 ? t4[1].split(i) : [];
        }
        function G2(e4, t4) {
          var n4 = t4.length, a2 = n4 - 1;
          return t4[a2] = (n4 > 1 ? "& " : "") + t4[a2], t4 = t4.join(n4 > 2 ? ", " : " "), e4.replace(r2, "{\n/* [wrapped with " + t4 + "] */\n");
        }
        function J(e4, t4) {
          return !!(t4 = t4 == null ? 9007199254740991 : t4) && (typeof e4 == "number" || f2.test(e4)) && e4 > -1 && e4 % 1 == 0 && e4 < t4;
        }
        function Y2(e4, t4) {
          for (var n4 = e4.length, a2 = I2(t4.length, n4), r3 = function(e5, t5) {
            var n5 = -1, a3 = e5.length;
            for (t5 || (t5 = Array(a3)); ++n5 < a3; )
              t5[n5] = e5[n5];
            return t5;
          }(e4); a2--; ) {
            var o2 = t4[a2];
            e4[a2] = J(o2, n4) ? r3[o2] : void 0;
          }
          return e4;
        }
        var $ = R2 ? function(e4, t4, n4) {
          var a2, r3 = t4 + "";
          return R2(e4, "toString", { configurable: true, enumerable: false, value: (a2 = G2(r3, Q(U2(r3), n4)), function() {
            return a2;
          }) });
        } : function(e4) {
          return e4;
        };
        function Q(e4, t4) {
          return function(e5, t5) {
            for (var n4 = -1, a2 = e5 ? e5.length : 0; ++n4 < a2 && t5(e5[n4], n4, e5) !== false; )
              ;
          }(n3, function(n4) {
            var a2 = "_." + n4[0];
            t4 & n4[1] && !m2(e4, a2) && e4.push(a2);
          }), e4.sort();
        }
        function Z2(e4, t4, n4) {
          var a2 = K(e4, 8, void 0, void 0, void 0, void 0, void 0, t4 = n4 ? void 0 : t4);
          return a2.placeholder = Z2.placeholder, a2;
        }
        function X2(e4) {
          var t4 = typeof e4;
          return !!e4 && (t4 == "object" || t4 == "function");
        }
        function ee2(e4) {
          return e4 ? (e4 = function(e5) {
            if (typeof e5 == "number")
              return e5;
            if (function(e6) {
              return typeof e6 == "symbol" || function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && M2.call(e6) == "[object Symbol]";
            }(e5))
              return NaN;
            if (X2(e5)) {
              var t4 = typeof e5.valueOf == "function" ? e5.valueOf() : e5;
              e5 = X2(t4) ? t4 + "" : t4;
            }
            if (typeof e5 != "string")
              return e5 === 0 ? e5 : +e5;
            e5 = e5.replace(a, "");
            var n4 = c2.test(e5);
            return n4 || u.test(e5) ? p2(e5.slice(2), n4 ? 2 : 8) : s.test(e5) ? NaN : +e5;
          }(e4)) === 1 / 0 || e4 === -1 / 0 ? 17976931348623157e292 * (e4 < 0 ? -1 : 1) : e4 == e4 ? e4 : 0 : e4 === 0 ? e4 : 0;
        }
        function te2(e4) {
          var t4 = ee2(e4), n4 = t4 % 1;
          return t4 == t4 ? n4 ? t4 - n4 : t4 : 0;
        }
        Z2.placeholder = {}, e3.exports = Z2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      function a(e4) {
        return e4 && e4.__esModule ? e4.default : e4;
      }
      t2.__esModule = true;
      var r2 = n2(95);
      t2.threezerotwofour = a(r2);
      var o = n2(96);
      t2.apathy = a(o);
      var i = n2(97);
      t2.ashes = a(i);
      var s = n2(98);
      t2.atelierDune = a(s);
      var c2 = n2(99);
      t2.atelierForest = a(c2);
      var l2 = n2(100);
      t2.atelierHeath = a(l2);
      var u = n2(101);
      t2.atelierLakeside = a(u);
      var f2 = n2(102);
      t2.atelierSeaside = a(f2);
      var p2 = n2(103);
      t2.bespin = a(p2);
      var d2 = n2(104);
      t2.brewer = a(d2);
      var b2 = n2(105);
      t2.bright = a(b2);
      var h = n2(106);
      t2.chalk = a(h);
      var v4 = n2(107);
      t2.codeschool = a(v4);
      var m2 = n2(108);
      t2.colors = a(m2);
      var y2 = n2(109);
      t2.default = a(y2);
      var g2 = n2(110);
      t2.eighties = a(g2);
      var E = n2(111);
      t2.embers = a(E);
      var j = n2(112);
      t2.flat = a(j);
      var x2 = n2(113);
      t2.google = a(x2);
      var _ = n2(114);
      t2.grayscale = a(_);
      var k2 = n2(115);
      t2.greenscreen = a(k2);
      var O2 = n2(116);
      t2.harmonic = a(O2);
      var C = n2(117);
      t2.hopscotch = a(C);
      var S2 = n2(118);
      t2.isotope = a(S2);
      var w2 = n2(119);
      t2.marrakesh = a(w2);
      var A2 = n2(120);
      t2.mocha = a(A2);
      var M2 = n2(121);
      t2.monokai = a(M2);
      var P2 = n2(122);
      t2.ocean = a(P2);
      var F2 = n2(123);
      t2.paraiso = a(F2);
      var D2 = n2(124);
      t2.pop = a(D2);
      var I2 = n2(125);
      t2.railscasts = a(I2);
      var R2 = n2(126);
      t2.shapeshifter = a(R2);
      var L = n2(127);
      t2.solarized = a(L);
      var B2 = n2(128);
      t2.summerfruit = a(B2);
      var N2 = n2(129);
      t2.tomorrow = a(N2);
      var z2 = n2(130);
      t2.tube = a(z2);
      var T2 = n2(131);
      t2.twilight = a(T2);
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      var a = n2(33);
      function r2(e4) {
        var t3 = Math.round(a(e4, 0, 255)).toString(16);
        return t3.length == 1 ? "0" + t3 : t3;
      }
      e3.exports = function(e4) {
        var t3 = e4.length === 4 ? r2(255 * e4[3]) : "";
        return "#" + r2(e4[0]) + r2(e4[1]) + r2(e4[2]) + t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(134), r2 = n2(135), o = n2(136), i = n2(137);
      var s = { "#": r2, hsl: function(e4) {
        var t3 = a(e4), n3 = i(t3);
        return t3.length === 4 && n3.push(t3[3]), n3;
      }, rgb: o };
      function c2(e4) {
        for (var t3 in s)
          if (e4.indexOf(t3) === 0)
            return s[t3](e4);
      }
      c2.rgb = o, c2.hsl = a, c2.hex = r2, e3.exports = c2;
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        switch (e4 = parseFloat(e4), t3) {
          case 0:
            return r2(e4, 0, 360);
          case 1:
          case 2:
            return r2(e4, 0, 100);
          case 3:
            return r2(e4, 0, 1);
        }
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        e4.length !== 4 && e4.length !== 5 || (e4 = function(e5) {
          for (var t4 = "#", n3 = 1; n3 < e5.length; n3++) {
            var a = e5.charAt(n3);
            t4 += a + a;
          }
          return t4;
        }(e4));
        var t3 = [parseInt(e4.substring(1, 3), 16), parseInt(e4.substring(3, 5), 16), parseInt(e4.substring(5, 7), 16)];
        if (e4.length === 9) {
          var n2 = parseFloat((parseInt(e4.substring(7, 9), 16) / 255).toFixed(2));
          t3.push(n2);
        }
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        return t3 < 3 ? e4.indexOf("%") != -1 ? Math.round(255 * r2(parseInt(e4, 10), 0, 100) / 100) : r2(parseInt(e4, 10), 0, 255) : r2(parseFloat(e4), 0, 1);
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        var t3, n2, a, r2, o, i = e4[0] / 360, s = e4[1] / 100, c2 = e4[2] / 100;
        if (s == 0)
          return [o = 255 * c2, o, o];
        t3 = 2 * c2 - (n2 = c2 < 0.5 ? c2 * (1 + s) : c2 + s - c2 * s), r2 = [0, 0, 0];
        for (var l2 = 0; l2 < 3; l2++)
          (a = i + 1 / 3 * -(l2 - 1)) < 0 && a++, a > 1 && a--, o = 6 * a < 1 ? t3 + 6 * (n2 - t3) * a : 2 * a < 1 ? n2 : 3 * a < 2 ? t3 + (n2 - t3) * (2 / 3 - a) * 6 : t3, r2[l2] = 255 * o;
        return r2;
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = typeof t3 == "object" && t3 && t3.Object === Object && t3, a = typeof self == "object" && self && self.Object === Object && self, r2 = n3 || a || Function("return this")();
        function o(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function i(e4, t4) {
          for (var n4 = -1, a2 = t4.length, r3 = e4.length; ++n4 < a2; )
            e4[r3 + n4] = t4[n4];
          return e4;
        }
        var s = Object.prototype, c2 = s.hasOwnProperty, l2 = s.toString, u = r2.Symbol, f2 = s.propertyIsEnumerable, p2 = u ? u.isConcatSpreadable : void 0, d2 = Math.max;
        function b2(e4) {
          return h(e4) || function(e5) {
            return function(e6) {
              return function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && function(e7) {
                return e7 != null && function(e8) {
                  return typeof e8 == "number" && e8 > -1 && e8 % 1 == 0 && e8 <= 9007199254740991;
                }(e7.length) && !function(e8) {
                  var t4 = function(e9) {
                    var t5 = typeof e9;
                    return !!e9 && (t5 == "object" || t5 == "function");
                  }(e8) ? l2.call(e8) : "";
                  return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
                }(e7);
              }(e6);
            }(e5) && c2.call(e5, "callee") && (!f2.call(e5, "callee") || l2.call(e5) == "[object Arguments]");
          }(e4) || !!(p2 && e4 && e4[p2]);
        }
        var h = Array.isArray;
        var v4, m2, y2, g2 = (m2 = function(e4) {
          var t4 = (e4 = function e5(t5, n5, a2, r3, o2) {
            var s2 = -1, c3 = t5.length;
            for (a2 || (a2 = b2), o2 || (o2 = []); ++s2 < c3; ) {
              var l3 = t5[s2];
              n5 > 0 && a2(l3) ? n5 > 1 ? e5(l3, n5 - 1, a2, r3, o2) : i(o2, l3) : r3 || (o2[o2.length] = l3);
            }
            return o2;
          }(e4, 1)).length, n4 = t4;
          for (v4; n4--; )
            if (typeof e4[n4] != "function")
              throw new TypeError("Expected a function");
          return function() {
            for (var n5 = 0, a2 = t4 ? e4[n5].apply(this, arguments) : arguments[0]; ++n5 < t4; )
              a2 = e4[n5].call(this, a2);
            return a2;
          };
        }, y2 = d2(y2 === void 0 ? m2.length - 1 : y2, 0), function() {
          for (var e4 = arguments, t4 = -1, n4 = d2(e4.length - y2, 0), a2 = Array(n4); ++t4 < n4; )
            a2[t4] = e4[y2 + t4];
          t4 = -1;
          for (var r3 = Array(y2 + 1); ++t4 < y2; )
            r3[t4] = e4[t4];
          return r3[y2] = a2, o(m2, this, r3);
        });
        e3.exports = g2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.yuv2rgb = function(e4) {
        var t3, n3, a, r2 = e4[0], o = e4[1], i = e4[2];
        return t3 = 1 * r2 + 0 * o + 1.13983 * i, n3 = 1 * r2 + -0.39465 * o + -0.5806 * i, a = 1 * r2 + 2.02311 * o + 0 * i, t3 = Math.min(Math.max(0, t3), 1), n3 = Math.min(Math.max(0, n3), 1), a = Math.min(Math.max(0, a), 1), [255 * t3, 255 * n3, 255 * a];
      }, t2.rgb2yuv = function(e4) {
        var t3 = e4[0] / 255, n3 = e4[1] / 255, a = e4[2] / 255;
        return [0.299 * t3 + 0.587 * n3 + 0.114 * a, -0.14713 * t3 + -0.28886 * n3 + 0.436 * a, 0.615 * t3 + -0.51499 * n3 + -0.10001 * a];
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      var r2 = n2(141), o = function() {
        function e4() {
          a(this, "_callbacks", void 0), a(this, "_isDispatching", void 0), a(this, "_isHandled", void 0), a(this, "_isPending", void 0), a(this, "_lastID", void 0), a(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
        }
        var t3 = e4.prototype;
        return t3.register = function(e5) {
          var t4 = "ID_" + this._lastID++;
          return this._callbacks[t4] = e5, t4;
        }, t3.unregister = function(e5) {
          this._callbacks[e5] || r2(false), delete this._callbacks[e5];
        }, t3.waitFor = function(e5) {
          this._isDispatching || r2(false);
          for (var t4 = 0; t4 < e5.length; t4++) {
            var n3 = e5[t4];
            this._isPending[n3] ? this._isHandled[n3] || r2(false) : (this._callbacks[n3] || r2(false), this._invokeCallback(n3));
          }
        }, t3.dispatch = function(e5) {
          this._isDispatching && r2(false), this._startDispatching(e5);
          try {
            for (var t4 in this._callbacks)
              this._isPending[t4] || this._invokeCallback(t4);
          } finally {
            this._stopDispatching();
          }
        }, t3.isDispatching = function() {
          return this._isDispatching;
        }, t3._invokeCallback = function(e5) {
          this._isPending[e5] = true, this._callbacks[e5](this._pendingPayload), this._isHandled[e5] = true;
        }, t3._startDispatching = function(e5) {
          for (var t4 in this._callbacks)
            this._isPending[t4] = false, this._isHandled[t4] = false;
          this._pendingPayload = e5, this._isDispatching = true;
        }, t3._stopDispatching = function() {
          delete this._pendingPayload, this._isDispatching = false;
        }, e4;
      }();
      e3.exports = o;
    }, function(e3, t2, n2) {
      e3.exports = function(e4, t3) {
        for (var n3 = arguments.length, r2 = new Array(n3 > 2 ? n3 - 2 : 0), o = 2; o < n3; o++)
          r2[o - 2] = arguments[o];
        if (!e4) {
          var i;
          if (t3 === void 0)
            i = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
          else {
            var s = 0;
            (i = new Error(t3.replace(/%s/g, function() {
              return String(r2[s++]);
            }))).name = "Invariant Violation";
          }
          throw i.framesToPop = 1, i;
        }
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      function r2(e4, t3) {
        var n3 = Object.keys(e4);
        if (Object.getOwnPropertySymbols) {
          var a2 = Object.getOwnPropertySymbols(e4);
          t3 && (a2 = a2.filter(function(t4) {
            return Object.getOwnPropertyDescriptor(e4, t4).enumerable;
          })), n3.push.apply(n3, a2);
        }
        return n3;
      }
      function o(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3] != null ? arguments[t3] : {};
          t3 % 2 ? r2(Object(n3), true).forEach(function(t4) {
            a(e4, t4, n3[t4]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e4, Object.getOwnPropertyDescriptors(n3)) : r2(Object(n3)).forEach(function(t4) {
            Object.defineProperty(e4, t4, Object.getOwnPropertyDescriptor(n3, t4));
          });
        }
        return e4;
      }
      function i(e4, t3) {
        if (!(e4 instanceof t3))
          throw new TypeError("Cannot call a class as a function");
      }
      function s(e4, t3) {
        for (var n3 = 0; n3 < t3.length; n3++) {
          var a2 = t3[n3];
          a2.enumerable = a2.enumerable || false, a2.configurable = true, "value" in a2 && (a2.writable = true), Object.defineProperty(e4, a2.key, a2);
        }
      }
      function c2(e4, t3, n3) {
        return t3 && s(e4.prototype, t3), n3 && s(e4, n3), e4;
      }
      function l2(e4, t3) {
        return (l2 = Object.setPrototypeOf || function(e5, t4) {
          return e5.__proto__ = t4, e5;
        })(e4, t3);
      }
      function u(e4, t3) {
        if (typeof t3 != "function" && t3 !== null)
          throw new TypeError("Super expression must either be null or a function");
        e4.prototype = Object.create(t3 && t3.prototype, { constructor: { value: e4, writable: true, configurable: true } }), t3 && l2(e4, t3);
      }
      function f2(e4) {
        return (f2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e5) {
          return e5.__proto__ || Object.getPrototypeOf(e5);
        })(e4);
      }
      function p2(e4) {
        return (p2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e5) {
          return typeof e5;
        } : function(e5) {
          return e5 && typeof Symbol == "function" && e5.constructor === Symbol && e5 !== Symbol.prototype ? "symbol" : typeof e5;
        })(e4);
      }
      function d2(e4) {
        if (e4 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return e4;
      }
      function b2(e4, t3) {
        return !t3 || p2(t3) !== "object" && typeof t3 != "function" ? d2(e4) : t3;
      }
      function h(e4) {
        var t3 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e5) {
            return false;
          }
        }();
        return function() {
          var n3, a2 = f2(e4);
          if (t3) {
            var r3 = f2(this).constructor;
            n3 = Reflect.construct(a2, arguments, r3);
          } else
            n3 = a2.apply(this, arguments);
          return b2(this, n3);
        };
      }
      n2.r(t2);
      var v4 = n2(0), m2 = n2.n(v4);
      function y2() {
        var e4 = this.constructor.getDerivedStateFromProps(this.props, this.state);
        e4 != null && this.setState(e4);
      }
      function g2(e4) {
        this.setState(function(t3) {
          var n3 = this.constructor.getDerivedStateFromProps(e4, t3);
          return n3 != null ? n3 : null;
        }.bind(this));
      }
      function E(e4, t3) {
        try {
          var n3 = this.props, a2 = this.state;
          this.props = e4, this.state = t3, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(n3, a2);
        } finally {
          this.props = n3, this.state = a2;
        }
      }
      function j(e4) {
        var t3 = e4.prototype;
        if (!t3 || !t3.isReactComponent)
          throw new Error("Can only polyfill class components");
        if (typeof e4.getDerivedStateFromProps != "function" && typeof t3.getSnapshotBeforeUpdate != "function")
          return e4;
        var n3 = null, a2 = null, r3 = null;
        if (typeof t3.componentWillMount == "function" ? n3 = "componentWillMount" : typeof t3.UNSAFE_componentWillMount == "function" && (n3 = "UNSAFE_componentWillMount"), typeof t3.componentWillReceiveProps == "function" ? a2 = "componentWillReceiveProps" : typeof t3.UNSAFE_componentWillReceiveProps == "function" && (a2 = "UNSAFE_componentWillReceiveProps"), typeof t3.componentWillUpdate == "function" ? r3 = "componentWillUpdate" : typeof t3.UNSAFE_componentWillUpdate == "function" && (r3 = "UNSAFE_componentWillUpdate"), n3 !== null || a2 !== null || r3 !== null) {
          var o2 = e4.displayName || e4.name, i2 = typeof e4.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
          throw Error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n" + o2 + " uses " + i2 + " but also contains the following legacy lifecycles:" + (n3 !== null ? "\n  " + n3 : "") + (a2 !== null ? "\n  " + a2 : "") + (r3 !== null ? "\n  " + r3 : "") + "\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-async-component-lifecycle-hooks");
        }
        if (typeof e4.getDerivedStateFromProps == "function" && (t3.componentWillMount = y2, t3.componentWillReceiveProps = g2), typeof t3.getSnapshotBeforeUpdate == "function") {
          if (typeof t3.componentDidUpdate != "function")
            throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
          t3.componentWillUpdate = E;
          var s2 = t3.componentDidUpdate;
          t3.componentDidUpdate = function(e5, t4, n4) {
            var a3 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : n4;
            s2.call(this, e5, t4, a3);
          };
        }
        return e4;
      }
      function x2(e4, t3) {
        if (e4 == null)
          return {};
        var n3, a2, r3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, t3);
        if (Object.getOwnPropertySymbols) {
          var o2 = Object.getOwnPropertySymbols(e4);
          for (a2 = 0; a2 < o2.length; a2++)
            n3 = o2[a2], t3.indexOf(n3) >= 0 || Object.prototype.propertyIsEnumerable.call(e4, n3) && (r3[n3] = e4[n3]);
        }
        return r3;
      }
      function _(e4) {
        var t3 = function(e5) {
          return {}.toString.call(e5).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
        }(e4);
        return t3 === "number" && (t3 = isNaN(e4) ? "nan" : (0 | e4) != e4 ? "float" : "integer"), t3;
      }
      y2.__suppressDeprecationWarning = true, g2.__suppressDeprecationWarning = true, E.__suppressDeprecationWarning = true;
      var k2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, O2 = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, C = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, S2 = n2(45), w2 = function(e4) {
        var t3 = function(e5) {
          return { backgroundColor: e5.base00, ellipsisColor: e5.base09, braceColor: e5.base07, expandedIcon: e5.base0D, collapsedIcon: e5.base0E, keyColor: e5.base07, arrayKeyColor: e5.base0C, objectSize: e5.base04, copyToClipboard: e5.base0F, copyToClipboardCheck: e5.base0D, objectBorder: e5.base02, dataTypes: { boolean: e5.base0E, date: e5.base0D, float: e5.base0B, function: e5.base0D, integer: e5.base0F, string: e5.base09, nan: e5.base08, null: e5.base0A, undefined: e5.base05, regexp: e5.base0A, background: e5.base02 }, editVariable: { editIcon: e5.base0E, cancelIcon: e5.base09, removeIcon: e5.base09, addIcon: e5.base0E, checkIcon: e5.base0E, background: e5.base01, color: e5.base0A, border: e5.base07 }, addKeyModal: { background: e5.base05, border: e5.base04, color: e5.base0A, labelColor: e5.base01 }, validationFailure: { background: e5.base09, iconColor: e5.base01, fontColor: e5.base01 } };
        }(e4);
        return { "app-container": { fontFamily: C.globalFontFamily, cursor: C.globalCursor, backgroundColor: t3.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: C.braceCursor, fontWeight: C.braceFontWeight, color: t3.braceColor }, "expanded-icon": { color: t3.expandedIcon }, "collapsed-icon": { color: t3.collapsedIcon }, colon: { display: "inline-block", margin: C.keyMargin, color: t3.keyColor, verticalAlign: "top" }, objectKeyVal: function(e5, n3) {
          return { style: o({ paddingTop: C.keyValPaddingTop, paddingRight: C.keyValPaddingRight, paddingBottom: C.keyValPaddingBottom, borderLeft: C.keyValBorderLeft + " " + t3.objectBorder, ":hover": { paddingLeft: n3.paddingLeft - 1 + "px", borderLeft: C.keyValBorderHover + " " + t3.objectBorder } }, n3) };
        }, "object-key-val-no-border": { padding: C.keyValPadding }, "pushed-content": { marginLeft: C.pushedContentMarginLeft }, variableValue: function(e5, t4) {
          return { style: o({ display: "inline-block", paddingRight: C.variableValuePaddingRight, position: "relative" }, t4) };
        }, "object-name": { display: "inline-block", color: t3.keyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "array-key": { display: "inline-block", color: t3.arrayKeyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "object-size": { color: t3.objectSize, borderRadius: C.objectSizeBorderRadius, fontStyle: C.objectSizeFontStyle, margin: C.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: C.dataTypeFontSize, marginRight: C.dataTypeMarginRight, opacity: C.datatypeOpacity }, boolean: { display: "inline-block", color: t3.dataTypes.boolean }, date: { display: "inline-block", color: t3.dataTypes.date }, "date-value": { marginLeft: C.dateValueMarginLeft }, float: { display: "inline-block", color: t3.dataTypes.float }, function: { display: "inline-block", color: t3.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: t3.dataTypes.integer }, string: { display: "inline-block", color: t3.dataTypes.string }, nan: { display: "inline-block", color: t3.dataTypes.nan, fontSize: C.nanFontSize, fontWeight: C.nanFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nanPadding, borderRadius: C.nanBorderRadius }, null: { display: "inline-block", color: t3.dataTypes.null, fontSize: C.nullFontSize, fontWeight: C.nullFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nullPadding, borderRadius: C.nullBorderRadius }, undefined: { display: "inline-block", color: t3.dataTypes.undefined, fontSize: C.undefinedFontSize, padding: C.undefinedPadding, borderRadius: C.undefinedBorderRadius, backgroundColor: t3.dataTypes.background }, regexp: { display: "inline-block", color: t3.dataTypes.regexp }, "copy-to-clipboard": { cursor: C.clipboardCursor }, "copy-icon": { color: t3.copyToClipboard, fontSize: C.iconFontSize, marginRight: C.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: t3.copyToClipboardCheck, marginLeft: C.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: C.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: C.metaDataPadding }, "icon-container": { display: "inline-block", width: C.iconContainerWidth }, tooltip: { padding: C.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.removeIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.addIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.editIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.checkIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.cancelIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: C.editInputMinWidth, borderRadius: C.editInputBorderRadius, backgroundColor: t3.editVariable.background, color: t3.editVariable.color, padding: C.editInputPadding, marginRight: C.editInputMarginRight, fontFamily: C.editInputFontFamily }, "detected-row": { paddingTop: C.detectedRowPaddingTop }, "key-modal-request": { position: C.addKeyCoverPosition, top: C.addKeyCoverPositionPx, left: C.addKeyCoverPositionPx, right: C.addKeyCoverPositionPx, bottom: C.addKeyCoverPositionPx, backgroundColor: C.addKeyCoverBackground }, "key-modal": { width: C.addKeyModalWidth, backgroundColor: t3.addKeyModal.background, marginLeft: C.addKeyModalMargin, marginRight: C.addKeyModalMargin, padding: C.addKeyModalPadding, borderRadius: C.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: t3.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: t3.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: t3.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: t3.addKeyModal.labelColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: t3.editVariable.addIcon, fontSize: C.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: t3.validationFailure.fontColor, backgroundColor: t3.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: t3.validationFailure.iconColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" } };
      };
      function A2(e4, t3, n3) {
        return e4 || console.error("theme has not been set"), function(e5) {
          var t4 = k2;
          return e5 !== false && e5 !== "none" || (t4 = O2), Object(S2.createStyling)(w2, { defaultBase16: t4 })(e5);
        }(e4)(t3, n3);
      }
      var M2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = (e5.rjvId, e5.type_name), n4 = e5.displayDataTypes, a2 = e5.theme;
          return n4 ? m2.a.createElement("span", Object.assign({ className: "data-type-label" }, A2(a2, "data-type-label")), t4) : null;
        } }]), n3;
      }(m2.a.PureComponent), P2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "boolean"), m2.a.createElement(M2, Object.assign({ type_name: "bool" }, e5)), e5.value ? "true" : "false");
        } }]), n3;
      }(m2.a.PureComponent), F2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "date"), m2.a.createElement(M2, Object.assign({ type_name: "date" }, e5)), m2.a.createElement("span", Object.assign({ className: "date-value" }, A2(e5.theme, "date-value")), e5.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
        } }]), n3;
      }(m2.a.PureComponent), D2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "float"), m2.a.createElement(M2, Object.assign({ type_name: "float" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent);
      function I2(e4, t3) {
        (t3 == null || t3 > e4.length) && (t3 = e4.length);
        for (var n3 = 0, a2 = new Array(t3); n3 < t3; n3++)
          a2[n3] = e4[n3];
        return a2;
      }
      function R2(e4, t3) {
        if (e4) {
          if (typeof e4 == "string")
            return I2(e4, t3);
          var n3 = Object.prototype.toString.call(e4).slice(8, -1);
          return n3 === "Object" && e4.constructor && (n3 = e4.constructor.name), n3 === "Map" || n3 === "Set" ? Array.from(e4) : n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3) ? I2(e4, t3) : void 0;
        }
      }
      function L(e4, t3) {
        var n3;
        if (typeof Symbol == "undefined" || e4[Symbol.iterator] == null) {
          if (Array.isArray(e4) || (n3 = R2(e4)) || t3 && e4 && typeof e4.length == "number") {
            n3 && (e4 = n3);
            var a2 = 0, r3 = function() {
            };
            return { s: r3, n: function() {
              return a2 >= e4.length ? { done: true } : { done: false, value: e4[a2++] };
            }, e: function(e5) {
              throw e5;
            }, f: r3 };
          }
          throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }
        var o2, i2 = true, s2 = false;
        return { s: function() {
          n3 = e4[Symbol.iterator]();
        }, n: function() {
          var e5 = n3.next();
          return i2 = e5.done, e5;
        }, e: function(e5) {
          s2 = true, o2 = e5;
        }, f: function() {
          try {
            i2 || n3.return == null || n3.return();
          } finally {
            if (s2)
              throw o2;
          }
        } };
      }
      function B2(e4) {
        return function(e5) {
          if (Array.isArray(e5))
            return I2(e5);
        }(e4) || function(e5) {
          if (typeof Symbol != "undefined" && Symbol.iterator in Object(e5))
            return Array.from(e5);
        }(e4) || R2(e4) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }();
      }
      var N2 = n2(46), z2 = new (n2(47)).Dispatcher(), T2 = new (function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).objects = {}, e5.set = function(t4, n4, a3, r4) {
            e5.objects[t4] === void 0 && (e5.objects[t4] = {}), e5.objects[t4][n4] === void 0 && (e5.objects[t4][n4] = {}), e5.objects[t4][n4][a3] = r4;
          }, e5.get = function(t4, n4, a3, r4) {
            return e5.objects[t4] === void 0 || e5.objects[t4][n4] === void 0 || e5.objects[t4][n4][a3] == null ? r4 : e5.objects[t4][n4][a3];
          }, e5.handleAction = function(t4) {
            var n4 = t4.rjvId, a3 = t4.data;
            switch (t4.name) {
              case "RESET":
                e5.emit("reset-" + n4);
                break;
              case "VARIABLE_UPDATED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-edited" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_REMOVED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-removed" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_ADDED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-added" })), e5.emit("variable-update-" + n4);
                break;
              case "ADD_VARIABLE_KEY_REQUEST":
                e5.set(n4, "action", "new-key-request", a3), e5.emit("add-key-request-" + n4);
            }
          }, e5.updateSrc = function(t4, n4) {
            var a3 = n4.name, r4 = n4.namespace, o2 = n4.new_value, i2 = (n4.existing_value, n4.variable_removed);
            r4.shift();
            var s3, c3 = e5.get(t4, "global", "src"), l3 = e5.deepCopy(c3, B2(r4)), u2 = l3, f3 = L(r4);
            try {
              for (f3.s(); !(s3 = f3.n()).done; ) {
                u2 = u2[s3.value];
              }
            } catch (e6) {
              f3.e(e6);
            } finally {
              f3.f();
            }
            return i2 ? _(u2) == "array" ? u2.splice(a3, 1) : delete u2[a3] : a3 !== null ? u2[a3] = o2 : l3 = o2, e5.set(t4, "global", "src", l3), l3;
          }, e5.deepCopy = function(t4, n4) {
            var a3, r4 = _(t4), i2 = n4.shift();
            return r4 == "array" ? a3 = B2(t4) : r4 == "object" && (a3 = o({}, t4)), i2 !== void 0 && (a3[i2] = e5.deepCopy(t4[i2], n4)), a3;
          }, e5;
        }
        return n3;
      }(N2.EventEmitter))();
      z2.register(T2.handleAction.bind(T2));
      var q2 = T2, V2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.getFunctionDisplay = function(e6) {
            var t4 = d2(a2).props;
            return e6 ? m2.a.createElement("span", null, a2.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), m2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, m2.a.createElement("span", null, "{"), m2.a.createElement("span", A2(t4.theme, "ellipsis"), "..."), m2.a.createElement("span", null, "}"))) : a2.props.value.toString().slice(9, -1);
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = this.state.collapsed;
          return m2.a.createElement("div", A2(e5.theme, "function"), m2.a.createElement(M2, Object.assign({ type_name: "function" }, e5)), m2.a.createElement("span", Object.assign({}, A2(e5.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(t4)));
        } }]), n3;
      }(m2.a.PureComponent), K = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "nan"), "NaN");
        } }]), n3;
      }(m2.a.PureComponent), W2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "null"), "NULL");
        } }]), n3;
      }(m2.a.PureComponent), H2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "integer"), m2.a.createElement(M2, Object.assign({ type_name: "int" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent), U2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "regexp"), m2.a.createElement(M2, Object.assign({ type_name: "regexp" }, e5)), this.props.value.toString());
        } }]), n3;
      }(m2.a.PureComponent), G2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          this.state.collapsed;
          var e5 = this.props, t4 = e5.collapseStringsAfterLength, n4 = e5.theme, a2 = e5.value, r3 = { style: { cursor: "default" } };
          return _(t4) === "integer" && a2.length > t4 && (r3.style.cursor = "pointer", this.state.collapsed && (a2 = m2.a.createElement("span", null, a2.substring(0, t4), m2.a.createElement("span", A2(n4, "ellipsis"), " ...")))), m2.a.createElement("div", A2(n4, "string"), m2.a.createElement(M2, Object.assign({ type_name: "string" }, e5)), m2.a.createElement("span", Object.assign({ className: "string-value" }, r3, { onClick: this.toggleCollapsed }), '"', a2, '"'));
        } }]), n3;
      }(m2.a.PureComponent), J = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "undefined"), "undefined");
        } }]), n3;
      }(m2.a.PureComponent);
      function Y2() {
        return (Y2 = Object.assign || function(e4) {
          for (var t3 = 1; t3 < arguments.length; t3++) {
            var n3 = arguments[t3];
            for (var a2 in n3)
              Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
          }
          return e4;
        }).apply(this, arguments);
      }
      var $ = v4.useLayoutEffect, Q = function(e4) {
        var t3 = Object(v4.useRef)(e4);
        return $(function() {
          t3.current = e4;
        }), t3;
      }, Z2 = function(e4, t3) {
        typeof e4 != "function" ? e4.current = t3 : e4(t3);
      }, X2 = function(e4, t3) {
        var n3 = Object(v4.useRef)();
        return Object(v4.useCallback)(function(a2) {
          e4.current = a2, n3.current && Z2(n3.current, null), n3.current = t3, t3 && Z2(t3, a2);
        }, [t3]);
      }, ee2 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, te2 = function(e4) {
        Object.keys(ee2).forEach(function(t3) {
          e4.style.setProperty(t3, ee2[t3], "important");
        });
      }, ne2 = null;
      var ae2 = function() {
      }, re2 = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oe2 = !!document.documentElement.currentStyle, ie2 = function(e4, t3) {
        var n3 = e4.cacheMeasurements, a2 = e4.maxRows, r3 = e4.minRows, o2 = e4.onChange, i2 = o2 === void 0 ? ae2 : o2, s2 = e4.onHeightChange, c3 = s2 === void 0 ? ae2 : s2, l3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]);
        var u2, f3 = l3.value !== void 0, p3 = Object(v4.useRef)(null), d3 = X2(p3, t3), b3 = Object(v4.useRef)(0), h2 = Object(v4.useRef)(), m3 = function() {
          var e5 = p3.current, t4 = n3 && h2.current ? h2.current : function(e6) {
            var t5 = window.getComputedStyle(e6);
            if (t5 === null)
              return null;
            var n4, a3 = (n4 = t5, re2.reduce(function(e7, t6) {
              return e7[t6] = n4[t6], e7;
            }, {})), r4 = a3.boxSizing;
            return r4 === "" ? null : (oe2 && r4 === "border-box" && (a3.width = parseFloat(a3.width) + parseFloat(a3.borderRightWidth) + parseFloat(a3.borderLeftWidth) + parseFloat(a3.paddingRight) + parseFloat(a3.paddingLeft) + "px"), { sizingStyle: a3, paddingSize: parseFloat(a3.paddingBottom) + parseFloat(a3.paddingTop), borderSize: parseFloat(a3.borderBottomWidth) + parseFloat(a3.borderTopWidth) });
          }(e5);
          if (t4) {
            h2.current = t4;
            var o3 = function(e6, t5, n4, a3) {
              n4 === void 0 && (n4 = 1), a3 === void 0 && (a3 = 1 / 0), ne2 || ((ne2 = document.createElement("textarea")).setAttribute("tab-index", "-1"), ne2.setAttribute("aria-hidden", "true"), te2(ne2)), ne2.parentNode === null && document.body.appendChild(ne2);
              var r4 = e6.paddingSize, o4 = e6.borderSize, i4 = e6.sizingStyle, s4 = i4.boxSizing;
              Object.keys(i4).forEach(function(e7) {
                var t6 = e7;
                ne2.style[t6] = i4[t6];
              }), te2(ne2), ne2.value = t5;
              var c4 = function(e7, t6) {
                var n5 = e7.scrollHeight;
                return t6.sizingStyle.boxSizing === "border-box" ? n5 + t6.borderSize : n5 - t6.paddingSize;
              }(ne2, e6);
              ne2.value = "x";
              var l4 = ne2.scrollHeight - r4, u3 = l4 * n4;
              s4 === "border-box" && (u3 = u3 + r4 + o4), c4 = Math.max(u3, c4);
              var f4 = l4 * a3;
              return s4 === "border-box" && (f4 = f4 + r4 + o4), [c4 = Math.min(f4, c4), l4];
            }(t4, e5.value || e5.placeholder || "x", r3, a2), i3 = o3[0], s3 = o3[1];
            b3.current !== i3 && (b3.current = i3, e5.style.setProperty("height", i3 + "px", "important"), c3(i3, { rowHeight: s3 }));
          }
        };
        return Object(v4.useLayoutEffect)(m3), u2 = Q(m3), Object(v4.useLayoutEffect)(function() {
          var e5 = function(e6) {
            u2.current(e6);
          };
          return window.addEventListener("resize", e5), function() {
            window.removeEventListener("resize", e5);
          };
        }, []), Object(v4.createElement)("textarea", Y2({}, l3, { onChange: function(e5) {
          f3 || m3(), i2(e5);
        }, ref: d3 }));
      }, se2 = Object(v4.forwardRef)(ie2);
      function ce2(e4) {
        e4 = e4.trim();
        try {
          if ((e4 = JSON.stringify(JSON.parse(e4)))[0] === "[")
            return le2("array", JSON.parse(e4));
          if (e4[0] === "{")
            return le2("object", JSON.parse(e4));
          if (e4.match(/\-?\d+\.\d+/) && e4.match(/\-?\d+\.\d+/)[0] === e4)
            return le2("float", parseFloat(e4));
          if (e4.match(/\-?\d+e-\d+/) && e4.match(/\-?\d+e-\d+/)[0] === e4)
            return le2("float", Number(e4));
          if (e4.match(/\-?\d+/) && e4.match(/\-?\d+/)[0] === e4)
            return le2("integer", parseInt(e4));
          if (e4.match(/\-?\d+e\+\d+/) && e4.match(/\-?\d+e\+\d+/)[0] === e4)
            return le2("integer", Number(e4));
        } catch (e5) {
        }
        switch (e4 = e4.toLowerCase()) {
          case "undefined":
            return le2("undefined", void 0);
          case "nan":
            return le2("nan", NaN);
          case "null":
            return le2("null", null);
          case "true":
            return le2("boolean", true);
          case "false":
            return le2("boolean", false);
          default:
            if (e4 = Date.parse(e4))
              return le2("date", new Date(e4));
        }
        return le2(false, null);
      }
      function le2(e4, t3) {
        return { type: e4, value: t3 };
      }
      var ue2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
        } }]), n3;
      }(m2.a.PureComponent), fe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
        } }]), n3;
      }(m2.a.PureComponent), pe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), de2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), be2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), he2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), ve2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), me2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ye = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ge2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
        } }]), n3;
      }(m2.a.PureComponent), Ee2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), je2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent);
      function xe(e4) {
        return e4 || (e4 = {}), { style: o(o({ verticalAlign: "middle" }, e4), {}, { color: e4.color ? e4.color : "#000000", height: "1em", width: "1em" }) };
      }
      var _e = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).copiedTimer = null, a2.handleCopy = function() {
            var e6 = document.createElement("textarea"), t4 = a2.props, n4 = t4.clickCallback, r3 = t4.src, o2 = t4.namespace;
            e6.innerHTML = JSON.stringify(a2.clipboardValue(r3), null, "  "), document.body.appendChild(e6), e6.select(), document.execCommand("copy"), document.body.removeChild(e6), a2.copiedTimer = setTimeout(function() {
              a2.setState({ copied: false });
            }, 5500), a2.setState({ copied: true }, function() {
              typeof n4 == "function" && n4({ src: r3, namespace: o2, name: o2[o2.length - 1] });
            });
          }, a2.getClippyIcon = function() {
            var e6 = a2.props.theme;
            return a2.state.copied ? m2.a.createElement("span", null, m2.a.createElement(ve2, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon"))), m2.a.createElement("span", A2(e6, "copy-icon-copied"), "\u2714")) : m2.a.createElement(ve2, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon")));
          }, a2.clipboardValue = function(e6) {
            switch (_(e6)) {
              case "function":
              case "regexp":
                return e6.toString();
              default:
                return e6;
            }
          }, a2.state = { copied: false }, a2;
        }
        return c2(n3, [{ key: "componentWillUnmount", value: function() {
          this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
        } }, { key: "render", value: function() {
          var e5 = this.props, t4 = (e5.src, e5.theme), n4 = e5.hidden, a2 = e5.rowHovered, r3 = A2(t4, "copy-to-clipboard").style, i2 = "inline";
          return n4 && (i2 = "none"), m2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: a2 ? "inline-block" : "none" } }, m2.a.createElement("span", { style: o(o({}, r3), {}, { display: i2 }), onClick: this.handleCopy }, this.getClippyIcon()));
        } }]), n3;
      }(m2.a.PureComponent), ke2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).getEditIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.theme;
            return m2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(Ee2, Object.assign({ className: "click-to-edit-icon" }, A2(n4, "editVarIcon"), { onClick: function() {
              a2.prepopInput(t4);
            } })));
          }, a2.prepopInput = function(e6) {
            if (a2.props.onEdit !== false) {
              var t4 = function(e7) {
                var t5;
                switch (_(e7)) {
                  case "undefined":
                    t5 = "undefined";
                    break;
                  case "nan":
                    t5 = "NaN";
                    break;
                  case "string":
                    t5 = e7;
                    break;
                  case "date":
                  case "function":
                  case "regexp":
                    t5 = e7.toString();
                    break;
                  default:
                    try {
                      t5 = JSON.stringify(e7, null, "  ");
                    } catch (e8) {
                      t5 = "";
                    }
                }
                return t5;
              }(e6.value), n4 = ce2(t4);
              a2.setState({ editMode: true, editValue: t4, parsedInput: { type: n4.type, value: n4.value } });
            }
          }, a2.getRemoveIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.namespace, r3 = e6.theme, o2 = e6.rjvId;
            return m2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(me2, Object.assign({ className: "click-to-remove-icon" }, A2(r3, "removeVarIcon"), { onClick: function() {
              z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: o2, data: { name: t4.name, namespace: n4, existing_value: t4.value, variable_removed: true } });
            } })));
          }, a2.getValue = function(e6, t4) {
            var n4 = !t4 && e6.type, r3 = d2(a2).props;
            switch (n4) {
              case false:
                return a2.getEditInput();
              case "string":
                return m2.a.createElement(G2, Object.assign({ value: e6.value }, r3));
              case "integer":
                return m2.a.createElement(H2, Object.assign({ value: e6.value }, r3));
              case "float":
                return m2.a.createElement(D2, Object.assign({ value: e6.value }, r3));
              case "boolean":
                return m2.a.createElement(P2, Object.assign({ value: e6.value }, r3));
              case "function":
                return m2.a.createElement(V2, Object.assign({ value: e6.value }, r3));
              case "null":
                return m2.a.createElement(W2, r3);
              case "nan":
                return m2.a.createElement(K, r3);
              case "undefined":
                return m2.a.createElement(J, r3);
              case "date":
                return m2.a.createElement(F2, Object.assign({ value: e6.value }, r3));
              case "regexp":
                return m2.a.createElement(U2, Object.assign({ value: e6.value }, r3));
              default:
                return m2.a.createElement("div", { className: "object-value" }, JSON.stringify(e6.value));
            }
          }, a2.getEditInput = function() {
            var e6 = a2.props.theme, t4 = a2.state.editValue;
            return m2.a.createElement("div", null, m2.a.createElement(se2, Object.assign({ type: "text", inputRef: function(e7) {
              return e7 && e7.focus();
            }, value: t4, className: "variable-editor", onChange: function(e7) {
              var t5 = e7.target.value, n4 = ce2(t5);
              a2.setState({ editValue: t5, parsedInput: { type: n4.type, value: n4.value } });
            }, onKeyDown: function(e7) {
              switch (e7.key) {
                case "Escape":
                  a2.setState({ editMode: false, editValue: "" });
                  break;
                case "Enter":
                  (e7.ctrlKey || e7.metaKey) && a2.submitEdit(true);
              }
              e7.stopPropagation();
            }, placeholder: "update this value", minRows: 2 }, A2(e6, "edit-input"))), m2.a.createElement("div", A2(e6, "edit-icon-container"), m2.a.createElement(me2, Object.assign({ className: "edit-cancel" }, A2(e6, "cancel-icon"), { onClick: function() {
              a2.setState({ editMode: false, editValue: "" });
            } })), m2.a.createElement(je2, Object.assign({ className: "edit-check string-value" }, A2(e6, "check-icon"), { onClick: function() {
              a2.submitEdit();
            } })), m2.a.createElement("div", null, a2.showDetected())));
          }, a2.submitEdit = function(e6) {
            var t4 = a2.props, n4 = t4.variable, r3 = t4.namespace, o2 = t4.rjvId, i2 = a2.state, s2 = i2.editValue, c3 = i2.parsedInput, l3 = s2;
            e6 && c3.type && (l3 = c3.value), a2.setState({ editMode: false }), z2.dispatch({ name: "VARIABLE_UPDATED", rjvId: o2, data: { name: n4.name, namespace: r3, existing_value: n4.value, new_value: l3, variable_removed: false } });
          }, a2.showDetected = function() {
            var e6 = a2.props, t4 = e6.theme, n4 = (e6.variable, e6.namespace, e6.rjvId, a2.state.parsedInput), r3 = (n4.type, n4.value, a2.getDetectedInput());
            if (r3)
              return m2.a.createElement("div", null, m2.a.createElement("div", A2(t4, "detected-row"), r3, m2.a.createElement(je2, { className: "edit-check detected", style: o({ verticalAlign: "top", paddingLeft: "3px" }, A2(t4, "check-icon").style), onClick: function() {
                a2.submitEdit(true);
              } })));
          }, a2.getDetectedInput = function() {
            var e6 = a2.state.parsedInput, t4 = e6.type, n4 = e6.value, r3 = d2(a2).props, i2 = r3.theme;
            if (t4 !== false)
              switch (t4.toLowerCase()) {
                case "object":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "{"), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "}"));
                case "array":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "["), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "]"));
                case "string":
                  return m2.a.createElement(G2, Object.assign({ value: n4 }, r3));
                case "integer":
                  return m2.a.createElement(H2, Object.assign({ value: n4 }, r3));
                case "float":
                  return m2.a.createElement(D2, Object.assign({ value: n4 }, r3));
                case "boolean":
                  return m2.a.createElement(P2, Object.assign({ value: n4 }, r3));
                case "function":
                  return m2.a.createElement(V2, Object.assign({ value: n4 }, r3));
                case "null":
                  return m2.a.createElement(W2, r3);
                case "nan":
                  return m2.a.createElement(K, r3);
                case "undefined":
                  return m2.a.createElement(J, r3);
                case "date":
                  return m2.a.createElement(F2, Object.assign({ value: new Date(n4) }, r3));
              }
          }, a2.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.variable, a2 = t4.singleIndent, r3 = t4.type, i2 = t4.theme, s2 = t4.namespace, c3 = t4.indentWidth, l3 = t4.enableClipboard, u2 = t4.onEdit, f3 = t4.onDelete, p3 = t4.onSelect, d3 = t4.displayArrayKey, b3 = t4.quotesOnKeys, h2 = this.state.editMode;
          return m2.a.createElement("div", Object.assign({}, A2(i2, "objectKeyVal", { paddingLeft: c3 * a2 }), { onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          }, className: "variable-row", key: n4.name }), r3 == "array" ? d3 ? m2.a.createElement("span", Object.assign({}, A2(i2, "array-key"), { key: n4.name + "_" + s2 }), n4.name, m2.a.createElement("div", A2(i2, "colon"), ":")) : null : m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({}, A2(i2, "object-name"), { className: "object-key", key: n4.name + "_" + s2 }), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", { style: { display: "inline-block" } }, n4.name), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(i2, "colon"), ":")), m2.a.createElement("div", Object.assign({ className: "variable-value", onClick: p3 === false && u2 === false ? null : function(t5) {
            var a3 = B2(s2);
            (t5.ctrlKey || t5.metaKey) && u2 !== false ? e5.prepopInput(n4) : p3 !== false && (a3.shift(), p3(o(o({}, n4), {}, { namespace: a3 })));
          } }, A2(i2, "variableValue", { cursor: p3 === false ? "default" : "pointer" })), this.getValue(n4, h2)), l3 ? m2.a.createElement(_e, { rowHovered: this.state.hovered, hidden: h2, src: n4.value, clickCallback: l3, theme: i2, namespace: [].concat(B2(s2), [n4.name]) }) : null, u2 !== false && h2 == 0 ? this.getEditIcon() : null, f3 !== false && h2 == 0 ? this.getRemoveIcon() : null);
        } }]), n3;
      }(m2.a.PureComponent), Oe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).getObjectSize = function() {
            var t4 = e5.props, n4 = t4.size, a3 = t4.theme;
            if (t4.displayObjectSize)
              return m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(a3, "object-size")), n4, " item", n4 === 1 ? "" : "s");
          }, e5.getAddAttribute = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = n4.namespace, i2 = n4.name, s3 = n4.src, c3 = n4.rjvId, l3 = n4.depth;
            return m2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: t4 ? "inline-block" : "none" } }, m2.a.createElement(ye, Object.assign({ className: "click-to-add-icon" }, A2(a3, "addVarIcon"), { onClick: function() {
              var e6 = { name: l3 > 0 ? i2 : null, namespace: r4.splice(0, r4.length - 1), existing_value: s3, variable_removed: false, key_name: null };
              _(s3) === "object" ? z2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: c3, data: e6 }) : z2.dispatch({ name: "VARIABLE_ADDED", rjvId: c3, data: o(o({}, e6), {}, { new_value: [].concat(B2(s3), [null]) }) });
            } })));
          }, e5.getRemoveObject = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = (n4.hover, n4.namespace), o2 = n4.name, i2 = n4.src, s3 = n4.rjvId;
            if (r4.length !== 1)
              return m2.a.createElement("span", { className: "click-to-remove", style: { display: t4 ? "inline-block" : "none" } }, m2.a.createElement(me2, Object.assign({ className: "click-to-remove-icon" }, A2(a3, "removeVarIcon"), { onClick: function() {
                z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: s3, data: { name: o2, namespace: r4.splice(0, r4.length - 1), existing_value: i2, variable_removed: true } });
              } })));
          }, e5.render = function() {
            var t4 = e5.props, n4 = t4.theme, a3 = t4.onDelete, r4 = t4.onAdd, o2 = t4.enableClipboard, i2 = t4.src, s3 = t4.namespace, c3 = t4.rowHovered;
            return m2.a.createElement("div", Object.assign({}, A2(n4, "object-meta-data"), { className: "object-meta-data", onClick: function(e6) {
              e6.stopPropagation();
            } }), e5.getObjectSize(), o2 ? m2.a.createElement(_e, { rowHovered: c3, clickCallback: o2, src: i2, theme: n4, namespace: s3 }) : null, r4 !== false ? e5.getAddAttribute(c3) : null, a3 !== false ? e5.getRemoveObject(c3) : null);
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent);
      function Ce2(e4) {
        var t3 = e4.parent_type, n3 = e4.namespace, a2 = e4.quotesOnKeys, r3 = e4.theme, o2 = e4.jsvRoot, i2 = e4.name, s2 = e4.displayArrayKey, c3 = e4.name ? e4.name : "";
        return !o2 || i2 !== false && i2 !== null ? t3 == "array" ? s2 ? m2.a.createElement("span", Object.assign({}, A2(r3, "array-key"), { key: n3 }), m2.a.createElement("span", { className: "array-key" }, c3), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null) : m2.a.createElement("span", Object.assign({}, A2(r3, "object-name"), { key: n3 }), m2.a.createElement("span", { className: "object-key" }, a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", null, c3), a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null);
      }
      function Se2(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(he2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          case "square":
            return m2.a.createElement(pe2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          default:
            return m2.a.createElement(ue2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
        }
      }
      function we2(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(be2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          case "square":
            return m2.a.createElement(de2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          default:
            return m2.a.createElement(fe2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
        }
      }
      var Ae2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function(e6) {
            var t4 = [];
            for (var n4 in a2.state.expanded)
              t4.push(a2.state.expanded[n4]);
            t4[e6] = !t4[e6], a2.setState({ expanded: t4 });
          }, a2.state = { expanded: [] }, a2;
        }
        return c2(n3, [{ key: "getExpandedIcon", value: function(e5) {
          var t4 = this.props, n4 = t4.theme, a2 = t4.iconStyle;
          return this.state.expanded[e5] ? m2.a.createElement(Se2, { theme: n4, iconStyle: a2 }) : m2.a.createElement(we2, { theme: n4, iconStyle: a2 });
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.src, a2 = t4.groupArraysAfterLength, r3 = (t4.depth, t4.name), o2 = t4.theme, i2 = t4.jsvRoot, s2 = t4.namespace, c3 = (t4.parent_type, x2(t4, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), l3 = 0, u2 = 5 * this.props.indentWidth;
          i2 || (l3 = 5 * this.props.indentWidth);
          var f3 = a2, p3 = Math.ceil(n4.length / f3);
          return m2.a.createElement("div", Object.assign({ className: "object-key-val" }, A2(o2, i2 ? "jsv-root" : "objectKeyVal", { paddingLeft: l3 })), m2.a.createElement(Ce2, this.props), m2.a.createElement("span", null, m2.a.createElement(Oe2, Object.assign({ size: n4.length }, this.props))), B2(Array(p3)).map(function(t5, a3) {
            return m2.a.createElement("div", Object.assign({ key: a3, className: "object-key-val array-group" }, A2(o2, "objectKeyVal", { marginLeft: 6, paddingLeft: u2 })), m2.a.createElement("span", A2(o2, "brace-row"), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            } }), e5.getExpandedIcon(a3)), e5.state.expanded[a3] ? m2.a.createElement(Fe2, Object.assign({ key: r3 + a3, depth: 0, name: false, collapsed: false, groupArraysAfterLength: f3, index_offset: a3 * f3, src: n4.slice(a3 * f3, a3 * f3 + f3), namespace: s2, type: "array", parent_type: "array_group", theme: o2 }, c3)) : m2.a.createElement("span", Object.assign({}, A2(o2, "brace"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            }, className: "array-group-brace" }), "[", m2.a.createElement("div", Object.assign({}, A2(o2, "array-group-meta-data"), { className: "array-group-meta-data" }), m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(o2, "object-size")), a3 * f3, " - ", a3 * f3 + f3 > n4.length ? n4.length : a3 * f3 + f3)), "]")));
          }));
        } }]), n3;
      }(m2.a.PureComponent), Me2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ expanded: !a2.state.expanded }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "expanded", a2.state.expanded);
            });
          }, a2.getObjectContent = function(e6, t4, n4) {
            return m2.a.createElement("div", { className: "pushed-content object-container" }, m2.a.createElement("div", Object.assign({ className: "object-content" }, A2(a2.props.theme, "pushed-content")), a2.renderObjectContents(t4, n4)));
          }, a2.getEllipsis = function() {
            return a2.state.size === 0 ? null : m2.a.createElement("div", Object.assign({}, A2(a2.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: a2.toggleCollapsed }), "...");
          }, a2.getObjectMetaData = function(e6) {
            var t4 = a2.props, n4 = (t4.rjvId, t4.theme, a2.state), r4 = n4.size, o2 = n4.hovered;
            return m2.a.createElement(Oe2, Object.assign({ rowHovered: o2, size: r4 }, a2.props));
          }, a2.renderObjectContents = function(e6, t4) {
            var n4, r4 = a2.props, o2 = r4.depth, i2 = r4.parent_type, s2 = r4.index_offset, c3 = r4.groupArraysAfterLength, l3 = r4.namespace, u2 = a2.state.object_type, f3 = [], p3 = Object.keys(e6 || {});
            return a2.props.sortKeys && u2 !== "array" && (p3 = p3.sort()), p3.forEach(function(r5) {
              if (n4 = new Pe2(r5, e6[r5]), i2 === "array_group" && s2 && (n4.name = parseInt(n4.name) + s2), e6.hasOwnProperty(r5))
                if (n4.type === "object")
                  f3.push(m2.a.createElement(Fe2, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), parent_type: u2 }, t4)));
                else if (n4.type === "array") {
                  var p4 = Fe2;
                  c3 && n4.value.length > c3 && (p4 = Ae2), f3.push(m2.a.createElement(p4, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), type: "array", parent_type: u2 }, t4)));
                } else
                  f3.push(m2.a.createElement(ke2, Object.assign({ key: n4.name + "_" + l3, variable: n4, singleIndent: 5, namespace: l3, type: a2.props.type }, t4)));
            }), f3;
          };
          var r3 = n3.getState(e5);
          return a2.state = o(o({}, r3), {}, { prevProps: {} }), a2;
        }
        return c2(n3, [{ key: "getBraceStart", value: function(e5, t4) {
          var n4 = this, a2 = this.props, r3 = a2.src, o2 = a2.theme, i2 = a2.iconStyle;
          if (a2.parent_type === "array_group")
            return m2.a.createElement("span", null, m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{"), t4 ? this.getObjectMetaData(r3) : null);
          var s2 = t4 ? Se2 : we2;
          return m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({ onClick: function(e6) {
            n4.toggleCollapsed();
          } }, A2(o2, "brace-row")), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container")), m2.a.createElement(s2, { theme: o2, iconStyle: i2 })), m2.a.createElement(Ce2, this.props), m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{")), t4 ? this.getObjectMetaData(r3) : null);
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.depth, a2 = t4.src, r3 = (t4.namespace, t4.name, t4.type, t4.parent_type), i2 = t4.theme, s2 = t4.jsvRoot, c3 = t4.iconStyle, l3 = x2(t4, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), u2 = this.state, f3 = u2.object_type, p3 = u2.expanded, d3 = {};
          return s2 || r3 === "array_group" ? r3 === "array_group" && (d3.borderLeft = 0, d3.display = "inline") : d3.paddingLeft = 5 * this.props.indentWidth, m2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          } }, A2(i2, s2 ? "jsv-root" : "objectKeyVal", d3)), this.getBraceStart(f3, p3), p3 ? this.getObjectContent(n4, a2, o({ theme: i2, iconStyle: c3 }, l3)) : this.getEllipsis(), m2.a.createElement("span", { className: "brace-row" }, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { paddingLeft: p3 ? "3px" : "0px" }) }, f3 === "array" ? "]" : "}"), p3 ? null : this.getObjectMetaData(a2)));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          var a2 = t4.prevProps;
          return e5.src !== a2.src || e5.collapsed !== a2.collapsed || e5.name !== a2.name || e5.namespace !== a2.namespace || e5.rjvId !== a2.rjvId ? o(o({}, n3.getState(e5)), {}, { prevProps: e5 }) : null;
        } }]), n3;
      }(m2.a.PureComponent);
      Me2.getState = function(e4) {
        var t3 = Object.keys(e4.src).length, n3 = (e4.collapsed === false || e4.collapsed !== true && e4.collapsed > e4.depth) && (!e4.shouldCollapse || e4.shouldCollapse({ name: e4.name, src: e4.src, type: _(e4.src), namespace: e4.namespace }) === false) && t3 !== 0;
        return { expanded: q2.get(e4.rjvId, e4.namespace, "expanded", n3), object_type: e4.type === "array" ? "array" : "object", parent_type: e4.type === "array" ? "array" : "object", size: t3, hovered: false };
      };
      var Pe2 = function e4(t3, n3) {
        i(this, e4), this.name = t3, this.value = n3, this.type = _(n3);
      };
      j(Me2);
      var Fe2 = Me2, De2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), o2 = 0; o2 < a2; o2++)
            r3[o2] = arguments[o2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).render = function() {
            var t4 = d2(e5).props, n4 = [t4.name], a3 = Fe2;
            return Array.isArray(t4.src) && t4.groupArraysAfterLength && t4.src.length > t4.groupArraysAfterLength && (a3 = Ae2), m2.a.createElement("div", { className: "pretty-json-container object-container" }, m2.a.createElement("div", { className: "object-content" }, m2.a.createElement(a3, Object.assign({ namespace: n4, depth: 0, jsvRoot: true }, t4))));
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent), Ie2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).closeModal = function() {
            z2.dispatch({ rjvId: a2.props.rjvId, name: "RESET" });
          }, a2.submit = function() {
            a2.props.submit(a2.state.input);
          }, a2.state = { input: e5.input ? e5.input : "" }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.theme, a2 = t4.rjvId, r3 = t4.isValid, o2 = this.state.input, i2 = r3(o2);
          return m2.a.createElement("div", Object.assign({ className: "key-modal-request" }, A2(n4, "key-modal-request"), { onClick: this.closeModal }), m2.a.createElement("div", Object.assign({}, A2(n4, "key-modal"), { onClick: function(e6) {
            e6.stopPropagation();
          } }), m2.a.createElement("div", A2(n4, "key-modal-label"), "Key Name:"), m2.a.createElement("div", { style: { position: "relative" } }, m2.a.createElement("input", Object.assign({}, A2(n4, "key-modal-input"), { className: "key-modal-input", ref: function(e6) {
            return e6 && e6.focus();
          }, spellCheck: false, value: o2, placeholder: "...", onChange: function(t5) {
            e5.setState({ input: t5.target.value });
          }, onKeyPress: function(t5) {
            i2 && t5.key === "Enter" ? e5.submit() : t5.key === "Escape" && e5.closeModal();
          } })), i2 ? m2.a.createElement(je2, Object.assign({}, A2(n4, "key-modal-submit"), { className: "key-modal-submit", onClick: function(t5) {
            return e5.submit();
          } })) : null), m2.a.createElement("span", A2(n4, "key-modal-cancel"), m2.a.createElement(ge2, Object.assign({}, A2(n4, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
            z2.dispatch({ rjvId: a2, name: "RESET" });
          } })))));
        } }]), n3;
      }(m2.a.PureComponent), Re2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).isValid = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            return t4 != "" && Object.keys(a3.existing_value).indexOf(t4) === -1;
          }, e5.submit = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            a3.new_value = o({}, a3.existing_value), a3.new_value[t4] = e5.props.defaultValue, z2.dispatch({ name: "VARIABLE_ADDED", rjvId: n4, data: a3 });
          }, e5;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.active, n4 = e5.theme, a2 = e5.rjvId;
          return t4 ? m2.a.createElement(Ie2, { rjvId: a2, theme: n4, isValid: this.isValid, submit: this.submit }) : null;
        } }]), n3;
      }(m2.a.PureComponent), Le2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.message, n4 = e5.active, a2 = e5.theme, r3 = e5.rjvId;
          return n4 ? m2.a.createElement("div", Object.assign({ className: "validation-failure" }, A2(a2, "validation-failure"), { onClick: function() {
            z2.dispatch({ rjvId: r3, name: "RESET" });
          } }), m2.a.createElement("span", A2(a2, "validation-failure-label"), t4), m2.a.createElement(ge2, A2(a2, "validation-failure-clear"))) : null;
        } }]), n3;
      }(m2.a.PureComponent), Be2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).rjvId = Date.now().toString(), a2.getListeners = function() {
            return { reset: a2.resetState, "variable-update": a2.updateSrc, "add-key-request": a2.addKeyRequest };
          }, a2.updateSrc = function() {
            var e6, t4 = q2.get(a2.rjvId, "action", "variable-update"), n4 = t4.name, r3 = t4.namespace, o2 = t4.new_value, i2 = t4.existing_value, s2 = (t4.variable_removed, t4.updated_src), c3 = t4.type, l3 = a2.props, u2 = l3.onEdit, f3 = l3.onDelete, p3 = l3.onAdd, d3 = { existing_src: a2.state.src, new_value: o2, updated_src: s2, name: n4, namespace: r3, existing_value: i2 };
            switch (c3) {
              case "variable-added":
                e6 = p3(d3);
                break;
              case "variable-edited":
                e6 = u2(d3);
                break;
              case "variable-removed":
                e6 = f3(d3);
            }
            e6 !== false ? (q2.set(a2.rjvId, "global", "src", s2), a2.setState({ src: s2 })) : a2.setState({ validationFailure: true });
          }, a2.addKeyRequest = function() {
            a2.setState({ addKeyRequest: true });
          }, a2.resetState = function() {
            a2.setState({ validationFailure: false, addKeyRequest: false });
          }, a2.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: n3.defaultProps.src, name: n3.defaultProps.name, theme: n3.defaultProps.theme, validationMessage: n3.defaultProps.validationMessage, prevSrc: n3.defaultProps.src, prevName: n3.defaultProps.name, prevTheme: n3.defaultProps.theme }, a2;
        }
        return c2(n3, [{ key: "componentDidMount", value: function() {
          q2.set(this.rjvId, "global", "src", this.state.src);
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.on(t4 + "-" + this.rjvId, e5[t4]);
          this.setState({ addKeyRequest: false, editKeyRequest: false });
        } }, { key: "componentDidUpdate", value: function(e5, t4) {
          t4.addKeyRequest !== false && this.setState({ addKeyRequest: false }), t4.editKeyRequest !== false && this.setState({ editKeyRequest: false }), e5.src !== this.state.src && q2.set(this.rjvId, "global", "src", this.state.src);
        } }, { key: "componentWillUnmount", value: function() {
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.removeListener(t4 + "-" + this.rjvId, e5[t4]);
        } }, { key: "render", value: function() {
          var e5 = this.state, t4 = e5.validationFailure, n4 = e5.validationMessage, a2 = e5.addKeyRequest, r3 = e5.theme, i2 = e5.src, s2 = e5.name, c3 = this.props, l3 = c3.style, u2 = c3.defaultValue;
          return m2.a.createElement("div", { className: "react-json-view", style: o(o({}, A2(r3, "app-container").style), l3) }, m2.a.createElement(Le2, { message: n4, active: t4, theme: r3, rjvId: this.rjvId }), m2.a.createElement(De2, Object.assign({}, this.props, { src: i2, name: s2, theme: r3, type: _(i2), rjvId: this.rjvId })), m2.a.createElement(Re2, { active: a2, theme: r3, rjvId: this.rjvId, defaultValue: u2 }));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          if (e5.src !== t4.prevSrc || e5.name !== t4.prevName || e5.theme !== t4.prevTheme) {
            var a2 = { src: e5.src, name: e5.name, theme: e5.theme, validationMessage: e5.validationMessage, prevSrc: e5.src, prevName: e5.name, prevTheme: e5.theme };
            return n3.validateState(a2);
          }
          return null;
        } }]), n3;
      }(m2.a.PureComponent);
      Be2.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Be2.validateState = function(e4) {
        var t3 = {};
        return _(e4.theme) !== "object" || function(e5) {
          var t4 = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
          if (_(e5) === "object") {
            for (var n3 = 0; n3 < t4.length; n3++)
              if (!(t4[n3] in e5))
                return false;
            return true;
          }
          return false;
        }(e4.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), t3.theme = "rjv-default"), _(e4.src) !== "object" && _(e4.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), t3.name = "ERROR", t3.src = { message: "src property must be a valid json object" }), o(o({}, e4), t3);
      }, j(Be2);
      t2.default = Be2;
    }]);
  });
})(main);
var ReactJson = /* @__PURE__ */ getDefaultExportFromCjs(main.exports);
function useLogs() {
  const logs = useCreation(() => LogsInstance, []);
  return logs;
}
const OptionView = ({
  id: id2,
  name: name2,
  chart,
  option,
  darkMode
}) => {
  const {
    tool
  } = useInjection({});
  const logs = useLogs();
  const event = useChartEventEmitter({
    global: true
  });
  const [collapsed, {
    set: toggleCollapsed
  }] = useBoolean(true);
  const optionChange = (ctrl) => {
    if (id2) {
      const {
        updated_src,
        namespace,
        existing_src,
        existing_value,
        new_value
      } = ctrl;
      chart == null ? void 0 : chart.setOption(updated_src);
      tool == null ? void 0 : tool.add({
        id: id2,
        name: name2,
        chart,
        option: updated_src
      });
      logs.updata({
        id: id2,
        name: name2,
        namespace,
        currentValue: updated_src,
        previewValue: existing_src,
        existing_value,
        new_value
      });
      event.emit("list");
    }
  };
  const JsonView = useMemo$1(() => {
    return /* @__PURE__ */ jsx(ReactJson, {
      src: option != null ? option : {},
      theme: darkMode ? "pop" : "rjv-default",
      displayObjectSize: false,
      displayDataTypes: false,
      collapsed,
      iconStyle: "triangle",
      enableClipboard: true,
      onEdit: optionChange,
      onAdd: optionChange,
      onDelete: optionChange
    });
  }, [darkMode, option, collapsed]);
  return /* @__PURE__ */ jsxs("div", {
    children: [/* @__PURE__ */ jsx(Row$1, {
      children: /* @__PURE__ */ jsx(Col$1, {
        children: /* @__PURE__ */ jsx(Switch$1, {
          checkedChildren: "\u5C55\u5F00\u914D\u7F6E",
          unCheckedChildren: "\u6298\u53E0\u914D\u7F6E",
          defaultChecked: false,
          onChange: (e2) => {
            toggleCollapsed(!e2);
          }
        })
      })
    }), /* @__PURE__ */ jsx("br", {}), JsonView]
  });
};
const container = "_container_35c0r_1";
var styles = {
  container,
  "function": "_function_35c0r_10",
  "drawer-dark": "_drawer-dark_35c0r_14",
  "tab-dark": "_tab-dark_35c0r_23"
};
const light = {
  color: "#000",
  drawerStyle: {
    backgroundColor: "#fff",
    color: "#000"
  }
};
const dark = {
  color: "#fff",
  drawerStyle: {
    backgroundColor: "#191919",
    color: "#fff"
  }
};
const SunSvg = () => /* @__PURE__ */ jsxs("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "16",
  height: "24",
  viewBox: "0 1 24 26",
  fill: "none",
  stroke: "currentColor",
  strokeWidth: "2",
  strokeLinecap: "round",
  strokeLinejoin: "round",
  children: [/* @__PURE__ */ jsx("circle", {
    cx: "12",
    cy: "12",
    r: "5"
  }), /* @__PURE__ */ jsx("line", {
    x1: "12",
    y1: "1",
    x2: "12",
    y2: "3"
  }), /* @__PURE__ */ jsx("line", {
    x1: "12",
    y1: "21",
    x2: "12",
    y2: "23"
  }), /* @__PURE__ */ jsx("line", {
    x1: "4.22",
    y1: "4.22",
    x2: "5.64",
    y2: "5.64"
  }), /* @__PURE__ */ jsx("line", {
    x1: "18.36",
    y1: "18.36",
    x2: "19.78",
    y2: "19.78"
  }), /* @__PURE__ */ jsx("line", {
    x1: "1",
    y1: "12",
    x2: "3",
    y2: "12"
  }), /* @__PURE__ */ jsx("line", {
    x1: "21",
    y1: "12",
    x2: "23",
    y2: "12"
  }), /* @__PURE__ */ jsx("line", {
    x1: "4.22",
    y1: "19.78",
    x2: "5.64",
    y2: "18.36"
  }), /* @__PURE__ */ jsx("line", {
    x1: "18.36",
    y1: "5.64",
    x2: "19.78",
    y2: "4.22"
  })]
});
const SunIcon = (props) => /* @__PURE__ */ jsx(Icon$1, __spreadValues({
  component: SunSvg
}, props));
const DarkSvg = () => /* @__PURE__ */ jsxs("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "20",
  height: "22",
  viewBox: "0 1 24 26",
  fill: "none",
  stroke: "currentColor",
  strokeWidth: "0",
  strokeLinecap: "round",
  strokeLinejoin: "round",
  style: {
    transform: "rotate(40deg)"
  },
  children: [/* @__PURE__ */ jsxs("mask", {
    id: "mask",
    children: [/* @__PURE__ */ jsx("rect", {
      x: "0",
      y: "0",
      width: "100%",
      height: "100%",
      fill: "white"
    }), /* @__PURE__ */ jsx("circle", {
      cx: "12",
      cy: "4",
      r: "9",
      fill: "black"
    })]
  }), /* @__PURE__ */ jsx("circle", {
    fill: "black",
    cx: "12",
    cy: "12",
    r: "9",
    mask: "url(#mask)"
  })]
});
const DarkIcon = (props) => /* @__PURE__ */ jsx(Icon$1, __spreadValues({
  component: DarkSvg
}, props));
const colors = ["#3896FF", "#C50D0D", "#FA6400", "#E9A647", "#A01EAA", "#01C1D5", "#5C1CF0"];
const LogView = ({
  id: id2,
  darkMode
}) => {
  const event = useChartEventEmitter({
    global: true
  });
  const logs = useLogs();
  const [logList, setLogList] = useState();
  const styleMode = useMemo$1(() => {
    return darkMode ? dark : light;
  }, [darkMode]);
  event.useSubscription("list", () => {
    setLogList(logs.getList(id2));
  });
  useEffect(() => {
    setLogList(logs.getList(id2));
  }, [id2]);
  return /* @__PURE__ */ jsx("div", {
    style: {
      color: styleMode.color
    },
    children: logList == null ? void 0 : logList.map((log, index2) => {
      var _a2, _b2, _c2, _d;
      return /* @__PURE__ */ jsxs("div", {
        children: [/* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "id"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: /* @__PURE__ */ jsx("div", {
              children: log.id
            })
          })]
        }), /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "name"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: /* @__PURE__ */ jsx("div", {
              children: log.name
            })
          })]
        }), ((_a2 = log.namespace) == null ? void 0 : _a2.length) && /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "namespace"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: (_b2 = log.namespace) == null ? void 0 : _b2.map((s, index22) => {
              var _a3, _b3, _c3;
              return /* @__PURE__ */ jsxs("span", {
                style: {
                  color: index22 < 7 ? colors[index22] : darkMode ? "#191919" : "#fff"
                },
                children: [`${s}`, ((_a3 = log.namespace) == null ? void 0 : _a3.length) && ((_b3 = log.namespace) == null ? void 0 : _b3.length) != 1 && index22 !== ((_c3 = log.namespace) == null ? void 0 : _c3.length) - 1 && /* @__PURE__ */ jsx("span", {
                  style: {
                    color: darkMode ? "#fff" : "#191919"
                  },
                  children: "-->"
                })]
              });
            })
          })]
        }), /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "form"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: /* @__PURE__ */ jsx(ReactJson, {
              src: (_c2 = log.previewValue) != null ? _c2 : {},
              collapsed: true,
              theme: darkMode ? "pop" : "rjv-default"
            })
          })]
        }), /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "to"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: /* @__PURE__ */ jsx(ReactJson, {
              src: (_d = log.currentValue) != null ? _d : {},
              collapsed: true,
              theme: darkMode ? "pop" : "rjv-default"
            })
          })]
        }), (log == null ? void 0 : log["existing_value"]) && /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "existing_value"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: log == null ? void 0 : log["existing_value"]
          })]
        }), (log == null ? void 0 : log["new_value"]) && /* @__PURE__ */ jsxs(Row$1, {
          children: [/* @__PURE__ */ jsx(Col$1, {
            span: 4,
            children: "new_value"
          }), /* @__PURE__ */ jsx(Col$1, {
            span: 20,
            children: log == null ? void 0 : log["new_value"]
          })]
        }), /* @__PURE__ */ jsx(Divider$1, {
          style: {
            color: darkMode ? "#191919" : "#fff"
          }
        })]
      }, `${log.id}${index2}`);
    })
  });
};
function _defineProperty$1(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys$1(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
      });
    keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys$1(Object(source), true).forEach(function(key) {
        _defineProperty$1(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys$1(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr)))
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = void 0;
  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
      });
    keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
function compose$1() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }
  return function(x2) {
    return fns.reduceRight(function(y2, f2) {
      return f2(y2);
    }, x2);
  };
}
function curry$1(fn) {
  return function curried() {
    var _this = this;
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    return args.length >= fn.length ? fn.apply(this, args) : function() {
      for (var _len3 = arguments.length, nextArgs = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        nextArgs[_key3] = arguments[_key3];
      }
      return curried.apply(_this, [].concat(args, nextArgs));
    };
  };
}
function isObject$1(value) {
  return {}.toString.call(value).includes("Object");
}
function isEmpty(obj) {
  return !Object.keys(obj).length;
}
function isFunction(value) {
  return typeof value === "function";
}
function hasOwnProperty$1(object4, property) {
  return Object.prototype.hasOwnProperty.call(object4, property);
}
function validateChanges(initial, changes) {
  if (!isObject$1(changes))
    errorHandler$1("changeType");
  if (Object.keys(changes).some(function(field) {
    return !hasOwnProperty$1(initial, field);
  }))
    errorHandler$1("changeField");
  return changes;
}
function validateSelector(selector2) {
  if (!isFunction(selector2))
    errorHandler$1("selectorType");
}
function validateHandler(handler) {
  if (!(isFunction(handler) || isObject$1(handler)))
    errorHandler$1("handlerType");
  if (isObject$1(handler) && Object.values(handler).some(function(_handler) {
    return !isFunction(_handler);
  }))
    errorHandler$1("handlersType");
}
function validateInitial(initial) {
  if (!initial)
    errorHandler$1("initialIsRequired");
  if (!isObject$1(initial))
    errorHandler$1("initialType");
  if (isEmpty(initial))
    errorHandler$1("initialContent");
}
function throwError$1(errorMessages2, type4) {
  throw new Error(errorMessages2[type4] || errorMessages2["default"]);
}
var errorMessages$1 = {
  initialIsRequired: "initial state is required",
  initialType: "initial state should be an object",
  initialContent: "initial state shouldn't be an empty object",
  handlerType: "handler should be an object or a function",
  handlersType: "all handlers should be a functions",
  selectorType: "selector should be a function",
  changeType: "provided value of changes should be an object",
  changeField: 'it seams you want to change a field in the state which is not specified in the "initial" state',
  "default": "an unknown error accured in `state-local` package"
};
var errorHandler$1 = curry$1(throwError$1)(errorMessages$1);
var validators$1 = {
  changes: validateChanges,
  selector: validateSelector,
  handler: validateHandler,
  initial: validateInitial
};
function create(initial) {
  var handler = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  validators$1.initial(initial);
  validators$1.handler(handler);
  var state = {
    current: initial
  };
  var didUpdate = curry$1(didStateUpdate)(state, handler);
  var update = curry$1(updateState)(state);
  var validate = curry$1(validators$1.changes)(initial);
  var getChanges = curry$1(extractChanges)(state);
  function getState2() {
    var selector2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : function(state2) {
      return state2;
    };
    validators$1.selector(selector2);
    return selector2(state.current);
  }
  function setState2(causedChanges) {
    compose$1(didUpdate, update, validate, getChanges)(causedChanges);
  }
  return [getState2, setState2];
}
function extractChanges(state, causedChanges) {
  return isFunction(causedChanges) ? causedChanges(state.current) : causedChanges;
}
function updateState(state, changes) {
  state.current = _objectSpread2(_objectSpread2({}, state.current), changes);
  return changes;
}
function didStateUpdate(state, handler, changes) {
  isFunction(handler) ? handler(state.current) : Object.keys(changes).forEach(function(field) {
    var _handler$field;
    return (_handler$field = handler[field]) === null || _handler$field === void 0 ? void 0 : _handler$field.call(handler, state.current[field]);
  });
  return changes;
}
var index = {
  create
};
var config$1 = {
  paths: {
    vs: "https://cdn.jsdelivr.net/npm/monaco-editor@0.33.0/min/vs"
  }
};
function curry(fn) {
  return function curried() {
    var _this = this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return args.length >= fn.length ? fn.apply(this, args) : function() {
      for (var _len2 = arguments.length, nextArgs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        nextArgs[_key2] = arguments[_key2];
      }
      return curried.apply(_this, [].concat(args, nextArgs));
    };
  };
}
function isObject(value) {
  return {}.toString.call(value).includes("Object");
}
function validateConfig(config2) {
  if (!config2)
    errorHandler("configIsRequired");
  if (!isObject(config2))
    errorHandler("configType");
  if (config2.urls) {
    informAboutDeprecation();
    return {
      paths: {
        vs: config2.urls.monacoBase
      }
    };
  }
  return config2;
}
function informAboutDeprecation() {
  console.warn(errorMessages.deprecation);
}
function throwError(errorMessages2, type4) {
  throw new Error(errorMessages2[type4] || errorMessages2["default"]);
}
var errorMessages = {
  configIsRequired: "the configuration object is required",
  configType: "the configuration object should be an object",
  "default": "an unknown error accured in `@monaco-editor/loader` package",
  deprecation: "Deprecation warning!\n    You are using deprecated way of configuration.\n\n    Instead of using\n      monaco.config({ urls: { monacoBase: '...' } })\n    use\n      monaco.config({ paths: { vs: '...' } })\n\n    For more please check the link https://github.com/suren-atoyan/monaco-loader#config\n  "
};
var errorHandler = curry(throwError)(errorMessages);
var validators = {
  config: validateConfig
};
var compose = function compose2() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }
  return function(x2) {
    return fns.reduceRight(function(y2, f2) {
      return f2(y2);
    }, x2);
  };
};
function merge2(target, source) {
  Object.keys(source).forEach(function(key) {
    if (source[key] instanceof Object) {
      if (target[key]) {
        Object.assign(source[key], merge2(target[key], source[key]));
      }
    }
  });
  return _objectSpread2$1(_objectSpread2$1({}, target), source);
}
var CANCELATION_MESSAGE = {
  type: "cancelation",
  msg: "operation is manually canceled"
};
function makeCancelable(promise) {
  var hasCanceled_ = false;
  var wrappedPromise = new Promise(function(resolve, reject) {
    promise.then(function(val) {
      return hasCanceled_ ? reject(CANCELATION_MESSAGE) : resolve(val);
    });
    promise["catch"](reject);
  });
  return wrappedPromise.cancel = function() {
    return hasCanceled_ = true;
  }, wrappedPromise;
}
var _state$create = index.create({
  config: config$1,
  isInitialized: false,
  resolve: null,
  reject: null,
  monaco: null
}), _state$create2 = _slicedToArray(_state$create, 2), getState = _state$create2[0], setState = _state$create2[1];
function config(globalConfig) {
  var _validators$config = validators.config(globalConfig), monaco = _validators$config.monaco, config2 = _objectWithoutProperties(_validators$config, ["monaco"]);
  setState(function(state) {
    return {
      config: merge2(state.config, config2),
      monaco
    };
  });
}
function init() {
  var state = getState(function(_ref) {
    var monaco = _ref.monaco, isInitialized = _ref.isInitialized;
    return {
      monaco,
      isInitialized
    };
  });
  if (!state.isInitialized) {
    setState({
      isInitialized: true
    });
    if (state.monaco) {
      return makeCancelable(Promise.resolve(state.monaco));
    }
    if (window.monaco && window.monaco.editor) {
      storeMonacoInstance(window.monaco);
      return makeCancelable(Promise.resolve(window.monaco));
    }
    compose(injectScripts, getMonacoLoaderScript)(configureLoader);
  }
  return makeCancelable(wrapperPromise);
}
function injectScripts(script) {
  return document.body.appendChild(script);
}
function createScript(src) {
  var script = document.createElement("script");
  return src && (script.src = src), script;
}
function getMonacoLoaderScript(configureLoader2) {
  var state = getState(function(_ref2) {
    var config2 = _ref2.config, reject = _ref2.reject;
    return {
      config: config2,
      reject
    };
  });
  var loaderScript = createScript("".concat(state.config.paths.vs, "/loader.js"));
  loaderScript.onload = function() {
    return configureLoader2();
  };
  loaderScript.onerror = state.reject;
  return loaderScript;
}
function configureLoader() {
  var state = getState(function(_ref3) {
    var config2 = _ref3.config, resolve = _ref3.resolve, reject = _ref3.reject;
    return {
      config: config2,
      resolve,
      reject
    };
  });
  var require2 = window.require;
  require2.config(state.config);
  require2(["vs/editor/editor.main"], function(monaco) {
    storeMonacoInstance(monaco);
    state.resolve(monaco);
  }, function(error) {
    state.reject(error);
  });
}
function storeMonacoInstance(monaco) {
  if (!getState().monaco) {
    setState({
      monaco
    });
  }
}
function __getMonacoInstance() {
  return getState(function(_ref4) {
    var monaco = _ref4.monaco;
    return monaco;
  });
}
var wrapperPromise = new Promise(function(resolve, reject) {
  return setState({
    resolve,
    reject
  });
});
var loader = {
  config,
  init,
  __getMonacoInstance
};
const registerDatavDarkTheme = (monaco) => {
  const themeName = "react-echarts-json-dark-theme";
  monaco.editor.defineTheme(themeName, {
    base: "vs-dark",
    inherit: true,
    rules: [
      { token: "key", foreground: "dddddd" },
      { token: "string.key.json", foreground: "dddddd" },
      { token: "string.value.json", foreground: "b4e98c" }
    ],
    colors: {
      "editor.background": "#0e1013",
      "editor.lineHighlightBackground": "#1f2329",
      "editorLineNumber.foreground": "#576369",
      "editorCursor.foreground": "#2483ff"
    }
  });
  return themeName;
};
let suggestLabels = [];
const createSuggestions = (monaco, range3) => {
  const suggestions = [];
  for (let i = 0; i < suggestLabels.length; i++) {
    const id2 = suggestLabels[i];
    suggestions.push({
      label: `:${id2}`,
      insertText: id2,
      kind: monaco.languages.CompletionItemKind.Variable,
      detail: "CallbackId",
      range: range3
    });
  }
  return suggestions;
};
const registerCompletionMap = /* @__PURE__ */ new Map();
const registerApiCompletion = (monaco, languageId, callbackIds) => {
  if (callbackIds && callbackIds.length > 0) {
    suggestLabels = callbackIds;
    if (registerCompletionMap.has(languageId)) {
      return;
    }
    registerCompletionMap.set(languageId, 1);
    monaco.languages.registerCompletionItemProvider(languageId, {
      triggerCharacters: [":"],
      provideCompletionItems(model, position2) {
        const word = model.getWordUntilPosition(position2);
        const range3 = {
          startLineNumber: position2.lineNumber,
          endLineNumber: position2.lineNumber,
          startColumn: word.startColumn,
          endColumn: word.endColumn
        };
        return {
          suggestions: createSuggestions(monaco, range3)
        };
      }
    });
  }
};
loader.config({
  paths: {
    vs: "https://unpkg.com/monaco-editor@0.27.0/min/vs"
  }
});
const Editor = ({
  activeId
}) => {
  const mainRef = useRef(null);
  const container2 = useRef(null);
  const [monaco, setMonaco] = useState();
  const editor = useRef();
  useEffect(() => {
    const loadMonco = async () => {
      const data2 = await loader.init();
      setMonaco(data2);
    };
    loadMonco();
  }, []);
  useEffect(() => {
    if (monaco) {
      registerDatavDarkTheme(monaco);
      registerApiCompletion(monaco, "javascript", ["react-echarts-json-monaco"]);
      const option = {
        value: "const chartInstance = instance",
        language: "javascript",
        theme: "react-echarts-json-dark-theme",
        tabSize: 2,
        cursorStyle: "line",
        fontSize: 14
      };
      if (container2.current)
        editor.current = monaco.editor.create(container2.current, option);
    }
  }, [monaco]);
  const {
    run
  } = useCreateEditor({
    domElement: mainRef.current,
    activeId
  });
  const codeRun = () => {
    var _a2;
    const code2 = (_a2 = editor.current) == null ? void 0 : _a2.getValue();
    run(code2);
  };
  return /* @__PURE__ */ jsxs("div", {
    ref: mainRef,
    children: [/* @__PURE__ */ jsxs(Row$1, {
      children: [/* @__PURE__ */ jsx(Col$1, {
        span: 20
      }), /* @__PURE__ */ jsx(Col$1, {
        span: 4,
        style: {
          display: "flex",
          justifyContent: "end"
        },
        children: /* @__PURE__ */ jsx(Button$2, {
          type: "primary",
          onClick: () => codeRun(),
          children: "\u8FD0\u884C"
        })
      })]
    }), /* @__PURE__ */ jsx("div", {
      ref: container2,
      style: {
        height: 800,
        marginTop: 32
      }
    })]
  });
};
const {
  TabPane
} = Tabs;
const EchartDefaultView = () => {
  var _a2;
  const event = useChartEventEmitter({
    global: true
  });
  const currentIndex = useRef(0);
  const {
    tool
  } = useInjection({});
  const {
    runSelect
  } = useChartSelect({});
  const [visible, setVisible] = useState(false);
  const [placement, setPlacement] = useState("right");
  const [chartList, setChartList] = useState([]);
  const [currentChart, setCurrentChart] = useState();
  const [darkMode, setDarkMode] = useDarkMode();
  const styleMode = useMemo$1(() => {
    return darkMode ? dark : light;
  }, [darkMode]);
  event.useSubscription("list", () => {
    var _a3;
    if (tool == null ? void 0 : tool.list().length) {
      setCurrentChart((_a3 = tool == null ? void 0 : tool.list()) == null ? void 0 : _a3[currentIndex.current]);
      setChartList(tool == null ? void 0 : tool.list());
    }
  });
  const showDrawer = () => {
    setVisible(true);
  };
  const onChange3 = (value) => {
    if (value) {
      setPlacement(value);
      showDrawer();
    }
  };
  const RadioOnChang = (e2) => {
    currentIndex.current = chartList.findIndex((v4) => v4.id === e2.target.value);
    setCurrentChart(chartList == null ? void 0 : chartList[currentIndex.current]);
  };
  const onClose = () => {
    setVisible(false);
  };
  useEffect(() => {
    if (currentChart == null ? void 0 : currentChart.id)
      runSelect({
        id: currentChart == null ? void 0 : currentChart.id
      });
  }, [currentChart]);
  return /* @__PURE__ */ jsx("div", {
    className: styles.container,
    children: /* @__PURE__ */ jsxs("div", {
      children: [/* @__PURE__ */ jsx("div", {
        className: styles.function,
        children: /* @__PURE__ */ jsxs(Space$1, {
          direction: "horizontal",
          size: 16,
          children: [/* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("top");
            },
            children: /* @__PURE__ */ jsx(UpOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("bottom");
            },
            children: /* @__PURE__ */ jsx(DownOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("left");
            },
            children: /* @__PURE__ */ jsx(LeftOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("right");
            },
            children: /* @__PURE__ */ jsx(RightOutlined$1, {})
          })]
        })
      }), /* @__PURE__ */ jsxs(Drawer$1, {
        title: "\u56FE\u8868\u914D\u7F6E",
        className: darkMode ? styles["drawer-dark"] : "",
        placement,
        width: 700,
        height: 400,
        mask: false,
        closable: false,
        onClose,
        visible,
        bodyStyle: styleMode.drawerStyle,
        headerStyle: __spreadProps(__spreadValues({}, styleMode.drawerStyle), {
          borderBottomColor: darkMode ? "#191919" : "#fff"
        }),
        footerStyle: styleMode.drawerStyle,
        extra: /* @__PURE__ */ jsxs(Space$1, {
          children: [/* @__PURE__ */ jsx(Switch$1, {
            checkedChildren: /* @__PURE__ */ jsx(DarkIcon, {}),
            unCheckedChildren: /* @__PURE__ */ jsx(SunIcon, {}),
            defaultChecked: darkMode,
            onChange: (e2) => {
              setDarkMode(e2);
            }
          }), /* @__PURE__ */ jsx(Button$2, {
            size: "small",
            shape: "circle",
            icon: /* @__PURE__ */ jsx(CloseOutlined$1, {}),
            onClick: onClose
          })]
        }),
        children: [/* @__PURE__ */ jsx(Row$1, {
          children: /* @__PURE__ */ jsx(Radio$1.Group, {
            onChange: RadioOnChang,
            defaultValue: (_a2 = chartList == null ? void 0 : chartList[0]) == null ? void 0 : _a2.id,
            value: currentChart == null ? void 0 : currentChart.id,
            children: chartList == null ? void 0 : chartList.map((item) => /* @__PURE__ */ jsxs(Radio$1, {
              style: {
                height: 48,
                color: styleMode.color
              },
              value: item.id,
              children: [item.name, "\uFF08", item.id, "\uFF09"]
            }, item.id))
          })
        }), /* @__PURE__ */ jsx(Divider$1, {}), /* @__PURE__ */ jsxs(Tabs, {
          defaultActiveKey: "view",
          className: darkMode ? styles["tab-dark"] : "",
          children: [/* @__PURE__ */ jsx(TabPane, {
            tab: /* @__PURE__ */ jsx("span", {
              style: {
                fontSize: 16
              },
              children: "\u914D\u7F6E\u9879\u7F16\u8F91"
            }),
            children: /* @__PURE__ */ jsx(OptionView, __spreadProps(__spreadValues({}, currentChart), {
              darkMode
            }))
          }, "view"), /* @__PURE__ */ jsx(TabPane, {
            tab: /* @__PURE__ */ jsx("span", {
              style: {
                fontSize: 16
              },
              children: "\u4EE3\u7801\u7F16\u8F91"
            }),
            children: /* @__PURE__ */ jsx(Editor, {
              activeId: currentChart == null ? void 0 : currentChart.id
            })
          }, "editor"), /* @__PURE__ */ jsx(TabPane, {
            tab: /* @__PURE__ */ jsx("span", {
              style: {
                fontSize: 16
              },
              children: "\u65E5\u5FD7\u89C6\u56FE"
            }),
            children: /* @__PURE__ */ jsx(LogView, {
              darkMode,
              id: currentChart == null ? void 0 : currentChart.id
            })
          }, "log")]
        })]
      })]
    })
  });
};
export { EchartDefaultView, Editor, LogView, OptionView as ReactEchartsJson, useChartEventEmitter, useChartSelect, useCreateEditor, useDarkMode, useEcharts, useInjection, useMedia };
